README for QA
=============

$Id: README 24461 2013-08-01 06:05:43Z d3y133 $

The QA directory contains tests cases and baselines for a wide variety
of functionality in NWChem. For basic usage see the file HOW-TO-RUN-TESTS
for instructions. 

Besides the manual usage of the QA suite the test cases are now also used by
the nightly testing infrastructure run through Jenkins. Exploiting this 
infrastructure imposes some additional requirements:

1. Ready to go submission scripts have to be provided for all the tested
   platforms. The reason is that the job script will be submitted from a
   Jenkins build step script. To keep that script as simple as possible the
   submission script should be as pre-cooked as possible.

2. The test cases should be highly reproducible. The validation of the results
   is completely automated. Therefore if a test case ran successfully it should
   validate OK and otherwise if should validate Failed. If there are any 
   ambiguities the framework will throw up many false positives.

Given an ordered list of files contanining molecular coordinates
in XYZ format, this simple shell script generates an animated
gif for each of the six possible views down a Cartesian axis.

It uses the free utilities
  - rasmol 
    (http://www.umass.edu/microbio/rasmol) 
    to manipulate the molecule and generate the individual frames
  - convert from ImageMagick 
    (http://www.wizards.dupont.com/cristy/ImageMagick.html)
    to combine the frames into an animated gif

It should be easy to modify the script to other file formats
or animation tools.

$Id: README 19708 2010-10-29 18:04:21Z d3y133 $

This is a pair of programs that translate between NWChem movecs files
in the usual binary format and an ASCII form that can be moved to
another platform and converted back into a binary file for that
machine.  They are quite simple, and don't do much error checking, but
they seem to work.

Known to work on Sun and SGI
Requires NWChem's include files and libnwcutil.a containing the MA
library.


MA_USE_ARMCI_MEM must not be set to anything for this to work:
unsetenv MA_USE_ARMCI_MEM

The dotests.msub MOAB script runs a bunch of NWChem and Amber runs, you might have to
edit it to set the right path and account number.  The resulting test.out.* file
should be empty when the job completes.

Each one of these subdirectories is a seperate test with its own README file.
big: amino acid sequence
big.shake: amino acid sequence, which shake enabled
ethane: single ethane molecule
ethane+: single ethane molecule with a +4 charge
small: ALA dimer
methanol: solvent only run (NWChem only)

Within each directory is a README file that describes what results you should get.

-------

Hints for generating your own amber tests:
First you need a PDB file of the molecule of interest (assume this is tiny.pdb)
Do this in an xterm
module purge
module load amber/10
./xleap &

Fix the PDB to match amber based upon these files:
${AMBERHOME}/dat/leap/lib/all_amino94.lib     ("normal" amino acids)
${AMBERHOME}/dat/leap/lib/all_aminont94.lib   (N terminating)
${AMBERHOME}/dat/leap/lib/all_aminoct94.lib   (C terminating)
Until all atoms are correctly named when you type:
tiny = loadPdb tiny.pdb on the xleap command line
For example, I had to change CD to CD1 in ILE

You may have to "edit tiny" to set atom types, add bonds, set charges, etc.  I
had to do that with ethane (there was nothing in the default libraries, because
it is not an amino acid).
To add bonds, you must be in "draw" mode

Once you think you are done, type this in the xleap command line:
check tiny

If all is well then save it as tiny2  (note this this is new name, since we 'fixed' things).
savePdb tiny tiny2.pdb
saveOff tiny tiny2.lib
saveAmberParm tiny tiny2.top tiny2.cor

-------

Hints for NWChem runs:
The atoms might need changed to match *.frg files for NWChem
This is why the pdb files might not be the same for amber and NWChem

1. change the environment variables in env_nwchem.source
   and source the file
   # set the environment variable LIBMPI if your mpi library is not '-lmpi'

2. make sure that the cca tools are compiled

3. compile the cca-chem-generic code
   If you have access to the cca-forum repository you can get the code by:
    setenv CVSROOT :ext:vidhya@cca-forum.org:/cvs/cca-chem
    setenv CVS_RSH ssh
    cvs co cca-chem-generic

4. compile NWChem: 
   This should generally just be two commands if you did step 1:
   In the $(NWCHEM_TOP)/src directory
   "make nwchem_config"
   "make >& make.log &"

5. make sure that the stubs file is available
   In the $(NWCHEM_TOP)/src directory
   "make stubs.o"
   
6. build cca component in the $(NWCHEM_TOP)/src/cca directory:
   change config.txt if necessary and source it or do your own configure
   make
   make install

7. test cca component
   cd $(NWCHEM_TOP)/src/cca/tests
   modify CCAFERC file
   ccafe-single --ccafe-rc CCAFERC

DOXYGEN README
==============

This directory contains experimental material to generate source code
documentation using Doxygen. 

To generate the source code for all of NWChem documentation run

	cd $NWCHEM_TOP
	./contrib/docygen/run_doxygen

To generate documentation for parts of NWChem you can invoke the run_doxygen
script in any subdirectory.

After this $NWCHEM_TOP/doxydocs/html should contain the source code
documentation. At the moment very few files of NWChem have been provided with
the appropriate comments. Hence the Doxygen documentation essentially only
contains what the tool can extract from the source code itself.

More information on Doxygen can be found at:

 - http://www.stack.nl/~dimitri/doxygen

Experience so far has been mixed:
- Doxygen requires the right configuration settings to deal with Fortran
  code.
- Doxygen can generate about 4 GB of documentation for the NWChem source tree
  in about 1 hour and 20 minutes. You can reduce this by using appropriate
  options, but then the result is also less informative.
- Doxygen can generate call treesi, caller trees and other diagrams. However
  it seems that sometimes nodes are missing from these diagrams.
Currently I am guessing that we will need multiple Doxygen configuration files
and allow a developer to select one with a command line option on the 
run_doxygen command line. Different options would then select more or less
extensive documentation at different compile time and disk space requirements.

INSTALLING DOXYGEN FOR NWCHEM
=============================

Prerequisites: Doxygen works best if the graphviz package is available to 
draw call graphs and such like. It uses the executable "dot". All that is 
required is to build and install graphviz so that "dot" is in your PATH.
I tried Doxygen with graphviz-2.28.0.

Installing Doxygen itself is relatively straightforward. Download the Doxygen
package of your choice (the version with which I have tested this setup is
listed at the top of doxygen.rc). With Doxygen 1.7.6.1 Fortran files with the
.F extension were not recognized properly. In Doxygen 1.8.0 this problem has
been fixed. To install Doxygen 1.8.0 only the usual steps are required:

	cd doxygen-<version>/.
	./configure --prefix <install dir>
	make
	make install

After this you should be able to run Doxygen as described at the top of this
file.

----

Happy coding, Huub.

How to compile NWChem libraries for NWChem/VENUS:
First time:
cd $NWCHEM_TOP/src
make nwchem_config NWCHEM_MODULES=venus
make >& make.log
make stubs.o
Following times:
cd $NWCHEM_TOP/src/geninterface
make

Experimental Quantum MD module. Not ready for production runs yet.

== TODO Items ==

* Applying constraints (Rattle, Shake)
* Use restart information
* Langevin/Stochastic dynamics
* Simulated annealing
* CPMD style dynamics
* Metadynamics
* Confining potentials for droplet simulations
* Clean up output, trajectory print intervals
* Test cases

A collection of miscelaneous Python scripts and test cases 
that have been partially tested.

IMPORTANT:
 Make sure that the directory containing Xrtdb.py is in your PYTHONPATH


Xrtdb.py - A Tkinter based graphical RTDB editor
     Requires Tkinter support be built into the Python that NWChem
     is linked against.  On some machines this also requires linking
     against _tkinter.so which is in the python lib-dynload.

testxrtb.nw
     Example use of Xrtdb

nwgeom.py - look in the file for (a little) more documentation
   Defines the procedures

   - coords = geom_get_coords(name)
   - geom_set_coords(name,coords)
     Get/set cartesian coordinates for named geometry

   - bond_length(i,j)
     Compute bond length between atoms i & j for
     default geometry

   - (xmin, fmin) = minimize1d(f, xlo, xhi, xtol, maxeval)
     Fairly robust minimization in 1d ... useful for crude
     localization of saddle points (look in util.py for
     better optimizers, notably quasinr()).

   - results = scan_input(input,start,end,nstep,theory,task)
     Scan parameters from start to end, substituting into 
     the NWChem input string and calling the specified
     task(theory), returning results from each step in results.

util.py - lots of useful python routines for manipulating vectors,
     matrices, and minimizing functions. Look in the file for more
     documentation, and at the end of the file for example usage.

basopt.nw - example of optimizing the exponents in a primitive basis
     set using the quasi-Newton optimizer quasinr() in util.py

basopt2.nw - another example of optimizing basis set exponents. 
     Uncontracts an STO-3G basis for water and optimizes the exponents.
     (this one will take a few minutes to complete)

basopt3.nw - yet another example. This time using MP2 for HF to 
     optimize the uncontracted sp on H and spd on F in the
     cc-pVDZ basis.

basopt4.nw - and another example.  This optimizes a sequence of
     even tempered primitive basis sets for Be with between 2 and
     twenty s functions and then prints out the summary to demonstrate
     exponential convergence to the Hartree-Fock basis set limit.

ts_search.nw
     Example use of minimize1d from nwgeom.py

scanexp.nw
     Example use of scan_input from nwgeom.py

hcn.nw
     Scans the HCN -> CNH reaction path displaying bond lengths
     and the energy as function of angle using Gnuplot.  You
     need Python and the GNUplot and Numeric extensions
     (www.python.org)

nh3.nw
     Scans the NH3 inversion path displaying bond lengths
     and the energy as function of angle using Gnuplot.  You
     need Python and the GNUplot and Numeric extensions
     (www.python.org)
     
isdoesmic.nw
     Uses python to compute a reaction energy as a function
     of basis set.


pes_scan.py
   Python script for use in
   NWchem that is the multidimensional analog of your zcoord scanning
   script. This script can scan a grid of variables in several
   dimensions, covering a parameter "volume", rather than the linear
   track between points done by zcoord.
   Additional documentation and usage notes is in the comments of the
   script itself  (from Lev Gelb, gelb@mitre.wustl.edu) 
   

  

ROBODOC README
==============

This directory contains experimental material to generate source code 
documentation using Robodoc.

To generate the source code documentation run

	cd $NWCHEM_TOP
	./contrib/robodoc/run_robodoc

After this $NWCHEM_TOP/srcdoc.html should contain the source code documentation
of all of NWChem. As currently very few (i.e. no) files contain the appropriate
comments that Robodoc recognizes this file will be small.

Experience so far has shown Robodoc to be stable and capable to handle a 
large code. How the tool will behave if a large fraction of the source code
is documented is unknown.

For more details on Robodoc see:

 - http://sourceforge.net/projects/robodoc/       -- project pages
 - http://www.xs4all.nl/~rfsber/Robo/robodoc.html -- general info

Requirements for the NWChem java gui:

1. JAVA 1.2 SDK or later in PATH
2. Create a directory $(NWCHEM_TOP)/lib/classes
3. Define the following environment variables in your .cshrc
	NWCHEM_CLASSES pointing to $(NWCHEM_TOP)/lib/classes
	PTPLOT_APPLICATION pointing to plotapplication.jar
	MYCLASSES pointing to directory with the CFORMAT classes
4. Add ${NWCHEM_CLASSES}, ${PTPLOT_APPLICATION} and ${MYCLASSES} to CLASSPATH

To compile type 'make' in $(NWCHEM_TOP)/src/java. This copies the
class files to ${NWCHEM_TOP)/lib/classes

To run type 'java nwchem'

The necessary third party class libraries:

PTOLEMY (http://ptolemy.eecs.berkeley.edu/ptolemyII)
CFORMAT (http://www.cs.ubc.edu/~lloyd/java/doc/cformat.html)

The prog and user trees are automatically generated by latex2html and
any edits down there will be lost.  The searching capability is
manually pasted into the {user,prog}.html files from stuff checked
into CVS in nwchem/doc.  The csh scripts {user,prog}_body are executed
from this directory and munge the backgrounds of the many pages in the
subdirectories.

README fix_include_files
========================

The script fix_include_files is supposed to be run from this directory. 
It modifies include files in the GA adding Fortran90 interface blocks so that
the compiler can check whether critical routines are called with the correct
data types. More comments on the how and why are included in the script itself.

JAN 17, 2009 Current state:

Added IRC so that it runs at low temperature and it finishes OK. 

In MD_DRIVER need to fix the punch/restart file "
In MD_DRIVER need to figure out how and when to call crossing
Make sure crossing does not error out

JAN 27, 2009 Current state

Punch/restart seems to work OK
When crossing is being called the code seg. faults. 

FEB 4, 2009

The results for FeHFe and OHO seems to be reproduced correctlly. 
iNeed to figure out why Traj.txt does not contain the entire run, seems to only keep the last trajectory.

FEB 5, 2009

The traj.txt writing has been fixed. This on seem sto be working fine, so it was commited to CVS. 
The next steps will include cleaning up of the code from unused variables, print statements and proper memmory dealocation.

FEB 11, 2009

crossing, mc_main and md_driver have been modified so that recrossing is tracked at each step. Seems to work fine.
Removed passing traj_num to md_driver and then to crossing. It is set properly to be varriable in mc_data
Next step:
Double check the inital conditions for the start of MD
change the restart, but parhaps starting a BIGMol run is also a good idea.

FEB 20, 2009
The hard-coded leps_gradient needs to be removed and replace by a proper gradient function

FEB 21, 2009
The gradient function and theory is now passed as an argument from task_dynamics. Not hardcoded.

MARCH 02, 2009
BUG: rtdb gets corrupted in MD run when SCF is used instead of LEPS.Error was first detected when running big molecule, but is reproducible with h3 system as well. 
  
The bug is not consistently reproducible. Some times crashes after few trajectories, and other times at the first frajectory. Looks like memory issue.  

Located bug in mc_init in the vay that forcees were accessed. So acceleration generated are garbage. Still not completelly fixed.

MARCH 3, 2009
md-init subroutine is not being used. Not sure why I keep it. 

Located anouther bug in crossing (where mass array was being filled in). 

Looks like code is working fine now (for big molecule), but there seems to be an issue with memory dealocation in mc_main. That is the next thing to look at.

MARCH 5
There is a memory overstepping somewhere that corrupts the sidecount memory block. Have no idea where it is.

Found a bug in crossing where i_sc+2*trajnum should add 0 and 1, not 1 and 2. Looks like it is fixing the memory issue. Need to test some more.  

Testing shows that now crossing is not being counted correctlly. That sounds like a logic error.

MARCH 6
Just fixed the i_sc indexing in mc_main and recrossing looks good. Running tests. 

Test with LEPS and SCF on small systems completed correctlly. 
Started test on the big system. 

*======================================================================
*
* DISCLAIMER
*
* This material was prepared as an account of work sponsored by an
* agency of the United States Government.  Neither the United States
* Government nor the United States Department of Energy, nor Battelle,
* nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
* ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
* COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
* SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
* INFRINGE PRIVATELY OWNED RIGHTS.
*
* ACKNOWLEDGMENT
*
* This software and its documentation were produced with Government
* support under Contract Number DE-AC06-76RLO-1830 awarded by the United
* States Department of Energy.  The Government retains a paid-up
* non-exclusive, irrevocable worldwide license to reproduce, prepare
* derivative works, perform publicly and display publicly by or for the
* Government, including the right to distribute to other Government
* contractors.
*
*======================================================================
*
*  -- PEIGS  routine (version 2.1) --
*     Pacific Northwest Laboratory
*     July 28, 1995
*
*======================================================================


README file for PeIGS.

The package, PeIGS, is a collection of linear algebra programs for
solving the general and standard symmetric eigensystem problem.  It is
being developed at Department of Energy's Pacific Northwest National Laboratory
operated by Battelle Memorial Institute and is in the Public Domain.  The
authors are David Elwood, George Fann, and Richard Littlefield.

There is a separate test directory "test_la" which performs a suite of
tests comparing the accuracy of this code with serial versions of
LAPACK and LINPACK.  This test suite also contains test codes for
random distribution of data.

For installation instructions please read the file "INSTALL."

The source code are contained in the directory "src/#" where #
is the programming language.

This is the top level directory for the general eigensystem solver Ax
= \lambda B x for a symmetric matrix A and a symmetric positive
definite matrix B.

The documentation is contained in ./doc/peigs.texi.  This is a file
which can be converted to a dvi file using texi2dvi, a GNU product.
It is also readable as on-line documentation using emacs using the
texi mode.

This is a very brief summary of what is contained in src/c The user is
advised to look at peigs.texi before installation.

These are input files that correspond to the examples in the paper:

  Jon Baker, Fora Chan,
  "The location of transition states:
   A comparison of Cartesian, Z-Matrix, and Natural Internal Coordinates",
  J.Comp.Chem. 17 (1996) 888-904.

These files were contributed by:

Huub van Dam
CCLRC Daresbury Laboratory
Keckwick Lane
Warrington, Cheshire UK
WA4 4AD 
h.j.j.van_dam@dl.ac.uk
+44 1925 603933

$Id: readme 19708 2010-10-29 18:04:21Z d3y133 $
****************************************************************
      Program averagehist_5

      Reads in multiple *.MCdata files created by the DNTMC module.  Produces a file *.fdist.average.(tempfinal)K which contains some property distributions obtained from the *.MCdata files.  This code is specific to water clusters in generall.  However, it may be modified to obtain properties of other systems.
      The properties include:  1.)   Oxygen - Oxygen distances  , 2.)  Hydrogen Bond Lengths, 3.)  Hydrogen Bond Angles measured as the bending angle (0 is linear) centered at the hydrogen atom., 4.)  Hydrogen Bond Angles measured as the bending angle (0 is linear) centered at the oxygen atom.,  5.)  Total Energy, 6.)  Energy decomposed into portions which come from structures with differing amounts of hydrogen bonding,  6.)  Estimated Dipole interaction energy, and 7.)  Absolute Dipole Moments projected onto principal rotational axies.
     The thermal averages of these properties along with other information is output to file *.fdist.average.(tempfinal)K.  This code is also capable of performing temperature scaling of the input data from the *.MCdata files which would allow the reading of *.MCdata files obtained at one temperature and producing properties at another temperature.

     Input information

     Input is read from std input.  These can be put in file and directed to the binary via the following syntax:  binary < file
The input file contains the following fields.  These fields are separated by spaces or by newlines as in the following list.

      'file name prefix' ! defines the prefix for files which are both read and written
      'Tempinit and Temp' !inital and final temperature (K) for scaled distributions
      'rmin and rmax' !grid min and max for O-O distance (Ang.)
      'natoms, nmcchains' !number of atoms per configuration and markov chains (files)
      'rcut' !cutoff of RConfig (All values .le.)
      'emin and emax' !grid min and max for Energies (kcal/mole)
      'maximum dipole moment' !grid max for Dipole Moments(au)
      'number of monomers' !number of distinct water monomers
      'Array of oxygen atom numbers' !atom numbers of oxygen atoms of each monomer
      'Array of atomic masses' !Atomic masses (amu or g/mol)

     Compilation

     Standard fortran compilers should work.  The code does require blas and lapack libraries to be linked to.

     Running

     The resulting binary should be run in the same location as the input and output files.  If a file is prepaired as input named inputfile.inp and the binary is named averagehist_5.x, the syntax to run this program is averagehist_5.x < inputfile.inp

****************************************************************
      Program refinedistribution_5

      Reads in multiple *.MCdata files created by the DNTMC module.  Produces a file *.fdist.output.(tempfinal)K which contains a new distribution determined by data read in from the *.MCdata files.  This new distribution has been scaled according to a change in temperature.  Temp is the temperature at which the *.MCdata files where obtained.  Final Temp is the temperature at which the new distribution is output in the *.fdist.output.(tempfinal)K file.

     Input information

     Input is read from std input.  These can be put in file and directed to the binary via the following syntax:  binary < file
The input file contains the following fields.  These fields are separated by spaces or by newlines as in the following list.

     'file name prefix' ! defines the prefix for files which are both read and written
     'Init. Temp  and Final Temp' !inital and final temperature (K) for scaled distributions
     'rmin and rmax' !grid min and max for distribution (Ang.)
     'natoms and nmcchains' !number of atoms per configuration and markov chains (files)

     Compilation

     Standard fortran compilers should work. No special instructions

     Running

      The resulting binary should be run in the same location as the input and output files.  If a file is prepaired as input named inputfile.inp and the binary is named refinedistribution_5.x, the syntax to run this program is refinedistribution_5.x < inputfile.inp

****************************************************************
      Program Data_Analysis5

      Reads in a distribution file (*.fdist) created by the DNTMC module.  This program wants this file to be names data_analysis.inp.  The results of the data_analysis are output to std output.  This code only supports homogenious nucleation, however, can be altered to include the possibility of different monomers.  For each entry in the (*.fdist) input file, 1.)  the number of configurations  2.)  Rcut  (Ang.)  3.)  Error in Rcut (Ang.)  4.)  Evaporation Rate constant (s^-1)  5.)  Error in Evaporation Rate Constant (s^-1)  6.)  Internal pressure (atm.)  7.)  Density (moles[cluster]/ml)

      Input Information

      Input is read from std input.  These can be put in file and directed to the binary via the following syntax:  binary < file
The input file contains the following fields.  These fields are separated by spaces or by newlines as in the following list.

      'rconfig and temp' !  A logical .true. or .false. which defines if the data to be read was obtained via the rconfig methodology
                                !  Also the temperature in (K) that the data to be read was obtained.

except for some variables in the code itself which must be set.  They are as follows:

      mtot = 18.02D+00 ! Mass of monomers (amu)

     Compilation

     Standard fortran compilers should work. No special instructions

     Running

      The resulting binary should be run in the same location as the input files.  If a file is prepaired as input named inputfile.inp and the binary is named data_analysis5.x, the syntax to run this program is data_analysis5.x < inputfile.inp.  If the output needs to be saved to a file, this can be done with an output file named outputfile.out via: data_analysis5.x < inputfile.inp > outputfile.out

DISTRO TOOLS
============

In this directory some tools are provided to help generate binary
distributions of NWChem. 

gen_default.nwchemrc

    This script will generate the default nwchemrc file on a users
    machine. This goes into the directory ${target}/etc.

build_nwchem_bin_distro

    This script takes as a command line argument the directory name
    were the source code distribution lives. It expects 
    gen_default.nwchemrc to sit next to this directory and expects
    to be run from that directory. It will then create a directory
    for the binary and the suplemental material, copy all relevant
    material into it, and generate the various archives.

    Example: In the directory nwchem_releases we have:

       ./nwchem-6.0-linux/
       ./gen_default.nwchemrc
       ./build_nwchem_bin_distro

    We can then run:

       ./build_nwchem_bin_distro nwchem-6.0-linux

    After which the directory will contain:

       ./nwchem-6.0-linux/
       ./gen_default.nwchemrc
       ./build_nwchem_bin_distro
       ./nwchem-6.0-binary/
       ./nwchem-6.0-binary.tgz
       ./nwchem-6.0-binary.MANIFEST
       ./nwchem-6.0-binary.tar.bz2

build_nwchem

    This script sets up a set of environment variables and builds 
    NWChem accordingly. I can easily be adapted to any particular build
    of interest. At present it is set up to build a statically linked
    executable with the GNU compilers.

Reorders pdb file based on the center of geometries distances from
central residue. 
Possible to limit center of geometry definition 
to subset of atoms specified by a name substring.
Can be run interactively or through parameter file.

Example files for sorting based on the distance between
oxygens

oh_ref.pdb
transform_pdb.dat

This is a series of amino acids

NWChem input files:
big.nw     - nwchem input deck
big.pdb    - pdb file with geometry

amber input files:
big_am.in  - amber input deck
big_am.top - amber topology file
big_am.cor - coordinates

NWChem output files:
big.seq
big.nam
VAL.mat
THR.mat
SER.mat
PHE.mat
MET.mat
LEU.mat
ILE.mat
GLU.mat
big.top
big_md.rst
big_md.cmd
big.bsg
ASP.mat
ASN.mat
ARG.mat
ALA.mat
big_energy.out
big.out
big_md.qrs
big_md.out
big.db

amber output files:
mdinfo
big_am.rst
big_am.out

results from *.out files:
 4.269883063E+03  kJ/mol for nwchem single point (1.0205d+03 kcal/mol)
-1.36273E+03 for step 500 of nwchem (-3.2570E+02 kcal/mol)
-2.19845E+03 for step 1500 of nwchem (-5.2544E+02 kcal/mol)
-2.63110E+03 for step 3000 of nwchem (-6.2885E+02 kcal/mol)
 1.0211E+03 kcal/mol for amber single point
-4.6434E+02 kcal/mol for amber 500 steps
-6.4649E+02 kcal/mol for amber 1500 steps
-7.5345E+02 kcal/mol for amber 3000 steps
Note that this is an unzipping of the amino acid chain, so the energy just keeps dropping

This is an Ethane 4 plus ion, that NWChem generates new data for

NWChem input file:
ethplus.nw   - nwchem input deck

Amber input files:
ethplus_am.in   - amber input deck
ethplus_am.cor  - coordinates
ethplus_am.top  - topology file

NWChem output files:
ethplus.zmat
ethplus.p
ethplus.nam
ethplus.movecs
ethplus.c
ethplus.b^-1
ethplus.b
ethplus.xyz
ethplus.top
ethplus.seq
ethplus.q
ethplus.plt
ethplus_md.rst
ethplus_md.cmd
ethplus.grid
ethplus_energy.out
ethplus.bsg
ethpl.sgm
ethpl.frg
ethplus.out
ethplus_md.qrs
ethplus_md.out
ethplus.db

Amber output files:
mdinfo
ethplus_am.rst
ethplus_am.out

Results from *.out files:
1.471673291E+03  kJ/mol NWChem single point (3.5174E+02 kcal/mol)
1.38277E+03      kJ/mol NWChem step 25 (3.3049E+02 kcal/mol)
3.5181E+02   kcal/mol Amber single point
3.3048E+02   kcal/mol Amber step 400
Note that NWChem and Amber match both optimized and initial

This is an ALA dimer

NWChem input files:
small.nw  - nwchem job file
small.pdb - geometry as a PDB file, used by small.nw

NWChem output file:
small_energy.out
small_md.out
small.top
small.seq
small.out
small.nam
small_md.rst
small_md.qrs
small_md.cmd
small.db
small.bsg

Amber input files:
small_am.in  - amber job file
small_am.cor - amber coordinate file
small_am.top - amber topology file

Amber output files:
small_am.out
small_am.rst
mdinfo

Results from *.out files:
-1.374134919E+02 kJ/mol for single point NWChem (-3.2843E+01 kcal/mol)
-1.83007E+02     kJ/mol for 500 steps NWChem    (-4.3740E+01 kcal/mol)
-1.90732E+02     kj/mol for 7000 steps NWChem   (-4.5586E+01 kcal/mol)
-3.2847E+01      kcal/mol for single point Amber
-4.5025E+01      kcal/mol for 500 steps Amber
-4.5867E+01      kcal/mol for 7000 steps Amber
Note that the initial and optimized energies match well

This is an Ethane molecule, that NWChem generates new data for

NWChem input file:
eth.nw   - nwchem input deck

Amber input files:
eth_am.in   - amber input deck
eth_am.cor  - coordinates
eth_am.top  - topology file

NWChem output files:
-rw-rw-r--  1 d3p852 d3p852  248 Oct 19 14:12 eth.zmat
-rw-rw-r--  1 d3p852 d3p852 6.2K Oct 19 14:12 eth.p
-rw-rw-r--  1 d3p852 d3p852 6.2K Oct 19 14:12 eth.c
-rw-rw-r--  1 d3p852 d3p852 5.3K Oct 19 14:12 eth.b^-1
-rw-rw-r--  1 d3p852 d3p852 5.3K Oct 19 14:12 eth.b
-rw-rw-r--  1 d3p852 d3p852  803 Oct 19 14:12 eth.q
-rw-rw-r--  1 d3p852 d3p852  104 Oct 19 14:12 eth.nam
-rw-rw-r--  1 d3p852 d3p852 2.7K Oct 19 14:12 eth.movecs
-rw-rw-r--  1 d3p852 d3p852 167K Oct 19 14:12 eth.grid
-rw-rw-r--  1 d3p852 d3p852  442 Oct 19 14:12 eth.xyz
-rw-rw-r--  1 d3p852 d3p852 4.7K Oct 19 14:12 eth.top
-rw-rw-r--  1 d3p852 d3p852 2.3K Oct 19 14:12 eth.sgm
-rw-rw-r--  1 d3p852 d3p852   40 Oct 19 14:12 eth.seq
-rw-rw-r--  1 d3p852 d3p852 169K Oct 19 14:12 eth.plt
-rw-rw-r--  1 d3p852 d3p852  41K Oct 19 14:12 eth.out
-rw-rw-r--  1 d3p852 d3p852 1.3K Oct 19 14:12 eth_md.rst
-rw-rw-r--  1 d3p852 d3p852  20K Oct 19 14:12 eth_md.qrs
-rw-rw-r--  1 d3p852 d3p852 9.6K Oct 19 14:12 eth_md.out
-rw-rw-r--  1 d3p852 d3p852    0 Oct 19 14:12 eth_md.cmd
-rw-rw-r--  1 d3p852 d3p852  824 Oct 19 14:12 eth.frg
-rw-rw-r--  1 d3p852 d3p852  12K Oct 19 14:12 eth_energy.out
-rw-rw-r--  1 d3p852 d3p852 1.1M Oct 19 14:12 eth.db
-rw-rw-r--  1 d3p852 d3p852  426 Oct 19 14:12 eth.bsg

Amber output files:
-rw-rw-r--  1 d3p852 d3p852  384 Oct 19 14:11 mdinfo
-rw-rw-r--  1 d3p852 d3p852  303 Oct 19 14:11 eth_am.rst
-rw-rw-r--  1 d3p852 d3p852  13K Oct 19 14:11 eth_am.out

Results from *.out files:
3.714703721E+00 kJ/mol Single point energy NWChem (8.8784E-01 kcal/mol)
1.63128E+00     kJ/mol after 19 steps in NWChem   (3.8989E-01 kcal/mol)
8.8371E-01    kcal/mol single point energy Amber
3.8987E-01    kcal/mol after 500 steps in Amber

Note that NWChem and Amber match both optimized and initial

Older version of manual.  New version under development.

This directory contains the documentation for PeIGS.  It uses "dvips"
to convert dvi-file to postscript.  You may want to edit the Makefile
to suit your local setup.

You can make a *.dvi file and the postscript file by

	% make

This is a solvent only NWChem run

NWChem input files:
meoh.nw  - nwchem input deck
meoh.pdb - EMPTY pdb file, to fool nwchem
meoh.rst - restart file - same as scr/data/solvents/meoh.rst

NWChem output files:
meoh.top
meoh.seq
meoh_out.pdb - This is a PDB file of the resulting structure
meoh.out
meoh.nam
meoh_em.rst
meoh.db
meoh.bsg

Result:
Expect a 5780 line PDB file that starts like
CRYST1   42.476   42.476   42.476  90.00  90.00  90.00
Note that this is not a test of a result, it is a functionality test

1. To compile set evironmental variable FC to your Fortran90 compiler 
    (.eg. setenv FC gfortran) and run make
2. To run type
   ./amber-helper
3. The program expects AMBER parameters to be in amber.in file 
   (see included amber.in.ref for example). No fixed formatting is assumed and
   lines prefixed by # will be ignored (see example file)
4. NWChem parameter file will be generated in amber.par. 
   If amber.par is present prior to run, the code will issue an error.
5. For information regarding units for NWChem amber.par file see enclosed
   parameter-file.pdf

   Marat Valiev, PNNL
   October 7, 2010

This is a series of amino acids, with SHAKE ON

NWChem input files:
big.nw     - nwchem input deck
big.pdb    - pdb file with geometry

amber input files:
big_am.in  - amber input deck
big_am.top - amber topology file
big_am.cor - coordinates

NWChem output files:
big.seq
big.nam
VAL.mat
THR.mat
SER.mat
PHE.mat
MET.mat
LEU.mat
ILE.mat
GLU.mat
big.top
big_md.rst
big_md.cmd
big.bsg
ASP.mat
ASN.mat
ARG.mat
ALA.mat
big_energy.out
big.out
big_md.qrs
big_md.out
big.db

amber output files:
mdinfo
big_am.rst
big_am.out

results from *.out files:
 4.266015438E+03 kJ/mol for NWChem single point (10.1960E+02 kcal/mol)
-1.29173E+03     kJ/mol for 300 steps NWChem    (-2.0873E+02 kcal/mol)
-2.70772E+03     kJ/mol for 1500 steps NWChem   (-6.4716E+02 kcal/mol)
-2.70992E+03     kJ/mol for 3000 steps NWChem   (-6.4769E+02 kcal/mol)
 9.4289E+02 kcal/mol for amber single point
-4.5606E+02 kcal/mol for amber 300 steps
-6.4034E+02 kcal/mol for amber 1500 steps
-6.4192E+02 kcal/mol for amber 3000 steps
Note that they match, but I had to limit NWChem's maximum step size to get this

This documents how to convert basis sets as output by Dave Fellers
gbasis program in nwchem format into NWCHEM library format.


The most time consuming steps cannot be automated since
they require assesment of the correctness of the contents.
A useful command is
  
   egrep '^BASIS|^END|^Effec' NWCHEM.BSLIB

1) Remove duplicate basis sets 

2) Look for obvious errors in data from Dave

3) Ensure that all basis sets are terminated with END
   (if not it could be a problem in data from Dave. 
   DFT basis sets seem to be an exception)
   a) use "./end2end.pl NWCHEM.BSLIB" to identify
   b) fix by hand (emacs/vi).

4) Ensure ECPs are present where they should be and that in 
   a basis set family that they appear AFTER the corresponding
   basis sets (introduced with 'Effective core potentials').

5) Replace '! #' with '#' (ECPs only?).
   a) cp NWCHEM.BSLIB stuff
   b) cat stuff | sed -e s'/\! #/#/g' > NWCHEM.BSLIB

6) nawk -f bas.awk < NWCHEM.BSLIB > library

7) look at the output
    a) do it!
    b) do it again!!


**********************   csh script grepsort does 8-13

8) egrep 'basis|ecp' ../library > list.old
   egrep 'basis|ecp' library > list.new

9) wc list.*  new should be equal or greater?

10) cat list.old | sort > sort.old 
    cat list.new | sort > sort.new

11) cat list.old | sort -u > sort.u.old 
    cat list.new | sort -u > sort.u.new

12) wc sort.* should identify redundancy in sets.

13) diff -b sort.u.old sort.u.new  shows the differences

names with < are in the old library but missing from the new library
names with > are new so keep them

14) make libcheck in the basis directory and run in the convert directory


I have a set of scripts that will eventually run calculations for all
of the basis sets and ECPs for all atoms.  This is not yet finished.

Robert


15) make compare in the basis directory and run in the convert directory
    the code assumes that your new library is called library.new and the
    previous basis set library is called library.

16) run "gen_liblist.pl library" to generate an updated library.list,
    library.fam and library.tex (tex file for use in user manual).

Bert

GLOBAL ARRAYS
~~~~~~~~~~~~~

DISCLAIMER
==========

This material was prepared as an account of work sponsored by an
agency of the United States Government.  Neither the United States
Government nor the United States Department of Energy, nor Battelle,
nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED,
OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
INFRINGE PRIVATELY OWNED RIGHTS.

ACKNOWLEDGMENT
==============

This software and its documentation were produced with United States
Government support under Contract Number DE-AC06-76RLO-1830 awarded
by the United States Department of Energy. The United States
Government retains a paid-up non-exclusive, irrevocable worldwide
license to reproduce, prepare derivative works, perform publicly and
display publicly by or for the US Government, including the right to
distribute to other US Government contractors.

The primary current source of funding for development of GA is the DoE-2000
ACTS project. GA is a part of the ACTS toolkit:

    http://acts.nersc.gov 

FOR THE IMPATIENT
=================

The command::

    ./configure && make && make install

should compile the static GA library (libga.a) to use sockets and install
headers and libraries to /usr/local/include and /usr/local/lib, respectively.

Please refer to the INSTALL file for generic build instructions.  That is a
good place to start if you are new to using "configure; make; make install"
types of builds.  Detailed instructions are covered later in this file.

QUESTIONS/HELP/SUPPORT/BUG-REPORT
=================================

email: hpctools@pnl.gov

If you encounter any problems, please first refer to the file NOTES located in
the same directory and see the GA support webpage:

    http://www.emsl.pnl.gov/docs/global/support.html

Please don't hesitate to send us an email.  An archive of emails is available
at:

    http://groups.google.com/group/hpctools

WHERE IS THE DOCUMENTATION?
===========================

The GA webpage has the most current versions of the Fortran and C documentation
and the User's Manual in the HTML format:

    http://www.emsl.pnl.gov/docs/global/

ABOUT THIS SOFTWARE
===================

This directory contains the Global Arrays (GA), Aggregate Remote Memory Copy
Interface (ARMCI) run-time library, and Memory Allocator (MA), parallel I/O
libraries (DRA,EAF,SF), TCGMSG, and TCGMSG-MPI packages bundled together. 

Global Arrays is a portable Non-Uniform Memory Access (NUMA) shared-memory
programming environment for distributed and shared memory computers. It
augments the message-passing model by providing a shared-memory like access to
distributed dense arrays.

ARMCI provides one-sided remote memory operations used by GA.

DRA (Disk Resident Arrays) is a parallel I/O library that maintains dense 2-dim
arrays on disk. 

SF (Shared Files) is a parallel I/O library that allows noncollective I/O to a
parallel file.

EAF (Exclusive Access Files) is parallel I/O library that supports I/O to
private files.

TCGMSG is a simple, efficient, but becoming obsolete message-passing library.

TCGMSG-MPI is a TCGMSG interface implementation on top of MPI and ARMCI. 

MA is a dynamic memory allocator/manager for Fortran and C programs.

GA++ is a C++ binding for global arrays.

See file 'COPYRIGHT' for copying conditions.
See file 'INSTALL' for compilation and installation instructions (generic).
See file 'NEWS' for a list of major changes in the current release.
See file 'AUTHORS' for the names of anyone who has contributed to GA.
See file 'NOTES' for a few platform-specific symptoms and fixes.

DIRECTORY STRUCTURE (ALPHABETICALLY)
====================================

- armci
    + config        (configuration makefile includes)
    + doc           (documentation for ARMCI library)
    + lib           (compatibility source files for missing system features)
    + src           (source code for ARMCI library)
- build-aux         (autotools support scripts)
- cca               (common component architecture)
- compat            (compatibility source files for missing system features)
- doc               (documentation)
- ga++              (C++ Bindings for Global Arrays)
    + doc           (contains sample Doxyfile for Doxygen doc generator)
    + src           (source code for GA C++ bindings)
    + testing       (test programs)
- gaf2c             (Fortran-to-C compatibility library and tests)
- global
    + doc           (paper & documentation in PostScript, HTML & plain text)
    + src           (source code for GA library)
    + testing       (GA test programs and performance results)
    + trace         (library and programs to generate and process tracefiles)
    + X             (xregion visualization program for GA)
- LinAlg            (linear algebra software used by GA)
    + lapack+blas
- m4                (autoconf macros)
- ma                (Memory Allocator) 
    + man
- pario
    + dra           (Disk Resident Array Library code)
    + eaf           (Exclusive Access Files Library code)
    + elio          ("device" layer for other parallel I/O models)
    + sf            (Shared Files Library code)
- tcgmsg            (simple, legacy message-passing library)
    + ipcv4.0    
    + ipcv5.0    
    + tcgmsg-mpi    (TCGMSG on top of MPI)

HOW TO BUILD THE PACKAGE?
=========================

Please refer to the INSTALL file for generic build instructions.  That is a
good place to start if you are new to using "configure; make; make install"
types of builds.  The following will cover platform-specific considerations as
well as the various optional features of GA.  Customizations to the GA build
via the configure script are discussed next.

Configuration Options
---------------------

There are many options available when configuring GA.  Although configure can
be safely run within this distributions' root folder, we recommend performing
an out-of-source (aka VPATH) build.  This will cleanly separate the generated
Makefiles and compiled object files and libraries from the source code.  This
will allow, for example, one build using sockets versus another build using
OpenIB for the communication layer to use the same source tree e.g.::

    mkdir bld_mpi_sockets && cd bld_mpi_sockets && ../configure
    mkdir bld_mpi_openib  && cd bld_mpi_openib  && ../configure --with-openib

Regardless of your choice to perform a VPATH build, the following should
hopefully elucidate the myriad options to configure.  Only the options
requiring additional details are documented here.  ./configure --help will
certainly list more options in addition to limited documentation.

--disable-f77           Disable Fortran code. This used to be the old
                        GA_C_CORE or NOFORT environment variables which
                        enabled the C++ bindings. However, it is severely
                        broken. There are certain cases where Fortran code is
                        required but this will not inhibit the building of the
                        C++ bindings.  In the future we may be able to
                        eliminate the need for the Fortran compiler/linker.
                        Use at your own risk (of missing symbols at link-time.)
--enable-cxx            Build C++ interface. This will require the C++ linker
                        to locate the Fortran libraries (handled
                        automatically) but user C++ code will require the same
                        considerations (C++ linker, Fortran libraries.)
--disable-opt           Don't use hard-coded optimization flags. GA is a
                        highly-optimized piece of software. There are certain
                        optimization levels or flags that are known to break
                        the software. If you experience mysterious faults,
                        consider rebuilding without optimization by using this
                        option.
--enable-peigs          Enable Parallel Eigensystem Solver interface. This
                        will build the stubs required to call into the peigs
                        library (external). 
--enable-checkpoint     Enable checkpointing.  Untested.  For use with old
                        X-based visualization tool.
--enable-profile        Enable profiling. Not sure what this does, sorry.
--enable-trace          Enable tracing. Not sure what this does, sorry.
--enable-thread-safety  **unsupported** Turn on thread safety.
--enable-underscoring   Force single underscore for all external Fortran
                        symbols. Usually, configure is able to detect the name
                        mangling scheme of the detected Fortran compiler and
                        will default to using what is detected. This includes
                        any variation of zero, one, or two underscores or
                        whether UPPERCASE or lowercase symbols are used. If
                        you want to force a single underscore which was the
                        default of older GA builds, use this option.
                        Otherwise, you can use the FFLAGS environment variable
                        to override the Fortran compiler's or platform's
                        defaults e.g. configure FFLAGS=-fno-underscoring.
--enable-i4             Use 4 bytes for Fortran INTEGER size. Otherwise, the
                        default INTEGER size is set to the results of the C
                        sizeof(void*) operator.
--enable-i8             Use 8 bytes for Fortran INTEGER size. Otherwise, the
                        default INTEGER size is set to the results of the C
                        sizeof(void*) operator.
--enable-shared         Build shared libraries [default=no]. Useful, for
                        example, if you plan on wrapping GA with an
                        interpreted language such as Python. Otherwise, some
                        systems only support static libraries (or vice versa)
                        but static libraries are the default.

For most of the external software packages an optional argument is allowed
(represented as ARG below.) **ARG can be omitted** or can be one or more
whitespace-separated directories, linker or preprocessor directives.  For
example::

    --with-mpi="/path/to/mpi -lmylib -I/mydir"
    --with-mpi=/path/to/mpi/base
    --with-mpi=-lmpich

The messaging libraries supported include MPI, TCGMSG, and TCGMSG over MPI.  If
you omit their respective --with-* option, MPI is the default.  GA can be built
to work with MPI or TCGMSG. Since the TCGMSG package is small (comparing to
portable MPI implementations), compiles fast, it is still bundled with the GA
package.

--with-mpi=ARG          Select MPI as the messaging library (default). If you
                        omit ARG, we attempt to locate the MPI compiler
                        wrappers. If you supply anything for ARG, we will
                        parse ARG as indicated above.
--with-tcgmsg           Select TCGMSG as the messaging library; if
                        --with-mpi is also specified then TCGMSG over MPI is
                        used.
--with-vampir=ARG       Enable VAMPIR performance tracing.
                        http://www.vampir.eu
--with-blas=ARG         Use external BLAS library; attempt to detect
                        sizeof(INTEGER) used to compile BLAS; if not found, an
                        internal BLAS is built
--with-blas4=ARG        Use external BLAS library compiled with
                        sizeof(INTEGER)==4
--with-blas8=ARG        Use external BLAS library compiled with
                        sizeof(INTEGER)==8
--with-lapack=ARG       Use external LAPACK library. If not found, an internal
                        one is built.
--with-scalapack=ARG    Use external ScaLAPACK library.

The ARMCI networks supported are listed next.  Our ability to automatically
locate required headers libraries is currently inadequate.  Therefore, you will
likely need to specify the optional ARG pointing to the necessary directories
and/or libraries. sockets is the default ARMCI network if nothing else is
specified.

--with-bgml=ARG         select armci network as IBM BG/L
--with-cray-shmem=ARG   select armci network as Cray XT shmem
--with-dcmf=ARG         select armci network as IBM BG/P Deep Computing
                        Message Framework
--with-lapi=ARG         select armci network as IBM LAPI
--with-mpi-spawn=ARG    select armci network as MPI-2 dynamic process mgmt
--with-openib=ARG       select armci network as Infiniband OpenIB
--with-portals=ARG      select armci network as Cray XT portals
--with-sockets=ARG      select armci network as Ethernet TCP/IP (default)

There are some influential environment variables as documented in configure
--help, however there are a few that are special to GA.

- THREAD_LIBRARY
  See --enable-thread-safety. I don't know what this does, sorry.

- F77_INT_FLAG
  Fortran compiler flag to set the default INTEGER size. We know about certain
  Fortran flags that set the default INTEGER size, but there will certainly be
  some new (or old) ones that we don't know about. If the configure test to
  determine the correct flag fails, please try setting this variable and
  rerunning configure.

- F2C_HIDDEN_STRING_LENGTH_AFTER_ARGS
  If cross compiling, set to either "yes" (default) or "no" (after string).
  For compatibility between Fortran and C, a Fortran subroutine written in C
  that takes a character string must take an additional argument (one per
  character string) indicating the length of the string. This 'hidden'
  argument appears either immediately after the string in the argument list
  or after all other arguments to the function. This is compiler dependent. We
  attempt to detect this behavior automatically, but in the case of
  cross-compiled systems it may be necessary to specify the less usual after
  string convention the gaf2c/testarg program crashes.

Special Notes for BLAS
----------------------

BLAS, being a Fortran library, can be compiled with a default INTEGER size of
4 or a promoted INTEGER size of 8.  Experience has shown us that most of the
time the default size of INTEGER used is 4.  In some cases, however, you may
have an external BLAS library which is using 8-byte INTEGERs.  In order to
correctly interface with an external BLAS library, GA must know the size of
INTEGER used by the BLAS library.

configure has the following BLAS-related options: --with-blas, --with-blas4,
and --with-blas8.  The latter two will force the INTEGER size to 4- or
8-bytes, respectively.  The first option, --with-blas, defaults to 4-byte
INTEGERS *however* in the two special cases of using ACML or MKL, it is
possible to detect 8-byte INTEGERs automatically.  As documented in the ACML
manual, if the path to the library has "_int64" then 8-byte INTEGERs are used.
As documented in the MKL manual, if the library is "ilp64", then 8-byte
INTEGERs are used.

You may always override --with-blas by specifying the INTEGER size using one
of the two more specific options.

Cross-Compilation Issues
------------------------

Certain platforms cross-compile from a login node for a compute node, or one
might choose to cross-compile for other reasons. Cross-compiling requires the
use of the --host option to configure which indicates to configure that certain
run-time tests should not be executed. See INSTALL for details on use of the
--host option.

Two of our target platforms are known to require cross-compilation, Cray XT and
IBM Blue Gene.

Cray XT
+++++++

It has been noted that configure still succeeds without the use of the --host
flag.  If you experience problems without --host, we recommend::

    configure --host=x86_64-unknown-linux-gnu

And if that doesn't work (cross-compilation is not detected) you must then
*force* cross-compilation using both --host and --build together::

    configure --host=x86_64-unknown-linux-gnu --build=x86_64-unknown-linux-gnu

BlueGene/P
++++++++++

Currently the only way to detect the BGP platform and compile correctly is to
use::

    configure --host=powerpc-bgp-linux

The rest of the configure options apply as usual e.g. --with-dcmf in this case.

Compiler Selection 
------------------

Unless otherwise noted you can try to overwrite the default compiler names
detected by configure by defining F77, CC, and CXX for Fortran (77), C, and C++
compilers, respectively.  Or when using the MPI compilers MPIF77, MPICC, and
MPICXX for MPI Fortran (77), C, and C++ compilers, respectively::

    configure F77=f90 CC=gcc
    configure MPIF77=mpif90 MPICC=mpicc

Although you can change the compiler at make-time it will likely fail.  Many
platform-specific compiler flags are detected at configure-time based on the
compiler selection. If changing compilers, we recommend rerunning configure as
above.

After Configuration
-------------------

By this point we assume you have successfully run configure either from the
base distribution directory or from a separate build directory (aka VPATH
build.)  You are now ready to run 'make'.  You can optionally run parallel
make using the "-j" option which significantly speeds up the build.  If using
the MPI compiler wrappers, occasionally using "-j" will cause build failures
because the MPI compiler wrapper creates a temporary symlink to the mpif.h
header.  In that case, you won't be able to use the "-j" option.  Further, the
influential environment variables used at configure-time can be overridden at
make-time in case problems are encountered.  For example::

    ./configure CFLAGS=-Wimplicit
    ...
    make CFLAGS="-Wimplicit -g -O0"

One particularly influential make variable is "V" which controls the verbosity
of the make output. This variable corresponds to the --dis/enable-silent-riles
configure-time option, but I often prefer the make-time variable::

    make V=0 (configure  --enable-silent-rules)
    make V=1 (configure --disable-silent-rules)

Test Programs
-------------

Running "make checkprogs" will build most test and example programs.  Note that
not all tests are built -- some tests depend on certain features being
detected or enabled during configure.  These programs are not intented to be
examples of good GA coding practices because they often include private
headers.  However, they help us debug or time our GA library.

Test Suite
++++++++++

Running "make check" will build most test and example programs (See "make
checkprogs" notes above) in addition to running the test suite.  The test
suite runs both the serial and parallel tests.  The test suite must know how
to launch the parallel tests via the MPIEXEC variable.  Please read your MPI
flavor's documentation on how to launch, or if using TCGMSG you will use the
"parallel" tool.  For example, the following is the command to launch the test
suite when compiled with OpenMPI::

    make check MPIEXEC="mpiexec -np 4"

All tests have a per-test log file containing the output of the test.  So if
the test is global/testing/test.x, the log file would be
global/testing/test.log.  The output of failed tests is collected in the
top-level log summary test-suite.log.

The test suite will recurse into the ARMCI directory and run the ARMCI test
suite first.  If the ARMCI test suite fails, the GA test suite will not run
(the assumption here is that you should fix bugs in the dependent library
first.)  To run only the GA test suite, type "make check-ga" with the
appropriate MPIEXEC variable.

How to Run GA Test Programs?  
----------------------------

Depends on the system. MPPs like Intel iPSC/860, Delta, Paragon, IBM SPx, Cray
T3/E have their own commands for submitting parallel jobs.

On workstations and clusters, GA are run like ordinary message-passing
programs::

  To run GA programs with MPI, you need to built the package to be compatible
  with MPI (see README in ./global and documentation in ./global/doc/ ) and
  run it as any other MPI program.  The GA package has been tested only with a
  limited number of MPI implementations (MPICH, and vendor's: Intel, IBM, Sun,
  HP, and SGI).

  TCGMSG `parallel' command (built automaticaly in ./tcgmsg/ipcv4.0/parallel
  if needed) is used to start a job on clusters if you are using TCGMSG as
  your message-passing library. On the workstations, GA-based programs that
  use TCGMSG can be run with a single process without the `parallel' command
  -- just by typing program name -- useful for debugging. 

Other Issues 
============

a. LINUX64 supports ALPHA, Itanium, Opteron, and Em64T processors only. 

b. The SGI_N32 version is recommended on all newer SGI boxes including
   the O2, Octane, Origin, Indigo2, and PowerChallenge systems
   unless the system has lots of memory and your program uses 
   huge arrays (>4GB) in which case 64-bit addressing is required
   (SGITFP version). In addition, TARGET_CPU environment
   variable can be used to choose the optimal compiler flags 
   for R8000 and R10000 processors.

c. In 64 bit platforms, if you are using blas libraries that takes
   integer as 8 bytes, then set the following environment variables:
   setenv BLAS_I8 yes
   setenv BLAS_LIB specify_your_blas_library
   e.g.setenv BLAS_LIB -L/usr/lib/libblas.a

d. To turn Async I/O on under Linux, set environment variable USE_LINUXAIO=y

Performance Tuning
------------------

global/src/gaconfig.h has a varible called AVOID_MA_STORAGE. If defined, this
variable forces GA to use ARMCI memory which can lead to better performance on
platforms on which memory needs to be registered for fast communication.

Setting an environment variable MA_USE_ARMCI_MEM forces MA library to use
ARMCI memory, communication via which can be faster on networks like GM, VIA
and InfiniBand.

Task Scheduling Library (tascel -- pronounced tassel)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

DISCLAIMER
==========

This material was prepared as an account of work sponsored by an
agency of the United States Government.  Neither the United States
Government nor the United States Department of Energy, nor Battelle,
nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED,
OR ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
INFRINGE PRIVATELY OWNED RIGHTS.

ACKNOWLEDGMENT
==============

This software and its documentation were produced with United States
Government support under Contract Number DE-AC06-76RLO-1830 awarded
by the United States Department of Energy. The United States
Government retains a paid-up non-exclusive, irrevocable worldwide
license to reproduce, prepare derivative works, perform publicly and
display publicly by or for the US Government, including the right to
distribute to other US Government contractors.

FOR THE IMPATIENT
=================

The command::

    ./configure && make && make install

should compile the static tascel library (libtascel.a) and install
headers and libraries to /usr/local/include and /usr/local/lib,
respectively.

Please refer to the INSTALL file for generic build instructions.  That is a
good place to start if you are new to using "configure; make; make install"
types of builds.  Detailed instructions are covered later in this file.

QUESTIONS/HELP/SUPPORT/BUG-REPORT
=================================

email: hpctools@pnl.gov

Please don't hesitate to send us an email.  An archive of emails is available
at:

    http://groups.google.com/group/hpctools

WHERE IS THE DOCUMENTATION?
===========================

The documentation, based on doxygen source code comments, is available
in doc/ sub-directory.


ABOUT THIS SOFTWARE
===================

Tascel is a task scheduling library, compatible with MPI and ARMCI,
that implements algorithms for dynamic load balancing. It builds
upon the algorithms developed in the implementation of the SCIOTO
library for dynamic load balancing.

DIRECTORY STRUCTURE (ALPHABETICALLY)
====================================

- src               (implementation of tascel algorithms)
- examples          (example programs using tascel)
  + scf             (SCF algorithm implemented with tascel)
- test              (small test programs)
- doc               (documentation)
- m4                (autoconf macros)
- build-aux         (autotools support scripts)


HOW TO BUILD THE PACKAGE?
=========================

Please refer to the INSTALL file for generic build instructions.  That is a
good place to start if you are new to using "configure; make; make install"
types of builds. 

SciPy Proceedings
=================

Paper Format
------------

General Guidelines
``````````````````
- All figures and tables should have captions.
- License conditions on images and figures must be respected
  (Creative Commons, etc.).
- Code snippets should be formatted to fit inside a single column
  without overflow.
- Try to use as little custom LaTeX markup as possible.
- The paper abstract should be a single paragraph.

Authors and affiliations
````````````````````````
Define the fields in the beginning of the paper::

  :author: My Name
  :email: myname@myplace.com
  :institution: Some University

  :author: Author Two
  :email: two@myplace.com
  :institution: Some University

Other markup
------------
Please refer to the example paper in ``papers/00_vanderwalt`` for
examples of how to:

 - Label figures, equations and tables
 - Use math markup
 - Include code snippets

Build Process
-------------
::

  ./make_paper.sh papers/my_paper_dir

Building the entire Proceedings
-------------------------------
::

  ./make_all.sh
  ./build_index.py
  ./make_all.sh
  ./concat_proceedings_pdf.sh

Requirements
------------
 - IEEETran and AMSmath LaTeX classes
 - **Latest** docutils (development version, they haven't released in years)
 - Pygments for code highlighting

$Id: README 19708 2010-10-29 18:04:21Z d3y133 $

Here are a few small examples of RI-MP2 calculations, along with the
associated SCF input decks.  Most of them freeze a couple of core
orbitals, but one of the C2H6 ones doesn't.  They all take the fitting
basis sets from fit.lib.

First run the *-scf.nwc calculation, then run any of the corresponding
*-ri*.nwc calculations.  The numbers used at the end of the input deck
names (00, 01, 02) indicate the use of different fitting basis sets,
and you should be able to run more than one such calculation without
re-doing the SCF calculation.

Note, however, that frozen core specifications (*-rifc*.nwc jobs) stay
in the .db file, and so will effect future calculations restarted from
the same .db file.  This means if you run the sequence c2h6-scf.nwc,
c2h6-rifc00.nwc, c2h6-ri00.nwc the frozen core directive from the
second job will also effect the third one!  The simplest approach is
to do any all-electron calculations BEFORE any of the frozen core
ones.

These jobs were run on an SGI PowerChallenge (1 CPU) 12 February 1997 

This is a set of various tests on OH + H2 -> OH2 + H for different 
options in DIRDYVTST.  When running oh3tr2, make sure that the files 
for oh3tr1 are available as oh3tr2 is a "restart" of oh3tr1 extending 
the points calculated on the surface.  The script runoh3 is included 
for ease of running these jobs serially.  NOTE: noautosym is used 
because the reactants have spacial symmetry breaking that causes
problems when symmetry is used.

This is a set of various tests on H + H2 for different options in
DIRDYVTST.  When running h3tr2, make sure that the files for h3tr1 
are available as h3tr2 is a "restart" of h3tr1 extending the points
calculated on the surface.  The script runh3 is included for ease of
running these jobs serially.

$Id: README 19708 2010-10-29 18:04:21Z d3y133 $
This tests the DIRDYVTST capability.  It is not part of the doqmtests because
nwparse.pl does not parse anything from the output file.  When the proper
testing mechanisms are in place, this will be part of the automatic test suite.

========= Dummy centers vs Ghost centers ==========
==== The Characters
Originally dummy centers (named "x") were a mathematical trick to specify 
zmatrices for tricky molecules.  E.g. benzene, or linear molecules.  
Because of their role it is alright to delete dummy centers. This was 
introduced at some point to clean up zmatrices. After deleting the dummies 
the autoz function would be used to regenerate a zmatrix. 

Ghost centers (named "bq" after the ghost Banquo from William 
Shakespeare's Macbeth) were introduced to calculate BSSE 
free energies. These centers have basis sets, but no charge and 
no electrons.

==== The conflict
The way the deletion is implemented means that different things happen 
depending on how dummy centers are named.  Due to a different choice 
of internal coordinates this could lead to a different optimization path.  

==== The resolution
To fix this all centers starting with "x" but not "xe" are deleted and a new 
zmatrix generated. Bq centers by their nature should not be deleted, and they 
now won't be.

==== The dénouement
Not clear to me at present is what happens if the original input 
zmatrix contains constraints. I don't see how these can be handled so that they 
would always survive the elimination of the dummy centers. Of course one could 
replace the dummy centers by ghost centers without a basis set to deal with  
such a case. The dft_bsse test case has been updated to match the new approach.

This directory contains 3 example codes.  They are
geneig2.c wilk2.c and tri_test.c.

The files geneig2.c wilk2.c and tri_test.c are examples of using C calling
the C version of the PeIGS library.

The user should beware that the definition for CTOFLIB in the DEFS files in the
peigs directory is important here for building the C examples.
Unfortunately, the MXSUBS on the SUN seems to need a F77 driver program
to perserve the common block.


This directory also contains the file teslamach for generating
machine dependent parameters which must be included in
 .../peigs/h/blas_lapack.h

2-e atomic ==> 80-100GB of memory
2-e fully transformed ===> 17GB
tilesize = 15
(tilesize)^4 => 0.5 MB
(tilesize)^6  => 91 MB

attilesize = 40
(attilesize)^4 => 2.5 MB

The following line is needed to get this bad boy to run on chinook
unsetenv MA_USE_ARMCI_MEM

Constraint optimization
=======================

This input runs 3 calculations on the water molecule. In all 3 calculations
one OH bond length is constraint, the other one is optimized as well as the
bond angle. However the geometries are specified slightly differently:

h2o_c1:  The symmetry option is used to turn all symmetry off. 
         The resulting calculation works as it should.

h2o_c2v: The input geometry is symmetric but the constraint is asymmetric
         and autosym is not turned off. 
         The resulting calculation optimizes everything even the constraint
         bondlength. THIS IS WRONG!!!

h2o_cs:  The input geometry is asymmetric otherwise everything is the same
         as with the h2o_c2v geometry. 
         The resulting calculation correctly sees the two bondlengths as 
         different and applies the constraints in the correct way.

If correct then all three calculations should arrive at the same answer.
At the moment they do not. The baseline in this directory has been manually
constructed by copying the geometry optimization output for the h2o_c1 
geometry to replace the incorrect results for the h2o_c2v geometry. At the
moment this is the best guess for what the correct output should look like.

This tests the finite nucleus integrals, which have been checked against
results from DREAMS. There are four SCF tasks. The basis set is the cc-pVDZ
set recontracted for a finite nucleus. The first task explicitly sets all
nuclei to be finite. The second simply uses the default point nucleus
model. The third sets finite by default. The fourth sets finite by default
and overrides the default for the H atoms with a point nucleus. The first
and third energies should be the same; the fourth is very close to the
first and third; the second differs in the fourth decimal.

README memory settings test
===========================

With the memory initialization having changed we needed special ways to work
out valid memory settings. Before release 6.1 you either used the default
memory settings or you specified everything in the input file.

Now there are compile time memory settings, they may be set in nwchemrc, by
environment variables or in the input. At this point it makes little sense
to force all sets of memory settings to be complete (i.e. set stack, heap,
global and total). But if they are incomplete we need rules to generate
a complete set of settings. 

These rules built a hierarchy from compiled in default to user input:
- compiled in defaults
- nwchemrc
- environment variables
- user input
The user input file takes precedence over anything else and compile time
defaults are overriden by anything else.

If Total is the default and something else is set. Then the resolution is
simply to adjust the total memory setting and leave anything else untouched.
If Total is set and somethings else is set then the lowest priority setting
is adjusted to ensure that Total = Stack + Heap + Global. If more than one
setting needs to be changed then the usual partitioning is used. I.e. if
Total = 1000 MB and Stack = 400 MB then 
Heap   = 0.25/(0.25+0.50)*(Total - Stack) = 200 MB
Global = 0.50/(0.25+0.50)*(Total - Stack) = 400 MB

The test cases in this directory are just to check that all the various 
combinations of set memory sizes produce the expected result. The flags
TSHG stand for Total, Stack, Heap, and Global, in the second quartet T (true)
means it is set and F (false) means it is not set in the input file. I.e.
he_TSHG_TFFT.nw means Total and Global are set in the input but Stack and Heap
are not.

These tests are not to be included in the usual test run script as we have
no means of automatically checking the results or even running the jobs 
successfully through that infra-structure. Also there should be no need to 
test this stuff on multiple platforms as we are looking for particular logical
errors in the design only.

This output has been verified via external chemistry codes.  The
energies and gradients are correct.

This test case does the energy and gradient of H2CO in a dz+++ like
basis set.  The goal of this test case is that all valid integral and
integral derivative paths are checked.  As integral pathways open up
new specific test cases should be added to the input/output.  The
input file preamble describes the options covered by this input deck.


Ricky A. Kendall, HPCCG, TM&S, EMSL, PNNL, June 1997

Authentication realm: <https://svn.pnl.gov:443> nwchem
------------------------------------------------------------------------
r21871 | d3y133 | 2012-01-25 23:39:15 -0800 (Wed, 25 Jan 2012) | 10 lines

HvD: This test case tests running a DFT calculation with cgmin and following
that up with a Hessian calculation. At the moment this calculation fails
miserably in the cphf_solve2. The reason for the failure is that in 
rohf_energy a Fock matrix is supposed to be generated but instead of a 2D
GA a 3D GA is passed into the Fock builder.
Somehow this problem seems to be related to the logic involving lcgmin on
line 273 of nwchem/src/ddscf/fock_xc.F. However, it is not clear to me what
that logic is trying to achieve so I am not sure what to do about it.
Any hints are welcome.

------------------------------------------------------------------------

This is a converted version of the scf test code in the tcgmsg directory
that solves the Hartree-Fock equations for a cluster of beryllium atoms.
The main modifications are that this code is uses distributed data
instead of replicated data and is based on the GA function calls instead
of TCGMSG. The input is a simple XYZ format file of the form

1 Number of beryllium atoms
2 Blank line
3 4 x y z
4 4 x y z
.
.
.

Other parameters that control convergence etc. can be found in the cscf.h
file. The two-electron Fock build does not make use of the 8-fold symmetry
of the two-electron integrals. The default diagonalization routine makes
use of a similarity transform so that only a standard eigenvalue problem
needs to be solved. A direct solution using a generalized eigenvalue solver
can be had by setting the USE_TRANSFORM compiler directive to 0 in the top
of the scf.F file.

A larger system containing 16 atoms has also been included in this
directory. To run the larger problem, just copy the file be16.inpt to
be.inpt and run the code.

-------------------------------------------------------------------------------
d3y186: 
(1). C version file list
1.cscc.h
2.input.h
3.input.c
4.integ.h
5.integ.c
6.output.h
7.output.c
8.timer.h
9.timer.c
10.scf.c

(2). remove all .F files after checking out from SVN

(3). change the path for GA in the Makefile

(4). use the command "module load pgi/10.6" to load pgcc
     use the command "module load mpi/mvapich/1.1/pgi" to load mpi

(5). You can compile your GA in Trinity by "gmake TARGET=LINUX64 USE_MPI=y ARMCI_NETWORK=OPENIB CC=pgcc FC=pgf90 LIBMPI="-lmpich -libumad" 2>&1 | tee make.log"

This directory contains the source code for a simple lattice Boltzmann
simulation of flow in a lid-driven square cavity. The algorithm used is
described in BJ Palmer and DR Rector, Journal of Computational Physics, vol.
161, pp. 1-20 (2000). The temperature has been set to a constant for this
simulation, eliminating the need for the second distribution and an ideal gas
has been used for equation of state. The output from the simulation is sent to
the file bltz.gmv and can be viewed using the General Mesh Viewer program
developed at Los Alamos National Laboratory. More information on this program
can be obtained from the web page at:

    http://www-xdiv.lanl.gov/XCM/gmv/GMVHome.html

The global arrays used in the code are all declared in the file main.F and
then passed by reference to the subroutines. The output file is created by the
subroutine in printdat.F; if you are interested in writing your own output
routine, you should consult this file. The size of the grid used for the
simulation is set in the include file "common" using the variable NSIZE, the
remaining system parameters are set in the subroutine in setup.F. The
parameters are currently set to model a relatively low velocity flow and
should take a couple of minutes to run on a modest number of processors.
Performance will, of course, depend on the particular system.

For those wishing to try some calculations at other conditions, some of the
remaining parameters are:

- xmax: the dimensions of the square cavity
- viscosity: viscosity
- delta_t: time increment
- tmprtr0: temperature of fluid
- rho0: initial uniform density of fluid in cavity
- uxbc: velocity of lid

The executable name is boltz.x

The parameters are currently set to run at a Reynolds number of 128. A
calculation at a much higher Reynolds number of 2560 can be run by changing
the value of NSIZE to 4097 and resetting the following parameters:

- viscosity: 0.05
- delta_t: 0.1

Note that the simulation will have to be run for a considerably longer time
period before any significant flow patterns begin to develop, on the order of
100000-200000 steps. This calculation also involves a much larger number of
grid cells and requires a significant number of processors to run.

*
* $Id: pspw_et.F 25932 2014-07-23 16:49:34Z bylaska $
*

***********************************************************************
*                      pspw_et  (MPI code)                            *
*                                                                     *
***********************************************************************

      logical function pspw_et(rtdb)
      implicit none
      integer rtdb

#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "rtdb.fh"
#include "errquit.fh"
      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d
      integer npack1,npack0

*     **** electronic variables ****
      real*8 icharge
      integer ispin
      integer ne(2),n1(2),n2(2),nemax,neq(2),nemaxq
      real*8  en(2)
      real*8  dipole(3)

      integer psi1(2), psi2(2), psi1_r(2), psi2_r(2)
      integer psi1f(2),psi2f(2),psi1f_r(2),psi2f_r(2)
      integer rho(2),vc(2)
    

*     ***** energy variables ****
      real*8  E(40)
      integer Sigma_ab(2),Cigma_ab(2),itmp(2)
      integer U_ab(2),V_ab(2),W_ab(2),Vt(2)

      logical field_exist


*     **** error variables ****
      integer ierr

*     **** local variables ****
      real*8 H1aa,H1bb,H1ab,H2aa,H2bb,H2ab,Vab,Haa,Hbb,Hab,Sab,S12(2)
      integer ms,mapping,mapping1d
      real*8  deltae,deltac,deltar
      real*8  gx,gy,gz,cx,cy,cz,sum1,sum2,Eion
      real*8  EV,pi,EVQ,rs,Eground,Eexcited,t
      integer i,j,k,ia,n,nn,q,nx,ny,nz
      integer ii,jj,indx,indx1,npath
      real*8 w,sumall,virial,scal1,scal2,ehartr,ehfx,phfx,dv
      integer nfft3
      parameter (nfft3=32)
      character*255 full_filename

      logical value,psi_nogrid
      integer hversion,hnfft(3),hispin,hne(2)
      real*8 hunita(3,3)
      integer ind
      character*50 filename1,filename2,ion_1,ion_2

  


*     **** external functions ****
      real*8      psp_zv,psp_rc,ewald_rcut,ion_amass
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg
      integer     ewald_ncut,ewald_nshl3d
      integer     psp_lmmax,psp_lmax,psp_locp
      character*4 ion_aname,ion_atom
      external    psp_zv,psp_rc,ewald_rcut,ion_amass
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg
      external    ewald_ncut,ewald_nshl3d
      external    psp_lmmax,psp_lmax,psp_locp
      external    ion_aname,ion_atom


      real*8   control_tole,control_tolc,control_tolr,ion_rion
      external control_tole,control_tolc,control_tolr,ion_rion
      real*8   control_time_step,control_fake_mass,ion_rion_extra
      external control_time_step,control_fake_mass,ion_rion_extra
      logical  control_read,control_move,ion_init,ion_q_FixIon
      external control_read,control_move,ion_init,ion_q_FixIon
      logical  ion_q_zFixIon
      external ion_q_zFixIon
 
      integer  pack_nwave_all
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave
      integer  ion_nion,ion_natm,ion_katm,ion_nkatm
      external pack_nwave_all
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave
      external  ion_nion,ion_natm,ion_katm,ion_nkatm

      character*12 control_boundry
      external     control_boundry

      logical      pspw_SIC,pspw_SIC_relaxed,pspw_qmmm_found
      logical      pspw_HFX,pspw_HFX_relaxed
      logical      psp_semicore,control_Mulliken
      real*8       psp_rcore,psp_ncore,psp_rlocal
      external     pspw_SIC,pspw_SIC_relaxed,pspw_qmmm_found
      external     pspw_HFX,pspw_HFX_relaxed
      external     psp_semicore,control_Mulliken
      external     psp_rcore,psp_ncore,psp_rlocal
      logical      control_check_charge_multiplicity
      external     control_check_charge_multiplicity
      real*8       nwpw_timing
      external     nwpw_timing
      integer      control_np_orbital,control_mapping,control_mapping1d
      external     control_np_orbital,control_mapping,control_mapping1d

      logical  control_translation,control_rotation,control_balance
      external control_translation,control_rotation,control_balance

      logical  Dneall_m_allocate,Dneall_m_free,control_parallel_io
      external Dneall_m_allocate,Dneall_m_free,control_parallel_io

      real*8   Dneall_m_value,ewald_e,ion_ion_e,coulomb_e
      external Dneall_m_value,ewald_e,ion_ion_e,coulomb_e
      character*9 ion_amm
      external    ion_amm
      logical  pspw_charge_found
      external pspw_charge_found


*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(30,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      

      if (taskid.eq.MASTER) call current_second(cpu1)

*     ***** print out header ****
      if (taskid.eq.MASTER) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1042)
         write(luout,1043)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
      end if
      
      value = control_read(1,rtdb)
      call Parallel2d_Init(control_np_orbital())
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      mapping = control_mapping()

*     **** initialize psi_data ****
      call psi_data_init(100)

*     **** initialize D3dB data structure ****
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d

*     ***** Initialize double D3dB data structure ****
      if (control_version().eq.4) 
     >   call D3dB_Init(2,2*ngrid(1),2*ngrid(2),2*ngrid(3),mapping)


*     **** initialize lattice and packing data structure ****
      call lattice_init()
      call G_init()
      call mask_init()
      call Pack_Init()
      call Pack_npack(1,npack1)
      call Pack_npack(0,npack0)

      call D3dB_pfft_init()
      call ga_sync()

*     **** read ions ****
      value = ion_init(rtdb)
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

      if (.not.rtdb_cget(rtdb,'pspw:et:ion_a',1,ion_1))
     >   ion_1 = 'geometry'
      if (.not.rtdb_cget(rtdb,'pspw:et:ion_b',1,ion_2))
     >   ion_2 = 'geometry'
      call ion_load_extra_geom(.true., rtdb,ion_1)
      call ion_load_extra_geom(.false.,rtdb,ion_2)
      call ion_morph_extra(1,2)


*     **** allocate psp data structure and read in psedupotentials into it ****
      call psp_init()
      call psp_readall()
      if (psp_semicore(0)) call semicore_check()

*     **** initialize G,mask,ke,and coulomb data structures ****
      call ke_init()
      if (control_version().eq.3) call coulomb_init()
      if (control_version().eq.4) call coulomb2_init()
      call strfac_init()
      call phafac()
      if (control_version().eq.3) then
         call ewald_init()
         call ewald_phafac()
      end if

      if (.not.rtdb_cget(rtdb,'pspw:et:movecs_a',1,filename1))
     >   call util_file_prefix('movecs',filename1)
      if (.not.rtdb_cget(rtdb,'pspw:et:movecs_b',1,filename2))
     >   call util_file_prefix('movecs',filename2)


      call psi_get_header_filename(filename1,
     >                             hversion,hnfft,hunita,ispin,ne)
      call psi_get_header_filename(filename2,
     >                             hversion,hnfft,hunita,hispin,hne)
      

*     ***** allocate psi2,and psi1 wavefunctions ****
      mapping1d = control_mapping1d()
      call Dne_init(ispin,ne,mapping1d)
      call Dneall_neq(neq)
      nemaxq = neq(1)+neq(2)
      
      value = MA_alloc_get(mt_dcpl,npack1*(neq(1)+neq(2)),
     >                     'psi2',psi2(2),psi2(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,npack1*(neq(1)+neq(2)),
     >                     'psi1',psi1(2),psi1(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,npack1*(neq(1)+neq(2)),
     >                     'psi1f',psi1f(2),psi1f(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,npack1*(neq(1)+neq(2)),
     >                     'psi2f',psi2f(2),psi2f(1))
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)



*     *****  read psi1 and psi2 wavefunctions ****
      call psi_read_filename(filename1,ispin,ne,dcpl_mb(psi1(1)))
      call psi_read_filename(filename2,ispin,ne,dcpl_mb(psi2(1)))
      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1)+1
      n2(2) = ne(1)+ne(2)
      nemax = ne(1)+ne(2)


*     **** allocate other variables *****
      field_exist = pspw_charge_found()
      value = MA_alloc_get(mt_dbl,(2*nemax),'Sigma_ab',
     >                     Sigma_ab(2),Sigma_ab(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(2*nemax),'Cigma_ab',
     >                     Cigma_ab(2),Cigma_ab(1))
      value = value.and.Dneall_m_allocate(0,itmp)
      value = value.and.Dneall_m_allocate(0,U_ab)
      value = value.and.Dneall_m_allocate(0,V_ab)
      value = value.and.Dneall_m_allocate(0,Vt)
      value = value.and.Dneall_m_allocate(0,W_ab)

      value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d*(neq(1)+neq(2)),
     >                     'psi1_r',psi1_r(2),psi1_r(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d*(neq(1)+neq(2)),
     >                     'psi2_r',psi2_r(2),psi2_r(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d*(neq(1)+neq(2)),
     >                     'psi1f_r',psi1f_r(2),psi1f_r(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d*(neq(1)+neq(2)),
     >                     'psi2f_r',psi2f_r(2),psi2f_r(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d,'rho',rho(2),rho(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d,'vcdkfj',vc(2),vc(1))
      if (.not. value) 
     >   call errquit('pspw_et:out of heap memory',0,MA_ERR)

*     **** initialize SIC and HFX  ****
      if (.not.rtdb_put(rtdb,'pspw:HFX_relax',mt_log,1,.false.))
     >   call errquit('setting pspw:HFX_relax',0,RTDB_ERR)
      if (.not.rtdb_put(rtdb,'pspw:HFX',mt_log,1,.true.))
     >   call errquit('setting pspw:HFX',0,RTDB_ERR)
      call pspw_init_HFX(rtdb,ispin,ne)

*     **** initialize QM/MM ****
      call pspw_qmmm_init(rtdb)

*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)


*                |**************************|
******************   summary of input data  **********************
*                |**************************|

      if (taskid.eq.MASTER) then
         write(luout,1800) filename1,ion_1
         write(luout,1801) filename2,ion_2
         write(luout,1111) np
         write(luout,1117) np_i,np_j
         if (mapping.eq.1) write(luout,1112)
         if (mapping.eq.2) write(luout,1113)
         if (mapping.eq.3) write(luout,1118)
         if (control_balance()) then
           write(luout,1114)
         else
           write(luout,1116)
         end if
         if (control_parallel_io()) then
           write(luout,1119)
         else
           write(luout,1122)
         end if


         write(luout,1115)
         write(luout,1121) control_boundry(),control_version()
         if (ispin.eq.1) write(luout,1130) 'restricted'
         if (ispin.eq.2) write(luout,1130) 'unrestricted'

         call pspw_print_HFX(luout)

         write(luout,1140)
         do ia = 1,ion_nkatm()
           write(luout,1150) ia,ion_atom(ia),
     >                    psp_zv(ia),psp_lmax(ia)
           write(luout,1152) psp_lmax(ia)
           write(luout,1153) psp_locp(ia)
           write(luout,1154) psp_lmmax(ia)
           if (control_version().eq.4) write(luout,1156) psp_rlocal(ia)
           if (psp_semicore(ia)) 
     >         write(luout,1155) psp_rcore(ia),psp_ncore(ia)
           write(luout,1151) (psp_rc(i,ia),i=0,psp_lmax(ia))
         end do

         icharge = -(ne(1)+ne(ispin))
         en(1)     = ne(1)
         en(ispin) = ne(ispin)
         do ia=1,ion_nkatm()
           icharge = icharge + ion_natm(ia)*psp_zv(ia)
         end do
         write(luout,1159) icharge

         if (control_version().eq.3) then
            rs  = (3.0d0*lattice_omega()/(4.0d0*pi))**(1.0d0/3.0d0)
            EVQ = 0.5d0*ewald_mandelung()*(icharge**2)/rs
         else
            EVQ = 0.0d0
         end if


         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         write(luout,1179) ion_1
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),
     >                   (ion_rion_extra(1,K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),
     >                   (ion_rion_extra(1,K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),
     >                   (ion_rion_extra(1,K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           end if
         end do
         write(luout,1179) ion_2
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),
     >                   (ion_rion_extra(2,K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),
     >                   (ion_rion_extra(2,K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),
     >                   (ion_rion_extra(2,K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           end if
         end do
         write(luout,1179) "midpoint"
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         write(luout,1220) ne(1),neq(1),
     >                   ne(ispin),neq(ispin),' (Fourier space)'
         write(luout,1221) ne(1),neq(1),
     >                   ne(ispin),neq(ispin),' (Fourier space)'
         write(luout,1230)
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         write(luout,1231) lattice_omega()
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(0),pack_nwave(0)
         write(luout,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(1),pack_nwave(1)
         if (control_version().eq.3) then
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()
         end if

         write(luout,1300)
         call util_flush(luout)
      end if

*                |***************************|
******************     start iterations      **********************
*                |***************************|

      if (taskid.eq.MASTER) call current_second(cpu2)


*     **** calculate SVD of <psi1(ms)|psi2(ms)> ****
      call Dneall_ffm_Multiply(0,dcpl_mb(psi1(1)),
     >                           dcpl_mb(psi2(1)),npack1,
     >                           dbl_mb(itmp(1)))
      call Dneall_m_SVD(0,dbl_mb(itmp(1)),dbl_mb(U_ab(1)),
     >                    dbl_mb(Sigma_ab(1)), dbl_mb(V_ab(1)))

*     **** calculate Vt ****
      call Dneall_mm_transpose(0,dbl_mb(V_ab(1)),dbl_mb(Vt(1)))


*     **** calculate S12(ms) and Sab ****
      do ms=1,ispin
         S12(ms) = 1.0d0
         do n=n1(ms),n2(ms)
            S12(ms) = S12(ms)*dbl_mb(Sigma_ab(1)+n-1)
            dbl_mb(Cigma_ab(1)+n-1) = dacos(dbl_mb(Sigma_ab(1)+n-1))
         end do
      end do
      Sab = S12(1)*S12(ispin)

*     **** rotate psi1f=psi1*V_ab and psi2f = psi2*U_ab ****
      call Dneall_fmf_Multiply(0,dcpl_mb(psi1(1)),npack1,
     >                         dbl_mb(V_ab(1)),1.0d0,
     >                         dcpl_mb(psi1f(1)),0.0d0)
      call Dneall_fmf_Multiply(0,dcpl_mb(psi2(1)),npack1,
     >                         dbl_mb(U_ab(1)),1.0d0,
     >                         dcpl_mb(psi2f(1)),0.0d0)
 
*     **** scale rotated psi1f and psi2f by sqrt(1/Sigma(n)) ****
      do q=1,neq(1)+neq(2)
         call Dneall_qton(q,n)
         w = dsqrt(1.0d0/dbl_mb(Sigma_ab(1)+n-1))
         call Pack_c_SMul1(1,w,dcpl_mb(psi1f(1)+(q-1)*npack1))
         call Pack_c_SMul1(1,w,dcpl_mb(psi2f(1)+(q-1)*npack1))
      end do

*     **** put psi1, psi2, psi1f, and psi2f into realspace ****
      call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,dcpl_mb(psi1(1)),
     >                      dbl_mb(psi1_r(1)))
      call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,dcpl_mb(psi2(1)),
     >                      dbl_mb(psi2_r(1)))
      call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,dcpl_mb(psi1f(1)),
     >                      dbl_mb(psi1f_r(1)))
      call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,dcpl_mb(psi2f(1)),
     >                      dbl_mb(psi2f_r(1)))


*     **** one-electron parts ****
      call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >            dcpl_mb(psi1(1)),dcpl_mb(psi1(1)),dbl_mb(psi1_r(1)),
     >            H1aa)
      call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >            dcpl_mb(psi2(1)),dcpl_mb(psi2(1)),dbl_mb(psi2_r(1)),
     >            H1bb)
      call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >         dcpl_mb(psi1f(1)),dcpl_mb(psi2f(1)),dbl_mb(psi2f_r(1)),
     >         H1ab)
      H1ab = H1ab * Sab

*     **** ion-ion part ****
      if (control_version().eq.3) Eion = ewald_e()   !**** get ewald energy ****
      if (control_version().eq.4) Eion = ion_ion_e() !**** get free-space ion-ion energy ****


*     **** two-electron part ****
      H2aa = 0.0d0
      H2bb = 0.0d0
      H2ab = 0.0d0

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()
      dv = scal1*lattice_omega()

*     **** coulomb part ****

      call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi1_r(1)),dbl_mb(rho(1)))
      if (control_version().eq.4) then
         call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
         call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
         H2aa = 0.5d0*ehartr*dv
      else
         call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
         call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
         call Pack_c_pack(0,dbl_mb(rho(1)))
         H2aa = coulomb_e(dbl_mb(rho(1)))
      end if

      call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi2_r(1)),dbl_mb(rho(1)))
      if (control_version().eq.4) then
         call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
         call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
         H2bb = 0.5d0*ehartr*dv
      else
         call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
         call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
         call Pack_c_pack(0,dbl_mb(rho(1)))
         H2bb = coulomb_e(dbl_mb(rho(1)))
      end if

      call pspw_et_gen_rho12(ispin,neq,n2ft3d,
     >                     dbl_mb(psi1f_r(1)),
     >                     dbl_mb(psi2f_r(1)),
     >                     dbl_mb(rho(1)))
      if (control_version().eq.4) then
         call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
         call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
         H2ab = 0.5d0*ehartr*dv*Sab
      else
         call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
         call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
         call Pack_c_pack(0,dbl_mb(rho(1)))
         H2ab = coulomb_e(dbl_mb(rho(1)))*Sab
      end if


*     **** exchange part ****
      call pspw_energy_HFX(ispin,dbl_mb(psi1_r(1)),ehfx,phfx)
      H2aa = H2aa + ehfx

      call pspw_energy_HFX(ispin,dbl_mb(psi2_r(1)),ehfx,phfx)
      H2bb = H2bb + ehfx

      call pspw_energy_HFX2(ispin,
     >                      dbl_mb(psi1f_r(1)),
     >                      dbl_mb(psi2f_r(1)),
     >                      ehfx,phfx)
      H2ab = H2ab + ehfx*Sab


      call Parallel_Brdcst_value(0,EVQ)

      Haa = H1aa + H2aa + Eion + EVQ
      Hbb = H1bb + H2bb + Eion + EVQ
      Hab = H1ab + H2ab + Sab*(Eion+EVQ)

      Vab = (Hab-Sab*(Haa+Hbb)/2.0d0)/(1.0d0-Sab*Sab);

      
*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::

      if (taskid.eq.MASTER) call current_second(cpu3)




*                |***************************|
****************** report summary of results **********************
*                |***************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

      if (taskid.eq.MASTER) then
         write(luout,1300)
         write(luout,1410)

         write(luout,*)

         write(luout,1810)
c         write(luout,1811) Saa
c         write(luout,1812) Sbb
         write(luout,1813) Sab

         write(luout,1820)
         write(luout,1821) H1aa
         write(luout,1822) H1bb
         write(luout,1823) H1ab
         write(luout,1824) Eion
         if (EVQ.gt.0.0d0) write(luout,1825) EVQ

         write(luout,1830)
         write(luout,1831) H2aa
         write(luout,1832) H2bb
         write(luout,1833) H2ab

         write(luout,1840)
         write(luout,1841) Haa
         write(luout,1842) Hbb
         write(luout,1843) Hab

         write(luout,1850) 
         write(luout,1851) dabs(Vab),dabs(Vab)*219474.63d0,
     >                     dabs(Vab)*27.2116d0,
     >                     dabs(Vab)*27.2116d0*23.06d0


*        **** write out diagonal <psi1|H|psi2> matrix ****
c          n = ne(1)
c          nn = n*n
c          do ms=1,ispin
c             if (ms.eq.1) write(luout,1331)
c             if (ms.eq.2) write(luout,1332)
c             !*** call Gainsville matrix output ***
c             call output(dbl_mb(hml1(1)+(ms-1)*nn),
c     >                    1,ne(ms),1,ne(ms),
c     >                    n,n,1)
c
c           end do

      end if

*                |***************************|
******************  Electron Tranfer Path    **********************
*                |***************************|

      npath = 21

*     **** define |u> = |psi2f> ****
      call Dneall_fmf_Multiply(0,dcpl_mb(psi1(1)),npack1,
     >                           dbl_mb(U_ab(1)),1.0d0,
     >                           dcpl_mb(psi1f(1)),0.0d0)

      call Dneall_fmf_Multiply(0,dcpl_mb(psi2(1)),npack1,
     >                           dbl_mb(V_ab(1)),1.0d0,
     >                           dcpl_mb(psi2f(1)),0.0d0)
      do q=1,neq(1)+neq(2)
         call Dneall_qton(q,n)
         w = dbl_mb(Sigma_ab(1)+n-1)
         call Pack_c_SMul1(1,w,dcpl_mb(psi1f(1)+(q-1)*npack1))

         call Pack_cc_Sub2(1,dcpl_mb(psi1f(1)+(q-1)*npack1),
     >                       dcpl_mb(psi2f(1)+(q-1)*npack1))

         w = 1.0d0/dsin(dbl_mb(Cigma_ab(1)+n-1))
         call Pack_c_SMul1(1,w,dcpl_mb(psi2f(1)+(q-1)*npack1))

      end do
      call dcopy(2*(neq(1)+neq(2))*npack1,
     >           dcpl_mb(psi2f(1)),1,
     >           dcpl_mb(psi2(1)), 1)


*     *********************************
*     **** epath at ion_1 geometry ****
*     *********************************
      call ion_morph_extra(1,1)
      call phafac()
      if (control_version().eq.3) call ewald_phafac()
      if (control_version().eq.3) Eion = ewald_e()   !**** get ewald energy ****
      if (control_version().eq.4) Eion = ion_ion_e() !**** get free-space ion-ion energy ****

      if (taskid.eq.MASTER) then
         write(luout,1900) ion_1
         write(luout,1905) 't','Eground(t)','Eexcited(t)'
         write(luout,1906)
      end if
      do i=1,npath
         t = (i-1)/dble(npath-1)

*        *** generate y(t) and yexcited(t) ***
         call pspw_et_get_yandyexcited(ispin,neq,npack1,ne(1)+ne(2),
     >                                 dcpl_mb(psi1(1)),
     >                                 dcpl_mb(psi2(1)),
     >                                 dbl_mb(U_ab(1)),
     >                                 dbl_mb(Vt(1)),
     >                                 dbl_mb(Cigma_ab(1)),
     >                                 t,
     >                                 dcpl_mb(psi1f(1)),
     >                                 dcpl_mb(psi2f(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi1f(1)),
     >                         dbl_mb(psi1f_r(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi2f(1)),
     >                         dbl_mb(psi2f_r(1)))

*        *** calculate E(y(t)) and E(yexcited(t)) ***
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi1f(1)),dcpl_mb(psi1f(1)),
     >                   dbl_mb(psi1f_r(1)),
     >                   H1aa)
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi2f(1)),dcpl_mb(psi2f(1)),
     >                   dbl_mb(psi2f_r(1)),
     >                   H1bb)
          H2aa = 0.0d0
          H2bb = 0.0d0

*         **** coulomb part ****
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi1f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2aa = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2aa = coulomb_e(dbl_mb(rho(1)))
          end if
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi2f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2bb = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2bb = coulomb_e(dbl_mb(rho(1)))
         end if

*        **** exchange part ****
         call pspw_energy_HFX(ispin,dbl_mb(psi1f_r(1)),ehfx,phfx)
         H2aa = H2aa + ehfx
         call pspw_energy_HFX(ispin,dbl_mb(psi2f_r(1)),ehfx,phfx)
         H2bb = H2bb + ehfx

         Eground  = H1aa + H2aa + Eion + EVQ
         Eexcited = H1bb + H2bb + Eion + EVQ
         if (taskid.eq.MASTER) then
            write(luout,1910) t,Eground,Eexcited
         end if
      end do

*     *********************************
*     **** epath at ion_2 geometry ****
*     *********************************
      call ion_morph_extra(2,2)
      call phafac()
      if (control_version().eq.3) call ewald_phafac()
      if (control_version().eq.3) Eion = ewald_e()   !**** get ewald energy ****
      if (control_version().eq.4) Eion = ion_ion_e() !**** get free-space ion-ion energy ****

      if (taskid.eq.MASTER) then
         write(luout,1900) ion_2
         write(luout,1905) 't','Eground(t)','Eexcited(t)'
         write(luout,1906)
      end if
      do i=1,npath
         t = (i-1)/dble(npath-1)

*        *** generate y(t) and yexcited(t) ***
         call pspw_et_get_yandyexcited(ispin,neq,npack1,ne(1)+ne(2),
     >                                 dcpl_mb(psi1(1)),
     >                                 dcpl_mb(psi2(1)),
     >                                 dbl_mb(U_ab(1)),
     >                                 dbl_mb(Vt(1)),
     >                                 dbl_mb(Cigma_ab(1)),
     >                                 t,
     >                                 dcpl_mb(psi1f(1)),
     >                                 dcpl_mb(psi2f(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi1f(1)),
     >                         dbl_mb(psi1f_r(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi2f(1)),
     >                         dbl_mb(psi2f_r(1)))

*        *** calculate E(y(t)) and E(yexcited(t)) ***
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi1f(1)),dcpl_mb(psi1f(1)),
     >                   dbl_mb(psi1f_r(1)),
     >                   H1aa)
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi2f(1)),dcpl_mb(psi2f(1)),
     >                   dbl_mb(psi2f_r(1)),
     >                   H1bb)
          H2aa = 0.0d0
          H2bb = 0.0d0

*         **** coulomb part ****
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi1f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2aa = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2aa = coulomb_e(dbl_mb(rho(1)))
          end if
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi2f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2bb = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2bb = coulomb_e(dbl_mb(rho(1)))
         end if

*        **** exchange part ****
         call pspw_energy_HFX(ispin,dbl_mb(psi1f_r(1)),ehfx,phfx)
         H2aa = H2aa + ehfx
         call pspw_energy_HFX(ispin,dbl_mb(psi2f_r(1)),ehfx,phfx)
         H2bb = H2bb + ehfx

         Eground  = H1aa + H2aa + Eion + EVQ
         Eexcited = H1bb + H2bb + Eion + EVQ
         if (taskid.eq.MASTER) then
            write(luout,1910) t,Eground,Eexcited
         end if
      end do

*     ************************************
*     **** epath at midpoint geometry ****
*     ************************************
      call ion_morph_extra(1,2)
      call phafac()
      if (control_version().eq.3) call ewald_phafac()
      if (control_version().eq.3) Eion = ewald_e()   !**** get ewald energy ****
      if (control_version().eq.4) Eion = ion_ion_e() !**** get free-space ion-ion energy ****

      if (taskid.eq.MASTER) then
         write(luout,1900) "midpoint"
         write(luout,1905) 't','Eground(t)','Eexcited(t)'
         write(luout,1906)
      end if
      do i=1,npath
         t = (i-1)/dble(npath-1)

*        *** generate y(t) and yexcited(t) ***
         call pspw_et_get_yandyexcited(ispin,neq,npack1,ne(1)+ne(2),
     >                                 dcpl_mb(psi1(1)),
     >                                 dcpl_mb(psi2(1)),
     >                                 dbl_mb(U_ab(1)),
     >                                 dbl_mb(Vt(1)),
     >                                 dbl_mb(Cigma_ab(1)),
     >                                 t,
     >                                 dcpl_mb(psi1f(1)),
     >                                 dcpl_mb(psi2f(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi1f(1)),
     >                         dbl_mb(psi1f_r(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi2f(1)),
     >                         dbl_mb(psi2f_r(1)))

*        *** calculate E(y(t)) and E(yexcited(t)) ***
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi1f(1)),dcpl_mb(psi1f(1)),
     >                   dbl_mb(psi1f_r(1)),
     >                   H1aa)
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi2f(1)),dcpl_mb(psi2f(1)),
     >                   dbl_mb(psi2f_r(1)),
     >                   H1bb)
          H2aa = 0.0d0
          H2bb = 0.0d0

*         **** coulomb part ****
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi1f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2aa = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2aa = coulomb_e(dbl_mb(rho(1)))
          end if
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi2f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2bb = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2bb = coulomb_e(dbl_mb(rho(1)))
         end if

*        **** exchange part ****
         call pspw_energy_HFX(ispin,dbl_mb(psi1f_r(1)),ehfx,phfx)
         H2aa = H2aa + ehfx
         call pspw_energy_HFX(ispin,dbl_mb(psi2f_r(1)),ehfx,phfx)
         H2bb = H2bb + ehfx

         Eground  = H1aa + H2aa + Eion + EVQ
         Eexcited = H1bb + H2bb + Eion + EVQ
         if (taskid.eq.MASTER) then
            write(luout,1910) t,Eground,Eexcited
         end if
      end do

*     ***********************************
*     **** epath at morph geometries ****
*     ***********************************
      if (taskid.eq.MASTER) then
         write(luout,1900) "geometry morphing"
         write(luout,1905) 't','Eground(t)','Eexcited(t)'
         write(luout,1906)
      end if
      do i=1,npath
         t = (i-1)/dble(npath-1)

         call ion_t_morph_extra(t,1,2)
         call phafac()
         if (control_version().eq.3) call ewald_phafac()
         if (control_version().eq.3) Eion = ewald_e()   !**** get ewald energy ****
         if (control_version().eq.4) Eion = ion_ion_e() !**** get free-space ion-ion energy ****

*        *** generate y(t) and yexcited(t) ***
         call pspw_et_get_yandyexcited(ispin,neq,npack1,ne(1)+ne(2),
     >                                 dcpl_mb(psi1(1)),
     >                                 dcpl_mb(psi2(1)),
     >                                 dbl_mb(U_ab(1)),
     >                                 dbl_mb(Vt(1)),
     >                                 dbl_mb(Cigma_ab(1)),
     >                                 t,
     >                                 dcpl_mb(psi1f(1)),
     >                                 dcpl_mb(psi2f(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi1f(1)),
     >                         dbl_mb(psi1f_r(1)))
         call pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,
     >                         dcpl_mb(psi2f(1)),
     >                         dbl_mb(psi2f_r(1)))

*        *** calculate E(y(t)) and E(yexcited(t)) ***
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi1f(1)),dcpl_mb(psi1f(1)),
     >                   dbl_mb(psi1f_r(1)),
     >                   H1aa)
         call pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                   dcpl_mb(psi2f(1)),dcpl_mb(psi2f(1)),
     >                   dbl_mb(psi2f_r(1)),
     >                   H1bb)
          H2aa = 0.0d0
          H2bb = 0.0d0

*         **** coulomb part ****
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi1f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2aa = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2aa = coulomb_e(dbl_mb(rho(1)))
          end if
          call pspw_et_gen_rho(ispin,neq,n2ft3d,
     >                     dbl_mb(psi2f_r(1)),dbl_mb(rho(1)))
          if (control_version().eq.4) then
             call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))
             call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
             H2bb = 0.5d0*ehartr*dv
          else
            call D3dB_r_SMul1(1,scal1,dbl_mb(rho(1)))
            call D3dB_rc_fft3f(1,dbl_mb(rho(1)))
            call Pack_c_pack(0,dbl_mb(rho(1)))
            H2bb = coulomb_e(dbl_mb(rho(1)))
         end if

*        **** exchange part ****
         call pspw_energy_HFX(ispin,dbl_mb(psi1f_r(1)),ehfx,phfx)
         H2aa = H2aa + ehfx
         call pspw_energy_HFX(ispin,dbl_mb(psi2f_r(1)),ehfx,phfx)
         H2bb = H2bb + ehfx

         Eground  = H1aa + H2aa + Eion + EVQ
         Eexcited = H1bb + H2bb + Eion + EVQ
         if (taskid.eq.MASTER) then
            write(luout,1910) t,Eground,Eexcited
         end if
      end do



      call Dneall_ffm_Multiply(0,dcpl_mb(psi1f(1)),
     >                           dcpl_mb(psi2f(1)),npack1,
     >                           dbl_mb(itmp(1)))

      write(*,*) "<psi1f|psi2f>="
      do ms=1,ispin
         do nn=1,ne(ms)
            nx = (nn-1)*ne(ms)+(ms-1)*ne(1)*ne(1)
            write(*,*) (dbl_mb(itmp(1)+nx+n-1),n=1,ne(ms))
         end do
      end do


*                |***************************|
******************         Prologue          **********************
*                |***************************|



*     **** deallocate heap memory ****
      if (control_version().eq.3) call ewald_end()
      call strfac_end()
      if (control_version().eq.3) call coulomb_end()
      if (control_version().eq.4) call coulomb2_end()
      call ke_end()
      call mask_end()
      call Pack_end()
      call G_end()
      call ion_end()
      call psp_end()
      call pspw_end_HFX()
      call ion_end_FixIon()
      call pspw_qmmm_end()
      call ion_delete_extra_geom()

      value =           Dneall_m_free(itmp)
      value = value.and.Dneall_m_free(U_ab)
      value = value.and.Dneall_m_free(V_ab)
      value = value.and.Dneall_m_free(Vt)
      value = value.and.Dneall_m_free(W_ab)
      value = value.and.MA_free_heap(Cigma_ab(2))
      value = value.and.MA_free_heap(Sigma_ab(2))
      value = value.and.MA_free_heap(psi1(2))
      value = value.and.MA_free_heap(psi2(2))
      value = value.and.MA_free_heap(psi1f(2))
      value = value.and.MA_free_heap(psi2f(2))
      value = value.and.MA_free_heap(psi1_r(2))
      value = value.and.MA_free_heap(psi2_r(2))
      value = value.and.MA_free_heap(psi1f_r(2))
      value = value.and.MA_free_heap(psi2f_r(2))
      value = value.and.MA_free_heap(rho(2))
      value = value.and.MA_free_heap(vc(2))
      call D3dB_pfft_end()
      call D3dB_end(1)
      if (control_version().eq.4) call D3dB_end(2)
      call Dne_end()
      call psi_data_end()

*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (taskid.eq.MASTER) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         write(luout,*)
         write(luout,*) '-----------------'
         write(luout,*) 'cputime in seconds'
         write(luout,*) 'prologue    : ',T1
         write(luout,*) 'main loop   : ',T2
         write(luout,*) 'epilogue    : ',T3
         write(luout,*) 'total       : ',T4
         write(luout,*)
         call nwpw_timing_print_final(.true.,1)
         CALL nwpw_MESSAGE(4)
      end if 


      call Parallel2d_Finalize()
      call Parallel_Finalize()
      pspw_et = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*        Electron-Transfer Calculation (ET)        *')
 1030 FORMAT(10X,'*     [     Algorithm of Farazdel et al.   ]       *')
 1035 FORMAT(10x,'*     [ NorthWest Chemistry implementation ]       *')
 1040 FORMAT(10X,'*            version #1.00   09/23/2012            *')
 1041 FORMAT(10X,'*    This code was developed by Eric J. Bylaska,   *')
 1042 FORMAT(10X,'*    and Duo Song                                  *')
 1043 FORMAT(10X,'*                                                  *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'=============== PSPW ET input data =================')
 1111 FORMAT(/' number of processors used:',I10)
 1112 FORMAT( ' parallel mapping         :      1d slab')
 1113 FORMAT( ' parallel mapping         :   2d hilbert')
 1114 FORMAT( ' parallel mapping         :     balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1117 FORMAT( ' processor grid           :',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         :    2d hcurve')
 1119 FORMAT( ' parallel io              :        on')
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1122 FORMAT( ' parallel io              :       off')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I1)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i2)
 1153 FORMAT(12X,' local potential used           : ',i2)
 1154 FORMAT(12X,' number of non-local projections: ',i2)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1159 FORMAT(/' total charge=',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A2,':',I5))
 1179 FORMAT(/' position of ions: ',A)
 1180 FORMAT(/' position of ions:')
 1190 FORMAT(5X, I4, A5, ' (',3F11.5,' ) - atomic mass= ',F7.3,' ',A)
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F6.3,' - fixed ',A)
 1193 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - z fixed')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1219 FORMAT(/' number of electrons: spin up=',F6.2, 16x,
     >                               '  down=',F6.2,A)
 1220 FORMAT(/' number of electrons: spin up=',I6,
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1221 FORMAT( ' number of orbitals : spin up=',I6,  
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,' volume : ',F12.1)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1250 FORMAT(5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters:')
 1271 FORMAT(5x, ' translation constrained')
 1272 FORMAT(5x, ' rotation constrained')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (electron)',E12.3,' (ion)')
 1300 FORMAT(//)
 1305 FORMAT(10X,'================ iteration =========================')
 1310 FORMAT(I8,E20.10,3E15.5)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1331 FORMAT(/' Elements of Hamiltonian matrix (up/restricted)')
 1332 FORMAT(/' Elements of Hamiltonian matrix (down)')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1341 FORMAT(I3,2I3,' H=',E16.6)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(//' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1431 FORMAT(/' QM Energies')
 1432 FORMAT( '------------')
 1433 FORMAT( ' total  QM energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1455 FORMAT( ' SIC-hartree energy  :',E19.10,' (',E15.5,'/electron)')
 1456 FORMAT( ' SIC-exc-corr energy :',E19.10,' (',E15.5,'/electron)')
 1457 FORMAT( ' HF exchange energy  :',E19.10,' (',E15.5,'/electron)')
 1458 FORMAT( ' DFT+U     energy    :',E19.10,' (',E15.5,'/electron)')
 1459 FORMAT( ' Metadynamics energy :',E19.10,' (',E15.5,'/ion)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1499 FORMAT( ' K.S. SIC-hartree energy  :',E19.10,
     >        ' (',E15.5,'/electron)')
 1500 FORMAT(/' orbital energies:')
 1501 FORMAT( ' K.S. SIC-exc-corr energy :',E19.10,
     >        ' (',E15.5,'/electron)')
 1502 FORMAT( ' K.S. HFX energy     :',E19.10,
     >        ' (',E15.5,'/electron)')
 1503 FORMAT( ' K.S. DFT+U energy   :',E19.10,' (',E15.5,'/electron)')
 1504 FORMAT( ' K.S. Metadynamics energy :',E19.10,' (',E15.5,'/ion)')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1511 FORMAT(2(E18.7,' (',F8.3,'eV) occ=',F5.3))
 1600 FORMAT(/' Total PSPW energy   :',E19.10)

 1700 FORMAT(/' QM/MM-pol-vib/CAV Energies')
 1701 FORMAT( ' --------------------------')
 1702 FORMAT( ' LJ energy              :',E19.10)
 1703 FORMAT( ' Residual Coulomb energy:',E19.10)
 1704 FORMAT( ' MM Vibration energy    :',E19.10)
 1705 FORMAT( ' MM Vibration energy    :',E19.10)
 1706 FORMAT( ' (QM+MM)/Cavity energy  :',E19.10)
                        
 1800 format( ' Reactant  psi filename: ',A,'  geometry: ',A)
 1801 format( ' Product   psi filename: ',A,'  geometry: ',A)
 1810 format(/' Electron Overlaps:')
 1811 format( '    Reactants/Reactant overlap          S(RR) : ',E19.10)
 1812 format( '    Reactants/Reactant overlap          S(PP) : ',E19.10)
 1813 format( '    Reactants/Products overlap          S(RP) : ',E19.10)
 1820 format(/' One-electron reactants/product interation energies:')
 1821 format( '    Electron energy of reactant         H1(RR): ',E19.10)
 1822 format( '    Electron energy of product          H1(PP): ',E19.10)
 1823 format( '    Electron energy of reactant/product H1(RP): ',E19.10)
 1824 format( '    Ion-Ion energy                      Eion  : ',E19.10)
 1825 format( '    Charge correction    0.5*q**2*mandelung/rs: ',E19.10)
 1830 format(/' Two-electron reactants/product interation energies:')
 1831 format( '    Electron energy of reactant         H2(RR): ',E19.10)
 1832 format( '    Electron energy of product          H2(PP): ',E19.10)
 1833 format( '    Electron energy of reactant/product H2(RP): ',E19.10)
 1840 format(/' Total reactants/product interation energies:')
 1841 format( '    Electron energy of reactant         H(RR) : ',E19.10)
 1842 format( '    Electron energy of product          H(PP) : ',E19.10)
 1843 format( '    Electron energy of reactant/product H(RP) : ',E19.10)
 1850 format(/' Electron Transfer Coupling:')
 1851 format( '    reactant/product coupling energy  |V(RP)| : ',E19.10,
     >        /,48x,F19.3, ' cm-1',
     >        /,48x,F19.3, ' eV',
     >        /,48x,F19.3, ' kcal/mol')
 1900 format(//' Electron Transfer Geodesic Path at geometry: ',A)
 1905 format(/A12,2A19)
 1906 format('    ----------------------------------------------')
 1910 format(F12.6,2E19.10)


!Electronic energy of reactants     H(RR)      -5.3402392824
!Electronic energy of products      H(PP)      -5.3402392824
!
!Reactants/Products overlap         S(RP)      -0.0006033839
!
!Reactants/Products interaction energy:
!-------------------------------------
!One-electron contribution         H1(RP)       0.0040314092
!
!Beginning calculation of 2e contribution
!Two-electron integral screening (tol2e) : 6.03E-11
!
!Two-electron contribution         H2(RP)      -0.0007837138
!Total interaction energy           H(RP)       0.0032476955
!
!Electron Transfer Coupling Energy |V(RP)|      0.0000254810
!                                                      5.592 cm-1
!                                                   0.000693 eV
!                                                      0.016 kcal/mol

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(luout,9010) ierr
      call Parallel2d_Finalize()
      call Parallel_Finalize()

      pspw_et = value
      return
      END

*     ****************************************************
*     *                                                  *
*     *               pspw_et_gen_psir                   *
*     *                                                  *
*     ****************************************************
      subroutine pspw_et_gen_psir(ispin,neq,npack1,n2ft3d,psi,psir)
      implicit none
      integer ispin,neq(2),npack1,n2ft3d
      complex*16 psi(npack1,*)
      real*8     psir(n2ft3d,*)

*     **** local variables ****
      integer n,nemaxq,nfft3d

      nemaxq = neq(1)+neq(2)
      call D3dB_nfft3d(1,nfft3d)

      call dcopy(nemaxq*n2ft3d,0.0d0,0,psir,1)
      do n=1,nemaxq
         call Pack_c_Copy(1,psi(1,n),psir(1,n))
      end do
      call Grsm_gh_fftb(nfft3d,nemaxq,psir)
      call Grsm_h_Zero_Ends(nfft3d,nemaxq,psir)

      return
      end

*     ****************************************************
*     *                                                  *
*     *               pspw_et_gen_rho                    *
*     *                                                  *
*     ****************************************************
      subroutine pspw_et_gen_rho(ispin,neq,n2ft3d,psi_r,rho)
      implicit none
      integer ispin,neq(2),n2ft3d
      real*8  psi_r(n2ft3d,*)
      real*8  rho(*)

*     **** local variables ****
      integer i,n,nemaxq
      real*8  scal2

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega

      nemaxq = neq(1)+neq(2)
      scal2 = 1.0d0/lattice_omega()

      call dcopy(n2ft3d,0.0d0,0,rho,1)
      do n=1,nemaxq
         do i=1,n2ft3d
            rho(i) = rho(i) + scal2*(psi_r(i,n)**2)
         end do
      end do
      call D3dB_r_Zero_Ends(1,rho)
      call D1dB_Vector_SumAll(n2ft3d,rho)
      if (ispin.eq.1) call dscal(n2ft3d,2.0d0,rho,1)

      return
      end

*     ****************************************************
*     *                                                  *
*     *               pspw_et_gen_rho12                  *
*     *                                                  *
*     ****************************************************
      subroutine pspw_et_gen_rho12(ispin,neq,n2ft3d,psi1_r,psi2_r,rho)
      implicit none
      integer ispin,neq(2),n2ft3d
      real*8  psi1_r(n2ft3d,*)
      real*8  psi2_r(n2ft3d,*)
      real*8  rho(*)

*     **** local variables ****
      integer i,n,nemaxq
      real*8  scal2

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega

      nemaxq = neq(1)+neq(2)
      scal2 = 1.0d0/lattice_omega()

      call dcopy(n2ft3d,0.0d0,0,rho,1)
      do n=1,nemaxq
         do i=1,n2ft3d
            rho(i) = rho(i) + scal2*(psi1_r(i,n)*psi2_r(i,n))
         end do
      end do
      call D3dB_r_Zero_Ends(1,rho)
      call D1dB_Vector_SumAll(n2ft3d,rho)
      if (ispin.eq.1) call dscal(n2ft3d,2.0d0,rho,1)

      return
      end


*     ****************************************************
*     *                                                  *
*     *               pspw_et_H1                         *
*     *                                                  *
*     ****************************************************
      subroutine pspw_et_H1(ispin,neq,npack1,n2ft3d,
     >                        psi1,psi2,psi2_r,
     >                        H1)
      implicit none
      integer ispin,neq(2),npack1,n2ft3d
      complex*16 psi1(npack1,*)
      complex*16 psi2(npack1,*)
      real*8     psi2_r(n2ft3d,*)
      real*8     H1

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      logical value,aperiodic,field_exist
      integer q,n,m,ms,nfft3d,nemaxq,npack0,n1q(2),n2q(2)
      integer Hpsi2(2),vlr_l(2),r_grid(2),v_field(2),vl(2)
      real*8 tmp1(2),tmp2(2),sum1,sum2
      
*     **** external functions ****
      logical  pspw_charge_found
      external pspw_charge_found
      integer  control_version
      external control_version

      aperiodic   = (control_version().eq.4)
      field_exist = pspw_charge_found()
      nemaxq = neq(1)+neq(2)

      call Pack_npack(0,npack0)
      call D3dB_nfft3d(1,nfft3d)

*     **** allocate memory ****
      value = MA_push_get(mt_dcpl,(nemaxq*npack1),
     >                    'Hpsi2',Hpsi2(2),Hpsi2(1))
      if (aperiodic) then
       value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'vlr_l',vlr_l(2),vlr_l(1))
      end if
      if (field_exist.or.aperiodic) then
         value = value.and.
     >            MA_push_get(mt_dbl,(3*n2ft3d),'r_grid',
     >                        r_grid(2),r_grid(1))
         value = value.and.
     >           MA_push_get(mt_dbl,(n2ft3d),'v_field',
     >                       v_field(2),v_field(1))
      end if
      value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'vloc',vl(2),vl(1))
      if (.not. value)
     >   call errquit('pspw_et_sub1:out of stack',0,MA_ERR)


*     **** generate r_grid ****
      if (aperiodic.or.field_exist)
     >   call lattice_r_grid(dbl_mb(r_grid(1)))

*     **** generate local pseudopotential  ****
      call v_local(dcpl_mb(vl(1)),.false.,tmp1,tmp2)

*     *** long-range psp for charge systems ***
      if (control_version().eq.4) then
         call v_lr_local(dbl_mb(r_grid(1)),dbl_mb(vlr_l(1)))
      end if

*     ***** generate other real-space fields ****
      if (field_exist) then
         call dcopy(n2ft3d,0.0d0,0,dbl_mb(v_field(1)),1)
         call pspw_charge_Generate_V(n2ft3d,
     >                               dbl_mb(r_grid(1)),
     >                               dbl_mb(v_field(1)))
      end if

      
*     **** get Hpsi2 ****
      call dcopy(2*nemaxq*npack1,0.0d0,0,dcpl_mb(Hpsi2(1)),1)
      if (aperiodic) then
         call psi_H1v4(ispin,neq,psi2,psi2_r,
     >             dcpl_mb(vl(1)),dbl_mb(vlr_l(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dcpl_mb(Hpsi2(1)))
      else
         call psi_H1(ispin,neq,psi2,psi2_r,
     >             dcpl_mb(vl(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dcpl_mb(Hpsi2(1)))
      end if

*     **** one-electron part ****
      n1q(1) = 1
      n2q(1) = neq(1)
      n1q(2) = neq(1)+1
      n2q(2) = neq(1)+neq(2)
      H1=0.0d0
      do ms=1,ispin
         if (neq(ms).gt.0) then
            do q=n1q(ms),n2q(ms)
               call Pack_cc_idot(1,psi1(1,q),
     >                           dcpl_mb(Hpsi2(1)+(q-1)*npack1),sum1)
               H1 = H1 - sum1
            end do
         end if
      end do
      call Parallel_SumAll(H1)
      if (ispin.eq.1) H1 = H1 + H1


*     **** deallocate memory ****
      value = MA_pop_stack(vl(2))
      if (field_exist.or.aperiodic) then
         value = value.and.MA_pop_stack(v_field(2))
         value = value.and.MA_pop_stack(r_grid(2))
      end if
      if (aperiodic) then
         value = value.and.MA_pop_stack(vlr_l(2))
      end if
      value = value.and.MA_pop_stack(Hpsi2(2))
      if (.not.value)
     >   call errquit('pspw_et_H1:pop stack',0,MA_ERR)
 
      return
      end

*     ****************************************************
*     *                                                  *
*     *               pspw_et_get_yandyexcited           *
*     *                                                  *
*     ****************************************************
      subroutine pspw_et_get_yandyexcited(ispin,neq,npack1,nemax,
     >                                    a,u,Uab,Vt,S,
     >                                    t,y,yexcited)
      implicit none
      integer ispin,neq(2),npack1,nemax
      complex*16 a(*)
      complex*16 u(*)
      real*8     Uab(*),Vt(*)
      real*8     S(*)
      real*8     t
      complex*16 y(*)
      complex*16 yexcited(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      logical    value
      integer    tmp1(2),tmp2(2),tmp3(2)
      integer    tmpC(2),tmpS(2)

*     **** external functions ****
      logical  Dneall_m_push_get,Dneall_m_pop_stack
      external Dneall_m_push_get,Dneall_m_pop_stack

*     **** allocate tmp space ****
      value =           Dneall_m_push_get(0,tmp1)
      value = value.and.Dneall_m_push_get(0,tmp2)
      value = value.and.Dneall_m_push_get(0,tmp3)
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpC',tmpC(2),tmpC(1))
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpS',tmpS(2),tmpS(1))
      if (.not.value) 
     > call errquit('pspw_et_get_yandyexcited:out of stack',0,MA_ERR)

      call Dneall_mm_SCtimesVtrans(0,t,S,Vt,
     >                             dbl_mb(tmp1(1)),
     >                             dbl_mb(tmp3(1)),
     >                             dbl_mb(tmpC(1)),
     >                             dbl_mb(tmpS(1)))


*     **** generate y(t) ****
      call Dneall_mmm_Multiply(0,Uab,dbl_mb(tmp1(1)),1.0d0,
     >                               dbl_mb(tmp2(1)),0.0d0)
      call Dneall_fmf_Multiply(0,a,npack1,
     >                          dbl_mb(tmp2(1)),1.0d0,
     >                          y,0.0d0)  
      call Dneall_fmf_Multiply(0,u,npack1,
     >                          dbl_mb(tmp3(1)),1.0d0,
     >                          y,1.0d0)

*     **** generate yexcited(t) ****
      call Dneall_mmm_Multiply(0,Uab,dbl_mb(tmp3(1)),1.0d0,
     >                               dbl_mb(tmp2(1)),0.0d0)
      call Dneall_fmf_Multiply(0,a,npack1,
     >                          dbl_mb(tmp2(1)),-1.0d0,
     >                          yexcited,0.0d0)  
      call Dneall_fmf_Multiply(0,u,npack1,
     >                          dbl_mb(tmp1(1)),1.0d0,
     >                          yexcited,1.0d0)

*     **** deallocate tmp space ****
      value = MA_pop_stack(tmpS(2))
      value = value.and.MA_pop_stack(tmpC(2))
      value = value.and.Dneall_m_pop_stack(tmp3)
      value = value.and.Dneall_m_pop_stack(tmp2)
      value = value.and.Dneall_m_pop_stack(tmp1)
      if (.not.value) 
     > call errquit('pspw_et_get_yandyexcited:popping stack',0,MA_ERR)

      return
      end 

      logical function pre_ang(lbnd,mbnd,nbmd,lang,mang,nang)
c
c $Id: pre_angl.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer mbnd,mang
      integer nbnd,nang
      integer lbnd(mbnd,2),lang(mang,3)
c
c     determine the list of angles
c     ----------------------------
c
      nang=0
      do 1 i=1,nbnd-1
      do 2 j=i+1,nbnd
      if(lbnd(i,1).eq.lbnd(j,1)) then
      nang=nang+1
      if(nang.gt.mang) goto 9999
      lang(nang,1)=lbnd(i,2)
      lang(nang,2)=lbnd(i,1)
      lang(nang,3)=lbnd(j,2)
      else
      if(lbnd(i,2).eq.lbnd(j,1)) then
      nang=nang+1
      if(nang.gt.mang) goto 9999
      lang(nang,1)=lbnd(i,1)
      lang(nang,2)=lbnd(i,2)
      lang(nang,3)=lbnd(j,2)
      else
      if(lbnd(i,1).eq.lbnd(j,2)) then
      nang=nang+1
      if(nang.gt.mang) goto 9999
      lang(nang,1)=lbnd(i,2)
      lang(nang,2)=lbnd(i,1)
      lang(nang,3)=lbnd(j,1)
      else
      if(lbnd(i,2).eq.lbnd(j,2)) then
      nang=nang+1
      if(nang.gt.mang) goto 9999
      lang(nang,1)=lbnd(i,1)
      lang(nang,2)=lbnd(i,2)
      lang(nang,3)=lbnd(j,1)
      endif
      endif
      endif
      endif
    2 continue
    1 continue
c
      pre_angl=.true.
      return
c
 9999 continue
      pre_angl=.false.
      return
      end

      subroutine put_1pwdm_hp(d_1pdm,k_1pdm_offset,d_hp,k_hp_offset)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
c
      integer d_1pdm,k_1pdm_offset
      integer d_hp,k_hp_offset
      integer h1b,p2b
      integer h1,p2
      integer size
      integer l_r1,k_r1,l_r1_sort,k_r1_sort
      integer i
c
      integer next
      integer count
      integer nxtask
      integer nprocs
      external nxtask
c
      nprocs=ga_nnodes()
      count=0
      next=nxtask(nprocs,1)
c
      do h1b = 1,noab
      do p2b = noab+1,noab+nvab
         if (next.eq.count) then
c
         if (int_mb(k_spin+h1b-1) .eq. int_mb(k_spin+p2b-1)) then 
         if ((.not.restricted).or.(int_mb(k_spin+h1b-1)
     1      +int_mb(k_spin+p2b-1).ne.4)) then
         if (ieor(int_mb(k_sym+h1b-1),int_mb(k_sym+p2b-1))
     1      .eq.irrep_e) then
            size = int_mb(k_range+h1b-1) * int_mb(k_range+p2b-1)
            if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1        call errquit('tce_print_hh: MA problem',0,MA_ERR)
c
            if (.not.ma_push_get(mt_dbl,size,'r1_sort',l_r1_sort,
     1         k_r1_sort))
     1         call errquit('tce_print_hh: MA problem',0,MA_ERR)

            call get_hash_block(d_hp,dbl_mb(k_r1),size,
     1        int_mb(k_hp_offset),(p2b-noab-1)+(h1b-1)*nvab)
            call put_hash_block(d_1pdm,dbl_mb(k_r1),size,
     1        int_mb(k_1pdm_offset),(p2b-1)+(h1b-1)*(noab+nvab))
c
            i=0
            do h1=1,int_mb(k_range+h1b-1)
            do p2=1,int_mb(k_range+p2b-1)
               dbl_mb(k_r1_sort+(h1-1)+(p2-1)*int_mb(k_range+h1b-1))=
     1         dbl_mb(k_r1+i)
               i=i+1
            enddo
            enddo
            call put_hash_block(d_1pdm,dbl_mb(k_r1_sort),size,
     1        int_mb(k_1pdm_offset),(h1b-1)+(p2b-1)*(noab+nvab))
c
            if (.not.ma_pop_stack(l_r1_sort))
     1      call errquit('put_1pdm_hh: MA problem',1,MA_ERR)
c
            if (.not.ma_pop_stack(l_r1))
     1      call errquit('put_1pdm_hh: MA problem',1,MA_ERR)
c
         endif
         endif
         endif
         next=nxtask(nprocs,1)
         endif
         count=count+1
      enddo
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c
      end
c $Id: put_1pwdm_hp.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b SLASQ1 computes the singular values of a real square bidiagonal matrix. Used by sbdsqr.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SLASQ1 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/slasq1.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/slasq1.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/slasq1.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SLASQ1( N, D, E, WORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, N
*       ..
*       .. Array Arguments ..
*       REAL               D( * ), E( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SLASQ1 computes the singular values of a real N-by-N bidiagonal
*> matrix with diagonal D and off-diagonal E. The singular values
*> are computed to high relative accuracy, in the absence of
*> denormalization, underflow and overflow. The algorithm was first
*> presented in
*>
*> "Accurate singular values and differential qd algorithms" by K. V.
*> Fernando and B. N. Parlett, Numer. Math., Vol-67, No. 2, pp. 191-230,
*> 1994,
*>
*> and the present implementation is described in "An implementation of
*> the dqds Algorithm (Positive Case)", LAPACK Working Note.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>        The number of rows and columns in the matrix. N >= 0.
*> \endverbatim
*>
*> \param[in,out] D
*> \verbatim
*>          D is REAL array, dimension (N)
*>        On entry, D contains the diagonal elements of the
*>        bidiagonal matrix whose SVD is desired. On normal exit,
*>        D contains the singular values in decreasing order.
*> \endverbatim
*>
*> \param[in,out] E
*> \verbatim
*>          E is REAL array, dimension (N)
*>        On entry, elements E(1:N-1) contain the off-diagonal elements
*>        of the bidiagonal matrix whose SVD is desired.
*>        On exit, E is overwritten.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (4*N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>        = 0: successful exit
*>        < 0: if INFO = -i, the i-th argument had an illegal value
*>        > 0: the algorithm failed
*>             = 1, a split was marked by a positive value in E
*>             = 2, current block of Z not diagonalized after 100*N
*>                  iterations (in inner while loop)  On exit D and E
*>                  represent a matrix with the same singular values
*>                  which the calling subroutine could use to finish the
*>                  computation, or even feed back into SLASQ1
*>             = 3, termination criterion of outer while loop not met 
*>                  (program created more than N unreduced blocks)
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERcomputational
*
*  =====================================================================
      SUBROUTINE SLASQ1( N, D, E, WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      REAL               D( * ), E( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IINFO
      REAL               EPS, SCALE, SAFMIN, SIGMN, SIGMX
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SLAS2, SLASCL, SLASQ2, SLASRT, XERBLA
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -2
         CALL XERBLA( 'SLASQ1', -INFO )
         RETURN
      ELSE IF( N.EQ.0 ) THEN
         RETURN
      ELSE IF( N.EQ.1 ) THEN
         D( 1 ) = ABS( D( 1 ) )
         RETURN
      ELSE IF( N.EQ.2 ) THEN
         CALL SLAS2( D( 1 ), E( 1 ), D( 2 ), SIGMN, SIGMX )
         D( 1 ) = SIGMX
         D( 2 ) = SIGMN
         RETURN
      END IF
*
*     Estimate the largest singular value.
*
      SIGMX = ZERO
      DO 10 I = 1, N - 1
         D( I ) = ABS( D( I ) )
         SIGMX = MAX( SIGMX, ABS( E( I ) ) )
   10 CONTINUE
      D( N ) = ABS( D( N ) )
*
*     Early return if SIGMX is zero (matrix is already diagonal).
*
      IF( SIGMX.EQ.ZERO ) THEN
         CALL SLASRT( 'D', N, D, IINFO )
         RETURN
      END IF
*
      DO 20 I = 1, N
         SIGMX = MAX( SIGMX, D( I ) )
   20 CONTINUE
*
*     Copy D and E into WORK (in the Z format) and scale (squaring the
*     input data makes scaling by a power of the radix pointless).
*
      EPS = SLAMCH( 'Precision' )
      SAFMIN = SLAMCH( 'Safe minimum' )
      SCALE = SQRT( EPS / SAFMIN )
      CALL SCOPY( N, D, 1, WORK( 1 ), 2 )
      CALL SCOPY( N-1, E, 1, WORK( 2 ), 2 )
      CALL SLASCL( 'G', 0, 0, SIGMX, SCALE, 2*N-1, 1, WORK, 2*N-1,
     $             IINFO )
*         
*     Compute the q's and e's.
*
      DO 30 I = 1, 2*N - 1
         WORK( I ) = WORK( I )**2
   30 CONTINUE
      WORK( 2*N ) = ZERO
*
      CALL SLASQ2( N, WORK, INFO )
*
      IF( INFO.EQ.0 ) THEN
         DO 40 I = 1, N
            D( I ) = SQRT( WORK( I ) )
   40    CONTINUE
         CALL SLASCL( 'G', 0, 0, SCALE, SIGMX, N, 1, D, N, IINFO )
      ELSE IF( INFO.EQ.2 ) THEN
*
*     Maximum number of iterations exceeded.  Move data from WORK
*     into D and E so the calling subroutine can try to finish
*
         DO I = 1, N
            D( I ) = SQRT( WORK( 2*I-1 ) )
            E( I ) = SQRT( WORK( 2*I ) )
         END DO
         CALL SLASCL( 'G', 0, 0, SCALE, SIGMX, N, 1, D, N, IINFO )
         CALL SLASCL( 'G', 0, 0, SCALE, SIGMX, N, 1, E, N, IINFO )
      END IF
*
      RETURN
*
*     End of SLASQ1
*
      END
c $Id: slasq1.f 24343 2013-06-22 05:35:15Z d3y133 $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     memory_defaults -- Set default memory partition based on platform
C     and other factors
C
C REVISION
C     $Id: memory_def.F 22702 2012-08-14 17:20:54Z d3y133 $
C
C SYNOPSIS
      Subroutine Memory_defaults(Total, TSource, Heap, HSource,
     $   Stack, SSource, Global, GSource)
      Implicit NONE
#include "errquit.fh"
#include "mem_what.fh"
      Integer Total  ! [inout] Total memory limit (in doubles)
      Integer Heap   ! [inout] Heap memory limit (in doubles)
      Integer Stack  ! [inout] Stack memory limit (in doubles)
      Integer Global ! [inout] GA memory limit (in doubles)
      Character*1 TSource ! [input] Source of memory limit
      Character*1 HSource ! [input] Source of memory limit
      Character*1 SSource ! [input] Source of memory limit
      Character*1 GSource ! [input] Source of memory limit
C
C DESCRIPTION
C     Combines user-specified memory limits with (hopefully intelligent)
C     defaults to produce a complete memory specification.
C
C     As memory limits may now be specified by compiled in defaults,
C     configuration files (i.e. .nwchemrc), environment variables,
C     and/or the input file a priority system is needed to resolve
C     inconsistencies. The priorities are (from highest to lowest):
C     1. User input file
C     2. Environment variables
C     3. Configuration files (i.e. .nwchemrc)
C     4. Defaults
C     5. Not specified (i.e. always override)
C     If inconsistencies are discovered in the memory specification
C     the lowest priority quantit(y/ies) will be modified to resolve
C     them.
C
C     On input, Source = 'U' indicates user-provided input.  All others
C     must be 'N' for "not specified".  On output, notations may be:
C        N)ot specified
C        F)ile .nwchemrc
C        E)nvironment
C        U)ser-specified (input file)
C        D)efault (for total only)
C        I)nferred from default partitioning and/or user input
C        C)alculated from other inputs
C        R)eset of user-specified or default value based on other inputs 
C          (for total only)
C
C EXTERNAL ROUTINES
#include "inp.fh"
      logical  memory_env_get, memory_nwchemrc_get, memory_override
      external memory_env_get, memory_nwchemrc_get, memory_override
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C PARAMETERS
C
      Integer Total_Dflt   ! Default for total memory (doubles)
C
C     Allow the default to be specified as a compiler option
C     at build time.  If it is not specified, we have sensible
C     platform-specific defaults below.
c
c     RJH: adjusted defaults to provide more local memory in 
c          light of new integrals, caching and replicated data
C
#ifdef DFLT_TOT_MEM
      Parameter (Total_Dflt = DFLT_TOT_MEM )   ! from compile flag
#elif defined(SP1) || defined(LAPI)
C     This is probably a minimum configuration for most IBM
C     platforms, but many will have more.  Assumes dedicated node
C     access.
C
      Parameter ( Total_Dflt = 52428800) ! 400 MB on 512 MB 
#elif defined(LINUX) || defined(WIN32) || defined (MACX)
*
*     parameter ( Total_Dflt = 16777216) ! 128 MB (linux)
*      Parameter ( Total_Dflt = 26214400) ! 200 MB on 256 MB node
      Parameter ( Total_Dflt = 52428800) ! 400 MB on 512 MB 
#elif defined(SUN) || defined(SOLARIS) || defined(HPUX)
*     Parameter ( Total_Dflt = 11796480) ! 90 MB on 128 MB node (sun or solaris)
      Parameter ( Total_Dflt = 52428800) ! 400 MB on 512 MB 
#elif defined(__crayx1)
C
      Parameter ( Total_Dflt = 52428800) ! 512
#elif defined(CRAY_T3E)
C
*too large   Parameter ( Total_Dflt = 11796480) ! 90 MB on 128 MB node
      Parameter ( Total_Dflt = 11010052) ! 83 MB on 128 MB node (t3e)
#elif defined(CRAY_T3D)
C     Note this is a minimum memory configuration for a T3D
C     Code seems to be very large on T3D (~10-15 MB)
C
      Parameter ( Total_Dflt = 5242880 ) ! 40 MB on a 64 MB node (t3d)
#elif defined(KSR)
      Parameter ( Total_Dflt = 2621440 ) ! 20 MB on a 32 MB node  (ksr)
#elif defined(__PARAGON__)
C     The OS Version 1.3 release notes give the following table
C     for memory usage by the OS based on physical memory on the
C     nodes.  The increase is due to larger paging tables.
C     Code itself is about 5 MB with everything configured in.
C     Phys. Mem.   OS Uses  Msg. bufs.   Available memory
C      16 MB        9 MB    1 MB           6 MB      786 432 dbl
C      32 MB       10 MB    1 MB          21 MB    2 763 264 dbl
C      64 MB       11 MB    1 MB          52 MB    6 815 744 dbl
C     128 MB       12 MB    1 MB         115 MB   15 973 289 dbl
C
      Parameter ( Total_Dflt = 2097152 ) ! 16 MB on a 32 MB node (paragon)
#elif defined(DELTA)
C     Note:  RTDB presently needs to be able to malloc to function
C     so this limit leaves it a little room.  It is pretty much
C     an upper limit on memory usage on the Delta, unfortunately.
C
      Parameter (Total_Dflt = 917504 ) ! 7 MB on a 16 MB node (delta)
#elif defined(SGITFP)
*     Parameter ( Total_Dflt = 11796480) ! 90 MB on 128 MB node (sgitfp)
      Parameter ( Total_Dflt = 52428800) ! 400 MB on 512 MB 
#elif defined(DECOSF)
*     Parameter ( Total_Dflt = 11796480) ! 90 MB on 128 MB node (decosf)
      Parameter ( Total_Dflt = 52428800) ! 400 MB on 512 MB 
#elif defined(SGI) && ! defined(SGITFP)
*     Parameter ( Total_Dflt = 11796480) ! 90 MB on 128 MB node (sgi)
      Parameter ( Total_Dflt = 52428800) ! 400 MB on 512 MB 
#elif defined(IBM)  || defined(IBM64)
*     Parameter ( Total_Dflt = 11796480) ! 90 MB on 128 MB node (ibm)
      Parameter ( Total_Dflt = 92428800) ! 400 MB on 512 MB 
#elif defined(FUJITSU_VPP)
      Parameter ( Total_Dflt = 67108864) ! 512 MB (Fujitsu VPP)
#elif defined(BGL)
      Parameter ( Total_Dflt = 52428800) ! 400 on 512 MB (default co mode)
#elif defined(BGP)
      Parameter ( Total_Dflt = 52428800) ! 400 on 512 MB (per core)
#endif
C
C     Fraction of total memory which goes into each memory category
C     by default.  This is (should be) an empirical estimate of what
C     distribution of memory will serve most applications.
C
      Double Precision Heap_Frc, Stack_Frc, Global_Frc
#ifdef ELAN3HACK
      Parameter (Heap_Frc=7d0/18d0,Stack_Frc=7d0/18d0,
     ,     Global_Frc=4d0/18d0)
#else
      Parameter (Heap_Frc = 0.25, Stack_Frc = 0.25, Global_Frc = 0.50 )
#endif
C
C LOCAL VARIABLES
      Logical TGiven, HGiven, SGiven, GGiven
      Logical TOverride, HOverride, SOverride, GOverride
C-----------------------------------------------------------------------
C
C     Check inputs
C
      TGiven = inp_compare(.false., TSource, 'U')
      SGiven = inp_compare(.false., SSource, 'U')
      HGiven = inp_compare(.false., HSource, 'U')
      GGiven = inp_compare(.false., GSource, 'U')
      If ( .NOT. TGiven ) Then
        TGiven = memory_env_get(MEM_TOTAL,Total)
        If (TGiven) TSource = 'E'
      EndIf
      If ( .NOT. TGiven ) Then
        TGiven = memory_nwchemrc_get(MEM_TOTAL,Total)
        If (TGiven) TSource = 'F'
      EndIf
      If ( .NOT. HGiven ) Then
        HGiven = memory_env_get(MEM_HEAP,Heap)
        If (HGiven) HSource = 'E'
      EndIf
      If ( .NOT. HGiven ) Then
        HGiven = memory_nwchemrc_get(MEM_HEAP,Heap)
        If (HGiven) HSource = 'F'
      EndIf
      If ( .NOT. SGiven ) Then
        SGiven = memory_env_get(MEM_STACK,Stack)
        If (SGiven) SSource = 'E'
      EndIf
      If ( .NOT. SGiven ) Then
        SGiven = memory_nwchemrc_get(MEM_STACK,Stack)
        If (SGiven) SSource = 'F'
      EndIf
      If ( .NOT. GGiven ) Then
        GGiven = memory_env_get(MEM_GLOBAL,Global)
        If (GGiven) GSource = 'E'
      EndIf
      If ( .NOT. GGiven ) Then
        GGiven = memory_nwchemrc_get(MEM_GLOBAL,Global)
        If (GGiven) GSource = 'F'
      EndIf
      If ( .NOT. 
     &    (( TGiven .AND..NOT. inp_compare(.false.,TSource, 'N')).OR.
     &     ( .NOT.TGiven .AND. inp_compare(.false.,TSource, 'N'))))
     $   Call ErrQuit('Memory_Defaults: Bad value for argument', 2,
     &       INPUT_ERR)
      If ( .NOT. 
     &    (( SGiven .AND..NOT. inp_compare(.false.,SSource, 'N')).OR.
     &     ( .NOT.SGiven .AND. inp_compare(.false.,SSource, 'N'))))
     $   Call ErrQuit('Memory_Defaults: Bad value for argument', 4,
     &       INPUT_ERR)
      If ( .NOT. 
     &    (( HGiven .AND..NOT. inp_compare(.false.,HSource, 'N')).OR.
     &     ( .NOT.HGiven .AND. inp_compare(.false.,HSource, 'N'))))
     $   Call ErrQuit('Memory_Defaults: Bad value for argument', 6,
     &       INPUT_ERR)
      If ( .NOT. 
     &    (( GGiven .AND..NOT. inp_compare(.false.,GSource, 'N')).OR.
     &     ( .NOT.GGiven .AND. inp_compare(.false.,GSource, 'N'))))
     $   Call ErrQuit('Memory_Defaults: Bad value for argument', 8,
     &       INPUT_ERR)
C
C     Use the default total limit if the user did not provide one.
C
      If ( .NOT. TGiven) then
         Total = Total_Dflt
         TSource = 'D' ! Default
      EndIf
c
c     Set up defaults, the remaining inputs are considered as
c     modifications of the defaults
c
      If (inp_compare(.false.,GSource, 'N')) Then
        Global = Global_Frc*Total_Dflt
      EndIf
      If (inp_compare(.false.,HSource, 'N')) Then
        Heap = Heap_Frc*Total_Dflt
      EndIf
      If (inp_compare(.false.,SSource, 'N')) Then
        Stack = Stack_Frc*Total_Dflt
      EndIf
c
C
C     Work out which variable(s) may be overridden based on the sources
C     of the others.
C
      TOverride = memory_override(TSource,HSource,SSource,GSource)
      SOverride = memory_override(SSource,TSource,HSource,GSource)
      HOverride = memory_override(HSource,TSource,SSource,GSource)
      GOverride = memory_override(GSource,TSource,SSource,HSource)
c
c     There are 16 potential cases which we work out below
c
      if (TOverride) then
        if (SOverride) then
          if (HOverride) then
            if (GOverride) then
c             T T T T: all settings have equal priority so they must
c                      match
              if (Total .ne. Stack + Heap + Global) then
                Call ErrQuit(
     &          'Memory_Defaults: Inconsistent memory specification',
     &          Total-Stack-Heap-Global, INPUT_ERR)
              endif
            else  ! GOverride
c             T T T F: global is set, all others to be computed.
c                      compute total as sum of the rest.
              TSource = 'C'
              Total = Stack+Heap+Global
            endif ! GOverride
          else  ! HOverride
            if (GOverride) then
c             T T F T: heap is set, all others to be computed.
c                      compute total as sum of the rest
              TSource = 'C'
              Total = Stack+Heap+Global
            else  ! GOverride
c             T T F F: heap and global are set all others to be computed.
c                      compute total as sum of the rest
              TSource = 'C'
              Total = Stack+Heap+Global
            endif ! GOverride
          endif ! HOverride
        else  ! SOverride
          if (HOverride) then
            if (GOverride) then
c             T F T T: stack is set, all others to be computed.
c                      compute total as sum of the rest
              TSource = 'C'
              Total = Stack+Heap+Global
            else  ! GOverride
c             T F T F: stack and global are set, all others to be computed.
c                      compute total as sum of the rest
              TSource = 'C'
              Total = Stack+Heap+Global
            endif ! GOverride
          else  ! HOverride
            if (GOverride) then
c             T F F T: stack and heap are set, all others to be computed.
c                      compute total as sum of the rest
              TSource = 'C'
              Total = Stack+Heap+Global
            else  ! GOverride
c             T F F F: stack, heap and global are set, total to be computed.
c                      compute total as sum of the rest
              TSource = 'C'
              Total = Stack+Heap+Global
            endif ! GOverride
          endif ! HOverride
        endif ! SOVerride
      else  ! TOverride
        if (SOverride) then
          if (HOverride) then
            if (GOverride) then
c             F T T T: total is set, all others are to be computed.
c                      split total according to standard fractions
              SSource = 'C'
              HSource = 'C'
              GSource = 'C'
              Stack   = Stack_Frc*Total
              Heap    = Heap_Frc*Total
              Global  = Global_Frc*Total
            else  ! GOverride
c             F T T F: total and global are set, all others are to be computed.
c                      split remainder of total according to standard fractions
              SSource = 'C'
              HSource = 'C'
              Stack   = Stack_Frc*(Total-Global)/(Stack_Frc+Heap_Frc)
              Heap    = Heap_Frc*(Total-Global)/(Stack_Frc+Heap_Frc)
            endif ! GOverride
          else  ! HOverride
            if (GOverride) then
c             F T F T: total and heap are set, all others are to be computed.
c                      split remainder of total according to standard fractions
              SSource = 'C'
              GSource = 'C'
              Stack   = Stack_Frc*(Total-Heap)/(Stack_Frc+Global_Frc)
              Global  = Global_Frc*(Total-Heap)/(Stack_Frc+Global_Frc)
            else  ! GOverride
c             F T F F: total, heap and global are set, stack is to be computed.
              SSource = 'C'
              Stack   = Total-Heap-Global
            endif ! GOverride
          endif ! HOverride
        else  ! SOverride
          if (HOverride) then
            if (GOverride) then
c             F F T T: total and stack are set, all others are to be computed.
c                      split remainder of total according to standard fractions
              HSource = 'C'
              GSource = 'C'
              Heap    = Heap_Frc*(Total-Stack)/(Global_Frc+Heap_Frc)
              Global  = Global_Frc*(Total-Stack)/(Global_Frc+Heap_Frc)
            else  ! GOverride
c             F F T F: total, stack and global are set, heap is to be computed.
              HSource = 'C'
              Heap    = Total-Stack-Global
            endif ! GOverride
          else  ! HOverride
            if (GOverride) then
c             F F F T: total, stack and heap are set, global is to be computed.
              GSource = 'C'
              Global  = Total-Stack-Heap
            else  ! GOverride
c             F F F F: total, stack, heap and global are set, the settings
c                      better match
              if (Total .ne. Stack + Heap + Global) then
                Call ErrQuit(
     &          'Memory_Defaults: Inconsistent memory specification',
     &          Total-Stack-Heap-Global, INPUT_ERR)
              endif
            endif ! GOverride
          endif ! HOverride
        endif ! SOVerride
      endif ! TOverride
c
      Heap   = max(0,Heap)
      Stack  = max(0,Stack)
      Global = max(0,Global)
      Total  = max(0,Total)
      if (Total .ne. Stack + Heap + Global) then
        Total   = Stack + Heap + Global
        TSource = 'R'
      endif
*
*     rjh: ensure that heap+stack are at least 6 mb
*
      if (heap+stack .lt. 750000) then
         heap = 750000/2
         stack= 750000/2
         global=total-heap-stack
      endif
*
c$$$      Write (0, *) 'memory_defaults: T H S G ',
c$$$     $     Total, TSource, Heap, HSource, Stack, SSource, Global,
c$$$     $   GSource
C
C     Check that what the user entered (or what we guessed) makes
C     sense.

      If ( Total .lt. Stack + Heap + Global ) Call ErrQuit(
     $   'Memory_Defaults: Inconsistent memory specification',
     $   Total-Stack-Heap-Global, INPUT_ERR)
C
      If ( Total .lt. 0) Call ErrQuit(
     $   'Memory_Defaults: Total memory limit unreasonable', Total,
     &       INPUT_ERR)
      If ( Stack .lt. 0) Call ErrQuit(
     $   'Memory_Defaults: Stack memory limit unreasonable', Stack,
     &       INPUT_ERR)
      If ( Heap .lt. 0) Call ErrQuit(
     $   'Memory_Defaults: Heap memory limit unreasonable', Heap,
     &       INPUT_ERR)
      If ( Global .lt. 0) Call ErrQuit(
     $   'Memory_Defaults: Global memory limit unreasonable', Global,
     &       INPUT_ERR)
C
      Return
      End
c
c-----------------------------------------------------------------------
c
      logical function memory_override(Tcandidate,Tvar1,Tvar2,Tvar3)
      implicit none
c
c     Work out if Tcandidate has the lowest priority in which case
c     it may be overridden, otherwise it cannot be overriden.
c     See subroutine memory_defaults for the definitions of the 
c     priority levels.
c
      character*1 Tcandidate ! [input] The candidate variable
      character*1 Tvar1      ! [input] An other variable
      character*1 Tvar2      ! [input] An other variable
      character*1 Tvar3      ! [input] An other variable
c
c     Local variables
c
      character*1 Highest    ! the highest priority among Tvar*
      character*1 Lowest     ! the lowest priority among Tvar*
c
      Highest = 'N'
      Lowest  = 'U'
      if ((Highest.eq.'N').and.(Tvar1.eq.'F'.or.Tvar1.eq.'E'.or.
     &                          Tvar1.eq.'U')) then
        Highest = Tvar1
      else if ((Highest.eq.'D').and.(Tvar1.eq.'F'.or.Tvar1.eq.'E'.or.
     &                               Tvar1.eq.'U')) then
        Highest = Tvar1
      else if ((Highest.eq.'F').and.(Tvar1.eq.'E'.or.Tvar1.eq.'U')) then
        Highest = Tvar1
      else if ((Highest.eq.'E').and.(Tvar1.eq.'U')) then
        Highest = Tvar1
      endif
      if ((Highest.eq.'N').and.(Tvar2.eq.'F'.or.Tvar2.eq.'E'.or.
     &                          Tvar2.eq.'U')) then
        Highest = Tvar2
      else if ((Highest.eq.'D').and.(Tvar2.eq.'F'.or.Tvar2.eq.'E'.or.
     &                               Tvar2.eq.'U')) then
        Highest = Tvar2
      else if ((Highest.eq.'F').and.(Tvar2.eq.'E'.or.Tvar2.eq.'U')) then
        Highest = Tvar2
      else if ((Highest.eq.'E').and.(Tvar2.eq.'U')) then
        Highest = Tvar2
      endif
      if ((Highest.eq.'N').and.(Tvar3.eq.'F'.or.Tvar3.eq.'E'.or.
     &                          Tvar3.eq.'U')) then
        Highest = Tvar3
      else if ((Highest.eq.'D').and.(Tvar3.eq.'F'.or.Tvar3.eq.'E'.or.
     &                               Tvar3.eq.'U')) then
        Highest = Tvar3
      else if ((Highest.eq.'F').and.(Tvar3.eq.'E'.or.Tvar3.eq.'U')) then
        Highest = Tvar3
      else if ((Highest.eq.'E').and.(Tvar3.eq.'U')) then
        Highest = Tvar3
      endif
c
      if ((Lowest.eq.'U').and.(Tvar1.eq.'N'.or.Tvar1.eq.'D'.or.
     &                         Tvar1.eq.'F'.or.Tvar1.eq.'E')) then
        Lowest = Tvar1
      else if ((Lowest.eq.'E').and.(Tvar1.eq.'N'.or.Tvar1.eq.'D'.or.
     &                              Tvar1.eq.'F')) then
        Lowest = Tvar1
      else if ((Lowest.eq.'F').and.(Tvar1.eq.'N'.or.Tvar1.eq.'D')) then
        Lowest = Tvar1
      else if ((Lowest.eq.'D').and.(Tvar1.eq.'N')) then
        Lowest = Tvar1
      endif
      if ((Lowest.eq.'U').and.(Tvar2.eq.'N'.or.Tvar2.eq.'D'.or.
     &                         Tvar2.eq.'F'.or.Tvar2.eq.'E')) then
        Lowest = Tvar2
      else if ((Lowest.eq.'E').and.(Tvar2.eq.'N'.or.Tvar2.eq.'D'.or.
     &                              Tvar2.eq.'F')) then
        Lowest = Tvar2
      else if ((Lowest.eq.'F').and.(Tvar2.eq.'N'.or.Tvar2.eq.'D')) then
        Lowest = Tvar2
      else if ((Lowest.eq.'D').and.(Tvar2.eq.'N')) then
        Lowest = Tvar2
      endif
      if ((Lowest.eq.'U').and.(Tvar3.eq.'N'.or.Tvar3.eq.'D'.or.
     &                         Tvar3.eq.'F'.or.Tvar3.eq.'E')) then
        Lowest = Tvar3
      else if ((Lowest.eq.'E').and.(Tvar3.eq.'N'.or.Tvar3.eq.'D'.or.
     &                              Tvar3.eq.'F')) then
        Lowest = Tvar3
      else if ((Lowest.eq.'F').and.(Tvar3.eq.'N'.or.Tvar3.eq.'D')) then
        Lowest = Tvar3
      else if ((Lowest.eq.'D').and.(Tvar3.eq.'N')) then
        Lowest = Tvar3
      endif
c
      memory_override = .false.
      if (Tcandidate.eq.'N') then
        memory_override = .true.
      else if (Lowest.eq.Highest) then
        if (Tcandidate.eq.Lowest) then
          memory_override = .false.
        else if ((Lowest.eq.'U').and.(Tcandidate.eq.'N'.or.
     &           Tcandidate.eq.'D'.or.Tcandidate.eq.'F'.or.
     &           Tcandidate.eq.'E')) then
          memory_override = .true.
        else if ((Lowest.eq.'E').and.(Tcandidate.eq.'N'.or.
     &           Tcandidate.eq.'D'.or.Tcandidate.eq.'F')) then
          memory_override = .true.
        else if ((Lowest.eq.'F').and.(Tcandidate.eq.'N'.or.
     &           Tcandidate.eq.'D')) then
          memory_override = .true.
        else if ((Lowest.eq.'D').and.(Tcandidate.eq.'N')) then
          memory_override = .true.
        endif
      else
        if (Tcandidate.eq.Lowest) then
          memory_override = .true.
        else if ((Lowest.eq.'U').and.(Tcandidate.eq.'N'.or.
     &           Tcandidate.eq.'D'.or.Tcandidate.eq.'F'.or.
     &           Tcandidate.eq.'E')) then
          memory_override = .true.
        else if ((Lowest.eq.'E').and.(Tcandidate.eq.'N'.or.
     &           Tcandidate.eq.'D'.or.Tcandidate.eq.'F')) then
          memory_override = .true.
        else if ((Lowest.eq.'F').and.(Tcandidate.eq.'N'.or.
     &           Tcandidate.eq.'D')) then
          memory_override = .true.
        else if ((Lowest.eq.'D').and.(Tcandidate.eq.'N')) then
          memory_override = .true.
        else if ((Lowest.eq.'N').and.(Tcandidate.eq.'D')) then
          memory_override = .true.
        endif
      endif
c
      return
      end
c
c-----------------------------------------------------------------------
c
      logical function memory_env_get(iwhat,iwords)
      implicit none
c
c     Get the number of words of the memory quantity specified by iwhat
c     from environment variables. If an environment variable was found
c     with a valid value the function returns .true. and the
c     corresponding value in iwords.
c     Otherwise the function returns .false. and iwords is unchanged.
c
#include "mem_what.fh"
#include "util.fh"
#include "global.fh"
#include "inp.fh"
#include "stdio.fh"
c
      integer iwhat  ! [input] id specifying what memory quantity to get
      integer iwords ! [input/output] how many words of memory
c
      logical success
      integer ival
      character*32 strval
      character*32 strenv
      logical debug
c
      debug = .false.
c
      success = .false.
      memory_env_get = success
      if (iwhat.eq.MEM_TOTAL) then
        strenv = "NWCHEM_MEMORY_TOTAL"
      else if (iwhat.eq.MEM_HEAP) then
        strenv = "NWCHEM_MEMORY_HEAP"
      else if (iwhat.eq.MEM_STACK) then
        strenv = "NWCHEM_MEMORY_STACK"
      else if (iwhat.eq.MEM_GLOBAL) then
        strenv = "NWCHEM_MEMORY_GLOBAL"
      else
        if (debug) then
          write(LuOut,
     +    '(i7," :memory_env_get failed: invalid iwhat: ",i8)')
     +    ga_nodeid(),iwhat
        endif
        return
      endif
c
c     Now try and get the value.
c
      call util_getenv(strenv(1:inp_strlen(strenv)),strval)
      if (debug) then
        write(LuOut,*)ga_nodeid(),"memory_env_get: "
     +        //strenv(1:inp_strlen(strenv))//"=<"
     +        //strval(1:inp_strlen(strval))//">"
      endif
      if (inp_strlen(strval).gt.0) then
        read(strval,'(i32)',ERR=900)ival
        if (ival.gt.0) then
          success = .true.
        endif
 900    continue
      endif
c
c     Check the outcome and return results accordingly
c
      memory_env_get = success
      if (success) iwords = ival
      if (debug) then
        write(LuOut,*)ga_nodeid(),"memory_env_get: ",success,
     +                ival,iwords
      endif
c
      return
      end
c
c-----------------------------------------------------------------------
c
      logical function memory_nwchemrc_get(iwhat,iwords)
      implicit none
c
c     Get the number of words of the memory quantity specified by iwhat
c     from nwchemrc files. If an nwchemrc key was found with a valid
c     value the function returns .true. and the corresponding value in
c     iwords.
c     Otherwise the function returns .false. and iwords is unchanged.
c
#include "mem_what.fh"
#include "util.fh"
#include "global.fh"
#include "inp.fh"
#include "stdio.fh"
c
      integer iwhat  ! [input] id specifying what memory quantity to get
      integer iwords ! [input/output] how many words of memory
c
      logical success
      integer ival
      character*32 strval
      character*32 strkey
      logical debug
c
      debug = .false.
c
      success = .false.
      memory_nwchemrc_get = success
      if (iwhat.eq.MEM_TOTAL) then
        strkey = "memory_total"
      else if (iwhat.eq.MEM_HEAP) then
        strkey = "memory_heap"
      else if (iwhat.eq.MEM_STACK) then
        strkey = "memory_stack"
      else if (iwhat.eq.MEM_GLOBAL) then
        strkey = "memory_global"
      else
        if (debug) then
          write(LuOut,
     +    '(i7," :memory_nwchemrc_get failed: invalid iwhat: ",i8)')
     +    ga_nodeid(),iwhat
        endif
        return
      endif
c
c     Now try and get the value.
c
      if (util_nwchemrc_get(strkey(1:inp_strlen(strkey)),strval)) then
        read(strval,'(i32)',ERR=910)ival
        if (ival.gt.0) then
          success = .true.
        endif
 910    continue
      endif
      if (debug) then
        write(LuOut,*)ga_nodeid(),"memory_nwchemrc_get: "
     +        //strkey(1:inp_strlen(strkey))//"=<"
     +        //strval(1:inp_strlen(strval))//">"
      endif
c
c     Check the outcome and return results accordingly
c
      memory_nwchemrc_get = success
      if (success) iwords = ival
      if (debug) then
        write(LuOut,*)ga_nodeid(),"memory_nwchemrc_get: ",success,
     +                ival,iwords
      endif
c
      return
      end

      logical function pre_multip(lseq,mseq,nseq,latm,matm,natm,
     + lang,mang,nang,ldih,mdih,ndih,limp,mimp,nimp)
c
c
c $Id: pre_multip.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer mseq,nseq
      integer lseq(6,mseq)
      integer matm,natm
      integer latm(11,matm)
      integer mang,nang
      integer lang(5,mang)
      integer mdih,ndih
      integer ldih(6,mdih)
      integer mimp,nimp
      integer limp(6,mimp)
c
      integer i
c
c     check number of segments involved in angles
c     -------------------------------------------
c
      do 76 i=1,nang
      if(lseq(1,latm(5,lang(1,i))).ne.lseq(1,latm(5,lang(2,i))).and.
     + lseq(1,latm(5,lang(1,i))).ne.lseq(1,latm(5,lang(3,i))).and.
     + lseq(1,latm(5,lang(2,i))).ne.lseq(1,latm(5,lang(3,i)))) then
      lang(5,i)=-1
      else
      lang(5,i)=0
      endif
   76 continue
c
c     check number of segments involved in dihedrals
c     ----------------------------------------------
c
      do 77 i=1,ndih
      ldih(6,i)=0
      if(lseq(1,latm(5,ldih(1,i))).ne.lseq(1,latm(5,ldih(2,i))).and.
     + lseq(1,latm(5,ldih(1,i))).ne.lseq(1,latm(5,ldih(3,i))).and.
     + lseq(1,latm(5,ldih(2,i))).ne.lseq(1,latm(5,ldih(3,i)))) then
      ldih(6,i)=-1
      else
      if(lseq(1,latm(5,ldih(1,i))).ne.lseq(1,latm(5,ldih(2,i))).and.
     + lseq(1,latm(5,ldih(1,i))).ne.lseq(1,latm(5,ldih(4,i))).and.
     + lseq(1,latm(5,ldih(2,i))).ne.lseq(1,latm(5,ldih(4,i)))) then
      ldih(6,i)=-1
      else
      if(lseq(1,latm(5,ldih(1,i))).ne.lseq(1,latm(5,ldih(3,i))).and.
     + lseq(1,latm(5,ldih(1,i))).ne.lseq(1,latm(5,ldih(4,i))).and.
     + lseq(1,latm(5,ldih(3,i))).ne.lseq(1,latm(5,ldih(4,i)))) then
      ldih(6,i)=-1
      else
      if(lseq(1,latm(5,ldih(2,i))).ne.lseq(1,latm(5,ldih(3,i))).and.
     + lseq(1,latm(5,ldih(2,i))).ne.lseq(1,latm(5,ldih(4,i))).and.
     + lseq(1,latm(5,ldih(3,i))).ne.lseq(1,latm(5,ldih(4,i)))) then
      ldih(6,i)=-1
      endif
      endif
      endif
      endif
   77 continue
c
c     check number of segments involved in improper dihedrals
c     -------------------------------------------------------
c
      do 78 i=1,nimp
      limp(6,i)=0
      if(lseq(1,latm(5,limp(1,i))).ne.lseq(1,latm(5,limp(2,i))).and.
     + lseq(1,latm(5,limp(1,i))).ne.lseq(1,latm(5,limp(3,i))).and.
     + lseq(1,latm(5,limp(2,i))).ne.lseq(1,latm(5,limp(3,i)))) then
      limp(6,i)=-1
      else
      if(lseq(1,latm(5,limp(1,i))).ne.lseq(1,latm(5,limp(2,i))).and.
     + lseq(1,latm(5,limp(1,i))).ne.lseq(1,latm(5,limp(4,i))).and.
     + lseq(1,latm(5,limp(2,i))).ne.lseq(1,latm(5,limp(4,i)))) then
      limp(6,i)=-1
      else
      if(lseq(1,latm(5,limp(1,i))).ne.lseq(1,latm(5,limp(3,i))).and.
     + lseq(1,latm(5,limp(1,i))).ne.lseq(1,latm(5,limp(4,i))).and.
     + lseq(1,latm(5,limp(3,i))).ne.lseq(1,latm(5,limp(4,i)))) then
      limp(6,i)=-1
      else
      if(lseq(1,latm(5,limp(2,i))).ne.lseq(1,latm(5,limp(3,i))).and.
     + lseq(1,latm(5,limp(2,i))).ne.lseq(1,latm(5,limp(4,i))).and.
     + lseq(1,latm(5,limp(3,i))).ne.lseq(1,latm(5,limp(4,i)))) then
      limp(6,i)=-1
      endif
      endif
      endif
      endif
   78 continue
c
      pre_multip=.true.
      return
      end

      subroutine induce(lself,lpbcs,xw,xwm,pw,pwp,iwdt,iwz,
     + iwfr,iwto,jwfr,jwto,xs,xsm,ps,psp,
     + isga,isat,isdt,isgr,ismf,isml,isss,isq1,isq2,isq3,isgm,ishop,isz,
     + isfr,isto,jsfr,jsto,lpbc,lstptr,lseq)
c
c     in     log : lself           : true for box self interactions
c     in     r*8 : xw(mwm,3,mwa)   : solvent coordinates
c     in     r*8 : xwm(mwm,3)      : solvent molecule center of mass coordinates
c     out    r*8 : rtos(mwm)       : solvent distances to closes solute atom
c     in     int : iwdt(mwm)       : solvent dynamics type
c     out    int : iwz(mwm)        : solvent boundary type
c     in     int : iwfr,iwto       : first and last solvent molecule i
c     in     int : jwfr,jwto       : first and last solvent molecule j
c     in     r*8 : xs(msa,3)       : solute atom coordinates
c     in     r*8 : xsm(msm,3)      : solute molecule center of mass coordinates
c     in     int : isga(msa)       : solute global atom number
c     in     int : isat(msa)       : solute atom type
c     in     int : isdt(msa)       : solute dynamics type
c     in     int : isgr(msa)       : solute charge group
c     in     int : ismf(msa)       : solute molecule fraction
c     in     int : isml(msa)       : solute molecule
c     in     int : isss(msa)       : solute separation shifted scaling type
c     in     int : isq1(msa)       : solute charge type 1
c     in     int : isq2(msa)       : solute charge type 2
c     in     int : isq3(msa)       : solute charge type 3
c     out    int : isz(msa)        : solute boundary type 
c     in     int : isfr,isto       : first and last solute atom i
c     in     int : jsfr,jsto       : first and last solute atom j
c     in     log : lpbc            : flag to consider periodic boundary conditions
c     in/out int : lstptr          : list pointer
c
c     dimensions nwm,nwa and nsa need to have been given by a call to cf_initx
c
c $Id: cf_induce.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "cf_common.fh"
#include "mafdecls.fh"
c
      real*8 xw(mwm,3,mwa),xwm(mwm,3)
      real*8 pw(mwm,3,mwa,2),pwp(mwm,3,mwa,2,2)
      real*8 xs(msa,3),xsm(msm,3)
      real*8 ps(msa,3,2),psp(msa,3,2,2)
      integer iwdt(mwm),iwz(mwm),isz(msa)
      integer isga(msa),isat(msa),isdt(msa),isgr(msa),ismf(msa)
      integer isml(msa),isss(msa),isq1(msa),isq2(msa),isq3(msa)
      integer isgm(msa),ishop(msa)
      integer lseq(mseq)
      integer iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto
      integer lstptr
      logical lself,lpbc,lpbcs
c
      integer nwloc,nsloc,nwnon,nsnon,npairs
      integer lptr
c
      if(lself) then
      jwfr=iwfr
      jwto=iwto
      jsfr=isfr
      jsto=isto
      endif
c
      nwloc=iwto-iwfr+1
      if(iwfr.eq.0.or.iwto.lt.iwfr) nwloc=0
      nwnon=jwto-jwfr+1
      if(jwfr.eq.0.or.jwto.lt.jwfr) nwnon=0
      nsloc=isto-isfr+1
      if(isfr.eq.0.or.isto.lt.isfr) nsloc=0
      nsnon=jsto-jsfr+1
      if(jsfr.eq.0.or.jsto.lt.jsfr) nsnon=0
c
c     list [ list(1)=int_mb(lptr) ] with offset ndxp
c
c     list( 1) : index to pairlist for solvent-solvent
c     list( 2) : index to pairlist for solute-solvent
c     list( 3) : index to pairlist for solvent-solute
c     list( 4) : index to pairlist for solute-solute
c     list( 5) : index to pairlist for solute bonds
c     list( 6) : index to pairlist for solute angles
c     list( 7) : index to pairlist for solute dihedrals
c     list( 8) : index to pairlist for solute impropers
c     list( 9) : index to pairlist for solute third neighbors
c     list(10) : index to pairlist for solute excluded pairs
c
c
c     pairlists
c     ---------
c
      if(lpair) call pairs(lself,lpbcs,xw,xwm,iwdt,iwz,
     + iwfr,iwto,jwfr,jwto,xs,xsm,
     + isga,isat,isdt,isgr,isgm,ismf,isml,isss,isq1,isq2,isq3,ishop,isz,
     + isfr,isto,jsfr,jsto,lpbc,lstptr,lseq)
c
c     induced dipoles
c     ---------------
c
      ndxp=lstptr
      lptr=i_list+ndxp+24
c
      if(lself.and.nwloc.gt.0) then
c      call cf_fw(iwfr,iwto,xw,fw,iwdt,int_mb(i_iwa),int_mb(i_iwq),
c     + lpbc,dbl_mb(i_vdw),dbl_mb(i_chg),mbt(1),numb(1),mbp(1),
c     + int_mb(i_ibnd(1)),dbl_mb(i_bnd(1)),dbl_mb(i_rbnd(1)),
c     + mht(1),numh(1),mhp(1),
c     + int_mb(i_iang(1)),dbl_mb(i_ang(1)),dbl_mb(i_rang(1)),
c     + mdt(1),numd(1),mdp(1),
c     + int_mb(i_idih(1)),dbl_mb(i_dih(1)),dbl_mb(i_rdih(1)),
c     + mit(1),numi(1),mip(1),
c     + int_mb(i_iimp(1)),dbl_mb(i_imp(1)),dbl_mb(i_rimp(1)),
c     + mtt(1),numt(1),int_mb(i_itrd(1)),
c     + mxt(1),numx(1),int_mb(i_ixcl(1)))
      endif
c
c     solvent-solvent polarization
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call cf_dww(xw,xwm,pw,pwp,iwfr,nwloc,lpbc,
     + dbl_mb(i_chg),int_mb(i_iwq),
     + int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nwloc),int_mb(lptr+1+4*nwloc),
     + dbl_mb(i_s3r1),dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r2),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_smr5),dbl_mb(i_smr6))
      lptr=lptr+4*nwloc+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute-solvent polarization
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call cf_dsw(xs,xsm,ps,psp,isdt,ismf,isml,isq1,isfr,nsloc,
     + xw,xwm,pw,pwp,int_mb(i_iwq),lpbc,dbl_mb(i_chg),int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nsloc),int_mb(lptr+1+4*nsloc),
     + dbl_mb(i_s3r1),dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r2),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_smr5),dbl_mb(i_smr6),
     + int_mb(i_s1i1))
      lptr=lptr+4*nsloc+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solvent-solute forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call cf_dsw(xs,xsm,ps,psp,isdt,ismf,isml,isq1,jsfr,nsnon,
     + xw,xwm,pw,pwp,int_mb(i_iwq),lpbc,dbl_mb(i_chg),int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nsloc),int_mb(lptr+1+4*nsloc),
     + dbl_mb(i_s3r1),dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r2),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_smr5),dbl_mb(i_smr6),
     + int_mb(i_s1i1))
      lptr=lptr+4*nsnon+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute-solute forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call cf_dss(xs,xsm,ps,psp,ismf,isml,isq2,isq3,isfr,nsloc,
     + lpbc,dbl_mb(i_chg),int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nsloc),int_mb(lptr+1+4*nsloc),
     + dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r1),dbl_mb(i_s1r1),
     + dbl_mb(i_s1r2),dbl_mb(i_s1r3),dbl_mb(i_s3r2),dbl_mb(i_s1r6),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_s1r5),
     + int_mb(i_s1i1),int_mb(i_s1i2),int_mb(i_s1i3),int_mb(i_s1i4),
     + dbl_mb(i_smr3),dbl_mb(i_smr4))
      lptr=lptr+4*nsloc+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute bond forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
c      call cf_fsb(npairs,int_mb(lptr+1),mbt(2),mbp(2),
c     + int_mb(i_ibnd(2)),dbl_mb(i_bnd(2)),dbl_mb(i_rbnd(2)),
c     + max(isto,jsto),msa,isga,ismf,isdt,isq1,dbl_mb(i_chg),
c     + xs,fs,esb,esp,lpbc)
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute angle forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
c      call cf_fsh(npairs,int_mb(lptr+1),mht(2),mhp(2),
c     + int_mb(i_iang(2)),dbl_mb(i_ang(2)),dbl_mb(i_rang(2)),
c     + max(isto,jsto),msa,isga,ismf,isdt,isq1,dbl_mb(i_chg),
c     + xs,fs,esh,esp,lpbc,lupden)
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute torsion forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
c      call cf_fsd(npairs,int_mb(lptr+1),mdt(2),mdp(2),
c     + int_mb(i_idih(2)),dbl_mb(i_dih(2)),dbl_mb(i_rdih(2)),
c     + max(isto,jsto),msa,isga,ismf,isdt,
c     + xs,fs,esd,esp,lpbc,lupden)
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute improper dihedral forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
c      call cf_fso(npairs,int_mb(lptr+1),mdt(2),mdp(2),
c     + int_mb(i_iimp(2)),dbl_mb(i_imp(2)),dbl_mb(i_rimp(2)),
c     + max(isto,jsto),msa,isga,ismf,isdt,
c     + xs,fs,eso,esp,lpbc,lupden)
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute third neighbor forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
c      call cf_fst(npairs,int_mb(lptr+1),mtt(2),int_mb(i_itrd(2)),
c     + dbl_mb(i_vdw),dbl_mb(i_chg),
c     + max(isto,jsto),msa,isat,isga,isml,isdt,isq2,
c     + xs,fs,esp,essl,essq,essr,lpbc)
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
      ndxp=lptr-i_list
c
      return
      end

      subroutine argos_diana_rdfwrt(isel,irdf)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      integer isel(msa)
      integer irdf(nsel,mwa,nrdf)
c
      integer i,j,k,l,m
      real*8 d
c
      write(*,'(a)') 'ARGOS_DIANA_RDFWRT'
c
      do 4 i=1,nsel
      do 5 m=1,nrdf
      write(*,'(2i5,10i10)') i,m,(irdf(i,l,m),l=1,nwa)
    5 continue
    4 continue
c
c      i=0
c      do 1 j=1,nsa
c      if(isel(j).gt.0) then
c      i=i+1
c      do 2 k=1,nrdf
c      d=dble(k)*rrdf/dble(nrdf)
c      write(*,1000) d,(irdf(i,l,k),l=1,nwa)
c 1000 format(f12.6,10i5)
c    2 continue
c      endif
c    1 continue
c
      close(unit=lfnrdf,status='keep')
      write(*,'(a)') ' Closing rdf file '
c
      return
      end
c $Id: argos_diana_rdfwrt.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup selci
C> @{
      subroutine selci_loadw(iflwmt, w1, w2, nfmax, nfmax2, nsmax)
*
* $Id: loadw.F 25132 2014-01-15 06:25:28Z d3y133 $
*
#include "implicit.fh"
      dimension w1(nfmax,nfmax,nsmax), w2(nfmax2,nfmax,nsmax-1)
c
c     read in the coupling coefficients off wmatrx
c
      read (iflwmt,*) 
     &     (((w1(iu,iv,i),iu=1,nfmax),iv=1,nfmax),i=nsmax,1,-1)
      if (nfmax2*nfmax*(nsmax-1).gt.0) then
         read (iflwmt,*)
     &        (((w2(iu,iv,i),iu=1,nfmax2),iv=1,nfmax),i=1,nsmax-1)
      endif
c
c      write(6,*) ' w1 '
c      do 10 i = 1,nsmax
c         write(6,*) i
c         call selci_output(w1(1,1,i),1,nfmax,1,nfmax,nfmax,nfmax,1)
c 10   continue
c
c      write(6,*) ' w2 '
c      do 20 i = 1,nsmax-1
c         write(6,*) i
c         call selci_output(w2(1,1,i),1,nfmax2,1,nfmax,nfmax2,nfmax,1)
c 20   continue
c
      end
C> @}

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
      subroutine input
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mpif.h"
c.......................................................................
c Input configuration from an XYZ format file call be.inpt and set up
c initial data structures. Atomic numbers from XYZ file are ignored and
c an atomic number of 4 (Beryllium) is used instead.
c.......................................................................
c
c   initialize variables
c
      natom = 0
      do i = 1, maxatom
        ax(i) = 0.0d00
        ay(i) = 0.0d00
        az(i) = 0.0d00
      end do
c
      if (ga_nodeid().eq.0) then
        open(2,file='be.inpt',status='old')
        read(2,*) natom
        read(2,*)
c
c Read in coordinates
c
        do i = 1, natom
          read(2,*) j,ax(i),ay(i),az(i)
        end do
        close(2)
      endif
      call ga_igop(1,natom,1,'+')
      call ga_dgop(2,ax,natom,'+')
      call ga_dgop(3,ay,natom,'+')
      call ga_dgop(4,az,natom,'+')
c
c Set up s-function centers and nuclear charges
c
      ifcnt = 1
      do i = 1, natom
        q(i) = 4.0d00
c
        expnt(ifcnt) = 1741.0d00
        expnt(ifcnt+1) = 262.1d00
        expnt(ifcnt+2) = 60.33d00
        expnt(ifcnt+3) = 17.62d00
        expnt(ifcnt+4) = 5.933d00
        expnt(ifcnt+5) = 2.185d00
        expnt(ifcnt+6) = 0.859d00
        expnt(ifcnt+7) = 0.1806d00
        expnt(ifcnt+8) = 0.05835d00
        expnt(ifcnt+9) = 0.3d00
        expnt(ifcnt+10) = 0.3d00
        expnt(ifcnt+11) = 0.3d00
        expnt(ifcnt+12) = 0.3d00
        expnt(ifcnt+13) = 0.3d00
        expnt(ifcnt+14) = 0.3d00
c
        do j = 1, 15
          x(ifcnt) = ax(i)
          y(ifcnt) = ay(i)
          z(ifcnt) = az(i)
          if (j.eq.10) then
            x(ifcnt) = x(ifcnt) + 1.6d00
          endif
          if (j.eq.11) then
            x(ifcnt) = x(ifcnt) - 1.6d00
          endif
          if (j.eq.12) then
            y(ifcnt) = y(ifcnt) + 1.6d00
          endif
          if (j.eq.13) then
            y(ifcnt) = y(ifcnt) - 1.6d00
          endif
          if (j.eq.14) then
            z(ifcnt) = z(ifcnt) + 1.6d00
          endif
          if (j.eq.15) then
            z(ifcnt) = z(ifcnt) - 1.6d00
          endif
          ifcnt = ifcnt + 1
        end do
      end do
c
c  evaluate repulsion energy
c
      enrep = 0.0d00
      do i = 1, natom
        do j = i+1, natom
          r = sqrt((ax(i)-ax(j))**2 + (ay(i)-ay(j))**2
     +      + (az(i)-az(j))**2)
          enrep = enrep + q(i)*q(j)/r
        end do
      end do
      nocc = 2*natom
      nbfn =  15*natom
      nnbfn = nbfn*(nbfn+1)/2
      return
      end

      double precision function sym_trace_bas_op(r, ang_max, maxf,
     $     n, itype)
C$Id: sym_tr_bs_op.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
      integer ang_max, maxf, itype, n
      double precision r(maxf, maxf, 0:ang_max)
c
      integer i
      double precision trace
c
      trace = 0.0d0
      do i = 1, n
         trace = trace + r(i, i, itype)
      enddo
c
      sym_trace_bas_op = trace
c
      end

      integer function pre_base(isgm,isegm,csa,msa,nsa)
c
c $Id: pre_base.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "inp.fh"
c
      logical str_replace
      external str_replace
c
      integer msa,nsa,isgm
      integer isegm(msa)
      character*16 csa(msa)
c
      integer i,ibase
c
c     determine base
c
c     0: none
c     1: adenine
c     2: guanine
c     3: cytosine
c     4: uracil
c     5: thymine
c
      ibase=0
c
      do 1 i=1,nsa
      if(isgm.eq.isegm(i)) then
      if(csa(i)(1:3).eq.'DA ') ibase=1
      if(csa(i)(1:3).eq.'DA_') ibase=1
      if(csa(i)(1:3).eq.'DAT') ibase=1
      if(csa(i)(1:3).eq.'DG ') ibase=2
      if(csa(i)(1:3).eq.'DG_') ibase=2
      if(csa(i)(1:3).eq.'DGT') ibase=2
      if(csa(i)(1:3).eq.'DC ') ibase=3
      if(csa(i)(1:3).eq.'DC_') ibase=3
      if(csa(i)(1:3).eq.'DCT') ibase=3
      if(csa(i)(1:3).eq.'RU ') ibase=4
      if(csa(i)(1:3).eq.'RU_') ibase=4
      if(csa(i)(1:3).eq.'RUT') ibase=4
      if(csa(i)(1:3).eq.'DT ') ibase=5
      if(csa(i)(1:3).eq.'DT_') ibase=5
      if(csa(i)(1:3).eq.'DTT') ibase=5
      goto 2
      endif
    1 continue
    2 continue
c
      pre_base=ibase
      return
      end

*
* $Id: chi_read.F 24456 2013-07-30 23:08:29Z bylaska $
*

*     ***********************************
*     *             			*
*     *           chi_read		*
*     *             			*
*     ***********************************

      subroutine chi_read(ispin,ne,chi2)
      implicit none 
      integer ispin,ne(2)
      double complex chi2(*)

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"


*    *** local variables ***
      integer version,l,rtdb
      integer nfft3d,npack1,occupation
      integer nfft(3)
      real*8  unita(3,3)
      character*50 filename
      character*255 full_filename

      integer MASTER,taskid
      parameter(MASTER=0)
      integer n,q,pj
      integer msglen

c     complex*16 tmp(*)
      integer tmp(2),tmp2(2)
      logical value,psi_nolattice

*     ***** local functions ****
      character*50 control_input_psi
      external     control_input_psi
      double precision control_unita
      external         control_unita
      integer  control_ngrid,control_rtdb
      external control_ngrid,control_rtdb
      
      call Parallel_taskid(taskid)
      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)

      value = MA_push_get(mt_dcpl,nfft3d,'tmp',tmp(2),tmp(1))
      if (.not. value) 
     >  call errquit('chi_read:out of stack memory',0, MA_ERR)

      value = MA_push_get(mt_dcpl,nfft3d,'tmp2',tmp2(2),tmp2(1))
       if (.not. value) 
     > call errquit('chi_read:out of stack memory',1, MA_ERR)

*     **** open ELCIN binary file ****
      if (taskid.eq.MASTER) then
         filename = control_input_psi()
         full_filename = filename
         call util_file_name_resolve(full_filename, .false.)
c        call util_file_name_noprefix(filename,.false.,
c    >                                .false.,
c    >                        full_filename)

         l = index(full_filename,' ') -1
         write(*,1210) full_filename(1:l)
 1210    FORMAT(/' input psi filename:',A)

         call openfile(5,full_filename,l,'r',l)
         call iread(5,version,1)
         call iread(5,nfft,3)
         call dread(5,unita,9)
         call iread(5,ispin,1)
         call iread(5,ne,2)
         call iread(5,occupation,1)
      end if

c     **** send header to all nodes ****
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,version)
      msglen = 3
      call Parallel_Brdcst_ivalues(MASTER,msglen,nfft)
      msglen = 9
      call Parallel_Brdcst_values(MASTER,msglen,unita)
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,ispin)
      msglen = 2
      call Parallel_Brdcst_ivalues(MASTER,msglen,ne)



*     ***** Error checking ****
      if (version.ne.9) then
       call errquit(
     >       'Error cannot read pspw or band structure wavefunctions',1,
     &       INPUT_ERR)
      end if

      if ( (nfft(1).ne.control_ngrid(1)) .or.
     >     (nfft(2).ne.control_ngrid(2)) .or.
     >     (nfft(3).ne.control_ngrid(3)) ) then
        if (taskid.eq.MASTER) then
        write(*,*) "nfft :",nfft
        write(*,*) "ngrid:",control_ngrid(1),
     >                      control_ngrid(2),
     >                      control_ngrid(3)
        end if
        call errquit('Error reading wavefunctions - bad grid', 2,
     &       INPUT_ERR)
      end if

      rtdb = control_rtdb()
      if (.not.rtdb_get(rtdb,'nwpw:psi_nolattice',
     >                  mt_log,1,psi_nolattice))
     >   psi_nolattice = .true.
  
      if (.not.psi_nolattice) then
      if ( (unita(1,1).ne.control_unita(1,1)) .or.
     >     (unita(2,1).ne.control_unita(2,1)) .or.
     >     (unita(3,1).ne.control_unita(3,1)) .or.
     >     (unita(1,2).ne.control_unita(1,2)) .or.
     >     (unita(2,2).ne.control_unita(2,2)) .or.
     >     (unita(3,2).ne.control_unita(3,2)) .or.
     >     (unita(1,3).ne.control_unita(1,3)) .or.
     >     (unita(2,3).ne.control_unita(2,3)) .or.
     >     (unita(3,3).ne.control_unita(3,3)) ) then
        call errquit('Error reading wavefunctions - bad lattice', 3,
     &       INPUT_ERR)
      end if
      end if


*     *** read in 3d blocks ***
      do n=1,ispin
         call D3dB_c_read(1,5,dcpl_mb(tmp2(1)),
     >                        dcpl_mb(tmp(1)),-1)
         call Pack_c_pack(1,dcpl_mb(tmp2(1)))
         call Pack_c_Copy(1,dcpl_mb(tmp2(1)),chi2(1+(n-1)*npack1))
      end do
      

*     *** close ELCIN binary file ***
      if (taskid.eq.MASTER) then
        call closefile(5)
      end if
 
      value =           MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp(2))
      if (.not. value) call errquit('chi_read:popping stack',4, MA_ERR)

*     end if

      return
      end

c $Id: int_canon.F 23197 2012-11-30 18:39:25Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Canonicalizes the integral labels
C>
C> This routine canonicalizes the integral labels of a 2-electron
C> integral \f$ (ij|kl) \f$ such that on output:
C> \f{eqnarray*}{
C>   i &\geq& j \\\\
C>   k &\geq& l \\\\
C>   ij = i(i-1)/2+j &\geq& kl = k(k-1)/2+l 
C> \f}
C>
c:tex-% part of the internal API routines
c:tex-\subsection{int\_canon}
c:tex-This routine canonicalizes integral lables such that:
c:tex-$i \geq j$, $k \geq l$, and $ij \geq kl$
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_canon(i, j, k, l, ii, jj, kk, ll)
c:tex-\end{verbatim}
      implicit none
c:tex-\begin{verbatim}
      integer i   !< [Input] i-label
      integer j   !< [Input] j-label
      integer k   !< [Input] k-label
      integer l   !< [Input] l-label
      integer ii  !< [Output] canonical i-label
      integer jj  !< [Output] canonical j-label
      integer kk  !< [Output] canonical k-label
      integer ll  !< [Output] canonical l-label
c:tex-\end{verbatim}
      integer iii,jjj
#if defined(DEBUG)
#include "stdio.fh"
      logical warn
#endif
c
c     return in ii,jj,kk,ll the cannonically ordered i,j,k,l
c
c     (i>=j) >= (k>=l)
c
#if defined(DEBUG)
      warn = .false.
#endif
      if (i .ge. j) then
        ii = i
        jj = j
      else
#if defined(DEBUG)
        warn = .true.
#endif
        ii = j
        jj = i
      endif
      if (k .ge. l) then
        kk = k
        ll = l
      else
#if defined(DEBUG)
        warn = .true.
#endif
        kk = l
        ll = k
      endif
      if (ii.lt.kk .or. (ii.eq.kk .and. jj.lt.ll)) then
#if defined(DEBUG)
        warn = .true.
#endif
        iii = ii
        jjj = jj
        ii = kk
        jj = ll
        kk = iii
        ll = jjj
      endif
#if defined(DEBUG)
      if (warn) then
        write(luout,10000)i,j,k,l
        write(luout,10001)ii,jj,kk,ll
      endif
10000 format(1x,'old:',4(i5))
10001 format(1x,'new:',4(i5))
#endif
c
      end
C> @}

      SUBROUTINE ccsd_y_o2(d_i0,d_o1,d_t1,d_y1,d_y2,k_i0_offset,k_o1_off
     &set,k_t1_offset,k_y1_offset,k_y2_offset)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yo + = 1 * P( 4 ) * o ( h3 p1 )_o * y ( h4 p2 )_y
C     i0 ( h3 h4 p1 p2 )_yo + = -1 * P( 2 ) * Sum ( h7 ) * y ( h3 h7 p1 p2 )_y * i1 ( h4 h7 )_o
C         i1 ( h3 h7 )_o + = 1 * o ( h3 h7 )_o
C         i1 ( h3 h7 )_ot + = 1 * Sum ( p5 ) * o ( h3 p5 )_o * t ( p5 h7 )_t
C     i0 ( h3 h4 p1 p2 )_yo + = -1 * P( 2 ) * Sum ( p5 ) * o ( p5 p1 )_o * y ( h3 h4 p2 p5 )_y
C     i0 ( h3 h4 p1 p2 )_yto + = -1 * P( 2 ) * Sum ( h5 ) * o ( h5 p1 )_o * i1 ( h3 h4 h5 p2 )_yt
C         i1 ( h3 h4 h5 p1 )_yt + = -1 * Sum ( p6 ) * t ( p6 h5 )_t * y ( h3 h4 p1 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_o1
      INTEGER k_o1_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_t1
      INTEGER k_t1_offset
      CHARACTER*255 filename
      CALL ccsd_y_o2_1(d_o1,k_o1_offset,d_y1,k_y1_offset,d_i0,k_i0_offse
     &t)
      CALL OFFSET_ccsd_y_o2_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsd_y_o2_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsd_y_o2_2_1(d_o1,k_o1_offset,d_i1,k_i1_offset)
      CALL ccsd_y_o2_2_2(d_o1,k_o1_offset,d_t1,k_t1_offset,d_i1,k_i1_off
     &set)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsd_y_o2_2(d_y2,k_y2_offset,d_i1,k_i1_offset,d_i0,k_i0_offse
     &t)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsd_y_o2',-1,MA
     &_ERR)
      CALL ccsd_y_o2_3(d_o1,k_o1_offset,d_y2,k_y2_offset,d_i0,k_i0_offse
     &t)
      CALL OFFSET_ccsd_y_o2_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsd_y_o2_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsd_y_o2_4_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i1,k_i1_off
     &set)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsd_y_o2_4(d_o1,k_o1_offset,d_i1,k_i1_offset,d_i0,k_i0_offse
     &t)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsd_y_o2',-1,MA
     &_ERR)
      RETURN
      END
      SUBROUTINE ccsd_y_o2_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yo + = 1 * P( 4 ) * o ( h3 p1 )_o * y ( h4 p2 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b_1
      INTEGER p1b_1
      INTEGER h4b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_o)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_y_o2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+p1b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(h3b,p1b,h3b_1,p1b_1)
      CALL TCE_RESTRICTED_2(h4b,p2b,h4b_2,p2b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_y_o2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_y_o2_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - 1 + (noab+nvab) * (h3b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_y_o2_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_y_o2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_y_o2_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (h4b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_y_o2_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_y_o2_1',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_y_o2_1',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_y_o2_1',9,MA_ERR)
      IF ((h3b .le. h4b) .and. (p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,4,2,3,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF ((h3b .le. h4b) .and. (p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,4,2,1,3,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF ((h4b .le. h3b) .and. (p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h3b - 1 + noab * (h4b
     & - 1)))))
      END IF
      IF ((h4b .le. h3b) .and. (p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,2,4,1,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (h3b - 1 + noab * (h4b
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_y_o2_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_y_o2_1',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_y_o2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yo + = -1 * P( 2 ) * Sum ( h7 ) * y ( h3 h7 p1 p2 )_y * i1 ( h4 h7 )_o
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h7b
      INTEGER h3b_1
      INTEGER h7b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h4b_2
      INTEGER h7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_o)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_y_o2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h7b = 1,noab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h7b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h3b,h7b,p1b,p2b,h3b_1,h7b_1,p1b_1,p2b_1)
      CALL TCE_RESTRICTED_2(h4b,h7b,h4b_2,h7b_2)
      dim_common = int_mb(k_range+h7b-1)
      dima_sort = int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1) * int_mb
     &(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_y_o2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_y_o2_2',2,MA_ERR)
      IF ((h7b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h3b_1 - 1 + noab 
     &* (h7b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h3b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h7b_1 - 1 + noab 
     &* (h3b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_y_o2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_y_o2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_y_o2_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h7b_2
     & - 1 + noab * (h4b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h7b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_y_o2_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_y_o2_2',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_y_o2_2',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_y_o2_2',9,MA_ERR)
      IF ((h3b .le. h4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,4,1,3,2,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF ((h4b .le. h3b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,1,4,3,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h3b - 1 + noab * (h4b
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_y_o2_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_y_o2_2',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_y_o2_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h7 )_o + = 1 * o ( h3 h7 )_o
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h7b
      INTEGER dimc
      INTEGER h3b_1
      INTEGER h7b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h7b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h7b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h7b-1)) .eq. irrep_o) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h7b-1)
      CALL TCE_RESTRICTED_2(h3b,h7b,h3b_1,h7b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h7b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_y_o2_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_y_o2_2_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + (noab+nvab) * (h3b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_y_o2_2_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_y_o2_2_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h7b -
     & 1 + noab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_y_o2_2_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_y_o2_2_1',5,MA
     &_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd_y_o2_2_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h7 )_o
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER h7b
      length = 0
      DO h3b = 1,noab
      DO h7b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h7b-1)) .eq. irrep_o) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h7b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd_y_o2_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO h7b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h7b-1)) .eq. irrep_o) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h7b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h7b - 1 + noab * (h3b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+h7b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd_y_o2_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h7 )_ot + = 1 * Sum ( p5 ) * o ( h3 p5 )_o * t ( p5 h7 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h7b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h3b_1
      INTEGER p5b_1
      INTEGER p5b_2
      INTEGER h7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h7b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h7b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h7b-1)) .eq. ieor(irrep_
     &o,irrep_t)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h7b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_y_o2_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+p5b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(h3b,p5b,h3b_1,p5b_1)
      CALL TCE_RESTRICTED_2(p5b,h7b,p5b_2,h7b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+h3b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_y_o2_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_y_o2_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - 1 + (noab+nvab) * (h3b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p5b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_y_o2_2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_y_o2_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_y_o2_2_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h7b_2
     & - 1 + noab * (p5b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h7b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_y_o2_2_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_y_o2_2_2',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_y_o2_2_2',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_y_o2_2_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h7b -
     & 1 + noab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_y_o2_2_2',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_y_o2_2_2',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_y_o2_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yo + = -1 * P( 2 ) * Sum ( p5 ) * o ( p5 p1 )_o * y ( h3 h4 p2 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p5b_1
      INTEGER p1b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p2b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_o)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_y_o2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+p1b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,p1b,p5b_1,p1b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,p2b,p5b,h3b_2,h4b_2,p2b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_y_o2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_y_o2_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - 1 + (noab+nvab) * (p5b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_y_o2_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_y_o2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_y_o2_3',5,MA_ERR)
      IF ((p5b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_y_o2_3',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_y_o2_3',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_y_o2_3',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_y_o2_3',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h3b-1),int_mb(k_range+p1b-1)
     &,3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF ((p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h3b-1),int_mb(k_range+p1b-1)
     &,3,2,1,4,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_y_o2_3',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_y_o2_3',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_y_o2_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yto + = -1 * P( 2 ) * Sum ( h5 ) * o ( h5 p1 )_o * i1 ( h3 h4 h5 p2 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER h5b_1
      INTEGER p1b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p2b_2
      INTEGER h5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,ieor(irrep_t
     &,irrep_o))) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_y_o2_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+p1b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(h5b,p1b,h5b_1,p1b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,p2b,h5b,h3b_2,h4b_2,p2b_2,h5b_2)
      dim_common = int_mb(k_range+h5b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_y_o2_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_y_o2_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - 1 + (noab+nvab) * (h5b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_y_o2_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_y_o2_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_y_o2_4',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h5b_2
     & - 1 + noab * (p2b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_
     &2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p2b-1),int_mb(k_range+h5b-1)
     &,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_y_o2_4',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_y_o2_4',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_y_o2_4',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_y_o2_4',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h3b-1),int_mb(k_range+p1b-1)
     &,3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF ((p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h3b-1),int_mb(k_range+p1b-1)
     &,3,2,1,4,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_y_o2_4',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_y_o2_4',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_y_o2_4_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h4 h5 p1 )_yt + = -1 * Sum ( p6 ) * t ( p6 h5 )_t * y ( h3 h4 p1 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER h5b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p6b_1
      INTEGER h5b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p1b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO h5b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+h5b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+h5b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+h5b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_y_o2_4_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p6b-1),int_mb(k_sym+h5b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p6b,h5b,p6b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,p1b,p6b,h3b_2,h4b_2,p1b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h5b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_y_o2_4_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_y_o2_4_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (p6b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h5b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_y_o2_4_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_y_o2_4_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_y_o2_4_1',5,MA_ERR)
      IF ((p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_y_o2_4_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_y_o2_4_1',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_y_o2_4_1',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_y_o2_4_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h3b-1),int_mb(k_range+h5b-1)
     &,3,2,1,4,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h5b -
     & 1 + noab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_y_o2_4_1',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_y_o2_4_1',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd_y_o2_4_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd_y_o2.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h4 h5 p1 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER h5b
      length = 0
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO h5b = 1,noab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+p1b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h5b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd_y_o2_4_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO h5b = 1,noab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+p1b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h5b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h5b - 1 + noab * (p1b - noab - 1 + nvab 
     &* (h4b - 1 + noab * (h3b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_
     &mb(k_range+p1b-1) * int_mb(k_range+h5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine mc_init(rtdb,grad,ircflag)
      implicit none
      integer rtdb
#include "const_data.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "geom.fh"

      logical     ircflag 
      integer     natom,geom, i,k,l, ivib, gseed,mode
      integer     c_start,c_array
      integer     tag,charge,mass,force
      integer     mc_data_get_i_c_array,mc_data_get_i_c
      integer     mc_data_get_i_t, mc_data_get_i_q, mc_data_get_natom
      integer     mc_data_get_i_m, mc_data_get_i_f
      integer     naccept, mc_data_get_naccept
      integer     mc_data_get_i_in_vel, mc_data_get_i_in_acc
      integer     mc_data_get_i_prp, mc_data_get_mode 
      integer     prp,vel,acc  
      integer     i_eval,mc_data_get_i_eval,i_evec,mc_data_get_i_evec
      integer     mc_data_get_gseed
      double precision kB,temp,temp10,vau,pimg      
      double precision mc_data_get_temp,gks_gasdev
      logical     grad
      external    grad       
      character*8 task1 
      character*32 thr     ! this is just the theory ex: leps
      character*64 theory, blanks64  !theory should be leps:gradient 
      character*32 task, blanks32    ! this is ":gradient"
      data blanks64(1:64) /' '/
      data blanks32(1:32)/' '/
      double precision unitt,unitl,uma  
      logical dbug 
      integer iw
      iw=6

      theory=blanks64

      thr=blanks32
      task=blanks32
      task=':gradient'
      dbug=.false. 

      c_array=mc_data_get_i_c_array()  ! get the entire array of starting geometries
      c_start=mc_data_get_i_c()
      tag=mc_data_get_i_t()
      charge=mc_data_get_i_q()
      mass=mc_data_get_i_m()
      force=mc_data_get_i_f()   ! this is not set up yet 
      natom=mc_data_get_natom()
      naccept=mc_data_get_naccept()
      i_eval=mc_data_get_i_eval()
      i_evec=mc_data_get_i_evec()
      if (ircflag) then 
       call mc_data_allocate_vel_acc()
      endif
      vel=mc_data_get_i_in_vel()
      acc=mc_data_get_i_in_acc()
      prp = mc_data_get_i_prp() 
C -- get the handles for MD to be used for IRC traj
      unitt   = 1.0D-15
      unitl   = 5.29177249D-09
C     FKC     = 627.509451D+00
      uma     = 1.6605655D-24
C                             ( = ATOMIC MASS UNIT IN GRAMS )
C      boltz   = 1.380662D-16
C                             ( = BOLTZMANN CONSTANT IN ERG/DEG. )

      mode=0
      mode=mc_data_get_mode()
      gseed = -1234
      gseed = -abs(mc_data_get_gseed())
      kB = boltz
      temp = mc_data_get_temp()
      temp10=10.0   
      write(iw,*) 'In mc_init:'
      if (dbug)  call printeg(3*natom,dbl_mb(i_eval),dbl_mb(i_evec))

      if (.not. geom_create(geom, 'geometry'))
     & call errquit('mc_driver_getgeom: failed creating geometry',
     & 0,GEOM_ERR)
c      write(*,*) 'MC_init: generating initial conditions'

      if (.not. rtdb_cget(rtdb, 'task:theory', 1, thr))
     $     call errquit('mc_driver: theory not specified',0, RTDB_ERR)
c      if (thr.eq.'mp2')   thr='sdmp2'
      call concat(thr,task,theory)
c      write(iw,*) 'Theory is:  ',thr
c      write(iw,*) 'Grad is: ', theory
C --- get geometry from the big array in mc_driver
C--- the first one is always the TS
C ---- set the appropriate coordinate
      if(ircflag) then

         temp = 10.0

         do k=1,3*natom
             dbl_mb(vel+k-1)=0.0
             dbl_mb(acc+k-1)=0.0
         enddo

         do k=1,3*natom
           dbl_mb(c_start+k-1)=dbl_mb(c_array+k-1)
         enddo

         if (.not. geom_cart_set(geom, natom, byte_mb(tag),
     &       dbl_mb(c_start), dbl_mb(charge)))
     &       call errquit('mc_init_putgeom: coord error',0,GEOM_ERR)

         if(.not.geom_rtdb_store(rtdb,geom,"geometry"))
     &       call errquit('mc_init: Failed to store geom to rtdb',0,
     &       RTDB_ERR)

C---- calculate the gradient to get the force for acceleration
         if (.not.grad(rtdb))
     &       call errquit('mc_init: no grad calculated ', 0, RTDB_ERR)

c         write (iw,*) 'calculated gradinet?'
c         if (thr.eq.'mp2') then
c             theory='mp2:nonseparable gradient'
c         endif
         if (.not. rtdb_get(rtdb,theory,mt_dbl,3*natom, dbl_mb(force)))
     &       call errquit('mc_grad: no grad stored ', 0, RTDB_ERR)

         do k=1,3*natom
            if (abs(dbl_mb(force+k-1)).lt.tolg) then
              dbl_mb(force+k-1)=0.0
            endif
         enddo 
c         write(iw,*) "MC-init IRC: force is:"
c         call printcoord(iw,natom,dbl_mb(force),byte_mb(tag))
         do ivib=1,3*natom
            if (dbl_mb(i_eval+ivib-1).gt.-0.1) then
                vau=0.0
            else
                vau=gks_gasdev(gseed)*sqrt(kb*temp)
                if(ivib.eq.1) vau=abs(vau) 
                vau=vau*(unitt/unitl/sqrt(uma))
c                vau=0.005449
            endif
c            write(iw,*) 'For ivib IRC:',ivib,' vau is: ', vau
            do k=1,3*natom
               dbl_mb(vel+k-1) =
     &            dbl_mb(vel+k-1)
     &          + dbl_mb(i_evec+(ivib-1)*3*natom+k-1)*vau
            enddo
         enddo
         if(dbug) then
           write(iw,*) 'IRC Velocities:'
              call printcoord(iw,natom,dbl_mb(vel),byte_mb(tag))
         endif
c----- set the  acceleration
         do k=1,natom
            do l=1,3
            dbl_mb(acc+(k-1)*3+l-1) =
     &          -dbl_mb(force+(k-1)*3+l-1)/dbl_mb(mass+k-1)
            enddo
         enddo

         if(dbug) then
           write(iw,*) 'IRC Mass '
           do k=1,natom
               write(iw,*) dbl_mb(mass+k-1)
           enddo
           write(iw,*) 'IRC Force '
           do k=1,natom
            do l=1,3
              write(iw,*) -dbl_mb(force+(k-1)*3+l-1)
            enddo
           enddo
           write(iw,*) 'IRC Force 2'

           do l=1,3*natom
              write(iw,*) -dbl_mb(force+l-1)
           enddo

           write(iw,*) 'IRC Acceleration:'
              call printcoord(iw,natom,dbl_mb(acc),byte_mb(tag))
         endif
      else 
c      write(*,*) 'in mc_init:naccept',naccept
      do i=1,naccept+1   ! loop over all of the initial structures
         pimg=0.0 
         do k=1,3*natom
           dbl_mb(c_start+k-1)=dbl_mb(c_array+(i-1)*3*natom+k-1)
         enddo
         if (.not. geom_cart_set(geom, natom, byte_mb(tag),
     &       dbl_mb(c_start), dbl_mb(charge)))
     &       call errquit('mc_init_putgeom: coord error',0,GEOM_ERR)

         if(.not.geom_rtdb_store(rtdb,geom,"geometry"))
     &       call errquit('mc_init: Failed to store geom to rtdb',0,
     &       RTDB_ERR)

C---- calculate the gradient to get the force for acceleration
         if (.not.grad(rtdb))
     &       call errquit('mc_init: no grad calculated ', 0, RTDB_ERR)

         if (.not. rtdb_get(rtdb,theory,mt_dbl,3*natom, dbl_mb(force)))
     &       call errquit('mc_grad: no grad stored ', 0, RTDB_ERR)

         do k=1,3*natom
            if (abs(dbl_mb(force+k-1)).lt.tolg) then
              dbl_mb(force+k-1)=0.0
            endif
         enddo 

C----- set the velocity and acc to zero
         do k=1,3*natom
             dbl_mb(vel+(i-1)*3*natom+k-1)=0.0
             dbl_mb(acc+(i-1)*3*natom+k-1)=0.0 
         enddo
c         write(*,*) "MC-init: temperature is:",temp  
         do ivib=1,3*natom
            vau=gks_gasdev(gseed)*sqrt(kb*temp)
            if (ivib.eq.1) then
                 vau=abs(vau)
                 pimg=vau
                 dbl_mb(prp+i-1)=pimg
            else if (abs(dbl_mb(i_eval+ivib-1)).lt.0.1.or.
     $      (ivib.eq.mode)) then
                vau=0.0
            else
c              write(iw,*) 'Before conversion vau is: ', vau
              vau=vau
            endif 
            vau=vau*(unitt/unitl/sqrt(uma))
C  the energy is multiplied by 3N-7 because it's 1 mode 
c            if (abs(dbl_mb(i_eval+ivib-1)).lt.0.1.or.
c     $      .not.(ivib.eq.mode)) then
c                vau=0.0
c            else
c                vau=gks_gasdev(gseed)*sqrt(kb*temp)
c                if (ivib.eq.1) then
c                    pimg=vau
c                    dbl_mb(prp+i-1)=pimg
c                endif
c                vau=(3*natom-7)*vau*(unitt/unitl/sqrt(uma))
c            endif
            if (vau.ne.0.0) then 
               write(iw,*) 'For i,ivib:',i,ivib,' vau is: ', vau
               write(iw,*) 'For i,ivib:',i,ivib,' pimg is: ', pimg
            endif
            do k=1,3*natom
               dbl_mb(vel+(i-1)*3*natom+k-1) = 
     &            dbl_mb(vel+(i-1)*3*natom+k-1)
     &          + dbl_mb(i_evec+(ivib-1)*3*natom+k-1)*vau
            enddo
         enddo
         if(dbug) then
           write(iw,*) 'Velocities:'
           do k=1,3*natom
              write(iw,*) dbl_mb(vel+(i-1)*3*natom+k-1)
           enddo 
           write(iw,*) 'PIMG= ',pimg
         endif
c----- set the  acceleration
         do k=1,natom
            do l=1,3
            dbl_mb(acc+(i-1)*3*natom+(k-1)*3+l-1) = 
     &          -dbl_mb(force+(k-1)*3+l-1)/dbl_mb(mass+k-1)
            enddo
         enddo 
         if(dbug) then
           write(iw,*) 'Acceleration:'
           do k=1,3*natom
              write(iw,*) dbl_mb(acc+(i-1)*3*natom+k-1) 
           enddo
         endif
C ---- end of setting
      enddo             
      endif
      if(dbug.and.(.not.ircflag)) then
        do i=1,naccept+1
         write(iw,*) 'Dbug Velocities:',i
         do k=1,3*natom
            write(iw,*) dbl_mb(vel+(i-1)*3*natom+k-1)
         enddo
         write(iw,*) 'Dbug Acceleration:',i
         do k=1,3*natom
            write(iw,*) dbl_mb(acc+(i-1)*3*natom+k-1)
         enddo
 
        enddo
      endif         
      if (.not. geom_destroy(geom))
     &   call errquit('mc_init:  geom_destroy failed',
     &   911,GEOM_ERR)

      end
C_CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c $Id: mc_init.F 21176 2011-10-10 06:35:49Z d3y133 $

c
c $Id: smd_leapf_shake.F 19707 2010-10-29 17:59:36Z d3y133 $
c

      subroutine smd_leapf_shake(natms,
     >                           ntcons,
     >                           tstep,
     >                           ekin,
     >                           mass,
     >                           icon1,
     >                           icon2,
     >                           consdist,
     >                           ncc,
     >                           nvv,
     >                           dcc,
     >                           nrij,
     >                           orij,
     >                           fff,
     >                           vvv,
     >                           ccc)

      implicit none
c
      integer natms
      integer ntcons
      double precision tstep
      double precision ekin
      double precision mass(natms)
      integer          icon1(ntcons)
      integer          icon2(ntcons)
      double precision consdist(ntcons)
      double precision ncc(3,natms),nvv(3,natms),dcc(3,natms)
      double precision nrij(3,ntcons),orij(3,ntcons)
      double precision fff(3,natms)
      double precision vvv(3,natms)
      double precision ccc(3,natms)

      integer i,j,it,maxit,iatm1,iatm2

      double precision   force,rma,rmb
      double precision   tmpvx,tmpvy,tmpvz
      double precision   tstepsq,rtstep,tol,mxdiff
      double precision   nrijsq,dijsq,diffsq,dotprod
      character*(42) pname

      pname = "smd_leapf_shake"
      write(*,*) "in "//pname

      ekin=0.0
      tstepsq=tstep**2
      rtstep=1.0/tstep
      tol=1.0d-8
      maxit=100
      mxdiff = 0.0d0


      do i=1,ntcons

       iatm1=icon1(i)
       iatm2=icon2(i)

       orij(1,i)=ccc(1,iatm1)-ccc(1,iatm2)
       orij(2,i)=ccc(2,iatm1)-ccc(2,iatm2)
       orij(3,i)=ccc(3,iatm1)-ccc(3,iatm2)

      enddo

      call smd_lat_rebox(ntcons,orij)

      do i=1,natms

       ncc(1,i)=ccc(1,i)
       ncc(2,i)=ccc(2,i)
       ncc(3,i)=ccc(3,i)

       nvv(1,i)=vvv(1,i)+fff(1,i)*tstep/mass(i)
       nvv(2,i)=vvv(2,i)+fff(2,i)*tstep/mass(i)
       nvv(3,i)=vvv(3,i)+fff(3,i)*tstep/mass(i)

       ccc(1,i)=ncc(1,i)+tstep*nvv(1,i)
       ccc(2,i)=ncc(2,i)+tstep*nvv(2,i)
       ccc(3,i)=ncc(3,i)+tstep*nvv(3,i)

      enddo 


      do i=1,maxit

       do j=1,ntcons

        iatm1=icon1(j)
        iatm2=icon2(j)

        nrij(1,j)=ccc(1,iatm1)-ccc(1,iatm2)
        nrij(2,j)=ccc(2,iatm1)-ccc(2,iatm2)
        nrij(3,j)=ccc(3,iatm1)-ccc(3,iatm2)

       enddo

       call smd_lat_rebox(ntcons,nrij) 

       do j=1,natms
        dcc(1,j)=0.0
        dcc(2,j)=0.0
        dcc(3,j)=0.0
       enddo

       do j=1,ntcons

        iatm1=icon1(j)
        iatm2=icon2(j)

        nrijsq=nrij(1,j)**2+nrij(2,j)**2+nrij(3,j)**2
        dijsq=consdist(j)**2
        diffsq=dijsq-nrijsq
        mxdiff=max(mxdiff,abs(diffsq)/consdist(j))

        dotprod=orij(1,j)*nrij(1,j)
     $         +orij(2,j)*nrij(2,j)
     $         +orij(3,j)*nrij(3,j)

        rma= tstepsq/mass(iatm1)
        rmb=-tstepsq/mass(iatm2)
        force=diffsq/(-2.0*(rma-rmb)*dotprod)

        dcc(1,iatm1)=dcc(1,iatm1)-rma*orij(1,j)*force
        dcc(2,iatm1)=dcc(2,iatm1)-rma*orij(2,j)*force
        dcc(3,iatm1)=dcc(3,iatm1)-rma*orij(3,j)*force
        dcc(1,iatm2)=dcc(1,iatm2)-rmb*orij(1,j)*force
        dcc(2,iatm2)=dcc(2,iatm2)-rmb*orij(2,j)*force
        dcc(3,iatm2)=dcc(3,iatm2)-rmb*orij(3,j)*force


       enddo

       do j=1,ntcons

        iatm1=icon1(j)
        iatm2=icon2(j)

        ccc(1,iatm1)=ccc(1,iatm1)+0.5*dcc(1,iatm1)
        ccc(2,iatm1)=ccc(2,iatm1)+0.5*dcc(2,iatm1)
        ccc(3,iatm1)=ccc(3,iatm1)+0.5*dcc(3,iatm1)
        ccc(1,iatm2)=ccc(1,iatm2)+0.5*dcc(1,iatm2)
        ccc(2,iatm2)=ccc(2,iatm2)+0.5*dcc(2,iatm2)
        ccc(3,iatm2)=ccc(3,iatm2)+0.5*dcc(3,iatm2)

       enddo

       mxdiff=mxdiff*0.5

       if(mxdiff.lt.tol)goto 100

      enddo

100   continue

      do i=1,natms

       nvv(1,i)=(ccc(1,i)-ncc(1,i))*rtstep
       nvv(2,i)=(ccc(2,i)-ncc(2,i))*rtstep
       nvv(3,i)=(ccc(3,i)-ncc(3,i))*rtstep

       tmpvx=0.5*(nvv(1,i)+vvv(1,i))
       tmpvy=0.5*(nvv(2,i)+vvv(2,i))
       tmpvz=0.5*(nvv(3,i)+vvv(3,i))

       ekin=ekin+mass(i)*(tmpvx**2+tmpvy**2+tmpvz**2)

       fff(1,i)=(nvv(1,i)-vvv(1,i))*mass(i)*rtstep
       fff(2,i)=(nvv(2,i)-vvv(2,i))*mass(i)*rtstep
       fff(3,i)=(nvv(3,i)-vvv(3,i))*mass(i)*rtstep

       vvv(1,i)=nvv(1,i)
       vvv(2,i)=nvv(2,i)
       vvv(3,i)=nvv(3,i)

      enddo


      ekin=0.5*ekin

      write(*,*) "out "//pname
    
      return

      END

*> \brief \b CPOTF2 computes the Cholesky factorization of a symmetric/Hermitian positive definite matrix (unblocked algorithm).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download CPOTF2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/cpotf2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/cpotf2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/cpotf2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CPOTF2( UPLO, N, A, LDA, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, N
*       ..
*       .. Array Arguments ..
*       COMPLEX            A( LDA, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CPOTF2 computes the Cholesky factorization of a complex Hermitian
*> positive definite matrix A.
*>
*> The factorization has the form
*>    A = U**H * U ,  if UPLO = 'U', or
*>    A = L  * L**H,  if UPLO = 'L',
*> where U is an upper triangular matrix and L is lower triangular.
*>
*> This is the unblocked version of the algorithm, calling Level 2 BLAS.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          Specifies whether the upper or lower triangular part of the
*>          Hermitian matrix A is stored.
*>          = 'U':  Upper triangular
*>          = 'L':  Lower triangular
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX array, dimension (LDA,N)
*>          On entry, the Hermitian matrix A.  If UPLO = 'U', the leading
*>          n by n upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading n by n lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>
*>          On exit, if INFO = 0, the factor U or L from the Cholesky
*>          factorization A = U**H *U  or A = L*L**H.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -k, the k-th argument had an illegal value
*>          > 0: if INFO = k, the leading minor of order k is not
*>               positive definite, and the factorization could not be
*>               completed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complexPOcomputational
*
*  =====================================================================
      SUBROUTINE CPOTF2( UPLO, N, A, LDA, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
      COMPLEX            CONE
      PARAMETER          ( CONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME, SISNAN
      COMPLEX            CDOTC
      EXTERNAL           LSAME, CDOTC, SISNAN
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMV, CLACGV, CSSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, REAL, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CPOTF2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Compute the Cholesky factorization A = U**H *U.
*
         DO 10 J = 1, N
*
*           Compute U(J,J) and test for non-positive-definiteness.
*
            AJJ = REAL( A( J, J ) ) - CDOTC( J-1, A( 1, J ), 1,
     $            A( 1, J ), 1 )
            IF( AJJ.LE.ZERO.OR.SISNAN( AJJ ) ) THEN
               A( J, J ) = AJJ
               GO TO 30
            END IF
            AJJ = SQRT( AJJ )
            A( J, J ) = AJJ
*
*           Compute elements J+1:N of row J.
*
            IF( J.LT.N ) THEN
               CALL CLACGV( J-1, A( 1, J ), 1 )
               CALL CGEMV( 'Transpose', J-1, N-J, -CONE, A( 1, J+1 ),
     $                     LDA, A( 1, J ), 1, CONE, A( J, J+1 ), LDA )
               CALL CLACGV( J-1, A( 1, J ), 1 )
               CALL CSSCAL( N-J, ONE / AJJ, A( J, J+1 ), LDA )
            END IF
   10    CONTINUE
      ELSE
*
*        Compute the Cholesky factorization A = L*L**H.
*
         DO 20 J = 1, N
*
*           Compute L(J,J) and test for non-positive-definiteness.
*
            AJJ = REAL( A( J, J ) ) - CDOTC( J-1, A( J, 1 ), LDA,
     $            A( J, 1 ), LDA )
            IF( AJJ.LE.ZERO.OR.SISNAN( AJJ ) ) THEN
               A( J, J ) = AJJ
               GO TO 30
            END IF
            AJJ = SQRT( AJJ )
            A( J, J ) = AJJ
*
*           Compute elements J+1:N of column J.
*
            IF( J.LT.N ) THEN
               CALL CLACGV( J-1, A( J, 1 ), LDA )
               CALL CGEMV( 'No transpose', N-J, J-1, -CONE, A( J+1, 1 ),
     $                     LDA, A( J, 1 ), LDA, CONE, A( J+1, J ), 1 )
               CALL CLACGV( J-1, A( J, 1 ), LDA )
               CALL CSSCAL( N-J, ONE / AJJ, A( J+1, J ), 1 )
            END IF
   20    CONTINUE
      END IF
      GO TO 40
*
   30 CONTINUE
      INFO = J
*
   40 CONTINUE
      RETURN
*
*     End of CPOTF2
*
      END
c $Id: cpotf2.f 24343 2013-06-22 05:35:15Z d3y133 $

*
*     $Id: c_cgminimize.F 24489 2013-08-08 20:12:41Z bylaska $                       
*


*  ************************************************************
*  *                MPI cgminimize routine                    *
*  *               (Fletcher-Reeves' steps)                   *
*  *                                                          *
*  *  This is a developing cgsdv3 parallel code wrtten for    *
*  *  NWChem                                                  *
*  *                                                          *
*  ************************************************************
  
      subroutine c_cgminimize(E,deltae,deltac,current_iteration,it_in)
      implicit none
      real*8     E(*)
      real*8     deltae,deltac
      integer    current_iteration
      integer    it_in

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****

      real*8  deltat_min
      parameter (deltat_min=1.0d-3)
       
c      complex*16 H0(nfft3d,nemax)
c      complex*16 G1(nfft3d,nemax)
      integer H0_tag,G0_tag,G1_tag
      real*8  E0,dE0

      real*8     sum0,sum1,scale,tole,tolc
      real*8     ehartree,eorbit,exc,pxc,eion
      real*8     Enew,Eold,Estart
      common / c_cgsd_block / Enew,Eold,Estart

      integer it
      real*8 tmin,deltat
      real*8 max_sigma,ehfx,phfx

      integer ispin,ne(2)
      integer neall,nfft3d,npack1,nbrill

*     **** external functions ****
      logical  band_hfx
      integer  cpsi_neq,control_version,cpsi_ispinq,cpsi_nbrillq
      integer  cpsi_data_push_stack
      real*8   control_tole,control_tolc
      real*8   cpsi_geodesic_energy
      real*8   cpsi_geodesic_denergy
      real*8   c_rho_error
      real*8   c_dng_1ehartree
      real*8   cpsi_1ke
      real*8   cpsi_1vl
      real*8   cpsi_1vnl
      real*8   cpsi_1vnlso
      real*8   c_rho_1exc
      real*8   c_rho_1pxc
      real*8   ewald_e
      real*8   cpsi_1eorbit
      real*8   linesearch
      external band_hfx
      external cpsi_neq,control_version,cpsi_ispinq,cpsi_nbrillq
      external cpsi_data_push_stack
      external control_tole,control_tolc
      external cpsi_geodesic_energy
      external cpsi_geodesic_denergy
      external c_rho_error
      external c_dng_1ehartree
      external cpsi_1ke
      external cpsi_1vl
      external cpsi_1vnl
      external c_rho_1exc
      external c_rho_1pxc
      external ewald_e
      external cpsi_1eorbit
      external linesearch
      real*8   ion_disp_energy
      external ion_disp_energy
      logical  ion_disp_on
      external ion_disp_on
       
  
      call C3dB_nfft3d(1,nfft3d)
      call Cram_max_npack(npack1)
      ispin  = cpsi_ispinq()
      ne(1)  = cpsi_neq(1)
      ne(2)  = cpsi_neq(2)
      neall  = ne(1)+ne(2)
      nbrill = cpsi_nbrillq()


*     **** allocate H0, G0, and G1 ****
      H0_tag = cpsi_data_push_stack(nbrill,neall,2*npack1)
c      G0_tag = cpsi_data_push_stack(nbrill,neall,2*npack1)
      G1_tag = cpsi_data_push_stack(nbrill,neall,2*npack1)

      Estart = Enew
      Eold   = Enew

*     ***** get the initial gradient and direction ****
      call cpsi_1get_Tgradient(G1_tag,E0)

      call Pneb_ff_traceall_tag(0,0,G1_tag,G1_tag,sum1)

      call BGrsm_ff_Copy_tag(G1_tag,H0_tag)


*     ******************************************
*     ****                                  ****
*     **** Start of conjugate gradient loop ****
*     ****                                  ****
*     ******************************************

      tole  = control_tole()
      tolc  = control_tolc()
      tmin  = deltat_min

      do it=2,it_in

*        **** initialize the geoedesic line data structure ****
         call c_geodesic_start(H0_tag,max_sigma,dE0)


*        ******* line search *********
         if (tmin.gt.0.0d0) then
            deltat = tmin
         else
            deltat = deltat_min
         end if

         Enew = linesearch(0.0d0,E0,dE0,deltat,
     >                        cpsi_geodesic_energy,
     >                        cpsi_geodesic_denergy,
     >                        tole,tmin,deltae,1)

c         write(*,*)'e0= ',e0
c         write(*,*)'de0 = ',de0
c         write(*,*)'tmin = ',tmin
c         call flush(6)
         call cpsi_geodesic_final(tmin)

         deltac = c_rho_error()

*        **** exit loop early ****
         if ((dabs(deltae).lt.tole).and.(deltac.lt.tolc)) 
     >      go to 30
     
   

*        **** transport the previous search directions ****
c         call BGrsm_ff_Copy_tag(G1_tag,G0_tag)

         call cpsi_1geodesic_transport( tmin,H0_tag)
c         call cpsi_1geodesic_Gtransport(tmin,G0_tag)

*        **** make psi1 <--- psi2(tmin) ****
         call cpsi_2to1()

*        **** get the new gradient - also updates densities****
         call cpsi_1get_Tgradient(G1_tag,E0)

c         call BGrsm_fff_Sub_tag(G1_tag,G0_tag,G0_tag)

         sum0  = sum1

         call Pneb_ff_traceall_tag(0,0,G1_tag,G1_tag,sum1)

*        **** the new direction using Fletcher-Reeves ****
         if ( (dabs(deltae).le.(1.0d-2)).and.
     >        (tmin.gt.deltat_min)) then

           if (sum0.gt.1.0d-15) then
              scale = sum1/sum0
           else
              scale = 0.0d0
           end if

           call BGrsm_f_dscale_tag(scale,H0_tag)

           call BGrsm_fff_sum_tag(G1_tag,H0_tag,H0_tag)

*        **** the new direction using steepest-descent ****
         else
              call BGrsm_ff_Copy_tag(G1_tag,H0_tag)

         end if

      end do

*     **** initialize the geoedesic line data structure ****

      call c_geodesic_start(H0_tag,max_sigma,dE0)

*     ******* line search *********
      if (tmin.gt.0.0d0) then
         deltat = tmin
      else
         deltat = deltat_min
      end if

      Enew = linesearch(0.0d0,E0,dE0,deltat,
     >                        cpsi_geodesic_energy,
     >                        cpsi_geodesic_denergy,
     >                        tole,tmin,deltae,1)

      call cpsi_geodesic_final(tmin)

      deltac = c_rho_error()

*     **** free memory ****
  30  call cpsi_data_pop_stack(G1_tag)
c      call cpsi_data_pop_stack(G0_tag)
      call cpsi_data_pop_stack(H0_tag)

      call cpsi_2to1()
      call cpsi_1toelectron() 
      call cpsi_check()

      eion     = ewald_e()
      eorbit   = cpsi_1eorbit()
      ehartree = c_dng_1ehartree()
      exc      = c_rho_1exc()
      pxc      = c_rho_1pxc()

      E(1)  = Enew + eion
      E(2)  = eorbit
      E(3)  = ehartree
      E(4)  = exc
      E(5)  = eion
      E(6)  = cpsi_1ke()
      E(7)  = cpsi_1vl()
      E(8)  = cpsi_1vnl()
      E(9)  = 2.0d0*ehartree
      E(10) = pxc
      E(11) = cpsi_1vnlso()  

*     **** HFX terms ****
      if (band_HFX()) then
         call c_electron_HFX_energies(ehfx,phfx)
         E(26) = ehfx
         E(27) = phfx
      end if

*     **** Dispersion energy ****
      if (ion_disp_on()) then
         E(33) = ion_disp_energy()
         E(1)  = E(1) + E(33)
      end if

      return
      end
 

      subroutine argos_cafe(lself,lpbcs,
     + xw,xwm,fw,zwi,rtos,iwdt,iwz,
     + iwfr,iwto,jwfr,jwto,xs,xsm,fs,zs,
     + isga,isat,isdt,isgr,ismf,isml,isss,isq1,isq2,isq3,isgm,ishop,isz,
     + isfr,isto,jsfr,jsto,lpbc,lstptr,lupden,eww,esw,ess,fss,esa,
     + lseq,lforce)
c
c     in     log : lself           : true for box self interactions
c     in     r*8 : xw(mwm,3,mwa)   : solvent coordinates
c     in     r*8 : xwm(mwm,3)      : solvent molecule center of mass coordinates
c     in/out r*8 : fw(nwm,3,mwa,2) : solvent forces
c     out    r*8 : rtos(mwm)       : solvent distances to closes solute atom
c     in     int : iwdt(mwm)       : solvent dynamics type
c     out    int : iwz(mwm)        : solvent boundary type
c     in     int : iwfr,iwto       : first and last solvent molecule i
c     in     int : jwfr,jwto       : first and last solvent molecule j
c     in     r*8 : xs(msa,3)       : solute atom coordinates
c     in     r*8 : xsm(msm,3)      : solute molecule center of mass coordinates
c     in/out r*8 : fs(msa,3,2)     : solute forces
c     out    r*8 : zs(msm,3)       : solute virial
c     in     int : isga(msa)       : solute global atom number
c     in     int : isat(msa)       : solute atom type
c     in     int : isdt(msa)       : solute dynamics type
c     in     int : isgr(msa)       : solute charge group
c     in     int : ismf(msa)       : solute molecule fraction
c     in     int : isml(msa)       : solute molecule
c     in     int : isss(msa)       : solute separation shifted scaling type
c     in     int : isq1(msa)       : solute charge type 1
c     in     int : isq2(msa)       : solute charge type 2
c     in     int : isq3(msa)       : solute charge type 3
c     out    int : isz(msa)        : solute boundary type
c     in     int : isfr,isto       : first and last solute atom i
c     in     int : jsfr,jsto       : first and last solute atom j
c     in     log : lpbc            : flag for periodic boundary conditions
c     in/out int : lstptr          : list pointer
c     in/out r*8 : eww(mpe,2)      : mpe=1 solvent bond energy
c                                        2 solvent angle energy
c                                        3 solvent torsion energy
c                                        4 solvent improper energy
c                                        5 solvent van der Waals energy
c                                        6 solvent electrostatic energy
c                                        7 solvent potential energy
c                  eswl(msf,2)     : solute-solvent van der Waals energy
c     in/out r*8 : eswq(msf,2)     : solute-solvent electrostatic energy
c     in/out r*8 : essl(msf,msf,2) : solute-solute van der Waals energy
c     in/out r*8 : essq(msf,msf,2) : solute-solute electrostatic energy
c     in/out r*8 : essr(msf,msf,2) : solute-solute reaction field energy
c     in/out r*8 : esp(msf,2)      : solute potential energy
c     in/out r*8 : esb(msf,2)      : solute bond energy
c     in/out r*8 : esh(msf,2)      : solute angle energy
c     in/out r*8 : esd(msf,2)      : solute torsion energy
c     in/out r*8 : eso(msf,2)      : solute improper energy
c     in     log : lupden          : update bonded energy contrbutions
c
c     dimensions nwm,nwa and nsa need to have been given by a call to argos_cafe_initx
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      real*8 xw(mwm,3,mwa),xwm(mwm,3),fw(mwm,3,mwa,2),zwi(3,3,2)
      real*8 xs(msa,3),xsm(msm,3),fs(msa,3,2)
      integer iwdt(mwm),iwz(mwm),isz(msa)
      integer isga(msa),isat(msa),isdt(msa),isgr(msa),ismf(msa)
      integer isml(msa),isss(msa),isq1(msa),isq2(msa),isq3(msa)
      integer isgm(msa),ishop(msa)
      integer lseq(mseq)
      integer iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto
      integer lstptr
      logical lself,lpbc,lupden,lpbcs,lforce
      real*8 rtos(mwm),zs(msf,3,32)
      real*8 eww(mpe,2),esw(msf,mpe,2),ess(msf,msf,mpe,2),esa(nsa)
      real*8 fss(msf,msf,3,2)
c
      integer nwloc,nsloc,nwnon,nsnon,npairs
      integer lptr
      integer i,j
c
c      print*,'CAFE forces'
c
      do 1 j=1,2
      do 2 i=1,3
      zw(1,i,j)=zwi(1,i,j)
      zw(2,i,j)=zwi(2,i,j)
      zw(3,i,j)=zwi(3,i,j)
    2 continue
    1 continue
c
      if(lself) then
      jwfr=iwfr
      jwto=iwto
      jsfr=isfr
      jsto=isto
      endif
c
      nwloc=iwto-iwfr+1
      if(iwfr.eq.0.or.iwto.lt.iwfr) nwloc=0
      nwnon=jwto-jwfr+1
      if(jwfr.eq.0.or.jwto.lt.jwfr) nwnon=0
      nsloc=isto-isfr+1
      if(isfr.eq.0.or.isto.lt.isfr) nsloc=0
      nsnon=jsto-jsfr+1
      if(jsfr.eq.0.or.jsto.lt.jsfr) nsnon=0
c
c     list [ list(1)=int_mb(lptr) ] with offset ndxp
c
c     list( 1) : index to pairlist for solvent-solvent
c     list( 2) : index to pairlist for solute-solvent
c     list( 3) : index to pairlist for solvent-solute
c     list( 4) : index to pairlist for solute-solute
c     list( 5) : index to pairlist for solute bonds
c     list( 6) : index to pairlist for solute angles
c     list( 7) : index to pairlist for solute dihedrals
c     list( 8) : index to pairlist for solute impropers
c     list( 9) : index to pairlist for solute third neighbors
c     list(10) : index to pairlist for solute excluded pairs
c
c
c     pairlists
c     ---------
c
      if(lpair) call argos_pairs(lself,lpbcs,xw,xwm,iwdt,iwz,
     + iwfr,iwto,jwfr,jwto,xs,xsm,
     + isga,isat,isdt,isgr,isgm,ismf,isml,isss,isq1,isq2,isq3,ishop,isz,
     + isfr,isto,jsfr,jsto,lpbc,lstptr,lseq)
c
      if(.not.lforce) return
c
c     forces
c     ------
c
      ndxp=lstptr
      lptr=i_list+ndxp+24
c
      if(lself.and.nwloc.gt.0) then
      call argos_cafe_fw(iwfr,iwto,xw,fw,iwdt,int_mb(i_iwa),
     + int_mb(i_iwq),
     + lpbc,eww,dbl_mb(i_vdw),dbl_mb(i_chg),mbt(1),numb(1),mbp(1),
     + int_mb(i_ibnd(1)),dbl_mb(i_bnd(1)),dbl_mb(i_rbnd(1)),
     + mht(1),numh(1),mhp(1),
     + int_mb(i_iang(1)),dbl_mb(i_ang(1)),dbl_mb(i_rang(1)),
     + dbl_mb(i_rub(1)),
     + mdt(1),numd(1),mdp(1),
     + int_mb(i_idih(1)),dbl_mb(i_dih(1)),dbl_mb(i_rdih(1)),
     + mit(1),numi(1),mip(1),
     + int_mb(i_iimp(1)),dbl_mb(i_imp(1)),dbl_mb(i_rimp(1)),
     + mtt(1),numt(1),int_mb(i_itrd(1)),
     + mxt(1),numx(1),int_mb(i_ixcl(1)))
      endif
c
c     solvent-solvent forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fww(xw,xwm,fw,iwdt,iwfr,nwloc,lpbc,eww,
     + dbl_mb(i_vdw),dbl_mb(i_chg),int_mb(i_iwa),int_mb(i_iwq),
     + int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nwloc),int_mb(lptr+1+4*nwloc),
     + dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r1),dbl_mb(i_s1r1),
     + dbl_mb(i_s1r2),dbl_mb(i_s1r3),dbl_mb(i_s3r2),dbl_mb(i_s1r4),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_s1r5))
      lptr=lptr+4*nwloc+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute-solvent forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fsw(xs,xsm,fs,zs,isga,isat,isdt,ismf,isml,isss,
     + isq1,isfr,nsloc,
     + xw,xwm,fw,rtos,iwdt,lpbc,lpbcs,esw,esa,
     + dbl_mb(i_vdw),dbl_mb(i_chg),int_mb(i_iwa),int_mb(i_iwq),
     + int_mb(i_ias),int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nsloc),int_mb(lptr+1+4*nsloc),
     + dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r1),dbl_mb(i_s1r1),
     + dbl_mb(i_s1r2),dbl_mb(i_s1r3),dbl_mb(i_s3r2),dbl_mb(i_s1r4),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_s1r5),dbl_mb(i_s1r6),
     + int_mb(i_s1i1),int_mb(i_s1i2),int_mb(i_s1i3),dbl_mb(i_sti))
      lptr=lptr+4*nsloc+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solvent-solute forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fsw(xs,xsm,fs,zs,isga,isat,isdt,ismf,isml,isss,
     + isq1,jsfr,nsnon,
     + xw,xwm,fw,rtos,iwdt,lpbc,lpbcs,esw,esa,
     + dbl_mb(i_vdw),dbl_mb(i_chg),int_mb(i_iwa),int_mb(i_iwq),
     + int_mb(i_ias),int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nsnon),int_mb(lptr+1+4*nsnon),
     + dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r1),dbl_mb(i_s1r1),
     + dbl_mb(i_s1r2),dbl_mb(i_s1r3),dbl_mb(i_s3r2),dbl_mb(i_s1r4),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_s1r5),dbl_mb(i_s1r6),
     + int_mb(i_s1i1),int_mb(i_s1i2),int_mb(i_s1i3),dbl_mb(i_sti))
      lptr=lptr+4*nsnon+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute-solute forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fss(xs,xsm,fs,zs,isga,isat,isdt,ismf,isml,isss,
     + isq2,isq3,isgm,isfr,nsloc,lpbc,lpbcs,ess,fss,esa,
     + dbl_mb(i_vdw),dbl_mb(i_chg),
     + int_mb(i_ias),int_mb(i_s2i1),
     + int_mb(lptr+1),int_mb(lptr+1+2*nsloc),int_mb(lptr+1+4*nsloc),
     + dbl_mb(i_smr1),dbl_mb(i_smr2),dbl_mb(i_s3r1),dbl_mb(i_s1r1),
     + dbl_mb(i_s1r2),dbl_mb(i_s1r3),dbl_mb(i_s3r2),dbl_mb(i_s1r4),
     + dbl_mb(i_smr3),dbl_mb(i_smr4),dbl_mb(i_s1r5),dbl_mb(i_s1r6),
     + int_mb(i_s1i1),int_mb(i_s1i2),int_mb(i_s1i3),int_mb(i_s1i4),
     + int_mb(i_s1i5),dbl_mb(i_smr5),dbl_mb(i_smr6),dbl_mb(i_sti),
     + int_mb(i_lda),dbl_mb(i_rda),dbl_mb(i_uda),int_mb(i_lseq))
      lptr=lptr+4*nsloc+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute bond forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fsb(npairs,int_mb(lptr+1),mbt(2),mbp(2),
     + int_mb(i_ibnd(2)),dbl_mb(i_bnd(2)),dbl_mb(i_rbnd(2)),
     + max(isto,jsto),msa,isga,isgm,ismf,isdt,isq1,dbl_mb(i_chg),
     + xs,fs,ess,lpbc,lpbcs,lupden,.true.,dbl_mb(i_sti),int_mb(i_lseq))
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute angle forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fsh(npairs,int_mb(lptr+1),mht(2),mhp(2),
     + int_mb(i_iang(2)),dbl_mb(i_ang(2)),dbl_mb(i_rang(2)),
     + dbl_mb(i_rub(2)),
     + max(isto,jsto),msa,isga,isgm,ismf,isdt,isq1,dbl_mb(i_chg),
     + xs,fs,ess,lpbc,lpbcs,lupden,.true.,dbl_mb(i_sti),int_mb(i_lseq))
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute torsion forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fsd(npairs,int_mb(lptr+1),mdt(2),mdp(2),
     + int_mb(i_idih(2)),dbl_mb(i_dih(2)),dbl_mb(i_rdih(2)),
     + max(isto,jsto),msa,isga,isgm,ismf,isdt,
     + xs,fs,ess,lpbc,lpbcs,lupden,.true.,dbl_mb(i_sti),int_mb(i_lseq))
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute improper dihedral forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fso(npairs,int_mb(lptr+1),mit(2),mip(2),
     + int_mb(i_iimp(2)),dbl_mb(i_imp(2)),dbl_mb(i_rimp(2)),
     + max(isto,jsto),msa,isga,isgm,ismf,isdt,
     + xs,fs,ess,lpbc,lpbcs,lupden,.true.,dbl_mb(i_sti),int_mb(i_lseq))
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
c     solute third neighbor forces
c
      npairs=int_mb(lptr)
      if(npairs.gt.0) then
      call argos_cafe_fst(npairs,int_mb(lptr+1),mtt(2),
     + int_mb(i_itrd(2)),
     + dbl_mb(i_vdw),dbl_mb(i_chg),
     + max(isto,jsto),msa,isat,isga,isgm,ismf,isdt,isq3,isss,
     + xs,fs,ess,lpbc,lpbcs,dbl_mb(i_sti),esa,int_mb(i_lseq))
      lptr=lptr+1+npairs
      else
      lptr=lptr+1
      endif
c
      ndxp=lptr-i_list
c
      do 3 j=1,2
      do 4 i=1,3
      zwi(1,i,j)=zw(1,i,j)
      zwi(2,i,j)=zw(2,i,j)
      zwi(3,i,j)=zw(3,i,j)
    4 continue
    3 continue
c
      return
      end
c $Id: argos_cafe.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_pme_selnod(value,target,nodep,knode,
     + kfrom,kto,map)
c
      implicit none
c
#include "argos_pme_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      real*8 value,target(np)
      integer nodep(nodpme),knode(ngz),kfrom(np),kto(np),map(np)
c
      integer i,j,k,npls,nlnd
#if defined(ESSL) && defined(LAPI)
      integer number,npr,npc,myr,myc
      integer icntxt,lfftok
#endif
c
c     select nodes with minimum value to be used for pme/fft
c
      do 1 i=1,np
      target(i)=zero
    1 continue
      target(me+1)=value
      call ga_dgop(mrp_d01,target,np,'+')
c
      do 2 i=1,np
      nodep(i)=i
    2 continue
      do 3 i=1,np-1
      do 4 j=i+1,np
      if(target(i).lt.target(j)) then
      k=nodep(i)
      nodep(i)=nodep(j)
      nodep(j)=k
      endif
    4 continue
    3 continue
      do 5 i=1,np
      nodep(i)=nodep(i)-1
    5 continue
      do 6 i=1,nodpme-1
      do 7 j=i+1,nodpme
      if(nodep(i).gt.nodep(j)) then
      k=nodep(i)
      nodep(i)=nodep(j)
      nodep(j)=k
      endif
    7 continue
    6 continue
c
      call ga_brdcst(mrp_i01,nodep,nodpme*ma_sizeof(mt_int,1,mt_byte),0)
c
c     for node i: kfrom(i) is the first grid point in the z direction
c     for node i: kto(i)   is the last  grid point in the z direction
c
      do 8 i=1,np
      kfrom(i)=0
      kto(i)=0
    8 continue
c
      npls=(ngz/nodpme)+1
      nlnd=mod(ngz,nodpme)
      kfrom(nodep(1)+1)=1
      do 9 i=1,nodpme
      if(i.eq.nlnd+1) npls=npls-1
      kto(nodep(i)+1)=kfrom(nodep(i)+1)+npls-1
      if(i.lt.nodpme) kfrom(nodep(i+1)+1)=kto(nodep(i)+1)+1
    9 continue
c
      if(kto(nodep(nodpme)+1).ne.ngz)
     + call md_abort('Error in argos_pme_select',me)
      kto(nodep(nodpme)+1)=ngz
c
c     for point i in the z direction: knode(i) is the owning node
c     ngzloc is the number of points in the z direction on this node
c
      j=1
      ngzloc=0
      do 10 i=1,ngz
      if(i.gt.kto(nodep(j)+1)) j=j+1
      knode(i)=nodep(j)
      if(nodep(j).eq.me) ngzloc=ngzloc+1
   10 continue
c
      lpnode=.false.
      do 11 i=1,nodpme
      if(me.eq.nodep(i)) lpnode=.true.
   11 continue
c
#if defined(ESSL) && defined(LAPI)
c
c     setup process grid for pessl grid
c
      if(imfft.eq.2) then
c
      if(lfftok.gt.0) then
      call blacs_gridexit(icntxt)
      else
      call blacs_pinfo(myr,myc)
      if(me.ne.myr) call md_abort('Identity crisis',me)
      if(np.ne.myc) call md_abort('Node count inconsistent',me)
      endif
c
      do 12 i=1,np
      map(i)=-1
   12 continue
      number=1
      do 13 i=1,ngz
      if(map(number).lt.0) then
      map(number)=knode(i)
      elseif(map(number).ne.knode(i)) then
      number=number+1
      map(number)=knode(i)
      endif
   13 continue
      if(number.ne.nodpme) call md_abort('Node assignment problem',me)
c
      call blacs_get(0,0,icntxt)
c
      call blacs_gridmap(icntxt,map,1,1,nodpme)
      call blacs_gridinfo(icntxt,npr,npc,myr,myc)
c
      if(lpnode.and.(myr.ge.npr.or.myc.ge.npc)) then
      call md_abort('arg_fft3d: fft initialization failed',me)
      endif
c
      endif
c
#endif
c
      return
      end
c $Id: argos_pme_selnod.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_diana_equitors(iequi,imol,idtors)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer iequi(msa),imol(msa)
      integer i,j,last,idtors
c
      last=ntors
c
      do 1 i=2,4
      if(imol(itors(ntors,i,1)).ne.imol(itors(ntors,1,1))) return
    1 continue
c
    2 continue
      do 3 i=1,4
      if(iequi(itors(ntors,i,1)).eq.0) goto 9
    3 continue
c
      ntors=ntors+1
      itors(ntors,1,3)=idtors
      if(ntors.gt.mxtors) call md_abort('Increase dimension mxtors',0)
c
      do 4 i=1,4
      itors(ntors,i,1)=iequi(itors(ntors-1,i,1))
      itors(ntors,i,2)=0
    4 continue
      goto 2
c
    9 continue
      return
      end
c $Id: argos_diana_equitors.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine tce_diis_tidy
c
c $Id: tce_diis_tidy.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Terminates the DIIS
c
      implicit none
#include "tce_diis.fh"
      integer i
c
      do i = 1,maxdiis
        if (t1_diis_exist(i))
     1    call deletefile(t1_diis(i)) 
        if (r1_diis_exist(i))
     1    call deletefile(r1_diis(i)) 
        if (t2_diis_exist(i))
     1    call deletefile(t2_diis(i)) 
        if (r2_diis_exist(i))
     1    call deletefile(r2_diis(i)) 
        if (t3_diis_exist(i))
     1    call deletefile(t3_diis(i)) 
        if (r3_diis_exist(i))
     1    call deletefile(r3_diis(i)) 
        if (t4_diis_exist(i))
     1    call deletefile(t4_diis(i)) 
        if (r4_diis_exist(i))
     1    call deletefile(r4_diis(i)) 
      enddo
      return
      end

      subroutine init70
c $Id: init70.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
c
c     called once by genr70 to initialize internal data
c     structures for the rotated axis integrals
c
#include "maxc.fh"
#include "auxvar.fh"
#include "picon.fh"
      double precision pi
c
      pidiv4 = atan(1.0d0)
      pi = 4.0d0*pidiv4
      pito52 = 2.0d0*pi**2.5d0
      root3 = sqrt(3.0d0)
      root5 = sqrt(5.0d0)
c
c     Generate tables for evaluation of incomplete gamma function
c
      call tabgen
c
c     Error2 and error1 control the accuracy of 2-e integrals.
c     For use in energy expressions 10^-11 is appropriate.
c     For use in the Schwarz() screening 10^-22 is required.
c     
c     The routine int_sp_acc has been provided so that this
c     value can be changed according to circumstances.
c     
      error2 = 1.0d-22
      error1 = sqrt(error2)
      var(1) = 15.0d0
      var(2) = 5.0d0
c
      end
      subroutine int_sp_acc(tol)
c $Id: init70.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
#include "maxc.fh"
      double precision tol
c
      error2 = tol
      error1 = sqrt(error2)
c
      end

      SUBROUTINE ex_4char(iposition,irecord,word)

      implicit none

      integer i,iposition,irec_len

      character word*4,letter*1,irecord*1

      parameter(irec_len=100)

      dimension letter(0:3),irecord(irec_len)

      do i=0,3
        letter(i)=irecord(iposition+i)
      enddo

      word=letter(0)//letter(1)//letter(2)//letter(3)

      return

      END
c $Id: extrct_char.f 22502 2012-05-20 06:11:57Z d3y133 $

c
c $Id: mm_interface.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      subroutine mm_init(irtdb0)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
c
      integer irtdb0
c
      integer includ
      character*32 pname

      pname = "mm_init"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call timer_init()
      call mm_set_irtdb(irtdb0)
c
c     include fixed atoms
c     otherwise prrroblems
c     -------------------
      includ=1
      if(.not.rtdb_put(irtdb0,'md:includ',mt_int,1,includ))
     + call errquit('mm_init: Failed to set includ',0,
     &       RTDB_ERR)
c
      call md_rdinp()
      call md_start()

c     this call is very important
c
c     for some strange reasons md_sp() has to be called twice
c     to stabilize bqzone flag for waters (MV)
      call md_sp()
      call md_sp()
      if(qmmm_print_debug()) write(*,*) "out "//pname
c
      return
      end

      subroutine mm_set_restart_file(irtdb0,filename)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
c
      integer irtdb0
      character*(*) filename
c
      character*32 pname
      integer j
c
      pname = "mm_set_restart_file"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
c     set the name of the new restart file
c     ------------------------------------
      j = index(filename,'.rst')-1
      if(.not.rtdb_cput(irtdb0,'md:project',1,filename(1:j)))
     + call errquit(pname//'Failed to set md:project',0,
     +       RTDB_ERR)
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
c
      return
      end

      subroutine mm_set_top_file(filename)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "global.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
c
      character*(*) filename
c
      character*32 pname
      character*255 oldfile
      integer j
c
      pname = "mm_set_restart_file"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c      
      call mm_top_file(oldfile)     
c
c     copy new file over an old one
c     -----------------------------
      call util_file_name_resolve(filename,.false.)
      if(ga_nodeid().eq.0) then 
        write(*,*) "copying filename", filename
        call util_file_copy(filename(1:inp_strlen(filename)),
     >                      oldfile(1:inp_strlen(oldfile)))
      end if
      call ga_sync()
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
c
      return
      end

      subroutine mm_reload_rst(irtdb0,filename)
c     convenience routine to load
c     different restart file into qmmm simulations
c     irtdb0   - rtdb handle              [in]
c     filename - name of the restart file [in]
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "inp.fh"
c
      integer irtdb0
      character*(*) filename
c
      character*32 pname
      integer j
      character*255 filename0
      character*255 filcmd,filcmd0
c
      pname = "mm_reload_rst"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
c     get old restart filename
c     ------------------------
      filename0 = ' '
      call mm_restart_filename(filename0)
      j = index(filename0,'.rst')-1
      filcmd0 = filename0(1:j)//".cmd"
c 
c     now clean up all prior md stuff
c     ---------------------------------
      call md_finish()
c
c     set the name of the new restart file
c     ------------------------------------
      j = index(filename,'.rst')-1
      if(.not.rtdb_cput(irtdb0,'md:project',1,filename(1:j)))
     + call errquit(pname//'Failed to set md:project',0,
     +       RTDB_ERR)
      filcmd = filename(1:j)//".cmd"
c
c     make copy of cmd file
c     ---------------------
      if(ga_nodeid().eq.0) then
        call util_file_copy(filcmd0(1:inp_strlen(filcmd0)),
     >                      filcmd(1:inp_strlen(filcmd)))
      end if
      call ga_sync()
c
c     now initialize md structures again
c     ----------------------------------
      call mm_init(irtdb0)
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
c
      return
      end

      subroutine mm_reload_rst_default(irtdb0,filename)
c     convenience routine to load
c     restart file in perm directory into default restart file
c     irtdb0   - rtdb handle              [in]
c     filename - name of the restart file in the perm directory[in]
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "global.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
#include "inp.fh"
c
      integer irtdb0
      character*(*) filename
c
      character*32 pname
      character*255 filename0
      integer j
c
      pname = "mm_reload_rst_default"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
c     get default restart filename
c     ----------------------------
      filename0 = ' '
      call mm_restart_filename(filename0)
c
c     copy restart file to a default one
c     ---------------------------------
      call util_file_name_resolve(filename,.false.)
      if(ga_nodeid().eq.0) then 
        write(*,*) "copying filename", filename
        call util_file_copy(filename(1:inp_strlen(filename)),
     >                      filename0(1:inp_strlen(filename0)))
      end if
      call ga_sync()
      call mm_reload_rst(irtdb0,filename0)
c 
      if(qmmm_print_debug()) write(*,*) "out "//pname
c
      return
      end

      subroutine mm_write_restart()
      implicit none
c
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
c
      character*255 rfile
      integer lfnrst
      character*32 pname
c
      pname = "mm_write_restart"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      rfile = " "
      call util_file_name("rst", .false., .false., rfile)

      lfnrst = 54
      call md_wrtrst(lfnrst,rfile,.false.)
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_restart_filename_prefix(filename)
      implicit none
c
#include "util.fh"
#include "md_common.fh"
#include "inp.fh"
c
      character*(*) filename
      integer j

      j = index(filrst,'.rst')-1
      filename = filrst(1:j)
      end

      subroutine mm_restart_filename(filename)
      implicit none
c
#include "util.fh"
#include "md_common.fh"
#include "inp.fh"
c
      character*(*) filename

      filename = filrst
      end

      subroutine mm_trajectory_filename(filename)
      implicit none
c
#include "util.fh"
#include "md_common.fh"
#include "inp.fh"
c
      character*(*) filename

      filename = filtrj
      end

      subroutine mm_system_prefix(prefix)
      implicit none
c
#include "util.fh"
#include "md_common.fh"
#include "inp.fh"
c
      character*(*) prefix
      integer i

      i=index(filtop,'.top')-1
      prefix = filtop(1:i)
      end

      subroutine mm_top_file(filename)
      implicit none
c
#include "util.fh"
#include "md_common.fh"
#include "inp.fh"
c
      character*(*) filename

      filename = filtop
      end

      subroutine mm_set_qmmm(oqmmm)
      implicit none
c
#include "util.fh"
#include "md_common.fh"
#include "inp.fh"
c
      logical oqmmm
      lqmmm = oqmmm

      end

      subroutine mm_write_restart_named(rfile,lv)
      implicit none
c
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
c
      character*(*) rfile
      logical lv
c
      integer lfnrst
      character*32 pname
c
      pname = "mm_write_restart_named"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      lfnrst = 54
      call md_wrtrst(lfnrst,rfile,lv)
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_end()
      implicit none
#include "md_common.fh"
#include "qmmm.fh"
      character*32 pname
c
      pname = "mm_end"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c      call md_wrtrst(lfnrst,rfile,.false.)
c      call md_wrtrst(lfnqrs,filqrs,.false.)
      call md_finish()
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_write_restart_default()
      implicit none
#include "md_common.fh"
#include "qmmm.fh"
      character*32 pname
c
      pname = "mm_write_restart_default"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      call md_wrtrst(lfnrst,rfile,.false.)
      call md_wrtrst(lfnqrs,filqrs,.false.)
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_write_restart_default_dynamics()
      implicit none
#include "md_common.fh"
#include "qmmm.fh"
      character*32 pname
c
      pname = "mm_write_restart_default_dynamics"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      call md_wrtrst(lfnrst,rfile,.true.)
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_rewind_trajectory()
      implicit none
#include "md_common.fh"
#include "qmmm.fh"
      rewind(lfntrj)
      return
      end

      function mm_skip_frame(fn,n)
      implicit none
#include "md_common.fh"
#include "qmmm.fh"
      integer n,fn
      logical mm_skip_frame
      character*32 pname
c
      external sp_skip
      logical  sp_skip
c
      pname = "mm_skip_frame"
c
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      mm_skip_frame = sp_skip(fn,n)
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      function mm_read_frame(fn,n)
      implicit none
#include "md_common.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
#include "msgids.fh"
      integer n,fn
      logical mm_read_frame
      character*32 pname
c
      external sp_skip,sp_rdtrj
      logical  sp_skip,sp_rdtrj
c
      pname = "mm_read_frame"
c
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      if(n.gt.1) then
        mm_read_frame = sp_skip(fn,n-1)
        if(.not.mm_read_frame) return
      end if
      call ga_sync()
c 
c     note that lxw,..., are output flags indicating whether
c     corresponding quantites (coords, vel, ..)
c     were found/read from file
c     ------------------------------------------------------
      mm_read_frame = sp_rdtrj(fn,lxw,lvw,lfw,lxs,lvs,lfs,
     + stime,pres,temp,tempw,temps,
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_fw),
     + dbl_mb(i_xwcr),int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_fs),nwmloc,nsaloc)
c
      call ga_brdcst(msg_qmmm_misc,mm_read_frame,
     >               ma_sizeof(mt_log,1,mt_byte),0)
      call ga_sync()

      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_write_frame(fn)
      implicit none
#include "md_common.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
      integer fn
      character*32 pname
c
      pname = "mm_write_frame"
c
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
c     atom redistribution
c
      call sp_travel(box,dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_xwcr),
     + dbl_mb(i_gw),int_mb(i_iw),nwmloc,dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_gs),int_mb(i_is),nsaloc)

c      call md_sp()
c
c     here we writing only solvent and solute coords
c     we could also write out velocities,forces, etc
c     ----------------------------------------------
      call sp_wrttrj(fn,.true.,.false.,.false.,.true.,.false.,.false.,
     + stime,pres,temp,tempw,temps,
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_fw),
     + dbl_mb(i_xwcr),int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_fs))

      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_print_info()
      implicit none
#include "qmmm.fh"
#include "md_common.fh"
#include "mafdecls.fh"
c
      call prp_print()
c
c     print energies
c
      call cf_print_energy(lfnout)
c
      call sp_printf(filtop,lfntop,
     + int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_fs),npener,dbl_mb(i_esa))
c
      return
      end

      subroutine mm_task_sp()
      implicit none
#include "qmmm.fh"
#include "md_common.fh"
      character*32 pname
      pname = "mm_task_sp"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
c      lpair = .false.
c      llong = .false.
      call md_sp_qmmm()
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
      end

      subroutine mm_get_tot_nqm(nqm)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nqm
      character*32 pname
      pname = "mm_get_tot_nqm"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solute_tot_na_gen(nqm,mm_quant)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_tot_nact(nact)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nact,nacts,nactw
      character*32 pname
      pname = "mm_get_tot_nact"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solute_tot_nact(nacts)
      call mm_get_solvent_tot_nact(nactw)
      nact = nacts + nactw
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_tot_nact(nqm)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nqm
      character*32 pname
      pname = "mm_get_tot_nqm"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solute_tot_na_gen(nqm,mm_active)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_tot_nact(nqm)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nqm
      character*32 pname
      pname = "mm_get_tot_nqm"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solvent_tot_na_gen(nqm,mm_active_w)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_tot_nact_bqs(nqm)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nqm
      character*32 pname
      pname = "mm_get_tot_nqm"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solute_tot_na_gen(nqm,mm_active_bqs)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_tot_nlink(n)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer n
      character*32 pname
      pname = "mm_get_tot_nlink"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solute_tot_na_gen(n,mm_link)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_nqm(nqm)
      implicit none
c
#include "mafdecls.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nqm
      character*32 pname
      pname = "mm_get_nqm"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c

      call mm_get_solute_na_gen(nqm,mm_quant_link)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_tot_na_gen(na,mm_type)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "qmmm.fh"
c
      integer na
      logical mm_type
      external mm_type
      integer tmp(1)
      character*32 pname
      pname = "mm_get_solute_tot_na_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solute_na_gen(tmp(1),mm_type)
      call ga_igop(msg_qmmm_nqm,tmp,1,'+')
      na=tmp(1)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_na_gen(na,mm_type)
      implicit none
c
#include "mafdecls.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer i
      logical mm_type
      external mm_type

      integer na
      integer nsaloc
      character*32 pname

      pname = "mm_get_solute_na_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsaloc)
c
      na=0
      do i=1,nsaloc
        if(mm_type(i)) then
          na=na+1
        endif
      end do
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_tot_nbqw(nbq)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "qmmm.fh"
c
      integer nbq
      integer tmp(1)
      character*32 pname
      pname = "mm_get_tot_nbqw"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_nbqw(tmp(1))
      call ga_igop(msg_qmmm_nbqw,tmp,1,'+')
      nbq=tmp(1)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_tot_na_gen(na,mm_type)
      implicit none
c
#include "mafdecls.fh"
#include "msgids.fh"
#include "qmmm.fh"
c
      integer na
      logical mm_type
      external mm_type

      integer tmp(1)
      character*32 pname
      pname = "mm_get_solvent_na_gen"

      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_solvent_na_gen(tmp(1),mm_type)
      call ga_igop(msg_qmmm_nbqw,tmp,1,'+')
      na=tmp(1)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_na_gen(na,mm_type)
      implicit none
c
#include "mafdecls.fh"
#include "qmmm_params.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer na
      logical mm_type
      external mm_type
c
      integer i
      integer mwa
      integer nwmloc
      character*32 pname
      pname = "mm_get_solvent_na_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_mwa(mwa)
      call mm_get_nwmloc(nwmloc)

      na=0
      do i=1,nwmloc
        if(mm_type(i)) na=na+mwa
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_nbqw(nbq)
      implicit none
c
#include "mafdecls.fh"
#include "qmmm_params.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nbq
c
      integer i
      integer mwa
      integer nwmloc
      character*32 pname
      pname = "mm_get_nbqw"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_mwa(mwa)
      call mm_get_nwmloc(nwmloc)

      nbq=0
      do i=1,nwmloc
        if(mm_bqwzone(i)) nbq=nbq+mwa
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_tot_nbqs(nbq)
      implicit none
c
#include "mafdecls.fh"
#include "mm_utils.fh"
#include "qmmm.fh"
c
      integer nbq
      character*32 pname
      pname = "mm_get_tot_nbqs"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      call mm_get_solute_tot_na_gen(nbq,mm_bqzone)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_activate_bqszone()
      implicit none
c
#include "mafdecls.fh"
#include "qmmm_params.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
c
      integer i
      integer nsaloc
      integer nwmloc
      integer psz
      character*32 pname
      pname = "mm_activate_bqszone"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsaloc)
      call mm_get_nwmloc(nwmloc)
      call mm_get_psz(psz)

      do i=1,nsaloc
          int_mb(psz+i-1)=1
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_activate_bqwzone()
      implicit none
c
#include "mafdecls.fh"
#include "qmmm_params.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
c
      integer i
      integer nsaloc
      integer nwmloc
      integer pwz
      character*32 pname
      pname = "mm_activate_bqwzone"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsaloc)
      call mm_get_nwmloc(nwmloc)
      call mm_get_pwz(pwz)

      do i=1,nwmloc
          int_mb(pwz+i-1)=1
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_prune_bqzone()
      implicit none
c
#include "mafdecls.fh"
#include "qmmm_params.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
c
      integer i
      integer nsaloc
      integer nwmloc
      integer bq_exclude
      character*32 pname
      pname = "mm_prune_bqzone"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsaloc)
      call mm_get_nwmloc(nwmloc)

      bq_exclude = qmmm_get_bq_exclude()

      if(bq_exclude.eq.qmmm_all_atoms) then
        do i=1,nsaloc
         call mm_clear_bqzone(i)
        end do
        do i=1,nwmloc
          call mm_clear_bqwzone(i)
        end do
      else if(bq_exclude.eq.qmmm_linkbond) then
        do i=1,nsaloc
          if(mm_lqsoft(i)) 
     >      call mm_clear_bqzone(i)
        end do
      else if(bq_exclude.eq.qmmm_linkbond_H) then
        do i=1,nsaloc
          if(mm_lqsoft(i).and.(mm_element(i).eq.1)) 
     >      call mm_clear_bqzone(i)
        end do
      end if
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_quant_link_ind(nt,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solute_quant_link_ind"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solute_ind_gen(nt,mm_quant_link,ind)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_link_ind(nt,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solute_link_ind"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solute_ind_gen(nt,mm_link,ind)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_bq_ind(nt,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solute_bq_ind"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solute_ind_gen(nt,mm_bqzone,ind)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_quant_ind(nt,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solute_quant_ind"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solute_ind_gen(nt,mm_quant,ind)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_ind_act(nt,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solute_ind_act"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solute_ind_gen(nt,mm_active,ind)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_ind_act(nt,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solvent_ind_act"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solvent_ind_gen(nt,mm_active_w,ind)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_act_bqs_ind(nt,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solute_act_bq_ind"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solute_ind_gen(nt,mm_active_bqs,ind)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_info_gen(nt,mm_type,ind,ires)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      logical mm_type
      integer ind(nt)
      integer ires(nt)
      external mm_type

c     local variables
      integer i
      integer ioff,ioq
      integer me
      integer np
      integer nqa
      integer l_ioff,i_ioff
      integer nsa
      integer psl
      character*32 pname
      pname = "mm_get_solute_ind_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call ifill(nt,0,ind,1)

      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)

      np=ga_nnodes()

      if(.not.ma_push_get(mt_int,np,'ioff',l_ioff,i_ioff))
     + call errquit('qmmm: Failed to allocate memory for ioff',np,
     &       MA_ERR)

      call ifill(np,0,int_mb(i_ioff),1)

c
c     accumulate offsets
c     ------------------
      me = ga_nodeid()
c      call mm_get_nqm(nqa)
      call mm_get_solute_na_gen(nqa,mm_type)
      do i=me+1,np
        int_mb(i_ioff+i-1)=nqa
      end do    
      call ga_igop(msg_qmmm_offset,int_mb(i_ioff),np,'+')
c
c     set offset for a current node
c     -----------------------------
      if(me.gt.0) then
        ioff=int_mb(i_ioff+me-1)
      else
        ioff=0
      end if

      ioq=ioff
      do i=1,nsa
      if(mm_type(i)) then
         ioq=ioq+1
         ind(ioq)=int_mb(psl+i-1)
      endif
      end do
       
      call ga_igop(msg_qmmm_ind,ind,nt,'+')

      if(.not.ma_pop_stack(l_ioff))
     + call errquit('qmmm: Failed to deallocate memory for ioff',np,
     &       MA_ERR)

      call qmmm_sort(nt,ind)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_ind_gen(nt,mm_type,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      logical mm_type
      integer ind(nt)
      external mm_type

c     local variables
      integer i
      integer ioff,ioq
      integer me
      integer np
      integer nqa
      integer l_ioff,i_ioff
      integer nsa
      integer psl
      character*32 pname
      pname = "mm_get_solute_ind_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call ifill(nt,0,ind,1)

      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)

      np=ga_nnodes()

      if(.not.ma_push_get(mt_int,np,'ioff',l_ioff,i_ioff))
     + call errquit('qmmm: Failed to allocate memory for ioff',np,
     &       MA_ERR)

      call ifill(np,0,int_mb(i_ioff),1)

c
c     accumulate offsets
c     ------------------
      me = ga_nodeid()
c      call mm_get_nqm(nqa)
      call mm_get_solute_na_gen(nqa,mm_type)
      do i=me+1,np
        int_mb(i_ioff+i-1)=nqa
      end do    
      call ga_igop(msg_qmmm_offset,int_mb(i_ioff),np,'+')
c
c     set offset for a current node
c     -----------------------------
      if(me.gt.0) then
        ioff=int_mb(i_ioff+me-1)
      else
        ioff=0
      end if

      ioq=ioff
      do i=1,nsa
      if(mm_type(i)) then
         ioq=ioq+1
         ind(ioq)=int_mb(psl+i-1)
      endif
      end do
       
      call ga_igop(msg_qmmm_ind,ind,nt,'+')

      if(.not.ma_pop_stack(l_ioff))
     + call errquit('qmmm: Failed to deallocate memory for ioff',np,
     &       MA_ERR)

      call qmmm_sort(nt,ind)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_ind_gen(nt,mm_type,ind)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "msgids.fh"
      integer nt
      logical mm_type
      integer ind(nt)
      external mm_type

c     local variables
      integer i
      integer ioff,ioq
      integer me
      integer np
      integer nqa
      integer l_ioff,i_ioff
      integer nwm
      integer mwa
      integer pwl
      character*32 pname
      pname = "mm_get_solvent_ind_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call ifill(nt,0,ind,1)

      call mm_get_nwmloc(nwm)
      call mm_get_mwa(mwa)

      call mm_get_pwl(pwl)

      np=ga_nnodes()

      if(.not.ma_push_get(mt_int,np,'ioff',l_ioff,i_ioff))
     + call errquit('qmmm: Failed to allocate memory for ioff',np,
     &       MA_ERR)

      call ifill(np,0,int_mb(i_ioff),1)

c
c     accumulate offsets
c     ------------------
      me = ga_nodeid()
      call mm_get_solvent_na_gen(nqa,mm_type)
c      call mm_get_nbqw(nqa)
c     number of water molecules = 
c     number of atoms/number of atoms per molecule 
      nqa=nqa/mwa
      do i=me+1,np
        int_mb(i_ioff+i-1)=nqa
      end do    
      call ga_igop(msg_qmmm_nbqw_off,int_mb(i_ioff),np,'+')
c
c     set offset for a current node
c     -----------------------------
      if(me.gt.0) then
        ioff=int_mb(i_ioff+me-1)
      else
        ioff=0
      end if

      ioq=ioff
      do i=1,nwm
      if(mm_type(i)) then
         ioq=ioq+1
         ind(ioq)=int_mb(pwl+i-1)
      endif
      end do

      call ga_igop(msg_qmmm_ind_solvent,ind,nt,'+')

      if(.not.ma_pop_stack(l_ioff))
     + call errquit('qmmm: Failed to deallocate memory for ioff',np,
     &       MA_ERR)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_ind_bq(nt,ind)
      implicit none
#include "mm_utils.fh"
#include "qmmm.fh"
      integer nt
      integer ind(nt)
      character*32 pname
      pname = "mm_get_solvent_ind_bq"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c

      call mm_get_solvent_ind_gen(nt,mm_bqwzone,ind)
    
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_coord_quant(nt,
     >                       link,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      logical link
      integer ai(nt)
      double precision c(3,nt)
      character*32 pname
      pname = "mm_get_solute_coord_quant"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      if(link) then
        call mm_get_solute_coord_gen(nt,
     >                         mm_quant_link,
     >                         ai,
     >                         c)
      else
        call mm_get_solute_coord_gen(nt,
     >                         mm_quant,
     >                         ai,
     >                         c)
      end if

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_geom(nt,
     >                       ai,
     >                       inum,
     >                       t,
     >                       c,
     >                       q,
     >                       m)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      integer inum(nt)
      character*16 t(nt)
      double precision c(3,nt)
      double precision q(nt)
      double precision m(nt)

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_geom_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call dfill(3*nt,0.0d0,c,1)
      call dfill(nt,0.0d0,q,1)
      call dfill(nt,0.0d0,m,1)
      call ifill(nt,0,inum,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
        do j=1,nt
          if(int_mb(psl+i-1).eq.ai(j)) then
             do k=1,3
               c(k,j)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
             end do
             inum(j)=mm_element(i) 
             q(j) = dble(inum(j))
             if(.not.geom_atn_to_default_mass(inum(j),m(j)))
     >         call errquit(pname,0, GEOM_ERR)
             if(mm_bqzone(i).or.mm_link(i)) then
c               inum(j) = 0
               q(j) = mm_solute_charge(i)
             end if
          end if
        end do
      end do

      call ga_dgop(msg_qmmm_c,c,3*nt,'+')
      call ga_dgop(msg_qmmm_chg,q,nt,'+')
      call ga_igop(msg_qmmm_inum,inum,nt,'+')
      call ga_dgop(msg_qmmm_m,m,nt,'+')

      do i=1,nt
         call cf_num2tag(inum(i),t(i))
      end do


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_geom_gen(nt,
     >                       mm_type,
     >                       ai,
     >                       inum,
     >                       t,
     >                       c,
     >                       q)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      logical mm_type
      integer ai(nt)
      integer inum(nt)
      character*16 t(nt)
      double precision c(3,nt)
      double precision q(nt)
      external mm_type

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_geom_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call dfill(3*nt,0.0d0,c,1)
      call dfill(nt,0.0d0,q,1)
      call ifill(nt,0,inum,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)


      do i=1,nsa
        if(mm_type(i)) then
            do j=1,nt
              if(int_mb(psl+i-1).eq.ai(j)) then
                 do k=1,3
                   c(k,j)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
                 end do
                 inum(j)=mm_element(i)
                 q(j) = mm_solute_charge(i)
              end if
            end do
        end if
      end do

      call ga_dgop(msg_qmmm_c,c,3*nt,'+')
      call ga_dgop(msg_qmmm_chg,q,nt,'+')
      call ga_igop(msg_qmmm_inum,inum,nt,'+')

      do i=1,nt
         call cf_num2tag(inum(i),t(i))
      end do


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_charge_gen(nt,
     >                       mm_type,
     >                       ai,
     >                       q)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      logical mm_type
      integer ai(nt)
      double precision q(nt)
      external mm_type

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_geom_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call dfill(nt,0.0d0,q,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)


      do i=1,nsa
        if(mm_type(i)) then
            do j=1,nt
              if(int_mb(psl+i-1).eq.ai(j)) then
                 q(j) = mm_solute_charge(i)
              end if
            end do
        end if
      end do

      call ga_dgop(msg_qmmm_chg,q,nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end
c
      subroutine mm_get_solute_cons_gen(nt,
     >                       mm_type,
     >                       ai,
     >                       act)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      logical act(nt)
      logical mm_type
      external mm_type

      integer i,j
      integer i_act,l_act


c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_cons_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      if(.not.ma_push_get(mt_int,nt,'i_act',l_act,i_act))
     + call errquit('qmmm: Failed to allocate memory for i_act',nt,
     &       MA_ERR)
      call ifill(nt,0,int_mb(i_act),1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)


      do i=1,nsa
        if(mm_type(i)) then
            do j=1,nt
              if(int_mb(psl+i-1).eq.ai(j)) then
                 if(mm_fixed(i)) int_mb(i_act+j-1)=1
              end if
            end do
        end if
      end do

      call ga_igop(msg_qmmm_act,int_mb(i_act),nt,'+')


      do i=1,nt
         act(i)=act(i).and.(int_mb(i_act+i-1).eq.0)
      end do

      if(.not.ma_pop_stack(l_act))
     + call errquit('qmmm: Failed to deallocate memory for act',nt,
     &       MA_ERR)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_cons(nt,
     >                       ai,
     >                       act)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      logical act(nt)

      integer i,j
      integer i_act,l_act


c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_cons_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      if(.not.ma_push_get(mt_int,nt,'i_act',l_act,i_act))
     + call errquit('qmmm: Failed to allocate memory for i_act',nt,
     &       MA_ERR)
      call ifill(nt,0,int_mb(i_act),1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)


      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              if(mm_fixed(i)) int_mb(i_act+j-1)=1
           end if
         end do
      end do

      call ga_igop(msg_qmmm_act,int_mb(i_act),nt,'+')


      do i=1,nt
         act(i)=int_mb(i_act+i-1).eq.0
      end do

      if(.not.ma_pop_stack(l_act))
     + call errquit('qmmm: Failed to deallocate memory for act',nt,
     +       MA_ERR)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_fix_solute_region(nt,mm_type,ai)
      implicit none

#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"

      logical mm_type
      external mm_type
      integer nt
      integer ai(nt)

      integer i,j

c     mm local variables
      integer nsa
      integer psdt
      integer psl
      character*32 pname
      pname = "mm_fix_solute_region"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)

      do i=1,nsa
        if(mm_type(i)) then
        if(int_mb(psl+i-1).eq.ai(j)) then
        do j=1,nt
           int_mb(psdt+i-1)=ior(int_mb(psdt+i-1),lfixed)
        end do
        end if
        end if
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_free_solute_region(nt,mm_type,ai)
      implicit none

#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"

      logical mm_type
      external mm_type
      integer nt
      integer ai(nt)

      integer i,j

c     mm local variables
      integer nsa
      integer psdt
      integer psl
      character*32 pname
      pname = "mm_fix_solute_region"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)

      do i=1,nsa
        if(mm_type(i)) then
        if(int_mb(psl+i-1).eq.ai(j)) then
        do j=1,nt
           int_mb(psdt+i-1)=iand(int_mb(psdt+i-1),not(mfixed))
        end do
        end if
        end if
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_fix_solute(mm_type)
      implicit none

#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"

      logical mm_type
      external mm_type

      integer i

c     mm local variables
      integer nsa
      integer psdt
      character*32 pname
      pname = "mm_fix_solute"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)

      do i=1,nsa
        if(mm_type(i)) then
           int_mb(psdt+i-1)=ior(int_mb(psdt+i-1),lfixed)
        end if
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_free_solute(mm_type)
      implicit none

#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"

      logical mm_type
      external mm_type

      integer i

c     mm local variables
      integer nsa
      integer psdt
      character*32 pname
      pname = "mm_free_solute"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)

      do i=1,nsa
        if(mm_type(i)) then
           int_mb(psdt+i-1)=iand(int_mb(psdt+i-1),not(mfixed))
        end if
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_fix_solute_res(nr,resid)
      implicit none

#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"

      integer nr
      integer resid(nr)

c     mm local variables
      integer i,ir
      integer psg
      integer nsa
      integer psdt
      character*32 pname
      pname = "mm_fix_solute_res"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psg(psg)

      do i=1,nsa
        do ir=1,nr
        if(int_mb(psg+i-1).eq.resid(ir)) then
           int_mb(psdt+i-1)=ior(int_mb(psdt+i-1),lfixed)
        end if
        end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_free_solute_res(nr,resid)
      implicit none

#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"

      integer nr
      integer resid(nr)

c     mm local variables
      integer i,ir
      integer psg
      integer nsa
      integer psdt
      character*32 pname
      pname = "mm_free_solute_res"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psg(psg)

      do i=1,nsa
        do ir=1,nr
        if(int_mb(psg+i-1).eq.resid(ir)) then
           int_mb(psdt+i-1)=iand(int_mb(psdt+i-1),not(mfixed))
        else
           int_mb(psdt+i-1)=ior(int_mb(psdt+i-1),lfixed)
        end if
        end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_coord_gen(nt,
     >                       mm_type,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      logical mm_type
      integer ai(nt)
      double precision c(3,nt)
      external mm_type

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_coord_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call dfill(3*nt,0.0d0,c,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
        if(mm_type(i)) then
            do j=1,nt
              if(int_mb(psl+i-1).eq.ai(j)) then
                 do k=1,3
                   c(k,j)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
                 end do
              end if
            end do
        end if
      end do

      call ga_dgop(msg_qmmm_c1,c,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_group(nt,
     >                       mm_type,
     >                       ai,
     >                       grp)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      integer grp(nt)
      external mm_type
      logical mm_type

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer psg
      character*32 pname
      pname = "mm_get_solute_group"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call ifill(nt,0,grp,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psg(psg)

      do i=1,nsa
        if(mm_type(i)) then
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              grp(j)=int_mb(psg+i-1)
           end if
         end do
        end if
      end do

      call ga_igop(msg_qmmm_c1,grp,nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_res(nt,
     >                       mm_type,
     >                       ai,
     >                       sgm)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      integer sgm(nt)
      external mm_type
      logical mm_type

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer psgm
      character*32 pname
      pname = "mm_get_solute_group"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call ifill(nt,0,sgm,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psgm(psgm)

      do i=1,nsa
        if(mm_type(i)) then
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              sgm(j)=int_mb(psgm+i-1)
           end if
         end do
        end if
      end do

      call ga_igop(msg_qmmm_c1,sgm,nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_coord(nt,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_coord_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call dfill(3*nt,0.0d0,c,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                c(k,j)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
              end do
           end if
         end do
      end do

      call ga_dgop(msg_qmmm_c1,c,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_coord_raw(nt,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_coord_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call dfill(3*nt,0.0d0,c,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                c(k,j)=dbl_mb(pxs+(i-1)+(k-1)*msa)
              end do
           end if
         end do
      end do

      call ga_dgop(msg_qmmm_c1,c,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_print_solute_coord()
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"


      integer i,k

c     mm local variables
      integer msa
      integer nsa
      integer pxs
      character*32 pname
      pname = "mm_print_solute_coord"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_pxs(pxs)
      
      if(qmmm_master()) then
        write(*,*) "mm_print_solute_coord"
        do i=1,nsa
            write(*,300) mm_solute_charge(i),
     >        (dbl_mb(pxs+(i-1)+(k-1)*msa)*
     >                    cnm2au*cau2ang,k=1,3)
        end do
      end if

300   FORMAT(4F12.6)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_geom(nt,
     >                       ai,
     >                       inum,
     >                       t,
     >                       c,
     >                       q,
     >                       mw)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)
      double precision q(nt)
      double precision mw(nt)
      integer inum(nt)
      character*16 t(nt)
      double precision cf_wcharge
      external cf_wcharge

      integer i,j,k,m,j1

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pxw
      integer pwl
      character*32 pname
      pname = "mm_get_solvent_geom"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call dfill(3*nt,0.0d0,c,1)
      call dfill(nt,0.0d0,q,1)
      call dfill(nt,0.0d0,mw,1)
      call ifill(nt,0,inum,1)

      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pxw(pxw)
      call mm_get_pwl(pwl)

 
      do i=1,nwm
         do j=1,nt/mwa
           if(int_mb(pwl+i-1).eq.ai(j)) then
              do m=1,mwa
                j1=(j-1)*mwa+m
                do k=1,3
                  c(k,j1)=dbl_mb(pxw+(i-1)+(k-1)*mwm+(m-1)*3*mwm)
                  c(k,j1)=c(k,j1)*cnm2au
                end do
                inum(j1)=0
                q(j1) = cf_wcharge(m)
                mw(j1) = mm_ww(m)
              end do
           end if
         end do
      end do


      call ga_dgop(msg_qmmm_cbqw,c,3*nt,'+')
      call ga_dgop(msg_qmmm_qbqw,q,nt,'+')
      call ga_dgop(msg_qmmm_mw,mw,nt,'+')
      call ga_igop(msg_qmmm_inumw,inum,nt,'+')

      do i=1,nt
          t(i) = "Bqw"
c         call cf_num2tag(inum(i),t(i))
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_geom_bq(nt,
     >                       ai,
     >                       c,
     >                       q)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      logical mm_type
      integer ai(nt)
      double precision c(3,nt)
      double precision q(nt)
      external mm_type
      double precision cf_wcharge
      external cf_wcharge

      integer i,j,k,m,j1

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pxw
      integer pwl
      character*32 pname
      pname = "mm_get_solvent_geom"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call dfill(3*nt,0.0d0,c,1)
      call dfill(nt,0.0d0,q,1)

      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pxw(pxw)
      call mm_get_pwl(pwl)

 
      do i=1,nwm
         do j=1,nt/mwa
           if(int_mb(pwl+i-1).eq.ai(j)) then
              do m=1,mwa
                j1=(j-1)*mwa+m
                do k=1,3
                  c(k,j1)=dbl_mb(pxw+(i-1)+(k-1)*mwm+(m-1)*3*mwm)
                  c(k,j1)=c(k,j1)*cnm2au
                end do
                q(j1) = cf_wcharge(m)
              end do
           end if
         end do
      end do


      call ga_dgop(msg_qmmm_cbqw,c,3*nt,'+')
      call ga_dgop(msg_qmmm_qbqw,q,nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_geom_bq(nt,
     >                       ai,
     >                       c,
     >                       q)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)
      double precision q(nt)

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_get_solute_geom_bq"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call dfill(3*nt,0.0d0,c,1)
      call dfill(nt,0.0d0,q,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)


      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                c(k,j)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
              end do
              q(j) = mm_solute_charge(i)
           end if
         end do
      end do

      call ga_dgop(msg_qmmm_c,c,3*nt,'+')
      call ga_dgop(msg_qmmm_chg,q,nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solvent_coord(nt,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)

      integer i,j,k,m,j1

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pxw
      integer pwl
      character*32 pname
      pname = "mm_get_solvent_geom"
      if(qmmm_print_debug()) write(*,*) "in "//pname



      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pxw(pxw)
      call mm_get_pwl(pwl)
 
      do i=1,nwm
c        if(mm_bqwzone(i)) then
            do j=1,nt/mwa
              if(int_mb(pwl+i-1).eq.ai(j)) then
                 do m=1,mwa
                   j1=(j-1)*mwa+m
                   do k=1,3
                     dbl_mb(pxw+(i-1)+(k-1)*mwm+(m-1)*3*mwm)=c(k,j1)*
     >                                                       cau2nm
                   end do
                 end do
              end if
            end do
c        end if
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_coord(nt,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)

      integer i,j,k,m,j1

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pxw
      integer pwl
      character*32 pname
      pname = "mm_get_solvent_coord"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call dfill(3*nt,0.0d0,c,1)

      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pxw(pxw)
      call mm_get_pwl(pwl)
 
      do i=1,nwm
         do j=1,nt/mwa
           if(int_mb(pwl+i-1).eq.ai(j)) then
              do m=1,mwa
                j1=(j-1)*mwa+m
                do k=1,3
                  c(k,j1) = 
     >             dbl_mb(pxw+(i-1)+(k-1)*mwm+(m-1)*3*mwm)/cau2nm
                end do
              end do
           end if
         end do
      end do

      call ga_dgop(msg_qmmm_cw,c,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_cons(nt,
     >                       ai,
     >                       act)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      logical act(nt)

      integer i,j,m

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pxw
      integer pwl
      integer i_act,l_act

      character*32 pname
      pname = "mm_get_solvent_cons_bq"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      if(.not.ma_push_get(mt_int,nt,'i_act',l_act,i_act))
     + call errquit('qmmm: Failed to allocate memory for i_act',nt,
     &       MA_ERR)
      call ifill(nt,0,int_mb(i_act),1)


      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pxw(pxw)
      call mm_get_pwl(pwl)
 
      do i=1,nwm
        if(mm_fixed_w(i)) then
            do j=1,nt/mwa
              if(int_mb(pwl+i-1).eq.ai(j)) then
                 do m=1,mwa
                 int_mb(i_act+(j-1)*mwa+m-1)=1
                 end do
              end if
            end do
        end if
      end do

      call ga_igop(msg_qmmm_wact,int_mb(i_act),nt,'+')

      do i=1,nt
         act(i)=act(i).and.(int_mb(i_act+i-1).eq.0)
      end do

      if(.not.ma_pop_stack(l_act))
     + call errquit('qmmm: Failed to deallocate memory for act',nt,
     &       MA_ERR)


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_fix_solvent()
      implicit none

#include "qmmm_params.fh"
#include "qmmm.fh"
#include "mafdecls.fh"
#include "errquit.fh"

c     mm local variables
      integer nwm
      integer pwdt
      integer i

      character*32 pname
      pname = "mm_get_solvent_cons_bq"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_pwdt(pwdt)
      call mm_get_nwmloc(nwm)
 
      do i=1,nwm
        int_mb(pwdt+i-1)=ior(int_mb(pwdt+i-1),lfixed)
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solvent_force(nt,
     >                       ai,
     >                       g)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision g(3,nt)

      integer i,j,k,m,j1,ioff

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pfw
      integer pwl
      character*32 pname
      pname = "mm_get_solvent_force"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call dfill(3*nt,0.0d0,g,1)

      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pfw(pfw)
      call mm_get_pwl(pwl)
 
      do i=1,nwm
c        if(mm_bqwzone(i)) then
            do j=1,nt/mwa
              if(int_mb(pwl+i-1).eq.ai(j)) then
                 do m=1,mwa
                   j1=(j-1)*mwa+m
                   do k=1,3
                     ioff=pfw+(i-1)+(k-1)*mwm+(m-1)*3*mwm
                     g(k,j1)=-dbl_mb(ioff)*cau2nm/cau2kj
                   end do
                 end do
              end if
            end do
c        end if
      end do

      call ga_dgop(msg_qmmm_forcew,g,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_rms_solvent_force_gen(mm_type,grms)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      logical mm_type
      external mm_type
      double precision grms

      integer i,k,m,ioff

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pfw
      integer ntot
      double precision g
      character*32 pname
      pname = "mm_get_rms_solvent_force_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pfw(pfw)
 
      ntot = 0
      grms = 0.0d0
      do i=1,nwm
        if(mm_type(i)) then
          ntot = ntot + 1
            do m=1,mwa
              do k=1,3
                ioff=pfw+(i-1)+(k-1)*mwm+(m-1)*3*mwm
                g=dbl_mb(ioff)
                grms = grms + g*g
              end do
            end do
       end if
      end do

      call ga_dgop(msg_qmmm_forcew,grms,1,'+')
      call ga_dgop(msg_qmmm_nqm,ntot,1,'+')
c
      grms = sqrt(grms/dble(ntot))*cau2nm/cau2kj
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solvent_force(nt,
     >                       ai,
     >                       g)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision g(3,nt)

      integer i,j,k,m,j1,ioff

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pfw
      integer pwl
      character*32 pname
      pname = "mm_set_solvent_force"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pfw(pfw)
      call mm_get_pwl(pwl)
 
      do i=1,nwm
        if(mm_bqwzone(i)) then
            do j=1,nt/mwa
              if(int_mb(pwl+i-1).eq.ai(j)) then
                 do m=1,mwa
                   j1=(j-1)*mwa+m
                   do k=1,3
                     ioff=pfw+(i-1)+(k-1)*mwm+(m-1)*3*mwm
                     dbl_mb(ioff)=-g(k,j1)*cau2kj/cau2nm
                   end do
                 end do
              end if
            end do
        end if
      end do


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_zero_solvent_force(nt,
     >                       ai,
     >                       map)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      logical map(nt)

      integer i,j,k,m,j1,ioff

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pfw
      integer pwl
      character*32 pname
      pname = "mm_set_solvent_force"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pfw(pfw)
      call mm_get_pwl(pwl)
 
      do i=1,nwm
         do j=1,nt/mwa
           if(int_mb(pwl+i-1).eq.ai(j)) then
              do m=1,mwa
                j1=(j-1)*mwa+m
                if(.not.map(j1)) then
                do k=1,3
                  ioff=pfw+(i-1)+(k-1)*mwm+(m-1)*3*mwm
                  dbl_mb(ioff)=0.0d0
                end do
                end if
              end do
           end if
         end do
      end do


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_print_solvent_force(un)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer un

      integer i,j,k,m,j1,ioff

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pfw
      integer pwl
      character*32 pname
      pname = "mm_print_solvent_force"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pfw(pfw)
      call mm_get_pwl(pwl)
 
      do i=1,nwm
       do m=1,mwa
         j1=(j-1)*mwa+m
         write(un,*)  
     +    (dbl_mb(pfw+(i-1)+(k-1)*mwm+(m-1)*3*mwm),k=1,3)
       end do
      end do


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_add_solvent_force(nt,
     >                       ai,
     >                       g)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision g(3,nt)

      integer i,j,k,m,j1,ioff

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pfw
      integer pwl
      character*32 pname
      pname = "mm_add_solvent_force"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pfw(pfw)
      call mm_get_pwl(pwl)

      do i=1,nwm
        if(mm_bqwzone(i)) then
            do j=1,nt/mwa
              if(int_mb(pwl+i-1).eq.ai(j)) then
                 do m=1,mwa
                   j1=(j-1)*mwa+m
                   do k=1,3
                     ioff=pfw+(i-1)+(k-1)*mwm+(m-1)*3*mwm
                     dbl_mb(ioff)=dbl_mb(ioff)-g(k,j1)*cau2kj/cau2nm
                   end do
                 end do
              end if
            end do
        end if
      end do


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_force_quant(nt,link,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "rtdb.fh"
      integer nt
      integer ai(nt)
      double precision  g(3,nt)
      logical link
      character*32 pname
      pname = "mm_get_solute_force_quant"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      if(link) then
      call mm_get_solute_force_gen(nt,mm_quant_link,ai,g)
      else
      call mm_get_solute_force_gen(nt,mm_quant,ai,g)
      end if
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_force_quant(nt,link,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "rtdb.fh"
      integer nt
      integer ai(nt)
      double precision  g(3,nt)
      logical link
      character*32 pname

      pname = " mm_set_solute_force_quant"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      if(qmmm_print_debug())
     >  write(*,*) "in "//pname

      if(link) then
      call mm_set_solute_force_gen(nt,mm_quant_link,ai,g)
      else
      call mm_set_solute_force_gen(nt,mm_quant,ai,g)
      end if

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_force_bq(nt,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "rtdb.fh"
      integer nt
      integer ai(nt)
      double precision  g(3,nt)
      character*32 pname
      pname = "mm_get_solute_force_bq"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_get_solute_force_gen(nt,mm_bqzone,ai,g)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_force_bq(nt,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "mm_utils.fh"
#include "rtdb.fh"
      integer nt
      integer ai(nt)
      double precision  g(3,nt)
      character*32 pname
      pname = "mm_set_solute_force_bq"
      if(qmmm_print_debug()) write(*,*) "in "//pname
      
      call mm_set_solute_force_gen(nt,mm_bqzone,ai,g)
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_force_gen(nt,mm_type,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "msgids.fh"
      integer nt
      logical mm_type
      integer ai(nt)
      double precision  g(3,nt)
      external mm_type
c     local variables
      integer i,j,k
      integer msa
      integer nsa
      integer psdt
      integer psl
      integer pfs
      character*32 pname

      pname = "mm_set_solute_force_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)
      call mm_get_pfs(pfs)

      do i=1,nsa
        if(mm_type(i)) then
            do j=1,nt
              if(int_mb(psl+i-1).eq.ai(j)) then
                 do k=1,3
                   dbl_mb(pfs+(i-1)+(k-1)*msa)=-g(k,j)*cau2kj/cau2nm
                 end do
              end if
            end do
        end if
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_zero_solute_force(nt,ai,map)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "msgids.fh"
      integer nt
      integer ai(nt)
      logical map(nt)
c     local variables
      integer i,j,k
      integer msa
      integer nsa
      integer psdt
      integer psl
      integer pfs
      character*32 pname

      pname = "mm_set_solute_force_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)
      call mm_get_pfs(pfs)

      do i=1,nsa
        do j=1,nt
          if(int_mb(psl+i-1).eq.ai(j)) then
             if(.not.map(j)) then
             do k=1,3
               dbl_mb(pfs+(i-1)+(k-1)*msa)=0.0d0
             end do
             end if
          end if
        end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_add_solute_force(nt,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "msgids.fh"
      integer nt
      integer ai(nt)
      double precision  g(3,nt)
c     local variables
      integer i,j,k
      integer msa
      integer nsa
      integer psdt
      integer psl
      integer pfs
      character*32 pname

      pname = "mm_add_solute_force_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)
      call mm_get_pfs(pfs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                dbl_mb(pfs+(i-1)+(k-1)*msa)=
     >             dbl_mb(pfs+(i-1)+(k-1)*msa)-g(k,j)*cau2kj/cau2nm
              end do
           end if
         end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_force(nt,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "msgids.fh"
      integer nt
      integer ai(nt)
      double precision  g(3,nt)
c     local variables
      integer i,j,k
      integer msa
      integer nsa
      integer psdt
      integer psl
      integer pfs
      character*32 pname

      pname = "mm_get_solute_force"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call dfill(3*nt,0.0d0,g,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)
      call mm_get_pfs(pfs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                g(k,j)=-dbl_mb(pfs+(i-1)+(k-1)*msa)*cau2nm/cau2kj
              end do
           end if
         end do
      end do

      call ga_dgop(msg_qmmm_force,g,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_force_raw(nt,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "msgids.fh"
      integer nt
      integer ai(nt)
      double precision  g(3,nt)
c     local variables
      integer i,j,k
      integer msa
      integer nsa
      integer psdt
      integer psl
      integer pfs
      character*32 pname

      pname = "mm_get_solute_force"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call dfill(3*nt,0.0d0,g,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)
      call mm_get_pfs(pfs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                g(k,j)=-dbl_mb(pfs+(i-1)+(k-1)*msa)
              end do
           end if
         end do
      end do

      call ga_dgop(msg_qmmm_force,g,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_rms_solute_force_gen(mm_type,grms)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "msgids.fh"
      logical mm_type
      double precision  grms
      external mm_type
c     local variables
      integer i,k
      integer msa
      integer nsa
      integer pfs
      integer ntot
      character*32 pname

      pname = "mm_get_rms_solute_force_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname
c
      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_pfs(pfs)
c
      ntot = 0
      grms = 0.0d0
      do i=1,nsa
        if(mm_type(i)) then
           ntot = ntot + 1
           do k=1,3
             grms=grms + dbl_mb(pfs+(i-1)+(k-1)*msa)*
     >                   dbl_mb(pfs+(i-1)+(k-1)*msa) 
           end do
        end if
      end do
c
      call ga_dgop(msg_qmmm_force,grms,1,'+')
      call ga_igop(msg_qmmm_nqm,ntot,1,'+')
c
      grms = sqrt(grms/dble(ntot))*cau2nm/cau2kj
c
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_get_solute_force_gen(nt,mm_type,ai,g)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "msgids.fh"
      integer nt
      logical mm_type
      integer ai(nt)
      double precision  g(3,nt)
      external mm_type
c     local variables
      integer i,j,k
      integer msa
      integer nsa
      integer psdt
      integer psl
      integer pfs
      character*32 pname

      pname = "mm_get_solute_force_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call dfill(3*nt,0.0d0,g,1)

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psdt(psdt)
      call mm_get_psl(psl)
      call mm_get_pfs(pfs)

      do i=1,nsa
        if(mm_type(i)) then
            do j=1,nt
              if(int_mb(psl+i-1).eq.ai(j)) then
                 do k=1,3
                   g(k,j)=-dbl_mb(pfs+(i-1)+(k-1)*msa)*cau2nm/cau2kj
                 end do
              end if
            end do
        end if
      end do

      call ga_dgop(msg_qmmm_force,g,3*nt,'+')

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_coord_quant(nt,
     >                       link,
     >                       ai,
     >                       c)
      implicit none

#include "mm_utils.fh"
#include "qmmm.fh"

      integer nt
      logical link
      integer ai(nt)
      double precision c(3,nt)
      character*32 pname
      pname = "mm_set_solute_coord_quant"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      if(link) then
      call mm_set_solute_coord_gen(nt,
     >                       mm_quant_link,
     >                       ai,
     >                       c)

      else
      call mm_set_solute_coord_gen(nt,
     >                       mm_quant,
     >                       ai,
     >                       c)


      end if
      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_coord_bq(nt,
     >                       ai,
     >                       c)
      implicit none

#include "mm_utils.fh"
#include "qmmm.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)
      character*32 pname
      pname = "mm_set_solute_coord_bq"

      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_set_solute_coord_gen(nt,
     >                       mm_bqzone,
     >                       ai,
     >                       c)

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_coord_gen(nt,
     >                       mm_type,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      logical mm_type
      integer ai(nt)
      double precision c(3,nt)
      external mm_type

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_set_solute_coord_gen"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
        if(mm_type(i)) then
            do j=1,nt
              if(int_mb(psl+i-1).eq.ai(j)) then
                 do k=1,3
                   dbl_mb(pxs+(i-1)+(k-1)*msa)=c(k,j)/cnm2au
                 end do
              end if
            end do
        end if
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_coord_raw(nt,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_set_solute_coord"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                dbl_mb(pxs+(i-1)+(k-1)*msa)=c(k,j)
              end do
           end if
         end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_set_solute_coord(nt,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)
      double precision c(3,nt)

      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_set_solute_coord"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                dbl_mb(pxs+(i-1)+(k-1)*msa)=c(k,j)/cnm2au
              end do
           end if
         end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_mix_solute_coord(nt,
     >                       lambda,
     >                       ai,
     >                       c)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      double precision lambda
      integer ai(nt)
      double precision c(3,nt)

      double precision x0,x1,x2
      integer i,j,k

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer pxs
      character*32 pname
      pname = "mm_set_solute_coord"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_pxs(pxs)

      do i=1,nsa
         do j=1,nt
           if(int_mb(psl+i-1).eq.ai(j)) then
              do k=1,3
                x0 = dbl_mb(pxs+(i-1)+(k-1)*msa)
                x1 = c(k,j)/cnm2au
                x2=(x1-x0)*lambda+x0
                dbl_mb(pxs+(i-1)+(k-1)*msa)=x2
              end do
           end if
         end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_mix_solute_coord_file(aname,lambda)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "msgids.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "global.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) aname    
      double precision lambda
c     local variables
      integer ns
      integer i
      integer k
      logical title


      integer i_itmp,h_itmp
      integer i_ctmp,h_ctmp
      character*32 pname
      character*30 buf
      character*255 filename, dir

      integer fn
      logical master

      pname = "mm_set_solute_coord_file"
      master = qmmm_master()

      filename = aname(1:inp_strlen(aname))
      if(master)  
     +  call util_print_centered(luout,
     + "Loading external geometry from "//
     +   filename,40,.true.)
      dir      = ' '
      call util_directory_name(dir, .false., 0)
      filename = ' '
      write(filename,13) dir(1:inp_strlen(dir)), 
     $     aname(1:inp_strlen(aname))
 13      format(a,'/',a)
      if(master) then  
        if(.not.qmmm_get_io_unit(fn)) 
     >       call errquit("cannot get file number",0,0)
c
        open(fn,file=filename,form='formatted',status='old',
     $          err=133)
      end if
      
c     get number of atoms
      if(master) then
         read(fn,*) ns
      else
         ns = 0
      end if


      call ga_igop(msg_qmmm_nqm,ns,1,'+')
      call ga_sync()

      if(.not.ma_push_get(mt_int,ns,'itmp',h_itmp,i_itmp))
     + call errquit( pname//'Failed to allocate memory for itmp',
     + ns, MA_ERR)
      call ifill(ns,0,int_mb(i_itmp),1)

      if(.not.ma_push_get(mt_dbl,3*ns,'ctmp',h_ctmp,i_ctmp))
     + call errquit( pname//'Failed to allocate memory for ctmp',
     + 3*ns, MA_ERR)
      call dfill(3*ns,0.0d0,dbl_mb(i_ctmp),1)

c
c     read the coords and global index
c     --------------------------------
      if(master) then
c     testing for the presence of the title
        rewind(fn)
        title =.false.
        do i=1,ns+2
          read(fn,*,end=1) buf
        end do
        title = .true.
1       continue
c       title or not read coordinates now
        rewind(fn) 
        read(fn,*) buf
        if(title) 
     +     read(fn,*) buf

        do i=1,ns
         read(fn,*) buf, (dbl_mb(i_ctmp+3*(i-1)+k-1),k=1,3),
     +               int_mb(i_itmp+i-1)
         write(luout,'(A,3F12.6,I5)') buf, 
     +              (dbl_mb(i_ctmp+3*(i-1)+k-1),k=1,3),
     +               int_mb(i_itmp+i-1)

        end do
        close(fn)
        do i=1,3*ns
          dbl_mb(i_ctmp+i-1) = dbl_mb(i_ctmp+i-1)/cau2ang
        end do
      end if
c
      call ga_igop(msg_qmmm_ind,int_mb(i_itmp),ns,'+')
      call ga_dgop(msg_qmmm_c1,dbl_mb(i_ctmp),3*ns,'+')
c
      call ga_sync
c
      call mm_mix_solute_coord(ns,
     >                         lambda,
     >                         int_mb(i_itmp),
     >                         dbl_mb(i_ctmp))

c
      if(.not.ma_pop_stack(h_ctmp))
     & call errquit('qmmm: 
     >              Failed to deallocate stack c_tmp',ns,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_itmp))
     & call errquit('qmmm: 
     >              Failed to deallocate stack i_itmp',ns,
     &       MA_ERR)

      return

 133  call errquit(pname//'error opening/closing xyz file',0, GEOM_ERR)

      end

      subroutine mm_set_solute_coord_file(aname)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "msgids.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "global.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) aname    
c     local variables
      integer ns
      integer i
      integer k
      logical title


      integer i_itmp,h_itmp
      integer i_ctmp,h_ctmp
      character*32 pname
      character*30 buf
      character*255 filename, dir

      integer fn
      logical master

      pname = "mm_set_solute_coord_file"
      master = qmmm_master()

      filename = aname(1:inp_strlen(aname))
      if(master)  
     +  call util_print_centered(luout,
     + "Loading external geometry from "//
     +   filename,40,.true.)
      dir      = ' '
      call util_directory_name(dir, .false., 0)
      filename = ' '
      write(filename,13) dir(1:inp_strlen(dir)), 
     $     aname(1:inp_strlen(aname))
 13      format(a,'/',a)
      if(master) then  
        if(.not.qmmm_get_io_unit(fn)) 
     >       call errquit("cannot get file number",0,0)
c
        open(fn,file=filename,form='formatted',status='old',
     $          err=133)
      end if
      
c     get number of atoms
      if(master) then
         read(fn,*) ns
      else
         ns = 0
      end if


      call ga_igop(msg_qmmm_nqm,ns,1,'+')
      call ga_sync()

      if(.not.ma_push_get(mt_int,ns,'itmp',h_itmp,i_itmp))
     + call errquit( pname//'Failed to allocate memory for itmp',
     + ns, MA_ERR)
      call ifill(ns,0,int_mb(i_itmp),1)

      if(.not.ma_push_get(mt_dbl,3*ns,'ctmp',h_ctmp,i_ctmp))
     + call errquit( pname//'Failed to allocate memory for ctmp',
     + 3*ns, MA_ERR)
      call dfill(3*ns,0.0d0,dbl_mb(i_ctmp),1)

c
c     read the coords and global index
c     --------------------------------
      if(master) then
c     testing for the presence of the title
        rewind(fn)
        title =.false.
        do i=1,ns+2
          read(fn,*,end=1) buf
        end do
        title = .true.
1       continue
c       title or not read coordinates now
        rewind(fn) 
        read(fn,*) buf
        if(title) 
     +     read(fn,*) buf

        do i=1,ns
         read(fn,*) buf, (dbl_mb(i_ctmp+3*(i-1)+k-1),k=1,3),
     +               int_mb(i_itmp+i-1)
         write(luout,*) buf, (dbl_mb(i_ctmp+3*(i-1)+k-1),k=1,3),
     +               int_mb(i_itmp+i-1)

        end do
        close(fn)
        do i=1,3*ns
          dbl_mb(i_ctmp+i-1) = dbl_mb(i_ctmp+i-1)/cau2ang
        end do
      end if
c
      call ga_igop(msg_qmmm_ind,int_mb(i_itmp),ns,'+')
      call ga_dgop(msg_qmmm_c1,dbl_mb(i_ctmp),3*ns,'+')
c
      call ga_sync
c
      call mm_set_solute_coord(ns,
     >                         int_mb(i_itmp),
     >                         dbl_mb(i_ctmp))

c
      if(.not.ma_pop_stack(h_ctmp))
     & call errquit('qmmm: 
     >              Failed to deallocate stack c_tmp',ns,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_itmp))
     & call errquit('qmmm: 
     >              Failed to deallocate stack i_itmp',ns,
     &       MA_ERR)

      return

 133  call errquit(pname//'error opening/closing xyz file',0, GEOM_ERR)

      end

      subroutine mm_create_trj_from_xyz(in_xyz,out_trj)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "msgids.fh"
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "global.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) in_xyz
      character*(*) out_trj
c     local variables
      integer ns
      integer i
      integer k
      logical title
      integer i_itmp,h_itmp
      integer i_ctmp,h_ctmp
      character*32 pname
      character*30 buf
      character*255 filename
      character*255 xyzfile
      character*255 trjfile
      character*255 message

      integer fn_xyz,fn_trj
      logical end_of_file
      logical master

      pname = "mm_create_trj_from_xyz"
      master = qmmm_master()
c
c     we assume that xyz file has a title
c     -----------------------------------
      title = .true.
c
      xyzfile = in_xyz(1:inp_strlen(in_xyz))
      call util_file_name_resolve(xyzfile, .false.)
c
      trjfile = out_trj(1:inp_strlen(out_trj))
      call util_file_name_resolve(trjfile, .false.)
c
      filename = in_xyz(1:inp_strlen(xyzfile))
      if(master) 
     + call util_print_centered(luout,
     + "Loading external xyz frames from "//
     +   filename,
     +   40,.true.)
c
      filename = out_trj(1:inp_strlen(out_trj))
      if(master) 
     + call util_print_centered(luout,
     + "Creating mm trajectory file "//
     +   filename,
     +   40,.true.)
c
c     prepare files for reading/writing
c     ---------------------------------
      if(master) then  
        if(.not.qmmm_get_io_unit(fn_xyz)) 
     >       call errquit("cannot get file number",0,0)
        filename = xyzfile
        open(fn_xyz,file=filename,form='formatted',status='old',
     $          err=133)
c
        if(.not.qmmm_get_io_unit(fn_trj)) 
     >       call errquit("cannot get file number",0,0)
        filename = trjfile
        open(fn_trj,file=filename,form='formatted',status='unknown',
     $          err=133)
c       write header for trj file
        call cf_trjhdr(fn_trj)
      end if
c
c     get number of atoms
c     ------------------
      message = " number of atoms "
      if(master) then
         read(fn_xyz,*,err=134) ns
         rewind(fn_xyz)
      end if
      call ga_brdcst(msg_qmmm_nqm,
     >     ns,
     >     ma_sizeof(mt_int,1,mt_byte),
     >     0)
      call ga_sync()

c
c     temporary stack memory
c     ----------------------
      if(.not.ma_push_get(mt_int,ns,'itmp',h_itmp,i_itmp))
     + call errquit( pname//'Failed to allocate memory for itmp',
     + ns, MA_ERR)

      if(.not.ma_push_get(mt_dbl,3*ns,'ctmp',h_ctmp,i_ctmp))
     + call errquit( pname//'Failed to allocate memory for ctmp',
     + 3*ns, MA_ERR)

c
c     read the coords and global index
c     --------------------------------
2     continue
      if(master) then
        end_of_file = .true.
        message = " number of atoms field"
        read(fn_xyz,*,err=134,end=3) buf
        end_of_file = .false.
        message = " title field"
        if(title) 
     +     read(fn_xyz,*,err=134,end=135) buf

        do i=1,ns
         read(fn_xyz,*,err=134,end=135) buf, 
     +        (dbl_mb(i_ctmp+3*(i-1)+k-1),k=1,3),
     +        int_mb(i_itmp+i-1)
        end do
        call dscal(3*ns,1/cau2ang,dbl_mb(i_ctmp),1)
      end if
c
3     continue
c
c     check if end of file was found
c     ------------------------------
      call ga_brdcst(msg_qmmm_misc,end_of_file,
     >               ma_sizeof(mt_log,1,mt_byte),0)
      if(end_of_file) goto 4
c
c     send coords/index to others
c     ---------------------------
      call ga_brdcst(msg_qmmm_ind,
     >     int_mb(i_itmp),
     >     ns*ma_sizeof(mt_int,1,mt_byte),
     >     0)
      call ga_brdcst(msg_qmmm_c1,
     >     dbl_mb(i_ctmp),
     >     3*ns*ma_sizeof(mt_dbl,1,mt_byte),
     >     0)
      call ga_sync()
c
c     push coords to mm
c     -----------------
      call mm_set_solute_coord(ns,
     >                         int_mb(i_itmp),
     >                         dbl_mb(i_ctmp))
c
      call mm_write_frame(fn_trj)
      goto 2
c
 4    continue
c
      if(.not.ma_pop_stack(h_ctmp))
     & call errquit('qmmm: 
     >              Failed to deallocate stack c_tmp',ns,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_itmp))
     & call errquit('qmmm: 
     >              Failed to deallocate stack i_itmp',ns,
     &       MA_ERR)

      if(master) then
        close(fn_xyz)
        close(fn_trj)
      end if
      return

 133  call errquit(pname//'error opening/closing '//filename,0, 0)
 134  call errquit(pname//'error reading xyz file'//message,0, 0)
 135  call errquit(pname//'error end of file at'//message,0, 0)

      end

      subroutine mm_debug0()
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"



c     local variables
      integer i
      integer msa
      integer nsa
      integer psl
      integer psz
      character*32 pname
      pname = "mm_debug0"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psz(psz)

      do i=1,nsa
        write(56,*) int_mb(psl+i-1),
     >                int_mb(psz+i-1)

      end do

      call ga_sync()
      if(qmmm_print_debug()) write(*,*) "out "//pname

      end

      subroutine mm_debug()
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"



c     local variables
      integer i
      integer msa
      integer nsa
      integer psl
      integer psz
      character*32 pname
      pname = "mm_debug"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psz(psz)

      do i=1,nsa
        if(int_mb(psl+i-1).eq.639) then
          write(*,*) "found atom",int_mb(psl+i-1),
     >                int_mb(psz+i-1)

        end if
      end do

      call ga_sync()

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_print_system_pdb()
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"



c     local variables
      integer i,k
      integer msa
      integer nsa
      integer psl
      integer psz
      integer pxs
      integer psg
      double precision c(3)
      character*16 t
      character*32 pname
      pname = "mm_print_system"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psz(psz)
      call mm_get_pxs(pxs)
      call mm_get_psg(psg)

      if(ga_nodeid().eq.0) then
      do i=1,nsa
         do k=1,3
c           c(k)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
           c(k)=dbl_mb(pxs+(i-1)+(k-1)*msa)
         end do
         call cf_num2tag(mm_element(i),t)
         write(23,FMT=9000)
     >            int_mb(psl+i-1), 
     >            t,
     >            int_mb(psg+i-1),
c     >            c(1)*0.529177249d00,
c     >            c(2)*0.529177249d00,
c     >            c(3)*0.529177249d00,
     >            c(1),
     >            c(2),
     >            c(3),
     >            int_mb(psz+i-1),
     >            mm_quant(i),
     >            mm_fixed(i)

      end do
      end if

9000  FORMAT("ATOM",T7,I5,T13,A4,T23,I4,T31,
     >       F8.3,T39,F8.3,T47,F8.3,T55,I2,
     >       T60,L2,T62,L2)


      call ga_sync()

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_print_system()
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"



c     local variables
      integer i,k
      integer msa
      integer nsa
      integer psl
      integer psz
      integer pxs
      integer psg
      double precision c(3)
      character*16 t
      character*32 pname
      pname = "mm_print_system"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psz(psz)
      call mm_get_pxs(pxs)
      call mm_get_psg(psg)

      if(ga_nodeid().eq.0) then
      do i=1,nsa
         do k=1,3
c           c(k)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
           c(k)=dbl_mb(pxs+(i-1)+(k-1)*msa)
         end do
         call cf_num2tag(mm_element(i),t)
         write(23,FMT=9000)
     >            int_mb(psl+i-1), 
     >            t,
     >            int_mb(psg+i-1),
c     >            c(1)*0.529177249d00,
c     >            c(2)*0.529177249d00,
c     >            c(3)*0.529177249d00,
     >            c(1),
     >            c(2),
     >            c(3),
     >            int_mb(psz+i-1),
     >            mm_quant(i),
     >            mm_fixed(i)

      end do
      end if

9000  FORMAT("ATOM",T7,I5,T13,A4,T23,I4,T31,
     >       F12.6,4X,F12.6,4X,F12.6,4X,I2,
     >       4x,L2,4x,L2)


      call ga_sync()

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_print_system_file(fn)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"


      integer fn

c     local variables
      integer i,k
      integer msa
      integer nsa
      integer psl
      integer psz
      integer pxs
      integer psg
      double precision c(3)
      character*16 t
      character*32 pname
      pname = "mm_print_system"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psz(psz)
      call mm_get_pxs(pxs)
      call mm_get_psg(psg)

      if(ga_nodeid().eq.0) then
      do i=1,nsa
         do k=1,3
           c(k)=dbl_mb(pxs+(i-1)+(k-1)*msa)*cnm2au
         end do
         call cf_num2tag(mm_element(i),t)
         write(fn,FMT=9000)
     >            int_mb(psl+i-1), 
     >            t,
     >            int_mb(psg+i-1),
     >            c(1)*0.529177249d00,
     >            c(2)*0.529177249d00,
     >            c(3)*0.529177249d00,
     >            int_mb(psz+i-1),
     >            mm_quant(i),
     >            mm_fixed(i)

      end do
      end if

9000  FORMAT("ATOM",T7,I5,T13,A4,T23,I4,T31,
     >       F8.3,T39,F8.3,T47,F8.3,T55,I2,
     >       T60,L2,T62,L2)


      call ga_sync()

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_links(na,ai,nlinks,ilinks)
      implicit none
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "mafdecls.fh"

      integer na
      integer ai(na)
      integer nlinks(na)
      integer ilinks(na,max_nb+1)
c
c     local variables:
      integer i,in
      integer psb
      integer msb
      integer ind1,ind2,ind0
      character*32 pname
      pname = "mm_links"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call cf_get_msb(msb)
      call cf_get_psb(psb)

      do in=1,na
       nlinks(in) = 0
      end do

      do i=1,msb
        ind1=int_mb(psb+i-1)
        ind2=int_mb(psb+msb+i-1)
        write(*,*) ind1,ind2
        do in=1,na
          ind0=ilinks(in,1)
          if(ind0.eq.ind1) then
             nlinks(in)=nlinks(in)+1
             ilinks(in,nlinks(in)+1)=ind2
          else if(ind0.eq.ind2) then
             nlinks(in)=nlinks(in)+1
             ilinks(in,nlinks(in)+1)=ind1
          end if
        end do
      end do
      write(*,*) "link atom list"

      do in=1,na
        write(*,*) nlinks(in), (ilinks(in,i),i=1,max_nb+1)
      end do
      
      if(qmmm_print_debug()) write(*,*) "out "//pname
      return
 
      end

      subroutine mm_count_links(nl,h_lb,i_lb)
      implicit none
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "mm_utils.fh"
#include "errquit.fh"

      integer nl
      integer h_lb
      integer i_lb
c     local variables:
      integer i
      integer psb
      integer msb
      integer ind1,ind2
      integer ind_qm,ind_l
      integer iqm
      integer nqm
      integer h_qind,i_qind
      integer il,nl0
      integer h_lind,i_lind
      integer h_link,i_link
      character*32 pname
      pname = "mm_count_links"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_tot_nlink(nl0)
      if(qmmm_print_debug()) then
        write(*,*) pname,"number of link atoms",nl0
      end if
      if(nl0.eq.0)  then
        nl=nl0
        return
      end if

      call mm_get_tot_nqm(nqm)
      if(.not.ma_push_get(mt_int,nqm,'tmp qind',h_qind,i_qind))
     + call errquit(pname//'Failed to allocate stack',nqm,
     &       MA_ERR)

      call mm_get_solute_ind_gen(nqm,mm_quant,int_mb(i_qind))

      if(.not.ma_push_get(mt_int,nl0,'tmp lind',h_lind,i_lind))
     + call errquit(pname//'Failed to allocate stack',nl,
     &       MA_ERR)


      call mm_get_solute_ind_gen(nl0,mm_link,int_mb(i_lind))

      if(.not.ma_push_get(mt_int,nl0*max_nb,'tmp links',h_link,i_link))
     + call errquit(pname//'Failed to allocate stack',nl,
     &       MA_ERR)
      call ifill(nl0*max_nb,-1,int_mb(i_link),1)


      call cf_get_msb(msb)
      call cf_get_psb(psb)


      nl = 0
      do i=1,msb
        ind1=int_mb(psb+i-1)
        ind2=int_mb(psb+msb+i-1)
        do il=1,nl0
          ind_l = int_mb(i_lind+il-1)
          if((ind_l.eq.ind1) .or. (ind_l.eq.ind2)) then
            do iqm=1,nqm
              ind_qm = int_mb(i_qind+iqm-1)
              if((ind_qm.eq.ind1) .or. (ind_qm.eq.ind2)) then
                nl = nl+1
                int_mb(i_link+2*(nl-1))=ind_qm
                int_mb(i_link+2*nl-1)=ind_l
              end if
            end do
          end if 
        end do
      end do

      if(.not.ma_alloc_get(mt_int,2*nl,'link bond index',h_lb,i_lb))
     + call errquit(pname//'Failed to allocate heap',nl,
     &       MA_ERR)

      do i=1,nl
        int_mb(i_lb+i-1) = int_mb(i_link+2*(i-1))
        int_mb(i_lb+nl+i-1) = int_mb(i_link+2*i-1)
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname

      if(.not.ma_pop_stack(h_link))
     + call errquit(pname//'Failed to pop stack',nqm,
     &       MA_ERR)
      if(.not.ma_pop_stack(h_lind))
     + call errquit(pname//'Failed to pop stack',nqm,
     &       MA_ERR)
      if(.not.ma_pop_stack(h_qind))
     + call errquit(pname//'Failed to pop stack',nqm,
     &       MA_ERR)
      return
 
      end

      subroutine mm_count_qlinks(nps,h_ips,i_ips)
      implicit none
#include "qmmm.fh"
#include "qmmm_params.fh"
#include "mafdecls.fh"
#include "mm_utils.fh"
#include "errquit.fh"

      integer nps
      integer h_ips
      integer i_ips
c     local variables:
      integer nl,i,j
      integer psb
      integer msb
      integer ind1,ind2
      integer ind_qm,ind_l
      integer iqm
      integer nqm
      integer h_qind,i_qind
      integer il,nl0
      integer h_lind,i_lind
      integer h_link,i_link
      logical duplicate
      character*32 pname
      pname = "mm_count_links"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_tot_nlink(nl0)
      if(qmmm_print_debug()) then
        write(*,*) pname,"number of link atoms",nl0
      end if
      if(nl0.eq.0) then
         nps = 0
         return
      end if

      call mm_get_tot_nqm(nqm)
      if(.not.ma_push_get(mt_int,nqm,'tmp qind',h_qind,i_qind))
     + call errquit(pname//'Failed to allocate stack',nqm,
     &       MA_ERR)

      call mm_get_solute_ind_gen(nqm,mm_quant,int_mb(i_qind))

      if(.not.ma_push_get(mt_int,nl0,'tmp lind',h_lind,i_lind))
     + call errquit(pname//'Failed to allocate stack',nl0,
     &       MA_ERR)

      call mm_get_solute_ind_gen(nl0,mm_link,int_mb(i_lind))

      if(.not.ma_push_get(mt_int,nl0*max_nb,'tmp links',h_link,i_link))
     + call errquit(pname//'Failed to allocate stack',nl,
     &       MA_ERR)
      call ifill(nqm,-1,int_mb(i_link),1)


      call cf_get_msb(msb)
      call cf_get_psb(psb)


      nl = 0
      do i=1,msb
        ind1=int_mb(psb+i-1)
        ind2=int_mb(psb+msb+i-1)
        do il=1,nl0
          ind_l = int_mb(i_lind+il-1)
          if((ind_l.eq.ind1) .or. (ind_l.eq.ind2)) then
            do iqm=1,nqm
              ind_qm = int_mb(i_qind+iqm-1)
              if((ind_qm.eq.ind1) .or. (ind_qm.eq.ind2)) then
                duplicate = .false.
                do j=1,nl
                  if(int_mb(i_link+j-1).eq.ind_qm) go to 10
                end do
                nl = nl+1
                int_mb(i_link+nl-1)=ind_qm
10              continue
              end if
            end do
          end if 
        end do
      end do
      
      nps = nl

      if(.not.ma_alloc_get(mt_int,nps,'pseudo atom index',h_ips,i_ips))
     + call errquit(pname//'Failed to allocate heap',nps,
     &       MA_ERR)

      do i=1,nps
        int_mb(i_ips+i-1) = int_mb(i_link+i-1)
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname

      if(.not.ma_pop_stack(h_link))
     + call errquit(pname//'Failed to pop stack',nqm,
     &       MA_ERR)
      if(.not.ma_pop_stack(h_lind))
     + call errquit(pname//'Failed to pop stack',nqm,
     &       MA_ERR)
      if(.not.ma_pop_stack(h_qind))
     + call errquit(pname//'Failed to pop stack',nqm,
     &       MA_ERR)

      return
 
      end

      subroutine mm_reset_solvent_bqzone(nt,
     >                       ai)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)

      integer i,j

c     mm local variables
      integer mwa
      integer mwm
      integer nwm
      integer pwz
      integer pwl
      character*32 pname
      pname = "mm_reset_solvent_bqzone"
      if(qmmm_print_debug()) write(*,*) "in "//pname


      call mm_get_mwa(mwa)
      call mm_get_mwm(mwm)
      call mm_get_nwmloc(nwm)
      call mm_get_pwz(pwz)
      call mm_get_pwl(pwl)

 
      do i=1,nwm
        do j=1,nt/mwa
          if(int_mb(pwl+i-1).eq.ai(j)) then
             int_mb(pwz+i-1)=1
          end if
        end do
      end do


      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

      subroutine mm_reset_solute_bqzone(nt,
     >                       ai)
      implicit none

#include "qmmm_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "qmmm.fh"
#include "msgids.fh"
#include "mm_utils.fh"

      integer nt
      integer ai(nt)

      integer i,j

c     mm local variables
      integer msa
      integer nsa
      integer psl
      integer psz
      character*32 pname

      pname = "mm_reset_solute_bqzone"
      if(qmmm_print_debug()) write(*,*) "in "//pname

      call mm_get_msa(msa)
      call mm_get_nsaloc(nsa)
      call mm_get_psl(psl)
      call mm_get_psz(psz)

      do i=1,nsa
        do j=1,nt
          if(int_mb(psl+i-1).eq.ai(j)) then
             int_mb(psz+i-1)=1
          end if
        end do
      end do

      if(qmmm_print_debug()) write(*,*) "out "//pname
      end

*
* $Id: pspw_wannier_input.F 19707 2010-10-29 17:59:36Z d3y133 $
*

      subroutine pspw_wannier_input(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
c
      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 6)
      character*30 dirs(num_dirs)
      data dirs / 'old_wavefunction_filename',
     >            'new_wavefunction_filename',
     >            'vectors',
     >            'maxiter',
     >            'time_step',
     >            'end'/

      character*255 test
      character*50  new_wavefunction_filename
      character*50  old_wavefunction_filename
      integer it
      double precision tstep

*     ***** initializations ****

 10   if (.not. inp_read()) 
     >     call errquit(
     >           'pspw_wannier_input: inp_read failed', 0,0)
      if (.not. inp_a(test))
     >     call errquit(
     >      'pspw_wannier_input: failed to read keyword', 1,0)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit(
     >           'pspw_wannier_input: unknown directive', 2,0)


      goto ( 100,  200, 300, 400, 500,
     >      9999) ind
      call errquit(
     >   'pspw_wannier_input: unimplemented directive', ind,0)



c
c old_wavefunction_filename
c
 100  if (.not. inp_a(old_wavefunction_filename))
     >     call errquit(
     >      'pspw_wannier_input: failed to read keyword', 3,0)

      ind = index(old_wavefunction_filename,' ') - 1
      if (.not. rtdb_cput(rtdb,'wannier:input_wavefunction_filename',
     >                    1,old_wavefunction_filename(1:ind)))
     >     call errquit(
     >     'pspw_wannier_input: rtdb_cput failed', 7,0)
      goto 10


c
c new_wavefunction_filename
c
 200  if (.not. inp_a(new_wavefunction_filename))
     >     call errquit(
     >      'pspw_wannier_input: failed to read ', 4,0)

      ind = index(new_wavefunction_filename,' ') - 1
      if (.not. rtdb_cput(rtdb,'wannier:output_wavefunction_filename',
     >                    1,new_wavefunction_filename(1:ind)))
     >     call errquit(
     >     'pspw_wannier_input: rtdb_cput failed', 8,0)

      goto 10


c
c     vectors; get input vectors, output vectors, initial guess, etc.
c
 300  call nwpw_vectors_input(rtdb,'wannier')

      goto 10


c
c maxiter
c
 400  if (.not.inp_i(it)) it = 500
      if (.not.rtdb_put(rtdb,'wannier:maxiter',mt_int,1,it))
     >  call errquit('nwpw_input: error writing to rtdb',9,0)

      goto 10

c
c time_step
c
 500  if (inp_f(tstep)) then
        if (.not.rtdb_put(rtdb,'wannier:time_step',mt_dbl,1,tstep))
     >  call errquit('nwpw_input: error writing to rtdb',10,0)
      end if

      goto 10


*     ***** add wavefunction to rtdb ****
 9999 continue

      return
      end

*
* $Id: fci_onepdm.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_onepdm(vec, nvec, weight, onepdm)
      implicit none
#include "fciinfo.fh"
c     
c     Compute the AVERAGE 1-particle density matrix for the input
c     determinant CI vectors and weights.  Force the weights to
c     add up to unity.
c     
c     onepdm(p,q) returns sum(ivec) weight(ivec) <V(ivec)|Epq|V(ivec)>
c     
      integer nvec              ! [input] No. of vectors
      double precision vec(ndets, nvec) ! [input] The CI vectors
      double precision weight(nvec) ! [input] The weights
      double precision onepdm(nactiv,nactiv) ! [output] 1 PDM
c     
      integer nvecmx            ! Maximum value of nvec
      parameter (nvecmx=10) 
      double precision epq(ndetmx*nvecmx*nactmx) ! Should dynamically allocate
      integer numq, qlist(nactmx)
      integer iwalk, idim, iocc(nactmx), nsi, ioff, p, q, qq
      integer ivec, ivq, w, sym
      double precision sum
c     
      if (nvec.gt.nvecmx) call fci_err('fci_onepdm: nvecmx? ', nvec)
c
c     Normalize the weights
c
      sum = 0.0d0
      do ivec = 1, nvec
         sum = sum + weight(ivec)
      enddo
      if (sum .eq. 0.0d0) call fci_err('fci_onepdm: zero weight sum',0)
      do ivec = 1, nvec
         weight(ivec) = weight(ivec) / sum
      enddo
      write(6,11) (weight(ivec),ivec = 1, nvec)
 11   format(/' Weights for averaging density matrix ', 20f10.6)
      write(6,*)
c     
      call dfill(0.0d0, onepdm, 1, nactiv*nactiv)
c     
c     Loop thru orbital walks I and get information
c     
      do 10 iwalk = 1, nwalko
         call fci_owalk_info(iwalk, iocc, nsi, ioff, idim, sym)
         if (sym .ne. statesym) goto 10
c     
c     Loop thru orbitals p
c     
         do p = 1, nactiv
c     
c     Form  <V|Epq|Iw> for all q
c     
            call fci_couple1(vec, nvec, p, iocc, idim, 
     $           numq, qlist, epq)
c     
c     Multiply with the CI vectors and add into the matrices
c     
            do qq = 1, numq
               q = qlist(qq)
               do ivec = 1, nvec
                  ivq = idim*(ivec-1 + nvec*(qq-1)) ! epq(idim,nvec,nactiv)
                  sum = 0.0d0
                  do w = 1, idim
                     sum = sum + epq(ivq+w)*vec(ioff+w,ivec)
                  enddo
                  onepdm(p,q) = onepdm(p,q) + sum*weight(ivec)
               enddo
            enddo
         enddo
 10   continue                  ! iwalk loop
c     
c     Done.  Check the symmetry and then force exact symmetry.
c     
      do p = 1, nactiv
         do q = 1, nactiv
            if (abs(onepdm(p,q)-onepdm(q,p)) .gt. 1d-10) then
               write(6,*) ivec, p, q, onepdm(p,q), onepdm(q,p)
               call fci_err('fci_onepdm: not symmetric ', 100*p+q)
            endif
            sum = (onepdm(p,q)+onepdm(q,p))*0.5d0
            onepdm(p,q) = sum
            onepdm(q,p) = sum
         enddo
      enddo
c     
c     Check the trace
c     
      sum = 0.0d0
      do p = 1, nactiv
         sum = sum + onepdm(p,p)
      enddo
      if (abs(sum-dfloat(nelec)).gt.1d-10) call fci_err
     $     ('fci_onepdm: incorrect trace ', ivec)
c
      write(6,*) ' Average one particle density matrix '
      write(6,*)
      call fci_output(onepdm(1,1),1,nactiv,1,nactiv,nactiv,
     $     nactiv,1)
      write(6,*)
c     
      end

      logical function pre_dimens(lfnout,lfnsgm,
     + lseq,cseq,mseq,nseq,natm,nbnd,nang,ndih,nimp,nparms)
c
c $Id: pre_dimens.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     function to determine total system array dimensions
c
      implicit none
c
#include "util.fh"
c
      logical pre_sgmfil,pre_sgmsiz
      external pre_sgmfil,pre_sgmsiz
c
      integer lfnout,lfnsgm,mseq,nseq,natm,nbnd,nang,ndih,nimp,nparms
      integer lseq(6,mseq)
      character*10 cseq(mseq)
c
      character*255 filsgm
      integer i,nsatm,nsbnd,nsang,nsdih,nsimp
c
      natm=0
      nbnd=0
      nang=0
      ndih=0
      nimp=0
c
      pre_dimens=.true.
c
c     loop over sequence list
c     -----------------------
c
      do 1 i=1,nseq+1
      if(i.lt.nseq+1.or.cseq(i)(1:1).ne.' ') then
c
      if(util_print('where',print_debug)) then
      write(lfnout,1000) cseq(i)
 1000 format('SEARCHING FOR SEGMENT FILE FOR ',a10)
      endif
c
c     find segment file
c     -----------------
c
      if(pre_sgmfil(cseq(i),lfnsgm,filsgm)) then
c
      if(util_print('where',print_debug)) then
      write(lfnout,1001) filsgm(1:index(filsgm,' ')-1)
 1001 format('FOUND SEGMENT FILE ',a)
      endif
c
c     find segment dimensions
c     -----------------------
c
      if(.not.pre_sgmsiz(lfnsgm,filsgm,nsatm,nsbnd,nsang,nsdih,nsimp,
     + nparms))
     + call md_abort('pre_sgmsiz failed',9999)
c
      natm=natm+nsatm
      nbnd=nbnd+nsbnd
      nang=nang+nsang
      ndih=ndih+nsdih
      nimp=nimp+nsimp
c
      else
      if(util_print('topology',print_none)) then
      write(lfnout,1002) cseq(i)
 1002 format('A SEGMENT FILE COULD NOT BE FOUND FOR ',a10)
      endif
      pre_dimens=.false.
      endif
      endif
    1 continue
c
      return
      end

      subroutine argos_prep_quick_charge(lfnout,lfnpar,
     + ilo,ihi,
     + latm,catm,qatm,matm,natm,lbnd,qbnd,mbnd,nbnd)
c
      implicit none
c
#include "util.fh"
#include "argos_prep_common.fh"
c
      integer lfnout,lfnpar
      integer matm,natm,mbnd,nbnd,ilo,ihi
      character*255 filnam
      integer latm(5,matm)
      real*8 qatm(matm)
      character*6 catm(3,matm)
      integer lbnd(2,mbnd)
      real*8 qbnd(mbnd)
      character*100 card
c
      integer i,j,k,l,lt,ld,len
      real*8 q
c
      do 1 i=1,nbnd
      qbnd(i)=0.0d0
    1 continue
c
      do 7 j=1,mdirpar
      do 77 k=1,nfilpar(j)
      write(filnam,'(a,a)') dirpar(j)(1:index(dirpar(j),' ')-1),
     + filpar(j,k)(1:index(filpar(j,k),' '))
      len=index(filnam,' ')-1
      open(unit=lfnpar,file=filnam(1:len),status='old',form='formatted',
     + err=2)
    3 continue
      read(lfnpar,1000,end=4,err=9999) card
      if(card(1:5).ne.'Bonds') goto 3
      if(util_print('files',print_medium)) then
      write(lfnout,2000) filnam(1:len)
 2000 format(' Bond charge definitions',t40,a)
      endif
    5 continue
      read(lfnpar,1000,end=4,err=9999) card
 1000 format(a)
      if(card(1:1).eq.'#'.or.card(1:4).eq.'    ') goto 5
      if(card(1:6).eq.'Angles') goto 4
      read(card(34:45),'(f12.6)') q
      do 6 i=1,nbnd
      if(catm(3,lbnd(1,i))(1:4).eq.card(1:4).and.
     + catm(3,lbnd(2,i))(1:4).eq.card(7:10)) qbnd(i)=q
      if(catm(3,lbnd(2,i))(1:4).eq.card(1:4).and.
     + catm(3,lbnd(1,i))(1:4).eq.card(7:10)) qbnd(i)=-q
    6 continue
      goto 5
    4 continue
      close(unit=lfnpar)
      if(util_print('where',print_debug)) then
      write(lfnout,'(a,a)') filnam(1:len),' closed'
      endif
    2 continue
   77 continue
    7 continue
c
      do 8 i=1,nbnd
      qatm(lbnd(1,i))=qatm(lbnd(1,i))+qbnd(i)
      qatm(lbnd(2,i))=qatm(lbnd(2,i))-qbnd(i)
    8 continue
c
      return
 9999 continue
      call md_abort('Error in argos_prep_quick_charge',0)
      return
      end
c $Id: argos_prep_quick_charge.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_gauss1(tgauss,frgaus,
     + numw,nums,vw,vs,iwdt,isdt,iwat,isat,wgt)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "util.fh"
c
      real*8 tgauss,frgaus
      integer numw,nums
      real*8 vw(mwm,3,mwa),vs(msa,3),wgt(mat,mset)
      integer iwdt(mwm),isdt(msa),iwat(mwa),isat(msa)
c
      real*8 facdof,rran,tdev
      integer iwa,iwm,ix,isa,iran
c
      tdev=zero
c
      if(numw.gt.0) then
      facdof=rgas*tgauss
      do 1 iwa=1,nwa
      if(facdof.gt.zero) tdev=sqrt(facdof/wgt(iwat(iwa),iset))
      do 2 iwm=1,numw
      if(iwdt(iwm).ne.0) then
      vw(iwm,1,iwa)=zero
      vw(iwm,2,iwa)=zero
      vw(iwm,3,iwa)=zero
      else
      do 3 ix=1,3
      rran=zero
      do 4 iran=1,12
      rran=rran+util_random(0)
    4 continue
      if(facdof.gt.zero) then
      vw(iwm,ix,iwa)=(one-frgaus)*vw(iwm,ix,iwa)+frgaus*(rran-six)*tdev
      else
      vw(iwm,ix,iwa)=zero
      endif
    3 continue
      endif
    2 continue
    1 continue
      endif
c
      if(nums.gt.0) then
      facdof=rgas*tgauss
      do 5 isa=1,nums
      if(isdt(isa).ne.0) then
      vs(isa,1)=zero
      vs(isa,2)=zero
      vs(isa,3)=zero
      else
      do 6 ix=1,3
      rran=zero
      do 7 iran=1,12
      rran=rran+util_random(0)
    7 continue
      if(facdof.gt.zero) then
      vs(isa,ix)=(one-frgaus)*vs(isa,ix)+
     + frgaus*(rran-six)*sqrt(facdof/wgt(isat(isa),iset))
      else
      vs(isa,ix)=zero
      endif
    6 continue
      endif
    5 continue
      endif
c
      return
      end
c $Id: argos_cafe_gauss1.F 21176 2011-10-10 06:35:49Z d3y133 $

      function smd_system_periodic()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c
      logical smd_system_periodic
c     
      character*32 pname,tag,sp_lattice
      logical result
c
      pname = "smd_system_periodic"
c
c      write(*,*) "in "//pname
c
c     get components
c     --------------
      tag = "lattice"
      call smd_system_get_component(sp_lattice,tag,result)
      
      smd_system_periodic = result
      return
      end

      function smd_system_shake()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c
      logical smd_system_shake
c     
      integer rtdb
      character*32 pname,tag,sp_lattice
      logical oshake,oshake_rtdb
c
      pname = "smd_system_shake"
c
      write(*,*) "in "//pname
c
c     get components
c     --------------
      tag = "shakelist"
      call smd_system_get_component(sp_lattice,tag,oshake)

      tag="smd:oshake"
      call smd_rtdb_get_handle(rtdb)
      if (.not.rtdb_get(rtdb,tag,mt_log,1,oshake_rtdb))
     >      oshake_rtdb=.true.

      
      smd_system_shake = oshake.and.oshake_rtdb
      return
      end

      function smd_system_ntot(ntot)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      logical smd_system_ntot
      integer ntot
c
      character*72 tag,sp_atom
      character*30 pname
      integer i_iconst
      logical result

      pname = "smd_system_ntot"

      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result) goto 100

      call smd_atom_ntot(ntot)

100   continue
      smd_system_ntot = result
      return
      end

      function smd_system_nres(nr)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      logical smd_system_nres
      integer nr
c
      character*72 tag,sp_atom
      character*30 pname
      integer i_iconst
      logical result

      pname = "smd_system_ntot"

      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result) goto 100

      call smd_atom_nres(sp_atom,nr)

100   continue
      smd_system_nres = result
      return
      end

      subroutine smd_system_ntcons(ntot)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer ntot
c
      character*72 tag,sp_shakelist
      character*30 pname
      integer i_iconst
      logical result

      pname = "smd_system_nt"

      ntot = 0
      tag = "shakelist"
      call smd_system_get_component(sp_shakelist,tag,result)
      if(.not.result) then
        goto 100
      end if

      tag = "shake:distance"
      call smd_data_get_size(sp_shakelist,tag,ntot,result)
      if(.not.result)
     >  call errquit(
     >       pname//'failed size on '//tag,0,0)

100   continue
      return
      end

      function smd_system_tstep(t)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c
      double precision t
      logical smd_system_tstep
c     
      character*32 pname,tag
      logical result
      integer rtdb
c
      pname = "smd_system_tstep"
c
      write(*,*) "in "//pname
c
      call smd_rtdb_get_handle(rtdb)
      tag="smd:step"
      result = rtdb_get(rtdb,tag,mt_dbl,1,t)
      
      smd_system_tstep = result
      return
      end

      function smd_system_ndata(nd)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c
      integer nd
      logical smd_system_ndata
c     
      character*32 pname,tag
      logical result
      integer rtdb
c
      pname = "smd_system_ndata"
c
      write(*,*) "in "//pname
c
      call smd_rtdb_get_handle(rtdb)
      tag="smd:ndata"
      result = rtdb_get(rtdb,tag,mt_int,1,nd)
      
      smd_system_ndata = result
      return
      end
c $Id: smd_system.F 22502 2012-05-20 06:11:57Z d3y133 $

      logical function argos_prep_wrtseq(lfnseq,filseq,lfnout,
     + cseq,lseq,mseq,nseq,lssb,mssb,nssb,llnk,clnk,mlnk,nlnk,nlnkf,
     + slvmdl,mcount,ncount,icount,scount,mfract,nfract,ifract)
c
c $Id: argos_prep_wrtseq.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to write the sequence file
c
      implicit none
c
#include "util.fh"
c
      integer lfnseq,mseq,nseq,mssb,nssb,mlnk,nlnk,nlnkf,lfnout
      integer lseq(6,mseq),lssb(2,mssb),llnk(4,mlnk)
      character*4 clnk(2,mlnk)
      character*5 cseq(2,mseq)
      character*10 slvmdl
      character*255 filseq
      integer mcount,ncount
      integer i,j,l,length,mol,molec,icount(mcount),ll
      character*4 scount(mcount)
      integer mfract,nfract,ifract(mfract)
c
      length=index(filseq,' ')-1
c
      open(unit=lfnseq,file=filseq(1:length),form='formatted',
     + status='new',err=9999)
c
      ll=0
      mol=0
      molec=1
      do 1 i=1,nseq
      if(i.gt.1.and.lseq(4,i).ne.mol) then
      if(nfract.eq.0) then
      write(lfnseq,1001)
 1001 format('molecule')
      else
      do 11 j=1,nfract
      if(ifract(j).eq.molec) then
      write(lfnseq,1005)
      goto 111
      endif
   11 continue
      write(lfnseq,1001)
  111 continue
      endif
      molec=molec+1
      endif
      mol=lseq(4,i)
      length=index(cseq(2,i),'_')-1
      if(length.le.0) length=5
c      write(lfnseq,1000) lseq(1,i),cseq(2,i)(1:length)
      write(lfnseq,1000) lseq(1,i),cseq(2,i)
 1000 format(i5,a)
      ll=lseq(1,i)
    1 continue
c
      if(ncount.gt.0) then
      write(lfnseq,1005)
 1005 format('fraction')
      l=0
      do 3 i=1,ncount
      do 33 j=1,icount(i)
      l=l+1
      write(lfnseq,1006) ll+l,scount(i)
 1006 format(i5,a)
      if(i.lt.ncount.or.j.lt.icount(i)) write(lfnseq,1007)
 1007 format('molecule')
   33 continue
      if(util_print('topology',print_medium)) then
      write(lfnout,1060) icount(i),scount(i)
 1060 format(' Appended ',i5,' counter ions ',a,' to topology')
      endif
    3 continue
      endif
c
c      do 2 i=1,nssb
c      write(lfnseq,1002) lssb(1,i),3,lssb(2,i),3
c    2 continue
c
      do 4 i=1,nlnk
      if(i.le.nlnkf) then
      write(lfnseq,1002) lseq(1,llnk(1,i)),clnk(1,i),
     + lseq(1,llnk(2,i)),clnk(2,i)
 1002 format('LINK ',i5,a4,i5,a4)
      else
      write(lfnseq,1003) lseq(1,llnk(1,i)),clnk(1,i),
     + lseq(1,llnk(2,i)),clnk(2,i)
 1003 format('link ',i5,a4,i5,a4)
      endif
    4 continue
c
c     solvent model
c     -------------
c
      if(slvmdl(1:1).ne.' ') then
      write(lfnseq,1004) 0,slvmdl
 1004 format('solvent',/,i5,a)
      endif
c
      write(lfnseq,1009)
 1009 format('stop')
c
      close(unit=lfnseq)
      argos_prep_wrtseq=.true.
      return
 9999 continue
      argos_prep_wrtseq=.false.
      return
      end

      subroutine smd_bondlist_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_bond,sp_type,sp_bondlist
      character*32 tag,pname
      logical result

      pname = "smd_bondlist_init_system"
c
      tag = "bond"
      call smd_system_get_component(sp_bond,tag,result)
      if(.not.result) goto 200

      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "bondlist"
      call smd_system_get_component(sp_bondlist,tag,result)
      if(.not.result) 
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_bondlist_init(sp_bondlist,result)

200   continue
      if(.not.result) then
       tag = "bondlist"
       call smd_system_unset_component(tag)
      end if
c
      return
      end

      subroutine smd_bondlist_init(sp_bondlist,result)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_bondlist
      integer rtdb
c
      character*32 pname
      character*80 tag
      character*255 filename
      integer na,nb,ns
      integer i_it
      integer i_kb
      integer i_ib1,i_ib2,i_db,i_itb
      integer h_il1t,i_il1t
      integer h_il2t,i_il2t
      integer h_dlt,i_dlt
      integer h_klt,i_klt
      integer h_tlt,i_tlt
      integer i_il1
      integer i_il2
      integer i_dl
      integer i_kl
      integer i_tl
      logical result
      integer i
c
      pname = "smd_bondlist_init"
c
c      write(*,*) "in "//pname
c
c     get array of types
c     ------------------
      tag = "type:id"
      call smd_get_ind_dim(tag,i_it,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c     get bond arrays
c     ---------------
      tag = "bond:i1"
      call smd_get_ind(tag,i_ib1,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:i2"
      call smd_get_ind(tag,i_ib2,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:distance"
      call smd_get_ind(tag,i_db,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:strength"
      call smd_get_ind(tag,i_kb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)


      tag = "bond:type"
      call smd_get_ind_dim(tag,i_itb,nb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

c
c     allocate initial storage for bond list
c     ---------------------------------------
      ns = na
      if(.not.ma_push_get(mt_int,ns,'tmp i1',h_il1t,i_il1t))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_int,ns,'tmp i2',h_il2t,i_il2t))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_dbl,ns,'tmp d',h_dlt,i_dlt))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_dbl,ns,'tmp k',h_klt,i_klt))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_int,ns,'tmp t',h_tlt,i_tlt))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)


      call smd_bondlist_set(ns,nb,na,
     >                       int_mb(i_il1t),
     >                       int_mb(i_il2t),
     >                       int_mb(i_tlt),
     >                       dbl_mb(i_dlt),
     >                       dbl_mb(i_klt),
     >                       int_mb(i_ib1),
     >                       int_mb(i_ib2),
     >                       int_mb(i_itb),
     >                       dbl_mb(i_db),
     >                       dbl_mb(i_kb),
     >                       int_mb(i_it))
c
c     create bond list structure
c     ---------------------------
      if(ns.eq.0) then
        result = .false.
        goto 200
      end if
      call smd_namespace_create(sp_bondlist)
      tag = "bond:i1"
      call smd_data_create_get(sp_bondlist,tag,ns,MT_INT,i_il1)
      tag = "bond:i2"
      call smd_data_create_get(sp_bondlist,tag,ns,MT_INT,i_il2)
      tag = "bond:distance"
      call smd_data_create_get(sp_bondlist,tag,ns,MT_DBL,i_dl)
      tag = "bond:strength"
      call smd_data_create_get(sp_bondlist,tag,ns,MT_DBL,i_kl)
      tag = "bond:type"
      call smd_data_create_get(sp_bondlist,tag,ns,MT_INT,i_tl)

c
      do i=1,ns
       int_mb(i_il1+i-1) = int_mb(i_il1t+i-1)
       int_mb(i_il2+i-1) = int_mb(i_il2t+i-1)
       int_mb(i_tl+i-1)  = int_mb(i_tlt+i-1)
       dbl_mb(i_dl+i-1)  = dbl_mb(i_dlt+i-1)
       dbl_mb(i_kl+i-1)  = dbl_mb(i_klt+i-1)
      end do

200   continue

      if(.not.ma_pop_stack(h_tlt))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_klt))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_dlt))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_il2t))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_il1t))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      return
      end

      subroutine smd_bondlist_set(ns,nb,na,
     >                       il1,
     >                       il2,
     >                       itl,
     >                       dl,
     >                       kl,
     >                       ib1,
     >                       ib2,
     >                       itb,
     >                       db,
     >                       kb,
     >                       it)
c
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer ns,nb,na
      integer il1(ns)
      integer il2(ns)
      integer itl(ns)
      double precision  dl(ns)
      double precision  kl(ns)
      integer ib1(nb)
      integer ib2(nb)
      integer itb(nb)
      double precision  db(ns)
      double precision  kb(ns)
      integer it(na)
c
      integer i,i1,i2,j,nlist
c
      nlist = 0
      do i=1,nb
        i1=0
        i2=0
        do j=1,na
         if(it(j).eq.ib1(i)) i1=j
         if(it(j).eq.ib2(i)) i2=j
         if(i1*i2.ne.0) then
          nlist = nlist + 1
          il1(nlist) = min(i1,i2)
          il2(nlist) = max(i1,i2)
          itl(nlist) = itb(i)
          kl(nlist)  = kb(i)
          dl(nlist)  = db(i)
          i1=0
          i2=0
         end if
        end do
      end do
      ns = nlist

      return
      end

c $Id: smd_bondlist.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: fci_couple1.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_couple1(vec, nvec, p, iocc, idim, 
     $     numq, qlist, epq)
      implicit none
#include "fciinfo.fh"
c     
c     Compute <V|Epq|Iw> for given CI vectors V, fixed 
c     orbital p, fixed orbital occupancy I (iocc), and all orbitals q
c     and primitive spin functions w.
c     
c     numq returns the number of orbitals q giving a nonzero interaction
c     
c     qlist(1...numq) contains the values of q
c     
c     epq(1...idim,1...nvec,1...numq) contains the coupling coeffcients
c     
      integer nvec              ! [input] No. of vectors on the left hand side
      double precision vec(ndets,nvec) ! [input] The CI vectors
      integer p                 ! [input] Fixed label on Epq
      integer iocc(nactiv)      ! [input] Orbital occupation of I
      integer idim              ! [input] No. of spin functions for I
      integer numq              ! [output] Returns the number of q
      integer qlist(*)          ! [output] Returns the list of interacting q
      double precision epq(idim,nvec,*) ! [output] epq(w,i,q) = <Vi|Epq|Iw>
c     
c     <V|Epq|Iw> = sum(Jv) V(Jv) <Jv|Epq|Iw> 
c     .          = sum(Jv) V(Jv) sum(u) <Jv|Epa|Ku><Ku|Eaq|Iw>
c     .          = sum(Jv) V(Jv) sum(u) <Ku|Eap|Jv><Ku|Eaq|Iw>
c     
c     The strategy is then to
c     
c     1) Loop over q occupied in I 
c     2) Form <Ku|Eaq|Iw>
c     3) Determine K
c     4) Determine occupations in J 
c     5) Form <Ku|Eap|Jv>
c     6) For each vector V <V|Epq|Iw> = sum(u) <Ku|Eap|Jv><Ku|Eaq|Iw>
c     .  noting that v = v(u).  If result is non-zero then add it in.
c     
      integer indbar(nactmx)    ! Position amoung singly occupied for I/K
      integer jperm(ndetmx), iperm(ndetmx) ! Permutations of spin functions
      double precision jval(ndetmx), ival(ndetmx) ! Phase factors
c     
      integer nsi, nsj, nsk     ! No. of unpaired spins in I, J, and K
      integer jdim, kdim        ! No. of determinants for J and K
      integer np, nq            ! Occuption of p in J and q in I
      integer jwalk             ! Lexical index of J
      integer jdet              ! Offset of J in CI vector
      integer symi              ! Symmetry of I
      integer symq              ! Required symmetry for q
      integer q, w, u, v, pbar, qbar, deltaq, idummy, i, qlo, qhi, ivec
      double precision sum, value
#include "bitops.fh"      
c     
      call fci_tstart(1,.false.)
      numq = 1
c     
c     Find I occupancy, compute no. of open shells and I indbar vector
c     
      nsi = 0
      symi = 0
      do i = 1,nactiv
         if (iocc(i).eq.2) then
            nsi = nsi + 1
            symi = ieor(symi,orbsym(i))
         endif
         indbar(i) = nsi
      enddo
      if (idim .ne. mnsdet(nsi)) call fci_err
     $     ('fci_couple1: mismatch for idim ', idim)
c
      symq = ieor(ieor(symi,orbsym(p)),statesym)
c     
c     Loop thru occupied q.  Note that if p is doubly occupied in
c     I then the only non-zero value is for q=p
c     
      if (iocc(p) .eq. 3) then
         qlo = p
         qhi = p
      else
         qlo = 1
         qhi = nactiv
      endif
c     
      do q = qlo, qhi
         nq = iocc(q)-1
         if (nq.gt.0 .and. orbsym(q).eq.symq) then
            iocc(q) = iocc(q) - 1 ! iocc now refers to K
c
            np = iocc(p)        ! Since iocc refers to K and we want J
            if (np .lt. 3) then
               iocc(p) = iocc(p) + 1 ! iocc now refers to J
c
c     Form <Ku|Eaq|Iw>
c     
               qbar = indbar(q)
               nsk  = nsi
               deltaq = -1
               if (nq .eq. 2) then
                  nsk = nsk + 2
                  qbar = qbar + 1
                  deltaq = 1
               endif
               kdim = mnsdet(nsk)
               call fci_apply_eaj(qbar, nq, idim, kdim, 
     $              eajdata(eajptr(nsi)), eajphase(1,1,nsi), .true.,
     $              idummy, idummy, iperm, ival)
c     
c     Determine info about J orbital occupation
c     
               call fci_ofind_weight(jwalk,iocc)
               pbar = indbar(p)
               if (np .eq. 1) pbar = pbar + 1 ! Since indbar refers to K
               if (p .ge. q) pbar = pbar + deltaq
               nsj = nsk
               if (np .eq. 2) nsj = nsj - 2 
               jdim = mnsdet(nsj)
c     
c     Form <Ku|Eap|Jv>
c     
               call fci_apply_eaj(pbar, np, jdim, kdim, 
     $              eajdata(eajptr(nsj)), eajphase(1,1,nsj), .true.,
     $              idummy, idummy, jperm, jval)
c     
c     Now use <Jv|Epq|Iw> = <Ku|Eap|Jv>*<Ku|Eaq|Iw>
c     
c     noting w(u)=iperm(u), v(u)=jperm(u), <Ku|Eap|Jv>=jval(u) and
c     .      <Ku|Eaq|Iw>=ival(u)
c     
               do ivec = 1, nvec
                  do w = 1, idim
                     epq(w,ivec,numq) = 0.0d0
                  enddo
               enddo
c     
               jdet = indexo(jwalk)
               sum = 0.0d0
               do ivec = 1, nvec
                  do u = 1, kdim
                     v = jperm(u)
                     w = iperm(u)
                     value = vec(jdet+v,ivec)*jval(u)*ival(u)
                     epq(w,ivec,numq) = epq(w,ivec,numq) + value
                     sum = sum + value*value
                  enddo
               enddo
               if (abs(sum) .gt. 0.0d0) then
                  qlist(numq) = q
                  numq = numq + 1
               endif
c
               iocc(p) = iocc(p) - 1 ! iocc now refers to K
            endif
c     
            iocc(q) = iocc(q) + 1 ! iocc now refers to I
         endif
      enddo
c     
      numq = numq - 1
c     
      call fci_tfinish(1,.false.)
c
      end
      

       program pair_correlation
       implicit none
       integer i,l
       double precision lat(3,3)
       double precision rmax
       integer i1,nb
       character*255 infile
       character*5 atag
       logical ofile
       
c
       inquire(file="pair.dat",exist=ofile)
       if(ofile) then
          open(10,file="pair.dat",
     $            form='formatted',status='old')
c         max distance
          read(10,*) rmax
c         lattice vectors a,b,c
          read(10,*) (lat(i,1),i=1,3)
          read(10,*) (lat(i,2),i=1,3)
          read(10,*) (lat(i,3),i=1,3)
c         index of central ion
          read(10,*) i1
c         tag of secondary ions
          read(10,*) atag
c         number of bins
          read(10,*) nb
c         xyz trajectory file name
          read(10,*) infile
          close(10)
       else
       write(6,*) "Please provide pair.dat file in the following format"
       write(*,*) "Maximum Distance:"
       write(*,*) "Lattice vectors"
       write(*,*) "Central ion index:"
       write(*,*) "Secondary ion tag:"
       write(*,*) "Number of bins:"
       write(*,*) "XYZ input file: "

       stop
       end if 
c      check if xyzfile does exist
       inquire(file=infile,exist=ofile)     
       if(.not.ofile) then
         write(6,*) "Cannot find xyz input file: ", infile
         stop
       end if
       write(*,*) "Maximum Distance:",rmax 
       write(*,*) "Lattice vectors"
       write(*,*) (lat(i,1),i=1,3)
       write(*,*) (lat(i,2),i=1,3)
       write(*,*) (lat(i,3),i=1,3)
       write(*,*) "Index of central ion:",i1
       write(*,*) "Secondary ion tag:",atag
       write(*,*) "Number of bins:",nb
       write(*,*) "XYZ input file: ",infile
c
       call pair_compute(rmax,lat,i1,atag,nb,infile)
       end

       subroutine pair_compute(rmax,lat,i1,atag,nb,infile)
       implicit none
       double precision lat(3,3)
       double precision rmax
       integer i1,nb
       character*(*) atag
       character*(*) infile
c
       integer j
       integer i,n,a,nd,k,n0
       double precision rlat(3,3),r1(3)
       double precision, dimension(:,:), allocatable :: c
       double precision, dimension(:,:), allocatable :: rd
       character*5, dimension(:), allocatable :: tag
       integer, dimension(:), allocatable :: gr
       double precision, dimension(:), allocatable :: grs
       character*30 buf
       character*180 bigbuf
       double precision d,dr
       double precision fourpi,x
       integer  nf 
       double precision vol,sum,norm,const,rl,ru,rho
       integer l,sl
 
c
       open(22,file="tmp.xyz",
     $            form='formatted',status='unknown')
c
c
       nf = 0
c
c      size of the bin
       dr = rmax/nb
c      g(r) array
       allocate(gr(nb))
       allocate(grs(nb))
       gr = 0
       grs = 0.0d0
c      get reciprocal lattice vectors 
       call smd_lat_invrt(lat,rlat)
       write(*,*) "Inverse Lattice vectors"
       write(*,*) (rlat(i,1),i=1,3)
       write(*,*) (rlat(i,2),i=1,3)
       write(*,*) (rlat(i,3),i=1,3)
c      get lattice volume
       call smd_latt_vol(lat,vol)
c
c      allocate other memory
       open(10,file=infile,
     $            form='formatted',status='old')
       read(10,*) n
       rewind(10)
       allocate(c(n,3))
       allocate(rd(n,3))
       allocate(tag(n))
c      start calculating distances
       l = 0
       n0 = 0
10     continue
c
c      get number of atoms (skipping empty lines)
c      ------------------------------------------
11     continue
       read(10,20,end=135) bigbuf
c      increment line number
       l=l+1
       if(bigbuf.eq."") goto 11
       read(bigbuf,*,err=136) n
c      check if number of atoms consistent with prior
       if(n0.eq.0) then
         n0=n
       else if(n0.ne.n) then
         goto 136
       end if
c
c      get title field(if any) 
c      -------------------
       read(10,20) bigbuf
       l=l+1
c      processing coodinates
       j = 0
       do i=1,n
c
c       read coordinates(skipping empty lines)
c       ------------------------------------
12      continue
        read(10,20) bigbuf
        l=l+1
        if(bigbuf.eq."") goto 12
        read(bigbuf,*,err=137) tag(i),(c(i,k),k=1,3)
c
c       extract coords of secondary atoms
c       with "atag" name (i1 is a central atom)
c       ---------------------------------------
c        if((tag(i).eq.atag).and.i.ne.i1) then
        sl = len_trim(atag)
        if(index(tag(i),atag(1:sl)).ne.0) then
        if(i.ne.i1) then
          j = j+1
          rd(j,:) = c(i,:)
        end if
        end if
       end do
       
c
c      construct relative distances
c      ----------------------------
       nd = j 
       r1 = c(i1,:)
       do j=1,nd
         rd(j,:) = rd(j,:)-r1
       end do

c
c      fold the distances into the box
c      -------------------------------
       call smd_util_rebox(nd,n,lat,rlat,rd)

c
c      compute histogram
c      -----------------
       do j=1,nd
         d=sqrt(rd(j,1)*rd(j,1)+rd(j,2)*rd(j,2)+rd(j,3)*rd(j,3))
         k = int(d/dr)+1
         if(k.le.nb ) then
          gr(k) = gr(k) + 1
         end if
       end do
       nf = nf + 1

       goto 10
      
135    continue
        write(*,*) "Number of frames processed",nf
c
c      smoothing g(r) per Allan/Tild. p 204 (6.48)
c      ------------------------------------------
       grs(1)=(69.0*gr(1)+4.0*gr(2)-6.0*gr(3)+
     >         4.0*gr(4)-gr(5))/70.0d0
       grs(2)=(2.0*gr(1)+27.0*gr(2)+12.0*gr(3)
     >  -8.0*gr(4)+2.0*gr(5))/35.0d0
       do i=3,nb-2
         grs(i) =(-3.0*gr(i-2)+12.0*gr(i-1)+17.0*gr(i)+
     >            12.0*gr(i+1)-3.0*gr(i+2))/35.0d0 
       end do
       grs(nb-1)=(2.0*gr(nb)+27*gr(nb-1)+12.0*gr(nb-2)-
     >            8.0*gr(nb-3)+2.0*gr(nb-4))/35.0d0
       grs(nb)=(69.0*gr(nb)+4.0*gr(nb-1)-6.0*gr(nb-2)+
     >          4.0*gr(nb-3)-gr(nb-4))/70.0d0
       open(12,file="gr.dat",
     $            form='formatted',status='unknown')

       fourpi = 16.0*atan(1.0)
       rho = real(nd)/vol
       x = 1.0/real(nf)
       const = fourpi*rho/3.0d0
       sum = 0.0d0
       do k=1,nb
         rl = real(k-1)*dr
         ru = rl+dr
         norm = const*(ru**3-rl**3)
         sum = sum + grs(k)*x
c         write(12,'(i5,F12.6,I5,F12.6,F12.6)') 
c     >             k,ru,gr(k),sum,real(gr(k))*x/norm
         write(12,'(3F12.6)') 
     >             ru,real(grs(k))*x/norm,sum
       end do
       return
c      error section
c      -------------
136    continue
       write(*,*) "error number of atoms field"
       write(*,*) "line number: ", l
       write(*,*) "buffer: ",bigbuf
       return
137    continue
       write(*,*) "error reading coords field"
       write(*,*) "line number: ", l
       write(*,*) "buffer: ", bigbuf
       return
c
c      format statements
c      -----------------
30     FORMAT(180A1)
20     FORMAT(A180)
       end

      subroutine smd_util_rebox(n,nmax,latt,rlatt,aaa)

      implicit none

      integer n,nmax
      double precision rlatt(3,3),latt(3,3)
      double precision  aaa(nmax,3)
c
      integer i
      double precision  ssx,ssy,ssz,xss,yss,zss
      logical oprint


      if(n.eq.1) then
       oprint =.true.
      else
       oprint = .false.
      end if
      oprint = .false.
      do i=1,n

       if(oprint)
     >          write(*,*) "rebox",aaa(i,1),aaa(i,2),aaa(i,3)
       ssx=(rlatt(1,1)*aaa(i,1)+rlatt(1,2)*aaa(i,2)+rlatt(1,3)*aaa(i,3))
       ssy=(rlatt(2,1)*aaa(i,1)+rlatt(2,2)*aaa(i,2)+rlatt(2,3)*aaa(i,3))
       ssz=(rlatt(3,1)*aaa(i,1)+rlatt(3,2)*aaa(i,2)+rlatt(3,3)*aaa(i,3))

       xss=ssx-nint(ssx)
       yss=ssy-nint(ssy)
       zss=ssz-nint(ssz)

       aaa(i,1)=(latt(1,1)*xss+latt(1,2)*yss+latt(1,3)*zss)
       aaa(i,2)=(latt(2,1)*xss+latt(2,2)*yss+latt(2,3)*zss)
       aaa(i,3)=(latt(3,1)*xss+latt(3,2)*yss+latt(3,3)*zss)

      enddo

      return

      END

      subroutine smd_latt_vol(latt,vol)
      implicit none
      real*8 x,y,z,latt,vol

      dimension latt(3,3)

      x=latt(2,2)*latt(3,3)-latt(2,3)*latt(2,3)
      y=latt(3,2)*latt(1,3)-latt(1,2)*latt(3,3)
      z=latt(1,2)*latt(2,3)-latt(2,2)*latt(1,3)

      vol=abs(latt(1,1)*x+latt(2,1)*y+latt(3,1)*z)

      return

      END

      subroutine smd_lat_invrt(latt,rlatt)
      implicit none
      double precision  latt(3,3),rlatt(3,3)
c
      double precision  det

      rlatt(1,1)=latt(2,2)*latt(3,3)-latt(3,2)*latt(2,3)
      rlatt(2,1)=latt(3,1)*latt(2,3)-latt(2,1)*latt(3,3)
      rlatt(3,1)=latt(2,1)*latt(3,2)-latt(3,1)*latt(2,2)
      rlatt(1,2)=latt(3,2)*latt(1,3)-latt(1,2)*latt(3,3)
      rlatt(2,2)=latt(1,1)*latt(3,3)-latt(3,1)*latt(1,3)
      rlatt(3,2)=latt(3,1)*latt(1,2)-latt(1,1)*latt(3,2)
      rlatt(1,3)=latt(1,2)*latt(2,3)-latt(2,2)*latt(1,3)
      rlatt(2,3)=latt(2,1)*latt(1,3)-latt(1,1)*latt(2,3)
      rlatt(3,3)=latt(1,1)*latt(2,2)-latt(2,1)*latt(1,2)

      det=latt(1,1)*rlatt(1,1)+latt(1,2)*rlatt(2,1)+latt(1,3)*rlatt(3,1)
      if(abs(det).gt.0.d0)det=1.d0/det

      rlatt(1,1)=det*rlatt(1,1)
      rlatt(2,1)=det*rlatt(2,1)
      rlatt(3,1)=det*rlatt(3,1)
      rlatt(1,2)=det*rlatt(1,2)
      rlatt(2,2)=det*rlatt(2,2)
      rlatt(3,2)=det*rlatt(3,2)
      rlatt(1,3)=det*rlatt(1,3)
      rlatt(2,3)=det*rlatt(2,3)
      rlatt(3,3)=det*rlatt(3,3)

      return

      end
c $Id: main.f 21413 2011-11-05 06:53:49Z d3y133 $

c $Id: et_det.F 19708 2010-10-29 18:04:21Z d3y133 $
      subroutine et_det(op,handle,n,detval)
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "apiP.fh"
#include "bas.fh"
#include "geom.fh"
#include "cscf.fh"
c
c returns the determinant of the square matrix with file handle 'handle'.
c n is the dimension of the array, detval is the returned value of the
c determinant. If op='N', a=a. If op='T', a=a'.
c
      character*1 op
      integer handle
      integer n,i,j,info
      integer l_ipvt,k_ipvt,l_a,k_a,l_work,k_work
      double precision detval,det(2),ten
c
      ten = 10.0d0
      if (.not.ma_push_get(mt_int,n,'ipvt',
     1  l_ipvt,k_ipvt)) call errquit
     2  ('et_det: failed to allocate ipvt',0,0)
      if (.not.ma_push_get(mt_dbl,n*n,'a',
     1  l_a,k_a)) call errquit
     2  ('et_det: failed to allocate a',0,0)
      if (.not.ma_push_get(mt_dbl,n,'work',
     1  l_work,k_work)) call errquit
     2  ('et_det: failed to allocate work',0,0)
c
      do i = 1,n
      do j = 1,n
       if(op.eq.'N') call ga_get(handle,i,i,j,j,
     1 dbl_mb(k_a+i-1+(j-1)*n),1)
       if(op.eq.'T') call ga_get(handle,j,j,i,i,
     1 dbl_mb(k_a+i-1+(j-1)*n),1)
      enddo
      enddo
c
      call dgefa(dbl_mb(k_a),n,n,int_mb(k_ipvt),info)
      call dgedi(dbl_mb(k_a),n,n,int_mb(k_ipvt),det,dbl_mb(k_work),10)
      detval =  det(1) * ten**det(2)
c
      if (.not.ma_pop_stack(l_work)) call errquit
     1  ('et_det: failed to deallocate work',0,0)
      if (.not.ma_pop_stack(l_a)) call errquit
     1  ('et_det: failed to deallocate a',0,0)
      if (.not.ma_pop_stack(l_ipvt)) call errquit
     1  ('et_det: failed to deallocate ipvt',0,0)
      call ga_sync()
      return
      end

      Subroutine hf2QStoCD(dQ,dS,dC,dD,alpha,ipair,ff,NPP,NPQ,Nint,
     &       ictrc,ictrd)
c $Id: hf2QStoCD.f 19696 2010-10-29 16:53:42Z d3y133 $

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)
      integer ictrc,ictrd

c--> Derivative Integrals WRT (Q,S)

      Dimension dQ((NPQ*NPP),Nint),dS((NPQ*NPP),Nint)

c--> Derivative Integrals WRT (C,D)

      Dimension dC(Nint),dD(Nint)

c--> Exponents & Pair Index

      Dimension alpha(2,NPP),ipair(2,NPP)

c--> Scratch space

      Dimension ff(2,(NPQ*NPP))
c--> local
      double precision sumC, sumD
c
c Transform derivative integrals wrt (Q,S) to (C,D).
c
c N.B. It is assumed that the product of contraction coefficients has been
c      factored into each primitive (Q,S) integral derivative. Thus, this 
c      routine currently transforms primitive (Q,S) integral derivatives to 
c      contracted (C,D) integral derivatives.
c
c*******************************************************************************

c Initialize derivative integrals wrt to (C,D).

      if (ictrc.eq.ictrd) then
        do 00100 nn = 1,Nint
          sumC = 0.0d00
          do 00200 mr = 1,(NPQ*NPP)
            sumC = sumC + dQ(mr,nn)
00200     continue
          dC(nn) = sumC
00100   continue
        call dlaset(' ',nint,1,0.0d00,0.0d00,dD,nint)
      else
c Compute exponent ratios.

        do 15 mq = 1,NPQ
          ff(1,mq) = alpha(1,mq)/(alpha(1,mq) + alpha(2,mq))
          ff(2,mq) = alpha(2,mq)/(alpha(1,mq) + alpha(2,mq))
15      continue
        
        mr = NPQ
        do 25 mp = 2,NPP
          do 20 mq = 1,NPQ
            mr = mr + 1
            
            ff(1,mr) = ff(1,mq)
            ff(2,mr) = ff(2,mq)
            
20        continue
25      continue
        
c Transform.
        
        do 40 nn = 1,Nint
          
          sumC = 0.0d00
          sumD = 0.0d00
          do 30 mr = 1,(NPQ*NPP)
            sumC = sumC + (ff(1,mr)*dQ(mr,nn) + dS(mr,nn))
            sumD = sumD + (ff(2,mr)*dQ(mr,nn) - dS(mr,nn))
30        continue
            dC(nn) = sumC
            dD(nn) = sumD
40      continue
        
      endif
      end

*> \brief \b STRSV
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE STRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
* 
*       .. Scalar Arguments ..
*       INTEGER INCX,LDA,N
*       CHARACTER DIAG,TRANS,UPLO
*       ..
*       .. Array Arguments ..
*       REAL A(LDA,*),X(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> STRSV  solves one of the systems of equations
*>
*>    A*x = b,   or   A**T*x = b,
*>
*> where b and x are n element vectors and A is an n by n unit, or
*> non-unit, upper or lower triangular matrix.
*>
*> No test for singularity or near-singularity is included in this
*> routine. Such tests must be performed before calling this routine.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>           On entry, UPLO specifies whether the matrix is an upper or
*>           lower triangular matrix as follows:
*>
*>              UPLO = 'U' or 'u'   A is an upper triangular matrix.
*>
*>              UPLO = 'L' or 'l'   A is a lower triangular matrix.
*> \endverbatim
*>
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>           On entry, TRANS specifies the equations to be solved as
*>           follows:
*>
*>              TRANS = 'N' or 'n'   A*x = b.
*>
*>              TRANS = 'T' or 't'   A**T*x = b.
*>
*>              TRANS = 'C' or 'c'   A**T*x = b.
*> \endverbatim
*>
*> \param[in] DIAG
*> \verbatim
*>          DIAG is CHARACTER*1
*>           On entry, DIAG specifies whether or not A is unit
*>           triangular as follows:
*>
*>              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*>
*>              DIAG = 'N' or 'n'   A is not assumed to be unit
*>                                  triangular.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the order of the matrix A.
*>           N must be at least zero.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is REAL array of DIMENSION ( LDA, n ).
*>           Before entry with  UPLO = 'U' or 'u', the leading n by n
*>           upper triangular part of the array A must contain the upper
*>           triangular matrix and the strictly lower triangular part of
*>           A is not referenced.
*>           Before entry with UPLO = 'L' or 'l', the leading n by n
*>           lower triangular part of the array A must contain the lower
*>           triangular matrix and the strictly upper triangular part of
*>           A is not referenced.
*>           Note that when  DIAG = 'U' or 'u', the diagonal elements of
*>           A are not referenced either, but are assumed to be unity.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program. LDA must be at least
*>           max( 1, n ).
*> \endverbatim
*>
*> \param[in,out] X
*> \verbatim
*>          X is REAL array of dimension at least
*>           ( 1 + ( n - 1 )*abs( INCX ) ).
*>           Before entry, the incremented array X must contain the n
*>           element right-hand side vector b. On exit, X is overwritten
*>           with the solution vector x.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           X. INCX must not be zero.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup single_blas_level2
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 2 Blas routine.
*>
*>  -- Written on 22-October-1986.
*>     Jack Dongarra, Argonne National Lab.
*>     Jeremy Du Croz, Nag Central Office.
*>     Sven Hammarling, Nag Central Office.
*>     Richard Hanson, Sandia National Labs.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE STRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
*
*  -- Reference BLAS level2 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER INCX,LDA,N
      CHARACTER DIAG,TRANS,UPLO
*     ..
*     .. Array Arguments ..
      REAL A(LDA,*),X(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL ZERO
      PARAMETER (ZERO=0.0E+0)
*     ..
*     .. Local Scalars ..
      REAL TEMP
      INTEGER I,INFO,IX,J,JX,KX
      LOGICAL NOUNIT
*     ..
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (.NOT.LSAME(UPLO,'U') .AND. .NOT.LSAME(UPLO,'L')) THEN
          INFO = 1
      ELSE IF (.NOT.LSAME(TRANS,'N') .AND. .NOT.LSAME(TRANS,'T') .AND.
     +         .NOT.LSAME(TRANS,'C')) THEN
          INFO = 2
      ELSE IF (.NOT.LSAME(DIAG,'U') .AND. .NOT.LSAME(DIAG,'N')) THEN
          INFO = 3
      ELSE IF (N.LT.0) THEN
          INFO = 4
      ELSE IF (LDA.LT.MAX(1,N)) THEN
          INFO = 6
      ELSE IF (INCX.EQ.0) THEN
          INFO = 8
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('STRSV ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF (N.EQ.0) RETURN
*
      NOUNIT = LSAME(DIAG,'N')
*
*     Set up the start point in X if the increment is not unity. This
*     will be  ( N - 1 )*INCX  too small for descending loops.
*
      IF (INCX.LE.0) THEN
          KX = 1 - (N-1)*INCX
      ELSE IF (INCX.NE.1) THEN
          KX = 1
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF (LSAME(TRANS,'N')) THEN
*
*        Form  x := inv( A )*x.
*
          IF (LSAME(UPLO,'U')) THEN
              IF (INCX.EQ.1) THEN
                  DO 20 J = N,1,-1
                      IF (X(J).NE.ZERO) THEN
                          IF (NOUNIT) X(J) = X(J)/A(J,J)
                          TEMP = X(J)
                          DO 10 I = J - 1,1,-1
                              X(I) = X(I) - TEMP*A(I,J)
   10                     CONTINUE
                      END IF
   20             CONTINUE
              ELSE
                  JX = KX + (N-1)*INCX
                  DO 40 J = N,1,-1
                      IF (X(JX).NE.ZERO) THEN
                          IF (NOUNIT) X(JX) = X(JX)/A(J,J)
                          TEMP = X(JX)
                          IX = JX
                          DO 30 I = J - 1,1,-1
                              IX = IX - INCX
                              X(IX) = X(IX) - TEMP*A(I,J)
   30                     CONTINUE
                      END IF
                      JX = JX - INCX
   40             CONTINUE
              END IF
          ELSE
              IF (INCX.EQ.1) THEN
                  DO 60 J = 1,N
                      IF (X(J).NE.ZERO) THEN
                          IF (NOUNIT) X(J) = X(J)/A(J,J)
                          TEMP = X(J)
                          DO 50 I = J + 1,N
                              X(I) = X(I) - TEMP*A(I,J)
   50                     CONTINUE
                      END IF
   60             CONTINUE
              ELSE
                  JX = KX
                  DO 80 J = 1,N
                      IF (X(JX).NE.ZERO) THEN
                          IF (NOUNIT) X(JX) = X(JX)/A(J,J)
                          TEMP = X(JX)
                          IX = JX
                          DO 70 I = J + 1,N
                              IX = IX + INCX
                              X(IX) = X(IX) - TEMP*A(I,J)
   70                     CONTINUE
                      END IF
                      JX = JX + INCX
   80             CONTINUE
              END IF
          END IF
      ELSE
*
*        Form  x := inv( A**T )*x.
*
          IF (LSAME(UPLO,'U')) THEN
              IF (INCX.EQ.1) THEN
                  DO 100 J = 1,N
                      TEMP = X(J)
                      DO 90 I = 1,J - 1
                          TEMP = TEMP - A(I,J)*X(I)
   90                 CONTINUE
                      IF (NOUNIT) TEMP = TEMP/A(J,J)
                      X(J) = TEMP
  100             CONTINUE
              ELSE
                  JX = KX
                  DO 120 J = 1,N
                      TEMP = X(JX)
                      IX = KX
                      DO 110 I = 1,J - 1
                          TEMP = TEMP - A(I,J)*X(IX)
                          IX = IX + INCX
  110                 CONTINUE
                      IF (NOUNIT) TEMP = TEMP/A(J,J)
                      X(JX) = TEMP
                      JX = JX + INCX
  120             CONTINUE
              END IF
          ELSE
              IF (INCX.EQ.1) THEN
                  DO 140 J = N,1,-1
                      TEMP = X(J)
                      DO 130 I = N,J + 1,-1
                          TEMP = TEMP - A(I,J)*X(I)
  130                 CONTINUE
                      IF (NOUNIT) TEMP = TEMP/A(J,J)
                      X(J) = TEMP
  140             CONTINUE
              ELSE
                  KX = KX + (N-1)*INCX
                  JX = KX
                  DO 160 J = N,1,-1
                      TEMP = X(JX)
                      IX = KX
                      DO 150 I = N,J + 1,-1
                          TEMP = TEMP - A(I,J)*X(IX)
                          IX = IX - INCX
  150                 CONTINUE
                      IF (NOUNIT) TEMP = TEMP/A(J,J)
                      X(JX) = TEMP
                      JX = JX - INCX
  160             CONTINUE
              END IF
          END IF
      END IF
*
      RETURN
*
*     End of STRSV .
*
      END
c $Id: strsv.f 24342 2013-06-22 05:32:15Z d3y133 $

      subroutine argos_main()
c
c $Id: argos_main.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos.fh"
c
      if(ntype.eq.0) then
c
c     single energy
c     -------------
c
      if(nftri.eq.0) then
      call argos_sp()
      else
      call argos_spi()
      endif
c
      elseif(ntype.eq.1) then
c
c     energy minimization
c     -------------------
c
      call argos_em()
c
      elseif(ntype.eq.2) then
c
c     molecular dynamics
c     ------------------
c
      call argos_md()
c
      elseif(ntype.eq.3) then
c
c     free energy simulation
c     ----------------------
c
      call argos_ti()
c
      else
      call md_abort('Unknown calculation type',ntype)
      endif
c
      return
      end

c $Id: int_init.F 23337 2013-01-02 20:29:00Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Main initialization routine for integrals
C>
C> This routine is the main initialization routine for the 
C> integral packages. It sets memory limits, accuracy thresholds,
C> and other initializations for all base integral codes. The
C> routine reads any integral settings changed by the user from
C> the runtime database.
C>
C> This routine is a wrapper around the original `int_init` which is now
C> called `int_init_org`. The reason for this extension is related to the
C> basis set use in Douglas-Kroll. Douglas-Kroll uses a fitting basis
C> set, which could be larger (# of exponents but also higher angular 
C> momenta), which also needs to be included in the initialization
C> procedure. The wrapper sets the Douglas-Kroll stuff and adds the new
C> fitting basis set to the list of active basis sets and calls 
C> `int_init_org`.
C>
c:tex-%API Initialization and Termination Routines
c:tex-\subsection{int\_init}
c:tex-This is the main initialization routine for integrals.
c:tex-Default memory requirements, accuracy thresholds, and other 
c:tex-initializations for all base integral codes are set here. 
c:tex-This routine will read (from the rtdb) any integral 
c:tex-settings changed by the user.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_init(rtdb, nbas, bases)
c:tex-\end{verbatim}
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "apiP.fh"
#include "candoP.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "util.fh"
#include "rel_nwc.fh"
#include "stdio.fh"
c
c This routine is a wrapper around the original int_init which is now
c called int_init_org. The reason for this extension is related to the
c basis set use in Douglas-Kroll. Douglas-Kroll uses a fitting basis
c set, which could be larger (# of exponents but also higher angular 
c momenta), which also needs to be included in the initialization
c procedure. The wrapper sets the Douglas-Kroll stuff and adds the new
c fitting basis set to the list of active basis sets and calls 
c int_init_org.
c
c::passed
c:tex-\begin{verbatim}
      integer rtdb        !< [Input] run time data base handle
      integer nbas        !< [Input] number of basis sets to be used
      integer bases(nbas) !< [Input] basis set handles
c:tex-\end{verbatim}
c::local
      integer mybm_a, mybIm_a, ibas, nrbas     ! Temporary variables
      character*255 dk_bas_name, dk_trans_name ! strings used for Douglas-Kroll
      logical ouseracc
c
      integer irtdb
      common /int_rtdb/irtdb   ! rtdb member variable handle
c
c     Set member irtdb
c
      irtdb = rtdb  
c
c     Put integral accuracy under user control
c
      ouseracc = .false.
      if (rtdb_get(rtdb,'int:acc_std',mt_dbl,1,val_int_acc_std)) then
         ouseracc = .true.
      else
c
cniri Reinstate the tighter tolerance. We encountered a subtle problem with a large system where 
cniri a rather diffuse augmented basis set was used. There were a number of dependencies.
cniri We managed to address the issue by ramping up this tolerance.
cniri val_int_acc_std = 1d-12
      val_int_acc_std = 1d-15


      end if
      if (rtdb_get(rtdb,'int:acc_high',mt_dbl,1,val_int_acc_high)) then 
         ouseracc = .true.
      else
         val_int_acc_high = val_int_acc_std**2
      end if
      if (ouseracc .and. ga_nodeid().eq.0 .and. 
     $     util_print('information',print_default)) then
         write(LuOut,606) val_int_acc_std, val_int_acc_high
 606     format(/'int_init: setting std/high accuracies to',1p,2d9.1)
         call util_flush(LuOut)
      end if
c
c   Dyall-modified Dirac equation
c
      if (.not. rtdb_get(rtdb,'dyall_mod_dir',mt_log,1,dyall_mod_dir))
     &    dyall_mod_dir = .false.
      if (.not. rtdb_get(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
     &    atomic_nesc = .false.
      if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,nesc_1e_approx))
     &    nesc_1e_approx = .false.
      if (.not. rtdb_get(rtdb,'ss_one_cent',mt_log,1,ss_one_cent))
     &    ss_one_cent = .false.
      if (.not. rtdb_get(rtdb,'do_ssss',mt_log,1,do_ssss)) 
     &    do_ssss = .false.
c
c     Setup array with basis sets from bases
c
      if (.not. ma_push_get(MT_INT,nbas+1,'mybases',mybm_a,mybIm_a))
     $     call errquit('int_init: ma_push_get failed mybases',0,
     &       INT_ERR)
      do 00500 ibas = 1, nbas
         int_mb(mybIm_a+ibas-1) = bases(ibas)
00500 continue
      nrbas = nbas
c
c Initialize the Douglas-Kroll variables
c
c form_type: 1. Free-particle projection operators
c            2. External potential projection operators without pxVp integrals
c            3. Complete spin-free Douglas-Kroll (i.e. including pxVp)
c
      if (.not. rtdb_get(rtdb,'doug_kroll',MT_LOG,1,doug_kroll)) 
     $    doug_kroll = .false.
      if (doug_kroll) then
c
c        Which form of Douglas-Kroll has to be done, default = 2
c
         if (.not. rtdb_get(rtdb,'doug_kroll:type',MT_INT,1,
     $      dk_form_type)) dk_form_type = 2
c
c        If one want one can specify an even tempered basis as fitting basis
c
         if (.not. rtdb_get(rtdb,'doug_kroll:eventemp',MT_LOG,1,
     $      dk_even_bas)) dk_even_bas = .false.
         if (.not. rtdb_get(rtdb,'doug_kroll:etratio',MT_DBL,1,
     $      dk_ratio)) dk_ratio = 2.0d0
c
c        Generate the fitting basis set and add it to the list of 
c        used basis sets
c
         do 00400 ibas = 1, nbas
            if (.not. bas_name(bases(ibas),dk_bas_name,dk_trans_name))
     $         call errquit('int_init: failed in bas_name',0, INT_ERR)
            if (dk_bas_name(1:8) .eq. 'ao basis') goto 00004
00400    continue
         call errquit('int_init: could not find ao basis',0, INT_ERR)
00004    call bas_create_uncont(rtdb,bases(ibas),'auto D-K basis',
     $      dk_fitbas)
c
c        Add fitting basis set to list of loaded basis sets for int_init
c
         int_mb(mybIm_a+nbas) = dk_fitbas
         nrbas = nrbas + 1
      endif
      if (doug_kroll .or. dyall_mod_dir) call rel_init_con (rtdb)
      call int_init_org(rtdb, nrbas, int_mb(mybIm_a))
      if (.not. ma_pop_stack(mybm_a))
     $     call errquit('int_init: ma_pop_stack mybm_a',0, INT_ERR)
c
      end
c
C>
C> \brief Initialization routine for integrals
C>
C> This routine is the initialization routine for the 
C> integral packages. It sets memory limits, accuracy thresholds,
C> and other initializations for all base integral codes. The
C> routine reads any integral settings changed by the user from
C> the runtime database. Only data associated with relativistic
C> basis sets are handled in `int_init`.
C>
      subroutine int_init_org(rtdb, nbas, bases)
c
c initializes integral code to data structers for a integral computation
c
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "apiP.fh"
#include "candoP.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "util.fh"
#include "stdio.fh"
c::functions
      logical  spcart_init
      external spcart_init
      logical  int_ecp_init
      external int_ecp_init
      logical  int_rel_init
      external int_rel_init
      logical  texas_check_basis_ok
      external texas_check_basis_ok
c::passed
      integer rtdb        !< [Input] run time data base handle
      integer nbas        !< [Input] number of basis sets to be used
      integer bases(nbas) !< [Input] basis set handles
c::local
      integer txs_mem_min ! memory from texas
      integer ibas, ang2use, angm, type
      logical status, oprint
      integer nqmax_texas  ! maximum number of quartets in texas blocking interface
      parameter (nqmax_texas = 10000)

c
c     print info/warnings unless print set to none. errors always print.
c
      oprint = util_print('information',print_low)
c
c      block data api_data
c
c
c Block data structure to initialize the common block variables in the
c  internal basis set object data structures
c
c     
      call int_mem_zero()
c
      DCexp     = 0.0D00
      DCcoeff   = 1.0D00
      val_int_acc = 0.0d00
c
      intd_memthresh = 0
      numd_tot       = 0
      numd_okay      = 0
      numd_red       = 0
c
      if(init_int.eq.1 .and. oprint) then
        write(luout,*)' warning nested int_inits'
        write(luout,*)' int_init already called '
        call util_flush(6)
      endif
c
c initialize type-> nbf maps
c
      int_nbf_x(-1) = 4
      int_nbf_s(-1) = 4
      do type = 0,int_nbf_max_ang
        int_nbf_x(type) = (type+1)*(type+2)/2
        int_nbf_s(type) = 2*type+1
      enddo
c
c initialize cando information from rtdb
c
      user_cando_sp   = .false.
      user_cando_nw   = .false.
      user_cando_txs  = .false.
      user_cando_hnd  = .false.
      def_cando_sp    = .false.
      def_cando_nw    = .false.
      def_cando_txs   = .false.
      def_cando_hnd   = .false.
c
      if (rtdb_get(rtdb,'int:cando_sp',MT_LOG,1,status)) then
        user_cando_sp = .true.
        def_cando_sp  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' int_init: cando_sp set to always be ',def_cando_sp
          call util_flush(luout)
        endif
      endif
c
      if (rtdb_get(rtdb,'int:cando_nw',MT_LOG,1,status)) then
        user_cando_nw = .true.
        def_cando_nw  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' int_init: cando_nw set to always be ',def_cando_nw
          call util_flush(luout)
        endif
      endif
c
      if (rtdb_get(rtdb,'int:cando_txs',MT_LOG,1,status)) then
        user_cando_txs = .true.
        def_cando_txs  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' int_init: cando_txs set to always be ',def_cando_txs
          call util_flush(luout)
        endif
      endif
c
      if (rtdb_get(rtdb,'int:cando_hnd',MT_LOG,1,status)) then
        user_cando_hnd = .true.
        def_cando_hnd  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' int_init: cando_hnd set to always be ',def_cando_hnd
          call util_flush(luout)
        endif
      endif
c
      if (.not.user_cando_txs) then
        if (.not.texas_check_basis_ok(nbas,bases)) then
          user_cando_txs = .true.
          def_cando_txs = .false.
          if (ga_nodeid().eq.0 .and. oprint) then
            write(luout,*)
     &          ' int_init: internal texas instability possible cando_',
     &          'txs set to always be ',def_cando_txs
            call util_flush(luout)
          endif
        endif
      endif
* sanity checking: e.g., you only want to turn off a particular integral
* code never always turn it on.
*
      if (def_cando_sp.or.def_cando_nw.or.def_cando_txs.or.
     &    def_cando_hnd) then
        if (ga_nodeid().eq.0) then
          write(luout,*)' you are trying to turn an integral code on? '
          write(luout,*)' sp  ', def_cando_sp
          write(luout,*)' nw  ', def_cando_nw
          write(luout,*)' txs ', def_cando_txs
          write(luout,*)' hnd ', def_cando_hnd
          call util_flush(luout)
        endif
        call errquit
     &      ('int_init: logic error with user cando settings',911,
     &       INT_ERR)
      endif
c
      status = .true.
      do 00100 ibas=1,nbas
        status = status .and. bas_check_handle(bases(ibas),'int_init')
00100 continue

      if (.not.status) then
        write(luout,*)' at least one basis handle not valid'
        do 00200 ibas = 1,nbas
          write(luout,'(a,i5)')
     &           ' basis set handle ',bases(ibas)
00200   continue
        call errquit('int_init: basis handles hosed ',nbas, INT_ERR)
      endif
*      write(luout,*)' int_init: basis set handles valid '
c
c check for both sp and gc shells
c
      call int_bothsp_gc_check(bases,nbas,'int_init')
c
c initialize defnxyz routines
c      
      ang2use = -1
      do 00300 ibas = 1,nbas
        if(.not.bas_high_angular(bases(ibas),angm))
     &      call errquit('int_init: angm error',angm, INT_ERR)
        ang2use = max(ang2use,angm)
        if (dyall_mod_dir) then
          if(.not.bas_rel_high_ang(bases(ibas),angm))
     &        call errquit('int_init: angm error',angm, INT_ERR)
          ang2use = max(ang2use,angm+1)
        end if
00300 continue
*
* test for higher than L functions  0123456789
      if (ang2use.ge.9) call errquit
     &    ('only basis sets with s through l functions are allowed',
     &    911, BASIS_ERR)
*
      call defNxyz(ang2use)
c
c initialize spcart stuff 
c
      if (.not.(spcart_init(ang2use,.true.,.false.))) then
        call errquit('int_init: spcart_init failed',911, INT_ERR)
      endif
c
c Initialize DmD relativistic basis set stuff
c
      if (dyall_mod_dir) then
        if (.not. int_rel_init(rtdb,nbas,bases)) call errquit
     &      ('int_init: int_rel_init failed ',911, INT_ERR)
        if (.not. nesc_1e_approx) then
          user_cando_sp   = .true.
          def_cando_sp   = .false.
          user_cando_txs = .true.
          def_cando_txs  = .false.
          if (ga_nodeid().eq.0 .and. oprint) then
            write(luout,*) ' int_init: cando_sp and cando_txs',
     &          ' turned off for NESC2E'
            call util_flush(luout)
          end if 
        end if
      end if
c
c... generate memory requirements and store in structures in apiP.fh
c
      call exact_mem(rtdb,bases,nbas)
      call sp_init(nbas,bases)
      call init70               ! To generate tables etc.
      call hnd_init(bases,nbas)
      call int_acc_std()
* def u=f d=f -> f.and.!f -> f -> e = t
* no txs u=t d=f -> t.and.!f -> t -> e = f
      if (.not.(user_cando_txs.and.(.not.def_cando_txs))) then
        call texas_init(rtdb,nbas,bases,nqmax_texas,txs_mem_min,
     *                  'scfd_int')
      else
         call igamma_init
      endif
c
c See if any basis has an attached ECP
c
      any_ecp = .false.
      ecp_bsh = 0
      do ibas = 1,nbas
        if (bas_get_ecp_handle(bases(ibas),ecp_bsh)) then
          any_ecp = .true.
          goto 00001
        endif
      enddo
00001 continue
      if (any_ecp) then
        if (.not.ecp_check_handle(ecp_bsh,'int_init')) call errquit
     &        ('int_init: ecp handle is invalid fatal error',911,
     &         INT_ERR)
      endif
*
c See if any basis has an attached SO potential
      any_so = .false.
      so_bsh = 0
      do ibas = 1,nbas
        if (bas_get_so_handle(bases(ibas),so_bsh)) then
          any_so = .true.
          goto 00002
        endif
      enddo
00002 continue
      if (any_so) then
        if (.not.so_check_handle(so_bsh,'int_init')) call errquit
     &        ('int_init: so handle is invalid fatal error',911, 
     &          INT_ERR)
      endif
      if (any_so.or.any_ecp) then
        if (.not.int_ecp_init(ecp_bsh,so_bsh,0)) call errquit
     &      ('int_init: int_ecp_init failed ',911, INT_ERR)
        if (dyall_mod_dir .or. doug_kroll) call errquit('int_init: '//
     &      'do not mix ECPs and all-electron relativistic methods',911,
     &       INT_ERR)
      endif
      init_int = 1
      end
      subroutine sp_init(nbas,bases)
      implicit none
      integer nbas
      integer bases(nbas)
      end
C>
C> \brief Check if the integrals for all basis sets can be evaluated by
C> the Texas integral package
C>
      logical function texas_check_basis_ok(nbas,bases)
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "util.fh"
c::passed
      integer nbas             !< [Input] number of basis sets
      integer bases(nbas)      !< [Input] basis set handles
*return:: texas_check_basis_ok !< [Output] true texas is okay to use
c::local
      integer ibas       ! specific basis index
      integer ishell     ! specific shell index
      integer my_highang ! high angular momentum specified in basis set
      integer my_nshell  ! number of contracted shells in basis set
      integer my_type    ! type of a given contraction
      integer my_nprim   ! number of primitives in a given contraction
      integer my_ngen    ! number of contractions in a given contraction
      integer my_spc            ! spherical/cartesian flag for a given contraction
      double precision exponent ! largest exponent for basis set
c
      texas_check_basis_ok = .true.  
c
      do ibas = 1,nbas
        if (.not.bas_high_angular(bases(ibas),my_highang))
     &      call errquit
     &      ('texas_check_basis_ok: bas_high_angular failed',911,
     &       BASIS_ERR)
        if (my_highang.ge.2) then
          if (.not.bas_numcont(bases(ibas),my_nshell))
     &        call errquit
     &        ('texas_check_basis_ok: bas_numcont failed',911,
     &       BASIS_ERR)
          do ishell = 1, my_nshell
            if (.not.bas_continfo
     &          (bases(ibas),ishell,my_type,my_nprim,my_ngen,my_spc))
     &          call errquit
     &          ('texas_check_basis_ok: bas_continfo failed',911,
     &       BASIS_ERR)
            if (my_type.ge.2) then
              if (.not.
     &            bas_cont_large_exponent(bases(ibas),ishell,exponent))
     &            call errquit
     &            ('texas_check_basis_ok: bas_cont_lrg_expnnt failed',
     &            911, BASIS_ERR)
              if (exponent.gt.10000.0d00) then
                texas_check_basis_ok = .false.
                return
              endif
            endif
          enddo
        endif
      enddo
      end
c
c     == access function for rtdb member variable handle ==
      integer function int_get_rtdb()
c
      implicit none
c
      integer irtdb
      common /int_rtdb/irtdb

      int_get_rtdb = irtdb
c   
      return
      end
C> @}

      SUBROUTINE ccsdtq_lambda3_27_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lambda3_27_2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h6 p13 h10 h12 p1 p2 )_yttt + = 1 * Sum ( h8 ) * t ( p13 h8 )_t * i2 ( h4 h5 h6 h8 h10 h12 p1 p2 )_ytt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p13b
      INTEGER p1b
      INTEGER p2b
      INTEGER h10b
      INTEGER h12b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h8b
      INTEGER p13b_1
      INTEGER h8b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h8b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER h10b_2
      INTEGER h12b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = h5b,noab
      DO p13b = noab+1,noab+nvab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h10b = 1,noab
      DO h12b = h10b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p13b-1)+int_mb(k_spin+p1b-1)+
     &int_mb(k_spin+p2b-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+h12b-1).n
     &e.16)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     &+int_mb(k_spin+p13b-1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b
     &-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p1b-1),ie
     &or(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+h10b-1),int_mb(k_sym+h12b
     &-1)))))))) .eq. ieor(irrep_y,ieor(irrep_t,ieor(irrep_t,irrep_t))))
     & THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p13b-1) * int_mb(k_range+p1b-1) * int_
     &mb(k_range+p2b-1) * int_mb(k_range+h10b-1) * int_mb(k_range+h12b-1
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_27_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h8b = 1,noab
      IF (int_mb(k_spin+p13b-1) .eq. int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),int_mb(k_sym+h8b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p13b,h8b,p13b_1,h8b_1)
      CALL TCE_RESTRICTED_8(h4b,h5b,h6b,h8b,p1b,p2b,h10b,h12b,h4b_2,h5b_
     &2,h6b_2,h8b_2,p1b_2,p2b_2,h10b_2,h12b_2)
      dim_common = int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+p13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * 
     &int_mb(k_range+h10b-1) * int_mb(k_range+h12b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_27_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda3_27_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (p13b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+h8b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda3_27_2',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_27_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda3_27_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h12b_
     &2 - 1 + noab * (h10b_2 - 1 + noab * (p2b_2 - noab - 1 + nvab * (p1
     &b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h6b_2 - 1 + noab * (h
     &5b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h12b-1),8,7,6,5,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda3_27_2',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda3_27_2
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda3_27_2
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda3_27_2',9,MA_ERR)
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+h4b-
     &1),int_mb(k_range+p13b-1),7,6,5,8,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h12b 
     &- 1 + noab * (h10b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - no
     &ab - 1 + nvab * (p13b - noab - 1 + nvab * (h6b - 1 + noab * (h5b -
     & 1 + noab * (h4b - 1)))))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda3_27_2',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda3_27_2
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

*
* $Id: integrate_kbpp_e_band_stress_local.F 22503 2012-05-20 06:58:57Z d3y133 $
*

*     **************************************
*     *                                    *
*     *  integrate_kbpp_e_band_stress_local  *
*     *                                    *
*     **************************************

      subroutine integrate_kbpp_e_band_stress_local(version,
     >                            nrho,drho,lmax,locp,nmax,
     >                            n_extra,n_expansion,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nfft1,nfft2,nfft3,nprj,
     >                            G,dvl,
     >                            semicore,rho_sc_r,rho_sc_k,
     >                            ierr)
      implicit none
      integer          version
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      integer          nmax
      integer          n_extra,n_expansion(0:lmax)
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:(lmax+n_extra))
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nfft1,nfft2,nfft3,nprj
      double precision G(nfft1,nfft2,nfft3,3)
      double precision dvl(nfft1,nfft2,nfft3)

      logical semicore
      double precision rho_sc_r(nrho,2)
      double precision rho_sc_k(nfft1,nfft2,nfft3,4)

      integer ierr

      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      integer task_count,nfft3d
      integer k1,k2,k3,i,l,n,nb
      double precision pi,twopi,forpi
      double precision q
      !integer indx(5,0:3)

*     **** external functions ****
      double precision simp
      external         simp

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      nfft3d = (nfft1)*nfft2*nfft3
      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      if ((nrho/2)*2.eq.nrho) then
        ierr=2
        return
      end if


*::::::::::::::::::  Define non-local pseudopotential  ::::::::::::::::
      do l=0,lmax
        if (l.ne.locp) then
          do I=1,nrho
            vp(i,l)=vp(i,l)-vp(i,locp)
          end do
        end if
      end do

*======================  Fourier transformation  ======================
      call dcopy(nfft3d,0.0d0,0,dvl,1)
      call dcopy(4*nfft3d,0.0d0,0,rho_sc_k,1)
      task_count = -1
      DO 700 k3=1,nfft3
      DO 700 k2=1,nfft2
      DO 700 k1=1,nfft1
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        q=dsqrt(G(k1,k2,k3,1)**2
     >         +G(k1,k2,k3,2)**2
     >         +G(k1,k2,k3,3)**2)

        if ((k1.eq.1).and.(k2.eq.1).and.(k3.eq.1)) go to 700

        DO I=1,nrho
          cs(I)=dcos(q*rho(I))
          sn(I)=dsin(q*rho(I))
        END DO

*::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
  600   CONTINUE

        do  i=1,nrho
          f(i)=rho(i)*vp(i,locp)*(rho(i)*cs(i)-sn(i)/q)
        end do
        dvl(k1,k2,k3)= simp(nrho,f,drho)*forpi/q
     >   + zv*forpi/(q*q)*(2.0d0*cs(nrho)/q + rho(nrho)*sn(nrho))

 

*::::::::::::::::::::: semicore density :::::::::::::::::::::::::::::::
        if (semicore) then

           do  i=1,nrho
             f(i)=rho(i)*dsqrt(rho_sc_r(i,1))*(rho(i)*cs(i)-sn(i)/q)
           end do
           rho_sc_k(k1,k2,k3,1)= simp(nrho,f,drho)*forpi/q
        end if

  700 CONTINUE

      call Parallel_Vector_SumAll(4*nfft3d,rho_sc_k)
      call Parallel_Vector_SumAll(nfft3d,dvl)
*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      

      dvl(1,1,1)= 0.0d0

      ierr=0
      return
      end

      subroutine esp_esp(ene,occ,dns,x,q,grid,val)
c
c $Id: esp_esp.F 25368 2014-03-21 06:10:42Z niri $
c
      implicit none
c
#include "esp_params.fh"
#include "esp_common.fh"
#include "global.fh"
#include "bas.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "util.fh"
#include "schwarz.fh"
#include "stdio.fh"
c
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
c
      real*8 ene(2*nbf),occ(2*nbf),dns(mbf,mbf)
      real*8 x(3,natoms),q(natoms)
      real*8 grid(3,mxgrid),val(mxgrid)
c
      integer i,j,ish,jsh,ix
      integer ilo,ihi,jlo,jhi
      real*8 dist,vt
      integer imin,nval,jshi
      real*8 dmin,fact
      character*10 today,now
      logical ldummy(1)
c
c     get the density matrix, occupation and energies
c
      call esp_denmat(occ,ene)
c
      if (lscrn.ne.0) call schwarz_init(igeom,ibasis)
c
c     get electrostatic potential on the grid points
c
      do i=1,ngrid
         val(i)=0.0d0
      end do
c
      call hnd_elfcon(ibasis,igeom,lg_d,grid(1,1),ngrid,val(1),0)
      if(me.eq.0) then
      do 8 i=1,ngrid
         imin=0
         val(i)=-val(i)
         vt=val(i)
         do 9 ix=1,natoms
            dist=sqrt((grid(1,i)-x(1,ix))*(grid(1,i)-x(1,ix))+
     +          (grid(2,i)-x(2,ix))*(grid(2,i)-x(2,ix))+
     +          (grid(3,i)-x(3,ix))*(grid(3,i)-x(3,ix)))
            if(imin.eq.0) then
               dmin=dist
               imin=ix
            endif
            if(dmin.gt.dist) then
               dmin=dist
               imin=ix
            endif
            val(i)=val(i)+q(ix)/dist
    9    continue
    8 continue
      endif
c
      if(lscrn.ne.0) call schwarz_tidy()
c
      if(np.gt.1) then
        call ga_brdcst(mre_002,val,ngrid*ma_sizeof(mt_dbl,1,mt_byte),0)
      endif
c
c     deallocate memory for the integrals
c
      if(.not.ga_destroy(lg_d))
     + call md_abort('esp_denmat: ga_destroy lg_d failed',me)
c
c     integral termination
c
      call int_terminate()
c
      if(me.eq.0) then
      call util_file_name('grid',.false.,.false.,grdfil)
      open(unit=lfngrd,file=grdfil,form='formatted',status='unknown')
      rewind(lfngrd)
      write(lfngrd,'(i10,f20.10)') ngrid,charge
      do i=1,ngrid
        write(lfngrd,'(4f20.10)') (grid(j,i),j=1,3),val(i)
      enddo
      close(unit=lfngrd)
      endif
c
      return
      end

      subroutine argos_diana_order(x)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      real*8 x(nsa,3)
c
      integer i,ia,n,igrp,j
      real*8 xsijx,xsijy,xsijz,xskjx,xskjy,xskjz
      real*8 rsij2,rskj2,rsij2i,rskj2i,rsikji,cphi
c
      real*8 xa(3),xb(3),xc(3)
c
      do 1 i=1,nord
      igrp=idord(i,1)
      n=ldef(igrp)
      do 2 j=1,n
      ia=idef(igrp,j)
      xa(1)=x(ia,1)
      xa(2)=x(ia,2)
      xa(3)=x(ia,3)
    2 continue
      xa(1)=xa(1)/dble(n)-x(idord(i,3),1)
      xa(2)=xa(2)/dble(n)-x(idord(i,3),2)
      xa(3)=xa(3)/dble(n)-x(idord(i,3),3)
      igrp=idord(i,2)
      n=ldef(igrp)
      do 3 j=1,n
      ia=idef(igrp,j)
      xb(1)=x(ia,1)
      xb(2)=x(ia,2)
      xb(3)=x(ia,3)
    3 continue
      xb(1)=xb(1)/dble(n)-x(idord(i,3),1)
      xb(2)=xb(2)/dble(n)-x(idord(i,3),2)
      xb(3)=xb(3)/dble(n)-x(idord(i,3),3)
      xc(1)=x(idord(i,4),1)-x(idord(i,3),1)
      xc(2)=x(idord(i,4),2)-x(idord(i,3),2)
      xc(3)=x(idord(i,4),3)-x(idord(i,3),3)
c
      xsijx=xa(1)-xb(1)
      xskjx=xc(1)-xb(1)
      xsijy=xa(2)-xb(2)
      xskjy=xc(2)-xb(2)
      xsijz=xa(3)-xb(3)
      xskjz=xc(3)-xb(3)
c
      rsij2=xsijx*xsijx+xsijy*xsijy+xsijz*xsijz
      rskj2=xskjx*xskjx+xskjy*xskjy+xskjz*xskjz
      cphi=xsijx*xskjx+xsijy*xskjy+xsijz*xskjz
      rsij2i=one/rsij2
      rskj2i=one/rskj2
      rsikji=one/sqrt(rsij2*rskj2)
      cphi=cphi*rsikji
      if(cphi.lt.-one) cphi=-one
      if(cphi.gt. one) cphi= one
c
cc      rord(i,1)=rord(i,1)+acos(cphi)
cc     rord(i,2)=rord(i,2)+cphi*cphi
c
    1 continue
c
      return
      end
c $Id: argos_diana_order.F 21176 2011-10-10 06:35:49Z d3y133 $

C $Id: rotf.F 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine drdy_rotf (fmat,amat,scr,natom,ndim,maxdim)
C
C  Transform Hessian matrix from Gaussian standard orientation to
C    original orientation.
C
      Implicit none
      Integer natom,ndim,maxdim
      Double Precision fmat(maxdim,ndim),amat(3,3),scr(3)
C
      Integer i,j,jj,k,l
      Double Precision sum

      do i = 1,ndim
         do j = 1,natom
            jj = (j-1)*3
            do k = 1,3
               sum=0.0
               do l = 1,3
                  sum = sum + amat(k,l)*fmat(i,jj+l)
               enddo
               scr(k) = sum
            enddo
            do k = 1,3
               fmat(i,jj+k) = scr(k)
            enddo
         enddo
      enddo
      do i = 1,ndim
         do j = 1,natom
            jj = (j-1)*3
            do k = 1,3
               sum=0.0
               do l = 1,3
                  sum = sum + amat(k,l)*fmat(jj+l,i)
               enddo
               scr(k) = sum
            enddo
            do k = 1,3
               fmat(jj+k,i) = scr(k)
            enddo
         enddo
      enddo
      return
      end

c $Id: bq_input.F 23019 2012-10-30 00:59:12Z d3y133 $
C> \ingroup bq
C> @{
C>
C> \brief Read Bq instances from the input file
C>
C> This routine reads Bq instances from the input file
C> and stores the data on the RTDB.
C>
      subroutine bq_input(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "bq_params.fh"
#include "bq.fh"
#include "stdio.fh"
c     
      integer rtdb !< [Input] The RTDB handle
c
      logical hprint
      integer print_level
      character*32 pname
      character*255 field
      character*255 namespace
      character*255 message
      character*255 aunit
      character*255 filename,rtdb_charge_tag,rtdb_coord_tag
      integer max_nbq
      logical status
      integer h_cbq,i_cbq
      integer h_qbq,i_qbq
      integer ncenter,ncenter_tmp
      double precision x,y,z,q
      integer i,ipos
      integer handle
      double precision  scale 
      double precision  charge_scale
c
      pname = "bq_input"

      call util_print_get_level(print_level)
      hprint = (ga_nodeid().eq.0).and.(print_high.le.print_level)
c
      max_nbq = 25000  ! default number
      if (.not. rtdb_get(rtdb, 'bq:max_nbq', mt_int, 1, max_nbq))
     $  max_nbq = 25000
c
      if (max_nbq .le. 0) 
     $  call errquit('bq_input: max_nbq',max_nbq, MA_ERR)
c
      if ( .not. ma_push_get( MT_DBL, 3*max_nbq, 
     &      'cbq scratch',
     &      h_cbq, i_cbq) ) call errquit(
     &      'failed scratch space '//pname,
     &      max_nbq, MA_ERR)
c
      call dfill(3*max_nbq,0.0d0,dbl_mb(i_cbq),1)
c
      if ( .not. ma_push_get( MT_DBL, max_nbq, 
     &      'qbq scratch',
     &      h_qbq, i_qbq) ) call errquit(
     &      'failed scratch space '//pname,
     &      max_nbq, MA_ERR)
c
      call dfill(max_nbq,0.0d0,dbl_mb(i_qbq),1)


c     ------------------
c     parse main bq line 
c     ------------------
      namespace = bq_default
      aunit = "ang"
      call inp_set_field(1)
10    continue
      if (inp_a(field)) then 
        if (inp_contains(.false.,'unit',field,ipos)) then
          message = "reading units"
          if (.not. inp_a(aunit)) goto 911  
          goto 10
        else
          if(namespace.eq.bq_default) namespace = field
          goto 10
        end if 
      end if

      call util_length_scale(aunit,scale)
     
      ncenter = 0
 20   if (inp_read()) then
       if(inp_a(field)) then

         if (inp_compare(.false., 'end', field)) then
           goto 30
         else if (inp_compare(.false., 'clear', field)) then
            call bq_rtdb_delete(rtdb,namespace)
            goto 20
         else if (inp_compare(.false.,'force',field)) then
            message = "reading force flag"
            if(.not. rtdb_put(rtdb,"bq:force",mt_log,1,.true.)) 
     >        goto 911
            if (inp_a(field)) then
              if(.not. rtdb_cput(rtdb,"bq:force_filename",1,field)) 
     >          goto 911
            end if
            goto 20
         else if (inp_compare(.false.,'noforce',field)) then
            message = "reading force flag"
            if(.not. rtdb_put(rtdb,"bq:force",mt_log,1,.false.)) 
     >        goto 911
            goto 20
         else if (inp_compare(.false., 'load', field)) then
            call  bq_input_load(aunit,max_nbq,ncenter,
     &                       dbl_mb(i_qbq),
     &                       dbl_mb(i_cbq))
            goto 20
         else if (inp_compare(.false., 'bq_rtdb', field)) then
           if (.not.inp_a(rtdb_charge_tag)) rtdb_charge_tag='cosmo:efcz'
           if (.not.inp_a(rtdb_coord_tag))  rtdb_coord_tag ='cosmo:efcc'

           call bq_fromrtdb(rtdb,rtdb_charge_tag,rtdb_coord_tag,
     &                      ncenter_tmp,
     &                      dbl_mb(i_qbq+ncenter),
     &                      dbl_mb(i_cbq+3*ncenter))
           ncenter = ncenter + ncenter_tmp
           goto 20

         else
           call inp_set_field(0)
           status = .true.
           status = status .and. inp_f(x)
           status = status .and. inp_f(y)         
           status = status .and. inp_f(z)         
           status = status .and. inp_f(q)
           if (hprint) write(*,*) q,x,y,z
            if (.not. status) 
     &         call errquit('bq_input: inp_read failed',0,0)
           dbl_mb(i_qbq+ncenter) = q
           dbl_mb(i_cbq+3*ncenter)   = x*scale
           dbl_mb(i_cbq+3*ncenter+1) = y*scale   
           dbl_mb(i_cbq+3*ncenter+2) = z*scale
           ncenter = ncenter + 1
           status = ncenter .le. max_nbq 
           if (.not. status) 
     $         call errquit('bq_input: too many centers',0,0)
           go to 20
       end if
      end if
      end if
 30   continue

      if(.not.bq_create(namespace,handle))   
     &       call errquit('bq_create failed',0,0)

      if(.not.bq_set(handle,ncenter,dbl_mb(i_qbq),dbl_mb(i_cbq)))
     &       call errquit('bq_set failed',0,0)

      call bq_print_info(handle)

      if(.not.bq_rtdb_store(rtdb,handle))
     &       call errquit('bq_store failed',0,0)

      if(.not.bq_destroy(handle))
     &       call errquit('bq_destroy failed',0,0)

c
c     activate default namespace if found
c     -----------------------------------
      if(ncenter.ne.0 .and. namespace.eq.bq_default) then
      if(.not. rtdb_cput(rtdb,"bq" , 1,bq_default)) then
         call errquit(pname//'failed to set default namespace',
     >                0,RTDB_ERR)
      end if
      end if

      if (.not. ma_pop_stack(h_qbq)) call errquit(
     &      'failed to free scratch space '//pname,
     &      max_nbq, MA_ERR)

      if (.not. ma_pop_stack(h_cbq)) call errquit(
     &      'failed to free scratch space '//pname,
     &      max_nbq, MA_ERR)
 
      return
998   call errquit('no token found '//field,0,
     >        RTDB_ERR)
911   call errquit(message,0,-1)
      end
C> @}

      subroutine bq_input_load(aunit,nmax,n,q,c)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "bq_params.fh"
#include "bq.fh"
c     
      character*(*) aunit
      integer nmax,n
      double precision q(nmax),c(3,nmax)
      character*255 message
      character*255 field
c      character*255 afile_coords 
      character*255 afile_charges
      character*255 afile
      logical oscale
      integer iloc(4)
      double precision charge_scale
      integer i,k,n0,ipos
      integer dn
      double precision scale

      
      iloc = [2,3,4,5]
c      afile_coords  = " "
      afile_charges = " "
      afile = " "
      oscale = .false.
      charge_scale = 1.0
10    continue
      if (inp_a(field)) then
        message = "processing field "//trim(field)
c        if (inp_compare(.false., 'coords', field)) then
c           if (.not.inp_a(afile)) goto 998
c             goto 10
        if (inp_contains(.false.,'unit',field,ipos)) then
          message = "reading units"
          if (.not. inp_a(aunit)) goto 998
          goto 10
        else if (inp_compare(.false., 'charges', field)) then
           if (.not.inp_a(afile_charges)) goto 998
             goto 10
        else if (inp_compare(.false., 'format', field)) then
           do k=1,4
             if (.not.inp_i(iloc(k))) goto 998
           end do
           goto 10
        else if (inp_compare(.false., 'scale', field)) then
           if (.not.inp_f(charge_scale)) goto 998
             oscale = .true.
             goto 10
        else
          if(afile.eq. " " ) afile = field 
        end if
        goto 10
      end if

      n0=n
      if(afile.eq." "
     >   .and. 
     >   afile_charges.ne." ") then
         message = "no files to load ;("
         goto 998
      end if
      if(afile_charges.ne." ") then
        call bq_load_xyz(afile,nmax,n,iloc(1:3),c)
        dn = n - n0
        message = "check format, no coords were found in "//afile
        if (dn.eq.0) goto 998
        n = n0
        call bq_load_q(afile_charges,nmax,n,iloc(4),q)
        message = "error reading charges "//afile_charges
        if (dn.ne.n-n0) goto 998
      else 
        call bq_load(afile,nmax,n,iloc,q,c)
        message = "error reading coords and charges "//afile
        if (n0.eq.n) goto 998
      end if

c     scale and convert as needed
      call util_length_scale(aunit,scale)
      call dscal(3*(n-n0), scale, c(:,n0+1:n), 1)
      if(oscale) then
        call dscal(n-n0, charge_scale, q(n0+1:n), 1)
      end if

c      do i=1,n
c       write(*,*) c(1,i),c(2,i),c(3,i),q(i)
c      end do
c      write(*,*) "oscale ",oscale
c      write(*,*) "scale ",charge_scale
c      write(*,*) "afile ",afile
c      write(*,*) "afile_coords ",afile_coords
c      write(*,*) "afile_charges ",afile_charges

      return

998   call errquit("error "//message,0,
     >        -1)

      end

      subroutine bq_load_xyz(filename,nmax,n,iloc,c)
      implicit none
#include "util.fh"
#include "errquit.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) filename
      integer       nmax,n
      integer iloc(3)
      double precision   c(3,nmax)

c
      integer fn,k
      character*180 buffer,field
      character*180 message
      character*30 pname,atag
      integer iloc_max
c
      logical util_io_unit
      external util_io_unit
      double precision f3(3)
c
      pname = "bq_load_xyz"
c
      call bq_open_file(filename,fn)
c      
      iloc_max = maxval(iloc)
c      
      call inp_init(fn,LuOut)
10    continue
      if (.not.inp_read()) goto 30
      if(inp_n_field().lt.iloc_max) goto 10
      message = "checking for bounds"
      if(n.gt.nmax) goto 911
      message = "reading coordinates"
      do k=1,3
        call inp_set_field(iloc(k)-1) 
        if (.not.inp_f(f3(k))) goto 10
      end do
      n = n+1
      c(:,n) = f3
      goto 10
30    continue
      close(fn)
      call inp_init(LuIn,LuOut)
      return
911   call errquit("error "//trim(message),0,
     >        -1)
      end

      subroutine bq_load_q(filename,nmax,n,iloc,q)
      implicit none
#include "util.fh"
#include "errquit.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) filename
      integer       nmax,n
      integer iloc
      double precision   q(nmax)
      double precision   c(3,nmax)

c
      integer fn,k
      character*180 buffer,field
      character*180 message
      character*30 pname,atag
      integer iloc_max
      double precision f
c
      logical util_io_unit
      external util_io_unit
c
      pname = "bq_load_q"
c
      call bq_open_file(filename,fn)
c      
      iloc_max = iloc
c      
      call inp_init(fn,LuOut)
10    continue
      if (.not.inp_read()) goto 30
      if(inp_n_field().lt.iloc_max) goto 10
      message = "checking for bounds"
      if(n.gt.nmax) goto 911
      message = "reading charges"
      call inp_set_field(iloc-1) 
      if (.not.inp_f(f)) goto 10
      n=n+1
      q(n) = f
      goto 10
30    continue
      call inp_init(LuIn,LuOut)
      close(fn)
      return
911   call errquit("error "//trim(message),0,
     >        -1)
      end

      subroutine bq_open_file(filename,fn)
      implicit none
#include "util.fh"
#include "errquit.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) filename
      integer       fn
c
      character*180 buffer
      character*180 message
      character*30 pname,atag
c
      logical util_io_unit
      external util_io_unit
c
      pname = "bq_open_file"
c
      if(.not.util_io_unit(80,90,fn))
     +  call errquit(pname//"cannot get io unit",0,0)
c     first try to open file in the run directory
      buffer = filename
      message = "loaded bq information from "//buffer
      open(unit=fn,file=buffer,status='old',form="formatted",ERR=10)
      goto 800
10    continue
c     now try perm directory
      call util_file_name_resolve(buffer, .false.)
      message = "loaded bq information from "//buffer
      open(unit=fn,file=buffer,status='old',form="formatted",ERR=911)
800   continue
      write(luout,*) "Successfully "//trim(message)
      write(luout,*)
      return
911   call errquit("error "//trim(message),0,
     >        -1)
      end

      subroutine bq_load(filename,nmax,n,iloc,q,c)
      implicit none
#include "util.fh"
#include "errquit.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) filename
      integer       nmax,n
      integer iloc(4)
      double precision   q(nmax)
      double precision   c(3,nmax)

c
      integer fn,k
      character*180 buffer,field
      character*180 message
      character*30 pname,atag
      integer iloc_max
      double precision f4(4)
c
      logical util_io_unit
      external util_io_unit
c
      pname = "bq_load"
c
      call bq_open_file(filename,fn)
c      
      iloc_max = maxval(iloc)
c      
      call inp_init(fn,LuOut)
10    continue
      if (.not.inp_read()) goto 30
      if(inp_n_field().lt.iloc_max) goto 10
      message = "checking for bounds"
      if(n.gt.nmax) goto 911
      message = "reading coordinates"
c      call inp_outrec()
      do k=1,3
        call inp_set_field(iloc(k)-1) 
        if (.not.inp_f(f4(k))) goto 10
      end do
      k = 4
      call inp_set_field(iloc(k)-1) 
      if (.not.inp_f(f4(k))) goto 10
      n=n+1
      c(:,n) = f4(1:3)
      q(n) = f4(4)
      goto 10
30    continue
      call inp_init(LuIn,LuOut)
      close(fn)
      return
911   call errquit("error "//trim(message),0,
     >        -1)
      end

      subroutine bq_fromrtdb(rtdb,rtdb_charge_tag,rtdb_coord_tag,
     &                      ncenter,charge,coord)
      implicit none
      integer       rtdb
      character*(*) rtdb_charge_tag
      character*(*) rtdb_coord_tag
      integer       ncenter
      real*8        charge(*)
      real*8        coord(*)

#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"

*     **** local variables ****
      integer      ncenter_tmp,ncenter3_tmp,matype1,matype2
      character*26 date
      
      ncenter = 0
      if (rtdb_get_info(rtdb,rtdb_charge_tag,
     &                  matype1,ncenter_tmp,date).and.
     &   rtdb_get_info(rtdb,rtdb_coord_tag,
     &            matype2,ncenter3_tmp,date)) then

        if ((ncenter3_tmp .eq. (3*ncenter_tmp)) .and.
     &      (matype1.eq.matype2)                .and.
     &      (matype1.eq.mt_dbl))                then

          !*** get charges ***
          if (.not.rtdb_get(rtdb,rtdb_charge_tag,
     &                      mt_dbl,ncenter_tmp,charge))
     &      goto 35

          !*** get coordinates ***
          if (.not.rtdb_get(rtdb,rtdb_coord_tag,
     &                      mt_dbl,ncenter3_tmp,coord))
     &      goto 35

            ncenter = ncenter + ncenter_tmp
        end if
      end if

  35  continue
      return
      end

      subroutine uccsdt_fterm(urange,vrange,lists)
c
c$Id: fterm.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
#include "mafdecls.fh"
#include "bas.fh"
#include "global.fh"
#include "cuccsdtP.fh"
c
      integer urange(2,0:7),vrange(2,0:7),u,v,m,n,vhi,vlo,uhi,ulo
      integer nspin,mspin,espin,fspin
      integer symv,symn,symf,symm,syme,symu
      integer symiu,symmu,symnf,symnv,symme
      integer k_vulist,l_vulist
      integer k_upart,l_upart
      integer k_vpart,l_vpart
      integer k_fpart,l_fpart
      integer k_eflist,l_eflist
      integer m_address,n_address, offset_me,offset_n,offset_nf
      integer dimu,dimv,dimf,dimn,dimm,dime,dimme,dimnf
      integer g_r_array,g_r
      integer dim_mx,list_nr,lists(0:7,14),mnpairs,mn
C
C     GENERATION OF F-TERM
C
C     COMPUTING F(me,nf) = <ef||^ mn> for each spin-block
C
C     <uv|mn> stored as (nv,mu) to be transformed to (nf,me)
C     On each processor
C        Get an mn pair
C        For each mn pair, get whole (u,v)_mn block and transform to (e,f)_mn
c            (v,u)*c(u,e)->(v,e)->(v,e)^t*(v,f)->(e,f)->(me,nf)
C        Put (e,f)_mn block back into F(me,nf)
C
      do nspin = 1, 2
         do mspin = 1, nspin
            espin = mspin
            fspin = nspin
            list_nr = 4 + nspin + (mspin-1)*2
            do symnf = 0, nir-1 
               symnv = symnf
               symme = symnf 
               symmu = symme
               dimme = ov_len(symme,mspin,mspin)
               dimnf = ov_len(symnf,nspin,nspin)
               if (.not. ga_create(MT_DBL,dimme,dimnf,'R_temp',0,0,
     &             g_r_array)) call 
     &             errquit('fterm: create g_r_array failed',0)
               do symf = 0, nir-1
                  symv = symf
                  symn = ieor(symnf, symf)
                  do syme = 0, nir-1
                     symu = syme
                     symm = ieor (symme, syme)
                     dime = nv_sym(syme,espin)
                     dimf = nv_sym(symf,fspin)
                     dimm = no_sym(symm,mspin)
                     dimn = no_sym(symn,nspin)
                     ulo = urange(1,symu)
                     uhi = urange(2,symu)
                     vlo = vrange(1,symv)
                     vhi = vrange(2,symv)
                     dimv = vhi - vlo + 1
                     dimu = uhi - ulo + 1
                     mnpairs = dimm*dimn
                     do mn = ga_nodeid()+1, mnpairs, ga_nnodes() 
                        m = (mnpairs / (dimn+1)) + 1
                        n = mnpairs - (dimm * (m-1))
                        if (.not. ma_push_get(mt_dbl,dimv*dimu,
     &                      'vu list',l_vulist,k_vulist)) call
     &                      errquit('fterm: vu list alloc failed',0)
                        dim_mx = max(dime,dimf)
                        if (.not. ma_push_get(mt_dbl,dim_mx*dim_mx,
     &                      'ef list',l_eflist, k_eflist)) call
     &                      errquit('fterm: ef list alloc failed',0)
                        n_address = o_sym(1,symn,nspin)+n-1
     &                              +oso_v_off(v,symnv,nspin)
                        m_address = o_sym(1,symm,mspin)+m-1
     &                              +oso_u_off(u,symmu,mspin)
                        call ga_get_strided(lists(symmu,list_nr),
     &                             n_address,dimv,dimn,
     &                             m_address,dimu,dimm,
     &                             dbl_mb(k_vulist))
                        if (.not. ma_push_get(mt_dbl,dimu*dime,
     &                      'c particle ue',l_upart,k_upart)) call
     &                      errquit('fterm: ue part alloc failed',0)
                        if (.not. ma_push_get(mt_dbl,dimv*dimf,
     &                      'c particle vf',l_vpart,k_vpart)) call
     &                      errquit('fterm: vf part alloc failed',0)
                        call ga_get(g_part(espin),ulo,uhi,
     &                             v_sym(1,syme,espin),
     &                             v_sym(2,syme,espin),
     &                             dbl_mb(k_upart),dimu)  
                        call ga_get(g_part(fspin),vlo,vhi,
     &                             v_sym(1,symf,fspin),
     &                             v_sym(2,symf,fspin),
     &                             dbl_mb(k_vpart),dimv)  
                        call dgemm('n','n',dimv,dime,dimu,1.0d0,
     &                             dbl_mb(k_vulist),dimv,
     &                             dbl_mb(k_upart),dimu,1.0d0,
     &                             dbl_mb(k_eflist),dimv)
                        call dgemm('t','n',dime,dimf,dimv,1.0d0,
     &                             dbl_mb(k_eflist),dimv,
     &                             dbl_mb(k_vpart),dimv,1.0d0,
     &                             dbl_mb(k_eflist),dime)
                        if (.not. ma_pop_stack(l_vpart)) call 
     &                      errquit('fterm: vf part dealloc failed',0)
                        if (.not. ma_pop_stack(l_upart)) call 
     &                      errquit('fterm: ue part dealloc failed',0)
                        call ga_put_strided(g_r_array,
     &                             m_address,dime,dimm,
     &                             n_address,dimf,dimn,
     &                             dbl_mb(k_eflist),dime)
                        if (.not. ma_pop_stack(l_eflist)) call 
     &                      errquit('fterm: ef list dealloc failed',0)
                        if (.not. ma_pop_stack(l_vulist)) call 
     &                      errquit('fterm: vu list dealloc failed',0)
                     end do
                  end do
               enddo
               offset_me = file_t2_off(mspin,espin,nspin,fspin,symnf)+
     &                     ov_off(1,symme,mspin,espin)
               offset_nf = file_t2_off(mspin,espin,nspin,fspin,symnf)+
     &                     ov_off(1,symnf,nspin,fspin)
               call ga_copy_patch('n',g_r_array,1,dimme,1,dimnf,g_r,
     &              offset_me,offset_me+dimme,offset_nf,offset_nf+dimnf)
               if (.not. ga_destroy(g_r_array)) call
     &             errquit('fterm: g_r_array dealloc failed',0)
            end do
         end do
      enddo
c
      end
c
      subroutine ga_get_strided(ga_in,ilo,ilength,istride,
     &                          jlo,jlength,jstride,array_out)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
c
      integer ga_in,ilo,ilength,istride,jlo,jlength,jstride
      integer nelem,ilist,jlist,ihi,jhi
      integer k_i,l_i,k_j,l_j
      double precision array_out(*)
c
      ihi = ilo + (ilength-1) * istride
      jhi = jlo + (jlength-1) * jstride
      nelem = ilength*jlength
      if (.not. ma_push_get(mt_dbl,nelem,'i list',l_i,k_i)) call
     &    errquit('ga_get_strided: i list alloc failed',0)
      if (.not. ma_push_get(mt_dbl,nelem,'j list',l_j,k_j)) call
     &    errquit('ga_get_strided: j list alloc failed',0)
      nelem = 0
      do jlist = jlo, jhi, jstride
         do ilist = ilo, ihi, istride
            int_mb(k_i+nelem) = ilist 
            int_mb(k_j+nelem) = jlist 
            nelem = nelem + 1
         enddo
      enddo
      call ga_gather(ga_in,array_out,int_mb(k_i),int_mb(k_j),nelem)
      if (.not. ma_pop_stack(l_i)) call 
     &   errquit('ga_put_strided: i list dealloc failed',0)
      if (.not. ma_pop_stack(l_j)) call 
     &   errquit('ga_put_strided: j list dealloc failed',0)
c
      end
c
      subroutine ga_put_strided(ga_out,ilo,ilength,istride,
     &                          jlo,jlength,jstride,array_in)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
c
      integer ga_out,ilo,ilength,istride,jlo,jlength,jstride
      integer nelem,ilist,jlist,ihi,jhi
      integer k_i,l_i,k_j,l_j
      double precision array_in(*)
c
      ihi = ilo + (ilength-1) * istride
      jhi = jlo + (jlength-1) * jstride
      nelem = ilength*jlength
      if (.not. ma_push_get(mt_dbl,nelem,'i list',l_i,k_i)) call
     &    errquit('ga_put_strided: i list alloc failed',0)
      if (.not. ma_push_get(mt_dbl,nelem,'j list',l_j,k_j)) call
     &    errquit('ga_put_strided: j list alloc failed',0)
      nelem = 0
      do jlist = jlo, jhi, jstride
         do ilist = ilo, ihi, istride
            nelem = nelem + 1
            int_mb(k_i+nelem) = ilist 
            int_mb(k_j+nelem) = jlist 
         enddo
      enddo
      call ga_scatter(ga_out,array_in,int_mb(k_i),int_mb(k_j),nelem)
      if (.not. ma_pop_stack(l_i)) call 
     &   errquit('ga_put_strided: i list dealloc failed',0)
      if (.not. ma_pop_stack(l_j)) call 
     &   errquit('ga_put_strided: j list dealloc failed',0)
c
      end

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_wlkchk(ENEW,CONVGE,BCKSTP,NMODE)
c $Id: stpr_wlkchk.F 25540 2014-05-01 22:33:27Z d3y133 $
C
C     Determination of walk information.
C
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
#include "util.fh"
      LOGICAL BCKSTP, LPRINT
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      COMMON / OLDES / ELAST,E2PRED
      BCKSTP = .FALSE.
      LPRINT = util_print('line information', print_low)
      IF(ICALC.GT.0)THEN
        IF(IWCTR.LE.1)THEN
c          IF(LPRINT)THEN
c            WRITE(6,*)'  There is not yet enough information '
c            WRITE(6,*)'  available to determine geometry walk '
c            WRITE(6,*)'  characteristics. '
c          ENDIF
          RETURN
        ELSE
c          IF(LPRINT)THEN
c            WRITE(6,*)'  Checking geometry walk information. '
c          ENDIF
        ENDIF
      ELSE
        RETURN
      ENDIF
C
C     Calculate actual energy difference ... EDIFF
C
      EDIFF = ENEW - ELAST
C
C     If actual or 2nd order predicted energies are less then
C     an energy tolerance e.g. ETOL then DO NOT worry about
C     backstepping.
C
      ETOL = CONVGE
      IF(ABS(EDIFF).LT.ETOL.OR.ABS(E2PRED).LT.ETOL)THEN
        IF(LPRINT)THEN
          WRITE(6,*)'  Actual energy difference is : ',EDIFF
          WRITE(6,*)'  2nd order predicted energy difference ',
     &              ' was : ',E2PRED
          WRITE(6,*)'  One of these is below the energy ',
     &              ' tolerance: ',ETOL
          WRITE(6,*)'  Backstepping possibilities are NO '
          WRITE(6,*)'  longer considered appropriate. '
        ENDIF
C
C       Set backstep flag .FALSE.
C
        BCKSTP = .FALSE.
        ERATIO = 0.0D0
        RETURN
      ELSE
C
C       Calculate actual to predicted energy ratio.
C
        ENUM = MIN(ABS(EDIFF),ABS(E2PRED))
        EDEN = MAX(ABS(EDIFF),ABS(E2PRED))
        ERATIO = 0.0D0
        IF(ABS(EDEN).GT.1.D-12)ERATIO = ENUM/EDEN
      ENDIF
C
C     Check sign of actual to predicted energies.
C
      ISEDIF = DNINT(ABS(EDIFF)/EDIFF)
      IF(E2PRED.NE.0)THEN
        ISE2OL = DNINT(ABS(E2PRED)/E2PRED)
      ELSE
        ISE2OL = ISEDIF
      ENDIF
      IF(ICALC.EQ.2)THEN
        IF(ISEDIF.NE.ISE2OL)THEN
          IF(LPRINT)THEN
            WRITE(6,*)'  Signs : ',ISEDIF,ISE2OL
            WRITE(6,*)'  Actual energy difference is : ',EDIFF
            WRITE(6,*)'  2nd order predicted energy ',
     &                ' difference was : ',E2PRED
            WRITE(6,*)'  Actual and predicted energies have '
            WRITE(6,*)'  sign disagreement.  Back-step is in '
            WRITE(6,*)'  order here. '
          ENDIF
          BCKSTP = .TRUE.
        ENDIF
      ELSEIF(ICALC.EQ.1.AND.IWCTR.GT.2)THEN
        IF(ISEDIF.NE.ISE2OL)THEN
          IF(LPRINT)THEN
            WRITE(6,*)'  Signs : ',ISEDIF,ISE2OL
            WRITE(6,*)'  Actual energy difference is : ',EDIFF
            WRITE(6,*)'  2nd order predicted energy ',
     &                ' difference was : ',E2PRED
            WRITE(6,*)'  Actual and predicted energies have '
            WRITE(6,*)'  sign disagreement.  Back-step is in '
            WRITE(6,*)'  order here. '
          ENDIF
          BCKSTP = .TRUE.
        ENDIF
      ENDIF
      IF(BCKSTP)RETURN
C
C     Set energy ratio backstep criterion.
C
      IF(ICALC.EQ.2)THEN
        ERATM = 0.0D0
      ELSEIF(ICALC.EQ.1)THEN
        ERATM = 0.0D0
      ENDIF
C
C     Check ratio of 2nd order energy prediction to actual energy.
C
      IF(LPRINT)THEN
        WRITE(6,'(a,f10.6)')
     $        '  Energy ratio, actual to predicted = ',
     &            ERATIO
      ENDIF
      IF(ERATIO.LT.ERATM)THEN
          IF(LPRINT)THEN
            WRITE(6,*)'  Actual energy difference is : ',EDIFF
            WRITE(6,*)'  2nd order predicted energy ',
     &                ' difference was : ',E2PRED
          ENDIF
        IF(NMODE.GT.0)THEN
          IF(LPRINT)THEN
            WRITE(6,*)'  There is poor agreement between '
            WRITE(6,*)'  actual and predicted energies ... '
            WRITE(6,*)'  less than: ',ERATM,' percent.  '
            WRITE(6,*)'  Conservatism in transition state '
            WRITE(6,*)'  walks --> Back-step is in order here. '
          ENDIF
          BCKSTP = .TRUE.
        ELSE
          IF(LPRINT)THEN
            WRITE(6,*)'  There is poor agreement between '
            WRITE(6,*)'  actual and predicted energies ... '
            WRITE(6,*)'  less than: ',ERATM,' percent.  '
            WRITE(6,*)'  Conservatism suggests that a  '
            WRITE(6,*)'  Back-step is in order here. '
          ENDIF
          BCKSTP = .TRUE.
        ENDIF
      ENDIF
C
C     Write walk backstep flag.
C
      IF(BCKSTP)THEN
          IF(LPRINT)THEN
            WRITE(6,*)' >>>> Geometry backstep in progress <<<<'
          ENDIF
      ELSE
c          IF(LPRINT)THEN
c            WRITE(6,*)'  Predicted versus actual energy in '
c            WRITE(6,*)'  geometry walk is JUST FINE. '
c          ENDIF
      ENDIF
      RETURN
      END
C> @}

c
c $Id: analysis_expansion_coef.F 22388 2012-05-07 16:32:57Z bylaska $
c
      subroutine analysis_expansion_coef(filename,lorb0,rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"

      character*255 filename
      integer lorb0
      integer rtdb

*     **** local variables ****
      integer lmax,i,nrho,ind,lorb
      real*8  b0(0:5),u2(0:5),u3(0:5)
      real*8  x2,y2,x3,y3,dum
      character*2 atom
 
      character*255 id,full_filename


      lorb = lorb0

      call util_file_name_noprefix(filename,.false.,.false.,
     >                    full_filename)


      ind = index(full_filename,' ') - 1
      open(82,FILE=full_filename,STATUS='OLD',FORM='FORMATTED')
        read(82,'(A2)') atom
        read(82,*) dum,dum,lmax
        read(82,*)
        read(82,*) nrho,dum
        read(82,*)
        do i=1,nrho
          read(82,*)
        end do
        read(82,*) 
        read(82,*) x2,(u2(i),i=0,lmax)
        read(82,*) x3,(u3(i),i=0,lmax)
      close(82)
      if (lorb.lt.0) lorb = lmax-1


      do i=0,lorb
          Y2=U2(i)/X2**(i+1)
          Y3=U3(i)/X3**(i+1)
          b0(i)=Y2-X2*(Y2-Y3)/(X2-X3)
      end do

      WRITE(6,*)
      WRITE(6,1300) filename(1:ind)
      WRITE(6,1305) 'ATOM ','S','P','D','F'
      WRITE(6,1310) ATOM,(B0(i),i=0,lorb)
      WRITE(6,*)
      WRITE(6,*)
      call util_flush(6)
 1300 FORMAT('== ',A,' expansion coefficients =='/)
 1305 FORMAT(A5,6X,A,12X,A,12X,A,12X,A)
 1310 FORMAT(A2,' : ',4E13.5)

      id = 'analysis:lorb'//atom
      if (.not. rtdb_put(rtdb,id,mt_int,1,lorb))
     >        call errquit(
     >        'analysis_input: rtdb_put failed', 0, RTDB_ERR)

      id = 'analysis:expansion'//atom
      if (.not. rtdb_put(rtdb,id,mt_dbl,(lorb+1),b0))
     >        call errquit(
     >        'analysis_input: rtdb_put failed', 0, RTDB_ERR)

      return
      end

      SUBROUTINE YTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, MM, M, WORK, INFO )
c $Id: ytrevc.F 21373 2011-11-02 20:52:29Z d3p852 $
*
      implicit none
#include "y64.fh"
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
C Warning size of logical=size of integer:  Will not work with HOWMNY="S"
      LOGICAL            SELECT( * )
      DOUBLE PRECISION   T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
c
      INTGR4            INFO4, LDT4, LDVL4, LDVR4, M4, MM4, N4
c
      LDT4=ldt
      LDVL4=ldvl
      LDVR4=ldvr
      M4=m
      MM4=mm
      N4=n
c      
      call DTREVC( SIDE, HOWMNY, SELECT, N4, T, LDT4, VL, LDVL4, VR,
     $                   LDVR4, MM4, M4, WORK, INFO4 )
      info=info4
      return
      end

      program pippo
      implicit none

      character*255 stcr
      integer zcomp,zcomm
      integer valcomm,valcomp
      integer newdist
      integer ga_Nodeid
      external ga_Nodeid
      integer getdist
      external getdist

      stcr='comp'
      call initialize_dist()
      zcomp = getdist( stcr )

      valcomp=123456
      call updist(zcomp, valcomp-1)
      call updist(zcomp, valcomp+10)
      call updist(zcomp, valcomp-1)
      call updist(zcomp, valcomp-2)
      call updist(zcomp, valcomp)
      call updist(zcomp, valcomp+10)


      call finalize_dist( ga_Nodeid() )

      stop
      end
c $Id: testdist.F 21483 2011-11-09 19:02:13Z d3p852 $

* $Id: test_drive.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
      Integer LUIn, LUOut, LUErr
      Parameter (LuIn = 5, LuOut = 6, LuErr = 0)
C###      Common /StdIO_Units/ LuIn, LuOut, LuErr
#include "ecp_consts.fh"
      integer i,j,k,l,m,n,ii,jj,lla,llb,
     &    iz_bas,ic_bas,iz_ecp,ic_ecp,jz_bas,jc_bas,n_bas,nprim,ncont,
     &    l_bas,l_ecp,i_C,n_C,idum,
     &    n_zeta_C,n_coef_C,n_C,l_ecp_max,lmax_both,
     &    n_prim_A,n_cont_A,l_A,i_c_A,nn_A,nb_A,
     &    n_prim_B,n_cont_B,l_B,i_c_B,nn_B,nb_B,
     &    n_int,n_blk,sphcart,lscr,ibug
      integer n_prim_C(0:2,-1:5,20),n_colc_C(-1:5,20),
     &    ind_z(-1:5,20),ind_c(-1:5,20),
     &    l_C(10),i_cent_C(10),n_bas_C(10),
     &    l_bas_C(20,10),nprim_bas(20,10),ncont_bas(20,10)

      integer lcsco,lscr
      parameter (lcsco = 10000,lscr=1000000)
      logical DryRun
      double precision w3,wint,wn,zz,
     &    xyz(3,10),z_bas(1000),c_bas(10000),
     &    z_ecp(1000),c_ecp(1000),
     &    scr(lscr),ecp_ints(10000)
      double precision csco(lcsco)
      character*2 type(10)
      character*1 llabel(0:2)
      data type/'  ','x ','y ','z ','x2','xy','xz','y2','yz','z2'/
      data llabel/'s','p','d'/
*
*  Read data
*
      call ecp_init_con
      w3 = one/sqrt(3.0d0)
      read (LuIn,*) ibug
      iz_bas = 0
      ic_bas = 0
      iz_ecp = 1
      ic_ecp = 1
      read (LUIn,*) n_C
      l_bas = 0
      l_ecp = 0
      do i_C = 1,n_C
        read (LUIn,*) (xyz(i,i_C),i=1,3)
        read (LUIn,*) n_bas
        n_bas_C(i_C) = n_bas
        do n = 1,n_bas
          read (LUIn,*) l,nprim,ncont
          l_bas_C(n,i_C) = l
          nprim_bas(n,i_C) = nprim
          ncont_bas(n,i_C) = ncont
          l_bas = max(l_bas,l_bas_C(n,i_C))
          do m = 1,nprim
            iz_bas = iz_bas+1
            read (LUIn,*) z_bas(iz_bas),(c_bas(ic_bas+k),k=1,ncont)
*
*         normalize basis functions
*
            zz =  z_bas(iz_bas)
            zz = zz+zz
            wn = sqrt((zz/pi)**3)
            if (l .gt. 0) wn = wn*(zz+zz)**l
            wn = sqrt(wn)
            do k = 1,ncont
              c_bas(ic_bas+k) = c_bas(ic_bas+k)*wn
            end do
            ic_bas = ic_bas+ncont
          end do
        end do
*
*     Read ECP data
*
        read (LUIn,*) l_C(i_C) 
        l_ecp = max(l_ecp,l_C(i_C))
        i_cent_C(i_C) = i_C
*
*     Local potential
*
        read (LUIn,*)  (n_prim_C(k,-1,i_C),k=0,2)
        ind_z(-1,i_C) = iz_ecp
        ind_c(-1,i_C) = ic_ecp
        n = 0
        do k = 0,2
          n = n+n_prim_C(k,-1,i_C)
          do m = 1,n_prim_C(k,-1,i_C)
            read (LUIn,*) j,z_ecp(iz_ecp),c_ecp(ic_ecp)
            if (j .ne. k) then
              write (LUOut,*) 'ECP data mismatch'
              stop
            end if
            iz_ecp = iz_ecp+1
            ic_ecp = ic_ecp+1
          end do
        end do
        n_colc_C(-1,i_C) = n
*
*     Scalar nonlocal potential
*
        do l = 0,l_C(i_C)
          read (LUIn,*)  (n_prim_C(k,l,i_C),k=0,2)
          ind_z(l,i_C) = iz_ecp
          ind_c(l,i_C) = ic_ecp
          n = 0
          do k = 0,2
            n = n+n_prim_C(k,l,i_C)
            do m = 1,n_prim_C(k,l,i_C)
              read (LUIn,*) j,z_ecp(iz_ecp),c_ecp(ic_ecp)
              if (j .ne. k) then
                write (LUOut,*) 'ECP data mismatch'
                stop
              end if
              iz_ecp = iz_ecp+1
              ic_ecp = ic_ecp+1
            end do
          end do
          n_colc_C(l,i_C) = n
        end do
*
*     Spin-orbit nonlocal potential
*
        do l = 1,l_C(i_C)
          read (LUIn,*)  (n_prim_C(k,l,i_C+n_C),k=0,2)
          ind_z(l,i_C+n_C) = iz_ecp
          ind_c(l,i_C+n_C) = ic_ecp
          n = 0
          do k = 0,2
            n = n+n_prim_C(k,l,i_C+n_C)
            do m = 1,n_prim_C(k,l,i_C+n_C)
              read (LUIn,*) j,z_ecp(iz_ecp),c_ecp(ic_ecp)
              if (j .ne. k) then
                write (LUOut,*) 'ECP data mismatch'
                stop
              end if
              iz_ecp = iz_ecp+1
              ic_ecp = ic_ecp+1
            end do
          end do
          n_colc_C(l,i_C+n_C) = n
        end do
      end do
      n_zeta_C = iz_ecp-1
      n_coef_C = ic_ecp-1
*
*  Initialize spherical transformation
*
      call defNxyz(l_bas)
      lmax_both = l_ecp + l_bas + 2 
      call ecp_init_c2s(lmax_both,csco,csco,lcsco,1,1,.true.,idum)
      write (LuOut,*) 'Cstrans needs',idum
      call ecp_init_c2s(lmax_both,csco,csco,lcsco,1,1,.false.,idum)
*
*  Call integral routine
*
      l_ecp_max = 5
      sphcart = 0
      DryRun = .false.
*
      n_blk = 1
      iz_bas = 1
      ic_bas = 1
      do i = 1, n_C
        do k = 1,n_bas_C(i)
          l_A = l_bas_C(k,i)
          lla = l_A*l_A
          n_prim_A = nprim_bas(k,i)
          n_cont_A = ncont_bas(k,i)
          nn_A = (l_A+1)*(l_A+2)/2
          nb_A = nn_A*n_cont_A
          i_c_A = i
*
          jz_bas = 1
          jc_bas = 1
          do j = 1,i
            n_bas = n_bas_C(j)
            if (j .eq. i) n_bas = k
            do m = 1,n_bas
              l_B = l_bas_C(m,j)
              llb = l_B*l_B
              n_prim_B = nprim_bas(m,j)
              n_cont_B = ncont_bas(m,j)
              nn_B = (l_B+1)*(l_B+2)/2
              nb_B = nn_B*n_cont_B
              i_c_B = j
              n_int = nb_A*nb_B
              call ecp_integral (
     &            xyz(1,i),z_bas(iz_bas),c_bas(ic_bas),
     &            n_prim_A,n_cont_A,l_A,i_c_A,
     &            xyz(1,j),z_bas(jz_bas),c_bas(jc_bas),
     &            n_prim_B,n_cont_B,l_B,i_c_B,
     &            xyz,z_ecp,c_ecp,n_prim_C,n_colc_C,
     &            ind_z,ind_c,n_zeta_C,n_coef_C,
     &            l_C,i_cent_C,n_C,l_ecp_max,
     &            sphcart,csco,lcsco,
     &            ecp_ints,n_int,n_blk,
     &            DryRun,scr,lscr,ibug)
              n = 1
              do ii = 1,nn_A
                do jj = 1,nn_B
                  wint = ecp_ints(n)
                  if (l_B .eq. 2 .and. (jj .eq. 1 .or. jj .eq. 4 .or.
     &                jj .eq. 6)) wint = wint*w3
                  if (l_A .eq. 2 .and. (ii .eq. 1 .or. ii .eq. 4 .or.
     &                ii .eq. 6)) wint = wint*w3
                  if (abs(wint) .gt. 1.0d-10)
     &                write (LuOut,600) i,llabel(l_A),k,type(ii+lla),
     &                j,llabel(l_B),m,type(jj+llb),wint
  600             format(2(i1,a1,i1,1x,a2,4x),F26.16)
                  n = n+1
                end do
              end do
*
              jz_bas = jz_bas+n_prim_B
              jc_bas = jc_bas+n_prim_B*n_cont_B
            end do
          end do
          iz_bas = iz_bas+n_prim_A
          ic_bas = ic_bas+n_prim_A*n_cont_A
        end do
      end do
*
*     Spin-orbit integrals
*
      n_blk = 3
      iz_bas = 1
      ic_bas = 1
      do i = 1, n_C
        do k = 1,n_bas_C(i)
          l_A = l_bas_C(k,i)
          lla = l_A*l_A
          n_prim_A = nprim_bas(k,i)
          n_cont_A = ncont_bas(k,i)
          nn_A = (l_A+1)*(l_A+2)/2
          nb_A = nn_A*n_cont_A
          i_c_A = i
*
          jz_bas = 1
          jc_bas = 1
          do j = 1,i
            n_bas = n_bas_C(j)
            if (j .eq. i) n_bas = k
            do m = 1,n_bas
              l_B = l_bas_C(m,j)
              llb = l_B*l_B
              n_prim_B = nprim_bas(m,j)
              n_cont_B = ncont_bas(m,j)
              nn_B = (l_B+1)*(l_B+2)/2
              nb_B = nn_B*n_cont_B
              i_c_B = j
              n_int = nb_A*nb_B
              write (6,*) '**********', i,k,j,m, '**********'
              call ecp_integral (
     &            xyz(1,i),z_bas(iz_bas),c_bas(ic_bas),
     &            n_prim_A,n_cont_A,l_A,i_c_A,
     &            xyz(1,j),z_bas(jz_bas),c_bas(jc_bas),
     &            n_prim_B,n_cont_B,l_B,i_c_B,
     &            xyz,z_ecp,c_ecp,n_prim_C,n_colc_C,
     &            ind_z,ind_c,n_zeta_C,n_coef_C,
     &            l_C,i_cent_C,n_C,l_ecp_max,
     &            sphcart,csco,lcsco,
     &            ecp_ints,n_int,n_blk,
     &            DryRun,scr,lscr,ibug)
              n = 1
              do l = 1,3
                write (LuOut,*) type(5-l),'spin-orbit'
                do ii = 1,nn_A
                  do jj = 1,nn_B
                    wint = ecp_ints(n)
                    if (l_B .eq. 2 .and. (jj .eq. 1 .or. jj .eq. 4 .or.
     &                  jj .eq. 6)) wint = wint*w3
                    if (l_A .eq. 2 .and. (ii .eq. 1 .or. ii .eq. 4 .or.
     &                  ii .eq. 6)) wint = wint*w3
                    if (abs(wint) .gt. 1.0d-10)
     &                  write (LuOut,600) i,llabel(l_A),k,type(ii+lla),
     &                  j,llabel(l_B),m,type(jj+llb),wint
                    n = n+1
                  end do
                end do
              end do
*
              jz_bas = jz_bas+n_prim_B
              jc_bas = jc_bas+n_prim_B*n_cont_B
            end do
          end do
          iz_bas = iz_bas+n_prim_A
          ic_bas = ic_bas+n_prim_A*n_cont_A
        end do
      end do
*
      stop
      end

      integer function moints_trp_mem(basis, nmo1, blen)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "mafdecls.fh"
      integer basis, nmo1, blen
c
c     return memory required for moints_trp with given arguments
c
      integer nbf, nsh, maxbfsh, max2e, mem2
      integer n_ssni, n_integ, n_ssbb, n_hlp, bsize
      logical status
c
      status = bas_numbf(basis,nbf)
      status = status.and.bas_numcont(basis,nsh)
      status = status.and.bas_nbf_cn_max(basis,maxbfsh)
      if (.not.status) call errquit('moints: cannot get basis info',0,
     &       BASIS_ERR)
      bsize = max(blen,maxbfsh)
      call intb_mem_2e4c(max2e, mem2) ! Determine mem2 = scratch space
      max2e = max(max2e,min(50*maxbfsh**4,21**4)) ! Enuf room for 1 cartesian H shell
      n_integ = max2e+mem2+ma_sizeof(mt_int, 4*max2e, mt_dbl)
      n_ssbb = maxbfsh*maxbfsh*bsize*bsize
      n_ssni = maxbfsh*maxbfsh*nbf*nmo1
      n_hlp = max((bsize*maxbfsh*maxbfsh*nmo1),(maxbfsh*nbf))
c
      moints_trp_mem = 
     $     ma_sizeof(mt_int, 3*(nbf+nsh), mt_dbl) +
     $     nbf**2 + n_ssni + n_ssbb + max(n_integ, n_hlp+n_ssbb)
c
      end
      

c  $Id: moints_trp.F 24570 2013-09-12 02:50:38Z edo $
c
c
c     No-one knows what this stuff is doing ... are the next comments correct?
c
c  This routine returns the Coulomb and exchange integral
c  operator matrices for the range of MO-indices as mo_indx_hi, mo_indx_lo
c  The g_coul, g_exch global arrays are ordered as
c
c               ij
c  (ij|ab) = ( J  )  = g_coul[ ij : (a-1)*N2 + b ] = g_coul [ ij : (b-1)*N2 + a ]
c                  ab
c
c               ij
c  (ia|jb) = ( K  )  = g_exch[ ij : (a-1)*N2 + b ]
c                  ab
c
c

       subroutine moints_trp( rtdb, basis, ohalf,
     $                        occ_start, mo1_lo, mo1_hi,
     $                        mo2_lo, mo2_hi,
     $                        g_coul, ocoul,
     $                        g_exch, oexch,
     $                        blen, cmo, ncor, nocc, nvir, ndel, Tol2E)
       implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "bas.fh"
#include "sym.fh"
#include "util.fh"
#include "schwarz.fh"
#include "rtdb.fh"
#include "msgids.fh"
c
c Arguments
c
       integer rtdb
       integer basis                          ! Basis handle
       logical ohalf                          ! Toggle alternative algorithm for half-ints intermediates
       integer occ_start                      ! Offset from frozen core
       integer mo1_lo, mo1_hi                 ! 1st Pair Index range
       integer mo2_lo, mo2_hi                 ! 2nd Pair Index range
       integer g_coul                         ! Coulomb operator
       integer g_exch                         ! Exchange operator
       logical ocoul,oexch                    ! Type selection
       integer blen                           ! Blocking length
       integer ncor, nocc, nvir, ndel
       double precision cmo(*)
       Double Precision Tol2E                 ! Integral tolerance
c
c Local variables
c
       integer geom, nmo1, nmo2, nbf, nsh, maxbfsh
       integer bsize, ngrp, kgr, lgr
       integer ish0, jsh0, ish, jsh, ilen, jlen
       integer ibflo,ibfhi,jbflo,jbfhi,kbflo,kbfhi,lbflo,lbfhi
       integer kshlo, kshhi, lshlo, lshhi
       integer kblen, lblen
       integer l_ssbb, k_ssbb, l_ssbbt, k_ssbbt, l_xmo, k_xmo
       integer l_hlp, k_hlp, l_ssni,k_ssni
       integer l_hlp2, k_hlp2, l_hlp3, k_hlp3
       integer l_eri, k_eri, l_iscr,k_iscr
       integer l_shmap, k_shmap, l_bfmap, k_bfmap, l_rbfmap, k_rbfmap
       integer l_glo, k_glo, l_ghi, k_ghi
       integer n_ssbb, n_ssni, n_hlp, n_hlp2, n_hlp3, n_ijni
       integer mem2, max2e
       integer num_nodes, ploop, next, nmixed, i, iz, jz, kz
       integer l_sym, k_sym
       integer g_tmp                       
       integer nmo
       double precision scale, schw_ij, q2
*       double precision d1, d2
       logical status, osym, odapt,odoit, oblk, st
c
       integer moints_numgr, gr_len, nxtask
       external moints_numgr, gr_len, nxtask
c
       double precision half
       data half/0.5d00/
       data oblk/.true./    ! toggle whether to use Texas blocking or shell quartet AO ints
c
c  General basis info
c
       num_nodes = ga_nnodes()
       if (.not. bas_geom(basis, geom)) call errquit
     $      ('moints: cannot get geometry', 0, GEOM_ERR)
       status = bas_numbf(basis,nbf)
       status = status.and.bas_numcont(basis,nsh)
       status = status.and.bas_nbf_cn_max(basis,maxbfsh)
       if (.not.status) call errquit('moints: cannot get basis info',0,
     &       BASIS_ERR)
       nmo1 = mo1_hi - mo1_lo + 1
       nmo2 = mo2_hi - mo2_lo + 1
c
       nmo = ncor + nocc + nvir + ndel
c     
c  Symmetry adapt the MOs and renumber irreps to start at zero
c     
      if (.not.rtdb_get(rtdb, 'scf:adapt',MT_LOG, 1, osym)) then
         osym = sym_number_ops(geom) .gt. 0
      endif
c
c Check if point group is abelian, if not turn off symmetry
c
       osym = osym.and.sym_abelian_group(geom)
       if(ga_nodeid().eq.0) write(6,*) ' symmetry use ',osym
       if (osym) then
          if (.not. ma_push_get(MT_INT, nbf, 'movec syms',l_sym, k_sym))
     $         call errquit('moints_trp: no memory for syms?',0, MA_ERR)
*ga:1:0
          if (.not.ga_create(MT_DBL,nbf,nmo,'tmp',nbf,0,g_tmp))
     $      call errquit('moints_trp: cannot ga_create tmp',0, GA_ERR)
          if (ga_nodeid() .eq. 0) call ga_put(g_tmp,1,nbf,1,nmo,cmo,nbf)
	  call ga_sync
          call sym_movecs_adapt( basis, 1d-8, g_tmp,
     $                            int_mb(k_sym), nmixed )
          call ga_get(g_tmp,1,nbf,1,nmo,cmo,nbf)
          if (.not.ga_destroy(g_tmp))
     $      call errquit('cannot destroy tmp',0, GA_ERR)
          if (nmixed .ne. 0)
     $       call errquit('moints_trp: symmetry contamination', nmixed,
     &       UNKNOWN_ERR)
          do i =0, nmo-1
             int_mb(k_sym+i) = int_mb(k_sym+i) - 1
          enddo
          if (util_print('orbital symmetry',print_debug)) then
            write(6,887) 
 887        format('Symmetry of MOs')
            write(6,888) (int_mb(k_sym+i),i=0,nmo-1)
 888        format(16i3)
          endif
       endif
c
c  Integrals allocation
c
*      call int_mem_2e4c(max2e, mem2)
       call intb_mem_2e4c(max2e, mem2) ! Determine mem2 = scratch space
       max2e = max(max2e,min(50*maxbfsh**4,21**4)) ! Enuf room for 1 cartesian H shell
c
c  Reorder shells by descending shell-length
c
       status = ma_push_get(MT_INT,nsh,'shell order map',
     $                      l_shmap, k_shmap)
       status = ma_push_get(MT_INT,nsh,'group lo', l_glo, k_glo )
     $       .and. status
       status = ma_push_get(MT_INT,nsh,'group hi', l_ghi, k_ghi)
     $       .and. status
       status = ma_push_get(MT_INT,nbf,'basis map',
     $                      l_bfmap, k_bfmap)
     $       .and. status
       status = ma_push_get(MT_INT,nbf,'rev basis map',
     $                      l_rbfmap, k_rbfmap)
     $       .and. status

       if (.not. status) call errquit('moints_trp: map memory?',0,
     &       MA_ERR)

       call moints_shorder( basis, nsh, nbf, blen, ngrp,
     $                      int_mb(k_glo), int_mb(k_ghi),
     $                      int_mb(k_shmap),
     $                      int_mb(k_bfmap), int_mb(k_rbfmap) )
c
c  Copy of MO coefficients with reordered rows
c
       status = ma_push_get(MT_DBL,(nbf*nbf),'reorder mos',
     $                      l_xmo, k_xmo)

       call row_exch( nbf, nbf, int_mb(k_rbfmap), cmo,
     $                       dbl_mb(k_xmo) )
c
c  Temporary partially-transformed arrays
c     
       bsize = max(blen,maxbfsh)
       n_ssbb = maxbfsh*maxbfsh*bsize*bsize
*       n_ssbb1 = max((nmo1*nmo1),n_ssbb)
       n_hlp = max((bsize*maxbfsh*maxbfsh*nmo1),(maxbfsh*nbf))
       n_hlp2 = maxbfsh*maxbfsh*nmo2
       n_hlp3 = maxbfsh*maxbfsh
       n_ssni = maxbfsh*maxbfsh*nbf*nmo1
       status = ma_push_get(MT_DBL,n_ssni,'ssni block',l_ssni,k_ssni)
       if (.not.(status)) call errquit('cannot allocate local memory',0,
     &       MA_ERR)
c
c Initialize
c
       if (oexch) call ga_zero(g_exch)
       if (ocoul) call ga_zero(g_coul)

       call ga_sync

       ploop = 0
       next = nxtask(num_nodes, 1)
c
c  4-fold shell loop
c
       do ish0=1,nsh
         do jsh0=1,ish0
           ish = max(int_mb(k_shmap+ish0-1),int_mb(k_shmap+jsh0-1))
           jsh = min(int_mb(k_shmap+ish0-1),int_mb(k_shmap+jsh0-1))
           status = bas_cn2bfr(basis,ish,ibflo,ibfhi)
           status = bas_cn2bfr(basis,jsh,jbflo,jbfhi)
           ilen = ibfhi - ibflo + 1
           jlen = jbfhi - jbflo + 1
           schw_ij = schwarz_shell(ish,jsh)
           scale = 1.d0
           if (ish.eq.jsh) scale = scale*half
           odoit = schw_ij*schwarz_max().ge.tol2e
           if (odoit .and. osym) then
              odoit = sym_shell_pair(basis, ish, jsh, q2)
           endif
           if (odoit) then
             if (next.eq.ploop) then
               n_ijni = ilen*jlen*nbf*nmo1
               call dfill(n_ijni,0.d0,dbl_mb(k_ssni),1)

               if (.not. ma_push_get(MT_DBL,n_ssbb,'ssbb block',
     $              l_ssbb,k_ssbb)) call errquit
     $              ('moints_trp: failed to alloc ssbb',n_ssbb,
     &       MA_ERR)

               do kgr=1,ngrp
                 kshlo = int_mb(k_glo+kgr-1)
                 kshhi = int_mb(k_ghi+kgr-1)
                 st = bas_cn2bfr(basis,int_mb(k_shmap+kshlo-1),iz,kz)
                 st = bas_cn2bfr(basis,int_mb(k_shmap+kshhi-1),kz,jz)
                 kbflo = int_mb(k_rbfmap+iz-1)
                 kbfhi = int_mb(k_rbfmap+jz-1)
                 kblen = kbfhi - kbflo + 1
                 do lgr=1,kgr
                   lshlo = int_mb(k_glo+lgr-1)
                   lshhi = int_mb(k_ghi+lgr-1)
                   st = bas_cn2bfr(basis,int_mb(k_shmap+lshlo-1),iz,kz)
                   st = bas_cn2bfr(basis,int_mb(k_shmap+lshhi-1),kz,jz)
                   lbflo = int_mb(k_rbfmap+iz-1)
                   lbfhi = int_mb(k_rbfmap+jz-1)
                   lblen = lbfhi - lbflo + 1
                   
                   if (.not. ma_push_get(MT_DBL, max2e,'moints: buf', 
     $                  l_eri, k_eri)) call errquit
     $                  ('moints_trp: failed to alloc buf',max2e,
     &       MA_ERR)
                   if (.not. ma_push_get(MT_DBL, mem2, 'moints: scr', 
     $                  l_iscr, k_iscr)) call errquit
     $                  ('moints_trp: failed to alloc scr',mem2, MA_ERR)


                   call moints_gblk( basis, ish, jsh,
     $                               kshlo, kshhi, lshlo, lshhi,
     $                               int_mb(k_shmap),int_mb(k_rbfmap),
     $                               schw_ij, tol2e, osym, oblk,
     $                               max2e, dbl_mb(k_eri),
     $                               mem2, dbl_mb(k_iscr),
     $                               ibflo, ibfhi, jbflo, jbfhi,
     $                               kbflo, kbfhi, lbflo, lbfhi,
     $                               dbl_mb(k_ssbb) )

                   if (.not. ma_pop_stack(l_iscr))
     $                  call errquit('moints: failed to pop', l_iscr,
     &       MA_ERR)
                   if (.not. ma_pop_stack(l_eri))
     $                  call errquit('moints: failed to pop', l_eri,
     &       MA_ERR)


                   if (.not. ma_push_get(MT_DBL,n_hlp,'hlp block',
     $                  l_hlp,k_hlp)) call errquit
     $                  ('moints_trp: failed to alloc hlp',n_hlp,
     &       MA_ERR)

                   if (lgr.ne.kgr) then

                      if (.not. ma_push_get(MT_DBL,n_ssbb,'ssbbt block',
     $                     l_ssbbt,k_ssbbt)) call errquit
     $                     ('moints: failed ssbbt', n_ssbb, MA_ERR)

                     call moints_blktr( ilen, jlen, kblen, lblen,
     $                                  dbl_mb(k_ssbb),
     $                                  dbl_mb(k_ssbbt))

                     call moints_trf1( nbf, 1, nbf, mo1_lo, mo1_hi,
     $                                 ilen, jlen, kbflo, kbfhi,
     $                                 lbflo, lbfhi, 1.d0,
     $                                 dbl_mb(k_ssbb),
     $                                 dbl_mb(k_ssbbt), dbl_mb(k_xmo),
     $                                 dbl_mb(k_ssni), dbl_mb(k_hlp) )

                     if (.not. ma_pop_stack(l_ssbbt))
     $                    call errquit('moints: failed to pop', l_ssbbt,
     &       MA_ERR)

                   else
                     call moints_trf1( nbf, 1, nbf, mo1_lo, mo1_hi,
     $                                 ilen, jlen, kbflo, kbfhi,
     $                                 lbflo, lbfhi, half,
     $                                 dbl_mb(k_ssbb),
     $                                 dbl_mb(k_ssbb), dbl_mb(k_xmo),
     $                                 dbl_mb(k_ssni), dbl_mb(k_hlp) )
                   endif

                   if (.not. ma_pop_stack(l_hlp))
     $                  call errquit('moints: failed to pop', l_hlp,
     &       MA_ERR)

                 enddo
               enddo

               if (.not. ma_pop_stack(l_ssbb))
     $              call errquit('moints: failed to pop', l_ssbb,
     &       MA_ERR)

               if (.not. ma_push_get(MT_DBL,n_hlp,'hlp block',
     $              l_hlp,k_hlp)) call errquit
     $              ('moints_trp: failed to alloc hlp',n_hlp,
     &       MA_ERR)

               if (oexch) then

                  if (.not. ma_push_get(MT_DBL,n_hlp2,'hlp2 block',
     $                 l_hlp2,k_hlp2)) call errquit
     $                 ('moints_trp: failed to alloc hlp2',n_hlp2,
     &       MA_ERR)

                 call mo_trp_trf23K( nbf, occ_start,
     $                               mo1_lo, mo1_hi, nmo2,
     $                               mo2_lo, mo2_hi, ibflo, ibfhi,
     $                               jbflo, jbfhi, scale,
     $                               dbl_mb(k_ssni),dbl_mb(k_hlp2),
     $                               dbl_mb(k_hlp), dbl_mb(k_hlp),
     $                               dbl_mb(k_xmo), cmo, 
     $                               g_exch, ncor, nocc)

                 if (.not. ma_pop_stack(l_hlp2))
     $                call errquit('moints: failed to pop', l_hlp2,
     &       MA_ERR)

               endif
               if (ocoul) then

                  if (.not. ma_push_get(MT_DBL,n_hlp3,'hlp3 block',
     $                 l_hlp3,k_hlp3)) call errquit
     $                 ('moints_trp: failed to alloc hlp2',n_hlp3,
     &       MA_ERR)

                 call mo_trp_trf2J( nbf, occ_start, mo1_lo, mo1_hi,
     $                              ibflo, ibfhi, jbflo, jbfhi,
     $                              dbl_mb(k_ssni),
     $                              dbl_mb(k_hlp3), dbl_mb(k_xmo),
     $                              g_coul, ncor, nocc)

                 if (.not. ma_pop_stack(l_hlp3))
     $                call errquit('moints: failed to pop', l_hlp3,
     &       MA_ERR)

               endif
               if (.not. ma_pop_stack(l_hlp))
     $              call errquit('moints: failed to pop', l_hlp,
     &       MA_ERR)
               next = nxtask(num_nodes, 1)
             endif
             ploop = ploop + 1
           endif
         enddo
       enddo
       next = nxtask(-num_nodes, 1)
c
c Clean-up
c
       if (.not. ma_chop_stack(l_shmap))
     $     call errquit('moints: failed to pop', l_shmap, MA_ERR)
c
       status = ma_push_get(MT_DBL,(nbf*nbf),'hlp',l_hlp,k_hlp)
       if (oexch) then
           call mo_trp_Ktrf4( g_exch, occ_start, mo1_lo, mo1_hi,
     $                        mo2_lo, mo2_hi, nbf, cmo,
     $                        dbl_mb(k_hlp), ncor, nocc,
     $                        osym, int_mb(k_sym) )
       endif
       if (ocoul) then
         call mo_trp_Jtrf34( g_coul, occ_start, mo1_lo, mo1_hi,
     $                       mo2_lo, mo2_hi, nbf, cmo,
     $                       dbl_mb(k_hlp), ncor, nocc, nvir,
     $                       osym, int_mb(k_sym) )
       endif

       call ga_sync

*       d1 = ga_ddot(g_coul,g_coul)
*       d2 = ga_ddot(g_exch,g_exch)
*       if (ga_nodeid() .eq. 0) then
*	   write(6,*) ' GACOUL1 ', d1
*	   write(6,*) ' GAEXCH1 ', d2
*       endif
c
c  Clean up
c
       if (.not. ma_pop_stack(l_hlp))
     $     call errquit('moints: failed to pop', l_hlp, MA_ERR)
       if (osym) then
          if (.not. ma_pop_stack(l_sym))
     $         call errquit('moints_trp: memory corrupt',0, MA_ERR)
       endif
c
c
c
#ifdef NOCOMMS
       if (ga_nodeid().eq.0) write(6,334)
 334   format(/,10x,'**** COMMUNICATION DISABLED ****')
#endif
c
       return
       end





       subroutine mo_trp_trf23K( nbf, ostart, olo, ohi, nvir,
     $                           vlo, vhi, ilo, ihi, jlo, jhi,
     $                           scale, ssni, ssv, h1, h2, xc, c,
     $                           g_exch, ncor, nocc )
       implicit none
#include "global.fh"
       integer nbf, ostart, ohi, olo, nvir, vlo, vhi
       integer ilo, ihi, jlo, jhi
       double precision scale
       double precision ssni(nbf,jlo:jhi,ilo:ihi,olo:ohi)
       double precision ssv(nvir,jlo:jhi,ilo:ihi)
       double precision h1(nvir,ilo:ihi), h2(nvir,jlo:jhi)
       double precision xc(nbf,nbf), c(nbf,nbf)
       integer g_exch,ncor,nocc

c
       integer aoff,nni,nnj,ab,ivlo,ivhi,jvlo,jvhi,ofroz
       integer ssij,ain,olb
       integer a,b,i,j,v
       double precision cc
c
       ofroz = ostart - 1
       ssij = (ihi - ilo + 1)*(jhi - jlo + 1)
       nni = (ihi - ilo + 1)*nvir
       ivlo = (ilo-1)*nvir + 1
       ivhi = ihi*nvir
       aoff = ((olo-ofroz)*(olo-ofroz-1))/2
       nnj = (jhi - jlo + 1)*nvir
       jvlo = (jlo-1)*nvir + 1
       jvhi = jhi*nvir

cedo       do a=olo,ohi
cstaggering to avoid congestion in ga-acc
       olb=ohi-olo+1
       do ain=ga_nodeid()+1,ga_nodeid()+olb
          a=mod(ain,olb)+olo
         call dgemm('t', 'n', nvir, ssij, nbf, 1.d0,
     $               xc(1,vlo), nbf, ssni(1,jlo,ilo,a),
     $               nbf, 0.d0, ssv, nvir )
         do b=ostart,ostart+nocc-1
           call dfill(nni,0.d0,h1,1)
           do j=jlo,jhi
             cc = c(j,b)
             do i=ilo,ihi
               do v=1,nvir
                 h1(v,i) = h1(v,i) + scale*cc*ssv(v,j,i)
               enddo
             enddo
           enddo
#ifndef NOCOMMS
           ab = (a-olo)*nocc+b-ostart+1
           call ga_acc(g_exch,ivlo,ivhi,ab,ab,h1,nni,1.d0)
#endif
         enddo
         do b=ostart,ostart+nocc-1
           call dfill(nnj,0.d0,h2,1)
           do i=ilo,ihi
            cc = c(i,b)
            do j=jlo,jhi
              do v=1,nvir
                h2(v,j) = h2(v,j) + scale*cc*ssv(v,j,i)
              enddo
            enddo
          enddo
#ifndef NOCOMMS
          ab = (a-olo)*nocc+b-ostart+1
          call ga_acc(g_exch,jvlo,jvhi,ab,ab,h2,nnj,1.d0)
#endif
         enddo
       enddo
c
c
       return
       end
      subroutine mo_trp_Ktrf4( g_exch, ostart, olo, ohi,
     $                         vlo, vhi, nbf, c, tmp ,ncor, nocc,
     $                         osym, syms )
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      integer g_exch
      integer nbf, ostart, olo, ohi, vlo, vhi,ncor,nocc
      double precision c(nbf,nbf)
      double precision tmp(nbf,nbf)
      logical osym
      integer syms(*)
      integer nvir, clo, chi, rlo, rhi, my_id
      integer ofroz, a1, a2, aa1, aa, aoff, k_local, ld
#ifdef BAD_GACCESS
      integer l_local
#endif

      ofroz = ostart - 1
      nvir = vhi - vlo + 1
      call ga_sync
      my_id = ga_nodeid()
      call ga_distribution(g_exch, my_id, rlo, rhi, clo, chi )
      aoff = ((olo-ofroz)*(olo-ofroz-1))/2
      do a1=olo,ohi
        aa1 = a1 - ofroz
        do a2=ostart,ostart+nocc-1
          aa = (a1-olo)*nocc+a2-ostart+1
          if ((aa.ge.clo).and.(aa.le.chi)) then
#ifdef BAD_GACCESS
             ld=rhi-rlo+1
             if(.not.ma_push_get(MT_DBL,ld,
     $            'scratch buff2x', l_local, k_local)) call
     $            errquit('moints2x: pushget failed',0,0)
             call ga_get(g_exch,rlo,rhi,aa,aa,dbl_mb(k_local),ld)
#else 
            call ga_access(g_exch,rlo,rhi,aa,aa,k_local,ld)
#endif
            call moints2xv_Ktrf4a( vlo, vhi, nbf, c,
     $                            dbl_mb(k_local), tmp )
            if (osym) call moints_sym_zero( nbf, vlo, vhi, syms,
     $                                      a1, a2, tmp)
            call dcopy((nvir*nvir),tmp,1,dbl_mb(k_local),1)
#ifdef BAD_GACCESS
            call ga_put(g_exch,rlo,rhi,aa,aa,dbl_mb(k_local),ld)
            if(.not.ma_pop_stack(l_local)) call 
     $           errquit('moints2x: popstack failed',0,0)
#else 
            call ga_release(g_exch,rlo,rhi,aa,aa)
#endif
          endif
        enddo
      enddo
      call ga_sync
      return
      end
      subroutine mo_trp_trf2J( nbf, ostart, olo, ohi, ilo, ihi,
     $     jlo, jhi, ssni, h2, c, g_coul,
     &     ncor, nocc )
      implicit none
#include "global.fh"
      integer nbf, ostart, olo, ohi, ilo, ihi, jlo, jhi
      double precision ssni(nbf,jlo:jhi,ilo:ihi,olo:ohi)
      double precision h1(21)   ! cartesian H shell 
      double precision h2(jlo:jhi,ilo:ihi)
      double precision c(nbf,nbf)
      integer g_coul,ncor,nocc
      integer ain,olb
c     
      double precision tmp
      integer nni, ijlo, ijhi, ilen, jlen, ijlen
      integer ab, a, b, i, j, aoff, ofroz, u
c     
c     
      ofroz = ostart - 1
      aoff = ((olo-ofroz)*(olo-ofroz-1))/2
      ilen = ihi - ilo + 1
      jlen = jhi - jlo + 1
      nni = ilen*nbf
      ijlen = ilen*jlen
cedo      do a=olo,ohi
cstaggering
       olb=ohi-olo+1
       do ain=ga_nodeid()+1,ga_nodeid()+olb
          a=mod(ain,olb)+olo
         do b=ostart,ostart+nocc-1
            do i = ilo,ihi
               do j = jlo,jhi
                  tmp = 0.0d0
                  do u = 1,nbf
                     tmp = tmp + ssni(u,j,i,a)*c(u,b)
                  enddo
                  h2(j,i) = tmp
               enddo
            enddo
*            call dgemm('t','n',ijlen,1,nbf,1.d0,ssni(1,jlo,ilo,a),
*     $           nbf,c(1,b),nbf,0.d0,h2,ijlen)
#ifndef NOCOMMS
            ab = (a-olo)*nocc+b-ostart+1
            if(jlo.le.ilo)then
               do i=ilo,ihi
*                  do j=jlo,min(i,jhi)
*                     ijlo = i*(i-1)/2 + j
*                     ijhi = i*(i-1)/2 + j
*                     call ga_acc(g_coul,ijlo,ijhi,ab,ab,h2(j,i),1,1.d0)
*                  enddo
                  ijlo = i*(i-1)/2 + jlo
                  ijhi = i*(i-1)/2 + min(i,jhi)
                  if (ijhi .ge. ijlo) call ga_acc(g_coul, ijlo, ijhi,
     $                 ab, ab, h2(jlo,i), 1, 1.d0)
               enddo
            else
               do j=jlo,jhi
*     do i=ilo,min(j,ihi)
*     ijlo = j*(j-1)/2 + i
*     ijhi = j*(j-1)/2 + i
*     call ga_acc(g_coul,ijlo,ijhi,ab,ab,h2(j,i),1,1.d0)
*     enddo
                  ijlo = j*(j-1)/2 + ilo
                  ijhi = j*(j-1)/2 + min(j,ihi)
                  if (ijhi .ge. ijlo)  then
                     do i = ilo,min(j,ihi)
                        h1(i-ilo+1) = h2(j,i)
                     enddo
                     call ga_acc(g_coul, ijlo, ijhi, ab, ab, 
     $                    h1,1,1.d0)
                  endif
               enddo
            endif
#endif
         enddo
      enddo
      return
      end
      subroutine mo_trp_Jtrf34( g_coul, ostart, olo, ohi, vlo, vhi,
     $                          nbf, c, tmp, ncor, nocc, nvir,
     $                          osym, syms )
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      integer g_coul
      integer ostart, olo, ohi, vlo, vhi, nbf, ncor, nocc, nvir
      double precision c(nbf,nbf)
      double precision tmp(nbf,nbf)
      logical osym
      integer syms(*)

      integer clo, chi, rlo, rhi, my_id
      integer ofroz, aoff, a1, a2, aa, k_local, ld
#ifdef BAD_GACCESS
      integer l_local
#endif

      call ga_sync

      ofroz = ostart - 1
      aoff = ((olo-ofroz)*(olo-ofroz-1))/2
      my_id = ga_nodeid()
      call ga_distribution(g_coul, my_id, rlo, rhi, clo, chi )
      do a1=olo,ohi
        do a2=ostart,ostart+nocc-1
          aa = (a1-olo)*nocc+a2-ostart+1
          if ((aa.ge.clo).and.(aa.le.chi)) then
#ifdef BAD_GACCESS
             ld=rhi-rlo+1
             if(.not.ma_push_get(MT_DBL,ld,
     $            'scratch buff2x', l_local, k_local)) call
     $            errquit('moints2x: pushget failed',0,0)
             call ga_get(g_coul,rlo,rhi,aa,aa,dbl_mb(k_local),ld)
#else
            call ga_access(g_coul,rlo,rhi,aa,aa,k_local,ld)
#endif
            call mo_trp_Jtrf34a( nbf, c, dbl_mb(k_local), tmp, 
     &                           ncor,nocc,nvir)
            if (osym) call moints_sym_zero(nbf, vlo, vhi, syms, a1, a2,
     $                                     dbl_mb(k_local))
#ifdef BAD_GACCESS
            call ga_put(g_coul,rlo,rhi,aa,aa,dbl_mb(k_local),ld)
            if(.not.ma_pop_stack(l_local)) call 
     $           errquit('moints2x: popstack failed',0,0)
#else 
            call ga_release(g_coul,rlo,rhi,aa,aa)
#endif
          endif
        enddo
      enddo
      call ga_sync
      return
      end
      subroutine mo_trp_Jtrf34a( nbf, c, x, tmp, ncor, nocc, nvir)
      implicit none
      integer nbf,ncor,nocc,nvir
      double precision c(nbf,nbf)
      double precision x(nbf*nbf)
      double precision tmp(nbf,nbf)

      integer i, j, icnt

      icnt=0
      do i=1,nbf
        do j=1,i
          icnt=icnt+1
          tmp(j,i) = x(icnt)
          tmp(i,j) = x(icnt)
CRK       write(6,*)'tmp',tmp(i,j)
        enddo
      enddo

      call dgemm('t','n',nvir,nbf,nbf,1.d0,c(1,ncor+nocc+1),nbf,tmp,nbf,
     $           0.d0,x,nvir)
      call dgemm('n','n',nvir,nvir,nbf,1.d0,x,nvir,c(1,ncor+nocc+1),nbf,
     $           0.d0,tmp,nvir)

      call dcopy(nvir*nvir,tmp,1,x,1)

      return
      end

C$Id: data_analysis5.F 19708 2010-10-29 18:04:21Z d3y133 $
      Program Data_Analysis5

      implicit none

      integer nob
      parameter (nob = 100)
      double precision PI, kb, temp  
      integer i, j, z
      double precision sumx
      double precision mtot
      double precision flux(nob), sumerr(nob)
      double precision flux2(nob), sumerr2(nob) 
      double precision NDA(nob), ERR(nob)
      double precision RB(nob), ERRX
      double precision rflux(nob)
      double precision ratec(nob),errrate
      integer nc
      character*256 text
      logical EOF
      double precision intpress, intdens, press
      logical rconfig

C Input Parameters
      PI = 3.141592653589793D+00 ! Constant PI
      kb = 1.987905D-03 ! Constant Boltzmann kcal/mole/K 
      temp = 243.D+00 ! Temperature used in original data 
      mtot = 18.02D+00 ! Mass of monomers
      press = 1.7D-05 
      rconfig = .true. ! Method selection

C Get some input
      WRITE(*,*)'Input parameters'
      WRITE(*,*)'rconfig and temp'
      READ(*,*)rconfig, temp
      WRITE(*,"(A10, A10, A10, A20, A20,
     &          A20, A20)")
     &'N. Conf.','Rcut','Rcut Err.','Ev.Rate','Ev.Rate Err.','Int.Press'
     &,'Density'
      WRITE(*,"(A10, A10, A10, A20, A20,
     &          A20, A20)")
     &' ','(Ang)','(Ang)','(s^-1)','(s^-1)','(atm)'
     &,'(mol/ml)'



C Open Input File
      OPEN(UNIT = 20,FILE = 'data_analysis.inp' 
     +    ,STATUS = 'OLD')

      EOF = .false.
 1234 CONTINUE ! beginning of while loop

C Read Data
      READ(20,*,END=5678)nc
      Do i = 1, nob
        READ(20,*,END=5678)RB(i), NDA(i), ERR(i)
      END DO
      READ(20,*,END=5678)text

      if (rconfig) then
C Calculate Flux
        flux(1) = NDA(1)
        Do i=2, NOB
          flux(i) = NDA(i) + flux(i-1)
        End Do ! CPF in flux
        Do i =1, NOB
          flux2(i) = NDA(i)
        ENDDO ! Derivative CPF in flux2
        sumerr(1) = ERR(1) * ERR(1)
        Do i = 2, NOB
          sumerr(i) = (ERR(i)*ERR(i)) + sumerr(i-1)
        END DO
        Do i = 1, NOB
          sumerr(i) = DSQRT(sumerr(i))
        End DO !Error in CPF in sumerr
        DO i = 1, NOB
          sumerr2(i) = ERR(i)
        ENDDO !Error in Derivative CPF in sumerr2
      else
        Do i = 1, NOB
          flux(i) = NDA(i)/(4.D+00*PI*(RB(i)**2.D+00))
          flux(i) = flux(i)*DEXP((4.D+00/3.D+00*PI*(RB(i)**3.D+00)*press
     &              )/kb/temp)
        ENDDO ! CPF in flux
        Do i = 1, NOB
          if ((i .eq. 1).or.(i .eq. NOB)) then
            flux2(i) = 0.00D+00
          else
            flux2(i) = (flux(i+1) - flux(i-1))/2.00D+00
          endif
        ENDDO ! Derivative CPF in flux2
        Do i = 1, NOB
          sumerr(i) = ERR(i)/(4.D+00*PI*(RB(i)**2.D+00))
          sumerr(i) = sumerr(i)*DEXP((4.D+00/3.D+00*PI*(RB(i)**3.D+00)
     &                *press)/kb/temp)
        ENDDO !Error in CPF in sumerr
        DO i = 1, NOB
          if ((i .eq. 1).or.(i .eq. NOB)) then
            sumerr2(i) = 0.00D+00
          else
            sumerr2(i) = (sumerr(i+1)*sumerr(i+1))
     &                  +(sumerr(i-1)*sumerr(i-1))
            sumerr2(i) = DSQRT(sumerr2(i))/2.00D+00
          endif
        ENDDO !Error in Derivative CPF in sumerr2
      endif

C Calculate Error
      ERRX = 0.00D+00
      Do i=1, NOB - 1
        ERRX = ERRX + RB(i+1) - RB(i)
      End Do
      ERRX = ERRX/DBLE(NOB - 1) ! Error related to bin interval
C Reactive Flux
      Do i=1, NOB
        rflux(i) = flux2(i)*kb*temp/ERRX
      enddo ! Reactive flux in rflux
C Rate Constants
      Do i=1, NOB
        if(flux(i) .eq. 0.D+00) then
        ratec(i) = 1.D+99
        else
        ratec(i) = 1.D+00*rflux(i)/flux(i)*1.D+13/
     &  DSQRT(2.D+00*PI*kb*temp*mtot/4.184D+00)
        endif
      Enddo ! Rate Constants in ratec

C Find Maximum Flux
      sumx = rflux(1)
      j = 1
      Do i = 2, NOB
        IF (rflux(i) .gt. sumx) then
          sumx = rflux(i)
          j = i
        EndIf
      EndDo
      if (j .eq. NOB) j = NOB -1
      if (j .eq. 1) j = 2
      z = j

C Find Minimum Flux
      j = z
      if (j .gt. NOB/2) then

      DO i = z , 2, -1 
        IF ( (rflux(i) .lt. rflux(i-1)) .and.
     &       (rflux(i) .le. rflux(i+1)) .and.
     &       (rflux(i) .lt. sumx)       .and.
     &       (rflux(i+1) .gt. 0.00D+00) ) then
          sumx = rflux(i)
          j = i
        endif
      End Do

      else 

      DO i = z , NOB -1
        IF ( (rflux(i) .lt. rflux(i-1)) .and.
     &       (rflux(i) .le. rflux(i+1)) .and.
     &       (rflux(i) .lt. sumx)       .and.
     &       (rflux(i+1) .gt. 0.00D+00) ) then
          sumx = rflux(i)
          j = i
        endif
      End Do

      endif

C Minimum flux index in j

      errrate = ratec(j)*DSQRT((sumerr(j)/flux(j))**2.D+00 
     &          + (flux2(j)/sumerr2(j))**2.D+00)
      intpress = rflux(j)/flux(j)/4/PI/(RB(j)**2.00D+00)
      intpress = intpress*kb*temp
      intpress = intpress*4.184*1.00D+30/1.01325D+02/6.022142D+23
      intdens = 4.00D+00/3.00D+00*PI*(RB(j)**3.00D+00)
      intdens = 1.00D+00/intdens*1.00D+24/6.022142D+23

      WRITE(*,"(I10, F10.5, F10.5, ES20.10E3, ES20.10E3, 
     &          ES20.10E3, ES20.10E3)")
     & nc, RB(j), ERRX, ratec(j), errrate, intpress, intdens
    
      goto 9098 ! skip EOF
 5678 EOF = .true.
 9098 CONTINUE ! skipped EOF
      if (.not. EOF) goto 1234 ! begin while loop again
C End of while Loop
C close file
      close(20)

      end

      Subroutine hferi(Ep,Eq,R0,IJK,ERI,E3,sum,MPP,MPQ,
     &                 NPP,NPQ,Nint,La,Lb,Lc,Ld,Lr,MXD,
     &                 canAB,canCD,canPQ)
c $Id: hferi.F 19696 2010-10-29 16:53:42Z d3y133 $

      Implicit none
#include "sh_order.fh"
      integer mpp,mpq,npp,npq,nint
      integer la,lb,lc,ld,lr,mxd
      integer ld2,lqmax,lqmax3
      integer iq,jq,nn,ia,ja,ka,mb_limit
      integer ij,mb,ib,jb,kb,ip,jp,kp,mp,ir,jr,lq,nq
      integer kr,nr,mq,mc,ic,jc,kc,md_limit,kl,md,id,jd,kd
      integer lb2,lc2,kq,ma,nc,la6,lb6,lc6,ld6
      integer nq1,iq1,iqfin,iqlast
      Logical canAB,canCD,canPQ

c--> Hermite Linear Expansion Coefficients

      Double precision Ep(3,NPP,0:MXD,0:(La+Lb),0:La,0:Lb)
      Double precision Eq(3,NPQ,0:MXD,0:(Lc+Ld),0:Lc,0:Ld)

c--> Auxiliary Function Integrals & Index

      Double precision R0(MPQ,MPP,*)
      Integer IJK(0:Lr,0:Lr,0:Lr)

c--> ERI

      Double precision ERI(Nint)

c--> Scratch Space

      Double precision E3(*),sum(MPQ,*),erinn,zot,
     ,     zot1,zot2
      Integer Nxyz(3),nqmx
c
c Compute electron repulsion integrals (ERI).
c
c     Formula:
c
c               __
c               \     Ic,Id;n10   Jc,Jd;n11   Kc,Kd;n12
c     ERI  =    /   Ex          Ey          Ez          SUM
c               --    Iq          Jq          Kq           Iq,Jq,Kq
c            Iq,Jq,Kq
c
c                            __
c                           \     Lq   Ia,Ib;n7   Ja,Jb;n8   Ka,Kb;n9
c         SUM          =    /  (-1)  Ex         Ey         Ez         R
c            Iq,Jq,Kq       --         Ip         Jp         Kp        Ir,Jr,Kr
c                        Ip,Jp,Kp
c
c                                Ir = (Ip+n1) + (Iq+n4)
c                        where   Jr = (Jp+n2) + (Jq+n5)
c                                Kr = (Kp+n3) + (Kq+n6)
c
c                         and    Lq = (Iq+n4) + (Jq+n5) + (Kq+n6)
c
c N.B.  For simple ERI (i.e., no derivative integrals)  n[1-12] = 0!
c
c******************************************************************************
*rak:      integer num_pg, num_tot, num_qg
*rak:      save num_pg, num_tot, num_qg
*rak:      data num_pg /0/
*rak:      data num_qg /0/
*rak:      data num_tot /0/
*rak:
*rak:      if(MPP.ge.MPQ) then
*rak:        num_pg = num_pg + 1
*rak:      else
*rak:        num_qg = num_qg + 1
*rak:      endif
*rak:      num_tot = num_tot + 1
*rak:      if (num_tot.lt.3200.or.mod(num_tot,1000).eq.0) then
*rak:        write(6,*)' num_pg  ',num_pg
*rak:        write(6,*)' num_qg  ',num_qg
*rak:        write(6,*)' num_tot ',num_tot
*rak:      endif
c
c General case:  [ab|cd]

c Define the number of shell components on each center.

      Lb2 = ((Lb+1)*(Lb+2))/2
      Lc2 = ((Lc+1)*(Lc+2))/2
      Ld2 = ((Ld+1)*(Ld+2))/2
      la6=(la*(la+1)*(la+2))/6
      lb6=(lb*(lb+1)*(lb+2))/6
      lc6=(lc*(lc+1)*(lc+2))/6
      ld6=(ld*(ld+1)*(ld+2))/6
      md_limit = Ld2
       
c Initialize the block of ERIs.

      Lqmax  = Lc + Ld
      Lqmax3 = ((Lqmax+1)*(Lqmax+2)*(Lqmax+3))/6

c Loop over the components of the "A" and "B" shells.
      nqmx=0
      do Iq = 0,Lqmax
         do Jq = 0,Lqmax-Iq
            do Kq = 0,Lqmax-Iq-Jq
               nqmx = max(IJK(Iq,Jq,Kq),nqmx)
            enddo
         enddo
      enddo
      nn = 0
      do ma = 1,((La+1)*(La+2))/2

       nc =  la6 + ma
       ia = Ixyz(1,nc)
       ja = Ixyz(2,nc)
       ka = Ixyz(3,nc)
         

        if( canAB )then
           mb_limit = ma
           ij = (ma*(ma-1))/2 
        else
           mb_limit = Lb2
           ij = (ma-1)*Lb2 
        end if

        do mb = 1,mb_limit
           ij=ij+1


       nc =  lb6 + mb
       ib = Ixyz(1,nc)
       jb = Ixyz(2,nc)
       kb = Ixyz(3,nc)

c Sum across (Ip,Jp,Kp) for each value of (Iq,Jq,Kq).
          call dcopy(mpq*nqmx,0d0,0,sum,1)

          do Ip = 0,Ia+Ib
             do Jp = 0,Ja+Jb
                do Kp = 0,Ka+Kb
                   if(MPP.eq.1) then
                      E3(1) = Ep(1,1,0,Ip,Ia,Ib)*
     &                     Ep(2,1,0,Jp,Ja,Jb)*
     &                     Ep(3,1,0,Kp,Ka,Kb)
                   else
                      
c Define the product of the Hermite expansions coefficients for 
c overlap distribution "P".
                      do mp = 1,MPP
                         E3(mp) = Ep(1,mp,0,Ip,Ia,Ib)*
     &                        Ep(2,mp,0,Jp,Ja,Jb)*
     &                        Ep(3,mp,0,Kp,Ka,Kb)
                      end do
                   endif

                do Iq = 0,Lqmax
                   Ir = Ip + Iq
                  do Jq = 0,Lqmax-Iq
                     Jr = Jp + Jq
                      Lq = Iq + Jq -1
                    do Kq = 0,Lqmax-Iq-Jq
                       
                      nq = IJK(Iq,Jq,Kq)

                      Kr = Kp + Kq

                      nr = IJK(Ir,Jr,Kr)

c Include the factor of (-1)**(Iq+Jq+Kq).
                      Lq=Lq+1
#ifdef GCC4
                      if(IAND(Lq,1).eq.1)then
#else
                      if(AND(Lq,1).eq.1)then
#endif
                        if(MPQ.eq.1) then
                           do mp = 1,MPP
                              sum(1,nq) = sum(1,nq)-E3(mp)*R0(1,mp,nr)
                           end do
                        else
                        do mp = 1,MPP
                           zot=-E3(mp)
                          do mq = 1,MPQ
                            sum(mq,nq) = sum(mq,nq)+zot*R0(mq,mp,nr)
                          end do
                        end do
                        endif
                      else
                        if(MPQ.eq.1) then
                           do mp = 1,MPP
                              sum(1,nq) = sum(1,nq)+E3(mp)*R0(1,mp,nr)
                           end do
                        else
                        do mp = 1,MPP
                           zot=E3(mp)
                          do mq = 1,MPQ
                            sum(mq,nq) = sum(mq,nq)+zot*R0(mq,mp,nr)
                          end do
                        end do
                        endif
                      end if

                    end do
                  end do
                end do

              end do
            end do
          end do

c Loop over the components of the "C" and "D" shells.

          do mc = 1,Lc2

             nc =  lc6 + mc
             ic = Ixyz(1,nc)
             jc = Ixyz(2,nc)
             kc = Ixyz(3,nc)

            if( canCD ) md_limit = mc


            if( canAB )then
               kl = (mc*(mc-1))/2 
            else
               kl = (mc-1)*Ld2 
            end if
            do md = 1,md_limit

              if( canPQ )then
                 kl=kl+1
                 if( kl.gt.ij ) go to 480
              end if

             nc =  ld6 + md
             id = Ixyz(1,nc)
             jd = Ixyz(2,nc)
             kd = Ixyz(3,nc)

              nn = nn + 1

c Sum across (Iq,Jq,Kq).
c Define the product of the Hermite expansion coefficients for 
c overlap distribution "Q" and calculate eri
              erinn=0d0
                
              if(MPQ.eq.1) then
                 do Iq = 0,Ic+Id
                    do Jq = 0,Jc+Jd
                       do Kq = 0,Kc+Kd
                          nq = IJK(Iq,Jq,Kq)
                          ERInn = ERInn + 
     &                         Eq(1,1,0,Iq,Ic,Id)*
     &                         Eq(2,1,0,Jq,Jc,Jd)*
     &                         Eq(3,1,0,Kq,Kc,Kd)*sum(1,nq)
                       enddo
                    enddo
                 enddo
              else
                 iqfin=0
                 iqlast=ic+id
                 if(iqlast.gt.0) then
                    iqfin=-1
#ifdef GCC4
                    if(iand(iqlast,1).eq.0) then
#else
                    if(and(iqlast,1).eq.0) then
#endif
                       iqfin=ic+id
                       iqlast=iqlast-2
                    endif
                    do Iq = 0,iqlast,2
                       iq1=iq+1
                       do Jq = 0,Jc+Jd
                          do Kq = 0,Kc+Kd
                             nq = IJK(Iq,Jq,Kq)
                             nq1 = IJK(Iq1,Jq,Kq)
                             do mq = 1,MPQ
                                ERInn = ERInn + 
     &                               (Eq(1,mq,0,Iq,Ic,Id)*sum(mq,nq)+
     &                               Eq(1,mq,0,Iq1,Ic,Id)*sum(mq,nq1))*
     &                               Eq(2,mq,0,Jq,Jc,Jd)*
     &                               Eq(3,mq,0,Kq,Kc,Kd)
                             end do
                          end do
                       enddo
                    enddo
                 endif
                 if(iqfin.ne.-1) then
                    do Jq = 0,Jc+Jd
                       do Kq = 0,Kc+Kd
                          nq = IJK(Iqfin,Jq,Kq)
                          do mq = 1,MPQ
                             ERInn = ERInn + 
     &                            Eq(1,mq,0,Iqfin,Ic,Id)*
     &                            Eq(2,mq,0,Jq,Jc,Jd)*
     &                            Eq(3,mq,0,Kq,Kc,Kd)*sum(mq,nq)
                          end do
                       end do
                    enddo
                 endif
              endif
              eri(nn)=erinn

            end do              ! md
  480       continue
          end do                ! mc
        end do                  ! mb
      end do                    ! ma

      end

      subroutine sym_op_class_name(op_type, order, power, direction,
     $     group_name, class)
C$Id: sym_op_cname.F 21544 2011-11-18 20:08:38Z d3p852 $
      implicit none
#include "inp.fh"
c     
      character*(*) op_type     ! [input]
      integer order, power      ! [input]
      double precision direction(3) ! [input]
      character*(*) group_name  ! [input]
      character*(*) class       ! [output]
c     
      integer abspow
c     
c     Try to assign the class name of an operator given all the other info
c     
c     Powers of rotations in Cn, Cnh and Sn are all in separate classes
c     Also for T and Th
c     
      abspow = abs(power)
      if (group_name(1:1).eq.'S' .or. 
     $     group_name.eq.'T' .or. group_name.eq.'Th' .or.
     $     (group_name(1:1).eq.'C' .and.
     $     (group_name(3:3).eq.'h' .or. inp_strlen(group_name).eq.2)))
     $     then
         if (power .lt. 0) then
            if (op_type.eq.'rotation' .or. mod(order,2).eq.0) then
               abspow = order+power
            else
               abspow = 2*order+power ! Odd improper rotation
            endif
         endif
      endif
c
      class = ' '
      if (op_type .eq. 'identity') then
         class = 'e'
      else if (op_type .eq. 'inversion') then
         if (group_name.eq.'Ci' .or. group_name.eq.'S2') then
            class = 'i=s2'
         else
            class = 'i'
         endif
      else if (op_type .eq. 'rotation') then
         if (order .gt. 2) then
            if (abspow .gt. 1) then
               write(class,'(''c'',i1,''^'',i1)') order, abspow
            else
               write(class,'(''c'',i1)') order
            endif
         else
            class = 'c2'
            if (group_name.eq.'D2' .or. group_name.eq.'D2h') then
               if (abs(direction(3)-1.0d0) .lt. 1.0e-6) then
                  class = 'c2z'
               else if (abs(direction(2)-1.0d0) .lt. 1.0e-6) then
                  class = 'c2y'
               else if (abs(direction(1)-1.0d0) .lt. 1.0e-6) then
                  class = 'c2x'
               endif
            else if (group_name.eq.'D4' .or. group_name.eq.'D4h') then
               if (abs(direction(3)-1.0d0) .lt. 1d-6) then
                  class = 'c2'
               else if ((abs(direction(1)-1.0d0) .lt. 1d-6) .or.
     $                 (abs(direction(2)-1.0d0) .lt. 1d-6)) then
                  class = 'c2'''
               else
                  class = 'c2"'
               endif
            else if (group_name.eq.'D2d' .or. group_name.eq.'D4d' .or. 
     $              group_name.eq.'D6d') then
               if (abs(direction(3)-1.0d0) .gt. 1.0e-6) then
                  class = 'c2'''
               endif
            else if (group_name(1:2).eq.'D6') then
c
c     C2' in plane of sigma.v ... -75, -15, 45 from X
c
               if (abs(direction(3)-1.0d0).lt.1e-3) then
                  class = 'c2'
               else if (
     $                 abs(direction(2)-0.7071).lt.1d-3 .or.
     $                 abs(direction(2)+0.2588).lt.1d-3 .or.
     $                 abs(direction(2)+0.9659).lt.1d-3) then
                  class = 'c2'''
               else
                  class = 'c2"'
               endif
            else if (group_name(1:2).eq.'D8') then
c
c     Added by Kurt on 16 NOV 2011
c
               if (abs(direction(3)-1.0d0).lt.1e-3) then
                  class = 'c2'
               else if (
     $                 abs(direction(1)-0.7071).lt.1d-3 .or.
     $                 abs(direction(1)-1.0000).lt.1d-3 .or.
     $                 abs(direction(2)-1.0000).lt.1d-3) then
                  class = 'c2'''
               else
                  class = 'c2"'
               endif
            else if (group_name(1:1).eq.'O') then
c     
c     C2 normal to x/y/z axes, C2' imbetween
c     
               if (abs(direction(1)-1.0d0).le.1d-3 .or.
     $             abs(direction(2)-1.0d0).le.1d-3 .or.
     $             abs(direction(3)-1.0d0).le.1d-3) then
                  class = 'c2'
               else
                  class = 'c2'''
               endif
            endif
         endif
      else if (op_type .eq. 'improper rotation') then
         if (group_name(1:1) .eq. 'D') then
c
c     Additional mirror planes of Dnh force some ops into the same class
c     whereas for Cnh they are all in different classes.
c
            if (abspow .gt. order) abspow = 2*order - abspow
         endif
         if (abspow .gt. 1) then
            if (order .lt. 10) then
               write(class,'(''s'',i1,''^'',i1)') order, abspow
            else
               write(class,'(''s'',i2,''^'',i1)') order, abspow
            endif
         else
            if (order .lt. 10) then
               write(class,'(''s'',i1)') order
            else
               write(class,'(''s'',i2)') order
            endif
         endif
      else if (op_type .eq. 'mirror') then
         if (group_name.eq.'C2v') then
            if (abs(direction(1)-1.0d0) .lt. 1.0d-6) then
               class = 'si.yz'
            else  if (abs(direction(2)-1.0d0) .lt. 1.0d-6) then
               class = 'si.xz'
            else
               write(6,*)' sym_op_class_name: c2v bad mirror'
            endif
         else if (group_name.eq.'D2h') then
            if (abs(direction(1)-1.0d0) .lt. 1.0d-6) then
               class = 'si.yz'
            else  if (abs(direction(2)-1.0d0) .lt. 1.0d-6) then
               class = 'si.xz'
            else  if (abs(direction(3)-1.0d0) .lt. 1.0d-6) then
               class = 'si.xy'
            else
               write(6,*)' sym_op_class_name: d2h bad mirror'
            endif
         else if (group_name(1:2) .eq. 'Ih') then
            class = 'si'
         else if (group_name(1:1) .eq. 'T' .or.
     $           group_name(3:3) .eq. 'd') then
            class = 'si.d'
         else if (group_name(1:2) .eq. 'Oh') then
c
c     sigmah normal to axes, sigmad between
c
            if (abs(direction(1)-1.0d0).le.1d-3 .or.
     $           abs(direction(2)-1.0d0).le.1d-3 .or.
     $           abs(direction(3)-1.0d0).le.1d-3) then
               class = 'si.h'
            else
               class = 'si.d'
            endif
         else if (abs(direction(3)-1.0d0) .lt. 1.0d-6) then
            class = 'si.h'
         else 
            class = 'si.v'
            if (group_name.eq.'C4v' .or. group_name.eq.'D4h') then
               if (abs(direction(1)-1.0d0).gt.1.0d-6 .and.
     $             abs(direction(2)-1.0d0).gt.1.0d-6) then
                  class = 'si.d'
               endif
            else if (group_name.eq.'C6v' .or. group_name.eq.'D6h') then
c
c     Adopt a convention that Sigma.v normals make angles of -45, 
c     +15 and 75 with the x-axis with the adopted direction convention
c
               if (
     $              abs(direction(2)+0.7071).lt.1d-3 .or.
     $              abs(direction(2)-0.2588).lt.1d-3 .or.
     $              abs(direction(2)-0.9659).lt.1d-3) then
                  class = 'si.v'
               else
                  class = 'si.d'
               endif

            else if (group_name.eq.'C8v' .or. group_name.eq.'D8h') then
c
c    Added by Kurt 16 Nov 2011
c
               if (
     $              abs(direction(1)-0.7071).lt.1d-3 .or.
     $              abs(direction(1)-1.0000).lt.1d-3 .or.
     $              abs(direction(2)-1.0000).lt.1d-3) then
                  class = 'si.d'
               else
                  class = 'si.v'
               endif
            endif
         endif
      else
         write(6,*) ' sym_op_class_name: unknown op type ', op_type
      endif
c
c      print*,op_type, order, power, direction(1:3),group_name,
c     &     class,acos(direction(1))*180/3.1415926535897932384626d0

      end

      SUBROUTINE ccsdtq_lr_alpha_16_15_3(d_a,k_a_offset,d_b,k_b_offset,d
     &_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_16_15_3.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 p13 h14 p11 )_ytrbt + = -1/3 * Sum ( h8 h9 h10 p5 p6 ) * t ( p5 p6 p13 h8 h9 h10 )_t * i3 ( h2 h8 h9 h10 h14 p5 p6 p11 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER h2b
      INTEGER h14b
      INTEGER p11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER h8b
      INTEGER h9b
      INTEGER h10b
      INTEGER p13b_1
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h8b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER h2b_2
      INTEGER h8b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER h14b_2
      INTEGER p11b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p13b = noab+1,noab+nvab
      DO h2b = 1,noab
      DO h14b = 1,noab
      DO p11b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p13b-
     &1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p13b-1) .eq. int_mb(k_spin+
     &h14b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p13b-1),ieor(int_mb
     &(k_sym+h14b-1),int_mb(k_sym+p11b-1)))) .eq. ieor(irrep_y,ieor(irre
     &p_trb,irrep_t))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p13b-1) * int_mb(k_r
     &ange+h14b-1) * int_mb(k_range+p11b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_16_15_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h8b = 1,noab
      DO h9b = h8b,noab
      DO h10b = h9b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &) .eq. int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+p6b-1),ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h9b-1),in
     &t_mb(k_sym+h10b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p13b,p5b,p6b,h8b,h9b,h10b,p13b_1,p5b_1,p6b_1
     &,h8b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_8(h2b,h8b,h9b,h10b,h14b,p11b,p5b,p6b,h2b_2,h8b
     &_2,h9b_2,h10b_2,h14b_2,p11b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+h8b-1) * int_mb(k_range+h9b-1) * int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h14b-1) * int_m
     &b(k_range+p11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_16_15_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_16_15_3',2,MA_ERR)
      IF ((p6b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (p13b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p13b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),3,6,5,4,2,1,1.0d0)
      END IF
      IF ((p5b .le. p13b) .and. (p13b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p6b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),2,6,5,4,3,1,-1.0d0)
      END IF
      IF ((p13b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),1,6,5,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_16_15_3'
     &,3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_16_15_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_16_15_3',5,MA_ERR)
      IF ((h10b .lt. h2b) .and. (h14b .le. p5b) .and. (p6b .le. p11b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h2b_2 - 1 + noab * (h10b_2 - 1 + n
     &oab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p11b-1),8,5,4,3,2,1,7,6,-1.0d0)
      END IF
      IF ((h10b .lt. h2b) .and. (h14b .le. p5b) .and. (p5b .le. p11b) .a
     &nd. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h2b_2 - 1 + noab * (h10b_2 - 1 + n
     &oab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b
     &-1),int_mb(k_range+p6b-1),7,5,4,3,2,1,8,6,1.0d0)
      END IF
      IF ((h10b .lt. h2b) .and. (p11b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h2b_2 - 1 + noab * (h10b_2 - 1 + n
     &oab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b
     &-1),int_mb(k_range+p6b-1),6,5,4,3,2,1,8,7,-1.0d0)
      END IF
      IF ((h9b .lt. h2b) .and. (h2b .le. h10b) .and. (h14b .le. p5b) .an
     &d. (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h2b_2 - 1 + n
     &oab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h2b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p11b-1),8,5,3,4,2,1,7,6,1.0d0)
      END IF
      IF ((h9b .lt. h2b) .and. (h2b .le. h10b) .and. (h14b .le. p5b) .an
     &d. (p5b .le. p11b) .and. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h2b_2 - 1 + n
     &oab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h2b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b
     &-1),int_mb(k_range+p6b-1),7,5,3,4,2,1,8,6,-1.0d0)
      END IF
      IF ((h9b .lt. h2b) .and. (h2b .le. h10b) .and. (p11b .lt. p5b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h2b_2 - 1 + n
     &oab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h2b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b
     &-1),int_mb(k_range+p6b-1),6,5,3,4,2,1,8,7,1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (h2b .le. h9b) .and. (h14b .le. p5b) .and
     &. (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1 + n
     &oab * (h2b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p11b-1),8,5,2,4,3,1,7,6,-1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (h2b .le. h9b) .and. (h14b .le. p5b) .and
     &. (p5b .le. p11b) .and. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1 + n
     &oab * (h2b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b
     &-1),int_mb(k_range+p6b-1),7,5,2,4,3,1,8,6,1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (h2b .le. h9b) .and. (p11b .lt. p5b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1 + n
     &oab * (h2b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b
     &-1),int_mb(k_range+p6b-1),6,5,2,4,3,1,8,7,-1.0d0)
      END IF
      IF ((h2b .le. h8b) .and. (h14b .le. p5b) .and. (p6b .le. p11b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1 + n
     &oab * (h8b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p11b-1),8,5,1,4,3,2,7,6,1.0d0)
      END IF
      IF ((h2b .le. h8b) .and. (h14b .le. p5b) .and. (p5b .le. p11b) .an
     &d. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1 + n
     &oab * (h8b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b
     &-1),int_mb(k_range+p6b-1),7,5,1,4,3,2,8,6,-1.0d0)
      END IF
      IF ((h2b .le. h8b) .and. (p11b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (h14b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1 + n
     &oab * (h8b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b
     &-1),int_mb(k_range+p6b-1),6,5,1,4,3,2,8,7,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_16_15_3'
     &,6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h8b .eq. h9b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h9b .eq. h10b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,12.0d0/FACTORIAL
     &(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(n
     &subh(2))/FACTORIAL(nsubh(3)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_
     &b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_16_
     &15_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_16_
     &15_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_16_15_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p11b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h2b-1),int_mb(k_range+p13b
     &-1),3,4,2,1,-1.0d0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p11b 
     &- noab - 1 + nvab * (h14b - 1 + noab * (p13b - noab - 1 + nvab * (
     &h2b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_16_15_3'
     &,10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_16_
     &15_3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine hnd_giaspd(gint,gijkl,gnkl,gnm,b00,b01,b10,c00,d00,
     1                      f00,abv,cv,rwv)
c
c $Id: hnd_giaspd.F 20181 2011-04-09 00:43:27Z niri $
c
      implicit none
#include "nwc_const.fh"
#include "mafdecls.fh"
#include "hnd_tol.fh"
#include "hnd_giao.fh"
#include "hnd_pointers.fh"
#include "hnd_rys.fh"
#include "util.fh"
#include "global.fh"
#include "case.fh"
c
      common/testdata/timing(20),irepeat
      double precision timing
      integer irepeat
c
c     Input parameters
c
      double precision gint(*),gijkl(*),gnkl(*),gnm(*)
      double precision b00(*),b01(*),b10(*),c00(*),d00(*),f00(*)
      double precision abv(5,*),cv(12,*),rwv(2,*)
c
c     Local variabels
c
      double precision pi252
      data pi252   /34.986836655250d+00/
      integer nimax,njmax,nkmax,nlmax,nmax,mmax,ng,maxg
      logical last,testy
      integer klg,ijg,numg,i,j,k
      double precision dtol2,q4,dtol
      double precision db,bb,xb,yb,zb,q4db
      double precision da,aa,xa,ya,za,aandb1,q4dbda,dum,rho,xx
      double precision cam2
c
      numi = lit*(lit+1)/2
      numj = ljt*(ljt+1)/2
      numk = lkt*(lkt+1)/2
      numl = lmt*(lmt+1)/2
      nimax=lit+1
      njmax=ljt
      nkmax=lkt+1
      nlmax=lmt
      nmax =lit+ljt
      mmax =lkt+lmt
      nmaxs=nmax.eq.1
      mmaxs=mmax.eq.1
c
c     Doing integrals in subblocks to save memory
c
      maxg=maxxyz/nroots
c
      dtol=1.0d+01**(-itol)
      dtol2=dtol*dtol
      q4=pi252*1.0d0
c
c     ----- pair of k,l primitives -----
c
      ng=0
      do 10 klg = 1, nkl
         db=bcharg( 1,klg)
         bb=bcharg( 2,klg)
         xb=bcharg( 3,klg)
         yb=bcharg( 4,klg)
         zb=bcharg( 5,klg)
         q4db=q4*db
c
c     ----- pair of i,j primitives -----
c
         do 20 ijg = 1, nij
            da=acharg( 1,ijg)
            aa=acharg( 2,ijg)
            aandb1=1.0d0/(aa+bb)
            q4dbda=q4db*da
            dum   =q4dbda*q4dbda*aandb1
            if(dum.le.dtol2) go to 20
            q4dbda=q4dbda* sqrt(aandb1)
            rho   =aa*bb*aandb1
            xa=acharg( 3,ijg)
            ya=acharg( 4,ijg)
            za=acharg( 5,ijg)
c
            xx=rho*((xa-xb)**2+(ya-yb)**2+(za-zb)**2)
            if (doscreen) then
             cam2 = cam_omega*cam_omega
             xx=xx*cam2/(cam2 + rho)
            end if
c
            ng=ng+1
            abv(1,ng)=aa
            abv(2,ng)=bb
            abv(3,ng)=rho
            abv(4,ng)=q4dbda
            abv(5,ng)=xx
c
            if(mmaxs) go to 21
            cv( 1,ng)=aa*(xa-xd)
            cv( 2,ng)=bb*(xb-xd)
            cv( 3,ng)=aa*(ya-yd)
            cv( 4,ng)=bb*(yb-yd)
            cv( 5,ng)=aa*(za-zd)
            cv( 6,ng)=bb*(zb-zd)
   21       if(nmaxs) go to 22
            cv( 7,ng)=aa*(xa-xc)
            cv( 8,ng)=bb*(xb-xc)
            cv( 9,ng)=aa*(ya-yc)
            cv(10,ng)=bb*(yb-yc)
            cv(11,ng)=aa*(za-zc)
            cv(12,ng)=bb*(zb-zc)
   22       continue
c
            last = (klg.eq.nkl).and.(ijg.eq.nij)
            if (ng.lt.maxg.and.(.not.last)) goto 20 
            numg=ng
            ng=0
            if (numg.eq.0) return 
c
c     ----- compute roots and weights for quadrature -----
c
c           timing(3)=timing(3)-util_wallsec()
            call hnd_jkwrys(rwv,abv,numg)
c           timing(3)=timing(3)+util_wallsec()
c
c     ----- compute coefficients for recursion formulae -----
c
c           timing(4)=timing(4)-util_wallsec()
            call hnd_jkbcdf(b00,b01,b10,c00,d00,f00,
     1                      abv,cv,rwv,numg)
c           timing(4)=timing(4)+util_wallsec()
c
c     ----- compute -x- , -y- , -z- integrals ( 2 centers,2-d ) -----
c
c           timing(5)=timing(5)-util_wallsec()
            call hnd_giagnm(gnm,numg*nroots,nmax,mmax,
     1                      b00,b01,b10,c00,d00,f00)
c           timing(5)=timing(5)+util_wallsec()
c
c     ----- compute -x- , -y- , -z- integrals ( 4 centers,2-d ) -----
c
c           timing(6)=timing(6)-util_wallsec()
            call hnd_giaxyz(gijkl,gijkl,gnkl,gnkl,gnkl,gnm,
     1                      numg*nroots,nmax,mmax,nimax,njmax,
     2                      nkmax,nlmax)
c           timing(6)=timing(6)+util_wallsec()
c
c     ----- -giao- specific -----
c
c           timing(7)=timing(7)-util_wallsec()
            call hnd_xyzgia(gijkl,numg*nroots,nimax,njmax,nkmax,nlmax)
c           timing(7)=timing(7)+util_wallsec()
c
c     ----- compute  - (i,j/k,l) -  integrals -----
c
c           timing(8)=timing(8)-util_wallsec()
            call hnd_spdgia(numg,nroots,gint,gijkl)
c           timing(8)=timing(8)+util_wallsec()
c
   20    continue
   10 continue
c
c     ----- ready for -giao- combinations -----
c
c     call hnd_giamak(gint,ijkl)
 
      return
      end

      SUBROUTINE ccsdtq_lambda2_23(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsdtq_lambda2_23.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_vty + = 1/4 * P( 2 ) * Sum ( p18 p13 h15 h17 h16 ) * y ( h3 h15 h16 h17 p1 p2 p13 p18 )_y * i1 ( h4 p13 p18 h15 h16 h17 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h15b
      INTEGER h16b
      INTEGER h17b
      INTEGER p13b
      INTEGER p18b
      INTEGER h3b_1
      INTEGER h15b_1
      INTEGER h16b_1
      INTEGER h17b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER p13b_1
      INTEGER p18b_1
      INTEGER h4b_2
      INTEGER p13b_2
      INTEGER p18b_2
      INTEGER h15b_2
      INTEGER h16b_2
      INTEGER h17b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperh(3)
      INTEGER isuperh
      INTEGER nsubp(2)
      INTEGER isubp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_v,ieor(irrep_t
     &,irrep_y))) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_23',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h15b = 1,noab
      DO h16b = h15b,noab
      DO h17b = h16b,noab
      DO p13b = noab+1,noab+nvab
      DO p18b = p13b,noab+nvab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+h16b-
     &1)+int_mb(k_spin+h17b-1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p
     &2b-1)+int_mb(k_spin+p13b-1)+int_mb(k_spin+p18b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h15b-1),ieor(int_mb
     &(k_sym+h16b-1),ieor(int_mb(k_sym+h17b-1),ieor(int_mb(k_sym+p1b-1),
     &ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p13b-1),int_mb(k_sym+p1
     &8b-1)))))))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_8(h3b,h15b,h16b,h17b,p1b,p2b,p13b,p18b,h3b_1,h
     &15b_1,h16b_1,h17b_1,p1b_1,p2b_1,p13b_1,p18b_1)
      CALL TCE_RESTRICTED_6(h4b,p13b,p18b,h15b,h16b,h17b,h4b_2,p13b_2,p1
     &8b_2,h15b_2,h16b_2,h17b_2)
      dim_common = int_mb(k_range+h15b-1) * int_mb(k_range+h16b-1) * int
     &_mb(k_range+h17b-1) * int_mb(k_range+p13b-1) * int_mb(k_range+p18b
     &-1)
      dima_sort = int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1) * int_mb
     &(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_23',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_23',2,MA_ERR)
      IF ((h17b .lt. h3b) .and. (p18b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p18b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h3b_1 - 1 + noab * (h17b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h17b-1),int_mb(k_range+h3b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p18b-1),int_mb(k_range+p
     &1b-1),int_mb(k_range+p2b-1),8,7,4,6,5,3,2,1,-1.0d0)
      END IF
      IF ((h17b .lt. h3b) .and. (p13b .lt. p1b) .and. (p1b .le. p18b) .a
     &nd. (p18b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h3b_1 - 1 + noab * (h17b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h17b-1),int_mb(k_range+h3b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,6,4,7,5,3,2,1,1.0d0)
      END IF
      IF ((h17b .lt. h3b) .and. (p13b .lt. p1b) .and. (p2b .le. p18b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h3b_1 - 1 + noab * (h17b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h17b-1),int_mb(k_range+h3b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,6,4,8,5,3,2,1,-1.0d0)
      END IF
      IF ((h17b .lt. h3b) .and. (p1b .le. p13b) .and. (p18b .lt. p2b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h3b_1 - 1 + noab * (h17b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h17b-1),int_mb(k_range+h3b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,5,4,7,6,3,2,1,-1.0d0)
      END IF
      IF ((h17b .lt. h3b) .and. (p1b .le. p13b) .and. (p13b .lt. p2b) .a
     &nd. (p2b .le. p18b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h3b_1 - 1 + noab * (h17b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h17b-1),int_mb(k_range+h3b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,5,4,8,6,3,2,1,1.0d0)
      END IF
      IF ((h17b .lt. h3b) .and. (p2b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p2b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h3b_1 - 1 + noab * (h17b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h17b-1),int_mb(k_range+h3b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p13
     &b-1),int_mb(k_range+p18b-1),6,5,4,8,7,3,2,1,-1.0d0)
      END IF
      IF ((h16b .lt. h3b) .and. (h3b .le. h17b) .and. (p18b .lt. p1b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p18b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h3b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p18b-1),int_mb(k_range+p
     &1b-1),int_mb(k_range+p2b-1),8,7,3,6,5,4,2,1,1.0d0)
      END IF
      IF ((h16b .lt. h3b) .and. (h3b .le. h17b) .and. (p13b .lt. p1b) .a
     &nd. (p1b .le. p18b) .and. (p18b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h3b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,6,3,7,5,4,2,1,-1.0d0)
      END IF
      IF ((h16b .lt. h3b) .and. (h3b .le. h17b) .and. (p13b .lt. p1b) .a
     &nd. (p2b .le. p18b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h3b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,6,3,8,5,4,2,1,1.0d0)
      END IF
      IF ((h16b .lt. h3b) .and. (h3b .le. h17b) .and. (p1b .le. p13b) .a
     &nd. (p18b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h3b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,5,3,7,6,4,2,1,1.0d0)
      END IF
      IF ((h16b .lt. h3b) .and. (h3b .le. h17b) .and. (p1b .le. p13b) .a
     &nd. (p13b .lt. p2b) .and. (p2b .le. p18b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h3b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,5,3,8,6,4,2,1,-1.0d0)
      END IF
      IF ((h16b .lt. h3b) .and. (h3b .le. h17b) .and. (p2b .le. p13b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p2b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h3b_1 
     &- 1 + noab * (h16b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p13
     &b-1),int_mb(k_range+p18b-1),6,5,3,8,7,4,2,1,1.0d0)
      END IF
      IF ((h15b .lt. h3b) .and. (h3b .le. h16b) .and. (p18b .lt. p1b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p18b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p18b-1),int_mb(k_range+p
     &1b-1),int_mb(k_range+p2b-1),8,7,2,6,5,4,3,1,-1.0d0)
      END IF
      IF ((h15b .lt. h3b) .and. (h3b .le. h16b) .and. (p13b .lt. p1b) .a
     &nd. (p1b .le. p18b) .and. (p18b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,6,2,7,5,4,3,1,1.0d0)
      END IF
      IF ((h15b .lt. h3b) .and. (h3b .le. h16b) .and. (p13b .lt. p1b) .a
     &nd. (p2b .le. p18b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,6,2,8,5,4,3,1,-1.0d0)
      END IF
      IF ((h15b .lt. h3b) .and. (h3b .le. h16b) .and. (p1b .le. p13b) .a
     &nd. (p18b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,5,2,7,6,4,3,1,-1.0d0)
      END IF
      IF ((h15b .lt. h3b) .and. (h3b .le. h16b) .and. (p1b .le. p13b) .a
     &nd. (p13b .lt. p2b) .and. (p2b .le. p18b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,5,2,8,6,4,3,1,1.0d0)
      END IF
      IF ((h15b .lt. h3b) .and. (h3b .le. h16b) .and. (p2b .le. p13b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p2b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h15b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h15b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p13
     &b-1),int_mb(k_range+p18b-1),6,5,2,8,7,4,3,1,-1.0d0)
      END IF
      IF ((h3b .le. h15b) .and. (p18b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p18b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h3b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p18b-1),int_mb(k_range+p
     &1b-1),int_mb(k_range+p2b-1),8,7,1,6,5,4,3,2,1.0d0)
      END IF
      IF ((h3b .le. h15b) .and. (p13b .lt. p1b) .and. (p1b .le. p18b) .a
     &nd. (p18b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h3b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,6,1,7,5,4,3,2,-1.0d0)
      END IF
      IF ((h3b .le. h15b) .and. (p13b .lt. p1b) .and. (p2b .le. p18b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (p13b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h3b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p13b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,6,1,8,5,4,3,2,1.0d0)
      END IF
      IF ((h3b .le. h15b) .and. (p1b .le. p13b) .and. (p18b .lt. p2b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h3b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p1
     &8b-1),int_mb(k_range+p2b-1),8,5,1,7,6,4,3,2,1.0d0)
      END IF
      IF ((h3b .le. h15b) .and. (p1b .le. p13b) .and. (p13b .lt. p2b) .a
     &nd. (p2b .le. p18b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p13b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h3b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p13b-1),int_mb(k_range+p2
     &b-1),int_mb(k_range+p18b-1),7,5,1,8,6,4,3,2,-1.0d0)
      END IF
      IF ((h3b .le. h15b) .and. (p2b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p18b_
     &1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p2b_1 - noab - 
     &1 + nvab * (p1b_1 - noab - 1 + nvab * (h17b_1 - 1 + noab * (h16b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h3b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p13
     &b-1),int_mb(k_range+p18b-1),6,5,1,8,7,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_23',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_23',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_23',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h17b_
     &2 - 1 + noab * (h16b_2 - 1 + noab * (h15b_2 - 1 + noab * (p18b_2 -
     & noab - 1 + nvab * (p13b_2 - noab - 1 + nvab * (h4b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p18b-1),int_mb(k_range+h15b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+h17b-1),1,3,2,6,5,4,1.0d
     &0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_23',6,MA_
     &ERR)
      nsuperh(1) = 1
      nsuperh(2) = 1
      nsuperh(3) = 1
      isuperh = 1
      IF (h15b .eq. h16b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      IF (h16b .eq. h17b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      nsubp(1) = 1
      nsubp(2) = 1
      isubp = 1
      IF (p13b .eq. p18b) THEN
      nsubp(isubp) = nsubp(isubp) + 1
      ELSE
      isubp = isubp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,12.0d0/FACTORIAL
     &(nsuperh(1))/FACTORIAL(nsuperh(2))/FACTORIAL(nsuperh(3))/FACTORIAL
     &(nsubp(1))/FACTORIAL(nsubp(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(
     &k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_23',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_23',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_23',9,MA_ERR)
      IF ((h3b .le. h4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,4,1,3,2,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF ((h4b .le. h3b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h3b-1)
     &,1,4,3,2,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h3b - 1 + noab * (h4b
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_23',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_23',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

*
* $Id: paw_mult_energy.F 25587 2014-05-11 15:51:47Z bylaska $
*
*
* $Log: not supported by cvs2svn $
* Revision 1.6  2004/07/29 15:55:37  bylaska
* Temporary array for Gaunt coefficients added.  Speeds up the program considerably, but it is extrememely memory intensive.  Also added timing routines to multipole calculations and fixed the initial total charge calculation.
*
*  ...EJB
*
* Revision 1.5  2003/03/05 23:16:32  bylaska
* Commented out write statements and other minor fixes.....
* self-consistent loop looks like it is working.....
* ....EJB
*
* Revision 1.4  2003/02/26 20:34:06  marat
* fixed bug related to calculation of
* comp_coeff, the i and j loop were incorrectly switched
* MV
*
* Revision 1.3  2003/02/23 23:06:48  bylaska
* energy subroutines changed to functions...EJB
*
* Revision 1.2  2003/02/23 22:45:52  bylaska
* bug fixes - energies agree with fortran90 code...EJB
*
* Revision 1.1  2003/02/23 21:37:07  bylaska
* routines for calculating atomic multipole energies have been added....EJB
*


  !*************************************************
  !
  !   Name    : paw_mult_energy_atom_comp
  !
  !   Purpose :
  !
  !   Created :
  !
  !*************************************************

      function paw_mult_energy_atom_comp()
      implicit none
      real*8 paw_mult_energy_atom_comp !*RESULT*

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_mult_data.fh"
#include "paw_comp_charge_data.fh"
#include "paw_basis.fh"

      !*** local variables ***
      integer ii,ia,li,mi,il,mult_li
      integer nion
      real*8 e_comp

      nion=ion_nion()
      e_comp = 0.0d0
      do ii=1,nion
        ia      = ion_katm(ii)
        mult_li = paw_basis_mult_l(ia)
        il      = int_mb(i_v_mult(1)+ii-1)
        do li=0,mult_li
        do mi=-li,li

          e_comp = e_comp
     >           + dble(dcpl_mb(paw_qlm(1)+il)
     >                 *dcpl_mb(comp_coeff(1)+il))

!         write(33,*) li,mi,ia,e_comp,dcpl_mb(paw_qlm(1)+il),
!    >                dcpl_mb(comp_coeff(1)+il)     

          il = il + 1
        end do !*mi*
        end do !*li*
      end do !*ii*

      paw_mult_energy_atom_comp = e_comp
      !write(*,*) " paw_mult_energy_atom_comp",e_comp
      return
      end


  !*************************************************
  !
  !   Name    : paw_mult_energy_atom_self
  !
  !   Purpose :
  !
  !   Created :
  !
  !*************************************************

      function paw_mult_energy_atom_self()
      implicit none
      real*8 paw_mult_energy_atom_self !*RESULT*

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_mult_data.fh"
#include "paw_comp_charge_data.fh"
#include "paw_basis.fh"

      !*** local variables ***
      integer ii,ia,li,mi,il,mult_li
      integer indx,lmax,nion
      real*8 e_self

      nion=ion_nion()
      lmax=paw_basis_max_mult_l()

      e_self = 0.0d0
      do ii=1,nion
        ia     = ion_katm(ii)
        mult_li = paw_basis_mult_l(ia)
        il = int_mb(i_v_mult(1)+ii-1)
        do li=0,mult_li
          indx = li + (ia-1)*(lmax+1)
          do mi=-li,li
     
          e_self
     >     = e_self
     >     - 0.5d0*dble(
     >             dconjg(dcpl_mb(paw_qlm(1)+il))
     >            *dcpl_mb(paw_qlm(1)+il))
     >            *dbl_mb(self_energy_coeff(1)+indx)
          il = il +1
          end do !*mi*
        end do !*li*
      end do !*ii*

      paw_mult_energy_atom_self = e_self
      return
      end


  !*************************************************
  !
  !   Name    : paw_mult_energy_atom_mult
  !
  !   Purpose :
  !
  !   Created :
  !
  !*************************************************

      function paw_mult_energy_atom_mult()
      implicit none
      real*8 paw_mult_energy_atom_mult !*RESULT*

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_mult_data.fh"
#include "paw_comp_charge_data.fh"
#include "paw_basis.fh"

      !*** local variables ***
      integer taskid,np,tcount
      integer ii,ia,li,mi,il,ill,mult_li
      integer jj,ja,lj,mj,jl,jll,mult_lj
      integer nion,indx,lmax,lmax2
      real*8 e_mult
      real*8 xxx

      call nwpw_timing_start(14)
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      nion  = ion_nion()
      lmax  = paw_basis_max_mult_l()
      lmax2 = (lmax+1)**2

      tcount = 0
      e_mult = 0.0d0
      do ii=1,nion
        ia     = ion_katm(ii)
        mult_li = paw_basis_mult_l(ia)
        il     = int_mb(i_v_mult(1)+ii-1)
        ill    = 0
        do li=0,mult_li
        do mi=-li,li

          do jj=1,nion
          if (tcount.eq.taskid) then
            ja     = ion_katm(jj)
            mult_lj = paw_basis_mult_l(ja)
            jl     = int_mb(i_v_mult(1)+jj-1)
            jll    = 0
            do lj=0,mult_lj
            do mj=-lj,lj

               indx = (ii-1)
     >              + ill*nion
     >              + (jj-1)*nion*lmax2
     >              + jll*nion*lmax2*nion

               e_mult
     >          = e_mult
     >          + 0.5d0*dble(
     >             dcpl_mb(paw_qlm(1)+jl)
     >            *dcpl_mb(paw_qlm(1)+il)
     >            *dcpl_mb(mult_energy_coeff(1)+indx))

              jl  = jl+1
              jll = jll+1
            end do !*mj*
            end do !*lj*
          end if
          tcount=mod(tcount+1,np)
          end do !*jj*

          il  = il +1
          ill = ill +1
        end do !*mi*
        end do !*li*
      end do !*ii*
      if (np.gt.1) call D3dB_SumAll(e_mult)
      call nwpw_timing_end(14)

      paw_mult_energy_atom_mult = e_mult
      return
      end

      Subroutine matchNxyz(lambda,ic,Nxyz)
c $Id: matchNxyz.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none

      integer lambda, ic, Nxyz(3)

#include "sh_order.fh"
#include "errquit.fh"

      integer l, l3, nc

c
c Given the angular momentum exponents for the "ic" component of a shell of
c Cartesian GTFs of angular momentum "lambda" return ic. Hard error if no
c match is found.
c
c 

      if( lambda.le.linit )then

       l = lambda - 1
cedo       l3 = ((l+1)*(l+2)*(l+3))/6
       l3 = ((l+2)*(l+3))/2
       nc =l3*(l+1)/3
       do ic = 1, l3
          nc = nc +1
          if (
     $         Nxyz(1) .eq. Ixyz(1,nc) .and.
     $         Nxyz(2) .eq. Ixyz(2,nc) .and.
     $         Nxyz(3) .eq. Ixyz(3,nc))
     $         return
       enddo
       call errquit('matchNxyz: invalid shell indices', 
     $      1000*lambda+100*nxyz(1)+10*nxyz(2)+nxyz(3), BASIS_ERR)
      else
       write(*,*)
       write(*,*) 'MATCHNXYZ:  Shell component ordering was defined for'
       write(*,*) '            shells up through L = ',linit,'.'
       write(*,*) '            Initialization (defNxyz) should include '
       write(*,*) '            shells up through L = ',lambda,'.'
       stop

      end if

      end

      subroutine argos_diana_rdsel()
c
      implicit none
c
#include "argos_diana_common.fh"
#include "mafdecls.fh"
c
      filsel=card(8:80)
      call argos_diana_readsel(lfnsel,filsel,int_mb(i_wsel),
     + int_mb(i_isel))
      call argos_diana_wcount(int_mb(i_wsel),int_mb(i_ndxw))
c
      return
      end
c $Id: argos_diana_rdsel.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: band_minimizer.F 25295 2014-02-25 23:59:25Z bylaska $
*
***********************************************************************
*                     band_minimizer								  *
*                                                                     *
*     This is a developing band structure parallel code for NWCHEM    *
*       + tcgmsg message passing library used                         *
*       + my own slap-decomposed parallel 3d-FFT(real->complex) used  *
*                                                                     *
*                                                                     *
***********************************************************************

      logical function band_minimizer(rtdb,flag)
      implicit none
      integer rtdb
      integer flag

#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"      

*     **** parallel variables ****
      integer  taskid,np,np_i,np_j,np_k
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d
      real*8  a,b,c,alpha,beta,gamma

*     ***** energy variables ****
      logical spin_orbit
      integer ispin,ne(2)
      real*8  E(10)
      real*8  dipole(3)
      real*8  stress(3,3),lstress(6)

*     **** gradient variables ****
      integer fion(2)

*     **** error variables ****
      logical value
      integer ierr

*     **** local variables ****
      logical newpsi,lprint,mprint,hprint
      real*8  gx,gy,gz,cx,cy,cz
      real*8  EV,pi,weight
      real*8  icharge,en(2)
      real*8  f0,f1,f2,f3,f4,f5,f6
      integer if1,if2
      integer i,k,ia,nion,vers,nbrillioun,nb,ms
      integer mapping,minimizer

*     **** external functions ****
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg,ion_amass,ion_TotalCharge
      character*4 ion_aname
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg,ion_amass,ion_TotalCharge
      external    ion_aname


      real*8   control_tole,control_tolc,control_tolr,ion_rion
      external control_tole,control_tolc,control_tolr,ion_rion
      real*8   control_time_step,control_fake_mass
      external control_time_step,control_fake_mass
      logical  control_read,control_move,ion_init,ion_q_FixIon
      external control_read,control_move,ion_init,ion_q_FixIon
      logical control_spin_orbit
      external control_spin_orbit
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      integer  ion_nkatm
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external ion_nkatm

      character*12 control_boundry
      external     control_boundry

      logical  brillioun_print,control_Mulliken
      integer  brillioun_nbrillioun,brillioun_nbrillq
      real*8   brillioun_weight_brdcst,brillioun_ks_brdcst
      real*8   brillioun_k_brdcst,brillioun_weight
      external brillioun_print,control_Mulliken
      external brillioun_nbrillioun,brillioun_nbrillq
      external brillioun_weight_brdcst,brillioun_ks_brdcst 
      external brillioun_k_brdcst,brillioun_weight
      integer  c_electron_count,linesearch_count
      external c_electron_count,linesearch_count

      real*8   nwpw_timing
      external nwpw_timing
      integer  Cram_nwave_all_brdcst,Cram_nwave_brdcst
      external Cram_nwave_all_brdcst,Cram_nwave_brdcst

      integer  ewald_ncut
      real*8   ewald_rcut,ewald_mandelung,ewald_e
      external ewald_ncut
      external ewald_rcut,ewald_mandelung,ewald_e
      logical  cpsp_semicore,psi_filefind,cpsi_initialize,cpsi_finalize
      external cpsp_semicore,psi_filefind,cpsi_initialize,cpsi_finalize
      real*8   c_cgsd_energy,c_cgsd_noit_energy
      external c_cgsd_energy,c_cgsd_noit_energy
      integer  cpsp_lmax,cpsp_locp,cpsp_lmmax
      external cpsp_lmax,cpsp_locp,cpsp_lmmax
      integer  cpsp_nprj,cpsp_psp_type
      external cpsp_nprj,cpsp_psp_type
      real*8   cpsp_rcore,cpsp_rc,cpsp_ncore,cpsp_zv
      external cpsp_rcore,cpsp_rc,cpsp_ncore,cpsp_zv
      character*4 ion_atom
      external    ion_atom

      character*255 cpsp_comment,comment
      external      cpsp_comment

      integer  cpsi_ispin,cpsi_ne,psi_get_version
      external cpsi_ispin,cpsi_ne,psi_get_version
      logical  pspw_reformat_c_wvfnc,control_check_charge_multiplicity
      external pspw_reformat_c_wvfnc,control_check_charge_multiplicity
      integer  control_mapping,control_minimizer,control_np_dimensions
      external control_mapping,control_minimizer,control_np_dimensions
      integer  control_scf_algorithm
      external control_scf_algorithm
      real*8   control_ks_alpha,control_kerker_g0
      external control_ks_alpha,control_kerker_g0
      integer  control_ks_maxit_orb,control_ks_maxit_orbs
      external control_ks_maxit_orb,control_ks_maxit_orbs
      real*8   cpsi_occupation,control_fractional_temperature
      external cpsi_occupation,control_fractional_temperature
      logical  control_fractional,control_print
      external control_fractional,control_print
      integer  control_fractional_smeartype
      external control_fractional_smeartype
      real*8   control_fractional_kT
      external control_fractional_kT

c      character*255 cpsp_comment,comment
c      external      cpsp_comment

      integer  ion_nconstraints,ion_ndof
      external ion_nconstraints,ion_ndof
      logical  control_smooth_cutoff
      external control_smooth_cutoff
      real*8   control_smooth_cutoff_values
      external control_smooth_cutoff_values


*****************************|  PROLOGUE  |****************************

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(10,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      value = control_read(5,rtdb)
      if (.not. value) 
     > call errquit('error reading control',0, DISK_ERR)

      lprint = ((taskid.eq.MASTER).and.(control_print(print_low)))
      mprint = ((taskid.eq.MASTER).and.(control_print(print_medium)))
      hprint = ((taskid.eq.MASTER).and.(control_print(print_high)))

      if (taskid.eq.MASTER) call current_second(cpu1)
*     ***** print out header ****
      if (mprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1042)
         write(luout,1043)
         write(luout,1044)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
         call flush(luout)
      end if
      

      call Parallel3d_Init(control_np_dimensions(2),
     >                     control_np_dimensions(3))
      call Parallel3d_np_i(np_i)
      call Parallel3d_np_j(np_j)
      call Parallel3d_np_k(np_k)

      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      minimizer = control_minimizer()
      mapping   = control_mapping()
      ierr = 0 

*     **** initialize C3dB data structure ****
      call C3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call C3dB_nfft3d(1,nfft3d)
       
      call cpsi_data_init(20)

*     **** initialize lattice data structure ****
      call lattice_init()
      call c_G_init()
      call brillioun_init()
      call Cram_Init()
      call C3dB_pfft_init()

*     **** initialize D3dB data structure and mask for GGA ****
      if ((control_gga().ge.10).and.(control_gga().le.200)) THEN
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call G_init()
      call mask_init()
      end if

*     **** read ions ****
      value = ion_init(rtdb)
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call cpsp_init()
      call cpsp_readall()
      if (cpsp_semicore(0)) call c_semicore_check()


*     **** initialize ke,and coulomb data structures ****
      call cstrfac_init()
      call cke_init()
      call c_coulomb_init()
      call ewald_init()

*     **** set up phase factors at the current geometry  ****
      call cphafac()
      call cphafac_k()
      call ewald_phafac()

*     **** read in wavefunctions and initialize psi ****
      if (.not.control_check_charge_multiplicity()) then
         call cpsi_new()
         newpsi = .true.
      else
         newpsi = .false.
*        **** convert from pspw format to band format ****
         vers = psi_get_version()
         if ((vers.eq.3).or.(vers.eq.4)) then
           newpsi = .true.
           value = rtdb_parallel(.false.)
           if (taskid.eq.MASTER) then
             value= pspw_reformat_c_wvfnc(1)  
           end if
           value = rtdb_parallel(.true.)
         end if
      end if

      call psi_get_ne(ispin,ne)
      if (ispin.eq.3) then
         spin_orbit = .true.
         ispin=2
      else
         spin_orbit = .false.
      end if
      nbrillioun = brillioun_nbrillioun()
      call Pneb_init(ispin,ne,nbrillioun,spin_orbit)
      value = cpsi_initialize(.true.)

*     **** electron and geodesic data structures ****
      call c_electron_init()
      call c_geodesic_init()

*     **** initialize HFX ****
      call band_init_HFX(rtdb,nbrillioun,ispin,ne)


*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)
 
*     **** initialize linesearching ****
      call linesearch_init()


*                |**************************|
******************   summary of input data  **********************
*                |**************************|


*     **** determine en ****
      if (.not.control_spin_orbit()) then
        icharge = 0.0d0
        en(1)   = 0.0d0
        en(2)   = 0.0d0
        b = dble(3-cpsi_ispin())
        do nb=1,brillioun_nbrillq()
        weight = brillioun_weight(nb)
        do ms=1,cpsi_ispin()
          do i=1,ne(ms)
            a = cpsi_occupation(nb,ms,i)
            icharge = icharge - b*a*weight
            en(ms)  = en(ms) + a*weight
          end do
        end do
        end do
        call K1dB_Vector_SumAll(2,en)
        call K1dB_SumAll(icharge)
      else
        icharge          = -cpsi_ne(1)
        en(1)            =  cpsi_ne(1)
        en(cpsi_ispin()) =  cpsi_ne(cpsi_ispin())
      end if


      if (mprint) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j,np_k
         if (mapping.eq.1) write(luout,1112)
         if (mapping.eq.2) write(luout,1113)
         if (mapping.eq.3) write(luout,1118)

         write(luout,1115)
         write(luout,1121) control_boundry(),control_version()
         if (.not.spin_orbit) then
           if (cpsi_ispin().eq.1) write(luout,1130) "restricted"
           if (cpsi_ispin().eq.2) write(luout,1130) "unrestricted"
         else
           write(luout,1130) "spin orbit"
         end if

         call v_bwexc_print(luout,control_gga())
         
         call band_print_HFX(luout)
         write(luout,1140)
         do ia = 1,ion_nkatm()
           write(luout,1150) ia,ion_atom(ia),
     >                    cpsp_zv(ia),cpsp_lmax(ia)
           comment = cpsp_comment(ia)
           i = inp_strlen(comment)
           write(6,1157) comment(1:i)
           write(6,1158) cpsp_psp_type(ia)
           write(luout,1152) cpsp_lmax(ia)
           write(luout,1153) cpsp_locp(ia)
c           write(luout,1154) cpsp_lmmax(ia)
           write(luout,1154) cpsp_nprj(ia)
           if (cpsp_semicore(ia))
     >         write(luout,1155) cpsp_rcore(ia),cpsp_ncore(ia)
           write(luout,1151) (cpsp_rc(i,ia),i=0,cpsp_lmax(ia))
         end do

         icharge = icharge + ion_TotalCharge()
         write(luout,1159) icharge


         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         if (hprint) then
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz
         write(luout,1211) ion_nconstraints(),ion_ndof()
         endif
         write(luout,1220) en(1),en(cpsi_ispin()),
     >                 ' (Fourier space)'
         write(luout,1221) cpsi_ne(1),cpsi_ne(cpsi_ispin()),
     >                 ' (Fourier space)'

         write(luout,1230)
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1231) lattice_omega()
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()

         write(luout,1255)
         write(luout,1256) brillioun_nbrillioun()
      end if

c     **** print brillioun zone - extra logic for distributed kpoints ****
      if (brillioun_print()) then
         do i=1,brillioun_nbrillioun()
            f0 = brillioun_weight_brdcst(i) 
            f1 = brillioun_ks_brdcst(1,i) 
            f2 = brillioun_ks_brdcst(2,i) 
            f3 = brillioun_ks_brdcst(3,i) 
            f4 = brillioun_k_brdcst(1,i)  
            f5 = brillioun_k_brdcst(2,i)  
            f6 = brillioun_k_brdcst(3,i)
            if (mprint) write(luout,1257) f0,f1,f2,f3,f4,f5,f6
         end do
      else
        if (mprint) write(luout,1258) 
      end if

      if1 = Cram_nwave_all_brdcst(0)
      if2 = Cram_nwave_brdcst(0)
      if (mprint) then
         write(luout,1249)
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                     if1,if2
      end if

      if (brillioun_print()) then
        do i=1,brillioun_nbrillioun()
          if1 = Cram_nwave_all_brdcst(i)
          if2 = Cram_nwave_brdcst(i)
          if (mprint) then
          write(luout,1251) i,lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                      if1,if2
          end if
        end do
      else
        if (mprint) write(luout,1252) lattice_wcut()
      end if

      if (mprint) then
         if (control_smooth_cutoff())
     >      write(luout,1253)
     >      control_smooth_cutoff_values(1)*lattice_wcut(),
     >      control_smooth_cutoff_values(2)

         write(luout,1270)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_tole(),control_tolc()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()

         if ((minimizer.eq.5).or.(minimizer.eq.8)) then
           write(6,1291)
           write(6,1292)
           write(luout,1295) control_ks_maxit_orb(),
     >                       control_ks_maxit_orbs()
           if (control_scf_algorithm().eq.0)
     >       write(6,1293) "simple mixing"
           if (control_scf_algorithm().eq.1)
     >       write(6,1293) "Anderson potential mixing"
           if (control_scf_algorithm().eq.2)
     >       write(6,1293) "Johnson-Pulay mixing"
           if (control_scf_algorithm().eq.3)
     >       write(6,1293) "Anderson density mixing"
           if (minimizer.eq.5) write(luout,1296) "potential"
           if (minimizer.eq.8) write(luout,1296) "density"
           write(6,1294) control_ks_alpha()
           write(6,1301) control_kerker_g0()
         end if
         if (control_fractional()) then
           write(6,1297)
           if (control_fractional_smeartype().eq.0)
     >       write(6,1298) "step function"
           if (control_fractional_smeartype().eq.1)
     >       write(6,1298) "Fermi-Dirac"
           if (control_fractional_smeartype().eq.2)
     >       write(6,1298) "Gaussian"
           write(6,1299) control_fractional_kT(),
     >                   control_fractional_temperature()
         end if
         write(luout,1300)
         call util_flush(luout)
      end if



*                |***************************|
******************     call CG minimizer     **********************
*                |***************************|
      if (taskid.eq.MASTER) call current_second(cpu2)


*     **** calculate energy ****
      if (flag.eq.-1) then

        EV= c_cgsd_noit_energy()
      else

        EV= c_cgsd_energy(newpsi)
      end if

*     **** calculate excited state orbitals ****
      call ga_sync()
      call c_cgsd_excited()

*     **** extra energy output for QA test ****
      if (lprint) write(luout,1600) EV

*     **** calculate the spin contamination ****
      if (flag.gt.-1) call cpsi_spin2(dipole(1))
      
*     **** calculate the dipole ***
      dipole(1) = 0.0d0
      dipole(2) = 0.0d0
      dipole(3) = 0.0d0

*     ****  calculate gradient ***
      if (flag.gt.0) then
      nion = ion_nion()
      value = MA_push_get(mt_dbl,(3*nion),
     >                       'fion',fion(2),fion(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


      call c_cgsd_energy_gradient(dbl_mb(fion(1)))
      call dscal(3*nion,(-1.0d0),dbl_mb(fion(1)),1)
      end if
     
*     **** calculate the stress tensor ****
      call dcopy(9,0.0d0,0,stress,1)
      call dcopy(6,0.0d0,0,lstress,1)
      if (flag.eq.3) then

         call cpsp_stress_init()
         call cpsp_stress_readall()
         call c_cgsd_energy_stress(stress,lstress)
         call cpsp_stress_end()
      end if


*     *************************************************************
*     **** output energy, dipole, and gradient to rtdb for use ****
*     **** by task_energy and task_gradient                    ****
*     *************************************************************
      if (flag.gt.-1) then
      value = rtdb_put(rtdb,'band:energy',mt_dbl,1,EV)
      value = value.and.
     >        rtdb_put(rtdb,'band:dipole',mt_dbl,
     >                 3,dipole)
      end if
      if (flag.gt.0) then
        value = value.and.rtdb_put(rtdb,'band:gradient',mt_dbl,
     >                             3*nion,dbl_mb(fion(1)))
        value = value.and.MA_pop_stack(fion(2))
      end if
      if (flag.eq.3) then
        value = value.and.
     >        rtdb_put(rtdb,'band:stress',mt_dbl,
     >                 9,stress)
        value = value.and.
     >        rtdb_put(rtdb,'band:lstress',mt_dbl,
     >                 6,lstress)
      end if
      if (.not. value) 
     > call errquit('band_minimizer: error writing rtdb',0, RTDB_ERR)
     


      if (taskid.eq.MASTER) call current_second(cpu3)

*                |***************************|
******************         Epilogue          **********************
*                |***************************|

*     **** calculate interpolated band structure plot ***
      call band_interpolate_structure(rtdb)
cc      call band_kp_structure(rtdb)

*     **** calculate Mulliken Populations ***
      if (control_Mulliken()) then
         call cpsi_Mulliken(rtdb)
      end if


*     **** write geometry to rtdb ****
      call ion_write(rtdb)

*     **** write wavefunctions to file and finalize psi ****
      if (flag.eq.-1) then
        value = cpsi_finalize(.false.)
      else
        value = cpsi_finalize(.true.)
      end if

*     **** deallocate heap memory ****
      call c_electron_finalize()
      call c_geodesic_finalize()
      call ewald_end()
      call cstrfac_end()
      call c_coulomb_end()
      call cke_end()
      call cpsp_end()
      call Cram_end()
      call c_G_end()
      call band_end_HFX()
      call brillioun_end()
      call ion_end()
      call ion_end_FixIon()
      call cpsi_data_end()
      call C3dB_pfft_end()
      call C3dB_end(1)
      IF ((control_gga().ge.10).and.(control_gga().le.200)) THEN
      call mask_end()
      call G_end()
      call D3dB_end(1)
      end if

*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (lprint) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(c_electron_count())
         write(luout,1801)
         write(luout,1802)
         write(luout,1803) T1
         write(luout,1804) T2
         write(luout,1805) T3
         write(luout,1806) T4
         write(luout,1807) AV,c_electron_count(),linesearch_count()

         call nwpw_timing_print_final(mprint,c_electron_count())
         write(luout,*)
         CALL nwpw_MESSAGE(4)
      end if 


      call Parallel3d_Finalize()
      call Parallel_Finalize()
      band_minimizer = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,
     > '**********************************************************')
 1010 FORMAT(10X,
     > '*                                                        *')
 1020 FORMAT(10X,
     > '*                   NWPW BAND Calculation                *')
 1030 FORMAT(10X,
     > '*  [(bundled Grassmann/Stiefel manifold implementation)] *')
 1035 FORMAT(10x,
     > '*         [ NorthWest Chemistry implementation ]         *')
 1040 FORMAT(10X,
     > '*                version #1.10   01/31/03                *')
 1041 FORMAT(10X,
     > '*  A pseudopotential plane-wave band structure program   *')
 1042 FORMAT(10X,
     > '*  with Brillouin zone sampling for optimizing crystals, *')
 1043 FORMAT(10X,
     > '*  slabs, and polymers.  Developed by Eric J. Bylaska    *')
 1044 FORMAT(10X,
     > '*  , Edoardo Apra, and Patrick Nichols.                  *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I16)
 1112 FORMAT( ' parallel mapping         :         1d slab')
 1113 FORMAT( ' parallel mapping         :     2d  hilbert')
 1115 FORMAT(/' options:')
 1117 FORMAT( ' processor grid           :',I4,' x',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         :       2d hcurve')
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I1)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)

 1159 FORMAT(/' total charge:',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I3))
 1180 FORMAT(/' initial position of ions:')
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - fixed')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1211 FORMAT(5X,'   number of constraints = ', I6,' ( DOF = ',I6,' )' )
 1220 FORMAT(/' number of electrons: spin up=',F8.2,
     >                          '  spin down=',F8.2,A)
 1221 FORMAT( ' number of orbitals:  spin up=',I8,
     >                          '  spin down=',I8,A)
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,' volume : ',F10.1)
 1232 FORMAT(/5x,' lattice:    a=',f8.3,'    b=',f8.3,'     c=',f8.3,
     >       /5x,'         alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1249 FORMAT(/' computational grids:')
 1250 FORMAT(5X,' density     cutoff=',F7.3,'  fft=',I4,'x',I4,'x',I4,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc ',I3,' cutoff=',F7.3,
     &        '  fft=',I4,'x',I4,'x',I4,
     &       '( ',I8,' waves ',I8,' per task)')
 1252 FORMAT(5x,' wavefnc     cutoff=',F7.3,
     >       ' wavefunction grids not printed - ',
     >       'number of k-points is very large')
 1253 FORMAT(5X,' smooth wavefnc cutoff:  A=',F7.3,' sigma = ',F7.3)

  
 1255 FORMAT(/' brillouin zone:')
 1256 FORMAT(5x,' number of zone points:',I6)
 1257 FORMAT(5x,' weight=',f8.3,'  ks=<',3f8.3,' >, k=<',3f8.3,'>')
 1258 FORMAT(5x,' number of k-points is very large')

 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 
 1270 FORMAT(/' technical parameters:')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (density)')
 1291 FORMAT(/' Kohn-Sham scf parameters:')
 1292 FORMAT(5X, ' Kohn-Sham algorithm  = conjugate gradient')
 1293 FORMAT(5X, ' scf algorithm        = ',A)
 1294 FORMAT(5X, ' scf mixing parameter =',F7.4)
 1295 FORMAT(5X, ' Kohn-Sham iterations = ',I3,
     >           ' (',I3,' outer)')
 1296 FORMAT(5X, ' scf mixing type      = ',A)
 1297 FORMAT(/' fractional smearing parameters:')
 1298 FORMAT(5X, ' smearing algorithm   = ',A)
 1299 FORMAT(5X, ' smearing parameter   = ',E9.3,' (',F7.1,' K)')
 1300 FORMAT(//)
 1301 FORMAT(5X, ' Kerker damping       =',F7.4)
 1305 FORMAT(10X,'================ iteration =========================')
 1310 FORMAT(I8,E20.10,3E15.5)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1500 FORMAT(/' orbital energies:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1600 FORMAT(/' Total BAND energy   :',E19.10)

 1801 FORMAT(//'== Timing ==')
 1802 FORMAT(/'cputime in seconds')
 1803 FORMAT( '  prologue    : ',E14.6)
 1804 FORMAT( '  main loop   : ',E14.6)
 1805 FORMAT( '  epilogue    : ',E14.6)
 1806 FORMAT( '  total       : ',E14.6)
 1807 FORMAT( '  cputime/step: ',E14.6,
     >        '       (',I8,' evalulations,', I8,' linesearches)')
 1808 FORMAT(A,E14.6,E14.6)
 1809 FORMAT(//A,2A14)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(6,9010) ierr
      call Parallel_Finalize()

      band_minimizer = value
      return
      END

c $Id: hnd_giao_init.F 21221 2011-10-20 14:30:56Z niri $
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     hondo : giao initialization routine
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine hnd_giao_init(bases,nbas)
      implicit none
#include "hnd_tol.fh"
#include "bas.fh"
#include "errquit.fh"
c
      integer nbas         ! [input] number of basis sets to be used
      integer bases(nbas)  ! [input] basis set handles
c
      integer ibas,maxang,angm
c
c     set default tolerance
c
      itol = 15
c
c     set up the HONDO hermit and wermit arrays
c
      call hnd_whermt
c
c     set up memory requirements: get max L first
c
      maxang = -1
      do 00300 ibas = 1,nbas
        if(.not.bas_high_angular(bases(ibas),angm))
     &         call errquit('hnd_giao_init: angm error',angm, INT_ERR)
        maxang = max(maxang,angm)
00300 continue
c
      call hnd_giao_1emem(maxang)
      call hnd_giao_2emem(maxang)
c
      return
      end

      SUBROUTINE YGESV( N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
* $Id: ygesv.F 21373 2011-11-02 20:52:29Z d3p852 $
*     .. Scalar Arguments ..
      implicit none
#include "y64.fh"
      INTEGER            INFO, LDA, LDB, N, NRHS
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
c
      INTGR4            INFO4, LDA4, LDB4, N4, NRHS4
C Warning the values of IPIV should not be used, since they are not
C changed before outputting
C      integer maxn
C      parameter (maxn=10000)
C      INTGR4            IPIV4(maxn)
      integer i
c
cedo      if(n.gt.maxn) then
cedo         write(6,*) ' ygesv: increase maxn to: ',n
cedo         call errquit(' ygesv: maxn value ',0,0)
cedo      endif
      LDA4=lda
      ldb4=ldb
      n4=n
      nrhs4=nrhs
c
      call DGESV( N4, NRHS4, A, LDA4, IPIV, B, LDB4, INFO4 )
c
cedo      do i=1,N
cedo         ipiv(i)=ipiv4(i)
cedo      enddo
      info=info4
      RETURN
      END

      subroutine dia_espplt()
c
c $Id: dia_espplt.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "dia_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
#include "util.fh"
c
      character*255 string
      integer i
      integer ilt,iht,jlt,jht,ndxt,ldt
c
      string=card(8:80)
      read(string(1:4),'(i4)') ngrid
      read(string(5:8),'(i4)') iesppb
      read(string(9:20),'(f12.6)') rcut
      fmtesp=string(21:23)
      strplt=string(24:80)
      strepz=string(24:80)
c
      call ga_distribution(ga_trj,me,il,ih,jl,jh)
      call ga_access(ga_trj,il,ih,jl,jh,ndx,ld)
      call ga_distribution(ga_trt,me,ilt,iht,jlt,jht)
      call ga_access(ga_trt,ilt,iht,jlt,jht,ndxt,ldt)
c
      call dia_pltgrd(int_mb(i_isel),dbl_mb(i_qdat),
     + dbl_mb(ndx),dbl_mb(ndxt),int_mb(i_atmn))
c
      return
      end
      subroutine dia_pltgrd(isel,qs,xtrj,trt,iatmn)
c
      implicit none
c
#include "dia_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer isel(nsa),iatmn(nsa)
      real*8 qs(nsa),xtrj(ntrj,3,nfrdim),trt(6,nfrdim)
c
      integer i,j,k
      real*8 d
c
c     allocate memory for grid
c
c
      do 12 j=1,3
      if(iesppb.eq.0.or.rcut.lt.0.0d0.or.
     + (iesppb.eq.1.and.j.ne.3).or.
     + (iesppb.eq.2.and.j.eq.3)) then
      d=xsmax(j)-xsmin(j)+2.0d0*abs(rcut)
      else
      d=box(j)
      endif
      ngrd(j)=ngrid*int(d)
   12 continue
c
      ngx=ngrd(1)
      ngy=ngrd(2)
      ngz=ngrd(3)
      mgrd=ngx*ngy*ngz
      if(.not.ma_push_get(mt_dbl,mgrd,'grid',l_grid,i_grid))
     + call md_abort('Failed to allocate memory for grid',me)
c
      do 1 k=1,nfrme
c
      write(filplt,1000) strplt(1:index(strplt,' ')-1),
     + me*nfrdim+k,'.plt '
      write(filcub,1000) strplt(1:index(strplt,' ')-1),
     + me*nfrdim+k,'.cube '
      write(filepz,1000) strepz(1:index(strepz,' ')-1),
     + me*nfrdim+k,'.epz '
 1000 format(a,i5.5,a)
c
c     calculate the electrostatic potential on the grid
c
      call dia_espgrd(isel,xtrj(1,1,k),trt(1,k),qs,dbl_mb(i_grid),
     + iatmn)
c
    1 continue
c
c     deallocate memory
c
      if(.not.ma_pop_stack(l_grid))
     + call md_abort('Failed to deallocate grid',0)
c
      return
 9999 continue
      call md_abort('dia_pltgrd: error',0)
      return
      end
      subroutine dia_espgrd(isel,x,t,q,g,iatmn)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 cf_anint
      external cf_anint
#endif
c
      real*8 x(nsa,3),q(nsa),g(ngx,ngy,ngz),t(6)
      integer isel(nsa),iatmn(nsa)
c
      integer ix,iy,iz,i,j,k,nxfr,nxto
      real*8 xg,yg,zg,value
      real*8 dx,dy,dz
      real*8 boxh(3),xd(3)
c
      real*8 nm2au
      parameter(nm2au=1.88972598858d01)
c
      mgrd=ngx*ngy*ngz
      lplt=1
c
      box(1)=t(4)
      box(2)=t(5)
      box(3)=t(6)
      boxh(1)=0.5d0*box(1)
      boxh(2)=0.5d0*box(2)
      boxh(3)=0.5d0*box(3)
c
      xmin(1)=x(1,1)
      xmin(2)=x(1,2)
      xmin(3)=x(1,3)
      xmax(1)=x(1,1)
      xmax(2)=x(1,2)
      xmax(3)=x(1,3)
      do 11 i=1,nsa
      xmin(1)=min(xmin(1),x(i,1))
      xmin(2)=min(xmin(2),x(i,2))
      xmin(3)=min(xmin(3),x(i,3))
      xmax(1)=max(xmax(1),x(i,1))
      xmax(2)=max(xmax(2),x(i,2))
      xmax(3)=max(xmax(3),x(i,3))
   11 continue
c
      do 12 j=1,3
      if(iesppb.eq.0.or.rcut.lt.0.0d0.or.
     + (iesppb.eq.1.and.j.ne.3).or.
     + (iesppb.eq.2.and.j.eq.3)) then
      xd(j)=xmax(j)-xmin(j)+2.0d0*abs(rcut)
      xmin(j)=xmin(j)-abs(rcut)
      else
      xd(j)=box(j)
      xmin(j)=0.5d0*(xmin(j)+xmax(j)-box(j))
      endif
   12 continue
c
      do 13 j=1,3
      spac(j)=xd(j)/(ngrd(j)-1)
   13 continue
c
      do 1 i=1,ngx
      do 2 j=1,ngy
      do 3 k=1,ngz
      g(i,j,k)=0.0d0
    3 continue
    2 continue
    1 continue
c
      do 4 ix=1,ngx
      xg=dble(ix-1)*spac(1)+xmin(1)
      do 5 iy=1,ngy
      yg=dble(iy-1)*spac(2)+xmin(2)
      do 6 iz=1,ngz
      zg=dble(iz-1)*spac(3)+xmin(3)
      do 7 i=1,nsa
      if(isel(i).gt.0) then
      dx=xg-x(i,1)
      dy=yg-x(i,2)
      dz=zg-x(i,3)
      if(iesppb.eq.2.or.iesppb.eq.3) then
      if(abs(dx).gt.boxh(1)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      dx=dx-cf_anint(dx/box(1))*box(1)
#else
      dx=dx-anint(dx/box(1))*box(1)
#endif
      endif
      if(abs(dy).gt.boxh(2)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      dy=dy-cf_anint(dy/box(2))*box(2)
#else
      dy=dy-anint(dy/box(2))*box(2)
#endif
      endif
      endif
      if(iesppb.eq.1.or.iesppb.eq.3) then
      if(abs(dz).gt.boxh(3)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      dz=dz-cf_anint(dz/box(3))*box(3)
#else
      dz=dz-anint(dz/box(3))*box(3)
#endif
      endif
      endif
      g(ix,iy,iz)=g(ix,iy,iz)+138.9354d0*
     + q(i)/sqrt(dx**2+dy**2+dz**2)
      endif
    7 continue
    6 continue
    5 continue
    4 continue
c
c     write to plt file
c     -----------------
c
      if(fmtesp.eq.'plt'.or.fmtesp.eq.'all') then
      open(unit=lfnplt,file=filplt(1:index(filplt,' ')-1),
     + form='formatted',status='unknown')
      rewind(lfnplt)
      write(lfnplt,1000) 3,3
 1000 format(2i7)
      write(lfnplt,1001) ngz,ngy,ngx
 1001 format(3i7)
      write(lfnplt,1002)
     + 10.0d0*xmin(3),10.0d0*(xmin(3)+dble(ngz-1)*spac(3)),
     + 10.0d0*xmin(2),10.0d0*(xmin(2)+dble(ngy-1)*spac(2)),
     + 10.0d0*xmin(1),10.0d0*(xmin(1)+dble(ngx-1)*spac(1))
 1002 format(6e12.5)
      write(lfnplt,1003) (((g(ix,iy,iz),ix=1,ngx),iy=1,ngy),iz=1,ngz)
 1003 format(2e20.12)
      close(unit=lfnplt)
      endif
c
c     write to cube file
c     ------------------
c
      if(fmtesp.eq.'cub'.or.fmtesp.eq.'all') then
      open(unit=lfncub,file=filcub(1:index(filcub,' ')-1),
     + form='formatted',status='unknown')
      rewind(lfncub)
      write(lfncub,2003)
 2003 format('NWChem-DIANA generated Electrostatic Potential',/,
     + 'Coordinates converted to Angstrom')
      write(lfncub,2004) nsa,nm2au*xmin(1),nm2au*xmin(2),
     + nm2au*xmin(3)
 2004 format(i5,3f12.6)
      write(lfncub,2005) ngx,nm2au*spac(1),0.0d0,0.0d0
      write(lfncub,2005) ngy,0.0d0,nm2au*spac(2),0.0d0
      write(lfncub,2005) ngz,0.0d0,0.0d0,nm2au*spac(3)
 2005 format(i5,3f12.6)
      do 14 i=1,nsa
      write(lfncub,2006) iatmn(i),q(i),
     + nm2au*x(i,1),nm2au*x(i,2),nm2au*x(i,3)
 2006 format(i5,4f12.6)
   14 continue
      do 16 ix=1,ngx
      do 15 iy=1,ngy
      write(lfncub,1007) (g(ix,iy,iz),iz=1,ngz)
 1007 format(6e13.5)
   15 continue
   16 continue
      close(unit=lfncub)
      endif
c
c     write the x and y averaged potentials
c     -------------------------------------
c
      open(unit=lfnepz,file=filepz(1:index(filepz,' ')-1),
     + form='formatted',status='unknown')
      rewind(lfnepz)
      do 8 iz=1,ngz
      value=0.0d0
      do 9 iy=1,ngy
      do 10 ix=1,ngx
      value=value+g(ix,iy,iz)
   10 continue
    9 continue
      write(lfnepz,1005) xmin(3)+dble(iz-1)*spac(3),value/dble(ngx*ngy)
 1005 format(2f12.6)
    8 continue
      close(unit=lfnepz)
c
      if(.not.ma_verify_allocator_stuff())
     + print*,'ERROR IN ESPPLT'
      return
      end

      subroutine densid(dt,dold,dos,nsym,nosh,ncsh,nccup,c,damp,nconv,
     x                 nbas,nitscf,tlarge)
c.......................................................................
c
c     driver routine for density matrix processing
c.......................................................................
C$Id: densid.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
      real *8 dt(*), dold(*), dos(*), c(*)
      real *8 damp, tlarge
      integer ncsh(*), nosh(*), nccup(*),  nbas(*)
      integer nsym, nconv, nitscf
c
      real *8 vamp1, vamp2, occucl, occuop, ddiff
      integer k, nstep1, nstep2, nbas1, icount
      integer i, m, n, j
c
      nstep1 = 1
      nstep2 = 1
      k = 0
      vamp1 = 1.0d0
      vamp2 = 0.0d0
      if (nitscf.gt.1 .and. nconv.eq.0) vamp1 = 1.0d0 - damp
      if (nitscf.gt.1 .and. nconv.eq.0) vamp2 = damp
      do i = 1 , nsym
         occucl = 4*i - 2
         occuop = nccup(i)
         nbas1 = nbas(i)
         do m = 1 , nbas1
            do n = 1 , m
               k = k + 1
               dt(k) = 0.0d0
               dos(k) = 0.0d0
            enddo
         enddo
         if (ncsh(i).ne.0) call denmad(dt(nstep1),c(nstep2),ncsh(i),
     +                                 nbas1,occucl,1)
         if (nosh(i).ne.0) call denmad(dos(nstep1),c(nstep2),nosh(i),
     +                                 nbas1,occuop,ncsh(i)+1)
         nstep1 = nstep1 + nbas1*(nbas1+1)/2
         nstep2 = nstep2 + nbas1**2
      enddo
      tlarge = 0.0d0
      icount = 0
      do i = 1 , nsym
         do j = 1 , nbas(i)
            do k = 1 , j
               icount = icount + 1
               dt(icount) = (dt(icount)+dos(icount))
     +                      *vamp1 + dold(icount)*vamp2
               ddiff = dabs(dt(icount)-dold(icount))
               dold(icount) = dt(icount)
               if (ddiff.gt.tlarge) then
                  tlarge = ddiff
               end if
            enddo
         enddo
      enddo
      return
      end

*> \brief \b SORGQL
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SORGQL + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sorgql.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sorgql.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sorgql.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SORGQL( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, K, LDA, LWORK, M, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SORGQL generates an M-by-N real matrix Q with orthonormal columns,
*> which is defined as the last N columns of a product of K elementary
*> reflectors of order M
*>
*>       Q  =  H(k) . . . H(2) H(1)
*>
*> as returned by SGEQLF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix Q. M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix Q. M >= N >= 0.
*> \endverbatim
*>
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>          The number of elementary reflectors whose product defines the
*>          matrix Q. N >= K >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the (n-k+i)-th column must contain the vector which
*>          defines the elementary reflector H(i), for i = 1,2,...,k, as
*>          returned by SGEQLF in the last k columns of its array
*>          argument A.
*>          On exit, the M-by-N matrix Q.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The first dimension of the array A. LDA >= max(1,M).
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is REAL array, dimension (K)
*>          TAU(i) must contain the scalar factor of the elementary
*>          reflector H(i), as returned by SGEQLF.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The dimension of the array WORK. LWORK >= max(1,N).
*>          For optimum performance LWORK >= N*NB, where NB is the
*>          optimal blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument has an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realOTHERcomputational
*
*  =====================================================================
      SUBROUTINE SORGQL( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, IINFO, IWS, J, KK, L, LDWORK, LWKOPT,
     $                   NB, NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLARFB, SLARFT, SORG2L, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF( N.EQ.0 ) THEN
            LWKOPT = 1
         ELSE
            NB = ILAENV( 1, 'SORGQL', ' ', M, N, K, -1 )
            LWKOPT = N*NB
         END IF
         WORK( 1 ) = LWKOPT
*
         IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
            INFO = -8
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SORGQL', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         RETURN
      END IF
*
      NBMIN = 2
      NX = 0
      IWS = N
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'SORGQL', ' ', M, N, K, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'SORGQL', ' ', M, N, K, -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code after the first block.
*        The last kk columns are handled by the block method.
*
         KK = MIN( K, ( ( K-NX+NB-1 ) / NB )*NB )
*
*        Set A(m-kk+1:m,1:n-kk) to zero.
*
         DO 20 J = 1, N - KK
            DO 10 I = M - KK + 1, M
               A( I, J ) = ZERO
   10       CONTINUE
   20    CONTINUE
      ELSE
         KK = 0
      END IF
*
*     Use unblocked code for the first or only block.
*
      CALL SORG2L( M-KK, N-KK, K-KK, A, LDA, TAU, WORK, IINFO )
*
      IF( KK.GT.0 ) THEN
*
*        Use blocked code
*
         DO 50 I = K - KK + 1, K, NB
            IB = MIN( NB, K-I+1 )
            IF( N-K+I.GT.1 ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i+ib-1) . . . H(i+1) H(i)
*
               CALL SLARFT( 'Backward', 'Columnwise', M-K+I+IB-1, IB,
     $                      A( 1, N-K+I ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H to A(1:m-k+i+ib-1,1:n-k+i-1) from the left
*
               CALL SLARFB( 'Left', 'No transpose', 'Backward',
     $                      'Columnwise', M-K+I+IB-1, N-K+I-1, IB,
     $                      A( 1, N-K+I ), LDA, WORK, LDWORK, A, LDA,
     $                      WORK( IB+1 ), LDWORK )
            END IF
*
*           Apply H to rows 1:m-k+i+ib-1 of current block
*
            CALL SORG2L( M-K+I+IB-1, IB, IB, A( 1, N-K+I ), LDA,
     $                   TAU( I ), WORK, IINFO )
*
*           Set rows m-k+i+ib:m of current block to zero
*
            DO 40 J = N - K + I, N - K + I + IB - 1
               DO 30 L = M - K + I + IB, M
                  A( L, J ) = ZERO
   30          CONTINUE
   40       CONTINUE
   50    CONTINUE
      END IF
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of SORGQL
*
      END
c $Id: sorgql.f 24343 2013-06-22 05:35:15Z d3y133 $

*
* $Id: paw_matrix_comp_pot.F 25800 2014-06-12 21:26:33Z bylaska $
*

!**************************************************
!
!       name:
!
!       purpose 
!
!       created:        7/9/2002
!**************************************************
      subroutine  init_paw_comp_pot_matrix()
      implicit none

#include "mafdecls.fh"
#include "paw_basis.fh"
#include "paw_matrix_comp_pot.fh"
#include "paw_utils.fh"
#include "paw_ma.fh"


      !*** local variables ***
      logical ok
      integer it,tot_ntype
      integer mult_l
      integer nbasis
      integer mtr_size, matr_index

      tot_ntype = paw_basis_tot_ntype()
      ok = my_alloc(mt_int,tot_ntype,"i_paw_comp_pot_matrix",
     >              i_paw_comp_pot_matrix)
      ok = ok.and.
     >     my_alloc(mt_int,tot_ntype,"s_paw_comp_pot_matrix",
     >              s_paw_comp_pot_matrix)
      if (.not.ok)
     > call errquit(
     > "init_paw_paw_comp_pot_matrix: out of heap memory",0,1)
  

      !*** determine matrix size ***
      mtr_size = 0
      do it=1,tot_ntype
        nbasis = paw_basis_nbasis(it)
        mult_l  = paw_basis_mult_l(it)
        int_mb(s_paw_comp_pot_matrix(1)+it-1) = nbasis**2*(mult_l+1)
        mtr_size=mtr_size+int_mb(s_paw_comp_pot_matrix(1) + it - 1)
      end do
  
      !*** set the indexing to access diff atom types ***
      int_mb(i_paw_comp_pot_matrix(1) )  = 0
      do it=1,tot_ntype-1
        int_mb(i_paw_comp_pot_matrix(1) +it) = 
     >           int_mb(i_paw_comp_pot_matrix(1) + it - 1)
     >         + int_mb(s_paw_comp_pot_matrix(1) + it - 1)
      end do

      ok = my_alloc(mt_dbl,mtr_size,"paw_comp_pot_matrix",
     >                paw_comp_pot_matrix)
      if (.not.ok)
     > call errquit(
     > "init_paw_comp_pot_matrix: out of heap memory",0,1)
  
      do it=1,tot_ntype
    
        matr_index = int_mb(i_paw_comp_pot_matrix(1) +it-1)
        call find_comp_pot_matrix(
     >            int_mb(paw_basis_i_i_cut(it)),
     >            int_mb(paw_basis_i_ngrid(it)),
     >            int_mb(paw_basis_i_nbasis(it)),
     >            int_mb(paw_basis_i_orb_l(it)),
     >            paw_basis_mult_l(it),
     >            dbl_mb(paw_basis_i_log_amesh(it)),
     >            dbl_mb(paw_basis_i_rgrid(it)),
     >            dbl_mb(paw_basis_i_sigma(it)),
     >            dbl_mb(paw_basis_i_phi_ps(it)),
     >            dbl_mb(paw_comp_pot_matrix(1) + matr_index))
      end do

      return
      end !subroutine init_paw_comp_pot_matrix

      subroutine  end_paw_comp_pot_matrix()
      implicit none

#include "mafdecls.fh"
#include "paw_basis.fh"
#include "paw_matrix_comp_pot.fh"
#include "paw_utils.fh"
#include "paw_ma.fh"


      !*** local variables ***
      logical ok


      ok =        my_dealloc(i_paw_comp_pot_matrix)
      ok = ok.and.my_dealloc(s_paw_comp_pot_matrix)
      ok = ok.and.my_dealloc(paw_comp_pot_matrix)
      if (.not.ok)
     > call errquit(
     > "end_paw_comp_pot_matrix: error freeing heap",0,0)

      return
      end !subroutine end_paw_comp_pot_matrix

!*************************************************
!
!   name :   find_comp_pot_matrix
!
!
!   purpose :
!
!
!   created :
!
!*************************************************
      subroutine find_comp_pot_matrix( ic,
     >                        ngrid,
     >                        nbasis,
     >                        orb_l,
     >                        mult_l,
     >                        log_amesh,
     >                        r,
     >                        sigma,
     >                        phi_ps,
     >                        matrix)
      implicit none

      integer    ic
      integer    ngrid
      integer    nbasis
      integer    orb_l(nbasis)
      integer    mult_l

      double precision log_amesh
      double precision  r(ngrid)
      double precision  sigma
      double precision phi_ps(ngrid,nbasis)
      double precision matrix(nbasis,nbasis,mult_l+1)

#include "mafdecls.fh"
#include "integrate.fh"
#include "paw_utils.fh"
#include "paw_ma.fh"

      !*** local variables ***
      logical  ok
      integer  i,j,ii
      integer  la
      integer  power_r
      integer  i_f1,l_f1
      integer  i_f2,l_f2
      integer p1,p2
      double precision tmp


      power_r = 0

      !*** temporary array for calculatcomp_charges ***
      ok = ma_push_get(mt_dbl,ic,"tmp_array1",l_f1,i_f1)
      ok = ma_push_get(mt_dbl,ic,"tmp_array2",l_f2,i_f2)

      do la=0,mult_l
    
        call find_gaussian_rspace_array(la,sigma,ic,r,
     >                                  dbl_mb(i_f1))

        do ii=1,ic
        dbl_mb(i_f1+ii-1) =  dbl_mb(i_f1+ii-1)*r(ii)*r(ii)
        end do

          p1       = la +2
          p2       = 2*la + 2

        do i=1,nbasis
        do j=1,i

          do ii=1,ic
          dbl_mb(i_f2+ii-1) =  phi_ps(ii,i)*phi_ps(ii,j)
          end do

          tmp = find_multipole_energy(la,ic,r,
     >                                p1,dbl_mb(i_f1),
     >                                p2,dbl_mb(i_f2),log_amesh)

          matrix(i,j,la+1) = tmp
          matrix(j,i,la+1) = tmp

        end do
        end do

      end do

      ok = ma_chop_stack(l_f1)

      return
      end !subroutine find_comp_pot_matrix


      subroutine  find_gaussian_rspace_array(l,sigma_tmp,nr,r_tmp,gl)
      implicit none
      integer  l
      integer  nr
      double precision sigma_tmp
      double precision r_tmp(*)
      double precision gl(*)

#include "paw_params.fh"

      !*** local variables ***
      integer ii
      double precision  c
  
      double precision double_factorial
      external double_factorial


      c = 2**(l+2)/(sqrt(pi)*double_factorial(2*l+1)*sigma_tmp**(2*l+3))

      !*** this fixes possible underflow error ***
      do ii=1,nr
        gl(ii) = 0.0d0
      end do


      do ii=1,nr
        if (dabs(r_tmp(ii)) .lt. 8.0d0*sigma_tmp)
     >    gl(ii) = c*r_tmp(ii)**l*exp(-(r_tmp(ii)/sigma_tmp)**2)
      end do


      return
      end 

      program testbasis
c $Id: testbasis.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
c
#include "nwc_const.fh"
#include "bas.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "geom.fh"
#include "inp.fh"
#include "stdio.fh"
c
c::friends functions
      logical bas_ucontinfo
      logical bas_getu_exponent
      logical bas_getu_coeff
      logical bas_setu_exponent
      logical bas_setu_coeff
      external bas_ucontinfo
      external bas_getu_exponent
      external bas_getu_coeff
      external bas_setu_exponent
      external bas_setu_coeff
c
      integer rtdb, geom, basis, ngen,nprim, iang
*      integer ncenters
      integer sphcart, i,j
      integer nbf,ibf,iat,icont, type
      character*256 namename, nametrans
*      character*16 drivtags(20)
*      double precision coords(3,20), charge(20)
      integer lexcf
      parameter (lexcf=400)
      double precision exp(lexcf), coeff(lexcf)
      logical status
      double precision expnt_new(3), coeff_new(4,3)
      logical bas_add_ucnt, bas_geobas_build
      external bas_add_ucnt, bas_geobas_build
      data expnt_new/1., 2., 3./
      data coeff_new/-1., -2., -3., 0.0, -4., -5., -6., 0.0, -7., -8.,
     $     -9., 0.0/
c
      if (.not. ma_init(MT_DBL, 400 000, 400 000))
     &      call errquit('testbasis: ma_init failed',911, MA_ERR)

      status = rtdb_open('testbasis.rtdb','empty', rtdb)
      if (.not.status) call errquit
     &      ('testbasis rtdb open failed',911, RTDB_ERR)
c
c      write(luout,*)' rtdb handle ', rtdb
*old      status = bas_321g_load(rtdb)
c
      open(unit=luin,file='testbasis.nw',
     &      form='formatted',
     &      access='sequential',
     &      status='old',
     &      err=99565)
      call input_parse(rtdb)
c
      if(.not.geom_create(geom,'geometry')) then
        write(LuOut,*)' error getting geometry handle '
        stop ' error '
      endif
c
      if(.not.geom_rtdb_load(rtdb,geom,'geometry'))
     &      call errquit('error loading geometry',911, GEOM_ERR)
      status=geom_print(geom)
c
      basis = 0
      if(.not.bas_create(basis,'xy basis')) then
        write(LuOut,*)' error getting basis handle '
        stop ' error '
      endif
      basis = 0
      if(.not.bas_create(basis,'wz basis')) then
        write(LuOut,*)' error getting second basis handle '
        stop ' error '
      endif
      basis = 0
      if(.not.bas_create(basis,'ao basis')) then
        write(LuOut,*)' error getting third basis handle '
        stop ' error '
      endif
c
c
      status = bas_rtdb_load(rtdb,geom,basis,'ao basis')
      status = bas_print(basis)
      status = gbs_map_print(basis)
c
      status = bas_continfo(basis,1,iang,nprim,ngen,sphcart)
      write(LuOut,*)' user:query: status  cont 1 ',status
      write(LuOut,*)' user:query: type    cont 1 ',iang
      write(LuOut,*)' user:query: nprim   cont 1 ',nprim
      write(LuOut,*)' user:query: ngen    cont 1 ',ngen
      write(LuOut,*)' user:query: sphcart cont 1 ',sphcart
      if (nprim*ngen.gt.lexcf) call errquit
     &      (' lexcf too small ',(nprim*ngen), BASIS_ERR)
      call dfill(lexcf,0.0d00,exp  ,1)
      call dfill(lexcf,0.0d00,coeff,1)
      status = bas_get_exponent(basis,1,exp)
      status = bas_get_coeff(basis,1,coeff)
      write(LuOut,*)' user exponenents and coefficients '
      do 00100 i=1,nprim
        write(LuOut,*)exp(i),(coeff(i+(j-1)*nprim),j=1,ngen)
00100 continue
c
      status = bas_ucontinfo(basis,1,type,nprim,ngen,sphcart)
      write(LuOut,*)' unique:query: status  cont 1 ',status
      write(LuOut,*)' unique:query: type    cont 1 ',type
      write(LuOut,*)' unique:query: nprim   cont 1 ',nprim
      if (nprim*ngen.gt.lexcf) call errquit
     &      (' lexcf too small ',(nprim*ngen), BASIS_ERR)
      write(LuOut,*)' unique:query: ngen    cont 1 ',ngen
      write(LuOut,*)' unique:query: sphcart cont 1 ',sphcart
      call dfill(lexcf,0.0d00,exp  ,1)
      call dfill(lexcf,0.0d00,coeff,1)
      status = bas_getu_exponent(basis,1,exp)
      status = bas_getu_coeff(basis,1,coeff)
      write(LuOut,*)' unique exponenents and coefficients '
      do 00200 i=1,nprim
        write(LuOut,*)exp(i),(coeff(i+(j-1)*nprim),j=1,ngen)
00200 continue
c
      exp(1) = 565.6589
      coeff(1) = 6.021023
      status = bas_setu_exponent(basis,1,exp,(nprim+1))
      status = bas_setu_coeff(basis,1,coeff,(nprim*ngen)+1)
      status = bas_setu_exponent(basis,1,exp,nprim)
      status = bas_setu_coeff(basis,1,coeff,nprim*ngen)
c
c
      status = bas_ucontinfo(basis,1,type,nprim,ngen,sphcart)
      write(LuOut,*)' modified '
      write(LuOut,*)' unique:query: status  cont 1 ',status
      write(LuOut,*)' unique:query: type    cont 1 ',type
      write(LuOut,*)' unique:query: nprim   cont 1 ',nprim
      write(LuOut,*)' unique:query: ngen    cont 1 ',ngen
      write(LuOut,*)' unique:query: sphcart cont 1 ',sphcart
      if (nprim*ngen.gt.lexcf) call errquit
     &      (' lexcf too small ',(nprim*ngen), BASIS_ERR)
      status = bas_getu_exponent(basis,1,exp)
      status = bas_getu_coeff(basis,1,coeff)
      write(LuOut,*)' exponenents and coefficients '
      do 00300 i=1,nprim
        write(LuOut,*)exp(i),(coeff(i+(j-1)*nprim),j=1,ngen)
00300 continue
c
c
c     Try adding new contractions on an existing center
c
      write(LuOut,*) ' adding 3*3 d function on H'
      if (.not. bas_add_ucnt(basis, 'H', 2, 3, 3, expnt_new,
     &    expnt_new, coeff_new, 4, 'none', .false.))
     &    write(LuOut,*) ' basis_add_ucnt failed'
      if (.not. bas_print(basis)) write(LuOut,*) ' print ?'
c
c     Try adding new contractions on a new center
c
      write(LuOut,*) ' adding 2*3 g function on Cl'
      if (.not. bas_add_ucnt(basis, 'Cl', 4, 2, 3, expnt_new,
     $     expnt_new,coeff_new, 4, 'none', .false.))
     &    write(LuOut,*) ' basis_add_ucnt failed'
      if (.not. bas_print(basis)) write(LuOut,*) ' print ?'
c
c
      write(LuOut,'(///,1x,a)')' bas_print_all '
      status = bas_print_all()
      call bas_err_info(' testbasis bas_err_info info ')
c
      status = bas_high_angular(basis,iang)
      write(LuOut,*)' high angular momentum ', iang
      status = bas_version()
      namename = ' '
      nametrans = ' '
      status = bas_name(basis,namename, nametrans)
      write(LuOut,*)' handle         :  ',basis, status
      i = inp_strlen(namename)
      write(LuOut,'(a,a,a)')' name           : <',
     &       namename(1:i),'>'
      i = inp_strlen(nametrans)
      write(LuOut,*)' translated name: <',
     &       nametrans(1:i),'>'
c
      write(LuOut,*)' basis function to ce/cn check '
      status = bas_numbf(basis,nbf)
      do 00400 ibf=1,nbf
        status = bas_bf2ce(basis,ibf,iat)
        status = bas_bf2cn(basis,ibf,icont)
        write(LuOut,*)' basis function ',ibf,
     &            ' is on center ',iat,
     &         ' and in contraction',icont
00400 continue
c
      status = bas_geobas_build(basis)
      write(LuOut,*)' basis handle ',basis
      call bas_geomap_check(basis)
c
      status = bas_nbf_cn_max(basis,nbf)
      write(LuOut,*)' max block of nbf on a shell for basis is:',nbf
c
      status = bas_nbf_ce_max(basis,nbf)
      write(LuOut,*)' max block of nbf on an atom for basis is:',nbf
c
      status = bas_ncoef_cn_max(basis,nbf)
      write(LuOut,*)' max num coefs in any contraction ',nbf
c
      status = bas_nprim_cn_max(basis,nbf)
      write(LuOut,*)' max num prims in any contraction ',nbf
c
c
      stop ' testbasis done '
99565 continue
      stop ' error opening testbasis.nw'
      end
      subroutine bas_geomap_check(basisin)
      implicit none
#include "nwc_const.fh"
#include "bas.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "mafdecls.fh"
#include "bas_ibs_dec.fh"
#include "geom.fh"
#include "stdio.fh"
c
      integer basisin
c
      logical status
      integer basis, geom
      integer ncont, icont, ucont, ucont2
      integer cent_api, cent_sf, cent_mb
      integer inat, nat, atom_sf, atom_mb
      integer bflo_api, bflo_sf, bflo_mb
      integer bfhi_api, bfhi_sf, bfhi_mb
      integer cnlo_api, cnlo_sf, cnlo_mb
      integer cnhi_api, cnhi_sf, cnhi_mb
c
#include "bas_ibs_sfn.fh"
c
      status = bas_geom(basisin,geom)
      basis = basisin + BASIS_HANDLE_OFFSET
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' basis geometry mapping checks '
      write(LuOut,*)' basis handle is    :',basisin
      write(LuOut,*)' geometry handle is :',geom
      write(LuOut,*)' '
      write(LuOut,*)' current memory heap pointers'
      write(LuOut,*)' ibs_cn2ucn ma handle :',ibs_cn2ucn(H_ibs,basis)
      write(LuOut,*)' ibs_cn2ucn ma pointer:',ibs_cn2ucn(K_ibs,basis)
      write(LuOut,*)' ibs_cn2ucn size      :',ibs_cn2ucn(SZ_ibs,basis)
      write(LuOut,*)' '
      write(LuOut,*)' ibs_cn2ce ma handle  :',ibs_cn2ce(H_ibs,basis)
      write(LuOut,*)' ibs_cn2ce ma pointer :',ibs_cn2ce(K_ibs,basis)
      write(LuOut,*)' ibs_cn2ce size       :',ibs_cn2ce(SZ_ibs,basis)
      write(LuOut,*)' '
      write(LuOut,*)' ibs_ce2uce ma handle :',ibs_ce2uce(H_ibs,basis)
      write(LuOut,*)' ibs_ce2uce ma pointer:',ibs_ce2uce(K_ibs,basis)
      write(LuOut,*)' ibs_ce2uce size      :',ibs_ce2uce(SZ_ibs,basis)
      write(LuOut,*)' '
      write(LuOut,*)' ibs_cn2bfr ma handle :',ibs_cn2bfr(H_ibs,basis)
      write(LuOut,*)' ibs_cn2bfr ma pointer:',ibs_cn2bfr(K_ibs,basis)
      write(LuOut,*)' ibs_cn2bfr size      :',ibs_cn2bfr(SZ_ibs,basis)
      write(LuOut,*)' '
      write(LuOut,*)' ibs_ce2cnr ma handle :',ibs_ce2cnr(H_ibs,basis)
      write(LuOut,*)' ibs_ce2cnr ma pointer:',ibs_ce2cnr(K_ibs,basis)
      write(LuOut,*)' ibs_ce2cnr size      :',ibs_ce2cnr(SZ_ibs,basis)
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' '
c
      status = bas_numcont(basisin,ncont)
      status = geom_ncent(geom,nat)
      write(LuOut,*)' total number of contractions is ',ncont
      write(LuOut,*)' total number of centers      is ',nat
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' cont 2 uniq cont check '
      do icont = 0,ncont
        ucont = 23234
        ucont2 = ucont
        ucont = sf_ibs_cn2ucn(icont,basis)
        ucont2 = int_mb(mb_ibs_cn2ucn(icont,basis))
        write(LuOut,'(a,i5,a,i5,i5)')
     &        ' contraction ',icont,
     &        ' maps to unique contraction ',ucont,ucont2
      enddo

      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' cont 2 center check '
      do icont = 0,ncont
        status = bas_cn2ce(basisin,icont,cent_api)
        cent_sf = sf_ibs_cn2ce(icont,basis)
        cent_mb = int_mb(mb_ibs_cn2ce(icont,basis))
        write(LuOut,'(a,i5,a,3i5,a)')
     &        ' contraction ',icont,' is on center ',
     &        cent_api,cent_sf,cent_mb,
     &        ' ... (sould be 3 identical numbers)'
      enddo
c
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' center 2 unique center check '
      do inat = 1,nat
        atom_sf = sf_ibs_ce2uce(inat,basis)
        atom_mb = int_mb(mb_ibs_ce2uce(inat,basis))
        write(LuOut,'(a,i5,a,2i5,a)')
     &        ' center ',inat,
     &        ' maps to unique center/tag ',atom_sf,atom_mb,
     &        ' ... (sould be 2 identical numbers)'
      enddo
c
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' contraction 2 basis function range '
      do icont = 1,ncont
        status = bas_cn2bfr(basisin,icont,bflo_api,bfhi_api)
        bflo_sf = sf_ibs_cn2bfr(1,icont,basis)
        bfhi_sf = sf_ibs_cn2bfr(2,icont,basis)
        bflo_mb = int_mb(mb_ibs_cn2bfr(1,icont,basis))
        bfhi_mb = int_mb(mb_ibs_cn2bfr(2,icont,basis))
        write(LuOut,'(a,i5,a,6i5,a)')
     &        ' contraction ',icont,
     &        ' maps to range of basis functions ',
     &        bflo_api,bfhi_api,bflo_sf,bfhi_sf,bflo_mb,bfhi_mb,
     &        ' ... (sould be 3 sets identical numbers)'
      enddo
c
      write(LuOut,*)' '
      write(LuOut,*)' '
      write(LuOut,*)' center 2 contraction range '
      do inat = 1,nat
        status = bas_ce2cnr(basisin,inat,cnlo_api,cnhi_api)
        cnlo_sf = sf_ibs_ce2cnr(1,inat,basis)
        cnhi_sf = sf_ibs_ce2cnr(2,inat,basis)
        cnlo_mb = int_mb(mb_ibs_ce2cnr(1,inat,basis))
        cnhi_mb = int_mb(mb_ibs_ce2cnr(2,inat,basis))
        write(LuOut,'(a,i5,a,6i5,a)')
     &        ' center ',inat,
     &        ' maps to range of contractons',
     &        cnlo_api,cnhi_api,cnlo_sf,cnhi_sf,cnlo_mb,cnhi_mb,
     &        ' ... (sould be 3 sets identical numbers)'
      enddo
c
      end

      logical function pre_imp(latm,matm,natm,lbnd,mbnd,nbnd,
     + limp,mimp,nimp)
c
c $Id: pre_imp.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
#include "pre_common.fh"
c
      integer matm,natm,mbnd,nbnd,mimp,nimp
      integer latm(6,matm),lbnd(2,mbnd),limp(4,mimp)
c
      integer i,j,k,l,ltemp,na
      integer ia(10),nia(10)
c
      nimp=0
c
c     loop over all atoms
c
      do 1 i=1,natm
      if(latm(2,i).gt.0) then
c
c     count the number of bonds to this atom
c
      na=0
      do 2 j=1,nbnd
      if(lbnd(1,j).eq.i) then
      na=na+1
      ia(na)=lbnd(2,j)
      endif
      if(lbnd(2,j).eq.i) then
      na=na+1
      ia(na)=lbnd(1,j)
      endif
    2 continue
c
      nia(1)=0
      nia(2)=0
      nia(3)=0
      do 54 k=1,nbnd
      if(lbnd(1,k).eq.ia(1)) nia(1)=nia(1)+1
      if(lbnd(2,k).eq.ia(1)) nia(1)=nia(1)+1
      if(lbnd(1,k).eq.ia(2)) nia(2)=nia(2)+1
      if(lbnd(2,k).eq.ia(2)) nia(2)=nia(2)+1
      if(lbnd(1,k).eq.ia(3)) nia(3)=nia(3)+1
      if(lbnd(2,k).eq.ia(3)) nia(3)=nia(3)+1
   54 continue
      do 55 k=1,2
      do 56 l=2,3
      if(nia(k).lt.nia(l)) then
      ltemp=nia(k)
      nia(k)=nia(l)
      nia(l)=ltemp
      ltemp=ia(k)
      ia(k)=ia(l)
      ia(l)=ltemp
      endif
   56 continue
   55 continue
c
c     planar
c
      if(latm(2,i).eq.1.and.na.eq.3) then
      nimp=nimp+1
      limp(1,nimp)=i
      limp(2,nimp)=ia(1)
      limp(3,nimp)=ia(2)
      limp(4,nimp)=ia(3)
      endif
c
c     chiral
c
      if((latm(2,i).eq.2.or.latm(2,i).eq.3).and.na.eq.3) then
      nimp=nimp+1
      limp(1,nimp)=i
      limp(2,nimp)=ia(1)
      limp(3,nimp)=ia(2)
      limp(4,nimp)=ia(3)
      endif
c
c     aromatic ring
c
      if(latm(2,i).ge.4.and.na.eq.3.and.
     + ((ffield(1:5).eq.'amber'.and.latm(2,i).le.6).or.
     + (ffield(1:5).eq.'charm'))) then
      nimp=nimp+1
      limp(1,nimp)=i
      limp(2,nimp)=ia(1)
      limp(3,nimp)=ia(2)
      limp(4,nimp)=ia(3)
      endif
c
      endif
    1 continue
c
      pre_imp=.true.
c
      return
      end

c
c     $Id: c_cgsd_energy_gradient.F 24489 2013-08-08 20:12:41Z bylaska $         c

*     *******************************
*     *				    *
*     *	  c_cgsd_energy_gradient    *
*     *				    *
*     *******************************

      subroutine c_cgsd_energy_gradient(G1)
      implicit none
      real*8 G1(3,*)

#include "stdio.fh"
#include "util.fh"

*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)

      logical allow_translation,oprint,hprint
      integer i,k,nion
      real*8  GG,fmax,fatom
      real*8  fmx,fmy,fmz
      real*8  fmx2,fmy2,fmz2

*     **** external functions ****
      logical     cpsp_semicore,control_print
      logical     control_allow_translation,ion_q_FixIon
      character*4 ion_aname
      integer     ion_katm,ion_nion,control_version
      real*8      ion_rion
      external cpsp_semicore,control_print
      external control_allow_translation,ion_q_FixIon
      external ion_aname
      external ion_katm,ion_nion,control_version
      external ion_rion
      logical  ion_disp_on
      external ion_disp_on


      allow_translation = control_allow_translation()
      nion = ion_nion()

      call dcopy(3*nion,0.0d0,0,G1,1)

      call cpsi_1force(G1)
      if (cpsp_semicore(0)) call c_electron_semicoreforce(G1)

      call ewald_f(G1)
      if (ion_disp_on()) call ion_disp_force(G1)

*     **** remove ion forces using ion_FixIon ****
      call ion_FixIon(G1)


      if (.not.allow_translation) then
        call center_F_mass(G1,fmx,fmy,fmz)
        do i=1,nion
         G1(1,i) = G1(1,i) - fmx
         G1(2,i) = G1(2,i) - fmy
         G1(3,i) = G1(3,i) - fmz
        end do
      end if
      call center_F_mass(G1,fmx2,fmy2,fmz2)

      GG   = 0.0d0
      fmax = 0.0d0
      do i=1,nion
         GG = GG + G1(1,i)**2 + G1(2,i)**2 + G1(3,i)**2
         fatom= dsqrt(G1(1,i)**2 + G1(2,i)**2 + G1(3,i)**2)
         if (fatom.gt.fmax) fmax = fatom
      end do

      call Parallel_taskid(taskid)
      hprint = ((taskid.eq.MASTER).and.control_print(print_high))
      oprint = ((taskid.eq.MASTER).and.control_print(print_medium))


      if (oprint) then
        write(luout,1300)
        write(luout,1301)
        write(luout,1302)
        write(luout,1304)
        if (.not.allow_translation) write(luout,1400) fmx,fmy,fmz
        write(luout,1304)
        write(luout,1410)
        if (hprint) then
           write(luout,1420)
           do I=1,ion_nion()
             if (ion_q_FixIon(I)) then
              write(6,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3)
             else
              write(6,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3)
             end if
           end do
        end if
        write(luout,1421)
        write(luout,1190)(i,ion_aname(I),
     >                  (G1(K,I),K=1,3),I=1,ion_nion())

        write(luout,1210) fmx2,fmy2,fmz2  
        write(luout,1425)
        write(luout,1426) dsqrt(GG),
     >                    dsqrt(GG)/dble(nion),
     >                    fmax,fmax*(27.2116d0/0.529177d0)
      end if

c     call dscal(3*nion,(-1.0d0),G1,1)

      return
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' )')
 1191 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - fixed')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1300 FORMAT(//'========================')
 1301 FORMAT(  '= Gradient calculation =')
 1302 FORMAT(  '========================')
 1304 FORMAT(/)
 1400 FORMAT('Translation force removed: (',3F11.5,')')
 1410 FORMAT(10X,'=============  Ion Gradients =================')
 1420 FORMAT( ' Ion Positions:')
 1421 FORMAT( ' Ion Forces:')
 1425 FORMAT(10X,'===============================================')
 1426 FORMAT(10X,'|F|       =',E15.6,
     >      /10x,'|F|/nion  =',E15.6,
     >      /10x,'max|Fatom|=',E15.6,1x,'(',F8.3,'eV/Angstrom)'//)
      end

      subroutine cis_xdiagon(size_x1,k_x1_offset,d_r1,omega,residual)
c
c $Id: cis_xdiagon.F 24030 2013-04-11 18:00:58Z edo $
c
c     Form a subspace matrix and diagonalize
c
      implicit none
#include "stdio.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
#include "errquit.fh"
#include "util.fh"
      integer size_x1,size_x2
      integer k_x1_offset
      integer d_r1
      double precision omega(*)
      double precision residual(*)
      double precision overlap
      logical nodezero
      integer ivec, jvec
      integer l_hbar, k_hbar
      integer l_vr, k_vr
      integer l_vl, k_vl
      integer l_ei, k_ei
      integer l_wk, k_wk
      integer info
      integer newnxtrials
      double precision ddotfile
      external ddotfile
      double precision au2ev   ! Conversion factor from a.u. to eV
      parameter (au2ev=27.2113961d0)
      character*255 filename
      double precision cpu, wall
      double precision cpu1, wall1
      double precision cpu2, wall2
c      logical hbar_restore
c      external hbar_restore
c      double precision hbar
c
      nodezero = (ga_nodeid().eq.0)
c
c     Allocate
c
c
      if (.not.ma_push_get(mt_dbl,nxtrials*nxtrials,'hbar',
     1  l_hbar,k_hbar)) call errquit('tce_eom_xdiagon: MA problem',0,
     2  MA_ERR)
      if (.not.ma_push_get(mt_dbl,nxtrials*nxtrials,'vr',
     1  l_vr,k_vr)) call errquit('tce_eom_xdiagon: MA problem',1,
     2  MA_ERR)
      if (.not.ma_push_get(mt_dbl,nxtrials,'vl',
     1  l_vl,k_vl)) call errquit('tce_eom_xdiagon: MA problem',2,
     2  MA_ERR)
      if (.not.ma_push_get(mt_dbl,nxtrials,'ei',
     1  l_ei,k_ei)) call errquit('tce_eom_xdiagon: MA problem',4,
     2  MA_ERR)
      if (.not.ma_push_get(mt_dbl,4*nxtrials,'work',
     1  l_wk,k_wk)) call errquit('tce_eom_xdiagon: MA problem',5,
     2  MA_ERR)
c
c     Form similarity transformed Hamiltonian subspace matrix
c
c     cpu = - util_cpusec()
c     wall = - util_wallsec()
      cpu1 = 0.0d0
      wall1 = 0.0d0
      cpu2 = 0.0d0
      wall2 = 0.0d0
      do ivec = 1, nxtrials
        if(.not.x1_exist(ivec))
     1    call errquit('cis_xdiagon: x1 not found',ivec,
     2      unknown_err)
        do jvec = 1, nxtrials
          cpu = - util_cpusec()
          wall = - util_wallsec()
          dbl_mb(k_hbar+(ivec-1)*nxtrials+jvec-1) = 0.0d0
          if (.not.xp1_exist(jvec))
     1      call errquit('ci_xdiagon: xp1 not found',jvec,
     2          UNKNOWN_ERR)
          dbl_mb(k_hbar+(ivec-1)*nxtrials+jvec-1) = 
     1    dbl_mb(k_hbar+(ivec-1)*nxtrials+jvec-1) + 
     2    ddotfile(x1(jvec),xp1(ivec),size_x1)
        enddo
      enddo
      if (nodezero.and.util_print('hbar',print_debug)) then
        write(LuOut,*)
        call ma_print(dbl_mb(k_hbar),nxtrials,nxtrials,
     1    "Similarity Transformed Hamiltonian")
      endif
c
c     Diagonalize the non-Hermitian matrix
c
      cpu = - util_cpusec()
      wall = - util_wallsec()
      call util_dgeev('n','v',nxtrials,dbl_mb(k_hbar),nxtrials,
     1  omega,dbl_mb(k_ei),dbl_mb(k_vl),1,dbl_mb(k_vr),nxtrials,
     2  dbl_mb(k_wk),4*nxtrials,info)
      if (info.ne.0) call errquit('tce_eom_xdiagon: dgeev failed',info,
     1  UNKNOWN_ERR)
      call util_nwsort(nxtrials,omega,dbl_mb(k_vr),'A')
      if (nodezero.and.util_print('omega',print_debug)) then
        do ivec = 1, nxtrials
          write(LuOut,9000) omega(ivec),omega(ivec)*au2ev
        enddo
      endif
      cpu = cpu + util_cpusec()
      wall = wall + util_wallsec()
      if (nodezero.and.util_print('eomtime',print_debug)) then
        write(LuOut,9020) 'DGEEV & SORT',cpu, wall
        call util_flush(LuOut)
      endif
      if (nodezero.and.util_print('vectors',print_debug)) then
        call ma_print(dbl_mb(k_vr),nxtrials,nxtrials,'Eigenvectors')
      endif
c
c     Compute residuals
c
      newnxtrials = nxtrials
      do ivec = 1, nroots_reduced
        if (nodezero.and.util_print('eomtime',print_debug)) then
          write(LuOut,9030) ivec
          call util_flush(LuOut)
        endif
        cpu = - util_cpusec()
        wall = - util_wallsec()
        residual(ivec) = 0.0d0
        call tce_zero(d_r1,size_x1)
        call daxpyfile(nxtrials,dbl_mb(k_vr+(ivec-1)*nxtrials),
     1     xp1,d_r1,size_x1)
        call dfill(nxtrials,0.0d0,dbl_mb(k_ei),1)
        call daxpy(nxtrials,-omega(ivec),
     1      dbl_mb(k_vr+(ivec-1)*nxtrials),1,dbl_mb(k_ei),1)
        call daxpyfile(nxtrials,dbl_mb(k_ei),
     1     x1,d_r1,size_x1)
        residual(ivec) = residual(ivec) 
     1                 + ddotfile(d_r1,d_r1,size_x1)
        if (nodezero.and.util_print('residual',print_debug)) then
          write(LuOut,*) ' X1: vector',ivec
          write(LuOut,*) ' X1: residual',residual(ivec)
          call sf_print(d_r1,size_x1)
        endif
        residual(ivec) = dsqrt(residual(ivec))
        if (nodezero.and.util_print('residual',print_debug)) then
          write(LuOut,*) ivec,' residual',residual(ivec)
        endif
        cpu = cpu + util_cpusec()
        wall = wall + util_wallsec()
        if (nodezero.and.util_print('eomtime',print_debug)) then
          write(LuOut,9020) 'RESIDUAL',cpu, wall
          call util_flush(LuOut)
        endif
c
c       New trial vectors
c
        cpu = - util_cpusec()
        wall = - util_wallsec()
        if (residual(ivec).gt.thresh) then
          if (newnxtrials.ge.maxtrials) call errquit
     1      ('cis_xdiagon: nxtrials exceeded maxtrials',newnxtrials,
     2      UNKNOWN_ERR)
          call tce_jacobi_x1(d_r1,k_x1_offset)
          call dscalfile(1.0d0/residual(ivec),d_r1,size_x1)
          do jvec = 1, newnxtrials
            overlap = 0.0d0
            overlap=overlap+ddotfile(d_r1,x1(jvec),size_x1)
            call daxpyfile(1,-overlap,x1(jvec),d_r1,size_x1)
          enddo
          overlap = 0.0d0
          overlap=overlap+ddotfile(d_r1,d_r1,size_x1)
          overlap = dsqrt(overlap)
          call dscalfile(1.0d0/overlap,d_r1,size_x1)
          if (overlap.gt.thresh) then
            newnxtrials = newnxtrials + 1
            call tce_filenameindexed(newnxtrials,'x1',filename)
            call createfile(filename,x1(newnxtrials),size_x1)
            call gatoeaf(x1(newnxtrials))
            call copyfile(d_r1,x1(newnxtrials),size_x1)
            call gatodra(x1(newnxtrials))
            x1_exist(newnxtrials) = .true.
          endif
        else
          call tce_zero(d_r1,size_x1)
          call daxpyfile(nxtrials,dbl_mb(k_vr+(ivec-1)*nxtrials),
     1        x1,d_r1,size_x1)
          if (.not.xc1_exist(ivec)) then
             call tce_filenameindexed(ivec,'xc1',filename)
             call createfile(filename,xc1(ivec),size_x1)
             xc1_exist(ivec)=.true.
          end if
          call gatoeaf(xc1(ivec))
          call copyfile(d_r1,xc1(ivec),size_x1)
          call gatodra(xc1(ivec))
            
c             call tce_filenameindexed(ivec,'x1_ini',filename)
c          call createfile(filename,x1_ini(ivec),size_x1)
c          call gatoeaf(x1_ini(ivec))
c          call copyfile(d_r1,x1_ini(ivec),size_x1)
c          call gatodra(x1_ini(ivec))
c          x1_ini_exist(ivec) = .true.
c
c
        endif
        cpu = cpu + util_cpusec()
        wall = wall + util_wallsec()
        if (nodezero.and.util_print('eomtime',print_debug)) then
          write(LuOut,9020) 'NEW TRIAL',cpu, wall
          call util_flush(LuOut)
        endif
      enddo
      if (newnxtrials.eq.nxtrials) then
        do ivec = 1,nroots_reduced
          if (residual(ivec).gt.thresh)
     1      call errquit('cis_xdiagon: failed to extend subspace',0,
     2      CALC_ERR)
        enddo
      endif
      nxtrials = newnxtrials
c
c     Deallocate
c
      if (.not.ma_pop_stack(l_wk))
     1  call errquit('tce_eom_xdiagon: MA problem',6,MA_ERR)
      if (.not.ma_pop_stack(l_ei))
     1  call errquit('tce_eom_xdiagon: MA problem',7,MA_ERR)
      if (.not.ma_pop_stack(l_vl))
     1  call errquit('tce_eom_xdiagon: MA problem',9,MA_ERR)
      if (.not.ma_pop_stack(l_vr))
     1  call errquit('tce_eom_xdiagon: MA problem',10,MA_ERR)
      if (.not.ma_pop_stack(l_hbar))
     1  call errquit('tce_eom_xdiagon: MA problem',11,MA_ERR)
 9000 format(1x,f20.10,' hartree ',f20.10,' eV')
 9010 format(1x,'Root ',i3,' converged')
 9020 format(1x,A,' cpu:',f10.2,' wall:',f10.2)
 9030 format(1x,'IVEC = ',i3)
      return
      end

      SUBROUTINE list_shell(nshel,ntshel,shelatm)

      implicit none

      include 'p_array.inc'
      include 'p_input.inc'
      include 'cm_atom.inc'
      include 'cm_shel.inc'

      integer i,j,k
      integer nshel,ntshel,shelatm 

      dimension shelatm(mxshel,2)

      ntshel=0

      do i=1,natms

       do j=1,nshel

        if(atmtype(i).eq.shelatm(j,1))then

         ntshel=ntshel+1
         if(ntshel.gt.mxshel2)then
          write(output,*)'Increase mxshel2 to ',ntshel
          stop
         endif

         k=shelatm(j,2)-shelatm(j,1)
         if(typmol(atmtype(i)).ne.typmol(atmtype(i+k)))then
          write(output,*)'Shell and core must be from the same molecule'
          stop
         endif

         shllist(ntshel,1)=i
         shllist(ntshel,2)=i+k
         shllist(ntshel,3)=j

        endif

       enddo

      enddo
 
      return

      END
c $Id: list_shell.f 22502 2012-05-20 06:11:57Z d3y133 $

      program test
C$Id: testsolve.F 21459 2011-11-08 18:52:06Z d3p852 $
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "mafdecls.fh"
c
      logical status, ga_iter_lsolve, ga_iter_diag
      integer dim, n, g_a, g_b, g_soln, g_resid, i, j, iter, g_v
      integer iter_solve
      common /info/ n, g_a
      integer nroot, heap
      parameter (dim = 10, nroot=3)
      double precision col(dim), acc(nroot), tol, scale, sum
      double precision eval(nroot), used, junk
      double precision evals(dim)
      double precision drandm
      external drandm, ga_iter_lsolve, ga_iter_diag
      external test_precond, test_product
c
      n = dim
      call pbeginf
      heap = max(8, (dim-1)/nnodes()+1)
      heap = dim*(heap + 2)
      heap = heap * 1.1d0 + 128*128*3
      if (.not. ma_init(MT_DBL, heap, heap)) call errquit
     $     ('test: ma_init?', 0, MA_ERR)
      status = ma_set_auto_verify(.true.)
      call ga_initialize()
      write(6,*) ga_nodeid(), ' initialized'
      call util_flush(6)
      call ga_sync()
c

*      call testpcg

c     
c     create the arrays to test the linear equation solver
c
*ga:1:0
*     status = ga_create(MT_DBL, n, n, 'test:v', 0, 0, g_v)
*ga:1:0
      status = ga_create(MT_DBL, n, n, 'test:a', 0, 0, g_a)
      write(6,*) ga_nodeid(), ' created'
      call util_flush(6)
      call ga_sync()

*ga:1:0
*      status = ga_create(MT_DBL, n, 1, 'test:soln', 0, 0, g_soln)
*ga:1:0
*      status = ga_create(MT_DBL, n, 1, 'test:b', 0, 0, g_b)
*ga:1:0
*      status = ga_create(MT_DBL, n, 1, 'test:resid', 0, 0, g_resid)
      junk = drandm(ga_nodeid()*37*2 + 1)
      do i = ga_nodeid()+1, n, ga_nnodes()
         if (i .le. 3) then
            scale = 0.1d0
         else
            scale = 10.0d0
         endif
         col(i) = (1.0d0+0.4d0*(0.5d0 - drandm(0)))*scale
         if (i .gt. 3) scale = 1.0d0
         do j = i+1,n
            col(j) = 0.4d0*(0.5d0 - drandm(0))*scale
         enddo
         call ga_put(g_a, i, n, i, i, col(i), 1)
         call ga_put(g_a, i, i, i, n, col(i), 1)
      enddo
c
      used = -tcgtime()
      call ga_orthog(g_a, -999999, .false.)
      used = (used + tcgtime())
      if (ga_nodeid().eq.0) then
         write(6,*) ' new used ', used
         call util_flush(6)
      endif
*      call ga_dgemm('t','n',n,n,n,1.0d0,g_a, g_a, 0.0d0, g_v)
*      call ga_get_diagonal(g_v, col)
*      sum = ga_ddot(g_v, g_v)
*      if (ga_nodeid().eq.0) then
*         write(6,*) ' diagonal ', sum
*         call util_flush(6)
*      endif
      call ga_sync()
c
c     Add small amount of ranom noise in and call iterative orthog
c
      do i = ga_nodeid()+1, n, ga_nnodes()
         call ga_get(g_a, 1, n, i, i, col(1), 1)
         do j = 1, n
            col(j) = col(j) + 1.0d-8*(drandm(0)-0.5d0)
         enddo
         call ga_put(g_a, 1, n, i, i, col(1), 1)
      enddo
c
      used = -tcgtime()
      call ga_iter_orthog(-1, g_a, .false., .false.)
      used = (used + tcgtime())
      if (ga_nodeid().eq.0) then
         write(6,*) ' old used ', used
         call util_flush(6)
      endif
c      
      goto 10000
c
      if (ga_nodeid() .eq. 0) then
         do i = 1, n
            col(i) = 0.5d0 - drandm(0)
         enddo
         call ga_put(g_b, 1, n, 1, 1, col, 1)
      endif
c
      write(6,*) ' Solver WITHOUT projection'
      tol = 0.0001d0
      call ga_zero(g_soln)
      do iter = 1, 3
         if (ga_iter_lsolve(n, 40, 5, tol, test_precond,
     $        test_product, .true., .true., g_b, g_soln,
     $        acc, iter_solve)) then
            if (ga_nodeid() .eq. 0) write(6,*) ' OK'
         else
            if (ga_nodeid() .eq. 0) write(6,*) ' not OK'
         endif
         tol = tol*0.0001d0
      enddo
c
      write(6,*) ' Solver using projection'
      call ga_init_project(n, 3, 10, 10, 0.05d0, test_precond,
     $     test_product, .true., 0.1d0)
      tol = 0.0001d0
      call ga_zero(g_soln)
      do iter = 1, 3
         if (ga_iter_lsolve(n, 40, 5, tol, test_precond,
     $        test_product, .true., .true., g_b, g_soln, 
     $        acc, iter_solve)) then
            if (ga_nodeid() .eq. 0) write(6,*) ' OK'
         else
            if (ga_nodeid() .eq. 0) write(6,*) ' not OK'
         endif
         tol = tol*0.0001d0
      enddo
c
      call ga_term_project()
c
      call ga_diag_std_seq(g_a, g_v, evals)
      write(6,*) ' Correct evals'
      call output(evals, 1, n, 1, 1, n, 1, 1)
      tol = 0.01d0
c
      status = ga_destroy(g_soln)
*ga:1:0
      if (.not. ga_create(MT_DBL, n, 3, 'test:soln', 0, 0, g_soln))
     $     call errquit('gac failed', 0, GA_ERR)
c      
      call ga_zero(g_soln)
      do iter = 1, 3
         if (ga_iter_diag(n, nroot, 40, 10, tol, test_precond,
     $        test_product, .true., 0.0d0,
     $        g_soln, eval, acc, iter_solve)) then
            if (ga_nodeid() .eq. 0) write(6,*) ' OK'
         else
            if (ga_nodeid() .eq. 0) write(6,*) ' not OK'
         endif
         tol = tol*0.01d0
      enddo
c
      status = ga_destroy(g_resid)
      status = ga_destroy(g_b)
      status = ga_destroy(g_soln)
      status = ga_destroy(g_a)
      status = ga_destroy(g_v)
c      
10000 call ga_terminate
      call pend
c
      end
      subroutine test_product(acc, g_x, g_ax)
      implicit none
#include "global.fh"
      double precision acc
      integer g_x, g_ax
      integer n, g_a
      common /info/ n, g_a
c
      call ga_dgemm('n', 'n', n, 1, n, 1.0d0, g_a, g_x, 0.0d0, g_ax)
c
      end
      subroutine test_precond(g_r, shift)
      implicit none
#include "global.fh"
      integer n, g_a
      integer g_r
      common /info/ n, g_a
      double precision x, shift, denominator, numerator
      integer i
c
      call ga_sync()
      do i = ga_nodeid()+1, n, ga_nnodes()
         call ga_get(g_a, i, i, i, i, denominator, 1)
         call ga_get(g_r, i, i, 1, 1, numerator, 1)
         denominator = denominator - shift
         if (abs(denominator) .lt. 0.1d0) denominator =
     $        sign(0.1d0, denominator)
         x = numerator / denominator
         call ga_put(g_r, i, i, 1, 1, x, 1)
      enddo
c
      end
      double precision function drandm(iflag)
      implicit none
      integer iflag
#ifdef KSR
      integer irandm
      external irandm
      double precision scale
      parameter(scale=1.0d0/2147483647.0d0)
      drandm = scale*irandm(iflag)
#else
      double precision drand
      external drand
      drandm = drand(iflag)
#endif
      end
      subroutine testpcg
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
c
      integer n, ls_max
      parameter (n = 10, ls_max=20)
      integer iwork(10)
      double precision dwork(3*ls_max+5)
      integer g_grad, g_work, g_s, g_x, g_a
      double precision step
      double precision ls_tol
      parameter (ls_tol = 1.0d-2)
      double precision eacc
      parameter (eacc = 1.0d-10)
      character*16 mode
      integer i, iter, j
      double precision x, e, local(n)
      double precision drandm
      external drandm
      logical print, conjugacy, status
      data print /.true./, conjugacy /.true./
c
*ga:1:0
      if (.not. ga_create(MT_DBL, n, n, 'testpcg: matrix', 0, 0,
     $     g_a)) call errquit('testpcg: a', n, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, n, 1, 'testpcg: grad', 0, 0,
     $     g_grad)) call errquit('testpcg: grad', n, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, n, 1, 'testpcg: work', 0, 0,
     $     g_work)) call errquit('testpcg: work', n, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, n, 1, 'testpcg: step', 0, 0,
     $     g_s)) call errquit('testpcg: step', n, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, n, 1, 'testpcg: x', 0, 0,
     $     g_x)) call errquit('testpcg: step', n, GA_ERR)
c
c     Initial guess for solution x
c
      do i = ga_nodeid()+1, n, ga_nnodes()
         x = 0.1*drandm(0)
         call ga_put(g_x, i, i, 1, 1, x, 1)
      enddo
      call ga_sync
c
c     Fill in the matrix with something positive definite
c
      do i = ga_nodeid()+1, n, ga_nnodes()
         x = 0.0d0
         do j = 1,n
            local(j) = 0.1*drandm(0)
            x = x + local(j)
         enddo
         local(i) = 1.0d0 + x
         call ga_put(g_a, 1, n, i, i, local, n)
      enddo
      call ga_symmetrize(g_a)
      do i = 1, n
         call ga_get(g_a, i, i, i, i, local(i), 1)
      enddo
c      
      mode = 'startup'
 10   continue
      call ga_pcg_minim(n, iter, e, g_grad, g_work, g_s, step, ls_tol,
     $     ls_max, eacc, conjugacy, print, iwork, dwork, mode)
      if (mode .eq. 'energy+gradient') then
         call ga_sync
         call ga_dadd(step, g_s, 1.0d0, g_x, g_x)
         call ga_dgemm('n', 'n', n, 1, n, 1.0d0, g_a, g_x, 0.0d0,g_grad)
         e = 0.5d0*ga_ddot(g_x, g_grad)
         call ga_dadd(-step, g_s, 1.0d0, g_x, g_x)
         goto 10
      else if (mode .eq. 'precondition') then
         call ga_sync
         do i = ga_nodeid()+1, n, ga_nnodes()
            call ga_get(g_grad, i, i, 1, 1, x, 1)
            x = x/(local(i) + 2.0d0)
            call ga_put(g_work, i, i, 1, 1, x, 1)
         enddo
         call ga_sync
         goto 10
      else if (mode .eq. 'accept step') then
         call ga_maxelt(g_grad, x)
         call ga_dadd(step, g_s, 1.0d0, g_x, g_x)
         if (x.gt.0.00001d0) goto 10
      else
         write(6,*) mode
         call errquit('unknown mode', 0, GA_ERR)
      endif
c
      status = ga_destroy(g_a)
      status = ga_destroy(g_x)
      status = ga_destroy(g_s)
      status = ga_destroy(g_grad)
      status = ga_destroy(g_work)
c
      end

      subroutine dia_index(sgmnam,ia,ja)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      character*80 atom
      character*16 sgmnam(nsa)
      character*10 word
      integer ia,ja
c
      integer i,j,k,isgm
c
      ia=0
      ja=0
c
      if(card(1:1).ne.'W'.and.card(1:1).ne.'w') then
c
      i=index(card,':')-1
      if(i.le.0.or.i.gt.10) call md_abort('Error in atom name',0)
      word='          '
      word(11-i:10)=card(1:i)
      read(word,'(i10)') isgm
      atom=card(i+2:80)
      j=index(atom,' ')-1
      if(atom(1:1).eq.'_') atom(1:1)=' '
c
      do 1 i=1,nsa
      read(sgmnam(i)(12:16),'(i5)') k
      if(isgm.eq.k) then
      if(sgmnam(i)(6:10).eq.atom(1:5)) then
      ia=i
      return
      endif
      endif
    1 continue
      print*,'index for atom is ',ia
c
      else
c
      i=index(card,':')-1
      if(i.le.1) call md_abort('Error in atom name',0)
      if(i.eq.2) then
      read(card(2:i),'(i1)') ia
      elseif(i.eq.3) then
      read(card(2:i),'(i2)') ia
      elseif(i.eq.4) then
      read(card(2:i),'(i3)') ia
      elseif(i.eq.5) then
      read(card(2:i),'(i4)') ia
      elseif(i.eq.6) then
      read(card(2:i),'(i5)') ia
      else
      call md_abort('Error in dia_index',me)
      endif
      ia=ia-nsgm
      if(ia.le.0) call md_abort('Error in dia_index',me)  
      atom=card(i+2:80)
      j=index(atom,' ')-1
      if(atom(1:1).eq.'_') atom(1:1)=' '
c
      do 2 i=1,nwa
      if(wnam(i)(6:10).eq.atom(1:5)) then
      ja=i
      return
      endif
    2 continue
c
      endif
c
      write(atom,'(a,a,a)') 'Atom ',card(1:index(card,' ')-1),
     + ' could not be found' 
c
      call md_abort(atom,0)
c
      return
      end
c $Id: dia_index.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_diana_covar()
c
c $Id: argos_diana_covar.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_diana_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
#include "util.fh"
c
      integer i,j,k
c
      filpca=card(8:80)
      if(index(filpca,'.pca').eq.0)
     + filpca=filpca(1:index(filpca,' ')-1)//'.pca'
c
      if(nsel.eq.0) call md_abort('No atoms selected',0)
c
      if(active) call argos_diana_edfinal()
      call argos_diana_edinit()
      active=.true.
c
      call ga_distribution(ga_trj,me,il,ih,jl,jh)
      call ga_access(ga_trj,il,ih,jl,jh,ndx,ld)
c
c      call argos_diana_xaver(dbl_mb(ndx),nsa,min((me+1)*nfrme,nfrtot)-me*nfrdim,
c     + dbl_mb(i_xadat),nsa)
c
      call argos_diana_cov(int_mb(i_ndx),dbl_mb(i_cov),int_mb(i_isel),
     + dbl_mb(ndx),dbl_mb(i_xadat))
c
      call ga_scale(ga_cov,1.0d0/dble(nfrtot))
c
c      call argos_diana_pcovar(int_mb(i_ndx),dbl_mb(i_cov),int_mb(i_isel))
c
      if(me.eq.0) then
      if(util_print('frames_read',print_debug)) then
      write(*,'(/,a)') ' Covariance matrix generation completed'
      endif
      endif
c
      call ga_sync()
c
      call ga_diag_std(ga_cov,ga_vec,dbl_mb(i_cov))
c
      call ga_sync()
      do 19 i=1,3*nsel
      int_mb(i_ord+i-1)=i
   19 continue
      do 17 i=1,3*nsel-1
      do 18 j=i+1,3*nsel
      if(abs(dbl_mb(i_cov-1+int_mb(i_ord+i-1))).lt.
     + abs(dbl_mb(i_cov-1+int_mb(i_ord+j-1)))) then
      k=int_mb(i_ord+i-1)
      int_mb(i_ord+i-1)=int_mb(i_ord+j-1)
      int_mb(i_ord+j-1)=k
      endif
   18 continue
   17 continue
c
      if(me.eq.0) then
      open(unit=lfnpca,file=filpca(1:index(filpca,' ')-1),
     + form='formatted',status='unknown')
      write(lfnpca,1000) 3*nsel,nsa
 1000 format(2i7)
      write(lfnpca,1001) (dbl_mb(i_cov-1+int_mb(i_ord+i-1)),i=1,3*nsel)
 1001 format(6e12.5)
      endif
c
      return
      end

      function leps_gradient(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
      logical leps_gradient
      logical leps_energy
      external leps_energy
      integer geom,natom, nelem 
      integer h_c,i_c,h_g,i_g 
      integer h_q,i_q
      integer h_t,i_t
      double precision eleps
c      integer h_g1,i_g1
c      double precision gg(3,3),c(3,3),eleps
c      double precision gradient(3,3) ! can do this because LEPS is only for triatomic collinier sys
c
c
c      write(*,*) "doing leps_gradient"
c      natom=3
c      eleps=0.0
      if (.not. leps_energy(rtdb))
     & call errquit('leps_gradien: error',
     & 0,GEOM_ERR)



c       call leps_energy(rtdb)
c      call leps_energy1(natom,c,eleps)
c      if (.not. rtdb_put(rtdb,'leps:energy',mt_dbl,1,eleps))
c     & call errquit('leps_energy:  no energy ', 0,
c     & RTDB_ERR)
c      write(*,*) "LEPS = ",eleps 
c----   create geometry object
      if (.not. geom_create(geom, 'geometry'))
     & call errquit('leps_getgeom: failed creating geometry',
     & 0,GEOM_ERR)
c---    load geometry into the object
      if (.not. geom_rtdb_load(rtdb, geom, 'geometry'))
     & call errquit('leps_getgeom: no geometry',
     & 0,RTDB_ERR)
C   get the number of centers (atoms)
      if (.not. geom_ncent(geom,natom))
     & call errquit('leps_getgeom: ncent error',
     & 0,GEOM_ERR)
c     print tgeometry
      if (.not. geom_print(geom))
     & call errquit('leps_getgeom: print error',
     & 0,GEOM_ERR)
C ---- allocate local copies for coordinates and gradients
      if (.not. ma_alloc_get(mt_dbl, 3*natom, 'coordinate' ,
     & h_c,i_c))
     & call errquit('leps_getgeom: coordinate not allocated',
     & 3*natom,MA_ERR)

      nelem=3*natom

      if (.not. ma_alloc_get(mt_dbl, nelem, 'gradient' ,
     & h_g,i_g))
     & call errquit('leps_getgradient: gradiant not allocated',
     & 3*natom,MA_ERR)

C  ---- load coordinates from the database
      if (.not. ma_alloc_get(mt_dbl, natom, 'charge', h_q,i_q))
     & call errquit('leps_getgeom: charge not allocated',
     & natom,MA_ERR)
c      if (.not.ma_alloc_get(mt_dbl, natom, 'mass', h_m,i_m))
c     & call errquit('leps_getgeom: mass not allocated',
c     & natom,MA_ERR)
      if (.not.ma_alloc_get(mt_byte, 16*natom, 'tags', h_t,i_t))
     & call errquit('leps_getgeom: tags not allocated',
     & natom,MA_ERR)

C-----Finished allocating memory for info we get from database

C ----- Fill up the local copies with data from geometry object
C------- accessed by the geom handle
      if (.not. geom_cart_get(geom, natom, byte_mb(i_t),
     & dbl_mb(i_c), dbl_mb(i_q)))
     & call errquit('leps_getgeom: coord error',0,GEOM_ERR)

C ------ Calculate the gradient by giving the coordinates as input and 

      call leps_gradient1(natom,nelem,dbl_mb(i_c),dbl_mb(i_g))
c      call leps_gradient0(natom,nelem,dbl_mb(i_g))
c      call leps_gradient1(natom,nelem,c,gg)  
c      call leps_gradient1(natom,nelem,dbl_mb(i_c),gg)
c      call leps_gradient0(natom,nelem,gg)
C-------- Store the gradient into the database
      if (.not. rtdb_put(rtdb,'leps:gradient',mt_dbl,nelem,
     &     dbl_mb(i_g)))
     & call errquit('leps_gradient:  no grad ', 0,
     & RTDB_ERR)

      if(ga_nodeid().eq.0) then
         call leps_gradient0(natom,nelem,dbl_mb(i_g))
      endif

      if(.not.ma_free_heap(h_c))
     &     call errquit('memory deallocation:coord',0,RTDB_ERR)
      if(.not.ma_free_heap(h_q))
     &     call errquit('memory deallocation:charge',0,RTDB_ERR)
      if(.not.ma_free_heap(h_g))
     &     call errquit('memory deallocation:mass',0,RTDB_ERR)
      if(.not.ma_free_heap(h_t))
     &     call errquit('memory deallocation:tags',0,RTDB_ERR)

      if (.not. geom_destroy(geom))
     & call errquit('leps_getgeom:  geom_destroy failed',
     & 911,GEOM_ERR)

c      if (.not. rtdb_put(rtdb,'leps:gradient',mt_dbl,nelem,
c     &     gg))
c     & call errquit('leps_gradient:  no grad ', 0,
c     & RTDB_ERR)

    
c      write(*,*) "looks like no error in doing leps_gradient"
C ---- Let's see if I can get the gradient from the database
c      if (.not. rtdb_get(rtdb,'leps:gradient',mt_dbl,nelem,
c     &     dbl_mb(i_g1)))
c     & call errquit('leps_gradient1:  no grad ', 0,
c     & RTDB_ERR)
c       write(*,*) "looks like properly stored in database"  
c       call leps_gradient0(natom,nelem,dbl_mb(i_g1))

C ---
      leps_gradient = .true.
      return
      end 

      subroutine leps_gradient0(n,nel,grad)
C THis function just prints the coordinates, masses and tags(names for the atoms)
      implicit none
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"

c      logical leps_gradient0
      integer n,nel
      double precision grad(3,n)
c
      integer i
      write(*,*) 'Leps_gradient:', nel

      do i=1,n
       write(6,9000) i,grad(1,i),grad(2,i),grad(3,i)
      end do
 9000 format (i4, F18.14,F18.14,F18.14)
      return
      END

      subroutine leps_gradient1(n,nel,c0,grad)
      implicit none
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
      logical out1 
      integer n,nel ! number of atoms
      integer i,j,jat
      double precision small,dot,cosa,c0(3,3),grad(3,3)
      logical coll

c------from leps energy
      double precision c(3,3),dr(3,3,3),dvk(3,3,3),dvj(3,3,3)
      double precision r(3),e1(3),e3(3),vj(3),sqrj
      double precision d1(3),be1(3),re1(3),d3(3),be3(3),re3(3)
      double precision tobohr, tohartree
      parameter (tobohr=0.529177249d+00)
      parameter (tohartree=627.509451d+00)
      data d1     /234.524674,234.524674,64.925971/
      data be1    /0.929968,0.929968,0.432955/
      data re1    /1.776382,1.776382,2.094857/
      data d3     /220.244820,220.244820,284.999867/
      data be3    /4.822681,4.822681,1.016811/
      data re3    /1.785014,1.785014,2.186060/
      out1=.false.
      dot=0.0
      cosa=0.0 
      small = 1d-10
      coll=.false.
C----- convert the coordinates to angstrom (because alp and re are in angstroms)
      do i=1,n
        do j=1,n
          c(j,i)=c0(j,i)*tobohr
        enddo
      end do
      r(1)=sqrt( (c(1,1)-c(1,2))**2+(c(2,1)-c(2,2))**2
     1                             +(c(3,1)-c(3,2))**2 )
      r(2)=sqrt( (c(1,2)-c(1,3))**2+(c(2,2)-c(2,3))**2
     1                             +(c(3,2)-c(3,3))**2 )
      r(3)=sqrt( (c(1,1)-c(1,3))**2+(c(2,1)-c(2,3))**2
     1                             +(c(3,1)-c(3,3))**2 )

C check collinearity
      dot =      (c(1,1)-c(1,2))*(c(1,1)-c(1,3))+
     1           (c(2,1)-c(2,2))*(c(2,1)-c(2,3))+
     2           (c(3,1)-c(3,2))*(c(3,1)-c(3,3))
      cosa=dot/(r(1)*r(3))

      cosa=abs(cosa)
      coll=abs(1.0-cosa).lt.small


c ------- Just cause I like all my arrays to be set to zero before use  
      do jat=1,n
         vj(jat)=0.0
         do j=1,3
            do i=1,3
               dr(i,j,jat)=0.0
               dvk(i,j,jat)=0.0
               dvj(i,j,jat)=0.0
            enddo
         enddo
      enddo
c      write(6,*) 'r 0 = ',r
c      write(6,*) 'dr 0 = ',dr
c      write(6,*) 'C =',c
c      write(6,*)'c0=',c0
C derivatives of the coordinates dr(a,b,c) is der(r_a)/der(b_c)
C r1
      dr(1,1,1)=(c(1,1)-c(1,2))/r(1)
      dr(1,2,1)=(c(2,1)-c(2,2))/r(1)
      dr(1,3,1)=(c(3,1)-c(3,2))/r(1)
      dr(1,1,2)=-dr(1,1,1)
      dr(1,2,2)=-dr(1,2,1)
      dr(1,3,2)=-dr(1,3,1)
c      write (*,*) 'dr(1,3,2):',dr(1,3,2)
c r2
      dr(2,1,2)=(c(1,2)-c(1,3))/r(2)
      dr(2,2,2)=(c(2,2)-c(2,3))/r(2)
      dr(2,3,2)=(c(3,2)-c(3,3))/r(2)
      dr(2,1,3)=-dr(2,1,2)
      dr(2,2,3)=-dr(2,2,2)
      dr(2,3,3)=-dr(2,3,2)
c      write (*,*) 'dr(2,3,3):',dr(2,3,3)
c r3
      dr(3,1,1)=(c(1,1)-c(1,3))/r(3)
      dr(3,2,1)=(c(2,1)-c(2,3))/r(3)
      dr(3,3,1)=(c(3,1)-c(3,3))/r(3)
      dr(3,1,3)=-dr(3,1,1)
      dr(3,2,3)=-dr(3,2,1)
      dr(3,3,3)=-dr(3,3,1)
c      write (*,*) 'dr(3,3,3):',dr(3,3,3)

c      write(6,*) 'dr  = ',dr
      if(coll) then
      do i=1,3
            e1(i) = d1(i)*(1.0 - exp(-be1(i)*(r(i)-re1(i))))**2-d1(i)
            e3(i) = d3(i)*(1.0 + exp(-be3(i)*(r(i)-re3(i))))**2-d3(i)
C            vk(i) = (e1(i) + e3(i))/2.0
            vj(i) = (e1(i) - e3(i))/2.0
      enddo


      do jat=1,n
        do j=1,3
          do i=1,3
            dvk(i,j,jat)= d1(i)*(1.0 - exp(-be1(i)*(r(i)-re1(i))))*
     1       (-1)*exp(-be1(i)*(r(i)-re1(i)))*(-be1(i))* dr(i,j,jat)
     2      +             (d3(i)*(1.0 - exp(-be3(i)*(r(i)-re3(i))))*
     3      (-exp(-be3(i)*(r(i)-re3(i))))*(-be3(i))* dr(i,j,jat))

            dvj(i,j,jat)= d1(i)*(1.0 - exp(-be1(i)*(r(i)-re1(i))))*
     1      (-exp(-be1(i)*(r(i)-re1(i))))*(-be1(i))* dr(i,j,jat)
     2      -             (d3(i)*(1.0 - exp(-be3(i)*(r(i)-re3(i))))*
     3      (-exp(-be3(i)*(r(i)-re3(i))))*(-be3(i))* dr(i,j,jat))
          enddo
        enddo
      enddo
         sqrj=  sqrt(((vj(1)-vj(2))**2 + (vj(2)-vj(3))**2 +
     1                (vj(1)-vj(3))**2                      )/2.0 )

c           do jat=1,n
c             do j=1,3
c                do i=1,3
c                write(*,*) 'jat,j,i,dvk',jat,j,i,dvk(i,j,jat)
c                write(*,*) 'jat,j,i,dvJ',jat,j,i,dvj(i,j,jat)  
c                enddo
c             enddo
c           enddo
         do jat=1,n
            do j=1,3
               grad(j,jat)=(   dvk(1,j,jat)+dvk(2,j,jat)+dvk(3,j,jat)
     1                   -( dvj(1,j,jat)*(vj(1)-vj(2))
     2                     -dvj(2,j,jat)*(vj(1)-vj(2))
     3                     +dvj(2,j,jat)*(vj(2)-vj(3))
     4                     -dvj(3,j,jat)*(vj(2)-vj(3))
     5                     +dvj(1,j,jat)*(vj(1)-vj(3))
     6                     -dvj(3,j,jat)*(vj(1)-vj(3)) )/sqrj/2.0)
     7                   /tohartree*tobohr

            enddo
         enddo
              
c         write (*,*) 'grad 0: ',grad
c         do jat=1,n
c            do j=1,3
c               grad(j,jat)=(   dvk(1,j,jat)+dvk(2,j,jat)+dvk(3,j,jat)
c     1                   -( (dvj(1,j,jat)
c     2                     -dvj(2,j,jat))*(vj(1)-vj(2))
c     3                     +(dvj(2,j,jat)
c     4                     -dvj(3,j,jat))*(vj(2)-vj(3))
c     5                     +(dvj(1,j,jat)
c     6                     -dvj(3,j,jat))*(vj(1)-vj(3)) )/sqrj/2.0)

c     1                   -( dvj(1,j,jat)*(vj(1)-vj(2))
c     2                     -dvj(2,j,jat)*(vj(1)-vj(2))
c     3                     +dvj(2,j,jat)*(vj(2)-vj(3))
c     4                     -dvj(3,j,jat)*(vj(2)-vj(3))
c     5                     +dvj(1,j,jat)*(vj(1)-vj(3))
c     6                     -dvj(3,j,jat)*(vj(1)-vj(3)) )/sqrj/2.0)
c     7                   /tohartree*tobohr
c            enddo
c         enddo
        else
         do jat=1,n
            do j=1,3
               grad(j,jat)=0.0
            enddo
         enddo   
        endif
         if (out1) then
          write(*,*) 'sqrj :', sqrj
           write(*,*) 'vj :', vj
           write(*,*) 'r: ',r(1),r(2),r(3)
           write(*,*) 'dr :', dr
           write(*,*) 'dvk :',dvk
           write(*,*) 'dvj :', dvj
           write(*,*) 'c :',c
           write(*,*) 'c0 :',c0
           write (*,*) 'grad :',grad
         endif
c      write (*,*) 'grad 1: ',grad
c      write (*,*) 'test - grad', 0.0+0.0+0.0 
      return
      end

c $Id: leps_gradient.F 21176 2011-10-10 06:35:49Z d3y133 $

c $Id: int_giaol10.F 23378 2013-01-05 22:46:06Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Compute the 1-electron GIAO Lagrangian integrals 
C>
C> Compute the 1-electron GIAO Lagrangian integrals.
C> For a definition of the GIAO basis functions see the
C> `int_giao_2e` routine (see also [1]).
C>
C> [1] M. Dupuis,
C>     "New integral transforms for molecular properties and application
C>     to a massively parallel GIAO-SCF implementation",
C>     Comp. Phys. Comm. <b>134</b>, 150-166 (2001), DOI:
C>     <a href="http://dx.doi.org/10.1016/S0010-4655(00)00195-8">
C>     10.1016/S0010-4655(00)00195-8</a>.
C>

c:tex-% this is part of the API Standard Integral routines.
c:tex-\subsection{int\_giaol10}
c:tex-This routine computes the 1-elec GIAO Lagrangian integrals
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_giaol10(i_basis,ish,j_basis,jsh,lscr,scr,ll10,l10)
c:tex-\end{verbatim}
      implicit none
#include "nwc_const.fh"
#include "errquit.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
#include "stdio.fh"
#include "apiP.fh"
#include "util.fh"
c::external subroutines used
c... errquit
c::functions
      logical cando_hnd_1e_prp
      logical int_chk_init
      logical int_chk_sh
      external int_chk_init
      external int_chk_sh
      external cando_hnd_1e_prp
c::passed
c:tex-\begin{verbatim}
      integer i_basis !< [Input] basis set handle for ish
      integer ish     !< [Input] i shell/contraction
      integer j_basis !< [Input] basis set handle for jsh
      integer jsh     !< [Input] j shell/contraction
      integer lscr    !< [Input] length of scratch array
      double precision scr(lscr) !< [Scratch] scratch array
      integer ll10               !< [Input] length of l10 buffer
      double precision l10(ll10) !< [Output] l10 integrals
c:tex-\end{verbatim}
c::local
      integer igeom, jgeom, ibas, jbas, ucont
      integer itype, inp, igen, iexp, icent, icf, iatom
      integer jtype, jnp, jgen, jexp, jcent, jcf, jatom
c
      logical any_spherical, trani, tranj, shells_ok
      integer i_nbf_x, j_nbf_x
      integer i_nbf_s, j_nbf_s
      integer ipts, ncartint ,i,j
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c check initialization and shells
c
      if (.not.int_chk_init('int_giaol10'))
     &       call errquit('int_giaol10: int_init was not called' ,0,
     &       INT_ERR)
c
      shells_ok = int_chk_sh(i_basis,ish)
      shells_ok = shells_ok .and. int_chk_sh(j_basis,jsh)
      if (.not.shells_ok)
     &       call errquit('int_giaol10: invalid contraction/shell',0,
     &       INT_ERR)
c
c  check if gencont
c
      call int_nogencont_check(i_basis,'int_giaol10:i_basis')
      call int_nogencont_check(j_basis,'int_giaol10:j_basis')
c
      ibas = i_basis + basis_handle_offset
      jbas = j_basis + basis_handle_offset
c
      ucont = (sf_ibs_cn2ucn(ish,ibas))
      itype = infbs_cont(CONT_TYPE ,ucont,ibas)
      inp   = infbs_cont(CONT_NPRIM,ucont,ibas)
      igen  = infbs_cont(CONT_NGEN ,ucont,ibas)
      iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      icf   = infbs_cont(CONT_ICFP ,ucont,ibas)
      iatom = (sf_ibs_cn2ce(ish,ibas))
      igeom = ibs_geom(ibas)
c
      ucont = (sf_ibs_cn2ucn(jsh,jbas))
      jtype = infbs_cont(CONT_TYPE ,ucont,jbas)
      jnp   = infbs_cont(CONT_NPRIM,ucont,jbas)
      jgen  = infbs_cont(CONT_NGEN ,ucont,jbas)
      jexp  = infbs_cont(CONT_IEXP ,ucont,jbas)
      jcf   = infbs_cont(CONT_ICFP ,ucont,jbas)
      jatom = (sf_ibs_cn2ce(jsh,jbas))
      jgeom = ibs_geom(jbas)
c
      if (igeom.ne.jgeom) then
        write(luout,*)'int_giaol10: two different geometries for',
     &         ' properties?'
        call errquit('int_giaol10: geom error ',911, GEOM_ERR)
      endif
c
c     Determine # of cartesian integrals in block
c
      ncartint = int_nbf_x(itype)*int_nbf_x(jtype)
c
      call hnd_giaol10(
     &       coords(1,iatom,igeom),
     &       dbl_mb(mb_exndcf(iexp,ibas)),
     &       dbl_mb(mb_exndcf(icf,ibas)),
     &       inp,igen,itype,
c
     &       coords(1,jatom,jgeom),
     &       dbl_mb(mb_exndcf(jexp,jbas)),
     &       dbl_mb(mb_exndcf(jcf,jbas)),
     &       jnp,jgen,jtype,
c
     &       ncartint,l10,scr,lscr)
c
c     h01 now has three blocks, one for each component x, y, z
c      
      any_spherical = bas_spherical(ibas).or.bas_spherical(jbas)
      if (.not.any_spherical) return
c
      i_nbf_x = int_nbf_x(itype)
      j_nbf_x = int_nbf_x(jtype)
c
c... assume we need to transform both i and j integrals
c
      trani = .true.
      tranj = .true. 
*.. do not tranform i component
      if (.not.bas_spherical(ibas)) trani = .false.
*.. do not tranform j component
      if (.not.bas_spherical(jbas)) tranj = .false.
c        
c ... reset general contractions for sp shells to 1 since they are handled
c     as a block of 4.
c
      if (itype.eq.-1) igen = 1
      if (jtype.eq.-1) jgen = 1
      call spcart_2cBtran(l10,scr,lscr,
     &    j_nbf_x,int_nbf_s(jtype),jtype,jgen,tranj,
     &    i_nbf_x,int_nbf_s(itype),itype,igen,trani,
     &    3,.false.)
c
c     We now have the integrals in array (nsph_ints,3)
c
      return
      end
C> @}

*
* $Id: integrate_paw_ray.F 25872 2014-06-28 23:07:32Z bylaska $
*

*     *************************************************
*     *                                               *
*     *           integrate_paw_ray                   *
*     *                                               *
*     *************************************************

      subroutine integrate_paw_ray(version,rlocal,sigma,
     >                            nrho,log_amesh,zv,
     >                            nbasis,n_ps,l_ps,
     >                            vlocal,prj_ps,
     >                            rho,f,cs,sn,
     >                            nray,G_ray,vl_ray,vlpaw_ray,vnl_ray,
     >                            ierr)
      implicit none
      integer          version
      double precision rlocal,sigma
      integer          nrho
      double precision log_amesh
      double precision zv
      integer nbasis,n_ps(*),l_ps(*)

      double precision vlocal(nrho)
      double precision prj_ps(nrho,nbasis)
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nray
      double precision G_ray(nray)
      double precision vl_ray(nray)
      double precision vlpaw_ray(nray)
      double precision vnl_ray(nray,nbasis)

      integer ierr

      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      integer task_count
      integer k1,i,l,ib,la,power_f
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3,p
      double precision a,q,d

*     **** Error function parameters ****
      real*8 yerf,xerf,yerf1,xerf1

*     **** external functions ****
      double precision log_integrate_def,util_erf
      external         log_integrate_def,util_erf


      call Parallel_np(np)
      call Parallel_taskid(taskid)

      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      p0=dsqrt(forpi)
      p1=dsqrt(3.0d0*forpi)
      p2=dsqrt(15.0d0*forpi)
      p3=dsqrt(105.0d0*forpi)

*======================  Fourier transformation  ======================
      call dcopy(nray,0.0d0,0,vl_ray,1)
      call dcopy(nray,0.0d0,0,vlpaw_ray,1)
      call dcopy(nbasis*nray,0.0d0,0,vnl_ray,1)
      task_count = -1
      DO 700 k1=2,nray
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        Q=G_ray(k1)

        do i=1,nrho
          cs(i)=dcos(Q*rho(i))
          sn(i)=dsin(Q*rho(i))
        end do

        do ib=1,nbasis
          la=l_ps(ib)

*         ::::::::::::::::::::::::::::::  h-wave  ::::::::::::::::::::::::::::::
*         ::::::::::::::::::::::::::::::  g-wave  ::::::::::::::::::::::::::::::
*         ::::::::::::::::::::::::::::::  f-wave  ::::::::::::::::::::::::::::::
          if (la.eq.3) then
             power_f = 8
             f(1)=0.0d0
             do i=2,nrho
               a=sn(i)/(Q*rho(i))
               a=15.0d0*(a-cs(i))/(Q*rho(i))**2 - 6*a + cs(i)
               f(i)=a*prj_ps(i,ib)
             end do
             d=p3*log_integrate_def(power_f,f,0,rho,log_amesh,nrho)/Q
             vnl_ray(k1,ib)=d
          end if
*         ::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
          if (la.eq.2) then
             power_f = 6
             f(1)=0.0d0
             do i=2,nrho
               a=3.0d0*(sn(i)/(Q*rho(i))-cs(i))/(Q*rho(i))-sn(i)
               f(i)=a*prj_ps(i,ib)
             end do
             d=p2*log_integrate_def(power_f,f,0,rho,log_amesh,nrho)/Q
             vnl_ray(k1,ib)=D
          end if
*         ::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
          if (la.eq.1) then
             power_f = 4
             f(1)=0.0d0
             do i=2,nrho
               f(i)=(sn(i)/(Q*rho(i))-cs(i))*prj_ps(i,ib)
             end do
             p=p1*log_integrate_def(power_f,f,0,rho,log_amesh,nrho)/Q
             vnl_ray(k1,ib)=p
          end if
*         ::::::::::::::::::::::::::::::  s-wave  ::::::::::::::::::::::::::::::
          if (la.eq.0) then
            power_f = 2
            do i=1,nrho
              f(i)=sn(i)*prj_ps(i,ib)
            end do
            vnl_ray(k1,ib)=
     >       p0*log_integrate_def(power_f,f,0,rho,log_amesh,nrho)/Q
          end if

        end do

*::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
        if (version.eq.3) then
           do  i=1,nrho
             xerf1 = rho(i)/sigma
             yerf1 = util_erf(xerf1)
             !f(i)=(rho(i)*vlocal(i)-zv*yerf1)*sn(i)
             f(i)=(-zv*yerf1)*sn(i)
           end do
ccccc        vl_ray(k1)=simp(NRHO,F,DRHO)*forpi/Q-zv*forpi*CS(NRHO)/(Q*Q)
           vl_ray(k1)=forpi
     >               *log_integrate_def(0,f,0,rho,log_amesh,nrho)/Q
     >            -zv*forpi*cs(nrho)/(Q*Q)
        end if
 
        if (version.eq.4) then
           do i=1,nrho
             xerf1 = rho(i)/sigma
             yerf1 = util_erf(xerf1)
             xerf=rho(i)/rlocal
             yerf = util_erf(xerf)
             !f(i)=(rho(i)*vlocal(i)-zv*yerf1+zv*yerf)*sn(i)
             f(i)=(-zv*yerf1+zv*yerf)*sn(i)
           end do
cccc        vl_ray(k1)=SIMP(NRHO,F,DRHO)*forpi/Q
           vl_ray(k1)=forpi
     >               *log_integrate_def(0,f,0,rho,log_amesh,nrho)/Q
        end if

*       **** vlpaw potential ****
        do i=1,nrho
          f(i)=(rho(i)*vlocal(i))*sn(i)
        end do
        vlpaw_ray(k1)=forpi
     >               *log_integrate_def(0,f,0,rho,log_amesh,nrho)/Q


  700 CONTINUE
      call Parallel_Vector_SumAll(nray,vl_ray)
      call Parallel_Vector_SumAll(nray,vlpaw_ray)
      call Parallel_Vector_SumAll(nbasis*nray,vnl_ray)

*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      
      if (version.eq.3) then
         do i=1,nrho
           xerf1 = rho(i)/sigma
           yerf1 = util_erf(xerf1)
           !f(i)=(vlocal(i)*rho(i)-zv*yerf1)*rho(i)
           f(i)=(-zv*yerf1)*rho(i)
         end do
         vl_ray(1)=forpi*log_integrate_def(0,f,0,rho,log_amesh,nrho)
     >            +twopi*zv*rho(nrho)**2
c         vl_ray(1)=forpi*log_integrate_def(0,f,0,rho,log_amesh,nrho)
      end if

      if (version.eq.4) then
         do i=1,nrho
           xerf1 = rho(i)/sigma
           yerf1 = util_erf(xerf1)
           xerf=rho(i)/rlocal
           yerf = util_erf(xerf)
           !f(i)=(vlocal(i)*rho(i)-zv*yerf1+zv*yerf)*rho(i)
           f(i)=(-zv*yerf1+zv*yerf)*rho(i)
         end do
         vl_ray(1)=forpi*log_integrate_def(0,f,0,rho,log_amesh,nrho)
      end if

      do i=1,nrho
        f(i)=vlocal(i)*rho(i)*rho(i)
      end do
      vlpaw_ray(1)=forpi*log_integrate_def(0,f,0,rho,log_amesh,nrho)


*     *** only j0 is non-zero at zero ****
      power_f = 2
      do ib=1,nbasis
        la=l_ps(ib)
        vnl_ray(1,ib)=0.0d0
        if (la.eq.0) then
           do i=1,nrho
             f(i)=rho(i)*prj_ps(i,ib)
           end do
           vnl_ray(1,ib)=
     >      p0*log_integrate_def(power_f,f,0,rho,log_amesh,nrho)
        end if
      end do

      ierr=0
      return
      end

      logical function dkdiv_energy(rtdb)
c $Id: dkdiv_energy.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
#include "global.fh"
#include "rtdb.fh"
#include "context.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "geom.fh"
#include "util.fh"
#include "stdio.fh"
#include "inp.fh"
#include "errquit.fh"
c
c     The routine computes the energy for a given basis, geometry
c     and density (read from the rtdb) for the integral difference
c     (Douglas-Kroll - non-relativistic Hamiltonian)
c
      integer rtdb ! [input] handle to database
c
      logical int_normalize, file_read_ga
      external int_normalize, file_read_ga
c
      character*255 dkdiv_name
      integer DKg_a, g_dens
      integer geom, basis
      integer nbf
      double precision energy
c
c     Get basis, geometry, density or densities and additional data
c
      if (.not. geom_create(geom, 'DK geometry'))
     $     call errquit('dkdiv_energy: geom_create failed', 0,
     &       GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, 'geometry'))
     $     call errquit('dkdiv_energy: geom_rtdb_load failed', 0,
     &       RTDB_ERR)
      if (.not. bas_create(basis, 'ao basis'))
     $     call errquit('dkdiv_energy: bas_create failed', 0,
     &       BASIS_ERR)
      if (.not. bas_rtdb_load(rtdb, geom, basis, 'ao basis'))
     $     call errquit('dkdiv_energy: bas_rtdb_load failed', 0,
     &       RTDB_ERR)
c
      call int_init(rtdb,1,basis)
c
      if (.not. int_normalize(rtdb,basis))
     $     call errquit('dkdiv_energy: int_normalize failed',0,
     &       INT_ERR)
      if (.not. bas_numbf(basis,nbf))
     $   call errquit('dkdiv_energy: bas_numbf failed',0, BASIS_ERR)
c
c     Get kinetic and potential energy integral matrix. Multiply
c     by -1 to setup for DK - NR
c
      if (.not. ga_create(MT_DBL,nbf,nbf,'GA dkdiv',1,1,DKg_a))
     $     call errquit('dkdiv_energy:ga_create failed GA dkdiv',0,
     &       GA_ERR)
      call ga_zero(DKg_a)
      call int_1e_oldga(basis,basis,DKg_a,'kinetic',.false.)
      call int_1e_oldga(basis,basis,DKg_a,'potential',.false.)
      call ga_dscal(Dkg_a, -1.0d0)
c
c     Add Douglas-Kroll integrals to GA with - kinetic - potential
c     We are left with the required difference integrals
c
      call int_1edk_ga(basis,DKg_a,3,.false.)
c
c     Get density from file back into a GA
c
      if (.not. ga_create(MT_DBL,nbf,nbf,'GA dens',1,1,g_dens))
     $     call errquit('dkdiv_energy:ga_create failed GA dens',0,
     &       GA_ERR)
      call ga_zero(g_dens)
      call util_file_name('dkdiv_density',.true.,.true.,dkdiv_name)
      if (.not. file_read_ga(dkdiv_name,g_dens))
     $    call errquit('dkdiv_energy:file_read_ga density failed',0,
     &       GA_ERR)
c
c     Compute the energy E = Density * Integrals
c
      energy = 0.0d0
      energy = ga_ddot(DKg_a,g_dens)
c
c     Store energy in database under specific name: grad_dk:dkdiv_energy
c
      if (.not. rtdb_put(rtdb,'grad_dk:dkdiv_energy',MT_DBL,1,energy))
     $   call errquit('dkdiv_energy:rtdb_put energy failed',0,
     &       RTDB_ERR)
      dkdiv_energy = .true.
c
      if (.not.((ga_destroy(g_dens)).and.(ga_destroy(DKg_a))))
     $   call errquit('dkdiv_energy: destroy GAs failed',0, GA_ERR)
      if (.not.((bas_destroy(basis)).and.(geom_destroy(geom))))
     $    call errquit('dkdiv_energy: destroy bas or geom failed',0,
     &       MEM_ERR)
c
      call int_terminate()
c
      return
c
      end

      logical function uhf(rtdb, energy)
C$Id: uhf.F 25603 2014-05-13 01:11:35Z niri $
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "tcgmsg.fh"
#include "cuhf.fh"
#include "cscf.fh"
#include "geom.fh"
#include "bas.fh"
c
c     Compute UHF wavefunction .
c
c     Initial vectors are assumed to be loaded in common/cscf/
c
      integer rtdb
      double precision energy   ! [output] Total SCF energy
c
c     local variables
c
      logical oprint, oprint_sym
      logical converged
      integer nprint
      double precision eone     ! One electron energy
      double precision etwo     ! Two electron energy
      double precision enrep    ! Effective nuclear repulsion energy
      double precision uhf_time
      double precision sz, s2
c
      integer ilo, ihi          ! For printing movecs analysis
      double precision eval_pr_tol_lo, eval_pr_tol_hi
      parameter (eval_pr_tol_lo = -1.5d0, eval_pr_tol_hi=0.5)
C
      Integer NAtoms, NShells
c
      logical uhf_nr_solve
      external uhf_nr_solve
c
      oprint = util_print('information',print_low)
c
c     Initialize the UHF data structures and allocate memory
c
      call uhf_init(rtdb)
c
c     Start timer
c
      call ga_sync()
      uhf_time = -util_cpusec()
c
c     Newton-Raphson based SCF
c
      if (maxiter .le. 0) then
         converged = .false.
         energy = 0.0d0
         eone = 0.0d0
         etwo = 0.0d0
      else
         converged = uhf_nr_solve(rtdb, energy,  eone, etwo, enrep)
      endif
c
      call ga_sync()
      uhf_time = uhf_time + util_cpusec()
c
c     Print out results
c
      call uhf_spin(sz,s2)
      if (.not. rtdb_put(rtdb,'scf:sz', mt_dbl, 1, sz)) call errquit
     $     ('uhf: storing sz failed', 0, RTDB_ERR)
      if (.not. rtdb_put(rtdb,'scf:s2', mt_dbl, 1, s2)) call errquit
     $     ('uhf: storing s2 failed', 0, RTDB_ERR)
      if (.not. rtdb_put(rtdb,'uhf:coulomb', mt_dbl, 1, etwo)) call 
     $     errquit('uhf: writing etwo failed', 0, RTDB_ERR)
c
      if (ga_nodeid().eq.0 .and. (oprint .or. .not.converged)) then
         if (.not. converged) then
            write(6,*)
            call util_print_centered(6,
     $           'Calculation failed to converge', 20, .true.)
            write(6,*)
         end if
         write(6,2) scftype, energy, eone, etwo, enrep, 
     $        sz, sz*(sz+1), s2, uhf_time
 2       format(//
     $        '       Final ',a4,' results '/
     $        '       ------------------ '//
     $        '         Total SCF energy =', f20.12/
     $        '      One electron energy =', f20.12/
     $        '      Two electron energy =', f20.12/
     $        ' Nuclear repulsion energy =', f20.12//
     $        '                       Sz =', f12.4/
     $        '                 Sz(Sz+1) =', f12.4/
     $        '                      S^2 =', f12.4//
     $        '        Time for solution =', f9.1,'s'//)
         call util_flush(6)
         call ecce_print1('total energy', mt_dbl, energy, 1)
         call ecce_print1('one-electron energy', mt_dbl, eone, 1)
         call ecce_print1('two-electron energy', mt_dbl, etwo, 1)
         call ecce_print1('nuclear repulsion energy', mt_dbl, enrep, 1)
         call ecce_print1('Sz', mt_dbl, sz, 1)
         call ecce_print1('S^2', mt_dbl, s2, 1)
      end if
C
      if (util_print('schwarz',print_high)) then
         if ( .NOT. geom_ncent(geom, natoms) ) Call ErrQuit(
     $        'uhf: problem with call to geom_ncent', geom, 0)
         if ( .NOT. bas_numcont(basis, nshells) ) Call ErrQuit(
     $        'uhf: problem with call to bas_numcont', basis,0)
         call schwarz_print(natoms, nshells)
      Endif
C
      nprint = min(nalpha+10,nmo)
      if (util_print('all vector symmetries', print_high))
     $     nprint = nmo
      if (oadapt) then
         oprint_sym = util_print('final vector symmetries',
     $        print_default)
         call scf_movecs_sym_adapt(basis, g_movecs, oprint_sym,
     $        nprint, '- alpha', .true., int_mb(k_irs))
         call scf_movecs_sym_adapt(basis, g_movecs(2), oprint_sym,
     $        nprint, '- beta', .true., int_mb(k_irs+nmo))
      endif
      if (ga_nodeid() .eq. 0) then
         if (util_print('final evals', print_default)) then
            call util_print_centered(6,'Final alpha eigenvalues',
     $           20,.true.)
            call output(dbl_mb(k_eval), 1, nprint, 1, 1, nmo, 1, 1)
            write(6,*)
            call util_print_centered(6,'Final beta eigenvalues',
     $           20,.true.)
            call output(dbl_mb(k_eval+nbf), 1, nprint, 1, 1, nmo, 1, 1)
            call util_flush(6)
         end if
      endif
      if (util_print('final vectors analysis', print_default)) then
         do ilo = 1,max(1,min(nalpha,nbeta)-10)
            if (dbl_mb(k_eval+ilo-1) .ge. eval_pr_tol_lo) goto 961
         enddo
 961     do ihi = min(max(nalpha,nbeta)+10,nmo),nmo
            if (dbl_mb(k_eval+ihi-1) .ge. eval_pr_tol_hi) goto 9611
         enddo
         ihi = max(ihi-1,1)
 9611    continue
         call movecs_print_anal(basis, ilo, ihi, 0.15d0, g_movecs, 
     $        'UHF Final Alpha Molecular Orbital Analysis', 
     $        .true., dbl_mb(k_eval), oadapt, int_mb(k_irs),
     $        .true., dbl_mb(k_occ))
         call movecs_print_anal(basis, ilo, ihi, 0.15d0, g_movecs(2), 
     $        'UHF Final Beta Molecular Orbital Analysis', 
     $        .true., dbl_mb(k_eval+nbf), oadapt, int_mb(k_irs+nmo),
     $        .true., dbl_mb(k_occ+nbf))
      endif
      if (ga_nodeid() .eq. 0) then
         if (util_print('final vectors', print_debug)) then
            write(6,*)
            call util_print_centered(6,'Final MO vectors',40,.true.)
            write(6,*)
            call util_flush(6)
         end if
      end if
      if (util_print('final vectors', print_debug)) then
         call ga_print(g_movecs)
         call ga_print(g_movecs(2))
      end if
c
      call uhf_analyze(rtdb)
c
c     Clean up common blocks and allocated data and return
c
      call uhf_tidy(rtdb)
c
      uhf = converged
c
      end
      subroutine uhf_init(rtdb)
      implicit none
#include "errquit.fh"
#include "cuhf.fh"
#include "cscf.fh"
#include "global.fh"
#include "mafdecls.fh"
      integer rtdb
c
      cuhf_vlen = nalpha*(nmo-nalpha) + nbeta*(nmo-nbeta)
c
c     Special case for no degrees of freedom ... avoid breaking GA
c
      if (cuhf_vlen .eq. 0) cuhf_vlen = 1
c
      if (.not. ga_create(MT_DBL, nmo, nmo, 'uhf_init: Falpha',
     $     32, 32, cuhf_g_falpha)) call errquit('uhf_init: Fa', 0,
     &       GA_ERR)
      if (.not. ga_create(MT_DBL, nmo, nmo, 'uhf_init: Fbeta',
     $     32, 32, cuhf_g_fbeta)) call errquit('uhf_init: Fb', 0,
     &       GA_ERR)
c
      cuhf_init_flag = .true.
      noskew_uhf = .true.
c
      end
      subroutine uhf_tidy(rtdb)
      implicit none
#include "errquit.fh"
#include "cuhf.fh"
#include "cscf.fh"
#include "global.fh"
#include "mafdecls.fh"
      integer rtdb
c
      if (.not. ga_destroy(cuhf_g_falpha)) call errquit
     $     ('uhf_tidy: failed to destroy fock matrix',0, GA_ERR)
      if (.not. ga_destroy(cuhf_g_fbeta)) call errquit
     $     ('uhf_tidy: failed to destroy fock matrix',0, GA_ERR)
      cuhf_init_flag = .false.
c
      end
      logical function uhf_nr_solve(rtdb, energy, eone, etwo, enrep)
C     $Id: uhf.F 25603 2014-05-13 01:11:35Z niri $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "cuhf.fh"
#include "pstat.fh"
#include "cscfps.fh"
#include "util.fh"
#include "cscf.fh"
c     
c     Solve the UHF equations using a hybrid NR/PCG method
c     
c     Arguments
c     
      integer rtdb
      double precision energy   ! Return UHF energy
      double precision eone, etwo, enrep ! Return UHF energy contribs
c     
c     Local GA handles 
c     
      integer g_grad            ! gradient vector  ... cuhf_vlen
      integer g_search          ! search direction ... cuhf_vlen
      integer g_work            ! scratch vector   ... cuhf_vlen
c     
c     Local variables
c     
      integer ls_max            ! Max. no. of points for line search
      parameter (ls_max=20)
      integer iwork(10)         ! PCG routine internal info
      double precision dwork(3*ls_max+5) ! PCG routine internal info
      character*16 mode         ! For communication with PCG routine 
c
      double precision tlastwrite,ttest  ! time last wrote the MO vectors
      double precision step     ! Step to take in search direction
      double precision time_iter_start
      integer time_prev_iter
      logical noscf ! one-shot energy option
c
      double precision gnorm    ! measures for convergence
      logical converged
      logical oprint_parm, oprint_conv, oprint_eval, oprint_vecs
      logical oprint_ls
c     
c     Functions
c     
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
C      external uhf_hessv, uhf_hessv_precond
c     
      
      if (ga_nodeid().eq.0) call util_flush(6)
c     
c     Allocate global arrays.  Gradient, search direction
c     and work space for the PCG routine.
c     
*ga:1:0
      if (.not. ga_create(MT_DBL, cuhf_vlen, 1, 'uhf_nr_solve: grad',
     $     0, 1, g_grad)) call errquit('uhf_nr_solve: ga_cre grad', 0,
     &       GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, cuhf_vlen, 1, 'uhf_nr_solve: serch',
     $     0, 0, g_search)) call errquit('uhf_nr_solve: ga_cre grad',0,
     &       GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, cuhf_vlen, 1, 'uhf_nr_solve: work',
     $     0, 0, g_work)) call errquit('uhf_nr_solve: ga_cre work', 0,
     &       GA_ERR)
c     
      oprint_parm = util_print('parameters', print_default)
      oprint_conv = util_print('convergence', print_default)
      oprint_ls   = util_print('line search', print_high)
      oprint_vecs = util_print('intermediate vectors', print_debug)
      oprint_eval = util_print('intermediate evals', print_debug)
c
      tlastwrite = util_wallsec()
c     
      if (ga_nodeid().eq.0.and. oprint_parm) then
         write(6,1) gnorm_tol, maxiter, tol2e
         if (ouser_changed_conv) write(6,11) shifts, nr_gswitch
         write(6,111)
 1       format(//,
     $        1x,'----------------------------------------------',/
     $        1x,'        Quadratically convergent UHF',//,
     $        1x,'Convergence threshold     :',9x,1p,e10.3,0p,/,
     $        1x,'Maximum no. of iterations :',9x,i4,/,
     $        1x,'Integral*density screening:',9x,1p,e10.3,0p)
 11      format(/,
     $        1x,'PCG initial level shift   :',9x,f10.3,/,
     $        1x,'PCG change shift at maxg  :',9x,f10.3,/,
     $        1x,'PCG final level shift     :',9x,f10.3,/,
     $        1x,'NR  initial level shift   :',9x,f10.3,/,
     $        1x,'NR  change shift at maxg  :',9x,f10.3,/,
     $        1x,'NR  final level shift     :',9x,f10.3,/,
     $        1x,'NR  enabled at maxg       :',9x,f10.3)
 111     format(
     $        1x,'----------------------------------------------',/)
         call util_flush(6)
      end if
c
      ododiag = .true.
      odisable_nr = .false.
c     
c     PCG iterative loop
c     
      time_prev_iter = 0
      time_iter_start = util_wallsec()
c
      mode = 'startup'
      converged = .false.
 10   if (.not. converged) then
         call ga_pcg_minim(cuhf_vlen, iter, energy, g_grad, g_work,
     $        g_search, step, ls_tol, ls_max, eprec, oconjugacy, 
     $        oprint_conv, oprint_ls, iwork, dwork, mode)
c     
         if (mode .eq. 'energy+gradient') then
c     
c     Compute the energy and gradient at step*search direction
c     
            call uhf_step_energy(rtdb, step, g_search,
     $           eone, etwo, enrep, energy, g_grad)
            gnorm = sqrt(ga_ddot(g_grad, g_grad))
            call ecce_print1('total energy', mt_dbl, energy, 1)
            call ecce_print1('orbital gradient norm', mt_dbl, gnorm, 1)
c
c           == is this a oneshot "noscf" type calculation ==
            noscf = .false.
            if (.not.rtdb_get(rtdb, 'scf:noscf', mt_log, 1, noscf))
     &                      noscf=.false.
            if (noscf) converged = .true.
            goto 10
c     
         else if (mode .eq. 'precondition') then
c     
c     Precondition the gradient direction with approx./exact hessian
c     
            call uhf_search_precond(rtdb, g_grad, g_work)
            gnorm = sqrt(ga_ddot(g_grad, g_grad))
            goto 10
c     
         else if (mode .eq. 'accept step') then
c     
c     Apply the rotation and check for overall convergence.
c     The current fock matrices and energy correspond to the
c     updated MO coefficients.
c     
            call uhf_rotate_movecs(step, g_search)
            converged = gnorm .lt. gnorm_tol
            time_prev_iter = util_wallsec() - time_iter_start
            time_iter_start = util_wallsec()
            if ((iter.le.maxiter).and.(.not. converged)) then
c     
c     Not finished ... dump mo-vectors to disk for restart and
c     go back to top of loop
c     
               if (oprint_vecs) then
                  if (ga_nodeid() .eq. 0) then
                     write(6,*)
                     call util_print_centered(6,
     $                    'Intermediate MO vectors',40,.true.)
                     write(6,*)
                     call util_flush(6)
                  end if
                  call ga_print(g_movecs)
                  call ga_print(g_movecs(2))
               end if
               ttest = util_wallsec()-tlastwrite
               call ga_dgop(1324,ttest,1,'max')
               if (ttest .gt. 300) then
*     if (olock) call scf_movecs_lock
                 call scf_movecs_write(rtdb)
                 tlastwrite = util_cpusec()
               endif
               if (util_test_time_remaining(rtdb,time_prev_iter*3))
     $              goto 10
            end if
c            
         end if
      end if
c     
c     End SCF minimisation
c     
      if (ga_nodeid().eq.0) call util_flush(6)
c
      if (.not.noscf) then  ! bypass for noscf
c     
c     *ALWAYS* return canonical MOs ... do not do aufbau
c     
      call uhf_canon(.false., oprint_eval)
      if (oadapt) then
        call scf_movecs_sym_adapt(basis, g_movecs, .false.,
     $        0, 'after canon', .true., int_mb(k_irs))
        call scf_movecs_sym_adapt(basis, g_movecs(2), .false.,
     $        0, 'after canon', .true., int_mb(k_irs+nmo))
      endif
      call movecs_fix_phase(g_movecs)
      call movecs_fix_phase(g_movecs(2))
      if (olock) call scf_movecs_lock
      call scf_movecs_write(rtdb)
c
      end if  ! bypass for noscf
c     
c     Free globals
c     
      if (.not. ga_destroy(g_grad)) call errquit
     $     ('uhf_nr_solve: ga_destroy grad', 0, GA_ERR)
      if (.not. ga_destroy(g_search)) call errquit
     $     ('uhf_nr_solve: ga_destroy search', 0, GA_ERR)
      if (.not. ga_destroy(g_work)) call errquit
     $     ('uhf_nr_solve: ga_destroy work', 0, GA_ERR)
c     
      if (ga_nodeid().eq.0) call util_flush(6)
      call ga_sync()
c     
      uhf_nr_solve = converged
c     
      end
      subroutine uhf_step_energy(rtdb, step, g_search,
     $     eone, etwo, enrep, energy, g_grad)
      implicit none
#include "errquit.fh"
#include "cuhf.fh"
#include "cscfps.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "cscf.fh"
c
      integer rtdb
      double precision step
      integer g_search
      double precision eone, etwo, enrep, energy
      integer g_grad
c
c     Compute the energy and gradient at the given step
c
      integer g_tmp(2)
      if (oscfps) call pstat_on(ps_search)
c
c     Apply rotation
c
      if (.not. ga_create(MT_DBL, nbf, nmo, 'uhf_s_e: alpha MOs',
     $     32, 32, g_tmp(1))) call errquit('uhf_s_e: MOs', 0, GA_ERR)
      if (.not. ga_create(MT_DBL, nbf, nmo, 'uhf_s_e: beta MOs',
     $     32, 32, g_tmp(2))) call errquit('uhf_s_e: MOs', 0, GA_ERR)
c
      call uhf_rotate(step, g_search, g_movecs, g_tmp)
c
c     Compute energy and gradient
c     
      call uhf_energy(rtdb, g_tmp, eone, etwo, enrep, energy, g_grad)
c     
c     Tidy up
c
      if (.not. ga_destroy(g_tmp(1))) call errquit
     $     ('uhf_nr_solve: tmp?', 0, GA_ERR)
      if (.not. ga_destroy(g_tmp(2))) call errquit
     $     ('uhf_nr_solve: tmp?', 0, GA_ERR)
c
      if (oscfps) call pstat_off(ps_search)
c
      end
      subroutine uhf_rotate_movecs(step, g_search)
      implicit none
#include "errquit.fh"
#include "cuhf.fh"
#include "cscf.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "cscfps.fh"
      double precision step
      integer g_search
c
      integer g_tmp(2)
c
c     Apply rotation
c
      if (.not. ga_create(MT_DBL, nbf, nmo, 'uhf_s_e: alpha MOs',
     $     32, 32, g_tmp(1))) call errquit('uhf_s_e: MOs', 0, GA_ERR)
      if (.not. ga_create(MT_DBL, nbf, nmo, 'uhf_s_e: beta MOs',
     $     32, 32, g_tmp(2))) call errquit('uhf_s_e: MOs', 0, GA_ERR)
c
      call uhf_rotate(step, g_search, g_movecs, g_tmp)
      call ga_copy(g_tmp(1), g_movecs(1))
      call ga_copy(g_tmp(2), g_movecs(2))
c
      if (.not. ga_destroy(g_tmp(1))) call errquit('urm: destroy?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_tmp(2))) call errquit('urm: destroy?',0,
     &       GA_ERR)
c
      end
      subroutine uhf_rotate(step, g_k, g_mos_in, g_mos_out)
      implicit none
#include "cuhf.fh"
#include "cscf.fh"
#include "global.fh"
      double precision step
      integer g_k, g_mos_in(2), g_mos_out(2)
c
c     Generate MOs * Exp(-step*K) in temporary arrays
c     
      double precision scale
c
      if (step .ne. 0.0d0) then
         call ga_dscal(g_k, step)
         call uhf_k2cf(basis,
     $        nbf, nmo, nalpha, nbeta,
     $        g_k, g_mos_in, g_mos_out)
         scale = 1.0d0 / step
         call ga_dscal(g_k, scale)
      else
         call ga_copy(g_mos_in(1), g_mos_out(1))
         call ga_copy(g_mos_in(2), g_mos_out(2))
      end if
c
      end
      subroutine uhf_k2cf(basis, nbf, nmo, nalpha, nbeta, g_kvec,
     $     g_mocf_in, g_mocf_out)
C$Id: uhf.F 25603 2014-05-13 01:11:35Z niri $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
c
c     given the step in g_kvec generate the exponential rotation
c     and apply it to the input vectors
c
c     currently the step is interpreted as being the alpha rotations
c     followed by the beta rotations ... this will change when the
c     singlet/triplet rotations are adopted.
c     
      integer nbf, nmo, basis, nalpha, nbeta
      integer g_kvec
      integer g_mocf_out(2), g_mocf_in(2)
c     
      integer nocc, nvir, nocc1, ioff
      integer g_kmat
      integer i, l_tmp, k_tmp, iset
      double precision mone, one, zero, maxk
      parameter(mone=-1.0d0, one=1.0d0, zero=0.0d0)
c     
      call ga_sync()
c     
      if (.not. ma_push_get(mt_dbl,nmo,'temp k',l_tmp,k_tmp))
     $     call errquit('uhf_k2cf: ma failed on tmp',  nmo, MA_ERR)
      if (.not. ga_create(mt_dbl, nmo, nmo, 'uhf_k2cf:kmat',
     $     32, 32, g_kmat)) call errquit('uhf_k2cf:ga_create?', nmo,
     &       MA_ERR)
c
      do iset = 1, 2            ! 1= alpha, 2= beta
c
         if (iset .eq. 1) then
            nocc = nalpha
            ioff = 0
         else
            nocc = nbeta
            ioff = nalpha*(nmo - nalpha)
         end if
         nvir  = nmo - nocc
         nocc1 = nocc + 1
c     
c     form k-matrix from vector
c
         call ga_zero(g_kmat)
         if (nvir*nocc .gt.0) then
            do i=ga_nodeid()+1,nocc,ga_nnodes()
               call ga_get(g_kvec, ioff+1+(i-1)*nvir, ioff+i*nvir, 1, 1,
     $              dbl_mb(k_tmp), 1)
               call ga_put(g_kmat, nocc1, nmo, i, i,
     $              dbl_mb(k_tmp), 1)
               call dscal(nvir, mone, dbl_mb(k_tmp), 1)
               call ga_put(g_kmat, i, i, nocc1, nmo,
     $              dbl_mb(k_tmp), 1)
            end do
         endif
c
c     Make near zeoes exactly zero so that sparsity tests in the
c     matrix multiply work well.  Can't screen with too large
c     a value since this breaks symmetry in non-abelian groups.
c     Must also allow value to tend to zero to allow for tight
c     convergence.
c
         call ga_maxelt(g_kmat, maxk)
         call ga_screen(g_kmat, min(maxk*maxk,maxk*1d-2,1d-12))
c
c     Exponentiate the matrix and apply the rotation
c
         call matrix_exp(g_kmat)
         call ga_dgemm('n', 'n', nbf, nmo, nmo, one, g_mocf_in(iset),
     $        g_kmat, zero, g_mocf_out(iset))
c
*     call ga_orthog_mos(basis, g_mocf_out(iset)) ! No longer necessary
      end do
c
      if (.not. ga_destroy(g_kmat))
     $     call errquit('uhf_k2cf: ga_destroy?', 0, GA_ERR)
      if (.not. ma_pop_stack(l_tmp))
     $     call errquit('uhf_k2cf: pop failed', 0, MA_ERR)
c     
      end
      subroutine uhf_energy(rtdb, g_vecs, eone, etwo, enrep, energy,
     $     g_grad )
c
      implicit none
c
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "geom.fh"
#include "cuhf.fh"
#include "cscf.fh"
#include "util.fh"
#include "cscfps.fh"
#include "rtdb.fh"
#include "bgj.fh"
#include "case.fh"
#include "zora.fh"
#include "frozemb.fh"
#include "cosmo.fh"
c     
c     $Id: uhf.F 25603 2014-05-13 01:11:35Z niri $
c
      integer rtdb
      integer g_vecs(2)
      double precision energy
      integer g_grad
c     
      double precision eone, etwo, enrep
      integer gtype, grow, gcol
      integer d(4), f(6), nfock
      integer g_a_dens, g_a_coul, g_a_exch, g_a_xc
      integer g_b_dens, g_b_coul, g_b_exch, g_b_xc
      integer g_hcore
      integer g_tmp(6),ifock
      double precision jfac(4), kfac(4), one, zero, mone
      parameter (one=1.0d0, zero=0.0d0, mone=-1.0d0)
      double precision e_a_coul, e_a_exch, e_b_coul, e_b_exch,
     &     e_a_xc, e_b_xc
      double precision errmaxa, errmaxb
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
      logical odebug
      logical cphf_uhf
      double precision ecosmo
      integer g_dens(2),i
      character*255 cosmo_file
c     
c     Check
c     
      odebug = util_print('uhf_debug', print_debug)
      call uhf_jkfac(jfac,kfac)
      if (.not.cuhf_init_flag)
     $     call errquit('uhf_energy: UHF internal block invalid',0,
     &       UNKNOWN_ERR)
      call ga_inquire(g_grad, gtype, grow, gcol)
      if ((grow.ne.cuhf_vlen).or.(gcol.ne.1))
     $     call errquit('uhf_energy: invalid vector length',0, GA_ERR)
      cphf_uhf = .false.
      if (.not. rtdb_get(bgj_get_rtdb_handle(), 
     &     'cphf_solve:cphf_uhf', mt_log, 1, cphf_uhf)) then
         cphf_uhf = .false.
      endif
c     
c     Arrays for AO density, coulomb and exchange matrices
c
      g_a_coul = ga_create_atom_blocked(geom, basis, 'uhf:a coul')
      g_b_coul = ga_create_atom_blocked(geom, basis, 'uhf:b coul')
      g_a_exch = ga_create_atom_blocked(geom, basis, 'uhf:a exch')
      g_b_exch = ga_create_atom_blocked(geom, basis, 'uhf:b exch')
      if(cphf_uhf)then
         g_a_xc   = ga_create_atom_blocked(geom, basis, 'uhf:a xc')
         g_b_xc   = ga_create_atom_blocked(geom, basis, 'uhf:b xc')
      endif
      g_a_dens = ga_create_atom_blocked(geom, basis, 'uhf:a dens')
      g_b_dens = ga_create_atom_blocked(geom, basis, 'uhf:b dens')
      call ga_zero(g_a_dens)
      call ga_zero(g_b_dens)
c
c     Make the densites and build the fock matrices
c
      if (nalpha .gt. 0) then
         call ga_dgemm('n', 't', nbf, nbf, nalpha, one, g_vecs(1),
     $        g_vecs(1), zero, g_a_dens)
      else
         call ga_zero(g_a_dens)
      endif
      if (nbeta .gt. 0) then
         call ga_dgemm('n', 't', nbf, nbf, nbeta, one, g_vecs(2),
     $        g_vecs(2), zero, g_b_dens)
      else
         call ga_zero(g_b_dens)
      endif
c
c     Since UHF can break spatial symmetry by localizing the orbitals
c     the densities may not be totally symmetric, but since the Hamiltonian
c     is symmetric contraction with the integrals projects out the totally 
c     symmetric component ... hence we can symmetrize the densities and
c     exploit symmetry.  Compute the max change in any element due to
c     symmetrizing and print a warning if it is big.
c
c     !! If this is the case then where does the 'force' for symmetry breaking
c     come from?  Must be missing something?
c
      call ga_copy(g_a_dens,g_a_coul)
      call ga_copy(g_b_dens,g_b_coul)
      if (oskel) then
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .true., g_a_dens)
         if (oscfps) call pstat_off(ps_sym_sym)
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .true., g_b_dens)
         if (oscfps) call pstat_off(ps_sym_sym)
      endif
      call ga_dadd(one, g_a_dens, mone, g_a_coul, g_a_coul)
      call ga_dadd(one, g_b_dens, mone, g_b_coul, g_b_coul)
      call ga_maxelt(g_a_coul, errmaxa)
      call ga_maxelt(g_b_coul, errmaxb)
      if (max(errmaxa,errmaxb).gt.1d-4) then
         if (ga_nodeid().eq.0) then
            write(6,77) errmaxa,errmaxb
 77         format(' Warning: spatial symmetry breaking in UHF: ',
     $           1p,2d9.2)
            call util_flush(6)
         endif
      endif
c
      if (odebug) then
         call ga_print(g_vecs(1))
         call ga_print(g_vecs(2))
         call ga_print(g_a_dens)
         call ga_print(g_b_dens)
      endif
 
      call ga_zero(g_a_coul)
      call ga_zero(g_b_coul)
      call ga_zero(g_a_exch)
      call ga_zero(g_b_exch)
      if(cphf_uhf)then
         call ga_zero(g_a_xc)
         call ga_zero(g_b_xc)
      endif
      d(1) = g_a_dens
      d(2) = g_a_dens
      d(3) = g_b_dens
      d(4) = g_b_dens
      f(1) = g_a_coul
      f(2) = g_a_exch
      f(3) = g_b_coul
      f(4) = g_b_exch
      if(cphf_uhf)then
         f(5) = g_a_xc
         f(6) = g_b_xc
      endif
c
czz   two extra ga's are passed to fock_2e to get the xc matrix
c
      if(cphf_uhf)then
         nfock = 6
      else
         nfock = 4
      endif
      call do_riscf (.false.)
      if (.not.cam_exch) then
        call fock_2e(geom, basis, nfock, jfac, kfac, tol2e,
     $     oskel, d, f, .false.)
      else ! for attenuated calculations
c
c       calculate the CAM exchange
c
        do ifock = 1,nfock
           g_tmp(ifock) = ga_create_atom_blocked(geom, basis, 'tmp')
           call ga_zero(g_tmp(ifock))
        end do
c
        call case_setflags(.true.)  ! set LC flag
        jfac(1)=0d0
        jfac(2)=0d0
        jfac(3)=0d0
        jfac(4)=0d0
        kfac(1)=0d0
        kfac(2)=1d0
        kfac(3)=0d0
        kfac(4)=1d0
        call fock_2e_cam(geom, basis, nfock, jfac, kfac, tol2e, 
     &     oskel, d, g_tmp, .false., .false.)
        call ga_dadd(1d0,f(2),1d0,g_tmp(2),f(2))  ! LC exchange part
        call ga_dadd(1d0,f(4),1d0,g_tmp(4),f(4))  ! LC exchange part
c
c       calculate the full Coulomb
c
        do ifock = 1,nfock
           call ga_zero(g_tmp(ifock))
        end do
        call case_setflags(.false.) ! turn off LC flag for full Coulomb
        jfac(1)=1d0
        jfac(2)=0d0
        jfac(3)=1d0
        jfac(4)=0d0
        kfac(1)=0d0
        kfac(2)=0d0
        kfac(3)=0d0
        kfac(4)=0d0
        call fock_2e_cam(geom, basis, nfock, jfac, kfac, tol2e, 
     &     oskel, d, g_tmp, .false., .true.)   ! last argument toggles xc
        call ga_dadd(1d0,f(1),1d0,g_tmp(1),f(1))   ! full Coulomb part
        call ga_dadd(1d0,f(3),1d0,g_tmp(3),f(3))   ! full Coulomb part
        call ga_dadd(1d0,f(2),1d0,g_tmp(2),f(2))   ! DFT xc part
        call ga_dadd(1d0,f(4),1d0,g_tmp(4),f(4))   ! DFT xc part
c
c       destroy work space
        if (.not. ga_destroy(g_tmp)) 
     &   call errquit('uhf: ga corrupt?',0, GA_ERR)
      end if  ! cam_exch
      call do_riscf (.true.)
c
      e_a_coul = 0.5d0*
     $     (ga_ddot(g_a_dens,g_a_coul) + ga_ddot(g_a_dens,g_b_coul))
      e_b_coul = 0.5d0*
     $     (ga_ddot(g_b_dens,g_a_coul) + ga_ddot(g_b_dens,g_b_coul))
      e_a_exch = 0.5d0*ga_ddot(g_a_dens,g_a_exch)
      e_b_exch = 0.5d0*ga_ddot(g_b_dens,g_b_exch)
      etwo = e_a_coul + e_b_coul - e_a_exch - e_b_exch 
      if(cphf_uhf)then
         e_a_xc = ga_ddot(g_a_dens,g_a_xc)
         e_b_xc = ga_ddot(g_b_dens,g_b_xc)
         etwo = etwo + e_a_xc + e_b_xc        
      endif
c
      if (odebug .and. ga_nodeid().eq.0) then
         write(6,*) ' coulomb energies', e_a_coul, e_b_coul
         write(6,*) ' exchang energies', e_a_exch, e_b_exch
         call util_flush(6)
      endif
      if (odebug) then
         call ga_print(g_a_coul)
         call ga_print(g_a_exch)
      endif
c
c     Form energies and AO fock matrices
c
c     Fa (in g_a_coul) = h + J(a) + J(b) - K(a)
c     Fb (in g_b_coul) = h + J(a) + J(b) - K(b)
c
c     E = ((Da + Db)*h + Da*Fa + Db*Fb) / 2
c     Eone = h * (Da + Db)
c
c     2e denotes 2-electron components only
c
      call ga_dadd(one, g_a_coul, one, g_b_coul, g_a_coul)
      call ga_copy(g_a_coul, g_b_coul)
      call ga_dadd(one, g_a_coul, mone, g_a_exch, g_a_coul)
      call ga_dadd(one, g_b_coul, mone, g_b_exch, g_b_coul)
      if(cphf_uhf)then
         call ga_dadd(one, g_a_coul, one, g_a_xc, g_a_coul)
         call ga_dadd(one, g_b_coul, one, g_b_xc, g_b_coul)
      endif
c
c     reuse g_a_exch to hold the 1-e integrals
c
      g_hcore = g_a_exch
      call ga_zero(g_hcore)
      call int_1e_ga(basis, basis, g_hcore, 'kinetic', oskel)  ! kinetic
      if (do_zora .and. .not.(do_NonRel)) then
        call ga_dadd(1.d0,g_hcore,1.d0,g_zora_Kinetic(1),g_hcore) ! zora kinetic
      endif
      call int_1e_ga(basis, basis, g_hcore, 'potential', oskel) ! potential
c
c     cosmo charges, potential and energy contribution
c
      if(cosmo_on.and.cosmo_phase.eq.2) then
        cosmo_file = "cosmo.xyz"
        do i = 1, 2
         g_dens(i) = ga_create_atom_blocked(geom,basis,'density matrix')
         call ga_zero(g_dens(i))
        end do
        call ga_copy(g_a_dens,g_dens(1))  ! alpha = 1
        call ga_copy(g_b_dens,g_dens(2))  ! beta = 2
        call cosmo_charges_from_dmat(rtdb, basis, geom, ecosmo, odebug, 
     &                                  2,           ! 2 = open shell 
     &                                  g_dens,      ! input density
     &                                  cosmo_file)  ! cosmo charges file name
        call int_1e_ga(basis,basis,g_hcore,'cos_chg_pot',.false.)
        do i = 1, 2
         if (.not.ga_destroy(g_dens(i)))
     &    call errquit('uhf_energy: ga_destroy failed g_dens',0,GA_ERR)
        enddo
      endif  ! cosmo check
c
c     add in frozen embedding
      if (frozemb) then
        call ga_dadd(1.d0,g_hcore,1.d0,g_frozemb,g_hcore)
      end if
c
      call ga_sync()
c
      eone = 
     $     (ga_ddot(g_a_dens,g_hcore) + ga_ddot(g_b_dens,g_hcore))
      call ga_dadd(one, g_hcore, one, g_a_coul, g_a_coul)
      call ga_dadd(one, g_hcore, one, g_b_coul, g_b_coul)
c
      if (oskel) then
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .false., g_a_coul)
         if (oscfps) call pstat_off(ps_sym_sym)
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .false., g_b_coul)
         if (oscfps) call pstat_off(ps_sym_sym)
      endif
c
      if (odebug) then
         call ga_print(g_a_coul)
         call ga_print(g_b_coul)
      endif
c
c     Transform the Fock matrices to the MO basis using g_a_dens for scratch
c
      call two_index_transf(g_a_coul, g_vecs(1), g_vecs(1),
     $     g_a_dens, cuhf_g_falpha)
      call two_index_transf(g_b_coul, g_vecs(2), g_vecs(2),
     $     g_a_dens, cuhf_g_fbeta)
c
      if (odebug) then
         call ga_print(cuhf_g_falpha)
         call ga_print(cuhf_g_fbeta)
      endif
c
c     Free up dead global arrays
c
      if (.not. ga_destroy(g_a_dens)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_b_dens)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if(cphf_uhf)then
         if (.not. ga_destroy(g_a_xc)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
         if (.not. ga_destroy(g_b_xc)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      endif
      if (.not. ga_destroy(g_a_exch)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_b_exch)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_a_coul)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_b_coul)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
c
c     extract the gradient
c
      call uhf_get_grad(g_grad)
c
      if (odebug) call ga_print(g_grad)
c
      if (.not. geom_nuc_rep_energy(geom, enrep))
     $     call errquit('uhf_energy: no repulsion energy?', 0, GEOM_ERR)
      energy = eone + etwo + enrep
c
c     cosmo energy term 
c
      if(cosmo_on.and.cosmo_phase.eq.2) then
         if (.not. rtdb_get(rtdb,'cosmo:energy',mt_dbl,1,ecosmo))
     $     call errquit('rohf_energy: rtdb get failed for ecosmo',911,
     &       RTDB_ERR)
         energy=energy+ecosmo
      endif  ! cosmo check
c
      if (odebug .and. ga_nodeid().eq.0) then
         write(6,*) ' eone, etwo, enrep, energy ',
     $        eone, etwo, enrep, energy
      endif
c
      end
      subroutine uhf_get_grad(g_grad)
      implicit none
#include "cscf.fh"
#include "cuhf.fh"
#include "mafdecls.fh"
      integer g_grad
c
      integer ioff
      integer nvir, ivoff
      double precision maxelt
c
      call ga_copy_patch('n',
     $     cuhf_g_falpha, nalpha+1, nmo, 1, nalpha,
     $     g_grad, 1, (nmo-nalpha)*nalpha, 1, 1)
c
      ioff = (nmo-nalpha)*nalpha
      call ga_copy_patch('n',
     $     cuhf_g_fbeta, nbeta+1, nmo, 1, nbeta,
     $     g_grad, ioff+1, ioff+(nmo-nbeta)*nbeta, 1, 1)
c
      call ga_dscal(g_grad, 2.0d0)
c
      if(oadapt) then
        nvir = nmo - nalpha
        call scf_sym_screen(nalpha, 0, nvir, int_mb(k_irs),
     $       g_grad, 0, .true., maxelt)
        nvir = nmo - nbeta
        ivoff = nalpha*(nmo-nalpha)
        call scf_sym_screen(nbeta, 0, nvir, int_mb(k_irs+nmo),
     $       g_grad, ivoff, .true., maxelt)
      endif
c
      end
      subroutine uhf_search_precond(rtdb, g_grad, g_work)
      implicit none
#include "cuhf.fh"      
#include "cscfps.fh"
#include "global.fh"
#include "cscf.fh"
#include "util.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
      integer rtdb
      integer g_grad
      integer g_work
c
c     Precondition the gradient with an approximation to the Hessian
c     return the result in g_work.
c
c     Old version only divided by the level-shifted diagonals which 
c     is in rohf the preconditioner to the preconditioner!
c
      logical oprint_conv, oprint_eval, oprint_debug, oprint_solve
      double precision gnorm
      double precision max_grad
      double precision min_shift
      integer max_precond_iter  ! Max. no. of iters for preconditioner
      integer max_precond_sub   ! Max. dim. of precond. iterative space
      parameter (max_precond_iter=20)
c
      double precision precond_acc ! Accuracy attained by solver
      integer precond_iter       ! No. of iterations used by solver
c
      integer nvir, ivoff
      double precision maxelt
c
      external uhf_precond, uhf_hessv
      logical ga_iter_lsolve
      external ga_iter_lsolve
c
      oprint_conv = util_print('convergence', print_default)
      oprint_eval = util_print('intermediate evals', print_debug)
      oprint_debug= util_print('uhf_debug', print_debug)
      oprint_solve= util_print('solve', print_high)
c
      if (.not.rtdb_get(rtdb, 'scf:maxsub', MT_INT, 1, 
     $     max_precond_sub)) max_precond_sub = 10
c
      call ga_maxelt(g_grad, max_grad)
      gnorm = sqrt(ga_ddot(g_grad, g_grad))
      eprec = max(1d-7,gnorm*0.01d0, tol2e*100.0d0) ! Approx precision available
c
c     Determine shift necessary to make the preconditioner
c     positive definite
c
 30   continue
      call uhf_make_shift(min_shift)
c
c     Figure out which preconditioner to use, convergence
c     thresholds, shifts, ...
c
      call scf_precond_select(gnorm, max_grad, min_shift,
     $     oprint_conv)
c
c     Do a diagonalization if it will make the Hessian more
c     diagonally dominant
c
      if (ododiag) then
         call uhf_canon(.false., oprint_eval)
         if (oadapt) then
           call scf_movecs_sym_adapt(basis, g_movecs, .false.,
     $           0, 'after canon', .true., int_mb(k_irs))
           call scf_movecs_sym_adapt(basis, g_movecs(2), .false.,
     $           0, 'after canon', .true., int_mb(k_irs+nmo))
         endif
         call uhf_get_grad(g_grad)
         call uhf_make_shift(min_shift) ! Recompute
      end if
c
c     After doing the diag make sure that the shift is still OK
c
      if (lshift .lt. min_shift) then
         lshift = min_shift + 2.0d0
         if (ga_nodeid().eq.0 .and. oprint_conv) then
            write(6,3131) lshift
 3131       format('  Setting level-shift to ', f6.2,
     $           ' to force positive preconditioner')
            call util_flush(6)
         end if
      end if
c
c     Next to lines precondition with just the eigenvalue differences
c
*      call ga_copy(g_grad,g_work)
*      call uhf_precond(g_work, 0.0d0)
c
      call ga_zero(g_work)      ! ESSENTIAL
c     
c     Attempt to solve the damned equations
c
*      write(6,*) ' pflg ', pflg
c
 20   if (.not. ga_iter_lsolve(cuhf_vlen, max_precond_iter,
     $     max_precond_sub, precond_tol, 
     $     uhf_precond, uhf_hessv, .true., oprint_solve, 
     $     g_grad, g_work, precond_acc, precond_iter)) then
c     
c     Iterative solution did not converge.  If we got at least
c     1 sig. fig. then just continue.  Otherwise for the 1-e
c     approximation increase the level-shift and restart with
c     the current vector as guess.  If the 2-e approximation did
c     not converge disable it forever and resort to the 1-e method.
c     
         if (precond_acc .gt. 0.1d0) then
            if (pflg .eq. 2) then
               odisable_nr = .true.
               maxiter = maxiter + 10
               if (ga_nodeid() .eq. 0 .and. oprint_conv) then
                  write(6,22) maxiter
 22               format(/' Disabled NR: increased maxiter to ',i3/)
                  call util_flush(6)
               endif
               goto 30
            else
               if (lshift .eq. 0.0d0) then
                  lshift = 2.0d0
                  call ga_zero(g_work)
               else
                  lshift = lshift*2.0d0
               endif
            endif
            if (ga_nodeid() .eq. 0 .and. oprint_conv) then
               write(6,2) lshift
 2             format(' Increased level shift to ', f8.2)
               call util_flush(6)
            endif
            goto 20
         endif
      endif
c
      if(oadapt) then
        nvir = nmo - nalpha
        call scf_sym_screen(nalpha, 0, nvir, int_mb(k_irs),
     $       g_work, 0, .true., maxelt)
        nvir = nmo - nbeta
        ivoff = nalpha*(nmo-nalpha)
        call scf_sym_screen(nbeta, 0, nvir, int_mb(k_irs+nmo),
     $       g_work, ivoff, .true., maxelt)
      endif
c
      end
      subroutine uhf_precond(g_x, solveshift)
      implicit none
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "cscf.fh"
#include "cuhf.fh"
      integer g_x
      double precision solveshift
c      
      integer nvir, nocc(2), iset
      integer i, j, ioff, ibase
      integer l_diag, k_diag, l_x, k_x
      integer g_f(2), ivec, nvec, gtype, vlen
      double precision diag, denominator, shift, dnrm
      integer ilo(2), ihi(2)
c
      logical oprint, olprint
c
      diag(i) = dbl_mb(k_diag + i - 1)
c     
      g_f(1) = cuhf_g_falpha
      g_f(2) = cuhf_g_fbeta
      nocc(1) = nalpha
      nocc(2) = nbeta
c
      oprint = util_print('precond',print_high)
      olprint = oprint .and. (ga_nodeid().eq.0)
c
      if (.not.ma_push_get(MT_DBL,nmo,'uhf: tmp',l_diag,k_diag))
     $     call errquit('uhf_precond: cannot allocate',0, MA_ERR)
      if (.not.ma_push_get(MT_DBL,nmo,'uhf: tmp',l_x,k_x))
     $     call errquit('uhf_hdiag_scale: cannot allocate',0, MA_ERR)
c
      call ga_sync()
      call ga_inquire(g_x, gtype, vlen, nvec)
c
      shift = lshift - solveshift
c
      if (oprint) then
        do ivec = 1, nvec
          ilo(1) = 1
          ilo(2) = ivec
          ihi(1) = vlen
          ihi(2) = ivec
          call nga_normf_patch(g_x,ilo,ihi,dnrm)
          if (olprint) then
            write(LuOut,'(1x,a,": in g_x = ",i4,f24.8)')
     +      __FILE__,ivec,dnrm
          endif
        enddo
      endif
c
      ibase = 1
      do iset = 1, 2
         nvir = nmo - nocc(iset)
         if (nvir .gt. 0) then
            call ga_get_diagonal(g_f(iset), dbl_mb(k_diag))
            do ivec = 1, nvec
               do i = ga_nodeid()+1, nocc(iset), ga_nnodes()
                  ioff = (i-1)*nvir + ibase
                  call ga_get(g_x, ioff, ioff+nvir-1, ivec, ivec,
     $                 dbl_mb(k_x),1)
                  do j=1,nvir
                     denominator = 2.d0 * (diag(j+nocc(iset)) - diag(i))
     $                    + shift
                     if (denominator .lt. 0.1d0) denominator = 0.1d0
                     dbl_mb(k_x+j-1) = dbl_mb(k_x+j-1) / denominator
                  end do
                  call ga_put(g_x, ioff, ioff+nvir-1, ivec, ivec,
     $                 dbl_mb(k_x),1)
               end do
            enddo
         endif
         ibase = ibase + nocc(1)*(nmo-nocc(1))
      end do
c
      if (oprint) then
        do ivec = 1, nvec
          ilo(1) = 1
          ilo(2) = ivec
          ihi(1) = vlen
          ihi(2) = ivec
          call nga_normf_patch(g_x,ilo,ihi,dnrm)
          if (olprint) then
            write(LuOut,'(1x,a,": out g_x = ",i4,f24.8)')
     +      __FILE__,ivec,dnrm
          endif
        enddo
      endif
c
      if (.not. ma_pop_stack(l_x)) call errquit('uhf:pop x',0, MA_ERR)
      if (.not. ma_pop_stack(l_diag)) call errquit('uhf:pop ',0, MA_ERR)
      call ga_sync()
c
      end
      subroutine uhf_make_shift(shift)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "cuhf.fh"
#include "cscf.fh"
c
c     Return minimum shift necessary for diagonal approximation
c     to 1-e Hessian to be positive definite
c
      double precision shift
c
      integer l_diag, k_diag
      double precision shift_a, shift_b
c
      if (.not. ma_push_get(mt_dbl, nmo, 'uhf_m_s: diag', 
     $     l_diag, k_diag)) call errquit
     $     ('uhf_make_shift: insufficient memory', nmo, MA_ERR)
c
      call ga_sync()
c
      shift_a = 0.0d0
      shift_b = 0.0d0
c
      call rohf_make_shift_2(cuhf_g_falpha, dbl_mb(k_diag),
     $     1, nalpha, nalpha+1, nmo, oadapt, int_mb(k_irs),
     $     2.0d0, shift_a)
      call rohf_make_shift_2(cuhf_g_fbeta, dbl_mb(k_diag),
     $     1, nbeta, nbeta+1, nmo, oadapt, int_mb(k_irs+nmo),
     $     2.0d0, shift_b)
c
      shift = max(shift_a, shift_b)
c
      if (.not. ma_pop_stack(l_diag)) call errquit('uhf_n_s: e',0,
     &       MA_ERR)
c
      end
      subroutine uhf_canon(oaufbau, oprint)
C$Id: uhf.F 25603 2014-05-13 01:11:35Z niri $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "cscfps.fh"
#include "cscf.fh"
#include "cuhf.fh"
      logical oaufbau
      logical oprint
c
      integer nocc(2), ioff, iset
      integer g_u, g_fock, g_f(2), g_tmp
      double precision one, zero
      data one, zero/1.d0, 0.d0/
c
c     This routine assumes that uhf_energy/uhf_fock have been called
c     so that the contents of /cuhf/ are current.
c
c     Diagonalize the UHF 'Fock' matrices
c     
c     If (oaufbau) 
c        diagonalize the whole thing and allow mixing of occ-virt
c     else
c        diagonalize separately the occ-occ, and virt-virt parts
c
c     Transform Fock matrices and MO coefficients into the new canonical basis
c
      if (.not. ga_create(MT_DBL, nmo, nmo, 'uhf_canon: u',
     $     32, 32, g_u)) call errquit('uhf_canon: ga failed for u', 0,
     &       GA_ERR)
      if (.not. ga_create(MT_DBL, nmo, nmo, 'uhf_canon: fock',
     $     32, 32, g_fock)) call errquit
     $     ('uhf_canon: ga failed for fock', 0, GA_ERR)
c
      g_f(1) = cuhf_g_falpha
      g_f(2) = cuhf_g_fbeta
      nocc(1) = nalpha
      nocc(2) = nbeta
c
      ioff = 0
      do iset = 1, 2
c
         if (oscfps) call pstat_on(ps_diag)
c
         call ga_zero(g_u)
         call ga_copy(g_f(iset), g_fock)
c     
         if (oaufbau) then
#if defined(PARALLEL_DIAG)
#ifdef SCALAPACK
            call ga_pdsyev(g_fock, g_u, dbl_mb(k_eval+ioff), 0)
#else
            call ga_diag_std(g_fock, g_u, dbl_mb(k_eval+ioff))
#endif
#else 
            call ga_diag_std_seq(g_fock, g_u, dbl_mb(k_eval+ioff))
#endif
         else
c     
c     occ-occ piece
c
            if (nocc(iset) .gt. 0) call rohf_canon_subspace
     $           (g_fock, g_u, dbl_mb(k_eval+ioff),
     $           1, nocc(iset), int_mb(k_irs+(iset-1)*nmo))
c
c     virt-virt piece
c     
            if (nmo-nocc(iset) .gt. 0)
     $           call rohf_canon_subspace(g_fock, g_u,
     $           dbl_mb(k_eval+ioff+nocc(iset)),
     $           nocc(iset)+1, nmo, int_mb(k_irs+(iset-1)*nmo))

         end if
c
         ioff = ioff + nbf
c
         if (oscfps) call pstat_off(ps_diag)
c
         call movecs_fix_phase(g_u)
c
c     Apply rotation to orbitals and fock matrix
c
         if (.not. ga_create(MT_DBL, nbf, nmo, 'uhf_canon: tmp',
     $        32, 32, g_tmp)) call errquit
     $        ('uhf_canon: ga failed for tmp', 0, GA_ERR)
         call ga_copy(g_movecs(iset), g_tmp)
         call ga_dgemm('n', 'n', nbf, nmo, nmo, one, g_tmp, g_u,
     $        zero, g_movecs(iset))
c
         if (nbf .ne. nmo) then
            if (.not. ga_destroy(g_tmp))
     $           call errquit('uhf_canon: destroy', 0,
     &       GA_ERR)
            if (.not. ga_create(MT_DBL, nmo, nmo, 'uhf_canon: tmp',
     $           32, 32, g_tmp)) call errquit
     $           ('uhf_canon: ga failed for tmp', 0, GA_ERR)
         endif
c
         call ga_dgemm('n', 'n', nmo, nmo, nmo, one, g_f(iset), g_u,
     $        zero, g_tmp)
         call ga_dgemm('t', 'n', nmo, nmo, nmo, one, g_u, g_tmp, 
     $        zero, g_f(iset))
c
         if (.not. ga_destroy(g_tmp))
     $        call errquit('uhf_canon: destroy', 0, GA_ERR)
      end do
c
      if (oprint .and. ga_nodeid().eq.0) then
         write(6,*)
         write(6,*)
         call util_print_centered(6, 'Alpha-spin eigenvalues',
     $        20, .true.)
         call output(dbl_mb(k_eval), 1, min(nalpha+5,nmo), 
     $        1, 1, nmo, 1, 1)
         write(6,*)
         call util_print_centered(6, 'Beta-spin eigenvalues',
     $        20, .true.)
         call output(dbl_mb(k_eval+nbf), 1, min(nalpha+5,nmo), 
     $        1, 1, nmo, 1, 1)
         call util_flush(6)
      end if
c
      if (.not. ga_destroy(g_u))
     $     call errquit('uhf_canon: destroy', 0, GA_ERR)
      if (.not. ga_destroy(g_fock))
     $     call errquit('uhf_canon: destroy', 0, GA_ERR)
c
      end
      subroutine uhf_spin(sz, s2)
      implicit none
#include "errquit.fh"
#include "cscf.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
      double precision sz, s2
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
c
c     Return the expection values of Sz and S^2
c
      integer g_smo, g_over, g_work, l_x, k_x, i, j
c
      sz = 0.5d0 * (nalpha - nbeta)
c     
c     Form Sab
c
      g_over = ga_create_atom_blocked(geom, basis, 'uhf_spin: over')
*      if (.not. ga_create(MT_DBL, nbf, nbf, 'uhf_spin: overlap',
*     $     32, 32, g_over)) call errquit('uhf_spin: overlap', 0)
      if (.not. ga_create(MT_DBL, nbf, nmo, 'uhf_spin: work',
     $     32, 32, g_work)) call errquit('uhf_spin: work', 0, GA_ERR)
      if (.not. ga_create(MT_DBL, nmo, nmo, 'uhf_spin: overlap',
     $     32, 32, g_smo)) call errquit('uhf_spin: overlap', 0, GA_ERR)
c      
      call ga_zero(g_over)
      call int_1e_ga(basis, basis, g_over, 'overlap', .false.)
      call two_index_transf(g_over, g_movecs(1), g_movecs(2),
     $     g_work, g_smo)
      if (.not. ga_destroy(g_work)) call errquit('uhf_spin:ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_over)) call errquit('uhf_spin:ga?',0,
     &       GA_ERR)
c
c     Sum overlap of occupied orbitals
c
      if (.not. ma_push_get(mt_dbl,nalpha,'uhf_spin:x',l_x,k_x))
     $     call errquit('uhf_spin: ma failed on x',  nalpha, MA_ERR)
c
      s2 = 0
      do i = 1+ga_nodeid(), nbeta, ga_nnodes()
         call ga_get(g_smo, 1, nalpha, i, i, dbl_mb(k_x), 1)
         do j = 1, nalpha
            s2 = s2 + dbl_mb(k_x+j-1)**2
         enddo
      enddo
      call ga_dgop(msg_uhf, s2, 1, '+')
      s2 = sz*(sz+1) + nbeta - s2
c
      if (.not. ma_pop_stack(l_x)) call errquit('uhf_spin:ma?',0,
     &       MA_ERR)
      if (.not. ga_destroy(g_smo)) call errquit('uhf_spin:ga?',0,
     &       GA_ERR)
c
      end
      subroutine uhf_analyze(rtdb)
      implicit none
#include "errquit.fh"
#include "cscf.fh"
#include "global.fh"
#include "util.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "bas.fh"
      integer rtdb
c
c     Analyze the UHF wavefunction.  Optionally print the mulliken
c     analysis and multipoles, always store the dipole in the RTDB
c     
      integer g_dens, g_adens, g_bdens, g_over
c     
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
      logical oprintmulliken, oprintmultipole,oprintinertia
c
      integer len_moments, lmax
      parameter (lmax = 2)
      parameter (len_moments = (lmax+1)*(lmax+2)*(lmax+3)/6)
      double precision totalmoments(len_moments) 
      double precision alphamoments (len_moments)
      double precision betamoments (len_moments)
      double precision nuclmoments (len_moments)
      double precision center(3)
      integer k, l, m, ltotal, ind
      data center/3*0.0d0/
c
      oprintmulliken  = util_print('mulliken', print_default)
      oprintmultipole = util_print('multipole', print_default)
      oprintinertia = util_print('inertia', print_default).and.
     . ga_nodeid().eq.0
c
c     moments of inertia
c
      if(oprintinertia) call geom_momint(geom)

c     
c     First analyze the total density
c     
      g_dens = ga_create_atom_blocked(geom, basis, 'uhf_mull:dens')
      g_adens = ga_create_atom_blocked(geom, basis, 'uhf_mull:dens')
      g_bdens = ga_create_atom_blocked(geom, basis, 'uhf_mull:dens')
      g_over  = ga_create_atom_blocked(geom, basis, 'uhf_mull:over')
      call ga_zero(g_dens)
      call ga_zero(g_adens)
      call ga_zero(g_bdens)
      call ga_zero(g_over)
      call int_1e_ga(basis, basis, g_over, 'overlap', .false.)
c     
      if (nalpha .gt. 0) 
     $    call ga_dgemm('n', 't', nbf, nbf, nalpha, 1.0d0, g_movecs(1),
     $         g_movecs(1), 0.0d0, g_adens)
      if (nbeta .gt. 0) 
     $    call ga_dgemm('n', 't', nbf, nbf, nbeta, 1.0d0, g_movecs(2),
     $         g_movecs(2), 0.0d0, g_bdens)
      call ga_dadd(1.0d0, g_adens, 1.0d0, g_bdens, g_dens)
c
      if (oprintmulliken) then
         if (ga_nodeid() .eq. 0) then
            write(6,*)
            call util_print_centered(6,
     $           'Mulliken analysis of the total density', 20,.true.)
         endif
         call mull_pop(geom, basis, g_dens, g_over, 'total')
c
         if (ga_nodeid() .eq. 0) then
            write(6,*)
            call util_print_centered(6,
     $           'Mulliken analysis of the alpha density', 20,.true.)
         endif
         call mull_pop(geom, basis, g_adens, g_over, 'alpha')
c     
         if (nbeta .gt. 0) then
            if (ga_nodeid() .eq. 0) then
               write(6,*)
               call util_print_centered(6,
     $              'Mulliken analysis of the beta density', 
     $              20,.true.)
            endif
            call mull_pop(geom, basis, g_bdens, g_over, 'beta')
c
            if (ga_nodeid() .eq. 0) then
               write(6,*)
               call util_print_centered(6,
     $              'Mulliken analysis of the spin density', 
     $              20,.true.)
            endif
            call ga_dadd(1.0d0, g_adens, -1.0d0, g_bdens, g_adens)
            call mull_pop(geom, basis, g_adens, g_over, 'spin')
            call ga_dadd(1.0d0, g_adens,  1.0d0, g_bdens, g_adens)
         endif
      endif
c
      if (.not. bas_cando_mpoles(basis)) goto 100
c     
      call dfill(len_moments, 0.0d0, totalmoments, 1)
      call dfill(len_moments, 0.0d0, nuclmoments, 1)
      call dfill(len_moments, 0.0d0, alphamoments, 1)
      call dfill(len_moments, 0.0d0, betamoments, 1)
      call dfill(len_moments, 0.0d0, totalmoments, 1)
      call dfill(len_moments, 0.0d0, nuclmoments, 1)
      call dfill(len_moments, 0.0d0, alphamoments, 1)
      call dfill(len_moments, 0.0d0, betamoments, 1)
      call geom_nuc_mpole(geom, center, lmax, nuclmoments, len_moments)
      if (nalpha .gt. 0)
     $     call multipole_density(basis, center, lmax, g_adens, 
     $     alphamoments, len_moments)
      if (nbeta .gt. 0) 
     $     call multipole_density(basis, center, lmax, g_bdens, 
     $     betamoments, len_moments)
      do k = 1, len_moments
         totalmoments(k) = alphamoments(k) + betamoments(k) + 
     $        nuclmoments(k)
      enddo
c
      if (oprintmultipole .and. ga_nodeid().eq.0) then
         write(6,*)
         call util_print_centered(6,
     $     'Multipole analysis of the density wrt the origin',
     $      30, .true.)
         write(6,*)
         write(6,*) '    L   x y z        total         alpha',
     $                 '         beta         nuclear'
         write(6,*) '    -   - - -        -----         -----',
     $                 '         ----         -------'
         ind = 0
         do ltotal = 0, lmax
            do k = ltotal, 0, -1
               do l = ltotal-k, 0, -1
                  m = ltotal - k - l
                  ind = ind + 1
                  write(6,12) ltotal, k, l, m, totalmoments(ind),
     $                 alphamoments(ind), betamoments(ind),
     $                 nuclmoments(ind)
 12               format(4x,i2,2x,3i2,4f14.6)
               enddo
            enddo
            write(6,*)
         enddo
      endif
c
      call ecce_print1('total dipole', mt_dbl, totalmoments(2), 3)
      call ecce_print1('alpha electronic dipole', mt_dbl, 
     $     alphamoments(2), 3)
      call ecce_print1('beta electronic dipole', mt_dbl, 
     $     betamoments(2), 3)
      call ecce_print1('nuclear dipole', mt_dbl, nuclmoments(2), 3)
      call ecce_print1('total quadrupole', mt_dbl, totalmoments(5), 6)
      call ecce_print1('alpha electronic quadrupole',mt_dbl,
     $     alphamoments(5),6)
      call ecce_print1('beta electronic quadrupole',mt_dbl,
     $     betamoments(5),6)
      call ecce_print1('nuclear quadrupole', mt_dbl, nuclmoments(5), 6)
c
c     Store the dipole moment
c
      if (.not. rtdb_put(rtdb, 'scf:dipole', mt_dbl, 
     $     3, totalmoments(2))) call errquit('multipole: rtdb?',0,
     &       RTDB_ERR)
c     
 100  if (.not. ga_destroy(g_over)) call errquit('uhf_mull: ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_adens)) call errquit('uhf_mull: ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_bdens)) call errquit('uhf_mull: ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_dens)) call errquit('uhf_mull: ga?',0,
     &       GA_ERR)
c     
      end

      SUBROUTINE ccsdtq_lr_alpha_15_4_3(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_4_3.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p17 h16 )_ytrat + = 3/2 * Sum ( h11 h9 p8 ) * t ( p8 p17 h9 h11 )_t * i3 ( h9 h11 h16 p8 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p17b
      INTEGER h16b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p8b
      INTEGER h9b
      INTEGER h11b
      INTEGER p17b_1
      INTEGER p8b_1
      INTEGER h9b_1
      INTEGER h11b_1
      INTEGER h9b_2
      INTEGER h11b_2
      INTEGER h16b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p17b = noab+1,noab+nvab
      DO h16b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p17b-1)+int_mb(k_spin+h16b
     &-1).ne.4)) THEN
      IF (int_mb(k_spin+p17b-1) .eq. int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p17b-1),int_mb(k_sym+h16b-1)) .eq. ieor(irre
     &p_y,ieor(irrep_tra,irrep_t))) THEN
      dimc = int_mb(k_range+p17b-1) * int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_4_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p8b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h11b = h9b,noab
      IF (int_mb(k_spin+p17b-1)+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+
     &h9b-1)+int_mb(k_spin+h11b-1)) THEN
      IF (ieor(int_mb(k_sym+p17b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb
     &(k_sym+h9b-1),int_mb(k_sym+h11b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p17b,p8b,h9b,h11b,p17b_1,p8b_1,h9b_1,h11b_1)
      CALL TCE_RESTRICTED_4(h9b,h11b,h16b,p8b,h9b_2,h11b_2,h16b_2,p8b_2)
      dim_common = int_mb(k_range+p8b-1) * int_mb(k_range+h9b-1) * int_m
     &b(k_range+h11b-1)
      dima_sort = int_mb(k_range+p17b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h16b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_4_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_4_3',2,MA_ERR)
      IF ((p8b .le. p17b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p17b_1 - noab - 1 + nvab * (p8
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p17b-1),int_mb(k_range+h9b-1),int_mb(k_range+h11b-
     &1),2,4,3,1,1.0d0)
      END IF
      IF ((p17b .lt. p8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p8b_1 - noab - 1 + nvab * (p17
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p17b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h11b-
     &1),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_4_3',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_4_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_4_3',5,MA_ERR)
      IF ((h16b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (h16b_2 - 1 + noab * (h11b_2 - 1 + noab * (h9
     &b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h16b-1),int_mb(k_range+p8b-
     &1),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_4_3',
     &6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h9b .eq. h11b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &4_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &4_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_4_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+p17b-1),2,1,3.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (p17b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_4_3',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &4_3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*> \brief \b DLASV2 computes the singular value decomposition of a 2-by-2 triangular matrix.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLASV2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlasv2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlasv2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlasv2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLASV2( F, G, H, SSMIN, SSMAX, SNR, CSR, SNL, CSL )
* 
*       .. Scalar Arguments ..
*       DOUBLE PRECISION   CSL, CSR, F, G, H, SNL, SNR, SSMAX, SSMIN
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLASV2 computes the singular value decomposition of a 2-by-2
*> triangular matrix
*>    [  F   G  ]
*>    [  0   H  ].
*> On return, abs(SSMAX) is the larger singular value, abs(SSMIN) is the
*> smaller singular value, and (CSL,SNL) and (CSR,SNR) are the left and
*> right singular vectors for abs(SSMAX), giving the decomposition
*>
*>    [ CSL  SNL ] [  F   G  ] [ CSR -SNR ]  =  [ SSMAX   0   ]
*>    [-SNL  CSL ] [  0   H  ] [ SNR  CSR ]     [  0    SSMIN ].
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] F
*> \verbatim
*>          F is DOUBLE PRECISION
*>          The (1,1) element of the 2-by-2 matrix.
*> \endverbatim
*>
*> \param[in] G
*> \verbatim
*>          G is DOUBLE PRECISION
*>          The (1,2) element of the 2-by-2 matrix.
*> \endverbatim
*>
*> \param[in] H
*> \verbatim
*>          H is DOUBLE PRECISION
*>          The (2,2) element of the 2-by-2 matrix.
*> \endverbatim
*>
*> \param[out] SSMIN
*> \verbatim
*>          SSMIN is DOUBLE PRECISION
*>          abs(SSMIN) is the smaller singular value.
*> \endverbatim
*>
*> \param[out] SSMAX
*> \verbatim
*>          SSMAX is DOUBLE PRECISION
*>          abs(SSMAX) is the larger singular value.
*> \endverbatim
*>
*> \param[out] SNL
*> \verbatim
*>          SNL is DOUBLE PRECISION
*> \endverbatim
*>
*> \param[out] CSL
*> \verbatim
*>          CSL is DOUBLE PRECISION
*>          The vector (CSL, SNL) is a unit left singular vector for the
*>          singular value abs(SSMAX).
*> \endverbatim
*>
*> \param[out] SNR
*> \verbatim
*>          SNR is DOUBLE PRECISION
*> \endverbatim
*>
*> \param[out] CSR
*> \verbatim
*>          CSR is DOUBLE PRECISION
*>          The vector (CSR, SNR) is a unit right singular vector for the
*>          singular value abs(SSMAX).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Any input parameter may be aliased with any output parameter.
*>
*>  Barring over/underflow and assuming a guard digit in subtraction, all
*>  output quantities are correct to within a few units in the last
*>  place (ulps).
*>
*>  In IEEE arithmetic, the code works correctly if one matrix element is
*>  infinite.
*>
*>  Overflow will not occur unless the largest singular value itself
*>  overflows or is within a few ulps of overflow. (On machines with
*>  partial overflow, like the Cray, overflow may occur if the largest
*>  singular value is within a factor of 2 of overflow.)
*>
*>  Underflow is harmless if underflow is gradual. Otherwise, results
*>  may correspond to a matrix modified by perturbations of size near
*>  the underflow threshold.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DLASV2( F, G, H, SSMIN, SSMAX, SNR, CSR, SNL, CSL )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   CSL, CSR, F, G, H, SNL, SNR, SSMAX, SSMIN
*     ..
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D0 )
      DOUBLE PRECISION   HALF
      PARAMETER          ( HALF = 0.5D0 )
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D0 )
      DOUBLE PRECISION   TWO
      PARAMETER          ( TWO = 2.0D0 )
      DOUBLE PRECISION   FOUR
      PARAMETER          ( FOUR = 4.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            GASMAL, SWAP
      INTEGER            PMAX
      DOUBLE PRECISION   A, CLT, CRT, D, FA, FT, GA, GT, HA, HT, L, M,
     $                   MM, R, S, SLT, SRT, T, TEMP, TSIGN, TT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SIGN, SQRT
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Executable Statements ..
*
      FT = F
      FA = ABS( FT )
      HT = H
      HA = ABS( H )
*
*     PMAX points to the maximum absolute element of matrix
*       PMAX = 1 if F largest in absolute values
*       PMAX = 2 if G largest in absolute values
*       PMAX = 3 if H largest in absolute values
*
      PMAX = 1
      SWAP = ( HA.GT.FA )
      IF( SWAP ) THEN
         PMAX = 3
         TEMP = FT
         FT = HT
         HT = TEMP
         TEMP = FA
         FA = HA
         HA = TEMP
*
*        Now FA .ge. HA
*
      END IF
      GT = G
      GA = ABS( GT )
      IF( GA.EQ.ZERO ) THEN
*
*        Diagonal matrix
*
         SSMIN = HA
         SSMAX = FA
         CLT = ONE
         CRT = ONE
         SLT = ZERO
         SRT = ZERO
      ELSE
         GASMAL = .TRUE.
         IF( GA.GT.FA ) THEN
            PMAX = 2
            IF( ( FA / GA ).LT.DLAMCH( 'EPS' ) ) THEN
*
*              Case of very large GA
*
               GASMAL = .FALSE.
               SSMAX = GA
               IF( HA.GT.ONE ) THEN
                  SSMIN = FA / ( GA / HA )
               ELSE
                  SSMIN = ( FA / GA )*HA
               END IF
               CLT = ONE
               SLT = HT / GT
               SRT = ONE
               CRT = FT / GT
            END IF
         END IF
         IF( GASMAL ) THEN
*
*           Normal case
*
            D = FA - HA
            IF( D.EQ.FA ) THEN
*
*              Copes with infinite F or H
*
               L = ONE
            ELSE
               L = D / FA
            END IF
*
*           Note that 0 .le. L .le. 1
*
            M = GT / FT
*
*           Note that abs(M) .le. 1/macheps
*
            T = TWO - L
*
*           Note that T .ge. 1
*
            MM = M*M
            TT = T*T
            S = SQRT( TT+MM )
*
*           Note that 1 .le. S .le. 1 + 1/macheps
*
            IF( L.EQ.ZERO ) THEN
               R = ABS( M )
            ELSE
               R = SQRT( L*L+MM )
            END IF
*
*           Note that 0 .le. R .le. 1 + 1/macheps
*
            A = HALF*( S+R )
*
*           Note that 1 .le. A .le. 1 + abs(M)
*
            SSMIN = HA / A
            SSMAX = FA*A
            IF( MM.EQ.ZERO ) THEN
*
*              Note that M is very tiny
*
               IF( L.EQ.ZERO ) THEN
                  T = SIGN( TWO, FT )*SIGN( ONE, GT )
               ELSE
                  T = GT / SIGN( D, FT ) + M / T
               END IF
            ELSE
               T = ( M / ( S+T )+M / ( R+L ) )*( ONE+A )
            END IF
            L = SQRT( T*T+FOUR )
            CRT = TWO / L
            SRT = T / L
            CLT = ( CRT+SRT*M ) / A
            SLT = ( HT / FT )*SRT / A
         END IF
      END IF
      IF( SWAP ) THEN
         CSL = SRT
         SNL = CRT
         CSR = SLT
         SNR = CLT
      ELSE
         CSL = CLT
         SNL = SLT
         CSR = CRT
         SNR = SRT
      END IF
*
*     Correct signs of SSMAX and SSMIN
*
      IF( PMAX.EQ.1 )
     $   TSIGN = SIGN( ONE, CSR )*SIGN( ONE, CSL )*SIGN( ONE, F )
      IF( PMAX.EQ.2 )
     $   TSIGN = SIGN( ONE, SNR )*SIGN( ONE, CSL )*SIGN( ONE, G )
      IF( PMAX.EQ.3 )
     $   TSIGN = SIGN( ONE, SNR )*SIGN( ONE, SNL )*SIGN( ONE, H )
      SSMAX = SIGN( SSMAX, TSIGN )
      SSMIN = SIGN( SSMIN, TSIGN*SIGN( ONE, F )*SIGN( ONE, H ) )
      RETURN
*
*     End of DLASV2
*
      END
c $Id: dlasv2.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine ana_diel(xs,qs,isel,xw,qw,iwsel)
c
c $Id: ana_diel.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_params.fh"
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      real*8 xs(msa,3),qs(msa),xw(mwm,mwa,3),qw(mwa)
      integer isel(msa),iwsel(mwm)
c
      integer i,j,nxp,nxm,nxpw,nxmw
      real*8 xp(3),xm(3),qp,qm
c
      do 1 i=1,3
      xp(i)=0.0d0
      xm(i)=0.0d0
    1 continue
      qp=0.0d0
      qm=0.0d0
      nxp=0
      nxm=0
      nxpw=0
      nxmw=0
c
      do 2 i=1,nsa
      if(isel(i).gt.0) then
      if(qs(i).lt.0.0d0) then
      nxm=nxm+1
      xm(1)=xm(1)+qs(i)*xs(i,1)
      xm(2)=xm(2)+qs(i)*xs(i,2)
      xm(3)=xm(3)+qs(i)*xs(i,3)
      qm=qm+qs(i)
      else
      nxp=nxp+1
      xp(1)=xp(1)+qs(i)*xs(i,1)
      xp(2)=xp(2)+qs(i)*xs(i,2)
      xp(3)=xp(3)+qs(i)*xs(i,3)
      qp=qp+qs(i)
      endif
      endif
    2 continue
c
      do 3 i=1,nwm
      do 4 j=1,nwa
      if(iwsel(i).gt.0) then
      if(qw(j).lt.0.0d0) then
      nxmw=nxmw+1
      xm(1)=xm(1)+qw(j)*xw(i,j,1)
      xm(2)=xm(2)+qw(j)*xw(i,j,2)
      xm(3)=xm(3)+qw(j)*xw(i,j,3)
      qm=qm+qw(j)
      else
      nxpw=nxpw+1
      xp(1)=xp(1)+qw(j)*xw(i,j,1)
      xp(2)=xp(2)+qw(j)*xw(i,j,2)
      xp(3)=xp(3)+qw(j)*xw(i,j,3)
      qp=qp+qw(j)
      endif
      endif
    4 continue
    3 continue
c
      write(lfndie,1000) nxp,nxm,nxpw,nxmw,qp,qm,(xp(i)+xm(i),i=1,3)
 1000 format(4i5,2f10.3,6f12.3)
c
      return
      end
      subroutine ana_diehdr(sgmnam)
c
      implicit none
c
#include "ana_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
c
      return
      end

      subroutine ga_diag_compl(g_ar, g_ac, g_vr, g_vc, eval)
*
* $Id: ga_complex_diag.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
      integer g_ar,g_ac         ! matrix to diagonalize (real and imag)
      integer g_vr,g_vc         ! global matrix to return evecs
      double precision eval(*)  ! local array to return evals
      double precision ee,dotres,toll
      parameter(toll=1.d-9)
      intrinsic abs
c     
c       
c     solve thecomplex symmetric eigenvalue problem 
c     for a hermitiancomplex matrix mapping it to
c     a real one in the following way
c     
c     
c     
c     ( AR  -AC)  (VR VR)  = (VR VR) (E  )
c     ( AC   AR)  (VC VC)  = (VC VC) (  E)
c
c since AR + i AC is hermitian this is a symmetric representation
c
c       returning
c       all eigenvectors and values in ascending order
c       
c       the input matrix is not destroyed
c       
c       proc - # of processors
c       pans - panel size incolumns
c       n    - problem size
c       
c       
c       
c~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c       
	integer iproc, pan, istart, istart1, iend, j,k,k1,n, nn, 
     $     npan, proc, myproc
	integer mypanel, myelem, mycol, elemz, ipan, ik, info
	logical status
	logical loop1,loop2
c       
	integer hma, adrma	!mapa
	integer hmz, adrmz	!mapz
	integer ga_diag_type,sndvec,brdres
	integer lenmes
c
	integer ha, adra	!a
	integer hz, adrz	!z
c       
	integer isize, rsize, ptr_size
	integer his, adris
	integer hsc, adrsc
	integer hip, adrip
	integer hj,adrj
	integer he,adre
	integer heval,adreval
	integer node1,node2
	integer igua,imazz
c       
	external fmemreq, pdspev
c       
	logical oactive		! true iff this process participates
	character*80 name
	integer dimA1, dimA2, typeA
	integer dimV1, dimV2, typeV
c       
	integer Elem
	Elem(istart,iend,n)=((iend-istart+1)*(2*n-istart-iend+2))/2
c       
c       
c***    check environment
c       
	myproc = ga_nodeid()
	proc   = ga_nnodes()
c       
c***    check GA info
c       
	call ga_check_handle(g_ar, 'ga_diag: ar')
	call ga_check_handle(g_vr, 'ga_diag: vr')
	call ga_check_handle(g_ac, 'ga_diag: ac')
	call ga_check_handle(g_vc, 'ga_diag: vc')
	call ga_inquire(g_ar, typeA, dimA1, dimA2)
	call ga_inquire(g_vr, typeV, dimV1, dimV2)
c       
c       
	if (dimA1 .ne. dimA2) then
	   call ga_error('ga_diag_compl:can only diag square matrix ',2
     $          )
	else if (dimV1 .ne. dimV2) then
	   call ga_error('ga_diag_compl:can only diag square matrix ',3
     $          )
	else if(dimA1.ne.dimV1 )then
         call ga_error('ga_diag_compl: A & V dimension mismatch ', 4)
	endif
c       
c       call mxpara(ienv)
	nn = dimA1
	n = 2*nn
c       
	call ga_sync()
c
       if (n .lt. 350) then
          proc = min(8,ga_nnodes())
       else if (n .lt. 700) then
          proc = min(16,ga_nnodes())
       else if (n .lt. 1000) then
          proc = min(20,ga_nnodes())
       else if (n .lt. 2000) then
          proc = min(128,ga_nnodes())
       else
          proc = min(256,ga_nnodes())
       endif
c
c         print *,myproc,' participate in eig: ',proc
c        call ffflush(6)
       oactive = myproc .lt. proc
       if (oactive) then
          pan = 1                !panel size
          npan = n/pan
c     
c        allocate map arrays
c
          status = ma_push_get(mt_int,n,'mapa',hma,adrma)
          status = ma_push_get(mt_int,n,'mapz',hmz,adrmz)
c         
c        determine distribution of a and z
c     
          mypanel = 0            ! number of panels at given processor
          mycol   = 0            ! number ofcolumns at given processor
          myelem  = 0            ! number of elements at given processor
c     
c        allocate first half of the panels - forwards
c
      do ipan = 1, npan/2 
         iproc = mod(ipan -1, proc)
         istart = (ipan - 1)*pan + 1
         iend   = istart + pan - 1
         do k = istart, iend
            int_mb(-1+adrma+k) = iproc
            int_mb(-1+adrmz+k) = iproc
         enddo
         if(iproc .eq. myproc)then
            myelem = myelem + elem(istart,iend,n)
            mypanel = mypanel+1	
         endif
      enddo	   
c     
c        allocate second half of the panels - backwards
c     
          ik = 1                 !ik is used to forward number processors
          do ipan =   npan-1, npan/2 +1 , -1
             ik = ik+1
             iproc = mod(ik -1, proc)
             istart = (ipan - 1)*pan + 1
             iend   = istart + pan - 1
             do k = istart, iend
                int_mb(-1+adrma+k) = iproc
                int_mb(-1+adrmz+k) = iproc
             enddo
             if(iproc .eq. myproc)then
                myelem = myelem + elem(istart,iend,n)
                mypanel = mypanel+1	
             endif
          enddo	   
c
c***     actually, there is one more panel left for the mismatch 
c     
          iproc  = 0             !processor 0 gets the mismatch panel
          istart = (npan - 1)*pan + 1
          iend   = n
          do k = istart, iend
             int_mb(-1+adrma+k) = iproc
             int_mb(-1+adrmz+k) = iproc
          enddo
          mycol = mypanel * pan
          if(iproc .eq. myproc)then
             myelem = myelem + elem(istart,iend,n)
             mycol  = mycol + iend - istart + 1	
          endif
          elemz = mycol * n
c
c***     allocate a and z arrays
c     
          status = ma_push_get(mt_dbl,n,'heval',heval,adreval)
          if(.not. status)
     $         call ga_error('ga_diag_compl allocator heval',1)
c     
          status = ma_push_get(mt_dbl,myelem,'a',ha,adra)
          status = ma_push_get(mt_dbl,elemz,'z',hz,adrz)
c
c***     load the fock (A) matrix
c        [ AR    ]
c        [ AC  AR] 
c
          istart = 0
          do k = 1, n
             if( int_mb(-1+adrma+k) .eq. myproc) then
                myelem = n-k+1
               if(k.le.nn) then
                call ga_get(
     $                 g_ar,k,nn,k,k,dbl_mb(adra+istart),1)
                call ga_get(
     $               g_ac,1,nn,k,k,dbl_mb(adra+istart+(nn-k+1)),1)
               else
                 k1=k-nn
                call ga_get(
     $                g_ar,k1,nn,k1,k1,dbl_mb(adra+istart),1)
               endif
               istart = istart + myelem
             endif
          enddo
c     
c***     allocate some memory forcompl eigensolver 
c
          status = ma_push_get(mt_int,n,'iscratch',his,adris)
          call fmemreq(1,n,int_mb(adrma),int_mb(adrma),int_mb(adrmz),
     $         isize, rsize, ptr_size,int_mb(adris))
          status = ma_pop_stack(his)
          if(.not. ma_push_get(mt_int,isize,'iscratch',his,adris))
     $         call ga_error('ga_diag_compl allocator',1)
          if(.not. ma_push_get(mt_dbl,rsize,'scratch',hsc,adrsc))
     $         call ga_error('ga_diag_compl allocator',2)
          if(.not. ma_push_get(mt_dbl,ptr_size,'iptr',hip,adrip))
     $         call ga_error('ga_diag_compl allocator',3)
c     
       endif
c
c
      call ga_sync()            ! To reduce message buffering problems
c
c***  calling PEIGS parallel eigensolver
c     
      if (oactive) then
c
c set info to use complex diag
c
         info = -1
         call pdspev(  n, dbl_mb(adra), int_mb(adrma),
     $        dbl_mb(adrz), int_mb(adrmz),  
     $        dbl_mb(adreval),  
     $        int_mb(adris), isize,  
     $        dbl_mb(adrip), ptr_size,  
     $        dbl_mb(adrsc), rsize, info)
         if (info .ne. 0)
     $        call ga_error('ga_diag_compl: info non-zero ', info)
         call pdcomplex(n, dbl_mb(adrz), int_mb(adrmz),
     $        dbl_mb(adreval),
     $        dbl_mb(adrsc), dbl_mb(adris), info)
         if (info .ne. 0)
     $        call ga_error(
     $        'ga_diag_comp: pdcomplex info non-zero ', info)
      endif
c     
c     to reduce out of order message problems between ga and non-ga process
c     
c     
      call ga_sync
c     
c***  store the eigenvector matrix in global array g_vr and g_vc
c     
      n = nn
      if (oactive) then
         istart = 0
         do k = 1, n
            if( int_mb(-1+adrmz+k) .eq. myproc) then
               call ga_put(g_vr,1,nn,k,k,dbl_mb(adrz+istart),1)
               call ga_put(g_vc,1,nn,k,k,dbl_mb(adrz+istart+nn),1)
               istart = istart + n
            endif
      enddo
c     
c     set n = n/2
c
      n = nn
c     
c***  deallocate work arrays 
c     
      status = ma_pop_stack(he) 
      status = ma_pop_stack(hj) 
      status = ma_pop_stack(hip) 
      status = ma_pop_stack(hsc) 
      status = ma_pop_stack(his) 
      status = ma_pop_stack(hz) 
      status = ma_pop_stack(ha) 
      status = ma_pop_stack(heval)
      status = ma_pop_stack(hmz) 
      status = ma_pop_stack(hma) 
      endif

c     
c     Make sure that even processes that did not participate in the
c     diagonalization have the eigen values
c     
c     
#ifdef DATA_SERVER
      FIX ME NOW
#endif
c     
      call ga_sync()
c     
      end
      

C> \file upkcon.F
C> Unpack configuration
C>
C> \ingroup selci
C> @{
C>
C> \brief Unpack a configuration
C>
C> Unpacks a configuration and stores the orbital occupations in an
C> integer array `iocc`.
C>
      subroutine selci_upkcon(norbs, iocc, mocc, nintpo, nbitpi)
#include "errquit.fh"
*
* $Id: upkcon.F 24783 2013-11-08 03:14:31Z d3y133 $
*
      dimension iocc(norbs), mocc(nintpo)
#include "bitops.fh"
c
c     scalar version
c     unpack occupation iocc(*) bitwise from mocc, nbitpi bits
c     per integer word
c     iocc(1:norbs) = 0 (uocc), 1 (socc), 3 (docc)
c     mocc(1:nintpo)= packed representation of iocc, 2 bits per element
c     nintpo = no. of integers needed to pack the occupancy
c     nbitpi = no. of bits in an integer
c
c     no. of elements per integer
c
      nelpi = nbitpi / 2
      if (nintpo .ne. (norbs+nelpi-1)/nelpi) 
     &     call errquit('nintpo has strange value ',nintpo, INPUT_ERR)
c
      ilo = 1
      do 10 iword = 1, nintpo
         move = nbitpi - 2
         itemp = mocc(iword)
         ihi = min(ilo+nelpi-1,norbs)
         do 20 i = ilo,ihi
            iocc(i) = iand(ishft(itemp,-move),3)
            move = move - 2
 20      continue
         ilo = ihi + 1
 10   continue
c

      end
C>
C> @}

*
* $Id: K1dB.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************************************
*     *								*
*     *   		   K1dB library				*
*     *			(MPI implemenation)			*
*     *								*
*     *   Author - Eric Bylaska					*
*     *   date   - 3/23/96					*
*     *								*
*     ***********************************************************

*	The K1dB (distributed one-dimensional block) library is to 
* be used for handling a parallel 1d data structure.  
*
*	The data structures is distributed across threads, p, in
* the k (i.e. nz) dimension using a cyclic decomposition.  
*
*	Where 
*		np = number of threads
*		nq = ceil(nz/np).
*		0 <= p < np
*		1 <= q <= nq
*		1 <= k <= nz
* 
* 	The mapping of k -> q is defined as:
*	
*		k = ((q-1)*np + p) + 1
*		q = ((k-1) - p)/np + 1
*		p = (k-1) mod np
*


*     ***********************************
*     *					*
*     *	       k_Mapping1d_init		*	
*     *					*
*     ***********************************

      subroutine k_Mapping1d_init()
      implicit none
     
#include "mafdecls.fh"
#include "errquit.fh"
#include "K1dB.fh"


      integer k,q,p,taskid
*     integer kn
      logical value

      call Parallel3d_taskid_k(taskid)

*     **** allocate q_map,p_map,k_map
      value=MA_alloc_get(mt_int,nz,'q_map',q_map(2),q_map(1))
      value=value.and.MA_alloc_get(mt_int,nz,'p_map',p_map(2),p_map(1))
      value=value.and.MA_alloc_get(mt_int,nz,'k_map',k_map(2),k_map(1))
      value=value.and.MA_alloc_get(mt_int,np_k,'nqarray',
     >                               nqarray(2),nqarray(1))
      if (.not. value)
     > call errquit('k_Mapping_init:out of heap memory',0, MA_ERR)


*     ****************************
*     ****** Cyclic Mapping ******
*     ****************************
      if (mapping.eq.0) then
         p = 0
         q = 1
         do k=1,nz
            int_mb(q_map(1)+k-1) = q
            int_mb(p_map(1)+k-1) = p
            if (p .eq. taskid) nq = q

            p = p+1
            if (p .ge. np_k) then
               p = 0
               q = q + 1
            end if
         end do

*     ***********************
*     **** block mapping ****
*     ***********************
      else

         do p=0,np_k-1
           int_mb(nqarray(1)+p) = 0
         end do

         p = 0
         do k=1,nz
           int_mb(nqarray(1)+p) = int_mb(nqarray(1)+p) + 1
           p = mod(p+1,np_k)
         end do

         k = 1
         do p=0,np_k-1
           do q=1,int_mb(nqarray(1)+p)
              int_mb(q_map(1)+k-1) = q
              int_mb(p_map(1)+k-1) = p
              k = k + 1
           end do
         end do

         nq = int_mb(nqarray(1)+taskid)

      end if
      !*** probably not needed!! ****
      do k=1,nz
         if (int_mb(p_map(1)+k-1) .eq. taskid) then
            int_mb(k_map(1)+int_mb(q_map(1)+k-1)-1) = k
         end if
      end do

      return
      end

*     ***********************************
*     *					*
*     *	          K1dB_end   		*	
*     *					*
*     ***********************************
      subroutine K1dB_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "K1dB.fh"


      logical value

      value =.true.
      value = value.and.MA_free_heap(q_map(2))
      value = value.and.MA_free_heap(p_map(2))
      value = value.and.MA_free_heap(k_map(2))
      value = value.and.MA_free_heap(nqarray(2))
      
      if (.not. value)
     > call errquit('K1dB_end:freeing heap memory',0, MA_ERR)

      return
      end
         
*     ***********************************
*     *					*
*     *	          K1dB_qtok   		*	
*     *					*
*     ***********************************

      subroutine K1dB_qtok(q,k)      
      implicit none
      integer q,k

#include "mafdecls.fh"
#include "K1dB.fh"

      k = int_mb(k_map(1)+q-1)
      return
      end

*     ***********************************
*     *					*
*     *	          K1dB_ktoqp  		*	
*     *					*
*     ***********************************

      subroutine K1dB_ktoqp(k,q,p)      
      implicit none
      integer k,q,p

#include "mafdecls.fh"
#include "K1dB.fh"

      q = int_mb(q_map(1)+k-1)
      p = int_mb(p_map(1)+k-1)
      return
      end



*     ***********************************
*     *					*
*     *	        K1dB_nq			*	
*     *					*
*     ***********************************

      subroutine K1dB_nq(nqtmp)
      implicit none
      integer nqtmp

#include "K1dB.fh"


      nqtmp = nq
      return 
      end


*     ***********************************
*     *					*
*     *	        K1dB_nz			*	
*     *					*
*     ***********************************

      subroutine K1dB_nz(nztmp)
      implicit none
      integer nztmp

#include "K1dB.fh"
    
      nztmp = nz
      return
      end



*     ***********************************
*     *					*
*     *	        K1dB_init		*	
*     *					*
*     ***********************************

      subroutine K1dB_init(nz_in,map_in)
      implicit none
      integer nz_in
      integer map_in

#include "K1dB.fh"

      !**** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer taskid

      call Parallel3d_np_k(np_k)
      call Parallel_taskid(taskid)

      !**** Make sure ngrid is consistent with mapping ***
      if (np_k.gt.nz_in) then
          if (taskid.eq.MASTER) then
            write(6,*) 'Possible Error?: for 1d decomposition the',
     >                 ' number of columns (np_k processors) must ',
     >                 ' be in the range ( 1 ...nz=',
     >                   nz_in,')'
            call util_flush(6)
          end if
c          call errquit('K1dB_init: mapping error',0,0)
      end if

*     ***** initialize K1dB common block *****
      nz      = nz_in
      mapping = map_in

*     **** do other initializations ****
      call k_Mapping1d_init()
      
      return
      end

      SUBROUTINE stpr_putbck ( COORD, C )
c $Id: stpr_putbck.f 19708 2010-10-29 18:04:21Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      COMMON / CFACE / IWCTR,NATOM,ICALC
      DIMENSION COORD(3,NATOM), C(3,NATOM)
C
C     Get coordinates.
C
      DO 2 I = 1, 3
        DO 1 N = 1, NATOM
          C(I,N) = COORD(I,N)
    1   CONTINUE
    2 CONTINUE
      RETURN
      END

      logical function pre_dummy(lfnout,latt,catt,patt,ratt,matt,natt,
     + latm,catm,matm,natm,lbnd,rbnd,mbnd,nbnd,lang,rang,mang,nang,
     + ldih,nfdih,kdih,rdih,mdih,ndih,limp,kimp,rimp,mimp,nimp,
     + nparms,mparms)
c
c $Id: pre_dummy.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "pre_common.fh"
c
      integer lfnout
      integer matt,natt,nparms,mparms
      integer latt(3,matt)
      character*6 catt(2,matt)
      real*8 patt(4,2,matt,matt),ratt(matt)
      integer matm,natm
      integer latm(11,matm)
      character*6 catm(mparms,matm)
      integer mbnd,nbnd
      integer lbnd(4,mbnd)
      real*8 rbnd(nparms,2,mbnd)
      integer mang,nang
      integer lang(5,mang)
      real*8 rang(nparms,4,mang)
      integer mdih,ndih
      integer ldih(6,mdih),nfdih(nparms,mdih),kdih(6,nparms,mdih)
      real*8 rdih(6,nparms,2,mdih)
      integer mimp,nimp
      integer limp(6,mimp),kimp(nparms,mimp)
      real*8 rimp(nparms,2,mimp)
c
      integer i,j,k,l,kpar
c
      do 1 i=1,nbnd
c      write(*,'(3i5)') (lbnd(j,i),j=1,3)
      k=-lbnd(3,i)
c      if(k.eq.0) call md_abort('Error in pre_dummy',1)
      if(k.ne.0) then
      kpar=0
      do 2 j=nparms,1,-1
      if(iand(k,2**(j-1)).ne.0) kpar=j
    2 continue
      if(kpar.eq.0) call md_abort('Error in pre_dummy',2)
      do 3 j=1,nparms
      if(iand(k,2**(j-1)).eq.0) then
      if(catm(j+1,lbnd(1,i))(6:6).eq.'D'.or.
     +   catm(j+1,lbnd(2,i))(6:6).eq.'D') then
      rbnd(j,1,i)=rbnd(kpar,1,i)
      rbnd(j,2,i)=rbnd(kpar,2,i)
      k=ior(k,2**(j-1))
      endif
      endif
    3 continue
      lbnd(3,i)=-k
      endif
    1 continue
c
      do 4 i=1,nang
      k=-lang(4,i)
c      print*,i,k
c      write(*,'(4i5)') (lang(j,i),j=1,4)
c      if(k.eq.0) call md_abort('Error in pre_dummy',3)
      if(k.gt.0) then
      kpar=0
      do 5 j=nparms,1,-1
      if(iand(k,2**(j-1)).ne.0) kpar=j
    5 continue
      if(kpar.eq.0) call md_abort('Error in pre_dummy',4)
      do 6 j=1,nparms
c      if(iand(k,2**(j-1)).eq.0) then
      if(catm(j+1,lang(1,i))(6:6).eq.'D'.or.
     +   catm(j+1,lang(2,i))(6:6).eq.'D'.or.
     +   catm(j+1,lang(3,i))(6:6).eq.'D') then
      rang(j,1,i)=rang(kpar,1,i)
      rang(j,2,i)=0.0d0
      if(ffield(1:6).eq.'charmm') then
      rang(j,3,i)=rang(kpar,3,i)
      rang(j,4,i)=0.0d0
      endif
c      print*,'Dummy',i,j
cx      rang(j,2,i)=rang(kpar,2,i)
      k=ior(k,2**(j-1))
      endif
c      endif
    6 continue
      lang(4,i)=-k
      endif
    4 continue
c
      do 7 i=1,ndih
      k=-ldih(5,i)
c      if(k.eq.0) call md_abort('Error in pre_dummy',5)
      if(k.gt.0) then
      kpar=0
      do 8 j=nparms,1,-1
      if(iand(k,2**(j-1)).ne.0) kpar=j
    8 continue
      if(kpar.eq.0) call md_abort('Error in pre_dummy',6)
      do 9 j=1,nparms
      if(iand(k,2**(j-1)).eq.0) then
      if(catm(j+1,ldih(1,i))(6:6).eq.'D'.or.
     +   catm(j+1,ldih(2,i))(6:6).eq.'D'.or.
     +   catm(j+1,ldih(3,i))(6:6).eq.'D'.or.
     +   catm(j+1,ldih(4,i))(6:6).eq.'D') then
      nfdih(j,i)=nfdih(kpar,i)
      do 10 l=1,nfdih(j,i)
      kdih(l,j,i)=kdih(l,kpar,i)
      rdih(l,j,1,i)=rdih(l,kpar,1,i)
      rdih(l,j,2,i)=rdih(l,kpar,2,i)
   10 continue
      k=ior(k,2**(j-1))
      endif
      endif
    9 continue
      ldih(5,i)=-k
      endif
    7 continue
c
      do 11 i=1,nimp
      k=-limp(5,i)
c      if(k.eq.0) call md_abort('Error in pre_dummy',7)
      if(k.gt.0) then
      kpar=0
      do 12 j=nparms,1,-1
      if(iand(k,2**(j-1)).ne.0) kpar=j
   12 continue
      if(kpar.eq.0) call md_abort('Error in pre_dummy',8)
      do 13 j=1,nparms
      if(iand(k,2**(j-1)).eq.0) then
      if(catm(j+1,limp(1,i))(6:6).eq.'D'.or.
     +   catm(j+1,limp(2,i))(6:6).eq.'D'.or.
     +   catm(j+1,limp(3,i))(6:6).eq.'D'.or.
     +   catm(j+1,limp(4,i))(6:6).eq.'D') then
      kimp(j,i)=kimp(kpar,i)
      rimp(j,1,i)=rimp(kpar,1,i)
      rimp(j,2,i)=rimp(kpar,2,i)
      k=ior(k,2**(j-1))
      endif
      endif
   13 continue
      limp(5,i)=-k
      endif
   11 continue
c
      pre_dummy=.true.
      return
 9999 continue
      pre_dummy=.false.
      return
      end

      SUBROUTINE cisdtq_2pdm_hhpp_mo(d_i0,d_t0,d_t1,d_t2,d_y2,d_y3,d_y4,
     &k_i0_offset,k_t0_offset,k_t1_offset,k_t2_offset,k_y2_offset,k_y3_o
     &ffset,k_y4_offset)
C     $Id: cisdtq_2pdm_hhpp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yt + = 1 * t ( )_t * y ( h3 h4 p1 p2 )_y
C     i0 ( h3 h4 p1 p2 )_yt + = 1 * Sum ( h6 p5 ) * t ( p5 h6 )_t * y ( h3 h4 h6 p1 p2 p5 )_y
C     i0 ( h3 h4 p1 p2 )_yt + = 1/4 * Sum ( h7 h8 p5 p6 ) * t ( p5 p6 h7 h8 )_t * y ( h3 h4 h7 h8 p1 p2 p5 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t0
      INTEGER k_t0_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_y3
      INTEGER k_y3_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_y4
      INTEGER k_y4_offset
      CALL cisdtq_2pdm_hhpp_mo_1(d_t0,k_t0_offset,d_y2,k_y2_offset,d_i0,
     &k_i0_offset)
      CALL cisdtq_2pdm_hhpp_mo_2(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i0,
     &k_i0_offset)
      CALL cisdtq_2pdm_hhpp_mo_3(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i0,
     &k_i0_offset)
      RETURN
      END
      SUBROUTINE cisdtq_2pdm_hhpp_mo_1(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: cisdtq_2pdm_hhpp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yt + = 1 * t ( )_t * y ( h3 h4 p1 p2 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (0 .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(h3b,h4b,p1b,p2b,h3b_2,h4b_2,p1b_2,p2b_2)
      dim_common = 1
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_a),dbl_mb(k_a_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_1',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_1',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_1',8,MA_ERR)
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_1',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_2pdm_hhpp_mo_2(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: cisdtq_2pdm_hhpp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yt + = 1 * Sum ( h6 p5 ) * t ( p5 h6 )_t * y ( h3 h4 h6 p1 p2 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h6b
      INTEGER p5b_1
      INTEGER h6b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER h6b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h6b = 1,noab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h6b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h6b,p5b_1,h6b_1)
      CALL TCE_RESTRICTED_6(h3b,h4b,h6b,p1b,p2b,p5b,h3b_2,h4b_2,h6b_2,p1
     &b_2,p2b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h6b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h6b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_2',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_2',5,MA_ERR)
      IF ((h6b .lt. h3b) .and. (p5b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h3b_2 - 1 + noab * (h6b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),6,5,3,2,1,4,1.0d0)
      END IF
      IF ((h6b .lt. h3b) .and. (p1b .le. p5b) .and. (p5b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h3b_2 - 1 + noab * (h6b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p2b-1),6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h6b .lt. h3b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h3b_2 - 1 + noab * (h6b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p5b-1),5,4,3,2,1,6,1.0d0)
      END IF
      IF ((h3b .le. h6b) .and. (h6b .lt. h4b) .and. (p5b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h6b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),6,5,3,1,2,4,-1.0d0)
      END IF
      IF ((h3b .le. h6b) .and. (h6b .lt. h4b) .and. (p1b .le. p5b) .and.
     & (p5b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h6b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p2b-1),6,4,3,1,2,5,1.0d0)
      END IF
      IF ((h3b .le. h6b) .and. (h6b .lt. h4b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h6b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p5b-1),5,4,3,1,2,6,-1.0d0)
      END IF
      IF ((h4b .le. h6b) .and. (p5b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h6b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),6,5,2,1,3,4,1.0d0)
      END IF
      IF ((h4b .le. h6b) .and. (p1b .le. p5b) .and. (p5b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p2b-1),6,4,2,1,3,5,-1.0d0)
      END IF
      IF ((h4b .le. h6b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p5b-1),5,4,2,1,3,6,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_2',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_2',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_2pdm_hhpp_mo_3(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: cisdtq_2pdm_hhpp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yt + = 1/4 * Sum ( h7 h8 p5 p6 ) * t ( p5 p6 h7 h8 )_t * y ( h3 h4 h7 h8 p1 p2 p5 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER h7b
      INTEGER h8b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER h7b_2
      INTEGER h8b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h7b = 1,noab
      DO h8b = h7b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &7b-1)+int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h7b-1),int_mb(k_sym+h8b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h7b,h8b,p5b_1,p6b_1,h7b_1,h8b_1)
      CALL TCE_RESTRICTED_8(h3b,h4b,h7b,h8b,p1b,p2b,p5b,p6b,h3b_2,h4b_2,
     &h7b_2,h8b_2,p1b_2,p2b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+h7b-1) * int_mb(k_range+h8b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_3',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_2pdm_hhpp_mo_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_3',5,MA_ERR)
      IF ((h8b .lt. h3b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),8,7,4,3,2,1,6,5,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (p5b .lt. p1b) .and. (p1b .le. p6b) .and.
     & (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,6,4,3,2,1,7,5,-1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (p5b .lt. p1b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,6,4,3,2,1,8,5,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (p1b .le. p5b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,5,4,3,2,1,7,6,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (p1b .le. p5b) .and. (p5b .lt. p2b) .and.
     & (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,5,4,3,2,1,8,6,-1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),6,5,4,3,2,1,8,7,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h3b .le. h8b) .and. (h8b .lt. h4b) .and.
     & (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),8,7,4,2,3,1,6,5,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h3b .le. h8b) .and. (h8b .lt. h4b) .and.
     & (p5b .lt. p1b) .and. (p1b .le. p6b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,6,4,2,3,1,7,5,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h3b .le. h8b) .and. (h8b .lt. h4b) .and.
     & (p5b .lt. p1b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,6,4,2,3,1,8,5,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h3b .le. h8b) .and. (h8b .lt. h4b) .and.
     & (p1b .le. p5b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,5,4,2,3,1,7,6,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h3b .le. h8b) .and. (h8b .lt. h4b) .and.
     & (p1b .le. p5b) .and. (p5b .lt. p2b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,5,4,2,3,1,8,6,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h3b .le. h8b) .and. (h8b .lt. h4b) .and.
     & (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),6,5,4,2,3,1,8,7,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h4b .le. h8b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),8,7,3,2,4,1,6,5,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h4b .le. h8b) .and. (p5b .lt. p1b) .and.
     & (p1b .le. p6b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,6,3,2,4,1,7,5,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h4b .le. h8b) .and. (p5b .lt. p1b) .and.
     & (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,6,3,2,4,1,8,5,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h4b .le. h8b) .and. (p1b .le. p5b) .and.
     & (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,5,3,2,4,1,7,6,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h4b .le. h8b) .and. (p1b .le. p5b) .and.
     & (p5b .lt. p2b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,5,3,2,4,1,8,6,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (h4b .le. h8b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),6,5,3,2,4,1,8,7,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h8b .lt. h4b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),8,7,4,1,3,2,6,5,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h8b .lt. h4b) .and. (p5b .lt. p1b) .and.
     & (p1b .le. p6b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,6,4,1,3,2,7,5,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h8b .lt. h4b) .and. (p5b .lt. p1b) .and.
     & (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,6,4,1,3,2,8,5,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h8b .lt. h4b) .and. (p1b .le. p5b) .and.
     & (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,5,4,1,3,2,7,6,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h8b .lt. h4b) .and. (p1b .le. p5b) .and.
     & (p5b .lt. p2b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,5,4,1,3,2,8,6,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h8b .lt. h4b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),6,5,4,1,3,2,8,7,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .lt. h4b) .and. (h4b .le. h8b) .and.
     & (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),8,7,3,1,4,2,6,5,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .lt. h4b) .and. (h4b .le. h8b) .and.
     & (p5b .lt. p1b) .and. (p1b .le. p6b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,6,3,1,4,2,7,5,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .lt. h4b) .and. (h4b .le. h8b) .and.
     & (p5b .lt. p1b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,6,3,1,4,2,8,5,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .lt. h4b) .and. (h4b .le. h8b) .and.
     & (p1b .le. p5b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,5,3,1,4,2,7,6,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .lt. h4b) .and. (h4b .le. h8b) .and.
     & (p1b .le. p5b) .and. (p5b .lt. p2b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,5,3,1,4,2,8,6,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .lt. h4b) .and. (h4b .le. h8b) .and.
     & (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h4b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),6,5,3,1,4,2,8,7,-1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 1
     & + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),8,7,2,1,4,3,6,5,1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p5b .lt. p1b) .and. (p1b .le. p6b) .and.
     & (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 1
     & + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,6,2,1,4,3,7,5,-1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p5b .lt. p1b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 1
     & + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,6,2,1,4,3,8,5,1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p1b .le. p5b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 1
     & + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p2b-1),8,5,2,1,4,3,7,6,1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p1b .le. p5b) .and. (p5b .lt. p2b) .and.
     & (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 1
     & + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p6b-1),7,5,2,1,4,3,8,6,-1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 1
     & + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),6,5,2,1,4,3,8,7,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_3',6
     &,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h7b .eq. h8b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_2pdm_hhpp_mo_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo_3',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_2pdm_hhpp_mo
     &_3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*> \brief \b STREVC
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download STREVC + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/strevc.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/strevc.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/strevc.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE STREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
*                          LDVR, MM, M, WORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          HOWMNY, SIDE
*       INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
*       ..
*       .. Array Arguments ..
*       LOGICAL            SELECT( * )
*       REAL               T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
*      $                   WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> STREVC computes some or all of the right and/or left eigenvectors of
*> a real upper quasi-triangular matrix T.
*> Matrices of this type are produced by the Schur factorization of
*> a real general matrix:  A = Q*T*Q**T, as computed by SHSEQR.
*> 
*> The right eigenvector x and the left eigenvector y of T corresponding
*> to an eigenvalue w are defined by:
*> 
*>    T*x = w*x,     (y**T)*T = w*(y**T)
*> 
*> where y**T denotes the transpose of y.
*> The eigenvalues are not input to this routine, but are read directly
*> from the diagonal blocks of T.
*> 
*> This routine returns the matrices X and/or Y of right and left
*> eigenvectors of T, or the products Q*X and/or Q*Y, where Q is an
*> input matrix.  If Q is the orthogonal factor that reduces a matrix
*> A to Schur form T, then Q*X and Q*Y are the matrices of right and
*> left eigenvectors of A.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'R':  compute right eigenvectors only;
*>          = 'L':  compute left eigenvectors only;
*>          = 'B':  compute both right and left eigenvectors.
*> \endverbatim
*>
*> \param[in] HOWMNY
*> \verbatim
*>          HOWMNY is CHARACTER*1
*>          = 'A':  compute all right and/or left eigenvectors;
*>          = 'B':  compute all right and/or left eigenvectors,
*>                  backtransformed by the matrices in VR and/or VL;
*>          = 'S':  compute selected right and/or left eigenvectors,
*>                  as indicated by the logical array SELECT.
*> \endverbatim
*>
*> \param[in,out] SELECT
*> \verbatim
*>          SELECT is LOGICAL array, dimension (N)
*>          If HOWMNY = 'S', SELECT specifies the eigenvectors to be
*>          computed.
*>          If w(j) is a real eigenvalue, the corresponding real
*>          eigenvector is computed if SELECT(j) is .TRUE..
*>          If w(j) and w(j+1) are the real and imaginary parts of a
*>          complex eigenvalue, the corresponding complex eigenvector is
*>          computed if either SELECT(j) or SELECT(j+1) is .TRUE., and
*>          on exit SELECT(j) is set to .TRUE. and SELECT(j+1) is set to
*>          .FALSE..
*>          Not referenced if HOWMNY = 'A' or 'B'.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix T. N >= 0.
*> \endverbatim
*>
*> \param[in] T
*> \verbatim
*>          T is REAL array, dimension (LDT,N)
*>          The upper quasi-triangular matrix T in Schur canonical form.
*> \endverbatim
*>
*> \param[in] LDT
*> \verbatim
*>          LDT is INTEGER
*>          The leading dimension of the array T. LDT >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] VL
*> \verbatim
*>          VL is REAL array, dimension (LDVL,MM)
*>          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
*>          contain an N-by-N matrix Q (usually the orthogonal matrix Q
*>          of Schur vectors returned by SHSEQR).
*>          On exit, if SIDE = 'L' or 'B', VL contains:
*>          if HOWMNY = 'A', the matrix Y of left eigenvectors of T;
*>          if HOWMNY = 'B', the matrix Q*Y;
*>          if HOWMNY = 'S', the left eigenvectors of T specified by
*>                           SELECT, stored consecutively in the columns
*>                           of VL, in the same order as their
*>                           eigenvalues.
*>          A complex eigenvector corresponding to a complex eigenvalue
*>          is stored in two consecutive columns, the first holding the
*>          real part, and the second the imaginary part.
*>          Not referenced if SIDE = 'R'.
*> \endverbatim
*>
*> \param[in] LDVL
*> \verbatim
*>          LDVL is INTEGER
*>          The leading dimension of the array VL.  LDVL >= 1, and if
*>          SIDE = 'L' or 'B', LDVL >= N.
*> \endverbatim
*>
*> \param[in,out] VR
*> \verbatim
*>          VR is REAL array, dimension (LDVR,MM)
*>          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
*>          contain an N-by-N matrix Q (usually the orthogonal matrix Q
*>          of Schur vectors returned by SHSEQR).
*>          On exit, if SIDE = 'R' or 'B', VR contains:
*>          if HOWMNY = 'A', the matrix X of right eigenvectors of T;
*>          if HOWMNY = 'B', the matrix Q*X;
*>          if HOWMNY = 'S', the right eigenvectors of T specified by
*>                           SELECT, stored consecutively in the columns
*>                           of VR, in the same order as their
*>                           eigenvalues.
*>          A complex eigenvector corresponding to a complex eigenvalue
*>          is stored in two consecutive columns, the first holding the
*>          real part and the second the imaginary part.
*>          Not referenced if SIDE = 'L'.
*> \endverbatim
*>
*> \param[in] LDVR
*> \verbatim
*>          LDVR is INTEGER
*>          The leading dimension of the array VR.  LDVR >= 1, and if
*>          SIDE = 'R' or 'B', LDVR >= N.
*> \endverbatim
*>
*> \param[in] MM
*> \verbatim
*>          MM is INTEGER
*>          The number of columns in the arrays VL and/or VR. MM >= M.
*> \endverbatim
*>
*> \param[out] M
*> \verbatim
*>          M is INTEGER
*>          The number of columns in the arrays VL and/or VR actually
*>          used to store the eigenvectors.
*>          If HOWMNY = 'A' or 'B', M is set to N.
*>          Each selected real eigenvector occupies one column and each
*>          selected complex eigenvector occupies two columns.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (3*N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realOTHERcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The algorithm used in this program is basically backward (forward)
*>  substitution, with scaling to make the the code robust against
*>  possible overflow.
*>
*>  Each eigenvector is normalized so that the element of largest
*>  magnitude has magnitude 1; here the magnitude of a complex number
*>  (x,y) is taken to be |x| + |y|.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE STREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, MM, M, WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      REAL               T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLV, BOTHV, LEFTV, OVER, PAIR, RIGHTV, SOMEV
      INTEGER            I, IERR, II, IP, IS, J, J1, J2, JNXT, K, KI, N2
      REAL               BETA, BIGNUM, EMAX, OVFL, REC, REMAX, SCALE,
     $                   SMIN, SMLNUM, ULP, UNFL, VCRIT, VMAX, WI, WR,
     $                   XNORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ISAMAX
      REAL               SDOT, SLAMCH
      EXTERNAL           LSAME, ISAMAX, SDOT, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SAXPY, SCOPY, SGEMV, SLABAD, SLALN2, SSCAL,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Local Arrays ..
      REAL               X( 2, 2 )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      BOTHV = LSAME( SIDE, 'B' )
      RIGHTV = LSAME( SIDE, 'R' ) .OR. BOTHV
      LEFTV = LSAME( SIDE, 'L' ) .OR. BOTHV
*
      ALLV = LSAME( HOWMNY, 'A' )
      OVER = LSAME( HOWMNY, 'B' )
      SOMEV = LSAME( HOWMNY, 'S' )
*
      INFO = 0
      IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -1
      ELSE IF( .NOT.ALLV .AND. .NOT.OVER .AND. .NOT.SOMEV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( LEFTV .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( RIGHTV .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE
*
*        Set M to the number of columns required to store the selected
*        eigenvectors, standardize the array SELECT if necessary, and
*        test MM.
*
         IF( SOMEV ) THEN
            M = 0
            PAIR = .FALSE.
            DO 10 J = 1, N
               IF( PAIR ) THEN
                  PAIR = .FALSE.
                  SELECT( J ) = .FALSE.
               ELSE
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).EQ.ZERO ) THEN
                        IF( SELECT( J ) )
     $                     M = M + 1
                     ELSE
                        PAIR = .TRUE.
                        IF( SELECT( J ) .OR. SELECT( J+1 ) ) THEN
                           SELECT( J ) = .TRUE.
                           M = M + 2
                        END IF
                     END IF
                  ELSE
                     IF( SELECT( N ) )
     $                  M = M + 1
                  END IF
               END IF
   10       CONTINUE
         ELSE
            M = N
         END IF
*
         IF( MM.LT.M ) THEN
            INFO = -11
         END IF
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STREVC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set the constants to control overflow.
*
      UNFL = SLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL SLABAD( UNFL, OVFL )
      ULP = SLAMCH( 'Precision' )
      SMLNUM = UNFL*( N / ULP )
      BIGNUM = ( ONE-ULP ) / SMLNUM
*
*     Compute 1-norm of each column of strictly upper triangular
*     part of T to control overflow in triangular solver.
*
      WORK( 1 ) = ZERO
      DO 30 J = 2, N
         WORK( J ) = ZERO
         DO 20 I = 1, J - 1
            WORK( J ) = WORK( J ) + ABS( T( I, J ) )
   20    CONTINUE
   30 CONTINUE
*
*     Index IP is used to specify the real or complex eigenvalue:
*       IP = 0, real eigenvalue,
*            1, first of conjugate complex pair: (wr,wi)
*           -1, second of conjugate complex pair: (wr,wi)
*
      N2 = 2*N
*
      IF( RIGHTV ) THEN
*
*        Compute right eigenvectors.
*
         IP = 0
         IS = M
         DO 140 KI = N, 1, -1
*
            IF( IP.EQ.1 )
     $         GO TO 130
            IF( KI.EQ.1 )
     $         GO TO 40
            IF( T( KI, KI-1 ).EQ.ZERO )
     $         GO TO 40
            IP = -1
*
   40       CONTINUE
            IF( SOMEV ) THEN
               IF( IP.EQ.0 ) THEN
                  IF( .NOT.SELECT( KI ) )
     $               GO TO 130
               ELSE
                  IF( .NOT.SELECT( KI-1 ) )
     $               GO TO 130
               END IF
            END IF
*
*           Compute the KI-th eigenvalue (WR,WI).
*
            WR = T( KI, KI )
            WI = ZERO
            IF( IP.NE.0 )
     $         WI = SQRT( ABS( T( KI, KI-1 ) ) )*
     $              SQRT( ABS( T( KI-1, KI ) ) )
            SMIN = MAX( ULP*( ABS( WR )+ABS( WI ) ), SMLNUM )
*
            IF( IP.EQ.0 ) THEN
*
*              Real right eigenvector
*
               WORK( KI+N ) = ONE
*
*              Form right-hand side
*
               DO 50 K = 1, KI - 1
                  WORK( K+N ) = -T( K, KI )
   50          CONTINUE
*
*              Solve the upper quasi-triangular system:
*                 (T(1:KI-1,1:KI-1) - WR)*X = SCALE*WORK.
*
               JNXT = KI - 1
               DO 60 J = KI - 1, 1, -1
                  IF( J.GT.JNXT )
     $               GO TO 60
                  J1 = J
                  J2 = J
                  JNXT = J - 1
                  IF( J.GT.1 ) THEN
                     IF( T( J, J-1 ).NE.ZERO ) THEN
                        J1 = J - 1
                        JNXT = J - 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
                     CALL SLALN2( .FALSE., 1, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale X(1,1) to avoid overflow when updating
*                    the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        IF( WORK( J ).GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
*
*                    Update right-hand side
*
                     CALL SAXPY( J-1, -X( 1, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
*
                  ELSE
*
*                    2-by-2 diagonal block
*
                     CALL SLALN2( .FALSE., 2, 1, SMIN, ONE,
     $                            T( J-1, J-1 ), LDT, ONE, ONE,
     $                            WORK( J-1+N ), N, WR, ZERO, X, 2,
     $                            SCALE, XNORM, IERR )
*
*                    Scale X(1,1) and X(2,1) to avoid overflow when
*                    updating the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        BETA = MAX( WORK( J-1 ), WORK( J ) )
                        IF( BETA.GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           X( 2, 1 ) = X( 2, 1 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                     WORK( J-1+N ) = X( 1, 1 )
                     WORK( J+N ) = X( 2, 1 )
*
*                    Update right-hand side
*
                     CALL SAXPY( J-2, -X( 1, 1 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-2, -X( 2, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                  END IF
   60          CONTINUE
*
*              Copy the vector x or Q*x to VR and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( KI, WORK( 1+N ), 1, VR( 1, IS ), 1 )
*
                  II = ISAMAX( KI, VR( 1, IS ), 1 )
                  REMAX = ONE / ABS( VR( II, IS ) )
                  CALL SSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
                  DO 70 K = KI + 1, N
                     VR( K, IS ) = ZERO
   70             CONTINUE
               ELSE
                  IF( KI.GT.1 )
     $               CALL SGEMV( 'N', N, KI-1, ONE, VR, LDVR,
     $                           WORK( 1+N ), 1, WORK( KI+N ),
     $                           VR( 1, KI ), 1 )
*
                  II = ISAMAX( N, VR( 1, KI ), 1 )
                  REMAX = ONE / ABS( VR( II, KI ) )
                  CALL SSCAL( N, REMAX, VR( 1, KI ), 1 )
               END IF
*
            ELSE
*
*              Complex right eigenvector.
*
*              Initial solve
*                [ (T(KI-1,KI-1) T(KI-1,KI) ) - (WR + I* WI)]*X = 0.
*                [ (T(KI,KI-1)   T(KI,KI)   )               ]
*
               IF( ABS( T( KI-1, KI ) ).GE.ABS( T( KI, KI-1 ) ) ) THEN
                  WORK( KI-1+N ) = ONE
                  WORK( KI+N2 ) = WI / T( KI-1, KI )
               ELSE
                  WORK( KI-1+N ) = -WI / T( KI, KI-1 )
                  WORK( KI+N2 ) = ONE
               END IF
               WORK( KI+N ) = ZERO
               WORK( KI-1+N2 ) = ZERO
*
*              Form right-hand side
*
               DO 80 K = 1, KI - 2
                  WORK( K+N ) = -WORK( KI-1+N )*T( K, KI-1 )
                  WORK( K+N2 ) = -WORK( KI+N2 )*T( K, KI )
   80          CONTINUE
*
*              Solve upper quasi-triangular system:
*              (T(1:KI-2,1:KI-2) - (WR+i*WI))*X = SCALE*(WORK+i*WORK2)
*
               JNXT = KI - 2
               DO 90 J = KI - 2, 1, -1
                  IF( J.GT.JNXT )
     $               GO TO 90
                  J1 = J
                  J2 = J
                  JNXT = J - 1
                  IF( J.GT.1 ) THEN
                     IF( T( J, J-1 ).NE.ZERO ) THEN
                        J1 = J - 1
                        JNXT = J - 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
                     CALL SLALN2( .FALSE., 1, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR, WI,
     $                            X, 2, SCALE, XNORM, IERR )
*
*                    Scale X(1,1) and X(1,2) to avoid overflow when
*                    updating the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        IF( WORK( J ).GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           X( 1, 2 ) = X( 1, 2 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                        CALL SSCAL( KI, SCALE, WORK( 1+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
*
*                    Update the right-hand side
*
                     CALL SAXPY( J-1, -X( 1, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-1, -X( 1, 2 ), T( 1, J ), 1,
     $                           WORK( 1+N2 ), 1 )
*
                  ELSE
*
*                    2-by-2 diagonal block
*
                     CALL SLALN2( .FALSE., 2, 2, SMIN, ONE,
     $                            T( J-1, J-1 ), LDT, ONE, ONE,
     $                            WORK( J-1+N ), N, WR, WI, X, 2, SCALE,
     $                            XNORM, IERR )
*
*                    Scale X to avoid overflow when updating
*                    the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        BETA = MAX( WORK( J-1 ), WORK( J ) )
                        IF( BETA.GT.BIGNUM / XNORM ) THEN
                           REC = ONE / XNORM
                           X( 1, 1 ) = X( 1, 1 )*REC
                           X( 1, 2 ) = X( 1, 2 )*REC
                           X( 2, 1 ) = X( 2, 1 )*REC
                           X( 2, 2 ) = X( 2, 2 )*REC
                           SCALE = SCALE*REC
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( KI, SCALE, WORK( 1+N ), 1 )
                        CALL SSCAL( KI, SCALE, WORK( 1+N2 ), 1 )
                     END IF
                     WORK( J-1+N ) = X( 1, 1 )
                     WORK( J+N ) = X( 2, 1 )
                     WORK( J-1+N2 ) = X( 1, 2 )
                     WORK( J+N2 ) = X( 2, 2 )
*
*                    Update the right-hand side
*
                     CALL SAXPY( J-2, -X( 1, 1 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-2, -X( 2, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL SAXPY( J-2, -X( 1, 2 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N2 ), 1 )
                     CALL SAXPY( J-2, -X( 2, 2 ), T( 1, J ), 1,
     $                           WORK( 1+N2 ), 1 )
                  END IF
   90          CONTINUE
*
*              Copy the vector x or Q*x to VR and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( KI, WORK( 1+N ), 1, VR( 1, IS-1 ), 1 )
                  CALL SCOPY( KI, WORK( 1+N2 ), 1, VR( 1, IS ), 1 )
*
                  EMAX = ZERO
                  DO 100 K = 1, KI
                     EMAX = MAX( EMAX, ABS( VR( K, IS-1 ) )+
     $                      ABS( VR( K, IS ) ) )
  100             CONTINUE
*
                  REMAX = ONE / EMAX
                  CALL SSCAL( KI, REMAX, VR( 1, IS-1 ), 1 )
                  CALL SSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
                  DO 110 K = KI + 1, N
                     VR( K, IS-1 ) = ZERO
                     VR( K, IS ) = ZERO
  110             CONTINUE
*
               ELSE
*
                  IF( KI.GT.2 ) THEN
                     CALL SGEMV( 'N', N, KI-2, ONE, VR, LDVR,
     $                           WORK( 1+N ), 1, WORK( KI-1+N ),
     $                           VR( 1, KI-1 ), 1 )
                     CALL SGEMV( 'N', N, KI-2, ONE, VR, LDVR,
     $                           WORK( 1+N2 ), 1, WORK( KI+N2 ),
     $                           VR( 1, KI ), 1 )
                  ELSE
                     CALL SSCAL( N, WORK( KI-1+N ), VR( 1, KI-1 ), 1 )
                     CALL SSCAL( N, WORK( KI+N2 ), VR( 1, KI ), 1 )
                  END IF
*
                  EMAX = ZERO
                  DO 120 K = 1, N
                     EMAX = MAX( EMAX, ABS( VR( K, KI-1 ) )+
     $                      ABS( VR( K, KI ) ) )
  120             CONTINUE
                  REMAX = ONE / EMAX
                  CALL SSCAL( N, REMAX, VR( 1, KI-1 ), 1 )
                  CALL SSCAL( N, REMAX, VR( 1, KI ), 1 )
               END IF
            END IF
*
            IS = IS - 1
            IF( IP.NE.0 )
     $         IS = IS - 1
  130       CONTINUE
            IF( IP.EQ.1 )
     $         IP = 0
            IF( IP.EQ.-1 )
     $         IP = 1
  140    CONTINUE
      END IF
*
      IF( LEFTV ) THEN
*
*        Compute left eigenvectors.
*
         IP = 0
         IS = 1
         DO 260 KI = 1, N
*
            IF( IP.EQ.-1 )
     $         GO TO 250
            IF( KI.EQ.N )
     $         GO TO 150
            IF( T( KI+1, KI ).EQ.ZERO )
     $         GO TO 150
            IP = 1
*
  150       CONTINUE
            IF( SOMEV ) THEN
               IF( .NOT.SELECT( KI ) )
     $            GO TO 250
            END IF
*
*           Compute the KI-th eigenvalue (WR,WI).
*
            WR = T( KI, KI )
            WI = ZERO
            IF( IP.NE.0 )
     $         WI = SQRT( ABS( T( KI, KI+1 ) ) )*
     $              SQRT( ABS( T( KI+1, KI ) ) )
            SMIN = MAX( ULP*( ABS( WR )+ABS( WI ) ), SMLNUM )
*
            IF( IP.EQ.0 ) THEN
*
*              Real left eigenvector.
*
               WORK( KI+N ) = ONE
*
*              Form right-hand side
*
               DO 160 K = KI + 1, N
                  WORK( K+N ) = -T( KI, K )
  160          CONTINUE
*
*              Solve the quasi-triangular system:
*                 (T(KI+1:N,KI+1:N) - WR)**T*X = SCALE*WORK
*
               VMAX = ONE
               VCRIT = BIGNUM
*
               JNXT = KI + 1
               DO 170 J = KI + 1, N
                  IF( J.LT.JNXT )
     $               GO TO 170
                  J1 = J
                  J2 = J
                  JNXT = J + 1
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).NE.ZERO ) THEN
                        J2 = J + 1
                        JNXT = J + 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side.
*
                     IF( WORK( J ).GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-1, T( KI+1, J ), 1,
     $                             WORK( KI+1+N ), 1 )
*
*                    Solve (T(J,J)-WR)**T*X = WORK
*
                     CALL SLALN2( .FALSE., 1, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
                     VMAX = MAX( ABS( WORK( J+N ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  ELSE
*
*                    2-by-2 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side.
*
                     BETA = MAX( WORK( J ), WORK( J+1 ) )
                     IF( BETA.GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-1, T( KI+1, J ), 1,
     $                             WORK( KI+1+N ), 1 )
*
                     WORK( J+1+N ) = WORK( J+1+N ) -
     $                               SDOT( J-KI-1, T( KI+1, J+1 ), 1,
     $                               WORK( KI+1+N ), 1 )
*
*                    Solve
*                      [T(J,J)-WR   T(J,J+1)     ]**T* X = SCALE*( WORK1 )
*                      [T(J+1,J)    T(J+1,J+1)-WR]               ( WORK2 )
*
                     CALL SLALN2( .TRUE., 2, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+1+N ) = X( 2, 1 )
*
                     VMAX = MAX( ABS( WORK( J+N ) ),
     $                      ABS( WORK( J+1+N ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  END IF
  170          CONTINUE
*
*              Copy the vector x or Q*x to VL and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( N-KI+1, WORK( KI+N ), 1, VL( KI, IS ), 1 )
*
                  II = ISAMAX( N-KI+1, VL( KI, IS ), 1 ) + KI - 1
                  REMAX = ONE / ABS( VL( II, IS ) )
                  CALL SSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
*
                  DO 180 K = 1, KI - 1
                     VL( K, IS ) = ZERO
  180             CONTINUE
*
               ELSE
*
                  IF( KI.LT.N )
     $               CALL SGEMV( 'N', N, N-KI, ONE, VL( 1, KI+1 ), LDVL,
     $                           WORK( KI+1+N ), 1, WORK( KI+N ),
     $                           VL( 1, KI ), 1 )
*
                  II = ISAMAX( N, VL( 1, KI ), 1 )
                  REMAX = ONE / ABS( VL( II, KI ) )
                  CALL SSCAL( N, REMAX, VL( 1, KI ), 1 )
*
               END IF
*
            ELSE
*
*              Complex left eigenvector.
*
*               Initial solve:
*                 ((T(KI,KI)    T(KI,KI+1) )**T - (WR - I* WI))*X = 0.
*                 ((T(KI+1,KI) T(KI+1,KI+1))                )
*
               IF( ABS( T( KI, KI+1 ) ).GE.ABS( T( KI+1, KI ) ) ) THEN
                  WORK( KI+N ) = WI / T( KI, KI+1 )
                  WORK( KI+1+N2 ) = ONE
               ELSE
                  WORK( KI+N ) = ONE
                  WORK( KI+1+N2 ) = -WI / T( KI+1, KI )
               END IF
               WORK( KI+1+N ) = ZERO
               WORK( KI+N2 ) = ZERO
*
*              Form right-hand side
*
               DO 190 K = KI + 2, N
                  WORK( K+N ) = -WORK( KI+N )*T( KI, K )
                  WORK( K+N2 ) = -WORK( KI+1+N2 )*T( KI+1, K )
  190          CONTINUE
*
*              Solve complex quasi-triangular system:
*              ( T(KI+2,N:KI+2,N) - (WR-i*WI) )*X = WORK1+i*WORK2
*
               VMAX = ONE
               VCRIT = BIGNUM
*
               JNXT = KI + 2
               DO 200 J = KI + 2, N
                  IF( J.LT.JNXT )
     $               GO TO 200
                  J1 = J
                  J2 = J
                  JNXT = J + 1
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).NE.ZERO ) THEN
                        J2 = J + 1
                        JNXT = J + 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
*                    Scale if necessary to avoid overflow when
*                    forming the right-hand side elements.
*
                     IF( WORK( J ).GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N2 ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-2, T( KI+2, J ), 1,
     $                             WORK( KI+2+N ), 1 )
                     WORK( J+N2 ) = WORK( J+N2 ) -
     $                              SDOT( J-KI-2, T( KI+2, J ), 1,
     $                              WORK( KI+2+N2 ), 1 )
*
*                    Solve (T(J,J)-(WR-i*WI))*(X11+i*X12)= WK+I*WK2
*
                     CALL SLALN2( .FALSE., 1, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            -WI, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
                     VMAX = MAX( ABS( WORK( J+N ) ),
     $                      ABS( WORK( J+N2 ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  ELSE
*
*                    2-by-2 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side elements.
*
                     BETA = MAX( WORK( J ), WORK( J+1 ) )
                     IF( BETA.GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, REC, WORK( KI+N2 ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             SDOT( J-KI-2, T( KI+2, J ), 1,
     $                             WORK( KI+2+N ), 1 )
*
                     WORK( J+N2 ) = WORK( J+N2 ) -
     $                              SDOT( J-KI-2, T( KI+2, J ), 1,
     $                              WORK( KI+2+N2 ), 1 )
*
                     WORK( J+1+N ) = WORK( J+1+N ) -
     $                               SDOT( J-KI-2, T( KI+2, J+1 ), 1,
     $                               WORK( KI+2+N ), 1 )
*
                     WORK( J+1+N2 ) = WORK( J+1+N2 ) -
     $                                SDOT( J-KI-2, T( KI+2, J+1 ), 1,
     $                                WORK( KI+2+N2 ), 1 )
*
*                    Solve 2-by-2 complex linear equation
*                      ([T(j,j)   T(j,j+1)  ]**T-(wr-i*wi)*I)*X = SCALE*B
*                      ([T(j+1,j) T(j+1,j+1)]               )
*
                     CALL SLALN2( .TRUE., 2, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            -WI, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                        CALL SSCAL( N-KI+1, SCALE, WORK( KI+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
                     WORK( J+1+N ) = X( 2, 1 )
                     WORK( J+1+N2 ) = X( 2, 2 )
                     VMAX = MAX( ABS( X( 1, 1 ) ), ABS( X( 1, 2 ) ),
     $                      ABS( X( 2, 1 ) ), ABS( X( 2, 2 ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  END IF
  200          CONTINUE
*
*              Copy the vector x or Q*x to VL and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL SCOPY( N-KI+1, WORK( KI+N ), 1, VL( KI, IS ), 1 )
                  CALL SCOPY( N-KI+1, WORK( KI+N2 ), 1, VL( KI, IS+1 ),
     $                        1 )
*
                  EMAX = ZERO
                  DO 220 K = KI, N
                     EMAX = MAX( EMAX, ABS( VL( K, IS ) )+
     $                      ABS( VL( K, IS+1 ) ) )
  220             CONTINUE
                  REMAX = ONE / EMAX
                  CALL SSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
                  CALL SSCAL( N-KI+1, REMAX, VL( KI, IS+1 ), 1 )
*
                  DO 230 K = 1, KI - 1
                     VL( K, IS ) = ZERO
                     VL( K, IS+1 ) = ZERO
  230             CONTINUE
               ELSE
                  IF( KI.LT.N-1 ) THEN
                     CALL SGEMV( 'N', N, N-KI-1, ONE, VL( 1, KI+2 ),
     $                           LDVL, WORK( KI+2+N ), 1, WORK( KI+N ),
     $                           VL( 1, KI ), 1 )
                     CALL SGEMV( 'N', N, N-KI-1, ONE, VL( 1, KI+2 ),
     $                           LDVL, WORK( KI+2+N2 ), 1,
     $                           WORK( KI+1+N2 ), VL( 1, KI+1 ), 1 )
                  ELSE
                     CALL SSCAL( N, WORK( KI+N ), VL( 1, KI ), 1 )
                     CALL SSCAL( N, WORK( KI+1+N2 ), VL( 1, KI+1 ), 1 )
                  END IF
*
                  EMAX = ZERO
                  DO 240 K = 1, N
                     EMAX = MAX( EMAX, ABS( VL( K, KI ) )+
     $                      ABS( VL( K, KI+1 ) ) )
  240             CONTINUE
                  REMAX = ONE / EMAX
                  CALL SSCAL( N, REMAX, VL( 1, KI ), 1 )
                  CALL SSCAL( N, REMAX, VL( 1, KI+1 ), 1 )
*
               END IF
*
            END IF
*
            IS = IS + 1
            IF( IP.NE.0 )
     $         IS = IS + 1
  250       CONTINUE
            IF( IP.EQ.-1 )
     $         IP = 0
            IF( IP.EQ.1 )
     $         IP = -1
*
  260    CONTINUE
*
      END IF
*
      RETURN
*
*     End of STREVC
*
      END
c $Id: strevc.f 24343 2013-06-22 05:35:15Z d3y133 $

*> \brief \b CUNML2 multiplies a general matrix by the unitary matrix from a LQ factorization determined by cgelqf (unblocked algorithm).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download CUNML2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/cunml2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/cunml2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/cunml2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CUNML2( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
*                          WORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          SIDE, TRANS
*       INTEGER            INFO, K, LDA, LDC, M, N
*       ..
*       .. Array Arguments ..
*       COMPLEX            A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CUNML2 overwrites the general complex m-by-n matrix C with
*>
*>       Q * C  if SIDE = 'L' and TRANS = 'N', or
*>
*>       Q**H* C  if SIDE = 'L' and TRANS = 'C', or
*>
*>       C * Q  if SIDE = 'R' and TRANS = 'N', or
*>
*>       C * Q**H if SIDE = 'R' and TRANS = 'C',
*>
*> where Q is a complex unitary matrix defined as the product of k
*> elementary reflectors
*>
*>       Q = H(k)**H . . . H(2)**H H(1)**H
*>
*> as returned by CGELQF. Q is of order m if SIDE = 'L' and of order n
*> if SIDE = 'R'.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'L': apply Q or Q**H from the Left
*>          = 'R': apply Q or Q**H from the Right
*> \endverbatim
*>
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>          = 'N': apply Q  (No transpose)
*>          = 'C': apply Q**H (Conjugate transpose)
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix C. M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix C. N >= 0.
*> \endverbatim
*>
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>          The number of elementary reflectors whose product defines
*>          the matrix Q.
*>          If SIDE = 'L', M >= K >= 0;
*>          if SIDE = 'R', N >= K >= 0.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is COMPLEX array, dimension
*>                               (LDA,M) if SIDE = 'L',
*>                               (LDA,N) if SIDE = 'R'
*>          The i-th row must contain the vector which defines the
*>          elementary reflector H(i), for i = 1,2,...,k, as returned by
*>          CGELQF in the first k rows of its array argument A.
*>          A is modified by the routine but restored on exit.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A. LDA >= max(1,K).
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is COMPLEX array, dimension (K)
*>          TAU(i) must contain the scalar factor of the elementary
*>          reflector H(i), as returned by CGELQF.
*> \endverbatim
*>
*> \param[in,out] C
*> \verbatim
*>          C is COMPLEX array, dimension (LDC,N)
*>          On entry, the m-by-n matrix C.
*>          On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
*> \endverbatim
*>
*> \param[in] LDC
*> \verbatim
*>          LDC is INTEGER
*>          The leading dimension of the array C. LDC >= max(1,M).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX array, dimension
*>                                   (N) if SIDE = 'L',
*>                                   (M) if SIDE = 'R'
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complexOTHERcomputational
*
*  =====================================================================
      SUBROUTINE CUNML2( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, NOTRAN
      INTEGER            I, I1, I2, I3, IC, JC, MI, NI, NQ
      COMPLEX            AII, TAUI
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CLACGV, CLARF, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
*
*     NQ is the order of Q
*
      IF( LEFT ) THEN
         NQ = M
      ELSE
         NQ = N
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, K ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNML2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 )
     $   RETURN
*
      IF( ( LEFT .AND. NOTRAN .OR. .NOT.LEFT .AND. .NOT.NOTRAN ) ) THEN
         I1 = 1
         I2 = K
         I3 = 1
      ELSE
         I1 = K
         I2 = 1
         I3 = -1
      END IF
*
      IF( LEFT ) THEN
         NI = N
         JC = 1
      ELSE
         MI = M
         IC = 1
      END IF
*
      DO 10 I = I1, I2, I3
         IF( LEFT ) THEN
*
*           H(i) or H(i)**H is applied to C(i:m,1:n)
*
            MI = M - I + 1
            IC = I
         ELSE
*
*           H(i) or H(i)**H is applied to C(1:m,i:n)
*
            NI = N - I + 1
            JC = I
         END IF
*
*        Apply H(i) or H(i)**H
*
         IF( NOTRAN ) THEN
            TAUI = CONJG( TAU( I ) )
         ELSE
            TAUI = TAU( I )
         END IF
         IF( I.LT.NQ )
     $      CALL CLACGV( NQ-I, A( I, I+1 ), LDA )
         AII = A( I, I )
         A( I, I ) = ONE
         CALL CLARF( SIDE, MI, NI, A( I, I ), LDA, TAUI, C( IC, JC ),
     $               LDC, WORK )
         A( I, I ) = AII
         IF( I.LT.NQ )
     $      CALL CLACGV( NQ-I, A( I, I+1 ), LDA )
   10 CONTINUE
      RETURN
*
*     End of CUNML2
*
      END
c $Id: cunml2.f 24343 2013-06-22 05:35:15Z d3y133 $

#ifdef XLF14
@PROCESS NOOPTimize
#endif
      Subroutine hfdkei(alpha,E,Tab,Ti,NPP,Nint,La,Lb,Li,
     &                  MXD,inder,Nder,canAB)
c $Id: hfdkei.F 24347 2013-06-23 04:26:26Z d3y133 $

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Logical canAB

c--> Hermite Linear Expansion Coefficients

      Dimension E(3,NPP,0:MXD,0:((La+Li)+(Lb+Li)),0:(La+Li),0:(Lb+Li))

c--> Exponents

      Dimension alpha(2,NPP)

c--> Kinetic Energy Integrals

      Dimension Tab(Nint,Nder)

c--> Derivative Indices

      Dimension inder(3,Nder)

c--> Scratch Space

      Dimension Nxyz(3),Ti(NPP)
c
c Compute the kinetic energy integrals.
c
c     Formula:                                                       
c
c            1  /  Ia,Ib   Ja,Jb   Ka,Kb                       \
c     Tab =  - | T      Ey      Ez      + "Y-term" + "Z-term"   |
c            2  \  X       0       0                           /
c                                                                     
c      i,j         i-1,j-1      i-1,j+1       i+1,j-1       i+1,j+1   
c     T      = ijEx       - 2ibEx      - 2ajEx       + 4abEx          
c      X           0             0            0             0
c                                                                     
c******************************************************************************
  
c Initialize the block of KEIs.

      do 10 id = 1,Nder
      do 10 nn = 1,Nint
       Tab(nn,id) = 0.D0
   10 continue

c Define the number of shell components on each center.

      La2 = ((La+1)*(La+2))/2
      Lb2 = ((Lb+1)*(Lb+2))/2

c Loop over shell components.

      nn = 0

      do 420 ma = 1,La2

c Define the angular momentum indices for shell "A".

       call getNxyz(La,ma,Nxyz)

       Ia = Nxyz(1)
       Ja = Nxyz(2)
       Ka = Nxyz(3)

       if( canAB )then
        mb_limit = ma
       else
        mb_limit = Lb2
       end if

       do 410 mb = 1,mb_limit

c Define the angular momentum indices for shell "B".

        call getNxyz(Lb,mb,Nxyz)

        Ib = Nxyz(1)
        Jb = Nxyz(2)
        Kb = Nxyz(3)

        nn = nn + 1

        do 405 id = 1,Nder

         n1 = inder(1,id)
         n2 = inder(2,id)
         n3 = inder(3,id)
  
c Build Tx.
  
        if( Ia.gt.0 .and. Ib.gt.0 )then
         do 100 m = 1,NPP
          Ti(m) =   0.5D0*(        Ia*Ib        )*E(1,m,n1,0,Ia-1,Ib-1)
     &            -       (        Ia*alpha(2,m))*E(1,m,n1,0,Ia-1,Ib+1)
     &            -       (alpha(1,m)*Ib        )*E(1,m,n1,0,Ia+1,Ib-1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(1,m,n1,0,Ia+1,Ib+1)
  100    continue
        else if( Ia.gt.0 )then
         do 110 m = 1,NPP
          Ti(m) = -       (        Ia*alpha(2,m))*E(1,m,n1,0,Ia-1,Ib+1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(1,m,n1,0,Ia+1,Ib+1)
  110    continue
        else if( Ib.gt.0 )then
         do 120 m = 1,NPP
          Ti(m) = -       (alpha(1,m)*Ib        )*E(1,m,n1,0,Ia+1,Ib-1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(1,m,n1,0,Ia+1,Ib+1)
  120    continue
        else
         do 130 m = 1,NPP
          Ti(m) =   2.0D0*(alpha(1,m)*alpha(2,m))*E(1,m,n1,0,Ia+1,Ib+1)
  130    continue
        end if
  
c Add Tx*Ey*Ez to Tab
  
        do 140 m = 1,NPP
         Tab(nn,id) = Tab(nn,id) + Ti(m)*
     &                             E(2,m,n2,0,Ja,Jb)*
     &                             E(3,m,n3,0,Ka,Kb)
  140   continue
  
c Build Ty.
  
        if( Ja.gt.0 .and. Jb.gt.0 )then
         do 200 m = 1,NPP
          Ti(m) =   0.5D0*(        Ja*Jb        )*E(2,m,n2,0,Ja-1,Jb-1)
     &            -       (        Ja*alpha(2,m))*E(2,m,n2,0,Ja-1,Jb+1)
     &            -       (alpha(1,m)*Jb        )*E(2,m,n2,0,Ja+1,Jb-1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(2,m,n2,0,Ja+1,Jb+1)
  200    continue
        else if( Ja.gt.0 )then
         do 210 m = 1,NPP
          Ti(m) = -       (        Ja*alpha(2,m))*E(2,m,n2,0,Ja-1,Jb+1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(2,m,n2,0,Ja+1,Jb+1)
  210    continue
        else if( Jb.gt.0 )then
         do 220 m = 1,NPP
          Ti(m) = -       (alpha(1,m)*Jb        )*E(2,m,n2,0,Ja+1,Jb-1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(2,m,n2,0,Ja+1,Jb+1)
  220    continue
        else
         do 230 m = 1,NPP
          Ti(m) =   2.0D0*(alpha(1,m)*alpha(2,m))*E(2,m,n2,0,Ja+1,Jb+1)
  230    continue
        end if
  
c Add Ex*Ty*Ez to Tab.
  
        do 240 m = 1,NPP
         Tab(nn,id) = Tab(nn,id) + E(1,m,n1,0,Ia,Ib)*
     &                             Ti(m)*
     &                             E(3,m,n3,0,Ka,Kb)
  240   continue
  
c Build Tz.
  
        if( Ka.gt.0 .and. Kb.gt.0 )then
         do 300 m = 1,NPP
          Ti(m) =   0.5D0*(        Ka*Kb        )*E(3,m,n3,0,Ka-1,Kb-1)
     &            -       (        Ka*alpha(2,m))*E(3,m,n3,0,Ka-1,Kb+1)
     &            -       (alpha(1,m)*Kb        )*E(3,m,n3,0,Ka+1,Kb-1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(3,m,n3,0,Ka+1,Kb+1)
  300    continue
        else if( Ka.gt.0 )then
         do 310 m = 1,NPP
          Ti(m) = -       (        Ka*alpha(2,m))*E(3,m,n3,0,Ka-1,Kb+1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(3,m,n3,0,Ka+1,Kb+1)
  310    continue
        else if( Kb.gt.0 )then
         do 320 m = 1,NPP
          Ti(m) = -       (alpha(1,m)*Kb        )*E(3,m,n3,0,Ka+1,Kb-1)
     &            + 2.0D0*(alpha(1,m)*alpha(2,m))*E(3,m,n3,0,Ka+1,Kb+1)
  320    continue
        else
         do 330 m = 1,NPP
          Ti(m) =   2.0D0*(alpha(1,m)*alpha(2,m))*E(3,m,n3,0,Ka+1,Kb+1)
  330    continue
        end if
  
c Add Ex*Ey*Tz to Tab.
  
        do 340 m = 1,NPP
         Tab(nn,id) = Tab(nn,id) + E(1,m,n1,0,Ia,Ib)*
     &                             E(2,m,n2,0,Ja,Jb)*
     &                             Ti(m)
  340   continue

  405  continue

  410  continue

  420 continue
  
      end

      subroutine tce_ao1e_shellfockbuild(rtdb,g_ao1e)
c
c $Id: tce_ao1e.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Returns a GA handle for AO Fock matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer rtdb               ! Run-time database
      integer g_ao1e(2)          ! GA handle for AO Fock matrices
      integer g_dens(2)          ! GA handle for AO density matrices
      integer g_hcore            ! GA handle for AO hcore (T+V) matrices
c     logical symmetry           ! True if symmetry is used in integral evaluation
c
c 7/1/03 Remember that there is a global variable with the same name (tce.fh)
c
      integer idim(3)            ! Dimension array for NGA create
      integer ichunk(3)          ! Chunk array for NGA create
      integer alo(2),ahi(2)      ! Regions for patch
      integer blo(3),bhi(3)      ! Regions for patch
      integer g_ndens,g_nfock    ! NGA handles for work density and Fock matrices
      double precision jf(4)     ! Prefactor for HF Coulomb as input for shell_fock_build
      double precision kf(4)     ! Prefactor for HF exchange as input for shell_fock_build
      integer i
      integer ndu,nfu
c
c     ====================
c     Initialize int_API's
c     ====================
c
c     symmetry=(sym_number_ops(geom).gt.0).and.sym_abelian_group(geom)
      call scf_get_fock_param(rtdb,tol2e)
c
c     ================================
c     Allocate g_ao1e, g_dens, g_hcore
c     ================================
c
      if (.not.ga_create(mt_dbl,nbf,nbf,'alpha AO Fock',
     1  -1,-1,g_ao1e(1))) call errquit('tce_ao1e: GA problem',0,GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'beta AO Fock',
     1  -1,-1,g_ao1e(2))) call errquit('tce_ao1e: GA problem',1,GA_ERR)
      do i=1,ipol
        if (.not.ga_create(mt_dbl,nbf,nbf,'AO density',
     1    -1,-1,g_dens(i))) call errquit('tce_ao1e: GA problem',2,
     2    GA_ERR)
      enddo
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO H core',
     1  -1,-1,g_hcore)) call errquit('tce_ao1e: GA problem',3,GA_ERR)
c
c     =====================
c     Make density matrices
c     =====================
c
      do i=1,ipol
        call ga_dgemm('N','T',nbf,nbf,nocc(i),1.0d0,
     1    g_movecs(i),g_movecs(i),0.0d0,g_dens(i))
        if (ipol.eq.1) call ga_dscal(g_dens(i),2.0d0)
        if (util_print('ao1e',
     1    print_debug)) call ga_print(g_dens(i))
      enddo
c
c     ===========================
c     Make core Hamiltonian (T+V)
c     ===========================
c
      call ga_zero(g_hcore)
      call int_1e_ga(ao_bas_han,ao_bas_han,g_hcore,'kinetic',.false.)
      call int_1e_ga(ao_bas_han,ao_bas_han,g_hcore,'potential',.false.)
      if (util_print('ao1e',
     1  print_debug)) call ga_print(g_hcore)
c
c     =====================
c     Call shell_fock_build
c     =====================
c
c     Note: even when a KS reference wave function is used,
c     the Fock operator is defined in a conventional HF way,
c     and is never the KS Hamiltonian.
c
      idim(1)=ipol
      idim(2)=nbf
      idim(3)=nbf
      ichunk(1)=ipol
      ichunk(2)=-1
      ichunk(3)=-1
      if (.not.nga_create(mt_dbl,3,idim,'Work density matrix',
     1  ichunk,g_ndens)) call errquit
     2  ('tce_ao1e: failed to create g_ndens',0,GA_ERR)
      if (.not.nga_create(mt_dbl,3,idim,'Work Fock matrix',
     1  ichunk,g_nfock)) call errquit
     2  ('tce_ao1e: failed to create g_nfock',0,GA_ERR)
      do i=1,ipol
        alo(1)=1
        ahi(1)=nbf
        alo(2)=1
        ahi(2)=nbf
        blo(1)=i
        bhi(1)=i
        blo(2)=1
        bhi(2)=nbf
        blo(3)=1
        bhi(3)=nbf
        call nga_copy_patch('N',g_dens(i),alo,ahi,g_ndens,blo,bhi)
      enddo
      call ga_zero(g_nfock)
      if (ipol.eq.1) then
        jf(1)=1.0d0
        kf(1)=-0.5d0
        call shell_fock_build(geom,ao_bas_han,0,1,
     1    jf,kf,tol2e,g_ndens,g_nfock,.true.)
      else if (ipol.eq.2) then
        jf(1)=1.0d0
        kf(1)=1.0d0
        jf(2)=1.0d0
        kf(2)=1.0d0
        ndu=2
        nfu=2
        call uhf_fock_setup(g_ndens,g_nfock,jf,kf,ndu,
     1    nfu,nbf,.false.)
        call shell_fock_build(geom,ao_bas_han,0,ndu,
     1    jf,kf,tol2e,g_ndens,g_nfock,.true.)
        call uhf_fock_finish(g_ndens,g_nfock,jf,kf,ndu,
     1    nfu,nbf,.false.)
      endif
      do i=1,ipol
        alo(1)=1
        ahi(1)=nbf
        alo(2)=1
        ahi(2)=nbf
        blo(1)=i
        bhi(1)=i
        blo(2)=1
        bhi(2)=nbf
        blo(3)=1
        bhi(3)=nbf
        call nga_copy_patch('N',g_nfock,blo,bhi,g_ao1e(i),alo,ahi)
      enddo
      do i=1,ipol
        call ga_add(1.0d0,g_hcore,1.0d0,g_ao1e(i),g_ao1e(i))
      enddo
      if (ipol.eq.1) call ga_copy(g_ao1e(1),g_ao1e(2))
      if (util_print('ao1e',print_debug)) then
        call ga_print(g_ao1e(1))
        call ga_print(g_ao1e(2))
      endif
c
c     ==========
c     Deallocate
c     ==========
c
      if (.not.ga_destroy(g_hcore))
     1  call errquit('tce_ao1e: failed to destroy g_hcore',0,GA_ERR)
      do i=1,ipol
        if (.not.ga_destroy(g_dens(i)))
     1  call errquit('tce_ao1e: failed to destroy g_aodens',0,GA_ERR)
      enddo
      if (.not.ga_destroy(g_ndens))
     1  call errquit('tce_ao1e: failed to destroy g_ndens',0,GA_ERR)
      if (.not.ga_destroy(g_nfock))
     1  call errquit('tce_ao1e: failed to destroy g_nfock',0,GA_ERR)
c
c     ======
c     Return
c     ======
c
      do i = 1, ipol
        if (.not.ga_destroy(g_movecs(i)))
     1    call errquit('tce_ao1e: GA problem',0,GA_ERR)
      enddo
      return
      end
      subroutine tce_ao1e_fock2e(rtdb,g_ao1e)
c
c     Returns a GA handle for AO Fock matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer rtdb               ! Run-time database
      integer g_ao1e(2)          ! GA handle for AO Fock matrices
      integer g_dens(4)          ! GA handle for AO density matrices
      integer g_fock(4)          ! GA handle for AO density matrices
      integer g_hcore            ! GA handle for AO hcore (T+V) matrices
      double precision jf(4)     ! Prefactor for HF Coulomb
      double precision kf(4)     ! Prefactor for HF exchange
      integer i
c
c     ====================
c     Initialize int_API's
c     ====================
c
      call scf_get_fock_param(rtdb,tol2e)
c
c     ================================
c     Allocate g_ao1e, g_dens, g_hcore
c     ================================
c
      if (.not.ga_create(mt_dbl,nbf,nbf,'alpha AO Fock',
     1  -1,-1,g_ao1e(1))) call errquit('tce_ao1e: GA problem',0,GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'beta AO Fock',
     1  -1,-1,g_ao1e(2))) call errquit('tce_ao1e: GA problem',1,GA_ERR)
      do i=1,4
        if (.not.ga_create(mt_dbl,nbf,nbf,'AO density',
     1    -1,-1,g_dens(i))) call errquit('tce_ao1e: GA problem',2,
     2    GA_ERR)
        if (.not.ga_create(mt_dbl,nbf,nbf,'AO Fock',
     1    -1,-1,g_fock(i))) call errquit('tce_ao1e: GA problem',3,
     2    GA_ERR)
        call ga_zero(g_fock(i))
      enddo
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO H core',
     1  -1,-1,g_hcore)) call errquit('tce_ao1e: GA problem',4,GA_ERR)
c
c     =====================
c     Make density matrices
c     =====================
c
      do i=1,ipol
        call ga_dgemm('N','T',nbf,nbf,nocc(i),1.0d0,
     1    g_movecs(i),g_movecs(i),0.0d0,g_dens(i))
        if (ipol.eq.1) call ga_dscal(g_dens(i),2.0d0)
        if (util_print('ao1e',
     1    print_debug)) call ga_print(g_dens(i))
      enddo
      if (ipol.eq.2) then
        call ga_copy(g_dens(1),g_dens(3))
        call ga_copy(g_dens(2),g_dens(4))
      endif
c
c     ===========================
c     Make core Hamiltonian (T+V)
c     ===========================
c
      call ga_zero(g_hcore)
      call int_1e_ga(ao_bas_han,ao_bas_han,g_hcore,'kinetic',.false.)
      call int_1e_ga(ao_bas_han,ao_bas_han,g_hcore,'potential',.false.)
      if (util_print('ao1e',
     1  print_debug)) call ga_print(g_hcore)
c
c     ============
c     Call fock_2e
c     ============
c
c     Note: even when a KS reference wave function is used,
c     the Fock operator is defined in a conventional HF way,
c     and is never the KS Hamiltonian.
c
      if (ipol.eq.1) then
        jf(1)=1.0d0
        kf(1)=-0.5d0
        call fock_2e(geom,ao_bas_han,1,
     1    jf,kf,tol2e,.false.,g_dens,g_fock,.false.)
      else if (ipol.eq.2) then
        jf(1)=1.0d0
        kf(1)=0.0d0
        jf(2)=1.0d0
        kf(2)=0.0d0
        jf(3)=0.0d0
        kf(3)=1.0d0
        jf(4)=0.0d0
        kf(4)=1.0d0
        call fock_2e(geom,ao_bas_han,4,
     1    jf,kf,tol2e,.false.,g_dens,g_fock,.false.)
      endif
      if (ipol.eq.1) then
        call ga_add(1.0d0,g_hcore,1.0d0,g_fock(1),g_ao1e(1))
        call ga_copy(g_ao1e(1),g_ao1e(2))
      else
        call ga_add(1.0d0,g_hcore,1.0d0,g_fock(1),g_ao1e(1))
        call ga_add(1.0d0,g_ao1e(1),1.0d0,g_fock(2),g_ao1e(1))
        call ga_add(1.0d0,g_ao1e(1),-1.0d0,g_fock(3),g_ao1e(1))
        call ga_add(1.0d0,g_hcore,1.0d0,g_fock(1),g_ao1e(2))
        call ga_add(1.0d0,g_ao1e(2),1.0d0,g_fock(2),g_ao1e(2))
        call ga_add(1.0d0,g_ao1e(2),-1.0d0,g_fock(4),g_ao1e(2))
      endif
      if (util_print('ao1e',print_debug)) then
        call ga_print(g_ao1e(1))
        call ga_print(g_ao1e(2))
      endif
c
c     ==========
c     Deallocate
c     ==========
c
      if (.not.ga_destroy(g_hcore))
     1  call errquit('tce_ao1e: failed to destroy g_hcore',0,GA_ERR)
      do i=1,4
        if (.not.ga_destroy(g_dens(i)))
     1  call errquit('tce_ao1e: failed to destroy g_dens',0,GA_ERR)
        if (.not.ga_destroy(g_fock(i)))
     1  call errquit('tce_ao1e: failed to destroy g_fock',0,GA_ERR)
      enddo
c
c     ======
c     Return
c     ======
c
      return
      end

c
c     qmd_driver: main driver
c
      logical function qmd_driver(rtdb)
c
      implicit none
c
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
#include "stdio.fh"
c
#include "qmd_common.fh"
c
      integer rtdb
c
      integer geom                  ! geometry object
c
      integer l_r, k_r              ! coordinates
      double precision r(3)
c
      integer l_v, k_v              ! velocities
      double precision v(3)
c
      integer l_g, k_g              ! gradients
      integer l_m, k_m              ! masses
c
      integer l_act, k_act          ! active atoms
c
      integer nat                   ! number of atoms
      integer nactive               ! number of active atoms
      integer nstep_nucl           ! total nuclear steps
      integer istep_nucl           ! nuclear md step
      double precision dt_nucl      ! nuclear md time step
      double precision esys         ! system energy (from task_gradient)
      double precision ekin         ! kinetic energy from the md part
      double precision etotal       ! total energy: esys + ekin
c
      logical status
c
      character*32 pname
      integer xyzfileunit
      character*255 xyzfilename
      integer rstfileunit
      character*255 rstfilename
c
      logical task_gradient
      external task_gradient
c
c     preliminaries
      status = .true.
      pname = "qmd_driver: "
      esys = 0.d0
      ekin = 0.d0
      etotal = 0.d0
c
c     get xyzfileunit
      if(.not.util_get_io_unit(xyzfileunit))
     &   call errquit("cannot get file unit",0,0)
c
c     get xyzfilename
      call util_file_name('xyz',.false.,.false.,xyzfilename)
c
c     get rstfileunit
      if(.not.util_get_io_unit(rstfileunit))
     &   call errquit("cannot get file unit",0,0)
c
c     get rstfilename
      call util_file_name('qmdrst',.false.,.false.,rstfilename)
c
c     initialize parameters
      call qmd_init(rtdb,nstep_nucl,dt_nucl)
c
c     create geometry object 
      if (.not. geom_create(geom,'geometry'))
     &   call errquit(pname//'geom_create', 911, GEOM_ERR)
c
c     load in the geometry
      if (.not. geom_rtdb_load(rtdb,geom,'geometry'))
     &   call errquit(pname//'geom_rtdb_load', geom, RTDB_ERR)
c
c     get number of atoms
      if (.not. geom_ncent(geom,nat))
     $   call errquit(pname//'geom_ncent',geom, GEOM_ERR)
      if (nat.eq.0) return
c
c     local memory and initialization
      if(.not.ma_push_get(mt_dbl,nat,'mass',l_m,k_m))  ! mass
     $   call errquit(pname//'ma_push_get mass', nat,MA_ERR)
      call dfill(nat, 0.0d0, dbl_mb(k_m), 1)
c
      if(.not.ma_push_get(mt_dbl,3*nat,'coords',l_r,k_r)) ! coords
     $   call errquit(pname//'ma_push_get coords', 3*nat,MA_ERR)
      call dfill(3*nat, 0.0d0, dbl_mb(k_r), 1)
c
      if(.not.ma_push_get(mt_dbl,3*nat,'vels',l_v,k_v))  ! vels
     $   call errquit(pname//'ma_push_get vels', 3*nat,MA_ERR)
      call dfill(3*nat, 0.0d0, dbl_mb(k_v), 1)
      if (.not.geom_vel_set(geom,dbl_mb(k_v))) ! init vels
     $   call errquit(pname//'geom_vel_set',0,GEOM_ERR)
c
      if(.not.ma_push_get(mt_dbl,3*nat,'grads',l_g,k_g))  ! grads
     $   call errquit(pname//'ma_push_get grads',3*nat,MA_ERR)
      call dfill(3*nat, 0.0d0, dbl_mb(k_g), 1)
c
c     get the active atoms (also need a check for linearity)
c     need to implement constraints
      if (.not. ma_push_get(mt_log,nat,'active atoms',l_act,k_act)) ! active
     $   call errquit(pname//'grad_active_atoms',nat,MA_ERR)
      call grad_active_atoms(rtdb, nat, log_mb(k_act), nactive)
      if (do_linear) then    ! check for linear flag
        ndeg = 3*nactive-5   ! 3N-5 (linear)
      else
        ndeg = 3*nactive-6   ! 3N-6 (general)
      end if
c
c     get the masses, initial coordinates
      if (.not.geom_masses_get(geom,nat,dbl_mb(k_m)))  ! masses
     $   call errquit(pname//'geom_masses_get',geom,GEOM_ERR)
      if (.not.geom_cart_coords_get(geom,dbl_mb(k_r)))
     $   call errquit(pname//'geom_cart_coords_get',0,GEOM_ERR)
c
c     perform energy gradient calculation on initial coordinates
      call qmd_gradient(rtdb,nat,dbl_mb(k_g),esys)
c
c     initialize velocity and acceleration 
      call qmd_nucl_dt(nat,dt_nucl,dbl_mb(k_m),dbl_mb(k_v),dbl_mb(k_g))
c
c     apply thermostat to initial velocities
      call qmd_thermostat(nat,dt_nucl,dbl_mb(k_m),dbl_mb(k_v),ekin)
c
c     start nuclear molecular dynamics loop
      do istep_nucl = 1,nstep_nucl
c
c       update position and velocity at half step: dt2
        call qmd_nucl_dt2(nat,dt_nucl,dbl_mb(k_m),dbl_mb(k_r),
     &      dbl_mb(k_v),dbl_mb(k_g))
c
c       apply thermostat
        call qmd_thermostat(nat,dt_nucl,dbl_mb(k_m),dbl_mb(k_v),ekin)
c
c       update geom and store in rtdb
        call qmd_geom_store(rtdb,geom,nat,dbl_mb(k_r))
c
c       calculate energy and gradient
        call qmd_gradient(rtdb,nat,dbl_mb(k_g),esys)
c
c       update velocity at full step: dt
        call qmd_nucl_dt(nat,dt_nucl,dbl_mb(k_m),dbl_mb(k_v),
     &             dbl_mb(k_g))
c
c       apply thermostat
        call qmd_thermostat(nat,dt_nucl,dbl_mb(k_m),dbl_mb(k_v),ekin)
c
c       persist updated velocity in geom
        if (.not.geom_vel_set(geom,dbl_mb(k_v)))
     $   call errquit(pname//'geom_vel_set',0,GEOM_ERR)
c
c       instantaneous total energy: instantaneous kinetic energy + system energy
        etotal = ekin + esys
c
c       instantaneous temperature
        final_temp = 2.0d0*ekin/kb/(1.d0*ndeg)
c
c       print md run information
        if (ga_nodeid().eq.0) then
c
         write(luout,*)
         write(luout,*)
         call util_print_centered(LuOut,'QMD Run Information',20,.true.)
         write(luout,*) "istep_nucl: ",istep_nucl
         write(luout,*) "Time elapsed: ",istep_nucl*dt_nucl*au2fs
         write(luout,*) "ekin: ",ekin
         write(luout,*) "esys: ",esys
         write(luout,*) "etotal: ",etotal
         write(luout,*) "targ_temp: ",targ_temp
         write(luout,*) "final_temp: ",final_temp
         write(luout,*)
c
c        write trajectory
         call qmd_write_trj(xyzfilename,xyzfileunit,.true.,nat,
     &          istep_nucl,etotal,geom)
        end if  ! ga_nodeid()
c
      end do  ! istep_nucl
c
c     write restart information
      if (ga_nodeid().eq.0) then
         call qmd_write_rst(rstfilename,rstfileunit,
     &             nat,istep_nucl-1,esys,ekin,geom)
      end if
c
c     clear memory
      if(.not.ma_pop_stack(l_act))! active
     + call errquit(pname//'ma_pop_stack act',0,MA_ERR)
      if(.not.ma_pop_stack(l_g))  ! gradient
     + call errquit(pname//'ma_pop_stack g',0,MA_ERR)
      if(.not.ma_pop_stack(l_v))  ! velocity
     + call errquit(pname//'ma_pop_stack v',0,MA_ERR)
      if(.not.ma_pop_stack(l_r))  ! positions
     + call errquit(pname//'ma_pop_stack r',0,MA_ERR)
      if(.not.ma_pop_stack(l_m))  ! masses
     + call errquit(pname//'ma_pop_stack m',0,MA_ERR)
      if(.not.ma_verify_allocator_stuff())
     + call errquit(pname//'ma_verify_allocator_stuff',0,MA_ERR)
      if(.not.geom_destroy(geom))
     + call errquit(pname//'geom_destroy',0,GEOM_ERR)
c
      qmd_driver = status
c
      end
c $Id: qmd_driver.F 24348 2013-06-23 04:29:20Z d3y133 $

      program showxyz
C$Id: showxyz.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
      integer Lvalm,Lval
      integer nxyz(3)
      integer icrng, ic
c
      Lvalm = 5
c
      call defnxyz(Lvalm)
c
      do 00100 Lval = 0,Lvalm*4
        icrng = ((Lval+1)*(Lval+2))/2
        do 00200 ic = 1,icrng
          call getNxyz(lval,ic,nxyz)
          call prntnxyz(lval,ic,nxyz)
00200   continue
        write(6,*)'  '
00100 continue
      end
      subroutine prntnxyz(lval,ic,nxyz)
      implicit none
      integer lval, ic, nxyz(3)
      character*30 cxyz
      character*1 pxyz(3)
      integer i,j, icnt
c
      pxyz(1) = 'x'
      pxyz(2) = 'y'
      pxyz(3) = 'z'
      cxyz=' '
      icnt = 1
      do 00100 i=1,3
        do 00200 j=1,nxyz(i)
          cxyz(icnt:icnt) = pxyz(i)
          icnt = icnt + 1
00200   continue
00100 continue
      write(6,*)'<',lval,',',ic,'>= ',cxyz
      end

*> \brief \b DLARRD computes the eigenvalues of a symmetric tridiagonal matrix to suitable accuracy.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLARRD + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlarrd.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlarrd.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlarrd.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLARRD( RANGE, ORDER, N, VL, VU, IL, IU, GERS,
*                           RELTOL, D, E, E2, PIVMIN, NSPLIT, ISPLIT,
*                           M, W, WERR, WL, WU, IBLOCK, INDEXW,
*                           WORK, IWORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          ORDER, RANGE
*       INTEGER            IL, INFO, IU, M, N, NSPLIT
*       DOUBLE PRECISION    PIVMIN, RELTOL, VL, VU, WL, WU
*       ..
*       .. Array Arguments ..
*       INTEGER            IBLOCK( * ), INDEXW( * ),
*      $                   ISPLIT( * ), IWORK( * )
*       DOUBLE PRECISION   D( * ), E( * ), E2( * ),
*      $                   GERS( * ), W( * ), WERR( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLARRD computes the eigenvalues of a symmetric tridiagonal
*> matrix T to suitable accuracy. This is an auxiliary code to be
*> called from DSTEMR.
*> The user may ask for all eigenvalues, all eigenvalues
*> in the half-open interval (VL, VU], or the IL-th through IU-th
*> eigenvalues.
*>
*> To avoid overflow, the matrix must be scaled so that its
*> largest element is no greater than overflow**(1/2) * underflow**(1/4) in absolute value, and for greatest
*> accuracy, it should not be much smaller than that.
*>
*> See W. Kahan "Accurate Eigenvalues of a Symmetric Tridiagonal
*> Matrix", Report CS41, Computer Science Dept., Stanford
*> University, July 21, 1966.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] RANGE
*> \verbatim
*>          RANGE is CHARACTER*1
*>          = 'A': ("All")   all eigenvalues will be found.
*>          = 'V': ("Value") all eigenvalues in the half-open interval
*>                           (VL, VU] will be found.
*>          = 'I': ("Index") the IL-th through IU-th eigenvalues (of the
*>                           entire matrix) will be found.
*> \endverbatim
*>
*> \param[in] ORDER
*> \verbatim
*>          ORDER is CHARACTER*1
*>          = 'B': ("By Block") the eigenvalues will be grouped by
*>                              split-off block (see IBLOCK, ISPLIT) and
*>                              ordered from smallest to largest within
*>                              the block.
*>          = 'E': ("Entire matrix")
*>                              the eigenvalues for the entire matrix
*>                              will be ordered from smallest to
*>                              largest.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the tridiagonal matrix T.  N >= 0.
*> \endverbatim
*>
*> \param[in] VL
*> \verbatim
*>          VL is DOUBLE PRECISION
*> \endverbatim
*>
*> \param[in] VU
*> \verbatim
*>          VU is DOUBLE PRECISION
*>          If RANGE='V', the lower and upper bounds of the interval to
*>          be searched for eigenvalues.  Eigenvalues less than or equal
*>          to VL, or greater than VU, will not be returned.  VL < VU.
*>          Not referenced if RANGE = 'A' or 'I'.
*> \endverbatim
*>
*> \param[in] IL
*> \verbatim
*>          IL is INTEGER
*> \endverbatim
*>
*> \param[in] IU
*> \verbatim
*>          IU is INTEGER
*>          If RANGE='I', the indices (in ascending order) of the
*>          smallest and largest eigenvalues to be returned.
*>          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*>          Not referenced if RANGE = 'A' or 'V'.
*> \endverbatim
*>
*> \param[in] GERS
*> \verbatim
*>          GERS is DOUBLE PRECISION array, dimension (2*N)
*>          The N Gerschgorin intervals (the i-th Gerschgorin interval
*>          is (GERS(2*i-1), GERS(2*i)).
*> \endverbatim
*>
*> \param[in] RELTOL
*> \verbatim
*>          RELTOL is DOUBLE PRECISION
*>          The minimum relative width of an interval.  When an interval
*>          is narrower than RELTOL times the larger (in
*>          magnitude) endpoint, then it is considered to be
*>          sufficiently small, i.e., converged.  Note: this should
*>          always be at least radix*machine epsilon.
*> \endverbatim
*>
*> \param[in] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          The n diagonal elements of the tridiagonal matrix T.
*> \endverbatim
*>
*> \param[in] E
*> \verbatim
*>          E is DOUBLE PRECISION array, dimension (N-1)
*>          The (n-1) off-diagonal elements of the tridiagonal matrix T.
*> \endverbatim
*>
*> \param[in] E2
*> \verbatim
*>          E2 is DOUBLE PRECISION array, dimension (N-1)
*>          The (n-1) squared off-diagonal elements of the tridiagonal matrix T.
*> \endverbatim
*>
*> \param[in] PIVMIN
*> \verbatim
*>          PIVMIN is DOUBLE PRECISION
*>          The minimum pivot allowed in the Sturm sequence for T.
*> \endverbatim
*>
*> \param[in] NSPLIT
*> \verbatim
*>          NSPLIT is INTEGER
*>          The number of diagonal blocks in the matrix T.
*>          1 <= NSPLIT <= N.
*> \endverbatim
*>
*> \param[in] ISPLIT
*> \verbatim
*>          ISPLIT is INTEGER array, dimension (N)
*>          The splitting points, at which T breaks up into submatrices.
*>          The first submatrix consists of rows/columns 1 to ISPLIT(1),
*>          the second of rows/columns ISPLIT(1)+1 through ISPLIT(2),
*>          etc., and the NSPLIT-th consists of rows/columns
*>          ISPLIT(NSPLIT-1)+1 through ISPLIT(NSPLIT)=N.
*>          (Only the first NSPLIT elements will actually be used, but
*>          since the user cannot know a priori what value NSPLIT will
*>          have, N words must be reserved for ISPLIT.)
*> \endverbatim
*>
*> \param[out] M
*> \verbatim
*>          M is INTEGER
*>          The actual number of eigenvalues found. 0 <= M <= N.
*>          (See also the description of INFO=2,3.)
*> \endverbatim
*>
*> \param[out] W
*> \verbatim
*>          W is DOUBLE PRECISION array, dimension (N)
*>          On exit, the first M elements of W will contain the
*>          eigenvalue approximations. DLARRD computes an interval
*>          I_j = (a_j, b_j] that includes eigenvalue j. The eigenvalue
*>          approximation is given as the interval midpoint
*>          W(j)= ( a_j + b_j)/2. The corresponding error is bounded by
*>          WERR(j) = abs( a_j - b_j)/2
*> \endverbatim
*>
*> \param[out] WERR
*> \verbatim
*>          WERR is DOUBLE PRECISION array, dimension (N)
*>          The error bound on the corresponding eigenvalue approximation
*>          in W.
*> \endverbatim
*>
*> \param[out] WL
*> \verbatim
*>          WL is DOUBLE PRECISION
*> \endverbatim
*>
*> \param[out] WU
*> \verbatim
*>          WU is DOUBLE PRECISION
*>          The interval (WL, WU] contains all the wanted eigenvalues.
*>          If RANGE='V', then WL=VL and WU=VU.
*>          If RANGE='A', then WL and WU are the global Gerschgorin bounds
*>                        on the spectrum.
*>          If RANGE='I', then WL and WU are computed by DLAEBZ from the
*>                        index range specified.
*> \endverbatim
*>
*> \param[out] IBLOCK
*> \verbatim
*>          IBLOCK is INTEGER array, dimension (N)
*>          At each row/column j where E(j) is zero or small, the
*>          matrix T is considered to split into a block diagonal
*>          matrix.  On exit, if INFO = 0, IBLOCK(i) specifies to which
*>          block (from 1 to the number of blocks) the eigenvalue W(i)
*>          belongs.  (DLARRD may use the remaining N-M elements as
*>          workspace.)
*> \endverbatim
*>
*> \param[out] INDEXW
*> \verbatim
*>          INDEXW is INTEGER array, dimension (N)
*>          The indices of the eigenvalues within each block (submatrix);
*>          for example, INDEXW(i)= j and IBLOCK(i)=k imply that the
*>          i-th eigenvalue W(i) is the j-th eigenvalue in block k.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (4*N)
*> \endverbatim
*>
*> \param[out] IWORK
*> \verbatim
*>          IWORK is INTEGER array, dimension (3*N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          > 0:  some or all of the eigenvalues failed to converge or
*>                were not computed:
*>                =1 or 3: Bisection failed to converge for some
*>                        eigenvalues; these eigenvalues are flagged by a
*>                        negative block number.  The effect is that the
*>                        eigenvalues may not be as accurate as the
*>                        absolute and relative tolerances.  This is
*>                        generally caused by unexpectedly inaccurate
*>                        arithmetic.
*>                =2 or 3: RANGE='I' only: Not all of the eigenvalues
*>                        IL:IU were found.
*>                        Effect: M < IU+1-IL
*>                        Cause:  non-monotonic arithmetic, causing the
*>                                Sturm sequence to be non-monotonic.
*>                        Cure:   recalculate, using RANGE='A', and pick
*>                                out eigenvalues IL:IU.  In some cases,
*>                                increasing the PARAMETER "FUDGE" may
*>                                make things work.
*>                = 4:    RANGE='I', and the Gershgorin interval
*>                        initially used was too small.  No eigenvalues
*>                        were computed.
*>                        Probable cause: your machine has sloppy
*>                                        floating-point arithmetic.
*>                        Cure: Increase the PARAMETER "FUDGE",
*>                              recompile, and try again.
*> \endverbatim
*
*> \par Internal Parameters:
*  =========================
*>
*> \verbatim
*>  FUDGE   DOUBLE PRECISION, default = 2
*>          A "fudge factor" to widen the Gershgorin intervals.  Ideally,
*>          a value of 1 should work, but on machines with sloppy
*>          arithmetic, this needs to be larger.  The default for
*>          publicly released versions should be large enough to handle
*>          the worst machine around.  Note that this has no effect
*>          on accuracy of the solution.
*> \endverbatim
*>
*> \par Contributors:
*  ==================
*>
*>     W. Kahan, University of California, Berkeley, USA \n
*>     Beresford Parlett, University of California, Berkeley, USA \n
*>     Jim Demmel, University of California, Berkeley, USA \n
*>     Inderjit Dhillon, University of Texas, Austin, USA \n
*>     Osni Marques, LBNL/NERSC, USA \n
*>     Christof Voemel, University of California, Berkeley, USA \n
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE DLARRD( RANGE, ORDER, N, VL, VU, IL, IU, GERS,
     $                    RELTOL, D, E, E2, PIVMIN, NSPLIT, ISPLIT,
     $                    M, W, WERR, WL, WU, IBLOCK, INDEXW,
     $                    WORK, IWORK, INFO )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          ORDER, RANGE
      INTEGER            IL, INFO, IU, M, N, NSPLIT
      DOUBLE PRECISION    PIVMIN, RELTOL, VL, VU, WL, WU
*     ..
*     .. Array Arguments ..
      INTEGER            IBLOCK( * ), INDEXW( * ),
     $                   ISPLIT( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), E2( * ),
     $                   GERS( * ), W( * ), WERR( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO, HALF, FUDGE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0,
     $                     TWO = 2.0D0, HALF = ONE/TWO,
     $                     FUDGE = TWO )
      INTEGER   ALLRNG, VALRNG, INDRNG
      PARAMETER ( ALLRNG = 1, VALRNG = 2, INDRNG = 3 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NCNVRG, TOOFEW
      INTEGER            I, IB, IBEGIN, IDISCL, IDISCU, IE, IEND, IINFO,
     $                   IM, IN, IOFF, IOUT, IRANGE, ITMAX, ITMP1,
     $                   ITMP2, IW, IWOFF, J, JBLK, JDISC, JE, JEE, NB,
     $                   NWL, NWU
      DOUBLE PRECISION   ATOLI, EPS, GL, GU, RTOLI, TMP1, TMP2,
     $                   TNORM, UFLOW, WKILL, WLU, WUL

*     ..
*     .. Local Arrays ..
      INTEGER            IDUMMA( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, ILAENV, DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAEBZ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, INT, LOG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Decode RANGE
*
      IF( LSAME( RANGE, 'A' ) ) THEN
         IRANGE = ALLRNG
      ELSE IF( LSAME( RANGE, 'V' ) ) THEN
         IRANGE = VALRNG
      ELSE IF( LSAME( RANGE, 'I' ) ) THEN
         IRANGE = INDRNG
      ELSE
         IRANGE = 0
      END IF
*
*     Check for Errors
*
      IF( IRANGE.LE.0 ) THEN
         INFO = -1
      ELSE IF( .NOT.(LSAME(ORDER,'B').OR.LSAME(ORDER,'E')) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( IRANGE.EQ.VALRNG ) THEN
         IF( VL.GE.VU )
     $      INFO = -5
      ELSE IF( IRANGE.EQ.INDRNG .AND.
     $        ( IL.LT.1 .OR. IL.GT.MAX( 1, N ) ) ) THEN
         INFO = -6
      ELSE IF( IRANGE.EQ.INDRNG .AND.
     $        ( IU.LT.MIN( N, IL ) .OR. IU.GT.N ) ) THEN
         INFO = -7
      END IF
*
      IF( INFO.NE.0 ) THEN
         RETURN
      END IF

*     Initialize error flags
      INFO = 0
      NCNVRG = .FALSE.
      TOOFEW = .FALSE.

*     Quick return if possible
      M = 0
      IF( N.EQ.0 ) RETURN

*     Simplification:
      IF( IRANGE.EQ.INDRNG .AND. IL.EQ.1 .AND. IU.EQ.N ) IRANGE = 1

*     Get machine constants
      EPS = DLAMCH( 'P' )
      UFLOW = DLAMCH( 'U' )


*     Special Case when N=1
*     Treat case of 1x1 matrix for quick return
      IF( N.EQ.1 ) THEN
         IF( (IRANGE.EQ.ALLRNG).OR.
     $       ((IRANGE.EQ.VALRNG).AND.(D(1).GT.VL).AND.(D(1).LE.VU)).OR.
     $       ((IRANGE.EQ.INDRNG).AND.(IL.EQ.1).AND.(IU.EQ.1)) ) THEN
            M = 1
            W(1) = D(1)
*           The computation error of the eigenvalue is zero
            WERR(1) = ZERO
            IBLOCK( 1 ) = 1
            INDEXW( 1 ) = 1
         ENDIF
         RETURN
      END IF

*     NB is the minimum vector length for vector bisection, or 0
*     if only scalar is to be done.
      NB = ILAENV( 1, 'DSTEBZ', ' ', N, -1, -1, -1 )
      IF( NB.LE.1 ) NB = 0

*     Find global spectral radius
      GL = D(1)
      GU = D(1)
      DO 5 I = 1,N
         GL =  MIN( GL, GERS( 2*I - 1))
         GU = MAX( GU, GERS(2*I) )
 5    CONTINUE
*     Compute global Gerschgorin bounds and spectral diameter
      TNORM = MAX( ABS( GL ), ABS( GU ) )
      GL = GL - FUDGE*TNORM*EPS*N - FUDGE*TWO*PIVMIN
      GU = GU + FUDGE*TNORM*EPS*N + FUDGE*TWO*PIVMIN
*     [JAN/28/2009] remove the line below since SPDIAM variable not use
*     SPDIAM = GU - GL
*     Input arguments for DLAEBZ:
*     The relative tolerance.  An interval (a,b] lies within
*     "relative tolerance" if  b-a < RELTOL*max(|a|,|b|),
      RTOLI = RELTOL
*     Set the absolute tolerance for interval convergence to zero to force
*     interval convergence based on relative size of the interval.
*     This is dangerous because intervals might not converge when RELTOL is
*     small. But at least a very small number should be selected so that for
*     strongly graded matrices, the code can get relatively accurate
*     eigenvalues.
      ATOLI = FUDGE*TWO*UFLOW + FUDGE*TWO*PIVMIN

      IF( IRANGE.EQ.INDRNG ) THEN

*        RANGE='I': Compute an interval containing eigenvalues
*        IL through IU. The initial interval [GL,GU] from the global
*        Gerschgorin bounds GL and GU is refined by DLAEBZ.
         ITMAX = INT( ( LOG( TNORM+PIVMIN )-LOG( PIVMIN ) ) /
     $           LOG( TWO ) ) + 2
         WORK( N+1 ) = GL
         WORK( N+2 ) = GL
         WORK( N+3 ) = GU
         WORK( N+4 ) = GU
         WORK( N+5 ) = GL
         WORK( N+6 ) = GU
         IWORK( 1 ) = -1
         IWORK( 2 ) = -1
         IWORK( 3 ) = N + 1
         IWORK( 4 ) = N + 1
         IWORK( 5 ) = IL - 1
         IWORK( 6 ) = IU
*
         CALL DLAEBZ( 3, ITMAX, N, 2, 2, NB, ATOLI, RTOLI, PIVMIN,
     $         D, E, E2, IWORK( 5 ), WORK( N+1 ), WORK( N+5 ), IOUT,
     $                IWORK, W, IBLOCK, IINFO )
         IF( IINFO .NE. 0 ) THEN
            INFO = IINFO
            RETURN
         END IF
*        On exit, output intervals may not be ordered by ascending negcount
         IF( IWORK( 6 ).EQ.IU ) THEN
            WL = WORK( N+1 )
            WLU = WORK( N+3 )
            NWL = IWORK( 1 )
            WU = WORK( N+4 )
            WUL = WORK( N+2 )
            NWU = IWORK( 4 )
         ELSE
            WL = WORK( N+2 )
            WLU = WORK( N+4 )
            NWL = IWORK( 2 )
            WU = WORK( N+3 )
            WUL = WORK( N+1 )
            NWU = IWORK( 3 )
         END IF
*        On exit, the interval [WL, WLU] contains a value with negcount NWL,
*        and [WUL, WU] contains a value with negcount NWU.
         IF( NWL.LT.0 .OR. NWL.GE.N .OR. NWU.LT.1 .OR. NWU.GT.N ) THEN
            INFO = 4
            RETURN
         END IF

      ELSEIF( IRANGE.EQ.VALRNG ) THEN
         WL = VL
         WU = VU

      ELSEIF( IRANGE.EQ.ALLRNG ) THEN
         WL = GL
         WU = GU
      ENDIF



*     Find Eigenvalues -- Loop Over blocks and recompute NWL and NWU.
*     NWL accumulates the number of eigenvalues .le. WL,
*     NWU accumulates the number of eigenvalues .le. WU
      M = 0
      IEND = 0
      INFO = 0
      NWL = 0
      NWU = 0
*
      DO 70 JBLK = 1, NSPLIT
         IOFF = IEND
         IBEGIN = IOFF + 1
         IEND = ISPLIT( JBLK )
         IN = IEND - IOFF
*
         IF( IN.EQ.1 ) THEN
*           1x1 block
            IF( WL.GE.D( IBEGIN )-PIVMIN )
     $         NWL = NWL + 1
            IF( WU.GE.D( IBEGIN )-PIVMIN )
     $         NWU = NWU + 1
            IF( IRANGE.EQ.ALLRNG .OR.
     $           ( WL.LT.D( IBEGIN )-PIVMIN
     $             .AND. WU.GE. D( IBEGIN )-PIVMIN ) ) THEN
               M = M + 1
               W( M ) = D( IBEGIN )
               WERR(M) = ZERO
*              The gap for a single block doesn't matter for the later
*              algorithm and is assigned an arbitrary large value
               IBLOCK( M ) = JBLK
               INDEXW( M ) = 1
            END IF

*        Disabled 2x2 case because of a failure on the following matrix
*        RANGE = 'I', IL = IU = 4
*          Original Tridiagonal, d = [
*           -0.150102010615740E+00
*           -0.849897989384260E+00
*           -0.128208148052635E-15
*            0.128257718286320E-15
*          ];
*          e = [
*           -0.357171383266986E+00
*           -0.180411241501588E-15
*           -0.175152352710251E-15
*          ];
*
*         ELSE IF( IN.EQ.2 ) THEN
**           2x2 block
*            DISC = SQRT( (HALF*(D(IBEGIN)-D(IEND)))**2 + E(IBEGIN)**2 )
*            TMP1 = HALF*(D(IBEGIN)+D(IEND))
*            L1 = TMP1 - DISC
*            IF( WL.GE. L1-PIVMIN )
*     $         NWL = NWL + 1
*            IF( WU.GE. L1-PIVMIN )
*     $         NWU = NWU + 1
*            IF( IRANGE.EQ.ALLRNG .OR. ( WL.LT.L1-PIVMIN .AND. WU.GE.
*     $          L1-PIVMIN ) ) THEN
*               M = M + 1
*               W( M ) = L1
**              The uncertainty of eigenvalues of a 2x2 matrix is very small
*               WERR( M ) = EPS * ABS( W( M ) ) * TWO
*               IBLOCK( M ) = JBLK
*               INDEXW( M ) = 1
*            ENDIF
*            L2 = TMP1 + DISC
*            IF( WL.GE. L2-PIVMIN )
*     $         NWL = NWL + 1
*            IF( WU.GE. L2-PIVMIN )
*     $         NWU = NWU + 1
*            IF( IRANGE.EQ.ALLRNG .OR. ( WL.LT.L2-PIVMIN .AND. WU.GE.
*     $          L2-PIVMIN ) ) THEN
*               M = M + 1
*               W( M ) = L2
**              The uncertainty of eigenvalues of a 2x2 matrix is very small
*               WERR( M ) = EPS * ABS( W( M ) ) * TWO
*               IBLOCK( M ) = JBLK
*               INDEXW( M ) = 2
*            ENDIF
         ELSE
*           General Case - block of size IN >= 2
*           Compute local Gerschgorin interval and use it as the initial
*           interval for DLAEBZ
            GU = D( IBEGIN )
            GL = D( IBEGIN )
            TMP1 = ZERO

            DO 40 J = IBEGIN, IEND
               GL =  MIN( GL, GERS( 2*J - 1))
               GU = MAX( GU, GERS(2*J) )
   40       CONTINUE
*           [JAN/28/2009]
*           change SPDIAM by TNORM in lines 2 and 3 thereafter
*           line 1: remove computation of SPDIAM (not useful anymore)
*           SPDIAM = GU - GL
*           GL = GL - FUDGE*SPDIAM*EPS*IN - FUDGE*PIVMIN
*           GU = GU + FUDGE*SPDIAM*EPS*IN + FUDGE*PIVMIN
            GL = GL - FUDGE*TNORM*EPS*IN - FUDGE*PIVMIN
            GU = GU + FUDGE*TNORM*EPS*IN + FUDGE*PIVMIN
*
            IF( IRANGE.GT.1 ) THEN
               IF( GU.LT.WL ) THEN
*                 the local block contains none of the wanted eigenvalues
                  NWL = NWL + IN
                  NWU = NWU + IN
                  GO TO 70
               END IF
*              refine search interval if possible, only range (WL,WU] matters
               GL = MAX( GL, WL )
               GU = MIN( GU, WU )
               IF( GL.GE.GU )
     $            GO TO 70
            END IF

*           Find negcount of initial interval boundaries GL and GU
            WORK( N+1 ) = GL
            WORK( N+IN+1 ) = GU
            CALL DLAEBZ( 1, 0, IN, IN, 1, NB, ATOLI, RTOLI, PIVMIN,
     $                   D( IBEGIN ), E( IBEGIN ), E2( IBEGIN ),
     $                   IDUMMA, WORK( N+1 ), WORK( N+2*IN+1 ), IM,
     $                   IWORK, W( M+1 ), IBLOCK( M+1 ), IINFO )
            IF( IINFO .NE. 0 ) THEN
               INFO = IINFO
               RETURN
            END IF
*
            NWL = NWL + IWORK( 1 )
            NWU = NWU + IWORK( IN+1 )
            IWOFF = M - IWORK( 1 )

*           Compute Eigenvalues
            ITMAX = INT( ( LOG( GU-GL+PIVMIN )-LOG( PIVMIN ) ) /
     $              LOG( TWO ) ) + 2
            CALL DLAEBZ( 2, ITMAX, IN, IN, 1, NB, ATOLI, RTOLI, PIVMIN,
     $                   D( IBEGIN ), E( IBEGIN ), E2( IBEGIN ),
     $                   IDUMMA, WORK( N+1 ), WORK( N+2*IN+1 ), IOUT,
     $                   IWORK, W( M+1 ), IBLOCK( M+1 ), IINFO )
            IF( IINFO .NE. 0 ) THEN
               INFO = IINFO
               RETURN
            END IF
*
*           Copy eigenvalues into W and IBLOCK
*           Use -JBLK for block number for unconverged eigenvalues.
*           Loop over the number of output intervals from DLAEBZ
            DO 60 J = 1, IOUT
*              eigenvalue approximation is middle point of interval
               TMP1 = HALF*( WORK( J+N )+WORK( J+IN+N ) )
*              semi length of error interval
               TMP2 = HALF*ABS( WORK( J+N )-WORK( J+IN+N ) )
               IF( J.GT.IOUT-IINFO ) THEN
*                 Flag non-convergence.
                  NCNVRG = .TRUE.
                  IB = -JBLK
               ELSE
                  IB = JBLK
               END IF
               DO 50 JE = IWORK( J ) + 1 + IWOFF,
     $                 IWORK( J+IN ) + IWOFF
                  W( JE ) = TMP1
                  WERR( JE ) = TMP2
                  INDEXW( JE ) = JE - IWOFF
                  IBLOCK( JE ) = IB
   50          CONTINUE
   60       CONTINUE
*
            M = M + IM
         END IF
   70 CONTINUE

*     If RANGE='I', then (WL,WU) contains eigenvalues NWL+1,...,NWU
*     If NWL+1 < IL or NWU > IU, discard extra eigenvalues.
      IF( IRANGE.EQ.INDRNG ) THEN
         IDISCL = IL - 1 - NWL
         IDISCU = NWU - IU
*
         IF( IDISCL.GT.0 ) THEN
            IM = 0
            DO 80 JE = 1, M
*              Remove some of the smallest eigenvalues from the left so that
*              at the end IDISCL =0. Move all eigenvalues up to the left.
               IF( W( JE ).LE.WLU .AND. IDISCL.GT.0 ) THEN
                  IDISCL = IDISCL - 1
               ELSE
                  IM = IM + 1
                  W( IM ) = W( JE )
                  WERR( IM ) = WERR( JE )
                  INDEXW( IM ) = INDEXW( JE )
                  IBLOCK( IM ) = IBLOCK( JE )
               END IF
 80         CONTINUE
            M = IM
         END IF
         IF( IDISCU.GT.0 ) THEN
*           Remove some of the largest eigenvalues from the right so that
*           at the end IDISCU =0. Move all eigenvalues up to the left.
            IM=M+1
            DO 81 JE = M, 1, -1
               IF( W( JE ).GE.WUL .AND. IDISCU.GT.0 ) THEN
                  IDISCU = IDISCU - 1
               ELSE
                  IM = IM - 1
                  W( IM ) = W( JE )
                  WERR( IM ) = WERR( JE )
                  INDEXW( IM ) = INDEXW( JE )
                  IBLOCK( IM ) = IBLOCK( JE )
               END IF
 81         CONTINUE
            JEE = 0
            DO 82 JE = IM, M
               JEE = JEE + 1
               W( JEE ) = W( JE )
               WERR( JEE ) = WERR( JE )
               INDEXW( JEE ) = INDEXW( JE )
               IBLOCK( JEE ) = IBLOCK( JE )
 82         CONTINUE
            M = M-IM+1
         END IF

         IF( IDISCL.GT.0 .OR. IDISCU.GT.0 ) THEN
*           Code to deal with effects of bad arithmetic. (If N(w) is
*           monotone non-decreasing, this should never happen.)
*           Some low eigenvalues to be discarded are not in (WL,WLU],
*           or high eigenvalues to be discarded are not in (WUL,WU]
*           so just kill off the smallest IDISCL/largest IDISCU
*           eigenvalues, by marking the corresponding IBLOCK = 0
            IF( IDISCL.GT.0 ) THEN
               WKILL = WU
               DO 100 JDISC = 1, IDISCL
                  IW = 0
                  DO 90 JE = 1, M
                     IF( IBLOCK( JE ).NE.0 .AND.
     $                    ( W( JE ).LT.WKILL .OR. IW.EQ.0 ) ) THEN
                        IW = JE
                        WKILL = W( JE )
                     END IF
 90               CONTINUE
                  IBLOCK( IW ) = 0
 100           CONTINUE
            END IF
            IF( IDISCU.GT.0 ) THEN
               WKILL = WL
               DO 120 JDISC = 1, IDISCU
                  IW = 0
                  DO 110 JE = 1, M
                     IF( IBLOCK( JE ).NE.0 .AND.
     $                    ( W( JE ).GE.WKILL .OR. IW.EQ.0 ) ) THEN
                        IW = JE
                        WKILL = W( JE )
                     END IF
 110              CONTINUE
                  IBLOCK( IW ) = 0
 120           CONTINUE
            END IF
*           Now erase all eigenvalues with IBLOCK set to zero
            IM = 0
            DO 130 JE = 1, M
               IF( IBLOCK( JE ).NE.0 ) THEN
                  IM = IM + 1
                  W( IM ) = W( JE )
                  WERR( IM ) = WERR( JE )
                  INDEXW( IM ) = INDEXW( JE )
                  IBLOCK( IM ) = IBLOCK( JE )
               END IF
 130        CONTINUE
            M = IM
         END IF
         IF( IDISCL.LT.0 .OR. IDISCU.LT.0 ) THEN
            TOOFEW = .TRUE.
         END IF
      END IF
*
      IF(( IRANGE.EQ.ALLRNG .AND. M.NE.N ).OR.
     $   ( IRANGE.EQ.INDRNG .AND. M.NE.IU-IL+1 ) ) THEN
         TOOFEW = .TRUE.
      END IF

*     If ORDER='B', do nothing the eigenvalues are already sorted by
*        block.
*     If ORDER='E', sort the eigenvalues from smallest to largest

      IF( LSAME(ORDER,'E') .AND. NSPLIT.GT.1 ) THEN
         DO 150 JE = 1, M - 1
            IE = 0
            TMP1 = W( JE )
            DO 140 J = JE + 1, M
               IF( W( J ).LT.TMP1 ) THEN
                  IE = J
                  TMP1 = W( J )
               END IF
  140       CONTINUE
            IF( IE.NE.0 ) THEN
               TMP2 = WERR( IE )
               ITMP1 = IBLOCK( IE )
               ITMP2 = INDEXW( IE )
               W( IE ) = W( JE )
               WERR( IE ) = WERR( JE )
               IBLOCK( IE ) = IBLOCK( JE )
               INDEXW( IE ) = INDEXW( JE )
               W( JE ) = TMP1
               WERR( JE ) = TMP2
               IBLOCK( JE ) = ITMP1
               INDEXW( JE ) = ITMP2
            END IF
  150    CONTINUE
      END IF
*
      INFO = 0
      IF( NCNVRG )
     $   INFO = INFO + 1
      IF( TOOFEW )
     $   INFO = INFO + 2
      RETURN
*
*     End of DLARRD
*
      END
c $Id: dlarrd.f 24343 2013-06-22 05:35:15Z d3y133 $

C $Id: ecp_cart_xpd.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_cart_xpd (n,n_n,n_all,X,Y,Z,xn,yn,zn,tmp,coef,
     &    sphcart,csco,lcsco)
*                                                                      *
*   Expand cartesian function on one centre about second centre.       *
*                                                                      *
*   n (inp) - angular momentum of original cartesian                   *
*   n_n (inp) - number of components of original cartesian             *
*               = (n+1)*(n+2)/2                                        *
*   n_all (inp) - number of components of cartesians on new centre     *
*           = sum_m^n (m+1)*(m+2)/2 = (n+1)*(n+2)*(n+3)/6              *
*   X,Y,Z (inp) - relative cartesian coordinates of new centre         *
*   xn,yn,zn (scr) - work arrays to store powers of X,Y,Z              *
*   tmp (scr) - work array for spherical transformation                *
*   coef (out) - array of coefficients of the cartesians in terms of   *
*                sphericals on the new centre                          *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
#include "errquit.fh"
      integer n,n_n,n_all
      integer lcsco,sphcart
      integer a,b,c,i,j,k,ii,jj,kk,m,ind_m,ind_n,ind_s,l_comp
      integer binomial(231)
      double precision X,Y,Z,xn(0:n),yn(0:n),zn(0:n),
     &    tmp(n_n,n_n),coef(n_n,n_all)
      double precision ifac,jfac,kfac,zero
      double precision csco(lcsco)
      parameter (zero = 0.0d00)
      data binomial/1, 1,1, 1,2,1, 1,3,3,1, 1,4,6,4,1, 1,5,10,10,5,1,
     &    1,6,15,20,15,6,1, 1,7,21,35,35,21,7,1, 1,8,28,56,70,56,28,8,1,
     &    1,9,36,84,126,126,84,36,9,1, 1,10,45,120,210,252,210,120,45,
     &    10,1, 1,11,55,165,330,462,462,330,165,55,11,1, 1,12,66,220,
     &    495,792,924,792,495,220,66,12,1, 1,13,78,286,715,1287,1716,
     &    1716,1287,715,286,78,13,1, 1,14,91,364,1001,2002,3003,3432,
     &    3003,2002,1001,364,91,14,1, 1,15,105,455,1365,3003,5005,6435,
     &    6435,5005,3003,1365,455,105,15,1, 1,16,120,560,1820,4368,8008,
     &    11440,12870,11440,8008,4368,1820,560,120,16,1, 1,17,136,680,
     &    2380,6188,12376,19448,24310,24310,19448,12376,6188,2380,680,
     &    136,17,1, 1,18,153,816,3060,8568,18564,31824,43758,48620,
     &    43758,31824,18564,8568,3060,816,153,18,1, 1,19,171,969,3876, 
     &    11628,27132,50388,75582,92378,92378,75582,50388,27132,11628,
     &    3876,969,171,19,1, 1,20,190,1140,4845,15504,38760,77520,
     &    125970,167960,184756,167960,125970,77520,38760,15504,4845,
     &    1140,190,20,1/
*
      if (n .gt. 20) call errquit (
     &    'Cannot handle angular momentum > 20 in ecp_cart_xpd',99,
     &       UNKNOWN_ERR)
*
*   Set up monomials in X, Y and Z
*
      xn(0) = 1.0d00
      yn(0) = 1.0d00
      zn(0) = 1.0d00
      do i = 1,n
        xn(i) = xn(i-1)*X
        yn(i) = yn(i-1)*Y
        zn(i) = zn(i-1)*Z
      end do
*
*     Loop over angular momenta on new centre
*
      ind_s = 1
      do m = 0,n
*
*   Loop over components of original cartesian
*
        ind_n = 0
        do i = n,0,-1
          ii = i*(i+1)/2+1
          do j = n-i,0,-1
            jj = j*(j+1)/2+1
            k = n-i-j
            kk = k*(k+1)/2+1
            ind_n = ind_n+1
*
*     Loop over components on new centre
*
            ind_m = 0
            do a = m,0,-1
              if (i .ge. a) then
                ifac = binomial(ii+a)
                ifac = ifac*xn(i-a)
                do b = m-a,0,-1
                  c = m-a-b
                  ind_m = ind_m+1
                  tmp(ind_n,ind_m) = 0d0
                  if (j .ge. b.and.k.ge.c) then
                    jfac = binomial(jj+b)
                    jfac = jfac*yn(j-b)
                    kfac = binomial(kk+c)
                    kfac = kfac*zn(k-c)
                    tmp(ind_n,ind_m) = ifac*jfac*kfac
                  end if
                end do
              else
                 call dcopy(m-a+1,zero,0,tmp(ind_n,ind_m+1),n_n)
                ind_m = ind_m+m-a+1
              end if
            end do
*
          end do
        end do
*
*   Now transform to spherical harmonics. This must be done with the 
*   inverse transformation because what we are really doing is inserting 
*   the resolution of the identity into the cartesian expansion; the 
*   cartesians on the new centre get the "real" transformation, the 
*   coefficients get the transpose of the inverse transformation.
*
        if (sphcart .eq. 0) then
          call dcopy (n_n*ind_m,tmp,1,coef(1,ind_s),1)
        else
          call ecp_cstrans (m,ind_m,ind_n,m,mod(m,2),l_comp,tmp,n_n,
     &        coef(1,ind_s),n_n,csco,lcsco,csco,1,1,-1)
        end if
        ind_s = ind_s+ind_m
*
      end do
*
      return
      end

*> \brief \b SGEBRD
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SGEBRD + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sgebrd.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sgebrd.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sgebrd.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGEBRD( M, N, A, LDA, D, E, TAUQ, TAUP, WORK, LWORK,
*                          INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, LDA, LWORK, M, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * ), D( * ), E( * ), TAUP( * ),
*      $                   TAUQ( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGEBRD reduces a general real M-by-N matrix A to upper or lower
*> bidiagonal form B by an orthogonal transformation: Q**T * A * P = B.
*>
*> If m >= n, B is upper bidiagonal; if m < n, B is lower bidiagonal.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows in the matrix A.  M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns in the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the M-by-N general matrix to be reduced.
*>          On exit,
*>          if m >= n, the diagonal and the first superdiagonal are
*>            overwritten with the upper bidiagonal matrix B; the
*>            elements below the diagonal, with the array TAUQ, represent
*>            the orthogonal matrix Q as a product of elementary
*>            reflectors, and the elements above the first superdiagonal,
*>            with the array TAUP, represent the orthogonal matrix P as
*>            a product of elementary reflectors;
*>          if m < n, the diagonal and the first subdiagonal are
*>            overwritten with the lower bidiagonal matrix B; the
*>            elements below the first subdiagonal, with the array TAUQ,
*>            represent the orthogonal matrix Q as a product of
*>            elementary reflectors, and the elements above the diagonal,
*>            with the array TAUP, represent the orthogonal matrix P as
*>            a product of elementary reflectors.
*>          See Further Details.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] D
*> \verbatim
*>          D is REAL array, dimension (min(M,N))
*>          The diagonal elements of the bidiagonal matrix B:
*>          D(i) = A(i,i).
*> \endverbatim
*>
*> \param[out] E
*> \verbatim
*>          E is REAL array, dimension (min(M,N)-1)
*>          The off-diagonal elements of the bidiagonal matrix B:
*>          if m >= n, E(i) = A(i,i+1) for i = 1,2,...,n-1;
*>          if m < n, E(i) = A(i+1,i) for i = 1,2,...,m-1.
*> \endverbatim
*>
*> \param[out] TAUQ
*> \verbatim
*>          TAUQ is REAL array dimension (min(M,N))
*>          The scalar factors of the elementary reflectors which
*>          represent the orthogonal matrix Q. See Further Details.
*> \endverbatim
*>
*> \param[out] TAUP
*> \verbatim
*>          TAUP is REAL array, dimension (min(M,N))
*>          The scalar factors of the elementary reflectors which
*>          represent the orthogonal matrix P. See Further Details.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The length of the array WORK.  LWORK >= max(1,M,N).
*>          For optimum performance LWORK >= (M+N)*NB, where NB
*>          is the optimal blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit 
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realGEcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The matrices Q and P are represented as products of elementary
*>  reflectors:
*>
*>  If m >= n,
*>
*>     Q = H(1) H(2) . . . H(n)  and  P = G(1) G(2) . . . G(n-1)
*>
*>  Each H(i) and G(i) has the form:
*>
*>     H(i) = I - tauq * v * v**T  and G(i) = I - taup * u * u**T
*>
*>  where tauq and taup are real scalars, and v and u are real vectors;
*>  v(1:i-1) = 0, v(i) = 1, and v(i+1:m) is stored on exit in A(i+1:m,i);
*>  u(1:i) = 0, u(i+1) = 1, and u(i+2:n) is stored on exit in A(i,i+2:n);
*>  tauq is stored in TAUQ(i) and taup in TAUP(i).
*>
*>  If m < n,
*>
*>     Q = H(1) H(2) . . . H(m-1)  and  P = G(1) G(2) . . . G(m)
*>
*>  Each H(i) and G(i) has the form:
*>
*>     H(i) = I - tauq * v * v**T  and G(i) = I - taup * u * u**T
*>
*>  where tauq and taup are real scalars, and v and u are real vectors;
*>  v(1:i) = 0, v(i+1) = 1, and v(i+2:m) is stored on exit in A(i+2:m,i);
*>  u(1:i-1) = 0, u(i) = 1, and u(i+1:n) is stored on exit in A(i,i+1:n);
*>  tauq is stored in TAUQ(i) and taup in TAUP(i).
*>
*>  The contents of A on exit are illustrated by the following examples:
*>
*>  m = 6 and n = 5 (m > n):          m = 5 and n = 6 (m < n):
*>
*>    (  d   e   u1  u1  u1 )           (  d   u1  u1  u1  u1  u1 )
*>    (  v1  d   e   u2  u2 )           (  e   d   u2  u2  u2  u2 )
*>    (  v1  v2  d   e   u3 )           (  v1  e   d   u3  u3  u3 )
*>    (  v1  v2  v3  d   e  )           (  v1  v2  e   d   u4  u4 )
*>    (  v1  v2  v3  v4  d  )           (  v1  v2  v3  e   d   u5 )
*>    (  v1  v2  v3  v4  v5 )
*>
*>  where d and e denote diagonal and off-diagonal elements of B, vi
*>  denotes an element of the vector defining H(i), and ui an element of
*>  the vector defining G(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE SGEBRD( M, N, A, LDA, D, E, TAUQ, TAUP, WORK, LWORK,
     $                   INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), D( * ), E( * ), TAUP( * ),
     $                   TAUQ( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IINFO, J, LDWRKX, LDWRKY, LWKOPT, MINMN, NB,
     $                   NBMIN, NX
      REAL               WS
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEBD2, SGEMM, SLABRD, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, REAL
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      NB = MAX( 1, ILAENV( 1, 'SGEBRD', ' ', M, N, -1, -1 ) )
      LWKOPT = ( M+N )*NB
      WORK( 1 ) = REAL( LWKOPT )
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, M, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -10
      END IF
      IF( INFO.LT.0 ) THEN
         CALL XERBLA( 'SGEBRD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      MINMN = MIN( M, N )
      IF( MINMN.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      WS = MAX( M, N )
      LDWRKX = M
      LDWRKY = N
*
      IF( NB.GT.1 .AND. NB.LT.MINMN ) THEN
*
*        Set the crossover point NX.
*
         NX = MAX( NB, ILAENV( 3, 'SGEBRD', ' ', M, N, -1, -1 ) )
*
*        Determine when to switch from blocked to unblocked code.
*
         IF( NX.LT.MINMN ) THEN
            WS = ( M+N )*NB
            IF( LWORK.LT.WS ) THEN
*
*              Not enough work space for the optimal NB, consider using
*              a smaller block size.
*
               NBMIN = ILAENV( 2, 'SGEBRD', ' ', M, N, -1, -1 )
               IF( LWORK.GE.( M+N )*NBMIN ) THEN
                  NB = LWORK / ( M+N )
               ELSE
                  NB = 1
                  NX = MINMN
               END IF
            END IF
         END IF
      ELSE
         NX = MINMN
      END IF
*
      DO 30 I = 1, MINMN - NX, NB
*
*        Reduce rows and columns i:i+nb-1 to bidiagonal form and return
*        the matrices X and Y which are needed to update the unreduced
*        part of the matrix
*
         CALL SLABRD( M-I+1, N-I+1, NB, A( I, I ), LDA, D( I ), E( I ),
     $                TAUQ( I ), TAUP( I ), WORK, LDWRKX,
     $                WORK( LDWRKX*NB+1 ), LDWRKY )
*
*        Update the trailing submatrix A(i+nb:m,i+nb:n), using an update
*        of the form  A := A - V*Y**T - X*U**T
*
         CALL SGEMM( 'No transpose', 'Transpose', M-I-NB+1, N-I-NB+1,
     $               NB, -ONE, A( I+NB, I ), LDA,
     $               WORK( LDWRKX*NB+NB+1 ), LDWRKY, ONE,
     $               A( I+NB, I+NB ), LDA )
         CALL SGEMM( 'No transpose', 'No transpose', M-I-NB+1, N-I-NB+1,
     $               NB, -ONE, WORK( NB+1 ), LDWRKX, A( I, I+NB ), LDA,
     $               ONE, A( I+NB, I+NB ), LDA )
*
*        Copy diagonal and off-diagonal elements of B back into A
*
         IF( M.GE.N ) THEN
            DO 10 J = I, I + NB - 1
               A( J, J ) = D( J )
               A( J, J+1 ) = E( J )
   10       CONTINUE
         ELSE
            DO 20 J = I, I + NB - 1
               A( J, J ) = D( J )
               A( J+1, J ) = E( J )
   20       CONTINUE
         END IF
   30 CONTINUE
*
*     Use unblocked code to reduce the remainder of the matrix
*
      CALL SGEBD2( M-I+1, N-I+1, A( I, I ), LDA, D( I ), E( I ),
     $             TAUQ( I ), TAUP( I ), WORK, IINFO )
      WORK( 1 ) = WS
      RETURN
*
*     End of SGEBRD
*
      END
c $Id: sgebrd.f 24343 2013-06-22 05:35:15Z d3y133 $

      logical function pre_pdbseq(iunit,filnam,lfnout,
     + model,namslv,lseq,cseq,mseq,nseq,latm,catm,xatm,matm,natm,
     + lssb,mssb,nssb,llnk,clnk,mlnk,nlnk,altloc,chain)
c
c $Id: pre_pdbseq.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     function to read sequence from a pdb formatted file
c
c     in  : iunit       = pdb logical file number
c           filnam      = pdb file name
c           lfnout      = output file logical file number
c           model       = model number
c           mseq        = dimension of the sequence list
c           nseq        = expected length of the sequence list
c
c     out : lseq(1,*)   = segment numbers
c           cseq(1,*)   = segment names
c           nseq        = actual length of the sequence list
c           latm(1,*)   = index to sequence list
c           catm(1,*)   = atom name
c           xatm(1:3,*) = atomic coordinates
c
      implicit none
c
#include "util.fh"
c
      integer iunit,lfnout,model,mseq,nseq,matm,natm,mssb,nssb,mlnk,nlnk
      integer lseq(6,mseq),latm(5,matm),lssb(2,mssb),llnk(4,mlnk)
      character*6 catm(3,matm)
      character*5 cseq(2,mseq)
      character*4 clnk(2,mlnk)
      character*3 namslv
      real*8 xatm(3,matm)
      character*255 filnam
      character*1 altloc,chain,pchain
c
      character*80 card
      integer length,mdl,iseq,isgm,i,j,k,nchain,iatm,ioff
c
      integer pre_atnum
      external pre_atnum
c
      mdl=0
      iseq=0
      isgm=0
      nchain=0
      iatm=0
      nssb=0
      nlnk=0
      ioff=0
      pchain=' '
c
      length=index(filnam,' ')-1
c
      if(util_print('where',print_debug)) then
      write(lfnout,2006) filnam(1:length)
 2006 format(/,'pre_pdbseq ',a)
      endif
c
c     initialize the lists
c
c     lseq(1,i) : actual residue number on pdb file
c
      do 10 i=1,mseq
      cseq(1,i)='     '
      cseq(2,i)='     '
      lseq(1,i)=0
      lseq(2,i)=0
      lseq(3,i)=0
   10 continue
      do 11 i=1,matm
      latm(1,i)=0
      latm(2,i)=0
      latm(3,i)=0
      latm(4,i)=0
      latm(5,i)=0
      catm(1,i)='      '
      catm(2,i)='      '
      catm(3,i)='      '
   11 continue
c
c     open the pdb file
c
      open(iunit,file=filnam(1:length),form='formatted',
     + status='old',err=9999)
      rewind(iunit)
c
    1 continue
c
      read(iunit,1000,end=999,err=9999) card
 1000 format(a)
c
c     MODEL
c
      if(model.ne.mdl) then
      if(card(1:6).eq.'MODEL ') then
      read(card(7:14),1002) mdl
 1002 format(i8)
      if(model.eq.mdl.and.util_print('where',print_debug)) then
      write(lfnout,2005) model
 2005 format(10x,'MODEL ',i8)
      endif
      goto 1
      endif
      endif
c
c     END and ENDMDL
c
      if(card(1:6).eq.'ENDMDL') then
      if(model.eq.mdl) goto 9
      goto 1
      endif
      if(card(1:6).eq.'END   ') goto 9
c
c     HEADER
c
      if(card(1:6).eq.'HEADER') then
      if(util_print('where',print_debug)) write(lfnout,2001) card
 2001 format(10x,a)
      goto 1
      endif
c
c     SSBOND
c
      if(card(1:6).eq.'SSBOND') then
      nssb=nssb+1
      if(nssb.gt.mssb) call md_abort('increase mssb',9999)
      read(card,2007) lssb(1,nssb),lssb(2,nssb)
 2007 format(17x,i4,10x,i4)
      goto 1
      endif
c
c     LINK
c
      if(card(1:6).eq.'LINK  ') then
      if(nlnk.gt.mlnk) call md_abort('pdbseq: increase mlnk',9999)
      if(card(22:22).ne.' '.and.
     + card(22:22).ne.chain.and.chain.ne.'*') goto 1
      if(card(52:52).ne.' '.and.
     + card(52:52).ne.chain.and.chain.ne.'*') goto 1
      nlnk=nlnk+1
      read(card,2011)
     + clnk(1,nlnk),llnk(1,nlnk),clnk(2,nlnk),llnk(2,nlnk)
 2011 format(12x,a4,6x,i4,16x,a4,6x,i4)
      llnk(3,nlnk)=0
      llnk(4,nlnk)=0
      goto 1
      endif
c
c     ATOM
c
      if(card(1:4).eq.'ATOM') then
      if(card(17:17).ne.' '.and.
     + card(17:17).ne.altloc.and.altloc.ne.'*') goto 1
      if(card(22:22).ne.' '.and.
     + card(22:22).ne.chain.and.chain.ne.'*') goto 1
      if(mdl.eq.model) then
      read(card(23:26),1003) i
 1003 format(i4)
      if(chain.eq.'*') then
      if(i.lt.isgm) then
      if(card(22:22).ne.pchain) ioff=(isgm/100+1)*100-i
      i=i+ioff
      endif
      endif
      pchain=card(22:22)
      if(card(18:20).eq.namslv) goto 99
      if(i.ne.isgm) then
      isgm=i
      iseq=iseq+1
      nchain=nchain+1
      if(iseq.ge.mseq) then
      write(lfnout,2009)
 2009 format('PDB ERROR : insufficient memory available')
      goto 9999
      endif
      lseq(1,iseq)=isgm
      cseq(1,iseq)(1:3)=card(18:20)
      lseq(3,iseq)=0
c      if(nchain.eq.1) cseq(1,iseq)(4:5)='_N'
      endif
      iatm=iatm+1
      if(lseq(3,iseq).eq.0) lseq(3,iseq)=iatm
      lseq(3,iseq+1)=iatm+1
      latm(1,iatm)=iseq
      latm(2,iatm)=pre_atnum(card(77:78))
      if(latm(2,iatm).eq.0) latm(2,iatm)=pre_atnum(card(13:14))
      catm(1,iatm)(1:4)=card(13:16)
      read(card(31:54),'(3f8.3)') (xatm(j,iatm),j=1,3)
      endif
      goto 1
      endif
c
c     HETATM
c
      if(card(1:6).eq.'HETATM') then
      if(card(17:17).ne.' '.and.
     + card(17:17).ne.altloc.and.altloc.ne.'*') goto 1
      if(card(22:22).ne.' '.and.
     + card(22:22).ne.chain.and.chain.ne.'*') goto 1
      if(mdl.eq.model) then
      read(card(23:26),1004) i
 1004 format(i4)
      if(chain.eq.'*') then
      if(i.lt.isgm) then
      if(card(22:22).ne.pchain) ioff=(isgm/100+1)*100-i
      i=i+ioff
      endif
      endif
      pchain=card(22:22)
      if(card(18:20).eq.namslv) goto 99
      if(i.ne.isgm) then
      isgm=i
      iseq=iseq+1
      nchain=nchain+1
      if(iseq.ge.mseq) then
      write(lfnout,2010)
 2010 format('PDB ERROR : insufficient memory available')
      goto 9999
      endif
      lseq(1,iseq)=isgm
      cseq(1,iseq)(1:3)=card(18:20)
      lseq(3,iseq)=0
c      if(nchain.eq.1) cseq(1,iseq)(4:5)='_N'
      endif
      iatm=iatm+1
      if(lseq(3,iseq).eq.0) lseq(3,iseq)=iatm
      lseq(3,iseq+1)=iatm+1
      latm(1,iatm)=iseq
      latm(2,iatm)=pre_atnum(card(77:78))
      if(latm(2,iatm).eq.0) latm(2,iatm)=pre_atnum(card(13:14))
      catm(1,iatm)(1:4)=card(13:16)
      read(card(31:54),'(3f8.3)') (xatm(j,iatm),j=1,3)
      endif
      goto 1
      endif
c
c     TER
c
c      if(card(1:6).eq.'TER   ') then
c      if(iseq.gt.0) then
c      if(nchain.eq.1) then
c      cseq(1,iseq)(4:5)='_M'
c      else
c      cseq(1,iseq)(4:5)='_C'
c      endif
c      endif
c      nchain=0
c      endif
c
      goto 1
c
  999 continue
c
      if(util_print('where',print_high)) then
      write(lfnout,2004)
 2004 format('PDB EOF encountered')
      endif
c
    9 continue
c
   99 continue
c
      close(iunit)
c
c     take white space out of segment names
c     -------------------------------------
c
      do 12 i=1,iseq
      k=0
      do 13 j=1,5
      if(cseq(1,i)(j:j).ne.' ') then
      k=k+1
      cseq(1,i)(k:k)=cseq(1,i)(j:j)
      endif
   13 continue
      k=k+1
      do 14 j=k,5
      cseq(1,i)(j:j)=' '
   14 continue
   12 continue
c
      if(iseq.ne.nseq) then
      if(util_print('where',print_debug)) then
      write(lfnout,2008) iseq,nseq
 2008 format(10x,'number of segments read',i8,' while expecting ',i8)
      endif
      nseq=iseq
      endif
c
      if(util_print('where',print_debug)) then
      write(lfnout,2002) nseq,filnam(1:length)
 2002 format(i20,' segments',//,
     + 'PDB close ',a)
      endif
c
c     since mseq>nseq lseq(3,nseq+1) can hold natm+1
c
      lseq(3,nseq+2)=natm+1
c
      do 23 i=1,natm
      xatm(1,i)=1.0d-01*xatm(1,i)
      xatm(2,i)=1.0d-01*xatm(2,i)
      xatm(3,i)=1.0d-01*xatm(3,i)
   23 continue
c
      pre_pdbseq=.true.
      return
c
 9999 continue
c
      if(util_print('where',print_none)) then
      write(lfnout,2003) filnam(1:length)
 2003 format('PDB error ',a)
      endif
c
      pre_pdbseq=.false.
      return
      end

      subroutine rism_input(rtdb)
c
      implicit none
#include "errquit.fh"
c
#include "stdio.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      character*32 tag
      character*72 keyword
      character*32 pname
      character*255 token
      character*32 mtoken(10)
      integer  itoken(10)
      double precision  eatoms
      double precision bqzone
      logical bq_dynamical
      integer linkatm,bq_exclude
      logical status
      integer ip,np
      logical ltoken
      logical ignore
      double precision f
c
      pname = "rism_input: "
c
#ifdef RISM_DEBUG      
      write(luout,*) "in ",pname
#endif      
c
      call inp_set_field(0)
c
c     start parsing input
c     ------------------
      if (.not.inp_a(token))
     + call errquit(pname//': no input available',0, INPUT_ERR)
      if (.not.inp_compare(.false.,token,'rism'))
     + call errquit(pname//': no input available',0, INPUT_ERR)
      goto 2
    1 continue
      if (.not.inp_read()) call errquit(pname//': premature EOF',0,
     &       INPUT_ERR)
    2 continue
      if(.not.inp_a(token)) goto 1
c
c     permittivity
c     -----------
      keyword="permittivity"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_f(f))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_dbl,1,f)) 
     >      goto 999
        goto 2
      endif
c
c     tau
c     tau separation between short and long range functions in 1/Angstroms
c     -----------
      keyword="tau"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_f(f))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_dbl,1,f)) 
     >      goto 999
        goto 2
      endif
c
c     Temperature
c     -----------
      keyword="temp"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_f(f))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_dbl,1,f)) 
     >      goto 999
        goto 2
      endif
c
c     tolerance
c     -----------
      keyword="tol"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_f(f))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_dbl,1,f)) 
     >      goto 999
        goto 2
      endif
c     
c
c     lambda
c     -----------
      keyword="lambda"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_f(f))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_dbl,1,f)) 
     >      goto 999
        goto 2
      endif
c
c     diis
c     -----------
      keyword="diis"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_i(itoken(1)))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_int,
     +      1,itoken(1))) 
     >      goto 999
        goto 2
      endif
c     
c     solute
c     -----------
      keyword="solute"
      if (inp_compare(.false.,keyword, token)) then
        call rism_solute_input(rtdb)
c        if (.not.inp_a(token))
c     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
c        tag = "rism:"//keyword(1:inp_strlen(keyword))
c        if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),
c     +      1,token)) 
c     >      goto 999
        goto 2
      endif
c
c     vdw
c     -----------
      keyword="vdw"
      if (inp_compare(.false.,keyword, token)) then
32       continue
         if (.not.inp_a(token)) goto 2
         if(inp_compare(.false.,"rule", token)) then
           if (.not.inp_a(token))
     >       call errquit(pname//'vdw rule',0,INPUT_ERR)
           tag="rism:vdw:rule"
           if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),1,token)) 
     >         goto 999
           goto 32
         else if(inp_compare(.false.,"parameters", token)) then
           if (.not.inp_a(token))
     >       call errquit(pname//'vdw parameters',0,INPUT_ERR)
           tag="rism:vdw:parameters"
           if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),1,token)) 
     >         goto 999
           goto 32
         else
            call errquit(pname//'unknown tag '//token,0,INPUT_ERR)
         end if
        goto 2
      endif
c     
cc
c     solvent
c     -----------
      keyword="solvent"
      if (inp_compare(.false.,keyword, token)) then
              call rism_solvent_input(rtdb)
c31       continue
c         if (.not.inp_a(token)) goto 2
c         if(inp_compare(.false.,"model", token)) then
c           if (.not.inp_a(token))
c     >       call errquit(pname//'solvent model',0,INPUT_ERR)
c           tag="rism:solvent:model"
c           if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),1,token)) 
c     >         goto 999
c           goto 31
c         else if(inp_compare(.false.,"rdf", token)) then
c           if (.not.inp_a(token))
c     >       call errquit(pname//'solvent rdf',0,INPUT_ERR)
c           tag="rism:solvent:rdf"
c           if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),1,token)) 
c     >         goto 999
c           goto 31
c         end if
         goto 2
      endif
c     
c
c     closure
c     -----------
      keyword="closure"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_a(token))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),
     +      1,token)) 
     >      goto 999
        goto 2
      endif
c     
c
c     number of grid points
c     -----------
      keyword="ngrid"
      if (inp_compare(.false.,keyword, token)) then
        if (.not.inp_i(itoken(1)))
     >    call errquit(pname//'failed to read '//keyword,0, INPUT_ERR)
        tag = "rism:"//keyword(1:inp_strlen(keyword))
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_int,
     +      1,itoken(1))) 
     >      goto 999
        goto 2
      endif
c     
cc     
c     print level 
c     -------------------
      if (inp_compare(.false.,'print', token)) then
         call util_print_input(rtdb, "rism")
         go to 2
      end if
c
      if (token.eq.'end') then
#ifdef RISM_DEBUG              
        write(luout,*) "out of ",pname
#endif        
        return
      endif
c
      write(luout,*)pname//' unrecognized token:',
     + token(1:inp_strlen(token))
       call errquit(pname//'failed ',0,
     >        RTDB_ERR)
      return
998   call errquit(pname//'no token found '//token,0,
     >        RTDB_ERR)
999   call errquit(pname//'failed to store '//tag,0,
     >        RTDB_ERR)

      end

      subroutine rism_solute_input(rtdb)
c
      implicit none
#include "errquit.fh"
c
#include "stdio.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      character*32 tag
      character*72 keyword
      character*32 pname
      character*255 token
      character*255 message
      character*32 mtoken(10)
      integer  itoken(10)
      logical status
      integer ip,np
      logical ltoken
      logical ignore
      double precision f
c
      pname = "rism_solute_input: "
c
#ifdef RISM_DEBUG      
      write(luout,*) "in ",pname
#endif      
c
c     read initial token
c     ------------------
      if (.not.inp_a(token)) goto 1000
#ifdef RISM_DEBUG      
      write(*,*) "found token",token
#endif      
c      
c     solute model
c     -------------
      if(inp_compare(.false.,"configuration", token)) then
        message = "processing solute configuration"
        if (.not.inp_a(token)) goto 998
        tag="rism:solute:configuration"
        if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),1,token)) 
     >      goto 999
        if (.not.inp_a(token)) goto 1000
      end if
      message = "unknown tokens"
      call rism_message(pname(1:inp_strlen(pname))//
     > ": ignoring the rest of input starting from "//
     > token)
c
c     entry point for sucsessfull return
c     -----------------------------------
1000  continue
      return
c     -----------------------------------
997   write(luout,*)pname//' unrecognized token:',
     + token(1:inp_strlen(token))
       call errquit(pname//'failed ',0,
     >        RTDB_ERR)
      return
998   call errquit(pname//message(1:inp_strlen(message)),
     >             0,0)
999   call errquit(pname//'failed to store '//tag,0,
     >        RTDB_ERR)

      end

      subroutine rism_solvent_input(rtdb)
c
      implicit none
#include "errquit.fh"
c
#include "stdio.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      character*32 tag
      character*72 keyword
      character*32 pname
      character*255 token
      character*255 message
      character*32 mtoken(10)
      integer  itoken(10)
      logical status
      integer ip,np
      logical ltoken
      logical ignore
      double precision f
c
      pname = "rism_solvent_input: "
c
#ifdef RISM_DEBUG      
      write(luout,*) "in ",pname
#endif      
c
c     read initial token
c     ------------------
      if (.not.inp_a(token)) goto 1000
#ifdef RISM_DEBUG      
      write(*,*) "found token",token
#endif      
c      
c     solvent model
c     -------------
      if(inp_compare(.false.,"model", token)) then
        message = "processing for solvent model"
        if (.not.inp_a(token)) goto 998
        tag="rism:solvent:model"
        if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),1,token)) 
     >      goto 999
        if (.not.inp_a(token)) goto 1000
      end if
c      
c     solvent permittivity
c     -------------------------------------
      if(inp_compare(.false.,"permittivity", token)) then
        message = "processing solvent permittivity"
        if (.not.inp_f(f)) goto 998
        tag="rism:solvent:permittivity"
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),
     >  mt_dbl,1,f)) 
     >  goto 999
        if (.not.inp_a(token)) goto 1000
      end if
c      
c     solvent rdf with optional kspace flag
c     -------------------------------------
      if(inp_compare(.false.,"rdf", token)) then
        message = "processing solvent rdf"
        if (.not.inp_a(token)) goto 998
        if(inp_compare(.false.,"kspace", token)) then
          tag="rism:solvent:kspace"
          if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),
     >    mt_log,1,token)) 
     >    goto 999
          if (.not.inp_a(token)) goto 998
        end if
        tag="rism:solvent:rdf"
        if (.not.rtdb_cput(rtdb,tag(1:inp_strlen(tag)),1,token)) 
     >      goto 999
        if (.not.inp_a(token)) goto 1000
      end if
      message = "unknown tokens"
      call rism_message(pname(1:inp_strlen(pname))//
     > ": ignoring the rest of input starting from "//
     > token)
c
c     entry point for sucsessfull return
c     -----------------------------------
1000  continue
      return
c     -----------------------------------
997   write(luout,*)pname//' unrecognized token:',
     + token(1:inp_strlen(token))
       call errquit(pname//'failed ',0,
     >        RTDB_ERR)
      return
998   call errquit(pname//message(1:inp_strlen(message)),
     >             0,0)
999   call errquit(pname//'failed to store '//tag,0,
     >        RTDB_ERR)

      end
c $Id: rism_input.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup selci
C> @{
C>
      subroutine selci_swrite(itape,a,n)
*
* $Id: selci_swrite.f 24780 2013-11-07 21:23:59Z d3y133 $
*
      real*8 a(n)
      parameter (lenbuf = 512)
c
      if (n.le.0) return
      left = n
      nbuf = (n-1)/lenbuf + 1
      do 10 ibuf = 1,nbuf
        m = min(lenbuf, left)
        call selci_sswrit(itape, a(1 + (ibuf-1)*lenbuf), m)
        left = left - m
10    continue
      if (left.ne.0) call errquit('swrite: left .ne. 0',left,0)
c
      end
      subroutine selci_sswrit(itape,a,n)
      real*8 a(n)
c
      write(itape) a
c
      end
C>
C> @}

c
c $Id: pspw_qmmm.F 24917 2013-11-29 22:21:46Z bylaska $
c

***********************************************************
*                                                         *
*                    PSPW-QMMM  module                    *
*                                                         *
* Top-level interface to Model_potential and Model_charge *
* modules                                                 *
*                                                         *
*          Interfaced to nwchem-PSPW code                 *
*                                                         *
*    -- developed by Eric J. Bylaska on October 18,2001   *
*                                                         *
***********************************************************
*
*
*  

*     **********************************
*     *	                               *
*     *          pspw_qmmm_init        *
*     *                                *
*     **********************************

      subroutine pspw_qmmm_init(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "util.fh"
#include "pspw_qmmm.fh"


*     **** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)
      logical value,oprint
      integer i,j,ii,jj,kk,ll,ia,ja,ni,nj,frag_size,shake_ptr,indx_ptr
      integer mm
      real*8  volume
      character*80 rtdb_name
      integer natmp,nbtmp,nabsize,nindxsize,ndsqsize
      integer nbindxsize,nKr0size
      integer naindxsize,nQr0size
      integer ncbindxsize,ncKr0size
      integer nmbindxsize,nmKr0size
      integer ndindxsize,ndKr0size
      integer nddindxsize,nddKr0size
      integer ncnindxsize0,ncnindxsize1,ncnindxsize2,ncnKr0size,n1,n2

*     **** external functions ****
      logical     control_print
      integer     ion_nion,ion_nion_qm,ion_nion_mm,control_version
      integer     ewald_nshl3d,ewald_rcell_ptr,ion_rion_ptr
      character*7 c_index_name
      real*8      lattice_unita,ion_TotalCharge,ion_TotalCharge_qm
      external    control_print
      external    ion_nion,ion_nion_qm,ion_nion_mm,control_version
      external    ewald_nshl3d,ewald_rcell_ptr,ion_rion_ptr
      external    c_index_name
      external    lattice_unita,ion_TotalCharge,ion_TotalCharge_qm

      rtdb_name = 'pspw_qmmm_auxon'
      if (.not.rtdb_get(rtdb,rtdb_name,mt_log,1,value)) value = .false.

      qmmm_found     = (ion_nion_mm().gt.0).or. value 
      auxiliary_only = (ion_nion_mm().le.0).and.value
      shake_found    = .false.
      nfrag  = 0
      nkfrag = 0
      

*     **** don't do anything if there are no MM atoms ****
      if (qmmm_found) then

*        **** set the nshl3d and rcell ****
         if (.not.auxiliary_only) then
         if (control_version().eq.3) then
            nshl3d   = ewald_nshl3d()
            rcell(1) = ewald_rcell_ptr()
            periodic = .true. 
         else
            periodic = .false.
            nshl3d = 1
            if (.not.MA_alloc_get(mt_dbl,3,'rcell',rcell(2),rcell(1))) 
     >      call errquit(
     >      'pspw_qmmm_init:failed allocating rcell from heap',0,MA_ERR)
            dbl_mb(rcell(1))   = 0.0d0
            dbl_mb(rcell(1)+1) = 0.0d0
            dbl_mb(rcell(1)+2) = 0.0d0
         end if
         end if

*        **** reading qmmm_lmbda ****
         rtdb_name = 'pspw_qmmm_lmbda'
         lmbda_flag = .false.
         qmmm_lmbda=1.0d0
         if (rtdb_get(rtdb,rtdb_name,mt_dbl,1,qmmm_lmbda)) 
     >      lmbda_flag=.true.

*        **** reading number of frags ****
         rtdb_name = 'pspw_qmmm_nfrag'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nfrag)) nfrag = 0

*        **** reading number of kinds of frags ****
         rtdb_name = 'pspw_qmmm_nkfrag'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nkfrag)) nkfrag = 0

         if (nfrag.eq.0) go to 999

         value = MA_alloc_get(mt_int,nfrag,'index_frag_start',
     >                        indx_frag_start(2),indx_frag_start(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nfrag,'size_frag',
     >                        size_frag(2),size_frag(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nfrag,'kfrag',kfrag(2),kfrag(1))

         value = value.and.
     >           MA_alloc_get(mt_log,nkfrag,'self_interaction',
     >                        self_interaction(2),self_interaction(1))
         value = value.and.
     >           MA_alloc_get(mt_log,nkfrag,'incell_frag',
     >                        incell_frag(2),incell_frag(1))
         value = value.and.
     >           MA_alloc_get(mt_dbl,nkfrag,'switch_Rin',
     >                        switch_Rin(2),switch_Rin(1))
         value = value.and.
     >           MA_alloc_get(mt_dbl,nkfrag,'switch_Rout',
     >                        switch_Rout(2),switch_Rout(1))

*        **** shake variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nshake',
     >                        nshake(2),nshake(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nab_shake_start',
     >                        nab_shake_start(2),nab_shake_start(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nindx_shake_start',
     >                        nindx_shake_start(2),nindx_shake_start(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'ndsq_shake_start',
     >                        ndsq_shake_start(2),ndsq_shake_start(1))

*        **** bond variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nbond',
     >                        nbond(2),nbond(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nindx_bond_start',
     >                        nindx_bond_start(2),nindx_bond_start(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nKr0_bond_start',
     >                        nKr0_bond_start(2),nKr0_bond_start(1))

*        **** angle variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nangle',
     >                        nangle(2),nangle(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nindx_angle_start',
     >                        nindx_angle_start(2),nindx_angle_start(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nKr0_angle_start',
     >                        nKr0_angle_start(2),nKr0_angle_start(1))

*        **** cbond variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'ncbond',
     >                        ncbond(2),ncbond(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nindx_cbond_start',
     >                        nindx_cbond_start(2),nindx_cbond_start(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nKr0_cbond_start',
     >                        nKr0_cbond_start(2),nKr0_cbond_start(1))

*        **** mbond variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nmbond',
     >                        nmbond(2),nmbond(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nindx_mbond_start',
     >                        nindx_mbond_start(2),nindx_mbond_start(1))
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'nKr0_mbond_start',
     >                        nKr0_mbond_start(2),nKr0_mbond_start(1))

*        **** dihedral spring variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'ndihedral_spring',
     >                        ndihedral_spring(2),ndihedral_spring(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'nindx_dihedral_spring_start',
     >                        nindx_dihedral_spring_start(2),
     >                        nindx_dihedral_spring_start(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'nKr0_dihedral_spring_start',
     >                      nKr0_dihedral_spring_start(2),
     >                      nKr0_dihedral_spring_start(1))

*        **** dihedral variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'ndihedral',
     >                        ndihedral(2),ndihedral(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'nindx_dihedral_start',
     >                        nindx_dihedral_start(2),
     >                        nindx_dihedral_start(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'nKr0_dihedral_start',
     >                      nKr0_dihedral_start(2),
     >                      nKr0_dihedral_start(1))

*        **** coord variables ****
         value = value.and.
     >           MA_alloc_get(mt_int,nkfrag,'ncoord',
     >                        ncoord(2),ncoord(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'nindx0_coord_start',
     >                        nindx0_coord_start(2),
     >                        nindx0_coord_start(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'nindx1_coord_start',
     >                        nindx1_coord_start(2),
     >                        nindx1_coord_start(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'nindx2_coord_start',
     >                        nindx2_coord_start(2),
     >                        nindx2_coord_start(1))
         value = value.and.
     >         MA_alloc_get(mt_int,nkfrag,'Kr0_coord_start',
     >                      nKr0_coord_start(2),
     >                      nKr0_coord_start(1))

         if (.not.value) 
     >    call errquit('cannot allocate heap memory for qmmm',0,
     >       MA_ERR)


*        **** set index_start and size_frag****
         ii = 0
         jj = 0
         nabsize   = 0
         nindxsize = 0
         ndsqsize  = 0
         nbindxsize = 0
         nKr0size   = 0
         naindxsize = 0
         nQr0size   = 0
         ncbindxsize = 0
         ncKr0size   = 0
         nmbindxsize = 0
         nmKr0size   = 0
         ndindxsize = 0
         ndKr0size   = 0
         nddindxsize = 0
         nddKr0size   = 0
         ncnindxsize0 = 0
         ncnindxsize1 = 0
         ncnindxsize2 = 0
         ncnKr0size   = 0

         do ia=1,nkfrag

            rtdb_name = 'pspw_qmmm_frag_size:'//c_index_name(ia)
            value = rtdb_get(rtdb,rtdb_name,mt_int,1,frag_size)
            if (.not. value)
     >        call errquit(
     >       'pspw_qmmm_init:failed reading frag_size',0,RTDB_ERR)

            rtdb_name = 'pspw_qmmm_frag_nindex_start:'//c_index_name(ia)
            value = rtdb_get(rtdb,rtdb_name,mt_int,1,ni)
            if (.not. value)
     >        call errquit(
     >       'pspw_qmmm_init:failed reading nindx_start',0,RTDB_ERR)
            
            do i=1,ni
               int_mb(size_frag(1)+ii+i-1) = frag_size
               int_mb(kfrag(1)+ii+i-1)     = ia
            end do

            rtdb_name = 'pspw_qmmm_frag_index_start:'//c_index_name(ia)
            value = rtdb_get(rtdb,rtdb_name,mt_int,
     >                       ni,int_mb(indx_frag_start(1)+ii))
            if (.not. value)
     >        call errquit(
     >       'pspw_qmmm_init:failed reading indx_start',0,RTDB_ERR)
            ii = ii + ni

            rtdb_name = 'pspw_qmmm_frag_self_interaction:'
     >                  //c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_log,1,
     >                       log_mb(self_interaction(1)+ia-1)))
     >          log_mb(self_interaction(1)+ia-1) = .false.

            rtdb_name = 'pspw_qmmm_frag_incell:'
     >                  //c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_log,1,
     >                       log_mb(incell_frag(1)+ia-1)))
     >          log_mb(incell_frag(1)+ia-1) = .true.

            rtdb_name = 'pspw_qmmm_frag_switch_Rin:'//c_index_name(ia)
            value = rtdb_get(rtdb,rtdb_name,mt_dbl,1,
     >                       dbl_mb(switch_Rin(1)+ia-1))
            if (.not.value) 
     >         dbl_mb(switch_Rin(1)+ia-1) =(2.0160d0/0.529177d0)

            rtdb_name = 'pspw_qmmm_frag_switch_Rout:'//c_index_name(ia)
            value = rtdb_get(rtdb,rtdb_name,mt_dbl,1,
     >                       dbl_mb(switch_Rout(1)+ia-1))
            if (.not.value) 
     >         dbl_mb(switch_Rout(1)+ia-1) =(3.1287d0/0.529177d0)


*           **** shake stuff  - get nshake  ****
            int_mb(nab_shake_start(1)+ia-1) = nabsize + 1
            rtdb_name = 'pspw_qmmm_frag_nshk:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(nshake(1)+ia-1))) 
     >         int_mb(nshake(1)+ia-1) = 0
            nabsize = nabsize + int_mb(nshake(1)+ia-1)


*           **** shake stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx_shake_start(1)+ia-1) = nindxsize + 1
            int_mb(ndsq_shake_start(1) +ia-1) = ndsqsize  + 1

            do ja=1,int_mb(nshake(1)+ia-1)
               rtdb_name = 'pspw_qmmm_frag_na:'
     >                     //c_index_name(ia)//c_index_name(ja)
               if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,natmp))
     >            natmp = 0
               nindxsize = nindxsize + natmp

               rtdb_name = 'pspw_qmmm_frag_nb:'
     >                     //c_index_name(ia)//c_index_name(ja)
               if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nbtmp))
     >            nbtmp = 0
               ndsqsize = ndsqsize + nbtmp
            end do

*           **** bond stuff  - get nbond  ****
            rtdb_name = 'pspw_qmmm_frag_nbond:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(nbond(1)+ia-1))) 
     >         int_mb(nbond(1)+ia-1) = 0

*           **** bond stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx_bond_start(1)+ia-1) = nbindxsize + 1
            int_mb(nKr0_bond_start(1) +ia-1) = nKr0size  + 1
            nbindxsize = nbindxsize + 2*int_mb(nbond(1)+ia-1)
            nKr0size   = nKr0size   + 2*int_mb(nbond(1)+ia-1)


*           **** angle stuff  - get nangle  ****
            rtdb_name = 'pspw_qmmm_frag_nangle:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(nangle(1)+ia-1)))
     >         int_mb(nangle(1)+ia-1) = 0

*           **** angle stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx_angle_start(1)+ia-1) = naindxsize + 1
            int_mb(nKr0_angle_start(1) +ia-1) = nQr0size  + 1
            naindxsize = naindxsize + 3*int_mb(nangle(1)+ia-1)
            nQr0size   = nQr0size   + 2*int_mb(nangle(1)+ia-1)

*           **** cbond stuff  - get ncbond  ****
            rtdb_name = 'pspw_qmmm_frag_ncbond:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(ncbond(1)+ia-1))) 
     >         int_mb(ncbond(1)+ia-1) = 0

*           **** cbond stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx_cbond_start(1)+ia-1) = ncbindxsize + 1
            int_mb(nKr0_cbond_start(1) +ia-1) = ncKr0size  + 1
            ncbindxsize = ncbindxsize + 4*int_mb(ncbond(1)+ia-1)
            ncKr0size   = ncKr0size   + 3*int_mb(ncbond(1)+ia-1)

*           **** mbond stuff  - get nmbond  ****
            rtdb_name = 'pspw_qmmm_frag_nmbond:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(nmbond(1)+ia-1))) 
     >         int_mb(nmbond(1)+ia-1) = 0

*           **** mbond stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx_mbond_start(1)+ia-1) = nmbindxsize + 1
            int_mb(nKr0_mbond_start(1) +ia-1) = nmKr0size  + 1
            nmbindxsize = nmbindxsize + 3*int_mb(nmbond(1)+ia-1)
            nmKr0size   = nmKr0size   + 6*int_mb(nmbond(1)+ia-1)


*           **** dihedral_spring stuff  - get ndihedral_spring  ****
            rtdb_name = 
     >        'pspw_qmmm_frag_ndihedral_spring:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(ndihedral_spring(1)+ia-1)))
     >         int_mb(ndihedral_spring(1)+ia-1) = 0

*           **** dihedral_spring stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx_dihedral_spring_start(1)+ia-1) = ndindxsize + 1
            int_mb(nKr0_dihedral_spring_start(1) +ia-1) = ndKr0size  + 1
            ndindxsize = ndindxsize + 4*int_mb(ndihedral_spring(1)+ia-1)
            ndKr0size  = ndKr0size  + 2*int_mb(ndihedral_spring(1)+ia-1)


*           **** dihedral stuff  - get ndihedral  ****
            rtdb_name =  
     >        'pspw_qmmm_frag_ndihedral:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(ndihedral(1)+ia-1)))
     >         int_mb(ndihedral(1)+ia-1) = 0

*           **** dihedral stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx_dihedral_start(1)+ia-1) = nddindxsize + 1
            int_mb(nKr0_dihedral_start(1) +ia-1) = nddKr0size  + 1
            nddindxsize = nddindxsize + 4*int_mb(ndihedral(1)+ia-1)
            nddKr0size  = nddKr0size  + 3*int_mb(ndihedral(1)+ia-1)


*           **** coordination number stuff  - get ncoord  ****
            rtdb_name =
     >        'pspw_qmmm_frag_ncoord:'//c_index_name(ia)
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,
     >                        int_mb(ncoord(1)+ia-1)))
     >         int_mb(ncoord(1)+ia-1) = 0

*           **** coordination number stuff  - determine nindxsize and ndsqsize  ****
            int_mb(nindx0_coord_start(1)+ia-1) = ncnindxsize0 + 1
            int_mb(nindx1_coord_start(1)+ia-1) = ncnindxsize1 + 1
            int_mb(nindx2_coord_start(1)+ia-1) = ncnindxsize2 + 1
            int_mb(nKr0_coord_start(1) +ia-1)  = ncnKr0size  + 1
            do i=1,int_mb(ncoord(1)+ia-1)
               rtdb_name = 'pspw_qmmm_frag_coord_indxsize1:'
     >                     //c_index_name(ia)//c_index_name(i)
               if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,n1)) n1 =0
               rtdb_name = 'pspw_qmmm_frag_coord_indxsize2:'
     >                     //c_index_name(ia)//c_index_name(i)
               if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,n2)) n2 =0
               ncnindxsize0 = ncnindxsize0 + 1
               ncnindxsize1 = ncnindxsize1 + n1
               ncnindxsize2 = ncnindxsize2 + n2
            end do
            ncnKr0size  = ncnKr0size  + 6*int_mb(ncoord(1)+ia-1)

         end do

*        *** more shake ****
         shake_found = (nabsize.gt.0)
         if (shake_found) then

            value = MA_alloc_get(mt_int,nabsize,'na',na(2),na(1))
            value = value.and.
     >              MA_alloc_get(mt_int,nabsize,'nb',nb(2),nb(1))
            value = value.and.
     >              MA_alloc_get(mt_int,nindxsize,'indx_shake',
     >                        indx_shake(2),indx_shake(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,ndsqsize,'dsq_shake',
     >                        dsq_shake(2),dsq_shake(1))
            if (.not.value) call errquit(
     >       'cannot allocate heap memory for qmmm shake',0,MA_ERR)

            nabsize   = 0
            nindxsize = 0
            ndsqsize  = 0
            do ia=1,nkfrag
               do ja=1,int_mb(nshake(1)+ia-1)
                  rtdb_name = 'pspw_qmmm_frag_na:'
     >                        //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,natmp))
     >               natmp = 0
                  int_mb(na(1)+nabsize) = natmp
                  rtdb_name = 'pspw_qmmm_frag_nb:'
     >                        //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nbtmp))
     >               nbtmp = 0
                  int_mb(nb(1)+nabsize) = nbtmp
                  nabsize = nabsize + 1

                  rtdb_name = 'pspw_qmmm_frag_indx_shake:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,natmp,
     >                int_mb(indx_shake(1)+nindxsize)))
     >               int_mb(indx_shake(1)+nindxsize) = 0
                  nindxsize = nindxsize + natmp

                  rtdb_name = 'pspw_qmmm_frag_dsq_shake:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,nbtmp,
     >                dbl_mb(dsq_shake(1)+ndsqsize)))
     >               dbl_mb(dsq_shake(1)+ndsqsize) = 0.0d0
                  ndsqsize = ndsqsize + nbtmp

               end do
            end do
            call pspw_qmmm_ion_add_constraint()
         end if

*        *** more bond ****
         bond_found = (nbindxsize.gt.0)
         if (bond_found) then
            value = MA_alloc_get(mt_int,nbindxsize,'indx_bond',
     >                        indx_bond(2),indx_bond(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nKr0size,'Kr0_bond',
     >                        Kr0_bond(2),Kr0_bond(1))
            if (.not.value) call errquit(
     >       'cannot allocate heap memory for qmmm bond',0,MA_ERR)

            nbindxsize = 0
            nKr0size   = 0
            do ia=1,nkfrag
               do ja=1,int_mb(nbond(1)+ia-1)

                  rtdb_name = 'pspw_qmmm_frag_indx_bond:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,2,
     >                int_mb(indx_bond(1)+nbindxsize)))
     >               int_mb(indx_bond(1)+nbindxsize) = 0
                  nbindxsize = nbindxsize + 2

                  rtdb_name = 'pspw_qmmm_frag_Kr0_bond:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,2,
     >                dbl_mb(Kr0_bond(1)+nKr0size)))
     >               dbl_mb(Kr0_bond(1)+nKr0size) = 0.0d0
                  nKr0size = nKr0size + 2

               end do
            end do

         end if



*        *** more angle ****
         angle_found = (naindxsize.gt.0)
         if (angle_found) then
            value = MA_alloc_get(mt_int,naindxsize,'indx_angle',
     >                        indx_angle(2),indx_angle(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nQr0size,'Kr0_angle',
     >                        Kr0_angle(2),Kr0_angle(1))
            if (.not.value) call errquit(
     >       'cannot allocate heap memory for qmmm angle',0,MA_ERR)

            naindxsize = 0
            nQr0size   = 0
            do ia=1,nkfrag
               do ja=1,int_mb(nangle(1)+ia-1)

                  rtdb_name = 'pspw_qmmm_frag_indx_angle:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,3,
     >                int_mb(indx_angle(1)+naindxsize)))
     >               int_mb(indx_angle(1)+naindxsize) = 0
                  naindxsize = naindxsize + 3

                  rtdb_name = 'pspw_qmmm_frag_Kr0_angle:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,2,
     >                dbl_mb(Kr0_angle(1)+nQr0size)))
     >               dbl_mb(Kr0_angle(1)+nQr0size) = 0.0d0
                  nQr0size = nQr0size + 2

               end do
            end do

         end if

*        *** more cbond ****
         cbond_found = (ncbindxsize.gt.0)
         if (cbond_found) then
            value = MA_alloc_get(mt_int,ncbindxsize,'indx_cbond',
     >                        indx_cbond(2),indx_cbond(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,ncKr0size,'Kr0_cbond',
     >                        Kr0_cbond(2),Kr0_cbond(1))
            if (.not.value) call errquit(
     >       'cannot allocate heap memory for qmmm cbond',0,MA_ERR)

            ncbindxsize = 0
            ncKr0size   = 0
            do ia=1,nkfrag
               do ja=1,int_mb(ncbond(1)+ia-1)

                  rtdb_name = 'pspw_qmmm_frag_indx_cbond:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,4,
     >                int_mb(indx_cbond(1)+ncbindxsize)))
     >               int_mb(indx_cbond(1)+ncbindxsize) = 0
                  ncbindxsize = ncbindxsize + 4

                  rtdb_name = 'pspw_qmmm_frag_Kr0_cbond:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,3,
     >                dbl_mb(Kr0_cbond(1)+ncKr0size)))
     >               dbl_mb(Kr0_cbond(1)+ncKr0size) = 0.0d0
                  ncKr0size = ncKr0size + 3

               end do
            end do

         end if

*        *** more mbond ****
         mbond_found = (nmbindxsize.gt.0)
         if (mbond_found) then
            value = MA_alloc_get(mt_int,nmbindxsize,'indx_mbond',
     >                        indx_mbond(2),indx_mbond(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nmKr0size,'Kr0_mbond',
     >                        Kr0_mbond(2),Kr0_mbond(1))
            if (.not.value) call errquit(
     >       'cannot allocate heap memory for qmmm mbond',0,MA_ERR)

            nmbindxsize = 0
            nmKr0size   = 0
            do ia=1,nkfrag
               do ja=1,int_mb(nmbond(1)+ia-1)

                  rtdb_name = 'pspw_qmmm_frag_indx_mbond:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,3,
     >                int_mb(indx_mbond(1)+nmbindxsize)))
     >               int_mb(indx_mbond(1)+nmbindxsize) = 0
                  nmbindxsize = nmbindxsize + 3

                  rtdb_name = 'pspw_qmmm_frag_Kr0_mbond:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,6,
     >                dbl_mb(Kr0_mbond(1)+nmKr0size)))
     >               dbl_mb(Kr0_mbond(1)+nmKr0size) = 0.0d0
                  nmKr0size = nmKr0size + 6

               end do
            end do

         end if

*        *** more dihedral_spring ****
         dihedral_spring_found = (ndindxsize.gt.0)
         if (dihedral_spring_found) then
            value = MA_alloc_get(mt_int,ndindxsize,
     >              'indx_dihedral_spring',
     >               indx_dihedral_spring(2),
     >               indx_dihedral_spring(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,ndKr0size,
     >                           'Kr0_dihedral_spring',
     >                            Kr0_dihedral_spring(2),
     >                            Kr0_dihedral_spring(1))
            if (.not.value) call errquit(
     >       'cannot allocate heap memory for qmmm dihedral_spring',
     >       0,MA_ERR)

            ndindxsize = 0
            ndKr0size  = 0
            do ia=1,nkfrag
               do ja=1,int_mb(ndihedral_spring(1)+ia-1)

                  rtdb_name = 'pspw_qmmm_frag_indx_dihedral_spring:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,4,
     >               int_mb(indx_dihedral_spring(1)+ndindxsize)))
     >               int_mb(indx_dihedral_spring(1)+ndindxsize) = 0
                  ndindxsize = ndindxsize + 4

                  rtdb_name = 'pspw_qmmm_frag_Kr0_dihedral_spring:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,2,
     >               dbl_mb(Kr0_dihedral_spring(1)+ndKr0size))) 
     >               dbl_mb(Kr0_dihedral_spring(1)+ndKr0size) = 0.0d0
                  ndKr0size = ndKr0size + 2

               end do
            end do
         end if

*        *** more dihedral ****
         dihedral_found = (nddindxsize.gt.0)
         if (dihedral_found) then
            value = MA_alloc_get(mt_int,nddindxsize,
     >              'indx_dihedral',
     >               indx_dihedral(2),
     >               indx_dihedral(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nddKr0size,
     >                           'Kr0_dihedral',
     >                            Kr0_dihedral(2),
     >                            Kr0_dihedral(1))
            if (.not.value) call errquit( 
     >       'cannot allocate heap memory for qmmm dihedral',
     >       0,MA_ERR)

            nddindxsize = 0
            nddKr0size  = 0
            do ia=1,nkfrag
               do ja=1,int_mb(ndihedral(1)+ia-1)

                  rtdb_name = 'pspw_qmmm_frag_indx_dihedral:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,4,
     >               int_mb(indx_dihedral(1)+nddindxsize)))
     >               int_mb(indx_dihedral(1)+nddindxsize) = 0
                  nddindxsize = nddindxsize + 4

                  rtdb_name = 'pspw_qmmm_frag_Kr0_dihedral:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,3,
     >               dbl_mb(Kr0_dihedral(1)+nddKr0size)))      
     >               dbl_mb(Kr0_dihedral(1)+nddKr0size) = 0.0d0
                  nddKr0size = nddKr0size + 3

               end do
            end do
         end if



*        *** more coordination number ****
         coord_found = (ncnindxsize1.gt.0)
         if (coord_found) then
            value = MA_alloc_get(mt_int,ncnindxsize0,
     >              'nsize1_coord',
     >               nsize1_coord(2),
     >               nsize1_coord(1))
            value = value.and.MA_alloc_get(mt_int,ncnindxsize0,
     >              'nsize2_coord',
     >               nsize2_coord(2),
     >               nsize2_coord(1))
            value = value.and.MA_alloc_get(mt_int,ncnindxsize1,
     >              'indx1_coord',
     >               indx1_coord(2),
     >               indx1_coord(1))
            value = value.and.MA_alloc_get(mt_int,ncnindxsize2,
     >              'indx2_coord',
     >               indx2_coord(2),
     >               indx2_coord(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,ncnKr0size,
     >                           'Kr0_coord',
     >                            Kr0_coord(2),
     >                            Kr0_coord(1))

            if (.not.value) call errquit(
     >       'cannot allocate heap memory for qmmm coord',
     >       0,MA_ERR)

            ncnindxsize0 = 0
            ncnindxsize1 = 0
            ncnindxsize2 = 0
            ncnKr0size  = 0
            do ia=1,nkfrag
               do ja=1,int_mb(ncoord(1)+ia-1)
                  rtdb_name = 'pspw_qmmm_frag_coord_indxsize1:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,n1)) n1=0
                  rtdb_name = 'pspw_qmmm_frag_coord_indxsize2:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,n2)) n2=0
                  int_mb(nsize1_coord(1)+ncnindxsize0) = n1
                  int_mb(nsize2_coord(1)+ncnindxsize0) = n2
                  ncnindxsize0 = ncnindxsize0 + 1

                  rtdb_name = 'pspw_qmmm_frag_coord_indx1:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,n1,
     >               int_mb(indx1_coord(1)+ncnindxsize1)))
     >               int_mb(indx1_coord(1)+ncnindxsize1) = 0

                  rtdb_name = 'pspw_qmmm_frag_coord_indx2:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_int,n2,
     >               int_mb(indx2_coord(1)+ncnindxsize2)))
     >               int_mb(indx2_coord(1)+ncnindxsize2) = 0
                  ncnindxsize1 = ncnindxsize1 + n1
                  ncnindxsize2 = ncnindxsize2 + n2

                  rtdb_name = 'pspw_qmmm_frag_coord_Kr0:'
     >                       //c_index_name(ia)//c_index_name(ja)
                  if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,6,
     >               dbl_mb(Kr0_coord(1)+ncnKr0size)))
     >               dbl_mb(Kr0_coord(1)+ncnKr0size) = 0.0d0
                  ncnKr0size = ncnKr0size + 6
               end do
            end do
         end if


*       ***** initialize Model, LJ, Pol, VIB, and CAV ****
        if (.not.auxiliary_only) then
           !call pspw_LJ_init(rtdb)
           call pspw_Pair_init(rtdb)
        end if

*       ***** make sure mm fragments are in cell ****
        if (periodic) then
           rtdb_name = 'nwpw:qmmm_fragcell'
           if (.not.rtdb_get(rtdb,rtdb_name,mt_log,1,value)) 
     >        value = .true.
           if (value) then
              call Parallel_taskid(taskid)
             oprint=((taskid.eq.MASTER).and.control_print(print_medium))
              if (oprint) then
                 write(luout,*) 
     >           "Making sure that fragments are connnected"
                 write(luout,*) " - to turn this option off: ",
     >                      "set nwpw:qmmm_fragcell .false."
              end if
              call pspw_qmmm_fragcell(dbl_mb(ion_rion_ptr()))
           end if
           call pspw_qmmm_incell1(dbl_mb(ion_rion_ptr()))
        end if


*       ***** write out header info ****
        call Parallel_taskid(taskid)
        oprint= ((taskid.eq.MASTER).and.control_print(print_medium))
        if (oprint) then
           write(luout,*)
           write(luout,'(1x,A)') "QM/MM Potential Parameters:"
           write(luout,'(2x,"fragments start (index_start) =",10I5)')
     >         (int_mb(indx_frag_start(1)+mm-1),mm=1,nfrag)
           write(luout,'(2x,"fragments kind                =",10I5)')
     >         (int_mb(kfrag(1)+mm-1),mm=1,nfrag)

           if (lmbda_flag) 
     >        write(luout,'(2x,A,I2)') 
     >        "qmmm_lambda coupling parameter  = ",qmmm_lmbda
           write(luout,*) 
           do ia=1,nkfrag
             write(luout,'(2x,A,I5)') "fragment: ",ia
             write(luout,'(2x,A,I4)') "  - fragment size = ",
     >                         int_mb(size_frag(1)+ia-1)
             if (log_mb(self_interaction(1)+ia-1)) then
                write(luout,*) "  - ionic fragment"
             else
                write(luout,*) "  - covalent fragment"
             end if
             if (log_mb(incell_frag(1)+ia-1)) then
                write(luout,*) "  - incell fragment"
             else
                write(luout,*) "  - not incell fragment"
             end if
             write(luout,*) "  - Switching Parameters = ",
     >                  dbl_mb(switch_Rin(1)+ia-1),
     >                  dbl_mb(switch_Rout(1)+ia-1)

             nj = int_mb(nshake(1)+ia-1)
             i  = int_mb(nab_shake_start(1)+ia-1)
             ii = int_mb(nindx_shake_start(1)+ia-1)
             jj = int_mb(ndsq_shake_start(1)+ia-1)
             if (nj.gt.0) then
             do ja=1,nj
                natmp = int_mb(na(1)+i-1+ja-1)
                nbtmp = int_mb(nb(1)+i-1+ja-1)
                indx_ptr  = indx_shake(1)+ii-1
                shake_ptr = dsq_shake(1) +jj-1
                if (natmp.eq.nbtmp) then
                   write(luout,'(A,5(I4,F8.3))')   
     >                "   - shake = ",
     >                (int_mb(indx_ptr+j-1),
     >                 dsqrt(dbl_mb(shake_ptr+j-1)),
     >                 j=1,nbtmp)
             else
                   write(luout,'(A,5(I4,F8.3))')   
     >                "   - shake = ",
     >                (int_mb(indx_ptr+j-1),
     >                 dsqrt(dbl_mb(shake_ptr+j-1)),
     >                 j=1,nbtmp),
     >                int_mb(indx_ptr+natmp-1)
             end if
               ii = ii + natmp
               jj = jj + nbtmp
             end do
             end if

             ii = int_mb(nindx_bond_start(1)+ia-1)
             jj = int_mb(nKr0_bond_start(1) +ia-1)
             do ja=1,int_mb(nbond(1)+ia-1)
                indx_ptr  = indx_bond(1)+ii-1
                shake_ptr = Kr0_bond(1) +jj-1

             write(luout,'(A,2I4,4x,A,F11.6,4x,A,F11.6)') 
     >       "   - Bond Spring Parameters =  ",
     >                  (int_mb(indx_ptr+j-1),j=1,2),
     >                  'K=',
     >                  dbl_mb(shake_ptr),
     >                  're=',
     >                  dbl_mb(shake_ptr+1)
               ii = ii + 2
               jj = jj + 2
             end do

             ii = int_mb(nindx_angle_start(1)+ia-1)
             jj = int_mb(nKr0_angle_start(1) +ia-1)
             do ja=1,int_mb(nangle(1)+ia-1)
                indx_ptr  = indx_angle(1)+ii-1
                shake_ptr = Kr0_angle(1) +jj-1

             write(luout,'(A,3I4,4x,A,F11.6,4x,A,F11.6)') 
     >       "   - Angle Spring Parameters = ",
     >                  (int_mb(indx_ptr+j-1),j=1,3),
     >                  'Ktheta=',
     >                  dbl_mb(shake_ptr),
     >                  'thetae=',
     >                  dbl_mb(shake_ptr+1)
               ii = ii + 3
               jj = jj + 2
             end do

             ii = int_mb(nindx_cbond_start(1)+ia-1)
             jj = int_mb(nKr0_cbond_start(1) +ia-1)
             do ja=1,int_mb(ncbond(1)+ia-1)
                indx_ptr  = indx_cbond(1)+ii-1
                shake_ptr = Kr0_cbond(1) +jj-1

             write(luout,'(A,A,2I4,4x,A,F11.6, 
     >             /35x, A,2I4,4x,A,F11.6,4x,A,F11.6)') 
     >       "   - Cross Bond Spring Parameters: ",
     >                  'indexes1=',
     >                  (int_mb(indx_ptr+j-1),j=1,2),
     >                  'r1e=',
     >                  dbl_mb(shake_ptr),
     >                  'indexes2=',
     >                  (int_mb(indx_ptr+j-1),j=3,4),
     >                  'r2e=',
     >                  dbl_mb(shake_ptr+1),
     >                  'K12=',
     >                  dbl_mb(shake_ptr+2)
               ii = ii + 4
               jj = jj + 3
             end do

             ii = int_mb(nindx_mbond_start(1)+ia-1)
             jj = int_mb(nKr0_mbond_start(1) +ia-1)
             do ja=1,int_mb(nmbond(1)+ia-1)
                indx_ptr  = indx_mbond(1)+ii-1
                shake_ptr = Kr0_mbond(1) +jj-1

                kk = int_mb(indx_ptr+2)

                if (kk.eq.1) then
                        write(luout,'(3x,A49,E14.6,A5,E14.6,/5x,A,2I4)')
     >              '- Potential=4*e*((s/rij)**12-(s/rij)**6),      e:',
     >                    dbl_mb(shake_ptr),
     >                    ' s:',
     >                    dbl_mb(shake_ptr+1),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.2) then
                        write(luout,'(3x,A49,E14.6,A5,E14.6,A5,E14.6,
     >                                /5x,A,2I4)')
     >              '- Potential=A*exp(-rij/rho) - C/rij**6,        A:',
     >                    dbl_mb(shake_ptr),
     >                    ' rho:',
     >                    dbl_mb(shake_ptr+1),
     >                    ' C:',
     >                    dbl_mb(shake_ptr+2),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.3) then
                write(luout,'(3x,A49,E14.6,A5,E14.6,A5,E14.6,A5,E14.6,
     >                        /5x,A,2I4)')
     >              '- Potential=A*exp(-rij/rho)-C/rij**6-D/rij**8, A:',
     >                    dbl_mb(shake_ptr),
     >                    ' rho:',
     >                    dbl_mb(shake_ptr+1),
     >                    ' C:',
     >                    dbl_mb(shake_ptr+2),
     >                    ' D:',
     >                    dbl_mb(shake_ptr+3),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.4) then
                        write(luout,'(3x,A49,E14.6,A5,E14.6,A5,E14.6,
     >                                /5x,A,2I4)')
     >              '- Potential=A*(rij-B)**C,                      A:',
     >                    dbl_mb(shake_ptr),
     >                    ' B:',
     >                    dbl_mb(shake_ptr+1),
     >                    ' C:',
     >                    dbl_mb(shake_ptr+2),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.5) then
                        write(luout,'(3x,A49,E14.6,A5,E14.6,/5x,A,2I4)')
     >              '- Potential=A*exp(-rij/rho),                   A:',
     >                    dbl_mb(shake_ptr),
     >                    ' rho:',
     >                    dbl_mb(shake_ptr+1),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.6) then
c             write(luout,'(A,A,2I4,3(4x,A,F11.6))') 
c     >       "   - Morse Parameters: ",
c     >                  "indexes=",
c     >                  (int_mb(indx_ptr+j-1),j=1,2),
c     >                  "De=", dbl_mb(shake_ptr),
c     >                  "rho=",dbl_mb(shake_ptr+1),
c     >                  "re=", dbl_mb(shake_ptr+2)
                       write(luout,'(3x,A49,E14.6,A5,E14.6,A5,E14.6,
     >                              /5x,A,2I4)')
     >              '- Potential=De*(1-exp(-a*(rij-re)) )**2,      De:',
     >                    dbl_mb(shake_ptr),
     >                    ' a:',
     >                    dbl_mb(shake_ptr+1),
     >                    ' re:',
     >                    dbl_mb(shake_ptr+2),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.7) then
                write(luout,'(3x,A,A,A,
     >                        /48x,A5,E14.6,A5,E14.6,A5,E14.6,A5,E14.6,
     >                        /48x,A5,E14.6,A5,E14.6,/5x,A,2I4)')
     >                    '- Potential=A*exp(-rij/rho)',
     >                    '-fdamp(6,Cd;rij)*C/rij**6',
     >                    '-fdamp(8,Dd;rij)*D/rij**8,',
     >                    ' A:',
     >                    dbl_mb(shake_ptr),
     >                    ' rho:',
     >                    dbl_mb(shake_ptr+1),
     >                    ' C:',
     >                    dbl_mb(shake_ptr+2),
     >                    ' D:',
     >                    dbl_mb(shake_ptr+3),
     >                    ' Cd:',
     >                    dbl_mb(shake_ptr+4),
     >                    ' Dd:',
     >                    dbl_mb(shake_ptr+5),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.8) then
                      write(luout,'(3x,A49,E14.6,A5,E14.6,/5x,A,2I4)')
     >              '- Potential=A*exp(-(rij/rho)**2),              A:',
     >                    dbl_mb(shake_ptr),
     >                    ' rho:',
     >                    dbl_mb(shake_ptr+1) ,
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                else if (kk.eq.9) then
                        write(luout,'(3x,A49,E14.6,A5,E14.6,A5,E14.6,
     >                                /5x,A,2I4)')
     >              '- Potential=A*exp(-(rij/B)**C),                A:',
     >                    dbl_mb(shake_ptr),
     >                    ' B:',
     >                    dbl_mb(shake_ptr+1),
     >                    ' C:',
     >                    dbl_mb(shake_ptr+2),
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,2)
                end if

               ii = ii + 3
               jj = jj + 6
             end do

             ii = int_mb(nindx_dihedral_spring_start(1)+ia-1)
             jj = int_mb(nKr0_dihedral_spring_start(1) +ia-1)
             do ja=1,int_mb(ndihedral_spring(1)+ia-1)
                indx_ptr  = indx_dihedral_spring(1)+ii-1
                shake_ptr = Kr0_dihedral_spring(1) +jj-1

             write(luout,'(A,A,4I4,2(4x,A,F11.6))')
     >       "   - Dihedral Spring Parameters: ",
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,4),
     >                  "Kphi=", dbl_mb(shake_ptr),
     >                  "phie=",dbl_mb(shake_ptr+1)
               ii = ii + 4
               jj = jj + 2
             end do

             ii = int_mb(nindx_dihedral_start(1)+ia-1)
             jj = int_mb(nKr0_dihedral_start(1) +ia-1)
             do ja=1,int_mb(ndihedral(1)+ia-1)
                indx_ptr  = indx_dihedral(1)+ii-1
                shake_ptr = Kr0_dihedral(1) +jj-1

             write(luout,'(A,A,4I4,3(4x,A,F11.6))')
     >       "   - Dihedral Parameters: ",
     >                  "indexes=",
     >                  (int_mb(indx_ptr+j-1),j=1,4),
     >                  "Vphi=", dbl_mb(shake_ptr),
     >                  "nphi=",dbl_mb(shake_ptr+1),
     >                  "phie=", dbl_mb(shake_ptr+2)
               ii = ii + 4
               jj = jj + 3
             end do

             ll = int_mb(nindx0_coord_start(1)+ia-1)
             ii = int_mb(nindx1_coord_start(1)+ia-1)
             jj = int_mb(nindx2_coord_start(1)+ia-1)
             kk = int_mb(nKr0_coord_start(1)  +ia-1)
             do ja=1,int_mb(ncoord(1)+ia-1)
                i  = indx1_coord(1)+ii-1
                j  = indx2_coord(1)+jj-1
                ni = int_mb(nsize1_coord(1)+ll-1)
                nj = int_mb(nsize2_coord(1)+ll-1)
                shake_ptr = Kr0_coord(1)+kk-1

                if (dbl_mb(shake_ptr+5).gt.0) then
                write(luout,'(A,/6x,A,F11.6,4x,A,F11.6,
     >                      /6x,A,F11.6,4x,A,F11.6)')
     >       "   - Coordination Number Parameters (Sprik): ",
     >                  "n=    ",dbl_mb(shake_ptr),
     >                  "r0=   ",dbl_mb(shake_ptr+2),
     >                  "K=    ",dbl_mb(shake_ptr+3),
     >                  "cn0=  ",dbl_mb(shake_ptr+4)
               else
                write(luout,'(A,/6x,A,F11.6,4x,A,F11.6,4x,A,F11.6,
     >                      /6x,A,F11.6,4x,A,F11.6)')
     >       "   - Coordination Number Parameters (LJ): ",
     >                  "n=    ",dbl_mb(shake_ptr),
     >                  "m=    ",dbl_mb(shake_ptr+1),
     >                  "r0=   ",dbl_mb(shake_ptr+2),
     >                  "K=    ",dbl_mb(shake_ptr+3),
     >                  "cn0=  ",dbl_mb(shake_ptr+4)
               end if
               write(luout,'(6x,"Index1 =",10I5)')
     >         (int_mb(i+mm-1),mm=1,ni)
               write(luout,'(6x,"Index2 =",10I5)')
     >         (int_mb(j+mm-1),mm=1,nj)

               ll = ll + 1
               ii = ii + ni
               jj = jj + nj 
               kk = kk + 6
             end do

           end do
           write(luout,'(/1x,A,F8.3)') "MM total charge",
     >          ion_TotalCharge()- ion_TotalCharge_qm()
        end if

 999    continue
        call pspw_2qmmm_init(rtdb)
      end if

      return
      end


*     **********************************
*     *	                               *
*     *         pspw_qmmm_end 	       *
*     *                                *
*     **********************************

      subroutine pspw_qmmm_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

      logical value
      integer  control_version
      external control_version
      logical  pspw_2qmmm_found
      external pspw_2qmmm_found

      if (qmmm_found) then
        if (nfrag.gt.0) then
        value =           MA_free_heap(indx_frag_start(2))
        value = value.and.MA_free_heap(size_frag(2))
        value = value.and.MA_free_heap(kfrag(2))
        value = value.and.MA_free_heap(self_interaction(2))
        value = value.and.MA_free_heap(incell_frag(2))
        value = value.and.MA_free_heap(switch_Rin(2))
        value = value.and.MA_free_heap(switch_Rout(2))
        value = value.and.MA_free_heap(nshake(2))
        value = value.and.MA_free_heap(nab_shake_start(2))
        value = value.and.MA_free_heap(nindx_shake_start(2))
        value = value.and.MA_free_heap(ndsq_shake_start(2))
        if (shake_found) then
          value = value.and.MA_free_heap(na(2))
          value = value.and.MA_free_heap(nb(2))
          value = value.and.MA_free_heap(indx_shake(2))
          value = value.and.MA_free_heap(dsq_shake(2))
        end if

        value = value.and.MA_free_heap(nbond(2))
        value = value.and.MA_free_heap(nindx_bond_start(2))
        value = value.and.MA_free_heap(nKr0_bond_start(2))
        if (bond_found) then
          value = value.and.MA_free_heap(indx_bond(2))
          value = value.and.MA_free_heap(Kr0_bond(2))
        end if

        value = value.and.MA_free_heap(nangle(2))
        value = value.and.MA_free_heap(nindx_angle_start(2))
        value = value.and.MA_free_heap(nKr0_angle_start(2))
        if (angle_found) then
          value = value.and.MA_free_heap(indx_angle(2))
          value = value.and.MA_free_heap(Kr0_angle(2))
        end if

        value = value.and.MA_free_heap(ncbond(2))
        value = value.and.MA_free_heap(nindx_cbond_start(2))
        value = value.and.MA_free_heap(nKr0_cbond_start(2))
        if (cbond_found) then
          value = value.and.MA_free_heap(indx_cbond(2))
          value = value.and.MA_free_heap(Kr0_cbond(2))
        end if

        value = value.and.MA_free_heap(nmbond(2))
        value = value.and.MA_free_heap(nindx_mbond_start(2))
        value = value.and.MA_free_heap(nKr0_mbond_start(2))
        if (mbond_found) then
          value = value.and.MA_free_heap(indx_mbond(2))
          value = value.and.MA_free_heap(Kr0_mbond(2))
        end if

        value = value.and.MA_free_heap(ndihedral_spring(2))
        value = value.and.MA_free_heap(nindx_dihedral_spring_start(2))
        value = value.and.MA_free_heap(nKr0_dihedral_spring_start(2))
        if (dihedral_spring_found) then
          value = value.and.MA_free_heap(indx_dihedral_spring(2))
          value = value.and.MA_free_heap(Kr0_dihedral_spring(2))
        end if

        value = value.and.MA_free_heap(ndihedral(2))
        value = value.and.MA_free_heap(nindx_dihedral_start(2))
        value = value.and.MA_free_heap(nKr0_dihedral_start(2))
        if (dihedral_found) then
          value = value.and.MA_free_heap(indx_dihedral(2))
          value = value.and.MA_free_heap(Kr0_dihedral(2))
        end if

        value = value.and.MA_free_heap(ncoord(2))
        value = value.and.MA_free_heap(nindx0_coord_start(2))
        value = value.and.MA_free_heap(nindx1_coord_start(2))
        value = value.and.MA_free_heap(nindx2_coord_start(2))
        value = value.and.MA_free_heap(nKr0_coord_start(2))
        if (coord_found) then
          value = value.and.MA_free_heap(indx1_coord(2))
          value = value.and.MA_free_heap(indx2_coord(2))
          value = value.and.MA_free_heap(Kr0_coord(2))
        end if


        if (.not.auxiliary_only) then
        if (control_version().ne.3) then
        value = value.and.MA_free_heap(rcell(2))
        end if
        end if

        if (.not.value) call errquit('cannot free heap memory',0,
     &       MA_ERR)

        end if

        if (pspw_2qmmm_found())  call pspw_2qmmm_end()
        if ((.not.auxiliary_only).and.(nfrag.gt.0)) then
            !call pspw_LJ_end()
            call pspw_Pair_end()
        end if
      end if

      return
      end

*     **********************************
*     *	                               *
*     *         pspw_qmmm_found        *
*     *                                *
*     **********************************
      logical function pspw_qmmm_found()
      implicit none

#include "pspw_qmmm.fh"

      pspw_qmmm_found = qmmm_found
      return
      end


*     **********************************
*     *                                *
*     *    pspw_qmmm_shake_found       *
*     *                                *
*     **********************************
      logical function pspw_qmmm_shake_found()
      implicit none

#include "pspw_qmmm.fh"

      pspw_qmmm_shake_found = shake_found
      return
      end

*     **********************************
*     *	                               *
*     *         pspw_qmmm_lambda       *
*     *                                *
*     **********************************
      real*8 function pspw_qmmm_lambda()
      implicit none

#include "pspw_qmmm.fh"

      pspw_qmmm_lambda = qmmm_lmbda
      return
      end

*     **********************************
*     *	                               *
*     *      pspw_qmmm_lambda_flag     *
*     *                                *
*     **********************************
      logical function pspw_qmmm_lambda_flag()
      implicit none

#include "pspw_qmmm.fh"

      pspw_qmmm_lambda_flag = lmbda_flag
      return
      end


*     **********************************
*     *	                               *
*     *         pspw_qmmm_LJ_E 	       *
*     *                                *
*     **********************************

      real*8 function pspw_qmmm_LJ_E()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

c     **** external functions ***
      integer  ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      external ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      real*8   pspw_LJ_E,pspw_Pair_E
      external pspw_LJ_E,pspw_Pair_E

      if (auxiliary_only) then
         pspw_qmmm_LJ_E = 0.0d0
      else
c         pspw_qmmm_LJ_E = pspw_LJ_E(ion_nion(),
c     >                              ion_nion_qm(),
c     >                              int_mb(ion_katm_ptr()),
c     >                              nfrag,
c     >                              int_mb(indx_frag_start(1)),
c     >                              int_mb(size_frag(1)),
c     >                              int_mb(kfrag(1)),
c     >                              log_mb(self_interaction(1)),
c     >                              qmmm_lmbda,
c     >                              nshl3d,dbl_mb(rcell(1)),
c     >                              dbl_mb(ion_rion_ptr()))
         pspw_qmmm_LJ_E = pspw_Pair_E(ion_nion(),
     >                              ion_nion_qm(),
     >                              int_mb(ion_katm_ptr()),
     >                              nfrag,
     >                              int_mb(indx_frag_start(1)),
     >                              int_mb(size_frag(1)),
     >                              int_mb(kfrag(1)),
     >                              log_mb(self_interaction(1)),
     >                              qmmm_lmbda,
     >                              nshl3d,dbl_mb(rcell(1)),
     >                              dbl_mb(ion_rion_ptr()))
      end if
      return
      end



*     **********************************
*     *                                *
*     *         pspw_qmmm_Q_E          *
*     *                                *
*     **********************************
      real*8 function pspw_qmmm_Q_E()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

      real*8 e1,e2,e3,e4

c     **** external functions ***
      integer  ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      external ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      integer  psp_zv_ptr,ion_amass_ptr,control_version
      external psp_zv_ptr,ion_amass_ptr,control_version
      real*8   ewald_e,ewald_e_qm,ewald_e_mm
      external ewald_e,ewald_e_qm,ewald_e_mm
      real*8   ion_ion_e,ion_ion_e_qm,ion_ion_e_mm
      external ion_ion_e,ion_ion_e_qm,ion_ion_e_mm
      real*8   pspw_Q_E
      external pspw_Q_E

      if (auxiliary_only) then
         pspw_qmmm_Q_E = 0.0d0
      else
         e1 = pspw_Q_E(ion_nion(),
     >                 ion_nion_qm(),
     >                 int_mb(ion_katm_ptr()),
     >                 dbl_mb(psp_zv_ptr()),
     >                 dbl_mb(ion_amass_ptr()),
     >                 nfrag,
     >                 int_mb(indx_frag_start(1)),
     >                 int_mb(size_frag(1)),
     >                 int_mb(kfrag(1)),
     >                 dbl_mb(switch_Rin(1)),
     >                 dbl_mb(switch_Rout(1)),
     >                 log_mb(self_interaction(1)),
     >                 nshl3d,dbl_mb(rcell(1)),
     >                 dbl_mb(ion_rion_ptr()))
         if (lmbda_flag.and.(dabs(qmmm_lmbda-1.0d0).gt.1.0d-6)) then
            if (control_version().eq.3) then
               e2 = ewald_e()
               e3 = ewald_e_qm()
               e4 = ewald_e_mm()
            else
               e2 = ion_ion_e()
               e3 = ion_ion_e_qm()
               e4 = ion_ion_e_mm()
            end if
c            write(*,*) "e1,e2,e3,e4=",e1,e2,e3,e4,
c     >                 (e1-e2+e3+e4),(e3+e4+e1)
            e1 = e1 + (qmmm_lmbda-1.0d0)*(e2-e3-e4)
            !e1 = (qmmm_lmbda-1.0d0)*(e2)
         end if
         pspw_qmmm_Q_E = e1
      end if
      return
      end


*     **********************************
*     *                                *
*     *         pspw_qmmm_mmq_Q_E      *
*     *                                *
*     **********************************

      real*8 function pspw_qmmm_mmq_Q_E()
      implicit none  

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"
         
c     **** external functions ***
      integer  ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      external ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      integer  mmq_zv_ptr,ion_amass_ptr
      external mmq_zv_ptr,ion_amass_ptr
      real*8   pspw_Q_E
      external pspw_Q_E

      if (auxiliary_only) then
         pspw_qmmm_mmq_Q_E = 0.0d0
      else
         pspw_qmmm_mmq_Q_E = pspw_Q_E(ion_nion(),
     >                            ion_nion_qm(),
     >                            int_mb(ion_katm_ptr()),
     >                            dbl_mb(mmq_zv_ptr()),
     >                            dbl_mb(ion_amass_ptr()),
     >                            nfrag,
     >                            int_mb(indx_frag_start(1)),
     >                            int_mb(size_frag(1)),
     >                            int_mb(kfrag(1)),
     >                            dbl_mb(switch_Rin(1)),
     >                            dbl_mb(switch_Rout(1)),
     >                            log_mb(self_interaction(1)),
     >                            nshl3d,dbl_mb(rcell(1)),
     >                            dbl_mb(ion_rion_ptr()))
      end if
      return
      end




*     **********************************
*     *                                *
*     *        pspw_qmmm_spring_E      *
*     *                                *
*     **********************************

      real*8 function pspw_qmmm_spring_E()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

c     **** local variables ****
      integer dutask,taskid,np
      integer w1,wk1,ks1,nbs,nas,ncbs,nbm,ii,jj,kk,ll,nds,ndds,ncns
      real*8  E

c     **** external functions ***
      integer  ion_rion_ptr
      external ion_rion_ptr
      real*8   pspw_qmmm_spring_bond_frag
      external pspw_qmmm_spring_bond_frag
      real*8   pspw_qmmm_spring_angle_frag
      external pspw_qmmm_spring_angle_frag
      real*8   pspw_qmmm_spring_cbond_frag
      external pspw_qmmm_spring_cbond_frag
      real*8   pspw_qmmm_morse_bond_frag
      external pspw_qmmm_morse_bond_frag
      real*8   pspw_qmmm_dihedral_spring_frag
      external pspw_qmmm_dihedral_spring_frag
      real*8   pspw_qmmm_dihedral_frag
      external pspw_qmmm_dihedral_frag
      real*8   pspw_qmmm_spring_coordnum_frag
      external pspw_qmmm_spring_coordnum_frag
      real*8   pspw_2qmmm_spring_E
      external pspw_2qmmm_spring_E
      logical  pspw_2qmmm_found
      external pspw_2qmmm_found

      call Parallel_np(np)
      call Parallel_taskid(taskid)
      dutask = 0

      E = 0.0d0
      do w1=1,nfrag
         if (dutask.eq.taskid) then
         ks1  = int_mb(indx_frag_start(1)+w1-1)
         wk1  = int_mb(kfrag(1)+w1-1)
         nbs  = int_mb(nbond(1)+wk1-1)
         nas  = int_mb(nangle(1)+wk1-1)
         ncbs = int_mb(ncbond(1)+wk1-1)
         nbm  = int_mb(nmbond(1)+wk1-1)
         nds   = int_mb(ndihedral_spring(1)+wk1-1)
         ndds  = int_mb(ndihedral(1)+wk1-1)
         ncns  = int_mb(ncoord(1)+wk1-1)
         if (nbs.gt.0) then
            jj  = int_mb(nindx_bond_start(1)+wk1-1)
            kk  = int_mb(nKr0_bond_start(1) +wk1-1)
            E = E + pspw_qmmm_spring_bond_frag(nbs,
     >                                int_mb(indx_bond(1)+jj-1),
     >                                dbl_mb(Kr0_bond(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)))
         end if
         if (nas.gt.0) then
            jj  = int_mb(nindx_angle_start(1)+wk1-1)
            kk  = int_mb(nKr0_angle_start(1) +wk1-1)
            E = E + pspw_qmmm_spring_angle_frag(nas,
     >                                int_mb(indx_angle(1)+jj-1),
     >                                dbl_mb(Kr0_angle(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)))
         end if
         if (ncbs.gt.0) then
            jj  = int_mb(nindx_cbond_start(1)+wk1-1)
            kk  = int_mb(nKr0_cbond_start(1) +wk1-1)
            E = E + pspw_qmmm_spring_cbond_frag(ncbs,
     >                                int_mb(indx_cbond(1)+jj-1),
     >                                dbl_mb(Kr0_cbond(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)))
         end if
         if (nbm.gt.0) then
            jj  = int_mb(nindx_mbond_start(1)+wk1-1)
            kk  = int_mb(nKr0_mbond_start(1) +wk1-1)
            E = E + pspw_qmmm_morse_bond_frag(nbm,
     >                                int_mb(indx_mbond(1)+jj-1),
     >                                dbl_mb(Kr0_mbond(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)))
         end if

         if (nds.gt.0) then
            jj  = int_mb(nindx_dihedral_spring_start(1)+wk1-1)
            kk  = int_mb(nKr0_dihedral_spring_start(1) +wk1-1)
            E = E + pspw_qmmm_dihedral_spring_frag(nbm,
     >                        int_mb(indx_dihedral_spring(1)+jj-1),
     >                        dbl_mb(Kr0_dihedral_spring(1) +kk-1),
     >                        dbl_mb(ion_rion_ptr()+3*(ks1-1)))
         end if
         if (ndds.gt.0) then
            jj  = int_mb(nindx_dihedral_start(1)+wk1-1)
            kk  = int_mb(nKr0_dihedral_start(1) +wk1-1)
            E = E + pspw_qmmm_dihedral_frag(nbm,
     >                        int_mb(indx_dihedral(1)+jj-1),
     >                        dbl_mb(Kr0_dihedral(1) +kk-1),
     >                        dbl_mb(ion_rion_ptr()+3*(ks1-1)))
         end if
         if (ncns.gt.0) then
            ii  = int_mb(nindx0_coord_start(1)+wk1-1)
            jj  = int_mb(nindx1_coord_start(1)+wk1-1)
            kk  = int_mb(nindx2_coord_start(1)+wk1-1)
            ll  = int_mb(nKr0_coord_start(1)  +wk1-1)
            E = E + pspw_qmmm_spring_coordnum_frag(ncns,
     >                        int_mb(nsize1_coord(1)+ii-1),
     >                        int_mb(indx1_coord(1) +jj-1),
     >                        int_mb(nsize2_coord(1)+ii-1),
     >                        int_mb(indx2_coord(1) +kk-1),
     >                        dbl_mb(Kr0_coord(1) +ll-1),
     >                        dbl_mb(ion_rion_ptr()+3*(ks1-1)))
         end if

         end if
         dutask = mod(dutask+1,np)
        
      end do
      if (np.gt.1) call Parallel_SumAll(E)

c     **** non-fragments ****
      if (pspw_2qmmm_found()) E = E + pspw_2qmmm_spring_E()

      pspw_qmmm_spring_E = E
      return
      end


*     **********************************
*     *                                *
*     *      pspw_qmmm_spring_fion     *
*     *                                *
*     **********************************

      subroutine pspw_qmmm_spring_fion(fion)
      implicit none
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

c     **** local variables ****
      integer dutask,taskid,np
      integer w1,wk1,ks1,nbs,nas,ncbs,nbm,ii,jj,kk,ll,nds,ndds,ncns

c     **** external functions ***
      integer  ion_rion_ptr
      external ion_rion_ptr
      logical  pspw_2qmmm_found
      external pspw_2qmmm_found

      call Parallel_np(np)
      call Parallel_taskid(taskid)
      dutask = 0

      do w1=1,nfrag
         if (dutask.eq.taskid) then
         ks1  = int_mb(indx_frag_start(1)+w1-1)
         wk1  = int_mb(kfrag(1)+w1-1)
         nbs  = int_mb(nbond(1)+wk1-1)
         nas  = int_mb(nangle(1)+wk1-1)
         ncbs = int_mb(ncbond(1)+wk1-1)
         nbm  = int_mb(nmbond(1)+wk1-1)
         nds  = int_mb(ndihedral_spring(1)+wk1-1)
         ndds  = int_mb(ndihedral(1)+wk1-1)
         ncns  = int_mb(ncoord(1)+wk1-1)
         if (nbs.gt.0) then
            jj  = int_mb(nindx_bond_start(1)+wk1-1)
            kk  = int_mb(nKr0_bond_start(1) +wk1-1)
            call pspw_qmmm_spring_bond_frag_fion(nbs,
     >                                int_mb(indx_bond(1)+jj-1),
     >                                dbl_mb(Kr0_bond(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)),
     >                                fion(1,ks1))
         end if
         if (nas.gt.0) then
            jj  = int_mb(nindx_angle_start(1)+wk1-1)
            kk  = int_mb(nKr0_angle_start(1) +wk1-1)
            call pspw_qmmm_spring_angle_frag_fion(nas,
     >                                int_mb(indx_angle(1)+jj-1),
     >                                dbl_mb(Kr0_angle(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)),
     >                                fion(1,ks1))
         end if
         if (ncbs.gt.0) then
            jj  = int_mb(nindx_cbond_start(1)+wk1-1)
            kk  = int_mb(nKr0_cbond_start(1) +wk1-1)
            call pspw_qmmm_spring_cbond_frag_fion(ncbs,
     >                                int_mb(indx_cbond(1)+jj-1),
     >                                dbl_mb(Kr0_cbond(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)),
     >                                fion(1,ks1))
         end if
         if (nbm.gt.0) then
            jj  = int_mb(nindx_mbond_start(1)+wk1-1)
            kk  = int_mb(nKr0_mbond_start(1) +wk1-1)
            call pspw_qmmm_morse_bond_frag_fion(nbm,
     >                                int_mb(indx_mbond(1)+jj-1),
     >                                dbl_mb(Kr0_mbond(1) +kk-1),
     >                                dbl_mb(ion_rion_ptr()+3*(ks1-1)),
     >                                fion(1,ks1))
         end if
         if (nds.gt.0) then
            jj  = int_mb(nindx_dihedral_spring_start(1)+wk1-1)
            kk  = int_mb(nKr0_dihedral_spring_start(1) +wk1-1)
            call pspw_qmmm_dihedral_spring_frag_fion(nds,
     >                        int_mb(indx_dihedral_spring(1)+jj-1),
     >                        dbl_mb(Kr0_dihedral_spring(1) +kk-1),
     >                        dbl_mb(ion_rion_ptr()+3*(ks1-1)),
     >                        fion(1,ks1))
         end if
         if (ndds.gt.0) then
            jj  = int_mb(nindx_dihedral_start(1)+wk1-1)
            kk  = int_mb(nKr0_dihedral_start(1) +wk1-1)
            call pspw_qmmm_dihedral_frag_fion(ndds,
     >                        int_mb(indx_dihedral(1)+jj-1),
     >                        dbl_mb(Kr0_dihedral(1) +kk-1),
     >                        dbl_mb(ion_rion_ptr()+3*(ks1-1)),
     >                        fion(1,ks1))
         end if
         if (ncns.gt.0) then
            ii  = int_mb(nindx0_coord_start(1)+wk1-1)
            jj  = int_mb(nindx1_coord_start(1)+wk1-1)
            kk  = int_mb(nindx2_coord_start(1)+wk1-1)
            ll  = int_mb(nKr0_coord_start(1) +wk1-1)
            call pspw_qmmm_spring_coordnum_frag_fion(ncns,
     >                        int_mb(nsize1_coord(1)+ii-1),
     >                        int_mb(indx1_coord(1) +jj-1),
     >                        int_mb(nsize2_coord(1)+ii-1),
     >                        int_mb(indx2_coord(1) +kk-1),
     >                        dbl_mb(Kr0_coord(1)   +ll-1),
     >                        dbl_mb(ion_rion_ptr()+3*(ks1-1)),
     >                        fion(1,ks1))
         end if

         end if
         dutask = mod(dutask+1,np)
      end do

c     *** non-fragments ***
      if (pspw_2qmmm_found()) call pspw_2qmmm_spring_fion(fion)
      return
      end



*     **********************************
*     *                                *
*     *         pspw_qmmm_LJ_fion      *
*     *                                *
*     **********************************

      subroutine pspw_qmmm_LJ_fion(fion)
      implicit none
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

c     **** external functions ***
      integer  ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      external ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr

      if (.not.auxiliary_only) then
c         call  pspw_LJ_fion(ion_nion(),
c     >                      ion_nion_qm(),
c     >                      int_mb(ion_katm_ptr()),
c     >                      nfrag,
c     >                      int_mb(indx_frag_start(1)),
c     >                      int_mb(size_frag(1)),
c     >                      int_mb(kfrag(1)),
c     >                      log_mb(self_interaction(1)),
c     >                      qmmm_lmbda,
c     >                      nshl3d,dbl_mb(rcell(1)),
c     >                      dbl_mb(ion_rion_ptr()),fion)
         call  pspw_Pair_fion(ion_nion(),
     >                      ion_nion_qm(),
     >                      int_mb(ion_katm_ptr()),
     >                      nfrag,
     >                      int_mb(indx_frag_start(1)),
     >                      int_mb(size_frag(1)),
     >                      int_mb(kfrag(1)),
     >                      log_mb(self_interaction(1)),
     >                      qmmm_lmbda,
     >                      nshl3d,dbl_mb(rcell(1)),
     >                      dbl_mb(ion_rion_ptr()),fion)
      end if
      return
      end



*     **********************************
*     *                                *
*     *         pspw_qmmm_Q_fion       *
*     *                                *
*     **********************************

      subroutine pspw_qmmm_Q_fion(fion)
      implicit none
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

      integer nion3,f2(2),f3(2),f4(2)

c     **** external functions ***
      integer  ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      external ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      integer  psp_zv_ptr,ion_amass_ptr,control_version
      external psp_zv_ptr,ion_amass_ptr,control_version
      real*8   pspw_Q_E
      external pspw_Q_E

      if (.not.auxiliary_only) then
         call pspw_Q_fion(ion_nion(),
     >                    ion_nion_qm(),
     >                    int_mb(ion_katm_ptr()),
     >                    dbl_mb(psp_zv_ptr()),
     >                    dbl_mb(ion_amass_ptr()),
     >                    nfrag,
     >                    int_mb(indx_frag_start(1)),
     >                    int_mb(size_frag(1)),
     >                    int_mb(kfrag(1)),
     >                    dbl_mb(switch_Rin(1)),
     >                    dbl_mb(switch_Rout(1)),
     >                    log_mb(self_interaction(1)),
     >                    nshl3d,dbl_mb(rcell(1)),
     >                    dbl_mb(ion_rion_ptr()),fion)

         if (lmbda_flag.and.(dabs(qmmm_lmbda-1.0d0).gt.1.0d-6)) then
           nion3 = 3*ion_nion()
           if (.not.MA_push_get(mt_dbl,nion3,'f2',f2(2),f2(1)))
     >     call errquit('pspw_qmmm_Q_fion:push stack memory',2,MA_ERR)
           if (.not.MA_push_get(mt_dbl,nion3,'f3',f3(2),f3(1)))
     >     call errquit('pspw_qmmm_Q_fion:push stack memory',3,MA_ERR)
           if (.not.MA_push_get(mt_dbl,nion3,'f4',f4(2),f4(1)))
     >     call errquit('pspw_qmmm_Q_fion:push stack memory',4,MA_ERR)
           call dcopy(nion3,0.0d0,0,dbl_mb(f2(1)),1)
           call dcopy(nion3,0.0d0,0,dbl_mb(f3(1)),1)
           call dcopy(nion3,0.0d0,0,dbl_mb(f4(1)),1)
           if (control_version().eq.3) then
               call ewald_f_async(dbl_mb(f2(1)))
               call ewald_f_qm_async(dbl_mb(f3(1)))
               call ewald_f_mm_async(dbl_mb(f4(1)))
           else
               call ion_ion_f_async(dbl_mb(f2(1)))
               call ion_ion_f_qm_async(dbl_mb(f3(1)))
               call ion_ion_f_mm_async(dbl_mb(f4(1)))
           end if
           call daxpy(nion3,(qmmm_lmbda-1.0d0),dbl_mb(f2(1)),1,fion,1)
           call daxpy(nion3,(1.0d0-qmmm_lmbda),dbl_mb(f3(1)),1,fion,1)
           call daxpy(nion3,(1.0d0-qmmm_lmbda),dbl_mb(f4(1)),1,fion,1)
           if (.not.MA_pop_stack(f4(2)))
     >     call errquit('pspw_qmmm_Q_fion:pop stack memory',4,MA_ERR)
           if (.not.MA_pop_stack(f3(2)))
     >     call errquit('pspw_qmmm_Q_fion:pop stack memory',3,MA_ERR)
           if (.not.MA_pop_stack(f2(2)))
     >     call errquit('pspw_qmmm_Q_fion:pop stack memory',2,MA_ERR)
         end if
      end  if
      return
      end

*     **********************************
*     *                                *
*     *         pspw_qmmm_mmq_Q_fion   *
*     *                                *
*     **********************************

      subroutine pspw_qmmm_mmq_Q_fion(fion)
      implicit none
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

c     **** external functions ***
      integer  ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      external ion_nion,ion_nion_qm,ion_katm_ptr,ion_rion_ptr
      integer  mmq_zv_ptr,ion_amass_ptr
      external mmq_zv_ptr,ion_amass_ptr
      real*8   pspw_Q_E
      external pspw_Q_E

      if (.not.auxiliary_only) then
         call pspw_Q_fion(ion_nion(),
     >                    ion_nion_qm(),
     >                    int_mb(ion_katm_ptr()),
     >                    dbl_mb(mmq_zv_ptr()),
     >                    dbl_mb(ion_amass_ptr()),
     >                    nfrag,
     >                    int_mb(indx_frag_start(1)),
     >                    int_mb(size_frag(1)),
     >                    int_mb(kfrag(1)),
     >                    dbl_mb(switch_Rin(1)),
     >                    dbl_mb(switch_Rout(1)),
     >                    log_mb(self_interaction(1)),
     >                    nshl3d,dbl_mb(rcell(1)),
     >                    dbl_mb(ion_rion_ptr()),fion)
      end  if
      return
      end




*     **********************************
*     *                                *
*     *         pspw_qmmm_fion         *
*     *                                *
*     **********************************
      subroutine pspw_qmmm_fion(fion)
      implicit none
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*      **** local variables ****
      integer ftmp(2),nion3,np

*     *** external functions ****
      integer  ion_nion
      external ion_nion
      call Parallel_np(np)

      if (np.eq.1) then
         if (.not.auxiliary_only) then
            call pspw_qmmm_LJ_fion(fion)
            call pspw_qmmm_Q_fion(fion)
         end if
         call pspw_qmmm_spring_fion(fion)
      else
         nion3 = 3*ion_nion()
         if (.not.MA_push_get(mt_dbl,nion3,'ftmp',ftmp(2),ftmp(1)))
     >  call errquit('pspw_qmmm_fion:cannot push stack memory',0,MA_ERR)

         call dcopy(nion3,0.0,0,dbl_mb(ftmp(1)),1)
         if (.not.auxiliary_only) then
            call pspw_qmmm_LJ_fion(dbl_mb(ftmp(1)))
            call pspw_qmmm_Q_fion(dbl_mb(ftmp(1)))
         end if
         call pspw_qmmm_spring_fion(dbl_mb(ftmp(1)))
         call Parallel_Vector_SumAll(nion3,dbl_mb(ftmp(1)))

         call daxpy(nion3,1.0d0,dbl_mb(ftmp(1)),1,fion,1)


         if (.not.MA_pop_stack(ftmp(2)))
     >   call errquit('pspw_qmmm_fion:cannot pop stack memory',0,MA_ERR)
      end if
      return
      end


*     **********************************
*     *                                *
*     *         pspw_qmmm_mmq_fion     *
*     *                                *
*     **********************************
      subroutine pspw_qmmm_mmq_fion(fion)
      implicit none
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*      **** local variables ****
      integer ftmp(2),nion3,np

*     *** external functions ****
      integer  ion_nion
      external ion_nion
      call Parallel_np(np)

      if (np.eq.1) then
         if (.not.auxiliary_only) then
            call pspw_qmmm_LJ_fion(fion)
            call pspw_qmmm_mmq_Q_fion(fion)
         end if
         call pspw_qmmm_spring_fion(fion)
      else
         nion3 = 3*ion_nion()
         if (.not.MA_push_get(mt_dbl,nion3,'ftmp',ftmp(2),ftmp(1)))
     >  call errquit('pspw_qmmm_fion:cannot push stack memory',0,MA_ERR)

         call dcopy(nion3,0.0,0,dbl_mb(ftmp(1)),1)
         if (.not.auxiliary_only) then
            call pspw_qmmm_LJ_fion(dbl_mb(ftmp(1)))
            call pspw_qmmm_mmq_Q_fion(dbl_mb(ftmp(1)))
         end if
         call pspw_qmmm_spring_fion(dbl_mb(ftmp(1)))
         call Parallel_Vector_SumAll(nion3,dbl_mb(ftmp(1)))

         call daxpy(nion3,1.0d0,dbl_mb(ftmp(1)),1,fion,1)

         if (.not.MA_pop_stack(ftmp(2)))
     >   call errquit('pspw_qmmm_fion:cannot pop stack memory',0,MA_ERR)
      end if
      return
      end


*     ******************************
*     *                            *
*     *       pspw_qmmm_frag_cm    *
*     *                            *
*     ******************************
*   Computes the center of mass and total mass of a fragment.
*
*    Entry - size_frag - fragment size
*            kfrag_s   - index to start of fragment
*            rion      - total atom list
*    Exit - rcm    - center of mass of fragment
*           mtotal - total mass of fragment
*
      subroutine pspw_qmmm_frag_cm(size_frag,kfrag_s,rion,rcm,mtotal)
      implicit none
      integer size_frag,kfrag_s
      real*8 rion(3,*),rcm(3),mtotal

#include "mafdecls.fh"

*     **** local variables ****
      integer k,kk,ptr
      real*8  m

*     **** external functions ****
      integer  ion_amass_ptr
      external ion_amass_ptr

      ptr = ion_amass_ptr()

      mtotal = 0.0d0
      rcm(1) = 0.0d0
      rcm(2) = 0.0d0
      rcm(3) = 0.0d0
      kk = kfrag_s
      do k=1,size_frag
         m = dbl_mb(ptr+kk-1)
         rcm(1) = rcm(1) + m*rion(1,kk)
         rcm(2) = rcm(2) + m*rion(2,kk)
         rcm(3) = rcm(3) + m*rion(3,kk)
         mtotal = mtotal + m
         kk = kk + 1
      end do
      rcm(1) = rcm(1)/mtotal
      rcm(2) = rcm(2)/mtotal
      rcm(3) = rcm(3)/mtotal

      return
      end

*     ******************************
*     *                            *
*     *       pspw_qmmm_fragcell   *
*     *                            *
*     ******************************
*
      subroutine pspw_qmmm_fragcell(r1)
      implicit none
      real*8 r1(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*     **** local variables ****
      integer w1,n1,ks1

      do w1=1,nfrag
        n1  = int_mb(size_frag(1)+w1-1)
        ks1 = int_mb(indx_frag_start(1)+w1-1)
        call lattice_fragcell(n1,r1(1,ks1))
      end do
      return
      end




*     ******************************
*     *                            *
*     *       pspw_qmmm_incell1    *
*     *                            *
*     ******************************
*   Computes the center of mass and total mass of a fragment.
*
*    Entry - size_frag - fragment size
*            kfrag_s   - index to start of fragment
*            rion      - total atom list
*    Exit - rcm    - center of mass of fragment
*           mtotal - total mass of fragment
*
      subroutine pspw_qmmm_incell1(r1)
      implicit none
      real*8 r1(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*     **** local variables ****
      integer w1,n1,ks1,ia
      real*8  rcm(3),mtotal

      do w1=1,nfrag
c        ia = int_mb(kfrag(1)+w1-1)
c        if (log_mb(incell_frag(1)+ia-1)) then
        n1  = int_mb(size_frag(1)+w1-1)
        ks1 = int_mb(indx_frag_start(1)+w1-1)
        call pspw_qmmm_frag_cm(n1,ks1,r1,rcm,mtotal)
        call lattice_incell1_frag(rcm,n1,r1(1,ks1))
c        end if
      end do
      return
      end 

*     ******************************
*     *                            *
*     *       pspw_qmmm_incell2    *
*     *                            *
*     ******************************
*   Computes the center of mass and total mass of a fragment.
*
*    Entry - size_frag - fragment size
*            kfrag_s   - index to start of fragment
*            rion      - total atom list
*    Exit - rcm    - center of mass of fragment
*           mtotal - total mass of fragment
*
      subroutine pspw_qmmm_incell2(r1,r2)
      implicit none
      real*8 r1(3,*),r2(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*     **** local variables ****
      integer w1,n1,ks1,ia
      real*8  rcm(3),mtotal

      do w1=1,nfrag
c        ia = int_mb(kfrag(1)+w1-1)
c        if (log_mb(incell_frag(1)+ia-1)) then
        n1  = int_mb(size_frag(1)+w1-1)
        ks1 = int_mb(indx_frag_start(1)+w1-1)
        call pspw_qmmm_frag_cm(n1,ks1,r1,rcm,mtotal)
        call lattice_incell2_frag(rcm,n1,r1(1,ks1),r2(1,ks1))
c        end if
      end do
      return
      end


*     ******************************
*     *                            *
*     *       pspw_qmmm_incell3    *
*     *                            *
*     ******************************
*   Computes the center of mass and total mass of a fragment.
*
*    Entry - size_frag - fragment size
*            kfrag_s   - index to start of fragment
*            rion      - total atom list
*    Exit - rcm    - center of mass of fragment
*           mtotal - total mass of fragment
*
      subroutine pspw_qmmm_incell3(r1,r2,r3)
      implicit none
      real*8 r1(3,*),r2(3,*),r3(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*     **** local variables ****
      integer w1,n1,ks1,ia
      real*8  rcm(3),mtotal


      do w1=1,nfrag
c        ia = int_mb(kfrag(1)+w1-1)
c        if (log_mb(incell_frag(1)+ia-1)) then
        n1  = int_mb(size_frag(1)+w1-1)
        ks1 = int_mb(indx_frag_start(1)+w1-1)
        call pspw_qmmm_frag_cm(n1,ks1,r1,rcm,mtotal)
        call lattice_incell3_frag(rcm,n1,r1(1,ks1),r2(1,ks1),r3(1,ks1))
c        end if
      end do

      return
      end



*     ******************************
*     *                            *
*     *       pspw_qmmm_shake      *
*     *                            *
*     ******************************
*   shakes the fragments 
*
      subroutine pspw_qmmm_shake(r2,r1)
      implicit none
      real*8 r2(3,*),r1(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*     **** local variables ****
      integer maxit
      double precision tol
      parameter (maxit=1000,tol=1.0d-4)

      integer w1,wk1,ks1
      integer nshk,ii,jj,kk

*     **** external functions ****
      integer  ion_amass_ptr
      external ion_amass_ptr
      logical  pspw_2qmmm_found
      external pspw_2qmmm_found

      do w1=1,nfrag
         wk1  = int_mb(kfrag(1)+w1-1)
         nshk = int_mb(nshake(1)+wk1-1)
         if (nshk.gt.0) then
            ks1 = int_mb(indx_frag_start(1)+w1-1)
            ii  = int_mb(nab_shake_start(1)  +wk1-1)
            jj  = int_mb(nindx_shake_start(1)+wk1-1)
            kk  = int_mb(ndsq_shake_start(1) +wk1-1)
            call pspw_qmmm_shake_frag(nshk,
     >                                int_mb(na(1)+ii-1),
     >                                int_mb(nb(1)+ii-1),
     >                                int_mb(indx_shake(1)+jj-1),
     >                                dbl_mb(dsq_shake(1) +kk-1),
     >                                tol,maxit,
     >                                dbl_mb(ion_amass_ptr()+ks1-1),
     >                                r2(1,ks1),r1(1,ks1))
     >
         end if
      end do
  
c     **** non-frags ****
      if (pspw_2qmmm_found()) call pspw_2qmmm_shake(r2,r1)

      return
      end

*     ******************************
*     *                            *
*     *   pspw_qmmm_shake_frag     *
*     *                            *
*     ******************************
*   shakes a fragment 
*
      subroutine pspw_qmmm_shake_frag(nshk,na,nb,indx,dsq,
     >                                tol,maxit,
     >                                mass,r2,r1)
      implicit none
      integer nshk, na(*),nb(*)
      integer indx(*)
      real*8  dsq(*)
      real*8  tol
      integer maxit
      real*8  mass(*)
      real*8 r2(*),r1(*)

*     **** local variables ****
      integer ii,jj,sk

      ii = 1
      jj = 1
      do sk=1,nshk
         call shake_chain3(na(sk),indx(ii),nb(sk),
     >                     tol,maxit,
     >                     dsq(jj),
     >                     mass,r2,r1)
         ii = ii + na(sk)
         jj = jj + nb(sk)
      end do
      return
      end

*     ***************************************
*     *                                     *
*     *       pspw_qmmm_ion_add_constraint  *
*     *                                     *
*     ***************************************
      subroutine pspw_qmmm_ion_add_constraint()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "pspw_qmmm.fh"

*     **** local variables ****
      integer w1,wk1,ks1,ns
      integer nshk,ii,jj,kk

      do w1=1,nfrag
         wk1  = int_mb(kfrag(1)+w1-1)
         nshk = int_mb(nshake(1)+wk1-1)
         if (nshk.gt.0) then
            ks1 = int_mb(indx_frag_start(1)+w1-1)
            ii  = int_mb(nab_shake_start(1)  +wk1-1)
            jj  = int_mb(nindx_shake_start(1)+wk1-1)
            kk  = int_mb(ndsq_shake_start(1) +wk1-1)
            do ns=1,nshk
               call ion_add_constraint(int_mb(nb(1)+ii-1+ns-1))
            end do
         end if
      end do
      return
      end

*
* $Id: paw_electron.F 25587 2014-05-11 15:51:47Z bylaska $
*


*     ***********************************
*     *                                 *
*     *         paw_electron_init       *
*     *                                 *
*     ***********************************
      subroutine paw_electron_init()
      implicit none

#include "mafdecls.fh"
#include "paw_electron.fh"
#include "errquit.fh"


*     **** paw_electron_counter common block ****
      integer counter
      common / paw_electron_counter / counter


*     **** local variables ****
      logical value
      integer n2ft3d

*     **** external functions ****
      logical  ion_chargeexist,ion_mmexist
      integer  paw_psi_ispin,paw_psi_ne,control_version
      external ion_chargeexist,ion_mmexist
      external paw_psi_ispin,paw_psi_ne,control_version

      counter = 0

      ispin = paw_psi_ispin()
      ne(1) = paw_psi_ne(1)
      ne(2) = paw_psi_ne(2)
      !field_exist = ion_chargeexist().or.ion_mmexist()

*     **** get nfft3d, and n2ft3d ****
      call Pack_npack(1,npack1)
      call Pack_npack(0,npack0)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d

*     **** allocate memory ****
      value = MA_alloc_get(mt_dcpl,npack1*(ne(1)+ne(2)),
     >                     'Hpsi_k',Hpsi_k(2),Hpsi_k(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d*(ne(1)+ne(2)),
     >                     'psi_r',psi_r(2),psi_r(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,npack0,
     >                     'vl2',vl(2),vl(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,2*n2ft3d,
     >                     'vall',vall(2),vall(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,npack0,
     >                     'vc',vc(2),vc(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d,
     >                     'vcomp',vcomp(2),vcomp(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d,
     >                     'vh',vh(2),vh(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,2*n2ft3d,
     >                     'dn_cmp_smooth',
     >                     dn_cmp_smooth(2),
     >                     dn_cmp_smooth(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,2*n2ft3d,
     >                     'xcp',xcp(2),xcp(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,2*n2ft3d,
     >                     'xce',xce(2),xce(1))
      if (.not. value) 
     >  call errquit('paw_electron_init: out of heap memory',0, MA_ERR)


      return
      end


*     ***********************************
*     *                                 *
*     *         paw_electron_finalize   *
*     *                                 *
*     ***********************************
      subroutine paw_electron_finalize()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "paw_electron.fh"


*     **** local variables ****
      logical value

*     **** free heap  memory ****
      value = MA_free_heap(Hpsi_k(2))
      value = value.and.
     >        MA_free_heap(psi_r(2))
      value = value.and.
     >        MA_free_heap(vl(2))
      value = value.and.
     >        MA_free_heap(vall(2))
      value = value.and.
     >        MA_free_heap(vc(2))
      value = value.and.
     >        MA_free_heap(vcomp(2))
      value = value.and.
     >        MA_free_heap(vh(2))
      value = value.and.
     >        MA_free_heap(dn_cmp_smooth(2))
      value = value.and.
     >        MA_free_heap(xcp(2))
      value = value.and.
     >        MA_free_heap(xce(2))
      if (.not. value) 
     >  call errquit('paw_electron_init: error freeing heap memory',0,
     &       MA_ERR)

      return
      end

*     ***********************************
*     *                                 *
*     *         paw_electron_count              *
*     *                                 *
*     ***********************************
      integer function paw_electron_count()
      implicit none

*     **** paw_electron_counter common block ****
      integer counter
      common / paw_electron_counter / counter

      paw_electron_count = counter
      return
      end


*     ***********************************
*     *                                 *
*     *         paw_electron_run                *
*     *                                 *
*     ***********************************
      subroutine paw_electron_run(psi_k,dn,dng)
      implicit none
      complex*16 psi_k(*)
      real*8     dn(*)
      complex*16 dng(*)

#include "mafdecls.fh"

      logical value

*     **** paw_electron_counter common block ****
      integer counter
      common / paw_electron_counter / counter

      counter = counter+1


*     **** set overlaps ****
      call paw_ovlp_coeff_set(psi_k)
      call paw_ovlp_weights_set()

*     **** generate comp charge potential ****
      call paw_comp_charge_update()
      call paw_pot_comp_solve()


*     **** generate realspace psi ***
      call paw_electron_gen_psi_r(psi_k)

*     **** generate densities ****
      call paw_electron_gen_densities(psi_k,dn,dng)

*     **** generate hartree, compensation, and xc potentials ****
      call paw_electron_gen_scf_potentials(dn,dng)


*     **** generate Hpsi **** 
      call paw_electron_gen_Hpsi_k(psi_k)

      return
      end

*     ***********************************
*     *                                 *
*     *         paw_electron_run_orb    *
*     *                                 *
*     ***********************************
      subroutine paw_electron_run_orb(i,psi_k)
      implicit none
      integer    i
      complex*16 psi_k(*)

      call paw_electron_gen_psi_r_orb(i,psi_k)
c      call paw_electron_gen_Hpsi_k_orb(i,psi_k)

      return
      end

*     ***********************************
*     *                                 *
*     *     paw_electron_sd_update      *
*     *                                 *
*     ***********************************
      subroutine paw_electron_sd_update(psi1,psi2,dte)
      implicit none
      complex*16 psi1(*),psi2(*)
      real*8     dte

#include "mafdecls.fh"
#include "paw_electron.fh"



      call dcopy(2*(npack1)*(ne(1)+ne(2)),psi1,1,psi2,1)
      call daxpy(2*(npack1)*(ne(1)+ne(2)),
     >           (-dte),
     >           dcpl_mb(Hpsi_k(1)),1,
     >           psi2,1)

      return
      end


 
*     ***********************************
*     *                                 *
*     *         paw_electron_energy     *
*     *                                 *
*     ***********************************
      real*8 function paw_electron_energy(psi_k,dn,dng)
      implicit none
      complex*16 psi_k(*)
      real*8     dn(*)
      complex*16 dng(*)

#include "mafdecls.fh"
#include "paw_energy_kin_atom.fh"
#include "paw_energy_vloc_atom.fh"
#include "paw_energy_ion_atom.fh"
#include "paw_energy_core_atom.fh"
#include "paw_energy_hartree_atom.fh"
#include "paw_xc.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer n2ft3d
      integer ii,ms,n1(2),n2(2),nx,ny,nz
      real*8  sum,ehartr,exc,exc2,dv,eke,evloc
      real*8  total_energy,occ(1)

*     **** external functions *****
      integer  control_version
      real*8   lattice_omega,paw_electron_ehartree
      real*8   paw_mult_energy_atom_comp
      real*8   paw_mult_energy_atom_self
      real*8   paw_mult_energy_atom_mult

      external control_version
      external lattice_omega,paw_electron_ehartree
      external paw_mult_energy_atom_comp
      external paw_mult_energy_atom_self
      external paw_mult_energy_atom_mult
      
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
     

      dv = lattice_omega()/dble(nx*ny*nz)

      n2ft3d = 2*nfft3d


*     **** get kinetic energies ****
      call ke_ave(ispin,ne,psi_k,eke,.false.,occ)
      eke = eke + paw_energy_kin_atom()
c      write(*,*) "eke:",eke

      
*     **** get coulomb energy ****
      ehartr = paw_electron_ehartree(dng)
     >       + paw_energy_hartree_atom()
     >       + paw_energy_ion_atom()
     >       + paw_energy_core_atom()
     >       + paw_energy_core_ion_atom()
     >       + paw_energy_core_self_atom()
     >       + paw_mult_energy_atom_self()
     >       + paw_mult_energy_atom_comp()
     >       + paw_mult_energy_atom_mult()
c      write(*,*) "ehartr:",ehartr
c      write(*,*) "    pw:",paw_electron_ehartree(dng)
c      write(*,*) "  atom:",  paw_energy_hartree_atom()
c     >       + paw_energy_ion_atom()
c     >       + paw_energy_core_atom()
c     >       + paw_energy_core_ion_atom()
c     >       + paw_energy_core_self_atom()
c     >       + paw_mult_energy_atom_self()
c     >       + paw_mult_energy_atom_comp()
c      write(*,*) "  mult:",paw_mult_energy_atom_mult()



*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,dn(1),dbl_mb(xce(1)),exc)
      if (ispin.eq.1) then
         exc= exc + exc
      else
         call D3dB_rr_dot(1,dn(1+n2ft3d),dbl_mb(xce(1)),exc2)
         exc= exc + exc2
      end if
      exc = exc*dv + paw_energy_xc_atom()      
c      write(*,*) "exc:",exc

*     **** get local potential energy ****
      call Pack_cc_dot(0,dng,dcpl_mb(vl(1)),evloc)
      evloc = evloc + paw_energy_vloc_atom()
c      write(*,*) "evloc:",evloc


          
      total_energy = eke + ehartr + exc + evloc

c      write(*,*) "total_energy:",total_energy

*     **** total energy ****
      paw_electron_energy = total_energy

      return
      end




*     ***********************************
*     *                                 *
*     *         paw_electron_eorbit     *
*     *                                 *
*     ***********************************
      real*8 function paw_electron_eorbit(psi_k)
      implicit none
      complex*16 psi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer ii,ms,n1(2),n2(2)
      real*8  sum,eorbit

      n1(1) = 1
      n1(2) = ne(1) + 1
      n2(1) = ne(1)
      n2(2) = ne(1) + ne(2)


*     *** get orbital energies ****
      eorbit = 0.0d0
      do ms=1,ispin
         do ii=n1(ms),n2(ms)
           call Pack_cc_idot(1,psi_k(1+(ii-1)*npack1),
     >                       dcpl_mb(Hpsi_k(1)+(ii-1)*npack1),
     >                       sum)

           eorbit = eorbit + sum

         end do
      end do
      call D3dB_SumAll(eorbit)
      if (ispin.eq.1) eorbit = eorbit+eorbit

           
      paw_electron_eorbit = eorbit 

      return
      end
 

*     ***********************************
*     *                                 *
*     *      paw_electron_ehartree      *
*     *                                 *
*     ***********************************
      real*8 function paw_electron_ehartree(dng)
      implicit none
      complex*16 dng(*)

#include "mafdecls.fh"
#include "paw_electron.fh"
#include "errquit.fh"

      !**** local varialbles ****
      logical value
      integer tmp1(2),tmp2(2)
      real*8 ehartr
      

      !**** external functions ****
      real*8   lattice_omega
      external lattice_omega

     
      value = MA_push_get(mt_dcpl,(nfft3d),'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d),'tmp2',tmp2(2),tmp2(1))
      if (.not. value) call errquit(
     >'paw_electron_ehartree: out of stack memory',0,MA_ERR)
 



*     **** get coulomb energy ****
      call Pack_cc_Sum(0,
     >                   dng,
     >                   dbl_mb(dn_cmp_smooth(1)),
     >                   dcpl_mb(tmp1(1)))
      call Pack_c_Copy(0,
     >                   dcpl_mb(vcomp(1)),
     >                   dcpl_mb(tmp2(1)))
      call Pack_cc_daxpy(0,0.5d0,
     >                   dcpl_mb(vh(1)),
     >                   dcpl_mb(tmp2(1)))
      call Pack_cc_dot(0,
     >                  dcpl_mb(tmp1(1)),
     >                  dcpl_mb(tmp2(1)),
     >                  ehartr)

c      call Pack_cc_dot(0,
c     >                  dbl_mb(dn_cmp_smooth(1)),
c     >                  dcpl_mb(tmp2(1)),
c     >                  ehartr)

c      call Pack_cc_dot(0,
c     >                  dng,
c     >                  dcpl_mb(vcomp(1)),
c     >                  ehartr)
      !ehartr = 0.5d0*ehartr

      value =           MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2)) 
      if (.not. value) call errquit(
     >'paw_electron_ehartree: error popping stack memory',0,
     > MA_ERR)


      paw_electron_ehartree = ehartr*lattice_omega()

      return
      end



*     ***********************************
*     *                                 *
*     *         paw_electron_exc        *
*     *                                 *
*     ***********************************
      real*8 function paw_electron_exc(dn)
      implicit none
      real*8 dn(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer nx,ny,nz
      real*8  exc,exc2,dv

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega


      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      
      dv = lattice_omega()/dble(nx*ny*nz)


*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,dn,
     >                 dbl_mb(xce(1)),
     >                 exc)
      if (ispin.eq.1) then
         exc= exc + exc 
      else
         call D3dB_rr_dot(1,dn(1+2*nfft3d),
     >                    dbl_mb(xce(1)),
     >                    exc2)
         exc= exc + exc2
      end if
      exc = exc*dv
        
  
      paw_electron_exc =  exc 

      return
      end


*     ***********************************
*     *                                 *
*     *         paw_electron_pxc        *
*     *                                 *
*     ***********************************
      real*8 function paw_electron_pxc(dn)
      implicit none
      real*8 dn(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer nx,ny,nz
      real*8  pxc,pxc2,dv

*     **** external functions *****
      real*8   lattice_omega
      external lattice_omega

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      
      dv = lattice_omega()/dble(nx*ny*nz)


*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,dn(1),
     >                 dbl_mb(xcp(1)),
     >                 pxc)
      if (ispin.eq.1) then
         pxc= pxc + pxc 
      else
         call D3dB_rr_dot(1,dn(1+2*nfft3d),
     >                    dbl_mb(xcp(1)+2*nfft3d),
     >                    pxc2)
         pxc= pxc + pxc2
      end if
      pxc = pxc*dv
        
  
      paw_electron_pxc =  pxc

      return
      end

*     ***********************************
*     *                                 *
*     *         paw_electron_pxc_rho    *
*     *                                 *
*     ***********************************
      real*8 function paw_electron_pxc_rho(rho)
      implicit none
      real*8 rho(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer nx,ny,nz
      real*8  pxc,pxc2,dv

*     **** external functions *****
      real*8   lattice_omega
      external lattice_omega

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      
      dv = lattice_omega()/dble(nx*ny*nz)

*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,rho,
     >                 dbl_mb(xcp(1)),
     >                 pxc)
      if (ispin.eq.1) then
         pxc = pxc + pxc
      else
         call D3dB_rr_dot(1,rho,
     >                    dbl_mb(xcp(1)+2*nfft3d),
     >                    pxc2)
         pxc = (pxc + pxc2)
      end if
      pxc = pxc*dv
          
      paw_electron_pxc_rho =  pxc
      return
      end





*     ***********************************
*     *                                 *
*     *         paw_electron_get_Hpsi_k *
*     *                                 *
*     ***********************************
      subroutine paw_electron_get_Hpsi_k(Hpsi_k_new)
      implicit none
      complex*16 Hpsi_k_new(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


      call dcopy(2*npack1*(ne(1)+ne(2)),
     >           dcpl_mb(Hpsi_k(1)),1,
     >           Hpsi_k_new,1)
      return
      end



*     ***************************
*     *                         *
*     *    paw_electron_ispin   *
*     *                         *
*     ***************************
      integer function paw_electron_ispin()
      implicit none

#include "paw_electron.fh"

      paw_electron_ispin = ispin
      return
      end


*     ***************************
*     *                         *
*     *      paw_electron_ne    *
*     *                         *
*     ***************************
      integer function paw_electron_ne(ms)
      implicit none
      integer ms

#include "paw_electron.fh"

      paw_electron_ne = ne(ms)
      return
      end


*     ***********************************
*     *                                 *
*     *     paw_electron_get_Tgradient  *
*     *                                 *
*     ***********************************

      subroutine paw_electron_get_Tgradient(psi_k,hml,THpsi_k)

      implicit none
      complex*16 psi_k(*)
      real*8     hml(*)
      complex*16 THpsi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     ***** local variables ****
      integer ms,n,shift1,shift2
     


*     **** no preconditioning ***
      do ms=1,ispin
            n     = ne(ms)
            if (n.le.0) go to 30
            shift1 = 1 + (ms-1)*ne(1)*npack1
            shift2 = 1 + (ms-1)*ne(1)*ne(1)

            call dgemm('N','N',2*npack1,n,n,
     >                (1.0d0),
     >                psi_k(shift1),  2*npack1,
     >                hml(shift2),    n,
     >                (0.0d0),
     >                THpsi_k(shift1),2*npack1)
  30        continue
      end do
      call daxpy(2*npack1*(ne(1)+ne(2)),
     >           (-1.0d0),
     >           dcpl_mb(Hpsi_k(1)),1,
     >           THpsi_k,1)
      return
      end


*     ***********************************
*     *                                 *
*     *     paw_electron_gen_Tangent    *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_Tangent(psi_k,hml,THpsi_k)
      implicit none
      complex*16 psi_k(*)
      real*8     hml(*)
      complex*16 THpsi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"

*     ***** local variables ****
      integer ms,n,shift1,shift2
     
      do ms=1,ispin
         n     = ne(ms)
         if (n.le.0) go to 30
         shift1 = 1 + (ms-1)*ne(1)*npack1
         shift2 = 1 + (ms-1)*ne(1)*ne(1)
         call dgemm('N','N',2*npack1,n,n,
     >             (-1.0d0),
     >             psi_k(shift1),  2*npack1,
     >             hml(shift2),    n,
     >             (1.0d0),
     >             THpsi_k(shift1),2*npack1)
   30    continue
      end do
      return
      end


*     ***********************************
*     *                                 *
*     *     paw_electron_get_Gradient   *
*     *                                 *
*     ***********************************

      subroutine paw_electron_get_Gradient(THpsi_k)
      implicit none
      complex*16 THpsi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


      call dcopy(2*npack1*(ne(1)+ne(2)),
     >           dcpl_mb(Hpsi_k(1)),1,
     >           THpsi_k,1)      
      return
      end


*     *******************************************
*     *                                         *
*     *     paw_electron_get_gradient_orb       *
*     *                                         *
*     *******************************************

      subroutine paw_electron_get_gradient_orb(i,Horb)
      implicit none
      integer i
      complex*16 Horb(*)

#include "mafdecls.fh"
#include "paw_electron.fh"

      call Pack_c_Copy(1,dcpl_mb(Hpsi_k(1)+(i-1)*npack1),Horb) 
      
      return
      end



*     *******************************************
*     *                                         *
*     *     paw_electron_get_TMgradient         *
*     *                                         *
*     *******************************************

      subroutine paw_electron_get_TMgradient(psi_k,THpsi_k)
      implicit none
#include "errquit.fh"
      complex*16 psi_k(*)
      complex*16 THpsi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     ***** local variables ****
      logical value
      integer ms,n,n1(2),shift,mhml(2)
     

      n1(1) = 1
      n1(2) = ne(1)+1

      value = MA_push_get(mt_dbl,(2*ne(1)*ne(1)),'mhml',mhml(2),mhml(1))
      if (.not. value)
     >call errquit('paw_electron_get_Tgradient: push stack',0, MA_ERR)



*     **** generate M*H|psi> *****
      call Grsm_gg_Copy(npack1,(ne(1)+ne(2)),
     >                  dcpl_mb(Hpsi_k(1)),
     >                  THpsi_k)
      call ke_precondition(npack1,(ne(1)+ne(2)),
     >                  psi_k,
     >                  THpsi_k)


*     **** generate mhml = <psi|M*H|psi> ****
      do ms=1,ispin
         shift = (ms-1)*ne(1)*ne(1)
         n     = ne(ms)
         call Grsm_ggm_dot(npack1,n,
     >                     psi_k(1+(ms-1)*ne(1)*npack1),
     >                     dcpl_mb(Hpsi_k(1)+(ms-1)*ne(1)*npack1),
     >                     dbl_mb(mhml(1)+shift))
      end do

*     **** mhml = -mhml ****
      call dscal(2*ne(1)*ne(1),(-1.0d0),dbl_mb(mhml(1)),1)


*     **** generate TMG = M*H|psi> - |psi>*mhml ****
      do ms=1,ispin
            shift = (ms-1)*ne(1)*ne(1)
            n     = ne(ms)
            call Grsm_gmg_daxpy(npack1,n,
     >                        psi_k(1+(ms-1)*ne(1)*npack1),
     >                        dbl_mb(mhml(1)+shift),
     >                        THpsi_k(1+(ms-1)*ne(1)*npack1))
      end do

      call Grsm_gg_dScale(npack1,(ne(1)+ne(2)),
     >                    (-1.0d0),
     >                    THpsi_k,
     >                    THpsi_k)


      value = MA_pop_stack(mhml(2))
      if (.not. value)
     >call errquit('paw_electron_get_Tradient: popping stack',0,MA_ERR)

      return
      end


*     ***********************************
*     *                                 *
*     *     paw_electron_gen_hml        *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_hml(psi_k,hml)
      implicit none
      complex*16 psi_k(*)
      real*8     hml(*)

#include "mafdecls.fh"
#include "paw_electron.fh"

*     **** local variables ****
      integer ms,n,shift

      do ms=1,ispin
         shift = (ms-1)*ne(1)*ne(1)
         n     = ne(ms)
         if (n.le.0) go to 30
         call Pack_ccm_sym_dot(1,n,
     >                     psi_k(1+(ms-1)*ne(1)*npack1),
     >                     dcpl_mb(Hpsi_k(1)+(ms-1)*ne(1)*npack1),
     >                     hml(shift+1))
  30     continue
      end do
      return
      end

*     ***********************************
*     *                                 *
*     *     paw_electron_gen_hml_S      *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_hml_S(psi_k,hml)
      implicit none
      complex*16 psi_k(*)
      real*8     hml(*)

#include "mafdecls.fh"
#include "paw_electron.fh"

*     **** local variables ****
      integer ms,n,shift

      do ms=1,ispin
         shift = (ms-1)*ne(1)*ne(1)
         n     = ne(ms)
         if (n.le.0) go to 30
         call paw_overlap_matrix_gen(n,n,
     >                     psi_k(1+(ms-1)*ne(1)*npack1),
     >                     dcpl_mb(Hpsi_k(1)+(ms-1)*ne(1)*npack1),
     >                     hml(shift+1))
  30     continue
      end do
      return
      end




*     ***********************************
*     *                                 *
*     *     paw_electron_gen_hml_g      *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_hml_g(psi_k,hml)
      implicit none
      complex*16 psi_k(*)
      real*8     hml(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer ms,n,n1(2),shift


      n1(1) = 1
      n1(2) = ne(1) + 1


      do ms=1,ispin
         shift = (ms-1)*ne(1)*ne(1)
         n     = ne(ms)
         call Pack_ccm_dot(1,n,
     >                     psi_k(1+(ms-1)*ne(1)*npack1),
     >                     dcpl_mb(Hpsi_k(1)+(ms-1)*ne(1)*npack1),
     >                     hml(shift+1))
      end do


      return
      end


*     ***********************************
*     *                                 *
*     *     paw_electron_gen_hmlt       *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_hmlt(psi_k,hmlt)
      implicit none
      complex*16 psi_k(*)
      real*8     hmlt(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer ms,n,n1(2),shift
     

      n1(1) = 1
      n1(2) = ne(1) + 1


      do ms=1,ispin
         n     = ne(ms)
         if (n.le.0) go to 30
         shift = (ms-1)*ne(1)*ne(1)
         call Pack_ccm_dot(1,n,
     >                     dcpl_mb(Hpsi_k(1)+(ms-1)*ne(1)*npack1),
     >                     psi_k(1+(ms-1)*ne(1)*npack1),
     >                     hmlt(shift+1))
   30    continue
      end do


      return
      end



*     **********************************************
*     *                                            *
*     *     paw_electron_gen_psiTangenthml_S       *
*     *                                            *
*     **********************************************

      subroutine paw_elecpsitang(psi_k,THpsi_k,hml)
      implicit none
      complex*16 psi_k(*)
      complex*16 THpsi_k(*)
      real*8     hml(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      integer ms,n,shift

      do ms=1,ispin
         n     = ne(ms)
         if (n.le.0) go to 30
         shift = (ms-1)*ne(1)*ne(1)
         call paw_overlap_matrix_gen(n,n,
     >                     psi_k(1+(ms-1)*ne(1)*npack1),
     >                     THpsi_k(1+(ms-1)*ne(1)*npack1),
     >                     hml(shift+1))
   30    continue
      end do

      return
      end






**************************************************************************
**************************************************************************
*******    routines below this line are for internal use only    *********
**************************************************************************
**************************************************************************

*     *******************************************
*     *                                         *
*     *         paw_electron_gen_Hpsi_k         *
*     *                                         *
*     *******************************************

      subroutine paw_electron_gen_Hpsi_k(psi_k)
      implicit none
      complex*16 psi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      logical move
      integer n
      real*8  fion(3,1)

*     **** external functions ****
      integer  control_version
      external control_version

      move = .false.

*     ******************
*     **** get Hpsi ****
*     ******************
        call paw_psi_H(ispin,ne,psi_k,
     >             dbl_mb(psi_r(1)),
     >             dcpl_mb(vl(1)),
     >             dcpl_mb(vc(1)),
     >             dbl_mb(xcp(1)),
     >             dcpl_mb(Hpsi_k(1)),
     >             move,
     >             fion)


      call Grsm_gg_dscale(npack1,(ne(1)+ne(2)),(-1.0d0),
     >                    dcpl_mb(Hpsi_k(1)),
     >                    dcpl_mb(Hpsi_k(1)))

      return
      end



c*     ***********************************
c*     *                                        *
c*     *     paw_electron_gen_Hpsi_k_orb        *
c*     *                                        *
c*     ***********************************
c
c      subroutine paw_electron_gen_Hpsi_k_orb(n,psi_k)
c      implicit none
c      integer n
c      complex*16 psi_k(*)
c
c#include "mafdecls.fh"
c#include "paw_electron.fh"
c
c
c*     **** local variables ****
c      integer nne(2)
c
c*     **** external functions ****
c      integer  control_version
c      external control_version
c
c
c    
c      if (n.le.ne(1)) then
c        nne(1) = 1
c        nne(2) = 0
c      else
c        nne(1) = 0
c        nne(2) = 1
c      end if 
c
c*     ******************
c*     **** get Hpsi ****
c*     ******************
c      call paw_psi_Horb(ispin,nne,psi_k(1+(n-1)*npack1),
c     >             dbl_mb(psi_r(1)+(n-1)*2*nfft3d),
c     >             dbl_mb(vall(1)),
c     >             dcpl_mb(Hpsi_k(1)+(n-1)*npack1))
c
c
c      call Pack_c_SMul(1,(-1.0d0),
c     >                 dcpl_mb(Hpsi_k(1)+(n-1)*npack1),
c     >                 dcpl_mb(Hpsi_k(1)+(n-1)*npack1))
c
c      return
c      end

c*     ***********************************
c*     *                                        *
c*     *   paw_electron_get_gradient_virtual *
c*     *                                        *
c*     ***********************************
c
c      subroutine paw_electron_get_gradient_virtual(ms,orb,Horb)
c      implicit none
c#include "errquit.fh"
c      integer    ms
c      complex*16 orb(*)
c      complex*16 Horb(*)
c
c#include "mafdecls.fh"
c#include "paw_electron.fh"
c
c
c*     **** local variables ****
c      logical value
c      integer nne(2),n2ft3d
c      integer tmp_r(2)
c
c*     **** external functions ****
c      integer  control_version
c      external control_version
c
c      if (ms.eq.1) then
c        nne(1) = 1
c        nne(2) = 0
c      else
c        nne(1) = 0
c        nne(2) = 1
c      end if 
c
c      n2ft3d = 2*nfft3d
c
c      value = MA_push_get(mt_dbl,(n2ft3d),'tmp_r',tmp_r(2),tmp_r(1))
c      if (.not. value)
c     >   call errquit('paw_electron_get_gradient_virtual: push stack',0,
c     &       MA_ERR)
c
c
c      call Pack_c_Copy(1,orb,dbl_mb(tmp_r(1)))
c      call Pack_c_unpack(1,  dbl_mb(tmp_r(1)))
c      call D3dB_cr_fft3b(1,  dbl_mb(tmp_r(1))) 
c
c
c*     **** get Hpsi ****
c      if (control_version().eq.3)
c     >  call psi_Horb(ispin,nne,orb,
c     >             dbl_mb(tmp_r(1)),
c     >             dbl_mb(vall(1)),
c     >             Horb)
c
c      if (control_version().eq.4)
c     >  call psi_Horbv4(ispin,nne,orb,
c     >             dbl_mb(tmp_r(1)),
c     >             dbl_mb(vall(1)),
c     >             Horb)
c
c      call Pack_c_SMul(1,(-1.0d0),Horb,Horb)
c
c      value = MA_pop_stack(tmp_r(2))
c      if (.not. value) call errquit(
c     >     'paw_electron_get_gradient_virtual: poping stack',1, MA_ERR)
c
c
c      return
c      end



*     ***********************************
*     *                                 *
*     *     paw_electron_gen_psi_r      *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_psi_r(psi_k)
      implicit none
      complex*16 psi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"

*     **** local variables ****
      integer n,nemax,n2ft3d


      n2ft3d = 2*nfft3d
      nemax = ne(1) + ne(2)

c     call Grsm_gg_Copy(npack1,nemax,psi_k,dbl_mb(psi_r(1)))
      do n=1,nemax
         call Pack_c_Copy(1,psi_k(1+(n-1)*npack1),
     >                    dbl_mb(psi_r(1)+(n-1)*n2ft3d))
      end do

      call Grsm_gh_fftb(nfft3d,nemax,dbl_mb(psi_r(1)))
      call Grsm_h_Zero_Ends(nfft3d,nemax,dbl_mb(psi_r(1)))

      return
      end

*     ***********************************
*     *                                 *
*     *     paw_electron_gen_psi_r_orb  *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_psi_r_orb(n,psi_k)
      implicit none
      integer    n
      complex*16 psi_k(*)

#include "mafdecls.fh"
#include "paw_electron.fh"

*     **** local variables ****
      integer n2ft3d

      n2ft3d = 2*nfft3d

      call Pack_c_Copy(1,psi_k(1+(n-1)*npack1),
     >                        dbl_mb(psi_r(1)+(n-1)*n2ft3d))
     
      call Pack_c_unpack(1,   dbl_mb(psi_r(1)+(n-1)*n2ft3d))
      call D3dB_cr_fft3b(1,   dbl_mb(psi_r(1)+(n-1)*n2ft3d)) 
      call D3dB_r_Zero_Ends(1,dbl_mb(psi_r(1)+(n-1)*n2ft3d))

      return
      end


*     ***********************************
*     *                                 *
*     *    paw_electron_gen_densities   *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_densities(psi_k,dn,dng)
      implicit none
      complex*16 psi_k(*)
      real*8     dn(*)
      complex*16 dng(*)

#include "mafdecls.fh"
#include "paw_electron.fh"

     
*     **** local variables ****
      integer i
      integer ms,n2ft3d
      integer n,n1(2),n2(2)
      real*8  scal2
      integer tmp1(2)
      logical value

*     ***** external functions *****
      real*8   lattice_omega
      external lattice_omega


      n1(1) = 1
      n1(2) = ne(1) + 1
      n2(1) = ne(1)
      n2(2) = ne(1) + ne(2)

      n2ft3d = 2*nfft3d
      scal2 = 1.0d0/lattice_omega()


*     *********************
*     **** generate dn ****
*     *********************
      call dcopy(2*n2ft3d,0.0d0,0,dn,1)

      do ms=1,ispin
         do n=n1(ms),n2(ms)
            do i=1,n2ft3d
               dn(i+(ms-1)*n2ft3d) 
     >            = dn(i+(ms-1)*n2ft3d) 
     >            + scal2*(dbl_mb(psi_r(1)+i-1+(n-1)*n2ft3d)**2)
            end do
         end do
         call D3dB_r_Zero_Ends(1,dn(1+(ms-1)*n2ft3d))
      end do

*     **** generate dng  ****
      call paw_electron_gen_dng(dn,dng)

      return
      end



*     ***********************************
*     *                                 *
*     *      paw_electron_gen_dng       *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_dng(dn,dng)
      implicit none
      real*8     dn(*)
      complex*16 dng(*)

#include "mafdecls.fh"
#include "paw_electron.fh"
#include "errquit.fh"

     
*     **** local variables ****
      integer i
      integer ms,nx,ny,nz,n2ft3d
      integer n,n1(2),n2(2)
      real*8  scal1
      integer tmp1(2)
      logical value

*     ***** external functions *****
      logical  psp_semicore
      external psp_semicore

      n2ft3d = 2*nfft3d
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 1.0d0/dble(nx*ny*nz)
        
*     **********************
*     **** generate dng ****
*     **********************
      value = MA_push_get(mt_dbl,(n2ft3d),'tmp1',tmp1(2),tmp1(1)) 
         if (.not. value) call errquit(
     >     'paw_electron_gen_dng: out of stack memory',0, MA_ERR)

      call D3dB_rr_Sum(1,dn,dn(1+(ispin-1)*n2ft3d),dbl_mb(tmp1(1)))
c      call D3dB_r_SMul(1,scal1,dbl_mb(tmp1(1)),dbl_mb(tmp1(1)))
      call D3dB_r_SMul1(1,scal1,dbl_mb(tmp1(1)))
      call D3dB_rc_fft3f(1,dbl_mb(tmp1(1)))
      call Pack_c_pack(0,dbl_mb(tmp1(1)))
      call Pack_c_Copy(0,dbl_mb(tmp1(1)),dng)


      value = MA_pop_stack(tmp1(2)) 
      if (.not. value) call errquit(
     >     'paw_electron_gen_dng: poping stack',1, MA_ERR)


      return
      end


*     ***********************************
*     *                                 *
*     *        paw_electron_gen_vall    *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_vall()
      implicit none
   

#include "mafdecls.fh"
#include "paw_electron.fh"
     
*     **** local variables ****
      integer ms
      real*8 scal2
      
*     **** external functions ****
      integer  control_version
      real*8   lattice_omega
      external control_version
      external lattice_omega
      

      scal2 = 1.0d0/lattice_omega()

      if (control_version().eq.3) then

*       **** add up k-space potentials, vall = scal2*vl + vc  ****
        call Pack_c_SMul(0,scal2,dcpl_mb(vl(1)),
     >                           dbl_mb(vall(1)))
c        call Pack_cc_Sum(0,dbl_mb(vall(1)),
c     >                     dcpl_mb(vc(1)),
c     >                     dbl_mb(vall(1)))
        call Pack_cc_Sum2(0,dcpl_mb(vc(1)),
     >                     dbl_mb(vall(1)))
      
*       **** fourier transform k-space potentials ****
        call Pack_c_unpack(0,dbl_mb(vall(1)))
        call D3dB_cr_fft3b(1,dbl_mb(vall(1)))

*       **** add v_field to vall ****
c        if (field_exist)
c     >    call D3dB_rr_Sum(1,dbl_mb(vall(1)),
c     >                       dbl_mb(v_field(1)),
c     >                       dbl_mb(vall(1)))
        if (field_exist)
     >    call D3dB_rr_Sum2(1,dbl_mb(v_field(1)),
     >                        dbl_mb(vall(1)))

      else

*       **** add up k-space potentials, vall = scal2*vsr_l    ****
        call Pack_c_SMul(0,scal2,dcpl_mb(vl(1)),
     >                           dbl_mb(vall(1)))
      
*        **** fourier transform k-space potentials ****
         call Pack_c_unpack(0,dbl_mb(vall(1)))
         call D3dB_cr_fft3b(1,dbl_mb(vall(1)))

*        **** add vlr_l, vc and v_field to vall ****
c         call D3dB_rr_Sum(1,dbl_mb(vall(1)),
c     >                      dbl_mb(vl_lr(1)),
c     >                      dbl_mb(vall(1)))
c         call D3dB_rr_Sum(1,dbl_mb(vall(1)),
c     >                      dcpl_mb(vc(1)),   
c     >                      dbl_mb(vall(1)))
c         if (field_exist)
c     >     call D3dB_rr_Sum(1,dbl_mb(vall(1)),
c     >                        dbl_mb(v_field(1)),
c     >                        dbl_mb(vall(1)))
         call D3dB_rr_Sum2(1,dbl_mb(vl_lr(1)),
     >                       dbl_mb(vall(1)))
         call D3dB_rr_Sum2(1,dcpl_mb(vc(1)),   
     >                       dbl_mb(vall(1)))
         if (field_exist)
     >     call D3dB_rr_Sum2(1,dbl_mb(v_field(1)),
     >                         dbl_mb(vall(1)))

      end if

*     **** add xcp to vall ****
c      do ms=ispin,1,-1      
c        call D3dB_rr_Sum(1,dbl_mb(vall(1)),
c     >                   dbl_mb(xcp(1)+(ms-1)*2*nfft3d),
c     >                   dbl_mb(vall(1)+(ms-1)*2*nfft3d))
c        call D3dB_r_Zero_Ends(1,dbl_mb(vall(1)+(ms-1)*2*nfft3d))
c      end do
      if (ispin.eq.2) then
        call D3dB_rr_Sum(1,dbl_mb(vall(1)),
     >                   dbl_mb(xcp(1)+2*nfft3d),
     >                   dbl_mb(vall(1)+2*nfft3d))
        call D3dB_r_Zero_Ends(1,dbl_mb(vall(1)+2*nfft3d))
      end if
      call D3dB_rr_Sum2(1,dbl_mb(xcp(1)),dbl_mb(vall(1)))
      call D3dB_r_Zero_Ends(1,dbl_mb(vall(1)))

      return
      end



*     ***********************************
*     *                                 *
*     *        paw_electron_get_vall    *
*     *                                 *
*     ***********************************

      subroutine paw_electron_get_vall(vall_out)
      implicit none
      real*8 vall_out

#include "mafdecls.fh"
#include "paw_electron.fh"

      call dcopy(4*nfft3d,dbl_mb(vall(1)),1,vall_out,1)
      return
      end


*     ***********************************
*     *                                 *
*     *        paw_electron_set_vall    *
*     *                                 *
*     ***********************************

      subroutine paw_electron_set_vall(vall_in)
      implicit none
      real*8 vall_in

#include "mafdecls.fh"
#include "paw_electron.fh"

      call dcopy(4*nfft3d,vall_in,1,dbl_mb(vall(1)),1)
      return
      end


*     *******************************************
*     *                                         *
*     *   paw_electron_gen_scf_potentials       *
*     *                                         *
*     *******************************************

      subroutine paw_electron_gen_scf_potentials(dn,dng)
      implicit none
      real*8     dn(*)
      complex*16 dng(*)

#include "mafdecls.fh"
#include "paw_electron.fh"
#include "nwxc.fh"
#include "errquit.fh"


*     ***** local variables ****
      logical value
      integer n2ft3d,nx,ny,nz,gga
      integer tmp1(2),tmp2(2)
      real*8  vzero,scal1

*     **** external functions ****
      integer  control_gga,control_version
      external control_gga,control_version

     
      n2ft3d = 2*nfft3d
      value = MA_push_get(mt_dcpl,(nfft3d),'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d),'tmp2',tmp2(2),tmp2(1))
      if (.not. value) call errquit(
     >'paw_electron_gen_scf_potentials: out of stack memory',0,MA_ERR)
 

*     ************************************
*     **** generate coulomb potential ****
*     ************************************
      call paw_pot_hartree_solve()

*     *** atomic portion ***

      call paw_mult_dn_cmp_get(dcpl_mb(tmp1(1)),
     >                         dbl_mb(dn_cmp_smooth(1)))

      if (control_version().eq.3)  then
           call Pack_cc_Sub(0,
     >                      dcpl_mb(tmp1(1)),
     >                      dbl_mb(dn_cmp_smooth(1)),
     >                      dcpl_mb(tmp2(1))) !** tmp2 = dn_cmp - dn_cmp_smooth
           call Pack_cc_Sum(0,
     >                      dbl_mb(dn_cmp_smooth(1)),
     >                      dng,
     >                      dcpl_mb(tmp1(1))) !** tmp1 = dng+dn_cmp_smooth **

           !**** vh *****
           call coulomb_v(dcpl_mb(tmp1(1)),
     >                    dcpl_mb(vh(1)))


           !**** vcmp *****
           call coulomb_v(dcpl_mb(tmp2(1)),
     >                    dcpl_mb(vcomp(1)))
           call paw_mult_vzero(vzero)
           call Pack_c_setzero(0,vzero,dcpl_mb(vcomp(1)))

           call paw_mult_coeff_set(dcpl_mb(vh(1)),dcpl_mb(vcomp(1)))

           call Pack_cc_Sum(0,
     >                      dcpl_mb(vh(1)),
     >                      dcpl_mb(vcomp(1)),
     >                      dcpl_mb(vc(1)))

      end if

      if (control_version().eq.4) then

           call D3dB_nx(1,nx)
           call D3dB_ny(1,ny)
           call D3dB_nz(1,nz)
           scal1 = 1.0d0/dble(nx*ny*nz)
           call Pack_cc_Sub(0,
     >                      dcpl_mb(tmp1(1)),
     >                      dbl_mb(dn_cmp_smooth(1)),
     >                      dcpl_mb(tmp2(1))) !** tmp2 = dn_cmp - dn_cmp_smooth
c           call Pack_c_Copy(0,
c     >                      dcpl_mb(tmp1(1)),
c     >                      dcpl_mb(tmp2(1))) !** tmp2 = dn_cmp
           call Pack_cc_Sum(0,
     >                      dbl_mb(dn_cmp_smooth(1)),
     >                      dng,
     >                      dcpl_mb(tmp1(1))) !** tmp1 = dng+dn_cmp_smooth **


           call Pack_c_unpack(0,dcpl_mb(tmp1(1)))
           call D3dB_cr_fft3b(1,dcpl_mb(tmp1(1)))
           call D3dB_r_Zero_Ends(1,dcpl_mb(tmp1(1)))

           call coulomb2_v(dcpl_mb(tmp1(1)),dcpl_mb(vh(1)))

           call D3dB_rc_fft3f(1,dcpl_mb(vh(1)))
           call D3dB_r_SMul1(1,scal1,dcpl_mb(vh(1)))
           call Pack_c_pack(0,dcpl_mb(vh(1)))


           call Pack_c_unpack(0,dcpl_mb(tmp2(1)))
           call D3dB_cr_fft3b(1,dcpl_mb(tmp2(1)))
           call D3dB_r_Zero_Ends(1,dcpl_mb(tmp2(1)))

           call coulomb2_v(dcpl_mb(tmp2(1)),dcpl_mb(vcomp(1)))

           call D3dB_rc_fft3f(1,dcpl_mb(vcomp(1)))
           call D3dB_r_SMul1(1,scal1,dcpl_mb(vcomp(1)))
           call Pack_c_pack(0,dcpl_mb(vcomp(1)))

           call paw_mult_vzero(vzero)
           call Pack_c_setzero(0,vzero,dcpl_mb(vcomp(1)))

           call paw_mult_coeff_set(dcpl_mb(vh(1)),dcpl_mb(vcomp(1)))

           call Pack_cc_Sum(0,
     >                      dcpl_mb(vh(1)),
     >                      dcpl_mb(vcomp(1)),
     >                      dcpl_mb(vc(1)))
      end if


*     *************************************************
*     **** generate exchange-correlation potential ****
*     *************************************************

*     **** local portion ****
c      call paw_density_solve()
      call paw_xc_solve()
      

*     **** plane wave portion ****
      gga = control_gga()
      if ((.not.nwxc_is_on().and.gga.eq.0).or.
     &    (nwxc_is_on().and.nwxc_is_lda())) then
        call vxc(n2ft3d,ispin,dn,
     >                    dbl_mb(xcp(1)),
     >                    dbl_mb(xce(1)),
     >                    dcpl_mb(tmp1(1)))

      else
        call v_bwexc(gga,n2ft3d,ispin,dn,
     >                    1.0d0,1.0d0,
     >                    dbl_mb(xcp(1)),
     >                    dbl_mb(xce(1)))
      end if

      value =           MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2)) 
      if (.not. value) call errquit(
     >'paw_electron_gen_scf_potentials: error popping stack memory',0,
     > MA_ERR)


      return
      end




*     ***********************************
*     *                                 *
*     *   paw_electron_gen_vl_potential *
*     *                                 *
*     ***********************************

      subroutine paw_electron_gen_vl_potential()
      implicit none
#include "errquit.fh"

#include "mafdecls.fh"
#include "paw_electron.fh"


*     **** local variables ****
      logical move,value
      integer n2ft3d
      integer tmp1(2)
      integer tmp2(2)

*     **** external functions *****
      integer  control_version
      external control_version

      value = MA_push_get(mt_dcpl,(nfft3d),'tmp1',tmp1(2),tmp1(1)) 
      value = value.and.
     >        MA_push_get(mt_dbl,(3),'tmp2',tmp2(2),tmp2(1))
      if (.not. value) call 
     >   errquit('paw_electron_gen_vl_potential: out of stack memory',0,
     &       MA_ERR)

      move = .false.
      call paw_vloc(dcpl_mb(vl(1)),
     >              move,
     >              dcpl_mb(tmp1(1)),
     >              dbl_mb(tmp2(1)))

      value = MA_pop_stack(tmp2(2))
      value = value.and.
     >        MA_pop_stack(tmp1(2))
      if (.not. value) call errquit(
     >  'paw_electron_gen_vl_potential: error popping stack memory',0,
     &       MA_ERR)

      return
      end



*     ***********************************
*     *                                 *
*     *   paw_electron_psi_vl_ave       *
*     *                                 *
*     ***********************************

      real*8 function paw_electron_psi_vl_ave(psi1,dn)
      implicit none
      complex*16 psi1(*)
      real*8     dn(*)

#include "mafdecls.fh"
#include "paw_electron.fh"
#include "errquit.fh"


*     **** local variables ****
      logical value
      integer n,ms,n1(2),n2(2)
      integer nx,ny,nz,n2ft3d,np
      real*8 elocal,sum,scal1,scal2,dv
      integer tmp1(2),tmp2(2)

*     **** external functions ***
      integer  control_version
      real*8   lattice_omega
      external control_version
      external lattice_omega


      call Parallel_np(np)

      n2ft3d = 2*nfft3d
      value = MA_push_get(mt_dbl,(n2ft3d),'tmp1',tmp1(2),tmp1(1)) 
      value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'tmp2',tmp2(2),tmp2(1))
      if (.not. value) call errquit(
     >'paw_electron_psi_vl_ave: out of stack memory',0, MA_ERR)

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)

      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()
      dv    = scal1/scal2


*     **** average Kohn-Sham v_local energy ****
       call Pack_c_Copy(0,dcpl_mb(vl(1)),dbl_mb(tmp1(1)))
      call Pack_c_unpack(0,dbl_mb(tmp1(1)))
      call D3dB_cr_fft3b(1,dbl_mb(tmp1(1)))
      elocal = 0.0d0
      do ms=1,ispin
         do n=n1(ms),n2(ms)
            call D3dB_rr_Mul(1,
     >                       dbl_mb(tmp1(1)),
     >                       dbl_mb(psi_r(1)+(n-1)*n2ft3d),
     >                       dbl_mb(tmp2(1)))

            
            call D3dB_rr_idot(1,
     >                       dbl_mb(psi_r(1)+(n-1)*n2ft3d),
     >                       dbl_mb(tmp2(1)),
     >                       sum)

            elocal = elocal + sum*scal1*scal2
         end do
      end do
      if (np.gt.1) call D3dB_SumAll(elocal)
      if (ispin.eq.1) elocal = 2.0d0*elocal

 
      value = MA_pop_stack(tmp2(2))
      value = value.and.
     >        MA_pop_stack(tmp1(2))
      if (.not. value) call errquit(
     >'paw_electron_psi_vl_ave: error popping stack memory',0,MA_ERR)

      paw_electron_psi_vl_ave = elocal
      return
      end

*     ***********************************
*     *                                 *
*     *       paw_electron_force        *
*     *                                 *
*     ***********************************

      subroutine paw_electron_force(psi1,dng1,fion)
      implicit none
      complex*16 psi1(*)
      complex*16 dng1(*)
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "paw_electron.fh"

      !**** local variables ****
      logical value
      integer tmp(2),nemax

      nemax = ne(1)+ne(2)
      call paw_vloc_force(dng1,fion)
      call paw_mult_pw_force(dcpl_mb(vh(1)),
     >                        dcpl_mb(vcomp(1)),
     >                        fion)
      call paw_force_solve(psi1,fion)

      value = MA_push_get(mt_dbl,(8*nemax*nemax),
     >                     'tmp',tmp(2),tmp(1))
      if (.not. value) 
     > call errquit('paw_electron_force:out of stack memory',0,0)


      call paw_electron_gen_hml(psi1,dbl_mb(tmp(1)))
      call paw_force_constraint(dbl_mb(tmp(1)),fion)

      value = MA_pop_stack(tmp(2))
      if (.not. value) 
     > call errquit('paw_electron_force:popping stack memory',0,0)



       return
       end

      SUBROUTINE ccsdtq_lambda2_20_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lambda2_20_3.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h4 h12 h13 )_yt + = 1/24 * Sum ( h10 h9 p8 p7 p6 p5 ) * t ( p5 p6 p7 p8 h9 h10 h12 h13 )_t * y ( h3 h4 h9 h10 p5 p6 p7 p8 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER h12b
      INTEGER h13b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER p8b
      INTEGER h9b
      INTEGER h10b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER h12b_1
      INTEGER h13b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(4)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h12b = 1,noab
      DO h13b = h12b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h13b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &12b-1)+int_mb(k_spin+h13b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h12b-1),int_mb(k_sym+h13b-1)))) .eq. ieor(irrep_y,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+h12b-1) * int_mb(k_range+h13b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_20_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO p8b = p7b,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h12b-1)+int_mb(k_spin+h13
     &b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h12b-1),ie
     &or(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h9b-1),int_mb(k_sym+h10b
     &-1)))))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_8(p5b,p6b,p7b,p8b,h12b,h13b,h9b,h10b,p5b_1,p6b
     &_1,p7b_1,p8b_1,h12b_1,h13b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_8(h3b,h4b,h9b,h10b,p5b,p6b,p7b,p8b,h3b_2,h4b_2
     &,h9b_2,h10b_2,p5b_2,p6b_2,p7b_2,p8b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+h9b-1) *
     & int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+h12b-1) * int_mb(k_range+h13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_20_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_20_3',2,MA_ERR)
      IF ((h10b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (
     &p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+h13b-1),8,7,6,5,4,3,2,1,1.0d0)
      END IF
      IF ((h9b .le. h12b) .and. (h12b .lt. h10b) .and. (h10b .le. h13b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h12b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (
     &p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h13b-1),8,6,7,5,4,3,2,1,-1.0d0)
      END IF
      IF ((h9b .le. h12b) .and. (h13b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h12b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (
     &p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h12b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h10b-1),7,6,8,5,4,3,2,1,1.0d0)
      END IF
      IF ((h12b .lt. h9b) .and. (h10b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (h12b_1 - 
     &1 + noab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (
     &p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h13b-1),8,5,7,6,4,3,2,1,1.0d0)
      END IF
      IF ((h12b .lt. h9b) .and. (h9b .le. h13b) .and. (h13b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h9b_1 - 1 + noab * (h12b_1 - 
     &1 + noab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (
     &p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h10b-1),7,5,8,6,4,3,2,1,-1.0d0)
      END IF
      IF ((h13b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h13b_1 - 1 + noab * (h12b_1 - 
     &1 + noab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (
     &p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h13b-1),int_mb(k_range+h9b-
     &1),int_mb(k_range+h10b-1),6,5,8,7,4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_20_3',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_20_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_20_3',5,MA_ERR)
      IF ((h10b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1
     & + noab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),4,3,2,1,8,7,6,5,1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (h10b .lt. h4b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h3b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h10b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),4,2,3,1,8,7,6,5,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h4b .le. h10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h4b_2 - 
     &1 + noab * (h3b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),3,2,4,1,8,7,6,5,1.0d0)
      END IF
      IF ((h3b .le. h9b) .and. (h10b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h9b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),4,1,3,2,8,7,6,5,1.0d0)
      END IF
      IF ((h3b .le. h9b) .and. (h9b .lt. h4b) .and. (h4b .le. h10b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h4b_2 - 
     &1 + noab * (h9b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h4b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),3,1,4,2,8,7,6,5,-1.0d0)
      END IF
      IF ((h4b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 - 
     &1 + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),2,1,4,3,8,7,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_20_3',6,M
     &A_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      nsuperp(3) = 1
      nsuperp(4) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      IF (p6b .eq. p7b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      IF (p7b .eq. p8b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h9b .eq. h10b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,48.0d0/FACTORIAL
     &(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsuperp(3))/FACTORIAL
     &(nsuperp(4))/FACTORIAL(nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_so
     &rt),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),
     &dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_20_3
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_20_3
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_20_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+h12b-
     &1),2,1,4,3,1.0d0/24.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h13b 
     &- 1 + noab * (h12b - 1 + noab * (h4b - 1 + noab * (h3b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_20_3',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_20_3
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE mp4_2pdm_pppp_mo(d_i0,d_t22,d_y2,k_i0_offset,k_t22_of
     &fset,k_y2_offset)
C     $Id: mp4_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 p3 p4 )_yt2 + = 1 * Sum ( h5 h6 ) * t2 ( p1 p2 h5 h6 )_t2 * y ( h5 h6 p3 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t22
      INTEGER k_t22_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      CALL mp4_2pdm_pppp_mo_1(d_t22,k_t22_offset,d_y2,k_y2_offset,d_i0
     &,k_i0_offset)
      RETURN
      END
      SUBROUTINE mp4_2pdm_pppp_mo_1(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: mp4_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 p3 p4 )_yt2 + = 1 * Sum ( h5 h6 ) * t2 ( p1 p2 h5 h6 )_t2 * y ( h5 h6 p3 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER p4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+p
     &3b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+p3b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_y,irrep_t2)) T
     &HEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+p3b-1) * int_mb(k_range+p4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mp4_2pdm_pppp_mo_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_t2) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h5b,h6b,p1b_1,p2b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,p4b,h5b_2,h6b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mp4_2pdm_pppp_mo_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mp4_2pdm_pppp_mo_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mp4_2pdm_pppp_mo_1',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mp4_2pdm_pppp_mo_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mp4_2pdm_pppp_mo_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mp4_2pdm_pppp_mo_1',6,
     &MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mp4_2pdm_pppp_mo_
     &1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mp4_2pdm_pppp_mo_
     &1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mp4_2pdm_pppp_mo_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (p2b - noab - 1 + nvab
     & * (p1b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mp4_2pdm_pppp_mo_1',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mp4_2pdm_pppp_mo_
     &1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

c $Id: smd_end.F 19707 2010-10-29 17:59:36Z d3y133 $
      subroutine smd_end()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer srtdb
c
      character*32 pname
c
      pname = "smd_end"
      call smd_atom_end()
c
      return
      end

      SUBROUTINE vib_LIBE(EQVAL,NOINT,NLIBE,I,J,K,C,B,NDIM)
C*MODULE VIB  *DECK LIBE
* $Id: vib_libe.F 19708 2010-10-29 18:04:21Z d3y133 $
C
      IMPLICIT NONE ! DOUBLE PRECISION (A-H,O-Z)
#include "errquit.fh"
C
      integer ndim, noint, nlibe, i, j, k
      double precision B(NDIM,*),C(3,*), eqval
      DOUBLE PRECISION ZERO, ONE, TOL1, TOL2
      PARAMETER (ZERO=0.0D+00, ONE=1.0D+00)
      PARAMETER (TOL1=1.0D-04, TOL2=5.0D-04)
      INTEGER MAXBE, NNAM
      PARAMETER (MAXBE=5, NNAM=1)
C
      double precision A(3),RJI(3),RJK(3),UN(3),APTS(3*MAXBE),RJA(3),
     *          UNIT(3),UP(3),EJI(3),EJK(3)
c
      DOUBLE PRECISION PI, FACT, DJKSQ, DJISQ, DAJSQ, DOT, RJASQ
      DOUBLE PRECISION DJI, DJK, DAJ, DOTJ, DOTP, TEST, B1, B2
      INTEGER IPT, M, LOC, NOCOL1, NOCOL2, NOCOL3 
C
C
C     ----- THIS ROUTINE COMPUTES THE B MATRIX ELEMENTS FOR ONE OR
C           BOTH OF 2 PERPENDICULAR LINEAR BENDING COORDINATES.
C           SEE FERIGLE AND MEISTER, J CHEM PHYS 19,982(1951) -----
C
C     ----- I AND K ARE THE END ATOMS AND J IS THE CENTRAL ATOM. A
C           GIVES THE CARTESIAN COORDINATES OF A POINT IN SPACE SUCH
C           THAT THE VECTOR FROM ATOM J TO POINT A IS PERPENDICULAR TO
C           THE LINE I-J-K AND SERVES TO ORIENT THE COORDS IN SPACE.
C           THE FIRST OF THE TWO INTERNAL COORDINATES IS IN THE I-A-K
C           PLANE AND THE SECOND IN A PLANE PERPENDICULAR TO THE FIRST,
C           THROUGH POINTS I,J, AND K -----
C
      PI = ACOS(-ONE)
C
C     ----- READ THE PLANE CONTAINING THE POINTS A -----
C
       IPT = 1 + (NLIBE - 1)*3
       READ(5,*,ERR=100,END=110)(APTS(I),I=IPT,IPT+2)
       GOTO 115
  100  WRITE(6,9040)
       CALL errquit('vib_libe error',911, UNKNOWN_ERR)
  110  WRITE(6,9050)
       CALL errquit('vib_libe error',911, UNKNOWN_ERR)
C
C     ----- TAKE THE POINT A LYING IN THE PLANE, AND GENERATE
C           THE POINT A SUCH THAT A-J IS PERP. TO I-J-K -----
C
  115 DJKSQ=ZERO
      DOT=ZERO
      LOC=3*NLIBE-3
      DO 120 M=1,3
         A(M) = APTS(LOC+M)
         RJK(M) = C(M,K) - C(M,J)
         DJKSQ = DJKSQ + RJK(M)*RJK(M)
         RJA(M) = A(M) - C(M,J)
         DOT = DOT + RJK(M)*RJA(M)
  120 CONTINUE
      FACT=DOT/DJKSQ
      RJASQ = ZERO
      DO 140 M=1,3
         RJA(M) = RJA(M) - FACT*RJK(M)
         RJASQ = RJASQ + RJA(M)*RJA(M)
         A(M) = C(M,J) + RJA(M)
  140 CONTINUE
      IF(ABS(RJASQ).LT.TOL1) THEN
         WRITE(6,9010) (APTS(LOC+M),M=1,3)
         CALL errquit('vib_libe error',911, UNKNOWN_ERR)
      END IF
C
C     ----- A IS NOW CORRECTLY LOCATED -----
C
      DJISQ = ZERO
      DJKSQ = ZERO
      DAJSQ = ZERO
      DO 210 M = 1,3
         RJI(M) = C(M,I)-C(M,J)
         DJISQ = DJISQ+RJI(M)*RJI(M)
         RJK(M) = C(M,K)-C(M,J)
         DJKSQ = DJKSQ+RJK(M)*RJK(M)
         UN(M) = A(M)-C(M,J)
         DAJSQ = DAJSQ+UN(M)*UN(M)
  210 CONTINUE
      DJI = SQRT(DJISQ)
      DJK = SQRT(DJKSQ)
      DAJ = SQRT(DAJSQ)
      DOTJ = ZERO
      DOTP = ZERO
      DO 230 M = 1,3
         EJI(M) = RJI(M)/DJI
         EJK(M) = RJK(M)/DJK
         UNIT(M) = UN(M)/DAJ
         DOTJ = DOTJ+EJI(M)*EJK(M)
         DOTP = DOTP+EJI(M)*UNIT(M)
  230 CONTINUE
      TEST = (ABS(DOTJ)-ONE)
      IF ((ABS(TEST).GT.TOL1) .OR.
     *    (ABS(DOTP).GT.TOL2)) THEN
         WRITE (6,9020)  TEST,DOTP
         CALL errquit('vib_libe error',911, UNKNOWN_ERR)
      END IF
      IF (ABS(DOTJ)-ONE .GT. ZERO) DOTJ=SIGN(ONE,DOTJ)
      EQVAL = ACOS(DOTJ)
      IF(ABS(EQVAL)   .LT.TOL1) EQVAL=ZERO
      IF(ABS(EQVAL-PI).LT.TOL1) EQVAL=PI
C
C     ----- FIRST COMPONENT OF THE BEND -----
C
      NOCOL1 = 3*(I-1)
      NOCOL2 = 3*(K-1)
      NOCOL3 = 3*(J-1)
      DO 300 M = 1,3
         B(NOINT,NOCOL1+M) = -UNIT(M)/DJI
         B(NOINT,NOCOL2+M) = -UNIT(M)/DJK
         B(NOINT,NOCOL3+M) = (ONE/DJI+ONE/DJK)*UNIT(M)
  300 CONTINUE
C
C     ----- SECOND COMPONENT OF THE BEND -----
C
      UP(1) = EJK(2)*UNIT(3)-EJK(3)*UNIT(2)
      UP(2) = EJK(3)*UNIT(1)-EJK(1)*UNIT(3)
      UP(3) = EJK(1)*UNIT(2)-EJK(2)*UNIT(1)
      DO 400 M = 1,3
         B1 = -UP(M)/DJI
         B2 = -UP(M)/DJK
         B(NOINT+1,NOCOL1+M) = B1
         B(NOINT+1,NOCOL2+M) = B2
         B(NOINT+1,NOCOL3+M) = -(B1+B2)
  400 CONTINUE
      RETURN
C
 9000 FORMAT(1X,'NO $LIBE INPUT DATA FOUND...THIS IS REQUIRED')
 9010 FORMAT(1X,'THE POINT A IS COLINEAR WITH I,J,K'/
     *    1X,'A=',3F15.8)
 9020 FORMAT(1X,'*** ROUNDOFF ERROR IN LIBE - TEST,DOTP=',2E20.10)
 9030 FORMAT(1X,'ONLY 5 LINEAR BENDS MAY BE USED --- ERROR')
 9040 FORMAT(1X,'Error reading input for linear bend info.',/,
     *       1X,'Call Bomb and Exit.')
 9050 FORMAT(1X,'End of file encountered during read of linear ',
     *          'bend infor.   Call Bomb and Exit.')
      END

      subroutine trans_t2_to_t2dagger(d_t2,k_t2_offset,d_y2,k_y2_offset)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
c
      integer d_t2,k_t2_offset
      integer d_y2,k_y2_offset
c
      integer p1b, p2b, h3b, h4b
      integer p1,  p2,  h3,  h4
      integer k_r2,l_r2,k_r2_sort,l_r2_sort,size
      integer i
c
      do p1b = noab+1,noab+nvab
      do p2b = p1b,noab+nvab
      do h3b = 1,noab
      do h4b = h3b,noab
         if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. 
     1       int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
         if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1       ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1)))) .eq. 
     1       irrep_t) then
         if ((.not.restricted).or.
     1       (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)
     1       +int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
c
             size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1               * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
             if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1       call errquit('trans_t2_to_t2dagger: ma problem',0,ma_err)
c
             if (.not.ma_push_get(mt_dbl,size,'r2_sort',l_r2_sort,
     1           k_r2_sort))
     1       call errquit('trans_t2_to_t2dagger: ma problem',0,ma_err)
c
             call get_hash_block(d_t2,dbl_mb(k_r2),size,
     1            int_mb(k_t2_offset), h4b-1+(h3b-1)*noab
     1            +(p2b-noab-1)*noab*noab+(p1b-noab-1)*noab*noab*nvab)
c
             i=0
             do p1=1,int_mb(k_range+p1b-1)
             do p2=1,int_mb(k_range+p2b-1)
             do h3=1,int_mb(k_range+h3b-1)
             do h4=1,int_mb(k_range+h4b-1)
                dbl_mb(k_r2_sort+p2-1+(p1-1)*int_mb(k_range+p2b-1)+
     1          (h4-1)*int_mb(k_range+p2b-1)*int_mb(k_range+p1b-1)+
     1          (h3-1)*int_mb(k_range+p2b-1)*int_mb(k_range+p1b-1)*
     1          int_mb(k_range+h4b-1)) = dbl_mb(k_r2+i)
                i=i+1
             enddo
             enddo
             enddo
             enddo
c
             call put_hash_block(d_y2,dbl_mb(k_r2_sort),size,
     1               int_mb(k_y2_offset),
     1               (p2b-noab-1)+(p1b-noab-1)*(nvab)+
     1               (h4b-1)*(nvab)*(nvab)+
     1               (h3b-1)*(nvab)*(nvab)*(noab))
c
            if (.not.ma_pop_stack(l_r2_sort))
     1      call errquit('trans_t2_to_t2dagger: ma problem',1,ma_err)
c
            if (.not.ma_pop_stack(l_r2))
     1      call errquit('trans_t2_to_t2dagger: ma problem',1,ma_err)
c
         endif
         endif
         endif
c
      enddo
      enddo
      enddo
      enddo
c
      end
c $Id: trans_t2_to_t2dagger.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: geodesic2.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************
*     *					*
*     *		geodesic2_init		*
*     *					*
*     ***********************************
*
*     Uses - geodesic common block
*

      subroutine geodesic2_init()
      implicit none
#include "errquit.fh"

#include "mafdecls.fh"
#include "geodesic2.fh"

*     **** local variables ****
      logical value
      integer npack1

*     **** external functions **** 
      integer  psi_ne,psi_neq
      external psi_ne,psi_neq
      logical  Dneall_m_allocate,Dneall_4m_allocate
      external Dneall_m_allocate,Dneall_4m_allocate

      call Pack_npack(1,npack1)
c      nemax = psi_neq(1)+psi_neq(2)
c      ne(1) = psi_neq(1)
c      ne(2) = psi_neq(2)

      value = MA_alloc_get(mt_dcpl,npack1*(psi_neq(1)+psi_neq(2)),
     >                     'Hold',Hold(2),Hold(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,npack1*(psi_neq(1)+psi_neq(2)),
     >                     'Q',Q(2),Q(1))
      value = value.and.Dneall_m_allocate(0,R)
      value = value.and.Dneall_m_allocate(0,A)
      value = value.and.Dneall_4m_allocate(0,V)
      value = value.and.Dneall_4m_allocate(0,W)

      value = value.and.
     >        MA_alloc_get(mt_dbl,2*(psi_ne(1)+psi_ne(2)),
     >                     'S',S(2),S(1))
      if (.not. value) call errquit('geodesic2_init:allocating heap',0,
     &       MA_ERR)

      return
      end

*     ***********************************
*     *					*
*     *		geodesic2_finalize	*
*     *					*
*     ***********************************
*
*     Uses - geodesic common block
*

      subroutine geodesic2_finalize()
      implicit none
#include "errquit.fh"

#include "mafdecls.fh"
#include "geodesic2.fh"

*     **** local variables ****
      logical value

      logical  Dneall_m_free
      external Dneall_m_free

      value =           MA_free_heap(S(2))   
      value = value.and.Dneall_m_free(W)
      value = value.and.Dneall_m_free(V)
      value = value.and.Dneall_m_free(A)
      value = value.and.Dneall_m_free(R)
      value = value.and.MA_free_heap(Q(2))
      value = value.and.MA_free_heap(Hold(2))
      if (.not. value) 
     >  call errquit('geodesic2_finalize:freeing heap memory',0,
     &       MA_ERR)

      return
      end



*     ***********************************
*     *					*
*     *		geodesic2_start		*
*     *					*
*     ***********************************
*
*     This routine determines the pxp matrices R and YA, and
* the orthogonal nxp matrix Q.   Q and R are determined from 
* the QR decomposition of the projected direction (I-YY^t)H, and
* YH is defined as the Lagrange Multiplier pxp matrix Y^tH.  
*
*     Uses - geodesic2 common block
*
      subroutine geodesic2_start(Y,H,max_sigma,dE)
      implicit none
      complex*16 Y(*)
      complex*16 H(*)
      real*8     max_sigma,dE

#include "mafdecls.fh"
#include "errquit.fh"
#include "geodesic2.fh"

*     **** local variables ****
      logical value
      integer npack1,nemax
      integer ms,n,ispin,ne(2)
      integer shift,shift2,i,j
      integer T(2)

*     **** external functions **** 
      logical  Dneall_4m_allocate,Dneall_m_free
      integer  psi_ispin,psi_neq
      real*8   electron_eorbit_noocc
      external Dneall_4m_allocate,Dneall_m_free
      external psi_ispin,psi_neq
      external electron_eorbit_noocc

      call nwpw_timing_start(10)
      call Pack_npack(1,npack1)
      nemax = psi_neq(1) + psi_neq(2)
      ispin = psi_ispin()
      ne(1) = psi_neq(1)
      ne(2) = psi_neq(2)

*     **** allocate tmp space ****
      value = Dneall_4m_allocate(0,T)
      if (.not. value) 
     >   call errquit('geodesic2_start: pushing stack',0, MA_ERR)

*     **** Hold <-- H ****
      call dcopy(2*npack1*nemax,H,1,dcpl_mb(Hold(1)),1)

*     **** calculate A=<Y|H> ****
      call Dneall_ffm_Multiply(0,Y,H,npack1,dbl_mb(A(1)))

*     **** calculate Q=(I-YYt)H - should not be necessary but just in case ****
      call Dneall_fmf_Multiply(0,Y,npack1,
     >                         dbl_mb(A(1)),1.0d0,
     >                         dcpl_mb(Q(1)),0.0d0)
      call daxpy(2*npack1*nemax,(-1.0d0),H,1,dcpl_mb(Q(1)),1)
      call dscal(2*npack1*nemax,(-1.0d0),dcpl_mb(Q(1)),1)

*     **** calculate QR using Modified Gram-Schmidt ****
      call Dneall_fm_QR(0,dcpl_mb(Q(1)),npack1,dbl_mb(R(1)))

*     **** generate T from A and R ****
*       -     -
*  T = |A, -R^t|
*      |R,  0  |
*       -     -
      call Dneall_AR_to_4m(0,dbl_mb(A(1)),dbl_mb(R(1)),dbl_mb(T(1)))

*     **** Factor T--> V,W,and S ****
      call Dneall_4m_FactorSkew(0, dbl_mb(T(1)),
     >                             dbl_mb(V(1)),
     >                             dbl_mb(W(1)),
     >                             dbl_mb(S(1)))

*     **** calculate dE ****
      dE = 2.0d0*electron_eorbit_noocc(H)


*     **** deallocate tmp space ****     
      value = Dneall_m_free(T)
      if (.not. value) 
     > call errquit('geodesic2_start:popping stack',1, MA_ERR)

      call nwpw_timing_end(10)
      return
      end

*     ***********************************
*     *					*
*     *	      geodesic2_generate_T	*
*     *					*
*     ***********************************
*
*     This routine determines T.  T is defined
* to be a 2nx2n skew symmetric matrix.
*
*       -     -
*  T = |A, -R^t|
*      |R,  0  |
*       -     -
*
*     Entry - n: dimension of matrices A and R
*             A: an nxn skew symmetric matrix
*             R: an nxn matrix
*     Exit - T: a 2nx2n skew symmetric matrix

      subroutine geodesic2_generate_T(n,A,R,T)
      implicit none
      integer n
      real*8 A(n,n)
      real*8 R(n,n)
      real*8 T(2*n,2*n)

*     **** local variables ****
      integer i,j

      call dcopy(4*n*n,0.0d0,0,T,1)
      
*     **** copy A to upper-left of T ****
      do j=1,n
      do i=1,n
         T(i,j) = A(i,j)
      end do
      end do

*     **** copy R to lower-left of T ****
      do j=1,n
      do i=1,n
         T(i+n,j) = R(i,j)
      end do
      end do

*     **** copy -R^t to upper-right of T ****
      do j=1,n
      do i=1,n
         T(i,j+n) = -R(j,i)
      end do
      end do

      return
      end 


*     ***********************************
*     *					*
*     *		geodesic2_get		*
*     *					*
*     ***********************************
*
*     This routine calculates 
*
*   Ynew = Yold*M(t) + Q*N(t)
*
*   where
*        -    -               - -
*       | M(t) | = Exp(t*T)* | I |
*       | N(t) |             | 0 |
*        -    -               - -
*
      subroutine geodesic2_get(t,Yold,Ynew)
      implicit none
      real*8     t
      complex*16 Yold(*)
      complex*16 Ynew(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "geodesic2.fh"

*     **** local variables ****
      logical value
      integer npack1,ispin,ne(2)
      integer ms,n,j,k,shift1,shift2
      integer MM(2),NN(2)

*     **** external functions ****
      logical  Dneall_m_push_get,Dneall_m_pop_stack
      external Dneall_m_push_get,Dneall_m_pop_stack


      call Pack_npack(1,npack1)

*     **** allocate tmp space ****
      value =           Dneall_m_push_get(0,MM)
      value = value.and.Dneall_m_push_get(0,NN)
      if (.not. value) 
     >   call errquit('geodesic2_get: pushing stack',0, MA_ERR)

      call geodesic2_get_MandN(t,dbl_mb(MM(1)),dbl_mb(NN(1)))

      call Dneall_fmf_Multiply(0,
     >                         Yold,npack1,
     >                         dbl_mb(MM(1)),
     >                         1.0d0,
     >                         Ynew,
     >                         0.0d0)
      call Dneall_fmf_Multiply(0,
     >                         dcpl_mb(Q(1)),npack1,
     >                         dbl_mb(NN(1)),
     >                         1.0d0,
     >                         Ynew,
     >                         1.0d0)

*     **** deallocate tmp space ****     
      value =           Dneall_m_pop_stack(NN)
      value = value.and.Dneall_m_pop_stack(MM)
      if (.not. value) 
     > call errquit('geodesic2_get:popping stack',1, MA_ERR)

      return
      end


*     ***********************************
*     *					*
*     *		geodesic2_transport	*
*     *					*
*     ***********************************
*
*     This routine calculates 
*
*   Hnew = Hold*M(t)    + Yold*R^t*N(t)
*
*   where
*        -    -               - -
*       | M(t) | = Exp(t*T)* | I |
*       | N(t) |             | 0 |
*        -    -               - -
*
      subroutine geodesic2_transport(t,Yold,Hnew)
      implicit none
#include "errquit.fh"
      real*8     t
      complex*16 Yold(*)
      complex*16 Hnew(*)

#include "mafdecls.fh"
#include "geodesic2.fh"


*     **** local variables ****
      logical value
      integer npack1
      integer MM(2),NN(2),TT(2)

*     **** external functions ****
      logical  Dneall_m_push_get,Dneall_m_pop_stack
      external Dneall_m_push_get,Dneall_m_pop_stack


      call Pack_npack(1,npack1)

*     **** allocate tmp space ****
      value =           Dneall_m_push_get(0,MM)
      value = value.and.Dneall_m_push_get(0,NN)
      value = value.and.Dneall_m_push_get(0,TT)
      if (.not. value) 
     >   call errquit('geodesic2_transport: pushing stack',0, MA_ERR)

      call geodesic2_get_MandN(t,dbl_mb(MM(1)),dbl_mb(NN(1)))

*     **** TT(t) = -R^t*NN(t) ****
      call Dneall_mmm_Multiply2ab(0,
     >                          dbl_mb(R(1)),
     >                          dbl_mb(NN(1)),
     >                          (-1.0d0),
     >                          dbl_mb(TT(1)),
     >                          0.0d0)


*     *** Hnew <-- Hold*M(t) + Yold*TT(t) ***
      call Dneall_fmf_Multiply(0,
     >                         dcpl_mb(Hold(1)),npack1,
     >                         dbl_mb(MM(1)),
     >                         1.0d0,
     >                         Hnew,
     >                         0.0d0)
      call Dneall_fmf_Multiply(0,
     >                         Yold,npack1,
     >                         dbl_mb(TT(1)),
     >                         1.0d0,
     >                         Hnew,
     >                         1.0d0)

*     **** deallocate tmp space ****    
      value =           Dneall_m_pop_stack(TT)
      value = value.and.Dneall_m_pop_stack(NN)
      value = value.and.Dneall_m_pop_stack(MM)
      if (.not. value) 
     > call errquit('geodesic2_transport:popping stack',1, MA_ERR)


      return
      end

      subroutine geodesic2_checkMN(name,n,MM,NN)
      implicit none
      character*(*) name
      integer n
      real*8 MM(n,n),NN(n,n)

*     **** local variables ****
      integer i,j,k
      real*8 tmp(n,n),sum

      do j=1,n
      do i=1,n
        sum = 0.0d0
        do k=1,n
          sum = sum + MM(k,i)*NN(k,j)
        end do
        tmp(i,j) = sum
      end do
      end do

      write(*,*)
      write(*,*) "checkMN:",name
      do i=1,n
        write(*,'(22F8.3)') (tmp(i,j),j=1,n)
      end do
      write(*,*)
      return
      end

*     ***********************************
*     *					*
*     *	      geodesic2_get_MandN	*
*     *					*
*     ***********************************
*
*   This routine returns 
*        -    -               - -
*       | M(t) | = Exp(t*T)* | I |
*       | N(t) |             | 0 |
*        -    -               - -
*   where 
* 
*      T =  U*Sigma*U^H, with U=(V+iW)
*
*      is a skew matrix that is decomposed into V,W,and Sigma
*      
      subroutine geodesic2_get_MandN(t,M,N)
      implicit none
      real*8 t
      real*8 M(*),N(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "geodesic2.fh"


*     **** local variables ****
      logical value
      integer ispin,ne(2)
      integer ms,i,j,nn,shift,shift2,shift3
      integer RR(2)

*     **** external functions ****
      logical  Dneall_4m_push_get,Dneall_m_pop_stack
      external Dneall_4m_push_get,Dneall_m_pop_stack

*     **** allocate tmp space ****
      value = Dneall_4m_push_get(0,RR)
      if (.not. value) 
     >   call errquit('geodesic2_get_MandN: pushing stack',0, MA_ERR)

      call Dneall_4m_RotateSkew(0,t,
     >                          dbl_mb(V(1)),
     >                          dbl_mb(W(1)),
     >                          dbl_mb(S(1)),
     >                          dbl_mb(RR(1)) )

      call Dneall_4m_to_MN(0,dbl_mb(RR(1)),M,N)

*     **** deallocate tmp space ****     
      value = Dneall_m_pop_stack(RR)
      if (.not. value) 
     > call errquit('geodesic2_get_MandN:popping stack',1, MA_ERR)

      return
      end

      subroutine fock_2e_cam( geom1, ao_basis, mfock, jfac, kfac,
     $           tol2e1, oskel1, vg_dens, vg_fock, asym, doxc )
c$Id: fock_2e_cam.F 25228 2014-02-04 00:25:33Z niri $
c
c     wrapper routine for ao_fock_2e and riscf_fock_2e
c
c
      implicit none
#include "errquit.fh"
c     !!! BGJ test !!!
#include "global.fh"
#include "bgj.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c     !!! BGJ test !!!
#include "cscf.fh"
#include "cfock.fh"
#include "bas.fh"
#include "util.fh"
#include "stdio.fh"

      integer geom1, ao_basis        ! [input] parameter handles
      integer nfock,mfock            ! [input] number of Fock matrices
      double precision tol2e1        ! [input] integral selection threshold
      logical oskel1                 ! [input] toggle skeleton Fock matrix
      integer vg_dens(mfock)         ! [input] array of handles to densities
      integer vg_fock(mfock)         ! [input] array of handles to Fock matrices
      logical asym                   ! [input] flag to antisymmetrize Fock matrices
      integer ifock      
      integer maxfocks
      parameter(maxfocks=1000)
      integer g_xc 
      double precision kfac(maxfocks), jfac(maxfocks),ffac
      double precision lfac(maxfocks)
      integer ga_create_atom_blocked
      integer vg_fockc
      integer dims(3), chunk(3),alo(3),ahi(3),blo(3),bhi(3)
      logical doxc
      integer rtdb
      double precision Exc(2)
      integer nExc
c
      external ga_create_atom_blocked
      logical xc_active, jfit,oprint,odft,cphf_uhf
c
c     Get a handle to the rtdb
      rtdb = bgj_get_rtdb_handle()
c
      oprint= util_print('fock_2e',print_debug)
      cphf_uhf = .false.
      if (.not. rtdb_get(bgj_get_rtdb_handle(), 
     &     'cphf_solve:cphf_uhf', mt_log, 1, cphf_uhf)) then
         cphf_uhf = .false.
      endif
      nfock = mfock
      if(cphf_uhf)nfock = 4
c
c     Make local copy of J and K prefactors in case we need to manipulate them
c
      if (nfock .gt. maxfocks) then
         call errquit('Dimens. assumption incorrect in fock_2e',nfock,
     &       UNKNOWN_ERR)
      endif
c
c     !!! BGJ test !!!
c
c     See if XC is active for this call
c
      if (.not.rtdb_get(bgj_get_rtdb_handle(),'bgj:xc_active',MT_LOG,1,
     &     xc_active)) xc_active = .false.
      if (oprint)
     &   write(luout,*)'*** fock_2e: xc_active ',xc_active
c
c     Set K contribution to be correct even for pure DFT and hybrids
c
      if (xc_active .and. bgj_have_xc()) then
         call dscal(nfock, bgj_kfac(), kfac, 1)
         if (oprint)
     &      write(luout,*)'*** fock_2e: set kfac to ',
     &        (kfac(ifock),ifock=1,nfock)
      endif
c
c     Determine whether J fitting is involved
c
      jfit = bgj_have_j_fit().and.(jfac(1).ne.0d0)
c !!! Edo commented this out before since it caused bugs - ask him about
c !!! it when it is necessary to turn back on for J fit CPKS
      jfit = .false.
c     !!! BGJ test !!!
      if (jfit) then
c
c     get the HF exchange part (must be replaced by DFT X)
c
         vg_fockc = ga_create_atom_blocked
     $        (geom1, ao_basis, 'fock_2e: vg_fockc')
         if (oprint)
     &      write(luout,*)'*** fock_2e: jfit case - original jfac = ',
     &        jfac(1)
cold         jfac(1)=0d0
cold         kfac(1)=-0.5d0*bgj_kfac()
         call ao_fock_2e( geom1, ao_basis, 1, 0d0, -0.5d0*bgj_kfac(),
     $        tol2e1, oskel1, vg_dens, vg_fock, asym )

         call fock_j_fit(nfock, vg_dens, vg_fockc)
         call ga_add(1.0d0, vg_fockc, 1.0d0, vg_fock,
     &        vg_fock)
         if (.not.ga_destroy(vg_fockc))
     .      call errquit('fock_2e: problem destroying test array',1,
     &       GA_ERR)
         return
      else if (nriscf.eq.10) then
        do ifock=1,nfock
            lfac(ifock)=0d0
        enddo
c
c       get HF exchange part in normal way
c
        call ao_fock_2e( geom1, ao_basis, nfock, lfac, kfac,
     $        tol2e1, oskel1, vg_dens, vg_fock, asym )
c
c       get HF coulomb part from RISCF integrals
c
        call riscf_fock_2e( geom1, ao_basis, riscf_basis, nfock,
     $       jfac, lfac, tol2e1, oskel1, vg_dens, vg_fock )
c
      else if (nriscf.gt.1) then
        call riscf_fock_2e( geom1, ao_basis, riscf_basis, nfock, 
     $       jfac, kfac, tol2e1, oskel1, vg_dens, vg_fock )
      else if (nriscf.eq.1) then
        if (rifock) then
          call riscf_fock_2e( geom1, ao_basis, riscf_basis, nfock, 
     $         jfac, kfac, tol2e1, oskel1, vg_dens, vg_fock )
        else
          call ao_fock_2e( geom1, ao_basis, nfock, jfac, kfac,
     $          tol2e1, oskel1, vg_dens, vg_fock,asym )
        endif
      else
         if (bgj_have_j_fit()) call fock_force_direct(rtdb)
         
         call ao_fock_2e( geom1, ao_basis, nfock, jfac, kfac,
     $                    tol2e1, oskel1, vg_dens, vg_fock, asym )
      endif

c     !!! BGJ test !!!

c !!! Exit if no XC part to do - this can be changed to just do XC
c !!! part and print it out for comparison by removing xc_active
c !!! from the test below
      if (.not. (xc_active .and. bgj_have_xc())) then
c         write(*,*)'*** fock_2e: no xc, returning'
         return
      endif
      if(nfock.ne.1.and.nfock.ne.4) then
         if(ga_nodeid().eq.0) then
            write(0,*) ' WARNING: likely restart: nfock = ',nfock
         endif
         if (.not.rtdb_put(bgj_get_rtdb_handle(),'bgj:xc_active',
     M        MT_LOG,1,.false.)) 
     C        call errquit(' fock2e: bgjrtdbput failed',0,0)
         return
      endif


c      write(*,*)'*** fock_2e: nfock =',nfock
      if (nfock.gt.maxfocks)
     &   call errquit('fock_2e: dimension error in test',0,
     &       UNKNOWN_ERR)
      if (.not. bas_numbf(ao_basis, nbf))
     &   call errquit('fock_2e: basis set error:', 86, BASIS_ERR)
      dims(1) = nfock
      dims(2) = nbf
      dims(3) = nbf
      chunk(1) = dims(1)
      chunk(2) = -1
      chunk(3) = -1
      if (.not. nga_create (MT_DBL, 3, dims, 'DFT CPKS RHS',chunk, 
     &     g_xc))
     &   call errquit('fock_2e: could not allocate g_xc',555, GA_ERR)
      call ga_zero(g_xc)
      if(oprint) then
         write(luout,*) 'fock2e: nfock ',nfock
         write(luout,*) 'fock2e: gdens ',vg_dens
         write(luout,*) 'fock2e: g_xc  ',g_xc
         write(luout,*) 'fock2e: g_xc  dims ',dims
      endif
c
c     works with nfock=1 for CS and nfock=4 for OS
c
      if(nfock.ne.1.and.nfock.ne.4) call errquit(
     &     '    fock_2e: unexpected nfock value = ',nfock, UNKNOWN_ERR)
       
      Exc(1) = 0.0d0
      Exc(2) = 0.0d0
      nExc = 1
      if (doxc) then
      call fock_xc(geom1, nbf,ao_basis,
     &             nfock, vg_dens, g_xc,Exc,nExc,.false.)
      ffac=1d0
      if (xc_active) then
         odft=nfock.eq.4
         ifock=1
         if(odft) ifock=2
         if (oprint)
     .        write(luout,*) 'f2e: Scaling XC matrix',
     ,        ifock,' by',ffac
         alo(1) = ifock
         ahi(1) = ifock
         alo(2) = 1
         ahi(2) = nbf
         alo(3) = 1
         ahi(3) = nbf
         blo(1) = 1
         bhi(1) = nbf
         blo(2) = 1
         bhi(2) = nbf
         blo(3)=-33
         bhi(3)=-33
         call nga_add_patch(ffac,g_xc,alo,ahi,
     .        1d0,vg_fock(ifock),blo,bhi,
     .        vg_fock(ifock),blo,bhi)
         if (oprint) then
            write(luout,*)'*** fock_2e: fock matrix',ifock
            call ga_print(vg_fock(ifock))
         endif
         if(odft) then
            ifock=4
            if (oprint)
     .           write(luout,*) 'f2e: Scaling XC matrix',
     ,           ifock,' by',ffac
            alo(1) = ifock
            ahi(1) = ifock
            call nga_add_patch(ffac,g_xc,alo,ahi,
     .           1d0,vg_fock(ifock),blo,bhi,
     .           vg_fock(ifock),blo,bhi)
            if (oprint) then
               write(luout,*)'*** fock_2e: fock matrix',ifock
               call ga_print(vg_fock(ifock))
            endif
         endif
c         
      endif !xc_active
      end if  ! doxc
c
      if (xc_active) then
        if (.not.ga_destroy(g_xc)) then
            call errquit('fock_2e: problem destroying test array',1,
     &       GA_ERR)
        endif
      end if ! xc_active
c
      return
      end

      SUBROUTINE ccsdt_lr_alpha2_7_12_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdt_lr_alpha2_7_12_1.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h13 p10 h12 p1 )_ytrbt + = 1 * Sum ( h7 h8 p5 ) * t ( p5 p10 h7 h8 )_t * i3 ( h7 h8 h13 h12 p1 p5 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p10b
      INTEGER h13b
      INTEGER h12b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h7b
      INTEGER h8b
      INTEGER p10b_1
      INTEGER p5b_1
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER h13b_2
      INTEGER h7b_2
      INTEGER h8b_2
      INTEGER h12b_2
      INTEGER p1b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p10b = noab+1,noab+nvab
      DO h13b = 1,noab
      DO h12b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h13b-1)+int_mb(k_spin+p10b
     &-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      IF (int_mb(k_spin+h13b-1)+int_mb(k_spin+p10b-1) .eq. int_mb(k_spin
     &+h12b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+p10b-1),ieor(int_m
     &b(k_sym+h12b-1),int_mb(k_sym+p1b-1)))) .eq. ieor(irrep_y,ieor(irre
     &p_trb,irrep_t))) THEN
      dimc = int_mb(k_range+h13b-1) * int_mb(k_range+p10b-1) * int_mb(k_
     &range+h12b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_7_12_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h7b = 1,noab
      DO h8b = h7b,noab
      IF (int_mb(k_spin+p10b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+
     &h7b-1)+int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p10b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+h7b-1),int_mb(k_sym+h8b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p10b,p5b,h7b,h8b,p10b_1,p5b_1,h7b_1,h8b_1)
      CALL TCE_RESTRICTED_6(h13b,h7b,h8b,h12b,p1b,p5b,h13b_2,h7b_2,h8b_2
     &,h12b_2,p1b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h7b-1) * int_m
     &b(k_range+h8b-1)
      dima_sort = int_mb(k_range+p10b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h13b-1) * int_mb(k_range+h12b-1) * int_
     &mb(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_7_12_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_7_12_1',2,MA_ERR)
      IF ((p5b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1
     &),2,4,3,1,1.0d0)
      END IF
      IF ((p10b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p10b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1
     &),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha2_7_12_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_7_12_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_7_12_1',5,MA_ERR)
      IF ((h8b .le. h13b) .and. (h12b .le. p5b) .and. (p5b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h13b_2 - 1 + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h13b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h8b .le. h13b) .and. (p1b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h13b_2 - 1 + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h13b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),5,4,3,2,1,6,1.0d0)
      END IF
      IF ((h7b .le. h13b) .and. (h13b .lt. h8b) .and. (h12b .le. p5b) .a
     &nd. (p5b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h13b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h13b-1),int_mb(k_range+h8b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),6,4,2,3,1,5,1.0d0)
      END IF
      IF ((h7b .le. h13b) .and. (h13b .lt. h8b) .and. (p1b .le. p5b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h13b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h13b-1),int_mb(k_range+h8b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),5,4,2,3,1,6,-1.0d0)
      END IF
      IF ((h13b .lt. h7b) .and. (h12b .le. p5b) .and. (p5b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h7b_2 - 1 + noab * (h13b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h13b-1
     &),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),6,4,1,3,2,5,-1.0d0)
      END IF
      IF ((h13b .lt. h7b) .and. (p1b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h7b_2 - 1 + noab * (h13b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h13b-1
     &),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),5,4,1,3,2,6,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha2_7_12_1',
     &6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h7b .eq. h8b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_7_1
     &2_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_7_1
     &2_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_7_12_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h13b-1),int_mb(k_range+p10b
     &-1),3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h12b - 1 + noab * (p10b - noab - 1 + nvab * (h
     &13b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha2_7_12_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_7_1
     &2_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine hf2d_3a(
     &    Axyz,Aprims,Acoefs,NPA,NCA,La,ictra,
     &    Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    bERI,Nint,canAB,canCD,canPQ,dryrun,
     &    W0,maxW0)
C $Id: hf2d_3a.F 19696 2010-10-29 16:53:42Z d3y133 $
      Implicit None
      Logical canAB,canCD,canPQ,dryrun
      
c--> Cartesian Coordinates, Primitives & Contraction Coefficients
      
      Integer La, Lb, Lc, Ld, Nint, MaxW0
      Integer NPA, NCA, NPB, NCB, NPC, NCC, NPD, NCD
      Double Precision Axyz(3),Aprims(NPA),Acoefs(NPA,NCA)
      Double Precision Bxyz(3),Bprims(NPB),Bcoefs(NPB,NCB)
      Double Precision Cxyz(3),Cprims(NPC),Ccoefs(NPC,NCC)
      Double Precision Dxyz(3),Dprims(NPD),Dcoefs(NPD,NCD)
      Integer ictra,ictrb,ictrc,ictrd
c--> Block of Electron Repulsion Integrals
      
      Double Precision bERI(Nint,*)
      
c--> Scratch Space
      
      Double Precision W0(maxW0)
c
      integer npa1, npa2, npa3
      integer a_exp, a_cof
      integer maxw0new, k0s, icont, kaddint, pw0
      integer mem1add, mem1
      integer mem2add, mem2
      integer mem3add, mem3
c
      npa1  = npa/3
      npa2  = npa1
      if (mod(npa,3).eq.1) then
        npa1 = npa1 + 1
      elseif(mod(npa,3).eq.2) then
        npa1 = npa1 + 1
        npa2 = npa1
      endif
      npa3  = npa - npa1 - npa2        ! size of third block
c... do first block     (a1|*)
      a_exp = 1                 ! exponent block
      a_cof = a_exp + npa1      ! coeff block
      k0s  = a_cof + npa1*NCA   ! start of scratch
      maxw0new = maxw0 - k0s    ! new scratch size
      call dcopy(npa1,Aprims,1,W0(a_exp),1) ! copy exponents

      mem1    = k0s         ! take care of compiler warnings
      mem2    = k0s
      mem1add = mem1
      mem2add = mem2
      mem3add = mem2

      if (dryrun) then
        mem1add = k0s
      else
        do 00100 icont = 1,NCA
          pw0 = a_cof+(icont-1)*npa1
          call dcopy(npa1,Acoefs(1,icont),1,W0(pw0),1) ! copy coeffs
00100   continue
      endif
c
      call hf2dold(
     &    Axyz,W0(a_exp),W0(a_cof),NPA1,NCA,La,ictra,
     &    Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    bERI,Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) mem1 = maxW0new + mem1add
c... do second block  (a2|*)
      a_exp    = 1
      a_cof    = a_exp + npa2
      kaddint = a_cof + npa2*NCA
      k0s     = kaddint + 12*nint
      maxw0new = maxw0 - k0s
      if (dryrun) then
        mem2add = k0s
      else
        call dcopy(npa2,Aprims(npa1+1),1,W0(a_exp),1)
        do 00200 icont = 1,NCA
          pw0 = a_cof+(icont-1)*npa2
          call dcopy(npa2,Acoefs((npa1+1),icont),1,W0(pw0),1)
00200   continue
      endif
      call hf2dold(
     &    Axyz,W0(a_exp),W0(a_cof),NPA2,NCA,La,ictra,
     &    Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    W0(kaddint),Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) then
        mem2 = maxW0new + mem2add
      else
c... sum 1,2 blocks
        call daxpy((nint*12),1.0d00,w0(kaddint),1,beri,1)
      endif
c... do third block  (a2|*)
      a_exp    = 1
      a_cof    = a_exp + npa3
      kaddint = a_cof + npa3*NCA
      k0s     = kaddint + 12*nint
      maxw0new = maxw0 - k0s
      if (dryrun) then
        mem3add = k0s
      else
        call dcopy(npa3,Aprims(npa1+npa2+1),1,W0(a_exp),1)
        do 00300 icont = 1,NCA
          pw0 = a_cof+(icont-1)*npa3
          call dcopy(npa3,Acoefs((npa1+npa2+1),icont),1,W0(pw0),1)
00300   continue
      endif
      call hf2dold(
     &    Axyz,W0(a_exp),W0(a_cof),NPA3,NCA,La,ictra,
     &    Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    W0(kaddint),Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) then
        mem3 = maxw0new + mem3add
        maxw0 = max(mem1,mem2,mem3)
      else
c... sum both blocks
        call daxpy((nint*12),1.0d00,w0(kaddint),1,beri,1)
      endif
      end

      subroutine argos_pme_sync(number,nodes)
c
      implicit none
c
      integer number
      integer nodes(number)
c
      external mxcombv1,argos_pme_synop
      integer mxcombv1,argos_pme_synop
c
      integer ires
      real*8 datum,buffer
c
      datum=0.0d0
      ires=mxcombv1(datum,argos_pme_synop,8,1,number,nodes,123,buffer)
c
      return
      end
c $Id: argos_pme_sync.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_ndxtrd(id,idx,jdx,n)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer id,n
      integer idx(n),jdx(n)
c
      if(n.gt.mtt(id)) call md_abort('Error in ndxtrd',0)
c
      if(id.eq.1) then
      call argos_cafe_icopy(idx,jdx,n,int_mb(i_itrd(id)),mtt(id))
      else
c      call argos_cafe_jcopy(idx,jdx,n,int_mb(i_itrd(id)),mtt(id))
c      call argos_cafe_index(int_mb(i_itrd(id)),mtt(id))
      call argos_cafe_ncopy(idx,jdx,n,int_mb(i_itrd(id)),mtt(id))
      endif
c
      return
      end
c $Id: argos_cafe_ndxtrd.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_diana_hbond_init(snam,ibnd,ihbnd)
c
c $Id: argos_diana_hbond.F
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
c
      character*16 snam(msa)
      integer ibnd(msb,2),ihbnd(msa)
c
      integer i,j,k
c
      if(np.gt.1)
     + call md_abort('h-bond analysis on single processor only',0)
c
      do 1 i=1,nsa
      ihbnd(i)=0
    1 continue
c
      do 2 j=1,2
      do 3 i=1,msb
      if(snam(ibnd(i,j))(6:7).eq.' O'.or.
     + snam(ibnd(i,j))(6:7).eq.' N'.or.
     + snam(ibnd(i,j))(6:7).eq.' S') ihbnd(ibnd(i,j))=-1
    3 continue
    2 continue
c
      do 4 j=1,2
      k=2
      if(j.eq.2) k=1
      do 5 i=1,msb
      if(ihbnd(ibnd(i,k)).eq.-1) then
      if(snam(ibnd(i,j))(6:7).eq.' H'.or.
     + snam(ibnd(i,j))(6:7).eq.'2H'.or.
     + snam(ibnd(i,j))(6:7).eq.'3H'.or.
     + snam(ibnd(i,j))(6:7).eq.'4H'.or.
     + snam(ibnd(i,j))(6:7).eq.'5H'.or.
     + snam(ibnd(i,j))(6:7).eq.'6H'.or.
     + snam(ibnd(i,j))(6:7).eq.'7H'.or.
     + snam(ibnd(i,j))(6:7).eq.'8H'.or.
     + snam(ibnd(i,j))(6:7).eq.'9H') ihbnd(ibnd(i,j))=ibnd(i,k)
      endif
    5 continue
    4 continue
c
      do 6 i=1,nwa
      ihbndw(i)=0
    6 continue
c
      do 7 j=1,2
      do 8 i=1,mwb
      if(wnam(ibndw(i,j))(6:7).eq.' O'.or.
     + wnam(ibndw(i,j))(6:7).eq.' N'.or.
     + wnam(ibndw(i,j))(6:7).eq.' S') ihbndw(ibnd(i,j))=-1
    8 continue
    7 continue
c
      do 9 j=1,2
      k=2
      if(j.eq.2) k=1
      do 10 i=1,mwb
      if(ihbndw(ibndw(i,k)).eq.-1) then
      if(wnam(ibndw(i,j))(6:7).eq.' H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'2H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'3H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'4H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'5H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'6H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'7H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'8H'.or.
     + wnam(ibndw(i,j))(6:7).eq.'9H') ihbndw(ibndw(i,j))=ibndw(i,k)
      endif
   10 continue
    9 continue
c
      return
      end

C Taken task_ncc out of the TASK module as it seems not to be used
C anywhere.
C  \ingroup task
C  @{
      logical function task_ncc(rtdb)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb
c
      logical stat
      logical ncc_driver
      external ncc_driver
      character*32 theory
c
c      print*,'top of task_ncc'
c
      task_ncc = .false.
c
      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $ call errquit('task_ncc: theory not specified',0, RTDB_ERR)
c
      if (theory .eq. 'ncc') then
        if (.not. ncc_driver(rtdb) ) then
          call errquit('task_ncc: ncc_driver failed',0,RTDB_ERR)
        else
          task_ncc = .true.
        endif
      else 
        call errquit('task_ncc: only valid for ncc',0,RTDB_ERR)
      endif
c
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, stat)) then
        call errquit('task_ncc: failed to store stat',0,RTDB_ERR)
      endif
c
c      print*,'end of task_ncc'
c
      end
C  @}
c $Id: task_ncc.F 22852 2012-09-13 16:38:20Z d3y133 $

      SUBROUTINE ccsdt_lr_beta_2_8_11(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdt_lr_beta_2_8_11.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p11 p12 h14 h15 )_ytrbtra + = -1 * Sum ( h9 p7 ) * tra ( p7 p12 h9 h15 )_tra * i2 ( h9 p11 h14 p7 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p12b
      INTEGER p11b
      INTEGER h15b
      INTEGER h14b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h9b
      INTEGER p12b_1
      INTEGER p7b_1
      INTEGER h15b_1
      INTEGER h9b_1
      INTEGER p11b_2
      INTEGER h9b_2
      INTEGER h14b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p12b = noab+1,noab+nvab
      DO p11b = noab+1,noab+nvab
      DO h15b = 1,noab
      DO h14b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p11b-1)+int_mb(k_spin+p12b
     &-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h15b-1).ne.8)) THEN
      IF (int_mb(k_spin+p11b-1)+int_mb(k_spin+p12b-1) .eq. int_mb(k_spin
     &+h14b-1)+int_mb(k_spin+h15b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_m
     &b(k_sym+h14b-1),int_mb(k_sym+h15b-1)))) .eq. ieor(irrep_y,ieor(irr
     &ep_trb,irrep_tra))) THEN
      dimc = int_mb(k_range+p11b-1) * int_mb(k_range+p12b-1) * int_mb(k_
     &range+h14b-1) * int_mb(k_range+h15b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_8_11',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO h9b = 1,noab
      IF (int_mb(k_spin+p12b-1)+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+
     &h15b-1)+int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb
     &(k_sym+h15b-1),int_mb(k_sym+h9b-1)))) .eq. irrep_tra) THEN
      CALL TCE_RESTRICTED_4(p12b,p7b,h15b,h9b,p12b_1,p7b_1,h15b_1,h9b_1)
      CALL TCE_RESTRICTED_4(p11b,h9b,h14b,p7b,p11b_2,h9b_2,h14b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+h9b-1)
      dima_sort = int_mb(k_range+p12b-1) * int_mb(k_range+h15b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p11b-1) * int_mb(k_range+h14b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_8_11',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_8_11',2,MA_ERR)
      IF ((p7b .le. p12b) .and. (h9b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p12b_1 - noab - 1 + nvab * (p7
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h15b-
     &1),4,2,3,1,1.0d0)
      END IF
      IF ((p7b .le. p12b) .and. (h15b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (p12b_1 - noab - 1 + nvab * (p7
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+h15b-1),int_mb(k_range+h9b-
     &1),3,2,4,1,-1.0d0)
      END IF
      IF ((p12b .lt. p7b) .and. (h9b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p7b_1 - noab - 1 + nvab * (p12
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1),int_mb(k_range+h15b-
     &1),4,1,3,2,-1.0d0)
      END IF
      IF ((p12b .lt. p7b) .and. (h15b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (p7b_1 - noab - 1 + nvab * (p12
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h15b-1),int_mb(k_range+h9b-
     &1),3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_beta_2_8_11',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_8_11',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_8_11',5,MA_ERR)
      IF ((h9b .le. p11b) .and. (h14b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (h14b_2 - 1 + noab * (p11b_2 - noab - 1 + nva
     &b * (h9b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+h14b-1),int_mb(k_range+p7b-
     &1),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_beta_2_8_11',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_8_1
     &1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_8_1
     &1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_8_11',9,MA_ERR)
      IF ((p11b .le. p12b) .and. (h14b .le. h15b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+h15b-1),int_mb(k_range+p12
     &b-1),2,4,1,3,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h14b - 1 + noab * (p12b - noab - 1 + nvab * (p11b - 
     &noab - 1)))))
      END IF
      IF ((p11b .le. p12b) .and. (h15b .le. h14b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+h15b-1),int_mb(k_range+p12
     &b-1),2,4,3,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h14b 
     &- 1 + noab * (h15b - 1 + noab * (p12b - noab - 1 + nvab * (p11b - 
     &noab - 1)))))
      END IF
      IF ((p12b .le. p11b) .and. (h14b .le. h15b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+h15b-1),int_mb(k_range+p12
     &b-1),4,2,1,3,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h14b - 1 + noab * (p11b - noab - 1 + nvab * (p12b - 
     &noab - 1)))))
      END IF
      IF ((p12b .le. p11b) .and. (h15b .le. h14b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+h15b-1),int_mb(k_range+p12
     &b-1),4,2,3,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h14b 
     &- 1 + noab * (h15b - 1 + noab * (p11b - noab - 1 + nvab * (p12b - 
     &noab - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_beta_2_8_11',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_8_1
     &1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_cafe_print_top(lfnout,npatom,nptopw,nptops)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer lfnout,npatom,nptopw,nptops
c
      if(me.eq.0) then
      write(lfnout,1000)
 1000 format(/,' TOPOLOGY')
c
      if(npatom.ne.0) then
      call argos_cafe_print_atypes(lfnout,byte_mb(i_nam),int_mb(i_num),
     + dbl_mb(i_mas),dbl_mb(i_vdw))
      call argos_cafe_print_ctypes(lfnout,dbl_mb(i_chg))
      endif
c      call argos_cafe_print_solvent(lfnout)
      if(nptops.ne.0) then
      call argos_cafe_print_solute(lfnout,int_mb(i_imul))
      endif
      endif
c
      return
      end
c $Id: argos_cafe_print_top.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE tce_dens_pp_offset(l_a_offset,k_a_offset,size)
c     written by Peng-Dong Fan on 07/25/2007
c     dens_pp ( p5 p6 )
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+p6b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+p6b-1)) .eq. irrep_t) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_dens_pp_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+p6b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+p6b-1)) .eq. irrep_t) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = (p6b-noab-1) + nvab * (p5b - noab - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
c $Id: tce_dens_pp_offset.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b ZLABRD reduces the first nb rows and columns of a general matrix to a bidiagonal form.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZLABRD + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zlabrd.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zlabrd.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zlabrd.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZLABRD( M, N, NB, A, LDA, D, E, TAUQ, TAUP, X, LDX, Y,
*                          LDY )
* 
*       .. Scalar Arguments ..
*       INTEGER            LDA, LDX, LDY, M, N, NB
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   D( * ), E( * )
*       COMPLEX*16         A( LDA, * ), TAUP( * ), TAUQ( * ), X( LDX, * ),
*      $                   Y( LDY, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZLABRD reduces the first NB rows and columns of a complex general
*> m by n matrix A to upper or lower real bidiagonal form by a unitary
*> transformation Q**H * A * P, and returns the matrices X and Y which
*> are needed to apply the transformation to the unreduced part of A.
*>
*> If m >= n, A is reduced to upper bidiagonal form; if m < n, to lower
*> bidiagonal form.
*>
*> This is an auxiliary routine called by ZGEBRD
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows in the matrix A.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns in the matrix A.
*> \endverbatim
*>
*> \param[in] NB
*> \verbatim
*>          NB is INTEGER
*>          The number of leading rows and columns of A to be reduced.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX*16 array, dimension (LDA,N)
*>          On entry, the m by n general matrix to be reduced.
*>          On exit, the first NB rows and columns of the matrix are
*>          overwritten; the rest of the array is unchanged.
*>          If m >= n, elements on and below the diagonal in the first NB
*>            columns, with the array TAUQ, represent the unitary
*>            matrix Q as a product of elementary reflectors; and
*>            elements above the diagonal in the first NB rows, with the
*>            array TAUP, represent the unitary matrix P as a product
*>            of elementary reflectors.
*>          If m < n, elements below the diagonal in the first NB
*>            columns, with the array TAUQ, represent the unitary
*>            matrix Q as a product of elementary reflectors, and
*>            elements on and above the diagonal in the first NB rows,
*>            with the array TAUP, represent the unitary matrix P as
*>            a product of elementary reflectors.
*>          See Further Details.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (NB)
*>          The diagonal elements of the first NB rows and columns of
*>          the reduced matrix.  D(i) = A(i,i).
*> \endverbatim
*>
*> \param[out] E
*> \verbatim
*>          E is DOUBLE PRECISION array, dimension (NB)
*>          The off-diagonal elements of the first NB rows and columns of
*>          the reduced matrix.
*> \endverbatim
*>
*> \param[out] TAUQ
*> \verbatim
*>          TAUQ is COMPLEX*16 array dimension (NB)
*>          The scalar factors of the elementary reflectors which
*>          represent the unitary matrix Q. See Further Details.
*> \endverbatim
*>
*> \param[out] TAUP
*> \verbatim
*>          TAUP is COMPLEX*16 array, dimension (NB)
*>          The scalar factors of the elementary reflectors which
*>          represent the unitary matrix P. See Further Details.
*> \endverbatim
*>
*> \param[out] X
*> \verbatim
*>          X is COMPLEX*16 array, dimension (LDX,NB)
*>          The m-by-nb matrix X required to update the unreduced part
*>          of A.
*> \endverbatim
*>
*> \param[in] LDX
*> \verbatim
*>          LDX is INTEGER
*>          The leading dimension of the array X. LDX >= max(1,M).
*> \endverbatim
*>
*> \param[out] Y
*> \verbatim
*>          Y is COMPLEX*16 array, dimension (LDY,NB)
*>          The n-by-nb matrix Y required to update the unreduced part
*>          of A.
*> \endverbatim
*>
*> \param[in] LDY
*> \verbatim
*>          LDY is INTEGER
*>          The leading dimension of the array Y. LDY >= max(1,N).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complex16OTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The matrices Q and P are represented as products of elementary
*>  reflectors:
*>
*>     Q = H(1) H(2) . . . H(nb)  and  P = G(1) G(2) . . . G(nb)
*>
*>  Each H(i) and G(i) has the form:
*>
*>     H(i) = I - tauq * v * v**H  and G(i) = I - taup * u * u**H
*>
*>  where tauq and taup are complex scalars, and v and u are complex
*>  vectors.
*>
*>  If m >= n, v(1:i-1) = 0, v(i) = 1, and v(i:m) is stored on exit in
*>  A(i:m,i); u(1:i) = 0, u(i+1) = 1, and u(i+1:n) is stored on exit in
*>  A(i,i+1:n); tauq is stored in TAUQ(i) and taup in TAUP(i).
*>
*>  If m < n, v(1:i) = 0, v(i+1) = 1, and v(i+1:m) is stored on exit in
*>  A(i+2:m,i); u(1:i-1) = 0, u(i) = 1, and u(i:n) is stored on exit in
*>  A(i,i+1:n); tauq is stored in TAUQ(i) and taup in TAUP(i).
*>
*>  The elements of the vectors v and u together form the m-by-nb matrix
*>  V and the nb-by-n matrix U**H which are needed, with X and Y, to apply
*>  the transformation to the unreduced part of the matrix, using a block
*>  update of the form:  A := A - V*Y**H - X*U**H.
*>
*>  The contents of A on exit are illustrated by the following examples
*>  with nb = 2:
*>
*>  m = 6 and n = 5 (m > n):          m = 5 and n = 6 (m < n):
*>
*>    (  1   1   u1  u1  u1 )           (  1   u1  u1  u1  u1  u1 )
*>    (  v1  1   1   u2  u2 )           (  1   1   u2  u2  u2  u2 )
*>    (  v1  v2  a   a   a  )           (  v1  1   a   a   a   a  )
*>    (  v1  v2  a   a   a  )           (  v1  v2  a   a   a   a  )
*>    (  v1  v2  a   a   a  )           (  v1  v2  a   a   a   a  )
*>    (  v1  v2  a   a   a  )
*>
*>  where a denotes an element of the original matrix which is unchanged,
*>  vi denotes an element of the vector defining H(i), and ui an element
*>  of the vector defining G(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE ZLABRD( M, N, NB, A, LDA, D, E, TAUQ, TAUP, X, LDX, Y,
     $                   LDY )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            LDA, LDX, LDY, M, N, NB
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), E( * )
      COMPLEX*16         A( LDA, * ), TAUP( * ), TAUQ( * ), X( LDX, * ),
     $                   Y( LDY, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ),
     $                   ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX*16         ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZGEMV, ZLACGV, ZLARFG, ZSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( M.LE.0 .OR. N.LE.0 )
     $   RETURN
*
      IF( M.GE.N ) THEN
*
*        Reduce to upper bidiagonal form
*
         DO 10 I = 1, NB
*
*           Update A(i:m,i)
*
            CALL ZLACGV( I-1, Y( I, 1 ), LDY )
            CALL ZGEMV( 'No transpose', M-I+1, I-1, -ONE, A( I, 1 ),
     $                  LDA, Y( I, 1 ), LDY, ONE, A( I, I ), 1 )
            CALL ZLACGV( I-1, Y( I, 1 ), LDY )
            CALL ZGEMV( 'No transpose', M-I+1, I-1, -ONE, X( I, 1 ),
     $                  LDX, A( 1, I ), 1, ONE, A( I, I ), 1 )
*
*           Generate reflection Q(i) to annihilate A(i+1:m,i)
*
            ALPHA = A( I, I )
            CALL ZLARFG( M-I+1, ALPHA, A( MIN( I+1, M ), I ), 1,
     $                   TAUQ( I ) )
            D( I ) = ALPHA
            IF( I.LT.N ) THEN
               A( I, I ) = ONE
*
*              Compute Y(i+1:n,i)
*
               CALL ZGEMV( 'Conjugate transpose', M-I+1, N-I, ONE,
     $                     A( I, I+1 ), LDA, A( I, I ), 1, ZERO,
     $                     Y( I+1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', M-I+1, I-1, ONE,
     $                     A( I, 1 ), LDA, A( I, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL ZGEMV( 'No transpose', N-I, I-1, -ONE, Y( I+1, 1 ),
     $                     LDY, Y( 1, I ), 1, ONE, Y( I+1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', M-I+1, I-1, ONE,
     $                     X( I, 1 ), LDX, A( I, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', I-1, N-I, -ONE,
     $                     A( 1, I+1 ), LDA, Y( 1, I ), 1, ONE,
     $                     Y( I+1, I ), 1 )
               CALL ZSCAL( N-I, TAUQ( I ), Y( I+1, I ), 1 )
*
*              Update A(i,i+1:n)
*
               CALL ZLACGV( N-I, A( I, I+1 ), LDA )
               CALL ZLACGV( I, A( I, 1 ), LDA )
               CALL ZGEMV( 'No transpose', N-I, I, -ONE, Y( I+1, 1 ),
     $                     LDY, A( I, 1 ), LDA, ONE, A( I, I+1 ), LDA )
               CALL ZLACGV( I, A( I, 1 ), LDA )
               CALL ZLACGV( I-1, X( I, 1 ), LDX )
               CALL ZGEMV( 'Conjugate transpose', I-1, N-I, -ONE,
     $                     A( 1, I+1 ), LDA, X( I, 1 ), LDX, ONE,
     $                     A( I, I+1 ), LDA )
               CALL ZLACGV( I-1, X( I, 1 ), LDX )
*
*              Generate reflection P(i) to annihilate A(i,i+2:n)
*
               ALPHA = A( I, I+1 )
               CALL ZLARFG( N-I, ALPHA, A( I, MIN( I+2, N ) ), LDA,
     $                      TAUP( I ) )
               E( I ) = ALPHA
               A( I, I+1 ) = ONE
*
*              Compute X(i+1:m,i)
*
               CALL ZGEMV( 'No transpose', M-I, N-I, ONE, A( I+1, I+1 ),
     $                     LDA, A( I, I+1 ), LDA, ZERO, X( I+1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', N-I, I, ONE,
     $                     Y( I+1, 1 ), LDY, A( I, I+1 ), LDA, ZERO,
     $                     X( 1, I ), 1 )
               CALL ZGEMV( 'No transpose', M-I, I, -ONE, A( I+1, 1 ),
     $                     LDA, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL ZGEMV( 'No transpose', I-1, N-I, ONE, A( 1, I+1 ),
     $                     LDA, A( I, I+1 ), LDA, ZERO, X( 1, I ), 1 )
               CALL ZGEMV( 'No transpose', M-I, I-1, -ONE, X( I+1, 1 ),
     $                     LDX, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL ZSCAL( M-I, TAUP( I ), X( I+1, I ), 1 )
               CALL ZLACGV( N-I, A( I, I+1 ), LDA )
            END IF
   10    CONTINUE
      ELSE
*
*        Reduce to lower bidiagonal form
*
         DO 20 I = 1, NB
*
*           Update A(i,i:n)
*
            CALL ZLACGV( N-I+1, A( I, I ), LDA )
            CALL ZLACGV( I-1, A( I, 1 ), LDA )
            CALL ZGEMV( 'No transpose', N-I+1, I-1, -ONE, Y( I, 1 ),
     $                  LDY, A( I, 1 ), LDA, ONE, A( I, I ), LDA )
            CALL ZLACGV( I-1, A( I, 1 ), LDA )
            CALL ZLACGV( I-1, X( I, 1 ), LDX )
            CALL ZGEMV( 'Conjugate transpose', I-1, N-I+1, -ONE,
     $                  A( 1, I ), LDA, X( I, 1 ), LDX, ONE, A( I, I ),
     $                  LDA )
            CALL ZLACGV( I-1, X( I, 1 ), LDX )
*
*           Generate reflection P(i) to annihilate A(i,i+1:n)
*
            ALPHA = A( I, I )
            CALL ZLARFG( N-I+1, ALPHA, A( I, MIN( I+1, N ) ), LDA,
     $                   TAUP( I ) )
            D( I ) = ALPHA
            IF( I.LT.M ) THEN
               A( I, I ) = ONE
*
*              Compute X(i+1:m,i)
*
               CALL ZGEMV( 'No transpose', M-I, N-I+1, ONE, A( I+1, I ),
     $                     LDA, A( I, I ), LDA, ZERO, X( I+1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', N-I+1, I-1, ONE,
     $                     Y( I, 1 ), LDY, A( I, I ), LDA, ZERO,
     $                     X( 1, I ), 1 )
               CALL ZGEMV( 'No transpose', M-I, I-1, -ONE, A( I+1, 1 ),
     $                     LDA, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL ZGEMV( 'No transpose', I-1, N-I+1, ONE, A( 1, I ),
     $                     LDA, A( I, I ), LDA, ZERO, X( 1, I ), 1 )
               CALL ZGEMV( 'No transpose', M-I, I-1, -ONE, X( I+1, 1 ),
     $                     LDX, X( 1, I ), 1, ONE, X( I+1, I ), 1 )
               CALL ZSCAL( M-I, TAUP( I ), X( I+1, I ), 1 )
               CALL ZLACGV( N-I+1, A( I, I ), LDA )
*
*              Update A(i+1:m,i)
*
               CALL ZLACGV( I-1, Y( I, 1 ), LDY )
               CALL ZGEMV( 'No transpose', M-I, I-1, -ONE, A( I+1, 1 ),
     $                     LDA, Y( I, 1 ), LDY, ONE, A( I+1, I ), 1 )
               CALL ZLACGV( I-1, Y( I, 1 ), LDY )
               CALL ZGEMV( 'No transpose', M-I, I, -ONE, X( I+1, 1 ),
     $                     LDX, A( 1, I ), 1, ONE, A( I+1, I ), 1 )
*
*              Generate reflection Q(i) to annihilate A(i+2:m,i)
*
               ALPHA = A( I+1, I )
               CALL ZLARFG( M-I, ALPHA, A( MIN( I+2, M ), I ), 1,
     $                      TAUQ( I ) )
               E( I ) = ALPHA
               A( I+1, I ) = ONE
*
*              Compute Y(i+1:n,i)
*
               CALL ZGEMV( 'Conjugate transpose', M-I, N-I, ONE,
     $                     A( I+1, I+1 ), LDA, A( I+1, I ), 1, ZERO,
     $                     Y( I+1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', M-I, I-1, ONE,
     $                     A( I+1, 1 ), LDA, A( I+1, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL ZGEMV( 'No transpose', N-I, I-1, -ONE, Y( I+1, 1 ),
     $                     LDY, Y( 1, I ), 1, ONE, Y( I+1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', M-I, I, ONE,
     $                     X( I+1, 1 ), LDX, A( I+1, I ), 1, ZERO,
     $                     Y( 1, I ), 1 )
               CALL ZGEMV( 'Conjugate transpose', I, N-I, -ONE,
     $                     A( 1, I+1 ), LDA, Y( 1, I ), 1, ONE,
     $                     Y( I+1, I ), 1 )
               CALL ZSCAL( N-I, TAUQ( I ), Y( I+1, I ), 1 )
            ELSE
               CALL ZLACGV( N-I+1, A( I, I ), LDA )
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of ZLABRD
*
      END
c $Id: zlabrd.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine ana_rmsdev(x,ix,nx,xref,wt,wts,xrms)
c $Id: ana_rmsdev.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "ana_params.fh"
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer nx
      integer ix(nx)
      real*8 x(msa,3),xref(nsa,3),wt(nsa),wts(nsa),xrms(nsa)
c
      real*8 rms0,rms1
c
      call super2(x,ix,nx,msa,xref,wt,wts,xrms,nsa,nsa,.false.,
     + rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa,.true.)
c
      if(me.eq.0) then
      write(lfnrms,1000) time,rms0,rms1
 1000 format(3f12.6)
      endif
c
      return
      end

      SUBROUTINE ccsdtq_lambda1_23_1_1_2(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdtq_lambda1_23_1_1_2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h5 h8 h9 p1 p3 p4 )_y + = 1/2 * y ( h5 h8 h9 p1 p3 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h8b
      INTEGER h9b
      INTEGER p1b
      INTEGER p3b
      INTEGER p4b
      INTEGER dimc
      INTEGER h5b_1
      INTEGER h8b_1
      INTEGER h9b_1
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h5b = 1,noab
      DO h8b = h5b,noab
      DO h9b = h8b,noab
      DO p1b = noab+1,noab+nvab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h8b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1)+i
     &nt_mb(k_spin+p4b-1).ne.12)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h8b-1),ieor(int_mb(
     &k_sym+h9b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p3b-1),int
     &_mb(k_sym+p4b-1)))))) .eq. irrep_y) THEN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h8b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p3b-1) * int_m
     &b(k_range+p4b-1)
      CALL TCE_RESTRICTED_6(h5b,h8b,h9b,p1b,p3b,p4b,h5b_1,h8b_1,h9b_1,p1
     &b_1,p3b_1,p4b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h8b-1) * int_mb
     &(k_range+h9b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p3b-1) * 
     &int_mb(k_range+p4b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_23_1_1_2',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_23_1_1_2',1,MA_ERR)
      IF ((p4b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1 
     &+ nvab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h5b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p1b-1),5,4,6,3,2,1,1.0d0)
      END IF
      IF ((p3b .lt. p1b) .and. (p1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p4b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p3b_1 - noab - 1 
     &+ nvab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h5b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p4b-1),6,4,5,3,2,1,-1.0d0)
      END IF
      IF ((p1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p4b_1
     & - noab - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p1b_1 - noab - 1 
     &+ nvab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h5b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),6,5,4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_23_1_1_2'
     &,2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_23_1_1_2',3,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p1b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h5b-1),6,5,4,3,2,1,1.0d0/2.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (p1b - noab - 1 + nvab
     & * (h9b - 1 + noab * (h8b - 1 + noab * (h5b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_23_1_1_2'
     &,4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_23_1
     &_1_2',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

c $Id: hnd_terminate.F 19696 2010-10-29 16:53:42Z d3y133 $
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     hondo : termination routine
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      logical function hnd_terminate()
      implicit none
#include "apiP.fh"
c
c     at this point nothing to do but just in case for later
c
      hnd_terminate = .true.
      return
      end

      SUBROUTINE ccsdt_lambda_o1(d_i0,d_o1,d_t1,d_t2,d_t3,d_y1,d_y2,d_y3
     &,k_i0_offset,k_o1_offset,k_t1_offset,k_t2_offset,k_t3_offset,k_y1_
     &offset,k_y2_offset,k_y3_offset)
C     $Id: ccsdt_lambda_o1.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h2 p1 )_yo + = -1 * Sum ( h5 ) * y ( h5 p1 )_y * i1 ( h2 h5 )_o
C         i1 ( h2 h5 )_o + = 1 * o ( h2 h5 )_o
C         i1 ( h2 h5 )_ot + = 1 * Sum ( p3 ) * o ( h2 p3 )_o * t ( p3 h5 )_t
C     i0 ( h2 p1 )_yo + = 1 * Sum ( p3 ) * o ( p3 p1 )_o * y ( h2 p3 )_y
C     i0 ( h2 p1 )_yo + = 1 * Sum ( h4 p3 ) * o ( p3 h4 )_o * y ( h2 h4 p1 p3 )_y
C     i0 ( h2 p1 )_yto + = -1 * Sum ( h3 ) * o ( h3 p1 )_o * i1 ( h2 h3 )_yt
C         i1 ( h2 h3 )_yt + = 1 * Sum ( p4 ) * t ( p4 h3 )_t * y ( h2 p4 )_y
C         i1 ( h2 h3 )_yt + = 1/2 * Sum ( h6 p5 p4 ) * t ( p4 p5 h3 h6 )_t * y ( h2 h6 p4 p5 )_y
C         i1 ( h2 h3 )_yt + = 1/12 * Sum ( h8 h7 p6 p5 p4 ) * t ( p4 p5 p6 h3 h7 h8 )_t * y ( h2 h7 h8 p4 p5 p6 )_y
C     i0 ( h2 p1 )_oty + = 1/2 * Sum ( p4 h5 h6 ) * y ( h5 h6 p1 p4 )_y * i1 ( h2 p4 h5 h6 )_ot
C         i1 ( h2 p4 h5 h6 )_ot + = -1 * Sum ( p3 ) * o ( h2 p3 )_o * t ( p3 p4 h5 h6 )_t
C     i0 ( h2 p1 )_oty + = -1/12 * Sum ( p4 p5 h6 h7 h8 ) * y ( h6 h7 h8 p1 p4 p5 )_y * i1 ( h2 p4 p5 h6 h7 h8 )_ot
C         i1 ( h2 p4 p5 h6 h7 h8 )_ot + = 1 * Sum ( p3 ) * o ( h2 p3 )_o * t ( p3 p4 p5 h6 h7 h8 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_o1
      INTEGER k_o1_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_y3
      INTEGER k_y3_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_t3
      INTEGER k_t3_offset
      CHARACTER*255 filename
#if !defined(CCSDTLR)
      CALL ERRQUIT('CCSDTLR not compiled (ccsdt_lambda_o1.F)',
     &              0,CAPMIS_ERR)
      RETURN
      END
#else
      CALL OFFSET_ccsdt_lambda_o1_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lambda_o1_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lambda_o1_1_1(d_o1,k_o1_offset,d_i1,k_i1_offset)
      CALL ccsdt_lambda_o1_1_2(d_o1,k_o1_offset,d_t1,k_t1_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lambda_o1_1(d_y1,k_y1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lambda_o1'
     &,-1,MA_ERR)
      CALL ccsdt_lambda_o1_2(d_o1,k_o1_offset,d_y1,k_y1_offset,d_i0,k_i0
     &_offset)
      CALL ccsdt_lambda_o1_3(d_o1,k_o1_offset,d_y2,k_y2_offset,d_i0,k_i0
     &_offset)
      CALL OFFSET_ccsdt_lambda_o1_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lambda_o1_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lambda_o1_4_1(d_t1,k_t1_offset,d_y1,k_y1_offset,d_i1,k_
     &i1_offset)
      CALL ccsdt_lambda_o1_4_2(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i1,k_
     &i1_offset)
      CALL ccsdt_lambda_o1_4_3(d_t3,k_t3_offset,d_y3,k_y3_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lambda_o1_4(d_o1,k_o1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lambda_o1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lambda_o1_5_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lambda_o1_5_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lambda_o1_5_1(d_o1,k_o1_offset,d_t2,k_t2_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lambda_o1_5(d_y2,k_y2_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lambda_o1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lambda_o1_6_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lambda_o1_6_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lambda_o1_6_1(d_o1,k_o1_offset,d_t3,k_t3_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lambda_o1_6(d_y3,k_y3_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lambda_o1'
     &,-1,MA_ERR)
      RETURN
      END
#endif

      subroutine smd_lat_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_lat
      character*32 tag,pname
      logical result

      pname = "smd_lat_init_system"
c
      tag = "lattice"
      call smd_system_get_component(sp_lat,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_lat_init(sp_lat,result)
      if(.not.result) then
       tag = "lattice"
       call smd_system_unset_component(tag)
      end if
c

      return
      end

      subroutine smd_lat_init(namespace,result)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      logical result
c
      integer rtdb
      character*32 pname
      character*80 tag
      integer i_lc,i_lrc,i_lfc
      double precision vol
c
      pname = "smd_lat_init"
c
c      write(*,*) "in "//pname
c
      call smd_rtdb_get_handle(rtdb)
c
c     check if there is any lattice in rtdb
      call smd_lat_rtdb_check(rtdb,result)
      if(.not.result) then
        call util_warning(
     >       pname//'no lattice found in rtdb',0,0)
        return
      end if
c
      call smd_namespace_create(namespace)
c
c     create lattice data structures
c     ------------------------------
      tag = "lat:fconst"
      call smd_data_create_get(namespace,tag,2,MT_DBL,i_lfc)
      tag = "lat:cell"
      call smd_data_create_get(namespace,tag,9,MT_DBL,i_lc)
      tag = "lat:rcell"
      call smd_data_create_get(namespace,tag,9,MT_DBL,i_lrc)
      
      call smd_lat_rtdb_read(rtdb,dbl_mb(i_lc))
      call smd_lat_invrt(dbl_mb(i_lc),dbl_mb(i_lrc))
      call smd_latt_vol(dbl_mb(i_lc),vol)
      dbl_mb(i_lfc) = vol
      return
      end

      subroutine smd_lat_rtdb_check(rtdb,olatt)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer rtdb
      logical olatt
c
      double precision latt(3,3)
      character*32 pname
      character*80 tag
      double precision a(3)
      integer i
c
      pname = "smd_lat_rtdb_read"
c
c      write(*,*) "in "//pname
c
      olatt = .true.
      tag="smd:lat_a"
      call smd_rtdb_get_dbl(tag,3,a(1),olatt)
c      if (.not.rtdb_get(rtdb,tag,mt_dbl,3,a(1))) 
c     >      olatt=.false.

      return
      end

      subroutine smd_lat_rtdb_read(rtdb,latt)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      double precision latt(3,3)
      integer rtdb
c
      character*32 pname
      character*80 tag
      double precision a(3)
      integer i
      logical result
c
      pname = "smd_lat_rtdb_read"
c
c      write(*,*) "in "//pname
c
      tag="smd:lat_a"
      call smd_rtdb_get_dbl(tag,3,a(1),result)
      if (.not.result) 
     >      call errquit(pname//'failed to get'//tag,0,
     >       RTDB_ERR)

c      if (.not.rtdb_get(rtdb,tag,mt_dbl,3,a(1))) 
c     >      call errquit(pname//'failed to get'//tag,0,
c     >       RTDB_ERR)
      do i=1,3
       latt(i,1)=a(i)
      end do
      tag="smd:lat_b"
      call smd_rtdb_get_dbl(tag,3,a(1),result)
      if (.not.result) 
     >      call errquit(pname//'failed to get'//tag,0,
     >       RTDB_ERR)

c      if (.not.rtdb_get(rtdb,tag,mt_dbl,3,a(1))) 
c     >      call errquit(pname//'failed to get'//tag,0,
c     >       RTDB_ERR)
      do i=1,3
       latt(i,2)=a(i)
      end do
      tag="smd:lat_c"
      call smd_rtdb_get_dbl(tag,3,a(1),result)
      if (.not.result) 
     >      call errquit(pname//'failed to get'//tag,0,
     >       RTDB_ERR)

c      if (.not.rtdb_get(rtdb,tag,mt_dbl,3,a(1))) 
c     >      call errquit(pname//'failed to get'//tag,0,
c     >       RTDB_ERR)
      do i=1,3
       latt(i,3)=a(i)
      end do
      return
      end

      subroutine smd_lat_invrt(latt,rlatt)
      implicit none
      double precision  latt(3,3),rlatt(3,3)
c
      double precision  det

      rlatt(1,1)=latt(2,2)*latt(3,3)-latt(3,2)*latt(2,3)
      rlatt(2,1)=latt(3,1)*latt(2,3)-latt(2,1)*latt(3,3)
      rlatt(3,1)=latt(2,1)*latt(3,2)-latt(3,1)*latt(2,2)
      rlatt(1,2)=latt(3,2)*latt(1,3)-latt(1,2)*latt(3,3)
      rlatt(2,2)=latt(1,1)*latt(3,3)-latt(3,1)*latt(1,3)
      rlatt(3,2)=latt(3,1)*latt(1,2)-latt(1,1)*latt(3,2)
      rlatt(1,3)=latt(1,2)*latt(2,3)-latt(2,2)*latt(1,3)
      rlatt(2,3)=latt(2,1)*latt(1,3)-latt(1,1)*latt(2,3)
      rlatt(3,3)=latt(1,1)*latt(2,2)-latt(2,1)*latt(1,2)
      
      det=latt(1,1)*rlatt(1,1)+latt(1,2)*rlatt(2,1)+latt(1,3)*rlatt(3,1)
      if(abs(det).gt.0.d0)det=1.d0/det
      
      rlatt(1,1)=det*rlatt(1,1)
      rlatt(2,1)=det*rlatt(2,1)
      rlatt(3,1)=det*rlatt(3,1)
      rlatt(1,2)=det*rlatt(1,2)
      rlatt(2,2)=det*rlatt(2,2)
      rlatt(3,2)=det*rlatt(3,2)
      rlatt(1,3)=det*rlatt(1,3)
      rlatt(2,3)=det*rlatt(2,3)
      rlatt(3,3)=det*rlatt(3,3)

      return

      end

      subroutine smd_latt_vol(latt,vol)
      implicit none
      real*8 x,y,z,latt,vol

      dimension latt(3,3)

      x=latt(2,2)*latt(3,3)-latt(2,3)*latt(2,3)
      y=latt(3,2)*latt(1,3)-latt(1,2)*latt(3,3)
      z=latt(1,2)*latt(2,3)-latt(2,2)*latt(1,3)

      vol=abs(latt(1,1)*x+latt(2,1)*y+latt(3,1)*z)

      return

      END

      subroutine smd_latt_get_vol(vol)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      double precision vol
c
      character*72 tag
      character*30 pname
      integer i_fconst
      logical result

      pname = "smd_latt_vol"
      tag = "lat:fconst"
      call smd_get_ind(tag,i_fconst,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting ntot '//tag,0, RTDB_ERR)
      vol = dbl_mb(i_fconst)

      return
      end

      subroutine smd_lat_rebox_alt(n,c)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer n
      double precision c(n,3)
c
      character*32 sp_lattice
c
      character*72 tag
      character*30 pname
      integer na
      integer i_c,i_lrc,i_lc
      logical result

      pname = "smd_lat_rebox"
c
c     get lattice params if any
c     -------------------------
      call smd_system_get_component(sp_lattice,"lattice",result)
      if(.not.result) then
        call util_warning(
     >       pname//'skipping reboxing as there is no lattice ',0,0)
        return
      end if

      tag = "lat:cell"
      call smd_data_get_index(sp_lattice,tag,i_lc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "lat:rcell"
      call smd_data_get_index(sp_lattice,tag,i_lrc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_util_rebox_alt(n,
     >                    dbl_mb(i_lc),
     >                    dbl_mb(i_lrc),
     >                    c)

      return
      end

      subroutine smd_lat_rebox(n,c)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer n
      double precision c(3,n)
c
      character*32 sp_lattice
c
      character*72 tag
      character*30 pname
      integer na
      integer i_c,i_lrc,i_lc
      logical result

      pname = "smd_lat_rebox"
c
c     get lattice params if any
c     -------------------------
      call smd_system_get_component(sp_lattice,"lattice",result)
      if(.not.result) then
        call util_warning(
     >       pname//'skipping reboxing as there is no lattice ',0,0)
        return
      end if

      tag = "lat:cell"
      call smd_data_get_index(sp_lattice,tag,i_lc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "lat:rcell"
      call smd_data_get_index(sp_lattice,tag,i_lrc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_util_rebox(n,
     >                    dbl_mb(i_lc),
     >                    dbl_mb(i_lrc),
     >                    c)

10    continue
      return
      end
C>    Folds coordinates back into the box
C>    based on center of coordinates
C>    so that "molecule" remains intact
C>    @param[in] n number of atoms
C>    @param[in,out] c[3,n] coordinates
      subroutine smd_lat_rebox_by_cog(n,c)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer n
      double precision c(3,n)
c
      character*32 sp_lattice
c
      character*72 tag
      character*30 pname
      integer na
      integer i_c,i_lrc,i_lc
      logical result

      pname = "smd_lat_rebox1"
c
c     get lattice params if any
c     -------------------------
      call smd_system_get_component(sp_lattice,"lattice",result)
      if(.not.result) then
        call util_warning(
     >       pname//'skipping reboxing as there is no lattice ',0,0)
        return
      end if

      tag = "lat:cell"
      call smd_data_get_index(sp_lattice,tag,i_lc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "lat:rcell"
      call smd_data_get_index(sp_lattice,tag,i_lrc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_util_rebox_by_cog(n,
     >                    dbl_mb(i_lc),
     >                    dbl_mb(i_lrc),
     >                    c)

10    continue
      return
      end

C>    Folds coordinates back into the box
C>    while preserving molecules/segments
C>    @param[in] nt number of atoms
C>    @param[in] n number of segments
C>    @param[in] in[n] starting index of given segment in coordinate array
C>    @param[in] nn[n] number of atoms in given segment
C>    @param[in,out] c[3,nt] coordinates
      subroutine smd_lat_rebox_segments(nt,n,in,nn,c)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer nt
      integer n
      integer in(n)
      integer nn(n)
      double precision c(3,nt)
c
      character*32 sp_lattice
c
      character*72 tag
      character*30 pname
      integer na
      integer i_c,i_lrc,i_lc
      logical result

      pname = "smd_lat_rebox1"
c
c     get lattice params if any
c     -------------------------
      call smd_system_get_component(sp_lattice,"lattice",result)
      if(.not.result) then
        call util_warning(
     >       pname//'skipping reboxing as there is no lattice ',0,0)
        return
      end if

      tag = "lat:cell"
      call smd_data_get_index(sp_lattice,tag,i_lc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "lat:rcell"
      call smd_data_get_index(sp_lattice,tag,i_lrc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_util_rebox_segments(nt,n,in,nn,
     >                    dbl_mb(i_lc),
     >                    dbl_mb(i_lrc),
     >                    c)

10    continue
      return
      end
c $Id: smd_lat.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine et_fmo_getdata(rtdb, frag, g_s, g_vecs, ma_evls,
     &   ma_occ)
      implicit none
c
c  Returns overlap matrix (g_s), MO vectors (g_vecs),
c  MO energies (ma_evls) and MO occupancies (ma_occ)
c  from the frag rtdb record and movecs file
c
c  ma_evls stack is allocated first
c
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "util.fh"
#include "inp.fh"
#include "apiP.fh"
#include "stdio.fh"
#include "cscf.fh"

c
      integer rtdb
      character*(*) frag
      character*255 str
      integer g_s, g_vecs
      integer ma_evls(2), ma_occ(2) ! mhandle 1st index, index 2nd index
      double precision dum
      integer i, j, k
c
      logical et_movecs_read
      external et_movecs_read
c
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
c
c
c -------------------------------
c load geometry and symmetry info
c -------------------------------
c
      if (.not. geom_create(geom, frag))
     &     call errquit('et_calc: geom_create?', 0, GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, frag))
     &     call errquit('et_calc: no geometry for frag', 0, RTDB_ERR)
c
c ----------------------------------------
c load the basis set and get info about it
c ----------------------------------------
c
      if (.not. bas_create(basis, 'ao basis'))
     &     call errquit('et_calc: bas_create?', 0, BASIS_ERR)
      if (.not. bas_rtdb_load(rtdb, geom, basis, 'ao basis'))
     &     call errquit('et_calc: no ao basis set', 0, RTDB_ERR)
c
      if (.not.bas_numbf(basis,nbf))
     &     call errquit('bas_numbf failed',0, BASIS_ERR)
c
      str = frag//'_s'
      g_s = ga_create_atom_blocked(geom, basis, str)
      call ga_zero(g_s)

      str = frag//'_mos'
      g_vecs = ga_create_atom_blocked(geom, basis, str)
      call ga_zero(g_vecs)
c
c initialize the API 
c
      call int_init(rtdb, 1, basis)
      call int_acc_std()
      call int_normalize(rtdb,basis)
c
c  -------------------------------
c  calculate the overlap integrals
c  -------------------------------
      call int_1e_ga(basis, basis, g_s, 'overlap', .false.)

      if (util_print("et",print_debug)) then
         call ga_print(g_s)
      endif
c
      str = frag//'_evls'
      if (.not.ma_push_get(mt_dbl,nbf,str,ma_evls(1),ma_evls(2)))
     & call errquit('ma_push_get failed _evls',ma_evls(2), MA_ERR)
c
      str = frag//'_occ'
      if(.not.ma_push_get(mt_dbl,nbf,str,ma_occ(1),ma_occ(2)))
     &   call errquit('ma_push_get failed _occ',ma_occ(2), MA_ERR)
c
      str = frag//'.movecs'
      if(.not.et_movecs_read(str,1,dbl_mb(ma_occ(2)),
     &   dbl_mb(ma_evls(2)),g_vecs,dum))
     & call errquit('et_movecs_read failed for frag mos',0, DISK_ERR)
c
c     destroying
c
c
      if (.not. geom_destroy(geom))
     &  call errquit('et_calc: geom destroy failed', 0, GEOM_ERR)
c
      if (.not. bas_destroy(basis))
     &  call errquit('et_calc: basis destroy failed',0, BASIS_ERR)
c
      call int_terminate()
      return
      end
c $Id: et_fmo_util.F 25011 2013-12-19 17:45:25Z d3y133 $

* $Id: Dnex.F 19707 2010-10-29 17:59:36Z d3y133 $
*


*     ***********************************
*     *					*
*     *	        Dnex_init		*	
*     *					*
*     ***********************************

      subroutine Dnex_init(ispin_in,ne_in,map_in)
      implicit none
      integer ispin_in
      integer ne_in(2)
      integer map_in

#include "Dnex.fh"

      ispin   = ispin_in
      ne(1)   = ne_in(1)
      ne(2)   = ne_in(2)

      neq(1) = 0
      neq(2) = 0
      call D1dB_init(3,ne(1),map_in)
      call D1dB_nq(3,neq(1))
      if (ispin.eq.2) then
        call D1dB_init(4,ne(2),map_in)
        call D1dB_nq(4,neq(2))
      end if

      return
      end


*     ***********************************
*     *					*
*     *	          Dnex_end   		*	
*     *					*
*     ***********************************

      subroutine Dnex_end()
      implicit none

#include "Dnex.fh"

      call D1dB_end(3)
      if (ispin.eq.2) call D1dB_end(4)

      return
      end
         

*     ***********************************
*     *					*
*     *	         Dnexall_ntoqp 		*	
*     *					*
*     ***********************************

      subroutine Dnexall_ntoqp(n,q,p)      
      implicit none
      integer n,q,p

#include "Dnex.fh"

      if (n.le.ne(1)) then
        call D1dB_ktoqp(3,n,q,p)
      else
        call D1dB_ktoqp(4,n,q,p)
        q = q + neq(1)
      end if

      return
      end



*     ***********************************
*     *					*
*     *	        Dnexall_neq		*	
*     *					*
*     ***********************************

      subroutine Dnexall_neq(nqtmp)
      implicit none
      integer nqtmp(2)

#include "Dnex.fh"

      nqtmp(1) = neq(1)
      nqtmp(2) = neq(2)
      return 
      end

      subroutine tce_jacobi_x3a(d_r3,k_r3_offset)
c
c $Id: tce_jacobi_x3a.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r3
      integer p1b
      integer p2b
      integer p3b
      integer h4b
      integer h5b
      integer h6b
      integer p1
      integer p2
      integer p3
      integer h4
      integer h5
      integer h6
      integer k_r3_offset
      integer size
      integer l_r3,k_r3
      integer i
      integer nprocs
      integer count
      integer next
      integer nxtask
      external nxtask
      logical nodezero
      logical noloadbalance
      logical acolo
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or. 
     1                ((ioalg.eq.6).and.(.not.fileisga(d_r3)))) 
      nprocs = ga_nnodes()
      count = 0
      next = nxtask(nprocs,1)
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do p3b = p2b,noab+nvab
            do h4b = 1,noab
              do h5b = h4b,noab
                do h6b = h5b,noab
                  if (noloadbalance.or.(next.eq.count)) then
                    if(acolo(p1b,p2b,p3b,h4b,h5b,h6b)) then
                    if (int_mb(k_spin+p1b-1)
     1                 +int_mb(k_spin+p2b-1)
     2                 +int_mb(k_spin+p3b-1)
     3              .eq.int_mb(k_spin+h4b-1)
     4                 +int_mb(k_spin+h5b-1)
     5                 +int_mb(k_spin+h6b-1)) then
                    if ((.not.restricted).or.
     1                 (int_mb(k_spin+p1b-1)
     2                 +int_mb(k_spin+p2b-1)
     3                 +int_mb(k_spin+p3b-1)
     4                 +int_mb(k_spin+h4b-1)
     5                 +int_mb(k_spin+h5b-1)
     6                 +int_mb(k_spin+h6b-1).ne.12)) then
                    if (ieor(int_mb(k_sym+p1b-1),
     1                  ieor(int_mb(k_sym+p2b-1),
     2                  ieor(int_mb(k_sym+p3b-1),
     3                  ieor(int_mb(k_sym+h4b-1),
     4                  ieor(int_mb(k_sym+h5b-1),
     5                  int_mb(k_sym+h6b-1)))))) .eq. irrep_x) then
                      size = int_mb(k_range+p1b-1)
     1                     * int_mb(k_range+p2b-1)
     2                     * int_mb(k_range+p3b-1)
     3                     * int_mb(k_range+h4b-1)
     4                     * int_mb(k_range+h5b-1)
     5                     * int_mb(k_range+h6b-1)
                      if (.not.ma_push_get(mt_dbl,size,'r3',
     1                  l_r3,k_r3))
     2                  call errquit('tce_jacobi_x3: MA problem',0,
     3                  MA_ERR)
                      call get_hash_block(d_r3,dbl_mb(k_r3),size,
     1                  int_mb(k_r3_offset),((((((p1b-noab-1)*nvab
     2                  +p2b-noab-1)*nvab+p3b-noab-1)*noab
     3                  +h4b-1)*noab+h5b-1)*noab+h6b-1))
                      i = 0
                      do p1 = 1,int_mb(k_range+p1b-1)
                        do p2 = 1,int_mb(k_range+p2b-1)
                          do p3 = 1,int_mb(k_range+p3b-1)
                            do h4 = 1,int_mb(k_range+h4b-1)
                              do h5 = 1,int_mb(k_range+h5b-1)
                                do h6 = 1,int_mb(k_range+h6b-1)
                                  i = i + 1
                     dbl_mb(k_r3+i-1) = dbl_mb(k_r3+i-1)
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              -dbl_mb(k_evl_sorted+int_mb(k_offset+p3b-1)+p3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1)
     5              +dbl_mb(k_evl_sorted+int_mb(k_offset+h5b-1)+h5-1)
     6              +dbl_mb(k_evl_sorted+int_mb(k_offset+h6b-1)+h6-1))
                                enddo
                              enddo
                            enddo
                          enddo
                        enddo
                      enddo
                      call put_hash_block(d_r3,dbl_mb(k_r3),size,
     1                  int_mb(k_r3_offset),((((((p1b-noab-1)*nvab
     2                  +p2b-noab-1)*nvab+p3b-noab-1)*noab
     3                  +h4b-1)*noab+h5b-1)*noab+h6b-1))
                      if (.not.ma_pop_stack(l_r3))
     1                  call errquit('tce_jacobi_x3: MA problem',1,
     2                  MA_ERR)
                    endif
                    endif
                    endif
                    endif  !active
                    next = nxtask(nprocs,1)
                  endif
                  count = count + 1
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      next = nxtask(-nprocs,1)
      call ga_sync()
      return
      end

c
c $Id: pspw_cosmo.F 25011 2013-12-19 17:45:25Z d3y133 $
c
  
***********************************************************
*                                                         *
*                   PSPW-COSMO module                     *
*                                                         *
*                                                         *
*   -- developed by Eric J. Bylaska on September 1, 2012  *
*                                                         *
***********************************************************
*
*
*  

*     **********************************
*     *	                               *
*     *          pspw_cosmo_init       *
*     *                                *
*     **********************************
 
      subroutine pspw_cosmo_init()
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "pspw_cosmo.fh"
#include "errquit.fh"


*     **** local variables ****
      logical value

*     **** external functions ****
      logical  control_cosmo
      external control_cosmo

      cosmo_found = control_cosmo()

      if (cosmo_found) then
         value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d,'fcut',fcut(2),fcut(1))
         value = value.and.
     >        MA_alloc_get(mt_dbl,3*n2ft3d,'gradfcut',
     >                     gradfcut(2),gradfcut(1))
         value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d,'lapfcut',
     >                     lapfcut(2),lapfcut(1))

         value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d,'vcond',vcond(2),vcond(1))
         value = value.and.
     >        MA_alloc_get(mt_dbl,n2ft3d,'Avcond',Avcond(2),Avcond(1))

      end if

      return
      end



*     **********************************
*     *	                               *
*     *        pspw_cosmo_end          *
*     *                                *
*     **********************************
      subroutine pspw_cosmo_end()
      implicit none

#include "mafdecls.fh"
#include "pspw_cosmo.fh"
#include "errquit.fh"

*     **** local variables ****
      logical value

      if (cosmo_found) then
         value =           MA_free_heap(fcut(2))
         value = value.and.MA_free_heap(vcond(2))
      end if

      return
      end


*     **********************************
*     *	                               *
*     *         pspw_cosmo_found       *
*     *                                *
*     **********************************
      logical function pspw_cosmo_found()
      implicit none

#include "pspw_cosmo.fh"
 

      pspw_cosmo_found = cosmo_found
      return
      end



*     **********************************
*     *	                               *
*     *     pspw_cosmo_nq_total        *
*     *                                *
*     **********************************
      integer function pspw_cosmo_nq_total()
      implicit none

#include "pspw_cosmo.fh"

      pspw_cosmo_nq_total = nq_total
      return
      end

*     **********************************
*     *	                               *
*     *     pspw_cosmo_nq_ion          *
*     *                                *
*     **********************************
      integer function pspw_cosmo_nq_ion(ii)
      implicit none
      integer ii

#include "mafdecls.fh"
#include "pspw_cosmo.fh"
#include "errquit.fh"

      pspw_cosmo_nq_ion = int_mb(nq_ion(1)+ii-1)
      return
      end

*     **********************************
*     *	                               *
*     *     pspw_cosmo                 *
*     *                                *
*     **********************************

      subroutine pspw_cosmo(n2ft3d,r_grid,vc,vcosmo)
      impicit none
      integer n2ft3d
      real*8 r_grid(3,n2ft3d),vc(n2ft3d),vcosmo(n2ft3d)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      integer grx(2),gry(2),grz(2)

*     **** external functions ****
      integer  G_indx
      external G_indx


      call pspw_cosmo_vions(n2ft3d,0.1d0,r_grid,vcosmo)
      call daxpy(n2ft3d,1.0d0,vc,1,vcosmo,1)

      value = value.and.
     >        MA_push_get(mt_dbl, n2ft3d,'fcut',fcut(2),grx(1))
      value = value.and.
     >        MA_push_get(mt_dbl, n2ft3d,'vconductor',vconductor(2),vconductor(1))

      value = value.and.
     >        MA_push_get(mt_dbl, n2ft3d,'grx',grx(2),grx(1))
      value = value.and.
     >        MA_push_get(mt_dbl, n2ft3d,'gry',gry(2),gry(1))
      value = value.and.
     >        MA_push_get(mt_dbl, n2ft3d,'grz',grz(2),grz(1))
      if (.not. value) 
     >   call errquit('pspw_cosmo:out of stack memory',0,MA_ERR)


      call D3dB_r_Zero_Ends(1,vcosmo)
      call D3dB_r_SMul1(1,scal1,vcosmo)
      call D3dB_rc_fft3f(1,vcosmo)
      call mask_C(0,vcosmo)

c     **** calculate  gradient vcosmo ****
      call D3dB_ic_Mul(1,dbl_mb(G_indx(1)),
     >                   vcosmo,
     >                   dbl_mb(grx(1)))
      call D3dB_ic_Mul(1,dbl_mb(G_indx(2)),
     >                   vcosmo,
     >                   dbl_mb(gry(1)))
      call D3dB_ic_Mul(1,dbl_mb(G_indx(3)),
     >                   vcosmo,
     >                   dbl_mb(grz(1)))
      call D3dB_cr_fft3b(1,dbl_mb(grx(1)))
      call D3dB_cr_fft3b(1,dbl_mb(gry(1)))
      call D3dB_cr_fft3b(1,dbl_mb(grz(1)))




      return
      end



*     ***********************************
*     *				        *
*     *	        pspw_cosmo_vions        *
*     *					*
*     ***********************************
      subroutine pspw_cosmo_vions(n2ft3d,rcut,r_grid,vlr_out)
      implicit none
      integer n2ft3d
      real*8 rcut
      real*8 r_grid(3,*)
      real*8 vlr_out(*)

*     **** Error function parameters ****
      real*8 xerf,yerf

*     **** local variables ****
      integer taskid_j,np_j
      integer i,j
      real*8 x,y,z,q,c,r,sqrt_pi

*     **** external functions ****
      integer  ion_nion,ion_katm
      real*8   ion_rion,psp_zv,util_erf
      external ion_nion,ion_katm
      external ion_rion,psp_zv,util_erf

      call nwpw_timing_start(5)
      call Parallel2d_np_j(np_j)
      call Parallel2d_taskid_j(taskid_j)
      sqrt_pi = dsqrt(4.0d0*datan(1.0d0))
      call dcopy(n2ft3d,0.0d0,0,vlr_out,1)
      do j=1,ion_nion()
         if (mod(j-1,np_j).eq.taskid_j) then
            x = ion_rion(1,j)
            y = ion_rion(2,j)
            z = ion_rion(3,j)
            q = -psp_zv(ion_katm(j))
            c = 1.0d0/rcut
            do i=1,n2ft3d
               r = dsqrt( (r_grid(1,i)-x)**2
     >                  + (r_grid(2,i)-y)**2
     >                  + (r_grid(3,i)-z)**2)
               if (r .gt. 1.0d-15) then
                 xerf=r*c
                 yerf = util_erf(xerf)
                 vlr_out(i) = vlr_out(i) + (q/r)*yerf
c                vlr_out(i) = vlr_out(i) + (q/r)*erf(r*c)
               else
                 vlr_out(i) = vlr_out(i) + 2.0d0*q*c/sqrt_pi
               end if
            end do
         end if
      end do
      if (np_j.gt.1) call D1dB_Vector_SumAll(n2ft3d,vlr_out)
      call nwpw_timing_end(5)
      return
      end

*     ***********************************
*     *				        *
*     *	        pspw_cosmo_gen_fcut     *
*     *					*
*     ***********************************
      subroutine pspw_cosmo_gen_fcut(rcut,nion,rcosmo,rion,
     >                               n2ft3d,r_grid,fcut)
      implicit none
      real*8  rcut
      integer nion
      real*8  rcosmo(*),rion(3,*)
      integer n2ft3d
      real*8  r_grid(3,n2ft3d),fcut(n2ft3d)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      integer i
      integer tmp(2)

*     **** external functions ****
      real*8   util_erf
      external util_erf

      if (.not.MA_push_get(mt_dbl, n2ft3d,'tmp',tmp(2),tmp(1)))
     >   call errquit('pspw_cosmo_gen_fcut:out of stack',0,MA_ERR)

      call dcopy(n2ft3d,0.0d0,0,dbl_mb(tmp(1)),1)
      do i=1,nion
         call pspw_cosmo_gen_fcut_ion(rcut,rcosmo(i),rion(1,i),
     >                                n2ft3d,r_grid,dbl_mb(tmp(1)))
      end do

      call dcopy(n2ft3d,0.0d0,0,fcut,1)
      do i=1,n2ft3d
         fcut(i) = util_erf(dbl_mb(tmp(1)+i-1)/rcut)
      end do

      if (.not.MA_pop_stack(tmp(2))) 
     >   call errquit('pspw_cosmo_gen_fcut:popping stack',1,MA_ERR)
      return
      end


*     ***********************************
*     *				        *
*     *	    pspw_cosmo_add_fcut_ion     *
*     *					*
*     ***********************************

      subroutine pspw_cosmo_add_fcut_ion(rcut,rsphere,rion,
     >                                   n2ft3d,r_grid,fcut_ion)
      implicit none
      real*8  rcut,rsphere,rcut,rion(3)
      integer n2ft3d
      real*8  r_grid(3,n2ft3d)
      real*8  fcut_ion(n2ft3d)

*     **** local variables ****
      integer i
      real*8 x,y,z,r,u

*     **** external functions ****
      real*8   util_erfc
      external util_erfc
      
      do i=1,n2ft3d
         x = rion(1) - r_grid(1,i)
         y = rion(2) - r_grid(2,i)
         z = rion(3) - r_grid(3,i)
         r = dsqrt(x*x + y*y + z*z)
         u = (r-rsphere)/rcut
         fcut_ion(i) = fcut_ion(i) + 0.5d0*util_erfc(u)
      end do
      return
      end
      
c*     ***********************************
c*     *				        *
c*     *	    pspw_cosmo_gen_dfcut_ion    *
c*     *					*
c*     ***********************************
c      
c      subroutine pspw_cosmo_gen_dfcut_ion(rcut,rsphere,rion,
c     >                                   n2ft3d,r_grid,dfcut_ion)
c      implicit none
c      real*8  rcut,rsphere,rion(3)
c      integer n2ft3d
c      real*8  r_grid(3,n2ft3d)
c      real*8  dfcut_ion(3,n2ft3d)
c      
c*     **** local variables ****
c      integer i
c      real*8 x,y,z,r,u,df,const
c
c*     **** external functions ****
c      real*8   util_erfc
c      external util_erfc
c
c      const = -1.0d0/dsqrt(4.0d0*datan(1.0d0))
c      const = const / rcut
c
c      call dcopy(3*n2ft3d,0.0d0,0,dfcut_ion,1)
c      do i=1,n2ft3d
c         x = rion(1) - r_grid(1,i)
c         y = rion(2) - r_grid(2,i)
c         z = rion(3) - r_grid(3,i)
c         r = dsqrt(x*x + y*y + z*z)
c         u = (r-rsphere)/rcut
c         df = const*dexp(-u*u)/r
c         
c         dfcut_ion(1,i) = df*x
c         dfcut_ion(1,i) = df*y
c         dfcut_ion(1,i) = df*z
c
c      end do
c      return
c      end

      subroutine pspw_cosmo_cg(n2ft3d,f1,f2xyz,f3,gamma)
      implicit none
      integer n2ft3d
      real*8 f1(n2ft3d),f2xyz(3,n2ft3d),f3(n2ft3d),b(n2ft3d)

      call pspw_cosmo_A(n2ft3d,f1,f2xyz,f3,gamma,gradp,lapp,Ap)
      call dcopy(n2ft3d,b,1,r,1)
      call daxpy(n2ft3d,-1.0d0,Ap,1,r,1)
      call dcopy(n2ft3d,r,1,p,1)
      call D3dB_rr_dot(1,r,r,rsold)

      done = .false.
      while (.not. done) do
         call pspw_cosmo_A(n2ft3d,f1,f2xyz,f3,p,gradp,lapp,Ap)
         call D3dB_rr_dot(1,p0,Ap0,x)
         alpha = rsold/x
         call daxpy(n2ft3d, alpha,p,1,r, 1)
         call daxpy(n2ft3d,-alpha,p,1,Ap,1)
         call D3dB_rr_dot(1,r,r,rsnew)
         done = (rsnew.lt.tol)
         if (.not.done) then
            call dscal(n2ft3d,(rsnew/rsold),p,1)
            call daxpy(n2ft3d,1.0d0,r,1,p,1)
            rsold = rsnew
         end if
      end do

      return
      end

*     ***********************************
*     *				        *
*     *	    pspw_cosmo_Agamma           *
*     *					*
*     ***********************************
      subroutine pspw_cosmo_Agamma(n2ft3d,tmpG,f1,f1x,f1y,f1z,lapf1,
     >                             tmp,tmp2,
     >                             gamma,Agamma)
      implicit none
      integer n2ft3d
      real*8 tmpG(n2ft3d/2,4)
      real*8 f1(n2ft3d)
      real*8 f1x(n2ft3d)
      real*8 f1y(n2ft3d)
      real*8 f1z(n2ft3d)
      real*8 lapf1(n2ft3d)
      real*8 tmp1(n2ft3d)
      real*8 tmp2(n2ft3d)
      real*8 gamma(n2ft3d)
      real*8 Agamma(n2ft3d)

      do i=1,n2ft3d
         Agamma(i) = lapf1(i)*gamma(i)
      end do

      call dcopy(n2ft3d,gamma,1,tmp1,1)
      call D3dB_r_Zero_Ends(1,tmp1)
      call D3dB_r_SMul1(1,scal1,tmp1)
      call D3dB_rc_fft3f(1,tmp1)
      call mask_C(0,tmp1)

c     **** calculate  gradient gamma ****
      call D3dB_ic_Mul(1,tmpG(1,1),tmp1,tmp2)
      call D3dB_cr_fft3b(1,tmp2)
      do i=1,n2ft3d
         Agamma(i) = 2.0d0*f1x(i)*tmp2(i)
      end do

      call D3dB_ic_Mul(1,tmpG(1,2),tmp1,tmp2)
      call D3dB_cr_fft3b(1,tmp2)
      do i=1,n2ft3d
         Agamma(i) = Agamma(i) + 2.0d0*f1y(i)*tmp2(i)
      end do

      call D3dB_ic_Mul(1,tmpG(1,3),tmp1,tmp2)
      call D3dB_cr_fft3b(1,tmp2)
      do i=1,n2ft3d
         Agamma(i) = Agamma(i) + 2.0d0*f1z(i)*tmp2(i)
      end do

      call D3dB_tc_Mul(1,tmpG(1,4),tmp1,tmp2)
      call D3dB_cr_fft3b(1,tmp2)
      do i=1,n2ft3d
         Agamma(i) = Agamma(i) + f1(i)*tmp2(i)
      end do

      return
      end 

*> \brief \b DSYGST
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DSYGV + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dsygv.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dsygv.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dsygv.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DSYGV( ITYPE, JOBZ, UPLO, N, A, LDA, B, LDB, W, WORK,
*                         LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          JOBZ, UPLO
*       INTEGER            INFO, ITYPE, LDA, LDB, LWORK, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), W( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DSYGV computes all the eigenvalues, and optionally, the eigenvectors
*> of a real generalized symmetric-definite eigenproblem, of the form
*> A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*> Here A and B are assumed to be symmetric and B is also
*> positive definite.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ITYPE
*> \verbatim
*>          ITYPE is INTEGER
*>          Specifies the problem type to be solved:
*>          = 1:  A*x = (lambda)*B*x
*>          = 2:  A*B*x = (lambda)*x
*>          = 3:  B*A*x = (lambda)*x
*> \endverbatim
*>
*> \param[in] JOBZ
*> \verbatim
*>          JOBZ is CHARACTER*1
*>          = 'N':  Compute eigenvalues only;
*>          = 'V':  Compute eigenvalues and eigenvectors.
*> \endverbatim
*>
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangles of A and B are stored;
*>          = 'L':  Lower triangles of A and B are stored.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrices A and B.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA, N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the
*>          leading N-by-N upper triangular part of A contains the
*>          upper triangular part of the matrix A.  If UPLO = 'L',
*>          the leading N-by-N lower triangular part of A contains
*>          the lower triangular part of the matrix A.
*>
*>          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*>          matrix Z of eigenvectors.  The eigenvectors are normalized
*>          as follows:
*>          if ITYPE = 1 or 2, Z**T*B*Z = I;
*>          if ITYPE = 3, Z**T*inv(B)*Z = I.
*>          If JOBZ = 'N', then on exit the upper triangle (if UPLO='U')
*>          or the lower triangle (if UPLO='L') of A, including the
*>          diagonal, is destroyed.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB, N)
*>          On entry, the symmetric positive definite matrix B.
*>          If UPLO = 'U', the leading N-by-N upper triangular part of B
*>          contains the upper triangular part of the matrix B.
*>          If UPLO = 'L', the leading N-by-N lower triangular part of B
*>          contains the lower triangular part of the matrix B.
*>
*>          On exit, if INFO <= N, the part of B containing the matrix is
*>          overwritten by the triangular factor U or L from the Cholesky
*>          factorization B = U**T*U or B = L*L**T.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] W
*> \verbatim
*>          W is DOUBLE PRECISION array, dimension (N)
*>          If INFO = 0, the eigenvalues in ascending order.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The length of the array WORK.  LWORK >= max(1,3*N-1).
*>          For optimal efficiency, LWORK >= (NB+2)*N,
*>          where NB is the blocksize for DSYTRD returned by ILAENV.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          > 0:  DPOTRF or DSYEV returned an error code:
*>             <= N:  if INFO = i, DSYEV failed to converge;
*>                    i off-diagonal elements of an intermediate
*>                    tridiagonal form did not converge to zero;
*>             > N:   if INFO = N + i, for 1 <= i <= N, then the leading
*>                    minor of order i of B is not positive definite.
*>                    The factorization of B could not be completed and
*>                    no eigenvalues or eigenvectors were computed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup doubleSYeigen
*
*  =====================================================================
      SUBROUTINE DSYGV( ITYPE, JOBZ, UPLO, N, A, LDA, B, LDB, W, WORK,
     $                  LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, ITYPE, LDA, LDB, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), W( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER, WANTZ
      CHARACTER          TRANS
      INTEGER            LWKMIN, LWKOPT, NB, NEIG
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DPOTRF, DSYEV, DSYGST, DTRMM, DTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( ITYPE.LT.1 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( UPPER .OR. LSAME( UPLO, 'L' ) ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
*
      IF( INFO.EQ.0 ) THEN
         LWKMIN = MAX( 1, 3*N - 1 )
         NB = ILAENV( 1, 'DSYTRD', UPLO, N, -1, -1, -1 )
         LWKOPT = MAX( LWKMIN, ( NB + 2 )*N )
         WORK( 1 ) = LWKOPT
*
         IF( LWORK.LT.LWKMIN .AND. .NOT.LQUERY ) THEN
            INFO = -11
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYGV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Form a Cholesky factorization of B.
*
      CALL DPOTRF( UPLO, N, B, LDB, INFO )
      IF( INFO.NE.0 ) THEN
         INFO = N + INFO
         RETURN
      END IF
*
*     Transform problem to standard eigenvalue problem and solve.
*
      CALL DSYGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      CALL DSYEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO )
*
      IF( WANTZ ) THEN
*
*        Backtransform eigenvectors to the original problem.
*
         NEIG = N
         IF( INFO.GT.0 )
     $      NEIG = INFO - 1
         IF( ITYPE.EQ.1 .OR. ITYPE.EQ.2 ) THEN
*
*           For A*x=(lambda)*B*x and A*B*x=(lambda)*x;
*           backtransform eigenvectors: x = inv(L)**T*y or inv(U)*y
*
            IF( UPPER ) THEN
               TRANS = 'N'
            ELSE
               TRANS = 'T'
            END IF
*
            CALL DTRSM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, ONE,
     $                  B, LDB, A, LDA )
*
         ELSE IF( ITYPE.EQ.3 ) THEN
*
*           For B*A*x=(lambda)*x;
*           backtransform eigenvectors: x = L*y or U**T*y
*
            IF( UPPER ) THEN
               TRANS = 'T'
            ELSE
               TRANS = 'N'
            END IF
*
            CALL DTRMM( 'Left', UPLO, TRANS, 'Non-unit', N, NEIG, ONE,
     $                  B, LDB, A, LDA )
         END IF
      END IF
*
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of DSYGV
*
      END
c $Id: dsygv.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine argos_cafe_parimp(id,idp,ip,p)
c
c     argos_cafe_parimp
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer id,idp,ip(6)
      real*8 p(4,24)
c
      if(id.le.0.or.id.gt.nbs) call md_abort('Error 1 in parimp',0)
      if(idp.lt.1.or.idp.gt.mit(id))
     + call md_abort('Error 2 in parimp',0)
      if(id.eq.2.and.ip(5).lt.0) nmult(4)=nmult(4)+1
c
      call argos_cafe_pcopy(idp,ip,p,6,mip(id),int_mb(i_iimp(id)),
     + dbl_mb(i_imp(id)),mit(id),
     + ip2(10+(id-1)*12),ip3(10+(id-1)*12),ith(10+(id-1)*12))
c
      return
      end
c $Id: argos_cafe_parimp.F 21176 2011-10-10 06:35:49Z d3y133 $

      double precision function util_wallsec()
      implicit none
c $Id: util_wallsec.F 25575 2014-05-07 01:06:40Z edo $
*
* routine to give wall clock seconds since start of execution
*  delta times are handled by all applications
*
*
      logical first_call
      double precision first_time,last_time,cur_time,diff
      double precision MPI_Wtime
      external MPI_Wtime
c
      save first_time
      save first_call
      data first_call /.true./
c
      util_wallsec = MPI_Wtime()
      if (first_call) then
         first_time = MPI_Wtime()
         first_call = .false.
      endif

      cur_time = MPI_Wtime()
      util_wallsec = cur_time - first_time

*
      end

      subroutine smd_pdb_natoms(filename,nt)
      implicit none
      character*(*) filename
      integer nt
c
      character*(4) buffer
      integer un
c
      un = 70
      open(unit=un,status="old",form="formatted",file=filename)

      nt = 0
100   continue
      read(un,'(A4)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        nt = nt + 1
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_pdb_read_coords(filename,nt,c)
      implicit none
      character*(*) filename
      integer nt
      double precision c(3,nt)
c
      character*(180) buffer
      character*(4)  tag
      integer i
      integer un
      character*(30) pname

      pname = "smd_pdb_read_coords"
c
      un = 70
c
      open(unit=un,status="old",form="formatted",file=filename)
      i = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        i = i +1
        read(buffer,*) tag,tag,tag,tag,tag,
     >                 c(1,i),c(2,i),c(3,i)
       end if
      goto 100
200   continue
      close(un)

      return

      end

      subroutine smd_pdb_read_atomres(filename,nt,ta,tr,ir)
      implicit none
      character*(*) filename
      integer nt
      character*(*) ta(nt)
      character*(*) tr(nt)
      integer ir(nt)
c
      character*(180) buffer
      integer i
      integer un
      character*(30) pname

      pname = "smd_pdb_read_atomres"
c
      un = 70
c
      open(unit=un,status="old",form="formatted",file=filename)
      i = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        i = i +1
        ta(i) = buffer(13:16)
        tr(i) = buffer(18:20)
        read(buffer(23:26),*) ir(i)
       end if
      goto 100
200   continue
      close(un)

      return

      end

      subroutine smd_pdb_sort_byres(nt,ta,tr,ir,c)
      implicit none
      integer nt
      character*(*) ta(nt)
      character*(*) tr(nt)
      integer ir(nt)
      double precision c(3,nt)
c
      character*(180) buffer
      integer i
      integer un
      character*(30) pname
      integer pass
      integer sorted
      integer itemp
      double precision ftemp
      character*16 stemp

      pass = 1
      sorted = 0
      do while(sorted .eq. 0) 
        sorted = 1
        do i = 1,nt-pass
          if(ir(i) .gt. ir(i+1)) then
            itemp = ir(i)
            ir(i) = ir(i+1)
            ir(i+1) = itemp
c
            stemp = ta(i)
            ta(i) = ta(i+1)
            ta(i+1) = stemp
c
            stemp = tr(i)
            tr(i) = tr(i+1)
            tr(i+1) = stemp
c
            ftemp = c(1,i)
            c(1,i) = c(1,i+1)
            c(1,i+1) = ftemp
c
            ftemp = c(2,i)
            c(2,i) = c(2,i+1)
            c(2,i+1) = ftemp
c
            ftemp = c(3,i)
            c(3,i) = c(3,i+1)
            c(3,i+1) = ftemp
c
            sorted = 0
          endif
        enddo
        pass = pass +1
      end do

      return

      end

      subroutine smd_pdb_sort_seq_distance(nr,is,im,d)
      implicit none
      integer nr
      integer is(nr)
      integer im(nr)
      double precision d(nr)
c
      integer i
      integer pass
      integer sorted
      integer itemp
      double precision ftemp

      pass = 1
      sorted = 0
      do while(sorted .eq. 0) 
        sorted = 1
        do i = 1,nr-pass
          if(d(i) .gt. d(i+1)) then
            ftemp = d(i)
            d(i) = d(i+1)
            d(i+1) = ftemp
c
            itemp = is(i)
            is(i) = is(i+1)
            is(i+1) = itemp
c
c            itemp = im(i)
c            im(i) = im(i+1)
c            im(i+1) = itemp

            sorted = 0
          endif
        enddo
        pass = pass +1
      end do

      return

      end

      subroutine smd_pdb_read(filename,nt,ta,tr,ir,c)
      implicit none
      character*(*) filename
      integer nt
      character*(16) ta(nt)
      character*(16) tr(nt)
      integer ir(nt)
      double precision c(3,nt)
c
      character*(180) buffer
      character*(4)  tag
      integer i
      integer un
      character*(30) pname

      pname = "smd_pdb_read"
c
      un = 70
c
      open(unit=un,status="old",form="formatted",file=filename)
      i = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        i = i +1
        read(buffer,*) tag,tag,ta(i),tr(i),ir(i),
     >                 c(1,i),c(2,i),c(3,i)
       end if
      goto 100
200   continue
      close(un)

      return

      end

      subroutine smd_pdb_write_byseq(filename,nr,nt,im,is,ta,tr,c)
      implicit none
      character*(*) filename
      integer nr
      integer im(nr+1)
      integer is(nr)
      integer nt
      character*(16) ta(nt)
      character*(16) tr(nt)
      double precision c(3,nt)
c
      character*(180) buffer
      character*(4)  tag
      integer i
      integer un
      integer i0,j0,j,jb,je
c
      un = 70
c
      open(unit=un,status="unknown",form="formatted",file=filename)
      j0=0
      do i=1,nr
       i0=is(i)
       jb = im(i0)
       je = im(i0+1)-1
       do j=jb,je
         j0=j0+1
         write(un,FMT=9000)j0,ta(j),tr(j),i,c(1,j),c(2,j),c(3,j)
       end do
      end do
      close(un)

      return
9000   FORMAT("ATOM",T7,I5,T13,A4,T18,A3,T23,I4,T31,
     >        F8.3,T39,F8.3,T47,F8.3,T55,F6.2)

      end

      subroutine smd_pdb_nres(filename,nr)
      implicit none
      character*(*) filename
      integer nr
c
      character*(180) buffer
      character*(4)  tag
      integer ir0,ir
      integer un
c
      un = 70
c
      open(unit=un,status="old",form="formatted",file=filename)

c      reset residue arrays to be the size of number of residues only
      nr = 0
      ir0 = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        read(buffer,*) tag,tag,tag,tag,ir
        if(ir0.ne.ir) then
          nr = nr + 1
          ir0=ir
        end if
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_pdb_nres0(nr,nt,ir)
      implicit none
      integer nr
      integer nt
      integer ir(nt)
c
      integer i,ir0
      nr = 0
      ir0 = 0
      do i=1,nt
      if(ir0.ne.ir(i)) then
        nr = nr + 1
        ir0=ir(i)
      end if
      end do

      end

      subroutine smd_pdb_cog(nt,nr,ir,c,cg)
      implicit none
      integer nt
      integer nr
      integer ir(nt)
      double precision c(3,nt)
      double precision  cg(3,nr)
c
      integer i,j,ir0,nm
      j=1
      ir0=ir(1)
      nm=0
      cg=0.0d0
      do i=1,nt
       if(ir(i).ne.ir0) then
         cg(:,j)=cg(:,j)/nm
         j=j+1
         ir0=ir(i)
         nm=0
       end if 
       cg(:,j)=cg(:,j)+c(:,i)
       nm=nm+1
      end do
      cg(:,j)=cg(:,j)/nm
      return
      end

      subroutine smd_pdb_cog_byname(nt,nr,tar,ta,ir,c,cg)
C     nt total number of atoms
C     nr total number of residues
C     tar atom name
C     ta  atom name array
C     ir  residue index array
C     c   coordinate array
C     cg  center of mass array
      implicit none
      integer nt
      integer nr
      character*(*) tar
      character*(*) ta(nt)
      integer ir(nt)
      double precision c(3,nt)
      double precision  cg(3,nr)

c
      integer i,j,ir0,nm
      integer s0
      integer length
      external length

      s0 = length(tar)
      j=1
C     first residue
      ir0=ir(1)
      nm=0
      cg=0.0d0
      do i=1,nt
       if(ir(i).ne.ir0) then
         if(nm.ne.0) then
           cg(:,j)=cg(:,j)/nm
         else
           write(*,*) "no atoms maching pattern ",tar(1:s0)
           stop
         end if
         j=j+1
         ir0=ir(i)
         nm=0
       end if 
       write(*,*) "atom name",tar
C      check for name match
       if(INDEX(ta(i),tar(1:s0)).gt.0) then
       cg(:,j)=cg(:,j)+c(:,i)
       nm=nm+1
       end if
      end do
      cg(:,j)=cg(:,j)/nm
      return
      end

      subroutine smd_pdb_sequence_bounds(nt,nr,ir,is,im)
      implicit none
      integer nt
      integer nr
      integer ir(nt)
      integer is(nr)
      integer im(nr+1)
c
      integer i,j,ir0,nm
      j = 1
      is(1) = ir(1)
      im(1) = 1
      do i=1,nt
       if(ir(i).ne.is(j)) then
         j=j+1
         is(j) = ir(i)
         im(j) = i
       end if 
      end do
      im(j+1)=i


      return
      end

      subroutine smd_pdb_distance(nt,c,cor,cd)
      implicit none
      integer nt
      double precision c(3,nt)
      double precision  cor(3)
      double precision cd(nt)
c
      double precision c1(3)
      integer i

      do i=1,nt
        c1(:)=c(:,i)-cor(:)
        c1(:)=c1(:)*c1(:)
        cd(i)=SUM(c1)
      end do
 
      cd = sqrt(cd)
      return
      end

      subroutine smd_pdb_read_res(filename,nt,nr,tr,ir,nm)
      implicit none
      character*(*) filename
      integer nt,nr,nc
      character*(16) tr(nr)
      integer ir(nt)
      integer nm(nr)
c
      character*(30) pname
      character*(180) buffer
      character*(4)  tag
      character*(16)  rtag,rtag0
      integer ir0,nr0
      integer ncenter
      integer un
c
      pname = "sg_read_res"
c
      un = 70
c
      open(unit=un,status="old",form="formatted",file=filename)

      ncenter = 0
      nr0 = 0
      rtag0 = " "
      ir0 = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        ncenter = ncenter + 1
        read(buffer,*) tag,tag,tag,rtag,ir(ncenter)
        if(ir0.ne.ir(ncenter)) then
          ir0=ir(ncenter)
          nr0 = nr0 + 1
          tr(nr0) = rtag
          rtag0=rtag 
        end if
        ir(ncenter) = nr0
        nm(nr0) = nm(nr0) + 1
      end if
      goto 100
200   continue

      close(un)

      return
      end

      function length(string) 
      implicit none
      integer length
*returns length of string ignoring trailing blanks 
      character*(*) string 
      integer i
      do i = len(string), 1, -1 
         if(string(i:i) .ne. ' ') go to 20 
      end do
20    length = i 
      end 

c $Id: smd_pdb.F 22505 2012-05-21 23:24:13Z d3y133 $

      SUBROUTINE YLASCL( TYPE, KL, KU, CFROM, CTO, M, N, A, LDA, INFO )
c
* $Id: ylascl.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
#include "y64.fh"
      CHARACTER          TYPE
      INTEGER            INFO, KL, KU, LDA, M, N
      DOUBLE PRECISION   CFROM, CTO
      DOUBLE PRECISION   A( LDA, * )
c
      INTGR4            INFO4, KL4, KU4, LDA4, M4, N4
c
      KL4=kl
      KU4=ku
      LDA4=lda 
      M4=m 
      N4=n
c
      call DLASCL( TYPE, KL4, KU4, CFROM, CTO, M4, N4, A, LDA4, INFO4 )
      info=info4
      return
      end

      SUBROUTINE OFFSET_ccsdt_t3_9_1(l_a_offset,k_a_offset,size)
C     $Id: OFFSET_ccsdt_t3_9_1.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h9 h10 p4 h1 h2 h3 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p4b
      INTEGER h9b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      length = 0
      DO p4b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+p4b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h9b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+p4b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdt_t3_9_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p4b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+p4b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h9b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+p4b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h3b - 1 + noab * (h2b - 1 + noab * (h1b 
     &- 1 + noab * (h10b - 1 + noab * (h9b - 1 + noab * (p4b - noab - 1)
     &))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p4b-1) * int_mb(k_range+h9b-1) * int_
     &mb(k_range+h10b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
     & * int_mb(k_range+h3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      SUBROUTINE beta_4(d_d1,d_i0,d_t1,d_t2,d_tr1,d_tr2,d_y1,d_y2,k_d1_o
     &ffset,k_i0_offset,k_t1_offset,k_t2_offset,k_tr1_offset,k_tr2_offse
     &t,k_y1_offset,k_y2_offset)
C     $Id: beta_4.F 19698 2010-10-29 17:03:09Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_ytrd + = -1 * Sum ( h2 h1 ) * d ( h1 h2 )_d * i1 ( h2 h1 )_ytr
C         i1 ( h2 h1 )_ytr + = 1 * Sum ( p3 ) * tr ( p3 h1 )_tr * y ( h2 p3 )_y
C         i1 ( h2 h1 )_ytr + = 1/2 * Sum ( h5 p3 p4 ) * tr ( p3 p4 h1 h5 )_tr * y ( h2 h5 p3 p4 )_y
C     i0 ( )_dtry + = 1 * Sum ( p1 h3 ) * y ( h3 p1 )_y * i1 ( p1 h3 )_dtr
C         i1 ( p1 h3 )_dtr + = 1 * Sum ( p2 ) * d ( p1 p2 )_d * tr ( p2 h3 )_tr
C     i0 ( )_ytrd + = 1 * Sum ( p2 h1 ) * d ( h1 p2 )_d * i1 ( p2 h1 )_ytr
C         i1 ( p2 h1 )_ytr + = 1 * Sum ( h4 p3 ) * tr ( p2 p3 h1 h4 )_tr * y ( h4 p3 )_y
C         i1 ( p2 h1 )_ytrt + = -1 * Sum ( h3 ) * t ( p2 h3 )_t * i2 ( h3 h1 )_ytr
C             i2 ( h3 h1 )_ytr + = 1 * Sum ( p4 ) * tr ( p4 h1 )_tr * y ( h3 p4 )_y
C             i2 ( h3 h1 )_ytr + = 1/2 * Sum ( h6 p4 p5 ) * tr ( p4 p5 h1 h6 )_tr * y ( h3 h6 p4 p5 )_y
C         i1 ( p2 h1 )_yttr + = -1 * Sum ( h7 ) * tr ( p2 h7 )_tr * i2 ( h7 h1 )_yt
C             i2 ( h7 h1 )_yt + = 1 * Sum ( p3 ) * t ( p3 h1 )_t * y ( h7 p3 )_y
C             i2 ( h7 h1 )_yt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * y ( h5 h7 p3 p4 )_y
C         i1 ( p2 h1 )_yttr + = 1/2 * Sum ( h5 h6 p4 ) * tr ( p2 p4 h5 h6 )_tr * i2 ( h5 h6 h1 p4 )_yt
C             i2 ( h5 h6 h1 p4 )_yt + = -1 * Sum ( p3 ) * t ( p3 h1 )_t * y ( h5 h6 p3 p4 )_y
C         i1 ( p2 h1 )_ytrt + = -1/2 * Sum ( h4 h5 p3 ) * t ( p2 p3 h4 h5 )_t * i2 ( h4 h5 h1 p3 )_ytr
C             i2 ( h4 h5 h1 p3 )_ytr + = -1 * Sum ( p6 ) * tr ( p6 h1 )_tr * y ( h4 h5 p3 p6 )_y
C     i0 ( )_ytrd + = 1/2 * Sum ( p2 p1 ) * d ( p1 p2 )_d * i1 ( p2 p1 )_ytr
C         i1 ( p2 p1 )_ytr + = 1 * Sum ( h4 h5 p3 ) * tr ( p2 p3 h4 h5 )_tr * y ( h4 h5 p1 p3 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_d1
      INTEGER k_d1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER l_i1_offset
      INTEGER d_tr1
      INTEGER k_tr1_offset
      INTEGER size_i1
      INTEGER d_tr2
      INTEGER k_tr2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER l_i2_offset
      INTEGER size_i2
      CHARACTER*255 filename
      CALL OFFSET_beta_4_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('beta_4_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL beta_4_1_1(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i1,k_i1_offs
     &et)
      CALL beta_4_1_2(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_i1_offs
     &et)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL beta_4_1(d_d1,k_d1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      CALL OFFSET_beta_4_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('beta_4_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL beta_4_2_1(d_d1,k_d1_offset,d_tr1,k_tr1_offset,d_i1,k_i1_offs
     &et)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL beta_4_2(d_y1,k_y1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      CALL OFFSET_beta_4_3_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('beta_4_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL beta_4_3_1(d_tr2,k_tr2_offset,d_y1,k_y1_offset,d_i1,k_i1_offs
     &et)
      CALL OFFSET_beta_4_3_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('beta_4_3_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL beta_4_3_2_1(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i2,k_i2_of
     &fset)
      CALL beta_4_3_2_2(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i2,k_i2_of
     &fset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL beta_4_3_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_offset
     &)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      CALL OFFSET_beta_4_3_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('beta_4_3_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL beta_4_3_3_1(d_t1,k_t1_offset,d_y1,k_y1_offset,d_i2,k_i2_offs
     &et)
      CALL beta_4_3_3_2(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i2,k_i2_offs
     &et)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL beta_4_3_3(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i1_offs
     &et)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      CALL OFFSET_beta_4_3_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('beta_4_3_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL beta_4_3_4_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i2,k_i2_offs
     &et)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL beta_4_3_4(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i1_offs
     &et)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      CALL OFFSET_beta_4_3_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('beta_4_3_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL beta_4_3_5_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i2,k_i2_of
     &fset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL beta_4_3_5(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_offset
     &)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL beta_4_3(d_d1,k_d1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      CALL OFFSET_beta_4_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('beta_4_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL beta_4_4_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_i1_offs
     &et)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL beta_4_4(d_d1,k_d1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('beta_4',-1,MA_ER
     &R)
      RETURN
      END

c
c $Id: init_velo.f 19707 2010-10-29 17:59:36Z d3y133 $
c
      SUBROUTINE init_velo(iseed)

      implicit none

      include 'p_array.inc'
      include 'cm_atom.inc'
      include 'cm_temp.inc'

      integer i,iatm,iseed

      real*8 x
      real*8 commass,comxvv,comyvv,comzvv
      real*8 instanke,xscale

      comxvv=0.d0
      comyvv=0.d0
      comzvv=0.d0
      commass = 0.0d0

      do i=1,natms

       iatm=atmtype(i)
       call tool_randm(iseed,x)
       vvv(i,1)=(x-0.5)/sqrt(typmass(iatm))
       call tool_randm(iseed,x)
       vvv(i,2)=(x-0.5)/sqrt(typmass(iatm))
       call tool_randm(iseed,x)
       vvv(i,3)=(x-0.5)/sqrt(typmass(iatm))

       comxvv=comxvv+vvv(i,1)*typmass(iatm)
       comyvv=comyvv+vvv(i,2)*typmass(iatm)
       comzvv=comzvv+vvv(i,3)*typmass(iatm)
       commass=commass+typmass(iatm)

      enddo

      comxvv=comxvv/commass
      comyvv=comyvv/commass
      comzvv=comzvv/commass

      do i=1,natms

       vvv(i,1)=vvv(i,1)-comxvv
       vvv(i,2)=vvv(i,2)-comyvv
       vvv(i,3)=vvv(i,3)-comzvv

      enddo

      instanke=0.d0

      do i=1,natms

       instanke=instanke
     $         +typmass(iatm)*((vvv(i,1)**2+vvv(i,2)**2+vvv(i,3)**2))

      enddo

      instanke=0.5*instanke

      xscale=sqrt(targetke/instanke)

      do i=1,natms

       vvv(i,1)=xscale*vvv(i,1)
       vvv(i,2)=xscale*vvv(i,2)
       vvv(i,3)=xscale*vvv(i,3)

      enddo

      return

      END

C$PRAGMA SUN OPT=2
      Subroutine hf1mke3(Axyz,Bxyz,Cxyz,alpha,G,GT,ABC2I,E,
     &                   NABC,La,Lb,Lc)
c $Id: hf1mke3.f 19696 2010-10-29 16:53:42Z d3y133 $

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Dimension Axyz(3),Bxyz(3),Cxyz(3),alpha(4,NABC),G(3,NABC)

      Dimension GT(NABC,3),ABC2I(3*NABC)

      Dimension E(NABC,3,0:(La+Lb+Lc),0:La,0:Lb,0:Lc)
c
c Define the Hermite linear expansion coefficients for the product of 
c three monomials. These coefficients are scaled by a factor appropriate
c for 3-ctr OIs, defined as
c
c         /    PI     \ 3/2     /   a b   __2 \      /   (a + b) c   __2 \
c   ES = | ----------- |    EXP| - -----  AB   | EXP| - -----------  PC   |
c         \ a + b + c /         \  a + b      /      \   a + b + c       /
c
c This scaling factor is passed as the 4th index of the exponents array
c (i.e., "alpha(4,m)").
c
c     Recursion Formulae:
c
c       0,0,0
c     Ex      = ES
c       0
c
c       0,0,0
c     Ey      = 1.0
c       0
c
c       0,0,0
c     Ez      = 1.0
c       0
c
c       Ia+1,Ib,Ic           Ia,Ib,Ic         Ia,Ib,Ic            Ia,Ib,Ic
c     Ex           = ABC2I Ex         + GAx Ex         + (Ip+1) Ex
c       Ip                   Ip-1             Ip                  Ip+1
c
c       Ia,Ib+1,Ic           Ia,Ib,Ic         Ia,Ib,Ic            Ia,Ib,Ic
c     Ex           = ABC2I Ex         + GBx Ex         + (Ip+1) Ex
c       Ip                   Ip-1             Ip                  Ip+1
c
c       Ia,Ib,Ic+1           Ia,Ib,Ic         Ia,Ib,Ic            Ia,Ib,Ic
c     Ex           = ABC2I Ex         + GCx Ex         + (Ip+1) Ex
c       Ip                   Ip-1             Ip                  Ip+1
c
c     Indices for E(m,k,Ip,Ia,Ib,Ic):
c
c     1 [  m  ] NABC
c     1 [  k  ] 3     {X,Y,Z}
c     0 [  Ip ] Ia+Ib+Ic
c     0 [  Ia ] La
c     0 [  Ib ] Lb
c     0 [  Ic ] Lc
c
c******************************************************************************

c Initialize the Hermite expansion coefficients.

      isz_e = NABC*3*(La+Lb+Lc+1)*(La+1)*(Lb+1)*(Lc+1)
      call dcopy(isz_e,0d0,0,E,1)
c Define E(Ip,Ia,Ib,Ic) for Ip=0, Ia=0, Ib=0, Ic=0.

      do 100 m = 1,NABC

       E(m,1,0,0,0,0) = alpha(4,m)
       E(m,2,0,0,0,0) = 1.D0
       E(m,3,0,0,0,0) = 1.D0

       ABC2I(m       ) = 0.5D0/(alpha(1,m) + alpha(2,m) + alpha(3,m))
       ABC2I(m+1*NABC) = ABC2I(m)
       ABC2I(m+2*NABC) = ABC2I(m)

       GT(m,1) = G(1,m) - Axyz(1)
       GT(m,2) = G(2,m) - Axyz(2)
       GT(m,3) = G(3,m) - Axyz(3)

  100 continue

c Define E(Ip,Ia,Ib,Ic) for Ip=0,Ia+Ib+Ic, Ia=1,La, Ib=0, Ic=0.

      do 250 Ia = 1,La

c                          ===>   Ip = 0   <===

       do 210 m = 1,3*NABC
        E(m,1,0,Ia,0,0) =   GT(m,1)*E(m,1,0,Ia-1,0,0)
     &                    +         E(m,1,1,Ia-1,0,0)
  210  continue

c                       ===>   Ip = 1,Ia-1   <===

        do 230 Ip = 1,Ia-1

         do 220 m = 1,3*NABC
          E(m,1,Ip,Ia,0,0) =   ABC2I(m)*E(m,1,Ip-1,Ia-1,0,0)
     &                       +  GT(m,1)*E(m,1,Ip  ,Ia-1,0,0)
     &                       +   (Ip+1)*E(m,1,Ip+1,Ia-1,0,0)
  220   continue

  230  continue

c                         ===>   Ip = Ia   <===

       Ip = Ia

       do 240 m = 1,3*NABC
        E(m,1,Ip,Ia,0,0) =   ABC2I(m)*E(m,1,Ip-1,Ia-1,0,0)
     &                     +  GT(m,1)*E(m,1,Ip  ,Ia-1,0,0)
  240  continue

  250 continue

c Define E(Ip,Ia,Ib,Ic) for Ip=0,Ia+Ib+Ic, Ia=0,La, Ib=1,Lb, Ic=0.

      do 300 m = 1,NABC
       GT(m,1) = G(1,m) - Bxyz(1)
       GT(m,2) = G(2,m) - Bxyz(2)
       GT(m,3) = G(3,m) - Bxyz(3)
  300 continue

      do 360 Ib = 1,Lb

       do 350 Ia = 0,La

c                          ===>   Ip = 0   <===

        do 310 m = 1,3*NABC
         E(m,1,0,Ia,Ib,0) =   GT(m,1)*E(m,1,0,Ia,Ib-1,0)
     &                      +         E(m,1,1,Ia,Ib-1,0)
  310   continue

c                       ===>   Ip = 1,Ia+Ib-1   <===

        do 330 Ip = 1,Ia+Ib-1

         do 320 m = 1,3*NABC
          E(m,1,Ip,Ia,Ib,0) =   ABC2I(m)*E(m,1,Ip-1,Ia,Ib-1,0)
     &                        +  GT(m,1)*E(m,1,Ip  ,Ia,Ib-1,0)
     &                        +   (Ip+1)*E(m,1,Ip+1,Ia,Ib-1,0)
  320    continue

  330   continue

c                        ===>   Ip = Ia+Ib   <===

        Ip = Ia + Ib

        do 340 m = 1,3*NABC
         E(m,1,Ip,Ia,Ib,0) =   ABC2I(m)*E(m,1,Ip-1,Ia,Ib-1,0)
     &                       +  GT(m,1)*E(m,1,Ip  ,Ia,Ib-1,0)
  340   continue

  350  continue

  360 continue

c Define E(Ip,Ia,Ib,Ic) for Ip=0,Ia+Ib+Ic, Ia=0,La, Ib=0,Lb, Ic=1,Lc.

      do 400 m = 1,NABC
       GT(m,1) = G(1,m) - Cxyz(1)
       GT(m,2) = G(2,m) - Cxyz(2)
       GT(m,3) = G(3,m) - Cxyz(3)
  400 continue

      do 470 Ic = 1,Lc

       do 460 Ib = 0,Lb

        do 450 Ia = 0,La

c                          ===>   Ip = 0   <===

         do 410 m = 1,3*NABC
          E(m,1,0,Ia,Ib,Ic) =   GT(m,1)*E(m,1,0,Ia,Ib,Ic-1)
     &                        +         E(m,1,1,Ia,Ib,Ic-1)
  410    continue

c                       ===>   Ip = 1,Ia+Ib+Ic-1   <===

         do 430 Ip = 1,Ia+Ib+Ic-1

          do 420 m = 1,3*NABC
           E(m,1,Ip,Ia,Ib,Ic) =   ABC2I(m)*E(m,1,Ip-1,Ia,Ib,Ic-1)
     &                          +  GT(m,1)*E(m,1,Ip  ,Ia,Ib,Ic-1)
     &                          +   (Ip+1)*E(m,1,Ip+1,Ia,Ib,Ic-1)
  420     continue

  430    continue

c                        ===>   Ip = Ia+Ib+Ic   <===

         Ip = Ia + Ib + Ic

         do 440 m = 1,3*NABC
          E(m,1,Ip,Ia,Ib,Ic) =   ABC2I(m)*E(m,1,Ip-1,Ia,Ib,Ic-1)
     &                         +  GT(m,1)*E(m,1,Ip  ,Ia,Ib,Ic-1)
  440    continue

  450   continue

  460  continue

  470 continue

      end

      logical function argos_prepare_paths()
c
c $Id: argos_prepare_paths.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      logical util_nwchemrc_get
      external util_nwchemrc_get
c
#include "argos_prepare_common.fh"
c
      integer i,j,len,lend,ifc
      character*255 key,value
c
      ndirpar=9
      do 1 i=1,mdirpar
      nfilpar(i)=0
      write(key,'(a,a,i1,a)') ffield(1:index(ffield,' ')-1),'_',i,' '
      if(util_nwchemrc_get(key,value)) then
      len=index(value,' ')-1
      if(len.gt.0) then
      lend=len
      if(len.gt.4) then
      if(value(len-3:len).eq.'.par') then
      do 2 j=1,len
      if(value(j:j).eq.'/') lend=j
    2 continue
      endif
      endif
      dirpar(i)=value(1:lend)
      if(value(lend:lend).ne.'/') dirpar(i)(lend+1:lend+1)='/'
      if(len.eq.lend) then
      nfilpar(i)=1
      filpar(i,1)=ffield(1:index(ffield,' ')-1)//'.par '
      else
      nfilpar(i)=0
      ifc=lend+1
      do 3 j=lend+1,len
      if(value(j:j).eq.',') then
      nfilpar(i)=nfilpar(i)+1
      filpar(i,nfilpar(i))=value(ifc:j-1)//' '
      ifc=j+1
      elseif(j.eq.len) then
      nfilpar(i)=nfilpar(i)+1
      filpar(i,nfilpar(i))=value(ifc:len)//' '
      endif
    3 continue
      endif
      endif
      endif
    1 continue
c
      if(nfilpar(mdirpar).eq.0) then
      nfilpar(mdirpar)=1
      dirpar(mdirpar)='./'
      filpar(mdirpar,1)=ffield(1:index(ffield,' ')-1)//'.par'
      endif
c
c      do 4 i=1,mdirpar
c      if(nfilpar(i).gt.0) then
c      do 5 j=1,nfilpar(i)
c      write(*,'(a,a)') dirpar(i)(1:index(dirpar(i),' ')-1),
c     + filpar(i,j)(1:index(filpar(i,j),' ')-1)
c    5 continue
c      endif
c    4 continue
c
      argos_prepare_paths=.true.
      return
      end

      SUBROUTINE ccsdtq_t4_10_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: ccsdtq_t4_10_3.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 p7 h1 h2 p14 )_vt + = 2/3 * P( 3 ) * Sum ( h10 p9 ) * t ( p5 p6 p9 h1 h2 h10 )_t * v ( h10 p7 p9 p14 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h1b
      INTEGER h2b
      INTEGER p14b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER h10b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p9b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h10b_1
      INTEGER p7b_2
      INTEGER h10b_2
      INTEGER p14b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO p14b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+p14b-1).ne.12)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+p14b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+p14b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+p14b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_t4_10_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      DO h10b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p9b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h10b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p9b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h10b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p5b,p6b,p9b,h1b,h2b,h10b,p5b_1,p6b_1,p9b_1,h
     &1b_1,h2b_1,h10b_1)
      CALL TCE_RESTRICTED_4(p7b,h10b,p14b,p9b,p7b_2,h10b_2,p14b_2,p9b_2)
      dim_common = int_mb(k_range+p9b-1) * int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p7b-1) * int_mb(k_range+p14b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_t4_10_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_t4_10_3',2,MA_ERR)
      IF ((p9b .lt. p5b) .and. (h10b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h10b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p9b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,3,2,4,1,1.0d0)
      END IF
      IF ((p9b .lt. p5b) .and. (h1b .le. h10b) .and. (h10b .lt. h2b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h10b_1 - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p9b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),6,4,3,2,5,1,-1.0d0)
      END IF
      IF ((p9b .lt. p5b) .and. (h2b .le. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p9b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h10b-1),5,4,3,2,6,1,1.0d0)
      END IF
      IF ((p5b .le. p9b) .and. (p9b .lt. p6b) .and. (h10b .lt. h1b)) THE
     &N
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h10b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p9b_1 - noab - 1 + nvab * (p5b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,3,1,4,2,-1.0d0)
      END IF
      IF ((p5b .le. p9b) .and. (p9b .lt. p6b) .and. (h1b .le. h10b) .and
     &. (h10b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h10b_1 - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p9b_1 - noab - 1 + nvab * (p5b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),6,4,3,1,5,2,1.0d0)
      END IF
      IF ((p5b .le. p9b) .and. (p9b .lt. p6b) .and. (h2b .le. h10b)) THE
     &N
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p9b_1 - noab - 1 + nvab * (p5b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h10b-1),5,4,3,1,6,2,-1.0d0)
      END IF
      IF ((p6b .le. p9b) .and. (h10b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h10b_1 - 1 + noab * (p9b_1 - no
     &ab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,2,1,4,3,1.0d0)
      END IF
      IF ((p6b .le. p9b) .and. (h1b .le. h10b) .and. (h10b .lt. h2b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h10b_1 - 1 + noab * (h1b_1 - 1 + noab * (p9b_1 - no
     &ab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),6,4,2,1,5,3,-1.0d0)
      END IF
      IF ((p6b .le. p9b) .and. (h2b .le. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p9b_1 - no
     &ab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h10b-1),5,4,2,1,6,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_t4_10_3',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_t4_10_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_t4_10_3',5,MA_ERR)
      IF ((h10b .le. p7b) .and. (p9b .le. p14b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p14b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (p7b_2 - 1 + (noa
     &b+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+p9b-1),int_mb(k_range+p14b-
     &1),4,2,1,3,1.0d0)
      END IF
      IF ((h10b .le. p7b) .and. (p14b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - 1 + (noab+nvab) * (p14b_2 - 1 + (noab+nvab) * (p7b_2 - 1 + (noa
     &b+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+p14b-1),int_mb(k_range+p9b-
     &1),3,2,1,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_t4_10_3',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_t4_10_3',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_t4_10_3',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_t4_10_3',9,MA_ERR)
      IF ((p6b .le. p7b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p14b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),6,5,2,4,3,1,2.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p14b 
     &- noab - 1 + nvab * (h2b - 1 + noab * (h1b - 1 + noab * (p7b - noa
     &b - 1 + nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p7b .le. p5b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p14b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),2,6,5,4,3,1,2.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p14b 
     &- noab - 1 + nvab * (h2b - 1 + noab * (h1b - 1 + noab * (p6b - noa
     &b - 1 + nvab * (p5b - noab - 1 + nvab * (p7b - noab - 1)))))))
      END IF
      IF ((p5b .le. p7b) .and. (p7b .le. p6b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p14b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),6,2,5,4,3,1,-2.0d0/3
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p14b 
     &- noab - 1 + nvab * (h2b - 1 + noab * (h1b - 1 + noab * (p6b - noa
     &b - 1 + nvab * (p7b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_t4_10_3',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_t4_10_3',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      Subroutine drdy_rsp(nm,n,nv,a,w,matz,z,fv1,fv2,ierr)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION A(NV),W(N),Z(NM,N),FV1(N),FV2(N)
C
C     THIS Subroutine CALLS THE RECOMMENDED SEQUENCE OF
C     SubroutineS FROM THE EIGENSYSTEM Subroutine PACKAGE (EISPACK)
C     TO FIND THE EIGENVALUES AND EIGENVECTORS (IF DESIRED)
C     OF A REAL SYMMETRIC PACKED MATRIX.
C
C     ON INPUT-
C
C        NM  MUST BE SET TO THE ROW DIMENSION OF THE TWO-DIMENSIONAL
C        ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C        DIMENSION STATEMENT,
C
C        N  IS THE ORDER OF THE MATRIX  A,
C
C        NV  IS AN INTEGER VARIABLE SET EQUAL TO THE
C        DIMENSION OF THE ARRAY  A  AS SPECIFIED FOR
C        A  IN THE CALLING PROGRAM.  NV  MUST NOT BE
C        LESS THAN  N*(N+1)/2,
C
C        A  CONTAINS THE LOWER TRIANGLE OF THE REAL SYMMETRIC
C        PACKED MATRIX STORED ROW-WISE,
C
C        MATZ  IS AN INTEGER VARIABLE SET EQUAL TO ZERO IF
C        ONLY EIGENVALUES ARE DESIRED,  OTHERWISE IT IS SET TO
C        ANY NON-ZERO INTEGER FOR BOTH EIGENVALUES AND EIGENVECTORS.
C
C     ON OUTPUT-
C
C        W  CONTAINS THE EIGENVALUES IN ASCENDING ORDER,
C
C        Z  CONTAINS THE EIGENVECTORS IF MATZ IS NOT ZERO,
C
C        IERR  IS AN INTEGER OUTPUT VARIABLE SET EQUAL TO AN
C        ERROR COMPLETION CODE DESCRIBED IN SECTION 2B OF THE
C        DOCUMENTATION.  THE NORMAL COMPLETION CODE IS ZERO,
C
C        FV1  AND  FV2  ARE TEMPORARY STORAGE ARRAYS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
      DATA ZERO,ONE/0.0D0,1.0D0/
      IF (N .LE. NM) GO TO 5
      IERR = 10 * N
      GO TO 50
    5 IF (NV .GE. (N * (N + 1)) / 2) GO TO 10
      IERR = 20 * N
      GO TO 50
C
   10 CALL  drdy_TRED3(N,NV,A,W,FV1,FV2)
      IF (MATZ .NE. 0) GO TO 20
C     ********** FIND EIGENVALUES ONLY **********
      CALL  drdy_TQLRAT(N,W,FV2,IERR)
      GO TO 50
C     ********** FIND BOTH EIGENVALUES AND EIGENVECTORS **********
   20 DO 40 I = 1, N
C
         DO 30 J = 1, N
            Z(J,I) = ZERO
   30    CONTINUE
C
         Z(I,I) = ONE
   40 CONTINUE
C
      CALL  drdy_TQL2(NM,N,W,FV1,Z,IERR)
      IF (IERR .NE. 0) GO TO 50
      CALL  drdy_TRBAK3(NM,N,NV,A,N,Z)
   50 RETURN
C     ********** LAST CARD OF RSP **********
      END
      Subroutine drdy_tql2(nm,n,d,e,z,ierr)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION D(N),E(N),Z(NM,N)
      DOUBLE PRECISION MACHEP
C
C     THIS Subroutine IS A TRANSLATION OF THE ALGOL PROCEDURE TQL2,
C     NUM. MATH. 11, 293-306(1968) BY BOWDLER, MARTIN, REINSCH, AND
C     WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 227-240(1971).
C
C     THIS Subroutine FINDS THE EIGENVALUES AND EIGENVECTORS
C     OF A SYMMETRIC TRIDIAGONAL MATRIX BY THE QL METHOD.
C     THE EIGENVECTORS OF A FULL SYMMETRIC MATRIX CAN ALSO
C     BE FOUND IF  TRED2  HAS BEEN USED TO REDUCE THIS
C     FULL MATRIX TO TRIDIAGONAL FORM.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY,
C
C        Z CONTAINS THE TRANSFORMATION MATRIX PRODUCED IN THE
C          REDUCTION BY  TRED2, IF PERFORMED.  IF THE EIGENVECTORS
C          OF THE TRIDIAGONAL MATRIX ARE DESIRED, Z MUST CONTAIN
C          THE IDENTITY MATRIX.
C
C      ON OUTPUT-
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT BUT
C          UNORDERED FOR INDICES 1,2,...,IERR-1,
C
C        E HAS BEEN DESTROYED,
C
C        Z CONTAINS ORTHONORMAL EIGENVECTORS OF THE SYMMETRIC
C          TRIDIAGONAL (OR FULL) MATRIX.  IF AN ERROR EXIT IS MADE,
C          Z CONTAINS THE EIGENVECTORS ASSOCIATED WITH THE STORED
C          EIGENVALUES,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C                **********
      DATA ZERO,ONE,TWO/0.0D0,1.0D0,2.0D0/
C     ********** MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC.
C
      MACHEP = TWO**(-37)
C
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E(I-1) = E(I)
C
      F = ZERO
      B = ZERO
      E(N) = ZERO
C
      DO 240 L = 1, N
         J = 0
         H = MACHEP * (ABS(D(L)) + ABS(E(L)))
         IF (B .LT. H) B = H
C     ********** LOOK FOR SMALL SUB-DIAGONAL ELEMENT **********
         DO 110 M = L, N
            IF (ABS(E(M)) .LE. B) GO TO 120
C     ********** E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 220
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     ********** FORM SHIFT **********
         L1 = L + 1
         G = D(L)
         P = (D(L1) - G) / (TWO * E(L))
         R = SQRT(P*P+ONE)
         D(L) = E(L) / (P + SIGN(R,P))
         H = G - D(L)
C
         DO 140 I = L1, N
  140    D(I) = D(I) - H
C
         F = F + H
C     ********** QL TRANSFORMATION **********
         P = D(M)
         C = ONE
         S = ZERO
         MML = M - L
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
         DO 200 II = 1, MML
            I = M - II
            G = C * E(I)
            H = C * P
            IF (ABS(P) .LT. ABS(E(I))) GO TO 150
            C = E(I) / P
            R = SQRT(C*C+ONE)
            E(I+1) = S * P * R
            S = C / R
            C = ONE / R
            GO TO 160
  150       C = P / E(I)
            R = SQRT(C*C+ONE)
            E(I+1) = S * E(I) * R
            S = ONE / R
            C = C * S
  160       P = C * D(I) - S * G
            D(I+1) = H + S * (C * G + S * D(I))
C     ********** FORM VECTOR **********
            DO 180 K = 1, N
               H = Z(K,I+1)
               Z(K,I+1) = S * Z(K,I) + C * H
               Z(K,I) = C * Z(K,I) - S * H
  180       CONTINUE
C
  200    CONTINUE
C
         E(L) = S * P
         D(L) = C * P
         IF (ABS(E(L)) .GT. B) GO TO 130
  220    D(L) = D(L) + F
  240 CONTINUE
C     ********** ORDER EIGENVALUES AND EIGENVECTORS **********
      DO 300 II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 260 J = II, N
            IF (D(J) .GE. P) GO TO 260
            K = J
            P = D(J)
  260    CONTINUE
C
         IF (K .EQ. I) GO TO 300
         D(K) = D(I)
         D(I) = P
C
         DO 280 J = 1, N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
  280    CONTINUE
C
  300 CONTINUE
C
      GO TO 1001
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
 1000 IERR = L
 1001 RETURN
C     ********** LAST CARD OF TQL2 **********
      END
      Subroutine drdy_tqlrat(n,d,e2,ierr)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION D(N),E2(N)
      DOUBLE PRECISION MACHEP
C
C     THIS Subroutine IS A TRANSLATION OF THE ALGOL PROCEDURE TQLRAT,
C     ALGORITHM 464, COMM. ACM 16, 689(1973) BY REINSCH.
C
C     THIS Subroutine FINDS THE EIGENVALUES OF A SYMMETRIC
C     TRIDIAGONAL MATRIX BY THE RATIONAL QL METHOD.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E2 CONTAINS THE SQUARES OF THE SUBDIAGONAL ELEMENTS OF THE
C          INPUT MATRIX IN ITS LAST N-1 POSITIONS.  E2(1) IS ARBITRARY.
C
C      ON OUTPUT-
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT AND
C          ORDERED FOR INDICES 1,2,...IERR-1, BUT MAY NOT BE
C          THE SMALLEST EIGENVALUES,
C
C        E2 HAS BEEN DESTROYED,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C                **********
      DATA ZERO,ONE,TWO/0.0D0,1.0D0,2.0D0/
C     ********** MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC.
C
      MACHEP = TWO**(-37)
C
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      DO 100 I = 2, N
  100 E2(I-1) = E2(I)
C
      F = ZERO
      B = ZERO
      E2(N) = ZERO
C
      DO 290 L = 1, N
         J = 0
         H = MACHEP * (ABS(D(L)) + SQRT(E2(L)))
         IF (B .GT. H) GO TO 105
         B = H
         C = B * B
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
  105    DO 110 M = L, N
            IF (E2(M) .LE. C) GO TO 120
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
  110    CONTINUE
C
  120    IF (M .EQ. L) GO TO 210
  130    IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     ********** FORM SHIFT **********
         L1 = L + 1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1) - G) / (TWO * S)
         R = SQRT(P*P+ONE)
         D(L) = S / (P + SIGN(R,P))
         H = G - D(L)
C
         DO 140 I = L1, N
  140    D(I) = D(I) - H
C
         F = F + H
C     ********** RATIONAL QL TRANSFORMATION **********
         G = D(M)
         IF (G .EQ. ZERO) G = B
         H = G
         S = ZERO
         MML = M - L
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
         DO 200 II = 1, MML
            I = M - II
            P = G * H
            R = P + E2(I)
            E2(I+1) = S * R
            S = E2(I) / R
            D(I+1) = H + S * (H + D(I))
            G = D(I) - E2(I) / G
            IF (G .EQ. ZERO) G = B
            H = G * P / R
  200    CONTINUE
C
         E2(L) = S * G
         D(L) = H
C     ********** GUARD AGAINST UNDERFLOW IN CONVERGENCE TEST **********
         IF (H .EQ. ZERO) GO TO 210
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 210
         E2(L) = H * E2(L)
         IF (E2(L) .NE. ZERO) GO TO 130
  210    P = D(L) + F
C     ********** ORDER EIGENVALUES **********
         IF (L .EQ. 1) GO TO 250
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
         DO 230 II = 2, L
            I = L + 2 - II
            IF (P .GE. D(I-1)) GO TO 270
            D(I) = D(I-1)
  230    CONTINUE
C
  250    I = 1
  270    D(I) = P
  290 CONTINUE
C
      GO TO 1001
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
 1000 IERR = L
 1001 RETURN
C     ********** LAST CARD OF TQLRAT **********
      END
      Subroutine drdy_trbak3(nm,n,nv,a,m,z)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(NV),Z(NM,M)
C
C     THIS Subroutine IS A TRANSLATION OF THE ALGOL PROCEDURE TRBAK3,
C     NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     THIS Subroutine FORMS THE EIGENVECTORS OF A REAL SYMMETRIC
C     MATRIX BY BACK TRANSFORMING THOSE OF THE CORRESPONDING
C     SYMMETRIC TRIDIAGONAL MATRIX DETERMINED BY  TRED3.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        NV MUST BE SET TO THE DIMENSION OF THE ARRAY PARAMETER A
C          AS DECLARED IN THE CALLING PROGRAM DIMENSION STATEMENT,
C
C        A CONTAINS INFORMATION ABOUT THE ORTHOGONAL TRANSFORMATIONS
C          USED IN THE REDUCTION BY  TRED3  IN ITS FIRST
C          N*(N+1)/2 POSITIONS,
C
C        M IS THE NUMBER OF EIGENVECTORS TO BE BACK TRANSFORMED,
C
C        Z CONTAINS THE EIGENVECTORS TO BE BACK TRANSFORMED
C          IN ITS FIRST M COLUMNS.
C
C     ON OUTPUT-
C
C        Z CONTAINS THE TRANSFORMED EIGENVECTORS
C          IN ITS FIRST M COLUMNS.
C
C     NOTE THAT TRBAK3 PRESERVES VECTOR EUCLIDEAN NORMS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
      DATA ZERO/0.0D0/
      IF (M .EQ. 0) GO TO 200
      IF (N .EQ. 1) GO TO 200
C
      DO 140 I = 2, N
         L = I - 1
         IZ = (I * L) / 2
         IK = IZ + I
         H = A(IK)
         IF (H .EQ. ZERO) GO TO 140
C
         DO 130 J = 1, M
            S = ZERO
            IK = IZ
C
            DO 110 K = 1, L
               IK = IK + 1
               S = S + A(IK) * Z(K,J)
  110       CONTINUE
C     ********** DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW **********
            S = (S / H) / H
            IK = IZ
C
            DO 120 K = 1, L
               IK = IK + 1
               Z(K,J) = Z(K,J) - S * A(IK)
  120       CONTINUE
C
  130    CONTINUE
C
  140 CONTINUE
C
  200 RETURN
C     ********** LAST CARD OF TRBAK3 **********
      END
      Subroutine drdy_tred3(n,nv,a,d,e,e2)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION A(NV),D(N),E(N),E2(N)
C
C     THIS Subroutine IS A TRANSLATION OF THE ALGOL PROCEDURE TRED3,
C     NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     THIS Subroutine REDUCES A REAL SYMMETRIC MATRIX, STORED AS
C     A ONE-DIMENSIONAL ARRAY, TO A SYMMETRIC TRIDIAGONAL MATRIX
C     USING ORTHOGONAL SIMILARITY TRANSFORMATIONS.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        NV MUST BE SET TO THE DIMENSION OF THE ARRAY PARAMETER A
C          AS DECLARED IN THE CALLING PROGRAM DIMENSION STATEMENT,
C
C        A CONTAINS THE LOWER TRIANGLE OF THE REAL SYMMETRIC
C          INPUT MATRIX, STORED ROW-WISE AS A ONE-DIMENSIONAL
C          ARRAY, IN ITS FIRST N*(N+1)/2 POSITIONS.
C
C     ON OUTPUT-
C
C        A CONTAINS INFORMATION ABOUT THE ORTHOGONAL
C          TRANSFORMATIONS USED IN THE REDUCTION,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX,
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL
C          MATRIX IN ITS LAST N-1 POSITIONS.  E(1) IS SET TO ZERO,
C
C        E2 CONTAINS THE SQUARES OF THE CORRESPONDING ELEMENTS OF E.
C          E2 MAY COINCIDE WITH E IF THE SQUARES ARE NOT NEEDED.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C     ********** FOR I=N STEP -1 UNTIL 1 DO -- **********
      DATA ZERO/0.0D0/
      DO  300 II = 1, N
         I = N + 1 - II
         L = I - 1
         IZ = (I * L) / 2
         H = ZERO
         SCALE = ZERO
         IF (L .LT. 1) GO TO 130
C     ********** SCALE ROW (ALGOL TOL THEN NOT NEEDED) **********
         DO 120 K = 1, L
            IZ = IZ + 1
            D(K) = A(IZ)
            SCALE = SCALE + ABS(D(K))
  120    CONTINUE
C
         IF (SCALE .NE. ZERO) GO TO 140
  130    E(I) = ZERO
         E2(I) = ZERO
         GO TO 290
C
  140    DO 150 K = 1, L
            D(K) = D(K) / SCALE
            H = H + D(K) * D(K)
  150    CONTINUE
C
         E2(I) = SCALE * SCALE * H
         F = D(L)
         G = -SIGN(SQRT(H),F)
         E(I) = SCALE * G
         H = H - F * G
         D(L) = F - G
         A(IZ) = SCALE * D(L)
         IF (L .EQ. 1) GO TO 290
         F = ZERO
C
         DO 240 J = 1, L
            G = ZERO
            JK = (J * (J-1)) / 2
C     ********** FORM ELEMENT OF A*U **********
            DO 180 K = 1, L
               JK = JK + 1
               IF (K .GT. J) JK = JK + K - 2
               G = G + A(JK) * D(K)
  180       CONTINUE
C     ********** FORM ELEMENT OF P **********
            E(J) = G / H
            F = F + E(J) * D(J)
  240    CONTINUE
C
         HH = F / (H + H)
         JK = 0
C     ********** FORM REDUCED A **********
         DO 260 J = 1, L
            F = D(J)
            G = E(J) - HH * F
            E(J) = G
C
            DO 260 K = 1, J
               JK = JK + 1
               A(JK) = A(JK) - F * E(K) - G * D(K)
  260    CONTINUE
C
  290    D(I) = A(IZ+1)
         A(IZ+1) = SCALE * SQRT(H)
  300 CONTINUE
C
      RETURN
C     ********** LAST CARD OF TRED3 **********
      END
c $Id: rsp.F 21176 2011-10-10 06:35:49Z d3y133 $

#define OMPCOLLAPSE 3
      SUBROUTINE ccsd_t_doubles_l(a_i0,
     &d_t2,d_v2,k_t2_offset,k_v2_offset,t
     &_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,toggle)
C     $Id: ccsd_t_doubles_l.F 25793 2014-06-11 21:38:37Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = -1 * P( 9 ) * Sum ( h7 ) * t ( p4 p5 h1 h7 )_t * v ( h7 p6 h2 h3 )_v
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = -1 * P( 9 ) * Sum ( p7 ) * t ( p4 p7 h1 h2 )_t * v ( p5 p6 h3 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "offl.fh"
#include "ccsd_t_ps.fh"
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER toggle
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      integer l_v2sub
      integer k_v2sub
      integer l_t2sub
      integer k_t2sub
      integer l_scratch
      integer k_scratch
      DOUBLE PRECISION a_i0(*)
      
      DOUBLE PRECISION krnl_start
      logical offload_master
      external offload_master
      integer range_p4,range_h1,ii
      integer t2size,v2size
      
      krnl_start = util_wallsec()
      
c *** debug ***
c      write(6,*)'I am in ccsd_t_doubles',ga_nodeid()
c      call util_flush(6)
c *************
      call ccsd_t_v2t2lgth(t2size,v2size)
      if (otceps) call pstat_on(ps_cctdbl)
      IF (.not.MA_PUSH_GET(mt_dbl,t2size,'t2sub',
     L     l_t2sub,k_t2sub)) CALL
     & ERRQUIT('ccsd_t_doubles t2sub',101,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,max(t2size,v2size),'t2sub',
     L     l_scratch,k_scratch)) CALL
     & ERRQUIT('ccsd_t_doubles scratch',102,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,v2size,'v2sub',
     L     l_v2sub,k_v2sub)) CALL
     & ERRQUIT('ccsd_t_doubles v2sub',103,MA_ERR)

      IF (toggle .eq. 2) then
      if(offload_master()) then
         CALL offl0_ccsd_t_doubles_l_12(d_t2,
     &        k_t2_offset,d_v2,k_v2_offset,
     A        a_i0,t_p4b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b,
     T        dbl_mb(k_v2sub),dbl_mb(k_t2sub),
     S        dbl_mb(k_scratch))
      else
         CALL ccsd_t_doubles_l_12(d_t2,
     &        k_t2_offset,d_v2,k_v2_offset,
     A        a_i0,t_p4b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b,
     T        dbl_mb(k_v2sub),dbl_mb(k_t2sub),
     S        dbl_mb(k_scratch))
         endif
      endif
      IF (.not.MA_chop_stack(l_t2sub)) CALL
     & ERRQUIT('ccsd_t_doubles_1',103,MA_ERR)
      if (otceps) call pstat_off(ps_cctdbl)
      
      RETURN
      END
      subroutine ccsd_t_v2t2lgth(t2size,v2size)
      implicit none
#include "mafdecls.fh"
#include "tce.fh"
c     compute v2sub and t2sub max length
      integer t2size,v2size ! [out]
c
      integer range_p4,range_h1,ii
c
      range_p4=0
      do ii = noab+1,noab+nvab
         range_p4 = max(range_p4,int_mb(k_range+ii-1))
      enddo
      range_h1=0
      do ii = 1,noab
         range_h1 = max(range_h1,int_mb(k_range+ii-1))
      enddo
      t2size=(range_p4**2)*(range_h1**2)
      v2size=max((range_p4)*(range_h1**3),
     M     (range_p4**3)*(range_h1))
      call util_align64(t2size)
      call util_align64(v2size)
      return
      end
      subroutine util_align64(in)
      implicit none
#include "mafdecls.fh"
      integer in,alignval
      alignval=64/MA_sizeof(MT_DBL,1,MT_BYTE)
      if(mod(in,alignval).ne.0) in=(1+in/alignval)*alignval
      return
      end
      subroutine ccsd_t_transpt2(t2sub,scratch,
     c     h1d,p5d,p4d,h7d)
      implicit none
      integer h1d,p5d,p4d,h7d
      double precision scratch(h7d,p4d,p5d,h1d)
      double precision t2sub(h1d,p5d,p4d,h7d)
c
      integer h1,p5,p4,h7
c     
      integer pp5,hh1
!DIR$ ASSUME_ALIGNED t2sub: 64
!DIR$ ASSUME_ALIGNED scratch: 64
c
      call dcopy(h1d*p5d*p4d*h7d,t2sub,1,scratch,1)
#define CHUNK 16
!$omp parallel do private(h7,p4,pp5,hh1,p5,h1) collapse(2)
      do h7=1,h7d
         do p4=1,p4d
            do pp5=1,p5d,CHUNK
               do hh1=1,h1d,CHUNK
                  do p5=pp5,min(pp5+CHUNK-1,p5d)
!DEC$ LOOP COUNT AVG=CHUNK
cc!deC$ SIMD
                     do h1=hh1,min(hh1+CHUNK-1,h1d)
                        t2sub(h1,p5,p4,h7)=scratch(h7,p4,p5,h1)
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      return
      end
      subroutine ccsd_t_detranspt2(t2sub,scratch,
     c     h1d,p5d,p4d,h7d)
      implicit none
      integer h1d,p5d,p4d,h7d
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision scratch(h1d,p5d,p5d,h7d)
c
      integer h1,p5,p4,h7
c     
      integer pp5,hh1
c
      call dcopy(h1d*p5d*p4d*h7d,scratch,1,t2sub,1)
      return
      end
      subroutine ccsd_t_transpt2_7124(t2sub,scratch,
     c    p4d,h1d,h2d,p7d)
      implicit none
      integer p4d,h1d,h2d,p7d
      double precision scratch(p7d,p4d,h1d,h2d)
      double precision t2sub(p7d,h2d,h1d,p4d)
c
      integer p4,h1,h2,p7
c     
      integer hh2,pp7
!DIR$ ASSUME_ALIGNED t2sub: 64
!DIR$ ASSUME_ALIGNED scratch: 64
c
      call dcopy(p4d*h1d*h2d*p7d,t2sub,1,scratch,1)
#define CHUNK 16
!$omp parallel do private(p4,h1,hh2,pp7,h2,p7) collapse(2)
      do p4=1,p4d
         do h1=1,h1d
            do hh2=1,h2d,CHUNK
               do pp7=1,p7d,CHUNK
                  do h2=hh2,min(hh2+CHUNK-1,h2d)
!DEC$ LOOP COUNT AVG=CHUNK
cc!deC$ SIMD
                     do p7=pp7,min(pp7+CHUNK-1,p7d)
                        t2sub(p7,h2,h1,p4)=scratch(p7,p4,h1,h2)
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      return
      end
      subroutine sd_t_d1_1(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h2d,h1d,p6d,p5d,p4d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h2,h1,p6,p5,p4)=triplesx(h3,h2,h1,p6,p5,p4)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_2(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h1d,h2d,p6d,p5d,p4d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h1,h2,p6,p5,p4)=triplesx(h3,h1,h2,p6,p5,p4)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo  
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_3(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h1d,h3d,h2d,p6d,p5d,p4d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
      do h7=1,h7d
       triplesx(h1,h3,h2,p6,p5,p4)=triplesx(h1,h3,h2,p6,p5,p4)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_4(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h2d,h1d,p5d,p4d,p6d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p6=1,p6d
      do p4=1,p4d
      do p5=1,p5d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h2,h1,p5,p4,p6)=triplesx(h3,h2,h1,p5,p4,p6)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_5(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h1d,h2d,p5d,p4d,p6d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p6=1,p6d
      do p4=1,p4d
      do p5=1,p5d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h1,h2,p5,p4,p6)=triplesx(h3,h1,h2,p5,p4,p6)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_6(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h1d,h3d,h2d,p5d,p4d,p6d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p6=1,p6d
      do p4=1,p4d
      do p5=1,p5d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
      do h7=1,h7d
       triplesx(h1,h3,h2,p5,p4,p6)=triplesx(h1,h3,h2,p5,p4,p6)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_7(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h2d,h1d,p5d,p6d,p4d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p6=1,p6d
      do p5=1,p5d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h2,h1,p5,p6,p4)=triplesx(h3,h2,h1,p5,p6,p4)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_8(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h1d,h2d,p5d,p6d,p4d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p6=1,p6d
      do p5=1,p5d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h1,h2,p5,p6,p4)=triplesx(h3,h1,h2,p5,p6,p4)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d1_9(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h1d,h3d,h2d,p5d,p6d,p4d)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,h7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p6=1,p6d
      do p5=1,p5d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
      do h7=1,h7d
       triplesx(h1,h3,h2,p5,p6,p4)=triplesx(h1,h3,h2,p5,p6,p4)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_1(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h3d,h2d,h1d,p6d,p5d,p4d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do p7=1,p7d
       triplesx(h3,h2,h1,p6,p5,p4)=triplesx(h3,h2,h1,p6,p5,p4)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_2(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h1d,h3d,p6d,p5d,p4d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h3=1,h3d
      do h1=1,h1d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h1,h3,p6,p5,p4)=triplesx(h2,h1,h3,p6,p5,p4)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_3(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h3d,h1d,p6d,p5d,p4d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h1=1,h1d
      do h3=1,h3d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h3,h1,p6,p5,p4)=triplesx(h2,h3,h1,p6,p5,p4)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_4(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h3d,h2d,h1d,p6d,p4d,p5d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p5=1,p5d
      do p4=1,p4d
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do p7=1,p7d
       triplesx(h3,h2,h1,p6,p4,p5)=triplesx(h3,h2,h1,p6,p4,p5)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_5(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h1d,h3d,p6d,p4d,p5d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p5=1,p5d
      do p4=1,p4d
      do p6=1,p6d
      do h3=1,h3d
      do h1=1,h1d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h1,h3,p6,p4,p5)=triplesx(h2,h1,h3,p6,p4,p5)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_6(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h3d,h1d,p6d,p4d,p5d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p5=1,p5d
      do p4=1,p4d
      do p6=1,p6d
      do h1=1,h1d
      do h3=1,h3d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h3,h1,p6,p4,p5)=triplesx(h2,h3,h1,p6,p4,p5)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_7(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h3d,h2d,h1d,p4d,p6d,p5d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p5=1,p5d
      do p6=1,p6d
      do p4=1,p4d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do p7=1,p7d
       triplesx(h3,h2,h1,p4,p6,p5)=triplesx(h3,h2,h1,p4,p6,p5)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_8(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h1d,h3d,p4d,p6d,p5d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p5=1,p5d
      do p6=1,p6d
      do p4=1,p4d
      do h3=1,h3d
      do h1=1,h1d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h1,h3,p4,p6,p5)=triplesx(h2,h1,h3,p4,p6,p5)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end
c
      subroutine sd_t_d2_9(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h3d,h1d,p4d,p6d,p5d)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
#ifdef USE_OPENMP
!$omp parallel do private(p5,p6,p4,h1,h3,h2,p7) collapse(OMPCOLLAPSE)
#endif
      do p5=1,p5d
      do p6=1,p6d
      do p4=1,p4d
      do h1=1,h1d
      do h3=1,h3d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h3,h1,p4,p6,p5)=triplesx(h2,h3,h1,p4,p6,p5)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
#ifdef USE_OPENMP
!$omp end parallel do
#endif
      return
      end

      subroutine argos_print()
c
      implicit none
c
#include "argos.fh"
c
      character*22 ctype
c
      if(me.eq.0) then
      if(lfnout.ne.6)
     + open(unit=lfnout,file=filout(1:index(filout,' ')-1),
     + form='formatted',status='unknown')
c
      if(ntype.eq.0) then
      ctype='ENERGY EVALUATION     '
      elseif(ntype.eq.1) then
      ctype='ENERGY MINIMIZATION   '
      elseif(ntype.eq.2) then
      ctype='MOLECULAR DYNAMICS    '
      elseif(ntype.eq.3) then
      ctype='FREE ENERGY EVALUATION'
      else
      call md_abort('Unknown calculation type',ntype)
      endif
c
      call swatch(today,now)
      write(lfnout,1000) ctype,today,now,npw,npg,np,ncp
 1000 format(' ARGOS MOLECULAR DYNAMICS SIMULATION PACKAGE',//,
     + ' MODULE: ',a22,t110,2a10,//,
     + ' Number of processes',t30,i6,/,
     + ' Number of process groups',t30,i6,/,
     + ' Number of processes in group',t30,i6,/,
     + ' Number of cores per cell',t30,i6,/)
c
      write(lfnout,1001) titinp(1),datinp,timinp,titinp(2),titinp(3)
 1001 format(/,' Title ',t10,a,t110,2a10,/,t10,a,/,t10,a)
c
      write(lfnout,1002) filnam(1:index(filnam,' ')-1)
 1002 format(/,' System ',a)
c
      if(ntype.le.2) then
      write(lfnout,1003) iset
 1003 format(/,' Force field parameter set ',i4)
      endif
c
      if(nserie.eq.0) then
      write(lfnout,1026)
 1026 format(/,' Initial simulation',/)
      elseif(nserie.eq.1) then
      write(lfnout,1027)
 1027 format(/,' Restart simulation',/)
      else
      write(lfnout,1028)
 1028 format(/,' Continuation simulation',/)
      endif
c
      if(ntype.eq.3) then
      if(mropt.eq.0) then
      write(lfnout,1032)
 1032 format(' Multiple run initial simulation')
      elseif(mropt.eq.1) then
      write(lfnout,1033)
 1033 format(' Multiple run simulation with initial conditions')
      else
      write(lfnout,1034)
 1034 format(' Multiple run extension simulation')
      endif
      write(lfnout,1025) mrun
 1025 format(' Number of runs ',i7)
      endif
      if(ntype.ge.2) then
      write(lfnout,1024) mequi,mdacq
 1024 format(' Number of equilibration steps ',i7,/
     + ' Number of data gathering steps',i7)
      endif
c
      if(ntype.eq.3.and.issscl.gt.0) then
      write(lfnout,1029) ssshft
 1029 format(/,' Separation shifted scaling, delta ',f12.6,' nm**2')
      endif
c
      if(ipme.gt.0) then
      write(lfnout,1030) morder,ngx,ngy,ngz,nodpme,pmetol
 1030 format(/,' Particle-mesh Ewald, spline to order ',i5,/,
     + ' Grid size ',i5,'x',i5,'x',i5,/,
     + ' Number of processors for p-FFT ',i5,/,
     + ' Tolerance at cutoff ',1pe12.5)
      if(imfft.le.1) then
      write(lfnout,1036)
 1036 format(' Using NWChem 3D-pFFT')
      else
      write(lfnout,1037)
#if defined(ESSL)
 1037 format(' Using PESSL 3D-pFFT')
#else
 1037 format(' Using system specific 3D-pFFT')
#endif
      endif
      endif
c
      if(ipolt.eq.1) then
      write(lfnout,1031) mpolit,ptol
 1031 format(/,' Polarization model, maximum iterations ',i5,/,
     + ' Tolerance ',1pe12.5)
      endif
c
      if(.not.ltwin) then
      write(lfnout,1004) rshort
 1004 format(/,' Cutoff radius ',f12.6, ' nm')
      else
      write(lfnout,1005) rshort,rlong
 1005 format(/,' Cutoff radius short range ',f12.6, ' nm',
     +       /,' Cutoff radius long range  ',f12.6, ' nm')
      endif
c
      if(ifield.gt.0) then
      write(lfnout,1035) xfield,xffreq,xfvect
 1035 format(/,' External electrostatic field strength ',f12.6,/,
     + 25x,'frequency ',f12.6,/,
     + 25x,'field vector ',3f12.6)
      endif
c
      if(ntype.ge.2) then
      if(ivreas.ne.0) then
      if(ivreas.gt.0) then
      write(lfnout,1022) tgauss,ivreas
 1022 format(/,' Velocity reassignment temperature ',f12.6,' K',/,
     + ' Velocity reassignment frequency   ',i5,/)
      else
      write(lfnout,1122) tgauss
 1122 format(/,' Velocity reassignment temperature ',f12.6,' K',/,
     + ' Velocity reassignment in first step only',/)
      endif
      endif
      if(itscal.gt.0) then
      write(lfnout,1021) tmpext1,tmpext2,tmprlx,tmsrlx,tann1,tann2
 1021 format(/,' Isothermal ensemble external temperature ',
     + 2f12.6,' K',/,
     + ' Temperature relaxation time solvent      ',f12.6,' ps',/,
     + ' Temperature relaxation time solute       ',f12.6,' ps',/,
     + ' Temperature annealing between times      ',2f12.6,' ps')
      endif
      if(ipscal.ne.0) then
      write(lfnout,1023) prsext,prsrlx,compr
 1023 format(' Isobaric ensemble external pressure ',1pe12.5,' Pa',/,
     + ' Pressure relaxation time ',0pf12.6,' ps',/,
     + ' Compressebility ',1pe12.5,' m**2/N')
      if(ipopt.eq.12) write(lfnout,2023)
 2023 format(' Pressure scaling in x and y only')
      if(ipopt.eq.3) write(lfnout,3023)
 3023 format(' Pressure scaling in z only')
      if(ipopt.eq.123) write(lfnout,3024)
 3024 format(' Pressure scaling in x and y separate from z')
      endif
      if(iguide.gt.0) then
      write(lfnout,1038) fguide,tguide
 1038 format(/,' Self-guided molecular dynamics with force coupling of',
     + f8.5,' and relaxation time of',f8.5,' ps')
      endif
      if(mdalgo.eq.1) then
      write(lfnout,1039)
 1039 format(/,' Leap-frog integration')
      else
      write(lfnout,1040)
 1040 format(/,' Leap-frog integration (Brown-Clarke)')
      endif
      endif
c
      if(scaleq.ge.zero) then
      write(lfnout,1041) scaleq
 1041 format(/,' Solute charges scaled by factor ',f8.5)
      endif
c
      if(ntype.eq.1) then
      if(msdit.gt.0) then
      write(lfnout,1006) msdit,dx0sd,dxmsd,dxsdmx
 1006 format(/,' Maximum number of steepest descent steps ',i5,/,
     + ' Initial step size ',f12.6,' nm',/,
     + ' Maximum step size ',f12.6,' nm',/,
     + ' Minimum step size ',f12.6,' nm')
      endif
      if(mcgit.gt.0) then
      write(lfnout,1007) mcgit,ncgcy,dx0cg,dxsdmx
 1007 format(/,' Maximum number of conjugate gradient steps ',i5,/,
     + ' Number of conjugate gradient steps per cycle ',i5,/,
     + ' Initial interval size ',f12.6,' nm',/,
     + ' Minimum step size ',f12.6,' nm')
      endif
      endif
c
      write(lfnout,1008) mshitw,tlwsha,mshits,tlssha
 1008 format(/,' Maximum number of solvent SHAKE iterations ',i5,
     + ', solvent SHAKE tolerance ',f12.6,' nm',/,
     + ' Maximum number of solute SHAKE iterations  ',i5,
     + ', solute SHAKE tolerance  ',f12.6,' nm',/)
c
      if(ntype.ge.2) then
      write(lfnout,1019) nfpair
 1019 format(' Frequency update pair lists ',t55,i5)
      if(ltwin) write(lfnout,1020) nflong
 1020 format(' Frequency update long range forces ',t55,i5)
      write(lfnout,1017) nfslow
 1017 format(' Frequency removal overall motion ',t55,i5)
      write(lfnout,1018) nfcntr
 1018 format(' Frequency solute centering ',t55,i5)
      if(icentr.eq.1) write(lfnout,1818)
 1818 format(' Centering in z-direction only')
      if(icentr.eq.2) write(lfnout,1819)
 1819 format(' Centering in xyplane only')
      write(lfnout,1009) nfoutp
 1009 format(' Frequency printing step information ',t55,i5)
      write(lfnout,1010) nfstat
 1010 format(' Frequency printing statistical information ',t55,i5)
      endif
      if(ntype.eq.1) then
      write(lfnout,1011) nfqrs
 1011 format(' Frequency recording minimum energy structure ',t55,i5)
      endif
      if(ntype.ge.2) then
      write(lfnout,1012) nfrest
 1012 format(' Frequency recording restart file ',t55,i5)
      write(lfnout,1013) nfcoor
 1013 format(' Frequency recording system coordinates ',t55,i5)
      write(lfnout,1014) nfscoo
 1014 format(' Frequency recording solute coordinates ',t55,i5)
      write(lfnout,1015) nfvelo
 1015 format(' Frequency recording system velocities ',t55,i5)
      write(lfnout,1016) nfsvel
 1016 format(' Frequency recording solute velocities ',t55,i5)
      write(lfnout,1115) nfforc
 1115 format(' Frequency recording system forces ',t55,i5)
      write(lfnout,1116) nfsfor
 1116 format(' Frequency recording solute forces ',t55,i5)
      endif
c
      write(lfnout,2000)
 2000 format(/,' LOAD BALANCING',/)
c
 
      if(loadb.eq.0) write(lfnout,2001)
 2001 format(' None')
      if(loadb.eq.2) write(lfnout,2002)
 2002 format(' Redistribution of inter-processor box pairs')
      if(loadb.eq.1) write(lfnout,2003) factld
 2003 format(' Resizing of processor domains: smallest scaling ',
     + t55,f12.6)
      if(loadb.eq.3) write(lfnout,2004) lbpair,factld
 2004 format(' Redistribution of inter-processor box pairs: retry ',
     + t55,i5,/,' Resizing of processor domains: smallest scaling ',
     + t55,f12.6)
      if(isload.gt.0) write(lfnout,2104)
 2104 format(' Resizing in z-dimension only')
c
      if(ireset.gt.0) write(lfnout,2005)
 2005 format(/,' Load balancing reset')
c
      write(lfnout,2012) nfload
 2012 format(/,' Load balancing frequency ',i5)
c
      if(itload.eq.0) write(lfnout,2006)
 2006 format(/,' Load balancing based on last synchronization time')
      if(itload.eq.1) write(lfnout,2007)
 2007 format(/,' Load balancing based on minimum synchronization time')
      if(itload.eq.2) write(lfnout,2008)
 2008 format(/,' Load balancing based on average synchronization time')
      if(itload.eq.3) write(lfnout,2009)
 2009 format(/,' Load balancing based on average synchronization time',
     + ' with minimum synchronization time on processor 0')
c
      if(ioload.eq.1) write(lfnout,2010)
 2010 format(/,' Time for I/O counted at each step')
      if(ioload.eq.1) write(lfnout,2011)
 2011 format(/,' Experimental load balancing')
c
      if(nfhop.gt.0) then
c
      write(lfnout,3000)
 3000 format(/,' QHOP PROTON HOPPING',/)
c
      write(lfnout,3001) nfhop
 3001 format(' Frequency hopping attempts ',t55,i5)
      write(lfnout,3002) rhop
 3002 format(' Donor-acceptor cutoff distance',t55,f12.6,' nm')
      write(lfnout,3003) thop
 3003 format(' Minimum time before backhop',t55,f12.6,' ps')
c
      endif
c
      endif
c
      return
      end
c $Id: argos_print.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine ccsd_left(d_f1,d_lr1,d_lr2,d_t1,d_t2,d_v2,d_lambda1,
     1       d_lambda2,k_f1_offset,k_l1_offset,k_t1_offset,
     2       k_t2_offset,k_v2_offset,k_l2_offset,size_l1,size_l2,
     3       iter,nodezero,residual)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
      integer d_f1,d_lr1,d_lr2,d_t1,d_t2,d_v2,d_lambda1,d_lambda2
      integer k_f1_offset,k_l1_offset,k_t1_offset,k_t2_offset
      integer k_v2_offset,k_l2_offset,size_l1,size_l2
      character*255 filename
      double precision cpu, wall
      logical nodezero
c      integer iter,dummy
      integer dummy
      double precision r1, r2, residual
      double precision ddotfile
      external ddotfile
c
      call tce_diis_init()
      do iter=1,maxiter
         cpu=-util_cpusec()
         wall=-util_wallsec()
         if (nodezero.and.(iter.eq.1)) write(LuOut,9400) "CCSD Lambda"
         call tce_filename('lr1',filename)
         call createfile(filename,d_lr1,size_l1)
         call ccsd_lambda1(d_f1,d_lr1,d_t1,d_t2,d_v2,d_lambda1,
     1         d_lambda2,k_f1_offset,k_l1_offset,k_t1_offset,
     2         k_t2_offset,k_v2_offset,k_l1_offset,k_l2_offset)
c         print *,iter,'ccsd_lambda1'
         call reconcilefile(d_lr1,size_l1)
         call tce_filename('lr2',filename)
         call createfile(filename,d_lr2,size_l2)
         call ccsd_lambda2(d_f1,d_lr2,d_t1,d_t2,d_v2,d_lambda1,
     1         d_lambda2,k_f1_offset,k_l2_offset,k_t1_offset,
     2         k_t2_offset,k_v2_offset,k_l1_offset,k_l2_offset)
c         print *,iter,'ccsd_lambda2'
         r1 = ddotfile(d_lr1,d_lr1,size_l1)
         r2 = ddotfile(d_lr2,d_lr2,size_l2)
         residual = max(r1,r2)
         cpu=cpu+util_cpusec()
         wall=wall+util_wallsec()
         if (nodezero) write(LuOut,9420) iter,residual,cpu,wall
         if (residual .lt. thresh) then
            if (nodezero) then
               write(LuOut,9410)
            endif
            call deletefile(d_lr2)
            call deletefile(d_lr1)
            call tce_diis_tidy()
            goto 2000
         endif
         call tce_diis(.true.,iter,.true.,.true.,.false.,.false.,
     1                  d_lr1,d_lambda1,k_l1_offset,size_l1,
     2                  d_lr2,d_lambda2,k_l2_offset,size_l2,
     3                  dummy,dummy,dummy,dummy,
     4                  dummy,dummy,dummy,dummy)
         call deletefile(d_lr2)
         call deletefile(d_lr1)
         if (nodezero) call util_flush(LuOut)
      enddo
      call errquit('tce_energy: maxiter exceeded',iter,CALC_ERR)

 2000 continue
 9400 format(/,1x,A,' iterations',/,
     1  1x,'--------------------------------------',/
     2  1x,'Iter          Residuum     Cpu    Wall',/
     3  1x,'--------------------------------------')
 9410 format(
     1  1x,'--------------------------------------',/
     2  1x,'Iterations converged')
 9420 format(1x,i4,f18.13,2f8.1)
      end
c $Id: ccsd_left.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup selci
C> @{
      subroutine selci_restin(iconf,ept,ept_mp,enew,ptnorm,ptnorm_mp,
     &                  nroot,irange,nrange,iwpt,
     &                  noconf,ioconf,nintpo,nconmx,ncold)
*
* $Id: restin.F 24790 2013-11-11 18:56:49Z d3y133 $
*
      implicit real*8(a-h,o-z), integer(i-n)
#include "errquit.fh"
      dimension ioconf(nintpo,nconmx),irange(nrange),
     &          ept(nroot),enew(nroot),ptnorm(nroot),
     &          ept_mp(nroot),ptnorm_mp(nroot)
c
c     irest = unit for restart tape 'selci.r.?'
c            ? is 1 or 2
c     istde = standard error
c     istdo = standard output
c 
      parameter(irest = 69)
      parameter(istde=0,istdo=6)
      logical doesit
#include "cselcifiles.fh"
#include "global.fh"
      me = ga_nodeid()
      master = 0
      if (me.ne.master) goto 90000
c
c check existence of file
c
      ifile = 1
      doesit = .false.
      inquire(file=names(1),exist=doesit)
      if (doesit) goto 1
      inquire(file=names(2),exist=doesit)
      if (doesit) then
         ifile = 2
      else
         goto 90000
      endif
c      

 1    open(unit=irest,file=names(ifile),access='sequential',
     &     form='unformatted',status='old',
     &     err=90911)
c
      read(irest)iconf,incold,inroot,inrang,inocnf,inntpo,incnmx,iniwpt
      nloop = inocnf
      if (incold.ne.ncold)   goto 91911
      if (inroot.ne.nroot)   goto 91911
      if (inrang.ne.nrange)  goto 91911
      if (inntpo.ne.nintpo)  goto 91911
      if (iniwpt.ne.iwpt)  then
         iwpt = iniwpt
         write(6,*)' switching pt selection procedure '
         if (iwpt.lt.0 .or. iwpt.gt.3) call errquit('rest: iwpt',iwpt,
     &       UNKNOWN_ERR)
      endif
      read(irest)(irange(ii),ii=1,nrange)
      read(irest)(ept(ii),ii=1,nroot)
      read(irest)(ept_mp(ii),ii=1,nroot)
      read(irest)(enew(ii),ii=1,nroot)
      read(irest)(ptnorm(ii),ii=1,nroot)
      read(irest)(ptnorm_mp(ii),ii=1,nroot)
c
      if (inocnf.gt.nconmx) goto 91911
c
      do jj = 1,nloop
         read(irest)(ioconf(ii,jj),ii=1,nintpo)
      enddo
      close(unit=irest,status='keep')
      noconf = inocnf
c
      write(6,123) iconf, ncold
 123  format(/' Restarting at configuration ',i6,' of ',i6/)
c
90000 continue
      call ga_brdcst(50,iconf,mitob(1),master)
      return
c
90911 call errquit(' error opening restart file ',0, DISK_ERR)
91911 continue
c 
      write(istdo,*)' restart info is not correct. it will be ignored '
      write(istde,*)' restart info is not correct. it will be ignored '
      close(unit=irest,status='keep')
      goto 90000
      end
C> @}

*> \brief \b SLANGE returns the value of the 1-norm, Frobenius norm, infinity-norm, or the largest absolute value of any element of a general rectangular matrix.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SLANGE + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/slange.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/slange.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/slange.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       REAL             FUNCTION SLANGE( NORM, M, N, A, LDA, WORK )
* 
*       .. Scalar Arguments ..
*       CHARACTER          NORM
*       INTEGER            LDA, M, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SLANGE  returns the value of the one norm,  or the Frobenius norm, or
*> the  infinity norm,  or the  element of  largest absolute value  of a
*> real matrix A.
*> \endverbatim
*>
*> \return SLANGE
*> \verbatim
*>
*>    SLANGE = ( max(abs(A(i,j))), NORM = 'M' or 'm'
*>             (
*>             ( norm1(A),         NORM = '1', 'O' or 'o'
*>             (
*>             ( normI(A),         NORM = 'I' or 'i'
*>             (
*>             ( normF(A),         NORM = 'F', 'f', 'E' or 'e'
*>
*> where  norm1  denotes the  one norm of a matrix (maximum column sum),
*> normI  denotes the  infinity norm  of a matrix  (maximum row sum) and
*> normF  denotes the  Frobenius norm of a matrix (square root of sum of
*> squares).  Note that  max(abs(A(i,j)))  is not a consistent matrix norm.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] NORM
*> \verbatim
*>          NORM is CHARACTER*1
*>          Specifies the value to be returned in SLANGE as described
*>          above.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix A.  M >= 0.  When M = 0,
*>          SLANGE is set to zero.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.  N >= 0.  When N = 0,
*>          SLANGE is set to zero.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          The m by n matrix A.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(M,1).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (MAX(1,LWORK)),
*>          where LWORK >= M when NORM = 'I'; otherwise, WORK is not
*>          referenced.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup realGEauxiliary
*
*  =====================================================================
      REAL             FUNCTION SLANGE( NORM, M, N, A, LDA, WORK )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          NORM
      INTEGER            LDA, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), WORK( * )
*     ..
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J
      REAL               SCALE, SUM, VALUE, TEMP
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLASSQ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME, SISNAN
      EXTERNAL           LSAME, SISNAN
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
      IF( MIN( M, N ).EQ.0 ) THEN
         VALUE = ZERO
      ELSE IF( LSAME( NORM, 'M' ) ) THEN
*
*        Find max(abs(A(i,j))).
*
         VALUE = ZERO
         DO 20 J = 1, N
            DO 10 I = 1, M
               TEMP = ABS( A( I, J ) ) 
               IF( VALUE.LT.TEMP .OR. SISNAN( TEMP ) ) VALUE = TEMP
   10       CONTINUE
   20    CONTINUE
      ELSE IF( ( LSAME( NORM, 'O' ) ) .OR. ( NORM.EQ.'1' ) ) THEN
*
*        Find norm1(A).
*
         VALUE = ZERO
         DO 40 J = 1, N
            SUM = ZERO
            DO 30 I = 1, M
               SUM = SUM + ABS( A( I, J ) )
   30       CONTINUE
            IF( VALUE.LT.SUM .OR. SISNAN( SUM ) ) VALUE = SUM
   40    CONTINUE
      ELSE IF( LSAME( NORM, 'I' ) ) THEN
*
*        Find normI(A).
*
         DO 50 I = 1, M
            WORK( I ) = ZERO
   50    CONTINUE
         DO 70 J = 1, N
            DO 60 I = 1, M
               WORK( I ) = WORK( I ) + ABS( A( I, J ) )
   60       CONTINUE
   70    CONTINUE
         VALUE = ZERO
         DO 80 I = 1, M
            TEMP = WORK( I )
            IF( VALUE.LT.TEMP .OR. SISNAN( TEMP ) ) VALUE = TEMP
   80    CONTINUE
      ELSE IF( ( LSAME( NORM, 'F' ) ) .OR. ( LSAME( NORM, 'E' ) ) ) THEN
*
*        Find normF(A).
*
         SCALE = ZERO
         SUM = ONE
         DO 90 J = 1, N
            CALL SLASSQ( M, A( 1, J ), 1, SCALE, SUM )
   90    CONTINUE
         VALUE = SCALE*SQRT( SUM )
      END IF
*
      SLANGE = VALUE
      RETURN
*
*     End of SLANGE
*
      END
c $Id: slange.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine aoccsd(basis,ncor,nocc,nvir,ndel,nact,nbf,maxit,
     &                  convi,iprt,cmo,eorb,blen,
     &                  g_ncoul, g_nexch, RefEner,
     $   CC_Theory, rtdb, mxvec, geom, Tol2e, occd, oconverged)
      implicit none
#include "errquit.fh"
C     $Id: aoccsd2.F 24570 2013-09-12 02:50:38Z edo $
c
      integer basis,ncor,nocc,nvir,ndel,nact,nbf,maxit,iprt,
     &        blen,g_objv,g_coul,g_exch,g_ncoul,g_nexch, mxvec
      double precision cmo(nbf,nbf),eorb(nbf)
      Double Precision RefEner, Convi, Tol2E
      Character*(*) CC_Theory
      Integer RTDB, geom
      logical oconverged, occd, use_trpdrv_nb
      logical use_trpdrv_bgp, use_trpdrv_bgp2
c
#include "ccsd_len.fh"
#include "tcgmsg.fh"
#include "bas.fh"
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
#include "msgids.fh"
#include "ccsdps.fh"
c
c ccsd
      Integer i
      logical stat
      integer nsh,maxbfsh,max2e,mem2
      integer l_t1,l_ht1,l_scra,l_scrb,
     &        l_hiu,l_hia,l_habe,l_giu,l_gabe,
     &        l_bbkp,l_bb
      integer k_t1,k_ht1,k_scra,k_scrb,
     &        k_hiu,k_hia,k_habe,k_giu,k_gabe,
     &        k_bbkp,k_bb
      integer g_t2,g_ht2
      integer ad1,ad2,ad3,ad4
c triples
      integer lbfo,lbfv,mem_avail
      integer l_f1n,l_f1t,l_f2n,l_f2t,l_f3n,l_f3t,l_f4n,l_f4t,
     &        l_buf1,l_buf2,l_tk
      integer k_f1n,k_f1t,k_f2n,k_f2t,k_f3n,k_f3t,k_f4n,k_f4t,
     &        k_buf1,k_buf2,k_tk
      integer k_einv,l_einv
      integer g_objo
      integer vchunk,noper,occ_lo,vir_lo,vir_hi,oseg_lo,oseg_hi,
     &        nvpass
      integer ga_create_jkblocked
      logical oexch,ocoul,ohalf,oprint,oprinthigh
      double precision eccsdt,eccsd,empt(2),tx(3)
      double precision eccsdos,eccsdss,fos,fss
      Integer Nodes, IAm, memdrv, memtrn
c
      integer kchunk,nkpass,    ! For reduced-memory triples
     $        k_trp_Tij, k_trp_Tkj, k_trp_Tia, 
     $        k_trp_Tka, k_trp_Xia, k_trp_Xka, 
     $        k_trp_Jia, k_trp_Jka, k_trp_Kia, 
     $        k_trp_Kka, k_trp_Jij, k_trp_Jkj, 
     $        k_trp_Kij, k_trp_Kkj, k_trp_Dja,
     $        k_trp_Djka, k_trp_Djia,
     $        l_trp_Tij, l_trp_Tkj, l_trp_Tia, 
     $        l_trp_Tka, l_trp_Xia, l_trp_Xka, 
     $        l_trp_Jia, l_trp_Jka, l_trp_Kia, 
     $        l_trp_Kka, l_trp_Jij, l_trp_Jkj, 
     $        l_trp_Kij, l_trp_Kkj, l_trp_Dja,
     $        l_trp_Djka, l_trp_Djia
c
      
      integer moints_trp_mem
      external moints_trp_mem
C
      double precision zip
*     double precision trace1, trace2, trace3, trace4
      integer lhoo,lhoov
C
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C     Temporary stuff added to play density matrix games
C
      Integer A, J, B, LSab
      Integer L_Sb, K_Sb, L_Sa, K_Sa
      Integer H_DenZ1, I_DenZ1, H_DenT1, I_DenT1
      Integer G_DenT2, G_DenZ2, G_1PDM
      Logical Do_CCDen
      Integer GA_Create_Atom_Blocked
      External GA_Create_Atom_Blocked
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c gradient
      integer l_z1
      integer k_z1
      integer g_nt2
      integer ilo,ihi,jlo,jhi,offt2,nvp1
      integer gmem_needed,gmem_avail,nvnnodes,ff,ff2,ff3,iin,jin
      integer memlimit
      integer MSG_MIN_LOCAL_MEM
      parameter(MSG_MIN_LOCAL_MEM=1971)
      external ccsd_createg
      Logical Do_Z,ccsd_createg
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
* DATA MUST FOLLOW ALL DELCARATIONS 
      Data Do_Z /.FALSE./
      Data Do_CCDen /.FALSE./
C
      data oexch,ocoul/.true.,.true./
      data ohalf/.false./
      data zip/0.0d00/
c$$$      double precision rtc
c$$$      external rtc
c
      call ga_sync()
      if (occsdps) then
         call pstat_on(ps_aoccsd)
      else
         call qenter('aoccsd',0)
      endif
      oprint = util_print('information',print_low)
      oprinthigh = util_print('ccsd extra',print_high)
c
      nodes = ga_nnodes()
      iam = ga_nodeid()
      stat=bas_numcont(basis,nsh)
      stat=stat.and.bas_nbf_cn_max(basis,maxbfsh)
      if (.not.stat) call errquit('moints: cannot get basis info',0,
     &       BASIS_ERR)
c
c      print *,'basis set handle ',basis
c      print *,' ga allocated start of aoccsd '
c      call ga_summarize(.true.)
c
      if (iam.eq.0.and.oprint)then
      write(6,1001)nodes
 1001 format(//,1x,76(1h*),/,14x,
     &       'the segmented parallel ccsd program:',
     &       i5,' nodes',/,1x,76(1h*),//)
      endif
      if (iam.eq.0.and.oprint)then
      write (*,1318) CC_Theory( :Inp_StrLen(CC_Theory) ),
     $      ncor,nocc,nvir,ndel,nbf,nsh,basis
 1318 format(//,' level of theory    ',A,/
     $          ' number of core     ',i5,/,
     &          ' number of occupied ',i5,/,
     &          ' number of virtual  ',i5,/,
     &          ' number of deleted  ',i5,/,
     &          ' total functions    ',i5,/,
     &          ' number of shells   ',i5,/,
     &          ' basis label        ',i5,/)
      write(*,6003) iprt,convi,maxit, mxvec
 6003 format(//,2x,' ***** ccsd parameters *****',
     &        /,2x,' iprt   = ',i5,
     &        /,2x,' convi  = ',e9.3,
     &        /,2x,' maxit  = ',i5,
     $        /,2x,' mxvec  = ',i5)
      endif
C
C Initialize GA_TRACING
C
CRK   call trace_init(1000)

c
c----------------------------------------------------------------
c Begin parallel ccsd code
c----------------------------------------------------------------
c
      mem_avail = ma_inquire_avail(MT_DBL)
      if(iam.eq.0.and.oprint)write(6,*)'memory',mem_avail
      call int_mem_2e4c(max2e, mem2)
      mem2=max(mem2,nbf*nbf)
      if (iprt.gt.10.and.iam.eq.0.and.oprint)then
         write(6,*)'lnoo,lnov,lnvv,lnoov,lnooo,lnovv',
     &              lnoo,lnov,lnvv,lnoov,lnooo,lnovv
      endif
      lnobj=max(lnoov,nbf*nbf)
      stat=.true.
      stat=stat.and.ma_push_get(MT_DBL,lnov,'t1',l_t1,k_t1)
      stat=stat.and.ma_push_get(MT_DBL,lnov,'ht1',l_ht1,k_ht1)
      stat=stat.and.ma_push_get(MT_DBL,lnoo,'hiu',l_hiu,k_hiu)
      stat=stat.and.ma_push_get(MT_DBL,lnov,'hia',l_hia,k_hia)
      stat=stat.and.ma_push_get(MT_DBL,lnvv,'habe',l_habe,k_habe)
      stat=stat.and.ma_push_get(MT_DBL,lnoo,'giu',l_giu,k_giu)
      stat=stat.and.ma_push_get(MT_DBL,lnvv,'gabe',l_gabe,k_gabe)
      stat=stat.and.ma_push_get(MT_DBL,mxvec*(mxvec+1)/2,'bbkp',
     &                          l_bbkp,k_bbkp)
      stat=stat.and.ma_push_get(MT_DBL,(mxvec+1)*(mxvec+2),'bb',
     &                          l_bb,k_bb)
      stat=stat.and.ma_push_get(MT_INT,nsh*(nsh+1),'tklst',l_tk,k_tk)
      stat=stat.and.ma_push_get(MT_DBL,lnobj,'1scra',l_scra,k_scra)
      stat=stat.and.ma_push_get(MT_DBL,lnobj,'scrb',l_scrb,k_scrb)
      if (.not.stat)call errquit('ccsd: failed to allocate ',0, MEM_ERR)
c
        lhoo=nocc*(nocc+1)/2
        lhoov=nvir*nocc*(nocc+1)/2
c
c     check if enough GA is there for the next 3 gacreate
c
       gmem_avail=(ga_memory_avail()/MA_sizeof(MT_DBL,1,MT_BYTE))
       nvnnodes=max(1,(nvir+1)/ga_nnodes()+1)
       call ga_igop(MSG_MIN_LOCAL_MEM,gmem_avail,1,'min')
c     mem for t2
       gmem_needed=2*mxvec*lhoov*nvnnodes
c     mem for nt2 (see ccsd_iterdrv2)
       ff=lnov/nvir/int(dsqrt(dble(ga_nnodes())))+2
       gmem_needed = gmem_needed + 2*nvir*nvir*ff*ff
c     mem needed for x c sht2 (see pampt3)
       ff2=max(1,nocc*nocc/ga_nnodes()+1)
       ff3=max(1,nbf*nbf/ga_nnodes()+1)
       gmem_needed = gmem_needed + 2*ff2*nbf*nbf+ff3*nocc*nocc
       
       if(gmem_needed.gt.gmem_avail) then
                mxvec=min(10,((gmem_avail-ff3*nocc*nocc)/2
     -         -(nvir*nvir*ff*ff)-
     -         ff2*nbf*nbf)/
     /         (lhoov*nvnnodes))
                if(ga_nodeid().eq.0) then
                   write(luout,*) ' ff = ',ff
                   write(luout,*) ' mxvec decreased to ',mxvec
                endif
                if(mxvec.eq.0) then
                if(ga_nodeid().eq.0) then
                   write(luout,'(A,2I16)')
     W               ' gmems (dbls): needed and avail ',
     W                  gmem_needed,gmem_avail
                   write(luout,'(A,2I10)') ' lhoov nv ',lhoov,nvir
                   write(luout,'(A,I16)') ' gneede for mxvec=1 ',
     W                  nvnnodes*(2*lhoov+lhoov)
                   call util_flush(luout)
                endif
               
                 call errquit(' bailing out',0,0)
                endif
       endif
       

*ga:1:0
      if (.not.ga_create(MT_DBL,mxvec*lhoov,nvir+1,'g_t2', 
     &                   mxvec*lhoov,0,g_t2))
     &     call errquit('ga_create failed for g_t2',0, GA_ERR)
*ga:1:0
      if (.not.ga_create(MT_DBL,mxvec*lhoov,nvir+1,'g_ht2', 
     &                   mxvec*lhoov,0,g_ht2))
     &     call errquit('ga_create failed for g_ht2',0, GA_ERR)
c      
      call ccsd_iterdrv2(rtdb,basis,nsh,ncor,nocc,nvir,nact,nbf,
     &                  maxit,convi,iprt,cmo,eorb,
     &                  dbl_mb(k_t1),dbl_mb(k_ht1),
     &                  dbl_mb(k_scra),dbl_mb(k_scrb),
     &                  dbl_mb(k_hiu),dbl_mb(k_hia),dbl_mb(k_habe),
     &                  dbl_mb(k_giu),dbl_mb(k_gabe),
     &                  dbl_mb(k_bbkp),dbl_mb(k_bb),
     &                  g_t2,g_ht2,
     &                  mxvec,eccsd,max2e,mem2,g_ncoul,g_nexch,
     &                  int_mb(k_tk),offt2,nvp1, refener, Tol2E, 
     $     occd, oconverged, eccsdos)
c     
      call ga_sync
c
         if (.not.ga_create(MT_DBL,lnov,lnov,'g_nt2',
     &      nvir,nvir,g_nt2))
     &      call errquit('ga_create failed g_nt2',0, GA_ERR)
         call ga_zero(g_nt2)
      if(ga_nodeid().eq.0.and.oprinthigh) then
         call ga_distribution(g_nt2, 0, ilo, ihi, jlo, jhi)
         write(luout,'(A,4I12)') ' distr for nt2 ',
     I        ilo, ihi, jlo, jhi
         call util_flush(luout)
      endif
c
#if 0
      call ga_get(g_t2,offt2+1,offt2+lnov,nvp1,nvp1,
     $            dbl_mb(k_t1),lnov)
#else
      if(ga_nodeid().eq.0)
     G      call ga_get(g_t2,offt2+1,offt2+lnov,nvp1,nvp1,
     $            dbl_mb(k_t1),lnov)
      call ga_brdcst(65537, dbl_mb(k_t1), 
     G     MA_sizeof(MT_DBL,1,MT_BYTE)*lnov, 0)
#endif
c
      call ga_distribution(g_t2,iam,jlo,jhi,ilo,ihi)
      do a=1,nvir
        if (a.ge.ilo.and.a.le.ihi)then
          call ga_get(g_t2,offt2+1,offt2+lhoov,a,a,
     &                 dbl_mb(k_scra),lhoov)
cstaggering
          do iin=ga_nodeid()+1,ga_nodeid()+nocc
             i=mod(iin,nocc)+1
             call dcopy(lnov,0.0d00,0,dbl_mb(k_scrb),1)
            do jin=1+ga_nodeid(),i+ga_nodeid()
               j=mod(jin,i)+1
              do b=1,nvir
                ad1=(b-1)*lhoo+i*(i-1)/2+j
                dbl_mb(k_scrb+b-1)=dbl_mb(k_scra+ad1-1)
              enddo
            ad1=(i-1)*nvir+a
            call ga_put(g_nt2,(j-1)*nvir+1,j*nvir,ad1,ad1,
     D           dbl_mb(k_scrb),nvir)
            enddo
          enddo
        endif
      enddo
      call ga_sync
c
      call ga_distribution(g_nt2,iam,jlo,jhi,ilo,ihi)
      do i=1,nocc
        ad1=(i-1)*nvir
        if (ad1+1.ge.ilo.and.ad1+1.le.ihi)then
          do j=1,i-1
            ad2=(j-1)*nvir
            if (ad2+1.ge.jlo.and.ad2+1.le.jhi)then
              call ga_get(g_nt2,ad2+1,ad2+nvir,ad1+1,ad1+nvir,
     &                    dbl_mb(k_scra),nvir)
              do a=1,nvir
              do b=1,nvir
                ad3=(b-1)*nvir+a
                ad4=(a-1)*nvir+b
                dbl_mb(k_scrb+ad4-1)=dbl_mb(k_scra+ad3-1)
              enddo
              enddo
              call ga_put(g_nt2,ad1+1,ad1+nvir,ad2+1,ad2+nvir,
     &                    dbl_mb(k_scrb),nvir)
            endif
          enddo
        endif
      enddo
      call ga_sync
c
         if (iam.eq.0.and.iprt.gt.5.and.oprint)then
            print *,'starting t1 vector'
            write(6,139)(dbl_mb(k_t1-1+i),i=1,lnov)
 139        format(4e14.4)
            call ga_print(g_nt2)
         endif
c
      stat=stat.and.ma_pop_stack(l_scrb)
      stat=stat.and.ma_pop_stack(l_scra)
c
      lnobj=2*lnoov+max(lnoov,lnooo)
*ga:1:0
      if(ga_nnodes().lt.3) then
         if (.not.ga_create(MT_DBL,lnobj,nvir+1,'objv',lnobj,1,
     &        g_objv))
     &     call errquit('ga_create g_objv failed',0, GA_ERR)
      else
         if(.not.ccsd_createg(g_objv, lnobj, nvir+1, 
     R        lnoov, max(lnoov,lnooo), lnoov,min(nocc,nvir),
     O        oprinthigh))
     &     call errquit('ga_create g_objv failed',0, GA_ERR)
      endif
      call ga_zero(g_objv)
c
      lnobj=lnoov+max(lnooo,lnoov)
      stat=stat.and.ma_push_get(MT_DBL,lnobj,'1scra',l_scra,k_scra)
      stat=stat.and.ma_push_get(MT_DBL,nocc*nact,'scrb',l_scrb,k_scrb)
      call ccsd_trpmo(ncor,nocc,nvir,nact,nbf,dbl_mb(k_scra),
     $            dbl_mb(k_scrb),dbl_mb(k_t1),g_nt2,g_objv,g_ncoul,
     $            g_nexch,iprt)
      stat=stat.and.ma_pop_stack(l_scrb)
      stat=stat.and.ma_pop_stack(l_scra)
c
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CRK
CRK   Gradient driver to go in here for development purposes 
CRK 
c
      If ( Do_Z) then
        lnobj=max(lnoov,nbf*nbf)
        stat=stat.and.ma_push_get(MT_DBL,lnobj,'3scra',l_scra,k_scra)
        stat=stat.and.ma_push_get(MT_DBL,lnobj,'scrb',l_scrb,k_scrb)
         stat=stat.and.ma_push_get(MT_DBL,lnov,'z1',l_z1,k_z1)
         call ccsd_graddrv(basis,nsh,ncor,nocc,nvir,nact,nbf,
     &      maxit,convi,iprt,cmo,eorb,dbl_mb(k_t1),dbl_mb(k_ht1),
     &      dbl_mb(k_scra),dbl_mb(k_scrb),dbl_mb(k_z1),
     &      dbl_mb(k_hiu),dbl_mb(k_hia),dbl_mb(k_habe),
     &      dbl_mb(k_giu),dbl_mb(k_gabe),
     &      dbl_mb(k_bbkp),dbl_mb(k_bb),
     &      g_nt2,g_t2,g_ht2,
     &      mxvec,eccsd,max2e,mem2,g_ncoul,g_nexch,
     &      int_mb(k_tk), Tol2E)
      EndIf
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c
      stat=.true.
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      If ( Do_Z ) then
         stat=stat.and.ma_pop_stack(l_z1)
         stat=stat.and.ma_pop_stack(l_scrb)
         stat=stat.and.ma_pop_stack(l_scra)
      EndIf
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      stat=stat.and.ma_pop_stack(l_tk)
      stat=stat.and.ma_pop_stack(l_bb)
      stat=stat.and.ma_pop_stack(l_bbkp)
      stat=stat.and.ma_pop_stack(l_gabe)
      stat=stat.and.ma_pop_stack(l_giu)
      stat=stat.and.ma_pop_stack(l_habe)
      stat=stat.and.ma_pop_stack(l_hia)
      stat=stat.and.ma_pop_stack(l_hiu)
      stat=stat.and.ma_pop_stack(l_ht1)
      stat=stat.and.ma_pop_stack(l_t1)
      if (.not.stat)call errquit('ccsd: cannot pop stack?',0,
     &       MA_ERR)
      call ga_sync()
      if (.not. ga_destroy(g_nt2))
     &     call errquit('ga_destroy failed',0, GA_ERR)
      if (.not. ga_destroy(g_ht2))
     &     call errquit('ga_destroy failed',0, GA_ERR)
      if (.not. ga_destroy(g_t2))
     &     call errquit('ga_destroy failed',0, GA_ERR)
c
      if (occsdps) then
         call pstat_off(ps_aoccsd)
      else
         call qexit('aoccsd',0)
      endif

c    get scaling factors for SCS-CCSD
      if (.not. rtdb_get(rtdb, 'ccsd:fss', mt_dbl, 1, fss))
     $  fss = 1.13d0        ! same spin scaling factor
      if (.not. rtdb_get(rtdb, 'ccsd:fos', mt_dbl, 1, fos))
     $  fos = 1.27d0        ! opposite spin scaling factor

c
      If ( GA_NodeID() .eq. 0 .AND.
     $     Util_Print('information', Print_Low) .AND.
     $   ( Util_Print('byproduct energies', Print_Default)
     $   .OR. Inp_Compare(.FALSE., 'ccsd', CC_Theory) ) ) then
         Call Banner(LuOut,
     $      'CCSD Energy', '-',
     $      .TRUE., .TRUE., .FALSE.)
         Write (LuOut, '(1X, A, F30.15)') 'Reference energy:  ',
     $      RefEner
         Write (LuOut, '(1X, A, F30.15)') 'CCSD corr. energy: ',
     $      eccsd
         Write (LuOut, '(1X, A, F30.15)') 'Total CCSD energy: ',
     $      RefEner + eccsd
         call ecce_print1('ccsd correlation energy', mt_dbl, eccsd, 1)
         call ecce_print1('ccsd total energy', mt_dbl, refener+eccsd, 1)
         call ecce_print1('total ccsd energy', mt_dbl, refener+eccsd, 1)

c       Spin Componenst Scaled CCSD

         write(LuOut,'(/)')
         eccsdss=eccsd-eccsdos
         Call Banner(LuOut,
     $      'Spin Component Scaled (SCS) CCSD', '-',
     $      .TRUE., .TRUE., .FALSE.)
         Write (LuOut, '(1X, A, F30.15)')'Same spin contribution:     ',
     $      eccsdss
         Write (LuOut, '(1X, A, F30.15)')'Same spin scaling factor:   ',
     $      fss
         Write (LuOut, '(1X, A, F30.15)')'Opposite spin contribution: ',
     $      eccsdos
         Write (LuOut, '(1X, A, F30.15)')'Opposite spin scaling fact.:',
     $      fos
         Write (LuOut, '(1X, A, F30.15)')'SCS-CCSD correlation energy:',
     $      eccsdos*fos+eccsdss*fss
         Write (LuOut, '(1X, A, F30.15)')'Total SCS-CCSD energy:      ',
     $      RefEner+eccsdos*fos+eccsdss*fss

      EndIf
C
C     Write our energy out to the database
C
      If ( .NOT. RTDB_Put( RTDB, 'ccsd:ccsd correlation energy',
     $   MT_Dbl, 1, Eccsd) )
     $   Call ErrQuit('CCSD: Can''t write to RTDB', 1,0)
      If ( .NOT. RTDB_Put( RTDB, 'ccsd:ccsd energy', MT_Dbl, 1,
     $   RefEner+eccsd) ) 
     $   Call ErrQuit('CCSD: Can''t write to RTDB', 2,0)
C
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C     Temporarily a good place to mess around with some density
C     matrix stuff
C
      If (Do_CCDen) then
C
C     Start by creating the data structures we need
C
         If ( .NOT. MA_Push_Get(MT_Dbl, NOcc*NVir, 'CCDens T1',
     $      H_DenT1, I_DenT1) ) Call ErrQuit(
     $      'CCDen (prep): unable to allocate T1', NOcc*NVir,0)
C
         If ( .NOT. MA_Push_Get(MT_Dbl, NOcc*NVir, 'CCDens Z1',
     $      H_DenZ1, I_DenZ1) ) Call ErrQuit(
     $      'CCDen (prep): unable to allocate Z1', NOcc*NVir,0)
C
         If ( .NOT. GA_Create(MT_Dbl, NVir*NOcc, NVir*NOcc,
     $      'CCDen T2', NVir, NVir, G_DenT2) ) Call ErrQuit(
     $      'CCDen(prep): unable to alloc T2', NVir*NOcc*NVir*NOcc,0)
C
         If ( .NOT. GA_Create(MT_Dbl, NVir*NOcc, NVir*NOcc,
     $      'CCDen Z2', NVir, NVir, G_DenZ2) ) Call ErrQuit(
     $      'CCDen (prep): unable to alloc Z2',NVir*NOcc*NVir*NOcc,0)
C
         G_1PDM = GA_Create_Atom_Blocked(Geom, Basis, 'CCDen 1-PDM')
C
C        Now rearrange the existing data into our new structures
C
C        First, T1 (and for now fill Z1 with T1 too)
C        (T1 is replicated for density, so all nodes do this)
C
         LnObj = lnoov + lnooo
         Call GA_Get(g_ObjV, LnObj+1, LnObj+Lnov, NVir+1, NVir+1,
     &      Dbl_MB(I_DenT1), NOcc*NVir)
         Call GA_Get(g_ObjV, LnObj+1, LnObj+Lnov, NVir+1, NVir+1,
     &      Dbl_MB(I_DenZ1), NOcc*NVir)
C
C        Now T2 (then copy to Z2 for the time being)
C        (T2 is a GA for density, so have node 0 do it for simplicity)
C
         If ( GA_NodeID() .eq. 0) then
            lsab=max(lnoov,nbf*nbf)
            If ( .NOT. ma_push_get(MT_DBL,lsab,'sa',l_sa, k_sa) )
     $         Call ErrQuit('CCDen (prep): can''t allocate sa', lsab,0)
            If (.NOT. ma_push_get(MT_DBL,lsab,'sb',l_sb, k_sb) )
     $         Call ErrQuit('CCDen (prep): can''t allocate sb', lsab,0)
            do a=1,nvir
               call ga_get(g_ObjV,lnobj+1, lnobj+lnoov,a,a,
     &            dbl_mb(k_sa),lnoov)
               do i=1,nocc
                  do j=1,nocc
                     do b=1,nvir
                        ad1=k_sa+(b-1)*lnoo+(i-1)*nocc+j-1
                        ad2=k_sb+(j-1)*nvir+b-1
                        dbl_mb(ad2)=dbl_mb(ad1)
                     enddo
                  enddo
                  ad1=(i-1)*nvir+a
                  call ga_put(g_DenT2,1,lnov,ad1,ad1,dbl_mb(k_sb),lnov)
               enddo
            enddo
            If ( .NOT. MA_Pop_Stack(L_Sb)) Call ErrQuit(
     $         'CCDen (prep): freeing sb', 0,0)
            If ( .NOT. MA_Pop_Stack(L_Sa)) Call ErrQuit(
     $         'CCDen (prep): freeing sa', 0,0)
         EndIf
         Call GA_Sync
         Call GA_Copy(G_DenT2, G_DenZ2)
C
C        Now call the Density driver routine
C
         Call CCDen_Driver(NOcc, NVir, Dbl_MB(I_DenT1), NOcc, G_DenT2,
     $      Dbl_MB(I_DenZ1), NOcc, G_DenZ2, G_1PDM)
C
         If ( .NOT. GA_Destroy(G_1PDM) ) Call ErrQuit(
     $      'CCDen (prep): unable to free 1PDM', 0,0)
         If ( .NOT. GA_Destroy(G_DenZ2) ) Call ErrQuit(
     $      'CCDen (prep): unable to free Z2', 0,0)
         If ( .NOT. GA_Destroy(G_DenT2) ) Call ErrQuit(
     $      'CCDen (prep): unable to free T2', 0,0)
         If ( .NOT. MA_Pop_Stack(H_DenZ1) ) Call ErrQuit(
     $      'CCDen (prep): unable to free Z1', 0,0)
         If ( .NOT. MA_Pop_Stack(H_DenT1) ) Call ErrQuit(
     $      'CCDen (prep): unable to free T1', 0,0)
      EndIf
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c
      if (.not. oconverged) goto 999
c
C     Do we continue to the triples or not?
C     Note: task_energy expects ccsd:energy as a marker of successful
C     completion.  Therefore, we don't want to write it unless we
C     are certain we have completed the expected task.
C
      If ( .NOT. ( Inp_Compare(.FALSE., 'ccsd(t)', CC_Theory)
     $   .OR. Inp_Compare(.FALSE., 'ccsd+t(ccsd)', CC_Theory) ) ) then
         call ecce_print1('total energy', mt_dbl, refener+eccsd, 1)
         If ( .NOT. RTDB_Put( RTDB, 'ccsd:energy', MT_Dbl, 1,
     $      RefEner+eccsd) ) 
     $      Call ErrQuit('CCSD: Can''t write to RTDB', 3,0)
         Goto 999
      EndIf
c
c ----------------------------
c the new parallel triples
c ----------------------------
c
      if (.not. rtdb_get(rtdb, 'ccsd:use_trpdrv_nb', mt_log, 1,
     1                   use_trpdrv_nb))
     2    use_trpdrv_nb=.false.
      if (.not. rtdb_get(rtdb, 'ccsd:use_trpdrv_bgp', mt_log, 1,
     1                   use_trpdrv_bgp))
     2    use_trpdrv_bgp=.false.
      if (.not. rtdb_get(rtdb, 'ccsd:use_trpdrv_bgp2', mt_log, 1,
     1                   use_trpdrv_bgp2))
     2    use_trpdrv_bgp2=.false.
c
      mem_avail = ma_inquire_avail(MT_DBL)
      if(iam.eq.0.and.oprint)write(luout,*)'memory',mem_avail
      if (occsdps) then
         call pstat_on(ps_tripls)
      else
         call qenter('triples',0)
      endif
      if (iam.eq.0.and.oprint)write(luout,293)
 293  format(//,'*********triples calculation*********',/)
      lbfo=lnovv+lnoov+lnoov
      lbfv=lnoov+lnoov+lnoov
      lbfv=max(lbfv,nbf*nbf)
      lnobj=max(2*lnoov+lnooo,3*lnoov)
      stat=.true.
      stat=stat.and.ma_push_get(MT_DBL,lnov,'t1',l_t1,k_t1)
      stat=stat.and.ma_push_get(MT_DBL,lnobj,'buf1',l_buf1,k_buf1)
      stat=stat.and.ma_push_get(MT_DBL,lnobj,'buf2',l_buf2,k_buf2)
c
*ga:1:0
*      if (.not.ga_create(MT_DBL,lbfo,nocc,'objo',lbfo,0,g_objo))
*     &     call errquit('ga_create failed for g_objo',0)
*ga:1:0
      if(ga_nnodes().lt.3) then
      if (.not.ga_create(MT_DBL,lbfo,nocc,'objo',lbfo,1,g_objo))
     &     call errquit('ga_create failed for g_objo',0, GA_ERR)
      else
         if(.not.ccsd_createg(g_objo, lbfo, nocc,
     R        lnovv, lnoov, lnoov,min(nocc,nvir),
     O        oprinthigh))
     &     call errquit('ga_create g_objo failed',0, GA_ERR)
      endif
c
c
      call ga_zero(g_objo)
      call ccsd_rdtrpo
     $     (dbl_mb(k_t1),dbl_mb(k_buf1),dbl_mb(k_buf2),
     $                 g_objo,g_objv,nocc,nvir,iprt)
      stat=.true.
      stat=stat.and.ma_pop_stack(l_buf2)
      stat=stat.and.ma_pop_stack(l_buf1)
      if (.not.stat)call errquit('rdtrpo: cannot pop stack?',0, MA_ERR)
c
c      print *,' ga allocated before trpdrv '
c      call ga_summarize(.true.)
c
c     Iteratively determine nvpass (vchunk) and 
c     internal chunking for the tripes (kchunk)
c
      mem_avail = ma_inquire_avail(MT_DBL)
c     we can hack the mem available (in MB)
      if ( rtdb_get(rtdb, 'ccsdt:memlimit', mt_int, 1, memlimit))
     $  mem_avail=min(mem_avail,memlimit*1024*1024/
     /     MA_sizeof(MT_DBL,1,MT_BYTE))

      call ga_igop(msg_cc_mem, mem_avail, 1, 'min')
c
      nvpass = 1
c
 7651 nkpass = 1
 7652 kchunk = (nocc - 1)/nkpass + 1
      vchunk = (nvir - 1)/nvpass + 1
c
cold      memdrv = lnvv*(11+3*kchunk) + lnov*(5+4*kchunk) + nvir*(1+kchunk)
      memdrv = lnvv*(11+3*kchunk) + lnov*(1+4*nocc+4*kchunk) +
     +     nvir*(1+kchunk)
      memtrn = moints_trp_mem(basis, vchunk, blen)
c
      if (iam .eq. 0.and.oprint) then
         write(luout,1101) nkpass, nvpass,memdrv,memtrn,mem_avail
 1101    format('nkpass=',i5,'; nvpass=',i5,'; memdrv=',i15,
     $        '; memtrn=',i15,'; memavail=',i15)
         call util_flush(luout)
      endif
c
      noper = nodes * 
     $     ((mem_avail - max(memdrv, memtrn))/(nbf*nbf + nbf*nvir))
      if (vchunk .gt. max(min(nvir,noper/nocc),1)) then
c
c     If the triples part is using more memory than the 4-index
c     then increase nkpass, otherwise increase nvpass
c
         if (memdrv .gt. memtrn) then
            nkpass = nkpass + 1
            if (nkpass .gt. nocc) call errquit
     $           ('ccsd triples: too many k passes', nkpass,
     &       UNKNOWN_ERR)
            goto 7652
         else
            nvpass = nvpass + 1
            if (nvpass .gt. nvir) call errquit
     $           ('ccsd triples: too many v passes ', nvpass,
     &       UNKNOWN_ERR)
            goto 7651
         endif
      endif
c
      noper=nocc*vchunk
c
      if (iam.eq.0.and.oprint)write(*,845)mem_avail,nvir,vchunk,nvpass,
     $     kchunk,nkpass
  845 format(' memory available/node                ',i15,/,
     &       ' total number of virtual orbitals     ',i5,/,
     &       ' number of virtuals per integral pass ',i5,/,
     &       ' number of integral evaluations       ',i5,/,
     $       ' number of occupied per triples pass  ',i5,/,
     $       ' number of triples passes             ',i5/)
      g_coul = ga_create_JKblocked(noper,nbf,nbf,'Coulomb oper')
      g_exch = ga_create_JKblocked(noper,nbf,nvir,'X oper')
      nvpass=0
      occ_lo = ncor+1
      vir_lo = ncor+nocc+1
      vir_hi = ncor+nocc+nvir
      oseg_hi = vir_lo - 1
      empt(1)=zip
      empt(2)=zip
      do while (oseg_hi.lt.vir_hi)
         nvpass = nvpass + 1
         oseg_lo = oseg_hi + 1
         oseg_hi = min(oseg_hi+vchunk,vir_hi)
         tx(1)=tcgtime()
         if (iam.eq.0)write(*,846)nvpass,tx(1)
 846     format(' commencing integral evaluation ',i8,' at ',f14.2)
         call moints_trp(rtdb,basis,  ohalf, occ_lo, oseg_lo, oseg_hi,
     &      vir_lo, vir_hi,
     &      g_coul, ocoul, g_exch, oexch,
     &      blen, cmo, ncor, nocc, nvir, ndel, Tol2E)
c        print *,'call trpdrv ',nvpass

*          if (iam .eq. 0.and.oprint) then
*            write(luout,*) ' Out of MOINTS '
*            call util_flush(luout)
*          endif

         if (.not. ma_push_get(MT_DBL,lnvv,'f1n',l_f1n,k_f1n))
     $        call errquit('aoccsd2:triples f1n',lnvv, MA_ERR)
         if (.not. ma_push_get(MT_DBL,lnvv,'f1t',l_f1t,k_f1t))
     $        call errquit('aoccsd2:triples f1t',lnvv, MA_ERR)
         if (.not. ma_push_get(MT_DBL,lnvv,'f2n',l_f2n,k_f2n))
     $        call errquit('aoccsd2:triples f2n',lnvv, MA_ERR)
         if (.not. ma_push_get(MT_DBL,lnvv,'f2t',l_f2t,k_f2t))
     $        call errquit('aoccsd2:triples f2t',lnvv, MA_ERR)
         if (.not. ma_push_get(MT_DBL,lnvv,'f3n',l_f3n,k_f3n))
     $        call errquit('aoccsd2:triples f3n',lnvv, MA_ERR)
         if (.not. ma_push_get(MT_DBL,lnvv,'f3t',l_f3t,k_f3t))
     $        call errquit('aoccsd2:triples f3t',lnvv, MA_ERR)
         if (.not. ma_push_get(MT_DBL,lnvv,'f4n',l_f4n,k_f4n))
     $        call errquit('aoccsd2:triples f4n',lnvv, MA_ERR)
         if (.not. ma_push_get(MT_DBL,lnvv,'f4t',l_f4t,k_f4t))
     $        call errquit('aoccsd2:triples f4t',lnvv, MA_ERR)
c
      if (.not. ma_push_get(MT_DBL, lnvv,'k_trp_Tij',
     $        l_trp_Tij,k_trp_Tij))
     $     call errquit('aoccsd2: triples: k_trp_Tij ', lnvv, MA_ERR)
      if (.not. ma_push_get(MT_DBL, kchunk*lnvv,'k_trp_Tkj',
     $     l_trp_Tkj,k_trp_Tkj))
     $     call errquit('aoccsd2: triples: k_trp_Tkj ', kchunk*lnvv,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, lnov*nocc,'k_trp_Tia',
     $     l_trp_Tia,k_trp_Tia))
     $     call errquit('aoccsd2: triples: k_trp_Tia ', lnov, MA_ERR)
      if (.not. ma_push_get(MT_DBL, kchunk*lnov,'k_trp_Tka',
     $     l_trp_Tka,k_trp_Tka))
     $     call errquit('aoccsd2: triples: k_trp_Tka ', kchunk*lnov,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, lnov*nocc,'k_trp_Xia',
     $     l_trp_Xia,k_trp_Xia))
     $     call errquit('aoccsd2: triples: k_trp_Xia ', lnov, MA_ERR)
      if (.not. ma_push_get(MT_DBL, kchunk*lnov,'k_trp_Xka',
     $     l_trp_Xka,k_trp_Xka))
     $     call errquit('aoccsd2: triples: k_trp_Xka ', kchunk*lnov,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, lnvv,'k_trp_Jia',
     $     l_trp_Jia,k_trp_Jia))
     $     call errquit('aoccsd2: triples: k_trp_Jia ', lnvv, MA_ERR)
      if (.not. ma_push_get(MT_DBL, kchunk*lnvv,'k_trp_Jka',
     $     l_trp_Jka,k_trp_Jka))
     $     call errquit('aoccsd2: triples: k_trp_Jka ', kchunk*lnvv,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, lnvv,'k_trp_Kia',
     $     l_trp_Kia,k_trp_Kia))
     $     call errquit('aoccsd2: triples: k_trp_Kia ', lnvv, MA_ERR)
      if (.not. ma_push_get(MT_DBL, kchunk*lnvv,'k_trp_Kka',
     $     l_trp_Kka,k_trp_Kka))
     $     call errquit('aoccsd2: triples: k_trp_Kka ', kchunk*lnvv,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, lnov*nocc,'k_trp_Jij',
     $     l_trp_Jij,k_trp_Jij))
     $     call errquit('aoccsd2: triples: k_trp_Jij ', lnov, MA_ERR)
      if (.not. ma_push_get(MT_DBL, kchunk*lnov,'k_trp_Jkj',
     $     l_trp_Jkj,k_trp_Jkj))
     $     call errquit('aoccsd2: triples: k_trp_Jkj ', kchunk*lnov,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, lnov*nocc,'k_trp_Kij',
     $     l_trp_Kij,k_trp_Kij))
     $     call errquit('aoccsd2: triples: k_trp_Kij ', lnov, MA_ERR)
      if (.not. ma_push_get(MT_DBL, kchunk*lnov,'k_trp_Kkj',
     $     l_trp_Kkj,k_trp_Kkj))
     $     call errquit('aoccsd2: triples: k_trp_Kkj ', kchunk*lnov,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, lnov,'k_trp_Dja',
     $     l_trp_Dja,k_trp_Dja))
     $     call errquit('aoccsd2: triples: k_trp_Dja ', lnov, MA_ERR)
      if (.not. ma_push_get(MT_DBL, nvir*kchunk,'k_trp_Djka',
     $     l_trp_Djka,k_trp_Djka))
     $     call errquit('aoccsd2: triples: k_trp_Djka ', nvir*kchunk,
     &       MA_ERR)
      if (.not. ma_push_get(MT_DBL, nvir*nocc,'k_trp_Djia',
     $     l_trp_Djia,k_trp_Djia))
     $     call errquit('aoccsd2: triples: k_trp_Djia ', nvir, MA_ERR)
c
         if (use_trpdrv_bgp) then
           if (.not. ma_push_get(MT_DBL,lnvv,'einv',l_einv,k_einv))
     $          call errquit('aoccsd2:triples einv',lnvv, MA_ERR)
         endif
c
         call ga_sync
         tx(2)=tcgtime()
c
         if (use_trpdrv_nb) then
c
         if (iam.eq.0.and.oprint) then
            write(luout,1847) nvpass
            call util_flush(luout)
         endif
 1847    format(' commencing triples evaluation - non-blocking',i8)
         call ccsd_trpdrv_nb(dbl_mb(k_t1),dbl_mb(k_f1n),
     $        dbl_mb(k_f1t),dbl_mb(k_f2n),dbl_mb(k_f2t),
     $        dbl_mb(k_f3n),dbl_mb(k_f3t),dbl_mb(k_f4n),
     $        dbl_mb(k_f4t),eorb,eccsdt,g_objo,g_objv,
     $        g_coul,g_exch,ncor,nocc,nvir,iprt,
     $        empt(1),empt(2),oseg_lo,oseg_hi,kchunk,
     $        dbl_mb(k_trp_Tij), dbl_mb(k_trp_Tkj), dbl_mb(k_trp_Tia),
     $        dbl_mb(k_trp_Tka), dbl_mb(k_trp_Xia), dbl_mb(k_trp_Xka),
     $        dbl_mb(k_trp_Jia), dbl_mb(k_trp_Jka), dbl_mb(k_trp_Kia),
     $        dbl_mb(k_trp_Kka), dbl_mb(k_trp_Jij), dbl_mb(k_trp_Jkj),
     $        dbl_mb(k_trp_Kij), dbl_mb(k_trp_Kkj), dbl_mb(k_trp_Dja),
     $        dbl_mb(k_trp_Djka), dbl_mb(k_trp_Djia))
c
         elseif (use_trpdrv_bgp) then
c
         if (iam.eq.0.and.oprint) then
            write(luout,1848) nvpass
            call util_flush(luout)
         endif
 1848    format(' commencing triples evaluation - Blue Gene v1',i8)
         call ccsd_trpdrv_bgp(dbl_mb(k_t1),dbl_mb(k_f1n),
     $        dbl_mb(k_f1t),dbl_mb(k_f2n),dbl_mb(k_f2t),
     $        dbl_mb(k_f3n),dbl_mb(k_f3t),dbl_mb(k_f4n),
     $        dbl_mb(k_f4t),eorb,dbl_mb(k_einv),eccsdt,g_objo,g_objv,
     $        g_coul,g_exch,ncor,nocc,nvir,
     $        empt(1),empt(2),oseg_lo,oseg_hi,kchunk,
     $        dbl_mb(k_trp_Tij), dbl_mb(k_trp_Tkj), dbl_mb(k_trp_Tia),
     $        dbl_mb(k_trp_Tka), dbl_mb(k_trp_Xia), dbl_mb(k_trp_Xka),
     $        dbl_mb(k_trp_Jia), dbl_mb(k_trp_Jka), dbl_mb(k_trp_Kia),
     $        dbl_mb(k_trp_Kka), dbl_mb(k_trp_Jij), dbl_mb(k_trp_Jkj),
     $        dbl_mb(k_trp_Kij), dbl_mb(k_trp_Kkj), dbl_mb(k_trp_Dja),
     $        dbl_mb(k_trp_Djka), dbl_mb(k_trp_Djia))
c
#ifdef BGP
         elseif (use_trpdrv_bgp2) then
c
         if (iam.eq.0.and.oprint) then
            write(luout,1849)nvpass
            call util_flush(luout)
         endif
 1849    format(' commencing triples evaluation - Blue Gene v2',i8)
         call ccsd_trpdrv_bgp2(dbl_mb(k_t1),dbl_mb(k_f1n),
     $        dbl_mb(k_f1t),dbl_mb(k_f2n),dbl_mb(k_f2t),
     $        dbl_mb(k_f3n),dbl_mb(k_f3t),dbl_mb(k_f4n),
     $        dbl_mb(k_f4t),eorb,eccsdt,g_objo,g_objv,
     $        g_coul,g_exch,ncor,nocc,nvir,iprt,
     $        empt(1),empt(2),oseg_lo,oseg_hi,kchunk,
     $        dbl_mb(k_trp_Tij), dbl_mb(k_trp_Tkj), dbl_mb(k_trp_Tia),
     $        dbl_mb(k_trp_Tka), dbl_mb(k_trp_Xia), dbl_mb(k_trp_Xka),
     $        dbl_mb(k_trp_Jia), dbl_mb(k_trp_Jka), dbl_mb(k_trp_Kia),
     $        dbl_mb(k_trp_Kka), dbl_mb(k_trp_Jij), dbl_mb(k_trp_Jkj),
     $        dbl_mb(k_trp_Kij), dbl_mb(k_trp_Kkj), dbl_mb(k_trp_Dja),
     $        dbl_mb(k_trp_Djka), dbl_mb(k_trp_Djia))
c
#endif
         else
c
         if (iam.eq.0.and.oprint) then
            write(luout,1846)nvpass
            call util_flush(luout)
         endif
 1846    format(' commencing triples evaluation - blocking',i8)
         call ccsd_trpdrv(dbl_mb(k_t1),dbl_mb(k_f1n),
     $        dbl_mb(k_f1t),dbl_mb(k_f2n),dbl_mb(k_f2t),
     $        dbl_mb(k_f3n),dbl_mb(k_f3t),dbl_mb(k_f4n),
     $        dbl_mb(k_f4t),eorb,eccsdt,g_objo,g_objv,
     $        g_coul,g_exch,ncor,nocc,nvir,iprt,
     $        empt(1),empt(2),oseg_lo,oseg_hi,kchunk,
     $        dbl_mb(k_trp_Tij), dbl_mb(k_trp_Tkj), dbl_mb(k_trp_Tia), 
     $        dbl_mb(k_trp_Tka), dbl_mb(k_trp_Xia), dbl_mb(k_trp_Xka), 
     $        dbl_mb(k_trp_Jia), dbl_mb(k_trp_Jka), dbl_mb(k_trp_Kia), 
     $        dbl_mb(k_trp_Kka), dbl_mb(k_trp_Jij), dbl_mb(k_trp_Jkj), 
     $        dbl_mb(k_trp_Kij), dbl_mb(k_trp_Kkj), dbl_mb(k_trp_Dja),
     $        dbl_mb(k_trp_Djka), dbl_mb(k_trp_Djia))
c
         endif
c
         tx(3)=tcgtime()

         if (.not. ma_chop_stack(l_f1n)) call errquit
     $        ('ccsd triples: stack corrupt (f1n)',0, MA_ERR)

         if (iam.eq.0.and.oprint)then
            write(luout,'(1x,a,i5,f9.2)')
     &       'Time for integral evaluation pass ',
     $       nvpass,tx(2)-tx(1)
            write(luout,'(1x,a,i5,f9.2)')
     &       'Time for triples evaluation pass  ',
     $      nvpass,tx(3)-tx(2)
            call util_flush(luout)
         endif

      enddo
      empt(1)=empt(1)+empt(1)
      empt(2)=empt(2)+empt(2)
      call ga_dgop(msg_cc_emp2,empt,2, '+')
      eccsdt=empt(1)+empt(2)
      if (iam.eq.0.and.oprint)then
       write(luout,100)empt(1),empt(2),eccsdt
 100   format(/,
     &     ' pseudo-e(mp4) ',e22.14,/,
     &     ' pseudo-e(mp5) ',e22.14,/,
     &     '        e(t)   ',e22.14,/)
       call util_flush(luout)
      endif

      stat=ga_destroy(g_coul)
      stat=stat.and.ga_destroy(g_exch)
c
      If ( IAm .eq. 0.and.oprint) then
         call ecce_print1('total ccsd+t(ccsd) energy', 
     $        mt_dbl, refener+eccsd+empt(1), 1)
         call ecce_print1('total ccsd(t) energy', 
     $        mt_dbl, RefEner + eccsd + eccsdt, 1)
         Call Banner(LuOut,
     $      'CCSD(T) Energy', '-',
     $      .TRUE., .TRUE., .FALSE.)
         Write (LuOut, '(1X, A, F30.15)') 'Reference energy:          ',
     $      RefEner
         If ( Util_Print('byproduct energies', Print_Default)
     $      .OR. Inp_Compare(.FALSE., 'ccsd+t(ccsd)', CC_Theory) ) then
            Write (LuOut, '(1X)')
            Write (LuOut, '(1X, A, F30.15)')
     $         'CCSD corr. energy:         ', eccsd
            Write (LuOut, '(1X, A, F30.15)')
     $         'T(CCSD) corr. energy:      ', empt(1)
            write (LuOut, '(1X, A, F30.15)')
     $         'Total CCSD+T(CCSD) energy: ', RefEner + eccsd + empt(1)
         EndIf
         If ( Util_Print('byproduct energies', Print_Default)
     $      .OR. Inp_Compare(.FALSE., 'ccsd(t)', CC_Theory) ) then
            Write (LuOut, '(1X)')
            Write (LuOut, '(1X, A, F30.15)')
     $         'CCSD corr. energy:         ', eccsd
            Write (LuOut, '(1X, A, F30.15)')
     $         '(T) corr. energy:          ', eccsdt
            Write (LuOut, '(1X, A, F30.15)')
     $         'Total CCSD(T) energy:      ', RefEner + eccsd + eccsdt
         EndIf
         call util_flush(luout)
      EndIf
C
C     Write our energy out to the database
C
      If ( .NOT. RTDB_Put( RTDB, 'ccsd:ccsd+t(ccsd) correlation energy',
     $   MT_Dbl, 1, Eccsd+empt(1) ) )
     $   Call ErrQuit('CCSD: Can''t write to RTDB', 10,0)
      If ( .NOT. RTDB_Put( RTDB, 'ccsd:ccsd+t(ccsd) energy', MT_Dbl, 1,
     $   RefEner+eccsd+empt(1) ) ) 
     $   Call ErrQuit('CCSD: Can''t write to RTDB', 11,0)
      If ( .NOT. RTDB_Put( RTDB, 'ccsd:ccsd(t) correlation energy',
     $   MT_Dbl, 1, Eccsd+eccsdt) )
     $   Call ErrQuit('CCSD: Can''t write to RTDB', 12,0)
      If ( .NOT. RTDB_Put( RTDB, 'ccsd:ccsd(t) energy', MT_Dbl, 1,
     $   RefEner+eccsd+eccsdt) ) 
     $   Call ErrQuit('CCSD: Can''t write to RTDB', 13,0)
C
C     This reports back to task_energy that the requested task has been
C     completed successfully.
C
      If ( Inp_Compare(.FALSE., 'ccsd(t)', CC_Theory) ) then
            call ecce_print1('total energy', mt_dbl, 
     $        RefEner+eccsd+eccsdt, 1)
         If ( .NOT. RTDB_Put( RTDB, 'ccsd:energy', MT_Dbl, 1,
     $      RefEner+eccsd+eccsdt) ) 
     $      Call ErrQuit('CCSD: Can''t write to RTDB', 14,0)
      ElseIf ( Inp_Compare(.FALSE., 'ccsd+t(ccsd)', CC_Theory) ) then
         call ecce_print1('total energy', mt_dbl, 
     $        RefEner+eccsd+empt(1), 1)
         If ( .NOT. RTDB_Put( RTDB, 'ccsd:energy', MT_Dbl, 1,
     $      RefEner+eccsd+empt(1) ) ) 
     $      Call ErrQuit('CCSD: Can''t write to RTDB', 14,0)
      EndIf
C
C
C
      stat=.true.
      stat=stat.and.ma_pop_stack(l_t1)
      if (.not.stat)call errquit('trpdrv: cannot pop stack?',0, MA_ERR)
c
      if (.not. ga_destroy(g_objo))
     &     call errquit('g_objo ga_destroy failed',0, MA_ERR)
c
c -- end of triples calculation
c
c      call ga_sync()
c      if (iam.eq.0)then
c       print *,' ga allocated end of aoccsd '
c       call ga_summarize(.false.)
c      endif
      call ga_sync()
      if (occsdps) then
         call pstat_off(ps_tripls)
      else
         call qexit('triples',0)
      endif
c
 999  if (.not. ga_destroy(g_objv))
     &     call errquit('g_objv ga_destroy failed',0, GA_ERR)
c
      if(.not.occsdps) call qstat()
      return
      end
      logical function ccsd_createg(g, rows, cols, r1, r2, r3, mcm,
     O     oprint)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
c
      integer g
      integer rows, cols, r1, r2, r3 ,mcm
      logical oprint
c
      integer mapr(3),l_mapc,k_mapc,i,nproc,
     C     nblocks,blksize,nblocksr,
     R     l_mapr,k_mapr,j
c
      nproc=ga_nnodes()
c
      nblocks=min(nproc/3,cols)
      blksize=max(cols/nblocks,1)
c
      if(ga_nodeid().eq.0.and.oprint) then
         write(6,1) 'nprocs ',nproc
         write(6,1) 'rows cols nprocs ',rows,cols,nproc
         write(6,1) 'r1 r2 r2 mcm',r1,r2,r3,mcm
      endif
      nblocksr=max(r1/mcm+r2/mcm+r3/mcm,1)
 11    continue
      if(nblocks*nblocksr.gt.nproc) then
         nblocksr=nproc/nblocks
         mcm=(r1+r2+r3)/nblocksr
         if(ga_nodeid().eq.0.and.oprint) then
            write(6,*) ' nblocksr ',nblocksr,
     c           nblocks*nblocksr
            write(6,*) ' np/nb ',
     D        dble(nproc)/dble(nblocks),nproc,nblocks
            write(6,*) ' new nblocksr ',nblocksr
            write(6,*) ' mcm increased to ',mcm
            write(6,1) ' segs ',r1/mcm,r2/mcm,r3/mcm
            write(6,1) ' nsegs*nbc ',
     C           (r1/mcm+r2/mcm+r3/mcm)*nblocks
         endif
 12      nblocksr=max(r1/mcm,1)+max(r2/mcm,1)+max(r3/mcm,1)
         if(nblocks*nblocksr.gt.nproc) then
         if(ga_nodeid().eq.0.and.oprint) 
     W           write(6,1) ' ouch ',nblocksr,nblocks,nproc
            mcm=mcm*2
            goto 12
         endif
      endif
      mapr(1)=1
      mapr(2)=r1+1
      mapr(3)=r1+r2+1
      if(.not.ma_push_get(MT_int,nblocks,
     .        'ga block maps',l_mapc,k_mapc))
     .     call errquit('ccsd_createg: not enough local mem',0,0)
      if(.not.ma_push_get(MT_int,nblocksr,
     .        'ga block mapr',l_mapr,k_mapr))
     .     call errquit('ccsd_createg: not enough local mem',0,0)
      nblocksr=0
      do i=1,max(r1/mcm,1)
         int_mb(k_mapr+i-1)=1+(i-1)*mcm
         nblocksr=nblocksr+1
      enddo
       if(ga_nodeid().eq.0.and.oprint) then
          write(6,*) ' 1st seg nblocksr ',nblocksr
          write(6,*) ' last map ',int_mb(k_mapr+nblocksr-1)
       endif
      do i=1,max(r2/mcm,1)
         int_mb(k_mapr+nblocksr)=r1+(i-1)*mcm
         nblocksr=nblocksr+1
      enddo
      if(ga_nodeid().eq.0.and.oprint) then
         write(6,*) ' 2nd seg nblocksr ',nblocksr
         write(6,*) ' last map ',int_mb(k_mapr+nblocksr-1)
      endif
      do i=1,max(r3/mcm,1)
         int_mb(k_mapr+nblocksr)=r1+r2+(i-1)*mcm
         nblocksr=nblocksr+1
      enddo
      if(ga_nodeid().eq.0.and.oprint) then
         write(6,*) ' 3rd seg nblocksr ',nblocksr
         write(6,*) ' last map ',int_mb(k_mapr+nblocksr-1)
         do i=1,nblocksr
            write(6,'(" MM ",5I13)')  i,int_mb(k_mapr+i-1)
         enddo
      endif
      do i=1,nblocks
         int_mb(k_mapc+i-1)=(i-1)*blksize+1
      enddo
      if(ga_nodeid().eq.0.and.oprint) then
         write(6,*) ' after maps nblocksr ',nblocksr
         write(6,1) 'rows cols nprocs ',rows,cols,nproc
         write(6,1) 'r1 r2 r2 ',r1,r2,r3
         write(6,1) 'mapr ',mapr
         write(6,1) ' blksize nblocks ',blksize,nblocks
         write(6,1) ' map1 maplast',int_mb(k_mapc),
     I        int_mb(k_mapc+nblocks-1)
     
 1     format(A,7I10)
       call util_flush(6)
      endif
      call ga_sync()
      ccsd_createg =  ga_create_irreg(MT_DBL, rows, cols, 'dunno',
     $     int_mb(k_mapr), nblocksr,
     $     int_mb(k_mapc), nblocks, g)

      if (.not.ma_chop_stack(l_mapc))
     &     call errquit('ccsd_createg: cannot chop stack',0,0)
      
      return
      end

c
c $Id: ewald_real.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE ewald_real(iii,rij,rijsq,jbeg,jend,ewald4)

      implicit none

      include 'p_array.inc'
      include 'p_const.inc'
      include 'cm_atom.inc'
      include 'cm_ewld.inc'
      include 'cm_cuto.inc'
      include 'cm_vlst.inc'

      integer iii,i,j,k,iatm,jatm
      integer jbeg,jend

      real*8 rij,drij,arij,rijsq
      real*8 ewald4,erfxc,force

      dimension rij(mxnlist,3),rijsq(mxnlist)

      ewald4=0.0
      k=0
      iatm=atmtype(iii)

      do i=jbeg,jend

       j=list(i)
       jatm=atmtype(j)
       k=k+1

       if(rijsq(k).lt.rcutsq)then

        drij=sqrt(rijsq(k))
        arij=alpha*drij

        ewald4=ewald4+convfct1*typchge(iatm)*typchge(jatm)
     $        *erfxc(arij)/drij

        force=convfct1*typchge(iatm)*typchge(jatm)*
     $       (erfxc(arij)+2*arij/sqrpi*exp(-arij*arij))/(drij*rijsq(k))

        fff(iii,1)=fff(iii,1)+convfct2*force*rij(k,1)
        fff(iii,2)=fff(iii,2)+convfct2*force*rij(k,2)
        fff(iii,3)=fff(iii,3)+convfct2*force*rij(k,3)

        fff(j,1)=fff(j,1)-convfct2*force*rij(k,1)
        fff(j,2)=fff(j,2)-convfct2*force*rij(k,2)
        fff(j,3)=fff(j,3)-convfct2*force*rij(k,3)

       endif

      enddo

      return

      END

*
* $Id: ofpw_minimizer.F 19818 2010-12-14 00:07:02Z bylaska $
*

***********************************************************************
*                      ofpw  (MPI code)                               *
*                                                                     *
*     This is a developing orbital free dft parallel code for NWCHEM  *
*                                                                     *
***********************************************************************

      logical function ofpw_minimizer(rtdb,flag)
      implicit none
      integer rtdb
      integer flag

#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"


#include "nwpw_timing.fh"
      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d
      real*8  a,b,c,alpha,beta,gamma
    

*     ***** energy variables ****
      integer ispin,ne(2),ms
      real*8     sum0,sum1,sum3,scale,tole,tolc
      real*8     ehartree,eorbit,exc,pxc,eion

      real*8  E(10),en(2)
      real*8  dipole(3)
      real*8  stress(3,3),lstress(6)

*     **** gradient variables ****
      integer fion(2)

*     **** error variables ****
      logical value,newpsi
      integer ierr

*     **** local variables ****
      logical oprint,lprint,hprint,qmmm
      real*8  gx,gy,gz,cx,cy,cz
      real*8  EV,pi
      real*8  icharge
      integer i,k,ia,nion,minimizer,mapping,mapping1d
  
      integer neall,npack1
      real*8 e_lj,e_q,e_spring


*     **** external functions ****
      real*8      psp_zv,psp_rc,ewald_rcut
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg,ion_amass
      integer     ewald_ncut,ewald_nshl3d
      integer     psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      integer     psp_nprj,psp_psp_type
      character*4 ion_atom,ion_aname
      external    psp_zv,psp_rc,ewald_rcut
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg,ion_amass
      external    ewald_ncut,ewald_nshl3d
      external    psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      external    psp_nprj,psp_psp_type
      external    ion_atom,ion_aname

      external      psp_comment
      character*255 psp_comment,comment

      real*8   control_tole,control_tolc,control_tolr,ion_rion
      external control_tole,control_tolc,control_tolr,ion_rion
      real*8   control_time_step,control_fake_mass
      external control_time_step,control_fake_mass
      logical  control_read,control_move,ion_init
      external control_read,control_move,ion_init

      integer  pack_nwave_all
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      integer  pspw_charge_nion
      external pack_nwave_all
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external pspw_charge_nion

      character*12 control_boundry
      external     control_boundry
      character*50 control_cell_name
      external     control_cell_name

      logical      psp_semicore
      real*8       psp_rcore,psp_ncore,psp_rlocal
      external     psp_semicore
      external     psp_rcore,psp_ncore,psp_rlocal

      logical  psi_initialize, psi_finalize
      integer  psi_ispin,psi_ne,psi_neq,electron_count,linesearch_count
      external psi_initialize, psi_finalize
      external psi_ispin,psi_ne,psi_neq,electron_count,linesearch_count
      real*8   ofpw_cgsd_energy
      external ofpw_cgsd_energy
      logical  control_Mulliken
      external control_Mulliken
      real*8   ion_TotalCharge
      external ion_TotalCharge
      logical   control_check_charge_multiplicity
      external  control_check_charge_multiplicity
      logical   pspw_charge_found,ion_q_FixIon
      external  pspw_charge_found,ion_q_FixIon
      integer  control_minimizer,control_scf_algorithm
      external control_minimizer,control_scf_algorithm
      integer  control_ks_algorithm
      external control_ks_algorithm
      real*8   control_ks_alpha
      external control_ks_alpha
      logical  control_print,control_balance
      external control_print,control_balance
      integer  control_mapping,control_mapping1d,control_np_orbital
      external control_mapping,control_mapping1d,control_np_orbital
      integer  control_ks_maxit_orb,control_ks_maxit_orbs
      external control_ks_maxit_orb,control_ks_maxit_orbs

      logical pspw_bqext
      external pspw_bqext

*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(10,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      value = control_read(3,rtdb)
      if (.not. value) 
     > call errquit('error reading control',0, INPUT_ERR)

      call Parallel2d_Init(control_np_orbital())
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)


      oprint= ((taskid.eq.MASTER).and.control_print(print_medium))
      lprint= ((taskid.eq.MASTER).and.control_print(print_low))
      hprint= ((taskid.eq.MASTER).and.control_print(print_high))


      if (oprint) call current_second(cpu1)

*     ***** print out header ****
      if (oprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1042)
         write(luout,1043)
         write(luout,1044)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
         call flush(luout)
      end if
      

      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      minimizer = control_minimizer()
      mapping   = control_mapping()


*     **** initialize D3dB data structure ****
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d

*     ***** Initialize double D3dB data structure ****
      if (control_version().eq.4)
     >   call D3dB_Init(2,2*ngrid(1),2*ngrid(2),2*ngrid(3),mapping)


 
*     **** initialize lattice data structure ****
      call lattice_init()
      call G_init()
      call mask_init()
      call Pack_Init()
      call D3dB_pfft_init()


*     **** read ions ****
      value = ion_init(rtdb)
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call psp_init()
      call psp_readall()
      if (psp_semicore(0)) call semicore_check()


*     **** initialize G,mask,ke,coulomb,and ewald data structures ****
      !call ke_init()
      if (control_version().eq.3) call coulomb_init()
      if (control_version().eq.4) call coulomb2_init()
      call strfac_init()
      if (control_version().eq.3) call ewald_init()

*     **** read in wavefunctions and initialize psi ****
c      chi(r) = ifft(chi(G)
c      loop
c         chi(r) = ifft(chi(G))
c         rho(r) = chi(r)*chi(r)
c         rho(G) = fft(rho(r))
c
c         Hchi(r) = 0
c
c         *** local psp term ****
c         Vloc(G) = Struct(I,G)*vlocal(G)
c         Vloc(r) = ifft(Vloc(G)
c         Hchi(r) += Vloc(r)*chi(r)
c
c         *** hartree term ***
c         Vh(G) = 4pi/G2 * rho(G)
c         Vh(r) = ifft(Vh(G))
c         Hchi(r) += Vh(r)*chi(r)
c
c         *** xc term ***
c         vxc(r) = VXC(rho(r))
c         Hchi(r) += vxc(r)*chi(r)
c
c         **** KE term ****
c         vtfvw(r) = VTFVW(rho(r))
c         Hchi(r) += vtfvw(r)*chi(r)
c        
c         vwgc(G) = Kernal(G)*rho(G)
c         Vwgc(r) = ifft(Vwgc(G))
c         Hchi(r) += Vwgc(r)*chi(r)
c
c
c         chi(r) = chi(r) +alpha*Hchi(r)
c       end loop
         


*     **** Initialize 1d mappings for ne spaces ****



*     **** electron and geodesic data structures ****

*     **** initialize QM/MM ****
      call pspw_init_APC(rtdb)
      call pspw_qmmm_init(rtdb)
      call pspw_charge_init(rtdb)

*     **** initialize SIC and HFX ****

*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)


*     **** initialize linesearching ****
      call linesearch_init()




*                |**************************|
******************   summary of input data  **********************
*                |**************************|

      if (oprint) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j
         if (mapping.eq.1) write(luout,1112) 
         if (mapping.eq.2) write(luout,1113) 
         if (mapping.eq.3) write(luout,1118) 
         if (control_balance()) then
           write(luout,1114)
         else
           write(luout,1116)
         end if
         write(luout,1115)

         write(luout,1121) control_boundry(),control_version()
         if (psi_ispin().eq.1) write(luout,1130) "restricted"
         if (psi_ispin().eq.2) write(luout,1130) "unrestricted"
         !if (qmmm) write(luout,1122)
         IF (control_gga().eq.-1) THEN
            write(luout,1131) 'off'
         ELSE IF (control_gga().eq.0) THEN
            write(luout,1131) 'LDA (Vosko et al) parameterization'
         ELSE IF (control_gga().eq.10) THEN
            write(luout,1131) 
     >      'PBE96 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.11) THEN
            write(luout,1131) 
     >      'BLYP (White and Bird) parameterization'
         ELSE IF (control_gga().eq.12) THEN
            write(luout,1131) 
     >      'revPBE (White and Bird) parameterization'

         ELSE IF (control_gga().eq.110) THEN
            write(luout,1131) 
     >      'PBE0 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.112) THEN
            write(luout,1131) 
     >      'revPBE0 (White and Bird) parameterization'

         ELSE IF (control_gga().eq.200) THEN
            write(luout,1131) 'Hartree-Fock'
         ELSE
            write(luout,1131) 'unknown parameterization'
            call errquit('bad exchange_correlation',0, INPUT_ERR)
         END IF

         write(luout,1140)
         do ia = 1,ion_nkatm()
           write(luout,1150) ia,ion_atom(ia),
     >                    psp_zv(ia),psp_lmax(ia)
           comment = psp_comment(ia)
           i = inp_strlen(comment)
           write(luout,1157) comment(1:i)
           write(luout,1158) psp_psp_type(ia)
           write(luout,1152) psp_lmax(ia)
           write(luout,1153) psp_locp(ia)
           write(luout,1154) psp_nprj(ia)
           if (control_version().eq.4) write(luout,1156) psp_rlocal(ia)
           if (psp_semicore(ia))
     >         write(luout,1155) psp_rcore(ia),psp_ncore(ia)
           write(luout,1151) (psp_rc(i,ia),i=0,psp_lmax(ia))
           write(luout,*)
         end do

         !icharge = -(psi_ne(1)+psi_ne(psi_ispin()))
         icharge = 0.0d0
         icharge = icharge + ion_TotalCharge()
         write(luout,1159) icharge




         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         if (hprint) then
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         call pspw_charge_Print(luout)
         end if

         !write(luout,1220) psi_ne(1),psi_ne(psi_ispin()),' (fourier space)'
         write(luout,1230)
         write(luout,1233) control_cell_name()
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1231) lattice_omega()
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(0),pack_nwave(0)
         write(luout,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(1),pack_nwave(1)
         if (control_version().eq.3) then
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()
         end if
         write(luout,1270)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_tole(),control_tolc()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()

         write(luout,1300)
c         call ion_Print_neighborlist()
         call util_flush(luout)
      end if

*                |***************************|
******************     call CG minimizer     **********************
*                |***************************|
      if (taskid.eq.MASTER) call current_second(cpu2)


*     **** calculate energy ****
      if (flag.eq.-1) then
        !EV= ofpw_cgsd_noit_energy()
        EV= 0.0d0
      else
        EV= ofpw_cgsd_energy()
      end if


*     **** extra energy output for QA test ****
      if (lprint) write(6,1600) EV

      
*     **** calculate the dipole ***
      dipole(1) = 0.0d0
      dipole(2) = 0.0d0
      dipole(3) = 0.0d0
      !if (flag.gt.-1) call rho_dipole(dipole)

*     ****  calculate gradient ***
      if (flag.gt.0) then
      nion = ion_nion()
      if (pspw_charge_found().and.
     >    (.not.pspw_bqext())) nion = nion + pspw_charge_nion()

      value = MA_push_get(mt_dbl,(3*nion),
     >                       'fion',fion(2),fion(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
     
      !call cgsd_energy_gradient(dbl_mb(fion(1)))
      call dcopy(3*nion,0.0d0,0, dbl_mb(fion(1)),1)
      call dscal(3*nion,(-1.0d0),dbl_mb(fion(1)),1)
      end if

*     **** calculate the stress tensor ****
      call dcopy(9,0.0d0,0,stress,1)
      call dcopy(6,0.0d0,0,lstress,1)
      if (flag.eq.3) then
         !call psp_stress_init()
         !call psp_stress_readall()
         !call cgsd_energy_stress(stress,lstress)
         !call psp_stress_end()
      end if


*     *************************************************************
*     **** output energy, dipole, and gradient to rtdb for use ****
*     **** by task_energy and task_gradient                    ****
*     *************************************************************
      if (flag.gt.-1) then
      value = rtdb_put(rtdb,'ofpw:energy',mt_dbl,1,EV)
      value = value.and.
     >        rtdb_put(rtdb,'ofpw:dipole',mt_dbl,
     >                 3,dipole)
      end if
      if (flag.gt.0) then
        value = value.and.
     >        rtdb_put(rtdb,'ofpw:gradient',mt_dbl,
     >                 3*nion,dbl_mb(fion(1)))
        value = value.and.MA_pop_stack(fion(2))
      end if
      if (flag.eq.3) then
        value = value.and.
     >        rtdb_put(rtdb,'ofpw:stress',mt_dbl,
     >                 9,stress)
        value = value.and.
     >        rtdb_put(rtdb,'ofpw:lstress',mt_dbl,
     >                 6,lstress)
      end if
      if (.not. value) call errquit('ofpw: error writing rtdb',0,
     &       RTDB_ERR)

      if (taskid.eq.MASTER) call current_second(cpu3)

*                |***************************|
******************         Epilogue          **********************
*                |***************************|


*     **** calculate Mulliken Populations ***

*     **** write wavefunctions to file and finalize psi ****

*     **** write geometry to rtdb ****
      call pspw_charge_write(rtdb)
      call ion_write(rtdb)


*     **** deallocate heap memory ****
      if (control_version().eq.3) call ewald_end()
      call strfac_end()
      if (control_version().eq.3) call coulomb_end()
      if (control_version().eq.4) call coulomb2_end()
      !call ke_end()
      call mask_end()
      call Pack_end()
      call G_end()
      call pspw_end_APC()
      call pspw_charge_end()
      call pspw_qmmm_end()
      call ion_end()
      call psp_end()
      call ion_end_FixIon()
      !call D3dB_n_fft_end(1)
      call D3dB_pfft_end()
      call D3dB_end(1)
      if (control_version().eq.4) call D3dB_end(2)
      

*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (lprint) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(1)
         AV= 0.0
         write(luout,1801)
         write(luout,1802)
         write(luout,1803) T1
         write(luout,1804) T2
         write(luout,1805) T3
         write(luout,1806) T4
         write(luout,1807) AV,1,linesearch_count()

         !call nwpw_timing_print_final(oprint,1)
         write(luout,*)
         CALL nwpw_MESSAGE(4)
      end if 



      call Parallel_Finalize()
      ofpw_minimizer = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*        NWPW Orbital Free DFT Calculation         *')
 1030 FORMAT(10X,'*         [ (unknown implementation) ]             *')
 1035 FORMAT(10x,'*      [ NorthWest Chemistry implementation ]      *')
 1040 FORMAT(10X,'*            version #1.00   06/30/07              *')
 1041 FORMAT(10X,'*    This code was developed by Niri Govind, and   *')
 1042 FORMAT(10X,'*    Eric J. Bylaska and is based upon the         *')
 1043 FORMAT(10X,'*    algorithms and code developed by the group of *')
 1044 FORMAT(10X,'*    Prof. Emily A. Carter.                        *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I10)
 1112 FORMAT( ' parallel mapping         :      slab')
 1113 FORMAT( ' parallel mapping         :   hilbert')
 1114 FORMAT( ' parallel mapping         :  balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1117 FORMAT( ' processor grid           :',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         :    hcurve')
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1122 FORMAT(5X,' qmmm simulation')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I3)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)

 1159 FORMAT(/' total charge:',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I3))
 1180 FORMAT(/' position of ions (au):')
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - fixed')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1219 FORMAT(/' number of electrons: spin up=',F6.2,
     >        '  down=',F6.2,A)
 1220 FORMAT(/' number of electrons: spin up=',I6,
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1221 FORMAT( ' number of orbitals : spin up=',I6,  
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,'             omega=',F8.1)
 1232 FORMAT(5x,' lattice:    a=    ',f8.3,' b=   ',f8.3,' c=    ',f8.3,
     >      /5x,'             alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1233 FORMAT(5x,' cell_name:  ',A)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1250 FORMAT(/5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
  
 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters:')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I8,
     >           ' ( ',I4,' inner ',I4,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (density)')
 1291 FORMAT(/' Kohn-Sham scf parameters:')
 1292 FORMAT(5X, ' Kohn-Sham algorithm  = ',A)
 1293 FORMAT(5X, ' SCF algorithm        = ',A)
 1294 FORMAT(5X, ' SCF mixing parameter =',F7.4)
 1295 FORMAT(5X, ' Kohn-Sham iterations = ',I3,
     >           ' (',I3,' outer)')
 1300 FORMAT(//)
 1305 FORMAT(10X,'================ iteration =========================')
 1310 FORMAT(I8,E20.10,3E15.5)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1500 FORMAT(/' orbital energies:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1600 FORMAT(/' Total PSPW energy   :',E19.10)

 1801 FORMAT(//'== Timing ==')
 1802 FORMAT(/'cputime in seconds')
 1803 FORMAT( '  prologue    : ',E14.6)
 1804 FORMAT( '  main loop   : ',E14.6)
 1805 FORMAT( '  epilogue    : ',E14.6)
 1806 FORMAT( '  total       : ',E14.6)
 1807 FORMAT( '  cputime/step: ',E14.6,
     >        '       (',I8,' evalulations,', I8,' linesearches)')
 1808 FORMAT(A,E14.6,E14.6)
 1809 FORMAT(//A,2A14)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(luout,9010) ierr
      call Parallel_Finalize()

      ofpw_minimizer = value
      return
      END

c
c     $Id: bfgsminimize3.F 24484 2013-08-08 01:49:15Z bylaska $                       
c

*  ************************************************************
*  *                                                          *
*  *               Limited Memory BFGS routine                *
*  *                                                          *
*  ************************************************************
  
      subroutine bfgsminimize3(E,deltae,deltac,
     >                        current_iteration,
     >                        minimizer)
      implicit none
      real*8     E(*)
      real*8     deltae,deltac
      integer    current_iteration
      integer    minimizer

#include "mafdecls.fh"

*     **** local variables ****

      real*8  deltat_min
      parameter (deltat_min=1.0d-4)
       
      integer G0(2),S0(2),Y0(2)
      real*8  E0,dE0


      real*8     tole,tolc
      real*8     ehartree,eorbit,exc,pxc,eion
      real*8     Enew,Eold,Estart
      common / cgsd_block / Enew,Eold,Estart

      real*8 tmin,dte,sum0,sum1
      common / bfgs_block / tmin,dte,sum0,sum1

      integer it,it_in
      real*8 deltat
      real*8 max_sigma,dt

      logical value
      integer neall,npack1
      !real*8 e_ionmm,e_qmmm,e_mmmm,e_pol,e_vib,e_cav
      !real*8 e_qmmm_e,e_qmmm_q,e_qmmm_lj,e_mmmm_q,e_mmmm_lj
      real*8 e_lj,e_q,e_spring
      real*8 ehfx,phfx


*     **** external functions ****
      integer  control_it_in,psi_neq,control_version
      real*8   control_tole,control_tolc
      real*8   psi_geodesic_energy
      real*8   psi_geodesic_denergy
      real*8   rho_error
      real*8   dng_1ehartree
      real*8   psi_1ke
      real*8   psi_1vl,psi_1v_field
      real*8   psi_1vnl
      real*8   rho_1exc
      real*8   rho_1pxc
      real*8   ewald_e,ion_ion_e
      real*8   psi_1eorbit
      real*8   linesearch
   
      external control_it_in,psi_neq,control_version
      external control_tole,control_tolc
      external psi_geodesic_energy
      external psi_geodesic_denergy
      external rho_error
      external dng_1ehartree
      external psi_1ke
      external psi_1vl,psi_1v_field
      external psi_1vnl
      external rho_1exc
      external rho_1pxc
      external ewald_e,ion_ion_e
      external psi_1eorbit
      external linesearch

*     ***** QM/MM external functions ****
      logical  pspw_qmmm_found
      real*8   pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E
      external pspw_qmmm_found
      external pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E

*     ***** pspw_charge external functions ****
      logical  pspw_charge_found
      real*8   pspw_charge_Energy_ion,pspw_charge_Energy_charge
      external pspw_charge_found
      external pspw_charge_Energy_ion,pspw_charge_Energy_charge


      real*8   control_time_step,control_fake_mass
      external control_time_step,control_fake_mass
      integer  control_lmbfgs_size
      external control_lmbfgs_size
   
      logical  pspw_HFX,psp_U_psputerm,meta_found
      external pspw_HFX,psp_U_psputerm,meta_found
      logical  nwpw_meta_gga_on,ion_disp_on
      external nwpw_meta_gga_on,ion_disp_on
      real*8   psi_1meta_gga_pxc,ion_disp_energy
      external psi_1meta_gga_pxc,ion_disp_energy


  

      dt = control_time_step()
c     dte = dt/dsqrt(control_fake_mass())
c     dte = dsqrt(control_fake_mass())/dt
c     dte = 1.0d0

      
      call Pack_npack(1,npack1)
      neall = psi_neq(1)+psi_neq(2)


*     **** allocate G0, S0 ****
      value = MA_push_get(mt_dcpl,npack1*neall,
     >                     'S0',S0(2),S0(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,npack1*neall,
     >                     'G0',G0(2),G0(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,npack1*neall,
     >                     'Y0',Y0(2),Y0(1))
      if (.not. value) 
     >   call errquit('bfgsminimize3:out of heap memory',0,0)
      call dcopy(2*npack1*neall,0.0d0,0,dcpl_mb(G0(1)),1)



*     ***** get the initial direction ****
      call psi_1get_psi(dcpl_mb(Y0(1)))
      call psi_1get_Gradient(dcpl_mb(G0(1)),E0)

      
      if (current_iteration.eq.1) then

*        ***** use the initial gradient for the direction ****
         call pspw_lmbfgs3_init(control_lmbfgs_size(),
     >                          dcpl_mb(Y0(1)),
     >                          dcpl_mb(G0(1)))
         
         call Grsm_gg_Copy(npack1,neall,
     >                      dcpl_mb(G0(1)),
     >                      dcpl_mb(S0(1)))
         call psi_1gen_Tangent(dcpl_mb(S0(1)))
         tmin  = 10*deltat_min
      else
         call pspw_lmbfgs3(tmin,dcpl_mb(Y0(1)),
     >                          dcpl_mb(G0(1)),
     >                          dcpl_mb(S0(1)))
         call psi_1gen_Tangent(dcpl_mb(S0(1)))
      end if

*     ******************************************
*     ****                                  ****
*     **** Start of BFGS iteration loop     ****
*     ****                                  ****
*     ******************************************
      it_in = control_it_in()
      tole  = control_tole()
      tolc  = control_tolc()
      do it=2,it_in

*        **** initialize the geoedesic line data structure ****
         call geodesic_start(dcpl_mb(S0(1)),max_sigma,dE0)

*        ******* line search *********
         if ((tmin.gt.deltat_min).and.(tmin.lt.1.0d4)) then
            deltat = tmin
         else
            deltat = deltat_min
         end if
         !deltat = 1.0d0  !** debug **
         Enew = linesearch(0.0d0,E0,dE0,deltat,
     >                        psi_geodesic_energy,
     >                        psi_geodesic_denergy,
     >                        0.50d0,tmin,deltae,2)
         call psi_geodesic_final(tmin)
         deltac = rho_error()

*        **** exit loop early ****
         if ((dabs(deltae).lt.tole).and.(deltac.lt.tolc)) then
            go to 30
         end if
     
*        **** get the new gradient - also updates densities****
         call psi_2get_psi(dcpl_mb(Y0(1)))
         call psi_2get_Gradient(2,dcpl_mb(G0(1)),E0)
         call pspw_lmbfgs3(tmin,dcpl_mb(Y0(1)),
     >                          dcpl_mb(G0(1)),
     >                          dcpl_mb(S0(1)))
         call psi_2gen_Tangent(dcpl_mb(S0(1)))


*        **** make psi1 <--- psi2(tmin) ****
         call psi_2to1()

      end do

*     **** initialize the geoedesic line data structure ****
      call geodesic_start(dcpl_mb(S0(1)),max_sigma,dE0)

*     ******* line search *********
      if ((tmin.gt.deltat_min).and.(tmin.lt.1.0d4)) then
         deltat = tmin
      else
         deltat = deltat_min
      end if
c      deltat = 1.0d0  !** debug **
c      Eold = psi_geodesic_energy(0.0d0)
      Enew = linesearch(0.0d0,E0,dE0,deltat,
     >                        psi_geodesic_energy,
     >                        psi_geodesic_denergy,
     >                        0.50d0,tmin,deltae,2)
      call psi_geodesic_final(tmin)
      deltac = rho_error()

*     **** free memory ****
 30   value = MA_pop_stack(Y0(2))
      value = value.and.
     >        MA_pop_stack(G0(2))
      value = value.and.
     >        MA_pop_stack(S0(2))
      if (.not. value) 
     >  call errquit('bfgsminimize3:error freeing heap memory',0,0)

      call psi_2to1()
      call psi_1toelectron() 
c     call rho_2to1()
c     call dng_2to1()
c     call psi_check()

      eion = 0.0d0
      if (control_version().eq.3) eion = ewald_e()
      if (control_version().eq.4) eion = ion_ion_e()

      eorbit   = psi_1eorbit()
      ehartree = dng_1ehartree()
      exc      = rho_1exc()
      pxc      = rho_1pxc()

      E(1)  = Enew + eion
      E(2)  = eorbit
      E(3)  = ehartree
      E(4)  = exc
      E(5)  = eion
      E(6)  = psi_1ke()
      E(7)  = psi_1vl()
      E(8)  = psi_1vnl()
      E(9)  = 2.0d0*ehartree
      E(10) = pxc
      if (pspw_qmmm_found()) then
         e_lj     = pspw_qmmm_LJ_E()
         e_q      = pspw_qmmm_Q_E()
         e_spring = pspw_qmmm_spring_E()
         E(1)  = E(1) + e_lj + e_q + e_spring

         E(11) = e_lj
         E(12) = e_q
         E(13) = e_spring
      end if

*     **** get pspw_charge energies ****
      if (pspw_charge_found()) then
         E(19)  = psi_1v_field()
         E(20)  = pspw_charge_Energy_ion()
         E(21)  = pspw_charge_Energy_charge()
         E(1)   = E(1) + E(20) + E(21)
      end if

*     **** HFX terms ****
      if (pspw_HFX()) then
         call electron_HFX_energies(ehfx,phfx)
         E(26) = ehfx
         E(27) = phfx
      end if

*     **** DFT+U terms ****
      if (psp_U_psputerm()) then
         call electron_U_energies(ehfx,phfx)
         E(29) =  ehfx
         E(30) =  phfx
      end if
*     **** DFT+U terms ****
      if (psp_U_psputerm()) then
         call electron_U_energies(ehfx,phfx)
         E(29) =  ehfx
         E(30) =  phfx
      end if

*     **** Metadynamics potential terms ****
      if (meta_found()) then
         call electron_meta_energies(ehfx,phfx)
         E(31) =  ehfx
         E(32) =  phfx
      end if

*     **** Metadynamics GGA Tau potential term ****
      if (nwpw_meta_gga_on()) then
         E(10) = E(10) - psi_1meta_gga_pxc()
      end if

*     **** Dispersion energy ****
      if (ion_disp_on()) then
         E(33) = ion_disp_energy()
         E(1)  = E(1) + E(33)
      end if



      return
      end
 

*
* $Id: types1.f 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine types1(a,b,alpha,beta,q,e,NIN,NDIM)
C
C-----------------------------------------------------------------------
C
C     This routine reads Fann's matrices, i.e., alpha's/beta's,
C     and computes the representation a's/b's, and q's/e's. 
C
C-----------------------------------------------------------------------
C
      integer          NDIM,NIN
      double precision a(*),alpha(*),b(*),beta(*),e(*),q(*)
C
      double precision zero
      parameter        (zero=0.0d0)
      integer          i,j
C
      intrinsic        sqrt
C
C.... read the alpha's and beta's ......................................
C
cgif      call parser (record,string)
cgif      read (string,fmt='(a)') matrix
cgif      call parser (record,string)
cgif      read (string,fmt='(e24.0)') shift
C
cgif      open (9,err=1,file=matrix,form='formatted')
cgif      read (9,err=1,fmt=*) NIN 
cgif      if ( NIN.GT.NDIM ) stop 'TYPE1: not enough space in Z'
cgif      read (9,err=1,fmt=*) (j,alpha(i),beta(i),i=1,NIN)
C
cgif      do j = 1,NIN-1
cgif         alpha(j) = alpha(j) + shift
cgif         beta(j) = beta(j+1)
cgif      end do
cgif      alpha(NIN) = alpha(NIN) + shift
C
C.... compute the q's and e's ..........................................
C
      q(1) = alpha(1)
      do j = 1,NIN-1
         e(j) = (beta(j)/q(j)) * beta(j)
         q(j+1) = alpha(j+1) - e(j) 
         if ( q(j+1).lt.zero ) 
     &      STOP 'Matrix is not positive definite, change shift'
      end do 
C
C.... compute the a's and b's ..........................................
C
      a(1) = sqrt(q(1))
      do i=1,NIN-1
         b(i) = sqrt(e(i))
         a(i+1) = sqrt(q(i+1))
      end do
C
      return
    1 stop '* I/O error, check file for Fann''s matrix'
      end

      subroutine ga_iter_orthog(basis, g_c, ometric, osym)
C$Id: ga_it_orth.F 21208 2011-10-18 17:00:19Z d3y133 $
      implicit none
#include "errquit.fh"
#include "bas.fh"
#include "mafdecls.fh"
#include "global.fh"
      integer basis
      integer g_c
      logical ometric
      logical osym
c     
c     Iteratively orthogonalize the vectors in g_c using quadratically
c     convergent algorithms
c
c     if (ometric) then
c       use the overlap integrals from basis as a metric
c     else
c       use a unit matrix as a metric
c     endif
c
c     if (osym) then
c       symmetrically orthogonalize the vectors using
c
c       C <-- C*(1.5*I - 0.5*S)
c
c     else
c       orthogonalize higher index vectors to lower
c       index vectors (e.g., so as to avoid mixing
c       virtual orbitals into occupied orbitals)
c
c       C <-- C*(I + U(I-S)) 
c
c       where U(M) = upper triangle with halved diagonal
c     endif
c     
c     Two n*n scratch GAs are used.
c     
c     
      integer g_s, g_tmp, g_ms
      integer iter, maxiter, nbf, nmo, type, i
      integer ilo, ihi, jlo, jhi
      double precision tol, zero, one, mone, mhalf, sii, err
      parameter (tol = 1.0d-15, maxiter = 9)
      parameter (zero=0.0d0, one=1.0d0, mhalf=-0.5d0, mone=-1.0d0)
c     
c     Make scratch arrays
c     
      call ga_inquire(g_c, type, nbf, nmo)
      if (nmo .ne. nbf) call errquit('iter_orthog:nmo.ne.nbf',nbf,
     &       GA_ERR)
      if (.not. ga_create(MT_DBL, nbf, nbf, 'iter_orthog:over',
     $     32, 32, g_s)) call errquit('iter_orthog:ga_create?',nbf,
     &       GA_ERR)
      if (.not. ga_create(MT_DBL, nbf, nmo, 'iter_orthog:tmp',
     $     32, 32, g_tmp)) call errquit('iter_orthog:ga_create?',nbf,
     &       GA_ERR)
      if (nmo .ne. nbf) then
         if (.not. ga_create(MT_DBL, nmo, nmo, 'iter_orthog:ms',
     $        32, 32, g_ms)) call errquit('iter_orthog:ga_create?',nbf,
     &       GA_ERR)
      else
         g_ms = g_s             ! Save space usually
      endif
c
c     Determine range of local diagonals for shifting g_ms
c
      call ga_distribution(g_ms, ga_nodeid(), ilo, ihi, jlo, jhi)
      if (ilo.gt.0 .and. jlo.gt.0) then
         ilo = max(ilo,jlo)
         ihi = min(ihi,jhi)
      endif
c     
      do iter = 1, maxiter
c     
c     Make the overlap matrix (S) in the MO basis in g_s
c     
         if (ometric) then
            call ga_zero(g_s)
            call int_1e_ga(basis, basis, g_s, 'overlap', .false.)
            call ga_dgemm('n','n',nbf,nmo,nbf,one,g_s,g_c,
     $           zero,g_tmp)
            call ga_dgemm('t','n',nmo,nmo,nbf,one,g_c,g_tmp,
     $           zero,g_ms)
         else
            call ga_dgemm('t','n',nmo,nmo,nbf,one,g_c,g_c,
     $           zero,g_ms)
         endif
c     
c     Form S - I and determine the error norm
c     
         do i = ilo, ihi
            call ga_acc(g_ms, i, i, i, i, mone, 1, one)
         enddo
         call ga_maxelt(g_ms, err)
*         if ((ga_nodeid().eq.0))
*     $        write(6,*) ' iter_orthog: err = ', err
c     
c     Form and apply the correction using locality
c     
         if (osym) then
            call ga_dscal(g_ms, mhalf)
            do i = ilo, ihi
               call ga_acc(g_ms, i, i, i, i, one, 1, one)
            enddo
         else
            call ga_dscal(g_ms, mone)
            do i = ilo, ihi
               call ga_get(g_ms, i, i, i, i, sii, 1)
               sii = 0.5d0*sii + one
               call ga_put(g_ms, i, i, i, i, sii, 1)
            enddo
         endif
c            
         call ga_dgemm('n','n',nbf,nmo,nmo,one,g_c,g_ms,zero,g_tmp)
         call ga_copy(g_tmp, g_c)
c     
c     Finally check for convergence (noting quadratic convergence)
c     
         if (err.lt.sqrt(tol)) goto 1000
c     
      enddo
      write(6,*) ' iter_orthog: failed to converge, error = ', err
      call errquit('iter_orthog: failed to converge', 0, CALC_ERR)
c     
 1000 continue
      if (.not. (ga_destroy(g_s) .and. ga_destroy(g_tmp)))
     $     call errquit('iter_orthog: ga_destroy failed', 0, GA_ERR)
      if (nbf .ne. nmo) then
         if (.not. ga_destroy(g_ms))
     $     call errquit('iter_orthog: ga_destroy failed', 0, GA_ERR)
      endif
c
      call ga_sync()
c
      end

*> \brief \b ZHEGST
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZHEGST + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zhegst.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zhegst.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zhegst.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZHEGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, ITYPE, LDA, LDB, N
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         A( LDA, * ), B( LDB, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZHEGST reduces a complex Hermitian-definite generalized
*> eigenproblem to standard form.
*>
*> If ITYPE = 1, the problem is A*x = lambda*B*x,
*> and A is overwritten by inv(U**H)*A*inv(U) or inv(L)*A*inv(L**H)
*>
*> If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
*> B*A*x = lambda*x, and A is overwritten by U*A*U**H or L**H*A*L.
*>
*> B must have been previously factorized as U**H*U or L*L**H by ZPOTRF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ITYPE
*> \verbatim
*>          ITYPE is INTEGER
*>          = 1: compute inv(U**H)*A*inv(U) or inv(L)*A*inv(L**H);
*>          = 2 or 3: compute U*A*U**H or L**H*A*L.
*> \endverbatim
*>
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangle of A is stored and B is factored as
*>                  U**H*U;
*>          = 'L':  Lower triangle of A is stored and B is factored as
*>                  L*L**H.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrices A and B.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX*16 array, dimension (LDA,N)
*>          On entry, the Hermitian matrix A.  If UPLO = 'U', the leading
*>          N-by-N upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading N-by-N lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>
*>          On exit, if INFO = 0, the transformed matrix, stored in the
*>          same format as A.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is COMPLEX*16 array, dimension (LDB,N)
*>          The triangular factor from the Cholesky factorization of B,
*>          as returned by ZPOTRF.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complex16HEcomputational
*
*  =====================================================================
      SUBROUTINE ZHEGST( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, ITYPE, LDA, LDB, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
      COMPLEX*16         CONE, HALF
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ),
     $                   HALF = ( 0.5D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            K, KB, NB
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZHEGS2, ZHEMM, ZHER2K, ZTRMM, ZTRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( ITYPE.LT.1 .OR. ITYPE.GT.3 ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZHEGST', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'ZHEGST', UPLO, N, -1, -1, -1 )
*
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code
*
         CALL ZHEGS2( ITYPE, UPLO, N, A, LDA, B, LDB, INFO )
      ELSE
*
*        Use blocked code
*
         IF( ITYPE.EQ.1 ) THEN
            IF( UPPER ) THEN
*
*              Compute inv(U**H)*A*inv(U)
*
               DO 10 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the upper triangle of A(k:n,k:n)
*
                  CALL ZHEGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
                  IF( K+KB.LE.N ) THEN
                     CALL ZTRSM( 'Left', UPLO, 'Conjugate transpose',
     $                           'Non-unit', KB, N-K-KB+1, CONE,
     $                           B( K, K ), LDB, A( K, K+KB ), LDA )
                     CALL ZHEMM( 'Left', UPLO, KB, N-K-KB+1, -HALF,
     $                           A( K, K ), LDA, B( K, K+KB ), LDB,
     $                           CONE, A( K, K+KB ), LDA )
                     CALL ZHER2K( UPLO, 'Conjugate transpose', N-K-KB+1,
     $                            KB, -CONE, A( K, K+KB ), LDA,
     $                            B( K, K+KB ), LDB, ONE,
     $                            A( K+KB, K+KB ), LDA )
                     CALL ZHEMM( 'Left', UPLO, KB, N-K-KB+1, -HALF,
     $                           A( K, K ), LDA, B( K, K+KB ), LDB,
     $                           CONE, A( K, K+KB ), LDA )
                     CALL ZTRSM( 'Right', UPLO, 'No transpose',
     $                           'Non-unit', KB, N-K-KB+1, CONE,
     $                           B( K+KB, K+KB ), LDB, A( K, K+KB ),
     $                           LDA )
                  END IF
   10          CONTINUE
            ELSE
*
*              Compute inv(L)*A*inv(L**H)
*
               DO 20 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the lower triangle of A(k:n,k:n)
*
                  CALL ZHEGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
                  IF( K+KB.LE.N ) THEN
                     CALL ZTRSM( 'Right', UPLO, 'Conjugate transpose',
     $                           'Non-unit', N-K-KB+1, KB, CONE,
     $                           B( K, K ), LDB, A( K+KB, K ), LDA )
                     CALL ZHEMM( 'Right', UPLO, N-K-KB+1, KB, -HALF,
     $                           A( K, K ), LDA, B( K+KB, K ), LDB,
     $                           CONE, A( K+KB, K ), LDA )
                     CALL ZHER2K( UPLO, 'No transpose', N-K-KB+1, KB,
     $                            -CONE, A( K+KB, K ), LDA,
     $                            B( K+KB, K ), LDB, ONE,
     $                            A( K+KB, K+KB ), LDA )
                     CALL ZHEMM( 'Right', UPLO, N-K-KB+1, KB, -HALF,
     $                           A( K, K ), LDA, B( K+KB, K ), LDB,
     $                           CONE, A( K+KB, K ), LDA )
                     CALL ZTRSM( 'Left', UPLO, 'No transpose',
     $                           'Non-unit', N-K-KB+1, KB, CONE,
     $                           B( K+KB, K+KB ), LDB, A( K+KB, K ),
     $                           LDA )
                  END IF
   20          CONTINUE
            END IF
         ELSE
            IF( UPPER ) THEN
*
*              Compute U*A*U**H
*
               DO 30 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the upper triangle of A(1:k+kb-1,1:k+kb-1)
*
                  CALL ZTRMM( 'Left', UPLO, 'No transpose', 'Non-unit',
     $                        K-1, KB, CONE, B, LDB, A( 1, K ), LDA )
                  CALL ZHEMM( 'Right', UPLO, K-1, KB, HALF, A( K, K ),
     $                        LDA, B( 1, K ), LDB, CONE, A( 1, K ),
     $                        LDA )
                  CALL ZHER2K( UPLO, 'No transpose', K-1, KB, CONE,
     $                         A( 1, K ), LDA, B( 1, K ), LDB, ONE, A,
     $                         LDA )
                  CALL ZHEMM( 'Right', UPLO, K-1, KB, HALF, A( K, K ),
     $                        LDA, B( 1, K ), LDB, CONE, A( 1, K ),
     $                        LDA )
                  CALL ZTRMM( 'Right', UPLO, 'Conjugate transpose',
     $                        'Non-unit', K-1, KB, CONE, B( K, K ), LDB,
     $                        A( 1, K ), LDA )
                  CALL ZHEGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
   30          CONTINUE
            ELSE
*
*              Compute L**H*A*L
*
               DO 40 K = 1, N, NB
                  KB = MIN( N-K+1, NB )
*
*                 Update the lower triangle of A(1:k+kb-1,1:k+kb-1)
*
                  CALL ZTRMM( 'Right', UPLO, 'No transpose', 'Non-unit',
     $                        KB, K-1, CONE, B, LDB, A( K, 1 ), LDA )
                  CALL ZHEMM( 'Left', UPLO, KB, K-1, HALF, A( K, K ),
     $                        LDA, B( K, 1 ), LDB, CONE, A( K, 1 ),
     $                        LDA )
                  CALL ZHER2K( UPLO, 'Conjugate transpose', K-1, KB,
     $                         CONE, A( K, 1 ), LDA, B( K, 1 ), LDB,
     $                         ONE, A, LDA )
                  CALL ZHEMM( 'Left', UPLO, KB, K-1, HALF, A( K, K ),
     $                        LDA, B( K, 1 ), LDB, CONE, A( K, 1 ),
     $                        LDA )
                  CALL ZTRMM( 'Left', UPLO, 'Conjugate transpose',
     $                        'Non-unit', KB, K-1, CONE, B( K, K ), LDB,
     $                        A( K, 1 ), LDA )
                  CALL ZHEGS2( ITYPE, UPLO, KB, A( K, K ), LDA,
     $                         B( K, K ), LDB, INFO )
   40          CONTINUE
            END IF
         END IF
      END IF
      RETURN
*
*     End of ZHEGST
*
      END
c $Id: zhegst.f 24343 2013-06-22 05:35:15Z d3y133 $

*> \brief \b CGERU
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CGERU(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
* 
*       .. Scalar Arguments ..
*       COMPLEX ALPHA
*       INTEGER INCX,INCY,LDA,M,N
*       ..
*       .. Array Arguments ..
*       COMPLEX A(LDA,*),X(*),Y(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CGERU  performs the rank 1 operation
*>
*>    A := alpha*x*y**T + A,
*>
*> where alpha is a scalar, x is an m element vector, y is an n element
*> vector and A is an m by n matrix.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>           On entry, M specifies the number of rows of the matrix A.
*>           M must be at least zero.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the number of columns of the matrix A.
*>           N must be at least zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is COMPLEX
*>           On entry, ALPHA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in] X
*> \verbatim
*>          X is COMPLEX array of dimension at least
*>           ( 1 + ( m - 1 )*abs( INCX ) ).
*>           Before entry, the incremented array X must contain the m
*>           element vector x.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           X. INCX must not be zero.
*> \endverbatim
*>
*> \param[in] Y
*> \verbatim
*>          Y is COMPLEX array of dimension at least
*>           ( 1 + ( n - 1 )*abs( INCY ) ).
*>           Before entry, the incremented array Y must contain the n
*>           element vector y.
*> \endverbatim
*>
*> \param[in] INCY
*> \verbatim
*>          INCY is INTEGER
*>           On entry, INCY specifies the increment for the elements of
*>           Y. INCY must not be zero.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX array of DIMENSION ( LDA, n ).
*>           Before entry, the leading m by n part of the array A must
*>           contain the matrix of coefficients. On exit, A is
*>           overwritten by the updated matrix.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program. LDA must be at least
*>           max( 1, m ).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex_blas_level2
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 2 Blas routine.
*>
*>  -- Written on 22-October-1986.
*>     Jack Dongarra, Argonne National Lab.
*>     Jeremy Du Croz, Nag Central Office.
*>     Sven Hammarling, Nag Central Office.
*>     Richard Hanson, Sandia National Labs.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE CGERU(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
*
*  -- Reference BLAS level2 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      COMPLEX ALPHA
      INTEGER INCX,INCY,LDA,M,N
*     ..
*     .. Array Arguments ..
      COMPLEX A(LDA,*),X(*),Y(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX ZERO
      PARAMETER (ZERO= (0.0E+0,0.0E+0))
*     ..
*     .. Local Scalars ..
      COMPLEX TEMP
      INTEGER I,INFO,IX,J,JY,KX
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (M.LT.0) THEN
          INFO = 1
      ELSE IF (N.LT.0) THEN
          INFO = 2
      ELSE IF (INCX.EQ.0) THEN
          INFO = 5
      ELSE IF (INCY.EQ.0) THEN
          INFO = 7
      ELSE IF (LDA.LT.MAX(1,M)) THEN
          INFO = 9
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('CGERU ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR. (ALPHA.EQ.ZERO)) RETURN
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF (INCY.GT.0) THEN
          JY = 1
      ELSE
          JY = 1 - (N-1)*INCY
      END IF
      IF (INCX.EQ.1) THEN
          DO 20 J = 1,N
              IF (Y(JY).NE.ZERO) THEN
                  TEMP = ALPHA*Y(JY)
                  DO 10 I = 1,M
                      A(I,J) = A(I,J) + X(I)*TEMP
   10             CONTINUE
              END IF
              JY = JY + INCY
   20     CONTINUE
      ELSE
          IF (INCX.GT.0) THEN
              KX = 1
          ELSE
              KX = 1 - (M-1)*INCX
          END IF
          DO 40 J = 1,N
              IF (Y(JY).NE.ZERO) THEN
                  TEMP = ALPHA*Y(JY)
                  IX = KX
                  DO 30 I = 1,M
                      A(I,J) = A(I,J) + X(IX)*TEMP
                      IX = IX + INCX
   30             CONTINUE
              END IF
              JY = JY + INCY
   40     CONTINUE
      END IF
*
      RETURN
*
*     End of CGERU .
*
      END
c $Id: cgeru.f 24342 2013-06-22 05:32:15Z d3y133 $

      Subroutine Banner(LU, Msg, Char, Top, Bot, Sides)
C$Id: banner.f 19707 2010-10-29 17:59:36Z d3y133 $
      Implicit NONE
      Integer LU
      Character*(*) Msg
      Character*(1) Char
      Logical Top, Bot, Sides
C
      Character*(80) Fmt
      Integer MsgLen
C
C     Figure out message length & create an appropriate format
C
      MsgLen = Len(Msg)
C     
      If ( Sides ) then
         Write( Fmt, 9000) MsgLen+4, Char
      Else
         Write( Fmt, 9000) MsgLen, Char
      EndIf
 9000 Format('(1X,', I5, '(''', A, '''))')
C
      If ( Top ) Write (Lu, Fmt=Fmt)
      If ( Sides ) then
         Write (Lu, Fmt = 9010) Char, Msg, Char
      Else
         Write (Lu, Fmt = 9010) Msg
      EndIf
      If ( Bot ) Write (Lu, Fmt=Fmt)
 9010 Format(1X, A, 1X, A, 1X, A)
C
      Return
      End

      Subroutine GA_Mat2Col( G_A, AILo, AIHi, AJLo, AJHi,
     $   G_B, BILo, BIHi, BJLo, BJHi)
C$Id: ga_mat2col.F 19707 2010-10-29 17:59:36Z d3y133 $
      Implicit NONE
#include "errquit.fh"
      Integer G_A, G_B, AILo, AIHi, AJLo, AJHi, BILo, BIHi, BJLo, BJHi
#include "mafdecls.fh"
#include "global.fh"
C LOCAL VARIABLES
      Integer LenCol, Me, NProc, BOff, Col
      Integer H_Col, I_Col
C
      Call GA_Sync
      Me = GA_NodeID()
      NProc = GA_NNodes()
C
C     Assume handles are okay, types is dbl, and dimensions are sensible
C
C     Use local memory long enough to hold a colum
C
      LenCol = AIHi - AILo + 1
      If ( .NOT. MA_Push_Get(MT_Dbl, LenCol, 'ga_mat2col tmp', H_Col,
     $   I_Col) ) Call ErrQuit(
     $   'GA_Mat2Col: Unable to allocate local memory', LenCol, MA_ERR)
C
C     Simple static load balancing, ignore data distribution.
C     Get a column and put it into the target.
C
      BOff = BILo
      Do Col = AJLo, AJHi
         If ( Mod(Col, NProc) .eq. Me) then
            Call GA_Get(G_A, AILo, AIHi, Col, Col,
     $         DBL_MB( I_Col), LenCol)
C
            Call GA_Put(G_B, BOff, BOff+LenCol-1, BJLo, BJHi,
     $         DBL_MB( I_Col), LenCol)
         EndIf
         BOff = BOff + LenCol
      EndDo
C
      If ( .NOT. MA_Pop_Stack( H_Col )) Call ErrQuit(
     $   'GA_Mat2Col: Unable to free local memory', 0, MA_ERR)
C
      Call GA_Sync
C
      Return
      End
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      Subroutine GA_Col2Mat( G_A, AILo, AIHi, AJLo, AJHi,
     $   G_B, BILo, BIHi, BJLo, BJHi)
      Implicit NONE
#include "errquit.fh"
      Integer G_A, G_B, AILo, AIHi, AJLo, AJHi, BILo, BIHi, BJLo, BJHi
#include "mafdecls.fh"
#include "global.fh"
C LOCAL VARIABLES
      Integer LenCol, Me, NProc, AOff, Col
      Integer H_Col, I_Col
C
      Call GA_Sync
      Me = GA_NodeID()
      NProc = GA_NNodes()
C
C     Assume handles are okay, types is dbl, and dimensions are sensible
C
C     Use local memory long enough to hold a colum
C
      LenCol = BIHi - BILo + 1
      If ( .NOT. MA_Push_Get(MT_Dbl, LenCol, 'ga_col2mat tmp', H_Col,
     $   I_Col) ) Call ErrQuit(
     $   'GA_Col2Mat: Unable to allocate local memory', LenCol, MA_ERR)
C
C     Simple static load balancing, ignore data distribution.
C     Get a column and put it into the target.
C
      AOff = AILo
      Do Col = BJLo, BJHi
         If ( Mod(Col, NProc) .eq. Me) then
            Call GA_Get(G_A, AOff, AOff+LenCol-1, AJLo, AJHi,
     $         DBL_MB( I_Col), LenCol)
C
            Call GA_Put(G_B, BILo, BIHi, Col, Col,
     $         DBL_MB( I_Col), LenCol)
         EndIf
         AOff = AOff + LenCol
      EndDo
C
      If ( .NOT. MA_Pop_Stack( H_Col )) Call ErrQuit(
     $   'GA_Col2Mat: Unable to free local memory', 0, MA_ERR)
C
      Call GA_Sync
C
      Return
      End

      subroutine tce_eom_ydiagon(needy1,needy2,needy3,needy4,
     1  size_y1,size_y2,size_y3,size_y4,
     2  k_y1_offset,k_y2_offset,k_y3_offset,k_y4_offset,
     3  d_r1,d_r2,d_r3,d_r4,omega,residual)
c
c $Id: tce_eom_ydiagon.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Form a subspace matrix and diagonalize
c
      implicit none
#include "stdio.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
#include "errquit.fh"
#include "util.fh"
      logical needy1
      logical needy2
      logical needy3
      logical needy4
      integer size_y1
      integer size_y2
      integer size_y3
      integer size_y4
      integer k_y1_offset
      integer k_y2_offset
      integer k_y3_offset
      integer k_y4_offset
      integer d_r1
      integer d_r2
      integer d_r3
      integer d_r4
      double precision omega(*)
      double precision residual(*)
      double precision overlap
      logical nodezero
      integer ivec, jvec
      integer l_hbar, k_hbar
      integer l_vr, k_vr
      integer l_vl, k_vl
      integer l_ei, k_ei
      integer l_wk, k_wk
      integer info
      integer newnytrials
      double precision ddotfile,ddotfile_1,ddotfile_2
      external ddotfile,ddotfile_1,ddotfile_2
      double precision au2ev   ! Conversion factor from a.u. to eV
      parameter (au2ev=27.2113961d0)
      character*255 filename
c     logical hbar_restore
c     external hbar_restore
c     double precision hbar
c
      nodezero = (ga_nodeid().eq.0)
c
c     Allocate
c
      if (.not.ma_push_get(mt_dbl,nytrials*nytrials,'hbar',
     1  l_hbar,k_hbar)) call errquit('tce_eom_ydiagon: MA problem',0,
     2  UNKNOWN_ERR)
      if (.not.ma_push_get(mt_dbl,nytrials*nytrials,'vr',
     1  l_vr,k_vr)) call errquit('tce_eom_ydiagon: MA problem',1,
     2  UNKNOWN_ERR)
      if (.not.ma_push_get(mt_dbl,nytrials,'vl',
     1  l_vl,k_vl)) call errquit('tce_eom_ydiagon: MA problem',2,
     2  UNKNOWN_ERR)
      if (.not.ma_push_get(mt_dbl,nytrials,'ei',
     1  l_ei,k_ei)) call errquit('tce_eom_ydiagon: MA problem',4,
     2  UNKNOWN_ERR)
      if (.not.ma_push_get(mt_dbl,4*nytrials,'work',
     1  l_wk,k_wk)) call errquit('tce_eom_ydiagon: MA problem',5,
     2  UNKNOWN_ERR)
c
c     Form similarity transformed Hamiltonian subspace matrix
c
      do ivec = 1, nytrials
        do jvec = 1, nytrials
c         if (hbar_restore(ivec,jvec,hbar)) then
c           dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) = hbar
c         else
            dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) = 0.0d0
            if (needy1) then
              if (.not.y1_exist(ivec))
     1          call errquit('tce_eom_ydiagon: y1 not found',ivec,
     2          UNKNOWN_ERR)
              if (.not.yp1_exist(jvec))
     1          call errquit('tce_eom_ydiagon: yp1 not found',jvec,
     2          UNKNOWN_ERR)
              dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) = 
     1        dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) + 
     2        ddotfile_1(y1(jvec),yp1(ivec),size_y1)
            endif
            if (needy2) then
              if (.not.y2_exist(ivec))
     1          call errquit('tce_eom_ydiagon: y2 not found',ivec,
     2          UNKNOWN_ERR)
              if (.not.yp2_exist(jvec))
     1          call errquit('tce_eom_ydiagon: yp2 not found',jvec,
     2          UNKNOWN_ERR)
              dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) = 
     1        dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) + 
     2        ddotfile_2(y2(jvec),yp2(ivec),size_y2)
            endif
            if (needy3) then
              if (.not.y3_exist(ivec))
     1          call errquit('tce_eom_ydiagon: y3 not found',ivec,
     2          UNKNOWN_ERR)
              if (.not.yp3_exist(jvec))
     1          call errquit('tce_eom_ydiagon: yp3 not found',jvec,
     2          UNKNOWN_ERR)
              dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) = 
     1        dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) + 
     2        ddotfile(y3(jvec),yp3(ivec),size_y3)
            endif
            if (needy4) then
              if (.not.y4_exist(ivec))
     1          call errquit('tce_eom_ydiagon: y4 not found',ivec,
     2          UNKNOWN_ERR)
              if (.not.yp4_exist(jvec))
     1          call errquit('tce_eom_ydiagon: yp4 not found',jvec,
     2          UNKNOWN_ERR)
              dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) = 
     1        dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1) + 
     2        ddotfile(y4(jvec),yp4(ivec),size_y4)
            endif
c           call hbar_store(ivec,jvec,
c    1        dbl_mb(k_hbar+(ivec-1)*nytrials+jvec-1))
c         endif
        enddo
      enddo
      if (nodezero.and.util_print('hbar',print_debug)) then
        write(LuOut,*)
        call ma_print(dbl_mb(k_hbar),nytrials,nytrials,
     1    "Similarity Transformed Hamiltonian")
      endif
c     call dcopy(nytrials**2,dbl_mb(k_hbar),1,dbl_mb(k_gbar),1)
c
c     Diagonalize the non-Hermitian matrix
c
      call tce_dgeev('n','v',nytrials,dbl_mb(k_hbar),nytrials,
     1  omega,dbl_mb(k_ei),dbl_mb(k_vl),1,dbl_mb(k_vr),nytrials,
     2  dbl_mb(k_wk),4*nytrials,info)
      if (info.ne.0) call errquit('tce_eom_ydiagon: dgeev failed',info,
     1  UNKNOWN_ERR)
c     call tce_schmidt(nytrials,dbl_mb(k_vr))
      call tce_sort(nytrials,omega,dbl_mb(k_vr),'A')
      if (nodezero.and.util_print('omega',print_debug)) then
        do ivec = 1, nytrials
          write(LuOut,9000) omega(ivec),omega(ivec)*au2ev
        enddo
      endif
      if (nodezero.and.util_print('vectors',print_debug)) then
        call ma_print(dbl_mb(k_vr),nytrials,nytrials,'Eigenvectors')
      endif
c
c     Compute residuals
c
      newnytrials = nytrials
      do ivec = 1, nroots_reduced
        residual(ivec) = 0.0d0
        if (needy1) then
          call tce_zero(d_r1,size_y1)
          call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1      yp1,d_r1,size_y1)
          call dfill(nytrials,0.0d0,dbl_mb(k_ei),1)    
          call daxpy(nytrials,-omega(ivec),
     1      dbl_mb(k_vr+(ivec-1)*nytrials),1,dbl_mb(k_ei),1)
          call daxpyfile(nytrials,dbl_mb(k_ei),
     1      y1,d_r1,size_y1)
          residual(ivec) = residual(ivec) 
     1                   + ddotfile_1(d_r1,d_r1,size_y1)
          if (nodezero.and.util_print('residual',print_debug)) then
            write(LuOut,*) ' Y1: vector',ivec
            write(LuOut,*) ' Y1: residual',residual(ivec)
            call sf_print(d_r1,size_y1)
          endif
        endif
        if (needy2) then
          call tce_zero(d_r2,size_y2)
          call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1      yp2,d_r2,size_y2)
          call dfill(nytrials,0.0d0,dbl_mb(k_ei),1)    
          call daxpy(nytrials,-omega(ivec),
     1      dbl_mb(k_vr+(ivec-1)*nytrials),1,dbl_mb(k_ei),1)
          call daxpyfile(nytrials,dbl_mb(k_ei),
     1      y2,d_r2,size_y2)
          residual(ivec) = residual(ivec) 
     1                   + ddotfile_2(d_r2,d_r2,size_y2)
          if (nodezero.and.util_print('residual',print_debug)) then
            write(LuOut,*) ' Y2: vector',ivec
            write(LuOut,*) ' Y2: residual',residual(ivec)
            call sf_print(d_r2,size_y2)
          endif
        endif
        if (needy3) then
          call tce_zero(d_r3,size_y3)
          call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1      yp3,d_r3,size_y3)
          call dfill(nytrials,0.0d0,dbl_mb(k_ei),1)    
          call daxpy(nytrials,-omega(ivec),
     1      dbl_mb(k_vr+(ivec-1)*nytrials),1,dbl_mb(k_ei),1)
          call daxpyfile(nytrials,dbl_mb(k_ei),
     1      y3,d_r3,size_y3)
          residual(ivec) = residual(ivec) 
     1                   + ddotfile(d_r3,d_r3,size_y3)
          if (nodezero.and.util_print('residual',print_debug)) then
            write(LuOut,*) ' Y3: vector',ivec
            write(LuOut,*) ' Y3: residual',residual(ivec)
            call sf_print(d_r3,size_y3)
          endif
        endif
        if (needy4) then
          call tce_zero(d_r4,size_y4)
          call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1      yp4,d_r4,size_y4)
          call dfill(nytrials,0.0d0,dbl_mb(k_ei),1)    
          call daxpy(nytrials,-omega(ivec),
     1      dbl_mb(k_vr+(ivec-1)*nytrials),1,dbl_mb(k_ei),1)
          call daxpyfile(nytrials,dbl_mb(k_ei),
     1      y4,d_r4,size_y4)
          residual(ivec) = residual(ivec) 
     1                   + ddotfile(d_r4,d_r4,size_y4)
          if (nodezero.and.util_print('residual',print_debug)) then
            write(LuOut,*) ' Y4: vector',ivec
            write(LuOut,*) ' Y4: residual',residual(ivec)
            call sf_print(d_r4,size_y4)
          endif
        endif
        residual(ivec) = dsqrt(residual(ivec))
        if (nodezero.and.util_print('residual',print_debug)) then
          write(LuOut,*) ivec,' residual',residual(ivec)
        endif
c
c       New trial vectors
c
        if (residual(ivec).gt.thresh) then
          if (newnytrials.ge.maxtrials) call errquit
     1      ('tce_eom_ydiagon: nytrials exceeded maxtrials',newnytrials,
     2      CALC_ERR)
          if (needy1) call tce_jacobi_y1(d_r1,k_y1_offset)
          if (needy2) call tce_jacobi_y2(d_r2,k_y2_offset)
          if (needy3) call tce_jacobi_y3(d_r3,k_y3_offset)
          if (needy4) call tce_jacobi_y4(d_r4,k_y4_offset)
          if (needy1) call dscalfile(1.0d0/residual(ivec),d_r1,size_y1)
          if (needy2) call dscalfile(1.0d0/residual(ivec),d_r2,size_y2)
          if (needy3) call dscalfile(1.0d0/residual(ivec),d_r3,size_y3)
          if (needy4) call dscalfile(1.0d0/residual(ivec),d_r4,size_y4)
          do jvec = 1, newnytrials
            overlap = 0.0d0
            if(needy1) overlap=overlap+ddotfile_1(d_r1,y1(jvec),size_y1)
            if(needy2) overlap=overlap+ddotfile_2(d_r2,y2(jvec),size_y2)
            if (needy3) overlap=overlap+ddotfile(d_r3,y3(jvec),size_y3)
            if (needy4) overlap=overlap+ddotfile(d_r4,y4(jvec),size_y4)
            if (needy1) call daxpyfile(1,-overlap,y1(jvec),d_r1,size_y1)
            if (needy2) call daxpyfile(1,-overlap,y2(jvec),d_r2,size_y2)
            if (needy3) call daxpyfile(1,-overlap,y3(jvec),d_r3,size_y3)
            if (needy4) call daxpyfile(1,-overlap,y4(jvec),d_r4,size_y4)
          enddo
          overlap = 0.0d0
          if (needy1) overlap=overlap+ddotfile_1(d_r1,d_r1,size_y1)
          if (needy2) overlap=overlap+ddotfile_2(d_r2,d_r2,size_y2)
          if (needy3) overlap=overlap+ddotfile(d_r3,d_r3,size_y3)
          if (needy4) overlap=overlap+ddotfile(d_r4,d_r4,size_y4)
          overlap = dsqrt(overlap)
          if (needy1) call dscalfile(1.0d0/overlap,d_r1,size_y1)
          if (needy2) call dscalfile(1.0d0/overlap,d_r2,size_y2)
          if (needy3) call dscalfile(1.0d0/overlap,d_r3,size_y3)
          if (needy4) call dscalfile(1.0d0/overlap,d_r4,size_y4)
          if (overlap.gt.thresh) then
            newnytrials = newnytrials + 1
            if (needy1) then
              call tce_filenameindexed(newnytrials,'y1',filename)
              call createfile(filename,y1(newnytrials),size_y1)
              call gatoeaf(y1(newnytrials))
              call copyfile(d_r1,y1(newnytrials),size_y1)
              call gatodra(y1(newnytrials))
              y1_exist(newnytrials) = .true.
            endif
            if (needy2) then
              call tce_filenameindexed(newnytrials,'y2',filename)
              call createfile(filename,y2(newnytrials),size_y2)
              call gatoeaf(y2(newnytrials))
              call copyfile(d_r2,y2(newnytrials),size_y2)
              call gatodra(y2(newnytrials))
              y2_exist(newnytrials) = .true.
            endif
            if (needy3) then
              call tce_filenameindexed(newnytrials,'y3',filename)
              call createfile(filename,y3(newnytrials),size_y3)
              call gatoeaf(y3(newnytrials))
              call copyfile(d_r3,y3(newnytrials),size_y3)
              call gatodra(y3(newnytrials))
              y3_exist(newnytrials) = .true.
            endif
            if (needy4) then
              call tce_filenameindexed(newnytrials,'y4',filename)
              call createfile(filename,y4(newnytrials),size_y4)
              call gatoeaf(y4(newnytrials))
              call copyfile(d_r4,y4(newnytrials),size_y4)
              call gatodra(y4(newnytrials))
              y4_exist(newnytrials) = .true.
            endif
          endif
        else
c         if (nodezero) write(LuOut,9010) ivec
          if (needy1) then
            call tce_zero(d_r1,size_y1)
            call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1        y1,d_r1,size_y1)
            call tce_filenameindexed(ivec,'yc1',filename)
            call createfile(filename,yc1(ivec),size_y1)
            call gatoeaf(yc1(ivec))
            call copyfile(d_r1,yc1(ivec),size_y1)
            call gatodra(yc1(ivec))
            yc1_exist(ivec) = .true.
          endif
          if (needy2) then
            call tce_zero(d_r2,size_y2)
            call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1        y2,d_r2,size_y2)
            call tce_filenameindexed(ivec,'yc2',filename)
            call createfile(filename,yc2(ivec),size_y2)
            call gatoeaf(yc2(ivec))
            call copyfile(d_r2,yc2(ivec),size_y2)
            call gatodra(yc2(ivec))
            yc2_exist(ivec) = .true.
          endif
          if (needy3) then
            call tce_zero(d_r3,size_y3)
            call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1        y3,d_r3,size_y3)
            call tce_filenameindexed(ivec,'yc3',filename)
            call createfile(filename,yc3(ivec),size_y3)
            call gatoeaf(yc3(ivec))
            call copyfile(d_r3,yc3(ivec),size_y3)
            call gatodra(yc3(ivec))
            yc3_exist(ivec) = .true.
          endif
          if (needy4) then
            call tce_zero(d_r4,size_y4)
            call daxpyfile(nytrials,dbl_mb(k_vr+(ivec-1)*nytrials),
     1        y4,d_r4,size_y4)
            call tce_filenameindexed(ivec,'yc4',filename)
            call createfile(filename,yc4(ivec),size_y4)
            call gatoeaf(yc4(ivec))
            call copyfile(d_r4,yc4(ivec),size_y4)
            call gatodra(yc4(ivec))
            yc4_exist(ivec) = .true.
          endif
        endif
      enddo
      if (newnytrials.eq.nytrials) then
        do ivec = 1,nroots_reduced
          if (residual(ivec).gt.thresh)
     1      call errquit('tce_eom_ydiagon: failed to extend subspace',0,
     2      CALC_ERR)
        enddo
      endif
      nytrials = newnytrials
c
c     Deallocate
c
      if (.not.ma_pop_stack(l_wk))
     1  call errquit('tce_eom_ydiagon: MA problem',6,MA_ERR)
      if (.not.ma_pop_stack(l_ei))
     1  call errquit('tce_eom_ydiagon: MA problem',7,MA_ERR)
      if (.not.ma_pop_stack(l_vl))
     1  call errquit('tce_eom_ydiagon: MA problem',9,MA_ERR)
      if (.not.ma_pop_stack(l_vr))
     1  call errquit('tce_eom_ydiagon: MA problem',10,MA_ERR)
      if (.not.ma_pop_stack(l_hbar))
     1  call errquit('tce_eom_ydiagon: MA problem',11,MA_ERR)
 9000 format(1x,f20.10,' hartree ',f20.10,' eV')
 9010 format(1x,'Root ',i3,' converged')
      return
      end

      SUBROUTINE ccsdtq_lambda1_20_18(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdtq_lambda1_20_18.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p15 p17 p18 h13 h14 h16 )_vttt + = 2 * Sum ( h10 ) * t ( p15 p18 h10 h13 )_t * i2 ( h10 p17 h14 h16 )_vtt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p15b
      INTEGER p18b
      INTEGER p17b
      INTEGER h13b
      INTEGER h14b
      INTEGER h16b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h10b
      INTEGER p15b_1
      INTEGER p18b_1
      INTEGER h13b_1
      INTEGER h10b_1
      INTEGER p17b_2
      INTEGER h10b_2
      INTEGER h14b_2
      INTEGER h16b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p15b = noab+1,noab+nvab
      DO p18b = p15b,noab+nvab
      DO p17b = noab+1,noab+nvab
      DO h13b = 1,noab
      DO h14b = 1,noab
      DO h16b = h14b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b
     &-1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h16b-1).ne.12)) THEN
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b-1)+int_mb(k_spin+p18b
     &-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin
     &+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+p18b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h14b-1
     &),int_mb(k_sym+h16b-1)))))) .eq. ieor(irrep_v,ieor(irrep_t,ieor(ir
     &rep_t,irrep_t)))) THEN
      dimc = int_mb(k_range+p15b-1) * int_mb(k_range+p17b-1) * int_mb(k_
     &range+p18b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+h14b-1) * 
     &int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_18',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h10b = 1,noab
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p18b-1) .eq. int_mb(k_spin
     &+h13b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p18b-1),ieor(int_m
     &b(k_sym+h13b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p15b,p18b,h13b,h10b,p15b_1,p18b_1,h13b_1,h10
     &b_1)
      CALL TCE_RESTRICTED_4(p17b,h10b,h14b,h16b,p17b_2,h10b_2,h14b_2,h16
     &b_2)
      dim_common = int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p15b-1) * int_mb(k_range+p18b-1) * int_
     &mb(k_range+h13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p17b-1) * int_mb(k_range+h14b-1) * int_
     &mb(k_range+h16b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_18',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_18',2,MA_ERR)
      IF ((h10b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (p18b_1 - noab - 1 + nvab * (p
     &15b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h10b-1),int_mb(k_range+h13
     &b-1),4,2,1,3,1.0d0)
      END IF
      IF ((h13b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (p18b_1 - noab - 1 + nvab * (p
     &15b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h13b-1),int_mb(k_range+h10
     &b-1),3,2,1,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_20_18',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_18',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_18',5,MA_ERR)
      IF ((h10b .le. p17b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h16b_
     &2 - 1 + noab * (h14b_2 - 1 + noab * (p17b_2 - noab - 1 + nvab * (h
     &10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+p17b-1),int_mb(k_range+h14b-1),int_mb(k_range+h16
     &b-1),4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_20_18',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_1
     &8',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_1
     &8',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_18',9,MA_ERR)
      IF ((p15b .le. p17b) .and. (p17b .le. p18b) .and. (h13b .le. h14b)
     &) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,3,5,4,2,1,2.0
     &d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p17b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF ((p15b .le. p17b) .and. (p17b .le. p18b) .and. (h14b .le. h13b)
     & .and. (h13b .le. h16b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,3,5,2,4,1,-2.
     &0d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h13b - 1 + noab * (h14b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p17b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF ((p15b .le. p17b) .and. (p17b .le. p18b) .and. (h16b .le. h13b)
     &) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,3,5,2,1,4,2.0
     &d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h13b 
     &- 1 + noab * (h16b - 1 + noab * (h14b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p17b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF ((p17b .le. p15b) .and. (h13b .le. h14b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),3,6,5,4,2,1,-2.
     &0d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p15b - noab - 1 + nvab * (p17b - noab - 1)))))))
      END IF
      IF ((p17b .le. p15b) .and. (h14b .le. h13b) .and. (h13b .le. h16b)
     &) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),3,6,5,2,4,1,2.0
     &d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h13b - 1 + noab * (h14b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p15b - noab - 1 + nvab * (p17b - noab - 1)))))))
      END IF
      IF ((p17b .le. p15b) .and. (h16b .le. h13b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),3,6,5,2,1,4,-2.
     &0d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h13b 
     &- 1 + noab * (h16b - 1 + noab * (h14b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p15b - noab - 1 + nvab * (p17b - noab - 1)))))))
      END IF
      IF ((p18b .le. p17b) .and. (h13b .le. h14b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,5,3,4,2,1,-2.
     &0d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (p17b - noab - 
     &1 + nvab * (p18b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF ((p18b .le. p17b) .and. (h14b .le. h13b) .and. (h13b .le. h16b)
     &) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,5,3,2,4,1,2.0
     &d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h13b - 1 + noab * (h14b - 1 + noab * (p17b - noab - 
     &1 + nvab * (p18b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF ((p18b .le. p17b) .and. (h16b .le. h13b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,5,3,2,1,4,-2.
     &0d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h13b 
     &- 1 + noab * (h16b - 1 + noab * (h14b - 1 + noab * (p17b - noab - 
     &1 + nvab * (p18b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_20_18',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_1
     &8',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

C $Id: path.F 19821 2010-12-14 07:46:49Z d3y133 $
      Subroutine drdy_path(ns)
C
C  Calculate steepest descent path from saddle point
C     lgs(31)  -  option for following MEP
C              =1, use Euler integrator
C              =2, use Page-McIver LQA algorithm
C              =3, use Page-McIver CLQA algorithm
C              =4, use Page-McIver CUBE algorithm
C
      Implicit none
      Integer ns
      Integer i,ierr,ii,iopt,j,nbar
      Double Precision delss,delsh,dxmag,smax,sold,swf,xsign

      Double Precision eps
c
#include "drdyP.fh"
C
      Data eps/1.d-6/
C
      sold = 0.0d0
      iopt = lgs(31)
      nbar = (n3*(n3+1))/2
      write (fu6,600) dels,delsv,delhss,dir,slm,slp
      if (iopt.le.1) then
         write (fu6,601)
      else if (iopt.eq.2) then
         write (fu6,602)
      else if (iopt.eq.3) then
         write (fu6,603)
      else
         write (fu6,604)
      end if
C
      if (lgs(1).ne.0) then
C Set up for calculation on reactant side (if lgs(1)=0 then no saddle
C    point and reaction path is in product direction only)
         xsign = -1.0d00
         smax = slm
         if (ns.gt.0 .and. sgrid(1).lt.0.0d00) then
C Restart from grid point with most negative s value
            ii = 0
            dxmag = 0.0d00
            do i = 1,n3
               x(i) = xgrid(i,1)
               dx(i) = dxgrid(i,1)
               dxmag = dxmag + dx(i)*dx(i)
               do j = 1,i
                  ii = ii + 1
                  f(j,i) = hgrid(ii,1)
                  f(i,j) = hgrid(ii,1)
               enddo
            enddo
            dxmag = sqrt(dxmag)
            if (iopt.ge.3) then
C For PG CLQA and CUBE algorithms we need the Hessian at a previous point
               if (ns.ge.2) then
                  sold = sgrid(2)
                  ii = 0
                  do i = 1,n3
                     do j = 1,i
                        ii = ii + 1
                        fold(j,i) = hgrid(ii,2)
                        fold(i,j) = hgrid(ii,2)
                     enddo
                  enddo
               else
C Use saddle point Hessian as previous one
                  sold = 0.0
                  do i = 1,n3
                     do j = 1,n3
                        fold(j,i) = fspsv(j,i)
                     enddo
                  enddo
               endif
            endif
            write(fu6,605)
            write(fu6,606)
            write(fu6,607) sgrid(1),vgrid(1),(x(i),i=1,n3)
            write(fu6,608) dxmag,(dx(i)/dxmag,i=1,n3)
            s = sgrid(1)
            delss = 0.0d00
            delsh = 0.0d00
            do i = 1,n3
               dxold(i) = dx(i)/dxmag
            enddo
C
         else
C Take step off saddle point in reactant direction
            write(fu6,609)
            write(fu6,606)
            write(fu6,607) 0.,vspsv-vzero,(xspsv(i),i=1,n3)
            write(fu6,608) 0.,(vec0sv(i),i=1,n3)
            if (lgs(39).ne.0) write (fu6,6001) vspspsv-vzerosp
            do i = 1,n3
               x(i) = xspsv(i)-dels*(vec0sv(i)-0.5d00*dels*vec1sv(i))
               do j = 1,n3
                  f(j,i) = fspsv(j,i)
               enddo
            enddo
            if (iopt.ge.3) then
C For CLQA and CUBE, store hessian matrix in fold
               sold = 0.0d00
               do i = 1,n3
                  do j = 1,n3
                     fold(j,i) = f(j,i)
                  enddo
               enddo
            endif
            s = -dels
            delss = dels
            delsh = dels
C Calculate g and optionally f at new geometry
            if (iopt.lt.3 .and. delss.lt.delsv*(1.0d00-eps) .and.
     *       delsh.lt.delhss*(1.0d00-eps)) then
               Call drdy_pot1 (x,v,dx,scr1,amass,natom,n3)
            else
               Call drdy_pot2 (x,v,dx,f,hess,scr1,amass,natom,n3,
     *            n3tm,nbar)
               delsh = 0.0d00
            endif
            write(fu6,607) s,v-vzero,(x(i),i=1,n3)
            dxmag = 0.0d00
            do i = 1,n3
               dxmag = dxmag + dx(i)*dx(i)
            enddo
            dxmag = sqrt(dxmag)
            write(fu6,608) dxmag,(dx(i)/dxmag,i=1,n3)
            do i = 1,n3
               dxold(i) = dx(i)/dxmag
            enddo
            if (delss.ge.delsv*(1.0d00-eps)) then
               swf = s
               if(lgs(38).gt.0) call drdy_wfiles(swf,0)
               if (lgs(39).ne.0) then
                  call drdy_potsp(x,vspc,scr1,amass,natom,n3)
                  write (fu6,6001) vspc-vzerosp
                  if(lgs(38).eq.4) call drdy_wfiles(swf,1)
               endif
               call drdy_rphwrt (7)
               if(lgs(2).ne.0) then
                  ierr = 0
                  call drdy_projct(ierr)
                  if (ierr.eq.0) call drdy_fdiag(n3,nf(5),ierr,lgs(2))
               endif
               delss = 0.0d00
            endif
         endif
C
         Call drdy_path2(iopt,delss,delsh,sold,smax,xsign)
C
      endif
C
C Calculation on product side
      xsign = 1.0d00
      smax = slp
      if (((lgs(1).ne.0.and.ns.gt.0) .or. ns.gt.1) .and. 
     *   sgrid(ns).gt.0.0d00) then
C Restart from grid point with most positive s value
         ii = 0
         dxmag = 0.0
         do i = 1,n3
            x(i) = xgrid(i,ns)
            dx(i) = dxgrid(i,ns)
            dxmag = dxmag + dx(i)*dx(i)
            do j = 1,i
               ii = ii + 1
               f(j,i) = hgrid(ii,ns)
               f(i,j) = hgrid(ii,ns)
            enddo
         enddo
         dxmag = sqrt(dxmag)
         if (iopt.ge.3) then
C For PM CLQA and CUBE algorithms we need the Hessian at a previous point
            if (ns.ge.2) then
               sold = sgrid(ns-1)
               ii = 0
               do i = 1,n3
                  do j = 1,i
                     ii = ii + 1
                     fold(j,i) = hgrid(ii,ns-1)
                     fold(i,j) = hgrid(ii,ns-1)
                  enddo
               enddo
            else
C Use saddle point Hessian as previous one (note that for lgs(1)=0,
C  ns>1 so this section will not be called
               sold = 0.0d00
               do i = 1,n3
                  do j = 1,n3
                     fold(j,i) = fspsv(j,i)
                  enddo
               enddo
            endif
         endif
         write(fu6,610)
         write(fu6,606)
         write(fu6,607) sgrid(ns),vgrid(ns),(x(i),i=1,n3)
         write(fu6,608) dxmag,(dx(i)/dxmag,i=1,n3)
         do i = 1,n3
            dxold(i) = dx(i)/dxmag
         enddo
         s = sgrid(ns)
         delss = 0.0d00
         delsh = 0.0d00
C 
      elseif (lgs(1).ne.0) then
C Calculation for step off saddle point
         write(fu6,611)
         write(fu6,606)
         write(fu6,607) 0.,vspsv-vzero,(xspsv(i),i=1,n3)
         write(fu6,608) 0.,(vec0sv(i),i=1,n3)
C Take step off saddle point in product direction
         do i = 1,n3
            x(i) = xspsv(i) + dels*(vec0sv(i) +
     &           0.5d0*dels*vec1sv(i))
            do j = 1,n3
               f(j,i) = fspsv(j,i)
            enddo
         enddo
         if (iopt.ge.3) then
C For CLQA and CUBE, store hessian matrix in fold
            sold = 0.0d00
            do i = 1,n3
               do j = 1,n3
                  fold(j,i) = f(j,i)
               enddo
            enddo
         endif
         s = dels
         delss = dels
         delsh = dels
C Calculate g and optionally f at new geometry
         if (iopt.lt.3 .and. delss.lt.delsv*(1.0d00-eps) .and.
     *    delsh.lt.delhss*(1.0-eps)) then
            Call drdy_pot1 (x,v,dx,scr1,amass,natom,n3)
         else
            Call drdy_pot2 (x,v,dx,f,hess,scr1,amass,natom,n3,
     *         n3tm,nbar)
            delsh = 0.0d00
         endif
         write(fu6,607) s,v-vzero,(x(i),i=1,n3)
         dxmag = 0.0
         do i = 1,n3
            dxmag = dxmag + dx(i)*dx(i)
         enddo
         dxmag = sqrt(dxmag)
         write(fu6,608) dxmag,(dx(i)/dxmag,i=1,n3)
         do i = 1,n3
            dxold(i) = dx(i)/dxmag
         enddo
         if (delss.ge.delsv*(1.0d00-eps)) then
            swf = s
            if(lgs(38).gt.0) call drdy_wfiles(swf,0)
            if (lgs(39).ne.0) then
               call drdy_potsp(x,vspc,scr1,amass,natom,n3)
               write (fu6,6001) vspc-vzerosp
               if(lgs(38).eq.4) call drdy_wfiles(swf,1)
            endif
            call drdy_rphwrt (7)
            if(lgs(2).ne.0) then
               ierr = 0
               call drdy_projct(ierr)
               if (ierr.eq.0) call drdy_fdiag(n3,nf(5),ierr,lgs(2))
            endif
            delss = 0.0d00
         endif
      else
C No saddle point, take step from starting geometry
         dxmag = 0.0d00
         do i = 1,n3
            x(i) = xspsv(i)
            dx(i) = dxspsv(i)
            dxmag = dxmag + dx(i)*dx(i)
            do j = 1,n3
               f(j,i) = fspsv(j,i)
C For CLQA and CUBE, store hessian matrix in fold
               fold(j,i) = fspsv(j,i)
            enddo
         enddo
         dxmag = sqrt(dxmag)
         write(fu6,612)
         write(fu6,606)
         write(fu6,607) 0.,vspsv-vzero,(x(i),i=1,n3)
         write(fu6,608) dxmag,(dx(i)/dxmag,i=1,n3)
         if (iopt.le.1) then
            call drdy_euler (n3tm,n3,x,dx,dels)
         else
            ierr = 0
            call drdy_pmlqa (n3tm,n3,nbar,x,dx,f,hess,amass,
     *       dels,vec0,vec1,u0,scr1,vec2,ierr)
            sold = 0.0
         endif
         s = dels
         delss = dels
         delsh = dels
C Calculate g and f at new geometry
         if (iopt.lt.3 .and. delss.lt.delsv*(1.0d00-eps) .and.
     *    delsh.lt.delhss*(1.0d00-eps)) then
            Call drdy_pot1 (x,v,dx,scr1,amass,natom,n3)
         else
            Call drdy_pot2 (x,v,dx,f,hess,scr1,amass,natom,n3,
     *        n3tm,nbar)
            delsh = 0.0d00
         endif
         write(fu6,607) s,v-vzero,(x(i),i=1,n3)
         dxmag = 0.0d00
         do i = 1,n3
            dxmag = dxmag + dx(i)*dx(i)
         enddo
         dxmag = sqrt(dxmag)
         write(fu6,608) dxmag,(dx(i)/dxmag,i=1,n3)
         do i = 1,n3
            dxold(i) = dx(i)/dxmag
         enddo
         if (delss.ge.delsv*(1.0d00-eps)) then
            swf = s
            if(lgs(38).gt.0) call drdy_wfiles(swf,0)
            if (lgs(39).ne.0) then
               call drdy_potsp(x,vspc,scr1,amass,natom,n3)
               write (fu6,6001) vspc-vzerosp
               if(lgs(38).eq.4) call drdy_wfiles(swf,1)
            endif
            call drdy_rphwrt (7)
            if(lgs(2).ne.0) then
               ierr = 0
               call drdy_projct(ierr)
               if (ierr.eq.0) call drdy_fdiag(n3,nf(5),ierr,lgs(2))
            endif
            delss = 0.0
         endif
      endif
C
      Call drdy_path2(iopt,delss,delsh,sold,smax,xsign)
C
      Return
600   Format(//,' ********** Calculate points along reaction path',//,
     *   5x,' dels=',T20,1pe13.5,/,5x,' delsv=',T20,1pe13.5,/,
     *   5x,' delhss=',T20,1pe13.5,/,5x,' dir=',T20,1pe13.5,/,
     *   5x,' slm=', T20,1pe13.5,/,5x,' slp=',T20,1pe13.5)
601   Format(/,' Path followed using Euler integrator')
602   Format(/,' Path followed using Page-McIver LQA algorithm')
603   Format(/,' Path followed using Page-McIver CLQA algorithm')
604   Format(/,' Path followed using Page-McIver CUBE algorithm')
605   Format(/,' Take step from restart geometry in reactant',
     *   ' direction')
606   Format(/,'  All quantities in atomic units, x is vector of ',
     *   'mass-weighted coordinates,',/,'  dx is the normalized mass-',
     *   'weighted gradient vector, and |dV/x| is the magnitude of',
     *   ' the gradient',/,9x,'s',7x,'V,|dV/dx|')
607   Format (t4,0pf12.5,1pe13.5,T33,'x=',(T35,0p9f9.4))
608   Format (15x,1pe13.5,T32,'dx=',(T35,0p9f9.4))
6001  Format(11x,'Vsp=',1pe13.5)
609   Format(/,' Take step from saddle point in reactant direction')
610   Format(/,' Take step from restart geometry in product',
     *   ' direction')
611   Format(/,' Take step from saddle point in product direction')
612   Format(/,' Take step from initial geometry along gradient')
      End

*> \brief \b STRTI2 computes the inverse of a triangular matrix (unblocked algorithm).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download STRTI2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/strti2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/strti2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/strti2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE STRTI2( UPLO, DIAG, N, A, LDA, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          DIAG, UPLO
*       INTEGER            INFO, LDA, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> STRTI2 computes the inverse of a real upper or lower triangular
*> matrix.
*>
*> This is the Level 2 BLAS version of the algorithm.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          Specifies whether the matrix A is upper or lower triangular.
*>          = 'U':  Upper triangular
*>          = 'L':  Lower triangular
*> \endverbatim
*>
*> \param[in] DIAG
*> \verbatim
*>          DIAG is CHARACTER*1
*>          Specifies whether or not the matrix A is unit triangular.
*>          = 'N':  Non-unit triangular
*>          = 'U':  Unit triangular
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the triangular matrix A.  If UPLO = 'U', the
*>          leading n by n upper triangular part of the array A contains
*>          the upper triangular matrix, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading n by n lower triangular part of the array A contains
*>          the lower triangular matrix, and the strictly upper
*>          triangular part of A is not referenced.  If DIAG = 'U', the
*>          diagonal elements of A are also not referenced and are
*>          assumed to be 1.
*>
*>          On exit, the (triangular) inverse of the original matrix, in
*>          the same storage format.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -k, the k-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup realOTHERcomputational
*
*  =====================================================================
      SUBROUTINE STRTI2( UPLO, DIAG, N, A, LDA, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J
      REAL               AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, STRMV, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STRTI2', -INFO )
         RETURN
      END IF
*
      IF( UPPER ) THEN
*
*        Compute inverse of upper triangular matrix.
*
         DO 10 J = 1, N
            IF( NOUNIT ) THEN
               A( J, J ) = ONE / A( J, J )
               AJJ = -A( J, J )
            ELSE
               AJJ = -ONE
            END IF
*
*           Compute elements 1:j-1 of j-th column.
*
            CALL STRMV( 'Upper', 'No transpose', DIAG, J-1, A, LDA,
     $                  A( 1, J ), 1 )
            CALL SSCAL( J-1, AJJ, A( 1, J ), 1 )
   10    CONTINUE
      ELSE
*
*        Compute inverse of lower triangular matrix.
*
         DO 20 J = N, 1, -1
            IF( NOUNIT ) THEN
               A( J, J ) = ONE / A( J, J )
               AJJ = -A( J, J )
            ELSE
               AJJ = -ONE
            END IF
            IF( J.LT.N ) THEN
*
*              Compute elements j+1:n of j-th column.
*
               CALL STRMV( 'Lower', 'No transpose', DIAG, N-J,
     $                     A( J+1, J+1 ), LDA, A( J+1, J ), 1 )
               CALL SSCAL( N-J, AJJ, A( J+1, J ), 1 )
            END IF
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of STRTI2
*
      END
c $Id: strti2.f 24343 2013-06-22 05:35:15Z d3y133 $

      double precision function gdot(n, buf1, nx, buf2, ny)
c     
c kahan's careful sum applied to dot products
c
      integer n, nx, ny
      double precision buf1(*), buf2(*)
c     
      integer i
      double precision s_1, c_1, y_1, t_1, f_1
c     
      s_1 = 0.d0
      c_1 = 0.d0
      do i = 1, n
         y_1 = c_1 + buf1(i)*buf2(i)
         t_1 = s_1 + y_1
         f_1 = 0.d0
         if ( y_1 .lt. 0.d0 .and. s_1 .lt. 0.d0 )
     $        f_1 = (0.46d0*t_1 - t_1)+t_1
         if ( y_1 .gt. 0.d0 .and. s_1 .gt. 0.d0 )
     $        f_1 = (0.46d0*t_1 - t_1)+t_1
         c_1 = ((s_1 - f_1) - ( t_1 - f_1)) + y_1
         s_1 = t_1
      enddo
      s_1 = s_1 + c_1
      gdot = s_1
      return
      end
c $Id: gdot.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine tce_schmidt(n,vector)
c
c $Id: tce_schmidt.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c Schmidt orthonormalize vectors
c Written by So Hirata, Feb 2002.
c (c) Battelle, PNNL, 2002.
c
      implicit none
#include "errquit.fh"
      integer n
      double precision vector(n,n)
      integer i,j,k
      double precision a

      do i=1,n
        a=0.0d0
        do k=1,n
          a=a+vector(k,i)*vector(k,i)
        enddo
        if (a.eq.0.0d0) call errquit
     1    ('tce_schmidt: unable to normalize',0, CALC_ERR)
        do k=1,n
          vector(k,i)=vector(k,i)/dsqrt(a)
        enddo
        if (i.ne.n) then
          do j=i+1,n
            a=0.0d0
            do k=1,n
              a=a+vector(k,i)*vector(k,j)
            enddo
            do k=1,n
              vector(k,j)=vector(k,j)-a*vector(k,i)
            enddo
          enddo
        endif
      enddo
      return
      end

!$Id: paw_density.F 19707 2010-10-29 17:59:36Z d3y133 $
!
!$Log: not supported by cvs2svn $
!Revision 1.7  2005/01/30 07:16:17  bylaska
!Parallelized radial integrations...EJB
!
!Revision 1.6  2003/10/21 02:05:16  marat
!switched to new errquit by running global replace operation
!see the script below (note it will not work on multiline errquit calls)
!*********************************************************
!#!/bin/sh
!
!e=`find . -name "*F" -print`
!
!for f in $e
!do
!cp $f $f.bak
!sed  's|\(^[ ].*call[ ]*errquit([^,]*\)\(,[^,]*\)\()\)|\1,0\2\3|' $f.bak > $f
!#rm $f.bak
!done
!**********************************************************
!
!Revision 1.5  2003/02/18 01:58:33  marat
!removed write statement
!MV
!
!Revision 1.4  2003/02/17 05:58:08  marat
!added lmax as an argument to init_paw_density
!MV
!
!Revision 1.3  2003/02/17 05:53:40  marat
!fixed bug in deallocation
!MV
!
!Revision 1.2  2003/02/17 00:52:31  marat
!generated multipole expansion of the atomic densities
!freed the memory
!
!MV
!
!Revision 1.1  2003/02/16 21:40:00  marat
!initial version
!MV
!


Cc     *************************************************
Cc     *                                               *
Cc     *             init_paw_density                  *
Cc     *                                               *
Cc     *************************************************
C
C      subroutine init_paw_density(ispin,lmax)
C      implicit none
C
C      integer ispin,lmax
C#include "paw_density_data.fh"
C#include "paw_basis.fh"
C#include "mafdecls.fh"      
C#include "paw_ma.fh"
C#include "paw_geom.fh"
C
C      logical ok
C      integer in,ia
C      integer nion
C      integer paw_rho_size
C
C*     **** external functions ****
C      integer  control_gga
C      external control_gga
C
C      nion = ion_nion()
C
C*     *** lmax for multipole expansion of the density***      
C      paw_rho_lmax  = lmax
C      paw_rho_ispin = ispin
C
C      paw_rho_gga = control_gga()
C      
C*     *** size for multipole density arrays ***
C      ok = my_alloc(mt_int,nion,"i_paw_rho",
C     >                                i_paw_rho)
C
C      paw_rho_size = 0     
C      do in=1,nion
C        ia = ion_katm(in)
C        int_mb(i_paw_rho(1) + in - 1) = paw_rho_size
Cc        paw_rho_size = paw_rho_size + paw_basis_i_cut(ia)*
Cc     >                                (paw_rho_lmax+1)**2
C        paw_rho_size = paw_rho_size + paw_basis_npoints(ia)*
C     >                                (paw_rho_lmax+1)**2
C      end do
C
C*     *** allocate multipole density arrays ****
C      ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_u_ae",
C     >                               paw_rho_ae(1,1)) 
C      ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_u_ps",
C     >                               paw_rho_ps(1,1)) 
C
C      if (paw_rho_gga.ge.10) then
C        ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_u_ae",
C     >                                 paw_rho_ae_prime(1,1)) 
C        ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_u_ps",
C     >                                 paw_rho_ps_prime(1,1)) 
C      end if
C
C      if (paw_rho_ispin.eq.2) then
C        ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_d_ae",
C     >                                 paw_rho_ae(1,2)) 
C        ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_d_ps",
C     >                               paw_rho_ps(1,2)) 
C        if (paw_rho_gga.ge.10) then
C          ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_d_ae",
C     >                                 paw_rho_ae_prime(1,2)) 
C          ok = ok .and. my_alloc(mt_dcpl,paw_rho_size,"paw_rho_d_ps",
C     >                               paw_rho_ps_prime(1,2)) 
C        end if
C
C      end if
C
C      end 
C
Cc     *********************************************
Cc     *                                           *
Cc     *           paw_density_solve               *
Cc     *                                           *
Cc     *********************************************
Cc
Cc   Calculates the atomic densities using from the
Cc   overlap coefficients.
C
C      subroutine paw_density_solve()
C      implicit none
C
C#include "mafdecls.fh"
C#include "paw_density_data.fh"
C#include "paw_geom.fh"
C#include "paw_basis.fh"
C#include "paw_proj.fh"
C#include "paw_ovlp_data.fh"
C      
C
C      integer i,li,mi,nilm
C      integer j,lj,mj,njlm
C      integer l,m,nlmi
C      integer in,ia,ms
C      integer nion
C      integer nb,nb2
C      integer ig,ng,ic,igg,istart
C      integer i_w,i_w0
C      integer i_rgrid
C      integer i_rho,i_rho0
C      integer i_phi_ae0
C      integer i_phi_ps0
C      double precision tmp
C      double precision tmp_gaunt
C      double complex    tmp_ms
C
C      double precision gen_gaunt_coeff
C      external gen_gaunt_coeff
C      
C      call nwpw_timing_start(21)
C      nion = ion_nion()
C
C*     ***init to zero***
C      do ms=1,paw_rho_ispin
C      call dcopy(2*paw_rho_ae(3,1),0.0d0,0,dcpl_mb(paw_rho_ae(1,ms)),1)
C      call dcopy(2*paw_rho_ae(3,1),0.0d0,0,dcpl_mb(paw_rho_ps(1,ms)),1)
C      end do
C
Cc      do i=1,paw_rho_u_ae(3)
Cc        dcpl_mb(paw_rho_ae(1,1)+i-1) = dcmplx(0,0) 
Cc        dcpl_mb(paw_rho_ae(1,2)+i-1) = dcmplx(0,0) 
Cc        dcpl_mb(paw_rho_ps(1,1)+i-1) = dcmplx(0,0) 
Cc        dcpl_mb(paw_rho_ps(1,2)+i-1) = dcmplx(0,0) 
Cc      end do
C
C
C      do in=1,nion
C        ia = ion_katm(in)
C        nb = paw_basis_nbasis(ia)
C        nb2 = nb*nb
C        ng = paw_basis_ngrid(ia)
Cc        ic = paw_basis_i_cut(ia)
C        ic = paw_basis_npoints(ia)
C        istart = paw_basis_i_start(ia)
C        i_rgrid = paw_basis_i_rgrid(ia)
C        i_phi_ae0 = paw_basis_i_phi_ae(ia)
C        i_phi_ps0 = paw_basis_i_phi_ps(ia)
C        i_w0 = int_mb(i_paw_ovlp_w(1) + in - 1)
C        i_rho0 = int_mb(i_paw_rho(1) + in - 1)
C        nilm = 0
C        do i=1,nb
C        li = paw_basis_orb_l(i,ia)
C        njlm = 0
C        do j=1,nb
C        lj = paw_basis_orb_l(j,ia)
C        nlmi = 0
C        do l=0,paw_rho_lmax
C        if(l.le.(li+lj) .and. l.ge.abs(li-lj)) then
C        do m=-l,l
C        do mi=-li,li
C        do mj=-lj,lj
C        if(m.eq.(mj-mi)) then
C          i_w   = i_w0-1+(njlm+lj+mj+1)+
C     >            (nilm+li+mi)*paw_proj_nbasis(ia)
C          tmp_gaunt = gen_gaunt_coeff(l,m,lj,mj,li,mi)
C
C          do ms=1,paw_rho_ispin
C            tmp_ms = tmp_gaunt* 
C     >             dcpl_mb(paw_ovlp_w_spin(1,ms) + i_w)       
C          
C            do ig=1,ic
C            igg = ig+istart-1
C
C            i_rho   = i_rho0-1+ig+
C     >            (nlmi+l+m)*ic
C          
C            tmp = dbl_mb(i_phi_ae0+(i-1)*ng+igg-1)*       
C     >                 dbl_mb(i_phi_ae0+(j-1)*ng+igg-1)/
C     >                 dbl_mb(i_rgrid+igg-1)**2 
C
C            dcpl_mb(paw_rho_ae(1,ms)+i_rho)=
C     >                 dcpl_mb(paw_rho_ae(1,ms)+i_rho)+
C     >                 tmp_ms*tmp
C                      
C            tmp = dbl_mb(i_phi_ps0+(i-1)*ng+igg-1)*       
C     >                 dbl_mb(i_phi_ps0+(j-1)*ng+igg-1)/
C     >                 dbl_mb(i_rgrid+igg-1)**2 
C
C            dcpl_mb(paw_rho_ps(1,ms)+i_rho)=
C     >                 dcpl_mb(paw_rho_ps(1,ms)+i_rho)+
C     >                 tmp_ms*tmp
C                      
C            end do
C           end do
C
C        end if
C        end do
C        end do
C        end do !m
C        end if
C        nlmi = nlmi + 2*l+1
C        end do !l
C        njlm = njlm + 2*lj+1
C        end do !j
C        nilm = nilm + 2*li+1
C        end do !i
C 
C      end do!in
C
C      call nwpw_timing_end(21)
C      return
C      end
C
Cc     **********************************************
Cc     *                                            *
Cc     *             paw_density_end                *
Cc     *                                            *
Cc     **********************************************
C
C      subroutine paw_density_end()
C      implicit none
C
C#include "paw_density_data.fh"
C#include "mafdecls.fh"      
C#include "paw_ma.fh"
C
C      logical ok
C      integer ms
C
C      ok =          my_dealloc(i_paw_rho)
C      do ms=1,paw_rho_ispin
C        ok = ok .and. my_dealloc(paw_rho_ae(1,ms)) 
C        ok = ok .and. my_dealloc(paw_rho_ps(1,ms))
C        if (paw_rho_gga.ge.10) then
C          ok = ok .and. my_dealloc(paw_rho_ae_prime(1,ms))
C          ok = ok .and. my_dealloc(paw_rho_ps_prime(1,ms))
C        end if
C      end do 
C      
C      if (.not.ok)
C     > call errquit("paw_density_end: error freeing heap",0,0)
C
C
C      end 
C
C
C
Cc     ********************************************
Cc     *                                          *
Cc     *        paw_density_prime_solve           *
Cc     *                                          *
Cc     ********************************************
C
Cc  This routine computes the radial gradient of the 
Cc  atomic densities from the overlap coefficients.
Cc
C
C      subroutine paw_density_prime_solve()
C      implicit none
C
C#include "mafdecls.fh"
C#include "paw_density_data.fh"
C#include "paw_geom.fh"
C#include "paw_basis.fh"
C#include "paw_proj.fh"
C#include "paw_ovlp_data.fh"
C      
C
C      integer i,li,mi,nilm
C      integer j,lj,mj,njlm
C      integer l,m,nlmi
C      integer in,ia,ms
C      integer nion
C      integer nb,nb2
C      integer ig,ng,ic,igg,istart
C      integer i_w,i_w0
C      integer i_rgrid
C      integer i_rho,i_rho0
C      integer i_phi_ae0,i_phi_ae0_prime
C      integer i_phi_ps0,i_phi_ps0_prime
C      double precision tmp
C      double precision tmp_gaunt
C      double complex   tmp_ms
C
C      double precision gen_gaunt_coeff
C      external gen_gaunt_coeff
C      
C      call nwpw_timing_start(21)
C      nion = ion_nion()
C
C*     ***init to zero***
C      do ms=1,paw_rho_ispin
C      call dcopy(2*paw_rho_ae_prime(3,1),0.0d0,0,
C     >           dcpl_mb(paw_rho_ae_prime(1,ms)),1)
C      call dcopy(2*paw_rho_ps_prime(3,1),0.0d0,0,
C     >           dcpl_mb(paw_rho_ps_prime(1,ms)),1)
C      end do
C
C
C
C      do in=1,nion
C        ia = ion_katm(in)
C        nb = paw_basis_nbasis(ia)
C        nb2 = nb*nb
C        ng = paw_basis_ngrid(ia)
Cc        ic = paw_basis_i_cut(ia)
C        ic = paw_basis_npoints(ia)
C        istart = paw_basis_i_start(ia)
C        i_rgrid = paw_basis_i_rgrid(ia)
C        i_phi_ae0       = paw_basis_i_phi_ae(ia)
C        i_phi_ps0       = paw_basis_i_phi_ps(ia)
C        i_phi_ae0_prime = paw_basis_i_phi_ae_prime(ia)
C        i_phi_ps0_prime = paw_basis_i_phi_ps_prime(ia)
C        i_w0 = int_mb(i_paw_ovlp_w(1) + in - 1)
C        i_rho0 = int_mb(i_paw_rho(1) + in - 1)
C        nilm = 0
C        do i=1,nb
C        li = paw_basis_orb_l(i,ia)
C        njlm = 0
C        do j=1,nb
C        lj = paw_basis_orb_l(j,ia)
C        nlmi = 0
C        do l=0,paw_rho_lmax
C        if(l.le.(li+lj) .and. l.ge.abs(li-lj)) then
C        do m=-l,l
C        do mi=-li,li
C        do mj=-lj,lj
C        if(m.eq.(mj-mi)) then
C          i_w   = i_w0-1+(njlm+lj+mj+1)+
C     >            (nilm+li+mi)*paw_proj_nbasis(ia)
C          tmp_gaunt = gen_gaunt_coeff(l,m,lj,mj,li,mi)
C
C          do ms=1,paw_rho_ispin
C            tmp_ms = tmp_gaunt* 
C     >             dcpl_mb(paw_ovlp_w_spin(1,ms) + i_w)       
C          
Cc            call paw_density_sub2(ic,tmp_ms,
Cc     >           dbl_mb(i_rgrid+istart-1),
Cc     >           dbl_mb(i_phi_ae0       +istart-1 +(i-1)*ng),
Cc     >           dbl_mb(i_phi_ae0_prime +istart-1 +(i-1)*ng),
Cc     >           dbl_mb(i_phi_ae0       +istart-1 +(j-1)*ng),
Cc     >           dbl_mb(i_phi_ae0_prime +istart-1 +(j-1)*ng),
Cc     >           dcpl_mb(paw_rho_ae_prime(1,ms)+irho0+(nlmi+l+m)*ic))
C
C            do ig=1,ic
C            igg = ig+istart-1
C
C            i_rho   = i_rho0-1+ig+
C     >            (nlmi+l+m)*ic
C          
C            tmp = (dbl_mb(i_phi_ae0_prime+(i-1)*ng+igg-1)       
C     >            *dbl_mb(i_phi_ae0+(j-1)*ng+igg-1)
C     >          +  dbl_mb(i_phi_ae0+(i-1)*ng+igg-1)
C     >            *dbl_mb(i_phi_ae0_prime+(j-1)*ng+igg-1))
C     >           /dbl_mb(i_rgrid+igg-1)**2 
C     >          - 2.0d0*(dbl_mb(i_phi_ae0+(i-1)*ng+igg-1)
C     >                 *dbl_mb(i_phi_ae0+(j-1)*ng+igg-1)
C     >                 /dbl_mb(i_rgrid+igg-1)**3)
C
C            dcpl_mb(paw_rho_ae_prime(1,ms)+i_rho)=
C     >                 dcpl_mb(paw_rho_ae_prime(1,ms)+i_rho)+
C     >                 tmp_ms*tmp
C
C            tmp =  (dbl_mb(i_phi_ps0_prime+(i-1)*ng+igg-1)       
C     >             *dbl_mb(i_phi_ps0+(j-1)*ng+igg-1)
C     >          +   dbl_mb(i_phi_ps0+(i-1)*ng+igg-1)
C     >             *dbl_mb(i_phi_ps0_prime+(j-1)*ng+igg-1))
C     >            /dbl_mb(i_rgrid+igg-1)**2 
C     >          - 2.0d0*(dbl_mb(i_phi_ps0+(i-1)*ng+igg-1)
C     >                 *dbl_mb(i_phi_ps0+(j-1)*ng+igg-1)
C     >                 /dbl_mb(i_rgrid+igg-1)**3)
C                      
C
C            dcpl_mb(paw_rho_ps_prime(1,ms)+i_rho)=
C     >                 dcpl_mb(paw_rho_ps_prime(1,ms)+i_rho)+
C     >                 tmp_ms*tmp
C                      
C            end do
C           end do
C
C        end if
C        end do
C        end do
C        end do !m
C        end if
C        nlmi = nlmi + 2*l+1
C        end do !l
C        njlm = njlm + 2*lj+1
C        end do !j
C        nilm = nilm + 2*li+1
C        end do !i
C 
C      end do!in
C
C      call nwpw_timing_end(21)
C      return
C      end
C
Cc      subroutine paw_density_sub2(ic,alpha,
Cc     >                            r,
Cc     >                            phi_i,dphi_i,
Cc     >                            phi_j,dphi_j,
Cc     >                            rho_prime)
Cc      implicit none
Cc      integer ic
Cc      double precision alpha
Cc      double precision r(*)
Cc      double precision phi_i(*),dphi_i(*)
Cc      double precision phi_j(*),dphi_j(*)
Cc      double precision rho_prime(*)
Cc
Cc*     **** local variables ****
Cc      integer          ig
Cc      double precision tmp
Cc
Cc      do ig=1,ic
Cc         tmp = dphi_i(ig)*phi_j(ig)/r(ig)**2
Cc     >       + phi_i(ig)*dphi_j(ig)/r(ig)**2
Cc     >       - 2.0d0*phi_i(ig)*phi_j(ig)/r(ig)**3
Cc
Cc         rho_prime(ig)=rho_prime(ig) + alpha*tmp
Cc      end do
Cc
Cc      return
Cc      end



c     *********************************************
c     *                                           *
c     *           paw_density_solve2              *
c     *                                           *
c     *********************************************
c
c   Calculates the atomic density lm expansions  from the
c   overlap coefficients.

      subroutine paw_density_solve2(ii,lmax,ic,lmax2,ispin0,
     >                              paw_rho_ae,paw_rho_ps)
      implicit none
      integer ii
      integer lmax
      integer ic,lmax2,ispin0
      double complex paw_rho_ae(ic,lmax2,ispin0)
      double complex paw_rho_ps(ic,lmax2,ispin0)

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_basis.fh"
#include "paw_proj.fh"
#include "paw_ovlp_data.fh"
      

      integer i,li,mi,nilm
      integer j,lj,mj,njlm
      integer l,m,nlmi
      integer ia,ms,l2
      integer nion
      integer nb,nb2
      integer ig,ng,igg,istart
      integer i_w,i_w0
      integer i_rgrid
      integer i_rho,i_rho0
      integer i_phi_ae0
      integer i_phi_ps0
      double precision tmp_ps,tmp_ae
      double precision tmp_gaunt
      double complex    tmp_ms

      double precision gen_gaunt_coeff
      external gen_gaunt_coeff
      
      call nwpw_timing_start(21)


*     ***init to zero***
      call dcopy(2*ic*lmax2*ispin0,0.0d0,0,paw_rho_ae,1)
      call dcopy(2*ic*lmax2*ispin0,0.0d0,0,paw_rho_ps,1)


      ia = ion_katm(ii)
      nb = paw_basis_nbasis(ia)
      nb2 = nb*nb
      ng = paw_basis_ngrid(ia)
c      ic = paw_basis_npoints(ia)
      istart = paw_basis_i_start(ia)
      i_rgrid = paw_basis_i_rgrid(ia)
      i_phi_ae0 = paw_basis_i_phi_ae(ia)
      i_phi_ps0 = paw_basis_i_phi_ps(ia)
      i_w0 = int_mb(i_paw_ovlp_w(1) + ii - 1)


      nilm = 0
      do i=1,nb
      li = paw_basis_orb_l(i,ia)
      njlm = 0
      do j=1,nb
      lj = paw_basis_orb_l(j,ia)
      nlmi = 0
      do l=0,lmax
        if(l.le.(li+lj) .and. l.ge.abs(li-lj)) then
        do m=-l,l
        do mi=-li,li
        do mj=-lj,lj
        if(m.eq.(mj-mi)) then

          i_w   = i_w0-1+(njlm+lj+mj+1)+
     >            (nilm+li+mi)*paw_proj_nbasis(ia)
          tmp_gaunt = gen_gaunt_coeff(l,m,lj,mj,li,mi)

          l2 = (nlmi+l+m)+1

          do ms=1,ispin0
            tmp_ms = tmp_gaunt* 
     >             dcpl_mb(paw_ovlp_w_spin(1,ms) + i_w)       
          
            call paw_density_gen_rho(ic,tmp_ms,
     >                              dbl_mb(i_rgrid+istart-1),
     >                              dbl_mb(i_phi_ae0+(i-1)*ng+istart-1),
     >                              dbl_mb(i_phi_ae0+(j-1)*ng+istart-1),
     >                              paw_rho_ae(1,l2,ms))
            call paw_density_gen_rho(ic,tmp_ms,
     >                              dbl_mb(i_rgrid+istart-1),
     >                              dbl_mb(i_phi_ps0+(i-1)*ng+istart-1),
     >                              dbl_mb(i_phi_ps0+(j-1)*ng+istart-1),
     >                              paw_rho_ps(1,l2,ms))
c            do ig=1,ic
c            igg = ig+istart-1
c
c            tmp_ae = dbl_mb(i_phi_ae0+(i-1)*ng+igg-1)*       
c     >                 dbl_mb(i_phi_ae0+(j-1)*ng+igg-1)/
c     >                 dbl_mb(i_rgrid+igg-1)**2 
c            tmp_ps = dbl_mb(i_phi_ps0+(i-1)*ng+igg-1)*       
c     >                 dbl_mb(i_phi_ps0+(j-1)*ng+igg-1)/
c     >                 dbl_mb(i_rgrid+igg-1)**2 
c
c            paw_rho_ae(ig,l2,ms) = paw_rho_ae(ig,l2,ms) + tmp_ms*tmp_ae
c            paw_rho_ps(ig,l2,ms) = paw_rho_ps(ig,l2,ms) + tmp_ms*tmp_ps
c            end do

           end do

        end if
        end do
        end do
        end do !m
        end if
        nlmi = nlmi + 2*l+1
      end do !l
      njlm = njlm + 2*lj+1
      end do !j
      nilm = nilm + 2*li+1
      end do !i
 
      call nwpw_timing_end(21)
      return
      end


      subroutine paw_density_gen_rho(ic,alpha,r,phi1,phi2,rho)
      implicit none
      integer ic
      double precision alpha(2)
      double precision r(ic)
      double precision phi1(ic)
      double precision phi2(ic)
      double precision rho(2,ic)

*     **** local variables ****
      integer i
      double precision tmp

      do i=1,ic
         tmp = (phi1(i)*phi2(i))/(r(i)**2)
         rho(1,i) = rho(1,i) + alpha(1)*tmp
         rho(2,i) = rho(2,i) + alpha(2)*tmp
      end do

      return
      end





c     *********************************************
c     *                                           *
c     *           paw_density_prime_solve2        *
c     *                                           *
c     *********************************************
c
c   Calculates the atomic density lm expansions  from the
c   overlap coefficients.

      subroutine paw_density_prime_solve2(ii,lmax,ic,lmax2,ispin0,
     >                              paw_rho_ae_prime,paw_rho_ps_prime)
      implicit none
      integer ii
      integer lmax
      integer ic,lmax2,ispin0
      double complex paw_rho_ae_prime(ic,lmax2,ispin0)
      double complex paw_rho_ps_prime(ic,lmax2,ispin0)

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_basis.fh"
#include "paw_proj.fh"
#include "paw_ovlp_data.fh"
      

      integer i,li,mi,nilm
      integer j,lj,mj,njlm
      integer l,m,nlmi
      integer ia,ms,l2
      integer nion
      integer nb,nb2
      integer ig,ng,igg,istart
      integer i_w,i_w0
      integer i_rgrid
      integer i_rho,i_rho0
      integer i_phi_ae0,i_phi_ae0_prime
      integer i_phi_ps0,i_phi_ps0_prime
      double precision tmp_ps,tmp_ae
      double precision tmp_gaunt
      double complex    tmp_ms

      double precision gen_gaunt_coeff
      external gen_gaunt_coeff
      
      call nwpw_timing_start(21)


*     ***init to zero***
      call dcopy(2*ic*lmax2*ispin0,0.0d0,0,paw_rho_ae_prime,1)
      call dcopy(2*ic*lmax2*ispin0,0.0d0,0,paw_rho_ps_prime,1)


      ia = ion_katm(ii)
      nb = paw_basis_nbasis(ia)
      nb2 = nb*nb
      ng = paw_basis_ngrid(ia)
c      ic = paw_basis_npoints(ia)
      istart  = paw_basis_i_start(ia)
      i_rgrid = paw_basis_i_rgrid(ia)

      i_phi_ae0       = paw_basis_i_phi_ae(ia)
      i_phi_ps0       = paw_basis_i_phi_ps(ia)
      i_phi_ae0_prime = paw_basis_i_phi_ae_prime(ia)
      i_phi_ps0_prime = paw_basis_i_phi_ps_prime(ia)

      i_w0 = int_mb(i_paw_ovlp_w(1) + ii - 1)


      nilm = 0
      do i=1,nb
      li = paw_basis_orb_l(i,ia)
      njlm = 0
      do j=1,nb
      lj = paw_basis_orb_l(j,ia)
      nlmi = 0
      do l=0,lmax
        if(l.le.(li+lj) .and. l.ge.abs(li-lj)) then
        do m=-l,l
        do mi=-li,li
        do mj=-lj,lj
        if(m.eq.(mj-mi)) then

          i_w   = i_w0-1+(njlm+lj+mj+1)+
     >            (nilm+li+mi)*paw_proj_nbasis(ia)
          tmp_gaunt = gen_gaunt_coeff(l,m,lj,mj,li,mi)

          l2 = (nlmi+l+m)+1

          do ms=1,ispin0
            tmp_ms = tmp_gaunt* 
     >             dcpl_mb(paw_ovlp_w_spin(1,ms) + i_w)       
          
            call paw_density_gen_drho(ic,tmp_ms,
     >              dbl_mb(i_rgrid                 +istart-1),
     >              dbl_mb(i_phi_ae0      +(i-1)*ng+istart-1),
     >              dbl_mb(i_phi_ae0_prime+(i-1)*ng+istart-1),
     >              dbl_mb(i_phi_ae0      +(j-1)*ng+istart-1),
     >              dbl_mb(i_phi_ae0_prime+(j-1)*ng+istart-1),
     >              paw_rho_ae_prime(1,l2,ms))
            call paw_density_gen_drho(ic,tmp_ms,
     >              dbl_mb(i_rgrid                 +istart-1),
     >              dbl_mb(i_phi_ps0      +(i-1)*ng+istart-1),
     >              dbl_mb(i_phi_ps0_prime+(i-1)*ng+istart-1),
     >              dbl_mb(i_phi_ps0      +(j-1)*ng+istart-1),
     >              dbl_mb(i_phi_ps0_prime+(j-1)*ng+istart-1),
     >              paw_rho_ps_prime(1,l2,ms))

           end do

        end if
        end do
        end do
        end do !m
        end if
        nlmi = nlmi + 2*l+1
      end do !l
      njlm = njlm + 2*lj+1
      end do !j
      nilm = nilm + 2*li+1
      end do !i
 
      call nwpw_timing_end(21)
      return
      end






      subroutine paw_density_gen_drho(ic,alpha,r,
     >                                phi1,dphi1,
     >                                phi2,dphi2,
     >                                drho)
      implicit none
      integer ic
      double precision alpha(2)
      double precision r(ic)
      double precision phi1(ic),dphi1(ic)
      double precision phi2(ic),dphi2(ic)
      double precision drho(2,ic)

*     **** local variables ****
      integer i
      double precision tmp

      do i=1,ic
         tmp = (dphi1(i)*phi2(i)+phi1(i)*dphi2(i))/(r(i)**2)
     >       - 2.0d0*(phi1(i)*phi2(i))/(r(i)**3)
         drho(1,i) = drho(1,i) + alpha(1)*tmp
         drho(2,i) = drho(2,i) + alpha(2)*tmp
      end do

      return
      end

*
* $Id: v_cpsi_read.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***************************
*     *          	   	*
*     *       v_cpsi_read	*
*     *             		*
*     ***************************
      subroutine v_cpsi_read(spin_orbit0,ispin0,ne0,nbrillioun0,
     >                       psi0_tag)
      implicit none 
      logical spin_orbit0
      integer ispin0,ne0(2),nbrillioun0
      integer psi0_tag

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "util.fh"

*    *** local variables ***
      integer rtdb
      integer version,l
      integer nfft3d,npack1
      integer nfft(3)
      real*8  unita(3,3)
      character*50 filename
      character*255 full_filename

*     **** local variables ****
      logical hprint,readblock
      integer MASTER,taskid,taskid_j,taskid_k
      parameter(MASTER=0)
      logical brillioun_check,psi_nolattice
      integer n,nb,nbrill,occupation,ms
      integer msglen,psiold,psiold1
      integer q,pj,nbq,pk,i
      integer ispin,ne(2)
      logical spin_orbit

c     complex*16 tmp(*)
      integer tmp(2),tmp2(2),tmpe(2)
      logical value

*     ***** local functions ****
      logical control_spin_orbit,control_print
      external control_spin_orbit,control_print
      character*50 control_input_v_psi
      external     control_input_v_psi
      double precision control_unita
      external         control_unita
      integer  control_ngrid,control_rtdb,control_fractional_orbitals
      external control_ngrid,control_rtdb,control_fractional_orbitals
      integer  cpsi_data_get_allptr,cpsi_data_get_next
      integer  cpsi_data_get_chnk
      external cpsi_data_get_allptr,cpsi_data_get_next
      external cpsi_data_get_chnk

      call Parallel_taskid(taskid)
      call Parallel3d_taskid_j(taskid_j)
      call Parallel3d_taskid_k(taskid_k)
      call C3dB_nfft3d(1,nfft3d)
      call Cram_max_npack(npack1)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)

      value = MA_push_get(mt_dcpl,nfft3d,'tmp',tmp(2),tmp(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      value = MA_push_get(mt_dcpl,nfft3d,'tmp2',tmp2(2),tmp2(1))
       if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      value = MA_push_get(mt_dbl,(ne0(1)+ne0(2)),'tmpe',tmpe(2),tmpe(1))
       if (.not. value) call errquit('out of stack memory',0, MA_ERR)
     
*     **** open ELCIN binary file ****
      if (taskid.eq.MASTER) then
         filename = control_input_v_psi()
         call util_file_name_noprefix(filename,.false.,
     >                                .false.,
     >                        full_filename)
         l = index(full_filename,' ') -1
         if (control_print(print_medium))
     >     write(luout,1210) full_filename(1:l)
 1210    FORMAT(/' input vpsi filename:',A)

         call openfile(5,full_filename,l,'r',l)
         call iread(5,version,1)
         call iread(5,nfft,3)
         call dread(5,unita,9)
         call iread(5,ispin,1)
         call iread(5,ne,2)
         call iread(5,nbrill,1)
         call iread(5,occupation,1)
      end if
      

c     **** send header to all nodes ****
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,version)
      msglen = 3
      call Parallel_Brdcst_ivalues(MASTER,msglen,nfft)
      msglen = 9
      call Parallel_Brdcst_values(MASTER,msglen,unita)
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,ispin)
      msglen = 2
      call Parallel_Brdcst_ivalues(MASTER,msglen,ne)
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,nbrill)
      call Parallel_Brdcst_ivalues(MASTER,msglen,occupation)


c     **** spin_orbit - ispin=3 --> ispin=2,spin_orbit=.true ****
      if (ispin.eq.3) then
         ispin = 2
         spin_orbit = .true.
      else
         spin_orbit = .false.
      end if


*     ***** Error checking ****
      readblock = .true.

      if (spin_orbit) then
        if (.not.spin_orbit0) readblock = .false.
      end if
      if (.not.spin_orbit) then
        if (spin_orbit0) readblock = .false.
      end if

      if ( (nfft(1).ne.control_ngrid(1)) .or.
     >     (nfft(2).ne.control_ngrid(2)) .or.
     >     (nfft(3).ne.control_ngrid(3)) ) then
         if (taskid.eq.MASTER) then
            write(*,*) "Error reading v_psi, v_psi set to zero"
            write(*,*) " - bad ngrid "
            write(*,*) " - vpsi_ngrid(1)=",nfft(1),
     >                 " ngrid(1)=",control_ngrid(1)
            write(*,*) " - vpsi_ngrid(2)=",nfft(2),
     >                 " ngrid(2)=",control_ngrid(2)
            write(*,*) " - vpsi_ngrid(3)=",nfft(3),
     >                 " ngrid(3)=",control_ngrid(3)
         end if
      end if

      if ( (unita(1,1).ne.control_unita(1,1)) .or.
     >     (unita(2,1).ne.control_unita(2,1)) .or.
     >     (unita(3,1).ne.control_unita(3,1)) .or.
     >     (unita(1,2).ne.control_unita(1,2)) .or.
     >     (unita(2,2).ne.control_unita(2,2)) .or.
     >     (unita(3,2).ne.control_unita(3,2)) .or.
     >     (unita(1,3).ne.control_unita(1,3)) .or.
     >     (unita(2,3).ne.control_unita(2,3)) .or.
     >     (unita(3,3).ne.control_unita(3,3)) .or.
     >     (ispin     .ne.ispin0)             .or.
     >     (nbrill    .ne.nbrillioun0)        .or.
     >     (ne(1)     .ne.ne0(1))             .or.
     >     (ne(2)     .ne.ne0(2))  ) then
         readblock = .false.
         if (taskid.eq.MASTER) then
            write(6,*) "Error reading v_psi, v_psi set to zero"
            write(6,*) " - incorrect unitcell,ispin, or ne"
         end if
      end if

*     *************************
*     *** read in 3d blocks ***
*     *************************

*     * file may contain more data then necessary *
      if (readblock) then
        do nb=1,nbrill
           call K1dB_ktoqp(nb,nbq,pk)
           do n=1,(ne(1)+ne(2))
              pj=0
              q=n
              call C3dB_c_Read(1,5,dcpl_mb(tmp2(1)),
     >                             dcpl_mb(tmp(1)),pj,pk)

            if ((pj.eq.taskid_j).and.(pk.eq.taskid_k)) then
               call Cram_c_pack(nbq,dcpl_mb(tmp2(1)))
               call cpsi_data_add(psi0_tag,nbq,q,dcpl_mb(tmp2(1)))
            end if
           end do
        end do
        if (occupation.gt.0) then
           l = cpsi_data_get_next(psi0_tag)
           if (nbrillioun0.eq.nbrill) then
  
              do nb=1,nbrill
                 call K1dB_ktoqp(nb,nbq,pk)
                 if (taskid.eq.MASTER) then
                    call dread(5,dbl_mb(tmpe(1)),(ne(1)+ne(2)))
                 end if
                 !** big broadcast - should be reduced ***
                 call Parallel_Brdcst_values(MASTER,
     >                         (ne(1)+ne(2)),dbl_mb(tmpe(1)))
                 if (pk.eq.taskid_k) then
                    do n=1,(ne(1)+ne(2))
                       call cpsi_data_add(l,nbq,n,dbl_mb(tmpe(1)+n-1))
                    end do
                 end if
              end do
*          **** reset to zeros and ones ****
           else
             do nb=1,nbrillioun0
               call K1dB_ktoqp(nb,nbq,pk) 
               if (pk.eq.taskid_k) then 
                 do ms=1,ispin
                 do n =1,ne(ms)
                 if (n.le.(ne(ms)-control_fractional_orbitals(ms))) then
                   unita(1,1) = 1.0d0  
                 else
                   unita(1,1) = 0.0d0  
                 end if
                 call cpsi_data_add(l,nbq,(n+(ms-1)*ne(1)),unita)
                 end do
                 end do
               end if
             end do
           end if

        end if
      end if

*     *** close ELCIN binary file ***
      if (taskid.eq.MASTER) then
        call closefile(5)
      end if
 
      value =           MA_pop_stack(tmpe(2))
      value = value.and.MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp(2))
*     end if

      return
      end

*
* $Id: fci_solve.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_solve(nroot, thresh, maxvec, ecore, h, g, 
     $     work, lenwrk, roots, evecfilename, diagfilename)
      implicit none
#include "fciinfo.fh"
c     
c     Solve the CI to the requested accuracy.  Right now just uses
c     determinants but is readily extended to also accomodate CSF.
c     
c     The eigenvalues are returned in roots.  The eigenvectors are
c     returned in file evecfilename.
c
c     The minimum amount of memory required is independent of the
c     number of roots, and is slightly larger than 2*ndeterminants.
c     The more memory the better, but 2*ndeterminants+500000 will
c     probably always be enough.
c     
      integer nroot             ! [input] No. of roots to find
      double precision thresh   ! [input] Threshold for residual norm
      integer maxvec            ! [input] Davidson subspace dim PER ROOT
      double precision ecore    ! [input] Nuclear repulsion+frozen core
      double precision h(nacttr) ! [input] h(ij) = h_{ij}
      double precision g(nacttr,nacttr) ! [input] g(ij,kl) = (ij|kl)
      integer lenwrk            ! [input] Size of work space
      double precision work(lenwrk) ! [scratch] Work space
      double precision roots(nroot) ! [output] Returns the eigenvalues
      character*(*) evecfilename ! [input] Name of file for eigen vectors
      character*(*) diagfilename ! [input] Name of file for diagonals
c     
      integer maxv              ! Local copy of maxvec so we can reduce it
      logical oprint
      integer itermx            ! Maximum number of iterations
      integer iv, ihd, itop2,  ionel, kpt, mkpt, ihmod
      integer ierr, nonelt, nonemx
c
      logical fci_davids
      external fci_davids
c
      integer evecfile, diagfile
c
      data itermx / 200/
c     
      oprint = .true.
      call fci_tstart(9,oprint)
c
      call fci_intchk(h, g)
c
c     Open files
c
      evecfile = 1
      diagfile = 2
      call wopen(evecfile, evecfilename, 0, 0, ierr)
      if (ierr .ne. 0) call fci_err
     $     ('fci_davids: failed to open evecfile', ierr)
      call wopen(diagfile, diagfilename, 0, 0, ierr)
      if (ierr .ne. 0) call fci_err
     $     ('fci_davids: failed to open diagfile', ierr)
c
c     Allocate temporary work space for initial guess and diags
c
      call fci_cntone(nonelt, nonemx)
      ihd = 1
      ihmod = ihd + ndets             ! h + 1/2 sum(k) (ik|kj)
      ionel = ihmod + nacttr
      kpt   = ihmod + (nonemx*5)/nav + 1 ! For computing diagonals
      mkpt  = kpt + nonemx/nav + 1 ! For computing diagonals
      itop2 = mkpt + ndetmx/nav + 1
      if (itop2 .gt. lenwrk+1) call fci_err
     $     ('fci_davids: insufficient memory for diagonals',itop2)
c
c     Modify the input 1-e integrals 
c
      call fci_hmod(h,g,work(ihmod))
c     
c     make the diagonals of the hamiltonian
c     
      call fci_diags(work(ihd),ecore,work(ihmod),g,work(ionel),
     $     nonemx,work(kpt), work(mkpt))
c
      call putwa(diagfile, work(ihd), 1, ndets, ierr)
      if (ierr.ne.0) call fci_err
     $     ('fci_davids: failed to write diagonals',ierr)
c
c     Form initial guess from the lowest energy orbital occupations
c     of the correct symmetry
c
      iv = ihd + ndets
      itop2 = iv + ndets
      if (itop2 .gt. lenwrk+1) call fci_err
     $     ('fci_davids: insufficient memory for guess',itop2)
      call fci_guess(evecfile, work(iv), work(ihd), nroot)
c
c     No memory is in use now.
c
      maxv = maxvec
      maxv = min(maxv,itermx,ncsf+1) ! Logic for small problems
c
      if (.not. fci_davids(ndets, nroot, itermx, maxv, thresh,
     $     work, lenwrk, evecfile, diagfile, roots, ecore, h, g))
     $     call fci_err('fci_davids failed', 0)
c     
      call wclose(evecfile,ierr)
      call wclose(diagfile,ierr)
c
      call fci_tfinish(9,oprint)
c     
      end
      subroutine fci_guess(evecfile, vec, diags, nroot)
      implicit none
#include "fciinfo.fh"
      integer evecfile          ! [input] Handle to vector file
      integer nroot             ! [input]
      double precision vec(ndets) ! [scratch]
      double precision diags(ndets) ! [input] Diagonal energies
c
c     Form an initial guess for nroot CI vectors of the correct symmetry.
c
c     Loop thru orbital configurations and determine the nroot
c     lowest energy orbital occupations.  Set the lowest energy 
c     determinant of each orbital occupation to 1 and then
c     spin project to get nroot orthogonal vectors of the correct
c     symmetry.
c
      integer iroot, iwalk, idone(50), jroot, sym, i, ilowest
      integer iocc(nactmx), ns, ioff, idim, iwalklo, ierr
      double precision elowest
#include "bitops.fh"
c
      if (nroot .gt. 50) call fci_err('fci_guess: nroot too big',nroot)
c
      write(6,*)
      do iroot = 1, nroot
         ilowest = -1
         elowest = 9999999.0d0
         do 10 iwalk = 1, nwalko
            do jroot = 1, iroot-1
               if (idone(jroot).eq.iwalk) goto 10
            enddo
            call fci_owalk_info(iwalk, iocc, ns, ioff, idim, sym)
            if (sym .eq. statesym) then
               do i = 1, idim
                  if (diags(i+ioff).lt.elowest) then
                     ilowest = i+ioff
                     iwalklo = iwalk
                     elowest = diags(ilowest)
                  endif
               enddo
            endif
 10      continue
         if (ilowest .le. 0) call fci_err
     $        ('fci_guess: insufficient independent states',nroot)
         call dfill(0.0d0, vec, 1, ndets)
c
         write(6,11) iroot, ilowest, elowest
 11      format(' Guess for root ', i2, ' is determinant ', 
     $        i8, ' energy ', f12.6)
         vec(ilowest) = 1.0d0
         call fci_spin_force(vec)
         call putwa(evecfile, vec, (iroot-1)*ndets + 1, ndets, ierr)
         if (ierr.ne.0) call fci_err
     $        ('fci_guess: failed writing vector ', ierr)
         idone(iroot) = iwalklo
      enddo
      write(6,*)
c
      end
      subroutine fci_readevectors(ndets, nvec, v, filename)
      implicit none
      integer ndets             ! [input] Vector length
      integer nvec             ! [input] No. 
      double precision v(ndets,nvec)
      character*(*) filename
c
      integer ierr, file
c
      file = 1
      call wopen(file, filename, 0, 0, ierr)
      if (ierr .ne. 0) call fci_err
     $     ('fci_readvectors: failed to open file', ierr)
      call getwa(file, v, 1, nvec*ndets, ierr)
      if (ierr .ne. 0) call fci_err
     $     ('fci_readvectors: failed to read file', ierr)
      call wclose(file,ierr)
c
      end

*,eke
* $Id: inner_loop_ofpw.F 24736 2013-10-29 20:50:30Z bylaska $
*

*  ************************************************************
*  *                cpsd routine                              *
*  *                                                          *
*  ************************************************************
  
      subroutine inner_loop_ofpw(ispin,ne,
     >                      npack1,nfft3d,
     >                      psi1,psi2,dn,
     >                      it_in,E,deltae,deltac,deltar,
     >                      hml,lmd,
     >                      psi_r,Hpsi)
      implicit none
      integer    ispin,ne(2)
      integer    npack1,nfft3d
      complex*16 psi1(npack1,ispin)
      complex*16 psi2(npack1,ispin)
      real*8     dn(2*nfft3d,2)
      integer    it_in
      real*8     E(*)
      real*8     deltae,deltac,deltar
      real*8     hml(*),lmd(*)

*     **** very big workspace variables ****
      real*8     psi_r(2*nfft3d,ispin)
      complex*16 Hpsi(npack1,ispin)


#include "mafdecls.fh"
#include "errquit.fh"


*     **** local variables ****
      logical move,sic,hfx
      integer n2ft3d,np_i,np_j
      integer i,n,n1(2),n2(2),it,ms,nn,ierr,nne(2)
      integer nx,ny,nz
      integer gga
      real*8  sum,Eold,eorbit,eion,ehartr,eke,elocal,enlocal
      real*8  A,B,C,x
      real*8  exc,exc2,pxc,pxc2,dte,scal1,scal2,dv,dt
      real*8  etf,etf2,ptf,ptf2
      real*8  evw,ewgc,pwgc,pwgc2
      real*8  ehsic,phsic,exsic,pxsic,ehfx,phfx
      real*8  deltamm
      real*8  e_lj, e_q, e_spring
      !real*8 e_ionmm,e_qmmm,e_mmmm,e_pol,e_vib,e_cav



*     **** MA local variables ****
      logical value,field_exist
*     real*8     tmp_L(8*nemax*nemax)
*     complex*16 tmp1(nfft3d)
*     complex*16 tmp2(nfft3d)
c     complex*16  vl(nfft3d)
c     complex*16  vc(nfft3d)
c     complex*16 dng(nfft3d)
c     real*8     xcp(2*nfft3d,2)
c     real*8     xce(2*nfft3d,2)
c     real*8     fion(3,natmx)
      integer tmp_L(2)
      integer tmp1(2),tmp2(2)
      integer vl(2),vc(2),dng(2)
      integer vlr_l(2),rho(2),r_grid(2)
      integer v_field(2),v_tmp(2)
      integer xcp(2),xce(2),dnall(2),v_tf(2),e_tf(2),v_wgc(2)
      integer natmx,fion(2),ftest(2)
      integer sumi(2)
      integer npack0

*     ***** external functions ****
      logical  control_move,psp_semicore
      logical  pspw_SIC,pspw_SIC_relaxed
      logical  pspw_HFX,pspw_HFX_relaxed
      integer  ion_nion,control_gga
      real*8   control_time_step,control_fake_mass,ion_dti
      real*8   lattice_omega,coulomb_e,ewald_e
      external control_move,psp_semicore
      external pspw_SIC,pspw_SIC_relaxed
      external pspw_HFX,pspw_HFX_relaxed
      external ion_nion,control_gga
      external control_time_step,control_fake_mass,ion_dti
      external lattice_omega,coulomb_e,ewald_e
      integer  control_version
      external control_version
      real*8   ion_ion_e
      external ion_ion_e

      double precision Dneall_m_trace,wgc_e
      external         Dneall_m_trace,wgc_e
      logical  Dneall_m_push_get_block,Dneall_m_pop_stack
      external Dneall_m_push_get_block,Dneall_m_pop_stack

*     ***** QM/MM external functions ****
      logical  pspw_charge_found,pspw_qmmm_found
      real*8   pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E
      external pspw_charge_found,pspw_qmmm_found
      external pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E

      call Pack_npack(0,npack0)
      call D3dB_n2ft3d(1,n2ft3d)
      deltamm = 0.0d0

      field_exist = pspw_charge_found()
      gga = control_gga()

      call nwpw_timing_start(12)


*     **** allocate MA local variables ****
      value = MA_push_get(mt_dcpl,(nfft3d),'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d),'tmp2',tmp2(2),tmp2(1))

      if (control_version().eq.3) then
       value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'vc',  vc(2),  vc(1))
      end if

      if (control_version().eq.4) then
       value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'vc',vc(2),vc(1))
       value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'vlr_l',vlr_l(2),vlr_l(1))
      end if

      if ((field_exist).or.(control_version().eq.4)) then
       value = value.and.
     >    MA_push_get(mt_dbl,(3*n2ft3d),'r_grid',r_grid(2),r_grid(1))
      end if

       value = value.and.
     >  MA_push_get(mt_dbl,(n2ft3d),'v_field',v_field(2),v_field(1))

      value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'vloc', vl(2), vl(1))
       call dcopy(2*npack0,0.0d0,0,dcpl_mb(vl(1)),1)
      value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'rho',rho(2),rho(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'dng',dng(2), dng(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'xcp',xcp(2), xcp(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'xce',xce(2), xce(1))

      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'v_tmp',v_tmp(2), v_tmp(1))

      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'v_tf',v_tf(2), v_tf(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(2*nfft3d),'e_tf',e_tf(2), e_tf(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'v_wgc',v_wgc(2), v_wgc(1))
      call dcopy(n2ft3d,0.0d0,0,dbl_mb(v_wgc(1)),1)

      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'dnall',dnall(2),dnall(1))
      natmx = ion_nion()
      value = value.and.
     >        MA_push_get(mt_dbl,(3*natmx),'fion',fion(2),fion(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(3*natmx),'ftest',ftest(2),ftest(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(ispin),'sumi',sumi(2),sumi(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      call nwpw_timing_end(12)
     
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      move = control_move()
      

      dt = control_time_step()
      dte = dt/dsqrt(control_fake_mass())
      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()
      dv    = scal1*lattice_omega()

      if ((control_version().eq.4).or.(field_exist))
     >   call lattice_r_grid(dbl_mb(r_grid(1)))

*     ******************************************
*     ****                                  ****
*     ****   Start of steepest descent loop ****
*     ****                                  ****
*     ******************************************
      do it=1,it_in
        call dcopy(2*npack1*ispin,psi2,1,psi1,1)
        if (move) call ion_shift()

*       ********************************
*       **** generate phaze factors ****
*       ********************************
        call phafac()
        if (control_version().eq.3) call ewald_phafac()


        call nwpw_timing_start(11)
*       *******************
*       **** get psi_r ****
*       *******************
        do n=1,ispin
           call Pack_c_Copy(1,psi1(1,n),psi_r(1,n))
           call Pack_c_unpack(1,psi_r(1,n))
           call D3dB_cr_pfft3b(1,1,psi_r(1,n))
        end do




*       *********************
*       **** generate dn ****
*       *********************
        call dcopy(ispin*n2ft3d,0.0d0,0,dn,1)
        do ms=1,ispin
           do i=1,n2ft3d
              dn(i,ms) = dn(i,ms) + dble(ne(ms))*scal2*(psi_r(i,ms)**2)
           end do
           call D3dB_r_Zero_Ends(1,dn(1,ms))
        end do

*       **********************
*       **** generate dng ****
*       **********************
        call D3dB_rr_Sum(1,dn(1,1),dn(1,ispin),dbl_mb(rho(1)))
        call D3dB_r_SMul(1,scal1,dbl_mb(rho(1)),dcpl_mb(tmp1(1)))
        !call D3dB_rc_fft3f(1,dcpl_mb(tmp1(1)))
        call D3dB_rc_pfft3f(1,0,dcpl_mb(tmp1(1)))
        call Pack_c_pack(0,dcpl_mb(tmp1(1)))
        call Pack_c_Copy(0,dcpl_mb(tmp1(1)),dcpl_mb(dng(1)))




*       ********************************************************
*       **** generate dnall - used for semicore corrections ****
*       ********************************************************
        if (psp_semicore(0)) then
           if (move .or. (it.eq.1)) call semicore_density_update()
           call semicore_density(dcpl_mb(tmp1(1)))
           call D3dB_r_SMul(1,0.5d0,dcpl_mb(tmp1(1)),dcpl_mb(tmp1(1)))
        else
           call dcopy(n2ft3d,0.0d0,0,dcpl_mb(tmp1(1)),1)
        end if
        do ms=1,ispin
          call D3dB_rr_Sum(1,dn(1,ms),
     >                     dcpl_mb(tmp1(1)),
     >                     dbl_mb(dnall(1) +(ms-1)*n2ft3d))
        end do
        
        call nwpw_timing_end(11)


*       *****************************************
*       **** generate local pseudopotential  ****
*       **** and also get force if move true ****
*       *****************************************
 
        call v_local(dcpl_mb(vl(1)),
     >               move,
     >               dcpl_mb(dng(1)),
     >               dbl_mb(fion(1)))


*       *** long-range psp for charge systems ***
        if (control_version().eq.4) then
          call v_lr_local(dbl_mb(r_grid(1)),
     >                    dbl_mb(vlr_l(1)))
          if (move) then
             call grad_v_lr_local(dbl_mb(r_grid(1)),
     >                            dbl_mb(rho(1)),
     >                            dbl_mb(fion(1)))
          end if
        end if


*       ************************************
*       **** generate coulomb potential ****
*       ************************************
        if (control_version().eq.3) 
     >     call coulomb_v(dcpl_mb(dng(1)),dcpl_mb(vc(1)))

        if (control_version().eq.4) 
     >     call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))



*       *************************************************
*       **** generate exchange-correlation potential ****
*       *************************************************
        if (gga.eq.0) then
          call vxc(n2ft3d,ispin,dbl_mb(dnall(1)),
     >                      dbl_mb(xcp(1)),
     >                      dbl_mb(xce(1)),
     >                      dcpl_mb(tmp1(1)))
        else if ((gga.ge.10).and.(gga.lt.100)) then
          call v_bwexc(gga,n2ft3d,ispin,dbl_mb(dnall(1)),
     >                      1.0d0,1.0d0,
     >                      dbl_mb(xcp(1)),
     >                      dbl_mb(xce(1)))

        else if (gga.eq.110) then
          call v_bwexc(10,n2ft3d,ispin,dbl_mb(dnall(1)),
     >                      0.75d0,1.0d0,
     >                      dbl_mb(xcp(1)),
     >                      dbl_mb(xce(1)))
        else if (gga.eq.112) then
          call v_bwexc(12,n2ft3d,ispin,dbl_mb(dnall(1)),
     >                      0.75d0,1.0d0,
     >                      dbl_mb(xcp(1)),
     >                      dbl_mb(xce(1)))

        end if

*       *************************************************
*       **** generate Kinetic  potentials            ****
*       *************************************************
       call v_thomasfermi(n2ft3d,ispin,
     >                    dn,
     >                    dbl_mb(v_tf(1)),
     >                    dbl_mb(e_tf(1)))
       call wgc_v(ispin,dn,dbl_mb(v_wgc(1)))

     
*       *******************************************
*       ***** generate other real-space fields ****
*       *******************************************
        if (field_exist) then

           call dcopy(n2ft3d,0.0d0,0,dbl_mb(v_field(1)),1)


*          **** generate charge potential ****
           if (pspw_charge_found()) then
              call pspw_charge_Generate_V(n2ft3d,
     >                                    dbl_mb(r_grid(1)),
     >                                    dbl_mb(v_field(1)))
           end if
        end if

        call nwpw_timing_start(13)


*       ******************
*       **** get Hchi ****
*       ******************
        if (control_version().eq.3) 
     >     call chi_H(ispin,ne,psi1,psi_r,
     >             dcpl_mb(vl(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dcpl_mb(vc(1)),dbl_mb(xcp(1)),
     >             dbl_mb(v_tf(1)),dbl_mb(v_wgc(1)),
     >             Hpsi,
     >             move,dbl_mb(fion(1)))

        if (control_version().eq.4) 
     >     call chi_Hv4(ispin,ne,psi1,psi_r,
     >             dcpl_mb(vl(1)),dbl_mb(vlr_l(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dbl_mb(vc(1)),dbl_mb(xcp(1)),
     >             dbl_mb(v_tf(1)),dbl_mb(v_wgc(1)),
     >             Hpsi,
     >             move,dbl_mb(fion(1)))

        
*       ************************************
*       **** do a steepest descent step ****
*       ************************************
        do n=1,ispin
          call Pack_c_SMul(1,dte,Hpsi(1,n),psi2(1,n))
          call Pack_cc_Sum2(1,psi1(1,n),psi2(1,n))
        end do
        call nwpw_timing_end(13)

*       *******************************************
*       **** get ewald and semicore forces     ****
*       ****   and do steepest descent on ions ****
*       *******************************************
        if (move) then

*          **** get the ewald force ****
           if (control_version().eq.3) call ewald_f(dbl_mb(fion(1)))

*          **** get the free-space ion force ****
           if (control_version().eq.4) call ion_ion_f(dbl_mb(fion(1)))

*          **** get the semicore force ****
           if (psp_semicore(0)) then
              call semicore_xc_F(ispin,dbl_mb(xcp(1)),dbl_mb(fion(1)))
           end if

*          **** get the qmmm force ****
           if (pspw_qmmm_found()) call pspw_qmmm_fion(dbl_mb(fion(1)))

*          **** remove ion forces using ion_FixIon ****
           call ion_FixIon(dbl_mb(fion(1)))

           call ion_optimize_step(dbl_mb(fion(1)))
        end if


*       *****************************************        
*       **** lagrange multiplier corrections ****
*       *****************************************        
        call chi_lmbda(ispin,npack1,psi1,psi2,dte,lmd,ierr)


      end do

*     *************************************
*     ***** total energy calculation ******
*     *************************************
      call nwpw_timing_start(10)
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

*     *** get orbital energies ****
      call Pack_cc_dot(1,psi1(1,1),Hpsi(1,1),eorbit)
      hml(1) = -eorbit
      if (ispin.eq.2) then
         call Pack_cc_dot(1,psi1(1,2),Hpsi(1,2),sum)
         hml(2) = -sum
         eorbit = eorbit + sum
      else
         eorbit = eorbit + eorbit
      end if
      eorbit = -eorbit


*     **** get ewald energy ****
      eion = 0.0d0
      if (control_version().eq.3) eion = ewald_e()
    
*     **** get free-space ion-ion energy ****
      if (control_version().eq.4) eion = ion_ion_e()

           
*     **** get coulomb energy ****
      if (control_version().eq.3) ehartr = coulomb_e(dcpl_mb(dng(1)))
      if (control_version().eq.4) then
         call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
         ehartr = 0.5d0*ehartr*dv
      end if
      !ehartr = 0.0d0
        

*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,dbl_mb(dnall(1)),dbl_mb(xce(1)),exc)
      call D3dB_rr_dot(1,dn(1,1),dbl_mb(xcp(1)),pxc)
      if (ispin.eq.1) then
         exc= exc + exc 
         pxc= pxc + pxc 
      else
         call D3dB_rr_dot(1,dbl_mb(dnall(1)+n2ft3d),
     >                      dbl_mb(xce(1)),exc2)
         call D3dB_rr_dot(1,dn(1,2),dbl_mb(xcp(1)+n2ft3d),pxc2)
         exc= exc + exc2
         pxc= pxc + pxc2
      end if
      exc = exc*dv
      pxc = pxc*dv
        
  
*     ***** Thomas-Fermi kinetic energy ****
      call D3dB_rr_dot(1,dbl_mb(dnall(1)),dbl_mb(e_tf(1)),etf)
      call D3dB_rr_dot(1,dn(1,1),dbl_mb(v_tf(1)),ptf)
      if (ispin.eq.1) then
         etf= etf + etf 
         ptf= ptf + ptf 
      else
         call D3dB_rr_dot(1,dbl_mb(dnall(1)+n2ft3d),
     >                      dbl_mb(e_tf(1)),etf2)
         call D3dB_rr_dot(1,dn(1,2),dbl_mb(v_tf(1)+n2ft3d),ptf2)
         etf= etf + etf2
         ptf= ptf + ptf2
      end if
      etf = etf*dv
      ptf = ptf*dv


*     ***** von-Weizsacker kinetic energy ****
      nne(1) = 1
      nne(2) = 0
      if (ispin.eq.1) then
         call ke_ave(ispin,nne,psi1,evw,.false.,n1)
         evw = evw*ne(1)
      else
         call ke_ave(ispin,nne,psi1,evw,.false.,n1)
         evw = evw*ne(1)
         call ke_ave(ispin,nne,psi1(1,2),ewgc,.false.,n1)
         evw = evw + ewgc*ne(2)
      end if
      


*     ***** WGC kinetic energy ****
      call D3dB_rr_dot(1,dn(1,1),dbl_mb(v_wgc(1)),pwgc)
      if (ispin.eq.1) then
         pwgc = pwgc + pwgc
      else
         call D3dB_rr_dot(1,dn(1,2),dbl_mb(v_wgc(1)),pwgc2)
         pwgc = pwgc + pwgc2
      end if
      pwgc = pwgc*dv
      ewgc = wgc_e(ispin,dn)
      !ewgc = 0.0d0
      !pwgc = 0.0d0



*     **** average Kohn-Sham v_local energy ****
      call Pack_cc_dot(0,dcpl_mb(dng(1)),dcpl_mb(vl(1)),elocal)


*     *** add in long range part ****
      if (control_version().eq.4) then
      call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vlr_l(1)),sum)
      elocal = elocal + sum*dv
      end if

*     *** add in other real-space fields ****
      if (field_exist) then
      call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(v_field(1)),sum)
      elocal = elocal + sum*dv
      end if

 
*     ***** average Kohn-Sham v_nonlocal energy ****
      enlocal = 0.0d0


*     **** total energy ****
      Eold=E(1)
      !E(1) = elocal + eion + exc + etf + ehartr 
      E(1) = eorbit + eion +exc+etf+ewgc-ehartr-pxc-ptf-pwgc
      E(2) = eorbit
      E(3) = ehartr
      E(4) = exc
      E(5) = eion
      E(6) = evw
      E(7) = elocal
      E(8) = enlocal
      E(9) = 2.0d0*ehartr
      E(10) = pxc
      E(14) = etf
      E(15) = ptf
      E(16) = ewgc
      E(17) = pwgc

      if (pspw_qmmm_found()) then
         e_lj     = pspw_qmmm_LJ_E()
         e_q      = pspw_qmmm_Q_E()
         e_spring = pspw_qmmm_spring_E()
         E(1)  = E(1) + e_lj + e_q + e_spring

         E(11) = e_lj
         E(12) = e_q
         E(13) = e_spring
      end if

*     **** set convergence variables ****
      deltae = (E(1)-Eold)/(dt*dble(it_in))

*     *** deltac ***
      do n=1,ispin
         do i=1,npack1
            Hpsi(i,n) = psi2(i,n) - psi1(i,n)
         end do
      end do

      do n=1,ispin
         call Pack_cc_idot(1,Hpsi(1,n),Hpsi(1,n),dbl_mb(sumi(1)+n-1))
      end do
      if (np_i.gt.1) 
     >     call D3dB_Vector_SumAll(ispin,dbl_mb(sumi(1)))

      deltac = 0.0d0
      do n=1,ispin
         if (dbl_mb(sumi(1)+n-1).gt.deltac) deltac=dbl_mb(sumi(1)+n-1)
      end do
      deltac = deltac/dte *(ne(1)+ne(2))


*     *** deltar ***
      deltar = deltamm
      if (move) then
        do i=1,ion_nion()
           sum = dsqrt( dbl_mb(fion(1)+(i-1)*3  )**2 
     >                + dbl_mb(fion(1)+(i-1)*3+1)**2 
     >                + dbl_mb(fion(1)+(i-1)*3+2)**2)
           if (sum.gt.deltar) deltar = sum
        end do
      end if
       
      call nwpw_timing_end(10)

*     **** dealocate MA local variables ****
      call nwpw_timing_start(12)
      value = MA_pop_stack(sumi(2))
      value = value.and.MA_pop_stack(ftest(2))
      value = value.and.MA_pop_stack(fion(2))
      value = value.and.MA_pop_stack(dnall(2))
      value = value.and.MA_pop_stack(v_wgc(2))
      value = value.and.MA_pop_stack(e_tf(2))
      value = value.and.MA_pop_stack(v_tf(2))
      value = value.and.MA_pop_stack(v_tmp(2))
      value = value.and.MA_pop_stack(xce(2))
      value = value.and.MA_pop_stack(xcp(2))
      value = value.and.MA_pop_stack(dng(2))
      value = value.and.MA_pop_stack(rho(2))
      value = value.and.MA_pop_stack(vl(2))
      value = value.and.MA_pop_stack(v_field(2))

      if ((control_version().eq.4).or.(field_exist))
     >   value = value.and.MA_pop_stack(r_grid(2))

      if (control_version().eq.4) 
     >   value = value.and.MA_pop_stack(vlr_l(2))

      value = value.and.MA_pop_stack(vc(2))
      value = value.and.MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2))

      call nwpw_timing_end(12)


      return
      end
 

      subroutine smd_leapf(natms,tstep,ekin,mass,fff,vvv,ccc)

      implicit none

      integer natms
      double precision tstep
      double precision ekin
      double precision mass(natms)
      double precision fff(natms,3)
      double precision vvv(natms,3)
      double precision ccc(natms,3)
c
      integer i,iatm

      double precision  tmpvx,tmpvy,tmpvz

      ekin=0.0

      do i=1,natms
       tmpvx=vvv(i,1)
       tmpvy=vvv(i,2)
       tmpvz=vvv(i,3)

       vvv(i,1)=vvv(i,1)+fff(i,1)*tstep/mass(i)
       vvv(i,2)=vvv(i,2)+fff(i,2)*tstep/mass(i)
       vvv(i,3)=vvv(i,3)+fff(i,3)*tstep/mass(i)

       tmpvx=0.5*(tmpvx+vvv(i,1))
       tmpvy=0.5*(tmpvy+vvv(i,2))
       tmpvz=0.5*(tmpvz+vvv(i,3))

       ekin=ekin+mass(i)*(tmpvx**2+tmpvy**2+tmpvz**2)

       ccc(i,1)=ccc(i,1)+tstep*vvv(i,1)
       ccc(i,2)=ccc(i,2)+tstep*vvv(i,2)
       ccc(i,3)=ccc(i,3)+tstep*vvv(i,3)
       
      enddo 

      ekin=0.5*ekin

      return

      end

c $Id: smd_leapf.F 22502 2012-05-20 06:11:57Z d3y133 $

c $Id: util_ga_test.F 21315 2011-10-27 22:58:38Z d3p852 $
c vector boxes lack arithmetic precision 
#ifdef CRAY_YMP
# define THRESH 1d-10
# define THRESHF 1e-5
#elif defined(FUJITSU)
# define THRESH 1d-12
# define THRESHF 1e-5
#else
# define THRESH 1d-13
# define THRESHF 1e-5
#endif

#define MISMATCH(x,y) abs(x-y)/max(1d0,abs(x)).gt.THRESH
#define MISMATCHF(x,y) abs(x-y)/max(1.0,abs(x)).gt.THRESHF 


      subroutine util_ga_test
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer heap, stack, fudge, ma_heap, me, nproc
      logical status
      parameter (heap=100*100*4, fudge=100, stack=100*100)
c     
c***  Intitialize a message passing library
c
#ifdef MPI
c      integer ierr
c      call mpi_init(ierr)
#else
c      call pbeginf
#endif
c
c***  Initialize GA
c
c     There are 2 choices: ga_initialize or ga_initialize_ltd.
c     In the first case, there is no explicit limit on memory usage.
c     In the second, user can set limit (per processor) in bytes.
c
c     call ga_initialize()
      nproc = ga_nnodes()
      me = ga_nodeid()
c     we can also use GA_set_memory_limit BEFORE first ga_create call
c
      ma_heap = heap/nproc + fudge 
c     call GA_set_memory_limit(util_mdtob(ma_heap))
c
c     if(ga_nodeid().eq.0)then
c        print *,' GA initialized '
c        call ffflush(6)
c     endif
c
c***  Initialize the MA package
c     MA must be initialized before any global array is allocated
c
c     status = ma_init(MT_DCPL, stack, ma_heap)
c     if (.not. status) call ga_error('ma_init failed',-1) 
c
c     Uncomment the below line to register external memory allocator
c     for dynamic arrays inside GA routines.
c      call register_ext_memory()
c
c     if(me.eq.(nproc-1))then
c       print *, 'using ', nproc,' process(es) ', ga_cluster_nnodes(),
c    $           ' cluster nodes'
c       print *,'process ', me, ' is on node ',ga_cluster_nodeid(),
c    $          ' with ',  ga_cluster_nprocs(-1), ' processes' 
c       call ffflush(6)
c     endif
      if (me.eq.0) then
        write(6,'(A,I3)') ' Number of processes ..............',nproc
        write(6,'(A,I3)') ' Number of cluster nodes ..........',
     1                    ga_cluster_nnodes()
        call ffflush(6)
      endif
      call ga_sync()
c
c***  Check support for double precision arrays
c
      if (me.eq.0) then
         write(6,*)
         write(6,'(A)') ' Checking doubles  '
         write(6,*)
         call ffflush(6)
      endif

      call check_dbl()
c
c***  Check support for double precision complex arrays
c
      if (me.eq.0) then
         write(6,*)
         write(6,'(A)') ' Checking double complexes'
         write(6,*)
         call ffflush(6)
      endif

      call check_complex()
c
c***  Check support for integer arrays
c
      if (me.eq.0) then
         write(6,*)
         write(6,'(A)') ' Checking integers  '
         write(6,*)
         call ffflush(6)
      endif

      call check_int()
c
c
c***  Check support for single precision
c
      if (me.eq.0) then
         write(6,*)
         write(6,'(A)') ' Checking single precisions '
         write(6,*)
         call ffflush(6)
      endif
 
      call check_flt() 
c     
      if (me.eq.0) then
         write(6,*)
         write(6,'(A)')' Checking wrappers to MP collective operations'
         write(6,*)
         call ffflush(6)
      endif

      call check_wrappers
c
c***  Check if memory limits are enforced 
c
c     if(ga_memory_limited())
c    1  call check_mem
c
c     if(me.eq.0) call ga_print_stats()
c     if(me.eq.0) print *,' ' 
c     if(me.eq.0) print *,'All tests succesful ' 
c
c***  Tidy up the GA package
c
c     call ga_terminate()
c
c***  Tidy up after message-passing library
c
#ifdef MPI
c     call mpi_finalize(ierr)
#else
c     call pend()
#endif
c
      end


      subroutine check_dbl()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c     
      integer n,m
      parameter (n = 128)
      parameter (m = 2*n)
      double precision a(n,n), b(n,n), v(m),w(m)
      integer iv(m), jv(m)
      logical status
      integer g_a, g_b
      integer i,j, loop,nloop,maxloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, ij, inc, ii, jj
      parameter (maxloop = 100)
      integer maxproc
      parameter (maxproc = 128)
      double precision crap, sum1, sum2, x
      double precision nwords
      integer iran
      external iran
c     
      nproc = ga_nnodes()
      me    = ga_nodeid()
      nloop = Min(maxloop,n)
c     
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = i-1 + (j-1)*n
            b(i,j) =-1. 
         enddo
      enddo
*      write(6,*) ' correct '
*      call output(a, 1, n, 1, n, n, n, 1)
*      call ffflush(6)
c
c     Create a global array
c
*     print *,ga_nodeid(), ' creating array'
*     call ffflush(6)
c     call setdbg(1)
      status = ga_create(MT_DBL, n, n, 'a', 0, 0, g_a)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_create ........................ OK'
        else
        write(6,'(A)') ' ga_create ........................ Failed'
        stop
        endif
        call ffflush(6)
      endif
c
c     check if handle is valid. be quiet unless error
C
      if(.not.ga_valid_handle(g_a)) call ga_error("invalid handle",g_a)
c
      call ga_distribution(g_a,me,ilo, ihi, jlo, jhi)
      call ga_sync()
c     
c     Zero the array
c
      call ga_zero(g_a)
c
c     Check that it is indeed zero
c
      status = .true.     
      call ga_get(g_a, 1, n, 1, n, b, n)
      call ga_sync()
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. 0.0d0) then
               status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_zero .......................... OK'
        else
        write(6,'(A)') ' ga_zero .......................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Each node fills in disjoint sections of the array
c
      call ga_sync()
c
      status = .true.     
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
*               write(6,4) me, ilo, ihi, jlo, jhi
* 4             format(' node ',i2,' checking put ',4i4)
*               call ffflush(6)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_sync()
c
c     All nodes check all of a
c
      call util_dfill(n*n, 0.0d0, b, 1)
*     call ga_print(g_a,1)
      call ga_get(g_a, 1, n, 1, n, b, n)
*      write(6,*) ' after get'
*      call output(b, 1, n, 1, n, n, n, 1)
c
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. a(i,j)) then
               status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_put ........................... OK'
        else
        write(6,'(A)') ' ga_put ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Now check nloop random gets from each node
c
      call ga_sync()
c
      nwords = 0
c
      status = .true.
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c     
         call util_dfill(n*n, 0.0d0, b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
         sum1 = 0.0d0
         do j = jlo, jhi
            do i = ilo, ihi
               sum1 = sum1 + b(i,j)
               if (b(i,j) .ne. a(i,j)) then
                  status = .false.
               endif
            enddo
         enddo
c
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_get ........................... OK'
        else
        write(6,'(A)') ' ga_get ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Each node accumulates into disjoint sections of the array
c
      call ga_sync()
c     
      crap = util_drand(12345)       ! Same seed for each process
      do j = 1, n
         do i = 1, n
c           b(i,j) = util_drand(0)
            b(i,j) = i+j 
         enddo
      enddo
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
c           x = util_drand(0)
            x = 10.
            ilo = i
            ihi = min(i+inc-1, n)
            if(ihi.eq.n-1)ihi=n
c           ihi = min(i+inc, n)
            jlo = j
            jhi = min(j+inc-1, n)
            if(jhi.eq.n-1)jhi=n
c           jhi = min(j+inc-1, n)
*               call ffflush(6)
            if (mod(ij,nproc) .eq. me) then
c               print *, me, 'checking accumulate ',ilo,ihi,jlo,jhi,x
* 11            format(' node ',i2,' checking accumulate ',4i4)
*               call ffflush(6)
               call ga_acc(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n, x)
            endif
            ij = ij + 1
c     
c           Each process applies all updates to its local copy
c
            do jj = jlo, jhi
               do ii = ilo, ihi
                  a(ii,jj) = a(ii,jj) + x * b(ii,jj)
               enddo
            enddo
         enddo
      enddo
      call ga_sync()
c
c     All nodes check all of a
c
      status = .true.
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if(MISMATCH(b(i,j),a(i,j)))then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_acc (disjoint) ................ OK'
        else
        write(6,'(A)') ' ga_acc (disjoint) ................ Failed'
        endif
        call ffflush(6)
      endif
c
c     overlapping accumulate
      status = .true.
      call ga_sync()
      if (.not. ga_create(MT_DBL, n, n, 'b', 0, 0, g_b)) then
         status = .false.
      endif
c
      call ga_zero(g_b)
      call ga_acc(g_b, n/2, n/2, n/2, n/2, 1d0, 1, 1d0)
      call ga_sync()
      if (me.eq.0) then
         call ga_get(g_b, n/2, n/2, n/2, n/2, b(1,1), 1)
         x = abs(b(1,1) -1d0*nproc)
         if(x.gt. 1d-10)then
            status = .false.
         endif
      endif
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_acc (overlap) ................. OK'
        else
        write(6,'(A)') ' ga_acc (overlap) ................. Failed'
        endif
        call ffflush(6)
      endif
c
c     Check the ga_add function
c
      crap = util_drand(12345)       ! Everyone has same seed
      do j = 1, n
         do i = 1, n
            b(i,j) = util_drand(0)
            a(i,j) = 0.1d0*a(i,j) + 0.9d0*b(i,j)
         enddo
      enddo
      
      status = .true.
      if (me.eq.0) call ga_put(g_b, 1, n, 1, n, b, n)
      call ga_add(0.1d0, g_a, 0.9d0, g_b, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if(MISMATCH(b(i,j), a(i,j)))then
               status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_add ........................... OK'
        else
        write(6,'(A)') ' ga_add ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Check the ddot function
c
      crap = util_drand(12345)       ! Everyone has same seed
      sum1 = 0.0d0
      do j = 1, n
         do i = 1, n
            b(i,j) = util_drand(0)
            sum1 = sum1 + a(i,j)*b(i,j)
         enddo
      enddo
      if (me.eq.0) then 
         call ga_put(g_b, 1, n, 1, n, b, n)
         call ga_put(g_a, 1, n, 1, n, a, n)
      endif
      call ga_sync()
      sum2 = ga_ddot(g_a,g_b)
      status = .true.
      if(MISMATCH(sum1, sum2))then
         status = .false.
      endif
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_ddot .......................... OK'
        else
        write(6,'(A)') ' ga_ddot .......................... Failed'
        endif
        call ffflush(6)
      endif
c
c     Check the ga_scale function
c
      call ga_scale(g_a, 0.123d0)
      call ga_get(g_a, 1, n, 1, n, b, n)
      status = .true.
      do j = 1, n
         do i = 1, n
            a(i,j) = a(i,j)*0.123d0
            if (MISMATCH(b(i,j), a(i,j)))then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scale ......................... OK'
        else
        write(6,'(A)') ' ga_scale ......................... Failed'
        endif
        call ffflush(6)
      endif
c
c     Check the ga_copy function
c
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      call ga_copy(g_a, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      status = .true.
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
               status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_copy .......................... OK'
        else
        write(6,'(A)') ' ga_copy .......................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_sync()
c
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      status = .true.
      do j = 1, 10 
       call ga_sync()
       itmp = iran(nproc)-1
       if(me.eq.itmp) then
         do loop = 1,m 
           ilo = iran(n) 
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
         enddo 
         call ga_gather(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,v(loop),1)
           if(v(loop)  .ne. a(ilo,jlo))then
             status = .false.
           endif
         enddo
       endif
      enddo
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_gather ........................ OK'
        else
        write(6,'(A)') ' ga_gather ........................ Failed'
        endif
        call ffflush(6)
      endif
c
      status = .true.
      do j = 1,10 
       call ga_sync()
       if(me.eq.iran(ga_nnodes())-1) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
c          v(loop) = DSIN(a(ilo,jlo)+b(ilo,jlo)) 
           v(loop) = 1d0 *(ilo+jlo)
         enddo 
         call ga_scatter(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop) 
           call ga_get(g_a,ilo,ilo,jlo,jlo,w(loop),1)
c          if(v(loop) .ne. w(loop))then 
           if(w(loop) .ne. 1d0 *(ilo+jlo) )then 
             status = .false.
           endif
         enddo 
       endif
       call ga_sync()
      enddo
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scatter ....................... OK'
        else
        write(6,'(A)') ' ga_scatter ....................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_sync()
c
c     scatter-acc available in GA ver. 3.0
#ifdef GA3
c
      crap = util_drand(1234)
      call ga_zero(g_a)
c
      do j = 1, n
         do i = 1, n
            b(i,j) =0.
         enddo
      enddo
c
      status = .true.
      x = .1d0
      ii =n
      do jj = 1,1 
	  call ga_sync()
        do loop = 1, ii 

c          generate unique i,j pairs
10         continue
              i = iran(n)
	      j=iran(n)
           if (found(i,j, iv, jv, loop-1) ) goto 10

           iv(loop) = i
           jv(loop) = j
           v(loop) = 1d0 *(i+j)
           b(i,j) = b(i,j) + nproc*x*v(loop) ! update local ref. array
        enddo
	call ga_scatter_acc(g_a,v,iv,jv, ii,x)
c
        call ga_sync()
c     
c       check the result
c
        call ga_get(g_a, 1, n, 1,n, a, n)

        do loop = 1,ii
          i = iv(loop)
          j = jv(loop)
          if(MISMATCH(a(i,j),b(i,j)))then
             status = .false.
*            if(me.eq.0)then
*              do ii=1,loop
*                   print *,'element',ii, iv(ii),jv(ii)
*              enddo
*            endif
             status = .false.
          endif
        enddo
        call ga_sync()
      enddo

      call ga_sync()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scatter_acc ................... OK'
        else
        write(6,'(A)') ' ga_scatter_acc ................... Failed'
        endif
        call ffflush(6)
      endif
#endif
c
c     Delete the global arrays
c
      status = ga_destroy(g_b)
      status = status .and. ga_destroy(g_a)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_destroy ....................... OK'
        else
        write(6,'(A)') ' ga_destroy ....................... Failed'
        endif
        call ffflush(6)
      endif
c     
      end

c-----------------------------------------------------------------
      subroutine check_complex()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c
      integer n,m
      parameter (n = 60)
      parameter (m = 2*n)
      double complex a(n,n), b(n,n), v(m),w(m)
      integer iv(m), jv(m)
      logical status
      integer g_a, g_b
      integer i,j, loop,nloop,maxloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, ij, inc, ii, jj
      parameter (maxloop = 100)
      integer maxproc
      parameter (maxproc = 128)
      double precision crap
      double precision nwords
      double complex   x, sum1, sum2, factor
      integer iran
      external iran
c
      nproc = ga_nnodes()
      me    = ga_nodeid()
      nloop = Min(maxloop,n)
c
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = cmplx(dble(i-1), dble((j-1)*n))
            b(i,j) = cmplx(-1d0,1d0)
         enddo
      enddo
c
c     Create a global array
c
c     print *,ga_nodeid(), ' creating array'
      call ffflush(6)
c     call setdbg(1)
      status = ga_create(MT_DCPL, n, n, 'a', 0, 0, g_a)
      status = status .and. ga_create(MT_DCPL, n, n, 'b', 0, 0, g_b)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_create ........................ OK'
        else
        write(6,'(A)') ' ga_create ........................ Failed'
        endif
        call ffflush(6)
      endif
      call ga_distribution(g_a,me,ilo, ihi, jlo, jhi)
      call ga_sync()
c
c     Zero the array
c
      call ga_zero(g_a)
c
c     Check that it is indeed zero
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      call ga_sync()
      status = .true.
      do i = 1, n
         do j = 1, n
            if(b(i,j).ne.(0d0,0d0)) then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_zero .......................... OK'
        else
        write(6,'(A)') ' ga_zero .......................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Each node fills in disjoint sections of the array
c
      call ga_sync()
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_sync()
c
c     All nodes check all of a
c
      call util_qfill(n*n, (0d0,0d0), b, 1)
      call ga_get(g_a, 1, n, 1, n, b, n)
c
      status = .true.
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. a(i,j)) then
               status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_put ........................... OK'
        else
        write(6,'(A)') ' ga_put ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Now check nloop random gets from each node
c
      call ga_sync()
c
      nwords = 0
c
      status = .true.
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c
         call util_qfill(n*n, (0.0d0,0d0), b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
         do j = jlo, jhi
            do i = ilo, ihi
               if (b(i,j) .ne. a(i,j)) then
                 status = .false.
               endif
            enddo
         enddo
c
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_get ........................... OK'
        else
        write(6,'(A)') ' ga_get ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Each node accumulates into disjoint sections of the array
c
      call ga_sync()
c
      status = .true.
      crap = util_drand(12345)       ! Same seed for each process
      do j = 1, n
         do i = 1, n
            b(i,j) = cmplx(util_drand(0),util_drand(1))
         enddo
      enddo
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
c           x = cmplx(util_drand(0),0.333d0)
c           x = cmplx(0.333d0,0)
*           x = cmplx(0d0,0d0)
            x = 0 
            ilo = i
            ihi = min(i+inc-1, n)
            if(ihi.eq.n-1)ihi=n
            jlo = j
            jhi = min(j+inc-1, n)
            if(jhi.eq.n-1)jhi=n
            if (mod(ij,nproc) .eq. me) then
               call ga_acc(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n, x)
            endif
            ij = ij + 1
c
c           Each process applies all updates to its local copy
c
            do jj = jlo, jhi
               do ii = ilo, ihi
                  a(ii,jj) = a(ii,jj) + x * b(ii,jj)
               enddo
            enddo
         enddo
      enddo
      call ga_sync()
c
c     All nodes check all of a
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (MISMATCH(b(i,j), a(i,j)))then
               status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_acc (disjoint) ................ OK'
        else
        write(6,'(A)') ' ga_acc (disjoint) ................ Failed'
        endif
        call ffflush(6)
      endif
c
c     overlapping accumulate
c
      call ga_zero(g_b)
      call ga_acc(g_b, n/2, n/2, n/2, n/2, (1d0,-1d0), 1, (1d0,0d0))
      call ga_sync()
      status = .true.
      if (me.eq.0) then
         call ga_get(g_b, n/2, n/2, n/2, n/2, x, 1)
c        error = abs(x -(1d0,-1d0)*nproc)
         if (MISMATCH(x, ((1d0,-1d0)*nproc)))then
c        if(error.gt. (1d-8))then
           status = .false.
         endif
      endif
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_acc (overlap) ................. OK'
        else
        write(6,'(A)') ' ga_acc (overlap) ................. Failed'
        endif
        call ffflush(6)
      endif
c
c     Check the ga_copy function
c
      status = .true.
      call ga_sync()
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      call ga_copy(g_a, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_copy .......................... OK'
        else
        write(6,'(A)') ' ga_copy .......................... Failed'
        endif
        call ffflush(6)
      endif
c
c
c     Check the ga_scale function
c
      factor = (1d0,-1d0)
      call ga_scale(g_a, factor)
      call ga_get(g_a, 1, n, 1, n, b, n)
      status = .true.
      do j = 1, n
         do i = 1, n
            a(i,j) = a(i,j)*factor
            if (MISMATCH(b(i,j), a(i,j)))then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scale ......................... OK'
        else
        write(6,'(A)') ' ga_scale ......................... Failed'
        endif
        call ffflush(6)
      endif
c
c     Check scatter&gather
c
      call ga_sync()
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
c
      status = .true.
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      do j = 1, 10
       call ga_sync()
       itmp = iran(nproc)-1
       if(me.eq.itmp) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
         enddo
         call ga_gather(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,v(loop),1)
           if(v(loop)  .ne. a(ilo,jlo))then
             status = .false.
           endif
         enddo
       endif
      enddo
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_gather ........................ OK'
        else
        write(6,'(A)') ' ga_gather ........................ Failed'
        endif
        call ffflush(6)
      endif
c
      status = .true.
      do j = 1,10
       call ga_sync()
       if(me.eq.iran(ga_nnodes())-1) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
           v(loop) = (1d0,-1d0) *(ilo+jlo)
         enddo
         call ga_scatter(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,w(loop),1)
           if(w(loop)  .ne. (1d0,-1d0) *(ilo+jlo) )then
             status = .false.
           endif
         enddo
       endif
       call ga_sync()
      enddo
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scatter ....................... OK'
        else
        write(6,'(A)') ' ga_scatter ....................... Failed'
        endif
        call ffflush(6)
      endif
c
c     Check ga_add
c
      call ga_get(g_a, 1, n, 1, n, a, n)
      crap = util_drand(12345)       ! Everyone has same seed
      do j = 1, n
         do i = 1, n
            b(i,j) = cmplx(util_drand(0), util_drand(1))
            a(i,j) = (0.1d0,-.1d0)*a(i,j) + (.9d0,-.9d0)*b(i,j)
         enddo
      enddo
      status = .true.
      if (me.eq.0) call ga_put(g_b, 1, n, 1, n, b, n)
      call ga_add((0.1d0,-.1d0), g_a, (0.9d0,-.9d0), g_b, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (MISMATCH(b(i,j), a(i,j)))then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_add ........................... OK'
        else
        write(6,'(A)') ' ga_add ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Check the zdot function
c
      crap = util_drand(12345)       ! Everyone has same seed
      sum1 = (0.0d0,0.d0)
      do j = 1, n
         do i = 1, n
            b(i,j) = cmplx(util_drand(0), util_drand(1))
            sum1 = sum1 + a(i,j)*b(i,j)
         enddo
      enddo
      if (me.eq.0) then
         call ga_put(g_b, 1, n, 1, n, b, n)
         call ga_put(g_a, 1, n, 1, n, a, n)
      endif
      call ga_sync()
      sum2 =  ga_zdot(g_a,g_b)
      status = .true.
      if (MISMATCH(sum1, sum2))then
        status = .false.
      endif
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_zdot .......................... OK'
        else
        write(6,'(A)') ' ga_zdot .......................... Failed'
        endif
        call ffflush(6)
      endif
c
c     Delete the global arrays
c
      status = ga_destroy(g_b)
      status = status .and. ga_destroy(g_a)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_destroy ....................... OK'
        else
        write(6,'(A)') ' ga_destroy ....................... Failed'
        endif
        call ffflush(6)
      endif
c
      end
c-----------------------------------------------------------------




      subroutine check_int()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c     
      integer n
      parameter (n = 128)
      integer a(n,n), b(n,n)
      logical status
      integer g_a
      integer i, j, loop, nloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, ij, inc, dimi,dimj,iproc, ii, jj
      double precision nwords
      parameter (nloop = 100)
      integer maxproc
      parameter (maxproc = 128)
      integer map(5,maxproc), found, np,k
      double precision crap, sum1
      integer buf
      integer iran
      external iran
c     
      nproc = ga_nnodes()
      me    = ga_nodeid()
c     
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = i-1 + (j-1)*1000
         enddo
      enddo
c     
c     Create a global array
c
      status = ga_create(MT_INT, n, n, 'a', 0, 0, g_a)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_create ........................ OK'
        else
        write(6,'(A)') ' ga_create ........................ Failed'
        endif
        call ffflush(6)
      endif
c     
c     Zero the array
c
      call ga_zero(g_a)
c
c     Check that it is indeed zero
c
      status = .true.
      call ga_get(g_a, 1, n, 1, n, b, n)
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. 0) then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_zero .......................... OK'
        else
        write(6,'(A)') ' ga_zero .......................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Each node fills in disjoint sections of the array
c
      call ga_sync()
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
c              write(6,4) me, ilo, ihi, jlo, jhi
c4             format(' node ',i2,' checking put ',4i4)
c              call ffflush(6)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_sync()
c
c     All nodes check all of a
c
      status = .true.
      if(me.eq.0)then
      call ga_get(g_a, 1, n, 1, n, b, n)
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. a(i,j)) then
              status = .false.
            endif
         enddo
      enddo
      endif
      call ga_sync()
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_put ........................... OK'
        else
        write(6,'(A)') ' ga_put ........................... Failed'
        endif
        call ffflush(6)
      endif
c
c     Now check nloop random gets from each node
c
      call ga_sync()
c
      nwords = 0
c
      status = .true.
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c     
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c
         call util_ifill(n*n, 0, b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
c
         sum1 = 0.0d0
         do j = jlo, jhi
            do i = ilo, ihi
               sum1 = sum1 + b(i,j)
               if (b(i,j) .ne. a(i,j)) then
                 status = .false.
               endif
            enddo
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_get ........................... OK'
        else
        write(6,'(A)') ' ga_get ........................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_sync()
c
      status = .true.
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      inc =5 
c     every processor will be operating on somebody elses data
c
      iproc = ga_nnodes()-me-1
c
      call ga_distribution(g_a,iproc,ilo,ihi,jlo,jhi)
c
      dimi = ihi-ilo
      dimj = jhi-jlo
c     write(6,*) me,'..',ilo,ihi,jlo,jhi,'.',dimi,dimj
c     call ffflush(6)
      call ga_sync()
      if(ilo .gt.0 .and. jhi .gt. 0)then
       do loop = 1,nloop 
         ii= IABS(iran(dimi))
         jj= IABS(iran(dimj))
         i=ilo + Mod(ii,dimi)
         j=jlo + Mod(jj,dimj)
c
c        write(6,*) me,'..',ilo,ihi,jlo,jhi,'.',dimi,dimj,'..',i,j
c        call ffflush(6)
         buf = ga_read_inc(g_a,i,j,inc)
         if(a(i,j).ne. buf)then   
           status = .false.
         endif
         call ga_get(g_a, i,i,j,j, buf,1) 
         a(i,j) = a(i,j)+inc 
         if(a(i,j).ne.  buf)then   
           status = .false.
         endif
       enddo
      endif
      call ga_sync()
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_read_inc ...................... OK'
        else
        write(6,'(A)') ' ga_read_inc ...................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_zero(g_a)
c
c***  use ga_read_inc and elements g_a(1:2,1) to implement a lock
c***  compute g_a(:,n) = sum (1(:)) for P processors
c     
      status = ga_create_mutexes(1)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_create_mutexes ................ OK'
        else
        write(6,'(A)') ' ga_create_mutexes ................ Failed'
        endif
        call ffflush(6)
      endif

      if ((n.lt.2).and.(me.eq.0)) then
        write(6,'(A)') ' ga_fence ........................ N/A'
        write(6,'(A)') ' ga_lock ......................... N/A'
        call ffflush(6)
      endif

      call ga_lock(0)
c     call my_lock(g_a)

c          get original values  g_a(:,n)
           call ga_get(g_a, 1,n, n,n, b,n)
c          add my contribution
           do i =1,n
              b(i,1)= b(i,1)+1
           enddo
c
c          need to use fence to assure that coms complete before leaving
c          Critical Section
c
           call ga_init_fence()
                call ga_put(g_a, 1,n, n,n, b,n)
           call ga_fence()
      call ga_unlock(0)
c     call my_unlock(g_a)
c
333   status = ga_destroy_mutexes()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_destroy_mutexes ............... OK'
        else
        write(6,'(A)') ' ga_destroy_mutexes ............... Failed'
        endif
        call ffflush(6)
      endif
c
      status = .true.
      call ga_sync()
      if (me.eq.0) then
         call ga_get(g_a, 1,n, n,n, b,n)
         do i =1,n
              if(b(i,1).ne. nproc)then
                status = .false.
              endif
         enddo
      endif 
c
      status = ga_locate_region(g_a, 1, n, 1,n, map,np)
      found = 0
      do j=1,n
         do i=1,n
            b(i,j)=-1
         enddo
      enddo
      if(me.eq.0)call ga_put(g_a,1,n,1,n,b,n)
      call ga_sync()
      do k = 1, np
         if(map(5,k).eq.me)then
                if(found.eq.1) then
                    write(6,*)'double entry in map for proc ',me
                    call ffflush(6)
                endif
                do j= map(3,k), map(4,k)
                        do i= map(1,k), map(2,k)
                        b(i,j)=1*me
                        enddo
                enddo
                call ga_put(g_a, map(1,k),map(2,k),map(3,k),map(4,k),
     &                 b(map(1,k),map(3,k)),n)
                found = 1
         endif
      enddo
      call ga_sync()
c
      do k = 1, np
         if(map(5,k).eq.me)then
                call ga_get(g_a, map(1,k),map(2,k),map(3,k),map(4,k),
     &                 a(map(1,k),map(3,k)),n)
                do j= map(3,k), map(4,k)
                      do i= map(1,k), map(2,k)
                        if(b(i,j).ne.a(i,j)) then
                           write(6,*)
     &                     'proc ',me, 'overlap with ',a(i,j)
                           call ffflush(6)
                        endif
                      enddo
                enddo
         endif
      enddo
      call ga_sync()
c
      if(me.eq.0)then
        call ga_get(g_a,1,n,1,n,a,n)
        do j=1,n
         do i=1,n
            if(a(i,j).eq.-1)then
              status = .false.
            endif
         enddo
        enddo
      endif
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_locate_region ................. OK'
        else
        write(6,'(A)') ' ga_locate_region ................. Failed'
        endif
        call ffflush(6)
      endif
c     
c     Delete the global array
c
      status = ga_destroy(g_a)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_destroy ....................... OK'
        else
        write(6,'(A)') ' ga_destroy ....................... Failed'
        endif
        call ffflush(6)
      endif
c     
      end

c---------------------------------------------------------------------

      subroutine check_flt()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer n, m
      parameter (n =10) 
      parameter (m=2*n)
      real a(n,n), b(n,n), v(m), w(m)
      integer iv(m), jv(m)
      logical status
      integer g_a, g_b
      integer i, j, loop, nloop, maxloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, ij, inc, ii, jj
      double precision nwords
      parameter (maxloop = 100)
      integer maxproc
      parameter (maxproc = 128)
      double precision crap
      real x, sum1, sum2
      integer iran
      external iran

      nproc = ga_nnodes()
      me    = ga_nodeid()
      nloop = Min(maxloop,n)
c     
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = i-1 + (j-1)*n
            b(i,j) = -1.
         enddo
      enddo
c     
c     Create a global array
c
      status = ga_create(MT_REAL, n, n, 'a', 0, 0, g_a)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_create ........................ OK'
        else
        write(6,'(A)') ' ga_create ........................ Failed'
        endif
        call ffflush(6)
      endif
c
c     check if handle is valid. be quiet unless error
c
      status = .true.
      if(.not.ga_valid_handle(g_a)) status = .false.
c
      call ga_distribution(g_a,me,ilo, ihi, jlo, jhi)
      call ga_sync()      
c     
c     Zero the array
c
      call ga_zero(g_a)
c
c     Check that it is indeed zero
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      call ga_sync()
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. 0.0) then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_zero .......................... OK'
        else
        write(6,'(A)') ' ga_zero .......................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Each node fills in disjoint sections of the array
c
      status = .true.
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
c               write(6,4) me, ilo, ihi, jlo, jhi
c 4             format(' node ',i2,' checking put ',4i4)
c               call ffflush(6)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_sync()
c
c     All nodes check all of a
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. a(i,j)) then
              status = .false.
            endif
         enddo
      enddo
      call ga_sync()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_put ........................... OK'
        else
        write(6,'(A)') ' ga_put ........................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_sync()
c
      nwords = 0
c
      status = .true.
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c     
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c
         call util_rfill(n*n, 0.0, b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
c
         sum1 = 0.0d0
         do j = jlo, jhi
            do i = ilo, ihi
               sum1 = sum1 + b(i,j)
               if (b(i,j) .ne. a(i,j)) then
                  status = .false.
               endif
            enddo
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_get ........................... OK'
        else
        write(6,'(A)') ' ga_get ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
c     Each node accumulates into disjoint sections of the array
c
      call ga_sync()
c
      crap = util_drand(12345)       ! Same seed for each process
      do j = 1, n
         do i = 1, n
c           b(i,j) = real(util_drand(0))
            b(i,j) = i+j
         enddo
      enddo
c
      status = .true.
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
c           x = real(util_drand(0))
            x = 10.
            ilo = i
            ihi = min(i+inc-1, n)
            if(ihi.eq.n-1)ihi=n
c           ihi = min(i+inc, n)
            jlo = j
            jhi = min(j+inc-1, n)
            if(jhi.eq.n-1)jhi=n
c           jhi = min(j+inc-1, n)
*               call ffflush(6)
            if (mod(ij,nproc) .eq. me) then
c               print *, me, 'checking accumulate ',ilo,ihi,jlo,jhi,x
* 11            format(' node ',i2,' checking accumulate ',4i4)
*               call ffflush(6)
               call ga_acc(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n, x)
            endif
            ij = ij + 1
c
c           Each process applies all updates to its local copy
c
            do jj = jlo, jhi
               do ii = ilo, ihi
                  a(ii,jj) = a(ii,jj) + x * b(ii,jj)
               enddo
            enddo
         enddo
      enddo
      call ga_sync()                       
c
c     All nodes check all of a
      call ga_get(g_a, 1, n, 1, n, b, n)
c
      do j = 1, n
         do i = 1, n
            if(MISMATCHF(b(i,j),a(i,j)))then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_acc (disjoint) ................ OK'
        else
        write(6,'(A)') ' ga_acc (disjoint) ................ Failed'
        endif
        call ffflush(6)
      endif
c
c     overlapping accumulate
      call ga_sync()
      status = .true.
      if (.not. ga_create(MT_REAL, n, n, 'b', 0, 0, g_b)) then
         status = .false.
      endif
c
      call ga_zero(g_b)
      call ga_acc(g_b, n/2, n/2, n/2, n/2, 1.0, 1, 1.0)
      call ga_sync()
      if (me.eq.0) then
         call ga_get(g_b, n/2, n/2, n/2, n/2, b(1,1), 1)
         x = abs(b(1,1) -1*nproc)
         if(x.gt. 1e-10)then
           status = .false.
         endif
      endif
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_acc (overlap) ................. OK'
        else
        write(6,'(A)') ' ga_acc (overlap) ................. Failed'
        endif
        call ffflush(6)
      endif
c
c     Check the ga_add function
c
      crap = util_drand(12345)       ! Everyone has same seed
      status = .true.
      do j = 1, n
         do i = 1, n
            b(i,j) = real(util_drand(0)*real(i)) + 1
            a(i,j) = 0.1*a(i,j) + 0.9*b(i,j)
         enddo
      enddo
      if (me.eq.0) call ga_put(g_b, 1, n, 1, n, b, n)
      call ga_add(0.1, g_a, 0.9, g_b, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if(MISMATCHF(b(i,j), a(i,j)))then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_add ........................... OK'
        else
        write(6,'(A)') ' ga_add ........................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
      status = .true.
      crap = util_drand(12345)       ! Everyone has same seed
      sum1 = 0.0
      do j = 1, n
         do i = 1, n
            b(i,j) = util_drand(0)
            sum1 = sum1 + a(i,j)*b(i,j)
         enddo
      enddo
      if (me.eq.0) then
         call ga_put(g_b, 1, n, 1, n, b, n)
         call ga_put(g_a, 1, n, 1, n, a, n)
      endif
      call ga_sync()
      sum2 = ga_sdot(g_a,g_b)
      if(MISMATCHF(sum1, sum2))then
        status = .false.
      endif
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_sdot .......................... OK'
        else
        write(6,'(A)') ' ga_sdot .......................... Failed'
        endif
        call ffflush(6)
      endif
c
      status = .true.
      call ga_scale(g_a, 0.123)
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            a(i,j) = a(i,j)*0.123
            if (MISMATCHF(b(i,j), a(i,j)))then
              status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scale ......................... OK'
        else
        write(6,'(A)') ' ga_scale ......................... Failed'
        endif
        call ffflush(6)
      endif
c                                
      status = .true.
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      call ga_copy(g_a, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
               status = .false.
            endif
         enddo
      enddo
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_copy .......................... OK'
        else
        write(6,'(A)') ' ga_copy .......................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_sync()
      status = .true.
      crap = util_drand(ga_nodeid()*51 + 1) ! Different seed for each process
      do j = 1, 10
       call ga_sync()
       itmp = iran(nproc)-1
       if(me.eq.itmp) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
         enddo
         call ga_gather(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,v(loop),1)
           if(v(loop)  .ne. a(ilo,jlo))then
             status = .false.
           endif                                     
         enddo
       endif
      enddo
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_gather ........................ OK'
        else
        write(6,'(A)') ' ga_gather ........................ Failed'
        endif
        call ffflush(6)
      endif
c
      status = .true.
      do j = 1,10
       call ga_sync()
       if(me.eq.iran(ga_nnodes())-1) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
c          v(loop) = DSIN(a(ilo,jlo)+b(ilo,jlo))
           v(loop) = 1.0 *(ilo+jlo)
         enddo
         call ga_scatter(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,w(loop),1)
c          if(v(loop)  .ne. w(loop))then
           if(w(loop)  .ne. 1.0 *(ilo+jlo) )then
             status = .false.
           endif
         enddo
       endif
       call ga_sync()
      enddo
c
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scatter ....................... OK'
        else
        write(6,'(A)') ' ga_scatter ....................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_sync()
c
c     scatter-acc available in GA ver. 3.0
#ifdef GA3                                         
      status = .true.
      crap = util_drand(1234)
      call ga_zero(g_a)
c
      do j = 1, n
         do i = 1, n
            b(i,j) =0.
         enddo
      enddo
c
      x = .1d0
      ii =n
      do jj = 1,1
          call ga_sync()
        do loop = 1, ii
 
c          generate unique i,j pairs
10         continue
              i = iran(n)
              j=iran(n)
           if (found(i,j, iv, jv, loop-1) ) goto 10

           iv(loop) = i
           jv(loop) = j
           v(loop) = 1.0 *(i+j)
           b(i,j) = b(i,j) + nproc*x*v(loop) ! update local ref. array
        enddo
 
        call ga_scatter_acc(g_a,v,iv,jv, ii,x)
        call ga_sync()
c
c       check the result
c
        call ga_get(g_a, 1, n, 1,n, a, n)
        do loop = 1,ii
          i = iv(loop)
          j = jv(loop)
          if(MISMATCH(a(i,j),b(i,j)))then
            status = .false.
          endif
        enddo                                 
        call ga_sync()
      enddo
      call ga_sync()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_scatter_acc ................... OK'
        else
        write(6,'(A)') ' ga_scatter_acc ................... Failed'
        endif
        call ffflush(6)
      endif
#endif                      
c
c     Delete the global array
c
      status = ga_destroy(g_a)
      status = status .and. ga_destroy(g_b)
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_destroy ....................... OK'
        else
        write(6,'(A)') ' ga_destroy ....................... Failed'
        endif
        call ffflush(6)
      endif
c     
      end
c_____________________________________________________________

      subroutine check_wrappers
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      double precision sum
      integer isum, ibuf(2)
      integer me, nproc
      logical status
      real fsum
c
      nproc = ga_nnodes()
      me = ga_nodeid()
c
      status = .true.
      call ga_sync()
      ibuf(1) = 1
      ibuf(2) =  me
      call ga_igop(10000, ibuf, 2, '+')
      if(ibuf(1).ne.nproc)then
        status = .false.
      endif
      if(ibuf(2).ne.((nproc-1)*nproc/2))then
        status = .false.
      endif
      call ga_sync()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_igop .......................... OK'
        else
        write(6,'(A)') ' ga_igop .......................... Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
c
      status = .true.
      sum = 1d0 * me
      call ga_dgop(10000, sum, 1, '+')
      if(Int(sum).ne.((nproc-1)*nproc/2))then
        status = .false. 
      endif
      call ga_sync()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_dgop .......................... OK'
        else
        write(6,'(A)') ' ga_dgop .......................... Failed'
        endif
        call ffflush(6)
      endif
c
      call ga_sync()
      status = .true.
      fsum = 1.0 * me
      call ga_sgop(10000, fsum, 1, '+')
      if(Int(sum).ne.((nproc-1)*nproc/2))then
        status = .false.
      endif
      call ga_sync()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_sgop .......................... OK'
        else
        write(6,'(A)') ' ga_sgop .......................... Failed'
        endif
        call ffflush(6)
      endif
c                                   
      call ga_sync()
      status = .true.
      if(me.eq.nproc-1)then
        ibuf(1) = me
        ibuf(2) = nproc
      endif
      call ga_brdcst(1000,ibuf,util_mitob(2),nproc-1)
      if(ibuf(1).ne.nproc-1) status = .false.
      if(ibuf(2).ne.nproc) status = .false.
      call ga_sync()
      if (me.eq.0) then
        if (status) then
        write(6,'(A)') ' ga_brdcst ........................ OK'
        else
        write(6,'(A)') ' ga_brdcst ........................ Failed'
        endif
        call ffflush(6)
      endif
      call ga_sync()
      end


      subroutine check_mem
      implicit none
      integer mem_size
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c
      integer n,nmax,left,need, me,procs,g_a, g_b 
      integer stack, heap, global
      logical status, overify, ohardfail
c
      call input_mem_size(stack, heap, global, overify, ohardfail)
      mem_size = ma_sizeof(mt_dbl,global,mt_byte)
      write(*,*) 'mem_size = ',mem_size
      me = ga_nodeid()
      procs = ga_nnodes()
      nmax = int(dsqrt(dble(mem_size/util_mitob(1))))
      left =  mem_size/procs - ga_inquire_memory()
      n = nmax/2
      need = util_mdtob(n*n)/procs
c
      if(me.eq.0)then
        write(6,*)' '
        if(ga_uses_ma())then
           write(6,*)' CHECKING GA MEMORY RESTRICTIONS (MA used)'
        else
           write(6,*)' CHECKING GA MEMORY RESTRICTIONS (MA not used)'
        endif
        write(6,*)' '
        write(6,*)' '
        call print_mem_info(n,left, need, mem_size/procs)
      endif
c
      status = ga_create(MT_DBL, n, n, 'a', 0, 0, g_a)
c
      if(me.eq.0) then
        if(status) then
              write(6,*) '  success'
        else
              write(6,*) '  failure'
        endif
        call ffflush(6)
      endif
c
      n = nmax
      left =  mem_size/procs - ga_inquire_memory()
      need = util_mdtob(n*n)/procs
      if(me.eq.0)then
        call print_mem_info(n,left, need, mem_size/procs)
      endif
c
      status = ga_create(MT_DBL, n, n, 'b', 0, 0, g_b)
c
      if(me.eq.0) then
        if(status) then
              write(6,*) '  success'
        else
              write(6,*) '  failure'
        endif
        write(6,*)' '
        write(6,*)' '
        call ffflush(6)
      endif
      status = ga_destroy(g_a)
      end

     

      subroutine print_mem_info(n,left, need, total)
      implicit none
      integer n,left, need, total
c
      write(6,*)' '
      if(left - need .ge. 0) then
        write(6,1)n,n 
1       format('> Creating array ',i4,' by ',i4,' -- should succeed')
      else
        write(6,2)n,n 
2       format('> Creating array ',i4,' by ',i4,' -- SHOULD FAIL')
      endif
      write(6,3) need, left, total
3     format('  (need ',i7,' and  ',i7,' out of ',i7,' bytes are left)')
      write(6,*)' '
      call ffflush(6)
c
      end


      
      subroutine my_lock(g_b)
      implicit none
#include "global.fh"
      integer g_b, val, flag, i
      logical first_time
      double precision  dummy 
      common /lock/ val 
      common /dum/ dummy
      data first_time /.true./
c
c     this awkward initialization is to avoid a weird problem 
C     with block data on SUN
      if(first_time)then
        first_time = .false.
        dummy = .0
      endif
c
      val = ga_read_inc(g_b,1,1, 1)
10    call ga_get(g_b, 2,2,1,1, flag, 1)
           if(flag.eq.val) return 
c
c          to reduce memory stress,  wait a while before retrying
           do i = 1, 100
              dummy = dummy + .1 
           enddo 
      goto 10
      end


      subroutine my_unlock(g_b)
      implicit none
#include "global.fh"
      integer g_b, val
      common /lock/ val
c
      call ga_put(g_b, 2,2,1,1, val+1, 1) 
      end


      logical function found(i,j, iv, jv, n)
      integer n
      integer i,j, iv(n), jv(n)
      integer loop

      found = .false.
      do loop = 1, n
               if(i .eq. iv(loop) .and. j .eq.jv(loop))then
                 found = .true.
                 goto 99
               endif
            enddo
99    continue
      return
      end 
      
            
      subroutine proc_remap()
      implicit none
#include "global.fh"
      integer proc(100),nproc,i
      nproc = ga_nnodes()
      if(nproc.gt.100)
     $   call ga_error("remap requires<=100 processes",nproc)
      do i = 1, nproc
         proc(i) = nproc-i
      enddo
c     call ga_register_proclist(proc,nproc)
      end

      
      subroutine util_rfill(n,val,a,ia)
      implicit none
      real  a(*), val
      integer n, ia, i
c
c     initialise real array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

      
      subroutine util_dfill(n,val,a,ia)
      implicit none
      double precision  a(*), val
      integer n, ia, i
c
c     initialise double precision array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

      subroutine util_ifill(n,val,a,ia)
      implicit none
      integer n, ia, i, a(*),val
c
c     initialise integer array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

      subroutine util_qfill(n,val,a,ia)
      implicit none
      double  complex  a(*), val
      integer n, ia, i
c
c     initialise double complex array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end


      integer function iran(i)
      implicit none
      double precision util_drand
      external util_drand
      integer i
      iran = int(util_drand(0)*dfloat(i))+1
      return
      end

*
* $Id: paw_matrix_vloc.F 20364 2011-05-20 20:38:23Z d3p852 $
*

!**************************************************
!
!       name: init_paw_vloc_matrix
!
!       purpose: initializes local pseudopotential 
!                matrix
!
!       created:        7/9/2002
!**************************************************
      subroutine  init_paw_vloc_matrix()
      implicit none

#include "mafdecls.fh"
#include "paw_basis.fh"
#include "paw_matrix_vloc_data.fh"
#include "paw_ma.fh"

      !*** local variables ***
      logical ok
      integer it,tot_ntype
      integer matr_size, matr_index
      integer ic,istart

      tot_ntype = paw_basis_tot_ntype()
      ok = my_alloc(mt_int,tot_ntype,"i_paw_vloc_matrix",
     >                                  i_paw_vloc_matrix)
      if (.not.ok) 
     > call errquit("init_paw_vloc_matrix: error allocating heap",0,0)
  
      !*** determine matrix size ***
      matr_size = 0
      do it=1,tot_ntype
        matr_size = matr_size + int_mb(paw_basis_i_nbasis(it))**2
      end do

      !*** set the indexing to access diff atom types ***
      int_mb(i_paw_vloc_matrix(1) )  = 0
      do it=1,tot_ntype-1
        int_mb(i_paw_vloc_matrix(1) +it)  = 
     >         int_mb(i_paw_vloc_matrix(1) + it - 1)
     >       + int_mb(paw_basis_i_nbasis(it))**2
      end do

      ok = my_alloc(mt_dbl,matr_size,"paw_vloc_matrix",paw_vloc_matrix)
      if (.not.ok) 
     > call errquit("init_paw_vloc_matrix: error allocating heap",0,1)
  
      do it=1,tot_ntype
       ic     = paw_basis_npoints(it)
       istart = paw_basis_i_start(it)
    
       matr_index = int_mb(i_paw_vloc_matrix(1) +it-1)
       call find_paw_vloc_matrix(ic,istart,
     >                        int_mb(paw_basis_i_ngrid(it)),
     >                        int_mb(paw_basis_i_nbasis(it)),
     >                        int_mb(paw_basis_i_orb_l(it)),
     >                        dbl_mb(paw_basis_i_log_amesh(it)),
     >                        dbl_mb(paw_basis_i_rgrid(it)),
     >                        dbl_mb(paw_basis_i_v_ps(it)),
     >                        dbl_mb(paw_basis_i_phi_ps(it)),
     >                        dbl_mb(paw_vloc_matrix(1) + matr_index))


      end do

      return
      end !subroutine init_paw_vloc_matrix


      subroutine  end_paw_vloc_matrix()
      implicit none

#include "mafdecls.fh"
#include "paw_basis.fh"
#include "paw_matrix_vloc_data.fh"
#include "paw_ma.fh"

      !*** local variables ***
      logical ok

      ok =        my_dealloc(i_paw_vloc_matrix)
      ok = ok.and.my_dealloc(paw_vloc_matrix)
      if (.not.ok) 
     > call errquit("end_paw_vloc_matrix: error freeing heap",0,0)


      return
      end !subroutine end_paw_vloc_matrix

!**************************************************
!
!       name:  find_paw_vloc_matrix
!
!       purpose: 
!
!       created:        7/9/2002
!**************************************************
      subroutine find_paw_vloc_matrix(ic,istart,
     >                        ngrid,
     >                        nbasis,
     >                        orb_l,
     >                        log_amesh,
     >                        r,
     >                        v_ps,
     >                        phi_ps,
     >                        matrix)
      implicit none
      integer    ic,istart
      integer    ngrid
      integer    nbasis
      integer    orb_l(nbasis)

      double precision     log_amesh
      double precision     r(ngrid)
      double precision     v_ps(ngrid)
      double precision     phi_ps(ngrid,nbasis)
      double precision     matrix(nbasis,nbasis)

#include "mafdecls.fh"
#include "integrate.fh"

      !*** local variables ***
      logical  ok
      integer  i,j,ig,igg,np
      integer  l
      integer  power_r,power_f
      integer  i_f,l_f
      double precision  tmp


      call Parallel_np(np)
      power_r = 0

      !*** temporary array for calculations ***
      ok = ma_push_get(mt_dbl,ic, "tmp_array",l_f,i_f)
      if (.not.ok)
     > call errquit('find_paw_vloc_matrix: out of stack memory',0,0)


      do i=1,nbasis
        l = orb_l(i)
        power_f = 2*orb_l(i) + 2
        do j=1,i
          if(orb_l(i).eq.orb_l(j)) then
            
            do ig=1,ic
            igg=ig+istart-1
            dbl_mb(i_f+ig-1) =  phi_ps(igg,i)
     >                             *phi_ps(igg,j)
     >                             *v_ps(igg)
            end do
c            tmp = def_integr(power_f,dbl_mb(i_f),power_r,
c     >                       r,log_amesh,ic)
            tmp = def_integr1(power_f,dbl_mb(i_f),power_r,
     >                       r(istart),log_amesh,ic,istart)
        
            matrix(i,j) = tmp
            matrix(j,i) = tmp
          else
            matrix(i,j) = 0.0d0
            matrix(j,i) = 0.0d0
          end if
          
        end do
      end do
      if (np.gt.1) call D3dB_Vector_SumAll(nbasis*nbasis,matrix)

      ok = ma_pop_stack(l_f)
      if (.not.ok)
     > call errquit('find_paw_vloc_matrix:error popping stack',0,0)

      return
      end !subroutine find_paw_vloc_matrix



      subroutine paw_vloc_matrix_ptr(ptr)
      implicit none
      integer ptr

#include "paw_matrix_vloc_data.fh"

      ptr = paw_vloc_matrix(1)

      return
      end

c $Id: util_ma.F 19707 2010-10-29 17:59:36Z d3y133 $

      subroutine util_set_ma_char_arrays(nt,tin,tout)
      implicit none
      integer nt
      character*1 tin(nt)
      character*1 tout(nt)

      integer i

      do i=1,nt
       tout(i) = tin(i) 
      end do

      end

C> \file ci.F
C> Initialize CI module
C>
C> \ingroup selci
C> @{
C>
C> \brief CI initialization
C>
      subroutine selci_ci(q, lword)
*
* $Id: ci.F 24783 2013-11-08 03:14:31Z d3y133 $
*
#include "implicit.fh"
#include "ciinfo.fh"
#include "mptr.fh"
#include "cselcifiles.fh"
#include "global.fh"
      character *80 title
c
      integer lword !< [Input] The available amount of memory
      double precision q(lword) !< [Scratch] The main memory array
c
c     data initialization
c
      junk = selci_minit(lword)
      call selci_gettim(startc, startw)
c
      lencib = mitob(lencii) + mdtob(lencir)
      me = ga_nodeid()
      if (me.eq.0) then
        call selci_initci(title, 'ci')
        write (iflham) nci
      else
        iflham = 4
        open(iflham,form='unformatted',status='unknown',file=hamil)
        call inibit
      endif
      call ga_brdcst(1,repnuc,lencib,0)
c
c     make integral addressing arrays, and then load the integrals
c
      int12 = selci_mptr(mitod(nnorbs))
      int34 = selci_mptr(mitod(nnorbs))
      call selci_mkinta(q(int12), q(int34))
      ih = selci_mptr(nnorbs)
      ig = selci_mptr(numint)
      if (me.eq.0) then
        write(ifllog,7) numint
 7      format(' no. of integrals       ',i9)
        call selci_load(q(ih), q(ig), q(int12), q(int34))
        call util_flush(ifllog)
      endif
      call ga_brdcst(2,q(ih),mdtob(nnorbs),0)
      call ga_brdcst(3,q(ig),mdtob(numint),0)
c         some integral types don't make repnuc available until load
      call ga_brdcst(4,repnuc,mdtob(1),0)
c
c     get in the coupling coefficient arrays
c
      iw1 = selci_mptr(nfmax*nfmax*nsmax)
      iw2 = selci_mptr(nfmax2*nfmax*(nsmax-1))
      if (me.eq.0) then
         call selci_loadw(iflwmt,q(iw1),q(iw2),
     $        nfmax,nfmax2,nsmax)
         close(iflwmt,status='delete')
      endif
      call ga_brdcst(5,q(iw1),mdtob(nfmax*nfmax*nsmax),0)
      call ga_brdcst(6,q(iw2),mdtob(nfmax2*nfmax*(nsmax-1)),0)
      call selci_inicij(q(iw1),q(iw2))
c
c     allocate space for orbital configurations and
c     the index vector, then read them off the ciconf file
c
      ioconf = selci_mptr(mitod(nintpo*noconf))
      indxci = selci_mptr(mitod(noconf))
      if (me.eq.0) then
         call selci_rdconf(iflcon,q(ioconf),q(indxci),
     $        nintpo,noconf)
         close(iflcon,status='keep')
      endif
      call ga_brdcst(7,q(ioconf),mitob(nintpo*noconf),0)
      call ga_brdcst(8,q(indxci),mitob(noconf),0)
c      call selci_pconls(q(ioconf))
c
c     make the hamiltonian
c
      ihd = selci_mptr(nci)
      iwork1 = selci_mptr(max(nfmax*nfmax, nci))
      iwork2 = selci_mptr(nfmax*nfmax)
      iwork3 = selci_mptr(nfmax*nfmax)
      if = selci_mptr(nnorbs)
c
      call selci_makeh(q(ih), q(ig), q(int12), q(int34), q(iw1), q(iw2),
     $     q(ioconf), q(indxci), q(ihd), q(iwork1), q(iwork2),
     $     q(iwork3), q(if))
c
      if (ga_nodeid() .eq. 0) then
         junk = selci_mstats(0)
         call selci_gettim(endc, endw)
         write(6,1) 'CI', endc-startc, endw-startw
 1       format(/1x,a,': Total cpu',f10.1,' : Total wall',f10.1)
         call util_flush(6)
      endif
c
      call ga_sync()
c
      end
C>
C> @}

      subroutine tce_mrcc_mo2e(rtdb,d_ao2e,d_mo2e,k_2e_offset,
     1 iref,d_mo2e1,k_2e_offset1)
c
c $Id: tce_mrcc_mo2e.F 24345 2013-06-22 06:19:30Z d3y133 $
c
c     Returns a SF handle for the MO 2-e integral matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_mrcc.fh"
      integer rtdb                 ! Run-time database
      logical nodezero             ! True if node zero
      integer d_ao2e               ! Half MO integrals
      integer d_mo2e               ! MO integrals
      integer k_2e_offset          ! MO integrals offset
      integer l_kl,k_kl            ! Half MO integrals
      integer l_sl,k_sl            ! Quarter transformed
      integer l_pqkl_packed,k_pqkl_packed! Packed
      integer pq_packed_off
      integer kl
      integer l_pqrs,k_pqrs        ! MO integrals
      integer pb,qb,rb,sb
      integer p,q
      integer spin_pq,spin_rs
      integer sym_pq,sym_rs
      integer sf_size_kl
      integer sf_size_rs
      integer sf_size_pq
      integer sf_size_pqrs
      integer pqoff
      integer l_pqboff,k_pqboff
      integer pq
      integer r_range,s_range
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      INTEGER NXTASKsub
      EXTERNAL NXTASKsub
      integer next,count,nprocs
      integer Nb
c     integer pqrs,r,s
c     integer l_debug,k_debug
c     double precision debugdbl
      logical transpose
      integer iref,i,pgd
      integer newpb,newqb,newrb,newsb
      integer orbspin,orbindex
      integer d_mo2e1,k_2e_offset1 
      integer iNb
c
c     ===========
c     Preliminary
c     ===========
c
      nodezero = (ga_nodeid().eq.0)
      Nb = noa + nob + nva + nvb
      if(lusesub)pgd = int_mb(k_innodes+ga_nnodes()+ga_nodeid())
c
c     ===========
c     Allocate SF
c     ===========
c
      sf_size_pqrs = 0
      pq_packed_off = 0
      if (.not.ma_push_get(mt_int,Nb*Nb,'pqboff',l_pqboff,k_pqboff))
     1  call errquit('tce_mo2e: MA problem',11,MA_ERR)
      do pb = 1,Nb
        do qb = pb,Nb
          do rb = 1,Nb
            do sb = rb,Nb
              if (int_mb(k_spin+pb-1)+int_mb(k_spin+qb-1) .eq.
     1            int_mb(k_spin+rb-1)+int_mb(k_spin+sb-1)) then
              if ((.not.restricted).or.
     1          (int_mb(k_spin+pb-1)+int_mb(k_spin+qb-1)+
     2           int_mb(k_spin+rb-1)+int_mb(k_spin+sb-1).ne.8)) then
              if (ieor(int_mb(k_sym+pb-1),ieor(int_mb(k_sym+qb-1),
     1            ieor(int_mb(k_sym+rb-1),int_mb(k_sym+sb-1))))
     2            .eq. 0) then
                sf_size_pqrs = sf_size_pqrs
     1            + int_mb(k_range+pb-1) * int_mb(k_range+qb-1)
     2            * int_mb(k_range+rb-1) * int_mb(k_range+sb-1)
              endif
              endif
              endif
            enddo
          enddo
          int_mb(k_pqboff+(pb-1)*Nb+qb-1) = pq_packed_off
          pq_packed_off = pq_packed_off + int_mb(k_range+pb-1)
     1                                  * int_mb(k_range+qb-1)
        enddo
      enddo
      sf_size_kl = nbf**2
c
c     ====================
c     Allocate work arrays
c     ====================
c
      if (.not.ma_push_get(mt_dbl,sf_size_kl,'kl',l_kl,k_kl))
     1  call errquit('tce_mo2e: MA problem',1,MA_ERR)
c
c     ============
c     Loop over pq
c     ============
c
      if(lusesub) then
      nprocs = ga_pgroup_nnodes(pgd)
      count = 0
      next = NXTASKsub(nprocs,1,pgd)
      else
      nprocs = ga_nnodes()
      count = 0
      next = NXTASK(nprocs, 1)
      endif

      do pb = 1,Nb
        do qb = pb,Nb
          if (next.eq.count) then
ckbn            if((iref.eq.1).and.lusesub.and.(pb.eq.qb))
ckbn     1 write(LuOut,"('2-el start II. part, blocks: ',I4,I4,' Nb:',I6)")
ckbn     1 pb,qb,Nb
            if (util_print('mo2e',print_debug))
     1        write(LuOut,9190) pb,qb,ga_nodeid()
            spin_pq = int_mb(k_spin+pb-1)+int_mb(k_spin+qb-1)
            sym_pq = ieor(int_mb(k_sym+pb-1),int_mb(k_sym+qb-1))
            sf_size_pq = int_mb(k_range+pb-1)*int_mb(k_range+qb-1)
            if (.not.ma_push_get(mt_dbl,sf_size_pq*sf_size_kl,
     1        'pqkl packed',l_pqkl_packed,k_pqkl_packed))
     2        call errquit('tce_mo2e: MA problem',2,MA_ERR)
            do kl = 1,sf_size_kl
              call get_block(d_ao2e,dbl_mb(k_pqkl_packed
     1          +(kl-1)*sf_size_pq),sf_size_pq,(kl-1)*pq_packed_off
     2          +int_mb(k_pqboff+(pb-1)*Nb+qb-1))
            enddo
            do rb = 1,Nb
              do sb = rb,Nb
                transpose = (int_mb(k_spin+pb-1).eq.int_mb(k_spin+rb-1))
                spin_rs = int_mb(k_spin+rb-1)+int_mb(k_spin+sb-1)
                sym_rs = ieor(int_mb(k_sym+rb-1),int_mb(k_sym+sb-1))
                if (spin_pq .eq. spin_rs) then
                if ((.not.restricted).or.(spin_pq+spin_rs.ne.8)) then
                if (ieor(sym_pq,sym_rs) .eq. 0) then
                  r_range = int_mb(k_range+rb-1)
                  s_range = int_mb(k_range+sb-1)
                  sf_size_rs = r_range * s_range
cjb

       if(log_mb(k_isactive(iref)+pb-1).or.
     1 log_mb(k_isactive(iref)+qb-1).or.
c        if(1.eq.1) then
     1 log_mb(k_isactive(iref)+rb-1).or.
     1 log_mb(k_isactive(iref)+sb-1).or.(iref.eq.1).or.
     1 (lusesub).or.(luseeaf2e)) then

cjb
                  if (.not.ma_push_get(mt_dbl,s_range*nbf,
     1              'sl',l_sl,k_sl))
     2              call errquit('tce_mo2e: MA problem',3,MA_ERR)
                  if (.not.ma_push_get(mt_dbl,sf_size_pq*sf_size_rs,
     1              'rs',l_pqrs,k_pqrs))
     2              call errquit('tce_mo2e: MA problem',4,MA_ERR)
                  pq = 0
                  pqoff = 0
                  do p = 1,int_mb(k_range+pb-1)
                    do q = 1,int_mb(k_range+qb-1)
                      pq = pq + 1
                      call dcopy(sf_size_kl,
     1                  dbl_mb(k_pqkl_packed+pq-1),
     2                  sf_size_pq,dbl_mb(k_kl),1)
                      if (transpose) then
#ifdef MA_TRANS_BLOCKED
                        call ma_transpose_blocked(dbl_mb(k_kl),nbf)
#else
                        call ma_transpose(dbl_mb(k_kl),nbf)
#endif
                      else
                        call ma_scale(dbl_mb(k_kl),nbf**2,-1.0d0)
                      endif
                      call dgemm('T','N',s_range,nbf,nbf,
     1                  1.0d0,dbl_mb(k_movecs_sorted
     2                  +int_mb(k_offset+sb-1)*nbf),nbf,
     3                  dbl_mb(k_kl),nbf,
     4                  0.0d0,dbl_mb(k_sl),s_range)
                      call dgemm('N','N',s_range,r_range,nbf,
     1                  1.0d0,dbl_mb(k_sl),s_range,
     2                  dbl_mb(k_movecs_sorted
     3                  +int_mb(k_offset+rb-1)*nbf),nbf,
     4                  0.0d0,dbl_mb(k_pqrs+pqoff),s_range)
                      pqoff = pqoff + r_range * s_range
                    enddo
                  enddo
                  if (util_print('mo2e',print_debug))
     1              then
                    write(LuOut,9200) pb,qb,rb,sb
                    call ma_print_compact(dbl_mb(k_pqrs),
     1              sf_size_pq*sf_size_rs,1,'MO 2e')
                  endif
                  call put_hash_block(d_mo2e,dbl_mb(k_pqrs),
     1              sf_size_pq*sf_size_rs,int_mb(k_2e_offset),
     2              ((((pb-1)*Nb+qb-1)*Nb+rb-1)*Nb+sb-1))
                  if (.not.ma_pop_stack(l_pqrs))
     1              call errquit('tce_mo2e: MA problem',5,MA_ERR)
                  if (.not.ma_pop_stack(l_sl))
     1              call errquit('tce_mo2e: MA problem',6,MA_ERR)
cjb
                else

      iNb = nblcks(1,1)+nblcks(2,1)
     +  + nblcks(3,1)+nblcks(4,1)

               orbspin = int_mb(k_spin+pb-1)-1
               orbindex = (1-orbspin+int_mb(k_mo_indexm(iref)+
     1 int_mb(k_offset+pb-1)))/2
               orbindex = moindexes(orbindex,orbspin+1,iref)
               orbindex = moindexes(orbindex,orbspin+1,1)
               newpb = orbinblck(orbindex,orbspin+1,1)

               orbspin = int_mb(k_spin+qb-1)-1
               orbindex = (1-orbspin+int_mb(k_mo_indexm(iref)+
     1 int_mb(k_offset+qb-1)))/2
               orbindex = moindexes(orbindex,orbspin+1,iref)
               orbindex = moindexes(orbindex,orbspin+1,1)
               newqb = orbinblck(orbindex,orbspin+1,1)

               orbspin = int_mb(k_spin+rb-1)-1
               orbindex = (1-orbspin+int_mb(k_mo_indexm(iref)+
     1 int_mb(k_offset+rb-1)))/2
               orbindex = moindexes(orbindex,orbspin+1,iref)
               orbindex = moindexes(orbindex,orbspin+1,1)
               newrb = orbinblck(orbindex,orbspin+1,1)

               orbspin = int_mb(k_spin+sb-1)-1
               orbindex = (1-orbspin+int_mb(k_mo_indexm(iref)+
     1 int_mb(k_offset+sb-1)))/2
               orbindex = moindexes(orbindex,orbspin+1,iref)
               orbindex = moindexes(orbindex,orbspin+1,1)
               newsb = orbinblck(orbindex,orbspin+1,1)

c               if(newpb.gt.newqb) then
c                 i = newpb
c                 newpb = newqb
c                 newqb = i
c               endif

c               if(newrb.gt.newsb) then
c                 i = newrb
c                 newrb = newsb
c                 newsb = i
c               endif

                  if (.not.ma_push_get(mt_dbl,sf_size_pq*sf_size_rs,
     1              'rs',l_pqrs,k_pqrs))
     2              call errquit('tce_mo2e: MA problem',4,MA_ERR)

c         CALL DFILL(sf_size_pq*sf_size_rs,0.0d0,dbl_mb(k_pqrs),1)   

                  call get_hash_block(d_mo2e1,dbl_mb(k_pqrs),
     1             sf_size_pq*sf_size_rs,int_mb(k_2e_offset1),
     2             ((((newpb-1)*iNb+newqb-1)*iNb+newrb-1)*iNb+newsb-1))

                  call put_hash_block(d_mo2e,dbl_mb(k_pqrs),
     1              sf_size_pq*sf_size_rs,int_mb(k_2e_offset),
     2              ((((pb-1)*Nb+qb-1)*Nb+rb-1)*Nb+sb-1))

                  if (.not.ma_pop_stack(l_pqrs))
     1              call errquit('tce_mo2e: MA problem',5,MA_ERR)

                endif
cjb
                endif
                endif
                endif
              enddo
            enddo
            if (.not.ma_pop_stack(l_pqkl_packed))
     1        call errquit('tce_mo2e: MA problem',3,MA_ERR)

      if(lusesub) then
        next = NXTASKsub(nprocs,1,pgd)
      else
        next = NXTASK(nprocs, 1)
      endif

ckbn            if((iref.eq.1).and.lusesub.and.(pb.eq.qb))
ckbn     1 write(LuOut,"('***END II. part, blocks: ',I4,I4,' Nb:',I6)")
ckbn     1 pb,qb,Nb

          endif
          count = count + 1
        enddo
      enddo

      if(lusesub) then
        next = NXTASKsub(-nprocs,1,pgd)
      else
        next = NXTASK(-nprocs,1)
      endif
c
c     ==========
c     Deallocate
c     ==========
c
      if (.not.ma_pop_stack(l_kl))
     1  call errquit('tce_mo2e: MA problem',10,MA_ERR)
      if (.not.ma_pop_stack(l_pqboff))
     1  call errquit('tce_mo2e: MA problem',12,MA_ERR)
      if (nodezero.and.util_print('time',print_debug)) then
        write(LuOut,8000) 'createfile   ', cpusecs(1), cpusecs(51)
        write(LuOut,8000) 'deletefile   ', cpusecs(2), cpusecs(52)
        write(LuOut,8000) 'put_block    ', cpusecs(3), cpusecs(53)
        write(LuOut,8000) 'add_block    ', cpusecs(4), cpusecs(54)
        write(LuOut,8000) 'get_block    ', cpusecs(5), cpusecs(55)
        write(LuOut,8000) 'reconcilefile', cpusecs(6), cpusecs(56)
      endif
 8000 format(1x,'cpu & wall time in seconds for ',A,2f20.1)
c
c     Debug only
c
c     if (.not.ma_push_get(mt_dbl,sf_size_pqrs,
c    1  'mo2e',l_debug,k_debug))
c    2  call errquit('tce_mo2e: MA problem',-1,MA_ERR)
c     call get_block(d_mo2e,dbl_mb(k_debug),sf_size_pqrs,0)
c     pqrs = 0
c     do pb = 1,Nb
c       do qb = pb,Nb
c         do rb = 1,Nb
c           do sb = rb,Nb
c             if (int_mb(k_spin+pb-1)+int_mb(k_spin+qb-1) .eq.
c    1            int_mb(k_spin+rb-1)+int_mb(k_spin+sb-1)) then
c               if (ieor(int_mb(k_sym+pb-1),ieor(int_mb(k_sym+qb-1),
c    1              ieor(int_mb(k_sym+rb-1),int_mb(k_sym+sb-1))))
c    2              .eq. 0) then
c                 do p = 1,int_mb(k_range+pb-1)
c                   do q = 1,int_mb(k_range+qb-1)
c                     do r = 1,int_mb(k_range+rb-1)
c                       do s = 1,int_mb(k_range+sb-1)
c                         pqrs = pqrs + 1
c                         debugdbl = dbl_mb(k_debug+pqrs-1)
c                         write(LuOut,9100) p+int_mb(k_offset+pb-1),
c    1                                      q+int_mb(k_offset+qb-1),
c    2                                      r+int_mb(k_offset+rb-1),
c    3                                      s+int_mb(k_offset+sb-1),
c    4                                      debugdbl
c                       enddo
c                     enddo
c                   enddo
c                 enddo
c               endif
c             endif
c           enddo
c         enddo
c       enddo
c     enddo
c     if (.not.ma_pop_stack(l_debug))
c    1  call errquit('tce_mo2e: MA problem',7,MA_ERR)
c9100 format(4i3,f20.10)
c
c     ======
c     Return
c     ======
c
 9190 format(/,' p q blocks ',2i3,' has been assigned to node ',i3)
 9200 format(/,' p q r s blocks ',4i3)
      call deletefile(d_ao2e)
      return
      end

*> \brief \b DCABS1
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       DOUBLE PRECISION FUNCTION DCABS1(Z)
* 
*       .. Scalar Arguments ..
*       COMPLEX*16 Z
*       ..
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DCABS1 computes absolute value of a double complex number 
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup double_blas_level1
*
*  =====================================================================
      DOUBLE PRECISION FUNCTION DCABS1(Z)
*
*  -- Reference BLAS level1 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      COMPLEX*16 Z
*     ..
*     ..
*  =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC ABS,DBLE,DIMAG
*
      DCABS1 = ABS(DBLE(Z)) + ABS(DIMAG(Z))
      RETURN
      END
c $Id: dcabs1.f 24342 2013-06-22 05:32:15Z d3y133 $

c
c $Id: band_analysis.F 22644 2012-07-25 00:12:42Z bylaska $
c

      subroutine band_analysis(flag,rtdb,ispin,ne,
     >                         nbrill,nbrillq,psi_tag,eig_tag)
      implicit none
      integer flag
      integer rtdb
      integer ispin,ne(2),nbrill,nbrillq
      integer psi_tag
      integer eig_tag

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "stdio.fh"

*     **** parallel variables ****
      integer  taskid,taskid_k
      integer  MASTER
      parameter(MASTER=0)


*     **** electronic variables ****
      integer npack1
      integer n1(2),n2(2)
    
*     **** local variables ****
      integer i,k,l,n,ms,l1,l2,j,nbq,nb,pk
      integer ll,spin,ind
      real*8  ttl1,ttl2,subttl

      integer h_actlist,l_actlist,nactive_atoms,ma_type
      integer npoints,ii,lmax
      integer weight(2),dstates(2)
      real*8 emin,emax,alpha,lmbda,rcut,bweight,kvec(3),ksvec(3)
      character*255 filename

      logical value,fixatoms
      character*28 DD
      character*255 id,test
      integer npsp,nion,nemax
      integer lorb(2)    ! integer lorb(npsp)
      integer b0(2)      ! real*8 b0(0:5,npsp)
      integer total(2)   ! real*8 total(nion)
      integer subtl(2)   ! real*8 subtl(0:5,3)
      integer a(2)       ! real*8 a(36,nemax,nion)
      integer sum(2)     ! real*8 sum(nemax)
      integer eig(2)     ! real*8 sum(nemax)
      integer A_tag,sum_tag
      integer A_shift,sum_shift,psi_shift,eig_shift
 
      character*4 spn(2)
      DATA SPN / 'UP  ', 'DOWN' /


*     **** external functions ****
      logical  control_DOS,nwpw_filefind
      logical  borbs_init,borbs_readall
      external control_DOS,nwpw_filefind
      external borbs_init,borbs_readall
      character   spdf_name
      external    spdf_name
      character*4 ion_atom_qm
      external    ion_atom_qm
      integer  ion_nion_qm,ion_katm_qm,ion_nkatm_qm
      external ion_nion_qm,ion_katm_qm,ion_nkatm_qm
      real*8   ion_rion
      external ion_rion
      real*8      lattice_omega,lattice_ecut,lattice_unita
      external    lattice_omega,lattice_ecut,lattice_unita
      real*8   borbs_rcut,borbs_lmbda,ddot,brillioun_weight
      external borbs_rcut,borbs_lmbda,ddot,brillioun_weight
      real*8   brillioun_weight_brdcst
      external brillioun_weight_brdcst
      real*8   brillioun_k_brdcst,brillioun_ks_brdcst
      external brillioun_k_brdcst,brillioun_ks_brdcst
      integer  cpsi_data_alloc,cpsi_data_get_chnk
      external cpsi_data_alloc,cpsi_data_get_chnk


      call Parallel_taskid(taskid)
      call Parallel3d_taskid_k(taskid_k)
      call Cram_max_npack(npack1)

      npsp = ion_nkatm_qm()
      nion = ion_nion_qm()
      nemax = ne(1)+ne(2)

      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1)+1
      n2(2) = ne(1)+ne(2)

      value = MA_alloc_get(mt_int,npsp,'lorb',lorb(2),lorb(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,6*npsp,'b0',b0(2),b0(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,nion,'total',total(2),total(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,50,'subtl',subtl(2),subtl(1))

      value = value.and.
     >        MA_alloc_get(mt_dcpl,36*nemax*nion,'a',a(2),a(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,nemax,'sum',sum(2),sum(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,nemax,'eig',eig(2),eig(1))

      A_tag   = cpsi_data_alloc(nbrillq,2*36*nemax*nion,1)
      sum_tag = cpsi_data_alloc(nbrillq,nemax,1)


*      ***********************************************
*      **** create psp1 files if they don't exist ****
*      ***********************************************
       do k=1,npsp
         DD = '                          '
         DD = ion_atom_qm(k)
         ind = index(DD,' ') - 1
         test = DD(1:ind)//'.psp1'
         id   = DD(1:ind)//'.borb'
         call control_mullikenparameters(ion_atom_qm(k),rcut,lmbda)
         if ((.not.nwpw_filefind(test)).or.(.not.nwpw_filefind(id)))
     >      call borbs_formatter_auto(ion_atom_qm(k),rcut,lmbda)
       end do

       call ga_sync()

*      ****************************************
*      **** read in expansion coefficients ****
*      ****************************************
       do k=1,npsp
          id = 'analysis:lorb'//ion_atom_qm(k)
          if (.not. rtdb_get(rtdb,id,mt_int,1,int_mb(lorb(1)+k-1))) then
            DD = '                          '
            DD = ion_atom_qm(k)
            ind = index(DD,' ') - 1
            test = DD(1:ind)//'.psp1'

            !write(*,*) "test:",test,ind
            value = rtdb_parallel(.false.)
            if (taskid.eq.MASTER) then
            ind = index(test,' ') - 1
            !write(*,*) "test:",test,ind
            call analysis_expansion_coef(test,-1,rtdb)
            end if
            value = rtdb_parallel(.true.)
            call ga_sync()

            if (.not. rtdb_get(rtdb,id,mt_int,1,int_mb(lorb(1)+k-1)))
     >        call errquit(
     >        'analysis: rtdb_get lorb failed', 0, RTDB_ERR)
          end if

          id = 'analysis:expansion'//ion_atom_qm(k)
          if (.not. rtdb_get(rtdb,id,mt_dbl,(int_mb(lorb(1)+k-1)+1),
     >                                  dbl_mb(b0(1)+(k-1)*6))) then
            DD = '                          '
            DD = ion_atom_qm(k)
            ind = index(DD,' ') -1
            test = DD(1:ind)//'.psp1'
            call analysis_expansion_coef(test,-1,rtdb)

            if (.not. rtdb_get(rtdb,id,mt_dbl,(int_mb(lorb(1)+k-1)+1),
     >                                       dbl_mb(b0(1)+(k-1)*6)))
     >       call errquit(
     >       'analysis: rtdb_get failed', 0, RTDB_ERR)
          end if
       end do

      call ga_sync()

      value = borbs_init()
      value = value.and.borbs_readall()
      if (.not.value) then
         do k=1,npsp
            call control_mullikenparameters(ion_atom_qm(k),rcut,lmbda)
            call borbs_formatter_auto(ion_atom_qm(k),rcut,lmbda)
         end do
      end if
      call ga_sync()

      value = .true.
      do k=1,npsp
         call control_mullikenparameters(ion_atom_qm(k),rcut,lmbda)
         if ((dabs(borbs_rcut(k)-rcut).gt.1.0d-6).or.
     >       (dabs(borbs_lmbda(k)-lmbda).gt.1.0d-6)) then
            call borbs_formatter_auto(ion_atom_qm(k),rcut,lmbda)
            value = .false.
         end if
      end do

      call ga_sync()
      
      if (.not.value) value = borbs_readall()
      if (.not.value) go to 1901
      call ga_sync()
      


      if (taskid.eq.MASTER) then
         call util_date(DD)
 
         WRITE(luout,*)
         WRITE(luout,*)
         WRITE(luout,*)
         WRITE(luout,*) 
     >  '*************************************************************'
         WRITE(luout,*) 
     >  '**                                                         **'
         WRITE(luout,*) 
     >  '**                  BAND Mulliken analysis                 **'
         WRITE(luout,*) 
     >  '**                                                         **'
         if (flag.eq.1)
     >   WRITE(luout,*)
     >  '**                   (Virtual Orbitals)                    **'
         WRITE(luout,*) 
     >  '** Population analysis algorithm developed by Ryoichi Kawai**'
         WRITE(luout,*) 
     >  '**                                                         **'
         WRITE(luout,1000) DD
 1000    FORMAT(
     >  ' **                   ',A16,'                      **')
         WRITE(luout,*)
     >   '**                                                         **'
         WRITE(luout,*) 
     >  '*************************************************************'
      end if


c     **** ouput xyz format ****
      call ion_Print_XYZ(luout)


      value = rtdb_parallel(.false.)
      if (taskid.eq.MASTER) then
         write(luout,1307)
         do k=1,npsp
           call control_mullikenparameters(ion_atom_qm(k),rcut,lmbda)
           if (lmbda.gt.0.0d0) then
              write(luout,1308) ion_atom_qm(k),"damping",rcut,lmbda
           else
              write(luout,*) ion_atom_qm(k)," nodamping"
           end if
         end do
         call util_flush(luout)
 1307    FORMAT(//'== Atomic Orbital Expansion =='/)
 1308    FORMAT(A5,A10,4x,"rcut=",F8.3,2x,"lmbda=",F8.3)
      end if
      value = rtdb_parallel(.true.)
 

 
c      call util_file_name('ORBOUT',
c     >                     .true.,
c     >                     .false.,
c     >                      id)
c      if (taskid.eq.MASTER) 
c     > OPEN(UNIT=65,FILE=id,FORM='FORMATTED')
c      call Orb_Analysis(65,flag,ispin,ne,npack1,nemax,psi,
c     >                        int_mb(lorb(1)),
c     >                        dbl_mb(b0(1)),
c     >                        dbl_mb(a(1)),
c     >                        dbl_mb(sum(1)))
c      if (taskid.eq.MASTER) close(unit=65)

      do nbq=1,nbrillq
        psi_shift = cpsi_data_get_chnk(psi_tag,nbq)
        A_shift   = cpsi_data_get_chnk(A_tag,nbq)
        sum_shift = cpsi_data_get_chnk(sum_tag,nbq)

        call Orb_pop_borb(flag,nbq,ispin,ne,
     >                  npack1,nemax,dbl_mb(psi_shift),
     >                  int_mb(lorb(1)),
     >                  dbl_mb(A_shift),dbl_mb(sum_shift))
      end do


      if (taskid.eq.MASTER) then
      WRITE(luout,*)
      WRITE(luout,*)
      WRITE(luout,*) 
     > '====================================================='
      if (flag.eq.0)
     >WRITE(luout,*) 
     > '| POPULATION ANALYSIS OF FILLED MOLECULAR ORBITALS  |'
      if (flag.eq.1)
     >WRITE(luout,*) 
     > '| POPULATION ANALYSIS OF VIRTUAL MOLECULAR ORBITALS |'
      WRITE(luout,*) 
     > '====================================================='
      WRITE(luout,1311)
c     WRITE(6,1313)
c     WRITE(6,1314)
c     WRITE(6,1315)
 1311 FORMAT(//'== Using pseudoatomic orbital expansion          ==')
      end if

 
      do nb=1,nbrill
         call dcopy(nemax,0.0d0,0,dbl_mb(eig(1)),1)
         call dcopy(nemax,0.0d0,0,dbl_mb(sum(1)),1)
         call dcopy(2*36*nion*nemax,0.0d0,0,dcpl_mb(a(1)),1)
         bweight = brillioun_weight_brdcst(nb)
         kvec(1) = brillioun_k_brdcst(1,nb)
         kvec(2) = brillioun_k_brdcst(2,nb)
         kvec(3) = brillioun_k_brdcst(3,nb)
         ksvec(1) = brillioun_ks_brdcst(1,nb)
         ksvec(2) = brillioun_ks_brdcst(2,nb)
         ksvec(3) = brillioun_ks_brdcst(3,nb)

         call K1dB_ktoqp(nb,nbq,pk)
         if (pk.eq.taskid_k) then
            eig_shift = cpsi_data_get_chnk(eig_tag,nbq)
            A_shift   = cpsi_data_get_chnk(A_tag,nbq)
            sum_shift = cpsi_data_get_chnk(sum_tag,nbq)
            call dcopy(nemax,dbl_mb(eig_shift),1,dbl_mb(eig(1)),1)
            call dcopy(nemax,dbl_mb(sum_shift),1,dbl_mb(sum(1)),1)
            call dcopy(2*36*nion*nemax,dbl_mb(A_shift),1,
     >                                 dcpl_mb(a(1)),1)
         end if
         call K1dB_Vector_SumAll(nemax,dbl_mb(eig(1)))
         call K1dB_Vector_SumAll(nemax,dbl_mb(sum(1)))
         call K1dB_Vector_SumAll(2*36*nion*nemax,dcpl_mb(a(1)))

         if (taskid.eq.MASTER) then
         DO SPIN=1,ISPIN
         DO N=N1(SPIN),N2(SPIN)
          WRITE(luout,1500)
          write(luout,1508) nb,bweight,ksvec,kvec
          IF(ISPIN.EQ.2) THEN
            WRITE(luout,1510) N,SPN(SPIN),dbl_mb(sum_shift+N-1),
     >                    dbl_mb(eig(1)+n-1),
     >                    dbl_mb(eig(1)+n-1)*27.2116d0
          ELSE
            WRITE(luout,1515) N,dbl_mb(sum(1)+N-1),
     >                   dbl_mb(eig(1)+n-1),
     >                   dbl_mb(eig(1)+n-1)*27.2116d0
          ENDIF
          !write(6,1519)
          WRITE(luout,1520) 'NO','ATOM','L','POPULATION'

          DO L=0,5
            dbl_mb(subtl(1)+L)=0.0d0
          END DO
          DO I=1,nion
            dbl_mb(TOTAL(1)+I-1)=0.0d0
            DO L=0,int_mb(lorb(1)+ion_katm_qm(I)-1)
              L1=L**2+1
              L2=(L+1)**2
              SUBTTL=0.0d0
              SUBTTL = ddot(2*(L2-L1+1),
     >                     dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >                     dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
              dbl_mb(TOTAL(1)+I-1)=dbl_mb(TOTAL(1)+I-1)+SUBTTL
c              DO LL=L1,L2
c                dbl_mb(TOTAL(1)+I-1)=dbl_mb(TOTAL(1)+I-1)+
c     >                dbl_mb(a(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c                SUBTTL=SUBTTL+
c     >                dbl_mb(a(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c              END DO
              dbl_mb(subtl(1)+L)=dbl_mb(subtl(1)+L)+SUBTTL
              if (l.eq.0) write(luout,1516)
              if (l.eq.1) write(luout,1517)
              if (l.eq.2) write(luout,1518)
              if (l.eq.3) write(luout,1519)
              WRITE(luout,1530) I,ion_atom_qm(ion_katm_qm(I)),L,SUBTTL,
     >               (dble(dcpl_mb(a(1)+LL-1+(N-1)*36+(I-1)*36*nemax)),
     >                        LL=L1,L2)
              WRITE(luout,1532) 
     >               (dimag(dcpl_mb(a(1)+LL-1+(N-1)*36+(I-1)*36*nemax)),
     >                        LL=L1,L2)

            END DO
          END DO

          WRITE(luout,1540)
          WRITE(luout,1550) (I,ion_atom_qm(ion_katm_qm(I)),
     >                   dbl_mb(TOTAL(1)+I-1),I=1,nion)
          WRITE(luout,1555)
          WRITE(luout,1560)  's','p','d','f'
          WRITE(luout,1570)  (dbl_mb(subtl(1)+L),L=0,3)
        END DO
        END DO
        call util_flush(luout)
        end if
      end do

 1500 FORMAT(//'------------------------------------------------',
     >         '------------------------------'//)
 1508 FORMAT( '*** Brillouin zone point: ',i6,
     >       /'*** weight=',f10.6,
     >       /'*** k     =<',3f8.3,'> . <b1,b2,b3> ',
     >       /'***       =<',3f8.3,'>')
 1510 FORMAT('*** ORBITAL=',I4,' ***  SPIN=',A4,
     >       4X,'SUM=',E12.5,
     >       ' E=',E12.5,' (',F8.3,'eV)'/)
 1515 FORMAT('*** ORBITAL=',I4,' ***  SPIN=BOTH',
     >       4X,'SUM=',E12.5,
     >       ' E=',E12.5,' (',F8.3,'eV)'/)
 1516 FORMAT(27x,' s')
 1517 FORMAT(27x,' px          pz          py')
 1518 FORMAT(27x,' dx2-y2      dzx         d3z2-1      dyz         dxy')
 1519 FORMAT(27x,
     > ' fx(x2-3y2)  fz(5z2-1)   fx(5z2-1)   fz(5z2-3)   fy(5z2-1)  ',
     > ' fxyz        fy(3x2-y2)')

c 1519 FORMAT(30x,'  s',
c     >      /30x,' px         py        pz '
c     >      /27x,'d3z2-1        dxy        dyz        dzx     dx2-y2',
c     >      /30x,' fy(3x2-y2) fxyz      fy(5z2-1)   fz(5z2-3)  fx(5z2-1)', 
c     >           '  fz(5z2-1)  fx(x2-3y2)')

 1520 FORMAT(A2,2X,A4,2X,A1,2X,A10)
 1530 FORMAT(I2,3X,A4,3X,I1,F11.5,8(F11.5,1x))
 1531 FORMAT(8F11.5)
 1532 FORMAT(24x,8(F11.5,'i'))
 1540 FORMAT(//'=== DISTRIBUTION ==='/)
 1550 FORMAT(4(I6,'(',A4,')',F9.4))
 1555 FORMAT(//'== ANGULAR MOMENTUM POPULATIONS ==='/)
 1560 FORMAT(6X,A1,3(9X,A1))
 1570 FORMAT(4F10.4)
 
      if (taskid.eq.MASTER) then
      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,*) '========================================'
      WRITE(6,*) '|   POPULATION ANALYSIS ON EACH ATOM   |'
      WRITE(6,*) '========================================'
      WRITE(6,*)
      WRITE(6,*)
      WRITE(6,1610) 'NO','ATOM','SPIN','TOTAL','s','p','d','f'
      end if

      DO I=1,nion
        TTL1=0.0d0
        TTL2=0.0d0

        call dcopy(ispin*6*int_mb(lorb(1)+ion_katm_qm(I)-1),
     >             0.0d0,0,dbl_mb(subtl(1)),1)
        do nbq=1,nbrillq
          A_shift   = cpsi_data_get_chnk(A_tag,nbq)
          call dcopy(2*36*nion*nemax,dbl_mb(A_shift),1,
     >                                 dcpl_mb(a(1)),1)
          DO L=0,int_mb(lorb(1)+ion_katm_qm(I)-1)
            DO ms=1,ispin
            DO N=N1(ms),N2(ms)
                L1=L**2+1
                L2=(L+1)**2
                dbl_mb(subtl(1)+L+(ms-1)*6) =
     >          dbl_mb(subtl(1)+L+(ms-1)*6) +
     >          brillioun_weight(nbq)*
     >          ddot(2*(L2-L1+1),
     >                  dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >                  dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
c                DO LL=L1,L2
c                 dbl_mb(subtl(1)+L+(ms-1)*6)=
c     >             dbl_mb(subtl(1)+L+(ms-1)*6) +
c     >             dbl_mb(a(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c
c                END DO
            END DO
            END DO
          END DO
        end do
        call K1dB_Vector_SumAll(
     >            ispin*6*int_mb(lorb(1)+ion_katm_qm(I)-1),
     >            dbl_mb(subtl(1)))
     
        if (taskid.eq.MASTER) then
          TTL1=0.0d0
          DO L=0,int_mb(lorb(1)+ion_katm_qm(I)-1)
          TTL1=TTL1+dbl_mb(subtl(1)+L)
          END DO
          WRITE(luout,1620) I,ion_atom_qm(ion_katm_qm(I)),SPN(1),TTL1,
     >                 ( dbl_mb(subtl(1)+L),
     >                   L=0,int_mb(lorb(1)+ion_katm_qm(I)-1) )
          TTL1=0.0d0
          DO L=0,int_mb(lorb(1)+ion_katm_qm(I)-1)
          TTL1=TTL1+dbl_mb(subtl(1)+L+(ispin-1)*6)
          END DO
          WRITE(luout,1620) I,ion_atom_qm(ion_katm_qm(I)),SPN(2),TTL1,
     >                 ( dbl_mb(subtl(1)+L+(ispin-1)*6),
     >                   L=0,int_mb(lorb(1)+ion_katm_qm(I)-1) )
        end if
      END DO
      if (taskid.eq.MASTER) call util_flush(luout)

 1610 FORMAT(A2,2X,A4,2X,A4,4X,A5,7X,A,10X,A,10X,A,10X,A)
 1620 FORMAT(I2,3X,A4,3X,A4,5F11.5)
 
      call dcopy(18,0.0d0,0,dbl_mb(subtl(1)),1)
      do nbq=1,nbrillq
          A_shift   = cpsi_data_get_chnk(A_tag,nbq)
          call dcopy(2*36*nion*nemax,dbl_mb(A_shift),1,
     >                                 dcpl_mb(a(1)),1)
         DO I=1,nion
         DO SPIN=1,ISPIN
         DO N=N1(SPIN),N2(SPIN)
            DO L=0,int_mb(lorb(1)+ion_katm_qm(I)-1)
              L1=L**2+1
              L2=(L+1)**2
              dbl_mb(subtl(1)+L+(SPIN-1)*6)=
     >        dbl_mb(subtl(1)+L+(SPIN-1)*6)+
     >        brillioun_weight(nbq)*
     >        ddot(2*(L2-L1+1),
     >             dcpl_mb(A(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >             dcpl_mb(A(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
c              DO LL=L1,L2
c                dbl_mb(subtl(1)+L+(SPIN-1)*6)=
c     >          dbl_mb(subtl(1)+L+(SPIN-1)*6)+
c     >          dbl_mb(A(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c              END DO
            END DO
         END DO
         END DO
         END DO
      end do
      call K1dB_Vector_SumAll(18,dbl_mb(subtl(1)))

      DO L=0,3
        dbl_mb(subtl(1)+L+2*6)=
     >  (dbl_mb(subtl(1)+L)+dbl_mb(subtl(1)+L+(ISPIN-1)*6))
     >   *100.d0/(NE(1)+NE(ISPIN))
        dbl_mb(subtl(1)+L)=dbl_mb(subtl(1)+L)*100.0d0/dble(NE(1))
        IF((ISPIN.EQ.2).and.(NE(2).gt.0)) 
     >    dbl_mb(subtl(1)+L+6)=dbl_mb(subtl(1)+L+6)*100.0d0/dble(NE(2))
      END DO

      if (taskid.eq.MASTER) then
      WRITE(luout,1700)
      WRITE(luout,1710) ' SPIN ','s','p','d','f'
      WRITE(luout,1720) SPN(1),(dbl_mb(subtl(1)+L),L=0,3)
      WRITE(luout,1720) SPN(ISPIN),
     >                  (dbl_mb(subtl(1)+L+(ISPIN-1)*6),L=0,3)
      WRITE(luout,1720) ' TOTAL',(dbl_mb(subtl(1)+L+(3-1)*6),L=0,3)
      call util_flush(luout)
 1700 FORMAT(///'=== TOTAL ANGULAR MOMENTUM POPULATION ==='/)
 1710 FORMAT(A6,6X,A1,3(11X,A1))
 1720 FORMAT(A6,4(F10.2,'% '))
      end if


*     ***********************************************
*     **** generate projected DENSITY OF STATES *****
*     ***********************************************
      if (control_DOS()) then

      value = rtdb_parallel(.true.)
      value = MA_push_get(mt_dbl,(nemax),'weight',weight(2),weight(1))
      if (.not. value)
     >  call errquit('analysis:out of stack memory',0, MA_ERR)
      call dcopy(nemax,1.0d0,0,dbl_mb(weight(1)),1)


      if (.not.rtdb_get(rtdb,'dos:alpha',mt_dbl,1,alpha)) then
        alpha = 0.05d0/27.2116d0
      end if

      if (.not.rtdb_get(rtdb,'dos:npoints',mt_int,1,npoints)) then
        npoints = 500
      end if

      value = MA_push_get(mt_dbl,(2*npoints),
     >                    'dstates',dstates(2),dstates(1))
      if (.not. value)
     >  call errquit('analysis:out of stack memory',0, MA_ERR)
      call dcopy(npoints,0.0d0,0,dbl_mb(dstates(1)),1)

      if (.not.rtdb_get(rtdb,'dos:emin',mt_dbl,1,emin)) then
         emin = 99999.0d0
         do nbq=1,nbrillq
            eig_shift = cpsi_data_get_chnk(eig_tag,nbq)
            do ii=1,ne(1)+ne(2)
              if (dbl_mb(eig_shift+ii-1).lt.emin) 
     >           emin = dbl_mb(eig_shift+ii-1)
            end do
         end do
         call K1dB_MinAll(emin)
         emin = emin - 0.1d0
      end if

      if (.not.rtdb_get(rtdb,'dos:emax',mt_dbl,1,emax)) then
         emax = -99999.0d0
         do nbq=1,nbrillq
            eig_shift = cpsi_data_get_chnk(eig_tag,nbq)
            do ii=1,ne(1)+ne(2)
              if (dbl_mb(eig_shift+ii-1).gt.emax) 
     >           emax = dbl_mb(eig_shift+ii-1)
            end do
         end do
         call K1dB_MaxAll(emax)
         emax = emax + 0.1d0
      end if

*     **** explicit number of atoms have been requested ****
      fixatoms = .false.
      if (rtdb_ma_get(rtdb, 'nwpw:dos:actlist', ma_type,
     >        nactive_atoms, h_actlist)) then

         if (.not.MA_get_index(h_actlist,l_actlist))
     >      call errquit(
     >       'analysis: ma_get_index failed for actlist',911,
     &       MA_ERR)

           fixatoms = .true.
      end if

      if (taskid.eq.MASTER) then
         write(6,1800)
         if (.not.fixatoms) write(6,1801)
         if (fixatoms) then
           write(6,1802)
           write(6,1803) (int_mb(l_actlist+j-1),j=1,nactive_atoms)
         end if
      end if
 1800 FORMAT(///'=== PROJECTED DENSITY OF STATES ==='/)
 1801 FORMAT('  All atoms were used to determine weights')
 1802 FORMAT('  The following atoms were used to determine weights:')
 1803 FORMAT(2x,8I6)

*     **** angular momentum decomposition *****
      lmax = -1
      do k=1,npsp
        if (lmax.le.int_mb(lorb(1)+k-1)) lmax = int_mb(lorb(1)+k-1)
      end do

      do L=0,lmax

         call dcopy(2*npoints,0.0d0,0,dbl_mb(dstates(1)),1)
         do nbq=1,nbrillq
            A_shift   = cpsi_data_get_chnk(A_tag,nbq)
            eig_shift = cpsi_data_get_chnk(eig_tag,nbq)
            call dcopy(2*36*nion*nemax,dbl_mb(A_shift),1,
     >                                   dcpl_mb(a(1)),1)
            call dcopy(nemax,0.0d0,0,dbl_mb(weight(1)),1)
            if (.not.fixatoms) then
               DO I=1,nion
               DO SPIN=1,ISPIN
               DO N=N1(SPIN),N2(SPIN)
               if (L.le.int_mb(lorb(1)+ion_katm_qm(I)-1)) then
                 L1=L**2+1
                 L2=(L+1)**2
                 dbl_mb(weight(1)+n-1)=
     >           dbl_mb(weight(1)+n-1)+
     >           ddot(2*(L2-L1+1),
     >                dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >                dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
c                 DO LL=L1,L2
c                   dbl_mb(weight(1)+n-1)=
c     >             dbl_mb(weight(1)+n-1)+
c     >             dbl_mb(A(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c                 END DO
               end if
               END DO
               END DO
               END DO
            else
               DO j=1,nactive_atoms
               I=int_mb(l_actlist+j-1)
               DO SPIN=1,ISPIN
               DO N=N1(SPIN),N2(SPIN)
                if (L.le.int_mb(lorb(1)+ion_katm_qm(I)-1)) then
                  L1=L**2+1
                  L2=(L+1)**2
                  dbl_mb(weight(1)+n-1)=
     >            dbl_mb(weight(1)+n-1)+
     >            ddot(2*(L2-L1+1),
     >                 dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >                 dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
c                  DO LL=L1,L2
c                    dbl_mb(weight(1)+n-1)=
c     >              dbl_mb(weight(1)+n-1)+
c     >              dbl_mb(A(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c                  END DO
                end if
               END DO
               END DO
               END DO
            end if
            if (ispin.eq.1) then
              call adddensityofstates(
     >                    dbl_mb(eig_shift),dbl_mb(weight(1)),ne(1),
     >                    brillioun_weight(nbq),alpha,npoints,emin,emax,
     >                    dbl_mb(dstates(1)))
            end if
            if (ispin.eq.2) then
              call adddensityofstates(
     >                    dbl_mb(eig_shift),dbl_mb(weight(1)),ne(1),
     >                    brillioun_weight(nbq),alpha,npoints,emin,emax,
     >                    dbl_mb(dstates(1)))
              call adddensityofstates(
     >                  dbl_mb(eig_shift+ne(1)),
     >                  dbl_mb(weight(1)+ne(1)),ne(2),
     >                 -brillioun_weight(nbq),alpha,npoints,emin,emax,
     >                   dbl_mb(dstates(1)+npoints))
            end if
         end do
         call K1dB_Vector_SumAll(2*npoints,dbl_mb(dstates(1)))
c
         if (ispin.eq.1) then
           if (flag.eq.0) filename = "mulliken_dos_both_"//spdf_name(l)
           if (flag.eq.1) filename = "mulliken_vdos_both_"//spdf_name(l)
           call writedensityofstates(filename,
     >                     1.0d0,alpha,npoints,emin,emax,
     >                     dbl_mb(dstates(1)))
         end if
         if (ispin.eq.2) then
           if (flag.eq.0) filename= "mulliken_dos_alpha_"//spdf_name(l)
           if (flag.eq.1) filename= "mulliken_vdos_alpha_"//spdf_name(l)
           call writedensityofstates(filename,
     >                     1.0d0,alpha,npoints,emin,emax,
     >                     dbl_mb(dstates(1)))
           if (flag.eq.0) filename = "mulliken_dos_beta_"//spdf_name(l)
           if (flag.eq.1) filename = "mulliken_vdos_beta_"//spdf_name(l)
           call writedensityofstates(filename,
     >               -1.0d0,alpha,npoints,emin,emax,
     >                dbl_mb(dstates(1)+npoints))
         end if
      end do

*     **** combined angular momentum decomposition *****
         call dcopy(2*npoints,0.0d0,0,dbl_mb(dstates(1)),1)
         do nbq=1,nbrillq
            A_shift   = cpsi_data_get_chnk(A_tag,nbq)
            eig_shift = cpsi_data_get_chnk(eig_tag,nbq)
            call dcopy(2*36*nion*nemax,dbl_mb(A_shift),1,
     >                                   dcpl_mb(a(1)),1)
            call dcopy(nemax,0.0d0,0,dbl_mb(weight(1)),1)
            if (.not.fixatoms) then
            DO I=1,nion
            DO SPIN=1,ISPIN
            DO N=N1(SPIN),N2(SPIN)
            DO L=0,int_mb(lorb(1)+ion_katm_qm(I)-1)
              L1=L**2+1
              L2=(L+1)**2
              dbl_mb(weight(1)+n-1)=
     >        dbl_mb(weight(1)+n-1)+
     >        ddot(2*(L2-L1+1),
     >             dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >             dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
c              DO LL=L1,L2
c                dbl_mb(weight(1)+n-1)=
c     >          dbl_mb(weight(1)+n-1)+
c     >          dbl_mb(A(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c              END DO
            END DO
            END DO
            END DO
            END DO
            else
            DO j=1,nactive_atoms
            I=int_mb(l_actlist+j-1)
            DO SPIN=1,ISPIN
            DO N=N1(SPIN),N2(SPIN)
            DO L=0,int_mb(lorb(1)+ion_katm_qm(I)-1)
              L1=L**2+1
              L2=(L+1)**2
              dbl_mb(weight(1)+n-1)=
     >        dbl_mb(weight(1)+n-1)+
     >        ddot(2*(L2-L1+1),
     >             dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >             dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
c              DO LL=L1,L2
c                dbl_mb(weight(1)+n-1)=
c     >          dbl_mb(weight(1)+n-1)+
c     >          dbl_mb(A(1)+LL-1+(N-1)*36+(I-1)*36*nemax)**2
c              END DO
            END DO
            END DO
            END DO
            END DO
            end if
            if (ispin.eq.1) then
              call adddensityofstates(
     >                    dbl_mb(eig_shift),dbl_mb(weight(1)),ne(1),
     >                    brillioun_weight(nbq),alpha,npoints,emin,emax,
     >                    dbl_mb(dstates(1)))
            end if
            if (ispin.eq.2) then
              call adddensityofstates(
     >                    dbl_mb(eig_shift),dbl_mb(weight(1)),ne(1),
     >                    brillioun_weight(nbq),alpha,npoints,emin,emax,
     >                    dbl_mb(dstates(1)))
              call adddensityofstates(
     >                   dbl_mb(eig_shift+ne(1)),
     >                   dbl_mb(weight(1)+ne(1)),ne(2),
     >                  -brillioun_weight(nbq),alpha,npoints,emin,emax,
     >                   dbl_mb(dstates(1)+npoints))
            end if
         end do
         call K1dB_Vector_SumAll(2*npoints,dbl_mb(dstates(1)))

         if (ispin.eq.1) then
           if (flag.eq.0) filename = "mulliken_dos_both_all"
           if (flag.eq.1) filename = "mulliken_vdos_both_all"
           call writedensityofstates(filename,
     >                     1.0d0,alpha,npoints,emin,emax,
     >                     dbl_mb(dstates(1)))
         end if
         if (ispin.eq.2) then
           if (flag.eq.0) filename = "mulliken_dos_alpha_all"
           if (flag.eq.1) filename = "mulliken_vdos_alpha_all"
           call writedensityofstates(filename,
     >                     1.0d0,alpha,npoints,emin,emax,
     >                     dbl_mb(dstates(1)))
           if (flag.eq.0) filename = "mulliken_dos_beta_all"
           if (flag.eq.1) filename = "mulliken_vdos_beta_all"
           call writedensityofstates(filename,
     >               -1.0d0,alpha,npoints,emin,emax,
     >                dbl_mb(dstates(1)+npoints))
         end if


*     *** free heap ***
      if(fixatoms) then
        if (.not. MA_free_heap(h_actlist))
     >   call errquit('h_actlist:error freeing heap memory',0, MA_ERR)
      end if

      value =           MA_pop_stack(dstates(2))
      value = value.and.MA_pop_stack(weight(2))
      if (.not. value)
     >  call errquit('analysis: error freeing stack',0, MA_ERR)

      end if !*** control_DOS ***


*     **** free heap space ****
 1901 continue
      call borbs_end()
      call cpsi_data_dealloc(A_tag)
      call cpsi_data_dealloc(sum_tag)
      value = MA_free_heap(a(2))
      value = value.and.MA_free_heap(sum(2))
      value = value.and.MA_free_heap(eig(2))
      value = value.and.MA_free_heap(lorb(2))
      value = value.and.MA_free_heap(b0(2))
      value = value.and.MA_free_heap(total(2))
      value = value.and.MA_free_heap(subtl(2))
      if (.not. value)
     >  call errquit('analysis: error freeing heap',0,MA_ERR)

      return
      end
 


*     *********************************************************
*     *                                                       *
*     *             band_projecteddos_analysis                *
*     *                                                       *
*     *********************************************************
*
*    Used by band_structure code to calculate projected density of states.
*    Calculates the projected weights, pweight, for each of the orbitals
*
*     pweight(ne(1)+ne(2),nbrillq,l) - weight for each orbital for each
*                                      angular momenentum.
*
      subroutine band_projecteddos_analysis(flag,rtdb,ispin,ne,
     >                         nbrillq,psi_tag,
     >                         pweight,lmax)
      implicit none
      integer flag
      integer rtdb
      integer ispin,ne(2),nbrillq
      integer psi_tag
      real*8 pweight(ne(1)+ne(2),nbrillq,*)
      integer lmax

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"

*     **** parallel variables ****
      integer  taskid,taskid_k
      integer  MASTER
      parameter(MASTER=0)

*     **** electronic variables ****
      integer npack1
      integer n1(2),n2(2)
    
*     **** local variables ****
      integer i,k,l,n,ms,l1,l2,j,nbq,nb,pk
      integer ll,spin,ind
      real*8  ttl1,ttl2,subttl

      integer h_actlist,l_actlist,nactive_atoms,ma_type
      integer npoints,ii
      real*8 lmbda,rcut,bweight,kvec(3),ksvec(3)

      logical value,fixatoms
      character*28 DD
      character*255 id,test
      integer npsp,nion,nemax
      integer lorb(2)    ! integer lorb(npsp)
      integer b0(2)      ! real*8 b0(0:5,npsp)
      integer total(2)   ! real*8 total(nion)
      integer subtl(2)   ! real*8 subtl(0:5,3)
      integer a(2)       ! real*8 a(36,nemax,nion)
      integer sum(2)     ! real*8 sum(nemax)
      integer eig(2)     ! real*8 sum(nemax)
      integer A_tag,sum_tag
      integer A_shift,sum_shift,psi_shift
 
      character*4 spn(2)
      DATA SPN / 'UP  ', 'DOWN' /


*     **** external functions ****
      logical  control_DOS,nwpw_filefind
      logical  borbs_init,borbs_readall
      external control_DOS,nwpw_filefind
      external borbs_init,borbs_readall
      character   spdf_name
      external    spdf_name
      character*4 ion_atom_qm
      external    ion_atom_qm
      integer  ion_nion_qm,ion_katm_qm,ion_nkatm_qm
      external ion_nion_qm,ion_katm_qm,ion_nkatm_qm
      real*8   ion_rion
      external ion_rion
      real*8      lattice_omega,lattice_ecut,lattice_unita
      external    lattice_omega,lattice_ecut,lattice_unita
      real*8   borbs_rcut,borbs_lmbda,ddot,brillioun_weight
      external borbs_rcut,borbs_lmbda,ddot,brillioun_weight
      real*8   brillioun_weight_brdcst
      external brillioun_weight_brdcst
      real*8   brillioun_k_brdcst,brillioun_ks_brdcst
      external brillioun_k_brdcst,brillioun_ks_brdcst
      integer  cpsi_data_alloc,cpsi_data_get_chnk
      external cpsi_data_alloc,cpsi_data_get_chnk


      call Parallel_taskid(taskid)
      call Parallel3d_taskid_k(taskid_k)
      call Cram_max_npack(npack1)

      npsp = ion_nkatm_qm()
      nion = ion_nion_qm()
      nemax = ne(1)+ne(2)

      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1)+1
      n2(2) = ne(1)+ne(2)

      value = MA_alloc_get(mt_int,npsp,'lorb',lorb(2),lorb(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,6*npsp,'b0',b0(2),b0(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,nion,'total',total(2),total(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,6*3,'subtl',subtl(2),subtl(1))

      value = value.and.
     >        MA_alloc_get(mt_dcpl,36*nemax*nion,'a',a(2),a(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,nemax,'sum',sum(2),sum(1))

      A_tag   = cpsi_data_alloc(nbrillq,2*36*nemax*nion,1)
      sum_tag = cpsi_data_alloc(nbrillq,nemax,1)


*      ***********************************************
*      **** always generate new borb files        ****
*      ***********************************************
       do k=1,npsp
         DD = '                          '
         DD = ion_atom_qm(k)
         ind = index(DD,' ') - 1
         test = DD(1:ind)//'.psp1'
         id   = DD(1:ind)//'.borb'
         call control_mullikenparameters(ion_atom_qm(k),rcut,lmbda)
         call borbs_formatter_auto(ion_atom_qm(k),rcut,lmbda)
       end do

*      ****************************************
*      **** read in expansion coefficients ****
*      ****************************************
       do k=1,npsp
          id = 'analysis:lorb'//ion_atom_qm(k)
          if (.not. rtdb_get(rtdb,id,mt_int,1,int_mb(lorb(1)+k-1))) then
            DD = '                          '
            DD = ion_atom_qm(k)
            ind = index(DD,' ') - 1
            test = DD(1:ind)//'.psp1'

            !write(*,*) "test:",test,ind
            value = rtdb_parallel(.false.)
            if (taskid.eq.MASTER) then
            ind = index(test,' ') - 1
            !write(*,*) "test:",test,ind
            call analysis_expansion_coef(test,-1,rtdb)
            end if
            value = rtdb_parallel(.true.)
            call ga_sync()

            if (.not. rtdb_get(rtdb,id,mt_int,1,int_mb(lorb(1)+k-1)))
     >        call errquit(
     >        'analysis: rtdb_get lorb failed', 0, RTDB_ERR)
          end if

          id = 'analysis:expansion'//ion_atom_qm(k)
          if (.not. rtdb_get(rtdb,id,mt_dbl,(int_mb(lorb(1)+k-1)+1),
     >                                  dbl_mb(b0(1)+(k-1)*6))) then
            DD = '                          '
            DD = ion_atom_qm(k)
            ind = index(DD,' ') -1
            test = DD(1:ind)//'.psp1'
            call analysis_expansion_coef(test,-1,rtdb)

            if (.not. rtdb_get(rtdb,id,mt_dbl,(int_mb(lorb(1)+k-1)+1),
     >                                       dbl_mb(b0(1)+(k-1)*6)))
     >       call errquit(
     >       'analysis: rtdb_get failed', 0, RTDB_ERR)
          end if
       end do


      value = borbs_init()
      value = value.and.borbs_readall()
      if (.not.value) go to 1901

      value = .true.
      do k=1,npsp
         call control_mullikenparameters(ion_atom_qm(k),rcut,lmbda)
         if ((dabs(borbs_rcut(k)-rcut).gt.1.0d-6).or.
     >       (dabs(borbs_lmbda(k)-lmbda).gt.1.0d-6)) then
            call borbs_formatter_auto(ion_atom_qm(k),rcut,lmbda)
            value = .false.
         end if
      end do
      if (.not.value) value = borbs_readall()
      if (.not.value) go to 1901


      do nbq=1,nbrillq
        psi_shift = cpsi_data_get_chnk(psi_tag,nbq)
        A_shift   = cpsi_data_get_chnk(A_tag,nbq)
        sum_shift = cpsi_data_get_chnk(sum_tag,nbq)

        call Orb_pop_borb(0,nbq,ispin,ne,
     >                  npack1,nemax,dbl_mb(psi_shift),
     >                  int_mb(lorb(1)),
     >                  dbl_mb(A_shift),dbl_mb(sum_shift))
      end do

 
*     **** explicit number of atoms have been requested ****
      fixatoms = .false.
      if (rtdb_ma_get(rtdb, 'nwpw:dos:actlist', ma_type,
     >        nactive_atoms, h_actlist)) then

         if (.not.MA_get_index(h_actlist,l_actlist))
     >      call errquit(
     >       'analysis: ma_get_index failed for actlist',911,
     &       MA_ERR)

           fixatoms = .true.
      end if

*     **** angular momentum decomposition *****
      lmax = -1
      do k=1,npsp
        if (lmax.le.int_mb(lorb(1)+k-1)) lmax = int_mb(lorb(1)+k-1)
      end do

      call dcopy((lmax+1)*(ne(1)+ne(2))*nbrillq,0.0d0,0,pweight,1)
      do L=0,lmax

         do nbq=1,nbrillq
            A_shift   = cpsi_data_get_chnk(A_tag,nbq)
            call dcopy(2*36*nion*nemax,dbl_mb(A_shift),1,
     >                                   dcpl_mb(a(1)),1)
            if (.not.fixatoms) then
               DO I=1,nion
               DO SPIN=1,ISPIN
               DO N=N1(SPIN),N2(SPIN)
               if (L.le.int_mb(lorb(1)+ion_katm_qm(I)-1)) then
                 L1=L**2+1
                 L2=(L+1)**2
                 pweight(n,nbq,L+1) = pweight(n,nbq,L+1) +
     >           ddot(2*(L2-L1+1),
     >                dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >                dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
               end if
               END DO
               END DO
               END DO
            else
               DO j=1,nactive_atoms
               I=int_mb(l_actlist+j-1)
               DO SPIN=1,ISPIN
               DO N=N1(SPIN),N2(SPIN)
                if (L.le.int_mb(lorb(1)+ion_katm_qm(I)-1)) then
                  L1=L**2+1
                  L2=(L+1)**2
                  pweight(n,nbq,L+1) = pweight(n,nbq,L+1) + 
     >            ddot(2*(L2-L1+1),
     >                 dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1,
     >                 dcpl_mb(a(1)+L1-1+(N-1)*36+(I-1)*36*nemax),1)
                end if
               END DO
               END DO
               END DO
            end if
         end do
      end do


*     *** free heap ***
      if(fixatoms) then
        if (.not. MA_free_heap(h_actlist))
     >   call errquit('h_actlist:error freeing heap memory',0, MA_ERR)
      end if


*     **** free heap space ****
 1901 continue
      call borbs_end()
      call cpsi_data_dealloc(A_tag)
      call cpsi_data_dealloc(sum_tag)

      value = MA_free_heap(a(2))
      value = value.and.MA_free_heap(sum(2))
      value = value.and.MA_free_heap(lorb(2))
      value = value.and.MA_free_heap(b0(2))
      value = value.and.MA_free_heap(total(2))
      value = value.and.MA_free_heap(subtl(2))
      if (.not. value)
     >  call errquit('analysis: error freeing heap',0,MA_ERR)

      return
      end
 

      subroutine smd_coulomb_compute()
      implicit none

#include "inp.fh"
#include "mafdecls.fh"
#include "smd_system.fh"
#include "stdio.fh"
#include "errquit.fh"
c
      character*30 pname
      logical operiodic
c
      pname = "smd_coulomb"
c      write(*,*) "in "//pname
c
      operiodic = smd_system_periodic()

c
c     NOTE THAT UPDATED VERLET LISTS
c     ARE REQUIRED
c     -----------------------------
      if(operiodic) then
        call smd_ewald_self()
        call smd_ewald_recip()
        call smd_ewald_excl()
        call smd_ewald_real()
      else
        call errquit("non periodic conditions not implemented",0,0)
      end if
      return
      END
c $Id: smd_coulomb.F 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE OFFSET_ccsdtq_lambda1_15_1(l_a_offset,k_a_offset,size)
C     $Id: OFFSET_ccsdtq_lambda1_15_1.F 19700 2010-10-29 17:11:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 h14 h12 h13 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h2b
      INTEGER h14b
      INTEGER h12b
      INTEGER h13b
      length = 0
      DO h2b = 1,noab
      DO h14b = 1,noab
      DO h12b = 1,noab
      DO h13b = h12b,noab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+
     &h12b-1)+int_mb(k_spin+h13b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb
     &(k_sym+h12b-1),int_mb(k_sym+h13b-1)))) .eq. ieor(irrep_y,irrep_t))
     & THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h14b-
     &1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h13b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lambda1_15_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h2b = 1,noab
      DO h14b = 1,noab
      DO h12b = 1,noab
      DO h13b = h12b,noab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+
     &h12b-1)+int_mb(k_spin+h13b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb
     &(k_sym+h12b-1),int_mb(k_sym+h13b-1)))) .eq. ieor(irrep_y,irrep_t))
     & THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h14b-
     &1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h13b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h13b - 1 + noab * (h12b - 1 + noab * (h1
     &4b - 1 + noab * (h2b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h2b-1) * int_mb(k_range+h14b-1) * int
     &_mb(k_range+h12b-1) * int_mb(k_range+h13b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

C$PRAGMA SUN OPT=2
      subroutine tabgen
c $Id: tabgen.f 19696 2010-10-29 16:53:42Z d3y133 $
c
c        *****  computes and tabulates f0(x) to f5(x)           *****
c        *****  in range x = -0.24 to x = 26.4                  *****
c        *****  in units of x = 0.08                            *****
c        *****  the two electron integral sp routines           *****
c        *****  the table is generated only once for each entry *****
c
      implicit none
      double precision c, ppp(350)
      common/tabint/ c(1000,6)
      double precision pt184, pt5, six, tenm7, four, two, done, pt886
      integer mm, l, i, m, j, notrms
      double precision q, qqq, a, term, ptlsum, b, temp1, temp2
      double precision approx, fimult, fiprop
      data pt184,pt5/ 0.184d0,0.50d0/
      data six,tenm7/6.0d0,1.0d-20 /
      data four,two,done/4.0d0,2.0d0,1.0d0/
      data pt886/0.8862269254527d0/
c
      q=-done
      do 30 mm=1,6
      m=mm-1
      q=q+done
      qqq = -0.24d0
      do 20 i=1,340
      qqq = qqq+0.08d0
      a=q
c        *****  change limit of approximate solution.           *****
      if(qqq-15.0d0) 1,1,10
    1 a=a+pt5
      term=done/a
      ptlsum=term
      do 2 l=2,50
      a=a+done
      term=term*qqq/a
      ptlsum=ptlsum+term
      if( dabs(term/ptlsum)-tenm7)3,2,2
    2 continue
    3 ppp(i)=pt5*ptlsum* dexp(-qqq)
      go to 20
   10 b=a+pt5
      a=a-pt5
      approx=pt886/(dsqrt(qqq)*qqq**m)
      if(m.eq.0) go to 13
      do 12 l=1,m
      b=b-done
   12 approx=approx*b
   13 fimult=pt5* dexp(-qqq)/qqq
      fiprop=fimult/approx
      term=done
      ptlsum=term
      notrms=qqq
      notrms=notrms+m
      do 14 l=2,notrms
      term=term*a/qqq
      ptlsum=ptlsum+term
      if( dabs(term*fiprop/ptlsum)-tenm7)15,15,14
   14 a=a-done
   15 ppp(i)=approx-fimult*ptlsum
   20 continue
      do 30 i=1,333
      j=i+2
      c(i,mm)=ppp(j)
      c(i+333,mm)=ppp(j+1)-ppp(j)
      temp1=-two*ppp(j)+ppp(j+1)+ppp(j-1)
      temp2=six*ppp(j)-four*ppp(j+1)-four*ppp(j-1)+ppp(j-2)+ppp(j+2)
   30 c(i+666,mm) = (temp1-pt184*temp2)/six
      return
      end

      subroutine cf_alpha
c $Id: cf_grid.F 23500 2013-01-26 19:15:27Z d3j191 $
      implicit none
c
#include "cf_common.fh"
#include "cf_funcs_dec.fh"
c
      real*8 a,alow,ahigh,b
      integer i,n
c
#include "cf_funcs_sfn.fh"
c
      a=half
      i=0
    1 continue
      a=two*a
      i=i+1
      b=(erfc(a*rlong))/rlong
      if(b.ge.pmetol) goto 1
c
      n=i+60
      alow=zero
      ahigh=a
      do 2 i=1,n
      a=half*(alow+ahigh)
      b=(erfc(a*rlong))/rlong
      if(b.ge.pmetol) then
      alow=a
      else
      ahigh=a
      endif
    2 continue
      ealpha=a
c
      return
      end
      subroutine cf_chgrid(lset,ipset,xw,nwmloc,xs,isq,isgm,nsaloc,
     + grid,mgz,lgrid,knode,kfrom,lsldo,node,mnx,mxx,mny,mxy,mnz,mxz)
c
      implicit none
c
#include "cf_common.fh"
#include "mafdecls.fh"
c
      logical lset,lgrid
      integer ipset,nwmloc,nsaloc,node,mgz
      real*8 xw(mwm,3,mwa),xs(msa,3)
      integer isq(msa),isgm(msa)
      integer knode(*),kfrom(*)
      logical lsldo(*)
      real*8 grid(ngrx,ngry,mgz)
      integer mnx,mxx,mny,mxy,mnz,mxz
c
      if(lset.or..not.lscr) then
      if(.not.lscr) call cf_salloc
      call cf_pmeset(xw,dbl_mb(i_pmew),nwmloc,xs,dbl_mb(i_pmes),
     + nsaloc,dbl_mb(i_theta),dbl_mb(i_dtheta))
      lset=.false.
      endif
c
      call cf_grid(ipset,xw,dbl_mb(i_pmew),int_mb(i_iwq),nwmloc,
     + xs,dbl_mb(i_pmes),isq,isgm,nsaloc,
     + dbl_mb(i_chg),dbl_mb(i_theta),dbl_mb(i_dtheta),
     + grid,mgz,lgrid,knode,kfrom,lsldo,node,mnx,mxx,mny,mxy,mnz,mxz,
     + int_mb(i_lseq))
c
      return
      end
      subroutine cf_grid(ipset,xw,yw,iwq,nwmloc,xs,ys,isq,isgm,
     + nsaloc,chg,theta,dtheta,
     + grid,mgz,lgrid,knode,kfrom,lsldo,node,
     + minx,maxx,miny,maxy,minz,maxz,lseq)
c
      implicit none
c
#include "cf_common.fh"
c
      logical lgrid
      integer ipset,nwmloc,nsaloc,node,mgz
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 yw(mwm,3,mwa),ys(msa,3)
      integer iwq(mwa),isq(msa),isgm(msa),lseq(mseq)
      real*8 chg(mqt,mqp,mset),theta(morder,3,*),dtheta(morder,3,*)
      integer knode(np),kfrom(np)
      logical lsldo(np,*)
      real*8 grid(ngrx,ngry,mgz)
c
      integer i,i0,j,j0,k,k0,ith1,ith2,ith3,isa,iwm,iwa,indx
      integer minx,miny,minz,maxx,maxy,maxz
      real*8 prod,charge
c
      do 1 k=1,mgz
      do 21 j=1,ngry
      do 31 i=1,ngrx
      grid(i,j,k)=zero
   31 continue
   21 continue
    1 continue
      lgrid=.false.
      indx=0
c
      minx=ngrx
      miny=ngry
      minz=mgz
      maxx=1
      maxy=1
      maxz=1
c
      do 2 iwa=1,mwa
      do 3 iwm=1,nwmloc
      indx=indx+1
      k0=int(yw(iwm,3,iwa))-morder
      do 4 ith3=1,morder
      k0=k0+1
      k=k0+1+(ngz-isign(ngz,k0))/2
      if(k.gt.ngz) k=k-ngz
      if(k.lt.1) k=k+ngz
      if(knode(k).eq.node) then
      lgrid=.true.
      k=k-kfrom(node+1)+1
      j0=int(yw(iwm,2,iwa))-morder
      if(k.lt.minz) minz=k
      if(k.gt.maxz) maxz=k
      lsldo(node+1,k)=.true.
      do 5 ith2=1,morder
      j0=j0+1
      j=j0+1+(ngy-isign(ngy,j0))/2
      miny=min(miny,j)
      maxy=max(maxy,j)
c      j=j0+1+(ngy-isign(ngy,j0))/2
c      if(j.gt.ngy) j=j-ngy
c      if(j.lt.1) j=j+ngy
      prod=theta(ith2,2,indx)*theta(ith3,3,indx)*chg(iwq(iwa),1,ipset)
      i0=int(yw(iwm,1,iwa))-morder
c      if(j.lt.miny) miny=j
c      if(j.gt.maxy) maxy=j
      do 6 ith1=1,morder
      i0=i0+1
      i=i0+1+(ngx-isign(ngx,i0))/2
      minx=min(minx,i)
      maxx=max(maxx,i)
c      i=i0+1+(ngx-isign(ngx,i0))/2
c      if(i.gt.ngx) i=i-ngx
c      if(i.lt.1) i=i+ngx
c      if(i.lt.minx) minx=i
c      if(i.gt.maxx) maxx=i
      grid(i,j,k)=grid(i,j,k)+theta(ith1,1,indx)*prod
    6 continue
    5 continue
      endif
    4 continue
    3 continue
    2 continue
c
      if(isolvo.eq.0) then
      do 7 isa=1,nsaloc
      if(nfhop.eq.0) then
      charge=chg(isq(isa),1,ipset)
      else
      charge=chg(isq(isa),1,lseq(isgm(isa)))
      endif
c      write(*,'(2i5,f12.5)') isa,isgm(isa),charge
      indx=indx+1
      k0=int(ys(isa,3))-morder
      do 8 ith3=1,morder
      k0=k0+1
      k=k0+1+(ngz-isign(ngz,k0))/2
      if(knode(k).eq.node) then
      lgrid=.true.
      k=k-kfrom(node+1)+1
      j0=int(ys(isa,2))-morder
      if(k.lt.minz) minz=k
      if(k.gt.maxz) maxz=k
      lsldo(node+1,k)=.true.
      do 9 ith2=1,morder
      j0=j0+1
      j=j0+1+(ngy-isign(ngy,j0))/2
      miny=min(miny,j)
      maxy=max(maxy,j)
c      j=j0+1+(ngy-isign(ngy,j0))/2
c      if(j.gt.ngy) j=j-ngy
c      if(j.lt.1) j=j+ngy
      prod=theta(ith2,2,indx)*theta(ith3,3,indx)*charge
      i0=int(ys(isa,1))-morder
c      if(j.lt.miny) miny=j
c      if(j.gt.maxy) maxy=j
      do 10 ith1=1,morder
      i0=i0+1
      i=i0+1+(ngx-isign(ngx,i0))/2
      minx=min(minx,i)
      maxx=max(maxx,i)
c      i=i0+1+(ngx-isign(ngx,i0))/2
c      if(i.gt.ngx) i=i-ngx
c      if(i.lt.1) i=i+ngx
c      if(i.lt.minx) minx=i
c      if(i.gt.maxx) maxx=i
      grid(i,j,k)=grid(i,j,k)+theta(ith1,1,indx)*prod
   10 continue
    9 continue
      endif
    8 continue
    7 continue
      endif
c
      return
      end
      subroutine cf_pmeset(xw,yw,nwmloc,xs,ys,nsaloc,theta,dtheta)
c
      implicit none
c
#include "cf_common.fh"
c
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 cf_anint
      external cf_anint
#endif
c
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 yw(mwm,3,mwa),ys(msa,3)
      real*8 theta(morder,3,*),dtheta(morder,3,*)
      integer nwmloc,nsaloc
c
      integer i,j,iwa,ix,iwm,isa,indx,ng(3)
      real*8 w,rinv
c
      if(nbxtyp.ne.1) then
      do 1 i=1,3
      do 2 j=1,3
      recip(i,j)=zero
    2 continue
      recip(i,i)=one/box(i)
    1 continue
      else
      do 3 i=1,3
      do 4 j=1,3
      recip(i,j)=vlati(i,j)
    4 continue
    3 continue
      endif
c
c     calculate scaled fractional coordinates
c
      ng(1)=ngx
      ng(2)=ngy
      ng(3)=ngz
      do 5 iwa=1,mwa
      do 6 ix=1,3
      do 7 iwm=1,nwmloc
      w=xw(iwm,1,iwa)*recip(1,ix)+xw(iwm,2,iwa)*recip(2,ix)+
     + xw(iwm,3,iwa)*recip(3,ix)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      yw(iwm,ix,iwa)=dble(ng(ix))*(w-cf_anint(w)+half)
#else
      yw(iwm,ix,iwa)=dble(ng(ix))*(w-anint(w)+half)
#endif
    7 continue
    6 continue
    5 continue
c
      do 8 ix=1,3
      do 9 isa=1,nsaloc
      w=xs(isa,1)*recip(1,ix)+xs(isa,2)*recip(2,ix)+
     + xs(isa,3)*recip(3,ix)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      ys(isa,ix)=dble(ng(ix))*(w-cf_anint(w)+half)
#else
      ys(isa,ix)=dble(ng(ix))*(w-anint(w)+half)
#endif
    9 continue
    8 continue
c
c     spline coefficients
c
      indx=0
      do 10 iwa=1,mwa
      do 11 iwm=1,nwmloc
      indx=indx+1
      do 12 ix=1,3
      w=yw(iwm,ix,iwa)-int(yw(iwm,ix,iwa))
      theta(morder,ix,indx)=zero
      theta(2,ix,indx)=w
      theta(1,ix,indx)=one-w
      do 13 i=3,morder-1
      rinv=one/dble(i-1)
      theta(i,ix,indx)=rinv*w*theta(i-1,ix,indx)
      do 14 j=1,i-2
      theta(i-j,ix,indx)=rinv*((w+dble(j))*theta(i-j-1,ix,indx)+
     + (dble(i-j)-w)*theta(i-j,ix,indx))
   14 continue
      theta(1,ix,indx)=rinv*(one-w)*theta(1,ix,indx)
   13 continue
      dtheta(1,ix,indx)=-theta(1,ix,indx)
      do 15 j=2,morder
      dtheta(j,ix,indx)=theta(j-1,ix,indx)-theta(j,ix,indx)
   15 continue
      rinv=one/dble(morder-1)
      theta(morder,ix,indx)=rinv*w*theta(morder-1,ix,indx)
      do 16 j=1,morder-2
      theta(morder-j,ix,indx)=rinv*((w+dble(j))*
     + theta(morder-j-1,ix,indx)+
     + (dble(morder-j)-w)*theta(morder-j,ix,indx))
   16 continue
      theta(1,ix,indx)=rinv*(one-w)*theta(1,ix,indx)
   12 continue
   11 continue
   10 continue
c      
      do 17 isa=1,nsaloc
      indx=indx+1
      do 18 ix=1,3
      w=ys(isa,ix)-int(ys(isa,ix))
      theta(morder,ix,indx)=zero
      theta(2,ix,indx)=w
      theta(1,ix,indx)=one-w
      do 19 i=3,morder-1
      rinv=one/dble(i-1)
      theta(i,ix,indx)=rinv*w*theta(i-1,ix,indx)
      do 20 j=1,i-2
      theta(i-j,ix,indx)=rinv*((w+dble(j))*theta(i-j-1,ix,indx)+
     + (dble(i-j)-w)*theta(i-j,ix,indx))
   20 continue
      theta(1,ix,indx)=rinv*(one-w)*theta(1,ix,indx)
   19 continue
      dtheta(1,ix,indx)=-theta(1,ix,indx)
      do 21 j=2,morder
      dtheta(j,ix,indx)=theta(j-1,ix,indx)-theta(j,ix,indx)
   21 continue
      rinv=one/dble(morder-1)
      theta(morder,ix,indx)=rinv*w*theta(morder-1,ix,indx)
      do 22 j=1,morder-2
      theta(morder-j,ix,indx)=rinv*((w+dble(j))*
     + theta(morder-j-1,ix,indx)+
     + (dble(morder-j)-w)*theta(morder-j,ix,indx))
   22 continue
      theta(1,ix,indx)=rinv*(one-w)*theta(1,ix,indx)
   18 continue
   17 continue
c
      return
      end
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 function cf_anint(x)
      real*8 x
      cf_anint=anint(x)
      return
      end
#endif
      subroutine cf_epme(knode,kfrom,kto,bmod,grid,mgz,energy)
c
      implicit none
c
#include "cf_common.fh"
#include "msgids.fh"
c
      integer mgz
      integer knode(ngz),kfrom(np),kto(np)
      real*8 bmod(ngmax,3),grid(2,ngx,ngy,mgz),energy
c
      real*8 fac,rh1,rh2,rh3,rsq,efac,vfac,ss
      integer i,j,k,kg,m1,m2,m3
      integer ngxy,nfx,nfy,nfz
c
      fac=(pi/ealpha)**2
c
      ngxy=ngx*ngy
      nfx=ngx/2
      if(2*nfx.lt.ngx) nfx=nfx+1
      nfy=ngy/2
      if(2*nfy.lt.ngy) nfy=nfy+1
      nfz=ngz/2
      if(2*nfz.lt.ngz) nfz=nfz+1
c
      epme=zero
c
      if(kfrom(me+1).gt.0) then
      do 2 k=kfrom(me+1),kto(me+1)
      kg=k+1-kfrom(me+1)
c
      do 3 j=1,ngy
      do 4 i=1,ngx
      if(i+j+k.gt.3) then
c
      m1=i-1
      if(i.gt.nfx) m1=m1-ngx
      m2=j-1
      if(j.gt.nfy) m2=m2-ngy
      m3=k-1
      if(k.gt.nfz) m3=m3-ngz
c
      rh1=recip(1,1)*m1+recip(1,2)*m2+recip(1,3)*m3
      rh2=recip(2,1)*m1+recip(2,2)*m2+recip(2,3)*m3
      rh3=recip(3,1)*m1+recip(3,2)*m2+recip(3,3)*m3
      rsq=rh1*rh1+rh2*rh2+rh3*rh3
c
      efac=exp(-fac*rsq)/(pi*volume*bmod(i,1)*bmod(j,2)*bmod(k,3)*rsq)
      vfac=two*(fac*rsq+one)/rsq
      ss=grid(1,i,j,kg)**2+grid(2,i,j,kg)**2
c
      epme=epme+efac*ss
      vpme(1)=vpme(1)+efac*ss*(vfac*rh1*rh1-one)
      vpme(2)=vpme(2)+efac*ss*(vfac*rh1*rh2)
      vpme(3)=vpme(3)+efac*ss*(vfac*rh1*rh3)
      vpme(4)=vpme(4)+efac*ss*(vfac*rh2*rh2-one)
      vpme(5)=vpme(5)+efac*ss*(vfac*rh2*rh3)
      vpme(6)=vpme(6)+efac*ss*(vfac*rh3*rh3-one)
c
      grid(1,i,j,kg)=efac*grid(1,i,j,kg)
      grid(2,i,j,kg)=efac*grid(2,i,j,kg)
c
      endif
    4 continue
    3 continue
c
    2 continue
      endif
c
      energy=0.5d0*epme
c
      return
      end
      subroutine cf_fpme(fw,nwmloc,fs,isq,isgm,nsaloc,grid,mgz,
     + knode,kfrom,lsldo,node)
c
      implicit none
c
#include "cf_common.fh"
#include "mafdecls.fh"
c
      integer nwmloc,nsaloc,node,mgz
      real*8 fw(mwm,3,mwa),fs(msa,3)
      integer isq(msa),isgm(msa)
      integer knode(*),kfrom(*)
      logical lsldo(*)
      real*8 grid(ngrx,ngry,mgz)
c
      call cf_forpme(dbl_mb(i_pmew),fw,int_mb(i_iwq),nwmloc,
     + dbl_mb(i_pmes),fs,isq,isgm,nsaloc,
     + dbl_mb(i_chg),dbl_mb(i_theta),dbl_mb(i_dtheta),
     + grid,mgz,knode,kfrom,lsldo,node,int_mb(i_lseq))
c
      return
      end
      subroutine cf_forpme(yw,fw,iwq,nwmloc,ys,fs,isq,isgm,nsaloc,
     + chg,theta,dtheta,
     + grid,mgz,knode,kfrom,lsldo,node,lseq)
c
      implicit none
c
#include "cf_common.fh"
#include "mafdecls.fh"
c
      integer nwmloc,nsaloc,node,mgz
      real*8 yw(mwm,3,mwa),fw(mwm,3,mwa),ys(msa,3),fs(msa,3)
      integer iwq(mwa),isq(msa),isgm(msa),lseq(mseq)
      real*8 chg(mqt,mqp,mset),theta(morder,3,*),dtheta(morder,3,*)
      integer knode(*),kfrom(*)
      logical lsldo(*)
      real*8 grid(ngrx,ngry,mgz)
c
      integer i,i0,j,j0,k,k0,ith1,ith2,ith3,iwm,iwa,isa,indx
      real*8 term,fx,fy,fz,charge
c
      indx=0
c
      do 2 iwa=1,mwa
      do 3 iwm=1,nwmloc
      indx=indx+1
      fx=zero
      fy=zero
      fz=zero
      k0=int(yw(iwm,3,iwa))-morder
      do 4 ith3=1,morder
      k0=k0+1
      k=k0+1+(ngz-isign(ngz,k0))/2
      if(k.gt.ngz) k=k-ngz
      if(k.lt.1) k=k+ngz
      if(knode(k).eq.node) then
      k=k-kfrom(node+1)+1
      j0=int(yw(iwm,2,iwa))-morder
      do 5 ith2=1,morder
      j0=j0+1
      j=j0+1+(ngy-isign(ngy,j0))/2
      i0=int(yw(iwm,1,iwa))-morder
      do 6 ith1=1,morder
      i0=i0+1
      i=i0+1+(ngx-isign(ngx,i0))/2
      term=chg(iwq(iwa),1,iset)*grid(i,j,k)
      fx=fx-ngx*term*dtheta(ith1,1,indx)*theta(ith2,2,indx)*
     + theta(ith3,3,indx)
      fy=fy-ngy*term*dtheta(ith2,2,indx)*theta(ith3,3,indx)*
     + theta(ith1,1,indx)
      fz=fz-ngz*term*dtheta(ith3,3,indx)*theta(ith1,1,indx)*
     + theta(ith2,2,indx)
    6 continue
    5 continue
      endif
    4 continue
      fw(iwm,1,iwa)=fw(iwm,1,iwa)+recip(1,1)*fx+recip(1,2)*fy+
     + recip(1,3)*fz
      fw(iwm,2,iwa)=fw(iwm,2,iwa)+recip(2,1)*fx+recip(2,2)*fy+
     + recip(2,3)*fz
      fw(iwm,3,iwa)=fw(iwm,3,iwa)+recip(3,1)*fx+recip(3,2)*fy+
     + recip(3,3)*fz
    3 continue
    2 continue
c
      do 7 isa=1,nsaloc
      if(nfhop.eq.0) then
      charge=chg(isq(isa),1,iset)
      else
      charge=chg(isq(isa),1,lseq(isgm(isa)))
      endif
      indx=indx+1
      fx=zero
      fy=zero
      fz=zero
      k0=int(ys(isa,3))-morder
      do 8 ith3=1,morder
      k0=k0+1
      k=k0+1+(ngz-isign(ngz,k0))/2
      if(knode(k).eq.node) then
      k=k-kfrom(node+1)+1
      j0=int(ys(isa,2))-morder
      do 9 ith2=1,morder
      j0=j0+1
      j=j0+1+(ngy-isign(ngy,j0))/2
      i0=int(ys(isa,1))-morder
      do 10 ith1=1,morder
      i0=i0+1
      i=i0+1+(ngx-isign(ngx,i0))/2
      term=charge*grid(i,j,k)
      fx=fx-ngx*term*dtheta(ith1,1,indx)*theta(ith2,2,indx)*
     + theta(ith3,3,indx)
      fy=fy-ngy*term*dtheta(ith2,2,indx)*theta(ith3,3,indx)*
     + theta(ith1,1,indx)
      fz=fz-ngz*term*dtheta(ith3,3,indx)*theta(ith1,1,indx)*
     + theta(ith2,2,indx)
   10 continue
    9 continue
      endif
    8 continue
      fs(isa,1)=fs(isa,1)+recip(1,1)*fx+recip(1,2)*fy+recip(1,3)*fz
      fs(isa,2)=fs(isa,2)+recip(2,1)*fx+recip(2,2)*fy+recip(2,3)*fz
      fs(isa,3)=fs(isa,3)+recip(3,1)*fx+recip(3,2)*fy+recip(3,3)*fz
    7 continue
c
      return
      end
      subroutine cf_pmecor(ipset,xw,nwmloc,xs,isq,isgm,nsaloc,ecorr)
c
      implicit none
c
#include "cf_common.fh"
#include "mafdecls.fh"
c
      integer ipset,nwmloc,nsaloc
      real*8 xw(mwm,3,mwa),xs(msa,3),ecorr
      integer isq(msa),isgm(msa)
c
      call cf_pmec(ipset,xw,nwmloc,xs,isq,isgm,nsaloc,
     + ecorr,int_mb(i_iwq),dbl_mb(i_chg),int_mb(i_lseq))
c
      return
      end
      subroutine cf_pmec(ipset,xw,nwmloc,xs,isq,isgm,nsaloc,
     + ecorr,iwq,chg,lseq)
c
      implicit none
c
#include "cf_common.fh"
#include "mafdecls.fh"
c
      integer ipset,nwmloc,nsaloc
      real*8 xw(mwm,3,mwa),xs(msa,3),ecorr
      integer isq(msa),iwq(mwa),isgm(msa),lseq(mseq)
      real*8 chg(mqt,mqp,mset)
c
      integer i,icset
c
      ecorr=zero
c
      if(nwmloc.gt.0) then
      do 1 i=1,nwa
      ecorr=ecorr-chg(iwq(i),1,ipset)*chg(iwq(i),1,ipset)
    1 continue
      ecorr=ecorr*dble(nwmloc)
      endif
c
      if(nfhop.eq.0) then
      if(nsaloc.gt.0) then
      do 2 i=1,nsaloc
      ecorr=ecorr-chg(isq(i),1,ipset)*chg(isq(i),1,ipset)
    2 continue
      endif
      else
      do 3 i=1,nsaloc
      icset=lseq(isgm(i))
      ecorr=ecorr-chg(isq(i),1,icset)*chg(isq(i),1,icset)
    3 continue
      endif
c
      ecorr=ealpha*ecorr/sqrt(pi)
c
      return
      end

      subroutine argos_spi()
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
c
      external argos_space_rdtrj,argos_space_skip,frequency
      logical argos_space_rdtrj,argos_space_skip,frequency
c
      integer import
c
      if(impfr.gt.1) then
      if(.not.argos_space_skip(lfntri,impfr-1)) return
      endif
c
      do 1 import=impfr,impto
c
      if(.not.frequency(import+1-impfr,nftri)) then
      if(.not.argos_space_skip(lfntri,1)) return
      goto 1
      endif
c
      lpair=.true.
      lload=.true.
      lhop=.false.
      llong=ltwin
c
c     read frame from trajectory file
c
      if(.not.argos_space_rdtrj(lfntri,lxw,lvw,lfw,lxs,lvs,lfs,
     + stime,pres,temp,tempw,temps,
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_fw),
     + dbl_mb(i_xwcr),int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_fs),nwmloc,nsaloc)) return
c
c     center of mass coordinates
c
      call argos_cafe_cenmas(nwmloc,dbl_mb(i_xw),dbl_mb(i_xwm),nsaloc,
     + int_mb(i_is+(lsatt-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_gsm))
c
c     periodic boundary conditions
c
      call argos_fold(int_mb(i_iw),int_mb(i_is),
     + dbl_mb(i_xw),dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_xsm))
c
c     atom redistribution
c
      call argos_space_travel(box,dbl_mb(i_xw),dbl_mb(i_vw),
     + dbl_mb(i_xwcr),
     + dbl_mb(i_gw),int_mb(i_iw),nwmloc,dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_gs),int_mb(i_is),nsaloc)
c
      call argos_cafe_mass(dbl_mb(i_wws),dbl_mb(i_wws+mwa),
     + int_mb(i_is+(lsatt-1)*msa),nsaloc)
c
      call argos_eminit(dbl_mb(i_xw),dbl_mb(i_yw),
     + dbl_mb(i_xs),dbl_mb(i_ys))
c
c     atomic forces and potential energies
c
      call argos_finit(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs),
     + dbl_mb(i_xsm),dbl_mb(i_xsmp))
      call argos_forces(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs))
c
      call argos_prop_proper(import,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme,
     + epot,epotw,epotsw,epots,volume,dwr,dbl_mb(i_dsr),ekin,etot,
     + npolit,dbl_mb(i_gsm),dbl_mb(i_esa),box,dbl_mb(i_xsm))
c
      call argos_prop_step(import,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme)
c
cx      call argos_prop_print()
c
      call rtdb_put(irtdb,'md:energy',mt_dbl,1,epot)
c
c     print energies
c
      if(me.eq.0.and.frequency(import,npener))
     + call argos_cafe_print_energy(lfnout)
c      if(me.eq.0.and.frequency(import,nfprop)) call argos_prop_record()
c
      if(me.eq.0.and.frequency(import,npforc))
     + call argos_space_printf(filtop,lfntop,
     + int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_fs),npener,dbl_mb(i_esa))
c
      if(ifidi.ne.0) then
      call argos_fd(int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),dbl_mb(i_fs),
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_fw))
      endif
c
      if(itest.eq.1) call argos_test()
c
    1 continue
c
      return
      end
c $Id: argos_spi.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine ao_fock_2e( geom, basis, nfock, jfac, kfac,
     $     tol2e, oskel, vg_dens, vg_fock, asym)
c
c$Id: ao_fock_2e.F 24112 2013-04-22 20:04:36Z d3y133 $
c
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "schwarz.fh"
#include "cscfps.fh"
#include "cfock.fh"
#include "util.fh"
c
c  Distributed-data AO 2e-Fock construction routine
c
c      F(i) = jfac(i)*J[D(i)] + kfac(i)*K[D(i)]
c
c     arguments
c     
      integer geom, basis            ! [input] parameter handles
      integer nfock                  ! [input] number of Fock matrices
      double precision jfac(nfock)   ! [input] Coulomb prefactor
      double precision kfac(nfock)   ! [input] exchange prefactor
      double precision tol2e         ! [input] integral selection threshold
      logical oskel                  ! [input] toggle skeleton Fock matrix
      integer vg_dens(nfock)         ! [input] array of handles to densities
      integer vg_fock(nfock)         ! [output] array of handles to Fock matrices
      logical asym                   ! [input] flag to antisymmetrize the fock matrices
c     
c     local variables
c     
      integer natoms, maxd, ablklen, nshb, nbf, maxg, lenscr, nsh
      integer i, mem_rep
      integer l_dij, l_dik, l_dli, l_djk, l_dlj, l_dlk
      integer l_fij, l_fik, l_fli, l_fjk, l_flj, l_flk
      integer k_dij, k_dik, k_dli, k_djk, k_dlj, k_dlk
      integer k_fij, k_fik, k_fli, k_fjk, k_flj, k_flk
      integer l_atmp, k_atmp
      integer l_block, k_block, nblock, maxblock
      integer tdim
      parameter (tdim = 100000)
      logical status
      logical int2e_test_mem, int2e_buf_write, int2e_file_rewind
      external int2e_test_mem, int2e_buf_write, int2e_file_rewind
c
      if (.not. bas_numbf(basis, nbf)) call errquit
     $     ('ao_fock_2e: bas_numbf failed', 0, BASIS_ERR)
      if (.not. bas_numcont(basis, nsh)) call errquit
     $     ('ao_fock_2e: bas_numcont failed', 0, BASIS_ERR)
      if (.not. geom_ncent(geom, natoms)) call errquit
     $     ('ao_fock_2e: geom_ncent failed', 0, GEOM_ERR)
c
c     Default is replicated data.  This can be overridden by setting
c     'fock:replicated' as false.  It is also overriden here when the
c     replicated data algorithm would exceed memory requirements
c
      call intb_mem_2e4c(maxg, lenscr)
      mem_rep = nbf*nbf*2*nfock + nsh*nsh + maxquartet
     $        + ma_sizeof(MT_INT,4*maxquartet+nbf*(nbf+1),MT_DBL)
     $        + nbf*(nbf+1)/2
     $        + ma_sizeof(MT_INT,2*tdim,MT_DBL) 
     $        + 8*ma_sizeof_overhead(MT_DBL)
      if (owritefile) mem_rep = mem_rep + max(0,memsize)
      if (owritefile .or. (.not. (owritefile .or. oreadfile)))
     $      mem_rep = mem_rep + maxeri*5 + lenscr
      if (oreplicated) then
         oreplicated = (mem_rep .lt. ma_inquire_avail(mt_dbl))
      endif
c
      if (oreplicated) then
         call ao_replicated( geom, basis, nfock, jfac, kfac,
     $        tol2e, oskel, vg_dens, vg_fock, asym )
         return
      endif
c     
c     allocate necessary local temporary arrays on the stack
c     
c     l_scr ... workspace for integral routines
c     l_d** ... ** block of density matrix
c     l_f** ... ** block of fock matrix
c     
c     k_* are the offsets corrsponding to the l_* handles
c
c     If reading/writing to/from cache/file then rewind
c
      if (oreadfile .or. owritefile) then
         if (.not. int2e_file_rewind()) call errquit
     $        ('ao_fock_2e: failed rewinding integral file',0,
     &       UNKNOWN_ERR)
      endif
c
c     Halve exchange factor to conform to internal definition
c
      call dscal(nfock, 0.5d0, kfac, 1)
c
c     Determine appropriate task chunking and max no. of bf in a
c     block of the density/fock matrix
c
      if (.not. geom_ncent(geom, natoms)) call errquit
     $     ('ao_fock_2e: geom_ncent failed', 0, GEOM_ERR)
      if (.not. ma_push_get(MT_INT, 2*natoms, 'fock2e:block',
     $     l_block, k_block))call errquit('fock_2e: ma failed',2*natoms,
     &       MA_ERR)
      call fock_2e_block_atoms(basis, oskel, tol2e,
     $     int_mb(k_block), nblock, maxblock)
c
      ablklen = maxblock**2
      maxd = nfock*ablklen
c     
      status = .true.
      status = status .and. ma_push_get(MT_DBL, maxd, 'dij',
     $     l_dij, k_dij)
      status = status .and. ma_push_get(MT_DBL, maxd, 'dik',
     $     l_dik, k_dik)
      status = status .and. ma_push_get(MT_DBL, maxd, 'dli',
     $     l_dli, k_dli)
      status = status .and. ma_push_get(MT_DBL, maxd, 'djk',
     $     l_djk, k_djk)
      status = status .and. ma_push_get(MT_DBL, maxd, 'dlj',
     $     l_dlj, k_dlj)
      status = status .and. ma_push_get(MT_DBL, maxd, 'dlk',
     $     l_dlk, k_dlk)
      status = status .and. ma_push_get(MT_DBL, maxd, 'fij',
     $     l_fij, k_fij)
      status = status .and. ma_push_get(MT_DBL, maxd, 'fik',
     $     l_fik, k_fik)
      status = status .and. ma_push_get(MT_DBL, maxd, 'fli',
     $     l_fli, k_fli)
      status = status .and. ma_push_get(MT_DBL, maxd, 'fjk',
     $     l_fjk, k_fjk)
      status = status .and. ma_push_get(MT_DBL, maxd, 'flj',
     $     l_flj, k_flj)
      status = status .and. ma_push_get(MT_DBL, maxd, 'flk',
     $     l_flk, k_flk)
      status = status .and. ma_push_get(MT_DBL, ablklen, 'atmp',
     $     l_atmp, k_atmp)
      if (.not. status) call errquit('fock_2e: d/f** failed', maxd,
     &       MA_ERR)
c
c     If we can hold all of the integrals in core then we should
c     do this ... i.e., the default should be semi-direct, though
c     right now we must store all of the integrals.
c
      if (.not. (oreadfile .or. owritefile))
     $     owritefile = int2e_test_mem(geom, basis, tol2e*0.01d0)
c
      if (oreadfile) then
         call fock_2e_from_file( geom, basis, nfock, ablklen,
     $        jfac, kfac, tol2e, oskel,
     $        dbl_mb(k_dij), dbl_mb(k_dik), dbl_mb(k_dli), 
     $        dbl_mb(k_djk), dbl_mb(k_dlj), dbl_mb(k_dlk), 
     $        dbl_mb(k_fij), dbl_mb(k_fik), dbl_mb(k_fli), 
     $        dbl_mb(k_fjk), dbl_mb(k_flj), dbl_mb(k_flk),
     $        dbl_mb(k_atmp), vg_dens, vg_fock)
      else
c
c        tell the screening statistics we're starting another fock build
c
         iscreen(6) = iscreen(6) + 1
c
         call fock_2e_a( geom, basis, nfock, ablklen,
     $        jfac, kfac, tol2e, oskel,
     $        dbl_mb(k_dij), dbl_mb(k_dik), dbl_mb(k_dli), 
     $        dbl_mb(k_djk), dbl_mb(k_dlj), dbl_mb(k_dlk), 
     $        dbl_mb(k_fij), dbl_mb(k_fik), dbl_mb(k_fli), 
     $        dbl_mb(k_fjk), dbl_mb(k_flj), dbl_mb(k_flk),
     $        dbl_mb(k_atmp), vg_dens, vg_fock,
     $        int_mb(k_block), nblock)
c
c        print the integral screening statistics for this fock build
c        schwarz_print must be called by all nodes.
c
         if (util_print('screening statistics', print_debug)) then
            if ( .not. bas_numcont(basis, nshb) ) call errquit(
     $         'ao_fock_2e: problem with call to bas_numcont', basis,
     &       BASIS_ERR)
            call schwarz_print(natoms, nshb)
         endif
C
      endif
c     
      status = .true.
      status = status .and. ma_pop_stack(l_atmp)
      status = status .and. ma_pop_stack(l_flk)
      status = status .and. ma_pop_stack(l_flj)
      status = status .and. ma_pop_stack(l_fjk)
      status = status .and. ma_pop_stack(l_fli)
      status = status .and. ma_pop_stack(l_fik)
      status = status .and. ma_pop_stack(l_fij)
      status = status .and. ma_pop_stack(l_dlk)
      status = status .and. ma_pop_stack(l_dlj)
      status = status .and. ma_pop_stack(l_djk)
      status = status .and. ma_pop_stack(l_dli)
      status = status .and. ma_pop_stack(l_dik)
      status = status .and. ma_pop_stack(l_dij)
      status = status .and. ma_pop_stack(l_block)
      if (.not. status) call errquit('fock_2e: ma_pop?', 0, MA_ERR)
c     
      call ga_sync()
c     
c     fock_2e_a stuffs contributions into both the lower and upper
c     triangles ... need to symmetrize
c
      do i=1,nfock
        call ga_dscal(vg_fock(i), 4.0d0)
        if (.not. oskel .and. .not. asym) 
     &       call ga_symmetrize(vg_fock(i))
      end do
c
c     Reset exchange factors
c
      call dscal(nfock, 2.d0, kfac, 1)
c
c     Disable writing integrals to cache/file and enable reading for
c     next call if we were just writing.  Also flush trailing block.
c
      if (owritefile) then
         oreadfile = .true.
         owritefile = .false.
         if (.not. int2e_buf_write(.true.))
     $        call errquit('ao_fock_2e: write of last record failed',0,
     &       UNKNOWN_ERR)
      endif
c     
      end

#define NBLOCKS 2

*
* $Id: C3dB-mpi.F 25017 2013-12-19 22:52:15Z d3y133 $
*

#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_c_transpose_jk		*
*     *					*
*     ***********************************

      subroutine C3dB_c_transpose_jk(nb,A,tmp1,tmp2)

*****************************************************
*                                                   *
*      This routine performs the operation          *
*               A(i,k,j) <- A(i,j,k)                * 
*                                                   *
*      np = the number of worker nodes              *
*      proc#=0...(np-1)
*                                                   *
*       this transpose uses more buffer space       *
*       then transpose2                             *
*****************************************************
      implicit none
      integer nb
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
c     integer iq_to_i1((NFFT1/2+1)*NFFT2*NSLABS)
c     integer iq_to_i2((NFFT1/2+1)*NFFT2*NSLABS)
c     integer i1_start(NFFT3+1)
c     integer i2_start(NFFT3+1)
      integer iq_to_i1(2,NBLOCKS)
      integer iq_to_i2(2,NBLOCKS)
      integer i1_start(2,NBLOCKS)
      integer i2_start(2,NBLOCKS)
      common / c_trans_blk / iq_to_i1,iq_to_i2,i1_start,i2_start



*     **** local variables ***
      logical value
      integer i
      integer proc_to,proc_from,it
      integer msgtype,source
      integer msglen,type
      integer request(2),reqcnt
      integer taskid,np
      integer mpierr

*     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)

*     **** allocate memory ****
      value = MA_push_get(mt_int,np,
     >                     'request',request(2),request(1))
      if (.not. value)
     > call errquit(' C3dB_c_transpose_jk:out of stack',0,MA_ERR)


*     **** pack A(i) array ****
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nfft3d(nb) 
         tmp1(int_mb(iq_to_i1(1,nb)+i-1)) = A(i)
      end do

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(i2_start(1,nb)+2-1) - int_mb(i2_start(1,nb)+1-1)
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,msglen
         tmp2(int_mb(i2_start(1,nb)+1-1)+i-1) 
     > = tmp1(int_mb(i1_start(1,nb)+1-1)+i-1)
      end do
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

         msgtype = 1
         source=proc_from
         type   = 1
         msglen = (int_mb(i2_start(1,nb)+it+2-1) 
     >          -  int_mb(i2_start(1,nb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = type
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            int_mb(request(1)+reqcnt-1) = 0
            int_mb(request(1)+reqcnt-1) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    type,MPI_COMM_WORLD,
     >                    int_mb(request(1)+reqcnt-1),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(i1_start(1,nb)+it+2-1)
     >              - int_mb(i1_start(1,nb)+it+1-1))
         msgtype   = 1
      
         if (msglen.gt.0) then
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_SEND(tmp1(int_mb(i1_start(1,nb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
            call MPI_SEND(tmp1(int_mb(i1_start(1,nb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,mpierr)
#endif
         end if

      end do

   
*     **** wait for completion of mp_send, also do a sync ****
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,int_mb(request(1)))


*     **** unpack A(i) array ****
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nfft3d(nb) !***(nx(nb)/2+1)*ny(nb)*nq(nb)
         A(i) = tmp2(int_mb(iq_to_i2(1,nb)+i-1))
      end do
      

      !*** deallocate memory ***
      value =           MA_pop_stack(request(2))
      if (.not. value)
     > call errquit(' C3dB_c_transpose_jk:popping stack',0,MA_ERR)

      return
      end



#endif


*

#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_r_transpose_jk		*
*     *					*
*     ***********************************

      subroutine C3dB_r_transpose_jk(nb,A,tmp1,tmp2)

*****************************************************
*                                                   *
*      This routine performs the operation          *
*               A(i,k,j) <- A(i,j,k)                * 
*                                                   *
*      np = the number of worker nodes              *
*      proc#=0...(np-1)
*                                                   *
*       this transpose uses more buffer space       *
*       then transpose2                             *
*****************************************************
      implicit none
      integer nb
      real*8 A(*)
      real*8 tmp1(*),tmp2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
c     integer iq_to_i1((NFFT1/2+1)*NFFT2*NSLABS)
c     integer iq_to_i2((NFFT1/2+1)*NFFT2*NSLABS)
c     integer i1_start(NFFT3+1)
c     integer i2_start(NFFT3+1)
      integer iq_to_i1(2,NBLOCKS)
      integer iq_to_i2(2,NBLOCKS)
      integer i1_start(2,NBLOCKS)
      integer i2_start(2,NBLOCKS)
      common / c_trans_blk / iq_to_i1,iq_to_i2,i1_start,i2_start



*     **** local variables ***
      logical value
      integer i
      integer proc_to,proc_from,it
      integer msgtype,source
      integer msglen,type
      integer request(2),reqcnt
      integer taskid,np
      integer mpierr

*     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)

*     **** allocate memory ****
      value = MA_push_get(mt_int,np,
     >                     'request',request(2),request(1))
      if (.not. value)
     > call errquit(' C3dB_c_transpose_jk:out of stack',0,MA_ERR)


*     **** pack A(i) array ****
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nfft3d(nb) 
         tmp1(int_mb(iq_to_i1(1,nb)+i-1)) = A(i)
      end do

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(i2_start(1,nb)+2-1) - int_mb(i2_start(1,nb)+1-1)
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,msglen
         tmp2(int_mb(i2_start(1,nb)+1-1)+i-1) 
     > = tmp1(int_mb(i1_start(1,nb)+1-1)+i-1)
      end do
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

         msgtype = 1
         source=proc_from
         type   = 1
         msglen = (int_mb(i2_start(1,nb)+it+2-1) 
     >          -  int_mb(i2_start(1,nb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = type
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nb)+it+1-1)),
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            int_mb(request(1)+reqcnt-1) = 0
            int_mb(request(1)+reqcnt-1) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_PRECISION,
     >                    Parallel3d_convert_taskid_i(source),
     >                    type,MPI_COMM_WORLD,
     >                    int_mb(request(1)+reqcnt-1),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(i1_start(1,nb)+it+2-1)
     >              - int_mb(i1_start(1,nb)+it+1-1))
         msgtype   = 1
      
         if (msglen.gt.0) then
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_SEND(tmp1(int_mb(i1_start(1,nb)+it+1-1)),
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
            call MPI_SEND(tmp1(int_mb(i1_start(1,nb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_PRECISION,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,mpierr)
#endif
         end if

      end do

   
*     **** wait for completion of mp_send, also do a sync ****
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,int_mb(request(1)))


*     **** unpack A(i) array ****
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nfft3d(nb) !***(nx(nb)/2+1)*ny(nb)*nq(nb)
         A(i) = tmp2(int_mb(iq_to_i2(1,nb)+i-1))
      end do
      

      !*** deallocate memory ***
      value =           MA_pop_stack(request(2))
      if (.not. value)
     > call errquit(' C3dB_r_transpose_jk:popping stack',0,MA_ERR)

      return
      end



#endif









#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_c_transpose_ijk		*
*     *					*
*     ***********************************

      subroutine C3dB_c_transpose_ijk(nb,op,A,tmp1,tmp2)

*****************************************************
*                                                   *
*      This routine performs the operation          *
*               A(i,k,j) <- A(i,j,k)                * 
*                                                   *
*      np = the number of worker nodes              *
*      proc#=0...(np-1)
*                                                   *
*       this transpose uses more buffer space       *
*       then transpose2                             *
*****************************************************
      implicit none
      integer nb,op
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"
#include "mpif.h"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
      integer h_iq_to_i1(2,6,NBLOCKS)
      integer h_iq_to_i2(2,6,NBLOCKS)
      integer h_i1_start(2,6,NBLOCKS)
      integer h_i2_start(2,6,NBLOCKS)
      common / c_trans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_i1_start,
     >                         h_i2_start



*     **** local variables ***
      logical value
      integer i,nnfft3d
      integer proc_to,proc_from,it
      integer msgtype,source
      integer msglen,type
      integer request(2),reqcnt
      integer taskid,np
      integer mpierr

*     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i

      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)

*     **** allocate memory ****
      value = MA_push_get(mt_int,np,
     >                    'request',request(2),request(1))
      if (.not. value) 
     > call errquit(' C3dB_c_transpose_ijk:out of stack',0,MA_ERR)


*     **** pack A(i) array ****
      if ((op.eq.1).or.(op.eq.5)) nnfft3d = nx(nb)*nq1(nb)
      if ((op.eq.2).or.(op.eq.4)) nnfft3d = ny(nb)*nq2(nb)
      if ((op.eq.3).or.(op.eq.6)) nnfft3d = nz(nb)*nq3(nb)
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nnfft3d
         tmp1(int_mb(h_iq_to_i1(1,op,nb)+i-1)) = A(i)
      end do

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(h_i2_start(1,op,nb)+2-1) 
     >       - int_mb(h_i2_start(1,op,nb)+1-1)
      call dcopy(2*msglen,tmp1(int_mb(h_i1_start(1,op,nb))),1,
     >                    tmp2(int_mb(h_i2_start(1,op,nb))),1)
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

         msgtype = 1
         source=proc_from
         type   = 1
         msglen = (int_mb(h_i2_start(1,op,nb)+it+2-1) 
     >          -  int_mb(h_i2_start(1,op,nb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = type
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            int_mb(request(1)+reqcnt-1) = 0
            int_mb(request(1)+reqcnt-1) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    type,MPI_COMM_WORLD,
     >                    int_mb(request(1)+reqcnt-1),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(h_i1_start(1,op,nb)+it+2-1)
     >              - int_mb(h_i1_start(1,op,nb)+it+1-1))
         msgtype   = 1
      
         if (msglen.gt.0) then
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_SEND(tmp1(int_mb(h_i1_start(1,op,nb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
            call MPI_SEND(tmp1(int_mb(h_i1_start(1,op,nb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,mpierr)
#endif
         end if

      end do

   
*     **** wait for completion of mp_send, also do a sync ****
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,int_mb(request(1)))


*     **** unpack A(i) array ****
      if ((op.eq.4).or.(op.eq.6)) nnfft3d = nx(nb)*nq1(nb)
      if ((op.eq.1).or.(op.eq.3)) nnfft3d = ny(nb)*nq2(nb)
      if ((op.eq.2).or.(op.eq.5)) nnfft3d = nz(nb)*nq3(nb)
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nnfft3d
         A(i) = tmp2(int_mb(h_iq_to_i2(1,op,nb)+i-1))
      end do 

      !*** deallocate memory ***
      value =           MA_pop_stack(request(2))
      if (.not. value) 
     > call errquit(' C3dB_c_transpose_ijk:popping stack',0,MA_ERR)
      
      return
      end
#endif




#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_r_transpose_ijk		*
*     *					*
*     ***********************************

      subroutine C3dB_r_transpose_ijk(nb,op,A,tmp1,tmp2)

*****************************************************
*                                                   *
*      This routine performs the operation          *
*               A(i,k,j) <- A(i,j,k)                * 
*                                                   *
*      np = the number of worker nodes              *
*      proc#=0...(np-1)
*                                                   *
*       this transpose uses more buffer space       *
*       then transpose2                             *
*****************************************************
      implicit none
      integer nb,op
      real*8  A(*)
      real*8  tmp1(*),tmp2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
      integer h_iq_to_i1(2,6,NBLOCKS)
      integer h_iq_to_i2(2,6,NBLOCKS)
      integer h_i1_start(2,6,NBLOCKS)
      integer h_i2_start(2,6,NBLOCKS)
      common / c_trans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_i1_start,
     >                         h_i2_start



*     **** local variables ***
      logical value
      integer i,nnfft3d
      integer proc_to,proc_from,it
      integer msgtype,source
c     integer msglen,type,nbytes
c     integer msgid
      integer msglen,type
c     integer status(MPI_STATUS_SIZE,512),request(512),reqcnt
      integer request(2),reqcnt
      integer taskid,np
      integer mpierr

*     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)


*     **** allocate memory ****
      value = MA_push_get(mt_int,np,
     >                     'request',request(2),request(1))
      if (.not. value)
     > call errquit(' C3dB_r_transpose_ijk:out of stack',0,MA_ERR)
      

*     **** pack A(i) array ****
      if ((op.eq.1).or.(op.eq.5)) nnfft3d = nx(nb)*nq1(nb)
      if ((op.eq.2).or.(op.eq.4)) nnfft3d = ny(nb)*nq2(nb)
      if ((op.eq.3).or.(op.eq.6)) nnfft3d = nz(nb)*nq3(nb)
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nnfft3d
         tmp1(int_mb(h_iq_to_i1(1,op,nb)+i-1)) = A(i)
      end do

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(h_i2_start(1,op,nb)+2-1) 
     >       - int_mb(h_i2_start(1,op,nb)+1-1)
      call dcopy(msglen,tmp1(int_mb(h_i1_start(1,op,nb))),1,
     >                  tmp2(int_mb(h_i2_start(1,op,nb))),1)
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

         msgtype = 1
         source=proc_from
         type   = 1
         msglen = (int_mb(h_i2_start(1,op,nb)+it+2-1) 
     >          -  int_mb(h_i2_start(1,op,nb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = type
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nb)+it+1-1)),
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            int_mb(request(1)+reqcnt-1) = 0
            int_mb(request(1)+reqcnt-1) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_PRECISION,
     >                    Parallel3d_convert_taskid_i(source),
     >                    type,MPI_COMM_WORLD,
     >                    int_mb(request(1)+reqcnt-1),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(h_i1_start(1,op,nb)+it+2-1)
     >              - int_mb(h_i1_start(1,op,nb)+it+1-1))
         msgtype   = 1
      
         if (msglen.gt.0) then
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_SEND(tmp1(int_mb(h_i1_start(1,op,nb)+it+1-1)),
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
            call MPI_SEND(tmp1(int_mb(h_i1_start(1,op,nb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_PRECISION,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,mpierr)
#endif
         end if

      end do

   
*     **** wait for completion of mp_send, also do a sync ****
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,int_mb(request(1)))


*     **** unpack A(i) array ****
      if ((op.eq.4).or.(op.eq.6)) nnfft3d = nx(nb)*nq1(nb)
      if ((op.eq.1).or.(op.eq.3)) nnfft3d = ny(nb)*nq2(nb)
      if ((op.eq.2).or.(op.eq.5)) nnfft3d = nz(nb)*nq3(nb)
#ifndef CRAY
!DIR$ ivdep
#endif
      do i=1,nnfft3d
         A(i) = tmp2(int_mb(h_iq_to_i2(1,op,nb)+i-1))
      end do
      

      !*** deallocate memory ***
      value =           MA_pop_stack(request(2))
      if (.not. value)
     > call errquit(' C3dB_r_transpose_ijk:popping stack',0,MA_ERR)

      return
      end



*     ***********************************
*     *                                 *
*     *         C3dB_SumAll             *
*     *                                 *
*     ***********************************

      subroutine C3dB_SumAll(sum)
c     implicit none
      real*8  sum


#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      integer msglen,mpierr,np
      real*8 sumall

*     **** external functions ****
      integer  Parallel3d_comm_i
      external Parallel3d_comm_i

      call Parallel3d_np_i(np)
      if (np.gt.1) then
         msglen = 1
#ifdef MPI4
         stupid_msglen = msglen
         call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                       stupid_sum,stupid_comm_i,stupid_ierr)
#else
         call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                       MPI_SUM,Parallel3d_comm_i(),mpierr)
#endif
         sum = sumall
      end if

      return
      end



*     ***********************************
*     *                                 *
*     *         C3dB_ISumAll            *
*     *                                 *
*     ***********************************

      subroutine C3dB_ISumAll(sum)
c     implicit none
      integer sum

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      integer msglen,mpierr,np
      integer sumall

*     **** external functions ****
      integer  Parallel3d_comm_i
      external Parallel3d_comm_i

      call Parallel3d_np_i(np)
      if (np.gt.1) then

#ifdef MPI4
         stupid_msglen = 1
         stupid_tsum = sum
         call MPI_Allreduce(stupid_tsum,stupid_tsum2,stupid_msglen,
     >                      stupid_integer,
     >                      stupid_sum,stupid_comm_i,stupid_ierr)
         sum = stupid_tsum2
#else
         msglen = 1
         call MPI_Allreduce(sum,sumall,msglen,MPI_INTEGER,
     >                       MPI_SUM,Parallel3d_comm_i(),mpierr)
         sum = sumall
#endif
      end if

      return
      end





*     ***********************************
*     *                                 *
*     *         C3dB_Vector_SumAll      *
*     *                                 *
*     ***********************************

      subroutine C3dB_Vector_SumAll(n,sum)
c     implicit none
      integer n
      real*8  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      logical value
      integer msglen,mpierr

*     **** temporary workspace ****
      integer sumall(2),np

*     **** external functions ****
      integer  Parallel3d_comm_i
      external Parallel3d_comm_i


      call Parallel3d_np_i(np)
      call nwpw_timing_start(2)
      if (np.gt.1) then

*     ***** allocate temporary space ****
      value = MA_push_get(mt_dbl,n,'sumall',sumall(2),sumall(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

#ifdef MPI4
      stupid_msglen = n
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),
     >                stupid_msglen,
     >                stupid_double,
     >                stupid_sum,stupid_comm_i,stupid_ierr)
#else
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),n,
     >                MPI_DOUBLE_PRECISION,
     >                MPI_SUM,Parallel3d_comm_i(),mpierr)
#endif

      call dcopy(n,dbl_mb(sumall(1)),1,sum,1)
      value = MA_pop_stack(sumall(2))

      end if
      call nwpw_timing_end(2)
      return
      end




*     ***********************************
*     *                                 *
*     *         C3dB_Vector_ISumAll     *
*     *                                 *
*     ***********************************

      subroutine C3dB_Vector_ISumAll(n,sum)
c     implicit none
      integer n
      integer  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      logical value
      integer msglen,mpierr

*     **** temporary workspace ****
      integer sumall(2),i,taskid,sumall1(2)

*     **** external functions ****
      integer  Parallel3d_comm_i
      external Parallel3d_comm_i

      call Parallel3d_taskid_i(taskid)
      call nwpw_timing_start(2)

      call Parallel3d_np_i(np)
      if (np.gt.1) then

*     ***** allocate temporary space ****
      value = MA_push_get(mt_int,n,'sumall',sumall(2),sumall(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

#ifdef MPI4
      if (.not.MA_push_get(mt_int,n,'sumall1',sumall1(2),sumall1(1)))
     > call errquit('out of stack memory',0,MA_ERR)
      stupid_msglen = n
      call stupid_icopy8to4(n,sum,int_mb(sumall1(1)))
      call MPI_Allreduce(int_mb(sumall1(1)),
     >                   int_mb(sumall(1)),stupid_msglen,
     >                stupid_integer,
     >                stupid_sum,stupid_comm_i,stupid_ierr)
      call stupid_icopy4to8(n,int_mb(sumall(1)),sum)
      if (.not. MA_pop_stack(sumall1(2)))
     > call errquit('error popping stack',0, MA_ERR)
#else
      msglen = n
      call MPI_Allreduce(sum,int_mb(sumall(1)),msglen,
     >                MPI_INTEGER,
     >                MPI_SUM,Parallel3d_comm_i(),mpierr)
      call icopy(n,int_mb(sumall(1)),1,sum,1)
#endif

      value = MA_pop_stack(sumall(2))
      if (.not. value) call errquit('error popping stack',0, MA_ERR)

      end if

      call nwpw_timing_end(2)
      return
      end


#endif


#ifdef MPI

      
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose1_jk	*
*     *					*
*     ***********************************

      subroutine C3dB_c_ptranspose1_jk(nbb,A,tmp1,tmp2)

*****************************************************
*                                                   *
*      This routine performs the operation          *
*               A(i,k,j) <- A(i,j,k)                * 
*                                                   *
*      np = the number of worker nodes              *
*      proc#=0...(np-1)
*                                                   *
*       this transpose uses more buffer space       *
*       then transpose2                             *
*****************************************************
      implicit none
      integer nbb
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk1 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start


*     **** local variables ***
      logical value
      integer proc_to,proc_from,it
      integer msgtype,source
c     integer msglen,type,nbytes
c     integer msgid
      integer msglen,type
c     integer status(MPI_STATUS_SIZE,512),request(512),reqcnt
      integer request(2),reqcnt
      integer taskid,np
      integer mpierr,n1,n2

*     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)

*     **** allocate memory ****
      value = MA_push_get(mt_int,np,
     >                     'request',request(2),request(1))
      if (.not. value)
     > call errquit(' C3dB_c_ptranspose1_jk:out of stack',0,MA_ERR)


      n1 = int_mb(i1_start(1,nbb)+np) - 1
      n2 = int_mb(i2_start(1,nbb)+np) - 1

*     **** pack A(i) array ****
       call C3dB_pfft_index1_copy(n1,int_mb(iq_to_i1(1,nbb)),A,tmp1)

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(i2_start(1,nbb)+2-1) - int_mb(i2_start(1,nbb)+1-1)
      call dcopy(2*msglen,
     >           tmp1(int_mb(i1_start(1,nbb)+1-1)),1,
     >           tmp2(int_mb(i2_start(1,nbb)+1-1)),1)
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

         msgtype = 1
         source=proc_from
         type   = 1
         msglen = (int_mb(i2_start(1,nbb)+it+2-1) 
     >          -  int_mb(i2_start(1,nbb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = type
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            int_mb(request(1)+reqcnt-1) = 0
            int_mb(request(1)+reqcnt-1) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    type,MPI_COMM_WORLD,
     >                    int_mb(request(1)+reqcnt-1),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(i1_start(1,nbb)+it+2-1)
     >              - int_mb(i1_start(1,nbb)+it+1-1))
         msgtype   = 1
      
         if (msglen.gt.0) then
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_SEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
            call MPI_SEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,mpierr)
#endif
         end if

      end do
   
*     **** wait for completion of mp_send, also do a sync ****
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,int_mb(request(1)))


*     **** unpack A(i) array ****
      call C3dB_pfft_index2_copy(n2,int_mb(iq_to_i2(1,nbb)),tmp2,A)
      call C3dB_pfft_index2_zero(nfft3d(1)-n2,int_mb(iz_to_i2(1,nbb)),A)
      

      !*** deallocate memory ***
      value =           MA_pop_stack(request(2))
      if (.not. value)
     > call errquit('C3dB_c_ptranspose1_jk:popping stack',0,MA_ERR)

      return
      end




      
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose2_jk	*
*     *					*
*     ***********************************

      subroutine C3dB_c_ptranspose2_jk(nbb,A,tmp1,tmp2)

*****************************************************
*                                                   *
*      This routine performs the operation          *
*               A(i,k,j) <- A(i,j,k)                * 
*                                                   *
*      np = the number of worker nodes              *
*      proc#=0...(np-1)
*                                                   *
*       this transpose uses more buffer space       *
*       then transpose2                             *
*****************************************************
      implicit none
      integer nbb
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk2 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start


*     **** local variables ***
      logical value
      integer proc_to,proc_from,it
      integer msgtype,source
      integer msglen,type
      integer request(2),reqcnt
      integer taskid,np
      integer mpierr,n1,n2

c     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)

*     **** allocate memory ****
      value = MA_push_get(mt_int,np,
     >                     'request',request(2),request(1))
      if (.not. value)
     > call errquit(' C3dB_c_ptranspose2_jk:out of stack',0,MA_ERR)

      n1 = int_mb(i1_start(1,nbb)+np) - 1
      n2 = int_mb(i2_start(1,nbb)+np) - 1

*     **** pack A(i) array ****
       call C3dB_pfft_index1_copy(n1,int_mb(iq_to_i1(1,nbb)),A,tmp1)

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(i2_start(1,nbb)+2-1) - int_mb(i2_start(1,nbb)+1-1)
      call dcopy(2*msglen,
     >           tmp1(int_mb(i1_start(1,nbb)+1-1)),1,
     >           tmp2(int_mb(i2_start(1,nbb)+1-1)),1)
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

         msgtype = 1
         source=proc_from
         type   = 1
         msglen = (int_mb(i2_start(1,nbb)+it+2-1) 
     >          -  int_mb(i2_start(1,nbb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = type
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            int_mb(request(1)+reqcnt-1) = 0
            int_mb(request(1)+reqcnt-1) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    type,MPI_COMM_WORLD,
     >                    int_mb(request(1)+reqcnt-1),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(i1_start(1,nbb)+it+2-1)
     >              - int_mb(i1_start(1,nbb)+it+1-1))
         msgtype   = 1
      
         if (msglen.gt.0) then
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_SEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
            call MPI_SEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,mpierr)
#endif
         end if

      end do
   
*     **** wait for completion of mp_send, also do a sync ****
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,int_mb(request(1)))


*     **** unpack A(i) array ****
      call C3dB_pfft_index2_copy(n2,int_mb(iq_to_i2(1,nbb)),tmp2,A)
      call C3dB_pfft_index2_zero(nfft3d(1)-n2,int_mb(iz_to_i2(1,nbb)),A)
      

      !*** deallocate memory ***
      value = MA_pop_stack(request(2))
      if (.not. value)
     > call errquit(' C3dB_c_ptranspose2_jk:popping stack',0,MA_ERR)

      return
      end


#endif



#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose_ijk	*
*     *					*
*     ***********************************

      subroutine C3dB_c_ptranspose_ijk(nbb,op,A,tmp1,tmp2)

*****************************************************
*                                                   *
*      This routine performs the operation          *
*               A(i,k,j) <- A(i,j,k)                * 
*                                                   *
*      np = the number of worker nodes              *
*      proc#=0...(np-1)
*                                                   *
*       this transpose uses more buffer space       *
*       then transpose2                             *
*****************************************************
      implicit none
      integer nbb,op
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
      integer h_iq_to_i1(2,6,0:1)
      integer h_iq_to_i2(2,6,0:1)
      integer h_iz_to_i2(2,6,0:1)
      integer h_iz_to_i2_count(6,0:1)
      integer h_i1_start(2,6,0:1)
      integer h_i2_start(2,6,0:1)
      common / c_ptrans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_iz_to_i2,
     >                         h_iz_to_i2_count,
     >                         h_i1_start,
     >                         h_i2_start



*     **** local variables ***
      logical value
      integer n1,n2,n3
      integer proc_to,proc_from,it
      integer msgtype,source
      integer msglen,type
      integer request(2),reqcnt
      integer taskid,np
      integer mpierr

c     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)

*     **** allocate memory ****
      value = MA_push_get(mt_int,np,
     >                     'request',request(2),request(1))
      if (.not. value) 
     > call errquit('C3dB_c_ptranspose_ijk:out of stack',0,MA_ERR)


      n1 = int_mb(h_i1_start(1,op,nbb)+np) - 1
      n2 = int_mb(h_i2_start(1,op,nbb)+np) - 1
      n3 = h_iz_to_i2_count(op,nbb)


*     **** pack A(i) array ****
      call C3dB_pfft_index1_copy(n1,int_mb(h_iq_to_i1(1,op,nbb)),A,tmp1)


*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(h_i2_start(1,op,nbb)+2-1) 
     >       - int_mb(h_i2_start(1,op,nbb)+1-1)
      call dcopy(2*msglen,
     >           tmp1(int_mb(h_i1_start(1,op,nbb))),1,
     >           tmp2(int_mb(h_i2_start(1,op,nbb))),1)


*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

         msgtype = 1
         source=proc_from
         type   = 1
         msglen = (int_mb(h_i2_start(1,op,nbb)+it+2-1) 
     >          -  int_mb(h_i2_start(1,op,nbb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = type
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nbb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            int_mb(request(1)+reqcnt-1) = 0
            int_mb(request(1)+reqcnt-1) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nbb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    type,MPI_COMM_WORLD,
     >                    int_mb(request(1)+reqcnt-1),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(h_i1_start(1,op,nbb)+it+2-1)
     >              - int_mb(h_i1_start(1,op,nbb)+it+1-1))
         msgtype   = 1
      
         if (msglen.gt.0) then
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_SEND(tmp1(int_mb(h_i1_start(1,op,nbb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
            call MPI_SEND(tmp1(int_mb(h_i1_start(1,op,nbb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,mpierr)
#endif
         end if

      end do

   
*     **** wait for completion of mp_send, also do a sync ****
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,int_mb(request(1)))


*     **** unpack A(i) array ****
      call C3dB_pfft_index2_copy(n2,int_mb(h_iq_to_i2(1,op,nbb)),tmp2,A)
      call C3dB_pfft_index2_zero(n3,int_mb(h_iz_to_i2(1,op,nbb)),A)


      !*** deallocate memory ***
      value = MA_pop_stack(request(2))
      if (.not. value) 
     > call errquit('C3dB_c_transpose_ijk:popping stack',0,MA_ERR)
      
      return
      end
#endif




#ifdef MPI
*     ************************************
*     *                                  *
*     *       c_Balance_c_balance_start  *
*     *                                  *
*     ************************************

      subroutine c_Balance_c_balance_start(nb,A,request,reqcnt,msgtype)
      implicit none
      integer nb
      complex*16 A(*)
      integer    request(*),reqcnt
      integer msgtype

#include "mafdecls.fh"
#include "mpif.h"
#include "balance_common.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** local variables ****
      integer j,np
      integer pto,pfrom,msglen,indx,mpierr

c     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i


      reqcnt = 0
      if (log_mb(sender_list(1)+nb)) then
         do j=1,int_mb(npacket_list(1)+nb)
            pto    = int_mb(int_mb(proc_to_list(1)    +2*nb)+j-1)    
            msglen = int_mb(int_mb(packet_size_list(1)+2*nb)+j-1)
            indx   = int_mb(int_mb(indx_start_list(1) +2*nb)+j-1)
c            msgtype=2
c            send data....
            if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(pto)
            call MPI_ISEND(A(indx),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,
     >                     stupid_request,stupid_ierr)
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_ISEND(A(indx),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(pto),
     >                     msgtype,MPI_COMM_WORLD,
     >                     request(reqcnt),mpierr)
#endif
            end if
  

         end do
      end if

      if (log_mb(receiver_list(1)+nb)) then
         do j=1,int_mb(npacket_list(1)+nb)
            pfrom  = int_mb(int_mb(proc_from_list(1)  +2*nb)+j-1)    
            msglen = int_mb(int_mb(packet_size_list(1)+2*nb)+j-1)
            indx   = int_mb(int_mb(indx_start_list(1) +2*nb)+j-1)
c            msgtype=2
c            recieve data....
            if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(pfrom)
            call MPI_IRECV(A(indx),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr)
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_IRECV(A(indx),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(pfrom),
     >                    msgtype,MPI_COMM_WORLD,
     >                    request(reqcnt),mpierr)
#endif
            end if

         end do
      end if

      return
      end
#endif




#ifdef MPI
*     ************************************
*     *                                  *
*     *       c_Balance_c_balance_end    *
*     *                                  *
*     ************************************

      subroutine c_Balance_c_balance_end(nb,A,request,reqcnt)
      implicit none
      integer nb
      complex*16 A(*)
      integer    request(*),reqcnt

*     **** local variables ***
      integer np

      call Parallel3d_np_i(np)
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,request)
      return
      end
#endif

#ifdef MPI
*     ************************************
*     *                                  *
*     *    c_Balance_c_unbalance_start   *
*     *                                  *
*     ************************************

      subroutine c_Balance_c_unbalance_start(nb,A,request,reqcnt,
     >                                       msgtype)
      implicit none
      integer nb
      complex*16 A(*)
      integer    request(*),reqcnt
      integer    msgtype

#include "mafdecls.fh"
#include "mpif.h"
#include "balance_common.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

*     **** local variables ****
      integer j,np
      integer pto,pfrom,msglen,indx,mpierr

c     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i


      reqcnt=0
      if (log_mb(sender_list(1)+nb)) then
         do j=1,int_mb(npacket_list(1)+nb)
            pfrom  = int_mb(int_mb(proc_to_list(1)    +2*nb)+j-1)
            msglen = int_mb(int_mb(packet_size_list(1)+2*nb)+j-1)
            indx   = int_mb(int_mb(indx_start_list(1) +2*nb)+j-1)
c            msgtype=2
c            recieve data....
            if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(pfrom)
            call MPI_IRECV(A(indx),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr)
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_IRECV(A(indx),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(pfrom),
     >                    msgtype,MPI_COMM_WORLD,
     >                    request(reqcnt),mpierr)
#endif
            end if
  
         end do
      end if

      if (log_mb(receiver_list(1)+nb)) then
         do j=1,int_mb(npacket_list(1)+nb)
            pto    = int_mb(int_mb(proc_from_list(1)  +2*nb)+j-1)    
            msglen = int_mb(int_mb(packet_size_list(1)+2*nb)+j-1)
            indx   = int_mb(int_mb(indx_start_list(1) +2*nb)+j-1)
c            msgtype=2
c            send data....
            if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(pto)
            call MPI_ISEND(A(indx),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,
     >                     stupid_request,stupid_ierr)
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_ISEND(A(indx),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(pto),
     >                     msgtype,MPI_COMM_WORLD,
     >                     request(reqcnt),mpierr)
#endif

            end if

         end do
      end if

      return
      end
#endif


#ifdef MPI
*     ************************************
*     *                                  *
*     *       c_Balance_c_unbalance_end    *
*     *                                  *
*     ************************************

      subroutine c_Balance_c_unbalance_end(nb,A,request,reqcnt)
      implicit none
      integer nb
      complex*16 A(*)
      integer    request(*),reqcnt

*     **** local variables ***
      integer np

      call Parallel3d_np_i(np)
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,request)
      return
      end
#endif



#ifdef MPI
      
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose1_jk_start	*
*     *					*
*     ***********************************

*                                           
*      This routine performs the operation   
*               A(i,k,j) <- A(i,j,k)          
*                                              
*      np = the number of worker nodes          
*      proc#=0...(np-1)
*                                                
*       this transpose uses more buffer space     
*       then transpose2                            
*

      subroutine C3dB_c_ptranspose1_jk_start(nbb,A,tmp1,tmp2,
     >                                       request,reqcnt,msgtype)
      implicit none
      integer nbb
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)
      integer request(*),reqcnt
      integer msgtype

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk1 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start


*     **** local variables ***
      integer proc_to,proc_from,it
      integer source
      integer msglen
      integer taskid,np
      integer mpierr,n1

c     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)

      n1 = int_mb(i1_start(1,nbb)+np) - 1

*     **** pack A(i) array ****
       call C3dB_pfft_index1_copy(n1,int_mb(iq_to_i1(1,nbb)),A,tmp1)

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(i2_start(1,nbb)+2-1) - int_mb(i2_start(1,nbb)+1-1)
      call dcopy(2*msglen,
     >           tmp1(int_mb(i1_start(1,nbb)+1-1)),1,
     >           tmp2(int_mb(i2_start(1,nbb)+1-1)),1)
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

c         msgtype = 1
c         type   = 1
         source=proc_from
         msglen = (int_mb(i2_start(1,nbb)+it+2-1) 
     >          -  int_mb(i2_start(1,nbb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    msgtype,MPI_COMM_WORLD,
     >                    request(reqcnt),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(i1_start(1,nbb)+it+2-1)
     >              - int_mb(i1_start(1,nbb)+it+1-1))
c         msgtype   = 1
      
         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_ISEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,
     >                     stupid_request,stupid_ierr)
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_ISEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,
     >                     request(reqcnt),mpierr)
#endif
         end if

      end do
   

      return
      end

#endif

#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose1_jk_end	*
*     *					*
*     ***********************************

*                                           
*      This routine performs the operation   
*               A(i,k,j) <- A(i,j,k)          
*                                              
*      np = the number of worker nodes          
*      proc#=0...(np-1)
*                                                
*       this transpose uses more buffer space     
*       then transpose2                            
*

      subroutine C3dB_c_ptranspose1_jk_end(nbb,A,tmp2,request,reqcnt)

      implicit none
      integer nbb
      complex*16  A(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt

#include "mafdecls.fh"
#include "C3dB.fh"

*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk1 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start

*     **** local variables ***
      integer np,n2
      
      call Parallel3d_np_i(np)
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,request)

*     **** unpack A(i) array ****
      n2 = int_mb(i2_start(1,nbb)+np) - 1
      call C3dB_pfft_index2_copy(n2,int_mb(iq_to_i2(1,nbb)),tmp2,A)
      call C3dB_pfft_index2_zero(nfft3d(1)-n2,int_mb(iz_to_i2(1,nbb)),A)
      
      return
      end

#endif



#ifdef MPI

      
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose2_jk_start	*
*     *					*
*     ***********************************

*                                           
*      This routine performs the operation   
*               A(i,k,j) <- A(i,j,k)          
*                                              
*      np = the number of worker nodes          
*      proc#=0...(np-1)
*                                                
*       this transpose uses more buffer space     
*       then transpose2                            
*

      subroutine C3dB_c_ptranspose2_jk_start(nbb,A,tmp1,tmp2,
     >                                       request,reqcnt,msgtype)
      implicit none
      integer nbb
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)
      integer request(*),reqcnt
      integer msgtype

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk2 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start


*     **** local variables ***
      integer proc_to,proc_from,it
      integer source
      integer msglen
      integer taskid,np
      integer mpierr,n1

c     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)


      n1 = int_mb(i1_start(1,nbb)+np) - 1

*     **** pack A(i) array ****
       call C3dB_pfft_index1_copy(n1,int_mb(iq_to_i1(1,nbb)),A,tmp1)

*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(i2_start(1,nbb)+2-1) - int_mb(i2_start(1,nbb)+1-1)
      call dcopy(2*msglen,
     >           tmp1(int_mb(i1_start(1,nbb)+1-1)),1,
     >           tmp2(int_mb(i2_start(1,nbb)+1-1)),1)
         

*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

c         msgtype = 1
c         type   = 1
         source=proc_from
         msglen = (int_mb(i2_start(1,nbb)+it+2-1) 
     >          -  int_mb(i2_start(1,nbb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr)
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(i2_start(1,nbb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    msgtype,MPI_COMM_WORLD,
     >                    request(reqcnt),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(i1_start(1,nbb)+it+2-1)
     >              - int_mb(i1_start(1,nbb)+it+1-1))
c         msgtype   = 1
      
         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_ISEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,
     >                     stupid_request,stupid_ierr)
            request(reqcnt) = 0 
            request(reqcnt) = stupid_request
#else
            call MPI_ISEND(tmp1(int_mb(i1_start(1,nbb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,
     >                     request(reqcnt),mpierr)
#endif
         end if

      end do
   

      return
      end

#endif

#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose2_jk_end	*
*     *					*
*     ***********************************

*                                           
*      This routine performs the operation   
*               A(i,k,j) <- A(i,j,k)          
*                                              
*      np = the number of worker nodes          
*      proc#=0...(np-1)
*                                                
*       this transpose uses more buffer space     
*       then transpose2                            
*

      subroutine C3dB_c_ptranspose2_jk_end(nbb,A,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16  A(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt

#include "mafdecls.fh"
#include "C3dB.fh"

*     **** indexing variables **** integer iq_to_i1(2,0:1)
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk2 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start

*     **** local variables ***
      integer np,n2
      
      call Parallel3d_np_i(np)
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,request)

*     **** unpack A(i) array ****
      n2 = int_mb(i2_start(1,nbb)+np) - 1
      call C3dB_pfft_index2_copy(n2,int_mb(iq_to_i2(1,nbb)),tmp2,A)
      call C3dB_pfft_index2_zero(nfft3d(1)-n2,int_mb(iz_to_i2(1,nbb)),A)
      return
      end

#endif


#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose_ijk_start	*
*     *					*
*     ***********************************
*                                                
*      This routine performs the operation      
*               A(i,k,j) <- A(i,j,k)           
*                                             
*      np = the number of worker nodes       
*      proc#=0...(np-1)
*                                           
*       this transpose uses more buffer space 
*       then transpose2                      
*


      subroutine C3dB_c_ptranspose_ijk_start(nbb,op,A,tmp1,tmp2,
     >                                       request,reqcnt,msgtype)

      implicit none
      integer nbb,op
      complex*16  A(*)
      complex*16  tmp1(*),tmp2(*)
      integer     request(*),reqcnt
      integer     msgtype

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** indexing variables ****
      integer h_iq_to_i1(2,6,0:1)
      integer h_iq_to_i2(2,6,0:1)
      integer h_iz_to_i2(2,6,0:1)
      integer h_iz_to_i2_count(6,0:1)
      integer h_i1_start(2,6,0:1)
      integer h_i2_start(2,6,0:1)
      common / c_ptrans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_iz_to_i2,
     >                         h_iz_to_i2_count,
     >                         h_i1_start,
     >                         h_i2_start


*     **** local variables ***
      integer n1
      integer proc_to,proc_from,it
      integer source
      integer msglen
      integer taskid,np
      integer mpierr

c     **** external functions ****
      integer  Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_i
      
      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)


*     **** pack A(i) array ****
      n1 = int_mb(h_i1_start(1,op,nbb)+np) - 1
      call C3dB_pfft_index1_copy(n1,int_mb(h_iq_to_i1(1,op,nbb)),A,tmp1)


*     **** it = 0, transpose data on same thread ****  
      msglen = int_mb(h_i2_start(1,op,nbb)+2-1) 
     >       - int_mb(h_i2_start(1,op,nbb)+1-1)
      call dcopy(2*msglen,
     >           tmp1(int_mb(h_i1_start(1,op,nbb))),1,
     >           tmp2(int_mb(h_i2_start(1,op,nbb))),1)


*     **** receive packed array data ****
      reqcnt = 0
      do it = 1,np-1

*        **** synchronous receive of tmp ****
         proc_from = mod((taskid)-it+np, np) 

c         msgtype = 1
c         type   = 1
         source=proc_from
         msglen = (int_mb(h_i2_start(1,op,nbb)+it+2-1) 
     >          -  int_mb(h_i2_start(1,op,nbb)+it+1-1))
         

         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(source)
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nbb)+it+1-1)),
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    stupid_request,stupid_ierr) 
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_IRECV(tmp2(int_mb(h_i2_start(1,op,nbb)+it+1-1)),
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    Parallel3d_convert_taskid_i(source),
     >                    msgtype,MPI_COMM_WORLD,
     >                    request(reqcnt),mpierr) 
#endif
         end if

      end do

*     **** send packed array to other processors ****
      do it = 1,np-1

*        **** synchronous send of tmp ****
         proc_to   = mod((taskid)+it, np) 
         msglen    = (int_mb(h_i1_start(1,op,nbb)+it+2-1)
     >              - int_mb(h_i1_start(1,op,nbb)+it+1-1))
c         msgtype   = 1
      
         if (msglen.gt.0) then
            reqcnt = reqcnt + 1
#ifdef MPI4
            stupid_msglen = msglen
            stupid_type   = msgtype
            stupid_taskid = Parallel3d_convert_taskid_i(proc_to)
            call MPI_ISEND(tmp1(int_mb(h_i1_start(1,op,nbb)+it+1-1)),
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,
     >                     stupid_request,stupid_ierr)
            request(reqcnt) = 0
            request(reqcnt) = stupid_request
#else
            call MPI_ISEND(tmp1(int_mb(h_i1_start(1,op,nbb)+it+1-1)),
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     Parallel3d_convert_taskid_i(proc_to),
     >                     msgtype,MPI_COMM_WORLD,
     >                     request(reqcnt),mpierr)
#endif
         end if

      end do

      return
      end

#endif


#ifdef MPI
*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose_ijk_end	*
*     *					*
*     ***********************************
*                                                  
*      This routine performs the operation        
*               A(i,k,j) <- A(i,j,k)             
*                                               
*      np = the number of worker nodes         
*      proc#=0...(np-1)                       
*                                            
*       this transpose uses more buffer space 
*       then transpose2                      
*

      subroutine C3dB_c_ptranspose_ijk_end(nbb,op,A,tmp2,
     >                                 request,reqcnt)

      implicit none
      integer nbb,op
      complex*16  A(*)
      complex*16  tmp2(*)
      integer request(*),reqcnt

#include "mafdecls.fh"
#include "C3dB.fh"

*     **** indexing variables ****
      integer h_iq_to_i1(2,6,0:1)
      integer h_iq_to_i2(2,6,0:1)
      integer h_iz_to_i2(2,6,0:1)
      integer h_iz_to_i2_count(6,0:1)
      integer h_i1_start(2,6,0:1)
      integer h_i2_start(2,6,0:1)
      common / c_ptrans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_iz_to_i2,
     >                         h_iz_to_i2_count,
     >                         h_i1_start,
     >                         h_i2_start

*     **** local variables ***
      integer n2,n3,np
      
      call Parallel3d_np_i(np)
      if (np.gt.1) call Parallel_mpiWaitAll(reqcnt,request)

*     **** unpack A(i) array ****
      n2 = int_mb(h_i2_start(1,op,nbb)+np) - 1
      n3 = h_iz_to_i2_count(op,nbb)
      call C3dB_pfft_index2_copy(n2,int_mb(h_iq_to_i2(1,op,nbb)),tmp2,A)
      call C3dB_pfft_index2_zero(n3,int_mb(h_iz_to_i2(1,op,nbb)),A)
      return
      end

#endif



*     ***********************************
*     *					*
*     *	       C3dB_(c,r)_read  	*	
*     *					*
*     ***********************************

      subroutine C3dB_c_read(nb,iunit,A,tmp,jcol,kcol)
      implicit none 
      integer nb
      integer iunit
      complex*16 A(*)
      complex*16 tmp(*)
      integer jcol,kcol

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

c#include "tcgmsg.fh"
c#include "msgtypesf.h"
c      integer rcv_len,rcv_proc

      
*     *** local variables ***
      logical value,fillcolumn,fillzone
      integer MASTER,taskid
      parameter(MASTER=0)
      integer p_to, p_here,q
      integer index,j,k
      integer source,msglen,msgtype
      integer tmp1(2),tmp2(2),status(2)

      integer taskid_j,np_j
      integer taskid_k,np_k
      integer ii,jj,kk,jstart,jend,kstart,kend
      integer mpierr

*     **** external functions ****
      integer  Parallel3d_convert_taskid_ijk,Parallel_comm_world
      external Parallel3d_convert_taskid_ijk,Parallel_comm_world

      call Parallel_taskid(taskid)

      call Parallel3d_np_j(np_j)
      call Parallel3d_taskid_j(taskid_j)
      if (jcol.lt.0) then
         jstart = 0
         jend = np_j-1
         fillcolumn = .true.
      else
         jstart = jcol
         jend   = jcol
         fillcolumn = (taskid_j.eq.jcol)
      endif
      call Parallel3d_np_k(np_k)
      call Parallel3d_taskid_k(taskid_k)
      if (kcol.lt.0) then
         kstart = 0
         kend = np_k-1
         fillzone = .true.
      else
         kstart = kcol
         kend   = kcol
         fillzone = (taskid_k.eq.kcol)
      endif

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*4,
     >                     'status',status(2),status(1)))
     > call errquit('C3dB_c_read:out of stack',0,MA_ERR)



      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)

            call dread(iunit,tmp,2*nx(nb)*ny(nb))

            call C3dB_ktoqp(nb,k,q,ii)
            do kk=kstart,kend
            do jj=jstart,jend
               p_to = Parallel3d_convert_taskid_ijk(ii,jj,kk)
               if (p_to.eq.MASTER) then
                  index = 1 + (q-1)*nx(nb)*ny(nb)
                  call zcopy(nx(nb)*ny(nb),tmp,1,A(index),1)
               else
                  msglen = nx(nb)*ny(nb)
                  msgtype = 1
c                  call SND(9+MSGDBL,tmp,mdtob(2*msglen),p_to,1)
#ifdef MPI4
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  stupid_taskid = p_to
                  call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                  call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     p_to,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif

               end if
            end do
            end do
         end do

*     **** not master node ****
      else if (fillcolumn.and.fillzone) then
         do k=1,nz(nb)
            call C3dB_ktoqp(nb,k,q,ii)
            p_here = Parallel3d_convert_taskid_ijk(ii,taskid_j,taskid_k)
            if (p_here.eq.taskid) then
               msglen = nx(nb)*ny(nb)
               msgtype = 1
               source  = MASTER
c               call RCV(9+MSGDBL,tmp,mdtob(2*msglen),rcv_len,
c     >                  source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = msglen
               stupid_type   = msgtype
               stupid_taskid = source
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif

               index = 1 + (q-1)*nx(nb)*ny(nb) 
               call zcopy(nx(nb)*ny(nb),tmp,1,A(index),1)
            end if
         end do
      end if



      !*************************
      !**** hilbert mapping ****
      !*************************
      else

*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)
         do j=1,ny(nb)

            call dread(iunit,tmp,2*nx(nb))

            q    = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii   = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            do kk=kstart,kend
            do jj=jstart,jend
               p_to = Parallel3d_convert_taskid_ijk(ii,jj,kk)
               if (p_to.eq.MASTER) then
                  index = 1 + (q-1)*nx(nb)
                  call zcopy(nx(nb),tmp,1,A(index),1)
               else
                  msglen = nx(nb)
                  msgtype = 1
c                  call SND(9+MSGDBL,tmp,mdtob(2*msglen),p_to,1)
#ifdef MPI4
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  stupid_taskid = p_to
                  call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                  call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     p_to,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif

               end if
            end do
            end do
         end do
         end do

*     **** not master node ****
      else if (fillcolumn.and.fillzone) then
         do k=1,nz(nb)
         do j=1,ny(nb)

            q      = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii     = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            p_here = Parallel3d_convert_taskid_ijk(ii,taskid_j,taskid_k)
            if (p_here.eq.taskid) then
               msglen = nx(nb)
               msgtype = 1
               source  = MASTER
c               call RCV(9+MSGDBL,tmp,mdtob(2*msglen),rcv_len,
c     >                  source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = msglen
               stupid_type   = msgtype
               stupid_taskid = source
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif
               index = 1 + (q-1)*nx(nb)
               call zcopy(nx(nb),tmp,1,A(index),1)
            end if
         end do
         end do
      end if

      if (fillcolumn.and.fillzone) then
*        **** allocate temporary space  ****
         value =MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp1',tmp1(2),tmp1(1))
         value =value.and.
     >          MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp2',tmp2(2),tmp2(1))
         if (.not. value) 
     >      call errquit('C3dB_c_Read:out of stack memory',0,MA_ERR)
*
         call C3dB_c_transpose_ijk(nb,5,A,
     >                          dcpl_mb(tmp1(1)),
     >                          dcpl_mb(tmp2(1)))  !*** map1to3 operation ***

*        **** deallocate temporary space  ****
         value =           MA_pop_stack(tmp2(2))
         value = value.and.MA_pop_stack(tmp1(2))
         if (.not. value) 
     >      call errquit('C3dB_c_Read:error popping stack',0,MA_ERR)
      endif

      end if

*     *** deallocate status memory ***
      if (.not.MA_pop_stack(status(2)))
     > call errquit('C3dB_c_read:popping stack',0,MA_ERR)

*     **** WAIT ****
c      call ga_sync()

      return
      end

      subroutine C3dB_r_read(nb,iunit,A,tmp,jcol,kcol)
      implicit none 
      integer nb
      integer iunit
      real*8  A(*)
      real*8  tmp(*)
      integer jcol,kcol

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

c#include "tcgmsg.fh"
c#include "msgtypesf.h"
c      integer rcv_len,rcv_proc

      
*     *** local variables ***
      integer MASTER,taskid
      parameter(MASTER=0)

      logical value,fillcolumn,fillzone
      integer p_to, p_here,q
      integer j,k,index,index2
      integer source,msglen
      integer tmp1(2),tmp2(2)

      integer taskid_j,np_j
      integer taskid_k,np_k
      integer ii,jj,kk,jstart,jend,kstart,kend,status(2)
      integer msgtype
      real*8 dum
      integer mpierr
c      integer mpierr,mstatus(MPI_STATUS_SIZE)

*     **** external functions ****
      integer  Parallel3d_convert_taskid_ijk,Parallel_comm_world
      external Parallel3d_convert_taskid_ijk,Parallel_comm_world

      call Parallel_taskid(taskid)

      call Parallel3d_np_j(np_j)
      call Parallel3d_taskid_j(taskid_j)
      if (jcol.lt.0) then
         jstart = 0
         jend = np_j-1
         fillcolumn = .true.
      else
         jstart = jcol
         jend   = jcol
         fillcolumn = (taskid_j.eq.jcol)
      endif
      call Parallel3d_np_k(np_k)
      call Parallel3d_taskid_k(taskid_k)
      if (kcol.lt.0) then
         kstart = 0
         kend = np_k-1
         fillzone = .true.
      else
         kstart = kcol
         kend   = kcol
         fillzone = (taskid_k.eq.kcol)
      endif

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*4,
     >                     'status',status(2),status(1)))
     > call errquit('C3dB_r_read:out of stack',0,MA_ERR)


      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)

            call dread(iunit,tmp,(nx(nb))*ny(nb))

            call C3dB_ktoqp(nb,k,q,ii)
            do kk=kstart,kend
            do jj=jstart,jend
               p_to = Parallel3d_convert_taskid_ijk(ii,jj,kk)
               if (p_to.eq.MASTER) then
                  index = 1 + (q-1)*nx(nb)*ny(nb)
                  call dcopy(nx(nb)*ny(nb),tmp,1,A(index),1)
               else
                  msglen = nx(nb)*ny(nb)
                  msgtype = 1
c                  call SND(9+MSGDBL,tmp,mdtob(msglen),p_to,1)
#ifdef MPI4
                 stupid_msglen = msglen
                 stupid_type   = msgtype
                 stupid_taskid = p_to
                 call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                 call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_PRECISION,
     >                     p_to,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif
               end if
            end do
            end do

         end do

*     **** not master node ****
      else if (fillcolumn.and.fillzone) then
         do k=1,nz(nb)
            call C3dB_ktoqp(nb,k,q,ii)
            p_here = Parallel3d_convert_taskid_ijk(ii,taskid_j,taskid_k)
            if (p_here.eq.taskid) then
               msglen  = nx(nb)*ny(nb)
               msgtype = 1
               source   = MASTER
c               call RCV(9+MSGDBL,tmp,mdtob(msglen),rcv_len,
c     >                  source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = msglen
               stupid_type   = msgtype
               stupid_taskid = source
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_PRECISION,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif
               index = 1 + (q-1)*nx(nb)*ny(nb)
               call dcopy(nx(nb)*ny(nb),tmp,1,A(index),1)
            end if
         end do
      end if

      !*************************
      !**** hilbert mapping ****
      !*************************
      else

*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)
         do j=1,ny(nb)

            call dread(iunit,tmp,(nx(nb)))

            q    = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii   = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            do kk=kstart,kend
            do jj=jstart,jend
               p_to = Parallel3d_convert_taskid_ijk(ii,jj,kk)
               if (p_to.eq.MASTER) then
                  index = (q-1)*nx(nb) + 1
                  call dcopy(nx(nb),tmp,1,A(index),1)
               else
                  msglen = nx(nb)
                  msgtype = 1
c                  call SND(9+MSGDBL,tmp,mdtob(msglen),p_to,1)
#ifdef MPI4
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  stupid_taskid = p_to
                  call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                  call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_PRECISION,
     >                     p_to,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif
               end if
            end do
            end do
         end do
         end do

*     **** not master node ****
      else if (fillcolumn.and.fillzone) then
         do k=1,nz(nb)
         do j=1,ny(nb)

            q      = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii     = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            p_here = Parallel3d_convert_taskid_ijk(ii,taskid_j,taskid_k)
            if (p_here.eq.taskid) then
               msglen = nx(nb)
               msgtype = 1
               source  = MASTER
c               call RCV(9+MSGDBL,tmp,mdtob(msglen),rcv_len,
c     >                  source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = msglen
               stupid_type   = msgtype
               stupid_taskid = source
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_PRECISION,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif
               index = (q-1)*nx(nb) + 1
               call dcopy(nx(nb),tmp,1,A(index),1)
            end if
         end do
         end do
       end if

      if (fillcolumn.and.fillzone) then
*        **** allocate temporary space  ****
         value =MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp1',tmp1(2),tmp1(1))
         value =value.and.
     >          MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp2',tmp2(2),tmp2(1))
         if (.not. value) 
     >      call errquit('C3dB_r_Read:out of stack memory',0,MA_ERR)
         call C3dB_r_transpose_ijk(nb,5,A,
     >                          dcpl_mb(tmp1(1)),
     >                          dcpl_mb(tmp2(1)))  !*** map1to3 operation ***
*        **** deallocate temporary space  ****
         value =           MA_pop_stack(tmp2(2))
         value = value.and.MA_pop_stack(tmp1(2))
         if (.not. value) 
     >      call errquit('C3dB_r_Read:error popping stack',0,MA_ERR)
      end if

      end if

*     *** deallocate status memory ***
      if (.not.MA_pop_stack(status(2)))
     > call errquit('C3dB_r_read:popping stack',0,MA_ERR)

*     **** WAIT ****
c      call ga_sync()

      return
      end


*     ***********************************
*     *					*
*     *	       C3dB_(c,r)_write	        *	
*     *					*
*     ***********************************

      subroutine C3dB_c_write(nb,iunit,A,tmp,jcol,kcol)
      implicit none 
      integer nb
      integer iunit
      complex*16 A(*)
      complex*16 tmp(*)
      integer jcol,kcol

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

c#include "tcgmsg.fh"
c#include "msgtypesf.h"
c      integer rcv_len,rcv_proc

      
*     *** local variables ***
      integer MASTER,taskid
      parameter(MASTER=0)
      logical value
      integer p_from, p_here,q
      integer j,k,index
      integer dest,source,msglen,msgtype
      integer dum,dum_msglen,dum_msgtype
      integer tmp1(2),tmp2(2),status(2)
      integer mpierr

      integer ii,taskid_j,taskid_k

*     **** external functions ****
      integer  Parallel3d_convert_taskid_ijk,Parallel_comm_world
      external Parallel3d_convert_taskid_ijk,Parallel_comm_world

      call Parallel_taskid(taskid)
      call Parallel3d_taskid_j(taskid_j)
      call Parallel3d_taskid_k(taskid_k)

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*4,
     >                     'status',status(2),status(1)))
     > call errquit('D3dB_c_write:out of stack',0,MA_ERR)


      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)

            call C3dB_ktoqp(nb,k,q,ii)
            p_from = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)

            if (p_from.eq.MASTER) then
               index = 1 + (q-1)*nx(nb)*ny(nb) 
               call zcopy(nx(nb)*ny(nb),A(index),1,tmp,1)
            else
               msglen  = nx(nb)*ny(nb)
               msgtype = 1
               source  = p_from
               dum = 99
               dum_msglen = 1
               dum_msgtype = 2
c               call SND(9+MSGINT,dum,mitob(dum_msglen),source,1)
c               call RCV(9+MSGDBL,tmp,mdtob(2*msglen),rcv_len,
c     >                       source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = dum_msglen
               stupid_type   = dum_msgtype
               stupid_taskid = source
               call MPI_SEND(dum,
     >                     stupid_msglen,stupid_integer,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
               stupid_msglen = msglen
               stupid_type   = msgtype
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_SEND(dum,
     >                     dum_msglen,MPI_INTEGER,
     >                     source,
     >                     dum_msgtype,Parallel_comm_world(),mpierr)
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif

            end if
            call dwrite(iunit,tmp,2*nx(nb)*ny(nb)) 
         end do

*     **** not master node ****
      else
         do k=1,nz(nb)
         
            call C3dB_ktoqp(nb,k,q,ii)
            p_here = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)
            if (p_here.eq.taskid) then

               index = 1 + (q-1)*nx(nb)*ny(nb)
               call zcopy(nx(nb)*ny(nb),A(index),1,tmp,1)

               msglen  = nx(nb)*ny(nb)
               msgtype = 1
               dest    = MASTER
               dum_msglen  = 1
               dum_msgtype = 2
c               call RCV(9+MSGINT,dum,mitob(dum_msglen),rcv_len,
c     >                       dest,rcv_proc,1)
c               call SND(9+MSGDBL,tmp,mdtob(2*msglen),dest,1)
#ifdef MPI4
                  stupid_msglen = dum_msglen
                  stupid_type   = dum_msgtype
                  stupid_taskid = dest
                  call MPI_RECV(dum,
     >                    stupid_msglen,stupid_integer,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                  call MPI_RECV(dum,
     >                    dum_msglen,MPI_INTEGER,
     >                    dest,
     >                    dum_msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
                  call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     dest,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif
            end if

         end do
      end if

      !*************************
      !**** hilbert mapping ****
      !*************************
      else

      if ((taskid_j.eq.jcol).and.(taskid_k.eq.kcol)) then
*        **** allocate temporary space  ****
         value = MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp1',
     >                       tmp1(2),tmp1(1))
         value = value.and.
     >         MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp2',tmp2(2),tmp2(1))
         if (.not. value) 
     >      call errquit('C3dB_c_Write:out of stack memory',0,MA_ERR)
*
         call C3dB_c_transpose_ijk(nb,6,A,
     >                          dcpl_mb(tmp1(1)),
     >                          dcpl_mb(tmp2(1)))  !*** map3to1 operation ***

*        **** deallocate temporary space  ****
         value = MA_pop_stack(tmp2(2))
         value = value.and.MA_pop_stack(tmp1(2))
         if (.not. value) 
     >      call errquit('C3dB_c_Write:error popping stack',0, MA_ERR)
      end if

c      call ga_sync()

*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)
         do j=1,ny(nb)

            q      = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii     = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            p_from = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)
            if (p_from.eq.MASTER) then

               index = 1 + (q-1)*nx(nb)
               call zcopy(nx(nb),A(index),1,tmp,1)
            else
               msglen  = nx(nb)
               msgtype = 1
               source  = p_from
               dum = 99
               dum_msglen  = 1
               dum_msgtype = 2
c               call SND(9+MSGINT,dum,mitob(dum_msglen),source,1)
c               call RCV(9+MSGDBL,tmp,mdtob(2*msglen),rcv_len,
c     >                       source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = dum_msglen
               stupid_type   = dum_msgtype
               stupid_taskid = source
               call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_integer,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
               stupid_msglen = msglen
               stupid_type   = msgtype
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_complex,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_SEND(dum,
     >                     dum_msglen,MPI_INTEGER,
     >                     source,
     >                     dum_msgtype,Parallel_comm_world(),mpierr)
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_COMPLEX,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif
            end if

            call dwrite(iunit,tmp,2*nx(nb))
         end do
         end do

*     **** not master node ****
      else
         do k=1,nz(nb)
         do j=1,ny(nb)

            q      = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii     = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            p_here = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)
            if (p_here.eq.taskid) then

               index = 1 + (q-1)*nx(nb)
               call zcopy(nx(nb),A(index),1,tmp,1)

               msglen  = nx(nb)
               msgtype = 1
               dest    = MASTER
               dum_msglen  = 1
               dum_msgtype = 2
c               call RCV(9+MSGINT,dum,mitob(dum_msglen),rcv_len,
c     >                       dest,rcv_proc,1)
c               call SND(9+MSGDBL,tmp,mdtob(2*msglen),dest,1)
#ifdef MPI4
                  stupid_msglen = dum_msglen
                  stupid_type   = dum_msgtype
                  stupid_taskid = dest
                  call MPI_RECV(dum,
     >                    stupid_msglen,stupid_integer,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_complex,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                  call MPI_RECV(dum,
     >                    dum_msglen,MPI_INTEGER,
     >                    dest,
     >                    dum_msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
                  call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_COMPLEX,
     >                     dest,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif
            end if

         end do
         end do
      end if

      end if

*     *** deallocate status memory ***
      if (.not.MA_pop_stack(status(2)))
     > call errquit('C3dB_c_write:popping stack',0,MA_ERR)

*     **** WAIT ****
c      call ga_sync()

      return
      end

      subroutine C3dB_r_write(nb,iunit,A,tmp,jcol,kcol)
      implicit none 
      integer nb
      integer iunit
      real*8     A(*)
      real*8     tmp(*)
      integer jcol,kcol

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "C3dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

c#include "tcgmsg.fh"
c#include "msgtypesf.h"
c      integer rcv_len,rcv_proc
      
*     *** local variables ***
      integer MASTER,taskid
      parameter(MASTER=0)
      integer p_from, p_here,q
      integer j,k,index,index2
      integer dest,source,status(2),msglen,msgtype
      integer mpierr

      integer ii,taskid_j,taskid_k

*     **** external functions ****
      integer  Parallel3d_convert_taskid_ijk,Parallel_comm_world
      external Parallel3d_convert_taskid_ijk,Parallel_comm_world

      call Parallel_taskid(taskid)
      call Parallel3d_taskid_j(taskid_j)
      call Parallel3d_taskid_k(taskid_k)

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*4,
     >                     'status',status(2),status(1)))
     > call errquit('C3dB_r_write:out of stack',0,MA_ERR)


      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)

            call C3dB_ktoqp(nb,k,q,ii)
            p_from = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)
            if (p_from.eq.MASTER) then
               index = 1 + (q-1)*nx(nb)*ny(nb)
               call dcopy(nx(nb)*ny(nb),A(index),1,tmp,1)
            else
               msglen  = (nx(nb))*ny(nb)
               msgtype = 1
               source  = p_from
c               call RCV(9+MSGDBL,tmp,mdtob(msglen),rcv_len,
c     >                       source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = msglen
               stupid_type   = msgtype
               stupid_taskid = source
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_PRECISION,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif
            end if

            call dwrite(iunit,tmp,(nx(nb))*ny(nb)) 
         end do

*     **** not master node ****
      else
         do k=1,nz(nb)
         
            call C3dB_ktoqp(nb,k,q,ii)
            p_here = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)
            if (p_here.eq.taskid) then

               index = 1 + (q-1)*nx(nb)*ny(nb)
               call dcopy(nx(nb)*ny(nb),A(index),1,tmp,1)
 
               msglen  = (nx(nb))*ny(nb)
               msgtype = 1
               dest    = MASTER
c               call SND(9+MSGDBL,tmp,mdtob(msglen),dest,1)
#ifdef MPI4
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  stupid_taskid = dest
                  call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                  call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_PRECISION,
     >                     dest,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif
            end if

         end do
      end if


      !*************************
      !**** hilbert mapping ****
      !*************************
      else
*     **** master node reads from file and distributes ****
      if (taskid.eq.MASTER) then
         do k=1,nz(nb)
         do j=1,ny(nb)

            q      = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii     = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            p_from = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)

            if (p_from.eq.MASTER) then
              index = 1 + (q-1)*nx(nb)
              call dcopy(nx(nb),A(index),1,tmp,1)
            else
               msglen  = (nx(nb))
               msgtype = 1
               source  = p_from
c               call RCV(9+MSGDBL,tmp,mdtob(msglen),rcv_len,
c     >                       source,rcv_proc,1)
#ifdef MPI4
               stupid_msglen = msglen
               stupid_type   = msgtype
               stupid_taskid = source
               call MPI_RECV(tmp,
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_world,
     >                    int_mb(status(1)),stupid_ierr)
#else
               call MPI_RECV(tmp,
     >                    msglen,MPI_DOUBLE_PRECISION,
     >                    source,
     >                    msgtype,Parallel_comm_world(),
     >                    int_mb(status(1)),mpierr)
#endif
            end if

            call dwrite(iunit,tmp,(nx(nb)))
         end do
         end do

*     **** not master node ****
      else
         do k=1,nz(nb)
         do j=1,ny(nb)

            q      = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            ii     = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            p_here = Parallel3d_convert_taskid_ijk(ii,jcol,kcol)

            if (p_here.eq.taskid) then

               index = 1 + (q-1)*nx(nb)
               call dcopy(nx(nb),A(index),1,tmp,1)

               msglen  = nx(nb)
               msgtype = 1
               dest    = MASTER
c               call SND(9+MSGDBL,tmp,mdtob(msglen),dest,1)
#ifdef MPI4
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  stupid_taskid = dest
                  call MPI_SEND(tmp,
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_world,stupid_ierr)
#else
                  call MPI_SEND(tmp,
     >                     msglen,MPI_DOUBLE_PRECISION,
     >                     dest,
     >                     msgtype,Parallel_comm_world(),mpierr)
#endif
            end if

         end do
         end do
      end if


      end if

*     *** deallocate status memory ***
      if (.not.MA_pop_stack(status(2)))
     > call errquit('C3dB_r_write:popping stack',0,MA_ERR)

*     **** wait ****
c      call ga_sync()
      return
      end

      subroutine argos_space_listbb(ibownr,boxsiz,lbbl)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      integer ibownr(maxbox,3),lbbl(mbbl,mbb2)
      real*8 boxsiz(maxbox,3)
      logical lside,leven
c
      integer ibx,iby,ibz,ipx,ipy,ipz,ibox,inode
      integer jbx,jby,jbz,kbx,kby,kbz,jpx,jpy,jpz
      integer ilx,ihx,ily,ihy,ilz,ihz
      integer i,j,jbox,jnode,ltemp
      real*8 dx,dxtmp,dy,dytmp,dz,dztmp,dist2
c
c     Construction of the box-box pairlist
c
      nbbl=0
      do 1 ibx=0,nbx-1
      ipx=ibownr(ibx+1,1)
      do 2 iby=0,nby-1
      ipy=ibownr(iby+1,2)
      do 3 ibz=0,nbz-1
      ipz=ibownr(ibz+1,3)
      ibox=(ibz*nby+iby)*nbx+ibx
      inode=(ipz*npy+ipy)*npx+ipx
      if(inode.eq.me) then
      do 4 jbx=0,nbx-1
      kbx=jbx-ibx
      jpx=ibownr(jbx+1,1)
c
      if(ibx.le.jbx) then
      ilx=ibx
      ihx=jbx
      else
      ilx=jbx
      ihx=ibx
      endif
c
      dx=zero
      if(ibx.ne.jbx) then
      dx=boxsiz(ihx,1)-boxsiz(ilx+1,1)
      if(npbtyp.gt.0) then
      dxtmp=zero
      if(ilx.gt.0) dxtmp=boxsiz(ilx,1)
      if(ihx.lt.nbx-1) dxtmp=dxtmp-boxsiz(ihx+1,1)+box(1)
      if(dxtmp.lt.dx) dx=dxtmp
      if(kbx.gt.0.and.kbx.gt.iabs(kbx-nbx)) kbx=kbx-nbx
      if(kbx.lt.0.and.-kbx.gt.iabs(kbx+nbx)) kbx=kbx+nbx
      endif
      endif
c
      do 5 jby=0,nby-1
      kby=jby-iby
      jpy=ibownr(jby+1,2)
c
      if(iby.le.jby) then
      ily=iby
      ihy=jby
      else
      ily=jby
      ihy=iby
      endif
c
      dy=zero
      if(iby.ne.jby) then
      dy=boxsiz(ihy,2)-boxsiz(ily+1,2)
      if(npbtyp.gt.0) then
      dytmp=zero
      if(ily.gt.0) dytmp=boxsiz(ily,2)
      if(ihy.lt.nby-1) dytmp=dytmp-boxsiz(ihy+1,2)+box(2)
      if(dytmp.lt.dy) dy=dytmp
      if(kby.gt.0.and.kby.gt.iabs(kby-nby)) kby=kby-nby
      if(kby.lt.0.and.-kby.gt.iabs(kby+nby)) kby=kby+nby
      endif
      endif
c
      do 6 jbz=0,nbz-1
      kbz=jbz-ibz
      jpz=ibownr(jbz+1,3)
c
      if(ibz.le.jbz) then
      ilz=ibz
      ihz=jbz
      else
      ilz=jbz
      ihz=ibz
      endif
c
      dz=zero
      if(ibz.ne.jbz) then
      dz=boxsiz(ihz,3)-boxsiz(ilz+1,3)
      if(npbtyp.eq.1) then
      dztmp=zero
      if(ilz.gt.0) dztmp=boxsiz(ilz,3)
      if(ihz.lt.nbz-1) dztmp=dztmp-boxsiz(ihz+1,3)+box(3)
      if(dztmp.lt.dz) dz=dztmp
      if(kbz.gt.0.and.kbz.gt.iabs(kbz-nbz)) kbz=kbz-nbz
      if(kbz.lt.0.and.-kbz.gt.iabs(kbz+nbz)) kbz=kbz+nbz
      endif
      endif
c
      jbox=(jbz*nby+jby)*nbx+jbx
      jnode=(jpz*npy+jpy)*npx+jpx
c
c     determine orientation jbox in relation to ibox
c
c     lside is true if
c
c     i: 0  j: 0  k:  +
c     i: 0  j:  + k:-0+
c     i:  + j:-0+ k:-0+
c
      lside=(kbx.eq.0.and.kby.eq.0.and.kbz.ge.0)
     + .or.(kbx.eq.0.and.kby.gt.0) .or. kbx.gt.0
c
c     determine if ibox is identical to jbox
c
c     lsame=kbx.eq.0.and.kby.eq.0.and.kbz.eq.0
c
c     determine if difference in box numbers is even or odd
c
      leven=2*(iabs(ibox-jbox)/2).eq.iabs(ibox-jbox)
c
c     calculate the distance between the two boxes
c
      if(nbxtyp.eq.1) then
      dist2=
     + (vlat(1,1)*dx/box(1)+vlat(1,2)*dy/box(2)+vlat(1,3)*dz/box(3))**2+
     + (vlat(2,1)*dx/box(1)+vlat(2,2)*dy/box(2)+vlat(2,3)*dz/box(3))**2+
     + (vlat(3,1)*dx/box(1)+vlat(3,2)*dy/box(2)+vlat(3,3)*dz/box(3))**2
      else
      dist2=dx*dx+dy*dy+dz*dz
      endif
c
c     keep half of the box pairs
c
c     this test also appears in argos_space_numbb
c     any changes need to be made in both routines
c
      if((inode.eq.jnode.and.ibox.ge.jbox).or. (inode.ne.jnode.and.
     + ((lside.and.leven).or.(.not.lside.and..not.leven)))) then
c
c     keep only those within maximum cutoff distance
c
      if(rbbl*rbbl.gt.dist2) then
      nbbl=nbbl+1
      if(nbbl.gt.mbbl) call md_abort('Box-box list too small',mbbl)
      lbbl(nbbl,1)=jnode
      lbbl(nbbl,2)=jbox
      lbbl(nbbl,3)=ibox
      lbbl(nbbl,4)=0
      endif
      endif
 6    continue
 5    continue
 4    continue
      endif
 3    continue
 2    continue
 1    continue
      npprev=0
c
      nbbloc=0
      do 7 i=1,nbbl-1
      do 8 j=i+1,nbbl
      if((lbbl(i,1).ne.me.and.lbbl(j,1).eq.me).or.
     + (lbbl(i,1).gt.lbbl(j,1).and.lbbl(i,1).ne.me).or.
     + (lbbl(i,1).eq.lbbl(j,1).and.lbbl(i,2).gt.lbbl(j,2)).or.
     + (lbbl(i,1).eq.lbbl(j,1).and.lbbl(i,2).eq.lbbl(j,2).and.
     + lbbl(i,3).gt.lbbl(j,3))) then
      ltemp=lbbl(i,1)
      lbbl(i,1)=lbbl(j,1)
      lbbl(j,1)=ltemp
      ltemp=lbbl(i,2)
      lbbl(i,2)=lbbl(j,2)
      lbbl(j,2)=ltemp
      ltemp=lbbl(i,3)
      lbbl(i,3)=lbbl(j,3)
      lbbl(j,3)=ltemp
      endif
    8 continue
      if(lbbl(i,1).eq.me) nbbloc=i
    7 continue
      if(lbbl(nbbl,1).eq.me) nbbloc=nbbl
c
      nrempr=0
      if(nbget.ne.0.and.np.gt.1) then
      nrempr=1
      do 9 i=2,nbbl
      if(lbbl(i,2).ne.lbbl(i-1,2)) nrempr=nrempr+1
    9 continue
      call ga_igop(msp_29,nrempr,1,'max')
      nrempr=min(2*nrempr,nrempr+25)
      endif
c
      if(iand(idebug,2).eq.2) then
      write(lfndbg,8000) (i,(lbbl(i,j),j=1,3),i=1,nbbl)
 8000 format('lbbl',/,(4i5))
      call util_flush(lfndbg)
      endif
c
      return
      end
c $Id: argos_space_listbb.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function pre_frgsiz(lfn,fil,lfnout,
     + natm,nbnd,nzmat,nparms,ipardef)
c
c $Id: pre_frgsiz.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     function to read dimensions from a frg file
c
c     in  : lfn = frg file logical file number
c           fil = frg file name
c           lfnout = output file logical file number
c
c     out : natm = number of atoms
c           nbnd = number of bonds
c
      implicit none
c
#include "util.fh"
c
      integer lfn,lfnout,natm,nbnd,nzmat
      character*255 fil
c
      character*80 card
      integer i,icon(16),length
c
      integer nparms,ipardef
c
      natm=0
      nbnd=0
      nzmat=0
c
      length=index(fil,' ')-1
c
      if(util_print('where',print_debug)) then
      write(lfnout,2000) fil(1:length)
 2000 format(/,'pre_frgsiz  ',a)
      endif
c
      open(unit=lfn,file=fil(1:length),form='formatted',
     + status='old',err=9999)
c
      if(util_print('where',print_debug)) then
      write(lfnout,2001) fil(1:length)
 2001 format('FRG OPEN  ',a)
      endif
c
    1 continue
c
      read(lfn,1000,end=9999,err=9999) card
 1000 format(a)
c
      if(card(1:1).eq.'#'.or.card(1:1).eq.'$') goto 1
c
      read(card,1001) natm,nparms,ipardef,nzmat
 1001 format(4i5)
c
      do 2 i=1,nparms*(natm+1)
      read(lfn,1000,end=9999,err=9999) card
    2 continue
c
    3 continue
      read(lfn,1002,end=9,err=9999) icon
 1002 format(16i5)
c
      if(icon(1).ne.0) then
      do 4 i=2,16
      if(icon(i).ne.0) nbnd=nbnd+1
    4 continue
      goto 3
      endif
c
      read(lfn,1000,end=9,err=9999) card
      if(card(1:8).eq.'z-matrix') then
    5 continue
      read(lfn,1003) i
 1003 format(i5)
      if(i.gt.0) then
      nzmat=nzmat+1
      goto 5
      endif
      endif
c
    9 continue
c
      close(lfn)
c
      if(util_print('where',print_debug)) then
      write(lfnout,2002) natm,nbnd,fil(1:length)
 2002 format(i20,' atoms',/,i20,' bonds',//,
     + 'FRG CLOSE ',a)
      endif
c
      pre_frgsiz=.true.
      return
c
 9999 continue
c
      if(util_print('where',print_none)) then
      write(lfnout,2003) fil(1:length)
 2003 format('FRG ERROR ',a)
      endif
c
      pre_frgsiz=.false.
      return
      end

      subroutine bas_create_uncont(usertdb,basis_in,name,basis_out)
c $Id: bas_create_uncont.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
#include "nwc_const.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "inp.fh"
#include "bas.fh"
#include "sym.fh"
#include "apiP.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "bgj.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
c
c     Given a contracted basis, create a new uncontracted basis on rtdb
c
c     function declarations
c
      logical bas_add_ucnt_init
      logical bas_add_ucnt_tidy
      logical bas_add_ucnt
      logical bas_set_spherical
      logical bas_get_spherical
      logical bas_ucontinfo
      logical bas_num_uce
      logical bas_uce2cnr
      logical bas_getu_exponent
      logical bas_uce_tag
      external bas_add_ucnt_init
      external bas_add_ucnt_tidy
      external bas_add_ucnt
      external bas_set_spherical
      external bas_get_spherical
      external bas_ucontinfo
      external bas_num_uce
      external bas_uce2cnr
      external bas_getu_exponent
      external bas_uce_tag
c
c     arguments
c
      integer usertdb                ! Handle of rtdb
      integer basis_in               ! Handle of input contracted basis
      character*(*) name             ! Name of the basis set for rtdb
      integer basis_out              ! Handle new uncontracted basis
c
c     local variables
c
      integer Expm_a, ExpIm_a        ! MA array for storing exponents
      integer Lm_a, LIm_a            ! MA array for storing l-values of exponents
      integer Sm_a, SIm_a            ! MA array for storing shells of exponents
      integer Am_a, AIm_a            ! MA array for storing centers of exponents
      integer ipr_mx                 ! Maximum # of primitives in basis
      integer usegeom                ! Handle to geometry basis_in
      integer nuniqatom              ! # of unique atoms
      integer iatom, ishell, iprim
      integer ifirst, ilast, icont
      integer cartsph, l_type
      integer counter, nuniqprim
      character*16 usetag
      logical spheri
c
      integer Pmnm_a,PmnIm_a         ! Following indices are used for generating 
      integer Pmxm_a,PmxIm_a         ! a fitting basis set based on exponents and
      integer l_max,nprim            ! angular momenta
      double precision maxprim,minprim,alpha
c
c     Get geometry and rtdb handles for basis_in
c
      if (.not. bas_geom(basis_in,usegeom))
     $   call errquit('bas_create_uncont: bas_geom failed',0, BASIS_ERR)
c
c     Create a new fitting basis set
c
      if (.not. bas_create(basis_out,name))
     $   call errquit('bas_create_uncont: bas_create failed',0,
     &       BASIS_ERR)
c
c     Check if the user generated a fitting basis on input called
c     "D-K basis", if so load, normalize and return
c
      if (bas_rtdb_load(usertdb,usegeom,basis_out,'D-K basis')) then
        call int_normalize(usertdb,basis_out)
        return
      end if
c
c     Create a new uncontracted basis and initialize adding function
c
      if (.not. bas_add_ucnt_init(basis_out)) call errquit
     &      ('bas_create_uncont: bas_add_ucnt_init failed',0,
     &       BASIS_ERR)
c
c     Get # unique centers 
c
      if (.not. bas_num_uce(basis_in,nuniqatom)) 
     $   call errquit ('bas_create_uncont: bas_numcont failed',0,
     &       BASIS_ERR)
c
c     Get maximum number of exponents for unique atoms
c
      ipr_mx = 0
      do 7 iatom = 1, nuniqatom
         if (.not.bas_uce2cnr(basis_in,iatom,ifirst,ilast))
     $      call errquit ('bas_create_uncont: bas_uce2cnr failed',0,
     &       BASIS_ERR)
         do 8 ishell = ifirst, ilast
            if (.not. bas_ucontinfo(basis_in,ishell,l_type,
     $                             nprim,icont,cartsph))
     $         call errquit ('bas_create_uncont: bas_ucontinfo ',0,
     &       BASIS_ERR)
            ipr_mx = ipr_mx + nprim
    8    continue
    7 continue
c
c     Make arrays for exponents plus l-types and shells of exponents
c
      if (.not. ma_push_get(MT_DBL,ipr_mx,'primitives',Expm_a,ExpIm_a))
     $     call errquit('bas_create_uncont: ma_push_get Exp array',0,
     &       MA_ERR)
      if (.not. ma_push_get(MT_INT,ipr_mx,'ltypes',Lm_a,LIm_a))
     $     call errquit('bas_create_uncont: ma_push_get L array',0,
     &       MA_ERR)
      if (.not. ma_push_get(MT_INT,ipr_mx,'shells',Sm_a,SIm_a))
     $     call errquit('bas_create_uncont: ma_push_get Exp array',0,
     &       MA_ERR)
      if (.not. ma_push_get(MT_INT,ipr_mx,'atoms',Am_a,AIm_a))
     $     call errquit('bas_create_uncont: ma_push_get Exp array',0,
     &       MA_ERR)
c
c     Extract exponents and data from basis_in for all unique atoms 
c
      counter = 0
      do 1 iatom = 1, nuniqatom
         if (.not.bas_uce2cnr(basis_in,iatom,ifirst,ilast))
     $      call errquit ('bas_create_uncont: bas_uce2cnr failed',0,
     &       BASIS_ERR)
         do 2 ishell = ifirst, ilast
            if (.not. bas_ucontinfo(basis_in,ishell,l_type,
     $                             nprim,icont,cartsph))
     $         call errquit ('bas_create_uncont: bas_ucontinfo ',0,
     &       BASIS_ERR)
            if (.not. bas_getu_exponent(basis_in,ishell,
     $                                 dbl_mb(ExpIm_a+counter)))
     $         call errquit ('bas_create_uncont: bas_getu_exponent',0,
     &       BASIS_ERR)
            do 3 iprim = 1, nprim
                 int_mb(LIm_a+counter+iprim-1) = l_type
                 int_mb(SIm_a+counter+iprim-1) = ishell
                 int_mb(AIm_a+counter+iprim-1) = iatom
    3       continue
            counter = counter + nprim
    2    continue
    1 continue
c
c   Find unique exponents and store exponents and data into basis_out
c
      call bas_unique_sort(dbl_mb(ExpIm_a),int_mb(LIm_a),int_mb(SIm_a),
     $                 int_mb(AIm_a),ipr_mx,nuniqprim)
c
c   If the option to use a more extensive, flexible fitting basis set
c   setup data to handle even tempered basis set construction
c
      if (dk_even_bas) then
         if ((ga_nodeid() .eq. 0) .and. 
     $       util_print('douglas-kroll', print_low)) write(luout,30)
   30    format(/12x, 
     $   'Extended even tempered basis constructed for Douglas-Kroll'/)

c
c        Check if sp or spd combined basis is used, they cannot be handled
c        in the flexible basis set construction code below
c
         do 9 iprim = 1, nuniqprim
            if (int_mb(LIm_a+iprim-1) .lt.0) call errquit(
     $       'Cannot use sp or spd to create flexi fitting basis DK',0,
     &       BASIS_ERR)
    9    continue
c
c        Get highest angular momentum for array definitions and create arrays
c
         if (.not. bas_high_angular(basis_in,l_max))
     $      call errquit('bas_create_uncont: bas_high_angular failed',0,
     &       BASIS_ERR)
         ipr_mx = l_max + 1
         if (.not. ma_push_get(MT_DBL,ipr_mx,'maxprim',Pmxm_a,PmxIm_a))
     $      call errquit('bas_create_uncont: ma_push_get Pmx array',0,
     &       MA_ERR)
         if (.not. ma_push_get(MT_DBL,ipr_mx,'minprim',Pmnm_a,PmnIm_a))
     $      call errquit('bas_create_uncont: ma_push_get Pmn array',0,
     &       MA_ERR)
c
c        Loop over each unique center
c
         do 17 iatom = 1, nuniqatom
c
c        Get l-values and l_max and tag for this center
c
            do 16 iprim = 0, ipr_mx - 1
               dbl_mb(PmxIm_a+iprim) = 0.0d0
               dbl_mb(PmnIm_a+iprim) = 1.0d20
   16       continue
            l_max = 0
            do 18 iprim = 1, nuniqprim
               if (int_mb(AIm_a+iprim-1) .eq. iatom) then
                  if (l_max .lt. int_mb(LIm_a+iprim-1))
     $               l_max = int_mb(LIm_a+iprim-1)
               counter = int_mb(LIm_a+iprim-1)
               if (dbl_mb(PmxIm_a+counter) .lt. dbl_mb(ExpIm_a+iprim-1)) 
     $             dbl_mb(PmxIm_a+counter) = dbl_mb(ExpIm_a+iprim-1)
               if (dbl_mb(PmnIm_a+counter) .gt. dbl_mb(ExpIm_a+iprim-1)) 
     $             dbl_mb(PmnIm_a+counter) = dbl_mb(ExpIm_a+iprim-1)
               endif
   18       continue
c
c        Get max and min exponent for each l-value, based on ratio get 
c        number of exponents (compute adjusted ratio based on integer
c        number of exponents) using the following extra rules:
c        s space has to incorporate p space
c        p space has to incorporate s and d space
c        d space has to incorporate p and f space, etc
c
c        When max and min primitive are set, compute the number of primitive
c        functions, expansion ratio for number of primitive and store in basis
c
            do 20 l_type = 0, l_max + 1
               if (l_type .eq. 0) then
                  if (l_max .gt. 0) then
                     maxprim = max(dbl_mb(PmxIm_a),
     $                             dbl_mb(PmxIm_a+1))
                     minprim = min(dbl_mb(PmnIm_a),
     $                             dbl_mb(PmnIm_a+1))
                  else
                     maxprim = dbl_mb(PmxIm_a)
                     minprim = dbl_mb(PmnIm_a)
                  endif
               elseif (l_type .eq. (l_max + 1)) then
                  maxprim = dbl_mb(PmxIm_a+l_type-1)
                  minprim = dbl_mb(PmnIm_a+l_type-1)
               elseif (l_type .eq. l_max) then
                  maxprim = max(dbl_mb(PmxIm_a+l_type),
     $                          dbl_mb(PmxIm_a+l_type-1))
                  minprim = min(dbl_mb(PmnIm_a+l_type),
     $                          dbl_mb(PmnIm_a+l_type-1))
               else
                  maxprim = max(dbl_mb(PmxIm_a+l_type),
     $                          dbl_mb(PmxIm_a+l_type-1),
     $                          dbl_mb(PmxIm_a+l_type+1))
                  minprim = min(dbl_mb(PmnIm_a+l_type),
     $                          dbl_mb(PmxIm_a+l_type-1),
     $                          dbl_mb(PmnIm_a+l_type+1))
               endif
               nprim = log(maxprim/minprim)/log(dk_ratio) + 1
               alpha = (maxprim/minprim)**(1.0d0/dble(nprim-1))
               if (.not. bas_uce_tag(basis_in,iatom, usetag))
     $          call errquit('bas_create_uncont: bas_cont_tag failed',0,
     &       BASIS_ERR)
               do 21 iprim = 1, nprim
                  if (.not. bas_add_ucnt(basis_out,usetag,l_type,1,1,
     $                0.0d0,maxprim,1.0d0,1,name, .false.)) call errquit 
     $                ('bas_create_uncont: bas_add_ucnt',0, BASIS_ERR)
                  maxprim = maxprim / alpha
   21          continue
   20       continue
   17    continue
         if (.not. ma_pop_stack(Pmnm_a))
     $     call errquit('bas_create_uncont: ma__pop_stack Pmn array',0,
     &       MA_ERR)
         if (.not. ma_pop_stack(Pmxm_a))
     $     call errquit('bas_create_uncont: ma__pop_stack Pmx array',0,
     &       MA_ERR)
      else
         do 15 iprim = 1, nuniqprim
            if (.not. bas_uce_tag(basis_in,int_mb(AIm_a+iprim-1),
     $                             usetag)) 
     $         call errquit ('bas_create_uncont: bas_cont_tag failed',0,
     &       BASIS_ERR)
            if (.not. bas_add_ucnt(basis_out,usetag,
     $                            int_mb(LIm_a+iprim-1),1,1,0.0d0,
     $                            dbl_mb(ExpIm_a+iprim-1),1.0d0,1,name,
     $                            .false.))
     $         call errquit ('bas_create_uncont: bas_add_ucnt',0,
     &       BASIS_ERR)
   15    continue
      endif
c
      if (.not. bas_get_spherical(basis_in,spheri))
     $     call errquit('bas_create_uncont: bas_get_spherical',0,
     &       BASIS_ERR)
      if (.not. bas_set_spherical(basis_out,spheri))
     $     call errquit('bas_create_uncont: bas_set_spherical',0,
     &       BASIS_ERR)
c
      if (.not. ma_pop_stack(Am_a))
     $   call errquit('bas_create_uncont: ma_pop_stack Sm_a',0,
     &       MA_ERR)
      if (.not. ma_pop_stack(Sm_a))
     $   call errquit('bas_create_uncont: ma_pop_stack Sm_a',0,
     &       MA_ERR)
      if (.not. ma_pop_stack(Lm_a))
     $   call errquit('bas_create_uncont: ma_pop_stack Lm_a',0,
     &       MA_ERR)
      if (.not. ma_pop_stack(Expm_a))
     $   call errquit('bas_create_uncont: ma_pop_stack Expm_a',0,
     &       MA_ERR)
c
c     Store the uncontracted basis on the RTDB
c
      if (.not. bas_rtdb_store(usertdb,name,basis_out))
     $   call errquit('bas_create_uncont: bas_rtdb_store failed',0,
     &       RTDB_ERR)
c
c     Do a delete for bas_add_ucnt_init with the strange name tidy
c
      if (.not. bas_add_ucnt_tidy(basis_out)) call errquit
     &      ('bas_create_uncont: bas_add_ucnt_tidy failed',0,
     &       BASIS_ERR)
c
      if (.not. bas_destroy(basis_out))
     $   call errquit('bas_create_uncont: bas_destroy failed',0,
     &       BASIS_ERR)
c
c     Load the uncontracted basis from the RTDB
c
      if (.not. bas_create(basis_out,name))
     $   call errquit('bas_create_uncont: bas_create failed',0,
     &       BASIS_ERR)
      if (.not. bas_rtdb_load(usertdb,usegeom,basis_out,name))
     $   call errquit('bas_create_uncont: bas_rtdb_load failed',0,
     &       RTDB_ERR)
c
c     Normalize the uncontracted fitting basis 
c
      call int_normalize(usertdb,basis_out)
c
      return
c
      end
c
      subroutine bas_unique_sort(rd,id1,id2,id3,length,iuniq)
      implicit none
c
      integer length, iuniq
      integer id1(length), id2(length), id3(length)
      double precision rd(length)
c
      integer iloop, jloop, kloop
c
      iuniq = length
    1 continue
      do 2 iloop = 1, iuniq
         do 3 jloop = iloop+1, iuniq 
            if ((dabs(rd(iloop)-rd(jloop)).lt.1.0d-5)
     $          .and.(id1(iloop).eq.id1(jloop)) .and.
     $          (id3(iloop).eq.id3(jloop))) then
               do 4 kloop = jloop+1, iuniq
                  rd(kloop-1) = rd(kloop)
                  id1(kloop-1) = id1(kloop)
                  id2(kloop-1) = id2(kloop)
                  id3(kloop-1) = id3(kloop)
    4          continue
               iuniq = iuniq - 1
               goto 1
            endif
    3    continue
    2 continue
c
      return
c
      end

      subroutine mp2_wai_uhf(nva_lo,nva_hi,sym_lo_oa,sym_hi_oa,
     $     sym_lo_va,sym_hi_va,num_oa,nvb_lo,nvb_hi,
     $     sym_lo_ob,sym_hi_ob,num_ob,sym_lo_vb,sym_hi_vb,
     $     nir,num_va,num_vb,oseg_lo,oseg_hi,irs_a,irs_b,
     $     nva_lo_local,nva_hi_local,noa_lo,noa_hi,
     $     nob_lo,nob_hi,nva,nvb,noa,nob,t_a,t_b,
     $     ij_ka,g_iajk_a,g_iajk_b,
     $     ioff_vooo_a,ioff_vooo_b,tunita,tunitb,
     $     p_ai_a,p_ai_b,w_ai_a,w_ai_b)
*
* $Id: mp2_wai_uhf.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
      integer i,c,jk
      integer noa_lo,noa_hi,nva_lo,nva_hi
      integer sym_lo_oa(0:*),sym_hi_oa(0:*)
      integer sym_lo_va(0:*),sym_hi_va(0:*)
      integer num_oa(0:*),num_va(0:*)
      integer nob_lo,nob_hi,nvb_lo,nvb_hi
      integer sym_lo_ob(0:*),sym_hi_ob(0:*)
      integer sym_lo_vb(0:*),sym_hi_vb(0:*)
      integer num_ob(0:*),num_vb(0:*)
      integer noa,nva,nob,nvb,counter
      integer nir
      integer ioff_vooo_a(noa*noa,0:nir-1),ioff_vooo_b(nob*nob,0:nir-1)
      integer a_a
      integer oseg_lo,oseg_hi
      double precision zero,one,minusone,half
      integer syma,symi,symb,symj,symia,symc,symk,symik,symib
      integer irs_a(*),irs_b(*),b,j,k
      integer nva_lo_local,nva_hi_local,noa_lo_local,noa_hi_local,cb,jb
      double precision t_a(*),t_b(*),ij_ka(*)
      double precision p_ai_a(*),p_ai_b(*),w_ai_a(*),w_ai_b(*)
      integer g_iajk_a,g_iajk_b
      integer counta,countb,tunitptra,tunitptrb,tunita,tunitb,ierr
      integer msg_w_ai_a_sum,msg_w_ai_b_sum
      parameter(msg_w_ai_a_sum=9992)
      parameter(msg_w_ai_b_sum=9991)
c     
      zero=0.0d0
      one=1.0d0
      minusone=-1.0d0
      half=0.5d0
      tunitptra=1
      tunitptrb=1
      do i=oseg_lo,oseg_hi 
         symi=irs_a(i)
         do syma=0,nir-1
            counter=0
            do symk=0,nir-1
               do k=sym_lo_oa(symk),sym_hi_oa(symk)
                  symia=ieor(syma,symi)
                  symj=ieor(symia,symk)
                  ioff_vooo_a(k,syma)=counter
                  counter=counter+num_oa(symj)
               enddo
            enddo
         enddo
         do syma=0,nir-1
            counter=0
            do symk=0,nir-1
               do k=sym_lo_ob(symk),sym_hi_ob(symk)
                  symia=ieor(syma,symi)
                  symj=ieor(symia,symk)
                  ioff_vooo_b(k,syma)=counter
                  counter=counter+num_ob(symj)
               enddo
            enddo
         enddo
         do a_a=nva_lo_local,nva_hi_local
            syma=irs_a(a_a)
            symia=ieor(syma,symi)
            do b=nva_lo,nva_hi
               symb=irs_a(b)
               symk=ieor(symb,symia)
               if(num_oa(symk).ne.0)then
                  counta=sym_hi_oa(symk)-sym_lo_oa(symk)+1
                  call getwa(tunita,t_a(sym_lo_oa(symk)),
     $                 tunitptra,counta,ierr)
                  if(ierr.ne.0)call errquit(
     $                 'could not read t_a back',ierr, DISK_ERR)
                  tunitptra=tunitptra+counta
               endif
            enddo
            do b=nvb_lo,nvb_hi
               symb=irs_b(b)
               symk=ieor(symb,symia)
               if(num_ob(symk).ne.0)then
                  countb=sym_hi_ob(symk)-sym_lo_ob(symk)+1
                  call getwa(tunitb,t_b(sym_lo_ob(symk)),
     $                 tunitptrb,countb,ierr)
                  if(ierr.ne.0)call errquit(
     $                 'could not read t_b back',ierr, DISK_ERR)
                  tunitptrb=tunitptrb+countb
               endif
            enddo
            do symk=0,nir-1
               symj=ieor(symia,symk)
               symc=ieor(symia,symk)
               if(num_oa(symj).gt.0.and.num_oa(symk).gt.0.and.
     $              num_va(symc).gt.0)then
                  jk=1
                  do k=sym_lo_oa(symk),sym_hi_oa(symk)
                     call ga_get(g_iajk_a,ioff_vooo_a(k,syma)+1,
     $                    ioff_vooo_a(k,syma)+num_oa(symj),
     $                    a_a-nva_lo+1,a_a-nva_lo+1,
     $                    ij_ka(jk),1)
                     jk=jk+num_oa(symj)
                  enddo 
                  call dgemm('t','n',num_va(symc),
     $                 num_oa(symk),num_oa(symj),one,
     $                 ij_ka,num_oa(symj),t_a,num_oa(symj),
     $                 half,w_ai_a,num_va(symc))
               endif
               if(num_ob(symj).gt.0.and.num_ob(symk).gt.0.and.
     $              num_vb(symc).gt.0)then
                  jk=1
                  do k=sym_lo_ob(symk),sym_hi_ob(symk)
                     call ga_get(g_iajk_b,ioff_vooo_b(k,syma)+1,
     $                    ioff_vooo_b(k,syma)+num_ob(symj),
     $                    a_a-nva_lo+1,a_a-nva_lo+1,
     $                    ij_ka(jk),1)
                     jk=jk+num_ob(symj)
                  enddo
                  call dgemm('t','n',num_vb(symc),
     $                 num_ob(symk),num_ob(symj),one,
     $                 ij_ka,num_ob(symj),t_b,num_ob(symj),
     $                 half,w_ai_b,num_vb(symc))
               endif
            enddo
         enddo
      enddo
      end

      subroutine sym_geom_project(geom, tol)
C     $Id: sym_geom_prj.F 20089 2011-03-14 20:27:45Z d3p852 $
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "sym.fh"
#include "mafdecls.fh"
#include "util.fh"
      integer geom
      double precision tol
c     
c     Apply a projection operator to the geometry
c     so that it posesses the symmetry of the group
c     to machine precision.  An atom and the image of
c     that atom under the operations of the group are
c     considered to be identical iff they are less than
c     tol distant from each other.  
c     
      integer iat, jat, k, op
      integer nops, nat, l_tmp, k_tmp
      double precision rnew(3), r, dx, dy, dz
      logical geom_check_handle, geom_print
      external geom_check_handle, geom_print
c     
      if (.not. geom_check_handle(geom, 'sym_geom_project'))
     $     call errquit('sym_geom_project: bad geom',0, GEOM_ERR)
c
      nops = sym_number_ops(geom)
c     
      nat = ncenter(geom)
      if (.not. ma_push_get(mt_dbl, 3*nat, 'coordtmp', l_tmp, k_tmp))
     $     call errquit('sym_geom_project: scratch space', 3*nat,
     &       MA_ERR)
c     
      if (util_print('sym_geom_project', print_debug)) then
         write(6,*) ' sym_geom_project: Input geometry'
         if (.not. geom_print(geom)) call errquit
     $        ('sym_geom_project: geom print failed',0, GEOM_ERR)
      endif
c
c     Map periodic system back to main unit cell with identity symmetry
c
      if(isystype(geom).gt.0) then
         do iat = 1, nat
            op = -9999 ! Secret identity flag - maps back to unit cell only
            call sym_apply_cart_op(geom, op, coords(1,iat,geom), rnew)
            coords(1,iat,geom)=rnew(1)
            coords(2,iat,geom)=rnew(2)
            coords(3,iat,geom)=rnew(3)
         end do
      end if
c
      call dcopy(3*nat, coords(1,1,geom), 1, dbl_mb(k_tmp), 1)
c
      do iat = 1, nat
         do op = 1, nops
            jat = sym_center_map(geom, iat, op)
C           This call maps back to unit cell in periodic cells
            call sym_apply_cart_op(geom, op, coords(1,iat,geom), rnew)
            dx = rnew(1)-coords(1,jat,geom)
            dy = rnew(2)-coords(2,jat,geom)
            dz = rnew(3)-coords(3,jat,geom)
            r = sqrt(dx**2 + dy**2 + dz**2)
            if (r.le.tol) then
               do k = 1, 3
                  dbl_mb(k_tmp-1 + k + (jat-1)*3) = 
     $                 dbl_mb(k_tmp-1 + k + (jat-1)*3) + rnew(k)
               enddo
            else
               if (.not. geom_print(geom)) call errquit
     $            ('sym_geom_project: geom print failed',0, GEOM_ERR)
               call errquit('sym_geom_project: sym_center_map'//
     $             ' is inconsistent with requested accuracy',
     $              op, INPUT_ERR)
            end if
         end do
      end do
c     
      call dscal(3*nat, 1.0d0/dble(nops+1), dbl_mb(k_tmp), 1)
c
      call dcopy(3*nat, dbl_mb(k_tmp), 1, coords(1,1,geom), 1)
c     
c     Should also munge any applied electric field which must be
c     totally symmetric and therefore invariant to all group
c     operations.
c     
c     
      if (util_print('sym_geom_project', print_debug)) then
         write(6,*) ' sym_geom_project: Output geometry'
         if (.not. geom_print(geom)) call errquit
     $        ('sym_geom_project: geom print failed',0, GEOM_ERR)
      endif
c
      if (.not.ma_pop_stack(l_tmp)) call errquit('s_g_p: ma?',0, MA_ERR)
c
c     May have changed the coords ... recompute derived info
c
        call geom_compute_values(geom)

      end

C> \ingroup nwint
C> @{
C>
C> \brief Compute 1-electron Gaussian periodic kinetic energy
C> integrals
C>
C> See [1] for details.
C>
C> [1] JE Jaffe, AC Hess,
C>     <i>"Gaussian basis density functional theory for systems 
C>     periodic in two or three dimensions: Energy and forces"</i>,
C>    J.Chem.Phys. <b>105</b>, 10983-10998 (1996), DOI:
C>    <a href="http://dx.doi.org/10.1063/1.472866">
C>    10.1063/1.472866</a>
C>
      subroutine intp_1eke(i_basis,ish,j_basis,jsh,R,lscr,scr,lke,Ke)
c $Id: intp_1eke.F 23392 2013-01-07 20:00:04Z d3y133 $
      implicit none
#include "nwc_const.fh"
#include "errquit.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
#include "stdio.fh"
c::external subroutines used
c... errquit
c::functions
      logical cando_nw_1e
      logical cando_nw
      logical int_chk_init
      logical int_chk_sh
      external int_chk_init
      external int_chk_sh
      external cando_nw_1e
      external cando_nw
c::passed
      integer i_basis !< [Input] basis set handle for ish functions
      integer j_basis !< [Input] basis set handle for jsh functions
      integer ish     !< [Input] lexical contraction/shell index
      integer jsh     !< [Input] lexical contraction/shell index
      integer lscr    !< [Input] length of the scratch array
      integer lke     !< [Input] length of kinetic energy integral array
      double precision Ke(lke)   !< [Output] kinetic energy integral array
      double precision scr(lscr) !< [Scratch] scratch array
      double precision R(3)      !< [Input] translational vector in fractional coords
c::local
      logical shells_ok
      integer i_geom, j_geom, ibas, jbas, ucont
      integer Li, i_prim, i_gen, i_iexp, i_icfp, i_cent
      integer Lj, j_prim, j_gen, j_iexp, j_icfp, j_cent
      double precision xyz_new(3)  ! new coordinates for jsh function center
*rak:      integer jjj
c
      logical inline_chk_sh
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c... statement function for int_chk_sh
      inline_chk_sh(ibas,ish) =
     $     ((ish.gt.0) .and. (ish.le.ncont_tot_gb(ibas)))
c
c check initialization and shells
c
      if (.not.int_chk_init('intp_1eke'))
     &       call errquit('intp_1eke: int_init was not called' ,0, 
     &          INT_ERR)
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
c
      shells_ok = inline_chk_sh(ibas,ish)
      shells_ok = shells_ok .and. inline_chk_sh(jbas,jsh)
      if (.not.shells_ok)
     &       call errquit('intp_1eke: invalid contraction/shell',0,
     &          INT_ERR)
c
      ucont   = (sf_ibs_cn2ucn(ish,ibas))
      Li      = infbs_cont(CONT_TYPE ,ucont,ibas)
      i_prim  = infbs_cont(CONT_NPRIM,ucont,ibas)
      i_gen   = infbs_cont(CONT_NGEN ,ucont,ibas)
      i_iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      i_icfp  = infbs_cont(CONT_ICFP ,ucont,ibas)
      i_cent  = (sf_ibs_cn2ce(ish,ibas))
      i_geom  = ibs_geom(ibas)
c
      ucont   = (sf_ibs_cn2ucn(jsh,jbas))
      Lj      = infbs_cont(CONT_TYPE ,ucont,jbas)
      j_prim  = infbs_cont(CONT_NPRIM,ucont,jbas)
      j_gen   = infbs_cont(CONT_NGEN ,ucont,jbas)
      j_iexp  = infbs_cont(CONT_IEXP ,ucont,jbas)
      j_icfp  = infbs_cont(CONT_ICFP ,ucont,jbas)
      j_cent  = (sf_ibs_cn2ce(jsh,jbas))
      j_geom  = ibs_geom(jbas)
c
      if (i_geom.ne.j_geom.and.WarnP.eq.0) then
        write(luout,*)
     &      'intp_1eke: WARNING: possible geometry inconsistency'
        write(luout,*)'i_basis geometry handle:',i_geom
        write(luout,*)'j_basis geometry handle:',j_geom
        WarnP = 1
      endif
c
c.. translate coordinates based on R
      call intp_txyz(j_cent,j_geom,R,xyz_new)
c
      if (cando_nw_1e(i_basis,ish,0).and.cando_nw_1e(j_basis,jsh,0))
     &    then
        call int_hf1sp(
     &         coords(1,i_cent,i_geom),dbl_mb(mb_exndcf(i_iexp,ibas)),
     &         dbl_mb(mb_exndcf(i_icfp,ibas)),
     &         i_prim, i_gen, Li, i_cent,
     &         xyz_new,dbl_mb(mb_exndcf(j_iexp,jbas)),
     &         dbl_mb(mb_exndcf(j_icfp,jbas)),
     &         j_prim, j_gen, Lj, j_cent,
     &         coords(1,1,i_geom),charge(1,i_geom),
     &         geom_invnucexp(1,i_geom),ncenter(i_geom),
c............................. doS    doT     doV     canonical
     &         scr,Ke,scr,lke,.false.,.true.,.false.,.false.,
c.............. dryrun
     &         .false.,scr,lscr,'intp_1eke')
        if (bas_spherical(ibas).or.bas_spherical(jbas)) then
          if (Li.eq.-1) i_gen = 1
          if (Lj.eq.-1) j_gen = 1
          call spcart_2ctran(Ke,scr,lscr,
     &        int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &        int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &        .false.)          
        endif
      else
        call errquit('intp_1eke: could not do sp or nw integrals',0,
     &         INT_ERR)
      endif
c
      end
C> @}

      subroutine speech_input(rtdb)
*
* $Id: speech_input.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "mafdecls.fh"
      integer rtdb
c
c     speech <integer hostname> <integer portnumber>
c
c     Identify the server for spoken output.  If the hostname is "off"
c     then disable speech.
c
      character*255 hostname
      integer port
      logical status
c
      if (.not. inp_a(hostname)) call errquit
     $     ('speech_input: failed reading the hostname', 0, INPUT_ERR)
c
      if (inp_compare(.false.,hostname,'off')) then
         status = rtdb_delete(rtdb,'speech:hostname')
         status = rtdb_delete(rtdb,'speech:port')
         return
      endif
c         
      if (.not. inp_i(port)) call errquit
     $     ('speech_input: failed reading the port',0, INPUT_ERR)
c
c     Initialize speech here so that input modules can speak
c
      call util_speak_init(hostname, port)
c
      if (.not. rtdb_cput(rtdb,'speech:hostname',1,hostname))
     $     call errquit('speech_input: failed rtdb_cput hostname',0,
     &       RTDB_ERR)
      if (.not. rtdb_put(rtdb,'speech:port',mt_int,1,port))
     $     call errquit('speech_input: failed rtdb_put port',0,
     &       RTDB_ERR)
c
      end

      subroutine ccsd_rdtrpo(t1,buf1,buf2,g_objo,g_objv,
     $     nocc,nvir,iprt)
C     $Id: ccsd_rdtrpo.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
c     
#include "ccsd_len.fh"
      integer g_objo,g_objv,nocc,nvir,iprt
      double precision t1(nvir,nocc),buf1(lnobj),buf2(lnobj)
c     
      integer i,j,k,a,av,bv,ad1,ad2,lbfo
      Integer Nodes, IAm
      integer g_tmp, start, end
C     
#include "msgids.fh"
#include "tcgmsg.fh"
#include "global.fh"
C     
      Nodes = GA_NNodes()
      IAm = GA_NodeID()
      call ga_sync
c     
c     - read in objects
c     - [io|ov], [oo|iv], t2(io:vv) / [ao|vo], t2(oo:av), t2(oo,va)
c     
      lbfo=lnovv+lnoov+lnoov
c     
c     do av ... uses 2*oov+ooo memory.  Don't use locality
c     so that we can distribute more uniformly across nodes.
c     Locality is not used in the triples driver.
c     
      do av=iam+1,nvir,nodes 
c     
c     get dint and eint
         call ga_get(g_objv,1,2*lnoov+lnooo,av,av,buf1,
     &        2*lnoov+lnooo)
c     
c     process eints for occupied indexed buffer
         do i=1,nocc
c     eintc
            ad1=0
            do j=1,nocc
               do k=1,nocc
                  ad1=ad1+1
                  buf2(ad1)=buf1(lnoov+(j-1)*lnoo+(i-1)*nocc+k)
               end do
            end do
            ad2=lnovv+(av-1)*lnoo
            call ga_put(g_objo,ad2+1,ad2+lnoo,i,i,buf2,lnoo)
c     eintx
            ad1=lnoov+(i-1)*lnoo+1
            ad2=lnovv+lnoov+(av-1)*lnoo
            call ga_put(g_objo,ad2+1,ad2+lnoo,i,i,buf1(ad1),lnoo)
         end do
c     
c     process dints for virtual indexed buffer
         ad1=0
         do i=1,nocc
            do j=1,nocc
               do bv=1,nvir
                  ad1=ad1+1
                  ad2=(bv-1)*lnoo+(i-1)*nocc+j
                  buf2(ad1)=buf1(ad2)
               end do
            end do
         end do
c     
c     process t2 amplitudes for virtual indexed buffer
c     t2c
         do i=1,nocc
            do j=1,nocc
               do bv=1,nvir
                  ad1=ad1+1
                  ad2=lnoov+lnooo+(bv-1)*lnoo+(i-1)*nocc+j
                  buf2(ad1)=buf1(ad2)
               end do
            end do
         end do
c     t2x
         do i=1,nocc
            do j=1,nocc
               do bv=1,nvir
                  ad1=ad1+1
                  ad2=lnoov+lnooo+(bv-1)*lnoo+(j-1)*nocc+i
                  buf2(ad1)=buf1(ad2)
               end do
            end do
         end do
         if (iprt.gt.50)then
            print *,'t2c new ',iam,av
            write(6,4859)(buf2(j),j=lnoov+1,2*lnoov)
            print *,'t2x new ',iam,av
            write(6,4859)(buf2(j),j=2*lnoov+1,3*lnoov)
            print *,'dint new ',iam,av
            write(6,4859)(buf2(j),j=1,lnoov)
 4859       format(1x,5e14.4)
         end if
         call ga_put(g_objv,1,ad1,av,av,buf2,ad1)
c     
c     process t2 amplitudes for occupied indexed buffer
c     t2j
         do i=1,nocc
            ad1=0
            do j=1,nocc
               do bv=1,nvir
                  ad1=ad1+1
                  buf2(ad1)=
     $                 buf1(lnoov+lnooo+(bv-1)*lnoo+(i-1)*nocc+j)
               end do
            end do
            ad2=(av-1)*lnov
            call ga_put(g_objo,ad2+1,ad2+lnov,i,i,buf2,lnov)
         end do
c     
      end do
c     
      call ga_sync()            ! ga_sync ensures all GA ops complete
c     
c     sort t1 then broadcast
c     
      if (iam.eq.0)then
         call ga_get(g_objv,lnoov+lnooo+1,lnoov+lnooo+lnov,
     $        nvir+1,nvir+1, buf1,lnov)
         ad1=0
         do a=1,nvir
            do i=1,nocc
               ad1=ad1+1
               t1(a,i)=buf1(ad1)
            end do
         end do
      end if
      call ga_brdcst(msg_cc_t1b,t1,mdtob(lnov),0)
c
c     Next phase transposes bits withing g_objo.  To avoid OVV local
c     memory, duplicate g_objo and do some smaller operations
c     to accomplish the sort in O(V) memory.
c     
      call ga_sync
c
      if (.not. ga_duplicate(g_objo, g_tmp, 'rtdpro')) call errquit
     $     ('ccsd_rdtpro: failed to allocate tmp GA',0, GA_ERR)
      call ga_copy(g_objo, g_tmp)
c
      do i=1+iam,nocc,nodes
c     t2j
**         start = 1
**         end   = lnovv
**         call ga_get(g_tmp,start,end,i,i,buf1,lnovv)
**         ad1 = 0
         do j=1,nocc
            do av=1,nvir
**               do bv=1,nvir
**                  ad1=ad1+1
**                  buf2(ad1)=buf1((av-1)*lnov+(j-1)*nvir+bv)
**               end do
               start = (av-1)*lnov+(j-1)*nvir+1
               end   = start + nvir - 1
               call ga_get(g_tmp,start,end,i,i,buf1,nvir)
c
               start = (av-1)*nvir+(j-1)*nvir*nvir+1
               end   = start + nvir - 1
               call ga_put(g_objo,start,end,i,i,buf1,nvir)
            end do
         end do
**         call ga_put(g_objo,start,end,i,i,buf2,lnovv)
c
c     eintc
         start = lnovv + 1
         end   = start + 2*lnoov - 1
         call ga_get(g_tmp,start,end,i,i,buf1,2*lnoov)
         ad1=0
         do j=1,nocc
            do av=1,nvir
               do k=1,nocc
                  ad1=ad1+1
                  ad2=(av-1)*lnoo+(j-1)*nocc+k
                  buf2(ad1)=buf1(ad2)
c     buf1(ad1)=gtint(i,a,j,k)
               end do
            end do
         end do
c     - eintx
         do j=1,nocc
            do av=1,nvir
               do k=1,nocc
                  ad1=ad1+1
                  ad2=lnoov+(av-1)*lnoo+(j-1)*nocc+k
                  buf2(ad1)=buf1(ad2)
c     buf1(ad1)=gtint(i,k,j,a)
               end do
            end do
         end do
c
         call ga_put(g_objo,start,end,i,i,buf2,2*lnoov)
c     
      end do
c     
      call ga_sync()
c
      if (.not. ga_destroy(g_tmp)) call errquit
     $     ('ccsd_trdpro: failed to destroy GA',0, GA_ERR)
c     
      end

*
* $Id: lcao_new_mix_dn.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      subroutine lcao_new_mix_dn(alpha,ispin,ne,n2ft3d,dn,
     >                           psimatrix,phi,rho_error,reset_diis)
      implicit none
#include "errquit.fh"
      real*8  alpha
      integer ispin,ne(2)
      integer n2ft3d
      real*8 dn(n2ft3d,2)
      integer psimatrix(*)
      complex*16 phi(*)
      real*8     rho_error
      logical    reset_diis

#include "mafdecls.fh"
#include "global.fh"

*     **** local variables ****
      logical value
      integer n,k,nbasis,ms
      integer nx,ny,nz
      real*8  scal1,scal2,dv,sum
      integer tmp(2),newdn(2),coef(2),dnerr(2)
      real*8  rho_error_old


*     ***** external functions ****
      integer  aorbs_nbasis
      real*8   lattice_omega
      external aorbs_nbasis
      external lattice_omega


      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()
      dv    = scal1*lattice_omega()

      nbasis = aorbs_nbasis()

      value = MA_push_get(mt_dbl,n2ft3d,'tmp',tmp(2),tmp(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(2*n2ft3d),'newdn',newdn(2),newdn(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(2*n2ft3d),'dnerr',dnerr(2),dnerr(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(nbasis),'coef',coef(2),coef(1))
      if (.not. value) 
     >  call errquit('lcao_new_mix_dn:out of stack memory',0, MA_ERR)


      call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(newdn(1)),1)
      do ms=1,ispin
         do n=1,ne(ms)

*           **** calculate electronic wavefunction ****
            call ga_get(psimatrix(ms),1,nbasis,n,n,
     >                  dbl_mb(coef(1)),nbasis) 
            call lcao_make_psi(dbl_mb(coef(1)),dbl_mb(tmp(1)),phi)

*           **** put in real-space ***
            call Pack_c_unpack(1,dbl_mb(tmp(1)))
            call D3dB_cr_pfft3b(1,1,dbl_mb(tmp(1)))

*           **** add to density ****
            do k=1,n2ft3d
              dbl_mb(newdn(1)+(ms-1)*n2ft3d+k-1)  
     >        = dbl_mb(newdn(1)+(ms-1)*n2ft3d+k-1) 
     >        + scal2*(dbl_mb(tmp(1)+k-1)**2)
            end do

         end do
      end do


*     **** calculate rho_error ****
      rho_error_old = rho_error
      rho_error     = 0.0d0
      do ms=1,ispin
         call D3dB_r_Zero_Ends(1,dbl_mb(newdn(1)+(ms-1)*n2ft3d))
         do k=1,n2ft3d
            call D3dB_rr_Minus(1,
     >                         dbl_mb(newdn(1)+(ms-1)*n2ft3d),
     >                         dn(1,ms),
     >                         dbl_mb(dnerr(1)+(ms-1)*n2ft3d))

         end do
         call D3dB_rr_dot(1,dbl_mb(dnerr(1)+(ms-1)*n2ft3d),
     >                      dbl_mb(dnerr(1)+(ms-1)*n2ft3d),
     >                      sum)
         rho_error = rho_error + sum
      end do
      rho_error = rho_error*dv
      if (rho_error.ge.rho_error_old) alpha=0.2d0*alpha

c     reset_diis =    (rho_error.ge.rho_error_old)
c    >           .or.(rho_error.gt.1.0d0)
      reset_diis =    (rho_error.ge.rho_error_old)
     >           .or.(rho_error.gt.0.10d0)

      if (.not. reset_diis) then
*       **** Calculate New Density = using DIIS *****
        call lcao_diis_dn_generate(alpha,ispin,n2ft3d,
     >                           dbl_mb(newdn(1)),
     >                           dn,reset_diis)
      end if


*     **** soften the new density by the old density ****
      if (reset_diis) then
      do ms=1,ispin
         do k=1,n2ft3d
            dn(k,ms) = alpha*dbl_mb(newdn(1)+(ms-1)*n2ft3d+k-1) 
     >                  + (1.0d0-alpha)*dn(k,ms)
         end do
      end do
      end if


c*     **** normalize densities ***
c      do ms=1,ispin
c        call D3dB_r_dsum(1,dn(1,ms),sum)
c        sum = sum*dv
c        sum = dble(ne(ms))/sum
c        call D3dB_r_SMul(1,sum,dn(1,ms),dn(1,ms))
c      end do

      value = MA_pop_stack(coef(2))
      value = value.and.
     >        MA_pop_stack(dnerr(2))
      value = value.and.
     >        MA_pop_stack(newdn(2))
      value = value.and.
     >        MA_pop_stack(tmp(2))
      if (.not. value) 
     >  call errquit('lcao_init_dn:popping stack memory',0, MA_ERR)
      return
      end

      subroutine tce_jacobi_sub_t2(d_r2,d_t2,k_t2_offset,iter,iref)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_mrcc.fh"
      integer d_r2
      integer d_t2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_t2_offset
      integer size
      integer l_r2,k_r2
      integer l_t2,k_t2
      integer i
      integer nprocs
      integer count
      integer nex
cc      integer nxtval
c
      integer iter
      integer iref
      double precision denom 
c
cc      external nxtval
      INTEGER NXTASKsub
      EXTERNAL NXTASKsub
      logical nodezero
      logical noloadbalance
c *** shift ***
      double precision shift
c *************
      if(iter.le.100) then
       shift=-(2.0d0)*zlshift
      else
       shift=0.0d0
      end if
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
c      noloadbalance = ((ioalg.eq.4).or. 
c     1                ((ioalg.eq.6).and.(.not.fileisga(d_r2))))
      nprocs=GA_pgroup_NNODES(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
      count = 0
      nex=NXTASKsub(nprocs,1,int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
c      call GA_Pgroup_SYNC(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do h3b = 1,noab
            do h4b = h3b,noab
              if (nex.eq.count) then
                if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1            .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
                if ((.not.restricted).or.
     1            (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2            int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
                if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1            ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2            .eq. 0) then
                  size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1                 * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)

                  if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1              call errquit('tce_jacobi_t2: MA problem',0,MA_ERR)
                  call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
c                if(lsubterm) then
                  if (.not.ma_push_get(mt_dbl,size,'t2',l_t2,k_t2))
     1              call errquit('tce_jacobi_t2: MA problem',0,MA_ERR)
                  call get_hash_block(d_t2,dbl_mb(k_t2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
c                endif

                  i = 0
c *** shift added ***
ccc               shift=0.50d0
c *******************
                  do p1 = 1,int_mb(k_range+p1b-1)
                    do p2 = 1,int_mb(k_range+p2b-1)
                      do h3 = 1,int_mb(k_range+h3b-1)
                        do h4 = 1,int_mb(k_range+h4b-1)
                          i = i + 1

              denom = (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              +dbl_mb(k_evl_sorted+int_mb(k_offset+h3b-1)+h3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1)
     5              +mrccshift)

       if((abs(denom).lt.0.01d0).and.
     1 (abs(dbl_mb(k_r2+i-1)/denom).gt.1.0d0))
     1  then
       write(6,"('2DENOM CLOSE TO ZERO: ',F16.10,F16.10,F16.10)")
     1 denom,dbl_mb(k_t2+i-1),dbl_mb(k_r2+i-1)
c       if(denom.lt.0.0d0) then
c        shift=-1.0d10 
c       else 
c        shift=1.0d10
c       endif
       endif

              if(.not.lsubterm) then

         if(forcedegen) then

                          dbl_mb(k_r2+i-1) = (dbl_mb(k_r2+i-1))
     1           / (orbdegenenergy(iref,h3b)
     1             +orbdegenenergy(iref,h4b)
     1             -orbdegenenergy(iref,p1b)
     1             -orbdegenenergy(iref,p2b)+mrccshift)
         else
                          dbl_mb(k_r2+i-1) = (dbl_mb(k_r2+i-1))
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              +dbl_mb(k_evl_sorted+int_mb(k_offset+h3b-1)+h3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1)
     5              +shift+mrccshift)
         endif
              else
  
         if(forcedegen) then

                          dbl_mb(k_r2+i-1) = (dbl_mb(k_r2+i-1)
     1             -mrccshift*dbl_mb(k_t2+i-1))
     1           / (orbdegenenergy(iref,h3b)
     1             +orbdegenenergy(iref,h4b)
     1             -orbdegenenergy(iref,p1b)
     1             -orbdegenenergy(iref,p2b)+mrccshift)

        else

                          dbl_mb(k_r2+i-1) = (dbl_mb(k_r2+i-1)
     1             -mrccshift*dbl_mb(k_t2+i-1))
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              +dbl_mb(k_evl_sorted+int_mb(k_offset+h3b-1)+h3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1)
     5              +shift+mrccshift)

c                          dbl_mb(k_r2+i-1) = ((dbl_mb(k_r2+i-1)
c     1             -mrccshift*dbl_mb(k_t2+i-1))*denom)
c     1           / (denom*denom+shift*shift)
          endif
              endif
c       shift=0.0d0

c       if(abs(dbl_mb(k_r2+i-1)).gt.20.0d0) then
c           if(dbl_mb(k_r2+i-1).lt.0.0d0) then
c               dbl_mb(k_r2+i-1)=-20.0d0
c           else
c               dbl_mb(k_r2+i-1)=20.0d0
c           endif
c           write(6,"('2RESIDUE HAS BEEN CUTED')")
c       endif
      if(iter .lt. 4) then
       if(.not. lreadt) then
        if(abs(dbl_mb(k_r2+i-1)).gt.0.1d0) then
         if(dbl_mb(k_r2+i-1).lt.0.0d0) then
               dbl_mb(k_r2+i-1)=-0.01d0
         else
               dbl_mb(k_r2+i-1)=0.01d0
         endif
c        if(nodezero) 
c          write(luout,*)"t2 residue has been modified to 0.01"
c        if(nodezero) call util_flush(LuOut)
        endif
       endif
      endif




                        enddo
                      enddo
                    enddo
                  enddo
                  call add_hash_block(d_t2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
c update of the res.-double vector to the form of increment used in DIIS proc.
c                  call put_hash_block(d_r2,dbl_mb(k_r2),size,
c     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
c     2              *noab+h3b-1)*noab+h4b-1))
c ----------------------------------------------------------------------------
                  if (nodezero.and.util_print('t2',print_debug)) 
     1              then
                    call get_hash_block(d_t2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
                    call ma_print_compact
     2              (dbl_mb(k_r2),size,1,'t2')
                  endif
c                 if(lsubterm) then
                  if (.not.ma_pop_stack(l_t2))
     1              call errquit('tce_jacobi_t2: MA problem',1,MA_ERR)
c                 endif
                  if (.not.ma_pop_stack(l_r2))
     1              call errquit('tce_jacobi_t2: MA problem',1,MA_ERR)
                endif
                endif
                endif
      nex=NXTASKsub(nprocs,1,int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
              endif
              count = count + 1
            enddo
          enddo
        enddo
      enddo
      nex=NXTASKsub(-nprocs,1,int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
      call GA_Pgroup_SYNC(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
      call util_flush(LuOut)
      return
      end
c
c
c
c
c $Id: tce_jacobi_sub_t2.F 24345 2013-06-22 06:19:30Z d3y133 $

      SUBROUTINE ccsd_e(d_f1,d_i0,d_t1,d_t2,d_v2,k_f1_offset,k_i0_offset
     &,k_t1_offset,k_t2_offset,k_v2_offset)
C     $Id: ccsd_e.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_tf + = 1 * Sum ( p5 h6 ) * t ( p5 h6 )_t * i1 ( h6 p5 )_f                     DONE
C         i1 ( h6 p5 )_f + = 1 * f ( h6 p5 )_f                                             DONE
C         i1 ( h6 p5 )_vt + = 1/2 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 h6 p3 p5 )_v    DONE
C     i0 ( )_vt + = 1/4 * Sum ( h3 h4 p1 p2 ) * t ( p1 p2 h3 h4 )_t * v ( h3 h4 p1 p2 )_v  DONE
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
c when local copies of  T1/X1 tensors are used,  d_t1 refers to k_t1_local (kk)
      INTEGER d_i0,k_i0_offset
      INTEGER d_t1,k_t1_offset
      INTEGER d_i1,k_i1_offset,l_i1_offset
      INTEGER d_t2,k_t2_offset
      INTEGER d_v2,k_v2_offset
      INTEGER d_f1,k_f1_offset
      INTEGER size_i1
      CHARACTER*255 filename
      CALL OFFSET_ccsd_e_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsd_e_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsd_e_copy_fock_to_t(d_f1,k_f1_offset,d_i1,k_i1_offset)
      CALL ccsd_e_1_2(d_t1,k_t1_offset,d_v2,k_v2_offset,
     1                d_i1,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsd_e_1(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) 
     1     CALL ERRQUIT('ccsd_e',-1,MA_ERR)
      CALL ccsd_e_2(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i0,k_i0_offset)
      RETURN
      END




      SUBROUTINE ccsd_e_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: ccsd_e.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_tf + = 1 * Sum ( p5 h6 ) * t ( p5 h6 )_t * i1 ( h6 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a,d_b,d_c
      INTEGER k_a_offset,k_b_offset,k_c_offset
      INTEGER NXTASK,next,nprocs,count
      INTEGER p5b,h6b,p5b_1,h6b_1,h6b_2,p5b_2
      INTEGER dim_p,dim_h,dim_ph,p,h
      INTEGER k_a,k_b,l_b,k_c,l_c
#ifdef LOCAL_COPY
      INTEGER l_a
#else
      INTEGER offset_a
#endif
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      IF (next.eq.count) THEN
       IF (0 .eq. ieor(irrep_t,irrep_f)) THEN
c
c     create output array
c
      IF (.not.MA_PUSH_GET(mt_dbl,1,'noname',l_c,k_c))
     1     CALL ERRQUIT('ccsd_e_1',0,MA_ERR)
      dbl_mb(k_c) = 0.0d0
c
      DO p5b = noab+1,noab+nvab
       DO h6b = 1,noab
        IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h6b-1)) THEN
         IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h6b-1))
     1       .eq.irrep_t) THEN
          CALL TCE_RESTRICTED_2(p5b,h6b,p5b_1,h6b_1)
          CALL TCE_RESTRICTED_2(h6b,p5b,h6b_2,p5b_2)
          dim_p = int_mb(k_range+p5b-1)
          dim_h = int_mb(k_range+h6b-1)
          dim_ph = dim_p * dim_h
          IF (dim_ph .gt. 0) THEN
c
c          a = t1
c
#ifdef LOCAL_COPY
           IF (.not.MA_PUSH_GET(mt_dbl,dim_ph,'a',l_a,k_a))
     1          CALL ERRQUIT('ccsd_e_1',2,MA_ERR)
           CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dim_ph,
     1          int_mb(k_a_offset),
     2          (h6b_1 - 1 + noab * (p5b_1 - noab - 1)))
#else
           call tce_hash(int_mb(k_a_offset),
     1                   (h6b_1 - 1 + noab * (p5b_1 - noab - 1)),
     2                   offset_a)
           k_a = d_a + offset_a
#endif
c
c          b = i1 = f1 + v2 * t1
c
           IF (.not.MA_PUSH_GET(mt_dbl,dim_ph,'b',l_b,k_b))
     1          CALL ERRQUIT('ccsd_e_1',5,MA_ERR)
           CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dim_ph,
     1          int_mb(k_b_offset),
     2          (p5b_2 - noab - 1 + nvab * (h6b_2 - 1)))
c
c          do the contraction as 2D dot product
c          c += Sum(p,h) a(p,h) * b(h,p)
c
           do p = 0,dim_p-1
            do h = 0,dim_h-1
             dbl_mb(k_c) = dbl_mb(k_c)
     1                   + dbl_mb(k_a + (dim_h * p) + h )
     2                   * dbl_mb(k_b + (dim_p * h) + p )
            enddo
           enddo
c
c          free arrays
c
           IF (.not.MA_POP_STACK(l_b)) 
     1          CALL ERRQUIT('ccsd_e_1',6,MA_ERR)
#ifdef LOCAL_COPY
           IF (.not.MA_POP_STACK(l_a)) 
     1          CALL ERRQUIT('ccsd_e_1',3,MA_ERR)
#endif
          END IF
         END IF
        END IF
       END DO
      END DO
c
c     sort output array and post to GA
c
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),1,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c))
     1     CALL ERRQUIT('ccsd_e_1',10,MA_ERR)
c
       END IF
       next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END




      SUBROUTINE ccsd_e_copy_fock_to_t(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd_e.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h6 p5 )_f + = 1 * f ( h6 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a,d_c
      INTEGER k_a_offset,k_c_offset
      INTEGER NXTASK,next,nprocs,count
      INTEGER h6b,p5b
      INTEGER h6b_1,p5b_1
      INTEGER dim_ph
      INTEGER k_a,l_a
      INTEGER k_c,l_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO h6b = 1,noab
       DO p5b = noab+1,noab+nvab
        IF (next.eq.count) THEN
         IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)
     1                            +int_mb(k_spin+p5b-1).ne.4)) THEN
          IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
           IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1))
     1         .eq. irrep_f) THEN
            CALL TCE_RESTRICTED_2(h6b,p5b,h6b_1,p5b_1)
            dim_ph = int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
            IF (dim_ph .gt. 0) THEN
             IF (.not.MA_PUSH_GET(mt_dbl,dim_ph,'a',l_a,k_a))
     1            CALL ERRQUIT('copy_fock_to_t',1,MA_ERR)
             CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dim_ph,
     1                           int_mb(k_a_offset),
     1                           (p5b_1-1 + (noab+nvab) * (h6b_1-1)))
             CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_a),dim_ph,
     1                           int_mb(k_c_offset),
     2                           (p5b-noab-1 + nvab * (h6b-1)))
             IF (.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('copy_fock_to_t',2,MA_ERR)
            END IF
           END IF
          END IF
         END IF
         next = NXTASK(nprocs, 1)
        END IF
        count = count + 1
       END DO
      END DO
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END




      SUBROUTINE ccsd_e_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: ccsd_e.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h6 p5 )_vt + = 1/2 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 h6 p3 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a,d_b,d_c
      INTEGER k_a_offset,k_b_offset,k_c_offset
      INTEGER NXTASK,next,nprocs,count
      INTEGER h6b,p5b,p3b,h4b,p3b_1,h4b_1,h6b_2,h4b_2,p5b_2,p3b_2
      INTEGER dim_common,dima_sort,dimb_sort,dima,dimb,dimc
      INTEGER k_as,l_as,k_bs,l_bs,k_c_sort,l_c_sort
      INTEGER k_a,k_b,l_b,k_c,l_c
#ifdef LOCAL_COPY
      INTEGER l_a
#else
      INTEGER offset_a
#endif
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO h6b = 1,noab
       DO p5b = noab+1,noab+nvab
        IF (next.eq.count) THEN
         IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)
     1                            +int_mb(k_spin+p5b-1).ne.4)) THEN
          IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
           IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1)) 
     1     .eq.ieor(irrep_v,irrep_t)) THEN
            dimc = int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
            IF (.not.MA_PUSH_GET(mt_dbl,dimc,'cs',l_c_sort,k_c_sort))
     1           CALL ERRQUIT('ccsd_e_1_2',0,MA_ERR)
            CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
            DO p3b = noab+1,noab+nvab
             DO h4b = 1,noab
              IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h4b-1)) THEN
               IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h4b-1)) 
     1             .eq. irrep_t) THEN
                CALL TCE_RESTRICTED_2(p3b,h4b,p3b_1,h4b_1)
                CALL TCE_RESTRICTED_4(h6b,h4b,p5b,p3b,
     1                                h6b_2,h4b_2,p5b_2,p3b_2)
                dim_common = int_mb(k_range+p3b-1) 
     1                     * int_mb(k_range+h4b-1)
                dima_sort = 1
                dima = dim_common * dima_sort
                dimb_sort = int_mb(k_range+h6b-1) 
     1                    * int_mb(k_range+p5b-1)
                dimb = dim_common * dimb_sort
                IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
                 IF (.not.MA_PUSH_GET(mt_dbl,dima,'as',l_as,k_as))
     1                CALL ERRQUIT('ccsd_e_1_2',1,MA_ERR)
#ifdef LOCAL_COPY
                 IF (.not.MA_PUSH_GET(mt_dbl,dima,'a',l_a,k_a))
     1                CALL ERRQUIT('ccsd_e_1_2',2,MA_ERR)
                 CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     1                int_mb(k_a_offset),
     2                (h4b_1 - 1 + noab * (p3b_1 - noab - 1)))
#else
                 call tce_hash(int_mb(k_a_offset),
     1                         (h4b_1 - 1 + noab * (p3b_1 - noab - 1)),
     2                         offset_a)
                 k_a = d_a + offset_a
#endif
                 CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_as),
     1                int_mb(k_range+p3b-1),
     2                int_mb(k_range+h4b-1),2,1,1.0d0)
#ifdef LOCAL_COPY
                 IF (.not.MA_POP_STACK(l_a))
     1                CALL ERRQUIT('ccsd_e_1_2',3,MA_ERR)
#endif
                 IF (.not.MA_PUSH_GET(mt_dbl,dimb,'bs',l_bs,k_bs))
     1                CALL ERRQUIT('ccsd_e_1_2',4,MA_ERR)
                 IF (.not.MA_PUSH_GET(mt_dbl,dimb,'b',l_b,k_b))
     1                CALL ERRQUIT('ccsd_e_1_2',5,MA_ERR)
                 IF ((h4b .le. h6b) .and. (p3b .le. p5b)) THEN
                  if(.not.intorb) then
                   CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p5b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + 
     3                  (noab+nvab) * (h6b_2 - 1 + (noab+nvab) * 
     4                  (h4b_2 - 1)))))
                  else
                   CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p5b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + 
     3                  (noab+nvab) * (h6b_2 - 1 + (noab+nvab) * 
     4                  (h4b_2 - 1)))),p5b_2,p3b_2,h6b_2,h4b_2)
                  end if
                  CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_bs),
     1                 int_mb(k_range+h4b-1),int_mb(k_range+h6b-1),
     2                 int_mb(k_range+p3b-1),int_mb(k_range+p5b-1),
     3                 4,2,1,3,1.0d0)
                 END IF
                 IF ((h4b .le. h6b) .and. (p5b .lt. p3b)) THEN
                  if(.not.intorb) then
                   CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p3b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + 
     3                  (noab+nvab) * (h6b_2 - 1 + (noab+nvab) * 
     4                  (h4b_2 - 1)))))
                  else 
                   CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p3b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + 
     3                  (noab+nvab) * (h6b_2 - 1 + (noab+nvab) * 
     4                  (h4b_2 - 1)))),p3b_2,p5b_2,h6b_2,h4b_2)
                  end if
                  CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_bs),
     1                  int_mb(k_range+h4b-1),int_mb(k_range+h6b-1),
     2                  int_mb(k_range+p5b-1),int_mb(k_range+p3b-1),
     3                  3,2,1,4,-1.0d0)
                 END IF
                 IF ((h6b .lt. h4b) .and. (p3b .le. p5b)) THEN
                  if(.not.intorb) THEN
                   CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p5b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + 
     3                  (noab+nvab) * (h4b_2 - 1 + (noab+nvab) * 
     4                  (h6b_2 - 1)))))
                  else
                   CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p5b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + 
     3                  (noab+nvab) * (h4b_2 - 1 + (noab+nvab) * 
     4                  (h6b_2 - 1)))),p5b_2,p3b_2,h4b_2,h6b_2)
                  end if
                  CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_bs),
     1                 int_mb(k_range+h6b-1),int_mb(k_range+h4b-1),
     2                 int_mb(k_range+p3b-1),int_mb(k_range+p5b-1),
     3                 4,1,2,3,-1.0d0)
                 END IF
                 IF ((h6b .lt. h4b) .and. (p5b .lt. p3b)) THEN
                  if(.not.intorb) then
                   CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p3b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + 
     3                  (noab+nvab) * (h4b_2 - 1 + (noab+nvab) * 
     4                  (h6b_2 - 1)))))
                  else
                   CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,
     1                  int_mb(k_b_offset),
     2                  (p3b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + 
     3                  (noab+nvab) * (h4b_2 - 1 + (noab+nvab) * 
     4                  (h6b_2 - 1)))),p3b_2,p5b_2,h4b_2,h6b_2)
                  end if
                  CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_bs),
     1                 int_mb(k_range+h6b-1),int_mb(k_range+h4b-1),
     2                 int_mb(k_range+p5b-1),int_mb(k_range+p3b-1),
     3                 3,1,2,4,1.0d0)
                 END IF
                 IF (.not.MA_POP_STACK(l_b))
     1                CALL ERRQUIT('ccsd_e_1_2',6,MA_ERR)
                 CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,
     1                1.0d0,dbl_mb(k_as),dim_common,dbl_mb(k_bs),
     2                dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
                 IF (.not.MA_POP_STACK(l_bs))
     1                CALL ERRQUIT('ccsd_e_1_2',7,MA_ERR)
                 IF (.not.MA_POP_STACK(l_as))
     1                CALL ERRQUIT('ccsd_e_1_2',8,MA_ERR)
                END IF
               END IF
              END IF
             END DO
            END DO
            IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c))
     1           CALL ERRQUIT('ccsd_e_1_2',9,MA_ERR)
            CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),
     1           int_mb(k_range+p5b-1),int_mb(k_range+h6b-1),
     2           2,1,1.0d0/2.0d0)
            CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,
     1           int_mb(k_c_offset),(p5b - noab - 1 + nvab * (h6b - 1)))
            IF (.not.MA_POP_STACK(l_c))
     1           CALL ERRQUIT('ccsd_e_1_2',10,MA_ERR)
            IF (.not.MA_POP_STACK(l_c_sort))
     1           CALL ERRQUIT('ccsd_e_1_2',11,MA_ERR)
           END IF
          END IF
         END IF
         next = NXTASK(nprocs, 1)
        END IF
        count = count + 1
       END DO
      END DO
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END




      SUBROUTINE ccsd_e_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: ccsd_e.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_vt + = 1/4 * Sum ( h3 h4 p1 p2 ) * t ( p1 p2 h3 h4 )_t * v ( h3 h4 p1 p2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a,d_b,d_c
      INTEGER k_a_offset,k_b_offset,k_c_offset
      INTEGER NXTASK,next,nprocs,count
      INTEGER p1,p2,h3,h4
      INTEGER p1b,p2b,h3b,h4b
      INTEGER p1b_1,p2b_1,h3b_1,h4b_1
      INTEGER h3b_2,h4b_2,p1b_2,p2b_2
      INTEGER dim_p1,dim_p2,dim_h3,dim_h4,dim_pphh
      INTEGER k_a,l_a,k_b,l_b,k_c,l_c
      INTEGER k_as,l_as
      INTEGER k_bs,l_bs
      INTEGER nsuperp,nsubh
      DOUBLE PRECISION alpha
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      IF (next.eq.count) THEN
       IF (0 .eq. ieor(irrep_v,irrep_t)) THEN
c
c     create output array
c
      IF (.not.MA_PUSH_GET(mt_dbl,1,'noname',l_c,k_c)) 
     1     CALL ERRQUIT('ccsd_e_2',9,MA_ERR)
      dbl_mb(k_c) = 0.0d0
c
      DO p1b = noab+1,noab+nvab
       DO p2b = p1b,noab+nvab
        DO h3b = 1,noab
         DO h4b = h3b,noab
          IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. 
     1        int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
           IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1         ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2         .eq. irrep_t) THEN
            CALL TCE_RESTRICTED_4(p1b,p2b,h3b,h4b,
     1                            p1b_1,p2b_1,h3b_1,h4b_1)
            CALL TCE_RESTRICTED_4(h3b,h4b,p1b,p2b,
     1                            h3b_2,h4b_2,p1b_2,p2b_2)
            dim_p1 = int_mb(k_range+p1b-1) 
            dim_p2 = int_mb(k_range+p2b-1) 
            dim_h3 = int_mb(k_range+h3b-1) 
            dim_h4 = int_mb(k_range+h4b-1) 
            dim_pphh = dim_p1*dim_p2*dim_h3*dim_h4
            IF (dim_pphh .gt. 0) THEN
c
c            a = t2
c
             IF (.not.MA_PUSH_GET(mt_dbl,dim_pphh,'as',l_as,k_as)) 
     1            CALL ERRQUIT('ccsd_e_2',1,MA_ERR)
             IF (.not.MA_PUSH_GET(mt_dbl,dim_pphh,'a',l_a,k_a))
     1            CALL ERRQUIT('ccsd_e_2',2,MA_ERR)
             CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dim_pphh,
     1            int_mb(k_a_offset),
     2            (h4b_1 - 1 + noab * (h3b_1 - 1 + noab * 
     3            (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
             CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_as),
     1            dim_p1,dim_p2,dim_h3,dim_h4,
     2            3,4,1,2,1.0d0)
             IF (.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('ccsd_e_2',3,MA_ERR)
c
c            b = v2
c
             IF (.not.MA_PUSH_GET(mt_dbl,dim_pphh,'b',l_b,k_b))
     1            CALL ERRQUIT('ccsd_e_2',5,MA_ERR)
             if(.not.intorb) then
               CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dim_pphh,
     1           int_mb(k_b_offset),
     2           (p2b_2 - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) *
     3           (h4b_2 - 1 + (noab+nvab) * (h3b_2 - 1)))))
             else
               CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dim_pphh,
     1           int_mb(k_b_offset),
     2           (p2b_2 - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) *
     3           (h4b_2 - 1 + (noab+nvab) * (h3b_2 - 1)))),
     4           p2b_2,p1b_2,h4b_2,h3b_2)
             end if
c
c            symmetry renormalization
c
             alpha = 1.0d0
             IF (p1b .eq. p2b) THEN
               alpha = 0.5d0*alpha
             END IF
             IF (h3b .eq. h4b) THEN
               alpha = 0.5d0*alpha
             END IF
c
c            do the contraction
c
             CALL DGEMM('T','N',1,1,dim_pphh,alpha,
     1            dbl_mb(k_as),dim_pphh,dbl_mb(k_b),
     2            dim_pphh,1.0d0,dbl_mb(k_c),1)
c
c            delete arrays
c
             IF (.not.MA_POP_STACK(l_b))
     1            CALL ERRQUIT('ccsd_e_2',7,MA_ERR)
             IF (.not.MA_POP_STACK(l_as))
     1            CALL ERRQUIT('ccsd_e_2',8,MA_ERR)
            END IF
           END IF
          END IF
         END DO
        END DO
       END DO
      END DO
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),1,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_e_2',10,MA_ERR)
      END IF
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END




      SUBROUTINE OFFSET_ccsd_e_1_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd_e.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h6 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h6b
      INTEGER p5b
      length = 0
      DO h6b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p5b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd_e_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h6b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p5b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p5b - noab - 1 + nvab * (h6b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END

C $Id: ecp_skipint.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      logical function ecp_skipint(
     &    l_a,n_prim_a,n_cont_a,coef_a,zeta_a,R_AC,
     &    l_b,n_prim_b,n_cont_b,coef_b,zeta_b,R_BC,
     &    n_coef_c,zeta_c,coef_c)
*                                                                      *
*   Do screening check for ECP integrals                               *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   l_a (inp) - (maximum) angular momentum of functions on centre A    *
*   n_prim_a (inp) - number of primitive functions on centre A         *
*   n_cont_a (inp) - number of contracted functions on centre A        *
*   coef_a (inp) - centre A contraction coefficients                   *
*   zeta_a (inp) - centre A exponents                                  *
*   R_AC (inp) - distance between centres A and C                      *
*   l_b (inp) - (maximum) angular momentum of functions on centre B    *
*   n_prim_b (inp) - number of primitive functions on centre B         *
*   n_cont_b (inp) - number of contracted functions on centre B        *
*   coef_b (inp) - centre B contraction coefficients                   *
*   zeta_b (inp) - centre B exponents                                  *
*   R_BC (inp) - distance between centres B and C                      *
*   n_coef_c (inp) - number of coefficients/exponents for ECP          *
*   zeta_c (inp) - ECP exponents                                       *
*   coef_c (inp) - ECP contraction coefficients                        *
*                                                                      *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
#include "ecp_consts.fh"
      integer l_a,n_prim_a,n_cont_a
      integer l_b,n_prim_b,n_cont_b
      Integer n_coef_c
      integer i_a,i_b,i_c
      double precision zeta_c(n_coef_c)
      double precision coef_c(n_coef_c)
      double precision coef_a(n_prim_a,n_cont_a)
      double precision coef_b(n_prim_b,n_cont_b)
      double precision zeta_a(n_prim_a)
      double precision zeta_b(n_prim_b)
      double precision R_AB
      double precision R_AC
      double precision R_BC
      double precision log_prefac,pr,pre,pref,sum
      double precision a,b,c,ca,cb,aA,bB,ab,aAbB,abc,P,wa,wb
      logical first
*
      integer idamax
      external idamax
*
      wa = l_a
      wb = l_b
      first = .true.
      log_prefac = zero
*
      R_AB = abs(R_AC-R_BC)
      do i_b = 1,n_prim_b
        b = zeta_b(i_b)
        i_c = idamax(n_cont_b,coef_b(i_b,1),n_prim_b)
        if (abs(coef_b(i_b,i_c)) .ne. zero) then
          cb = log(abs(coef_b(i_b,i_c)))
        else
          cb = zero
        end if
        bB = b*R_BC 
        do i_a = 1,n_prim_a
          a = zeta_a(i_a)
          i_c = idamax(n_cont_a,coef_a(i_a,1),n_prim_a)
          if (abs(coef_a(i_a,i_c)) .ne. zero) then
            ca = log(abs(coef_a(i_a,i_c)))
          else
            ca = zero
          end if
          aA = a*R_AC 
          aAbB = aA+bB
          ab = zeta_a(i_a)+zeta_b(i_b)
          pref = zero
          sum = zero
          do i_c = 1,n_coef_c
            c = zeta_c(i_c)
            abc = ab+c
            P = aAbB/abc
            pre = 0.5d0*(log(pi)-log(abc))
     &          - (a*b*R_AB**2 + b*c*R_BC**2 + a*c*R_AC**2)/abc
            if (abs(R_AC-P) .gt. 1.0d-10) pre = pre+wa*log(abs(R_AC-P))
            if (abs(R_BC-P) .gt. 1.0d-10) pre = pre+wb*log(abs(R_BC-P))
            if (pref .eq. zero) then
              pref = pre
              sum = coef_c(i_c)
            else 
              pr = pre - pref
              if (pr .lt. zero) then
                if (pr .gt. ln_thr_ecp) 
     &              sum = sum+coef_c(i_c)*exp(pr)
              else
                if (-pr .gt. ln_thr_ecp) then
                  sum = sum*exp(-pr)
                else
                  sum = zero
                end if
                sum = sum+coef_c(i_c)
                pref = pre
              end if
            end if
          end do
          if (sum .ne. zero) pref = pref+log(abs(sum))
          pref = pref+ca+cb
          if (first) then
            log_prefac = pref
            first = .false.
          else
            log_prefac = max(log_prefac, pref)
          end if
        end do
      end do
*
      log_prefac = log_prefac + log(dble(n_prim_a*n_prim_b))
      ecp_skipint = log_prefac .lt. ln_thr_ecp
*
      return
      end

       subroutine thermo(nu,nv,nvv,ngr,icl,ims,den,t,rgrid,qqu,qvv,
     * hnew,cnew,solperm,tau) 
       implicit none
       real*8 muh, mugf, muuh(1:nu,1:nvv),muugf(1:nu,1:nvv)        
       integer  nu, nv,nvv, ngr, i,j1,j,icl        
       real*8 rgrid(1:ngr)  
       real*8 pi,dr,kb,t,kcal,theta,ck,echar,solperm,nav,tau
       real*8 den(1:nv)
       integer ims(1:nv)
       real*8 cnew(1:nu,1:nvv,1:ngr), hnew(1:nu,1:nvv,1:ngr)
       real*8 ul(1:nu,1:nvv,1:ngr),hq(1:nu,1:nvv,1:ngr)
       real*8 ulr(1:nu,1:nvv,1:ngr),qvv(1:nvv),qqu(1:nu)
       real*8 erf
#ifndef GFORTRAN
       external erf
#endif
c
       pi=2*asin(1.0)
       kb=8.13441e-3
       kcal=0.00198717 
       mugf=0 
       muh=0
       do j=1,nu
        do j1=1,nvv
         muugf(j,j1)=0
         muuh(j,j1)=0
        enddo
       enddo
       dr=rgrid(2)-rgrid(1)
       nav=6.02214179e+23
       echar=4.803e-10
       ck=nav*echar**2/solperm*0.01
c  ulr electrostatic part of the interaction potential in real space
       do j=1,nu
        do j1=1,nvv     
         do i=1,ngr 
          ulr(j,j1,i)=ck*qqu(j)*qvv(j1)/rgrid(i)*erf(tau*rgrid(i))/4.1868
         enddo    
        enddo
       enddo 
c calculations of partial contibutions 
       do j=1,nu
        do j1=1,nvv  
         do i=1,ngr
          if(icl.eq.1) then 
            hq(j,j1,i)=hnew(j,j1,i)
          endif
          if(icl.eq.2) then 
           hq(j,j1,i)= -theta(-hnew(j,j1,i))
          endif           
          muugf(j,j1)=muugf(j,j1)-(2*cnew(j,j1,i)+hnew(j,j1,i)*
     *    (cnew(j,j1,i)-ulr(j,j1,i)/kcal/t))*rgrid(i)**2*dr*2*pi
          muuh(j,j1)=muuh(j,j1)-(2*cnew(j,j1,i)+hnew(j,j1,i)*
     *    (cnew(j,j1,i)-ulr(j,j1,i)/kcal/t))*rgrid(i)**2*dr*2*pi
     *    +hnew(j,j1,i)*hq(j,j1,i)*rgrid(i)**2*dr*2*pi   
         enddo    
        enddo
       enddo 
       do j=1,nu
        do j1=1,nv
         mugf=mugf+den(j1)*muugf(j,ims(j1))*kcal*t 
         muh=muh+den(j1)*muuh(j,ims(j1))*kcal*t       
        enddo
       enddo             
c           print*, mugf,muh
c  mugf chem.potential in gaussian approximation
c muh   chem.potential in hnc approximation         
       open(3, file='tout.data', status='unknown')         
        write(3,108) muh,mugf
       close(3)
  108  format(2(2x,e10.4))
       return 
       end subroutine
c
      real*8 function theta(x)
      real*8 x
       if(x.le.0.0)then
        theta=x
        else
        theta=0
       endif
       return
       end      
c
c $Id: rism_thermo.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function jvltest(rtdb)
*     
*     $Id: jvltest.F 19708 2010-10-29 18:04:21Z d3y133 $
*      calling routine for CCSD(T) trials
*
      implicit none
      integer rtdb
c...    rtdb is handle to database
c
      call triple_so(rtdb)
c
      jvltest = .true.
c
      end

      subroutine triple_so(rtdb)
c
c...  first stab at a triple code for CCSD(T)
c...  using spin-orbital integrals sitting in core 
c...  for now a 4-dimensional array of <ij||ab> 
c
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
      integer nn_almlof,nn_laguer
      parameter (nn_almlof=8, nn_laguer=200)
      integer rtdb,n_almlof,np_almlof(nn_almlof),
     1             n_laguer,np_laguer(nn_laguer)
c
      integer occ,virt,nbasis
      logical oexist
      integer l_rint,k_rint,l_t1,k_t1,l_t2,k_t2,l_orb,k_orb
      integer l_orbn,k_orbn
      double precision delta,energy
      integer i
      character*26 date
c
c...  check existence of required files
c
      inquire(file='T2',exist=oexist)
      if (.not. oexist)
     $     call errquit('jvltest: no T2 ', 0, UNKNOWN_ERR)
      inquire(file='ASOINTS',exist=oexist)
      if (.not. oexist)
     $     call errquit('jvltest: no ASOINTS ', 0, UNKNOWN_ERR)
      inquire(file='EVALS',exist=oexist)
      if (.not. oexist)
     $     call errquit('jvltest: no EVALS ', 0, UNKNOWN_ERR)
c
c... get basis size from T2
c
      open(9,file='T2',form='formatted')
      read(9,*) occ,virt
      nbasis = occ + virt
      close(9)
c
c..     integrals
c     double precision rint(nbasis,nbasis,nbasis,nbasis)
      if (.not. ma_push_get(mt_dbl, nbasis**4,'rint',l_rint, k_rint))
     $    call errquit('rint',0, MA_ERR)
c..    amplitudes 
c     double precision t1(occ,virt), t2(occ,occ,virt,virt)
      if (.not. ma_push_get(mt_dbl, occ**2*virt**2,'t2',l_t2, k_t2))
     $    call errquit('t2',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, occ*virt,'t1',l_t1, k_t1))
     $    call errquit('t1',0, MA_ERR)
c..    the orb  (orbital energies)
c     double precision orb(nbasis)
      if (.not. ma_push_get(mt_dbl, nbasis,'orb',l_orb, k_orb))
     $    call errquit('orb',0, MA_ERR)
c
      call get_INTS(dbl_mb(k_rint),nbasis)
      call get_T1(dbl_mb(k_t1),occ,virt)
      call get_T2(dbl_mb(k_t2),occ,virt)
      call get_EVALS(dbl_mb(k_orb),nbasis,occ,virt)
c
*     call calc_robert(dbl_mb(k_rint),dbl_mb(k_t1),dbl_mb(k_t2),
*    1                dbl_mb(k_orb),nbasis,occ,virt)
c
*     call calc_pople(dbl_mb(k_rint),dbl_mb(k_t1),dbl_mb(k_t2),
*    1                dbl_mb(k_orb),nbasis,occ,virt)
c
c...  now make modified (homo-lumo) orbital energies and 
c...  call all + cullen
c
*     if (.not. ma_push_get(mt_dbl, nbasis,'orbn',l_orbn, k_orbn))
*    $    call errquit('orbn',0)
*     call mod_EVALS(dbl_mb(k_orb),dbl_mb(k_orbn),nbasis,occ,virt)
c
*     print *,' ORBITAL ENERGIES TO HOMO-LUMO '
*     delta = dbl_mb(k_orb+occ-1) - dbl_mb(k_orb+occ)
*     print *,' delta e used ',delta
*     delta = delta * 3.0d0
c
*     call calc_robert(dbl_mb(k_rint),dbl_mb(k_t1),dbl_mb(k_t2),
*    1                dbl_mb(k_orbn),nbasis,occ,virt)
c
*     call calc_pople(dbl_mb(k_rint),dbl_mb(k_t1),dbl_mb(k_t2),
*    1                dbl_mb(k_orbn),nbasis,occ,virt)
c
c...  set orbital energies to 1 to get almlof to do cullen
c...  delta contains de delta e (*3)
c
      call dfill(nbasis,1.0d0,dbl_mb(k_orbn),1)
      delta = 1.0d0
      call calc_almlof(dbl_mb(k_rint),dbl_mb(k_t1),dbl_mb(k_t2),
     1                 delta,dbl_mb(k_orbn),
     2                 nbasis,occ,virt,energy,.true.)
c
c     try integrating
c
c     call mod_EVALS(dbl_mb(k_orb),dbl_mb(k_orbn),nbasis,occ,virt)
c     call dcopy(nbasis,dbl_mb(k_orbn),1,dbl_mb(k_orb),1)
c     print *,' cw keep ORBITAL ENERGIES as HOMO-LUMO '
c
*     if (.not.rtdb_get_info(rtdb,'cct_almlof',i,n_almlof,date))
*    1 then
*       n_almlof = 1
*       np_almlof(1) = 5
*     else
*      if (.not.rtdb_get(rtdb,'cct_almlof',MT_INT,nn_almlof,np_almlof))
*    1 call errquit(' cct_almlof ',0)
*     end if
c
*     do i=1,n_almlof
*     call int_almlof(dbl_mb(k_rint),dbl_mb(k_t1),dbl_mb(k_t2),
*    1                dbl_mb(k_orb),dbl_mb(k_orbn),   
*    2                nbasis,occ,virt,energy,np_almlof(i))
*     print *,np_almlof(i),' point almlof integrated energy ',energy
*     end do
c
*     if (.not.rtdb_get_info(rtdb,'cct_laguer',i,n_laguer,date))
*    1 then
*       n_laguer = 1
*       np_laguer(1) = 5
*     else
*      if (.not.rtdb_get(rtdb,'cct_laguer',MT_INT,nn_laguer,np_laguer))
*    1 call errquit(' cct_laguer ',0)
*     end if
c
*     do i=1,n_laguer
*     call int_laguer(dbl_mb(k_rint),dbl_mb(k_t1),dbl_mb(k_t2),
*    1                dbl_mb(k_orb),dbl_mb(k_orbn),   
*    2                nbasis,occ,virt,energy,np_laguer(i),rtdb)
*     print *,np_laguer(i),' point laguer integrated energy ',energy
*     end do
c
c...  free all core beyond rint
c
      if (.not. ma_chop_stack(l_rint)) call errquit(' ma chop?', 0,
     &       MA_ERR)
c
c      could also use ma_pop_stack(l_occ)  which is like gmem_free
c      (but using handle instead of pointer)
c
      end
      subroutine int_almlof(rint,t1,t2,orb,fac,nbasis,occ,virt,
     1                      energy,np)
c
c...   control routine for Almloef integration
c...   energy returns the finally computed energy
c...   np is thew # points to be used
c
      implicit none
#include "errquit.fh"
c
      integer nbasis,occ,virt,np
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt),t1(occ,virt)
      double precision orb(nbasis),fac(nbasis),energy
c
      integer ip,itw
      double precision enerp
      common/flop/ term1,term2,term3,term4
      double precision term1,term2,term3,term4,tt1,tt2,tt3,tt4
c
      integer npoint,nd
      parameter (npoint=8, nd=npoint*(npoint+1)/2)
      double precision t_alpha(nd), weight(nd)
c
      data t_alpha/0.2543066d0,
     2             0.1057374d0, 0.8263985d0,
     3             0.0664618d0, 0.4380785d0, 1.6101925d0,
     4             0.0135967d0, 0.1646374d0, 0.6569702d0, 2.0357815d0,
     5             0.0064785d0, 0.0669154d0, 0.3089156d0, 0.9478808d0,
     5             2.5786393d0,
     6             0.0060050d0, 0.0553016d0, 0.2346500d0, 0.6587781d0,
     6             1.5760606d0, 3.6502575d0,
     7             0.0035243d0, 0.0251939d0, 0.1193583d0, 0.3653936d0,
     7             0.8850526d0, 1.9454617d0, 4.2401468d0,
     8             0.0034250d0, 0.0238627d0, 0.1023430d0, 0.2947359d0,
     8             0.6736046d0, 1.3821837d0, 2.7133497d0, 5.4051090d0/
      data weight /0.7443778d0,
     2             0.2998529d0, 1.3750404d0,
     3             0.1793919d0, 0.6329602d0, 1.9996848d0,
     4             0.0527171d0, 0.2757647d0, 0.7858024d0, 2.2786679d0,
     5             0.0177806d0, 0.1278500d0, 0.3878375d0, 0.9741098d0,
     5             2.6125732d0,
     6             0.0164421d0, 0.0995694d0, 0.2759458d0, 0.6106806d0,
     6             1.3178664d0, 3.1857008d0,
     7             0.0095904d0, 0.0437062d0, 0.1566528d0, 0.3542937d0,
     7             0.7264528d0, 1.4928836d0, 3.4634348d0,
     8             0.0093035d0, 0.0390022d0, 0.1267465d0, 0.2692945d0,
     8             0.5112993d0, 0.9512673d0, 1.8163835d0, 3.9522146d0/
c
      tt1 = 0.0d0
      tt2 = 0.0d0
      tt3 = 0.0d0
      tt4 = 0.0d0
c
      if (np.gt.npoint) call errquit('almlof overflow',0, UNKNOWN_ERR)
      energy=0.0d0
      do ip=1,np
       energy=energy+dexp(-5.0d0*t_alpha(np*(np-1)/2 + ip))
     1                          *weight(np*(np-1)/2 + ip)
      end do
      print *,np,' points 0.2 is ', energy
c
      energy = 0.0d0
      do ip=1,np
       itw = np*(np-1)/2 + ip
       call cct_fac(orb,fac,nbasis,occ,virt,t_alpha(itw))
c
       call calc_almlof(rint,t1,t2,-1.0d0,fac,
     1                  nbasis,occ,virt,enerp,.false.)
c
       energy = energy + enerp * weight(itw)
c      print *,' point ',ip,' of ',np,' contr ',enerp,' energy ',energy
       tt1 = tt1 + term1*weight(itw)
       tt2 = tt2 + term2*weight(itw)
       tt3 = tt3 + term3*weight(itw)
       tt4 = tt4 + term4*weight(itw)
      end do
c      print *,' t ',tt1,tt2,tt3,tt4
c
      return
      end
      subroutine int_laguer(rint,t1,t2,orb,fac,nbasis,occ,virt,
     1                      energy,np,rtdb)
c
c...   control routine for Almloef integration
c...   using straight gauss-laguerre
c...   energy returns the finally computed energy
c...   np is thew # points to be used
c
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
      integer nbasis,occ,virt,np,rtdb
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt),t1(occ,virt)
      double precision orb(nbasis),fac(nbasis),energy
c
      integer ip,i,n
      double precision enerp,sum,avocc,avirt,delta
c
      integer npoint
      parameter (npoint= 200)
      double precision t_alpha(npoint), weight(npoint) 
      double precision scra(npoint), dum(2),elimit(2)
      character*26 date
c
      if (np.gt.npoint) call errquit(' enlarge int_laguer ',0,
     &       UNKNOWN_ERR)
      call gaussq(6,np,0.0d0,0.0d0,0,dum,scra,t_alpha,weight)
c
c...  dermine integration scale required
c     default : average delta e (*3)
c               might exclude extremes or all
c
      if (.not.rtdb_get_info(rtdb,'cct_laguer_scale',i,n,date))
     1 then
c..    default (-5 to +5 for now)
        elimit(1) = -5.0d0
        elimit(2) = +5.0d0
      else
       if (n.eq.0) then
c..    next default (all)
        elimit(1) = -9.0d99
        elimit(2) = +9.0d99
       else 
        if (.not.rtdb_get(rtdb,'cct_laguer_scale',MT_DBL,2,elimit))
     1     call errquit(' cct_laguer_scale ',0, RTDB_ERR)
        if (n.eq.1) elimit(2) = elimit(1)
        elimit(1) = -elimit(1)
       end if
      end if
c
c...    compute scale
c
      sum = 0.0d0
      n = 0
      do i=1,occ
         if (orb(i).gt.elimit(1)) then
            n = n + 1
            sum = sum + orb(i)
         end if
      end do
      avocc = sum/max0(n,1)
      ip = n
      sum = 0.0d0
      n = 0
      do i=occ+1,nbasis
         if (orb(i).lt.elimit(2)) then
            n = n + 1
            sum = sum + orb(i)
         end if
      end do
      avirt = sum/max0(n,1)
c...    scale
      delta = 3.0d0*(avirt-avocc)
      if (elimit(1).eq.0.0d0.and.elimit(2).ne.0.0d0) delta = elimit(2)
      if (delta .lt.1.0d-2) delta = 1.0d0
      print *,' laguerre scaled by ',delta,' kept ',ip,'/',n
c
c...  add the ex(xi) to weights
c
      energy=0.0d0
      do ip=1,np
       energy=energy+dexp(-5.0d0*t_alpha(ip)/delta)*weight(ip)
     1                           *dexp(t_alpha(ip))/delta
      end do
      print *,np,' points 0.2 is ', energy
c
      energy = 0.0d0
      do ip=1,np
       call cct_fac(orb,fac,nbasis,occ,virt,t_alpha(ip)/delta)
c
       call calc_almlof(rint,t1,t2,-1.0d0,fac,
     1                  nbasis,occ,virt,enerp,.false.)
c
       energy = energy + enerp * weight(ip)*dexp(t_alpha(ip))/delta
      end do
c
      return
      end

      subroutine get_EVALS(orb,nbasis,occ,virt)
c
c...  read orbital energies from EVALS
c
      implicit none
#include "errquit.fh"
c
      integer nbasis,occ,virt
      double precision orb(nbasis)
c
      integer nbin,i
      logical oexist
c
      inquire(file='EVALS',exist=oexist)
      if (.not.oexist) call errquit(' no EVAL ',0, UNKNOWN_ERR)
      open(9,file='EVALS',form='formatted')
      read(9,*) nbin
      if (nbin.ne.nbasis) call errquit('nbasis wrong',1, BASIS_ERR)
      do i=1,nbasis
         read(9,'(5x,f20.10)') orb(i)
      end do
      close(9)
c
      print *,' orbital energies read '
c     print *, orb
      return
      end
      subroutine mod_EVALS(orb,orbn,nbasis,occ,virt)
c
c...  make modified orbital energies  (homo/lumo)
c
      implicit none
c
      integer nbasis,occ,virt
      double precision orb(nbasis),orbn(nbasis)
      integer i
c
       do i=1,occ
         orbn(i) = orb(occ)
       end do
       do i=occ+1,nbasis
         orbn(i) = orb(occ+1)
       end do
c
      return
      end
      subroutine get_T2(t2,occ,virt)
c
c...  real t2 amplitudes from T2
c
      implicit none
#include "errquit.fh"
c
      integer occ,virt
      double precision t2(occ,occ,virt,virt)
c
      integer ocin,vin,i,j,a,b
      logical oexist
c
      inquire(file='T2',exist=oexist)
      if (.not.oexist) call errquit(' no T2 ',0, UNKNOWN_ERR)
      open(9,file='T2',form='formatted')
      read(9,*) ocin,vin
      if (ocin.ne.occ.or.vin.ne.virt) call errquit(' occ,virt wrong',0,
     &       UNKNOWN_ERR)
c
      call dfill(occ*occ*virt*virt,0.0d0,t2,1)
c
10    read(9,'(4i5,f20.10)',end=20) i,j,a,b,t2(i,j,a,b)
      go to 10
c
20    close(9)
      print *,' T2 read '
c     print *,((((t2(i,j,a,b),i=1,3),j=1,3),a=1,3),b=1,3)
c
      return
      end
      subroutine get_T1(t1,occ,virt)
c
c...  real t1 amplitudes from T1
c
      implicit none
#include "errquit.fh"
c
      integer occ,virt
      double precision t1(occ,virt)
c
      integer ocin,vin,i,a
      logical oexist
c
      inquire(file='T1',exist=oexist)
      if (.not.oexist) then
         print *,' no T1 '
         call dfill(occ*virt,0.0d0,t1,1)
         return
      end if
      open(9,file='T1',form='formatted')
      read(9,*) ocin,vin
      if (ocin.ne.occ.or.vin.ne.virt) call errquit(' occ,virt wrong',1,
     &       UNKNOWN_ERR)
c
      call dfill(occ*virt,0.0d0,t1,1)
c
10    read(9,'(2i5,f20.10)',end=20) i,a,t1(i,a)
      go to 10
c
20    close(9)
      print *,' T1 read '
c
      return
      end
      subroutine get_INTS(rint,nbasis)
c
c...  real integrals from ASOINTS
c
      implicit none
#include "errquit.fh"
c
      integer nbasis
      double precision rint(nbasis,nbasis,nbasis,nbasis)
c
      integer in,i,j,k,l
      logical oexist
c
      inquire(file='ASOINTS',exist=oexist)
      if (.not.oexist) call errquit(' no INTS ',0, DISK_ERR)
      open(9,file='ASOINTS',form='formatted')
      read(9,*) in
      if (in.ne.nbasis) call errquit(' nbasis on INTS wrong',0,
     &       BASIS_ERR)
c
      call dfill(nbasis**4,0.0d0,rint,1)
c
10    read(9,'(4i5,f20.10)',end=20) i,j,k,l,rint(i,j,k,l)
      go to 10
c
20    close(9)
      print *,' integrals read '
c     print *,((((rint(i,j,k,l),i=1,3),j=1,3),k=1,3),l=1,3)
c
      return
      end
      subroutine cct_fac(orb,fac,nbasis,occ,virt,factor)
c
c...  generatewd factores for laplace integration
c...  calculated as exp(-orb)*factor for occ
c...                exp(orb)*factor for virt
c
      implicit none
#include "errquit.fh"
      integer nbasis,occ,virt
      double precision orb(nbasis),fac(nbasis),factor
c
      integer i
c
      do i=1,occ
       fac(i) = dexp(orb(i)*factor)
      end do
      do i=occ+1,nbasis
       fac(i) = dexp(-orb(i)*factor)
      end do
c
      if (orb(occ).gt.0.0d0.or.orb(occ+1).lt.0.0d0)
     1 call errquit(' OEPS orbital energies ',0, UNKNOWN_ERR)
c     print *,' factor ... ',orb(occ),orb(occ+1)
c     print *,fac(1),fac(nbasis)
c     print *,(fac(1)*fac(nbasis))**3
c
      return
      end 
      subroutine calc_robert(rint,t1,t2,orb,nbasis,occ,virt)
c
c...   use Robert's formulae
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t1(occ,virt), t2(occ,occ,virt,virt)
      double precision orb(nbasis)
c..     intermediates
      double precision w1,w2,w3,w4,v,w1w1,w1w2,w1w3,w1w4
      double precision vw1,vw2,vw3,vw4
c
      double precision e1,e2,energy,delta
      integer i,j,k,a,b,c,e,m
c
      w1w1 = 0.0d0
      w1w2 = 0.0d0
      w1w3 = 0.0d0
      w1w4 = 0.0d0
      vw1 = 0.0d0
      vw2 = 0.0d0
      vw3 = 0.0d0
      vw4 = 0.0d0
c
      do i=1,occ
       do j=1,occ
        do k=1,occ
         do a=1,virt
          do b=1,virt
           do c=1,virt
            w1 = 0.0d0
            w2 = 0.0d0
            w3 = 0.0d0
            w4 = 0.0d0
            do e=1,virt
             w1 = w1 + t2(i,j,c,e)*rint(a+occ,b+occ,e+occ,k)
             w2 = w2 + t2(k,j,c,e)*rint(a+occ,b+occ,e+occ,i)
             w3 = w3 + t2(i,j,a,e)*rint(c+occ,b+occ,e+occ,k)
             w4 = w4 + t2(k,j,a,e)*rint(c+occ,b+occ,e+occ,i)
            end do
            do m=1,occ
             w1 = w1 + t2(k,m,a,b)*rint(c+occ,m,i,j)
             w2 = w2 + t2(i,m,a,b)*rint(c+occ,m,k,j)
             w3 = w3 + t2(k,m,c,b)*rint(a+occ,m,i,j)
             w4 = w4 + t2(i,m,c,b)*rint(a+occ,m,k,j)
            end do
            v = t1(k,c)*rint(i,j,a,b)
            delta = (orb(i)+orb(j)+orb(k)
     1            - orb(a+occ)-orb(b+occ)-orb(c+occ))
            w1w1 = w1w1 + w1*w1 / delta
            w1w2 = w1w2 + w1*w2 / delta
            w1w3 = w1w3 + w1*w3 / delta
            w1w4 = w1w4 + w1*w4 / delta
            vw1 = vw1 + v*w1 / delta
            vw2 = vw2 + v*w2 / delta
            vw3 = vw3 + v*w3 / delta
            vw4 = vw4 + v*w4 / delta
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  calculate energies
c
      e1 = (vw1 - 2.0d0*vw2 -2.0d0*vw3 + 4.0d0*vw4) /4.0d0
      e2 = (w1w1 - 2.0d0*w1w2 -2.0d0*w1w3 + 4.0d0*w1w4) /4.0d0
      print *,' w1w1 ',w1w1
      print *,' w1w2 ',w1w2
      print *,' w1w3 ',w1w3
      print *,' w1w4 ',w1w4
      energy = e1 + e2
c
      print *,' Robert : e1= ',e1,' e2= ',e2,' e= ',energy
c
      end
      subroutine calc_pople(rint,t1,t2,orb,nbasis,occ,virt)
c
c...   use Pople's formulae (who can argue with a Nobel-prize)
c...   BUT ... typed in from Laplace triple document (jvl)
c...   ( + formulae(QCI ...))
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t1(occ,virt), t2(occ,occ,virt,virt)
      double precision orb(nbasis)
c..     intermediates
      double precision u1,u2,u3,u4,u5,u6,u7,u8,u9,v1
c
      double precision e1,e2,energy,delta
      integer i,j,k,a,b,c,e,m
c
      e1 = 0.0d0
      e2 = 0.0d0
c
      do i=1,occ
       do j=1,occ
        do k=1,occ
         do a=1,virt
          do b=1,virt
           do c=1,virt
            u1 = 0.0d0
            u2 = 0.0d0
            u3 = 0.0d0
            u4 = 0.0d0
            u5 = 0.0d0
            u6 = 0.0d0
            u7 = 0.0d0
            u8 = 0.0d0
            u9 = 0.0d0
            do e=1,virt
             u1 = u1 + t2(i,j,a,e)*rint(b+occ,c+occ,e+occ,k)
             u2 = u2 + t2(i,j,b,e)*rint(c+occ,a+occ,e+occ,k)
             u3 = u3 + t2(i,j,c,e)*rint(a+occ,b+occ,e+occ,k)
             u4 = u4 + t2(k,i,a,e)*rint(b+occ,c+occ,e+occ,j)
             u5 = u5 + t2(k,i,b,e)*rint(c+occ,a+occ,e+occ,j)
             u6 = u6 + t2(k,i,c,e)*rint(a+occ,b+occ,e+occ,j)
             u7 = u7 + t2(j,k,a,e)*rint(b+occ,c+occ,e+occ,i)
             u8 = u8 + t2(j,k,b,e)*rint(c+occ,a+occ,e+occ,i)
             u9 = u9 + t2(j,k,c,e)*rint(a+occ,b+occ,e+occ,i)
            end do
            do m=1,occ
             u1 = u1 + t2(i,m,a,b)*rint(c+occ,m,j,k)
             u2 = u2 + t2(i,m,b,c)*rint(a+occ,m,j,k)
             u3 = u3 + t2(i,m,c,a)*rint(b+occ,m,j,k)
             u4 = u4 + t2(j,m,a,b)*rint(c+occ,m,k,i)
             u5 = u5 + t2(j,m,b,c)*rint(a+occ,m,k,i)
             u6 = u6 + t2(j,m,c,a)*rint(b+occ,m,k,i)
             u7 = u7 + t2(k,m,a,b)*rint(c+occ,m,i,j)
             u8 = u8 + t2(k,m,b,c)*rint(a+occ,m,i,j)
             u9 = u9 + t2(k,m,c,a)*rint(b+occ,m,i,j)
            end do
            v1 = t1(i,a)*rint(j,k,b+occ,c+occ) 
     1         + t1(i,b)*rint(j,k,c+occ,a+occ) 
     2         + t1(i,c)*rint(j,k,a+occ,b+occ) 
     3         + t1(j,a)*rint(k,i,b+occ,c+occ) 
     4         + t1(j,b)*rint(k,i,c+occ,a+occ)
     5         + t1(j,c)*rint(k,i,a+occ,b+occ) 
     6         + t1(k,a)*rint(i,j,b+occ,c+occ) 
     7         + t1(k,b)*rint(i,j,c+occ,a+occ)
     8         + t1(k,c)*rint(i,j,a+occ,b+occ) 
            delta = (orb(i)+orb(j)+orb(k)
     1            - orb(a+occ)-orb(b+occ)-orb(c+occ))
            e1 = e1+ v1*(u1+u2+u3+u4+u5+u6+u7+u8+u9) / delta
            e2 = e2+ (u1+u2+u3+u4+u5+u6+u7+u8+u9)**2 / delta
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  calculate energies
c
      e1 = e1 / 36.0d0
      e2 = e2 / 36.0d0
      energy = e1 + e2
c
      print *,' Pople  : e1= ',e1,' e2= ',e2,' e= ',energy
c
      end
      subroutine calc_almlof(rint,t1,t2,delta,fac,nbasis,occ,virt,
     1                       energy,opr)
c
c...   this routine can do Cullen+Zerner's approach by
c...   setting all fac'a ,to 1 and delta to delta e
c...   for almlof delta is set to 1
c
c...   starting from "Robert's" formula
c     notation v(vv) : running index (virtual), o(oo)= running occupied)
c
c
      implicit none
#include "errquit.fh"
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t1(occ,virt), t2(occ,occ,virt,virt)
      double precision delta,fac(nbasis),energy
      logical opr
#include "global.fh"
#include "mafdecls.fh"
c
c...  functions
c
      double precision cct_so_a4a,cct_so_a4b,cct_so_b4b
      double precision cct_so_a3a,cct_so_a3b,cct_so_b3b
      double precision cct_so_a2a,cct_so_a2b,cct_so_b2b
      double precision cct_so_a1a,cct_so_a1b,cct_so_b1b
c
      double precision term4,term_a4a,term_a4b,term_b4b
      double precision term3,term_a3a,term_a3b,term_b3b
      double precision term2,term_a2a,term_a2b,term_b2b
      double precision term1,term_a1a,term_a1b,term_b1b
      double precision e1,e2
      common/flop/ term1,term2,term3,term4
c
      integer lenabcd,leniabc,lenijab,lenijka,lenijkl,lenab,lenia,lenij
      integer l_w,k_w
c
      lenabcd = virt*virt*virt*virt
      leniabc = occ*virt*virt*virt
      lenijab = occ*occ*virt*virt
      lenijka = occ*occ*occ*virt
      lenijkl = occ*occ*occ*occ
      lenab = virt*virt
      lenia = virt*occ
      lenij = occ*occ
      if (opr) print *,' triple delta e used ',delta
c
c term 1
c
      if (.not. ma_push_get(mt_dbl,lenab*2,'a2a', l_w, k_w))
     1    call errquit('push a1a',0, MA_ERR)
      term_a1a = cct_so_a1a(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenab))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a2a',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl,lenia*2,'a1b', l_w, k_w))
     1    call errquit('push a1b',0, MA_ERR)
      term_a1b = cct_so_a1b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenia))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a1b',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl,lenij*2,'b1b', l_w, k_w))
     1    call errquit('push b1b',0, MA_ERR)
      term_b1b = cct_so_b1b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenij))
      if (.not.ma_pop_stack(l_w)) call errquit('pop b1b',0, MA_ERR)
c
      term1 = term_a1a + 2.0d0*term_a1b + term_b1b
c
      if (opr) then
c        print *,' term a1a ',term_a1a/ delta
c        print *,' term a1b=b1a ',term_a1b/ delta
c        print *,' term b1b ',term_b1b/ delta
         print *,' term1 ',term1/ delta
      end if

c
c term 2
c
      if (.not. ma_push_get(mt_dbl,lenijab+lenijab,'a2a', l_w, k_w))
     1    call errquit('push a2a',0, MA_ERR)
      term_a2a = cct_so_a2a(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenijab))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a2a',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl,lenijka*2,'a2a', l_w, k_w))
     1    call errquit('push a2b',0, MA_ERR)
      term_a2b = cct_so_a2b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenijka))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a2b',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl,lenijka+lenijkl,'b2b', l_w, k_w))
     1    call errquit('push b2b',0, MA_ERR)
      term_b2b = cct_so_b2b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenijka))
      if (.not.ma_pop_stack(l_w)) call errquit('pop b2b',0, MA_ERR)
c
      term2 = term_a2a + 2.0d0*term_a2b + term_b2b
c
      if (opr) then
c        print *,' term a2a ',term_a2a/ delta
c        print *,' term a2b=b2a ',term_a2b/ delta
c        print *,' term b2b ',term_b2b/ delta
         print *,' term2 ',term2/ delta
      end if
c
c term 3
c
      if (.not. ma_push_get(mt_dbl,lenabcd+leniabc,'a3a', l_w, k_w))
     1    call errquit('push a3a',0, MA_ERR)
      term_a3a = cct_so_a3a(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenabcd))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a3a',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl,leniabc+lenijka,'a3b', l_w, k_w))
     1    call errquit('push a3b',0, MA_ERR)
      term_a3b = cct_so_a3b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+leniabc))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a3b',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl,lenijab+lenijka,'b3b', l_w, k_w))
     1    call errquit('push b3b',0, MA_ERR)
      term_b3b = cct_so_b3b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenijab))
      if (.not.ma_pop_stack(l_w)) call errquit('pop b3b',0, MA_ERR)
c
      print *,' term_a3a *.5 ',term_a3a*0.5d0
      print *,' term_a3b *1, ',term_a3b 
      print *,' term_b3b *.5 ',term_b3b*0.5d0 
      term3 = term_a3a + 2.0d0*term_a3b + term_b3b
c
      if (opr) then
c        print *,' term a3a ',term_a3a/ delta
c        print *,' term a3b=b3a ',term_a3b/ delta
c        print *,' term b3b ',term_b3b/ delta
         print *,' term3 ',term3/ delta
      end if

c
c term 4
c
      if (.not. ma_push_get(mt_dbl,leniabc+lenijab,'a4a', l_w, k_w))
     1    call errquit('push a4a',0, MA_ERR)
      term_a4a = cct_so_a4a(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+leniabc))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a4a',0, MA_ERR)
c
      if (.not. ma_push_get(mt_dbl,lenijab+lenijka,'a4b', l_w, k_w))
     1    call errquit('push a4b',0, MA_ERR)
      term_a4b = cct_so_a4b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenijab))
      if (.not.ma_pop_stack(l_w)) call errquit('pop a4b',0, MA_ERR)
c
      if (.not. ma_push_get(mt_dbl,lenijka*2,'b4b', l_w, k_w))
     1    call errquit('push b4b',0, MA_ERR)
      term_b4b = cct_so_b4b(rint,nbasis,t2,occ,virt,fac,
     1                      dbl_mb(k_w),dbl_mb(k_w+lenijka))
      if (.not.ma_pop_stack(l_w)) call errquit('pop b4b',0, MA_ERR)
c
      term4 = term_a4a + 2.0d0*term_a4b + term_b4b
c
      if (opr) then
c        print *,' term a4a ',term_a4a/ delta
c        print *,' term a4b=b4a ',term_a4b/ delta
c        print *,' term b4b ',term_b4b/ delta
         print *,' term4 ',term4/ delta
      end if
c
       e1 = 0.0d0
       e2 = (0.25d0*term1 - 0.5d0*term2 - 0.5d0*term3 + term4)/ delta
       energy = e1 + e2
      if (opr) print *,' Cullen  : e1= ',e1,' e2= ',e2,' e= ',energy
c
      end
      double precision function cct_so_a4a(rint,nbasis,t2,occ,virt,fac,
     1                                     wiabc,wijab)
c
c     term A4A 
c       t(ij,ce) (ab||ek) t(kj,af) (cb||fi)
c     = t(ij,ce) (cb||fi) (ab||ek) t(kj,af) 
c     weighting 1.
c
c...  fac has to be added to i,j,k,a,b,c (there is choice)
c...  early is done / late might be better ?
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt),fac(nbasis)
c
      integer j,e,b,f,i,c,k,a
      double precision wiabc(virt,virt,virt,occ),
     1                 wijab(virt,virt,occ,occ),sum
c
c...  t2 * integral (ic) t(ij,ce) (cb||fi) => (j,e,b,f)
c
      do j=1,occ
       do e=1,virt
        do b=1,virt
         do f=1,virt
          wiabc(f,b,e,j) = 0.0d0
          do i=1,occ
           do c=1,virt
            wiabc(f,b,e,j) = wiabc(f,b,e,j) + t2(i,j,c,e)
     1                                      * rint(c+occ,b+occ,f+occ,i)
     2                     * fac(j)*fac(b+occ)*fac(i)*fac(c+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (eb) (j,e,b,f) (ab||ek) => (j,k,f,a)  (choice)
c
      do j=1,occ
       do k=1,occ
        do f=1,virt
         do a=1,virt
          wijab(a,f,k,j) = 0.0d0
          do e=1,virt
           do b = 1,virt
            wijab(a,f,k,j) = wijab(a,f,k,j) + wiabc(f,b,e,j)
     1                                      * rint(a+occ,b+occ,e+occ,k)
     2                     * fac(k)*fac(a+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (jkfa)  (j,k,f,a) t(kj,af)
c
      sum = 0.0d0
      do j=1,occ
       do k=1,occ
        do f=1,virt
         do a=1,virt
          sum= sum + wijab(a,f,k,j) * t2(k,j,a,f)
         end do
        end do
       end do
      end do
c
      cct_so_a4a = sum
c
      return
      end 
      double precision function cct_so_a4b(rint,nbasis,t2,occ,virt,fac,
     1                                     wijab,wijka)
c
c     term A4B = B4A
c A4B = t(ij,ce) (ab||ek) t(in,cb) (an||kj)
c     = t(ij,ce) t(in,cb) (ab||ek) (an||kj)
c
c B4A = t(km,ab) (cm||ij) t(kj,af) (cb||fi)
c relabel in cb   an  kj    ij ce   ab  ek
c     weighting 1.
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt),fac(nbasis)
c
      integer j,n,e,b,i,c,k,a
      double precision wijab(virt,virt,occ,occ),
     1                 wijka(virt,occ,occ,occ),sum
c
c..   contract t's (ic) t(ij,ce) t(in,cb) => (j,n,e,b) choice
c
      do j=1,occ
       do n=1,occ
        do e=1,virt
         do b=1,virt
          wijab(b,e,n,j) = 0.0d0
          do i=1,occ
           do c=1,virt
            wijab(b,e,n,j) = wijab(b,e,n,j) + t2(i,j,c,e)
     1                                      * t2(i,n,c,b)
     2                     * fac(j)*fac(b+occ)*fac(i)*fac(c+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c..   (be)  (j,n,e,b) (ab||ek)  => (j,n,k,a) (choice)
c
      do j=1,occ
       do n=1,occ
        do k=1,occ
         do a=1,virt
          wijka(a,k,n,j) = 0.0d0
          do b=1,virt
           do e=1,virt
            wijka(a,k,n,j) = wijka(a,k,n,j) + wijab(b,e,n,j)
     1                                      * rint(a+occ,b+occ,e+occ,k)
     2                     * fac(k)*fac(a+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c     (jnka)  (j,n,k,a) ((an||kj) => sum
c
      sum = 0.0d0
      do j=1,occ
       do n=1,occ
        do k=1,occ
         do a=1,virt
          sum = sum + wijka(a,k,n,j) * rint(a+occ,n,k,j)
         end do
        end do
       end do
      end do
c
      cct_so_a4b = sum
c
      return
      end 
      double precision function cct_so_b4b(rint,nbasis,t2,occ,virt,fac,
     1                                     wijka,wijka2)
c
c     term B4B 
c       t(km,ab)(cm||ij) t(in,cb) (an||kj)
c     = t(km,ab)(an||kj) (cm||ij) t(in,cb)
c
c     weighting 1.
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer m,n,j,b,k,a,i,c
      double precision wijka(virt,occ,occ,occ),
     1                 wijka2(virt,occ,occ,occ),sum
c
c...  (ka) ..  t*rint (left) t(km,ab)(an||kj => (m,n,j,b)
c
      do m=1,occ
       do n=1,occ
        do j=1,occ
         do b=1,virt
          wijka(b,j,n,m) = 0.0d0
          do k=1,occ
           do a=1,virt
            wijka(b,j,n,m) = wijka(b,j,n,m) + t2(k,m,a,b)
     1                                      * rint(a+occ,n,k,j)
     2                     * fac(j)*fac(b+occ)*fac(k)*fac(a+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (nb) ..  (m,n,j,b) t(in,cb) => (m,j,i,c)  
c
      do m=1,occ
       do j=1,occ
        do i=1,occ
         do c=1,virt
          wijka2(c,i,j,m) = 0.0d0
          do n=1,occ
           do b=1,virt
            wijka2(c,i,j,m) = wijka2(c,i,j,m) + wijka(b,j,n,m)
     1                                        * t2(i,n,c,b)
     2                      * fac(i)*fac(c+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...    (mjic) ..  (m,j,i,c) ((cm||ij) => sum
c
      sum = 0.0d0
      do m=1,occ
       do j=1,occ
        do i=1,occ
         do c=1,virt      
          sum = sum + wijka2(c,i,j,m) * rint(c+occ,m,i,j)
         end do
        end do
       end do
      end do
c
      cct_so_b4b = sum
c
      return
      end 
      double precision function cct_so_a3a(rint,nbasis,t2,occ,virt,fac,
     1                                     wabcd,wiabc)
c
c     term A3A 
c       
c       t(ij,ce) (ab||ek) t(ij,af) (cb||fk)
c     = t(ij,ce) t(ij,af) (ab||ek) (cb||fk)
c
c     weighting 0.5
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer c,e,a,f,i,j,k,b
      double precision wabcd(virt,virt,virt,virt),
     1                 wiabc(virt,virt,virt,occ),sum
c
c...  (ij) t(ij,ce) t(ij,af) => (c,e,a,f)
c
      do c=1,virt
       do e=1,virt
        do a=1,virt
         do f=1,virt
          wabcd(f,a,e,c) = 0.0d0
          do i=1,occ
           do j=1,occ
            wabcd(f,a,e,c) = wabcd(f,a,e,c) + t2(i,j,c,e)*t2(i,j,a,f)
     2                     * fac(i)*fac(j)*fac(a+occ)*fac(c+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (ae) (c,e,a,f) (ab||ek) => (k,c,f,b)
c
      do k=1,occ
       do c=1,virt
        do f=1,virt
         do b=1,virt
          wiabc(b,f,c,k) = 0.0d0
          do a=1,virt
           do e=1,virt
            wiabc(b,f,c,k) = wiabc(b,f,c,k) + wabcd(f,a,e,c)
     1                                      * rint(a+occ,b+occ,e+occ,k)
     2                     * fac(k)*fac(b+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c..   (kcfb) (k,c,f,b) (cb||fk) => sum
c
      sum = 0.0d0
      do k=1,occ
       do c=1,virt
        do f=1,virt
         do b=1,virt
          sum = sum + wiabc(b,f,c,k)*rint(c+occ,b+occ,f+occ,k)
         end do
        end do
       end do
      end do
c
      cct_so_a3a = sum
c
      return 
      end
      double precision function cct_so_a3b(rint,nbasis,t2,occ,virt,fac,
     1                                     wiabc,wijka)
c
c     term A3B = B3A
c       
c       t(ij,ce) (ab||ek) t(kn,cb) (an||ij)
c     = (ab||ek) t(kn,cb) t(ij,ce) (an||ij)
c
c B3A = t(km,ab) (cm||ij) t(ij,af) (cb||fk)
c relabel kn cb   an  ij    ij ce   ab  ek
c     weighting 0.5
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer n,c,a,e,k,b,i,j
      double precision wiabc(virt,virt,virt,occ),
     1                 wijka(virt,occ,occ,occ),sum
c
c...  (kb) t(kn,cb) (ab||ek) => (n,c,a,e)
c
      do n=1,occ
       do c=1,virt
        do a=1,virt
         do e=1,virt
          wiabc(e,a,c,n) = 0.0d0
          do k=1,occ
           do b=1,virt
            wiabc(e,a,c,n) = wiabc(e,a,c,n) + t2(k,n,c,b)
     1                                      * rint(a+occ,b+occ,e+occ,k)
     2                     * fac(c+occ)*fac(a+occ)*fac(k)*fac(b+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (ce) (n,c,a,e) t(i,j,c,e) => (n,i,j,a)
c
      do n=1,occ
       do i=1,occ
        do j=1,occ
         do a=1,virt
          wijka(a,j,i,n) = 0.0d0
          do c=1,virt
           do e=1,virt
            wijka(a,j,i,n) = wijka(a,j,i,n) + wiabc(e,a,c,n)*t2(i,j,c,e)
     2                     * fac(i)*fac(j)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (nija) (n,i,j,a) (an||ij) => sum
c
      sum = 0.0d0
      do n=1,occ
       do i=1,occ
        do j=1,occ
         do a=1,virt
          sum = sum + wijka(a,j,i,n) * rint(a+occ,n,i,j)
         end do
        end do
       end do
      end do
c
      cct_so_a3b = sum
c
      return 
      end
      double precision function cct_so_b3b(rint,nbasis,t2,occ,virt,fac,
     1                                     wijab,wijka)
c
c     term B3B 
c       
c       t(km,ab) (cm||ij) t(kn,cb) (an||ij)
c     = t(km,ab) t(kn,cb) (cm||ij) (an||ij)
c
c     weighting 0.5
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer m,n,j,b,k,a,i,c
      double precision wijab(virt,virt,occ,occ),
     1                 wijka(virt,occ,occ,occ),sum
c
c...  (kb) t(km,ab) t(kn,cb) => (m,n,a,c)
c
      do m=1,occ
       do n=1,occ
        do a=1,virt
         do c=1,virt
          wijab(c,a,n,m) = 0.0d0
          do k=1,occ
           do b=1,virt
            wijab(c,a,n,m) = wijab(c,a,n,m) + t2(k,m,a,b) * t2(k,n,c,b)
     2                     * fac(a+occ)*fac(c+occ)*fac(k)*fac(b+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (mc) (m,n,a,c) (cm||ij) => (n,i,j,a)
c
      do n=1,occ
       do i=1,occ
        do j=1,occ
         do a=1,virt
          wijka(a,j,i,n) = 0.0d0
          do m=1,occ
           do c=1,virt
            wijka(a,j,i,n) = wijka(a,j,i,n) + wijab(c,a,n,m) 
     1                                      * rint(c+occ,m,i,j)
     2                     * fac(i)*fac(j)
           end do
          end do
         end do
        end do
       end do
      end do
c
c..   (nija) (n,i,j,a) (an||ij) => sum
c
      sum = 0.0d0
      do n=1,occ
       do i=1,occ
        do j=1,occ
         do a=1,virt
          sum = sum + wijka(a,j,i,n)*rint(a+occ,n,i,j)
         end do
        end do
       end do
      end do
c
      cct_so_b3b = sum
c
      return 
      end
      double precision function cct_so_a2a(rint,nbasis,t2,occ,virt,fac,
     1                                     wijab,wijab2)
c
c     term A2A 
c       
c       t(ij,ce) (ab||ek) t(kj,cf) (ab||fi)
c     = (ab||ek) (ab||fi) t(ij,ce) t(kj,cf)
c
c     weighting 0.5
c
c
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer k,i,e,f,a,b,j,c
      double precision wijab(virt,virt,occ,occ),
     1                 wijab2(virt,virt,occ,occ),sum
c
c...  (ab) (ab||ek) (ab||fi) => (k,i,e,f)
c
      do k=1,occ
       do i=1,occ
        do e=1,virt
         do f=1,virt
          wijab(f,e,i,k) = 0.0d0
          do a=1,virt
           do b=1,virt
             wijab(f,e,i,k) =  wijab(f,e,i,k)+rint(a+occ,b+occ,e+occ,k)
     1                                       *rint(a+occ,b+occ,f+occ,i)
     2                      * fac(k)*fac(i)*fac(a+occ)*fac(b+occ)
             if (.not. ma_verify_allocator_stuff()) call errquit('a',0,
     &       MA_ERR)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (ie) (k,i,e,f) t(ij,ce) => (k,j,c,f)
c
      do k=1,occ
       do j=1,occ
        do c=1,virt
         do f=1,virt
          wijab2(f,c,j,k) = 0.0d0
          do i=1,occ
           do e=1,virt
            wijab2(f,c,j,k) = wijab2(f,c,j,k) + wijab(f,e,i,k)
     1                                        * t2(i,j,c,e)
     2                      * fac(j)*fac(c+occ)
             if (.not. ma_verify_allocator_stuff()) call errquit('b',0,
     &       MA_ERR)
           end do
          end do
         end do
        end do
       end do
      end do
c
c..   (kjcf) (k,j,c,f) t(kj,cf) => sum
c
      sum = 0.0d0
      do k=1,occ
       do j=1,occ
        do c=1,virt
         do f=1,virt
          sum = sum + wijab2(f,c,j,k) * t2(k,j,c,f)
         end do
        end do
       end do
      end do
c
      cct_so_a2a = sum
c
      return 
      end
      double precision function cct_so_a2b(rint,nbasis,t2,occ,virt,fac,
     1                                     wijka,wijka2)
c
c     term A2B=B2A
c       
c       t(ij,ce) (ab||ek) t(in,ab) (cn||kj)
c     = (ab||ek) t(in,ab) t(ij,ce) (cn||kj)
c B2A = t(km,ab) (cm||ij) t(kj,cf) (ab||fi)
c rename  in ab   cn  kj    ij ce   ab  ek
c
c     weighting 0.5
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer i,n,k,e,a,b,j,c
      double precision wijka(virt,occ,occ,occ),
     1                 wijka2(virt,occ,occ,occ),sum
c
c...  (ab) t(in,ab) (ab||ek) => (i,n,k,e)
c
      do i=1,occ
       do n=1,occ
        do k=1,occ
         do e=1,virt
          wijka(e,k,n,i) = 0.0d0
          do a=1,virt
           do b=1,virt
            wijka(e,k,n,i) = wijka(e,k,n,i) + t2(i,n,a,b)
     1                                      * rint(a+occ,b+occ,e+occ,k)
     2                     * fac(i)*fac(k)*fac(a+occ)*fac(b+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (ie) (i,n,k,e) t(ij,ce) => (n,k,j,c)
c
      do n=1,occ
       do k=1,occ
        do j=1,occ
         do c=1,virt
          wijka2(c,j,k,n) = 0.0d0
          do i=1,occ
           do e=1,virt
            wijka2(c,j,k,n) = wijka2(c,j,k,n) + wijka(e,k,n,i) 
     1                                        * t2(i,j,c,e)
     2                      * fac(j)*fac(c+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c..   (nkjc) (n,k,j,c) (cn||kj) => sum
c
      sum = 0.0d0
      do n=1,occ
       do k=1,occ
        do j=1,occ
         do c=1,virt
          sum = sum + wijka2(c,j,k,n)*rint(c+occ,n,k,j)
         end do
        end do
       end do
      end do
c
      cct_so_a2b = sum
c
      return 
      end
      double precision function cct_so_b2b(rint,nbasis,t2,occ,virt,fac,
     1                                     wijka,wijkl)
c
c     term B2B 
c       
c       t(km,ab) (cm||ij) t(in,ab) (cn||kj)
c     = t(km,ab) t(in,ab) (cm||ij) (cn||kj)
c
c     weighting 0.5
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer k,m,i,n,a,b,j,c
      double precision wijka(virt,occ,occ,occ),
     1                 wijkl(occ,occ,occ,occ),sum
c
c...  (ab) t(km,ab) t(in,ab) => (k,m,i,n)
c
      do k=1,occ
       do m=1,occ
        do i=1,occ
         do n=1,occ
          wijkl(n,i,m,k) = 0.0d0
          do a=1,virt
           do b=1,virt
             wijkl(n,i,m,k) =  wijkl(n,i,m,k) + t2(k,m,a,b)*t2(i,n,a,b)
     2                      * fac(k)*fac(i)*fac(a+occ)*fac(b+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c...  (mi) (k,m,i,n) (cm||ij) => (k,n,j,c)
c
      do k=1,occ
       do n=1,occ
        do j=1,occ
         do c=1,virt
          wijka(c,j,n,k) = 0.0d0
          do m=1,occ
           do i=1,occ
            wijka(c,j,n,k) = wijka(c,j,n,k) + wijkl(n,i,m,k) 
     1                                      * rint(c+occ,m,i,j)
     2                     * fac(j)*fac(c+occ)
           end do
          end do
         end do
        end do
       end do
      end do
c
c..   (knjc) (k,n,j,c) (cn||kj) => sum
c
      sum = 0.0d0
      do k=1,occ
       do n=1,occ
        do j=1,occ
         do c=1,virt
          sum = sum + wijka(c,j,n,k)*rint(c+occ,n,k,j)
         end do
        end do
       end do
      end do
c
      cct_so_b2b = sum
c
      return 
      end
      double precision function cct_so_a1a(rint,nbasis,t2,occ,virt,fac,
     1                                     wab,wab2)
c
c     term A1A 
c     *seems might be combined with A2A*
c       
c       t(ij,ce) (ab||ek) t(ij,cf) (ab||fk)
c     = (ab||ek) (ab||fk) t(ij,ce) t(ij,cf)
c
c     weighting 0.25
c
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer e,f,k,a,b,i,j,c
      double precision wab(virt,virt),
     1                 wab2(virt,virt),sum,ddot
c
c...  (abk) (ab||ek) (ab||fk) => (e,f)
c
      do e=1,virt
       do f=1,virt
        wab(f,e) = 0.0d0
        do k=1,occ
         do a=1,virt
          do b=1,virt
           wab(f,e) =  wab(f,e) + rint(a+occ,b+occ,e+occ,k)
     1                          * rint(a+occ,b+occ,f+occ,k)
     2              * fac(k)*fac(a+occ)*fac(b+occ)
          end do
         end do
        end do
       end do
      end do
c
c...  (ijc) t(ij,ce) t(ijcf)  => (e,f)
c
      do e=1,virt
       do f=1,virt
        wab2(f,e) = 0.0d0
        do i=1,occ
         do j=1,occ
          do c=1,virt
            wab2(f,e) = wab2(f,e) + t2(i,j,c,e) * t2(i,j,c,f)
     2                * fac(i)*fac(j)*fac(c+occ)
          end do
         end do
        end do
       end do
      end do
c
      sum = ddot(virt*virt,wab,1,wab2,1)
c
      cct_so_a1a = sum
c
      return 
      end
      double precision function cct_so_a1b(rint,nbasis,t2,occ,virt,fac,
     1                                     wia,wia2)
c
c     term A1B=B1A
c       
c       t(ij,ce) (ab||ek) t(kn,ab) (cn||ij)
c     = (ab||ek) t(kn,ab) t(ij,ce) (cn||ij)
c
c     weighting 0.25
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer n,e,k,a,b,i,j,c
      double precision wia(virt,occ),
     1                 wia2(virt,occ),sum,ddot
c
c...  (abk) t(kn,ab) (ab||ek) => (n,e)
c
      do n=1,occ
       do e=1,virt
        wia(e,n) = 0.0d0
        do k=1,occ
         do a=1,virt
          do b=1,virt
           wia(e,n) = wia(e,n) + t2(k,n,a,b) * rint(a+occ,b+occ,e+occ,k)
     2              * fac(k)*fac(a+occ)*fac(b+occ)
          end do
         end do
        end do
       end do
      end do
c
c...  (ijc) (cn||ij) t(ij,ce) => (n,e)
c
      do n=1,occ
       do e=1,virt
        wia2(e,n) = 0.0d0
        do i=1,occ
         do j=1,occ
          do c=1,virt
           wia2(e,n) = wia2(e,n) + t2(i,j,c,e) * rint(c+occ,n,i,j)
     2               * fac(i)*fac(j)*fac(c+occ)
          end do
         end do
        end do
       end do
      end do
c
      sum = ddot(virt*occ,wia,1,wia2,1)
c
      cct_so_a1b = sum
c
      return 
      end
      double precision function cct_so_b1b(rint,nbasis,t2,occ,virt,fac,
     1                                     wij,wij2)
c
c     term B1B 
c       
c       t(km,ab) (cm||ij) t(kn,ab) (cn||ij)
c     = t(km,ab) t(kn,ab) (cm||ij) (cn||ij)
c
c     weighting 0.25
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision fac(nbasis)
c
      integer  m,n,k,a,b,j,i,c
      double precision wij(occ,occ),
     1                 wij2(occ,occ),sum,ddot
c
c...  (abk) t(km,ab) t(kn,ab) => (m,n)
c
      do m=1,occ
       do n=1,occ
        wij(n,m) = 0.0d0
        do k=1,occ
         do a=1,virt
          do b=1,virt
            wij(n,m) = wij(n,m) + t2(k,m,a,b) * t2(k,n,a,b)
     2               * fac(k)*fac(a+occ)*fac(b+occ)
          end do
         end do
        end do
       end do
      end do
c
c...  (cij) (cn||ij)  (cm||ij) => (m,n)
c
      do m=1,occ
       do n=1,occ
        wij2(n,m) = 0.0d0
        do j=1,occ
         do i=1,occ
          do c=1,virt
           wij2(n,m) = wij2(n,m) + rint(c+occ,n,i,j) * rint(c+occ,m,i,j)
     2               * fac(i)*fac(j)*fac(c+occ)
          end do
         end do
        end do
       end do
      end do
c
      sum = ddot(occ*occ,wij,1,wij2,1)
c
      cct_so_b1b = sum
c
      return 
      end
#if(0)
      subroutine w_ii(rint,nbasis,occ,virt,
     1                  w,con)
c
c...  calculated the integral only contracted intermediate
c...  (ab||ei)*(ab||fj) => (ij,ef)  ('ab')
c
      implicit none
#include "errquit.fh"
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      character*(*) con
c
      double precision w(occ,occ,virt,virt)
c
      if (con.eq.'ab') then
c
       do e=1,virt
        do f=1,virt
         do i=1,occ
          do j=1,occ
c
c..      wab(occ,occ,virt,virt)=sum(ab)(ab||ei)*(ab||fj)
c
           w(i,j,e,f) = 0.0d0
           do a=1,virt
            do b=1,virt
             w(i,j,e,f) = rint(a+occ,b+occ,e+occ,i)
     1                    * rint(a+occ,b+occ,f+occ,j)
            end do
           end do
c
          end do
         end do
        end do
       end do
c
      else if (con.eq.'ij') then
c
       do e=1,virt
        do f=1,virt
         do i=1,occ
          do j=1,occ
c
c..      w(occ,occ,virt,virt)=sum(ab)(ab||ei)*(ab||fj)
c
           w(i,j,e,f) = 0.0d0
           do a=1,occ
            do b=1,occ
             w(i,j,e,f) = rint(a,b,e+occ,i)
     1                    * rint(a,b,f+occ,j)
            end do
           end do
c
          end do
         end do
        end do
       end do
c
      else 
         call errquit(' what ?',0, UNKNOWN_ERR)
      end if
c
      end
      subroutine cct_tr_ij_vv_kc(rint,nbasis,t2,occ,virt,w)
c
c...  calculated t2(ij,vv) (vv//kc) contracted intermediate
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision w(i,j,k,c)
c
c
       do i=1,occ
        do j=1,occ
         do k=1,occ
          do c=1,virt
c
           w(i,j,k,c) = 0.0d0
           do a=1,virt
            do b=1,virt
             w(i,j,k,c) = rint(a+occ,b+occ,k,c+occ)
     1                  * t2(i,j,a,b)
            end do
           end do
c
          end do
         end do
        end do
       end do
c
      end
      subroutine cct_rt_avbo_oicv(rint,nbasis,t2,occ,virt,wiabc)
c
c...  calculated  intermediate
c
      implicit none
c
      integer nbasis,occ,virt
      double precision rint(nbasis,nbasis,nbasis,nbasis)
      double precision t2(occ,occ,virt,virt)
      double precision w(i,j,k,c)
c
      integer i,a,b,c,v,o
c
      do i=1,occ
       do a=1,virt
        do b=1,virt
         do c=1,virt
c
           w(i,a,b,c) = 0.0d0
           do o=1,occ
            do v=1,virt
             w(i,a,b,c) = rint(a+occ,v+occ,b+occ,o)
     1                  * t2(o,i,c,v)
            end do
           end do
c
          end do
         end do
        end do
       end do
c
      end
#endif

      SUBROUTINE YGEEVX( BALANC, JOBVL, JOBVR, SENSE, N, A, LDA, WR, WI,
     $                   VL, LDVL, VR, LDVR, ILO, IHI, SCALE, ABNRM,
     $                   RCONDE, RCONDV, WORK, LWORK, IWORK, INFO )
*
* $Id: ygeevx.F 24349 2013-06-23 04:30:58Z d3y133 $
*
      implicit none
#include "y64.fh"
*     .. Scalar Arguments ..
      CHARACTER          BALANC, JOBVL, JOBVR, SENSE
      INTEGER            IHI, ILO, INFO, LDA, LDVL, LDVR, LWORK, N
      DOUBLE PRECISION   ABNRM
*     ..
*     .. Array Arguments ..
      INTEGER            IWORK( * )
      DOUBLE PRECISION   A( LDA, * ), RCONDE( * ), RCONDV( * ),
     $                   SCALE( * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WI( * ), WORK( * ), WR( * )
c
      INTGR4            N4, LDA4, LDVL4, LDVR4, LWORK4, INFO4,
     $     ILO4,IHI4
c
      N4=N
      LDA4=LDA
      LDVL4=LDVL
      LDVR4=LDVR
      LWORK4=LWORK
c
      CALL DGEEVX( BALANC, JOBVL, JOBVR, SENSE, N4, A, LDA4, WR, WI,
     $                   VL, LDVL4, VR, LDVR4, ILO4, IHI4, SCALE, ABNRM,
     $                   RCONDE, RCONDV, WORK, LWORK4, IWORK, INFO4 )
      INFO=INFO4
      ILO=ILO4
      IHI=IHI4

      RETURN
      END

      SUBROUTINE ccsdt_lr_alpha2_9_22_7_1(d_a,k_a_offset,d_b,k_b_offset,
     &d_c,k_c_offset)
C     $Id: ccsdt_lr_alpha2_9_22_7_1.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h2 p12 h15 p3 )_ytrbt + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p12 h9 h10 )_t * i4 ( h2 h9 h10 h15 p3 p7 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p12b
      INTEGER h2b
      INTEGER h15b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h9b
      INTEGER h10b
      INTEGER p12b_1
      INTEGER p7b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER h2b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER h15b_2
      INTEGER p3b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p12b = noab+1,noab+nvab
      DO h2b = 1,noab
      DO h15b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p12b-
     &1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p12b-1) .eq. int_mb(k_spin+
     &h15b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_mb
     &(k_sym+h15b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,ieor(irrep
     &_trb,irrep_t))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p12b-1) * int_mb(k_r
     &ange+h15b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_22_7_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (int_mb(k_spin+p12b-1)+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+
     &h9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb
     &(k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p12b,p7b,h9b,h10b,p12b_1,p7b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_6(h2b,h9b,h10b,h15b,p3b,p7b,h2b_2,h9b_2,h10b_2
     &,h15b_2,p3b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+h9b-1) * int_m
     &b(k_range+h10b-1)
      dima_sort = int_mb(k_range+p12b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h15b-1) * int_m
     &b(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_22_7_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_22_7_1',2,MA_ERR)
      IF ((p7b .le. p12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p12b_1 - noab - 1 + nvab * (p7
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),2,4,3,1,1.0d0)
      END IF
      IF ((p12b .lt. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p7b_1 - noab - 1 + nvab * (p12
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha2_9_22_7_1
     &',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_22_7_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_22_7_1',5,MA_ERR)
      IF ((h10b .lt. h2b) .and. (h15b .le. p7b) .and. (p7b .lt. p3b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (h15b_2 - 1 + noab
     & * (h2b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p3b-1),6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h10b .lt. h2b) .and. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h15b_2 - 1 + noab
     & * (h2b_2 - 1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p7b-1),5,4,3,2,1,6,1.0d0)
      END IF
      IF ((h9b .lt. h2b) .and. (h2b .le. h10b) .and. (h15b .le. p7b) .an
     &d. (p7b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (h15b_2 - 1 + noab
     & * (h10b_2 - 1 + noab * (h2b_2 - 1 + noab * (h9b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p3b-1),6,4,2,3,1,5,1.0d0)
      END IF
      IF ((h9b .lt. h2b) .and. (h2b .le. h10b) .and. (p3b .le. p7b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h15b_2 - 1 + noab
     & * (h10b_2 - 1 + noab * (h2b_2 - 1 + noab * (h9b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p7b-1),5,4,2,3,1,6,-1.0d0)
      END IF
      IF ((h2b .le. h9b) .and. (h15b .le. p7b) .and. (p7b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (h15b_2 - 1 + noab
     & * (h10b_2 - 1 + noab * (h9b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p3b-1),6,4,1,3,2,5,-1.0d0)
      END IF
      IF ((h2b .le. h9b) .and. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h15b_2 - 1 + noab
     & * (h10b_2 - 1 + noab * (h9b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p7b-1),5,4,1,3,2,6,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha2_9_22_7_1
     &',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h9b .eq. h10b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_2
     &2_7_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_2
     &2_7_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_22_7_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h2b-1),int_mb(k_range+p12b-
     &1),3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (h15b - 1 + noab * (p12b - noab - 1 + nvab * (h
     &2b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha2_9_22_7_1
     &',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_2
     &2_7_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

* $Id: derivat.f 19696 2010-10-29 16:53:42Z d3y133 $
c===================================================================
c This file contains all dintegral derivatives routines :
c for nmr/giao integral derivatives
c for first derivatives (gradient) integrals
c for second derivatives (hessian) integrals
c===================================================================
c
c
c===========NMR/GIAO INTEGRAL DERIVATIVES ROUTINES==================
c
c     It is called from Calcint2 when WHERE='shif'
c
      subroutine shift_der(nbls,lnijr,lnklr,npij,npkl,ngcd,
     *                   idx1,idx2, ixab,ixcd,ixyab,ixycd)
c
      implicit real*8 (a-h,o-z)
c
      common /logic4/ nfu(1)
      common /big/ bl(1)
      COMMON/SHELL/LSHELLT,LSHELIJ,LSHELKL,LHELP,LCAS2(4),LCAS3(4)
      common /lcases/ lcase
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,mmax,
     * nqi,nqj,nqk,nql,nsij,nskl,
     * nqij,nqij1,nsij1,nqkl,nqkl1,nskl1,ijbeg,klbeg
c
      common /memor4/ iwt0,iwt1,iwt2,ibuf,ibuf2,
     * ibfij1,ibfij2,ibfkl1,ibfkl2,
     * ibf2l1,ibf2l2,ibf2l3,ibf2l4,ibfij3,ibfkl3,
     * ibf3l,issss,
     * ix2l1,ix2l2,ix2l3,ix2l4,ix3l1,ix3l2,ix3l3,ix3l4,
     * ixij,iyij,izij, iwij,ivij,iuij,isij
c
      common /memor4a/ ibf3l1,ibf3l2,ibf3l3,ibf3l4
c
c dimensions for assembling :
      common /dimasse/ lqijr,lqklr,lqmxr,lij3,lkl3,l3l,lsss
c----------------------------------------------------------
c     lqijr=nfu(nqij1+1)
c     lqklr=nfu(nqkl1+1)
c     lqmxr=lqijr
c       if(lqklr.gt.lqijr) lqmxr=lqklr
c
      lqij=nfu(nqij+1)
      lqkl=nfu(nqkl+1)
      lqmx=lqij
        if(lqkl.gt.lqij) lqmx=lqkl
c----------------------------------------------------------
c
      call getmem(3*nbls,ixabq)
      call getmem(3*nbls,ixcdq)
      call getmem(3*nbls,ixyabq)
      call getmem(3*nbls,ixycdq)
c------
c
      call conv24x(nbls,npij,npkl,bl(idx1),bl(idx2),
     *            bl(ixab),bl(ixcd),bl(ixyab),bl(ixycd),
     *            bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq) )
c------
c
      ibeg =ibuf2
      incr1=ngcd*nbls*lnijr*lnklr
      ider=ibeg+incr1
c
      call giao_der(ngcd,nbls,bl(ibeg),lnijr,lnklr,lnij,lnkl,nqij,nqkl,
     *            bl(ider),bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c
      ibuf2=ibuf2+incr1
c------
      if(lshellt.eq.0) go to 100
c------
c
c     if(lcase.eq. 2.or.lcase.eq. 6.or.lcase.eq. 8.or.lcase.eq. 9.or.
c    *   lcase.eq.12.or.lcase.eq.13.or.lcase.eq.14.or.lcase.eq.16) then
      if(lshelij.eq.1 .or. lshelij.eq.3) then
c-   --- for bfij1 ---
c
         ibeg =ibfij1
         incr1=nbls*lqijr*lnklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqijr,lnklr,lqij,lnkl, 1  ,1 ,
     *      bl(ider),bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibfij1=ibfij1+incr1
      endif
c----------
c     if(lcase.eq. 3.or.lcase.eq. 6.or.lcase.eq.10.or.lcase.eq.11.or.
c    *   lcase.eq.12.or.lcase.eq.13.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelij.eq.2 .or. lshelij.eq.3) then
c-   --- for bfij2 ---
c
         ibeg =ibfij2
         incr1=nbls*lqijr*lnklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqijr,lnklr,lqij,lnkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibfij2=ibfij2+incr1
      endif
c----------
c     if(lcase.eq. 4.or.lcase.eq. 7.or.lcase.eq. 8.or.lcase.eq.10.or.
c    *   lcase.eq.12.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.1 .or. lshelkl.eq.3) then
c-   --- for bfkl1 ---
c
         ibeg =ibfkl1
         incr1=nbls*lnijr*lqklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lnijr,lqklr,lnij,lqkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibfkl1=ibfkl1+incr1
      endif
c----------
c     if(lcase.eq. 5.or.lcase.eq. 7.or.lcase.eq. 9.or.lcase.eq.11.or.
c    *   lcase.eq.13.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.2 .or. lshelkl.eq.3) then
c-   --- for bfkl2 ---
c
         ibeg =ibfkl2
         incr1=nbls*lnijr*lqklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lnijr,lqklr,lnij,lqkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibfkl2=ibfkl2+incr1
      endif
c----------
      if(lshellt.eq.1) go to 100
c----------
c     if(lcase.eq. 6.or.lcase.eq.12.or.lcase.eq.13.or.lcase.eq.16) then
      if(lshelij.eq.3) then
c-   --- for bfij3 (nbls,4,lnklr) ; 4 is for nmr only
c
         ibeg =ibfij3
         incr1=4*nbls*lnklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),4    ,lnklr,1   ,lnkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibfij3=ibfij3+incr1
      endif
c----------
c     if(lcase.eq. 7.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.3) then
c-   --- for bfkl3 (nbls,lnijr,4) ; 4 is for nmr only
c
         ibeg =ibfkl3
         incr1=4*nbls*lnijr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lnijr,4    ,lnij,1   , 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibfkl3=ibfkl3+incr1
      endif
c----------
c     if(lcase.eq. 8.or.lcase.eq.12.or.lcase.eq.14.or.lcase.eq.16) then
      if(lcas2(1).eq.1) then
c-   --- for bf2l1 ---
c
         ibeg =ibf2l1
         incr1=nbls*lqijr*lqklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf2l1=ibf2l1+incr1
      endif
c----------
c     if(lcase.eq. 9.or.lcase.eq.13.or.lcase.eq.14.or.lcase.eq.16) then
      if(lcas2(2).eq.1) then
c-   --- for bf2l2 ---
c
         ibeg =ibf2l2
         incr1=nbls*lqijr*lqklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf2l2=ibf2l2+incr1
      endif
c----------
c     if(lcase.eq.10.or.lcase.eq.12.or.lcase.eq.15.or.lcase.eq.16) then
      if(lcas2(3).eq.1) then
c-   --- for bf2l3 ---
c
         ibeg =ibf2l3
         incr1=nbls*lqijr*lqklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf2l3=ibf2l3+incr1
      endif
c----------
c     if(lcase.eq.11.or.lcase.eq.13.or.lcase.eq.15.or.lcase.eq.16) then
      if(lcas2(4).eq.1) then
c-   --- for bf2l4 ---
c
         ibeg =ibf2l4
         incr1=nbls*lqijr*lqklr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf2l4=ibf2l4+incr1
      endif
c----------
      if(lshellt.eq.2) go to 100
c----------
c     if(lcase.eq.12.or.lcase.eq.16) then
      if(lcas3(1).eq.1) then
c-   --- for bf3l(nbls,4,lqmx) -first  
c
         ibeg =ibf3l1
         incr1=4*nbls*lqmxr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),4    ,lqmxr,1   ,lqmx, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf3l1=ibf3l1+incr1
      endif
c----------
c     if(lcase.eq.13.or.lcase.eq.16) then
      if(lcas3(2).eq.1) then
c-   --- for bf3l(nbls,4,lqmx) - second
c
         ibeg =ibf3l2
         incr1=4*nbls*lqmxr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),4    ,lqmxr,1   ,lqmx, 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf3l2=ibf3l2+incr1
      endif
c----------
c     if(lcase.eq.14.or.lcase.eq.16) then
      if(lcas3(3).eq.1) then
c-   --- for bf3l(nbls,lqmx,4) - third 
c
         ibeg =ibf3l3
         incr1=4*nbls*lqmxr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqmxr,4    ,lqmx,1   , 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf3l3=ibf3l3+incr1
      endif
c----------
c     if(lcase.eq.15.or.lcase.eq.16) then
      if(lcas3(4).eq.1) then
c-   --- for bf3l(nbls,lqmx,4) - fourth
c
         ibeg =ibf3l4
         incr1=4*nbls*lqmxr
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),lqmxr,4    ,lqmx,1   , 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         ibf3l4=ibf3l4+incr1
      endif
c----------
      if(lcase.eq.16) then
c-   --- for ssss(nbls)  ---
         ibeg =issss
         incr1=nbls*16
         ider=ibeg+incr1
         call giao_der(ngcd,nbls,bl(ibeg),4    ,4    ,1   ,1   , 1  ,1 ,
     *      bl(ider), bl(ixabq),bl(ixcdq),bl(ixyabq),bl(ixycdq))
c-
         issss=issss+incr1
      endif
c
  100 continue
c...................
      call retmem(4)
      end
c=================================================================
c moved into the convert.f file (1998)
c     subroutine conv24x(nbls,npij,npkl,idx1,idx2 ,
c    *                  xab ,xcd, xyab, xycd ,
c    *                  xabq,xcdq,xyabq,xycdq )
c=================================================================
c moved into the convert.f file (1998)
c     subroutine conv24r(nbls,npij,idx1,xab,xabq)
c=================================================================
      subroutine giao_der(ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                    nqij,nqkl, deriv,  xab,xcd, xyab,xycd)
      implicit real*8 (a-h,o-z)
c
      common /logic4/ nfu(1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
      dimension buf2(nbls,lnijr,lnklr,ngcd)
      dimension deriv(6,nbls,lnij,lnkl,ngcd)
c--------------------------------------------
c---> dimension typ1x(nbls,lnij,lnkl,ngcd),
c--->*          typ2x(nbls,lnij,lnkl,ngcd)
c---> dimension typ1y(nbls,lnij,lnkl,ngcd),
c--->*          typ2y(nbls,lnij,lnkl,ngcd)
c---> dimension typ1z(nbls,lnij,lnkl,ngcd),
c--->*          typ2z(nbls,lnij,lnkl,ngcd)
c--------------------------------------------
      dimension xab(nbls,3),xcd(nbls,3),xyab(nbls,3),xycd(nbls,3)
c
c-----
c
      do 200 kl=nfu(nqkl)+1,lnkl
      klpx=npxyz(1,kl)
      klpy=npxyz(2,kl)
      klpz=npxyz(3,kl)
      do 200 ij=nfu(nqij)+1,lnij
      ijpx=npxyz(1,ij)
      ijpy=npxyz(2,ij)
      ijpz=npxyz(3,ij)
c
      do 225 iqu=1,ngcd
c
        do 250 ijkl=1,nbls
c---------------
c--x deriv.
        abzy= -xab(ijkl,3)*buf2(ijkl,ijpy,kl,iqu) 
     *        +xab(ijkl,2)*buf2(ijkl,ijpz,kl,iqu)
     *       +xyab(ijkl,1)*buf2(ijkl,ij,kl,iqu)
        cdzy= -xcd(ijkl,3)*buf2(ijkl,ij,klpy,iqu) 
     *        +xcd(ijkl,2)*buf2(ijkl,ij,klpz,iqu)
     *       +xycd(ijkl,1)*buf2(ijkl,ij,kl,iqu)
c
cccccc  typ1x(ijkl,ij,kl,iqu)= abzy+cdzy
cccccc  typ2x(ijkl,ij,kl,iqu)=-abzy+cdzy
        deriv(1,ijkl,ij,kl,iqu)= abzy+cdzy
        deriv(2,ijkl,ij,kl,iqu)=-abzy+cdzy
c
c
c--y deriv.
        abzx= +xab(ijkl,3)*buf2(ijkl,ijpx,kl,iqu) 
     *        -xab(ijkl,1)*buf2(ijkl,ijpz,kl,iqu)
     *       +xyab(ijkl,2)*buf2(ijkl,ij,kl,iqu)
        cdzx= +xcd(ijkl,3)*buf2(ijkl,ij,klpx,iqu) 
     *        -xcd(ijkl,1)*buf2(ijkl,ij,klpz,iqu)
     *       +xycd(ijkl,2)*buf2(ijkl,ij,kl,iqu)
c
cccccc  typ1y(ijkl,ij,kl,iqu)= abzx+cdzx
cccccc  typ2y(ijkl,ij,kl,iqu)=-abzx+cdzx
        deriv(3,ijkl,ij,kl,iqu)= abzx+cdzx
        deriv(4,ijkl,ij,kl,iqu)=-abzx+cdzx
c
c--z deriv.
        abyx= -xab(ijkl,2)*buf2(ijkl,ijpx,kl,iqu) 
     *        +xab(ijkl,1)*buf2(ijkl,ijpy,kl,iqu)
     *       +xyab(ijkl,3)*buf2(ijkl,ij,kl,iqu)
        cdyx= -xcd(ijkl,2)*buf2(ijkl,ij,klpx,iqu) 
     *        +xcd(ijkl,1)*buf2(ijkl,ij,klpy,iqu)
     *       +xycd(ijkl,3)*buf2(ijkl,ij,kl,iqu)
c
cccccc  typ1z(ijkl,ij,kl,iqu)= abyx+cdyx
cccccc  typ2z(ijkl,ij,kl,iqu)=-abyx+cdyx
        deriv(5,ijkl,ij,kl,iqu)= abyx+cdyx
        deriv(6,ijkl,ij,kl,iqu)=-abyx+cdyx
c
  250   continue
  225 continue
  200 continue
c
      end
c===================================================================
c===========GRADIENT INTEGRAL DERIVATIVES ROUTINES==================
c
c     It is called from Calcint2 when WHERE='forc'
c
      subroutine force_der(bl,nbls,lnijr,lnklr,npij,ngcd,idx1,ixab)
c
      implicit real*8 (a-h,o-z)
c
      common /logic4/ nfu(1)
      COMMON/SHELL/LSHELLT,LSHELIJ,LSHELKL,LHELP,LCAS2(4),LCAS3(4)
      common /lcases/ lcase
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,mmax,
     * nqi,nqj,nqk,nql,nsij,nskl,
     * nqij,nqij1,nsij1,nqkl,nqkl1,nskl1,ijbeg,klbeg
c
      common /memor4/ iwt0,iwt1,iwt2,ibuf,ibuf2,
     * ibfij1,ibfij2,ibfkl1,ibfkl2,
     * ibf2l1,ibf2l2,ibf2l3,ibf2l4,ibfij3,ibfkl3,
     * ibf3l,issss,
     * ix2l1,ix2l2,ix2l3,ix2l4,ix3l1,ix3l2,ix3l3,ix3l4,
     * ixij,iyij,izij, iwij,ivij,iuij,isij
c
      common /memor4a/ ibf3l1,ibf3l2,ibf3l3,ibf3l4
c
c only for first & second derivatives (for use in amshift):
cccc  common /memor4b/ibuf0
      common /memor4b/ider0,ider1,ider2
c
c dimensions for assembling :
      common /dimasse/ lqijr,lqklr,lqmxr,lij3,lkl3,l3l,lsss
c
      dimension bl(*)
c----------------------------------------------------------
      lqij=nfu(nqij+1)
      lqkl=nfu(nqkl+1)
      lqmx=lqij
      if(lqkl.gt.lqij) lqmx=lqkl
c----------------------------------------------------------
      ndim=4     ! dimension for buf2(ndim,*) used in first_der
c----------------------------------------------------------
      call getmem(3*nbls,ixabq)
      call conv24r(nbls,npij,bl(idx1),bl(ixab),bl(ixabq))
c----------------------------------------------------------
c contracted integrals with higher and lower ang.mom. are in buf now,
c not in buf2. In buf2 derivatives will be placed after call to 
c first_der
c
      ibeg =ibuf
      ider1=ibuf2
      incr9=9*ngcd*nbls*lnij*lnkl
      ider0=ider1+incr9
c
      call first_der(ngcd,nbls,bl(ibeg),ndim,
     *               lnijr,lnklr,lnij,lnkl,nqij,nqkl,
     *               bl(ider1),bl(ider0),bl(ixabq))
c
cccc  ibuf0=ider0
c
c!!!!!!!   poprawic incre and ider0 ponizej !!!!!!!!!
c------
      if(lshellt.eq.0) go to 100
c------
c
c     if(lcase.eq. 2.or.lcase.eq. 6.or.lcase.eq. 8.or.lcase.eq. 9.or.
c    *   lcase.eq.12.or.lcase.eq.13.or.lcase.eq.14.or.lcase.eq.16) then
      if(lshelij.eq.1 .or. lshelij.eq.3) then
c-   --- for bfij1 ---
c
         ibeg =ibfij1
         incr4=4*nbls*lqijr*lnklr
         incr9=9*nbls*lqij*lnkl
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqijr,lnklr,lqij,lnkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibfij1=ider1
         ibfij1_0=ider0
      endif
c----------
c     if(lcase.eq. 3.or.lcase.eq. 6.or.lcase.eq.10.or.lcase.eq.11.or.
c    *   lcase.eq.12.or.lcase.eq.13.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelij.eq.2 .or. lshelij.eq.3) then
c-   --- for bfij2 ---
c
         ibeg =ibfij2
         incr4=4*nbls*lqijr*lnklr
         incr9=9*nbls*lqij*lnkl
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqijr,lnklr,lqij,lnkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibfij2=ider1
         ibfij2_0=ider0
      endif
c----------
c     if(lcase.eq. 4.or.lcase.eq. 7.or.lcase.eq. 8.or.lcase.eq.10.or.
c    *   lcase.eq.12.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.1 .or. lshelkl.eq.3) then
c-   --- for bfkl1 ---
c
         ibeg =ibfkl1
         incr4=4*nbls*lnijr*lqklr
         incr9=9*nbls*lnij*lqkl
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lnijr,lqklr,lnij,lqkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibfkl1=ider1
         ibfkl1_0=ider0
      endif
c----------
c     if(lcase.eq. 5.or.lcase.eq. 7.or.lcase.eq. 9.or.lcase.eq.11.or.
c    *   lcase.eq.13.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.2 .or. lshelkl.eq.3) then
c-   --- for bfkl2 ---
c
         ibeg =ibfkl2
         incr4=4*nbls*lnijr*lqklr
         incr9=9*nbls*lnij*lqkl
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lnijr,lqklr,lnij,lqkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibfkl2=ider1
         ibfkl2_0=ider0
      endif
c----------
      if(lshellt.eq.1) go to 100
c----------
c     if(lcase.eq. 6.or.lcase.eq.12.or.lcase.eq.13.or.lcase.eq.16) then
      if(lshelij.eq.3) then
c-   --- for bfij3 (nbls,4,lnklr) ; 4 is for nmr only
c
         ibeg =ibfij3
         incr4=4*4*nbls*lnklr
         incr9=9*4*nbls*lnkl 
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  4    ,lnklr,1   ,lnkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibfij3=ider1
         ibfij3_0=ider0
      endif
c----------
c     if(lcase.eq. 7.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.3) then
c-   --- for bfkl3 (nbls,lnijr,4) ; 4 is for nmr only
c
         ibeg =ibfkl3
         incr4=4*4*nbls*lnijr
         incr9=9*4*nbls*lnij
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lnijr,4    ,lnij,1   , 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibfkl3=ider1
         ibfkl3_0=ider0
      endif
c----------
c     if(lcase.eq. 8.or.lcase.eq.12.or.lcase.eq.14.or.lcase.eq.16) then
      if(lcas2(1).eq.1) then
c-   --- for bf2l1 ---
c
         ibeg =ibf2l1
         incr4=4*nbls*lqijr*lqklr
         incr9=9*nbls*lqij *lqkl 
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf2l1=ider1
         ibf2l1_0=ider0
      endif
c----------
c     if(lcase.eq. 9.or.lcase.eq.13.or.lcase.eq.14.or.lcase.eq.16) then
      if(lcas2(2).eq.1) then
c-   --- for bf2l2 ---
c
         ibeg =ibf2l2
         incr4=4*nbls*lqijr*lqklr
         incr9=9*nbls*lqij *lqkl 
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf2l2=ider1
         ibf2l2_0=ider0
      endif
c----------
c     if(lcase.eq.10.or.lcase.eq.12.or.lcase.eq.15.or.lcase.eq.16) then
      if(lcas2(3).eq.1) then
c-   --- for bf2l3 ---
c
         ibeg =ibf2l3
         incr4=4*nbls*lqijr*lqklr
         incr9=9*nbls*lqij *lqkl 
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf2l3=ider1
         ibf2l3_0=ider0
      endif
c----------
c     if(lcase.eq.11.or.lcase.eq.13.or.lcase.eq.15.or.lcase.eq.16) then
      if(lcas2(4).eq.1) then
c-   --- for bf2l4 ---
c
         ibeg =ibf2l4
         incr4=4*nbls*lqijr*lqklr
         incr9=9*nbls*lqij *lqkl 
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf2l4=ider1
         ibf2l4_0=ider0
      endif
c----------
      if(lshellt.eq.2) go to 100
c----------
c     if(lcase.eq.12.or.lcase.eq.16) then
      if(lcas3(1).eq.1) then
c-   --- for bf3l(nbls,4,lqmx) -first  
c
         ibeg =ibf3l1
         incr4=4*4*nbls*lqmxr
         incr9=9*4*nbls*lqmx 
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  4    ,lqmxr,1   ,lqmx, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf3l1=ider1
         ibf3l1_0=ider0
      endif
c----------
c     if(lcase.eq.13.or.lcase.eq.16) then
      if(lcas3(2).eq.1) then
c-   --- for bf3l(nbls,4,lqmx) - second
c
         ibeg =ibf3l2
         incr4=4*4*nbls*lqmxr
         incr9=9*4*nbls*lqmx
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  4    ,lqmxr,1   ,lqmx, 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf3l2=ider1
         ibf3l2_0=ider0
      endif
c----------
c     if(lcase.eq.14.or.lcase.eq.16) then
      if(lcas3(3).eq.1) then
c-   --- for bf3l(nbls,lqmx,4) - third 
c
         ibeg =ibf3l3
         incr4=4*4*nbls*lqmxr
         incr9=9*4*nbls*lqmx
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqmxr,4    ,lqmx,1   , 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf3l3=ider1
         ibf3l3_0=ider0
      endif
c----------
c     if(lcase.eq.15.or.lcase.eq.16) then
      if(lcas3(4).eq.1) then
c-   --- for bf3l(nbls,lqmx,4) - fourth
c
         ibeg =ibf3l4
         incr4=4*4*nbls*lqmxr
         incr9=9*4*nbls*lqmx
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  lqmxr,4    ,lqmx,1   , 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         ibf3l4=ider1
         ibf3l4_0=ider0
      endif
c----------
      if(lcase.eq.16) then
c-   --- for ssss(nbls)  ---
         ibeg =issss
         incr4=4*nbls*16
         incr4=9*nbls*16
         ider1=ibeg+incr4
         ider0=ider1+incr9
         call first_der(ngcd,nbls,bl(ibeg),ndim,
     *                  4    ,4    ,1   ,1   , 1 ,1 ,
     *                  bl(ider1),bl(ider0),bl(ixabq))
c-
         issss=ider1
         issss_0=ider0
      endif
c
  100 continue
c...................
      call retmem(1)
      end
c=================================================================
      subroutine first_der(ngcd,nbls,buf2,ndim,lnijr,lnklr,lnij,lnkl,
     *                     nqij,nqkl,deriv,der00,xab)
      implicit real*8 (a-h,o-z)
c
c this subroutine is also called when second-derivatives are calculated
c because first-derivatives are needed in the shifting procedure for
c second-der. That's why dimension for buf2(ndim,*,*,*,*) has ndim=4
c for first- and ndim=10 for second-derivatives.
c
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
cccc  dimension buf2(4,nbls,lnijr,lnklr,ngcd) OR buf2(10,etc.)
c2002 dimension buf2(ndim,nbls,lnijr,lnklr,ngcd)
      dimension buf2(nbls,lnijr,lnklr,ngcd,ndim)
      dimension deriv(9,nbls,lnij,lnkl,ngcd),der00(nbls,lnij,lnkl,ngcd)
      dimension xab(nbls,3)
c-------------------------------------------------------------------
c This routine calculates UNFINISHED gradient derivatives 
c of the type 
c
c d/dAx (a+b,s|c+d,s)=2a*(a+b+1x,s|c+d,s)-n_ab_x*(a+b-1x,s|c+d,s)
c
c d/dBx (a+b,s|c+d,s)=2b*(a+b,s+1x|c+d,s)-  0*(a+b,s-1x|c+d,s)
c                    =2b[(a+b+1x,s|c+d,s)+(Ax-Bx)*(a+b,s|c+d,s)].
c
c d/dCx (a+b,s|c+d,s)=2c*(a+b,s|c+d+1x,s)-n_cd_x*(a+b,s|c+d-1x,s)
c
c-------------------------------------------------------------------
c INPUT buf2(1,nbls,lnijr,lnklr,ngcd) - ordinary 2-el.integ.
c INPUT buf2(2,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 2*exp_a
c INPUT buf2(3,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 2*exp_b
c INPUT buf2(4,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 2*exp_c
c
c OUTPUT : 
c
c--->           derAX=deriv(1,nbls,lnij,lnkl,ngcd),
c--->           derBX=deriv(2,nbls,lnij,lnkl,ngcd)
c--->           derCX=deriv(3,nbls,lnij,lnkl,ngcd),
c
c--->           derAY=deriv(4,nbls,lnij,lnkl,ngcd),
c--->           derBY=deriv(5,nbls,lnij,lnkl,ngcd),
c--->           derCY=deriv(6,nbls,lnij,lnkl,ngcd),
c
c--->           derAZ=deriv(7,nbls,lnij,lnkl,ngcd),
c--->           derBZ=deriv(8,nbls,lnij,lnkl,ngcd),
c--->           derCZ=deriv(9,nbls,lnij,lnkl,ngcd),
c
c--->           der00(nbls,lnij,lnkl,ngcd) - ordinary integr.
c               needed in shifting for d/dA,d/dB (1->2) and d/dC (3->4)
c-------------------------------------------------------------------
c
      do 200 kl=nfu(nqkl)+1,lnkl
      n_cd_x=nia(1,kl)
      n_cd_y=nia(2,kl)
      n_cd_z=nia(3,kl)
      klpx=npxyz(1,kl)
      klpy=npxyz(2,kl)
      klpz=npxyz(3,kl)
c
      klmx=0
      klmy=0
      klmz=0
      if(n_cd_x.gt.0) klmx=nmxyz(1,kl)
      if(n_cd_y.gt.0) klmy=nmxyz(2,kl)
      if(n_cd_z.gt.0) klmz=nmxyz(3,kl)
c
      do 200 ij=nfu(nqij)+1,lnij
      n_ab_x=nia(1,ij)
      n_ab_y=nia(2,ij)
      n_ab_z=nia(3,ij)
      ijpx=npxyz(1,ij)
      ijpy=npxyz(2,ij)
      ijpz=npxyz(3,ij)
      ijmx=0
      ijmy=0
      ijmz=0
      if(n_ab_x.gt.0) ijmx=nmxyz(1,ij)
      if(n_ab_y.gt.0) ijmy=nmxyz(2,ij)
      if(n_ab_z.gt.0) ijmz=nmxyz(3,ij)
c
      do 225 iqu=1,ngcd
        do 250 ijkl=1,nbls
c---------------
        two_a_x=buf2(ijkl,ijpx,kl,iqu,2) 
        two_a_y=buf2(ijkl,ijpy,kl,iqu,2) 
        two_a_z=buf2(ijkl,ijpz,kl,iqu,2) 
c
        two_b_0=buf2(ijkl,ij,kl,iqu,3) 
        two_b_x=buf2(ijkl,ijpx,kl,iqu,3) 
        two_b_y=buf2(ijkl,ijpy,kl,iqu,3) 
        two_b_z=buf2(ijkl,ijpz,kl,iqu,3)
c
        two_c_x=buf2(ijkl,ij,klpx,iqu,4) 
        two_c_y=buf2(ijkl,ij,klpy,iqu,4) 
        two_c_z=buf2(ijkl,ij,klpz,iqu,4) 
c
c---------------
        der00(ijkl,ij,kl,iqu)=buf2(ijkl,ij,kl,iqu,1)
c---------------
c--X deriv.
c
        if(n_ab_x.gt.0) then
           x_n_ab=n_ab_x*buf2(ijkl,ijmx,kl,iqu,1)
           deriv(1,ijkl,ij,kl,iqu)=two_a_x - x_n_ab
        else
           deriv(1,ijkl,ij,kl,iqu)=two_a_x
        endif
        deriv(2,ijkl,ij,kl,iqu)=two_b_x + xab(ijkl,1)*two_b_0
        if(n_cd_x.gt.0) then
           x_n_cd=n_cd_x*buf2(ijkl,ij,klmx,iqu,1)
           deriv(3,ijkl,ij,kl,iqu)=two_c_x - x_n_cd
        else
           deriv(3,ijkl,ij,kl,iqu)=two_c_x
        endif
c---------------
c--Y deriv.
c
        if(n_ab_y.gt.0) then
           y_n_ab=n_ab_y*buf2(ijkl,ijmy,kl,iqu,1)
           deriv(4,ijkl,ij,kl,iqu)=two_a_y - y_n_ab
        else
           deriv(4,ijkl,ij,kl,iqu)=two_a_y
        endif
        deriv(5,ijkl,ij,kl,iqu)=two_b_y + xab(ijkl,2)*two_b_0
        if(n_cd_y.gt.0) then
           y_n_cd=n_cd_y*buf2(ijkl,ij,klmy,iqu,1)
           deriv(6,ijkl,ij,kl,iqu)=two_c_y - y_n_cd
        else
           deriv(6,ijkl,ij,kl,iqu)=two_c_y
        endif
c---------------
c--Z deriv.
c
        if(n_ab_z.gt.0) then
           z_n_ab=n_ab_z*buf2(ijkl,ijmz,kl,iqu,1)
           deriv(7,ijkl,ij,kl,iqu)=two_a_z - z_n_ab
        else
           deriv(7,ijkl,ij,kl,iqu)=two_a_z
        endif
        deriv(8,ijkl,ij,kl,iqu)=two_b_z + xab(ijkl,3)*two_b_0
        if(n_cd_z.gt.0) then
           z_n_cd=n_cd_z*buf2(ijkl,ij,klmz,iqu,1)
           deriv(9,ijkl,ij,kl,iqu)=two_c_z - z_n_cd
        else
           deriv(9,ijkl,ij,kl,iqu)=two_c_z
        endif
c---------------
c
  250   continue
  225 continue
  200 continue
c
      end
c=================================================================
c
c===========HESSIAN  INTEGRAL DERIVATIVES ROUTINES==================
c
c     It is called from Calcint2 when WHERE='hess'
c
      subroutine hessian_der(bl,nbls,lnijr,lnklr,npij,ngcd,idx1,ixab)
c
      implicit real*8 (a-h,o-z)
c
      common /logic4/ nfu(1)
      COMMON/SHELL/LSHELLT,LSHELIJ,LSHELKL,LHELP,LCAS2(4),LCAS3(4)
      common /lcases/ lcase
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,mmax,
     * nqi,nqj,nqk,nql,nsij,nskl,
     * nqij,nqij1,nsij1,nqkl,nqkl1,nskl1,ijbeg,klbeg
c
      common /memor4/ iwt0,iwt1,iwt2,ibuf,ibuf2,
     * ibfij1,ibfij2,ibfkl1,ibfkl2,
     * ibf2l1,ibf2l2,ibf2l3,ibf2l4,ibfij3,ibfkl3,
     * ibf3l,issss,
     * ix2l1,ix2l2,ix2l3,ix2l4,ix3l1,ix3l2,ix3l3,ix3l4,
     * ixij,iyij,izij, iwij,ivij,iuij,isij
c
      common /memor4a/ ibf3l1,ibf3l2,ibf3l3,ibf3l4
c
c only for first & second derivatives (for use in amshift):
cccc  common /memor4b/ibuf0
      common /memor4b/ider0,ider1,ider2
c
c dimensions for assembling :
      common /dimasse/ lqijr,lqklr,lqmxr,lij3,lkl3,l3l,lsss
c
      dimension bl(*)
c----------------------------------------------------------
      lqij=nfu(nqij+1)
      lqkl=nfu(nqkl+1)
      lqmx=lqij
        if(lqkl.gt.lqij) lqmx=lqkl
c----------------------------------------------------------
      ndim=10   ! dimension for buf2(ndim,*) used in first_der
c----------------------------------------------------------
      call getmem(3*nbls,ixabq)
      call conv24r(nbls,npij,bl(idx1),bl(ixab),bl(ixabq))
c----------------------------------------------------------
      ibeg =ibuf
      ider2=ibuf2
      incr45=45*ngcd*nbls*lnij*lnkl
      ider1=ider2+incr45
      incr9 = 9*ngcd*nbls*lnij*lnkl
      ider0=ider1+incr9
c
      call first_der(ngcd,nbls,bl(ibeg),ndim,
     *               lnijr,lnklr,lnij,lnkl,nqij,nqkl,
     *               bl(ider1),bl(ider0),bl(ixabq))
c
      call secnd_der(ngcd,nbls,bl(ibeg),lnijr,lnklr,lnij,lnkl,nqij,nqkl,
     *               bl(ider2),bl(ixabq))
c
c
c!!!!!!!   NOTHING IS READY FOR L-shells    !!!!!!!!!
c------
      if(lshellt.eq.0) go to 100
c------
c
c     if(lcase.eq. 2.or.lcase.eq. 6.or.lcase.eq. 8.or.lcase.eq. 9.or.
c    *   lcase.eq.12.or.lcase.eq.13.or.lcase.eq.14.or.lcase.eq.16) then
      if(lshelij.eq.1 .or. lshelij.eq.3) then
c-   --- for bfij1 ---
c
         ibeg =ibfij1
         incre=nbls*lqijr*lnklr
         incr4=4*incre
         incr9=9*incre
         ider=ibeg+incr4
         ider0=ider+incr9
         call secnd_der(ngcd,nbls,bl(ibeg),lqijr,lnklr,lqij,lnkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibfij1=ibfij1+incr4
      endif
c----------
c     if(lcase.eq. 3.or.lcase.eq. 6.or.lcase.eq.10.or.lcase.eq.11.or.
c    *   lcase.eq.12.or.lcase.eq.13.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelij.eq.2 .or. lshelij.eq.3) then
c-   --- for bfij2 ---
c
         ibeg =ibfij2
         incr1=4*nbls*lqijr*lnklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lqijr,lnklr,lqij,lnkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibfij2=ibfij2+incr1
      endif
c----------
c     if(lcase.eq. 4.or.lcase.eq. 7.or.lcase.eq. 8.or.lcase.eq.10.or.
c    *   lcase.eq.12.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.1 .or. lshelkl.eq.3) then
c-   --- for bfkl1 ---
c
         ibeg =ibfkl1
         incr1=4*nbls*lnijr*lqklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lnijr,lqklr,lnij,lqkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibfkl1=ibfkl1+incr1
      endif
c----------
c     if(lcase.eq. 5.or.lcase.eq. 7.or.lcase.eq. 9.or.lcase.eq.11.or.
c    *   lcase.eq.13.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.2 .or. lshelkl.eq.3) then
c-   --- for bfkl2 ---
c
         ibeg =ibfkl2
         incr1=4*nbls*lnijr*lqklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lnijr,lqklr,lnij,lqkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibfkl2=ibfkl2+incr1
      endif
c----------
      if(lshellt.eq.1) go to 100
c----------
c     if(lcase.eq. 6.or.lcase.eq.12.or.lcase.eq.13.or.lcase.eq.16) then
      if(lshelij.eq.3) then
c-   --- for bfij3 (nbls,4,lnklr) ; 4 is for nmr only
c
         ibeg =ibfij3
         incr1=4*4*nbls*lnklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),4    ,lnklr,1   ,lnkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibfij3=ibfij3+incr1
      endif
c----------
c     if(lcase.eq. 7.or.lcase.eq.14.or.lcase.eq.15.or.lcase.eq.16) then
      if(lshelkl.eq.3) then
c-   --- for bfkl3 (nbls,lnijr,4) ; 4 is for nmr only
c
         ibeg =ibfkl3
         incr1=4*4*nbls*lnijr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lnijr,4    ,lnij,1   , 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibfkl3=ibfkl3+incr1
      endif
c----------
c     if(lcase.eq. 8.or.lcase.eq.12.or.lcase.eq.14.or.lcase.eq.16) then
      if(lcas2(1).eq.1) then
c-   --- for bf2l1 ---
c
         ibeg =ibf2l1
         incr1=4*nbls*lqijr*lqklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf2l1=ibf2l1+incr1
      endif
c----------
c     if(lcase.eq. 9.or.lcase.eq.13.or.lcase.eq.14.or.lcase.eq.16) then
      if(lcas2(2).eq.1) then
c-   --- for bf2l2 ---
c
         ibeg =ibf2l2
         incr1=4*nbls*lqijr*lqklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf2l2=ibf2l2+incr1
      endif
c----------
c     if(lcase.eq.10.or.lcase.eq.12.or.lcase.eq.15.or.lcase.eq.16) then
      if(lcas2(3).eq.1) then
c-   --- for bf2l3 ---
c
         ibeg =ibf2l3
         incr1=4*nbls*lqijr*lqklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf2l3=ibf2l3+incr1
      endif
c----------
c     if(lcase.eq.11.or.lcase.eq.13.or.lcase.eq.15.or.lcase.eq.16) then
      if(lcas2(4).eq.1) then
c-   --- for bf2l4 ---
c
         ibeg =ibf2l4
         incr1=4*nbls*lqijr*lqklr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lqijr,lqklr,lqij,lqkl, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf2l4=ibf2l4+incr1
      endif
c----------
      if(lshellt.eq.2) go to 100
c----------
c     if(lcase.eq.12.or.lcase.eq.16) then
      if(lcas3(1).eq.1) then
c-   --- for bf3l(nbls,4,lqmx) -first  
c
         ibeg =ibf3l1
         incr1=4*4*nbls*lqmxr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),4    ,lqmxr,1   ,lqmx, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf3l1=ibf3l1+incr1
      endif
c----------
c     if(lcase.eq.13.or.lcase.eq.16) then
      if(lcas3(2).eq.1) then
c-   --- for bf3l(nbls,4,lqmx) - second
c
         ibeg =ibf3l2
         incr1=4*4*nbls*lqmxr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),4    ,lqmxr,1   ,lqmx, 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf3l2=ibf3l2+incr1
      endif
c----------
c     if(lcase.eq.14.or.lcase.eq.16) then
      if(lcas3(3).eq.1) then
c-   --- for bf3l(nbls,lqmx,4) - third 
c
         ibeg =ibf3l3
         incr1=4*4*nbls*lqmxr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lqmxr,4    ,lqmx,1   , 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf3l3=ibf3l3+incr1
      endif
c----------
c     if(lcase.eq.15.or.lcase.eq.16) then
      if(lcas3(4).eq.1) then
c-   --- for bf3l(nbls,lqmx,4) - fourth
c
         ibeg =ibf3l4
         incr1=4*4*nbls*lqmxr
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),lqmxr,4    ,lqmx,1   , 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         ibf3l4=ibf3l4+incr1
      endif
c----------
      if(lcase.eq.16) then
c-   --- for ssss(nbls)  ---
         ibeg =issss
         incr1=4*nbls*16
         ider=ibeg+incr1
         call secnd_der(ngcd,nbls,bl(ibeg),4    ,4    ,1   ,1   , 1 ,1 ,
     *                  bl(ider),bl(ixabq))
c-
         issss=issss+incr1
      endif
c
  100 continue
c...................
      call retmem(1)
      end
c=================================================================
      subroutine secnd_der(ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                     nqij,nqkl,der2,xab)
      implicit real*8 (a-h,o-z)
c
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
c2002 dimension buf2(10,nbls,lnijr,lnklr,ngcd)
      dimension buf2(nbls,lnijr,lnklr,ngcd,10)
cccc  dimension der0(nbls,lnij,lnkl,ngcd)        these two are constracted
cccc  dimension der1(9,nbls,lnij,lnkl,ngcd)      when first_der is called
      dimension der2(45,nbls,lnij,lnkl,ngcd)
      dimension xab(nbls,3)
c----------------------------------------------------------------------
c This routine calculates UNFINISHED hessian derivatives (second order)
c of the type 
c----------------------------------------------------------------------
c d2/dAxdAy (a+b,s|c+d,s)=    (2a)*(2a)*(a+b+1x+1y,s|c+d,s)
c                          -n_ab_x*(2a)*(a+b-1x+1y,s|c+d,s)
c                          -n_ab_y*(2a)*(a+b+1x-1y,s|c+d,s)
c                        +n_ab_x*n_ab_y*(a+b-1x-1y,s|c+d,s)
c
c d2/dAxdBy (a+b,s|c+d,s)=
c          (2a)*(2b)*[ (a+b+1x+1y,s|c+d,s) + (Ay-By)*(a+b+1x,s|c+d,s) ]
c            -n_ab_x*[ (a+b-1x+1y,s|c+d,s) + (Ay-By)*(a+b-1x,s|c+d,s) ]
c
c d2/dAxdCy (a+b,s|c+d,s)=    (2a)*(2c)*(a+b+1x,s|c+d+1y,s)
c                          -n_ab_x*(2c)*(a+b-1x,s|c+d+1y,s)
c                          -n_cd_y*(2a)*(a+b+1x,s|c+d-1y,s)
c                        +n_ab_x*n_cd_y*(a+b-1x,s|c+d-1y,s)
c
c d2/dAxdDy (a+b,s|c+d,s)= - [ d2/dAxdAy (a+b,s|c+d,s)
c                             +d2/dAxdBy (a+b,s|c+d,s)
c                             +d2/dAxdCy (a+b,s|c+d,s) ]
c
c----------------------------------------------------------------------
c d2/dBxdAy (a+b,s|c+d,s)= d2/dAydBx (a+b,s|c+d,s) see above
c
c d2/dBxdBy (a+b,s|c+d,s)=          (2b)*(2b)*(a+b+1x+1y,s|c+d,s)
c                          +(Ay-By)*(2b)*(2b)*(a+b+1x,s|c+d,s)
c                          +(Ax-Bx)*(2b)*     (a+b+1y,s|c+d,s)
c                          +(Ax-Bx)*(Ay-By)*  (a+b,s|c+d,s)
c                          +d(Ax-Bx)/dBy*(2b)*(a+b,s|c+d,s)
c
c d2/dBxdCy (a+b,s|c+d,s)=          (2b)*(2c)*(a+b+1x,s|c+d+1y,s)
c                           -n_cd_y*(2b)*     (a+b+1x,s|c+d-1y,s)
c                          +(Ax-Bx)*(2b)*(2c)*(a+b,s|c+d+1y,s)
c                        -(Ax-Bx)*n_cd_y*(2b)*(a+b,s|c+d-1y,s)
c
c d2/dBxdDy (a+b,s|c+d,s)= - [ d2/dBxdAy (a+b,s|c+d,s)
c                             +d2/dBxdBy (a+b,s|c+d,s)
c                             +d2/dBxdCy (a+b,s|c+d,s) ]
c
c----------------------------------------------------------------------
c d2/dCxdAy (a+b,s|c+d,s)= d2/dAydCx (a+b,s|c+d,s)  see above
c d2/dCxdBy (a+b,s|c+d,s)= d2/dBydCx (a+b,s|c+d,s)  see above
c
c d2/dCxdCy (a+b,s|c+d,s)=    (2c)*(2c)*(a+b,s|c+d+1x+1y,s)
c                          -n_cd_x*(2c)*(a+b,s|c+d-1x+1y,s)
c                          -n_cd_y*(2c)*(a+b,s|c+d+1x-1y,s)
c                        +n_cd_x*n_cd_y*(a+b,s|c+d-1x-1y,s)
c
c d2/dCxdDy (a+b,s|c+d,s)= - [ d2/dCxdAy (a+b,s|c+d,s)
c                             +d2/dCxdBy (a+b,s|c+d,s)
c                             +d2/dCxdCy (a+b,s|c+d,s) ]
c
c----------------------------------------------------------------------
c d2/dDxdAy (a+b,s|c+d,s)= d2/dAydDx (a+b,s|c+d,s)  see above
c d2/dDxdBy (a+b,s|c+d,s)= d2/dBydDx (a+b,s|c+d,s)  see above
c d2/dDxdCy (a+b,s|c+d,s)= d2/dCydDx (a+b,s|c+d,s)  see above
c
c d2/dDxdDy (a+b,s|c+d,s)= - [ d2/dDxdAy (a+b,s|c+d,s)
c                             +d2/dDxdBy (a+b,s|c+d,s)
c                             +d2/dDxdCy (a+b,s|c+d,s) ]
c
c----------------------------------------------------------------------
c Order for derivatives:       AA AB AC AD
c                                 BB BC BD
c                                    CC CD
c                                       DD
c
c       Block AA :         Block AB :          Block AC :     Block AD :
c  1 -  d2/dAxdAx     7 -  d2/dAxdBx     16 -  d2/dAxdCx      trans.inv.
c  2 -  d2/dAxdAy     8 -  d2/dAxdBy     17 -  d2/dAxdCy
c  3 -  d2/dAxdAz     9 -  d2/dAxdBz     18 -  d2/dAxdCz
c  4 -  d2/dAydAy    10 -  d2/dAydBx     19 -  d2/dAydCx
c  5 -  d2/dAydAz    11 -  d2/dAydBy     20 -  d2/dAydCy
c  6 -  d2/dAzdAz    12 -  d2/dAydBz     21 -  d2/dAydCz
c                    13 -  d2/dAzdBx     22 -  d2/dAzdCx
c                    14 -  d2/dAzdBy     23 -  d2/dAzdCy
c                    15 -  d2/dAzdBz     24 -  d2/dAzdCz
c
c       Block BA :         Block BB :          Block BC :     Block BD :
c                    25 -  d2/dBxdBx     31 -  d2/dBxdCx      trans.inv.
c                    26 -  d2/dBxdBy     32 -  d2/dBxdCy
c                    27 -  d2/dBxdBz     33 -  d2/dBxdCz
c                    28 -  d2/dBydBy     34 -  d2/dBydCx
c                    29 -  d2/dBydBz     35 -  d2/dBydCy
c                    30 -  d2/dBzdBz     36 -  d2/dBydCz
c                                        37 -  d2/dBzdCx
c                                        38 -  d2/dBzdCy
c                                        39 -  d2/dBzdCz
c
c       Block CA :         Block CB :          Block CC :     Block CD :
c                                        40 -  d2/dCxdCx      trans.inv.
c                                        41 -  d2/dCxdCy
c                                        42 -  d2/dCxdCz
c                                        43 -  d2/dCydCy
c                                        44 -  d2/dCydCz
c                                        45 -  d2/dCzdCz
c----------------------------------------------------------------------
c INPUT buf2(1,nbls,lnijr,lnklr,ngcd) - ordinary 2-el.integ.
c
c  buf2(2,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 2*exp_a
c  buf2(3,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 2*exp_b
c  buf2(4,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 2*exp_c
c
c  buf2(5,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 4*exp_a*exp_b
c  buf2(6,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 4*exp_a*exp_c
c  buf2(7,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 4*exp_b*exp_c
c
c  buf2(8,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 4*exp_a*exp_a
c  buf2(9,nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 4*exp_b*exp_b
c  buf2(10nbls,lnijr,lnklr,ngcd) - 2-el.integ. resc by 4*exp_c*exp_c
c
c OUTPUT : 
c    der000=der0(nbls,lnij,lnkl,ngcd) - ordinary integr.
c    needed in shifting for d/dA,d/dB (1->2) and d/dC (3->4)
c
c    der1AX=der1(1,nbls,lnij,lnkl,ngcd),
c    der1BX=der1(2,nbls,lnij,lnkl,ngcd)
c    der1CX=der1(3,nbls,lnij,lnkl,ngcd),
c
c    der1AY=der1(4,nbls,lnij,lnkl,ngcd),
c    der1BY=der1(5,nbls,lnij,lnkl,ngcd),
c    der1CY=der1(6,nbls,lnij,lnkl,ngcd),
c
c    der1AZ=der1(7,nbls,lnij,lnkl,ngcd),
c    der1BZ=der1(8,nbls,lnij,lnkl,ngcd),
c    der1CZ=der1(9,nbls,lnij,lnkl,ngcd),
c
c    der2_AxAx=der2(1,nbls,lnij,lnkl,ngcd),
c    der2_AxAy=der2(2,nbls,lnij,lnkl,ngcd),
c    der2_AxAz=der2(3,nbls,lnij,lnkl,ngcd),
c    der2_AyAy=der2(4,nbls,lnij,lnkl,ngcd),
c    der2_AyAz=der2(5,nbls,lnij,lnkl,ngcd),
c    der2_AzAz=der2(6,nbls,lnij,lnkl,ngcd),
c
c    der2_AxBx= der2(7,nbls,lnij,lnkl,ngcd),
c    der2_AxBy= der2(8,nbls,lnij,lnkl,ngcd),
c    der2_AxBz= der2(9,nbls,lnij,lnkl,ngcd),
c    der2_AyBx=der2(10,nbls,lnij,lnkl,ngcd),
c    der2_AyBy=der2(11,nbls,lnij,lnkl,ngcd),
c    der2_AyBz=der2(12,nbls,lnij,lnkl,ngcd),
c    der2_AzBx=der2(13,nbls,lnij,lnkl,ngcd),
c    der2_AzBy=der2(14,nbls,lnij,lnkl,ngcd),
c    der2_AzBz=der2(15,nbls,lnij,lnkl,ngcd),
c
c    der2_AxCx=der2(16,nbls,lnij,lnkl,ngcd),
c    der2_AxCy=der2(17,nbls,lnij,lnkl,ngcd),
c    der2_AxCz=der2(18,nbls,lnij,lnkl,ngcd),
c    der2_AyCx=der2(19,nbls,lnij,lnkl,ngcd),
c    der2_AyCy=der2(20,nbls,lnij,lnkl,ngcd),
c    der2_AyCz=der2(21,nbls,lnij,lnkl,ngcd),
c    der2_AzCx=der2(22,nbls,lnij,lnkl,ngcd),
c    der2_AzCy=der2(23,nbls,lnij,lnkl,ngcd),
c    der2_AzCz=der2(24,nbls,lnij,lnkl,ngcd),
c
c    der2_BxBx=der2(25,nbls,lnij,lnkl,ngcd),
c    der2_BxBy=der2(26,nbls,lnij,lnkl,ngcd),
c    der2_BxBz=der2(27,nbls,lnij,lnkl,ngcd),
c    der2_ByBy=der2(28,nbls,lnij,lnkl,ngcd),
c    der2_ByBz=der2(29,nbls,lnij,lnkl,ngcd),
c    der2_BzBz=der2(30,nbls,lnij,lnkl,ngcd),
c
c    der2_BxCx=der2(31,nbls,lnij,lnkl,ngcd),
c    der2_BxCy=der2(32,nbls,lnij,lnkl,ngcd),
c    der2_BxCz=der2(33,nbls,lnij,lnkl,ngcd),
c    der2_ByCx=der2(34,nbls,lnij,lnkl,ngcd),
c    der2_ByCy=der2(35,nbls,lnij,lnkl,ngcd),
c    der2_ByCz=der2(36,nbls,lnij,lnkl,ngcd),
c    der2_BzCx=der2(37,nbls,lnij,lnkl,ngcd),
c    der2_BzCy=der2(38,nbls,lnij,lnkl,ngcd),
c    der2_BzCz=der2(39,nbls,lnij,lnkl,ngcd),
c
c    der2_CxCx=der2(40,nbls,lnij,lnkl,ngcd),
c    der2_CxCy=der2(41,nbls,lnij,lnkl,ngcd),
c    der2_CxCz=der2(42,nbls,lnij,lnkl,ngcd),
c    der2_CyCy=der2(43,nbls,lnij,lnkl,ngcd),
c    der2_CyCz=der2(44,nbls,lnij,lnkl,ngcd),
c    der2_CzCz=der2(45,nbls,lnij,lnkl,ngcd),
c-------------------------------------------------------------------
c Second derivatives:
c 
c Block AA (1-6)
c Block BB (25-30)
c Block CC (40-45)
c
        nder_aa=1
        nder_bb=25
        nder_cc=40
        do icart=1,3
           do jcart=icart,3    
              call block_aa(icart,jcart,
     *                      ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                      nqij,nqkl,
     *                      nder_aa,der2)
!DIR$ NOINLINE
              call block_bb(icart,jcart,
     *                      ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                      nqij,nqkl,
     *                      nder_bb,der2,xab)
              call block_cc(icart,jcart,
     *                      ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                      nqij,nqkl,
     *                      nder_cc,der2)
              nder_aa=nder_aa+1
              nder_bb=nder_bb+1
              nder_cc=nder_cc+1
           enddo
        enddo
c
c Block AB (7-15)
c Block AC (16-24)
c Block BC (31-39)
c
        nder_ab=7
        nder_ac=16
        nder_bc=31
        do icart=1,3
           do jcart=1,3    
              call block_ab(icart,jcart,
     *                      ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                      nqij,nqkl,
     *                      nder_ab,der2,xab)
              call block_ac(icart,jcart,
     *                      ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                      nqij,nqkl,
     *                      nder_ac,der2)
!DIR$ INLINE
              call block_bc(icart,jcart,
     *                      ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                      nqij,nqkl,
     *                      nder_bc,der2,xab)
              nder_ab=nder_ab+1
              nder_ac=nder_ac+1
              nder_bc=nder_bc+1
           enddo
        enddo
c
      end
c=================================================================
      subroutine block_aa(icart,jcart,
     *                    ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                    nqij,nqkl,
     *                    nder_aa,der2)
      implicit real*8 (a-h,o-z)
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
      dimension buf2(nbls,lnijr,lnklr,ngcd,10)
      dimension der2(45,nbls,lnij,lnkl,ngcd)
c
      do 200 kl=nfu(nqkl)+1,lnkl
      do 200 ij=nfu(nqij)+1,lnij
c
      ij_pi=npxyz(icart,ij)
      ij_pj=npxyz(jcart,ij)
      ij_pi_pj=npxyz(jcart,ij_pi)
c----------------------------------
c Three "pawers" are needed :
c     n_ij_00_i=nia(icart,ij)
c     n_ij_pi_j=nia(jcart,ij_pi)
c     n_ij_mi_j=nia(jcart,ij_mi)
c----------------------------------
      n_ij_pi_j=nia(jcart,ij_pi)
c
      n_ij_00_i=nia(icart,ij)
      if(n_ij_00_i.gt.0) then
         ij_mi=nmxyz(icart,ij)
      else
         ij_mi=0
      endif
c
      if(ij_mi.gt.0) then
         n_ij_mi_j=nia(jcart,ij_mi)
      else
         n_ij_mi_j=0
      endif
c
c first add than substract:
      ij_mi_pj=nmxyz(icart,ij_pj)
      ij_pi_mj=nmxyz(jcart,ij_pi)
c
      ij_mi_mj=0
      if(ij_mi.gt.0) ij_mi_mj=nmxyz(jcart,ij_mi)
c                 or ij_mi_mj=nmxyz(icart,ij_mj)
c
      do 225 iqu=1,ngcd
        do 250 ijkl=1,nbls
c
c       four_a_pipj=buf2(8,ijkl,ij_pi_pj, kl,iqu) 
c       two_a_mi_pj=buf2(2,ijkl,ij_mi_pj, kl,iqu) 
c       two_a_pi_mj=buf2(2,ijkl,ij_pi_mj, kl,iqu) 
c       two_0_mi_mj=buf2(1,ijkl,ij_mi_mj, kl,iqu) 
c
      der=buf2(ijkl,ij_pi_pj, kl,iqu,8) 
c
      if(ij_mi_pj.gt.0) then
         der=der-n_ij_00_i*buf2(ijkl,ij_mi_pj, kl,iqu,2) 
      endif
      if(ij_pi_mj.gt.0) then
         der=der-n_ij_pi_j*buf2(ijkl,ij_pi_mj, kl,iqu,2) 
      endif
      if(ij_mi_mj.gt.0) then
         der=der+n_ij_00_i*n_ij_mi_j*buf2(ijkl,ij_mi_mj, kl,iqu,1)
      endif
c
      der2(nder_aa,ijkl,ij,kl,iqu)=der
c
  250   continue
  225 continue
  200 continue
c
      end
c=================================================================
      subroutine block_cc(icart,jcart,
     *                    ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                    nqij,nqkl,
     *                    nder_cc,der2)
      implicit real*8 (a-h,o-z)
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
c2002 dimension buf2(10,nbls,lnijr,lnklr,ngcd)
      dimension buf2(nbls,lnijr,lnklr,ngcd,10)
      dimension der2(45,nbls,lnij,lnkl,ngcd)
c
      do 200 kl=nfu(nqkl)+1,lnkl
      kl_pi=npxyz(icart,kl)
      kl_pj=npxyz(jcart,kl)
      kl_pi_pj=npxyz(jcart,kl_pi)
c
      n_kl_pi_j=nia(jcart,kl_pi)
c
      n_kl_00_i=nia(icart,kl)
      if(n_kl_00_i.gt.0) then
         kl_mi=nmxyz(icart,kl)
      else
         kl_mi=0
      endif
c
      if(kl_mi.gt.0) then
         n_kl_mi_j=nia(jcart,kl_mi)
      else
         n_kl_mi_j=0
      endif
c
c first add than substract:
      kl_mi_pj=nmxyz(icart,kl_pj)
      kl_pi_mj=nmxyz(jcart,kl_pi)
c
      kl_mi_mj=0
      if(kl_mi.gt.0) kl_mi_mj=nmxyz(jcart,kl_mi)
c                 or kl_mi_mj=nmxyz(icart,kl_mj)
c
      do 200 ij=nfu(nqij)+1,lnij
      do 225 iqu=1,ngcd
        do 250 ijkl=1,nbls
c
c
c       four_c_pipj=buf2(10,ijkl,ij,kl_pi_pj,iqu) 
c       two_c_mi_pj=buf2( 4,ijkl,ij,kl_mi_pj,iqu) 
c       two_c_pi_mj=buf2( 4,ijkl,ij,kl_pi_mj,iqu) 
c       two_0_mi_mj=buf2( 1,ijkl,ij,kl_mi_mj,iqu) 
c
      der=buf2(ijkl,ij,kl_pi_pj,iqu,10) 
      if(kl_mi_pj.gt.0) then
        der=der-n_kl_00_i*buf2(ijkl,ij,kl_mi_pj,iqu,4) 
      endif
      if(kl_pi_mj.gt.0) then
        der=der-n_kl_pi_j*buf2(ijkl,ij,kl_pi_mj,iqu,4) 
      endif
      if(kl_mi_mj.gt.0) then
        der=der+n_kl_00_i*n_kl_mi_j*buf2(ijkl,ij,kl_mi_mj,iqu,1) 
      endif
c
      der2(nder_cc,ijkl,ij,kl,iqu)=der
c
  250   continue
  225 continue
  200 continue
c
      end
c=================================================================
      subroutine block_bb(icart,jcart,
     *                    ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                    nqij,nqkl,
     *                    nder_bb,der2,xab)
      implicit real*8 (a-h,o-z)
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
c2002 dimension buf2(10,nbls,lnijr,lnklr,ngcd)
      dimension buf2(nbls,lnijr,lnklr,ngcd,10)
      dimension der2(45,nbls,lnij,lnkl,ngcd)
      dimension xab(nbls,3)
ctest
c     write(6,60) icart,jcart,nder_bb
c 60  format('from BB: icart,jcart=',2i3,' no=',i3)
c
      do 200 kl=nfu(nqkl)+1,lnkl
      do 200 ij=nfu(nqij)+1,lnij
c
      ij_pi=npxyz(icart,ij)
      ij_pj=npxyz(jcart,ij)
      ij_pi_pj=npxyz(jcart,ij_pi)
c
      do 225 iqu=1,ngcd
        do 250 ijkl=1,nbls
c
c       four_b_pipj=buf2(9,ijkl,ij_pi_pj, kl,iqu) 
c       four_b_pi  =buf2(9,ijkl,ij_pi   , kl,iqu) 
c       four_b_pj  =buf2(9,ijkl,ij_pj   , kl,iqu) 
c       four_b_0   =buf2(9,ijkl,ij      , kl,iqu) 
c       two_b_0    =buf2(3,ijkl,ij      , kl,iqu) 
c
      der=                  buf2(ijkl,ij_pi_pj,kl,iqu,9) 
     *              +xab(ijkl,jcart)*buf2(ijkl,ij_pi,kl,iqu,9) 
     *              +xab(ijkl,icart)*buf2(ijkl,ij_pj,kl,iqu,9) 
     *   +xab(ijkl,icart)*xab(ijkl,jcart)*buf2(ijkl,ij,kl,iqu,9) 

      if(jcart.eq.icart) der=der-buf2(ijkl,ij,kl,iqu,3) 
c
      der2(nder_bb,ijkl,ij,kl,iqu)=der
c
c        write(6,66) nder_bb, ij,kl
c  66    format('no=',i3,'ij,kl=',2i4)
c        write(6,67) '(2b)2 int. ++ =',buf2(9,ijkl,ij_pi_pj,kl,iqu)
c        write(6,67) '(2b)2 int. +0 =',buf2(9,ijkl,ij_pi   ,kl,iqu)
c        write(6,67) '(2b)2 int. 0+ =',buf2(9,ijkl,ij_pj   ,kl,iqu)
c        write(6,67) '(2b)2 int. 00 =',buf2(9,ijkl,ij      ,kl,iqu)
c        write(6,67) '(2b)1 int. 00 =',buf2(3,ijkl,ij      ,kl,iqu)
c        write(6,67) '  final deriv =',der
c 67     format(a15,f12.7)
c
  250   continue
  225 continue
  200 continue
c
      end
c=================================================================
      subroutine block_ab(icart,jcart,
     *                    ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                    nqij,nqkl,
     *                    nder_ab,der2,xab)
      implicit real*8 (a-h,o-z)
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
c2002 dimension buf2(10,nbls,lnijr,lnklr,ngcd)
      dimension buf2(nbls,lnijr,lnklr,ngcd,10)
      dimension der2(45,nbls,lnij,lnkl,ngcd)
      dimension xab(nbls,3)
ctest
c     write(6,60) icart,jcart,nder_ab
c 60  format('from AB: icart,jcart=',2i3,' no=',i3)
c
c
      do 200 kl=nfu(nqkl)+1,lnkl
      do 200 ij=nfu(nqij)+1,lnij
c
      ij_pi=npxyz(icart,ij)
      ij_pj=npxyz(jcart,ij)
      n_ij_i=nia(icart,ij)
c
      ij_mi=0
      if(n_ij_i.gt.0) ij_mi=nmxyz(icart,ij)
c
      ij_pi_pj=npxyz(jcart,ij_pi)
c first add than substract:
      ij_mi_pj=nmxyz(icart,ij_pj)
c
c     ij_mi_mj=0
c     if(ij_mi.gt.0) ij_mi_mj=nmxyz(jcart,ij_mi)
c                 or ij_mi_mj=nmxyz(icart,ij_mj)
c
      do 225 iqu=1,ngcd
        do 250 ijkl=1,nbls
c
c       four_ab_pipj=buf2(5,ijkl,ij_pi_pj, kl,iqu) 
c       four_ab_pi  =buf2(5,ijkl,ij_pi   , kl,iqu) 
c
c       two_b_mi_pj=buf2(3,ijkl,ij_mi_pj, kl,iqu) 
c       two_b_mi   =buf2(3,ijkl,ij_mi   , kl,iqu) 
c
      der=                buf2(ijkl,ij_pi_pj, kl,iqu,5) 
     *         +xab(ijkl,jcart)*buf2(ijkl,ij_pi, kl,iqu,5) 
c
      if(n_ij_i.gt.0) then
        if(ij_mi_pj.gt.0) then
          der=der-n_ij_i*buf2(ijkl,ij_mi_pj, kl,iqu,3) 
        endif
        if(ij_mi   .gt.0) then
          der=der -n_ij_i*xab(ijkl,jcart)*buf2(ijkl,ij_mi , kl,iqu,3) 
        endif
      endif
c
c        write(6,66) nder_ab, ij,kl
c  66    format('no=',i3,'ij,kl=',2i4)
c        write(6,67) '(4ab  int. ++ =',buf2(5,ijkl,ij_pi_pj,kl,iqu)
c        write(6,67) '(4ab  int. +  =',buf2(5,ijkl,ij_pi   ,kl,iqu)
c        write(6,67) '(2b   int. -+ =',buf2(3,ijkl,ij_mi_pj,kl,iqu)
c        write(6,67) '(2b   int. -  =',buf2(3,ijkl,ij_mi   ,kl,iqu)
c        write(6,67) '  final deriv =',der
c 67     format(a15,f12.7)
c
c
      der2(nder_ab,ijkl,ij,kl,iqu)=der
c
  250   continue
  225 continue
  200 continue
c
      end
c=================================================================
      subroutine block_ac(icart,jcart,
     *                    ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                    nqij,nqkl,
     *                    nder_ac,der2)
      implicit real*8 (a-h,o-z)
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
c2002 dimension buf2(10,nbls,lnijr,lnklr,ngcd)
      dimension buf2(nbls,lnijr,lnklr,ngcd,10)
      dimension der2(45,nbls,lnij,lnkl,ngcd)
ctest
c     write(6,60) icart,jcart,nder_ac
c 60  format('from AC: icart,jcart=',2i3,' no=',i3)
c
c
      do 200 kl=nfu(nqkl)+1,lnkl
      kl_pj=npxyz(jcart,kl)
      n_kl_j=nia(jcart,kl)
      kl_mj=0
      if(n_kl_j.gt.0) kl_mj=nmxyz(jcart,kl)
c
      do 200 ij=nfu(nqij)+1,lnij
      ij_pi=npxyz(icart,ij)
      n_ij_i=nia(icart,ij)
      ij_mi=0
      if(n_ij_i.gt.0) ij_mi=nmxyz(icart,ij)
c
      do 225 iqu=1,ngcd
        do 250 ijkl=1,nbls
c
c       four_ac_pipj=buf2(6,ijkl,ij_pi,kl_pj,iqu) 
c
c       two_c_mi_pj=buf2(4,ijkl,ij_mi,kl_pj,iqu) 
c       two_a_pi_mj=buf2(2,ijkl,ij_pi,kl_mj,iqu) 
c       two_0_mi_mj=buf2(1,ijkl,ij_mi,kl_mj,iqu) 
c
      der=buf2(ijkl,ij_pi,kl_pj,iqu,6) 
      if(n_ij_i.gt.0 .and. ij_mi.gt.0) then
        der=der-n_ij_i*buf2(ijkl,ij_mi,kl_pj,iqu,4) 
      endif
      if(n_kl_j.gt.0 .and. kl_mj.gt.0) then
        der=der-n_kl_j*buf2(ijkl,ij_pi,kl_mj,iqu,2) 
      endif
      if(n_ij_i.gt.0 .and. n_kl_j.gt.0) then
cccc    if(ij_mi.gt.0 .and. kl_mj.gt.0) then
        der=der+n_ij_i*n_kl_j*buf2(ijkl,ij_mi,kl_mj,iqu,1) 
cccc    endif
      endif
c
      der2(nder_ac,ijkl,ij,kl,iqu)=der
c
c        write(6,66) nder_ac, ij,kl
c        write(6,*)'ij   ,kl   =',ij   ,kl   
c        write(6,*)'ij_pi,kl_pj=',ij_pi,kl_pj
c        write(6,*)'ij_mi,kl_pj=',ij_mi,kl_pj
c        write(6,*)'ij_pi,kl_mj=',ij_pi,kl_mj
c        write(6,*)'ij_mi,kl_mj=',ij_mi,kl_mj
c  66    format('no=',i3,'ij,kl=',2i4)
c        write(6,67) '(4ac  int. ++ =',buf2(6,ijkl,ij_pi,kl_pj,iqu)
c        write(6,67) '(2c   int. -+ =',buf2(4,ijkl,ij_mi,kl_pj,iqu)
c        write(6,67) '(2a   int. +- =',buf2(2,ijkl,ij_pi,kl_mj,iqu)
c        write(6,67) '(     int. -- =',buf2(1,ijkl,ij_mi,kl_mj,iqu)
c        write(6,67) '  final deriv =',der
c 67     format(a15,f12.7)
c
  250   continue
  225 continue
  200 continue
c
      end
c=================================================================
      subroutine block_bc(icart,jcart,
     *                    ngcd,nbls,buf2,lnijr,lnklr,lnij,lnkl,
     *                    nqij,nqkl,
     *                    nder_bc,der2,xab)
      implicit real*8 (a-h,o-z)
      common /logic4/ nfu(1)
      common /logic9/ nia(3,1)
      common /logic10/ nmxyz(3,1)
      common /logic11/ npxyz(3,1)
c
c2002 dimension buf2(10,nbls,lnijr,lnklr,ngcd)
      dimension buf2(nbls,lnijr,lnklr,ngcd,10)
      dimension der2(45,nbls,lnij,lnkl,ngcd)
      dimension xab(nbls,3)
c
      do 200 kl=nfu(nqkl)+1,lnkl
      kl_pj=npxyz(jcart,kl)
      n_kl_j=nia(jcart,kl)
      kl_mj=0
      if(n_kl_j.gt.0) kl_mj=nmxyz(jcart,kl)
c
      do 200 ij=nfu(nqij)+1,lnij
      ij_pi=npxyz(icart,ij)
c
      do 225 iqu=1,ngcd
        do 250 ijkl=1,nbls
c
c       four_bc_pipj=buf2(7,ijkl,ij_pi,kl_pj,iqu) 
c       four_bc_0ipj=buf2(7,ijkl,ij   ,kl_pj,iqu) 
c
c       two_b_pi_mj=buf2(3,ijkl,ij_pi,kl_mj,iqu) 
c       two_b_0i_mj=buf2(3,ijkl,ij   ,kl_mj,iqu) 
c
c
      der=                buf2(ijkl,ij_pi,kl_pj,iqu,7) 
     *  + xab(ijkl,icart)*buf2(ijkl,ij   ,kl_pj,iqu,7)
c
      if(n_kl_j.gt.0 .and. kl_mj.gt.0) then
          der=der
     *    - n_kl_j*(                  buf2(ijkl,ij_pi,kl_mj,iqu,3) 
     *              + xab(ijkl,icart)*buf2(ijkl,ij   ,kl_mj,iqu,3) )
     *      
      endif
c
      der2(nder_bc,ijkl,ij,kl,iqu)=der
c
  250   continue
  225 continue
  200 continue
c
      end
c=================================================================

      SUBROUTINE OFFSET_ccsdtq_lambda1_20_1(l_a_offset,k_a_offset,size)
C     $Id: OFFSET_ccsdtq_lambda1_20_1.F 19700 2010-10-29 17:11:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p15 p17 p18 h13 h14 h16 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p15b
      INTEGER p17b
      INTEGER p18b
      INTEGER h13b
      INTEGER h14b
      INTEGER h16b
      length = 0
      DO p15b = noab+1,noab+nvab
      DO p17b = p15b,noab+nvab
      DO p18b = p17b,noab+nvab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      DO h16b = h14b,noab
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b-1)+int_mb(k_spin+p18b
     &-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin
     &+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+p18b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h14b-1
     &),int_mb(k_sym+h16b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b
     &-1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h16b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lambda1_20_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p15b = noab+1,noab+nvab
      DO p17b = p15b,noab+nvab
      DO p18b = p17b,noab+nvab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      DO h16b = h14b,noab
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b-1)+int_mb(k_spin+p18b
     &-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin
     &+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+p18b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h14b-1
     &),int_mb(k_sym+h16b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b
     &-1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h16b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h16b - 1 + noab * (h14b - 1 + noab * (h1
     &3b - 1 + noab * (p18b - noab - 1 + nvab * (p17b - noab - 1 + nvab 
     &* (p15b - noab - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p15b-1) * int_mb(k_range+p17b-1) * in
     &t_mb(k_range+p18b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+h14
     &b-1) * int_mb(k_range+h16b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

c $Id: int_chk_init.F 23223 2012-12-03 22:09:32Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Check that the integral API is initialized
C>
C> Check that the integral API is initialized. If it is not 
C> then a warning is constructed from the message information
C> in the argument and printed on the output. The message text
C> usually is chosen to identify the calling routine.
C>
C> \return Return .true. if the API is initialized, and .false. 
C> otherwise.
C>
c:tex-% part of the internal API routines
c:tex-\subsection{int\_chk\_init}
c:tex-This function checks to see that the integral API is initialized.
c:tex-Returns .true. if initialized and .false. if not.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      logical function int_chk_init(msg)
c:tex-\end{verbatim}
      implicit none
#include "apiP.fh"
#include "stdio.fh"
c:: passed
c:tex-\begin{verbatim}
      character*(*) msg !< [Input] The message text. 
c:tex-\end{verbatim}
c
c check initialization
c
      int_chk_init = init_int.ne.0
      if (.not.int_chk_init) then
        write(luout,*)' ERROR:: <',msg,'>'
        write(luout,*)' int_init was not called '
      endif
      end
C> @}

      subroutine argos_diana_rmsdev(xtrj,xr,wt,wts,xrms,rms,trms,ga_rms,
     + isel,sgmnam)
c $Id: argos_diana_rmsdev.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "argos_diana_params.fh"
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer ga_rms
      real*8 xtrj(ntrj,3,nfrdim)
      real*8 xr(nsa,3),wt(nsa),wts(nsa),xrms(nsa)
      real*8 rms(2,nfrdim),trms(3,nfrtot)
      character*16 sgmnam(nsa)
      integer isel(nsa)
c
      real*8 arms,bfact
c
      integer i,j,k,n,ip,ilc,ihc,jlc,jhc,ilt,iht,jlt,jht
c
      bfact=128.0d0*atan(1.0d0)*atan(1.0d0)/3.0d0
c
      do 1 k=1,nfrme
      call super(xtrj(1,1,k),ntrj,ntrj,xr,wt,wts,xrms,nsa,nsa,
     + .false.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa,.false.)
      rms(1,k)=rms0
      rms(2,k)=rms1
    1 continue
c
      call ga_dgop(mag_d01,xrms,nsa,'+')
c
      if(me.eq.0) then
c
      open(unit=lfnrms,file=filrms(1:index(filrms,' ')-1),
     + form='formatted',status='unknown')
c
      nsgm=1
      do 2 i=2,nsa
      if(sgmnam(i)(11:16).ne.sgmnam(i-1)(11:16)) nsgm=nsgm+1
    2 continue
c
      write(lfnrms,1000) nsa,nsgm,nfrtot
 1000 format(3i7)
c
      if(me.eq.0) then
c
      do 3 i=1,nsa
      xrms(i)=xrms(i)/dble(nfrtot)
    3 continue
c
      write(lfnrms,1001) (sgmnam(i),i,isel(i),
     + sqrt(xrms(i)),bfact*xrms(i),i=1,nsa)
 1001 format(a16,i10,i5,2f12.6)
c
      n=0
      do 4 i=1,nsa
      if(isel(i).ne.0) then
      arms=arms+xrms(i)
      n=n+1
      endif
      if(i.eq.nsa) goto 5
      if(sgmnam(i)(11:16).ne.sgmnam(i+1)(11:16)) goto 5
      goto 4
    5 continue
      if(n.gt.0) then
      write(lfnrms,1002) sgmnam(i)(1:5),sgmnam(i)(11:16),
     + sqrt(arms/dble(n)),bfact*arms/dble(n)
 1002 format(a5,a6,2f12.6)
      endif
      arms=0.0d0
      n=0
    4 continue
c
      endif
c
      do 6 ip=0,np-1
      call ga_distribution(ga_rms,ip,ilc,ihc,jlc,jhc)
      call ga_get(ga_rms,1,2,jlc,jhc,trms(2,ip*nfrdim+1),3)
      call ga_distribution(ga_trt,ip,ilt,iht,jlt,jht)
      call ga_get(ga_trt,1,1,jlt,jht,trms(1,ip*nfrdim+1),3)
    6 continue
c
      write(lfnrms,1003) ((trms(j,k),j=1,3),k=1,nfrtot)
 1003 format(3f12.6)
c
      close(unit=lfnrms,status='keep')
      endif
c
      return
      end

       program cosmo_hack
       implicit none
       character*255 message
       character*255 solutefile
       character*255 cosmofile
       character*255 outfile
       character*16  tar
       character*4 a4
       character*255 buf
       logical ofile
       integer fns,fnc,fno      
       integer iat,ires
       integer nat
       integer i
       character*5, dimension(:), allocatable :: atag
       double precision, dimension(:,:), allocatable :: c
       double precision, dimension(:), allocatable :: q
c
       external util_get_io_unit
       logical util_get_io_unit
c      ---------------------
c      read input parameters
c      ---------------------
       inquire(file="cosmo_hack.dat",exist=ofile)
       if(ofile) then
          open(10,file="cosmo_hack.dat",
     $            form='formatted',status='unknown')
          read(10,*,ERR=911) solutefile
          read(10,*,ERR=911) cosmofile
          read(10,*,ERR=911) outfile
          close(10)
       else
          write(6,*) "Enter solute PDB file"
          read(5,*) solutefile
          write(6,*) "Enter cosmo file"
          read(5,*) cosmofile
          write(6,*) "Enter output file"
          read(5,*) outfile
       end if 
     
       write(*,*) solutefile
       write(*,*) cosmofile
       write(*,*) outfile

c      -------------
c      open io units
c      -------------
       if(.not.util_get_io_unit(fns)) then
           message = "no free file units"
           goto 911
       else
           message = "opening "//trim(solutefile)
           open(fns,file=trim(solutefile),
     $                form='formatted',status='old',err=911)
       end if 

       if(.not.util_get_io_unit(fnc)) then
           message = "no free file units"
           goto 911
       else
           message = "opening "//trim(cosmofile)
           open(fnc,file=trim(cosmofile),
     $                form='formatted',status='unknown',err=911)
       end if 
       if(.not.util_get_io_unit(fno)) then
           message = "no free file units"
           goto 911
       else
           message = "opening "//trim(outfile)
           open(fno,file=trim(outfile),
     $                form='formatted',status='unknown',err=911)
       end if 
c      -------------------------------------------
c      extract solute portion from solute pdb file
c      -------------------------------------------
       rewind(fns)
       do 
         message = "reading "//trim(solutefile)
         read(fns,200,ERR=911,END=911) buf
         write(*,*) trim(buf)
         IF(buf(1:3).eq."TER") exit
         IF(buf(1:3).eq."END") exit
         if(buf(1:4).eq."ATOM") then
           read(buf,*) a4,iat,a4,a4,ires
           write(*,*) "iat,ires",iat,ires
         end if
         write(fno,'(A)') trim(buf)
       end do
c      --------------------------------------------
c      insert cosmo charges as individual fragments
c      --------------------------------------------
       call xyz_read_natoms(nat,fnc)
       write(*,*) "nat",nat
       allocate(c(3,nat))
       allocate(q(nat))
       allocate(atag(nat))
       rewind(fnc)
       call xyzq_read(nat,c,q,atag,fnc)
       write(*,*) "nat",nat
       do i=1,nat
         iat = iat + 1
         ires = ires +1 
         write(a4,'(I3.3)') i
         write(fno,FMT=9000)iat," Q  ",a4,ires,c(1,i),c(2,i),c(3,i)
         write(*,*) "q=",q(i)
c        create fragment
         call create_simple_fragment(1,a4," Q    ","Q     ",q(i))
      end do
c      ------------------
c      add solvent if any
c      ------------------
      do 
         message = "reading "//trim(solutefile)
         read(fns,200,ERR=20,END=20) buf
         write(*,*) trim(buf)
         if(buf(1:4).ne."ATOM") exit
         write(fno,'(A)') trim(buf)
       end do
20     continue
       write(fno,'(A)') "END"
       stop
c      if you reach this you are in trouble
911    continue
       write(*,*) "Emergency STOP"
       write(*,*) message
       stop
c      format statements
c      -----------------
200    FORMAT(A255)
9000   FORMAT("ATOM",T7,I5,T13,A4,T18,A3,T23,I4,T31,
     >        F8.3,T39,F8.3,T47,F8.3,T55,F6.2)
        end

      function util_get_io_unit(fn)

      implicit none
      integer fn
      logical util_get_io_unit
c 
      integer k
      logical ostatus
c
      do k=80,90
        INQUIRE(UNIT=k,OPENED=ostatus)
        ostatus = .not.ostatus
        if(ostatus) 
     >    INQUIRE(UNIT=k,EXIST=ostatus)
        if(ostatus) then
          fn = k
          util_get_io_unit = .true.
          return
        end if 
      end do
      util_get_io_unit = .false.
      return
      end

       subroutine create_simple_fragment(n,ar,an,at,q)
       implicit none
       integer n             !> number of atoms
       character*(*) ar      !> name of the residue
       character(*) an(n)   !> name of atoms in the residue
       character*(*) at(n)   !> name of atom type in the residue
       double precision q(n) !> charges
c
       integer i
       integer fnf
       character*30 pname 
       character*255 message
       external util_get_io_unit
       logical util_get_io_unit
c
       pname = "create_simple_fragment"
       if(.not.util_get_io_unit(fnf)) then
           message = "no free file units"
           goto 911
       else
           message = "opening "//trim(ar)//".frg"
           open(fnf,file=trim(ar)//".frg",
     $                 form='formatted',status='unknown',err=911)
       end if         
       write(fnf,'(A)') "$"//trim(ar)
       write(fnf,'(4I5)') n,1,1,0
       write(fnf,'(A)') trim(ar)
       do i=1,n
         write(fnf,'(I5,A6,A6,5I5,2f12.6)') i,an(i),
     >         at(i),
     >         0,0,0,1,1,q(i),0.0d0
       end do

       close(fnf)
       write(*,*) "out "//pname
       return
c      -------------
c      error section
c      -------------
911    continue
       write(*,*) "ERROR STOP"
       write(*,*) "subroutine:" //pname(1:len_trim(pname))
       write(*,*) "message" //message(1:len_trim(message))
       stop
c
c      format statements
c      -----------------
1030     FORMAT(180A1)
1020     FORMAT(A180)
       end
       subroutine xyz_read_natoms(n,fn_in)
       implicit none
       integer n
       integer fn_in
c       
       character*30 pname
       character*180 bigbuf
       logical is_integer
       external is_integer
c
       pname = "xyz_read_natoms"
       n = 0
c      ------------------------------------------
c      get number of atoms (skipping empty lines)
c      ------------------------------------------
       bigbuf = " "
       do 
         read(fn_in,20,end=10) bigbuf
         if(is_integer(bigbuf)) exit
       end do
       read(bigbuf,*,err=136) n
10     continue
       return
c      -------------
c      error section
c      -------------
136    continue
       write(*,*) "error in ",pname(1:len_trim(pname))
       write(*,*) "current buffer: ",bigbuf(1:len_trim(bigbuf))
       stop
c
c      format statements
c      -----------------
20     FORMAT(A180)
       end

      function is_integer(string)
      implicit none
      character*(*) string
      logical is_integer
c
      character(len=10) :: anumber = "0123456789"
      integer i,l
      is_integer = .false.
      if(string.eq." ") return
      l  = len_trim(string)
      do i=1,l
       if(string(i:i).ne." ") exit
      end do
      is_integer = verify(string(i:l), anumber).eq.0
      end function


       subroutine xyzq_read(n0,c,q,atag,fn_in)
       implicit none
       integer n0
       double precision c(3,n0)
       double precision q(n0)
       integer fn_in
       character*(*) atag(n0)
c
       integer i,k,n
       character*180 bigbuf
       character*180 message
       logical is_integer
       external is_integer
       character*30 pname 
c
       pname = "xyz_read"
       c = 0.0d0
       atag = " "
       n=0
c
       call xyz_read_natoms(n,fn_in)
       if(n.eq.0) then
          n0=0
          goto 20
       end if
       if(n.gt.n0) then
          message = "too small array size"
          goto 911
       end if
c
c      -------------------
c      get title field(if any) 
c      -------------------
       read(fn_in,1020) bigbuf
c
c       ------------------------------------
c       read coordinates(skipping empty lines)
c       ------------------------------------
       do i=1,n
        do
          read(fn_in,1020,end=20) bigbuf
          if(bigbuf.eq."") then
             cycle
          else if(bigbuf(1:1).eq."#") then
             cycle
          else
             exit
          end if
        end do
        message = "reading "//bigbuf
        read(bigbuf,*,err=911) atag(i),(c(k,i),k=1,3),q(i)
        n0=i
       end do
c      check if all atoms were read
       if(n0.lt.n) then
         message = "could not find all the atoms"
         goto 911
       end if
20     continue
       write(*,*) "out "//pname
       return
c      -------------
c      error section
c      -------------
911    continue
       write(*,*) "ERROR STOP"
       write(*,*) "subroutine:" //pname(1:len_trim(pname))
       write(*,*) "message" //message(1:len_trim(message))
       stop
c
c      format statements
c      -----------------
1030     FORMAT(180A1)
1020     FORMAT(A180)
       end
c $Id: main.f 22505 2012-05-21 23:24:13Z d3y133 $

      SUBROUTINE ccsdt_lr_alpha_offdiag_15_11_2_1(d_a,k_a_offset,d_b,k_b
     &_offset,d_c,k_c_offset)
C     $Id: ccsdt_lr_alpha_offdiag_15_11_2_1.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h5 h6 h14 p9 )_yb + = 1 * Sum ( h3 p1 p2 ) * b ( p1 p2 h3 h14 )_b * y ( h3 h5 h6 p1 p2 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h6b
      INTEGER h14b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER p2b
      INTEGER h3b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h14b_1
      INTEGER h3b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h3b_2
      INTEGER p9b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h14b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h14b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+h
     &14b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h14b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_y,irrep_b)) T
     &HEN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+h14b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_15_11_2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h3b = 1,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &14b-1)+int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h14b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_b) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h14b,h3b,p1b_1,p2b_1,h14b_1,h3b_1)
      CALL TCE_RESTRICTED_6(h5b,h6b,h3b,p9b,p1b,p2b,h5b_2,h6b_2,h3b_2,p9
     &b_2,p1b_2,p2b_2)
      dim_common = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+h3b-1)
      dima_sort = int_mb(k_range+h14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_15_11_2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_15_11_2_1',2,MA_ERR)
      IF ((h3b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h14b-1
     &),4,3,2,1,1.0d0)
      END IF
      IF ((h14b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h14b-1),int_mb(k_range+h3b-1
     &),3,4,2,1,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &5_11_2_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_15_11_2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_15_11_2_1',5,MA_ERR)
      IF ((h3b .le. h5b) .and. (p2b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h5b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p9b-1),6,3,2,1,5,4,1.0d0)
      END IF
      IF ((h3b .le. h5b) .and. (p1b .le. p9b) .and. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h5b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p2b-1),5,3,2,1,6,4,-1.0d0)
      END IF
      IF ((h3b .le. h5b) .and. (p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h5b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),4,3,2,1,6,5,1.0d0)
      END IF
      IF ((h5b .lt. h3b) .and. (h3b .le. h6b) .and. (p2b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h3b_2 - 1 + noab * (h5b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p9b-1),6,3,1,2,5,4,-1.0d0)
      END IF
      IF ((h5b .lt. h3b) .and. (h3b .le. h6b) .and. (p1b .le. p9b) .and.
     & (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h3b_2 - 1 + noab * (h5b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p2b-1),5,3,1,2,6,4,1.0d0)
      END IF
      IF ((h5b .lt. h3b) .and. (h3b .le. h6b) .and. (p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h6b_2 - 1 + noab * (h3b_2 - 1 + noab * (h5b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h6b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),4,3,1,2,6,5,-1.0d0)
      END IF
      IF ((h6b .lt. h3b) .and. (p2b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h3b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p9b-1),6,2,1,3,5,4,1.0d0)
      END IF
      IF ((h6b .lt. h3b) .and. (p1b .le. p9b) .and. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h3b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p2b-1),5,2,1,3,6,4,-1.0d0)
      END IF
      IF ((h6b .lt. h3b) .and. (p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h3b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),4,2,1,3,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &5_11_2_1',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p1b .eq. p2b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_15_11_2_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_15_11_2_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_15_11_2_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+h14b-1
     &),3,2,4,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h14b - 1 + noab * (h6b - 1 + noab * (h5b - 1))
     &)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &5_11_2_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_15_11_2_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* $Id: daxpy.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine daxpy(n,da,dx,incx,dy,incy)
c     
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     
      double precision dx(1),dy(1),da
      integer i,incx,incy,m,mp1,n
c     
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c     
c     code for unequal increments or equal increments
c     not equal to 1
c     
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
         dy(iy) = dy(iy) + da*dx(ix)
         ix = ix + incx
         iy = iy + incy
 10   continue
      return
c     
c     code for both increments equal to 1
c     
c     
c     clean-up loop
c     
 20   m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
         dy(i) = dy(i) + da*dx(i)
 30   continue
      if( n .lt. 4 ) return
 40   mp1 = m + 1
      do 50 i = mp1,n,4
         dy(i) = dy(i) + da*dx(i)
         dy(i + 1) = dy(i + 1) + da*dx(i + 1)
         dy(i + 2) = dy(i + 2) + da*dx(i + 2)
         dy(i + 3) = dy(i + 3) + da*dx(i + 3)
 50   continue
      return
      end

      logical function pre_rdpdb(lfnout,filpdb,lfnpdb,filtmp,lfntmp,
     + lnams,csa,isar,isgm,isfnd,xs,vs,msa,nsa,nmis,msm,nsm,iwmr,iwfnd,
     + xw,vw,cwa,mwm,mwa,nwm,nwa,namslv,iwater,altloc,chain,model,box,
     + lpdbbx)
c
c $Id: pre_rdpdb.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
      integer lfnout
      integer lfnpdb,lfntmp,msa,nsa,nmis,msm,nsm,mwm,mwa,nwm,nwa
      logical lnams,lnames
      character*255 filpdb,filtmp
      character*16 cwa(mwa),csa(msa)
      integer isar(msa),isgm(msa),iwmr(mwm),isfnd(msa),iwfnd(mwm)
      real*8 xs(3,msa),vs(3,msa),box(3)
      real*8 xw(3,mwa,mwm),vw(3,mwa,mwm)
      character*3 namslv
      integer iwater,model
      character*1 altloc,chain
c
      character*6 name1,name2
      character*80 card
      integer i,last,nprv,num,iw,length,mdl,nump,ioff,lrgpdb
      real*8 x,y,z
      character*3 namr
      character*4 nama
      character*6 hdr
      logical lsolut,lpdbbx
      character*1 alocal,achain,pchain
c
      lnames=lnams
      iw=0
      iwater=0
      mdl=0
      nump=0
      ioff=0
      pchain=' '
      lrgpdb=0
      lpdbbx=.false.
c
      length=index(filpdb,' ')-1
      if(util_print('where',print_debug)) then
      write(lfnout,2006) filpdb(1:length)
 2006 format(/,'pdb_read  ',a)
      endif
c
c     open pdb file
c     -------------
c
      open(unit=lfnpdb,file=filpdb(1:index(filpdb,' ')-1),
     + form='formatted',status='old',err=9991)
c
      if(util_print('where',print_debug)) then
      write(lfnout,2000) filpdb(1:length)
 2000 format(' PDB OPEN  ',a)
      endif
c
c     open the alternate names file
c     -----------------------------
c
      if(lnames) then
      lnames=.false.
      open(unit=lfntmp,file=filtmp(1:index(filtmp,' ')-1),
     + form='formatted',status='old',err=99)
      lnames=.true.
   99 continue
      endif
c
c     initializations
c     ---------------
c
      nmis=0
      last=0
      nprv=0
      do 1 i=1,msa
      isfnd(i)=0
      isar(i)=0
      xs(1,i)=0.0d0
      xs(2,i)=0.0d0
      xs(3,i)=0.0d0
      vs(1,i)=0.0d0
      vs(2,i)=0.0d0
      vs(3,i)=0.0d0
      if(isgm(i).gt.last) last=isgm(i)
    1 continue
      nsa=0
      nwm=0
      lsolut=.true.
c
  100 continue
c
      read(lfnpdb,1000,end=9,err=9992) card
 1000 format(a)
c
c     BOX
c
      if(card(1:6).eq.'CRYST1') then
      read(card(7:42),'(3f9.3)') box
      box(1)=0.1d0*box(1)
      box(2)=0.1d0*box(2)
      box(3)=0.1d0*box(3)
      lpdbbx=.true.
      goto 100
      endif
c
c     lrgpdb option
c
      if(card(1:6).eq.'LRGPDB') then
      lrgpdb=1
      goto 100
      endif
c
c     MODEL
c
      if(model.ne.mdl) then
      if(card(1:6).eq.'MODEL ') then
      read(card(7:14),1001) mdl
 1001 format(i8)
      if(model.eq.mdl.and.util_print('where',print_debug)) then
      write(lfnout,2005) model
 2005 format(10x,'MODEL ',i8)
      endif
      goto 100
      endif
      endif
c
c     END and ENDMDL
c
      if(card(1:6).eq.'ENDMDL') then
      if(model.eq.mdl) goto 9
      goto 100
      endif
      if(card(1:6).eq.'END   ') goto 9
c
      if(card(1:4).ne.'ATOM'.and.card(1:6).ne.'HETATM') goto 100
c
      if(mdl.ne.model) goto 100
c
      if(lrgpdb.eq.0) then
      read(card,1002,end=9993,err=9993) hdr,nama,alocal,namr,achain,num,
     + x,y,z
      else
      read(card,2002,end=9994,err=9994) hdr,nama,alocal,namr,num,
     + x,y,z
      achain=' '
      endif
 1002 format(a6,6x,a4,a1,a3,1x,a1,i4,4x,3f8.3)
 2002 format(a6,6x,a4,a1,a3,i6,4x,3f8.3)
      if(util_print('where',print_debug)) then
      if(lrgpdb.eq.0) then
      write(lfnout,1002) hdr,nama,alocal,namr,achain,num,x,y,z
      else
      write(lfnout,2002) hdr,nama,alocal,namr,num,x,y,z
      endif
      endif
      if(alocal.ne.' '.and.alocal.ne.altloc.and.altloc.ne.'*') goto 100
      if(achain.ne.' '.and.achain.ne.chain.and.chain.ne.'*') goto 100
c
      if(chain.eq.'*') then
      if(num.lt.nump) then
      if(achain.ne.pchain) ioff=(nump/100+1)*100-num
      num=num+ioff
      endif
      endif
      pchain=achain
      if(card(18:20).eq.namslv) lsolut=.false.
      if(num.ne.nump) nump=num
c
      if(.not.lsolut.or.num.gt.last.or.num.lt.nprv) then
      if(lnames) then
      close(unit=lfntmp)
      lnames=.false.
      endif
      lsolut=.false.
      endif
c
      if(lnames) then
      read(lfntmp,1003,end=9995,err=9995) name1,name2
 1003 format(2a6)
      endif
c
      if(lsolut) then
      do 3 i=1,msa
      if(num.eq.isgm(i)) then
      if(lnames) then
      if(csa(i)(11:14).ne.name2(1:4)) goto 3
      if(nama.ne.name1(1:4)) goto 3
      else
      if(nama.ne.csa(i)(11:14)) goto 3
      endif
      isfnd(i)=1
      xs(1,i)=1.0d-01*x
      xs(2,i)=1.0d-01*y
      xs(3,i)=1.0d-01*z
      goto 100
      endif
    3 continue
      else
      if(iw.ne.num) then
      nwm=nwm+1
      iw=num
      iwfnd(nwm)=0
      endif
      iwfnd(nwm)=iwfnd(nwm)+1
      iwmr(nwm)=0
      if(namslv.eq.'HOH') iwater=1
      do 5 i=1,nwa
      if(cwa(i)(11:14).eq.nama.or.
     + (namslv.eq.'HOH'.and.
     +  ((nama.eq.' O  '.and.cwa(i)(11:14).eq.' OW ').or.
     +   (nama.eq.' H  '.and.cwa(i)(11:14).eq.' HW ')))) then
      xw(1,i,nwm)=1.0d-01*x
      xw(2,i,nwm)=1.0d-01*y
      xw(3,i,nwm)=1.0d-01*z
      vw(1,i,nwm)=0.0d0
      vw(2,i,nwm)=0.0d0
      vw(3,i,nwm)=0.0d0
      endif
    5 continue
      endif
c
      goto 100
c
    9 continue
c
      close(unit=lfnpdb)
c
      if(util_print('where',print_debug)) then
      write(lfnout,2003) filpdb(1:length)
 2003 format(' PDB CLOSE ',a)
      endif
c
      nmis=0
      do 4 i=1,msa
      if(isfnd(i).eq.0) nmis=nmis+1
    4 continue
      nsa=msa
c
      pre_rdpdb=.true.
      return
c
 9991 call md_abort('Error in pre_rdpdb ',1)
 9992 call md_abort('Error in pre_rdpdb ',2)
 9993 call md_abort('Error in pre_rdpdb ',3)
 9994 call md_abort('Error in pre_rdpdb ',4)
 9995 call md_abort('Error in pre_rdpdb ',5)
 9996 call md_abort('Error in pre_rdpdb ',6)
 9997 call md_abort('Error in pre_rdpdb ',7)
 9998 call md_abort('Error in pre_rdpdb ',8)
 9999 continue
      pre_rdpdb=.false.
      return
      end

      subroutine int2e_file_balance
*
* $Id: int2e_balance.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "cint2efile.fh"
#include "eaf.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
c     
c     Attempt to load balance the integral file ... version 2
c
c     Eliminate intermediate syncrhonizations, attempt to overlap
c     big transfers, fuzzy termination.
c     
      integer nrec, me, nproc, him, msglen, from, record
      integer tmp, i, j, p, q, test, nexch, nmoved, npass
      integer his_count, my_count, total, shift
      double precision newfilelen, used
c
      integer maxproc
      parameter (maxproc = 200000)
      integer info(2,0:maxproc-1) ! 1=node#, 2=nrec
      logical int2e_packed_buf_read, int2e_packed_buf_write
     $     , int2e_file_rewind
      external int2e_packed_buf_read, int2e_packed_buf_write
     $     , int2e_file_rewind
      logical oprint, odebug
      intrinsic mod
c     
c Return immediately if in subgroups since the snd and rcv do not work in subgroups
c
      if(GA_PGROUP_GET_DEFAULT() .ne. GA_PGROUP_GET_WORLD()) return

      npass = 0                 ! Used for paranoid infinite loop avoidance
      me = ga_nodeid()          ! Not true on workstation clusters
      nproc = ga_nnodes()
      if (nproc.eq.1) return
c
      call ga_sync()            ! So can use message passing
      used = util_wallsec()
      odebug = util_print('balance debug',print_never) 
      oprint = util_print('balance', print_default) .and.  me.eq.0
      if (odebug) 
     $     write(6,*) me, ' initial n_re_in_file ', n_rec_in_file
c
      nexch = 0                 ! Just for printing statistics
      nmoved= 0
c     
c     Fill in info
c     
      call ifill(2*nproc, 0, info, 1)
      info(1,me) = me
      info(2,me) = n_rec_in_file
      call ga_igop(33, info, 2*nproc, '+')
      total = 0
      do i = 0, nproc-1
         total = total + info(2,i)
      enddo
      nrec = (total - 1) / nproc + 1
      test = max(2,nint(0.01*nrec))
c
c     Adjust info so the record count is difference from the mean
c
      do i = 0, nproc-1
         info(2,i) = info(2,i) - nrec
      enddo
c
c     The logic with shifts is to ensure that have mod(total,nproc)
c     processes with nrec, with rest with nrec-1 (rather than
c     nproc-1 with nrec and one with nrec-nproc-1)
c
      do i = 0, nproc-1
         shift = 0
         if (i.ge.mod(total,nproc)) shift = 1
         info(2,i) = info(2,i) + shift
      enddo
c
 10   continue                  ! While loop
      npass = npass + 1
c
c     Sort nodes by #records suplus/deficit
c
      do i = 0, nproc-1
         do j = 0, i-1
            if (info(2,i).gt.info(2,j)) then
               tmp = info(1,i)
               info(1,i) = info(1,j)
               info(1,j) = tmp
               tmp = info(2,i)
               info(2,i) = info(2,j)
               info(2,j) = tmp
            endif
         enddo
      enddo
c
c     Find my place in the list and thus my counterpart (note i and j
c     used from here to 100)
c
      do i = 0, nproc-1
         if (info(1,i) .eq. me) goto 11
      enddo
      call errquit('int2e_file_balance: algorithm failure?',0,
     &       UNKNOWN_ERR)
 11   j = nproc-1-i
c
      if (odebug .and. me.eq.0) then
         write(6,1) (info(1,tmp), info(2,tmp), tmp=0,nproc-1)
 1       format(400(6(4x,i4,i4:)/))
         call util_flush(6)
      endif
c
c     If discrepancy is small enough then quit
c
      if (info(2,0).le.test .and. info(2,nproc-1).ge.-test) goto 100
      if (npass .gt. ((nproc-1)/2+1)) goto 100
c
c     Pair processor with largest surplus with one with largest deficit
c
      him = info(1,j)
      his_count = info(2,j)
      my_count = info(2,i)
c
c     The case of nproc odd is automatically handled by the logic.
c
      if (my_count.lt.0 .and. his_count.gt.0) then
c     
c     He will send to me
c     
         my_count = min(abs(my_count), his_count)
         if (odebug) then
            write(6,*) me, ' receiving ', my_count, ' from ', him
            call util_flush(6)
         endif
         do record = 1, my_count
            call rcv(2,buf,8*rec_len_in_dbl,msglen,him,from,1)
            if (.not. int2e_packed_buf_write(.false.))
     $           call errquit('int2e_file_balance:write failed',0,
     &       INT_ERR)
         enddo
      else if (my_count.gt.0 .and. his_count.lt.0) then
c     
c     I'll send to him
c     
         his_count = min(my_count, abs(his_count))
         cur_rec = n_rec_in_file - his_count + 1
         do record = 1, his_count
            if (.not. int2e_packed_buf_read())
     $         call errquit('int2e_file_balance: read failed',0,
     &       INT_ERR)
            call snd(2, buf, 8*rec_len_in_dbl, him, 1)
         enddo
         n_rec_in_file = n_rec_in_file - his_count
      endif
c     
c     Adjust everyone's counters by repeating above logic on all nodes
c
      do p = 0, (nproc-2)/2
         q = nproc-1-p
         if (info(2,p).le.0 .and. info(2,q).ge.0) then
            tmp = min(abs(info(2,p)),info(2,q))
            info(2,p) = info(2,p) + tmp
            info(2,q) = info(2,q) - tmp
            nexch  = nexch + 1
            nmoved = nmoved + tmp
         else if (info(2,p).ge.0 .and. info(2,q).le.0) then
            tmp = min(abs(info(2,q)),info(2,p))
            info(2,p) = info(2,p) - tmp
            info(2,q) = info(2,q) + tmp
            nexch  = nexch + 1
            nmoved = nmoved + tmp
         endif
      enddo
c            
      goto 10
c     
 100  if (n_rec_in_file .gt. max_cache_rec) then
         newfilelen = max(0.0d0,
     $        8.0d0*rec_len_in_dbl*(n_rec_in_file-max_cache_rec))
         if (odebug) then
            write(6,*) me,' truncating at ', n_rec_in_file, newfilelen
            call util_flush(6)
         endif
         if (eaf_truncate(fd, newfilelen) .ne. 0) call errquit
     $        ('int2e_file_balance: file truncate failed', 0, INT_ERR)
         cur_rec = n_rec_in_file
      endif
c
      if (oprint) then
         used = util_wallsec() - used
         write(6,21) nexch, nmoved, used
 21      format(/'File balance: exchanges=',i6,'  moved=',i6,
     $        '  time=',f6.1/)
         call util_flush(6)
      endif
c
      if (.not. int2e_file_rewind()) call errquit
     $     ('int2e_file_balance: failed rewind integral file', 0,
     &       INT_ERR)
      call ga_sync()
c
      end

      subroutine movecs_fragment(rtdb, geom, basis, 
     $     module, iset, nclosed, nopen, g_vecs, evals)
*
* $Id: movecs_frag.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
      integer rtdb              ! [input]
      integer geom, basis       ! [input]
      character *(*) module     ! [input] Name of invoking module
      integer iset              ! [input] 1 ROHF, 1/2=alpha/beta UHF
      integer nclosed           ! [input] doubly occ in each set (zero UHF)
      integer nopen             ! [input] single (active) occ in each set
      integer g_vecs            ! [output] GA containing MOs
      double precision evals(*) ! [output] Eigenvalues from the fragments
c
c     Assemble initial guess MOs from the MO vectors of
c     fragments.
c
      integer nmo, nbf, nvirt, closed_off, open_off, virt_off, bf_off
      integer g_frag, l_eval, k_eval, l_occ, k_occ, excess
      integer nclosed_frag, nopen_frag, nvirt_frag, ioff
      integer i
      integer maxfrag
      parameter (maxfrag = 100)
      character*256 fragments(maxfrag), key
      integer ma_type, nfrag
c
      logical oprint
c
      character*255 title_frag, basis_name_frag
      character*20 scftype_frag
      integer nbf_frag, nsets_frag, nmo_frag(2)
      integer frag
      logical movecs_read_header, movecs_read
      external  movecs_read_header, movecs_read
c
      call ga_sync()
      oprint = util_print('mo guess', print_default) 
     $     .and. (ga_nodeid().eq.0)
      if (oprint) then
         write(6,*)
         call util_print_centered(6,
     $        'Fragment Molecular Orbital Initial Guess', 22, .true.)
         write(6,*)
         call util_flush(6)
      endif
      key = ' '
      write(key,'(a,a)') module(1:inp_strlen(module)),':nfrag'
      if (.not. rtdb_get(rtdb, key, mt_int, 1, nfrag))
     $     call errquit('movecs_fragment: no fragment info?',0,
     &       RTDB_ERR)
      if (nfrag .gt. maxfrag) 
     $     call errquit('movecs_fragment: too many fragments', nfrag,
     &       UNKNOWN_ERR)
      write(key,'(a,a)') module(1:inp_strlen(module)),':fragments'
      if (.not. rtdb_cget(rtdb, key, nfrag, fragments))
     $     call errquit('movecs_fragment: can''t read fragments', nfrag,
     &       RTDB_ERR)
c
      call ga_inquire(g_vecs, ma_type, nbf, nmo)
      nvirt       = nmo - nclosed - nopen
      closed_off  = 1
      open_off    = nclosed + 1
      virt_off    = nclosed + nopen + 1
      bf_off      = 1
c
      call ga_zero(g_vecs)
c
      do frag = 1, nfrag
         call util_file_name_resolve(fragments(frag),.false.)
         if (.not. movecs_read_header(fragments(frag), 
     $        title_frag, basis_name_frag, scftype_frag, nbf_frag, 
     $        nsets_frag, nmo_frag,2)) call errquit
     $        ('movecs_fragment: failed reading frag header', frag,
     &       INPUT_ERR)
         if (.not. ga_create(MT_DBL, nbf_frag, nmo_frag(1), 
     $        ' frag mos',  32, 32, g_frag)) 
     $        call errquit('movecs_fragment: GA for frag MOs', nmo_frag,
     &       GA_ERR)
         if (.not. ma_push_get(mt_dbl, nbf_frag, 
     $        ' fragment eva', l_eval, k_eval)) call errquit
     $        ('movecs fragment: insufficient memory?', nbf_frag,
     &       MA_ERR)
         if (.not. ma_push_get(mt_dbl, nbf_frag, 
     $        ' fragment eva', l_occ, k_occ)) call errquit
     $        ('movecs fragment: insufficient memory?', nbf_frag,
     &       MA_ERR)
c     
         if (.not. movecs_read(fragments(frag), iset, dbl_mb(k_occ), 
     $        dbl_mb(k_eval), g_frag)) call errquit
     $        ('movecs fragment: failed read fragment MOs',0,
     &       INPUT_ERR)
c
**         call ga_print(g_frag)
c
         nclosed_frag = 0
         nopen_frag   = 0
         nvirt_frag   = 0
         do i = 0, nmo_frag(1)-1
            if (dbl_mb(k_occ+i).eq.2.0d0) then
               nclosed_frag = nclosed_frag + 1
            else if (dbl_mb(k_occ+i).ne.0.0d0) then
               nopen_frag = nopen_frag + 1
            else
               nvirt_frag = nvirt_frag + 1
            endif
         enddo
         if (oprint) then
            write(6,3) title_frag(1:inp_strlen(title_frag)),
     $           basis_name_frag(1:inp_strlen(basis_name_frag)),
     $           scftype_frag, nbf_frag, nsets_frag, nmo_frag(1),
     $           nclosed_frag, nopen_frag, nvirt_frag
 3          format(
     $           ' title    ', a/
     $           ' basis    ', a/
     $           ' scftype  ', a/
     $           ' nbf      ', i6/
     $           ' nsets    ', i6/
     $           ' nmo      ', i6/
     $           ' nclosed  ', i6/
     $           ' nopen    ', i6/
     $           ' nvirtual ', i6/)
            call util_flush(6)
         endif
c
         if (bf_off+nbf_frag-1 .gt. nbf) call errquit
     $        ('movecs_fragment: no. basis function mismatch', nbf,
     &       INPUT_ERR)
         ioff = 1
         if (nclosed_frag .gt. 0) then
            if (closed_off+nclosed_frag-1 .gt. nclosed) call errquit
     $           ('movecs_fragment: closed shell mismatch', nclosed,
     &       INPUT_ERR)
            call ga_copy_patch('n',
     $           g_frag, 1, nbf_frag, ioff, ioff+nclosed_frag-1,
     $           g_vecs, bf_off, bf_off+nbf_frag-1,
     $                   closed_off,closed_off+nclosed_frag-1)
            call dcopy(nclosed_frag,dbl_mb(k_eval+ioff-1),1,
     $           evals(closed_off), 1)
            closed_off = closed_off + nclosed_frag
            ioff = ioff + nclosed_frag
         endif
         if (nopen_frag .gt. 0) then
            if (open_off+nopen_frag-1 .gt. nclosed+nopen) call errquit
     $           ('movecs_fragment: open shell mismatch', nopen,
     &       INPUT_ERR)
            call ga_copy_patch('n',
     $           g_frag, 1, nbf_frag, ioff, ioff+nopen_frag-1,
     $           g_vecs, bf_off, bf_off+nbf_frag-1,
     $                   open_off,open_off+nopen_frag-1)
            call dcopy(nopen_frag,dbl_mb(k_eval+ioff-1),1,
     $           evals(open_off), 1)
            open_off = open_off + nopen_frag
            ioff = ioff + nopen_frag
         endif
c
         if (nvirt_frag .gt. 0) then
c            if (virt_off+nvirt_frag-1 .gt. nmo) call errquit
c     $           ('movecs_fragment: virt shell mismatch', nvirt)
            if (virt_off+nvirt_frag-1 .gt. nmo) then
               excess = virt_off+nvirt_frag-1 - nmo
            if (excess.LT.0) call errquit
     $         ('movecs_fragment: virt shell mismatch',excess,
     &       INPUT_ERR)
             if(oprint) then
               write(6,*) '**************WARNING*****************'
               write(6,*) ' movecs_fragment: virt shell mismatch,'
               write(6,*) ' probably due to linear dependence.'
               write(6,*) ' virtual orbitals excluded: ', excess
               write(6,*) '**************************************'
             endif
            else 
               excess=0
            endif
            call ga_copy_patch('n',
     $           g_frag, 1, nbf_frag, ioff, ioff+nvirt_frag-1-excess,
     $           g_vecs, bf_off, bf_off+nbf_frag-1,
     $                   virt_off,virt_off+nvirt_frag-1-excess)
            call dcopy(nvirt_frag-excess,dbl_mb(k_eval+ioff-1),1,
     $           evals(virt_off), 1)
            virt_off = virt_off + nvirt_frag - excess
            ioff = ioff + nvirt_frag
         endif
c
         bf_off = bf_off + nbf_frag
c
**         call ga_print(g_vecs)
c
         if (.not. ma_pop_stack(l_occ)) 
     $        call errquit('movecs_fragment: stack is bad',0, MA_ERR)
         if (.not. ma_pop_stack(l_eval)) 
     $        call errquit('movecs_fragment: stack is bad2',0, MA_ERR)
         if (.not. ga_destroy(g_frag))
     $        call errquit('movecs_fragment: ga is bad?',0, GA_ERR)
c
      enddo
c
*      call output(evals,1,nmo,1,1,nmo,1,1)
c
      if (closed_off .ne. nclosed+1) call errquit
     $     ('movecs_fragment: bad # closed shells',  closed_off-1,
     &       INPUT_ERR)
      if (open_off .ne. nclosed+nopen+1) call errquit
     $     ('movecs_fragment: bad # open shells',  open_off-closed_off,
     &       INPUT_ERR)
c      if (virt_off .ne. nmo+1) call errquit
c     $     ('movecs_fragment: bad # virtuals', virt_off-open_off)
c
      call ga_sync()
c
      end

      SUBROUTINE ccsdtq_lambda2_6_4_1(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdtq_lambda2_6_4_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h6 p1 )_vt + = 1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h6 h8 p1 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h6b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h8b
      INTEGER p7b_1
      INTEGER h8b_1
      INTEGER h6b_2
      INTEGER h8b_2
      INTEGER p1b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h6b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+h6b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_6_4_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO h8b = 1,noab
      IF (int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+h8b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p7b,h8b,p7b_1,h8b_1)
      CALL TCE_RESTRICTED_4(h6b,h8b,p1b,p7b,h6b_2,h8b_2,p1b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+h8b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_6_4_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_6_4_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (p7b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h8b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_6_4_1',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_6_4_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_6_4_1',5,MA_ERR)
      IF ((h8b .lt. h6b) .and. (p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((h8b .lt. h6b) .and. (p1b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF ((h6b .le. h8b) .and. (p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,1,2,3,-1.0d0)
      END IF
      IF ((h6b .le. h8b) .and. (p1b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_6_4_1',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_6_4_
     &1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_6_4_
     &1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_6_4_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h6b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h6b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_6_4_1',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_6_4_
     &1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine tce_sort_0(unsorted,sorted,factor)
c
c $Id: tce_sort0.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
      double precision sorted
      double precision unsorted
      double precision factor
      sorted = unsorted * factor
      return
      end

      SUBROUTINE mbpt3_t2_sd(d_e20,d_f1,d_i0,d_t12,d_t21,d_t22,d_t31,d_t
     &32,d_v2,k_e20_offset,k_f1_offset,k_i0_offset,k_t12_offset,k_t21_of
     &fset,k_t22_offset,k_t31_offset,k_t32_offset,k_v2_offset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_t3f + = 1 * P( 4 ) * t3 ( p1 h9 )_t3 * f ( p2 h10 )_f
C     i0 ( p1 p2 h9 h10 )_t3f + = 1 * P( 2 ) * Sum ( h3 ) * t3 ( p1 p2 h3 h9 )_t3 * f ( h3 h10 )_f
C     i0 ( p1 p2 h9 h10 )_t3f + = 1 * P( 2 ) * Sum ( p3 ) * t3 ( p1 p3 h9 h10 )_t3 * f ( p2 p3 )_f
C     i0 ( p1 p2 h9 h10 )_vt2 + = -1 * P( 2 ) * Sum ( h3 ) * t2 ( p1 h3 )_t2 * v ( h3 p2 h9 h10 )_v
C     i0 ( p1 p2 h9 h10 )_vt2 + = -1 * P( 2 ) * Sum ( p3 ) * t2 ( p3 h9 )_t2 * v ( p1 p2 h10 p3 )_v
C     i0 ( p1 p2 h9 h10 )_vt2 + = 1/2 * Sum ( h3 h4 ) * t2 ( p1 p2 h3 h4 )_t2 * v ( h3 h4 h9 h10 )_v
C     i0 ( p1 p2 h9 h10 )_vt2 + = 1 * P( 4 ) * Sum ( h4 p3 ) * t2 ( p1 p3 h4 h9 )_t2 * v ( h4 p2 h10 p3 )_v
C     i0 ( p1 p2 h9 h10 )_vt2 + = 1/2 * Sum ( p3 p4 ) * t2 ( p3 p4 h9 h10 )_t2 * v ( p1 p2 p3 p4 )_v
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = 1/4 * t1 ( p1 p2 h9 h10 )_t1 * i1 ( )_vt1
C         i1 ( )_vt1 + = 1 * Sum ( h5 h6 p3 p4 ) * t1 ( p3 p4 h5 h6 )_t1 * v ( h5 h6 p3 p4 )_v
C         i1 ( )_e2 + = -4 * e2 ( )_e2
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = -1/2 * P( 2 ) * Sum ( p3 ) * t1 ( p1 p3 h9 h10 )_t1 * i1 ( p2 p3 )_vt1
C         i1 ( p1 p3 )_vt1 + = 1 * Sum ( h5 h6 p4 ) * t1 ( p1 p4 h5 h6 )_t1 * v ( h5 h6 p3 p4 )_v
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = 1/4 * Sum ( h3 h4 ) * t1 ( p1 p2 h3 h4 )_t1 * i1 ( h3 h4 h9 h10 )_vt1
C         i1 ( h3 h4 h9 h10 )_vt1 + = 1 * Sum ( p5 p6 ) * t1 ( p5 p6 h9 h10 )_t1 * v ( h3 h4 p5 p6 )_v
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = 1/2 * P( 2 ) * Sum ( h3 ) * t1 ( p1 p2 h3 h9 )_t1 * i1 ( h3 h10 )_vt1
C         i1 ( h3 h9 )_vt1 + = -1 * Sum ( h6 p4 p5 ) * t1 ( p4 p5 h6 h9 )_t1 * v ( h3 h6 p4 p5 )_v
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = -1/2 * P( 4 ) * Sum ( h4 p3 ) * t1 ( p1 p3 h4 h9 )_t1 * i1 ( h4 p2 h10 p3 )_vt1
C         i1 ( h4 p1 h9 p3 )_vt1 + = -1 * Sum ( h6 p5 ) * t1 ( p1 p5 h6 h9 )_t1 * v ( h4 h6 p3 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t31
      INTEGER k_t31_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER d_t32
      INTEGER k_t32_offset
      INTEGER d_t21
      INTEGER k_t21_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_t22
      INTEGER k_t22_offset
      INTEGER d_t12
      INTEGER k_t12_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_e20
      INTEGER k_e20_offset
      CHARACTER*255 filename
      CALL mbpt3_t2_sd_1(d_t31,k_t31_offset,d_f1,k_f1_offset,d_i0,k_i0_o
     &ffset)
      CALL mbpt3_t2_sd_2(d_t32,k_t32_offset,d_f1,k_f1_offset,d_i0,k_i0_o
     &ffset)
      CALL mbpt3_t2_sd_3(d_t32,k_t32_offset,d_f1,k_f1_offset,d_i0,k_i0_o
     &ffset)
      CALL mbpt3_t2_sd_4(d_t21,k_t21_offset,d_v2,k_v2_offset,d_i0,k_i0_o
     &ffset)
      CALL mbpt3_t2_sd_5(d_t21,k_t21_offset,d_v2,k_v2_offset,d_i0,k_i0_o
     &ffset)
      CALL mbpt3_t2_sd_6(d_t22,k_t22_offset,d_v2,k_v2_offset,d_i0,k_i0_o
     &ffset)
      CALL mbpt3_t2_sd_7(d_t22,k_t22_offset,d_v2,k_v2_offset,d_i0,k_i0_o
     &ffset)
      CALL mbpt3_t2_sd_8(d_t22,k_t22_offset,d_v2,k_v2_offset,d_i0,k_i0_o
     &ffset)
      CALL OFFSET_mbpt3_t2_sd_9_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('mbpt3_t2_sd_9_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL mbpt3_t2_sd_9_1(d_t12,k_t12_offset,d_v2,k_v2_offset,d_i1,k_i1
     &_offset)
      CALL mbpt3_t2_sd_9_2(d_e20,k_e20_offset,d_i1,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL mbpt3_t2_sd_9(d_t12,k_t12_offset,d_i1,k_i1_offset,d_i0,k_i0_o
     &ffset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('mbpt3_t2_sd',-1,
     &MA_ERR)
      CALL OFFSET_mbpt3_t2_sd_10_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('mbpt3_t2_sd_10_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL mbpt3_t2_sd_10_1(d_t12,k_t12_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL mbpt3_t2_sd_10(d_t12,k_t12_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('mbpt3_t2_sd',-1,
     &MA_ERR)
      CALL OFFSET_mbpt3_t2_sd_11_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('mbpt3_t2_sd_11_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL mbpt3_t2_sd_11_1(d_t12,k_t12_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL mbpt3_t2_sd_11(d_t12,k_t12_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('mbpt3_t2_sd',-1,
     &MA_ERR)
      CALL OFFSET_mbpt3_t2_sd_12_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('mbpt3_t2_sd_12_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL mbpt3_t2_sd_12_1(d_t12,k_t12_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL mbpt3_t2_sd_12(d_t12,k_t12_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('mbpt3_t2_sd',-1,
     &MA_ERR)
      CALL OFFSET_mbpt3_t2_sd_13_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('mbpt3_t2_sd_13_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL mbpt3_t2_sd_13_1(d_t12,k_t12_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL mbpt3_t2_sd_13(d_t12,k_t12_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('mbpt3_t2_sd',-1,
     &MA_ERR)
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_t3f + = 1 * P( 4 ) * t3 ( p1 h9 )_t3 * f ( p2 h10 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b_1
      INTEGER h9b_1
      INTEGER p2b_2
      INTEGER h10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_t3,irrep_f)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h9b-1)) .eq. irrep_t3) T
     &HEN
      CALL TCE_RESTRICTED_2(p1b,h9b,p1b_1,h9b_1)
      CALL TCE_RESTRICTED_2(p2b,h10b,p2b_2,h10b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h9b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h10b_
     &2 - 1 + (noab+nvab) * (p2b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h10b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_1',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_1',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_1',9,MA_ERR)
      IF ((p1b .le. p2b) .and. (h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,2,3,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p1b .le. p2b) .and. (h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,2,1,3,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b) .and. (h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b) .and. (h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),2,4,1,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_1',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_1',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_t3f + = 1 * P( 2 ) * Sum ( h3 ) * t3 ( p1 p2 h3 h9 )_t3 * f ( h3 h10 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h9b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER h10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h9b = 1,noab
      DO h10b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_t3,irrep_f)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_t3) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h9b,h3b,p1b_1,p2b_1,h9b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,h10b,h3b_2,h10b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_2',2,MA_ERR)
      IF ((h3b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h9b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((h9b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h3b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h10b_
     &2 - 1 + (noab+nvab) * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h10b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_2',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_2',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_2',9,MA_ERR)
      IF ((h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,1,2,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_2',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_2',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_t3f + = 1 * P( 2 ) * Sum ( p3 ) * t3 ( p1 p3 h9 h10 )_t3 * f ( p2 p3 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_t3,irrep_f)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t3) THEN
      CALL TCE_RESTRICTED_4(p1b,p3b,h9b,h10b,p1b_1,p3b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_2(p2b,p3b,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+h9b-1) * int_mb
     &(k_range+h10b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_3',2,MA_ERR)
      IF ((p3b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,-1.0d0)
      END IF
      IF ((p1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_3',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_3',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_3',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_3',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,1,3,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),1,4,3,2,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_3',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_3',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt2 + = -1 * P( 2 ) * Sum ( h3 ) * t2 ( p1 h3 )_t2 * v ( h3 p2 h9 h10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p1b_1
      INTEGER h3b_1
      INTEGER p2b_2
      INTEGER h3b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t2)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h3b-1)) .eq. irrep_t2) T
     &HEN
      CALL TCE_RESTRICTED_2(p1b,h3b,p1b_1,h3b_1)
      CALL TCE_RESTRICTED_4(p2b,h3b,h9b,h10b,p2b_2,h3b_2,h9b_2,h10b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h9b-1) * int_mb
     &(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_4',5,MA_ERR)
      IF ((h3b .le. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h10b_
     &2 - 1 + (noab+nvab) * (h9b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noa
     &b+nvab) * (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_4',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_4',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_4',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_4',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_4',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_4',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt2 + = -1 * P( 2 ) * Sum ( p3 ) * t2 ( p3 h9 )_t2 * v ( p1 p2 h10 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p3b_1
      INTEGER h9b_1
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER h10b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h9b = 1,noab
      DO h10b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t2)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h9b-1)) .eq. irrep_t2) T
     &HEN
      CALL TCE_RESTRICTED_2(p3b,h9b,p3b_1,h9b_1)
      CALL TCE_RESTRICTED_4(p1b,p2b,h10b,p3b,p1b_2,p2b_2,h10b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_5',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h9b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_5',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_5',5,MA_ERR)
      IF ((h10b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (h10b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noa
     &b+nvab) * (p1b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_5',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_5',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_5',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_5',9,MA_ERR)
      IF ((h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h9b-1
     &),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h9b-1
     &),3,2,1,4,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_5',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_5',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_6(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt2 + = 1/2 * Sum ( h3 h4 ) * t2 ( p1 p2 h3 h4 )_t2 * v ( h3 h4 h9 h10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t2)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h3b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_t2) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h3b,h4b,p1b_1,p2b_1,h3b_1,h4b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,h9b,h10b,h3b_2,h4b_2,h9b_2,h10b_2)
      dim_common = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h9b-1) * int_mb(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_6',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_6',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_6',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h10b_
     &2 - 1 + (noab+nvab) * (h9b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noa
     &b+nvab) * (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_6',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h3b .eq. h4b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_6',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_6',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_6',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_6',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_6',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_7(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt2 + = 1 * P( 4 ) * Sum ( h4 p3 ) * t2 ( p1 p3 h4 h9 )_t2 * v ( h4 p2 h10 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER h9b_1
      INTEGER h4b_1
      INTEGER p2b_2
      INTEGER h4b_2
      INTEGER h10b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t2)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_7',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_t2) THEN
      CALL TCE_RESTRICTED_4(p1b,p3b,h9b,h4b,p1b_1,p3b_1,h9b_1,h4b_1)
      CALL TCE_RESTRICTED_4(p2b,h4b,h10b,p3b,p2b_2,h4b_2,h10b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_7',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_7',2,MA_ERR)
      IF ((p3b .lt. p1b) .and. (h4b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h9b-1)
     &,4,2,3,1,-1.0d0)
      END IF
      IF ((p3b .lt. p1b) .and. (h9b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h9b-1),int_mb(k_range+h4b-1)
     &,3,2,4,1,1.0d0)
      END IF
      IF ((p1b .le. p3b) .and. (h4b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h9b-1)
     &,4,1,3,2,1.0d0)
      END IF
      IF ((p1b .le. p3b) .and. (h9b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h4b-1)
     &,3,1,4,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_7',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_7',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_7',5,MA_ERR)
      IF ((h4b .le. p2b) .and. (h10b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (h10b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noa
     &b+nvab) * (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_7',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_7',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_7',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_7',9,MA_ERR)
      IF ((p1b .le. p2b) .and. (h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,2,3,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p1b .le. p2b) .and. (h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,2,1,3,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b) .and. (h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b) .and. (h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),2,4,1,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_7',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_7',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_8(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt2 + = 1/2 * Sum ( p3 p4 ) * t2 ( p3 p4 h9 h10 )_t2 * v ( p1 p2 p3 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t2)) 
     &THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_8',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t2) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h9b,h10b,p3b_1,p4b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_4(p1b,p2b,p3b,p4b,p1b_2,p2b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1)
      dima_sort = int_mb(k_range+h9b-1) * int_mb(k_range+h10b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_8',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_8',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_8',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_8',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_8',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noab
     &+nvab) * (p1b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_8',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_8',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_8',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_8',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h10b-1),int_mb(k_range+h9b-1
     &),2,1,4,3,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_8',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_8',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_9(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = 1/4 * t1 ( p1 p2 h9 h10 )_t1 * i1 ( )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,ieor(irrep_
     &t1,irrep_t1))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_9',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h9b,h10b,p1b_1,p2b_1,h9b_1,h10b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+h9b-1) * int_mb(k_range+h10b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_9',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_9',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_9',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_9',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_9',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_b),dbl_mb(k_b_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_9',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_9',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_9',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_9',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_9',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_9',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_9_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( )_vt1 + = 1 * Sum ( h5 h6 p3 p4 ) * t1 ( p3 p4 h5 h6 )_t1 * v ( h5 h6 p3 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      IF (next.eq.count) THEN
      IF (0 .eq. ieor(irrep_v,irrep_t1)) THEN
      dimc = 1
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_9_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h5b,h6b,p3b_1,p4b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,p4b,h5b_2,h6b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+h5b-1) * int_mb(k_range+h6b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_9_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_9_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_9_1',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_9_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_9_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_9_1',6,MA_ER
     &R)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_9_1',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_9_1',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_9_1',9,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_c_sort),dbl_mb(k_c),1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_9_1',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_9_1',11
     &,MA_ERR)
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_mbpt3_t2_sd_9_1(l_a_offset,k_a_offset,size)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      length = 0
      IF (0 .eq. ieor(irrep_v,irrep_t1)) THEN
      length = length + 1
      END IF
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('mbpt3_t2_sd_9_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      IF (0 .eq. ieor(irrep_v,irrep_t1)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = 0
      int_mb(k_a_offset+length+addr) = size
      size = 1
      END IF
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_9_2(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( )_e2 + = -4 * e2 ( )_e2
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      IF (next.eq.count) THEN
      IF (0 .eq. irrep_e2) THEN
      dimc = 1
      dim_common = 1
      dima_sort = 1
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_9_2',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_9_2',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_a),dbl_mb(k_a_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_9_2',2,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_9_2',3,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_a_sort),dbl_mb(k_c),-4.0d0/1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_9_2',4,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_9_2',5,
     &MA_ERR)
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_10(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = -1/2 * P( 2 ) * Sum ( p3 ) * t1 ( p1 p3 h9 h10 )_t1 * i1 ( p2 p3 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,ieor(irrep_
     &t1,irrep_t1))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_10',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p1b,p3b,h9b,h10b,p1b_1,p3b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_2(p2b,p3b,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+h9b-1) * int_mb
     &(k_range+h10b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_10',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_10',2,MA_ERR)
      IF ((p3b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,-1.0d0)
      END IF
      IF ((p1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_10',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_10',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_10',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_10',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_10',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_10',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_10',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,1,3,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),1,4,3,2,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_10',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_10',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_10_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p1 p3 )_vt1 + = 1 * Sum ( h5 h6 p4 ) * t1 ( p1 p4 h5 h6 )_t1 * v ( h5 h6 p3 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b_1
      INTEGER p4b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p3b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p3b-1)) .eq. ieor(irrep_
     &v,irrep_t1)) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_10_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p1b,p4b,h5b,h6b,p1b_1,p4b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,p4b,h5b_2,h6b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+h5b-1) * int_m
     &b(k_range+h6b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_10_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_10_1',2,MA_ERR)
      IF ((p4b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_10_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_10_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_10_1',5,MA_ERR)
      IF ((p4b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p4b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p3b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_10_1',6,MA_E
     &RR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_10_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_10_1',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_10_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (p1b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_10_1',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_10_1',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_mbpt3_t2_sd_10_1(l_a_offset,k_a_offset,size)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p1 p3 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p1b
      INTEGER p3b
      length = 0
      DO p1b = noab+1,noab+nvab
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p3b-1)) .eq. ieor(irrep_
     &v,irrep_t1)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('mbpt3_t2_sd_10_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p1b = noab+1,noab+nvab
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p3b-1)) .eq. ieor(irrep_
     &v,irrep_t1)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p3b - noab - 1 + nvab * (p1b - noab - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p1b-1) * int_mb(k_range+p3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_11(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = 1/4 * Sum ( h3 h4 ) * t1 ( p1 p2 h3 h4 )_t1 * i1 ( h3 h4 h9 h10 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,ieor(irrep_
     &t1,irrep_t1))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_11',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h3b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h3b,h4b,p1b_1,p2b_1,h3b_1,h4b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,h9b,h10b,h3b_2,h4b_2,h9b_2,h10b_2)
      dim_common = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h9b-1) * int_mb(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_11',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_11',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_11',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_11',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_11',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h10b_
     &2 - 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)
     &))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_11',6,MA_ERR
     &)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h3b .eq. h4b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_11',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_11',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_11',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_11',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_11',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_11_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h4 h9 h10 )_vt1 + = 1 * Sum ( p5 p6 ) * t1 ( p5 p6 h9 h10 )_t1 * v ( h3 h4 p5 p6 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t1)) 
     &THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_11_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h9b,h10b,p5b_1,p6b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,p5b,p6b,h3b_2,h4b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h9b-1) * int_mb(k_range+h10b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_11_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_11_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_11_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_11_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_11_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_11_1',6,MA_E
     &RR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_11_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_11_1',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_11_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h10b-1),int_mb(k_range+h9b-1
     &),2,1,4,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (h4b - 1 + noab * (h3b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_11_1',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_11_1',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_mbpt3_t2_sd_11_1(l_a_offset,k_a_offset,size)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h4 h9 h10 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER h4b
      INTEGER h9b
      INTEGER h10b
      length = 0
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t1)) 
     &THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('mbpt3_t2_sd_11_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,irrep_t1)) 
     &THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h10b - 1 + noab * (h9b - 1 + noab * (h4b
     & - 1 + noab * (h3b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_
     &mb(k_range+h9b-1) * int_mb(k_range+h10b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_12(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = 1/2 * P( 2 ) * Sum ( h3 ) * t1 ( p1 p2 h3 h9 )_t1 * i1 ( h3 h10 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h9b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER h10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h9b = 1,noab
      DO h10b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,ieor(irrep_
     &t1,irrep_t1))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_12',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h9b,h3b,p1b_1,p2b_1,h9b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,h10b,h3b_2,h10b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_12',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_12',2,MA_ERR)
      IF ((h3b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h9b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((h9b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h3b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_12',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_12',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_12',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h10b_
     &2 - 1 + noab * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h10b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_12',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_12',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_12',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_12',9,MA_ERR)
      IF ((h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1
     &),4,3,1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_12',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_12',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_12_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h9 )_vt1 + = -1 * Sum ( h6 p4 p5 ) * t1 ( p4 p5 h6 h9 )_t1 * v ( h3 h6 p4 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p5b
      INTEGER h6b
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER h9b_1
      INTEGER h6b_1
      INTEGER h3b_2
      INTEGER h6b_2
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h3b = 1,noab
      DO h9b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h9b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h9b-1)) .eq. ieor(irrep_
     &v,irrep_t1)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_12_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO p5b = p4b,noab+nvab
      DO h6b = 1,noab
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p4b,p5b,h9b,h6b,p4b_1,p5b_1,h9b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h3b,h6b,p4b,p5b,h3b_2,h6b_2,p4b_2,p5b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_m
     &b(k_range+h6b-1)
      dima_sort = int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_12_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_12_1',2,MA_ERR)
      IF ((h6b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h9b-1)
     &,4,3,2,1,1.0d0)
      END IF
      IF ((h9b .lt. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h9b-1),int_mb(k_range+h6b-1)
     &,3,4,2,1,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_12_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_12_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_12_1',5,MA_ERR)
      IF ((h6b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p4b_2 - 1 + (noab+nvab) * (h3b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,2,1,4,3,-1.0d0)
      END IF
      IF ((h3b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p4b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,1,2,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_12_1',6,MA_E
     &RR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p4b .eq. p5b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_12_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_12_1',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_12_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h9b-1),1,2,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_12_1',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_12_1',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_mbpt3_t2_sd_12_1(l_a_offset,k_a_offset,size)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h9 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER h9b
      length = 0
      DO h3b = 1,noab
      DO h9b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h9b-1)) .eq. ieor(irrep_
     &v,irrep_t1)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h9b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('mbpt3_t2_sd_12_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO h9b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h9b-1)) .eq. ieor(irrep_
     &v,irrep_t1)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h9b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h9b - 1 + noab * (h3b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+h9b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_13(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 h9 h10 )_vt1t1 + = -1/2 * P( 4 ) * Sum ( h4 p3 ) * t1 ( p1 p3 h4 h9 )_t1 * i1 ( h4 p2 h10 p3 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER h9b
      INTEGER h10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER h9b_1
      INTEGER h4b_1
      INTEGER p2b_2
      INTEGER h4b_2
      INTEGER h10b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. ieor(irrep_v,ieor(irrep_
     &t1,irrep_t1))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_13',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p1b,p3b,h9b,h4b,p1b_1,p3b_1,h9b_1,h4b_1)
      CALL TCE_RESTRICTED_4(p2b,h4b,h10b,p3b,p2b_2,h4b_2,h10b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_13',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_13',2,MA_ERR)
      IF ((p3b .lt. p1b) .and. (h4b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h9b-1)
     &,4,2,3,1,-1.0d0)
      END IF
      IF ((p3b .lt. p1b) .and. (h9b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h9b-1),int_mb(k_range+h4b-1)
     &,3,2,4,1,1.0d0)
      END IF
      IF ((p1b .le. p3b) .and. (h4b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h9b-1)
     &,4,1,3,2,1.0d0)
      END IF
      IF ((p1b .le. p3b) .and. (h9b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h4b-1)
     &,3,1,4,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_13',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_13',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_13',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (h10b_2 - 1 + noab * (h4b_2 - 1 + noab * (p2b
     &_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),3,1,2,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_13',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_13',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_13',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_13',9,MA_ERR)
      IF ((p1b .le. p2b) .and. (h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,2,3,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p1b .le. p2b) .and. (h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),4,2,1,3,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p2b - noab - 1 + nvab * (p1b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b) .and. (h9b .le. h10b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),2,4,3,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h10b 
     &- 1 + noab * (h9b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF ((p2b .le. p1b) .and. (h10b .le. h9b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1
     &),2,4,1,3,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h10b - 1 + noab * (p1b - noab - 1 + nvab * (p2b - noa
     &b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_13',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_13',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mbpt3_t2_sd_13_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 p1 h9 p3 )_vt1 + = -1 * Sum ( h6 p5 ) * t1 ( p1 p5 h6 h9 )_t1 * v ( h4 h6 p3 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER h4b
      INTEGER h9b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h6b
      INTEGER p1b_1
      INTEGER p5b_1
      INTEGER h9b_1
      INTEGER h6b_1
      INTEGER h4b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p1b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h9b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_v,irrep_t1)) T
     &HEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_13_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h6b = 1,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_t1) THEN
      CALL TCE_RESTRICTED_4(p1b,p5b,h9b,h6b,p1b_1,p5b_1,h9b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h4b,h6b,p3b,p5b,h4b_2,h6b_2,p3b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_13_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mbpt3_t2_sd_13_1',2,MA_ERR)
      IF ((p5b .lt. p1b) .and. (h6b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h6b-1),int_mb(k_range+h9b-1)
     &,4,2,3,1,-1.0d0)
      END IF
      IF ((p5b .lt. p1b) .and. (h9b .lt. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h9b-1),int_mb(k_range+h6b-1)
     &,3,2,4,1,1.0d0)
      END IF
      IF ((p1b .le. p5b) .and. (h6b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h9b-1)
     &,4,1,3,2,1.0d0)
      END IF
      IF ((p1b .le. p5b) .and. (h9b .lt. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h9b-1),int_mb(k_range+h6b-1)
     &,3,1,4,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mbpt3_t2_sd_13_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mbpt3_t2_sd_13_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mbpt3_t2_sd_13_1',5,MA_ERR)
      IF ((h6b .lt. h4b) .and. (p5b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p3b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((h6b .lt. h4b) .and. (p3b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p3b-1),int_mb(k_range+p5b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF ((h4b .le. h6b) .and. (p5b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p5b-1),int_mb(k_range+p3b-1)
     &,4,1,2,3,-1.0d0)
      END IF
      IF ((h4b .le. h6b) .and. (p3b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p5b-1)
     &,3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mbpt3_t2_sd_13_1',6,MA_E
     &RR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mbpt3_t2_sd_13_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mbpt3_t2_sd_13_1',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mbpt3_t2_sd_13_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1)
     &,4,2,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (h9b - 1 + noab * (h4b - 1 + noab * (p1b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mbpt3_t2_sd_13_1',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mbpt3_t2_sd_13_1',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_mbpt3_t2_sd_13_1(l_a_offset,k_a_offset,size)
C     $Id: mbpt3_t2_sd.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 p1 h9 p3 )_vt1
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p1b
      INTEGER h4b
      INTEGER h9b
      INTEGER p3b
      length = 0
      DO p1b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h9b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_v,irrep_t1)) T
     &HEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('mbpt3_t2_sd_13_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p1b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h9b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_v,irrep_t1)) T
     &HEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p3b - noab - 1 + nvab * (h9b - 1 + noab 
     &* (h4b - 1 + noab * (p1b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p1b-1) * int_mb(k_range+h4b-1) * int_
     &mb(k_range+h9b-1) * int_mb(k_range+p3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine ifill(n,val,a,ia)
C$Id: ifill.f 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
      integer n, val, a(*), ia, i
c
c     initialise integer precision array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

*
* $Id: fci_onelcc.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_onelcc(iocc,idet,idim,isym,
     $     ionel,nonel,nonemx)
      implicit none
#include "fciinfo.fh"
c     
c     compute all non-zero one-electron coupling coefficents
c     g(i,j;I,J) = <I|Eij|J> for all orbitals ij and for all
c     determinants generated from orbital configuration iwalk
c     
c     ionel(1,*) = i
c     ionel(2,*) = j
c     ionel(3,*) = ideterminant
c     ionel(4,*) = jdeterminant
c     ionel(5,*) = value (only -1,+1,2 are valid)
c     
c     <Iv|Eij|Jw> = <Iv|Eia|Ku><Ku|Eaj|Jw>
c     .           = <Ku|Eai|Iv><Ku|Eaj|Jw>
c
c     Orbital configuration I may be of any symmetry (specified 
c     only by its occupation etc.) but J is constrained to be
c     of the same symmetry as the CI state.
c     
      integer iocc(nactiv),idet,idim,isym ! [input] Info about I
      integer nonemx            ! [input] last dimension of ionel
      integer ionel(5,nonemx)   ! [output] returns coupling coeff info
      integer nonel             ! [output] no. of coeff returned
c     
      integer indbar(nactmx)
      integer jperm(ndetmx), iperm(ndetmx)
      double precision jval(ndetmx), ival(ndetmx)
c     
      integer nsi, nsj, nsk, jdet, jwalk, ni, nj,
     $     jdim, kdim, i, j, u, v, ibar, jbar, deltai, value,
     $     idummy, ii, jsym
      logical oprint
#include "bitops.fh"
c     
      oprint = .false.
      nonel = 0
c     
c     Form I indbar vector
c     
      if (oprint) then
         write(6,*) ' iocc ', (iocc(i),i=1,nactiv)
         write(6,*) ' isym ', isym, statesym
      endif
c
      nsi = 0
      do i = 1,nactiv
         if (iocc(i).eq.2) nsi = nsi + 1
         indbar(i) = nsi
      enddo
      if (idim .ne. mnsdet(nsi)) call fci_err('fci_onelcc: nsi?',nsi)
c     
c     Loop thru i
c     
      do i = 1, nactiv
         ni = iocc(i)-1
         if (ni .gt. 0) then
            if (oprint) write(6,*) ' i = ', i, ' ni = ', ni
c     
c     Handle Eii special case for efficiency
c     
            if (isym .eq. statesym) then
               call fci_ofind_weight(jwalk,iocc) ! idet may not be absolute
               jdet = indexo(jwalk)
               do v = 1,idim
                  nonel = nonel + 1
                  ionel(1,nonel) = i
                  ionel(2,nonel) = i
                  ionel(3,nonel) = v + idet
                  ionel(4,nonel) = v + jdet
                  ionel(5,nonel) = ni
               enddo
            endif
c     
c     Form <Ku|Eai|Iv>
c     
            ibar = indbar(i)
            nsk  = nsi
            if (ni .eq. 2) then
               nsk = nsk + 2
               ibar = ibar + 1
            endif
            kdim = mnsdet(nsk)
            call fci_apply_eaj(ibar, ni, idim, kdim, 
     $           eajdata(eajptr(nsi)), eajphase(1,1,nsi), .true.,
     $           idummy, idummy, iperm, ival)
c
c
            if (oprint) write(6,17) i, (iperm(u),ival(u),u=1,kdim)
 17         format(i5,20(i3,f5.1,2x))
c     
c     Remove the electron in i from occupation vectors
c     
            if(oprint)write(6,88) ' I ', (iocc(u),indbar(u),u=1,nactiv)
 88         format(a,2x,20(i2,'(',i2,')',2x))
            iocc(i) = iocc(i) - 1
            deltai = -1
            if (ni .eq. 2) deltai = 1
            do ii = i,nactiv
               indbar(ii) = indbar(ii) + deltai
            enddo
            if(oprint)write(6,88) ' K ', (iocc(u),indbar(u),u=1,nactiv)
c
            jsym = ieor(ieor(isym,orbsym(i)),statesym) ! Sym. of orbital j
c     
c     indbar and iocc now refer to the occupation of K
c     
c     Now loop thru j!=i, and not doubly occupied in K, and form <Ku|Eaj|Jw>
c     
            do j = 1, nactiv
               nj = iocc(j)     ! Since iocc refers to K and we want J
               if ((nj .lt. 3) .and. (i .ne. j) .and. 
     $              (orbsym(j).eq.jsym)) then
                  if(oprint)write(6,*) ' j = ', j, ' nj = ', nj
c     
c     Determine index of J orbital occupation
c     
                  iocc(j) = iocc(j) + 1
                  if(oprint)write(6,11) i, j, (iocc(v),v=1,nactiv)
 11               format(2i5,5x,20i3)
                  call fci_ofind_weight(jwalk,iocc)
                  iocc(j) = iocc(j) - 1
c     
                  jbar = indbar(j)
                  if (nj .eq. 1) jbar = jbar + 1 ! Since indbar refers to K
                  nsj = nsk
                  if (nj .eq. 2) nsj = nsj - 2 
                  jdim = mnsdet(nsj)
                  if (oprint) write(6,*) 
     $                 ' jbar ', jbar, ' nsj ', nsj, ' nsk ', nsk
                  call fci_apply_eaj(jbar, nj, jdim, kdim, 
     $                 eajdata(eajptr(nsj)), eajphase(1,1,nsj), .true.,
     $                 idummy, idummy, jperm, jval)
                  if(oprint) write(6,17) j, (jperm(u),jval(u),u=1,kdim)
c     
c     Now use <Iv|Eij|Jw> = <Ku|Eai|Iv>*<Ku|Eaj|Jv>
c     
                  jdet = indexo(jwalk)
                  do u = 1, kdim
                     value = nint(ival(u)*jval(u))
                     if (value .ne. 0) then
                        nonel = nonel + 1
                        ionel(1,nonel) = i
                        ionel(2,nonel) = j
                        ionel(3,nonel) = iperm(u)+idet
                        ionel(4,nonel) = jperm(u)+jdet
                        ionel(5,nonel) = value
                     endif
                  enddo
               endif
            enddo
c     
c     Restore the electron in i to the occupation vectors
c     
            iocc(i) = iocc(i) + 1
            do ii = i,nactiv
               indbar(ii) = indbar(ii) - deltai
            enddo
c     
c     indbar and iocc now again refer to iocc
c     
         endif
      enddo
c
      if (oprint) call fci_prteop(ionel,nonel)
c
*      stop 1
c
      end

c     
c     All processes call this routine.  Only process 0 actually reads the 
c     input.  All other processes skip to the end of the routine
c     to wait in the broadcast of the return value.
c
c     Process 0 reads input until a task directive is encountered.
c     After this is read (by task_input) process 0 branches to the 
c     broadcast at the end and all processes return a value of TRUE.  
c     Otherwise FALSE is returned by all processes.
c
      logical function input_parse(rtdb)

C     $Id: input_parse.F 26003 2014-08-19 00:14:50Z edo $
c
      implicit none
c
#include "errquit.fh"
c
      integer rtdb              ! [input]
c
#include "inp.fh"
#include "global.fh"
#include "rtdb.fh"
#include "util.fh"
#include "stdio.fh"
c
      logical status
      integer found_task
      character*255 test
      integer nlines            ! No. of lines of input read in this call
c
      nlines = 0
      found_task = 0            ! 0=false, 1=true
c
      if (ga_nodeid() .eq. 0) then
c     
         if (util_print('banner',print_low)) then
           write(LuOut,*)
           write(LuOut,*)
           call util_print_centered(LuOut, 
     &          'NWChem Input Module',40,.true.)
           write(LuOut,*)
           write(LuOut,*)
         endif
c     
c     Do data base operations in sequential mode
c     
         status = rtdb_parallel(.false.)
c     
c     While (input is available)
c     
 10      if (inp_read()) then
            nlines = nlines + 1
            if (.not. inp_a(test))
     $           call errquit('input_parse: failed to read keyword', 0,
     &       INPUT_ERR)
            call inp_prev_field
c     
            if (inp_compare(.false.,test,'task')) then
               call task_input(rtdb)
               found_task = 1
               goto 9999
            else if (inp_compare(.false.,test,'geometry')) then
               call geom_input(rtdb)
            else if (inp_compare(.false.,test,'bsse')) then
               call bsse_input(rtdb)
            else if (inp_compare(.false.,test,'basis')) then
               call bas_input(rtdb)
            else if (inp_compare(.false.,test,'python')) then
               call python_input(rtdb)
            else if (inp_compare(.false.,test,'cosmo')) then
               call cosmo_input(rtdb)
            else if (inp_compare(.false.,test,'ecp')) then
               call bas_input(rtdb)
            else if (inp_compare(.false.,test,'so')) then
               call bas_input(rtdb)
            else if (inp_compare(.false.,test,'integral').or.
     &               inp_compare(.false.,test,'intgrl')) then
               call intgrl_input(rtdb)
            else if (inp_compare(.false.,test,'scf')) then
               call scf_input(rtdb)
            else if (inp_compare(.false.,test,'mp2')) then
               call mp2_input(rtdb)
            else if (inp_compare(.false.,test,'time')) then
               call input_time(rtdb)
            else if (inp_compare(.false.,test,'set')) then
               call input_set(rtdb)
            else if (inp_compare(.false.,test,'drdy').or.
     &               inp_compare(.false.,test,'dirdyvtst').or.
     &               inp_compare(.false.,test,'drdy_nwchem')) then
               call drdy_input(rtdb)
            else if (inp_compare(.false.,test,'stop')) then
               call errquit('input_parse: STOP', 0, INPUT_ERR)
            else if (inp_compare(.false.,test,'title')) then
               call input_title(rtdb)
            else if (inp_compare(.false.,test,'stepper')) then
               call stepper_input(rtdb)
            else if (inp_compare(.false.,test,'mepgs')) then
               call mepgs_input(rtdb)
            else if (inp_compare(.false.,test,'tropt')) then
               call tropt_input(rtdb)
            else if (inp_compare(.false.,test,'driver')) then
               call driver_input(rtdb)
            else if (inp_compare(.false.,test,'string')) then
               call string_input(rtdb)
            else if (inp_compare(.false.,test,'zts')) then
               call string_input(rtdb)
            else if (inp_compare(.false.,test,'qcharge')) then
               call input_qcharge(rtdb)
            else if (inp_compare(.false.,test,'charge')) then
               call input_charge(rtdb)
            else if (inp_compare(.false.,test,'dft')) then
               call dft_input(rtdb)
            else if (inp_compare(.false.,test,'qmd')) then
               call qmd_input(rtdb)
            else if (inp_compare(.false.,test,'occup')) then
               call occup_input(rtdb)
            else if (inp_compare(.false.,test,'prepare')) then
               call pre_input(rtdb)
            else if (inp_compare(.false.,test,'md')) then
               call md_input(rtdb)
            else if (inp_compare(.false.,test,'argos')) then
               call argos_input(rtdb)
            else if (inp_compare(.false.,test,'esp')) then
               call esp_input(rtdb)
            else if (inp_compare(.false.,test,'et')) then
               call et_input(rtdb)
            else if (inp_compare(.false.,test,'analysis')) then
               call ana_input(rtdb)
            else if (inp_compare(.false.,test,'analyze')) then
               call ana_input(rtdb)
            else if (inp_compare(.false.,test,'diana')) then
               call dia_input(rtdb)
            else if (inp_compare(.false.,test,'grad')) then
               call gradients_input(rtdb)
            else if (inp_compare(.false.,test,'gradients')) then
               call gradients_input(rtdb)
            else if (inp_compare(.false.,test,'gradient')) then
               call gradients_input(rtdb)
            else if (inp_compare(.false.,test,'ccsd')) then
               call ccsd_input(rtdb)
            else if (inp_compare(.false.,test,'oniom')) then
               call oniom_input(rtdb)
            else if (inp_compare(.false.,test,'print')) then
               call util_print_input(rtdb,' ')
               call util_print_rtdb_load(rtdb,' ') ! High level print
            else if (inp_compare(.false.,test,'noprint')) then
               call util_print_input(rtdb,' ')
            else if (inp_compare(.false.,test,'set')) then
               call input_set(rtdb)
            else if (inp_compare(.false.,test,'unset')) then
               call input_unset(rtdb)
            else if (inp_compare(.false.,test,'mcscf')) then
               call mcscf_input(rtdb)
c           else if (inp_compare(.false.,test,'plnwv')) then
c              call plnwv_input(rtdb)
            else if (inp_compare(.false.,test,'bq')) then
               call bq_input(rtdb)
            else if (inp_compare(.false.,test,'constraints')) then
               call cons_input(rtdb)
            else if (inp_compare(.false.,test,'dplot')) then
               call dplot_input(rtdb)
            else if (inp_compare(.false.,test,'property')) then
               call prop_input(rtdb)
            else if (inp_compare(.false.,test,'speech')) then
               call speech_input(rtdb)
            else if (inp_compare(.false.,test,'neb')) then
               call neb_input(rtdb)
            else if (inp_compare(.false.,test,'pspw')) then
               call nwpw_input(rtdb)
            else if (inp_compare(.false.,test,'nwpw')) then
               call nwpw_input(rtdb)
            else if (inp_compare(.false.,test,'smd')) then
               call smd_input(rtdb)
            else if (inp_compare(.false.,test,'pause')) then
               call util_sleep(60)
            else if (inp_compare(.false.,test,'rism')) then
               call rism_input(rtdb)
            else if (inp_compare(.false.,test,'qmmm')) then
               call qmmm_input(rtdb)
            else if (inp_compare(.false.,test,'ccca')) then
               call ccca_input(rtdb)
c            else if (inp_compare(.false.,test,'embed')) then
c               call embed_input(rtdb)
            else if (inp_compare(.false.,test,'relativistic')) then
               call rel_input(rtdb)
            else if (inp_compare(.false.,test,'nbo')) then
               call nbo_input(rtdb)
            else if (inp_compare(.false.,test,'vscf')) then
               call vscf_input(rtdb)
            else if (inp_compare(.false.,test,'raman')) then
               call raman_input(rtdb)
            else if (inp_compare(.false.,test,'dntmc')) then
               call dntmc_input(rtdb)
            else if (inp_compare(.false.,test,'vib')) then
               call freq_vib_input(rtdb)
* this reordered test will match freq and freq*
            else if (inp_compare(.false.,'freq',test)) then  
               call freq_vib_input(rtdb)
            else if (inp_compare(.false.,test,'hessian')) then
               call hess_input(rtdb)
            else if (inp_compare(.false.,test,'tddft')) then
               call tddft_input(rtdb)
            else if (inp_compare(.false.,test,'rt_tddft')) then
               call rt_tddft_input(rtdb)
            else if (inp_compare(.false.,test,'mymd')) then
                call mymd_input(rtdb)
            else if (inp_compare(.false.,test,'mymc')) then
                call mymc_input(rtdb)
            else if (inp_compare(.false.,test,'tce')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'tce'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               if (.not.rtdb_cput(rtdb,'tce:model',1,'ccsd'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ucc')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'ucc'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'uci')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'uci'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ump')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'umbpt')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'uccd')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'uccd'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ulccd')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'ulccd'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'uccsd')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'uccsd'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ulccsd')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'ulccsd'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'uqcisd')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'uqcisd'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'uccsdt')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'uccsdt'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'uccsdtq')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'uccsdtq'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ucisd')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'ucisd'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ucisdt')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'ucisdt'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ucisdtq')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'ucisdtq'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ump2')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt2'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ump3')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt3'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'ump4')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt4'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'umbpt2')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt2'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'umbpt3')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt3'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)
            else if (inp_compare(.false.,test,'umbpt4')) then
               if (.not.rtdb_cput(rtdb,'tce:module',1,'umbpt4'))
     1         call errquit('input_parse: failed writing to rtdb',0,
     &       RTDB_ERR)
               call tce_input(rtdb)

#ifdef MRCC_METHODS
c#warning "MRCC methods are currently under development"
ckbn mrcc-r-1 -3
            else if (inp_compare(.false.,test,'mrccdata')) then
               call tce_mrcc_input(rtdb)
#endif

c
c     INSERT NEW ELSE IF CLAUSES ABOVE HERE
c
            else if (inp_compare(.false.,test,'memory')) then
               continue         ! Already digested by input_mem_size
            else if (inp_compare(.false.,test,'start')) then
               continue         ! Already digested by input_file_info
            else if (inp_compare(.false.,test,'restart')) then
               continue         ! Already digested by input_file_info
            else if (inp_compare(.false.,test,'continue')) then
               continue         ! Already digested by input_file_info
            else if (inp_compare(.false.,test,'echo')) then
               continue         ! Already digested by input_file_info
            else if (inp_compare(.false.,test,'scratch_dir')) then
               continue         ! Already digested by input_file_info
            else if (inp_compare(.false.,test,'permanent_dir')) then
               continue         ! Already digested by input_file_info
            else if (inp_compare(.false.,test,'ecce_print')) then
               continue         ! Already digested by input_file_info
            else
               call errquit('input_parse: unknown directive '//test,0,
     &       INPUT_ERR)
            endif
c
            goto 10 
         endif                  ! End while
 9999    status = rtdb_parallel(.true.) ! Restore parallel access to db
         if (nlines.gt.0 .and. found_task.eq.0 .and. 
     $       util_print('warning',print_low)) then
c
c     Read input but found no task directive.  Not an error
c     but is probably undesirable ... unless doing python loop
c
c            write(LuOut,*) 
c            write(LuOut,*) ' ! warning: processed input with no task'
c            write(LuOut,*)
c            call util_flush(LuOut)
         endif
      endif                     ! End node zero only
c     
c     Global sum of integer variable for simple broadcast
c
      call ga_sync()
      call ga_igop(33,found_task,1,'+')
      input_parse = (found_task .eq. 1)
c     
      end
      subroutine input_time(rtdb)
      implicit none
      integer rtdb
      end
      subroutine input_qcharge(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
      integer rtdb
      double precision qcharge
      character*255 test
c
      if (.not. inp_a(test)) call errquit
     &    ('input_qcharge: failed to read ascii string',911, INPUT_ERR)
      if (.not.inp_compare(.false.,test,'qcharge')) call errquit
     &    ('input_qcharge: failed to read "qcharge"',911, INPUT_ERR)
c
      if (.not. inp_f(qcharge)) call errquit
     $     ('input_qcharge: failed to read real number', 0, INPUT_ERR)
c
      if (.not. rtdb_put(rtdb, 'qcharge', MT_DBL, 1, qcharge))
     $     call errquit
     $     ('input_qcharge: failed to write to rtdb', 0, RTDB_ERR)
c
      end
      subroutine input_charge(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
      integer rtdb
      double precision charge
      character*255 test
c
      if (.not. inp_a(test)) call errquit
     &    ('input_charge: failed to read ascii string',911, INPUT_ERR)
      if (.not.inp_compare(.false.,test,'charge')) call errquit
     &    ('input_charge: failed to read "charge"',911, INPUT_ERR)
c
      if (.not. inp_f(charge)) call errquit
     $     ('input_charge: failed to read real number', 0, INPUT_ERR)
c
      if (.not. rtdb_put(rtdb, 'charge', MT_DBL, 1, charge))
     $     call errquit
     $     ('input_charge: failed to write to rtdb', 0, RTDB_ERR)
c
      end

      SUBROUTINE md_frce(ntype,ecoul,eshrt,ebond,ntbond,eshel,ntshel,
     $     ewald1)

      implicit none

      include 'p_array.inc'
      include 'p_input.inc'
      include 'cm_atom.inc'
      include 'cm_latt.inc'
      include 'cm_vlst.inc'
      include 'cm_elst.inc'

      integer i,j,k
      integer jbeg,jend,jnab
      integer ntype,ntbond,ntshel

      real*8 rij,rijsq
      real*8 ewald1,ewald2,ewald3,ewald4
      real*8 evdw,ecoul,eshrt,ebond,eshel
      double precision ewald_excluded

      dimension rij(mxnlist,3),rijsq(mxnlist)

      ewald_excluded = 0.0d0
      do i=1,natms
       fff(i,1)=0.0
       fff(i,2)=0.0
       fff(i,3)=0.0
      enddo

      ecoul=ewald1
      eshrt=0.0
      ebond=0.0
      eshel=0.0
      evdw=0.0
      ewald2=0.0
      ewald3=0.0
      ewald4=0.0

c Reciprocal space sum
      call ewald_recp(ewald2)
      write(*,*) "ewald reciprocal",ewald2
      ecoul=ecoul+ewald2

      do i=1,natms-1

c Excluded electrostatic interactions
       jbeg=epoint(i)
       jend=epoint(i+1)-1
       k=0

       if(jbeg.le.jend)then

        do jnab=jbeg,jend

         j=elist(jnab)
         k=k+1

         if(k.gt.mxnlist)then
          write(output,*)'k greater than mxnlist'
          stop
         endif

         rij(k,1)=ccc(i,1)-ccc(j,1)
         rij(k,2)=ccc(i,2)-ccc(j,2)
         rij(k,3)=ccc(i,3)-ccc(j,3)

        enddo

        call tool_rebox(k,mxnlist,latt,rlatt,rij)

        k=0
        do jnab=jbeg,jend

         k=k+1
         rijsq(k)=rij(k,1)*rij(k,1)+rij(k,2)*rij(k,2)+rij(k,3)*rij(k,3)

        enddo

        call ewald_excl(i,rij,rijsq,jbeg,jend,ewald3)
        ewald_excluded = ewald_excluded + ewald3
        ecoul=ecoul+ewald3

       endif

       jbeg=point(i)
       jend=point(i+1)-1
       k=0

       if(jbeg.le.jend)then

        do jnab=jbeg,jend

         j=list(jnab)
         k=k+1

         if(k.gt.mxnlist)then
          write(output,*)'k greater than mxnlist'
          stop
         endif

         rij(k,1)=ccc(i,1)-ccc(j,1)
         rij(k,2)=ccc(i,2)-ccc(j,2)
         rij(k,3)=ccc(i,3)-ccc(j,3)

        enddo

        call tool_rebox(k,mxnlist,latt,rlatt,rij)

        k=0
        do jnab=jbeg,jend

         k=k+1
         rijsq(k)=rij(k,1)*rij(k,1)+rij(k,2)*rij(k,2)+rij(k,3)*rij(k,3)

        enddo

c Real space sum
        call ewald_real(i,rij,rijsq,jbeg,jend,ewald4)
        ecoul=ecoul+ewald4

c Non-bonded interactions
        call frce_shrt(i,ntype,rij,rijsq,jbeg,jend,evdw)
        eshrt=eshrt+evdw
        write(*,*) "evdw",evdw

       endif

      enddo

      write(*,*) "ewald exluded",ewald_excluded
c Bonded interactions
c      if(ntbond.gt.0)call frce_bond(ntbond,ebond)

c Core-shell interactions
c      if(ntshel.gt.0)call frce_shel(ntshel,eshel)

      return

      END
c $Id: md_frce.f 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine rohf_hessv_1e( basis, geom, nmo, nclosed, nopen,
     $     g_fcv, g_fpv, g_fcp,
     $     g_x, g_ax)
C     $Id: rohf_h1e.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
c     
      integer basis, geom
      integer nmo, nclosed, nopen
      integer g_fcv, g_fpv, g_fcp
      integer g_x
      integer g_ax
c     
      integer nvir, voff, ooff, oend, xoff, xend
      integer g_tmp1, g_tmp2, g_tmp3
      double precision four, mfour, one, mone, two, mtwo, zero
      parameter (four=4.0d0, mfour=-4.0d0, one=1.0d0, mone=-1.0d0,
     $     two=2.0d0, mtwo=-2.0d0, zero=0.0d0)
c
      integer ivec, nvec, gtype, vlen
c
      call ga_inquire(g_x,gtype,vlen,nvec)
c     
      nvir = nmo - nclosed - nopen
      voff = nclosed + nopen + 1
      ooff = nclosed + 1
      oend = nclosed + nopen
c     
c     Reshape argument vector by copying patches into matrix
c     
c       cv      cv  cv       cv  cv
c     S   =  4.F  .x   -  4.x  .F
c     
      if (.not. ga_create(MT_DBL, nmo, nmo, 'rohf_hv1e: tmp1',
     $     32, 32, g_tmp1)) call errquit('rohf_hv1e: tmp1', 0, GA_ERR)
      if (.not. ga_create(MT_DBL, nmo, nmo, 'rohf_hv1e: tmp2',
     $     32, 32, g_tmp2)) call errquit('rohf_hv1e: tmp2', 0, GA_ERR)
      if (nopen .gt. 0) then
         if (.not. ga_create(MT_DBL, nmo, nmo, 'rohf_hv1e: tmp3',
     $        32, 32, g_tmp3)) call errquit('rohf_hv1e: tmp3', 0,
     &       GA_ERR)
      endif
c
      do ivec = 1, nvec
         call ga_zero(g_tmp1)
         call ga_vec_to_mat(g_tmp1, voff, nmo, 1, nclosed, 
     $                      g_x, 1, ivec)
*         call ga_copy_patch('n', g_x, 1, (nvir*nclosed), ivec, ivec,
*     $        g_tmp1, voff, nmo, 1, nclosed )
         call ga_zero(g_tmp2)
         call ga_matmul_patch('n','n',four,zero,
     $        g_fcv, voff, nmo, voff, nmo,
     $        g_tmp1, voff, nmo, 1, nclosed,
     $        g_tmp2, voff, nmo, 1, nclosed )
         call ga_matmul_patch('n','n',mfour,one,
     $        g_tmp1, voff, nmo, 1, nclosed, 
     $        g_fcv, 1, nclosed, 1, nclosed,
     $        g_tmp2, voff, nmo, 1, nclosed )
c
         if (nopen .gt. 0) then
c     
            xoff = nclosed*nvir + 1
            xend = (nclosed + nopen)*nvir
            call ga_copy_patch('n', g_x, xoff, xend, ivec, ivec,
     $           g_tmp1, voff, nmo, ooff, oend )
            xoff = nvir*(nclosed+nopen) + 1
            xend = nvir*(nclosed+nopen) + nclosed*nopen
            call ga_copy_patch('n', g_x, xoff, xend, ivec, ivec,
     $           g_tmp1, ooff, oend, 1, nclosed )
c     
c       pv       pv  pv       pv  pv
c     S   =  2.F  .x   -  2.x  .F
c     
            call ga_matmul_patch('n','n',two,one,
     $           g_fpv, voff, nmo, voff, nmo,
     $           g_tmp1, voff, nmo, ooff, oend,
     $           g_tmp2, voff, nmo, ooff, oend )
            call ga_matmul_patch('n','n', mtwo, one,
     $           g_tmp1, voff, nmo, ooff, oend,
     $           g_fpv, ooff, oend, ooff, oend,
     $           g_tmp2, voff, nmo, ooff, oend )
c     
c       cp       cp  cp       cp  cp
c     S   =  2.F  .x   -  2.x  .F
c     
            call ga_matmul_patch('n','n',two,one,
     $           g_fcp, ooff, oend, ooff, oend,
     $           g_tmp1, ooff, oend, 1, nclosed,
     $           g_tmp2, ooff, oend, 1, nclosed )
            call ga_matmul_patch('n','n',mtwo,one,
     $           g_tmp1, ooff, oend, 1, nclosed,
     $           g_fcp, 1, nclosed, 1, nclosed,
     $           g_tmp2, ooff, oend, 1, nclosed )
c     
c       cv         cp     pv   cp
c     S    += (2.F   +  F  ).x
c     
c       cp         cp     pv   cv
c     S    += (2.F   +  F  ).x
c     
            call ga_dadd(two,g_fcp,one,g_fpv,g_tmp3)
            call ga_matmul_patch('n', 'n', one, one,
     $           g_tmp3, voff, nmo, ooff, oend,
     $           g_tmp1, ooff, oend, 1, nclosed,
     $           g_tmp2, voff, nmo, 1, nclosed )
            call ga_matmul_patch('t', 'n', one, one,
     $           g_tmp3, ooff, oend, voff, nmo,
     $           g_tmp1, voff, nmo, 1, nclosed,
     $           g_tmp2, ooff, oend, 1, nclosed )
c     
c       cv         pv     cp   pv
c     S    -= (2.F   +  F  ).x
c     
c       pv         pv     cp   cv
c     S    -= (2.F   +  F  ).x
c     
            call ga_dadd(one,g_fcp,two,g_fpv,g_tmp3)
            call ga_matmul_patch('n','n',mone,one,
     $           g_tmp1, voff, nmo, ooff, oend,
     $           g_tmp3, ooff, oend, 1, nclosed,
     $           g_tmp2, voff, nmo, 1, nclosed )
            call ga_matmul_patch('n','t',mone,one,
     $           g_tmp1, voff, nmo, 1, nclosed,
     $           g_tmp3, 1, nclosed, ooff, oend,
     $           g_tmp2, voff, nmo, ooff, oend )
c     
c       pv       cp     pv   cp
c     S    += (F   -  F  ).x
c     
c       cp       cp     pv   pv
c     S    += (F   -  F  ).x
c     
            call ga_dadd(one,g_fcp,mone,g_fpv,g_tmp3)
            call ga_matmul_patch('n', 't', one, one,
     $           g_tmp3, voff, nmo, 1, nclosed,
     $           g_tmp1, 1, nclosed, ooff, oend,
     $           g_tmp2, voff, nmo, ooff, oend )
            call ga_matmul_patch('t', 'n', one, one,
     $           g_tmp1, ooff, oend, voff, nmo,
     $           g_tmp3, voff, nmo, 1, nclosed,
     $           g_tmp2, ooff, oend, 1, nclosed )
c
         endif
c     
         xend = nclosed*nvir
c
         call ga_mat_to_vec(g_tmp2, voff, nmo, 1, nclosed,
     $       g_ax, 1, ivec, 1.0d0, '+')
*         call ga_dadd_patch( one, g_tmp2, voff, nmo, 1, nclosed,
*     $        one, g_ax, 1, xend, ivec, ivec,
*     $        g_ax, 1, xend, ivec, ivec)
c
         if (nopen .gt. 0) then
            xoff = xend + 1
            xend = xend + nopen*nvir
*
            call ga_mat_to_vec(g_tmp2, voff, nmo, ooff, oend,
     $         g_ax, xoff, ivec, 1.0d0, '+')
*            call ga_dadd_patch( one, g_tmp2, voff, nmo, ooff, oend,
*     $           one, g_ax, xoff, xend, ivec, ivec,
*     $           g_ax, xoff, xend, ivec, ivec)
            xoff = xend + 1
            xend = xend + nopen*nclosed
            call ga_mat_to_vec(g_tmp2, ooff, oend, 1, nclosed,
     $         g_ax, xoff, ivec, 1.0d0, '+')
*            call ga_dadd_patch( one, g_tmp2, ooff, oend, 1, nclosed,
*     $           one, g_ax, xoff, xend, ivec, ivec,
*     $           g_ax, xoff, xend, ivec, ivec)
         endif
      enddo
c
      if (.not. ga_destroy(g_tmp1)) call errquit('rohf_hv1?',0, GA_ERR)
      if (.not. ga_destroy(g_tmp2)) call errquit('rohf_hv1?',0, GA_ERR)
      if (nopen .gt. 0) then
         if (.not. ga_destroy(g_tmp3)) call errquit('rohf_hv1?',0,
     &       GA_ERR)
      endif
c
      end

*
* $Id: DMatrix.F 25818 2014-06-18 01:27:15Z bylaska $
*

*     ***********************************************************
*     *								*
*     *   		   DMatrix library			*
*     *								*
*     *   Author - Eric Bylaska					*
*     *   date   - 5/19/06					*
*     *								*
*     ***********************************************************
c
c
c
c

c     ****************************************
c     *                                      *
c     *        DMatrix_block_mapping         *
c     *                                      *
c     ****************************************

c     Defines a SUMMA block mapping of an n1xn2 matrix.
c
      subroutine DMatrix_block_mapping(n1,n2,
     >                                 np_i,np_j,
     >                                 block_i,block_j)
      implicit none
      integer n1,n2
      integer np_i,np_j
      integer block_i(0:np_i-1),block_j(0:np_j-1)

*     **** local variables ****
      integer i,j,k
      
*     *** determine block mapping ****
      call icopy(np_i,0,1,block_i,1)
      call icopy(np_j,0,1,block_j,1)

      i = 0
      do k=1,n1
        block_i(i) = block_i(i) + 1
        i = mod(i+1,np_i)
      end do
      j = 0
      do k=1,n2
        block_j(j) = block_i(j) + 1
        j = mod(j+1,np_j)
      end do
      return
      end
 




*     ***********************************
*     *                                 *
*     *         DMatrix_tredq           *
*     *                                 *
*     ***********************************
      subroutine DMatrix_tredq(n,
     >                 A,Q,lda,ma,na,
     >                 taskid_i,taskid_j,
     >                 np_i,np_j,
     >                 comm_i, comm_j,
     >                 work1,work2,
     >                 Q1,V1)
      implicit none
      integer n


      integer lda,ma(*),na(*)
      real*8  A(lda,*),Q(lda,*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  work1(*),work2(*)
      real*8  Q1(*),V1(*)

*     **** local variables ****
      integer k
      real*8  r2


      call DMatrix_eye(n,n,1.0d0,Q,lda,ma,na,taskid_i,taskid_j)
      do k = 1,n-2

c         call DMatrix_houseq_V(k,n,A,V1,Q1,lda,ma,na,r2,
c     >            taskid_i,taskid_j,np_i,np_j,comm_i,comm_j,
c     >            work1,work2)

         call nwpw_timing_start(26)
         call DMatrix_houseq(k,n,A,V1,Q1,lda,ma,na,
     >            taskid_i,taskid_j,np_i,np_j,comm_i,comm_j,
     >            work1,work2)
         call nwpw_timing_end(26)

         call nwpw_timing_start(27)
*        **** A = Q1*A*Q1 ****
         call DMatrix_dgemm1(n,n,n,64,
     >             1.0d0,
     >             Q1,lda, ma,na,
     >             A, lda, ma,na,
     >             0.0d0,
     >             V1,lda, ma,na,
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             work1,work2)
         call DMatrix_dgemm1(n,n,n,64,
     >             1.0d0,
     >             V1,lda, ma,na,
     >             Q1,lda, ma,na,
     >             0.0d0,
     >             A, lda, ma,na,
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             work1,work2)

*        **** Q = Q*Q1 ****
        call dcopy(ma(taskid_i+1)*na(taskid_j+1),Q,1,V1,1)
         call DMatrix_dgemm1(n,n,n,64,
     >             1.0d0,
     >             V1,lda, ma,na,
     >             Q1,lda, ma,na,
     >             0.0d0,
     >             Q,lda, ma,na,
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             work1,work2)
         call nwpw_timing_end(27)

      end do


      return
      end



*     ***********************************
*     *                                 *
*     *         DMatrix_eye             *
*     *                                 *
*     ***********************************

      subroutine DMatrix_eye(m,n,
     >               alpha,
     >               Q,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer m,n
      real*8  alpha

      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*)

      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,m

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               if (i.eq.j) then
                  Q(ii,jj) = alpha
               else
                  Q(ii,jj) = 0.0d0
               end if
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end



*     ***********************************
*     *                                 *
*     *         DMatrix_setdiag         *
*     *                                 *
*     ***********************************
      subroutine DMatrix_setdiag(m,n,
     >               alpha,
     >               Q,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer m,n
      real*8  alpha(*)

      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*)

      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,m

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               if (i.eq.j) then
                  Q(ii,jj) = alpha(i)
               else
                  Q(ii,jj) = 0.0d0
               end if
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end



*     ***********************************
*     *                                 *
*     *         DMatrix_s22             *
*     *                                 *
*     ***********************************
      subroutine DMatrix_s22(n,
     >               dte,
     >               Q,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  dte
      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               if (i.eq.j) then
                  Q(ii,jj) = (1.0d0-Q(ii,jj))*0.5d0/dte
               else
                  Q(ii,jj) = -Q(ii,jj)*0.5d0/dte
               end if
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end



*     ***********************************
*     *                                 *
*     *         DMatrix_s21             *
*     *                                 *
*     ***********************************
      subroutine DMatrix_s21(n,
     >               dte,
     >               Q,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  dte
      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               if (i.eq.j) then
                  Q(ii,jj) = (1.0d0-Q(ii,jj))*0.5d0
               else
                  Q(ii,jj) = -Q(ii,jj)*0.5d0
               end if
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end


*     ***********************************
*     *                                 *
*     *         DMatrix_s11             *
*     *                                 *
*     ***********************************

      subroutine DMatrix_s11(n,
     >               dte,
     >               Q,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  dte
      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  Q(ii,jj) = -Q(ii,jj)*0.5d0*dte
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end

*     ***********************************
*     *                                 *
*     *     DMatrix_Kiril_BTransform    *
*     *                                 *
*     ***********************************
      subroutine DMatrix_Kiril_BTransform(n,
     >               s12,s21,
     >               ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      integer ldq,mq(*),nq(*)
      real*8  s12(ldq,*),s21(ldq,*)
      integer taskid_i,taskid_j

*     **** local variables ****
      integer i,j,ii,jj,im,jm,i1,j1,k,l,index
      integer icur,jcur
      real*8  tmp1

      do k=1,n
         do l=1,(k-1)
            index = (k-1) + l*(k-1) !****index = (i-1) + (j-1)*n****
            im = mod(index,n)
            jm = (index-im)/n
            i1 = im + 1
            j1 = jm + 1

            jj   = 1
            jcur = 0
            do j=1,j1-1
                jj = jj + 1
               if (jj.gt.nq(jcur+1)) then
                 jcur = jcur + 1
                 jj   = 1
               end if
            end do
            ii   = 1
            icur = 0
            do i=1,i1-1
               ii = ii +1
               if (ii.gt.mq(icur+1)) then
                  icur = icur + 1
                  ii   = 1
               end if
            end do
            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               tmp1 = 0.5d0*(s12(ii,jj)+s21(ii,jj))
               s12(ii,jj) = tmp1
               s21(ii,jj) = tmp1
            end if
         end do
      end do
      return
      end




*     ***********************************
*     *                                 *
*     *      DMatrix_SASBtimesVtrans    *
*     *                                 *
*     ***********************************

      subroutine DMatrix_SASBtimesVtrans(n,
     >               SA,SB,
     >               Vt,A,B,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  SA(*),SB(*)
      integer ldq,mq(*),nq(*)
      real*8  Vt(ldq,*), A(ldq,*), B(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur


      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  A(ii,jj) = Vt(ii,jj)*SA(i)
                  B(ii,jj) = Vt(ii,jj)*SB(i)
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end



*     ***********************************
*     *                                 *
*     *         DMatrix_trace           *
*     *                                 *
*     ***********************************
      double precision function DMatrix_trace(n,
     >                           Q,ldq,mq,nq,
     >                           taskid_i,taskid_j)
      implicit none
      integer n
      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur
      double precision sum

      sum = 0.0d0
      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               if (i.eq.j) then
                  sum = sum + Q(ii,jj) 
               end if
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      call DMatrix_SumAll(sum)
      DMatrix_trace = sum
      return
      end

*     ***********************************
*     *                                 *
*     *         DMatrix_m_ijtoiijjp     *
*     *                                 *
*     ***********************************
      subroutine DMatrix_m_ijtoiijjp(i1,j1,ii,jj,p,ldq,mq,nq)
      implicit none
      integer i1,j1,ii,jj,p
      integer ldq,mq(*),nq(*)

*     **** local variables ****
      integer i,j,icur,jcur

*     **** external functions ****
      integer  Parallel2d_convert_taskid_ij
      external Parallel2d_convert_taskid_ij

      jj   = 1
      jcur = 0
      do j=1,j1-1
          jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      ii   = 1
      icur = 0
      do i=1,i1-1
         ii = ii +1
         if (ii.gt.mq(icur+1)) then
            icur = icur + 1
            ii   = 1
         end if
      end do
      p = Parallel2d_convert_taskid_ij(icur,jcur)
      return
      end


*     ***********************************
*     *                                 *
*     *         DMatrix_m_get_value     *
*     *                                 *
*     ***********************************
      real*8 function DMatrix_m_get_value(i1,j1,A,ldq,mq,nq)
      implicit none
      integer i1,j1
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)

*     **** local variables ****
      logical value
      integer taskid
      integer i,j
      integer ii,jj
      integer icur,jcur
      integer psend
      real*8 w

*     **** external functions ****
      integer  Parallel2d_convert_taskid_ij
      external Parallel2d_convert_taskid_ij

      call Parallel_taskid(taskid)


      jj   = 1
      jcur = 0
      do j=1,j1-1
          jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      ii   = 1
      icur = 0
      do i=1,i1-1
         ii = ii +1
         if (ii.gt.mq(icur+1)) then
            icur = icur + 1
            ii   = 1
         end if
      end do

      w = 0.0d0
      psend = Parallel2d_convert_taskid_ij(icur,jcur)
      if (psend.eq.taskid) then
          w = A(ii,jj)
      end if
      call Parallel_Brdcst_value(psend,w)

      Dmatrix_m_get_value = w
      return
      end


*     ***********************************
*     *                                 *
*     *       DMatrix_m_set_value       *
*     *                                 *
*     ***********************************
      subroutine DMatrix_m_set_value(w,i1,j1,A,ldq,mq,nq)
      implicit none
      real*8  w
      integer i1,j1
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)

*     **** local variables ****
      logical value
      integer taskid
      integer i,j
      integer ii,jj
      integer icur,jcur
      integer precv

*     **** external functions ****
      integer  Parallel2d_convert_taskid_ij
      external Parallel2d_convert_taskid_ij

      call Parallel_taskid(taskid)

      jj   = 1
      jcur = 0
      do j=1,j1-1
          jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      ii   = 1
      icur = 0
      do i=1,i1-1
         ii = ii +1
         if (ii.gt.mq(icur+1)) then
            icur = icur + 1
            ii   = 1
         end if
      end do

      precv = Parallel2d_convert_taskid_ij(icur,jcur)
      if (precv.eq.taskid) then
          A(ii,jj) = w
      end if

      return
      end




*     ***********************************
*     *                                 *
*     *       DMatrix_m_add_value       *
*     *                                 *
*     ***********************************
      subroutine DMatrix_m_add_value(w,i1,j1,A,ldq,mq,nq)
      implicit none
      real*8  w
      integer i1,j1
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)

*     **** local variables ****
      logical value
      integer taskid
      integer i,j
      integer ii,jj
      integer icur,jcur
      integer precv

*     **** external functions ****
      integer  Parallel2d_convert_taskid_ij
      external Parallel2d_convert_taskid_ij

      call Parallel_taskid(taskid)

      jj   = 1
      jcur = 0
      do j=1,j1-1
          jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      ii   = 1
      icur = 0
      do i=1,i1-1
         ii = ii +1
         if (ii.gt.mq(icur+1)) then
            icur = icur + 1
            ii   = 1
         end if
      end do

      precv = Parallel2d_convert_taskid_ij(icur,jcur)
      if (precv.eq.taskid) then
          A(ii,jj) = A(ii,jj) + w
      end if

      return
      end




*     ***********************************
*     *                                 *
*     *      DMatrix_HmltimesSA         *
*     *                                 *
*     ***********************************

      subroutine DMatrix_HmltimesSA(n,SA,
     >               A,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  SA(*)
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  A(ii,jj) = A(ii,jj)*SA(j)
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end




*     ***********************************
*     *                                 *
*     *      DMatrix_HmldivideSA        *
*     *                                 *
*     ***********************************

      subroutine DMatrix_HmldivideSA(n,SA,
     >               A,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  SA(*)
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  A(ii,jj) = A(ii,jj)/SA(j)
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end





*     ***********************************
*     *                                 *
*     *      DMatrix_HmldivideDplusD    *
*     *                                 *
*     ***********************************

      subroutine DMatrix_HmldivideDplusD(n,D,
     >               A,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  D(*)
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  A(ii,jj) = A(ii,jj)/(D(i)+D(j))
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end





*     ***********************************
*     *                                 *
*     *      DMatrix_Hmlfweightscale    *
*     *                                 *
*     ***********************************
*
*     A(i,j) = A(i,j) * (2*fw(i)/(fw(i)+fw(j)))

      subroutine DMatrix_Hmlfweightscale(n,fw,
     >               A,ldq,mq,nq,
     >               taskid_i,taskid_j)
      implicit none
      integer n
      real*8  fw(*)
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)
      integer taskid_i,taskid_j


*     **** local variables ****
      integer i,j,ii,jj
      integer icur,jcur

      jj   = 1
      jcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         do i=1,n

            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  A(ii,jj) = A(ii,jj)* (2.0d0*fw(i)/(fw(i)+fw(j)))
            end if

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if
         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if
      end do

      return
      end

      subroutine argos_cafe_slow(xw,vw,numw,xs,vs,isat,nums)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer numw,nums
      integer isat(msa)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 vw(mwm,3,mwa),vs(msa,3)
c
c      call argos_cafe_slowt(vw,numw,vs,nums,int_mb(i_iwa),isat,dbl_mb(i_mas))
      call argos_cafe_slowr(xw,vw,numw,xs,vs,nums,int_mb(i_iwa),isat,
     + dbl_mb(i_mas))
c
      return
      end
c $Id: argos_cafe_slow.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine tce_jacobi_t1(d_r1,d_t1,k_t1_offset,shift)
c
c $Id: tce_jacobi_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r1
      integer d_t1
      integer p1b
      integer h2b
      integer p1
      integer h2
      integer k_t1_offset
      integer size
      integer l_r1,k_r1
      integer i
      integer nprocs
      integer count
      integer next
      integer iter
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
      logical noloadbalance
      double precision shift
c
c      if(iter.le.100) then
c       shift=-zlshift
c      else
c       shift=0.0d0
c      end if
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_r1))))
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (noloadbalance.or.(next.eq.count)) then
            if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then 
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1)).eq.0) then
              size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
              if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1          call errquit('tce_jacobi_t1: MA problem',0,MA_ERR)
              call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
              i = 0
              do p1 = 1,int_mb(k_range+p1b-1)
                do h2 = 1,int_mb(k_range+h2b-1)
                  i = i + 1
                  dbl_mb(k_r1+i-1) = dbl_mb(k_r1+i-1)
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              +dbl_mb(k_evl_sorted+int_mb(k_offset+h2b-1)+h2-1)
     3             +shift)
                enddo
              enddo
              call add_hash_block(d_t1,dbl_mb(k_r1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
c update of the res.-single vector to the form of increment used in DIIS proc.
ccx              call put_hash_block(d_r1,dbl_mb(k_r1),size,
ccx     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
cc
              if (nodezero.and.util_print('t1',print_debug)) then
                call get_hash_block(d_t1,dbl_mb(k_r1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
                call ma_print_compact(dbl_mb(k_r1),size,1,'t1')
              endif
              if (.not.ma_pop_stack(l_r1))
     1          call errquit('tce_jacobi_t1: MA problem',1,MA_ERR)
            endif
            endif
            endif
cc            next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end
c
c
c
      subroutine tce_r1_divide(d_r1,k_t1_offset)
c
c $Id: tce_jacobi_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r1
      integer p1b
      integer h2b
      integer p1
      integer h2
      integer k_t1_offset
      integer size
      integer l_r1,k_r1
      integer i
      integer nprocs
      integer count
      integer next
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
      logical noloadbalance
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_r1))))
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (noloadbalance.or.(next.eq.count)) then
            if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then 
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1)).eq.0) then
              size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
              if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1          call errquit('tce_r1_divide: MA problem',0,MA_ERR)
              call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
              i = 0
              do p1 = 1,int_mb(k_range+p1b-1)
                do h2 = 1,int_mb(k_range+h2b-1)
                  i = i + 1
                  dbl_mb(k_r1+i-1) = dbl_mb(k_r1+i-1)
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              +dbl_mb(k_evl_sorted+int_mb(k_offset+h2b-1)+h2-1))
                enddo
              enddo
c update of the res.-single vector to the form of increment used in DIIS proc.
              call put_hash_block(d_r1,dbl_mb(k_r1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
cc
              if (.not.ma_pop_stack(l_r1))
     1          call errquit('tce_r1_divide: MA problem',1,MA_ERR)
            endif
            endif
            endif
cc            next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end

C***********************************************************************
      LOGICAL FUNCTION  DC_ENERGY(rtdb)
C***********************************************************************
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012

C This code applies the dangchang potential to WATER ONLY.

      IMPLICIT NONE

#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "dc_common.fh"
#include "util.fh"

      DOUBLE PRECISION cau2kcal

      parameter(cau2kcal = 627.509552D00) !value from /src/drdy/drdyP.fh

      INTEGER rtdb

C      DOUBLE PRECISION R

      DOUBLE PRECISION R3,EFLDMAG

      DOUBLE PRECISION V,EF,EFWX,EFWY,EFWZ,EFIX,EFIY,EFIZ
      DOUBLE PRECISION EFUX,EFUY,EFUZ,EFX,EFY,EFZ,POL,UU,Upol1
      DOUBLE PRECISION RXIIJJ,RYIIJJ,RZIIJJ,RIIJJSQ,RIIJJ
      DOUBLE PRECISION DOTX,DOTY,DOTZ,DOT,UDOT1
      DOUBLE PRECISION Vh2o,DC_VLJONES,DC_VCOUL,DC_EFMAG ! FxNs
      DOUBLE PRECISION DCDIP(3) ! Dipole Moment holder
      DOUBLE PRECISION  NUX,NUY,NUZ,MUX,MUY,MUZ,MX,MY,MZ,MUTOL,MU,DMU
      
C      INTEGER MXMOLS,NMOLS,MXATOM
      INTEGER NSCF,SCF,I,II,J,JJ,COUNT,SUM

      PARAMETER (NSCF = 200)         

      DIMENSION COUNT(MXMOLS)
      DIMENSION V(MXMOLS,MXMOLS,MXATOM,MXATOM)
      DIMENSION EF(MXMOLS,MXMOLS,MXATOM,MXATOM,3)
      DIMENSION EFWX(MXMOLS),EFWY(MXMOLS),EFWZ(MXMOLS)
      DIMENSION EFIX(MXMOLS),EFIY(MXMOLS),EFIZ(MXMOLS)
      DIMENSION EFX(MXMOLS),EFY(MXMOLS),EFZ(MXMOLS)
      DIMENSION NUX(MXMOLS,MXMOLS),NUY(MXMOLS,MXMOLS),
     & NUZ(MXMOLS,MXMOLS)
      DIMENSION MUX(NSCF,MXMOLS),MUY(NSCF,MXMOLS),
     & MUZ(NSCF,MXMOLS),MU(NSCF,MXMOLS)
      DIMENSION MX(MXMOLS),MY(MXMOLS),MZ(MXMOLS)       
      DIMENSION Vh2o(MXATOM,MXATOM)
      DIMENSION R3(MXMOLS,MXMOLS)


      EXTERNAL DC_Initialize

      EXTERNAL dc_setgeom


C     INITIALIZE LOGICAL FxN
      dc_energy = .false.

      CALL DC_Initialize

      CALL dc_setgeom(rtdb)      

      UU = 0.D+00

      Upol1 = 0.D+00

      DO I = 1, NMOLS

         EFWX(I) = 0.D+00
         EFWY(I) = 0.D+00
         EFWZ(I) = 0.D+00

      ENDDO 


     
C THIS SECTION WILL BE ACCESSED FOR EVERY MONTE CARLO STEP
C DUE TO THE FACT THAT ALL MOLECULES ARE MOVED AT ONCE

C     The first part of 1st DO Loop calculates 
C     the initial electric field
C     for every atom


C     O atom = 1st point charge
C     H atom = 2nd-3rd point charges
C     M atom = 4th point charge added
C              to correct the dipole
C     I and J represent molecule of interest
C     II and JJ represent atom of interest

C     4's below on II and JJ loops
C     indicate 4 point charges on each H2O            

      DO I = 1, NMOLS - 1

        DO J = I + 1, NMOLS

            DO II = 1, 4

              DO JJ = 1, 4
           
              RXIIJJ = R(I,II,1) - R(J,JJ,1)
              RYIIJJ = R(I,II,2) - R(J,JJ,2)
              RZIIJJ = R(I,II,3) - R(J,JJ,3)
              RIIJJSQ = RXIIJJ**2 + RYIIJJ**2 + RZIIJJ**2
              RIIJJ = DSQRT(RIIJJSQ)


C     if then applies to II being M atom
       
               IF(II.EQ.4)THEN
  
C               WRITE(6,*)'RIIJJ =',RIIJJ,' ANGSTROMS'

                EFUX = RXIIJJ/RIIJJ
               EFUY = RYIIJJ/RIIJJ
               EFUZ = RZIIJJ/RIIJJ
               
               EFLDMAG = DC_EFMAG(J,JJ,RIIJJSQ)
             
               EF(I,J,II,JJ,1) = EFLDMAG*EFUX
               EF(I,J,II,JJ,2) = EFLDMAG*EFUY
               EF(I,J,II,JJ,3) = EFLDMAG*EFUZ
               
               EFWX(I) = EFWX(I) + EF(I,J,II,JJ,1)
               EFWY(I) = EFWY(I) + EF(I,J,II,JJ,2)
               EFWZ(I) = EFWZ(I) + EF(I,J,II,JJ,3)
               
        
c     BELOW if then applies to II and JJ being the M atom                                                                   
                IF((II.EQ.4).AND.(JJ.EQ.4))THEN
                
                  EF(J,I,JJ,II,1) = -EF(I,J,II,JJ,1)
                  EF(J,I,JJ,II,2) = -EF(I,J,II,JJ,2)
                  EF(J,I,JJ,II,3) = -EF(I,J,II,JJ,3)
                  
                  EFWX(J) = EFWX(J) + EF(J,I,JJ,II,1)
                  EFWY(J) = EFWY(J) + EF(J,I,JJ,II,2)
                  EFWZ(J) = EFWZ(J) + EF(J,I,JJ,II,3)

                   NUX(I,J) = RXIIJJ/RIIJJ
                   NUY(I,J) = RYIIJJ/RIIJJ
                   NUZ(I,J) = RZIIJJ/RIIJJ
c234567                   
                   NUX(J,I) = -NUX(I,J)
                   NUY(J,I) = -NUY(I,J)
                   NUZ(J,I) = -NUZ(I,J)

                   R3(I,J) = RIIJJ*RIIJJ*RIIJJ*6.748332695D+00
                   R3(J,I) = R3(I,J)
                   
         ENDIF ! II being M atom

C     BELOW  Else if then applies to II NOT being M atom
C            and JJ being the M atom
        
                ELSEIF(JJ.EQ.4)THEN
                
                RXIIJJ = R(J,JJ,1) - R(I,II,1)
                RYIIJJ = R(J,JJ,2) - R(I,II,2)
                RZIIJJ = R(J,JJ,3) - R(I,II,3)
                RIIJJSQ = RXIIJJ**2 + RYIIJJ**2 + RZIIJJ**2
                RIIJJ = DSQRT(RIIJJSQ)

                
C               WRITE(6,*)'RIIJJ =',RIIJJ,' ANGSTROMS'

                EFUX = RXIIJJ/RIIJJ
               EFUY = RYIIJJ/RIIJJ
               EFUZ = RZIIJJ/RIIJJ
               
               EFLDMAG = DC_EFMAG(I,II,RIIJJSQ)
             
               EF(J,I,JJ,II,1) = EFLDMAG*EFUX
               EF(J,I,JJ,II,2) = EFLDMAG*EFUY
               EF(J,I,JJ,II,3) = EFLDMAG*EFUZ
               
               EFWX(J) = EFWX(J) + EF(J,I,JJ,II,1)
               EFWY(J) = EFWY(J) + EF(J,I,JJ,II,2)
               EFWZ(J) = EFWZ(J) + EF(J,I,JJ,II,3)
               
        
               ENDIF ! II NOT being M atom 
                      ! JJ being M atom

C     The second part of 1st DO Loop calculates
C     the pairwise additive potential energy
                                                         
               IF(II.EQ.1.AND.JJ.EQ.1)THEN

                 Vh2o(II,JJ) = DC_Vljones(I,J,II,JJ,RIIJJSQ)                 
c                WRITE(12,*)'Vh2oOO =',Vh2o(II,JJ),' kcal/mole'              
                                               
              ELSEIF(II.EQ.4.AND.JJ.EQ.4)THEN
              
                 Vh2o(II,JJ) = DC_Vcoul(I,J,II,JJ,RIIJJ)
c                WRITE(12,*)'Vh2o =',Vh2o(II,JJ)
                 
               ELSEIF(II.EQ.1.OR.JJ.EQ.1)THEN                               

                 Vh2o(II,JJ) = 0.D+00               
                 
               ELSE
               
                 Vh2o(II,JJ) = DC_Vcoul(I,J,II,JJ,RIIJJ)
c                WRITE(12,*)'Vh2o =',DC_Vcoul(I,J,II,JJ,RIIJJ)              
                                                                            
              ENDIF


               V(I,J,II,JJ) = Vh2o(II,JJ)      

c234567                              
               UU = UU + V(I,J,II,JJ)
    
               END DO

            END DO       
 
         END DO

      END DO ! Ends all 4 loops



c      WRITE(12,*)'UU and DU before induced dipoles are computed'
c      WRITE(12,*)'UU =',UU

C      WRITE(12,*)'Done with pair potentials and point charge'
c      WRITE(12,*)'electric field calculation...'
C      WRITE(12,*)'...'

     
C This section calculates the self-consistent induced dipole moments
C for each molecule and once converged evaluates Upol


      POL = 9.74459258D+00
      MUTOL = 1.D-6

      DO I = 1, NMOLS

         COUNT(I) = 0
         MU(1,I) = 0.D+00
         MUX(1,I) = 0.D+00
         MUY(1,I) = 0.D+00
         MUZ(1,I) = 0.D+00
         EFX(I) = 0.D+00
         EFY(I) = 0.D+00
         EFZ(I) = 0.D+00

      ENDDO


      SUM = 0

C     First part of SCF DO Loop
C     calculates change in electric field
  
      DO SCF = 2, NSCF

        DO I = 1, NMOLS

          DO J = 1, I - 1

c         First dot product of induced dipole and Tensor
c         (MU) dot (unit vector between 2 atoms)

          DOTX = NUX(I,J)*MUX(SCF-1,J)
          DOTY = NUY(I,J)*MUY(SCF-1,J)
          DOTZ = NUZ(I,J)*MUZ(SCF-1,J)

          DOT = DOTX + DOTY + DOTZ

c         Second dot product of induced dipole and Tensor
c         (MU dot NU) dot (NU)

          EFIX(I)=(3.D+00*DOT*NUX(I,J)-MUX(SCF-1,J))/R3(I,J)
          EFIY(I)=(3.D+00*DOT*NUY(I,J)-MUY(SCF-1,J))/R3(I,J)
          EFIZ(I)=(3.D+00*DOT*NUZ(I,J)-MUZ(SCF-1,J))/R3(I,J)

C         Sum all Tensor-induced dipole dot products

          EFX(I) = EFX(I) + EFIX(I)
          EFY(I) = EFY(I) + EFIY(I)
          EFZ(I) = EFZ(I) + EFIZ(I)

          ENDDO ! J Loop

C         The next J DO Loop avoids self interactions

          DO J = I + 1, NMOLS

          DOTX = NUX(I,J)*MUX(SCF-1,J)
          DOTY = NUY(I,J)*MUY(SCF-1,J)
          DOTZ = NUZ(I,J)*MUZ(SCF-1,J)

          DOT = DOTX + DOTY + DOTZ

          EFIX(I)=(3.D+00*DOT*NUX(I,J)-MUX(SCF-1,J))/R3(I,J)
          EFIY(I)=(3.D+00*DOT*NUY(I,J)-MUY(SCF-1,J))/R3(I,J)
          EFIZ(I)=(3.D+00*DOT*NUZ(I,J)-MUZ(SCF-1,J))/R3(I,J)
          
          EFX(I) = EFX(I) + EFIX(I)
          EFY(I) = EFY(I) + EFIY(I)
          EFZ(I) = EFZ(I) + EFIZ(I)
          
          ENDDO ! 2nd J Loop

        ENDDO ! I Loop


C         Second part of SCF DO Loop 
C         Calculates and Saves
C         New Total Electric Field

        DO I = 1, NMOLS

          MUX(SCF,I)=POL*(EFWX(I) + EFX(I))
          MUY(SCF,I)=POL*(EFWY(I) + EFY(I))
          MUZ(SCF,I)=POL*(EFWZ(I) + EFZ(I))
          
          MU(SCF,I)=DSQRT(MUX(SCF,I)**2+MUY(SCF,I)**2+MUZ(SCF,I)**2)

          DMU=DABS(MU(SCF,I)-MU(SCF-1,I))

          IF(DMU.LT.MUTOL)THEN

C      MX(I) is the final self consistent induced dipole moment
C      from the final electric field times the polarizability

            MX(I)= MUX(SCF,I)
            MY(I)= MUY(SCF,I)
            MZ(I)= MUZ(SCF,I)

c            WRITE(12,*)'hey dipole',I,' converged'
c            WRITE(12,*)'after ',SCF,' steps'
c            WRITE(12,*)'************************'
c            WRITE(12,*)'MX(',I,') =',MX(I)
c            WRITE(12,*)'MY(',I,') =',MY(I)
c            WRITE(12,*)'MZ(',I,') =',MZ(I)
c            WRITE(12,*)'|MU| =',X
c            WRITE(12,*)'************************'

            COUNT(I) = 1 ! WHY WOULD HE LET IT EQUAL ONE AGAIN???

C            WRITE(12,*)'COUNT(',I,') =',COUNT(I)            

          ENDIF


        END DO ! 2nd I Loop
 
        DO J = 1, NMOLS

           SUM = SUM + COUNT(J)

        END DO ! J Loop

          
        IF(SUM.EQ.DBLE(NMOLS))THEN

C          WRITE(12,*)'all induced dipoles have converged!'
C          WRITE(12,*)'SUM =',SUM
          
          GOTO 817

        ENDIF 
           
        SUM = 0 ! Not Converged

        DO J = 1, NMOLS

           EFX(J) = 0.D+00 ! Reinitializing
           EFY(J) = 0.D+00
           EFZ(J) = 0.D+00
           COUNT(J) = 0.D+00

        ENDDO ! J Loop


C        WRITE(12,*)'finished with lower ith loop'
C        WRITE(12,*)'going back for another SCF iteration'


        IF(SCF.GE.NSCF)THEN
    
C        WRITE(12,*)'...there is a problem...'
C        WRITE(12,*)'the induced dipoles did not converge'
C        WRITE(12,*)'...stopping...sorry'


        ENDIF

      ENDDO ! SCF Loop

 817  CONTINUE

C******************************************************************
C This loop sums the dot products of the self consistent induced
C dipole moments with the total INITIAL electric field of the charges
C to give the polarization interaction


      DO I = 1, NMOLS
    
         DOTX=MX(I)*EFWX(I)
         DOTY=MY(I)*EFWY(I)
         DOTZ=MZ(I)*EFWZ(I)

         DOT = DOTX + DOTY + DOTZ

         UDOT1 = - 0.5D+00*DOT*627.5095D+00

         Upol1 = Upol1 + UDOT1


      ENDDO ! I Loop
      

      UU = UU + Upol1

      UU = UU / cau2kcal

C     Calculate Total Dipole Moment Components
      CALL DC_DIPOLEMOM(MX,MY,MZ,DCDIP)
      if (util_print('Information',print_low)) then
      WRITE(6,*)'Energy=', UU, 'Hartrees'
      WRITE(6,*)'Dipole Moments in (au)'
      WRITE(6,*)(DCDIP(I),I=1,3)
      endif

C     INITIALIZE LOGICAL FxN
      dc_energy = .true.

      if (.not. rtdb_put(rtdb,'dangchang:energy',mt_dbl,1,UU))
     & call errquit('dc_energy:  no energy in dangchang?', 0,
     & RTDB_ERR)

      if (.not. rtdb_put(rtdb,'dangchang:dipole',mt_dbl,3,DCDIP))
     & call errquit ('dc_energy:  no dipole in dangchang?', 0,
     & RTDB_ERR)

      RETURN
      END

C***********************************************************************
      FUNCTION DC_Vcoul(I,J,II,JJ,RIIJJ)
C***********************************************************************
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012

      IMPLICIT NONE

      DOUBLE PRECISION kb,k,e,esqrd,PI,QSQRD,SGMSQ,EPSILON,EPS,Q
      DOUBLE PRECISION RIIJJ,DC_Vcoul
      INTEGER I,J,II,JJ

      COMMON/DCI/kb,k,e,esqrd,PI,Q(4),
     +QSQRD(4,4),SGMSQ(4,4),EPS(4,4)
                      
      DC_Vcoul = (k*QSQRD(II,JJ)*esqrd) / RIIJJ
      
      RETURN
      END 

C***********************************************************************
      FUNCTION DC_Vljones(I,J,II,JJ,RIIJJSQ)
C***********************************************************************
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012

      IMPLICIT NONE

      DOUBLE PRECISION SR2,SR6,SR12,RIIJJSQ
      DOUBLE PRECISION DC_Vljones
      DOUBLE PRECISION kb,k,e,esqrd,PI,QSQRD,SGMSQ,EPS
      DOUBLE PRECISION EPSILON,Q
      INTEGER I,J,II,JJ

      COMMON/DCI/kb,k,e,esqrd,PI,Q(4),
     +QSQRD(4,4),SGMSQ(4,4),EPS(4,4)

      SR2 = SGMSQ(II,JJ)/RIIJJSQ
              
      SR6 = SR2*SR2*SR2
              
      SR12 = SR6*SR6
               
      DC_Vljones = 4.0D+00*EPS(II,JJ)*(SR12 - SR6)
     
      RETURN
      END
     
C***********************************************************************
      FUNCTION DC_EFMAG(I,II,RIIJJSQ)
C***********************************************************************
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012

      IMPLICIT NONE
      DOUBLE PRECISION DC_EFMAG,RIIJJSQ,Q
      DOUBLE PRECISION  kb,k,e,esqrd,PI,QSQRD,SGMSQ,EPS
      DOUBLE PRECISION  EPSILON
      INTEGER I,J,II,JJ

      COMMON/DCI/kb,k,e,esqrd,PI,Q(4),
     +QSQRD(4,4),SGMSQ(4,4),EPS(4,4)

      DC_EFMAG= k*e*Q(II)/RIIJJSQ
      DC_EFMAG= DC_EFMAG/7.401250726D+21
      
      RETURN
      END         

C***********************************************************************
      SUBROUTINE DC_DIPOLEMOM(MX,MY,MZ,DCDIP)
C***********************************************************************
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
      IMPLICIT NONE

#include "dc_common.fh"

      DOUBLE PRECISION kb,k,e,esqrd,PI,Q,QSQRD,SGMSQ,EPS
      INTEGER I, J
      DOUBLE PRECISION DCDIP(3)
      DOUBLE PRECISION MX(MXMOLS),MY(MXMOLS),MZ(MXMOLS)

      COMMON/DCI/kb,k,e,esqrd,PI,Q(4),
     +QSQRD(4,4),SGMSQ(4,4),EPS(4,4)

      DO I = 1, 3
          DCDIP(I) = 0.00D+00
      ENDDO
      DO I = 1, NMOLS
          DCDIP(1) = DCDIP(1) + MX(I)
          DCDIP(2) = DCDIP(2) + MY(I)
          DCDIP(3) = DCDIP(3) + MZ(I)
      DO J = 1, 4
          DCDIP(1) = DCDIP(1) + (Q(J)*R(I,J,1)/0.5291772083D+00)
          DCDIP(2) = DCDIP(2) + (Q(J)*R(I,J,2)/0.5291772083D+00)
          DCDIP(3) = DCDIP(3) + (Q(J)*R(I,J,3)/0.5291772083D+00)
      ENDDO
      ENDDO

      RETURN
      END
C***********************************************************************
C  End of SUBROUTINE DC_DIPOLEMOM(MX,MY,MZ,DCDIP)
C***********************************************************************
c $Id: dc_energy.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine input_title(rtdb)
C$Id: input_title.F 19697 2010-10-29 16:57:34Z d3y133 $
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "stdio.fh"
c
      integer rtdb
      character*255 title
      character*255 blank, underline
      integer lent, i
      integer center
c
c     Detect extraneous input after title directive ... probable error
c
      call inp_set_field(0)
      if (inp_n_field() .gt. 2) goto 1000
      if (.not. inp_a(title)) call errquit
     *      ('input_title: title is not set',555, INPUT_ERR)
      if (.not. inp_a(title)) goto 1000
c
c     Shuffle title down to remove leading blanks
c
      lent = inp_strlen(title)
      do center = 1, lent
         if (title(center:center) .ne. ' ') goto 10
      enddo
 10   do i = center, lent
         title(i-center+1:i-center+1) = title(i:i)
      enddo
      title(lent-center+2:) = ' '
c     
c     Write out centered and underlined title
c
       call util_print_centered(6,title(1:lent),40,.true.)
c      lent = inp_strlen(title)
c      center = 16
cc      center = (255 - lent) / 2
c      blank = ' '
c      do i = 1, lent
c         underline(i:i) = '-'
c      enddo
c      write(LuOut,1) blank(1:center),title(1:lent)
c      write(LuOut,1) blank(1:center),underline(1:lent)
c      write(LuOut,*)
c 1    format(1x,a,a)
c
c     Store title in the database
c
      if (.not. rtdb_cput(rtdb, 'title', 1, title))
     $     call errquit('input_title: put of title failed', lent,
     &       RTDB_ERR)
c
      return
c
 1000 call errquit('input_title: title <string title>', 0, INPUT_ERR)
      end

      subroutine tce_cisdt_energy(d_f1,d_v2,d_t1,d_t2,d_t3,
     1           d_r1,d_r2,d_r3,d_e,
     1           k_f1_offset,k_v2_offset,
     1           k_t1_offset,k_t2_offset,k_t3_offset,
     1           k_r1_offset,k_r2_offset,k_r3_offset,k_e_offset,
     1           size_e,size_r1,size_r2,size_r3,
     1           size_t1,size_t2,size_t3,ref,corr)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
c
      integer d_f1,d_v2,d_t1,d_t2,d_t3,d_r1,d_r2,d_r3,d_e 
      integer k_f1_offset,k_v2_offset
      integer k_t1_offset,k_t2_offset,k_t3_offset
      integer k_r1_offset,k_r2_offset,k_r3_offset,k_e_offset
      integer size_e,size_r1,size_r2,size_r3
      integer size_t1,size_t2,size_t3
      double precision ref,corr
c
c      integer iter
      double precision cpu, wall
      double precision r1,r2,r3
      double precision residual
      logical nodezero
      integer dummy
      character*255 filename
c
      nodezero=(ga_nodeid().eq.0)
      call tce_diis_init()
      do iter=1,maxiter
         cpu=-util_cpusec()
         wall=-util_wallsec()
         if (nodezero.and.(iter.eq.1)) write(LuOut,9050) "CISDT"
         call tce_filename('e',filename)
         call createfile(filename,d_e,size_e)
         call cisdt_e(d_f1,d_e,d_t1,d_t2,d_v2,
     1                k_f1_offset,k_e_offset,
     2                k_t1_offset,k_t2_offset,k_v2_offset)
         call reconcilefile(d_e,size_e)
         call tce_filename('r1',filename)
         call createfile(filename,d_r1,size_r1)
         call cisdt_c1(d_e,d_f1,d_r1,d_t1,d_t2,d_t3,d_v2,
     1                 k_e_offset,k_f1_offset,k_r1_offset,k_t1_offset,
     2                 k_t2_offset,k_t3_offset,k_v2_offset)
         call reconcilefile(d_r1,size_r1)
         call tce_filename('r2',filename)
         call createfile(filename,d_r2,size_r2)
         call cisdt_c2(d_e,d_f1,d_r2,d_t1,d_t2,d_t3,d_v2,
     1                 k_e_offset,k_f1_offset,k_r2_offset,k_t1_offset,
     2                 k_t2_offset,k_t3_offset,k_v2_offset)
         call reconcilefile(d_r2,size_r2)
         call tce_filename('r3',filename)
         call createfile(filename,d_r3,size_r3)
         call cisdt_c3(d_e,d_f1,d_r3,d_t1,d_t2,d_t3,d_v2,
     1                 k_e_offset,k_f1_offset,k_r3_offset,k_t1_offset,
     2                 k_t2_offset,k_t3_offset,k_v2_offset)
         call reconcilefile(d_r3,size_r3)
         call tce_residual_t1(d_r1,k_r1_offset,r1)
         call tce_residual_t2(d_r2,k_r2_offset,r2)
         call tce_residual_t3(d_r3,k_r3_offset,r3)
         residual = max(r1,r2,r3)
         call get_block(d_e,corr,1,0)
         cpu=cpu+util_cpusec()
         wall=wall+util_wallsec()
         if (nodezero) write(LuOut,9100) iter,residual,corr,cpu,wall
         if (residual .lt. thresh) then
            if (nodezero) then
               write(LuOut,9060)
               write(LuOut,9070) "CISDT",corr
               write(LuOut,9080) "CISDT",ref + corr
            endif
            call deletefile(d_r3)
            call deletefile(d_r2)
            call deletefile(d_r1)
            call deletefile(d_e)
            call tce_diis_tidy()
            goto 100
         endif
         call tce_diis(.false.,iter,.true.,.true.,.true.,.false.,
     1                 d_r1,d_t1,k_t1_offset,size_t1,
     2                 d_r2,d_t2,k_t2_offset,size_t2,
     3                 d_r3,d_t3,k_t3_offset,size_t3,
     4                 dummy,dummy,dummy,dummy)
         call deletefile(d_r3)
         call deletefile(d_r2)
         call deletefile(d_r1)
         call deletefile(d_e)
         if (nodezero) call util_flush(LuOut)
      enddo
      call errquit('tce_energy: maxiter exceeded',iter,CALC_ERR)
 100  continue
 9050 format(/,1x,A,' iterations',/,
     1  1x,'--------------------------------------------------------',/
     2  1x,'Iter          Residuum       Correlation     Cpu    Wall',/
     3  1x,'--------------------------------------------------------')
 9060 format(
     1  1x,'--------------------------------------------------------',/
     2  1x,'Iterations converged')
 9070 format(1x,A,' correlation energy / hartree = ',f25.15)
 9080 format(1x,A,' total energy / hartree       = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
      end

c $Id: tce_cisdt_energy.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b ZGEQRF
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZGEQRF + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zgeqrf.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zgeqrf.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zgeqrf.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZGEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, LDA, LWORK, M, N
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZGEQRF computes a QR factorization of a complex M-by-N matrix A:
*> A = Q * R.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix A.  M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX*16 array, dimension (LDA,N)
*>          On entry, the M-by-N matrix A.
*>          On exit, the elements on and above the diagonal of the array
*>          contain the min(M,N)-by-N upper trapezoidal matrix R (R is
*>          upper triangular if m >= n); the elements below the diagonal,
*>          with the array TAU, represent the unitary matrix Q as a
*>          product of min(m,n) elementary reflectors (see Further
*>          Details).
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is COMPLEX*16 array, dimension (min(M,N))
*>          The scalar factors of the elementary reflectors (see Further
*>          Details).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX*16 array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The dimension of the array WORK.  LWORK >= max(1,N).
*>          For optimum performance LWORK >= N*NB, where NB is
*>          the optimal blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex16GEcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The matrix Q is represented as a product of elementary reflectors
*>
*>     Q = H(1) H(2) . . . H(k), where k = min(m,n).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**H
*>
*>  where tau is a complex scalar, and v is a complex vector with
*>  v(1:i-1) = 0 and v(i) = 1; v(i+1:m) is stored on exit in A(i+1:m,i),
*>  and tau in TAU(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE ZGEQRF( M, N, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IB, IINFO, IWS, K, LDWORK, LWKOPT, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZGEQR2, ZLARFB, ZLARFT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NB = ILAENV( 1, 'ZGEQRF', ' ', M, N, -1, -1 )
      LWKOPT = N*NB
      WORK( 1 ) = LWKOPT
      LQUERY = ( LWORK.EQ.-1 )
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGEQRF', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      K = MIN( M, N )
      IF( K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NBMIN = 2
      NX = 0
      IWS = N
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
*
*        Determine when to cross over from blocked to unblocked code.
*
         NX = MAX( 0, ILAENV( 3, 'ZGEQRF', ' ', M, N, -1, -1 ) )
         IF( NX.LT.K ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
               NB = LWORK / LDWORK
               NBMIN = MAX( 2, ILAENV( 2, 'ZGEQRF', ' ', M, N, -1,
     $                 -1 ) )
            END IF
         END IF
      END IF
*
      IF( NB.GE.NBMIN .AND. NB.LT.K .AND. NX.LT.K ) THEN
*
*        Use blocked code initially
*
         DO 10 I = 1, K - NX, NB
            IB = MIN( K-I+1, NB )
*
*           Compute the QR factorization of the current block
*           A(i:m,i:i+ib-1)
*
            CALL ZGEQR2( M-I+1, IB, A( I, I ), LDA, TAU( I ), WORK,
     $                   IINFO )
            IF( I+IB.LE.N ) THEN
*
*              Form the triangular factor of the block reflector
*              H = H(i) H(i+1) . . . H(i+ib-1)
*
               CALL ZLARFT( 'Forward', 'Columnwise', M-I+1, IB,
     $                      A( I, I ), LDA, TAU( I ), WORK, LDWORK )
*
*              Apply H**H to A(i:m,i+ib:n) from the left
*
               CALL ZLARFB( 'Left', 'Conjugate transpose', 'Forward',
     $                      'Columnwise', M-I+1, N-I-IB+1, IB,
     $                      A( I, I ), LDA, WORK, LDWORK, A( I, I+IB ),
     $                      LDA, WORK( IB+1 ), LDWORK )
            END IF
   10    CONTINUE
      ELSE
         I = 1
      END IF
*
*     Use unblocked code to factor the last or only block.
*
      IF( I.LE.K )
     $   CALL ZGEQR2( M-I+1, N-I+1, A( I, I ), LDA, TAU( I ), WORK,
     $                IINFO )
*
      WORK( 1 ) = IWS
      RETURN
*
*     End of ZGEQRF
*
      END
c $Id: zgeqrf.f 24343 2013-06-22 05:35:15Z d3y133 $

c
c $Id: psp_formatter.F 23206 2012-12-01 02:30:26Z bylaska $
c

*     ***************************************
*     *	  				    *
*     *		   psp_formatter	    *
*     *					    *
*     ***************************************

      logical function psp_formatter(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
c
      integer rtdb
      logical      value

      integer taskid,MASTER
      parameter (MASTER=0)

*     ***** rtdb variables *****
      real*8        rlocal
      integer       l
      integer	    locp,lmax
      character*50  cell_name,psp_filename,formatted_filename
      character*50  rtdb_unita
      character*50  rtdb_ngrid
      character*50  rtdb_boundry
      integer       ia,kn,kbpp_len,kbpp_number
      character*50  rtdb_name,kbpp_name

*     ***** simulation cell  variables *****
      character*50     boundry
      double precision unita(3,3)
      integer          ngrid(3)

*     ***** external functions *****
      logical  kbppv3,kbppv3_stress
      external kbppv3,kbppv3_stress

      taskid = ga_nodeid()
      value  = .true.
*     **** read kbpp_number ***
      if(.not. rtdb_get(rtdb,'kbpp_number',mt_int,1,kbpp_number))
     >    call errquit(
     >       'psp_formatter: kbpp_number not read', 0, RTDB_ERR)


*     **** loop over kbpp_number ****
      do kn = 1,kbpp_number
*       **** define kbpp_name  - not very elegent and could break if ****
*       ****                     kbpp_number becomes very large      **** 
        ia        = ICHAR('a')
        kbpp_name = 'kbpp'//CHAR(kn-1+ia)
        kbpp_len  = index(kbpp_name,' ') - 1
        if (taskid.eq.MASTER) then
         write(*,*) 
         write(*,*) 'Formatting rtdb psp inputblock: ',kbpp_name
         write(*,*) '   ',kn,' of ',kbpp_number
         write(*,*) 
        end if



      rtdb_name = kbpp_name(1:kbpp_len)//':locp'
      value = rtdb_get(rtdb,rtdb_name,
     >                  mt_int,1,locp)

      rtdb_name = kbpp_name(1:kbpp_len)//':lmax'
      value = value.and.rtdb_get(rtdb,rtdb_name,
     >                  mt_int,1,lmax)

      rtdb_name = kbpp_name(1:kbpp_len)//':rlocal'
      value = value.and.rtdb_get(rtdb,rtdb_name,
     >                  mt_dbl,1,rlocal)

      rtdb_name = kbpp_name(1:kbpp_len)//':cell_name'
      value = value.and.rtdb_cget(rtdb,rtdb_name,
     >                  1,cell_name)

      rtdb_name = kbpp_name(1:kbpp_len)//':psp_filename'
      value = value.and.rtdb_cget(rtdb,rtdb_name,
     >                  1,psp_filename)

      rtdb_name = kbpp_name(1:kbpp_len)//':formatted_filename'
      value = value.and.rtdb_cget(rtdb,rtdb_name,
     >                  1,formatted_filename)

      l = index(cell_name,' ') - 1
      rtdb_unita   = cell_name(1:l)//':unita'
      rtdb_ngrid   = cell_name(1:l)//':ngrid'
      rtdb_boundry = cell_name(1:l)//':boundry'

      value = value.and.rtdb_get(rtdb,rtdb_unita,mt_dbl,9,unita)
      value = value.and.rtdb_get(rtdb,rtdb_ngrid,mt_int,3,ngrid)
      value = value.and.rtdb_cget(rtdb,rtdb_boundry,1,boundry)


      l = index(boundry,' ') - 1

*     ***** run Periodic code *****
      if (boundry(1:l).eq.'periodic') then
         value = value.and.
     >     kbppv3(.true.,3,psp_filename,formatted_filename,ngrid,unita,
     >            locp,lmax,rlocal)

*     ***** run APeriodic code *****
      else if (boundry(1:l).eq.'aperiodic') then
         value = value.and.
     >     kbppv3(.true.,4,psp_filename,formatted_filename,ngrid,unita,
     >            locp,lmax,rlocal)
      else
         write(*,*) "unknown boundry type: ",boundry(1:l)
      end if

*     *** exit if error found ***
      if(.not. value) call errquit('psp_formatter: error',0,
     &       UNKNOWN_ERR)

      end do
*     **** end kbpp_number loop ***

      psp_formatter = value
      return
      end


*     ***************************************
*     *                                     *
*     *		psp_formatter_auto          *
*     *                                     *
*     ***************************************
      subroutine psp_formatter_auto(atom)
      implicit none
      character*4  atom

#include "errquit.fh"

*     ***** local variables *****
      logical       value
      integer       i,j,l
      integer	    locp,lmax
      character*50  psp_filename,formatted_filename
      character*5   element
      real*8        rlocal

*     ***** simulation cell  variables *****
      double precision unita(3,3)
      integer          ngrid(3),version,psp_type

*     ***** external functions *****
      integer      control_version
      integer      control_ngrid
      real*8       control_unita
      logical      kbppv3d,kbppv3e,hghppv1,pawppv1,nwpw_filefind
      external     control_version
      external     control_ngrid
      external     control_unita
      external     kbppv3d,kbppv3e,hghppv1,pawppv1,nwpw_filefind


*     **** get lmax,locp,and rlocal from psp library ****
      lmax  = -1
      locp  = -1
      rlocal = 1.0d0

*     **** define psp_filename and formatted_filename ****
      element = '     '
      element = atom
      l = index(element,' ') - 1
      psp_filename       = element(1:l)//'.psp'
      formatted_filename = element(1:l)//'.vpp'

*     **** generate one-dimensional pseudopotential file ****
      if (.not.nwpw_filefind(psp_filename)) then
         call psp_generator_auto(1,atom,lmax,locp,rlocal)

*     **** get lmax,locp,and rlocal from rtdb ****
      else
         call control_pspparameters(atom,lmax,locp,rlocal)
      end if


*     **** cell information ****
      version = control_version()
      do i=1,3
         ngrid(i) = control_ngrid(i)
         do j=1,3
           unita(i,j) = control_unita(i,j)
         end do
      end do

      call get_psp_type(psp_filename,psp_type)

      if ((psp_type.eq.0).or.(psp_type.eq.9)) then
         value = kbppv3d(.false.,
     >            version,psp_filename,formatted_filename,ngrid,unita,
     >            locp,lmax,rlocal)
      else if (psp_type .eq.1) then
         value = hghppv1(.false.,
     >            version,psp_filename,formatted_filename,ngrid,unita,
     >            rlocal)
      else if (psp_type.eq.2) then
         value = kbppv3e(.false.,
     >            version,psp_filename,formatted_filename,ngrid,unita,
     >            locp,lmax,rlocal)
      else if ((psp_type.eq.4).or.(psp_type.eq.6)) then
         value = pawppv1(.false.,
     >            version,psp_filename,formatted_filename,ngrid,unita,
     >            locp,lmax,rlocal)
      else 
         value = .false.
      end if


*     *** exit if error found ***
      if(.not. value) call errquit('psp_formatter_auto: error',0,
     >       UNKNOWN_ERR)

      return
      end

c $Id: intd_init.F 23308 2012-12-19 17:08:41Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Initialize the integral derivative drivers
C>
C> This is the main initialization routine for integral derivatives.
C> Default memory requirements, accuracy thresholds, and other 
C> initializations for all base integral codes are set here. 
C> This routine will read (from the rtdb) any integral 
C> settings changed by the user.
C>
c:tex-%API Initialization and Termination Routines
c:tex-\subsection{intd\_init}
c:tex-This is the main initialization routine for integral derivatives.
c:tex-Default memory requirements, accuracy thresholds, and other 
c:tex-initializations for all base integral codes are set here. 
c:tex-This routine will read (from the rtdb) any integral 
c:tex-settings changed by the user.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine intd_init(rtdb,nbas,bases)
c:tex-\end{verbatim}
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "apiP.fh"
#include "rtdb.fh"
#include "candoP.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "util.fh"
#include "rel_consts.fh"
c
c This routine is a wrapper around the original intd_init which is now
c called intd_init_org. The reason for this extension is related to the
c basis set use in Douglas-Kroll. Douglas-Kroll uses a fitting basis
c set, which could be larger (# of exponents but also higher angular
c momenta), which also needs to be included in the initialization
c procedure. The wrapper sets the Douglas-Kroll stuff and adds the new
c fitting basis set to the list of active basis sets and calls
c intd_init_org.
c
c::passed
c:tex-\begin{verbatim}
      integer rtdb        !< [Input] run time data base handle
      integer nbas        !< [Input] number of basis sets to be used
      integer bases(nbas) !< [Input] basis set handles
c:tex-\end{verbatim}
c::local
      integer mybm_a, mybIm_a, ibas, nrbas     ! Temporary variables
      character*255 dk_bas_name, dk_trans_name ! strings used for Douglas-Kroll
c
c   Dyall-modified Dirac equation
c
      if (.not. rtdb_get(rtdb,'dyall_mod_dir',mt_log,1,dyall_mod_dir))
     &    dyall_mod_dir = .false.
      if (.not. rtdb_get(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
     &    atomic_nesc = .false.
      if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,nesc_1e_approx))
     &    nesc_1e_approx = .false.
      if (.not. rtdb_get(rtdb,'ss_one_cent',mt_log,1,ss_one_cent))
     &    ss_one_cent = .false.
      if (.not. rtdb_get(rtdb,'do_ssss',mt_log,1,do_ssss)) 
     &    do_ssss = .false.
c
c     Setup array with basis sets from bases
c
      if (.not. ma_push_get(MT_INT,nbas+1,'mybases',mybm_a,mybIm_a))
     $     call errquit('int_init: ma_push_get failed mybases',0,
     &           INT_ERR)
      do 00500 ibas = 1, nbas
         int_mb(mybIm_a+ibas-1) = bases(ibas)
00500 continue
      nrbas = nbas
c
c Initialize the Douglas-Kroll variables
c
c form_type: 1. Free-particle projection operators
c            2. External potential projection operators without pxVp integrals
c            3. Complete spin-free Douglas-Kroll (i.e. including pxVp)
c
      if (.not. rtdb_get(rtdb,'doug_kroll',MT_LOG,1,doug_kroll))
     $    doug_kroll = .false.
      if (doug_kroll) then
c
c        Which form of Douglas-Kroll has to be done, default = 2
c
         if (.not. rtdb_get(rtdb,'doug_kroll:type',MT_INT,1,
     $      dk_form_type)) dk_form_type = 2
c
c        If one want one can specify an even tempered basis as fitting basis
c
         if (.not. rtdb_get(rtdb,'doug_kroll:eventemp',MT_LOG,1,
     $      dk_even_bas)) dk_even_bas = .false.
         if (.not. rtdb_get(rtdb,'doug_kroll:etratio',MT_DBL,1,
     $      dk_ratio)) dk_ratio = 2.0d0
c
c        Generate the fitting basis set and add it to the list of
c        used basis sets
c
         do 00400 ibas = 1, nbas
            if (.not. bas_name(bases(ibas),dk_bas_name,dk_trans_name))
     $         call errquit('int_init: failed in bas_name',0, INT_ERR)
            if (dk_bas_name(1:8) .eq. 'ao basis') goto 00004
00400    continue
         call errquit('int_init: could not find ao basis',0, BASIS_ERR)
00004    call bas_create_uncont(rtdb,bases(ibas),'auto D-K basis',
     $      dk_fitbas)
c
c        Add fitting basis set to list of loaded basis sets for int_init
c
         int_mb(mybIm_a+nbas) = dk_fitbas
         nrbas = nrbas + 1
      endif
      if (doug_kroll .or. dyall_mod_dir) call rel_init_con (rtdb)
      call intd_init_org(rtdb, nrbas, int_mb(mybIm_a))
      if (.not. ma_pop_stack(mybm_a))
     $     call errquit('int_init: ma_pop_stack mybm_a',0, MA_ERR)
c
      end
c
      subroutine intd_init_org(rtdb, nbas, bases)
c
c Initializes integral derivative code 
c
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "apiP.fh"
#include "rtdb.fh"
#include "candoP.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "util.fh"
c::functions
      logical  spcart_init
      external spcart_init
      logical  int_ecp_init
      external int_ecp_init
      logical  int_rel_init
      external int_rel_init
      logical  texas_check_basis_ok
      external texas_check_basis_ok
c::passed
      integer rtdb        ! [input] run time data base handle
      integer nbas        ! [input] number of basis sets to be used
      integer bases(nbas) ! [input] basis set handles
c::local
      integer ibas, ang2use, angm
      logical status, oprint
      integer intd_memtmp
      integer nqmax_texas  ! maximum number of quartets in texas blocking interface
      parameter (nqmax_texas = 10000)
      integer txs_mem_min
      integer type
      logical cando_txs_deriv
c
c
c     print info/warnings unless print set to none. errors always print.
c
      oprint = util_print('information',print_low)

*      call int_init(nbas,bases)
c
      call int_mem_zero()
c
      DCexp     = 0.0D00
      DCcoeff   = 1.0D00
      val_int_acc = 0.0d00
c
      if(init_intd.eq.1 .and. oprint) then
        write(luout,*)' warning nested intd_inits'
        write(luout,*)' intd_init already called '
        call util_flush(6)
      endif
c
c initialize type-> nbf maps
c
      int_nbf_x(-1) = 4
      int_nbf_s(-1) = 4
      do type = 0,int_nbf_max_ang
        int_nbf_x(type) = (type+1)*(type+2)/2
        int_nbf_s(type) = 2*type+1
      enddo
c
cTEMPORARY WORKAROUND check for derivative flag intd:cando_txs
c
      cando_txs_deriv = .true.
      if (rtdb_get(rtdb,'intd:cando_txs',MT_LOG,1,status))
     $     cando_txs_deriv = status
      if (.not.cando_txs_deriv) then
         call int_app_set_no_texas(rtdb)
      endif
c
c initialize cando information from rtdb
c
      user_cando_sp   = .false.
      user_cando_nw   = .false.
      user_cando_txs  = .false.
      user_cando_hnd  = .false.
      def_cando_sp    = .false.
      def_cando_nw    = .false.
      def_cando_txs   = .false.
      def_cando_hnd   = .false.
c
      if (rtdb_get(rtdb,'int:cando_sp',MT_LOG,1,status)) then
        user_cando_sp = .true.
        def_cando_sp  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' intd_init: cando_sp set to always be ',def_cando_sp
          call util_flush(6)
        endif
      endif
c
      if (rtdb_get(rtdb,'int:cando_nw',MT_LOG,1,status)) then
        user_cando_nw = .true.
        def_cando_nw  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' intd_init: cando_nw set to always be ',def_cando_nw
          call util_flush(6)
        endif
      endif
c
      if (rtdb_get(rtdb,'int:cando_txs',MT_LOG,1,status)) then
        user_cando_txs = .true.
        def_cando_txs  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' intd_init: cando_txs set to always be ',def_cando_txs
          call util_flush(6)
        endif
      endif
c
      if (rtdb_get(rtdb,'int:cando_hnd',MT_LOG,1,status)) then
        user_cando_hnd = .true.
        def_cando_hnd  = status
        if (ga_nodeid().eq.0 .and. oprint) then
          write(luout,*)
     &        ' intd_init: cando_hnd set to always be ',def_cando_hnd
          call util_flush(6)
        endif
      endif
*
      if (.not.user_cando_txs) then
        if (.not.texas_check_basis_ok(nbas,bases)) then
          user_cando_txs = .true.
          def_cando_txs = .false.
          if (ga_nodeid().eq.0 .and. oprint) then
            write(luout,*)
     &          ' intd_init: internal texas instability possible cando',
     &          '_txs set to always be ',def_cando_txs
            call util_flush(6)
          endif
        endif
      endif
* sanity checking: e.g., you only want to turn off a particular integral
* code never always turn it on.
*
      if (def_cando_sp.or.def_cando_nw.or.def_cando_txs.or.
     &    def_cando_hnd) then
        if (ga_nodeid().eq.0) then
          write(luout,*)' you are trying to turn an integral code on? '
          write(luout,*)' sp  ', def_cando_sp
          write(luout,*)' nw  ', def_cando_nw
          write(luout,*)' txs ', def_cando_txs
          write(luout,*)' hnd ', def_cando_hnd
          call util_flush(6)
        endif
        call errquit
     &      ('intd_init: logic error with user cando settings',911, 
     &         INT_ERR)
      endif
      status = .true.
      do 00100 ibas=1,nbas
        status = status .and. bas_check_handle(bases(ibas),'intd_init')
00100 continue
      if (.not.status) then
        write(luout,*)' at least one basis handle not valid'
        do 00200 ibas = 1,nbas
          write(luout,'(a,i5)')
     &           ' basis set handle ',bases(ibas)
00200   continue
        call errquit('intd_init: basis handles hosed ',nbas, BASIS_ERR)
      endif
*      write(luout,*)' intd_init: basis set handles valid '
c
c check for both sp and gc shells
c
      call int_bothsp_gc_check(bases,nbas,'intd_init')
c
c initialize defnxyz routines
c      
      ang2use = -1
      do 00300 ibas = 1,nbas
        if(.not.bas_high_angular(bases(ibas),angm))
     &         call errquit('intd_init: angm error',angm, INT_ERR)
        ang2use = max(ang2use,angm)
        if (dyall_mod_dir) then
          if(.not.bas_rel_high_ang(bases(ibas),angm))
     &        call errquit('int_init: angm error',angm, INT_ERR)
          ang2use = max(ang2use,angm+1)
        end if
00300 continue
*
* test for higher than h functions  0123456
      if (ang2use.ge.8) call errquit
     &    ('only basis sets with s through h functions are allowed',
     &    911 , INT_ERR)
*
c.. for first derivatives add 1
      call defNxyz(ang2use+1)
c
c initialize spcart stuff 
c
      if (.not.(spcart_init((ang2use+1),.true.,.false.))) then
        call errquit('intd_init: spcart_init failed',911, INT_ERR)
      endif
c
c Initialize DmD relativistic basis set stuff
c
      if (dyall_mod_dir) then
        if (.not. int_rel_init(rtdb,nbas,bases)) call errquit
     &      ('int_init: int_rel_init failed ',911, INT_ERR)
        if (.not. nesc_1e_approx) then
          user_cando_sp   = .true.
          def_cando_sp   = .false.
          user_cando_txs = .true.
          def_cando_txs  = .false.
          if (ga_nodeid().eq.0 .and. oprint) then
            write(luout,*) ' intd_init: cando_sp and cando_txs',
     &          ' turned off for NESC2E'
            call util_flush(luout)
          end if 
        end if
      end if
c
c.. read in approximate memory from rtdb
c.  
c.. parameter is default value used in hf2d
c.. input memory in words should be scaled by 1/12 for same range
      intd_memthresh = intd_memp
      if (rtdb_get(rtdb,'intd:approxmem',MT_INT,1,intd_memtmp)) then
        if(ga_nodeid().eq.0)then
          write(luout,'(/a,i10,a/)')
     &        ' approximate memory for derivative integrals set to:',
     &        intd_memtmp
        endif
        intd_memthresh = intd_memtmp/12
      endif
c
c... generate memory requirements and store in structures in apiP.fh
c
      call exactd_mem(rtdb,bases,nbas)
      call sp_der_init(nbas,bases)
      call int_acc_std()
      if (.not.(user_cando_txs.and.(.not.def_cando_txs))) then
         call texas_init(rtdb,nbas,bases,nqmax_texas,txs_mem_min,
     &        'der1_int')
      endif
      call hnd_initd(bases,nbas)
c
c See if any basis has an attached ECP
c
      any_ecp = .false.
      ecp_bsh = 0
      do ibas = 1,nbas
        if (bas_get_ecp_handle(bases(ibas),ecp_bsh)) then
          any_ecp = .true.
          goto 00001
        endif
      enddo
00001 continue
      if (any_ecp) then
        if (.not.ecp_check_handle(ecp_bsh,'intd_init')) call errquit
     &        ('intd_init: ecp handle is invalid fatal error',911,
     &          INT_ERR)
      endif
*
c See if any basis has an attached SO potential
      any_so = .false.
      so_bsh = 0
      do ibas = 1,nbas
        if (bas_get_so_handle(bases(ibas),so_bsh)) then
          any_so = .true.
          goto 00002
        endif
      enddo
00002 continue
      if (any_so) then
        if (.not.so_check_handle(so_bsh,'intd_init')) call errquit
     &        ('intd_init: so handle is invalid fatal error',911,
     &          INT_ERR)
      endif
      if (any_so.or.any_ecp) then
        if (.not.int_ecp_init(ecp_bsh,so_bsh,1)) call errquit
     &        ('intd_init: int_ecp_init failed ',911, INT_ERR)
      endif
      init_int = 1
      init_intd = 1
      end
      subroutine sp_der_init(nbas,bases)
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "apispP.fh"
#include "bas.fh"
#include "mafdecls.fh"
c
c:: functions
      logical api_is_ecp_basis
      external api_is_ecp_basis
c::passed
      integer nbas
      integer bases(nbas)
c::local
      integer ncont,icont,ibas
      integer mytype,nprim,ngen,sphorcart
c
      no_sp_conts = .true.
      do 00100 ibas = 1,nbas
        if (.not.api_is_ecp_basis(bases(ibas))) then
          if (.not.bas_numcont(bases(ibas),ncont))
     &        call errquit('sp_der_init: bas_numcont failed',911,
     &              INT_ERR)
          do 00200 icont = 1,ncont
            if(.not.bas_continfo
     &          (bases(ibas),icont,mytype,nprim,ngen,sphorcart))
     &          call errquit('sp_der_init: bas_continfo failed',911,
     &              INT_ERR)
            
            if (mytype.lt.0) then
              no_sp_conts = .false.
              goto 00201
            endif
00200     continue
        endif
00100 continue
00201 continue
c
      if (no_sp_conts) return
c
      write(luout,*)' sp functions cannot be used in the integral ',
     &       'derivative code yet'
      call errquit('sp_der_init',911, INT_ERR)
      end

C> @}

      subroutine argos_diana_preadframe(x,w,t)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer ftell
      external ftell
      real*8 x(msa,3),w(mwm,mwa,3),t(6)
      integer i,j,k
      real*8 timp
      integer inwm,inwa
c
      read(lfntrj,1000,err=9999,end=9998) card
 1000 format(a)
      if(card(1:5).ne.'frame')
     + call md_abort('Could not find frame',0)
      read(lfntrj,1001,err=9999,end=9998) timp,temp,pres,datum,tijd
 1001 format(2f12.6,e12.5,2a10)
      t(1)=timp
      t(2)=temp
      t(3)=pres
      read(lfntrj,1000) card
      if(card(54:54).eq.'.') then
      read(card,1012) box
 1012 format(f12.6,36x,f12.6,36x,f12.6)
      else
      read(card,1002) box(1)
 1002 format(f12.6)
      read(lfntrj,1022) box(2),box(3)
 1022 format(12x,f12.6,/,24x,f12.6)
      endif
      t(4)=box(1)
      t(5)=box(2)
      t(6)=box(3)
      read(lfntrj,1000) card
      if(card(8:8).eq.'F'.or.card(8:8).eq.'T') then
      read(card,1006) lxw,lvw,lfw,lpw,lsx,lsv,lfs,lps,inwm,inwa,nsa
      elseif(card(6:6).eq.'F'.or.card(6:6).eq.'T') then
      read(card,1007) lxw,lvw,lfw,lsx,lsv,lfs,inwm,inwa,nsa
      lpw=.false.
      lps=.false.
      else
      read(card,1003) lxw,lvw,lsx,lsv,inwm,inwa,nsa
      lfw=.false.
      lfs=.false.
      endif
      if(inwm.gt.0) then
      nwm=inwm
      nwa=inwa
      endif
      if(nwm.gt.mwm)
     + call md_abort('Restart file not compatible with trajectory',nwm)
 1003 format(4l1,3i10,2l1)
 1006 format(8l1,3i10)
 1007 format(6l1,3i10)
      if(nsa.gt.msa) call md_abort('Error in trj 1',0)
      if((lxw.or.lvw).and.nwm.gt.0) then
      do 2 i=1,nwm
      do 3 j=1,nwa
      read(lfntrj,1004) (w(i,j,k),k=1,3)
 1004 format(3f8.3)
    3 continue
    2 continue
      endif
      if(lsx.and.nsa.gt.0) then
      do 4 i=1,nsa
      read(lfntrj,1005) (x(i,j),j=1,3)
 1005 format(3f8.3)
    4 continue
      endif
c
      return
 9998 continue
      call md_abort('EOF in argos_diana_preadfram',me)
 9999 continue
      call md_abort('Error in argos_diana_preadfram',me)
      return
      end
c $Id: argos_diana_preadframe.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine scf_lindep(rtdb, geom, basis, g_u, n_indep)
c     $Id: scf_lindep.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "bas.fh"
#include "rtdb.fh"
#include "util.fh"
      integer rtdb, geom, basis ! [input] Handles
      integer g_u              ! [input] GA handle for output vectors
      integer n_indep          ! [output] No. of linearly indep vectors
c
c     Return in g_u the linearly independent eigenvectors of the overlap
c     matrix in the given basis.  Note that these vectors are orthonormal
c     over the standard inner product, but are NOT orthonormal over the
c     overlap matrix.
c
c     n_indep returns the number of vectors
c
c     To project a set of MOs C into the linearly independent space 
c     use U * UT * C.
c
      integer n_dep            ! No. of dependent vectors
      double precision tol_default, tol
      parameter (tol_default = 1d-5)
c
      logical oprint
      integer g_over
      integer l_ev, k_ev
      integer i, j, nbf
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
c
      oprint = util_print('lindep', print_default) .and. 
     $      ga_nodeid().eq.0
c
c     Make and diag the overlap matrix
c
       if (.not. bas_numbf(basis, nbf)) 
     $      call errquit('scf_lin: bad basis?',0, BASIS_ERR)
       if (.not. ma_push_get(MT_DBL, nbf, 'Evals', l_ev, k_ev))
     $      call errquit('scf_lindep: push of evals failed', nbf,
     &       MA_ERR)
       g_over  = ga_create_atom_blocked(geom, basis,'Temp Over')
c
       call ga_zero(g_over)
       call int_1e_ga(basis, basis, g_over, 'overlap', .false.)
       if (util_print('ao overlap', print_debug))
     $      call ga_print(g_over)
c
#ifdef PARALLEL_DIAG
#ifdef SCALAPACK
       call ga_pdsyev(g_over, g_u, dbl_mb(k_ev), 0)
#else
       call ga_diag_std(g_over, g_u, dbl_mb(k_ev))
#endif
#else
       call ga_diag_std_seq(g_over, g_u, dbl_mb(k_ev))
#endif
c
c     Get user input parameters ... only one allowed
c
c     lindep:n_dep  ... force number of linearly dep vectors vectors
c     lindep:tol    ... tolerance 
c
       if (rtdb_get(rtdb, 'lindep:n_dep', mt_int, 1, n_dep)) then
          if (oprint) then
             write(6, 2) n_dep
 2           format(/' Forcing the number of linearly dependent ',
     $            'vectors to be', i3)
             call util_flush(6)
          endif
       else
          n_dep = -1
       endif
       if (rtdb_get(rtdb, 'lindep:tol', mt_dbl, 1, tol)) then
          if (oprint) then
             write(6, 3) tol
 3           format(/' Setting tolerance for linear dependence to',
     $            1p,d9.2)
             call util_flush(6)
          endif
       else
          tol = -1.0d0
       endif
c
       if ((tol.ne.-1.0d0) .and. (n_dep.ne.-1)) call errquit
     $      ('scf_lindep: only one of n_dep and tol permitted',0,
     &       UNKNOWN_ERR)
c
c     Determine linearly independent set
c
       if (n_dep .eq. -1) then
          if (tol .eq. -1.0d0) tol = tol_default
          do i = 0, nbf-1
             if (dbl_mb(k_ev+i).gt.tol) goto 333
          enddo
 333      n_dep = i
       endif
c
       if (n_dep.gt.0 .and. oprint .and. ga_nodeid().eq.0) then
          write(6,334) n_dep
 334      format(/' !! The overlap matrix has ',i3,' vectors deemed ',
     $         'linearly dependent with'/'    eigenvalues:')
          write(6,33) (dbl_mb(k_ev+j),j=0,n_dep-1)
 33       format(1p,8d9.2)
          write(6,*)
          call util_flush(6)
       endif
c
c     Move the linearly independent vectors down to the beginning
c     of the vector set
c
       if (n_dep.gt.0 .and. ga_nodeid().eq.0) then
          do i = 1, n_dep
             j = nbf - i + 1
             call ga_get(g_u, 1, nbf, j, j, dbl_mb(k_ev), 1)
             call ga_put(g_u, 1, nbf, i, i, dbl_mb(k_ev), 1)
          enddo
       endif
       call ga_sync
c
       n_indep = nbf - n_dep
c
       if (.not. ga_destroy(g_over)) call errquit
     $      ('scf_lindep: destroy of over?', 0, GA_ERR)
       if (.not. ma_pop_stack(l_ev)) call errquit
     $      ('scf_lindep: destroy of ev?', 0, MA_ERR)
c
       end

      logical function rohf_diis_solve(rtdb, energy, eone, etwo, enrep)
C     $Id: rohf_diis.F 19987 2011-02-21 22:02:51Z edo $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "crohf.fh"
#include "pstat.fh"
#include "cscfps.fh"
#include "util.fh"
#include "cscf.fh"
#include "cosmo.fh"
c     
c     Solve the ROHF equations using DIIS
c     
c     Arguments
c     
      integer rtdb
      double precision energy                  ! Return ROHF energy
      double precision eone, etwo, enrep       ! Return ROHF energy contribs
c
      integer DFLT_MAX_DIIS_BAS
      parameter(DFLT_MAX_DIIS_BAS=5)
c     
c     Local GA handles 
c     
      integer g_fock
      integer g_xorth
      integer g_tmp
      integer g_tmp2
      integer g_gdiis
      integer g_grad
      integer g_over
      integer g_err
c     
c     Local variables
c     
      double precision gnorm                   ! measures for convergence
      double precision diis_emax
      logical converged, odo_diis
      integer vlen, ndiis
      integer voff, aoff, aend
      logical oprint_parm
      integer mxdiisbas
c     
c     Functions
c     
      integer ga_create_atom_blocked,g_oexch,g_cfock
      external ga_create_atom_blocked, ga_iter_lsolve
c
c     cosmo code
c
      logical odbug
      logical osome
      double precision ecosmo
c
      double precision egas
      double precision esol
c
      integer itype_wfn
c     
      vlen = crohf_vlen
      aoff = nclosed + 1
      aend = nclosed + nopen
      voff = nclosed + nopen + 1
c
      odbug=.false.
      if(odbug) then
         write(6,*) 'in rohf_diis_solve ... with node id =',
     $              ga_nodeid()
      endif
c
      oprint_parm = util_print('parameters', print_default)
      if (.not.rtdb_get(rtdb,'scf:diisbas',MT_INT, 1, mxdiisbas ))
     $   mxdiisbas = DFLT_MAX_DIIS_BAS
c
c   Print info
c
      if (ga_nodeid().eq.0.and. oprint_parm) then
         write(6,1) gnorm_tol, maxiter, tol2e, mxdiisbas
         write(6,111)
 1       format(//,
     $        1x,'----------------------------------------------',/
     $        1x,'               DIIS ROHF',//,
     $        1x,'Convergence threshold     :',9x,1p,e10.3,0p,/,
     $        1x,'Maximum no. of iterations :',9x,i4,/,
     $        1x,'Integral*density screening:',9x,1p,e10.3,0p,/,
     $        1x,'DIIS subspace             :',9x,i4,/)
 111     format(
     $        1x,'----------------------------------------------',/)
         call util_flush(6)
      endif
c     
c     Allocate global arrays.  
c     
*ga:1:0
      if (.not. ga_create(MT_DBL, vlen, 1, 'diis:grad', 0, 0, g_grad))
     $     call errquit('diis:grad', 0, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, (nbf*nbf), (2*mxdiisbas),
     $     'diis:basis', 0, 0, g_gdiis)) call errquit('diis: work', 0,
     &       GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, nbf, nbf, 'rohf_diis_solve:fock',
     $     0, 0, g_fock)) call
     $     errquit('rohf_diis_solve: ga failed for fock', 0, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, nbf, nbf, 'rohf_diis_solve:over',
     $     0, 0, g_over)) call
     $     errquit('rohf_diis_solve: ga failed for over', 0, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, nbf, nbf, 'rohf_diis_solve:xorth',
     $     0, 0, g_xorth)) call
     $     errquit('rohf_diis_solve: ga failed for xorth', 0, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, nbf, nbf, 'rohf_diis_solve:tmp',
     $     0, 0, g_tmp)) call
     $     errquit('rohf_diis_solve: ga failed for tmp', 0, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, nbf, nbf, 'rohf_diis_solve:tmp2',
     $     0, 0, g_tmp2)) call
     $     errquit('rohf_diis_solve: ga failed for tmp2', 0, GA_ERR)
*ga:1:0
      if (.not. ga_create(MT_DBL, (nbf*nbf), 1, 'rohf_diis_solve:err',
     $     0, 0, g_err)) call
     $     errquit('rohf_diis_solve: ga failed for error', 0, GA_ERR)
c
c  Generate overlap and orthonormalization matrix
c
      call ga_zero(g_over)
      call int_1e_ga( basis, basis, g_over, 'overlap', .false. )
      call rohf_ao_orthonorm( nbf, g_over, g_xorth )
      call ga_sync()
c
 1000 continue
c     
c  SCF-DIIS loop
c
      converged = .false.
      ndiis = 0
      call ga_zero(g_err)
      do iter=1,maxiter
        call rohf_energy( g_movecs, eone, etwo, enrep, energy, g_grad,
     $                    rtdb)
c
c   Check convergence
c
        gnorm = sqrt(ga_ddot(g_grad, g_grad))
        converged = (gnorm.lt.gnorm_tol)
        if (converged) goto 333
        call rohf_get_fock( g_fock )
c
c   Recover AO Fock matrix
c
c                  t
c   F   =  S.C.F  C.S
c    ao         mo
c
        call ga_dgemm( 'n', 't', nbf, nbf, nbf, 1.d0, g_fock,
     $                 g_movecs, 0.d0, g_tmp )
        call ga_dgemm( 'n', 'n', nbf, nbf, nbf, 1.d0, g_tmp,
     $                 g_over, 0.d0, g_fock )
        call ga_dgemm( 'n', 'n', nbf, nbf, nbf, 1.d0, g_movecs,
     $                 g_fock, 0.d0, g_tmp )
        call ga_dgemm( 'n', 'n', nbf, nbf, nbf, 1.d0, g_over,
     $                 g_tmp, 0.d0, g_fock )
c
c   DIIS Error vector
c
        call rohf_errvec( g_fock, g_movecs, g_over, g_xorth,
     $                    g_tmp, g_tmp2, g_err )
        call ga_maxelt( g_err, diis_emax )
c
c   Print energy
c
        if(iter.eq.1) then
           if(cosmo_on.and.cosmo_phase.eq.1) then
              if(ga_nodeid().eq.0) write(6,909)
           else
              if(ga_nodeid().eq.0) write(6,910)
           endif
        endif
 909    format(2x,'   COSMO gas phase')
 910    format(2x,'   COSMO solvation phase')
c
        if(ga_nodeid().eq.0) then
           write(6,911) iter, ndiis, energy, gnorm, diis_emax
        endif
 911    format(5x,i5,i3,5x,f20.12,5x,2e10.2)
c
c   DIIS extrapolation
c
        odo_diis = (diis_emax.lt.0.5d0)
        call rohf_diis( nbf, iter, ndiis, g_err, g_gdiis,
     $                  g_fock, odo_diis )
c
c   Diagonalize
c
#if defined(PARALLEL_DIAG)
#ifdef SCALAPACK
        call ga_pdsygv(g_fock,g_over, g_tmp, dbl_mb(k_eval))
#else
        call ga_diag( g_fock, g_over, g_tmp, dbl_mb(k_eval))
#endif
#else 
        call ga_diag_seq( g_fock, g_over, g_tmp, dbl_mb(k_eval))
#endif
        call ga_copy(g_tmp, g_movecs)
      enddo
c     
c     End SCF minimisation
c     
 333  continue
      if (ga_nodeid().eq.0) call util_flush(6)
c     
c     *ALWAYS* return canonical MOs ... don't do aufbau
c     
      if (.not. ga_destroy(g_tmp)) call errquit
     $     ('rohf_diis_solve: ga_destroy tmp', 0, GA_ERR)
      if (.not. ga_destroy(g_tmp2)) call errquit
     $     ('rohf_diis_solve: ga_destroy tmp2', 0, GA_ERR)
      call rohf_canon(.false., .false.)
      call movecs_fix_phase(g_movecs)
      call scf_movecs_write(rtdb)
      if (olagr) then
         g_cfock = ga_create_atom_blocked(geom, basis, 'rohf: cfock')
         g_oexch = ga_create_atom_blocked(geom, basis, 'rohf: ocoul')
         call rohf_readfock(nopen,g_oexch,g_cfock)
         if (.not. ga_duplicate(g_movecs, g_tmp, 'scfmsa'))
     $        call errquit('rohf_lagr: gaduplicate?',0, GA_ERR)
         call two_index_transf(g_cfock, g_movecs, g_movecs, g_tmp, 
     C        crohf_g_fcv)
         
         if (nopen .gt. 0) then
            call two_index_transf(g_oexch, g_movecs, g_movecs, g_tmp, 
     C           crohf_g_fpv)
         endif
         if (.not. ga_destroy(g_oexch)) call errquit
     $        ('rohf_nr_solve: ga_destroy oexch', 0, GA_ERR)
         if (.not. ga_destroy(g_cfock)) call errquit
     $        ('rohf_nr_solve: ga_destroy cfock', 0, GA_ERR)
         if (.not. ga_destroy(g_tmp)) call errquit
     $        ('rohf_nr_solve: ga_destroy tmp', 0, GA_ERR)
         call rohf_lagr()
      endif
c
c     ----- if sol_phase=.T. go back and do solution phase -----
c
      odbug=.false.
      if(cosmo_on.and.cosmo_phase.eq.1) then
         converged =.false.
         egas      =energy
         cosmo_phase = 2
         if(odbug) then
            write(6,*) 'gas_phase done, do sol-phase now ...'
         endif
         call ga_sync()
         go to 1000
      elseif(cosmo_on.and.cosmo_phase.eq.2) then
         esol      =energy
         if(ga_nodeid().eq.0) then
            write(6,*) '                 COSMO solvation results'
            write(6,*) '                 -----------------------'
            write(6,*) 
            write(6,912) egas
            write(6,913) esol
            write(6,914) (egas-esol),(egas-esol)*627.509451d+00
 912     format('                 gas phase energy = ',f20.10)
 913     format('                 sol phase energy = ',f20.10)
 914     format(' (electrostatic) solvation energy = ',f20.10,
     $          ' (',f8.2,' kcal/mol)'                       )
         endif
      endif
      call ga_sync()
c     
c     Free globals
c     
      if (.not. ga_destroy(g_grad)) call errquit
     $     ('rohf_diis_solve: ga_destroy grad', 0, GA_ERR)
      if (.not. ga_destroy(g_fock)) call errquit
     $     ('rohf_diis_solve: ga_destroy fock', 0, GA_ERR)
      if (.not. ga_destroy(g_err)) call errquit
     $     ('rohf_diis_solve: ga_destroy err', 0, GA_ERR)
      if (.not. ga_destroy(g_gdiis)) call errquit
     $     ('rohf_diis_solve: ga_destroy gdiis', 0, GA_ERR)
      if (.not. ga_destroy(g_over)) call errquit
     $     ('rohf_diis_solve: ga_destroy over', 0, GA_ERR)
      if (.not. ga_destroy(g_xorth)) call errquit
     $     ('rohf_diis_solve: ga_destroy xorth', 0, GA_ERR)
c     
      if (ga_nodeid().eq.0) call util_flush(6)
      call ga_sync()
c     
      rohf_diis_solve = converged
c     
      end




c
c  Generic DIIS extrapolation routine
c  Cyclic storage of error-vectors and Fock matrices
c
      subroutine rohf_diis( nbf, iter, ndiis, g_err, g_bas, g_fock,
     $                      odo_diis )
      implicit none
#include "global.fh"      
      integer nbf, iter, ndiis
      integer g_err
      integer g_fock
      integer g_bas
      logical odo_diis
c
      integer mxbas, nbas, vlen, itype
      integer i, j, ij, ji
      integer info
      double precision xx(500), yy(100), tmp(100), zz
c
c  Copy new error vector to basis
c
      call ga_inquire( g_bas, itype, vlen, mxbas )
      mxbas = mxbas/2
      if (odo_diis) then
        ndiis = ndiis + 1
        i = mod( (ndiis-1), mxbas ) + 1
        nbas = min(ndiis, mxbas)
        call ga_copy_patch( 'n', g_err, 1, vlen, 1, 1,
     $                           g_bas, 1, vlen, i, i )
        call ga_copy_patch( 'n', g_fock, 1, nbf, 1, nbf,
     $                           g_bas, 1, vlen, i+mxbas, i+mxbas )
      endif
      if ((iter.le.3).or.(.not.odo_diis)) return
c
c  Construct error metric
c
      call dfill((nbas+1)*(nbas+1),-1.d0,xx,1)
      xx(1) = 0.d0
      do i=1,nbas
        do j=1,i
          zz = ga_ddot_patch( g_bas, 'n', 1, vlen, i, i,
     $                        g_bas, 'n', 1, vlen, j, j ) 
          ij = (i-1+1)*(nbas+1) + j + 1
          ji = (j-1+1)*(nbas+1) + i + 1
          xx(ij) = zz
          xx(ji) = zz
        enddo
      enddo
      call dfill((nbas+1),0.d0,yy,1)
      yy(1) = -1.d0
      call dgesv((nbas+1), 1, xx, (nbas+1), tmp, yy, (nbas+1), info)
c
c  Construct extrapolated vector
c
      call ga_zero(g_err)
      do i=1,nbas
        call ga_dadd_patch( yy(i+1), g_bas, 1, vlen, mxbas+i, mxbas+i,
     $                      1.d0,    g_err, 1, vlen, 1, 1,
     $                               g_err, 1, vlen, 1, 1 )
      enddo
      call ga_copy_patch( 'n', g_err, 1, vlen, 1, 1,
     $                         g_fock, 1, nbf, 1, nbf )
      odo_diis = .true.
      return
      end




c
c  Generate Pulay's error vector from AO fock matrix
c
c             -1/2 t             1/2
c       e = (S    ).(FDS - SDF).S
c
c
      subroutine rohf_errvec( g_fock, g_vecs, g_over, g_xorth,
     $                        g_tmp1, g_tmp2, g_err )
      implicit none
#include "global.fh"
#include "cscf.fh"
      integer g_fock
      integer g_vecs
      integer g_over
      integer g_xorth
      integer g_tmp1
      integer g_tmp2
      integer g_err
c
c  ROHF density
c
      call ga_matmul_patch( 'n', 't', 2.d0, 0.d0,
     $                       g_movecs, 1, nbf, 1, nclosed,
     $                       g_movecs, 1, nclosed, 1, nbf,
     $                       g_tmp2, 1, nbf, 1, nbf )
      if (nopen.gt.0) then
        call ga_matmul_patch( 'n', 't', 1.d0, 1.d0,
     $                       g_movecs, 1, nbf, nclosed+1, nclosed+nopen,
     $                       g_movecs, nclosed+1, nclosed+nopen, 1, nbf,
     $                       g_tmp2, 1, nbf, 1, nbf )
      endif
c
c                         t
c  FDS - SDF  =  FDS - FDS
c
      call ga_dgemm( 'n', 'n', nbf, nbf, nbf, 1.d0, g_fock,
     $               g_tmp2, 0.d0, g_tmp1 )
      call ga_dgemm( 'n', 'n', nbf, nbf, nbf, 1.d0, g_tmp1,
     $               g_over, 0.d0, g_tmp2 )
      call ga_transpose( g_tmp2, g_tmp1 )
      call ga_dadd( 1.d0, g_tmp2, -1.d0, g_tmp1, g_tmp2 )
c
c       -1/2          t   -1/2
c  e = S   .(FDS - FDS ).S
c
      call ga_dgemm( 't', 'n', nbf, nbf, nbf, 1.d0, g_xorth,
     $                g_tmp2, 0.d0, g_tmp1 )
      call ga_dgemm( 'n', 'n', nbf, nbf, nbf, 1.d0, g_tmp1,
     $                g_xorth, 0.d0, g_tmp2 )
      call ga_copy_patch( 'n', g_tmp2, 1, nbf, 1, nbf,
     $                         g_err, 1, (nbf*nbf), 1, 1)
c
c
c
      return
      end
      subroutine rohf_ao_orthonorm( nbf, g_over, g_xorth )
      implicit none
#include "errquit.fh"
c
c   Construct AO orthonormalization matrix
c   using symmetric orthogonalization.
c   Does *not* handle linear dependence, yet
c
#include "mafdecls.fh"
#include "global.fh"      
      integer nbf
      integer g_over
      integer g_xorth
c
      integer l_e, k_e, i
      double precision xx
c
      if (.not.ma_push_get(MT_DBL, nbf, 'overlap', l_e, k_e ))
     $     call errquit('rohf_ao_orthonorm: cannot allocate over',0,
     &       MA_ERR)
#if defined(PARALLEL_DIAG)
#ifdef SCALAPACK
      call ga_pdsyev(g_over, g_xorth, dbl_mb(k_e), 0)
#else
      call ga_diag_std( g_over, g_xorth, dbl_mb(k_e))
#endif
#else 
      call ga_diag_std_seq( g_over, g_xorth, dbl_mb(k_e))
#endif
c               1/2
c   X   = U  / s
c    ij    ij   j
c
      do i=ga_nodeid()+1,nbf,ga_nnodes()
        xx = 1.d0/sqrt(dbl_mb(k_e+i-1))
        call ga_dscal_patch( g_xorth, 1, nbf, i, i, xx )
      enddo
c
c
c
      if (.not.ma_pop_stack(l_e))
     $     call errquit('rohf_ao_orthonorm: cannot pop stack',0,
     &       MA_ERR)
      return
      end

*> \brief \b SGEBAK
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SGEBAK + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sgebak.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sgebak.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sgebak.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGEBAK( JOB, SIDE, N, ILO, IHI, SCALE, M, V, LDV,
*                          INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          JOB, SIDE
*       INTEGER            IHI, ILO, INFO, LDV, M, N
*       ..
*       .. Array Arguments ..
*       REAL               V( LDV, * ), SCALE( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGEBAK forms the right or left eigenvectors of a real general matrix
*> by backward transformation on the computed eigenvectors of the
*> balanced matrix output by SGEBAL.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] JOB
*> \verbatim
*>          JOB is CHARACTER*1
*>          Specifies the type of backward transformation required:
*>          = 'N', do nothing, return immediately;
*>          = 'P', do backward transformation for permutation only;
*>          = 'S', do backward transformation for scaling only;
*>          = 'B', do backward transformations for both permutation and
*>                 scaling.
*>          JOB must be the same as the argument JOB supplied to SGEBAL.
*> \endverbatim
*>
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'R':  V contains right eigenvectors;
*>          = 'L':  V contains left eigenvectors.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of rows of the matrix V.  N >= 0.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>          The integers ILO and IHI determined by SGEBAL.
*>          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*> \endverbatim
*>
*> \param[in] SCALE
*> \verbatim
*>          SCALE is REAL array, dimension (N)
*>          Details of the permutation and scaling factors, as returned
*>          by SGEBAL.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of columns of the matrix V.  M >= 0.
*> \endverbatim
*>
*> \param[in,out] V
*> \verbatim
*>          V is REAL array, dimension (LDV,M)
*>          On entry, the matrix of right or left eigenvectors to be
*>          transformed, as returned by SHSEIN or STREVC.
*>          On exit, V is overwritten by the transformed eigenvectors.
*> \endverbatim
*>
*> \param[in] LDV
*> \verbatim
*>          LDV is INTEGER
*>          The leading dimension of the array V. LDV >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realGEcomputational
*
*  =====================================================================
      SUBROUTINE SGEBAK( JOB, SIDE, N, ILO, IHI, SCALE, M, V, LDV,
     $                   INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          JOB, SIDE
      INTEGER            IHI, ILO, INFO, LDV, M, N
*     ..
*     .. Array Arguments ..
      REAL               V( LDV, * ), SCALE( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFTV, RIGHTV
      INTEGER            I, II, K
      REAL               S
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SSCAL, SSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Decode and Test the input parameters
*
      RIGHTV = LSAME( SIDE, 'R' )
      LEFTV = LSAME( SIDE, 'L' )
*
      INFO = 0
      IF( .NOT.LSAME( JOB, 'N' ) .AND. .NOT.LSAME( JOB, 'P' ) .AND.
     $    .NOT.LSAME( JOB, 'S' ) .AND. .NOT.LSAME( JOB, 'B' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -5
      ELSE IF( M.LT.0 ) THEN
         INFO = -7
      ELSE IF( LDV.LT.MAX( 1, N ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SGEBAK', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( M.EQ.0 )
     $   RETURN
      IF( LSAME( JOB, 'N' ) )
     $   RETURN
*
      IF( ILO.EQ.IHI )
     $   GO TO 30
*
*     Backward balance
*
      IF( LSAME( JOB, 'S' ) .OR. LSAME( JOB, 'B' ) ) THEN
*
         IF( RIGHTV ) THEN
            DO 10 I = ILO, IHI
               S = SCALE( I )
               CALL SSCAL( M, S, V( I, 1 ), LDV )
   10       CONTINUE
         END IF
*
         IF( LEFTV ) THEN
            DO 20 I = ILO, IHI
               S = ONE / SCALE( I )
               CALL SSCAL( M, S, V( I, 1 ), LDV )
   20       CONTINUE
         END IF
*
      END IF
*
*     Backward permutation
*
*     For  I = ILO-1 step -1 until 1,
*              IHI+1 step 1 until N do --
*
   30 CONTINUE
      IF( LSAME( JOB, 'P' ) .OR. LSAME( JOB, 'B' ) ) THEN
         IF( RIGHTV ) THEN
            DO 40 II = 1, N
               I = II
               IF( I.GE.ILO .AND. I.LE.IHI )
     $            GO TO 40
               IF( I.LT.ILO )
     $            I = ILO - II
               K = SCALE( I )
               IF( K.EQ.I )
     $            GO TO 40
               CALL SSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
   40       CONTINUE
         END IF
*
         IF( LEFTV ) THEN
            DO 50 II = 1, N
               I = II
               IF( I.GE.ILO .AND. I.LE.IHI )
     $            GO TO 50
               IF( I.LT.ILO )
     $            I = ILO - II
               K = SCALE( I )
               IF( K.EQ.I )
     $            GO TO 50
               CALL SSWAP( M, V( I, 1 ), LDV, V( K, 1 ), LDV )
   50       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of SGEBAK
*
      END
c $Id: sgebak.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine argos_cafe_fix_sw(lfnout,lfn,numfix,iwgmn,iwdt,numw,
     + isgan,isatt,isdt,issgm,nums,snam,xwm,xs,idb,msb,nsb,itemp)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer argos_cafe_atonum,argos_cafe_numcon
      external argos_cafe_atonum,argos_cafe_numcon
c
      integer lfnout,lfn,numfix,numw,nums,msb,nsb
      integer iwdt(mwm),iwgmn(mwm),isgan(msa),isatt(msa),isdt(msa)
      integer issgm(msa),idb(msb,4),itemp(nsatot)
      character*16 snam(nsatot)
      real*8 xwm(mwm,3),xs(msa,3)
c
      integer i,j,ndof(3),ifix,ifr,ito,l,len,number,itarget,ntotal(2)
      integer ib,jb,nsad
      real*8 fact(3),xtarget(3),rfix,dist2,rfix2
      character*80 string,target,residu
      character*16 tag,token
      logical lnumber
c
      integer icolon,icomma,idash,length,jfr,jto
c
      if(me.eq.0) then
      write(lfnout,1000) numfix
 1000 format(/,' POSITIONAL CONSTRAINTS',/,
     + ' Number of fix directives is ',i5,/)
      endif
c
      number=0
c
      do 1 l=1,numfix
c
      if(me.eq.0) then
      read(lfn,2000) string
 2000 format(a80)
c
      target=string(41:80)
      len=index(target,':')
      residu=' '
      if(len.gt.0) then
      residu=target(1:len-1)
      target=target(len+1:80)
      target(13-len:11)=residu
      endif
      do 33 i=1,4
      if(target(i:i).eq.'_') target(i:i)=' '
   33 continue
c
      itarget=0
      do 34 i=1,nsatot
      if(snam(i)(6:16).eq.target(1:11)) itarget=i
   34 continue
c
      endif
c
      call ga_brdcst(mrg_d47,itarget,ma_sizeof(mt_int,1,mt_byte),0)
      call util_char_ga_brdcst(mrg_d47,string,0)
c
      if(itarget.gt.0) then
      do 35 i=1,nums
      if(isgan(i).eq.itarget) then
      itarget=i
      xtarget(1)=xs(i,1)
      xtarget(2)=xs(i,2)
      xtarget(3)=xs(i,3)
      goto 36
      endif
   35 continue
      xtarget(1)=zero
      xtarget(2)=zero
      xtarget(3)=zero
      itarget=0
   36 continue
      call ga_dgop(mrg_d47,xtarget,3,'+')
      endif
c
      if(string(1:3).eq.'fix') then
c
      read(string(6:40),'(i3,2i10,f12.6)') ifix,ifr,ito,rfix
      target=string(41:80)
      len=index(target,':')
      residu=' '
      if(len.gt.0) then
      residu=target(1:len-1)
      target=target(len+1:80)
      endif
      len=4
      do 21 i=1,4
      if(target(i:i).eq.'_') target(i:i)=' '
   21 continue
c
c     solvent
c
      if(string(5:5).eq.'w') then
      if(numw.gt.0) then
      if(ifr.eq.0.or.ito.eq.0) then
      if(ifix.eq.0) then
      do 2 i=1,numw
      iwdt(i)=iand(iwdt(i),not(mfixed))
    2 continue
      endif
      if(ifix.eq.1) then
      do 3 i=1,numw
      iwdt(i)=ior(iwdt(i),lfixed)
    3 continue
      endif
      else
      if(ifr.gt.0) then
      do 4 i=1,numw
      if(iwgmn(i).ge.ifr.and.iwgmn(i).le.ito) then
      if(ifix.eq.0) iwdt(i)=iand(iwdt(i),not(mfixed))
      if(ifix.eq.1) iwdt(i)=ior(iwdt(i),lfixed)
      endif
    4 continue
      else
      rfix2=rfix*rfix
      do 41 i=1,numw
      dist2=(xwm(i,1)-xtarget(1))**2+(xwm(i,2)-xtarget(2))**2+
     + (xwm(i,3)-xtarget(3))**2
      if(ito.eq.-1.and.dist2.le.rfix2) then
      if(ifix.eq.0) iwdt(i)=iand(iwdt(i),not(mfixed))
      if(ifix.eq.1) iwdt(i)=ior(iwdt(i),lfixed)
      elseif(ito.eq.-2.and.dist2.ge.rfix2) then
      if(ifix.eq.0) iwdt(i)=iand(iwdt(i),not(mfixed))
      if(ifix.eq.1) iwdt(i)=ior(iwdt(i),lfixed)
      endif
   41 continue
      endif
      endif
      endif
      endif
c
c     solute
c
      if(string(5:5).eq.'s') then
      if(nums.gt.0) then
      if(ifr.eq.0.or.ito.eq.0) then
      if(ifix.eq.0) then
      do 5 i=1,nums
      tag=snam(isgan(i))
      do 51 j=1,16
      if(target(j:j).eq.'?') tag(j+5:j+5)='?'
   51 continue
      if((target(1:2).eq.'  '.or.target(1:len).eq.tag(6:len+5)).and.
     + (residu(1:1).eq.' '.or.residu(1:3).eq.tag(1:3))) then
      isdt(i)=iand(isdt(i),not(mfixed))
      number=number+1
      endif
    5 continue
      endif
      if(ifix.eq.1) then
      do 6 i=1,nums
      tag=snam(isgan(i))
      do 61 j=1,16
      if(target(j:j).eq.'?') tag(j+5:j+5)='?'
   61 continue
      if((target(1:2).eq.'  '.or.target(1:len).eq.tag(6:len+5)).and.
     + (residu(1:1).eq.' '.or.residu(1:3).eq.tag(1:3))) then
      isdt(i)=ior(isdt(i),lfixed)
      number=number+1
      endif
    6 continue
      endif
      else
      if(ifr.gt.0) then
      do 7 i=1,nums
      if(issgm(i).ge.ifr.and.issgm(i).le.ito) then
      tag=snam(isgan(i))
      do 71 j=1,16
      if(target(j:j).eq.'?') tag(j+5:j+5)='?'
   71 continue
      if((target(1:2).eq.'  '.or.target(1:len).eq.tag(6:len+5)).and.
     + (residu(1:1).eq.' '.or.residu(1:3).eq.tag(1:3))) then
      number=number+1
      if(ifix.eq.0) isdt(i)=ior(isdt(i),not(mfixed))
      if(ifix.eq.1) isdt(i)=ior(isdt(i),lfixed)
      endif
      endif
    7 continue
      else
      rfix2=rfix*rfix
      do 72 i=1,nums
      dist2=(xs(i,1)-xtarget(1))**2+(xs(i,2)-xtarget(2))**2+
     + (xs(i,3)-xtarget(3))**2
      if(ito.eq.-1.and.dist2.le.rfix2) then
      if(ifix.eq.0) isdt(i)=iand(isdt(i),not(mfixed))
      if(ifix.eq.1) isdt(i)=ior(isdt(i),lfixed)
      elseif(ito.eq.-2.and.dist2.ge.rfix2) then
      if(ifix.eq.0) isdt(i)=iand(isdt(i),not(mfixed))
      if(ifix.eq.1) isdt(i)=ior(isdt(i),lfixed)
      endif
   72 continue
      endif
      endif
      endif
      endif
c
c     heavy solute atoms only
c
      if(string(5:5).eq.'x') then
      if(nums.gt.0) then
      if(ifr.eq.0.or.ito.eq.0) then
      if(ifix.eq.0) then
      do 8 i=1,nums
      tag=snam(isgan(i))
      do 81 j=1,16
      if(target(j:j).eq.'?') tag(j+5:j+5)='?'
   81 continue
      if((target(1:2).eq.'  '.or.target(1:len).eq.tag(6:len+5)).and.
     + (residu(1:1).eq.' '.or.residu(1:3).eq.tag(1:3))) then
      if(argos_cafe_atonum(isatt(i),int_mb(i_num)).ne.1)
     + isdt(i)=iand(isdt(i),not(mfixed))
      number=number+1
      endif
    8 continue
      endif
      if(ifix.eq.1) then
      do 9 i=1,nums
      tag=snam(isgan(i))
      do 91 j=1,16
      if(target(j:j).eq.'?') tag(j+5:j+5)='?'
   91 continue
      if((target(1:2).eq.'  '.or.target(1:len).eq.tag(6:len+5)).and.
     + (residu(1:1).eq.' '.or.residu(1:3).eq.tag(1:3))) then
      if(argos_cafe_atonum(isatt(i),int_mb(i_num)).ne.1)
     + isdt(i)=ior(isdt(i),lfixed)
      number=number+1
      endif
    9 continue
      endif
      else
      do 10 i=1,nums
      if(issgm(i).ge.ifr.and.issgm(i).le.ito) then
      tag=snam(isgan(i))
      do 101 j=1,16
      if(target(j:j).eq.'?') tag(j+5:j+5)='?'
  101 continue
      if((target(1:2).eq.'  '.or.target(1:len).eq.tag(6:len+5)).and.
     + (residu(1:1).eq.' '.or.residu(1:3).eq.tag(1:3))) then
      if(argos_cafe_atonum(isatt(i),int_mb(i_num)).ne.1) then
      if(ifix.eq.0) isdt(i)=ior(isdt(i),not(mfixed))
      if(ifix.eq.1) isdt(i)=ior(isdt(i),lfixed)
      endif
      number=number+1
      endif
      endif
   10 continue
      endif
      endif
      endif
c
c     selection
c
      if(string(5:5).eq.'S') then
      target=string(41:80)
c
      do 55 i=1,nsatot
      itemp(i)=0
   55 continue
c
c     for the residues
c
  140 continue
      icolon=index(target,':')
      if(icolon.gt.0) then
      token='                '
      icomma=index(target(1:icolon-1),',')
      if(icomma.gt.0) then
      length=icomma-1
      else
      length=icolon-1
      endif
      token(1:length)=target(1:length)
      do 57 i=1,length
      lnumber=.false.
      if(token(i:i).eq.'1') lnumber=.true.
      if(token(i:i).eq.'2') lnumber=.true.
      if(token(i:i).eq.'3') lnumber=.true.
      if(token(i:i).eq.'4') lnumber=.true.
      if(token(i:i).eq.'5') lnumber=.true.
      if(token(i:i).eq.'6') lnumber=.true.
      if(token(i:i).eq.'7') lnumber=.true.
      if(token(i:i).eq.'8') lnumber=.true.
      if(token(i:i).eq.'9') lnumber=.true.
      if(token(i:i).eq.'0') lnumber=.true.
      if(token(i:i).eq.'-') lnumber=.true.
      if(.not.lnumber) goto 58
   57 continue
c     number
      idash=index(token(1:length),'-')
      if(idash.gt.0) then
c     range numbered residues
      tag='                '
      tag(18-idash:16)=token(1:idash-1)
      read(tag,'(i16)') jfr
      tag='                '
      tag(17+idash-length:16)=token(idash+1:length)
      read(tag,'(i16)') jto
      else
c     single numbered residue
      tag='                '
      tag(17-length:16)=token(1:length)
      read(tag,'(i16)') jfr
      jto=jfr
      endif
      do 60 i=1,nsatot
      read(snam(i)(11:16),'(i6)') j
      if(j.ge.jfr.and.j.le.jto) itemp(i)=1
   60 continue
      goto 59
   58 continue
c     single named residue
      do 141 i=1,nsatot
      if(snam(i)(1:length).eq.token(1:length)) itemp(i)=1
  141 continue
   59 continue
      if(icomma.gt.0) then
      target=target(icomma+1:80)
      goto 140
      else
      target=target(icolon+1:80)
      endif
      else
      do 56 i=1,nsatot
      itemp(i)=1
   56 continue
      endif
c
c     for the atoms
c
      if(index(target,' ')-1.eq.0) then
      do 145 i=1,nsatot
      itemp(i)=itemp(i)+1
  145 continue
      goto 144
      endif
c
  142 continue
      icomma=index(target,',')
      if(icomma.gt.0) then
      length=icomma-1
      else
      length=index(target,' ')-1
      endif
      do 147 i=1,length
      if(target(i:i).eq.'_') target(i:i)=' '
  147 continue
      do 143 i=1,nsatot
      token(1:length)=snam(i)(6:5+length)
      do 146 j=1,length
      if(target(j:j).eq.'?') token(j:j)='?'
  146 continue
      if(token(1:length).eq.target(1:length)) itemp(i)=itemp(i)+1
  143 continue
      if(icomma.gt.0) then
      target=target(icomma+1:80)
      goto 142
      endif
c
  144 continue
      do 66 i=1,nums
      if(itemp(isgan(i)).gt.1) then
      if(ifix.eq.0) isdt(i)=iand(isdt(i),not(mfixed))
      if(ifix.eq.1) isdt(i)=ior(isdt(i),lfixed)
      endif
   66 continue
c
      endif
c
c     solute atoms constraints
c
      do 76 i=1,nsatot
      itemp(i)=0
   76 continue
c
      do 62 i=1,nums
      itemp(isgan(i))=i
   62 continue
c
      do 64 j=1,4
      do 63 i=1,nsb
      ib=itemp(idb(i,1))
      jb=itemp(idb(i,2))
      if(ib.gt.0.and.jb.gt.0.and.idb(i,3).gt.0) then
      if(iand(isdt(ib),mfixed).eq.lfixed) isdt(jb)=ior(isdt(jb),lfixed)
      if(iand(isdt(jb),mfixed).eq.lfixed) isdt(ib)=ior(isdt(ib),lfixed)
      endif
   63 continue
   64 continue
c
c     make permanent
c
      if(string(5:5).eq.'p') then
      do 77 i=1,nums
      j=iand(isdt(i),mfixed)/4
      isdt(i)=lshift(rshift(isdt(i),2),2)
      isdt(i)=ior(isdt(i),j)
   77 continue
      do 78 i=1,numw
      j=iand(iwdt(i),mfixed)/4
      iwdt(i)=lshift(rshift(iwdt(i),2),2)
      iwdt(i)=ior(iwdt(i),j)
   78 continue
      endif
c
      endif
c
    1 continue
c
      ntotal(1)=0
      ntotal(2)=0
      do 201 i=1,nums
      if(iand(isdt(i),mfixed).eq.lfixed) ntotal(1)=ntotal(1)+1
  201 continue
      do 202 i=1,numw
      if(iand(iwdt(i),mfixed).eq.lfixed) ntotal(2)=ntotal(2)+1
  202 continue
c
      if(np.gt.1) then
      call ga_igop(mrg_d48,ntotal,2,'+')
      endif
c
      if(me.eq.0) then
      write(lfnout,'(a,i8,a,i8,a)')
     +  ' Solute fix applied to  ',ntotal(1),' out of ',nsa,' atoms'
      write(lfnout,'(a,i8,a,i8,a,/)')
     +  ' Solvent fix applied to ',ntotal(2),' out of ',nwm,' molecules'
      endif
c
c      if(numw.gt.0) then
c      if(iand(ifix,1).eq.1) then
c      do 1 i=1,numw
c      iwdt(i)=ior(iwdt(i),lfixed)
c    1 continue
c      endif
c      if(iand(iunfix,1).eq.1) then
c      do 2 i=1,numw
c      iwdt(i)=iand(iwdt(i),not(lfixed))
c    2 continue
c      endif
c      if(iand(ifix,2).eq.2) then
c      do 3 i=1,numw
c      iwdt(i)=ior(iwdt(i),lfixed)
c    3 continue
c      endif
c      if(iand(iunfix,2).eq.2) then
c      do 4 i=1,numw
c      iwdt(i)=iand(iwdt(i),not(lfixed))
c    4 continue
c      endif
c      endif
c
c      if(nums.gt.0) then
c      if(iand(ifix,1).eq.1) then
c      do 5 i=1,nums
c      isdt(i)=ior(isdt(i),lfixed)
c    5 continue
c      endif
c      if(iand(iunfix,1).eq.1) then
c      do 6 i=1,nums
c      isdt(i)=iand(isdt(i),not(lfixed))
c    6 continue
c      endif
c      if(iand(ifix,4).eq.4) then
c      do 7 i=1,nums
c      isdt(i)=ior(isdt(i),lfixed)
c    7 continue
c      endif
c      if(iand(iunfix,4).eq.4) then
c      do 8 i=1,nums
c      isdt(i)=iand(isdt(i),not(lfixed))
c    8 continue
c      endif
c      if(iand(ifix,8).eq.8) then
c      do 9 i=1,nums
c      if(argos_cafe_atonum(isatt(i),int_mb(i_num)).ne.1)
c     + isdt(i)=ior(isdt(i),lfixed)
c    9 continue
c      endif
c      if(iand(iunfix,8).eq.8) then
c      do 10 i=1,nums
c      if(argos_cafe_atonum(isatt(i),int_mb(i_num)).ne.1)
c     + isdt(i)=iand(isdt(i),not(lfixed))
c   10 continue
c      endif
c      endif
c
      ndof(1)=0
      ndof(2)=0
      ndof(3)=0
c
      do 11 i=1,numw
      if(iand(iwdt(i),lfixed).ne.lfixed) ndof(1)=ndof(1)+1
   11 continue
      do 12 i=1,nums
      if(iand(isdt(i),lfixed).ne.lfixed) then
      ndof(2)=ndof(2)+1
      ndof(3)=ndof(3)+argos_cafe_numcon(int_mb(i_ibnd(2)),
     + mbt(2),isgan(i))
      endif
   12 continue
c
      call ga_igop(mrg_d46,ndof,3,'+')
      nsc=ndof(3)/2
c
      factmw=zero
      factms=zero
      factmp=zero
      if(noshak.eq.2.or.noshak.eq.3) then
      nsad=3*ndof(2)-3*ndums
      else
      nsad=3*ndof(2)-2*ndums
      endif
      if(ndof(1)*(3*nwa-nwc)-3*islow.gt.0)
     + factmw=two/(rgas*dble(ndof(1)*(3*nwa-nwc)-3*islow))
      if(3*ndof(2)-nsc-3*islow.gt.0)
     + factms=two/(rgas*dble(nsad-nsc-3*islow))
      if(ndof(1)*(3*nwa-nwc)+nsad-nsc-3*islow.gt.0)
     + factmp=two/(rgas*dble(ndof(1)*(3*nwa-nwc)+nsad-nsc-3*islow))
c
      fact(1)=factmw
      fact(2)=factms
      fact(3)=factmp
      call ga_brdcst(mrg_d47,fact,3*ma_sizeof(mt_int,1,mt_byte),0)
      factmw=fact(1)
      factms=fact(2)
      factmp=fact(3)
c
      return
      end
c $Id: argos_cafe_fix_sw.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function pre_slvsiz(lfnslv,filslv,nwm,nwa)
c
c $Id: pre_slvsiz.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer lfnslv,nwm,nwa
      character*255 filslv
c
      character*1 cdummy
      integer i,nsa,npbtyp
c
      open(unit=lfnslv,file=filslv(1:index(filslv,' ')-1),
     + status='old',err=9999)
c
      do 1 i=1,4
      read(lfnslv,1000) cdummy
 1000 format(a1)
    1 continue
      read(lfnslv,1001) npbtyp
 1001 format(i5)
      do 2 i=1,5
      read(lfnslv,1000) cdummy
    2 continue
c
      read(lfnslv,1002) nwm,nwa,nsa
 1002 format(2i10,10x,i10)
c
      close(unit=lfnslv)
c
      if(nsa.ne.0) goto 9999
      if(npbtyp.eq.0) goto 9999
c
      pre_slvsiz=.true.
      return
c
 9999 continue
      pre_slvsiz=.false.
      return
      end

      subroutine tce_eom_init
c
c $Id: tce_eom_init.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Initializes file handle holders
c
      implicit none
#include "tce_diis.fh"
      integer i
c
      do i = 1,maxtrials
        xc1_exist(i)  = .false.
        yc1_exist(i)  = .false.
        xc2_exist(i)  = .false.
        yc2_exist(i)  = .false.
        xc3_exist(i)  = .false.
        yc3_exist(i)  = .false.
        xc4_exist(i)  = .false.
        yc4_exist(i)  = .false.
        x1_exist(i)  = .false.
        y1_exist(i)  = .false.
        x2_exist(i)  = .false.
        y2_exist(i)  = .false.
        x3_exist(i)  = .false.
        y3_exist(i)  = .false.
        x4_exist(i)  = .false.
        y4_exist(i)  = .false.
        xp1_exist(i) = .false.
        yp1_exist(i) = .false.
        xp2_exist(i) = .false.
        yp2_exist(i) = .false.
        xp3_exist(i) = .false.
        yp3_exist(i) = .false.
        xp4_exist(i) = .false.
        yp4_exist(i) = .false.
      enddo
      return
      end

c
c $Id: tool_volme.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE tool_volme(latt,vol)

      implicit none

      real*8 x,y,z,latt,vol

      dimension latt(3,3)

      x=latt(2,2)*latt(3,3)-latt(2,3)*latt(2,3)
      y=latt(3,2)*latt(1,3)-latt(1,2)*latt(3,3)
      z=latt(1,2)*latt(2,3)-latt(2,2)*latt(1,3)

      vol=abs(latt(1,1)*x+latt(2,1)*y+latt(3,1)*z)

      return

      END

      subroutine argos_diana_supimp(xtrj)
c
      implicit none
c
#include "msgids.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "argos_diana_common.fh"
c
      real*8 zero
      parameter(zero=0.0d0)
c
      integer nfr,nxa
      real*8 xtrj(ntrj,3,nfrdim)
c
      integer i,j,k
c
      nwm=0
      do 1 k=1,nfrme
      call super(xtrj(1,1,k),ntrj,ntrj,
     + dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms),
     + nsa,msa,.true.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa,.false.)
    1 continue
c
      return
      end
c $Id: argos_diana_supimp.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function tce_ccsdt_response_driver(title,thresh,maxiter,
     &        d_tr1,k_tr1_offset,size_tr1,d_tr2,k_tr2_offset,size_tr2,
     &        d_tr3,k_tr3_offset,size_tr3,d_t1,k_t1_offset,
     &        d_t2,k_t2_offset,d_t3,k_t3_offset,d_f1,k_f1_offset,
     &        d_v2,k_v2_offset,d_o1,k_o1_offset,omega,diis_tr3)
c
c $Id: tce_ccsdt_response_driver.F 19706 2010-10-29 17:52:31Z d3y133 $
c 
c Main routine for many-electron theory calculations.
c Some of the subroutines have been generated by 
c operator/tensor contraction engines.
c
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "sf.fh"
#include "inp.fh"
#include "errquit.fh"
#include "tce.fh"
c#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
c#include "tce_amps.fh"
c#include "tce_diis.fh"
c
c     CI, CC, & MBPT
c
      integer iter,maxiter
      logical nodezero         ! True if node 0
      logical recompf          ! True if recompute Fock
      logical diis_tr3
      double precision cpu     ! CPU sec counter
      double precision wall    ! WALL sec counter
      integer irrep
      integer irrep_g
      integer d_tr1            ! SF handle for tr1 amplitudes
      integer k_tr1_offset      ! Offset for tr1 file
      integer size_tr1          ! File size in doubles
      integer d_tr2            ! SF handle for tr2 amplitudes
      integer k_tr2_offset      ! Offset for tr2 file
      integer size_tr2          ! File size in doubles
      integer d_tr3            ! SF handle for tr2 amplitudes
      integer k_tr3_offset      ! Offset for tr2 file
      integer size_tr3          ! File size in doubles
      integer d_rr1,d_rr2,d_rr3
      integer d_o1
      integer k_o1_offset
      integer d_f1             ! SF handle for MO 1e integrals
      integer k_f1_offset      ! Offset for 1e integral file
      integer d_v2             ! SF handle for MO 2e integrals
      integer k_v2_offset      ! Offset for 2e integral file
      integer d_t1             ! SF handle for t1 amplitudes
      integer k_t1_offset      ! Offset for t1 file
      integer size_t1          ! File size in doubles
      integer d_t2             ! SF handle for t2 amplitudes
      integer k_t2_offset      ! Offset for t2 file
      integer size_t2          ! File size in doubles
      integer d_t3             ! SF handle for t2 amplitudes
      integer k_t3_offset      ! Offset for t2 file
      integer size_t3          ! File size in doubles
      double precision rr1,rr2,rr3
      double precision residual! Largest residual
      double precision thresh
      double precision ddotfile
      double precision omega
      character*6 rr1filename ! File name stub
      data rr1filename/'rr1   '/
      character*6 rr2filename ! File name stub
      data rr2filename/'rr2   '/
      character*6 rr3filename ! File name stub
      data rr3filename/'rr3   '/
      external ddotfile
      integer dummy            ! Dummy argument for DIIS
      character*255 filename
      character*20 title
      character*4 irrepname
      nodezero=(ga_nodeid().eq.0)
      call tce_diis_init()
      do iter=1,maxiter
        cpu=-util_cpusec()
        wall=-util_wallsec()
        if (nodezero.and.(iter.eq.1))
     &    write(LuOut,9400) title
        call tce_filename(rr1filename,filename)
        call createfile(filename,d_rr1,size_tr1)
        call tce_zero(d_rr1,size_tr1)
        call daxpyfile(1,omega,d_tr1,d_rr1,size_tr1)
        call ccsdt_o1(d_rr1,d_o1,d_t1,d_t2,k_tr1_offset,k_o1_offset,
     &       k_t1_offset,k_t2_offset)
        call eomccsdt_x1(d_f1,d_rr1,d_t1,d_t2,d_v2,d_tr1,d_tr2,d_tr3,
     &       k_f1_offset,k_tr1_offset,k_t1_offset,k_t2_offset,
     &       k_v2_offset,k_tr1_offset,k_tr2_offset,k_tr3_offset)
        call tce_filename(rr2filename,filename)
        call createfile(filename,d_rr2,size_tr2)
        call tce_zero(d_rr2,size_tr2)
        call daxpyfile(1,omega,d_tr2,d_rr2,size_tr2)
        call ccsdt_o2(d_rr2,d_o1,d_t1,d_t2,d_t3,k_tr2_offset,
     &       k_o1_offset,k_t1_offset,k_t2_offset,k_t3_offset)
        call eomccsdt_x2(d_f1,d_rr2,d_t1,d_t2,d_t3,d_v2,
     &       d_tr1,d_tr2,d_tr3,k_f1_offset,k_tr2_offset,
     &       k_t1_offset,k_t2_offset,k_t3_offset,
     &       k_v2_offset,k_tr1_offset,k_tr2_offset,k_tr3_offset)
        call tce_filename(rr3filename,filename)
        call createfile(filename,d_rr3,size_tr3)
        call tce_zero(d_rr3,size_tr3)
        call daxpyfile(1,omega,d_tr3,d_rr3,size_tr3)
        call eomccsdt_x3(d_f1,d_rr3,d_t1,d_t2,d_t3,d_v2,
     1       d_tr1,d_tr2,d_tr3,k_f1_offset,k_tr3_offset,
     3       k_t1_offset,k_t2_offset,k_t3_offset,k_v2_offset,
     4       k_tr1_offset,k_tr2_offset,k_tr3_offset)
        call ccsdt_o3(d_rr3,d_o1,d_t1,d_t2,d_t3,
     &       k_tr3_offset,k_o1_offset,
     &       k_t1_offset,k_t2_offset,k_t3_offset)
        call reconcilefile(d_rr1,size_tr1)
        call reconcilefile(d_rr2,size_tr2)
        call reconcilefile(d_rr3,size_tr3)
        call tce_residual_tr1(d_rr1,k_tr1_offset,rr1)
        call tce_residual_tr2(d_rr2,k_tr2_offset,rr2)
        call tce_residual_tr3(d_rr3,k_tr3_offset,rr3)
        residual = max(rr1,rr2)
        cpu=cpu+util_cpusec()
        wall=wall+util_wallsec()
        if (nodezero) write(LuOut,9420) iter,residual,cpu,wall
        if (residual .lt. thresh) then
          if (nodezero) write(LuOut,9410)
          call deletefile(d_rr3)
          call deletefile(d_rr2)
          call deletefile(d_rr1)
          call tce_diis_tidy()
          tce_ccsdt_response_driver=.true.
          return
        endif
        call tce_diis2(.false.,iter,.true.,.true.,diis_tr3,.false.,
     1       d_rr1,d_tr1,k_tr1_offset,size_tr1,
     2       d_rr2,d_tr2,k_tr2_offset,size_tr2,
     3       d_rr3,d_tr3,k_tr3_offset,size_tr3,
     4       dummy,dummy,dummy,dummy)
        call deletefile(d_rr2)
        call deletefile(d_rr1)
        if (nodezero) call util_flush(LuOut)
      enddo
      call tce_diis_tidy()
      tce_ccsdt_response_driver=.false.
      return  
c
c     ======
c     Format
c     ======
c
 9000 format(1x,A,' file size   = ',i16)
 9010 format(1x,A,' file name   = ',A)
 9090 format(1x,A,' file handle = ',i10)
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9480 format(1x,'Cpu & wall time / sec for ',A,2f15.1)
 9050 format(/,1x,A,' iterations',/,
     1  1x,'--------------------------------------------------------',/
     2  1x,'Iter          Residuum       Correlation     Cpu    Wall',/
     3  1x,'--------------------------------------------------------')
 9060 format(
     1  1x,'--------------------------------------------------------',/
     2  1x,'Iterations converged')
 9070 format(1x,A,' correlation energy / hartree = ',f25.15)
 9080 format(1x,A,' total energy / hartree       = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
 9120 format(1x,A)
 9250 format(1x,'Ground-state symmetry is ',A4)
 9210 format(/,1x,'Iteration ',i3,' using ',i4,' trial vectors')
 9230 format(1x,f17.13,f18.13,f11.5,2f8.1)
 9240 format(1x,
     1'--------------------------------------------------------------'
     2,/,1x,'Iterations converged')
 9310 format(1x,A,' ground state energy / hartree  =',f25.15)
 9400 format(/,1x,A,' iterations',/,
     1  1x,'--------------------------------------',/
     2  1x,'Iter          Residuum     Cpu    Wall',/
     3  1x,'--------------------------------------')
 9410 format(
     1  1x,'--------------------------------------',/
     2  1x,'Iterations converged')
 9420 format(1x,i4,f18.13,2f8.1)
 9440 format(1x,A3,' axis ( ',A4,'symmetry)')
      end

      subroutine argos_diana_rmsd
c
c $Id: argos_diana_rmsd.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "argos_diana_params.fh"
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer i_rms,l_rms,ga_rms
      integer ilr,ihr,jlr,jhr,ndxr,ldr
c
      filrms=card(14:80)
c
      if(me.eq.0) then
      if(.not.ma_push_get(mt_dbl,nfrtot*3,'trms',l_rms,i_rms))
     + call md_abort('Failed to allocate trms',0)
      endif
c
      call ga_distribution(ga_trj,me,il,ih,jl,jh)
      call ga_access(ga_trj,il,ih,jl,jh,ndx,ld)
c
c     allocate global array to hold the rms data
c
      if(.not.ga_create(mt_dbl,2,nfrtot,'rms',2,nfrdim,ga_rms))
     + call md_abort('Failed to create ga_rms',0)
      call ga_distribution(ga_rms,me,ilr,ihr,jlr,jhr)
      call ga_access(ga_rms,ilr,ihr,jlr,jhr,ndxr,ldr)
c
      if(card(8:13).eq.'averag') then
      elseif(card(8:13).eq.'refere') then
      call argos_diana_rmsdev(dbl_mb(ndx),dbl_mb(i_xref),dbl_mb(i_swt),
     + dbl_mb(i_wt),dbl_mb(i_xrms),dbl_mb(ndxr),dbl_mb(i_rms),ga_rms,
     + int_mb(i_isel),byte_mb(i_snam))
      else
      call md_abort('Error in rmsdev directive',0)
      endif
c
      if(.not.ga_destroy(ga_rms))
     + call md_abort('Could not destroy ga_rms',0)
c
      if(me.eq.0) then
      if(.not.ma_pop_stack(l_rms))
     + call md_abort('Failed to deallocate trms',0)
      endif
c
      return
      end

*
* $Id: smd_pot.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      subroutine smd_pot_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_pot,sp_param
      character*32 tag,pname
      logical result

      pname = "smd_pot_init_system"
c
      tag = "potential"
      call smd_system_get_component(sp_pot,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_pot_init(sp_pot,result)

      if(.not.result) then
       tag = "potential"
       call smd_system_unset_component(tag)
      end if
c
      return
      end

      subroutine smd_pot_init(sp_pot,result)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_pot
      logical result
c
      character*32 pname
      character*80 tag
      character*255 filename
      integer nt,np
      integer i_p1,i_p2,i_p3
      integer i_pt
      integer i_it
      integer i_tt,i_tr
c
      pname = "smd_pot_init"
c
c      write(*,*) "in "//pname
c
      tag = "param:typename"
      call smd_get_ind(tag,i_tt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "param:resname"
      call smd_get_ind_dim(tag,i_tr,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c     total number of possible pairwise interactions
c     ----------------------------------------------
      np=nt*(nt+1)
      np=np/2
c
c     create pot data structures
c     ---------------------------
      call smd_namespace_create(sp_pot)
      call smd_data_create_get(sp_pot,"pot:p1",np,MT_DBL,i_p1)
      call smd_data_create_get(sp_pot,"pot:p2",np,MT_DBL,i_p2)
      call smd_data_create_get(sp_pot,"pot:p3",np,MT_DBL,i_p3)
      call smd_data_create_get(sp_pot,"pot:type",np,MT_INT,i_pt)

      call smd_paramfile_read_pot(np,
     +                         int_mb(i_pt),
     +                         dbl_mb(i_p1),
     +                         dbl_mb(i_p2),
     +                         dbl_mb(i_p3),
     +                         nt,
     +                         byte_mb(i_tt),
     +                         byte_mb(i_tr))


      if(np.eq.0) then
       result = .false.
       call smd_namespace_destroy(sp_pot)
      end if
      return
      end

      subroutine smd_pot_compute()

      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      double precision  e
c
      character*30 pname
      character*32 tag
      integer i_p1,i_p2,i_p3,i_pt
      integer nt,np
      integer i_f,i_c,i_rlat
      integer i_lat
      integer i_l,i_p
      integer i_it
      integer nl,na
      double precision vol
      double precision alpha
      double precision rcutsq
      integer kmax(3)
      integer ntmp,nk
      logical result

      pname = "smd_pot_compute"


      e = 0.0d0
c
c     get verlet list data
c     --------------------
      tag = "vlist:pointer"
      call smd_get_ind(tag,i_p,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "vlist:list"
      call smd_get_ind_dim(tag,i_l,nl,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "vlist:distances"
      call smd_get_ind(tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

c
c     get type data
c     ------------
      tag = "type:id"
      call smd_get_ind_dim(tag,i_it,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     get pot data
c     ------------
      tag = "pot:p1"
      call smd_get_ind_dim(tag,i_p1,np,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "pot:p2"
      call smd_get_ind(tag,i_p2,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "pot:p3"
      call smd_get_ind(tag,i_p3,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "pot:type"
      call smd_get_ind(tag,i_pt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     get force data
c     --------------
      tag = "force"
      call smd_get_ind_dim(tag,i_f,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      na = na/3
c
c     get cutoff data
c     ---------------
      call smd_cutoff_get_rcut(rcutsq)
      rcutsq = rcutsq*rcutsq

      call       smd_pot_compute_generic(np,
     >                                  nl,
     >                                  na,
     >                                  rcutsq,
     >                                  int_mb(i_it),
     >                                  dbl_mb(i_p1),
     >                                  dbl_mb(i_p2),
     >                                  dbl_mb(i_p3),
     >                                  int_mb(i_pt),
     >                                  dbl_mb(i_c),
     >                                  dbl_mb(i_f),
     >                                  int_mb(i_p),
     >                                  int_mb(i_l),
     >                                  e)

      call smd_energy_set_component("vdw",e)
      return

      END

*
* $Id: matrix.f 19707 2010-10-29 17:59:36Z d3y133 $
*
      SUBROUTINE EIGEN(NEMAX,NE,HML,EIG,WORK,IERR)
*     =======================================
*     DIAGONALIZATION OF HAMILTONIAN MATRIX 
*     =======================================
      implicit double precision(a-h, o-z)
      DIMENSION EIG(*),HML(NEMAX,*),WORK(*)

      CALL DCOPY(NEMAX,0.0d0,0,EIG,1)
      IF(NE.EQ.0) RETURN
      IF(NE.EQ.1) THEN
        EIG(1)=HML(1,1)
        HML(1,1)=1.0d0
        RETURN
      ENDIF
      CALL TRED3(HML,NE,NEMAX,EIG,WORK)
      CALL TQLI(EIG,WORK,NE,NEMAX,HML,IERR)

      CALL EIGSRT(EIG,HML,NE,NEMAX)

 1000 FORMAT(I8,E20.10)
      RETURN
      END

*     =======================================
*     DIAGONALIZATION OF HAMILTONIAN MATRIX 
*     =======================================
      SUBROUTINE EIGEN_UNSORT(NEMAX,NE,HML,EIG,WORK,IERR)
      implicit double precision(a-h, o-z)
      DIMENSION EIG(*),HML(NEMAX,*),WORK(*)

      CALL DCOPY(NEMAX,0.0d0,0,EIG,1)
      IF(NE.EQ.0) RETURN
      IF(NE.EQ.1) THEN
        EIG(1)=HML(1,1)
        HML(1,1)=1.0d0
        RETURN
      ENDIF
      CALL TRED3(HML,NE,NEMAX,EIG,WORK)
      CALL TQLI(EIG,WORK,NE,NEMAX,HML,IERR)

      RETURN
      END




      SUBROUTINE EIGSRT(D,V,N,NP)
*     -----------------------------------------------------------------
*     SORT EIGENVALUES INTO DESCENDING ORDER AND REARRANGE EIGENVECTORS
*     -----------------------------------------------------------------
      implicit double precision(a-h, o-z)
      double precision D(NP),V(NP,NP)
      DO 13 I=1,N-1
         K=I
         P=D(I)
         DO 11 J=I+1,N
            IF(D(J).GE.P) THEN
               K=J
               P=D(J)
            ENDIF
   11    CONTINUE
         IF(K.NE.I) THEN
            D(K)=D(I)
            D(I)=P
            DO 12 J=1,N
               P=V(J,I)
               V(J,I)=V(J,K)
               V(J,K)=P
   12       CONTINUE
         ENDIF
   13 CONTINUE
      RETURN
      END


      SUBROUTINE DMADD(NX,N,X,Y,Z)
*     ==============
*     MATRIX ADDTION
*     ==============
      implicit double precision(a-h, o-z)
      DIMENSION X(*),Y(*),Z(*)
      DO 1 I=1,NX*N
        Z(I)=X(I)+Y(I)
    1 CONTINUE
      RETURN
      END

      SUBROUTINE DMMUL(NX,N,X,Y,Z)
*     =====================
*     MATRIX MULTIPLICATION
*     =====================
      implicit double precision(a-h, o-z)
      DIMENSION X(NX,*),Y(NX,*),Z(NX,*)
      DO 1 J=1,N
      DO 1 I=1,N
        Z(I,J)=DDOT(N,X(I,1),NX,Y(1,J),1)
    1 CONTINUE
      RETURN
      END

      SUBROUTINE DMSUB(NX,N,X,Y,Z)
*     ===================
*     MUTRIX SUBSTRACTION
*     ===================
      implicit double precision(a-h, o-z)
      DIMENSION X(*),Y(*),Z(*)
      DO 1 I=1,NX*N
        Z(I)=X(I)-Y(I)
    1 CONTINUE
      RETURN
      END


      SUBROUTINE TQLI(D,E,N,NP,Z,IERR)
*     ==========================================
*     EIGENVALUES AND EIGENVECTORS
*     FOR A REAL SYMMETRIC TRIDIAGONAL MATRIX 
*     ==========================================
      implicit double precision(a-h, o-z)
      double precision D(NP),E(NP),Z(NP,NP)
      IF(N.GT.1) THEN
        DO 11 I=2,N
          E(I-1)=E(I)
   11   CONTINUE
        E(N)=0
        DO 15 L=1,N
          ITER=0
    1     DO 12 M=L,N-1
            DD=DABS(D(M))+DABS(D(M+1))
            IF(DABS(E(M))+DD.EQ.DD) GO TO 2
   12     CONTINUE
          M=N
    2     IF(M.NE.L) THEN
            IF(ITER.EQ.30) THEN
              IERR=1
              RETURN
            ENDIF
            ITER=ITER+1
            G=(D(L+1)-D(L))/(2.0d0*E(L))
            R=DSQRT(G**2+1.0d0)
            G=D(M)-D(L)+E(L)/(G+DSIGN(R,G))
            S=1.0d0
            C=1.0d0
            P=0.0d0
            DO 14 I=M-1,L,-1
              F=S*E(I)
              B=C*E(I)
              IF(DABS(F).GE.DABS(G)) THEN
                C=G/F
                R=DSQRT(C**2+1.0d0)
                E(I+1)=F*R
                S=1.0d0/R
                C=C*S
              ELSE
                S=F/G
                R=DSQRT(S**2+1.0d0)
                E(I+1)=G*R
                C=1.0d0/R
                S=S*C
              ENDIF
              G=D(I+1)-P
              R=(D(I)-G)*S+2.0d0*C*B
              P=S*R
              D(I+1)=G+P
              G=C*R-B
              DO 13 K=1,N
                F=Z(K,I+1)
                Z(K,I+1)=S*Z(K,I)+C*F
                Z(K,I)=C*Z(K,I)-S*F
   13         CONTINUE
   14       CONTINUE
            D(L)=D(L)-P
            E(L)=G
            E(M)=0.0d0
            GO TO 1
          ENDIF
   15   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE TRED3(A,N,NP,D,E)
*     ==================================================
*     HOUSEHOLDER REDUCTION OF A REAL SYMMETRIC MATRIX 
*     ==================================================
      implicit double precision(a-h, o-z)
      double precision A(NP,NP),D(NP),E(NP)
      IF(N.GT.1) THEN
        DO 18 I=N,2,-1
          L=I-1
          H=0.0d0
          SCALE=0.0d0
          IF(L.GT.1) THEN
            DO 11 K=1,L
              SCALE=SCALE+DABS(A(I,K))
   11       CONTINUE
            IF(SCALE.EQ.0.) THEN
              E(I)=A(I,L)
            ELSE
              DO 12 K=1,L
                A(I,K)=A(I,K)/SCALE
                H=H+A(I,K)**2
   12         CONTINUE
              F=A(I,L)
              G=-DSIGN(DSQRT(H),F)
              E(I)=SCALE*G
              H=H-F*G
              A(I,L)=F-G
              F=0.0d0
              DO 15 J=1,L
                A(J,I)=A(I,J)/H
                G=0.0d0
                DO 13 K=1,J
                  G=G+A(J,K)*A(I,K)
   13           CONTINUE
                IF(L.GT.J) THEN
                  DO 14 K=J+1,L
                    G=G+A(K,J)*A(I,K)
   14             CONTINUE
                ENDIF
                E(J)=G/H
                F=F+E(J)*A(I,J)
   15         CONTINUE
              HH=F/(H+H)
              DO 17 J=1,L
                F=A(I,J)
                G=E(J)-HH*F
                E(J)=G
                DO 16 K=1,J
                  A(J,K)=A(J,K)-F*E(K)-G*A(I,K)
   16           CONTINUE
   17         CONTINUE
            ENDIF
          ELSE
            E(I)=A(I,L)
          ENDIF
          D(I)=H
   18   CONTINUE
      ENDIF
      D(1)=0.0d0
      E(1)=0.0d0
      DO 23 I=1,N
        L=I-1
        IF(D(I).NE.0.0d0) THEN
          DO 21 J=1,L
            G=0.0d0
            DO 19 K=1,L
              G=G+A(I,K)*A(K,J)
   19       CONTINUE
            DO 20 K=1,L
              A(K,J)=A(K,J)-G*A(K,I)
   20       CONTINUE
   21     CONTINUE
        ENDIF
        D(I)=A(I,I)
        A(I,I)=1.0d0
        IF(L.GE.1) THEN
          DO 22 J=1,L
            A(I,J)=0.0d0
            A(J,I)=0.0d0
   22     CONTINUE
        ENDIF
   23 CONTINUE
      RETURN
      END

*
* $Id: chi_write.F 24456 2013-07-30 23:08:29Z bylaska $
*

*     ***********************************
*     *             			*
*     *           chi_write		*
*     *             			*
*     ***********************************

      subroutine chi_write(ispin,ne,psi2)
      implicit none 
      integer ispin,ne(2)
      double complex psi2(*)

#include "mafdecls.fh"
#include "errquit.fh"


*    *** local variables ***
      integer version,l
      integer nfft3d,npack1,occupation
      integer nfft(3)
      real*8  unita(3,3)
      character*50 filename
      character*255 full_filename

      integer MASTER,taskid,taskid_j
      parameter(MASTER=0)
      integer n,q,pj

c     complex*16 tmp(*)
      integer tmp(2),tmp2(2)
      logical value

*     ***** local functions ****
      character*50 control_output_psi
      external     control_output_psi
      double precision control_unita
      external         control_unita
      integer  control_ngrid,control_version
      external control_ngrid,control_version

      call Parallel_taskid(taskid)
      call Parallel2d_taskid_j(taskid_j)
      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)

      value = MA_push_get(mt_dcpl,nfft3d,'tmp',tmp(2),tmp(1))
      if (.not. value) 
     > call errquit('chi_write:out of stack memory',0, MA_ERR)
      value = MA_push_get(mt_dcpl,nfft3d,'tmp2',tmp2(2),tmp2(1))
      if (.not. value) 
     > call errquit('chi_write:out of stack memory',0, MA_ERR)

      version = 9  ! version 9 - ofpw, version 5 - band, version 3 and 4 - pspw
      nfft(1) = control_ngrid(1)
      nfft(2) = control_ngrid(2)
      nfft(3) = control_ngrid(3)

      unita(1,1) = control_unita(1,1)
      unita(2,1) = control_unita(2,1)
      unita(3,1) = control_unita(3,1)
      unita(1,2) = control_unita(1,2)
      unita(2,2) = control_unita(2,2)
      unita(3,2) = control_unita(3,2)
      unita(1,3) = control_unita(1,3)
      unita(2,3) = control_unita(2,3)
      unita(3,3) = control_unita(3,3)

*     **** open ELCIN binary file ****
      if (taskid.eq.MASTER) then
         filename = control_output_psi()
         
         full_filename = filename
         call util_file_name_resolve(full_filename, .false.)
c        call util_file_name_noprefix(filename,.false.,
c    >                                .false.,
c    >                       full_filename)
         l = index(full_filename,' ') -1
         write(*,1210) full_filename(1:l)
 1210    FORMAT(/' output psi filename:',A)

         call openfile(6,full_filename,l,'w',l)
         call iwrite(6,version,1)
         call iwrite(6,nfft,3)
         call dwrite(6,unita,9)
         call iwrite(6,ispin,1)
         call iwrite(6,ne,2)
         occupation = -1
         call iwrite(6,occupation,1)
      end if

*     *** write out 3d blocks ***
      do n=1,(ispin)
         call Pack_c_Copy(1,psi2(1+(n-1)*npack1),dcpl_mb(tmp2(1)))
         call Pack_c_unpack(1,dcpl_mb(tmp2(1)))          
         call D3dB_c_write(1,6,dcpl_mb(tmp2(1)),
     >                         dcpl_mb(tmp(1)),0)
      end do

*     *** close ELCIN binary file ***
      if (taskid.eq.MASTER) then
        call closefile(6)
      end if


      value = MA_pop_stack(tmp2(2))
      value = MA_pop_stack(tmp(2))
      return
      end

      subroutine sym_inv_op(geom, op, opinv)
      implicit none
#include "nwc_const.fh"
#include "geomP.fh"
      integer geom, op, opinv
c
      opinv = sym_op_inv(op, geom)
c
      end
      subroutine sym_init_inv_op(geom)
      implicit none
#include "nwc_const.fh"
#include "geomP.fh"
      integer geom
      integer i
c
      do i = 1, sym_num_ops(geom)
         call sym_find_inv_op(geom, i, sym_op_inv(i,geom))
      enddo
c
      end
      subroutine sym_find_inv_op(geom, op, opinv)
C$Id: sym_inv_op.F 25312 2014-03-10 19:40:42Z bylaska $
      implicit none
#include "errquit.fh"
#include "sym.fh"
      integer geom, op, opinv
c
c     return in opinv the index of the operation that is
c     the inverse of op
c
      double precision r(3), rop(3), rinv(3), dist
      integer nops
c
      r(1) = 3.14159d0          ! A point not on a symmetry axis
      r(2) = 2.71828d0
      r(3) = 1.0d0
c
      nops = sym_number_ops(geom)
      call sym_apply_cart_op(geom, op, r, rop)
c
      do opinv = 1, nops
         call sym_apply_cart_op(geom, opinv, rop, rinv)
         dist = sqrt((r(1)-rinv(1))**2 + (r(2)-rinv(2))**2 + 
     $        (r(3)-rinv(3))**2)
         if (dist .lt. 1.0d-8) return
      enddo
c
c      call errquit('sym_inv_op: failed to find inverse for',op,
c     &       CALC_ERR)
c
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
      subroutine printdat(g_fg,  fg,  ld_fg1,  ld_fg2,
     +                    g_fld, fld, ld_fld1, ld_fld2,
     +                    g_bc,  bc,  ld_bc1)
#include "common"
c
      integer ld_fg1, ld_fg2, ld_fld1, ld_fld2, ld_bc1
      double precision fg(ld_fg1, ld_fg2, *)
      double precision fld(ld_fld1, ld_fld2, *)
      integer bc(ld_bc1, *)
      integer g_fg, g_fld, g_bc 
c
#include "mafdecls.fh"
#include "global.fh"
c
      double precision buffer(NSIZE,10,3)
      double precision dx, dy
      integer glo(NDIM+1), ghi(NDIM+1), bld(NDIM)
      integer i,j,k,imax,icnt1,icnt2,inc1,inc2,jcnt
      integer maxelem
c
c   Subroutine to print current value of fields to a file
c
      imax = size(2)/10 + 1
      glo(1) = 1
      ghi(1) = size(1)
      glo(3) = 1
      ghi(3) = 3
      bld(1) = NSIZE
      bld(2) = 10
c
      maxelem = 256
c
c    Check dimensions to see if size needs to be reduced
c
      if (size(1).gt.maxelem) then
        inc1 = size(1)/maxelem
        icnt1 = 0
        do i = 1, size(1), inc1
          icnt1 = icnt1 + 1
        end do
      else
        inc1 = 1
        icnt1= size(1)
      endif
      if (size(2).gt.maxelem) then
        inc2 = size(2)/maxelem
        icnt2 = 0
        do i = 1, size(2), inc2
          icnt2 = icnt2 + 1
        end do
      else
        inc2 = 1
        icnt2= size(2)
      endif
c
      if (ga_nodeid().eq.0) then
        open(unit=7,file='bltz.gmv',status='unknown')
c
c   Write out header type information
c
        write(7,100)
        write(7,200) icnt1,icnt2,1
        dx = dble(inc1)*xmax/dble(size(1)-1)
        dy = dble(inc1)*xmax/dble(size(1)-1)
        write(7,300) (dble(i-1)*dx,i=1,icnt1)
        write(7,300) (dble(i-1)*dy,i=1,icnt2)
        write(7,300) 0.0
        write(7,1000)
        write(7,400)
        write(7,500)
        jcnt = 0
        do i = 1, imax
          glo(2) = (i-1)*10 + 1
          ghi(2) = i*10
          if (ghi(2).gt.size(2)) ghi(2) = size(2)
          if (ghi(2).ge.glo(2)) then
            call nga_get(g_fld, glo, ghi, buffer, bld)
            do k = 1, ghi(2)-glo(2)+1
              jcnt = jcnt + 1
              if (mod((jcnt-1),inc2).eq.0) then
                write(7,300) (buffer(j,k,1),j=1,size(1),inc1)
              endif
            end do
          endif
        end do
        write(7,600)
        jcnt = 0
        do i = 1, imax
          glo(2) = (i-1)*10 + 1
          ghi(2) = i*10
          if (ghi(2).gt.size(2)) ghi(2) = size(2)
          if (ghi(2).ge.glo(2)) then
            call nga_get(g_fld, glo, ghi, buffer, bld)
            do k = 1, ghi(2)-glo(2)+1
              jcnt = jcnt + 1
              if (mod((jcnt-1),inc2).eq.0) then
                write(7,300) (buffer(j,k,2),j=1,size(1),inc1)
              endif
            end do
          endif
        end do
        write(7,700)
        do i = 1, imax
          glo(2) = (i-1)*10 + 1
          ghi(2) = i*10
          if (ghi(2).gt.size(2)) ghi(2) = size(2)
          if (ghi(2).ge.glo(2)) then
            call nga_get(g_fld, glo, ghi, buffer, bld)
            do k = 1, ghi(2)-glo(2)+1
              jcnt = jcnt + 1
              if (mod((jcnt-1),inc2).eq.0) then
                write(7,300) (buffer(j,k,3),j=1,size(1),inc1)
              endif
            end do
          endif
        end do
        write(7,1100)
        glo(3) = 4
        ghi(3) = 6
        do i = 1, imax
          glo(2) = (i-1)*10 + 1
          ghi(2) = i*10
          if (ghi(2).gt.size(2)) ghi(2) = size(2)
          if (ghi(2).ge.glo(2)) then
            call nga_get(g_fld, glo, ghi, buffer, bld)
            do k = 1, ghi(2)-glo(2)+1
              jcnt = jcnt + 1
              if (mod((jcnt-1),inc2).eq.0) then
                write(7,300) (buffer(j,k,3),j=1,size(1),inc1)
              endif
            end do
          endif
        end do
        write(7,800)
        write(7,900)
        close(7)
      endif
c
  100 format('gmvinput ascii')
  200 format('nodes       -1',3i10)
  300 format('    ',5f12.4)
  400 format('variable')
  500 format('rho                           1')
  600 format('ux                            1')
  700 format('uy                            1')
  800 format('endvars')
  900 format('endgmv')
 1000 format('cells     0')
 1100 format('vorticity                     1')
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      subroutine estat
#include "common.fh"
c
c    This subroutine accumulates energy statistics for the simulation.
c    The averages are stored in the array anrg(). The contents of nrg()
c    and anrg() are listed below. Temporary values for the averages are
c    stored in tmpnrg() and the uncertainties are stored anrg2().
c    Corresponding entries in anrg(), tmpnrg(), and anrg2() are all indexed
c    by the same variable.
c
c                   Contents of nrg()
c
c    nrg(1): the total number of degrees of freedom in the system
c
c    nrg(2): the total number of degrees of freedom in the system
c            times Rgas/2
c
c    nrg(3): the total energy of the system
c
c    nrg(4): the total kinetic energy of the system
c
c    nrg(5): temperature (in Kelvin) of the system
c
c    nrg(6): potential energy of the system
c
c    nrg(7): current pressure (in atmospheres)
c
c    nrg(8): the total translational kinetic energy of the system
c
c    nrg(9): the instantaneous value of the Hamiltonian
c
c    nrg(10): the instantaneous value of the virial
c
c    nrg(11): the instantaneous value of the Enthalpy
c
c    nrg(12): the instantaneous coulomb energy of the system
c
c    nrg(13): the instantaneous repulsion energy of the system
c
c    nrg(14): the instantaneous dispersion energy of the system
c
c    nrg(15): the virial contribution to the pressure (in atmospheres)
c
c    nrg(16): the instantaneous torsional energy of the system
c
c    nrg(17): instantaneous energy from harmonic oscillators
c
c    nrg(18): x component of virial
c
c    nrg(19): y component of virial
c
c    nrg(20): z component of virial
c
c    nrg(21): instantaneous energy from bond angle bends
c
c    nrg(22): x component of total momentum
c
c    nrg(23): y component of total momentum
c
c    nrg(24): z component of total momentum
c
c    nrg(25): total mass
c
c                   Contents of anrg(), tmpnrg(), and anrg2()
c
c    anrg(1): the average total energy of the system
c
c    anrg(2): the average total kinetic energy of the system
c
c    anrg(3): the average temperature (in Kelvin) of the system
c
c    anrg(4): the average potential energy of the system
c
c    anrg(5): the average pressure (in atmospheres)
c
c    anrg(6): the average total translational kinetic energy of the system
c
c    anrg(7): the average value of the Hamiltonian
c
c    anrg(8): the average value of the Enthalpy
c
c    anrg(9): the average coulomb energy of the system
c
c    anrg(10): the average repulsion energy of the system
c
c    anrg(11): the average dispersion energy of the system
c
c    anrg(12): the average x dimension of the system
c
c    anrg(13): the average y dimension of the system
c
c    anrg(14): the average z dimension of the system
c
c    anrg(15): the average value of the time scaling parameter
c
c    anrg(16): the average volume of the system
c
c    anrg(17): mean square total energy
c
c    anrg(18): mean square Hamiltonian
c
c    anrg(19): mean square kinetic energy
c
c    anrg(20): mean square potential energy
c
c    anrg(21): mean square pressure (in atmospheres**2)
c
c    anrg(22): mean square x dimension
c
c    anrg(23): mean square y dimension
c
c    anrg(24): mean square z dimension
c
c    anrg(25): mean square scaling parameter
c
c    anrg(26): mean square temperature
c
c    anrg(27): mean square Enthalpy
c
c    arng(28): the average torsional energy
c
c    arng(29): the average harmonic oscillator energy
c
c    arng(30): the average bond angle bend energy
c
      nrgcnt = nrgcnt + 1
c
      anrg(1) = anrg(1) + nrg(3)
      anrg(2) = anrg(2) + nrg(4)
      anrg(3) = anrg(3) + nrg(5)
      anrg(4) = anrg(4) + nrg(6)
      anrg(5) = anrg(5) + nrg(7)
      anrg(6) = anrg(6) + nrg(8)
      anrg(7) = anrg(7) + nrg(9)
      anrg(8) = anrg(8) + nrg(11)
      anrg(9) = anrg(9) + nrg(12)
      anrg(10) = anrg(10) + nrg(13)
      anrg(11) = anrg(11) + nrg(14)
      anrg(12) = anrg(12) + xbox
      anrg(13) = anrg(13) + ybox
      anrg(14) = anrg(14) + zbox
      anrg(15) = anrg(15) + scal1
      anrg(16) = anrg(16) + vol1
      anrg(17) = anrg(17) + nrg(3)**2
      anrg(18) = anrg(18) + nrg(9)**2
      anrg(19) = anrg(19) + nrg(4)**2
      anrg(20) = anrg(20) + nrg(6)**2
      anrg(21) = anrg(21) + nrg(7)**2
      anrg(22) = anrg(22) + xbox**2
      anrg(23) = anrg(23) + ybox**2
      anrg(24) = anrg(24) + zbox**2
      anrg(25) = anrg(25) + scal1**2
      anrg(26) = anrg(26) + nrg(5)**2
      anrg(27) = anrg(27) + nrg(11)**2
      anrg(28) = anrg(28) + nrg(16)
      anrg(29) = anrg(29) + nrg(17)
      anrg(30) = anrg(30) + nrg(21)
c
      return
      end
c
      subroutine prtnrg
#include "common.fh"
c
      double precision bstat,b2stat
      integer i,ibstat
c
      if (nrgcnt.eq.0) return
c
      do 25 i = 1, MAXNRG
        anrg(i) = anrg(i) / dble(nrgcnt)
   25 continue
c
c      call ga_dgop(3,bstat,1,'+')
c      call ga_dgop(3,b2stat,1,'+')
c      call ga_igop(3,ibstat,1,'+')
c
      if (ga_nodeid().eq.0.and.l_stdio) then
c        if (ibstat.gt.0) bstat = bstat/dble(ibstat)
c        if (ibstat.gt.0) b2stat = b2stat/dble(ibstat)
c        b2stat = sqrt(abs(b2stat-bstat**2))
c
        write(6,50)
        write(6,100) anrg(1)
        write(6,200) anrg(2)
        write(6,300) anrg(3)
c        write(6,600) anrg(6)
        write(6,400) anrg(4)
c        write(6,900) anrg(9)
        write(6,1000) anrg(10)
        write(6,1100) anrg(11)
c        write(6,2800) anrg(28)
        write(6,2900) anrg(29)
        write(6,3000) anrg(30)
        write(6,500) anrg(5)
        write(6,700) anrg(7)
        write(6,800) anrg(8)
c        write(6,850) bstat
        write(6,1150)
        write(6,1200) anrg(12)
        write(6,1300) anrg(13)
        write(6,1400) anrg(14)
        write(6,1500) anrg(15)
        write(6,1600) anrg(16)
        write(6,1650)
        write(6,1700) sqrt(abs(anrg(17)-anrg(1)**2))
        write(6,1800) sqrt(abs(anrg(18)-anrg(7)**2))
        write(6,1900) sqrt(abs(anrg(19)-anrg(2)**2))
        write(6,2000) sqrt(abs(anrg(20)-anrg(4)**2))
        write(6,2600) sqrt(abs(anrg(26)-anrg(3)**2))
        write(6,2700) sqrt(abs(anrg(27)-anrg(8)**2))
        write(6,2100) sqrt(abs(anrg(21)-anrg(5)**2))
        write(6,2200) sqrt(abs(anrg(22)-anrg(12)**2))
        write(6,2300) sqrt(abs(anrg(23)-anrg(13)**2))
        write(6,2400)
     +                   sqrt(abs(anrg(24)-anrg(14)**2))
        write(6,2500) sqrt(abs(anrg(25)-anrg(15)**2))
        write(6,2550) b2stat
      endif
c
   50 format('Average Energy statistics for simulation:')
  100 format('                   <Energy>                :',f16.4)
  200 format('                   <Kinetic Energy>        :',f16.4)
  300 format('                   <Temperature>           :',f16.4)
  400 format('                   <Potential Energy>      :',f16.4)
  500 format('                   <Pressure>              :',f16.4)
  600 format('                       <T_trans>           :',f16.4)
  700 format('                   <Hamiltonian>           :',f16.4)
  800 format('                   <Enthalpy>              :',f16.4)
  850 format('                   <Bond Length>           :',f16.4)
  900 format('                       <Coulomb Energy>    :',f16.4)
 1000 format('                       <Repulsion Energy>  :',f16.4)
 1100 format('                       <Dispersion Energy> :',f16.4)
 1150 format('Average system parameters for simulation :')
 1200 format('                   <X>                     :',f16.4)
 1300 format('                   <Y>                     :',f16.4)
 1400 format('                   <Z>                     :',f16.4)
 1500 format('                   <S>                     :',f16.4)
 1600 format('                   <V>                     :',f16.4)
 1650 format('Root mean square fluctuations:')
 1700 format('                   Energy                  :',f16.4)
 1800 format('                   Hamiltonian             :',f16.4)
 1900 format('                   Kinetic Energy          :',f16.4)
 2000 format('                   Potential Energy        :',f16.4)
 2100 format('                   Pressure                :',f16.4)
 2200 format('                   X                       :',f16.4)
 2300 format('                   Y                       :',f16.4)
 2400 format('                   Z                       :',f16.4)
 2500 format('                   S                       :',f16.4)
 2550 format('                   Bond Length             :',f16.4)
 2600 format('                   Temperature             :',f16.4)
 2700 format('                   Enthalpy                :',f16.4)
 2800 format('                       <Torsional Energy>  :',f16.4)
 2900 format('                       <Vibrational Energy>:',f16.4)
 3000 format('                       <Angle Bend Energy> :',f16.4)
      return
      end
c
      subroutine nrgsum
#include "common.fh"
c
      double precision rbuf(50)
c
c   this subroutine does a global add on some of the quantities stored
c   in the array nrg()
c
      rbuf(1) = nrg(3)
      rbuf(2) = nrg(4)
      rbuf(3) = nrg(6)
      rbuf(4) = nrg(8)
      rbuf(5) = nrg(9)
      rbuf(6) = nrg(10)
      rbuf(7) = nrg(11)
      rbuf(8) = nrg(12)
      rbuf(9) = nrg(13)
      rbuf(10) = nrg(14)
      rbuf(11) = nrg(17)
      rbuf(12) = nrg(21)
      rbuf(13) = nrg(22)
      rbuf(14) = nrg(23)
      rbuf(15) = nrg(24)
      rbuf(16) = nrg(25)
      rbuf(17) = nrg(15)
c
      call ga_dgop(3,rbuf,20,'+')
c
      nrg(3) = rbuf(1)
      nrg(4) = rbuf(2)
      nrg(6) = rbuf(3)
      nrg(8) = rbuf(4)
      nrg(9) = rbuf(5)
      nrg(10) = rbuf(6)
      nrg(11) = rbuf(7)
      nrg(12) = rbuf(8)
      nrg(13) = rbuf(9)
      nrg(14) = rbuf(10)
      nrg(17) = rbuf(11)
      nrg(21) = rbuf(12)
      nrg(22) = rbuf(13)
      nrg(23) = rbuf(14)
      nrg(24) = rbuf(15)
      nrg(25) = rbuf(16)
      nrg(15) = rbuf(17)
c
      return
      end

      SUBROUTINE ewald_setp()

      implicit none

      include 'p_const.inc'
      include 'cm_latt.inc'
      include 'cm_ewld.inc'

      real*8 axb1,axb2,axb3,bxc1,bxc2,bxc3,cxa1,cxa2,cxa3
      integer i

      ralphsq=-0.25/alpha**2

      write(*,*) "rlatt"
      write(*,*) (rlatt(i,1),i=1,3)
      write(*,*) (rlatt(i,2),i=1,3)
      write(*,*) (rlatt(i,3),i=1,3)


      axb1=rlatt(2,1)*rlatt(3,2)-rlatt(3,1)*rlatt(2,2)
      axb2=rlatt(3,1)*rlatt(1,2)-rlatt(1,1)*rlatt(3,2)
      axb3=rlatt(1,1)*rlatt(2,2)-rlatt(2,1)*rlatt(1,2)
      bxc1=rlatt(2,2)*rlatt(3,3)-rlatt(3,2)*rlatt(2,3)
      bxc2=rlatt(3,2)*rlatt(1,3)-rlatt(1,2)*rlatt(3,3)
      bxc3=rlatt(1,2)*rlatt(2,3)-rlatt(2,2)*rlatt(1,3)
      cxa1=rlatt(2,3)*rlatt(3,1)-rlatt(2,1)*rlatt(3,3)
      cxa2=rlatt(1,1)*rlatt(3,3)-rlatt(3,1)*rlatt(1,3)
      cxa3=rlatt(2,1)*rlatt(1,3)-rlatt(1,1)*rlatt(2,3)

      rvol=abs(rlatt(1,1)*bxc1+rlatt(2,1)*bxc2+rlatt(3,1)*bxc3)

      xvector=rvol/sqrt(bxc1*bxc1+bxc2*bxc2+bxc3*bxc3)
      yvector=rvol/sqrt(cxa1*cxa1+cxa2*cxa2+cxa3*cxa3)
      zvector=rvol/sqrt(axb1*axb1+axb2*axb2+axb3*axb3)

      rksqmax=min(real(kmaxx)*xvector,
     $            real(kmaxy)*yvector,
     $            real(kmaxz)*zvector)
      rksqmax=rksqmax*1.05*twopi
      rksqmax=rksqmax**2

      write(*,*) "ewald data"
      write(*,*) "kmax",kmaxx,kmaxy,kmaxz
      write(*,*) "alpha",alpha
      write(*,*) "ralphsq",ralphsq
      write(*,*) "rksqmax",rksqmax

      return

      END
c $Id: ewald_setp.f 22502 2012-05-20 06:11:57Z d3y133 $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     begin_seq_output -- Mark the start of a section of sequentialized 
C     output
C
C REVISION
C     $Id: seq_output.F 19707 2010-10-29 17:59:36Z d3y133 $
C
C SYNOPSIS
      Subroutine Begin_Seq_Output
      Implicit NONE
#include "errquit.fh"
C
C DESCRIPTION
C     Indicates the start of a section of sequentialized output.
C     Should be followed by any number of Write_Seq calls terminated
C     by an End_Seq_Output.  All output will be sent to node 0 and
C     written there in order my node number.
C
C     All nodes must participate in a sequential output section.
C
C INCLUDE FILES
#include "msgids.fh"
#include "tcgmsg.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer GoAhead, Len, Node, Me, TCG_Master
C
C     Translate from GA_NodeID to TCGMSG NODEID
C     Only need Node 0 at the moment
C
      Call GA_List_NodeID(TCG_Master, 1)
C
C     Expect node 0 to tell us to go ahead with our output.  If we
C     are node 0, this is a no-op.
C
      Me = NodeID()
      If ( Me .ne. TCG_Master) then
         Call RCV(Msg_SeqOut_Ctrl, GoAhead, MItoB(1), Len,
     $      TCG_Master, Node, 1)
         If ( GoAHead .ne. Me .OR. Node .ne. TCG_Master)
     $      Call ErrQuit(
     $        'Begin_Seq_Output: Incorrect signal from node 0: ',
     $        GoAhead, CALC_ERR)
      EndIf
      Return
      End
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     end_seq_output -- Mark the end of a section of sequentialized 
C     output
C
C REVISION
C     $Id: seq_output.F 19707 2010-10-29 17:59:36Z d3y133 $
C
C SYNOPSIS
      Subroutine End_Seq_Output
      Implicit NONE
#include "errquit.fh"
C
C DESCRIPTION
C     Indicates the end of a section of sequentialized output.
C
C     All nodes must participate in a sequential output section.
C
C BUGS
C     Because we have to declare a fixed length string, it is possible
C     for some transmissions to be truncated.  In practice, however,
C     we choose something rather longer than typical line lengths and
C     it should not be a serious problem.
C
C INCLUDE FILES
#include "msgids.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "mafdecls.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C PARAMETERS
C
C     Text longer than MaxLen will be truncated at this end.
C
      Integer MaxLen
      Parameter (MaxLen = 256)
C
C LOCAL VARIABLES
      Integer Len, Me, LUN, Node, FrNode, I, TCG_Master, H_Map, I_Map
      Character*(MaxLen) Text
C
C     Only GA nodes can participate, but we need TCGMSG node ids.
C
      if ( .NOT. MA_Push_Get(MT_Int, GA_NNodes(), 'Node list',
     $   H_Map, I_Map) )
     $   Call ErrQuit('End_Seq_Output: Insufficient memory',
     $   GA_NNodes() , MA_ERR)
      Call GA_List_NodeID(Int_MB(I_Map), GA_NNodes())
      TCG_Master = Int_MB(I_Map)
C
      Me = NodeID()
C
C     If we are not node 0, simply say we are done
C
      If ( Me .ne. TCG_Master) then
         Call SND(Msg_SeqOut_Ctrl, -Me, MItoB(1), TCG_Master, 1)
         If ( .NOT. MA_Pop_Stack(H_Map)) Call ErrQuit(
     $      'End_Seq_Output: Unable to free local memory', 0, MA_ERR)
         Return
      EndIf
C
C     If we are node 0, we have more responsibilities.  At this point
C     we have printed all of our stuff.  Now we need to listen to each
C     of the other nodes in turn.
C
      Do I = 1, GA_NNodes() - 1
         Node = Int_MB(I_Map + I)
C
C        Tell them to go ahead
C
         Call SND(Msg_SeqOut_Ctrl, Node, MItoB(1), Node, 1)
C
C        Listen for their output until we get -Node back for the
C        control signal.
C
 1000    Call RCV(Msg_SeqOut_Ctrl, LUN, MItoB(1), Len, Node, FrNode, 1)
C
         If ( LUN .ge. 0) then
            Call FCRCV(Msg_SeqOut_Text, Text, Len, Node, FrNode, 1)
            Write (LUN, '(A)') Text(:Min(Len,MaxLen))
            Goto 1000
         ElseIf ( LUN .ne. -Node) then
            Call ErrQuit('End_Seq_Output: Incorrect signal from node',
     $         Node, UNKNOWN_ERR)
         EndIf
      EndDo
C
      If ( .NOT. MA_Pop_Stack(H_Map)) Call ErrQuit(
     $   'End_Seq_Output: Unable to free local memory', 0, MA_ERR)
C
      Return
      End
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     write_seq -- Write sequentialized output
C
C REVISION
C     $Id: seq_output.F 19707 2010-10-29 17:59:36Z d3y133 $
C
C SYNOPSIS
      Subroutine Write_Seq(LUN, Text)
      Implicit NONE
#include "errquit.fh"
      Integer LUN
      Character*(*) Text
C
C DESCRIPTION
C     Write formatted output on the chosen logical unit on node 0.
C     If invoked on nodes other than 0 sends data to node 0.  Must
C     be surrounded by Begin_Seq_Output/End_Seq_Output calls.
C
C     Observe that LUN is the unit on node 0, not the invoking node!
C
C INCLUDE FILES
#include "msgids.fh"
#include "tcgmsg.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer TCG_Master
C
C     Safety check the node number because it is also a signal
C     to node 0.
C
      If ( LUN .lt. 0) Call ErrQuit(
     $   'Write_Seq: Negative unit numbers are invalid', LUN, INPUT_ERR)
C
C     Translate from GA_NodeID to TCGMSG NODEID
C     Only need Node 0 at the moment
C
      Call GA_List_NodeID(TCG_Master, 1)
C
C     Of course node 0 prints what it has, everyone else sends to node 0.
C
      If (NodeID() .eq. TCG_Master) then
         Write (LUN, '(A)') Text
      Else
         Call SND(Msg_SeqOut_Ctrl, LUN, MItoB(1), TCG_Master, 1)
         Call FCSND(Msg_SeqOut_Text, Text, TCG_Master, 1)
      EndIf
C
      Return
      End

*
* $Id: c_coulomb_screened.F 21124 2011-09-30 07:38:12Z bylaska $
*
*     *************************************************
*     *                                               *
*     *           c_coulomb_screened_init             *
*     *                                               *
*     *************************************************
*
      subroutine c_coulomb_screened_init(flag0,rcut0,pp0)
      implicit none 
      integer flag0
      real*8 rcut0,pp0

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block ****
      real*8 rcut,pp
      integer flag
      integer vc_indx,vc_hndl
      common / c_vc_screened_block / rcut,pp,flag,vc_indx,vc_hndl

*     **** local variables ****
      integer npack0

      call nwpw_timing_start(7)
      flag = flag0
      rcut = rcut0
      pp   = pp0

*     **** allocate vc memory ****
      call Cram_npack(0,npack0)
      if (.not.MA_alloc_get(mt_dbl,npack0,'vc',vc_hndl,vc_indx))
     > call errquit('c_coulomb_screened_init:out of heap memory',
     >              0,MA_ERR)


      call nwpw_timing_end(7)
      return
      end


*
*     *************************************************
*     *                                               *
*     *           c_coulomb_screened_end              *
*     *                                               *
*     *************************************************
      subroutine c_coulomb_screened_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block ****
      real*8 rcut,pp
      integer flag
      integer vc_indx,vc_hndl
      common / c_vc_screened_block / rcut,pp,flag,vc_indx,vc_hndl

      if (.not.MA_free_heap(vc_hndl))
     > call errquit('c_coulomb_screened_end:errror freeing heap',
     >              0,MA_ERR)

      return
      end


*     *************************************************
*     *                                               *
*     *           c_coulomb_screened_set              *
*     *                                               *
*     *************************************************
      subroutine c_coulomb_screened_set(kv1,kv2)
      implicit none 
      real*8 kv1(*),kv2(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block used for coulomb.f ****
      real*8 rcut,pp
      integer flag
      integer vc_indx,vc_hndl
      common / c_vc_screened_block / rcut,pp,flag,vc_indx,vc_hndl

*     **** local variables ****
      real*8 EPSILON
      logical value
      integer npack0,nfft3d,G(3),n2ft3d
      integer i,j,k,k1,k2,k3,p,q,index
      integer zero,qzero,pzero,taskid
      integer nx,ny,nz,nxh,nyh,nzh
      real*8  pi,twopi,fourpi,gg,x,y,z,temp,dV,pp2,scal1
      real*8  a(3,3),gx,gy,gz
      integer gk(2),glr(2),gk2(2)

*     **** external functions ****
      integer  c_G_indx
      real*8   util_erf,lattice_omega,lattice_unita
      external c_G_indx
      external util_erf,lattice_omega,lattice_unita


      call nwpw_timing_start(7)
      call Parallel2d_taskid_i(taskid)

      call C3dB_nfft3d(1,nfft3d)
      call C3dB_n2ft3d(1,n2ft3d)
      call Cram_npack(0,npack0)
      G(1) = c_G_indx(1)
      G(2) = c_G_indx(2)
      G(3) = c_G_indx(3)
      pp2 = pp + 2.0d0

      EPSILON=1.0d0/rcut

*     **** allocate vc memory ****
      value = MA_push_get(mt_dcpl,nfft3d,'gk',gk(2),gk(1))
      value = value.and.
     >        MA_push_get(mt_dbl,nfft3d,'glr',glr(2),glr(1))
      value = value.and.
     >        MA_push_get(mt_dbl,nfft3d,'gk2',gk2(2),gk2(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


      call C3dB_nz(1,nz)
      call C3dB_ny(1,ny)
      call C3dB_nx(1,nx)
      nxh = nx/2
      nyh = ny/2
      nzh = nz/2

      pi     = 4.0d0*datan(1.0d0)
      twopi  = 2.0d0*pi
      fourpi = 4.0d0*pi

*     **** elemental vectors ****
      do i=1,3
         a(i,1) = lattice_unita(i,1)/nx
         a(i,2) = lattice_unita(i,2)/ny
         a(i,3) = lattice_unita(i,3)/nz
      end do
      dV     = lattice_omega()/dble(nx*ny*nz)
      scal1  = 1.0d0/dble(nx*ny*nz)


*     ***********************************************
*     ***** use aperiodic definitions of kernel ******
*     ***********************************************
      if ((flag.eq.0).or.(flag.eq.2)) then

*     ***********************************
*     *** Set up the Green's function ***
*     ***********************************

*     ***** find the G==0 point in the lattice *****
      i=0
      j=0
      k=0
      call C3dB_ijktoindexp(1,i+1,j+1,k+1,zero,pzero)


      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(gk(1)),1)

*     **** short-range part of Greens function set only for short-range ****
      if (flag.eq.0) then
         do i=1,nfft3d
            gx  =  dbl_mb(G(1)+i-1) + kv1(1) - kv2(1)
            gy  =  dbl_mb(G(2)+i-1) + kv1(2) - kv2(2)
            gz  =  dbl_mb(G(3)+i-1) + kv1(3) - kv2(3)
            gg  = gx*gx + gy*gy + gz*gz

            if (gg<1.0d-6) then
               temp = pi/EPSILON**2
            else
               temp = (fourpi/gg)
     >              * (1.0d0 - dexp(-gg/(4.0d0*EPSILON**2)))
            end if
           
            dcpl_mb(gk(1)+i-1) = dcmplx(temp,0.0d0)
         end do
         call C3dB_cr_fft3b(1,dcpl_mb(gk(1)))
         call C3dB_c_SMul1(1,scal1,dcpl_mb(gk(1)))
      end if


*     **** long-range part of Greens function ****
      call dcopy(nfft3d,0.0d0,0,dbl_mb(glr(1)),1)
      do k3=-nzh,nzh-1
      do k2=-nyh,nyh-1
      do k1=-nxh,nxh-1
         i = k1
         j = k2
         k = k3
         if (i.lt.0) i=i+nx
         if (j.lt.0) j=j+ny
         if (k.lt.0) k=k+nz

         call C3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
         if (p .eq. taskid) then
            x = a(1,1)*k1 + a(1,2)*k2 + a(1,3)*k3
            y = a(2,1)*k1 + a(2,2)*k2 + a(2,3)*k3
            z = a(3,1)*k1 + a(3,2)*k2 + a(3,3)*k3

            temp = dsqrt(x*x + y*y + z*z)

            if (temp .gt. 1.0d-10) then
              temp = (util_erf(EPSILON*temp)/temp) 
            else
              temp = 2.0d0*EPSILON/dsqrt(pi)
            end if
 
            dbl_mb(glr(1)+index-1) = temp*dV
 
         end if

      end do
      end do
      end do


*     **** add long-range part to short-range part  ****
      call C3dB_rc_Sum2(1,dbl_mb(glr(1)),dcpl_mb(gk(1)))


*     **** Multiply by the screening function ****
      do k3=-nzh,nzh-1
      do k2=-nyh,nyh-1
      do k1=-nxh,nxh-1
         i = k1
         j = k2
         k = k3
         if (i.lt.0) i=i+nx 
         if (j.lt.0) j=j+ny 
         if (k.lt.0) k=k+nz 

         call C3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
         if (p .eq. taskid) then

            x = a(1,1)*k1 + a(1,2)*k2 + a(1,3)*k3
            y = a(2,1)*k1 + a(2,2)*k2 + a(2,3)*k3
            z = a(3,1)*k1 + a(3,2)*k2 + a(3,3)*k3
            temp = dsqrt(x*x + y*y + z*z)

            dbl_mb(glr(1)+index-1) 
     >        = dbl_mb(glr(1)+index-1)
     >       * (1.0d0-(1.0d0-dexp(-(temp/rcut)**pp2))**pp)

         end if

      end do
      end do
      end do


*     **** Put glr in k-space ****
      call C3dB_rc_fft3f(1,dcpl_mb(gk(1)))
        

*     *** note that only real parts of tranformed grl are used ****
      do k=1,nfft3d
         dbl_mb(gk2(1)+k-1) =  dbl_mb(glr(1)+2*(k-1)) 
      end do




*     **************************************************************
*     ***** flag==4 use erfc definitions of cutoff-kernel     ******
*     **************************************************************
      else if (flag.eq.4) then

      EPSILON=1.0d0/rcut

*     ***** find the G==0 point in the lattice *****
c      i=0
c      j=0
c      k=0
c      call C3dB_ijktoindexp(1,i+1,j+1,k+1,zero,pzero)
      call dcopy(nfft3d,0.0d0,0,dbl_mb(gk2(1)),1)

*     **** short-range part of Greens function set only for short-range ****
      do i=1,nfft3d
         gx  =  dbl_mb(G(1)+i-1) + kv1(1) - kv2(1)
         gy  =  dbl_mb(G(2)+i-1) + kv1(2) - kv2(2)
         gz  =  dbl_mb(G(3)+i-1) + kv1(3) - kv2(3)
         gg  = gx*gx + gy*gy + gz*gz

         if (gg .lt. 1.0d-6) then
            temp = pi/EPSILON**2
         else
            temp = (fourpi/gg)
     >           * (1.0d0 - dexp(-gg/(4.0d0*EPSILON**2)))
         end if
           
         dbl_mb(gk2(1)+i-1) = temp
      end do 

      end if

*     *** Cram the kernel ****
      call Cram_r_pack(0,dbl_mb(gk2(1)))
      call Cram_r_Copy(0,dbl_mb(gk2(1)),dbl_mb(vc_indx))

      value = MA_pop_stack(gk2(2))
      value = value.and.MA_pop_stack(glr(2))
      value = value.and.MA_pop_stack(gk(2))
      if (.not. value) 
     >  call errquit('c_coulomb_screened_set: poppingstack memory',0,
     &       MA_ERR)


      call nwpw_timing_end(7)

      return
      end



*     *************************************************
*     *                                               *
*     *           c_coulomb_screened_v                *
*     *                                               *
*     *************************************************
      subroutine c_coulomb_screened_v(dng,vc_out)
      implicit none
      complex*16 dng(*)
      complex*16 vc_out(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block ****
      real*8 rcut,pp
      integer flag
      integer vc_indx,vc_hndl
      common / c_vc_screened_block / rcut,pp,flag,vc_indx,vc_hndl

      call nwpw_timing_start(7)
      call Cram_rc_Mul(0,dbl_mb(vc_indx),dng,vc_out)
      call nwpw_timing_end(7)
      return 
      end

*     *************************************************
*     *                                               *
*     *           c_coulomb_screened_e                *
*     *                                               *
*     *************************************************
      real*8 function c_coulomb_screened_e(dng)
      implicit none
      complex*16 dng(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block ****
      real*8 rcut,pp
      integer flag
      integer vc_indx,vc_hndl
      common / c_vc_screened_block / rcut,pp,flag,vc_indx,vc_hndl

*     **** local variables ****
      integer npack0
      real*8 ec
      integer tmp1(2)

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega

      write(*,*) "fera,npack0=",npack0
      call util_flush(6)
      call nwpw_timing_start(7)

      call Cram_npack(0,npack0)
      write(*,*) "fera,npack0=",npack0
      if (.not.MA_push_get(mt_dbl,npack0,'tmp1',tmp1(2),tmp1(1)))
     > call errquit('c_coulomb_screened_e:out of stack memory',0,MA_ERR)
      
      call Cram_cr_Sqr(0,dng,dbl_mb(tmp1(1)))
      call Cram_rr_dot(0,dbl_mb(tmp1(1)),dbl_mb(vc_indx),ec)
      ec = 0.5d0*ec*lattice_omega()

      if (.not.MA_pop_stack(tmp1(2)))
     > call errquit('c_coulomb_screened_e:popping stack',0,MA_ERR)
      
      call nwpw_timing_end(7)
      c_coulomb_screened_e = ec
      return 
      end

*     *************************************************
*     *                                               *
*     *           c_icoulomb_screened_e               *
*     *                                               *
*     *************************************************
      real*8 function c_icoulomb_screened_e(dng)
      implicit none
      complex*16 dng(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block ****
      real*8 rcut,pp
      integer flag
      integer vc_indx,vc_hndl
      common / c_vc_screened_block / rcut,pp,flag,vc_indx,vc_hndl

*     **** local variables ****
      integer tmp1(2)
      integer npack0
      real*8 ec

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega

      call nwpw_timing_start(7)
      call Cram_npack(0,npack0)
      if (.not.MA_push_get(mt_dbl,npack0,'tmp1',tmp1(2),tmp1(1)))
     > call errquit('out of stack',0, MA_ERR)

      call Cram_cr_Sqr(0,dng,dbl_mb(tmp1(1)))
      call Cram_rr_idot(0,dbl_mb(tmp1(1)),dbl_mb(vc_indx),ec)

      ec = 0.5d0*ec*lattice_omega()

      if (.not.MA_pop_stack(tmp1(2)))
     >  call errquit('popping stack memory',0, MA_ERR)
      call nwpw_timing_end(7)

      c_icoulomb_screened_e = ec
      return
      end




*     **********************************
*     *                                *
*     *   c_coulomb_screened_euv_init  *
*     *                                *
*     **********************************

      subroutine c_coulomb_screened_euv_init(flag,rcut,pp)
      implicit none 
      integer flag
      real*8 rcut,pp

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block used for coulomb_screened_euv ****
      integer dvscr_loc(2),vloc(2)
      common / vc_screened_euv_block / dvscr_loc,vloc

*     **** local variables ****
      real*8 EPSILON
      parameter (EPSILON=1.0d0)   !** should be inputed by user! **

      logical value
      integer npack0,nfft3d,G(3),n2ft3d,u,s
      integer i,j,k,k1,k2,k3,p,q,index
      integer zero,qzero,pzero,taskid
      integer nx,ny,nz,nxh,nyh,nzh
      real*8  pi,twopi,fourpi,gg,x,y,z,temp,temp2,dV,pp2,scal1
      real*8  a(3,3),xyz(3),r
      integer gk(2),dgk(2),gr(2),dgr(2),gk2(2),dvscr(3,3)

*     **** external functions ****
      integer  G_indx
      real*8   util_erf,lattice_omega,lattice_unita
      real*8   kiril_coulomb_transform, kiril_coulomb_transform0
      external G_indx
      external util_erf,lattice_omega,lattice_unita
      external kiril_coulomb_transform, kiril_coulomb_transform0

      call nwpw_timing_start(7)
      call Parallel2d_taskid_i(taskid)


      call C3dB_nfft3d(1,nfft3d)
      call C3dB_n2ft3d(1,n2ft3d)
      call Cram_npack(0,npack0)
      G(1) = G_indx(1)
      G(2) = G_indx(2)
      G(3) = G_indx(3)
      pp2 = pp + 2.0d0

*     **** allocate vc_screened_euv_block memory ****
      value = MA_alloc_get(mt_dbl,9*npack0,'dvscr_loc',
     >                     dvscr_loc(2),dvscr_loc(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,npack0,'vloc',
     >                     vloc(2),vloc(1))
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)
      j = 0
      do s=1,3
      do u=1,3
         dvscr(u,s)  = dvscr_loc(1)  + j
         j = j + npack0
      end do
      end do

      value = MA_push_get(mt_dcpl,nfft3d,'gk',gk(2),gk(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'dgk',dgk(2),dgk(1))
      value = value.and.
     >        MA_push_get(mt_dbl,nfft3d,'gk2',gk2(2),gk2(1))
      value = value.and.
     >        MA_push_get(mt_dbl,n2ft3d,'gr',gr(2),gr(1))
      value = value.and.
     >        MA_push_get(mt_dbl,n2ft3d,'dgr',dgr(2),dgr(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


      call C3dB_nz(1,nz)
      call C3dB_ny(1,ny)
      call C3dB_nx(1,nx)
      nxh = nx/2
      nyh = ny/2
      nzh = nz/2

      pi     = 4.0d0*datan(1.0d0)
      twopi  = 2.0d0*pi
      fourpi = 4.0d0*pi

*     **** elemental vectors ****
      do i=1,3
         a(i,1) = lattice_unita(i,1)/nx
         a(i,2) = lattice_unita(i,2)/ny
         a(i,3) = lattice_unita(i,3)/nz
      end do
      dV     = lattice_omega()/dble(nx*ny*nz)
      scal1  = 1.0d0/dble(nx*ny*nz)


*     ***********************************************
*     ***** use aperiodic definitions of kernel ******
*     ***********************************************
      if (flag.eq.0) then


*     ***********************************************
*     *** Set up the short range Green's function ***
*     ***********************************************

*     ***** find the G==0 point in the lattice *****
      i=0
      j=0
      k=0
      call C3dB_ijktoindexp(1,i+1,j+1,k+1,zero,pzero)


*     **** short-range part of Greens function ****
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(gk(1)),1)
      do i=1,nfft3d

         gg  = ( dbl_mb(G(1)+i-1)*dbl_mb(G(1)+i-1)
     >         + dbl_mb(G(2)+i-1)*dbl_mb(G(2)+i-1)
     >         + dbl_mb(G(3)+i-1)*dbl_mb(G(3)+i-1) )

         if ((pzero.eq.taskid) .and. (i.eq.zero)) then
            temp = pi/EPSILON**2
         else
            temp = (fourpi/gg)
     >           * (1.0d0 - dexp(-gg/(4.0d0*EPSILON**2)))
         end if

         dcpl_mb(gk(1)+i-1)  = dcmplx(temp,0.0d0)
      end do
      call C3dB_cr_fft3b(1,dcpl_mb(gk(1)))
      call dcopy(n2ft3d,dcpl_mb(gk(1)), 1,dbl_mb(gr(1)), 1)


*     **** Multiply by the screening function ****
      do k3=-nzh,nzh-1
      do k2=-nyh,nyh-1
      do k1=-nxh,nxh-1
         i = k1
         j = k2
         k = k3
         if (i.lt.0) i=i+nx
         if (j.lt.0) j=j+ny
         if (k.lt.0) k=k+nz

         call C3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
         if (p .eq. taskid) then
            x = a(1,1)*k1 + a(1,2)*k2 + a(1,3)*k3
            y = a(2,1)*k1 + a(2,2)*k2 + a(2,3)*k3
            z = a(3,1)*k1 + a(3,2)*k2 + a(3,3)*k3
            r = dsqrt(x*x + y*y + z*z)
            dbl_mb(gr(1)+index-1)
     >        = dbl_mb(gr(1)+index-1)
     >         *(1.0d0-(1.0d0-dexp(-(r/rcut)**pp2))**pp)
         end if

      end do
      end do
      end do
      call C3dB_r_SMul1(1,scal1,dbl_mb(gr(1)))


*     **** Put gk in k-space ****
      call C3dB_rc_fft3f(1,dbl_mb(gr(1)))


*     *** note that only real parts of tranformed gls are used ****
      do k=1,nfft3d
         dbl_mb(gk2(1)+k-1) =  dbl_mb(gr(1)+2*(k-1))
      end do

*     *** Cram the kernel ****
      call Cram_r_pack(0,dbl_mb(gk2(1)))
      call Cram_r_Copy(0,dbl_mb(gk2(1)),dbl_mb(vloc(1)))




*     *********************************************
*     *** Set up the Green's function gradients ***
*     *********************************************
      do s=1,3
      do u=1,3


*     **** short-range part of Greens function ****
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(gk(1)),1)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(dgk(1)),1)
      do i=1,nfft3d

         gg  = ( dbl_mb(G(1)+i-1)*dbl_mb(G(1)+i-1)
     >         + dbl_mb(G(2)+i-1)*dbl_mb(G(2)+i-1)
     >         + dbl_mb(G(3)+i-1)*dbl_mb(G(3)+i-1) )

         if ((pzero.eq.taskid) .and. (i.eq.zero)) then
            temp = pi/EPSILON**2
            temp2 = 0.0d0
         else
            temp = (fourpi/gg)
     >           * (1.0d0 - dexp(-gg/(4.0d0*EPSILON**2)))
            temp2 = (-2.0d0*dbl_mb(G(u)+i-1)*dbl_mb(G(s)+i-1))
     >            * ( (-fourpi/(gg*gg))
     >               *(1.0d0 - dexp(-gg/(4.0d0*EPSILON**2)))
     >               + (pi/(gg*EPSILON**2))
     >                *dexp(-gg/(4.0d0*EPSILON**2)))
         end if

         dcpl_mb(gk(1)+i-1)  = dcmplx(temp,0.0d0)
         dcpl_mb(dgk(1)+i-1) = dcmplx(temp2,0.0d0)
      end do
      call C3dB_cr_fft3b(1,dcpl_mb(gk(1)))
      call C3dB_cr_fft3b(1,dcpl_mb(dgk(1)))

      call dcopy(n2ft3d,dcpl_mb(gk(1)), 1,dbl_mb(gr(1)), 1)
      call dcopy(n2ft3d,dcpl_mb(dgk(1)),1,dbl_mb(dgr(1)),1)


*     **** Multiply by the screening function ****
      do k3=-nzh,nzh-1
      do k2=-nyh,nyh-1
      do k1=-nxh,nxh-1
         i = k1
         j = k2
         k = k3
         if (i.lt.0) i=i+nx 
         if (j.lt.0) j=j+ny 
         if (k.lt.0) k=k+nz 

         call C3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
         if (p .eq. taskid) then
            x = a(1,1)*k1 + a(1,2)*k2 + a(1,3)*k3
            y = a(2,1)*k1 + a(2,2)*k2 + a(2,3)*k3
            z = a(3,1)*k1 + a(3,2)*k2 + a(3,3)*k3
            r = dsqrt(x*x + y*y + z*z)
            xyz(1) = x
            xyz(2) = y
            xyz(3) = z

            if (r.gt.1.0d-10) then
              gg = -dexp(-(r/rcut)**pp2)
              gg = gg*(1.0d0-dexp(-(r/rcut)**pp2))**(pp-1)
              gg = gg*(pp*pp2)*(r/rcut)**(pp+1)
              gg = gg/rcut
              dbl_mb(gr(1)+index-1) = 
     >           dbl_mb(gr(1)+index-1)*gg*(xyz(u)*xyz(s))/r
            else
              dbl_mb(gr(1)+index-1) = 0.0d0
            end if

            dbl_mb(gr(1)+index-1) 
     >        = dbl_mb(gr(1)+index-1)
     >        + dbl_mb(dgr(1)+index-1)
     >         *(1.0d0-(1.0d0-dexp(-(r/rcut)**pp2))**pp)

         end if

      end do
      end do
      end do
      call C3dB_r_SMul1(1,scal1,dbl_mb(gr(1)))


*     **** Put gr in k-space ****
      call C3dB_rc_fft3f(1,dbl_mb(gr(1)))
        

*     *** note that only real parts of tranformed gls are used ****
      do k=1,nfft3d
         dbl_mb(gk2(1)+k-1) =  dbl_mb(gr(1)+2*(k-1)) 
      end do

*     *** Cram the kernel ****
      call Cram_r_pack(0,dbl_mb(gk2(1)))
      call Cram_r_Copy(0,dbl_mb(gk2(1)),dbl_mb(dvscr(u,s)))


*     **** long-range part of Greens function ****
      call dcopy(n2ft3d,0.0d0,0,dbl_mb(gr(1)),1)
      call dcopy(n2ft3d,0.0d0,0,dbl_mb(dgr(1)),1)
      do k3=-nzh,nzh-1
      do k2=-nyh,nyh-1
      do k1=-nxh,nxh-1
         i = k1
         j = k2
         k = k3
         if (i.lt.0) i=i+nx
         if (j.lt.0) j=j+ny
         if (k.lt.0) k=k+nz

         call C3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
         if (p .eq. taskid) then
            x = a(1,1)*k1 + a(1,2)*k2 + a(1,3)*k3
            y = a(2,1)*k1 + a(2,2)*k2 + a(2,3)*k3
            z = a(3,1)*k1 + a(3,2)*k2 + a(3,3)*k3
            r = dsqrt(x*x + y*y + z*z)
            xyz(1) = x
            xyz(2) = y
            xyz(3) = z

            if (r .gt. 1.0d-10) then
              temp  = (util_erf(EPSILON*r)/r)
              temp2 = ((2.0d0*EPSILON/dsqrt(pi))
     >              *dexp(-EPSILON**2*r**2)/r
     >             - (util_erf(EPSILON*r)/r**2))

            else
              temp  = 2.0d0*EPSILON/dsqrt(pi)
              temp2 = 0.0d0
            end if

            dbl_mb(gr(1)+index-1)  = temp
            dbl_mb(dgr(1)+index-1) = temp2
         end if

      end do
      end do
      end do


*     **** Multiply by the screening function ****
      do k3=-nzh,nzh-1
      do k2=-nyh,nyh-1
      do k1=-nxh,nxh-1
         i = k1
         j = k2
         k = k3
         if (i.lt.0) i=i+nx
         if (j.lt.0) j=j+ny
         if (k.lt.0) k=k+nz

         call C3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
         if (p .eq. taskid) then
            x = a(1,1)*k1 + a(1,2)*k2 + a(1,3)*k3
            y = a(2,1)*k1 + a(2,2)*k2 + a(2,3)*k3
            z = a(3,1)*k1 + a(3,2)*k2 + a(3,3)*k3
            r = dsqrt(x*x + y*y + z*z)
            xyz(1) = x
            xyz(2) = y
            xyz(3) = z

            if (r.gt.1.0d-10) then
              gg = -dexp(-(r/rcut)**pp2)
              gg = gg*(1.0d0-dexp(-(r/rcut)**pp2))**(pp-1)
              gg = gg*(pp*pp2)*(r/rcut)**(pp+1)
              gg = gg/rcut
              dbl_mb(gr(1)+index-1) =
     >           dbl_mb(gr(1)+index-1)*gg
            else
              dbl_mb(gr(1)+index-1) = 0.0d0
            end if

            dbl_mb(gr(1)+index-1)
     >        = dbl_mb(gr(1)+index-1)
     >        + dbl_mb(dgr(1)+index-1)
     >         *(1.0d0-(1.0d0-dexp(-(r/rcut)**pp2))**pp)

            if (r.gt.1.0d-10) then
              dbl_mb(gr(1)+index-1)
     >          = dbl_mb(gr(1)+index-1)*xyz(u)*xyz(s)/r
            else
              dbl_mb(gr(1)+index-1) = 0.0d0
            end if

         end if

      end do
      end do
      end do
      call C3dB_r_SMul1(1,dV,dbl_mb(gr(1)))


*     **** Put gk in k-space ****
      call C3dB_rc_fft3f(1,dbl_mb(gr(1)))


*     *** note that only real parts of tranformed gls are used ****
      do k=1,nfft3d
         dbl_mb(gk2(1)+k-1) =  dbl_mb(gr(1)+2*(k-1))
      end do

*     *** Cram the kernel ****
      call Cram_r_pack(0,dbl_mb(gk2(1)))
      call Cram_rr_Sum2(0,dbl_mb(gk2(1)),dbl_mb(dvscr(u,s)))

      end do 
      end do 

*     *******************************************
*     ***** use erfc definitions of kernel ******
*     ******************************************* 
      else if (flag.eq.4) then
*     ***********************************************
*     *** Set up the short range Green's function ***
*     ***********************************************
*     ***** find the G==0 point in the lattice *****
      i=0
      j=0
      k=0
      call C3dB_ijktoindexp(1,i+1,j+1,k+1,zero,pzero)

*     **** short-range part of Greens function ****
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(gk(1)),1)
      do i=1,nfft3d

         gg  = ( dbl_mb(G(1)+i-1)*dbl_mb(G(1)+i-1)
     >         + dbl_mb(G(2)+i-1)*dbl_mb(G(2)+i-1)
     >         + dbl_mb(G(3)+i-1)*dbl_mb(G(3)+i-1) )

         if ((pzero.eq.taskid) .and. (i.eq.zero)) then
            temp = pi/EPSILON**2
         else
            temp = (fourpi/gg)
     >           * (1.0d0 - dexp(-gg/(4.0d0*EPSILON**2)))
         end if

         dbl_mb(gk2(1)+i-1)  = temp
      end do

*     *** Cram the kernel ****
      call Cram_r_pack(0,dbl_mb(gk2(1)))
      call Cram_r_Copy(0,dbl_mb(gk2(1)),dbl_mb(vloc(1)))






*     ***********************************************
*     ***** use periodic definitions of kernel ******
*     ***********************************************
      else
        write(*,*) "periodic screening stresses not implemented!"
        call errquit('coulomb_screened_euv_init:',0,0)
      end if



*     *** free up stack memory ***
      value =           MA_pop_stack(dgr(2))
      value =           MA_pop_stack(gr(2))
      value = value.and.MA_pop_stack(gk2(2))
      value = value.and.MA_pop_stack(dgk(2))
      value = value.and.MA_pop_stack(gk(2))
      if (.not. value) 
     >  call errquit('coulomb_screened_euv_init: popping stack',0,
     &       MA_ERR)

      call nwpw_timing_end(7)
      return
      end


*     **********************************
*     *                                *
*     *   c_coulomb_screened_euv_end   *
*     *                                *
*     **********************************

      subroutine c_coulomb_screened_euv_end()
      implicit none
#include "mafdecls.fh"

*     **** common block used for coulomb_screened_euv ****
      integer dvscr_loc(2),vloc(2)
      common / vc_screened_euv_block / dvscr_loc,vloc

      logical value

      value = MA_free_heap(dvscr_loc(2))
      value = value.and.MA_free_heap(vloc(2))
      if (.not. value) 
     >  call errquit('coulomb_screened_euv_end: freeing heap',0,0)
      return
      end



*     **********************************
*     *                                *
*     *    c_coulomb_screened_euv      *
*     *                                *
*     **********************************
      subroutine c_coulomb_screened_euv(dng,euv)
      implicit none 
      complex*16 dng(*)
      real*8 euv(3,3)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block used for coulomb_screened_euv ****
      integer dvscr_loc(2),vloc(2)
      common / vc_screened_euv_block / dvscr_loc,vloc


*     **** local variables ****
      integer npack0
      integer i,j
      integer u,v,s
      logical value

      real*8 pi,scal,ss,sum
      real*8 hm(3,3),Bus(3,3),ec
      integer tmp1(2),dvscr(3,3)

*     **** external functions ****
      real*8   lattice_unitg,lattice_omega
      external lattice_unitg,lattice_omega


      call Cram_npack(0,npack0)
      value = MA_push_get(mt_dbl,npack0,'tmp1',tmp1(2),tmp1(1))
      if (.not. value) 
     > call errquit('coulomb_screened_euv:out of stack memory',0,MA_ERR)
      j = 0
      do s=1,3
      do u=1,3
         dvscr(u,s)  = dvscr_loc(1)  + j
         j = j + npack0
      end do
      end do

*     *** compute local screened coulomb energy ***
      call Cram_cr_Sqr(0,dng,dbl_mb(tmp1(1)))
      call Cram_rr_dot(0,dbl_mb(tmp1(1)),dbl_mb(vloc(1)),ec)
      ec = 0.5d0*ec*lattice_omega()

*     **** Bus = Sum(G) (omega/2)*dvscr_loc(G,u,v) ****
      call dcopy(9,0.0d0,0,Bus,1)
      ss     = 0.5d0*lattice_omega()
      do u=1,3
      do s=u,3
        call Cram_rr_dot(0,dbl_mb(tmp1(1)),dbl_mb(dvscr(u,s)),sum)
        Bus(u,s) = ss*sum
      end do
      end do
      do u=1,3
      do s=u+1,3
         Bus(s,u) = Bus(u,s)
      end do
      end do

      pi     = 4.0d0*datan(1.0d0)
      scal   = 1.0d0/(2.0d0*pi)

*     *** define hm ****
      do j=1,3
      do i=1,3
         hm(i,j) = scal*lattice_unitg(i,j)
      end do
      end do      

      do v=1,3
      do u=1,3
         euv(u,v) = -ec*hm(u,v)
         do s=1,3
            euv(u,v) = euv(u,v) + Bus(u,s)*hm(s,v)
         end do
      end do
      end do

      if (.not.MA_pop_stack(tmp1(2)))
     > call errquit('c_coulomb_screened_euv:popping stack',0,MA_ERR)

      return
      end

c
      LOGICAL FUNCTION ACOLO_1P_1H(p1b,h1b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER h1b
      INTEGER p1b
      INTEGER iocc_o
      INTEGER iocc_v
      acolo_1p_1h = .false.
      iocc_o=int_mb(k_active+h1b-1)
      iocc_v=int_mb(k_active+p1b-1)
      if(iocc_o.ge.numact-2.and.iocc_v.ge.numact-2) acolo_1p_1h=.true.
      RETURN
      END
c $Id: acolo_1p_1h.F 21176 2011-10-10 06:35:49Z d3y133 $

c $Id: metadynamics.F 25998 2014-08-16 18:46:52Z bylaska $

c     **********************************************
c     *                                            *
c     *            meta_initialize                 *
c     *                                            *
c     **********************************************
      subroutine meta_initialize(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "metadynamics.fh"

*     **** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)
      logical value,cnmeta_read
      integer d,i,j,n1,n2,s1,s2,yshift,ntype
      real*8 x,y,z,r,rmax,dr,pi,da,maxcoord,a,b,n,m,sigma,w,r0,s0,v0,dv0
      real*8 boundary(2),temp,fac,sn2(12)
      character*80 rtdb_name,potential_filename
      character*60 gauss_filename
      character*4 celement1,celement2
      character*500 eqnstring

*     **** external functions ****
      logical     control_Nose
      real*8      lattice_unita,ion_Temperature,control_Nose_Tr
      character*7 c_index_name
      integer     control_it_out
      external    control_Nose
      external    lattice_unita,ion_Temperature,control_Nose_Tr
      external    c_index_name
      external    control_it_out

      call Parallel_taskid(taskid)
      metaprintcount = 0
      rtdb_name = 'metadynamics_print'
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,maxmetaprintcount)) 
     >   maxmetaprintcount=100

      rtdb_name = 'metadynamics_nmeta'
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nmeta)) nmeta = 0

      metafound = (nmeta.gt.0)

      if (metafound) then

         rtdb_name = 'metadynamics_update'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,maxmetacount)) 
     >      maxmetacount = 1

         rtdb_name = 'metadynamics_metacount'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,metacount)) 
     >      metacount = 0

         rtdb_name = 'metadynamics_print_shift'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,metarayshift)) 
     >      metarayshift = maxmetaprintcount

         rtdb_name = 'metadynamics_metaraycount'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,metaraycount)) 
     >      metaraycount = 0

         rtdb_name = 'metadynamics_tempered'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,1,dTtempered)) 
     >      dTtempered = -1.0d0

         rtdb_name = 'metadynamics_boundary'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,2,boundary)) then
            boundary(1) = 0.0d0
            boundary(2) = 0.0d0
         end if

         rtdb_name = 'metadynamics_sn2-surface'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,12,sn2)) then
            call dcopy(12,0.0d0,0,sn2,1)
         end if

         value = .true.
         if (nmeta.gt.0) then
            rtdb_name = 'metadynamics_nindxmeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nindxmeta)) 
     >         nindxmeta = 0
            rtdb_name = 'metadynamics_nparammeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nparammeta)) 
     >         nparammeta = 0
            rtdb_name = 'metadynamics_nxmeta_all'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,nxmeta_all)) 
     >         nxmeta_all = 0

*           **** allocate and read nxmeta,sindxmeta,sparameta,and indxmeta ****
            value = value.and.
     >              MA_alloc_get(mt_int,nmeta,'nxmeta',
     >                           nxmeta(2),nxmeta(1))
            value = value.and.
     >              MA_alloc_get(mt_int,nmeta,'sindxmeta',
     >                           sindxmeta(2),sindxmeta(1))
            value = value.and.
     >              MA_alloc_get(mt_int,nmeta,'sparammeta',
     >                           sparammeta(2),sparammeta(1))
            value = value.and.
     >              MA_alloc_get(mt_int,nindxmeta,'indxmeta',
     >                           indxmeta(2),indxmeta(1))

            rtdb_name = 'metadynamics_nxmeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,nmeta,
     >                        int_mb(nxmeta(1)))) then
               do d=1,nmeta
                  int_mb(nxmeta(1)+d-1) = 0
               end do
            end if
            rtdb_name = 'metadynamics_sindxmeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,nmeta,
     >                        int_mb(sindxmeta(1)))) then
               do d=1,nmeta
                  int_mb(sindxmeta(1)+d-1) = 0
               end do
            end if
            rtdb_name = 'metadynamics_sparammeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,nmeta,
     >                        int_mb(sparammeta(1)))) then
               do d=1,nmeta
                  int_mb(sindxmeta(1)+d-1) = 0
               end do
            end if
            rtdb_name = 'metadynamics_indxmeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,nindxmeta,
     >                        int_mb(indxmeta(1)))) then
               do d=1,nindxmeta
                  int_mb(indxmeta(1)+d-1) = 0
               end do
            end if



*           ***** allocate and read pmeta,ameta,bmeta,parammeta, and ymeta ****
            value = value.and.
     >              MA_alloc_get(mt_int,nmeta,'pmeta',pmeta(2),pmeta(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nmeta,'ameta',ameta(2),ameta(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nmeta,'bmeta',bmeta(2),bmeta(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nparammeta,'parammeta',
     >                           parammeta(2),parammeta(1))
            value = value.and.
     >              MA_alloc_get(mt_dbl,nxmeta_all,
     >                           'ymeta',ymeta(2),ymeta(1))

            rtdb_name = 'metadynamics_pmeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_int,nmeta,
     >                        int_mb(pmeta(1)))) then
               do d=1,nmeta
                  int_mb(pmeta(1)+d-1) = 0
               end do
            end if
            rtdb_name = 'metadynamics_ameta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,nmeta,
     >                        dbl_mb(ameta(1)))) then
               do d=1,nmeta
                  dbl_mb(ameta(1)+d-1) = 0.0d0
               end do
            end if
            rtdb_name = 'metadynamics_bmeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,nmeta,
     >                        dbl_mb(bmeta(1)))) then
               do d=1,nmeta
                  dbl_mb(bmeta(1)+d-1) = 0.0d0
               end do
            end if
            rtdb_name = 'metadynamics_parammeta'
            if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,nparammeta,
     >                        dbl_mb(parammeta(1)))) then
               do d=1,nparammeta
                  dbl_mb(parammeta(1)+d-1) = 0.0d0
               end do
            end if

*           **** set default limits ****
            x = lattice_unita(1,1)
            y = lattice_unita(2,1)
            z = lattice_unita(3,1)
            r = dsqrt(x*x+y*y+z*z)
            rmax = r
            x = lattice_unita(1,2)
            y = lattice_unita(2,2)
            z = lattice_unita(3,2)
            r = dsqrt(x*x+y*y+z*z)
            if (r.gt.rmax) rmax = r
            x = lattice_unita(1,3)
            y = lattice_unita(2,3)
            z = lattice_unita(3,3)
            r = dsqrt(x*x+y*y+z*z)
            if (r.gt.rmax) rmax = r
            do d=1,nmeta
               s1 = int_mb(sindxmeta(1) +d-1)
               if ((int_mb(indxmeta(1)+s1).eq.1).or.
     >             (int_mb(indxmeta(1)+s1).eq.5)) then
                  if (int_mb(pmeta(1)+d-1).lt.0)
     >               int_mb(pmeta(1)+d-1) = 0
                  if (dbl_mb(ameta(1)+d-1).lt.0.0d0) 
     >               dbl_mb(ameta(1)+d-1) = 0.0d0
                  if (dbl_mb(bmeta(1)+d-1).lt.0.0d0)
     >               dbl_mb(bmeta(1)+d-1) = rmax
               end if
               if (int_mb(indxmeta(1)+s1).eq.2) then
                  if (int_mb(pmeta(1)+d-1).lt.0)
     >               int_mb(pmeta(1)+d-1) = 0
                  if (dbl_mb(ameta(1)+d-1).lt.(-99.0d0))
     >               dbl_mb(ameta(1)+d-1) = 0.0d0
                  if (dbl_mb(bmeta(1)+d-1).lt.(-99.0d0))
     >               dbl_mb(bmeta(1)+d-1) = 4.0d0*datan(1.0d0)
               end if
            end do
         end if

*        **** load old spline fits ****
         call dcopy(nxmeta_all,0.0d0,0,dbl_mb(ymeta(1)),1)
         rtdb_name = 'metadynamics_ymeta'
         if (.not.rtdb_get(rtdb,rtdb_name,mt_dbl,nxmeta_all,
     >                       dbl_mb(ymeta(1)))) then
            call dcopy(nxmeta_all,0.0d0,0,dbl_mb(ymeta(1)),1)
            if (boundary(1).gt.0.0d0) then
               if (taskid.eq.MASTER)
     >            write(luout,'(A,2F11.6)') 
     >                 "  ... setting boundary, w,sigma=",
     >                 boundary(1),boundary(2)
               call meta_setboundary(boundary(1),boundary(2))
            end if
            if (dabs(sn2(1)).gt.0.0d0) then
               if (taskid.eq.MASTER)
     >            write(luout,'(A)') "  ... setting sn2 surface"
               call meta_setsn2surface(sn2)
            end if
         else
            if (taskid.eq.MASTER) 
     >        write(luout,*) "  ... reading metadynamics data from rtdb"

            !*** re-scale tempered ***
            fac = 1.0d0
            if (dTtempered.gt.0.0d0) then
               if (taskid.eq.MASTER) 
     >            write(luout,*) 
     >            "  ... re-scaling to be consistent with tempering"
               if (control_Nose()) then
                  temp = control_Nose_Tr()
               else
                  temp = ion_Temperature()
               end if
               fac = dTtempered/(temp+dTtempered)
            end if
            do i=1,nxmeta_all
               dbl_mb(ymeta(1)+i-1) = fac*dbl_mb(ymeta(1)+i-1)
            end do
         end if


         call nwpw_interp_init(nmeta,8)

         if (.not.value)
     >    call errquit('cannot allocate heap memory for metadynamics',0,
     >       MA_ERR)


*        **** iniitialize meta_gauss_write ****
         rtdb_name = 'metadynamics_gaussian_filename'
         gauss_filename = 
     >   '                                                           '
         if(.not.rtdb_cget(rtdb,rtdb_name,1,gauss_filename))
     >      call util_file_prefix('meta_gaussians',gauss_filename)
         call meta_gauss_write_init(gauss_filename)

*        **** start nwpw_expression ****
         call nwpw_expression_start(rtdb)


*     **** write out header info ****
      call Parallel_taskid(taskid)
      value = rtdb_parallel(.false.)
      if (taskid.eq.MASTER) then
         write(luout,*) 
         write(luout,*)  "MetaDynamics parameters:"
         write(luout,'(A,5x,I6," * inner iterations")')
     >   "   - update      = ",maxmetacount
         write(luout,'(A,5x,I6," * inner iterations")')
     >   "   - print       = ",maxmetaprintcount
         write(luout,'(A,5x,I6)') "   - print_shift = ",metarayshift
         if (dTtempered.gt.0.0d0) then
            write(luout,'(A,5x,F11.1)') 
     >      "   - Tempered dT (K) = ",dTtempered
         end if
         do d=1,nmeta
            s1 = int_mb(sindxmeta(1) +d-1)
            s2 = int_mb(sparammeta(1)+d-1)
            ntype = int_mb(indxmeta(1)+s1)
            w     = dbl_mb(parammeta(1)+s2)
            sigma = dbl_mb(parammeta(1)+s2+1)

            if (ntype.eq.1) then
             write(luout,'(A,5x,2I4,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - Bond Parameters =  ",
     >           (int_mb(indxmeta(1)+s1+j),j=1,2),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic=',int_mb(pmeta(1)+d-1) 

            else if (ntype.eq.2) then
             write(luout,'(A,3I4,4x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - Angle Parameters =  ",
     >           (int_mb(indxmeta(1)+s1+j),j=1,3),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic=',int_mb(pmeta(1)+d-1) 

            else if (ntype.eq.4) then
             n1 = int_mb(indxmeta(1)+s1+1)
             n2 = int_mb(indxmeta(1)+s1+2)
             n  =  dbl_mb(parammeta(1)+s2+2)
             m  =  dbl_mb(parammeta(1)+s2+3)
             r0 =  dbl_mb(parammeta(1)+s2+4)
             write(luout,1001) (int_mb(indxmeta(1)+s1+3+j-1),j=1,n1)
             write(luout,1002) (int_mb(indxmeta(1)+s1+3+n1+j-1),j=1,n2)

             write(luout,'(A,/6x,A,F11.6,4x,A,F11.6,
     >                   /6x,A,F11.6,4x,A,F11.6,
     >                   /6x,A,F11.6,
     >                   /6x,A,F11.6,F11.6,
     >                   /6x,A,I5,
     >                   /6x,A,I2)')
     >       "  - Coordination Number Parameters: ",
     >           'n= ',n,'m=       ',m,
     >           'w= ',w,'sigma=   ',sigma,
     >           'r0=',r0,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'ngrid=  ',int_mb(nxmeta(1)+d-1),
     >           'periodic=  ',int_mb(pmeta(1)+d-1)
              if (dbl_mb(parammeta(1)+s2+5).lt.0) then
                 write(luout,'(6x,A)') '- LJ function form'
              else
                 write(luout,'(6x,A)') '- Sprik function form'
              end if

            else if (ntype.eq.5) then
             n1 = int_mb(indxmeta(1)+s1+2)
             write(luout,1001) int_mb(indxmeta(1)+s1+1)
             write(luout,1002) (int_mb(indxmeta(1)+s1+3+j-1),j=1,n1)
             write(luout,'(A,5x,
     >                /6x,A,F11.6,F11.6,F11.6,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "  - n-plane Parameters =  ",
     >           'normal=',
     >           dbl_mb(parammeta(1)+s2+2),
     >           dbl_mb(parammeta(1)+s2+3),
     >           dbl_mb(parammeta(1)+s2+4),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic= ',int_mb(pmeta(1)+d-1)
            else if (ntype.eq.6) then

             if (int_mb(indxmeta(1)+s1+1).eq.1) then
             write(luout,'(A,5x,I4,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - X Parameters =  ",
     >           int_mb(indxmeta(1)+s1+2),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic= ',int_mb(pmeta(1)+d-1)
             else if (int_mb(indxmeta(1)+s1+1).eq.2) then
             write(luout,'(A,5x,I4,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - Y Parameters =  ",
     >           int_mb(indxmeta(1)+s1+2),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic= ',int_mb(pmeta(1)+d-1)
             else 
             write(luout,'(A,5x,I4,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - Z Parameters =  ",
     >           int_mb(indxmeta(1)+s1+2),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic= ',int_mb(pmeta(1)+d-1)
             end if

            else if (ntype.eq.7) then
             write(luout,'(A,5x,A,I4,4x,A,I4,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - local_density_trace Parameters =  ",
     >           'atom index=',int_mb(indxmeta(1)+s1+1),
     >           'l=',int_mb(indxmeta(1)+s1+2),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic=',int_mb(pmeta(1)+d-1) 

            else if (ntype.eq.8) then
             write(luout,'(A,
     >                /6x,A,2I4,
     >                /6x,A,2I4,
     >                /6x,A,2F11.6,
     >                /6x,A,2F11.6,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - 2Bonds Parameters =  ",
     >           'bond 1 indexes=',(int_mb(indxmeta(1)+s1+j),j=1,2),
     >           'bond 2 indexes=',(int_mb(indxmeta(1)+s1+j),j=3,4),
     >           'bond center 1 =',(dbl_mb(parammeta(1)+s2+j),j=2,3),
     >           'bond center 2 =',(dbl_mb(parammeta(1)+s2+j),j=4,5),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic=',int_mb(pmeta(1)+d-1)

            else if (ntype.eq.9) then
             write(luout,'(A,5x,A,I4,4x,A,I4,4x,A,I4,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - local_density_trace2_diff Parameters =  ",
     >           'atom index1=',int_mb(indxmeta(1)+s1+1),
     >           'atom index2=',int_mb(indxmeta(1)+s1+2),
     >           'l=',int_mb(indxmeta(1)+s1+3),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic=',int_mb(pmeta(1)+d-1) 

            else if (ntype.eq.10) then
             write(luout,'(A,
     >                /6x,A,3I4,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >       "   - Bond_Difference2 Parameters =  ",
     >           'bond indexes=',(int_mb(indxmeta(1)+s1+j),j=1,3),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic=',int_mb(pmeta(1)+d-1)

            else if (ntype.eq.11) then
             n1 = int_mb(indxmeta(1)+s1+1)
             n2 = int_mb(indxmeta(1)+s1+2)
             n  =  dbl_mb(parammeta(1)+s2+2)
             m  =  dbl_mb(parammeta(1)+s2+3)
             r0 =  dbl_mb(parammeta(1)+s2+4)
             v0  =  dbl_mb(parammeta(1)+s2+6)
             dv0 =  dbl_mb(parammeta(1)+s2+7)
             write(luout,1003) (int_mb(indxmeta(1)+s1+3+j-1),j=1,n1)
             write(luout,1004) (int_mb(indxmeta(1)+s1+3+n1+j-1),j=1,n2)

             write(luout,'(A,/6x,A,F11.6,4x,A,F11.6,
     >                   /6x,A,F11.6,4x,A,F11.6,
     >                   /6x,A,F11.6,4x,A,F11.6,F11.6,
     >                   /6x,A,F15.6,F15.6,
     >                   /6x,A,I5,
     >                   /6x,A,I2)')
     >       "  - Bond_Difference_Shell Parameters: ",
     >           'n= ',n,'m=       ',m,
     >           'w= ',w,'sigma=   ',sigma,
     >           'r0=',r0,'V0,dV0= ',v0,dv0,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'ngrid=  ',int_mb(nxmeta(1)+d-1),
     >           'periodic=  ',int_mb(pmeta(1)+d-1)
              if (dbl_mb(parammeta(1)+s2+5).lt.0) then
                 write(luout,'(6x,A)') '- LJ function form'
              else
                 write(luout,'(6x,A)') '- Sprik function form'
              end if

            else if (ntype.eq.12) then
               call nwpw_expression_eqnstring(rtdb,
     >                                        int_mb(indxmeta(1)+s1+1),
     >                                        eqnstring)
               write(luout,'(A,/6x,A,A,
     >                /6x,A,F11.6,4x,A,F11.6,
     >                /6x,A,F11.6,F11.6,4x,A,I5,4x,A,I2)')
     >           '  - Equation Parameters: ',
     >           'equation= ',trim(eqnstring),
     >           'w=',w,'sigma=',sigma,
     >           'range=  ',dbl_mb(ameta(1)+d-1),dbl_mb(bmeta(1)+d-1),
     >           'nrange= ',int_mb(nxmeta(1)+d-1),
     >           'periodic=',int_mb(pmeta(1)+d-1) 

            end if

         end do

 1001 FORMAT(2x,"- Coorination Number (Index1) :",10I5)
 1002 FORMAT(2x,"- Coorination Number (Index2) :",10I5)
 1003 FORMAT(2x,"- Bond Difference Indexes (Index1) :",10I5)
 1004 FORMAT(2x,"- Bath Indexes            (Index2) :",10I5)

      end if
      value = rtdb_parallel(.true.)
      
      end if
      return
      end

c     **********************************************
c     *                                            *
c     *            meta_finalize                   *
c     *                                            *
c     **********************************************
      subroutine meta_finalize(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)

      logical value
      integer i,j,yshift,k
      real*8 temp,fac
      character*80 filename,rtdb_name
      character*255 full_filename

*     **** external functions ****
      logical  control_Nose
      external control_Nose
      character*7 c_index_name
      external    c_index_name
      real*8   control_Nose_Tr,ion_Temperature
      external control_Nose_Tr,ion_Temperature

      call Parallel_taskid(taskid)

      if (metafound) then

*        **** print out potentials ******
         !metaraycount = metaraycount + metarayshift
         call meta_print_potentials(0)

         value=.true.
         rtdb_name='metadynamics_metacount'
         value= value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,metacount)
         rtdb_name='metadynamics_metaraycount'
         value= value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,metaraycount)

         if (nmeta.gt.0) then

            !*** un-scale tempered ***
            fac = 1.0d0
            if (dTtempered.gt.0.0d0) then
               if (control_Nose()) then
                  temp = control_Nose_Tr()
               else
                  temp = ion_Temperature()
               end if
               fac = (temp+dTtempered)/dTtempered
            end if
            do i=1,nxmeta_all
               dbl_mb(ymeta(1)+i-1) = fac*dbl_mb(ymeta(1)+i-1)
            end do 

*           **** write out current spline fits ****
            rtdb_name = 'metadynamics_ymeta'
            value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                        nxmeta_all,dbl_mb(ymeta(1)))

            value = value.and.MA_free_heap(pmeta(2))
            value = value.and.MA_free_heap(ameta(2))
            value = value.and.MA_free_heap(bmeta(2))
            value = value.and.MA_free_heap(nxmeta(2))
            value = value.and.MA_free_heap(indxmeta(2))
            value = value.and.MA_free_heap(parammeta(2))
            value = value.and.MA_free_heap(sindxmeta(2))
            value = value.and.MA_free_heap(sparammeta(2))
            value = value.and.MA_free_heap(ymeta(2))
            call nwpw_interp_end()
            call meta_gauss_write_end()

            call nwpw_expression_end(rtdb)

         end if

      end if

      return
      end


c     **********************************************
c     *                                            *
c     *            meta_collective                 *
c     *                                            *
c     **********************************************
      real*8 function meta_collective(indx,param,ispin,ne,psi1)
      implicit none
      integer indx(*)
      real*8  param(*)
      integer ispin,ne(2)
      real*8  psi1(*)

#include "mafdecls.fh"

*     **** local variables ****
      logical sprik
      integer i,j,ntype,n1,n2,isgn,nion
      real*8 x1,y1,z1,x2,y2,z2,x3,y3,z3,dx,dy,dz,r,r1,r2,r3
      real*8 dx1,dy1,dz1,dx3,dy3,dz3,theta,n,m,r0,f,la,lb
      real*8 nx,ny,nz,x4,y4,z4,dx2,dy2,dz2,d1a,d2a,d1b,d2b
      real*8 cf(100),v0,dv0

*     **** external functions ****
      integer  ion_rion_ptr,ion_nion
      external ion_rion_ptr,ion_nion
      real*8   ion_rion,psp_ld_trace,metadynamics_coordspherediff
      external ion_rion,psp_ld_trace,metadynamics_coordspherediff
      real*8   nwpw_expression_f
      external nwpw_expression_f

      ntype = indx(1)

      f = 0.0d0
c     **** bond distance ***
      if (ntype.eq.1) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         dx = x1-x2
         dy = y1-y2
         dz = z1-z2
         call lattice_min_difference(dx,dy,dz)
         r  = dsqrt(dx**2 + dy**2 + dz**2)
         f  = r

c     **** bond angle ***
      else if (ntype.eq.2) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         dx1 = x1-x2
         dy1 = y1-y2
         dz1 = z1-z2
         call lattice_min_difference(dx1,dy1,dz1)
         r1  = dsqrt(dx1**2 + dy1**2 + dz1**2)
         dx3 = x3-x2
         dy3 = y3-y2
         dz3 = z3-z2
         call lattice_min_difference(dx3,dy3,dz3)
         r3  = dsqrt(dx3**2 + dy3**2 + dz3**2)
         theta = (dx1*dx3 + dy1*dy3 + dz1*dz3)/(r1*r3)
         if (theta.gt.1.0d0)  theta = 1.0d0
         if (theta.lt.-1.0d0) theta = -1.0d0
         theta = dacos(theta)
         f = theta

c     **** bond dihedral ****
      else if (ntype.eq.3) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         x4 = ion_rion(1,indx(5))
         y4 = ion_rion(2,indx(5))
         z4 = ion_rion(3,indx(5))
         dx1 = x2-x1
         dy1 = y2-y1
         dz1 = z2-z1
         call lattice_min_difference(dx1,dy1,dz1)
         dx2 = x3-x2
         dy2 = y3-y2
         dz2 = z3-z2
         call lattice_min_difference(dx2,dy2,dz2)
         dx3 = x4-x3
         dy3 = y4-y3
         dz3 = z4-z3
         call lattice_min_difference(dx3,dy3,dz3)

         dy = dx1*(dy2*dz3-dy3*dz2) 
     >      + dy1*(dz2*dx3-dz3*dx2) 
     >      + dz1*(dx2*dy3-dx3*dy2)
         dy = dy*dsqrt(dx2**2 + dy2**2 + dz2**2)

         dx = (dy2*dz3 - dy3*dz2)*(dy1*dz2 - dy2*dz1)
     >      + (dz2*dx3 - dz3*dx2)*(dz1*dx2 - dz2*dx1)
     >      + (dx2*dy3 - dx3*dy2)*(dx1*dy2 - dx2*dy1)
         f = datan2(dy,dx)

c     **** coordination number ****
      else if (ntype.eq.4) then
         n1=indx(2)
         n2=indx(3)
         if (param(6).lt.0.0d0) then
            f = 0.0d0
            n  = param(3)
            m  = param(4)
            r0 = param(5)
            do i=1,n1
               do j=1,n2
                  x1 = ion_rion(1,indx(3+i))
                  y1 = ion_rion(2,indx(3+i))
                  z1 = ion_rion(3,indx(3+i))
                  x2 = ion_rion(1,indx(3+n1+j))
                  y2 = ion_rion(2,indx(3+n1+j))
                  z2 = ion_rion(3,indx(3+n1+j))
                  dx1 = x1-x2
                  dy1 = y1-y2
                  dz1 = z1-z2
                  call lattice_min_difference(dx1,dy1,dz1)
                  r1  = dsqrt(dx1**2 + dy1**2 + dz1**2)
                  f = f + (1.0d0-(r1/r0)**n)/(1.0d0-(r1/r0)**m)
               end do
            end do
         else
            f = 0.0d0
            n  = param(3)
            m  = param(4)
            r0 = param(5)
            do i=1,n1
               do j=1,n2
                  x1 = ion_rion(1,indx(3+i))
                  y1 = ion_rion(2,indx(3+i))
                  z1 = ion_rion(3,indx(3+i))
                  x2 = ion_rion(1,indx(3+n1+j))
                  y2 = ion_rion(2,indx(3+n1+j))
                  z2 = ion_rion(3,indx(3+n1+j))
                  dx1 = x1-x2
                  dy1 = y1-y2
                  dz1 = z1-z2
                  call lattice_min_difference(dx1,dy1,dz1)
                  r1  = dsqrt(dx1**2 + dy1**2 + dz1**2)
c                 f = f + (1.0d0-(r1/r0)**n)/(1.0d0-(r1/r0)**m)
                  f = f + 1.d0/(1.d0+dexp(n*(r1-r0)))
               end do
            end do
         end if

c     **** n-plane ****
      else if (ntype.eq.5) then
         f = 0.0d0
         nx = param(3)
         ny = param(4)
         nz = param(5)
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         n1=indx(3)
         do i=1,n1
            x2 = ion_rion(1,indx(3+i))
            y2 = ion_rion(2,indx(3+i))
            z2 = ion_rion(3,indx(3+i))
            dx = x1-x2
            dy = y1-y2
            dz = z1-z2
            call lattice_min_difference(dx,dy,dz)
            r =  nx*dx + ny*dy + nz*dz
            f = f + dsqrt(r*r)
         end do
         f = f/dble(n1)

*     **** x,y,z ****
      else if (ntype.eq.6) then
         if (indx(2).eq.1)  then
            f = ion_rion(1,indx(3))
         else if (indx(2).eq.1)  then
            f = ion_rion(2,indx(3))
         else
            f = ion_rion(3,indx(3))
         end if

*     **** ld_trace ****
      else if (ntype.eq.7) then
         f =  psp_ld_trace(indx(2),indx(3),ispin,ne,psi1)

*     *** 2bonds ****
      else if (ntype.eq.8) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         x4 = ion_rion(1,indx(5))
         y4 = ion_rion(2,indx(5))
         z4 = ion_rion(3,indx(5))
         dx1 = x2-x1
         dy1 = y2-y1
         dz1 = z2-z1
         call lattice_min_difference(dx1,dy1,dz1)
         dx2 = x4-x3
         dy2 = y4-y3
         dz2 = z4-z3
         call lattice_min_difference(dx2,dy2,dz2)
         d1a = param(3)
         d2a = param(4)
         d1b = param(5)
         d2b = param(6)
         r1 = dsqrt(dx1**2 + dy1**2 + dz1**2)
         r2 = dsqrt(dx2**2 + dy2**2 + dz2**2)
         la = dsqrt((r1-d1a)**2 + (r2-d2a)**2)
         lb = dsqrt((r1-d1b)**2 + (r2-d2b)**2)
         f = la/(la+lb)

*     **** ld_trace2diff ****
      else if (ntype.eq.9) then
         f =  psp_ld_trace(indx(2),indx(4),ispin,ne,psi1)
     >     -  psp_ld_trace(indx(3),indx(4),ispin,ne,psi1)

*     *** bond_difference2 ****
      else if (ntype.eq.10) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         dx1 = x2-x1
         dy1 = y2-y1
         dz1 = z2-z1
         call lattice_min_difference(dx1,dy1,dz1)
         r1 = (dx1**2 + dy1**2 + dz1**2)
         dx2 = x3-x1
         dy2 = y3-y1
         dz2 = z3-z1
         call lattice_min_difference(dx2,dy2,dz2)
         r2 = (dx2**2 + dy2**2 + dz2**2)
         f = r1 - r2

c     **** bond_difference_shell ****
      else if (ntype.eq.11) then
         n1=indx(2)
         n2=indx(3)
         n   = param(3)
         m   = param(4)
         r0  = param(5)
         sprik = (param(6).ge.0.0d0)
         v0  = param(7)
         dv0 = param(8)
         f = metadynamics_coordspherediff(v0,dv0,sprik,n,m,r0,
     >                                    n1,indx(3   +1),
     >                                    n2,indx(3+n1+1),
     >                                    dbl_mb(ion_rion_ptr()))

      else if (ntype.eq.12) then
          nion = ion_nion()
          f = nwpw_expression_f(indx(2),nion,dbl_mb(ion_rion_ptr()))
      end if

      meta_collective = f
      return
      end

c     **********************************************
c     *                                            *
c     *           meta_collective_force            *
c     *                                            *
c     **********************************************
      subroutine meta_collective_force(indx,param,dv,
     >                                 ispin,ne,psi1,fmeta_psi1,
     >                                 move,fmeta)
      implicit none
      integer indx(*)
      real*8 param(*),dv
      integer ispin,ne(2)
      real*8 psi1(*),fmeta_psi1(*)
      logical move
      real*8 fmeta(3,*)

#include "mafdecls.fh"

*     **** local variables ****
      logical sprik
      integer i,j,ntype,n1,n2,nion
      real*8 x1,y1,z1,r1,vx1,vx2,vy1,vy2,vz1,vz2
      real*8 x2,y2,z2,aa,a11,a12,a22,r,df,n,m,r0,rn,rm
      real*8 x3,y3,z3,r3,ctheta,stheta,denom
      real*8 dx,dy,dz,dx1,dy1,dz1,dx3,dy3,dz3,nx,ny,nz,la,lb
      real*8 x4,y4,z4,dx2,dy2,dz2,r2,df1,df2,d1a,d2a,d1b,d2b
      real*8 dfla,dflb,dlar1,dlar2,dlbr1,dlbr2
      real*8 v0,dv0

*     **** external functions ****
      integer  ion_rion_ptr,ion_nion
      external ion_rion_ptr,ion_nion
      real*8   ion_rion
      external ion_rion

      ntype = indx(1)

      if (move) then

c     **** bond distance ***
      if (ntype.eq.1) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         dx = x1-x2
         dy = y1-y2
         dz = z1-z2
         call lattice_min_difference(dx,dy,dz)
         r  = dsqrt(dx**2 + dy**2 + dz**2)

         fmeta(1,indx(2)) = fmeta(1,indx(2)) - (dx/r)*dv
         fmeta(2,indx(2)) = fmeta(2,indx(2)) - (dy/r)*dv
         fmeta(3,indx(2)) = fmeta(3,indx(2)) - (dz/r)*dv
         fmeta(1,indx(3)) = fmeta(1,indx(3)) + (dx/r)*dv
         fmeta(2,indx(3)) = fmeta(2,indx(3)) + (dy/r)*dv
         fmeta(3,indx(3)) = fmeta(3,indx(3)) + (dz/r)*dv

c     **** bond angle ***
      else if (ntype.eq.2) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         dx1 = x1-x2
         dy1 = y1-y2
         dz1 = z1-z2
         call lattice_min_difference(dx1,dy1,dz1)
         r1  = dsqrt(dx1**2 + dy1**2 + dz1**2)
         dx3 = x3-x2
         dy3 = y3-y2
         dz3 = z3-z2
         call lattice_min_difference(dx3,dy3,dz3)
         r3  = dsqrt(dx3**2 + dy3**2 + dz3**2)
         denom = r1*r3
         if (denom.gt.1.0d-11) then
            ctheta = (dx1*dx3 + dy1*dy3 + dz1*dz3)/(denom)
            if (ctheta.gt.1.0d0)  ctheta =  1.0d0
            if (ctheta.lt.-1.0d0) ctheta = -1.0d0
            stheta = dsqrt(1.0d0-ctheta*ctheta)
            if (stheta.lt.0.001d0) stheta = 0.001d0
            stheta = 1.0d0/stheta

            aa  =  dv*stheta
            a11 =  aa*ctheta/r1
            a12 = -aa/(denom)
            a22 =  aa*ctheta/r3

            vx1 = a11*dx1 + a12*dx3
            vx2 = a22*dx3 + a12*dx1

            vy1 = a11*dy1 + a12*dy3
            vy2 = a22*dy3 + a12*dy1

            vz1 = a11*dz1 + a12*dz3
            vz2 = a22*dz3 + a12*dz1

            fmeta(1,indx(2)) = fmeta(1,indx(2)) - vx1
            fmeta(2,indx(2)) = fmeta(2,indx(2)) - vy1
            fmeta(3,indx(2)) = fmeta(3,indx(2)) - vz1

            fmeta(1,indx(3)) = fmeta(1,indx(3)) + vx1 + vx2
            fmeta(2,indx(3)) = fmeta(2,indx(3)) + vy1 + vy2
            fmeta(3,indx(3)) = fmeta(3,indx(3)) + vz1 + vz2

            fmeta(1,indx(4)) = fmeta(1,indx(4)) - vx2
            fmeta(2,indx(4)) = fmeta(2,indx(4)) - vy2
            fmeta(3,indx(4)) = fmeta(3,indx(4)) - vz2
         end if

c     **** bond dihedral ****
      else if (ntype.eq.3) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         x4 = ion_rion(1,indx(5))
         y4 = ion_rion(2,indx(5))
         z4 = ion_rion(3,indx(5))
         dx1 = x2-x1
         dy1 = y2-y1
         dz1 = z2-z1
         call lattice_min_difference(dx1,dy1,dz1)
         dx2 = x3-x2
         dy2 = y3-y2
         dz2 = z3-z2
         call lattice_min_difference(dx2,dy2,dz2)
         dx3 = x4-x3
         dy3 = y4-y3
         dz3 = z4-z3
         call lattice_min_difference(dx3,dy3,dz3)

         dy = dx1*(dy2*dz3-dy3*dz2)
     >      + dy1*(dz2*dx3-dz3*dx2)
     >      + dz1*(dx2*dy3-dx3*dy2)
         dy = dy*dsqrt(dx2**2 + dy2**2 + dz2**2)

         dx = (dy2*dz3 - dy3*dz2)*(dy1*dz2 - dy2*dz1)
     >      + (dz2*dx3 - dz3*dx2)*(dz1*dx2 - dz2*dx1)
     >      + (dx2*dy3 - dx3*dy2)*(dx1*dy2 - dx2*dy1)
         r2 = datan2(dy,dx)
         vx1 = -dy/(dx**2 + dy**2)
         vy1 =  dx/(dx**2 + dy**2)

c          dphi/dx  (dx/db1 db1/dr1 + dx/db2 db2/dr1 + dx/db3 db3/dr1)
c          dphi/dy  (dy/db1 db1/dr1 + dy/db2 db2/dr1 + dy/db3 db3/dr1)

            fmeta(1,indx(2)) = fmeta(1,indx(2)) 
            fmeta(2,indx(2)) = fmeta(2,indx(2)) 
            fmeta(3,indx(2)) = fmeta(3,indx(2)) 

            fmeta(1,indx(3)) = fmeta(1,indx(3)) 
            fmeta(2,indx(3)) = fmeta(2,indx(3)) 
            fmeta(3,indx(3)) = fmeta(3,indx(3)) 

            fmeta(1,indx(4)) = fmeta(1,indx(4)) 
            fmeta(2,indx(4)) = fmeta(2,indx(4)) 
            fmeta(3,indx(4)) = fmeta(3,indx(4)) 

            fmeta(1,indx(5)) = fmeta(1,indx(5)) 
            fmeta(2,indx(5)) = fmeta(2,indx(5)) 
            fmeta(3,indx(5)) = fmeta(3,indx(5)) 



c     **** coordination number ***
      else if (ntype.eq.4) then
         n1 = indx(2)
         n2 = indx(3)
         if (param(6).lt.0.0d0) then
            n  = param(3)
            m  = param(4)
            r0 = param(5)
            do i=1,n1
               do j=1,n2
                  x1 = ion_rion(1,indx(3+i))
                  y1 = ion_rion(2,indx(3+i))
                  z1 = ion_rion(3,indx(3+i))
                  x2 = ion_rion(1,indx(3+n1+j))
                  y2 = ion_rion(2,indx(3+n1+j))
                  z2 = ion_rion(3,indx(3+n1+j))
                  dx = x1-x2
                  dy = y1-y2
                  dz = z1-z2
                  call lattice_min_difference(dx,dy,dz)
                  r  = dsqrt(dx**2 + dy**2 + dz**2)
                  rn  = (1.0d0-(r/r0)**n)
                  rm  = (1.0d0-(r/r0)**m)
                  df = (-n*rm/r0*(r/r0)**(n-1) + m*rn/r0*(r/r0)**(m-1))
     >                 / (rm**2)
                  fmeta(1,indx(3+i)) = fmeta(1,indx(3+i)) - (dx/r)*df*dv
                  fmeta(2,indx(3+i)) = fmeta(2,indx(3+i)) - (dy/r)*df*dv
                  fmeta(3,indx(3+i)) = fmeta(3,indx(3+i)) - (dz/r)*df*dv
                  fmeta(1,indx(3+n1+j)) = fmeta(1,indx(3+n1+j)) 
     >                                  + (dx/r)*df*dv
                  fmeta(2,indx(3+n1+j)) = fmeta(2,indx(3+n1+j)) 
     >                                  + (dy/r)*df*dv
                  fmeta(3,indx(3+n1+j)) = fmeta(3,indx(3+n1+j)) 
     >                                  + (dz/r)*df*dv
               end do
            end do
         else
            n  = param(3)
            m  = param(4)
            r0 = param(5)
            do i=1,n1
               do j=1,n2
                  x1 = ion_rion(1,indx(3+i))
                  y1 = ion_rion(2,indx(3+i))
                  z1 = ion_rion(3,indx(3+i))
                  x2 = ion_rion(1,indx(3+n1+j))
                  y2 = ion_rion(2,indx(3+n1+j))
                  z2 = ion_rion(3,indx(3+n1+j))
                  dx = x1-x2
                  dy = y1-y2
                  dz = z1-z2
                  call lattice_min_difference(dx,dy,dz)
                  r  = dsqrt(dx**2 + dy**2 + dz**2)
c                 rn  = (1.0d0-(r/r0)**n)
c                 rm  = (1.0d0-(r/r0)**m)
c                 df = (-n*rm/r0*(r/r0)**(n-1) + m*rn/r0*(r/r0)**(m-1))
c    >                 / (rm**2)
                  rn  = 1.d0+dexp(n*(r-r0))
                  df = -n*(rn-1.d0)/(rn*rn)
                  fmeta(1,indx(3+i)) = fmeta(1,indx(3+i)) - (dx/r)*df*dv
                  fmeta(2,indx(3+i)) = fmeta(2,indx(3+i)) - (dy/r)*df*dv
                  fmeta(3,indx(3+i)) = fmeta(3,indx(3+i)) - (dz/r)*df*dv
                  fmeta(1,indx(3+n1+j)) = fmeta(1,indx(3+n1+j)) 
     >                                  + (dx/r)*df*dv
                  fmeta(2,indx(3+n1+j)) = fmeta(2,indx(3+n1+j)) 
     >                                  + (dy/r)*df*dv
                  fmeta(3,indx(3+n1+j)) = fmeta(3,indx(3+n1+j)) 
     >                                  + (dz/r)*df*dv
               end do
            end do
         endif

c     **** n-plane ****
      else if (ntype.eq.5) then
         nx = param(3)
         ny = param(4)
         nz = param(5)
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         n1=indx(3)
         do i=1,n1
            x2 = ion_rion(1,indx(3+i))
            y2 = ion_rion(2,indx(3+i))
            z2 = ion_rion(3,indx(3+i))
            dx = x1-x2
            dy = y1-y2
            dz = z1-z2
            call lattice_min_difference(dx,dy,dz)
            r =  nx*dx + ny*dy + nz*dz
            r0 =  dsqrt(r*r)
            df = (r/r0)*dv/dble(n1)
            fmeta(1,indx(2)) = fmeta(1,indx(2)) - nx*df
            fmeta(2,indx(2)) = fmeta(2,indx(2)) - ny*df
            fmeta(3,indx(2)) = fmeta(3,indx(2)) - nz*df

            fmeta(1,indx(3+i)) = fmeta(1,indx(3+i)) + nx*df
            fmeta(2,indx(3+i)) = fmeta(2,indx(3+i)) + ny*df
            fmeta(3,indx(3+i)) = fmeta(3,indx(3+i)) + nz*df
         end do

*     **** x,y,z ****
      else if (ntype.eq.6) then
         if (indx(2).eq.1)  then
            fmeta(1,indx(3)) = fmeta(1,indx(3)) - dv
         else if (indx(2).eq.1)  then
            fmeta(2,indx(3)) = fmeta(2,indx(3)) - dv
         else
            fmeta(3,indx(3)) = fmeta(3,indx(3)) - dv
         end if

c     **** ld_trace ***
      else if (ntype.eq.7) then
         call psp_ld_trace_gradient(indx(2),indx(3),ispin,ne,psi1,
     >                                 .false.,param,
     >                                 (-dv),fmeta_psi1,
     >                                 move,fmeta)

c     **** 2bonds ****
      else if (ntype.eq.8) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         x4 = ion_rion(1,indx(5))
         y4 = ion_rion(2,indx(5))
         z4 = ion_rion(3,indx(5))
         dx1 = x2-x1
         dy1 = y2-y1
         dz1 = z2-z1
         call lattice_min_difference(dx1,dy1,dz1)
         r1 = dsqrt(dx1**2 + dy1**2 + dz1**2)
         dx2 = x4-x3
         dy2 = y4-y3
         dz2 = z4-z3
         call lattice_min_difference(dx2,dy2,dz2)
         r2 = dsqrt(dx2**2 + dy2**2 + dz2**2)
         d1a = param(3)
         d2a = param(4)
         d1b = param(5)
         d2b = param(6)
         la = dsqrt((r1-d1a)**2 + (r2-d2a)**2)
         lb = dsqrt((r1-d1b)**2 + (r2-d2b)**2)
         if (dabs(la).lt.1.0d-6) then
            dlar1 = dtanh((r1-d1a)/1.0d-7)
            dlar2 = dtanh((r2-d2a)/1.0d-7)
         else
            dlar1 = (r1-d1a)/la
            dlar2 = (r2-d2a)/la
         end if
         if (dabs(lb).lt.1.0d-6) then
            dlbr1 = dtanh((r1-d1b)/1.0d-7)
            dlbr2 = dtanh((r2-d2b)/1.0d-7)
         else
            dlbr1 = (r1-d1b)/lb
            dlbr2 = (r2-d2b)/lb
         end if
         !f = la/(la+lb)
         dfla = 1.0d0/(la+lb) - la/(la+lb)**2
         dflb = -la/(la+lb)**2
         df1 = dfla*dlar1 + dflb*dlbr1
         df2 = dfla*dlar2 + dflb*dlbr2

         fmeta(1,indx(2)) = fmeta(1,indx(2)) + (dx1/r1)*dv*df1
         fmeta(2,indx(2)) = fmeta(2,indx(2)) + (dy1/r1)*dv*df1
         fmeta(3,indx(2)) = fmeta(3,indx(2)) + (dz1/r1)*dv*df1

         fmeta(1,indx(3)) = fmeta(1,indx(3)) - (dx1/r1)*dv*df1
         fmeta(2,indx(3)) = fmeta(2,indx(3)) - (dy1/r1)*dv*df1
         fmeta(3,indx(3)) = fmeta(3,indx(3)) - (dz1/r1)*dv*df1

         fmeta(1,indx(4)) = fmeta(1,indx(4)) + (dx2/r2)*dv*df2
         fmeta(2,indx(4)) = fmeta(2,indx(4)) + (dy2/r2)*dv*df2
         fmeta(3,indx(4)) = fmeta(3,indx(4)) + (dz2/r2)*dv*df2

         fmeta(1,indx(5)) = fmeta(1,indx(5)) - (dx2/r2)*dv*df2
         fmeta(2,indx(5)) = fmeta(2,indx(5)) - (dy2/r2)*dv*df2
         fmeta(3,indx(5)) = fmeta(3,indx(5)) - (dz2/r2)*dv*df2

c     **** ld_trace2diff ***
      else if (ntype.eq.9) then
         call psp_ld_trace_gradient(indx(2),indx(4),ispin,ne,psi1,
     >                                 .false.,param,
     >                                 (-dv),fmeta_psi1,
     >                                 move,fmeta)
         call psp_ld_trace_gradient(indx(3),indx(4),ispin,ne,psi1,
     >                                 .false.,param,
     >                                 (dv),fmeta_psi1,
     >                                 move,fmeta)

c     **** bond_difference2 ****
      else if (ntype.eq.10) then
         x1 = ion_rion(1,indx(2))
         y1 = ion_rion(2,indx(2))
         z1 = ion_rion(3,indx(2))
         x2 = ion_rion(1,indx(3))
         y2 = ion_rion(2,indx(3))
         z2 = ion_rion(3,indx(3))
         x3 = ion_rion(1,indx(4))
         y3 = ion_rion(2,indx(4))
         z3 = ion_rion(3,indx(4))
         dx1 = x2-x1
         dy1 = y2-y1
         dz1 = z2-z1
         call lattice_min_difference(dx1,dy1,dz1)
         r1 = (dx1**2 + dy1**2 + dz1**2)
         dx2 = x3-x1
         dy2 = y3-y1
         dz2 = z3-z1
         call lattice_min_difference(dx2,dy2,dz2)
         r2 = (dx2**2 + dy2**2 + dz2**2)
         !f = r1 - r2
         df1 =  1
         df2 = -1
         fmeta(1,indx(2)) = fmeta(1,indx(2)) +2.0d0*(dx1*df1+dx2*df2)*dv
         fmeta(2,indx(2)) = fmeta(2,indx(2)) +2.0d0*(dy1*df1+dy2*df2)*dv
         fmeta(3,indx(2)) = fmeta(3,indx(2)) +2.0d0*(dz1*df1+dz2*df2)*dv

         fmeta(1,indx(3)) = fmeta(1,indx(3)) - (2.0d0*dx1*df1)*dv
         fmeta(2,indx(3)) = fmeta(2,indx(3)) - (2.0d0*dy1*df1)*dv
         fmeta(3,indx(3)) = fmeta(3,indx(3)) - (2.0d0*dz1*df1)*dv

         fmeta(1,indx(4)) = fmeta(1,indx(4)) - (2.0d0*dx2*df2)*dv
         fmeta(2,indx(4)) = fmeta(2,indx(4)) - (2.0d0*dy2*df2)*dv
         fmeta(3,indx(4)) = fmeta(3,indx(4)) - (2.0d0*dz2*df2)*dv

      else if (ntype.eq.11) then
        n1=indx(2)
        n2=indx(3)
        n   = param(3)
        m   = param(4)
        r0  = param(5)
        sprik = (param(6).ge.0.0d0)
        v0  = param(7)
        dv0 = param(8)
        call metadynamics_coordspherediff_force(dv,v0,dv0,
     >                                        sprik,n,m,r0,
     >                                        n1,indx(3   +1),
     >                                        n2,indx(3+n1+1),
     >                                        dbl_mb(ion_rion_ptr()),
     >                                        fmeta)
      else if (ntype.eq.12) then
         nion = ion_nion()
         call nwpw_expression_fion(dv,indx(2),
     >                        nion,dbl_mb(ion_rion_ptr()),
     >                        fmeta)

      end if

*     ***** move = .false. ******
      else
         if (ntype.eq.7) then
         call psp_ld_trace_gradient(indx(2),indx(3),ispin,ne,psi1,
     >                                 .false.,param,
     >                                 (-dv),fmeta_psi1,
     >                                 move,fmeta)
         else if (ntype.eq.9) then
         call psp_ld_trace_gradient(indx(2),indx(4),ispin,ne,psi1,
     >                                 .false.,param,
     >                                 (-dv),fmeta_psi1,
     >                                 move,fmeta)
         call psp_ld_trace_gradient(indx(3),indx(4),ispin,ne,psi1,
     >                                 .false.,param,
     >                                 (dv),fmeta_psi1,
     >                                 move,fmeta)
         end if
      end if

      return
      end



*     ***********************************************
*     *                                             *
*     *              meta_update                    *
*     *                                             *
*     ***********************************************
      subroutine meta_update(ispin,ne,psi1,E)
      implicit none
      integer ispin,ne(2)
      real*8 psi1(*)
      real*8 E(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      double precision kb
      parameter (kb=3.16679d-6)

      integer d,i,j(10),s1,s2
      real*8  r0(10),sigma0(10),r,x,w,ww,sigma,v,expv

*     **** external functions ****
      real*8   meta_collective,meta_energy
      external meta_collective,meta_energy

      if (metafound) then

         metacount = metacount + 1
         if (metacount.ge.maxmetacount) then
         metacount = 0

         if (dTtempered.gt.0.0d0) then
            v    = meta_energy(ispin,ne,psi1)
            expv = dexp(-v/(kb*dTtempered))
         else
            v    = 0.0d0
            expv = 1.0d0
         end if

         if (nmeta.gt.0) then
            w = 1.0d0
            do d=1,nmeta
               s1 = int_mb(sindxmeta(1) +d-1)
               s2 = int_mb(sparammeta(1)+d-1)
               r0(d) = meta_collective(int_mb(indxmeta(1)+s1),
     >                                 dbl_mb(parammeta(1)+s2),
     >                                 ispin,ne,psi1)
               sigma0(d) = dbl_mb(parammeta(1)+s2+1)
               w  = w*dbl_mb(parammeta(1)+s2)
               j(d) = 0
            end do
            w = w**(1.0d0/dble(nmeta))
           
            do i=1,nxmeta_all
               ww = 1.0d0
               do d=1,nmeta
                  s1 = int_mb(sindxmeta(1) +d-1)
                  s2 = int_mb(sparammeta(1)+d-1)
c                  r0    = meta_collective(int_mb(indxmeta(1)+s1),
c     >                                    dbl_mb(parammeta(1)+s2),
c     >                                    ispin,ne,psi1)
                  sigma = dbl_mb(parammeta(1)+s2+1)
                  if (pmeta(d).eq.0) then
                     x = dbl_mb(ameta(1)+d-1) 
     >                + j(d)*(dbl_mb(bmeta(1)+d-1)-dbl_mb(ameta(1)+d-1))
     >                    /dble(int_mb(nxmeta(1)+d-1)-1)
                  else
                     x = dbl_mb(ameta(1)+d-1) 
     >                + j(d)*(dbl_mb(bmeta(1)+d-1)-dbl_mb(ameta(1)+d-1))
     >                      /dble(int_mb(nxmeta(1)+d-1))
                  end if
                  r = x-r0(d)
                  ww = ww * dexp(-0.5d0*(r/sigma)**2)
               end do
            
               dbl_mb(ymeta(1)+i-1) = dbl_mb(ymeta(1)+i-1) + ww*w*expv

               j(1) = j(1) + 1
               do d=1,nmeta-1
                  if (j(d).ge.int_mb(nxmeta(1)+d-1)) then
                     j(d) = 0
                     j(d+1) = j(d+1)+1
                  end if
               end do
            end do
            call meta_gauss_write(nmeta,r0,sigma0,w*expv,E)
         end if

         end if

         metaprintcount = metaprintcount + 1
         if (metaprintcount.ge.maxmetaprintcount) then
            metaprintcount = 0
            metaraycount   = metaraycount + metarayshift
            call meta_print_potentials(metaraycount)
         end if

      end if
 
      return
      end

*     ***********************************************
*     *                                             *
*     *              meta_force                     *
*     *                                             *
*     ***********************************************
      subroutine meta_force(ispin,ne,psi1,fmeta_psi1,move,fmeta)
      implicit none
      integer ispin,ne(2)
      real*8 psi1(*),fmeta_psi1(*)
      logical move
      real*8 fmeta(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      integer d,s1,s2
      real*8 r(10),dv(10)

*     **** external functions ****
      integer  ion_nion
      external ion_nion
      real*8   meta_collective
      external meta_collective
      
      if (metafound) then

         if (nmeta.gt.0) then
            do d=1,nmeta
               s1 = int_mb(sindxmeta(1) +d-1)
               s2 = int_mb(sparammeta(1)+d-1)
               r(d) = meta_collective(int_mb(indxmeta(1)+s1),
     >                                dbl_mb(parammeta(1)+s2),
     >                                ispin,ne,psi1)
            end do

            call nwpw_dinterp(nmeta,int_mb(nxmeta(1)),
     >                        dbl_mb(ameta(1)),dbl_mb(bmeta(1)),
     >                        int_mb(pmeta(1)),
     >                        dbl_mb(ymeta(1)),r,dv)

            do d=1,nmeta
               s1 = int_mb(sindxmeta(1) +d-1)
               s2 = int_mb(sparammeta(1)+d-1)
               call meta_collective_force(int_mb(indxmeta(1) +s1),
     >                                    dbl_mb(parammeta(1)+s2),
     >                                    dv(d),
     .                                    ispin,ne,psi1,fmeta_psi1,
     >                                    move,fmeta)
            end do
      
         end if

      end if

      return
      end


*     ***********************************************
*     *                                             *
*     *              meta_energy                    *
*     *                                             *
*     ***********************************************
      real*8 function meta_energy(ispin,ne,psi1)
      implicit none
      integer ispin,ne(2)
      real*8 psi1(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      integer d,s1,s2
      real*8 r(10),v

*     **** external functions ****
      real*8   nwpw_interp,meta_collective
      external nwpw_interp,meta_collective

      v = 0.0d0
      if (metafound) then

         if (nmeta.gt.0) then
            do d=1,nmeta
               s1 = int_mb(sindxmeta(1) +d-1)
               s2 = int_mb(sparammeta(1)+d-1)
               r(d) = meta_collective(int_mb(indxmeta(1)+s1),
     >                                dbl_mb(parammeta(1)+s2),
     >                                ispin,ne,psi1)
            end do
            v = nwpw_interp(nmeta,int_mb(nxmeta(1)),
     >                      dbl_mb(ameta(1)),dbl_mb(bmeta(1)),
     >                      int_mb(pmeta(1)),
     >                      dbl_mb(ymeta(1)),r)

            call Parallel_Brdcst_value(0,v)  !*** syncing to master taskid ***
         end if

      end if

      meta_energy = v 
      return
      end





*     ***********************************************
*     *                                             *
*     *              meta_energypotential           *
*     *                                             *
*     ***********************************************
      subroutine meta_energypotential(ispin,ne,psi1,e,p)
      implicit none
      integer ispin,ne(2)
      real*8 psi1(*)
      real*8 e,p

#include "mafdecls.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      integer d,s1,s2,ntype
      real*8 r(10),dv(10),v

*     **** external functions ****
      real*8   nwpw_interp,meta_collective
      external nwpw_interp,meta_collective

      e = 0.0d0
      p = 0.0d0
      if (metafound) then

         if (nmeta.gt.0) then
            do d=1,nmeta
               s1 = int_mb(sindxmeta(1) +d-1)
               s2 = int_mb(sparammeta(1)+d-1)
               r(d) = meta_collective(int_mb(indxmeta(1)+s1),
     >                                dbl_mb(parammeta(1)+s2),
     >                                ispin,ne,psi1)
            end do
            e = nwpw_interp(nmeta,int_mb(nxmeta(1)),
     >                      dbl_mb(ameta(1)),dbl_mb(bmeta(1)),
     >                      int_mb(pmeta(1)),
     >                      dbl_mb(ymeta(1)),r)

            call nwpw_dinterp(nmeta,int_mb(nxmeta(1)),
     >                        dbl_mb(ameta(1)),dbl_mb(bmeta(1)),
     >                        int_mb(pmeta(1)),
     >                        dbl_mb(ymeta(1)),r,dv)

            do d=1,nmeta
               s1 = int_mb(sindxmeta(1) +d-1)
               ntype = int_mb(indxmeta(1)+s1)
               if ((ntype.eq.7).or.(ntype.eq.9)) then
                  p = p + r(d)*dv(d)
               end if
            end do

            call Parallel_Brdcst_value(0,e)  !*** syncing to master taskid ***
            call Parallel_Brdcst_value(0,p)
         end if

      end if

      return
      end


*     ***********************************************
*     *                                             *
*     *              meta_found                     *
*     *                                             *
*     ***********************************************
      logical function meta_found()
      implicit none

#include "metadynamics.fh"

      meta_found = metafound
      return
      end


c     **********************************************
c     *                                            *
c     *            meta_print_potentials           *
c     *                                            *
c     **********************************************
      subroutine meta_print_potentials(icount)
      implicit none
      integer icount

#include "mafdecls.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)

      integer d,i,j(10)
      real*8  x(10),r,v,dv(10),fac,temp
      character*80 filename
      character*255 full_filename

*     **** external functions ****
      logical  control_Nose
      external control_Nose
      character*7 c_index_name
      external    c_index_name
      real*8   nwpw_interp,control_Nose_Tr,ion_Temperature
      external nwpw_interp,control_Nose_Tr,ion_Temperature

      call Parallel_taskid(taskid)

      if (metafound) then

*        **** determine tempered metadynamics factor ****
         fac = 1.0d0
         if (dTtempered.gt.0.0d0) then
            if (control_Nose()) then
               temp = control_Nose_Tr()
            else
               temp = ion_Temperature()
            end if
            fac = (temp+dTtempered)/dTtempered
         end if


*        **** print out potentials ******
         if (nmeta.gt.0) then
            if (taskid.eq.MASTER) then
               if (icount.gt.0) then
                  filename = "meta"//c_index_name(icount)//".dat"
               else
                  filename = "meta"//".dat"
               end if

               call util_file_name_noprefix(filename,.false.,
     >                                      .false.,
     >                                      full_filename)
               open(unit=53,file=full_filename,form='formatted')

               write(53,'(A,A)') "#metadynamics filename=",filename
               write(53,'(A,I6)') "#nmeta ",nmeta
               write(53,'(A,10I6)') "#nxmeta ",
     >                              (int_mb(nxmeta(1)+i-1),i=1,nmeta) 
               write(53,'(A,10I6)') "#sindxmeta ",
     >                     (int_mb(sindxmeta(1)+i-1),i=1,nmeta) 
               write(53,'(A,10I6)') "#sparammeta ",
     >                     (int_mb(sparammeta(1)+i-1),i=1,nmeta) 
               write(53,'(A,10F18.12)') "#ameta ",
     >                                 (dbl_mb(ameta(1)+i-1),i=1,nmeta)
               write(53,'(A,10F18.12)') "#bmeta ",
     >                                (dbl_mb(bmeta(1)+i-1),i=1,nmeta)
               write(53,'(A,10I3)') "#pmeta ",
     >                              (int_mb(pmeta(1)+i-1),i=1,nmeta)
               write(53,'(A,I8)') "#nindxmeta ",nindxmeta
               write(53,'(A,500I6)') "#indxmeta ",
     >                     (int_mb(indxmeta(1)+i-1),i=1,nindxmeta) 
               write(53,'(A,I8)') "#nparammeta ",nparammeta
               write(53,'(A,500F18.12)') "#parammeta ",
     >                     (dbl_mb(parammeta(1)+i-1),i=1,nparammeta)
               write(53,'(A,I8)') "#maxmetacount ",maxmetacount
               write(53,'(A,I8)') "#metacount ",metacount
               write(53,'(A,I8)') "#metarayshift ",metarayshift
               write(53,'(A,I8)') "#metaraycount ",metaraycount
               write(53,'(A,I8)')"#maxmetaprintcount ",maxmetaprintcount
               write(53,'(A,F18.12)') "#dTempered ",dTtempered
               write(53,'(A,I8)') "#nxmeta_all ",nxmeta_all

               do d=1,nmeta
                  j(d) = 0
               end do
               do i=1,nxmeta_all
                  do d=1,nmeta
                     x(d) = dbl_mb(ameta(1)+d-1)
     >                + j(d)*(dbl_mb(bmeta(1)+d-1)-dbl_mb(ameta(1)+d-1))
     >                      /dble(int_mb(nxmeta(1)+d-1)-1)
                  end do
                  write(53,'(12F15.6)') 
     >                 (x(d),d=1,nmeta),dbl_mb(ymeta(1)+i-1)*fac
                  j(1) = j(1) + 1
                  if (j(1).ge.int_mb(nxmeta(1))) then
                     write(53,*)
                  end if
                  do d=1,nmeta-1
                     if (j(d).ge.int_mb(nxmeta(1)+d-1)) then
                        j(d) = 0
                        j(d+1) = j(d+1)+1
                     end if
                  end do
               end do

               close(53)
               

c               filename = "test.dat"
c               call util_file_name_noprefix(filename,.false.,
c     >                                      .false.,
c     >                                      full_filename)
c               open(unit=53,file=full_filename,form='formatted')
c               do i=1,501
c                  x(1) = 1.0d0 + (i-1)*8.0d0/501.0d0
c                
c                  v = nwpw_interp(nmeta,int_mb(nxmeta(1)),
c     >                      dbl_mb(ameta(1)),dbl_mb(bmeta(1)),
c     >                      dbl_mb(ymeta(1)),x)
c                  call nwpw_dinterp(nmeta,int_mb(nxmeta(1)),
c     >                        dbl_mb(ameta(1)),dbl_mb(bmeta(1)),
c     >                        dbl_mb(ymeta(1)),x,dv)
c
c                  write(53,'(12F15.6)') x(1),v,dv(1)
c
c               end do
c               close(53)

            end if
         end if

      end if

      return
      end





*     ***********************************************
*     *                                             *
*     *              meta_setboundary               *
*     *                                             *
*     ***********************************************
      subroutine meta_setboundary(bheight,bsigma)
      implicit none
      real*8 bheight,bsigma

#include "mafdecls.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      integer d,i,j(10)
      real*8  r0,r,x,w,ww,wa,wb,ra,rb

      if (metafound) then
         if (nmeta.gt.0) then
            do d=1,nmeta
               j(d) = 0
            end do
            do i=1,nxmeta_all
               ww = 0.0d0
               do d=1,nmeta
                  if (pmeta(d).eq.0) then
                     x = dbl_mb(ameta(1)+d-1) 
     >                + j(d)*(dbl_mb(bmeta(1)+d-1)-dbl_mb(ameta(1)+d-1))
     >                      /dble(int_mb(nxmeta(1)+d-1)-1)
                  else
                     x = dbl_mb(ameta(1)+d-1) 
     >                + j(d)*(dbl_mb(bmeta(1)+d-1)-dbl_mb(ameta(1)+d-1))
     >                      /dble(int_mb(nxmeta(1)+d-1))
                  end if
                  ra= dbl_mb(ameta(1)+d-1)
                  rb= dbl_mb(bmeta(1)+d-1)
                  wa = dexp(-0.5d0*((x-ra)/bsigma)**2)
                  wb = dexp(-0.5d0*((x-rb)/bsigma)**2)
                  ww = ww + wa + wb
               end do
            
               dbl_mb(ymeta(1)+i-1) = dbl_mb(ymeta(1)+i-1) + bheight*ww

               j(1) = j(1) + 1
               do d=1,nmeta-1
                  if (j(d).ge.int_mb(nxmeta(1)+d-1)) then
                     j(d) = 0
                     j(d+1) = j(d+1)+1
                  end if
               end do
            end do
         end if
      end if
      return
      end



*     ***********************************************
*     *                                             *
*     *          meta_gauss_write_init              *
*     *                                             *
*     ***********************************************
      subroutine meta_gauss_write_init(filename)
      implicit none
      character*(*) filename

#include "mafdecls.fh"
#include "stdio.fh"
#include "metadynamics.fh"

      integer   MASTER
      parameter (MASTER=0)

      logical found,found_bak
      integer taskid,l1,l2,i
      character*255 full_filename,full_bak

      call Parallel_taskid(taskid)


*     **** produce META-GAUSS FILE ****
      if (taskid.eq.MASTER) then

         call util_file_name_noprefix(filename,.false.,
     >                                .false.,
     >                       full_filename)

*        **** check for backup file ***
         call util_file_name_noprefix('META-GAUSS99-bak',.false.,
     >                                  .false.,
     >                                  full_bak)
         inquire(file=full_bak,exist=found_bak)
         if (found_bak) then
            write(luout,*)
            write(luout,*) "META-GAUSS99-bak exists:"
            l1=index(full_bak,' ')
            l2=index(full_filename,' ')
            write(luout,*) "   Copying ",full_bak(1:l2),
     >                 " to ",full_filename(1:l2)
            write(*,*)
            call util_file_copy(full_bak,full_filename)
         end if
         inquire(file=full_filename,exist=found)
         if (found) then

*           **** make a new backup file ***
            call util_file_copy(full_filename,full_bak)

           open(unit=54,file=full_filename,form='formatted',
     >          status='old')
           do while (found)
             read(54,*,end=100)
           end do
  100      continue
#if defined(FUJITSU_SOLARIS) || defined(SOLARIS) || defined(__crayx1) || defined(GCC46)
           backspace 54
#endif
         else
           open(unit=54,file=full_filename,form='formatted',
     >           status='new')

           write(54,'(A,A40)') 
     >        "#metadynamics gaussian filename=",filename
           write(54,'(A,I6)') "#nmeta ",nmeta
           write(54,'(A,10I6)') "#nxmeta ",
     >                          (int_mb(nxmeta(1)+i-1),i=1,nmeta) 
           write(54,'(A,10I6)') "#sindxmeta ",
     >                 (int_mb(sindxmeta(1)+i-1),i=1,nmeta) 
           write(54,'(A,10I6)') "#sparammeta ",
     >                 (int_mb(sparammeta(1)+i-1),i=1,nmeta) 
           write(54,'(A,10F18.12)') "#ameta ",
     >                             (dbl_mb(ameta(1)+i-1),i=1,nmeta)
           write(54,'(A,10F18.12)') "#bmeta ",
     >                            (dbl_mb(bmeta(1)+i-1),i=1,nmeta)
           write(54,'(A,10I3)') "#pmeta ",
     >                          (int_mb(pmeta(1)+i-1),i=1,nmeta)
           write(54,'(A,I8)') "#nindxmeta ",nindxmeta
           write(54,'(A,500I6)') "#indxmeta ",
     >                 (int_mb(indxmeta(1)+i-1),i=1,nindxmeta) 
           write(54,'(A,I8)') "#nparammeta ",nparammeta
           write(54,'(A,500F18.12)') "#parammeta ",
     >                 (dbl_mb(parammeta(1)+i-1),i=1,nparammeta)
           write(54,'(A,I8)') "#maxmetacount ",maxmetacount
           write(54,'(A,I8)') "#metacount ",metacount
           write(54,'(A,I8)') "#metarayshift ",metarayshift
           write(54,'(A,I8)') "#metaraycount ",metaraycount
           write(54,'(A,I8)') "#maxmetaprintcount ",maxmetaprintcount
           write(54,'(2A)') "# (r(i),i=1,n),(sigma(i),i=1,n),w,",
     >                     "E(2)-E(31)+E(32),E(3),E(4),E(31),E(32)"
         end if
      end if

      return
      end




*     ***********************************************
*     *                                             *
*     *          meta_gauss_write_end               *
*     *                                             *
*     ***********************************************
      subroutine meta_gauss_write_end()
      implicit none

      integer   MASTER
      parameter (MASTER=0)

      integer taskid
      character*255 full_bak

      call Parallel_taskid(taskid)

      if (taskid.eq.MASTER) then
         close(unit=54)

*        **** remove backup file ***
         call util_file_name_noprefix('META-GAUSS99-bak',.false.,
     >                                .false.,
     >                                full_bak)
         call util_file_unlink(full_bak)
      end if


      return
      end

*     ***********************************************
*     *                                             *
*     *          meta_gauss_write                   *
*     *                                             *
*     ***********************************************
      subroutine meta_gauss_write(n,r,sigma,w,E)
      implicit none
      integer n
      real*8 r(*),sigma(*),w,E(*)

*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)

      integer i

      call Parallel_taskid(taskid)

      if (taskid.eq.MASTER) then
         write(54,111) (r(i),i=1,n),(sigma(i),i=1,n),w,
     >                 E(2)-E(31)+E(32),E(3),E(4),E(31),E(32)
         call util_flush(54)
      end if
  111 format(99e14.6)

      return
      end



*     ***********************************************
*     *                                             *
*     *              meta_setsn2surface             *
*     *                                             *
*     ***********************************************
      subroutine meta_setsn2surface(sn2)
      implicit none
      real*8 sn2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "metadynamics.fh"

*     **** local variables ****
      logical sn2found,blaisbunker
      integer d1,d2,i,j(10),d
      real*8  xp,xr,ww
      real*8 er,ep,erp,betar,betap,betarp,xr0,xp0,xrp0
      real*8 wr,ar,br,wp,ap,bp,fr,fp,frp,gr,gp

      sn2found = dabs(sn2(1)).gt.1.0d-9
      if (sn2found) then

      blaisbunker = (sn2(1).lt.0.0d0)
    
      if (blaisbunker) then
      er  = sn2(2)
      ep  = sn2(3)
      erp = sn2(4)
      betar  = sn2(5)
      betap  = sn2(6)
      betarp = sn2(7)
      xr0  = sn2(8)
      xp0  = sn2(9)
      xrp0 = sn2(9)
      ap = sn2(10)
      bp = sn2(11)

      else
      xr0 = sn2(2)
      wr  = sn2(3)
      ar  = sn2(4)
      br  = sn2(5)

      xp0 = sn2(6)
      wp  = sn2(7)
      ap  = sn2(8)
      bp  = sn2(9)

      er  = sn2(10)
      ep  = sn2(11)
      erp = sn2(12)
      end if

      if (metafound) then
         if (nmeta.gt.0) then
            do d=1,nmeta
               j(d) = 0
            end do
            do i=1,nxmeta_all
               ww = 0.0d0
               d1 = 1
               d2 = 2
               xr = dbl_mb(ameta(1)+d1-1) 
     >           + j(d1)*(dbl_mb(bmeta(1)+d1-1)-dbl_mb(ameta(1)+d1-1))
     >                 /dble(int_mb(nxmeta(1)+d1-1)-1)
               xp = dbl_mb(ameta(1)+d2-1) 
     >           + j(d2)*(dbl_mb(bmeta(1)+d2-1)-dbl_mb(ameta(1)+d2-1))
     >                 /dble(int_mb(nxmeta(1)+d2-1)-1)

               if (blaisbunker) then
                  fr = er - er*(1.0d0-dexp(-betar*(xr-xr0)))**2
                  fp = ep - ep*(1.0d0-dexp(-betap*(xp-xp0)))**2
     >               + (1.0d0-dtanh(ap*xr+bp))
     >                *(ep - ep*dexp(-betap*(xp-xp0)))
                  frp = erp - erp*(1.0d0-dexp(-betarp*(xr+xp-xrp0)))**2
                  ww = fr+fp+frp
               else
                  fr = er + (erp-er)*(1.0d0+dtanh( (xp0-xp)/ar))
                  gr = dexp(-((xr-xr0)/wr)**2)
     >                *(0.5d0+0.5d0*dtanh((xp-xp0)/br))

                  fp = ep + (erp-ep)*(1.0d0+dtanh( (xr0-xr)/ap))
                  gp = dexp(-((xp-xp0)/wp)**2)
     >                 *(0.5d0+0.5d0*dtanh((xr-xr0)/bp))
                  ww = fr*gr + fp*gp
               end if

               if (ww.gt.0.0d0) ww = 0.0d0
               dbl_mb(ymeta(1)+i-1) = dbl_mb(ymeta(1)+i-1) - ww

               j(1) = j(1) + 1
               do d=1,nmeta-1
                  if (j(d).ge.int_mb(nxmeta(1)+d-1)) then
                     j(d) = 0
                     j(d+1) = j(d+1)+1
                  end if
               end do
            end do
         end if
      end if
      end if
      return
      end

c
c $Id: hnd_sd_ij.F 21348 2011-10-31 22:51:25Z d3p852 $
c
c Modified from HONDO
c
      subroutine hnd_sd_ij2(xyzi,expi,coefi,i_nprim,i_ngen, Li,
     1  xyzj,expj,coefj, j_nprim, j_ngen, Lj,
     1  disij,djsij,didisij,didjsij,djdjsij,nder,nint,scr,lscr)
c
c This is a wrapper routine, setting up scratch blocks used in actual
c integral routine
c
      implicit none
c
      integer i_nprim  ! [input] num. prims on function i
      integer i_ngen   ! [input] num general conts on func. i
      integer Li       ! [input] angular momentum of func. i
      integer j_nprim  ! [input] num. prims on function j
      integer j_ngen   ! [input] num general conts on func. j
      integer Lj       ! [input] angular momentum of func. j
      integer nder     ! [input] 1=1rst der; 2=2nd der
      integer nint     ! [input] number of base integrals
      integer lscr     ! [input] length of scratch space
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim)  ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen)  ! [input] j coeffs
      double precision disij(nint,3)! [output] 1rst derivative wrt i
      double precision djsij(nint,3) ! [output] 1rst derivative wrt j
      double precision didisij(nint,3,3) ! [output] 2nd derivative wrt i,i
      double precision didjsij(nint,3,3) ! [output] 2nd derivative wrt i,j
      double precision djdjsij(nint,3,3) ! [output] 2nd derivative wrt j,j
      double precision scr(lscr) ! [input] scratch buffer
c
# include "hnd_pointers.fh"
c
c Use scratch for temps in integral calculation
c Scratch needs are dependent on nder:
c nder=1 (3*(Li+3)*(Lj+2) + 6*(Li+1)*(Lj+1)) + 9 zero length blocks
c nder=2 (3*(Li+3)*(Lj+2) +15*(Li+1)*(Lj+1))
c
c The pointers are defined in hnd_pointers.fh
c
      call hnd_sd_ij21(xyzi,expi,coefi,i_nprim,i_ngen, Li,
     1     xyzj,expj,coefj, j_nprim, j_ngen, Lj,
     2     disij,djsij,didisij,didjsij,djdjsij,nder,nint,
     3     scr(tvp(1)) ,scr(tvp(2)) ,scr(tvp(3)) ,scr(tvp(7)),
     4     scr(tvp(8)) ,scr(tvp(9)) ,scr(tvp(10)),scr(tvp(11)),
     5     scr(tvp(12)),scr(tvp(28)),scr(tvp(29)),scr(tvp(30)),
     6     scr(tvp(31)),scr(tvp(32)),scr(tvp(33)),scr(tvp(34)),
     7     scr(tvp(35)),scr(tvp(36)))
c
      return
      end
c
      subroutine hnd_sd_ij21(xyzi,expi,coefi,i_nprim,i_ngen, Li,
     1  xyzj,expj,coefj, j_nprim, j_ngen, Lj,
     2  disij,djsij,didisij,didjsij,djdjsij,nder,nint,
     3  xs,ys,zs,dxsdi,dysdi,dzsdi,dxsdj,dysdj,dzsdj,dxsdii,dysdii,
     4  dzsdii,dxsdjj,dysdjj,dzsdjj,dxsdij,dysdij,dzsdij)
c
c  This is the routine that actually computes the 1rst and 2nd
c  derivatives of the overlap.  It is assumed that the buffers
c  for the integrals have been zeroed before entering this routine
c  (disij,djsij,didisij,didjsij,djdjsij).
c
      implicit none
#include "hnd_tol.fh"
#include "errquit.fh"
      integer i_nprim  ! [input] num. prims on function i
      integer i_ngen   ! [input] num general conts on func. i
      integer Li       ! [input] angular momentum of func. i
      integer j_nprim  ! [input] num. prims on function j
      integer j_ngen   ! [input] num general conts on func. j
      integer Lj       ! [input] angular momentum of func. j
      integer nder     ! [input] 1=1rst der; 2=2nd der
      integer nint     ! [input] number of base integrals
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim)  ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen)  ! [input] j coeffs
      double precision disij ! [output] 1rst derivative wrt i
      double precision djsij ! [output] 1rst derivative wrt j
      double precision didisij ! [output] 2nd derivative wrt i,i
      double precision didjsij ! [output] 2nd derivative wrt i,j
      double precision djdjsij ! [output] 2nd derivative wrt j,j

      common/hnd_xyzder/xint,yint,zint,t,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     1                             ni,nj,cx,cy,cz
      double precision xint, yint, zint, t, x0, y0, z0, xi, yi, zi
      double precision xj, yj, zj, cx, cy, cz
      double precision ijx, ijy, ijz, xs, ys, zs
      double precision dxsdi, dysdi, dzsdi, dxsdj, dysdj, dzsdj
      double precision dxsdii, dysdii, dzsdii 
      double precision dxsdjj, dysdjj, dzsdjj 
      double precision dxsdij, dysdij, dzsdij
      double precision rln10, zero, one, tol, rr, ai, aj, arri
      double precision axi, ayi, azi, csi, cpi, cdi, cfi, cgi
      double precision aa, aa1, dum, fac, csj, cpj, cdj, cfj, cgj
      double precision ax, ay, az, dum1, dum2, pij
      double precision dumx, dumy, dumz, dumxx, dumyy, dumzz
      double precision dumxy, dumxz, dumyz, dumyx, dumzx, dumzy
      integer ni, nj, Nxyz
      integer lit, maxi, litder, ljt, maxj
      integer ljtder, ig, jg, ij, i, j, ix, iy, iz, jx, jy, jz
      dimension didisij(nint,3,3),didjsij(nint,3,3),djdjsij(nint,3,3)
      dimension disij(nint,3),djsij(nint,3)
      dimension xs(Li+3,Lj+2), ys(Li+3,Lj+2), zs(Li+3,Lj+2)
      dimension dxsdi (Li+1,Lj+1),dysdi (Li+1,Lj+1),dzsdi (Li+1,Lj+1)
      dimension dxsdj (Li+1,Lj+1),dysdj (Li+1,Lj+1),dzsdj (Li+1,Lj+1)
      dimension dxsdii(Li+1,Lj+1),dysdii(Li+1,Lj+1),dzsdii(Li+1,Lj+1)
      dimension dxsdjj(Li+1,Lj+1),dysdjj(Li+1,Lj+1),dzsdjj(Li+1,Lj+1)
      dimension dxsdij(Li+1,Lj+1),dysdij(Li+1,Lj+1),dzsdij(Li+1,Lj+1)
      dimension Nxyz(3)
      data rln10  /2.30258d+00/
      data zero   /0.0d+00/
      data one    /1.0d+00/
c
      tol =rln10*itol
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi=lit*(lit+1)/2
c
      litder=lit+nder
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj=ljt*(ljt+1)/2
c
      ljtder=ljt+nder
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
c
c     ----- i primitive -----
c
      do 7000 ig=1,i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do 6000 jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=one/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) go to 6000
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      pij=csi*csj*fac
c
c     ----- overlap derivatives -----
c
      t = sqrt(aa1)
      x0=ax
      y0=ay
      z0=az
      do 370 j=1,ljtder
      nj=j
      do 370 i=1,litder
      ni=i
      call hnd_sxyz
      xs(i,j)=xint*t
      ys(i,j)=yint*t
      zs(i,j)=zint*t
  370 continue
c
      call hnd_dderij2(dxsdii,dysdii,dzsdii,dxsdij,dysdij,dzsdij,
     1            dxsdjj,dysdjj,dzsdjj,
     2            dxsdi ,dysdi ,dzsdi ,dxsdj ,dysdj ,dzsdj ,
     3            xs,ys,zs,lit,ljt,ai,aj,nder)
c
      ij=0
      do 390 i=1,maxi
      call getNxyz(Li,i,Nxyz)
      ix = Nxyz(1) + 1
      iy = Nxyz(2) + 1
      iz = Nxyz(3) + 1
      do 380 j=1,maxj
      call getNxyz(Lj,j,Nxyz)
      jx = Nxyz(1) + 1
      jy = Nxyz(2) + 1
      jz = Nxyz(3) + 1
c
      ij=ij+1
c
      if (nder.eq.1) then
c
c do derivative wrt the first atom
c
        dumx =dxsdi (ix,jx)* ys   (iy,jy)* zs   (iz,jz)
        dumy = xs   (ix,jx)*dysdi (iy,jy)* zs   (iz,jz)
        dumz = xs   (ix,jx)* ys   (iy,jy)*dzsdi (iz,jz)
c
c switching the ij and xyz breaks unit stride, but it works
c for the moment - tlw
c
        disij(ij,1)=disij(ij,1)+ dumx*pij
        disij(ij,2)=disij(ij,2)+ dumy*pij
        disij(ij,3)=disij(ij,3)+ dumz*pij
c
c do derivative wrt the second atom
c
        dumx =dxsdj (ix,jx)* ys   (iy,jy)* zs   (iz,jz)
        dumy = xs   (ix,jx)*dysdj (iy,jy)* zs   (iz,jz)
        dumz = xs   (ix,jx)* ys   (iy,jy)*dzsdj (iz,jz)
        djsij(ij,1)=djsij(ij,1)+ dumx*pij
        djsij(ij,2)=djsij(ij,2)+ dumy*pij
        djsij(ij,3)=djsij(ij,3)+ dumz*pij
      endif
c
      if (nder.eq.2) then
      dumxx=dxsdii(ix,jx)* ys   (iy,jy)* zs   (iz,jz)
      dumyy= xs   (ix,jx)*dysdii(iy,jy)* zs   (iz,jz)
      dumzz= xs   (ix,jx)* ys   (iy,jy)*dzsdii(iz,jz)
      dumxy=dxsdi (ix,jx)*dysdi (iy,jy)* zs   (iz,jz)
      dumxz=dxsdi (ix,jx)* ys   (iy,jy)*dzsdi (iz,jz)
      dumyz= xs   (ix,jx)*dysdi (iy,jy)*dzsdi (iz,jz)
      didisij(ij,1,1)=didisij(ij,1,1)+ dumxx*pij 
      didisij(ij,1,2)=didisij(ij,1,2)+ dumxy*pij 
      didisij(ij,1,3)=didisij(ij,1,3)+ dumxz*pij 
      didisij(ij,2,1)=didisij(ij,2,1)+ dumxy*pij 
      didisij(ij,2,2)=didisij(ij,2,2)+ dumyy*pij 
      didisij(ij,2,3)=didisij(ij,2,3)+ dumyz*pij 
      didisij(ij,3,1)=didisij(ij,3,1)+ dumxz*pij 
      didisij(ij,3,2)=didisij(ij,3,2)+ dumyz*pij 
      didisij(ij,3,3)=didisij(ij,3,3)+ dumzz*pij 
c
      dumxx=dxsdij(ix,jx)* ys   (iy,jy)* zs   (iz,jz)
      dumxy=dxsdi (ix,jx)*dysdj (iy,jy)* zs   (iz,jz)
      dumxz=dxsdi (ix,jx)* ys   (iy,jy)*dzsdj (iz,jz)
      dumyx=dxsdj (ix,jx)*dysdi (iy,jy)* zs   (iz,jz)
      dumyy= xs   (ix,jx)*dysdij(iy,jy)* zs   (iz,jz)
      dumyz= xs   (ix,jx)*dysdi (iy,jy)*dzsdj (iz,jz)
      dumzx=dxsdj (ix,jx)* ys   (iy,jy)*dzsdi (iz,jz)
      dumzy= xs   (ix,jx)*dysdj (iy,jy)*dzsdi (iz,jz)
      dumzz= xs   (ix,jx)* ys   (iy,jy)*dzsdij(iz,jz)
      didjsij(ij,1,1)=didjsij(ij,1,1)+ dumxx*pij 
      didjsij(ij,1,2)=didjsij(ij,1,2)+ dumxy*pij 
      didjsij(ij,1,3)=didjsij(ij,1,3)+ dumxz*pij 
      didjsij(ij,2,1)=didjsij(ij,2,1)+ dumyx*pij 
      didjsij(ij,2,2)=didjsij(ij,2,2)+ dumyy*pij 
      didjsij(ij,2,3)=didjsij(ij,2,3)+ dumyz*pij 
      didjsij(ij,3,1)=didjsij(ij,3,1)+ dumzx*pij 
      didjsij(ij,3,2)=didjsij(ij,3,2)+ dumzy*pij 
      didjsij(ij,3,3)=didjsij(ij,3,3)+ dumzz*pij 

      dumxx=dxsdjj(ix,jx)* ys   (iy,jy)* zs   (iz,jz)
      dumyy= xs   (ix,jx)*dysdjj(iy,jy)* zs   (iz,jz)
      dumzz= xs   (ix,jx)* ys   (iy,jy)*dzsdjj(iz,jz)
      dumxy=dxsdj (ix,jx)*dysdj (iy,jy)* zs   (iz,jz)
      dumxz=dxsdj (ix,jx)* ys   (iy,jy)*dzsdj (iz,jz)
      dumyz= xs   (ix,jx)*dysdj (iy,jy)*dzsdj (iz,jz)
      djdjsij(ij,1,1)=djdjsij(ij,1,1)+ dumxx*pij 
      djdjsij(ij,1,2)=djdjsij(ij,1,2)+ dumxy*pij 
      djdjsij(ij,1,3)=djdjsij(ij,1,3)+ dumxz*pij 
      djdjsij(ij,2,1)=djdjsij(ij,2,1)+ dumxy*pij 
      djdjsij(ij,2,2)=djdjsij(ij,2,2)+ dumyy*pij 
      djdjsij(ij,2,3)=djdjsij(ij,2,3)+ dumyz*pij 
      djdjsij(ij,3,1)=djdjsij(ij,3,1)+ dumxz*pij 
      djdjsij(ij,3,2)=djdjsij(ij,3,2)+ dumyz*pij 
      djdjsij(ij,3,3)=djdjsij(ij,3,3)+ dumzz*pij 
c
      endif ! nder=2

  380 continue
  390 continue
c
 6000 continue
 7000 continue
c
      return
      end

      Subroutine hfderi(Ep,Eq,R0,IJK,ERI,E3,sum,
     &                  NPP,NPQ,Nint,La,Lb,Lc,Ld,Lr,
     &                  MXD,inder1,Nder1,inder2,Nder2,inder3,Nder3,
     &                  canAB,canCD,canPQ)
c $Id: hfderi.F 19696 2010-10-29 16:53:42Z d3y133 $

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)
#include "sh_order.fh"

      Logical canAB,canCD,canPQ

c--> Hermite Linear Expansion Coefficients

      Dimension Ep(3,NPP,0:MXD,0:(La+Lb),0:La,0:Lb)
      Dimension Eq(3,NPQ,0:MXD,0:(Lc+Ld),0:Lc,0:Ld)

c--> Auxiliary Function Integrals & Index

      Dimension R0((NPQ*NPP),*),IJK(0:Lr,0:Lr,0:Lr)

c--> ERI

      Dimension ERI((NPQ*NPP),Nint,(Nder1*Nder2*Nder3))

c--> Derivative Indices

      Dimension inder1(6,Nder1),inder2(3,Nder2),inder3(3,Nder3)

c--> Scratch Space

      Dimension E3(*),sum((NPQ*NPP),(Nder1*Nder2),*)
c
c Compute gradient electron repulsion integrals (ERI).
c
c     Formula:
c
c               __
c               \     Ic,Id;n10   Jc,Jd;n11   Kc,Kd;n12
c     ERI  =    /   Ex          Ey          Ez          SUM
c               --    Iq          Jq          Kq           Iq,Jq,Kq
c            Iq,Jq,Kq
c
c                            __
c                           \     Lq   Ia,Ib;n7   Ja,Jb;n8   Ka,Kb;n9
c         SUM          =    /  (-1)  Ex         Ey         Ez         R
c            Iq,Jq,Kq       --         Ip         Jp         Kp        Ir,Jr,Kr
c                        Ip,Jp,Kp
c
c                                Ir = (Ip+n1) + (Iq+n4)
c                        where   Jr = (Jp+n2) + (Jq+n5)
c                                Kr = (Kp+n3) + (Kq+n6)
c
c                         and    Lq = (Iq+n4) + (Jq+n5) + (Kq+n6)
c
c Currently, the 12 gradient integrals can be grouped into 3 sets. The 
c integrals in each set can be evaluated with a single call to this routine
c The derivative indices specify the order of differentiation for each of 
c the 12 coordinates:
c
c     Set 1, inder1(i,n), i=1-3:   d/dPx, d/dPy, d/dPz;       n1,  n2,  n3
c                         i=4-6:   d/dQx, d/dQy, d/dQz;       n4,  n5,  n6
c     Set 2, inder2(i,n), i=1-3:   d/dRx, d/dRy, d/dRz;       n7,  n8,  n9
c     Set 3, inder3(i,n), i=1-3:   d/dSx, d/dSy, d/dSz;      n10, n11, n12
c
c N.B. This routine cannot simultaneously evaluate integrals from
c      different sets!
c
c******************************************************************************
      double precision zot
      integer la6,lb6,lc6,ld6
      integer nder12
      logical lneg
      la6=(la*(la+1)*(la+2))/6
      lb6=(lb*(lb+1)*(lb+2))/6
      lc6=(lc*(lc+1)*(lc+2))/6
      ld6=(ld*(ld+1)*(ld+2))/6
      nder12=nder1*nder2
      if(nder12.ne.1.and.nder12.ne.3) call
     C     errquit(' hfderi: nder12.ne.1.and.ne.3 ',nder12,0)
    
c

c Initialize the block of ERIs.

      call dcopy(nder12*Nder3*Nint*NPQ*NPP,0d0,0,ERI,1)

c General case:  [ab|cd]

c Define the number of shell components on each center.

       La2 = ((La+1)*(La+2))/2
       Lb2 = ((Lb+1)*(Lb+2))/2
       Lc2 = ((Lc+1)*(Lc+2))/2
       Ld2 = ((Ld+1)*(Ld+2))/2

       Lqmax  = Lc + Ld
       Lqmax3 = ((Lqmax+1)*(Lqmax+2)*(Lqmax+3))/6

c Loop over the components of the "a" and "b" shells.

       nn = 0
       md_limit = Ld2
       mb_limit = Lb2
       
       do 500 ma = 1,La2

        nc =  la6 + ma
        ia = Ixyz(1,nc)
        ja = Ixyz(2,nc)
        ka = Ixyz(3,nc)

        if( canAB )  mb_limit = ma

        do 490 mb = 1,mb_limit

           if( canPQ )then

            if( canAB )then
             ij = (ma*(ma-1))/2 + mb
            else
             ij = (ma-1)*Lb2 + mb
            end if


           end if


           nc =  lb6 + mb
           ib = Ixyz(1,nc)
           jb = Ixyz(2,nc)
           kb = Ixyz(3,nc)

c Sum across (Ip,Jp,Kp) for each value of (Iq,Jq,Kq).

         call dcopy((NPQ*NPP)*nder12*Lqmax3,0d0,0,sum,1)

         do 425 Ip = 0,Ia+Ib
         do 425 Jp = 0,Ja+Jb
         do 425 Kp = 0,Ka+Kb

          do 424 id2 = 1,Nder2

           n7 = inder2(1,id2)
           n8 = inder2(2,id2)
           n9 = inder2(3,id2)

c Define the product of the Hermite expansions coefficients for 
c charge distribution "P".

           do 410 mp = 1,NPP
            E3(mp) = Ep(1,mp,n7,Ip,Ia,Ib)*
     &               Ep(2,mp,n8,Jp,Ja,Jb)*
     &               Ep(3,mp,n9,Kp,Ka,Kb)
  410      continue

           do 420 Iq = 0,Lqmax
           do 420 Jq = 0,Lqmax-Iq
           do 420 Kq = 0,Lqmax-Iq-Jq

            nq = IJK(Iq,Jq,Kq)

             id4 = (id2-1)*Nder1 

            do 419 id1 = 1,Nder1

             n1 = inder1(1,id1)
             n2 = inder1(2,id1)
             n3 = inder1(3,id1)

             n4 = inder1(4,id1)
             n5 = inder1(5,id1)
             n6 = inder1(6,id1)

             Ir = (Ip+Iq)+n1+n4
             Jr = (Jp+Jq)+n2+n5
             Kr = (Kp+Kq)+n3+n6

             nr = IJK(Ir,Jr,Kr)

             id4 = id4 + 1

c Include the factor of (-1)**Lq

             Lq = (Iq+n4) + (Jq+n5) + (Kq+n6)

             lneg=( and(Lq,1).eq.1 )

              mr = 0
              if(npq.eq.1) then
                 if(lneg) then
                    do  mp = 1,NPP
                       sum(mp,id4,nq) = sum(mp,id4,nq) -e3(mp)*R0(mp,nr)
                    enddo
                 else
                    do  mp = 1,NPP
                       sum(mp,id4,nq) = sum(mp,id4,nq) +e3(mp)*R0(mp,nr)
                    enddo
                 endif
              else
              do  mp = 1,NPP
                 if(lneg) then
                    zot=-e3(mp)
                 else
                    zot=e3(mp)
                 endif
              do mq = mr+1,mr+NPQ

               sum(mq,id4,nq) = sum(mq,id4,nq) +zot*R0(mq,nr)

               enddo
               mr = mr + NPQ
            enddo
            endif


  419       continue

  420      continue

  424     continue

  425    continue

c Loop over the components of the "c" and "d" shells.

         do 480 mc = 1,Lc2

            nc =  lc6 + mc
            ic = Ixyz(1,nc)
            jc = Ixyz(2,nc)
            kc = Ixyz(3,nc)

          if( canCD ) md_limit = mc

          do 470 md = 1,md_limit

           if( canPQ )then

            if( canAB )then
             kl = (mc*(mc-1))/2 + md
            else
             kl = (mc-1)*Ld2 + md
            end if

            if( kl.gt.ij ) go to 480

           end if

             nc =  ld6 + md
             id = Ixyz(1,nc)
             jd = Ixyz(2,nc)
             kd = Ixyz(3,nc)

           nn = nn + 1

c Sum across (Iq,Jq,Kq).

           do 450 Iq = 0,Ic+Id
           do 450 Jq = 0,Jc+Jd
           do 450 Kq = 0,Kc+Kd

            nq = IJK(Iq,Jq,Kq)

            id5 = 0
            if(npq.eq.1) then
               do  id3 = 1,Nder3

                  n10 = inder3(1,id3)
                  n11 = inder3(2,id3)
                  n12 = inder3(3,id3)
                  zot=
     *                       Eq(1,1,n10,Iq,Ic,Id)*
     &                       Eq(2,1,n11,Jq,Jc,Jd)*
     &                       Eq(3,1,n12,Kq,Kc,Kd)
                  if(nder12.eq.1) then
                     id5 = id5 + 1
                     
                     do  mp = 1,NPP

                        ERI(mp,nn,id5) = ERI(mp,nn,id5) + 
     +                       sum(mp,1,nq)*zot
                        
                     enddo
                  else
                     do  mp = 1,NPP
                        ERI(mp,nn,id5+1) = ERI(mp,nn,id5+1) + 
     +                       sum(mp,1,nq)*zot
                        ERI(mp,nn,id5+2) = ERI(mp,nn,id5+2) + 
     +                       sum(mp,2,nq)*zot
                        ERI(mp,nn,id5+3) = ERI(mp,nn,id5+3) + 
     +                       sum(mp,3,nq)*zot
                     enddo
                     id5 = id5 + 3
                  endif
               enddo
            else
            do 449 id3 = 1,Nder3

             n10 = inder3(1,id3)
             n11 = inder3(2,id3)
             n12 = inder3(3,id3)

c Define the product of the Hermite expansions coefficients for 
c charge distribution "Q".

             if(NPQ.eq.1) then
                zot = Eq(1,1,n10,Iq,Ic,Id)*
     &               Eq(2,1,n11,Jq,Jc,Jd)*
     &               Eq(3,1,n12,Kq,Kc,Kd)
             else
             do mq = 1,NPQ
                E3(mq) = Eq(1,mq,n10,Iq,Ic,Id)*
     &               Eq(2,mq,n11,Jq,Jc,Jd)*
     &               Eq(3,mq,n12,Kq,Kc,Kd)
             enddo
             endif

             if(NPP.eq.1) then
                if(NPQ.eq.1) then
                   if(nder12.eq.1) then
                      ERI(1,nn,id5) = ERI(1,nn,id5) + 
     +                     zot*sum(1,1,nq)
                      id5=id5+1
                   else
                      ERI(1,nn,id5+1) = ERI(1,nn,id5) + 
     +                     zot*sum(1,1,nq)
                      ERI(1,nn,id5+2) = ERI(1,nn,id5) + 
     +                     zot*sum(1,2,nq)
                      ERI(1,nn,id5+3) = ERI(1,nn,id5) + 
     +                     zot*sum(1,3,nq)
                      id5 = id5 + 3
                   endif
                else
                   do id4 = 1,nder12
                      id5 = id5 + 1
                      do  mq = 1,NPQ
                         ERI(mq,nn,id5) = ERI(mq,nn,id5) + 
     +                        E3(mq)*sum(mq,id4,nq)
                      enddo
                   enddo
                endif
             else
                mr = 0
                if(nder12.eq.1) then
              id5 = id5 + 1
                   do mp = 1,NPP
                      do  mq = 1,NPQ
                         mr = mr + 1

                         ERI(mr,nn,id5) = ERI(mr,nn,id5) + 
     +                        E3(mq)*sum(mr,1,nq)

                    enddo
                 enddo
                else

              do 440 mp = 1,NPP
                 do 440 mq = 1,NPQ
                    mr = mr + 1

                    ERI(mr,nn,id5+1) = ERI(mr,nn,id5+1) + 
     +                   E3(mq)*sum(mr,1,nq)
                    ERI(mr,nn,id5+2) = ERI(mr,nn,id5+2) + 
     +                   E3(mq)*sum(mr,2,nq)
                    ERI(mr,nn,id5+3) = ERI(mr,nn,id5+3) + 
     +                   E3(mq)*sum(mr,3,nq)

 440             continue
              id5 = id5 + 3
                 
          endif
             endif

  449       continue

            endif
  450      continue

  470     continue
  480    continue
  490   continue
  500  continue

      end

      subroutine argos_space_nrnode
c
      implicit none
c
#include "argos_space_common.fh"
c
      integer ix,iy,iz,npt,i,j,k,l
c
c     this routine distributes the available processes in the
c     Cartesian directions
c
c     npx : number of processes in x direction
c     npy : number of processes in y direction
c     npz : number of processes in z direction
c
c     determine node dimensions
c
      if(npx*npy*npz.ne.np) then
      if(npx+npy+npz.gt.0)
     + call md_abort('Specified npx*npy*npz ne np',0)
c
      npt=0
      do 1 i=1,np
      do 2 j=i,np
      do 3 k=j,np
      l=i*j*k
      if(l.eq.np) then
      if(l.eq.npt) then
      if(k.gt.npz) goto 3
      if(i+j+k.lt.npx+npy+npz) then
      npx=i
      npy=j
      npz=k
      endif
      goto 3
      else
      npt=np
      npx=i
      npy=j
      npz=k
      endif
      endif
    3 continue
    2 continue
    1 continue
c
      if(npx*npy*npz.ne.np) call md_abort('nrnode: code error',0)
      endif
c
c     determine processor location of me
c
      do 4 ix=1,npx
      do 5 iy=1,npy
      do 6 iz=1,npz
      if(me.eq.((iz-1)*npy+(iy-1))*npx+(ix-1)) then
      mex=ix-1
      mey=iy-1
      mez=iz-1
      endif
    6 continue
    5 continue
    4 continue
c
      return
      end
c $Id: argos_space_nrnode.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine smd_geom_init_system0()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
c     
      character*(smd_string_size) sp_geom,sp_atom
      character*(smd_string_size) tag,pname
      logical result
      integer h_itmp,i_itmp
      integer nb,nr
      integer h_c,i_c,h_ct,i_ct
      integer i_nb
      integer nt
      integer ng
      integer i,j
      integer i_pr,i_mr
      integer i_im,i_nm
      integer i_c1,i_ms1,i_t1,i_qf1
      integer i_sht
      integer i_qf,i_m,i_ta
      integer rtdb

      pname = "smd_geom_init_system0"

c      write(*,*) "in "//pname
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
      call util_message(pname//":0")
      call smd_namespace_create(sp_geom)
c      write(*,*) "out of "//pname

      return
      end

      subroutine smd_geom_repair()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "stdio.fh"
      integer im
      logical oinclude
      character*(smd_string_size) sp_geom
      character*(smd_string_size) tag,pname
      logical result
      integer h_itmp,i_itmp
      integer nb,nr
      integer i_nb
      integer nt
      integer ng
      integer i,j,ir
      integer i_pr,i_mr
      integer i_im,i_nm
      integer i_c
      character*64 msg

      pname = "smd_geom_init_system"
c
c     get locations of residues in the atomic arrays
c     ----------------------------------------------
      tag = "atom:res_pointer"
      call smd_get_ind_dim(tag,i_pr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:res_size"
      call smd_get_ind_dim(tag,i_mr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c     
c     get copy of coordinates
c     ----------------------
      tag = "coords"
      call smd_get_ind_dim(tag,i_c,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      do ir=1,nr
        call smd_geom_rebuild(nt,int_mb(i_mr+ir-1),
     >                   int_mb(i_pr+ir-1),dbl_mb(i_c)) 
      end do
      call smd_coords_print_pdb("repaired.pdb")
      return
      end

      subroutine smd_geom_prepare()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "smd_fids.fh"
#include "smd_system.fh"
#include "stdio.fh"
      integer im
      logical oinclude
      character*(smd_string_size) sp_geom
      character*(smd_string_size) tag,pname
      logical result
      integer h_itmp,i_itmp
      integer nb,nr
      integer i_nb
      integer nt
      integer ng
      integer i,j
      integer i_pr,i_mr,i_xr
      integer i_im,i_nm
      double precision shift(3)
      integer i0,n0
      character*64 msg
      logical operiodic
      integer i_c

      pname = "smd_geom_init_system"
c
      operiodic = smd_system_periodic()
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c     get locations of residues in the atomic arrays
c     ----------------------------------------------
      tag = "atom:res_pointer"
      call smd_get_ind_dim(tag,i_pr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:res_size"
      call smd_get_ind_dim(tag,i_mr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:res_type"
      call smd_get_ind_dim(tag,i_xr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c     determine cluster residues
c     --------------------------
      tag = "icenter"
      call smd_data_get_int(sp_geom,tag,1,im,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting central residue'//tag,0, RTDB_ERR)
c
c     check if attempting to compute nonexisting residue
      if(im.gt.nr)   
     >  call errquit(
     >       pname//'residue index out of bounds',0, RTDB_ERR)
c
c
      tag = "oinclude"
      call smd_data_get_log(sp_geom,tag,1,oinclude,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting include flag'//tag,0, RTDB_ERR)

      if(.not.ma_push_get(mt_int,nr,'tmp i',h_itmp,i_itmp))
     + call errquit(pname//'Failed to allocate memory for h_itmp',0,0)
c
      nb = nr
      call smd_geom_find_neighbors(oinclude,im,nb,int_mb(i_itmp))
c      if(ga_nodeid().eq.0) then
c        write(luout,*) "cluster information",
c     +    (int_mb(i_itmp+i-1),i=1,nb)
c        call util_flush(luout)
c      end if
      tag = "neighbor_index"
      call smd_data_put_int(sp_geom,tag,nb,int_mb(i_itmp))
      call smd_data_get_index(sp_geom,tag,i_nb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
c     set residue type to QM for cluter segments
c     ------------------------------------------
      do i=1,nb
        j=int_mb(i_nb+i-1)
        int_mb(i_xr+j-1) = i_tqm
      end do
c
c     determine position and size (atom based) of the cluster residues
c
      tag = "position"
      call smd_data_create_get(sp_geom,tag,nb,MT_INT,i_im)
      tag = "size"
      call smd_data_create_get(sp_geom,tag,nb,MT_INT,i_nm)
      do i=1,nb
        j=int_mb(i_nb+i-1)
        int_mb(i_im+i-1)=int_mb(i_pr+j-1)
        int_mb(i_nm+i-1)=int_mb(i_mr+j-1)
      end do
c
c     total number of atoms in the geometry
c     ------------------------------------
      ng = 0
      do i=1,nb
        j=int_mb(i_nb+i-1)
        ng=ng+int_mb(i_mr+j-1)
      end do
      tag = "ntot"
      call smd_data_put_int(sp_geom,tag,1,ng)
c
c     determine translation vector to put 1st residue in the center
c     -------------------------------------------------------------
c     
c     get copy of coordinates
c     ----------------------
      tag = "coords"
      call smd_get_ind(tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      if(operiodic) then
        i0=int_mb(i_pr+im-1)
        n0=int_mb(i_mr+im-1)
        call smd_geom_shift(n0,
     +                  dbl_mb(i_c+3*(i0-1)),shift)
      else
        do i=1,3
          shift(i) = 0.0d0
        end do
      end if
      tag = "shift vector"
      call smd_data_put_dbl(sp_geom,tag,3,shift)
c
c      
      if(.not.ma_pop_stack(h_itmp))
     & call errquit(pname//'Failed to deallocate stack h_itmp',0,
     &       MA_ERR)
c    
c     create geometry
c     --------------
      call smd_geom_create()

      call util_message("out "//pname)

      return
      end

      subroutine smd_geom_end()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "smd_fids.fh"
#include "stdio.fh"
      integer im
      logical oinclude
      character*(smd_string_size) sp_geom
      character*(smd_string_size) tag,pname
      logical result
      integer h_itmp,i_itmp
      integer nb,nr
      integer i_nb
      integer nt
      integer ng
      integer i,j
      integer i_pr,i_mr,i_xr
      integer i_im,i_nm
      character*64 msg

      pname = "smd_geom_init_system"
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "atom:res_type"
      call smd_get_ind_dim(tag,i_xr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c     reset residue type to MM
c     ------------------------
      do i=1,nr
        int_mb(i_xr+i-1) = i_tmm
      end do
      call util_message("out "//pname)

      return
      end

      subroutine smd_geom_init_system(im)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "stdio.fh"
      integer im
c     
      character*(smd_string_size) sp_geom
      character*(smd_string_size) tag,pname
      logical result
      integer h_itmp,i_itmp
      integer nb,nr
      integer i_nb
      integer nt
      integer ng
      integer i,j
      integer i_pr,i_mr
      integer i_im,i_nm
      character*64 msg

      pname = "smd_geom_init_system"
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
c     get locations of residues in the atomic arrays
c     ----------------------------------------------
      tag = "atom:res_pointer"
      call smd_get_ind_dim(tag,i_pr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:res_size"
      call smd_get_ind_dim(tag,i_mr,nr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c     check if attempting to compute nonexisting residue
      if(im.gt.nr)   
     >  call errquit(
     >       pname//'residue index out of bounds',0, RTDB_ERR)
c
c     determine neighbors around im
c     -----------------------------
      if(.not.ma_push_get(mt_int,nr,'tmp i',h_itmp,i_itmp))
     + call errquit(pname//'Failed to allocate memory for h_itmp',0,0)
c
      nb = nr
      call smd_geom_find_neighbors(.true.,im,nb,int_mb(i_itmp))
c      if(ga_nodeid().eq.0) then
c        write(luout,*) "cluster information",
c     +    (int_mb(i_itmp+i-1),i=1,nb)
c        call util_flush(luout)
c      end if
      tag = "neighbor_index"
      call smd_data_put_int(sp_geom,tag,nb,int_mb(i_itmp))
      call smd_data_get_index(sp_geom,tag,i_nb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
c     determine position and size (atom based) of the cluster residues
c
      tag = "position"
      call smd_data_create_get(sp_geom,tag,nb,MT_INT,i_im)
      tag = "size"
      call smd_data_create_get(sp_geom,tag,nb,MT_INT,i_nm)
      do i=1,nb
        j=int_mb(i_nb+i-1)
        int_mb(i_im+i-1)=int_mb(i_pr+j-1)
        int_mb(i_nm+i-1)=int_mb(i_mr+j-1)
      end do
c
c     total number of atoms in the geometry
c     ------------------------------------
      ng = 0
      do i=1,nb
        j=int_mb(i_nb+i-1)
        ng=ng+int_mb(i_mr+j-1)
      end do
      tag = "ntot"
      call smd_data_put_int(sp_geom,tag,1,ng)
c      
      if(.not.ma_pop_stack(h_itmp))
     & call errquit(pname//'Failed to deallocate stack h_itmp',0,
     &       MA_ERR)
c    
c     create geometry
c     --------------
      call smd_geom_create()

      call util_message("out "//pname)

      return
      end
C>    Creates geometry object and
C>    stores it in rtdb
C>    Input parameters are passed silently
C>    through the smd objects (geom,coords,atom)
      subroutine smd_geom_create()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
#include "smd_const_data.fh"
#include "smd_system.fh"
#include "stdio.fh"
c
      logical geom_cart_set_gen1
      external geom_cart_set_gen1
c      
      integer rtdb,m,n,ncent
c
      integer i,j
      integer i0,i1,n0,k
      character*20 pname
      character*64 msg
      character*(smd_string_size) tag
      character*(smd_string_size) sp_geom
      integer igeom
      integer nact,i_act,h_act
      double precision shift(3)
      integer i_t1,h_t1
      integer i_q1,h_q1
      integer i_c1,h_c1
      integer i_ms1,h_ms1
      integer n1,ns
      integer i_c,i_qf,i_m,i_ta
      integer i_im,i_nm
      integer ioff
      logical result
      integer igroup
      integer un
      logical operiodic
      integer im
      integer i_gim,i_gnm
c
      pname = "smd_geom_create"
c      call smd_geom_repair()
c      stop

c
      call smd_task_get_counter(im)
      write(msg,'(A20," 1 ",I3)') pname,im
c      call smd_coords_check(msg)
      operiodic = smd_system_periodic()
c
      call smd_group_id_get(igroup)
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "position"
      call smd_data_get_ind_dim(sp_geom,tag,i_im,m,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c      
      tag = "size"
      call smd_data_get_ind_dim(sp_geom,tag,i_nm,m,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
      ns = smd_string_size
c     
c     get copy of coordinates
c     ----------------------
      tag = "coords"
      call smd_get_ind_dim(tag,i_c,n,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      tag = "mass"
      call smd_get_ind(tag,i_m,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:name"
      call smd_get_ind(tag,i_ta,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      tag = "atom:formal_charge"
      call smd_get_ind(tag,i_qf,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c c
c     size
c     ----
      n1=0
      do i=1,m
        n1 = n1 + int_mb(i_nm+i-1)
      end do
c      
      if(.not.ma_push_get(mt_dbl,3*n1,pname//'tmp c',h_c1,i_c1))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
      if(.not.ma_push_get(mt_dbl,n1,'tmp q',h_q1,i_q1))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
      if(.not.ma_push_get(mt_dbl,n1,'tmp m',h_ms1,i_ms1))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
      if(.not.ma_push_get(mt_byte,n1*smd_string_size,'tmp t',h_t1,i_t1))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
c
c     determine translation vector to put 1st residue in the center
c     -------------------------------------------------------------
c      if(operiodic) then
c        i0=int_mb(i_im+i-1)-1
c        call smd_geom_shift(int_mb(i_nm),
c     +                  dbl_mb(i_c+3*()),shift)
c      else
c        do i=1,3
c          shift(i) = 0.0d0
c        end do
c      end if
c      tag = "shift vector"
c      call smd_data_put_dbl(sp_geom,tag,3,shift)
      tag = "shift vector"
      call smd_data_get_dbl(sp_geom,tag,3,shift,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting shift vector '//tag,0, RTDB_ERR)

      tag = "res-index"
      call smd_data_create_get(sp_geom,tag,m,MT_INT,i_gim)
      tag = "res-size"
      call smd_data_create_get(sp_geom,tag,m,MT_INT,i_gnm)
c
c     copy geometry of the region into temp buffers
c     ---------------------------------------------
      j=0
      do i=1,m
       i0=int_mb(i_im+i-1)-1
       n0=int_mb(i_nm+i-1)
       int_mb(i_gim+i-1)=j+1
       int_mb(i_gnm+i-1)=n0
       do i1=1,n0
         j = j+1
         ioff = i0+i1-1
         do k=1,3
           dbl_mb(i_c1+(j-1)*3+k-1)=
     +         dbl_mb(i_c+ioff*3+k-1)-shift(k)
         end do
         dbl_mb(i_ms1+j-1)=dbl_mb(i_m+ioff)
         dbl_mb(i_q1+j-1)=dbl_mb(i_qf+ioff)
         do k=1,ns
           byte_mb(i_t1+(j-1)*ns+k-1)=byte_mb(i_ta+ioff*ns+k-1)
         end do
       end do
      end do
c      if(operiodic)
c     + call smd_lat_rebox(n1,dbl_mb(i_c1)) 
      if(operiodic)
     + call smd_lat_rebox_segments(n1,m,int_mb(i_gim),int_mb(i_gnm),
     +                     dbl_mb(i_c1)) 

C      write(*,*) "before shift"
C      do i=1,n1
C        write(*,*) (dbl_mb(i_c1+(i-1)*3+k-1),k=1,3)
C      end do
      do i=1,n1
         do k=1,3
           dbl_mb(i_c1+(i-1)*3+k-1)=
     +         dbl_mb(i_c1+(i-1)*3+k-1)+shift(k)
         end do
       end do
C
C      write(*,*) "after shift"
C      do i=1,n1
C        write(*,*) (dbl_mb(i_c1+(i-1)*3+k-1),k=1,3)
C      end do
c
c
c     create geometry
c     ---------------
       if(.not.geom_create(igeom,"geometry"))
     + call errquit('qmmm: Failed to create geometry',0, GEOM_ERR)

      i0=1
      if(.not.geom_cart_set_gen1(igeom,i0,n1,n1,smd_string_size,
     + byte_mb(i_t1),dbl_mb(i_c1),dbl_mb(i_q1)))
     + call errquit('qmmm: Failed to initialize geometry',0, GEOM_ERR)

      if(.not.geom_masses_set(igeom,n1,dbl_mb(i_ms1)))
     + call errquit('qmmm: Failed to initialize masses',0, GEOM_ERR)
      call geom_compute_values(igeom)
      if(.not.geom_ncent(igeom, ncent))
     $           call errquit(pname,0,RTDB_ERR)

c
      if(ga_nodeid().eq.0) then
      call smd_file_open(un,"tmp.xyz")
      if (.not. geom_print_xyz(igeom,un))
     + call errquit('qmmmsi geom_print_xyz',0, GEOM_ERR)
      call util_flush(un)
      close(un)
      end if
c
      call ga_sync()
c
      call smd_rtdb_get_handle(rtdb)
      if(.not.geom_rtdb_store(rtdb,igeom,"geometry"))
     + call errquit('qmmm: Failed to store geom to rtdb',0, RTDB_ERR)

       if(.not.geom_destroy(igeom))
     + call errquit('qmmm: Failed to destroy geometry',0, GEOM_ERR)

c
c     set active atoms for optimizations (this really should not be here)
c     -----------------------------------------------------------------
      nact = int_mb(i_nm)
      if(.not.ma_push_get(mt_int,nact,'tmp',h_act,i_act))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nact, MA_ERR)
      do i=1,nact
       int_mb(i_act+i-1) = i
      end do
      if (.not.rtdb_put(rtdb, 'geometry:actlist',
     >       mt_int,nact,int_mb(i_act)))
     $       call errquit(pname,0,
     &       RTDB_ERR)

      if(.not.ma_chop_stack(h_c1))
     & call errquit(pname//'Failed to deallocate stack h_l',0,
     &       MA_ERR)


c      write(msg,'(A20," 2 ",I3)') pname,im
c      call smd_coords_check(msg)
      return
c
  
      end
c
      subroutine smd_geom_rebuild(nt,nm,i0,c)
c     rebuilds potentially cut segment
c     nt      [in]  total number of atoms
c     nm      [in]  number of atoms in the segment
c     i0      [in]  starting index for the segment
c     c[3,nt] [in]  coordinates of the overall system
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer nt
      integer nm
      integer i0
      double precision c(3,nt)
c
      integer i,j
      double precision cshift(3)
      integer i_ftmp,h_ftmp
      character*30 pname
c
      pname = "smd_geom_cog"
c      
      if(.not.ma_push_get(mt_dbl,3*nm,'tmp i',h_ftmp,i_ftmp))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
c
c     put 1st atom in the middle
c     ---------------------------
      do j=1,3
         cshift(j)=c(j,i0)
      end do

      do i=1,nm
      do j=1,3
         dbl_mb(i_ftmp+(i-1)*3+j-1)=
     +         c(j,i0+i-1)-cshift(j)
      end do
      end do
 
c     fold in other coordinates potentially
c     cutoff by the box boundary
      call smd_lat_rebox(nm,dbl_mb(i_ftmp)) 
c     calculate cog for shifted segment
c     --------------------------------- 
      do i=1,nm
      do j=1,3
         c(j,i0+i-1)=dbl_mb(i_ftmp+(i-1)*3+j-1)+cshift(j)
      end do
      end do
c
      if(.not.ma_pop_stack(h_ftmp))
     & call errquit(pname//'Failed to deallocate stack h_ftmp',0,
     &       MA_ERR)
c
      return
c
  
      end
c      
      subroutine smd_geom_cog1(nt,c,cog)
c     finds center of geometry for a give segment
c     nt      [in]  number of atoms
c     c[3,nt] [in]  coordinates 
c     cog[3]  [out] center of mass coordinates
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer nt
      double precision c(3,nt)
      double precision cog(3)
c
      integer i,j
      double precision cshift(3)
      integer i_ftmp,h_ftmp
      character*30 pname
c
      pname = "smd_geom_cog"
c      
      if(.not.ma_push_get(mt_dbl,3*nt,'tmp i',h_ftmp,i_ftmp))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
c
c     put 1st atom in the middle
c     ---------------------------
      do j=1,3
         cshift(j)=c(j,1)
      end do

      do i=1,nt
      do j=1,3
         dbl_mb(i_ftmp+(i-1)*3+j-1)=
     +         c(j,i)-cshift(j)
      end do
      end do
 
c     fold in other coordinates potentially
c     cutoff by the box boundary
      call smd_lat_rebox(nt,dbl_mb(i_ftmp)) 
c     calculate cog for shifted segment
c     --------------------------------- 
      cog(1) = 0.0d0
      cog(2) = 0.0d0
      cog(3) = 0.0d0
      
      do i=1,nt
      do j=1,3
         cog(j)=cog(j)+dbl_mb(i_ftmp+(i-1)*3+j-1)
      end do
      end do

      cog(1) = cog(1)/nt
      cog(2) = cog(2)/nt
      cog(3) = cog(3)/nt
c
c     correct for the shift
c     ---------------------
      do j=1,3
        cog(j) = cog(j)+cshift(j)
      end do
c
      if(.not.ma_pop_stack(h_ftmp))
     & call errquit(pname//'Failed to deallocate stack h_ftmp',0,
     &       MA_ERR)
c
      return
c
  
      end

      subroutine smd_geom_shift(nt,c,shift)
c     finds center of geometry for a give segment
c     nt      [in]  total number of atoms
c     c[3,nt] [in]  coordinates of the overall system
c     shift[3]  [out] center of mass coordinates
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer nt
      integer nm
      integer i0
      double precision c(3,nt)
      double precision shift(3)
      character*72 tag,sp_lat
c
      integer i,j
      double precision cshift(3)
      integer i_ftmp,h_ftmp
      character*30 pname
      double precision a(3,3),dx(3)
      logical result
c
      pname = "smd_geom_shift"
c
      tag = "lattice"
      call smd_system_get_component(sp_lat,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
      tag = "lat:cell"
      call smd_data_get_dbl(sp_lat,tag,9,a,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no lat:cell'//tag,0,0)

      shift(1) = 0.0d0
      shift(2) = 0.0d0
      shift(3) = 0.0d0
      
      do i=1,nt
      do j=1,3
         shift(j)=shift(j)+c(j,i)
      end do
      end do

      shift(1) = shift(1)/nt
      shift(2) = shift(2)/nt
      shift(3) = shift(3)/nt
c
      return
c
  
      end

      subroutine smd_geom_coc(nt,nm,i0,q,c,cog)
c     finds center of charge   for a give segment
c     nt      [in]  total number of atoms
c     nm      [in]  number of atoms in the segment
c     i0      [in]  starting index for the segment
c     q[nt]   [in]  charges  of the overall system
c     c[3,nt] [in]  coordinates of the overall system
c     cog[3]  [out] center of mass coordinates
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer nt
      integer nm
      integer i0
      double precision q(nt)
      double precision c(3,nt)
      double precision cog(3)
c
      integer i,j
      double precision cshift(3)
      integer i_ftmp,h_ftmp
      character*30 pname
      double precision qtot
c
      pname = "smd_geom_coc"
c      
      if(.not.ma_push_get(mt_dbl,3*nm,'tmp i',h_ftmp,i_ftmp))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
c
c     put 1st atom in the middle
c     ---------------------------
      do j=1,3
         cshift(j)=c(j,i0)
      end do

      do i=1,nm
      do j=1,3
         dbl_mb(i_ftmp+(i-1)*3+j-1)=
     +         c(j,i0+i-1)-cshift(j)
      end do
      end do
 
c     fold in other coordinates potentially
c     cutoff by the box boundary
      call smd_lat_rebox(nm,dbl_mb(i_ftmp)) 
c     calculate cog for shifted segment
c     --------------------------------- 
      cog(1) = 0.0d0
      cog(2) = 0.0d0
      cog(3) = 0.0d0
      
      qtot = 0.0d0
      do i=1,nm
      do j=1,3
         cog(j)=cog(j)+q(i0+i-1)*dbl_mb(i_ftmp+(i-1)*3+j-1)
      end do
      qtot = qtot + q(i0+i-1)
      end do

      cog(1) = cog(1)/qtot
      cog(2) = cog(2)/qtot
      cog(3) = cog(3)/qtot
c
c     correct for the shift
c     ---------------------
      do j=1,3
        cog(j) = cog(j)+cshift(j)
      end do
c
      if(.not.ma_pop_stack(h_ftmp))
     & call errquit(pname//'Failed to deallocate stack h_ftmp',0,
     &       MA_ERR)
c
      return
c
  
      end
c
C>    Updates local charge arrays with computed
C>    ESP charges
      subroutine smd_geom_get_charges()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
c
      integer im
c     
      character*32 sp_coords,sp_atom,sp_charge,sp_mass
      character*32 sp_geom
      character*32 sp_global
      character*32 tag,pname
      logical result
      integer i_ir,i_ta,i_q,i_c,i_m,i_qf
      integer i_ct,h_ct
      integer i,j,i0,i1,n0
      integer nt,nm,nqm
      integer rtdb
      integer igeom
      integer i_q1,h_q1
      integer ng
      integer nb
      integer i_nm,i_im
      integer ga_handle, ilo,ihi
c
      logical geom_cart_set1
      external geom_cart_set1
      logical geom_rtdb_ncent
      external geom_rtdb_ncent
c
      pname = "smd_geom_get_charges"
c
      tag = "global"
      call smd_system_get_component(sp_global,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      call smd_rtdb_get_handle(rtdb)
c
      tag = "charge"
      call smd_get_ind_dim(tag,i_q,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c      
      tag="ntot"
      call smd_data_get_int(sp_geom,tag,1,ng,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
      tag = "position"
      call smd_data_get_ind_dim(sp_geom,tag,i_im,nb,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c      
      tag = "size"
      call smd_data_get_ind_dim(sp_geom,tag,i_nm,nb,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c    
      if(.not.geom_create(igeom,"geometry"))
     + call errquit('qmmm: Failed to create geometry',0, GEOM_ERR)

c
c     pick the best available charge geometry
c     ---------------------------------------
      tag = "cresp:geometry"
      result = geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      if(.not.result) then
        tag = "resp:geometry"
        result =  geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      end if
      if(.not.result) then
        tag = "cesp:geometry"
        result =  geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      end if
      if(.not.result) then
        tag = "esp:geometry"
        result =  geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      end if

      if(.not.result) then
         call errquit(pname//'cannot find charges')
      end if

      if(nqm.ne.ng)
     + call errquit(pname//'mismatch in sizes'//tag,0, GEOM_ERR)

      if(.not.geom_rtdb_load(rtdb,igeom,tag(1:inp_strlen(tag))))
     + call errquit(pname//'Failed to load geometry'//tag,0, GEOM_ERR)

      if(.not.ma_push_get(mt_dbl,ng,'tmp q',h_q1,i_q1))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)

      if(.not.geom_cart_get_charges(igeom,ng,dbl_mb(i_q1)))
     + call errquit(pname//'Failed to get charges',0, GEOM_ERR)

       if(.not.geom_destroy(igeom))
     + call errquit(pname//'Failed to destroy geometry',0, GEOM_ERR)
c      This code updates global charge array.
c      Orginally
c      it was meant to serve as replacement for local charge update
c      as done below, keeping local charge array pristine
cc
cc     get global array
cc     ---------------
      call smd_data_get_int(sp_global,"charges",1,ga_handle,result)
      if(.not.result) call errquit(
     >       pname//'no coordindates ',0,0)
c
      do i=1,nb
       i0=int_mb(i_im+i-1)
       n0=int_mb(i_nm+i-1)
       ilo = i0
       ihi = (i0-1)+n0
      if(ga_nodeid().eq.0) then
        call nga_put(ga_handle,ilo,ihi, dbl_mb(i_q1), 1)
      end if
      end do
cc      call smd_global_print_file("charges","charge.tmp")
      
c
      j=0
      do i=1,nb
       i0=int_mb(i_im+i-1)-1
       n0=int_mb(i_nm+i-1)
       do i1=1,n0
         j = j+1
         dbl_mb(i_q+i0+i1-1) = dbl_mb(i_q1+j-1)
       end do
      end do

      if(.not.ma_pop_stack(h_q1))
     & call errquit(pname//'Failed to deallocate stack ',0,
     &       MA_ERR)
c      
      return
      end
c      
      subroutine smd_geom_get_gradients()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer im
c     
      character*32 tag,pname,sp_geom
      logical result
      integer i_f
      integer i_g1,h_g1
      integer i,j,i1,i0
      integer ng
      integer rtdb
      integer i_im,i_nm
      integer nb,k,n0
c
      pname = "smd_geom_get_gradients"
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag="ntot"
      call smd_data_get_int(sp_geom,tag,1,ng,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
c      tag = "gradients"
c      call smd_data_get_ind_dim(sp_geom,tag,i_g1,nt,result)
c      if(.not. result)  call errquit(
c     >       pname//'error getting index for'//tag,0,0 )
c      nt = nt/3
c
      tag = "position"
      call smd_data_get_ind_dim(sp_geom,tag,i_im,nb,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c      
      tag = "size"
      call smd_data_get_ind_dim(sp_geom,tag,i_nm,nb,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c    
c
      call smd_rtdb_get_handle(rtdb)
c
      tag = "force"
      call smd_get_ind(tag,i_f,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c    
      if(.not.ma_push_get(mt_dbl,3*ng,'tmp h_g1',h_g1,i_g1))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
c      
      if (.not.rtdb_get(rtdb, 'task:gradient', mt_dbl,
     $        3*ng, dbl_mb(i_g1))) 
     $           call errquit(pname,0,RTDB_ERR)

      j=0
      do i=1,nb
       i0=int_mb(i_im+i-1)-1
       n0=int_mb(i_nm+i-1)
       do i1=1,n0
         j = j+1
         do k=1,3
           dbl_mb(i_f+3*(i0+i1-1)+k-1) = dbl_mb(i_g1+3*(j-1)+k-1)
         end do
       end do
      end do


      if(.not.ma_pop_stack(h_g1))
     & call errquit(pname//'Failed to deallocate stack ',0,
     &       MA_ERR)

      return
      end
c      
      subroutine smd_geom_get_dipole()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer im
c     
      character*32 tag,pname,sp_geom,theory,sp_atom
      character*255 key
      logical result
      integer i,j,i1,i0
      integer ng
      integer rtdb
      integer i_nb
      integer nb,k,n0
      double precision dipole(3)
      integer ihi,ilo,ic,nr
c
      pname = "smd_geom_get_dipole"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c    
c
      call smd_rtdb_get_handle(rtdb)
c
c     get the theory 
c     --------------
      if (.not.(rtdb_cget(rtdb,'task:theory',1,theory)))
     +     call errquit('rtdb_cget task:theory failed',0,0)
c
       key = theory(1:inp_strlen(theory))//":dipole"
         if (.not.rtdb_get(rtdb,key,mt_dbl,3,
     +            dipole))
     +            call errquit(key,
     +            0,RTDB_ERR)
         if(ga_nodeid().eq.0) 
     +     write(*,*) "dipole is",dipole(1),dipole(2),
     +                 dipole(3)
c      
      tag = "neighbor_index"
      call smd_data_get_ind_dim(sp_geom,tag,i_nb,nb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      if(nb.gt.1) 
     >  call errquit(
     >       pname//'not a monomer',0, RTDB_ERR)
c
      ic = int_mb(i_nb)
      ilo=3*(ic-1)+1
      ihi=3*(ic-1)+3
      tag = "res_dipoles"
      write(*,*) "ic,ilo,ihi",ic,ilo,ihi
      call smd_data_put_dbl1(sp_atom,tag,ilo,ihi,dipole)
      call smd_data_namespace_print(sp_atom,6)
      return
      end
c
      subroutine smd_geom_get_coords()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
#include "smd_const_data.fh"
#include "stdio.fh"
#include "smd_system.fh"
c
      integer im
c     
      character*32 tag,sp_geom
      character*20 pname
      logical result
      integer i_c
      integer i_c1,h_c1
      integer i,j,i1,i0
      integer nt
      integer rtdb
      integer i_im,i_nm,i_nb
      integer nb,k,n0
      integer igeom
      double precision sht(3)
      integer ncent
      character*64 msg
      integer i_gim,i_gnm
      logical operiodic
c
      pname = "smd_geom_get_coords"
c
      operiodic = smd_system_periodic()
c
      call smd_task_get_counter(im)
c
c      write(msg,'(A20," 1 ",I3)') pname,im
c      call smd_coords_check(msg)
c
      tag = "geom"
      call smd_system_get_component(sp_geom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag="ntot"
      call smd_data_get_int(sp_geom,tag,1,nt,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
      tag = "position"
      call smd_data_get_ind_dim(sp_geom,tag,i_im,nb,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c      
      tag = "size"
      call smd_data_get_ind_dim(sp_geom,tag,i_nm,nb,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
      tag = "neighbor_index"
      call smd_data_get_index(sp_geom,tag,i_nb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
      tag = "res-index"
      call smd_data_get_index(sp_geom,tag,i_gim,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
      tag = "res-size"
      call smd_data_get_index(sp_geom,tag,i_gnm,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
c
      call smd_rtdb_get_handle(rtdb)
c
      tag = "coords"
      call smd_get_ind(tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c     
      if(.not.geom_create(igeom,"geometry"))
     + call errquit('qmmm: Failed to create geometry',0, GEOM_ERR)
c      
      if(.not.geom_rtdb_load(rtdb,igeom,"geometry"))
     + call errquit(pname//'Failed to load geometry'//tag,0, GEOM_ERR)
c    
      if(.not.ma_push_get(mt_dbl,3*nt,'tmp h_c1',h_c1,i_c1))
     + call errquit(pname//'Failed to allocate memory for h_ftmp',0,0)
c    
      if(.not.geom_ncent(igeom, ncent))
     $           call errquit(pname,0,RTDB_ERR)
      if(ncent.ne.nt) then
        call smd_task_get_counter(im)
        write(luout,*) "node",ga_nodeid()
        write(luout,*) "ncent,nt,im",ncent,nt,im
        write(luout,*) "current neighbor index",
     +       (int_mb(i_nb+i-1),i=1,nb)
c
        call util_flush(luout)
        call errquit(
     >       pname//' ncent ne nt',im,0 )
      end if

      if(.not.geom_cart_coords_get(igeom,dbl_mb(i_c1)))
     $           call errquit(pname,0,RTDB_ERR)
      call dscal(3*nt,cau2ang,dbl_mb(i_c1),1)
c
      tag = "shift vector"
      call smd_data_get_dbl(sp_geom,tag,3,sht,result)
      if(.not. result)  call errquit(
     >       pname//'error getting index for'//tag,0,0 )
       
c      do i=1,nt
c        do k=1,3
c          dbl_mb(i_c1+3*(i-1)+k-1)=dbl_mb(i_c1+3*(i-1)+k-1)+
c     >                             sht(k)
c        end do
c      end do
      if(operiodic)
     + call smd_lat_rebox_segments(nt,nb,int_mb(i_gim),int_mb(i_gnm),
     +                     dbl_mb(i_c1)) 
c      call smd_lat_rebox(nt,dbl_mb(i_c1)) 
      
c
      j=0
      do i=1,nb
       i0=int_mb(i_im+i-1)-1
       n0=int_mb(i_nm+i-1)
       do i1=1,n0
         j = j+1
         if(j.gt.nt) 
     +     call errquit(
     >       pname//'out of bounds j nt',j,nt )
         do k=1,3
           dbl_mb(i_c+3*(i0+i1-1)+k-1) = dbl_mb(i_c1+3*(j-1)+k-1)
         end do
       end do
      end do

c      write(msg,'(A20," 2 ",I3)') pname,im
c      call smd_coords_check(msg)
       if(.not.geom_destroy(igeom))
     + call errquit('qmmm: Failed to destroy geometry',0, GEOM_ERR)

      if(.not.ma_pop_stack(h_c1))
     & call errquit(pname//'Failed to deallocate stack ',0,
     &       MA_ERR)

      return
      end
cc
      subroutine smd_geom_monomer_index_size(im,nt,ir,nm,i0)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer im
      integer rtdb
      integer nt
      integer ir(nt)
      integer nm
      integer i0
c
      integer i,j
c
c     count number of atoms in residue im
c     contigious storage is presumed
c     -----------------------------------
      nm = 0
      do i=1,nt
       j = i
       if(im.eq.ir(i)) then
100     continue
        nm = nm + 1
        j = j + 1
        if(im.eq.ir(j)) then
         goto 100
        else
         goto 101 
        end if
       end if
      end do
101   continue
      i0=i
      return
c
  
      end

      subroutine smd_geom_find_neighbors(oinclude,icr,nb,inb)

      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
#include "stdio.fh"
c     if oinclude central residue is included
      logical oinclude
      integer icr
      integer nb
      integer inb(nb)
c
      character*30 pname
      character*32 tag
      integer i_f,i_c,i_rlat
      integer i_lat
      integer i_l,i_p
      integer i_ir
      integer i_inb,h_nb
      integer nl,na
      double precision rcutsq
      logical result
      integer i,j
      integer i_tmp
      integer nr,nrmax

      pname = "smd_geom_find_neighbors"
c
c     get verlet list data
c     --------------------
      tag = "vlist:pointer"
      call smd_get_ind(tag,i_p,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "vlist:list"
      call smd_get_ind_dim(tag,i_l,nl,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "vlist:distances"
      call smd_get_ind(tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:resid"
      call smd_get_ind_dim(tag,i_ir,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c      
      tag = "nres"
      call smd_get_ind(tag,i_tmp,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      nr = int_mb(i_tmp)
c
c     get cutoff data
c     ---------------
      call smd_cutoff_get_rcut(rcutsq)
      rcutsq = rcutsq*rcutsq
c      
      if(.not.ma_push_get(mt_int,nr,'tmp inb',h_nb,i_inb))
     + call errquit(pname//'Failed to allocate memory for tmp inb',
     + na, MA_ERR)
c      
      call    smd_geom_find_neighbors_gen(icr,
     >                                  na,
     >                                  nr,
     >                                  nl,
     >                                  rcutsq,
     >                                  int_mb(i_ir),
     >                                  dbl_mb(i_c),
     >                                  int_mb(i_p),
     >                                  int_mb(i_l),
     >                                  int_mb(i_inb))

      if(oinclude) then
        j = 1
        inb(j) = icr
      else
        j = 0
      end if
      do i=1,nr
       if(int_mb(i_inb+i-1).ne.0) then
         j = j+1
         inb(j) = i
       end if
      end do
      nb = j


      if(.not.ma_pop_stack(h_nb))
     & call errquit(pname//'Failed to deallocate stack h_nb',na,
     &       MA_ERR)

      return

      END
c
      subroutine smd_geom_find_neighbors_gen(icr,
     >                           na,
     >                           nr,
     >                           nl,
     >                           rcutsq,
     >                           ir,
     >                           ccc,
     >                           point,
     >                           list,
     >                           inb)

      implicit none

#include "smd_const_data.fh"


c       icr        [in] residue number to find neighbors
c       na         [in] number of atoms
c       nr         [in] number of residues
c       nl         [in] size of verlet list
c       rcutsq     [in] cutoff radius 
c       ir(na)     [in] residue index
c       point(na)  [in] verlet pointer
c       list(nl)   [in] verlet list
c       ccc(3,nl)  [in] verlet pair distance vector
c       inb(nr)    [out] indices of neighbors

      integer icr
      integer na
      integer nr
      integer nl
      double precision rcutsq
      integer ir(na)
      integer point(na)
      integer list(nl)
      integer nb
      double precision ccc(3,nl)
      integer inb(nr)
c
      integer i,j,k,jnab
      integer jbeg,jend
      integer ii
      integer ir1,ir2,nt

      double precision  rsq

      double precision x,y,z
      character*30 pname

      pname = "smd_geom_find_neighbors_gen"

      call util_message("in "//pname)

      do i=1,nr
        inb(i) = 0
      end do

      call util_message("1: "//pname)
      nb = 0
      do i=1,na-1

       ir1 = ir(i)
       jbeg=point(i)
       jend=point(i+1)-1

      do jnab=jbeg,jend

       j=list(jnab)
       ir2 = ir(j)
       if(ir1.eq.icr) then
         inb(ir2) = 1
         nb = nb + 1
       else if(ir2.eq.icr) then
         inb(ir1) = 1
         nb = nb +1
       end if
      end do
      end do

      return

      end

c $Id: smd_geom.F 21176 2011-10-10 06:35:49Z d3y133 $

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c $Id: perform.F,v 1.9 2000-05-25 01:09:20 d3h325 Exp $
      program perform
c***
c***  Last modification: Fri Jan 13 12:13:27 PST 1995
c***
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      integer heap
c
c***  Intitialize a message passing library
c
#include "mp3.fh"
c
c***  Intitialize the GA package
      call ga_initialize()
      if(ga_nnodes().ne.4 .and. ga_nodeid().eq.0)
     $   call ga_error('Program requires 4 GA processes',ga_nnodes())
c
c***  Initialize the MA package
      heap = 450000
      if (.not. ma_init(MT_DBL, heap,heap))
     $     call ga_error('ma init failed',2*heap)
c
      call testit()
c
      if(ga_nodeid().eq.0) print *, 'All tests successful'
c
      call ga_terminate()
c
      call MP_FINALIZE()
      end


c-----------------

      subroutine testit()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
c
      integer n, nn, num_chunks
      parameter (n = 710, nn = n*n/4, num_chunks=12)
      double precision buf(nn)
c
      integer g_a
      integer ilo, ihi, jlo, jhi
      integer nproc, me, loop
      integer chunk(num_chunks)
      data    chunk /1,3,4,9,16,30,64,91,128,171,256,353/
c     
      nproc = ga_nnodes()
      me = ga_nodeid()
c
c***  Create global array
      if (.not. ga_create(MT_DBL, n, n, 'a', 0, 0, g_a))
     $     call ga_error(' ga_create failed ',1)
c     
      do loop=1,nn
         buf(loop) = .01d0
      enddo
      call ga_zero(g_a) 
c
      if (me .eq. 0) then
        write(*,*)' '
        print *,'> Performance of ga_get, ga_put & ga_acc n = ', n
        print *,' '
      endif
c
      
c     do loop=1,2
c
c***  local ops
c
      call ga_distribution(g_a, me, ilo, ihi, jlo, jhi)
      call TestPutGetAcc
     &     (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo, jhi)
c
c***  remote ops
c
      call ga_distribution(g_a, nproc-1, ilo, ihi, jlo, jhi)
      call TestPutGetAcc
     &     (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo, jhi)

c     enddo
      end


      subroutine TestPutGetAcc
     &          (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo,jhi)
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer num_chunks, chunk(num_chunks)
      integer n, ilo, ihi, jlo,jhi,g_a
      double precision buf(*), tg, tp, ta
      double precision time_acc, time_get, time_put
c
      integer me
      integer loop, jump, count, bytes
c
      me = ga_nodeid()
      if (me .eq. 0) then
        write(6,*)' '
        write(6,'(21X,8hACCESS [,i3,1h:,i4,1h,,i3,1h:,i4,1h])') 
     &        ilo,ihi,jlo,jhi
        write(6,*)'bytes  loop         get                    put',
     &           '                 accumulate'
        call flush(6)
      endif
      call ga_sync()
c
      do loop = 1, num_chunks
        bytes = util_mdtob(1)*chunk(loop)*chunk(loop) !how much data is accessed
        jump  =  n/(60*loop) ! jump distance between consecutive patches
c
c       everybody touches own data 
        call ga_fill_patch(g_a, 1, n, 1, n , 1d0*me*loop)
        if (me .eq. 0) then
          tg= time_get(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count)
        else
          call sleep(2)
        endif
c
c       everybody touches own data
        call ga_fill_patch(g_a, 1, n, 1, n , 1d0*me*loop)
        if (me .eq. 0) then
          tp= time_put(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count)
        else
          call sleep(2)
        endif
c
c       everybody touches own data
        call ga_fill_patch(g_a, 1, n, 1, n , 1d0*me*loop)
        if (me .eq. 0) then
          ta= time_acc(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count)
        else
          call sleep(2)
        endif
c
        if (me .eq. 0) then
          write(6,77)bytes, count, tg, 1d-6*bytes/tg,
     &               tp, 1d-6*bytes/tp, ta, 1d-6*bytes/ta
          call flush(6)
        endif
      enddo
c
77    format(i6, i5, 3(d10.3, d9.2,'MB/s'))
      end



      double precision function
     &       time_acc(g_a, is, ie, js, je, buf, chunk, jump, count)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c

      integer g_a, chunk, jump, count, is, js, ie, je
c
      integer ilo, ihi, jlo, jhi
      double precision  seconds, buf 
c
      count = 0
      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
           ihi = ilo + chunk -1
           do jlo = js, je -chunk-jump +1, chunk+jump
              jhi = jlo + chunk -1
              count = count + 1
              call ga_acc(g_a, ilo, ihi, jlo, jhi, buf, chunk, 1d0)
           enddo
        enddo
      seconds = util_timer() - seconds
c
      time_acc = seconds/count
      end


      double precision function
     &       time_get(g_a, is, ie, js, je, buf, chunk, jump, count)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
c
      integer ilo, ihi, jlo, jhi
      double precision  seconds, buf
c
      count = 0
      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
           ihi = ilo + chunk -1
           do jlo = js, je -chunk-jump +1, chunk+jump
              jhi = jlo + chunk -1
              count = count + 1
              call ga_get(g_a, ilo, ihi, jlo, jhi, buf, chunk)
           enddo
        enddo
      seconds = util_timer() - seconds
c
      time_get = seconds/count
      end



      double precision function
     &       time_put(g_a, is, ie, js, je, buf, chunk, jump, count)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
c
      integer ilo, ihi, jlo, jhi
      double precision  seconds, buf
c
      count = 0
      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
           ihi = ilo + chunk -1
           do jlo = js, je -chunk-jump +1, chunk+jump
              jhi = jlo + chunk -1
              count = count + 1
              call ga_put(g_a, ilo, ihi, jlo, jhi, buf, chunk)
           enddo
        enddo
      seconds = util_timer() - seconds
c
      time_put = seconds/count
      end

c
c     $Id: auto_corr.F 26024 2014-08-21 01:36:37Z bylaska $
c

*     *********************************
*     *                               *
*     *   velocity_autocorrelation    *
*     *                               *
*     *********************************
*
*   This routine calculated the velocity auto correlation
* using the MOTION file.  
*
*  - This routine needs to be rewritten so that it
*    doesn't use so much memory
*
*  Updated: 5-8-2002

      subroutine velocity_autocorrelation(filename)
      implicit none
      character*(*) filename

#include "mafdecls.fh"
#include "errquit.fh"


      real*8 c,auTOsec
      parameter (c=2.996d+10,auTOsec=2.41889d-17)
 
      integer MASTER,taskid
      parameter (MASTER=0)

*     **** local variables ****
      logical value
      integer i,k,natoms,natoms1,nframes,iii
      integer vx(2),vy(2),vz(2)
      integer vt(2),vk(2)
      integer tfft(2)
      real*8  time1,time2,t,freq,dt,volume,volume1
      real*8  tmax
      real*8  x,y,z
      real*8  v1,v2,v3
      real*8  unita(3,3)
      character*255 full_filename1
      character*255 full_filename2
      character*2 tag2
      character*4 tag4


*     *** synchronization ***
      call ga_sync()

      call util_file_name_noprefix('VEL_CORRELATION',.false.,
     >                             .false.,
     >                             full_filename1)
      call util_file_name_noprefix('POWER_SPECTRUM',.false.,
     >                             .false.,
     >                             full_filename2)

      call Parallel_taskid(taskid)
     
*     **********************************************
*     ****** Velocity autocorrelation routine ******
*     *********************************************
      if (taskid.eq.MASTER) then
     
      write(*,*)
      write(*,*) '===== Calculating velocity auto correlation ===='
      write(*,*)    
      call MOTION_nframes(filename,nframes,natoms,volume,unita)

      open(unit=19,file=filename,form='formatted')

*     **** try to exit in a nice way if too not enough memory available ****
      if (.not.MA_push_get(mt_dcpl,2*natoms*nframes,'vx',vx(2),vx(1))) 
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + velocity autocorrelation not performed'
         close(unit=19)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*natoms*nframes,'vy',vy(2),vy(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + velocity autocorrelation not performed'
         value = MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',1,
     >                 MA_ERR)
         close(unit=19)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*natoms*nframes,'vz',vz(2),vz(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + velocity autocorrelation not performed'
         value =           MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',2,
     >                 MA_ERR)
         close(unit=19)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*nframes,'vt',vt(2),vt(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + velocity autocorrelation not performed'
         value =           MA_pop_stack(vz(2))
         value = value.and.MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',3,
     >                 MA_ERR)
         close(unit=19)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*nframes,'vk',vk(2),vk(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + velocity autocorrelation not performed'
         value =           MA_pop_stack(vt(2))
         value = value.and.MA_pop_stack(vz(2))
         value = value.and.MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',4,
     >                 MA_ERR)
         close(unit=19)
         goto 999
      end if
       if (.not.MA_push_get(mt_dcpl,(8*nframes+15),
     >    'tfft',tfft(2),tfft(1))) then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + velocity autocorrelation not performed'
         value =           MA_pop_stack(vk(2))
         value = value.and.MA_pop_stack(vt(2))
         value = value.and.MA_pop_stack(vz(2))
         value = value.and.MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',5,
     >                 MA_ERR)
         close(unit=19)
         goto 999
      end if
      

      call dcopy(4*natoms*nframes,0.0d0,0,dcpl_mb(vx(1)),1)
      call dcopy(4*natoms*nframes,0.0d0,0,dcpl_mb(vy(1)),1)
      call dcopy(4*natoms*nframes,0.0d0,0,dcpl_mb(vz(1)),1)
      call dcopy(4*nframes,       0.0d0,0,dcpl_mb(vt(1)),1)
      call dcopy(4*nframes,        0.0d0,0,dcpl_mb(vk(1)),1)
     
      time1   = 0.0d0
      time2   = 0.0d0
      do k=1,nframes
        
         time1    = time2
         read(19,*) time2,natoms1,volume1,unita
         do i=1,natoms
            read(19,*) iii,tag2,tag4,x,y,z,v1,v2,v3
            dcpl_mb(vx(1)+(k-1) + (i-1)*2*nframes) = v1
            dcpl_mb(vy(1)+(k-1) + (i-1)*2*nframes) = v2
            dcpl_mb(vz(1)+(k-1) + (i-1)*2*nframes) = v3        
         end do

      end do
      close(unit=19)

      dt   = time2-time1
      write(6,*)
      write(6,*) 'frames used: ',nframes
      write(6,*) 'natoms:      ',natoms
      write(6,*) 'volume:      ',volume
      write(6,*) 'time interval (au)       : ', dt
      write(6,*) 'Max time      (au)       : ', dt*(nframes-1)
      write(6,*) 'frequency interval (cm-1): ', 
     >           1.0d0/(dt*nframes*auTOsec*c)
      write(6,*) 'Max frequency (cm-1)     : ', 
     >           1.0d0/(2*dt*auTOsec*c)
      write(6,*) 'MOTION filename: ',filename
      write(6,*) '<v*v>  filename: ',full_filename1
      write(6,*) 's(k)   filename: ',full_filename2
      write(6,*)

      dt   = time2-time1
      tmax = dt*(nframes-1)
      call dcffti(2*nframes,dcpl_mb(tfft(1)))
      do i=1,natoms
         call dcfftf(2*nframes,dcpl_mb(vx(1)+ (i-1)*2*nframes),
     >                         dcpl_mb(tfft(1)))
         call dcfftf(2*nframes,dcpl_mb(vy(1)+ (i-1)*2*nframes),
     >                         dcpl_mb(tfft(1)))
         call dcfftf(2*nframes,dcpl_mb(vz(1)+ (i-1)*2*nframes),
     >                         dcpl_mb(tfft(1)))
      end do

      do k=1,(2*nframes)
         dcpl_mb(vt(1)+(k-1)) = dcmplx(0.0d0,0.0d0)
         do i=1,natoms
           dcpl_mb(vt(1)+(k-1)) = dcpl_mb(vt(1)+(k-1))
     >           + dconjg(dcpl_mb(vx(1)+(k-1)+(i-1)*2*nframes))
     >                   *dcpl_mb(vx(1)+(k-1)+(i-1)*2*nframes)
     >           + dconjg(dcpl_mb(vy(1)+(k-1)+(i-1)*2*nframes))
     >                   *dcpl_mb(vy(1)+(k-1)+(i-1)*2*nframes)
     >           + dconjg(dcpl_mb(vz(1)+(k-1)+(i-1)*2*nframes))
     >                   *dcpl_mb(vz(1)+(k-1)+(i-1)*2*nframes)

         end do
      end do
      x = 1.0d0/dble(2*nframes)
      call dscal(4*nframes,x,dcpl_mb(vt(1)),1)
      call dcfftb(2*nframes,dcpl_mb(vt(1)),dcpl_mb(tfft(1)))


*     ***** write out velocity autocorrelation ****
      open(unit=19,file=full_filename1,form='formatted')
      do k=1,nframes
         t = dt*(k-1)
         x = 1.0d0/dble(nframes-(k-1))
         dcpl_mb(vt(1)+k-1) = dcpl_mb(vt(1)+k-1)*x
         write(19,*) t,dble(dcpl_mb(vt(1)+k-1)),
     >                dimag(dcpl_mb(vt(1)+k-1))
      end do
      close(unit=19)


*     ************************************************
*     ****                                        ****
*     **** calculate the power spectrum using fft ****
*     ****                                        ****
*     ************************************************
      call dcffti(nframes,dcpl_mb(tfft(1)))
      call dcfftf(nframes,dcpl_mb(vt(1)),dcpl_mb(tfft(1)))
      !x = 1.0d0/dble(nframes)
      dcpl_mb(vk(1)) = dconjg(dcpl_mb(vt(1)))
     >                *dcpl_mb(vt(1))
      dcpl_mb(vk(1)+nframes/2) = dconjg(dcpl_mb(vt(1)+nframes/2))
     >                          *dcpl_mb(vt(1)+nframes/2)
      do k=1,(nframes/2)-1
        dcpl_mb(vk(1)+k) =   dconjg(dcpl_mb(vt(1)+k))
     >                      *dcpl_mb(vt(1)+k)
     >                   +   dconjg(dcpl_mb(vt(1)+nframes-k))
     >                      *dcpl_mb(vt(1)+nframes-k)
      end do

      !*** scale the power spectrum ***
      x = 0.0d0
      do k=0,nframes/2
        x = x + dble(dcpl_mb(vk(1)+k))
      end do
      if (x.gt.1.0d-12) then
         x = 1.0d0/x 
      else 
         x = 1.0d0
      end if
      call dscal(4*nframes,x,dcpl_mb(vk(1)),1)

      open(unit=19,file=full_filename2,form='formatted')
      do k=0,nframes/2
         if(k.ne.0) then
            t = nframes*dt/dble(k)
            freq = 1.0d0/(t*auTOsec*c)
         else
            freq=0.0d0
         endif
         write(19,*) freq, dble(dcpl_mb(vk(1)+k)),
     >                    dimag(dcpl_mb(vk(1)+k))
      end do
      close(unit=19)

      value =           MA_pop_stack(tfft(2))
      value = value.and.MA_pop_stack(vk(2))
      value = value.and.MA_pop_stack(vt(2))
      value = value.and.MA_pop_stack(vz(2))
      value = value.and.MA_pop_stack(vy(2))
      value = value.and.MA_pop_stack(vx(2))
      if (.not. value) 
     >    call errquit('cpmd_properties: cant release stack memory',0,
     >       MA_ERR)
     
      end if

*     *** synchronization ***
  999 continue
      call ga_sync()

      return
      end



*     **************************************
*     *                                    *
*     *   dipole_motion_autocorrelation    *
*     *                                    *
*     **************************************
*
*   This routine calculated the dipole auto correlation
* using the MOTION file.  
*
*  - This routine needs to be rewritten so that it
*    doesn't use so much memory
*
*  Updated: 5-8-2002

      subroutine dipole_motion_autocorrelation(rtdb,filename)
      implicit none
      integer rtdb
      character*(*) filename

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"


      real*8 c,auTOsec
      parameter (c=2.996d+10,auTOsec=2.41889d-17)
 
      integer MASTER,taskid
      parameter (MASTER=0)

*     **** local variables ****
      logical value
      integer i,k,natoms,natoms1,nframes,iii
      integer vx(2),vy(2),vz(2)
      integer vt(2),vk(2)
      integer tfft(2)
      real*8  time1,time2,t,freq,dt,volume,volume1
      real*8  tmax
      real*8  x,y,z
      real*8  v1,v2,v3,sv1,sv2,sv3
      real*8  unita(3,3)
      character*80  tfilename
      character*255 full_filename1
      character*255 full_filename2


*     *** synchronization ***
      call ga_sync()

      if (.not.rtdb_cget(rtdb,
     >                   'nwpw:dipole_motion_correlation_filename',
     >                   1,tfilename))
     >   call util_file_prefix('dipole_correlation',tfilename)

      call util_file_name_noprefix(tfilename,.false.,.false.,
     >                             full_filename1)

      if (.not.rtdb_cget(rtdb,
     >                   'nwpw:dipole_motion_powerspectrum_filename',
     >                   1,tfilename))
     >   call util_file_prefix('dipole_powerspectrum',tfilename)
      call util_file_name_noprefix(tfilename,.false.,.false.,
     >                             full_filename2)

      call Parallel_taskid(taskid)
     
*     **********************************************
*     ****** Velocity autocorrelation routine ******
*     *********************************************
      if (taskid.eq.MASTER) then
     
      write(*,*)
      write(*,*) '===== Calculating dipole auto correlation ===='
      write(*,*)    
      call dipole_motion_nframes(filename,nframes)

      open(unit=36,file=filename,form='formatted')

*     **** try to exit in a nice way if too not enough memory available ****
      if (.not.MA_push_get(mt_dcpl,2*nframes,'vx',vx(2),vx(1))) 
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + dipole motion autocorrelation not performed'
         close(unit=36)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*nframes,'vy',vy(2),vy(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + dipole motion autocorrelation not performed'
         value = MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',1,
     >                 MA_ERR)
         close(unit=36)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*nframes,'vz',vz(2),vz(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + dipole motion autocorrelation not performed'
         value =           MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',2,
     >                 MA_ERR)
         close(unit=36)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*nframes,'vt',vt(2),vt(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + dipole motion autocorrelation not performed'
         value =           MA_pop_stack(vz(2))
         value = value.and.MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',3,
     >                 MA_ERR)
         close(unit=36)
         goto 999
      end if
      if (.not.MA_push_get(mt_dcpl,2*nframes,'vk',vk(2),vk(1)))
     >   then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + dipole autocorrelation not performed'
         value =           MA_pop_stack(vt(2))
         value = value.and.MA_pop_stack(vz(2))
         value = value.and.MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',4,
     >                 MA_ERR)
         close(unit=36)
         goto 999
      end if
       if (.not.MA_push_get(mt_dcpl,(8*nframes+15),
     >    'tfft',tfft(2),tfft(1))) then
         write(*,*) 'cpmd_properties: out of stack memory'
         write(*,*) ' + dipole autocorrelation not performed'
         value =           MA_pop_stack(vk(2))
         value = value.and.MA_pop_stack(vt(2))
         value = value.and.MA_pop_stack(vz(2))
         value = value.and.MA_pop_stack(vy(2))
         value = value.and.MA_pop_stack(vx(2))
         if (.not. value) 
     >    call errquit('cpmd_properties: cannot release stack memory',5,
     >                 MA_ERR)
         close(unit=36)
         goto 999
      end if
      

      call dcopy(4*nframes,0.0d0,0,dcpl_mb(vx(1)),1)
      call dcopy(4*nframes,0.0d0,0,dcpl_mb(vy(1)),1)
      call dcopy(4*nframes,0.0d0,0,dcpl_mb(vz(1)),1)
      call dcopy(4*nframes,0.0d0,0,dcpl_mb(vt(1)),1)
      call dcopy(4*nframes, 0.0d0,0,dcpl_mb(vk(1)),1)
     
      time1   = 0.0d0
      time2   = 0.0d0
      sv1 = 0.0d0
      sv2 = 0.0d0
      sv3 = 0.0d0
      do k=1,nframes
        
         time1    = time2
         read(36,*) time2,v1,v2,v3
         dcpl_mb(vx(1)+(k-1)) = v1
         dcpl_mb(vy(1)+(k-1)) = v2
         dcpl_mb(vz(1)+(k-1)) = v3        
         sv1 = sv1 + v1
         sv2 = sv2 + v2
         sv3 = sv3 + v3
      end do
      close(unit=36)
      sv1 = sv1/dble(nframes)
      sv2 = sv2/dble(nframes)
      sv3 = sv3/dble(nframes)
      do k=1,nframes
         dcpl_mb(vx(1)+k-1) = dcpl_mb(vx(1)+k-1) - sv1
         dcpl_mb(vy(1)+k-1) = dcpl_mb(vy(1)+k-1) - sv2
         dcpl_mb(vz(1)+k-1) = dcpl_mb(vz(1)+k-1) - sv3
      end do

      dt   = time2-time1
      write(6,*)
      write(6,*) 'frames used: ',nframes
      write(6,*) 'time interval (au)       : ', dt
      write(6,*) 'Max time      (au)       : ', dt*(nframes-1)
      write(6,*) 'frequency interval (cm-1): ', 
     >           1.0d0/(dt*nframes*auTOsec*c)
      write(6,*) 'Max frequency (cm-1)     : ', 
     >           1.0d0/(2*dt*auTOsec*c)
      write(6,*) 'dipole_motion filename: ',filename
      write(6,*) '<mu*mu>       filename: ',full_filename1
      write(6,*) 's(k)          filename: ',full_filename2
      write(6,*)

      dt   = time2-time1
      tmax = dt*(nframes-1)
      call dcffti(2*nframes,dcpl_mb(tfft(1)))

      call dcfftf(2*nframes,dcpl_mb(vx(1)),dcpl_mb(tfft(1)))
      call dcfftf(2*nframes,dcpl_mb(vy(1)),dcpl_mb(tfft(1)))
      call dcfftf(2*nframes,dcpl_mb(vz(1)),dcpl_mb(tfft(1)))

      do k=1,(2*nframes)
         dcpl_mb(vt(1)+(k-1)) = 
     >           + dconjg(dcpl_mb(vx(1)+(k-1)))
     >                   *dcpl_mb(vx(1)+(k-1))
     >           + dconjg(dcpl_mb(vy(1)+(k-1)))
     >                   *dcpl_mb(vy(1)+(k-1))
     >           + dconjg(dcpl_mb(vz(1)+(k-1)))
     >                   *dcpl_mb(vz(1)+(k-1))
      end do
      x = 1.0d0/dble(2*nframes)
      call dscal(4*nframes,x,dcpl_mb(vt(1)),1)
      call dcfftb(2*nframes,dcpl_mb(vt(1)),dcpl_mb(tfft(1)))


*     ***** write out dipole motion autocorrelation ****
      open(unit=36,file=full_filename1,form='formatted')
      do k=1,nframes
         t = dt*(k-1)
         x = 1.0d0/dble(nframes-(k-1))
         dcpl_mb(vt(1)+k-1) = dcpl_mb(vt(1)+k-1)*x
         write(36,*) t,dble(dcpl_mb(vt(1)+k-1)),
     >                dimag(dcpl_mb(vt(1)+k-1))
      end do
      close(unit=36)


*     ************************************************
*     ****                                        ****
*     **** calculate the power spectrum using fft ****
*     ****                                        ****
*     ************************************************
      call dcffti(nframes,dcpl_mb(tfft(1)))
      call dcfftf(nframes,dcpl_mb(vt(1)),dcpl_mb(tfft(1)))
      !x = 1.0d0/dble(nframes)
      dcpl_mb(vk(1)) = dconjg(dcpl_mb(vt(1)))
     >                *dcpl_mb(vt(1))
      dcpl_mb(vk(1)+nframes/2) = dconjg(dcpl_mb(vt(1)+nframes/2))
     >                          *dcpl_mb(vt(1)+nframes/2)
      do k=1,(nframes/2)-1
        dcpl_mb(vk(1)+k) =   dconjg(dcpl_mb(vt(1)+k))
     >                      *dcpl_mb(vt(1)+k)
     >                   +   dconjg(dcpl_mb(vt(1)+nframes-k))
     >                      *dcpl_mb(vt(1)+nframes-k)
      end do

      !*** scale the power spectrum ***
      x = 0.0d0
      do k=0,nframes/2
        x = x + dble(dcpl_mb(vk(1)+k))
      end do
      if (x.gt.1.0d-12) then
         x = 1.0d0/x 
      else 
         x = 1.0d0
      end if
      call dscal(4*nframes,x,dcpl_mb(vk(1)),1)

      open(unit=36,file=full_filename2,form='formatted')
      do k=0,nframes/2
         if(k.ne.0) then
            t = nframes*dt/dble(k)
            freq = 1.0d0/(t*auTOsec*c)
         else
            freq=0.0d0
         endif
         write(36,*) freq, dble(dcpl_mb(vk(1)+k)),
     >                    dimag(dcpl_mb(vk(1)+k))
      end do
      close(unit=36)

      value =           MA_pop_stack(tfft(2))
      value = value.and.MA_pop_stack(vk(2))
      value = value.and.MA_pop_stack(vt(2))
      value = value.and.MA_pop_stack(vz(2))
      value = value.and.MA_pop_stack(vy(2))
      value = value.and.MA_pop_stack(vx(2))
      if (.not. value) 
     >    call errquit('cpmd_properties: cant release stack memory',0,
     >       MA_ERR)
     
      end if

*     *** synchronization ***
  999 continue
      call ga_sync()

      return
      end



*     *******************************************
*     *                                         *
*     *       dipole_motion_nframes             *
*     *                                         *
*     *******************************************
      subroutine dipole_motion_nframes(filename,nframes)
      implicit none
      character*(*) filename
      integer nframes

      real*8    time,dipole(3)

      nframes = 0

      open(unit=36,file=filename,form='formatted',status='old')
      do while(.true.)
        read(36,*,ERR=30,END=30) time,dipole
        nframes = nframes + 1
      end do
 30   continue
      close(unit=36)

      return
      end

C
C $Id: geninterface.F 19708 2010-10-29 18:04:21Z d3y133 $
C
C This is a first attempt at an interface code for Venus written in F77.
C
      Subroutine initialize_qm(theory, basis, natom, 
     $    coordinates, labels, charge, printName, stack, heap,
     $    global,venusnw_file)

      implicit none

#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "tcgmsg.fh"
#include "stdio.fh"
#include "util.fh"
#include "geninterface.fh"
#include "inp.fh"

      character*256 theory
      character*256 basis
      integer natom,I3N
      double precision charge
      double precision coordinates (3*natom)
      character*16 labels(natom)
      character*256 printName
      character*256 venusnw_file
      character*(nw_max_path_len) input_filename, rtdb_name

      integer stack, heap, global, i 
      logical overify, ohardfail, ostartup, ocontinue

      logical setTheory, setBasisSet, setInitCoordinates, setCharge
      external setTheory, setBasisSet, setInitCoordinates, setCharge

      logical nw_inp_from_file
      external nw_inp_from_file
 
      logical setPrint
      external setPrint

c      write (6,*) 'theory=',theory,' basis=',basis,' natom=',natom,
c     $       ' charge=',charge,' printName=',printName,' stack=',stack,
c     $       ' heap=',heap,' global=',global,' venusnw_file=',
c     $       venusnw_file

C  Create parallel processes
c - raj
      stack = 29582399
      heap = 29582386
      global = 29582386
c----

      call ga_brdcst(MT_INT, natom, mitob(1), 0)
      call ga_brdcst(MT_DBL, coordinates, mdtob(3*natom), 0)
C change MT_INT-256/4 to MT_BYTE-256
      call ga_brdcst(MT_BYTE, theory, 256, 0)
      call ga_brdcst(MT_BYTE, basis, 256, 0)
      call ga_brdcst(MT_INT, labels, 16*mitob(natom)/4, 0)
C      write(6,*) labels(1), labels(2), labels(3),labels(4)
C     * ,labels(5),labels(6)
C      call flush(6)
C YA: Broadcast charge
      call ga_brdcst(MT_DBL, charge, mdtob(1), 0)
      call ga_brdcst(MT_BYTE, printName, 256, 0)
C PA Broadcast Memory parameters
      call ga_brdcst(MT_INT, stack, mitob(1), 0)
      call ga_brdcst(MT_INT, heap, mitob(1), 0)
      call ga_brdcst(MT_INT, global, mitob(1), 0)
c--raj
       write (6,*) 'stack=',stack,' heap=',heap,' global=',global
c--
      numatoms = natom
C  Worry about input file.  For now use a dummy one.  Do I need to open it?

      input_filename = "junk.nw"
c      if (nodeid().eq.0) then
c         open(LuIn, file=input_filename, status='old', form='formatted',
c     $        err=10000)
c         goto 10001
c10000    call errquit('nwchem: failed to open the input file', 0)
c10001    continue
c
c      else
c#if !(defined(KSR) || defined(IBM) || defined(FUJITSU_SOLARIS) ||defined(FUJITSU_VPP) ||defined(FUJITSU_VPP64))
c         close(LuIn)
c#endif
c      endif

C  Set up memory environment

!      call input_mem_size(stack, heap, global, overify, ohardfail)

C YA: Hardwire memory limits assuming total equal 1800.0 Mbytes
c       stack = 58982399
c       heap = 58982386
c       global = 117964800

       overify = .true.
       ohardfail = .true.
c       write (6,*) 'stack=',stack,' heap=',heap,' global=',global,
c     *            ' overify=', overify,' ohardfail=',ohardfail
!      call ga_initialize()
      if ( ga_uses_ma() ) then
        if (.not.ma_init(mt_dbl, stack, heap+global))
     $      call errquit
     $      ('initialize_qm: ma_init failed (ga_uses_ma=T)',555)
      else
        if (.not.ma_init(mt_dbl,stack,heap))
     $      call errquit
     $      ('initialize_qm: ma_init failed (ga_uses_ma=F)',555)
        call ga_set_memory_limit(ma_sizeof(mt_dbl,global,mt_byte))
      endif

C  Open rtdb
C  Need to get the input file name and the rtdb_name taken care of

!      call input_file_info(input_filename, rtdb_name, 
!     $                     ostartup, ocontinue)
      rtdb_name = "junk.rtdb"
      ostartup = .true.
      ocontinue = .false.
      if (.not. rtdb_open(rtdb_name, 'empty', rtdb))
     $     call errquit('initialize_qm: rtdb_open empty failed ',
     $   555,0)
      call util_set_rtdb_state(rtdb,.true.,.false.,.false.)
      call util_file_info_rtdb(rtdb)
      call geom_hnd_parallel(.true.)

c      write (6,*) 'In geninterface.F: venusnw_file=',venusnw_file
!  Test for .nw file from VENUS
      if (venusnw_file.eq.' ') then
       write (6,*) 'No NWChem file name is detected in VENUS input'
       write (6,*) 'Using only VENUS input data for NWChem init'

C  Process number of scf iterations

      if (.not. rtdb_put(rtdb, 'scf:maxiter', mt_int, 1, 200))
     $     call errquit('scf-input: rtdb_put failed', 0,0)

C  Process number of dft iterations

      if (.not. rtdb_put(rtdb, 'dft:iterations',
     &     mt_int, 1, 200))
     &     call errquit('dft_rdinput: rtdb_put failed', 101,0)

C  Process theory type and put into rtdb

      if (.not. setTheory(theory))
     $     call errquit('initialize_qm: setTheory failed', 555,0)

C  Process basis type and put into rtdb

      if (.not. setBasisSet(basis))
     $     call errquit('initialize_qm: setBasisSet failed', 555,0)

C  Process charge and put into rtdb

      if (.not. setCharge(charge))
     $     call errquit('initialize_qm: setCharge failed', 555,0)

C  Process print type and put into rtdb

c      write (6,*) 'printName=',printName, ga_nodeid()
C      i = rtdb_parallel(0)
C      if (ga_nodeid().eq.0) then
       if (.not. setPrint(printName))
     $     call errquit('initialize_qm: setPrint failed', 555)
C      end if
C      i = rtdb_parallel(i)
c      write (6,*) 'after printName=',printName, ga_nodeid()

C  Process molecule input and put into rtdb

      if (.not. setInitCoordinates(coordinates,labels,natom))
     $     call errquit
     $     ('initialize_qm:setInitCoordinates failed',555)

c      initialize_qm = .true.
c       write(6,*)'Initalize called'

      else
       write (6,*) 'Reading .nw file'
       if (.not.nw_inp_from_file(rtdb,venusnw_file))
     $ call errquit ('nw_inp_from_file: Error opening file',555)

C  Process molecule input and put into rtdb

      if (.not. setInitCoordinates(coordinates,labels,natom))
     $     call errquit
     $     ('initialize_qm:setInitCoordinates failed',555)

      end if

      return
      end
C
C
      logical function finalize_qm()

      implicit none

#include "global.fh"
#include "rtdb.fh"
#include "tcgmsg.fh"
#include "util.fh"
#include "geninterface.fh"

      finalize_qm = .false.

C  Close the rtdb

      if (.not. rtdb_close(rtdb, 'delete'))
     $     call errquit('finalize_qm: rtdb_close failed', rtdb,0)

C  Close the global memory

C      call ga_sync()
C      call ga_terminate()

C  Close the parallel environment

C      call pend()

      finalize_qm = .true.

      return
      end

C
C
      logical function setBasisSet(basisSet)

      implicit none

#include "inp.fh"
#include "util.fh"
#include "geninterface.fh"
      character*(*) basisSet
      character*32 temp_basis

      external nw_inp_from_character
      logical nw_inp_from_character

      setBasisSet = .false.

      temp_basis = basisSet(1:inp_strlen(basisSet))
	write(6,*)'basis in setbasis set function',temp_basis 
      write(basisSet, '(''basis; * library '',a,'' ; end'')')
     $     temp_basis(1:inp_strlen(temp_basis))

      if (.not. nw_inp_from_character(rtdb, basisSet))
     $     call errquit('setBasisSet: setting rtdb failed', 555,0)

      setBasisSet = .true.

      return 
      end
C
C
      logical function setTheory(theoryName)

      implicit none
#include "geninterface.fh"
#include "rtdb.fh"
#include "util.fh"

      character*(*) theoryName
      character*32 dft_func

      external nw_inp_from_character
      logical nw_inp_from_character

      setTheory = .false.

      if (theoryName.eq.'b3lyp') then 
         write(dft_func, '(''dft; XC b3lyp; end'')')
         if (.not. nw_inp_from_character(rtdb, dft_func))
     $   call errquit('setTheoryB3LYP: setting rtdb failed', 555,0)
         if (.not. rtdb_cput(rtdb, 'task:theory', 1, 'dft'))
     $     call errquit('setTheory: failed setting theory',555,0)

      else

         if (.not. rtdb_cput(rtdb, 'task:theory', 1, theoryName))
     $     call errquit('setTheory: failed setting theory',555,0)
      end if

      setTheory = .true.

      return
      end
C
C
      logical function setCoordinates(coords)

      implicit none

#include "geom.fh"
#include "geninterface.fh"

      integer geom
      character*12 units
      double precision scale
      double precision coords(*)
      integer i

      setCoordinates = .false.

      if (.not.geom_create(geom,'geometry'))
     $      call errquit('setCoordinates: geom_create failed',555,0)

      if (.not.geom_rtdb_load(rtdb, geom,'geometry'))
     $      call errquit('setCoordinates: geom_rtdb_load failed',555,0)

      if (.not. geom_set_user_units(geom,'angstroms'))
     $     call errquit
     $     ('setInitCoordinates: failed setting user units',0)

      if (.not. geom_get_user_scale(geom,scale))
     $     call errquit
     $     ('setInitCoordinates:: failed getting user scale',0)

c      write(6,*) 'numatoms is in setCoordinates', numatoms
      call flush(6)
      if (scale.ne.1.0d0) 
     $   call dscal(3*numatoms, scale, coords, 1)

      if (.not.geom_cart_coords_set(geom,coords))
     $      call errquit
     $      ('setCoordinates: geom_cart_coords_set failed',555)

      if (.not.geom_rtdb_store(rtdb,geom,'geometry'))
     $      call errquit('setCoordinates: geom_rtdb_store failed',555,0)

      if (.not.geom_destroy(geom))
     $      call errquit('setCoordinates: geom_destroy failed',555,0)

c      write(6,*) 'numatoms at end of setCoordinates', numatoms
      call flush(6)
      setCoordinates = .true.

      return
      end
C
C
      logical function setInitCoordinates(coordinates,labels,natoms)

      implicit none

#include "geninterface.fh"
#include "geom.fh"
#include "rtdb.fh"

      integer natoms, geom, atn, i, j
      double precision coordinates(3,natoms)
      character*16 labels(natoms), element
      character*2 symbol
      character*12 units
      double precision scale
      double precision masses(natoms), charges(natoms)
      logical is_atom

      setInitCoordinates = .false.

      if (.not.geom_create(geom,'geometry'))
     $      call errquit('setCoordinates: geom_create failed',555,0)
      if (.not. geom_set_user_units(geom,'angstroms'))
     $     call errquit
     $     ('setInitCoordinates: failed setting user units',0)
      if (.not. geom_get_user_scale(geom,scale))
     $     call errquit
     $     ('setInitCoordinates:: failed getting user scale',0)

c      if (.not.geom_rtdb_load(rtdb, geom,'geometry'))
c     $      call errquit
c     $      ('setInitCoordinates: geom_rtdb_load failed',555)

C  Map labels to atoms and charges

      do i = 1, natoms
        is_atom = geom_tag_to_element(labels(i), symbol,
     $             element, atn)

        if (.not. is_atom) call errquit
     $        ('setInitCoordinates:center is not an atom',555)

        if (.not.
     $       geom_atn_to_default_mass(atn,masses(i)))
     $       call errquit('setInitCoordinates: default mass failed',
     $       555)

        charges(i) = atn
      enddo

      call geom_check_input_quants
     $     (labels,charges,natoms,1.0d-12,'charge')

      call geom_check_input_quants
     $     (labels,masses,natoms,1.0d-8,'mass')

      if (scale.ne.1.0d0) 
     $   call dscal(3*natoms, scale, coordinates, 1)

      if (.not.geom_cart_set(geom,natoms,labels,coordinates,charges))
     $     call errquit
     $     ('setInitCoordinates: geom_cart_coords_set failed',555)

      if (.not. geom_masses_set(geom, natoms, masses))
     $     call errquit
     $     ('setInitCoordinates: geom_masses_set failed',555)

      if (.not.geom_rtdb_store(rtdb,geom,'geometry'))
     $     call errquit
     $     ('setInitCoordinates: geom_rtdb_store failed',555)

      if (.not.geom_destroy(geom))
     $     call errquit('setInitCoordinates: geom_destroy failed',555,0)

      setInitCoordinates = .true.

      return
      end
C
      logical function evaluateObjective(coords, energy)

      implicit none

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geninterface.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "tcgmsg.fh"

      common/threads/myid
      integer myid 
      double precision coords(*), energy
      integer i
      external setCoordinates, task_energy
      logical setCoordinates, task_energy
      character*256 movecs_in

      evaluateObjective = .false.

      call ga_brdcst(MT_DBL, coords, mdtob(3*numatoms), 0)
      call flush(6)

      if (.not.setCoordinates(coords))
     $     call errquit('evaluateObjective: setCoordinates failed',
     $    555,0)

      if (.not.task_energy(rtdb)) then
         write (6,*) 'SCF failed running rest.scf script'
         movecs_in = 'atomic'
        if (.not. rtdb_cput(rtdb, 'dft:input vectors', 1, movecs_in))
     $  call errquit('name_rout: failed setting movecs_in',0,0)
        if (.not.task_energy(rtdb))
     &      call errquit('task_energy failed',555,0)
      endif

      if (.not.rtdb_get(rtdb, "task:energy", mt_dbl, 1, energy))
     $     call errquit('evaluateObjective:rtdb_get failed',555,0)

      evaluateObjective = .true.

      return
      end
C
      logical function evaluateGradient(coords, gradient)

      implicit none

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geninterface.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "tcgmsg.fh"

      common/threads/myid
      integer myid
      double precision coords(3*numatoms), gradient(3*numatoms)
      integer i

      external setCoordinates, task_gradient
      logical setCoordinates, task_gradient
      external task_energy
      logical task_energy
      character*256 movecs_in 

      evaluateGradient = .false.

      call ga_brdcst(MT_DBL, coords, mdtob(3*numatoms), 0)

      if (.not.setCoordinates(coords))
     $     call errquit('evaluateGradient: setCoordinates failed',555,0)

cc
      if (.not.task_energy(rtdb)) then
        write (6,*) 'SCF failed running rest.scf script'
        movecs_in = 'atomic'
        if (.not. rtdb_cput(rtdb, 'dft:input vectors', 1, movecs_in))
     $      call errquit('name_rout: failed setting movecs_in',0,0)
        if (.not.task_energy(rtdb))
     &      call errquit('task_energy failed',555,0)
      endif
      if (.not.task_gradient(rtdb))
     $     call errquit('evaluateGradient:task_gradient failed',555,0)

C      if (.not.rtdb_print(rtdb, .true.))
C     $     call errquit('evaluateGradient:rtdb_print failed',555)
C
      if (.not.rtdb_get(rtdb, "task:gradient", mt_dbl, numatoms*3, 
     $     gradient))
     $     call errquit('evaluateGradient:rtdb_get failed',555,0)

c
c       call ga_sync()

      evaluateGradient = .true.

      return
      end
C
      logical function evaluateObjectiveAndGradient(coords, 
     $       energy, gradient)

      implicit none
      integer i

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geninterface.fh"
c

      double precision coords(*), energy, gradient(*)

      external evaluateGradient
      logical evaluateGradient

      evaluateObjectiveAndGradient = .false.
c
      if (.not.evaluateGradient(coords, gradient))
     $     call errquit
     $     ('evaluateObjectiveAndGradient:evaluateGradient failed',555)

      if (.not.rtdb_get(rtdb, "task:energy", mt_dbl, 1, energy))
     $     call errquit
     $     ('evaluateObjectiveAndGradient:rtdb_get failed',555)
c
      evaluateObjectiveAndGradient = .true.

      return
      end

      logical function evaluateHessian(coords,
     $       hessian)

      implicit none
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geninterface.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "tcgmsg.fh"
c--- added 11/15/05
#include "msgids.fh"
#include "msgtypesf.h"
c---

      double precision coords(*), hessian(*)

      external hess_read
      external task_hessian
      external setCoordinates
      logical task_hessian
      logical setCoordinates
c
      call ga_brdcst(MT_DBL, coords, mdtob(3*numatoms), 0)
c
      evaluateHessian = .false.

      if (.not.setCoordinates(coords))
     $     call errquit('NWChem_TaskHessian: setCoordinates failed',
     $    555,0)

      if (.not.task_hessian(rtdb))
     $     call errquit('NWChem_TaskHessian:task_hessian failed',555,0)

c--- changed 11/15/05 
       if (ga_nodeid().eq.0) then
         call hess_read(numatoms, hessian)
       endif
c
c  Broadcast results to all of the processors 
c
       call ga_brdcst(msg_hess_exy+MSGDBL, hessian,
     &               mdtob(3*numatoms*3*numatoms), 0)
c---
      evaluateHessian = .true.

      return
      end

      subroutine net_init (myid, nnodes1)

      implicit none

#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "tcgmsg.fh"
#include "stdio.fh"
#include "util.fh"
#include "geninterface.fh"

      integer myid       
      integer nnodes1
      call pbeginf()
      call ga_initialize()
      myid=nodeid()
      nnodes1=nnodes()

      return
      end

      subroutine net_final() 
      
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "tcgmsg.fh"
#include "stdio.fh"
#include "util.fh"
#include "geninterface.fh"

C      call ga_sync()
      call ga_terminate()

C  Close the parallel environment

      call pend()

      return
      end

CBERT subroutine net_broadcast(myid,idop)
      subroutine net_broadcast(idop)
      implicit none

#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "tcgmsg.fh"
#include "stdio.fh"
#include "util.fh"
#include "geninterface.fh"

      integer myid,idop

      call ga_brdcst(MT_INT, idop, mitob(1), 0)

      return
      end

C
C
      logical function setCharge(charge)

      implicit none

#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "tcgmsg.fh"
#include "stdio.fh"
#include "util.fh"
#include "geninterface.fh"
#include "inp.fh"

      double precision charge

      setCharge = .false.

      if (.not. rtdb_put(rtdb, 'charge', MT_DBL, 1, charge))
     $     call errquit
     $     ('input_charge: failed to write to rtdb', 0)

      setCharge = .true.

      return
      end

      logical function setPrint(printName)
      implicit none
#include "geninterface.fh"
#include "rtdb.fh"
#include "util.fh"

      character*256 printName
      integer level

      setPrint = .false.

      if (printName.eq."none") then
         level=print_none
      else if (printName.eq."low") then
         level=print_low
      else if (printName.eq."high") then
         level=print_high
      else if (printName.eq."debug") then
         level=print_debug
      else
         level=print_medium
      end if

      call util_print_set_level(level)

      setPrint = .true.

      return
      end


      subroutine clearOld()

      implicit none

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geninterface.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "tcgmsg.fh"

      common/threads/myid
      integer myid
      character*256 movecs_in


      movecs_in = 'atomic'
      if (.not. rtdb_cput(rtdb, 'dft:input vectors', 1, movecs_in))
     $  call errquit('name_rout: failed setting movecs_in',0,0)

      return
      end

      subroutine argos_cafe_pcopy(id,ipari,pari,idimi,idimp,
     + ipar,par,idimt,ip2log,ip3log,ithlog)
c
#include "argos_cafe_common.fh"
c
      integer id,idimi,idimp,idimt
      integer ipari(idimi),ipar(idimt,idimi)
      real*8 pari(4,24),par(idimt,idimp,mset)
      logical ip2log,ip3log,ithlog
c
      do 1 i=1,idimi
      ipar(id,i)=ipari(i)
    1 continue
c
      if(.not.lfree) then
      do 2 i=1,idimp
      do 3 j=1,nparms
      par(id,i,j)=pari(i,j)
    3 continue
    2 continue
      else
      do 4 i=1,idimp
      do 5 j=1,3
      par(id,i,j)=pari(i,j)
    5 continue
      par(id,i,4)=par(id,i,3)-par(id,i,2)
      par(id,i,5)=par(id,i,2)
      par(id,i,6)=par(id,i,3)
      if(abs(pari(i,1)-pari(i,2)).gt.tiny) ip2log=.true.
      if(abs(pari(i,1)-pari(i,3)).gt.tiny) ip3log=.true.
      if(abs(pari(i,2)-pari(i,3)).gt.tiny) ithlog=.true.
    4 continue
      endif
c
      return
      end
c $Id: argos_cafe_pcopy.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b CLARF applies an elementary reflector to a general rectangular matrix.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download CLARF + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/clarf.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/clarf.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/clarf.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CLARF( SIDE, M, N, V, INCV, TAU, C, LDC, WORK )
* 
*       .. Scalar Arguments ..
*       CHARACTER          SIDE
*       INTEGER            INCV, LDC, M, N
*       COMPLEX            TAU
*       ..
*       .. Array Arguments ..
*       COMPLEX            C( LDC, * ), V( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CLARF applies a complex elementary reflector H to a complex M-by-N
*> matrix C, from either the left or the right. H is represented in the
*> form
*>
*>       H = I - tau * v * v**H
*>
*> where tau is a complex scalar and v is a complex vector.
*>
*> If tau = 0, then H is taken to be the unit matrix.
*>
*> To apply H**H (the conjugate transpose of H), supply conjg(tau) instead
*> tau.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'L': form  H * C
*>          = 'R': form  C * H
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix C.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix C.
*> \endverbatim
*>
*> \param[in] V
*> \verbatim
*>          V is COMPLEX array, dimension
*>                     (1 + (M-1)*abs(INCV)) if SIDE = 'L'
*>                  or (1 + (N-1)*abs(INCV)) if SIDE = 'R'
*>          The vector v in the representation of H. V is not used if
*>          TAU = 0.
*> \endverbatim
*>
*> \param[in] INCV
*> \verbatim
*>          INCV is INTEGER
*>          The increment between elements of v. INCV <> 0.
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is COMPLEX
*>          The value tau in the representation of H.
*> \endverbatim
*>
*> \param[in,out] C
*> \verbatim
*>          C is COMPLEX array, dimension (LDC,N)
*>          On entry, the M-by-N matrix C.
*>          On exit, C is overwritten by the matrix H * C if SIDE = 'L',
*>          or C * H if SIDE = 'R'.
*> \endverbatim
*>
*> \param[in] LDC
*> \verbatim
*>          LDC is INTEGER
*>          The leading dimension of the array C. LDC >= max(1,M).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX array, dimension
*>                         (N) if SIDE = 'L'
*>                      or (M) if SIDE = 'R'
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complexOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE CLARF( SIDE, M, N, V, INCV, TAU, C, LDC, WORK )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE
      INTEGER            INCV, LDC, M, N
      COMPLEX            TAU
*     ..
*     .. Array Arguments ..
      COMPLEX            C( LDC, * ), V( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ONE, ZERO
      PARAMETER          ( ONE = ( 1.0E+0, 0.0E+0 ),
     $                   ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            APPLYLEFT
      INTEGER            I, LASTV, LASTC
*     ..
*     .. External Subroutines ..
      EXTERNAL           CGEMV, CGERC
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILACLR, ILACLC
      EXTERNAL           LSAME, ILACLR, ILACLC
*     ..
*     .. Executable Statements ..
*
      APPLYLEFT = LSAME( SIDE, 'L' )
      LASTV = 0
      LASTC = 0
      IF( TAU.NE.ZERO ) THEN
!     Set up variables for scanning V.  LASTV begins pointing to the end
!     of V.
         IF( APPLYLEFT ) THEN
            LASTV = M
         ELSE
            LASTV = N
         END IF
         IF( INCV.GT.0 ) THEN
            I = 1 + (LASTV-1) * INCV
         ELSE
            I = 1
         END IF
!     Look for the last non-zero row in V.
         DO WHILE( LASTV.GT.0 .AND. V( I ).EQ.ZERO )
            LASTV = LASTV - 1
            I = I - INCV
         END DO
         IF( APPLYLEFT ) THEN
!     Scan for the last non-zero column in C(1:lastv,:).
            LASTC = ILACLC(LASTV, N, C, LDC)
         ELSE
!     Scan for the last non-zero row in C(:,1:lastv).
            LASTC = ILACLR(M, LASTV, C, LDC)
         END IF
      END IF
!     Note that lastc.eq.0 renders the BLAS operations null; no special
!     case is needed at this level.
      IF( APPLYLEFT ) THEN
*
*        Form  H * C
*
         IF( LASTV.GT.0 ) THEN
*
*           w(1:lastc,1) := C(1:lastv,1:lastc)**H * v(1:lastv,1)
*
            CALL CGEMV( 'Conjugate transpose', LASTV, LASTC, ONE,
     $           C, LDC, V, INCV, ZERO, WORK, 1 )
*
*           C(1:lastv,1:lastc) := C(...) - v(1:lastv,1) * w(1:lastc,1)**H
*
            CALL CGERC( LASTV, LASTC, -TAU, V, INCV, WORK, 1, C, LDC )
         END IF
      ELSE
*
*        Form  C * H
*
         IF( LASTV.GT.0 ) THEN
*
*           w(1:lastc,1) := C(1:lastc,1:lastv) * v(1:lastv,1)
*
            CALL CGEMV( 'No transpose', LASTC, LASTV, ONE, C, LDC,
     $           V, INCV, ZERO, WORK, 1 )
*
*           C(1:lastc,1:lastv) := C(...) - w(1:lastc,1) * v(1:lastv,1)**H
*
            CALL CGERC( LASTC, LASTV, -TAU, WORK, 1, V, INCV, C, LDC )
         END IF
      END IF
      RETURN
*
*     End of CLARF
*
      END
c $Id: clarf.f 24343 2013-06-22 05:35:15Z d3y133 $

c     $Id: paw_cgsd_noit_energy.F 20364 2011-05-20 20:38:23Z d3p852 $                       


*     ***************************
*     *                         *
*     *    paw_cgsd_noit_energy *
*     *                         *
*     ***************************

      real*8 function paw_cgsd_noit_energy()
      implicit none

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "util.fh"
#include "stdio.fh"

*     **** local variables ***
      integer MASTER,taskid
      parameter (MASTER=0)

      logical value,oprint
      real*8  E(30),en(2),en1(2),en2(2),EV
      integer rtdb,i,NN,neall

*     **** external functions ****
      logical  control_print
      integer  ion_nion,paw_psi_ne,paw_psi_ispin,control_rtdb
      real*8   paw_psi_eigenvalue
      external control_print
      external ion_nion,paw_psi_ne,paw_psi_ispin,control_rtdb
      external paw_psi_eigenvalue

      call Parallel_taskid(taskid)
      oprint = ((taskid.eq.MASTER).and.control_print(print_medium))
   
*     **** generate phaze factors and local psp and core density ****
      call paw_electron_gen_vl_potential()


      call paw_nominimize(E)


*     **** diagonalize hamiltonian and rotate psi  ****
*     **** but skip if doing an SIC calculations   ****
c     BUG!!!!!!
      call paw_psi_spin_density(en1,en2)
      en(1) = en1(1)+en2(1)
      en(2) = en1(2)+en2(2)

      call paw_psi_1gen_hml()
      call paw_psi_diagonalize_hml()


*:::::::::::::::::   report summary of results  :::::::::::::::::::::::
      if (oprint) then
         neall = (paw_psi_ne(1)+paw_psi_ne(2))
         write(luout,1304)
         write(luout,1410)
         write(luout,*)
c         write(luout,1321) r_charge,' (real space)'
         write(luout,1320) en(1), en(paw_psi_ispin()),' (real space)'
         write(luout,1322) en1(1),en1(paw_psi_ispin()),' (real space)'
         write(luout,1323) en2(1),en2(paw_psi_ispin()),' (real space)'
         call paw_energy_output(luout,ion_nion(),neall,E)

*        **** write out KS eigenvalues ****
         write(luout,1500)
         NN=paw_psi_ne(1)-paw_psi_ne(2)
         EV=27.2116d0
         do I=1,NN
           write(luout,1510) paw_psi_eigenvalue(1,I),
     >                       paw_psi_eigenvalue(1,I)*EV
         end do
         do I=1,paw_psi_ne(2)
           write(luout,1510)  paw_psi_eigenvalue(1,I+NN),
     >                        paw_psi_eigenvalue(1,I+NN)*EV,
     >                        paw_psi_eigenvalue(2,I),
     >                        paw_psi_eigenvalue(2,I)*EV
         end do

      end if



*     **** debug - energies written to rtdb for numerical stress ****
      rtdb = control_rtdb()
      value =           rtdb_put(rtdb,'paw:E_ke',      mt_dbl,1,
     >                           E(2)+E(3))
      value = value.and.rtdb_put(rtdb,'paw:E_hartree', mt_dbl,1,
     >                           E(4)+E(5))
      value = value.and.rtdb_put(rtdb,'paw:E_mult',    mt_dbl,1,
     >                           E(6))
      value = value.and.rtdb_put(rtdb,'paw:E_xc',      mt_dbl,1,
     >                           E(7)+E(8))
      value = value.and.rtdb_put(rtdb,'paw:E_local',   mt_dbl,1,
     >                           E(9)+E(10))
      if (.not. value) call errquit(
     >   'paw_cgsd_noit_energy: numerical stress - error writing rtdb',
     >    0,RTDB_ERR)


      paw_cgsd_noit_energy = E(1)
      return
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F6.3,' ')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1300 FORMAT(//'======================')
 1301 FORMAT(//'== Energy Calculation ==')
 1302 FORMAT(  '======================')
 1304 FORMAT(/) 
 1305 FORMAT(10X,'====== Grassmann conjugate gradient iteration ======')
 1306 FORMAT(10X,'============ Grassmann lmbfgs iteration ============')
 1307 FORMAT(10X,'============ Grassmann diis iteration ==============')
 1308 FORMAT(10X,'======= Stiefel conjugate gradient iteration =======')
 1309 FORMAT(10X,'============= Kohn-Sham scf iteration ==============')
 1310 FORMAT(I8,E20.10,3E15.5)
 1311 FORMAT(10X,'======= Projected Grassmann lmbfgs iteration =======')
 1312 FORMAT(10X,'============= Stiefel lmbfgs iteration =============')
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1321 FORMAT(' total charge of system:',F11.5,A)
 1322 FORMAT('     plane-wave part:         ',F11.5,'       ',F11.5,A)
 1323 FORMAT('      augmented part:         ',F11.5,'       ',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1331 FORMAT(/' Diagonal Elements of Hamiltonian matrix')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1341 FORMAT(I3,2I3,' H=',E16.6)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
c1410 FORMAT(10X,'=============  summary of results  =================')
 1410 FORMAT('==  Summary Of Results  ==')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1431 FORMAT(/' QM Energies')
 1432 FORMAT( '------------')
 1433 FORMAT( ' total  QM energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1455 FORMAT( ' SIC-hartree energy  :',E19.10,' (',E15.5,'/electron)')
 1456 FORMAT( ' SIC-exc-corr energy :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1491 FORMAT( ' K.S. Vl+Vqm/mm      :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1499 FORMAT( ' K.S. SIC-hartree energy  :',E19.10,
     >        ' (',E15.5,'/electron)')
 1501 FORMAT( ' K.S. SIC-exc-corr energy :',E19.10,
     >        ' (',E15.5,'/electron)')
 1500 FORMAT(/' orbital energies:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1511 FORMAT(2(E18.7,' (',F8.3,'eV) occ=',F5.3))
 
 1700 FORMAT(/' QM/MM-pol-vib/CAV Energies')
 1701 FORMAT( ' --------------------------')
 1702 FORMAT( ' QM/MM energy                     :',E19.10)
 1703 FORMAT(/' MM/MM energy                     :',E19.10)
 1704 FORMAT(/' MM Polarization energy           :',E19.10)
 1705 FORMAT( ' MM Vibration energy              :',E19.10)
 1706 FORMAT( ' (QM+MM)/Cavity energy            :',E19.10)
 1707 FORMAT( ' - MM Charge Field/QM Electron    :',E19.10)
 1708 FORMAT( ' - MM Charge Field/QM Ion         :',E19.10)
 1709 FORMAT( ' - MM LJ/QM LJ                    :',E19.10)
 1710 FORMAT( ' - MM Charge Field/MM Charge Field:',E19.10)
 1711 FORMAT( ' - MM LJ/MM LJ                    :',E19.10)
 
 1800 FORMAT(/' Charge Field Energies')
 1801 FORMAT( ' ---------------------')
 1802 FORMAT( ' - Charge Field/Electron    :',E19.10)
 1803 FORMAT( ' - Charge Field/Ion         :',E19.10)
 1804 FORMAT( ' - Charge Field/Charge Field:',E19.10)
 1805 FORMAT( ' Charge Field Energy        :',E19.10)

      end

      logical function int_ecp_init(ecpidin,soidin,indx_grad)
* $Id: int_ecp.F 25489 2014-04-15 22:40:34Z d3y133 $
      implicit none
*::cr::7
*--------------------------------------------------*
* COPYRIGHT (C) 1994, 1995, 1996, 1997, 1998, 1999 *
*         Pacific Northwest National Laboratory,   * 
*         Battelle Memorial Institute.             *
*--------------------------------------------------*
*------------> All Rights Reserved <---------------*
*--------------------------------------------------*
*
#include "errquit.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "geom.fh"
#include "geomP.fh"
#include "apiP.fh"
#include "ecp_nwc.fh"
#include "int_nbf.fh"
#include "stdio.fh"
#include "sym.fh"
*::passed
      integer ecpidin   ! [input] ecp basis handle
      integer soidin    ! [input] so potential handle
      integer indx_grad ! [input] gradient level 0=energy 1=grad 2=hess
*::local
c
      integer ecpid                 ! lexical index for ecp basis handle
      integer soid                  ! lexical index for ecp basis handle
      integer geom                  ! geometry handle
      integer geomecp               ! geometry handle from ecp
      integer geomso                ! geometry handle from so pot.
*      integer num_ecp               ! number of ecp centers (counted)
      integer ncenters              ! number of centers
      integer n_zeta_c_e            ! length of ecp exponent array
      integer n_zeta_c_c            ! length of ecp coefficient array
      integer nz_add                ! increment for exp/coef counters
*      integer icent                 ! counter for center loop
*      integer iucent                ! unique center of icent
      integer l_ecp_sz              ! size of ang info for ecp pointer arrays
      integer l_so                  ! maximum angular momentum of so pot.
      integer lmax_both
      integer idum
      integer basis_handle
      integer l_bas
      integer bas_id
      integer basis_ncont
      integer i_cont, ic, iuc, ie, icf, inp, ing, il, ig
      integer j_cont, jc, juc, je, jcf, jnp, jng, jl, jg
      integer lecp_mem, mem_ecp, lecp_mem1
*      integer h_tlist, k_tlist
      integer nV
      logical o_both, o_ecp, o_so
      double precision dpdum(2),qfact
      logical oskel
      integer ictr,ic1,ic2
      integer jctr,jc1,jc2
*
      external ecp_init_bd
*
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
*<<<------------------------------------------------------------>
*<<<-First pass is to explode all information into arrays
*<<<-The memory used can be reduced by keeping track of the
*<<< tag to basis-unique tag information so that the pointers
*<<< for exponent and coefficient arrays is similar to the 
*<<< storage in the basis set object.  It may be possible to 
*<<< pass the entire exndcf array for the ecp basis to the 
*<<< integral routines with the proper pointer mechanism in 
*<<< place.
*<<<
*<<< RAK Apr 1996
*<<<------------------------------------------------------------>
c
c
c.. check initialization
      if (init_ecp_init) then
        write(6,*)' already called int_ecp_init' 
        call errquit('int_ecp_init error',911, INT_ERR)
      endif
      init_ecp_init = .true.
c.. determine if ecp/so or both are needed
      o_ecp = ecpidin.ne.0
      o_so  = soidin.ne.0
      o_both = o_ecp.and.o_so
c.. lexical basis index
      ecpid = -1
      soid = -1
      if (o_ecp) ecpid = ecpidin + BASIS_HANDLE_OFFSET
      if (o_so)  soid  = soidin  + BASIS_HANDLE_OFFSET

c.. determine geom
      if (o_ecp) then
        geomecp = ibs_geom(ecpid)
        geom = geomecp
      endif
      if (o_so) then
        geomso  = ibs_geom(soid)
        geom = geomso
      endif
      if (o_both) then
        if (geomso.ne.geomecp) then
          write(luout,*)' geometry used to load ecp ',geomecp
          write(luout,*)' geometry used to load so  ',geomso
          call errquit('int_ecp_init: ecp/so geometry mismatch',911,
     &       GEOM_ERR)
        endif
        geom = geomecp
      endif
*
*      build up ecp/so information for heap
c....
c.. get total number of centers
      if (.not.geom_ncent(geom,ncenters)) call errquit
     &    ('int_ecp_init: geom_ncent failed?',911, GEOM_ERR)
c.. get number of ecp/so/both centers
      n_ecp = 0
      if (o_both) then
        if (.not.ecpso_ncent
     &      (geom,soidin,ecpidin,n_ecp)) call errquit
     &      ('int_ecp_init: ecpso_ncent failed',911, INT_ERR)
      else if (o_ecp) then
        if (.not.ecp_ncent
     &      (geom,ecpidin,n_ecp)) call errquit
     &      ('int_ecp_init: ecp_ncent failed?',911, INT_ERR)
      else if (o_so) then
        if (.not.so_ncent
     &      (geom,soidin,n_ecp)) call errquit
     &      ('int_ecp_init: so_ncent failed',911, INT_ERR)
      else
        call errquit('int_ecp_init: no so or ecp basis',911,
     &       BASIS_ERR)
      endif
      if (n_ecp.eq.0) call errquit
     &    ('int_ecp_init: fatal error no ecp/so centers',911,
     &       BASIS_ERR)

c.. allocate space for coordintates of ecp/so centers
      if (.not.ma_alloc_get(mt_dbl,
     &    (3*n_ecp),
     &    'ecp center coords',
     &    h_xyzecp, k_xyzecp)) call errquit
     &    (' int_ecp_init: ecp center coords ma failed ',911,
     &       BASIS_ERR)
      call dfill((3*n_ecp),0.0d00,dbl_mb(k_xyzecp),1)

c.. get coordinates for ecp centers.
      if (o_both) then
        if (.not.ecpso_get_coords(geom,soidin,ecpidin,
     &      n_ecp,dbl_mb(k_xyzecp)))
     &    call errquit('int_ecp_init: ecpso_get_coords failed',911,
     &       INT_ERR)
      else if (o_ecp) then
        if (.not.ecp_get_coords(geom,ecpidin,
     &      n_ecp,dbl_mb(k_xyzecp)))
     &    call errquit('int_ecp_init: ecp_get_coords failed',911,
     &       INT_ERR)
      else if (o_so) then
        if (.not.so_get_coords(geom,soidin,
     &      n_ecp,dbl_mb(k_xyzecp)))
     &    call errquit('int_ecp_init: so_get_coords failed',911,
     &       INT_ERR)
      else
        call errquit('int_ecp_init: no so or ecp basis',911,
     &       INT_ERR)
      endif
*      write(6,*)' coordinates after read '
*      call output(dbl_mb(k_xyzecp),1,3,1,n_ecp,3,n_ecp,1)
c
c...       now comes the tricky part
c
c allocate and fill an exponent and coeff array for the ecp basis
c
*      write(6,*)'inside ecp init'
*      if (.not.ecp_print(ecpidin)) stop ' ecp_print error'
      if (o_both) then
        if (.not.bas_num_prim(ecpidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_prim failed?',911, BASIS_ERR)
        n_zeta_c_e = nz_add
        if (.not.bas_num_prim(soidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_prim failed?',911,
     &       BASIS_ERR)
        n_zeta_c_e = n_zeta_c_e + nz_add
        if (.not.bas_num_coef(ecpidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_coef failed?',911, BASIS_ERR)
        n_zeta_c_c = nz_add
        if (.not.bas_num_coef(soidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_prim failed?',911, BASIS_ERR)
        n_zeta_c_c = n_zeta_c_c + nz_add
      else if (o_ecp) then
        if (.not.bas_num_prim(ecpidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_prim failed?',911, BASIS_ERR)
        n_zeta_c_e = nz_add
        if (.not.bas_num_coef(ecpidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_coef failed?',911, BASIS_ERR)
        n_zeta_c_c = nz_add
      else if (o_so) then
        if (.not.bas_num_prim(soidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_prim failed?',911, BASIS_ERR)
        n_zeta_c_e = nz_add
        if (.not.bas_num_coef(soidin,nz_add)) call errquit
     &      ('int_ecp_init:bas_num_coef failed?',911, BASIS_ERR)
        n_zeta_c_c = nz_add
      else
        call errquit('int_ecp_init: no so or ecp basis',911, BASIS_ERR)
      endif
*.. error check for general contraction
      if (n_zeta_c_e.ne.n_zeta_c_c) then
        write(6,*)' possible general contraction on ecp/so basis'
        call errquit ('int_ecp_init: n_zeta_c_e .ne. n_zeta_c_c',
     &      (n_zeta_c_e- n_zeta_c_c), BASIS_ERR)
      endif
      n_zeta_c = n_zeta_c_e ! use e one
c
c.. allocate space for ecp/so exponents and ecp/so coefficients
      if (.not.ma_alloc_get(mt_dbl,
     &    n_zeta_c,
     &    'ecp exponents',
     &    h_ecp_e, k_ecp_e)) call errquit
     &    (' int_ecp_init: ecp exponent ma failed ',911, BASIS_ERR)
      call dfill(n_zeta_c,0.0d00,dbl_mb(k_ecp_e),1)
      if (.not.ma_alloc_get(mt_dbl,
     &    n_zeta_c,
     &    'ecp coefficients',
     &    h_ecp_c, k_ecp_c)) call errquit
     &    (' int_ecp_init: ecp coefficients ma failed ',911, BASIS_ERR)
      call dfill(n_zeta_c,0.0d00,dbl_mb(k_ecp_c),1)
c
c... determine maximum angular momentum of ecp basis
      l_ecp = 0
      if (o_ecp) then
        if (.not.bas_high_angular(ecpidin,l_ecp)) call errquit
     &      ('int_ecp_init:ecp: bas_high_angular failed',911, BASIS_ERR)
      endif
      if (o_so) then
        if (.not.bas_high_angular(soidin,l_so)) call errquit
     &      ('int_ecp_init:so: bas_high_angular failed',911, BASIS_ERR)
        l_ecp = max(l_ecp,l_so)
      endif
c
      l_ecp_sz = l_ecp + 2       !    (-1->Lval)
c
c... allocate space for n_prim_C(0:4,-1:l_ecp_max,n_C*2),
      if (.not.ma_alloc_get(mt_int,
     &    (5*l_ecp_sz*n_ecp*2),
     &    'ecp n_prim_C',
     &    h_ecp_nprim_c, k_ecp_nprim_c)) call errquit
     &    (' int_ecp: ecp nprim_c ma failed ',911, BASIS_ERR)
      call ifill((5*l_ecp_sz*n_ecp*2),0,int_mb(k_ecp_nprim_c),1)
c... allocate space for n_coef_C(-1:l_ecp_max,n_C*2)
      if (.not.ma_alloc_get(mt_int,
     &    (l_ecp_sz*n_ecp*2),
     &    'ecp n_coef_C',
     &    h_ecp_ncoef_c, k_ecp_ncoef_c)) call errquit
     &    (' int_ecp: ecp ncoef_c ma failed ',911, BASIS_ERR)
      call ifill((l_ecp_sz*n_ecp*2),0,int_mb(k_ecp_ncoef_c),1)
c... allocate space for ind_C      
      if (.not.ma_alloc_get(mt_int,
     &    (l_ecp_sz*n_ecp*2),
     &    'ecp ind_C',
     &    h_ecp_ind_c, k_ecp_ind_c)) call errquit
     &      (' int_ecp: ecp ind_c ma failed ',911, BASIS_ERR)
      call ifill((l_ecp_sz*n_ecp*2),0,int_mb(k_ecp_ind_c),1)
c... allocate space for ind_z      
      if (.not.ma_alloc_get(mt_int,
     &    (l_ecp_sz*n_ecp*2),
     &    'ecp ind_z',
     &    h_ecp_ind_z, k_ecp_ind_z)) call errquit
     &      (' int_ecp: ecp ind_z ma failed ',911, BASIS_ERR)
      call ifill((l_ecp_sz*n_ecp*2),0,int_mb(k_ecp_ind_z),1)
c... allocate space for l_C      
      if (.not.ma_alloc_get(mt_int,
     &    n_ecp,
     &    'ecp l_C',
     &    h_ecp_l_c, k_ecp_l_c)) call errquit
     &    (' int_ecp: ecp l_c ma failed ',911, BASIS_ERR)
      call ifill(n_ecp,0,int_mb(k_ecp_l_c),1)
c... allocate space for ecp center pointer list
      if (.not.ma_alloc_get(mt_int,
     &    n_ecp,
     &    'ecp lexical indeces for ecp centers',
     &    h_ecp_lip, k_ecp_lip)) call errquit
     &    (' int_ecp: ecp_lip ma failed',911, BASIS_ERR)
      call ifill(n_ecp,0,int_mb(k_ecp_lip),1)
c
      call int_ecp_build_ecp_ptrs(ecpidin,soidin,geom,
     &    o_both,o_ecp,o_so,
     &    ncenters,
     &    n_ecp,
     &    l_ecp,
     &    n_zeta_c,
     &    int_mb(k_ecp_nprim_c),
     &    int_mb(k_ecp_ncoef_c),
     &    int_mb(k_ecp_ind_c),
     &    int_mb(k_ecp_ind_z),
     &    int_mb(k_ecp_l_c),
     &    int_mb(k_ecp_lip),
     &    dbl_mb(k_ecp_e),
     &    dbl_mb(k_ecp_c) )
c
*...   allocate space for c2s and s2c internal ecp transformation routines
c
c determine lmax among ao basis and ecp basis
c l_ecp currently has Lmax for ecp basis
      if (.not.ecp_get_parent_handle(ecpidin,basis_handle))
     &      call errquit
     &      ('int_ecp_init: ecp_get_parent_handle failed',911,
     &       BASIS_ERR)
      if (.not.bas_high_angular(basis_handle,l_bas)) call errquit
     &      ('int_ecp_init: bas_high_angular failed for ao handle',
     &      911, BASIS_ERR)
      lmax_both = max(l_ecp,l_bas) + l_bas + 2 
      call ecp_init_c2s(lmax_both,dpdum,dpdum,idum,1,1,.true.,mem_c2s)
      if (.not.ma_alloc_get(mt_dbl,
     &      mem_c2s,
     &      'ecp c2s routines',
     &      h_ecp_c2s, k_ecp_c2s)) call errquit
     &      ('int_ecp_init: ma failed for c2s',911, MA_ERR)
      call dfill(mem_c2s,0.0d00,dbl_mb(k_ecp_c2s),1)
      call ecp_init_c2s(lmax_both,
     &      dbl_mb(k_ecp_c2s),dbl_mb(k_ecp_c2s),mem_c2s,1,1,.false.,
     &      idum)
c
c initialize constants for ecp integral code
c
      call ecp_init_con()
c
c determine maximum memory for ecp integrals
c
      bas_id = basis_handle + basis_handle_offset
      basis_ncont = ncont_tot_gb(bas_id)
      ig = ibs_geom(bas_id)
      jg = ig
      mem_ecp = 0
*      if (.not.bas_print(basis_handle)) stop ' error'
*      if (.not.gbs_map_print(basis_handle)) stop ' error '
*      if (.not.bas_print(ecpidin)) stop 'error'
*      if (.not.gbs_map_print(ecpidin)) stop ' error'
      oskel=.true.
      do ictr=1,ncenters
         if (sym_atom(ig, ictr, qfact))  then
            if(.not.(bas_ce2cnr(basis_handle,ictr,ic1,ic2)))
     .           call errquit('intecp:basce2cnr failed',0, BASIS_ERR)
            do i_cont = ic1,ic2
               ic  = sf_ibs_cn2ce(i_cont,bas_id)
               iuc = sf_ibs_cn2ucn(i_cont,bas_id)
               ie  = infbs_cont(cont_iexp,iuc,bas_id)
               icf = infbs_cont(cont_icfp,iuc,bas_id)
               inp = infbs_cont(cont_nprim,iuc,bas_id)
               ing = infbs_cont(cont_ngen,iuc,bas_id)
               il  = infbs_cont(cont_type,iuc,bas_id) 
               do jctr=ictr,ncenters
                  if (sym_atom(ig, jctr, qfact))  then
                     if(.not.(bas_ce2cnr(basis_handle,jctr,jc1,jc2)))
     .                    call errquit('intecp:basce2cnr failed',0,
     &       BASIS_ERR)
                     do j_cont = jc1,jc2
                        jc = sf_ibs_cn2ce(j_cont,bas_id)
                        juc = sf_ibs_cn2ucn(j_cont,bas_id)
                        je  = infbs_cont(cont_iexp,juc,bas_id)
                        jcf = infbs_cont(cont_icfp,juc,bas_id)
                        jnp = infbs_cont(cont_nprim,juc,bas_id)
                        jng = infbs_cont(cont_ngen,juc,bas_id)
                        jl  = infbs_cont(cont_type,juc,bas_id)
                        nV  = int_nbf_x(il)*int_nbf_x(jl)*ing*jng
                        lecp_mem = 90000
                        if (indx_grad.eq.0) then
                           if (o_ecp) then
                             call int_ecp_hf1(
     &                          coords(1,ic,ig),
     &                          dbl_mb(mb_exndcf(ie,bas_id)),
     &                          dbl_mb(mb_exndcf(icf,bas_id)),
     &                          inp,ing,il,ic,
     &                          coords(1,jc,jg),
     &                          dbl_mb(mb_exndcf(je,bas_id)),
     &                          dbl_mb(mb_exndcf(jcf,bas_id)),
     &                          jnp,jng,jl,jc,
     &                          dpdum,nV,dpdum,lecp_mem1,.true.)
                             lecp_mem = max(lecp_mem,lecp_mem1)
                           endif
                           if (o_so) then
                             call intso_hf1(
     &                          coords(1,ic,ig),
     &                          dbl_mb(mb_exndcf(ie,bas_id)),
     &                          dbl_mb(mb_exndcf(icf,bas_id)),
     &                          inp,ing,il,ic,
     &                          coords(1,jc,jg),
     &                          dbl_mb(mb_exndcf(je,bas_id)),
     &                          dbl_mb(mb_exndcf(jcf,bas_id)),
     &                          jnp,jng,jl,jc,
     &                          dpdum,nV,dpdum,lecp_mem1,.true.)
                             lecp_mem = max(lecp_mem,lecp_mem1)
                           endif
                        elseif (indx_grad.eq.1) then
                           if (o_ecp) then
                             call intd_ecp_hf1(
     &                          coords(1,ic,ig),
     &                          dbl_mb(mb_exndcf(ie,bas_id)),
     &                          dbl_mb(mb_exndcf(icf,bas_id)),
     &                          inp,ing,il,ic,
     &                          coords(1,jc,jg),
     &                          dbl_mb(mb_exndcf(je,bas_id)),
     &                          dbl_mb(mb_exndcf(jcf,bas_id)),
     &                          jnp,jng,jl,jc,
     &                          dpdum,nV,ncenters,dpdum,lecp_mem1,
     &                          .true.)
                             lecp_mem = max(lecp_mem,lecp_mem1)
                           endif
                           if (o_so) then
                             call intd_so_hf1(
     &                          coords(1,ic,ig),
     &                          dbl_mb(mb_exndcf(ie,bas_id)),
     &                          dbl_mb(mb_exndcf(icf,bas_id)),
     &                          inp,ing,il,ic,
     &                          coords(1,jc,jg),
     &                          dbl_mb(mb_exndcf(je,bas_id)),
     &                          dbl_mb(mb_exndcf(jcf,bas_id)),
     &                          jnp,jng,jl,jc,
     &                          dpdum,nV,ncenters,dpdum,lecp_mem1,
     &                          .true.)
                             lecp_mem = max(lecp_mem,lecp_mem1)
                           endif
                        elseif (indx_grad.eq.2) then
                           if (o_ecp) then
                             call intdd_ecp_hf1(
     &                          coords(1,ic,ig),
     &                          dbl_mb(mb_exndcf(ie,bas_id)),
     &                          dbl_mb(mb_exndcf(icf,bas_id)),
     &                          inp,ing,il,ic,
     &                          coords(1,jc,jg),
     &                          dbl_mb(mb_exndcf(je,bas_id)),
     &                          dbl_mb(mb_exndcf(jcf,bas_id)),
     &                          jnp,jng,jl,jc,
     &                          dpdum,nV,ncenters,dpdum,lecp_mem1,
     &                          .true.)
                             lecp_mem = max(lecp_mem,lecp_mem1)
                           endif
                           if (o_so) then
                             call intdd_so_hf1(
     &                          coords(1,ic,ig),
     &                          dbl_mb(mb_exndcf(ie,bas_id)),
     &                          dbl_mb(mb_exndcf(icf,bas_id)),
     &                          inp,ing,il,ic,
     &                          coords(1,jc,jg),
     &                          dbl_mb(mb_exndcf(je,bas_id)),
     &                          dbl_mb(mb_exndcf(jcf,bas_id)),
     &                          jnp,jng,jl,jc,
     &                          dpdum,nV,ncenters,dpdum,lecp_mem1,
     &                          .true.)
                             lecp_mem = max(lecp_mem,lecp_mem1)
                           endif
                        else
                           call errquit(
     .                          'int_ecp_init:unknown initializ',911,
     &       INT_ERR)
                        endif
c     ! nint block used in api routine int_hf1sp                  
                        lecp_mem = lecp_mem + nV 
*                        write(6,*)' i_cont ',i_cont
*                        write(6,*)' j_cont ',j_cont
                        mem_ecp = max(mem_ecp,lecp_mem)
*                        write(6,*)' lecp_mem from int_ecp_init is ',
*     &        lecp_mem,mem_ecp
                     enddo
                  endif
               enddo
            enddo
         endif
      enddo
*     write(6,*)' scr 1e memory without ecp',mem_1e
      mem_1e = max(mem_1e,mem_ecp)
*     write(6,*)' scr 1e memory with    ecp',mem_1e
*     
      call int_nbf_max(basis_handle,mem_ecp)
c
      if (indx_grad.eq.0) then
         mem_ecp=mem_ecp*mem_ecp
      elseif (indx_grad.eq.1) then
         mem_ecp=mem_ecp*mem_ecp*3*ncenters
      else
         mem_ecp=mem_ecp*mem_ecp*3*3*(ncenters*(ncenters-1)/2+ncenters)
         mem_1e = max(mem_1e,mem_ecp)
      endif
      isz_1e = max (isz_1e,mem_ecp)
c
      int_ecp_init = .true.
*     
      end
      subroutine int_ecp_terminate()
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "ecp_nwc.fh"

      logical status

      status = .true.
      status = status .and. MA_free_heap(h_xyzecp)
      status = status .and. MA_free_heap(h_ecp_e)
      status = status .and. MA_free_heap(h_ecp_c)
      status = status .and. MA_free_heap(h_ecp_nprim_c)
      status = status .and. MA_free_heap(h_ecp_ncoef_c)
      status = status .and. MA_free_heap(h_ecp_ind_c)
      status = status .and. MA_free_heap(h_ecp_ind_z)
      status = status .and. MA_free_heap(h_ecp_l_c)
      status = status .and. MA_free_heap(h_ecp_c2s)
      status = status .and. MA_free_heap(h_ecp_lip)
      h_xyzecp      = 0
      k_xyzecp      = 0
      h_ecp_e       = 0
      k_ecp_e       = 0
      h_ecp_c       = 0
      k_ecp_c       = 0
      h_ecp_nprim_c = 0
      k_ecp_nprim_c = 0
      h_ecp_ncoef_c = 0
      k_ecp_ncoef_c = 0
      h_ecp_ind_c   = 0
      k_ecp_ind_c   = 0
      h_ecp_ind_z   = 0
      k_ecp_ind_z   = 0
      h_ecp_l_c     = 0
      k_ecp_l_c     = 0
      h_ecp_c2s     = 0
      k_ecp_c2s     = 0
      h_ecp_lip     = 0
      k_ecp_lip     = 0
      n_zeta_c      = 0
      l_ecp         = 0
      n_ecp         = 0
      init_ecp_init = .false.
      if (status) return
      call errquit
     &    ('int_ecp_terminate: error freeing heap',911, MEM_ERR)
      end
      subroutine int_ecp_build_ecp_ptrs(ecpidin,soidin,geom,
     &    o_both, o_ecp, o_so,
     &    ncenters,
     &    n_ecp,
     &    l_ecp,
     &    nz_ecp,
     &    n_prim_C,
     &    n_coef_C,
     &    ind_C,
     &    ind_Z,
     &    l_C,
     &    i_cent_C,
     &    c_exp,
     &    c_coef)
      implicit none
#include "errquit.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
c
      integer ecpidin  ! [input] ecp basis set handle
      integer soidin   ! [input] so pot. handle
      logical o_both, o_ecp, o_so ![input] which ones to set up
      integer ncenters ! [input] number of centers
      integer n_ecp    ! [input] number of ecp centers
      integer l_ecp    ! [input] maximum angular momentum in ecp basis
      integer nz_ecp   ! [input] number of prims/coeffs in stored data structure. 
      integer n_prim_C(0:4,-1:l_ecp,n_ecp,2) ! [output] 
      integer n_coef_C(-1:l_ecp,n_ecp,2)     ! [output] 
      integer ind_C(-1:l_ecp,n_ecp,2)        ! [output] 
      integer ind_z(-1:l_ecp,n_ecp,2)        ! [output] 
      integer l_C(n_ecp)                      ! [output] 
      integer i_cent_C(n_ecp)                 ! [output]
      double precision c_exp(nz_ecp)          ! [output] 
      double precision c_coef(nz_ecp)         ! [output] 
c
      logical on_ecp, on_so
      integer geom        ! geometry handle
      integer ecpid       ! lexical basis set handle
      integer soid        ! lexical so pot handle
      integer icent       ! counter for centers
      integer iucent      ! unique map of icent
      integer p_nprim     ! counter/pointer into exp/coeff array
      integer num_ecp     ! ecp center as counted
      integer F_cont      ! first contraction on center iucent
      integer L_cont      ! last  contraction on center iucent
      integer iucont      ! contraction counter
      integer type        ! function type (-1 = local, 0-lval is non-local)
      integer nprim       ! number of prims in a contraction
      integer ncoef       ! number of coefficients in a contraction
      integer iexp        ! pointer into exndcf for exponents
      integer icfp        ! pointer into exndcf for coefficients
      integer irexp       ! pointer into exndcf for r-exponents
      integer n0,n1,n2    ! r-exponent count 
      integer n3,n4       ! r-exponent count 
      integer ie          ! ecp/so counter
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
*      write(6,*)' inside build'
      ecpid = ecpidin + BASIS_HANDLE_OFFSET
      soid  = soidin  + BASIS_HANDLE_OFFSET
c... zero arrays
      call ifill((5*(l_ecp+2)*n_ecp*2),0,n_prim_C,1)
      call ifill(((l_ecp+2)*n_ecp*2),0,n_coef_C,1)
      call ifill(((l_ecp+2)*n_ecp*2),0,ind_C,1)
      call ifill(((l_ecp+2)*n_ecp*2),0,ind_z,1)
      call ifill(n_ecp,0,l_C,1)
      call ifill(n_ecp,0,i_cent_C,1)
      call dfill(nz_ecp,0.0d00,c_exp,1)
      call dfill(nz_ecp,0.0d00,c_coef,1)
c
      if (o_both) then
        if (.not.
     &      ecpso_list_ncent(geom,soidin,ecpidin,num_ecp,i_cent_C))
     &      call errquit('ecp_ptrs: ecpso_list failed',911, BASIS_ERR)
      else if (o_ecp) then
        if (.not.ecp_list_ncent(geom,ecpidin,num_ecp,i_cent_C))
     &      call errquit('ecp_ptrs: ecp_list failed',911, BASIS_ERR)
      else if (o_so) then
        if (.not.so_list_ncent(geom,soidin,num_ecp,i_cent_C))
     &      call errquit('ecp_ptrs: ecpso_list failed',911, BASIS_ERR)
      else 
        call errquit('ecp_ptrs: should not get here',911, BASIS_ERR)
      endif
      if (num_ecp.ne.n_ecp) call errquit
     &    ('ecp_ptrs: mismatch in num_ecp and n_ecp',
     &    (num_ecp-n_ecp), BASIS_ERR)
c
      p_nprim = 0
      do ie = 1,n_ecp
        icent = i_cent_C(ie)
        if (o_ecp) then
          on_ecp = bas_isce(geom,ecpidin,icent)
        else
          on_ecp = .false.
        endif
        if (o_so) then
          on_so  = bas_isce(geom,soidin,icent)
        else
          on_so  = .false.
        endif
        if (on_ecp) then
          iucent = sf_ibs_ce2uce(icent,ecpid)
          F_cont = infbs_tags(TAG_FCONT,iucent,ecpid)
          L_cont = infbs_tags(TAG_LCONT,iucent,ecpid)
          do iucont = F_cont, L_cont
            type  = infbs_cont(CONT_TYPE,iucont,ecpid)
            nprim = infbs_cont(CONT_NPRIM,iucont,ecpid)
            ncoef = nprim*infbs_cont(CONT_NGEN,iucont,ecpid)
            if (nprim.ne.ncoef) then
              write(6,*)'general contraction ecp basis are invalid now'
              call errquit('int_ecp_build_ecp_ptrs: error',911,
     &       BASIS_ERR)
            endif
            iexp  = infbs_cont(CONT_IEXP,iucont,ecpid)
            icfp  = infbs_cont(CONT_ICFP,iucont,ecpid)
            irexp = infbs_cont(CONT_IREXP,iucont,ecpid)
            if ((p_nprim+nprim).gt.nz_ecp) call errquit
     &          ('int_ecp_build_ecp_ptrs:too many coefficients',911,
     &       BASIS_ERR)
            call ecp_get_n3(
     &          c_exp((p_nprim+1)),
     &          dbl_mb(mb_exndcf(iexp,ecpid)),
     &          c_coef((p_nprim+1)),
     &          dbl_mb(mb_exndcf(icfp,ecpid)),
     &          dbl_mb(mb_exndcf(irexp,ecpid)),
     &          nprim,n0,n1,n2,n3,n4)
            n_prim_C(0,type,ie,1) = n0
            n_prim_C(1,type,ie,1) = n1
            n_prim_C(2,type,ie,1) = n2
            n_prim_C(3,type,ie,1) = n3
            n_prim_C(4,type,ie,1) = n4
            ind_C(type,ie,1)      = p_nprim+1
            ind_Z(type,ie,1)      = p_nprim+1
            n_coef_c(type,ie,1)   = nprim
            l_C(ie)               = max(type,l_C(ie))
            p_nprim = p_nprim+nprim
          enddo
        endif
        if (on_so) then
          iucent = sf_ibs_ce2uce(icent,soid)
          F_cont = infbs_tags(TAG_FCONT,iucent,soid)
          L_cont = infbs_tags(TAG_LCONT,iucent,soid)
          do iucont = F_cont, L_cont
            type  = infbs_cont(CONT_TYPE,iucont,soid)
            nprim = infbs_cont(CONT_NPRIM,iucont,soid)
            ncoef = nprim*infbs_cont(CONT_NGEN,iucont,soid)
            if (nprim.ne.ncoef) then
              write(6,*)'general contraction so basis are invalid now'
              call errquit('int_ecp_build_ecp_ptrs: error',911,
     &       BASIS_ERR)
            endif
            iexp  = infbs_cont(CONT_IEXP,iucont,soid)
            icfp  = infbs_cont(CONT_ICFP,iucont,soid)
            irexp = infbs_cont(CONT_IREXP,iucont,soid)
            if ((p_nprim+nprim).gt.nz_ecp) call errquit
     &          ('int_ecp_build_ecp_ptrs:too many coefficients',911,
     &       BASIS_ERR)
            call ecp_get_n3(
     &          c_exp((p_nprim+1)),
     &          dbl_mb(mb_exndcf(iexp,soid)),
     &          c_coef((p_nprim+1)),
     &          dbl_mb(mb_exndcf(icfp,soid)),
     &          dbl_mb(mb_exndcf(irexp,soid)),
     &          nprim,n0,n1,n2,n3,n4)
            n_prim_C(0,type,ie,2) = n0
            n_prim_C(1,type,ie,2) = n1
            n_prim_C(2,type,ie,2) = n2
            n_prim_C(3,type,ie,2) = n3
            n_prim_C(4,type,ie,2) = n4
            ind_C(type,ie,2)      = p_nprim+1
            ind_Z(type,ie,2)      = p_nprim+1
            n_coef_c(type,ie,2)   = nprim
            l_C(ie)               = max(type,l_C(ie))
            p_nprim = p_nprim+nprim
          enddo
        endif
      enddo
c
*debug:      call print_ecp_ptrs(n_ecp,
*debug:     &    l_ecp,nz_ecp,
*debug:     &    n_prim_C,
*debug:     &    n_coef_C,
*debug:     &    ind_C,
*debug:     &    ind_Z,
*debug:     &    l_C,
*debug:     &    c_exp,
*debug:     &    c_coef)
c
      end
      subroutine print_ecp_ptrs(n_ecp,
     &    l_ecp,nz_ecp,
     &    n_prim_C,
     &    n_coef_C,
     &    ind_C,
     &    ind_Z,
     &    l_C,
     &    c_exp,
     &    c_coef)
      implicit none
c     
      integer n_ecp    ! [input] number of ecp centers
      integer l_ecp    ! [input] maximum angular momentum in ecp basis
      integer nz_ecp   ! [input] number of prims/coeffs in stored data structure. 
      integer n_prim_C(0:4,-1:l_ecp,n_ecp,2) ! [output] 
      integer n_coef_C(-1:l_ecp,n_ecp,2)     ! [output] 
      integer ind_C(-1:l_ecp,n_ecp,2)        ! [output] 
      integer ind_Z(-1:l_ecp,n_ecp,2)        ! [output] 
      integer l_C(n_ecp)                      ! [output] 
      double precision c_exp(nz_ecp)          ! [output] 
      double precision c_coef(nz_ecp)         ! [output] 
*
      integer i, j, k, l
*      integer low0, high0, low1, high1, low2, high2
*      integer ir
      integer pe, pek
*
      write(6,*)' print_ecp_ptrs: start'
      write(6,*)' exponents and coefficients array'
      do i = 1,nz_ecp
        write(6,10000)i,c_exp(i),i,c_coef(i)
      enddo
10000 format(1x,'exp(',i5,') =',f12.6,2x,'coeff(',i5,') =',f12.6)
      do i = 1,n_ecp
        write(6,*)' l_c(',i,')',l_c(i)
      enddo
      do l = 1,2
        do i=1,n_ecp
          do j=-1,l_ecp
            write(6,*)' n_coef_C(',j,',',i,',',l,') = ',
     &          n_coef_C(j,i,l)
            write(6,*)' ind_C(',j,',',i,',',l,') = ',
     &          ind_C(j,i,l)
            write(6,*)' ind_z(',j,',',i,',',l,') = ',
     &          ind_z(j,i,l)
            do k = 0,4
              write(6,*)' n_prim_C(',
     &            k,',',j,',',i,',',l,') =',
     &            n_prim_C(k,j,i,l)
            enddo
          enddo
        enddo
      enddo
      write(6,*)' --- '
      write(6,*)' i = 1:',n_ecp
      do l = 1,2
        if (l.eq.1)
     &      write(6,*)'                                            ecp'
        if (l.eq.2)
     &      write(6,*)'                                            sop'
        do i=1,n_ecp
          write(6,*)' angular momentum max on center ',
     &        i,'is',l_c(i)
          write(6,*)' j = -1:',l_ecp
          do j=-1,l_ecp
            write(6,*)' lval = ',j
            pe = ind_c(j,i,l)-1
            do k=1,n_prim_C(0,j,i,l)
              pek = pe + k
              write(6,*)' 0 ',c_exp(pek),c_coef(pek)
            enddo
            pe = pe + n_prim_C(0,j,i,l)
            do k=1,n_prim_C(1,j,i,l)
              pek = pe + k
              write(6,*)' 1 ',c_exp(pek),c_coef(pek)
            enddo
            pe = pe + n_prim_C(1,j,i,l)
            do k=1,n_prim_C(2,j,i,l)
              pek = pe + k
              write(6,*)' 2 ',c_exp(pek),c_coef(pek)
            enddo
            pe = pe + n_prim_C(2,j,i,l)
            do k=1,n_prim_C(3,j,i,l)
              pek = pe + k
              write(6,*)' 3 ',c_exp(pek),c_coef(pek)
            enddo
            pe = pe + n_prim_C(3,j,i,l)
            do k=1,n_prim_C(4,j,i,l)
              pek = pe + k
              write(6,*)' 4 ',c_exp(pek),c_coef(pek)
            enddo
            write(6,*)' '
          enddo
          write(6,*)' '
        enddo
      enddo
      write(6,*)' print_ecp_ptrs: finish'
      end
      subroutine ecp_get_n3(
     &    c_exp,
     &    ecp_exp,
     &    c_coef,
     &    ecp_coef,
     &    grexp,
     &    nprim,new0,new1,new2,new3,new4)
      implicit none
#include "errquit.fh"
c
c data structures in the ecp code assume all 0 exponents, all 1 exponents
c and all 2 exponents are contiguous.  Not enforced in the input.
c 
c
      integer nprim, new0, new1, new2, new3, new4
      double precision c_exp(nprim)
      double precision ecp_exp(nprim)
      double precision c_coef(nprim)
      double precision ecp_coef(nprim)
      double precision grexp(nprim)
c
      integer i, j, ival, iptr
      integer new(0:4)
c
c assumes no general contraction in the ecp basis
c
*:debugn3:      write(6,*)' '
*:debugn3:      write(6,*)'-----------------------------------------------------'
*:debugn3:      write(6,*)' ecp exp '
*:debugn3:      call output (ecp_exp,1,nprim,1,1,nprim,1,1)
*:debugn3:      write(6,*)' ecp coef '
*:debugn3:      call output (ecp_coef,1,nprim,1,1,nprim,1,1)
*:debugn3:      write(6,*)' grexp '
*:debugn3:      call output (grexp,1,nprim,1,1,nprim,1,1)
      call ifill(5,0,new,1)
      iptr = 0
      do i = 0,4
        do j = 1,nprim
          ival = int(grexp(j) + 0.00002d00)
*:debugn3:          write(6,*)' i, j, ival ',i, j, ival
          if (ival.lt.0.or.ival.gt.4) then
            write(6,*)' ival    = ',ival
            write(6,*)' grexp(j) = ',grexp(j)
            call errquit
     &          ('ecp_get_n3: r-exponent not equal to 0,1,2,3,4',911,
     &       BASIS_ERR)
          endif
          if (ival.eq.i) then
            new(i) = new(i) + 1
            iptr = iptr + 1
*:debugn3:            write(6,*)' i, j, ival,iptr,new ',i, j, ival,iptr,new
            c_exp(iptr) = ecp_exp(j)
            c_coef(iptr) = ecp_coef(j)
          endif
        enddo
      enddo
*:debugn3:      write(6,*) ' iprt after loop,nprim ',iptr,nprim
      new0 = new(0)
      new1 = new(1)
      new2 = new(2)
      new3 = new(3)
      new4 = new(4)
*:debugn3:      write(6,*)' c_exp  '
*:debugn3:      call output (c_exp,1,nprim,1,1,nprim,1,1)
*:debugn3:      write(6,*)' c_coef  '
*:debugn3:      call output (c_coef,1,nprim,1,1,nprim,1,1)
*:debugn3:      write(6,*)'-----------------------------------------------------'
*:debugn3:      write(6,*)' '
c
      end
      block data ecp_init_bd
c
c Block data structure to initialize common block for ecp
c
#include "ecp_nwc.fh"
      data h_xyzecp      /0/       ! MA handle for ecp center coordinates
      data k_xyzecp      /0/       ! MA index  for ecp center coordinates
      data h_ecp_e       /0/       ! MA handle for ecp exponents
      data k_ecp_e       /0/       ! MA index  for ecp exponents
      data h_ecp_c       /0/       ! MA handle for ecp coefficients
      data k_ecp_c       /0/       ! MA index  for ecp coefficients
      data h_ecp_nprim_c /0/       ! MA handle for n_prim_C (see ecp_integral)
      data k_ecp_nprim_c /0/       ! MA index  for n_prim_C (see ecp_integral)
      data h_ecp_ncoef_c /0/       ! MA handle for n_coef_C (see ecp_integral)
      data k_ecp_ncoef_c /0/       ! MA index  for n_coef_C (see ecp_integral)
      data h_ecp_ind_c   /0/       ! MA handle for int_C (see ecp_integral)
      data k_ecp_ind_c   /0/       ! MA index  for int_C (see ecp_integral)
      data h_ecp_l_c     /0/       ! MA handle for l_C (see ecp_integral)
      data k_ecp_l_c     /0/       ! MA index  for l_C (see ecp_integral)
      data h_ecp_c2s     /0/       ! MA handle for c2s routines
      data k_ecp_c2s     /0/       ! MA index  for c2s routines
      data h_ecp_lip     /0/       ! MA handle for ecp center index
      data k_ecp_lip     /0/       ! MA index for ecp center index
      data n_zeta_c      /0/       ! length of ecp exp/coef array
      data l_ecp         /0/       ! high ang for ecp basis
      data n_ecp         /0/       ! number of ecp centers (from API)
      data init_ecp_init /.false./ ! logical saying if ecp is init-ed
      end
      subroutine int_ecp_hf1(
     &    xyza,expa,coefa,a_nprim,a_ngen,La,ictra,
     &    xyzb,expb,coefb,b_nprim,b_ngen,Lb,ictrb,
     &    ecp_ints,sz_ints,scr,lscr,dryrun)
      implicit none
#include "mafdecls.fh"
#include "ecp_nwc.fh"
*
      integer a_nprim, a_ngen, La, ictra
      integer b_nprim, b_ngen, Lb, ictrb
      double precision expa(a_nprim), expb(b_nprim)
      double precision coefa(a_nprim,a_ngen), coefb(b_nprim,b_ngen)
      integer sz_ints  ! [input] buffer size for ecp_ints
      integer lscr     ! [input] length of scratch array
      double precision xyza(3), xyzb(3)  ! [input] a and b center coords.
      double precision ecp_ints(sz_ints) ! [output] ecp integrals
      double precision scr(lscr)         ! [scratch] array
      logical dryrun   ! [input] compute vs calculate memory requirements.
*
*      write(6,*)' lscr IN ecp_hf1:',lscr
*      if (.not.dryrun) then
*        write(6,*)' int_ecp_hf1: coords a ',xyza
*        write(6,*)' int_ecp_hf1: coords b ',xyzb
*      endif
c
      call ecp_integral(
     &      xyza,
     &      expa,
     &      coefa,
     &      a_nprim,a_ngen,La,ictra,
     &      xyzb,
     &      expb,
     &      coefb,
     &      b_nprim,b_ngen,Lb,ictrb,
     &      dbl_mb(k_xyzecp),
     &      dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &      int_mb(k_ecp_nprim_c),
     &      int_mb(k_ecp_ncoef_c),  ! new name is n_colc_C
     &      int_mb(k_ecp_ind_z),
     &      int_mb(k_ecp_ind_c),
     &      n_zeta_c,
     &      n_zeta_c,
     &      int_mb(k_ecp_l_c),
     &      int_mb(k_ecp_lip), 
     &      n_ecp,l_ecp,
     &      0,
     &      dbl_mb(k_ecp_c2s),mem_c2s,
     &      ecp_ints,sz_ints,1,   ! nblk 1 for ecp integrals only 
     &      dryrun,scr,lscr,
     &      0)  ! ibug
*
      end
      subroutine intdd_ecp_hf1(
     &    xyza,expa,coefa,a_nprim,a_ngen,La,ictra,
     &    xyzb,expb,coefb,b_nprim,b_ngen,Lb,ictrb,
     &    ecp_grad,sz_grad,nat,scr,lscr,dryrun)
      implicit none
#include "mafdecls.fh"
#include "ecp_nwc.fh"
*
      integer a_nprim, a_ngen, La, ictra
      integer b_nprim, b_ngen, Lb, ictrb
      integer nat
      double precision expa(a_nprim), expb(b_nprim)
      double precision coefa(a_nprim,a_ngen), coefb(b_nprim,b_ngen)
      integer sz_grad  ! [input] buffer size for ecp_grad
      integer lscr     ! [input] length of scratch array
      double precision xyza(3), xyzb(3)  ! [input] a and b center coords.
      double precision ecp_grad(sz_grad,3,3,(nat*(nat-1)/2+nat)) ! [output] ecp integrals
      double precision scr(lscr)         ! [scratch] array
      logical dryrun   ! [input] compute vs calculate memory requirements.
*
*      write(6,*)' lscr IN d_ecp_hf1:',lscr
*      if (.not.dryrun) then
*        write(6,*)' intd_ecp_hf1: coords a ',xyza
*        write(6,*)' intd_ecp_hf1: coords b ',xyzb
*      endif
c
      call ecp_hessian(
     &      xyza,
     &      expa,
     &      coefa,
     &      a_nprim,a_ngen,La,ictra,
     &      xyzb,
     &      expb,
     &      coefb,
     &      b_nprim,b_ngen,Lb,ictrb,
     &      dbl_mb(k_xyzecp),
     &      dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &      int_mb(k_ecp_nprim_c),
     &      int_mb(k_ecp_ncoef_c),
     &      int_mb(k_ecp_ind_z),
     &      int_mb(k_ecp_ind_c),
     &      n_zeta_c,
     &      n_zeta_c,
     &      int_mb(k_ecp_l_c),
     &      int_mb(k_ecp_lip), 
     &      n_ecp,l_ecp,
     &      0,
     &      dbl_mb(k_ecp_c2s),mem_c2s,
     &      ecp_grad,sz_grad,1,nat,          ! nblock = 1 for ECP only 
     &      dryrun,scr,lscr,
     &      0)  ! ibug
*
      end
      subroutine intd_ecp_hf1(
     &    xyza,expa,coefa,a_nprim,a_ngen,La,ictra,
     &    xyzb,expb,coefb,b_nprim,b_ngen,Lb,ictrb,
     &    ecp_grad,sz_grad,nat,scr,lscr,dryrun)
      implicit none
#include "mafdecls.fh"
#include "ecp_nwc.fh"
*
      integer a_nprim, a_ngen, La, ictra
      integer b_nprim, b_ngen, Lb, ictrb
      integer nat
      double precision expa(a_nprim), expb(b_nprim)
      double precision coefa(a_nprim,a_ngen), coefb(b_nprim,b_ngen)
      integer sz_grad  ! [input] buffer size for ecp_grad
      integer lscr     ! [input] length of scratch array
      double precision xyza(3), xyzb(3)  ! [input] a and b center coords.
      double precision ecp_grad(sz_grad,3,nat) ! [output] ecp integrals
      double precision scr(lscr)         ! [scratch] array
      logical dryrun   ! [input] compute vs calculate memory requirements.
*
*      write(6,*)' lscr IN d_ecp_hf1:',lscr
*      if (.not.dryrun) then
*        write(6,*)' intd_ecp_hf1: coords a ',xyza
*        write(6,*)' intd_ecp_hf1: coords b ',xyzb
*      endif
c
      call ecp_gradient(
     &      xyza,
     &      expa,
     &      coefa,
     &      a_nprim,a_ngen,La,ictra,
     &      xyzb,
     &      expb,
     &      coefb,
     &      b_nprim,b_ngen,Lb,ictrb,
     &      dbl_mb(k_xyzecp),
     &      dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &      int_mb(k_ecp_nprim_c),
     &      int_mb(k_ecp_ncoef_c),
     &      int_mb(k_ecp_ind_z),
     &      int_mb(k_ecp_ind_c),
     &      n_zeta_c,
     &      n_zeta_c,
     &      int_mb(k_ecp_l_c),
     &      int_mb(k_ecp_lip), 
     &      n_ecp,l_ecp,
     &      0,
     &      dbl_mb(k_ecp_c2s),mem_c2s,
     &      ecp_grad,sz_grad,1,nat,          ! nblock = 1 for ECP only 
     &      dryrun,scr,lscr,
     &      0)  ! ibug
*
      end
      subroutine intso_hf1(
     &    xyza,expa,coefa,a_nprim,a_ngen,La,ictra,
     &    xyzb,expb,coefb,b_nprim,b_ngen,Lb,ictrb,
     &    ecp_ints,sz_ints,scr,lscr,dryrun)
      implicit none
#include "mafdecls.fh"
#include "ecp_nwc.fh"
*
      integer a_nprim, a_ngen, La, ictra
      integer b_nprim, b_ngen, Lb, ictrb
      double precision expa(a_nprim), expb(b_nprim)
      double precision coefa(a_nprim,a_ngen), coefb(b_nprim,b_ngen)
      integer sz_ints  ! [input] buffer size for ecp_ints
      integer lscr     ! [input] length of scratch array
      double precision xyza(3), xyzb(3)  ! [input] a and b center coords.
      double precision ecp_ints(sz_ints) ! [output] ecp integrals
      double precision scr(lscr)         ! [scratch] array
      logical dryrun   ! [input] compute vs calculate memory requirements.
*
*      write(6,*)' lscr IN so_hf1:',lscr
c
      call ecp_integral(
     &      xyza,
     &      expa,
     &      coefa,
     &      a_nprim,a_ngen,La,ictra,
     &      xyzb,
     &      expb,
     &      coefb,
     &      b_nprim,b_ngen,Lb,ictrb,
     &      dbl_mb(k_xyzecp),
     &      dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &      int_mb(k_ecp_nprim_c),
     &      int_mb(k_ecp_ncoef_c),  ! new name is n_colc_C
     &      int_mb(k_ecp_ind_z),
     &      int_mb(k_ecp_ind_c),
     &      n_zeta_c,
     &      n_zeta_c,
     &      int_mb(k_ecp_l_c),
     &      int_mb(k_ecp_lip), 
     &      n_ecp,l_ecp,
     &      0,
     &      dbl_mb(k_ecp_c2s),mem_c2s,
     &      ecp_ints,sz_ints,3,   ! nblk 1 for ecp integrals only 
     &      dryrun,scr,lscr,
     &      0)  ! ibug
*
      end
      subroutine intd_so_hf1(
     &    xyza,expa,coefa,a_nprim,a_ngen,La,ictra,
     &    xyzb,expb,coefb,b_nprim,b_ngen,Lb,ictrb,
     &    ecp_grad,sz_grad,nat,scr,lscr,dryrun)
      implicit none
#include "mafdecls.fh"
#include "ecp_nwc.fh"
*
      integer a_nprim, a_ngen, La, ictra
      integer b_nprim, b_ngen, Lb, ictrb
      integer nat
      double precision expa(a_nprim), expb(b_nprim)
      double precision coefa(a_nprim,a_ngen), coefb(b_nprim,b_ngen)
      integer sz_grad  ! [input] buffer size for ecp_grad
      integer lscr     ! [input] length of scratch array
      double precision xyza(3), xyzb(3)  ! [input] a and b center coords.
      double precision ecp_grad(sz_grad,3,nat) ! [output] ecp integrals
      double precision scr(lscr)         ! [scratch] array
      logical dryrun   ! [input] compute vs calculate memory requirements.
*
*      write(6,*)' lscr IN d_ecp_hf1:',lscr
*      if (.not.dryrun) then
*        write(6,*)' intd_ecp_hf1: coords a ',xyza
*        write(6,*)' intd_ecp_hf1: coords b ',xyzb
*      endif
c
      call ecp_gradient(
     &      xyza,
     &      expa,
     &      coefa,
     &      a_nprim,a_ngen,La,ictra,
     &      xyzb,
     &      expb,
     &      coefb,
     &      b_nprim,b_ngen,Lb,ictrb,
     &      dbl_mb(k_xyzecp),
     &      dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &      int_mb(k_ecp_nprim_c),
     &      int_mb(k_ecp_ncoef_c),
     &      int_mb(k_ecp_ind_z),
     &      int_mb(k_ecp_ind_c),
     &      n_zeta_c,
     &      n_zeta_c,
     &      int_mb(k_ecp_l_c),
     &      int_mb(k_ecp_lip), 
     &      n_ecp,l_ecp,
     &      0,
     &      dbl_mb(k_ecp_c2s),mem_c2s,
     &      ecp_grad,sz_grad,3,nat,          ! nblock = 3 for SO only 
     &      dryrun,scr,lscr,
     &      0)  ! ibug
*
      end
      subroutine intdd_so_hf1(
     &    xyza,expa,coefa,a_nprim,a_ngen,La,ictra,
     &    xyzb,expb,coefb,b_nprim,b_ngen,Lb,ictrb,
     &    ecp_grad,sz_grad,nat,scr,lscr,dryrun)
      implicit none
#include "mafdecls.fh"
#include "ecp_nwc.fh"
*
      integer a_nprim, a_ngen, La, ictra
      integer b_nprim, b_ngen, Lb, ictrb
      integer nat
      double precision expa(a_nprim), expb(b_nprim)
      double precision coefa(a_nprim,a_ngen), coefb(b_nprim,b_ngen)
      integer sz_grad  ! [input] buffer size for ecp_grad
      integer lscr     ! [input] length of scratch array
      double precision xyza(3), xyzb(3)  ! [input] a and b center coords.
      double precision ecp_grad(sz_grad,3,3,(nat*(nat-1)/2+nat)) ! [output] ecp integrals
      double precision scr(lscr)         ! [scratch] array
      logical dryrun   ! [input] compute vs calculate memory requirements.
*
*      write(6,*)' lscr IN d_ecp_hf1:',lscr
*      if (.not.dryrun) then
*        write(6,*)' intd_ecp_hf1: coords a ',xyza
*        write(6,*)' intd_ecp_hf1: coords b ',xyzb
*      endif
c
      call ecp_hessian(
     &      xyza,
     &      expa,
     &      coefa,
     &      a_nprim,a_ngen,La,ictra,
     &      xyzb,
     &      expb,
     &      coefb,
     &      b_nprim,b_ngen,Lb,ictrb,
     &      dbl_mb(k_xyzecp),
     &      dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &      int_mb(k_ecp_nprim_c),
     &      int_mb(k_ecp_ncoef_c),
     &      int_mb(k_ecp_ind_z),
     &      int_mb(k_ecp_ind_c),
     &      n_zeta_c,
     &      n_zeta_c,
     &      int_mb(k_ecp_l_c),
     &      int_mb(k_ecp_lip), 
     &      n_ecp,l_ecp,
     &      0,
     &      dbl_mb(k_ecp_c2s),mem_c2s,
     &      ecp_grad,sz_grad,3,nat,          ! nblock = 1 for ECP only 
     &      dryrun,scr,lscr,
     &      0)  ! ibug
*
      end

      SUBROUTINE DGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
C     .. Parameters ..
C     $Id: dgemm.F 24342 2013-06-22 05:32:15Z d3y133 $
      DOUBLE PRECISION ONE, ZERO
      PARAMETER        (ONE=1.0D+0,ZERO=0.0D+0)
      INTEGER          MB, NB, KB
#ifdef CACHE1M
!x86_64 cache=1024K 
      PARAMETER        (MB=256,NB=MB,KB=256)
#elif CACHE6M
!ia64 cache=6M
      PARAMETER        (MB=512,NB=MB,KB=512)
#else
!x86 cache=256K   
       PARAMETER        (MB=64,NB=MB,KB=64)
#endif
C     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA, BETA
      INTEGER          K, LDA, LDB, LDC, M, N
      CHARACTER        TRANSA, TRANSB
C     .. Array Arguments ..
C
C     Purpose
C     =======
C
C     DGEMM  performs one of the matrix-matrix operations
C
C     C := alpha*op( A )*op( B ) + beta*C,
C
C     where  op( X ) is one of
C
C     op( X ) = X   or   op( X ) = X',
C
C     alpha and beta are scalars, and A, B and C are matrices, with op( A )
C     an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
C
C     Parameters
C     ==========
C
C     TRANSA - CHARACTER*1.
C     On entry, TRANSA specifies the form of op( A ) to be used in
C     the matrix multiplication as follows:
C
C     TRANSA = 'N' or 'n',  op( A ) = A.
C
C     TRANSA = 'T' or 't',  op( A ) = A'.
C
C     TRANSA = 'C' or 'c',  op( A ) = A'.
C
C     Unchanged on exit.
C
C     TRANSB - CHARACTER*1.
C     On entry, TRANSB specifies the form of op( B ) to be used in
C     the matrix multiplication as follows:
C
C     TRANSB = 'N' or 'n',  op( B ) = B.
C
C     TRANSB = 'T' or 't',  op( B ) = B'.
C
C     TRANSB = 'C' or 'c',  op( B ) = B'.
C
C     Unchanged on exit.
C
C     M      - INTEGER.
C     On entry,  M  specifies  the number  of rows  of the  matrix
C     op( A )  and of the  matrix  C.  M  must  be at least  zero.
C     Unchanged on exit.
C
C     N      - INTEGER.
C     On entry,  N  specifies the number  of columns of the matrix
C     op( B ) and the number of columns of the matrix C. N must be
C     at least zero.
C     Unchanged on exit.
C
C     K      - INTEGER.
C     On entry,  K  specifies  the number of columns of the matrix
C     op( A ) and the number of rows of the matrix op( B ). K must
C     be at least  zero.
C     Unchanged on exit.
C
C     ALPHA  - DOUBLE PRECISION.
C     On entry, ALPHA specifies the scalar alpha.
C     Unchanged on exit.
C
C     A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
C     k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
C     Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
C     part of the array  A  must contain the matrix  A,  otherwise
C     the leading  k by m  part of the array  A  must contain  the
C     matrix A.
C     Unchanged on exit.
C
C     LDA    - INTEGER.
C     On entry, LDA specifies the first dimension of A as declared
C     in the calling (sub) program. When  TRANSA = 'N' or 'n' then
C     LDA must be at least  max( 1, m ), otherwise  LDA must be at
C     least  max( 1, k ).
C     Unchanged on exit.
C
C     B      - DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is
C     n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
C     Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
C     part of the array  B  must contain the matrix  B,  otherwise
C     the leading  n by k  part of the array  B  must contain  the
C     matrix B.
C     Unchanged on exit.
C
C     LDB    - INTEGER.
C     On entry, LDB specifies the first dimension of B as declared
C     in the calling (sub) program. When  TRANSB = 'N' or 'n' then
C     LDB must be at least  max( 1, k ), otherwise  LDB must be at
C     least  max( 1, n ).
C     Unchanged on exit.
C
C     BETA   - DOUBLE PRECISION.
C     On entry,  BETA  specifies the scalar  beta.  When  BETA  is
C     supplied as zero then C need not be set on input.
C     Unchanged on exit.
C
C     C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
C     Before entry, the leading  m by n  part of the array  C must
C     contain the matrix  C,  except when  beta  is zero, in which
C     case C need not be set on entry.
C     On exit, the array  C  is overwritten by the  m by n  matrix
C     ( alpha*op( A )*op( B ) + beta*C ).
C
C     LDC    - INTEGER.
C     On entry, LDC specifies the first dimension of C as declared
C     in  the  calling  (sub)  program.   LDC  must  be  at  least
C     max( 1, m ).
C     Unchanged on exit.
C
C
C     Level 3 Blas routine.
C
C     -- Written on 8-February-1989.
C     Jack Dongarra, Argonne National Laboratory.
C     Iain Duff, AERE Harwell.
C     Jeremy Du Croz, Numerical Algorithms Group Ltd.
C     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*     This code comes from a report entitled:
*     The IBM RISC System/6000 and Linear Algebra Operations, by
*     Jack J. Dongarra, Peter Mayes, and Giuseppe Radicati di Brozolo,
*     University of Tennessee Computer Science Tech Report: CS - 90 - 122.
C
C
      DOUBLE PRECISION A(LDA,*), B(LDB,*), C(LDC,*)
C     .. External Functions ..
      LOGICAL          LSAME
      EXTERNAL         LSAME
C     .. External Subroutines ..
      EXTERNAL         XERBLA
C     .. Intrinsic Functions ..
      INTRINSIC        MAX, MIN
C     .. Local Scalars ..
      DOUBLE PRECISION T11, T12, T21, T22
      INTEGER          I, IDEPTH, II, ILEN, INFO, ISPAN, J, JDEPTH, JJ,
     *                 JLEN, JSPAN, L, LL, LSPAN, NCOLA, NROWA, NROWB
      LOGICAL          NOTA, NOTB
C     .. Local Arrays ..
      DOUBLE PRECISION CH(KB,MB), CH1(KB), CH2(KB)
C     .. Executable Statements ..
C
C     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
C     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
C     and  columns of  A  and the  number of  rows  of  B  respectively.
C
      NOTA = LSAME(TRANSA,'N')
      NOTB = LSAME(TRANSB,'N')
      IF (NOTA) THEN
         NROWA = M
         NCOLA = K
      ELSE
         NROWA = K
         NCOLA = M
      END IF
      IF (NOTB) THEN
         NROWB = K
      ELSE
         NROWB = N
      END IF
C
C     Test the input parameters.
C
      INFO = 0
      IF (( .NOT. NOTA) .AND. ( .NOT. LSAME(TRANSA,'C'))
     *    .AND. ( .NOT. LSAME(TRANSA,'T'))) THEN
         INFO = 1
      ELSE IF (( .NOT. NOTB) .AND. ( .NOT. LSAME(TRANSB,'C'))
     *         .AND. ( .NOT. LSAME(TRANSB,'T'))) THEN
         INFO = 2
      ELSE IF (M.LT.0) THEN
         INFO = 3
      ELSE IF (N.LT.0) THEN
         INFO = 4
      ELSE IF (K.LT.0) THEN
         INFO = 5
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
         INFO = 8
      ELSE IF (LDB.LT.MAX(1,NROWB)) THEN
         INFO = 10
      ELSE IF (LDC.LT.MAX(1,M)) THEN
         INFO = 13
      END IF
      IF (INFO.NE.0) THEN
         CALL XERBLA('DGEMM ',INFO)
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR. (((ALPHA.EQ.ZERO) .OR. (K.EQ.0))
     *     .AND. (BETA.EQ.ONE))) RETURN
      IF (BETA.EQ.ZERO) THEN
         DO 40 J = 1, N
            DO 20 I = 1, M
               C(I,J) = ZERO
   20       CONTINUE
   40    CONTINUE
      ELSE
         DO 80 J = 1, N
            DO 60 I = 1, M
               C(I,J) = BETA*C(I,J)
   60       CONTINUE
   80    CONTINUE
      END IF
C
C     And if  alpha.eq.zero.
C
      IF (ALPHA.EQ.ZERO) RETURN
C
C     Start the operations.
C
      IF (NOTB) THEN
         IF (NOTA) THEN
C
C           Form  C := C + alpha*A*B.
C
            DO 380 L = 1, K, KB
               LSPAN = MIN(KB,K-L+1)
               DO 360 I = 1, M, MB
                  IDEPTH = 2
                  ISPAN = MIN(MB,M-I+1)
                  ILEN = IDEPTH*(ISPAN/IDEPTH)
                  DO 120 II = I, I + ISPAN - 1
                     DO 100 LL = L, L + LSPAN - 1
                        CH(LL-L+1,II-I+1) = ALPHA*A(II,LL)
  100                CONTINUE
  120             CONTINUE
                  DO 340 J = 1, N, NB
                     JDEPTH = 2
                     JSPAN = MIN(NB,N-J+1)
                     JLEN = JDEPTH*(JSPAN/JDEPTH)
                     DO 220 JJ = J, J + JLEN - 1, JDEPTH
                        DO 160 II = I, I + ILEN - 1, IDEPTH
                           T11 = ZERO
                           T21 = ZERO
                           T12 = ZERO
                           T22 = ZERO
                           DO 140 LL = L, L + LSPAN - 1
                              T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,JJ)
                              T21 = T21 + CH(LL-L+1,II-I+2)*B(LL,JJ)
                              T12 = T12 + CH(LL-L+1,II-I+1)*B(LL,JJ+1)
                              T22 = T22 + CH(LL-L+1,II-I+2)*B(LL,JJ+1)
  140                      CONTINUE
                           C(II,JJ) = C(II,JJ) + T11
                           C(II+1,JJ) = C(II+1,JJ) + T21
                           C(II,JJ+1) = C(II,JJ+1) + T12
                           C(II+1,JJ+1) = C(II+1,JJ+1) + T22
  160                   CONTINUE
                        IF (ILEN.LT.ISPAN) THEN
                           DO 200 II = I + ILEN, I + ISPAN - 1
                              T11 = ZERO
                              T12 = ZERO
                              DO 180 LL = L, L + LSPAN - 1
                                 T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,JJ)
                                 T12 = T12 + CH(LL-L+1,II-I+1)*B(LL,
     *                                 JJ+1)
  180                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II,JJ+1) = C(II,JJ+1) + T12
  200                      CONTINUE
                        END IF
  220                CONTINUE
                     IF (JLEN.LT.JSPAN) THEN
                        DO 320 JJ = J + JLEN, J + JSPAN - 1
                           DO 260 II = I, I + ILEN - 1, IDEPTH
                              T11 = ZERO
                              T21 = ZERO
                              DO 240 LL = L, L + LSPAN - 1
                                 T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,JJ)
                                 T21 = T21 + CH(LL-L+1,II-I+2)*B(LL,JJ)
  240                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II+1,JJ) = C(II+1,JJ) + T21
  260                      CONTINUE
                           IF (ILEN.LT.ISPAN) THEN
                              DO 300 II = I + ILEN, I + ISPAN - 1
                                 T11 = ZERO
                                 DO 280 LL = L, L + LSPAN - 1
                                    T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,
     *                                    JJ)
  280                            CONTINUE
                                 C(II,JJ) = C(II,JJ) + T11
  300                         CONTINUE
                           END IF
  320                   CONTINUE
                     END IF
  340             CONTINUE
  360          CONTINUE
  380       CONTINUE
         ELSE
C
C           Form  C := C + alpha*A'*B
C
            DO 680 I = 1, M, MB
               IDEPTH = 2
               ISPAN = MIN(MB,M-I+1)
               ILEN = IDEPTH*(ISPAN/IDEPTH)
               DO 660 L = 1, K, KB
                  LSPAN = MIN(KB,K-L+1)
                  DO 420 II = I, I + ISPAN - 1
                     DO 400 LL = L, L + LSPAN - 1
                        CH(LL-L+1,II-I+1) = ALPHA*A(LL,II)
  400                CONTINUE
  420             CONTINUE
                  DO 640 J = 1, N, NB
                     JDEPTH = 2
                     JSPAN = MIN(NB,N-J+1)
                     JLEN = JDEPTH*(JSPAN/JDEPTH)
                     DO 520 JJ = J, J + JLEN - 1, JDEPTH
                        DO 460 II = I, I + ILEN - 1, IDEPTH
                           T11 = ZERO
                           T21 = ZERO
                           T12 = ZERO
                           T22 = ZERO
                           DO 440 LL = L, L + LSPAN - 1
                              T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,JJ)
                              T21 = T21 + CH(LL-L+1,II-I+2)*B(LL,JJ)
                              T12 = T12 + CH(LL-L+1,II-I+1)*B(LL,JJ+1)
                              T22 = T22 + CH(LL-L+1,II-I+2)*B(LL,JJ+1)
  440                      CONTINUE
                           C(II,JJ) = C(II,JJ) + T11
                           C(II+1,JJ) = C(II+1,JJ) + T21
                           C(II,JJ+1) = C(II,JJ+1) + T12
                           C(II+1,JJ+1) = C(II+1,JJ+1) + T22
  460                   CONTINUE
                        IF (ILEN.LT.ISPAN) THEN
                           DO 500 II = I + ILEN, I + ISPAN - 1
                              T11 = ZERO
                              T12 = ZERO
                              DO 480 LL = L, L + LSPAN - 1
                                 T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,JJ)
                                 T12 = T12 + CH(LL-L+1,II-I+1)*B(LL,
     *                                 JJ+1)
  480                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II,JJ+1) = C(II,JJ+1) + T12
  500                      CONTINUE
                        END IF
  520                CONTINUE
                     IF (JLEN.LT.JSPAN) THEN
                        DO 620 JJ = J + JLEN, J + JSPAN - 1
                           DO 560 II = I, I + ILEN - 1, IDEPTH
                              T11 = ZERO
                              T21 = ZERO
                              DO 540 LL = L, L + LSPAN - 1
                                 T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,JJ)
                                 T21 = T21 + CH(LL-L+1,II-I+2)*B(LL,JJ)
  540                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II+1,JJ) = C(II+1,JJ) + T21
  560                      CONTINUE
                           IF (ILEN.LT.ISPAN) THEN
                              DO 600 II = I + ILEN, I + ISPAN - 1
                                 T11 = ZERO
                                 DO 580 LL = L, L + LSPAN - 1
                                    T11 = T11 + CH(LL-L+1,II-I+1)*B(LL,
     *                                    JJ)
  580                            CONTINUE
                                 C(II,JJ) = C(II,JJ) + T11
  600                         CONTINUE
                           END IF
  620                   CONTINUE
                     END IF
  640             CONTINUE
  660          CONTINUE
  680       CONTINUE
         END IF
      ELSE
         IF (NOTA) THEN
C
C           Form  C := C + alpha*A*B'
C
            DO 1000 J = 1, N, NB
               JDEPTH = 2
               JSPAN = MIN(NB,N-J+1)
               JLEN = JDEPTH*(JSPAN/JDEPTH)
               DO 980 L = 1, K, KB
                  LSPAN = MIN(KB,K-L+1)
                  DO 720 JJ = J, J + JSPAN - 1
                     DO 700 LL = L, L + LSPAN - 1
                        CH(LL-L+1,JJ-J+1) = ALPHA*B(JJ,LL)
  700                CONTINUE
  720             CONTINUE
                  DO 960 I = 1, M, MB
                     IDEPTH = 2
                     ISPAN = MIN(MB,M-I+1)
                     ILEN = IDEPTH*(ISPAN/IDEPTH)
                     DO 840 II = I, I + ILEN - 1, IDEPTH
                        DO 740 LL = L, L + LSPAN - 1
                           CH1(LL-L+1) = A(II,LL)
                           CH2(LL-L+1) = A(II+1,LL)
  740                   CONTINUE
                        DO 780 JJ = J, J + JLEN - 1, JDEPTH
                           T11 = ZERO
                           T21 = ZERO
                           T12 = ZERO
                           T22 = ZERO
                           DO 760 LL = L, L + LSPAN - 1
                              T11 = T11 + CH1(LL-L+1)*CH(LL-L+1,JJ-J+1)
                              T21 = T21 + CH2(LL-L+1)*CH(LL-L+1,JJ-J+1)
                              T12 = T12 + CH1(LL-L+1)*CH(LL-L+1,JJ-J+2)
                              T22 = T22 + CH2(LL-L+1)*CH(LL-L+1,JJ-J+2)
  760                      CONTINUE
                           C(II,JJ) = C(II,JJ) + T11
                           C(II+1,JJ) = C(II+1,JJ) + T21
                           C(II,JJ+1) = C(II,JJ+1) + T12
                           C(II+1,JJ+1) = C(II+1,JJ+1) + T22
  780                   CONTINUE
                        IF (JLEN.LT.JSPAN) THEN
                           DO 820 JJ = J + JLEN, J + JSPAN - 1
                              T11 = ZERO
                              T21 = ZERO
                              DO 800 LL = L, L + LSPAN - 1
                                 T11 = T11 + A(II,LL)*CH(LL-L+1,JJ-J+1)
                                 T21 = T21 + A(II+1,LL)*CH(LL-L+1,
     *                                 JJ-J+1)
  800                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II+1,JJ) = C(II+1,JJ) + T21
  820                      CONTINUE
                        END IF
  840                CONTINUE
                     IF (ILEN.LT.ISPAN) THEN
                        DO 940 II = I + ILEN, I + ISPAN - 1
                           DO 880 JJ = J, J + JLEN - 1, JDEPTH
                              T11 = ZERO
                              T12 = ZERO
                              DO 860 LL = L, L + LSPAN - 1
                                 T11 = T11 + A(II,LL)*CH(LL-L+1,JJ-J+1)
                                 T12 = T12 + A(II,LL)*CH(LL-L+1,JJ-J+2)
  860                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II,JJ+1) = C(II,JJ+1) + T12
  880                      CONTINUE
                           IF (JLEN.LT.JSPAN) THEN
                              DO 920 JJ = J + JLEN, J + JSPAN - 1
                                 T11 = ZERO
                                 DO 900 LL = L, L + LSPAN - 1
                                    T11 = T11 + A(II,LL)*CH(LL-L+1,
     *                                    JJ-J+1)
  900                            CONTINUE
                                 C(II,JJ) = C(II,JJ) + T11
  920                         CONTINUE
                           END IF
  940                   CONTINUE
                     END IF
  960             CONTINUE
  980          CONTINUE
 1000       CONTINUE
         ELSE
C
C           Form  C := C + alpha*A'*B'
C
            DO 1300 J = 1, N, NB
               JDEPTH = 2
               JSPAN = MIN(NB,N-J+1)
               JLEN = JDEPTH*(JSPAN/JDEPTH)
               DO 1280 L = 1, K, KB
                  LSPAN = MIN(KB,K-L+1)
                  DO 1040 JJ = J, J + JSPAN - 1
                     DO 1020 LL = L, L + LSPAN - 1
                        CH(LL-L+1,JJ-J+1) = ALPHA*B(JJ,LL)
 1020                CONTINUE
 1040             CONTINUE
                  DO 1260 I = 1, M, MB
                     IDEPTH = 2
                     ISPAN = MIN(MB,M-I+1)
                     ILEN = IDEPTH*(ISPAN/IDEPTH)
                     DO 1140 II = I, I + ILEN - 1, IDEPTH
                        DO 1080 JJ = J, J + JLEN - 1, JDEPTH
                           T11 = ZERO
                           T21 = ZERO
                           T12 = ZERO
                           T22 = ZERO
                           DO 1060 LL = L, L + LSPAN - 1
                              T11 = T11 + A(LL,II)*CH(LL-L+1,JJ-J+1)
                              T21 = T21 + A(LL,II+1)*CH(LL-L+1,JJ-J+1)
                              T12 = T12 + A(LL,II)*CH(LL-L+1,JJ-J+2)
                              T22 = T22 + A(LL,II+1)*CH(LL-L+1,JJ-J+2)
 1060                      CONTINUE
                           C(II,JJ) = C(II,JJ) + T11
                           C(II+1,JJ) = C(II+1,JJ) + T21
                           C(II,JJ+1) = C(II,JJ+1) + T12
                           C(II+1,JJ+1) = C(II+1,JJ+1) + T22
 1080                   CONTINUE
                        IF (JLEN.LT.JSPAN) THEN
                           DO 1120 JJ = J + JLEN, J + JSPAN - 1
                              T11 = ZERO
                              T21 = ZERO
                              DO 1100 LL = L, L + LSPAN - 1
                                 T11 = T11 + A(LL,II)*CH(LL-L+1,JJ-J+1)
                                 T21 = T21 + A(LL,II+1)*CH(LL-L+1,
     *                                 JJ-J+1)
 1100                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II+1,JJ) = C(II+1,JJ) + T21
 1120                      CONTINUE
                        END IF
 1140                CONTINUE
                     IF (ILEN.LT.ISPAN) THEN
                        DO 1240 II = I + ILEN, I + ISPAN - 1
                           DO 1180 JJ = J, J + JLEN - 1, JDEPTH
                              T11 = ZERO
                              T12 = ZERO
                              DO 1160 LL = L, L + LSPAN - 1
                                 T11 = T11 + A(LL,II)*CH(LL-L+1,JJ-J+1)
                                 T12 = T12 + A(LL,II)*CH(LL-L+1,JJ-J+2)
 1160                         CONTINUE
                              C(II,JJ) = C(II,JJ) + T11
                              C(II,JJ+1) = C(II,JJ+1) + T12
 1180                      CONTINUE
                           IF (JLEN.LT.JSPAN) THEN
                              DO 1220 JJ = J + JLEN, J + JSPAN - 1
                                 T11 = ZERO
                                 DO 1200 LL = L, L + LSPAN - 1
                                    T11 = T11 + A(LL,II)*CH(LL-L+1,
     *                                    JJ-J+1)
 1200                            CONTINUE
                                 C(II,JJ) = C(II,JJ) + T11
 1220                         CONTINUE
                           END IF
 1240                   CONTINUE
                     END IF
 1260             CONTINUE
 1280          CONTINUE
 1300       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of DGEMM .
C
      END

      SUBROUTINE ccsdt_lr_alpha1(d_i0,d_o1,d_t1,d_t2,d_t3,d_tr1,d_tr2,d_
     &tr3,d_y1,d_y2,d_y3,k_i0_offset,k_o1_offset,k_t1_offset,k_t2_offset
     &,k_t3_offset,k_tr1_offset,k_tr2_offset,k_tr3_offset,k_y1_offset,k_
     &y2_offset,k_y3_offset)
C     $Id: ccsdt_lr_alpha1.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_tro + = 1 * Sum ( p10 h11 ) * o ( h11 p10 )_o * i1 ( p10 h11 )_tr
C         i1 ( p10 h11 )_tr + = 1 * tr ( p10 h11 )_tr
C         i1 ( p10 h11 )_ytr + = 1 * Sum ( h4 p3 ) * tr ( p3 p10 h4 h11 )_tr * y ( h4 p3 )_y
C         i1 ( p10 h11 )_ytr + = 1/4 * Sum ( h5 h6 p3 p4 ) * tr ( p3 p4 p10 h5 h6 h11 )_tr * y ( h5 h6 p3 p4 )_y
C         i1 ( p10 h11 )_yttr + = -1 * Sum ( h2 ) * tr ( p10 h2 )_tr * i2 ( h2 h11 )_yt
C             i2 ( h2 h11 )_yt + = 1 * Sum ( p3 ) * t ( p3 h11 )_t * y ( h2 p3 )_y
C             i2 ( h2 h11 )_yt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h5 h11 )_t * y ( h2 h5 p3 p4 )_y
C             i2 ( h2 h11 )_yt + = 1/12 * Sum ( h6 h7 p3 p4 p5 ) * t ( p3 p4 p5 h6 h7 h11 )_t * y ( h2 h6 h7 p3 p4 p5 )_y
C         i1 ( p10 h11 )_ytrt + = 1/2 * Sum ( h8 ) * t ( p10 h8 )_t * i2 ( h8 h11 )_ytr
C             i2 ( h8 h11 )_ytr + = -1 * Sum ( h5 p3 p4 ) * tr ( p3 p4 h5 h11 )_tr * y ( h5 h8 p3 p4 )_y
C             i2 ( h8 h11 )_ytr + = -1/6 * Sum ( h6 h7 p3 p4 p5 ) * tr ( p3 p4 p5 h6 h7 h11 )_tr * y ( h6 h7 h8 p3 p4 p5 )_y
C             i2 ( h8 h11 )_ytr + = -2 * Sum ( p3 ) * tr ( p3 h11 )_tr * y ( h8 p3 )_y
C         i1 ( p10 h11 )_yttr + = 1/2 * Sum ( h1 h3 p2 ) * tr ( p2 p10 h1 h3 )_tr * i2 ( h1 h3 h11 p2 )_yt
C             i2 ( h1 h3 h11 p2 )_yt + = -1 * Sum ( p6 ) * t ( p6 h11 )_t * y ( h1 h3 p2 p6 )_y
C             i2 ( h1 h3 h11 p2 )_yt + = 1/2 * Sum ( h7 p5 p6 ) * t ( p5 p6 h7 h11 )_t * y ( h1 h3 h7 p2 p5 p6 )_y
C         i1 ( p10 h11 )_yttr + = -1/12 * Sum ( h5 h6 h7 p3 p4 ) * tr ( p3 p4 p10 h5 h6 h7 )_tr * i2 ( h5 h6 h7 h11 p3 p4 )_yt
C             i2 ( h5 h6 h7 h11 p3 p4 )_yt + = 1 * Sum ( p8 ) * t ( p8 h11 )_t * y ( h5 h6 h7 p3 p4 p8 )_y
C         i1 ( p10 h11 )_ytrt + = 1/2 * Sum ( h1 h3 p2 ) * t ( p2 p10 h1 h3 )_t * i2 ( h1 h3 h11 p2 )_ytr
C             i2 ( h1 h3 h11 p2 )_ytr + = -1 * Sum ( p6 ) * tr ( p6 h11 )_tr * y ( h1 h3 p2 p6 )_y
C             i2 ( h1 h3 h11 p2 )_ytr + = 1/2 * Sum ( h7 p5 p6 ) * tr ( p5 p6 h7 h11 )_tr * y ( h1 h3 h7 p2 p5 p6 )_y
C         i1 ( p10 h11 )_ytrt + = -1/12 * Sum ( h5 h6 h7 p3 p4 ) * t ( p3 p4 p10 h5 h6 h7 )_t * i2 ( h5 h6 h7 h11 p3 p4 )_ytr
C             i2 ( h5 h6 h7 h11 p3 p4 )_ytr + = 1 * Sum ( p8 ) * tr ( p8 h11 )_tr * y ( h5 h6 h7 p3 p4 p8 )_y
C     i0 ( )_ytro + = -1 * Sum ( h2 h1 ) * o ( h1 h2 )_o * i1 ( h2 h1 )_ytr
C         i1 ( h2 h1 )_ytr + = 1 * Sum ( p3 ) * tr ( p3 h1 )_tr * y ( h2 p3 )_y
C         i1 ( h2 h1 )_ytr + = 1/2 * Sum ( h5 p3 p4 ) * tr ( p3 p4 h1 h5 )_tr * y ( h2 h5 p3 p4 )_y
C         i1 ( h2 h1 )_ytr + = 1/12 * Sum ( h6 h7 p3 p4 p5 ) * tr ( p3 p4 p5 h1 h6 h7 )_tr * y ( h2 h6 h7 p3 p4 p5 )_y
C     i0 ( )_otry + = 1 * Sum ( p1 h3 ) * y ( h3 p1 )_y * i1 ( p1 h3 )_otr
C         i1 ( p1 h3 )_otr + = 1 * Sum ( p2 ) * o ( p1 p2 )_o * tr ( p2 h3 )_tr
C     i0 ( )_ytro + = 1/2 * Sum ( p2 p1 ) * o ( p1 p2 )_o * i1 ( p2 p1 )_ytr
C         i1 ( p2 p1 )_ytr + = 1 * Sum ( h4 h5 p3 ) * tr ( p2 p3 h4 h5 )_tr * y ( h4 h5 p1 p3 )_y
C         i1 ( p2 p1 )_ytr + = 1/6 * Sum ( h5 h6 h7 p3 p4 ) * tr ( p2 p3 p4 h5 h6 h7 )_tr * y ( h5 h6 h7 p1 p3 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_o1
      INTEGER k_o1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER l_i1_offset
      INTEGER d_tr1
      INTEGER k_tr1_offset
      INTEGER size_i1
      INTEGER d_tr2
      INTEGER k_tr2_offset
      INTEGER d_tr3
      INTEGER k_tr3_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_t3
      INTEGER k_t3_offset
      INTEGER l_i2_offset
      INTEGER size_i2
      INTEGER d_y3
      INTEGER k_y3_offset
      CHARACTER*255 filename
#if !defined(CCSDTLR)
      CALL ERRQUIT('CCSDTLR not compiled (ccsdt_lr_alpha1.F)',
     &              0,CAPMIS_ERR)
      RETURN
      END
#else
      CALL OFFSET_ccsdt_lr_alpha1_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lr_alpha1_1_1(d_tr1,k_tr1_offset,d_i1,k_i1_offset)
      CALL ccsdt_lr_alpha1_1_2(d_tr2,k_tr2_offset,d_y1,k_y1_offset,d_i1,
     &k_i1_offset)
      CALL ccsdt_lr_alpha1_1_3(d_tr3,k_tr3_offset,d_y2,k_y2_offset,d_i1,
     &k_i1_offset)
      CALL OFFSET_ccsdt_lr_alpha1_1_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_1_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_4_1(d_t1,k_t1_offset,d_y1,k_y1_offset,d_i2,
     &k_i2_offset)
      CALL ccsdt_lr_alpha1_1_4_2(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i2,
     &k_i2_offset)
      CALL ccsdt_lr_alpha1_1_4_3(d_t3,k_t3_offset,d_y3,k_y3_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_4(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,
     &k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_1_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_1_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_5_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i
     &2,k_i2_offset)
      CALL ccsdt_lr_alpha1_1_5_2(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i
     &2,k_i2_offset)
      CALL ccsdt_lr_alpha1_1_5_3(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i
     &2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_5(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_1_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_1_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_6_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i2,
     &k_i2_offset)
      CALL ccsdt_lr_alpha1_1_6_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_6(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,
     &k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_1_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_1_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_7_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_7(d_tr3,k_tr3_offset,d_i2,k_i2_offset,d_i1,
     &k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_1_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_1_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_8_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i
     &2,k_i2_offset)
      CALL ccsdt_lr_alpha1_1_8_2(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i
     &2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_8(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_1_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_1_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_9_1(d_tr1,k_tr1_offset,d_y3,k_y3_offset,d_i
     &2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha1_1_9(d_t3,k_t3_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha1_1(d_o1,k_o1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lr_alpha1_2_1(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i1,
     &k_i1_offset)
      CALL ccsdt_lr_alpha1_2_2(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,
     &k_i1_offset)
      CALL ccsdt_lr_alpha1_2_3(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i1,
     &k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha1_2(d_o1,k_o1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_3_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lr_alpha1_3_1(d_o1,k_o1_offset,d_tr1,k_tr1_offset,d_i1,
     &k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha1_3(d_y1,k_y1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha1_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha1_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lr_alpha1_4_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,
     &k_i1_offset)
      CALL ccsdt_lr_alpha1_4_2(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i1,
     &k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha1_4(d_o1,k_o1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha1'
     &,-1,MA_ERR)
      RETURN
      END
#endif

      SUBROUTINE TRIDIB(N,EPS1,D,E,E2,LB,UB,M11,M,W,IND,IERR,RV4,RV5)
c
c  njtj
c  ###  Cray conversions
c  ###    1)Switch double precision to real.
c  ###    2)Switch double precision parameter
c  ###      to single precision parameter statement.
c  ###  Cray conversions
c  njtj
C
      INTEGER I,J,K,L,M,N,P,Q,R,S,II,M1,M2,M11,M22,TAG,IERR,ISTURM
      INTEGER IND(M)
      DOUBLE PRECISION D(N),E(N),E2(N),W(M),RV4(N),RV5(N)
      DOUBLE PRECISION U,V,LB,T1,T2,UB,XU,X0,X1,EPS1,MACHEP
Cray      REAL D(N),E(N),E2(N),W(M),RV4(N),RV5(N)
Cray      REAL U,V,LB,T1,T2,UB,XU,X0,X1,EPS1,MACHEP
C
      PARAMETER(ZERO=0.D0,ONE=1.D0,TWO=2.D0,PFIVE=0.5D0)
Cray      PARAMETER(ZERO=0.0,ONE=1.0,TWO=2.0,PFIVE=0.5)
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE BISECT,
C     NUM. MATH. 9, 386-393(1967) BY BARTH, MARTIN, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 249-256(1971).
C
C     THIS SUBROUTINE FINDS THOSE EIGENVALUES OF A TRIDIAGONAL
C     SYMMETRIC MATRIX BETWEEN SPECIFIED BOUNDARY INDICES,
C     USING BISECTION.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        EPS1 IS AN ABSOLUTE ERROR TOLERANCE FOR THE COMPUTED
C          EIGENVALUES.  IF THE INPUT EPS1 IS NON-POSITIVE,
C          IT IS RESET FOR EACH SUBMATRIX TO A DEFAULT VALUE,
C          NAMELY, MINUS THE PRODUCT OF THE RELATIVE MACHINE
C          PRECISION AND THE 1-NORM OF THE SUBMATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY,
C
C        E2 CONTAINS THE SQUARES OF THE CORRESPONDING ELEMENTS OF E.
C          E2(1) IS ARBITRARY,
C
C        M11 SPECIFIES THE LOWER BOUNDARY INDEX FOR THE DESIRED
C          EIGENVALUES,
C
C        M SPECIFIES THE NUMBER OF EIGENVALUES DESIRED.  THE UPPER
C          BOUNDARY INDEX M22 IS THEN OBTAINED AS M22=M11+M-1.
C
C     ON OUTPUT-
C
C        EPS1 IS UNALTERED UNLESS IT HAS BEEN RESET TO ITS
C          (LAST) DEFAULT VALUE,
C
C        D AND E ARE UNALTERED,
C
C        ELEMENTS OF E2, CORRESPONDING TO ELEMENTS OF E REGARDED
C          AS NEGLIGIBLE, HAVE BEEN REPLACED BY ZERO CAUSING THE
C          MATRIX TO SPLIT INTO A DIRECT SUM OF SUBMATRICES.
C          E2(1) IS ALSO SET TO ZERO,
C
C        LB AND UB DEFINE AN INTERVAL CONTAINING EXACTLY THE DESIRED
C          EIGENVALUES,
C
C        W CONTAINS, IN ITS FIRST M POSITIONS, THE EIGENVALUES
C          BETWEEN INDICES M11 AND M22 IN ASCENDING ORDER,
C
C        IND CONTAINS IN ITS FIRST M POSITIONS THE SUBMATRIX INDICES
C          ASSOCIATED WITH THE CORRESPONDING EIGENVALUES IN W --
C          1 FOR EIGENVALUES BELONGING TO THE FIRST SUBMATRIX FROM
C          THE TOP, 2 FOR THOSE BELONGING TO THE SECOND SUBMATRIX, ETC.,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          3*N+1      IF MULTIPLE EIGENVALUES AT INDEX M11 MAKE
C                     UNIQUE SELECTION IMPOSSIBLE,
C          3*N+2      IF MULTIPLE EIGENVALUES AT INDEX M22 MAKE
C                     UNIQUE SELECTION IMPOSSIBLE,
C
C        RV4 AND RV5 ARE TEMPORARY STORAGE ARRAYS.
C
C     NOTE THAT SUBROUTINE TQL1, IMTQL1, OR TQLRAT IS GENERALLY FASTER
C     THAN TRIDIB, IF MORE THAN N/4 EIGENVALUES ARE TO BE FOUND.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C     ********** MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC.
C
C                **********
      MACHEP = TWO**(-40)
C
      IERR = 0
      TAG = 0
      XU = D(1)
      X0 = D(1)
      U = ZERO
C     ********** LOOK FOR SMALL SUB-DIAGONAL ENTRIES AND DETERMINE AN
C                INTERVAL CONTAINING ALL THE EIGENVALUES **********
      DO 40 I = 1, N
         X1 = U
         U = ZERO
         IF (I .NE. N) U = ABS(E(I+1))
         XU = MIN(D(I)-(X1+U),XU)
         X0 = MAX(D(I)+(X1+U),X0)
         IF (I .EQ. 1) GO TO 20
         IF (ABS(E(I)) .GT. MACHEP * (ABS(D(I)) + ABS(D(I-1))))
     X      GO TO 40
   20    E2(I) = ZERO
   40 CONTINUE
C
      X1 = MAX(ABS(XU),ABS(X0)) * MACHEP * REAL(N)
      XU = XU - X1
      T1 = XU
      X0 = X0 + X1
      T2 = X0
C     ********** DETERMINE AN INTERVAL CONTAINING EXACTLY
C                THE DESIRED EIGENVALUES **********
      P = 1
      Q = N
      M1 = M11 - 1
      IF (M1 .EQ. 0) GO TO 75
      ISTURM = 1
   50 V = X1
      X1 = XU + (X0 - XU) * 0.5
      IF (X1 .EQ. V) GO TO 980
      GO TO 320
   60 IF (S - M1) 65, 73, 70
   65 XU = X1
      GO TO 50
   70 X0 = X1
      GO TO 50
   73 XU = X1
      T1 = X1
   75 M22 = M1 + M
      IF (M22 .EQ. N) GO TO 90
      X0 = T2
      ISTURM = 2
      GO TO 50
   80 IF (S - M22) 65, 85, 70
   85 T2 = X1
   90 Q = 0
      R = 0
C     ********** ESTABLISH AND PROCESS NEXT SUBMATRIX, REFINING
C                INTERVAL BY THE GERSCHGORIN BOUNDS **********
  100 IF (R .EQ. M) GO TO 1001
      TAG = TAG + 1
      P = Q + 1
      XU = D(P)
      X0 = D(P)
      U = ZERO
C
      DO 120 Q = P, N
         X1 = U
         U = ZERO
         V = ZERO
         IF (Q .EQ. N) GO TO 110
         U = ABS(E(Q+1))
         V = E2(Q+1)
  110    XU = MIN(D(Q)-(X1+U),XU)
         X0 = MAX(D(Q)+(X1+U),X0)
         IF (V .EQ. 0.0) GO TO 140
  120 CONTINUE
C
  140 X1 = MAX(ABS(XU),ABS(X0)) * MACHEP
      IF (EPS1 .LE. 0.0) EPS1 = -X1
      IF (P .NE. Q) GO TO 180
C     ********** CHECK FOR ISOLATED ROOT WITHIN INTERVAL **********
      IF (T1 .GT. D(P) .OR. D(P) .GE. T2) GO TO 940
      M1 = P
      M2 = P
      RV5(P) = D(P)
      GO TO 900
  180 X1 = X1 * REAL(Q-P+1)
      LB = MAX(T1,XU-X1)
      UB = MIN(T2,X0+X1)
      X1 = LB
      ISTURM = 3
      GO TO 320
  200 M1 = S + 1
      X1 = UB
      ISTURM = 4
      GO TO 320
  220 M2 = S
      IF (M1 .GT. M2) GO TO 940
C     ********** FIND ROOTS BY BISECTION **********
      X0 = UB
      ISTURM = 5
C
      DO 240 I = M1, M2
         RV5(I) = UB
         RV4(I) = LB
  240 CONTINUE
C     ********** LOOP FOR K-TH EIGENVALUE
C                FOR K=M2 STEP -1 UNTIL M1 DO --
C                (-DO- NOT USED TO LEGALIZE -COMPUTED GO TO-) **********
      K = M2
  250    XU = LB
C     ********** FOR I=K STEP -1 UNTIL M1 DO -- **********
         DO 260 II = M1, K
            I = M1 + K - II
            IF (XU .GE. RV4(I)) GO TO 260
            XU = RV4(I)
            GO TO 280
  260    CONTINUE
C
  280    IF (X0 .GT. RV5(K)) X0 = RV5(K)
C     ********** NEXT BISECTION STEP **********
  300    X1 = (XU + X0) * PFIVE
         IF ((X0 - XU) .LE. (TWO * MACHEP *
     X      (ABS(XU) + ABS(X0)) + ABS(EPS1))) GO TO 420
C     ********** IN-LINE PROCEDURE FOR STURM SEQUENCE **********
  320    S = P - 1
         U = ONE
C
         DO 340 I = P, Q
            IF (U .NE. ZERO) GO TO 325
            V = ABS(E(I)) / MACHEP
            IF (E2(I) .EQ. ZERO) V = ZERO
            GO TO 330
  325       V = E2(I) / U
  330       U = D(I) - X1 - V
            IF (U .LT. ZERO) S = S + 1
  340    CONTINUE
C
         GO TO (60,80,200,220,360), ISTURM
C     ********** REFINE INTERVALS **********
  360    IF (S .GE. K) GO TO 400
         XU = X1
         IF (S .GE. M1) GO TO 380
         RV4(M1) = X1
         GO TO 300
  380    RV4(S+1) = X1
         IF (RV5(S) .GT. X1) RV5(S) = X1
         GO TO 300
  400    X0 = X1
         GO TO 300
C     ********** K-TH EIGENVALUE FOUND **********
  420    RV5(K) = X1
      K = K - 1
      IF (K .GE. M1) GO TO 250
C     ********** ORDER EIGENVALUES TAGGED WITH THEIR
C                SUBMATRIX ASSOCIATIONS **********
  900 S = R
      R = R + M2 - M1 + 1
      J = 1
      K = M1
C
      DO 920 L = 1, R
         IF (J .GT. S) GO TO 910
         IF (K .GT. M2) GO TO 940
         IF (RV5(K) .GE. W(L)) GO TO 915
C
         DO 905 II = J, S
            I = L + S - II
            W(I+1) = W(I)
            IND(I+1) = IND(I)
  905    CONTINUE
C
  910    W(L) = RV5(K)
         IND(L) = TAG
         K = K + 1
         GO TO 920
  915    J = J + 1
  920 CONTINUE
C
  940 IF (Q .LT. N) GO TO 100
      GO TO 1001
C     ********** SET ERROR -- INTERVAL CANNOT BE FOUND CONTAINING
C                EXACTLY THE DESIRED EIGENVALUES **********
  980 IERR = 3 * N + ISTURM
 1001 LB = T1
      UB = T2
      RETURN
C     ********** LAST CARD OF TRIDIB **********
      END
c $Id: tridib.f 21413 2011-11-05 06:53:49Z d3y133 $

*> \brief \b SLAUUM computes the product UUH or LHL, where U and L are upper or lower triangular matrices (blocked algorithm).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SLAUUM + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/slauum.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/slauum.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/slauum.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SLAUUM( UPLO, N, A, LDA, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SLAUUM computes the product U * U**T or L**T * L, where the triangular
*> factor U or L is stored in the upper or lower triangular part of
*> the array A.
*>
*> If UPLO = 'U' or 'u' then the upper triangle of the result is stored,
*> overwriting the factor U in A.
*> If UPLO = 'L' or 'l' then the lower triangle of the result is stored,
*> overwriting the factor L in A.
*>
*> This is the blocked form of the algorithm, calling Level 3 BLAS.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          Specifies whether the triangular factor stored in the array A
*>          is upper or lower triangular:
*>          = 'U':  Upper triangular
*>          = 'L':  Lower triangular
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the triangular factor U or L.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the triangular factor U or L.
*>          On exit, if UPLO = 'U', the upper triangle of A is
*>          overwritten with the upper triangle of the product U * U**T;
*>          if UPLO = 'L', the lower triangle of A is overwritten with
*>          the lower triangle of the product L**T * L.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -k, the k-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup realOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE SLAUUM( UPLO, N, A, LDA, INFO )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, IB, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM, SLAUU2, SSYRK, STRMM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SLAUUM', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'SLAUUM', UPLO, N, -1, -1, -1 )
*
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code
*
         CALL SLAUU2( UPLO, N, A, LDA, INFO )
      ELSE
*
*        Use blocked code
*
         IF( UPPER ) THEN
*
*           Compute the product U * U**T.
*
            DO 10 I = 1, N, NB
               IB = MIN( NB, N-I+1 )
               CALL STRMM( 'Right', 'Upper', 'Transpose', 'Non-unit',
     $                     I-1, IB, ONE, A( I, I ), LDA, A( 1, I ),
     $                     LDA )
               CALL SLAUU2( 'Upper', IB, A( I, I ), LDA, INFO )
               IF( I+IB.LE.N ) THEN
                  CALL SGEMM( 'No transpose', 'Transpose', I-1, IB,
     $                        N-I-IB+1, ONE, A( 1, I+IB ), LDA,
     $                        A( I, I+IB ), LDA, ONE, A( 1, I ), LDA )
                  CALL SSYRK( 'Upper', 'No transpose', IB, N-I-IB+1,
     $                        ONE, A( I, I+IB ), LDA, ONE, A( I, I ),
     $                        LDA )
               END IF
   10       CONTINUE
         ELSE
*
*           Compute the product L**T * L.
*
            DO 20 I = 1, N, NB
               IB = MIN( NB, N-I+1 )
               CALL STRMM( 'Left', 'Lower', 'Transpose', 'Non-unit', IB,
     $                     I-1, ONE, A( I, I ), LDA, A( I, 1 ), LDA )
               CALL SLAUU2( 'Lower', IB, A( I, I ), LDA, INFO )
               IF( I+IB.LE.N ) THEN
                  CALL SGEMM( 'Transpose', 'No transpose', IB, I-1,
     $                        N-I-IB+1, ONE, A( I+IB, I ), LDA,
     $                        A( I+IB, 1 ), LDA, ONE, A( I, 1 ), LDA )
                  CALL SSYRK( 'Lower', 'Transpose', IB, N-I-IB+1, ONE,
     $                        A( I+IB, I ), LDA, ONE, A( I, I ), LDA )
               END IF
   20       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of SLAUUM
*
      END
c $Id: slauum.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine tce_ccsd_hyperpolar(beta,
     &  respaxis,irrep_d1,d_d1,k_d1_offset,
     &  d_f1,k_f1_offset,d_v2,k_v2_offset,
     &  d_t1,k_t1_offset,d_t2,k_t2_offset,
     &  d_y1,k_y1_offset,d_y2,k_y2_offset,
     &  d_tr1,k_tr1_offset,d_tr2,k_tr2_offset,
     &  d_yr1,k_yr1_offset,d_yr2,k_yr2_offset)
c
c $Id: tce_ccsd_hyperpolar_static.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "sf.fh"
#include "inp.fh"
#include "errquit.fh"
#include "tce.fh"
c#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
c#include "tce_amps.fh"
c#include "tce_diis.fh"
c
c     CI, CC, & MBPT
c
      integer iter,maxiter
      integer irrep_g,irrep_d1(3)
      integer axisA,axisB,axisC
c      integer d_b0              ! Dipole polarizability component handle
c      integer l_b0_offset       ! Offset for b0 file
c      integer k_b0_offset       ! Offset for b0 file
c      integer size_b0           ! File size in doubles
      integer d_d1(3)           ! MO dipole integral file
      integer k_d1_offset(3)    ! Offset for d1 integral file
      integer d_yr1(12)             ! SF handle for yr1 amplitudes
      integer k_yr1_offset(3)      ! Offset for yr1 file
      integer d_yr2(12)             ! SF handle for yr2 amplitudes
      integer k_yr2_offset(3)      ! Offset for yr2 file
      integer d_tr1(12)             ! SF handle for tr1 amplitudes
      integer k_tr1_offset(3)      ! Offset for tr1 file
      integer d_tr2(12)             ! SF handle for tr2 amplitudes
      integer k_tr2_offset(3)      ! Offset for tr2 file
      integer d_f1             ! SF handle for MO 1e integrals
      integer k_f1_offset      ! Offset for 1e integral file
      integer d_v2             ! SF handle for MO 2e integrals
      integer k_v2_offset      ! Offset for 2e integral file
      integer d_t1             ! SF handle for t1 amplitudes
      integer k_t1_offset      ! Offset for t1 file
      integer d_t2             ! SF handle for t2 amplitudes
      integer k_t2_offset      ! Offset for t2 file
      integer d_y1             ! Lambda 1 file
      integer k_y1_offset      ! Offset for Lambda 1 file
      integer d_y2             ! Lambda 2 file
      integer k_y2_offset      ! Offset for Lambda 2 file
      logical nodezero,respaxis(3)
      double precision cpu,wall
      double precision omega,ptol
      double precision beta(3,3,3)
      double precision beta0,beta1,beta2,beta3,beta4!,beta5,beta6
      external ddotfile
      character*255 filename
      character*20 title
      character*4 irrepname
      nodezero=(ga_nodeid().eq.0)
      cpu=-util_cpusec()
      wall=-util_wallsec()
      irrep_g=0
c
      do axisA = 1, 3
        do axisB = 1, 3
          do axisC = 1, 3
            beta(axisA,axisB,axisC)=0.0d0
          enddo
        enddo
      enddo
c
      do axisA = 1, 3
        irrep_a=irrep_d1(axisA)
        do axisB = 1, 3
          irrep_b=irrep_d1(axisB)
          do axisC = 1, 3
            irrep_c=irrep_d1(axisC)
            if ( ( respaxis(axisA).and.respaxis(axisB) )
     &                            .and.respaxis(axisC) ) then
c
              call tce_ccsd_hyperpolar_eval(beta1,beta2,beta3,beta4,
     1             d_d1(axisA),k_d1_offset(axisA),
     2             d_d1(axisB),k_d1_offset(axisB),d_f1,k_f1_offset,
     3             d_v2,k_v2_offset,d_t1,k_t1_offset,d_t2,k_t2_offset,
     4             d_y1,k_y1_offset,d_y2,k_y2_offset,
     5             d_tr1(axisA),k_tr1_offset(axisA),
     6             d_tr2(axisA),k_tr2_offset(axisA),
     7             d_tr1(axisB),k_tr1_offset(axisB),
     8             d_tr2(axisB),k_tr2_offset(axisB),
     9             d_tr1(axisC),k_tr1_offset(axisC),
     1             d_tr2(axisC),k_tr2_offset(axisC),
     2             d_yr1(axisA),k_yr1_offset(axisA),
     3             d_yr2(axisA),k_yr2_offset(axisA))
c
! #if defined(DEBUG_PRINT)
         ptol = 1e-10
         if (dabs(beta1).gt.ptol) then
         if (dabs(beta2).gt.ptol) then
         if (dabs(beta3).gt.ptol) then
         if (dabs(beta4).gt.ptol) then
                write(LuOut,*) "axisA = ",axisA
                write(LuOut,*) "axisB = ",axisB
                write(LuOut,*) "axisC = ",axisC
                write(LuOut,*) "beta1 = ",beta1
                write(LuOut,*) "beta2 = ",beta2
                write(LuOut,*) "beta3 = ",beta3
                write(LuOut,*) "beta4 = ",beta4
         endif
         endif
         endif
         endif
! #endif
c
c             This term contributes to only one component
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta1
c
c             These terms both contribute to three components
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta2
              beta(axisB,axisC,axisA)=beta(axisB,axisC,axisA)-beta2
              beta(axisC,axisA,axisB)=beta(axisC,axisA,axisB)-beta2
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta3
              beta(axisB,axisC,axisA)=beta(axisB,axisC,axisA)-beta3
              beta(axisC,axisA,axisB)=beta(axisC,axisA,axisB)-beta3
c
c             This term contributes to six components
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta4
              beta(axisA,axisC,axisB)=beta(axisA,axisC,axisB)-beta4
              beta(axisB,axisA,axisC)=beta(axisB,axisA,axisC)-beta4
              beta(axisB,axisC,axisA)=beta(axisB,axisC,axisA)-beta4
              beta(axisC,axisA,axisB)=beta(axisC,axisA,axisB)-beta4
              beta(axisC,axisB,axisA)=beta(axisC,axisB,axisA)-beta4
c
            endif ! respaxis(axisA,axisB,axisC)
          enddo ! axisB loop
        enddo ! axisB loop
      enddo ! axisA loop
c
      cpu=cpu+util_cpusec()
      wall=wall+util_wallsec()
      if (nodezero) write(LuOut,9020) cpu, wall
      return
c
c     ======
c     Format
c     ======
c
 9000 format(1x,A,' file size   = ',i16)
 9010 format(1x,A,' file name   = ',A)
 9090 format(1x,A,' file handle = ',i10)
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9480 format(1x,'Cpu & wall time / sec for ',A,2f15.1)
      end
c
      subroutine tce_ccsd_hyperpolar_eval(beta1,beta2,beta3,beta4,
     &  d_a1,k_a1_offset,d_b1,k_b1_offset,d_f1,k_f1_offset,
     &  d_v2,k_v2_offset,d_t1,k_t1_offset,d_t2,k_t2_offset,
     &  d_y1,k_y1_offset,d_y2,k_y2_offset,
     &  d_tr1a,k_tr1a_offset,d_tr2a,k_tr2a_offset,
     &  d_tr1b,k_tr1b_offset,d_tr2b,k_tr2b_offset,
     &  d_tr1c,k_tr1c_offset,d_tr2c,k_tr2c_offset,
     &  d_yr1a,k_yr1a_offset,d_yr2a,k_yr2a_offset)
c
c $Id: tce_ccsd_hyperpolar_static.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c Written by Jeff Hammond, February 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "sf.fh"
#include "inp.fh"
#include "errquit.fh"
#include "tce.fh"
c#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
c#include "tce_amps.fh"
c#include "tce_diis.fh"
c
c     CI, CC, & MBPT
c
      integer iter,maxiter
      integer irrep_g
      integer d_b0              ! Hyperpolarizability component handle
      integer l_b0_offset       ! Offset for b0 file
      integer k_b0_offset       ! Offset for b0 file
      integer size_b0           ! File size in doubles
      integer d_a1              ! SF handle for dipole integrals
      integer k_a1_offset       ! Offset for dipole integral file
      integer d_b1              ! SF handle for dipole integrals
      integer k_b1_offset       ! Offset for dipole integral file
      integer d_yr1a            ! SF handle for yr1 amplitudes
      integer k_yr1a_offset     ! Offset for yr1 file
      integer d_yr2a            ! SF handle for yr2 amplitudes
      integer k_yr2a_offset     ! Offset for yr2 file
      integer d_tr1a,d_tr1b,d_tr1c
      integer k_tr1a_offset,k_tr1b_offset,k_tr1c_offset
      integer d_tr2a,d_tr2b,d_tr2c
      integer k_tr2a_offset,k_tr2b_offset,k_tr2c_offset
      integer d_f1              ! SF handle for MO 1e integrals
      integer k_f1_offset       ! Offset for 1e integral file
      integer d_v2              ! SF handle for MO 2e integrals
      integer k_v2_offset       ! Offset for 2e integral file
      integer d_t1              ! SF handle for t1 amplitudes
      integer k_t1_offset       ! Offset for t1 file
      integer d_t2              ! SF handle for t2 amplitudes
      integer k_t2_offset       ! Offset for t2 file
      integer d_y1              ! Lambda 1 file
      integer k_y1_offset       ! Offset for Lambda 1 file
      integer d_y2              ! Lambda 2 file
      integer k_y2_offset       ! Offset for Lambda 2 file
      logical nodezero
      double precision cpu
      double precision wall
      double precision omega
      double precision beta0,beta1,beta2,beta3,beta4
      external ddotfile
      character*255 filename
      character*20 title
      character*4 irrepname
      nodezero=(ga_nodeid().eq.0)
c
      call tce_e_offset(l_b0_offset,k_b0_offset,size_b0)
#if defined(DEBUG_PRINT)
        if(nodezero) write(LuOut,*) 'l_b0_offset = ',l_b0_offset
#endif
      call tce_filename('b0',filename)
      call createfile(filename,d_b0,size_b0)
c
      beta1=0.0d0
      beta2=0.0d0
      beta3=0.0d0
      beta4=0.0d0
c
      irrep_g=0
c
      irrep_y=irrep_g
      irrep_tra=irrep_a
      irrep_trb=irrep_b
      irrep_trc=irrep_c
#if defined(DEBUG_PRINT)
      write(LuOut,*) "beta_1"
#endif
      call beta_1(d_b0,d_t1,d_tr1a,d_tr2a,
     1     d_tr1b,d_tr2b,d_tr1c,d_tr2c,
     2     d_v2,d_y1,d_y2,k_b0_offset,k_t1_offset,
     3     k_tr1a_offset,k_tr2a_offset,
     4     k_tr1b_offset,k_tr2b_offset,
     5     k_tr1c_offset,k_tr2c_offset,
     6     k_v2_offset,k_y1_offset,k_y2_offset)
      call reconcilefile(d_b0,size_b0)
      call get_block(d_b0,beta1,1,0)
      call tce_zero(d_b0,size_b0)
c
c
      irrep_y=irrep_g
      irrep_d=irrep_a
      irrep_tra=irrep_b
      irrep_trb=irrep_c
#if defined(DEBUG_PRINT)
      write(LuOut,*) "beta_2"
#endif
      call beta_2(d_a1,d_b0,d_tr1b,d_tr2b, d_tr1c,d_tr2c,d_y1,d_y2,
     1     k_a1_offset,k_b0_offset,k_tr1b_offset,k_tr2b_offset,
     2     k_tr1c_offset,k_tr2c_offset,k_y1_offset,k_y2_offset)
      call reconcilefile(d_b0,size_b0)
      call get_block(d_b0,beta2,1,0)
      call tce_zero(d_b0,size_b0)
c
      irrep_y=irrep_a
      irrep_tra=irrep_b
      irrep_trb=irrep_c
#if defined(DEBUG_PRINT)
      write(LuOut,*) "beta_3"
#endif
      call beta_3(d_f1,d_b0,d_t1,d_t2,d_tr1b,d_tr2b,d_tr1c,d_tr2c,d_v2,
     1     d_yr1a,d_yr2a,k_f1_offset,k_b0_offset,k_t1_offset,
     2     k_t2_offset,k_tr1b_offset,k_tr2b_offset,k_tr1c_offset,
     3     k_tr2c_offset,k_v2_offset,k_yr1a_offset,k_yr2a_offset)
      call reconcilefile(d_b0,size_b0)
      call get_block(d_b0,beta3,1,0)
      call tce_zero(d_b0,size_b0)
c
      irrep_y=irrep_a
      irrep_d=irrep_b
      irrep_tr=irrep_c
#if defined(DEBUG_PRINT)
      write(LuOut,*) "beta_4"
#endif
      call beta_4(d_b1,d_b0,d_t1,d_t2,d_tr1c,d_tr2c,d_yr1a,d_yr2a,
     1     k_b1_offset,k_b0_offset,k_t1_offset,k_t2_offset,
     2     k_tr1c_offset,k_tr2c_offset,k_yr1a_offset,k_yr2a_offset)
      call reconcilefile(d_b0,size_b0)
      call get_block(d_b0,beta4,1,0)
c
      call deletefile(d_b0)
      if (.not.ma_pop_stack(l_b0_offset))
     1     call errquit("tce_ccsd_hyperpolar: MA problem",
     2                  l_b0_offset,MA_ERR)
c
      return
      end

*
* $Id: psi_H.F 25803 2014-06-12 21:29:14Z bylaska $
*

*     *************************************
*     *                                   *
*     *             psi_H                 *
*     *                                   *
*     *************************************
*
*  This routine calculates 
*
*       Hpsi_k = KE*psi_k + Vnl*psi_k +VSic*psi_k + FFT[(vall+xcp)*psi_r]
*
*  where vall = iFFT[Vl+Vc] + Vfield
*
*   Entry - ispin,ne            - spin and number of electron in each spin
*           psi_k,psi_r         - orbitals in k-space and r-space
*           vl                  - local psp in k-space
*           v_field,field_exist - external fields (e.g. QM/MM)
*           vc                  - coulomb potential in k-space
*           xcp                 - xc potential in r-space
*           move                - flag to compute ionic forces
*   Exit - Hpsi_k - gradient in k-space
*          fion   - ionic forces
*
      subroutine psi_H(ispin,ne,
     >                 psi_k,psi_r,
     >                 vl,
     >                 v_field,field_exist,
     >                 vc,xcp,Hpsi_k,
     >                 move,fion,
     >                 fractional,occ)
      implicit none
      integer    ispin,ne(2)
      complex*16 psi_k(*)
      real*8     psi_r(*)
      complex*16 vl(*)
      real*8     v_field(*)
      logical    field_exist
      complex*16 vc(*)
      real*8     xcp(*)
      complex*16 Hpsi_k(*)
      logical    move
      real*8     fion(3,*)
      logical fractional
      real*8 occ(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      logical dosic,dohfx,dodftu,meta,tamd,meta_gga
      integer ms,n,n1(2),n2(2)
      integer nx,ny,nz
      real*8  scal1,scal2

*     **** tempory space ****
c     complex*16 vall(nfft3d)
c     complex*16 vpsi(nfft3d)
      integer nfft3d,n2ft3d,npack1,indx1,indx2
      integer vall(2),vpsi(2),Hpsi_r(2)
      logical value,done


*     **** external functions ****
      logical  pspw_SIC,pspw_SIC_relaxed,D3dB_rc_pfft3_queue_filled
      logical  pspw_HFX,pspw_HFX_relaxed,psp_U_psputerm,meta_found
      logical  psp_pawexist,nwpw_meta_gga_on,tamd_found
      real*8   lattice_omega
      external pspw_SIC,pspw_SIC_relaxed,D3dB_rc_pfft3_queue_filled
      external pspw_HFX,pspw_HFX_relaxed,psp_U_psputerm,meta_found
      external psp_pawexist,nwpw_meta_gga_on,tamd_found
      external lattice_omega


      dosic = (pspw_SIC().and.pspw_SIC_relaxed()) 
      dohfx = (pspw_HFX().and.pspw_HFX_relaxed()) 
      dodftu = psp_U_psputerm()
      meta = meta_found()
      tamd = tamd_found()
      meta_gga = nwpw_meta_gga_on()
      call Pack_npack(1,npack1)
      
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      call nwpw_timing_start(12)
      value = MA_push_get(mt_dcpl,nfft3d,'vall',vall(2),vall(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'vpsi',vpsi(2),vpsi(1))
     
      if ((dosic).or.(dohfx)) then
         value = value.and.
     >           MA_push_get(mt_dbl,(ne(1)+ne(2))*n2ft3d,
     >                        'Hpsi_r',Hpsi_r(2),Hpsi_r(1))
         call dcopy((ne(1)+ne(2))*n2ft3d,0.0d0,0,dbl_mb(Hpsi_r(1)),1)
      end if
      if (.not. value) call errquit('psi_H:out of stack memory',0,
     &       MA_ERR)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(vall(1)),1)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(vpsi(1)),1)
      call nwpw_timing_end(12)
      

      scal2 = 1.0d0/lattice_omega()
      scal1 = 1.0d0/dble(nx*ny*nz)
      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)

*     *********************************************************
*     **** add kinetic energy - Hpsi_k = Ke*psi_k ****
*     *********************************************************
      call ke(ispin,ne,psi_k,Hpsi_k)

*     *********************************************************
*     **** add non-local psp - Hpsi_k = Hpsi_k + Vnl*psi_k ****
*     *********************************************************
      if (psp_pawexist()) call psp_set_vc(vc)
      call v_nonlocal(ispin,ne,psi_k,Hpsi_k,move,fion,fractional,occ)



*     *********************************************************
*     **** add DFT+U correction -                             *
*     *********************************************************
      if (dodftu) then
         call psp_U_v_nonlocal(ispin,ne,psi_k,Hpsi_k,move,fion,
     >                         fractional,occ,.true.)
      end if

*     *********************************************************
*     **** add Metadynamics potential                         *
*     *********************************************************
      if (meta) then
         call meta_force(ispin,ne,psi_k,Hpsi_k,move,fion)
      end if

*     *********************************************************
*     **** add TAMD potential                                 *
*     *********************************************************
      if (tamd) then
         call tamd_force(ispin,ne,psi_k,Hpsi_k,move,fion)
      end if

*     **********************************************************************
*     **** add extra Meta GGA terms Hpsi_k += grad dot (dfdtau*gradpsi) ****
*     **********************************************************************
      if (meta_gga) then
         call nwpw_meta_gga_Hpsik(ispin,ne,psi_k,Hpsi_k)
      end if


*     *******************************************************
*     **** SIC corrections- Hpsi_r = Vsic*psi_r ****
*     *******************************************************
      if (dosic) then
         call pspw_potential_SIC(ispin,psi_r,dbl_mb(Hpsi_r(1)))
      end if

*     *******************************************************
*     **** HF exchange corrections- Hpsi_r = Vhfx*psi_r ****
*     *******************************************************
      if (dohfx) then
         call pspw_potential_HFX(ispin,psi_r,dbl_mb(Hpsi_r(1)))
      end if


*     **************************************************************************
*     **** add up k-space potentials, vall = scal2*vl + vc  (+ vcmp if paw) ****
*     **************************************************************************
      call Pack_c_SMul(0,scal2,vl,dcpl_mb(vall(1)))
      call Pack_cc_Sum2(0,vc,dcpl_mb(vall(1)))
      if (psp_pawexist()) call psp_add_vcmp(dcpl_mb(vall(1)))
      
*     **********************************************
*     **** fourier transform k-space potentials ****
*     **********************************************
      call Pack_c_unpack(0,dcpl_mb(vall(1)))
      call D3dB_cr_fft3b(1,dcpl_mb(vall(1)))

*     ******************************
*     **** add v_field to vall  ****
*     ******************************
c      if (field_exist)
c     >  call D3dB_rr_Sum(1,dcpl_mb(vall(1)),v_field,dcpl_mb(vall(1)))
      if (field_exist)
     >  call D3dB_rr_Sum2(1,v_field,dcpl_mb(vall(1)))


*     **************************************************************
*     **** Hpsi_k = Hpsi_k + FFT[vall_r+xcp)*psi_r +Vsic*psi_r] **** 
*     ************************************************************** 
      indx1 = 1
      indx2 = 1
      done  = .false.
      do while (.not.done)
         if (indx1.le.n2(ispin)) then
            ms = 1
            if (indx1.gt.n2(1)) ms = 2

*           **** vpsi_r = (vall_r+xcp)*psi_r + Hpsi_r****
            call D3dB_rr_Sum(1,dcpl_mb(vall(1)),
     >                       xcp(1+(ms-1)*n2ft3d),
     >                       dcpl_mb(vpsi(1)))

c            call D3dB_rr_Mul(1,dcpl_mb(vpsi(1)),
c     >                       psi_r(1+(indx1-1)*n2ft3d),
c     >                       dcpl_mb(vpsi(1)))
            call D3dB_rr_Mul2(1,psi_r(1+(indx1-1)*n2ft3d),
     >                       dcpl_mb(vpsi(1)))

c            if ((dosic).or.(dohfx))
c     >        call D3dB_rr_Sum(1,dcpl_mb(vpsi(1)),
c     >                         dbl_mb(Hpsi_r(1)+(indx1-1)*n2ft3d),
c     >                         dcpl_mb(vpsi(1)))
            if ((dosic).or.(dohfx))
     >        call D3dB_rr_Sum2(1,dbl_mb(Hpsi_r(1)+(indx1-1)*n2ft3d),
     >                            dcpl_mb(vpsi(1)))

*           **** put vpsi_r in k-space ****
            call D3dB_rc_pfft3f_queuein(1,dcpl_mb(vpsi(1)))
            indx1 = indx1 + 1

         end if

         if ((D3dB_rc_pfft3_queue_filled()).or.
     >       (indx1.gt.n2(ispin))) then
            call D3dB_rc_pfft3f_queueout(1,dcpl_mb(vpsi(1)))

*           **** add to Hpsi_k ****
            call Pack_cc_daxpy(1,(-scal1),
     >                           dcpl_mb(vpsi(1)),
     >                           Hpsi_k(1+(indx2-1)*npack1))
            indx2 = indx2 + 1
         end if

         done = ((indx1.gt.n2(ispin)).and.(indx2.gt.n2(ispin)))
      end do
 

      call nwpw_timing_start(12)

      value = .true.
      if ((dosic).or.(dohfx)) 
     >  value = value.and.MA_pop_stack(Hpsi_r(2))
      value = value.and.MA_pop_stack(vpsi(2))
      value = value.and.MA_pop_stack(vall(2))
      if (.not. value) call errquit('psi_H:popping stack memory',1,0)

      call nwpw_timing_end(12)
      return
      end


*     *************************************
*     *                                   *
*     *             psi_Horb              *
*     *                                   *
*     *************************************
*
*  This routine calculates 
*
*       Hpsi_k = KE*psi_k + Vnl*psi_k +VSic*psi_k + FFT[(vall+xcp)*psi_r]
*
*  where vall = iFFT[Vl+Vc] + Vfield
*
*   Entry - ispin,ne            - spin and number of electrons in each spin
*           ms,n                - spin and electron number 
*           psi_k,psi_r         - orbitals in k-space and r-space
*           vall                  - local +external fields+coulomb in r-space
*           xcp                 - xc potential in r-space
*   Exit - Hpsi_k - gradient in k-space
*
      subroutine psi_Horb(hfxon,ispin,ms,
     >                 psi_r,
     >                 vall,
     >                 orb_k,orb_r,
     >                 Horb_k)
      implicit none
      logical    hfxon
      integer    ispin,ms
      real*8     psi_r(*)
      real*8     vall(*)      
      complex*16 orb_k(*)
      real*8     orb_r(*)
      complex*16 Horb_k(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      logical dohfx,meta_gga
      integer nne(2)
      integer nx,ny,nz
      real*8  scal1,fion(3,1)

*     **** tempory space ****
      integer nfft3d,n2ft3d,npack1
      integer vpsi(2),Horb_r(2)
      logical value


*     **** external functions ****
      logical  pspw_SIC,pspw_SIC_relaxed,nwpw_meta_gga_on
      logical  pspw_HFX,pspw_HFX_relaxed
      real*8   lattice_omega
      external pspw_SIC,pspw_SIC_relaxed,nwpw_meta_gga_on
      external pspw_HFX,pspw_HFX_relaxed
      external lattice_omega


      dohfx = pspw_HFX().and.pspw_HFX_relaxed().and.hfxon
      meta_gga = nwpw_meta_gga_on()
      call Pack_npack(1,npack1)
      
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      call nwpw_timing_start(12)
      value = MA_push_get(mt_dcpl,nfft3d,'vpsi',vpsi(2),vpsi(1))
      if (dohfx) then
         value = value.and.
     >           MA_push_get(mt_dbl,n2ft3d,'Horb_r',Horb_r(2),Horb_r(1))
         call dcopy(n2ft3d,0.0d0,0,dbl_mb(Horb_r(1)),1)
      end if
      if (.not. value) 
     >  call errquit('psi_Horb:out of stack memory',0, MA_ERR)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(vpsi(1)),1)
      call nwpw_timing_end(12)
      

      if (ms.eq.1) then
        nne(1) = 1
        nne(2) = 0
      else
        nne(1) = 0
        nne(2) = 1
      end if
*
      scal1 = 1.0d0/dble(nx*ny*nz)


*     ************************************************
*     **** add kinetic energy - Horb_k = Ke*orb_k ****
*     ************************************************
      call ke(ispin,nne,orb_k,Horb_k)

*     *********************************************************
*     **** add non-local psp - Horb_k = Horb_k + Vnl*orb_k ****
*     *********************************************************
      call v_nonlocal(ispin,nne,orb_k,Horb_k,
     >                .false.,fion,.false.,fion)


*     **********************************************************************
*     **** add extra Meta GGA terms Hpsi_k += grad dot (dfdtau*gradpsi) ****
*     **********************************************************************
      if (meta_gga) then
         call nwpw_meta_gga_Hpsik(ispin,nne,orb_k,Horb_k)
      end if

*     ***************************
*     **** SIC corrections?? ****
*     ***************************
c     if (pspw_SIC().and.pspw_SIC_relaxed()) then
c        call pspw_potential_SIC(ispin,psi_r,Hpsi_k)
c     end if

*     **********************
*     **** HFX energy   ****
*     **********************
      if (dohfx) then
         call pspw_potential_HFX_orb(ms,
     >                               psi_r,
     >                               orb_r,
     >                               dbl_mb(Horb_r(1)))
      end if


*     **************************************************
*     **** Hpsi_k = Hpsi_k + FFT[vall_r+xcp)*orb_r] **** 
*     **************************************************        

*     **** vpsi_r = (vall_r)*orb_r ****
      call D3dB_rr_Mul(1,vall(1+(ms-1)*n2ft3d),
     >                   orb_r,
     >                   dcpl_mb(vpsi(1)))

*     **** vpsi_r = vpsi_r + Hpsi_r ****
c      if (dohfx)
c     >   call D3dB_rr_Sum(1,dcpl_mb(vpsi(1)),
c     >                      dbl_mb(Horb_r(1)),
c     >                      dcpl_mb(vpsi(1)))
      if (dohfx)
     >   call D3dB_rr_Sum2(1,dbl_mb(Horb_r(1)),
     >                      dcpl_mb(vpsi(1)))

*     **** put vpsi_r in k-space ****
      call D3dB_rc_pfft3f(1,1,dcpl_mb(vpsi(1)))
      call Pack_c_pack(1,dcpl_mb(vpsi(1)))

*     **** add to Horb_k ****
      call Pack_cc_daxpy(1,(-scal1),
     >                   dcpl_mb(vpsi(1)),
     >                   Horb_k)

      call nwpw_timing_start(12)
      value = .true.
      if (dohfx) 
     >  value = value.and.MA_pop_stack(Horb_r(2))
      value = value.and.MA_pop_stack(vpsi(2))
      if (.not.value) 
     >  call errquit('psi_Horb: popping stack',1, MA_ERR)
      call nwpw_timing_end(12)

      return
      end


*     *************************************
*     *                                   *
*     *         psi_Horb_replicated       *
*     *                                   *
*     *************************************
*
*  This routine calculates 
*
*       Hpsi_k = KE*psi_k + Vnl*psi_k +VSic*psi_k + FFT[(vall+xcp)*psi_r]
*
*  where vall = iFFT[Vl+Vc] + Vfield
*
*   Entry - ispin,ne            - spin and number of electrons in each spin
*           ms,n                - spin and electron number 
*           psi_k,psi_r         - distributed orbitals in k-space and r-space
*           orb_k,orb_h         - replicated orbital in k-space and r-space
*           vall                  - local +external fields+coulomb in r-space
*           xcp                 - xc potential in r-space
*           notvirtual
*   Exit - Horb_k - replicated gradient in k-space
*
      subroutine psi_Horb_replicated(hfxon,ispin,ms,
     >                 psi_r,
     >                 vall,
     >                 orb_k,orb_r,
     >                 Horb_k)
      implicit none
      logical    hfxon
      integer    ispin,ms
      real*8     psi_r(*)
      real*8     vall(*)      
      complex*16 orb_k(*)
      real*8     orb_r(*)
      complex*16 Horb_k(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      logical dohfx,dodftu
      integer nne(2)
      integer nx,ny,nz
      real*8  scal1,fion(3,1)

*     **** tempory space ****
      integer nfft3d,n2ft3d,npack1
      integer vpsi(2),Horb_r(2)
      logical value,meta_gga


*     **** external functions ****
      logical  pspw_SIC,pspw_SIC_relaxed,nwpw_meta_gga_on
      logical  pspw_HFX,pspw_HFX_relaxed,psp_U_psputerm
      real*8   lattice_omega
      external pspw_SIC,pspw_SIC_relaxed,nwpw_meta_gga_on
      external pspw_HFX,pspw_HFX_relaxed,psp_U_psputerm
      external lattice_omega


      dohfx = pspw_HFX().and.pspw_HFX_relaxed().and.hfxon
      dodftu = psp_U_psputerm().and.hfxon
      meta_gga = nwpw_meta_gga_on()
      call Pack_npack(1,npack1)
      
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      call nwpw_timing_start(12)
      value = MA_push_get(mt_dcpl,nfft3d,'vpsi',vpsi(2),vpsi(1))
      if (dohfx) then
         value = value.and.
     >           MA_push_get(mt_dbl,n2ft3d,'Horb_r',Horb_r(2),Horb_r(1))
         call dcopy(n2ft3d,0.0d0,0,dbl_mb(Horb_r(1)),1)
      end if
      if (.not. value) 
     >  call errquit('psi_Horb:out of stack memory',0, MA_ERR)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(vpsi(1)),1)
      call nwpw_timing_end(12)
      
      if (ms.eq.1) then
        nne(1) = 1
        nne(2) = 0
      else
        nne(1) = 0
        nne(2) = 1
      end if
*
      scal1 = 1.0d0/dble(nx*ny*nz)


*     ************************************************
*     **** add kinetic energy - Horb_k = Ke*orb_k ****
*     ************************************************
      call ke(ispin,nne,orb_k,Horb_k)

*     *********************************************************
*     **** add non-local psp - Horb_k = Horb_k + Vnl*orb_k ****
*     *********************************************************
      call v_nonlocal(ispin,nne,orb_k,Horb_k,
     >                .false.,fion,.false.,fion)

*     *********************************************************
*     **** add DFT+U term                                  ****
*     *********************************************************
      if (dodftu) then
         call psp_U_v_nonlocal(ispin,nne,orb_k,Horb_k,
     >                .false.,fion,.false.,fion,.false.)
      end if

*     **********************************************************************
*     **** add extra Meta GGA terms Hpsi_k += grad dot (dfdtau*gradpsi) ****
*     **********************************************************************
      if (meta_gga) then
         call nwpw_meta_gga_Hpsik(ispin,nne,orb_k,Horb_k)
      end if


*     ***************************
*     **** SIC corrections?? ****
*     ***************************
c     if (pspw_SIC().and.pspw_SIC_relaxed()) then
c        call pspw_potential_SIC(ispin,psi_r,Hpsi_k)
c     end if

*     **********************
*     **** HFX energy   ****
*     **********************
      if (dohfx) then
         call pspw_potential_HFX_orb_replicated(ms,
     >                               psi_r,
     >                               orb_r,
     >                               dbl_mb(Horb_r(1)))
      end if


*     **************************************************
*     **** Hpsi_k = Hpsi_k + FFT[vall_r+xcp)*orb_r] **** 
*     **************************************************        

*     **** vpsi_r = (vall_r)*orb_r ****
      call D3dB_rr_Mul(1,vall(1+(ms-1)*n2ft3d),
     >                   orb_r,
     >                   dcpl_mb(vpsi(1)))

*     **** vpsi_r = vpsi_r + Hpsi_r ****
      if (dohfx)
     >   call D3dB_rr_Sum2(1,dbl_mb(Horb_r(1)),
     >                      dcpl_mb(vpsi(1)))

*     **** put vpsi_r in k-space ****
      call D3dB_rc_pfft3f(1,1,dcpl_mb(vpsi(1)))
      call Pack_c_pack(1,dcpl_mb(vpsi(1)))

*     **** add to Horb_k ****
      call Pack_cc_daxpy(1,(-scal1),
     >                   dcpl_mb(vpsi(1)),
     >                   Horb_k)

      call nwpw_timing_start(12)
      value = .true.
      if (dohfx) 
     >  value = value.and.MA_pop_stack(Horb_r(2))
      value = value.and.MA_pop_stack(vpsi(2))
      if (.not.value) 
     >  call errquit('psi_Horb: popping stack',1, MA_ERR)
      call nwpw_timing_end(12)

      return
      end



*     *************************************
*     *                                   *
*     *             psi_H1                *
*     *                                   *
*     *************************************
*
*  This routine calculates 
*
*       Hpsi_k = KE*psi_k + Vnl*psi_k + FFT[(vall)*psi_r]
*
*  where vall = iFFT[Vl+Vc] + Vfield
*
*   Entry - ispin,ne            - spin and number of electron in each spin
*           psi_k,psi_r         - orbitals in k-space and r-space
*           vl                  - local psp in k-space
*           v_field,field_exist - external fields (e.g. QM/MM)
*   Exit - Hpsi_k - gradient in k-space
*
      subroutine psi_H1(ispin,ne,
     >                 psi_k,psi_r,
     >                 vl,
     >                 v_field,field_exist,
     >                 Hpsi_k)
      implicit none
      integer    ispin,ne(2)
      complex*16 psi_k(*)
      real*8     psi_r(*)
      complex*16 vl(*)
      real*8     v_field(*)
      logical    field_exist
      complex*16 Hpsi_k(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      integer ms,n,n1(2),n2(2)
      integer nx,ny,nz
      real*8  scal1,scal2

*     **** tempory space ****
c     complex*16 vall(nfft3d)
c     complex*16 vpsi(nfft3d)
      integer nfft3d,n2ft3d,npack1,indx1,indx2
      integer vall(2),vpsi(2)
      logical value,done,meta_gga
      real*8 fion(3),occ(3)


*     **** external functions ****
      logical  D3dB_rc_pfft3_queue_filled,nwpw_meta_gga_on
      real*8   lattice_omega
      external D3dB_rc_pfft3_queue_filled,nwpw_meta_gga_on
      external lattice_omega


      meta_gga = nwpw_meta_gga_on()
      call Pack_npack(1,npack1)
      
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      call nwpw_timing_start(12)
      value = MA_push_get(mt_dcpl,nfft3d,'vall',vall(2),vall(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'vpsi',vpsi(2),vpsi(1))
      if (.not. value) call errquit('psi_H:out of stack memory',0,
     &       MA_ERR)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(vall(1)),1)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(vpsi(1)),1)
      call nwpw_timing_end(12)
      

      scal2 = 1.0d0/lattice_omega()
      scal1 = 1.0d0/dble(nx*ny*nz)
      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)

*     *********************************************************
*     **** add kinetic energy - Hpsi_k = Ke*psi_k ****
*     *********************************************************
      call ke(ispin,ne,psi_k,Hpsi_k)

*     *********************************************************
*     **** add non-local psp - Hpsi_k = Hpsi_k + Vnl*psi_k ****
*     *********************************************************
      call v_nonlocal(ispin,ne,psi_k,Hpsi_k,.false.,fion,.false.,occ)



*     **********************************************************************
*     **** add extra Meta GGA terms Hpsi_k += grad dot (dfdtau*gradpsi) ****
*     **********************************************************************
      if (meta_gga) then
         call nwpw_meta_gga_Hpsik(ispin,ne,psi_k,Hpsi_k)
      end if


*     **********************************************************
*     **** add up k-space potentials, vall = scal2*vl       ****
*     **********************************************************
      call Pack_c_SMul(0,scal2,vl,dcpl_mb(vall(1)))
      
*     **********************************************
*     **** fourier transform k-space potentials ****
*     **********************************************
      call Pack_c_unpack(0,dcpl_mb(vall(1)))
      call D3dB_cr_fft3b(1,dcpl_mb(vall(1)))

*     ******************************
*     **** add v_field to vall  ****
*     ******************************
      if (field_exist)
     >  call D3dB_rr_Sum2(1,v_field,dcpl_mb(vall(1)))


*     **********************************************
*     **** Hpsi_k = Hpsi_k + FFT[vall_r]*psi_r  **** 
*     ********************************************** 
      indx1 = 1
      indx2 = 1
      done  = .false.
      do while (.not.done)
         if (indx1.le.n2(ispin)) then
            ms = 1
            if (indx1.gt.n2(1)) ms = 2

*           **** vpsi_r = (vall_r+xcp)*psi_r ****
            call D3dB_r_Copy(1,dcpl_mb(vall(1)),dcpl_mb(vpsi(1)))

            call D3dB_rr_Mul2(1,psi_r(1+(indx1-1)*n2ft3d),
     >                       dcpl_mb(vpsi(1)))


*           **** put vpsi_r in k-space ****
            call D3dB_rc_pfft3f_queuein(1,dcpl_mb(vpsi(1)))
            indx1 = indx1 + 1

         end if

         if ((D3dB_rc_pfft3_queue_filled()).or.
     >       (indx1.gt.n2(ispin))) then
            call D3dB_rc_pfft3f_queueout(1,dcpl_mb(vpsi(1)))

*           **** add to Hpsi_k ****
            call Pack_cc_daxpy(1,(-scal1),
     >                           dcpl_mb(vpsi(1)),
     >                           Hpsi_k(1+(indx2-1)*npack1))
            indx2 = indx2 + 1
         end if

         done = ((indx1.gt.n2(ispin)).and.(indx2.gt.n2(ispin)))
      end do
 

      call nwpw_timing_start(12)

      value = .true.
      value = value.and.MA_pop_stack(vpsi(2))
      value = value.and.MA_pop_stack(vall(2))
      if (.not. value) call errquit('psi_H:popping stack memory',1,0)

      call nwpw_timing_end(12)
      return
      end

      subroutine band_kp_structure(rtdb)
      implicit none
      integer rtdb

#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"


*     **** parallel variables ****
      integer  taskid,taskid_k,np,np_i,np_j,np_k
      integer  MASTER
      parameter(MASTER=0)

      integer nbrillall,k,isize,NN,i,j,n1,n2,n3,ii,i1,i2,i3
      integer ne(2),ne_excited(2),neall(2)
      integer itet(3,4),teigs(2,4),eigs(2),hml(2),mgrid(3),tindx(4)
      integer ix,iy,iz,ipiv(4),ierr
      real*8  ktet(3,4),kstet(3,4),kstetm(3,4),dktet(3,4),rx,ry,rz
      real*8  ks(3),kv(3),kold(3),dk(3),dk2,pathlength,dist,e1,e2,EV
      real*8  vandermonde(4,4),A(4,4),f(4)
      character*255 full_filename
 

*     **** external functions ****
      logical  Pneb_wne_allocate_block,Pneb_w_free
      logical  cpsi_spin_orbit,control_spin_orbit,control_print
      integer  cpsi_ispin,cpsi_ne,control_num_kvectors_structure
      integer  control_ksvector_index
      integer  control_excited_ne
      real*8   lattice_unitg
      external Pneb_wne_allocate_block,Pneb_w_free
      external cpsi_spin_orbit,control_spin_orbit,control_print
      external cpsi_ispin,cpsi_ne,control_num_kvectors_structure
      external control_ksvector_index
      external control_excited_ne
      external lattice_unitg


      ne(1) = cpsi_ne(1)
      ne(2) = cpsi_ne(2)
      ne_excited(1) = 0
      ne_excited(2) = 0
      ne_excited(1) = control_excited_ne(1)
      if (cpsi_ispin().eq.2) ne_excited(2) = control_excited_ne(2)
      neall(1) = ne(1) + ne_excited(1)
      neall(2) = ne(2) + ne_excited(2)
      NN=neall(1)-neall(2)
      EV=27.2116d0

      nbrillall = control_num_kvectors_structure()
      call control_monkhorst_pack_grid(mgrid)

      if ((nbrillall.gt.1).and.
     >    (mgrid(1).ne.0) .and.
     >    (mgrid(2).ne.0) .and.
     >    (mgrid(3).ne.0)) then

      call Parallel_taskid(taskid)

*     **** allocate eigs ****
      isize = neall(1)+neall(2)
      do i=1,4
      if (.not.MA_push_get(mt_dbl,isize,'teigs',teigs(2,i),teigs(1,i)))
     >  call errquit(
     > 'band_interpolate structure:out of stack memory',0,MA_ERR)
      end do
      if (.not.MA_push_get(mt_dbl,isize,'eigs',eigs(2),eigs(1)))
     >  call errquit(
     > 'band_interpolate structure:out of stack memory',0,MA_ERR)
      if (.not.Pneb_wne_allocate_block(0,1,1,neall,hml))
     >  call errquit(
     > 'band_interpolate structure:out of stack memory',1,MA_ERR)



*     **** produce eigenvalue band file(s) ****
      if (cpsi_ispin().eq.1) then
        call util_file_name('restricted_band_kp',
     >                    .false.,
     >                    .false.,
     >                    full_filename)
        if (taskid.eq.MASTER) then
         open(unit=58,file=full_filename,form='formatted')
        end if
      else
        if (cpsi_spin_orbit()) then
        call util_file_name('spinor_band_kp',
     >                    .false.,
     >                    .false.,
     >                    full_filename)
        if (taskid.eq.MASTER) then
         open(unit=58,file=full_filename,form='formatted')
        end if
        else 
        call util_file_name('alpha_band_kp',
     >                    .false.,
     >                    .false.,
     >                    full_filename)
        if (taskid.eq.MASTER) then
         open(unit=58,file=full_filename,form='formatted')
        end if
        call util_file_name('beta_band_kp',
     >                    .false.,
     >                    .false.,
     >                    full_filename)
        if (taskid.eq.MASTER) then
         open(unit=59,file=full_filename,form='formatted')
        end if
        end if
      end if

      if (taskid.eq.MASTER) 
     >   write(luout,*) "kp band structure calculation" 

      do k=1,nbrillall
         call control_ksvector_structure(k,ks)
         call control_kvector_structure(k,kv)
         rx = 0.5d0*(ks(1)*2*mgrid(1) + mgrid(1) - 1)
         ry = 0.5d0*(ks(2)*2*mgrid(2) + mgrid(2) - 1)
         rz = 0.5d0*(ks(3)*2*mgrid(3) + mgrid(3) - 1)
         i1 = nint(rx)
         i2 = nint(ry)
         i3 = nint(rz)
         if (rx.ge.i1)  then
            ix= 1
         else
            ix=-1
         end if
         if (ry.ge.i2)  then
            iy= 1
         else
            iy=-1
         end if
         if (rz.ge.i3)  then
            iz= 1
         else
            iz=-1
         end if
         itet(1,1) = i1
         itet(2,1) = i2
         itet(3,1) = i3

         itet(1,2) = i1 + ix
         itet(2,2) = i2
         itet(3,2) = i3

         itet(1,3) = i1
         itet(2,3) = i2 + iy
         itet(3,3) = i3

         itet(1,4) = i1
         itet(2,4) = i2
         itet(3,4) = i3 + iz


         do j=1,4
         do i=1,3
            kstet(i,j) = (2*itet(i,j)+1-mgrid(i))/(2.0d0*mgrid(i))
         end do
         end do

         do j=1,4
         do i=1,3
            ktet(i,j) = lattice_unitg(i,1)*kstet(1,j)
     >                + lattice_unitg(i,2)*kstet(2,j)
     >                + lattice_unitg(i,3)*kstet(3,j)
           dktet(i,j) = ktet(i,j) - kv(i)
         end do
         end do

         do j=1,4
            do i=1,3
               itet(i,j)   = mod(itet(i,j),mgrid(i))
               kstetm(i,j) = (2*itet(i,j)+1-mgrid(i))/(2.0d0*mgrid(i))
            end do
            tindx(j) = control_ksvector_index(kstetm(1,j))
         end do


         if (taskid.eq.MASTER) then
            if (k.eq.1) then
               pathlength = 0.0d0
            else
               dist =        (kv(1)-kold(1))**2
               dist = dist + (kv(2)-kold(2))**2
               dist = dist + (kv(3)-kold(3))**2
               dist = dsqrt(dist)
               pathlength = pathlength + dist
            end if
            kold(1) = kv(1)
            kold(2) = kv(2)
            kold(3) = kv(3)
            write(luout,1508) k,pathlength,ks,kv
            write(luout,1500)
         end if

         call band_kp_setvandermonde(dktet,vandermonde)

         do j=1,4
            dk(1) = ktet(1,j)-kv(1)
            dk(2) = ktet(2,j)-kv(2)
            dk(3) = ktet(3,j)-kv(3)
            dk2   = dk(1)*dk(1) + dk(2)*dk(2) + dk(3)*dk(3)
            write(*,*) "j=",j,dk2,tindx(j),neall,dk
            call ecpsi_generate_kb_H(dk,tindx(j),dcpl_mb(hml(1)))
            write(*,*) " - herb"
            call band_kb_add_eigs(dk2,tindx(j),neall,dcpl_mb(hml(1)))
            call Pneb_wne_diag(0,1,neall,
     >                         dbl_mb(teigs(1,j)),dcpl_mb(hml(1)))
         end do
         do i=1,(neall(1)+neall(2))
            do j=1,4
               f(j) = dbl_mb(teigs(1,j)+i-1)
            end do
            call dcopy(16,vandermonde,1,A,1)
            call DGESV(4,1,A,4,ipiv,f,4,ierr)
c            dbl_mb(eigs(1)+i-1)=f(1)*kv(1)+f(2)*kv(2)+f(3)*kv(3)+f(4)
            dbl_mb(eigs(1)+i-1)=f(4)
         end do

c         call band_kp_eigs(kv,tindx,ktet,dcpl_mb(hml(1)),dbl_mb(eigs(1)))

         !*** spin-orbit ****
         if (taskid.eq.MASTER) then
            if (cpsi_spin_orbit()) then
               do i=0,neall(1)-1
                  e1 = dbl_mb(eigs(1)+neall(1)-i-1)
                  write(luout,1510)  e1,e1*EV
               end do
            !*** not spin-orbit ****
            else
               do i=0,NN-1
                  e1 = dbl_mb(eigs(1)+neall(1)-i-1)
                  write(luout,1510) e1,e1*EV
               end do
               do i=0,neall(2)-1
                  e1 = dbl_mb(eigs(1)+neall(1)-i-NN-1)
                  e2 = dbl_mb(eigs(1)+neall(1)+neall(2)-i-1)
                  write(luout,1510)  e1,e1*EV,e2,e2*EV
               end do
            end if
            write(58,'(1000E14.6)') pathlength,
     >          (dbl_mb(eigs(1)+i-1),i=1,neall(1))
            if ((.not.cpsi_spin_orbit()).and.(cpsi_ispin().eq.2)) then
               write(59,'(1000E14.6)') pathlength,
     >             (dbl_mb(eigs(1)+i-1),i=1,neall(2))
            end if
         end if

      end do

      if (taskid.eq.MASTER) then
        close(58)
        if (cpsi_ispin().eq.2) close(59)
      end if

      if (.not.Pneb_w_free(hml))
     >  call errquit(
     > 'band_interpolate structure:popping stack memory',1,MA_ERR)
      if (.not.MA_pop_stack(eigs(2))) 
     >  call errquit(
     > 'band_interpolate structure:popping stack memory',0,MA_ERR)
      do j=4,1,-1
      if (.not.MA_pop_stack(teigs(2,j))) 
     >  call errquit(
     > 'band_interpolate structure:popping stack memory',0,MA_ERR)
      end do


      end if

 1500 FORMAT(/' kp orbital energies:')
 1508 FORMAT(/' Brillouin zone point: ',i5,
     >       /'pathlength=',f10.6,
     >       /'    k     =<',3f8.3,'> . <b1,b2,b3> ',
     >       /'          =<',3f8.3,'>')
c 1509 FORMAT(/' Brillouin zone tet-point: ',i3,i5
c     >       /'    k     =<',3f8.3,'> . <b1,b2,b3> ',
c     >       /'          =<',3f8.3,'>')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))


      return
      end 

      subroutine band_kb_add_eigs(dk2,nb,neall,H)
      implicit none
      real*8      dk2
      integer     nb,neall(2)
      complex*16  H(*)

*     **** local variables ****
      integer    i,ms,ne(2),indx
      real*8     f

*     **** external functions ****
      integer  cpsi_ne,cpsi_ispin
      real*8   cpsi_eigenvalue_brdcst
      real*8   cpsi_virtual_brdcst
      external cpsi_ne,cpsi_ispin
      external cpsi_eigenvalue_brdcst
      external cpsi_virtual_brdcst

      ne(1) = cpsi_ne(1)
      ne(2) = cpsi_ne(2)

*     **** set up kp matrix ****
      do ms=1,cpsi_ispin()
         do i=1,neall(ms)
            indx = i+(i-1)*neall(ms)+(ms-1)*neall(1)**2

            if (i.le.ne(ms)) then
               f = cpsi_eigenvalue_brdcst(nb,ms,i) 
            else
               f = cpsi_virtual_brdcst(nb,ms,i-ne(ms))
            end if
            H(indx) = H(indx) + (f + 0.5d0*dk2)
         end do
      end do
      
      
      return
      end


      subroutine band_kp_setvandermonde(ktet,vandermonde)
      implicit none
      real*8 ktet(3,*),vandermonde(4,4)

      integer i

      do i=1,4
         vandermonde(i,1) = ktet(1,i)
         vandermonde(i,2) = ktet(2,i)
         vandermonde(i,3) = ktet(3,i)
         vandermonde(i,4) = 1.0d0
      end do

      return
      end

c $Id: band_fft_structure.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE YGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
*
* $Id: ygemv.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      implicit none
#include "y64.fh"
*     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA, BETA
      INTEGER            INCX, INCY, LDA, M, N
      CHARACTER*1        TRANS
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
c
      INTGR4            INCX4, INCY4, LDA4, M4, N4
c
      INCX4=incx
      INCY4=incy
      LDA4=lda
      M4=m
      N4=n
c
      call DGEMV ( TRANS, M4, N4, ALPHA, A, LDA4, X, INCX4,
     $                   BETA, Y, INCY4 )

      RETURN
      END

      subroutine argos_cafe_init(stimei,lp,llng,bx,vl,vli,zwi,zs,
     + eww,esw,ess,fss,esa)
c     + vw,vwt,vs,vst,zwi,zs,eww,esw,ess)
c
c     in r*8 : bx(3) : box dimensions
c     in log : lp    : flag to force pairlist recalculation
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
c      real*8 vw(mwm,3,mwa),vwt(mwm,3,mwa),vs(msa,3),vst(msa,3)
      real*8 bx(3),vl(3,3),vli(3,3),zwi(3,3,2),zs(msf,3,3,2)
      real*8 eww(mpe,2),esw(msf,mpe,2),ess(msf,msf,mpe,2)
      real*8 fss(msf,msf,3,2)
      real*8 esa(nsa,2),stimei
      logical lp,llng
c
      integer i,j,k,l,m
c
c     initialize pme flags
c
      stime=stimei
      if(nhops.gt.0) call argos_cafe_hopinit(int_mb(i_lsthop),
     + dbl_mb(i_timhop))
c
      if(ipme.gt.0) then
      call argos_pme_flag(0,0,me)
      call argos_pme_flag(1,0,me)
      endif
c
      entry argos_cafe_init2(lp,llng,bx,vl,vli,zwi,zs,eww,esw,
     + ess,fss,esa)
c
      lpair=lp
      llong=llng
c
      ntest=0
      m=1
      if(llong) m=2
c
      do 1 i=1,3
      box(i)=bx(i)
      boxh(i)=half*bx(i)
      do 2 j=1,3
      vlat(i,j)=vl(i,j)
      vlati(i,j)=vli(1,3)
    2 continue
    1 continue
      volume=box(1)*box(2)*box(3)
c
      do 8 l=1,m
      do 3 i=1,mpe
      eww(i,l)=zero
      do 4 j=1,msf
      esw(j,i,l)=zero
      do 5 k=1,msf
      ess(k,j,i,l)=zero
    5 continue
    4 continue
    3 continue
      do 16 k=1,3
      do 6 i=1,3
      zw(k,i,l)=zero
      zwi(k,i,l)=zero
      do 7 j=1,msf
      zs(j,k,i,l)=zero
    7 continue
    6 continue
   16 continue
      if(m.eq.2) then
      vpme(1)=zero
      vpme(2)=zero
      vpme(3)=zero
      vpme(4)=zero
      vpme(5)=zero
      vpme(6)=zero
      endif
      if(ntype.eq.3) then
      do 9 i=1,24
      deriv(i,l)=zero
    9 continue
      endif
      ep2(l)=zero
      ep3(l)=zero
      do 21 i=1,msf
      do 22 j=1,msf
      fss(i,j,1,l)=zero
      fss(i,j,2,l)=zero
      fss(i,j,3,l)=zero
   22 continue
   21 continue
    8 continue
      ep2(3)=zero
      ep3(3)=zero
c
      if(npener.gt.0) then
      do 10 i=1,nsa
      esa(i,1)=zero
      esa(i,2)=zero
   10 continue
      endif
c
      if(me.eq.0) eww(6,1)=dble(nwm)*ewc(iset)
c
      lpww=1
      lpsw=1
      lpss=1
      if(llong) then
      lpww=2
      lpsw=2
      lpss=2
      endif
c
      if(lpair) then
      llww=0
      lsww=0
      llsw=0
      lssw=0
      llss=0
      lsss=0
      nlda=0
      endif
c
      do 23 i=1,4*nhop
      dbl_mb(i_uda-1+i)=zero
   23 continue
c
      if(.not.llist) lpair=.true.
c
c     allocate memory for the scratch arrays
c
      if(.not.lscr) call argos_cafe_salloc()
c
c     allocate memory for the pairlists
c
      if(.not.llst) call argos_cafe_lalloc()
c
      ndxp=0
c
      call argos_cafe_binit(dbl_mb(i_rbnd(2)),numb(2),2)
      call argos_cafe_binit(dbl_mb(i_rang(2)),numh(2),2)
      call argos_cafe_binit(dbl_mb(i_rub(2)),numh(2),2)
      call argos_cafe_binit(dbl_mb(i_rdih(2)),numd(2),2)
      call argos_cafe_binit(dbl_mb(i_rimp(2)),numi(2),2)
c
      return
      end
c $Id: argos_cafe_init.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function hbar_restore(ivec,jvec,hbar)
c
c $Id: hbar.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Read (if exist) hbar(ivec,jvec)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "msgids.fh"
#include "eaf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      character*255 filename
      integer ivec
      integer jvec
      double precision hbar
      integer d_temp
      integer n, i
      double precision dj
      double precision di
      double precision dn
c
      call tce_filename('hbar',filename)
      if (eaf_open(filename, EAF_R, d_temp).ne.0)
     1  call errquit('hbar_restore: eaf problem',0,DISK_ERR)
      if (eaf_read(d_temp,0.0d0,dn,bytes).ne.0)
     1  call errquit('hbar_restore: eaf problem',1,DISK_ERR)
      n = int(dn)
      if (n.gt.0) then
        do i = 1, n
          if (eaf_read(d_temp,dfloat(bytes)*dfloat((i-1)*3+1),
     1      di,bytes).ne.0)
     2      call errquit('hbar_restore: eaf problem',2,DISK_ERR)
          if (eaf_read(d_temp,dfloat(bytes)*dfloat((i-1)*3+2),
     1      dj,bytes).ne.0)
     2      call errquit('hbar_restore: eaf problem',3,DISK_ERR)
          if (eaf_read(d_temp,dfloat(bytes)*dfloat((i-1)*3+3),
     1      hbar,bytes).ne.0)
     2      call errquit('hbar_restore: eaf problem',4,DISK_ERR)
          if ((int(di).eq.ivec).and.(int(dj).eq.jvec)) then
            if (eaf_close(d_temp).ne.0)
     1        call errquit('hbar_restore: eaf problem',9,DISK_ERR)
c           write(LuOut,*) 'Restoring H bar(',ivec,jvec,') = ',hbar
            hbar_restore = .true.
            return
          endif
        enddo
      endif
      if (eaf_close(d_temp).ne.0)
     1  call errquit('hbar_restore: eaf problem',9,DISK_ERR)
      hbar_restore = .false.
      return
      end
      subroutine hbar_store(ivec,jvec,hbar)
c
c $Id: hbar.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Write hbar(ivec,jvec)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "msgids.fh"
#include "eaf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      character*255 filename
      integer ivec
      integer jvec
      double precision hbar
      integer d_temp
      integer n
      double precision dn
      double precision di
      double precision dj
c
      call tce_filename('hbar',filename)
      if (eaf_open(filename, EAF_RW, d_temp).ne.0)
     1  call errquit('hbar_store: eaf problem',0,DISK_ERR)
      if (eaf_read(d_temp,0.0d0,dn,bytes).ne.0)
     1  call errquit('hbar_store: eaf problem',1,DISK_ERR)
      n = int(dn)
      n = n + 1
      dn = dfloat(n)
      if (eaf_write(d_temp,0.0d0,dn,bytes).ne.0)
     1  call errquit('hbar_store: eaf problem',2,DISK_ERR)
      di = dfloat(ivec)
      dj = dfloat(jvec)
      if (eaf_write(d_temp,dfloat(bytes)*dfloat((n-1)*3+1),
     1  di,bytes).ne.0)
     2  call errquit('hbar_store: eaf problem',3,DISK_ERR)
      if (eaf_write(d_temp,dfloat(bytes)*dfloat((n-1)*3+2),
     1  dj,bytes).ne.0)
     2  call errquit('hbar_store: eaf problem',4,DISK_ERR)
      if (eaf_write(d_temp,dfloat(bytes)*dfloat((n-1)*3+3),
     1  hbar,bytes).ne.0)
     2  call errquit('hbar_store: eaf problem',5,DISK_ERR)
      if (eaf_close(d_temp).ne.0)
     1  call errquit('hbar_store: eaf problem',9,DISK_ERR)
c     write(LuOut,*) 'Storing H bar(',ivec,jvec,') = ',hbar
      return
      end
      subroutine hbar_init
c
c $Id: hbar.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Initialize hbar file
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "msgids.fh"
#include "eaf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      character*255 filename
      integer d_temp
      double precision dn
c
      call tce_filename('hbar',filename)
      if (eaf_open(filename, EAF_RW, d_temp).ne.0)
     1  call errquit('hbar_init: eaf problem',0,DISK_ERR)
      dn = 0.0d0
      if (eaf_write(d_temp,0.0d0,dn,bytes).ne.0)
     1  call errquit('hbar_init: eaf problem',1,DISK_ERR)
      if (eaf_close(d_temp).ne.0)
     1  call errquit('hbar_init: eaf problem',2,DISK_ERR)
      return
      end
      subroutine hbar_tidy
c
c $Id: hbar.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Terminate hbar file
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "msgids.fh"
#include "eaf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      character*255 filename
c
      call tce_filename('hbar',filename)
      if (eaf_delete(filename).ne.0)
     1  call errquit('hbar_tidy: eaf problem',0,DISK_ERR)
      return
      end

      subroutine ana_init(nsai,msai,nwmi,mwmi,nwai,mwai,ltask)
c
c $Id: ana_init.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
      integer nsai,msai,nwmi,mwmi,nwai,mwai
      logical ltask
c
c     determine me and np
c     this is needed here for on-the-fly analysis since then there
c     is no call to the analysis main task routine
c
c     input: nsai : total number of solute atoms
c            msai : dimension arrays for solute atoms on this node
c
      me=ga_nodeid()
      np=ga_nnodes()
c
      nsa=nsai
      msa=msai
      nwm=nwmi
      mwm=mwmi
      nwa=nwai
      mwa=mwai
c
c     read rtdb if on-the-fly
c     for analysis task calls this has already been done
c
      if(.not.ltask) call ana_rtdbin()
c
c     get filename from rtdb: only node 0 is doing i/o
c
      if(me.eq.0) then
      if(.not.rtdb_cget(irtdb,'ana:project',1,filnam)) then
      if(.not.rtdb_cget(irtdb,'arg:project',1,filnam)) then
      if(.not.rtdb_cget(irtdb,'prep:sysnam',1,filnam)) then
      if(.not.rtdb_cget(irtdb,'file_prefix',1,filnam))
     + call md_abort('arg_rdname: error rtdb_cget project',0)
      endif
      endif
      endif
      filana=filnam(1:index(filnam,' ')-1)//'.ana'
      open(unit=lfnana,file=filana,form='formatted',status='unknown')
      endif
c
c     allocate memory
c
      if(.not.ma_push_get(mt_int,nsa,'hbnd',l_hbnd,i_hbnd))
     + call md_abort('Failed to allocate memory for hbnd',me)
      if(.not.ma_push_get(mt_int,nsa,'isel',l_isel,i_isel))
     + call md_abort('Failed to allocate memory for isel',me)
      if(.not.ma_push_get(mt_int,nsa,'ssel',l_ssel,i_ssel))
     + call md_abort('Failed to allocate memory for ssel',me)
      if(.not.ma_push_get(mt_int,nsa,'osel',l_osel,i_osel))
     + call md_abort('Failed to allocate memory for osel',me)
c
      if(.not.ma_push_get(mt_byte,48*nsa,'tag',l_tag,i_tag))
     + call md_abort('Failed to allocate memory for tag',me)
      if(.not.ma_push_get(mt_dbl,2*nsa,'val',l_val,i_val))
     + call md_abort('Failed to allocate memory for val',me)
c
      if(.not.ma_push_get(mt_dbl,3*nsa,'xref',l_xref,i_xref))
     + call md_abort('Failed to allocate memory for xref',me)
      if(.not.ma_push_get(mt_dbl,nsa,'xrms',l_xrms,i_xrms))
     + call md_abort('Failed to allocate memory for xrms',me)
      if(.not.ma_push_get(mt_dbl,nsa,'wt',l_wt,i_wt))
     + call md_abort('Failed to allocate memory for wt',me)
      if(.not.ma_push_get(mt_dbl,nsa,'swt',l_swt,i_swt))
     + call md_abort('Failed to allocate memory for swt',me)
      if(.not.ma_push_get(mt_dbl,nsa,'owt',l_owt,i_owt))
     + call md_abort('Failed to allocate memory for owt',me)
c
c     initialize rms and wt arrays
c
      call ana_inirms(dbl_mb(i_xref),dbl_mb(i_xrms),dbl_mb(i_wt))
c
c     initialize tags
c
      call ana_initag(byte_mb(i_tag),dbl_mb(i_val))
c
c     for task calls memory needs to be set aside for atom names,
c     coordinates and global atom numbers
c     for on-the-fly analyses these come directly from the md
c     module where these arrays are distributed.
c     for task analyses these arrays are replicated over all
c     nodes
c     currently only solute coordinates are analyzed
c
      if(ltask) then
      if(.not.ma_push_get(mt_byte,16*nsa,'sgmnam',l_snam,i_snam))
     + call md_abort('Failed to allocate memory for sgmnam',me)
      if(.not.ma_push_get(mt_dbl,3*nsa,'xdat',l_xdat,i_xdat))
     + call md_abort('Failed to allocate memory for xdat',me)
      if(.not.ma_push_get(mt_dbl,nsa,'qdat',l_qdat,i_qdat))
     + call md_abort('Failed to allocate memory for qdat',me)
      if(.not.ma_push_get(mt_dbl,3*nsa,'xadat',l_xadat,i_xadat))
     + call md_abort('Failed to allocate memory for xadat',me)
      if(.not.ma_push_get(mt_dbl,3*nsa,'xp',l_xp,i_xp))
     + call md_abort('Failed to allocate memory for xp',me)
      if(.not.ma_push_get(mt_int,nsa,'idat',l_idat,i_idat))
     + call md_abort('Failed to allocate memory for idat',me)
      if(.not.ma_push_get(mt_dbl,3*mwm*mwa,'wdat',l_wdat,i_wdat))
     + call md_abort('Failed to allocate memory for wdat',me)
      if(.not.ma_push_get(mt_dbl,nwa,'qwdat',l_qwdat,i_qwdat))
     + call md_abort('Failed to allocate memory for qwdat',me)
      if(.not.ma_push_get(mt_int,mwm,'wdat',l_wsel,i_wsel))
     + call md_abort('Failed to allocate memory for wsel',me)
      if(.not.ma_push_get(mt_int,mwm,'ndxw',l_ndxw,i_ndxw))
     + call md_abort('Failed to allocate memory for ndxw',me)
      endif
c
c     set the number of analyzed frames to zero
c
      ndata=0
c
      return
      end

      subroutine python_input(rtdb)
*
* $Id: python_input.F 19695 2010-10-29 16:51:02Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
      integer rtdb
c
      integer k, line, leading
      character*255 buf, key
      logical oprint
c
      oprint = .true.
c
c     Process any keys on the PYTHON directive
c
 1    if (inp_a(key)) then
         if (inp_compare(.false.,key,'print')) then
            oprint = .true.
         else if (inp_compare(.false.,key,'noprint')) then
            oprint = .false.
         endif
         goto 1
      endif
      call inp_clear_err
c
      if (oprint) then
         write(6,*)
         call util_print_centered(6,'NWChem Python program',40,.true.)
         write(6,*)
      endif
c
      open(1,file="nwchem.py",form="formatted",status="unknown")
c
c     Need to circumvent NWChem's processing of special characters
c
c     Also, python insists that the initial indent level is zero
c     so to permit NWChem python code to be indented within the
c     python block quietly strip off from all input lines
c     the amount of white space present on the first line
c
      line = 1
      leading = 0
 10   if (inp_read_physical_line(buf)) then
         if (inp_compare(.false.,buf,'end')) goto 20
         if (line .eq. 1 .and. buf.ne.' ') then
            do k = 1, len(buf)
               if (buf(k:k) .ne. ' ') goto 7
            enddo
 7          leading = k - 1
         endif
         line = line + 1
c
         do k = 1, leading
            if (buf(k:k) .ne. ' ') call errquit
     $           ('python_input: indentation must be >= that'//
     $           ' of first line',leading, INPUT_ERR)
         enddo
         write(1,15) (buf(k:k),k=leading+1,inp_strlen(buf))
         if (oprint)
     $        write(6,15) (buf(k:k),k=leading+1,inp_strlen(buf))
 15      format(255a1) 
         goto 10
      endif
c
 20   close(1,status='keep')
      if (oprint) then
         write(6,*)
         call util_flush(6)
      endif
c
      end

      subroutine tce_jacobi_lr2(d_r2,d_l2,k_l2_offset,omega,shift)
c
c $Id: tce_jacobi_lr2.F 24184 2013-05-04 00:43:17Z edo $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
      integer d_r2
      integer d_l2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_l2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer nprocs
      integer count
      integer next
      integer nxtask
      external nxtask
      logical noloadbalance
      logical nodezero         ! True if node 0
      double precision omega,shift
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_l2)))) 
      nprocs = ga_nnodes()
      count = 0
      next = nxtask(nprocs,1)
      do h3b = 1,noab
        do h4b = h3b,noab
          do p1b = noab+1,noab+nvab
            do p2b = p1b,noab+nvab
              if (noloadbalance.or.(next.eq.count)) then
                if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1            .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
                if ((.not.restricted).or.
     1            (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2            int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
                if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1            ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2            .eq. irrep_y) then
                  size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1                 * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                  if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1              call errquit('tce_jacobi_lr2: MA problem',0,MA_ERR)
                  call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1              int_mb(k_l2_offset),((((h3b-1)*noab+h4b-1)
     2              *nvab+p1b-noab-1)*nvab+p2b-noab-1))
                  i = 0
                  do h3 = 1,int_mb(k_range+h3b-1)
                    do h4 = 1,int_mb(k_range+h4b-1)
                      do p1 = 1,int_mb(k_range+p1b-1)
                        do p2 = 1,int_mb(k_range+p2b-1)
                          i = i + 1
                          dbl_mb(k_r2+i-1) = dbl_mb(k_r2+i-1)
     1           /((-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              +dbl_mb(k_evl_sorted+int_mb(k_offset+h3b-1)+h3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1))
     3              -omega)
                        enddo
                      enddo
                    enddo
                  enddo
                  call add_hash_block(d_l2,dbl_mb(k_r2),size,
     1              int_mb(k_l2_offset),((((h3b-1)*noab+h4b-1)
     2              *nvab+p1b-noab-1)*nvab+p2b-noab-1))
                  if (.not.ma_pop_stack(l_r2))
     1              call errquit('tce_jacobi_lr2: MA problem',1,MA_ERR)
                endif
                endif
                endif
                next = nxtask(nprocs,1)
              endif
              count = count + 1
            enddo
          enddo
        enddo
      enddo
      next = nxtask(-nprocs,1)
      call ga_sync()
      return
      end

C$Id: averagehist_5.F 19708 2010-10-29 18:04:21Z d3y133 $
      Program averagehist_5 

      Implicit none

      double precision au_to_kcal_mol, au_to_angs
      double precision rmin, rmax, rcut
      integer natom, nmcchain

      integer nob
      parameter(nob=200) ! bins in grid

      integer mxatom
      parameter(mxatom=100)

      double precision Number(NOB) ! grid
      double precision Number2(NOB),Number3(NOB,(2*mxatom)+2)
      double precision Number4(NOB)
      double precision sum, sum2, sum3((2*mxatom)+2)
      double precision sum4
      double precision RB(NOB), NDA(NOB) ! labels and average grid
      double precision UU, RCONFIG ! Store information
      double precision UUinit
      character*256 text ! text holder
      character*256 filename ! filename for read and write files
      character*4 prcfil ! stores mc number 0000
      character*256 suffix ! cocat holder
      double precision Coord(mxatom,3) ! Store information
      integer ndistatom
      integer atomlabel(mxatom)
      double precision distance(mxatom*(mxatom-1)/2)
      double precision averagedistance
      double precision averageenergy((2*mxatom)+2)
      double precision RB2(NOB), NDA2(NOB)
      double precision emin, emax
      double precision ohmin, ohmax
      double precision RB3(NOB), NDA3(NOB,(2*mxatom)+2)
      double precision averageohdistance
      double precision ohdistance(mxatom*4),hodistance(mxatom*4)
      double precision ohangle(mxatom*4),PI
      double precision ohanglemax
      double precision RB4(NOB),NDA4(NOB)
      double precision majordistance(2)
      double precision averageohangle
      double precision averagehbonds
      integer hold
      integer numberhbonds
      double precision weight, kb, temp, tempinit
      double precision DIPOLE(3)
      double precision mass(mxatom),dipmax
      double precision RB5(NOB), number5(NOB,3), NDA5(NOB,3), sum5(3)
      double precision averageMOI(3), averageDipole(3),averageDipole2(3)
      double precision AtomDist(mxatom), MOI(3,3), DMOI(3), PMOI(3,3)
      double precision PDIPOLE(3),wk(40)
      integer ik(20), stat

      external dsyevd

      double precision dipvec(2,3),diplen(2),rvec(3),rlen,theta(3)
      double precision  averagedipint, dipint, dipinthold
      double precision number6(NOB),RB6(NOB),sum6,NDA6(NOB)

      integer i,j,l,n,o,IR
      integer R, M, P

      character*16 eletags(mxatom)
      integer idum
      double precision dntmc_RAN3    

      double precision mhodistance(mxatom*4), hoangle(mxatom*4)
      double precision averagehoangle, hoanglemax
      double precision RB7(NOB), number7(NOB), NDA7(NOB), sum7

      integer hbcounter(mxatom*2)
      
C     Input Parameters
      PI = 3.141592653589793D+00 ! Constant PI
      au_to_kcal_mol = 627.5095D+00 ! Conversion from au to kcal/mole
      au_to_angs = 0.52917720832D+00 ! Conversion from au to Angstroms
      kb = 1.987905D-03 ! Constant Boltzmann kcal/mole/K
C      emin = -20.00D+00
C      emax = 5.00D+00
C      emin = -95430.00D+00 ! min for energy bins
C      emax = -95405.00D+00 ! max for energy bins
      ohmin = 1.50D+00 ! min for hbond length (selection) and bins
      ohmax = 2.50D+00 ! max for hbond length (selection) and bins
      ohanglemax = 60.00D+00 ! max for hbond angle (selection) and bins, min is 0
      hoanglemax = 120.00D+00 ! max for hbond angle (2nd) and bins, min is 0
      idum = 7

      Write(*,*)'Please input file name prefix:'
      Write(*,*)'Tempinit and Temp' !inital and final temperature (K) for scaled distributions
      Write(*,*)'rmin and rmax' !grid min and max for O-O distance (Ang.)
      Write(*,*)'natoms, nmcchains' !number of atoms per configuration and markov chains (files)
      Write(*,*)'rcut' !cutoff of RConfig (All values .le.)
      Write(*,*)'emin and emax' !grid min and max for Energies (kcal/mole)
      Write(*,*)'maximum dipole moment' !grid max for Dipole Moments(au)
      Write(*,*)'number of monomers' !number of distinct water monomers
      Write(*,*)'Array of oxygen atom numbers' !atom numbers of oxygen atoms of each monomer
      Write(*,*)'Array of atomic masses' !Atomic masses (amu or g/mol)
      Read(*,*)filename
      Read(*,*)tempinit, temp
      Read(*,*)rmin,rmax
      Read(*,*)natom,nmcchain
      Read(*,*)rcut
      Read(*,*)emin, emax
      Read(*,*)dipmax
      Read(*,*)ndistatom
      Read(*,*)(atomlabel(IR),IR=1,ndistatom)
      Read(*,*)(mass(IR),IR=1,natom)

C     Determine number of possible h-bonds + 2
       if (ndistatom .gt. 5) then
         hold = (2*ndistatom) + 2
       else
         hold = ((ndistatom*(ndistatom-1)/2) + 2)
       endif

C     Open Input/Output Files
      prcfil(1:4)='0000'
      Do i = 20, 19+nmcchain
        write(prcfil(1:4), '(i4)') i-19
        if((i-19).lt. 10) then
          prcfil(1:3)='000'
        else if((i-19).lt.100) then
          prcfil(1:2)='00'
        else if((i-19).lt.1000) then
          prcfil(1:1)='0'
        endif

        write(suffix, '(a,a)')'.MCdata.', prcfil(1:4)
        Open(Unit = i,FILE = filename(1:len_trim(filename))
     &    //suffix(1:len_trim(suffix))
     &    ,STATUS = 'OLD')
       enddo

        write(suffix, '(a,i3,a)')'.fdist.average.',int(temp),'K'
        Open(Unit = 10,FILE = filename(1:len_trim(filename))
     &     //suffix(1:len_trim(suffix))
     &     ,STATUS = 'REPLACE')

      prcfil(1:4)='0000'
      Do i = 100, 99+hold
        write(prcfil(1:4), '(i4)') i-100
        if((i-100).lt. 10) then
          prcfil(1:3)='000'
        else if((i-100).lt.100) then
          prcfil(1:2)='00'
        else if((i-100).lt.1000) then
          prcfil(1:1)='0'
        endif

        write(suffix, '(a,i3,a,a)')'.fdist.average.',int(temp),'K.hb.',
     &                             prcfil(1:4)
        Open(Unit = i,FILE = filename(1:len_trim(filename))
     &     //suffix(1:len_trim(suffix))
     &     ,STATUS = 'REPLACE')
      enddo

C     Setup Grid  General
      RB(1) = rmin + (rmax - rmin)/DBLE(NOB)
      RB2(1) = emin + (emax -emin)/DBLE(NOB)
      RB3(1) = ohmin + (ohmax-ohmin)/DBLE(NOB)
      RB4(1) = (ohanglemax)/DBLE(NOB)
      RB6(1) = -0.100D+00 + (0.200D+00)/DBLE(NOB)
      RB5(1) = (dipmax)/DBLE(NOB)
      RB7(1) = (hoanglemax)/DBLE(NOB)
      DO i = 2, nob
        RB(i) = RB(i-1) + (rmax - rmin)/DBLE(NOB)
        RB2(i) = RB2(i-1) + (emax -emin)/DBLE(NOB)
        RB3(i) = RB3(i-1) + (ohmax-ohmin)/DBLE(NOB)
        RB4(i) = RB4(i-1) + (ohanglemax)/DBLE(NOB)
        RB6(i) = RB6(i-1) + (0.200D+00)/DBLE(NOB)
        RB5(i) = RB5(i-1) + (dipmax)/DBLE(NOB)
        RB7(i) = RB7(i-1) + (hoanglemax/DBLE(NOB))
      ENDDO
      Do i = 1, nob
        RB(i) = RB(i) - ((rmax - rmin)/DBLE(NOB)/2.0D+00)
        RB2(i) = RB2(i) - ((emax -emin)/DBLE(NOB)/2.0D+00)
        RB3(i) = RB3(i) - ((ohmax-ohmin)/DBLE(NOB)/2.0D+00)
        RB4(i) = RB4(i) - ((ohanglemax)/DBLE(NOB)/2.0D+00) 
        RB6(i) = RB6(i) - ((0.200D+00)/DBLE(NOB)/2.00D+00)
        RB5(i) = RB5(i) - ((dipmax)/DBLE(NOB)/2.0D+00)
        RB7(i) = RB7(i) - ((hoanglemax)/DBLE(NOB)/2.0D+00)
      EndDo

C     Initialize Bins General
      Do i = 1, NOB 
       number(i) = 0.00D+00 
       number2(i) = 0.00D+00
       number4(i) = 0.00D+00
       number6(i) = 0.00D+00
       number7(i) = 0.00D+00
      Do j = 1, (2*mxatom)+2
       number3(i,j) = 0.00D+00
      EndDO
      Do j = 1, 3
        number5(i,j) = 0.00D+00
      ENDDO
      EndDo
      averagedistance = 0.00D+00
      Do i = 1, (2*mxatom)+2
      averageenergy(i) = 0.00D+00
      EndDo
      averageohdistance = 0.00D+00
      averageohangle = 0.00D+00
      averagehoangle = 0.00D+00
      averagehbonds = 0.00D+00
      averagedipint = 0.00D+00
      UUinit = 0.00D+00
      Do i = 1, 3
      averageMOI(i) = 0.00D+00
      averageDipole(i) = 0.00D+00
      averageDipole2(i) = 0.00D+00
      EndDo

C     Begin a Do loop over records General
      R = 0
      Do i = 20, 19+nmcchain

C     Loop over items in record with while loop
5678    Continue
C     Data read
        Do j = 1, natom
C          Read(i,*,END=1234)(Coord(j,IR),IR=1,3)
          Read(i,*,END=1234)eletags(j),(Coord(j,IR),IR=1,3)
        EndDo
        Read(i,*,END=1234)text,text,UU
        Read(i,*,END=1234)text,text,(DIPOLE(IR),IR=1,3)
        Read(i,*,END=1234)text,text,RCONFIG
C     Check if within scope of average
        if(RCONFIG .gt. rcut) goto 5678 ! not in scope, new data
        R = R + 1 ! have usable data

C     Set initial Energy only once
        if (UUinit .eq. 0.00D+00) then
          UUinit = UU
        endif
C     Analze data General O-O distance
        M = 0
        Do j = 1, ndistatom - 1
          Do l = j+1, ndistatom
            M = M + 1
            distance(M) = 0.00D+00
            Do n = 1, 3
              distance(M) = distance(M) +
     &        (Coord(atomlabel(j),n) - Coord(atomlabel(l),n))**2.00D+00
            EndDo
            distance(M) = DSQRT(distance(M))
          EndDo
        EndDo

C     Analyze some more data Dipole Interaction Energy
        dipint = 0.00D+00
        Do j = 1, ndistatom - 1
        Do l = j+1, ndistatom
          Do n = 1, 3
            rvec(n) = Coord(atomlabel(l),n) - Coord(atomlabel(j),n)
            dipvec(1,n) =Coord(atomlabel(j)+1,n)+Coord(atomlabel(j)+2,n)
            dipvec(1,n) = dipvec(1,n)/2.00D+00
            dipvec(1,n) = dipvec(1,n) - Coord(atomlabel(j),n)
            dipvec(2,n) =Coord(atomlabel(l)+1,n)+Coord(atomlabel(l)+2,n)
            dipvec(2,n) = dipvec(2,n)/2.00D+00
            dipvec(2,n) = dipvec(2,n) - Coord(atomlabel(l),n)
          ENDDO
          rlen = 0.00D+00
          diplen(1) = 0.00D+00
          diplen(2) = 0.00D+00
          Do n = 1, 3
            rlen = rlen + (rvec(n)**2.00D+00)
            diplen(1) = diplen(1) + (dipvec(1,n)**2.00D+00)
            diplen(2) = diplen(2) + (dipvec(2,n)**2.00D+00)
          ENDDO
          rlen = DSQRT(rlen)
          diplen(1) = DSQRT(diplen(1))
          diplen(2) = DSQRT(diplen(2))
          Do n = 1, 3
            rvec(n) = rvec(n)/rlen
            dipvec(1,n) = dipvec(1,n)/diplen(1)
            dipvec(2,n) = dipvec(2,n)/diplen(2)
          ENDDO
          Do n = 1, 3
            theta(n) = 0.00D+00
          ENDDO
          Do n = 1, 3
            theta(1) = theta(1) + (rvec(n)*dipvec(1,n))
            theta(2) = theta(2) + (rvec(n)*dipvec(2,n))
            theta(3) = theta(3) + (dipvec(1,n)*dipvec(2,n))
          ENDDO
          Do n = 1, 3
            theta(n) = DACOS(theta(n))
          ENDDO
          dipinthold = -2.00D+00*DCOS(theta(1))*DCOS(theta(2))
          dipinthold = dipinthold + DCOS(theta(3))
          dipinthold = dipinthold * (rmin**3.00D+00) / (rlen**3.00D+00)
          dipint = dipint + dipinthold
        ENDDO
        ENDDO
             
C     Analyze some more data O--H distance and O--H-O angle
C     Added Bisect - O--H  angle and Bisect - O distance
        P = 0
        Do j = 1, ndistatom
          Do l = 1, ndistatom
            if (.not.(l .eq. j)) then
              Do n = 1, 2
                P = P + 1
                ohdistance(P) = 0.00D+00
                hodistance(P) = 0.00D+00
                mhodistance(P) = 0.00D+00
                ohangle(P) = 0.00D+00
                hoangle(P) = 0.00D+00
                Do o = 1, 3
                  ohdistance(P) = ohdistance(P) +
     &            (Coord(atomlabel(j),o) - Coord(atomlabel(l)+n,o))
     &            **2.00D+00
                  hodistance(P) = hodistance(P) +
     &            (Coord(atomlabel(l)+n,o) - Coord(atomlabel(l),o))
     &            **2.00D+00
                  mhodistance(P) = mhodistance(P) +
     &            (Coord(atomlabel(j),o) - ((Coord(atomlabel(j)+1,o) 
     &            + Coord(atomlabel(j)+2,o))/2.00D+00))**2.00D+00
                  ohangle(P) = ohangle(P) +
     &            (Coord(atomlabel(l)+n,o) - Coord(atomlabel(j),o))*
     &            (Coord(atomlabel(l),o) - Coord(atomlabel(l)+n,o))
                  hoangle(P) = hoangle(P) +
     &            (Coord(atomlabel(l)+n,o) - Coord(atomlabel(j),o))*
     &            (Coord(atomlabel(j),o) - ((Coord(atomlabel(j)+1,o)
     &            + Coord(atomlabel(j)+2,o))/2.00D+00))
                enddo
                ohdistance(P) = DSQRT(ohdistance(P))
                hodistance(P) = DSQRT(hodistance(P))
                mhodistance(P) = DSQRT(mhodistance(P))
                ohangle(P) = ohangle(P)/(ohdistance(P)*hodistance(P))
                ohangle(P) = DACOS(ohangle(P))
                hoangle(P) = hoangle(P)/(mhodistance(P)*ohdistance(P))
                hoangle(P) = DACOS(hoangle(P))
              enddo
            endif
          enddo
        enddo

C     Init counter
        Do j = 1, (ndistatom*2)
          hbcounter(j) = 0
        EndDo
C     Analyze number of hbonds per hydrogen
        P = 0
        Do j = 1, ndistatom
          Do l = 1, ndistatom
            if (.not. l .eq. j) then
              Do n = 1, 2
              P = P + 1
       if ((ohdistance(P) .ge. ohmin).and.(ohdistance(P).le.ohmax)) then
            if (.not. (ohangle(P) .gt. (ohanglemax*PI/180.00D+00))) then
            if (.not. (hoangle(P) .gt. (hoanglemax*PI/180.00D+00))) then
              hbcounter((2*l)-2+n) = hbcounter((2*l)-2+n) + 1
            endif
            endif
       endif
              EndDo
            endif
          EndDo
        EndDo
C     Count only one hydrogen bond per hydrogen
       numberhbonds = 0
       Do j = 1, (ndistatom*2)
         if (hbcounter(j) .ge. 1) then
           numberhbonds = numberhbonds + 1
         endif
       EndDo

CC     Analyze some more data number of hydrogen bonds
C       numberhbonds = 0
C        Do j = 1, (ndistatom*(ndistatom -1)*2)
C       if ((ohdistance(j) .ge. ohmin).and.(ohdistance(j).le.ohmax)) then
C            if (.not. (ohangle(j) .gt. (ohanglemax*PI/180.00D+00))) then
C            if (.not. (hoangle(j) .gt. (hoanglemax*PI/180.00D+00))) then
C               numberhbonds = numberhbonds + 1
C             endif
C             endif
C           endif
C        EndDo

C     Print coordinates (random) of some configurations of each # of hbonds
        if ((dntmc_RAN3(idum)*1.00D+05) .lt. 1.00D+00) then
        Do j = 1, hold
          if (j-1 .eq. numberhbonds) then
            write(j+99,*)natom
            write(j+99,*)numberhbonds, 'hydrogen bonds'
            Do l = 1, natom
              write(j+99,*)eletags(l),(Coord(l,IR),IR=1,3)
            EndDo
          endif
        ENDDO
        endif
          if (numberhbonds .gt. hold-2) then
            write(hold+99,*)natom
            write(hold+99,*)numberhbonds, 'hydrogen bonds'
            Do l = 1, natom
              write(hold+99,*)eletags(l),(Coord(l,IR),IR=1,3)
            EndDo
          endif

C     Analyze some more data, determine weight
        if (temp .eq. tempinit) then
          weight = 1.00D+00
        else
        weight = (UU - UUinit)*au_to_kcal_mol/kb*
     &           ((1.D+00/temp)-(1.D+00/tempinit))
        weight = DEXP(-weight)
        endif

C     Analyze some more data, MOI and Projected Dipole Moment
C     Distance to all atoms
      Do j = 1, natom
        AtomDist(j) = 0.00D+00
        Do l = 1, 3
          AtomDist(j) = AtomDist(j) +(Coord(j,l)**2.00D+00)
        ENDDO
      ENDDO
C     MOI Calculation
      Do j = 1, 3
        Do l = 1, 3
          MOI(j,l) = 0.00D+00
          PMOI(j,l) = 0.00D+00
          DMOI(j) = 0.00D+00
          Do n = 1, natom
            if(j .eq. l) then
              MOI(j,l) = MOI(j,l) +
     & (mass(n)*(AtomDist(n)-(Coord(n,j)*Coord(n,l))))
            else
              MOI(j,l) = MOI(j,l) +
     & (-mass(n)*Coord(n,j)*Coord(n,l))
            endif
          ENDDO
        ENDDO
      ENDDO
C     Copy MOI Matrix
      Do j = 1,3
        Do l = 1,3
         PMOI(j,l) = MOI(j,l)
        ENDDO
      ENDDO
C     Find PMOI and DMOI
      call dsyevd('V','U',3,PMOI(1,1),3,DMOI(1),WK(1),40,IK(1),20,stat)
      if (.not. (stat .eq. 0)) then
      WRITE(10,*)'ERROR with MOI Diagonalization'
      goto 1234
      endif
C     Reorient Dipole
      Do j = 1, 3
        Pdipole(j) = 0.00D+00
        Do l = 1, 3
          Pdipole(j) = Pdipole(j)+(PMOI(l,j)*DIPOLE(l))
        ENDDO
      ENDDO
C     Convert DMOI to au
      Do j = 1, 3
        DMOI(j) = DMOI(j)/(au_to_angs**2.00D+00)
      ENDDO
C     End of MOI, Projected Dipole Moment Calculation

C    Bin Data  O-O distance
        Do j = 1, (ndistatom*(ndistatom - 1)/2)
          l = INT((((distance(j)-rmin)/(rmax-rmin))*DBLE(NOB))) + 1
          if (.not.((l .lt. 1).or.(l .gt. NOB))) then
          number(l) = number(l) + weight
          averagedistance = averagedistance + (weight*distance(j))
          endif
        ENDDO

C    Bin Data O--H distance
       Do j = 1, (ndistatom*(ndistatom - 1)*2)
          l = INT((((ohdistance(j)-ohmin)/(ohmax-ohmin))*DBLE(NOB))) + 1
          if (.not.((l .lt. 1).or.(l .gt. NOB))) then
          number2(l) = number2(l) + weight
          averageohdistance = averageohdistance + (weight*ohdistance(j))
          endif
       EndDo

C    Bin Data Dipole interactions
       l = INT((((dipint+0.100D+00)/(0.200D+00))*DBLE(NOB))) + 1
       if (.not.((l .lt. 1).or.(l .gt. NOB))) then
         if (numberhbonds .eq. 0) then
           number6(l) = number6(l) + weight
           averagedipint = averagedipint + (dipint*weight)
         endif
       endif

C    Bin Data 0--H-O angle
       Do j = 1, (ndistatom*(ndistatom - 1)*2)
          l = INT((((ohangle(j)/PI*180.00D+00)/(ohanglemax))
     &        *DBLE(NOB))) + 1
          if (.not.((l .lt. 1).or.(l .gt. NOB))) then
          number4(l) = number4(l) + weight
      averageohangle=averageohangle+(weight*ohangle(j)/PI*180.00D+00)
          endif
       EndDo

C    Bin Data Bisect - O--H angle
       Do j = 1, (ndistatom*(ndistatom - 1)*2)
          l = INT((((hoangle(j)/PI*180.00D+00)/(hoanglemax))
     &        *DBLE(NOB))) + 1
          if (.not.((l .lt. 1).or.(l .gt. NOB))) then
          number7(l) = number7(l) + weight
      averagehoangle=averagehoangle+(weight*hoangle(j)/PI*180.00D+00)
          endif
       EndDo

C    Bin Data Energy Partition
       if (ndistatom .gt. 5) then
         hold = (2*ndistatom) + 2
       else
         hold = ((ndistatom*(ndistatom-1)/2) + 2)
       endif
       l = INT(((((UU*au_to_kcal_mol)-emin)/(emax-emin))*DBLE(NOB))) + 1
       if (.not.((l .lt. 1).or.(l .gt. NOB))) then
       Do j = 1, hold
       if ((j .gt. 1) .and. (numberhbonds+2 .eq. j)) then
       number3(l,j) = number3(l,j) + weight
       averageenergy(j) = averageenergy(j) + (UU*au_to_kcal_mol*weight)
       if (j .eq. hold) then
       averagehbonds = averagehbonds + (weight*DBLE(numberhbonds))
       endif
       else if (j .eq. 1) then
       number3(l,j) = number3(l,j) + weight
       averageenergy(j) = averageenergy(j) + (UU*au_to_kcal_mol*weight)
       else if ((j .eq. hold) .and. (numberhbonds+2 .gt. j)) then
       number3(l,j) = number3(l,j) + weight
       averageenergy(j) = averageenergy(j) + (UU*au_to_kcal_mol*weight)
       averagehbonds = averagehbonds + (weight*DBLE(numberhbonds))
       endif
       EndDo
       endif

C    Bin Data Projected Dipole Moments
      Do j = 1, 3
        l = INT(ABS(PDIPOLE(j))/dipmax*DBLE(NOB)) + 1
        if (.not.((l .lt. 1).or.(l .gt. NOB))) then
        number5(l,j) = number5(l,j) + weight
        averageMOI(j) = averageMOI(j) + (DMOI(j)*weight)
        averageDIPOLE(j) = averageDIPOLE(j) + ABS(PDIPOLE(j)*weight)
        averageDIPOLE2(j) = averageDIPOLE2(j) +
     &   (DSQRT((PDIPOLE(1)**2.0D+00)+(PDIPOLE(2)**2.0D+00)+
     &         (PDIPOLE(3)**2.0D+00)-(PDIPOLE(j)**2.0D+00))*weight)
        endif
      ENDDO

C     Continue with new data GENERAL
      CONTINUE
      goto 5678
C     EOF Condition GENERAL
1234  CONTINUE
      EndDO   

C     Close Read Files
      Do i = 20, 19+nmcchain
        Close(i)
      EndDo    
      Do i = 100, 99+hold
        Close(i)
      EndDo     

C     Calculate Final Distributions
C     Determine number of possible h-bonds + 2
       if (ndistatom .gt. 5) then
         hold = (2*ndistatom) + 2
       else
         hold = ((ndistatom*(ndistatom-1)/2) + 2)
       endif

C     Sum Distributions
        sum  = 0.00D+00
        sum2 = 0.00D+00
      Do i = 1, hold
        sum3(i) = 0.00D+00
      EndDo
        sum4 = 0.00D+00
        sum7 = 0.00D+00
        sum6 = 0.00D+00
      Do i = 1, 3
        sum5(i) = 0.00D+00
      ENDDO
      Do i = 1, nob
          sum  = sum + number(i)
          sum2 = sum2 + number2(i)
        Do j = 1, hold 
          sum3(j) = sum3(j) + number3(i,j)
        ENDDO
          sum4 = sum4 + number4(i)
          sum7 = sum7 + number7(i)
          sum6 = sum6 + number6(i)
        Do j = 1, 3
          sum5(j) = sum5(j) + number5(i,j)
        ENDDO
      EndDo 

C     Normalize Distributions
      Do i = 1, nob
         NDA(i) = number(i)/sum
         NDA2(i) = number2(i)/sum2
         NDA4(i) = number4(i)/sum4
         NDA7(i) = number7(i)/sum7
         NDA6(i) = number6(i)/sum6
         Do j = 1, hold
           NDA3(i,j) = number3(i,j)/sum3(1)
         EndDo
         Do j = 1, 3
           NDA5(i,j) = number5(i,j)/sum5(j)
         ENDDO
      EndDo

C     Find Averages
      averagedistance = averagedistance/sum
      averageohdistance = averageohdistance/sum2
      averageohangle = averageohangle/sum4
      averagehoangle = averagehoangle/sum7
      averagedipint = averagedipint/sum6
      Do i = 1, hold
        averageenergy(i) = averageenergy(i)/sum3(i)
      ENDDO
      averagehbonds = averagehbonds/sum3(hold)
      Do i = 2, hold
        sum3(i) = sum3(i)/sum3(1)
      ENDDO
      Do i = 1, 3
        averageMOI(i) = averageMOI(i)/sum5(i)
        averageDIPOLE(i) = averageDIPOLE(i)/sum5(i)
        averageDIPOLE2(i) = averageDIPOLE2(i)/sum5(i)
      ENDDO

C     Write Distributions
      WRITE(10,*)'***************************************'
      WRITE(10,*)'O-O Distances in Ang.'
      WRITE(10,*)'Thermal average is ',averagedistance
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB(i),NDA(i)
      ENDDO
      WRITE(10,*)'***************************************'
      WRITE(10,*)'***************************************'
      WRITE(10,*)'O--H Distances in Ang.'
      WRITE(10,*)'Thermal average is ',averageohdistance
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB3(i),NDA2(i)
      ENDDO
      WRITE(10,*)'***************************************'
      WRITE(10,*)'***************************************'
      WRITE(10,*)'O--H-O Angle in Degrees'
      WRITE(10,*)'Thermal average is ',averageohangle
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB4(i),NDA4(i)
      ENDDO
      WRITE(10,*)'***************************************'
      WRITE(10,*)'***************************************'
      WRITE(10,*)'Bisect - O--H Angle in Degrees'
      WRITE(10,*)'Thermal average is ',averagehoangle
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB7(i),NDA7(i)
      ENDDO
      WRITE(10,*)'***************************************'
      WRITE(10,*)'***************************************'
      WRITE(10,*)'Energy in kcal/mol'
      WRITE(10,*)'Thermal average is ',averageenergy(1)
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB2(i),NDA3(i,1)
      ENDDO
      WRITE(10,*)'***************************************'
      Do j = 2, hold
      WRITE(10,*)'***************************************'
      WRITE(10,*)'Energy in kcal/mol of configurations'
      WRITE(10,"(A,I3,A)")'with ',(j-2),' hydrogen bonds'
      WRITE(10,*)'Thermal average is',averageenergy(j)
      WRITE(10,*)'Fraction of Total is ',sum3(j)
      if (j .eq. hold) then
      WRITE(10,*)'Average hydrogen bonds is ',averagehbonds
      endif
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB2(i),NDA3(i,j)
      ENDDO
      WRITE(10,*)'***************************************'
      EndDo
      WRITE(10,*)'***************************************'
      WRITE(10,*)'Dipole Int. Energy in Arb. Units'
      WRITE(10,*)'For non bonded monomers'
      WRITE(10,*)'Thermal average is ',averagedipint
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB6(i),NDA6(i)
      ENDDO
      WRITE(10,*)'***************************************'

      Do j = 1, 3
      WRITE(10,*)'***************************************'
      WRITE(10,*)'Principal Dipole Moments in au'
      WRITE(10,*)'related to principal axis ',(j)
      WRITE(10,*)'with an average MOI (au) of ',averageMOI(j)
      WRITE(10,*)'Thermal average Dipole Moment is ',averageDIPOLE(j)
      WRITE(10,*)'Average Perp. Dipole Moment is ',averageDIPOLE2(j)
      WRITE(10,*)'***************************************'
      Do i = 1, nob
      WRITE(10,*)RB5(i),NDA5(i,j)
      ENDDO
      WRITE(10,*)'***************************************'
      EndDo


C     Close Distribution File
      Close(10)

      end

C***********************************************************************
      double precision FUNCTION dntmc_RAN3(IDUM)
C***********************************************************************
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
c     N.R. FUNCTION ran3(idum)
c
      implicit none

      integer idum  ! input

      integer mbig, mseed, ma
      integer iff, mj, mk, mz, inext, inextp
      integer i, ii, k
      double precision fac
      parameter (mbig=1000000000,mseed=161803398,mz=0,fac=1.e-9)
      dimension ma(55)
      data iff /0/
      save iff, mj, ma, mk, inext, inextp
      if(idum.lt.0.or.iff.eq.0)then
        iff=1
        mj=mseed-iabs(idum)
        mj=mod(mj,mbig)
        ma(55)=mj
        mk=1
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.mz)mk=mk+mbig
          mj=ma(ii)
11      continue
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.mz)ma(i)=ma(i)+mbig
12        continue
13      continue
        inext=0
        inextp=31
        idum=1
      endif
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.mz)mj=mj+mbig
      ma(inext)=mj
      dntmc_ran3=mj*fac
      return
      end
C***********************************************************************
C End of double precision FUNCTION dntmc_RAN3(IDUM)
C***********************************************************************

      SUBROUTINE ccsdtq_lr_alpha_15_26_1(d_a,k_a_offset,d_b,k_b_offset,d
     &_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_26_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h5 h6 p13 p1 p2 p3 )_ytra + = -1 * Sum ( h11 h12 p9 ) * tra ( p9 p13 h11 h12 )_tra * y ( h5 h6 h11 h12 p1 p2 p3 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER h11b
      INTEGER h12b
      INTEGER p13b_1
      INTEGER p9b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p13b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p13b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     &int_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p13b-1
     &) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p13b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),in
     &t_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+p13b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_
     &mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_26_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      DO h11b = 1,noab
      DO h12b = h11b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p9b-1) .eq. int_mb(k_spin+
     &h11b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p9b-1),ieor(int_mb
     &(k_sym+h11b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_tra) THEN
      CALL TCE_RESTRICTED_4(p13b,p9b,h11b,h12b,p13b_1,p9b_1,h11b_1,h12b_
     &1)
      CALL TCE_RESTRICTED_8(h5b,h6b,h11b,h12b,p1b,p2b,p3b,p9b,h5b_2,h6b_
     &2,h11b_2,h12b_2,p1b_2,p2b_2,p3b_2,p9b_2)
      dim_common = int_mb(k_range+p9b-1) * int_mb(k_range+h11b-1) * int_
     &mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_26_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_26_1',2,MA_ERR)
      IF ((p9b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p13b_1 - noab - 1 + nvab * (p
     &9b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b
     &-1),2,4,3,1,1.0d0)
      END IF
      IF ((p13b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p9b_1 - noab - 1 + nvab * (p1
     &3b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b
     &-1),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_26_1'
     &,3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_26_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_26_1',5,MA_ERR)
      IF ((h12b .lt. h5b) .and. (p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h5b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h12b .lt. h5b) .and. (p1b .le. p9b) .and. (p9b .lt. p2b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h5b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p9b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,4,3,2,1,6,1.0d0)
      END IF
      IF ((h12b .lt. h5b) .and. (p2b .le. p9b) .and. (p9b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h5b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p3b-1),8,6,5,4,3,2,1,7,-1.0d0)
      END IF
      IF ((h12b .lt. h5b) .and. (p3b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h5b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p9b-1),7,6,5,4,3,2,1,8,1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h5b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,4,2,3,1,5,1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h5b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p1b .le. p9b) .and. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p9b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,4,2,3,1,6,-1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h5b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p2b .le. p9b) .and. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p3b-1),8,6,5,4,2,3,1,7,1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h5b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p3b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p9b-1),7,6,5,4,2,3,1,8,-1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h6b .le. h12b) .and. (p9b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,3,2,4,1,5,-1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h6b .le. h12b) .and. (p1b .le. p9b) .an
     &d. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p9b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,3,2,4,1,6,1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h6b .le. h12b) .and. (p2b .le. p9b) .an
     &d. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p3b-1),8,6,5,3,2,4,1,7,-1.0d0)
      END IF
      IF ((h11b .lt. h5b) .and. (h6b .le. h12b) .and. (p3b .le. p9b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h5b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p9b-1),7,6,5,3,2,4,1,8,1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h12b .lt. h6b) .and. (p9b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,4,1,3,2,5,-1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h12b .lt. h6b) .and. (p1b .le. p9b) .an
     &d. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p9b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,4,1,3,2,6,1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h12b .lt. h6b) .and. (p2b .le. p9b) .an
     &d. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p3b-1),8,6,5,4,1,3,2,7,-1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h12b .lt. h6b) .and. (p3b .le. p9b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p9b-1),7,6,5,4,1,3,2,8,1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,3,1,4,2,5,1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p1b .le. p9b) .and. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p9b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,3,1,4,2,6,-1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p2b .le. p9b) .and. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p3b-1),8,6,5,3,1,4,2,7,1.0d0)
      END IF
      IF ((h5b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p3b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p9b-1),7,6,5,3,1,4,2,8,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,2,1,4,3,5,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (p1b .le. p9b) .and. (p9b .lt. p2b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p9b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,2,1,4,3,6,1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (p2b .le. p9b) .and. (p9b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p3b-1),8,6,5,2,1,4,3,7,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (p3b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p9b-1),7,6,5,2,1,4,3,8,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_26_1'
     &,6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h11b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &26_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &26_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_26_1',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p13b-1),5,4,6,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (p1b - noab - 1 + nvab
     & * (p13b - noab - 1 + nvab * (h6b - 1 + noab * (h5b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_26_1'
     &,10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &26_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine btrans1(d_a,k_a_offset,ga,atpart2,nalength2)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
      integer d_a,k_a_offset
      integer ga
      integer atpart2
      integer nalength2(*)
c
      integer d_i1,l_i1_offset,k_i1_offset,size_i1
      character*255 filename
c
c     ======================================================================
c     factorized tile structure based code use share files for intermediates
c     ======================================================================
c
      call offset_btrans1_i1(l_i1_offset,k_i1_offset,size_i1,atpart2,
     1     nalength2)
      call tce_filename('btrans1_i1',filename)
      call createfile(filename,d_i1,size_i1)
      call btrans1_i1(d_a,k_a_offset,d_i1,k_i1_offset,atpart2,
     1     nalength2)
      call reconcilefile(d_i1,size_i1)
      call btrans1_i0(d_i1,k_i1_offset,ga,atpart2,nalength2)
      call deletefile(d_i1)
      if (.not. ma_pop_stack(l_i1_offset))
     1    call errquit('btrans1: ma problem',1,ma_err)
c
      end
c
      subroutine btrans1_i1(d_a,k_a_offset,d_c,k_c_offset,atpart2,
     1           nalength2)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
      integer d_a, k_a_offset
      integer d_c, k_c_offset
      integer atpart2,nalength2(*)
c
      integer dima,dima_sort
      integer dimb,dimb_sort
      integer dimc,dimc_sort
      integer dim_common
      integer k_a,l_a
      integer k_b,l_b
      integer k_c,l_c
      integer g1b,g2b
      integer g1,g2
      integer jb
      integer j,k,j_ind,j1
c
      integer nxtask
      integer next
      integer nprocs
      integer count
      external nxtask
c
      nprocs=ga_nnodes()
      count=0
      next=nxtask(nprocs,1)
c
      j_ind=0
      do jb=1,atpart2
      do g1b=1,noab+nvab
         if (next.eq.count) then
            dimc=int_mb(k_range+g1b-1)*nalength2(jb)
            if (.not.ma_push_get(mt_dbl,dimc,'noname',l_c,k_c))
     1          call errquit('btrans1_i1: ma problem',1,ma_err)
            call dfill(dimc,0.d0,dbl_mb(k_c),1)
            do g2b=1,noab+nvab
               if ((.not.restricted).or.(int_mb(k_spin+g2b-1)
     1              +int_mb(k_spin+g1b-1)).ne.4) then
               if (int_mb(k_spin+g2b-1).eq.int_mb(k_spin+g1b-1)) then
               if (ieor(int_mb(k_sym+g2b-1),int_mb(k_sym+g1b-1)).eq.
     1             0) then
                  dima=int_mb(k_range+g1b-1)*int_mb(k_range+g2b-1)
                  dima_sort = int_mb(k_range+g1b-1)
                  dim_common=int_mb(k_range+g2b-1)
                  if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
     1            call errquit('btrans1_i1: ma problem',2,ma_err)
                  call get_hash_block(d_a,dbl_mb(k_a),dima,
     1                 int_mb(k_a_offset),(g2b-1)+(g1b-1)*(noab+nvab))
                  dimb=int_mb(k_range+g2b-1)*nalength2(jb)
                  dimb_sort=nalength2(jb)
                  if(.not.ma_push_get(mt_dbl,dimb,'noname',l_b,k_b))
     1            call errquit('btrans1_i1: ma problem',3,ma_err)
                  do j=1,nalength2(jb)
                     j1=j_ind+j
                    do g2=1,int_mb(k_range+g2b-1)
                      dbl_mb(k_b+(g2-1)+(j-1)*int_mb(k_range+g2b-1))=
     1                dbl_mb(k_movecs_sorted+
     1                (j1-1)+(int_mb(k_offset+g2b-1)+g2-1)*nbf)
                    enddo
                  enddo
                  call dgemm('t','n',dima_sort,dimb_sort,dim_common,
     1                      1.d0,dbl_mb(k_a),dim_common,dbl_mb(k_b),
     1                      dim_common,1.d0,dbl_mb(k_c),dima_sort)
                  if (.not.ma_pop_stack(l_b))
     1            call errquit('btrans1_i1:ma problem',4,ma_err)
                  if (.not.ma_pop_stack(l_a))
     1            call errquit('btrans1_i1: ma problem',5,ma_err)
               endif
               endif
               endif
            enddo
            call put_hash_block(d_c,dbl_mb(k_c),dimc,
     1           int_mb(k_c_offset),
     1           (g1b-1)+(jb-1)*(noab+nvab))
            if(.not.ma_pop_stack(l_c))
     1      call errquit('btrans1_i1: ma problem',6,ma_err)
            next = nxtask(nprocs,1)
         endif
         count=count+1
      enddo
      j_ind=j_ind+nalength2(jb)
      enddo
      next = nxtask(-nprocs,1)
      call ga_sync( )
      return
      end
c
      subroutine btrans1_i0(d_a,k_a_offset,ga,atpart2,nalength2)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
      integer d_a,k_a_offset
      integer k_1pdm_ao
      integer ga
      integer atpart2
      integer nalength2(*)
c
      integer k_b,l_b,dimb,dimb_sort
      integer k_a,l_a,dima,dima_sort
      integer k_c,l_c,dimc,dimc_sort
      integer dim_common
c
      integer ib,jb
      integer i,j,i1
      integer ihi,ilo
      integer jhi,jlo
      double precision res
      integer i_ind, j_ind
      integer g1b,g1
c
      integer nxtask
      integer next
      integer nprocs
      integer count
      external nxtask
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      i_ind=0
      do ib=1,atpart2
      j_ind=0
      do jb=1,atpart2
         if (next.eq.count) then
            dimc=nalength2(ib)*nalength2(jb)
            if (.not.ma_push_get(mt_dbl,dimc,'noname',l_c,k_c))
     1      call errquit('btrans1_i0: ma problem',1,ma_err)
            call dfill(dimc,0.d0,dbl_mb(k_c),1)
            do g1b=1,noab+nvab
               dima=int_mb(k_range+g1b-1)*nalength2(jb)
               dima_sort = nalength2(jb)
               if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
     1         call errquit('btrans1_i0: ma problem',2,ma_err)
               dimb=int_mb(k_range+g1b-1)*nalength2(ib)
               dimb_sort = nalength2(ib)
               dim_common=int_mb(k_range+g1b-1)
               if (.not.ma_push_get(mt_dbl,dimb,'noname',l_b,k_b))
     1            call errquit('btrans1_i0: ma problem',3,ma_err)
               call get_hash_block(d_a,dbl_mb(k_a),dima,
     1              int_mb(k_a_offset),
     1              (g1b-1)+(jb-1)*(noab+nvab))
               do i=1,nalength2(ib)
                  i1=i_ind+i
               do g1=1,int_mb(k_range+g1b-1)
                  dbl_mb(k_b+(g1-1)+(i-1)*int_mb(k_range+g1b-1))=
     1            dbl_mb(k_movecs_sorted+
     1            (i1-1)+(int_mb(k_offset+g1b-1)+g1-1)*nbf)
               enddo
               enddo
               call dgemm('t','n',dima_sort,dimb_sort,dim_common,1.d0,
     1              dbl_mb(k_a),dim_common,
     1              dbl_mb(k_b),dim_common,1.d0,dbl_mb(k_c),dima_sort)
               if(.not.ma_pop_stack(l_b))
     1          call errquit('btrans1_i0: ma problem',4,ma_err)
               if(.not.ma_pop_stack(l_a))
     1         call errquit('btrans1_hh_i0: ma problem',5,ma_err)
            enddo
            if (restricted) then
               do i=1,dimc
                  dbl_mb(k_c+i-1)=2.d0*dbl_mb(k_c+i-1)
               enddo
            endif
            ilo=i_ind+1
            ihi=i_ind+nalength2(ib)
            jlo=j_ind+1
            jhi=j_ind+nalength2(jb)
            call ga_put(ga,jlo,jhi,ilo,ihi,dbl_mb(k_c),nalength2(jb))
            if (.not.ma_pop_stack(l_c))
     1      call errquit('btrans1_hh_i0: ma problem',6,ma_err)
            next = nxtask(nprocs,1)
         endif
         count = count + 1
         j_ind=j_ind+nalength2(jb)
      enddo
         i_ind=i_ind+nalength2(ib)
      enddo
      next = nxtask(-nprocs,1)
      call ga_sync( )
      return
      end
c
      subroutine offset_btrans1_i1(l_a_offset,k_a_offset,size,
     1           atpart2,nalength2)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
      integer l_a_offset
      integer k_a_offset
      integer size
      integer atpart2
      integer nalength2(*)
c
      integer length
      integer addr
      integer ib
      integer g1b
c
      length = 0
      do ib=1,atpart2
      do g1b=1,noab+nvab
         length=length+1
      enddo
      enddo
c
      if (.not. ma_push_get(mt_int,2*length+1,'noname',l_a_offset,
     1    k_a_offset))
     1  call errquit('offset_btrans1_i1',0,ma_err)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      do ib=1,atpart2
      do g1b = 1, noab+nvab
         addr = addr + 1
         int_mb(k_a_offset+addr) = (g1b-1)+(ib-1)*(noab+nvab)
         int_mb(k_a_offset+length+addr) = size
         size = size + int_mb(k_range+g1b-1)*nalength2(ib)
      enddo
      enddo
      end
c $Id: btrans1.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup task
C> @{
C>
C> \brief Generic interface for Molecular Dynamics (MD) simulations
C>
C> \return Return .true. if successfull, and .false. otherwise.
C>
      logical function task_dynamics(rtdb)
*
* $Id: task_dynamics.F 23070 2012-11-08 01:04:52Z niri $
*
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb !< [Input] The RTDB handle
c
c     Generic NWChem interface to perform molecular dynamics simulations
c
c     RTDB input parameters
c     ---------------------
c     task:theory (string) - name of level of theory to use
c     
c     RTDB output parameters
c     ----------------------
c     task:status (logical)- T/F for success/failure
c     if (status) then
c     .  task:cputime (real)  - cpu time to execute the task
c     .  task:walltime (real) - wall time to execute the task
c
c     Also returns status through the function value
c
      logical argos,nwmd
      external argos,nwmd
c
      logical task_smd_dynamics
      external task_smd_dynamics
c
      logical  md_driver
      external md_driver
c
      logical  task_freq, leps_gradient, mc_main
      external task_freq, leps_gradient, mc_main
c
      logical status
      double precision cpu,wall
c
      character*32 theory
c
      call ecce_print_module_entry('task dynamics')
c
      task_dynamics = .false.
c
      cpu  = util_cpusec()
      wall = util_wallsec()
c
c     Right now only have a QM component
c
      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $     call errquit('task:energy: theory not specified',0, RTDB_ERR)
c
c     Set output parameters as if failed
c
      status = rtdb_delete(rtdb, 'task:dynamics')
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, .false.))
     $     call errquit('task_dynamics: failed to invalidate status',0,
     &       RTDB_ERR)
c
c     Actually do the deed
c
      if(theory.eq."smd") then
c         write(*,*) "smd dynamics is disabled for now"
        status = task_smd_dynamics(rtdb)
c      else if(theory.eq.'leps') then
c        status = task_freq(rtdb)
c        status = mc_main(rtdb,leps_gradient,theory)
      elseif(theory.eq.'argos') then
        status=argos(rtdb)
      else
        status=nwmd(rtdb)
      end if
c
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - wall
c
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, status))
     $   call errquit('task_dynamics: failed to set status',0, RTDB_ERR)
c
      if (status) then
c
         if (.not. rtdb_put(rtdb, 'task:cputime', mt_dbl, 1, cpu))
     $        call errquit('task_dynamics: failed storing cputime',0,
     &       RTDB_ERR)
         if (.not. rtdb_put(rtdb, 'task:walltime', mt_dbl, 1, wall))
     $        call errquit('task_dynamics: failed storing walltime',0,
     &       RTDB_ERR)
c
      endif
c
      call ecce_print1('cpu time', mt_dbl, cpu, 1)
      call ecce_print1('wall time', mt_dbl, wall, 1)
      if (status) then
         call ecce_print_module_exit('task dynamics', 'ok')
      else
         call ecce_print_module_exit('task dynamics', 'failed')
      endif
c         
      task_dynamics = status
c
      end

      SUBROUTINE ccsdtq_lr_alpha_15_48_5_7_3_2(d_a,k_a_offset,d_c,k_c_of
     &fset)
C     $Id: ccsdtq_lr_alpha_15_48_5_7_3_2.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i5 ( h10 h11 h12 h18 p5 p7 p8 p9 )_y + = 1 * y ( h10 h11 h12 h18 p5 p7 p8 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h11b
      INTEGER h12b
      INTEGER h18b
      INTEGER p5b
      INTEGER p7b
      INTEGER p8b
      INTEGER p9b
      INTEGER dimc
      INTEGER h10b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER h18b_1
      INTEGER p5b_1
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER p9b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h10b = 1,noab
      DO h11b = h10b,noab
      DO h12b = h11b,noab
      DO h18b = h12b,noab
      DO p5b = noab+1,noab+nvab
      DO p7b = p5b,noab+nvab
      DO p8b = p7b,noab+nvab
      DO p9b = p8b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b
     &-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h18b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+p9b-1).
     &ne.16)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h12b
     &-1)+int_mb(k_spin+h18b-1) .eq. int_mb(k_spin+p5b-1)+int_mb(k_spin+
     &p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_m
     &b(k_sym+h12b-1),ieor(int_mb(k_sym+h18b-1),ieor(int_mb(k_sym+p5b-1)
     &,ieor(int_mb(k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),int_mb(k_sym+p9
     &b-1)))))))) .eq. irrep_y) THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h11b-1) * int_mb(k_
     &range+h12b-1) * int_mb(k_range+h18b-1) * int_mb(k_range+p5b-1) * i
     &nt_mb(k_range+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+p9b-
     &1)
      CALL TCE_RESTRICTED_8(h10b,h11b,h12b,h18b,p5b,p7b,p8b,p9b,h10b_1,h
     &11b_1,h12b_1,h18b_1,p5b_1,p7b_1,p8b_1,p9b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h11b-1) * int_
     &mb(k_range+h12b-1) * int_mb(k_range+h18b-1) * int_mb(k_range+p5b-1
     &) * int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range
     &+p9b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_48_5_7_3_2',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_48_5_7_3_2',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p9b_1
     & - noab - 1 + nvab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 
     &+ nvab * (p5b_1 - noab - 1 + nvab * (h18b_1 - 1 + noab * (h12b_1 -
     & 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h18
     &b-1),int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8
     &b-1),int_mb(k_range+p9b-1),8,7,6,5,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_48_5_
     &7_3_2',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_48_5_7_3_2',3,MA_ERR)
      CALL TCE_SORT_8(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h18b-1),int_mb(k_range+h12b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h10b-1),8,7,6,5,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (p8b - noab - 1 + nvab * (p7b - noab - 1 + nvab
     & * (p5b - noab - 1 + nvab * (h18b - 1 + noab * (h12b - 1 + noab * 
     &(h11b - 1 + noab * (h10b - 1)))))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_48_5_
     &7_3_2',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &48_5_7_3_2',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE vib_BDIHA5(NOINT,NDIM,IZMAT,CARTC,DIHANG,BMAT)
* $Id: vib_bdiha5.F 19708 2010-10-29 18:04:21Z d3y133 $
C*MODULE VIB  *DECK BDIHA5
C* 21 MAR 1983 - STE * 9 MAR 1983 - STE
C********************************************************************
C*       ROUTINE BDIHA5(IW,NOINT,NDIM,IZMAT,CARTC,DIHANG,BMAT)
C*
C*    AUTHOR: S. T. ELBERT (AMES LABORATORY - USDOE)  DATE: 25 FEB 1983
C*
C*    PURPOSE -
C*       EVALUATE B MATRIX AND DIHEDRAL ANGLE BETWEEN 5 ATOMS FORMING
C*                *            ***      *             *
C*       TWO PLANES HAVING ONE ATOM IN COMMON
C*
C*    ON ENTERING -
C*       IW     - INTEGER (LOGICAL UNIT NO.)
C*                ERROR MESSAGE FILE
C*       NOINT  - INTEGER
C*                NO. OF INTERNAL COORDINATE BEING EVALUATED
C*       NDIM   - INTEGER
C*                NO. OF COORDINATES = 3 * NATOMS
C*       IZMAT  - INTEGER (5)
C*                LIST OF ATOMS INVOLVED
C*       CARTC  - W.P. REAL (3,NATOMS)
C*                CARTESIAN COORDINATES FOR ATOMS
C*
C*    ON EXITING -
C*       DIHANG - W.P. REAL
C*                DIHEDRAL ANGLE IN DEGREES
C*       BMAT   - W.P. REAL (NDIM,NDIM)
C*                B MATRIX (TRANSFORMS INTERNAL COORD TO CART. COORD
C*                          TO FIRST ORDER)
C*
C********************************************************************
C
C                    DECLARATIONS
C
      IMPLICIT NONE 
C
      integer noint, ndim
      integer izmat(5)
      double precision cartc(3,*)
      double precision bmat(ndim,ndim)
      double precision dihang
c
c:old      DIMENSION IZMAT(5), CARTC(3,1), BMAT(NDIM,NDIM)
c:old     *         ,A(3),B(3),C(3),D(3),E1(3),E2(3),E3(3)
C
      double precision one, zero
      PARAMETER (ZERO=0.0D+00, ONE=1.0D+00)
c
      double precision A(3),B(3),C(3),D(3)
      double precision E1(3), E2(3), E3(3)
      double precision adote2, cdote1, e1de2, sindi
      double precision axbmag, cxdmag, axbmi, cxdmi
      double precision f1, f2, f4, f5
      double precision b1, b2, b3, b4, b5
      integer iatom, jatom, katom, latom, matom, ixyz
      integer i, j, k, l, m, n
      
C
C---------------------------------------------------------------------
C
C           THE FIRST THREE ATOMS ARE ON THE FIRST PLANE
C           THE  LAST THREE ATOMS ARE ON THE SECOND PLANE
C
      IATOM = IZMAT(1)
      JATOM = IZMAT(2)
      KATOM = IZMAT(3)
      LATOM = IZMAT(4)
      MATOM = IZMAT(5)
C
C           DEFINE VECTORS FROM PIVOT (THIRD) ATOM THAT DEFINE PLANES
C                    A = I - K   AND  B = J - K   DEFINE FIRST PLANE
C                    C = L - K   AND  D = M - K   DEFINE SECOND PLANE
C
      DO 110 IXYZ=1,3
         A(IXYZ) = CARTC(IXYZ,IATOM) - CARTC(IXYZ,KATOM)
         B(IXYZ) = CARTC(IXYZ,JATOM) - CARTC(IXYZ,KATOM)
         C(IXYZ) = CARTC(IXYZ,LATOM) - CARTC(IXYZ,KATOM)
         D(IXYZ) = CARTC(IXYZ,MATOM) - CARTC(IXYZ,KATOM)
  110 CONTINUE
C
C              E1 = A X B  IS PERPENDICULAR TO FIRST PLANE
C
      E1(1) = A(2)*B(3) - A(3)*B(2)
      E1(2) = A(3)*B(1) - A(1)*B(3)
      E1(3) = A(1)*B(2) - A(2)*B(1)
      AXBMAG = SQRT(E1(1)**2 + E1(2)**2 + E1(3)**2)
      IF(ONE+AXBMAG.EQ.ONE) GO TO 810
      AXBMI = ONE / AXBMAG
C
C              E2 = C X D  IS PERPENDICULAR TO FIRST PLANE
C
      E2(1) = C(2)*D(3) - C(3)*D(2)
      E2(2) = C(3)*D(1) - C(1)*D(3)
      E2(3) = C(1)*D(2) - C(2)*D(1)
      CXDMAG = SQRT(E2(1)**2 + E2(2)**2 + E2(3)**2)
      IF(ONE+CXDMAG.EQ.ONE) GO TO 820
      CXDMI = ONE / CXDMAG
C
C              NORMALIZE E1 AND E2
C
      DO 120 IXYZ=1,3
         E1(IXYZ) = AXBMI * E1(IXYZ)
         E2(IXYZ) = CXDMI * E2(IXYZ)
  120 CONTINUE
C
C        THE DIRECTION OF E2 IS DEFINED SUCH THAT WHEN THE PLANES ARE
C        ROTATED ALONG THE INTERSECTION E3 (= E1 X E2) SO THEY COINCIDE
C        (DIHEDRAL ANGLE = 0), THEN ATOMS 1 AND 4 LIE ON THE SAME
C        SIDE OF E3.  IF ATOMS 1 AND/OR 4 LIE ON E3, THEN
C        ATOMS 2 AND/OR 5 ARE USED.
C
      ADOTE2 = A(1)*E2(1) + A(2)*E2(2) + A(3)*E2(3)
      IF(ONE+ADOTE2.EQ.ONE) ADOTE2 = B(1)*E2(1)+B(2)*E2(2)+B(3)*E2(3)
      CDOTE1 = C(1)*E1(1) + C(2)*E1(2) + C(3)*E1(3)
      IF(ONE+CDOTE1.EQ.ONE) CDOTE1 = D(1)*E1(1)+D(2)*E1(2)+D(3)*E1(3)
      IF(ADOTE2*CDOTE1 .LT. ZERO) GO TO 140
C
C        CHANGE SENSE OF E2 SO A (OR B) WILL BE ON SAME SIDE
C        OF E1 X E2 AS C (OR D)
C
         ADOTE2=-ADOTE2
         DO 130 IXYZ=1,3
            E2(IXYZ) = -E2(IXYZ)
  130    CONTINUE
  140 CONTINUE
C
C           EVALUATE DIHEDRAL ANGLE    0 < ABS(DIHANG) < 180
C           ANGLE IS POSITIVE FOR SECOND PLANE "ABOVE" ATOM 1
C           ANGLE IS NEGATIVE FOR SECOND PLANE "BELOW" ATOM 1
C
      E1DE2 = E1(1)*E2(1) + E1(2)*E2(2) + E1(3)*E2(3)
      IF(ABS(E1DE2).GT.ONE) GO TO 840
      IF(ABS(E1DE2).EQ.ONE) GO TO 830
      DIHANG = ACOS(E1DE2)
      IF(ADOTE2 .GT. ZERO) DIHANG = -DIHANG
      SINDI = ONE / SIN(DIHANG)
C
C         E3 = E1 X E2  IS ALONG THE INTERSECTION LINE OF THE TWO PLANES
C
      E3(1) = SINDI * (E1(2)*E2(3) - E1(3)*E2(2))
      E3(2) = SINDI * (E1(3)*E2(1) - E1(1)*E2(3))
      E3(3) = SINDI * (E1(1)*E2(2) - E1(2)*E2(1))
C
      F1 =  AXBMI * (B(1)*E3(1) + B(2)*E3(2) + B(3)*E3(3))
      F2 = -AXBMI * (A(1)*E3(1) + A(2)*E3(2) + A(3)*E3(3))
      F4 = -CXDMI * (D(1)*E3(1) + D(2)*E3(2) + D(3)*E3(3))
      F5 =  CXDMI * (C(1)*E3(1) + C(2)*E3(2) + C(3)*E3(3))
C
      I = 3*IATOM - 3
      J = 3*JATOM - 3
      K = 3*KATOM - 3
      L = 3*LATOM - 3
      M = 3*MATOM - 3
C
C           CALCULATE B MATRIX ELEMENTS
C
      DO 160 N=1,3
         B1 = E1(N) * F1
         B2 = E1(N) * F2
         B4 = E2(N) * F4
         B5 = E2(N) * F5
         B3 = -(B1+B2+B4+B5)
         BMAT(NOINT,I+N) = B1
         BMAT(NOINT,J+N) = B2
         BMAT(NOINT,K+N) = B3
         BMAT(NOINT,L+N) = B4
         BMAT(NOINT,M+N) = B5
  160 CONTINUE
      RETURN
C
C               ERROR MESSAGE SECTION
C
  810 CONTINUE
      WRITE(6,910)
      GO TO 880
C
  820 CONTINUE
      WRITE(6,920)
      GO TO 880
C
  830 CONTINUE
      WRITE(6,930)
      GO TO 880
C
  840 CONTINUE
      WRITE(6,940)
C
  880 CONTINUE
      WRITE(6,901) NOINT,IATOM,(CARTC(IXYZ,IATOM),IXYZ=1,3)
     *                   ,JATOM,(CARTC(IXYZ,JATOM),IXYZ=1,3)
     *                   ,KATOM,(CARTC(IXYZ,KATOM),IXYZ=1,3)
     *                   ,LATOM,(CARTC(IXYZ,LATOM),IXYZ=1,3)
     *                   ,MATOM,(CARTC(IXYZ,MATOM),IXYZ=1,3)
      WRITE(6,900)
C
  900 FORMAT('0THESE MESSAGES BROUGHT TO YOU BY ROUTINE BDIHA5 *****')
  901 FORMAT('0INTERNAL COORDINATE',I4,' (DIHEDRAL ANGLE BETWEEN TWO'
     *      ,' PLANES WITH ONE ATOM IN COMMON) USES THESE ATOMS'/
     *       (I10,3F20.6))
  910 FORMAT('0***** ERROR - FIRST THREE ATOMS ARE LINEAR *****')
  920 FORMAT('0***** ERROR -- LAST THREE ATOMS ARE LINEAR *****')
  930 FORMAT('0***** ERROR - ALL FIVE ATOMS LIE IN THE SAME PLANE ****')
  940 FORMAT('0***** ERROR - COSIN OF DIHEDRAL ANGLE IS GREATER THAN 1')
      END

      SUBROUTINE ccsdtq_lambda3_22_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lambda3_22_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 p7 h10 h11 h12 )_vt + = 1 * Sum ( p8 p9 ) * t ( p7 p8 p9 h10 h11 h12 )_t * v ( h4 h5 p8 p9 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER p7b
      INTEGER h10b
      INTEGER h11b
      INTEGER h12b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p8b
      INTEGER p9b
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER p9b_1
      INTEGER h10b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p8b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p7b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h11b = h10b,noab
      DO h12b = h11b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)
     &+int_mb(k_spin+h12b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h1
     &2b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h11b-1),i
     &nt_mb(k_sym+h12b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+h10b-1) * int_mb(k_range+h11b-1) * int
     &_mb(k_range+h12b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_22_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p8b = noab+1,noab+nvab
      DO p9b = p8b,noab+nvab
      IF (int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+p9b-1)
     & .eq. int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h1
     &2b-1)) THEN
      IF (ieor(int_mb(k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(
     &k_sym+p9b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h11b-1),i
     &nt_mb(k_sym+h12b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p7b,p8b,p9b,h10b,h11b,h12b,p7b_1,p8b_1,p9b_1
     &,h10b_1,h11b_1,h12b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p8b,p9b,h4b_2,h5b_2,p8b_2,p9b_2)
      dim_common = int_mb(k_range+p8b-1) * int_mb(k_range+p9b-1)
      dima_sort = int_mb(k_range+p7b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+h11b-1) * int_mb(k_range+h12b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_22_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda3_22_1',2,MA_ERR)
      IF ((p9b .lt. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (p7b_1 - 
     &noab - 1 + nvab * (p9b_1 - noab - 1 + nvab * (p8b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p7b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),6,5,4,3,2,1,1.0d0)
      END IF
      IF ((p8b .lt. p7b) .and. (p7b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (p9b_1 - 
     &noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p8b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),6,5,4,2,3,1,-1.0d0
     &)
      END IF
      IF ((p7b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (p9b_1 - 
     &noab - 1 + nvab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+p9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),6,5,4,1,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda3_22_1',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_22_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda3_22_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - 1 + (noab+nvab) * (p8b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda3_22_1',6,M
     &A_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p8b .eq. p9b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda3_22_1
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda3_22_1
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda3_22_1',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+h11b-
     &1),int_mb(k_range+h10b-1),int_mb(k_range+p7b-1),2,1,6,5,4,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h12b 
     &- 1 + noab * (h11b - 1 + noab * (h10b - 1 + noab * (p7b - noab - 1
     & + nvab * (h5b - 1 + noab * (h4b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda3_22_1',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda3_22_1
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

c
c $Id: list_const.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE list_const(ncons,ntcons,consatm)

      implicit none

      include 'p_array.inc'
      include 'p_input.inc'
      include 'cm_atom.inc'
      include 'cm_cons.inc'

      integer i,j,k
      integer ncons,ntcons,consatm

      dimension consatm(mxcons,2)

      ntcons=0

      do i=1,natms

       do j=1,ncons

        if(atmtype(i).eq.consatm(j,1))then

         ntcons=ntcons+1
         if(ntcons.gt.mxcons2)then
          write(output,*)'Increase mxcons2 to ',ntcons
          stop
         endif

         k=consatm(j,2)-consatm(j,1)
         conlist(ntcons,1)=i
         conlist(ntcons,2)=i+k
         conlist(ntcons,3)=j

        endif

       enddo

      enddo
 
      return

      END

      logical function argos_prepare_ang(lbnd,mbnd,nbnd,lang,mang,nang)
c
c $Id: argos_prepare_ang.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to extend the list of angles from a list of bonds
c
c     in  : lbnd(2,mbnd) = list of bond indices
c         : mbnd         = dimension of the bond index list
c         : nbnd         = number of bonds
c         : mang         = dimension of the angle index list
c     out : lang(3,mang) = list of angle indices
c         : nang         = number of angles
c
c     function returns .false. if mang < nang
c
      implicit none
c
      integer mbnd,mang
      integer nbnd,nang
      integer lbnd(2,mbnd),lang(3,mang)
      integer i,j,k,ltemp
c
c     determine the list of angles
c     ----------------------------
c
      argos_prepare_ang=.false.
      do 1 i=1,nbnd-1
      do 2 j=i+1,nbnd
      if(lbnd(1,i).eq.lbnd(1,j)) then
      if(nang.ge.mang) return
      nang=nang+1
      lang(1,nang)=lbnd(2,i)
      lang(2,nang)=lbnd(1,i)
      lang(3,nang)=lbnd(2,j)
      else
      if(lbnd(2,i).eq.lbnd(1,j)) then
      if(nang.ge.mang) return
      nang=nang+1
      lang(1,nang)=lbnd(1,i)
      lang(2,nang)=lbnd(2,i)
      lang(3,nang)=lbnd(2,j)
      else
      if(lbnd(1,i).eq.lbnd(2,j)) then
      if(nang.ge.mang) return
      nang=nang+1
      lang(1,nang)=lbnd(2,i)
      lang(2,nang)=lbnd(1,i)
      lang(3,nang)=lbnd(1,j)
      else
      if(lbnd(2,i).eq.lbnd(2,j)) then
      if(nang.ge.mang) return
      nang=nang+1
      lang(1,nang)=lbnd(1,i)
      lang(2,nang)=lbnd(2,i)
      lang(3,nang)=lbnd(1,j)
      endif
      endif
      endif
      endif
    2 continue
    1 continue
c
      do 3 i=1,nang
      if(lang(1,i).gt.lang(3,i)) then
      ltemp=lang(1,i)
      lang(1,i)=lang(3,i)
      lang(3,i)=ltemp
      endif
    3 continue
c
      do 4 i=1,nang-1
      do 5 j=i+1,nang
      if(lang(2,i).gt.lang(2,j).or.
     + (lang(2,i).eq.lang(2,j).and.lang(1,i).gt.lang(1,j)).or.
     + (lang(2,i).eq.lang(2,j).and.lang(1,i).eq.lang(1,j).and.
     + lang(3,i).gt.lang(3,j))) then
      do 6 k=1,3
      ltemp=lang(k,i)
      lang(k,i)=lang(k,j)
      lang(k,j)=ltemp
    6 continue
      endif
    5 continue
    4 continue
c
      argos_prepare_ang=.true.
      return
      end

      subroutine ccsd_trpdrv_bgp(t1,
     &     f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,eorb,einv,
     &     eccsdt,g_objo,g_objv,g_coul,g_exch,
     &     ncor,nocc,nvir,emp4,emp5,
     &     oseg_lo,oseg_hi,
     &     kchunk, Tij, Tkj, Tia, Tka, Xia, Xka, Jia, Jka, Kia, Kka,
     &     Jij, Jkj, Kij, Kkj, Dja, Djka, Djia)
C     $Id: ccsd_trpdrv_bgp.F 25363 2014-03-20 18:15:55Z jhammond $
      implicit none
c
#include "global.fh"
#include "ccsd_len.fh"
#include "ccsdps.fh"
c     
      integer ncor,nocc,nvir
      double precision t1(*)
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision eorb(*),einv(nvir,nvir)
      double precision Tij(*), Tkj(*), Tia(*), Tka(*)
      double precision Xia(*), Xka(*)
      double precision Jia(*), Jka(*), Jij(*), Jkj(*)
      double precision Kia(*), Kka(*), Kij(*), Kkj(*)
      double precision Dja(*), Djka(*), Djia(*)
c
      double precision emp4,emp5,denom
      double precision emp4a,emp5a,emp4b,emp5b
      double precision eaijk,eorbaux,eccsdt
#ifdef DEBUG_PRINT
      double precision tt0,tt1
      double precision ga_time(2)
      double precision tengy_time(2)
      double precision dgemm_time
      double precision einv_time
#endif
      integer jump,jump1,jump2
      integer g_objo,g_objv,g_coul,g_exch
      integer inode,next,nodes,iam
      integer oseg_lo,oseg_hi
      integer a,b,c,i,j,k,akold,av
      integer klo, khi, kchunk
      integer nxtask
      external nxtask
#ifdef _OPENMP
      integer omp_get_max_threads
      external omp_get_max_threads
#endif
c
      nodes = ga_nnodes()
      iam = ga_nodeid()
#ifdef _OPENMP
      if (iam.eq.0) write(6,99) omp_get_max_threads()
   99 format(2x,'Using ',i2,' OpenMP threads in CCSD(T)')
#endif
c
c      call ga_sync() ! ga_sync called just before trpdrv in aoccsd2
c
      inode=-1
      next=nxtask(nodes, 1)
#ifdef DEBUG_PRINT
      ga_time(1) = 0.0d0
      ga_time(2) = 0.0d0
      tengy_time(1) = 0.0d0
      tengy_time(2) = 0.0d0
      dgemm_time = 0.0d0
      einv_time = 0.0d0
#endif
      do klo = 1, nocc, kchunk
         akold=0
         khi = min(nocc, klo+kchunk-1)
         do a=oseg_lo,oseg_hi
            av=a-ncor-nocc
            do j=1,nocc
               inode=inode+1
               if (inode.eq.next)then
#ifdef DEBUG_PRINT
                  tt0 = ga_wtime()
#endif
                  call ga_get(g_objv,1+(j-1)*lnov,j*lnov,av,av,Dja,lnov)
                  call ga_get(g_objo,(klo-1)*lnvv+1,khi*lnvv,j,j,Tkj,
     &                 (khi-klo+1)*lnvv)
                  call ga_get(g_objo,lnovv+(klo-1)*lnov+1,
     &                 lnovv+khi*lnov,j,j,Jkj,(khi-klo+1)*lnov)
                  call ga_get(g_objo,lnovv+lnoov+(klo-1)*lnov+1,
     &                 lnovv+lnoov+khi*lnov,j,j,Kkj,(khi-klo+1)*lnov)
                  if (akold .ne. a) then
                     akold = a
                     call ga_get(g_coul,1,lnvv,(a-oseg_lo)*nocc+klo,
     &                    (a-oseg_lo)*nocc+khi,Jka,lnvv)
                     call ga_get(g_exch,1,lnvv,(a-oseg_lo)*nocc+klo,
     &                    (a-oseg_lo)*nocc+khi,Kka,lnvv)
                     call ga_get(g_objv,1+lnoov+(klo-1)*lnov,
     &                    lnoov+khi*lnov,av,av,Tka,(khi-klo+1)*lnov)
                     call ga_get(g_objv,1+2*lnoov+(klo-1)*lnov,
     &                    2*lnoov+khi*lnov,av,av,Xka,(khi-klo+1)*lnov)
                  endif
                  do k = klo, khi
                     call ga_get(g_objv,1+(j-1)*nvir+(k-1)*lnov,
     &                    j*nvir+(k-1)*lnov,av,av,
     &                    Djka(1+(k-klo)*nvir),nvir)
                  enddo
#ifdef DEBUG_PRINT
                  tt1 = ga_wtime()
                  ga_time(1) = ga_time(1) + (tt1-tt0)
#endif
                  do i=1,nocc
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objo,(i-1)*lnvv+1,i*lnvv,j,j,Tij,
     &                    lnvv)
                     call ga_get(g_objo,lnovv+(i-1)*lnov+1,
     &                    lnovv+i*lnov,j,j,Jij,lnov)
                     call ga_get(g_objo,lnovv+lnoov+(i-1)*lnov+1,
     &                    lnovv+lnoov+i*lnov,j,j,Kij,lnov)
                     call ga_get(g_coul,1,lnvv,(a-oseg_lo)*nocc+i,
     &                    (a-oseg_lo)*nocc+i,Jia,lnvv)
                     call ga_get(g_exch,1,lnvv,(a-oseg_lo)*nocc+i,
     &                    (a-oseg_lo)*nocc+i,Kia,lnvv)
                     call ga_get(g_objv,1+(j-1)*nvir+(i-1)*lnov,
     &                    j*nvir+(i-1)*lnov,av,av,Djia,nvir)
                     call ga_get(g_objv,1+lnoov+(i-1)*lnov,
     &                    lnoov+i*lnov,av,av,Tia,lnov)
                     call ga_get(g_objv,1+2*lnoov+(i-1)*lnov,
     &                    2*lnoov+i*lnov,av,av,Xia,lnov)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     ga_time(2) = ga_time(2) + (tt1-tt0)
#endif
                     do k=klo,min(khi,i)
#ifdef DEBUG_PRINT
                        tt0 = ga_wtime()
#endif
!$omp sections
!$omp& private(jump1,jump2)
!$omp& firstprivate(nocc,nvir)
                        jump1 = 1+(k-klo)*lnvv
                        jump2 = 1+(k-klo)*lnov
!$omp section
                        call dgemm('n','t',nvir,nvir,nvir,1.0d0,
     1                       Jia,nvir,Tkj(jump1),nvir,0.0d0,
     2                       f1n,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Tia,nvir,Kkj(jump2),nocc,1.0d0,
     2                       f1n,nvir)
!$omp section
                        call dgemm('n','n',nvir,nvir,nvir,1.0d0,
     1                       Jia,nvir,Tkj(jump1),nvir,0.0d0,
     2                       f3n,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Tia,nvir,Jkj(jump2),nocc,1.0d0,
     2                       f3n,nvir)
!$omp section
                        call dgemm('n','t',nvir,nvir,nvir,1.0d0,
     1                       Kia,nvir,Tkj(jump1),nvir,0.0d0,
     2                       f2n,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Xia,nvir,Kkj(jump2),nocc,1.0d0,
     2                       f2n,nvir)
!$omp section
                        call dgemm('n','n',nvir,nvir,nvir,1.0d0,
     1                       Kia,nvir,Tkj(jump1),nvir,0.0d0,
     2                       f4n,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Xia,nvir,Jkj(jump2),nocc,1.0d0,
     2                       f4n,nvir)
!$omp section
                        call dgemm('n','t',nvir,nvir,nvir,1.0d0,
     1                       Jka(jump1),nvir,Tij,nvir,0.0d0,
     2                       f1t,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Tka(jump2),nvir,Kij,nocc,1.0d0,
     2                       f1t,nvir)
!$omp section
                        call dgemm('n','n',nvir,nvir,nvir,1.0d0,
     1                       Jka(jump1),nvir,Tij,nvir,0.0d0,
     2                       f3t,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Tka(jump2),nvir,Jij,nocc,1.0d0,
     2                       f3t,nvir)
!$omp section
                        call dgemm('n','t',nvir,nvir,nvir,1.0d0,
     1                       Kka(jump1),nvir,Tij,nvir,0.0d0,
     2                       f2t,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Xka(jump2),nvir,Kij,nocc,1.0d0,
     2                       f2t,nvir)
!$omp section
                        call dgemm('n','n',nvir,nvir,nvir,1.0d0,
     1                       Kka(jump1),nvir,Tij,nvir,0.0d0,
     2                       f4t,nvir)
                        call dgemm('n','n',nvir,nvir,nocc,-1.0d0,
     1                       Xka(jump2),nvir,Jij,nocc,1.0d0,
     2                       f4t,nvir)
!$omp end sections

#ifdef DEBUG_PRINT
                        tt1 = ga_wtime()
                        dgemm_time = dgemm_time + (tt1-tt0)
                        tt0 = ga_wtime()
#endif
                        eaijk=eorb(a) - (  eorb(ncor+i)
     &                                    +eorb(ncor+j)
     &                                    +eorb(ncor+k) )
                        jump = ncor+nocc
!$omp parallel do
!$omp& schedule(static)
!$omp& shared(einv,eorb)
!$omp& private(b,c)
!$omp& firstprivate(eaijk,jump)
                        do b=1,nvir
                          do c=1,nvir
                            einv(c,b)=-1.0d0/( eorb(jump+b)
     &                                        +eorb(jump+c)+eaijk )
                          enddo
                        enddo
!$omp end parallel do

#ifdef DEBUG_PRINT
                        tt1 = ga_wtime()
                        einv_time = einv_time + (tt1-tt0)
                        tt0 = ga_wtime()
#endif
                        call ccsd_tengy_bgp(f1n,f1t,f2n,f2t,
     1                                      f3n,f3t,f4n,f4t,
     2                                      Dja(1+(i-1)*nvir),
     3                                      Djia,
     4                                      t1((k-1)*nvir+1),
     5                                      einv,emp4,emp5,
     6                                      nvir)
#ifdef DEBUG_PRINT
                        tt1 = ga_wtime()
                        tengy_time(1) = tengy_time(1) + (tt1-tt0)
#endif
                        if (i.ne.k) then
#ifdef DEBUG_PRINT
                           tt0 = ga_wtime()
#endif
                           call ccsd_tengy_bgp(f1t,f1n,f2t,f2n,
     1                                         f3t,f3n,f4t,f4n,
     2                                         Dja(1+(k-1)*nvir),
     3                                         Djka(1+(k-klo)*nvir),
     4                                         t1((i-1)*nvir+1),
     5                                         einv,emp4,emp5,
     6                                         nvir)
#ifdef DEBUG_PRINT
                           tt1 = ga_wtime()
                           tengy_time(2) = tengy_time(2) + (tt1-tt0)
#endif

                        end if ! (i.ne.k)
                     end do
                  end do
                  next=nxtask(nodes, 1)
               end if
            end do
         end do
      end do
#ifdef DEBUG_PRINT
      call ga_sync()
      if (iam.eq.0) write(6,87)
   87 format(2x,'node',6x,'ga_get',9x,'dgemm',10x,'einv'10x,'tengy')
      call ga_sync()
      write(6,88) iam,ga_time(1)+ga_time(2),dgemm_time,einv_time,
     &                tengy_time(1)+tengy_time(2)
   88 format(i7,4e15.5)
#endif
      next=nxtask(-nodes, 1)
      call ga_sync()
c
      end

#ifdef NO_VITALI_TENGY
      subroutine ccsd_tengy_bgp(f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,
     1                          dintc,dintx,t1v,einv,
     2                          emp4,emp5,nvir)
      implicit none
      integer nvir,b,c
      double precision emp4,emp5,denom
      double precision two,three,four
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision dintc(nvir),dintx(nvir),t1v(nvir)
      double precision einv(nvir,nvir)
      data two/2.0d00/,three/3.0d00/,four/4.0d00/
c
      do b=1,nvir
        do c=1,nvir
          denom=einv(c,b)
c
          emp4=emp4+denom*
     &         (f1t(b,c)+f1n(c,b)+f2t(c,b)+f3n(b,c)+f4n(c,b))*
     &         (f1t(b,c)-two*f2t(b,c)-two*f3t(b,c)+f4t(b,c))
c
          emp4=emp4-denom*
     &         (f1n(b,c)+f1t(c,b)+f2n(c,b)+f3n(c,b))*
     &         (two*f1t(b,c)-f2t(b,c)-f3t(b,c)+two*f4t(b,c))
c
          emp4=emp4+three*denom*(
     &         f1n(b,c)*(f1n(b,c)+f3n(c,b)+two*f4t(c,b))+
     &         f2n(b,c)*f2t(c,b)+f3n(b,c)*f4t(b,c))
c
          emp5=emp5+denom*t1v(b)*dintx(c)*
     &        (     f1t(b,c)+f2n(b,c)+f4n(c,b)
     &         -two*(f3t(b,c)+f4n(b,c)+f2n(c,b)+
     &              f1n(b,c)+f2t(b,c)+f3n(c,b))
     &         +four*(f3n(b,c)+f4t(b,c)+f1n(c,b)))
c
          emp5=emp5+denom*t1v(b)*dintc(c)*
     &        (     f1n(b,c)+f4n(b,c)+f1t(c,b)
     &          -two*(f2n(b,c)+f3n(b,c)+f2t(c,b)))
c
        enddo
      enddo
c
      return
      end
#else
!
!    Argonne Leadership Computing Facility
!    BlueGene/P version
!    Written by Vitali Morozov <morozov@anl.gov>
!    Updated 20091022
!    -O5 -qipa=noinline -qsmp=omp
!
!    modified from the original (use of einv)
!
      subroutine ccsd_tengy_bgp(f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,
     1                          dintc,dintx,t1v,einv,
     2                          emp4,emp5,nvir)
      implicit none
      integer nvir,b,c
      double precision emp4,emp5,denom
      double precision two,three,four
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision dintc(nvir),dintx(nvir),t1v(nvir)
      double precision einv(nvir,nvir)
      double precision e1, e2, e3, e4
      double precision t0, t1, t2, t3, t4, t5, t6, t7, t8, t9
      double precision z0, z1, z3, z5, z9, s0
c
!$omp parallel do
!$omp& private(b,c,e1,e2,e3,e4,z0,z1,z3,z5,z9,s0,
!$omp&         t0,t1,t2,t3,t4,t5,t6,t7,t8,t9)
!$omp& shared(f1n,f2n,f3n,f4n,f1t,f2t,f3t,f4t,dintx,dintc,t1v,einv)
!$omp& reduction(+:emp5,emp4) schedule(static)
      do b = 1, nvir
         do c = 1, nvir

            s0 = einv(c,b)

            e1 = f1n(c,b) + f4n(c,b) - 2d0*( f2n(c,b) + f3n(c,b) )
            e2 = e1 + 3d0*f1n(c,b)

            e3 = f1t(c,b) -2d0 * f2t(c,b)
            e4 = e3 + f2n(c,b) - 2d0*( f3t(c,b) + f4n(c,b) + f1n(c,b)
     1                                - 2d0*( f3n(c,b) + f4t(c,b) ) )

            emp5 = emp5 + ( t1v(c)*( e1*dintc(b) + e4*dintx(b) )
     1                    + t1v(b)*( e2*dintx(c) + e3*dintc(c) ) ) * s0

            t1 = f1t(c,b) + f3n(c,b)
            t2 = f1n(c,b) + f2t(c,b) + f4n(c,b)
            t9 = f1t(c,b) + f4t(c,b)
            t0 = f2t(c,b) + f3t(c,b)
            t3 = t9 - 2d0*t0
            t4 = t1 + f2n(c,b)
            t5 = 2d0*t9 - t0
            t6 = f3n(c,b) + 2d0*f4t(c,b)
            t7 = f3n(c,b) * f4t(c,b)
            t8 = t1*t3 - f1n(c,b)*t5 +3d0*( f1n(c,b)*f1n(c,b) + t7 )

            z0 = f2t(b,c) + f3t(b,c)
            z9 = f1t(b,c) + f4t(b,c)
            z1 = f1t(b,c) + f3n(b,c)
            z3 = z9 - 2d0*z0
            z5 = 2d0*z9 - z0

            emp4 = emp4 + ( t8 + t2*z3 - t4*z5 
     1           + 3d0*( t6*f1n(b,c) + f2t(c,b)*f2n(b,c) ) ) * s0
         enddo
      enddo
c
      return
      end
#endif


#ifdef DEAD_CODE
      subroutine ccsd_tengy4_bgp(f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,
     1                           einv,emp4,nvir)
      implicit none
      integer nvir,b,c
      double precision emp4,denom
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision einv(nvir,nvir)
c
      do b=1,nvir
        do c=1,nvir
          denom=einv(c,b)
          emp4=emp4+denom*
     &         ( f1t(b,c)+f1n(c,b)+f2t(c,b)+f3n(b,c)+f4n(c,b) )*
     &         ( f1t(b,c)-2.0d0*f2t(b,c)-2.0d0*f3t(b,c)+f4t(b,c) )
          emp4=emp4-denom*
     &         (       f1n(b,c)+f1t(c,b)+f2n(c,b)+f3n(c,b) )*
     &         ( 2.0d0*f1t(b,c)-f2t(b,c)-f3t(b,c)+2.0d0*f4t(b,c) )
          emp4=emp4+3.0d0*denom*
     &         ( f1n(b,c)*(f1n(b,c)+f3n(c,b)+2.0d0*f4t(c,b))+
     &           f2n(b,c)*f2t(c,b) + f3n(b,c)*f4t(b,c) )
        enddo
      enddo
c
      return
      end

      subroutine ccsd_tengy5_bgp(f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,
     1                           dintc,dintx,t1v,einv,emp5,nvir)
      implicit none
      integer nvir,b,c
      double precision emp5,denom
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision dintc(nvir),dintx(nvir),t1v(nvir)
      double precision einv(nvir,nvir)
c
      do b=1,nvir
        do c=1,nvir
          denom=einv(c,b)
          emp5=emp5+denom*t1v(b)*dintx(c)*
     &        (
     &                 f1t(b,c)+f2n(b,c)+f4n(c,b)
     &         +4.0d0*(f3n(b,c)+f4t(b,c)+f1n(c,b))
     &         -2.0d0*(f3t(b,c)+f4n(b,c)+f2n(c,b)+
     &                 f1n(b,c)+f2t(b,c)+f3n(c,b))
     &        )
          emp5=emp5+denom*t1v(b)*dintc(c)*
     &        (
     &                 f1n(b,c)+f4n(b,c)+f1t(c,b)
     &         -2.0d0*(f2n(b,c)+f3n(b,c)+f2t(c,b))
     &        )
        enddo
      enddo
c
      return
      end



      subroutine ccsd_tengy4ab_bgp(f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,
     1                             einv,emp4a,emp4b,nvir)
      implicit none
      integer nvir,b,c
      double precision emp4a,emp4b,denom
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision einv(nvir,nvir)
c
      do b=1,nvir
        do c=1,nvir
          denom=einv(c,b)
c
          emp4a=emp4a+denom*
     &         ( f1t(b,c)+f1n(c,b)+f2t(c,b)+f3n(b,c)+f4n(c,b) )*
     &         ( f1t(b,c)-2.0d0*f2t(b,c)-2.0d0*f3t(b,c)+f4t(b,c) )
          emp4a=emp4a+denom*
     &         (       f1n(b,c)+f1t(c,b)+f2n(c,b)+f3n(c,b) )*
     &         (-2.0d0*f1t(b,c)+f2t(b,c)+f3t(b,c)-2.0d0*f4t(b,c) )
          emp4a=emp4a+3.0d0*denom*f1n(b,c)*
     &         ( f1n(b,c)+f3n(c,b)+2.0d0*f4t(c,b) )
          emp4a=emp4a+3.0d0*denom*f2n(b,c)*f2t(c,b)
          emp4a=emp4a+3.0d0*denom*f3n(b,c)*f4t(b,c)
c
          emp4b=emp4b+denom*
     &         ( f1n(b,c)+f1t(c,b)+f2n(c,b)+f3t(b,c)+f4t(c,b) )*
     &         ( f1n(b,c)-2.0d0*f2n(b,c)-2.0d0*f3n(b,c)+f4n(b,c) )
          emp4b=emp4b+denom*
     &         (       f1t(b,c)+f1n(c,b)+f2t(c,b)+f3t(c,b) )*
     &         (-2.0d0*f1n(b,c)+f2n(b,c)+f3n(b,c)-2.0d0*f4n(b,c) )
          emp4b=emp4b+3.0d0*denom*f1t(b,c)*
     &         ( f1t(b,c)+f3t(c,b)+2.0d0*f4n(c,b) )
          emp4b=emp4b+3.0d0*denom*f2t(b,c)*f2n(c,b)
          emp4b=emp4b+3.0d0*denom*f3t(b,c)*f4n(b,c)
c
        enddo
      enddo
c
      return
      end



      subroutine ccsd_tengy5ab_bgp(f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,
     1                             dintcA,dintxA,t1vA,
     2                             dintcB,dintxB,t1vB,
     3                             einv,emp5a,emp5b,nvir)
      implicit none
      integer nvir,b,c
      double precision emp5a,emp5b,denom
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision dintcA(nvir),dintxA(nvir),t1vA(nvir)
      double precision dintcB(nvir),dintxB(nvir),t1vB(nvir)
      double precision einv(nvir,nvir)
c
      do b=1,nvir
        do c=1,nvir
          denom=einv(c,b)
c
          emp5a=emp5a+denom*t1vA(b)*dintxA(c)*
     &         (
     &                  f1t(b,c)+f2n(b,c)+f4n(c,b)
     &          +4.0d0*(f3n(b,c)+f4t(b,c)+f1n(c,b))
     &          -2.0d0*(f3t(b,c)+f4n(b,c)+f2n(c,b))
     &          -2.0d0*(f1n(b,c)+f2t(b,c)+f3n(c,b))
     &         )
c
          emp5b=emp5b+denom*t1vB(b)*dintcB(c)*
     &         (
     &                  f1t(b,c)+f4t(b,c)+f1n(c,b)
     &          -2.0d0*(f2t(b,c)+f3t(b,c)+f2n(c,b))
     &         )
c
          emp5a=emp5a+denom*t1vA(b)*dintcA(c)*
     &         (
     &                  f1n(b,c)+f4n(b,c)+f1t(c,b)
     &          -2.0d0*(f2n(b,c)+f3n(b,c)+f2t(c,b))
     &         )
c
          emp5b=emp5b+denom*t1vB(b)*dintxB(c)*
     &         (
     &                  f1n(b,c)+f2t(b,c)+f4t(c,b)
     &          +4.0d0*(f3t(b,c)+f4n(b,c)+f1t(c,b))
     &          -2.0d0*(f3n(b,c)+f4t(b,c)+f2t(c,b))
     &          -2.0d0*(f1t(b,c)+f2n(b,c)+f3t(c,b))
     &         )
c
        enddo
      enddo
c
      return
      end
#endif

      subroutine argos_pme_splfil(w,arr,darr)
c
      implicit none
c
#include "argos_pme_common.fh"
c
      real*8 arr(morder),darr(morder),w
c
      integer i,j
      real*8 rinv
c
      arr(morder)=zero
      arr(2)=w
      arr(1)=one-w
      do 1 i=3,morder-1
      rinv=one/dble(i-1)
      arr(i)=rinv*w*arr(i-1)
      do 2 j=1,i-2
      arr(i-j)=rinv*((w+dble(j))*arr(i-j-1)+(dble(i-j)-w)*arr(i-j))
    2 continue
      arr(1)=rinv*(one-w)*arr(1)
    1 continue
      darr(1)=-arr(1)
      do 3 j=2,morder
      darr(j)=arr(j-1)-arr(j)
    3 continue
      rinv=one/dble(morder-1)
      arr(morder)=rinv*w*arr(morder-1)
      do 4 j=1,morder-2
      arr(morder-j)=rinv*((w+dble(j))*arr(morder-j-1)+
     + (dble(morder-j)-w)*arr(morder-j))
    4 continue
      arr(1)=rinv*(one-w)*arr(1)
c
      return
      end
c $Id: argos_pme_splfil.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine dplot_dump(lgaussian,out_unit,iproc,luout,
     ,     where,what,title,
     ,     natom,xyz,charge,volume,tol_rho,
     ,     coofrom,cooto,no_of_spacings,ngrid,values,atag)
      implicit none
      logical lgaussian
      character *(*) title
      character*8 where,what                ! [input]
      integer out_unit ! [input]
      double precision xyz(3,*),charge(*)
      integer natom
      integer no_of_spacings(3),ngrid
      integer iproc,luout
      double precision values(*),volume,coofrom(3),cooto(3)
      character*16 atag(*)
c
      double precision spread(3),step(3),angle(3),tol_rho
      integer const_m(3),const_p(3)
c
      integer i,ii,ifast,atomicno
      double precision appch,sum
      character*16 element
      character*2 symbol
      logical geom_tag_to_element
      external geom_tag_to_element
c
      appch=0d0
      call  dplot_defgrid(volume,angle,
     ,     spread,step,const_m,const_p,
     ,     cooto,coofrom,no_of_spacings)
c
      If (iProc.eq.0 . and . Where.ne.'NUCLEI') Then
         if(lgaussian) then
            Write(Out_Unit,*)"Cube file generated by NWChem"
            Write(Out_Unit,*) Title
         else
            Write(Out_Unit,*)Title
            Write(Out_Unit,115)
 115        format('(1F15.10)')
         endif
      End If
      If (iProc.eq.0 . and . Where.ne.'NUCLEI') Then
         if(lgaussian) then
 9498       format(I5,3F12.6)
            Write(Out_Unit,9498)
     &           natom,(coofrom(i),i=1,3)
            Write(Out_Unit,9498)
     &           no_of_spacings(1)+1,step(1),0d0,0d0
            Write(Out_Unit,9498)
     &           no_of_spacings(2)+1,0d0,step(2),0d0
            Write(Out_Unit,9498)
     &           no_of_spacings(3)+1,0d0,0d0,step(3)
            do i=1,natom
            if (.not. geom_tag_to_element(atag(i), symbol, 
     &         element, atomicno)) then
               if (symbol .ne. 'bq') call errquit
     &              ('dplotdump: center is neither atom nor bq',
     &              0,0)
            endif
            Write(Out_Unit,9499)
     .            atomicno,charge(i),xyz(1,i),xyz(2,i),xyz(3,i)
 9499       format(I5,4F12.6)
c
c     dump MOlist (if any)
c
         enddo
         else
            Write(Out_Unit,'(3(1x,f10.5),3(3x,f5.2))')
     &           (Spread(i),i=1,3),(Angle(i),i=1,3)
            Write(Out_Unit,'(3(2x,i4))')(no_of_spacings(i),i=1,3)
            iFast = 1
            Write(Out_Unit,'(5x,i1,6(2x,i4))')
     &           iFast,(Const_M(i),Const_P(i),i=1,3)
         endif
      End If
c
c     dump grid values
c
      If (iProc.eq.0 . and . Where.ne.'NUCLEI') Then
c
         if(lgaussian) then ! for cube files
c
c     truncation
c
            Do i = 1, nGrid
               if(abs(values(i)).lt.tol_rho) values(i)=0d0
            enddo
            Do i = 1, nGrid,No_Of_Spacings(3)+1
               Write(Out_Unit,99498)(values(i+ii),ii=0,
     .              No_Of_Spacings(3))
99498          format(6E13.5)
            enddo
            else
            Do i = 1, nGrid
               Write(Out_Unit,'(f15.10)')values(i)
            End Do
         endif
         If (What.eq.'VIEW') Then
            write(Out_unit,19498)
19498       format(10I5)
         endif
c
         If (What.eq.'DENSITY') Then
            Sum = 0.d0
            Do i = 1, nGrid
               Sum = Sum + values(i)
            End Do
            AppCh = Sum*Volume
            Write(LuOut,*)
            Write(LuOut,'(a,f30.5)')'  Sum of elements      = ',sum
            Write(LuOut,'(a,f30.5)')'  Integration volume   = ',volume
            Write(LuOut,'(a,f30.5)')'  Integrated Charge    = ',AppCh
         End If
      End If
      return
      end
c $Id: dplot_dump.F 24667 2013-10-18 00:35:12Z edo $

      subroutine argos_cafe_salloc()
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer lenscr
c
      if(lscr) call md_abort('Error 1 in argos_cafe_salloc',0)
      if(mscr.le.0) call md_abort('Error 2 in argos_cafe_salloc',0)
c
      if(.not.ma_alloc_get(mt_int,mscr,'s1i1',l_s1i1,i_s1i1))
     + call md_abort('Failed to allocate scratch array s1i1',0)
c
      if(.not.ma_alloc_get(mt_int,mscr,'s1i2',l_s1i2,i_s1i2))
     + call md_abort('Failed to allocate scratch array s1i2',0)
c
      if(.not.ma_alloc_get(mt_int,mscr,'s1i3',l_s1i3,i_s1i3))
     + call md_abort('Failed to allocate scratch array s1i3',0)
c
      if(.not.ma_alloc_get(mt_int,mscr,'s1i4',l_s1i4,i_s1i4))
     + call md_abort('Failed to allocate scratch array s1i4',0)
c
      if(.not.ma_alloc_get(mt_int,mscr,'s1i5',l_s1i5,i_s1i5))
     + call md_abort('Failed to allocate scratch array s1i5',0)
c
      if(.not.ma_alloc_get(mt_int,mscr,'s1i6',l_s1i6,i_s1i6))
     + call md_abort('Failed to allocate scratch array s1i6',0)
c
      lenscr=max(nsatot,3*mscr)
      if(.not.ma_alloc_get(mt_int,lenscr,'s2i1',l_s2i1,i_s2i1))
     + call md_abort('Failed to allocate scratch array s2i1',0)
c
      if(.not.ma_alloc_get(mt_dbl,mscr,'s1r1',l_s1r1,i_s1r1))
     + call md_abort('Failed to allocate scratch array s1r1',0)
c
      if(.not.ma_alloc_get(mt_dbl,mscr,'s1r2',l_s1r2,i_s1r2))
     + call md_abort('Failed to allocate scratch array s1r2',0)
c
      if(.not.ma_alloc_get(mt_dbl,mscr,'s1r3',l_s1r3,i_s1r3))
     + call md_abort('Failed to allocate scratch array s1r3',0)
c
      if(.not.ma_alloc_get(mt_dbl,mscr,'s1r4',l_s1r4,i_s1r4))
     + call md_abort('Failed to allocate scratch array s1r4',0)
c
      if(.not.ma_alloc_get(mt_dbl,mscr,'s1r5',l_s1r5,i_s1r5))
     + call md_abort('Failed to allocate scratch array s1r5',0)
c
      if(.not.ma_alloc_get(mt_dbl,mscr,'s1r6',l_s1r6,i_s1r6))
     + call md_abort('Failed to allocate scratch array s1r6',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mscr,'s3r1',l_s3r1,i_s3r1))
     + call md_abort('Failed to allocate scratch array s3r1',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mscr,'s3r2',l_s3r2,i_s3r2))
     + call md_abort('Failed to allocate scratch array s3r2',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mwa*mscr,'smr1',l_smr1,i_smr1))
     + call md_abort('Failed to allocate scratch array smr1',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mwa*mscr,'smr2',l_smr2,i_smr2))
     + call md_abort('Failed to allocate scratch array smr2',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mwa*mscr,'smr3',l_smr3,i_smr3))
     + call md_abort('Failed to allocate scratch array smr3',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mwa*mscr,'smr4',l_smr4,i_smr4))
     + call md_abort('Failed to allocate scratch array smr4',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mwa*mscr,'smr5',l_smr5,i_smr5))
     + call md_abort('Failed to allocate scratch array smr5',0)
c
      if(.not.ma_alloc_get(mt_dbl,3*mwa*mscr,'smr6',l_smr6,i_smr6))
     + call md_abort('Failed to allocate scratch array smr6',0)
c
      if(ipme.gt.0) then
      if(.not.ma_alloc_get(mt_dbl,3*msa,'pmes',l_pmes,i_pmes))
     + call md_abort('Failed to allocate scratch array pmes',0)
      if(.not.ma_alloc_get(mt_dbl,3*mwa*mwm,'pmew',l_pmew,i_pmew))
     + call md_abort('Failed to allocate scratch array pmew',0)
      lenscr=3*morder*(mwa*mwm+msa)
      if(.not.ma_alloc_get(mt_dbl,lenscr,'theta',l_theta,i_theta))
     + call md_abort('Failed to allocate scratch array theta',0)
      if(.not.ma_alloc_get(mt_dbl,lenscr,'dtheta',l_dtheta,i_dtheta))
     + call md_abort('Failed to allocate scratch array dtheta',0)
      endif
c
      lscr=.true.
c
      return
      end
c $Id: argos_cafe_salloc.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine tce_mp2_gradient(d_f1,d_v2,d_t2,
     1           k_f1_offset,k_v2_offset,k_t2_offset,
     1           rtdb)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "rtdb.fh"
c     
      integer d_f1,k_f1_offset
      integer d_v2,k_v2_offset
      integer d_t2,k_t2_offset
c
c     storage for T_{2}^{\dag} y2
c
      integer d_y2,k_y2_offset,size_y2,l_y2_offset
c
c     integer k_force
c     
      integer rtdb
      integer ii
      double precision corr
      double precision corr_a,corr_b,corr_c
      double precision corr_d,corr_e,corr_f
      double precision corr_g,corr_h,corr_i
      character*255 filename
c
c     variables for 1PDM, 2PDM, and 1PWDM
c     ====
c     1PDM
c     ====
      integer d_hh,l_hh_offset,k_hh_offset,size_hh
      integer d_pp,l_pp_offset,k_pp_offset,size_pp
      integer d_ph,l_ph_offset,k_ph_offset,size_ph
      integer d_1pdm,l_1pdm_offset,k_1pdm_offset,size_1pdm
c     ====
c     2PDM
c     ====
      integer d_hhhh,l_hhhh_offset,k_hhhh_offset,size_hhhh
      integer d_hhhp,l_hhhp_offset,k_hhhp_offset,size_hhhp
      integer d_hhpp,l_hhpp_offset,k_hhpp_offset,size_hhpp
      integer d_hphh,l_hphh_offset,k_hphh_offset,size_hphh
      integer d_hphp,l_hphp_offset,k_hphp_offset,size_hphp
      integer d_hppp,l_hppp_offset,k_hppp_offset,size_hppp
      integer d_pphh,l_pphh_offset,k_pphh_offset,size_pphh
      integer d_pphp,l_pphp_offset,k_pphp_offset,size_pphp
      integer d_pppp,l_pppp_offset,k_pppp_offset,size_pppp
      integer d_2pdm,l_2pdm_offset,k_2pdm_offset,size_2pdm
c     =====
c     1PWDM
c     ===== 
      integer d_whh,l_whh_offset,k_whh_offset,size_whh
      integer d_whp,l_whp_offset,k_whp_offset,size_whp
      integer d_wpp,l_wpp_offset,k_wpp_offset,size_wpp
      integer d_1pwdm,l_1pwdm_offset,k_1pwdm_offset,size_1pwdm
c     ===========================
c     add references contribution
c     ===========================
      integer l_a,k_a,l_b,k_b,dima
c     ===========================
c     atomic orbital tiles
c     ===========================
c      integer atpart2
c      integer nalength2(200)
c      integer a2length2(200)
c     ======
c     Z-VEC
c     ======
      integer d_x1,l_x1_offset,k_x1_offset,size_x1
      integer d_r1,l_r1_offset,k_r1_offset,size_r1
c
      double precision cpu,wall,r1,residual
      integer dummy, iter
c     
c     memory allocation
c     
      integer nh,np
c     
c     mos
c     
      integer dim_mo
      integer l_mo,k_mo
c     
c     1pdm_ao, 2pdm_ao, and 1pwdm_ao
c     
      integer dim_1pdm_ao,l_1pdm_ao,k_1pdm_ao
      integer dim_2pdm_ao,l_2pdm_ao,k_2pdm_ao
      integer dim_1pwdm_ao,l_1pwdm_ao,k_1pwdm_ao
c     ===========================
c     GA for 1PDM_AO and 1PWDM_AO
c     ===========================
      integer  ga_create_atom_blocked
      external ga_create_atom_blocked
      integer  g_1pdm, g_1pwdm
c     
      logical tce_gradients_doit
      external tce_gradients_doit
      logical status
c     
      integer i
      logical nodezero
c     
      integer nbf_verify        ! nbf read from movecs_read_header
      integer ipol_verify       ! ipol read from movecs_read_header
      character*255 movecs_out  ! MO vector file name
      character*255 title       ! Title
      character*255 basisname   ! Basis set name
      character*255 scftype     ! Type of SCF
      logical movecs_read,movecs_read_header
      external movecs_read,movecs_read_header
c      integer ga_create_atom_blocked
c      external ga_create_atom_blocked
      logical rohf
      integer j
c     
      integer l_test,k_test,l_r2,k_r2,size,l_r1,k_r1
      integer g1,g2,g3,g4,g1b,g2b,g3b,g4b
      integer ig1,ig2,ig3,ig4,igg1,igg2,igg3,igg4
      integer k,l,ind1,ind2
      integer dim_2pdm, k_2pdm, l_2pdm
      integer dim_1pdm, k_1pdm, l_1pdm
      integer dim_1pwdm,k_1pwdm,l_1pwdm
      integer k_2eint,l_2eint,k_1eint,l_1eint
c
      double precision res
      integer l_zvec_x,k_zvec_x
      integer m,e,a,b,q,r,s,n,f
c
c     debug
      logical zvec_debug, wdm_debug
c
      integer nxtask
      integer nprocs
      integer next
      integer count
      external nxtask
c 
      nodezero=(ga_nodeid().eq.0)
c
c     ====================================
c     create d_y2 for T_{2}^{\dag}
c     ====================================
c
      call tce_filename("y2",filename)
      call tce_y2_offset(l_y2_offset,k_y2_offset,size_y2)
      call createfile(filename,d_y2,size_y2)
      call trans_t2_to_t2dagger(d_t2,k_t2_offset,d_y2,k_y2_offset)
      call reconcilefile(d_y2,size_y2)
c     
c    
c     ====================================
c     1PDM, 2PDM, and 1PWDM with MO basis
c     ====================================
c     
c     ====================
c     1PDM Hole-Hole Block
c     ====================
      irrep_y=irrep_t
      call tce_filename('hh',filename)
      call tce_dens_hh_offset(l_hh_offset,k_hh_offset,size_hh)
      call createfile(filename,d_hh,size_hh)
      call mp2_1pdm_hh_mo(d_hh,d_t2,d_y2,k_hh_offset,k_t2_offset,
     1     k_y2_offset)
c      call tce_zero(d_hh,size_hh)
      call reconcilefile(d_hh,size_hh)
c     ============================
c     1PDM Particle-Particle Block
c     ============================
      call tce_filename('pp',filename)
      call tce_dens_pp_offset(l_pp_offset,k_pp_offset,size_pp)
      call createfile(filename,d_pp,size_pp)
      call mp2_1pdm_pp_mo(d_pp,d_t2,d_y2,k_pp_offset,k_t2_offset,
     1     k_y2_offset)
c      call tce_zero(d_pp,size_pp)
      call reconcilefile(d_pp,size_pp)
c     ==============================
c     2PDM Hole-Hole-Hole-Hole Block
c     ==============================
      call tce_filename('hhhh',filename)
      call tce_dens_hhhh_offset(l_hhhh_offset,k_hhhh_offset,size_hhhh)
      call createfile(filename,d_hhhh,size_hhhh)
      call tce_zero(d_hhhh,size_hhhh)
      call reconcilefile(d_hhhh,size_hhhh)
c     ==================================
c     2PDM Hole-Hole-Hole-Particle Block
c     ==================================
      call tce_filename('hhhp',filename)
      call tce_dens_hhhp_offset(l_hhhp_offset,k_hhhp_offset,size_hhhp)
      call createfile(filename,d_hhhp,size_hhhp)
      call tce_zero(d_hhhp,size_hhhp)
      call reconcilefile(d_hhhp,size_hhhp)
c     ======================================
c     2PDM Hole-Hole-Particle-Particle Block
c     ======================================
      call tce_filename('hhpp',filename)
      call tce_dens_hhpp_offset(l_hhpp_offset,k_hhpp_offset,size_hhpp)
      call createfile(filename,d_hhpp,size_hhpp)
c      call tce_zero(d_hhpp,size_hhpp)
      call copyfile(d_y2,d_hhpp,size_hhpp)
      call reconcilefile(d_hhpp,size_hhpp)
c     ==================================
c     2PDM Hole-Particle-Hole-Hole Block
c     ==================================
      call tce_filename('hphh',filename)
      call tce_dens_hphh_offset(l_hphh_offset,k_hphh_offset,size_hphh)
      call createfile(filename,d_hphh,size_hphh)
      call tce_zero(d_hphh,size_hphh)
      call reconcilefile(d_hphh,size_hphh)
c     ======================================
c     2PDM Hole-Particle-Hole-Particle Block
c     ======================================
      call tce_filename('hphp',filename)
      call tce_dens_hphp_offset(l_hphp_offset,k_hphp_offset,size_hphp)
      call createfile(filename,d_hphp,size_hphp)
      call tce_zero(d_hphp,size_hphp)
      call reconcilefile(d_hphp,size_hphp)
c     ==========================================
c     2PDM Hole-Particle-Particle-Particle Block
c     ==========================================
      call tce_filename('hppp',filename)
      call tce_dens_hppp_offset(l_hppp_offset,k_hppp_offset,size_hppp)
      call createfile(filename,d_hppp,size_hppp)
      call tce_zero(d_hppp,size_hppp)
      call reconcilefile(d_hppp,size_hppp)
c     ======================================
c     2PDM Particle-Particle-Hole-Hole Block
c     ======================================
      call tce_filename('pphh',filename)
      call tce_dens_pphh_offset(l_pphh_offset,k_pphh_offset,size_pphh)
      call createfile(filename,d_pphh,size_pphh)
c     put 2 times of T2 in this block
c      call dscalfile(2.d0,d_t2,size_pphh)
      call copyfile(d_t2,d_pphh,size_pphh)
      call reconcilefile(d_pphh,size_pphh)
c     ==========================================
c     2PDM Particle-Particle-Hole-Particle Block
c     ==========================================
      call tce_filename('pphp',filename)
      call tce_dens_pphp_offset(l_pphp_offset,k_pphp_offset,size_pphp)
      call createfile(filename,d_pphp,size_pphp)
      call tce_zero(d_pphp,size_pphp)
      call reconcilefile(d_pphp,size_pphp)
c     ==============================================
c     2PDM Particle-Particle-Particle-Particle Block
c     ==============================================
      call tce_filename('pppp',filename)
      call tce_dens_pppp_offset(l_pppp_offset,k_pppp_offset,size_pppp)
      call createfile(filename,d_pppp,size_pppp)
      call tce_zero(d_pppp,size_pppp)
      call reconcilefile(d_pppp,size_pppp)
c
c
      call tce_filename('x1',filename)
      call tce_zvec_x1_offset(l_x1_offset,k_x1_offset,size_x1)
      call createfile(filename,d_x1,size_x1)
      call tce_zero(d_x1,size_x1)
      call zvec_x_a_a(d_hhhh,d_x1,d_v2,k_hhhh_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_b_a(d_hhhp,d_x1,d_v2,k_hhhp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_b_b(d_hphh,d_x1,d_v2,k_hphh_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_c_a(d_hphh,d_x1,d_v2,k_hphh_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_c_b(d_hhhp,d_x1,d_v2,k_hhhp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_d(d_hphp,d_x1,d_v2,k_hphp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_e_a(d_pphh,d_x1,d_v2,k_pphh_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_e_b(d_hhpp,d_x1,d_v2,k_hhpp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_f_a(d_pphp,d_x1,d_v2,k_pphp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_a_f_b(d_hppp,d_x1,d_v2,k_hppp_offset,
     1     k_x1_offset,k_v2_offset)
c
      call zvec_x_b_a_a(d_hphh,d_x1,d_v2,k_hphh_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_a_b(d_hhhp,d_x1,d_v2,k_hhhp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_b_a(d_pphh,d_x1,d_v2,k_pphh_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_b_b(d_hhpp,d_x1,d_v2,k_hhpp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_c(d_hphp,d_x1,d_v2,k_hphp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_d_a(d_pphp,d_x1,d_v2,k_pphp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_d_b(d_hppp,d_x1,d_v2,k_hppp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_e_a(d_hppp,d_x1,d_v2,k_hppp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_e_b(d_pphp,d_x1,d_v2,k_pphp_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_b_f(d_pppp,d_x1,d_v2,k_pppp_offset,
     1     k_x1_offset,k_v2_offset)
c
      call zvec_x_c_a(d_hh,d_x1,d_v2,k_hh_offset,
     1     k_x1_offset,k_v2_offset)
      call zvec_x_c_b(d_pp,d_x1,d_v2,k_pp_offset,
     1     k_x1_offset,k_v2_offset)
c     ==============================================================================
c     1PDM Particle-Hole Block (Hole-Particle Block is equal to Particle-Hole Block)
c     ==============================================================================
      call tce_filename('ph',filename)
      call tce_dens_ph_offset(l_ph_offset,k_ph_offset,size_ph)
      call createfile(filename,d_ph,size_ph)
      call tce_diis_init()
      call tce_dens_ph_offset(l_r1_offset,k_r1_offset,size_r1)
      do iter=1,maxiter
        cpu=-util_cpusec()
        wall=-util_wallsec()
        if (nodezero.and.(iter.eq.1)) write(LuOut,9050) "Z-VEC"
        call tce_filename('r1',filename)
        call createfile(filename,d_r1,size_r1)
        call ccsd_zvec(d_f1,d_r1,d_v2,d_x1,d_ph,k_f1_offset,
     1         k_r1_offset,k_v2_offset,k_x1_offset,k_ph_offset)
        call reconcilefile(d_r1,size_r1)
        call tce_residual_t1(d_r1,k_r1_offset,r1)
        residual = r1
        cpu=cpu+util_cpusec()
        wall=wall+util_wallsec()
        if (nodezero) write(LuOut,9100) iter,residual,cpu,wall
        if (residual .lt. thresh) then
          if (nodezero) then 
             write(LuOut,9060)
             write(LuOut,*)
          endif
          call deletefile(d_r1)
          call tce_diis_tidy()
          goto 320
        endif
        call tce_diis(.false.,iter,.true.,.false.,.false.,.false.,
     1                  d_r1,d_ph,k_ph_offset,size_ph,
     2                  dummy,dummy,dummy,dummy,
     3                  dummy,dummy,dummy,dummy,
     4                  dummy,dummy,dummy,dummy)
        call deletefile(d_r1)
      enddo
      call errquit('tce_mp2_gradient: maxiter exceeded',iter,CALC_ERR)
c
320   continue
      if(.not.ma_pop_stack(l_r1_offset))
     1  call errquit('tce_mp2_gradient: ma problem',120,ma_err)
c     =====================
c     1PWDM Hole-Hole Block
c     =====================
      call tce_filename('whh',filename)
      call tce_dens_hh_offset(l_whh_offset,k_whh_offset,size_whh)
      call createfile(filename,d_whh,size_whh)
      call tce_zero(d_whh,size_whh)
      call wdm_hh_mo_a(d_hh,d_f1,d_whh,k_hh_offset,k_f1_offset,
     1     k_whh_offset)
      call wdm_hh_mo_b_a_a(d_hh,d_whh,d_v2,k_hh_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_b_a_b(d_hh,d_whh,d_v2,k_hh_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_b_b_a(d_pp,d_whh,d_v2,k_pp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_b_b_b(d_pp,d_whh,d_v2,k_pp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_a(d_hhhh,d_whh,d_v2,k_hhhh_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_b_a(d_hhhp,d_whh,d_v2,k_hhhp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_b_b(d_hphh,d_whh,d_v2,k_hphh_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_c_a(d_hphh,d_whh,d_v2,k_hphh_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_c_b(d_hhhp,d_whh,d_v2,k_hhhp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_d(d_hphp,d_whh,d_v2,k_hphp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_e_a(d_pphh,d_whh,d_v2,k_pphh_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_e_b(d_hhpp,d_whh,d_v2,k_hhpp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_f_a(d_pphp,d_whh,d_v2,k_pphp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_c_f_b(d_hppp,d_whh,d_v2,k_hppp_offset,k_whh_offset,
     1     k_v2_offset)
      call wdm_hh_mo_d(d_whh,d_v2,d_ph,k_whh_offset,k_v2_offset,
     1     k_ph_offset)
      call reconcilefile(d_whh,size_whh)
c     =========================
c     1PWDM Hole-Particle Block
c     =========================
      call tce_filename('whp',filename)
      call tce_dens_hp_offset(l_whp_offset,k_whp_offset,size_whp)
      call createfile(filename,d_whp,size_whp)
      call tce_zero(d_whp,size_whp)
      call wdm_hp_mo_a(d_pp,d_f1,d_whp,k_pp_offset,k_f1_offset,
     1     k_whp_offset)
      call wdm_hp_mo_b_a_a(d_hphh,d_whp,d_v2,k_hphh_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_a_b(d_hhhp,d_whp,d_v2,k_hhhp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_b_a(d_pphh,d_whp,d_v2,k_pphh_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_b_b(d_hhpp,d_whp,d_v2,k_hhpp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_c(d_hphp,d_whp,d_v2,k_hphp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_d_a(d_pphp,d_whp,d_v2,k_pphp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_d_b(d_hppp,d_whp,d_v2,k_hppp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_e_a(d_hppp,d_whp,d_v2,k_hppp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_e_b(d_pphp,d_whp,d_v2,k_pphp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_b_f(d_pppp,d_whp,d_v2,k_pppp_offset,k_whp_offset,
     1     k_v2_offset)
      call wdm_hp_mo_c(d_f1,d_whp,d_ph,k_f1_offset,k_whp_offset,
     1     k_ph_offset)
      call reconcilefile(d_whp,size_whp)
c     =============================
c     1PWDM Particle-Particle Block
c     =============================
      call tce_filename('wpp',filename)
      call tce_dens_pp_offset(l_wpp_offset,k_wpp_offset,size_wpp)
      call createfile(filename,d_wpp,size_wpp)
      call tce_zero(d_wpp,size_wpp)
      call wdm_pp_mo_a(d_pp,d_f1,d_wpp,k_pp_offset,k_f1_offset,
     1     k_wpp_offset)
      call wdm_pp_mo_b_a_a(d_hphh,d_wpp,d_v2,k_hphh_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_a_b(d_hhhp,d_wpp,d_v2,k_hhhp_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_b_a(d_pphh,d_wpp,d_v2,k_pphh_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_b_b(d_hhpp,d_wpp,d_v2,k_hhpp_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_c(d_hphp,d_wpp,d_v2,k_hphp_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_d_a(d_pphp,d_wpp,d_v2,k_pphp_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_d_b(d_hppp,d_wpp,d_v2,k_hppp_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_e_a(d_hppp,d_wpp,d_v2,k_hppp_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_e_b(d_pphp,d_wpp,d_v2,k_pphp_offset,k_wpp_offset,
     1     k_v2_offset)
      call wdm_pp_mo_b_f(d_pppp,d_wpp,d_v2,k_pppp_offset,k_wpp_offset,
     1     k_v2_offset)
      call reconcilefile(d_wpp,size_wpp)
c
c     ===========================================
c     put 2pdm 9 pieces into one file
c     ===========================================
      call tce_filename('2pdm',filename)
      call tce_2pdm_offset(l_2pdm_offset,k_2pdm_offset,size_2pdm)
      call createfile(filename,d_2pdm,size_2pdm)
c
      call put_2pdm_hhhh(d_2pdm,k_2pdm_offset,d_hhhh,k_hhhh_offset)
      call put_2pdm_hhhp(d_2pdm,k_2pdm_offset,d_hhhp,k_hhhp_offset)
      call put_2pdm_hhpp(d_2pdm,k_2pdm_offset,d_hhpp,k_hhpp_offset)
      call put_2pdm_hphh(d_2pdm,k_2pdm_offset,d_hphh,k_hphh_offset)
      call put_2pdm_hphp(d_2pdm,k_2pdm_offset,d_hphp,k_hphp_offset)
      call put_2pdm_hppp(d_2pdm,k_2pdm_offset,d_hppp,k_hppp_offset)
      call put_2pdm_pphh(d_2pdm,k_2pdm_offset,d_pphh,k_pphh_offset)
      call put_2pdm_pphp(d_2pdm,k_2pdm_offset,d_pphp,k_pphp_offset)
      call put_2pdm_pppp(d_2pdm,k_2pdm_offset,d_pppp,k_pppp_offset)
c
      call reconcilefile(d_2pdm,size_2pdm)
c     ===============================
c     put 1pdm 3 pieces into one file
c     ===============================
      call tce_filename('1pdm',filename)
      call tce_1pdm_offset(l_1pdm_offset,k_1pdm_offset,size_1pdm)
      call createfile(filename,d_1pdm,size_1pdm)
c
      call put_1pdm_hh(d_1pdm,k_1pdm_offset,d_hh,k_hh_offset)
      call put_1pdm_ph(d_1pdm,k_1pdm_offset,d_ph,k_ph_offset)
      call put_1pdm_pp(d_1pdm,k_1pdm_offset,d_pp,k_pp_offset)
c
      call reconcilefile(d_1pdm,size_1pdm)
c     ======================================
c     put 1pwdm 3 pieces into one file
c     ======================================
      call tce_filename('1pwdm',filename)
      call tce_1pdm_offset(l_1pwdm_offset,k_1pwdm_offset,size_1pwdm)
      call createfile(filename,d_1pwdm,size_1pwdm)
c
      call put_1pdm_hh(d_1pwdm,k_1pwdm_offset,d_whh,k_whh_offset)
      call put_1pwdm_hp(d_1pwdm,k_1pwdm_offset,d_whp,k_whp_offset)
      call put_1pdm_pp(d_1pwdm,k_1pwdm_offset,d_wpp,k_wpp_offset)
c
      call reconcilefile(d_1pwdm,size_1pwdm)
c
c     =================================
c     HF REFERENCE CONTRIBUTION TO 2PDM
c     =================================
      nprocs=ga_nnodes( )
      count=0
      next=nxtask(nprocs,1)
c
      do g1b=1,noab
      do g2b=1,noab
         if(next.eq.count) then
c
         if (ieor(int_mb(k_sym+g1b-1),ieor(int_mb(k_sym+g2b-1),
     1       ieor(int_mb(k_sym+g1b-1),int_mb(k_sym+g2b-1)))) 
     1       .eq. irrep_e) THEN
         if ((.not.restricted).or.(int_mb(k_spin+g1b-1)+
     1       int_mb(k_spin+g2b-1).ne.4)) then
            dima=int_mb(k_range+g1b-1)*int_mb(k_range+g1b-1)*
     1           int_mb(k_range+g2b-1)*int_mb(k_range+g2b-1)
            if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
     1      call errquit('tce_mp2_gradient: ma problem',3,ma_err)
c
            call get_hash_block(d_2pdm,dbl_mb(k_a),dima,
     1           int_mb(k_2pdm_offset),(g2b-1)+(g1b-1)*(noab+nvab)+
     1           (g2b-1)*(noab+nvab)*(noab+nvab)+(g1b-1)*(noab+nvab)*
     1           (noab+nvab)*(noab+nvab))
            do g1=1,int_mb(k_range+g1b-1)
            do g2=1,int_mb(k_range+g2b-1)
               dbl_mb(k_a+(g2-1)+(g1-1)*int_mb(k_range+g2b-1)+
     1         (g2-1)*int_mb(k_range+g2b-1)*int_mb(k_range+g1b-1)+
     1         (g1-1)*int_mb(k_range+g2b-1)*int_mb(k_range+g1b-1)*
     1                int_mb(k_range+g2b-1)) = 
     1         dbl_mb(k_a+(g2-1)+(g1-1)*int_mb(k_range+g2b-1)+
     1         (g2-1)*int_mb(k_range+g2b-1)*int_mb(k_range+g1b-1)+
     1         (g1-1)*int_mb(k_range+g2b-1)*int_mb(k_range+g1b-1)*
     1                int_mb(k_range+g2b-1)) + 1.d0
            enddo
            enddo
            call put_hash_block(d_2pdm,dbl_mb(k_a),dima,
     1           int_mb(k_2pdm_offset),(g2b-1)+(g1b-1)*(noab+nvab)+
     1           (g2b-1)*(noab+nvab)*(noab+nvab)+(g1b-1)*(noab+nvab)*
     1           (noab+nvab)*(noab+nvab))
c
            call get_hash_block(d_2pdm,dbl_mb(k_a),dima,
     1           int_mb(k_2pdm_offset),(g1b-1)+(g2b-1)*(noab+nvab)+
     1           (g2b-1)*(noab+nvab)*(noab+nvab)+(g1b-1)*(noab+nvab)*
     1           (noab+nvab)*(noab+nvab))
            do g1=1,int_mb(k_range+g1b-1)
            do g2=1,int_mb(k_range+g2b-1)
               dbl_mb(k_a+(g1-1)+(g2-1)*int_mb(k_range+g1b-1)+
     1         (g2-1)*int_mb(k_range+g1b-1)*int_mb(k_range+g2b-1)+
     1         (g1-1)*int_mb(k_range+g1b-1)*int_mb(k_range+g2b-1)*
     1                int_mb(k_range+g2b-1)) =
     1         dbl_mb(k_a+(g1-1)+(g2-1)*int_mb(k_range+g1b-1)+
     1         (g2-1)*int_mb(k_range+g1b-1)*int_mb(k_range+g2b-1)+
     1         (g1-1)*int_mb(k_range+g1b-1)*int_mb(k_range+g2b-1)*
     1                int_mb(k_range+g2b-1)) - 1.d0
            enddo
            enddo
            call put_hash_block(d_2pdm,dbl_mb(k_a),dima,
     1           int_mb(k_2pdm_offset),(g1b-1)+(g2b-1)*(noab+nvab)+
     1           (g2b-1)*(noab+nvab)*(noab+nvab)+(g1b-1)*(noab+nvab)*
     1           (noab+nvab)*(noab+nvab))
            if (.not.ma_pop_stack(l_a))
     1      call errquit('tce_mp2_gradient: ma problem',4,ma_err)
c
         endif
         endif
         next=nxtask(nprocs,1)
         endif
         count=count+1
      enddo
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c    =================================
c    HF REFERENCE CONTRIBUTION TO 1PDM
c    =================================
      nprocs=ga_nnodes( )
      count=0
      next=nxtask(nprocs,1)

      do g1b=1,noab
         if(next.eq.count) then
c
         if ((.not.restricted).or.(int_mb(k_spin+g1b-1).ne.2)) then
            dima=int_mb(k_range+g1b-1)*int_mb(k_range+g1b-1)
            if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
     1      call errquit('tce_mp2_gradient: ma problem',2,ma_err)
            call get_hash_block(d_1pdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            do g1=1,int_mb(k_range+g1b-1)
               dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))=
     1         dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))+1.d0
            enddo
            call put_hash_block(d_1pdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            if (.not.ma_pop_stack(l_a))
     1      call errquit('tce_mp2_gradient: ma problem',3,ma_err)
         endif
         next=nxtask(nprocs,1)
         endif
         count=count+1
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c     ==================================
c     HF REFERENCE CONTRIBUTION TO 1PWDM
c     ==================================
      nprocs=ga_nnodes( )
      count=0
      next=nxtask(nprocs,1)
c
      do g1b=1,noab
         if(next.eq.count) then
c
         if ((.not.restricted).or.(int_mb(k_spin+g1b-1).ne.2)) then
            dima = int_mb(k_range+g1b-1)*int_mb(k_range+g1b-1)
            if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
     1      call errquit('tce_mp2_gradient: ma problem',4,ma_err)
            if (.not.ma_push_get(mt_dbl,dima,'noname',l_b,k_b))
     1      call errquit('tce_mp2_gradient: ma problem',5,ma_err)
c
            call get_hash_block(d_1pwdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pwdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            call get_hash_block(d_f1,dbl_mb(k_b),dima,
     1           int_mb(k_f1_offset),(g1b-1)+(g1b-1)*(noab+nvab))
c
            do g1=1,int_mb(k_range+g1b-1)
               dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))=
     1         dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1)) -
     1         dbl_mb(k_b+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))
            enddo
            call put_hash_block(d_1pwdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pwdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            if (.not.ma_pop_stack(l_b))
     1      call errquit('tce_mp2_gradient: ma problem',6,ma_err)
            if (.not.ma_pop_stack(l_a))
     1      call errquit('tce_mp2_gradient: ma problem',3,ma_err)
         endif
         next=nxtask(nprocs,1)
         endif
         count=count+1
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c     ==============================
      call int_terminate()
      call schwarz_tidy()
c     =================
c     Do the gradients
c     =================
      status=tce_gradients_doit(rtdb, model,
     1       d_1pdm,  k_1pdm_offset,  size_1pdm,
     1       d_1pwdm, k_1pwdm_offset, size_1pwdm,
     1       d_2pdm,  k_2pdm_offset,  size_2pdm,
     1       noab,nvab,k_range,k_offset,k_spin,
     1       k_movecs_sorted,restricted)
c     =============================
c     clean up the files and arrays
c     =============================
      call deletefile(d_1pwdm)
      if(.not.ma_pop_stack(l_1pwdm_offset))
     1  call errquit('tce_mp2_gradient: ma problem',997,ma_err)
      call deletefile(d_1pdm)
      if(.not.ma_pop_stack(l_1pdm_offset))
     1  call errquit('tce_mp2_gradient: ma problem',996,ma_err)
      call deletefile(d_2pdm)
      if(.not.ma_pop_stack(l_2pdm_offset))
     1  call errquit('tce_mp2_gradient: ma problem',995,ma_err)     
c
      call deletefile(d_wpp)
      if(.not.ma_pop_stack(l_wpp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',1,ma_err)
c
      call deletefile(d_whp)
      if(.not.ma_pop_stack(l_whp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',3,ma_err)
c
      call deletefile(d_whh)
      if(.not.ma_pop_stack(l_whh_offset))
     1  call errquit('tce_mp2_gradient: ma problem',4,ma_err)
c
      call deletefile(d_ph)
      if(.not.ma_pop_stack(l_ph_offset))
     1  call errquit('tce_mp2_gradient: ma problem',6,ma_err)
c
      call deletefile(d_x1)
      if(.not.ma_pop_stack(l_x1_offset))
     1  call errquit('tce_mp2_gradient: ma problem',7,ma_err)
c
      call deletefile(d_pppp)
      if(.not.ma_pop_stack(l_pppp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',8,ma_err)
c
      call deletefile(d_pphp)
      if(.not.ma_pop_stack(l_pphp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',9,ma_err)
c
      call deletefile(d_pphh)
      if(.not.ma_pop_stack(l_pphh_offset))
     1  call errquit('tce_mp2_gradient: ma problem',10,ma_err)
c
      call deletefile(d_hppp)
      if(.not.ma_pop_stack(l_hppp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',11,ma_err)
c
      call deletefile(d_hphp)
      if(.not.ma_pop_stack(l_hphp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',12,ma_err)
c
      call deletefile(d_hphh)
      if(.not.ma_pop_stack(l_hphh_offset))
     1  call errquit('tce_mp2_gradient: ma problem',13,ma_err)
c
      call deletefile(d_hhpp)
      if(.not.ma_pop_stack(l_hhpp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',14,ma_err)
c
      call deletefile(d_hhhp)
      if(.not.ma_pop_stack(l_hhhp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',15,ma_err)
c
      call deletefile(d_hhhh)
      if(.not.ma_pop_stack(l_hhhh_offset))
     1  call errquit('tce_mp2_gradient: ma problem',16,ma_err)
c
      call deletefile(d_pp)
      if(.not.ma_pop_stack(l_pp_offset))
     1  call errquit('tce_mp2_gradient: ma problem',17,ma_err)
c
      call deletefile(d_hh)
      if(.not.ma_pop_stack(l_hh_offset))
     1  call errquit('tce_mp2_gradient: ma problem',18,ma_err)
c
      call deletefile(d_y2)
      if (.not.ma_pop_stack(l_y2_offset))
     1   call errquit('tce_mp2_gradient: ma problem',19,ma_err)
c
 9050 format(/,1x,A,' iterations',/,
     1  1x,'--------------------------------------',/
     2  1x,'Iter          Residuum     Cpu    Wall',/
     3  1x,'--------------------------------------')
 9060 format(
     1  1x,'--------------------------------------',/
     2  1x,'Iterations converged')
 9100 format(1x,i4,f18.13,2f8.1)
      end
c $Id: tce_mp2_gradient.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine smd_init(operation,rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) operation
      integer rtdb
c
      character*80 pname
      character*80 tag

      pname = "smd_init"
      tag = operation
      if(tag.eq."energy") then
        call smd_init_sp(rtdb)
      else if(tag.eq."dynamics") then
        call smd_init_dynamics(rtdb)
      else if(tag.eq."fragment") then
        call smd_init_fragment(rtdb)
      else
        call errquit(
     >       pname//'unknown operation'//tag,0, 0)
      end if


      return
      end

      subroutine smd_init_sp(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer rtdb
c
      logical ostatus
      character*72 tag
      character*32 pname
      character*255 filename
      character*72 sp_system
      character*72 sp_atom
      character*72 sp_param
      character*72 sp_bond
      character*72 sp_shakelist
      character*72 sp_bondlist
      character*72 sp_lattice
      character*72 sp_type
      character*72 sp_pot
      character*72 sp_coord
      character*72 sp_charge
      character*72 sp_force
      character*72 sp_energy
      character*72 sp_exlist
      character*72 sp_vlist
      character*72 sp_mass
      character*72 sp_cutoff
      character*72 sp_temperature
      character*72 sp_rtdb
      character*72 sp_ewald
c
      logical olattice
      logical obond
      integer master
      logical odistrib
c
      odistrib = .false.
      master = 0
      pname = "smd_init_dynamics"
c
      sp_atom      = "atom"
      sp_param     = "parameters"
      sp_lattice   = "lattice"
      sp_type      = "type"
      sp_pot       = "potential"
      sp_coord     = "coordinates"
      sp_charge    = "charge"
      sp_force     = "force"
      sp_energy    = "energy"
      sp_exlist    = "excluded_list"
      sp_vlist     = "verlet_list"
      sp_shakelist = "shakelist"
      sp_bondlist  = "bondlist"
      sp_bond      = "bond"
      sp_mass  = "mass"
      sp_cutoff  = "cutoff"
      sp_temperature = "temperature"
      sp_rtdb = "rtdb"
      sp_ewald = "ewald"
c
c
c     CREATE SYSTEM
c     ------------
      tag = "atom"
      call smd_system_set_component(tag,sp_atom)

      tag = "parameters"
      call smd_system_set_component(tag,sp_param)

      tag = "type"
      call smd_system_set_component(tag,sp_type)

      tag = "lattice"
      call smd_system_set_component(tag,sp_lattice)

      tag = "potential"
      call smd_system_set_component(tag,sp_pot)

      tag = "coordinates"
      call smd_system_set_component(tag,sp_coord)

      tag = "force"
      call smd_system_set_component(tag,sp_force)

      tag = "charge"
      call smd_system_set_component(tag,sp_charge)

      tag = "excl_list"
      call smd_system_set_component(tag,sp_exlist)

      tag = "verlet_list"
      call smd_system_set_component(tag,sp_vlist)

      tag = "energy"
      call smd_system_set_component(tag,sp_energy)

      tag = "bond"
      call smd_system_set_component(tag,sp_bond)

      tag = "shakelist"
      call smd_system_set_component(tag,sp_shakelist)

      tag = "bondlist"
      call smd_system_set_component(tag,sp_bondlist)

      tag = "mass"
      call smd_system_set_component(tag,sp_mass)

      tag = "cutoff"
      call smd_system_set_component(tag,sp_cutoff)

      tag = "temperature"
      call smd_system_set_component(tag,sp_temperature)

      tag = "rtdb"
      call smd_system_set_component(tag,sp_rtdb)

      tag = "ewald"
      call smd_system_set_component(tag,sp_ewald)
c
c      write(*,*) "in "//pname
c     DEFINE ALL THE COMPONENTS
c     --------------------------------
c
      if(ga_nodeid().eq.master) then
      call smd_rtdb_init(.false.,rtdb)
      call smd_cutoff_init()
      call smd_temper_init()
      call smd_atom_init_system()
      call smd_param_init_system()
      call smd_lat_init_system()
      call smd_pot_init_system()
      call smd_type_init_system()
      call smd_energy_init_system()
      call smd_force_init_system()
      call smd_charge_init_system()
      call smd_coords_init_system()
      call smd_exlist_init_system()
      call smd_vlist_init_system()
      call smd_bond_init_system()
      call smd_shakelist_init_system()
      call smd_bondlist_init_system()
      call smd_mass_init_system()
c
c     finish system setup
c     -------------------
      call smd_coords_rebox()
      call smd_ewald_init()
      call smd_system_print(6)

      end if
      call ga_sync()
      call smd_data_brdcst_create(master)
      return
      end

      subroutine smd_init_fragment(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer rtdb
c
      logical ostatus
      character*72 tag
      character*32 pname
      character*255 filename
      character*72 sp_system
      character*72 sp_atom
      character*72 sp_param
      character*72 sp_bond
      character*72 sp_shakelist
      character*72 sp_bondlist
      character*72 sp_lattice
      character*72 sp_type
      character*72 sp_pot
      character*72 sp_coord
      character*72 sp_charge
      character*72 sp_force
      character*72 sp_energy
      character*72 sp_exlist
      character*72 sp_vlist
      character*72 sp_mass
      character*72 sp_cutoff
      character*72 sp_temperature
      character*72 sp_rtdb
      character*72 sp_ewald
      character*72 sp_fragment
c
      logical olattice
      logical obond
      integer master
      logical odistrib
c
      odistrib = .true.
c
      master = 0
      pname = "smd_init_dynamics"
c
      sp_atom      = "atom"
      sp_param     = "parameters"
      sp_lattice   = "lattice"
      sp_type      = "type"
      sp_pot       = "potential"
      sp_coord     = "coordinates"
      sp_charge    = "charge"
      sp_fragment    = "fragment"
      sp_force     = "force"
      sp_energy    = "energy"
      sp_exlist    = "excluded_list"
      sp_vlist     = "verlet_list"
      sp_shakelist = "shakelist"
      sp_bondlist  = "bondlist"
      sp_bond      = "bond"
      sp_mass  = "mass"
      sp_cutoff  = "cutoff"
      sp_temperature = "temperature"
      sp_rtdb = "rtdb"
      sp_ewald = "ewald"
c
c
c     CREATE SYSTEM
c     ------------
      tag = "atom"
      call smd_system_set_component(tag,sp_atom)

      tag = "parameters"
      call smd_system_set_component(tag,sp_param)

      tag = "type"
      call smd_system_set_component(tag,sp_type)

      tag = "lattice"
      call smd_system_set_component(tag,sp_lattice)

      tag = "potential"
      call smd_system_set_component(tag,sp_pot)

      tag = "coordinates"
      call smd_system_set_component(tag,sp_coord)

      tag = "force"
      call smd_system_set_component(tag,sp_force)

      tag = "charge"
      call smd_system_set_component(tag,sp_charge)

      tag = "fragment"
      call smd_system_set_component(tag,sp_fragment)

      tag = "excl_list"
      call smd_system_set_component(tag,sp_exlist)

      tag = "verlet_list"
      call smd_system_set_component(tag,sp_vlist)

      tag = "energy"
      call smd_system_set_component(tag,sp_energy)

      tag = "bond"
      call smd_system_set_component(tag,sp_bond)

      tag = "shakelist"
      call smd_system_set_component(tag,sp_shakelist)

      tag = "bondlist"
      call smd_system_set_component(tag,sp_bondlist)

      tag = "mass"
      call smd_system_set_component(tag,sp_mass)

      tag = "cutoff"
      call smd_system_set_component(tag,sp_cutoff)

      tag = "temperature"
      call smd_system_set_component(tag,sp_temperature)

      tag = "rtdb"
      call smd_system_set_component(tag,sp_rtdb)

      tag = "ewald"
      call smd_system_set_component(tag,sp_ewald)
c
c      write(*,*) "in "//pname
c     DEFINE ALL THE COMPONENTS
c     --------------------------------
c
      if(ga_nodeid().eq.master) then
      call smd_rtdb_init(.false.,rtdb)
      call smd_cutoff_init()
      call smd_temper_init()
      call smd_atom_init_system()
      call smd_param_init_system()
      call smd_lat_init_system()
      call smd_pot_init_system()
      call smd_type_init_system()
      call smd_energy_init_system()
      call smd_force_init_system()
      call smd_charge_init_system()
      call smd_coords_init_system()
      call smd_exlist_init_system()
      call smd_vlist_init_system()
      call smd_bond_init_system()
      call smd_shakelist_init_system()
      call smd_bondlist_init_system()
      call smd_mass_init_system()
c
c     finish system setup
c     -------------------
      call smd_coords_rebox()
      call smd_ewald_init()
      call smd_system_print(6)

      end if
      call ga_sync()
      call smd_data_brdcst_create(master)
      call smd_fragment_init_system()
      return
      end

      subroutine smd_init_dynamics(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer rtdb
c
      logical ostatus
      character*72 tag
      character*32 pname
      character*255 filename
      character*72 sp_system
      character*72 sp_atom
      character*72 sp_param
      character*72 sp_bond
      character*72 sp_shakelist
      character*72 sp_bondlist
      character*72 sp_lattice
      character*72 sp_type
      character*72 sp_pot
      character*72 sp_coord
      character*72 sp_charge
      character*72 sp_force
      character*72 sp_energy
      character*72 sp_exlist
      character*72 sp_vlist
      character*72 sp_velocity
      character*72 sp_mass
      character*72 sp_cutoff
      character*72 sp_temperature
      character*72 sp_rtdb
      character*72 sp_ewald
c
      logical olattice
      logical obond
      integer master
c
      logical odistrib
c
      odistrib = .false.
      master = 0
      pname = "smd_init_dynamics"
c
      sp_atom      = "atom"
      sp_param     = "parameters"
      sp_lattice   = "lattice"
      sp_type      = "type"
      sp_pot       = "potential"
      sp_coord     = "coordinates"
      sp_charge    = "charge"
      sp_force     = "force"
      sp_energy    = "energy"
      sp_exlist    = "excluded_list"
      sp_vlist     = "verlet_list"
      sp_shakelist = "shakelist"
      sp_bondlist  = "bondlist"
      sp_bond      = "bond"
      sp_velocity  = "velocity"
      sp_mass  = "mass"
      sp_cutoff  = "cutoff"
      sp_temperature = "temperature"
      sp_rtdb = "rtdb"
      sp_ewald = "ewald"
c
c
c     CREATE SYSTEM
c     ------------
      tag = "atom"
      call smd_system_set_component(tag,sp_atom)

      tag = "parameters"
      call smd_system_set_component(tag,sp_param)

      tag = "type"
      call smd_system_set_component(tag,sp_type)

      tag = "lattice"
      call smd_system_set_component(tag,sp_lattice)

      tag = "potential"
      call smd_system_set_component(tag,sp_pot)

      tag = "coordinates"
      call smd_system_set_component(tag,sp_coord)

      tag = "force"
      call smd_system_set_component(tag,sp_force)

      tag = "charge"
      call smd_system_set_component(tag,sp_charge)

      tag = "excl_list"
      call smd_system_set_component(tag,sp_exlist)

      tag = "verlet_list"
      call smd_system_set_component(tag,sp_vlist)

      tag = "energy"
      call smd_system_set_component(tag,sp_energy)

      tag = "bond"
      call smd_system_set_component(tag,sp_bond)

      tag = "shakelist"
      call smd_system_set_component(tag,sp_shakelist)

      tag = "bondlist"
      call smd_system_set_component(tag,sp_bondlist)

      tag = "velocity"
      call smd_system_set_component(tag,sp_velocity)

      tag = "mass"
      call smd_system_set_component(tag,sp_mass)

      tag = "cutoff"
      call smd_system_set_component(tag,sp_cutoff)

      tag = "temperature"
      call smd_system_set_component(tag,sp_temperature)

      tag = "rtdb"
      call smd_system_set_component(tag,sp_rtdb)

      tag = "ewald"
      call smd_system_set_component(tag,sp_ewald)
c
c      write(*,*) "in "//pname
c     DEFINE ALL THE COMPONENTS
c     --------------------------------
c
      if(ga_nodeid().eq.master) then
      call smd_rtdb_init(.false.,rtdb)
      call smd_cutoff_init()
      call smd_temper_init()
      call smd_atom_init_system()
      call smd_param_init_system()
      call smd_lat_init_system()
      call smd_pot_init_system()
      call smd_type_init_system()
      call smd_energy_init_system()
      call smd_force_init_system()
      call smd_coords_init_system()
      call smd_charge_init_system()
      call smd_exlist_init_system()
      call smd_vlist_init_system()
      call smd_bond_init_system()
      call smd_shakelist_init_system()
      call smd_bondlist_init_system()
      call smd_vel_init_system()
      call smd_mass_init_system()
c
c     finish system setup
c     -------------------
      call smd_coords_rebox()
      call smd_ewald_init()
      call smd_system_print(6)

      end if
      call ga_sync()
      call smd_data_brdcst_create(master)
      return
      end

c $Id: smd_init.F 22502 2012-05-20 06:11:57Z d3y133 $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     CCDen_Driver -- Top-level routine for coupled cluster density
C
C REVISION
C     $Id: ccden_driver.F 19708 2010-10-29 18:04:21Z d3y133 $
C
C SYNOPSIS
      Subroutine CCDen_Driver(NOcc, NVir, T1, LDT1, g_T2, Z1, LDZ1,
     $   g_Z2, g_1PDM)
      Implicit NONE
#include "errquit.fh"
      Integer NOcc, NVir, LDT1, LDZ1
      Integer g_T2, g_Z2, g_1PDM
      Double Precision T1(LDT1, NVir), Z1(LDZ1, NVir)
C
C ARGUMENTS
C DESCRIPTION
C INCLUDE FILES
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
#include "stdio.fh"
C
C EXTERNAL ROUTINES
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer H_SmOmeg1, H_SmOmeg2, H_SmOmeg3, H_SmOmeg4
      Integer I_SmOmeg1, I_SmOmeg2, I_SmOmeg3, I_SmOmeg4
      Integer g_LgOmeg1, g_LgOmeg2
      Integer g_2PDMoooo
      Integer g_2PDMvvoo
C
C     ******************
C     * Initialization *
C     ******************
C
C     ********************************
C     * Create 2-index intermediates *
C     ********************************
C     These are the "small omega" quantities of APR & TJL Eq. 52--55
C
      If (.NOT. MA_Push_Get(MT_Dbl, NOcc*NVir, 'CCDen SmOmeg1',
     $   H_SmOmeg1, I_SmOmeg1) ) Call ErrQuit(
     $   'CCDen_Driver: unable to allocate SmOmeg1', NOcc*NVir,
     &       MA_ERR)
C
      If (.NOT. MA_Push_Get(MT_Dbl, NOcc*NVir, 'CCDen SmOmeg2',
     $   H_SmOmeg2, I_SmOmeg2) ) Call ErrQuit(
     $   'CCDen_Driver: unable to allocate SmOmeg2', NOcc*NVir,
     &       MA_ERR)
C
      If (.NOT. MA_Push_Get(MT_Dbl, NVir*NVir, 'CCDen SmOmeg3',
     $   H_SmOmeg3, I_SmOmeg3) ) Call ErrQuit(
     $   'CCDen_Driver: unable to allocate SmOmeg3', NVir*NVir,
     &       MA_ERR)
C
      If (.NOT. MA_Push_Get(MT_Dbl, NOcc*NOcc, 'CCDen SmOmeg4',
     $   H_SmOmeg4, I_SmOmeg4) ) Call ErrQuit(
     $   'CCDen_Driver: unable to allocate SmOmeg4', NOcc*NOcc,
     &       MA_ERR)
C
      Call CCDen_Interm2( NOcc, NVir, T1, LDT1, G_T2, Z1, LDZ1, g_Z2,
     $   Dbl_MB(I_SmOmeg1), NOcc, Dbl_MB(I_SmOmeg2), NOcc,
     $   Dbl_MB(I_SmOmeg3), NVir, Dbl_MB(I_SmOmeg4), NOcc )
C
C     Print these things if requested
C
      If (Util_Print('density 2-index intermediates', Print_Debug)
     $   .AND. GA_NodeID() .eq. 0) then
         Call DGeWr(NOcc, NVir, Dbl_MB(I_SmOmeg1), NOcc, 0, 0, LuOut,
     $      'Density Intermediate (small) Omega 1', 80, 'F20.15')
         Call DGeWr(NOcc, NVir, Dbl_MB(I_SmOmeg2), NOcc, 0, 0, LuOut,
     $      'Density Intermediate (small) Omega 2', 80, 'F20.15')
         Call DGeWr(NVir, NVir, Dbl_MB(I_SmOmeg3), NVir, 0, 0, LuOut,
     $      'Density Intermediate (small) Omega 3', 80, 'F20.15')
         Call DGeWr(NOcc, NOcc, Dbl_MB(I_SmOmeg4), NOcc, 0, 0, LuOut,
     $      'Density Intermediate (small) Omega 4', 80, 'F20.15')
      EndIf
C
C     *****************
C     * Compute 1-PDM *
C     *****************
C
      Call CCDen_1PDM( NOcc, NVir, T1, LDT1, G_T2, Z1, LDZ1, g_Z2,
     $   Dbl_MB(I_SmOmeg1), NOcc, Dbl_MB(I_SmOmeg2), NOcc,
     $   Dbl_MB(I_SmOmeg3), NVir, Dbl_MB(I_SmOmeg4), NOcc, G_1PDM )
C
C     Print this thing if requested
C
      If (Util_Print('1pdm', Print_Debug) ) Call GA_Print(G_1PDM)
C
C     -----WRITE TO DISK HERE-----
C
C     ****************************
C     * Compute 2-PDM oooo terms *
C     ****************************
C     No multi-passing -- assumes v > o and holds G(i,j,k,l) in core
C
C     To save memory, we do not save Tau = T2 + T1 * T1, or 
C     [TauZ](i,j,k,l), both of which are computed in CCDen_2PDMoooo.
C     Formation of [TauZ] costs O(o**4 v**2), and it appears also in
C     G(a,i,b,j) and G(a,i,j,k).
C
      If ( .NOT. GA_Create(MT_Dbl, NOcc*NOcc, NOcc*NOcc,
     $     'CCDen 2-PDM oooo', NOcc, NOcc, G_2PDMoooo) ) Call ErrQuit(
     $     'CCDen_Driver: unable to allocate 2-PDM oooo',
     $     NOcc*NOcc*NOcc*NOcc, GA_ERR)
C
      Call CCDen_2PDMoooo(NOcc, NVir, T1, LDT1, g_T2, g_Z2,
     $     g_1PDM, g_2PDMoooo)
C
      If (Util_Print('2pdm', Print_Debug) ) Call GA_Print(G_2PDMoooo)
C
C     -----WRITE TO DISK HERE-----
C
      If (.NOT. GA_Destroy(g_2PDMoooo) ) Call ErrQuit(
     $     'CCDen_Driver: unable to free 2-PDM oooo', 0, GA_ERR)
C
C     ****************************
C     * Compute 2-PDM vvvv terms *
C     ****************************
C
C     ********************************
C     * Create 4-index intermediates *
C     ********************************
C     These are the "large omega" quantities of APR & TJL Eq. 60--62
C     Not required for oooo and vvvv terms of 2-PDM.
C     Costs are O(o**3 v**3) for each term.
C
C     Since LgOmeg3 is easily computed as the scaled sum of LgOmeg1 and
C     LgOmeg2, we do it on the fly as needed.
C
C
      If ( .NOT. GA_Create(MT_Dbl, NVir*NOcc, NVir*NOcc,
     $     'CCDen LgOmeg1', NVir, NVir, G_LgOmeg1) ) Call ErrQuit(
     $     'CCDen_Driver: unable to allocate LgOmeg1',
     $     NVir*NOcc*NVir*NOcc, GA_ERR)
C
      If ( .NOT. GA_Create(MT_Dbl, NVir*NOcc, NVir*NOcc,
     $     'CCDen LgOmeg2', NVir, NVir, G_LgOmeg2) ) Call ErrQuit(
     $     'CCDen_Driver: unable to allocate LgOmeg2',
     $     NVir*NOcc*NVir*NOcc, GA_ERR)
C
      Call CCDen_Interm4( NOcc, NVir, G_T2, g_Z2, g_LgOmeg1, g_LgOmeg2)
C
C     Print these things if requested
C
      If (Util_Print('density 4-index intermediates',
     $     Print_Debug) ) then
         Call GA_Print(g_LgOmeg1)
         Call GA_Print(g_LgOmeg2)
      EndIf
C
C     ****************************
C     * Compute 2-PDM vvoo terms *
C     ****************************
C     No multi-passing -- assumes v > o and holds G(a,b,i,j) in core
C     NOTE: stored like T2 and Z2, despite "vvoo" labeling!
C
      If ( .NOT. GA_Create(MT_Dbl, NVir*NOcc, NVir*NOcc,
     $     'CCDen 2-PDM vvoo', NVir, NVir, G_2PDMvvoo) ) Call ErrQuit(
     $     'CCDen_Driver: unable to allocate 2-PDM vvoo',
     $     NVir*NOcc*NVir*NOcc, GA_ERR)
C
      Call CCDen_2PDMvvoo( NOcc, NVir, T1, LDT1, Z1, LDZ1, g_Z2,
     $     g_LgOmeg1, g_LgOmeg2, g_1PDM, g_2PDMvvoo)
C
C     Print these things if requested
C
      If (Util_Print('2pdm', Print_Debug) )Call GA_Print(g_2PDMvvoo)
C
C     -----WRITE TO DISK HERE-----
C
      If (.NOT. GA_Destroy(g_2PDMvvoo) ) Call ErrQuit(
     $     'CCDen_Driver: unable to free 2-PDM vvoo', 0, GA_ERR)








C
C     Get rid of temporary arrays
C
      If (.NOT. GA_Destroy(g_LgOmeg2) ) Call ErrQuit(
     $     'CCDen_Driver: unable to free LgOmeg2', 0, GA_ERR)
      If (.NOT. GA_Destroy(g_LgOmeg1) ) Call ErrQuit(
     $     'CCDen_Driver: unable to free LgOmeg1', 0, GA_ERR)
C
      If (.NOT. MA_Pop_Stack(H_SmOmeg4) ) Call ErrQuit(
     $   'CCDen_Driver: unable to free SmOmeg4', 0, MA_ERR)
      If (.NOT. MA_Pop_Stack(H_SmOmeg3) ) Call ErrQuit(
     $   'CCDen_Driver: unable to free SmOmeg3', 0, MA_ERR)
      If (.NOT. MA_Pop_Stack(H_SmOmeg2) ) Call ErrQuit(
     $   'CCDen_Driver: unable to free SmOmeg2', 0, MA_ERR)
      If (.NOT. MA_Pop_Stack(H_SmOmeg1) ) Call ErrQuit(
     $   'CCDen_Driver: unable to free SmOmeg1', 0, MA_ERR)
C
      Return
      End

*
* $Id: psp_U.F 25011 2013-12-19 17:45:25Z d3y133 $
*

*     ***********************************
*     *					*
*     *	 	  psp_U_init  		*
*     *					*
*     ***********************************

      subroutine psp_U_init()      
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "psp.fh"

      integer taskid,MASTER
      parameter (MASTER=0)

      integer nion,i,j,ii
      logical value

*     **** external functions *****
      logical  control_psputerm
      external control_psputerm
      integer  ion_nion,control_pspnuterms
      external ion_nion,control_pspnuterms
 

*     **** setup psputerm structure - used for adding Hubbard U term ****
      pspnuterms = control_pspnuterms()
      psputerm   = control_psputerm().and.(pspnuterms.gt.0)
      if (psputerm) then
         nion  = ion_nion()
         value = MA_alloc_get(mt_int,pspnuterms,'psputerm_l',
     >                psputerm_l(2),psputerm_l(1))

         value = value.and.
     >   MA_alloc_get(mt_dbl,pspnuterms,'psputerm_uscale',
     >                psputerm_uscale(2),psputerm_uscale(1))
         value = value.and.
     >   MA_alloc_get(mt_dbl,pspnuterms,'psputerm_jscale',
     >                psputerm_jscale(2),psputerm_jscale(1))
         value = value.and.
     >   MA_alloc_get(mt_log,nion*pspnuterms,'psputerm_ions',
     >                psputerm_ions(2),psputerm_ions(1))

         value = value.and.
     >   MA_alloc_get(mt_int,pspnuterms,'psputerm_vstart',
     >                psputerm_vstart(2),psputerm_vstart(1))

         if (.not. value)
     >   call errquit('psp_U_init:out of heap memory',0, MA_ERR)

         call control_set_psputerm(nion,pspnuterms,
     >                             int_mb(psputerm_l(1)),
     >                             dbl_mb(psputerm_uscale(1)),
     >                             dbl_mb(psputerm_jscale(1)),
     >                             log_mb(psputerm_ions(1)))

         psputerm_vcount = 0
         do i=1,pspnuterms
            int_mb(psputerm_vstart(1)+i-1) = psputerm_vcount
            psputerm_vcount = psputerm_vcount 
     >                      + (2*int_mb(psputerm_l(1)+i-1)+1)**4
         end do

         j = 0
         do ii=1,nion
         do i=1,pspnuterms
         if (log_mb(psputerm_ions(1)+ii-1+(i-1)*nion)) then
            j = j + 1
         end if
         end do
         end do
         value = MA_alloc_get(mt_int,j,'psputerm_ld_start',
     >             psputerm_ld_start(2),psputerm_ld_start(1))
         if (.not. value)
     >   call errquit('psp_U_init:out of heap memory',1, MA_ERR)


         j = 0
         psputerm_ld_count = 0
         do ii=1,nion
            do i=1,pspnuterms
               if (log_mb(psputerm_ions(1)+ii-1+(i-1)*nion)) then
                  int_mb(psputerm_ld_start(1)+j) = psputerm_ld_count
                  psputerm_ld_count = psputerm_ld_count 
     >                   + 2*(2*int_mb(psputerm_l(1)+i-1)+1)**2
                  j = j + 1
               end if
            end do
         end do

         value = 
     >   MA_alloc_get(mt_dbl,psputerm_vcount,'psputerm_vmmmm',
     >                psputerm_vmmmm(2),psputerm_vmmmm(1))
         value = value.and.
     >   MA_alloc_get(mt_dbl,psputerm_ld_count,'psputerm_ld',
     >                psputerm_ld(2),psputerm_ld(1))
         if (.not. value)
     >   call errquit('psp_U_init:out of heap memory',2, MA_ERR)

         do i=1,pspnuterms
             call psputerm_gen_vmmmm(int_mb(psputerm_l(1)+i-1),
     >                               2*int_mb(psputerm_l(1)+i-1)+1,
     >                               dbl_mb(psputerm_uscale(1)+i-1),
     >                               dbl_mb(psputerm_jscale(1)+i-1),
     >                               dbl_mb(psputerm_vmmmm(1)
     >                               +int_mb(psputerm_vstart(1)+i-1)))
         end do

      end if

      return
      end

*     ***********************************
*     *					*
*     *	 	  psp_U_end  		*
*     *					*
*     ***********************************

      subroutine psp_U_end()      
      implicit none

#include "errquit.fh"
#include "mafdecls.fh"
#include "psp.fh"

*     **** version4 common block ****
      logical value

      value = .true.
      if (psputerm) then
         value = value.and.MA_free_heap(psputerm_l(2))
         value = value.and.MA_free_heap(psputerm_uscale(2))
         value = value.and.MA_free_heap(psputerm_jscale(2))
         value = value.and.MA_free_heap(psputerm_ions(2))
         value = value.and.MA_free_heap(psputerm_vstart(2))
         value = value.and.MA_free_heap(psputerm_vmmmm(2))
         value = value.and.MA_free_heap(psputerm_ld_start(2))
         value = value.and.MA_free_heap(psputerm_ld(2))
      end if

      if (.not.value) 
     >  call errquit('psp_U_end:error freeing heap memory',0,MA_ERR)

      return
      end


*     ***********************************
*     *                                 *
*     *            psp_U_psputerm       *
*     *                                 *
*     ***********************************
      logical function psp_U_psputerm()
      implicit none

#include "psp.fh"

      psp_U_psputerm = psputerm
      return
      end



*     ***********************************
*     *					*
*     *	 	   psp_U_v_nonlocal	*
*     *					*
*     ***********************************

*    This routine computes the Kleinman-Bylander non-local 
* pseudopotential projection.
*
*  Note - This routine was restructured 5-13-2002 to improve
*         parallel efficiency.
*
      subroutine psp_U_v_nonlocal(ispin,ne,psi1,psi2,move,fion,
     >                            fractional,occ,ld_update)
      implicit none
      integer    ispin,ne(2)
      complex*16 psi1(*)
      complex*16 psi2(*)
      logical move
      real*8 fion(3,*)
      logical fractional
      real*8 occ(*)
      logical ld_update

#include "mafdecls.fh"
#include "psp.fh"
#include "errquit.fh"


*     *** local variables ***
      integer G(3),npack1,nion,nu
      integer i,j,ii,ia,l,n,nn
      integer k,shift,l_prj,nproj,Gijl_indx
      real*8  omega,scal,ff(3)
      complex*16 ctmp
      integer exi(2),xtmp(2),sw1(2),sw2(2),sw3(2),asum(2)
      logical value,sd_function
      real*8 vmm(50)
      integer ld_ptr

*     **** external functions ****
      logical  is_sORd
      integer  ion_nion,ion_katm,Pack_G_indx
      integer  psi_data_get_ptr,psi_data_get_chnk
      real*8   lattice_omega
      external is_sORd
      external ion_nion,ion_katm,Pack_G_indx
      external psi_data_get_ptr,psi_data_get_chnk
      external lattice_omega

      call nwpw_timing_start(6) 

*     **** allocate local memory ****
      nion = ion_nion()
      nn = ne(1)+ne(2)
      call Pack_npack(1,npack1)

      value = MA_push_get(mt_dcpl,npack1,'exi', exi(2), exi(1))
      value = value.and.
     >   MA_push_get(mt_dbl,nn*nprj_max*nprj_mult,'sw1',sw1(2),sw1(1))
      value = value.and.
     >   MA_push_get(mt_dbl,nn*nprj_max*nprj_mult,'sw2',sw2(2),sw2(1))
      value = value.and.
     >   MA_push_get(mt_dbl,nn*nprj_max*nprj_mult,'sw3',sw3(2),sw3(1))
      if (.not.value) 
     >  call errquit('v_nonlocal: out of stack',0, MA_ERR)

      if (move) then
       value = value.and.MA_push_get(mt_dbl,npack1,
     >                               'xtmp',xtmp(2),xtmp(1))
       value = value.and.MA_push_get(mt_dbl,3*nn,'asum',asum(2),asum(1))
       if (.not. value) 
     >  call errquit('v_nonlocal:out of stack memory',1,MA_ERR)

       G(1)  = Pack_G_indx(1,1)
       G(2)  = Pack_G_indx(1,2)
       G(3)  = Pack_G_indx(1,3)
      end if

      omega = lattice_omega()
      scal = 1.0d0/omega

      j = 0
      psputerm_edftu = 0.0d0
      psputerm_pdftu = 0.0d0
      do ii=1,nion
        value = .false.
        do nu=1,pspnuterms
           value=value.or.log_mb(psputerm_ions(1)+ii-1+(nu-1)*nion)
        end do
        if (value) then
           ia=ion_katm(ii)
           nproj = int_mb(nprj(1)+ia-1)

*          **** structure factor and local pseudopotential ****
           call strfac_pack(1,ii,dcpl_mb(exi(1)))

*          **** generate sw1's and projectors ****
           do l=1,nproj
              shift = psi_data_get_ptr(int_mb(vnl(1)+ia-1),l)
              l_prj = int_mb(l_projector(1)+(l-1) 
     >                                  + (ia-1)*(nmax_max*lmmax_max))

#ifdef GCC4
              k = iand(l_prj,1)
#else
              k = and(l_prj,1)
#endif
              sd_function = (k.eq.0)

*             *** current function is s or d ****
              if (sd_function) then
                 call Pack_tc_Mul(1,dbl_mb(shift),
     >                              dcpl_mb(exi(1)),
     >                              dcpl_mb(prjtmp(1)+(l-1)*npack1))

*             *** current function is p or f ****
              else
                 call Pack_tc_iMul(1,dbl_mb(shift),
     >                              dcpl_mb(exi(1)),
     >                              dcpl_mb(prjtmp(1)+(l-1)*npack1))

              end if
              call Pack_cc_indot(1,nn,
     >                      psi1,
     >                      dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                      dbl_mb(sw1(1)+(l-1)*nn))
           end do
           call D3dB_Vector_SumAll((nn*nproj*nprj_mult),dbl_mb(sw1(1)))

*          **** sw2 = Gijl*sw1 ******
           Gijl_indx = psi_data_get_ptr(int_mb(Gijl(1)+ia-1),1)
           call Multiply_Gijl_sw1(nn,
     >                         nproj,
     >                         int_mb(nmax(1)+ia-1),
     >                         int_mb(lmax(1)+ia-1),
     >                         int_mb(n_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(l_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(m_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         dbl_mb(Gijl_indx),
     >                         dbl_mb(sw1(1)),
     >                         dbl_mb(sw2(1)))

           call dcopy(nn*nproj,0.0d0,0,dbl_mb(sw3(1)),1)
           do nu=1,pspnuterms
           if (log_mb(psputerm_ions(1)+ii-1+(nu-1)*nion)) then
              ld_ptr =psputerm_ld(1)+int_mb(psputerm_ld_start(1)+j)
              j = j + 1
              if (ld_update) then
                 call psputerm_gen_l_density(ispin,ne,nproj,
     >                        int_mb(l_projector(1)
     >                               +(ia-1)*(nmax_max*lmmax_max)),
     >                        int_mb(m_projector(1)
     >                              +(ia-1)*(nmax_max*lmmax_max)),
     >                        dbl_mb(sw2(1)),
     >                        int_mb(psputerm_l(1)+nu-1),
     >                        2*int_mb(psputerm_l(1)+nu-1)+1,
     >                        dbl_mb(ld_ptr))
              end if
              call psputerm_gen_vmm(ispin,
     >                     int_mb(psputerm_l(1)+nu-1),
     >                     2*int_mb(psputerm_l(1)+nu-1)+1,
     >                     dbl_mb(psputerm_uscale(1)+nu-1),
     >                     dbl_mb(psputerm_jscale(1)+nu-1),
     >                     dbl_mb(psputerm_vmmmm(1)
     >                           +int_mb(psputerm_vstart(1)+nu-1)),
     >                     dbl_mb(ld_ptr),vmm,
     >                     psputerm_edftu,psputerm_pdftu)
              call psputerm_add_upotential(ispin,ne,nproj,
     >                     int_mb(l_projector(1)
     >                            +(ia-1)*(nmax_max*lmmax_max)),
     >                     int_mb(m_projector(1)
     >                           +(ia-1)*(nmax_max*lmmax_max)),
     >                     int_mb(psputerm_l(1)+nu-1),
     >                     2*int_mb(psputerm_l(1)+nu-1)+1,
     >                     vmm,dbl_mb(sw2(1)),dbl_mb(sw3(1)))
           end if
           end do

           call Multiply_Gijl_sw1(nn,
     >                         nproj,
     >                         int_mb(nmax(1)+ia-1),
     >                         int_mb(lmax(1)+ia-1),
     >                         int_mb(n_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(l_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(m_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         dbl_mb(Gijl_indx),
     >                         dbl_mb(sw3(1)),
     >                         dbl_mb(sw2(1)))
        
*          **** do Kleinman-Bylander Multiplication ****
           call dscal(nn*int_mb(nprj(1)+ia-1)*nprj_mult,
     >                scal,dbl_mb(sw2(1)),1)

          call DGEMM('N','T',2*npack1,nn,int_mb(nprj(1)+ia-1)*nprj_mult,
     >               (1.0d0),
     >               dcpl_mb(prjtmp(1)), 2*npack1,
     >               dbl_mb(sw2(1)),     nn,
     >               (1.0d0),
     >               psi2,               2*npack1)


        if (move) then
        do l=1,nproj
             do n=1,nn
                if (ispin.eq.1) 
     >            dbl_mb(sw2(1)+n-1+(l-1)*nn)
     >            =2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change

#ifndef CRAY
!DIR$ ivdep
#endif
                do i=1,npack1
                   ctmp = psi1(i+(n-1)*npack1)
     >                  *dconjg(dcpl_mb(prjtmp(1)+(l-1)*npack1 + i-1))
                   dbl_mb(xtmp(1)+i-1) = dimag(ctmp)
                end do
                call Pack_tt_idot(1,dbl_mb(G(1)),dbl_mb(xtmp(1)),
     >                            dbl_mb(asum(1)+3*(n-1)))
                call Pack_tt_idot(1,dbl_mb(G(2)),dbl_mb(xtmp(1)),
     >                            dbl_mb(asum(1)+1+3*(n-1)))
                call Pack_tt_idot(1,dbl_mb(G(3)),dbl_mb(xtmp(1)),
     >                            dbl_mb(asum(1)+2+3*(n-1)))

             end do

             call D3dB_Vector_SumAll(3*(nn),dbl_mb(asum(1)))

             !**** fractional weighting ****
             if (fractional) then
             do n=1,nn
              call Dneall_qton(n,i)
              dbl_mb(asum(1)  +3*(n-1))=dbl_mb(asum(1)  +3*(n-1))*occ(i)
              dbl_mb(asum(1)+1+3*(n-1))=dbl_mb(asum(1)+1+3*(n-1))*occ(i)
              dbl_mb(asum(1)+2+3*(n-1))=dbl_mb(asum(1)+2+3*(n-1))*occ(i)
             end do
             end if
  
             ff(1) = 0.0d0
             ff(2) = 0.0d0
             ff(3) = 0.0d0
             do n=1,nn
                ff(1) = ff(1) + 2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change
     >                               *dbl_mb(asum(1)+  3*(n-1))
                ff(2) = ff(2) + 2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change
     >                               *dbl_mb(asum(1)+1+3*(n-1))
                ff(3) = ff(3) + 2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change
     >                               *dbl_mb(asum(1)+2+3*(n-1))
             end do
             call D1dB_Vector_SumAll(3,ff)
             fion(1,ii) = fion(1,ii)  - ff(1)
             fion(2,ii) = fion(2,ii)  - ff(2)
             fion(3,ii) = fion(3,ii)  - ff(3)
       
        end do !** l **
        end if !** move **


        end if !** if nproj>0 **
      end do !** ii **

      value = .true.
      if (move) then
      value = value.and.MA_pop_stack(asum(2))
      value = value.and.MA_pop_stack(xtmp(2))
      end if
      value = value.and.MA_pop_stack(sw3(2))
      value = value.and.MA_pop_stack(sw2(2))
      value = value.and.MA_pop_stack(sw1(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not.value) call errquit('v_nonlocal: popping stack',3,
     &       MA_ERR)
      call nwpw_timing_end(6)

      return 
      end


*     ***********************************
*     *					*
*     *	      f_psp_U_v_nonlocal	*
*     *					*
*     ***********************************

*    This routine computes the Kleinman-Bylander non-local 
* pseudopotential projection.
*
*  Note - This routine was restructured 5-13-2002 to improve
*         parallel efficiency.
*
      subroutine f_psp_U_v_nonlocal(ispin,ne,psi1,fion,
     >                            fractional,occ,ld_update)
      implicit none
      integer    ispin,ne(2)
      complex*16 psi1(*)
      real*8 fion(3,*)
      logical fractional
      real*8 occ(*)
      logical ld_update

#include "mafdecls.fh"
#include "psp.fh"
#include "errquit.fh"

*     *** local variables ***
      integer G(3),npack1,nion,nu
      integer i,j,ii,ia,l,n,nn
      integer k,shift,l_prj,nproj,Gijl_indx
      real*8  omega,scal,ff(3)
      complex*16 ctmp
      integer exi(2),xtmp(2),sw1(2),sw2(2),sw3(2),asum(2)
      logical value,sd_function
      real*8 vmm(50)
      integer ld_ptr

*     **** external functions ****
      logical  is_sORd
      integer  ion_nion,ion_katm,Pack_G_indx
      integer  psi_data_get_ptr,psi_data_get_chnk
      real*8   lattice_omega
      external is_sORd
      external ion_nion,ion_katm,Pack_G_indx
      external psi_data_get_ptr,psi_data_get_chnk
      external lattice_omega

      call nwpw_timing_start(6) 

*     **** allocate local memory ****
      nion = ion_nion()
      nn = ne(1)+ne(2)
      call Pack_npack(1,npack1)

      value = MA_push_get(mt_dcpl,npack1,'exi', exi(2), exi(1))
      value = value.and.
     >   MA_push_get(mt_dbl,nn*nprj_max*nprj_mult,'sw1',sw1(2),sw1(1))
      value = value.and.
     >   MA_push_get(mt_dbl,nn*nprj_max*nprj_mult,'sw2',sw2(2),sw2(1))
      value = value.and.
     >   MA_push_get(mt_dbl,nn*nprj_max*nprj_mult,'sw3',sw3(2),sw3(1))
      if (.not.value) 
     >  call errquit('v_nonlocal: out of stack',0, MA_ERR)

      value = value.and.MA_push_get(mt_dbl,npack1,
     >                               'xtmp',xtmp(2),xtmp(1))
      value = value.and.MA_push_get(mt_dbl,3*nn,'asum',asum(2),asum(1))
      if (.not. value) 
     > call errquit('v_nonlocal:out of stack memory',1,MA_ERR)

      G(1)  = Pack_G_indx(1,1)
      G(2)  = Pack_G_indx(1,2)
      G(3)  = Pack_G_indx(1,3)

      omega = lattice_omega()
      scal = 1.0d0/omega

      j = 0
      psputerm_edftu = 0.0d0
      psputerm_pdftu = 0.0d0
      do ii=1,nion
        value = .false.
        do nu=1,pspnuterms
           value=value.or.log_mb(psputerm_ions(1)+ii-1+(nu-1)*nion)
        end do
        if (value) then
           ia=ion_katm(ii)
           nproj = int_mb(nprj(1)+ia-1)

*          **** structure factor and local pseudopotential ****
           call strfac_pack(1,ii,dcpl_mb(exi(1)))

*          **** generate sw1's and projectors ****
           do l=1,nproj
              shift = psi_data_get_ptr(int_mb(vnl(1)+ia-1),l)
              l_prj = int_mb(l_projector(1)+(l-1) 
     >                                  + (ia-1)*(nmax_max*lmmax_max))

#ifdef GCC4
              k = iand(l_prj,1)
#else
              k = and(l_prj,1)
#endif
              sd_function = (k.eq.0)

*             *** current function is s or d ****
              if (sd_function) then
                 call Pack_tc_Mul(1,dbl_mb(shift),
     >                              dcpl_mb(exi(1)),
     >                              dcpl_mb(prjtmp(1)+(l-1)*npack1))

*             *** current function is p or f ****
              else
                 call Pack_tc_iMul(1,dbl_mb(shift),
     >                              dcpl_mb(exi(1)),
     >                              dcpl_mb(prjtmp(1)+(l-1)*npack1))

              end if
              call Pack_cc_indot(1,nn,
     >                      psi1,
     >                      dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                      dbl_mb(sw1(1)+(l-1)*nn))
           end do
           call D3dB_Vector_SumAll((nn*nproj*nprj_mult),dbl_mb(sw1(1)))

*          **** sw2 = Gijl*sw1 ******
           Gijl_indx = psi_data_get_ptr(int_mb(Gijl(1)+ia-1),1)
           call Multiply_Gijl_sw1(nn,
     >                         nproj,
     >                         int_mb(nmax(1)+ia-1),
     >                         int_mb(lmax(1)+ia-1),
     >                         int_mb(n_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(l_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(m_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         dbl_mb(Gijl_indx),
     >                         dbl_mb(sw1(1)),
     >                         dbl_mb(sw2(1)))

           call dcopy(nn*nproj,0.0d0,0,dbl_mb(sw3(1)),1)
           do nu=1,pspnuterms
           if (log_mb(psputerm_ions(1)+ii-1+(nu-1)*nion)) then
              ld_ptr =psputerm_ld(1)+int_mb(psputerm_ld_start(1)+j)
              j = j + 1
              if (ld_update) then
                 call psputerm_gen_l_density(ispin,ne,nproj,
     >                        int_mb(l_projector(1)
     >                               +(ia-1)*(nmax_max*lmmax_max)),
     >                        int_mb(m_projector(1)
     >                              +(ia-1)*(nmax_max*lmmax_max)),
     >                        dbl_mb(sw2(1)),
     >                        int_mb(psputerm_l(1)+nu-1),
     >                        2*int_mb(psputerm_l(1)+nu-1)+1,
     >                        dbl_mb(ld_ptr))
              end if
              call psputerm_gen_vmm(ispin,
     >                     int_mb(psputerm_l(1)+nu-1),
     >                     2*int_mb(psputerm_l(1)+nu-1)+1,
     >                     dbl_mb(psputerm_uscale(1)+nu-1),
     >                     dbl_mb(psputerm_jscale(1)+nu-1),
     >                     dbl_mb(psputerm_vmmmm(1)
     >                           +int_mb(psputerm_vstart(1)+nu-1)),
     >                     dbl_mb(ld_ptr),vmm,
     >                     psputerm_edftu,psputerm_pdftu)
              call psputerm_add_upotential(ispin,ne,nproj,
     >                     int_mb(l_projector(1)
     >                            +(ia-1)*(nmax_max*lmmax_max)),
     >                     int_mb(m_projector(1)
     >                           +(ia-1)*(nmax_max*lmmax_max)),
     >                     int_mb(psputerm_l(1)+nu-1),
     >                     2*int_mb(psputerm_l(1)+nu-1)+1,
     >                     vmm,dbl_mb(sw2(1)),dbl_mb(sw3(1)))
           end if
           end do

           call Multiply_Gijl_sw1(nn,
     >                         nproj,
     >                         int_mb(nmax(1)+ia-1),
     >                         int_mb(lmax(1)+ia-1),
     >                         int_mb(n_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(l_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         int_mb(m_projector(1)
     >                                + (ia-1)*(nmax_max*lmmax_max)),
     >                         dbl_mb(Gijl_indx),
     >                         dbl_mb(sw3(1)),
     >                         dbl_mb(sw2(1)))
        
*          **** do Kleinman-Bylander Multiplication ****
           call dscal(nn*int_mb(nprj(1)+ia-1)*nprj_mult,
     >                scal,dbl_mb(sw2(1)),1)


        do l=1,nproj
             do n=1,nn
                if (ispin.eq.1) 
     >            dbl_mb(sw2(1)+n-1+(l-1)*nn)
     >            =2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change

#ifndef CRAY
!DIR$ ivdep
#endif
                do i=1,npack1
                   ctmp = psi1(i+(n-1)*npack1)
     >                  *dconjg(dcpl_mb(prjtmp(1)+(l-1)*npack1 + i-1))
                   dbl_mb(xtmp(1)+i-1) = dimag(ctmp)
                end do
                call Pack_tt_idot(1,dbl_mb(G(1)),dbl_mb(xtmp(1)),
     >                            dbl_mb(asum(1)+3*(n-1)))
                call Pack_tt_idot(1,dbl_mb(G(2)),dbl_mb(xtmp(1)),
     >                            dbl_mb(asum(1)+1+3*(n-1)))
                call Pack_tt_idot(1,dbl_mb(G(3)),dbl_mb(xtmp(1)),
     >                            dbl_mb(asum(1)+2+3*(n-1)))

             end do

             call D3dB_Vector_SumAll(3*(nn),dbl_mb(asum(1)))

             !**** fractional weighting ****
             if (fractional) then
             do n=1,nn
              call Dneall_qton(n,i)
              dbl_mb(asum(1)  +3*(n-1))=dbl_mb(asum(1)  +3*(n-1))*occ(i)
              dbl_mb(asum(1)+1+3*(n-1))=dbl_mb(asum(1)+1+3*(n-1))*occ(i)
              dbl_mb(asum(1)+2+3*(n-1))=dbl_mb(asum(1)+2+3*(n-1))*occ(i)
             end do
             end if
  
             ff(1) = 0.0d0
             ff(2) = 0.0d0
             ff(3) = 0.0d0
             do n=1,nn
                ff(1) = ff(1) + 2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change
     >                               *dbl_mb(asum(1)+  3*(n-1))
                ff(2) = ff(2) + 2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change
     >                               *dbl_mb(asum(1)+1+3*(n-1))
                ff(3) = ff(3) + 2.0d0*dbl_mb(sw2(1)+n-1+(l-1)*nn) !// change
     >                               *dbl_mb(asum(1)+2+3*(n-1))
             end do
             call D1dB_Vector_SumAll(3,ff)
             fion(1,ii) = fion(1,ii)  - ff(1)
             fion(2,ii) = fion(2,ii)  - ff(2)
             fion(3,ii) = fion(3,ii)  - ff(3)
       
        end do !** l **


        end if !** if nproj>0 **
      end do !** ii **

      value = .true.
      value = value.and.MA_pop_stack(asum(2))
      value = value.and.MA_pop_stack(xtmp(2))
      value = value.and.MA_pop_stack(sw3(2))
      value = value.and.MA_pop_stack(sw2(2))
      value = value.and.MA_pop_stack(sw1(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not.value) call errquit('v_nonlocal: popping stack',3,
     &       MA_ERR)
      call nwpw_timing_end(6)

      return 
      end





*     ****************************************************
*     *                                                  *
*     *                psputerm_gen_vmmmm                *
*     *                                                  *
*     ****************************************************
      subroutine psputerm_gen_vmmmm(l,lm,U,J,vmmmm)
      implicit none
      integer l,lm
      real*8 U,J
      real*8 vmmmm(lm,lm,lm,lm)

*     **** local variables ****
      integer m1,m2,m3,m4,k,q,kk
      real*8 F(4),fourpi,aterm

*     **** external functions ****
      real*8   nwpw_gaunt
      external nwpw_gaunt

      fourpi = 16.0d0*datan(1.0d0)

      if (l.eq.0) then
        F(1) = U
        F(2) = 0.0d0
        F(3) = 0.0d0
        F(4) = 0.0d0
      end if
      if (l.eq.1) then
        F(1) = U
        F(2) = 5*J
        F(3) = 0.0d0
        F(4) = 0.0d0
      end if
      if (l.eq.2) then
        F(1) = U
        F(2) = 112.0d0/13.0d0*J
        F(3) =   70.d0/13.0d0*J
        F(4) = 0.0d0
      end if
      if (l.eq.3) then
        F(1) = U
        F(2) = 4125.0d0/346.0d0*J
        F(3) = 5511.0d0/692.0d0*J
        F(4) = 8151.0d0/13840d0*J
      end if

      do m1=-l,l
      do m3=-l,l
      do m2=-l,l
      do m4=-l,l
         vmmmm(m1+l+1,m2+l+1,m3+l+1,m4+l+1) = 0.0d0

         do kk=1,4
            k = 2*(kk-1)
            aterm = 0.0d0
            do q=-k,k
               aterm = aterm + nwpw_gaunt(.true.,k,q,l,m1,l,m2)
     >                        *nwpw_gaunt(.true.,k,q,l,m4,l,m3)
            end do
            aterm = aterm*fourpi/dble(2*k+1)

            vmmmm(m1+l+1,m2+l+1,m3+l+1,m4+l+1) 
     >         = vmmmm(m1+l+1,m2+l+1,m3+l+1,m4+l+1)
     >         +  F(kk)*aterm
         end do
      end do
      end do
      end do
      end do

      return
      end 

*     ****************************************************
*     *                                                  *
*     *                psputerm_gen_vmm                  *
*     *                                                  *
*     ****************************************************
      subroutine psputerm_gen_vmm(ispin,l,lm,U,J,vmmmm,l_density,vmm,
     >                            edftu,pdftu)
      implicit none
      integer ispin,l,lm
      real*8 U,J
      real*8 vmmmm(lm,lm,lm,lm)
      real*8 l_density(lm,lm,ispin)
      real*8 vmm(lm,lm,ispin)
      real*8 edftu,pdftu

*     *** local variables ****
      integer ms,m1,m2,m3,m4,n1,n2,n3,n4
      real*8  density_total,density(2),edftu1,pdftu1

      do ms=1,ispin
         density(ms) = 0.0d0
         do n1=1,lm
            density(ms) = density(ms) + l_density(n1,n1,ms)
         end do
      end do
      density_total = density(1)+density(ispin)
  
      edftu1 = 0.0d0
      pdftu1 = 0.0d0

      do ms=1,ispin
         do m1=-l,l
         do m2=-l,l
            n1=m1+l+1
            n2=m2+l+1
            vmm(n1,n2,ms)=0.0d0
            do m3=-l,l
            do m4=-l,l
               n3 = m3+l+1
               n4 = m4+l+1
            
               vmm(n1,n2,ms) = vmm(n1,n2,ms)
     >                       + (vmmmm(n1,n2,n3,n4)-vmmmm(n1,n4,n3,n2))
     >                        *l_density(n3,n4,ms)
               vmm(n1,n2,ms) = vmm(n1,n2,ms)
     >                       + vmmmm(n1,n2,n3,n4)
     >                        *l_density(n3,n4,ispin+1-ms)
            end do
            end do
            edftu1 = edftu1 + 0.5d0*vmm(n1,n2,ms)*l_density(n1,n2,ms)
            if(m1==m2)  then
               vmm(n1,n2,ms)=vmm(n1,n2,ms)-U*(density_total-0.5d0)
               vmm(n1,n2,ms)=vmm(n1,n2,ms)+J*(density(ms)  -0.5d0)
            end if
            pdftu1 = pdftu1 + vmm(n1,n2,ms)*l_density(n1,n2,ms)
         end do
         end do
         edftu1 = edftu1 + 0.5d0*J*density(ms)*(density(ms)-1.0d0)
      end do
      edftu1 = edftu1 - 0.5d0*U*density_total*(density_total-1.0d0)

      if (ispin.eq.1) then
         edftu1 = edftu1 + edftu1
         pdftu1 = pdftu1 + pdftu1
      end if
      edftu = edftu + edftu1
      pdftu = pdftu + pdftu1


      return 
      end 
      

*     ****************************************************
*     *                                                  *
*     *                psputerm_gen_l_density            *
*     *                                                  *
*     ****************************************************
      subroutine psputerm_gen_l_density(ispin,ne,nprj,l_prj,m_prj,sw2,
     >                                  l,lm,l_density)
      implicit none
      integer ispin,ne(2),nprj
      integer l_prj(nprj),m_prj(nprj)
      real*8  sw2(ne(1)+ne(2),nprj)
      integer l,lm
      real*8  l_density(lm,lm,ispin)

*     **** local variables ****
      real*8  omega,trace
      integer a,b,c,s,k,ma,mb,ms,n,n1(2),n2(2)

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega

      omega = lattice_omega()
      n1(1) = 1
      n1(2) = ne(1)+1
      n2(1) = ne(1)
      n2(2) = ne(1)+ne(2)

      call dcopy(lm*lm*ispin,0.0d0,0,l_density,1)
      do a=1,nprj
      do b=1,nprj
      if ((l_prj(a).eq.l).and.(l_prj(b).eq.l)) then
         mb = m_prj(b)+l+1
         ma = m_prj(a)+l+1
         do ms=1,ispin
         do n=n1(ms),n2(ms)
            l_density(ma,mb,ms) = l_density(ma,mb,ms)
     >                          + sw2(n,a)*sw2(n,b)/omega
         end do
         end do
      end if
      end do
      end do
      call D1dB_Vector_SumAll(lm*lm*ispin,l_density)

      return
      end 

*     ****************************************************
*     *                                                  *
*     *                psputerm_add_upotential           *
*     *                                                  *
*     ****************************************************
      subroutine psputerm_add_upotential(ispin,ne,nprj,l_prj,m_prj,
     >                                   l,lm,vmm,sw2,sw3)
      implicit none
      integer ispin,ne(2),nprj
      integer l_prj(nprj),m_prj(nprj)
      integer l,lm
      real*8  vmm(lm,lm,ispin)
      real*8  sw2(ne(1)+ne(2),nprj)
      real*8  sw3(ne(1)+ne(2),nprj)

*     **** local variables ****
      integer a,b,ms,i,ma,mb,n1(2),n2(2)
      real*8 omega

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega
  
      omega = lattice_omega()
      n1(1) = 1
      n1(2) = ne(1)+1
      n2(1) = ne(1)
      n2(2) = ne(1)+ne(2)

      do ms =1,ispin
      do i=n1(ms),n2(ms)
         do a=1,nprj
         do b=1,nprj
            if ((l_prj(a).eq.l).and.(l_prj(b).eq.l)) then
               mb = m_prj(b)+l+1
               ma = m_prj(a)+l+1
               sw3(i,a) = sw3(i,a)
     >                  - sw2(i,b)*vmm(ma,mb,ms)
            end if
         end do
         end do
      end do
      end do

      return 
      end

*     ****************************************************
*     *                                                  *
*     *                psp_U_psputerm_energy             *
*     *                                                  *
*     ****************************************************
      subroutine psp_U_psputerm_energy(edftu,pdftu)
      implicit none
      real*8 edftu,pdftu

#include "psp.fh"
      
      edftu = psputerm_edftu
      pdftu = psputerm_pdftu
      return
      end 

      subroutine tce_diis_init
c
c $Id: tce_diis_init.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Initializes file handle holders
c
      implicit none
#include "tce_diis.fh"
      integer i
c
      t1_pointer = 0
      t2_pointer = 0
      t3_pointer = 0
      t4_pointer = 0
      r1_pointer = 0
      r2_pointer = 0
      r3_pointer = 0
      r4_pointer = 0
      do i = 1,maxdiis
        t1_diis_exist(i) = .false.
        r1_diis_exist(i) = .false.
        t2_diis_exist(i) = .false.
        r2_diis_exist(i) = .false.
        t3_diis_exist(i) = .false.
        r3_diis_exist(i) = .false.
        t4_diis_exist(i) = .false.
        r4_diis_exist(i) = .false.
      enddo
      return
      end

      SUBROUTINE ccsdt_lr_alpha2(d_f1,d_i0,d_t1,d_t2,d_t3,d_tra1,d_tra2,
     &d_tra3,d_trb1,d_trb2,d_trb3,d_v2,d_y1,d_y2,d_y3,k_f1_offset,k_i0_o
     &ffset,k_t1_offset,k_t2_offset,k_t3_offset,k_tra1_offset,k_tra2_off
     &set,k_tra3_offset,k_trb1_offset,k_trb2_offset,k_trb3_offset,k_v2_o
     &ffset,k_y1_offset,k_y2_offset,k_y3_offset)
C     $Id: ccsdt_lr_alpha2.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_vtrbtra + = 1/2 * Sum ( h2 p1 ) * tra ( p1 h2 )_tra * i1 ( h2 p1 )_vtrb
C         i1 ( h2 p1 )_vtrb + = 1 * Sum ( h4 p3 ) * trb ( p3 h4 )_trb * v ( h2 h4 p1 p3 )_v
C     i0 ( )_ytrbtraf + = -1 * Sum ( p10 h9 ) * i1 ( p10 h9 )_ytrbtra * f ( h9 p10 )_f
C         i1 ( p10 h9 )_ytrbtra + = 1 * Sum ( h2 ) * tra ( p10 h2 )_tra * i2 ( h2 h9 )_ytrb
C             i2 ( h2 h9 )_ytrb + = 1 * Sum ( p3 ) * trb ( p3 h9 )_trb * y ( h2 p3 )_y
C             i2 ( h2 h9 )_ytrb + = -1/2 * Sum ( h5 p3 p4 ) * trb ( p3 p4 h5 h9 )_trb * y ( h2 h5 p3 p4 )_y
C             i2 ( h2 h9 )_ytrb + = 1/12 * Sum ( h6 h7 p3 p4 p5 ) * trb ( p3 p4 p5 h6 h7 h9 )_trb * y ( h2 h6 h7 p3 p4 p5 )_y
C         i1 ( p10 h9 )_ytratrb + = -1/2 * Sum ( h8 ) * trb ( p10 h8 )_trb * i2 ( h8 h9 )_ytra
C             i2 ( h8 h9 )_ytra + = -1 * Sum ( h5 p3 p4 ) * tra ( p3 p4 h5 h9 )_tra * y ( h5 h8 p3 p4 )_y
C             i2 ( h8 h9 )_ytra + = -1/6 * Sum ( h6 h7 p3 p4 p5 ) * tra ( p3 p4 p5 h6 h7 h9 )_tra * y ( h6 h7 h8 p3 p4 p5 )_y
C             i2 ( h8 h9 )_ytra + = -2 * Sum ( p3 ) * tra ( p3 h9 )_tra * y ( h8 p3 )_y
C         i1 ( p10 h9 )_ytrbtra + = -1/2 * Sum ( h1 h3 p2 ) * tra ( p2 p10 h1 h3 )_tra * i2 ( h1 h3 h9 p2 )_ytrb
C             i2 ( h1 h3 h9 p2 )_ytrb + = -1 * Sum ( p6 ) * trb ( p6 h9 )_trb * y ( h1 h3 p2 p6 )_y
C             i2 ( h1 h3 h9 p2 )_ytrb + = 1/2 * Sum ( h7 p5 p6 ) * trb ( p5 p6 h7 h9 )_trb * y ( h1 h3 h7 p2 p5 p6 )_y
C         i1 ( p10 h9 )_ytrbtra + = 1/12 * Sum ( h5 h6 h7 p3 p4 ) * tra ( p3 p4 p10 h5 h6 h7 )_tra * i2 ( h5 h6 h7 h9 p3 p4 )_ytrb
C             i2 ( h5 h6 h7 h9 p3 p4 )_ytrb + = 1 * Sum ( p8 ) * trb ( p8 h9 )_trb * y ( h5 h6 h7 p3 p4 p8 )_y
C         i1 ( p10 h9 )_ytratrb + = -1/2 * Sum ( h1 h3 p2 ) * trb ( p2 p10 h1 h3 )_trb * i2 ( h1 h3 h9 p2 )_ytra
C             i2 ( h1 h3 h9 p2 )_ytra + = -1 * Sum ( p6 ) * tra ( p6 h9 )_tra * y ( h1 h3 p2 p6 )_y
C             i2 ( h1 h3 h9 p2 )_ytra + = 1/2 * Sum ( h7 p5 p6 ) * tra ( p5 p6 h7 h9 )_tra * y ( h1 h3 h7 p2 p5 p6 )_y
C         i1 ( p10 h9 )_ytratrb + = 1/12 * Sum ( h5 h6 h7 p3 p4 ) * trb ( p3 p4 p10 h5 h6 h7 )_trb * i2 ( h5 h6 h7 h9 p3 p4 )_ytra
C             i2 ( h5 h6 h7 h9 p3 p4 )_ytra + = 1 * Sum ( p8 ) * tra ( p8 h9 )_tra * y ( h5 h6 h7 p3 p4 p8 )_y
C     i0 ( )_vtrbtray + = 1 * Sum ( p9 h7 ) * y ( h7 p9 )_y * i1 ( p9 h7 )_vtrbtra
C         i1 ( p9 h7 )_vtrbtra + = 1 * Sum ( h10 ) * tra ( p9 h10 )_tra * i2 ( h10 h7 )_vtrb
C             i2 ( h10 h7 )_vtrb + = 1 * Sum ( h4 p3 ) * trb ( p3 h4 )_trb * v ( h4 h10 h7 p3 )_v
C             i2 ( h10 h7 )_vtrb + = -1/2 * Sum ( h4 p1 p2 ) * trb ( p1 p2 h4 h7 )_trb * v ( h4 h10 p1 p2 )_v
C             i2 ( h10 h7 )_vtrbt + = -1 * Sum ( p1 ) * t ( p1 h7 )_t * i3 ( h10 p1 )_vtrb
C                 i3 ( h10 p1 )_vtrb + = -1 * Sum ( h6 p5 ) * trb ( p5 h6 )_trb * v ( h6 h10 p1 p5 )_v
C             i2 ( h10 h7 )_vttrb + = -1 * Sum ( p1 ) * trb ( p1 h7 )_trb * i3 ( h10 p1 )_vt
C                 i3 ( h10 p1 )_vt + = -1 * Sum ( h6 p5 ) * t ( p5 h6 )_t * v ( h6 h10 p1 p5 )_v
C         i1 ( p9 h7 )_vtrbtra + = 1 * Sum ( p1 ) * tra ( p1 h7 )_tra * i2 ( p9 p1 )_vtrb
C             i2 ( p9 p1 )_vtrb + = -1 * Sum ( h4 p3 ) * trb ( p3 h4 )_trb * v ( h4 p9 p1 p3 )_v
C         i1 ( p9 h7 )_vtrbtra + = 1/2 * Sum ( h3 h4 p2 ) * tra ( p2 p9 h3 h4 )_tra * i2 ( h3 h4 h7 p2 )_vtrb
C             i2 ( h3 h4 h7 p2 )_vtrb + = -1 * Sum ( p5 ) * trb ( p5 h7 )_trb * v ( h3 h4 p2 p5 )_v
C         i1 ( p9 h7 )_vtratrb + = -1/2 * Sum ( h10 ) * trb ( p9 h10 )_trb * i2 ( h10 h7 )_vtra
C             i2 ( h10 h7 )_vtra + = 1 * Sum ( h4 p1 p2 ) * tra ( p1 p2 h4 h7 )_tra * v ( h4 h10 p1 p2 )_v
C             i2 ( h10 h7 )_vtra + = -2 * Sum ( h4 p3 ) * tra ( p3 h4 )_tra * v ( h4 h10 h7 p3 )_v
C             i2 ( h10 h7 )_vttra + = 2 * Sum ( p1 ) * tra ( p1 h7 )_tra * i3 ( h10 p1 )_vt
C             i2 ( h10 h7 )_vtrat + = 2 * Sum ( p1 ) * t ( p1 h7 )_t * i3 ( h10 p1 )_vtra
C                 i3 ( h10 p1 )_vtra + = -1 * Sum ( h6 p5 ) * tra ( p5 h6 )_tra * v ( h6 h10 p1 p5 )_v
C         i1 ( p9 h7 )_vtrbtra + = 1 * Sum ( h4 p2 ) * tra ( p2 p9 h4 h7 )_tra * i2 ( h4 p2 )_vtrb
C             i2 ( h4 p2 )_vtrb + = 1 * Sum ( h6 p5 ) * trb ( p5 h6 )_trb * v ( h4 h6 p2 p5 )_v
C         i1 ( p9 h7 )_vtratrb + = 1 * Sum ( p1 ) * trb ( p1 h7 )_trb * i2 ( p9 p1 )_vtra
C             i2 ( p9 p1 )_vtra + = -1 * Sum ( h4 p3 ) * tra ( p3 h4 )_tra * v ( h4 p9 p1 p3 )_v
C         i1 ( p9 h7 )_vtratrb + = 1/2 * Sum ( h3 h4 p2 ) * trb ( p2 p9 h3 h4 )_trb * i2 ( h3 h4 h7 p2 )_vtra
C             i2 ( h3 h4 h7 p2 )_vtra + = -1 * Sum ( p5 ) * tra ( p5 h7 )_tra * v ( h3 h4 p2 p5 )_v
C         i1 ( p9 h7 )_vtratrb + = 1 * Sum ( h4 p2 ) * trb ( p2 p9 h4 h7 )_trb * i2 ( h4 p2 )_vtra
C             i2 ( h4 p2 )_vtra + = 1 * Sum ( h6 p5 ) * tra ( p5 h6 )_tra * v ( h4 h6 p2 p5 )_v
C         i1 ( p9 h7 )_vtratrbt + = -1 * Sum ( h4 ) * t ( p9 h4 )_t * i2 ( h4 h7 )_vtratrb
C             i2 ( h4 h7 )_vtratrb + = 1 * Sum ( p1 ) * trb ( p1 h7 )_trb * i3 ( h4 p1 )_vtra
C                 i3 ( h4 p1 )_vtra + = 1 * Sum ( h6 p5 ) * tra ( p5 h6 )_tra * v ( h4 h6 p1 p5 )_v
C             i2 ( h4 h7 )_vtrbtra + = 1 * Sum ( p1 ) * tra ( p1 h7 )_tra * i3 ( h4 p1 )_vtrb
C                 i3 ( h4 p1 )_vtrb + = 1 * Sum ( h6 p5 ) * trb ( p5 h6 )_trb * v ( h4 h6 p1 p5 )_v
C     i0 ( )_ytrbtrav + = -1/4 * Sum ( h6 h7 h11 h12 ) * i1 ( h6 h7 h11 h12 )_ytrbtra * v ( h11 h12 h6 h7 )_v
C         i1 ( h6 h7 h11 h12 )_ytrbtra + = 1 * Sum ( p1 ) * tra ( p1 h11 )_tra * i2 ( h6 h7 h12 p1 )_ytrb
C             i2 ( h6 h7 h12 p1 )_ytrb + = -1 * Sum ( p3 ) * trb ( p3 h12 )_trb * y ( h6 h7 p1 p3 )_y
C         i1 ( h6 h7 h11 h12 )_ytratrb + = -1 * Sum ( p5 ) * trb ( p5 h12 )_trb * i2 ( h6 h7 h11 p5 )_ytra
C             i2 ( h6 h7 h11 p5 )_ytra + = 1 * Sum ( h3 p1 p2 ) * tra ( p1 p2 h3 h11 )_tra * y ( h3 h6 h7 p1 p2 p5 )_y
C         i1 ( h6 h7 h11 h12 )_ytratrb + = 1 * Sum ( p1 ) * trb ( p1 h11 )_trb * i2 ( h6 h7 h12 p1 )_ytra
C             i2 ( h6 h7 h12 p1 )_ytra + = -1 * Sum ( p3 ) * tra ( p3 h12 )_tra * y ( h6 h7 p1 p3 )_y
C         i1 ( h6 h7 h11 h12 )_ytrbtra + = -1 * Sum ( p5 ) * tra ( p5 h12 )_tra * i2 ( h6 h7 h11 p5 )_ytrb
C             i2 ( h6 h7 h11 p5 )_ytrb + = 1 * Sum ( h3 p1 p2 ) * trb ( p1 p2 h3 h11 )_trb * y ( h3 h6 h7 p1 p2 p5 )_y
C     i0 ( )_ytrbtrav + = 1 * Sum ( h11 p7 h9 p10 ) * i1 ( h11 p7 h9 p10 )_ytrbtra * v ( h9 p10 h11 p7 )_v
C         i1 ( h11 p7 h9 p10 )_ytrbtra + = 1 * Sum ( h4 ) * tra ( p7 h4 )_tra * i2 ( h4 h11 h9 p10 )_ytrb
C             i2 ( h4 h11 h9 p10 )_ytrb + = 1 * Sum ( p3 ) * trb ( p3 h9 )_trb * y ( h4 h11 p3 p10 )_y
C             i2 ( h4 h11 h9 p10 )_ytrb + = 1/2 * Sum ( h3 p1 p2 ) * trb ( p1 p2 h3 h9 )_trb * y ( h3 h4 h11 p1 p2 p10 )_y
C         i1 ( h11 p7 h9 p10 )_ytratrb + = -1/2 * Sum ( h4 ) * trb ( p7 h4 )_trb * i2 ( h4 h11 h9 p10 )_ytra
C             i2 ( h4 h11 h9 p10 )_ytra + = -1 * Sum ( h3 p1 p2 ) * tra ( p1 p2 h3 h9 )_tra * y ( h3 h4 h11 p1 p2 p10 )_y
C             i2 ( h4 h11 h9 p10 )_ytra + = -2 * Sum ( p3 ) * tra ( p3 h9 )_tra * y ( h4 h11 p3 p10 )_y
C         i1 ( h11 p7 h9 p10 )_ytrbtra + = -1/2 * Sum ( h3 h4 p1 ) * tra ( p1 p7 h3 h4 )_tra * i2 ( h3 h4 h11 h9 p1 p10 )_ytrb
C             i2 ( h3 h4 h11 h9 p1 p10 )_ytrb + = -1 * Sum ( p5 ) * trb ( p5 h9 )_trb * y ( h3 h4 h11 p1 p5 p10 )_y
C         i1 ( h11 p7 h9 p10 )_ytratrb + = -1/2 * Sum ( h3 h4 p1 ) * trb ( p1 p7 h3 h4 )_trb * i2 ( h3 h4 h11 h9 p1 p10 )_ytra
C             i2 ( h3 h4 h11 h9 p1 p10 )_ytra + = -1 * Sum ( p5 ) * tra ( p5 h9 )_tra * y ( h3 h4 h11 p1 p5 p10 )_y
C     i0 ( )_vtrbtray + = 1/4 * Sum ( p10 p11 h13 h9 ) * y ( h9 h13 p10 p11 )_y * i1 ( p10 p11 h9 h13 )_vtrbtra
C         i1 ( p10 p11 h9 h13 )_vtrbtra + = 1 * Sum ( p1 ) * tra ( p1 h13 )_tra * i2 ( p10 p11 h9 p1 )_vtrb
C             i2 ( p10 p11 h9 p1 )_vtrb + = -1 * Sum ( p3 ) * trb ( p3 h9 )_trb * v ( p10 p11 p1 p3 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtra + = 4 * Sum ( h4 p2 ) * tra ( p2 p10 h4 h13 )_tra * i2 ( h4 p11 h9 p2 )_vtrb
C             i2 ( h4 p11 h9 p2 )_vtrb + = -1 * Sum ( p5 ) * trb ( p5 h9 )_trb * v ( h4 p11 p2 p5 )_v
C             i2 ( h4 p11 h9 p2 )_vtrb + = -1/2 * Sum ( h8 p6 ) * trb ( p6 p11 h8 h9 )_trb * v ( h4 h8 p2 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtratrb + = 1 * Sum ( h7 ) * trb ( p10 h7 )_trb * i2 ( h7 p11 h9 h13 )_vtra
C             i2 ( h7 p11 h9 h13 )_vtra + = -1 * Sum ( p1 p2 ) * tra ( p1 p2 h9 h13 )_tra * v ( h7 p11 p1 p2 )_v
C             i2 ( h7 p11 h9 h13 )_vtrat + = -2 * Sum ( p1 ) * t ( p1 h13 )_t * i3 ( h7 p11 h9 p1 )_vtra
C                 i3 ( h7 p11 h9 p1 )_vtra + = -1 * Sum ( p3 ) * tra ( p3 h9 )_tra * v ( h7 p11 p1 p3 )_v
C             i2 ( h7 p11 h9 h13 )_vtrat + = 1/2 * Sum ( h4 ) * t ( p11 h4 )_t * i3 ( h4 h7 h9 h13 )_vtra
C                 i3 ( h4 h7 h9 h13 )_vtra + = -1 * Sum ( p5 p6 ) * tra ( p5 p6 h9 h13 )_tra * v ( h4 h7 p5 p6 )_v
C             i2 ( h7 p11 h9 h13 )_vttra + = 2 * Sum ( p6 ) * tra ( p6 p11 h9 h13 )_tra * i3 ( h7 p6 )_vt
C                 i3 ( h7 p6 )_vt + = -1 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 h7 p3 p6 )_v
C             i2 ( h7 p11 h9 h13 )_vttra + = -2 * Sum ( p1 ) * tra ( p1 h13 )_tra * i3 ( h7 p11 h9 p1 )_vt
C                 i3 ( h7 p11 h9 p1 )_vt + = -1 * Sum ( p3 ) * t ( p3 h9 )_t * v ( h7 p11 p1 p3 )_v
C             i2 ( h7 p11 h9 h13 )_vttra + = 1/2 * Sum ( h4 ) * tra ( p11 h4 )_tra * i3 ( h4 h7 h9 h13 )_vt
C                 i3 ( h4 h7 h9 h13 )_vt + = -1 * Sum ( p5 p6 ) * t ( p5 p6 h9 h13 )_t * v ( h4 h7 p5 p6 )_v
C             i2 ( h7 p11 h9 h13 )_vtrat + = 2 * Sum ( p6 ) * t ( p6 p11 h9 h13 )_t * i3 ( h7 p6 )_vtra
C                 i3 ( h7 p6 )_vtra + = -1 * Sum ( h4 p3 ) * tra ( p3 h4 )_tra * v ( h4 h7 p3 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtra + = -2 * Sum ( p2 ) * tra ( p2 p10 h9 h13 )_tra * i2 ( p11 p2 )_vtrb
C             i2 ( p11 p2 )_vtrb + = -1 * Sum ( h6 p5 ) * trb ( p5 h6 )_trb * v ( h6 p11 p2 p5 )_v
C             i2 ( p11 p2 )_vtrb + = 1/2 * Sum ( h7 h8 p6 ) * trb ( p6 p11 h7 h8 )_trb * v ( h7 h8 p2 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtra + = 1 * Sum ( h5 h6 p3 ) * tra ( p3 p10 p11 h5 h6 h13 )_tra * i2 ( h5 h6 h9 p3 )_vtrb
C             i2 ( h5 h6 h9 p3 )_vtrb + = -1 * Sum ( p7 ) * trb ( p7 h9 )_trb * v ( h5 h6 p3 p7 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtra + = 1 * Sum ( h6 p3 ) * tra ( p3 p10 p11 h6 h9 h13 )_tra * i2 ( h6 p3 )_vtrb
C             i2 ( h6 p3 )_vtrb + = 1 * Sum ( h8 p7 ) * trb ( p7 h8 )_trb * v ( h6 h8 p3 p7 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtra + = 1 * Sum ( h4 ) * tra ( p10 p11 h4 h13 )_tra * i2 ( h4 h9 )_vtrb
C             i2 ( h4 h9 )_vtrb + = 1 * Sum ( h8 p5 p6 ) * trb ( p5 p6 h8 h9 )_trb * v ( h4 h8 p5 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtratrb + = 1 * Sum ( p1 ) * trb ( p1 h13 )_trb * i2 ( p10 p11 h9 p1 )_vtra
C             i2 ( p10 p11 h9 p1 )_vtra + = -1 * Sum ( p3 ) * tra ( p3 h9 )_tra * v ( p10 p11 p1 p3 )_v
C         i1 ( p10 p11 h9 h13 )_vtratrb + = 4 * Sum ( h4 p2 ) * trb ( p2 p10 h4 h13 )_trb * i2 ( h4 p11 h9 p2 )_vtra
C             i2 ( h4 p11 h9 p2 )_vtra + = -1 * Sum ( p5 ) * tra ( p5 h9 )_tra * v ( h4 p11 p2 p5 )_v
C             i2 ( h4 p11 h9 p2 )_vtra + = -1/2 * Sum ( h8 p6 ) * tra ( p6 p11 h8 h9 )_tra * v ( h4 h8 p2 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtra + = 1 * Sum ( h7 ) * tra ( p10 h7 )_tra * i2 ( h7 p11 h9 h13 )_vtrb
C             i2 ( h7 p11 h9 h13 )_vtrb + = -1 * Sum ( p1 p2 ) * trb ( p1 p2 h9 h13 )_trb * v ( h7 p11 p1 p2 )_v
C             i2 ( h7 p11 h9 h13 )_vttrb + = 1/2 * Sum ( h4 ) * trb ( p11 h4 )_trb * i3 ( h4 h7 h9 h13 )_vt
C             i2 ( h7 p11 h9 h13 )_vtrbt + = 2 * Sum ( p6 ) * t ( p6 p11 h9 h13 )_t * i3 ( h7 p6 )_vtrb
C                 i3 ( h7 p6 )_vtrb + = -1 * Sum ( h4 p3 ) * trb ( p3 h4 )_trb * v ( h4 h7 p3 p6 )_v
C             i2 ( h7 p11 h9 h13 )_vttrb + = -2 * Sum ( p1 ) * trb ( p1 h13 )_trb * i3 ( h7 p11 h9 p1 )_vt
C             i2 ( h7 p11 h9 h13 )_vtrbt + = 1/2 * Sum ( h4 ) * t ( p11 h4 )_t * i3 ( h4 h7 h9 h13 )_vtrb
C                 i3 ( h4 h7 h9 h13 )_vtrb + = -1 * Sum ( p5 p6 ) * trb ( p5 p6 h9 h13 )_trb * v ( h4 h7 p5 p6 )_v
C             i2 ( h7 p11 h9 h13 )_vttrb + = 2 * Sum ( p6 ) * trb ( p6 p11 h9 h13 )_trb * i3 ( h7 p6 )_vt
C             i2 ( h7 p11 h9 h13 )_vtrbt + = -2 * Sum ( p1 ) * t ( p1 h13 )_t * i3 ( h7 p11 h9 p1 )_vtrb
C                 i3 ( h7 p11 h9 p1 )_vtrb + = -1 * Sum ( p3 ) * trb ( p3 h9 )_trb * v ( h7 p11 p1 p3 )_v
C         i1 ( p10 p11 h9 h13 )_vtratrb + = -2 * Sum ( p2 ) * trb ( p2 p10 h9 h13 )_trb * i2 ( p11 p2 )_vtra
C             i2 ( p11 p2 )_vtra + = -1 * Sum ( h6 p5 ) * tra ( p5 h6 )_tra * v ( h6 p11 p2 p5 )_v
C             i2 ( p11 p2 )_vtra + = 1/2 * Sum ( h7 h8 p6 ) * tra ( p6 p11 h7 h8 )_tra * v ( h7 h8 p2 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtratrb + = 1 * Sum ( h5 h6 p3 ) * trb ( p3 p10 p11 h5 h6 h13 )_trb * i2 ( h5 h6 h9 p3 )_vtra
C             i2 ( h5 h6 h9 p3 )_vtra + = -1 * Sum ( p7 ) * tra ( p7 h9 )_tra * v ( h5 h6 p3 p7 )_v
C         i1 ( p10 p11 h9 h13 )_vtratrb + = 1 * Sum ( h6 p3 ) * trb ( p3 p10 p11 h6 h9 h13 )_trb * i2 ( h6 p3 )_vtra
C             i2 ( h6 p3 )_vtra + = 1 * Sum ( h8 p7 ) * tra ( p7 h8 )_tra * v ( h6 h8 p3 p7 )_v
C         i1 ( p10 p11 h9 h13 )_vtratrb + = 1 * Sum ( h4 ) * trb ( p10 p11 h4 h13 )_trb * i2 ( h4 h9 )_vtra
C             i2 ( h4 h9 )_vtra + = 1 * Sum ( h8 p5 p6 ) * tra ( p5 p6 h8 h9 )_tra * v ( h4 h8 p5 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtrat + = -2 * Sum ( h2 ) * t ( p10 h2 )_t * i2 ( h2 p11 h9 h13 )_vtrbtra
C             i2 ( h2 p11 h9 h13 )_vtrbtra + = 1 * Sum ( p1 ) * tra ( p1 h13 )_tra * i3 ( h2 p11 h9 p1 )_vtrb
C                 i3 ( h2 p11 h9 p1 )_vtrb + = -1 * Sum ( p3 ) * trb ( p3 h9 )_trb * v ( h2 p11 p1 p3 )_v
C             i2 ( h2 p11 h9 h13 )_vtrbtra + = -1/4 * Sum ( h4 ) * tra ( p11 h4 )_tra * i3 ( h2 h4 h9 h13 )_vtrb
C                 i3 ( h2 h4 h9 h13 )_vtrb + = 1 * Sum ( p5 p6 ) * trb ( p5 p6 h9 h13 )_trb * v ( h2 h4 p5 p6 )_v
C             i2 ( h2 p11 h9 h13 )_vtratrb + = -1 * Sum ( p6 ) * trb ( p6 p11 h9 h13 )_trb * i3 ( h2 p6 )_vtra
C                 i3 ( h2 p6 )_vtra + = 1 * Sum ( h4 p3 ) * tra ( p3 h4 )_tra * v ( h2 h4 p3 p6 )_v
C             i2 ( h2 p11 h9 h13 )_vtratrb + = 1 * Sum ( p1 ) * trb ( p1 h13 )_trb * i3 ( h2 p11 h9 p1 )_vtra
C                 i3 ( h2 p11 h9 p1 )_vtra + = -1 * Sum ( p3 ) * tra ( p3 h9 )_tra * v ( h2 p11 p1 p3 )_v
C             i2 ( h2 p11 h9 h13 )_vtratrb + = -1/4 * Sum ( h4 ) * trb ( p11 h4 )_trb * i3 ( h2 h4 h9 h13 )_vtra
C                 i3 ( h2 h4 h9 h13 )_vtra + = 1 * Sum ( p5 p6 ) * tra ( p5 p6 h9 h13 )_tra * v ( h2 h4 p5 p6 )_v
C             i2 ( h2 p11 h9 h13 )_vtrbtra + = -1 * Sum ( p6 ) * tra ( p6 p11 h9 h13 )_tra * i3 ( h2 p6 )_vtrb
C                 i3 ( h2 p6 )_vtrb + = 1 * Sum ( h4 p3 ) * trb ( p3 h4 )_trb * v ( h2 h4 p3 p6 )_v
C         i1 ( p10 p11 h9 h13 )_vtrbtrat + = -2 * Sum ( h8 ) * t ( p10 p11 h8 h9 )_t * i2 ( h8 h13 )_vtrbtra
C             i2 ( h8 h13 )_vtrbtra + = 1 * Sum ( p1 ) * tra ( p1 h13 )_tra * i3 ( h8 p1 )_vtrb
C                 i3 ( h8 p1 )_vtrb + = 1 * Sum ( h4 p3 ) * trb ( p3 h4 )_trb * v ( h4 h8 p1 p3 )_v
C             i2 ( h8 h13 )_vtratrb + = 1 * Sum ( p1 ) * trb ( p1 h13 )_trb * i3 ( h8 p1 )_vtra
C                 i3 ( h8 p1 )_vtra + = 1 * Sum ( h4 p3 ) * tra ( p3 h4 )_tra * v ( h4 h8 p1 p3 )_v
C         i1 ( p10 p11 h9 h13 )_vtrattrb + = -2 * Sum ( h8 ) * trb ( p10 p11 h8 h9 )_trb * i2 ( h8 h13 )_vtrat
C             i2 ( h8 h13 )_vtrat + = 1 * Sum ( p1 ) * t ( p1 h13 )_t * i3 ( h8 p1 )_vtra
C             i2 ( h8 h13 )_vttra + = 1 * Sum ( p1 ) * tra ( p1 h13 )_tra * i3 ( h8 p1 )_vt
C                 i3 ( h8 p1 )_vt + = 1 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 h8 p1 p3 )_v
C         i1 ( p10 p11 h9 h13 )_vttrbtra + = -2 * Sum ( h8 ) * tra ( p10 p11 h8 h9 )_tra * i2 ( h8 h13 )_vttrb
C             i2 ( h8 h13 )_vttrb + = 1 * Sum ( p1 ) * trb ( p1 h13 )_trb * i3 ( h8 p1 )_vt
C             i2 ( h8 h13 )_vtrbt + = 1 * Sum ( p1 ) * t ( p1 h13 )_t * i3 ( h8 p1 )_vtrb
C     i0 ( )_ytratrbv + = 1/4 * Sum ( h13 p10 h11 h12 ) * i1 ( h13 p10 h11 h12 )_ytratrb * v ( h11 h12 h13 p10 )_v
C         i1 ( h13 p10 h11 h12 )_ytratrb + = 1 * Sum ( h8 ) * trb ( p10 h8 )_trb * i2 ( h8 h13 h11 h12 )_ytra
C             i2 ( h8 h13 h11 h12 )_ytra + = -1 * Sum ( p1 p2 ) * tra ( p1 p2 h11 h12 )_tra * y ( h8 h13 p1 p2 )_y
C             i2 ( h8 h13 h11 h12 )_ytra + = -1/3 * Sum ( h4 p1 p2 p3 ) * tra ( p1 p2 p3 h4 h11 h12 )_tra * y ( h4 h8 h13 p1 p2 p3 )_y
C             i2 ( h8 h13 h11 h12 )_ytrat + = -2 * Sum ( p3 ) * t ( p3 h11 )_t * i3 ( h8 h13 h12 p3 )_ytra
C                 i3 ( h8 h13 h12 p3 )_ytra + = 1 * Sum ( p5 ) * tra ( p5 h12 )_tra * y ( h8 h13 p3 p5 )_y
C                 i3 ( h8 h13 h12 p3 )_ytra + = -1 * Sum ( h7 p5 p6 ) * tra ( p5 p6 h7 h12 )_tra * y ( h7 h8 h13 p3 p5 p6 )_y
C             i2 ( h8 h13 h11 h12 )_yttra + = -2 * Sum ( p3 ) * tra ( p3 h11 )_tra * i3 ( h8 h13 h12 p3 )_yt
C                 i3 ( h8 h13 h12 p3 )_yt + = 1 * Sum ( p5 ) * t ( p5 h12 )_t * y ( h8 h13 p3 p5 )_y
C                 i3 ( h8 h13 h12 p3 )_yt + = -1 * Sum ( h7 p5 p6 ) * t ( p5 p6 h7 h12 )_t * y ( h7 h8 h13 p3 p5 p6 )_y
C         i1 ( h13 p10 h11 h12 )_ytrbtra + = 4 * Sum ( h3 p1 ) * tra ( p1 p10 h3 h11 )_tra * i2 ( h3 h13 h12 p1 )_ytrb
C             i2 ( h3 h13 h12 p1 )_ytrb + = 1 * Sum ( p5 ) * trb ( p5 h12 )_trb * y ( h3 h13 p1 p5 )_y
C         i1 ( h13 p10 h11 h12 )_ytratrb + = 2 * trb ( p10 h12 )_trb * i2 ( h13 h11 )_ytra
C             i2 ( h13 h11 )_ytra + = -1 * Sum ( h3 p1 p2 ) * tra ( p1 p2 h3 h11 )_tra * y ( h3 h13 p1 p2 )_y
C             i2 ( h13 h11 )_ytra + = -1/6 * Sum ( h4 h5 p1 p2 p3 ) * tra ( p1 p2 p3 h4 h5 h11 )_tra * y ( h4 h5 h13 p1 p2 p3 )_y
C         i1 ( h13 p10 h11 h12 )_ytratrb + = 1 * Sum ( h4 h5 p1 p2 ) * trb ( p1 p2 p10 h4 h5 h11 )_trb * i2 ( h4 h5 h13 h12 p1 p2 )_ytra
C             i2 ( h4 h5 h13 h12 p1 p2 )_ytra + = 1 * Sum ( p7 ) * tra ( p7 h12 )_tra * i3 ( h4 h5 h13 p1 p2 p7 )_y
C                 i3 ( h4 h5 h13 p1 p2 p7 )_y + = 1 * y ( h4 h5 h13 p1 p2 p7 )_y
C         i1 ( h13 p10 h11 h12 )_ytrbtrb + = -1/2 * Sum ( p5 p6 ) * trb ( p5 p6 h11 h12 )_trb * i2 ( h13 p10 p5 p6 )_ytrb
C             i2 ( h13 p10 p5 p6 )_ytrb + = 1 * Sum ( h3 h4 p1 ) * trb ( p1 p10 h3 h4 )_trb * y ( h3 h4 h13 p1 p5 p6 )_y
C         i1 ( h13 p10 h11 h12 )_ytratrb + = -2 * Sum ( h7 p5 ) * trb ( p5 p10 h7 h12 )_trb * i2 ( h7 h13 h11 p5 )_ytra
C             i2 ( h7 h13 h11 p5 )_ytra + = -1 * Sum ( h3 p1 p2 ) * tra ( p1 p2 h3 h11 )_tra * y ( h3 h7 h13 p1 p2 p5 )_y
C         i1 ( h13 p10 h11 h12 )_ytrbtra + = 1 * Sum ( h8 ) * tra ( p10 h8 )_tra * i2 ( h8 h13 h11 h12 )_ytrb
C             i2 ( h8 h13 h11 h12 )_ytrb + = -1 * Sum ( p1 p2 ) * trb ( p1 p2 h11 h12 )_trb * y ( h8 h13 p1 p2 )_y
C             i2 ( h8 h13 h11 h12 )_ytrb + = -1/3 * Sum ( h4 p1 p2 p3 ) * trb ( p1 p2 p3 h4 h11 h12 )_trb * y ( h4 h8 h13 p1 p2 p3 )_y
C             i2 ( h8 h13 h11 h12 )_yttrb + = -2 * Sum ( p3 ) * trb ( p3 h11 )_trb * i3 ( h8 h13 h12 p3 )_yt
C             i2 ( h8 h13 h11 h12 )_ytrbt + = -2 * Sum ( p3 ) * t ( p3 h11 )_t * i3 ( h8 h13 h12 p3 )_ytrb
C                 i3 ( h8 h13 h12 p3 )_ytrb + = 1 * Sum ( p5 ) * trb ( p5 h12 )_trb * y ( h8 h13 p3 p5 )_y
C                 i3 ( h8 h13 h12 p3 )_ytrb + = -1 * Sum ( h7 p5 p6 ) * trb ( p5 p6 h7 h12 )_trb * y ( h7 h8 h13 p3 p5 p6 )_y
C         i1 ( h13 p10 h11 h12 )_ytratrb + = 4 * Sum ( h3 p1 ) * trb ( p1 p10 h3 h11 )_trb * i2 ( h3 h13 h12 p1 )_ytra
C             i2 ( h3 h13 h12 p1 )_ytra + = 1 * Sum ( p5 ) * tra ( p5 h12 )_tra * y ( h3 h13 p1 p5 )_y
C         i1 ( h13 p10 h11 h12 )_ytrbtra + = 2 * tra ( p10 h12 )_tra * i2 ( h13 h11 )_ytrb
C             i2 ( h13 h11 )_ytrb + = -1 * Sum ( h3 p1 p2 ) * trb ( p1 p2 h3 h11 )_trb * y ( h3 h13 p1 p2 )_y
C             i2 ( h13 h11 )_ytrb + = -1/6 * Sum ( h4 h5 p1 p2 p3 ) * trb ( p1 p2 p3 h4 h5 h11 )_trb * y ( h4 h5 h13 p1 p2 p3 )_y
C         i1 ( h13 p10 h11 h12 )_ytrbtra + = -1/2 * Sum ( p5 p6 ) * tra ( p5 p6 h11 h12 )_tra * i2 ( h13 p10 p5 p6 )_ytrb
C         i1 ( h13 p10 h11 h12 )_ytrbtra + = -2 * Sum ( h7 p5 ) * tra ( p5 p10 h7 h12 )_tra * i2 ( h7 h13 h11 p5 )_ytrb
C             i2 ( h7 h13 h11 p5 )_ytrb + = -1 * Sum ( h3 p1 p2 ) * trb ( p1 p2 h3 h11 )_trb * y ( h3 h7 h13 p1 p2 p5 )_y
C         i1 ( h13 p10 h11 h12 )_ytrbttra + = 1 * Sum ( p1 ) * tra ( p1 h11 )_tra * i2 ( h13 p10 h12 p1 )_ytrbt
C             i2 ( h13 p10 h12 p1 )_ytrbt + = 1 * Sum ( h7 h8 p5 ) * t ( p5 p10 h7 h8 )_t * i3 ( h7 h8 h13 h12 p1 p5 )_ytrb
C                 i3 ( h7 h8 h13 h12 p1 p5 )_ytrb + = -1 * Sum ( p3 ) * trb ( p3 h12 )_trb * y ( h7 h8 h13 p1 p3 p5 )_y
C             i2 ( h13 p10 h12 p1 )_yttrb + = 1 * Sum ( h7 h8 p5 ) * trb ( p5 p10 h7 h8 )_trb * i3 ( h7 h8 h13 h12 p1 p5 )_yt
C                 i3 ( h7 h8 h13 h12 p1 p5 )_yt + = -1 * Sum ( p3 ) * t ( p3 h12 )_t * y ( h7 h8 h13 p1 p3 p5 )_y
C         i1 ( h13 p10 h11 h12 )_ytrbtrat + = -2 * Sum ( h2 ) * t ( p10 h2 )_t * i2 ( h2 h13 h11 h12 )_ytrbtra
C             i2 ( h2 h13 h11 h12 )_ytrbtra + = 1 * Sum ( p3 ) * tra ( p3 h11 )_tra * i3 ( h2 h13 h12 p3 )_ytrb
C                 i3 ( h2 h13 h12 p3 )_ytrb + = 1 * Sum ( p5 ) * trb ( p5 h12 )_trb * y ( h2 h13 p3 p5 )_y
C                 i3 ( h2 h13 h12 p3 )_ytrb + = 1 * Sum ( h7 p5 p6 ) * trb ( p5 p6 h7 h12 )_trb * y ( h2 h7 h13 p3 p5 p6 )_y
C             i2 ( h2 h13 h11 h12 )_ytratrb + = 1 * Sum ( p3 ) * trb ( p3 h11 )_trb * i3 ( h2 h13 h12 p3 )_ytra
C                 i3 ( h2 h13 h12 p3 )_ytra + = 1 * Sum ( p5 ) * tra ( p5 h12 )_tra * y ( h2 h13 p3 p5 )_y
C                 i3 ( h2 h13 h12 p3 )_ytra + = 1 * Sum ( h7 p5 p6 ) * tra ( p5 p6 h7 h12 )_tra * y ( h2 h7 h13 p3 p5 p6 )_y
C         i1 ( h13 p10 h11 h12 )_ytratrbt + = 1 * Sum ( p1 ) * t ( p1 h11 )_t * i2 ( h13 p10 h12 p1 )_ytratrb
C             i2 ( h13 p10 h12 p1 )_ytratrb + = 1 * Sum ( h7 h8 p5 ) * trb ( p5 p10 h7 h8 )_trb * i3 ( h7 h8 h13 h12 p1 p5 )_ytra
C                 i3 ( h7 h8 h13 h12 p1 p5 )_ytra + = -1 * Sum ( p3 ) * tra ( p3 h12 )_tra * y ( h7 h8 h13 p1 p3 p5 )_y
C             i2 ( h13 p10 h12 p1 )_ytrbtra + = 1 * Sum ( h7 h8 p5 ) * tra ( p5 p10 h7 h8 )_tra * i3 ( h7 h8 h13 h12 p1 p5 )_ytrb
C         i1 ( h13 p10 h11 h12 )_yttratrb + = 1 * Sum ( p1 ) * trb ( p1 h11 )_trb * i2 ( h13 p10 h12 p1 )_yttra
C             i2 ( h13 p10 h12 p1 )_yttra + = 1 * Sum ( h7 h8 p5 ) * tra ( p5 p10 h7 h8 )_tra * i3 ( h7 h8 h13 h12 p1 p5 )_yt
C             i2 ( h13 p10 h12 p1 )_ytrat + = 1 * Sum ( h7 h8 p5 ) * t ( p5 p10 h7 h8 )_t * i3 ( h7 h8 h13 h12 p1 p5 )_ytra
C     i0 ( )_ytratrbv + = 1/4 * Sum ( p2 p5 p7 p8 ) * i1 ( p2 p5 p7 p8 )_ytratrb * v ( p7 p8 p2 p5 )_v
C         i1 ( p2 p5 p7 p8 )_ytratrb + = 1 * Sum ( h6 ) * trb ( p5 h6 )_trb * i2 ( h6 p2 p7 p8 )_ytra
C             i2 ( h6 p2 p7 p8 )_ytra + = 1 * Sum ( h3 h4 p1 ) * tra ( p1 p2 h3 h4 )_tra * y ( h3 h4 h6 p1 p7 p8 )_y
C         i1 ( p2 p5 p7 p8 )_ytrbtra + = 1 * Sum ( h6 ) * tra ( p5 h6 )_tra * i2 ( h6 p2 p7 p8 )_ytrb
C             i2 ( h6 p2 p7 p8 )_ytrb + = 1 * Sum ( h3 h4 p1 ) * trb ( p1 p2 h3 h4 )_trb * y ( h3 h4 h6 p1 p7 p8 )_y
C     i0 ( )_ytrbtrav + = -1/4 * Sum ( p11 p12 h14 h15 ) * i1 ( p11 p12 h14 h15 )_ytrbtra * v ( h14 h15 p11 p12 )_v
C         i1 ( p11 p12 h14 h15 )_ytrbtra + = 1 * Sum ( h4 h5 p1 ) * tra ( p1 p11 p12 h4 h5 h14 )_tra * i2 ( h4 h5 h15 p1 )_ytrb
C             i2 ( h4 h5 h15 p1 )_ytrb + = -1 * Sum ( p7 ) * trb ( p7 h15 )_trb * y ( h4 h5 p1 p7 )_y
C             i2 ( h4 h5 h15 p1 )_ytrb + = 1/2 * Sum ( h9 p7 p8 ) * trb ( p7 p8 h9 h15 )_trb * y ( h4 h5 h9 p1 p7 p8 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtra + = -1/4 * Sum ( h7 h8 ) * tra ( p11 p12 h7 h8 )_tra * i2 ( h7 h8 h14 h15 )_ytrb
C             i2 ( h7 h8 h14 h15 )_ytrb + = 1 * Sum ( p5 p6 ) * trb ( p5 p6 h14 h15 )_trb * y ( h7 h8 p5 p6 )_y
C             i2 ( h7 h8 h14 h15 )_ytrb + = 1/3 * Sum ( h4 p1 p2 p3 ) * trb ( p1 p2 p3 h4 h14 h15 )_trb * y ( h4 h7 h8 p1 p2 p3 )_y
C             i2 ( h7 h8 h14 h15 )_yttrb + = 2 * Sum ( p9 ) * trb ( p9 h15 )_trb * i3 ( h7 h8 h14 p9 )_yt
C                 i3 ( h7 h8 h14 p9 )_yt + = 1 * Sum ( h3 p1 p2 ) * t ( p1 p2 h3 h14 )_t * y ( h3 h7 h8 p1 p2 p9 )_y
C             i2 ( h7 h8 h14 h15 )_ytrbt + = 2 * Sum ( p9 ) * t ( p9 h15 )_t * i3 ( h7 h8 h14 p9 )_ytrb
C                 i3 ( h7 h8 h14 p9 )_ytrb + = 1 * Sum ( h3 p1 p2 ) * trb ( p1 p2 h3 h14 )_trb * y ( h3 h7 h8 p1 p2 p9 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtra + = 1/2 * Sum ( h4 p1 p2 ) * tra ( p1 p2 p11 h4 h14 h15 )_tra * i2 ( h4 p12 p1 p2 )_ytrb
C             i2 ( h4 p12 p1 p2 )_ytrb + = 1 * Sum ( h9 h10 p7 ) * trb ( p7 p12 h9 h10 )_trb * y ( h4 h9 h10 p1 p2 p7 )_y
C         i1 ( p11 p12 h14 h15 )_ytratrb + = -1/12 * Sum ( h7 h8 ) * trb ( p11 p12 h7 h8 )_trb * i2 ( h7 h8 h14 h15 )_ytra
C             i2 ( h7 h8 h14 h15 )_ytra + = 1 * Sum ( h4 p1 p2 p3 ) * tra ( p1 p2 p3 h4 h14 h15 )_tra * y ( h4 h7 h8 p1 p2 p3 )_y
C             i2 ( h7 h8 h14 h15 )_ytra + = 3 * Sum ( p5 p6 ) * tra ( p5 p6 h14 h15 )_tra * y ( h7 h8 p5 p6 )_y
C             i2 ( h7 h8 h14 h15 )_ytrat + = 6 * Sum ( p9 ) * t ( p9 h15 )_t * i3 ( h7 h8 h14 p9 )_ytra
C                 i3 ( h7 h8 h14 p9 )_ytra + = 1 * Sum ( h3 p1 p2 ) * tra ( p1 p2 h3 h14 )_tra * y ( h3 h7 h8 p1 p2 p9 )_y
C             i2 ( h7 h8 h14 h15 )_yttra + = 6 * Sum ( p9 ) * tra ( p9 h15 )_tra * i3 ( h7 h8 h14 p9 )_yt
C         i1 ( p11 p12 h14 h15 )_ytratrb + = -1 * Sum ( h9 p7 ) * trb ( p7 p12 h9 h15 )_trb * i2 ( h9 p11 h14 p7 )_ytra
C             i2 ( h9 p11 h14 p7 )_ytra + = 1 * Sum ( h4 h5 p1 p2 ) * tra ( p1 p2 p11 h4 h5 h14 )_tra * y ( h4 h5 h9 p1 p2 p7 )_y
C         i1 ( p11 p12 h14 h15 )_ytratrb + = 1/6 * Sum ( h9 ) * trb ( p11 p12 h9 h15 )_trb * i2 ( h9 h14 )_ytra
C             i2 ( h9 h14 )_ytra + = 1 * Sum ( h4 h5 p1 p2 p3 ) * tra ( p1 p2 p3 h4 h5 h14 )_tra * y ( h4 h5 h9 p1 p2 p3 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtra + = 1/12 * Sum ( h2 h13 h4 p6 ) * tra ( p6 p11 p12 h2 h4 h13 )_tra * i2 ( h2 h4 h13 h14 h15 p6 )_ytrb
C             i2 ( h2 h4 h13 h14 h15 p6 )_ytrb + = -1 * Sum ( p7 p8 ) * trb ( p7 p8 h14 h15 )_trb * y ( h2 h4 h13 p6 p7 p8 )_y
C             i2 ( h2 h4 h13 h14 h15 p6 )_yttrb + = -2 * Sum ( p1 ) * trb ( p1 h14 )_trb * i3 ( h2 h4 h13 h15 p1 p6 )_yt
C                 i3 ( h2 h4 h13 h15 p1 p6 )_yt + = 1 * Sum ( p3 ) * t ( p3 h15 )_t * y ( h2 h4 h13 p1 p3 p6 )_y
C             i2 ( h2 h4 h13 h14 h15 p6 )_ytrbt + = -2 * Sum ( p1 ) * t ( p1 h14 )_t * i3 ( h2 h4 h13 h15 p1 p6 )_ytrb
C                 i3 ( h2 h4 h13 h15 p1 p6 )_ytrb + = 1 * Sum ( p3 ) * trb ( p3 h15 )_trb * y ( h2 h4 h13 p1 p3 p6 )_y
C         i1 ( p11 p12 h14 h15 )_ytratrb + = 1/6 * Sum ( p7 ) * trb ( p7 p12 h14 h15 )_trb * i2 ( p11 p7 )_ytra
C             i2 ( p11 p7 )_ytra + = 1 * Sum ( h4 h5 h6 p1 p2 ) * tra ( p1 p2 p11 h4 h5 h6 )_tra * y ( h4 h5 h6 p1 p2 p7 )_y
C         i1 ( p11 p12 h14 h15 )_ytratrb + = 1 * Sum ( h4 h5 p1 ) * trb ( p1 p11 p12 h4 h5 h14 )_trb * i2 ( h4 h5 h15 p1 )_ytra
C             i2 ( h4 h5 h15 p1 )_ytra + = -1 * Sum ( p7 ) * tra ( p7 h15 )_tra * y ( h4 h5 p1 p7 )_y
C             i2 ( h4 h5 h15 p1 )_ytra + = 1/2 * Sum ( h9 p7 p8 ) * tra ( p7 p8 h9 h15 )_tra * y ( h4 h5 h9 p1 p7 p8 )_y
C         i1 ( p11 p12 h14 h15 )_ytratrb + = 1/2 * Sum ( h4 p1 p2 ) * trb ( p1 p2 p11 h4 h14 h15 )_trb * i2 ( h4 p12 p1 p2 )_ytra
C             i2 ( h4 p12 p1 p2 )_ytra + = 1 * Sum ( h9 h10 p7 ) * tra ( p7 p12 h9 h10 )_tra * y ( h4 h9 h10 p1 p2 p7 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtra + = -1 * Sum ( h9 p7 ) * tra ( p7 p12 h9 h15 )_tra * i2 ( h9 p11 h14 p7 )_ytrb
C             i2 ( h9 p11 h14 p7 )_ytrb + = 1 * Sum ( h4 h5 p1 p2 ) * trb ( p1 p2 p11 h4 h5 h14 )_trb * y ( h4 h5 h9 p1 p2 p7 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtra + = 1/6 * Sum ( h9 ) * tra ( p11 p12 h9 h15 )_tra * i2 ( h9 h14 )_ytrb
C             i2 ( h9 h14 )_ytrb + = 1 * Sum ( h4 h5 p1 p2 p3 ) * trb ( p1 p2 p3 h4 h5 h14 )_trb * y ( h4 h5 h9 p1 p2 p3 )_y
C         i1 ( p11 p12 h14 h15 )_ytratrb + = 1/12 * Sum ( h2 h13 h4 p6 ) * trb ( p6 p11 p12 h2 h4 h13 )_trb * i2 ( h2 h4 h13 h14 h15 p6 )_ytra
C             i2 ( h2 h4 h13 h14 h15 p6 )_ytra + = -1 * Sum ( p7 p8 ) * tra ( p7 p8 h14 h15 )_tra * y ( h2 h4 h13 p6 p7 p8 )_y
C             i2 ( h2 h4 h13 h14 h15 p6 )_ytrat + = -2 * Sum ( p1 ) * t ( p1 h14 )_t * i3 ( h2 h4 h13 h15 p1 p6 )_ytra
C                 i3 ( h2 h4 h13 h15 p1 p6 )_ytra + = 1 * Sum ( p3 ) * tra ( p3 h15 )_tra * y ( h2 h4 h13 p1 p3 p6 )_y
C             i2 ( h2 h4 h13 h14 h15 p6 )_yttra + = -2 * Sum ( p1 ) * tra ( p1 h14 )_tra * i3 ( h2 h4 h13 h15 p1 p6 )_yt
C         i1 ( p11 p12 h14 h15 )_ytrbtra + = 1/6 * Sum ( p7 ) * tra ( p7 p12 h14 h15 )_tra * i2 ( p11 p7 )_ytrb
C             i2 ( p11 p7 )_ytrb + = 1 * Sum ( h4 h5 h6 p1 p2 ) * trb ( p1 p2 p11 h4 h5 h6 )_trb * y ( h4 h5 h6 p1 p2 p7 )_y
C         i1 ( p11 p12 h14 h15 )_yttrbtra + = 1/2 * Sum ( h2 ) * tra ( p11 h2 )_tra * i2 ( h2 p12 h14 h15 )_yttrb
C             i2 ( h2 p12 h14 h15 )_yttrb + = 1 * Sum ( h4 ) * trb ( p12 h4 )_trb * i3 ( h2 h4 h14 h15 )_yt
C                 i3 ( h2 h4 h14 h15 )_yt + = -1 * Sum ( p5 p6 ) * t ( p5 p6 h14 h15 )_t * y ( h2 h4 p5 p6 )_y
C                 i3 ( h2 h4 h14 h15 )_yt + = -1/3 * Sum ( h8 p5 p6 p7 ) * t ( p5 p6 p7 h8 h14 h15 )_t * i4 ( h2 h4 h8 p5 p6 p7 )_y
C                     i4 ( h2 h4 h8 p5 p6 p7 )_y + = 1 * y ( h2 h4 h8 p5 p6 p7 )_y
C                 i3 ( h2 h4 h14 h15 )_ytt + = -2 * Sum ( p5 ) * t ( p5 h14 )_t * i4 ( h2 h4 h15 p5 )_yt
C                     i4 ( h2 h4 h15 p5 )_yt + = 1 * Sum ( p7 ) * t ( p7 h15 )_t * y ( h2 h4 p5 p7 )_y
C                     i4 ( h2 h4 h15 p5 )_yt + = -1 * Sum ( h9 p7 p8 ) * t ( p7 p8 h9 h15 )_t * y ( h2 h4 h9 p5 p7 p8 )_y
C             i2 ( h2 p12 h14 h15 )_ytrbt + = 8 * Sum ( h7 p5 ) * t ( p5 p12 h7 h15 )_t * i3 ( h2 h7 h14 p5 )_ytrb
C                 i3 ( h2 h7 h14 p5 )_ytrb + = 1 * Sum ( p3 ) * trb ( p3 h14 )_trb * y ( h2 h7 p3 p5 )_y
C             i2 ( h2 p12 h14 h15 )_ytrbt + = 2 * Sum ( h8 h9 p5 p6 ) * t ( p5 p6 p12 h8 h9 h15 )_t * i3 ( h2 h8 h9 h14 p5 p6 )_ytrb
C                 i3 ( h2 h8 h9 h14 p5 p6 )_ytrb + = 1 * Sum ( p3 ) * trb ( p3 h14 )_trb * y ( h2 h8 h9 p3 p5 p6 )_y
C             i2 ( h2 p12 h14 h15 )_ytrbt + = 1 * Sum ( h4 ) * t ( p12 h4 )_t * i3 ( h2 h4 h14 h15 )_ytrb
C                 i3 ( h2 h4 h14 h15 )_ytrb + = -1 * Sum ( p5 p6 ) * trb ( p5 p6 h14 h15 )_trb * y ( h2 h4 p5 p6 )_y
C                 i3 ( h2 h4 h14 h15 )_ytrbt + = -2 * Sum ( p5 ) * t ( p5 h14 )_t * i4 ( h2 h4 h15 p5 )_ytrb
C                     i4 ( h2 h4 h15 p5 )_ytrb + = 1 * Sum ( p7 ) * trb ( p7 h15 )_trb * y ( h2 h4 p5 p7 )_y
C                     i4 ( h2 h4 h15 p5 )_ytrb + = -1 * Sum ( h9 p7 p8 ) * trb ( p7 p8 h9 h15 )_trb * y ( h2 h4 h9 p5 p7 p8 )_y
C                 i3 ( h2 h4 h14 h15 )_yttrb + = -2 * Sum ( p5 ) * trb ( p5 h14 )_trb * i4 ( h2 h4 h15 p5 )_yt
C             i2 ( h2 p12 h14 h15 )_yttrb + = 8 * Sum ( h7 p5 ) * trb ( p5 p12 h7 h15 )_trb * i3 ( h2 h7 h14 p5 )_yt
C                 i3 ( h2 h7 h14 p5 )_yt + = 1 * Sum ( p3 ) * t ( p3 h14 )_t * y ( h2 h7 p3 p5 )_y
C             i2 ( h2 p12 h14 h15 )_yttrb + = 2 * Sum ( h8 h9 p5 p6 ) * trb ( p5 p6 p12 h8 h9 h15 )_trb * i3 ( h2 h8 h9 h14 p5 p6 )_yt
C                 i3 ( h2 h8 h9 h14 p5 p6 )_yt + = 1 * Sum ( p3 ) * t ( p3 h14 )_t * y ( h2 h8 h9 p3 p5 p6 )_y
C             i2 ( h2 p12 h14 h15 )_ytttrb + = -2 * Sum ( p3 ) * trb ( p3 h14 )_trb * i3 ( h2 p12 h15 p3 )_ytt
C                 i3 ( h2 p12 h15 p3 )_ytt + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p12 h9 h10 )_t * i4 ( h2 h9 h10 h15 p3 p7 )_yt
C                     i4 ( h2 h9 h10 h15 p3 p7 )_yt + = -1 * Sum ( p5 ) * t ( p5 h15 )_t * y ( h2 h9 h10 p3 p5 p7 )_y
C             i2 ( h2 p12 h14 h15 )_yttrbt + = -2 * Sum ( p3 ) * t ( p3 h14 )_t * i3 ( h2 p12 h15 p3 )_yttrb
C                 i3 ( h2 p12 h15 p3 )_yttrb + = 1 * Sum ( h9 h10 p7 ) * trb ( p7 p12 h9 h10 )_trb * i4 ( h2 h9 h10 h15 p3 p7 )_yt
C                 i3 ( h2 p12 h15 p3 )_ytrbt + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p12 h9 h10 )_t * i4 ( h2 h9 h10 h15 p3 p7 )_ytrb
C                     i4 ( h2 h9 h10 h15 p3 p7 )_ytrb + = -1 * Sum ( p5 ) * trb ( p5 h15 )_trb * y ( h2 h9 h10 p3 p5 p7 )_y
C         i1 ( p11 p12 h14 h15 )_yttratrb + = -1/3 * trb ( p12 h14 )_trb * i2 ( p11 h15 )_yttra
C             i2 ( p11 h15 )_yttra + = 1 * Sum ( h2 ) * tra ( p11 h2 )_tra * i3 ( h2 h15 )_yt
C                 i3 ( h2 h15 )_yt + = 1 * Sum ( h8 h9 p5 p6 p7 ) * t ( p5 p6 p7 h8 h9 h15 )_t * y ( h2 h8 h9 p5 p6 p7 )_y
C             i2 ( p11 h15 )_ytrat + = 1 * Sum ( h2 ) * t ( p11 h2 )_t * i3 ( h2 h15 )_ytra
C                 i3 ( h2 h15 )_ytra + = 1 * Sum ( h8 h9 p5 p6 p7 ) * tra ( p5 p6 p7 h8 h9 h15 )_tra * y ( h2 h8 h9 p5 p6 p7 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtrat + = 1/6 * Sum ( h8 h9 h10 p5 ) * t ( p5 p11 p12 h8 h9 h10 )_t * i2 ( h8 h9 h10 h14 h15 p5 )_ytrbtra
C             i2 ( h8 h9 h10 h14 h15 p5 )_ytrbtra + = 1 * Sum ( p1 ) * tra ( p1 h14 )_tra * i3 ( h8 h9 h10 h15 p1 p5 )_ytrb
C                 i3 ( h8 h9 h10 h15 p1 p5 )_ytrb + = -1 * Sum ( p3 ) * trb ( p3 h15 )_trb * y ( h8 h9 h10 p1 p3 p5 )_y
C             i2 ( h8 h9 h10 h14 h15 p5 )_ytratrb + = 1 * Sum ( p1 ) * trb ( p1 h14 )_trb * i3 ( h8 h9 h10 h15 p1 p5 )_ytra
C                 i3 ( h8 h9 h10 h15 p1 p5 )_ytra + = -1 * Sum ( p3 ) * tra ( p3 h15 )_tra * y ( h8 h9 h10 p1 p3 p5 )_y
C         i1 ( p11 p12 h14 h15 )_ytrattrb + = -1/3 * trb ( p11 h15 )_trb * i2 ( p12 h14 )_ytrat
C             i2 ( p12 h14 )_ytrat + = 1 * Sum ( h8 h9 h10 p5 p6 ) * t ( p5 p6 p12 h8 h9 h10 )_t * i3 ( h8 h9 h10 h14 p5 p6 )_ytra
C                 i3 ( h8 h9 h10 h14 p5 p6 )_ytra + = 1 * Sum ( p1 ) * tra ( p1 h14 )_tra * y ( h8 h9 h10 p1 p5 p6 )_y
C             i2 ( p12 h14 )_yttra + = 1 * Sum ( h8 h9 h10 p5 p6 ) * tra ( p5 p6 p12 h8 h9 h10 )_tra * i3 ( h8 h9 h10 h14 p5 p6 )_yt
C                 i3 ( h8 h9 h10 h14 p5 p6 )_yt + = 1 * Sum ( p1 ) * t ( p1 h14 )_t * y ( h8 h9 h10 p1 p5 p6 )_y
C         i1 ( p11 p12 h14 h15 )_ytratrbt + = -1/2 * Sum ( h10 ) * t ( p12 h10 )_t * i2 ( h10 p11 h14 h15 )_ytratrb
C             i2 ( h10 p11 h14 h15 )_ytratrb + = 1 * Sum ( p5 p6 ) * trb ( p5 p6 h14 h15 )_trb * i3 ( h10 p11 p5 p6 )_ytra
C                 i3 ( h10 p11 p5 p6 )_ytra + = 1 * Sum ( h3 h4 p1 ) * tra ( p1 p11 h3 h4 )_tra * y ( h3 h4 h10 p1 p5 p6 )_y
C             i2 ( h10 p11 h14 h15 )_ytratrb + = 4 * Sum ( h7 p5 ) * trb ( p5 p11 h7 h15 )_trb * i3 ( h7 h10 h14 p5 )_ytra
C                 i3 ( h7 h10 h14 p5 )_ytra + = -1 * Sum ( h3 p1 p2 ) * tra ( p1 p2 h3 h14 )_tra * y ( h3 h7 h10 p1 p2 p5 )_y
C             i2 ( h10 p11 h14 h15 )_ytrbtra + = 1 * Sum ( p5 p6 ) * tra ( p5 p6 h14 h15 )_tra * i3 ( h10 p11 p5 p6 )_ytrb
C                 i3 ( h10 p11 p5 p6 )_ytrb + = 1 * Sum ( h3 h4 p1 ) * trb ( p1 p11 h3 h4 )_trb * y ( h3 h4 h10 p1 p5 p6 )_y
C             i2 ( h10 p11 h14 h15 )_ytrbtra + = 4 * Sum ( h7 p5 ) * tra ( p5 p11 h7 h15 )_tra * i3 ( h7 h10 h14 p5 )_ytrb
C                 i3 ( h7 h10 h14 p5 )_ytrb + = -1 * Sum ( h3 p1 p2 ) * trb ( p1 p2 h3 h14 )_trb * y ( h3 h7 h10 p1 p2 p5 )_y
C         i1 ( p11 p12 h14 h15 )_yttratrb + = -2 * Sum ( h7 p5 ) * trb ( p5 p12 h7 h14 )_trb * i2 ( h7 p11 h15 p5 )_yttra
C             i2 ( h7 p11 h15 p5 )_yttra + = 1 * Sum ( h3 h4 p1 ) * tra ( p1 p11 h3 h4 )_tra * i3 ( h3 h4 h7 h15 p1 p5 )_yt
C                 i3 ( h3 h4 h7 h15 p1 p5 )_yt + = -1 * Sum ( p9 ) * t ( p9 h15 )_t * y ( h3 h4 h7 p1 p5 p9 )_y
C             i2 ( h7 p11 h15 p5 )_ytrat + = 1 * Sum ( h3 h4 p1 ) * t ( p1 p11 h3 h4 )_t * i3 ( h3 h4 h7 h15 p1 p5 )_ytra
C                 i3 ( h3 h4 h7 h15 p1 p5 )_ytra + = -1 * Sum ( p9 ) * tra ( p9 h15 )_tra * y ( h3 h4 h7 p1 p5 p9 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtrat + = -1 * t ( p12 h15 )_t * i2 ( p11 h14 )_ytrbtra
C             i2 ( p11 h14 )_ytrbtra + = 1 * Sum ( h3 h4 p1 ) * tra ( p1 p11 h3 h4 )_tra * i3 ( h3 h4 h14 p1 )_ytrb
C                 i3 ( h3 h4 h14 p1 )_ytrb + = 1 * Sum ( h7 p5 p6 ) * trb ( p5 p6 h7 h14 )_trb * y ( h3 h4 h7 p1 p5 p6 )_y
C             i2 ( p11 h14 )_ytratrb + = 1 * Sum ( h3 h4 p1 ) * trb ( p1 p11 h3 h4 )_trb * i3 ( h3 h4 h14 p1 )_ytra
C                 i3 ( h3 h4 h14 p1 )_ytra + = 1 * Sum ( h7 p5 p6 ) * tra ( p5 p6 h7 h14 )_tra * y ( h3 h4 h7 p1 p5 p6 )_y
C         i1 ( p11 p12 h14 h15 )_ytrbtrat + = 1/2 * Sum ( h2 ) * t ( p11 h2 )_t * i2 ( h2 p12 h14 h15 )_ytrbtra
C             i2 ( h2 p12 h14 h15 )_ytrbtra + = 1 * Sum ( h4 ) * tra ( p12 h4 )_tra * i3 ( h2 h4 h14 h15 )_ytrb
C                 i3 ( h2 h4 h14 h15 )_ytrb + = -1/3 * Sum ( h8 p5 p6 p7 ) * trb ( p5 p6 p7 h8 h14 h15 )_trb * y ( h2 h4 h8 p5 p6 p7 )_y
C             i2 ( h2 p12 h14 h15 )_ytratrb + = 8 * Sum ( h7 p5 ) * trb ( p5 p12 h7 h15 )_trb * i3 ( h2 h7 h14 p5 )_ytra
C                 i3 ( h2 h7 h14 p5 )_ytra + = 1 * Sum ( p3 ) * tra ( p3 h14 )_tra * y ( h2 h7 p3 p5 )_y
C             i2 ( h2 p12 h14 h15 )_ytratrb + = 2 * Sum ( h8 h9 p5 p6 ) * trb ( p5 p6 p12 h8 h9 h15 )_trb * i3 ( h2 h8 h9 h14 p5 p6 )_ytra
C                 i3 ( h2 h8 h9 h14 p5 p6 )_ytra + = 1 * Sum ( p3 ) * tra ( p3 h14 )_tra * y ( h2 h8 h9 p3 p5 p6 )_y
C             i2 ( h2 p12 h14 h15 )_ytratrb + = 1 * Sum ( h4 ) * trb ( p12 h4 )_trb * i3 ( h2 h4 h14 h15 )_ytra
C                 i3 ( h2 h4 h14 h15 )_ytra + = -1 * Sum ( p5 p6 ) * tra ( p5 p6 h14 h15 )_tra * y ( h2 h4 p5 p6 )_y
C                 i3 ( h2 h4 h14 h15 )_ytra + = -1/3 * Sum ( h8 p5 p6 p7 ) * tra ( p5 p6 p7 h8 h14 h15 )_tra * y ( h2 h4 h8 p5 p6 p7 )_y
C                 i3 ( h2 h4 h14 h15 )_yttra + = -2 * Sum ( p5 ) * tra ( p5 h14 )_tra * i4 ( h2 h4 h15 p5 )_yt
C                 i3 ( h2 h4 h14 h15 )_ytrat + = -2 * Sum ( p5 ) * t ( p5 h14 )_t * i4 ( h2 h4 h15 p5 )_ytra
C                     i4 ( h2 h4 h15 p5 )_ytra + = 1 * Sum ( p7 ) * tra ( p7 h15 )_tra * y ( h2 h4 p5 p7 )_y
C                     i4 ( h2 h4 h15 p5 )_ytra + = -1 * Sum ( h9 p7 p8 ) * tra ( p7 p8 h9 h15 )_tra * y ( h2 h4 h9 p5 p7 p8 )_y
C             i2 ( h2 p12 h14 h15 )_ytrbtra + = 8 * Sum ( h7 p5 ) * tra ( p5 p12 h7 h15 )_tra * i3 ( h2 h7 h14 p5 )_ytrb
C             i2 ( h2 p12 h14 h15 )_ytrbtra + = 2 * Sum ( h8 h9 p5 p6 ) * tra ( p5 p6 p12 h8 h9 h15 )_tra * i3 ( h2 h8 h9 h14 p5 p6 )_ytrb
C             i2 ( h2 p12 h14 h15 )_ytrbttra + = -2 * Sum ( p3 ) * tra ( p3 h14 )_tra * i3 ( h2 p12 h15 p3 )_ytrbt
C             i2 ( h2 p12 h14 h15 )_ytrbtrat + = -2 * Sum ( h4 ) * t ( p12 h4 )_t * i3 ( h2 h4 h14 h15 )_ytrbtra
C                 i3 ( h2 h4 h14 h15 )_ytrbtra + = 1 * Sum ( p5 ) * tra ( p5 h14 )_tra * i4 ( h2 h4 h15 p5 )_ytrb
C                 i3 ( h2 h4 h14 h15 )_ytratrb + = 1 * Sum ( p5 ) * trb ( p5 h14 )_trb * i4 ( h2 h4 h15 p5 )_ytra
C             i2 ( h2 p12 h14 h15 )_ytratrbt + = -2 * Sum ( p3 ) * t ( p3 h14 )_t * i3 ( h2 p12 h15 p3 )_ytratrb
C                 i3 ( h2 p12 h15 p3 )_ytratrb + = 1 * Sum ( h9 h10 p7 ) * trb ( p7 p12 h9 h10 )_trb * i4 ( h2 h9 h10 h15 p3 p7 )_ytra
C                     i4 ( h2 h9 h10 h15 p3 p7 )_ytra + = -1 * Sum ( p5 ) * tra ( p5 h15 )_tra * y ( h2 h9 h10 p3 p5 p7 )_y
C                 i3 ( h2 p12 h15 p3 )_ytrbtra + = 1 * Sum ( h9 h10 p7 ) * tra ( p7 p12 h9 h10 )_tra * i4 ( h2 h9 h10 h15 p3 p7 )_ytrb
C             i2 ( h2 p12 h14 h15 )_ytrattrb + = -2 * Sum ( p3 ) * trb ( p3 h14 )_trb * i3 ( h2 p12 h15 p3 )_ytrat
C                 i3 ( h2 p12 h15 p3 )_ytrat + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p12 h9 h10 )_t * i4 ( h2 h9 h10 h15 p3 p7 )_ytra
C                 i3 ( h2 p12 h15 p3 )_yttra + = 1 * Sum ( h9 h10 p7 ) * tra ( p7 p12 h9 h10 )_tra * i4 ( h2 h9 h10 h15 p3 p7 )_yt
C         i1 ( p11 p12 h14 h15 )_ytrbttra + = -1/3 * tra ( p12 h14 )_tra * i2 ( p11 h15 )_ytrbt
C             i2 ( p11 h15 )_ytrbt + = 1 * Sum ( h2 ) * t ( p11 h2 )_t * i3 ( h2 h15 )_ytrb
C                 i3 ( h2 h15 )_ytrb + = 1 * Sum ( h8 h9 p5 p6 p7 ) * trb ( p5 p6 p7 h8 h9 h15 )_trb * y ( h2 h8 h9 p5 p6 p7 )_y
C             i2 ( p11 h15 )_yttrb + = 1 * Sum ( h2 ) * trb ( p11 h2 )_trb * i3 ( h2 h15 )_yt
C         i1 ( p11 p12 h14 h15 )_yttrbtra + = -1/3 * tra ( p11 h15 )_tra * i2 ( p12 h14 )_yttrb
C             i2 ( p12 h14 )_yttrb + = 1 * Sum ( h8 h9 h10 p5 p6 ) * trb ( p5 p6 p12 h8 h9 h10 )_trb * i3 ( h8 h9 h10 h14 p5 p6 )_yt
C             i2 ( p12 h14 )_ytrbt + = 1 * Sum ( h8 h9 h10 p5 p6 ) * t ( p5 p6 p12 h8 h9 h10 )_t * i3 ( h8 h9 h10 h14 p5 p6 )_ytrb
C                 i3 ( h8 h9 h10 h14 p5 p6 )_ytrb + = 1 * Sum ( p1 ) * trb ( p1 h14 )_trb * y ( h8 h9 h10 p1 p5 p6 )_y
C         i1 ( p11 p12 h14 h15 )_yttratrb + = -1/2 * Sum ( h10 ) * trb ( p12 h10 )_trb * i2 ( h10 p11 h14 h15 )_yttra
C             i2 ( h10 p11 h14 h15 )_yttra + = 1 * Sum ( p5 p6 ) * tra ( p5 p6 h14 h15 )_tra * i3 ( h10 p11 p5 p6 )_yt
C                 i3 ( h10 p11 p5 p6 )_yt + = 1 * Sum ( h3 h4 p1 ) * t ( p1 p11 h3 h4 )_t * y ( h3 h4 h10 p1 p5 p6 )_y
C             i2 ( h10 p11 h14 h15 )_yttra + = 4 * Sum ( h7 p5 ) * tra ( p5 p11 h7 h15 )_tra * i3 ( h7 h10 h14 p5 )_yt
C                 i3 ( h7 h10 h14 p5 )_yt + = -1 * Sum ( h3 p1 p2 ) * t ( p1 p2 h3 h14 )_t * y ( h3 h7 h10 p1 p2 p5 )_y
C             i2 ( h10 p11 h14 h15 )_ytrat + = 1 * Sum ( p5 p6 ) * t ( p5 p6 h14 h15 )_t * i3 ( h10 p11 p5 p6 )_ytra
C             i2 ( h10 p11 h14 h15 )_ytrat + = 4 * Sum ( h7 p5 ) * t ( p5 p11 h7 h15 )_t * i3 ( h7 h10 h14 p5 )_ytra
C         i1 ( p11 p12 h14 h15 )_ytrbttra + = -2 * Sum ( h7 p5 ) * tra ( p5 p12 h7 h14 )_tra * i2 ( h7 p11 h15 p5 )_ytrbt
C             i2 ( h7 p11 h15 p5 )_ytrbt + = 1 * Sum ( h3 h4 p1 ) * t ( p1 p11 h3 h4 )_t * i3 ( h3 h4 h7 h15 p1 p5 )_ytrb
C                 i3 ( h3 h4 h7 h15 p1 p5 )_ytrb + = -1 * Sum ( p9 ) * trb ( p9 h15 )_trb * y ( h3 h4 h7 p1 p5 p9 )_y
C             i2 ( h7 p11 h15 p5 )_yttrb + = 1 * Sum ( h3 h4 p1 ) * trb ( p1 p11 h3 h4 )_trb * i3 ( h3 h4 h7 h15 p1 p5 )_yt
C         i1 ( p11 p12 h14 h15 )_ytrattrb + = -1 * trb ( p12 h15 )_trb * i2 ( p11 h14 )_ytrat
C             i2 ( p11 h14 )_ytrat + = 1 * Sum ( h3 h4 p1 ) * t ( p1 p11 h3 h4 )_t * i3 ( h3 h4 h14 p1 )_ytra
C             i2 ( p11 h14 )_yttra + = 1 * Sum ( h3 h4 p1 ) * tra ( p1 p11 h3 h4 )_tra * i3 ( h3 h4 h14 p1 )_yt
C                 i3 ( h3 h4 h14 p1 )_yt + = 1 * Sum ( h7 p5 p6 ) * t ( p5 p6 h7 h14 )_t * y ( h3 h4 h7 p1 p5 p6 )_y
C         i1 ( p11 p12 h14 h15 )_ytrattrb + = 1/2 * Sum ( h2 ) * trb ( p11 h2 )_trb * i2 ( h2 p12 h14 h15 )_ytrat
C             i2 ( h2 p12 h14 h15 )_ytrat + = 1 * Sum ( h4 ) * t ( p12 h4 )_t * i3 ( h2 h4 h14 h15 )_ytra
C             i2 ( h2 p12 h14 h15 )_yttra + = 8 * Sum ( h7 p5 ) * tra ( p5 p12 h7 h15 )_tra * i3 ( h2 h7 h14 p5 )_yt
C             i2 ( h2 p12 h14 h15 )_yttra + = 2 * Sum ( h8 h9 p5 p6 ) * tra ( p5 p6 p12 h8 h9 h15 )_tra * i3 ( h2 h8 h9 h14 p5 p6 )_yt
C             i2 ( h2 p12 h14 h15 )_yttra + = 1 * Sum ( h4 ) * tra ( p12 h4 )_tra * i3 ( h2 h4 h14 h15 )_yt
C                 i3 ( h2 h4 h14 h15 )_yt + = -1/3 * Sum ( h8 p5 p6 p7 ) * t ( p5 p6 p7 h8 h14 h15 )_t * y ( h2 h4 h8 p5 p6 p7 )_y
C             i2 ( h2 p12 h14 h15 )_ytrat + = 8 * Sum ( h7 p5 ) * t ( p5 p12 h7 h15 )_t * i3 ( h2 h7 h14 p5 )_ytra
C             i2 ( h2 p12 h14 h15 )_ytrat + = 2 * Sum ( h8 h9 p5 p6 ) * t ( p5 p6 p12 h8 h9 h15 )_t * i3 ( h2 h8 h9 h14 p5 p6 )_ytra
C             i2 ( h2 p12 h14 h15 )_yttrat + = -2 * Sum ( p3 ) * t ( p3 h14 )_t * i3 ( h2 p12 h15 p3 )_yttra
C             i2 ( h2 p12 h14 h15 )_ytttra + = -2 * Sum ( p3 ) * tra ( p3 h14 )_tra * i3 ( h2 p12 h15 p3 )_ytt
C         i1 ( p11 p12 h14 h15 )_ytratrbt + = -1/3 * t ( p12 h14 )_t * i2 ( p11 h15 )_ytratrb
C             i2 ( p11 h15 )_ytratrb + = 1 * Sum ( h2 ) * trb ( p11 h2 )_trb * i3 ( h2 h15 )_ytra
C             i2 ( p11 h15 )_ytrbtra + = 1 * Sum ( h2 ) * tra ( p11 h2 )_tra * i3 ( h2 h15 )_ytrb
C         i1 ( p11 p12 h14 h15 )_ytrbtrat + = -1/3 * t ( p11 h15 )_t * i2 ( p12 h14 )_ytrbtra
C             i2 ( p12 h14 )_ytrbtra + = 1 * Sum ( h8 h9 h10 p5 p6 ) * tra ( p5 p6 p12 h8 h9 h10 )_tra * i3 ( h8 h9 h10 h14 p5 p6 )_ytrb
C             i2 ( p12 h14 )_ytratrb + = 1 * Sum ( h8 h9 h10 p5 p6 ) * trb ( p5 p6 p12 h8 h9 h10 )_trb * i3 ( h8 h9 h10 h14 p5 p6 )_ytra
C         i1 ( p11 p12 h14 h15 )_ytrbttra + = -1/2 * Sum ( h10 ) * tra ( p12 h10 )_tra * i2 ( h10 p11 h14 h15 )_ytrbt
C             i2 ( h10 p11 h14 h15 )_ytrbt + = 1 * Sum ( p5 p6 ) * t ( p5 p6 h14 h15 )_t * i3 ( h10 p11 p5 p6 )_ytrb
C             i2 ( h10 p11 h14 h15 )_ytrbt + = 4 * Sum ( h7 p5 ) * t ( p5 p11 h7 h15 )_t * i3 ( h7 h10 h14 p5 )_ytrb
C             i2 ( h10 p11 h14 h15 )_yttrb + = 1 * Sum ( p5 p6 ) * trb ( p5 p6 h14 h15 )_trb * i3 ( h10 p11 p5 p6 )_yt
C             i2 ( h10 p11 h14 h15 )_yttrb + = 4 * Sum ( h7 p5 ) * trb ( p5 p11 h7 h15 )_trb * i3 ( h7 h10 h14 p5 )_yt
C         i1 ( p11 p12 h14 h15 )_ytratrbt + = -2 * Sum ( h7 p5 ) * t ( p5 p12 h7 h14 )_t * i2 ( h7 p11 h15 p5 )_ytratrb
C             i2 ( h7 p11 h15 p5 )_ytratrb + = 1 * Sum ( h3 h4 p1 ) * trb ( p1 p11 h3 h4 )_trb * i3 ( h3 h4 h7 h15 p1 p5 )_ytra
C             i2 ( h7 p11 h15 p5 )_ytrbtra + = 1 * Sum ( h3 h4 p1 ) * tra ( p1 p11 h3 h4 )_tra * i3 ( h3 h4 h7 h15 p1 p5 )_ytrb
C         i1 ( p11 p12 h14 h15 )_ytrbtrat + = -1/2 * Sum ( h7 h8 ) * t ( p11 p12 h7 h8 )_t * i2 ( h7 h8 h14 h15 )_ytrbtra
C             i2 ( h7 h8 h14 h15 )_ytrbtra + = 1 * Sum ( p9 ) * tra ( p9 h15 )_tra * i3 ( h7 h8 h14 p9 )_ytrb
C             i2 ( h7 h8 h14 h15 )_ytratrb + = 1 * Sum ( p9 ) * trb ( p9 h15 )_trb * i3 ( h7 h8 h14 p9 )_ytra
C         i1 ( p11 p12 h14 h15 )_yttrbtra + = -1 * tra ( p12 h15 )_tra * i2 ( p11 h14 )_yttrb
C             i2 ( p11 h14 )_yttrb + = 1 * Sum ( h3 h4 p1 ) * trb ( p1 p11 h3 h4 )_trb * i3 ( h3 h4 h14 p1 )_yt
C             i2 ( p11 h14 )_ytrbt + = 1 * Sum ( h3 h4 p1 ) * t ( p1 p11 h3 h4 )_t * i3 ( h3 h4 h14 p1 )_ytrb
C     i0 ( )_ytratrbv + = -1/4 * Sum ( p13 p11 h10 p9 ) * i1 ( p11 p13 h10 p9 )_ytratrb * v ( h10 p9 p11 p13 )_v
C         i1 ( p11 p13 h10 p9 )_ytratrb + = 1 * Sum ( h8 ) * trb ( p11 h8 )_trb * i2 ( h8 p13 h10 p9 )_ytra
C             i2 ( h8 p13 h10 p9 )_ytra + = 1 * Sum ( h4 h5 p1 p2 ) * tra ( p1 p2 p13 h4 h5 h10 )_tra * y ( h4 h5 h8 p1 p2 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytrbtra + = -1/3 * Sum ( h4 h5 h6 p1 ) * tra ( p1 p11 p13 h4 h5 h6 )_tra * i2 ( h4 h5 h6 h10 p1 p9 )_ytrb
C             i2 ( h4 h5 h6 h10 p1 p9 )_ytrb + = -1 * Sum ( p7 ) * trb ( p7 h10 )_trb * y ( h4 h5 h6 p1 p7 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytratrb + = -1/3 * trb ( p11 h10 )_trb * i2 ( p13 p9 )_ytra
C             i2 ( p13 p9 )_ytra + = 1 * Sum ( h4 h5 h6 p1 p2 ) * tra ( p1 p2 p13 h4 h5 h6 )_tra * y ( h4 h5 h6 p1 p2 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytratrb + = -2 * Sum ( h7 p5 ) * trb ( p5 p11 h7 h10 )_trb * i2 ( h7 p13 p5 p9 )_ytra
C             i2 ( h7 p13 p5 p9 )_ytra + = -1 * Sum ( h3 h4 p1 ) * tra ( p1 p13 h3 h4 )_tra * y ( h3 h4 h7 p1 p5 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytratrb + = 1/2 * Sum ( h7 h8 ) * trb ( p11 p13 h7 h8 )_trb * i2 ( h7 h8 h10 p9 )_ytra
C             i2 ( h7 h8 h10 p9 )_ytra + = 1 * Sum ( h3 p1 p2 ) * tra ( p1 p2 h3 h10 )_tra * y ( h3 h7 h8 p1 p2 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytrbtra + = 1 * Sum ( h8 ) * tra ( p11 h8 )_tra * i2 ( h8 p13 h10 p9 )_ytrb
C             i2 ( h8 p13 h10 p9 )_ytrb + = 1 * Sum ( h4 h5 p1 p2 ) * trb ( p1 p2 p13 h4 h5 h10 )_trb * y ( h4 h5 h8 p1 p2 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytratrb + = -1/3 * Sum ( h4 h5 h6 p1 ) * trb ( p1 p11 p13 h4 h5 h6 )_trb * i2 ( h4 h5 h6 h10 p1 p9 )_ytra
C             i2 ( h4 h5 h6 h10 p1 p9 )_ytra + = -1 * Sum ( p7 ) * tra ( p7 h10 )_tra * y ( h4 h5 h6 p1 p7 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytrbtra + = -1/3 * tra ( p11 h10 )_tra * i2 ( p13 p9 )_ytrb
C             i2 ( p13 p9 )_ytrb + = 1 * Sum ( h4 h5 h6 p1 p2 ) * trb ( p1 p2 p13 h4 h5 h6 )_trb * y ( h4 h5 h6 p1 p2 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytrbtra + = -2 * Sum ( h7 p5 ) * tra ( p5 p11 h7 h10 )_tra * i2 ( h7 p13 p5 p9 )_ytrb
C             i2 ( h7 p13 p5 p9 )_ytrb + = -1 * Sum ( h3 h4 p1 ) * trb ( p1 p13 h3 h4 )_trb * y ( h3 h4 h7 p1 p5 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytrbtra + = 1/2 * Sum ( h7 h8 ) * tra ( p11 p13 h7 h8 )_tra * i2 ( h7 h8 h10 p9 )_ytrb
C             i2 ( h7 h8 h10 p9 )_ytrb + = 1 * Sum ( h3 p1 p2 ) * trb ( p1 p2 h3 h10 )_trb * y ( h3 h7 h8 p1 p2 p9 )_y
C         i1 ( p11 p13 h10 p9 )_yttrbtra + = 1 * Sum ( h2 ) * tra ( p13 h2 )_tra * i2 ( h2 p11 h10 p9 )_yttrb
C             i2 ( h2 p11 h10 p9 )_yttrb + = 1 * Sum ( h4 ) * trb ( p11 h4 )_trb * i3 ( h2 h4 h10 p9 )_yt
C                 i3 ( h2 h4 h10 p9 )_yt + = -1 * Sum ( h7 p5 p6 ) * t ( p5 p6 h7 h10 )_t * y ( h2 h4 h7 p5 p6 p9 )_y
C             i2 ( h2 p11 h10 p9 )_ytrbt + = 2 * Sum ( h7 h8 p5 ) * t ( p5 p11 h7 h8 )_t * i3 ( h2 h7 h8 h10 p5 p9 )_ytrb
C                 i3 ( h2 h7 h8 h10 p5 p9 )_ytrb + = -1 * Sum ( p3 ) * trb ( p3 h10 )_trb * y ( h2 h7 h8 p3 p5 p9 )_y
C             i2 ( h2 p11 h10 p9 )_ytrbt + = 1 * Sum ( h4 ) * t ( p11 h4 )_t * i3 ( h2 h4 h10 p9 )_ytrb
C                 i3 ( h2 h4 h10 p9 )_ytrb + = -1 * Sum ( h7 p5 p6 ) * trb ( p5 p6 h7 h10 )_trb * y ( h2 h4 h7 p5 p6 p9 )_y
C             i2 ( h2 p11 h10 p9 )_yttrb + = 2 * Sum ( h7 h8 p5 ) * trb ( p5 p11 h7 h8 )_trb * i3 ( h2 h7 h8 h10 p5 p9 )_yt
C                 i3 ( h2 h7 h8 h10 p5 p9 )_yt + = -1 * Sum ( p3 ) * t ( p3 h10 )_t * y ( h2 h7 h8 p3 p5 p9 )_y
C         i1 ( p11 p13 h10 p9 )_ytrbtrat + = 1 * Sum ( h2 ) * t ( p13 h2 )_t * i2 ( h2 p11 h10 p9 )_ytrbtra
C             i2 ( h2 p11 h10 p9 )_ytrbtra + = 1 * Sum ( h4 ) * tra ( p11 h4 )_tra * i3 ( h2 h4 h10 p9 )_ytrb
C             i2 ( h2 p11 h10 p9 )_ytratrb + = 2 * Sum ( h7 h8 p5 ) * trb ( p5 p11 h7 h8 )_trb * i3 ( h2 h7 h8 h10 p5 p9 )_ytra
C                 i3 ( h2 h7 h8 h10 p5 p9 )_ytra + = -1 * Sum ( p3 ) * tra ( p3 h10 )_tra * y ( h2 h7 h8 p3 p5 p9 )_y
C             i2 ( h2 p11 h10 p9 )_ytratrb + = 1 * Sum ( h4 ) * trb ( p11 h4 )_trb * i3 ( h2 h4 h10 p9 )_ytra
C                 i3 ( h2 h4 h10 p9 )_ytra + = -1 * Sum ( h7 p5 p6 ) * tra ( p5 p6 h7 h10 )_tra * y ( h2 h4 h7 p5 p6 p9 )_y
C             i2 ( h2 p11 h10 p9 )_ytrbtra + = 2 * Sum ( h7 h8 p5 ) * tra ( p5 p11 h7 h8 )_tra * i3 ( h2 h7 h8 h10 p5 p9 )_ytrb
C         i1 ( p11 p13 h10 p9 )_ytrattrb + = 1 * Sum ( h2 ) * trb ( p13 h2 )_trb * i2 ( h2 p11 h10 p9 )_ytrat
C             i2 ( h2 p11 h10 p9 )_ytrat + = 1 * Sum ( h4 ) * t ( p11 h4 )_t * i3 ( h2 h4 h10 p9 )_ytra
C             i2 ( h2 p11 h10 p9 )_yttra + = 2 * Sum ( h7 h8 p5 ) * tra ( p5 p11 h7 h8 )_tra * i3 ( h2 h7 h8 h10 p5 p9 )_yt
C             i2 ( h2 p11 h10 p9 )_yttra + = 1 * Sum ( h4 ) * tra ( p11 h4 )_tra * i3 ( h2 h4 h10 p9 )_yt
C             i2 ( h2 p11 h10 p9 )_ytrat + = 2 * Sum ( h7 h8 p5 ) * t ( p5 p11 h7 h8 )_t * i3 ( h2 h7 h8 h10 p5 p9 )_ytra
C     i0 ( )_vtratrb + = 1/2 * Sum ( h2 p1 ) * trb ( p1 h2 )_trb * i1 ( h2 p1 )_vtra
C         i1 ( h2 p1 )_vtra + = 1 * Sum ( h4 p3 ) * tra ( p3 h4 )_tra * v ( h2 h4 p1 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_tra1
      INTEGER k_tra1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_trb1
      INTEGER k_trb1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER d_tra2
      INTEGER k_tra2_offset
      INTEGER d_tra3
      INTEGER k_tra3_offset
      INTEGER d_trb2
      INTEGER k_trb2_offset
      INTEGER d_trb3
      INTEGER k_trb3_offset
      INTEGER l_i2_offset
      INTEGER size_i2
      INTEGER d_y3
      INTEGER k_y3_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i3
      INTEGER k_i3_offset
      INTEGER l_i3_offset
      INTEGER size_i3
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_t3
      INTEGER k_t3_offset
      INTEGER d_i4
      INTEGER k_i4_offset
      INTEGER l_i4_offset
      INTEGER size_i4
      CHARACTER*255 filename
#if !defined(CCSDTLR)
      CALL ERRQUIT('CCSDTLR not compiled (ccsdt_lr_alpha2.F)',
     &              0,CAPMIS_ERR)
      RETURN
      END
#else
      CALL OFFSET_ccsdt_lr_alpha2_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lr_alpha2_1_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d_i
     &1,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_1(d_tra1,k_tra1_offset,d_i1,k_i1_offset,d_i0,
     &k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_2_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_2_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_1_1(d_trb1,k_trb1_offset,d_y1,k_y1_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_2_1_2(d_trb2,k_trb2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_2_1_3(d_trb3,k_trb3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_1(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_2_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_2_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_2_1(d_tra2,k_tra2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_2_2_2(d_tra3,k_tra3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_2_2_3(d_tra1,k_tra1_offset,d_y1,k_y1_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_2(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_2_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_2_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_3_1(d_trb1,k_trb1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_2_3_2(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_3(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_2_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_2_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_4_1(d_trb1,k_trb1_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_4(d_tra3,k_tra3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_2_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_2_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_5_1(d_tra1,k_tra1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_2_5_2(d_tra2,k_tra2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_5(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_2_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_2_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_6_1(d_tra1,k_tra1_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_2_6(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_2(d_i1,k_i1_offset,d_f1,k_f1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_3_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_1_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_3_1_2(d_trb2,k_trb2_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_3_1_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_1_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_1_3_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_1_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_1_4_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_1_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_1_4_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_1_4(d_trb1,k_trb1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_1(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_2_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_2(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_3_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_3(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_4_1(d_tra2,k_tra2_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_3_4_2(d_tra1,k_tra1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_3_4_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_4_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_4_3_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_4_3(d_tra1,k_tra1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_4_4_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_4_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_4_4_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_4_4(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_4(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_5_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_5(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_6_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_6(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_7_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_7(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_8_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_8(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_3_9_1_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_9_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_9_1_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_9_1(d_trb1,k_trb1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_3_9_2_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_3_9_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_9_2_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_3_9_2(d_tra1,k_tra1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_3_9(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_3(d_y1,k_y1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_4_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_4_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_1_1(d_trb1,k_trb1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_1(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_4_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_4_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_2_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_2(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_4_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_4_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_3_1(d_tra1,k_tra1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_3(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_4_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_4_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_4_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_4_4(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_4(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_5_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_5_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_5_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_5_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_1_1(d_trb1,k_trb1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_5_1_2(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_1(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_5_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_5_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_2_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_5_2_2(d_tra1,k_tra1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_2(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_5_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_5_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_3_1(d_trb1,k_trb1_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_3(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_5_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_5_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_4_1(d_tra1,k_tra1_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_5_4(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_5(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_6_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_1_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_1(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_2_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_6_2_2(d_trb2,k_trb2_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_2(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_3_1(d_tra2,k_tra2_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_6_3_2_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_3_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_2_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_3_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_3_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_3_1(d_tra2,k_tra2_offset,d_v2,k_v2_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_3_4_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_3_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_4_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_4(d_tra2,k_tra2_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_3_5_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_3_5_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_5_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_5(d_tra1,k_tra1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_3_6_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_3_6_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_6_1(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_6(d_tra1,k_tra1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_3_7_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_3_7_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_7_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_3_7(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_3(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_4_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_6_4_2(d_trb2,k_trb2_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_4(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_5_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_5(d_tra3,k_tra3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_6_1(d_trb1,k_trb1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_6(d_tra3,k_tra3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_7_1(d_trb2,k_trb2_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_7(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_8_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_8(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_9_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_6_9_2(d_tra2,k_tra2_offset,d_v2,k_v2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_9(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_10_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_10_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_10_1(d_trb2,k_trb2_offset,d_v2,k_v2_offset,
     &d_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_6_10_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_10_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_2_1(d_t2,k_t2_offset,d_v2,k_v2_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_2(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_10_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_10_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_3_1(d_trb1,k_trb1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_3(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_10_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_10_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_4_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_4(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_10_5_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_10_5_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_5_1(d_trb2,k_trb2_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_5(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_10_6_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_10_6_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_6_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_6(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_10_7_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_10_7_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_7_1(d_trb1,k_trb1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_10_7(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_10(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_11_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_11_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_11_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,
     &d_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_6_11_2(d_tra2,k_tra2_offset,d_v2,k_v2_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_11(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_12_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_12_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_12_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_12(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_13_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_13_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_13_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_13(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_14_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_14_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_14_1(d_tra2,k_tra2_offset,d_v2,k_v2_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_14(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_15_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_15_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_6_15_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_15_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_1_1(d_trb1,k_trb1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_15_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_15_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_2_1(d_trb2,k_trb2_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_2(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_15_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_15_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_3_1(d_tra1,k_tra1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_3(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_15_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_15_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_4_1(d_tra1,k_tra1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_4(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_15_5_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_15_5_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_5_1(d_tra2,k_tra2_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_5(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_15_6_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_15_6_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_6_1(d_trb1,k_trb1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_15_6(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_15(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_16_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_16_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_6_16_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_16_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_16_1_1(d_trb1,k_trb1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_16_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_16_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_16_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_16_2_1(d_tra1,k_tra1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_16_2(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_16(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_17_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_17_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_6_17_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_17_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_17_1_1(d_tra1,k_tra1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_17_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_17_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_17_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_17_2_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_17_2(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_17(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_18_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_18_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_6_18_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_18_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_18_1_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_18_1(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_6_18_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_6_18_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_18_2_1(d_trb1,k_trb1_offset,d_v2,k_v2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_6_18_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_6_18(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_6(d_y2,k_y2_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_7_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_1_1(d_tra2,k_tra2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_7_1_2(d_tra3,k_tra3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_7_1_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_1_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_1_3_1(d_tra1,k_tra1_offset,d_y2,k_y2_offset
     &,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_7_1_3_2(d_tra2,k_tra2_offset,d_y3,k_y3_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_1_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_1_4_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_1_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_1_4_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i
     &3,k_i3_offset)
      CALL ccsdt_lr_alpha2_7_1_4_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_1_4(d_tra1,k_tra1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_1(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_2_1(d_trb1,k_trb1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_2(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_3_1(d_tra2,k_tra2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_7_3_2(d_tra3,k_tra3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_3(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_7_4_1_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_4_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_4_1_1(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_7_4_1_2(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_4_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_4(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_5_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_5(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_6_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_6(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_7_1(d_trb2,k_trb2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_7_7_2(d_trb3,k_trb3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_7_7_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_7_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_7_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i
     &3,k_i3_offset)
      CALL ccsdt_lr_alpha2_7_7_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_7_3(d_trb1,k_trb1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_7_4_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_7_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_7_4_1(d_trb1,k_trb1_offset,d_y2,k_y2_offset
     &,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_7_7_4_2(d_trb2,k_trb2_offset,d_y3,k_y3_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_7_4(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_7(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_8_1(d_tra1,k_tra1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_8(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_9_1(d_trb2,k_trb2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_7_9_2(d_trb3,k_trb3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_9(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_10_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_10_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_10_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_10(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_11_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_11_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_11_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_11(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_12_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_12_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_7_12_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_12_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_12_1_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_12_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_12_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_12_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_12_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_12_2(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_12(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_13_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_13_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_7_13_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_13_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_13_1_1(d_trb1,k_trb1_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_7_13_1_2(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_13_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_13_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_13_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_13_2_1(d_tra1,k_tra1_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_7_13_2_2(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_13_2(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_13(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_14_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_14_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_7_14_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_14_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_14_1_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_14_1(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_14_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_14_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_14_2_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_14_2(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_14(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_15_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_15_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_7_15_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_15_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_15_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_15_1(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_7_15_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_7_15_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_15_2_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_7_15_2(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_7_15(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_7(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_8_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_8_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_8_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_8_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_8_1_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_8_1(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_8_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_8_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_8_2_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_8_2(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_8(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_9_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_1_1(d_trb1,k_trb1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_9_1_2(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_1(d_tra3,k_tra3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_2_1(d_trb2,k_trb2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_9_2_2(d_trb3,k_trb3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_2_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_2_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_2_3_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_2_3(d_trb1,k_trb1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_2_4_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_2_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_2_4_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_2_4(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_2(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_3_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_3(d_tra3,k_tra3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_4_1(d_tra3,k_tra3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_9_4_2(d_tra2,k_tra2_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_4_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_4_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_4_3_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_4_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_4_4_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_4_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_4_4_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_4_4(d_tra1,k_tra1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_4(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_5_1(d_tra3,k_tra3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_5(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_6_1(d_tra3,k_tra3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_6(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_7_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_7_2_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_7_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_7_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_7_2(d_trb1,k_trb1_offset,d_i3,k_i3_offset,d
     &_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_7_3_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_7_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_7_3_1(d_trb1,k_trb1_offset,d_y3,k_y3_offset
     &,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_7_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_7(d_tra3,k_tra3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_8_1(d_tra3,k_tra3_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_8(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_9_1(d_tra1,k_tra1_offset,d_y2,k_y2_offset,d
     &_i2,k_i2_offset)
      CALL ccsdt_lr_alpha2_9_9_2(d_tra2,k_tra2_offset,d_y3,k_y3_offset,d
     &_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_9(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_i
     &1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_10_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_10_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_10_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_10(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_11_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_11_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_11_1(d_trb3,k_trb3_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_11(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_12_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_12_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_12_1(d_trb3,k_trb3_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_12(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_13_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_13_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_13_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_13_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_13_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_13_2_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_13_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_13_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_13_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_13_3_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_13_3(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_13(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_14_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_14_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_14_1(d_trb3,k_trb3_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_14(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_1_1(d_t2,k_t2_offset,d_y2,k_y2_offset,d_
     &i3,k_i3_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_1_2_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_1_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_1_2_1(d_y3,k_y3_offset,d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_15_1_2_2(d_y3,k_y3_offset,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_1_2(d_t3,k_t3_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_1_3_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_1_3_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_1_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,
     &d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_15_1_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_1_3(d_t1,k_t1_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_1(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_2_1(d_trb1,k_trb1_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_2(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_3_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_3(d_t3,k_t3_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_4_1(d_trb2,k_trb2_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_4_2_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_4_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_4_2_1(d_trb1,k_trb1_offset,d_y2,k_y2_off
     &set,d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_15_4_2_2(d_trb2,k_trb2_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_4_2(d_t1,k_t1_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_4_3_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_4_3_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_4_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,
     &d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_15_4_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_4_3(d_trb1,k_trb1_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_4(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_5_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_5_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_5_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_5(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_6_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_6_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_6_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_6(d_trb3,k_trb3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_7_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_7_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_7_1_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_7_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_7_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_7_1(d_t2,k_t2_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_7(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_8_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_8_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_8_1_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_8_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_8_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_8_1(d_trb2,k_trb2_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_15_8_2_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_15_8_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_8_2_1(d_trb1,k_trb1_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_15_8_2(d_t2,k_t2_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_15_8(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_15(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_16_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_16_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_16_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_16_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_16_1_1(d_t3,k_t3_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_16_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_16_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_16_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_16_2_1(d_tra3,k_tra3_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_16_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_16(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_17_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_17_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_17_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_17_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_17_1_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_17_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_17_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_17_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_17_2_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_17_2(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_17(d_t3,k_t3_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_18_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_18_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_18_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_18_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_18_1_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_18_1(d_t3,k_t3_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_18_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_18_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_18_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_18_2(d_tra3,k_tra3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_18(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_19_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_19_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_19_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_19_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_1_1(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_1(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_19_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_19_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_2_1(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_2(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_19_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_19_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_3_1(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_3(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_19_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_19_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_4_1(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_19_4(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_19(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_20_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_20_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_20_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_20_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_20_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_20_1(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_20_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_20_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_20_2_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_20_2(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_20(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_21_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_21_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_21_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_21_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_21_1_1(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_21_1(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_21_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_21_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_21_2_1(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_21_2(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_21(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_1_1(d_trb2,k_trb2_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_9_22_1_2(d_trb3,k_trb3_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_1_3_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_1_3_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_1_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,
     &d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_22_1_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_1_3(d_trb1,k_trb1_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_1_4_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_1_4_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_1_4_1(d_trb1,k_trb1_offset,d_y2,k_y2_off
     &set,d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_22_1_4_2(d_trb2,k_trb2_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_1_4(d_t1,k_t1_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_2_1(d_tra1,k_tra1_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_2(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_3_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_3(d_trb3,k_trb3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_4_1(d_tra2,k_tra2_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_9_22_4_2(d_tra3,k_tra3_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_4_3_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_4_3_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_4_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,
     &d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_22_4_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_4_3(d_tra1,k_tra1_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_4_4_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_4_4_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_4_4_1(d_tra1,k_tra1_offset,d_y2,k_y2_off
     &set,d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_22_4_4_2(d_tra2,k_tra2_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_4_4(d_t1,k_t1_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_4(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_5_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_5_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_5_1(d_trb1,k_trb1_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_5(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_6_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_6_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_6_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_6(d_tra3,k_tra3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_7_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_7_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_7_1_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_7_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_7_1_1(d_trb1,k_trb1_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_7_1(d_t2,k_t2_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_7_2_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_7_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_7_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_7_2(d_trb2,k_trb2_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_7(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_8_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_8_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_8_1_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_8_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_8_1_1(d_trb1,k_trb1_offset,d_y2,k_y2_off
     &set,d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_22_8_1_2(d_trb2,k_trb2_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_8_1(d_tra1,k_tra1_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_8_2_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_8_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_8_2_1(d_tra1,k_tra1_offset,d_y2,k_y2_off
     &set,d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_22_8_2_2(d_tra2,k_tra2_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_8_2(d_trb1,k_trb1_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_8(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_9_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_9_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_9_1_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_9_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_9_1_1(d_tra1,k_tra1_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_9_1(d_trb2,k_trb2_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_9_2_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_9_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_9_2_1(d_trb1,k_trb1_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_9_2(d_tra2,k_tra2_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_9(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_10_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_10_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_10_1_1(l_i4_offset,k_i4_offset,si
     &ze_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_10_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_10_1_1(d_tra1,k_tra1_offset,d_y3,k_y3_of
     &fset,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_10_1(d_t2,k_t2_offset,d_i4,k_i4_offset,d
     &_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_22_10_2_1(l_i4_offset,k_i4_offset,si
     &ze_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_22_10_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_10_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset
     &,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_22_10_2(d_tra2,k_tra2_offset,d_i4,k_i4_offs
     &et,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_22_10(d_trb1,k_trb1_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_22(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_23_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_23_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_23_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_23_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_23_1_1(d_trb3,k_trb3_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_23_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_23_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_23_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_23_2_1(d_t3,k_t3_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_23_2(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_23(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_24_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_24_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_24_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_24_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_24_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_24_1(d_trb3,k_trb3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_24_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_24_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_24_2_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_24_2(d_t3,k_t3_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_24(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_25_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_25_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_25_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_25_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_1_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_1(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_25_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_25_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_2_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_2(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_25_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_25_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_3_1(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_3(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_25_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_25_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_4_1(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_25_4(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_25(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_26_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_26_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_26_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_26_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_26_1_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_26_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_26_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_26_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_26_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_26_2(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_26(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_27_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_27_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_27_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_27_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_27_1_1(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_27_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_27_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_27_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_27_2_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_27_2(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_27(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_1_1(d_tra2,k_tra2_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_9_28_1_2(d_tra3,k_tra3_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_1_3_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_1_3_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_1_3_1(d_tra1,k_tra1_offset,d_y2,k_y2_off
     &set,d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_28_1_3_2(d_tra2,k_tra2_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_1_3(d_t1,k_t1_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_1_4_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_1_4_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_1_4_1(d_t1,k_t1_offset,d_y2,k_y2_offset,
     &d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_28_1_4_2(d_t2,k_t2_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_1_4(d_tra1,k_tra1_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_2_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_2(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_3_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_3(d_tra3,k_tra3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_4_1(d_t2,k_t2_offset,d_y2,k_y2_offset,d_
     &i3,k_i3_offset)
      CALL ccsdt_lr_alpha2_9_28_4_2(d_t3,k_t3_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_4_3_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_4_3_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_4_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,
     &d_i4,k_i4_offset)
      CALL ccsdt_lr_alpha2_9_28_4_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_4_3(d_t1,k_t1_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_4(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_5_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_5_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_5_1(d_tra1,k_tra1_offset,d_y2,k_y2_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_5(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_6_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_6_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_6_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_6(d_t3,k_t3_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_7_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_7_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_7_1_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_7_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_7_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_7_1(d_tra2,k_tra2_offset,d_i4,k_i4_offse
     &t,d_i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_7_2_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_7_2_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_7_2_1(d_tra1,k_tra1_offset,d_y3,k_y3_off
     &set,d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_7_2(d_t2,k_t2_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_7(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_8_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_8_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL OFFSET_ccsdt_lr_alpha2_9_28_8_1_1(l_i4_offset,k_i4_offset,siz
     &e_i4)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_28_8_1_1_i4',filename)
      CALL CREATEFILE(filename,d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_8_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,
     &d_i4,k_i4_offset)
      CALL RECONCILEFILE(d_i4,size_i4)
      CALL ccsdt_lr_alpha2_9_28_8_1(d_t2,k_t2_offset,d_i4,k_i4_offset,d_
     &i3,k_i3_offset)
      CALL DELETEFILE(d_i4)
      IF (.not.MA_POP_STACK(l_i4_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_28_8(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_28(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_29_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_29_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_29_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_29_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_29_1_1(d_tra3,k_tra3_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_29_1(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_29_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_29_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_29_2_1(d_trb3,k_trb3_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_29_2(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_29(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_30_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_30_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_30_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_30_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_30_1_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_30_1(d_tra3,k_tra3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_30_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_30_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_30_2_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_30_2(d_trb3,k_trb3_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_30(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_31_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_31_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_31_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_31_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_1_1(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_31_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_31_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_2_1(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_2(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_31_3_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_31_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_3_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_3(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_31_4_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_31_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_4_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_31_4(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_31(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_32_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_32_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_32_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_32_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_32_1_1(d_tra1,k_tra1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_32_1(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_32_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_32_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_32_2_1(d_trb1,k_trb1_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_32_2(d_tra2,k_tra2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_32(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_33_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_33_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_33_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_33_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_33_1_1(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_33_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_33_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_33_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_33_2_1(d_tra2,k_tra2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_33_2(d_trb1,k_trb1_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_33(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k
     &_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_34_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_34_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_9_34_1_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_34_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_34_1_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_
     &i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_34_1(d_trb2,k_trb2_offset,d_i3,k_i3_offset,
     &d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_9_34_2_1(l_i3_offset,k_i3_offset,size_
     &i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_9_34_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_34_2_1(d_trb2,k_trb2_offset,d_y3,k_y3_offse
     &t,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_9_34_2(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2
     &,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_9_34(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_9(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_lr_alpha2_10_1_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_1_1(d_tra3,k_tra3_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_1(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_2_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_2_1(d_trb1,k_trb1_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_2(d_tra3,k_tra3_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_3_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_3_1(d_tra3,k_tra3_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_3(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_4_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_4_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_4(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_5_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_5_1(d_tra2,k_tra2_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_5(d_trb2,k_trb2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_6_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_6_1(d_trb3,k_trb3_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_6(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_7_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_7_1(d_tra1,k_tra1_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_7(d_trb3,k_trb3_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_8_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_8_1(d_trb3,k_trb3_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_8(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_9_1(l_i2_offset,k_i2_offset,size_i2
     &)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_9_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_9(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_10_1(l_i2_offset,k_i2_offset,size_i
     &2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_10_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_10_1(d_trb2,k_trb2_offset,d_y3,k_y3_offset
     &,d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_10(d_tra2,k_tra2_offset,d_i2,k_i2_offset,d
     &_i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_11_1(l_i2_offset,k_i2_offset,size_i
     &2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_11_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_10_11_1_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_11_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_1_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d
     &_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_1(d_trb1,k_trb1_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_11_2_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_11_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_2_1(d_trb1,k_trb1_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_2(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i
     &2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_11_3_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_11_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_3_1(d_trb2,k_trb2_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i
     &2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_11_4_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_11_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_4_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d
     &_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_11_4(d_trb2,k_trb2_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_11(d_tra1,k_tra1_offset,d_i2,k_i2_offset,d
     &_i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_12_1(l_i2_offset,k_i2_offset,size_i
     &2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_12_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_10_12_1_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_12_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_1_1(d_trb2,k_trb2_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_1(d_tra1,k_tra1_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_12_2_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_12_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_2_1(d_tra1,k_tra1_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_2(d_trb2,k_trb2_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_12_3_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_12_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_3_1(d_tra2,k_tra2_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_3(d_trb1,k_trb1_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_12_4_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_12_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_4_1(d_trb1,k_trb1_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_12_4(d_tra2,k_tra2_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_12(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,
     &k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_13_1(l_i2_offset,k_i2_offset,size_i
     &2)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_13_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_lr_alpha2_10_13_1_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_13_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_1_1(d_tra2,k_tra2_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i
     &2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_13_2_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_13_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d
     &_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_2(d_tra2,k_tra2_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_13_3_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_13_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_3_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d
     &_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_3(d_tra1,k_tra1_offset,d_i3,k_i3_offset
     &,d_i2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_10_13_4_1(l_i3_offset,k_i3_offset,size
     &_i3)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_10_13_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_4_1(d_tra1,k_tra1_offset,d_y3,k_y3_offs
     &et,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_lr_alpha2_10_13_4(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i
     &2,k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_lr_alpha2_10_13(d_trb1,k_trb1_offset,d_i2,k_i2_offset,d
     &_i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_10(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i
     &0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      CALL OFFSET_ccsdt_lr_alpha2_11_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_lr_alpha2_11_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_lr_alpha2_11_1(d_tra1,k_tra1_offset,d_v2,k_v2_offset,d_
     &i1,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_lr_alpha2_11(d_trb1,k_trb1_offset,d_i1,k_i1_offset,d_i0
     &,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_lr_alpha2'
     &,-1,MA_ERR)
      RETURN
      END
#endif

      subroutine movecs_project(rtdb, nmo, geom, basis, g_vecs,iset,
     A     calling_module, k_eval)
C$Id: movecs_proj.F 22248 2012-03-29 16:02:37Z edo $
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "global.fh"
#include "inp.fh"
#include "util.fh"
c
      integer rtdb, geom, basis, g_vecs(2), k_eval
      double precision one, zero, mone
c
c     Project the MO vectors in old_basis_name into the current basis.  
c     It is no longer assumed that the old basis is smaller than the current 
c     basis, and it now works when linear dependencies have been removed.
c
c     If nnew > nold
c     --------------
c     For i = 1, nold
c        C_new(u,i) = sum(v,w) S^-1(u,v) Snew-old(v,w) C_old(w,i)
c  
c     For i=nold+1, nnew
c        C_new(u,i) = random number in -0.5,0.5 
c
c     If nold > nnew
c     --------------
c     For i = 1, nnew
c        C_new(u,i) = sum(v,w) S^-1(u,v) Snew-old(v,w) C_old(w,i)
c     
c     S^-1 is the inverse overlap in the new basis
c     Snew-old is the mixed basis overlap
c
c     !! THE RESULTING MOS WILL NOT BE ORTHONORMAL
c
      integer iset ! [in] 1 = alpha 2 =beta
      integer basis_handles(2)
      integer old_nbf, old_nsets, old_nmo(2), file_nbf
      integer g_old_vecs
      integer g_over
      integer g_mix
      integer l_old_occ, k_old_occ, l_old_evals, k_old_evals
      integer l_ran, k_ran
      integer old_basis
      integer nbf, i, j, nmo
      double precision temp
      character*255 old_title,basis_name_from_file,old_basis_name,
     A     old_filename
      character*80 project(2)
      character*20 old_scftype
      character*(*) calling_module
      logical oprint, oprint_info

      logical movecs_read_header, movecs_read
      external movecs_read_header, movecs_read
      integer ga_create_atom_blocked,anggg
      external ga_create_atom_blocked
      integer nbases,dft_nbases
      external dft_nbases
      logical int_normalize
      external int_normalize

      data   one,  zero,  mone ! Because of KSR2 bug?
     $     /1.0d0, 0.0d0, -1.0d0/

      oprint = util_print('mo guess', print_default)
      oprint_info = (ga_nodeid() .eq. 0 .and. oprint)
      
      if (oprint_info) then
         write(6,*)
         call util_print_centered(6,'Orbital projection guess',15,
     $        .true.)
         call util_flush(6)
      endif

*     read in old vectors

      if (.not. rtdb_cget(rtdb, 'vectors:project', 2, project))
     $     call errquit('movecs_project: no file/basis', 0, RTDB_ERR)
      old_basis_name = project(1)
      old_filename   = project(2)
      call util_file_name_resolve(old_filename, .false.)
*
      if (.not. bas_create(old_basis,old_basis_name)) call errquit
     $     ('movecs_project: bas_create', 0, BASIS_ERR)
      if (.not. bas_rtdb_load(rtdb, geom, old_basis, old_basis_name))
     $     call errquit('movecs_project: no old basis?', 0, RTDB_ERR)
      if (.not.int_normalize(rtdb,old_basis))
     $     call errquit('movecs_project: int_normalize failed', 0,
     &       INT_ERR)
      if (.not. movecs_read_header(old_filename, old_title,
     $     basis_name_from_file, old_scftype, 
     $     file_nbf, old_nsets, old_nmo, 2)) 
     $     call errquit
     $     ('movecs_project: failed to read old header', 0, INPUT_ERR)
c
      if (.not. (bas_numbf(basis, nbf))) 
     $     call errquit('movecs project: bas_numbf?', 0, BASIS_ERR)
      if (.not. (bas_numbf(old_basis, old_nbf))) 
     $     call errquit('movecs project: bas_numbf?', 0, BASIS_ERR)
c
      if (nbf .lt. old_nbf) then
          write(6,*) 'The current basis is smaller than the basis',
     $               ' you are projecting from !!!'
c          call errquit
c     $     ('movecs_project: new bas smaller than old bas',0) 
      endif
c
      if (file_nbf .ne. old_nbf) call errquit
     $     ('movecs_project: nbf on file inconsistent with basis', 0,
     &       BASIS_ERR)
c
*ga:1:0
c      if (.not. ga_create(mt_dbl, old_nbf, old_nbf, 'Old vectors',
      if (.not. ga_create(mt_dbl, old_nbf, old_nmo(1), 'Old vectors',
     $     0, 0, g_old_vecs)) call errquit
     $     ('movecs_project: failed creating old vectors', 0, GA_ERR)
      if (.not. ma_push_get(mt_dbl, old_nbf, 'Old occ',
     $     l_old_occ, k_old_occ)) call errquit
     $     ('movecs_project: ma old occ', old_nbf, MA_ERR)
*
      if (.not. movecs_read(old_filename, iset, dbl_mb(k_old_occ),
     $     dbl_mb(k_eval), g_old_vecs)) call errquit
     $     ('movecs_project: failed reading old vectors', 0, INPUT_ERR)
*
      if (oprint_info) then
         write(6,1)
     $        old_filename(1:inp_strlen(old_filename)),
     $        old_title(1:inp_strlen(old_title)),
     $        old_nbf,
     $        old_nsets,
     $        old_nmo(1),
     $        old_basis_name(1:inp_strlen(old_basis_name)),
     $        basis_name_from_file(1:inp_strlen(basis_name_from_file))
 1       format(/
     $        ' Filename           = ',a/
     $        ' Old title          = "',a,'"'/
     $        ' Old basis size     = ', i5/
     $        ' Old no. of sets    = ', i5/
     $        ' Old no. of MOs     = ', i5/
     $        ' Old basis name     = ', a/
     $        ' Basis name on file = ', a/)
         call util_flush(6)
*         write(6,*) ' Old eigen values'
*         call output(dbl_mb(k_old_evals),1,old_nbf,1,1,old_nbf,1,1)
*         write(6,*) ' Old occupations'
*         call output(dbl_mb(k_old_occ),1,old_nbf,1,1,old_nbf,1,1)
      end if
*
      if (.not. ma_pop_stack(l_old_occ)) call errquit
     $     ('movecs_project: ma pop', 0, MA_ERR)

*     Multiply by mixed overlap

      basis_handles(1) = basis
      basis_handles(2) = old_basis

*ga:1:0
      if (.not. ga_create(mt_dbl, nbf, old_nbf, 'Mixed overlap',
     $     0, 0, g_over)) call errquit
     $     ('movecs_project: create mixed overlap', 0, GA_ERR)
*ga:1:0
c      if (.not. ga_create(mt_dbl, nbf, old_nbf, 'Temp',
      if (.not. ga_create(mt_dbl, nbf, old_nmo(1), 'Temp',
     $     0, 0, g_mix)) call errquit
     $     ('movecs_project: create temp', 0, GA_ERR)
      call ga_zero(g_mix)
      call ga_zero(g_over)
      call int_terminate
      call int_init(rtdb,2,basis_handles)
      call int_1e_ga(basis, old_basis, g_over, 'overlap', .false.)
      call int_terminate
      if (.not. bas_high_angular(basis,anggg))
     &   call errquit('rdinput: basis set error:', 0, 0)
      if(calling_module.eq.'dft') then
         nbases=dft_nbases(basis_handles)
         call int_init(rtdb, nbases, basis_handles) !  RIGHT?
      else
         call int_init(rtdb, 1, basis) !  WRONG WRONG WRONG
      endif
      if (.not. bas_destroy(old_basis)) call errquit
     $     ('movecs_project: bas_destroy?',0, BASIS_ERR)

*
*      if (ga_nodeid().eq.0) then
*         call ga_summarize(0)
*         write(6,*) ' nbf, old_nbf, g_over, g_old_vecs, g_mix ',
*     $         nbf, old_nbf, g_over, g_old_vecs, g_mix
*         call util_flush(6)
*      endif
*      call ga_sync
*

c      call ga_dgemm('n','n',nbf,old_nbf,old_nbf,one,g_over,
      call ga_dgemm('n','n',nbf,old_nmo(1),old_nbf,one,g_over,
     $     g_old_vecs,zero,g_mix)
      if (.not. ga_destroy(g_over)) call errquit
     $     ('movecs project: ga_destroy?', 0, GA_ERR)
      if (.not. ga_destroy(g_old_vecs)) call errquit
     $     ('movecs project: ga_destroy?', 0, GA_ERR)

*     Make and invert plain overlap

      g_over = ga_create_atom_blocked(geom, basis, 'Overlap')
*ga:1:0
*      if (.not. ga_create(mt_dbl, nbf, nbf, 'Overlap',
*     $     0, 0, g_over)) call errquit
*     $     ('movecs_project: failed making overlap', 0)
      call ga_zero(g_over)
      call int_1e_ga(basis, basis, g_over, 'overlap', .false.)

      call ga_matpow(g_over, mone, zero)

*     Multiply by inverse overlap

      call ga_zero(g_vecs(iset))

*
*      if (ga_nodeid().eq.0) then
*         call ga_summarize(0)
*         write(6,*) ' nbf, old_nbf, g_over, g_mix, g_vecs ',
*     $         nbf, old_nbf, g_over, g_mix, g_vecs(iset)
*         call util_flush(6)
*      endif
*      call ga_sync
*
      if (old_nmo(1).gt.nmo) old_nmo(1) = nmo
      call ga_dgemm('n','n',nbf,old_nmo(1),nbf,one,g_over,g_mix,
     $     zero,g_vecs(iset))
      if (.not. ga_destroy(g_over)) call errquit
     $     ('movecs project: ga_destroy?', 0, GA_ERR)
      if (.not. ga_destroy(g_mix)) call errquit
     $     ('movecs project: ga_destroy?', 0, GA_ERR)

*     Fill in missing columns with random numbers
      if (nbf.gt.old_nbf) then
      if (.not. ma_push_get(mt_dbl, nbf, 'ran #',
     $     l_ran, k_ran)) call errquit
     $     ('movecs_project: ma ran #', nbf, MA_ERR)
      temp = util_random(ga_nodeid()*314159+1)
c      do i = old_nbf+1+ga_nodeid(), nbf, ga_nnodes()
cbert      do i = old_nbf+1+ga_nodeid(), nmo, ga_nnodes()
       do i = old_nmo(1)+1+ga_nodeid(), nmo, ga_nnodes()
*         write(6,*) ' Randomizing ', i
*         call util_flush(6)
         do j = 1, nbf
            dbl_mb(k_ran+j-1) = (util_random(0) - 0.5d0)
         end do
         call ga_put(g_vecs(iset), 1, nbf, i, i, dbl_mb(k_ran), 1)
      end do
      if (.not. ma_pop_stack(l_ran)) call errquit
     $     ('movecs_project: ma pop?', 0, MA_ERR)
      endif

      end

      subroutine argos_cafe_inita(nat,nap,nqt,nqp)
c
c     argos_cafe_init initializes atom type and charge type information
c
c     in:  nat, integer number of atom types
c          nap, integer number of parameters per atom type
c          nqt, integer number of charge types
c          nqp, integer number of parameters per charge type
c
c     this routine allocates the memory necessary to store all
c     atom type based force field parameters
c
      implicit none
c
      integer nat,nap,nqt,nqp
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      mat=max(1,nat)
      map=max(1,nap)
      mqt=max(1,nqt)
      mqp=max(1,nqp)
c
c     allocate memory
c
c     for the 4 van der Waals parameters (c6,c12,c6t,c12t) 1 : set 1
c                                                          2 : set 2
c                                                          3 : set 3
c                                                          4 : derivative
c                                                          5 : set 1
c                                                          6 : set 2
c
      if(.not.ma_push_get(mt_dbl,mat*mat*map*mset,'vdw',l_vdw,i_vdw))
     + call md_abort('Allocation failed for vdw',0)
c
c     for atomic masses 1 : mass set 1
c                       2 : mass set 2
c                       3 : mass set 3
c                       4 : mass derivative
c                       5 : mass set 1
c                       6 : mass set 2
c
      if(.not.ma_push_get(mt_dbl,mat*mset,'mas',l_mas,i_mas))
     + call md_abort('Allocation failed for mas',0)
c
c     for atom type names 1 : name set 1
c                         2 : name set 2
c                         3 : name set 3
c
      if(.not.ma_push_get(mt_byte,6*mat*nparms,'nam',l_nam,i_nam))
     + call md_abort('Allocation failed for nam',0)
c
c     for atomic numbers  1 : atomic number set 1
c                         2 : atomic number set 2
c                         3 : atomic number set 3
c
      if(.not.ma_push_get(mt_int,mat*nparms,'num',l_num,i_num))
     + call md_abort('Allocation failed for num',0)
c
c     for special type    1 : type in set 1
c                         2 : type in set 2
c                         3 : type in set 3
c
      if(.not.ma_push_get(mt_int,mat*nparms,'typ',l_typ,i_typ))
     + call md_abort('Allocation failed for typ',0)
c
      if(.not.ma_push_get(mt_int,mat*mat,'ias',l_ias,i_ias))
     + call md_abort('Allocation failed for ias',0)
c
c     for charge types
c
      if(.not.ma_push_get(mt_dbl,mqt*mqp*mset,'chg',l_chg,i_chg))
     + call md_abort('Allocation failed for chg',0)
c
      return
      end
c $Id: argos_cafe_inita.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine guess_dens(rtdb, geom, basis, g_dens)
      implicit none
      integer rtdb, geom, basis, g_dens
c
      logical odens
      double precision eatom
c
      odens = .true.
c
      call guess_dens_gen(rtdb, geom, basis, odens, g_dens, eatom)
c
      end
      subroutine guess_dens_gen(rtdb, geom, basis, odens, g_dens, eatom)
C$Id: denat.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
#include "geom.fh"
#include "bas.fh"
#include "cguess.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
#include "rtdb.fh"
#include "atomz.fh"
#include "inp.fh"
#include "stdio.fh"
      integer rtdb              ! Run Time Data Base Handle
      integer geom, basis       ! Handles
      logical odens             ! [input] If true make the density
      integer g_dens            ! GA returns superposition of atomic densities
      double precision eatom    ! returns sum of atomic SCF energies
c
c..   get starting vectors from superposition of atomic densities
c..
c..   routines involved are (all present in this order) :
c..   denat  : general control routine
c..   datoms : translate orbital info, call atomscf , gather d-matrix
c..   atomd,tracd,trafsd,cmergd,oeigd,teigd,densid,denmad, ..
c..   .. hamild,outpud,shalfd,atcond,starcd,creded,pdfded, ..
c..   .. jacod,orderd,tramad
c..   oeigd has been changed to pick up the 1-elec ints
c..   atcond has been changed to allow for effective nuclear charge
c..   creded/pdfded have been adapted to yield directly a d-matrix
crz   xpsnld: implemented for use of non local pseudo potentials
c..
c...  start all types after one cycle closed shell in routine denscf
c
      integer iwrite
      logical oprint_dens, oprint_scf, oprint_ener, oprint_mod_z,spec
      integer l2, iii, iiilen
      integer ntr, nsq
      integer i10, ipcap, iqcap, ifc, ifo, is, iu, it
      integer ih, idc, idos, idt, idold, iss, ic, icopn, ismin
      integer iqmin, itransf, icc, last, memq, l_scr, k_scr
c
      integer ma_type
      character*26 date
c
      data iwrite/6/, oprint_dens/.false./, oprint_scf/.false./
c
      oprint_dens = (odens .and. 
     $     util_print('atomic guess density',print_debug))
      oprint_scf  = util_print('atomic scf', print_debug)
      oprint_ener = util_print('mo guess', print_default)
      oprint_mod_z = util_print('mo guess', print_default)
c
      iwrite = LuOut
      if (ga_nodeid().eq.0 .and. 
     $     (oprint_dens .or. oprint_scf .or. oprint_ener)) then
         write(LuOut,*)
         call util_print_centered(LuOut,
     $        'Superposition of Atomic Density Guess', 23, .true.)
         write(LuOut,*)
      endif
c..
c..    core partitioning
c..
c     allow for maximum of 100 bfns on any given atom
c
      ntr = nb*(nb+1)/2
      l2 = ntr
      nsq = nb * nb
c
c     dynamically allocate memory
c
      call guess_mem(memq)
      if (.not. ma_push_get(mt_dbl, memq,'atomic guess', l_scr, k_scr))
     $     call errquit('guess_dens: ma_push failed', memq, MA_ERR)
      call dfill(memq,0.0d00,dbl_mb(k_scr),1)
c
      i10 = k_scr
      ipcap = i10 + l2
      iqcap = ipcap + ntr
      ifc = iqcap + ntr
      ifo = ifc + ntr
      is = ifo + ntr
      iu = is + ntr
      it = iu + ntr
      ih = it + ntr
      idc = ih + ntr
      idos = idc + ntr
      idt = idos + ntr
      idold = idt + ntr
      iss = idold + ntr
      ic = iss + ntr
c
      icopn = ic + nsq
      ismin = icopn + nsq
      iqmin = ismin + nb * no
      itransf = iqmin + nb * no
      icc = itransf + nsq
      last = icc + nsq
      if ((last - i10) .gt. memq) call errquit
     $     ('guess_dens: memory?', memq, MEM_ERR)
c..
c.. parse data from rtdb about atoms
c..
*      if (.not.rtdb_get(rtdb,'atomscf:num_z',mt_int,1,num_z))
*     &    num_z = 0
c
      if (.not. rtdb_get(rtdb, 'atomscf:special', mt_log, 1, spec))
     $     spec = .false.
c
      if (.not. rtdb_get_info(rtdb, 'atomscf:z', ma_type, num_z, date))
     $     num_z = 0
c
      if (num_z .gt. max_num_z)
     &    call errquit
     &    ('guess_dens: max_num_z < num_z  delta =',(max_num_z-num_z),
     &       UNKNOWN_ERR)
      if (num_z .gt. 0) then
        if (.not.rtdb_get(rtdb,'atomscf:z',mt_dbl,num_z,z))
     &      call errquit('guess_dens: read of atomscf:z failed ',911,
     &       UNKNOWN_ERR)
        if (.not.rtdb_cget(rtdb,'atomscf:tags_z',num_z,tags_z))
     &      call errquit
     &      ('guess_dens: read of atomscf:tag_z failed',911,
     &       INPUT_ERR)
        if (oprint_mod_z.and.(ga_nodeid().eq.0)) then
          do iii = 1,num_z
            iiilen = inp_strlen(tags_z(iii))
            write(luout,'(1x,a,f7.2,a,a)')
     &          'Atomic density modified by a delta charge of',
     &          z(iii),' for atom tag ',
     &          tags_z(iii)(1:iiilen)
          enddo
          write(luout,*)' '
        endif
      endif
c..
c..   now loop over the atoms / do atomic scf and gather d-matrix
c..
      call datoms(geom, basis, dbl_mb(i10),g_dens,oprint_scf,
     +     dbl_mb(ipcap), dbl_mb(iqcap), dbl_mb(ifc), dbl_mb(ifo), 
     $     dbl_mb(is), dbl_mb(iu), 
     +     dbl_mb(it), dbl_mb(ih), dbl_mb(idc), dbl_mb(idos), 
     $     dbl_mb(idt), dbl_mb(idold), dbl_mb(iss) ,
     +     dbl_mb(ic), dbl_mb(icopn), dbl_mb(ismin), dbl_mb(iqmin), 
     $     dbl_mb(itransf), dbl_mb(icc), nb, oprint_ener,
     $     odens, eatom,spec) 
c
c..   print if requested
c
      if (oprint_dens) then
        if (ga_nodeid().eq.0) write (iwrite,6020)
        call ga_print(g_dens)
      endif
c
      if (.not. ma_pop_stack(l_scr))
     $     call errquit('guess_dens: pop_stack failed', 0, MEM_ERR)
c     
      if (util_print('debugatscf',print_never))
     $     call atscf_debug(geom,basis,spec)
c
      return
 6020 format (//30x,28('-'),/,30x,'   initial guess density   ',/,30x,
     +        28('-')//)
      end
      subroutine atscf_debug(geom,basis,spec)
      implicit none
#include "errquit.fh"
      integer geom,basis
      logical spec
#include "geom.fh"
c
      integer nl_out, iat, nat
      integer ncsh_out(4),nosh_out(4),nccup_out(4),nbc_out(4)
      double precision cc_out(2000), energy_out, eps_out(50)
c
      if (.not. geom_ncent(geom, nat)) call errquit('atscf_debug',0,
     &       UNKNOWN_ERR)
      do iat = 1, nat
         call atscf_atomic_scf(geom, basis, iat, .true.,
     $        nl_out, ncsh_out, nosh_out, nccup_out, nbc_out,
     $        cc_out, energy_out, eps_out,spec)
      enddo
c
      end

*
* $Id: dqdbisec.f 19708 2010-10-29 18:04:21Z d3y133 $
*
      SUBROUTINE DQDBISEC( RANGE, N, B1, BN, VL, VU, IL, IU,
     $               L, D, LD, LLD,
     $     ABSTOL, SHIFT, M, W, WLEFT, WRIGHT,
     $               LPLUS,
     $               DPLUS, UMINUS, DMINUS, WORK, IWORK, INFO )
*
*  -- LAPACK routine (version 0.0) -- in progress --
*     January 1996
*
*     .. Scalar Arguments ..
      CHARACTER          RANGE
      INTEGER            N, B1, BN, IL, IU, INFO, M
      DOUBLE PRECISION   VL, VU, ABSTOL, SHIFT
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), L( * ), LD( * ), LLD( * ),
     $                   W( * ), WLEFT( * ), WRIGHT( * ),
     $                   DMINUS( * ), LPLUS( * ), DPLUS( * ),
     $                   UMINUS( * ), WORK( * )
      INTEGER            IWORK( * )
*     ..
*
*  Purpose
*  =======
*
*  DQDBISEC computes the eigenvalues of L * D * L^T by bisection.
*  The inner loops are QD-recurrences that guarantee that the exact
*  eigenvalues of a relatively perturbed matrix are found.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The order of the matrix L * D * L^T.
*
*  B1      (input) INTEGER
*          Starting index of the submatrix (of L * D * L^T).
*
*  BN      (input) INTEGER
*          Last index of the submatrix (of L * D * L^T).
*
*  RANGE   (input) CHARACTER
*          = 'A': ("All")   all eigenvalues will be found.
*          = 'V': ("Value") all eigenvalues in the half-open interval
*                           (VL, VU] will be found.
*          = 'I': ("Index") the IL-th through IU-th eigenvalues (of the
*                           entire matrix) will be found.
*  VL      (input) DOUBLE PRECISION
*  VU      (input) DOUBLE PRECISION
*          If RANGE='V', the lower and upper bounds of the interval to
*          be searched for eigenvalues.  Eigenvalues less than or equal
*          to VL, or greater than VU, will not be returned.  VL < VU.
*          Not referenced if RANGE = 'A' or 'I'.
*
*  IL      (input) INTEGER
*  IU      (input) INTEGER
*          If RANGE='I', the indices (in ascending order) of the
*          smallest and largest eigenvalues to be returned.
*          1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0.
*          Not referenced if RANGE = 'A' or 'V'.
*
*  L       (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) subdiagonal elements of the bidiagonal matrix
*          L, in elements 1 to N-1.  L(N) need not be set.
*
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D.
*
*  LD      (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*D(i).
*
*  LLD     (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*L(i)*D(i).
*
*  ABSTOL  (input) DOUBLE PRECISION
*          Input tolerance.
*
*  M       (output) INTEGER
*          Number of eigenvalues found.
*
*  W       (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalues in ascending order.
*
*  WLEFT   (output) DOUBLE PRECISION array, dimension (N)
*  WRIGHT  (output) DOUBLE PRECISION array, dimension (N)
*          If INFO = 0, the eigenvalue W(I) is contained in
*          [ WLEFT(I), WRIGHT(I) ]
*
*  LPLUS   (workspace) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) subdiagonal elements of L+.
*
*  DPLUS   (workspace) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of D+.
*
*  UMINUS  (workspace) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) superdiagonal elements of U-.
*
*  DMINUS  (workspace) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of D-.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (3*N)
*
*  IWORK   (workspace) INTEGER array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the algorithm failed to converge; i
*                off-diagonal elements of an intermediate tridiagonal
*                form did not converge to zero.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0d+0, ONE = 1.0d+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, KF, KFNEW, KL, KLNEW, firstind,
     $                   NGL, NGU, NLEFT, NMID, NRIGHT, save
      DOUBLE PRECISION   BNRM, DELTA, EPS, GL, GU, LEFT, MID,
     $                   RIGHT, TMP1, TMP2, TMP3, UNFL, STEP,
     $                   TMPD, TMPL, TMPT
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT, ABS
      integer            doprnt1,doprnt2
      common             doprnt1,doprnt2

*     ..
*     .. Executable Statements ..
*

      M = 0
      DELTA = ZERO
      EPS = DLAMCH( 'Precision' )
      UNFL = DLAMCH( 'U' )
      IF( RANGE.EQ.'I' .AND. IL.EQ.B1 .AND. IU.EQ.BN )
     $     RANGE = 'A'
      
      IF( RANGE.EQ.'A') THEN
         IF( B1.EQ.1 ) THEN
            TMP3 = D( B1 )
         ELSE
            TMP3 = LLD( B1-1 ) + D( B1 )
         END IF
         GU = TMP3
         GL = TMP3
         TMP1 = ZERO
*     
         DO I = B1, BN-1
            TMP2 = ABS( LD( I ) )
            GU = MAX( GU, TMP3+TMP1+TMP2 )
            GL = MIN( GL, TMP3-TMP1-TMP2 )
            TMP3 = LLD( I ) + D( I+1 )
            TMP1 = TMP2
         END DO
*     
         GU = MAX( GU, TMP3+TMP1 )
         GL = MIN( GL, TMP3-TMP1 )
         BNRM = MAX( ABS( GL ), ABS( GU ) )
         GL = GL - 2.0d+0*BNRM*EPS*N
         GU = GU + 2.0d+0*BNRM*EPS*N
         NGL = 0
         NGU = N
      ELSE IF( RANGE.EQ.'V' ) THEN
         STEP = 10.0d+0
 112     CONTINUE
         GL = VL
         CALL DDSTQDS( GL, DELTA, N, B1, BN, L, D, LD,
     $        LPLUS, DPLUS, WORK )
         NGL = 0
         DO I = B1, BN
            IF( DPLUS( I ).LT.ZERO ) NGL = NGL + 1
         END DO
         
*     CALL DDQDS( GL, DELTA, N, B1, BN, L, D, LLD,
*     $                  UMINUS, DMINUS, WORK )
*     NGL = 0
*     DO I = B1, BN
*     IF( DMINUS( I ).LT.ZERO ) NGL = NGL + 1
*     END DO
         IF( NGL.GT.IL-1 ) THEN
            VL = VL - STEP * EPS * ABS( SHIFT )
            STEP = STEP * 10.0d+0
            GO TO 112
         ELSE IF( NGL.LT.IL-1 ) THEN
            print *,"NGL too small! NGL,IL = ",NGL,IL
            stop
         END IF
         
         STEP = 10.0d+0
 113     CONTINUE
         GU = VU
         CALL DDSTQDS( GU, DELTA, N, B1, BN, L, D, LD,
     $        LPLUS, DPLUS, WORK )
         NGU = 0
         DO I = B1, BN
            IF( DPLUS( I ).LT.ZERO ) NGU = NGU + 1
         END DO
         
*     CALL DDQDS( GU, DELTA, N, B1, BN, L, D, LLD,
*     $                  UMINUS, DMINUS, WORK )
*     NGU = 0
*     DO I = B1, BN
*     IF( DMINUS( I ).LT.ZERO ) NGU = NGU + 1
*     END DO
         IF( NGU.LT.IU ) THEN
            VU = VU + STEP * EPS * ABS( SHIFT )
            STEP = STEP * 10.0d+0
            GO TO 113
         ELSE IF( NGU.GT.IU ) THEN
            print *,"NGU too big! NGU,IU = ",NGU,IU
            stop
         END IF
         
         IF( NGL.GE.NGU ) THEN
            PRINT *,"NGL = ",NGL," should be smaller than NGU = ",NGU
            stop
         END IF
      END IF
      
      WORK( 1 ) = GL
      WORK( 2 ) = GU
      IWORK( 1 ) = NGL
      IWORK( 2 ) = NGU
      KF = 1
      KL = 1
110   CONTINUE
      IF( KL.GE.KF ) THEN
          KFNEW = KF
          KLNEW = KL
          DO I = KF, KL
             LEFT = WORK( 2*I-1 )
             RIGHT = WORK( 2*I )
             NLEFT = IWORK( 2*I-1 )
             NRIGHT = IWORK( 2*I )
             IF( RIGHT-LEFT.LE.MAX( MAX( 4.0d+0*EPS*MAX( ABS( LEFT ),
     $                    ABS( RIGHT ) ), UNFL ), ABSTOL ) ) THEN
                 IF( I.GT.KFNEW ) THEN
                     WORK( 2*I-1 ) = WORK( 2*KFNEW-1 )
                     WORK( 2*I ) = WORK( 2*KFNEW )
                     IWORK( 2*I-1 ) = IWORK( 2*KFNEW-1 )
                     IWORK( 2*I ) = IWORK( 2*KFNEW )
                     WORK( 2*KFNEW-1 ) = LEFT
                     WORK( 2*KFNEW ) = RIGHT
                     IWORK( 2*KFNEW-1 ) = NLEFT
                     IWORK( 2*KFNEW ) = NRIGHT
                 END IF
                 KFNEW = KFNEW + 1
             ELSE
                 MID = ( LEFT + RIGHT ) / 2.0d+0
                 NMID = 0

*                CALL DDSTQDS( MID, DELTA, N, B1, BN, L, D, LD,
*    $                         LPLUS, DPLUS, WORK( 2*N+1 ) )

                 IF( B1.EQ.1 ) THEN
                    TMPT = -MID
                 ELSE
                    TMPT = LLD( B1-1 ) - MID
                 END IF
                 DO J = B1, BN-1
                    TMPD = D( J ) + TMPT
                    IF( ( TMPD.LT.ZERO ).OR.( (TMPD.EQ.ZERO)
     $                 .AND. (ONE/TMPD.LT.ZERO) ) ) NMID = NMID + 1
                    TMPL = LD( J ) / TMPD
                    TMPT = TMPT * TMPL * L( J ) - MID
                 END DO
                 TMPD = D( BN ) + TMPT
                 IF( ( TMPD.LT.ZERO ).OR.( (TMPD.EQ.ZERO)
     $              .AND. (ONE/TMPD.LT.ZERO)) ) NMID = NMID + 1

                 IF(.NOT.( ( TMPD.GT.ZERO ) .OR.
     $                     ( TMPD.LT.ONE ) ) ) THEN
                    NMID = 0
                    IF( B1.EQ.1 ) THEN
                       TMPT = -MID
                    ELSE
                       TMPT = LLD( B1-1 ) - MID
                    END IF
                    DO J = B1, BN-1
                       TMPD = D( J ) + TMPT
                       IF( ( TMPD.LT.ZERO ).OR.( (TMPD.EQ.ZERO)
     $                    .AND. (ONE/TMPD.LT.ZERO)) ) NMID = NMID + 1
                       TMPL = LD( J ) / TMPD
*
*                      Need to check the next few lines
*
                       IF(TMPL.EQ.0 .AND. ONE/TMPT.EQ.ZERO ) THEN
                          TMPT = LLD( J ) - MID
                       ELSE IF( TMPT.EQ.ZERO .AND. ONE/TMPL.EQ.0 ) THEN
                          TMPT = -ONE / TMPD
                       ELSE
                          TMPT = TMPT * TMPL * L( J ) - MID
                       END IF
                    END DO
                    TMPD = D( BN ) + TMPT
                    IF( ( TMPD.LT.ZERO ).OR.( (TMPD.EQ.ZERO)
     $                 .AND. (ONE/TMPD.LT.ZERO)) ) NMID = NMID + 1
                 END IF

                 IF(.NOT.( ( TMPD.GT.ZERO ) .OR.
     $                     ( TMPD.LT.ONE ) ) ) THEN
                    print *,"DQDBISEC : NaN detected! Aborting!"
                    stop
                 END IF

                 if( nmid.lt.nleft .or. nmid.gt.nright) then
                    print *,"Count is nonmonotonic. Check!"
                    print *,"left,right,nleft,nright=",left,right,
     $                       nleft,nright
                    print *,"mid,nmid = ",mid,nmid
                    print *,"dplus = [ "
                    do j = b1,bn
                      write(*,101) dplus(j)
                    end do
                    print *,"];"
                    print *,"lplus = [ "
                    do j = b1,bn-1
                      write(*,101) lplus(j)
                    end do
                    print *,"];"
                    print *,"t  = [ "
                    do j = b1,bn
                      write(*,101) work(2*n+j)
                    end do
                    print *,"];"
*                   stop
                 end if
                 NMID = MAX( MIN( NRIGHT, NMID ), NLEFT )
                 IF( NMID.GT.NLEFT .AND. NMID.LT.NRIGHT ) THEN
                     WORK( 2*I ) = MID
                     IWORK( 2*I ) = NMID
                     KLNEW = KLNEW + 1
                     WORK( 2*KLNEW-1 ) = MID
                     IWORK( 2*KLNEW-1 ) = NMID
                     WORK( 2*KLNEW ) = RIGHT
                     IWORK( 2*KLNEW ) = NRIGHT
                 ELSE IF( NMID.GT.NLEFT ) THEN
                     WORK( 2*I ) = MID
                     IWORK( 2*I ) = NMID
                 ELSE IF( NMID.LT.NRIGHT ) THEN
                     WORK( 2*I-1 ) = MID
                     IWORK( 2*I-1 ) = NMID
                 END IF
             END IF
          END DO
          KF = KFNEW
          KL = KLNEW
          GO TO 110
      END IF
*
*     Sort the eigenvalues
*
      DO I = 1,KL
         DO J = IWORK( 2*I-1 )+1, IWORK( 2*I )
            W( J ) = ( WORK( 2*I-1 )+WORK( 2*I ) ) / 2.0d+0
            WLEFT( J ) = WORK( 2*I-1 )
            WRIGHT( J ) = WORK( 2*I )
            M = M + 1
         END DO
      END DO


      RETURN
101   format (E22.14)
102   format (E22.14,E22.14)
103   format (E22.14,E22.14,E22.14)
*
*     End of DQDBISEC
*
      END

      subroutine argos_cafe_dss(xs,xsm,ps,psp,ismf,isml,isq2,isq3,
     + isfrom,nums,
     + lpbc,chg,lssndx,lssjpt,lssin,lssj,xi,xj,rwc,rwi1,rwi2,rwi6,
     + rwx,rw,fi,fj,f,isal,jsal,jmal,jfal,pl,pj)
c
c $Id: argos_cafe_dss.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      real*8 xs(msa,3),xsm(msm,3),ps(msa,3,2),psp(msa,3,2,2)
      integer ismf(msa),isml(msa),isq2(msa),isq3(msa)
      integer isfrom,nums
      logical lpbc
      real*8 chg(mqt,mqp,mset)
      integer lssndx(0:msa,2),lssjpt(nums,2),lssin(nums,2)
c
      real*8 xi(mscr,3),xj(mscr,3),rwx(mscr,3),rwi1(mscr)
      real*8 rwi2(mscr),rwi6(mscr),rwc(mscr,3),rw(mscr)
      real*8 f(mscr),fi(mscr,3),fj(mscr,3),pl(mscr,3),pj(mscr,3)
      integer isal(mscr),jsal(mscr),jmal(mscr),jfal(mscr)
      integer lssj(*)
c
      integer isa,jsa,jsf,ipset
      integer isfr,nsslen(2)
      integer ipss,number,isslen,nax,nax2,jsaptr
      integer jnum,lssptr,iax,ism,jsm
c
      real*8 ri1,ri2,ri3,rx,ry,rz,pix,piy,piz,pjx,pjy,pjz,rmi,rmj
      real*8 qai,pai,qaj,paj
c
#include "bitops.fh"
c
      real*8 qfaci
c
      qfaci=one/qfac
c
c     solute non-bonded pairs
c     =======================
c
      isfr=isfrom-1
c
c     loop over both short and long range pairlists
c
      do 1 ipss=1,npss
c
c     evaluate outer index array
c
      nsslen(ipss)=0
      lssndx(0,ipss)=0
      number=0
      do 2 isa=1,nums
      if(number+lssin(isa,ipss).gt.mscr .or.
     + (ismf(isfr+isa).ne.ismf(isfr+isa-1).and.number.gt.0)) then
      nsslen(ipss)=nsslen(ipss)+1
      lssndx(nsslen(ipss),ipss)=isa-1
      number=0
      endif
      number=number+lssin(isa,ipss)
    2 continue
      if(number.gt.0) then
      nsslen(ipss)=nsslen(ipss)+1
      lssndx(nsslen(ipss),ipss)=nums
      endif
c
c     loop over number of cycles to complete pairlists
c
      do 3 isslen=1,nsslen(ipss)
      nax=0
      ism=isml(isfr+lssndx(isslen,ipss))
c
c     collect coordinates into workarrays
c
c      if(npbtyp.eq.0) then
      do 4 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      ism=isml(isfr+isa)
      if(lpbc) then
      do 151 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      rwc(nax+jnum,1)=xs(isfr+isa,1)-xs(lssptr,1)
      rwc(nax+jnum,2)=xs(isfr+isa,2)-xs(lssptr,2)
      rwc(nax+jnum,3)=xs(isfr+isa,3)-xs(lssptr,3)
  151 continue
      call argos_cafe_pbc(0,rwc,mscr,rwx,mscr,nax,1,lssin(isa,ipss))
      endif
      do 5 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      jsf=ismf(lssptr)
      isal(nax+jnum)=isfr+isa
      jsal(nax+jnum)=lssptr
      jmal(nax+jnum)=jsf
      jsm=isml(lssptr)
      jfal(nax+jnum)=2
      if(ism.ne.jsm) jfal(nax+jnum)=3
      if(ism.gt.0) then
      if(jsm.gt.0) then
      rwc(nax+jnum,1)=xsm(ism,1)-xsm(jsm,1)
      rwc(nax+jnum,2)=xsm(ism,2)-xsm(jsm,2)
      rwc(nax+jnum,3)=xsm(ism,3)-xsm(jsm,3)
      else
      rwc(nax+jnum,1)=xsm(ism,1)-xs(lssptr,1)
      rwc(nax+jnum,2)=xsm(ism,2)-xs(lssptr,2)
      rwc(nax+jnum,3)=xsm(ism,3)-xs(lssptr,3)
      endif
      else
      if(jsm.gt.0) then
      rwc(nax+jnum,1)=xs(isfr+isa,1)-xsm(jsm,1)
      rwc(nax+jnum,2)=xs(isfr+isa,2)-xsm(jsm,2)
      rwc(nax+jnum,3)=xs(isfr+isa,3)-xsm(jsm,3)
      else
      rwc(nax+jnum,1)=xs(isfr+isa,1)-xs(lssptr,1)
      rwc(nax+jnum,2)=xs(isfr+isa,2)-xs(lssptr,2)
      rwc(nax+jnum,3)=xs(isfr+isa,3)-xs(lssptr,3)
      endif
      endif
    5 continue
      if(.not.lpbc) then
      do 7 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      xi(nax+jnum,1)=xs(isfr+isa,1)
      xi(nax+jnum,2)=xs(isfr+isa,2)
      xi(nax+jnum,3)=xs(isfr+isa,3)
      xj(nax+jnum,1)=xs(lssptr,1)
      xj(nax+jnum,2)=xs(lssptr,2)
      xj(nax+jnum,3)=xs(lssptr,3)
      pl(nax+jnum,1)=ps(isfr+isa,1,2)
      pl(nax+jnum,2)=ps(isfr+isa,2,2)
      pl(nax+jnum,3)=ps(isfr+isa,3,2)
      pj(nax+jnum,1)=ps(lssptr,1,2)
      pj(nax+jnum,2)=ps(lssptr,2,2)
      pj(nax+jnum,3)=ps(lssptr,3,2)
      isal(nax+jnum)=isfr+isa
      jsal(nax+jnum)=lssptr
    7 continue
      else
      do 8 jnum=1,lssin(isa,ipss)
      rwc(nax+jnum,1)=rwc(nax+jnum,1)-rwx(jnum,1)
      rwc(nax+jnum,2)=rwc(nax+jnum,2)-rwx(jnum,2)
      rwc(nax+jnum,3)=rwc(nax+jnum,3)-rwx(jnum,3)
      lssptr=lssj(jsaptr+jnum)
      xi(nax+jnum,1)=xs(isfr+isa,1)
      xi(nax+jnum,2)=xs(isfr+isa,2)
      xi(nax+jnum,3)=xs(isfr+isa,3)
      xj(nax+jnum,1)=xs(lssptr,1)+rwx(jnum,1)
      xj(nax+jnum,2)=xs(lssptr,2)+rwx(jnum,2)
      xj(nax+jnum,3)=xs(lssptr,3)+rwx(jnum,3)
      pl(nax+jnum,1)=ps(isfr+isa,1,2)
      pl(nax+jnum,2)=ps(isfr+isa,2,2)
      pl(nax+jnum,3)=ps(isfr+isa,3,2)
      pj(nax+jnum,1)=ps(lssptr,1,2)
      pj(nax+jnum,2)=ps(lssptr,2,2)
      pj(nax+jnum,3)=ps(lssptr,3,2)
      isal(nax+jnum)=isfr+isa
      jsal(nax+jnum)=lssptr
    8 continue
      endif
      nax=nax+lssin(isa,ipss)
    4 continue
c      else
c      do 8 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
c      jsaptr=lssjpt(isa,ipss)-1
c      ism=isl(isfr+isa,lsmol)
c      do 9 jnum=1,lssin(isa,ipss)
c      lssptr=lssj(jsaptr+jnum)
c      jsa=lssptr
c      rwx(jnum,1)=zero
c      rwx(jnum,2)=zero
c      rwx(jnum,3)=zero
c      if(abs(xs(isfr+isa,1)-xs(jsa,1)).gt.boxh(1)) then
c      rwx(jnum,1)=sign(box(1),xs(isfr+isa,1))
c      endif
c      if(abs(xs(isfr+isa,2)-xs(jsa,2)).gt.boxh(2)) then
c      rwx(jnum,2)=sign(box(2),xs(isfr+isa,2))
c      endif
c      if(npbtyp.eq.1) then
c      if(abs(xs(isfr+isa,3)-xs(jsa,3)).gt.boxh(3)) then
c      rwx(jnum,3)=sign(box(3),xs(isfr+isa,3))
c      endif
c      endif
c      jsf=isl(lssptr,lsfrc)
c      isal(nax+jnum)=isfr+isa
c      jsal(nax+jnum)=lssptr
c      jmal(nax+jnum)=jsf
c      jsm=isl(lssptr,lsmol)
c      jfal(nax+jnum)=2
c      if(ism.ne.jsm) jfal(nax+jnum)=3
c      if(ism.gt.0) then
c      if(jsm.gt.0) then
c      rwc(nax+jnum,1)=xsm(ism,1)-xsm(jsm,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xsm(ism,2)-xsm(jsm,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xsm(ism,3)-xsm(jsm,3)-rwx(jnum,3)
c      else
c      rwc(nax+jnum,1)=xsm(ism,1)-xs(lssptr,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xsm(ism,2)-xs(lssptr,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xsm(ism,3)-xs(lssptr,3)-rwx(jnum,3)
c      endif
c      else
c      if(jsm.gt.0) then
c      rwc(nax+jnum,1)=xs(isfr+isa,1)-xsm(jsm,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xs(isfr+isa,2)-xsm(jsm,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xs(isfr+isa,3)-xsm(jsm,3)-rwx(jnum,3)
c      else
c      rwc(nax+jnum,1)=xs(isfr+isa,1)-xs(lssptr,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xs(isfr+isa,2)-xs(lssptr,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xs(isfr+isa,3)-xs(lssptr,3)-rwx(jnum,3)
c      endif
c      endif
c    9 continue
c      do 11 jnum=1,lssin(isa,ipss)
c      lssptr=lssj(jsaptr+jnum)
c      xi(nax+jnum,1)=xs(isfr+isa,1)
c      xi(nax+jnum,2)=xs(isfr+isa,2)
c      xi(nax+jnum,3)=xs(isfr+isa,3)
c      xj(nax+jnum,1)=xs(lssptr,1)+rwx(jnum,1)
c      xj(nax+jnum,2)=xs(lssptr,2)+rwx(jnum,2)
c      xj(nax+jnum,3)=xs(lssptr,3)+rwx(jnum,3)
c      pl(nax+jnum,1)=ps(isfr+isa,1,2)
c      pl(nax+jnum,2)=ps(isfr+isa,2,2)
c      pl(nax+jnum,3)=ps(isfr+isa,3,2)
c      pj(nax+jnum,1)=ps(lssptr,1,2)
c      pj(nax+jnum,2)=ps(lssptr,2,2)
c      pj(nax+jnum,3)=ps(lssptr,3,2)
c   11 continue
c      nax=nax+lssin(isa,ipss)
c    8 continue
c      endif
c
      do 12 iax=1,nax
      isa=isal(iax)
      jsa=jsal(iax)
      if(jfal(iax).eq.2) then
      qai=qfaci*chg(isq2(isa),1,iset)
      pai=chg(isq2(isa),2,iset)
      qaj=qfaci*chg(isq2(jsa),1,iset)
      paj=chg(isq2(jsa),2,iset)
      else
      qai=qfaci*chg(isq3(isa),1,iset)
      pai=chg(isq3(isa),2,iset)
      qaj=qfaci*chg(isq3(jsa),1,iset)
      paj=chg(isq3(jsa),2,iset)
      endif
      rx=xj(iax,1)-xi(iax,1)
      ry=xj(iax,2)-xi(iax,2)
      rz=xj(iax,3)-xi(iax,3)
      ri2=one/(rx*rx+ry*ry+rz*rz)
      ri1=sqrt(ri2)
      ri3=ri1*ri2
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1)
      pjy=paj*pj(iax,2)
      pjz=paj*pj(iax,3)
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1)=((rmi+qai)*rx-pix)*ri3
      fj(iax,2)=((rmi+qai)*ry-piy)*ri3
      fj(iax,3)=((rmi+qai)*rz-piz)*ri3
   12 continue
c
c     accumulate fields into solute field arrays
c
      iax=0
      do 13 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      do 14 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      ps(isfr+isa,1,1)=ps(isfr+isa,1,1)+fi(iax+jnum,1)
      ps(isfr+isa,2,1)=ps(isfr+isa,2,1)+fi(iax+jnum,2)
      ps(isfr+isa,3,1)=ps(isfr+isa,3,1)+fi(iax+jnum,3)
      ps(lssptr,1,1)=ps(lssptr,1,1)+fj(iax+jnum,1)
      ps(lssptr,2,1)=ps(lssptr,2,1)+fj(iax+jnum,2)
      ps(lssptr,3,1)=ps(lssptr,3,1)+fj(iax+jnum,3)
   14 continue
      iax=iax+lssin(isa,ipss)
   13 continue
c
c     thermodynamic integration and perturbation
c
      do 15 ipset=2,3
      if((ipset.eq.2.and.ipert2).or.
     + (ipset.eq.3.and.ipert3)) then
c
      nax2=0
      do 16 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      do 17 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      pl(nax2+jnum,1)=psp(isfr+isa,1,ipset-1,2)
      pl(nax2+jnum,2)=psp(isfr+isa,2,ipset-1,2)
      pl(nax2+jnum,3)=psp(isfr+isa,3,ipset-1,2)
      pj(nax2+jnum,1)=psp(lssptr,1,ipset-1,2)
      pj(nax2+jnum,2)=psp(lssptr,2,ipset-1,2)
      pj(nax2+jnum,3)=psp(lssptr,3,ipset-1,2)
   17 continue
      nax2=nax2+lssin(isa,ipss)
   16 continue
c
      if(nax2.ne.nax) call md_abort('Error in dips',me)
c
      do 18 iax=1,nax
      isa=isal(iax)
      jsa=jsal(iax)
      if(jfal(iax).eq.2) then
      qai=qfaci*chg(isq2(isa),1,ipset)
      pai=chg(isq2(isa),2,ipset)
      qaj=qfaci*chg(isq2(jsa),1,ipset)
      paj=chg(isq2(jsa),2,ipset)
      else
      qai=qfaci*chg(isq3(isa),1,ipset)
      pai=chg(isq3(isa),2,ipset)
      qaj=qfaci*chg(isq3(jsa),1,ipset)
      paj=chg(isq3(jsa),2,ipset)
      endif
      rx=xj(iax,1)-xi(iax,1)
      ry=xj(iax,2)-xi(iax,2)
      rz=xj(iax,3)-xi(iax,3)
      ri2=one/(rx*rx+ry*ry+rz*rz)
      ri1=sqrt(ri2)
      ri3=ri1*ri2
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1)
      pjy=paj*pj(iax,2)
      pjz=paj*pj(iax,3)
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1)=((rmi+qai)*rx-pix)*ri3
      fj(iax,2)=((rmi+qai)*ry-piy)*ri3
      fj(iax,3)=((rmi+qai)*rz-piz)*ri3
   18 continue
c
c     accumulate fields into solute field arrays
c
      iax=0
      do 19 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      do 20 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      psp(isfr+isa,1,ipset-1,1)=psp(isfr+isa,1,ipset-1,1)+fi(iax+jnum,1)
      psp(isfr+isa,2,ipset-1,1)=psp(isfr+isa,2,ipset-1,1)+fi(iax+jnum,2)
      psp(isfr+isa,3,ipset-1,1)=psp(isfr+isa,3,ipset-1,1)+fi(iax+jnum,3)
      psp(lssptr,1,ipset-1,1)=psp(lssptr,1,ipset-1,1)+fj(iax+jnum,1)
      psp(lssptr,2,ipset-1,1)=psp(lssptr,2,ipset-1,1)+fj(iax+jnum,2)
      psp(lssptr,3,ipset-1,1)=psp(lssptr,3,ipset-1,1)+fj(iax+jnum,3)
   20 continue
      iax=iax+lssin(isa,ipss)
   19 continue
c
      endif
   15 continue
    3 continue
    1 continue
c
      return
      end

      subroutine argos_cafe_proper(vol,tmp,tmpw,tmps,prs,tsw,tss,psc,
     + ewkin,nwwl,nwws,nswl,nsws,nssl,nsss,nshw,nshs,ept2,ept3,
     + ep2m,ep3m,edistr,epomef,vir,prest,virt,ekct,ubiasi,pmfu)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      real*8 vol,tmp,tmpw,tmps,prs,tsw,tss,psc,ewkin,ept2,ept3
      real*8 edistr,epomef,vir,ubiasi,ep2m,ep3m
      real*8 prest(3,3),virt(3,3),ekct(3,3),pmfu(100)
      integer nwwl,nwws,nswl,nsws,nssl,nsss,nshw,nshs
c
      integer i,j
c
      vol=volume
      tmp=temp
      tmpw=tempw
      tmps=temps
      prs=pres
      tsw=scalew
      tss=scales
      psc=pscale
      vir=virial
c
      ewkin=ewk
c
      nwwl=llww
      nwws=lsww
      nswl=llsw
      nsws=lssw
      nssl=llss
      nsss=lsss
c
      nshw=niterw
      nshs=niters
c
      ept2=ep2(1)
      ept3=ep3(1)
      ep2m=ep2(3)
      ep3m=ep3(3)
c
      edistr=edrs
      epomef=epmf
c
      ubiasi=ubias
c
      do 1 i=1,3
      do 2 j=1,3
      prest(i,j)=prx(i,j)
      virt(i,j)=z(i,j)
      ekct(i,j)=ekc(i,j)
    2 continue
    1 continue
c
      if(npmfi.gt.0) then
      do 3 i=1,npmfi
      pmfu(i)=dbl_mb(i_upmf+i-1)
    3 continue
      endif
c
      return
      end
c $Id: argos_cafe_proper.F 21176 2011-10-10 06:35:49Z d3y133 $

* $Id: memoha.F 24347 2013-06-23 04:26:26Z d3y133 $
c====================================================================
c kw Feb. 18,1994
c there is the new subroutine memo5 (memory handling for pairs)
c
c====================================================================
c    Memory handling subroutines for 2-electron integrals program
c
c====================================================================
      subroutine memo1_int(namount,iaddress)
      common /cpu/ intsize,iacc,icache,memreal
c
      needed=namount
      if(intsize.ne.1) needed=namount/intsize+1 
      call getmem(needed,iaddress)
c
      end
c====================================================================
      subroutine memo2(nbloks)
      common /cpu/ intsize,iacc,icache,memreal
      common /memor2/ nqrtd, nibld,nkbld, nijbd,nijed, nklbd,nkled
c
      ndim=nbloks
      if(intsize.ne.1) ndim=ndim/intsize+1
c
      call getmem(ndim,nqrtd)     ! for nqrt array
      call getmem(ndim,nibld)     ! for nibl array
      call getmem(ndim,nkbld)     ! for nkbl array
      call getmem(ndim,nijbd)     ! for nijb array
      call getmem(ndim,nijed)     ! for nije array
      call getmem(ndim,nklbd)     ! for nklb array
      call getmem(ndim,nkled)     ! for nkle array
c
      return
      end
c====================================================================
      subroutine memo3(maxqrt)
      common /cpu/ intsize,iacc,icache,memreal
      common /memor3/ nblok1d
      common /memors/ nsym,ijshp,isymm
c
c--------------------------------------------------
      ndim=maxqrt*2
      if(intsize.ne.1) ndim=ndim/intsize+1
c
      call getmem(ndim,nblok1d)      ! for nblok1(2,*)
      call getmem(maxqrt,isymm)      ! for isymm(*)
c--------------------------------------------------
c     call memo1_int(maxqrt*2, nblok1d)  ! for nblok1(2*maxqrt) 
c     call memo1_int(maxqrt  , nsymm  )  ! for symm(maxqrt) 
c--------------------------------------------------
      end
c********
      subroutine memo4a(bl, nbls, l11,l12,mem2,igmcnt)
      double precision bl(*)
c nmr deriv
      character*11 scftype
      character*8 where
      common /runtype/ scftype,where
c--
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
c
#include "texas_lpar.fh"     
c
      COMMON/SHELL/LSHELLT,LSHELIJ,LSHELKL,LHELP,LCAS2(4),LCAS3(4)
      common /memor4/ iwt0,iwt1,iwt2,ibuf,ibuf2,
     * ibfij1,ibfij2,ibfkl1,ibfkl2,
     * ibf2l1,ibf2l2,ibf2l3,ibf2l4,ibfij3,ibfkl3,
     * ibf3l,issss,
     * ix2l1,ix2l2,ix2l3,ix2l4,ix3l1,ix3l2,ix3l3,ix3l4,
     * ixij,iyij,izij, iwij,ivij,iuij,isij
c
      common /memor4a/ ibf3l1,ibf3l2,ibf3l3,ibf3l4
c
c dimensions for assembling :
      common /dimasse/ lqij,lqkl,lqmx,lij3,lkl3,l3l,lsss
c dimensions for a.m.shifting :
c     common /dimamsh/ 
c
C************************************************************
cxxx  DATA LENSM/1,4,10,20,35,56,84,120,165,220,286,364,455,560,680/
C*******  UP TO: S P D F G H I J K L M N O P Q *******
C     LENSM(NSIJ)=TOTAL NUMBER OF FUNCTIONS UP TO GIVEN NSIJ
C************************************************************
c---------------------------------------------------------------------
c  dimensions for assembling :
c  buf2(nbls,lnij,lnkl), bfij1(nbls,lqij,lnkl), bfkl1(nbls,lnij,lqkl)
c                        bfij2(nbls,lqij,lnkl), bfkl2(nbls,lnij,lqkl)
c                        bfij3(nbls,lij3,lnkl), bfkl3(nbls,lnij,lkl3)
c
c                        bf2l1(nbls,lqij,lqkl), bf2l2(nbls,lqij,lqkl)
c                        bf2l3(nbls,lqij,lqkl), bf2l4(nbls,lqij,lqkl)
c
c                        bf3l1(nbls,l3l ,lqmx), bf3l2(nbls,l3l ,lqmx)
c                        bf3l3(nbls,lqmx,l3l ), bf3l4(nbls,lqmx,l3l )
c
c                         ssss(nbls,lsss,lsss)
c---------------------------------------------------------------------
c
       lqij=nfu(nqij +1)
       lqkl=nfu(nqkl +1)
       lij3=1
       lkl3=1
       l3l =1
       lsss=1
       if(where.eq.'shif' .or. where.eq.'forc') then
          lqij=nfu(nqij1+1)
          lqkl=nfu(nqkl1+1)
          if(lshellt.gt.1) then
            lij3=4
            lkl3=4
          endif
          if(lshellt.gt.2) l3l =4
          if(lshellt.gt.3) lsss=4
       endif
       lqmx=max( lqij,lqkl )
c
c---------------------------------------------------------------------
c l11,l12,mem2 are not used for mmax.le.2 (psss)
c
       l11=1
       l12=1
       mem2=1
c---------------------------------------------------------------------
c
c* initiate all addresses :
c for trobsa :
       iwt0=1
       iwt1=1
       iwt2=1
c for assemble :
       ibuf=1
       ibuf2=1
       ibfij1=1
       ibfij2=1
       ibfkl1=1
       ibfkl2=1
       ibf2l1=1
       ibf2l2=1
       ibf2l3=1
       ibf2l4=1
       ibfij3=1
       ibfkl3=1
       ibf3l=1
c
c      ibf3l1=ibf3l
c
       ibf3l1=1
       ibf3l2=1
       ibf3l3=1
       ibf3l4=1
c
       issss=1
c
      mem0=lnij*lnkl
c
C******************************************************
c       Memory for "assemble"
c
c ------------------------------------------
c
c gen.contr.
      ngcijkl=(ngci+1)*(ngcj+1)*(ngck+1)*(ngcl+1)
      nblsg=nbls*ngcijkl
c
ccccc if(where.ne.'shif' .and. where.ne.'forc') then
      if(where.eq.'buff') then
        call getmem_zero(bl,nblsg*lnijkl,ibuf)  ! for buf(nbls,lnijkl)    ZERO
        call getmem_zero(bl,nblsg*mem0,ibuf2)  ! for buf2(nbls,lnij,lnkl) ZERO
      endif
      if(where.eq.'shif') then
c     - for nmr derivatives -
        call getmem(7*nblsg*lnijkl,ibuf)  ! for buf(nbls,lnijkl)
        ixxx=nblsg*mem0 + 6*nblsg*nfu(nsij)*nfu(nskl)
        call getmem(ixxx      ,ibuf2)  ! for buf2(nbls,lnij,lnkl)
      endif
      if(where.eq.'forc') then
c     memory allocated for ibuf will be used twice : first for
c     assembling (instead of buf2) and then for final derivatives.
c     For ibuf allocate maximum of :
        iyyy=nblsg*max(9*lnijkl,4*mem0) 
c     and for ibuf2 :
        ixxx=               10*nblsg*nfu(nsij)*nfu(nskl)
c     instead of ixxx=4*nblsg*mem0 + 10*nblsg*nfu(nsij)*nfu(nskl)
c
c 4*nblsg*mem0 is probably ALWAYS greater than 9*nblsg*lnijkl
c
c 4 comes from : ordinary contraction 
c              + rescaled contrac. with 2*expA
c              + rescaled contrac. with 2*expB
c              + rescaled contrac. with 2*expC
c 10 comes from 9 different derivatives with respect to 
c Ax,y,z , Bx,y,z and Cx,y,z (center positions)
c     plus 1 location for ordinary integrals.
c
        call getmem(iyyy  ,ibuf )  ! for buf (nbls,lnijkl)
        call getmem(ixxx  ,ibuf2)  ! for buf2(nbls,lnij,lnkl)
      endif
c
      if(where.eq.'hess') then
        iyyy=nblsg*max(54*lnijkl,10*mem0) 
        ixxx=55*nblsg*nfu(nsij)*nfu(nskl)
c
c 10 comes from : ordinary contraction 
c               + rescaled contrac. with 2*expA
c               + rescaled contrac. with 2*expB
c               + rescaled contrac. with 2*expC
c               + rescaled contrac. with 2*expA*2expB
c               + rescaled contrac. with 2*expA*2expC
c               + rescaled contrac. with 2*expB*2expC
c               + rescaled contrac. with (2*expA)**2    
c               + rescaled contrac. with (2*expB)**2
c               + rescaled contrac. with (2*expC)**2
c 54 comes from :  9 first derivatives 
c                +45 second derivatives
c
c 55 comes from :  1 ordinary integrals
c                  9 first derivatives 
c                +45 second derivatives
c
        call getmem(iyyy  ,ibuf )  ! for buf (nbls,lnijkl)
        call getmem(ixxx  ,ibuf2)  ! for buf2(nbls,lnij,lnkl)
      endif
c
c
c  count calls of getmem :
c
change  igmcnt=2     !  to save ibuf
        igmcnt=1
c
      if(mmax.le.2) return
c
        IF(LSHELLT.GT.0) THEN
c for ordinary integrals:
c
           mbfkl12=lnij*nfu(nqkl+1)*nbls 
           mbfij12=nfu(nqij+1)*lnkl*nbls
c
          if(where.eq.'shif') then
           mbfkl12=lnij*nfu(nqkl1+1)*nbls + 6*nfu(nsij)*nfu(nqkl+1)*nbls
           mbfij12=nfu(nqij1+1)*lnkl*nbls + 6*nfu(nqij+1)*nfu(nskl)*nbls
          endif
          if(where.eq.'forc') then
           mbfkl12=4*lnij*nfu(nqkl1+1)*nbls
     *            +10*nfu(nsij)*nfu(nqkl+1)*nbls
           mbfij12=4*nfu(nqij1+1)*lnkl*nbls
     *            +10*nfu(nqij+1)*nfu(nskl)*nbls
          endif
c
          if(lshellt.gt.1) then
            call getmem_zero(bl,mbfij12,ibfij1)  ! for bfij1 ZERO
            call getmem_zero(bl,mbfij12,ibfij2)  ! for bfij2 ZERO
            call getmem_zero(bl,mbfkl12,ibfkl1)  ! for bfkl1 ZERO
            call getmem_zero(bl,mbfkl12,ibfkl2)  ! for bfkl2 ZERO
            igmcnt=igmcnt+4
          else
            call getmem_zero(bl,mbfij12,ibfij1)  ! for bfij1 ZERO
            ibfij2=ibfij1
            call getmem_zero(bl,mbfkl12,ibfkl1)  ! for bfkl1 ZERO
            ibfkl2=ibfkl1
            igmcnt=igmcnt+2
          endif
c     
        IF( LSHELLT.GT.1 ) THEN
c
            mbf2l=nfu(nqij+1)*nfu(nqkl+1)*nbls 
            mbfkl3=lnij*nbls
            mbfij3=lnkl*nbls
c
          if(where.eq.'shif') then
            mbf2l=nfu(nqij1+1)*nfu(nqkl1+1)*nbls 
     *         +6*nfu(nqij +1)*nfu(nqkl +1)*nbls
c
            mbfkl3=lnij*4*nbls + 6*nfu(nsij)*nbls
            mbfij3=4*lnkl*nbls + 6*nfu(nskl)*nbls
          endif
          if(where.eq.'forc') then
            mbf2l=4*nfu(nqij1+1)*nfu(nqkl1+1)*nbls 
     *           +10*nfu(nqij +1)*nfu(nqkl +1)*nbls
c
            mbfkl3=4*(lnij*4*nbls) + 10*nfu(nsij)*nbls
            mbfij3=4*(4*lnkl*nbls) + 10*nfu(nskl)*nbls
          endif
c
          if(lshellt.gt.2) then
            call getmem_zero(bl,mbf2l,ibf2l1)   ! for bf2l1 ZERO
            call getmem_zero(bl,mbf2l,ibf2l2)   ! for bf2l2 ZERO
            call getmem_zero(bl,mbf2l,ibf2l3)   ! for bf2l3 ZERO
            call getmem_zero(bl,mbf2l,ibf2l4)   ! for bf2l4 ZERO
            igmcnt=igmcnt+4
          else
            call getmem_zero(bl,mbf2l,ibf2l1)   ! for bf2l1 ZERO
            ibf2l2=ibf2l1
            call getmem_zero(bl,mbf2l,ibf2l3)   ! for bf2l3 ZERO
            ibf2l4=ibf2l3
            igmcnt=igmcnt+2
          endif
c
            call getmem_zero(bl,mbfij3,ibfij3)  ! for bfij3 ZERO
            call getmem_zero(bl,mbfkl3,ibfkl3)  ! for bfkl3 ZERO
            igmcnt=igmcnt+2
c
        IF( LSHELLT.GT.2 ) THEN
c
            mbf3l0=max( nfu(nqij +1),nfu(nqkl +1) )
            mbf3l=mbf3l0*nbls
          if(where.eq.'shif') then
            mbf3l1=max( nfu(nqij1+1),nfu(nqkl1+1) )
            mbf3l0=max( nfu(nqij +1),nfu(nqkl +1) )
            mbf3l=4*mbf3l1*nbls + 6*mbf3l0*nbls
          endif
          if(where.eq.'forc') then
            mbf3l1=max( nfu(nqij1+1),nfu(nqkl1+1) )
            mbf3l0=max( nfu(nqij +1),nfu(nqkl +1) )
            mbf3l=4*(4*mbf3l1*nbls) + 10*mbf3l0*nbls
          endif
c
          if(lshellt.gt.3) then
            call getmem(mbf3l,ibf3l1)  ! for bf3l1
            call getmem(mbf3l,ibf3l2)  ! for bf3l2
            call getmem(mbf3l,ibf3l3)  ! for bf3l3
            call getmem(mbf3l,ibf3l4)  ! for bf3l4
            igmcnt=igmcnt+4
           else
            call getmem(mbf3l,ibf3l1)  ! for bf3l1
            ibf3l2=ibf3l1
            call getmem(mbf3l,ibf3l3)  ! for bf3l3
            ibf3l4=ibf3l3
            igmcnt=igmcnt+2
           endif
c
        IF( LSHELLT.GT.3 ) then
c
            i4s =nbls
          if(where.eq.'shif') then
            i4s =16*nbls + 6*nbls
          endif
          if(where.eq.'forc') then
            i4s =4*16*nbls + 10*nbls
          endif
c
           call getmem_zero(bl,i4s  ,issss)  ! for ssss ZERO
c
            igmcnt=igmcnt+1
        ENDIF
        ENDIF
        ENDIF
        ENDIF
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c         Memory handling for Obara-Saika-Tracy method
c     
c     0) for target classes WT0 or XT0(nbls,lnij,lnkl)
c
c     1) for recursive formulas in Obara-Saika:
c
c         WT1 or XT1( mmax, nbls, lensm(mmax) )
c
c     2) for recursive formulas in Tracy :
c        WT2(nbls,mem2)  where mem2 is a sum of all matrices  
c        from xt1(lensm(mmax),1) to  xt1(lensm(nsij),lensm(nskl))
c  
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc
c  for target classes
c
cc
c  for Obara-Saika
c
      l11=mmax
      l12=lensm(mmax)     
      mem1=l11*l12
cc
c  for Tracy 
c
      mem2_1=0
c98   if(nsij.ge.nskl) then
        klstep=0
        do 10 ijstep=mmax,nsij,-1
        klstep=klstep+1
        ijdim=lensm(ijstep)
        kldim=lensm(klstep)
        ijkld=ijdim*kldim
        mem2_1=mem2_1+ijkld
   10   continue
c98   else
      mem2_2=0
        ijstep=0
        do 11 klstep=mmax,nskl,-1
        ijstep=ijstep+1
        ijdim=lensm(ijstep)
        kldim=lensm(klstep)
        ijkld=ijdim*kldim
        mem2_2=mem2_2+ijkld
   11   continue
c98   endif
c98
      mem2=max(mem2_1,mem2_2)
c
ccc   write(6,*)' memoha: mem2_1,mem2_2,mem2=',mem2_1,mem2_2,mem2
c
      call getmem_zero(bl,nbls*mem0,iwt0)   ! for wt0(nbls,lnij,lnkl) ZERO
      call getmem_zero(bl,nbls*mem1,iwt1)   ! for wt1(l11,nbls,l12) ZERO
      call getmem_zero(bl,nbls*mem2,iwt2)      ! for wt2(nbls,mem2) ZERO
c
      igmcnt=igmcnt+3
c
      return
      end
c
c********
      subroutine memo4b(bl,nbls,igmcnt)
      double precision bl(*)
c nmr deriv
      character*11 scftype
      character*8 where
      common /runtype/ scftype,where
c--
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
C
#include "texas_lpar.fh"
c
      COMMON/SHELL/LSHELLT,LSHELIJ,LSHELKL,LHELP,LCAS2(4),LCAS3(4)
      common /memor4/ iwt0,iwt1,iwt2,ibuf,ibuf2,
     * ibfij1,ibfij2,ibfkl1,ibfkl2,
     * ibf2l1,ibf2l2,ibf2l3,ibf2l4,ibfij3,ibfkl3,
     * ibf3l,issss,
     * ix2l1,ix2l2,ix2l3,ix2l4,ix3l1,ix3l2,ix3l3,ix3l4,
     * ixij,iyij,izij, iwij,ivij,iuij,isij
C
C************************************************************
c
c* initiate all addresses :
c
c for amshift :
       ix2l1=1
       ix2l2=1
       ix2l3=1
       ix2l4=1
       ix3l1=1
       ix3l2=1
       ix3l3=1
       ix3l4=1
       ixij=1
       iyij=1
       izij=1
       iwij=1
       ivij=1
       iuij=1
       isij=1
c
c------------------------------------------------
c       Memory for "shifts"
c
c* for wij and xij :
c
c---new----
            mwvus=max(lnij,lnkl)*max(nfu(nqj+1),nfu(nql+1))
            mxij=nfu(nqi+1)*nfu(nqij+1)*lnkl
c
            mwij=mwvus
            mwij=mwij*nbls
            mxij=mxij*nbls
        if(where.eq.'shif') then
            mwij=6*mwij
            mxij=6*mxij
        endif
        if(where.eq.'forc') then
            mwij=10*mwij
            mxij=10*mxij
        endif
        if(where.eq.'hess') then
            mwij=55*mwij
            mxij=55*mxij
        endif
c---new----
c
            call getmem(mwij,iwij)    ! for wij
            call getmem_zero(bl,mxij,ixij)    ! for xij ZERO
c
c  count calls of getmem :
c
            igmcnt=2
c
        IF(LSHELLT.GT.0) THEN
c
c* for vij10:
c
c--new--    mvus=lnij2
            mvus=mwvus
            myz=nfu(nqi+1)*nfu(nqj+1)*nfu(nqkl+1)
            mvus=mvus*nbls
            myz=myz*nbls
c
        if(where.eq.'shif') then
            mvus=6*mvus
            myz =6*myz 
        endif
        if(where.eq.'forc') then
            mvus=10*mvus
            myz =10*myz 
        endif
c
            call getmem(mvus,ivij)      ! for vij
            call getmem(myz ,iyij)      ! for yij
c 
           igmcnt=igmcnt+2
c     
        IF( LSHELLT.GT.1 ) THEN
            mbf2l=nfu(nqij+1)*nfu(nqkl+1) *nbls
            if(where.eq.'shif') then
               mbf2l=6*mbf2l
            endif
            if(where.eq.'forc') then
               mbf2l=10*mbf2l
            endif
c
c* for x2l1-4, uij and sij:
c
            call getmem(mvus,iuij)      ! for uij
            call getmem(mvus,isij)      ! for sij
            call getmem(myz ,izij)      ! for zij
            igmcnt=igmcnt+3
cc
          if(lshellt.gt.2) then
            call getmem(mbf2l,ix2l1)    ! for x2l1
            call getmem(mbf2l,ix2l2)    ! for x2l2
            call getmem(mbf2l,ix2l3)    ! for x2l3
            call getmem(mbf2l,ix2l4)    ! for x2l4
            igmcnt=igmcnt+4
          else
            call getmem(mbf2l,ix2l1)    ! for x2l1
            ix2l2=ix2l1                 ! for x2l2
            ix2l3=ix2l1                 ! for x2l3
            ix2l4=ix2l1                 ! for x2l4
            igmcnt=igmcnt+1
          endif
c
        IF( LSHELLT.GT.2 ) THEN
c
         mnbls=nbls
         if(where.eq.'shif') mnbls=6*nbls
         if(where.eq.'forc') mnbls=10*nbls
c
         if(lshellt.gt.3) then
            call getmem(mnbls*nfu(nqkl+1), ix3l1) ! for x3l1
            call getmem(mnbls*nfu(nqkl+1), ix3l2) ! for x3l2
            call getmem(mnbls*nfu(nqij+1), ix3l3) ! for x3l3
            call getmem(mnbls*nfu(nqij+1), ix3l4) ! for x3l4
            igmcnt=igmcnt+4
          else
            call getmem(mnbls*nfu(nqkl+1), ix3l1) ! for x3l1
            ix3l2=ix3l1
            call getmem(mnbls*nfu(nqij+1), ix3l3) ! for x3l3
            ix3l4=ix3l3
            igmcnt=igmcnt+2
          endif
c
        ENDIF
        ENDIF
        ENDIF
c
      return
      end
c
c================================================================
      subroutine memo5a_2(npij,mmax1)
c------------------------------------------
c Memory handling for left-hand pairs:
c
c 1: for individual shells (2 quantities)
c   cis,cjs - contr coef. dimensions are (lci), (lcj)
c
c 2: for : xab(ijpar,3) and xp, xpn, xpp all (ijpar,3,lcij)
c
c 3: for : apb, rapb, factij, (lcij)
c          ceofij and sij all (ijpar,lcij)
c
c 4. for : txab(ijpar,3,lcij)
c
c Total number of calls of Getmem is 11 or 12 (if gen.con.)
c OR 13 or 14 if where='forc'
c------------------------------------------
c for gradient derivatives:
      character*11 scftype
      character*8 where
      common /runtype/ scftype,where
c
      common /cpu/ intsize,iacc,icache,memreal
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
      common /memor5x/ ieab,iecd
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c------------------------------------------
      ijpar=npij
c------------------------------------------
c reserve memory for left-hand pairs IJ :
c
       ndi=   ijpar*lci
       ndj=   ijpar*lcj
c
      call getmem(lci,icis)       ! for cis(lci)                 1
      call getmem(lcj,icjs)       ! for cjs(lcj)                 2
      call getmem(ijpar*3,ixab)   ! for xab(ijpar,3)             3
c
       ndij=ndi*lcj
       ndij3=ndij*3
c
ckw Do not change this order
      call getmem(ndij3,ixp)     ! for xp(ijpar,3,lcij)          4
      call getmem(ndij3,ixpn)    ! for xpn(ijpar,3,lcij)         5
      call getmem(ndij3,ixpp)    ! for xpp(ijpar,3,lcij)         6
ckw up to here.
c
      call getmem(lcij,ifij)     ! for factij(lcij)              7 
      call getmem(ndij,icij)     ! for coefij(ijpar,lcij)        8
      call getmem(ndij,ieab)     ! for eab(ijpar,lcij)           9
      call getmem(ndij3,itxab)   ! for txab(ijpar,3,lcij)       10
c
      ndijm=lcij*mmax1
      call getmem(ndijm,iabnia)  ! for abnia(mmax-1,lcij)       11
c
c------------------------------------------
c for general contraction on IJ-pairs
c
      ngci1=ngci+1
      ngcj1=ngcj+1
      ngck1=ngck+1
      ngcl1=ngcl+1
      ngcd=ngci1*ngcj1*ngck1*ngcl1
c
c-----
c
      igcij=1
      if(ngcd.gt.1) then
        ndijg=lcij*ngci1*ngcj1
        call getmem(ndijg,igcij)              !               12
      endif
c
      iaa=1
      ibb=1
      if(where.eq.'forc' .or. where.eq.'hess') then
         call getmem(ndi,iaa)     ! for  aa(ijpar,lci)        13  
         call getmem(ndj,ibb)     ! for  bb(ijpar,lcj)        14   
      endif
c------------------------------------------
      end
c================================================================
      subroutine memo5b_2(npkl,mmax1)
      common /cpu/ intsize,iacc,icache,memreal
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
c------------------------------------------
c Memory handling for right-hand pairs:
c------------------------------------------
c for gradient derivatives:
      character*11 scftype
      character*8 where
      common /runtype/ scftype,where
c
      common /memor5x/ ieab,iecd
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c------------------------------------------
      klpar=npkl
c------------------------------------------
c reserve memory for right-hand pairs KL :
c
       ndk=   klpar*lck
cccc   ndl=   klpar*lcl
c
      call getmem(lck,icks)       ! for cks(lck)                1
      call getmem(lcl,icls)       ! for cls(lcl)                2
      call getmem(klpar*3,ixcd)  ! for xcd(klpar,3)             3
c
       ndkl=ndk*lcl
       ndkl3=ndkl*3
c
ckw Do not change this order
      call getmem(ndkl3,ixq)     ! for xq(klpar,3,lckl)         4
      call getmem(ndkl3,ixqn)    ! for xqn(klpar,3,lckl)        5
      call getmem(ndkl3,ixqq)    ! for xqq(klpar,3,lckl)        6
ckw up to here.
c
      call getmem(ndkl,ifkl)     ! for factkl(klapr,lckl)       7
      call getmem(ndkl,ickl)     ! for coefkl(klapr,lckl)       8
      call getmem(ndkl,iecd)     ! for ecd(klapr,lckl)          9
      call getmem(ndkl3,itxcd)   ! for txcd(klpar,3,lckl)      10
c
      ndklm=lckl*mmax1
      call getmem(ndklm,icdnia)  ! for cdnia(mmax-1,lckl)      11
c------------------------------------------
c for general contraction on KL-pairs
c
      ngci1=ngci+1
      ngcj1=ngcj+1
      ngck1=ngck+1
      ngcl1=ngcl+1
      ngcd=ngci1*ngcj1*ngck1*ngcl1
c-----
      igckl=1
      if(ngcd.gt.1) then
        ndklg=lckl*ngck1*ngcl1
        call getmem(ndklg,igckl)      !               12
      endif
c------------------------------------------
      icc=1
      if(where.eq.'forc' .or. where.eq.'hess') then
         call getmem(ndk,icc)   ! for  cc(klpar,lck) 13
      endif
c------------------------------------------
      end
c================================================================
      subroutine memo5c_2(nbls,mmax1,npij,npkl,nfumax)
      common /cpu/ intsize,iacc,icache,memreal
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
c------------------------------------------
c Memory handling 
c
c 3: and quartets precalculations (12 quantities)
c (for whole block of contracted quartets and 
c        one primitive quartet )
c
c Total number of calls of Getmem is 21 or 23 (if gen.cont)
c------------------------------------------
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
      common /memor5b/ irppq,
     * irho,irr1,irys,irhoapb,irhocpd,iconst,ixwp,ixwq,ip1234,
     * idx1,idx2,indx
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5d/ iabnix,icdnix,ixpnx,ixqnx,ihabcdx
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
      common /memor5f/ indxp
c------------------------------------------
c reserve memory for quartets ijkl
c------------------------------------------
      nblsi=nbls
      if(intsize.ne.1) nblsi=nbls/intsize+1
c------------------------------------------
      call getmem(nblsi,indxp)   !                    1
      call getmem(nblsi,idx1)    ! for indxij         2
      call getmem(nblsi,idx2)    ! for indxkj         3
      call getmem(nblsi,indx)    ! for index          4
c
      call getmem(1   ,irppq)    ! for rppq(1   )     5
      call getmem(nbls,irr1)     ! for rr1(nbls)      6  
c
      call getmem(1   ,irhoapb)  ! for rhoapb(1   )   7
      call getmem(1   ,irhocpd)  ! for rhocpd(1   )   8
c
      nbls3=nbls*3
      call getmem(nbls3,ixpnx)   !                    9
      call getmem(nbls3,ixwp)    ! for xwp(nbls,3)   10
      call getmem(nbls3,ixqnx)   !                   11
      call getmem(nbls3,ixwq)    ! for xwq(nbls,3)   12
      call getmem(nbls3,ip1234)  ! for p1234(nbls,3) 13
      call getmem(1   ,iabcd)    ! for abcd(1   )    14
      call getmem(nbls,iconst)   ! for const(nbls)   15
      call getmem(nbls,irys)     ! for rys(nbls)     16
c
      nfha=3*nfumax*max(lcij,lckl)
      call getmem(nfha,ihabcd)    !                  17
c------------------------------------------
c for general contraction
c
      ngci1=ngci+1
      ngcj1=ngcj+1
      ngck1=ngck+1
      ngcl1=ngcl+1
      ngcd=ngci1*ngcj1*ngck1*ngcl1
c
c------------------------------------------
c for both gen.contr. and segmented basis sets
c because of the common Destiny
c
      call getmem(ngcd,icfg)        !               18
      call getmem(ngcd,jcfg)        !               19
      call getmem(ngcd,kcfg)        !               20
      call getmem(ngcd,lcfg)        !               21
c
c------------------------------------------
c for general contraction
c
      indgc=1
      igcoef=1
c
      if(ngcd.gt.1) then
        call getmem(nbls,indgc)       !             22
        call getmem(nbls*ngcd,igcoef) !             23
      endif
c
c------------------------------------------
      end
c====================================================================
      subroutine memo6(npij,npkl)
      common /memor6/ ixyab,ixycd
c**************
c
c Memory handling for NMR derivatives
c reserve memory for pair quantities :
c
c  ( Xa*Yb - Ya*Xb ) = xyab(ijpar,3)  - contributes to Z deriv.
c  (-Xa*Zb + Za*Xb ) = xyab(ijpar,2)  - contributes to Y deriv.
c  ( Ya*Zb + Za*Yb ) = xyab(ijpar,1)  - contributes to X deriv.
c
c  ( Xc*Yd - Yc*Xd ) = xycd(klpar,3)  - contributes to Z deriv.
c  (-Xc*Zd + Zc*Xd ) = xycd(klpar,2)  - contributes to Y deriv.
c  ( Yc*Zd + Zc*Yd ) = xycd(klpar,1)  - contributes to X deriv.
c
c**************
c
      npij3=3*npij
      npkl3=3*npkl
c
      call getmem(npij3,ixyab)
      call getmem(npkl3,ixycd)
c
      end
c================================================================
c used when iroute=1 (old) :
c
      subroutine memo5a_1(npij,mmax1)
      common /cpu/ intsize,iacc,icache,memreal
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
c------------------------------------------
c Memory handling for left-hand pairs:
c
c 1: for individual shells (4 quantities)
c ( aa, bb  - exponents ) and  ( cis,cjs - contr coef.)
c  dimensions are (ijpar,lcij)
c
c 2: for : xab(ijpar,3) and xp, xpn, xpp all (ijpar,3,lcij)
c
c 3: for : apb, rapb, factij, ceofij and sij all (ijpar,lcij)
c
c 4. for : txab(ijpar,3,lcij)
c
c Total number of calls of Getmem is 13 or 15 (if gen.con.)
c------------------------------------------
      common /memor5x/ ieab,iecd
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
c
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c
c------------------------------------------
      ijpar=npij
c------------------------------------------
c reserve memory for left-hand pairs IJ :
c
       ndi=   ijpar*lci
       ndj=   ijpar*lcj
c
      call getmem(ndi,iaa)        ! for  aa(ijpar,lci)           1
      call getmem(ndj,ibb)        ! for  bb(ijpar,lcj)           2
      call getmem(ndi,icis)       ! for cis(ijpar,lci)           3
      call getmem(ndj,icjs)       ! for cjs(ijpar,lcj)           4
      call getmem(ijpar*3,ixab)   ! for xab(ijpar,3)              5
c
       ndij=ndi*lcj
       ndij3=ndij*3
c
ckw Do not change this order
      call getmem(ndij3,ixp)     ! for xp(ijpar,3,lcij)          6
      call getmem(ndij3,ixpn)    ! for xpn(ijpar,3,lcij)         7
      call getmem(ndij3,ixpp)    ! for xpp(ijpar,3,lcij)         8
ckw up to here.
c
c     call getmem(ndij,iapb)     ! for apb(ijpar,lcij)             
c     call getmem(ndij,i1apb)    ! for rapb(ijpar,lcij)         
      call getmem(ndij,ifij)     ! for factij(ijpar,lcij)        9 
      call getmem(ndij,icij)     ! for coefij(ijpar,lcij)       10
      call getmem(ndij,ieab)     ! for eab(ijpar,lcij)          
c
      call getmem(ndij3,itxab)   ! for txab(ijpar,3,lcij)       11
c
      ndijm=ndij*mmax1
      call getmem(ndijm,iabnia)  ! for abnia(ijpar,mmax-1,lcij) 12
c
c------------------------------------------
c for general contraction on IJ-pairs
c
      ngci1=ngci+1
      ngcj1=ngcj+1
      ngck1=ngck+1
      ngcl1=ngcl+1
      ngcd=ngci1*ngcj1*ngck1*ngcl1
c
c-----
c
      igci=1
      igcj=1
c
      if(ngcd.gt.1) then
        ndig=ndi*ngci1
        ndjg=ndj*ngcj1
        call getmem(ndig,igci)        !               13
        call getmem(ndjg,igcj)        !               14
      endif
c
c------------------------------------------
      end
c================================================================
      subroutine memo5b_1(npkl,mmax1)
      common /cpu/ intsize,iacc,icache,memreal
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
c------------------------------------------
c Memory handling for right-hand pairs:
c
c 1: for individual shells (4 quantities)
c ( cc, dd  - exponents ) and  ( cks,cls - contr coef.)
c  dimensions are (klpar,lcij)
c
c 2: for : xcd(ijpar,3) and xq, xqn, xqq all (klpar,3,lckl)
c
c 3: for : cpd, rcpd, factkl, coefkl and skl all (klpar,lckl)
c
c 4. for : txcd(klpar,3,lckl)
c
c Total number of calls of Getmem is 13 or 15 (if gen.con.)
c------------------------------------------
      common /memor5x/ ieab,iecd
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
c
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c
c------------------------------------------
      klpar=npkl
c------------------------------------------
c reserve memory for right-hand pairs KL :
c
       ndk=   klpar*lck
       ndl=   klpar*lcl
c
      call getmem(ndk,icc)        ! for  cc(klpar,lck)           1
      call getmem(ndl,idd)        ! for  dd(klpar,lcl)           2
      call getmem(ndk,icks)       ! for cks(klpar,lck)           3
      call getmem(ndl,icls)       ! for cls(klpar,lcl)           4
      call getmem(klpar*3,ixcd)  ! for xcd(klpar,3)              5
c
       ndkl=ndk*lcl
       ndkl3=ndkl*3
c
ckw Do not change this order
      call getmem(ndkl3,ixq)     ! for xq(klpar,3,lckl)          6
      call getmem(ndkl3,ixqn)    ! for xqn(klpar,3,lckl)         7
      call getmem(ndkl3,ixqq)    ! for xqq(klpar,3,lckl)         8
ckw up to here.
c
c     call getmem(ndkl,icpd)     ! for cpd(klapr,lckl)     
c     call getmem(ndkl,i1cpd)    ! for rcpd(klapr,lckl)   
      call getmem(ndkl,ifkl)     ! for factkl(klapr,lckl)        9
      call getmem(ndkl,ickl)     ! for coefkl(klapr,lckl)       10
      call getmem(ndkl,iecd)     ! for ecd(klapr,lckl)  
c
      call getmem(ndkl3,itxcd)   ! for txcd(klpar,3,lckl)       11
c
      ndklm=ndkl*mmax1
      call getmem(ndklm,icdnia)  ! for cdnia(klpar,mmax-1,lckl) 12
c
c------------------------------------------
c for general contraction on KL-pairs
c
      ngci1=ngci+1
      ngcj1=ngcj+1
      ngck1=ngck+1
      ngcl1=ngcl+1
      ngcd=ngci1*ngcj1*ngck1*ngcl1
c
c-----
c
      igck=1
      igcl=1
c
      if(ngcd.gt.1) then
        ndkg=ndk*ngck1
        ndlg=ndl*ngcl1
        call getmem(ndkg,igck)        !               13
        call getmem(ndlg,igcl)        !               14
      endif
c------------------------------------------
      end
c================================================================
      subroutine memo5c_1(bl,nbls,mmax1,npij,npkl,nfha,nfumax)
      double precision bl(*)
      common /cpu/ intsize,iacc,icache,memreal
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
c------------------------------------------
c Memory handling 
c
c 3: and quartets precalculations (12 quantities)
c (for whole block of contracted quartets and 
c        one primitive quartet )
c
c Total number of calls of Getmem is 24 or 26 (if gen.cont)
c------------------------------------------
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
c
      common /memor5b/ irppq,
     * irho,irr1,irys,irhoapb,irhocpd,iconst,ixwp,ixwq,ip1234,
     * idx1,idx2,indx
c
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5d/ iabnix,icdnix,ixpnx,ixqnx,ihabcdx
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c
      common /memor5f/ indxp
c------------------------------------------
c reserve memory for quartets ijkl
c------------------------------------------
      nblsi=nbls
      if(intsize.ne.1) nblsi=nbls/intsize+1
c------------------------------------------
      call getmem(nblsi,indxp)   !                    3
c------------------------------------------
c
      call getmem(nblsi,idx1)    ! for indxij         4
      call getmem(nblsi,idx2)    ! for indxkj         5
      call getmem(nblsi,indx)    ! for index          6
c
      call getmem(nbls,irppq)    ! for rppq(nbls)     7    
cNOT  call getmem(nbls,irho)     ! for rho(nbls)      8   
      call getmem(nbls,irr1)     ! for rr1(nbls)      9  
c       
c
      call getmem(nbls,irhoapb)  ! for rhoapb(nbls)   10
      call getmem(nbls,irhocpd)  ! for rhocpd(nbls)   11
c
      nbmx=nbls*mmax1
      call getmem(nbmx,iabnix)   !                    12
      call getmem(nbmx,icdnix)   !                    13
c
      nbls3=nbls*3
      call getmem(nbls3,ixpnx)   !                    14
      call getmem(nbls3,ixwp)    ! for xwp(nbls,3)    15
      call getmem(nbls3,ixqnx)   !                    16
      call getmem(nbls3,ixwq)    ! for xwq(nbls,3)    17
      call getmem(nbls3,ip1234)  ! for p1234(nbls,3)  18
      call getmem(nbls,iabcd)    ! for abcd(nbls)     19
      call getmem(nbls,iconst)   ! for const(nbls)    20
      call getmem(nbls,irys)     ! for rys(nbls)      21
c
      call getmem(nfha*3,ihabcd) !                    22
      call getmem_zero(bl,nbls3*nfumax,ihabcdx)  !            23 ZERO
c
c------------------------------------------
c for general contraction
c
      ngci1=ngci+1
      ngcj1=ngcj+1
      ngck1=ngck+1
      ngcl1=ngcl+1
      ngcd=ngci1*ngcj1*ngck1*ngcl1
c
c------------------------------------------
c for both gen.contr. and segmented basis sets
c because of the common Destiny
c
      call getmem(ngcd,icfg)          !               24
      call getmem(ngcd,jcfg)          !               25
      call getmem(ngcd,kcfg)          !               26
      call getmem(ngcd,lcfg)          !               27
c
c------------------------------------------
c for general contraction
c
      indgc=1
      igcoef=1
c
      if(ngcd.gt.1) then
        call getmem(nbls,indgc)       !               32
        call getmem(nbls*ngcd,igcoef) !               33
      endif
c
c------------------------------------------
      end
c====================================================================

C $Id: rel_pot2.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
c:tex-\subsection{rel\_pot2}
c:tex-This routine assembles the relativistic (small-small) potential 
c:tex-energy integrals from a set of potential energy integrals for 
c:tex-shifted angular momenta. The routine uses the modified Dirac 
c:tex-formalism, and returns integrals in various formats, depending
c:tex-on the input parameter ntyp, which also determines how many 
c:tex-integral blocks are returned. This routine generalizes rel\_pot
c:tex-to allow for two-electron integrals of any class. 
c:tex-
c:tex-NOTE: the factor of \alpha^2/4 is NOT included here.
c:tex-
c:tex-\noindent Author: K. G. Dyall
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine rel_pot2 (Vpp,Vpm,Vmp,Vmm,Vrel,nints,ntyp,n_x,
     &    l_a,np_a,n_a,nm_a,n_ca,
     &    l_b,np_b,n_b,nm_b,n_cb,
     &    DryRun,scr,lscr,ibug)
c:tex-\end{verbatim}
************************************************************************
      implicit none
#include "stdio.fh"
#include "errquit.fh"
      double precision zero, one
      parameter (zero = 0.0d00, one = 1.0d00)
*
c:tex-{\it Argument list:}
c:tex-\begin{verbatim}
      integer nints    ! [input] number of integrals of each type
      integer ntyp     ! [input] integral type
      integer l_A      ! [input] - angular momentum of shell A
      integer np_A     ! [input] number of cartesian components for l_A+1
      integer n_A      ! [input] number of cartesian components for l_A
      integer nm_A     ! [input] number of cartesian components for l_A-1
      integer n_cA     ! [input] number of contracted functions on centre A
      integer l_B      ! [input] angular momentum of functions on centre B
      integer np_B     ! [input] number of cartesian components for l_B+1
      integer n_B      ! [input] number of cartesian components for l_B
      integer nm_B     ! [input] number of cartesian components for l_B-1
      integer n_cB     ! [input] number of contracted functions on centre B
      integer n_x      ! number of functions preceding B
      integer lscr     ! [i/o] - length of scratch array/memory needed
      integer ibug     ! debug flag. 
      double precision Vpp(n_x,np_b,n_cb,np_a,n_ca) ! [input] integrals for l_B+1, l_A+1
      double precision Vpm(n_x,np_b,n_cb,nm_a,n_ca) ! [input] integrals for l_B+1, l_A-1
      double precision Vmp(n_x,nm_b,n_cb,np_a,n_ca) ! [input] integrals for l_B-1, l_A+1
      double precision Vmm(n_x,nm_b,n_cb,nm_a,n_ca) ! [input] integrals for l_B-1, l_A-1
      double precision Vrel(nints,ntyp) ! [output] final relativistic integrals
      double precision scr(lscr) ! scratch array
      logical DryRun   ! [input] logical for dry run
c:tex-\end{verbatim}
c:tex-The possible values for ntyp are
c:tex-{\leftskip 4pc\obeylines
c:tex-ntyp = 1 : scalar integrals only
c:tex-ntyp = 3 : spin-orbit integrals only
c:tex-ntyp = 4 : scalar and spin-orbit integrals
c:tex-ntyp = 9 : derivative integrals}
c:tex-The possible values for ibug are
c:tex-{\leftskip 4pc\obeylines
c:tex-ibug = 0 for no debug, 
c:tex-ibug = 1 for address printing, 
c:tex-ibug = 2 for array printing, 
c:tex-ibug = 3 for both.}
c:tex-
c:tex-Note that n_ca and n_cb are essentially only the second and
c:tex-fourth dimensions of the integral array; the code does not make use
c:tex-of their significance as number of contracted functions, so there
c:tex-is no reason why these cannot be used for the two-electron integrals.
*
      integer n_all_A  ! total basis functions on A
      integer n_all_B  ! total basis functions on B
      integer n_allp_B ! total basis functions on B for l_B+1
      integer n_allm_B ! total basis functions on B for l_B-1
      integer np  ! no. gradient integrals for l_B+1
      integer nm  ! no. gradient integrals for l_B-1
      integer nab ! size of integral block
      integer nn  ! no. second derivative integrals
      integer i_scr  ! address of scratch space
      integer i_grdp ! address of gradient integrals for l_B+1
      integer i_grdm ! address of gradient integrals for l_B+1
      integer i_free ! address of free space in scr
      integer k ! integer variable
      logical debug_gen       ! do general debug printing
      logical debug_addresses ! do address debug printing
      logical debug_arrays    ! do array debug printing
*
      debug_gen = ibug .gt. 0
      debug_addresses = mod(ibug,2) .eq. 1
      debug_arrays = mod(ibug,10)/2 .eq. 1
*
      if (debug_gen) write (LuOut,'(//A,/)') 'Entering rel_pot ...'
      n_all_A = n_cA*n_A
      n_all_B = n_cB*n_B
      n_allp_B = n_cB*np_B*n_x
      n_allm_B = n_cB*nm_B*n_x
      np = 3*n_all_A*n_allp_B
      nm = 3*n_all_A*n_allm_B
      nab = n_all_A*n_all_B*n_x
      if ((nab .ne. nints) .and. (.not.DryRun)) call errquit
     &    ('Mismatch between nints and nab in rel_pot',99, INT_ERR)
      nn = 9*nab
*
      i_scr = 1
      i_grdp = i_scr+nn
      i_grdm = i_grdp+np
      i_free = i_grdm+nm
*
      if (DryRun) then
        lscr = i_free-1
      else
        if (lscr .lt. i_free-1) call errquit 
     &      ('Insufficient memory in rel_pot',99, MEM_ERR)
        call dcopy (np,zero,0,scr(i_grdp),1)
        call ecp_grad_a (l_A,np_A,n_A,nm_A,n_cA,Vpp,Vpm,
     &      scr(i_grdp),n_allp_B,ibug/10)
        call dcopy (nm,zero,0,scr(i_grdm),1)
        if (l_B .gt. 0) call ecp_grad_a (l_A,np_A,n_A,nm_A,n_ca,
     &      Vmp,Vmm,scr(i_grdm),n_allm_B,ibug/10)
        call dcopy (nn,zero,0,scr,1)
        call ecp_grad_a (l_b,np_b,n_b,nm_b,n_cb*n_all_A*3,
     &      scr(i_grdp),scr(i_grdm),scr,n_x,ibug/10)
        call dcopy (nints*ntyp,zero,0,Vrel,1)
*
*   Return with derivative integrals only
*
        if (ntyp .eq. 9) then
          call dcopy (nab*ntyp,scr(i_scr),1,Vrel,1)
          return
        end if 
*
*   Assemble scalar integrals
*
        if ((ntyp .eq. 1) .or. (ntyp .eq. 4)) then
          call daxpy (nab,one,scr(i_scr),1,Vrel,1)
          call daxpy (nab,one,scr(i_scr+4*nab),1,Vrel,1)
          call daxpy (nab,one,scr(i_scr+8*nab),1,Vrel,1)
          if (debug_arrays) call ecp_matpr (Vrel,1,n_all_b,1,n_all_a,
     &        1,n_all_b,1,n_all_a,'Scalar integrals','E',78,4)
        end if
*
*   Assemble spin-orbit integrals
*
        k = ntyp-3
        if (k .ge. 0) then
          call daxpy (nab,one,scr(i_scr+5*nab),1,Vrel(1,k+3),1)
          call daxpy (nab,one,scr(i_scr+6*nab),1,Vrel(1,k+2),1)
          call daxpy (nab,one,scr(i_scr+nab),1,Vrel(1,k+1),1)
          call daxpy (nab,-one,scr(i_scr+7*nab),1,Vrel(1,k+3),1)
          call daxpy (nab,-one,scr(i_scr+2*nab),1,Vrel(1,k+2),1)
          call daxpy (nab,-one,scr(i_scr+3*nab),1,Vrel(1,k+1),1)
          if (debug_arrays) call ecp_matpr (Vrel(1,k+1),
     &        1,n_all_b,1,n_all_a,1,n_all_b,1,n_all_a,
     &        'Z spin-orbit integrals','E',78,4)
          if (debug_arrays) call ecp_matpr (Vrel(1,k+2),
     &        1,n_all_b,1,n_all_a,1,n_all_b,1,n_all_a,
     &        'Y spin-orbit integrals','E',78,4)
          if (debug_arrays) call ecp_matpr (Vrel(1,k+3),
     &        1,n_all_b,1,n_all_a,1,n_all_b,1,n_all_a,
     &        'X spin-orbit integrals','E',78,4)
        end if
      end if
*
      if (debug_gen) write (LuOut,*) 'Exiting rel_pot'
*
      return
      end

*
* $Id: c_wvfnc_expander.F 23385 2013-01-07 02:27:33Z bylaska $
*

*     *******************************************
*     *						*
*     *	 	   c_wvfnc_expander		*
*     *						*
*     *******************************************

      logical function c_wvfnc_expander(rtdb)
      implicit none
#include "mafdecls.fh"
#include "rtdb.fh"
      integer rtdb
      logical value
      integer version
 
      integer ierr

      integer ne(2),ispin

      character*50 new_wavefunction_filename
      character*50 old_wavefunction_filename
      character*255 full_filename,full_filename2


      integer ngrid(3),nbrillioun
      integer dngrid(3)
      integer cfull(2),dcfull(2)
      integer nfft3d,n2ft3d
      integer dnfft3d,dn2ft3d
      integer ms,n,l,nb,ispin0,occupation


      double precision unita(3,3),rx

      value = .false.
      version = 3

*     **** get wavefunction information ****
      value = rtdb_cget(rtdb,'c_xpndr:old_wavefunction_filename',
     >                  1,old_wavefunction_filename)
      value = rtdb_cget(rtdb,'c_xpndr:new_wavefunction_filename',
     >                  1,new_wavefunction_filename)

      value = rtdb_get(rtdb,'c_xpndr:ngrid',mt_int,3,dngrid)

 
      call util_file_name_noprefix(old_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin0,1)
      if (ispin0.eq.3) then
         ispin = 2
      else
         ispin = ispin0
      end if
      call iread(5,ne,2)
      call iread(5,nbrillioun,1)
      call iread(5,occupation,1)
 
      call util_file_name('c_wvfnc_expander',
     >                    .true.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      call openfile(6,full_filename,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,dngrid,3)
      call dwrite(6,unita,9)
      call iwrite(6,ispin0,1)
      call iwrite(6,ne,2)
      call iwrite(6,nbrillioun,1)
      call iwrite(6,occupation,1)

       
       nfft3d =  ngrid(1)* ngrid(2)* ngrid(3)
      dnfft3d = dngrid(1)*dngrid(2)*dngrid(3)
       n2ft3d = 2* nfft3d
      dn2ft3d = 2*dnfft3d

      write(*,109) old_wavefunction_filename
      write(*,110) new_wavefunction_filename
      write(*,111) ngrid(1), ngrid(2), ngrid(3),
     >            dngrid(1),dngrid(2),dngrid(3)
  109 format(' old_filename: ',A)
  110 format(' new_filename: ',A)
  111 format(' converting  : ',I3,'x',I3,'x',I3,' --> ', 
     >                     I3,'x',I3,'x',I3)
 
*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull(2),cfull(1))

      value = MA_alloc_get(mt_dcpl,dnfft3d,
     >                     'dcfull',dcfull(2),dcfull(1))

      do nb=1,nbrillioun
      do ms=1,ispin
        do n=1,ne(ms)
          call dread(5,dcpl_mb(cfull(1)),n2ft3d)

          write(*,'(A,I5,A,I2,A,I5)') 
     >    "converting .... psi:", n," spin:",ms," nb:",nb
          call c_wvfnc_expander_convert(ngrid,dcpl_mb(cfull(1)),
     >                               dngrid,dcpl_mb(dcfull(1)))

          call dwrite(6,dcpl_mb(dcfull(1)),dn2ft3d)

        end do
      end do
      end do
      if (occupation.gt.0) then
        do nb=1,nbrillioun
        do ms=1,ispin
        do n=1,ne(ms)
          call dread(5,rx,1)
          call dwrite(6,rx,1)
        end do
        end do
        end do
      end if
      call closefile(5)
      call closefile(6)

c     *** copy wvfnc_expander to new_wavefunction_filename ****
      call util_file_name_noprefix(new_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)
      call util_file_copy(full_filename,full_filename2)
      call util_file_unlink(full_filename)
      IERR=0
      GO TO 9999
 
 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999
 
 9999 value = MA_free_heap(cfull(2))
      value = MA_free_heap(dcfull(2))
      !IF(IERR.EQ.0) THEN
      !  WRITE(6,*) ' JOB HAS BEEN COMPLETED.  CODE=',IERR
      !ELSE
      !  WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
      !  value = .false.
      !ENDIF
      !call nwpw_message(4)
      
      c_wvfnc_expander = value
      return 
      end
 


*     ***************************************************
*     *							*
*     *	 	   c_wvfnc_expander_convert		*
*     *							*
*     ***************************************************

      subroutine c_wvfnc_expander_convert(ngrid,psi1,dngrid,psi2)
      implicit none
      integer ngrid(3)
      complex*16 psi1(*)
      integer dngrid(3)
      complex*16 psi2(*)

*     **** local variables ****
      integer nfft3d,dnfft3d,n2ft3d,dn2ft3d
      integer inc2,inc3,dinc2,dinc3
      integer i,j,k,i2,j2,k2,n1,n2,n3
      integer idiff,jdiff,kdiff,indx,dindx
      logical ireverse,jreverse,kreverse
       
       nfft3d =  ngrid(1)* ngrid(2)* ngrid(3)
      dnfft3d = dngrid(1)*dngrid(2)*dngrid(3)
       n2ft3d = 2* nfft3d
      dn2ft3d = 2*dnfft3d
       inc2 =  ngrid(1)
      dinc2 = dngrid(1)
       inc3 =  ngrid(1)* ngrid(2)
      dinc3 = dngrid(1)*dngrid(2)


      n1 = ngrid(1)
      n2 = ngrid(2)
      n3 = ngrid(3)
      if (n1.gt.dngrid(1)) n1 = dngrid(1)
      if (n2.gt.dngrid(2)) n2 = dngrid(2)
      if (n3.gt.dngrid(3)) n3 = dngrid(3)

      idiff = dngrid(1) - ngrid(1)
      jdiff = dngrid(2) - ngrid(2)
      kdiff = dngrid(3) - ngrid(3)
      ireverse = (idiff.lt.0)
      jreverse = (jdiff.lt.0)
      kreverse = (kdiff.lt.0)
      if (ireverse) idiff = -idiff
      if (jreverse) jdiff = -jdiff
      if (kreverse) kdiff = -kdiff

      call dcopy(dn2ft3d,0.0d0,0,psi2,1)
      do k=0,n3-1
      do j=0,n2-1
      do i=0,n1-1
         indx  = 0
         dindx = 0

         if (k.lt. (n3/2)) then
           k2 = k
         else
           k2 = kdiff + k
         end if

         if (j.lt. (n2/2)) then
           j2 = j
         else
           j2 = jdiff + j
         end if

         if (i.lt. (n1/2)) then
           i2 = i
         else
           i2 = idiff + i
         end if

         if (ireverse) then
            indx  = indx  + i2
            dindx = dindx + i 
         else
            indx  = indx  + i 
            dindx = dindx + i2
         end if
         if (jreverse) then
            indx  = indx  + j2*inc2
            dindx = dindx + j *dinc2
         else
            indx  = indx  + j *inc2
            dindx = dindx + j2*dinc2
         end if
         if (kreverse) then
            indx  = indx  + k2*inc3
            dindx = dindx + k *dinc3
         else
            indx  = indx  + k *inc3
            dindx = dindx + k2*dinc3
         end if

         psi2(dindx+1) = psi1(indx+1)
      end do
      end do
      end do

      return 
      end
 

      subroutine argos_em_fnorm(iwl,isl,xw,xwm,xs,fw,fs)
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xwm(mwm,3),xs(msa,3)
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
c
      integer i,j,k
c
      call timer_start(47)
      call argos_cafe_fnorm(iwl(1,lwdyn),fw,nwmloc,
     + isl(1,lsatt),isl(1,lsdyn),fs,nsaloc,fnorm,fmax)
      call timer_stop(47)
c
      return
      end
c $Id: argos_em_fnorm.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_space_free()
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      if(.not.ga_destroy(ga_isz))
     + call md_abort('Error ga_destroy isz',ga_isz)
      if(.not.ga_destroy(ga_iwz))
     + call md_abort('Error ga_destroy iwz',ga_iwz)
c
      if(.not.ga_destroy(ga_s))
     + call md_abort('Error ga_destroy s',ga_s)
      if(.not.ga_destroy(ga_is))
     + call md_abort('Error ga_destroy is',ga_is)
      if(.not.ga_destroy(ga_w))
     + call md_abort('Error ga_destroy w',ga_w)
      if(.not.ga_destroy(ga_iw))
     + call md_abort('Error ga_destroy iw',ga_iw)
      if(.not.ga_destroy(ga_ip))
     + call md_abort('Error ga_destroy iw',ga_ip)
c
      if(.not.ma_pop_stack(l_sndx))
     + call md_abort('Failed to deallocate sndx',0)
      if(.not.ma_pop_stack(l_lseq))
     + call md_abort('Failed to deallocate lseq',0)
      if(.not.ma_pop_stack(l_jpl))
     + call md_abort('Failed to deallocate jpl',0)
      if(.not.ma_pop_stack(l_ipl))
     + call md_abort('Failed to deallocate ipl',0)
      if(.not.ma_pop_stack(l_rng))
     + call md_abort('Failed to deallocate rng',0)
      if(.not.ma_pop_stack(l_boxr))
     + call md_abort('Failed to deallocate boxr',0)
      if(.not.ma_pop_stack(l_boxs))
     + call md_abort('Failed to deallocate boxs',0)
      if(.not.ma_pop_stack(l_iown))
     + call md_abort('Failed to deallocate iown',0)
      if(.not.ma_pop_stack(l_buren))
     + call md_abort('Failed to deallocate buren',0)
      if(.not.ma_pop_stack(l_bindex))
     + call md_abort('Failed to deallocate bindex',0)
c
      return
      end
c $Id: argos_space_free.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine tce_mod1_new(rtdb,d_mod1,mpole)
c
c $Id: tce_mod1_new.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Spin-spatial-symmetry blocked dipole matrix transformations.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sym.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
c     formerly in tce_aod1_new.F
c
      integer rtdb               ! Run-time database
      double precision origin(3)
      data origin/0d0,0d0,0d0/
c
      integer mpole,mpoles        ! order of multipole, number of blocks
      integer g_aod1              ! AO dipole matrices
      integer l_aod1,k_aod1       ! AO dipole matrices
      integer l_mod1,k_mod1       ! MO dipole matrices
      integer l_work,k_work       ! Work space
      integer sf_size,sf_offset   ! SF size and offset
      integer d_mod1(*)           ! File handle
      integer g1b,g2b             ! Block indexes
      integer range_g1,range_g2   ! Block ranges
      integer offset_g1,offset_g2 ! Block offsets
      integer axis                ! 1=x, 2=y, 3=z
      integer alo(3),ahi(3),ld(2)
      logical nodezero,debugprint
      integer sym_abelian_axis    ! Move this to "sym.fh"
      external sym_abelian_axis
c
      nodezero = (ga_nodeid().eq.0)
      debugprint = .false.
      if (multipole.eq.1) then
        debugprint = debugprint.or.(util_print('aod1',print_debug))
        debugprint = debugprint.or.(util_print('mod1',print_debug))
      elseif (multipole.eq.2) then
        debugprint = debugprint.or.(util_print('aoq1',print_debug))
        debugprint = debugprint.or.(util_print('moq1',print_debug))
      elseif (multipole.eq.3) then
        debugprint = debugprint.or.(util_print('aoo1',print_debug))
        debugprint = debugprint.or.(util_print('moo1',print_debug))
      endif
c
      mpoles = (mpole+1)*(mpole+2)/2
c
c     formerly in tce_aod1_new.F
c
c     ===============
c     Allocate g_aod1
c     ===============
c
      alo(1) = nbf
      alo(2) = -1
      alo(3) = -1
      ahi(1) = nbf
      ahi(2) = nbf
      ahi(3) = mpoles ! formerly 3
      if (.not.nga_create(MT_DBL,3,ahi,'AO dipole ALL',alo,g_aod1))
     &    call errquit('aor_driver: nga_create failed g_aod1',0,GA_ERR)
      call ga_zero(g_aod1)
c
c     ====================
c     Make dipole matrices
c     ====================
c
#ifdef DEBUG_PRINT
      write(LuOut,*) 'calling int_mpole_1ega'
#endif
      if (mpole.eq.1) then
        call int_mpole_1ega(ao_bas_han,ao_bas_han,g_aod1,'dipole',
     &                      origin,.false.)
      elseif (mpole.eq.2) then
        call int_mpole_1ega(ao_bas_han,ao_bas_han,g_aod1,'quadrupole',
     &                      origin,.false.)
      elseif (mpole.eq.3) then
        call int_mpole_1ega(ao_bas_han,ao_bas_han,g_aod1,'octupole',
     &                      origin,.false.)
      endif
      if (debugprint) call ga_print(g_aod1)
c
c     end of what was formerly in tce_aod1_new.F
c
      do axis = 1,mpoles
        irrep_d = sym_abelian_axis(geom,axis)
        sf_size=0
        do g1b = 1,noa+nob+nva+nvb
          do g2b = 1,noa+nob+nva+nvb
            if (int_mb(k_spin+g1b-1) .eq. int_mb(k_spin+g2b-1)) then
            if ((.not.restricted).or.(int_mb(k_spin+g1b-1)
     1        +int_mb(k_spin+g2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+g1b-1),int_mb(k_sym+g2b-1))
     1        .eq. irrep_d) then
              sf_size = sf_size + int_mb(k_range+g1b-1)
     1                          * int_mb(k_range+g2b-1)
            endif
            endif
            endif
          enddo
        enddo
        if (.not.ma_push_get(mt_dbl,sf_size,'MO dipole',l_mod1,k_mod1))
     &      call errquit('tce_mod1_new: MA problem',3,MA_ERR)
        sf_offset=0
        do g2b = 1,noa+nob+nva+nvb
          do g1b = 1,noa+nob+nva+nvb
            if (int_mb(k_spin+g1b-1) .eq. int_mb(k_spin+g2b-1)) then
            if ((.not.restricted).or.(int_mb(k_spin+g1b-1)
     1        +int_mb(k_spin+g2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+g1b-1),int_mb(k_sym+g2b-1))
     1        .eq. irrep_d) then
              range_g1 = int_mb(k_range+g1b-1)
              range_g2 = int_mb(k_range+g2b-1)
              offset_g1 = int_mb(k_offset+g1b-1)*nbf
              offset_g2 = int_mb(k_offset+g2b-1)*nbf
              if (.not.ma_push_get(mt_dbl,range_g1*nbf,'Work',l_work,
     1          k_work)) call errquit('tce_mod1_new: MA problem',0,
     2          MA_ERR)
              if (.not.ma_push_get(mt_dbl,nbf*nbf*1,'AO dipole',l_aod1,
     1          k_aod1)) call errquit('tce_mod1_new: MA problem',1,
     2          MA_ERR)
c
c             OLD CALL
c              call ga_get(g_aod1(axis),1,nbf,1,nbf,dbl_mb(k_aod1),nbf)
c
c             NEW CALL
              alo(1) = 1
              ahi(1) = nbf
              alo(2) = 1
              ahi(2) = nbf
              alo(3) = axis 
              ahi(3) = axis ! 3 for dipole, 6 for quadrupole, 10 for octupole
              ld(1) = nbf 
              ld(2) = 1
              call nga_get(g_aod1,alo,ahi,dbl_mb(k_aod1),ld)
c
              call dgemm('T','N',range_g1,nbf,nbf,1.0d0,
     1          dbl_mb(k_movecs_sorted+offset_g1),nbf,dbl_mb(k_aod1),
     2          nbf,0.0d0,dbl_mb(k_work),range_g1)
              if (.not.ma_pop_stack(l_aod1))
     1          call errquit('tce_mod1_new: MA problem',2,MA_ERR)
              call dgemm('N','N',range_g1,range_g2,nbf,1.0d0,
     1          dbl_mb(k_work),range_g1,
     2          dbl_mb(k_movecs_sorted+offset_g2),nbf,
     3          0.0d0,dbl_mb(k_mod1+sf_offset),range_g1)
c              if (nodezero.and.util_print('mod1',print_debug))
c     1          call ma_print(dbl_mb(k_mod1+sf_offset),
c     2          range_g1,range_g2,'Spin symmetry block of dipole')
              if (.not.ma_pop_stack(l_work))
     1          call errquit('tce_mod1_new: MA problem',5,MA_ERR)
              sf_offset = sf_offset + range_g1 * range_g2
            endif
            endif
            endif
          enddo
        enddo
        call put_block(d_mod1(axis),dbl_mb(k_mod1),sf_size,0)
        if (.not.ma_pop_stack(l_mod1))
     1    call errquit('tce_mod1_new: MA problem',6,MA_ERR)
c
c       Debug printing
c
        if (debugprint) then
          if (nodezero) write(LuOut,*) 'MO multipole integrals'
          call ga_print(d_mod1)
        endif
c
      enddo
      if (.not.ga_destroy(g_aod1))
     1  call errquit('tce_mod1_new: GA problem',2,GA_ERR)
c
#ifdef DEBUG_PRINT
      write(LuOut,*) 'end of tce_mod1_new'
#endif
c
      return
      end

      subroutine tce_reference_check(rtdb,ref)
c
c $Id: tce_reference_check.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "errquit.fh"
c#include "tce.fh"
#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
c#include "tce_amps.fh"
c#include "tce_diis.fh"
      integer rtdb
      double precision ref
      logical scf
      external scf
      logical dft_energy
      external dft_energy
c
c     =========================
c     Ground-state HF/DFT first
c     =========================
c
      if (.not.rtdb_get(rtdb,'tce:reference',mt_int,1,reference)) then
        reference = 1
        if (.not.rtdb_put(rtdb,'tce:reference',mt_int,1,reference))
     1    call errquit('tce_property: failed to write reference',0,
     2    RTDB_ERR)
      endif
      if (reference.eq.0) then
        if (.not.dft_energy(rtdb)) return
        if (.not.rtdb_get(rtdb,'dft:energy',mt_dbl,1,ref))
     1    call errquit('tce_property: failed to get dft energy',0,
     2    RTDB_ERR)
      else if (reference.eq.1) then
        if (.not.scf(rtdb)) return
        if (.not.rtdb_get(rtdb,'scf:energy',mt_dbl,1,ref))
     1    call errquit('tce_property: failed to get scf energy',0,
     2    RTDB_ERR)
      else
        call errquit('tce_property: illegal reference',reference,
     1    UNKNOWN_ERR)
      endif
      return
      end

      subroutine smd_vel_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_vel,sp_atom
      character*32 tag,pname
      logical result

      pname = "smd_vel_init_system"




      write(*,*) "in "//pname
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      tag = "velocity"
      call smd_system_get_component(sp_vel,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_vel_init(sp_vel,sp_atom)
c      call smd_vel_set(sp_vel,sp_type,sp_param)
c
      return
      end

      subroutine smd_vel_init(sp_vel,sp_atom)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_vel
      character*(*) sp_atom
c
      character*32 pname
      integer na
c
      pname = "smd_vel_init"
c
c      write(*,*) "in "//pname
c
c     get total number of atoms 
c     -------------------------
      call smd_atom_ntot(sp_atom,na)
      if(na.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)
c
c     create vel data structures
c     ---------------------------
      call smd_namespace_create(sp_vel)
      call smd_data_create(sp_vel,"vel",3*na,MT_DBL)
      return
      end
c
      subroutine smd_vel_random_guess()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
c     
      character*72 sp_vel
      character*72 sp_param
      character*72 sp_type
      character*32 pname
      character*80 tag
      integer nt,na
      integer i_v,i_it
      integer i_m
      logical result
      double precision targetke,ke
c
      pname = "smd_type_init"
c
      write(*,*) "in "//pname
c
c     get components
c     --------------
      tag = "velocity"
      call smd_system_get_component(sp_vel,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


c
c     get velocity array
c     ------------------
      tag = "vel"
      call smd_data_get_index(sp_vel,tag,i_v,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      call  smd_data_get_size(sp_vel,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      na = na/3

c
c     get mass array
c     ------------------
      tag = "param:mass"
      call smd_data_get_index(sp_param,tag,i_m,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
c
c     get type array
c     --------------
      tag = "type:id"
      call smd_data_get_index(sp_type,tag,i_it,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

      call smd_temper_get_ke_target(targetke)
      if(targetke.eq.0.0d0) 
     >   call smd_temper_ke_compute(298.15,targetke)
      call smd_vel_random0(na,
     >                     targetke,
     >                     dbl_mb(i_v),
     >                     dbl_mb(i_m),
     >                     int_mb(i_it))

      call smd_vel_ke_compute(ke)
c      write(*,*) "current ke compared",targetke,ke
      return
      end

      subroutine smd_vel_write(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
      integer un
c     
      character*72 sp_vel
      character*72 sp_param
      character*72 sp_type
      character*32 pname
      character*80 tag
      integer nt,na
      integer i_v,i_it
      integer i_m
      logical result
      double precision targetke,ke
c
      pname = "smd_type_init"
c
c      write(*,*) "in "//pname
c
c     get components
c     --------------
      tag = "velocity"
      call smd_system_get_component(sp_vel,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
c     get velocity array
c     ------------------
      tag = "vel"
      call smd_data_get_index(sp_vel,tag,i_v,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      call  smd_data_get_size(sp_vel,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      na = na/3

      call smd_vel_write0(un,
     >                   na,
     >                   dbl_mb(i_v))

      return
      end

      subroutine smd_vel_read(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
      integer un
c     
      character*72 sp_vel
      character*72 sp_param
      character*72 sp_type
      character*32 pname
      character*80 tag
      integer nt,na
      integer i_v,i_it
      integer i_m
      logical result
      double precision targetke,ke
c
      pname = "smd_type_init"
c
c      write(*,*) "in "//pname
c
c     get components
c     --------------
      tag = "velocity"
      call smd_system_get_component(sp_vel,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
c     get velocity array
c     ------------------
      tag = "vel"
      call smd_data_get_index(sp_vel,tag,i_v,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      call  smd_data_get_size(sp_vel,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      na = na/3

      call smd_vel_read0(un,
     >                   na,
     >                   dbl_mb(i_v))

      return
      end

      subroutine smd_vel_ke_compute(targetke)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
c     
      character*72 sp_vel
      character*72 sp_param
      character*72 sp_type
      character*32 pname
      character*80 tag
      integer nt,na
      integer i_v,i_it
      integer i_m
      logical result
      double precision targetke
c
      pname = "smd_type_init"
c
c      write(*,*) "in "//pname
c
c     get components
c     --------------
      tag = "velocity"
      call smd_system_get_component(sp_vel,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


c
c     get velocity array
c     ------------------
      tag = "vel"
      call smd_data_get_index(sp_vel,tag,i_v,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      call  smd_data_get_size(sp_vel,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      na = na/3

c
c     get mass array
c     ------------------
      tag = "param:mass"
      call smd_data_get_index(sp_param,tag,i_m,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
c
c     get type array
c     --------------
      tag = "type:id"
      call smd_data_get_index(sp_type,tag,i_it,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

      call smd_vel_ke0(na,
     >                     targetke,
     >                     dbl_mb(i_v),
     >                     dbl_mb(i_m),
     >                     int_mb(i_it))

c      write(*,*) "current ke 1",targetke
      return
      end

      SUBROUTINE smd_vel_random0(natms,targetke,vvv,typmass,atmtype)

      implicit none

      integer natms
      double precision targetke
      double precision vvv(natms,3)
      double precision typmass(*)
      integer atmtype(*)
c
      integer i,iatm,iseed

      double precision   x
      double precision  commass,comxvv,comyvv,comzvv
      double precision  instanke,xscale

      iseed=620419483
      comxvv=0.d0
      comyvv=0.d0
      comzvv=0.d0
      commass = 0.0d0

      do i=1,natms

       iatm=atmtype(i)
       call tool_randm(iseed,x)
       vvv(i,1)=(x-0.5)/sqrt(typmass(iatm))
       call tool_randm(iseed,x)
       vvv(i,2)=(x-0.5)/sqrt(typmass(iatm))
       call tool_randm(iseed,x)
       vvv(i,3)=(x-0.5)/sqrt(typmass(iatm))

       comxvv=comxvv+vvv(i,1)*typmass(iatm)
       comyvv=comyvv+vvv(i,2)*typmass(iatm)
       comzvv=comzvv+vvv(i,3)*typmass(iatm)
       commass=commass+typmass(iatm)

      enddo

      comxvv=comxvv/commass
      comyvv=comyvv/commass
      comzvv=comzvv/commass

      do i=1,natms

       vvv(i,1)=vvv(i,1)-comxvv
       vvv(i,2)=vvv(i,2)-comyvv
       vvv(i,3)=vvv(i,3)-comzvv

      enddo

      instanke=0.d0

      do i=1,natms

       iatm=atmtype(i)
       instanke=instanke
     $         +typmass(iatm)*((vvv(i,1)**2+vvv(i,2)**2+vvv(i,3)**2))

      enddo

      instanke=0.5*instanke

      xscale=sqrt(targetke/instanke)

      do i=1,natms

       vvv(i,1)=xscale*vvv(i,1)
       vvv(i,2)=xscale*vvv(i,2)
       vvv(i,3)=xscale*vvv(i,3)

      enddo

      instanke=0.d0

      do i=1,natms

       iatm=atmtype(i)
       instanke=instanke
     $         +typmass(iatm)*((vvv(i,1)**2+vvv(i,2)**2+vvv(i,3)**2))

      enddo

      instanke=0.5*instanke

c      write(*,*) "current ke comp1",targetke,instanke

      return

      END

      SUBROUTINE smd_vel_read0(un,natms,vvv)

      implicit none

      integer un,natms
      double precision vvv(natms,3)
c
      integer i

      do i=1,natms

       read(un,*) vvv(i,1),vvv(i,2),vvv(i,3)

      enddo

      return

      END

      SUBROUTINE smd_vel_write0(un,natms,vvv)

      implicit none

      integer un,natms
      double precision vvv(natms,3)
c
      integer i

      do i=1,natms

       write(un,*) vvv(i,1),vvv(i,2),vvv(i,3)

      enddo

      return

      END

      SUBROUTINE smd_vel_ke0(natms,ke,vvv,typmass,atmtype)

      implicit none

      integer natms
      double precision targetke
      double precision vvv(natms,3)
      double precision typmass(*)
      integer atmtype(*)
c
      integer i,iatm

      double precision ke
c
      ke=0.d0

      do i=1,natms

       iatm=atmtype(i)
       ke=ke
     $          +typmass(iatm)*((vvv(i,1)**2+vvv(i,2)**2+vvv(i,3)**2))

      enddo

      ke=0.5*ke

      return

      END


c $Id: smd_vel.F 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE stpr_gmass(GRAD,ATMASS)
c $Id: stpr_gmass.f 19708 2010-10-29 18:04:21Z d3y133 $
C
C     This routine mass weights the gradient vector.
C
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      DIMENSION GRAD(NAT3)
      DIMENSION ATMASS(NATOM)
      IATOM(I)  = (I+2)/3
C
      DO 00100 II = 1,NAT3
         IATII = IATOM(II)
         FACT = SQRT(ATMASS(IATII))
         GRAD(II) = GRAD(II)/FACT
00100 CONTINUE
      WRITE(6,9000)
      CALL stpr_matout(GRAD,NAT3,1,NAT3)
c      WRITE(6,*)(GRAD(I),I=1,NAT3)
 9000 FORMAT(/,10X,52('-'),
     &  /,10X,'Mass-weighted gradient (atomic units)',
     &  /,10X,52('-'),//)
      RETURN
      END

      logical function argos_prepare_transl(itran,jtran,xtran,is,xs,msa,
     + nsa)
c
c $Id: argos_prepare_transl.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer msa,nsa,itran,jtran
      integer is(msa)
      real*8 xs(3,msa),xtran(3)
c
      integer i,j
c
      if(nsa.le.0.or.itran.le.0.or.jtran.gt.nsa) then
      argos_prepare_transl=.false.
      return
      endif
c
      do 1 i=1,nsa
      if(is(i).ge.itran.and.is(i).le.jtran) then
      do 2 j=1,3
      xs(j,i)=xs(j,i)+xtran(j)
    2 continue
      endif
    1 continue
c
      argos_prepare_transl=.true.
c
      return
      end

      subroutine tce_eomccsd_1prdm(d_hh,d_pp,d_t1,d_t2,d_x0,d_x1,d_x2,
     1                         d_y1,d_y2,k_hh_offset,k_pp_offset,
     1                         k_t1_offset,k_t2_offset,
     1                         k_x0_offset,k_x1_offset,k_x2_offset,
     3                         k_y1_offset,k_y2_offset)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "rtdb.fh"
      integer d_hh,k_hh_offset
      integer d_pp,k_pp_offset
      integer d_t1,k_t1_offset
      integer d_t2,k_t2_offset
      integer d_x0,k_x0_offset
      integer d_x1,k_x1_offset
      integer d_x2,k_x2_offset
      integer d_y1,k_y1_offset
      integer d_y2,k_y2_offset
c
      character*255 filename
c     ====
c     1PDM
c     ====
      integer d_hp,l_hp_offset,k_hp_offset,size_hp
      integer d_ph,l_ph_offset,k_ph_offset,size_ph
      integer d_1pdm,l_1pdm_offset,k_1pdm_offset,size_1pdm
c     ====================
c     atomic orbital tiles
c     ====================
c      integer atpart
c      integer nalength(200)
c      integer a2length(200)
c
      double precision cpu,wall,r1,residual
      integer dummy, iter
c     ==============
c     GA for 1PDM_AO
c     ==============
      integer  ga_create_atom_blocked
      external ga_create_atom_blocked
      integer  g_1pdm
c
      logical  nodezero
c
      integer g1b, g1
      integer dima, l_a, k_a
c
c     parallel
      integer next
      integer count
      integer nxtask
      external nxtask
      integer nprocs
c
      nodezero=(ga_nodeid().eq.0)
c
c     ============================================================
c     !!! Attention: frozen orbital option was not considered !!!
c     ============================================================
c
c     ==========================
c     1PDM Hole-Particle Block
c     ==========================
      call tce_filename('hp',filename)
      call tce_dens_hp_offset(l_hp_offset,k_hp_offset,size_hp)
      call createfile(filename,d_hp,size_hp)
      call eomccsd_1pdm_hp_mo(d_hp,d_x0,d_x1,d_y1,d_y2,
     1      k_hp_offset,k_x0_offset,k_x1_offset,
     2      k_y1_offset,k_y2_offset)
      call reconcilefile(d_hp,size_hp)
c     ===========================
c     1PDM Particle-Hole Block
c     ==========================
      call tce_filename('ph',filename)
      call tce_dens_ph_offset(l_ph_offset,k_ph_offset,size_ph)
      call createfile(filename,d_ph,size_ph)
      call eomccsd_1pdm_ph_mo(d_ph,d_t1,d_t2,
     1              d_x0,d_x1,d_x2,d_y1,d_y2,
     1     k_ph_offset,k_t1_offset,k_t2_offset,
     1     k_x0_offset,k_x1_offset,k_x2_offset,
     1     k_y1_offset,k_y2_offset)
      call reconcilefile(d_ph,size_ph)
c     =====================================================================================================
c     put 1PDM Hole-Hole, Hole-Particle, Particle-Hole, and Particle-Particle Block four pieces in one file
c     =====================================================================================================
      call tce_filename('1pdm',filename)
      call tce_1pdm_offset(l_1pdm_offset,k_1pdm_offset,size_1pdm)
      call createfile(filename,d_1pdm,size_1pdm)
c
      call put_1pdm_hh(d_1pdm,k_1pdm_offset,d_hh,k_hh_offset)
      call put_1pdm_hp(d_1pdm,k_1pdm_offset,d_hp,k_hp_offset)
      call put_1pdm_ph_2(d_1pdm,k_1pdm_offset,d_ph,k_ph_offset)
      call put_1pdm_pp(d_1pdm,k_1pdm_offset,d_pp,k_pp_offset)
      call reconcilefile(d_1pdm,size_1pdm)
c    =================================
c    HF REFERENCE CONTRIBUTION TO 1PDM
c    =================================
      nprocs=ga_nnodes( )
      count=0
      next=nxtask(nprocs,1)
c
      do g1b=1,noab
         if(count.eq.next) then
c
         if ((.not.restricted).or.(int_mb(k_spin+g1b-1).ne.2)) then
            dima=int_mb(k_range+g1b-1)*int_mb(k_range+g1b-1)
            if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
     1      call errquit('tce_eomccsd_1prdm: ma problem',2,ma_err)
            call get_hash_block(d_1pdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            do g1=1,int_mb(k_range+g1b-1)
               dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))=
     1         dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))+1.d0
            enddo
            call put_hash_block(d_1pdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            if (.not.ma_pop_stack(l_a))
     1      call errquit('tce_eomccsd_1prdm: ma problem',3,ma_err)
         endif
         next=nxtask(nprocs,1)
         endif
         count=count+1
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c     ====================================
c     Do the back transformation
c     ===================================
      g_1pdm = ga_create_atom_blocked(geom, ao_bas_han,
     $         'density matrix')
c      call ga_zero(g_1pdm)
      call ao_tiles(atpart,nalength,a2length,30)
      call btrans1(d_1pdm,k_1pdm_offset,g_1pdm,atpart,nalength)
c      call ga_symmetrize(g_1pdm)
c     ====================================
c     DUMP it to a file
c     ====================================
c      call ga_zero(g_1pdm)
c      call ga_print(g_1pdm)
      call ao_1prdm_write(nbf,g_1pdm)
c      call ao_1prdm_read(nbf,g_1pdm)
c      call ga_print(g_1pdm)
c     =============================
c     clean up the files and arrays
c     =============================
      if (.not. ga_destroy(g_1pdm)) call errquit
     1   ('tce_ccsd_1prdm: error destroying density', 1, GA_ERR)
c
      call deletefile(d_1pdm)
      if(.not.ma_pop_stack(l_1pdm_offset))
     1  call errquit('tce_ccsd_1prdm: ma problem',17,ma_err)
c
      call deletefile(d_ph)
      if(.not.ma_pop_stack(l_ph_offset))
     1  call errquit('tce_ccsd_1prdm: ma problem',17,ma_err)
c
      call deletefile(d_hp)
      if(.not.ma_pop_stack(l_hp_offset))
     1  call errquit('tce_ccsd_1prdm: ma problem',17,ma_err)
c
      end
c $Id: tce_eomccsd_1prdm.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine esp_rtdbin
c
c $Id: esp_rtdbin.F 25368 2014-03-21 06:10:42Z niri $
c
      implicit none
c
#include "esp_params.fh"
#include "esp_common.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "bas.fh"
#include "mafdecls.fh"
c
      integer i
c
c     get input from rtdb
c
      resb=0.0d0
c
c     load geometry
c
      if(.not.geom_create(igeom,'geometry'))
     + call md_abort('esp: geom_create failed',me)
c
      if(.not.geom_rtdb_load(irtdb,igeom,'geometry'))
     + call md_abort('esp: geom_rtdb_load failed',me)
c
      if(.not.geom_ncent(igeom,natoms))
     + call md_abort('esp: geom_ncent failed',me)
c
c     load the basis set
c
      if(.not.bas_create(ibasis,'ao basis'))
     + call md_abort('esp: bas_create failed',me)
c
      if(.not.bas_rtdb_load(irtdb,igeom,ibasis,'ao basis'))
     + call md_abort('esp: bas_rtdb_load failed',me)
c
      if(.not.bas_numbf(ibasis,nbf))
     + call md_abort('esp: bas_numbf failed',me)
c     
      if(.not.geom_nuc_charge(igeom,chgnuc))
     + call md_abort('esp: geom_nuc_charge failed',me)
c
c     get cutoff radius and gridspacing
c
      if(.not.rtdb_cget(irtdb,"esp:input vectors",1,movfil)) 
     +    movfil = ' '
      if(.not.rtdb_get(irtdb,'esp:probe',mt_dbl,1,probe)) probe=0.07d0
      if(.not.rtdb_get(irtdb,'esp:factor',mt_dbl,1,factor))
     +  factor=1.00d0
      if(.not.rtdb_get(irtdb,'esp:rcut',mt_dbl,1,rcut)) rcut=0.3d0
      if(.not.rtdb_get(irtdb,'esp:spac',mt_dbl,1,spac)) spac=0.05d0
      if(.not.rtdb_get(irtdb,'esp:radius',mt_dbl,107,radius)) then
      radius(  1)=0.030d0
      radius(  2)=0.122d0
      radius(  3)=0.123d0
      radius(  4)=0.089d0
      radius(  5)=0.088d0
      radius(  6)=0.077d0
      radius(  7)=0.070d0
      radius(  8)=0.066d0
      radius(  9)=0.058d0
      radius( 10)=0.160d0
      radius( 11)=0.140d0
      radius( 12)=0.136d0
      radius( 13)=0.125d0
      radius( 14)=0.117d0
      radius( 15)=0.110d0
      radius( 16)=0.104d0
      radius( 17)=0.099d0
      radius( 18)=0.191d0
      radius( 19)=0.203d0
      radius( 20)=0.174d0
      radius( 21)=0.144d0
      radius( 22)=0.132d0
      radius( 23)=0.122d0
      radius( 24)=0.119d0
      radius( 25)=0.117d0
      radius( 26)=0.117d0
      radius( 27)=0.116d0
      radius( 28)=0.115d0
      radius( 29)=0.117d0
      radius( 30)=0.125d0
      radius( 31)=0.125d0
      radius( 32)=0.122d0
      radius( 33)=0.121d0
      radius( 34)=0.117d0
      radius( 35)=0.114d0
      radius( 36)=0.198d0
      radius( 37)=0.222d0
      radius( 38)=0.192d0
      radius( 39)=0.162d0
      radius( 40)=0.145d0
      radius( 41)=0.134d0
      radius( 42)=0.129d0
      radius( 43)=0.127d0
      radius( 44)=0.124d0
      radius( 45)=0.125d0
      radius( 46)=0.128d0
      radius( 47)=0.134d0
      radius( 48)=0.141d0
      radius( 49)=0.150d0
      radius( 50)=0.140d0
      radius( 51)=0.141d0
      radius( 52)=0.137d0
      radius( 53)=0.133d0
      radius( 54)=0.209d0
      radius( 55)=0.235d0
      radius( 56)=0.198d0
      radius( 57)=0.169d0
      radius( 58)=0.165d0
      radius( 59)=0.165d0
      radius( 60)=0.164d0
      radius( 61)=0.165d0
      radius( 62)=0.166d0
      radius( 63)=0.165d0
      radius( 64)=0.161d0
      radius( 65)=0.159d0
      radius( 66)=0.159d0
      radius( 67)=0.158d0
      radius( 68)=0.157d0
      radius( 69)=0.156d0
      radius( 70)=0.156d0
      radius( 71)=0.156d0
      radius( 72)=0.144d0
      radius( 73)=0.134d0
      radius( 74)=0.130d0
      radius( 75)=0.128d0
      radius( 76)=0.126d0
      radius( 77)=0.126d0
      radius( 78)=0.129d0
      radius( 79)=0.134d0
      radius( 80)=0.144d0
      radius( 81)=0.155d0
      radius( 82)=0.154d0
      radius( 83)=0.152d0
      radius( 84)=0.153d0
      radius( 85)=0.150d0
      radius( 86)=0.220d0
      radius( 87)=0.324d0
      radius( 88)=0.268d0
      radius( 89)=0.225d0
      radius( 90)=0.216d0
      radius( 91)=0.193d0
      radius( 92)=0.166d0
      radius( 93)=0.157d0
      radius( 94)=0.181d0
      radius( 95)=0.221d0
      radius( 96)=0.143d0
      radius( 97)=0.142d0
      radius( 98)=0.140d0
      radius( 99)=0.139d0
      radius(100)=0.138d0
      radius(101)=0.137d0
      radius(102)=0.136d0
      radius(103)=0.134d0
      radius(104)=0.130d0
      radius(105)=0.130d0
      radius(106)=0.130d0
      radius(107)=0.130d0
      endif
      if(.not.rtdb_get(irtdb,'esp:nconst',mt_int,1,nconst)) nconst=0
      if(nconst.gt.0) then
      if(.not.rtdb_get(irtdb,'esp:ncon',mt_int,1,ncon))
     + call md_abort('Error reading ncon from rtdb',ncon)
      if(.not.rtdb_get(irtdb,'esp:icon',mt_int,ncon,icon))
     + call md_abort('Error reading icon from rtdb',ncon)
      if(.not.rtdb_get(irtdb,'esp:rcon',mt_dbl,nconst,rcon))
     + call md_abort('Error reading rcon from rtdb',nconst)
      endif
      if(.not.rtdb_get(irtdb,'esp:irest',mt_int,1,irest)) irest=0
      if(irest.gt.0) then
      if(.not.rtdb_get(irtdb,'esp:resa',mt_dbl,1,resa)) resa=0.005d0
      if(.not.rtdb_get(irtdb,'esp:resc',mt_dbl,1,resc)) resc=0.010d0
      if(.not.rtdb_get(irtdb,'esp:hfree',mt_int,1,ihfree)) ihfree=0
      if(irest.gt.1) then
      if(.not.rtdb_get(irtdb,'esp:resa',mt_dbl,1,resa)) resa=0.001d0
      if(.not.rtdb_get(irtdb,'esp:resb',mt_dbl,1,resb)) resb=0.1d0
      if(.not.rtdb_get(irtdb,'esp:resc',mt_dbl,1,resc)) resc=0.002d0
      if(.not.rtdb_get(irtdb,'esp:resd',mt_dbl,1,resd)) resd=0.1d0
      endif
      if(.not.rtdb_get(irtdb,'esp:maxit',mt_int,1,maxit)) maxit=25
      if(.not.rtdb_get(irtdb,'esp:toler',mt_dbl,1,toler)) toler=1.0d-4
      endif
      if(.not.rtdb_get(irtdb,'esp:dump',mt_int,1,idump)) idump=0
      if(.not.rtdb_get(irtdb,'esp:screen',mt_int,1,lscrn)) lscrn=0
      if(.not.rtdb_get(irtdb,'esp:scrtol',mt_dbl,1,scrtol))
     + scrtol=1.0d-9
      if(.not.rtdb_get(irtdb,'esp:qh',mt_dbl,1,qh)) qh=0.0d0
      if(.not.rtdb_get(irtdb,'esp:newgrd',mt_int,1,newgrd)) newgrd=0
      if(.not.rtdb_get(irtdb,'esp:denmat',mt_int,1,denmat)) denmat=0
c
c     convert rcut and spac from nm to au
c
      rcut=cnm2au*rcut
      spac=cnm2au*spac
c
      nconst=nconst+1
c
      do 1 i=1,107
        radius(i)=factor*(radius(i)+probe)
    1 continue
c
      return
      end

      SUBROUTINE ccsdtq_lr_alpha_17(d_a,k_a_offset,d_b,k_b_offset,d_c,k_
     &c_offset)
C     $Id: ccsdtq_lr_alpha_17.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_vtratrb + = 1/2 * Sum ( h2 p1 ) * trb ( p1 h2 )_trb * i1 ( h2 p1 )_vtra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER h2b
      INTEGER p1b_1
      INTEGER h2b_1
      INTEGER h2b_2
      INTEGER p1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      IF (next.eq.count) THEN
      IF (0 .eq. ieor(irrep_v,ieor(irrep_tra,irrep_trb))) THEN
      dimc = 1
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_17',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      DO h2b = 1,noab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1)) .eq. irrep_trb) 
     &THEN
      CALL TCE_RESTRICTED_2(p1b,h2b,p1b_1,h2b_1)
      CALL TCE_RESTRICTED_2(h2b,p1b,h2b_2,p1b_2)
      dim_common = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_17',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_17',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_17',3,MA
     &_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_17',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_17',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (h2b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p1b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_17',6,MA
     &_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_17'
     &,7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_17'
     &,8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_17',9,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_c_sort),dbl_mb(k_c),1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_17',10,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_17'
     &,11,MA_ERR)
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

************************************************************************
*                                                                      *
      subroutine ecp_t2_init1 (n,ldQ,m_min,m_max,j,h,tol,ai,bi,
     &    alpha,beta,gamma,prefactor,temp,ind,Q)
*                                                                      *
*   Calculate values of Q^1_{mm}, Q^2_{m+1m} and Q^2_{mm+1}            *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   n (inp) - number of functions to evaluate                          *
*   ldQ (inp) - leading dimension of array Q                           *
*   m_min (inp) - minimum value of m                                   *
*   m_max (inp) - maximum value of m                                   *
*   l_a (inp) - (maximum) angular momentum of functions on centre a    *
*   l_b (inp) - (maximum) angular momentum of functions on centre b    *
*   tol (inp) - maximum relative error in bessel functions             *
*   ai (inp) - 1/a                                                     *
*   bi (inp) - 1/b                                                     *
*   alpha (inp) -  a/2sqrt(c)                                          *
*   beta (inp) - b/2sqrt(c)                                            *
*   gamma (inp) - 1/sqrt(c)                                            *
*   prefactor (inp) - exponential prefactor (see calling routine)      *
*   temp - work array                                                  *
*   ind (scr) - index array for bessel driver                          *
*   Q (out) - uncontracted Q integrals                                 *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
* $Id: ecp_t2_init1.f 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
      integer h,i,j,ja,jb,jl,js,k,ldQ,m,m_min,m_max,mm,mp,n,na,nb,nl,
     &    ns,nq,ind(n)
      double precision ai(n),bi(n),alpha(n),beta(n),gamma(n),
     &    prefactor(n),temp(n,18),Q(ldQ,m_min:m_max,2),
     &    tol,one,two,cutoff,big,afac,bfac
      parameter (one = 1.0d00, two = 2.0d00,
     &    cutoff = 24.5d00, big = 75.0d00)
*
*   Gather arguments for quadrature and single power series
*   Quadrature starts at alpha*beta=cutoff
*
      if (n .eq. 0) return
C      write (6,'(/A,/)') 'p=1 start values'
      nq = 0
      ns = 0
      do i = 1,n
        if (alpha(i)*beta(i) .ge. cutoff) then
          nq = nq+1
          ind(i) = nq
        else 
          ns = ns-1
          ind(i) = ns
        end if
      end do
*
*   Subdivide arguments for different ranges in the quadrature
*   and into alpha > beta and alpha < beta for the power series
*
      na = nq
      nb = n+1
      ns = 0
      nl = nq+1
      do i = 1,n
        if (ind(i) .gt. 0) then
          if (alpha(i)+beta(i) .le. big) then
            ns = ns+1
            ind(i) = ns
            temp(ns,1) = alpha(i)
            temp(ns,2) = beta(i)
            temp(ns,3) = gamma(i)
          else
            nl = nl-1
            ind(i) = nl
            temp(nl,1) = alpha(i)
            temp(nl,2) = beta(i)
            temp(nl,3) = gamma(i)
          end if
        else
          if (alpha(i) .le. beta(i)) then
            na = na+1
            ind(i) = na
            temp(na,1) = alpha(i)
            temp(na,2) = beta(i)
            temp(na,3) = gamma(i)
          else
            nb = nb-1
            ind(i) = nb
            temp(nb,2) = alpha(i)
            temp(nb,1) = beta(i)
            temp(nb,3) = gamma(i)
          end if
        end if
      end do
      js = 1
      jl = nl
      ja = nq+1
      jb = nb
      nl = nq-ns
      nb = n-na
      na = na-nq
C      write (6,*) 'na,nb,ns,nl',na,nb,ns,nl
*
*   Evaluate Q^1_{mm} functions. Note that the function for m_max is
*   not required for the recursion.
*
      do m = m_min,max(m_max-1,m_min)
        if (ns .gt. 0) call ecp_t2_ghq (1,m,m,ns,12,temp(js,1),
     &      temp(js,2),temp(js,3),temp(js,6),temp(js,4),temp(js,5),tol)
        if (nl .gt. 0) call ecp_t2_ghq (1,m,m,nl,6,temp(jl,1),
     &      temp(jl,2),temp(jl,3),temp(jl,6),temp(jl,4),temp(jl,5),tol)
        if (na .gt. 0) call ecp_t2_p1pow (na,m,0,temp(ja,1),temp(ja,2),
     &      temp(ja,3),temp(ja,4),temp(ja,6),temp(ja,7),temp(ja,5),tol)
        if (nb .gt. 0) call ecp_t2_p1pow (nb,m,0,temp(jb,1),temp(jb,2),
     &      temp(jb,3),temp(jb,4),temp(jb,6),temp(jb,7),temp(jb,5),tol)
        do i = 1,n
          Q(i,m,1) = prefactor(i)*temp(ind(i),5)
C          write (6,'(i5,1pe20.10)') i,Q(i,m,2)
        end do
      end do
*
C      write (6,'(2I5,1pe20.10)') ((i,m,Q(i,m,1),i=1,n),m=m_min,m_max)
      if (m_min .eq. m_max) return
*
*   Evaluate Q^1_{mm-1} or Q^1_{m-1m} functions
*
      k = j-h
      do m = m_max-1,max(m_max-2,m_min),-1
        if (ns .gt. 0) call ecp_t2_ghq (2,m+j,m+h,ns,12,temp(js,1),
     &      temp(js,2),temp(js,3),temp(js,6),temp(js,4),temp(js,5),tol)
        if (nl .gt. 0) call ecp_t2_ghq (2,m+j,m+h,nl,6,temp(jl,1),
     &      temp(jl,2),temp(jl,3),temp(jl,6),temp(jl,4),temp(jl,5),tol)
        if (na .gt. 0) call ecp_t2_p1pow (na,m+h,k,temp(ja,1),
     &      temp(ja,2),temp(ja,3),temp(ja,4),temp(ja,6),temp(ja,7),
     &      temp(ja,5),tol)
        if (nb .gt. 0) call ecp_t2_p1pow (nb,m+j,-k,temp(jb,1),
     &      temp(jb,2),temp(jb,3),temp(jb,4),temp(jb,6),temp(jb,7),
     &      temp(jb,5),tol)
        do i = 1,n
          Q(i,m,2) = prefactor(i)*temp(ind(i),5)
C          write (6,'(2i5,1pe20.10)') i,m,Q(i,m,2)
        end do
      end do
*
      do m = m_max-2,m_min+1,-1
        mm = m-1
        mp = m+1
        afac = 2*mp+k
        bfac = 2*mp-k
        do i = 1,n
          Q(i,mm,2) = Q(i,mp,2) 
     &        + afac*Q(i,m+j,1)*ai(i)
     &        + bfac*Q(i,m+h,1)*bi(i)
C          write (6,'(2i5,1pe20.10)') i,mm,Q(i,mm,2)
        end do
      end do
*
      return
      end

*
* $Id: numbers.f 22489 2012-05-16 01:44:09Z d3y133 $
*
      program numbers
      implicit integer (a-z)
c
      maxdiff = 0
      do i = 7,2048
         n = i
         call fastj_optimize_n(n,'upperbound')
         if (abs(n-i) .gt. maxdiff) then
            maxdiff = abs(n-i)
            write(6,*) i, n, maxdiff
         endif
      enddo
c
      write(6,*) ' upperbound ', maxdiff
c
      maxdiff = 0
      do i = 7,2048
         n = i
         call fastj_optimize_n(n,'nearby')
         if (abs(n-i) .gt. maxdiff) then
            maxdiff = abs(n-i)
            write(6,*) i, n, maxdiff
         endif
      enddo
      write(6,*) ' nearby ', maxdiff
c
      end
      subroutine fastj_optimize_n(n, mode)
      implicit none
      integer n
      character*(*) mode
c
      integer n2, n3, n5, ii2, ii3, ii5, i2, i3, i5
      double precision test, diff
c
      n = n + 1                 ! Temporarily to force to power of radix
c
      n2 = log(dble(n))/log(2.0d0) + 1
      n3 = log(dble(n))/log(3.0d0) + 1
      n5 = log(dble(n))/log(5.0d0) + 1
      ii2 = 0
      ii3 = 0
      ii5 = 0
      diff = n
      do i2 = 0, n2
         do i3 = 0, n3
            do i5 = 0, n5
               test = (2.0d0**i2)*(3.0d0**i3)*(5.0d0**i5) + 1d-6
               if (test.ge.n .or. mode.ne.'upperbound') then
                  if (abs(test-n) .lt. diff) then
                     diff = abs(test - n)
                     ii2 = i2
                     ii3 = i3
                     ii5 = i5
                  endif
               endif
            enddo
         enddo
      enddo
c
      n = (2.0d0**ii2)*(3.0d0**ii3)*(5.0d0**ii5)  - 1
c
      end
      

      logical function argos_prep_params(lfnpar,lfnout,nparms,mparms,
     + releps,q14fac,ignore,
     + latm,catm,matm,natm,
     + lbnd,rbnd,mbnd,nbnd,lang,rang,mang,nang,
     + ldih,nfdih,kdih,rdih,mdih,ndih,limp,kimp,rimp,mimp,nimp,
     + latt,lats,catt,patt,ratt,matt,natt,mats,nats,
     + lseq,cseq,mseq,nseq,icomb)
c
c $Id: argos_prep_params.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
#include "mafdecls.fh"
#include "argos_prep_common.fh"
c
      logical argos_prep_ffield,argos_prep_parcnv,argos_prep_check,
     + argos_prep_dummy,argos_prep_multip
      external argos_prep_ffield,argos_prep_parcnv,argos_prep_check,
     + argos_prep_dummy,argos_prep_multip
c
      integer lfnpar,lfnout,ignore,nparms,mparms
      integer matm,natm
      integer latm(11,matm)
      character*6 catm(mparms,matm)
      integer mbnd,nbnd
      integer lbnd(4,mbnd)
      real*8 rbnd(nparms,2,mbnd)
      integer mang,nang
      integer lang(5,mang)
      real*8 rang(nparms,4,mang)
      integer mdih,ndih
      integer ldih(6,mdih),nfdih(nparms,mdih),kdih(6,nparms,mdih)
      real*8 rdih(6,nparms,2,mdih)
      integer mimp,nimp
      integer limp(6,mimp),kimp(nparms,mimp)
      real*8 rimp(nparms,2,mimp)
      integer matt,natt,mats,nats
      integer latt(matt),lats(nparms,mats)
      character*6 catt(2,matt)
      real*8 patt(4,2,matt,matt),ratt(matt)
      integer mseq,nseq
      integer lseq(6,mseq)
      character*10 cseq(mseq)
c
      integer i,j,k,kk,lp,ld,icomb,len
      character*255 filnam
      real*8 releps,q14fac
c
c     make atom type list
c     -------------------
c
c     natt : number of atom types
c
      natt=0
      do 1 i=1,natm
      do 2 j=1,nparms
      do 3 k=1,natt
      if(catm(1+j,i).eq.catt(1,k)) goto 2
    3 continue
      natt=natt+1
      if(natt.gt.matt) call md_abort('increase matt',9999)
      catt(1,natt)=catm(1+j,i)
      latt(natt)=0
    2 continue
    1 continue
c
      nats=0
      do 5 i=1,natm
      do 4 j=1,nats
      kk=0
      do 44 k=1,nparms
      if(catm(k+1,i).eq.catt(1,lats(k,j))) kk=kk+1
   44 continue
      if(kk.eq.nparms) then
      latm(3,i)=j
      goto 5
      endif
    4 continue
      nats=nats+1
      if(nats.gt.mats) call md_abort('increase mats',9999)
      do 6 k=1,natt
      do 66 kk=1,nparms
      if(catm(kk+1,i).eq.catt(1,k)) lats(kk,nats)=k
   66 continue
    6 continue
      latm(3,i)=nats
    5 continue
c
c     substitute parameters parameter files
c     -------------------------------------
c
      icomb=0
c
      do 544 i=1,mdirpar
      do 545 j=1,nfilpar(i)
      write(filnam,'(a,a)') dirpar(i)(1:index(dirpar(i),' ')-1),
     + filpar(i,j)(1:index(filpar(i,j),' '))
      len=index(filnam,' ')-1
      if(.not.argos_prep_ffield(1,lfnpar,filnam,lfnout,q14fac,releps,
     + icomb,latt,catt,patt,ratt,matt,natt,latm,catm,matm,natm,
     + lbnd,rbnd,mbnd,nbnd,lang,rang,mang,nang,
     + ldih,nfdih,kdih,rdih,mdih,ndih,
     + limp,kimp,rimp,mimp,nimp,nparms,mparms)) then
      endif
  545 continue
  544 continue
c
      if(util_print('topology',print_default)) then
      write(lfnout,1000)
 1000 format(' ')
      endif
c
c     convert non-bonded parameters to C6 and C12
c     -------------------------------------------
c
      if(.not.argos_prep_parcnv(icomb,latt,patt,catt,matt,natt))
     + call md_abort('argos_prep_parcnv failed',9999)
c
c     copy bonded parameters for dummy atoms
c     --------------------------------------
c
      if(.not.argos_prep_dummy(lfnout,latt,catt,patt,ratt,matt,natt,
     + latm,catm,matm,natm,lbnd,rbnd,mbnd,nbnd,lang,rang,mang,nang,
     + ldih,nfdih,kdih,rdih,mdih,ndih,
     + limp,kimp,rimp,mimp,nimp,nparms,mparms))
     + call md_abort('argos_prep_dummy failed',9999)
c
c     check if all required parameters have been found
c     ------------------------------------------------
c
      if(.not.argos_prep_check(lfnout,nparms,mparms,ignore,
     + latt,catt,matt,natt,catm,latm,matm,natm,lbnd,mbnd,nbnd,
     + lang,mang,nang,ldih,mdih,ndih,limp,mimp,nimp,
     + lseq,cseq,mseq,nseq))
     + call md_abort('argos_prep_check failed',9999)
c
c     check for angles, dihedrals and impropers that involve more than 2 processors
c
      if(.not.argos_prep_multip(lseq,mseq,nseq,latm,matm,natm,
     + lang,mang,nang,ldih,mdih,ndih,limp,mimp,nimp))
     + call md_abort('argos_prep_multip failed',9999)
c
      argos_prep_params=.true.
      return
      end
 

      SUBROUTINE ccsdt_lr_beta_4_4_17_6(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdt_lr_beta_4_4_17_6.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 p14 h12 h15 )_ytratrc + = 2 * Sum ( h8 h9 p5 p6 ) * trc ( p5 p6 p14 h8 h9 h15 )_trc * i3 ( h2 h8 h9 h12 p5 p6 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p14b
      INTEGER h2b
      INTEGER h15b
      INTEGER h12b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER h8b
      INTEGER h9b
      INTEGER p14b_1
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h15b_1
      INTEGER h8b_1
      INTEGER h9b_1
      INTEGER h2b_2
      INTEGER h8b_2
      INTEGER h9b_2
      INTEGER h12b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p14b = noab+1,noab+nvab
      DO h2b = 1,noab
      DO h15b = 1,noab
      DO h12b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p14b-
     &1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h15b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p14b-1) .eq. int_mb(k_spin+
     &h12b-1)+int_mb(k_spin+h15b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p14b-1),ieor(int_mb
     &(k_sym+h12b-1),int_mb(k_sym+h15b-1)))) .eq. ieor(irrep_y,ieor(irre
     &p_tra,irrep_trc))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p14b-1) * int_mb(k_r
     &ange+h12b-1) * int_mb(k_range+h15b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_4_4_17_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h8b = 1,noab
      DO h9b = h8b,noab
      IF (int_mb(k_spin+p14b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+p14b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+p6b-1),ieor(int_mb(k_sym+h15b-1),ieor(int_mb(k_sym+h8b-1),i
     &nt_mb(k_sym+h9b-1)))))) .eq. irrep_trc) THEN
      CALL TCE_RESTRICTED_6(p14b,p5b,p6b,h15b,h8b,h9b,p14b_1,p5b_1,p6b_1
     &,h15b_1,h8b_1,h9b_1)
      CALL TCE_RESTRICTED_6(h2b,h8b,h9b,h12b,p5b,p6b,h2b_2,h8b_2,h9b_2,h
     &12b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+h8b-1) * int_mb(k_range+h9b-1)
      dima_sort = int_mb(k_range+p14b-1) * int_mb(k_range+h15b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h12b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_4_4_17_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_beta_4_4_17_6',2,MA_ERR)
      IF ((p6b .le. p14b) .and. (h9b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (p14b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p14b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h15b-1),6,3,5,4,2,1,1.0d0)
      END IF
      IF ((p6b .le. p14b) .and. (h8b .le. h15b) .and. (h15b .lt. h9b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h8b_1 - 1 + noab * (p14b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p14b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h9b-1),5,3,6,4,2,1,-1.0d0)
      END IF
      IF ((p6b .le. p14b) .and. (h15b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h15b_1 - 1 + noab * (p14b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p14b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),4,3,6,5,2,1,1.0d0)
      END IF
      IF ((p5b .le. p14b) .and. (p14b .lt. p6b) .and. (h9b .le. h15b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p14b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h15b-1),6,2,5,4,3,1,-1.0d0)
      END IF
      IF ((p5b .le. p14b) .and. (p14b .lt. p6b) .and. (h8b .le. h15b) .a
     &nd. (h15b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h8b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p14b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h9b-1),5,2,6,4,3,1,1.0d0)
      END IF
      IF ((p5b .le. p14b) .and. (p14b .lt. p6b) .and. (h15b .lt. h8b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h15b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p14b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),4,2,6,5,3,1,-1.0d0)
      END IF
      IF ((p14b .lt. p5b) .and. (h9b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p14b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p14b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h15b-1),6,1,5,4,3,2,1.0d0)
      END IF
      IF ((p14b .lt. p5b) .and. (h8b .le. h15b) .and. (h15b .lt. h9b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (h8b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p14b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p14b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+h8b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h9b-1),5,1,6,4,3,2,-1.0d0)
      END IF
      IF ((p14b .lt. p5b) .and. (h15b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h15b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p14b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p14b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+h15b-
     &1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),4,1,6,5,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_beta_4_4_17_6',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_4_4_17_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_beta_4_4_17_6',5,MA_ERR)
      IF ((h9b .lt. h2b) .and. (h12b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h2b_2 - 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,3,2,1,6,5,1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (h2b .le. h9b) .and. (h12b .le. p5b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h9b_2 - 1 + noab * (h2b_2 - 1 + noab * (h8b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h9b-1),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,2,3,1,6,5,-1.0d0)
      END IF
      IF ((h2b .le. h8b) .and. (h12b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab
     & * (h9b_2 - 1 + noab * (h8b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,1,3,2,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_beta_4_4_17_6',
     &6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h8b .eq. h9b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_beta_4_4_1
     &7_6',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_beta_4_4_1
     &7_6',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_beta_4_4_17_6',9,MA_ERR)
      IF ((h12b .le. h15b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h15b-1),int_mb(k_range+p14b
     &-1),2,4,1,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h12b - 1 + noab * (p14b - noab - 1 + nvab * (h2b - 1
     &)))))
      END IF
      IF ((h15b .le. h12b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h15b-1),int_mb(k_range+p14b
     &-1),2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h12b 
     &- 1 + noab * (h15b - 1 + noab * (p14b - noab - 1 + nvab * (h2b - 1
     &)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_beta_4_4_17_6',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_beta_4_4_1
     &7_6',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* $Id: integrate_kbpp_e_band_ray.F 22503 2012-05-20 06:58:57Z d3y133 $
*
      subroutine integrate_kbpp_e_band_ray(version,
     >                            nrho,drho,lmax,locp,nmax,
     >                            n_extra,n_expansion,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nray,G_ray,vl_ray,vnl_ray,
     >                            semicore,rho_sc_r,rho_sc_k_ray,
     >                            ierr)
      implicit none
      integer          version
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      integer          nmax
      integer          n_extra,n_expansion(0:lmax)
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:(lmax+n_extra))
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nray
      double precision G_ray(nray)
      double precision vl_ray(nray)
      double precision vnl_ray(nray,0:(lmax+n_extra))

      logical semicore
      double precision rho_sc_r(nrho,2)
      double precision rho_sc_k_ray(nray,2)
      integer ierr

#include "errquit.fh"

*     *** local variables ****
      integer np,taskid,MASTER
      parameter (MASTER=0)

      integer lcount,task_count
      integer k1,i,l,n,nb
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3,p
      double precision a,q
      integer indx(5,0:3)

*     **** external functions ****
      double precision dsum,simp
      external         dsum,simp

*     **** set up indx(n,l) --> to wp ****
      nb = lmax+1
      do l=0,lmax
         indx(1,l) = l
         do n=2,n_expansion(l)
            indx(n,l) = nb
            nb = nb+1
         end do
      end do

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      if ((nrho/2)*2.eq.nrho) then
        call errquit('integrate_kbpp_band_ray - psp grid not odd',0,
     >       INPUT_ERR)
        ierr = 2
        return
      end if

      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi
      p0=DSQRT(forpi)
      p1=DSQRT(3.0d0*forpi)
      p2=DSQRT(15.0d0*forpi)
      p3=DSQRT(105.0d0*forpi)


*======================  Fourier transformation  ======================
      call dcopy(nray,0.0d0,0,vl_ray,1)
      call dcopy((lmax+1+n_extra)*nray,0.0d0,0,vnl_ray,1)
      call dcopy(2*nray,0.0d0,0,rho_sc_k_ray,1)
      task_count = -1
      DO 700 k1=2,nray
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        Q=G_ray(k1)

        do i=1,nrho
          cs(i)=DCOS(Q*rho(i))
          sn(i)=DSIN(Q*rho(i))
        end do

        GO TO (500,400,300,200), lmax+1

*::::::::::::::::::::::::::::::  f-wave  ::::::::::::::::::::::::::::::
  200   CONTINUE
        if (locp.ne.3) then
           do n=1,n_expansion(3)
              F(1)=0.0d0
              do I=2,NRHO
                A=SN(I)/(Q*RHO(I))
                A=15.0d0*(A-CS(I))/(Q*RHO(I))**2 - 6*A + CS(I)
                F(I)=A*WP(I,indx(n,3))*VP(I,3)
              end do
             vnl_ray(k1,indx(n,3))=P3*SIMP(NRHO,F,DRHO)/Q
          end do
        end if

*::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
  300   CONTINUE
        if (locp.ne.2) then
          do n=1,n_expansion(2)
             F(1)=0.0d0
             DO I=2,NRHO
               A=3.0d0*(SN(I)/(Q*RHO(I))-CS(I))/(Q*RHO(I))-SN(I)
               F(I)=A*WP(I,indx(n,2))*VP(I,2)
             END DO
             vnl_ray(k1,indx(n,2))=P2*SIMP(NRHO,F,DRHO)/Q
          end do
        end if

*::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
  400   CONTINUE
        if (locp.ne.1) then
           do n=1,n_expansion(1)
              F(1)=0.0d0
              DO I=2,NRHO
                F(I)=(SN(I)/(Q*RHO(I))-CS(I))*WP(I,indx(n,1))*VP(I,1)
              END DO
              vnl_ray(k1,indx(n,1))=P1*SIMP(NRHO,F,DRHO)/Q
           end do
        end if

*::::::::::::::::::::::::::::::  s-wave  :::::::::::::::::::::::::::::::
  500   CONTINUE
        if (locp.ne.0) then
          do n=1,n_expansion(0)
             DO I=1,NRHO
               F(I)=SN(I)*WP(I,indx(n,0))*VP(I,0)
             END DO
             lcount = lcount-1
             vnl_ray(k1,indx(n,0))=P0*SIMP(NRHO,F,DRHO)/Q
          end do
        end if

*::::::::::::::::::::::::::  local potentials  ::::::::::::::::::::::::::
  600   CONTINUE
        do i=1,nrho
          f(i)=rho(i)*vp(i,locp)*sn(i)
        end do
        vl_ray(k1)=SIMP(nrho,f,drho)*FORPI/Q-ZV*FORPI*cs(nrho)/(Q*Q)

*::::::::::::::::::::: semicore density :::::::::::::::::::::::::::::::
        if (semicore) then
           do i=1,nrho
              f(i) = rho(i)*dsqrt(rho_sc_r(i,1))*sn(i)
           end do
           rho_sc_k_ray(k1,1) = SIMP(nrho,f,drho)*forpi/Q

           do i=1,nrho
             f(i)=(sn(i)/(Q*rho(i))-cs(i))*rho_sc_r(i,2)*rho(i)
           end do
           P = SIMP(nrho,f,drho)*forpi/Q
           rho_sc_k_ray(k1,2)=P
        end if

  700 CONTINUE
      call Parallel_Vector_SumAll(2*nray,rho_sc_k_ray)
      call Parallel_Vector_SumAll(nray,vl_ray)
      call Parallel_Vector_Sumall((lmax+1+n_extra)*nray,vnl_ray)

*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::
      do i=1,nrho
        f(i)=vp(i,locp)*rho(i)**2
      END DO
      vl_ray(1)=FORPI*SIMP(nrho,f,drho)+TWOPI*ZV*rho(nrho)**2

*     **** semicore density ****
      if (semicore) then
         do i=1,nrho
            f(i) = dsqrt(rho_sc_r(i,1))*rho(i)**2
         end do
         rho_sc_k_ray(1,1) = forpi*SIMP(nrho,f,drho)
         rho_sc_k_ray(1,2) = 0.0d0
      end if

      do l=0,lmax
        do n=1,n_expansion(l)
           vnl_ray(1,indx(n,l))=0.0d0
        end do
      end do
*     *** only j0 is non-zero at zero ****
      if (locp.ne.0) then
         do n=1,n_expansion(0)
            DO  I=1,NRHO
              F(I)=RHO(I)*WP(I,indx(n,0))*VP(I,0)
            END DO
            vnl_ray(1,indx(n,0))=P0*SIMP(NRHO,F,DRHO)
         end do
      end if

      ierr=0
      return
      end

      SubRoutine Get_Charges(rtdb,Geom,AO_Bas_Han,nBF,nGrid,nAtom,
     &                       g_Dns,Grid,Values,g_Vls,
     &                       XYZ,Charge,Tags,AMt,BMt,Dst,
     &                       STD,Tot_Charge)
*
* $Id: get_charges.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      Implicit None
*
************************************************************************
#include "mafdecls.fh"
#include "global.fh"
#include "stdio.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "context.fh"
************************************************************************
*
*---- Arguments of a Get_Charges call
      Integer rtdb,Geom,AO_Bas_Han
      Integer nBF,nGrid,nAtom,g_Dns,g_Vls
      Double Precision Grid(3,nGrid),Values(nGrid)
      Double Precision XYZ(3,nAtom),Charge(nAtom)
      Double Precision AMt(nAtom+1,nAtom+1),BMt(nAtom+1)
      Double Precision STD,Tot_Charge
      Double Precision Dst(nGrid,nAtom)
      Character*16 Tags
*---- Local variables
      Integer iAtom,jAtom,iCart
      Integer iPoint,iGrid,iProc,nProc,nGrPP,lthPP,iOffG
      Integer l_Pot,k_Pot,l_Dns,k_Dns,l_Pivot,k_Pivot,Info_var
      Double Precision Sum,SumA,SumB
      Logical LResult,DeBug
*
      Double Precision ddot
      External         ddot
*
************************************************************************
*
      DeBug = .False.
      iProc = ga_nodeid()
      nProc = ga_nnodes()
*
*---- Get distances (qdist computes squares of distances)
      Do iGrid = 1, nGrid
         Do iAtom = 1, nAtom
            Dst(iGrid,iAtom) = Sqrt( Dst(iGrid,iAtom) )
         End Do
      End Do
*
      If (DeBug . and . iProc.eq.0) Then
         Write(*,*)' Cartesian coordinates'
         Do iAtom = 1, nAtom
            Write(*,'(10f12.6)')(XYZ(iCart,iAtom),iCart=1,3)
         End Do
         Write(*,*)' Grid Points'
         Do iGrid = 1, nGrid
            Write(*,'(10f12.6)')(Grid(iCart,iGrid),iCart=1,3)
         End Do
         Write(*,*)' Distances'
         Do iGrid = 1, nGrid
            Write(*,'(10f12.6)')(Dst(iGrid,iAtom),iAtom=1,nAtom)
         End Do
      End If
*
*---- Share the grid points among processes
      lthPP = nGrid/nProc
      If (lthPP*nProc.ne.nGrid) Then
         lthPP = lthPP + 1
         nGrPP = lthPP
         If (iProc.eq.nProc-1) nGrPP = nGrid - (nProc-1)*lthPP
      Else
         nGrPP = lthPP
      End If
      iOffG = iProc*lthPP+1
      If (nGrPP.eq.0) GoTo 9999
*
      If (DeBug . and . iProc.eq.0) Then
         Write(LuOut,*)
         Write(LuOut,*)'        nBF = ',nBF
         Write(LuOut,*)'      nGrid = ',nGrid
         Write(LuOut,*)'      nProc = ',nProc
         Write(LuOut,*)'      iProc = ',iProc
         Write(LuOut,*)'      nGrPP = ',nGrPP
         Write(LuOut,*)
      End If
*
*---- Initialize integrals
      call int_init(rtdb,1,AO_Bas_Han)
*
*---- Allocate memory for the integrals and the density matrix
      LResult = MA_Push_Get(MT_Dbl,nBF*nBF,'Pot',l_Pot,k_Pot)
      Call ErrMem(LResult,'Get_Charges: Failed to allocate Pot',0)
      LResult = MA_Push_Get(MT_Dbl,nBF*nBF,'Dns',l_Dns,k_Dns)
      Call ErrMem(LResult,'Get_Charges: Failed to allocate Pot',0)
*
*---- Get the density matrix
      Call GA_Get(g_Dns,1,nBF,1,nBF,Dbl_mb(k_Dns),nBF)
*
      If (DeBug . and . iProc.eq.0) Then
         Write(*,*)' Charges:'
         Write(*,'(5f10.5)')(Charge(iAtom),iAtom = 1, nAtom)
      End If
*
*---- Loop over the points assigned to the given node
      Do iPoint = 1, nGrPP
         iGrid = iOffG + iPoint - 1
*------- Get the electronic potential at a given point
         Call Pot_At_Pos(Grid(1,iGrid),1.d0,Dbl_mb(k_Pot),nBF,
     &                   AO_Bas_Han,AO_Bas_Han)
         Values(iGrid) = ddot(nBF*nBF,Dbl_mb(k_Dns),1,Dbl_mb(k_Pot),1) 
*------- Get the nuclear potential
         Sum = 0.d0
         Do iAtom = 1, nAtom
            Sum = Sum + Charge(iAtom)/Dst(iGrid,iAtom)
         End Do
         Values(iGrid) = Values(iGrid) + Sum
      End Do
*
*---- Deallocate memory
      LResult = MA_Pop_Stack(l_Dns)
      Call ErrMem(LResult,'Get_Charges: Failed to deallocate Dns',0)
      LResult = MA_Pop_Stack(l_Pot)
      Call ErrMem(LResult,'Get_Charges: Failed to deallocate Pot',0)
*
*---- Put values into the global array and synchronize
      Call GA_Put(g_Vls,iOffG,iOffG+nGrPP-1,1,1,Values(iOffG),nGrPP)
 9999 Continue
      Call GA_Sync
*
*---- Sequential part
      If (iProc.eq.0) Then
         Call GA_Get(g_Vls,1,nGrid,1,1,Values,nGrid)
         Call dfill((nAtom+1)**2,0.d0,AMt,1)
         Call dfill(nAtom+1,     0.d0,BMt,1)
*------- Set up the A-matrix and B-vector
         Do iAtom = 1, nAtom
            SumB = 0.d0
            Do iGrid = 1, nGrid
               SumB = SumB + Values(iGrid)/Dst(iGrid,iAtom)
            End Do
            BMt(iAtom) = SumB
            Do jAtom = 1, iAtom
               SumA = 0.d0
               Do iGrid = 1, nGrid
                  SumA = SumA + 1.d0/Dst(iGrid,iAtom)/Dst(iGrid,jAtom)
               End Do
               AMt(iAtom,jAtom) = SumA
               AMt(jAtom,iAtom) = SumA
            End Do
            AMt(nAtom+1,iAtom) = 1.d0
            AMt(iAtom,nAtom+1) = 1.d0
         End Do
         AMt(nAtom+1,nAtom+1) = 0.d0
         BMt(nAtom+1) = Tot_Charge
*------- DeBug printout
         If (DeBug) Then
            Write(*,*)' A-matrix'
            Do iAtom = 1, nAtom + 1
               Write(*,'(10f12.6)')(AMt(iAtom,jAtom),jAtom=1,nAtom + 1)
            End Do
            Write(*,*)' B-matrix'
            Do iAtom = 1, nAtom + 1
               Write(*,'(10f12.6)')BMt(iAtom)
            End Do
         End If
*------- Solve a set of linear equations to get charges
         Info_var = 0
         LResult = MA_Push_Get(MT_Int,nAtom+1,'Pivot',l_Pivot,k_Pivot)
         Call ErrMem(LResult,'Get_Charges: Failed to allocate Pivot',0)
         Call dgesv(nAtom+1,1,AMt,nAtom+1,Int_mb(k_Pivot),
     &              BMt,nAtom+1,Info_var)
         LResult = MA_Pop_Stack(l_Pivot)
         Call ErrMem(LResult,
     &               'Get_Charges: Failed to deallocate Pivot',0)
*------- Overwrite nuclear charges (for the final printout in DPlot)
         Do iAtom = 1, nAtom
            Charge(iAtom)= BMt(iAtom)
         End Do
*------- Find the deviations
         STD = 0.d0
         Do iGrid = 1, nGrid
            Sum = 0.d0
            Do iAtom = 1, nAtom
               Sum = Sum + BMt(iAtom)/Dst(iGrid,iAtom)
            End Do
*           Write(*,'(3(2x,e12.6))')Values(iGrid),Sum,Values(iGrid)-Sum
            Sum = Values(iGrid)-Sum
            STD = STD + Sum*Sum
         End Do
         STD = Sqrt(STD/Dble(nGrid-1))
      End If
*
*---- Normal termination
      Return
      End
*
*-----------------------------------------------------------------------
*
      SubRoutine Pot_At_Pos(Pos,Charg,Pot,nBF,ibas,jbas)
      Implicit None
#include "errquit.fh"
*
************************************************************************
#include "mafdecls.fh"
#include "global.fh"
#include "inp.fh"
#include "bas.fh"
#include "cscfps.fh"
#include "sym.fh"
************************************************************************
*
*---- Arguments of a Pot_At_Pos call
      Double Precision Pos(3),Charg ! [input] point & associated charge
      Integer ibas, jbas            ! [input] bra and ket basis sets
      Integer nBF                   ! [input] # of basis functions
      Double Precision Pot(nBF,nBF) ! [output] calculated potential
*---- Local variables
      Integer nshell_i, nshell_j
      Integer ishell, jshell, mem1, max1e
      Integer ilo, ihi, jlo, jhi, idim, jdim, i, j, iFrom
      Integer l_buf, l_scr
      Integer k_buf, k_scr
      Integer iPos, jPos, nInt
*     
*---- Get info about the basis sets
      If (.not. bas_numcont(ibas, nshell_i)) call errquit
     &     ('Pot_At_Pos: bas_numcont failed for ibas', ibas, BASIS_ERR)
      If (.not. bas_numcont(jbas, nshell_j)) call errquit
     &     ('Pot_At_Pos: bas_numcont failed for jbas', jbas, BASIS_ERR)
*     
*---- Allocate necessary local temporary arrays on the stack
      call int_mem_1e(max1e, mem1)
      if (.not. MA_push_get(MT_DBL,max1e,'buf',l_buf,k_buf))
     &     call errquit('Pot_At_Pos: ma failed', max1e, MA_ERR)
      if (.not. MA_push_get(MT_DBL, mem1,'scr',l_scr,k_scr))
     &     call errquit('Pot_At_Pos: ma failed', mem1, MA_ERR)
*     
*---- Get the integrals (use Int_1er from NWDFT module)
      Do jShell = 1, nShell_j
         Do iShell = 1, jShell
            If (.not. bas_cn2bfr(ibas, ishell, ilo, ihi)) 
     &         call errquit('int_1e_ga: bas_cn2bfr ?', ibas, BASIS_ERR)
            If (.not. bas_cn2bfr(jbas, jshell, jlo, jhi))
     &         call errquit('int_1e_ga: bas_cn2bfr ?', jbas, BASIS_ERR)
            idim = ihi - ilo + 1
            jdim = jhi - jlo + 1
            nInt = idim*jdim
*---------- Generate the integrals
            Call Int_1er(Pos,1,Charg,
     &                   jbas,jshell,ibas,ishell, 
     &                   mem1,dbl_mb(k_scr),max1e,dbl_mb(k_buf))
*---------- Put the blockinto the Pot array
            iFrom = k_buf-1
            Do j = jlo, jhi
               Do i = ilo, ihi
                  iFrom = iFrom + 1
                  Pot(j,i) = dbl_mb(iFrom)
               End Do
            End Do
         End Do
      End Do
*
      Do iPos = 1, nBF
         Do jPos = 1, iPos - 1
            Pot(jPos,iPos) = Pot(iPos,jPos)
         End Do
      End Do
*     
*---- Deallocate memory     
      If (.not. MA_Pop_Stack(l_scr))
     &   Call ErrQuit('Pot_At_Pos: pop failed', 0,0)
      if (.not. MA_Pop_Stack(l_buf))
     &   Call ErrQuit('Pot_At_Pos: pop failed', 0,0)
*     
      call int_terminate
      Return
      End

      subroutine smd_coords_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_coords,sp_atom
      character*32 tag,pname
      logical result

      pname = "smd_coords_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "coordinates"
      call smd_system_get_component(sp_coords,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_coords_init(sp_coords,sp_atom)
      
      call smd_coords_read(sp_coords)
c
      return
      end

      subroutine smd_coords_init(sp_coords,sp_atom)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_coords
      character*(*) sp_atom
c
      character*32 pname
      integer na
c
      pname = "smd_coords_init"
c
c      write(*,*) "in "//pname
c
c     get total number of atoms 
c     -------------------------
      call smd_atom_ntot(sp_atom,na)
      if(na.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)
c
c     create coords data structures
c     ---------------------------
      call smd_namespace_create(sp_coords)
      call smd_data_create(sp_coords,"coords",3*na,MT_DBL)

      return
      end

      subroutine smd_coords_read(sp_coords)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_coords
      integer rtdb
c
      character*32 pname
      character*72 tag
      integer i_c
      integer na
      logical result
c
      pname = "smd_coords_read"
c
c      write(*,*) "in "//pname
c
c     fill in coordinates from pdb file if any
c     ----------------------------------------
      tag = "coords"
      call smd_data_get_index(sp_coords,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      call smd_data_get_size(sp_coords,tag,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      if(na.le.0)
     >call errquit(
     >     pname//'no atoms ',0, RTDB_ERR)
      na = na/3


      call smd_coordfile_read_coords(na,
     +                          dbl_mb(i_c))


      return
      end

      subroutine smd_coords_rebox()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_coords
c
      character*72 tag
      character*30 pname
      integer na
      integer i_c,i_lrc,i_lc
      logical result

      pname = "smd_atom_rebox"

c
c     get atomic coordinates
c     ----------------------
      call smd_system_get_component(sp_coords,"coordinates",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no coordinates ',0,0)

      tag = "coords"
      call smd_data_get_index(sp_coords,tag,i_c,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_data_get_size(sp_coords,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      na = na/3

      call smd_lat_rebox(na,
     >                    dbl_mb(i_c))

      return
      end

      subroutine smd_coords_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer un
      character*32 sp_coords
c
      character*72 tag
      character*30 pname
      integer na
      integer i_c,i_lrc,i_lc
      logical result

      pname = "smd_atom_rebox"

c
c     get atomic coordinates
c     ----------------------
      call smd_system_get_component(sp_coords,"coordinates",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no coordinates ',0,0)

      tag = "coords"
      call smd_data_get_index(sp_coords,tag,i_c,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_data_get_size(sp_coords,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      na = na/3

      
      call smd_util_print_force_array(un,na,
     >                           dbl_mb(i_c))  

      return
      end

      subroutine smd_coords_update()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "smd_system.fh"
c     
      character*72 sp_vel
      character*72 sp_coords
      character*72 sp_mass
      character*72 sp_force
      character*72 sp_shakelist
      character*32 pname
      character*80 tag
      integer nt,na
      integer i_f
      integer i_m,i_c,i_v
      logical result
      integer rtdb
      double precision ekin, tstep
      logical oshake
      integer i_is1,i_is2,i_ds,ns
      integer h_ncc,i_ncc
      integer h_nvv,i_nvv
      integer h_dcc,i_dcc
      integer h_nrij,i_nrij
      integer h_orij,i_orij
c
      pname = "smd_coords_update"
c
c      write(*,*) "in "//pname
c
      call  smd_rtdb_get_handle(rtdb)
c
c     get components
c     --------------
      tag = "velocity"
      call smd_system_get_component(sp_vel,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "mass"
      call smd_system_get_component(sp_mass,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "force"
      call smd_system_get_component(sp_force,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "coordinates"
      call smd_system_get_component(sp_coords,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

c
c     get velocity array
c     ------------------
      tag = "vel"
      call smd_data_get_index(sp_vel,tag,i_v,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      call  smd_data_get_size(sp_vel,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      na = na/3

c
c     get mass array
c     ------------------
      tag = "mass"
      call smd_data_get_index(sp_mass,tag,i_m,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
c
c     get force array
c     ---------------
      tag = "force"
      call smd_data_get_index(sp_force,tag,i_f,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

c
c     get coord array
c     ---------------
      tag = "coords"
      call smd_data_get_index(sp_coords,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

c
c     get time step
c     -------------
      tag="smd:step"
        if (.not.rtdb_get(rtdb,tag,mt_dbl,1,tstep)) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
 

      oshake = smd_system_shake()

      if(oshake) then

        tag = "shakelist"
        call smd_system_get_component(sp_shakelist,tag,result)
        if(.not.result)
     >    call errquit(
     >         pname//'no component '//tag,0,0)

        tag = "shake:i1"
        call smd_data_get_index(sp_shakelist,tag,i_is1,result)
        if(.not. result) 
     >    call errquit(
     >         pname//'error getting index for '//tag,0, 0)

        tag = "shake:i2"
        call smd_data_get_index(sp_shakelist,tag,i_is2,result)
        if(.not. result) 
     >    call errquit(
     >         pname//'error getting index for '//tag,0, 0)

        tag = "shake:distance"
        call smd_data_get_index(sp_shakelist,tag,i_ds,result)
        if(.not. result) 
     >    call errquit(
     >         pname//'error getting index for '//tag,0, 0)

        call smd_data_get_size(sp_shakelist,tag,ns,result)
        if(.not. result) 
     >    call errquit(
     >         pname//'error getting size for '//tag,0, 0)

        if(.not.ma_push_get(mt_dbl,na*3,'i_ncc',h_ncc,i_ncc))
     +   call errquit(pname//'Failed to allocate memory',
     +   0, MA_ERR)

        if(.not.ma_push_get(mt_dbl,na*3,'i_nvv',h_nvv,i_nvv))
     +   call errquit(pname//'Failed to allocate memory',
     +   0, MA_ERR)

        if(.not.ma_push_get(mt_dbl,na*3,'i_dcc',h_dcc,i_dcc))
     +   call errquit(pname//'Failed to allocate memory',
     +   0, MA_ERR)

        if(.not.ma_push_get(mt_dbl,ns*3,'i_nrij',h_nrij,i_nrij))
     +   call errquit(pname//'Failed to allocate memory',
     +   0, MA_ERR)

        if(.not.ma_push_get(mt_dbl,ns*3,'i_orij',h_orij,i_orij))
     +   call errquit(pname//'Failed to allocate memory',
     +   0, MA_ERR)

      end if
      if(oshake) then
            call smd_leapf_shake(na,
     >                           ns,
     >                           tstep,
     >                           ekin,
     >                           dbl_mb(i_m),
     >                           int_mb(i_is1),
     >                           int_mb(i_is2),
     >                           dbl_mb(i_ds),
     >                           dbl_mb(i_ncc),
     >                           dbl_mb(i_nvv),
     >                           dbl_mb(i_dcc),
     >                           dbl_mb(i_nrij),
     >                           dbl_mb(i_orij),
     >                           dbl_mb(i_f),
     >                           dbl_mb(i_v),
     >                           dbl_mb(i_c))


      else
      call smd_leapf(na,
     >                 tstep,
     >                 ekin,
     >                 dbl_mb(i_m),
     >                 dbl_mb(i_f),
     >                 dbl_mb(i_v),
     >                 dbl_mb(i_c))

      end if

      call smd_coords_rebox()

      if(oshake) then

        if(.not.ma_pop_stack(h_orij))
     &   call errquit(pname//'Failed to deallocate stack h_orij',0,
     &         MA_ERR)

        if(.not.ma_pop_stack(h_nrij))
     &   call errquit(pname//'Failed to deallocate stack h_nrij',0,
     &         MA_ERR)

        if(.not.ma_pop_stack(h_dcc))
     &   call errquit(pname//'Failed to deallocate stack h_dcc',0,
     &         MA_ERR)

        if(.not.ma_pop_stack(h_nvv))
     &   call errquit(pname//'Failed to deallocate stack h_nvv',0,
     &         MA_ERR)


        if(.not.ma_pop_stack(h_ncc))
     &   call errquit(pname//'Failed to deallocate stack h_ncc',0,
     &         MA_ERR)

      end if

      return
      end
c $Id: smd_coords.F 22502 2012-05-20 06:11:57Z d3y133 $

C> \ingroup nwint
C> @{
C>
C> \brief Compute transposed 2-electron 3-center Gaussian periodic
C> electron repulsion integrals
C>
C> The code in question always uses density fitting approaches for
C> the 3-center 2-electron integrals are needed. See [1] for details.
C>
C> [1] JE Jaffe, AC Hess,
C>     <i>"Gaussian basis density functional theory for systems 
C>     periodic in two or three dimensions: Energy and forces"</i>,
C>    J.Chem.Phys. <b>105</b>, 10983-10998 (1996), DOI:
C>    <a href="http://dx.doi.org/10.1063/1.472866">
C>    10.1063/1.472866</a>
C>
      subroutine intp_2e3ct(brain, ish, jsh, ketin, ksh, Rj, Rk, 
     &       lscr, scr, leri, eri)
*
* $Id: intp_2e3ct.F 23392 2013-01-07 20:00:04Z d3y133 $
*
      implicit none
c
c basic api routine to generate a block of 3 center two 
c  electron integrals
c
c eri = <bra_g(ish)bra_g(jsh)|ket_g(ksh)>
c
#include "apiP.fh"
#include "errquit.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
c
c::external subroutines used
c errquit
c::functions
      logical cando_nw
      logical int_chk_sh
      logical int_chk_init
      external cando_nw
      external int_chk_sh
      external int_chk_init
c:: passed
      integer brain  !< [Input] basis set handle for bra function
      integer ketin  !< [Input] basis set handle for ket function
      integer ish    !< [Input] lexical contraction/shell index
      integer jsh    !< [Input] lexical contraction/shell index
      integer ksh    !< [Input] lexical contraction/shell index
      integer lscr   !< [Input] length of scratch array
      integer leri   !< [Input] length of ERI array
      double precision scr(lscr) !< [Scratch] scratch array 
      double precision eri(leri) !< [Output] ERI array
c translation vectors are in fractional coordinates !
      double precision Rk(3)  !< [Input] translation vector for ksh center 
      double precision Rj(3)  !< [Input] translation vector for jsh center 
c:: local
      logical shells_ok
      integer bra, ket 
      integer q_geom, ab_geom, ucont
      integer Lq, q_prim, q_gen, q_iexp, q_icfp, q_cent
      integer La, a_prim, a_gen, a_iexp, a_icfp, a_cent
      integer Lb, b_prim, b_gen, b_iexp, b_icfp, b_cent
      integer nintx
      double precision xyz_new_k(3)  ! new coordinates for ksh function
      double precision xyz_new_j(3)  ! new coordinates for jsh function
c
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c check initialization
c
      if (.not.int_chk_init('intp_2e3ct'))
     &       call errquit('intp_2e3ct: int_init was not called' ,0,
     &            INT_ERR)
c
c     check input shell ranges
c
      shells_ok = int_chk_sh(brain,ish)
      shells_ok = shells_ok .and. int_chk_sh(brain,jsh)
      shells_ok = shells_ok .and. int_chk_sh(ketin,ksh)
      if (.not.shells_ok)
     &       call errquit('intp_2e3ct: invalid contraction/shell',0,
     &           BASIS_ERR)
c
c  check if spherical/gencon/sp shell
c
      call int_nogencont_check(brain,'intp_2e3ct:bra')
      call int_nogencont_check(ketin,'intp_2e3ct:ket')
      call int_nospshell_check(brain,'intp_2e3ct:bra')
      call int_nospshell_check(ketin,'intp_2e3ct:ket')
c
c     define center information required 
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
      ab_geom = ibs_geom(bra)
      q_geom  = ibs_geom(ket)
c
      if (q_geom.ne.ab_geom.and.WarnP.eq.0) then
        write(luout,*)
     &      'intp_2e3ct: WARNING: possible geometry inconsistency'
        write(luout,*)'bra geometry handle:',ab_geom
        write(luout,*)'ket geometry handle:',q_geom
        WarnP = 1
      endif
c
      a_cent  = (sf_ibs_cn2ce(ish,bra))
      b_cent  = (sf_ibs_cn2ce(jsh,bra))
      q_cent  = (sf_ibs_cn2ce(ksh,ket))
c.. translate ksh center coordinates based on Rk
      call intp_txyz(q_cent,q_geom,Rk,xyz_new_k)
c.. translate jsh center coordinates based on Rj
      call intp_txyz(b_cent,ab_geom,Rj,xyz_new_j)
c
      if(cando_nw(brain,ish,jsh).and.cando_nw(ketin,ksh,0)) then
c
        ucont   = (sf_ibs_cn2ucn(ish,bra))
        La      = infbs_cont(CONT_TYPE ,ucont,bra)
        a_prim  = infbs_cont(CONT_NPRIM,ucont,bra)
        a_gen   = infbs_cont(CONT_NGEN ,ucont,bra)
        a_iexp  = infbs_cont(CONT_IEXP ,ucont,bra)
        a_icfp  = infbs_cont(CONT_ICFP ,ucont,bra)
c
        ucont   = (sf_ibs_cn2ucn(jsh,bra))
        Lb      = infbs_cont(CONT_TYPE ,ucont,bra)
        b_prim  = infbs_cont(CONT_NPRIM,ucont,bra)
        b_gen   = infbs_cont(CONT_NGEN ,ucont,bra)
        b_iexp  = infbs_cont(CONT_IEXP ,ucont,bra)
        b_icfp  = infbs_cont(CONT_ICFP ,ucont,bra)
c
        ucont   = (sf_ibs_cn2ucn(ksh,ket))
        Lq      = infbs_cont(CONT_TYPE ,ucont,ket)
        q_prim  = infbs_cont(CONT_NPRIM,ucont,ket)
        q_gen   = infbs_cont(CONT_NGEN ,ucont,ket)
        q_iexp  = infbs_cont(CONT_IEXP ,ucont,ket)
        q_icfp  = infbs_cont(CONT_ICFP ,ucont,ket)
c      
        call hf2(
     &         coords(1,a_cent,ab_geom), dbl_mb(mb_exndcf(a_iexp,bra)),
     &         dbl_mb(mb_exndcf(a_icfp,bra)), a_prim,a_gen,La,
     &         xyz_new_j, dbl_mb(mb_exndcf(b_iexp,bra)),
     &         dbl_mb(mb_exndcf(b_icfp,bra)), b_prim, b_gen, Lb,
     &         xyz_new_k, dbl_mb(mb_exndcf(q_iexp,ket)),
     &         dbl_mb(mb_exndcf(q_icfp,ket)), q_prim, q_gen, Lq,
     &         xyz_new_k, DCexp,
     &         DCcoeff           ,      1,     1, 0,
c......................... canAB    canCD    canPQ
     &         eri, leri, .false., .false., .false.,
c............ dryrun
     &         .false., scr, lscr)
c
        if (bas_spherical(ket).or.bas_spherical(bra)) then
          nintx = int_nbf_x(Lq)*int_nbf_x(La)*int_nbf_x(Lb)
          if (nintx.lt.lscr)
     &        call errquit
     &        ('intp_2e3ct: not enough scratch for spherical transform',
     &        911, MEM_ERR)
          call spcart_3ctran(eri,scr,lscr,
     &        int_nbf_x(La),int_nbf_s(La),La,a_gen,bas_spherical(bra),
     &        int_nbf_x(Lb),int_nbf_s(Lb),Lb,b_gen,bas_spherical(bra),
     &        int_nbf_x(Lq),int_nbf_s(Lq),Lq,q_gen,bas_spherical(ket),
     &        .false.)          
        endif
      else
        write(luout,*)'intp_2e3ct: could not do nw integrals'
        write(luout,*)' brain :',brain
        write(luout,*)' ketin :',ketin
        write(luout,*)' ish   :',ish
        write(luout,*)' jsh   :',jsh
        write(luout,*)' ksh   :',ksh
        call errquit('intp_2e3ct: fatal error ',0, INT_ERR)
      endif
      end
C> @}

*
* $Id: fci_detwalk.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_det_to_walk(idet, owalk, mwalk)
      implicit none
#include "fciinfo.fh"
c
c     Given the index of a determinant, idet, return the
c     corresponding lexical weights of orbital and primitive
c     spin functions.  Without having an index vector the
c     length of the CI expansion the only way to do this
c     is with a binary search, so this operation costs 
c     about log2(ndets).
c
      integer idet    ! [input] Index into determinant CI vector
      integer owalk   ! [output] Corresponding orbital walk
      integer mwalk   ! [output] Corresponding primitive spin function walk
c
      integer left, right, middle
c
      left = 1
      right = nwalko
c
 10   middle = (left+right)/2
      if (indexo(middle) .ge. idet) then
         right = middle
      else 
         left = middle
      endif
      if ((right-left) .gt. 1) goto 10
c
      if (indexo(right) .lt. idet) then
         owalk = right
      else
         owalk = left
      endif
c
c     Adjust for walks of incorrect symmetry
c
 20   if (indexo(owalk).eq.indexo(owalk+1)) then
         owalk = owalk + 1
         goto 20
      endif
c
      mwalk = idet - indexo(owalk)
c
      if (mwalk.le.0 .or. mwalk.gt.(indexo(owalk+1)-indexo(owalk)))
     $     call fci_err('fci_det_to_walk: bad mwalk ', mwalk)
c
      end

*
* $Id: paw_psi.F 20364 2011-05-20 20:38:23Z d3p852 $
*


*     ***********************************
*     *                                 *
*     *          paw_psi_MakeOrtho      *
*     *                                 *
*     ***********************************

*   This routine orthonormalizes the orbitals using a modified
* Gram-Schmidt algorithm.
*
      subroutine paw_psi_MakeOrtho(npack,ne,psi)
      implicit none
      integer npack,ne
      double complex psi(npack,ne)

*     **** local variables ****
      integer j,k
      real*8  w

      do k=1,ne
         call paw_overlap_matrix_gen(1,1,psi(1,k),psi(1,k),w)
         w = 1.0d0/dsqrt(w)
c         call Pack_c_SMul(1,w,psi(1,k),psi(1,k))
         call Pack_c_SMul1(1,w,psi(1,k))

         do j=k+1,ne
            call paw_overlap_matrix_gen(1,1,psi(1,k),psi(1,j),w)
            w = -w
            call Pack_cc_daxpy(1,w,psi(1,k),psi(1,j))
         end do
      end do

      return
      end

*     ***********************************
*     *                                 *
*     *          paw_psi_CheckOrtho     *
*     *                                 *
*     ***********************************

*   This routine return true if the orbitals are
* orthonormal.

      real*8 function paw_psi_CheckOrtho(npack,ne,psi)
      implicit none
      integer npack,ne
      double complex psi(npack,ne)


*     **** local variables ****
      integer j,k
      real*8  w,error

      error = 0.0d0
      do k=1,ne
        call paw_overlap_matrix_gen(1,1,psi(1,k),psi(1,k),w)
        error = error + dabs(1.0d0-w)

        do j=k+1,ne
           call paw_overlap_matrix_gen(1,1,psi(1,j),psi(1,k),w)
           error = error + dabs(w)
        end do
      end do

      paw_psi_CheckOrtho = error
      return
      end


*     ***********************************
*     *                                 *
*     *          paw_psi_CheckOrtho2    *
*     *                                 *
*     ***********************************

*   This routine return true if the orbitals are
* orthonormal.

      subroutine paw_psi_CheckOrtho2(npack,ne,psi)
      implicit none
      integer npack,ne
      double complex psi(npack,ne)


*     **** local variables ****
      integer j,k
      real*8  w,error

      
      write(*,*)
      do k=1,ne
        call paw_overlap_matrix_gen(1,1,psi(1,k),psi(1,k),w)
        write(*,*) "CheckOrtho2:",k,k,w

        do j=k+1,ne
           call paw_overlap_matrix_gen(1,1,psi(1,j),psi(1,k),w)
        write(*,*) "CheckOrtho2:",j,k,w
        end do
      end do
      write(*,*)

      return
      end



*     ***********************************
*     *                                 *
*     *          paw_psi_lmbda          *
*     *                                 *
*     ***********************************

      subroutine paw_psi_lmbda(ispin,ne,nemax,npack1,
     >                     psi1,psi2,
     >                     dte,
     >                     lmbda,tmp,ierr)

      implicit none
      integer ispin,ne(2),nemax,npack1
      complex*16 psi1(npack1,nemax)
      complex*16 psi2(npack1,nemax)
      real*8     dte
      real*8     lmbda(*)
      real*8     tmp(*)
      integer    ierr

      integer MASTER
      parameter (MASTER=0)

*     **** local variables ****
      logical failed
      integer taskid
      integer n1(2),n2(2)
      integer i,j,ii,jj,ms
      integer n,nn,index
      integer st1,st2
      integer A,B,C,U,D,Ba,Bs,fnm
      integer sl(2)
      real*8  alpha



      call nwpw_timing_start(3)

      call Parallel_taskid(taskid)

      n    = ne(1)
      nn   = n**2
      
      A    = 0*nn + 1
      B    = 1*nn + 1
      C    = 2*nn + 1
      Ba   = 3*nn + 1
      Bs   = 4*nn + 1
      fnm  = 5*nn + 1
      st1  = 6*nn + 1
      D    = 7*nn + 1

      U    = Bs
      st2  = B

      call dcopy(8*nn,0.0d0,0,tmp,1)

      sl(1)  = 0*nn + 1
      sl(2)  = 1*nn + 1
      call dcopy(2*nn,0.0d0,0,lmbda,1)

      n1(1)=1
      n2(1)=ne(1)
      n1(2)=ne(1)+1
      n2(2)=ne(1)+ne(2)
      

      do ms=1,ispin
        IF(ne(ms).le.0) go to 640


*       ***** compute the overlap matrices ****
        call paw_overlap_sym_matrix_gen(n,ne(ms),
     >                          psi2(1,n1(ms)),
     >                          psi2(1,n1(ms)),
     >                          tmp(A))
        call paw_overlap_matrix_gen(n,ne(ms),
     >                          psi1(1,n1(ms)),
     >                          psi2(1,n1(ms)),
     >                          tmp(B))
        call paw_overlap_sym_matrix_gen(n,ne(ms),
     >                          psi1(1,n1(ms)),
     >                          psi1(1,n1(ms)),
     >                          tmp(C))


        call paw_psi_gen_Ba_Bs(n,ne(ms),tmp(B),tmp(Bs),tmp(Ba))
        call paw_psi_gen_UD(n,ne(ms),tmp(Bs),tmp(D),lmbda)


        call paw_psi_gen_X(n,ne(ms),tmp(st1),tmp(st2),
     >                     tmp(A),tmp(Ba),tmp(C),
     >                     tmp(U),tmp(D),tmp(fnm),
     >                     failed)

        if (failed) then 
          if (taskid.eq.MASTER) then
            write(6,*) 
     >     'Warning: Lagrange Multiplier generation failed.'
            write(6,*) '        +Try using a smaller time step'
            write(6,*) '        +Gram-Schmidt being performed, spin:',ms
          end if
          call paw_psi_MakeOrtho(npack1,ne(ms),psi2(1,n1(ms)))
        else
          call dcopy(n*ne(ms),tmp(st1),1,lmbda(sl(ms)),1)
          call dscal(n*ne(ms),(1.0d0/dte),lmbda(sl(ms)),1)


*         ****  correction due to the constraint ****
          call dgemm('N','N',2*npack1,ne(ms),ne(ms),
     >              (1.0d0),
     >              psi1(1,n1(ms)),2*npack1,
     >              tmp(st1),n,
     >              (1.0d0),
     >              psi2(1,n1(ms)),2*npack1)

        end if
  640   continue
      end do !*ms*
      call nwpw_timing_end(3)

      return
      end



*     ***********************************
*     *                                 *
*     *        paw_psi_gen_Ba_Bs        *
*     *                                 *
*     ***********************************
      subroutine paw_psi_gen_Ba_Bs(n_max,n,B,Bs,Ba)
      implicit none
      integer n_max,n
      real*8 B(n_max,n)
      real*8 Bs(n_max,n)
      real*8 Ba(n_max,n)

      !*** local variables ***
      integer i,j

      do i=1,n
      do j=1,n
         Bs(i,j) = 0.5d0*(B(i,j)+B(j,i))
         Ba(i,j) = 0.5d0*(B(i,j)-B(j,i))
      end do
      end do
      return
      end

*     ***********************************
*     *                                 *
*     *        paw_psi_gen_UD           *
*     *                                 *
*     ***********************************
      subroutine paw_psi_gen_UD(n_max,n,Bs,D,work)
      implicit none
      integer n_max,n
      real*8 Bs(n_max,n)
      real*8 D(n_max,n)
      real*8 Work(n_max,n)

      !*** local variables ***
      integer ierr

      !call eigen(n_max,n,Bs,D,D(1,2))
      call dsyev('V','U',n,Bs,n_max, D,Work,2*n_max*n_max,ierr)
      return
      end




*     ***********************************
*     *                                 *
*     *        paw_psi_gen_X            *
*     *                                 *
*     ***********************************
      subroutine paw_psi_gen_X(n_max,n,
     >                     X1,tmp,
     >                     A,Ba,C,
     >                     U,D,fnm,
     >                     failed)
     > 
      implicit none
      integer n_max,n
      real*8 X1(n_max,n)
      real*8 tmp(*)
      real*8 A(n_max,n)
      real*8 Ba(n_max,n)
      real*8 C(n_max,n)
      real*8 U(n_max,n)
      real*8 D(n_max,n)
      real*8 fnm(n_max,n)
      logical failed

      !**** local variables ****
      integer itrlmd
      real*8  convg
      parameter (itrlmd=40, convg=1.0d-15)

      integer i,it
      real*8  adiff

      !**** external functions ****
      integer  idamax
      external idamax


      !**** A = I-A ***
      call dscal(n_max*n,(-1.0d0),A,1)
      do i=1,n
         A(i,i) = A(i,i) + 1.0d0
      end do

      !*** fnm = I-A ****
      call dcopy(n_max*n,A,1,fnm,1)

      !*** solve U*D*Ut*X + X*U*D*Ut = fnm for X ***
      call paw_psi_fnm_to_X(n_max,n,fnm,U,D,tmp)
      call dcopy(n_max*n,fnm,1,X1,1)


      it     = 0
      failed = .true.
      do while (failed .and. (it.lt.itrlmd))
        it = it + 1

        !*** fnm = X*C*X ***
        call DMMUL(n_max,n,C,X1,tmp)
        call DMMUL(n_max,n,X1,tmp,fnm)


        !*** fnm = Ba*X - X*C*X ***
        call DMMUL(n_max,n,Ba,X1,tmp)
        call DMSUB(n_max,n,tmp,fnm,fnm)


        !*** fnm = Ba*X - X*Ba - X*C*X ***
        call DMMUL(n_max,n,X1,Ba,tmp)
        call DMSUB(n_max,n,fnm,tmp,fnm)

        !*** fnm = I-A + Ba*X - X*Ba - X*C*X ***
        call DMADD(n_max,n,fnm,A,fnm)


        !*** solve U*D*Ut*X + X*U*D*Ut = fnm for X ***
        call paw_psi_fnm_to_X(n_max,n,fnm,U,D,tmp)

        call DMSUB(n_max,n,fnm,X1,tmp)
        adiff = tmp(idamax(n_max*n,tmp,1))
        call dcopy(n_max*n,fnm,1,X1,1)

        adiff = dabs(adiff)

        if (adiff.lt.convg) failed = .false.
      end do

      return
      end


*     ***********************************
*     *                                 *
*     *        paw_psi_fnm_to_X         *
*     *                                 *
*     ***********************************
      subroutine paw_psi_fnm_to_X(n_max,n,
     >                            fnm,U,D,tmp)
      implicit none
      integer n_max,n
      real*8 fnm(n_max,n)
      real*8 U(n_max,n)
      real*8 D(n_max,n)
      real*8 tmp(n_max,n)

      !**** local variables ****
      integer i,j
      real*8  d2


      !**** fnm = Ut*fnm*U ***
      call dgemm('N','N',n,n,n,1.0d0,
     >           fnm,n_max,
     >           U,n_max,
     >           0.0d0,
     >           tmp,n_max)
      call dgemm('T','N',n,n,n,1.0d0,
     >           U,n_max,
     >           tmp,n_max,
     >           0.0d0,
     >           fnm,n_max)


      !**** fnm = (Ut*fnm*U)_nm/(d_n+d_m) ***
      do j=1,n
      do i=1,n
        d2 = D(i,1)+D(j,1)
        fnm(i,j) = fnm(i,j)/d2
      end do
      end do

      !**** fnm = X = U*{(Ut*fnm*U)_nm/(d_n+d_m)}*Ut ***
      call dgemm('N','N',n,n,n,1.0d0,
     >           U,n_max,
     >           fnm,n_max,
     >           0.0d0,
     >           tmp,n_max)
      call dgemm('N','T',n,n,n,1.0d0,
     >           tmp,n_max,
     >           U,n_max,
     >           0.0d0,
     >           fnm,n_max)

      return
      end 

c===============================================================c
c                                                               c
c       NCC - a New Coupled-Cluster code for NWChem             c
c                                                               c
c       Developed by:                                           c
c                                                               c
c               Jeff R. Hammond                                 c
c               Leadership Computing Facility                   c
c               Argonne National Laboratory                     c
c               jhammond@mcs.anl.gov                            c
c                                                               c
c               Karol Kowalski                                  c
c               Environmental Molecular Sciences Laboratory     c
c               Pacific Northwest National Laboratory           c
c               karol.kowalski@pnl.gov                          c
c                                                               c
c               Marta Włoch                                     c
c               Department of Chemistry                         c
c               Michigan Technological University               c
c               wloch@mtu.edu                                   c
c                                                               c
c===============================================================c
      logical function ncc_input(rtdb)
c
c $Id: ncc_input.F 21494 2011-11-09 23:09:16Z jhammond $
c
      implicit none
#include "inp.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "stdio.fh"
c===============================================================c
c                                                               c
#include "ncc_input.fh"                                         
c                                                               c
c      ...defines these common variables:                       c
c                                                               c
c      integer debugmode                                        c
c      double precision thresh                                  c
c      character*20 method                                      c
c                                                               c
c      I am using common variables to pass from this routine    c
c      into the NCC module so that I don't have to use the      c
c      RTDB since that would involve disk access.               c
c                                                               c
c===============================================================c
c
      integer rtdb
      integer itemp
c
      double precision dtemp
c
      character*20 test
      character*20 ctemp
c
      logical debug
      logical ltemp
c
#ifdef DEBUG_PRINT
      print*,'top of ncc_input'
      debug = .true.
#else
      debug = .false.
#endif
c
      ncc_input = .false.
c
c ----------
c Read input
c ----------
c
c
 10   if (.not. inp_read()) then
        call errquit('ncc_input: failed reading input',0,RTDB_ERR)
      endif
      if (.not. inp_a(test)) then
        call errquit('ncc_input: failed reading keyword',0,RTDB_ERR)
      endif
c
c     DEBUGMODE
c
      if (inp_compare(.false.,test,'debugmode')) then
        if (debug) write(LuOut,100) 'debugmode'
        if (.not.inp_i(itemp)) then
          write(LuOut,200) 'debugmode',100
          debugmode = 100
        else
          debugmode = itemp
        endif
#ifndef NO_RTDB_CALLS
        if (.not.rtdb_put(rtdb,'ncc:debugmode',mt_int,1,thresh)) then
          call errquit('ncc_input: rtdb_put failed',0,RTDB_ERR)
        endif
#endif
        if (debug) write(LuOut,150) debugmode
c
c     FREEZE (frozen cores/virtuals)
c
      elseif (inp_compare(.false.,test,'freeze')) then
        if (debug) write(LuOut,100) 'freeze'
        call freeze_input(rtdb,'ncc')
c
c     METHOD (ccsd, etc.)
c
      elseif (inp_compare(.false.,test,'method')) then
        if (debug) write(LuOut,100) 'method'
        if (.not.inp_a(ctemp)) then
          call errquit('ncc_input: no method given',0,RTDB_ERR)
        endif
        method = ctemp
#ifndef NO_RTDB_CALLS
        if (.not.rtdb_cput(rtdb,'ncc:method',1,ctemp)) then
          call errquit('ncc_input: rtdb_cput failed',0,RTDB_ERR)
        endif
#endif
        if (debug) write(LuOut,170) method
c
c     THRESH (convergence threshold for Davidson iteration)
c
      elseif (inp_compare(.false.,test,'thresh')) then
        if (debug) write(LuOut,100) 'thresh'
        if (.not.inp_f(dtemp)) then
          call errquit('ncc_input: no thresh given',0,RTDB_ERR)
        endif
        thresh = dtemp
#ifndef NO_RTDB_CALLS
        if (.not.rtdb_put(rtdb,'ncc:thresh',mt_dbl,1,thresh)) then
          call errquit('ncc_input: rtdb_put failed',0,RTDB_ERR)
        endif
#endif
        if (debug) write(LuOut,160) thresh
c
c     TILING
c
      elseif (inp_compare(.false.,test,'occtile')) then
        if (debug) write(LuOut,100) 'occtile'
        if (.not.inp_i(itemp)) then
          write(LuOut,200) 'occtile',10
          occtile = 10
        else
          occtile = itemp
        endif
#ifndef NO_RTDB_CALLS
        if (.not.rtdb_put(rtdb,'ncc:occtile',mt_int,1,thresh)) then
          call errquit('ncc_input: rtdb_put failed',0,RTDB_ERR)
        endif
#endif
        if (debug) write(LuOut,150) occtile
c
      elseif (inp_compare(.false.,test,'virtile')) then
        if (debug) write(LuOut,100) 'virtile'
        if (.not.inp_i(itemp)) then
          write(LuOut,200) 'virtile',25
          virtile = 25
        else
          virtile = itemp
        endif
#ifndef NO_RTDB_CALLS
        if (.not.rtdb_put(rtdb,'ncc:virtile',mt_int,1,thresh)) then
          call errquit('ncc_input: rtdb_put failed',0,RTDB_ERR)
        endif
#endif
        if (debug) write(LuOut,150) virtile
c
c     PRINT
c
      elseif (inp_compare(.false.,test,'print')) then
        if (debug) write(LuOut,100) 'print'
        call util_print_input(rtdb,'ncc')
c
c     END
c
      elseif (inp_compare(.false.,test,'end')) then
        if (debug) write(LuOut,100) 'end'
        goto 20
      else
        call errquit('ncc_input: unknown directive',0,INPUT_ERR)
      endif
      goto 10
c
c ------
c Return
c ------
c
 20   continue
c
      ncc_input = .true.
c
#ifdef DEBUG_PRINT
      print*,'end of ncc_input'
#endif
c
      return
c
 100  format(8x,'keyword found:         ',a20)
 150  format(8x,'using value:           ',i20)
 160  format(8x,'using value:           ',f20.8)
 170  format(8x,'using value:           ',a20)
 200  format(8x,'value not found for:   ',a20,/,
     &       8x,'using default value of ',i20)
c
      end

!$Id: paw_spher_grid.F 19707 2010-10-29 17:59:36Z d3y133 $
!
!$Log:

      subroutine get_spher_grid(ntheta,nphi,angle_phi,
     >                          cos_theta,w_theta,w_phi)
      implicit none

      integer ntheta
      integer nphi
      double precision cos_theta(ntheta)
      double precision angle_phi(nphi)
      double precision w_theta(ntheta)
      double precision w_phi(nphi)

#include "paw_params.fh"

*     *** local variables ***
      integer i

*     *** gaussian quadrature angular grid for cos_theta ***
      call gauss_weights(-1.0d0,1.0d0,cos_theta,w_theta,ntheta)

      if (nphi.gt.1) then
*       *** linear angular grid for angle_phi***
        do i=1,nphi
         angle_phi(i) = 2.0d0*pi*(i-1)/(nphi-1)
         w_phi(i) = 2.0d0*pi/(nphi-1)
        end do
        w_phi(1)    = 0.5d0*w_phi(1)
        w_phi(nphi) = w_phi(1)
      else
        angle_phi(1) = 0.0d0
        w_phi(1)     = 2.0d0*pi
      end if

      end

*> \brief \b ZHEMV
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZHEMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
* 
*       .. Scalar Arguments ..
*       COMPLEX*16 ALPHA,BETA
*       INTEGER INCX,INCY,LDA,N
*       CHARACTER UPLO
*       ..
*       .. Array Arguments ..
*       COMPLEX*16 A(LDA,*),X(*),Y(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZHEMV  performs the matrix-vector  operation
*>
*>    y := alpha*A*x + beta*y,
*>
*> where alpha and beta are scalars, x and y are n element vectors and
*> A is an n by n hermitian matrix.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>           On entry, UPLO specifies whether the upper or lower
*>           triangular part of the array A is to be referenced as
*>           follows:
*>
*>              UPLO = 'U' or 'u'   Only the upper triangular part of A
*>                                  is to be referenced.
*>
*>              UPLO = 'L' or 'l'   Only the lower triangular part of A
*>                                  is to be referenced.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the order of the matrix A.
*>           N must be at least zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is COMPLEX*16
*>           On entry, ALPHA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is COMPLEX*16 array of DIMENSION ( LDA, n ).
*>           Before entry with  UPLO = 'U' or 'u', the leading n by n
*>           upper triangular part of the array A must contain the upper
*>           triangular part of the hermitian matrix and the strictly
*>           lower triangular part of A is not referenced.
*>           Before entry with UPLO = 'L' or 'l', the leading n by n
*>           lower triangular part of the array A must contain the lower
*>           triangular part of the hermitian matrix and the strictly
*>           upper triangular part of A is not referenced.
*>           Note that the imaginary parts of the diagonal elements need
*>           not be set and are assumed to be zero.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program. LDA must be at least
*>           max( 1, n ).
*> \endverbatim
*>
*> \param[in] X
*> \verbatim
*>          X is COMPLEX*16 array of dimension at least
*>           ( 1 + ( n - 1 )*abs( INCX ) ).
*>           Before entry, the incremented array X must contain the n
*>           element vector x.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           X. INCX must not be zero.
*> \endverbatim
*>
*> \param[in] BETA
*> \verbatim
*>          BETA is COMPLEX*16
*>           On entry, BETA specifies the scalar beta. When BETA is
*>           supplied as zero then Y need not be set on input.
*> \endverbatim
*>
*> \param[in,out] Y
*> \verbatim
*>          Y is COMPLEX*16 array of dimension at least
*>           ( 1 + ( n - 1 )*abs( INCY ) ).
*>           Before entry, the incremented array Y must contain the n
*>           element vector y. On exit, Y is overwritten by the updated
*>           vector y.
*> \endverbatim
*>
*> \param[in] INCY
*> \verbatim
*>          INCY is INTEGER
*>           On entry, INCY specifies the increment for the elements of
*>           Y. INCY must not be zero.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex16_blas_level2
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 2 Blas routine.
*>  The vector and matrix arguments are not referenced when N = 0, or M = 0
*>
*>  -- Written on 22-October-1986.
*>     Jack Dongarra, Argonne National Lab.
*>     Jeremy Du Croz, Nag Central Office.
*>     Sven Hammarling, Nag Central Office.
*>     Richard Hanson, Sandia National Labs.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE ZHEMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
*
*  -- Reference BLAS level2 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      COMPLEX*16 ALPHA,BETA
      INTEGER INCX,INCY,LDA,N
      CHARACTER UPLO
*     ..
*     .. Array Arguments ..
      COMPLEX*16 A(LDA,*),X(*),Y(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16 ONE
      PARAMETER (ONE= (1.0D+0,0.0D+0))
      COMPLEX*16 ZERO
      PARAMETER (ZERO= (0.0D+0,0.0D+0))
*     ..
*     .. Local Scalars ..
      COMPLEX*16 TEMP1,TEMP2
      INTEGER I,INFO,IX,IY,J,JX,JY,KX,KY
*     ..
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC DBLE,DCONJG,MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (.NOT.LSAME(UPLO,'U') .AND. .NOT.LSAME(UPLO,'L')) THEN
          INFO = 1
      ELSE IF (N.LT.0) THEN
          INFO = 2
      ELSE IF (LDA.LT.MAX(1,N)) THEN
          INFO = 5
      ELSE IF (INCX.EQ.0) THEN
          INFO = 7
      ELSE IF (INCY.EQ.0) THEN
          INFO = 10
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('ZHEMV ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((N.EQ.0) .OR. ((ALPHA.EQ.ZERO).AND. (BETA.EQ.ONE))) RETURN
*
*     Set up the start points in  X  and  Y.
*
      IF (INCX.GT.0) THEN
          KX = 1
      ELSE
          KX = 1 - (N-1)*INCX
      END IF
      IF (INCY.GT.0) THEN
          KY = 1
      ELSE
          KY = 1 - (N-1)*INCY
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through the triangular part
*     of A.
*
*     First form  y := beta*y.
*
      IF (BETA.NE.ONE) THEN
          IF (INCY.EQ.1) THEN
              IF (BETA.EQ.ZERO) THEN
                  DO 10 I = 1,N
                      Y(I) = ZERO
   10             CONTINUE
              ELSE
                  DO 20 I = 1,N
                      Y(I) = BETA*Y(I)
   20             CONTINUE
              END IF
          ELSE
              IY = KY
              IF (BETA.EQ.ZERO) THEN
                  DO 30 I = 1,N
                      Y(IY) = ZERO
                      IY = IY + INCY
   30             CONTINUE
              ELSE
                  DO 40 I = 1,N
                      Y(IY) = BETA*Y(IY)
                      IY = IY + INCY
   40             CONTINUE
              END IF
          END IF
      END IF
      IF (ALPHA.EQ.ZERO) RETURN
      IF (LSAME(UPLO,'U')) THEN
*
*        Form  y  when A is stored in upper triangle.
*
          IF ((INCX.EQ.1) .AND. (INCY.EQ.1)) THEN
              DO 60 J = 1,N
                  TEMP1 = ALPHA*X(J)
                  TEMP2 = ZERO
                  DO 50 I = 1,J - 1
                      Y(I) = Y(I) + TEMP1*A(I,J)
                      TEMP2 = TEMP2 + DCONJG(A(I,J))*X(I)
   50             CONTINUE
                  Y(J) = Y(J) + TEMP1*DBLE(A(J,J)) + ALPHA*TEMP2
   60         CONTINUE
          ELSE
              JX = KX
              JY = KY
              DO 80 J = 1,N
                  TEMP1 = ALPHA*X(JX)
                  TEMP2 = ZERO
                  IX = KX
                  IY = KY
                  DO 70 I = 1,J - 1
                      Y(IY) = Y(IY) + TEMP1*A(I,J)
                      TEMP2 = TEMP2 + DCONJG(A(I,J))*X(IX)
                      IX = IX + INCX
                      IY = IY + INCY
   70             CONTINUE
                  Y(JY) = Y(JY) + TEMP1*DBLE(A(J,J)) + ALPHA*TEMP2
                  JX = JX + INCX
                  JY = JY + INCY
   80         CONTINUE
          END IF
      ELSE
*
*        Form  y  when A is stored in lower triangle.
*
          IF ((INCX.EQ.1) .AND. (INCY.EQ.1)) THEN
              DO 100 J = 1,N
                  TEMP1 = ALPHA*X(J)
                  TEMP2 = ZERO
                  Y(J) = Y(J) + TEMP1*DBLE(A(J,J))
                  DO 90 I = J + 1,N
                      Y(I) = Y(I) + TEMP1*A(I,J)
                      TEMP2 = TEMP2 + DCONJG(A(I,J))*X(I)
   90             CONTINUE
                  Y(J) = Y(J) + ALPHA*TEMP2
  100         CONTINUE
          ELSE
              JX = KX
              JY = KY
              DO 120 J = 1,N
                  TEMP1 = ALPHA*X(JX)
                  TEMP2 = ZERO
                  Y(JY) = Y(JY) + TEMP1*DBLE(A(J,J))
                  IX = JX
                  IY = JY
                  DO 110 I = J + 1,N
                      IX = IX + INCX
                      IY = IY + INCY
                      Y(IY) = Y(IY) + TEMP1*A(I,J)
                      TEMP2 = TEMP2 + DCONJG(A(I,J))*X(IX)
  110             CONTINUE
                  Y(JY) = Y(JY) + ALPHA*TEMP2
                  JX = JX + INCX
                  JY = JY + INCY
  120         CONTINUE
          END IF
      END IF
*
      RETURN
*
*     End of ZHEMV .
*
      END
c $Id: zhemv.f 24342 2013-06-22 05:32:15Z d3y133 $

      SUBROUTINE ccsd2_q_right(a_i0,d_i1_1,d_i1_2,d_t1,d_t2,d_v2,k_i1_of
     &fset_1,k_i1_offset_2,k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offs
     &et_1,l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_h4b,t_p5b,t_p6b,t_p7b,t_p8b
     &,toggle)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_vtt + = 3/2 * P( 24 ) * Sum ( h14 ) * t ( p5 p6 h1 h14 )_t * i1 ( h14 p7 p8 h2 h3 h4 )_vt
C         i1 ( h14 p5 p6 h1 h2 h3 )_vt + = 1/3 * P( 3 ) * Sum ( h10 ) * t ( p5 p6 h1 h10 )_t * i2 ( h10 h14 h2 h3 )_v
C             i2 ( h10 h14 h1 h2 )_v + = 1 * v ( h10 h14 h1 h2 )_v
C             i2 ( h10 h14 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p11 ) * t ( p11 h1 )_t * i3 ( h10 h14 h2 p11 )_v
C                 i3 ( h10 h14 h1 p11 )_v + = 1 * v ( h10 h14 h1 p11 )_v
C                 i3 ( h10 h14 h1 p11 )_vt + = -1/2 * Sum ( p12 ) * t ( p12 h1 )_t * v ( h10 h14 p11 p12 )_v
C             i2 ( h10 h14 h1 h2 )_vt + = 1/2 * Sum ( p11 p12 ) * t ( p11 p12 h1 h2 )_t * v ( h10 h14 p11 p12 )_v
C         i1 ( h14 p5 p6 h1 h2 h3 )_vt + = -2/3 * P( 6 ) * Sum ( p9 ) * t ( p5 p9 h1 h2 )_t * i2 ( h14 p6 h3 p9 )_v
C             i2 ( h14 p5 h1 p9 )_v + = 1 * v ( h14 p5 h1 p9 )_v
C             i2 ( h14 p5 h1 p9 )_vt + = 1 * Sum ( h10 ) * t ( p5 h10 )_t * i3 ( h10 h14 h1 p9 )_v
C                 i3 ( h10 h14 h1 p9 )_v + = 1 * v ( h10 h14 h1 p9 )_v
C                 i3 ( h10 h14 h1 p9 )_vt + = -1 * Sum ( p11 ) * t ( p11 h1 )_t * v ( h10 h14 p9 p11 )_v
C             i2 ( h14 p5 h1 p9 )_vt + = -1 * Sum ( p11 ) * t ( p11 h1 )_t * v ( h14 p5 p9 p11 )_v
C             i2 ( h14 p5 h1 p9 )_vt + = 1 * Sum ( h12 p11 ) * t ( p5 p11 h1 h12 )_t * v ( h12 h14 p9 p11 )_v
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_vtt + = 3/2 * P( 24 ) * Sum ( p9 ) * t ( p5 p9 h1 h2 )_t * i1 ( p6 p7 p8 h3 h4 p9 )_vt
C         i1 ( p5 p6 p7 h1 h2 p9 )_vt + = -1/3 * P( 3 ) * Sum ( p10 ) * t ( p5 p10 h1 h2 )_t * i2 ( p6 p7 p9 p10 )_v
C             i2 ( p5 p6 p9 p10 )_v + = 1 * v ( p5 p6 p9 p10 )_v
C             i2 ( p5 p6 p9 p10 )_vt + = -1 * P( 2 ) * Sum ( h11 ) * t ( p5 h11 )_t * i3 ( h11 p6 p9 p10 )_v
C                 i3 ( h11 p5 p9 p10 )_v + = 1 * v ( h11 p5 p9 p10 )_v
C                 i3 ( h11 p5 p9 p10 )_vt + = -1/2 * Sum ( h12 ) * t ( p5 h12 )_t * v ( h11 h12 p9 p10 )_v
C             i2 ( p5 p6 p9 p10 )_vt + = 1/2 * Sum ( h11 h12 ) * t ( p5 p6 h11 h12 )_t * v ( h11 h12 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER toggle
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_i1_1
      INTEGER k_i1_offset_1
      INTEGER l_i1_offset_1
      INTEGER d_i1_2
      INTEGER k_i1_offset_2
      INTEGER l_i1_offset_2
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER size_i1_1
      INTEGER l_i2_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER size_i2
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i3
      INTEGER k_i3_offset
      INTEGER l_i3_offset
      INTEGER size_i3
      INTEGER size_i1_2
      DOUBLE PRECISION a_i0(*)
      CHARACTER*255 filename
      IF (toggle .eq. 3) THEN
      CALL DELETEFILE(d_i1_2)
      IF (.not.MA_POP_STACK(l_i1_offset_2)) CALL ERRQUIT('ccsd2_q_right'
     &,-1,MA_ERR)
      END IF
      IF (toggle .eq. 3) THEN
      CALL DELETEFILE(d_i1_1)
      IF (.not.MA_POP_STACK(l_i1_offset_1)) CALL ERRQUIT('ccsd2_q_right'
     &,-1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_1_1(l_i1_offset_1,k_i
     &1_offset_1,size_i1_1)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_1_1_i1',filena
     &me)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i1_1,size_i1_1)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_1_1_1(l_i2_offset,k_i
     &2_offset,size_i2)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_1_1_1_i2',file
     &name)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i2,size_i2)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_1_1(d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_1_1_2_1(l_i3_offset,k
     &_i3_offset,size_i3)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_1_1_2_1_i3',fi
     &lename)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i3,size_i3)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_1_2_1(d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_1_2_2(d_t1,k_t1_offset,d_v
     &2,k_v2_offset,d_i3,k_i3_offset)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i3,size_i3)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_1_2(d_t1,k_t1_offset,d_i3,
     &k_i3_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) THEN
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsd2_q_right',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_1_3(d_t2,k_t2_offset,d_v2,
     &k_v2_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i2,size_i2)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_1(d_t2,k_t2_offset,d_i2,k_
     &i2_offset,d_i1_1,k_i1_offset_1)
      IF (toggle .eq. 1) THEN
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsd2_q_right',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_1_2_1(l_i2_offset,k_i
     &2_offset,size_i2)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_1_2_1_i2',file
     &name)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i2,size_i2)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_2_1(d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_1_2_2_1(l_i3_offset,k
     &_i3_offset,size_i3)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_1_2_2_1_i3',fi
     &lename)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i3,size_i3)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_2_2_1(d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_2_2_2(d_t1,k_t1_offset,d_v
     &2,k_v2_offset,d_i3,k_i3_offset)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i3,size_i3)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_2_2(d_t1,k_t1_offset,d_i3,
     &k_i3_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) THEN
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsd2_q_right',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_2_3(d_t1,k_t1_offset,d_v2,
     &k_v2_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_2_4(d_t2,k_t2_offset,d_v2,
     &k_v2_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i2,size_i2)
      IF (toggle .eq. 1) CALL ccsd2_q_right_1_2(d_t2,k_t2_offset,d_i2,k_
     &i2_offset,d_i1_1,k_i1_offset_1)
      IF (toggle .eq. 1) THEN
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsd2_q_right',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i1_1,size_i1_1)
      IF (toggle .eq. 2) CALL ccsd2_q_right_1(d_t2,k_t2_offset,d_i1_1,k_
     &i1_offset_1,a_i0,t_p5b,t_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_2_1(l_i1_offset_2,k_i
     &1_offset_2,size_i1_2)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_2_1_i1',filena
     &me)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i1_2,size_i1_2)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_2_1_1(l_i2_offset,k_i
     &2_offset,size_i2)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_2_1_1_i2',file
     &name)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i2,size_i2)
      IF (toggle .eq. 1) CALL ccsd2_q_right_2_1_1(d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_q_right_2_1_2_1(l_i3_offset,k
     &_i3_offset,size_i3)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_q_right_2_1_2_1_i3',fi
     &lename)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i3,size_i3)
      IF (toggle .eq. 1) CALL ccsd2_q_right_2_1_2_1(d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      IF (toggle .eq. 1) CALL ccsd2_q_right_2_1_2_2(d_t1,k_t1_offset,d_v
     &2,k_v2_offset,d_i3,k_i3_offset)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i3,size_i3)
      IF (toggle .eq. 1) CALL ccsd2_q_right_2_1_2(d_t1,k_t1_offset,d_i3,
     &k_i3_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) THEN
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsd2_q_right',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL ccsd2_q_right_2_1_3(d_t2,k_t2_offset,d_v2,
     &k_v2_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i2,size_i2)
      IF (toggle .eq. 1) CALL ccsd2_q_right_2_1(d_t2,k_t2_offset,d_i2,k_
     &i2_offset,d_i1_2,k_i1_offset_2)
      IF (toggle .eq. 1) THEN
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsd2_q_right',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i1_2,size_i1_2)
      IF (toggle .eq. 2) CALL ccsd2_q_right_2(d_t2,k_t2_offset,d_i1_2,k_
     &i1_offset_2,a_i0,t_p5b,t_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1(d_a,k_a_offset,d_b,k_b_offset,a_c,t_p5b
     &,t_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_vtt + = 3/2 * P( 24 ) * Sum ( h14 ) * t ( p5 p6 h1 h14 )_t * i1 ( h14 p7 p8 h2 h3 h4 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER p8b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h14b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h14b_1
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER h14b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = noab+1,noab+nvab
      DO p8b = p7b,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h4b = h3b,noab
      skipped = .true.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+h1b-1)+i
     &nt_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.1
     &6)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-
     &1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1)
     &))))))) .eq. ieor(irrep_v,ieor(irrep_t,irrep_t))) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h14b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h14b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h14b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h1b,h14b,p5b_1,p6b_1,h1b_1,h14b_1)
      CALL TCE_RESTRICTED_6(p7b,p8b,h14b,h2b,h3b,h4b,p7b_2,p8b_2,h14b_2,
     &h2b_2,h3b_2,h4b_2)
      dim_common = int_mb(k_range+h14b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1) * int_mb
     &(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1',2,MA_ERR)
      IF ((h14b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1
     &),4,2,1,3,-1.0d0)
      END IF
      IF ((h1b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h14b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h4b_2
     & - 1 + noab * (h3b_2 - 1 + noab * (h2b_2 - 1 + noab * (h14b_2 - 1 
     &+ noab * (p8b_2 - noab - 1 + nvab * (p7b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+h14b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),6,5,4,2,1,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,5,4,6,3,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,5,4,3,6,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,5,4,3,2,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,5,4,3,2,1,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,7,4,6,3,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,7,4,3,6,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,7,4,3,2,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,7,4,3,2,1,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,7,4,6,3,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,7,4,3,6,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,7,4,3,2,6,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,7,4,3,2,1,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,4,7,6,3,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,4,7,3,6,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,4,7,3,2,6,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,8,4,7,3,2,1,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,4,7,6,3,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,4,7,3,6,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,4,7,3,2,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,5,4,7,3,2,1,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,4,8,7,6,3,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,4,8,7,3,6,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,4,8,7,3,2,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),5,4,8,7,3,2,1,6,-3.0d0/2.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1',9,
     &MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h14 p5 p6 h1 h2 h3 )_vt + = 1/3 * P( 3 ) * Sum ( h10 ) * t ( p5 p6 h1 h10 )_t * i2 ( h10 h14 h2 h3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER h14b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h10b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h10b_1
      INTEGER h14b_2
      INTEGER h10b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO h2b = 1,noab
      DO h3b = h2b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h14b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h14b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+h14b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_
     &mb(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h10b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h1b,h10b,p5b_1,p6b_1,h1b_1,h10b_1)
      CALL TCE_RESTRICTED_4(h14b,h10b,h2b,h3b,h14b_2,h10b_2,h2b_2,h3b_2)
      dim_common = int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h14b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_1',2,MA_ERR)
      IF ((h10b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h10b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h10b-1),int_mb(k_range+h1b-1
     &),4,2,1,3,-1.0d0)
      END IF
      IF ((h1b .le. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h10b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_1',5,MA_ERR)
      IF ((h10b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h3b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (h14b_2 - 1 + noab * (h10b_2 - 1
     &)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-
     &1),4,3,2,1,1.0d0)
      END IF
      IF ((h14b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h3b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (h10b_2 - 1 + noab * (h14b_2 - 1
     &)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-
     &1),4,3,1,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_1',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_1',9,MA_ERR)
      IF ((h1b .le. h2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),6,5,3,4,2,1,1.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab *
     & (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((h2b .le. h1b) .and. (h1b .le. h3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),6,5,3,2,4,1,-1.0d0/3
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * (h14b - 1 + noab *
     & (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((h3b .le. h1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),6,5,3,2,1,4,1.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h14b - 1 + noab *
     & (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_1_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h14 p5 p6 h1 h2 h3 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      INTEGER h14b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h3b - 1 + noab * (h2b - 1 + noab * (h1b 
     &- 1 + noab * (h14b - 1 + noab * (p6b - noab - 1 + nvab * (p5b - no
     &ab - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_
     &mb(k_range+h14b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
     & * int_mb(k_range+h3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h10 h14 h1 h2 )_v + = 1 * v ( h10 h14 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER h10b_1
      INTEGER h14b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_mb(k_
     &range+h1b-1) * int_mb(k_range+h2b-1)
      CALL TCE_RESTRICTED_4(h10b,h14b,h1b,h2b,h10b_1,h14b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (h14b_1 - 1 + (noa
     &b+nvab) * (h10b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-
     &1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_1_1',2,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h14b-1),int_mb(k_range+h10b-
     &1),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab * (h10b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_1_1',4,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_1
     &',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_1_1_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h10 h14 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER h2b
      length = 0
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_1_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h2b - 1 + noab * (h1b - 1 + noab * (h14b
     & - 1 + noab * (h10b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * in
     &t_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h10 h14 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p11 ) * t ( p11 h1 )_t * i3 ( h10 h14 h2 p11 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p11b
      INTEGER p11b_1
      INTEGER h1b_1
      INTEGER h10b_2
      INTEGER h14b_2
      INTEGER h2b_2
      INTEGER p11b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_v,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_mb(k_
     &range+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p11b = noab+1,noab+nvab
      IF (int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p11b,h1b,p11b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h10b,h14b,h2b,p11b,h10b_2,h14b_2,h2b_2,p11b_
     &2)
      dim_common = int_mb(k_range+p11b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_
     &mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p11b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_1_2',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h14b_2 - 1 + noab * (h1
     &0b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h2b-1),int_mb(k_range+p11b
     &-1),3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_1_2',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_2
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_2
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2',9,MA_ERR)
      IF ((h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+h10b-1),int_mb(k_range+h1b-
     &1),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab * (h10b - 1)))))
      END IF
      IF ((h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+h10b-1),int_mb(k_range+h1b-
     &1),3,2,1,4,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (h14b - 1 + noab * (h10b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_1_2',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_2
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_1_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h10 h14 h1 p11 )_v + = 1 * v ( h10 h14 h1 p11 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER p11b
      INTEGER dimc
      INTEGER h10b_1
      INTEGER h14b_1
      INTEGER h1b_1
      INTEGER p11b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p11b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p11b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_mb(k_
     &range+h1b-1) * int_mb(k_range+p11b-1)
      CALL TCE_RESTRICTED_4(h10b,h14b,h1b,p11b,h10b_1,h14b_1,h1b_1,p11b_
     &1)
      dim_common = 1
      dima_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+p11b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2_1',1,MA_ERR)
      IF ((h1b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p11b_
     &1 - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (h14b_1 - 1 + (no
     &ab+nvab) * (h10b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1),int_mb(k_range+p11b
     &-1),4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_1_2_1',2
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p11b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h14b-1),int_mb(k_range+h10b
     &-1),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p11b 
     &- noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (h10b - 1
     &)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_1_2_1',4
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_2
     &_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_1_1_2_1(l_a_offset,k_a_offset,size
     &)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h10 h14 h1 p11 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER p11b
      length = 0
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p11b = noab+1,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p11b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_1_1_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p11b = noab+1,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p11b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p11b - noab - 1 + nvab * (h1b - 1 + noab
     & * (h14b - 1 + noab * (h10b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * in
     &t_mb(k_range+h1b-1) * int_mb(k_range+p11b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_1_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h10 h14 h1 p11 )_vt + = -1/2 * Sum ( p12 ) * t ( p12 h1 )_t * v ( h10 h14 p11 p12 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER p11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p12b
      INTEGER p12b_1
      INTEGER h1b_1
      INTEGER h10b_2
      INTEGER h14b_2
      INTEGER p11b_2
      INTEGER p12b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p11b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p11b-1)))) .eq. ieor(irrep_v,irrep_t))
     & THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_mb(k_
     &range+h1b-1) * int_mb(k_range+p11b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p12b = noab+1,noab+nvab
      IF (int_mb(k_spin+p12b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p12b,h1b,p12b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h10b,h14b,p11b,p12b,h10b_2,h14b_2,p11b_2,p12
     &b_2)
      dim_common = int_mb(k_range+p12b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_
     &mb(k_range+p11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p12b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_1_2_2',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2_2',5,MA_ERR)
      IF ((p12b .lt. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - 1 + (noab+nvab) * (p12b_2 - 1 + (noab+nvab) * (h14b_2 - 1 + (n
     &oab+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p12b-1),int_mb(k_range+p11
     &b-1),4,2,1,3,-1.0d0)
      END IF
      IF ((p11b .le. p12b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p12b_
     &2 - 1 + (noab+nvab) * (p11b_2 - 1 + (noab+nvab) * (h14b_2 - 1 + (n
     &oab+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p12
     &b-1),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_1_2_2',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_2
     &_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_2
     &_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_2_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p11b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h10b-1),int_mb(k_range+h1b
     &-1),3,2,4,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p11b 
     &- noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (h10b - 1
     &)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_1_2_2',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_2
     &_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_1_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h10 h14 h1 h2 )_vt + = 1/2 * Sum ( p11 p12 ) * t ( p11 p12 h1 h2 )_t * v ( h10 h14 p11 p12 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p11b
      INTEGER p12b
      INTEGER p11b_1
      INTEGER p12b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h10b_2
      INTEGER h14b_2
      INTEGER p11b_2
      INTEGER p12b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_v,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_mb(k_
     &range+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p11b = noab+1,noab+nvab
      DO p12b = p11b,noab+nvab
      IF (int_mb(k_spin+p11b-1)+int_mb(k_spin+p12b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p11b,p12b,h1b,h2b,p11b_1,p12b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(h10b,h14b,p11b,p12b,h10b_2,h14b_2,p11b_2,p12
     &b_2)
      dim_common = int_mb(k_range+p11b-1) * int_mb(k_range+p12b-1)
      dima_sort = int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p12b_1 - noab - 1 + nvab * (p11
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p12b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-
     &1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_1_3',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_1_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p12b_
     &2 - 1 + (noab+nvab) * (p11b_2 - 1 + (noab+nvab) * (h14b_2 - 1 + (n
     &oab+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p12
     &b-1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_1_3',6,M
     &A_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p11b .eq. p12b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_3
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_3
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_1_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-
     &1),2,1,4,3,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab * (h10b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_1_3',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_1_3
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h14 p5 p6 h1 h2 h3 )_vt + = -2/3 * P( 6 ) * Sum ( p9 ) * t ( p5 p9 h1 h2 )_t * i2 ( h14 p6 h3 p9 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER h14b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER p5b_1
      INTEGER p9b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p6b_2
      INTEGER h14b_2
      INTEGER h3b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h14b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h14b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+h14b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_
     &mb(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p9b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p9b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p9b,h1b,h2b,p5b_1,p9b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(p6b,h14b,h3b,p9b,p6b_2,h14b_2,h3b_2,p9b_2)
      dim_common = int_mb(k_range+p9b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+h14b-1) * int_m
     &b(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_2',2,MA_ERR)
      IF ((p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p9b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p9b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_2',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (h3b_2 - 1 + noab * (h14b_2 - 1 + noab * (p6b
     &_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+h3b-1),int_mb(k_range+p9b-1
     &),3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_2',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_2',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_2',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_2',9,MA_ERR)
      IF ((p5b .le. p6b) .and. (h2b .le. h3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),6,3,2,5,4,1,-2.0d0/3
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab *
     & (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p5b .le. p6b) .and. (h3b .le. h1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),6,3,2,1,5,4,-2.0d0/3
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (h14b - 1 + noab *
     & (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p5b .le. p6b) .and. (h1b .le. h3b) .and. (h3b .le. h2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),6,3,2,5,1,4,2.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab *
     & (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p6b .le. p5b) .and. (h2b .le. h3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),3,6,2,5,4,1,2.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab *
     & (p5b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p6b .le. p5b) .and. (h3b .le. h1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),3,6,2,1,5,4,2.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (h14b - 1 + noab *
     & (p5b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p6b .le. p5b) .and. (h1b .le. h3b) .and. (h3b .le. h2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),3,6,2,5,1,4,-2.0d0/3
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * (h14b - 1 + noab *
     & (p5b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_2',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_2',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h14 p5 h1 p9 )_v + = 1 * v ( h14 p5 h1 p9 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER p5b_1
      INTEGER h14b_1
      INTEGER h1b_1
      INTEGER p9b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+h14b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p9b-1)
      CALL TCE_RESTRICTED_4(p5b,h14b,h1b,p9b,p5b_1,h14b_1,h1b_1,p9b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h14b-1) * int_m
     &b(k_range+h1b-1) * int_mb(k_range+p9b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_1',1,MA_ERR)
      IF ((h14b .le. p5b) .and. (h1b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p9b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p5b_1 - 1 + (noab
     &+nvab) * (h14b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+p9b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_2_1',2,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (p5b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_2_1',4,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_1
     &',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_1_2_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h14 p5 h1 p9 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_1_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p9b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (h14b - 1 + noab * (p5b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+h14b-1) * int
     &_mb(k_range+h1b-1) * int_mb(k_range+p9b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h14 p5 h1 p9 )_vt + = 1 * Sum ( h10 ) * t ( p5 h10 )_t * i3 ( h10 h14 h1 p9 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h10b
      INTEGER p5b_1
      INTEGER h10b_1
      INTEGER h14b_2
      INTEGER h10b_2
      INTEGER h1b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+h14b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h10b = 1,noab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h10b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p5b,h10b,p5b_1,h10b_1)
      CALL TCE_RESTRICTED_4(h14b,h10b,h1b,p9b,h14b_2,h10b_2,h1b_2,p9b_2)
      dim_common = int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p5b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h14b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h10b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_2_2',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2',5,MA_ERR)
      IF ((h10b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (h1b_2 - 1 + noab * (h14b_2 - 1 + noab * (h10
     &b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1),int_mb(k_range+p9b-
     &1),4,3,2,1,1.0d0)
      END IF
      IF ((h14b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (h1b_2 - 1 + noab * (h10b_2 - 1 + noab * (h14
     &b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h1b-1),int_mb(k_range+p9b-
     &1),4,3,1,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_2_2',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_2
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_2
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h14b-1),int_mb(k_range+p5b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (p5b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_2_2',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_2
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_2_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h10 h14 h1 p9 )_v + = 1 * v ( h10 h14 h1 p9 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER h10b_1
      INTEGER h14b_1
      INTEGER h1b_1
      INTEGER p9b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_mb(k_
     &range+h1b-1) * int_mb(k_range+p9b-1)
      CALL TCE_RESTRICTED_4(h10b,h14b,h1b,p9b,h10b_1,h14b_1,h1b_1,p9b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+p9b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2_1',1,MA_ERR)
      IF ((h1b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p9b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (h14b_1 - 1 + (noa
     &b+nvab) * (h10b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h1b-1),int_mb(k_range+p9b-
     &1),4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_2_2_1',2
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h14b-1),int_mb(k_range+h10b-
     &1),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (h10b - 1)
     &))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_2_2_1',4
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_2
     &_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_1_2_2_1(l_a_offset,k_a_offset,size
     &)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h10 h14 h1 p9 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      length = 0
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_1_2_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p9b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (h14b - 1 + noab * (h10b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * in
     &t_mb(k_range+h1b-1) * int_mb(k_range+p9b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_2_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h10 h14 h1 p9 )_vt + = -1 * Sum ( p11 ) * t ( p11 h1 )_t * v ( h10 h14 p9 p11 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h10b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p11b
      INTEGER p11b_1
      INTEGER h1b_1
      INTEGER h10b_2
      INTEGER h14b_2
      INTEGER p9b_2
      INTEGER p11b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h10b = 1,noab
      DO h14b = h10b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin
     &+h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_m
     &b(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_v,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_mb(k_
     &range+h1b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p11b = noab+1,noab+nvab
      IF (int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p11b,h1b,p11b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h10b,h14b,p9b,p11b,h10b_2,h14b_2,p9b_2,p11b_
     &2)
      dim_common = int_mb(k_range+p11b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h14b-1) * int_
     &mb(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p11b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_2_2_2',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2_2',5,MA_ERR)
      IF ((p11b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - 1 + (noab+nvab) * (p11b_2 - 1 + (noab+nvab) * (h14b_2 - 1 + (no
     &ab+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p9b
     &-1),4,2,1,3,-1.0d0)
      END IF
      IF ((p9b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h14b_2 - 1 + (no
     &ab+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b
     &-1),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_2_2_2',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_2
     &_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_2
     &_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_2_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+h10b-1),int_mb(k_range+h1b-
     &1),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (h10b - 1)
     &))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_2_2_2',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_2
     &_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_2_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h14 p5 h1 p9 )_vt + = -1 * Sum ( p11 ) * t ( p11 h1 )_t * v ( h14 p5 p9 p11 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p11b
      INTEGER p11b_1
      INTEGER h1b_1
      INTEGER p5b_2
      INTEGER h14b_2
      INTEGER p9b_2
      INTEGER p11b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+h14b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p11b = noab+1,noab+nvab
      IF (int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p11b,h1b,p11b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p5b,h14b,p9b,p11b,p5b_2,h14b_2,p9b_2,p11b_2)
      dim_common = int_mb(k_range+p11b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h14b-1) * int_m
     &b(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p11b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_2_3',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_3',5,MA_ERR)
      IF ((h14b .le. p5b) .and. (p11b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - 1 + (noab+nvab) * (p11b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noa
     &b+nvab) * (h14b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p9b-
     &1),4,1,2,3,-1.0d0)
      END IF
      IF ((h14b .le. p5b) .and. (p9b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noa
     &b+nvab) * (h14b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b-
     &1),3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_2_3',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_3
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_3
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1
     &),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (p5b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_2_3',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_3
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_1_2_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h14 p5 h1 p9 )_vt + = 1 * Sum ( h12 p11 ) * t ( p5 p11 h1 h12 )_t * v ( h12 h14 p9 p11 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER h14b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p11b
      INTEGER h12b
      INTEGER p5b_1
      INTEGER p11b_1
      INTEGER h1b_1
      INTEGER h12b_1
      INTEGER h14b_2
      INTEGER h12b_2
      INTEGER p9b_2
      INTEGER p11b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+h14b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p11b = noab+1,noab+nvab
      DO h12b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p11b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p11b,h1b,h12b,p5b_1,p11b_1,h1b_1,h12b_1)
      CALL TCE_RESTRICTED_4(h14b,h12b,p9b,p11b,h14b_2,h12b_2,p9b_2,p11b_
     &2)
      dim_common = int_mb(k_range+p11b-1) * int_mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h14b-1) * int_mb(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_4',2,MA_ERR)
      IF ((p11b .lt. p5b) .and. (h12b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h12b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p11
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h12b-1),int_mb(k_range+h1b-
     &1),4,2,3,1,1.0d0)
      END IF
      IF ((p11b .lt. p5b) .and. (h1b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p11
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h12b-
     &1),3,2,4,1,-1.0d0)
      END IF
      IF ((p5b .le. p11b) .and. (h12b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h12b_1 - 1 + noab * (p11b_1 - noab - 1 + nvab * (p5
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h1b-
     &1),4,1,3,2,-1.0d0)
      END IF
      IF ((p5b .le. p11b) .and. (h1b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h1b_1 - 1 + noab * (p11b_1 - noab - 1 + nvab * (p5
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+h1b-1),int_mb(k_range+h12b-
     &1),3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_1_2_4',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_1_2_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_4',5,MA_ERR)
      IF ((h12b .le. h14b) .and. (p11b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - 1 + (noab+nvab) * (p11b_2 - 1 + (noab+nvab) * (h14b_2 - 1 + (no
     &ab+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p11b-1),int_mb(k_range+p9b
     &-1),4,2,1,3,-1.0d0)
      END IF
      IF ((h12b .le. h14b) .and. (p9b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h14b_2 - 1 + (no
     &ab+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b
     &-1),3,2,1,4,1.0d0)
      END IF
      IF ((h14b .lt. h12b) .and. (p11b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - 1 + (noab+nvab) * (p11b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h14b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p11b-1),int_mb(k_range+p9b
     &-1),4,1,2,3,1.0d0)
      END IF
      IF ((h14b .lt. h12b) .and. (p9b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h14b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b
     &-1),3,1,2,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_1_2_4',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_4
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_4
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_1_2_4',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1
     &),4,2,3,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h14b - 1 + noab * (p5b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_1_2_4',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_1_2_4
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_2(d_a,k_a_offset,d_b,k_b_offset,a_c,t_p5b
     &,t_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_vtt + = 3/2 * P( 24 ) * Sum ( p9 ) * t ( p5 p9 h1 h2 )_t * i1 ( p6 p7 p8 h3 h4 p9 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER p8b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER p5b_1
      INTEGER p9b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO p7b = p6b,noab+nvab
      DO p8b = p7b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      skipped = .true.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+h1b-1)+i
     &nt_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.1
     &6)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-
     &1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1)
     &))))))) .eq. ieor(irrep_v,ieor(irrep_t,irrep_t))) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p9b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p9b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p9b,h1b,h2b,p5b_1,p9b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_6(p6b,p7b,p8b,h3b,h4b,p9b,p6b_2,p7b_2,p8b_2,h3
     &b_2,h4b_2,p9b_2)
      dim_common = int_mb(k_range+p9b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+p7b-1) * int_mb
     &(k_range+p8b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_2',2,MA_ERR)
      IF ((p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p9b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p9b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_2',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1 + noab * (p8b_
     &2 - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     &)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p8b-1),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p9b-1),5,4,3,2,1,6,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_2',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_2',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_2',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,5,4,3,7,6,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,5,4,3,2,7,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,5,4,3,7,2,6,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,5,4,3,2,7,1,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,5,4,3,7,2,1,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,5,4,3,2,1,7,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,8,4,3,7,6,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,8,4,3,2,7,6,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,8,4,3,7,2,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,8,4,3,2,7,1,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,8,4,3,7,2,1,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,8,4,3,2,1,7,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,8,3,7,6,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,8,3,2,7,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,8,3,7,2,6,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,8,3,2,7,1,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,8,3,7,2,1,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,8,3,2,1,7,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,3,8,7,6,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,3,8,2,7,6,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,3,8,7,2,6,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,3,8,2,7,1,6,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,3,8,7,2,1,6,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),5,4,3,8,2,1,7,6,-3.0d0/2.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_2',9,
     &MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_2_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 p7 h1 h2 p9 )_vt + = -1/3 * P( 3 ) * Sum ( p10 ) * t ( p5 p10 h1 h2 )_t * i2 ( p6 p7 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h1b
      INTEGER h2b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p10b
      INTEGER p5b_1
      INTEGER p10b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER p9b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+p9b-1).ne.12)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+p9b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+p9b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p10b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p10b,h1b,h2b,p5b_1,p10b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(p6b,p7b,p9b,p10b,p6b_2,p7b_2,p9b_2,p10b_2)
      dim_common = int_mb(k_range+p10b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+p7b-1) * int_mb
     &(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_2_1',2,MA_ERR)
      IF ((p10b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p10b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,2,1,-1.0d0)
      END IF
      IF ((p5b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_2_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_2_1',5,MA_ERR)
      IF ((p10b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p10b_2 - noab - 1 + nvab * (p7b_2 - noab - 1
     & + nvab * (p6b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p10b-1),int_mb(k_range+p9b-1
     &),4,2,1,3,-1.0d0)
      END IF
      IF ((p9b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p7b_2 - noab - 1
     & + nvab * (p6b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_2_1',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_2_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_2_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_2_1',9,MA_ERR)
      IF ((p5b .le. p6b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),6,3,2,5,4,1,-1.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h2b - 1 + noab * (h1b - 1 + noab * (p7b - noab
     & - 1 + nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),3,6,2,5,4,1,1.0d0/3.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h2b - 1 + noab * (h1b - 1 + noab * (p7b - noab
     & - 1 + nvab * (p5b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p7b .le. p5b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),3,2,6,5,4,1,-1.0d0/3.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h2b - 1 + noab * (h1b - 1 + noab * (p5b - noab
     & - 1 + nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_2_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_2_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_2_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 p7 h1 h2 p9 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h1b
      INTEGER h2b
      INTEGER p9b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+p9b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+p9b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+p9b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+p9b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+p9b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+p9b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p9b - noab - 1 + nvab * (h2b - 1 + noab 
     &* (h1b - 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nva
     &b * (p5b - noab - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_
     &mb(k_range+p7b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) 
     &* int_mb(k_range+p9b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_2_1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p5 p6 p9 p10 )_v + = 1 * v ( p5 p6 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p9b
      INTEGER p10b
      INTEGER dimc
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p9b_1
      INTEGER p10b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+p
     &9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p9b-1) * int_mb(k_range+p10b-1)
      CALL TCE_RESTRICTED_4(p5b,p6b,p9b,p10b,p5b_1,p6b_1,p9b_1,p10b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+p9b-1) * int_mb(k_range+p10b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p10b_
     &1 - 1 + (noab+nvab) * (p9b_1 - 1 + (noab+nvab) * (p6b_1 - 1 + (noa
     &b+nvab) * (p5b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b-1
     &),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_2_1_1',2,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p10b 
     &- noab - 1 + nvab * (p9b - noab - 1 + nvab * (p6b - noab - 1 + nva
     &b * (p5b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_2_1_1',4,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_1
     &',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_2_1_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p5 p6 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      INTEGER p9b
      INTEGER p10b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+p
     &9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_2_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+p
     &9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p10b - noab - 1 + nvab * (p9b - noab - 1
     & + nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_
     &mb(k_range+p9b-1) * int_mb(k_range+p10b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_2_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p5 p6 p9 p10 )_vt + = -1 * P( 2 ) * Sum ( h11 ) * t ( p5 h11 )_t * i3 ( h11 p6 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p9b
      INTEGER p10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h11b
      INTEGER p5b_1
      INTEGER h11b_1
      INTEGER p6b_2
      INTEGER h11b_2
      INTEGER p9b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+p
     &9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p9b-1) * int_mb(k_range+p10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h11b = 1,noab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h11b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h11b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p5b,h11b,p5b_1,h11b_1)
      CALL TCE_RESTRICTED_4(p6b,h11b,p9b,p10b,p6b_2,h11b_2,p9b_2,p10b_2)
      dim_common = int_mb(k_range+h11b-1)
      dima_sort = int_mb(k_range+p5b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+p9b-1) * int_mb
     &(k_range+p10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h11b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_2_1_2',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (h11b_2 - 1 + noa
     &b * (p6b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b-
     &1),4,3,1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_2_1_2',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_2
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_2
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2',9,MA_ERR)
      IF ((p5b .le. p6b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1
     &),4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p10b 
     &- noab - 1 + nvab * (p9b - noab - 1 + nvab * (p6b - noab - 1 + nva
     &b * (p5b - noab - 1)))))
      END IF
      IF ((p6b .le. p5b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1
     &),3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p10b 
     &- noab - 1 + nvab * (p9b - noab - 1 + nvab * (p5b - noab - 1 + nva
     &b * (p6b - noab - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_2_1_2',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_2
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_2_1_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h11 p5 p9 p10 )_v + = 1 * v ( h11 p5 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER h11b
      INTEGER p9b
      INTEGER p10b
      INTEGER dimc
      INTEGER p5b_1
      INTEGER h11b_1
      INTEGER p9b_1
      INTEGER p10b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO h11b = 1,noab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+h11b-
     &1)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+h11b-1) .eq. int_mb(k_spin+
     &p9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_mb
     &(k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+h11b-1) * int_mb(k_r
     &ange+p9b-1) * int_mb(k_range+p10b-1)
      CALL TCE_RESTRICTED_4(p5b,h11b,p9b,p10b,p5b_1,h11b_1,p9b_1,p10b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h11b-1) * int_m
     &b(k_range+p9b-1) * int_mb(k_range+p10b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2_1',1,MA_ERR)
      IF ((h11b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p10b_
     &1 - 1 + (noab+nvab) * (p9b_1 - 1 + (noab+nvab) * (p5b_1 - 1 + (noa
     &b+nvab) * (h11b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b-
     &1),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_2_1_2_1',2
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+h11b-1),int_mb(k_range+p5b-
     &1),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p10b 
     &- noab - 1 + nvab * (p9b - noab - 1 + nvab * (h11b - 1 + noab * (p
     &5b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_2_1_2_1',4
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_2
     &_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_q_right_2_1_2_1(l_a_offset,k_a_offset,size
     &)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h11 p5 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER h11b
      INTEGER p9b
      INTEGER p10b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO h11b = 1,noab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (int_mb(k_spin+h11b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+
     &p9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+h11b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h11b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_q_right_2_1_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO h11b = 1,noab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (int_mb(k_spin+h11b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+
     &p9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+h11b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h11b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p10b - noab - 1 + nvab * (p9b - noab - 1
     & + nvab * (h11b - 1 + noab * (p5b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+h11b-1) * int
     &_mb(k_range+p9b-1) * int_mb(k_range+p10b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_q_right_2_1_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h11 p5 p9 p10 )_vt + = -1/2 * Sum ( h12 ) * t ( p5 h12 )_t * v ( h11 h12 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER h11b
      INTEGER p9b
      INTEGER p10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h12b
      INTEGER p5b_1
      INTEGER h12b_1
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER p9b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO h11b = 1,noab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+h11b-
     &1)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+h11b-1) .eq. int_mb(k_spin+
     &p9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_mb
     &(k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. ieor(irrep_v,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+h11b-1) * int_mb(k_r
     &ange+p9b-1) * int_mb(k_range+p10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h12b = 1,noab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h12b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p5b,h12b,p5b_1,h12b_1)
      CALL TCE_RESTRICTED_4(h11b,h12b,p9b,p10b,h11b_2,h12b_2,p9b_2,p10b_
     &2)
      dim_common = int_mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p5b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h11b-1) * int_mb(k_range+p9b-1) * int_m
     &b(k_range+p10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h12b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_2_1_2_2',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2_2',5,MA_ERR)
      IF ((h12b .lt. h11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h11b_2 - 1 + (no
     &ab+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b
     &-1),4,3,2,1,-1.0d0)
      END IF
      IF ((h11b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h11b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b
     &-1),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_2_1_2_2',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_2
     &_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_2
     &_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_2_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+h11b-1),int_mb(k_range+p5b-
     &1),4,3,2,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p10b 
     &- noab - 1 + nvab * (p9b - noab - 1 + nvab * (h11b - 1 + noab * (p
     &5b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_2_1_2_2',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_2
     &_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_q_right_2_1_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsd2_q_right.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p5 p6 p9 p10 )_vt + = 1/2 * Sum ( h11 h12 ) * t ( p5 p6 h11 h12 )_t * v ( h11 h12 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p9b
      INTEGER p10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h11b
      INTEGER h12b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER p9b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL nxtask
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+p
     &9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p9b-1),int_mb(k_sym+p10b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p9b-1) * int_mb(k_range+p10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h11b = 1,noab
      DO h12b = h11b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &11b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h11b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h11b,h12b,p5b_1,p6b_1,h11b_1,h12b_1)
      CALL TCE_RESTRICTED_4(h11b,h12b,p9b,p10b,h11b_2,h12b_2,p9b_2,p10b_
     &2)
      dim_common = int_mb(k_range+h11b-1) * int_mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p9b-1) * int_mb(k_range+p10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_q_right_2_1_3',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_q_right_2_1_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h11b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b
     &-1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_q_right_2_1_3',6,M
     &A_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h11b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_3
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_3
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_q_right_2_1_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1
     &),4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p10b 
     &- noab - 1 + nvab * (p9b - noab - 1 + nvab * (p6b - noab - 1 + nva
     &b * (p5b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_q_right_2_1_3',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_q_right_2_1_3
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

C> \ingroup task
C> @{
C>
C> \brief Reads the task directive from input and stores associated 
C> parameters on the RTDB
C>
C> This routine should be called by the root process only.
C> The objective of this routine is to parse the task directive and
C> check for any inconsistencies. The details of the task directive are
C> stored on the RTDB. 
C> ~~~~
C> task [qmmm] <string theory> [<string operation = energy>] [numerical || analytic] 
C>      [ignore]
C> ~~~~
C> The actual task call itself has to be made elsewhere. In case an
C> inconsistency is found the code will abort with an error.
C>
      subroutine task_input(rtdb)
c
c $Id: task_input.F 25962 2014-07-31 17:17:07Z bylaska $
c
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "mafdecls.fh"
      integer rtdb !< [Input] The RTDB handle
c
c     Called by process 0 only.  Does nothing but read the input
c     and set corresponding the database parameters
c
c     Called whenever the input parser encounters a task directive.
c     Terminates by calling errquit if there was any error.
c
c     task [qmmm] <string theory> [<string operation = energy>] [numerical || analytic] 
c          [ignore]
c
      logical numerical, ignore, oqmmm, analytic
      logical orism
      logical opes
c      logical oembed
      logical ofragment
      logical osmd
      character*30 test, operation
      character*32 theory
      character*128 err_string
c
      theory    = ' '
      operation = ' '
      analytic  = .false.
      numerical = .false.
      ignore    = .false.
      oqmmm     = .false.
      orism     = .false.
      opes      = .false.
      ofragment = .false.
      osmd      = .false.
c      oembed    = .false.
c
      call rtdb_clean(rtdb, 'task:') ! Delete ALL previous task parameters
      
c
      if (.not. inp_a(test)) goto 1000 ! task keyword
 10   if (inp_a(test)) then
         if (inp_compare(.false.,test,'energy')) then
            operation = 'energy'
         else if (inp_compare(.false.,test,'abc')) then
            operation = 'abc'
         else if (inp_compare(.false.,test,'fep')) then
            operation = 'fep'
         else if (inp_compare(.false.,test,'property')) then
            operation = 'property'
         else if (inp_compare(.false.,test,'optimize')) then
            operation = 'optimize'
         else if (inp_compare(.false.,test,'saddle')) then
            operation = 'saddle'
         else if (inp_compare(.false.,test,'lst')) then
            operation = 'lst'
         else if (inp_compare(.false.,test,'neb')) then
            operation = 'neb'
         else if (inp_compare(.false.,test,'gradient')) then
            operation = 'gradient'
         else if (inp_compare(.false.,test,'hessian')) then
            operation = 'hessian'
         else if (inp_compare(.false.,test,'dynamics')) then
            operation = 'dynamics'
         else if (inp_compare(.false.,test,'qmd')) then
            operation = 'qmd'
         else if (inp_compare(.false.,test,'rfcf')) then
            operation = 'rfcf'
         else if (inp_compare(.false.,test,'thermodynamics')) then
            operation = 'thermodynamics'
         else if (inp_compare(.false.,test,'mepgs')) then
            operation = 'mepgs'
         else if (inp_compare(.false.,test,'string')) then
            operation = 'string'
         else if (inp_compare(.false.,test,'et')) then
            operation = 'et'
         else if (inp_compare(.false.,test,'rt_tddft')) then
            operation = 'rt_tddft'
c         else if (inp_compare(.false.,test,'prepare')) then
c            operation = 'prepare'
         else if (inp_compare(.false.,test,'freq') .or.
     $            inp_compare(.false.,test,'frequencies')) then
            operation = 'freq'
         else if (inp_compare(.false.,test,'numerical')) then
            numerical = .true.
         else if (inp_compare(.false.,test,'analytic')) then
            analytic  = .true.
         else if (inp_compare(.false.,test,'vscf')) then
            operation  = 'vscf'
         else if (inp_compare(.false.,test,'raman')) then
            operation  = 'raman'
         else if (inp_compare(.false.,test,'dntmc')) then
            operation  = 'dntmc'
         else if (inp_compare(.false.,test,'ccca')) then
            theory  = 'ccca'
         else if (inp_compare(.false.,test,'shell')) then
            theory = 'shell'
            call task_shell_input(rtdb)
         else if (inp_compare(.false.,test,'debug')) then
            if (.not. rtdb_put(rtdb, 'task:debug', MT_LOG, 1, .true.))
     $           call errquit('task_input: failed putting debug flag',0,
     &       RTDB_ERR)
         else if (inp_compare(.false.,test,'ignore')) then
            ignore = .true.
         else if (inp_compare(.false.,test,'rism')) then
            orism = .true.
         else if (inp_compare(.false.,test,'qmmm')) then
            oqmmm = .true.
c         else if (inp_compare(.false.,test,'embed')) then
c            oembed = .true.
         else if (inp_compare(.false.,test,'fragment')) then
            ofragment = .true.
         else if (inp_compare(.false.,test,'smd')) then
            osmd = .true.
         else if (inp_compare(.false.,test,'pes')) then
            opes = .true.
         else if (inp_compare(.false.,test,
     >                        'steepest_descent')) then
            operation='steepest_descent'
         else if (inp_compare(.false.,test,
     >                        'espcharge')) then
            operation='espcharge'
         else if (inp_compare(.false.,test,
     >                        'Car-Parrinello')) then
            operation='Car-Parrinello'
         else if (inp_compare(.false.,test,
     >                        'Born-Oppenheimer')) then
            operation='Born-Oppenheimer'
         else if (inp_compare(.false.,test,
     >                        'Metropolis')) then
            operation='Metropolis'
         else if (inp_compare(.false.,test,
     >                        'nwpw-optimize')) then
            operation='nwpw-optimize'
         else if (inp_compare(.false.,test,
     >                        'aimd_properties')) then
            operation='aimd_properties'
         else if (inp_compare(.false.,test,
     >                        'conjugate_gradient')) then
            operation='conjugate_gradient'
         else if (inp_compare(.false.,test,
     >                        'wavefunction_initializer')) then
            operation='wavefunction_initializer'
         else if (inp_compare(.false.,test,
     >                        'v_wavefunction_initializer')) then
            operation='v_wavefunction_initializer'
         else if (inp_compare(.false.,test,
     >                        'wavefunction_expander')) then
            operation='wavefunction_expander'
         else if (inp_compare(.false.,test,
     >                        'psp_formatter')) then
            operation='psp_formatter'
         else if (inp_compare(.false.,test,
     >                        'psp_generator')) then
            operation='psp_generator'
         else if (inp_compare(.false.,test,
     >                        'cell_optimize')) then
            operation='cell_optimize'
         else if (inp_compare(.false.,test,
     >                        'stress')) then
            operation='stress'
         else if (inp_compare(.false.,test,
     >                        'noit_energy')) then
            operation='noit_energy'
         else if (inp_compare(.false.,test,
     >                        'pspw_dplot')) then
            operation='pspw_dplot'
         else if (inp_compare(.false.,test,
     >                        'band_dplot')) then
            operation='band_dplot'
         else if (inp_compare(.false.,test,
     >                        'wannier')) then
            operation='wannier'
         else if (inp_compare(.false.,test,
     >                        'pspw_et')) then
            operation='pspw_et'
         else if (inp_compare(.false.,test,
     >                        'expand_cell')) then
            operation='expand_cell'
         else if (inp_compare(.false.,test,
     >                        'ionize')) then
            operation='ionize'
         else if (inp_compare(.false.,test,
     >                        'convert_restricted')) then
            operation='convert_restricted'
         else if (inp_compare(.false.,test,
     >                        'structure')) then
            operation='structure'
         else if (inp_compare(.false.,test,
     >                        'dos')) then
            operation='dos'
         else if (inp_compare(.false.,test,
     >                        'dos_dplot')) then
            operation='dos_dplot'
         else if (inp_compare(.false.,test,
     >                        'rdf')) then
            operation='rdf'
         else if (inp_compare(.false.,test,
     >                        'lcao')) then
            operation='lcao'

         else if (theory .eq. ' ') then
            theory = test
            call inp_lcase(theory)
         else
            goto 1000
         endif
         goto 10
      endif
      call inp_clear_err()
c
      if (numerical.and.analytic) then
        write(luout,*)' ********** fatal input error ************'
        write(luout,*)' both numerical and analytic specified '
        goto 1000
      endif
      if (numerical) then
         if (.not. rtdb_put(rtdb, 'task:numerical', mt_log, 1, 
     $        numerical)) call errquit('task_input: rtdb is corrupt',0,
     &       RTDB_ERR)
      endif
      if (analytic) then
         if (.not. rtdb_put(rtdb, 'task:analytic', mt_log, 1, 
     $        analytic)) call errquit('task_input: rtdb is corrupt',0,
     &       RTDB_ERR)
      endif
      if (osmd) then
        if (.not.rtdb_put(rtdb, 'task:smd', mt_log, 1, .true.))
     &       call errquit('task_input:task:smd rtdb is corrupt',911,
     &       RTDB_ERR)
      end if
      if (ofragment) then
        if (.not.rtdb_put(rtdb, 'task:fragment', mt_log, 1, .true.))
     &       call errquit('task_input:task:pes rtdb is corrupt',911,
     &       RTDB_ERR)
      end if
      if (opes) then
        if (.not.rtdb_put(rtdb, 'task:pes', mt_log, 1, .true.))
     &       call errquit('task_input:task:pes rtdb is corrupt',911,
     &       RTDB_ERR)
      end if
      if (orism) then
        if (.not.rtdb_put(rtdb, 'task:rism', mt_log, 1, .true.))
     &       call errquit('task_input:task:QMMM rtdb is corrupt',911,
     &       RTDB_ERR)
        if (theory.eq.'md') call errquit
     &      ('task_input:theory must be a QM method for rism',911,
     &       RTDB_ERR)
        if (operation.ne.'energy') call errquit
     &      ("task_input:"//operation//"not supported with QMMM",911,
     &       RTDB_ERR)
      endif
      if (oqmmm) then
        if (.not.rtdb_put(rtdb, 'task:QMMM', mt_log, 1, .true.))
     &       call errquit('task_input:task:QMMM rtdb is corrupt',911,
     &       RTDB_ERR)
        if (theory.eq.'md') call errquit
     &      ('task_input:theory must be a QM method for QMMM',911,
     &       RTDB_ERR)
        if (operation.ne.'energy' .and.
     >      theory.ne.'dplot' .and.
     >      theory.ne.'esp' .and.
     >      operation.ne.'optimize' .and.
     >      operation.ne.'fep' .and.
     >      operation.ne.'neb' .and.
     >      operation.ne.'saddle' .and.
     >      operation.ne.'frequencies' .and.
     >      operation.ne.'hessian' .and.
     >      operation.ne.'freq' .and.
     >      operation.ne.'mepgs' .and.
     >      operation.ne.'string' .and.
     >      operation.ne.'gradient' .and.
     >      operation.ne.'property' .and.
     >      operation.ne.'dynamics' .and.
     >      operation.ne.'qmd' .and.
     >      operation.ne.'rfcf' .and.
     >      operation.ne.'abc' .and.
     >      operation.ne.'et' ) call errquit
     &      ("task_input:"//operation//"not supported with QMMM",911,
     &       RTDB_ERR)
      endif
c
c      if (oembed) then
c        if (.not.rtdb_put(rtdb, 'task:embed', mt_log, 1, .true.))
c     &       call errquit('task_input:task:embed rtdb is corrupt',911,
c     &       RTDB_ERR)
c        if (operation.ne.'energy' .and.
c     >      operation.ne.'optimize' .and.
c     >      operation.ne.'prepare' .and.
c     >      operation.ne.'neb' .and.
c     >      operation.ne.'saddle' .and.
c     >      operation.ne.'frequencies' .and.
c     >      operation.ne.'hessian' .and.
c     >      operation.ne.'freq' .and.
c     >      operation.ne.'gradient' .and.
c     >      operation.ne.'property' .and.
c     >      operation.ne.'dynamics' .and.
c     >      operation.ne.'abc' .and.
c     >      operation.ne.'et' ) call errquit
c     &      ("task_input:"//operation//"not supported with embed",911,
c     &       RTDB_ERR)
c      endif
c
      if (ignore) then
         if (.not. rtdb_put(rtdb, 'task:ignore', mt_log, 1, 
     $        ignore)) call errquit('task_input: rtdb is corrupt',0,
     &       RTDB_ERR)
      endif
c
      if (theory .eq. ' ') then
        if(osmd) theory="smd"
      end if        
      if (theory .ne. ' ') then
         if (.not. rtdb_cput(rtdb, 'task:theory', 1, theory))
     $        call errquit('task_input: rtdb is corrupt', 0,
     &       RTDB_ERR)
      endif
      if (operation .ne. ' ') then
         if (.not. rtdb_cput(rtdb, 'task:operation',1,operation))
     $        call errquit('task_input: rtdb is corrupt', 0,
     &       RTDB_ERR)
      endif
c
      return
c
 1000 err_string =             'usage: task <string theory>'
      err_string = err_string//' [<string operation = energy>] '
      err_string = err_string//'[numerical || analytic] [ignore]'
      call errquit(err_string,911, INPUT_ERR)
c
c     THIS IS NEVER EXECUTED.  IT IS HERE BEACUSE -ltask IS AT
c     THE FRONT OF THE LINK PATH AND THE STATE ROUTINES ARE NOT
c     REFERENCED UNTIL LATER.
c
      call task_save_state(0,'a')
      call task_restore_state(0,'a')
      call task_delete_state(0,'a')
c
      end
C> @}

      SUBROUTINE ccsdtq_lambda2_10(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsdtq_lambda2_10.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yf + = 1 * Sum ( h12 p13 ) * y ( h3 h4 h12 p1 p2 p13 )_y * i1 ( p13 h12 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h12b
      INTEGER p13b
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER h12b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER p13b_1
      INTEGER p13b_2
      INTEGER h12b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_f)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_10',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h12b = 1,noab
      DO p13b = noab+1,noab+nvab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+h12b-1
     &) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p13
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h12b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),in
     &t_mb(k_sym+p13b-1)))))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_6(h3b,h4b,h12b,p1b,p2b,p13b,h3b_1,h4b_1,h12b_1
     &,p1b_1,p2b_1,p13b_1)
      CALL TCE_RESTRICTED_2(p13b,h12b,p13b_2,h12b_2)
      dim_common = int_mb(k_range+h12b-1) * int_mb(k_range+p13b-1)
      dima_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_10',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_10',2,MA_ERR)
      IF ((h12b .lt. h3b) .and. (p13b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p13b_1 - noab - 1
     & + nvab * (h4b_1 - 1 + noab * (h3b_1 - 1 + noab * (h12b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p13b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),6,5,3,2,4,1,1.0d0)
      END IF
      IF ((h12b .lt. h3b) .and. (p1b .le. p13b) .and. (p13b .lt. p2b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (h4b_1 - 1 + noab * (h3b_1 - 1 + noab * (h12b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p13b-1),int_mb(k_range+p2b-1),6,4,3,2,5,1,-1.0d0)
      END IF
      IF ((h12b .lt. h3b) .and. (p2b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p13b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (h4b_1 - 1 + noab * (h3b_1 - 1 + noab * (h12b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+p13b-1),5,4,3,2,6,1,1.0d0)
      END IF
      IF ((h3b .le. h12b) .and. (h12b .lt. h4b) .and. (p13b .lt. p1b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p13b_1 - noab - 1
     & + nvab * (h4b_1 - 1 + noab * (h12b_1 - 1 + noab * (h3b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h4b-1),int_mb(k_range+p13b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),6,5,3,1,4,2,-1.0d0)
      END IF
      IF ((h3b .le. h12b) .and. (h12b .lt. h4b) .and. (p1b .le. p13b) .a
     &nd. (p13b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (h4b_1 - 1 + noab * (h12b_1 - 1 + noab * (h3b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p13b-1),int_mb(k_range+p2b-1),6,4,3,1,5,2,1.0d0)
      END IF
      IF ((h3b .le. h12b) .and. (h12b .lt. h4b) .and. (p2b .le. p13b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p13b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (h4b_1 - 1 + noab * (h12b_1 - 1 + noab * (h3b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h4b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+p13b-1),5,4,3,1,6,2,-1.0d0)
      END IF
      IF ((h4b .le. h12b) .and. (p13b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p13b_1 - noab - 1
     & + nvab * (h12b_1 - 1 + noab * (h4b_1 - 1 + noab * (h3b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+p13b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),6,5,2,1,4,3,1.0d0)
      END IF
      IF ((h4b .le. h12b) .and. (p1b .le. p13b) .and. (p13b .lt. p2b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (h12b_1 - 1 + noab * (h4b_1 - 1 + noab * (h3b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p13b-1),int_mb(k_range+p2b-1),6,4,2,1,5,3,-1.0d0)
      END IF
      IF ((h4b .le. h12b) .and. (p2b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p13b_
     &1 - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1
     & + nvab * (h12b_1 - 1 + noab * (h4b_1 - 1 + noab * (h3b_1 - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+p13b-1),5,4,2,1,6,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_10',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_10',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_10',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h12b_
     &2 - 1 + noab * (p13b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+h12b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_10',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_10',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_10',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_10',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_10',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_10',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

*> \brief \b SORMQR
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SORMQR + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sormqr.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sormqr.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sormqr.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SORMQR( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
*                          WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          SIDE, TRANS
*       INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * ), C( LDC, * ), TAU( * ),
*      $                   WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SORMQR overwrites the general real M-by-N matrix C with
*>
*>                 SIDE = 'L'     SIDE = 'R'
*> TRANS = 'N':      Q * C          C * Q
*> TRANS = 'T':      Q**T * C       C * Q**T
*>
*> where Q is a real orthogonal matrix defined as the product of k
*> elementary reflectors
*>
*>       Q = H(1) H(2) . . . H(k)
*>
*> as returned by SGEQRF. Q is of order M if SIDE = 'L' and of order N
*> if SIDE = 'R'.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'L': apply Q or Q**T from the Left;
*>          = 'R': apply Q or Q**T from the Right.
*> \endverbatim
*>
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>          = 'N':  No transpose, apply Q;
*>          = 'T':  Transpose, apply Q**T.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix C. M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix C. N >= 0.
*> \endverbatim
*>
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>          The number of elementary reflectors whose product defines
*>          the matrix Q.
*>          If SIDE = 'L', M >= K >= 0;
*>          if SIDE = 'R', N >= K >= 0.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is REAL array, dimension (LDA,K)
*>          The i-th column must contain the vector which defines the
*>          elementary reflector H(i), for i = 1,2,...,k, as returned by
*>          SGEQRF in the first k columns of its array argument A.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.
*>          If SIDE = 'L', LDA >= max(1,M);
*>          if SIDE = 'R', LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is REAL array, dimension (K)
*>          TAU(i) must contain the scalar factor of the elementary
*>          reflector H(i), as returned by SGEQRF.
*> \endverbatim
*>
*> \param[in,out] C
*> \verbatim
*>          C is REAL array, dimension (LDC,N)
*>          On entry, the M-by-N matrix C.
*>          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*> \endverbatim
*>
*> \param[in] LDC
*> \verbatim
*>          LDC is INTEGER
*>          The leading dimension of the array C. LDC >= max(1,M).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The dimension of the array WORK.
*>          If SIDE = 'L', LWORK >= max(1,N);
*>          if SIDE = 'R', LWORK >= max(1,M).
*>          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*>          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*>          blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realOTHERcomputational
*
*  =====================================================================
      SUBROUTINE SORMQR( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            INFO, K, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            NBMAX, LDT
      PARAMETER          ( NBMAX = 64, LDT = NBMAX+1 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LEFT, LQUERY, NOTRAN
      INTEGER            I, I1, I2, I3, IB, IC, IINFO, IWS, JC, LDWORK,
     $                   LWKOPT, MI, NB, NBMIN, NI, NQ, NW
*     ..
*     .. Local Arrays ..
      REAL               T( LDT, NBMAX )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLARFB, SLARFT, SORM2R, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      NOTRAN = LSAME( TRANS, 'N' )
      LQUERY = ( LWORK.EQ.-1 )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) ) THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( K.LT.0 .OR. K.GT.NQ ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, NW ) .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
*
      IF( INFO.EQ.0 ) THEN
*
*        Determine the block size.  NB may be at most NBMAX, where NBMAX
*        is used to define the local array T.
*
         NB = MIN( NBMAX, ILAENV( 1, 'SORMQR', SIDE // TRANS, M, N, K,
     $        -1 ) )
         LWKOPT = MAX( 1, NW )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SORMQR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. K.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NBMIN = 2
      LDWORK = NW
      IF( NB.GT.1 .AND. NB.LT.K ) THEN
         IWS = NW*NB
         IF( LWORK.LT.IWS ) THEN
            NB = LWORK / LDWORK
            NBMIN = MAX( 2, ILAENV( 2, 'SORMQR', SIDE // TRANS, M, N, K,
     $              -1 ) )
         END IF
      ELSE
         IWS = NW
      END IF
*
      IF( NB.LT.NBMIN .OR. NB.GE.K ) THEN
*
*        Use unblocked code
*
         CALL SORM2R( SIDE, TRANS, M, N, K, A, LDA, TAU, C, LDC, WORK,
     $                IINFO )
      ELSE
*
*        Use blocked code
*
         IF( ( LEFT .AND. .NOT.NOTRAN ) .OR.
     $       ( .NOT.LEFT .AND. NOTRAN ) ) THEN
            I1 = 1
            I2 = K
            I3 = NB
         ELSE
            I1 = ( ( K-1 ) / NB )*NB + 1
            I2 = 1
            I3 = -NB
         END IF
*
         IF( LEFT ) THEN
            NI = N
            JC = 1
         ELSE
            MI = M
            IC = 1
         END IF
*
         DO 10 I = I1, I2, I3
            IB = MIN( NB, K-I+1 )
*
*           Form the triangular factor of the block reflector
*           H = H(i) H(i+1) . . . H(i+ib-1)
*
            CALL SLARFT( 'Forward', 'Columnwise', NQ-I+1, IB, A( I, I ),
     $                   LDA, TAU( I ), T, LDT )
            IF( LEFT ) THEN
*
*              H or H**T is applied to C(i:m,1:n)
*
               MI = M - I + 1
               IC = I
            ELSE
*
*              H or H**T is applied to C(1:m,i:n)
*
               NI = N - I + 1
               JC = I
            END IF
*
*           Apply H or H**T
*
            CALL SLARFB( SIDE, TRANS, 'Forward', 'Columnwise', MI, NI,
     $                   IB, A( I, I ), LDA, T, LDT, C( IC, JC ), LDC,
     $                   WORK, LDWORK )
   10    CONTINUE
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of SORMQR
*
      END
c $Id: sormqr.f 24343 2013-06-22 05:35:15Z d3y133 $

*
* $Id: chi_expander.F 24456 2013-07-30 23:08:29Z bylaska $
*

*     *******************************************
*     *						*
*     *	 	   chi_expander 		*
*     *						*
*     *******************************************

      logical function chi_expander(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"

      logical value
      integer version
 
      integer ierr

      integer ne(2),ispin

      character*50 new_wavefunction_filename
      character*50 old_wavefunction_filename
      character*255 full_filename,full_filename2


      integer ngrid(3)
      integer dngrid(3)
      integer nfft3d,n2ft3d
      integer dnfft3d,dn2ft3d
      integer ms,n,l
      integer cfull(2),dcfull(2)


      double precision unita(3,3)

      value = .false.
      version = 9

*     **** get wavefunction information ****
      value = rtdb_cget(rtdb,'xpndr:old_wavefunction_filename',
     >                  1,old_wavefunction_filename)
      value = rtdb_cget(rtdb,'xpndr:new_wavefunction_filename',
     >                  1,new_wavefunction_filename)

      value = rtdb_get(rtdb,'xpndr:ngrid',mt_int,3,dngrid)

 
      call util_file_name_noprefix(old_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin,1)
      call iread(5,ne,2)
 
      call util_file_name('wvfnc_expander',
     >                    .true.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      call openfile(6,full_filename,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,dngrid,3)
      call dwrite(6,unita,9)
      call iwrite(6,ispin,1)
      call iwrite(6,ne,2)

       
       nfft3d = ( ngrid(1)/2+1)* ngrid(2)* ngrid(3)
      dnfft3d = (dngrid(1)/2+1)*dngrid(2)*dngrid(3)
       n2ft3d = 2* nfft3d
      dn2ft3d = 2*dnfft3d

      write(*,109) old_wavefunction_filename
      write(*,110) new_wavefunction_filename
      write(*,111) ngrid(1), ngrid(2), ngrid(3),
     >            dngrid(1),dngrid(2),dngrid(3)
  109 format(' old_filename: ',A)
  110 format(' new_filename: ',A)
  111 format(' converting  : ',I3,'x',I3,'x',I3,' --> ', 
     >                     I3,'x',I3,'x',I3)
 
*     ***** allocate wavefunction memory ****
      value = MA_push_get(mt_dcpl,nfft3d,
     >                    'cfull',cfull(2),cfull(1))

      value = MA_push_get(mt_dcpl,dnfft3d,
     >                    'dcfull',dcfull(2),dcfull(1))

      do ms=1,ispin
          call dread(5,dcpl_mb(cfull(1)),n2ft3d)

          write(*,*) "converting .... spin:",ms
          call wvfnc_expander_convert(ngrid,dcpl_mb(cfull(1)),
     >                               dngrid,dcpl_mb(dcfull(1)))

          call dwrite(6,dcpl_mb(dcfull(1)),dn2ft3d)

      end do
      call closefile(5)
      call closefile(6)

c     *** copy wvfnc_expander to new_wavefunction_filename ****
      call util_file_name_noprefix(new_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)
      call util_file_copy(full_filename,full_filename2)
      call util_file_unlink(full_filename)
      IERR=0
      GO TO 9999
 
 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999
 
 9999 value =           MA_pop_stack(dcfull(2))
      value = value.and.MA_pop_stack(cfull(2))
      !IF(IERR.EQ.0) THEN
      !  WRITE(6,*) ' JOB HAS BEEN COMPLETED.  CODE=',IERR
      !ELSE
      !  WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
      !  value = .false.
      !ENDIF
      !call nwpw_message(4)
      
      chi_expander = value
      return 
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
      program main

c
#include "common"
c
      integer i, j, gdim, type
      integer gdims(NDIM+1), gwidth(NDIM+1)
      integer pdims(NDIM+1), mcnt, mapc(5000)
      integer g_fg, g_fld, g_bc, ptr_fg, ptr_fld, ptr_bc
      integer ld_fg(NDIM+1), ld_fld(NDIM+1), ld_bc(NDIM)
      integer heap, stack, me, nproc
c
#include "mafdecls.fh"
#include "global.fh"
c
c  Initialize a message passing library
c
#include "mp3.fh"
      size(1) = NSIZE
      size(2) = NSIZE
c
c   Initialize global arrays
c
      call ga_initialize()
c
      nproc = ga_nnodes()
      me = ga_nodeid()
c
      if (ga_uses_ma()) then
        heap = (size(1)+2)*(size(2)+2)*34/nproc
      else
        heap = 100000
      endif
      stack = 50000
c
      if (.not.ma_init(MT_DBL, stack, heap))
     +  call ga_error("ma init failed", -1)

c
c initialize global arrays
c
      do i = 1, NDIM
        dims(i) = size(i)
        gdims(i) = size(i)
        width(i) = 1
        gwidth(i) = 1
      end do
c
c  evaluate distribution of processors
c
      gdim = NDIM
      call factor(nproc,gdim,pdims)
      mcnt = 1
      do i = 1, NDIM
        do j = 0, pdims(i)-1
          mapc(mcnt) = ((dble(j)/dble(pdims(i)))*dble(gdims(i)))+1
          mcnt = mcnt + 1
        end do
      end do
      do i = 0, pdims(1)-1
        mapc(mcnt) = ((dble(i)/dble(pdims(1)))*dble(NDIM))+1
        mcnt = mcnt + 1
      end do
      do i = 0, pdims(2)-1
        mapc(mcnt) = ((dble(i)/dble(pdims(2)))*dble(NDIM))+1
        mcnt = mcnt + 1
      end do
c
c   Create global arrays. Start by creating array for LB distribution
c   functions. The last dimension runs over the distribution function
c   indices. The first 9 elements are the actual distribution elements,
c   the next 9 indices are the equilibrium distribution elements,
c   and the last 9 elements are temporary storage space used for doing
c   the streaming updates.
c
      type = MT_DBL
      gdim = 3
      gdims(3) = 27
      gwidth(3) = 0
      pdims(3) = 1
      mapc(mcnt) = 1
      if (.not.nga_create_ghosts_irreg(type, gdim, gdims, gwidth,
     +    "lb_dist", mapc, pdims, g_fg))
     +    call ga_error("g_fg init failed",me)
c
c   Create global array to hold density, momentum, pressure,
c   and relaxation parameters. These are stored at each point
c   and indexed by the last indice as density, p_x, p_y,
c   pressure, t_rho.
c
      type = MT_DBL
      gdim = 3
      gdims(3) = 6
      gwidth(3) = 0
      pdims(3) = 1
      mapc(mcnt) = 1
      if (.not.nga_create_ghosts_irreg(type, gdim, gdims, gwidth,
     +    "fields", mapc, pdims, g_fld))
     +    call ga_error("g_fld init failed",me)
c
c   Create global array to hold boundary condition data.
c
      type = MT_INT
      gdim = 2
      if (.not.nga_create_ghosts_irreg(type, gdim, gdims, gwidth,
     +    "bc_mask", mapc, pdims, g_bc))
     +    call ga_error("g_bc init failed",me)
c
c   Find pointers to global array data
c
      call nga_access_ghosts(g_fg,dims_fg,ptr_fg,ld_fg)
      call nga_access_ghosts(g_fld,dims_fld,ptr_fld,ld_fld)
      call nga_access_ghosts(g_bc,dims_bc,ptr_bc,ld_bc)
      do i = 1, NDIM
        dims(i) = dims_fg(i)
      end do
c
c   Call routine to run main simulation
c
      call boltzmann(g_fg,  dbl_mb(ptr_fg),  ld_fg(1),  ld_fg(2),
     +               g_fld, dbl_mb(ptr_fld), ld_fld(1), ld_fld(2),
     +               g_bc,  int_mb(ptr_bc),  ld_bc(1))
c
c   Close out calculation
c
      call ga_terminate()
      call MP_FINALIZE()
      stop
      end
c
      subroutine factor(p,ndim,dims)
      implicit none
      integer i,j,p,ndim,dims(*),imin,mdim
      integer ip,ifac,pmax,prime(1000)
      integer fac(1000)
c
      i = 1
      ip = p
      do i = 1, ndim
        dims(i) = 1
      end do
c
c    factor p completely
c    first, find all prime numbers less than or equal to p
c
      pmax = 0
      do i = 2, p
        do j = 1, pmax
          if (mod(i,prime(j)).eq.0) go to 100
        end do
        pmax = pmax + 1
        prime(pmax) = i
  100   continue
      end do
c
c    find all prime factors of p
c
      ifac = 0
      do i = 1, pmax
  200   if (mod(ip,prime(i)).eq.0) then
          ifac = ifac + 1
          fac(ifac) = prime(i)
          ip = ip/prime(i)
          go to 200
        endif
      end do
c
c    determine dimensions of processor grid
c
      do i = ifac, 1, -1
c
c    find dimension with minimum value
c
        imin = dims(1)
        mdim = 1
        do j = 2, ndim
          if (dims(j).lt.imin) then
            imin = dims(j)
            mdim = j
          endif
        end do
        dims(mdim) = dims(mdim)*fac(i)
      end do
c
      return
      end

      subroutine hbftrans(hbf,hbftrn,tr,nsy,nchan,nscat,nsch,nlm,
     1 ngauss,ngch,nbfmax,lmtop,nchnl,iprint,hbfp,hbftrnp,istat,ioft)
       implicit real*8 (a-h,o-z)
c
c  transform the bound index of the bound-free hamiltonian
c
      real*8 tr(nbfmax,nbfmax)
      complex*16 hbf(lmtop,nbfmax,nchnl**2),hbfp(lmtop,nbfmax,nchnl**2)
      complex*16 hbftrn(lmtop,nbfmax,nchnl**2),hbftrnp(lmtop,nbfmax
     1 ,nchnl**2)
      integer nscat(nchnl),ngauss(nchnl),nlm(nchnl),nsch(nbfmax,nchnl)
      integer ngch(nbfmax,nchnl)
      character*8 istat,ioft
      do 102 ic=1,nchan
      nlmic=nlm(ic)
      do 102 jc=1,nchan
      nsjc=nscat(jc)
      ngjc=ngauss(jc)
      icc=nchan*(ic-1) + jc
      do 80 i=1,nlmic
      do 80 j=1,nsjc
      hbftrnp(i,j,icc) = 0.
80    hbftrn(i,j,icc) = 0.
      do 100 kkc=1,ngjc
      do 100 ilm=1,nlmic
      do 100 jsc=1,nsjc
100    hbftrn(ilm,jsc,icc)=hbftrn(ilm,jsc,icc) +
     1   hbf(ilm,kkc,icc)*tr(ngch(kkc,jc),nsch(jsc,jc))
      if(istat.eq.ioft)then
      do 103 kkc=1,ngjc
      do 103 ilm=1,nlmic
      do 103 jsc=1,nsjc
103    hbftrnp(ilm,jsc,icc)=hbftrnp(ilm,jsc,icc) +
     1   hbfp(ilm,kkc,icc)*tr(ngch(kkc,jc),nsch(jsc,jc))
      endif
 102  continue
      if(iprint.ne.0) then
      do 200 ic=1,nchan
      nlmic=nlm(ic)
      do 200 jc=1,nchan
      write(6,107)ic,jc
107   format(//,' transformed bound free ham. matrix for channels:',2i4)
      nsjc=nscat(jc)
      icc=nchan*(ic-1)+jc
      do 200 ilm=1,nlmic
200   write(6,101) ilm,(hbftrn(ilm,j,icc),j=1,nsjc)
101   format(1x,i3,3("(",f8.5,3x,f8.5,")",3x),/,
     &     (4x,3("(",f8.5,3x,f8.5,")",3x)))
      if(istat.eq.ioft)then
      do 201 ic=1,nchan
      nlmic=nlm(ic)
      do 201 jc=1,nchan
      write(6,108)ic,jc
 108  format(//,' transformed bound free (p) ham. matrix for channels:'
     1 ,2i4)
      nsjc=nscat(jc)
      icc=nchan*(ic-1)+jc
      do 201 ilm=1,nlmic
 201     write(6,101) ilm,(hbftrn(ilm,j,icc),j=1,nsjc)
      endif
      endif
      return
      end
c $Id: hbftrans.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: paw_ovlp.F 20364 2011-05-20 20:38:23Z d3p852 $
*

!**************************************************
!
!       Name: paw_ovlp_init
!
!       Purpose: initializes the paw overlap coefficients
!
!       Created:        8/07/2002
!**************************************************
      subroutine paw_ovlp_init(ispin0,ne)
      implicit none
      integer ispin0
      integer ne(2)

#include "mafdecls.fh"
#include "paw_proj.fh"
#include "paw_ovlp_data.fh" 
#include "paw_geom.fh" 
#include "paw_ma.fh" 
#include "paw_basis.fh" 
  
*     **** local variables ****
      logical value
      integer ii,ia,nlm,nlmii,n,m,mabs
      integer nbasis,i2,i1,isgn,nion
      integer paw_ovlp_w_size
      integer in,li,lj,mi,mj,i,j


      nion = ion_nion()

c     !*** calculate total number of (n,l,m) projectors  ***
      total_nbasis = 0
      do ia=1,ion_nkatm()
c        !-- ion_natm(ia) is number of atoms of kind ia --
         total_nbasis = total_nbasis 
     >                + paw_proj_nbasis(ia)*ion_natm(ia)
      end do

c     !*** calculate the size and indexing for weight coefficients  ***
      value = my_alloc(mt_int,ion_nion(),"i_paw_ovlp_w",i_paw_ovlp_w)
      if (.not.value) call errquit('paw_ovlp_init: alloc heap',0,1)

      paw_ovlp_w_size = 0
      do in=1,nion
         int_mb(i_paw_ovlp_w(1) + in - 1) = paw_ovlp_w_size
         ia = ion_katm(in)
         paw_ovlp_w_size = paw_ovlp_w_size
     >                + paw_proj_nbasis(ia)**2
      end do



c     !*** allocate storage for paw_ovlp arrays*** 
c     !-- total number of electron states
      ispin = ispin0
      neall = ne(1) + ne(2)
      ne_u=ne(1)
      ne_d=ne(2)

      value =           my_alloc(mt_dcpl,(total_nbasis*neall),
     >                               'coeff',coeff)
      value = value.and.my_alloc(mt_dcpl,
     >                               (total_nbasis*neall),
     >                               'toeff',toeff)
      value = value.and.my_alloc(mt_int,(total_nbasis*neall),
     >                               'indx2',indx2)
      value = value.and.my_alloc(mt_int,(total_nbasis*neall),
     >                               'sgn',sgn)

      value = value.and.my_alloc(mt_dcpl,paw_ovlp_w_size,
     >                           "paw_ovlp_w",paw_ovlp_w)

      value = value.and.my_alloc(mt_dcpl,paw_ovlp_w_size,
     >                           "paw_ovlp_w_u",paw_ovlp_w_spin(1,1))

      if (ispin.eq.2)
     > value = value.and.my_alloc(mt_dcpl,paw_ovlp_w_size,
     >                           "paw_ovlp_w_d",paw_ovlp_w_spin(1,2))

      if (.not.value) call errquit('paw_ovlp_init: alloc heap',0,1)


c    !    atom=1                        atom=2
c    !l : 0  1  1  1  2  2  2  2  2 ... 0  1  1  1 ... 
c    !m : 0 -1  0  1 -2 -1  0  1  1 ... 0 -1  0  1 ...
c    !
c    !

c     !*** set sign array (isgn) and location of -m elements(indx2)
      nlmii = 0
      do ii=1,nion
c        !-- the atom kind is ia --
         ia = ion_katm(ii)
         nbasis = paw_proj_nbasis(ia)
c        !-- loop over projectors for atom of kind ia --
         do nlm=1,nbasis
            nlmii = nlmii + 1
            m = paw_proj_m(nlm,ia)
            mabs = abs(m)
c           !-- set sign coeff as (-1)**m --
            if (mod(mabs,2).eq.0) then
              isgn = 1
            else
              isgn = -1
            end if
            do n=1,neall
              i1 = (nlmii-1)*neall + (n-1)
              i2 = i1 - 2*m*neall

              int_mb(indx2(1)+i1) = i2     ! location of -m elements
              int_mb(sgn(1)  +i1) = isgn   ! sign array=(-1)**m 
            end do
         end do 
      end do    


      return
      end

!**************************************************
!
!       Name: paw_ovlp_end
!
!       Purpose: removes space used by the paw overlap coefficients
!
!       Created:        8/07/2002
!**************************************************
      subroutine paw_ovlp_end()
      implicit none      

#include "mafdecls.fh"
#include "paw_ma.fh" 
#include "paw_ovlp_data.fh"

      !*** local variables ***
      logical value
      
      value =           MA_free_heap(coeff(2))
      value = value.and.MA_free_heap(toeff(2))
      value = value.and.MA_free_heap(indx2(2))
      value = value.and.MA_free_heap(sgn(2))
      value = value.and.MA_free_heap(paw_ovlp_w(2))
      value = value.and.MA_free_heap(paw_ovlp_w_spin(2,1))
      if (ispin.eq.2)
     > value = value.and.MA_free_heap(paw_ovlp_w_spin(2,2))
      value = value.and.my_dealloc(i_paw_ovlp_w)

      if (.not.value) call errquit('paw_ovlp_end: dealloc heap',0,0)
      return
      end


**************************************************
!
!       Name: paw_ovlp_coeff_set
!
!       Purpose: sets the paw overlap coefficients
!
!       Created:        8/07/2002
!**************************************************
      subroutine paw_ovlp_coeff_set(psi)
      implicit none
      complex*16 psi(*)
      
#include "mafdecls.fh"
#include "paw_ovlp_data.fh"
#include "paw_proj.fh"
#include "paw_geom.fh"
#include "paw_basis.fh"

      !*** local variables ***
      logical value
      integer ii,ia,nbasis,nlm,nlmii,npack1
      integer nion,prj,i1,i2,n
      integer indx_psi,indx_prj,indx_coeff
      integer exi(2),tmp(2)
      integer ni,i,li,mi


      call nwpw_timing_start(6)

      !*** allocate temporary space ***
      call Pack_npack(1,npack1)
      value =           MA_push_get(mt_dcpl,npack1,'exi',exi(2),exi(1))
      value = value.and.MA_push_get(mt_dcpl,npack1,'tmp',tmp(2),tmp(1))
      if (.not.value) call errquit('paw_ovlp_coeff_set: push stack',0,0)



c      !*** compute overlap coefficients c(n=1:neall,nlm=1:nbasis(ii),ii=1:nion) ***
      nlmii = 0
      nion  = ion_nion()
      do ii=1,nion
        ia = ion_katm(ii)
        call strfac_pack(1,ii,dcpl_mb(exi(1)))
        nbasis = paw_proj_nbasis(ia)
        prj = paw_proj_i_prj_atom(ia)
        do nlm=1,nbasis
           
           nlmii = nlmii + 1
           indx_prj = (nlm-1)*npack1
           call Pack_cc_Mul(1,
     >                      dcpl_mb(exi(1)),
     >                      dcpl_mb(prj+indx_prj),
     >                      dcpl_mb(tmp(1)))
           do n=1,neall
             indx_psi   = (n-1)*npack1    + 1
             indx_coeff = (nlmii-1)*neall + (n-1)
             call Pack_cc_izdot(1,
     >                         dcpl_mb(tmp(1)),
     >                         psi(indx_psi),
     >                         dcpl_mb(toeff(1)+indx_coeff))
           end do
        end do
      end do 
      call D3dB_Vector_SumAll(2*neall*total_nbasis,
     >                        dcpl_mb(toeff(1)))


      !*** unsrcramble to get true overlap coefficients ***
      do i1=1,total_nbasis*neall
         i2 = int_mb(indx2(1)+i1-1)
         dcpl_mb(coeff(1)+i1-1) 
     >     = 0.5d0*( dcpl_mb(toeff(1)+i1-1)
     >             + int_mb(sgn(1)+i1-1)
     >              *dconjg(dcpl_mb(toeff(1)+i2)))
      end do     





      value =           MA_pop_stack(tmp(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not.value) call errquit('paw_ovlp_coeff_set: pop stack',0,1)
      
      call nwpw_timing_end(6)

      return
      end
 
**************************************************
!
!       Name: paw_ovlp_weigths_set
!
!       Purpose: sets the overlap weight coefficients
!
!       Created:        8/07/2002
!**************************************************
      subroutine paw_ovlp_weights_set()
      
      implicit none

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_ovlp_data.fh"
#include "paw_proj.fh"
#include "paw_basis.fh"

      integer i_nbasis,ii,ii1
      integer in,nlm,nlm1,ia,n
      integer nbasis
      integer indx_coeff,indx_coeff1
      integer i,j,mi,mj,li,lj
      integer i_w0,i_w
      integer nilm,njlm,niplm,njplm
      integer n1(2),n2(2),ms
      real*8  occup
      double complex w_tmp
      
      
      call nwpw_timing_start(6)
      !*** check for restricted calculation ****
c      occup = 1.0d0
      n1(1) = 1
      n2(1) = ne_u
      n1(2) = ne_u+1
      n2(2) = ne_u+ne_d

      ii = 0
      i_nbasis = 0
      do in=1,ion_nion()
        ia = ion_katm(in)
        nbasis = paw_proj_nbasis(ia)
        do nlm =1,nbasis
        do nlm1=1,nbasis

           do ms=1,ispin
             w_tmp = dcmplx(0.0d0,0.0d0)
             do n=n1(ms),n2(ms)
               indx_coeff  = (i_nbasis+nlm-1)*neall + (n-1)
               indx_coeff1 = (i_nbasis+nlm1-1)*neall + (n-1)
               w_tmp = w_tmp + conjg(dcpl_mb(coeff(1)+indx_coeff))
     >                         *dcpl_mb(coeff(1)+indx_coeff1)
             end do
             dcpl_mb(paw_ovlp_w_spin(1,ms)+ii) = w_tmp
           end do

           dcpl_mb(paw_ovlp_w(1)+ii) 
     >            = dcpl_mb(paw_ovlp_w_spin(1,1)+ii)
     >            + dcpl_mb(paw_ovlp_w_spin(1,ispin)+ii)      
           
           ii =ii +1
        end do
        end do
        i_nbasis = i_nbasis + nbasis
      end do
      

!      write(*,*) " paw weights"
!      ii = 0
!      nilm = 0
!      njlm = 0
!      do in=1,ion_nion()
!        ia = ion_katm(in)
!        i_w0 = int_mb(i_paw_ovlp_w(1) + in - 1)
!        nbasis = paw_basis_nbasis(ia)
!        nilm = 0
!        do i=1,nbasis
!          li = paw_basis_orb_l(i,ia)
!          do mi=-li,li
!            njlm = 0
!            do j=1,nbasis
!              lj = paw_basis_orb_l(j,ia)
!                do mj=-lj,lj
!                  i_w   = i_w0-1+(njlm+lj+mj+1)+
!     >                   (nilm+li+mi)*paw_proj_nbasis(ia)
!                  write(*,*) i,mi,j,mj,in
!                  write(*,*)"w=",dcpl_mb(paw_ovlp_w(1)+ii)
!                  write(*,*)"w_up=",dcpl_mb(paw_ovlp_w_u(1)+ii)
!                  write(*,*)"w_down=",dcpl_mb(paw_ovlp_w_d(1)+ii)
!                
!                  ii =ii +1
!                end do
!                njlm=njlm + 2*lj+1
!             end do
!           end do   
!           nilm = nilm + 2*li+1
!         end do
!      end do
      call nwpw_timing_end(6)
    
      return
      end

**************************************************
!
!       Name: paw_ovlp_calc_coef
!
!       Purpose: Calculate the projectors coefficients
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_calc_coef(ne,psi,c1)
      implicit none
      integer ne
      complex*16 psi(*)
      complex*16 c1(ne,*)

#include "mafdecls.fh"
#include "paw_ovlp_data.fh"

      !**** local variables ****
      logical ok
      integer ct(2)
      !*** allocate space from stack ****
      ok = MA_push_get(mt_dcpl,ne*total_nbasis,'ct',ct(2),ct(1))
      if (.not.ok)
     > call errquit('paw_ovlp_calc_coeffn: out of stack memory',0,0)


      call paw_ovlp_calc_scramble_coef(ne,psi,dcpl_mb(ct(1)))
      call paw_ovlp_unscramble_coef(ne,dcpl_mb(ct(1)),c1)


      !*** deallocate temporary space ***
      ok = MA_pop_stack(ct(2))
      if (.not.ok)
     > call errquit(
     >  'paw_ovlp_calc_coeff: error freeing stack memory',1,0)

      return
      end


**************************************************
!
!       Name: paw_ovlp_calc_scramble_coef
!
!       Purpose: Calculate the scrambled coefficients
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_calc_scramble_coef(ne,psi,ct)
      implicit none
      integer ne
      complex*16 psi(*)
      complex*16 ct(ne,*)

#include "mafdecls.fh"
#include "paw_ovlp_data.fh"
#include "paw_proj.fh"
#include "paw_geom.fh"
#include "paw_basis.fh"

      !*** local variables ***
      logical value
      integer ii,ia,nbasis,nlm,nlmii,npack1
      integer nion,prj,n
      integer indx_psi,indx_prj
      integer exi(2),tmp(2)


      call nwpw_timing_start(6)
      !*** allocate temporary space ***
      call Pack_npack(1,npack1)
      value =           MA_push_get(mt_dcpl,npack1,'exi',exi(2),exi(1))
      value = value.and.MA_push_get(mt_dcpl,npack1,'tmp',tmp(2),tmp(1))
      if (.not.value) 
     > call errquit('paw_ovlp_coeff_set: out of stack memory',0,0)


c     !*** compute overlap coefficients c(n=1:ne,nlm=1:nbasis(ii),ii=1:nion) ***
      nlmii = 0
      nion  = ion_nion()
      do ii=1,nion
        ia = ion_katm(ii)
        call strfac_pack(1,ii,dcpl_mb(exi(1)))
        nbasis = paw_proj_nbasis(ia)
        prj = paw_proj_i_prj_atom(ia)
        do nlm=1,nbasis
           nlmii = nlmii + 1
           indx_prj = (nlm-1)*npack1
           call Pack_cc_Mul(1,
     >                      dcpl_mb(exi(1)),
     >                      dcpl_mb(prj+indx_prj),
     >                      dcpl_mb(tmp(1)))
           do n=1,ne
             indx_psi   = (n-1)*npack1    + 1
             call Pack_cc_izdot(1,
     >                         dcpl_mb(tmp(1)),
     >                         psi(indx_psi),
     >                         ct(n,nlmii))
           end do
        end do
      end do
      call D3dB_Vector_SumAll(2*ne*total_nbasis,ct)


      !*** deallocate temporary space ***
      value =           MA_pop_stack(tmp(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not.value)  call errquit(
     > 'paw_ovlp_coeff_set: error freeing stack memory',0,1)

      call nwpw_timing_end(6)
      return
      end



**************************************************
!
!       Name: paw_ovlp_unscramble_coef
!
!       Purpose: unscrambe the coefficients
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_unscramble_coef(ne,ct,c1)
      implicit none
      integer ne
      complex*16 ct(ne,*),c1(ne,*)


#include "mafdecls.fh"
#include "paw_ma.fh"
#include "paw_proj.fh"
#include "paw_ovlp_data.fh"
#include "paw_geom.fh"

*     **** local variables ****
      integer ii,ia,nlm,nlmii,n,m,mabs
      integer nbasis,nion,i2
      real*8 isgn

      call nwpw_timing_start(6)
      nion = ion_nion()
      nlmii = 0
      do ii=1,nion
         ia = ion_katm(ii)
         nbasis = paw_proj_nbasis(ia)

         do nlm=1,nbasis
            nlmii = nlmii + 1
            m = paw_proj_m(nlm,ia)
            mabs = abs(m)
            if (mod(mabs,2).eq.0) then
              isgn = 1.0d0
            else
              isgn = -1.0d0
            end if
            i2 = nlmii-2*m
            do n=1,ne
              c1(n,nlmii) = 0.5d0*(ct(n,nlmii) 
     >                   + isgn*dconjg(ct(n,i2)))
            end do
         end do
      end do

      call nwpw_timing_end(6)
      return
      end

**************************************************
!
!       Name: paw_ovlp_S
!
!       Purpose: Apply the overlap operator
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_S(ne,psi,Spsi)
      implicit none
      integer ne
      complex*16 psi(*)
      complex*16 Spsi(*)

#include "mafdecls.fh"
#include "paw_ovlp_data.fh"
#include "paw_proj.fh"
#include "paw_geom.fh"
#include "paw_basis.fh"

      !*** local variables ***
      logical ok
      integer ii,ia,nbasis,nlm,nlmii
      integer nion,prj,n,npack1
      integer indx_psi,indx_prj,indx
      integer c1(2),pv(2),exi(2),tmp(2)


      !*** allocate temporary space ***
      call Pack_npack(1,npack1)
      ok =        MA_push_get(mt_dcpl,npack1,'exi',exi(2),exi(1))
      ok = ok.and.MA_push_get(mt_dcpl,npack1,'tmp',tmp(2),tmp(1))
      ok = ok.and.
     >     MA_push_get(mt_dcpl,ne*total_nbasis,'c1',c1(2),c1(1))
      ok = ok.and.
     >     MA_push_get(mt_dcpl,ne*total_nbasis,'pv',pv(2),pv(1))
      if (.not.ok)
     > call errquit('paw_ovlp_S: out of stack memory',0,0)


      !**** calculate pv ****
      call paw_ovlp_calc_coef(ne,psi,dcpl_mb(c1(1)))
      call  paw_overlap_pv_gen(ne,total_nbasis,
     >          dcpl_mb(c1(1)),
     >          dcpl_mb(pv(1)))


      call dcopy(2*ne*npack1,psi,1,Spsi,1)
      nlmii = 0
      nion  = ion_nion()
      do ii=1,nion
        ia = ion_katm(ii)
        call strfac_pack(1,ii,dcpl_mb(exi(1)))
        nbasis = paw_proj_nbasis(ia)
        prj = paw_proj_i_prj_atom(ia)
        do nlm=1,nbasis
           nlmii = nlmii + 1
           indx_prj = (nlm-1)*npack1
           call Pack_cc_Mul(1,
     >                      dcpl_mb(exi(1)),
     >                      dcpl_mb(prj+indx_prj),
     >                      dcpl_mb(tmp(1)))

           do n=1,ne
             indx_psi = (n-1)*npack1    + 1
             indx     = (nlmii-1)*ne + (n-1)
             call Pack_cc_zaxpy(1,
     >                         dcpl_mb(pv(1)+indx),
     >                         dcpl_mb(tmp(1)),
     >                         Spsi(indx_psi))
           end do
        end do
      end do

      !*** deallocate temporary space ***
      ok =        MA_pop_stack(pv(2))
      ok = ok.and.MA_pop_stack(c1(2))
      ok = ok.and.MA_pop_stack(tmp(2))
      ok = ok.and.MA_pop_stack(exi(2))
      if (.not.ok) 
     > call errquit('paw_ovlp_S: error freeing stack memory',0,1)

      return
      end

**************************************************
!
!       Name: paw_ovlp_coeff_ptr
!
!       Purpose: 
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_coeff_ptr(ptr)
      implicit none
      integer ptr

#include "paw_ovlp_data.fh"

      ptr = coeff(1)
      return
      end 
**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_indx2_ptr(ptr)
      implicit none
      integer ptr(4)

#include "paw_ovlp_data.fh"
      integer i

      do i=1,4
      ptr(i) = indx2(i)
      end do
      return
      end 

**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_sgn_ptr(ptr)
      implicit none
      integer ptr(4)

#include "paw_ovlp_data.fh"

      integer i

      do i=1,4
      ptr(i) = sgn(i)
      end do
      return
      end 

**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_c_ptr(ptr)
      implicit none
      integer ptr(4)

#include "paw_ovlp_data.fh"

      integer i

      do i=1,4
      ptr(i) = coeff(i)
      end do
      return
      end 

**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:        2/10/2002
!**************************************************
      subroutine paw_ovlp_i_w_ptr(ptr)
      implicit none
      integer ptr(4)

#include "paw_ovlp_data.fh"

      integer i

      do i=1,4
      ptr(i) = i_paw_ovlp_w(i)
      end do
      return
      end 



**************************************************
!
!       Name: paw_ovlp_coeff_size
!
!       Purpose:  returns the size of the overlap array
!
!       Created:        2/10/2002
!**************************************************
      function paw_ovlp_coeff_size()
      implicit none
       
      integer paw_ovlp_coeff_size 

#include "paw_ovlp_data.fh"

      paw_ovlp_coeff_size=coeff(3)
      return
      end 
**************************************************
!
!       Name: paw_ovlp_coeff_ptr
!
!       Purpose: 
!
!       Created:        2/10/2002
!**************************************************
      function paw_ovlp_weight_size()
      implicit none
       
      integer paw_ovlp_weight_size 

#include "paw_ovlp_data.fh"

      paw_ovlp_weight_size=paw_ovlp_w(3)
      return
      end 
**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:
!**************************************************
      function paw_ne_total()
      implicit none
       
      integer paw_ne_total

#include "paw_ovlp_data.fh"

      paw_ne_total=neall
      return
      end 
**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:
!**************************************************
      function paw_ne_up()
      implicit none
       
      integer paw_ne_up

#include "paw_ovlp_data.fh"

      paw_ne_up=ne_u
      return
      end 
**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:
!**************************************************
      function paw_ne_down()
      implicit none
       
      integer paw_ne_down

#include "paw_ovlp_data.fh"

      paw_ne_down=ne_d
      return
      end 
**************************************************
!
!       Name: 
!
!       Purpose: 
!
!       Created:
!**************************************************
      function paw_ispin()
      implicit none
       
      integer paw_ispin

#include "paw_ovlp_data.fh"

      paw_ispin = ispin
      return
      end 

**************************************************
!
!       Name: paw_ovlp_weigths_write
!
!       Purpose: dumps the overlap weight coefficients
!
!       Created:        8/07/2002
!**************************************************
      subroutine paw_ovlp_weights_write(nu)
      
      implicit none
      integer nu

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_ovlp_data.fh"
#include "paw_proj.fh"
#include "paw_basis.fh"

      integer ii
      integer in,ia
      integer nbasis
      integer i,j,mi,mj,li,lj
      integer i_w0,i_w
      integer nilm,njlm
      

      ii = 0
      nilm = 0
      njlm = 0
      do in=1,ion_nion()
        ia = ion_katm(in)
        i_w0 = int_mb(i_paw_ovlp_w(1) + in - 1)
        nbasis = paw_basis_nbasis(ia)
        nilm = 0
        do i=1,nbasis
          li = paw_basis_orb_l(i,ia)
          do mi=-li,li
            njlm = 0
            do j=1,nbasis
              lj = paw_basis_orb_l(j,ia)
                do mj=-lj,lj
                  i_w   = i_w0-1+(njlm+lj+mj+1)+
     >                   (nilm+li+mi)*paw_proj_nbasis(ia)

                  write(nu,*) i,mi,j,mj,in
                  write(nu,*)dcpl_mb(paw_ovlp_w(1)+ii)
                
                  ii =ii +1
                end do
                njlm=njlm + 2*lj+1
             end do
           end do   
           nilm = nilm + 2*li+1
         end do
      end do
    
      return
      end
c

      subroutine rohf_jkfac(jfac,kfac)
*
* $Id: rohf_jkfac.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
      double precision jfac(3),kfac(3)
c
      jfac(1)=1d0
      jfac(2)=1d0
      jfac(3)=0d0
      kfac(1)=-.5d0
      kfac(2)=0d0
      kfac(3)=-.5d0
c
      return
      end

*
* $Id: smd_data.F 19707 2010-10-29 17:59:36Z d3y133 $
*

      block data initial_smd_data
      implicit none
#include "smd_data.fh"
c     
      data smd_n /0/
      data smd_nd /smd_max_n*0/

      end

      subroutine smd_data_get_sindex(sname,ns,result)
      implicit none
#include "smd_data.fh"
      character*(*) sname
      integer ns
      logical result
c
      integer i

      result = .false.
      ns = 0
      do i=1,smd_n
       if(smd_name(i).eq.sname) then
         ns = i
         result = .true.
         return
       end if
      end do

      return
      end

      subroutine smd_data_get_dindex(sname,dname,nd,result)
      implicit none
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer nd
      logical result
c
      integer i,ns
      character*72 buffer
      character*30 pname

      pname = "smd_data_get_dindex"    
 
      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      result = .false.
      nd = 0
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         nd = i
         result = .true.
         return
       end if
      end do

      return
      end

      subroutine smd_data_get_index(sname,dname,ind,result)
      implicit none
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ind
      logical result
c
      integer i,ns,nd
      character*72 buffer
      character*30 pname

      pname = "smd_data_get_index"    
 
      buffer = sname

      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      result = .false.
      nd = 0
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         ind = smd_index(ns,i)
         result = .true.
         return
       end if
      end do

      return
      end

      subroutine smd_data_destroy(sname,dname,result)
      implicit none
#include "smd_data.fh"
#include "mafdecls.fh"
      character*(*) sname
      character*(*) dname
      integer ind
      logical result
c
      integer i,j,ns,nd
      character*72 buffer
      character*30 pname

      pname = "smd_data_get_index"    
 
      buffer = sname

      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result) return

      result = .false.
      nd = 0
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         ind = smd_index(ns,i)
         result = .true.
         goto 10
       end if
      end do
10    continue
      if(.not.result) return
c
      if(.not.ma_free_heap(smd_handle(ns,i)))
     +     call errquit(pname//'memory deallocation'//smd_dname(ns,i),
     +           smd_dim(ns,i),
     +           0)

c
      do j=i,smd_nd(ns)-1
        smd_dname(ns,j)  = smd_dname(ns,j+1)
        smd_handle(ns,j) = smd_handle(ns,j+1)
        smd_index(ns,j)  = smd_index(ns,j+1)
        smd_type(ns,j)   = smd_type(ns,j+1)
        smd_dim(ns,j)    = smd_dim(ns,j+1)
      end do
      smd_dname(ns,smd_nd(ns))  = " "
      smd_handle(ns,smd_nd(ns)) = 0
      smd_index(ns,smd_nd(ns))  = 0
      smd_type(ns,smd_nd(ns))   = 0
      smd_dim(ns,smd_nd(ns))    = 0
      smd_nd(ns) = smd_nd(ns)-1 
      return
      end

      subroutine smd_data_get_size(sname,dname,nsize,result)
      implicit none
#include "smd_data.fh"
#include "smd_const_data.fh"
      character*(*) sname
      character*(*) dname
      integer nsize
      logical result
c
      integer i,ns,nd
      character*72 buffer
      character*30 pname

      pname = "smd_data_get_size"    
 
      buffer = sname

      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      result = .false.
      nd = 0
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         if(smd_type(ns,i).eq.MT_STR) then
           nsize = smd_dim(ns,i)*smd_string_size
         else
           nsize = smd_dim(ns,i)
         end if
         result = .true.
         return
       end if
      end do

      return
      end

      subroutine smd_data_get_ind_dim(sname,dname,ind,nq,result)
      implicit none
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ind,nq
      logical result
c
      integer i,ns,nd
      character*72 buffer
      character*30 pname

      pname = "smd_data_get_index"    
 
      buffer = sname

      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      result = .false.
      nd = 0
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         ind = smd_index(ns,i)
         nq  = smd_dim(ns,i)
         result = .true.
         return
       end if
      end do

      return
      end

      subroutine smd_data_get_attrib(sname,dname,ind,nq,dtype,result)
      implicit none
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ind,nq,dtype
      logical result
c
      integer i,ns,nd
      character*72 buffer
      character*30 pname

      pname = "smd_data_get_index"    
 
      buffer = sname

      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      result = .false.
      nd = 0
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         ind = smd_index(ns,i)
         nq  = smd_dim(ns,i)
         dtype = smd_type(ns,i)
         result = .true.
         return
       end if
      end do

      return
      end

      subroutine smd_data_get_dim(sname,dname,ndim,result)
      implicit none
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      logical result
c
      integer i,ns,nd
      character*72 buffer
      character*30 pname

      pname = "smd_data_get_dim"    
 
      buffer = sname

      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      result = .false.
      nd = 0
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         ndim = smd_dim(ns,i)
         result = .true.
         return
       end if
      end do

      return
      end

      subroutine smd_namespace_create(sname)
      implicit none
#include "smd_data.fh"
      character*(*) sname
c
      character*(30) pname
      pname = "smd_namespace_create"

      call smd_namespace_destroy(sname)
      smd_n = smd_n + 1
      if(smd_n.gt.smd_max_n) 
     +   call errquit(pname//'increase namespace size to',
     +         smd_n,
     +         0)
      smd_name(smd_n) = sname

      end

      subroutine smd_namespace_destroy(sname)
      implicit none
#include "smd_data.fh"
#include "errquit.fh"
#include "mafdecls.fh"
      character*(*) sname
c
      integer i,j
      integer ns
      logical result
      character*72 buffer
      character*(30) pname
      pname = "smd_namespace_destroy"

      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result) return

      do i=smd_nd(ns),1,-1
        if(.not.ma_free_heap(smd_handle(ns,i)))
     +   call errquit(pname//'memory deallocation'//smd_dname(ns,i),
     +         smd_dim(ns,i),
     +         MA_ERR)

        smd_dname(ns,i) = " "
        smd_dim(ns,i) = 0

      end do

      smd_nd(ns) = 0
      smd_name(ns) = " "

      do i=ns,smd_n-1
       smd_name(i) = smd_name(i+1)
       smd_nd(i)   = smd_nd(i+1)
       do j=1,smd_nd(i)
         smd_dname(i,j)  = " "
         smd_handle(i,j) = 0
         smd_index(i,j)  = 0
         smd_type(i,j)   = 0
         smd_dim(i,j)    = 0
       end do
       do j=1,smd_nd(i+1)
         smd_dname(i,j)  = smd_dname(i+1,j) 
         smd_handle(i,j) = smd_handle(i+1,j) 
         smd_index(i,j)  = smd_index(i+1,j) 
         smd_type(i,j)   = smd_type(i+1,j) 
         smd_dim(i,j)    = smd_dim(i+1,j) 
       end do
      end do
      smd_n = smd_n - 1
      end

      subroutine smd_data_destroy_all()
      implicit none
#include "smd_data.fh"
#include "errquit.fh"
#include "mafdecls.fh"
c
      integer i
      integer ns
      character*(30) pname
      pname = "smd_data_destroy_all"

      do ns=smd_n,1,-1

        do i=smd_nd(ns),1,-1
          if(.not.ma_free_heap(smd_handle(ns,i)))
     +     call errquit(pname//'memory deallocation'//smd_dname(ns,i),
     +           smd_dim(ns,i),
     +           MA_ERR)

          smd_dname(ns,i) = " "
          smd_dim(ns,i) = 0

        end do

        smd_nd(ns) = 0
        smd_name(i) = " "
      end do
      smd_n = 0
     
      return
      end

      subroutine smd_data_print(un)
      implicit none
#include "smd_data.fh"
#include "errquit.fh"
#include "mafdecls.fh"
c
      integer i,un
      integer ns
      character*(30) pname
      pname = "smd_namespace_destroy"

      do ns=1,smd_n
        call smd_data_namespace_print(smd_name(ns),un)
      end do
     
      return
      end

      subroutine smd_data_create(sname,dname,ndim,dtype)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "smd_const_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      integer dtype
c
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ma_type,ma_ndim

      pname = "smd_data_create"

      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      
      call smd_data_destroy(sname,dname,result)
      smd_nd(ns) = smd_nd(ns) + 1
      if(smd_nd(ns).gt.smd_max_nd) 
     +   call errquit(pname//'increase dataspace size to',
     +         smd_nd(ns),
     +         0)

      nd = smd_nd(ns)
      smd_dim(ns,nd)=ndim
      smd_type(ns,nd)=dtype
      smd_dname(ns,nd)=dname

      if(dtype.eq.MT_STR) then
        ma_type = MT_BYTE
        ma_ndim = ndim*smd_string_size
      else
        ma_type = dtype
        ma_ndim = ndim
      end if

      if(.not.ma_alloc_get(ma_type,
     +   ma_ndim,
     +   smd_dname(ns,nd),
     +   smd_handle(ns,nd),
     +   smd_index(ns,nd)))
     +   call errquit(pname//'memory allocation'//smd_dname(ns,nd),
     +         smd_dim(ns,nd),
     +         MA_ERR)

      if(smd_type(ns,nd).eq.MT_DBL) then
        call dfill(smd_dim(ns,nd),
     +             0.d0,
     +             dbl_mb(smd_index(ns,nd)),
     +             1)
      end if

      if(smd_type(ns,nd).eq.MT_INT) then
        call ifill(smd_dim(ns,nd),
     +             0,
     +             int_mb(smd_index(ns,nd)),
     +             1)
      end if
      if(smd_type(ns,nd).eq.MT_LOG) then
        do i=1,smd_dim(ns,nd)
          log_mb(smd_index(ns,nd)+i-1) = .false.
        end do
      end if
cc     should probably fill logical and char arrays

      end

      subroutine smd_data_create_get(sname,dname,ndim,dtype,ind)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "smd_const_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      integer dtype
      integer ind
c
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ma_type,ma_ndim

      pname = "smd_data_create"

      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      
      call smd_data_destroy(sname,dname,result)
      smd_nd(ns) = smd_nd(ns) + 1
      if(smd_nd(ns).gt.smd_max_nd) 
     +   call errquit(pname//'increase dataspace size to',
     +         smd_nd(ns),
     +         0)

      nd = smd_nd(ns)
      smd_dim(ns,nd)=ndim
      smd_type(ns,nd)=dtype
      smd_dname(ns,nd)=dname

      if(dtype.eq.MT_STR) then
        ma_type = MT_BYTE
        ma_ndim = ndim*smd_string_size
      else
        ma_type = dtype
        ma_ndim = ndim
      end if

      if(.not.ma_alloc_get(ma_type,
     +   ma_ndim,
     +   smd_dname(ns,nd),
     +   smd_handle(ns,nd),
     +   smd_index(ns,nd)))
     +   call errquit(pname//'memory allocation'//smd_dname(ns,nd),
     +         smd_dim(ns,nd),
     +         MA_ERR)


      ind = smd_index(ns,nd)
c
      if(smd_type(ns,nd).eq.MT_DBL) then
        call dfill(smd_dim(ns,nd),
     +             0.d0,
     +             dbl_mb(smd_index(ns,nd)),
     +             1)
      end if

      if(smd_type(ns,nd).eq.MT_INT) then
        call ifill(smd_dim(ns,nd),
     +             0,
     +             int_mb(smd_index(ns,nd)),
     +             1)
      end if
      if(smd_type(ns,nd).eq.MT_LOG) then
        do i=1,smd_dim(ns,nd)
          log_mb(smd_index(ns,nd)+i-1) = .false.
        end do
      end if
cc     should probably fill logical and char arrays

      end

      subroutine smd_data_inquire(sname,dname,ndim,dtype,result)
      implicit none
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      integer dtype
      logical result
c
      integer i,ns
      character*72 buffer
      character*30 pname

      pname = "smd_data_inquire"    
 
      buffer = sname

      ndim  = 0
      dtype = 0 
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result) goto 100

      result = .false.
      buffer = dname
      do i=1,smd_nd(ns)
       if(smd_dname(ns,i).eq.buffer) then
         result = .true.
         ndim = smd_dim(ns,i)
         dtype=smd_type(ns,i)
       end if
      end do

100   continue
      return
      end

      subroutine smd_data_namespace_brdcst(sname,root)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "msgids.fh"
#include "global.fh"
#include "smd_const_data.fh"
      character*(*) sname
      integer root
c
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim,dtype,ind

      pname = "smd_data_create"

      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      nd = smd_nd(ns)
      do i=1,nd
        ndim  = smd_dim(ns,i)
        dtype = smd_type(ns,i)
        ind   = smd_index(ns,i) 
        buffer = smd_dname(ns,i)
        if(dtype.eq. MT_DBL) then
          call ga_brdcst(msg_smd,dbl_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else if(dtype.eq.MT_INT) then
          call ga_brdcst(msg_smd,int_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else if(dtype.eq.MT_STR) then
          call ga_brdcst(msg_smd,byte_mb(ind),
     >     smd_string_size*ndim*ma_sizeof(dtype,1,mt_byte),root)
         else if(dtype.eq.MT_BYTE) then
          call ga_brdcst(msg_smd,byte_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else if(dtype.eq.MT_LOG) then
          call ga_brdcst(msg_smd,log_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else
         call errquit(pname//'unknown type',0,0)
        endif
      end do 

      return
      end

      subroutine smd_data_namespace_print(sname,un)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "msgids.fh"
#include "global.fh"
#include "smd_const_data.fh"
      character*(*) sname
      integer un
c
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i,j,k
      integer ndim,dtype,ind

      pname = "smd_data_create"

      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)

      nd = smd_nd(ns)
      write(un,*) "NAMESPACE",sname
      do k=1,nd
        ndim  = smd_dim(ns,k)
        dtype = smd_type(ns,k)
        ind   = smd_index(ns,k) 
        buffer = smd_dname(ns,k)
        if(dtype.eq. MT_DBL) then
          write(un,*) "DATA NAME",buffer
          write(un,*) "DATA TYPE"," double"
          write(un,*) "DATA SIZE",ndim
          do i=1,ndim
          write(un,*) dbl_mb(ind+i-1)
          end do
        else if(dtype.eq.MT_LOG) then
          write(un,*) "DATA NAME",buffer
          write(un,*) "DATA TYPE"," logical"
          write(un,*) "DATA SIZE",ndim
          do i=1,ndim
          write(un,*) log_mb(ind+i-1)
          end do
         else if(dtype.eq.MT_INT) then
          write(un,*) "DATA NAME",buffer
          write(un,*) "DATA TYPE"," integer"
          write(un,*) "DATA SIZE",ndim
          do i=1,ndim
          write(un,*) int_mb(ind+i-1)
          end do
        else if(dtype.eq.MT_STR) then
          write(un,*) "DATA NAME",buffer
          write(un,*) "DATA TYPE"," string"
          write(un,*) "DATA SIZE",ndim
c          call smd_ma_char_print(ndim*smd_string_size,byte_mb(ind),un)
          do i=1,ndim
          write(un,'(72A1)') 
     >      (byte_mb(ind+smd_string_size*(i-1)+j-1),j=1,smd_string_size)
          end do
        else
         call errquit(pname//'unknown type',0,0)
        endif
      end do 

      return
      end

      subroutine smd_data_namespace_brdcst_create(sname,root)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "msgids.fh"
#include "global.fh"
#include "smd_const_data.fh"
      character*(*) sname
      integer root
c
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim,dtype,ind

      pname = "smd_data_create"

      if(ga_nodeid().eq.root) then
      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)
       nd = smd_nd(ns)
      else
       nd = 0
      end if

      if(ga_nodeid().ne.root) then
        call smd_namespace_destroy(sname)
        call smd_namespace_create(sname)
      end if
c
      call ga_brdcst(msg_smd,nd,
     >     ma_sizeof(mt_int,1,mt_byte),root)
c
      call ga_sync()
      do i=1,nd
        if(ga_nodeid().eq.root) then
          ndim  = smd_dim(ns,i)
          dtype = smd_type(ns,i)
          buffer = smd_dname(ns,i)
        end if

        call ga_brdcst(msg_smd,ndim,
     >       ma_sizeof(mt_int,1,mt_byte),root)
        call ga_brdcst(msg_smd,dtype,
     >       ma_sizeof(mt_int,1,mt_byte),root)
        call ga_brdcst(msg_smd,buffer,
     >     72*ma_sizeof(mt_int,1,mt_byte),root)
     
        call ga_sync()
     
        if(ga_nodeid().ne.root) then
          call smd_data_create_get(sname,buffer,ndim,dtype,ind)
        else
          ind = smd_index(ns,i)
        end if
        call ga_sync()

        if(dtype.eq. MT_DBL) then
          call ga_brdcst(msg_smd,dbl_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else if(dtype.eq.MT_INT) then
          call ga_brdcst(msg_smd,int_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else if(dtype.eq.MT_STR) then
          call ga_brdcst(msg_smd,byte_mb(ind),
     >     smd_string_size*ndim*ma_sizeof(dtype,1,mt_byte),root)
       else if(dtype.eq.MT_BYTE) then
          call ga_brdcst(msg_smd,byte_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else if(dtype.eq.MT_LOG) then
          call ga_brdcst(msg_smd,log_mb(ind),
     >     ndim*ma_sizeof(dtype,1,mt_byte),root)
        else
         call errquit(pname//'unknown type',0,0)
        endif

      end do 

      return
      end

      subroutine smd_data_brdcst_create(root)
      implicit none
#include "smd_data.fh"
#include "errquit.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
c
      integer root
c
      integer ns,nsmax
      character*(30) pname
      character*(72) buffer
      pname = "smd_namespace_destroy"

      
      if(ga_nodeid().eq.root) then
        nsmax = smd_n
      end if
      call ga_brdcst(msg_smd,nsmax,
     >     ma_sizeof(mt_int,1,mt_byte),root)
      do ns=1,nsmax
      if(ga_nodeid().eq.root) then
        buffer = smd_name(ns)
      end if
      call ga_sync()
      call ga_brdcst(msg_smd,buffer,
     >     72*ma_sizeof(mt_byte,1,mt_byte),root)
       call smd_data_namespace_brdcst_create(buffer,root)   
      end do
     
      return
      end

      subroutine smd_data_put_log(sname,dname,ndim,datum)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      logical datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i

      pname = "smd_data_put_int"

      call smd_data_create_get(sname,dname,ndim,MT_LOG,ind)
      do i=1,ndim
        log_mb(ind+i-1) = datum(i)
      end do
      return
      end

      subroutine smd_data_get_log(sname,dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      logical datum(ndim)
c
      integer ind,dtype
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_data_get_int"

      call smd_data_get_attrib(sname,dname,ind,ndim1,dtype,result)
      if(.not.result) return
      if(dtype.ne.MT_LOG)
     >     call errquit(pname//"incompatible types",0,0)
      if(ndim1.ne.ndim)
     >     call errquit(pname//"incompatible sizes",0,0)

      do i=1,ndim
        datum(i) = log_mb(ind+i-1)
      end do
      return
      end

      subroutine smd_data_put_int(sname,dname,ndim,datum)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      integer datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i

      pname = "smd_data_put_int"

      call smd_data_create_get(sname,dname,ndim,MT_INT,ind)
      do i=1,ndim
        int_mb(ind+i-1) = datum(i)
      end do
      return
      end

      subroutine smd_data_get_int(sname,dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      integer datum(ndim)
c
      integer ind,dtype
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_data_get_int"

      call smd_data_get_attrib(sname,dname,ind,ndim1,dtype,result)
      if(.not.result) return
      if(dtype.ne.MT_INT)
     >     call errquit(pname//"incompatible types",0,0)
      if(ndim1.ne.ndim)
     >     call errquit(pname//"incompatible sizes",0,0)

      do i=1,ndim
        datum(i) = int_mb(ind+i-1)
      end do
      return
      end

      subroutine smd_data_put_dbl(sname,dname,ndim,datum)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      double precision datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i

      pname = "smd_data_put_int"

      call smd_data_create_get(sname,dname,ndim,MT_DBL,ind)
      do i=1,ndim
        dbl_mb(ind+i-1) = datum(i)
      end do
      return
      end

      subroutine smd_data_get_dbl(sname,dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      double precision datum(ndim)
c
      integer ind,dtype
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_data_get_int"

      call smd_data_get_attrib(sname,dname,ind,ndim1,dtype,result)
      if(.not.result) return
      if(dtype.ne.MT_DBL)
     >     call errquit(pname//"incompatible types",0,0)

      if(ndim1.ne.ndim)
     >     call errquit(pname//"incompatible sizes",0,0)

      do i=1,ndim
        datum(i) = dbl_mb(ind+i-1)
      end do
      return
      end

      subroutine smd_data_put_string(sname,dname,ndim,datum)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "smd_const_data.fh"
#include "inp.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      integer dtype
      character*(*) datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i,l
      integer ndim1

      pname = "smd_data_create"

c      ndim1 = smd_tag_size*ndim

      do i=1,ndim
       l = inp_strlen(datum(i))
       if(l.gt.smd_string_size)
     >     call errquit(pname//"too big size",l,0) 
      end do
      call smd_data_create_get(sname,dname,ndim,MT_STR,ind)
      call smd_set_char_to_ma(ndim,datum,byte_mb(ind))
      return
      end

      subroutine smd_data_get_string(sname,dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "smd_const_data.fh"
#include "inp.fh"
      character*(*) sname
      character*(*) dname
      integer ndim
      character*(*) datum(ndim)
c
      integer ind
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1,dtype
      integer chunk
      logical result

      pname = "smd_data_get_string"

      call smd_data_get_attrib(sname,dname,ind,ndim1,dtype,result)
      if(.not.result) return
c      write(*,*) "LEN",LEN(datum(1))
      if(dtype.ne.MT_STR)
     >     call errquit(pname//"incompatible types",0,0)
      if(ndim1.ne.ndim)
     >     call errquit(pname//"incompatible sizes",0,0)
      call smd_set_ma_to_char(ndim1,byte_mb(ind),datum)
      return
      end

      subroutine smd_data_namespace_rtdb_get(rtdb,sname,prefix)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_data.fh"
#include "msgids.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "inp.fh"
#include "rtdb.fh"
      integer rtdb
      character*(*) sname
      character*(*) prefix
c
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      character*256 big_buffer
      integer i
      integer istart,iend
      integer ndim,dtype,ind
      character*(smd_string_size) token
c      character*(smd_string_size) mtoken(100)
      character*256 mtoken(100)
      integer  itoken(100)
      double precision  ftoken(100)
      logical ltoken(100)
      pname = "smd_data_namespace_rtdb_get"

      buffer = sname
      call smd_data_get_sindex(buffer,ns,result)
      if(.not.result)
     +   call errquit(pname//'no namespace'//buffer,
     +         0,
     +         0)
      nd = smd_nd(ns)
     
      if(.not.rtdb_first(rtdb,token))
     +  call errquit(pname//'rtdb is empty',0,0)
c
300   continue
      if(index(token,prefix).gt.0) then
      if(.not.rtdb_get_info(rtdb, token, dtype, ndim, buffer))
     >  call errquit("rtdb_get_info"//token,0,0)

      if(dtype.eq. MT_DBL) then
        if(.not.rtdb_get(rtdb,token,mt_dbl,ndim,ftoken))
     >     call errquit("rtdb_get"//token,0,0)
        call smd_data_put_dbl(sname,token,ndim,ftoken)
      else if(dtype.eq.MT_INT) then
        if(.not.rtdb_get(rtdb,token,mt_int,ndim,itoken))
     >     call errquit("rtdb_get"//token,0,0)
        call smd_data_put_int(sname,token,ndim,itoken)
      else if(dtype.eq.MT_C_CHAR) then
        if(.not.rtdb_cget_size(rtdb,token,ndim))
     >     call errquit("rtdb_get_size"//token,0,0)
        if(.not.rtdb_cget(rtdb,token,ndim,mtoken))
     >     call errquit("rtdb_get"//token,0,0)
        call smd_data_put_string(sname,token,ndim,mtoken)
        call smd_data_get_string(sname,token,ndim,mtoken,result)
      else if(dtype.eq.MT_LOG) then
        if(.not.rtdb_get(rtdb,token,mt_log,ndim,ltoken))
     >     call errquit("rtdb_get"//token,0,0)
        call smd_data_put_log(sname,token,ndim,ltoken)
      else
        call errquit(pname//'unknown type',0,0)
      endif

      end if

      result = rtdb_next(rtdb,big_buffer)
      token = big_buffer
      if(result) goto 300
      call smd_data_put_int(sname,"smd:rtdb_handle",1,rtdb)

      if(.not. rtdb_getfname(rtdb, big_buffer)) call
     *        errquit('rtdb_getfname failed',0,0)
      istart = 0
   10 if (inp_strtok(big_buffer, '/', istart, iend)) then
      buffer = big_buffer(istart:iend)
      goto 10
      endif
      call smd_data_put_string(sname,"smd:rtdb_name",1,
     >                         buffer)

      return
      end

      subroutine tce_restricted_2(a1b,a2b,b1b,b2b)
c
c $Id: tce_restricted.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer a1b,a2b
      integer b1b,b2b
c
c     Restricted
c
      if (restricted.and.
     1   (int_mb(k_spin+a1b-1)
     2   +int_mb(k_spin+a2b-1).eq.4)) then
        b1b = int_mb(k_alpha+a1b-1)
        b2b = int_mb(k_alpha+a2b-1)
      else
c
c     Unrestricted
c
       b1b = a1b
       b2b = a2b
      endif
      return
      end
      subroutine tce_restricted_4(a1b,a2b,a3b,a4b,
     1                            b1b,b2b,b3b,b4b)
c
c $Id: tce_restricted.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer a1b,a2b,a3b,a4b
      integer b1b,b2b,b3b,b4b
c
c     Restricted
c
      if (restricted.and.
     1   (int_mb(k_spin+a1b-1)
     2   +int_mb(k_spin+a2b-1)
     3   +int_mb(k_spin+a3b-1)
     4   +int_mb(k_spin+a4b-1).eq.8)) then
        b1b = int_mb(k_alpha+a1b-1)
        b2b = int_mb(k_alpha+a2b-1)
        b3b = int_mb(k_alpha+a3b-1)
        b4b = int_mb(k_alpha+a4b-1)
      else
c
c     Unrestricted
c
       b1b = a1b
       b2b = a2b
       b3b = a3b
       b4b = a4b
      endif
      return
      end
      subroutine tce_restricted_6(a1b,a2b,a3b,a4b,a5b,a6b,
     1                            b1b,b2b,b3b,b4b,b5b,b6b)
c
c $Id: tce_restricted.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer a1b,a2b,a3b,a4b,a5b,a6b
      integer b1b,b2b,b3b,b4b,b5b,b6b
c
c     Restricted
c
      if (restricted.and.
     1   (int_mb(k_spin+a1b-1)
     2   +int_mb(k_spin+a2b-1)
     3   +int_mb(k_spin+a3b-1)
     4   +int_mb(k_spin+a4b-1)
     5   +int_mb(k_spin+a5b-1)
     6   +int_mb(k_spin+a6b-1).eq.12)) then
        b1b = int_mb(k_alpha+a1b-1)
        b2b = int_mb(k_alpha+a2b-1)
        b3b = int_mb(k_alpha+a3b-1)
        b4b = int_mb(k_alpha+a4b-1)
        b5b = int_mb(k_alpha+a5b-1)
        b6b = int_mb(k_alpha+a6b-1)
      else
c
c     Unrestricted
c
       b1b = a1b
       b2b = a2b
       b3b = a3b
       b4b = a4b
       b5b = a5b
       b6b = a6b
      endif
      return
      end
      subroutine tce_restricted_8(a1b,a2b,a3b,a4b,a5b,a6b,a7b,a8b,
     1                            b1b,b2b,b3b,b4b,b5b,b6b,b7b,b8b)
c
c $Id: tce_restricted.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer a1b,a2b,a3b,a4b,a5b,a6b,a7b,a8b
      integer b1b,b2b,b3b,b4b,b5b,b6b,b7b,b8b
c
c     Restricted
c
      if (restricted.and.
     1   (int_mb(k_spin+a1b-1)
     2   +int_mb(k_spin+a2b-1)
     3   +int_mb(k_spin+a3b-1)
     4   +int_mb(k_spin+a4b-1)
     5   +int_mb(k_spin+a5b-1)
     6   +int_mb(k_spin+a6b-1)
     7   +int_mb(k_spin+a7b-1)
     8   +int_mb(k_spin+a8b-1).eq.16)) then
        b1b = int_mb(k_alpha+a1b-1)
        b2b = int_mb(k_alpha+a2b-1)
        b3b = int_mb(k_alpha+a3b-1)
        b4b = int_mb(k_alpha+a4b-1)
        b5b = int_mb(k_alpha+a5b-1)
        b6b = int_mb(k_alpha+a6b-1)
        b7b = int_mb(k_alpha+a7b-1)
        b8b = int_mb(k_alpha+a8b-1)
      else
c
c     Unrestricted
c
       b1b = a1b
       b2b = a2b
       b3b = a3b
       b4b = a4b
       b5b = a5b
       b6b = a6b
       b7b = a7b
       b8b = a8b
      endif
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      subroutine estep
#include "common.fh"
      integer iter
      iter = 0
c
      prsflg = .false.
      tmpflg = .false.
      ptflg = .false.

      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in estep',istep)
        endif
      end do
c
      return
      end
c
      subroutine pstep
#include "common.fh"
      integer iter
      iter = 0
c
      prsflg = .true.
      tmpflg = .false.
      ptflg = .false.
      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in pstep',istep)
        endif
      end do
c
      return
      end
c
      subroutine tstep
#include "common.fh"
      integer iter
      iter = 0
c
      prsflg = .false.
      tmpflg = .true.
      ptflg = .false.
      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in tstep',istep)
        endif
      end do
c
      return
      end
c
      subroutine sstep
#include "common.fh"
c
      double precision scale
      integer i,j
      integer iter
      iter = 0
c
c   This subroutine scales the atomic velocities and momenta
c   so that the system temperature corresponds to the desired
c   temperature.
c
      if (nrg(5).gt.0.0d00) then
        scale = sqrt(tmprtr / nrg(5))
      else
        scale = 1.0d00
      endif
      do 200 j = 1, 3
        do 100 i = 1, antot
          ra(i,j,2) = scale * ra(i,j,2)
          ra(i,j,5) = scale * ra(i,j,5)
  100   continue
  200 continue
      prsflg = .false.
      tmpflg = .false.
      ptflg = .false.
      mbflg = .true.
      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in sstep',istep)
        endif
      end do
c
      return
      end
c
      subroutine kstep
#include "common.fh"
c
      double precision scale,ke
      integer i,j
      integer iter
      iter = 0
c
c   This subroutine adjusts the kinetic energy so that the
c   average temperature corresponds to the target temperature
c
      if (itavg.gt.0) then
        tavg = tavg / dble(itavg)
        ke = nrg(2) * (tmprtr - tavg)
        scale = (nrg(4) + ke)/nrg(4)
      else
        scale = 0.0d00
      endif
      if (scale.gt.0.0d00) then
        scale = sqrt(scale)
      else
        scale = 1.0d00
      endif
      do 200 j = 1, 3
        do 100 i = 1, antot
          ra(i,j,2) = scale * ra(i,j,2)
          ra(i,j,5) = scale * ra(i,j,5)
  100   continue
  200 continue
      tavg = 0.0d00
      itavg = 0
      prsflg = .false.
      tmpflg = .false.
      ptflg = .false.
      mbflg = .true.
      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in kstep',istep)
        endif
      end do
c
      return
      end
c
      subroutine ptstep
#include "common.fh"
      integer iter
      iter = 0
c
      prsflg = .false.
      tmpflg = .false.
      ptflg = .true.
      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in ptstep',istep)
        endif
      end do
      return
      end
c
      subroutine mbstep
#include "common.fh"
c
      double precision scl,gasdev
      integer i,j
      integer iter
      iter = 0
c
c   This subroutine updates configuration if only a single 
c   configuration is available. It starts by assigning a
c   Boltzmann distribution of velocities and momenta to all 
c   the atoms and then calculating the next configuration
c   using a regular Gear step.
c
c    generate atomic velocities
c
      do 200 j = 1, 3
        do 100 i = 1, antot
          scl = sqrt(tmprtr / mass(i))
          ra(i,j,2) = scl * gasdev(0)
          ra(i,j,5) = mass(i) * ra(i,j,2)
          ra(i,j,3) = ra(i,j,4)/mass(i)
  100   continue
  200 continue
c
c   Re-initialize absolute coordinates
c
      call com
      call com_rmv
      call cluster_com
      tmstrt = istep
      scal2 = 0.0d00
      scal3 = 0.0d00
      vol2 = 0.0d00
      vol3 = 0.0d00
      prsflg = .false.
      tmpflg = .false.
      ptflg = .false.
      mbflg = .true.
      cmflg = .true.
      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in mbstep',istep)
        endif
      end do
#if 0
      if (mod(istep,ilist).eq.0) then
        if (istep.gt.equil_1) then
          call cluster_com
          call cluster_center
        endif
        call fixper
        do i = 1, antot
          ra(i,1,6) = ra(i,1,1)
          ra(i,2,6) = ra(i,2,1)
          ra(i,3,6) = ra(i,3,1)
        end do
      endif
#endif
      return
      end
c
      subroutine vlstep
#include "common.fh"
c
      double precision scale,sclinc
      integer i,j
      integer iter
      iter = 0
c
      prsflg = .false.
      tmpflg = .false.
      ptflg = .false.
      if (itarg.ge.istep) then
        scale = xbox * ybox * zbox
        sclinc = (tvol - scale ) / float(itarg - istep + 1)
        scale = (scale + sclinc) / (xbox * ybox * zbox)
        scale = exp(log(scale)/3.0d00)
        xbox = scale * xbox
        ybox = scale * ybox
        zbox = scale * zbox
        xbox2 = scale * xbox2
        ybox2 = scale * ybox2
        zbox2 = scale * zbox2
        do 300 j = 1, 3
          do 100 i = 1, antot
            ra(i,j,1) = scale * ra(i,j,1)
            ra(i,j,6) = scale * ra(i,j,6)
  100     continue
  300   continue
      endif
      mbflg = .true.
      do while (t_rmndr.gt.0.0d00)
        iter = iter + 1
        call pred
        call force
        call corr
        if (iter.gt.100) then
          write(6,*) 'istep: ',istep
          write(6,*) 't_rmndr: ',t_rmndr
        endif
        if (iter.gt.1000) then
          call ga_error('Failed in vlstep',istep)
        endif
      end do
      if (nrg(5).gt.0.0d00) then
        scale = sqrt(tmprtr / nrg(5))
      else
        scale = 1.0d00
      endif
      do 600 j = 1, 3
        do 400 i = 1, antot
          ra(i,j,2) = scale * ra(i,j,2)
          ra(i,j,5) = scale * ra(i,j,5)
  400   continue
  600 continue
c
      return
      end
c
      subroutine pred
#include "common.fh"
c
      double precision scale,c1,c2
      double precision rx,ry,rz,dt
      integer i,j
      double precision cluster_check_radius
      logical debug
c
c   This subroutine implements the predictor for a 3 point Gear
c   predictor-corrector algorithm
c
      if (istep.gt.3930438) then
        debug = .false.
      else
        debug = .false.
      endif
      call cluster_com
      call cluster_old_at
      call cluster_therm
      if (debug) then
        write(6,*) ga_nodeid(),' (pred) Got to 1 at step ',istep
      endif
c      rx = cluster_check_radius()
c      if (rx.gt.r_cluster.and.istep.gt.equil_3) then
c        write(6,*) ga_nodeid(),' Step ',istep
c        write(6,*) ga_nodeid(),' t_done               ',t_done
c        write(6,*) ga_nodeid(),' Radius out of bounds ',rx
c        write(6,*) ga_nodeid(),' r_cluster            ',r_cluster
c      endif
      if (t_done.eq.tau) then
        t_done = 0.0d00
        dt = tau
        t_rmndr = tau
      else
        dt = t_rmndr
      endif
c
      c1 = dt
      c2 = dt * c1 / 2.0d00
c
c   predictor step for atoms
c
      do 200 j = 1, 3
        do 100 i = 1, antot
          ra(i,j,6) = ra(i,j,6) + c1 * ra(i,j,2) + c2 * ra(i,j,3)
          ra(i,j,2) = ra(i,j,2) + c1 * ra(i,j,3) 
  100   continue
  200 continue
c
c   predictor step for volume
c
      if ((prsflg.or.ptflg).and.ipmode.eq.0) then
        vol1 = vol1 + c1 * vol2 + c2 * vol3
        vol2 = vol2 + c1 * vol3
        scale = vol1 / (xbox * ybox * zbox)
        scale = exp(log(scale)/3.0d00)
        xbox = scale * xbox
        ybox = scale * ybox
        zbox = scale * zbox
        xbox2 = scale * xbox2
        ybox2 = scale * ybox2
        zbox2 = scale * zbox2
      endif
c
      if ((prsflg.or.ptflg).and.ipmode.eq.1) then
        do 500 j = 1, 3
          alen1(j) = alen1(j) + c1 * alen2(j) + c2 * alen3(j)
          alen2(j) = alen2(j) + c1 * alen3(j)
  500   continue
        xbox = alen1(1)
        ybox = alen1(2)
        zbox = alen1(3)
        xbox2 = xbox/2.0d00
        ybox2 = ybox/2.0d00
        zbox2 = zbox/2.0d00
      endif
c
      if ((prsflg.or.ptflg).and.ipmode.eq.2) then
        do 600 j = 1, 2
          alen1(j) = alen1(j) + c1 * alen2(j) + c2 * alen3(j)
          alen2(j) = alen2(j) + c1 * alen3(j)
  600   continue
        xbox = alen1(1)
        ybox = alen1(2)
        xbox2 = xbox/2.0d00
        ybox2 = ybox/2.0d00
      endif
c
c   predictor step for time scale
c
      if (tmpflg.or.ptflg) then
        scal1 = scal1 + c1 * scal2 + c2 * scal3
        scal2 = scal2 + c1 * scal3 
      endif
c
      if (debug) then
        write(6,*) ga_nodeid(),' (pred) Got to 2 at step ',istep
      endif
      call fixper
      if (istep.gt.equil_1) then
        call cluster_com
      endif
      if (debug) then
        write(6,*) ga_nodeid(),' (pred) Got to 3 at step ',istep
      endif
      if (istep.gt.equil_1) then
        call cluster_check_cllsn
      else
        t_rmndr = 0.0d00
        t_done = tau
      endif
      if (debug) then
        write(6,*) ga_nodeid(),' (pred) Got to 4 at step ',istep
      endif
      if (.not.(ptflg.or.prsflg)) then
        if (t_rmndr.eq.0.0d00) call cluster_center
      endif
      if (debug) then
        write(6,*) ga_nodeid(),' (pred) Got to 5 at step ',istep
      endif
      if (mod(istep,ilist).eq.0.and.t_rmndr.eq.0.0d00) then
        call update
      endif
      if (cllsn_cnt.gt.100) then
        call ga_error("Too many collisions ",istep)
      endif
      if (debug) then
        write(6,*) ga_nodeid(),' (pred) Got to 6 at step ',istep
      endif
c
      return
      end
c
      subroutine corr
#include "common.fh"
c
      double precision c1,c2,coef1,xcorr,vcorr,scorr,dt
      double precision v1,s1,pmassi,tmassi,dlnvdt(3),itmp
      double precision mv1,cmr,kvt,kvtl(3),l1(3)
      double precision rbuf(8),virial,virc(3)
      double precision alfx,alfy,alfpx,alfpy,alfpz
      integer i,j,iat,nreal,nbyte
c
c   This subroutine implements the corrector for a 3 point Gear
c   predictor-corrector algorithm
c
      dt = t_done
      c1 = dt
      c2 = dt * c1 / 2.0d00
      coef1 = c2 / c1
c
      if (prsflg.or.ptflg) then
        pmassi = 1.0d00 / pmass
      else
        pmassi = 0.0d00
        vol1 = xbox * ybox * zbox
        vol2 = 0.0
        vol3 = 0.0
c
        alen1(1) = xbox
        alen1(2) = ybox
        alen1(3) = zbox
        do  20 j = 1, 3
          alen2(j) = 0.0d00
          alen3(j) = 0.0d00
   20   continue
      endif
      if (tmpflg.or.ptflg) then
        tmassi = 1.0d00 / tmass
      else
        tmassi = 0.0d00
        scal1 = 1.0d00
        scal2 = 0.0d00
        scal3 = 0.0d00
      endif
c
      if (ipmode.eq.0) then
        dlnvdt(1) = vol2 / (3.0d00 * vol1)
        dlnvdt(2) = vol2 / (3.0d00 * vol1)
        dlnvdt(3) = vol2 / (3.0d00 * vol1)
      elseif (ipmode.eq.1) then
        dlnvdt(1) = alen2(1) / alen1(1)
        dlnvdt(2) = alen2(2) / alen1(2)
        dlnvdt(3) = alen2(3) / alen1(3)
      elseif (ipmode.eq.2) then
        dlnvdt(1) = alen2(1) / alen1(1)
        dlnvdt(2) = alen2(2) / alen1(2)
        dlnvdt(3) = 0.0d00
      endif
      kvt = 0.0d00
      kvtl(1) = 0.0d00
      kvtl(2) = 0.0d00
      kvtl(3) = 0.0d00
      do 200 j = 1, 3
        do 150 iat = 1, antot
          mv1 = mass(iat) * (ra(iat,j,2) - ra(iat,j,6) * dlnvdt(j))
          kvt = kvt + mv1**2/mass(iat)
          kvtl(j) = kvtl(j) + mv1**2/mass(iat)
  150   continue
  200 continue
c
c   do global sum on quantities needed for corrector, if necessary
c
      if (prsflg.or.ptflg.or.tmpflg) then
        rbuf(1) = kvt
        rbuf(2) = kvtl(1)
        rbuf(3) = kvtl(2)
        rbuf(4) = kvtl(3)
        rbuf(5) = nrg(10)
        rbuf(6) = nrg(18)
        rbuf(7) = nrg(19)
        rbuf(8) = nrg(20)
c
        call ga_dgop(3,rbuf,8,'+')
c
        kvt = rbuf(1)
        kvtl(1) = rbuf(2)
        kvtl(2) = rbuf(3)
        kvtl(3) = rbuf(4)
        virial = rbuf(5)
        virc(1) = rbuf(6)
        virc(2) = rbuf(7)
        virc(3) = rbuf(8)
      endif
c
      itmp = (kvt + virial)/(3.0d00 * vol1)
      if (prsflg.or.ptflg) then
        if (ipmode.eq.0) then
          v1 = scal1**2 * pmassi * (itmp - prssr) + vol2 * scal2 / scal1
        else
          l1(1) = scal1**2*pmassi*((kvtl(1)+virc(1))/alen1(1)
     +          - prssr*alen1(2)*alen1(3)) + alen2(1)*scal2/scal1
          l1(2) = scal1**2*pmassi*((kvtl(2)+virc(2))/alen1(2)
     +          - prssr*alen1(1)*alen1(3)) + alen2(2)*scal2/scal1
          if (ipmode.eq.1) then
            l1(3) = scal1**2*pmassi*((kvtl(3)+virc(3))/alen1(3)
     +            - prssr*alen1(1)*alen1(2)) + alen2(3)*scal2/scal1
          else
            l1(3) = 0.0d00
          endif
          alfx = l1(1)
          alfy = l1(2)
        endif
      else
        v1 = 0.0d00
      endif
c
      do 400 j = 1, 3
        if (ipmode.eq.0) then
          do 300 i = 1, antot
            cmr = ra(i,j,6)
            ra(i,j,8) = ra(i,j,4) / mass(i) 
     +         - (dlnvdt(j) + scal2 / scal1)
     +         * (ra(i,j,2) - dlnvdt(j) * cmr)
     +         - (vol2**2 * cmr / (3.0d00*vol1**2) 
     +         - v1 * cmr / (3.0d00 * vol1)
     +         - dlnvdt(j) * ra(i,j,2)) 
  300     continue
        elseif (ipmode.ge.1) then
          do 340 i = 1, antot
            cmr = ra(i,j,6)
            ra(i,j,8) = ra(i,j,4) / mass(i)
     +        - scal2 * ra(i,j,2) / scal1
     +        + cmr * scal2 * dlnvdt(j) / scal1
     +        + cmr * l1(j) / alen1(j)
  340     continue
        endif
  400 continue
c
      do 425 j = 1, 3
        do 450 i = 1, antot
          xcorr = ra(i,j,8) - ra(i,j,3)
          ra(i,j,2) = ra(i,j,2) + coef1 * xcorr
          ra(i,j,3) = ra(i,j,8)
          ra(i,j,7) = ra(i,j,8)
  450   continue
  425 continue
c
      if (tmpflg.or.ptflg) then
        s1 = scal1 * tmassi * (kvt - nrg(1) * tmprtr)
     +     + scal2**2 / scal1
      endif
      if ((prsflg.or.ptflg).and.ipmode.eq.0) then
        vcorr = v1 - vol3
        vol2 = vol2 + coef1 * vcorr
        vol3 = v1
      endif
      if ((prsflg.or.ptflg).and.ipmode.ge.1) then
        l1(1) = l1(1) + alfpx
        l1(2) = l1(2) + alfpy
        l1(3) = l1(3) + alfpz
        if (ipmode.eq.1) then
          do 475 j = 1, 3
            vcorr = l1(j) - alen3(j)
            alen2(j) = alen2(j) + coef1 * vcorr
            alen3(j) = l1(j)
  475     continue
        elseif (ipmode.eq.2) then
          do 485 j = 1, 2
            vcorr = l1(j) - alen3(j)
            alen2(j) = alen2(j) + coef1 * vcorr
            alen3(j) = l1(j)
  485     continue
        endif
        alfpx = l1(1)
        alfpy = l1(2)
        alfpz = l1(3)
      endif
      if (tmpflg.or.ptflg) then
        scorr = s1 - scal3
        scal2 = scal2 + coef1 * scorr
        scal3 = s1
      endif
c
c   calculate value of the Hamiltonian
c
      kvt = 0.0d00
      if (ipmode.eq.0) then
        dlnvdt(1) = vol2 / (3.0d00 * vol1)
        dlnvdt(2) = vol2 / (3.0d00 * vol1)
        dlnvdt(3) = vol2 / (3.0d00 * vol1)
      elseif (ipmode.eq.1) then
        dlnvdt(1) = alen2(1) / alen1(1)
        dlnvdt(2) = alen2(2) / alen1(2)
        dlnvdt(3) = alen2(3) / alen1(3)
        vol1 = alen1(1)*alen1(2)*alen1(3)
      elseif (ipmode.eq.2) then
        dlnvdt(1) = alen2(1) / alen1(1)
        dlnvdt(2) = alen2(2) / alen1(2)
        dlnvdt(3) = 0.0d00
        vol1 = alen1(1)*alen1(2)*zbox
      endif
      do 600 j = 1, 3
        do 550 iat = 1, antot
          ra(iat,j,5) = mass(iat) * (ra(iat,j,2)-ra(iat,j,6)*dlnvdt(j))
          kvt = kvt + ra(iat,j,5)**2 / mass(iat)
  550   continue
  600 continue
c
      call com
      call kin
      call nrgsum
      call com_rmv
c
      kvt = 2.0 * nrg(4)
      nrg(9) = 0.5d00 * (kvt + tmass * scal2**2 / scal1**2) + nrg(6)
      if (ipmode.eq.0) nrg(9) = nrg(9)+0.5d00*pmass*vol2**2/scal1**2
      if (ipmode.eq.1) nrg(9) = nrg(9)+0.5d00*pmass*alen2(1)**2/scal1**2
     +                                +0.5d00*pmass*alen2(2)**2/scal1**2
     +                                +0.5d00*pmass*alen2(3)**2/scal1**2
      if (ipmode.eq.2) nrg(9) = nrg(9)+0.5d00*pmass*alen2(1)**2/scal1**2
     +                                +0.5d00*pmass*alen2(2)**2/scal1**2
      itmp = (kvt + nrg(10))/(3.0d00 * vol1)
      if (prsflg.or.ptflg) then
        nrg(11) = 0.5d00 * kvt + nrg(6) + vol1 * prssr
      else
        nrg(11) = 0.5d00 * kvt + nrg(6) + vol1 * itmp
      endif
      if (prsflg.or.ptflg) nrg(9) = nrg(9) + prssr * vol1
      if (tmpflg.or.ptflg) then
        nrg(9) = nrg(9) + nrg(1) * tmprtr * log(scal1)
      endif
c
      nrg(5) = nrg(4) / nrg(2)
      tavg = tavg + nrg(5)
      itavg = itavg + 1
c
c    make sure volume and temperature scale factor is the same on
c    all processors
c
      if ((mod(istep,100).eq.0).and.(prsflg.or.ptflg.or.tmpflg)) then
        if (ga_nodeid().eq.0) then
          rbuf(1) = scal1
          rbuf(2) = scal2
          rbuf(3) = xbox
          rbuf(4) = ybox
          rbuf(5) = zbox
          rbuf(6) = vol2
        else
          rbuf(1) = 0.0d00
          rbuf(2) = 0.0d00
          rbuf(3) = 0.0d00
          rbuf(4) = 0.0d00
          rbuf(5) = 0.0d00
          rbuf(6) = 0.0d00
        endif
c
        nreal = 6
        call ga_dgop(1,rbuf,6,'+')
c
        scal1 = rbuf(1)
        scal2 = rbuf(2)
        xbox = rbuf(3)
        ybox = rbuf(4)
        zbox = rbuf(5)
        vol2 = rbuf(6)
      endif
      if (l_cllsn) then 
        call cluster_do_cllsn
      endif
      call cluster_com
c
      return
      end

*
* $Id: heapsort.f 19708 2010-10-29 18:04:21Z d3y133 $
*
*======================================================================
*
* DISCLAIMER
*
* This material was prepared as an account of work sponsored by an
* agency of the United States Government.  Neither the United States
* Government nor the United States Department of Energy, nor Battelle,
* nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
* ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
* COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
* SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
* INFRINGE PRIVATELY OWNED RIGHTS.
*
* ACKNOWLEDGMENT
*
* This software and its documentation were produced with Government
* support under Contract Number DE-AC06-76RLO-1830 awarded by the United
* States Department of Energy.  The Government retains a paid-up
* non-exclusive, irrevocable worldwide license to reproduce, prepare
* derivative works, perform publicly and display publicly by or for the
* Government, including the right to distribute to other Government
* contractors.
*
*======================================================================
*
*  -- PEIGS  routine (version 2.1) --
*     Pacific Northwest Laboratory
*     July 28, 1995
*
*======================================================================
      subroutine heapsort(n, ra)
      implicit none
c     
c     
c     
      integer n
      double precision ra(n)
c     
      integer l, ir, i,j
      double precision rra
c     
c     
      if ( n .eq. 0 ) return
      if ( n .eq. 1 ) return
      
c     
      l = n/2 + 1
      ir = n
c     
 10   continue
      if ( l .gt. 1 ) then
         l = l-1
         rra = ra(l)
      else
         rra = ra(ir)
         ra(ir) = ra(1)
         ir = ir - 1
         if ( ir .eq. 1 ) then
            ra(1) = rra
            return
         endif
      endif
c     
      if ( ir .eq. 1 ) goto 30
c     
      i = l
      j = l + l
 20   continue
      if ( j .le. ir ) then
         if ( j .lt. ir ) then
            if ( ra(j) .lt. ra(j+1)) j = j+1
         endif
         if ( rra .lt. ra(j)) then
            ra(i) = ra(j)
            i = j
            j = j + j
         else
            j = ir + 1
         endif
         go to 20
      endif
      ra(i) = rra
      goto 10
c
 30   return
      end
      

      SUBROUTINE ccsdt_lambda_o1_6(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsdt_lambda_o1_6.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h2 p1 )_oty + = -1/12 * Sum ( p4 p5 h6 h7 h8 ) * y ( h6 h7 h8 p1 p4 p5 )_y * i1 ( h2 p4 p5 h6 h7 h8 )_ot
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h6b
      INTEGER h7b
      INTEGER h8b
      INTEGER p4b
      INTEGER p5b
      INTEGER h6b_1
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER p1b_1
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER h2b_2
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER h6b_2
      INTEGER h7b_2
      INTEGER h8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperh(3)
      INTEGER isuperh
      INTEGER nsubp(2)
      INTEGER isubp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h2b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &o,ieor(irrep_t,irrep_y))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lambda_o1_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h6b = 1,noab
      DO h7b = h6b,noab
      DO h8b = h7b,noab
      DO p4b = noab+1,noab+nvab
      DO p5b = p4b,noab+nvab
      IF (int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),ieor(int_mb(k_sym+h7b-1),ieor(int_mb(
     &k_sym+h8b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p4b-1),int
     &_mb(k_sym+p5b-1)))))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_6(h6b,h7b,h8b,p1b,p4b,p5b,h6b_1,h7b_1,h8b_1,p1
     &b_1,p4b_1,p5b_1)
      CALL TCE_RESTRICTED_6(h2b,p4b,p5b,h6b,h7b,h8b,h2b_2,p4b_2,p5b_2,h6
     &b_2,h7b_2,h8b_2)
      dim_common = int_mb(k_range+h6b-1) * int_mb(k_range+h7b-1) * int_m
     &b(k_range+h8b-1) * int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lambda_o1_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lambda_o1_6',2,MA_ERR)
      IF ((p5b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b_1 - noab - 1 
     &+ nvab * (h8b_1 - 1 + noab * (h7b_1 - 1 + noab * (h6b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),6,5,4,3,2,1,1.0d0)
      END IF
      IF ((p4b .lt. p1b) .and. (p1b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p4b_1 - noab - 1 
     &+ nvab * (h8b_1 - 1 + noab * (h7b_1 - 1 + noab * (h6b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),5,6,4,3,2,1,-1.0d0)
      END IF
      IF ((p1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - noab - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p1b_1 - noab - 1 
     &+ nvab * (h8b_1 - 1 + noab * (h7b_1 - 1 + noab * (h6b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),4,6,5,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lambda_o1_6',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lambda_o1_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lambda_o1_6',5,MA_ERR)
      IF ((h2b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h8b_2
     & - 1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1 + noab * (p5b_2 - noa
     &b - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),1,3,2,6,5,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lambda_o1_6',6,MA_
     &ERR)
      nsuperh(1) = 1
      nsuperh(2) = 1
      nsuperh(3) = 1
      isuperh = 1
      IF (h6b .eq. h7b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      IF (h7b .eq. h8b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      nsubp(1) = 1
      nsubp(2) = 1
      isubp = 1
      IF (p4b .eq. p5b) THEN
      nsubp(isubp) = nsubp(isubp) + 1
      ELSE
      isubp = isubp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,12.0d0/FACTORIAL
     &(nsuperh(1))/FACTORIAL(nsuperh(2))/FACTORIAL(nsuperh(3))/FACTORIAL
     &(nsubp(1))/FACTORIAL(nsubp(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(
     &k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lambda_o1_6',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lambda_o1_6',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lambda_o1_6',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p1b-1),1,2,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h2b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lambda_o1_6',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lambda_o1_6',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine rohf_hessv_xx( basis, geom, nbf, nmo, nclosed, nopen, 
     $     pflg,
     $     g_movecs, oskel, g_fcv, g_fpv, g_fcp,
     $     acc, lshift, g_x, g_ax )
C     $Id: rohf_hxx.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "bgj.fh"
c     
      integer basis, geom
      integer nbf, nmo, nclosed, nopen
      integer pflg
      integer g_movecs
      logical oskel
      integer g_fcv, g_fpv, g_fcp
      double precision acc
      double precision lshift
      integer g_x, g_ax, vlen, nvec, g_tmp, gtype
c
      call ga_zero(g_ax)
      if (pflg.gt.2 .or. pflg.le.0) then
         call errquit('rohf_hessv_xx: pflg invalid ', pflg, UNKNOWN_ERR)
      endif
      if (pflg .gt. 0) then
         call ga_dadd( lshift, g_x, 0.d0, g_ax, g_ax )
         call rohf_hessv_1e( basis, geom, nmo, nclosed, nopen,
     $        g_fcv, g_fpv, g_fcp,
     $        g_x, g_ax )
      endif
 200  continue
      if (pflg .gt. 1) then
         call rohf_hessv_2e( basis, geom, nbf, nmo, nclosed, nopen,
     $        g_movecs, oskel, g_x, acc, ! was min(1d-6,acc)
     $        g_ax )
      endif
c     
      end

      subroutine rohf_get_grad(g_grad)
      implicit none
#include "cscf.fh"
#include "crohf.fh"
#include "mafdecls.fh"
      integer g_grad
c
      integer nvir
      double precision maxelt
c
      call rohf_fock2grad(nmo, nclosed, nopen, crohf_g_fcv, 
     $     crohf_g_fpv, crohf_g_fcp, g_grad)
c
      nvir = nmo - nclosed - nopen
      if(oadapt) call scf_sym_screen(nclosed, nopen, nvir,int_mb(k_irs),
     $  g_grad, 0, .true., maxelt)
c
      end
      subroutine rohf_fock2grad( nmo, nclosed, nopen,
     $     g_fcv, g_fpv, g_fcp,
     $     g_grad)
C     $Id: rohf_fock2g.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "global.fh"
      integer nmo, nclosed, nopen ! [input] Occupation and number of mos
      integer g_fcv, g_fpv, g_fcp ! [input] Fock matrices for each subspace
      integer g_grad            ! [output] Gradient vector
c     
      integer nvir, voff, ooff, oend, xoff, xend
      double precision tol
c     
      nvir = nmo - nclosed - nopen
      voff = nclosed + nopen + 1
      ooff = nclosed + 1
      oend = nclosed + nopen
c     
      call ga_zero(g_grad)
      xend = nclosed*nvir
      call ga_mat_to_vec(g_fcv, voff, nmo, 1, nclosed, g_grad, 1, 1,
     $    0.0d0, '=')
*      call ga_copy_patch('n', g_fcv, voff, nmo, 1, nclosed,
*     $     g_grad, 1, xend, 1, 1 )
      call ga_dscal_patch(g_grad, 1, xend, 1, 1, 4.d0 )
      if (nopen .gt. 0) then
         xoff = xend + 1
         xend = xend + nopen*nvir
         call ga_mat_to_vec(g_fpv, voff, nmo, ooff, oend,
     $      g_grad, xoff, 1, 0.0d0, '=')
*         call ga_copy_patch('n', g_fpv, voff, nmo, ooff, oend,
*     $        g_grad, xoff, xend, 1, 1 )
         call ga_dscal_patch(g_grad, xoff, xend, 1, 1, 2.d0 )
         xoff = xend + 1
         xend = xend + nopen*nclosed
         call ga_mat_to_vec(g_fcp, ooff, oend, 1, nclosed,
     $      g_grad, xoff, 1, 0.0d0, '=')
*         call ga_copy_patch('n', g_fcp, ooff, oend, 1, nclosed,
*     $        g_grad, xoff, xend, 1, 1 )
         call ga_dscal_patch(g_grad, xoff, xend, 1, 1, 2.d0 )
      endif
c
c     Screen small numbers to ensure hard zeroes are not polluted
c     but don't mess up the quadratic convergence
c
c     Cannot screen with a large number (greater than accuracy in integrals) 
c     since in a non-abelian group we could break symmetry ... either
c     screen with a small threshold or screen with a large one and then
c     enforce symmetry (which is expensive in high order groups).
c     Also, threshold must tend to zero for high convergence.
c
      call ga_maxelt(g_grad, tol)
      tol = min(tol*tol,1d-12)
      call ga_screen(g_grad, tol)
c     
      end

c
c $Id: util_length_scale.F 24349 2013-06-23 04:30:58Z d3y133 $
c
      subroutine util_length_scale(aunit,scale)
      implicit none
#include "util_params.fh"      
#include "errquit.fh"
      double precision scale
      character*(*) aunit
c
      character*3 test

      test = aunit
      select case (test)
      case('au','boh')
        scale = 1.0d0
      case('ang')
        scale = cang2au
      case('nm','nan')
        scale = cnm2au
      case('pm','pic')
        scale = cpm2au
      case default
        call errquit("unknown units: "//test,0,-1)
      end select
   

      end subroutine

c
c $Id: pspw_Q.F 19707 2010-10-29 17:59:36Z d3y133 $
c


*     **********************************
*     *	                               *
*     *          Q_Electrostatic	   *
*     *                                *
*     **********************************

*   This routine calculates the Electrostatic energy between two centers 
*
      real*8 function Q_Electrostatic(r1,q1,r2,q2)
      implicit none
      real*8 r1(3),q1
      real*8 r2(3),q2

*     **** local variables ****
      real*8 xo,yo,zo,d
     

      xo = r2(1)-r1(1)
      yo = r2(2)-r1(2)
      zo = r2(3)-r1(3)
  
      d = dsqrt(xo*xo + yo*yo + zo*zo)

      Q_Electrostatic = q1*q2/d
      return 
      end

*     **********************************
*     *	                               *
*     *      Q_Electrostatic_Force 	   *
*     *                                *
*     **********************************

*   This routine calculates the Electrostaticn force between two centers
*
      subroutine Q_Electrostatic_Force(r1,q1,f1,r2,q2,f2)
      implicit none
      real*8 r1(3),q1
      real*8 f1(3)
      real*8 r2(3),q2
      real*8 f2(3)

*     **** local variables ****
      real*8 xo,yo,zo,d0,d2
      real*8 der
      real*8 fx,fy,fz
     

      xo = r2(1)-r1(1)
      yo = r2(2)-r1(2)
      zo = r2(3)-r1(3)
  
      d2 = (xo*xo + yo*yo + zo*zo)
      d0 = dsqrt(d2)

      der = -q1*q2/d2
      fx = -(xo/d0)*der
      fy = -(yo/d0)*der
      fz = -(zo/d0)*der  

      f2(1) = f2(1) + fx
      f2(2) = f2(2) + fy
      f2(3) = f2(3) + fz

      f1(1) = f1(1) - fx
      f1(2) = f1(2) - fy
      f1(3) = f1(3) - fz
      return 
      end




*     **********************************
*     *                                *
*     *      Q_Electrostatic_SmForce   *
*     *                                *
*     **********************************

*   This routine calculates the Electrostaticn force between two centers
*
      subroutine Q_Electrostatic_SmForce(Sm,r1,q1,f1,r2,q2,f2)
      implicit none
      real*8 Sm
      real*8 r1(3),q1
      real*8 f1(3)
      real*8 r2(3),q2
      real*8 f2(3)

*     **** local variables ****
      real*8 xo,yo,zo,d0,d2
      real*8 der
      real*8 fx,fy,fz


      xo = r2(1)-r1(1)
      yo = r2(2)-r1(2)
      zo = r2(3)-r1(3)

      d2 = (xo*xo + yo*yo + zo*zo)
      d0 = dsqrt(d2)

      der = -Sm*q1*q2/d2
      fx = -(xo/d0)*der
      fy = -(yo/d0)*der
      fz = -(zo/d0)*der

      f2(1) = f2(1) + fx
      f2(2) = f2(2) + fy
      f2(3) = f2(3) + fz

      f1(1) = f1(1) - fx
      f1(2) = f1(2) - fy
      f1(3) = f1(3) - fz
      return
      end



c     *************************************
c     *                                   *
c     *           pspw_Q_E                *
c     *                                   *
c     *************************************
      real*8 function pspw_Q_E(nion,nion_qm,katm,psp_zv,amass,
     >                          nfrag,indx_frag_start,size_frag,
     >                          kfrag,
     >                          switch_Rin,switch_Rout,
     >                          self_interaction,
     >                          nshl3d,rcell,
     >                          rion)
      implicit none
      integer nion,nion_qm
      integer katm(*)
      real*8  psp_zv(*),amass(*)
      integer nfrag
      integer indx_frag_start(*),size_frag(*) 
      integer kfrag(*)
      real*8  switch_Rin(*),switch_Rout(*)
      logical self_interaction(*)
      integer nshl3d
      real*8  rcell(nshl3d,3)
      real*8  rion(3,*)


*     **** local variables ****
      integer dutask,taskid,np
      integer w1,a,ks1,kk1,n1
      integer w2,b,ks2,kk2,n2
      real*8  Rin1,Rout1,rw1_cm(3)
      real*8  Rin2,Rout2,rw2_cm(3)
      real*8  Rin,Rout,E

*     **** external functions ****
      real*8   pspw_Q_E_frag_frag,Q_Electrostatic_self
      external pspw_Q_E_frag_frag,Q_Electrostatic_self

      call nwpw_timing_start(41) 
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      dutask = 0

      E = 0.0d0

      do w1=1,nfrag-1
         if (dutask.eq.taskid) then
         ks1 = indx_frag_start(w1)
         n1  = size_frag(w1)
         Rin1  = switch_Rin(kfrag(w1))
         Rout1 = switch_Rout(kfrag(w1))
         call pspw_Q_cm(n1,ks1,amass,rion,rw1_cm)

         do w2=w1+1,nfrag
            ks2 = indx_frag_start(w2)
            n2  = size_frag(w2)
            Rin2  = switch_Rin(kfrag(w2))
            Rout2 = switch_Rout(kfrag(w2))
            call pspw_Q_cm(n2,ks2,amass,rion,rw2_cm)

            Rin  = 0.5d0*(Rin1 +Rin2)
            Rout = 0.5d0*(Rout1+Rout2)
            E = E + pspw_Q_E_frag_frag(n1,ks1,rw1_cm,
     >                                 n2,ks2,rw2_cm,
     >                                 Rin,Rout,
     >                                 katm,psp_zv,rion,
     >                                 nshl3d,rcell)
         end do
         end if
         dutask = mod(dutask+1,np)
      end do
     

c     **** take out MM/MM Coulomb self energy ****
      do w1 = 1,nfrag
         if (.not.self_interaction(kfrag(w1))) then
         if (dutask.eq.taskid) then
         ks1 = indx_frag_start(w1)
         do a=1,size_frag(w1)
         do b=a+1,size_frag(w1)
            kk1 = ks1+a-1
            kk2 = ks1+b-1
            E = E - Q_Electrostatic_self(rion(1,kk1),psp_zv(katm(kk1)),
     >                                   rion(1,kk2),psp_zv(katm(kk2)))
         end do
         end do
         end if
         dutask = mod(dutask+1,np)
         end if
      end do
      if (np.gt.1) call Parallel_SumAll(E)

      call nwpw_timing_end(41) 
      pspw_Q_E = E
      return
      end

c     *********************************************
c     *                                           *
c     *              pspw_Q_E_frag_frag           *
c     *                                           *
c     *********************************************

      real*8 function pspw_Q_E_frag_frag(n1,ks1,rw1_cm,
     >                                   n2,ks2,rw2_cm,
     >                                   Rin,Rout,
     >                                   katm,psp_zv,rion,
     >                                   nshl3d,rcell)
      implicit none
      integer n1,ks1
      real*8  rw1_cm(3)
      integer n2,ks2
      real*8  rw2_cm(3)
      real*8  Rin,Rout
      integer katm(*)
      real*8  psp_zv(*)
      real*8  rion(3,*)
      integer nshl3d
      real*8  rcell(nshl3d,3)


*     **** local variables ****
      integer l,a,b,kk1,kk2
      real*8  x,y,z,rcm,Sm
      real*8  r1(3),q1
      real*8  r2(3),q2
      real*8  E

*     **** external functions ****
      real*8   pspw_Q_Switching,Q_Electrostatic
      external pspw_Q_Switching,Q_Electrostatic

      E = 0.0d0
      do l=1,nshl3d
         x = rw1_cm(1) - rw2_cm(1) + rcell(l,1)
         y = rw1_cm(2) - rw2_cm(2) + rcell(l,2)
         z = rw1_cm(3) - rw2_cm(3) + rcell(l,3)
         rcm = dsqrt(x**2 + y**2 + z**2)
         if (rcm.lt.Rout) then
            Sm = pspw_Q_Switching(Rin,Rout,rcm)-1.0d0
            kk1 = ks1
            do a = 1,n1
               r1(1) = rion(1,kk1) + rcell(l,1)
               r1(2) = rion(2,kk1) + rcell(l,2)
               r1(3) = rion(3,kk1) + rcell(l,3)
               q1    = psp_zv(katm(kk1))

               kk2 = ks2
               do b = 1,n2
                  r2(1) = rion(1,kk2) 
                  r2(2) = rion(2,kk2)
                  r2(3) = rion(3,kk2)
                  q2    = psp_zv(katm(kk2))
                  E = E + Sm*Q_Electrostatic(r1,q1,r2,q2)
                  kk2 = kk2 + 1
               end do
               kk1 = kk1 + 1
            end do
         end if
      end do

      pspw_Q_E_frag_frag = E
      return
      end


      

*     **********************************
*     *                                *
*     *      Q_Electrostatic_self      *
*     *                                *
*     **********************************

*   This routine calculates the Electrostatic energy between two centers
*
      real*8 function Q_Electrostatic_self(r1,q1,r2,q2)
      implicit none
      real*8 r1(3),q1
      real*8 r2(3),q2

*     **** local variables ****
      real*8 xo,yo,zo,d

      xo = r2(1)-r1(1)
      yo = r2(2)-r1(2)
      zo = r2(3)-r1(3)

      d = dsqrt(xo*xo + yo*yo + zo*zo)

      Q_Electrostatic_self = q1*q2/d
      return
      end




*     ***************************************
*     *	                                    *
*     *      Q_Electrostatic_mForce_self    *
*     *                                     *
*     ***************************************

*   This routine calculates minus the Electrostatic force between two centers
*
      subroutine Q_Electrostatic_mForce_self(r1,q1,f1,r2,q2,f2)
      implicit none
      real*8 r1(3),q1
      real*8 f1(3)
      real*8 r2(3),q2
      real*8 f2(3)

*     **** local variables ****
      real*8 xo,yo,zo,d0,d2
      real*8 der
      real*8 fx,fy,fz
     

      xo = r2(1)-r1(1)
      yo = r2(2)-r1(2)
      zo = r2(3)-r1(3)

      d2 = (xo*xo + yo*yo + zo*zo)
      d0 = dsqrt(d2)

      der = -q1*q2/d2
      fx = -(xo/d0)*der
      fy = -(yo/d0)*der
      fz = -(zo/d0)*der  

      f2(1) = f2(1) - fx
      f2(2) = f2(2) - fy
      f2(3) = f2(3) - fz

      f1(1) = f1(1) + fx
      f1(2) = f1(2) + fy
      f1(3) = f1(3) + fz
      return 
      end




c     *************************************
c     *                                   *
c     *           pspw_Q_fion             *
c     *                                   *
c     *************************************
      subroutine pspw_Q_fion(nion,nion_qm,katm,psp_zv,amass,
     >                       nfrag,indx_frag_start,size_frag,
     >                       kfrag,
     >                       switch_Rin,switch_Rout,
     >                       self_interaction,
     >                       nshl3d,rcell,
     >                       rion,fion)
      implicit none
      integer nion,nion_qm
      integer katm(*)
      real*8  psp_zv(*),amass(*)
      integer nfrag
      integer indx_frag_start(*),size_frag(*) 
      integer kfrag(*)
      real*8  switch_Rin(*),switch_Rout(*)
      logical self_interaction(*)
      integer nshl3d
      real*8  rcell(nshl3d,3)
      real*8  rion(3,*),fion(3,*)


*     **** local variables ****
      integer dutask,taskid,np
      integer w1,a,ks1,kk1,n1
      integer w2,b,ks2,kk2,n2
      real*8  Rin1,Rout1,rw1_cm(3),m1
      real*8  Rin2,Rout2,rw2_cm(3),m2
      real*8  Rin,Rout

      call nwpw_timing_start(41) 
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      dutask = 0

      do w1=1,nfrag-1
         if (dutask.eq.taskid) then
         ks1 = indx_frag_start(w1)
         n1  = size_frag(w1)
         Rin1  = switch_Rin(kfrag(w1))
         Rout1 = switch_Rout(kfrag(w1))
         call pspw_Q_cmm(n1,ks1,amass,rion,rw1_cm,m1)

         do w2=w1+1,nfrag
            ks2 = indx_frag_start(w2)
            n2  = size_frag(w2)
            Rin2  = switch_Rin(kfrag(w2))
            Rout2 = switch_Rout(kfrag(w2))
            call pspw_Q_cmm(n2,ks2,amass,rion,rw2_cm,m2)

            Rin  = 0.5d0*(Rin1 +Rin2)
            Rout = 0.5d0*(Rout1+Rout2)
            call pspw_Q_fion_frag_frag(n1,ks1,rw1_cm,m1,
     >                                 n2,ks2,rw2_cm,m2,
     >                                 Rin,Rout,
     >                                 katm,psp_zv,amass,rion,fion,
     >                                 nshl3d,rcell)
         end do
         end if
         dutask = mod(dutask+1,np)
      end do

c     **** take out MM/MM Coulomb self energy ****
      do w1 = 1,nfrag
         if (.not.self_interaction(kfrag(w1))) then
         if (dutask.eq.taskid) then
         ks1 = indx_frag_start(w1)
         do a=1,size_frag(w1)
         do b=a+1,size_frag(w1)
            kk1 = ks1+a-1
            kk2 = ks1+b-1
            call Q_Electrostatic_mForce_self(
     >               rion(1,kk1),psp_zv(katm(kk1)),fion(1,kk1),
     >               rion(1,kk2),psp_zv(katm(kk2)),fion(1,kk2))
         end do
         end do
         end if
         dutask = mod(dutask+1,np)
         end if
      end do

      call nwpw_timing_end(41) 
      return
      end

c     *********************************************
c     *                                           *
c     *              pspw_Q_fion_frag_frag           *
c     *                                           *
c     *********************************************

      subroutine pspw_Q_fion_frag_frag(n1,ks1,rw1_cm,m1,
     >                                 n2,ks2,rw2_cm,m2,
     >                                 Rin,Rout,
     >                                 katm,psp_zv,amass,rion,fion,
     >                                 nshl3d,rcell)
      implicit none
      integer n1,ks1
      real*8  rw1_cm(3),m1
      integer n2,ks2
      real*8  rw2_cm(3),m2
      real*8  Rin,Rout
      integer katm(*)
      real*8  psp_zv(*)
      real*8  amass(*)
      real*8  rion(3,*)
      real*8  fion(3,*)
      integer nshl3d
      real*8  rcell(nshl3d,3)


*     **** local variables ****
      integer l,a,b,kk1,kk2
      real*8  x,y,z,rcm,Sm,dSm
      real*8  r1(3),q1
      real*8  r2(3),q2
      real*8  E

*     **** external functions ****
      real*8   Q_Electrostatic
      external Q_Electrostatic


      do l=1,nshl3d
         x = rw1_cm(1) - rw2_cm(1) + rcell(l,1)
         y = rw1_cm(2) - rw2_cm(2) + rcell(l,2)
         z = rw1_cm(3) - rw2_cm(3) + rcell(l,3)
         rcm = dsqrt(x**2 + y**2 + z**2)
         if (rcm.lt.Rout) then
            call pspw_Q_dSwitching(Rin,Rout,rcm,Sm,dSm)
            Sm = Sm - 1.0d0

*           *** calculate E, and -Sm*grad(E) ****
            E = 0.0d0
            kk1 = ks1
            do a = 1,n1
               r1(1) = rion(1,kk1) + rcell(l,1)
               r1(2) = rion(2,kk1) + rcell(l,2)
               r1(3) = rion(3,kk1) + rcell(l,3)
               q1    = psp_zv(katm(kk1))

               kk2 = ks2
               do b = 1,n2
                  r2(1) = rion(1,kk2) 
                  r2(2) = rion(2,kk2)
                  r2(3) = rion(3,kk2)
                  q2    = psp_zv(katm(kk2))
                  E = E + Q_Electrostatic(r1,q1,r2,q2)

                  call Q_Electrostatic_SmForce(Sm,r1,q1,fion(1,kk1),
     >                                            r2,q2,fion(1,kk2))
                  kk2 = kk2 + 1
               end do
               kk1 = kk1 + 1
            end do

*           *** calculate -E*grad(Sm) ****
            kk1 = ks1
            do a=1,n1
               fion(1,kk1) = fion(1,kk1) - E*dSm*(x/rcm)*amass(kk1)/m1
               fion(2,kk1) = fion(2,kk1) - E*dSm*(y/rcm)*amass(kk1)/m1
               fion(3,kk1) = fion(3,kk1) - E*dSm*(z/rcm)*amass(kk1)/m1
               kk1 = kk1 + 1
            end do
            kk2 = ks2
            do b=1,n2
               fion(1,kk2) = fion(1,kk2) + E*dSm*(x/rcm)*amass(kk2)/m2
               fion(2,kk2) = fion(2,kk2) + E*dSm*(y/rcm)*amass(kk2)/m2
               fion(3,kk2) = fion(3,kk2) + E*dSm*(z/rcm)*amass(kk2)/m2
               kk2 = kk2 + 1
            end do

         end if
      end do

      return
      end


*     ******************************
*     *                            *
*     *       pspw_Q_Switching     *
*     *                            *
*     ******************************
      real*8 function pspw_Q_Switching(Rin,Rout,r)
      implicit none
      real*8 Rin,Rout,r

*     **** ST2 parameters ****
c      real*8 Rl,Ru,c1,c2
c      parameter (Rl=2.0160d0/0.529177d0)
c      parameter (Ru=3.1287d0/0.529177d0)
c      parameter (c1 = (Ru-Rl)**3)
c      parameter (c2 = (3.0d0*Ru-Rl))
       real*8 c1,c2,s

      if (r.le.Rin) then
         s = 0.0d0
      else if (r.ge.Rout) then
         s = 1.0d0
      else
         c1 = (Rout-Rin)**3
         c2 = 3.0d0*Rout-Rin
         s = ((r-Rin)**2) * (c2-2.0d0*r)/c1
      end if

      pspw_Q_Switching = s
      return
      end


*     ******************************
*     *                            *
*     *       pspw_Q_dSwitching     *
*     *                            *
*     ******************************
      subroutine pspw_Q_dSwitching(Rin,Rout,r,S,dS)
      implicit none
      real*8 Rin,Rout,r,S,dS

*     **** ST2 parameters ****
c      real*8 Rl,Ru,c1,c2
c      parameter (Rl=2.0160d0/0.529177d0)
c      parameter (Ru=3.1287d0/0.529177d0)
c      parameter (c1 = (Ru-Rl)**3)
c      parameter (c2 = (3.0d0*Ru-Rl))
       real*8 c1,c2

      if (r.le.Rin) then
         S  = 0.0d0
         dS = 0.0d0
      else if (r.ge.Rout) then
         S  = 1.0d0
         dS = 0.0d0
      else
         c1 = (Rout-Rin)**3
         c2 = 3.0d0*Rout-Rin
         S  =       ((r-Rin)**2) * (c2-2.0d0*r)/c1
         
         dS = 2.0d0*(r-Rin)    * ((c2-2.0d0*r)/c1)
     >      - 2.0d0*((r-Rin)**2) /c1
      end if

      return
      end

*     ******************************
*     *                            *
*     *       pspw_Q_cm            *
*     *                            *
*     ******************************
      subroutine pspw_Q_cm(n,ks,amass,rion,rcm)
      implicit none
      integer n,ks
      real*8 amass(*),rion(3,*),rcm(3)

*     **** local variables ****
      integer k,kk
      real*8  m

      m      = 0.0d0
      rcm(1) = 0.0d0
      rcm(2) = 0.0d0
      rcm(3) = 0.0d0
      kk = ks
      do k=1,n
         rcm(1) = rcm(1) + amass(kk)*rion(1,kk)
         rcm(2) = rcm(2) + amass(kk)*rion(2,kk)
         rcm(3) = rcm(3) + amass(kk)*rion(3,kk)
         m = m + amass(kk)
         kk = kk + 1
      end do
      rcm(1) = rcm(1)/m
      rcm(2) = rcm(2)/m
      rcm(3) = rcm(3)/m

      return
      end

      
*     ******************************
*     *                            *
*     *       pspw_Q_cmm           *
*     *                            *
*     ******************************
      subroutine pspw_Q_cmm(n,ks,amass,rion,rcm,m)
      implicit none
      integer n,ks
      real*8 amass(*),rion(3,*),rcm(3)
      real*8  m

*     **** local variables ****
      integer k,kk

      m      = 0.0d0
      rcm(1) = 0.0d0
      rcm(2) = 0.0d0
      rcm(3) = 0.0d0
      kk = ks
      do k=1,n
         rcm(1) = rcm(1) + amass(kk)*rion(1,kk)
         rcm(2) = rcm(2) + amass(kk)*rion(2,kk)
         rcm(3) = rcm(3) + amass(kk)*rion(3,kk)
         m = m + amass(kk)
         kk = kk + 1
      end do
      rcm(1) = rcm(1)/m
      rcm(2) = rcm(2)/m
      rcm(3) = rcm(3)/m

      return
      end

*
* $Id: cloak.F 20275 2011-05-05 15:36:00Z bylaska $
*

*     *******************************
*     *			  	    *
*     *	        cloak_init          *
*     *				    *
*     *******************************
      subroutine cloak_init()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "cloak_common.fh"

      logical value
      integer nfft3d

*     **** allocate masker memory ****
      call C3dB_nfft3d(1,nfft3d)

      value = MA_alloc_get(mt_log,nfft3d,
     >                     'masker',masker(2),masker(1))
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)

      return
      end

*     *******************************
*     *				    *
*     *	        cloak_end           *
*     *				    *
*     *******************************
      subroutine cloak_end()
      implicit none
#include "errquit.fh"

#include "mafdecls.fh"
#include "cloak_common.fh"

      logical value

      value = MA_free_heap(masker(2))
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)

      return
      end

*     *******************************
*     *				    *
*     *	        cloak_set           *
*     *				    *
*     *******************************
      subroutine cloak_set(kvector,ecut)
      implicit none
      real*8 kvector(3),ecut

#include "mafdecls.fh"
#include "cloak_common.fh"

*     **** local variables ****
      integer nfft3d
      integer i,j,k,p,q,index
      integer k1,k2,k3
      integer nx,ny,nz
      integer nxh,nyh,nzh
      real*8  ggcut,g1,g2,g3,gg
      integer taskid

*     **** external functions ***
      real*8   lattice_unitg_frozen
      external lattice_unitg_frozen

      call Parallel3d_taskid_i(taskid)
      call C3dB_nfft3d(1,nfft3d)
      call C3dB_nx(1,nx)
      call C3dB_ny(1,ny)
      call C3dB_nz(1,nz)
      nxh = nx/2
      nyh = ny/2
      nzh = nz/2

*     **** set all masker on ****
      do i=1,nfft3d
            log_mb(masker(1)+i-1) = .true.
      end do

*     **** get fermi sphere cut-off ****
      nwave = 0
      ggcut = 2.0d0*ecut


*     **** undo masker in sphere defined by ggcut ****
      do k3 = -nzh+1, nzh-1
         do k2 = -nyh+1, nyh-1
            do k1 = -nxh+1, nxh-1
               g1 = k1*lattice_unitg_frozen(1,1) 
     >            + k2*lattice_unitg_frozen(1,2) 
     >            + k3*lattice_unitg_frozen(1,3)
     >            + kvector(1)
               g2 = k1*lattice_unitg_frozen(2,1) 
     >            + k2*lattice_unitg_frozen(2,2) 
     >            + k3*lattice_unitg_frozen(2,3)
     >            + kvector(2)
               g3 = k1*lattice_unitg_frozen(3,1) 
     >            + k2*lattice_unitg_frozen(3,2) 
     >            + k3*lattice_unitg_frozen(3,3)
     >            + kvector(3)
               i=k1
               j=k2
               k=k3
               if (i .lt. 0) i = i + nx
               if (j .lt. 0) j = j + ny
               if (k .lt. 0) k = k + nz

                !call C3dB_ktoqp(1,k+1,q,p)
                call C3dB_ijktoindexp(1,i+1,j+1,k+1,index,p)
                if (p .eq. taskid) then
                  gg = g1*g1 + g2*g2 + g3*g3
                  if (gg.lt.ggcut) then
c                    index = (q-1)*(nx)*ny
c    >                     + j*(nx)
c    >                     + i+1
                     log_mb(masker(1)+index-1) = .false.
                     nwave = nwave + 1
                  end if
               end if
            end do
         end do
      end do
      nwave_all = nwave
      call C3dB_ISumAll(nwave_all)

      return
      end

*     *******************************
*     *		 		    *
*     *	        cloak_C             *
*     *				    *
*     *******************************
      subroutine cloak_C(A)
      implicit none
      complex*16 A(*)

#include "mafdecls.fh"
#include "cloak_common.fh"

*     **** local variables ****
      integer i,nfft3d

      call nwpw_timing_start(9)

      call C3dB_nfft3d(1,nfft3d)
      do i=1,nfft3d
         if (log_mb(masker(1)+i-1)) A(i) = dcmplx(0.0d0,0.0d0)
      end do

      call nwpw_timing_end(9)
      return 
      end

*     *******************************
*     *				    *
*     *	        cloak_R             *
*     *				    *
*     *******************************
      subroutine cloak_R(A)
      implicit none
      real*8    A(*)

#include "mafdecls.fh"
#include "cloak_common.fh"

*     **** local variables ****
      integer i,nfft3d

      call C3dB_nfft3d(1,nfft3d)
      do i=1,nfft3d
         if (log_mb(masker(1)+i-1)) A(i) = 0.0d0
      end do

      return 
      end


*     *******************************
*     *			  	    *
*     *	        cloak_nwave         *
*     *				    *
*     *******************************
      integer function cloak_nwave()
      implicit none

#include "cloak_common.fh"

      cloak_nwave = nwave
      return
      end

*     *******************************
*     *				    *
*     *	        cloak_nwave_all     *
*     *				    *
*     *******************************
      integer function cloak_nwave_all()
      implicit none

#include "cloak_common.fh"

      cloak_nwave_all = nwave_all
      return
      end

*     *******************************
*     *				    *
*     *	        cloak_masker        *
*     *				    *
*     *******************************
      logical function cloak_masker(i)
      implicit none
      integer i

#include "mafdecls.fh"
#include "cloak_common.fh"

      cloak_masker = log_mb(masker(1)+i-1) 
      return
      end

*
* $Id: dgetavec4.F 19708 2010-10-29 18:04:21Z d3y133 $
*
#include "blas_lapackf.h"
c      
      SUBROUTINE DDSTQDS( LAMBDA, DELTA, N, B1, BN, L, D,
     $     LD, LPLUS, DPLUS, T )
*      
*     -- LAPACK routine (version 0.0) -- in progress --
*     September 1995
*      
*     .. Scalar Arguments ..
      implicit none
      INTEGER            N, B1, BN
      DOUBLE PRECISION   DELTA, LAMBDA
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), L( * ), LPLUS( * ),
     $                   LD( * ), T(*), DPLUS( * )
*     ..
*      
*  Purpose
*  =======
*      
*     DDSTQDS computes the L+ D+ L+^T decomposition of the submatrix
*     indexed from B1 to BN of (L*D*L^T - (LAMBDA+DELTA)*I)
*     by the differential form of the stationary qd algorithm.
*      
*     Arguments
*     =========
*      
*     LAMBDA  (input) DOUBLE PRECISION
*     The shift.
*      
*     DELTA   (input) DOUBLE PRECISION
*     Lower order bits of the shift.
*      
*     N       (input) INTEGER
*     The order of the matrix L * D * L^T.
*      
*     B1      (input) INTEGER
*     Starting index of the submatrix (of L * D * L^T).
*      
*     BN      (input) INTEGER
*     Last index of the submatrix (of L * D * L^T).
*      
*     L       (input) DOUBLE PRECISION array, dimension (N-1)
*     The (n-1) subdiagonal elements of the bidiagonal matrix
*     L, in elements 1 to N-1.  L(N) need not be set.
*      
*     D       (input) DOUBLE PRECISION array, dimension (N)
*     The n diagonal elements of the diagonal matrix D.
*      
*     LD      (input) DOUBLE PRECISION array, dimension (N-1)
*     The n-1 elements L(i)*D(i).
*      
*     LPLUS   (output) DOUBLE PRECISION array, dimension (N-1)
*     The (n-1) subdiagonal elements of L+.
*      
*     DPLUS   (output) DOUBLE PRECISION array, dimension (N)
*     The n diagonal elements of D+.
*      
*     T       (output) DOUBLE PRECISION array, dimension (N)
*     Intermediate results of the algorithm.
*      
*  =====================================================================
*      
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0d+0, ONE = 1.0d+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   TMP, EPS
*     ..
*     .. External Functions ..
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
#include "blas_lapack.data"
*     ..
*     .. Executable Statements ..
*      


 310  CONTINUE
      IF( B1.EQ.1 ) THEN
         T( B1 ) = -LAMBDA
      ELSE
         T( B1 ) = LD( B1-1 ) * L( B1-1 ) - LAMBDA
      END IF
      
      DO I = B1, BN-1
         DPLUS( I ) = ( D( I ) + T( I ) ) - DELTA
c     LPLUS( I ) = LD( I ) / DPLUS( I )
         if ( dplus(i) .lt. DLAMCHU ) then
         LPLUS( I ) = LD( I ) /(DPLUS( I ) + DLAMCHU)
         else
         LPLUS( I ) = LD( I ) /DPLUS( I )
         endif

         T ( I+1 ) =
     $        ( T( I )-DELTA ) * LPLUS( I ) * L( I ) - LAMBDA
      END DO
      DPLUS( BN	) = ( D( BN ) + T( BN ) ) - DELTA
      
      IF(.NOT.( ( DPLUS( BN ).GT.ZERO) .OR.
     $     ( DPLUS( BN ).LT.ONE ) ) ) THEN
         IF( B1.EQ.1 ) THEN
            T( B1 ) = -LAMBDA
         ELSE
            T( B1 ) = LD( B1-1 ) * L( B1-1 ) - LAMBDA
         END IF
         
         DO I = B1, BN-1
            DPLUS( I ) = ( D( I ) + T( I ) ) - DELTA
         if ( dplus(i) .lt. DLAMCHU ) then
         LPLUS( I ) = LD( I ) /(DPLUS( I ) + DLAMCHU)
         else
         LPLUS( I ) = LD( I ) /DPLUS( I )
         endif
c            LPLUS( I ) = LD( I ) /DPLUS( I )

*     
*     Need to check the next few lines
*     
         IF(LPLUS( I ).EQ.0 
     $           .AND. ONE/(T( I )-DELTA).EQ.ZERO ) THEN
               T ( I+1 ) = L( I ) * LD( I ) - LAMBDA
            ELSE IF((T(I)-DELTA).EQ.ZERO
     $              .AND. ONE/LPLUS(I).EQ.0 ) THEN
               T ( I+1 ) = -ONE / (DPLUS( I )+ DLAMCHU)
            ELSE
               T ( I+1 ) =
     $              ( T( I )-DELTA )*LPLUS( I )*L( I ) - LAMBDA
            END IF
         END DO
         DPLUS( BN ) = ( D( BN ) + T( BN ) ) - DELTA
      END IF
       
      IF(.NOT.( ( DPLUS( BN ).GT.ZERO) .OR.
     $          ( DPLUS( BN ).LT.ONE ) ) ) THEN
         print *,"DDSTQDS : NaN detected!"
         GO TO 310
      END IF
       
       
      RETURN
101   format (E22.14)
102   format (E22.14,E22.14)
103   format (E22.14,E22.14,E22.14)
*      
*     End of DDSTQDS
*      
      END
       
      SUBROUTINE DDQDS( LAMBDA, DELTA, N, B1, BN, L, D,
     $                  LLD, UMINUS, DMINUS, P )
*      
*  -- LAPACK routine (version 0.0) -- in progress --
*     September 1995
*      
*     .. Scalar Arguments ..
      implicit none
      INTEGER            N, B1, BN
      DOUBLE PRECISION   DELTA, LAMBDA
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( N ), L( N-1 ), P(N ), DMINUS( N ),
     $                   LLD( N-1 ), UMINUS( N )
*     ..
*      
*  Purpose
*  =======
*      
*  DDQDS computes the U- D- U-^T decomposition of the submatrix
*  indexed from B1 to BN of (L*D*L^T - (LAMBDA+DELTA)*I)
*  by the differential form of the progressive qd algorithm.
*      
*  Arguments
*  =========
*      
*  LAMBDA  (input) DOUBLE PRECISION
*          The shift.
*      
*  DELTA   (input) DOUBLE PRECISION
*          Lower order bits of the shift.
*      
*  N       (input) INTEGER
*          The order of the matrix L * D * L^T.
*      
*  B1      (input) INTEGER
*          Starting index of the submatrix (of L * D * L^T).
*      
*  BN      (input) INTEGER
*          Last index of the submatrix (of L * D * L^T).
*      
*  L       (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) subdiagonal elements of the bidiagonal matrix
*          L, in elements 1 to N-1.  L(N) need not be set.
*      
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D.
*      
*  LLD     (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*L(i)*D(i).
*      
*  UMINUS  (output) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) superdiagonal elements of U-.
*      
*  DMINUS  (output) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of D-.
*      
*  P       (output) DOUBLE PRECISION array, dimension (N)
*          Intermediate results of the algorithm.
*      
*  =====================================================================
*      
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0d+0, ONE = 1.0d+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   TMP, EPS, dummy
*     ..
*     .. External Functions ..
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
#include "blas_lapack.data"
*     ..
*     .. Executable Statements ..
*      


 210  CONTINUE
      P( BN ) = D( BN ) - LAMBDA

      DO I = BN-1, B1, -1
         DMINUS( I+1 ) = ( LLD( I ) + P( I+1 ) ) - DELTA
         if ( dminus(i+1) .lt. DLAMCHU ) then
            TMP = D( I ) / (DMINUS( I+1 )+DLAMCHS)
         else
            TMP = D( I ) / DMINUS( I+1 )
         endif
         UMINUS( I ) = L( I ) * TMP
         P ( I ) = ( P( I+1 ) - DELTA ) * TMP - LAMBDA
      END DO
      IF( B1.EQ.1 ) THEN
         DMINUS( B1 ) = P( B1 ) - DELTA
      ELSE
         DMINUS( B1 ) = ( LLD( B1-1 ) + P( B1 ) ) - DELTA
      END IF
       
      IF(.NOT.( ( DMINUS( B1 ).GT.ZERO) .OR.
     $          ( DMINUS( B1 ).LT.ONE ) ) ) THEN
         P( BN ) = D( BN ) - LAMBDA

         DO I = BN-1, B1, -1
            DMINUS( I+1 ) = ( LLD( I ) + P( I+1 ) ) - DELTA
            if ( dminus(i+1) .lt. DLAMCHS ) then
               TMP = D( I ) / (DMINUS( I+1 )+DLAMCHS)
            else
               TMP = D( I ) / DMINUS( I+1 )
            endif
            UMINUS( I ) = L( I ) * TMP
*      
*  Need to check the next few lines
*      
            IF( TMP.EQ.0 .AND. ONE/(P( I+1) - DELTA).EQ.ZERO ) THEN
               P ( I ) = ( L( I ) ) - LAMBDA
            ELSE IF((P( I+1)-DELTA).EQ.ZERO .AND. ONE/TMP.EQ.0) THEN
               P ( I ) = - ONE / DMINUS( I+1 )
            ELSE
               P ( I ) = ( P( I+1 ) - DELTA ) * TMP - LAMBDA
            END IF
         END DO
         IF( B1.EQ.1 ) THEN
            DMINUS( B1 ) = P( B1 ) - DELTA
         ELSE
            DMINUS( B1 ) = ( LLD( B1-1 ) + P( B1 ) ) - DELTA
         END IF
      END IF
       
      IF(.NOT.( ( DMINUS( B1 ).GT.ZERO) .OR.
     $     ( DMINUS( B1 ).LT.ONE ) ) ) THEN
         print *," peigs DDQDS : NaN detected!"
         GO TO 210
      END IF
      
       
      RETURN
101   format (E22.14)
102   format (E22.14,E22.14)
103   format (E22.14,E22.14,E22.14)
*      
*     End of DDQDS
*      
      END
       
      SUBROUTINE DCMPGAMMA( LAMBDA, DELTA, N, B1,
     $     BN, L, D,
     $     LD, LLD, LPLUS, DPLUS, UMINUS,
     $     DMINUS, T,
     $     P, K, GAMMA )
*     
*  -- LAPACK routine (version 0.0) -- in progress --
*     September 1995
*      
*     .. Scalar Arguments ..
      implicit none
      INTEGER            N, B1, BN, K
      DOUBLE PRECISION   DELTA, LAMBDA
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( N ), L( N-1 ), P( N ), GAMMA( N ),
     $     DMINUS( N-1 ), LPLUS( N-1 ), T( N ),
     $     UMINUS( N-1 ),
     $     DPLUS( N ), LD( N-1 ), LLD( N-1 )
*     ..
*      
*  Purpose
*  =======
*      
*  DCMPGAMMA computes the GAMMA array, where GAMMA(I) is the
*  reciprocal of the I^{th} diagonal element of the inverse of
*  (L*D*L^T - (LAMBDA+DELTA)*I)
*      
*  Arguments
*  =========
*      
*  LAMBDA  (input) DOUBLE PRECISION
*          The shift.
*      
*  DELTA   (input) DOUBLE PRECISION
*          Lower order bits of the shift.
*      
*  N       (input) INTEGER
*          The order of the matrix L * D * L^T.
*      
*  B1      (input) INTEGER
*          Starting index of the submatrix (of L * D * L^T).
*      
*  BN      (input) INTEGER
*          Last index of the submatrix (of L * D * L^T).
*      
*  L       (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) subdiagonal elements of the bidiagonal matrix
*          L, in elements 1 to N-1.  L(N) need not be set.
*      
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D.
*      
*  LD      (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*D(i).
*      
*  LLD     (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*L(i)*D(i).
*      
*  LPLUS   (output) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) diagonal elements of L+.
*      
*  DPLUS   (output) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of D+.
*      
*  UMINUS  (output) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) diagonal elements of U-.
*      
*  DMINUS  (output) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of D-.
*      
*  T       (output) DOUBLE PRECISION array, dimension (N)
*          Intermediate results of the dstqds algorithm.
*      
*  P       (output) DOUBLE PRECISION array, dimension (N)
*          Intermediate results of the dqds algorithm.
*      
*  K       (output) INTEGER
*          The k^{th} column of the inverse of (L*D*L^T - (LAMBDA+DELTA)*I).
*      
*  GAMMA   (output) DOUBLE PRECISION array, dimension (N)
*          GAMMA(i) is the reciprocal of the i^{th} diagonal element
*          of the inverse of (L*D*L^T - (LAMBDA+DELTA)*I).
*      
*  =====================================================================
*      
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0d+0, ONE = 1.0d+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   DIF, EPS, MINDIF
*     ..
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
#include "blas_lapack.data"
       
*     ..
*     .. Executable Statements ..
*      


       
      EPS = DLAMCHP
      K = B1
      IF( B1.EQ.1 ) THEN
         MINDIF = P( B1 ) - DELTA
      ELSE
         MINDIF = ( LLD( B1-1 ) + P( B1 ) ) - DELTA
      END IF
      IF( MINDIF.EQ.ZERO ) THEN
         MINDIF = EPS * P( B1 )
      END IF
      GAMMA( B1 ) = MINDIF
       
      DIF = ( D( BN ) + T( BN ) ) - DELTA
      IF( DIF.EQ.ZERO ) THEN
         DIF = EPS * T( BN )
      END IF
      GAMMA( BN ) = DIF
      IF( ABS( DIF ).LT.ABS( MINDIF ) ) THEN
          MINDIF = DIF
          K = BN
      END IF
       
      DO I = B1+1, BN-1
*        DIF = P( I ) + ( (L( I-1 ) * L( I-1 )) * / DPLUS( I-1 ) ) * T(
         DIF = ( ( P( I ) + T( I ) ) + LAMBDA ) - DELTA
         IF( DIF.EQ.ZERO ) THEN
            DIF = EPS * P( I )
         END IF
         GAMMA( I ) = DIF
         IF( ABS( DIF ).LT.ABS( MINDIF ) ) THEN
             MINDIF = DIF
             K = I
         END IF
      END DO
       
       
      RETURN
101   format (E22.14)
102   format (E22.14,E22.14)
103   format (E22.14,E22.14,E22.14)
*      
*     End of DCMPGAMMA
*      
      END
C****************************************************************
C   Translated by Pacific-Sierra Research VAST-2          
C   Version 6.1C1 on 11/ 3/97 at 12:05:10
C****************************************************************
C
C****************************************************************
C   Translated by Pacific-Sierra Research VAST-2
C   Version 6.1C1 on 10/14/97 at 11:50:45
C****************************************************************
C      
       
      SUBROUTINE DGETAVEC4( iii, LAMBDA, DELTA, N, B1, BN, L, D, LD,
     $     LLD, LPLUS,
     $     DPLUS, UMINUS, DMINUS, T, P, GAMMA, Z, K,
     $     ZTZ, ZBEGIN, ZEND, vecno, index )
*      
*  -- LAPACK routine (version 0.0) -- in progress --
*     September 1995
*      
*     .. Scalar Arguments ..
      implicit none
      integer iii
      INTEGER            N, B1, BN, K, ZBEGIN, ZEND, vecno, index(*)
      DOUBLE PRECISION   DELTA, LAMBDA, ZTZ
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), L( * ), LD( * ), LLD( * ),
     $                   P( * ), GAMMA( * ),
     $                   DMINUS( * ), LPLUS( * ),
     $                   T( * ), UMINUS( * ), DPLUS( * ), Z( * )
*     ..
*      
*  Purpose
*  =======
*      
*  DGETAVEC computes the FP vector of the submatrix indexed from
*  B1 to BN of (L*D*L^T - (LAMBDA+DELTA)*I) using the qd algorithms.
*      
*  Arguments
*  =========
*      
*  LAMBDA  (input) DOUBLE PRECISION
*          The shift.
*      
*  DELTA   (input) DOUBLE PRECISION
*          Lower order bits of the shift.
*      
*  N       (input) INTEGER
*          The order of the matrix L * D * L^T.
*      
*  B1      (input) INTEGER
*          Starting index of the submatrix (of L * D * L^T).
*      
*  BN      (input) INTEGER
*          Last index of the submatrix (of L * D * L^T).
*      
*  L       (input) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) subdiagonal elements of the bidiagonal matrix
*          L, in elements 1 to N-1.  L(N) need not be set.
*      
*  D       (input) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of the diagonal matrix D.
*      
*  LD      (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*D(i).
*      
*  LLD     (input) DOUBLE PRECISION array, dimension (N-1)
*          The n-1 elements L(i)*L(i)*D(i).
*      
*  LPLUS   (output) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) diagonal elements of L+.
*      
*  DPLUS   (output) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of D+.
*      
*  UMINUS  (output) DOUBLE PRECISION array, dimension (N-1)
*          The (n-1) diagonal elements of U-.
*      
*  DMINUS  (output) DOUBLE PRECISION array, dimension (N)
*          The n diagonal elements of D-.
*      
*  T       (output) DOUBLE PRECISION array, dimension (N)
*          Intermediate results of the dstqds algorithm.
*      
*  P       (output) DOUBLE PRECISION array, dimension (N)
*          Intermediate results of the dqds algorithm.
*      
*  GAMMA   (output) DOUBLE PRECISION array, dimension (N)
*          GAMMA(i) is the reciprocal of the i^{th} diagonal element
*          of the inverse of (L*D*L^T - (LAMBDA+DELTA)*I).
*      
*  Z       (output) DOUBLE PRECISION array, dimension (N)
*          The FP vector. Z(k) is returned to be 1.
*      
*  K       (output) INTEGER
*          The k^{th} column of the inverse of (L*D*L^T - (LAMBDA+DELTA)*I).
*      
*  ZTZ     (output) DOUBLE PRECISION
*          The square of the norm of the FP vector.
*      
*  ZBEGIN  (output) INTEGER
*          For i < ZBEGIN, Z(i) < EPS. ZBEGIN >= B1.
*      
*  ZEND    (output) INTEGER
*          For i > ZEND, Z(i) < EPS. ZEND <= BN.
*      
*  vecno   (input) INTEGER --- ( used for printing purposes )
*          Index of the eigenvector desired.
*      
*  =====================================================================
*      
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0d+0, ONE = 1.0d+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   znrm, dummy, dummy1, dummy2
*     ..
*     .. External Functions ..
      INTEGER            idamax
      EXTERNAL           idamax
c      
      DOUBLE PRECISION dnrm2
      EXTERNAL dnrm2, dscal
c      
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT, ABS
#include "blas_lapack.data"
*     ..
*     .. Executable Statements ..
*      
      INTEGER I1, I2, kk
      LOGICAL L1, L2, L3, L4, L5, L6
      INTEGER I3, I4
      LOGICAL L7, L8, L9, L10, L11, L12, L13, L14, L15, L16, L17, L18
      ZBEGIN = B1
      ZEND = BN


      CALL DDSTQDS( LAMBDA, DELTA, N, B1, BN, L, D, LD,
     $     LPLUS, DPLUS, T )
      CALL DDQDS( LAMBDA, DELTA, N, B1, BN, L, D, LLD,
     $     UMINUS, DMINUS, P )
      CALL DCMPGAMMA( LAMBDA, DELTA, N, B1, BN, L, D, LD, LLD,
     $     LPLUS, DPLUS, UMINUS, DMINUS, T, P, K, GAMMA )
      goto 1000
c      
c      
c      
c this is for an occasionally breakage on cray mpp
c can''t tell if it is the compiler or what
c
      if ( abs(gamma(k)) .lt. DLAMCHS) then
         Z( K ) = DLAMCHS
      else	
         Z( K ) = gamma(k)* ONE
      endif
      RETURN
101   format (E22.14)
102   format (E22.14,E22.14)
103   format (E22.14,E22.14,E22.14)
*      
*     End of DGETAVEC
*      
      END

      SUBROUTINE YSYEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO )
c
* $Id: ysyev.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
#include "y64.fh"
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDA, LWORK, N
      DOUBLE PRECISION   A( LDA, * ), W( * ), WORK( * )
c
      INTGR4            INFO4, LDA4, LWORK4, N4
c
      lda4=lda
      lwork4=lwork
      n4=n
      call DSYEV( JOBZ, UPLO, N4, A, LDA4, W, WORK, LWORK4, INFO4)
      info=info4
      RETURN
      END

*
* $Id: fci_tinit.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_tinit
      implicit none
#include "fcitime.fh"      
c
      integer i
c
      do i = 1, maxroutine
         names(i) = ' '
         times(i) = 0.0d0
      enddo
c
      names(1)  = 'couple1'
      names(2)  = 'couple2'
      names(3)  = 'couple3'
      names(4)  = 'davidson'
      names(5)  = 'diags'
      names(6)  = 'make_eaj '
      names(7)  = 'setup'
      names(8)  = 'sigma'
      names(9)  = 'solve'
      names(10) = 'spnfrc'
      names(11) = 'cntone'
      names(12) = 'hami1'
      names(13) = 'hami2'
      names(14) = 'symfrc'
c
      end
      subroutine fci_tstart(i,oprint)
      implicit none
#include "fcitime.fh"      
      integer i
      logical oprint
      integer fci_strlen
      external fci_strlen
c
      if (i.le.0  .or.  i.gt.maxroutine) call fci_err('tstart?',i)
      ncalls(i) = ncalls(i) + 1
      if (ncalls(i) .lt. maxcalls) then   ! Avoid too many system calls
        started(i) = fci_time()
      else
        started(i) = 0.0d0
      endif
c     
      if (oprint) write(6,1) names(i)(1:fci_strlen(names(i))), 
     $     ncalls(i), started(i)
 1    format('  Started ',a,': call number',f10.0,' at', f9.1,'s')
c
      end
      subroutine fci_tfinish(i,oprint)
      implicit none
#include "fcitime.fh"      
      integer i
      logical oprint
      double precision now
      integer fci_strlen
      external fci_strlen
c
      if (i.le.0  .or.  i.gt.maxroutine) call fci_err('tfinish?',i)
c
      if (ncalls(i) .lt. maxcalls) then  ! Avoid too many system calls
        now = fci_time()
        times(i) = times(i) + now - started(i)
      else
        now = 0.0d0
      endif
c
      if (oprint) write(6,1) names(i)(1:fci_strlen(names(i))), 
     $     ncalls(i), now, now-started(i),
     $     times(i)
 1    format(' Finished ',a,': call number',f10.0,' at', f9.1,'s',
     $     ' used ',f9.1,'s', ' total ',f9.2, 's')
c
      end
      subroutine fci_tprint()
      implicit none
#include "fcitime.fh"      
      integer i
      double precision used, now, totalcalls
c
      write(6,1) 
 1    format(/'  FCI timing information '/
     $        '  ----------------------'/
     $     1x, ' name                    ncalls       time'/
     $     1x, ' --------------------  ----------  ----------')
      totalcalls = 0
      do i = 1, maxroutine
         if (ncalls(i) .gt. 0) then
            if (ncalls(i) .gt. maxcalls) times(i) = 0.0d0  ! Did not measure it
            write(6,2) names(i), ncalls(i), times(i)
 2          format(2x,a20,2x,f10.0,2x,f9.1)
            if (times(i).gt.0.0d0) totalcalls = totalcalls + 2*ncalls(i)
         endif
      enddo
c
c     Determine the overhead due to timing
c
      used = -fci_time()
      do i = 1, maxcalls
         now = fci_time()
         if (used+now .gt. 2) goto 10
      enddo
 10   used = (used+now)/dfloat(i)
      write(6,3) used, totalcalls, used*totalcalls
 3    format(/1p,'  Timing overhead=',d8.1,'/call, #calls=',
     $     d8.1, ', total ovehead=',d8.1/)
c
      end
      double precision function fci_time()
      implicit none
c
c     return the CPU time in seconds from the first call to this routine
c
c     MACHINE DEPENDENT
c
      double precision firsttime
      logical firstcall
#ifdef AIX
      integer mclock
      data firstcall /.true./, firsttime/0.0d0/
c
      if (firstcall) then
         firsttime = dfloat(mclock())*0.01d0
         firstcall = .false.
      endif
      fci_time = dfloat(mclock())*0.01d0 - firsttime
#elif defined(LINUX)
      double precision linux_cputime
      external linux_cputime
      data firstcall /.true./, firsttime/0.0d0/
      if (firstcall) then
         firsttime = linux_cputime()
         firstcall = .false.
      endif
c
      fci_time = linux_cputime() - firsttime
#else
      real*4 tarray(2)
      real*4 etime
      external etime
      data firstcall /.true./, firsttime/0.0d0/
c
      if (firstcall) then
         firsttime = etime(tarray)
         firstcall = .false.
      endif
c
      fci_time = etime(tarray) - firsttime
#endif
c
      end
      integer function fci_strlen(a)
      implicit none
      character*(*) a
      integer i
      intrinsic len
c
      do i = len(a),1,-1
         if (a(i:i) .ne. ' ') goto 10
      enddo
c
 10   fci_strlen = i
c
      end

*
* $Id: nwpw_filefind.F 22651 2012-07-28 00:05:42Z bylaska $
*

*     ***********************************
*     *					*
*     *	 	  nwpw_filefind 	*
*     *					*
*     ***********************************

      logical function nwpw_filefind(fname)
      implicit none
      character*50 fname

#include "tcgmsg.fh"
#include "msgtypesf.h"

*     *** local variables ***
      integer MASTER,taskid
      parameter(MASTER=0)

      logical found
      integer idum
      character*255 full_filename

      call Parallel_taskid(taskid)
      idum = 0
      if (taskid.eq.MASTER) then
         call util_file_name_noprefix(fname,.false.,
     >                             .false.,
     >                       full_filename)
         inquire(file=full_filename,exist=found)

         idum = 0
         if (found) idum = 1
      end if
      call Parallel_Brdcst_ivalue(MASTER,idum)
      

      if (idum.eq.1) then
         found = .true.
      else
         found = .false.
      end if

      nwpw_filefind = found
      return
      end

      subroutine nmcoef2c(z,cc,l,np,scr,lscr)
c $Id: nmcoef2c.F 19696 2010-10-29 16:53:42Z d3y133 $
c.. routine to compute normalized contraction based on (cgtf|cgtf) 
c..  normalization factor and do normalization
c
      implicit none
#include "errquit.fh"
c::passed
      integer l                   ! [input] angular momentum type
      integer np                  ! [input] number of primitives in contraction
      double precision z(np)      ! [input] exponents
      double precision cc(np)     ! [input/output] contraction coefficients
      integer lscr                ! [input] length of scratch array
      double precision scr(lscr)  ! [input] scratch array
c::local
      double precision factor, sum, almost_one
      double precision xyz(3), dumexp, dumcof
      double precision PI
      integer nint, i, nbf, l_lim
      integer ip, j, index
      logical warning
      logical oldway
c
      oldway = .false.
c
      PI = 2.0d00*acos(0.0d00)
c
c... dummy coordinates
      xyz(1) = 0.0d00
      xyz(2) = 0.0d00
      xyz(3) = 0.0d00
c... dummy coef/exponent
      dumexp = 0.0d00
      dumcof = 1.0d00
c... number of integrals
      if (l.lt.0) call errquit
     &    ('nmcoef2c: how did I get an sp or spd shell here?',911,
     &       BASIS_ERR)
      nbf = (l+1)*(l+2)/2
      nint = nbf*nbf
      if (.not.oldway) then
*
*...
*... normalize for overlap of basis function in all space
*... e.g., normalize with respect to primitive coefficients
*...
*
        do ip = 1,np
          cc(ip) = cc(ip) *
     &        ((2.D0*z(ip)/PI)**0.75D0)*(4.D0*z(ip))**(0.5D0*l)
          l_lim = 2*l - 1
          factor = 1.0d00
          do i = l_lim,2,-2
            factor = factor*dble(i)
          enddo
          cc(ip) = cc(ip) / sqrt(factor)
        enddo

*
*...
* normalize contraction coefficients to make (a|a) = 1 
*...
*
        sum = 0.0d00
        do i = 1,np
          do j = i,np
*debug:            write(6,*)' '
*debug:            write(6,*)'---------------------------------------'
*debug:            write(6,*)' xyz ',xyz
*debug:            write(6,*)' i,exp,coeff: ',i,z(i),cc(i)
*debug:            write(6,*)' j,exp,coeff: ',j,z(j),cc(j)
            call hf2(
     &          xyz,z(i),cc(i),1,1,l,
     &          xyz,dumexp,dumcof,1,1,0,
     &          xyz,z(j),cc(j),1,1,l,
     &          xyz,dumexp,dumcof,1,1,0,
     &          scr,nint,.false.,.false.,.false.,.false.,
     &          scr(1+nint),(lscr-nint))
* find minimum diagonal element
            call find_min_diag_nmcoef2c(scr,nbf,factor)
*debug:            write(6,*)' sum 1     ', sum, factor
            if(i.ne.j) factor = factor*2d0
            sum = sum + factor
*debug:            write(6,*)' sum 2     ', sum
          enddo
        enddo
*debug:        write(6,*)' sum final ', sum
        factor = 1.0d00/sqrt(sum)
*debug:        write(6,*)' factor    ',factor
        do i = 1,np
          cc(i) = cc(i)*factor
        enddo
c
      else
        call hf2 (
     &        xyz,z,cc,np,1,l,
     &        xyz,dumexp,dumcof,1,1,0,
     &        xyz,z,cc,np,1,l,
     &        xyz,dumexp,dumcof,1,1,0,
     &        scr,nint,.false.,.false.,.false.,.false.,
     &        scr(1+nint),(lscr-nint))
*        
crak:--
c.. find minimum diagonal element
c
        factor = abs(scr(1))
        index = 0
        do i = 1,nbf
          do j = 1,nbf
            index = index + 1
            if (i.eq.j) then
              if (abs(scr(index)).gt.1.0d-05) then
                factor = min(factor,abs(scr(index)))
              endif
*debug:              write(6,*)'factor ',factor,' val ',scr(index)
            endif
          enddo
        enddo
        factor = 1.0d00/sqrt(factor)
c
c... normalize contraction coefficients
        do i = 1, np
          cc(i) = cc(i)*factor
        enddo
      endif
*debug:* compute sum of squares
*debug:      factor = 0.0d00
*debug:      do ip = 1,np
*debug:        factor = factor + cc(ip)*cc(ip)
*debug:      enddo
*debug:      write(6,*) ' sum of squares :',factor
*
*...
*...  compute integrals and check diagonal elements
*...  diagonal elements must be >= 1.0
*
      call hf2 (
     &        xyz,z,cc,np,1,l,
     &        xyz,dumexp,dumcof,1,1,0,
     &        xyz,z,cc,np,1,l,
     &        xyz,dumexp,dumcof,1,1,0,
     &        scr,nint,.false.,.false.,.false.,.false.,
     &        scr(1+nint),(lscr-nint))
      warning = .false.
      almost_one = 1.0d00 - 1.0d-10  ! allow a little slop
00001 continue
      index = 0
      do i = 1,nbf
        do j = 1,nbf
          index = index + 1
          if (i.eq.j) then
            factor = scr(index)
            if ((.not.warning).and.(factor.lt.almost_one)) then
              warning = .true.
              write(6,*)' nmcoef2c: problem normalizing basis set ',
     &            '::factor       ::', factor
              factor = 1.0d00 - factor
              write(6,*)' nmcoef2c: problem normalizing basis set ',
     &            '::diff from 1.0::', factor
              goto 00001
            endif
            if (warning) then
              write(6,10000)l,i,j,factor
            endif
          endif
        enddo
      enddo
      if (warning)
     &    call errquit(' nmcoef2c: problem normalizing basis set',911,
     &       BASIS_ERR)
10000 format(1x,'ints after normalization(',i3,
     &    ') <',i5,'|',i5,'> =',1pd20.10)
      end
*
      subroutine find_min_diag_nmcoef2c(buf,nr,factor)
      implicit none
      integer nr
      double precision buf(nr,nr)
      double precision factor
      logical negative
c
      integer i,j
*debug:      write(6,*)' nr = ',nr
      factor = abs(buf(1,1))
      negative = buf(1,1).lt.0.0d00
      do i = 1,nr
        do j = 1,nr
          if (i.eq.j) then
*debug:            write(6,10000)i,j,buf(i,j)
            if (abs(buf(i,j)).lt.factor) then
              factor = abs(buf(i,j))
              negative = buf(i,j) .lt. 0.0d00
            endif
          endif
        enddo
      enddo
      if (negative) factor = -1.0d00*factor
10000 format(' findbuffer(',i3,',',i3,') =',1pd20.10)
      end

      subroutine dia_groups(sgmnam,imol,isel,wt,x)
c
c $Id: dia_groups.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),imol(msa)
      real*8 x(nsa,3)
c
      integer i
c
      ngroups=ngroups+1
      if(ngroups.gt.maxgrp) call md_abort('Increase maxgrp',maxgrp)
c
      if(card(1:6).eq.'groups') then
      read(card(8:67),1001) (igroups(ngroups,i),i=1,6),
     + (rgroups(ngroups,i),i=1,2)
 1001 format(4i7,i5,i3,2f12.6)
      endif
      print*,'++++++++++',igroups(ngroups,5) 
c
      filgrp=card(68:80)
      if(filgrp(1:1).ne.' ') then
      open(unit=lfngrp,file=filgrp(1:index(filgrp,' ')-1),
     + form='formatted',status='unknown')
      if(igroups(ngroups,5).eq.1)
     + call dia_grpcogdis(sgmnam,imol,isel,wt,x,ngroups)
      if(igroups(ngroups,5).eq.2)
     + call dia_grpdis(sgmnam,imol,isel,wt,x,ngroups)
      if(igroups(ngroups,5).eq.4)
     + call dia_grpcogang(sgmnam,imol,isel,wt,x,ngroups)
      if(igroups(ngroups,5).eq.5)
     + call dia_grpvectors(sgmnam,imol,isel,wt,x,ngroups)
      ngroups=ngroups-1
      close(unit=lfngrp)
      endif
c
      return
      end
      subroutine dia_group(sgmnam,imol,isel,wt,x,iwrk)
c
c $Id: dia_groups.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),imol(msa),iwrk(mxdef,mxnum,maxgrp)
      real*8 x(nsa,3)
c
      integer i,j
c
      ngroup=ngroup+1
      if(ngroup.gt.maxgrp) call md_abort('Increase maxgrp',maxgrp)
c
      read(card(8:46),1000) (igroup(ngroup,i),i=1,3),
     + (rgroup(ngroup,i),i=1,2)
 1000 format(i7,i5,i3,2f12.6)
c
      do 1 i=1,mxdef
      do 2 j=1,mxnum
      iwrk(i,j,ngroup)=0
    2 continue
    1 continue
c
      return
      end
      subroutine dia_grpdis(sgmnam,imol,isel,wt,x,igr)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),igr,imol(msa)
      real*8 x(nsa,3)
c
      integer igrp,jgrp
      integer i,j,jfrom,ito,ia,ja,number
      real*8 dist,dx,dy,dz
c
      igrp=igroups(igr,1)
      jgrp=igroups(igr,2)
c
      number=0
c
      if(ldef(igrp).lt.0) return
c
      write(lfngrp,1000) igr,igroups(igr,5)
 1000 format(2i5)
c
      ito=ldef(igrp)
      if(igrp.eq.jgrp) ito=ito-1
      do 1 i=1,ito
      ia=idef(igrp,i)
      jfrom=1
      if(igrp.eq.jgrp) jfrom=i+1
      do 2 j=jfrom,ldef(jgrp)
      ja=idef(jgrp,j)
      dx=abs(x(ia,1)-x(ja,1))
      dy=abs(x(ia,2)-x(ja,2))
      dz=abs(x(ia,3)-x(ja,3))
      if(igroups(igr,6).eq.1) then
      if(dz.gt.box(3)) dz=dz-box(3)
      elseif(igroups(igr,6).eq.2) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      elseif(igroups(igr,6).eq.3) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      if(dz.gt.box(3)) dz=dz-box(3)
      endif
      dist=sqrt(dx*dx+dy*dy+dz*dz)
      if(dist.ge.rgroups(igr,1).and.dist.le.rgroups(igr,2)) then
      write(lfngrp,1001)
     + imol(ia),sgmnam(ia)(11:16),sgmnam(ia)(1:5),sgmnam(ia)(6:10),
     + imol(ja),sgmnam(ja)(11:16),sgmnam(ja)(1:5),sgmnam(ja)(6:10),dist
 1001 format(2(i5,a6,' ',a5,':',a5,' '),f12.6)
      number=number+1
      endif
    2 continue
    1 continue
c
      write(lfngrp,1002) 0
 1002 format(i5)
c
      return
      end
      subroutine dia_grpvectors(sgmnam,imol,isel,wt,x,igr)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),igr,imol(msa)
      real*8 x(nsa,3),vi(3),vj(3)
c
      integer igrp,jgrp
      integer i,j,jfrom,ito,ia,ja,number
      real*8 dist,dx,dy,dz,dot
c
      igrp=igroups(igr,1)
      jgrp=igroups(igr,2)
      print*,'igrp,jgrp=',igrp,jgrp
c
      number=0
c
      if(ldef(igrp).lt.0) return
c
      write(lfngrp,1000) igr,igroups(igr,5)
 1000 format(2i5)
c
      if(igrp.eq.jgrp)
     + call md_abort('vectors: single atom list',0)
      if(ldef(igrp).ne.ldef(jgrp))
     + call md_abort('vectors: unequal atom lists',0)
      ito=ldef(igrp)
      do 1 i=1,ito
      ia=idef(igrp,i)
      ja=idef(jgrp,i)
      dx=abs(x(ia,1)-x(ja,1))
      dy=abs(x(ia,2)-x(ja,2))
      dz=abs(x(ia,3)-x(ja,3))
      if(igroups(igr,6).eq.1) then
      if(dz.gt.box(3)) dz=dz-box(3)
      elseif(igroups(igr,6).eq.2) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      elseif(igroups(igr,6).eq.3) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      if(dz.gt.box(3)) dz=dz-box(3)
      endif
      dist=sqrt(dx*dx+dy*dy+dz*dz)
c      write(lfngrp,1001)
c     + imol(ia),sgmnam(ia)(11:16),sgmnam(ia)(1:5),sgmnam(ia)(6:10),
c     + imol(ja),sgmnam(ja)(11:16),sgmnam(ja)(1:5),sgmnam(ja)(6:10),dist
c 1001 format(2(i5,a6,' ',a5,':',a5,' '),f12.6)
      write(lfngrp,1003) i,(x(ia,j),j=1,3),(x(ja,j)-x(ia,j),j=1,3),dist
 1003 format(i5,7f12.6)
      number=number+1
    1 continue
      do 2 i=1,ito
      ia=idef(igrp,i)
      ja=idef(jgrp,i)
      vi(1)=x(ia,1)-x(ja,1)
      vi(2)=x(ia,2)-x(ja,2)
      vi(3)=x(ia,3)-x(ja,3)
      do 3 j=i,ito
      ia=idef(igrp,j)
      ja=idef(jgrp,j)
      vj(1)=x(ia,1)-x(ja,1)
      vj(2)=x(ia,2)-x(ja,2)
      vj(3)=x(ia,3)-x(ja,3)
      dot=(vi(1)*vj(1)+vi(2)*vj(2)+vi(3)*vj(3))/
     + (sqrt(vi(1)**2+vi(2)**2+vi(3)**2)*
     +  sqrt(vj(1)**2+vj(2)**2+vj(3)**2))
      write(lfngrp,1004) i,j,dot
 1004 format(2i5,f12.6)
    3 continue
    2 continue
c    1 continue
c
      write(lfngrp,1002) 0
 1002 format(i5)
c
      return
      end
      subroutine dia_lochdr(sgmnam,imol,isel)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      integer imol(msa),isel(nsa)
c
      integer i,num,igrp,ia,j,ito
c
      num=0
      do 1 i=1,nsa
      if(isel(i).ne.0) num=num+1
    1 continue
c
      write(lfnloc,1000) ngroup
 1000 format(2i7)
      do 4 j=1,ngroup
      igrp=igroup(j,1)
      ito=ldef(igrp)
      write(lfnloc,1000) ito,nsa
      do 2 i=1,ito
      ia=idef(igrp,i)
      write(lfnloc,1001) ia,imol(ia),sgmnam(ia)(11:16),sgmnam(ia)(1:5),
     + sgmnam(ia)(6:10)
    2 continue
    4 continue
      write(lfnloc,1000) num,nsa
      do 3 i=1,nsa
      if(isel(i).ne.0) then
      write(lfnloc,1001) i,imol(i),sgmnam(i)(11:16),sgmnam(i)(1:5),
     + sgmnam(i)(6:10)
 1001 format(i7,i5,a6,' ',a5,':',a5)
      endif
    3 continue
c
      return
      end
      subroutine dia_grploc(sgmnam,imol,isel,wt,x,igr,iwrk)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),igr,imol(msa),iwrk(mxdef,mxnum,maxgrp)
      real*8 x(nsa,3)
c
      integer i,j,igrp,ia,ja,k,ntmp,ito
      real*8 dx,dy,dz,dist
c
      integer num,ndex(100)
      real*8 rd(100)
c
      igrp=igroup(igr,1)
      ito=ldef(igrp)
c
c      write(lfngrp,1000) time
c 1000 format('Atom distances for selected atoms at time ',f12.6)
c
      do 1 i=1,ito
      ia=idef(igrp,i)
      num=0
      do 2 ja=1,nsa
      if(ia.ne.ja.and.isel(ja).ne.0) then
      dx=abs(x(ia,1)-x(ja,1))
      dy=abs(x(ia,2)-x(ja,2))
      dz=abs(x(ia,3)-x(ja,3))
      if(igroup(igr,3).eq.1) then
      if(dz.gt.box(3)) dz=dz-box(3)
      elseif(igroup(igr,3).eq.2) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      elseif(igroup(igr,3).eq.3) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      if(dz.gt.box(3)) dz=dz-box(3)
      endif
      dist=sqrt(dx*dx+dy*dy+dz*dz)
      if(dist.ge.rgroup(igr,1).and.dist.le.rgroup(igr,2)) then
      if(num.lt.100) then
      num=num+1
      ndex(num)=ja
      rd(num)=dist
      endif
      endif
      endif
    2 continue
      if(num.gt.0) then
      do 3 j=1,num-1
      do 4 k=j+1,num
      if(ndex(j).gt.ndex(k)) then
      ntmp=ndex(j)
      ndex(j)=ndex(k)
      ndex(k)=ntmp
      endif
    4 continue
    3 continue
      do 5 j=1,num
      if(ndex(j).eq.0) goto 6
      if(ndex(j).ne.iwrk(igrp,j,i)) goto 6
    5 continue
      if(iwrk(igrp,num+1,i).eq.0) goto 1
    6 continue
      iwrk(igrp,num+1,i)=0
      do 7 j=1,num
      iwrk(igrp,j,i)=ndex(j)
    7 continue
      if(num.lt.11) then
      write(lfnloc,1001) time,ia,(ndex(j),j=1,num)
 1001 format(f12.6,11i6)
      else
      write(lfnloc,1002) time,ia,(ndex(j),j=1,num)
 1002 format(f12.6,11i6,/,(18x,10i6))
      endif
c      write(lfnloc,1001)
c     + imol(ia),sgmnam(ia)(11:16),sgmnam(ia)(1:5),sgmnam(ia)(6:10),
c     + (imol(ndex(j)),sgmnam(ndex(j))(11:16),sgmnam(ndex(j))(1:5),
c     + sgmnam(ndex(j))(6:10),j=1,num)
c 1001 format(2(i5,a6,' ',a5,':',a5,' '),/,(t25,i5,a6,' ',a5,':',a5,' '))
      endif
    1 continue
c
      return
      end
      subroutine dia_histo(x,w,ihi)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer ihi,ito
      real*8 x(nsa,3),w(mwm,mwa,3)
c
      integer i,ia,j,ihndx
c
      dhis=1.2d0*box(3)/real(idhis(ihi,2))
c
      ito=ldef(idhis(ihi,1))
      if(ito.gt.0) then
      do 1 i=1,ito
      ia=idef(idhis(ihi,1),i)
      ihndx=(x(ia,3)-rhis)/dhis
      ihis(ihndx,ihi)=ihis(ihndx,ihi)+1
    1 continue
      else
      do 2 j=1,nwm
      do 3 i=1,-ito
      ia=idef(idhis(ihi,1),i)
      ihndx=(w(j,ia,3)-rhis)/dhis
      ihis(ihndx,ihi)=ihis(ihndx,ihi)+1
    3 continue
    2 continue
      endif
c
      return
      end      
      subroutine dia_order(x)
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      real*8 x(nsa,3)
c
      integer i,ia,n,igrp,j
      real*8 xsijx,xsijy,xsijz,xskjx,xskjy,xskjz
      real*8 rsij2,rskj2,rsij2i,rskj2i,rsikji,cphi
c
      real*8 xa(3),xb(3),xc(3)
c
      do 1 i=1,nord
      igrp=idord(i,1)
      n=ldef(igrp)
      do 2 j=1,n
      ia=idef(igrp,j)
      xa(1)=x(ia,1)
      xa(2)=x(ia,2)
      xa(3)=x(ia,3)
    2 continue
      xa(1)=xa(1)/dble(n)-x(idord(i,3),1)
      xa(2)=xa(2)/dble(n)-x(idord(i,3),2)
      xa(3)=xa(3)/dble(n)-x(idord(i,3),3)
      igrp=idord(i,2)
      n=ldef(igrp)
      do 3 j=1,n
      ia=idef(igrp,j)
      xb(1)=x(ia,1)
      xb(2)=x(ia,2)
      xb(3)=x(ia,3)
    3 continue
      xb(1)=xb(1)/dble(n)-x(idord(i,3),1)
      xb(2)=xb(2)/dble(n)-x(idord(i,3),2)
      xb(3)=xb(3)/dble(n)-x(idord(i,3),3)
      xc(1)=x(idord(i,4),1)-x(idord(i,3),1)
      xc(2)=x(idord(i,4),2)-x(idord(i,3),2)
      xc(3)=x(idord(i,4),3)-x(idord(i,3),3)
c
      xsijx=xa(1)-xb(1)
      xskjx=xc(1)-xb(1)
      xsijy=xa(2)-xb(2)
      xskjy=xc(2)-xb(2)
      xsijz=xa(3)-xb(3)
      xskjz=xc(3)-xb(3)
c
      rsij2=xsijx*xsijx+xsijy*xsijy+xsijz*xsijz
      rskj2=xskjx*xskjx+xskjy*xskjy+xskjz*xskjz
      cphi=xsijx*xskjx+xsijy*xskjy+xsijz*xskjz
      rsij2i=one/rsij2
      rskj2i=one/rskj2
      rsikji=one/sqrt(rsij2*rskj2)
      cphi=cphi*rsikji
      if(cphi.lt.-one) cphi=-one
      if(cphi.gt. one) cphi= one
c
cc      rord(i,1)=rord(i,1)+acos(cphi)
cc     rord(i,2)=rord(i,2)+cphi*cphi
c
    1 continue
c
      return
      end
      subroutine dia_grpcogdis(sgmnam,imol,isel,wt,x,igr)
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),igr,imol(msa)
      real*8 x(nsa,3)
c
      integer igrp,jgrp
      integer i,ia,ja
      real*8 dist,dx,dy,dz
      real*8 cogi(3),cogj(3),factor
      real*8 boxh(3)
c
      boxh(1)=half*box(1)
      boxh(2)=half*box(2)
      boxh(3)=half*box(3)
c
      igrp=igroups(igr,1)
      jgrp=igroups(igr,2)
c
      if(ldef(igrp).lt.0) return
      if(ldef(jgrp).lt.0) return
c
      do 1 i=1,3
      cogi(i)=zero
      cogj(i)=zero
    1 continue
c
      do 2 i=1,ldef(igrp)
      ia=idef(igrp,i)
      cogi(1)=cogi(1)+x(ia,1)
      cogi(2)=cogi(2)+x(ia,2)
      cogi(3)=cogi(3)+x(ia,3)
    2 continue
      factor=one/dble(ldef(igrp))
      cogi(1)=cogi(1)*factor
      cogi(2)=cogi(2)*factor
      cogi(3)=cogi(3)*factor
c
      do 3 i=1,ldef(jgrp)
      ja=idef(jgrp,i)
      cogj(1)=cogj(1)+x(ja,1)
      cogj(2)=cogj(2)+x(ja,2)
      cogj(3)=cogj(3)+x(ja,3)
    3 continue
      factor=one/dble(ldef(jgrp))
      cogj(1)=cogj(1)*factor
      cogj(2)=cogj(2)*factor
      cogj(3)=cogj(3)*factor
c
      dx=abs(cogi(1)-cogj(1))
      dy=abs(cogi(2)-cogj(2))
      dz=abs(cogi(3)-cogj(3))
c
      if(igroups(igr,6).eq.1) then
      if(dz.gt.boxh(3)) dz=dz-box(3)
      elseif(igroups(igr,6).eq.2) then
      if(dx.gt.boxh(1)) dx=dx-box(1)
      if(dy.gt.boxh(2)) dy=dy-box(2)
      elseif(igroups(igr,6).eq.3) then
      if(dx.gt.boxh(1)) dx=dx-box(1)
      if(dy.gt.boxh(2)) dy=dy-box(2)
      if(dz.gt.boxh(3)) dz=dz-box(3)
      endif
      dist=sqrt(dx*dx+dy*dy+dz*dz)
c
      write(lfngrp,1001) igr,igroups(igr,5),dist,dx,dy,dz
 1001 format(2i5,4f12.6)
c
      return
      end
      subroutine dia_grpcogang(sgmnam,imol,isel,wt,x,igr)
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),igr,imol(msa)
      real*8 x(nsa,3)
c
      integer igrp,jgrp,kgrp
      integer i,ia,ja,ka
      real*8 dx
      real*8 cogi(3),cogj(3),cogk(3),factor
      real*8 boxh(3)
      real*8 xsijx,xskjx,xsijy,xskjy,xsijz,xskjz,rsij2,rskj2
      real*8 cphi,rsij2i,rskj2i,rsikji,phi
c
      boxh(1)=half*box(1)
      boxh(2)=half*box(2)
      boxh(3)=half*box(3)
c
      igrp=igroups(igr,1)
      jgrp=igroups(igr,2)
      kgrp=igroups(igr,3)
c
      if(ldef(igrp).lt.0) return
      if(ldef(jgrp).lt.0) return
      if(ldef(kgrp).lt.0) return
c
      do 1 i=1,3
      cogi(i)=zero
      cogj(i)=zero
      cogk(i)=zero
    1 continue
c
      do 2 i=1,ldef(igrp)
      ia=idef(igrp,i)
      cogi(1)=cogi(1)+x(ia,1)
      cogi(2)=cogi(2)+x(ia,2)
      cogi(3)=cogi(3)+x(ia,3)
    2 continue
      factor=one/dble(ldef(igrp))
      cogi(1)=cogi(1)*factor
      cogi(2)=cogi(2)*factor
      cogi(3)=cogi(3)*factor
c
      do 3 i=1,ldef(jgrp)
      ja=idef(jgrp,i)
      cogj(1)=cogj(1)+x(ja,1)
      cogj(2)=cogj(2)+x(ja,2)
      cogj(3)=cogj(3)+x(ja,3)
    3 continue
      factor=one/dble(ldef(jgrp))
      cogj(1)=cogj(1)*factor
      cogj(2)=cogj(2)*factor
      cogj(3)=cogj(3)*factor
c
      do 4 i=1,ldef(kgrp)
      ka=idef(kgrp,i)
      cogk(1)=cogk(1)+x(ka,1)
      cogk(2)=cogk(2)+x(ka,2)
      cogk(3)=cogk(3)+x(ka,3)
    4 continue
      factor=one/dble(ldef(kgrp))
      cogk(1)=cogk(1)*factor
      cogk(2)=cogk(2)*factor
      cogk(3)=cogk(3)*factor
c
      if(igroups(igr,6).gt.0) then
      do 6 i=1,igroups(igr,6)
      dx=cogi(i)-cogj(i)
      if(dx.lt.-boxh(i)) cogi(i)=cogi(i)+box(i)
      if(dx.gt.boxh(i)) cogi(i)=cogi(i)-box(i)
      dx=cogk(i)-cogk(i)
      if(dx.lt.-boxh(i)) cogk(i)=cogk(i)+box(i)
      if(dx.gt.boxh(i)) cogk(i)=cogk(i)-box(i)
    6 continue
      endif
c
      xsijx=cogi(1)-cogj(1)
      xskjx=cogk(1)-cogj(1)
      xsijy=cogi(2)-cogj(2)
      xskjy=cogk(2)-cogj(2)
      xsijz=cogi(3)-cogj(3)
      xskjz=cogk(3)-cogj(3)
c
      rsij2=xsijx*xsijx+xsijy*xsijy+xsijz*xsijz
      rskj2=xskjx*xskjx+xskjy*xskjy+xskjz*xskjz
      cphi=xsijx*xskjx+xsijy*xskjy+xsijz*xskjz
      rsij2i=one/rsij2
      rskj2i=one/rskj2
      rsikji=one/sqrt(rsij2*rskj2)
      cphi=cphi*rsikji
      if(cphi.lt.-one) cphi=-one
      if(cphi.gt. one) cphi= one
      phi=acos(cphi)
c
      write(lfngrp,1001) igr,igroups(igr,5),phi
 1001 format(2i5,4f12.6)
c
      return
      end

      SUBROUTINE ccsdtq_t4_11_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: ccsdtq_t4_11_1.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h11 h12 p5 p6 h1 h2 h3 h4 )_vt + = 1 * Sum ( p9 p10 ) * t ( p5 p6 p9 p10 h1 h2 h3 h4 )_t * v ( h11 h12 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER h11b
      INTEGER h12b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER p10b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p9b_1
      INTEGER p10b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER p9b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h11b = 1,noab
      DO h12b = h11b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      DO h4b = h3b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h1b-1)
     &+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne
     &.16)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h11b-1
     &)+int_mb(k_spin+h12b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2
     &b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h11b-1),ieor(int_mb(k_sym+h12b-1),ieor(int_mb(k_sym+h1b-1),i
     &eor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-
     &1)))))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+h11b-1) * int_mb(k_range+h12b-1) * int_mb(k_range+h1b-1) * int
     &_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_t4_11_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p9b-1)
     &+int_mb(k_spin+p10b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b
     &-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p9b-1),ieor(int_mb(k_sym+p10b-1),ieor(int_mb(k_sym+h1b-1),ie
     &or(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1
     &)))))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_8(p5b,p6b,p9b,p10b,h1b,h2b,h3b,h4b,p5b_1,p6b_1
     &,p9b_1,p10b_1,h1b_1,h2b_1,h3b_1,h4b_1)
      CALL TCE_RESTRICTED_4(h11b,h12b,p9b,p10b,h11b_2,h12b_2,p9b_2,p10b_
     &2)
      dim_common = int_mb(k_range+p9b-1) * int_mb(k_range+p10b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * 
     &int_mb(k_range+h4b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h11b-1) * int_mb(k_range+h12b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_t4_11_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_t4_11_1',2,MA_ERR)
      IF ((p10b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p10
     &b_1 - noab - 1 + nvab * (p9b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h4b-1),8,7,6,5,4,3,2,1,1.0d0)
      END IF
      IF ((p9b .lt. p5b) .and. (p5b .le. p10b) .and. (p10b .lt. p6b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p10b_1 - noab - 1 + nvab * (p5
     &b_1 - noab - 1 + nvab * (p9b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p10b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h4b-1),8,7,6,5,4,2,3,1,-1.0d0)
      END IF
      IF ((p9b .lt. p5b) .and. (p6b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p10b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5
     &b_1 - noab - 1 + nvab * (p9b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p10b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h4b-1),8,7,6,5,3,2,4,1,1.0d0)
      END IF
      IF ((p5b .le. p9b) .and. (p10b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p10b_1 - noab - 1 + nvab * (p9
     &b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p10b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h4b-1),8,7,6,5,4,1,3,2,1.0d0)
      END IF
      IF ((p5b .le. p9b) .and. (p9b .lt. p6b) .and. (p6b .le. p10b)) THE
     &N
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p10b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p9
     &b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),int_mb(k_range+p10b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h4b-1),8,7,6,5,3,1,4,2,-1.0d0)
      END IF
      IF ((p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p10b_1 - noab - 1 + nvab * (p9b_1 - noab - 1 + nvab * (p6
     &b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h4b-1),8,7,6,5,2,1,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_t4_11_1',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_t4_11_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_t4_11_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h11b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b
     &-1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_t4_11_1',6,MA_ERR
     &)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p9b .eq. p10b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_t4_11_1',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_t4_11_1',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_t4_11_1',9,MA_ERR)
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h4b-1),int_mb(k_range+h3b-
     &1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p5b-1),8,7,2,1,6,5,4,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(h12b - 1 + noab * (h11b - 1 + noab * (p6b - noab - 1 + nvab * (p5
     &b - noab - 1)))))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_t4_11_1',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_t4_11_1',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

c $Id: intbdd_2e4c.F 23165 2012-11-28 19:07:48Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Computes the 2nd derivative integrals of a block of shell quartets
C> with respect to the nuclear positions
C>
C> Compute the 2nd derivative integrals of a block of shell quartets. Only
C> the non-zero integrals and the corresponding labels are returned. This
C> routine cannot be called without a preceding call to `intbdd_init4c` with
C> the same block information.
C>
C> the integrals evaluated are defined as
C> \f{eqnarray*}{
C> ({\mu}{\rho}|{\nu}{\lambda}) &=& \int_{-\infty}^{\infty} g_{\mu}(X_{\mu},r_{1})g_{\rho}(X_{\rho},r_{1})\frac{1}{r_{12}}g_{\nu}(X_{\nu},r_{2})g_{\lambda}(X_{\lambda},r_{2})dr_{1}dr_{2} \\\\
C> eri(1,*) &=& \frac{\partial^2 ({\mu}{\rho}|{\nu}{\lambda})}{\partial (X_\mu^{x})^2} \\\\
C> &\ldots& \\\\
C> eri(78,*) &=& \frac{\partial^2 ({\mu}{\rho}|{\nu}{\lambda})}{\partial (X_\lambda^{z})^2} \\\\
C> \f}
C>
C> \return Returns .true. if not all integrals fitted in the buffer
C> provided and an additional call to `intbdd_2e4c` is required, and
C> returns .false. if all integrals were retrieved.
C>
      logical function intbdd_2e4c(brain, icl, jcl, ketin, kcl, lcl,
     &     num_q, q4, use_q4, zerotol, canonicalize,
     &     ilab, jlab, klab, llab, eri,
     &     l_erilab, nint, lscr, scr)
      implicit none
#include "numb_qP.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "stdio.fh"
c::functions
      logical intbdd_nw_2e4c
      external intbdd_nw_2e4c
c::passed
c:tex-\begin{verbatim}
      integer brain              !< [Input]  basis set handle for bra 
      integer ketin              !< [Input]  basis set handle for ket 
      integer num_q              !< [Input]  number of quartets input
      integer icl(num_q)         !< [Input]  i-contraction quartet labels
      integer jcl(num_q)         !< [Input]  j-contraction quartet labels
      integer kcl(num_q)         !< [Input]  k-contraction quartet labels
      integer lcl(num_q)         !< [Input]  l-contraction quartet labels
      logical use_q4             !< [Input]  logical for use of q4
      double precision q4(num_q) !< [Input] symmetry prefactors for ints
*     
      integer l_erilab           !< [Input]  length of eri and label arrays
      integer ilab(l_erilab)     !< [Output] integral labels for ``i'' 
      integer jlab(l_erilab)     !< [Output] integral labels for ``j'' 
      integer klab(l_erilab)     !< [Output] integral labels for ``k'' 
      integer llab(l_erilab)     !< [Output] integral labels for ``l'' 
      integer nint               !< [Output] number of integrals returned
      double precision eri(78,l_erilab) !< [Output] integral values
      integer lscr               !< [Input] length of scratch array
      double precision scr(lscr) !< [Input] scratch array
      double precision zerotol   !< [Input] zero integral threshold
      logical canonicalize       !< [Input] Canonicalize integral labels?
c:tex-\end{verbatim}
      
c::local
      double precision roff(3)
c
      intbdd_2e4c = .false.
      if (num_q.eq.0) then
        nint = 0
        return
      endif
      if (txs_b2e4c) then
        call texas_hf2_m(
     &      brain, icl(num_q_start), jcl(num_q_start),
     &      ketin, kcl(num_q_start), lcl(num_q_start), 
     &      num_q-num_q_start+1,
     &      q4(num_q_start), use_q4,
     &      roff,roff,roff,roff,.false.,
     &      eri,l_erilab, ilab, jlab, klab, llab, nint, .true.,
     &      more_ints_txs, scr, lscr, zerotol,'der2_int')
        intbdd_2e4c = more_ints_txs
      else
c
c currently, only texas 2 e- 2nd derivative integrals are available.  The rest
c of these mechanics need to be added in if another integral package becomes
c available (i.e. HONDO)
c
c       intbdd_2e4c = intbdd_nw_2e4c(
c    &      brain, icl, jcl, ketin, kcl, lcl,
c    &      num_q, q4, use_q4, zerotol, canonicalize,
c    &      ilab, jlab, klab, llab, eri,
c    &      l_erilab, nint, lscr, scr)
        write(luout,*)'intbdd_2e4c: could not use the texas '
        write(luout,*)'            integral second derivatives'
        write(luout,*)' Please notify nwchem-support@emsl.pnl.gov with'
        write(luout,*)'        the input deck and output available'
        call errquit('intbdd_2e4c: fatal error',911, INT_ERR)
      endif
c
      return
      end
C>
C> \brief Compute the 2nd derivative integrals of a block of shell quartets
C> using the NWChem McMurchie-Davidson code.
C>
C> Compute and return the non-zero 2nd derivative integrals and corresponding
C> labels based on the input of a group of shell quartets (a block). This 
C> routine explicitly uses the McMurchie-Davidson code, it should \b NEVER
C> be called directly by an application module! Please call `intbdd_2e4c`
C> instead.
C>
      logical function intbdd_nw_2e4c(
     &    brain, icl, jcl, ketin, kcl, lcl,
     &    num_q, q4, use_q4, zerotol, canonicalize,
     &     ilab, jlab, klab, llab, eri,
     &     l_erilab, nint, lscr, scr)
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "numb_qP.fh"
c::functions
      integer int_nint_cart
      external int_nint_cart
c::   passed
c:tex-\begin{verbatim}
      integer brain              !< [Input]  basis set handle for bra 
      integer ketin              !< [Input]  basis set handle for ket 
      integer num_q              !< [Input]  number of quartets input
      integer icl(num_q)         !< [Input]  i-contraction quartet labels
      integer jcl(num_q)         !< [Input]  j-contraction quartet labels
      integer kcl(num_q)         !< [Input]  k-contraction quartet labels
      integer lcl(num_q)         !< [Input]  l-contraction quartet labels
      logical use_q4             !< [Input]  logical for use of q4
      double precision q4(num_q) !< [Input] symmetry prefactors for ints
*     
      integer l_erilab           !< [Input]  length of eri and label arrays
      integer ilab(l_erilab)     !< [Output] integral labels for ``i'' 
      integer jlab(l_erilab)     !< [Output] integral labels for ``j'' 
      integer klab(l_erilab)     !< [Output] integral labels for ``k'' 
      integer llab(l_erilab)     !< [Output] integral labels for ``l'' 
      integer nint               !< [Output] number of integrals returned
      double precision eri(78,l_erilab) !< [Output] integral values
      integer lscr               !< [Input] length of scratch array
      double precision scr(lscr) !< [Input] scratch array
      double precision zerotol   !< [Input] zero integral threshold
      logical canonicalize       !< [Input] Canonicalize integral labels?
c:tex-\end{verbatim}
*
c:local
      integer i_q 
      integer i_scr_ptr
      integer newlscr
      integer idatom(4)
      integer nint_s
      integer numint
      integer ilo, jlo, klo, llo
      integer ihi, jhi, khi, lhi
*
c
      intbdd_nw_2e4c = .true.
*
      if (num_q_start.eq.num_q_last) then
         write(luout,*)' l_erilab: too small ',l_erilab
         call errquit(' intbdd_nw_2e4c: infinite blocking loop ',911,
     &             INT_ERR)
      endif
c
*... only do one quartet of derivative integrals at a time!!
      i_q = num_q_start
      num_q_last = num_q_start
*......
      nint_s = 1
*
      if (.not.bas_cn2bfr(brain,icl(i_q),ilo,ihi))
     &    call errquit(' intbdd_nw_2e4c: cn2bfr failed for ish',911,
     &           INT_ERR)
      nint_s = nint_s*(ihi-ilo+1)       ! i partial block size
*
      if (.not.bas_cn2bfr(brain,jcl(i_q),jlo,jhi))
     &    call errquit(' intbdd_nw_2e4c: cn2bfr failed for jsh',911,
     &              INT_ERR)
      nint_s = nint_s*(jhi-jlo+1)       ! j partial block size
*
      if (.not.bas_cn2bfr(brain,kcl(i_q),klo,khi))
     &    call errquit(' intbdd_nw_2e4c: cn2bfr failed for ksh',911,
     &          INT_ERR)
      nint_s = nint_s*(khi-klo+1)       ! k partial block size
*
      if (.not.bas_cn2bfr(brain,lcl(i_q),llo,lhi))
     &    call errquit(' intbdd_nw_2e4c: cn2bfr failed for lsh',911,
     &           INT_ERR)
      nint_s = nint_s*(lhi-llo+1)       ! l partial block size
*......

      if (nint_s.gt.l_erilab) then
        write(luout,*)' nint_s    = ',nint_s
        write(luout,*)' l_erilab  = ',l_erilab
        call errquit(' intbdd_nw_2e4c: buffer size too small ',911,
     &            INT_ERR)
      endif
      numint = int_nint_cart(                    ! get size of cartesian block
     &    brain,icl(i_q),brain,jcl(i_q),
     &    ketin,kcl(i_q),ketin,lcl(i_q))
      numint = numint*78
      i_scr_ptr = numint + 1
      newlscr   = lscr - numint
      if (newlscr .lt. 0) then
        write(luout,*)' newlscr too small      :',newlscr
        write(luout,*)' lscr                   :',lscr
        write(luout,*)' numint                 :',(numint/78)
        write(luout,*)' numint spherical       :',nint_s
        write(luout,*)' numint hess            :',numint
        write(luout,*)' numint hess spherical  :',(nint_s*78)
        write(luout,*)' i bf size is ',(ihi-ilo+1)
        write(luout,*)' j bf size is ',(jhi-jlo+1)
        write(luout,*)' k bf size is ',(khi-klo+1)
        write(luout,*)' l bf size is ',(lhi-llo+1)
        call errquit('intbdd_nw_2e4c: fatal error',911, INT_ERR)
      endif
*
* use memory copy instead of first part of scratch.  Otherwise scratch is 
* way to big to do derivativeswith sphericals
*
      call intdd_2e4c(
     &    brain,icl(i_q),jcl(i_q),
     &    ketin,kcl(i_q),lcl(i_q),
     &    lscr,scr,
     &    numint,eri,idatom)
      call dcopy (numint,eri,1,scr,1)
      if (nint_s.gt.numint) then
        write(luout,*)' spherical/real size larger than cartesean size'
        write(luout,*)' nint_s = ',nint_s
        write(luout,*)' numint = ',numint
        call errquit('intbdd_nw_2e4c: fatal error ',911, INT_ERR)
      endif
* scr has integral derivatives in nwchem order (nint_s,3,4)      
      nint = 0
      call intbdd_nw_label_copy(scr,eri,nint_s,nint,idatom,
     &    ilo,ihi,jlo,jhi,klo,khi,llo,lhi,
     &    ilab,jlab,klab,llab,
     &    zerotol,canonicalize)
      if (use_q4.and.nint.gt.0) then
        call dscal((nint*78),q4(i_q),eri,1)
      endif
      if (i_q.eq.num_q) then
        num_q_start = 1
        intbdd_nw_2e4c = .false.
      else
        num_q_start = i_q + 1
      endif
c
      end
      subroutine intbdd_nw_label_copy(eri_nworder,eri,nint_s,nint,
     &    idatom,
     &    ilo,ihi,jlo,jhi,klo,khi,llo,lhi,
     &    ilab,jlab,klab,llab,
     &    zerotol,canonicalize)
      implicit none
c::passed
      integer nint_s
      integer nint
      integer idatom(4)
      integer ilo, jlo, klo, llo
      integer ihi, jhi, khi, lhi
      integer ilab(nint_s)
      integer jlab(nint_s)
      integer klab(nint_s)
      integer llab(nint_s)
      double precision zerotol
      logical canonicalize
      double precision eri_nworder(llo:lhi,klo:khi,jlo:jhi,ilo:ihi,3,4)
      double precision eri(3,4,nint_s)
c::local
      integer i, xyz, ii, jj, kk, ll
      double precision val_max
      double precision vals(3,4)
      integer numgt1
*
      call dcopy((78*nint_s),0.0d00,0,eri,1)
      nint = 0
      numgt1 = 0
      do i = 1,4
        if (idatom(i).ge.1) numgt1 = numgt1+1
      enddo
      if (numgt1.eq.0) return
*
c right now there doesn't seem to be any logic in intdd_2e4c to set idatom
c correctly.  May have to zero the buffer before making the call to that
c routine.
c     do i = 1,4
c       if (idatom(i).lt.1) then   ! ensure that unused buffers from idatom are zero
c         call dcopy((3*nint_s),0.0d00,0,
c    &        eri_nworder(llo,klo,jlo,ilo,1,i),1)
c       endif
c     enddo
c
c  The do loop structure needs to be fixed to handle getting 78 matrices
c  The current setup is for the gradient code.
c
      do ii = ilo,ihi
        do jj = jlo,jhi
          do kk = klo,khi
            do ll = llo,lhi
              val_max = 0.0d00
              do i = 1,4
                do xyz = 1,3
*assume: memory copy is cheaper than 2 memory access with stride nint_s ?
*check this out
                  vals(xyz,i) = eri_nworder(ll,kk,jj,ii,xyz,i)
                  val_max = max(val_max,abs(vals(xyz,i)))
                enddo
              enddo
              if (val_max.gt.zerotol) then
                nint = nint + 1
                if (canonicalize) then
                  call int_canon(
     &                ii,        jj,        kk,        ll,
     &                ilab(nint),jlab(nint),klab(nint),llab(nint))
                else
                  ilab(nint) = ii
                  jlab(nint) = jj
                  klab(nint) = kk
                  llab(nint) = ll
                endif
                do i = 1,4
                  do xyz = 1,3
                    eri(xyz,i,nint) = vals(xyz,i)
                  enddo
                enddo
              endif
            enddo
          enddo
        enddo
      enddo
*
      return
      end
C> @}

      subroutine tce_print_x1(d_r1,k_r1_offset,r1_thresh,irrep)
c
c $Id: tce_print_x1.F 20265 2011-05-05 00:09:26Z d3y133 $
c
c Prints the X1 tensor
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r1
      integer p1b
      integer h2b
      integer p1
      integer h2
      integer k_r1_offset
      integer size
      integer l_r1,k_r1
      integer i
      integer irrep
      logical nodezero
      double precision r1_thresh
      character*4 irrep_p,irrep_h
      character*5 spinnames(2),spin_p,spin_h
      data spinnames/'alpha','beta '/
c
      nodezero = (ga_nodeid().eq.0)
      if (nodezero) write(LuOut,9000) 'Singles contributions'
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then 
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
              if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1))
     1          .eq.irrep) then
                size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
                if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1            call errquit('tce_print_x1: MA problem',0,MA_ERR)
                call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1            int_mb(k_r1_offset),((p1b-noab-1)*noab+h2b-1))
                i = 0
                do p1 = 1,int_mb(k_range+p1b-1)
                  do h2 = 1,int_mb(k_range+h2b-1)
                    i = i + 1
                    if (dabs(dbl_mb(k_r1+i-1)).gt.r1_thresh) then
                      call sym_irrepname(geom,int_mb(k_sym+p1b-1)+1,
     1                                   irrep_p)
                      call sym_irrepname(geom,int_mb(k_sym+h2b-1)+1,
     1                                   irrep_h)
                      spin_p = spinnames(int_mb(k_spin+p1b-1))
                      spin_h = spinnames(int_mb(k_spin+h2b-1))
                      if (nodezero) write(LuOut,9010) 
c     1                int_mb(k_offset+p1b-1)+p1,irrep_p,spin_p,
c     2                int_mb(k_offset+h2b-1)+h2,irrep_h,spin_h,
c     3                dbl_mb(k_r1+i-1)
     1                (int_mb(k_mo_index+int_mb(k_offset+p1b-1)+p1-1)+
     1                 2-int_mb(k_spin+p1b-1))/2,
     1                irrep_p,spin_p,
     2                (int_mb(k_mo_index+int_mb(k_offset+h2b-1)+h2-1)+
     1                 2-int_mb(k_spin+h2b-1))/2,
     2                irrep_h,spin_h,
     2                dbl_mb(k_r1+i-1)
                    endif
                  enddo
                enddo
                if (.not.ma_pop_stack(l_r1))
     1            call errquit('tce_print_x1: MA problem',1,MA_ERR)
              endif
            endif
          endif
        enddo
      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9010 format(1x,i5,a4,'(',a5,') --- ',i5,a4,'(',a5,')',f20.10)
      return
      end

      subroutine tce_print_y1(d_r1,k_r1_offset,r1_thresh,irrep)
c
c Prints the Y1 tensor
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r1
      integer p1b
      integer h2b
      integer p1
      integer h2
      integer k_r1_offset
      integer size
      integer l_r1,k_r1
      integer i
      integer irrep
      logical nodezero
      double precision r1_thresh
      character*4 irrep_p,irrep_h
      character*5 spinnames(2),spin_p,spin_h
      data spinnames/'alpha','beta '/
c
      nodezero = (ga_nodeid().eq.0)
      if (nodezero) write(LuOut,9000) 'Singles contributions'
      do h2b = 1,noab
        do p1b = noab+1,noab+nvab
          if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then 
          if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1      +int_mb(k_spin+h2b-1).ne.4)) then
          if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1))
     1      .eq.irrep) then
            size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
            if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1        call errquit('tce_print_y1: MA problem',0,MA_ERR)
            call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1        int_mb(k_r1_offset),((h2b-1)*nvab+p1b-noab-1))
            i = 0
            do p1 = 1,int_mb(k_range+p1b-1)
              do h2 = 1,int_mb(k_range+h2b-1)
                i = i + 1
                if (dabs(dbl_mb(k_r1+i-1)).gt.r1_thresh) then
                  call sym_irrepname(geom,int_mb(k_sym+p1b-1)+1,irrep_p)
                  call sym_irrepname(geom,int_mb(k_sym+h2b-1)+1,irrep_h)
                  spin_p = spinnames(int_mb(k_spin+p1b-1))
                  spin_h = spinnames(int_mb(k_spin+h2b-1))
                  if (nodezero) write(LuOut,9010) 
     1              int_mb(k_offset+p1b-1)+p1,irrep_p,spin_p,
     2              int_mb(k_offset+h2b-1)+h2,irrep_h,spin_h,
     3              dbl_mb(k_r1+i-1)
                endif
              enddo
            enddo
            if (.not.ma_pop_stack(l_r1))
     1        call errquit('tce_print_y1: MA problem',1,MA_ERR)
          endif
          endif
          endif
        enddo
      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9010 format(1x,i5,a4,'(',a5,') --- ',i5,a4,'(',a5,')',f20.10)
      return
      end
c
c
c
c
c
      subroutine tce_print_g1(rtdb,d_r1,k_r1_offset,r1_thresh,irrep_r1)
c
c Prints the G1 tensor
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "rtdb.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer rtdb
      integer d_r1
      integer g1b
      integer g2b
      integer g1
      integer g2
      integer k_r1_offset
      integer size
      integer l_r1,k_r1
      integer i
      integer irrep_r1
      integer eiformat
      logical nodezero
      double precision r1_thresh
      character*4 irrep_g1,irrep_g2
      character*5 spinnames(2),spin_g1,spin_g2
      data spinnames/'alpha','beta '/
c
      if (.not.rtdb_get(rtdb,'tce:eiformat',mt_int,1,eiformat)) then
        eiformat = 1
        if (.not.rtdb_put(rtdb,'tce:eiformat',mt_int,1,eiformat))
     1  call errquit('tce_init: failed to write eiformat',0,RTDB_ERR)
      endif
c
      nodezero = (ga_nodeid().eq.0)
c      if (nodezero) write(LuOut,9000) 'Singles contributions'
      do g2b = 1,noab+nvab
        do g1b = 1,noab+nvab
          if (int_mb(k_spin+g1b-1) .eq. int_mb(k_spin+g2b-1)) then
          if ((.not.restricted).or.(int_mb(k_spin+g1b-1)
     1      +int_mb(k_spin+g2b-1).ne.4)) then
          if (ieor(int_mb(k_sym+g1b-1),int_mb(k_sym+g2b-1))
     1      .eq.irrep_r1) then
            size = int_mb(k_range+g1b-1) * int_mb(k_range+g2b-1)
            if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1        call errquit('tce_print_y1: MA problem',0,MA_ERR)
            call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1        int_mb(k_r1_offset),(g2b-1)*(noab+nvab)+g1b-1)
            i = 0
            do g1 = 1,int_mb(k_range+g1b-1)
             do g2 = 1,int_mb(k_range+g2b-1)
               i = i + 1
               if (dabs(dbl_mb(k_r1+i-1)).gt.r1_thresh) then
                 call sym_irrepname(geom,int_mb(k_sym+g1b-1)+1,irrep_g1)
                 call sym_irrepname(geom,int_mb(k_sym+g2b-1)+1,irrep_g2)
                 spin_g1 = spinnames(int_mb(k_spin+g1b-1))
                 spin_g2 = spinnames(int_mb(k_spin+g2b-1))
                 if ((nodezero).and.(eiformat.eq.1)) then
                   write(LuOut,9011)
     1             int_mb(k_offset+g1b-1)+g1,irrep_g1,spin_g1,
     2             int_mb(k_offset+g2b-1)+g2,irrep_g2,spin_g2,
     3             dbl_mb(k_r1+i-1)
                 elseif ((nodezero).and.(eiformat.eq.2)) then
                   write(LuOut,9012)
     1             int_mb(k_offset+g1b-1)+g1,irrep_g1,spin_g1,
     2             int_mb(k_offset+g2b-1)+g2,irrep_g2,spin_g2,
     3             dbl_mb(k_r1+i-1)
                 elseif ((nodezero).and.(eiformat.eq.3)) then
                   write(LuOut,9013)
     1             int_mb(k_offset+g1b-1)+g1,int_mb(k_sym+g1b-1)+1,
     2             int_mb(k_spin+g1b-1),
     3             int_mb(k_offset+g2b-1)+g2,int_mb(k_sym+g2b-1)+1,
     4             int_mb(k_spin+g2b-1),
     5             dbl_mb(k_r1+i-1)
                 elseif ((nodezero).and.(eiformat.eq.4)) then
                   write(LuOut,9014)
     1             int_mb(k_offset+g1b-1)+g1,
     2             int_mb(k_offset+g2b-1)+g2,
     3             dbl_mb(k_r1+i-1)          
                 endif
               endif
             enddo
            enddo
            if (.not.ma_pop_stack(l_r1))
     1        call errquit('tce_print_y1: MA problem',1,MA_ERR)
          endif
          endif
          endif
        enddo
      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9011 format(1x,i3,a4,'(',a5,') --- ',i3,a4,'(',a5,')',f20.14)
 9012 format(1x,i3,',  ',a4,',',a5,',',i3,',  ',a4,',',a5,',',f20.14)
 9013 format(1x,i3,',',i3,',',i3,',',i3,',',i3,',',i3,',',f20.14)
 9014 format(1x,i3,', ',i3,', ',f20.14)
      return
      end

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     XF3cI_Step12b -- Perform the first 1/3 transformation,
c     accumulating the result for a complete pass through the innermost
c     index.
C
C REVISION
C     $Id: xf3ci_s12b.F 19697 2010-10-29 16:57:34Z d3y133 $
C
C SYNOPSIS
      Subroutine XF3cI_Step12b(UseERI, AOBas, PShLo, PShHi, PDim,
     $   QDim, FitBas, SShLo, SShHi, SDim, Neglect,
     $   Int, LInt, Scr, LScr, IBuf, CQ, QXFLo, QXFHi, G_C,
     $   Interm, Out, LDOut, FLOPs)
      Implicit NONE
#include "errquit.fh"
      Logical UseERI
      Integer AOBas, PShLo, PShHi, PDim, QDim, SDim
      Integer FitBas, SShLo, SShHi, LInt, LScr
      Integer LDOut, QXFLo, QXFHi, G_C
      Double precision Neglect, FLOPs
      Double precision Int(LInt), Scr(LScr), CQ(QDim, QXFHi-QXFLo+1),
     $   IBuf(QDim, PDim, SDim), Interm(QXFHi-QXFLo+1, PDim, SDim),
     $   Out(LDOut, QXFHi-QXFLo+1, SDim)
C
C ARGUMENTS
C     UseERI   Compute 2e3c ERIs (.TRUE.) or 1e3c overlaps [IN]
C     AOBas    Handle for AO basis. [IN]
C     PShLo    Lower limit of shell range of P index [IN]
C     PShHi    Upper limit of shell range of P index [IN]
C     PDim     Space allocated to P index of IBuf (must be at least the
C              number of functions in the range PShLo:PShHi) [IN]
C     QDim     Space allocated to Q index of IBuf
C     FitBas   Handle for fitting basis. [IN]
C     SShLo    Lower limit of shell range of fitting (S) index [IN]
C     SShHi    Upper limit of shell range of fitting (S) index [IN]
C     SDim     Space allocated to S index of IBuf (must be at least the
C              number of functions in the range SShLo:SShHi) [IN]
C     Neglect  Neglect raw integrals smaller than this value [IN]
C     Int      Integral evaluation array for Eval_3ci_Block [scratch]
C     LInt     Length of Int
C     Scr      Integral evaluation scratch array for Eval_3ci_Block [scr]
C     LScr     Length of Scr
C     IBuf     Target integral buffer for Eval_3ci_Block [scratch]
C     CQ       Space for Q index transformation matrix [scratch]
C     QXFLo    Lower limit of MO functions to transform Q into [IN]
C     QXFHi    Upper limit of MO functions to transform Q into [IN]
C     G_C      GA handle for Q index transformation matrix [IN]
C     Interm   Used to hold 1/3 transformed integrals before transposition
C              to (pi|s) organization [scratch]
C     Out      Matrix of 1/3 transformed integrals (pi|s) [OUT]
C     LDOut    Leading dimension of Out [IN]
C     FLOPs    Number of floating point operations performed [INOUT]
C
C DESCRIPTION
C     Performs the first index transformation for three-center integrals,
C     making a complete pass through the Q index for a specified range of
C     P and S functions.  The output is a matrix of integrals (pi|s),
C     where q --> i is the transformation done here.
C
C     The Q index is covered in multiple passes according to the QDim
C     provided by the caller and respecting shell boundaries.  The size
C     QDim governs the contraction length in a matrix multiplication
C     so ideally it should be made large enough to obtain asymptotic
C     performance from the matrix multiplication.
C
C     The structure of the integrals that is to be output would not allow
C     a single large DGEMM in general, so this routine evaluates the 
C     integrals in such a way as to produce the large single DGEMM
C     desired, then transposes the result into the form expected by the
C     parent.  This will slow things a little compared to asymptotic 
C     DGEMM speeds, but unless QDim is very small, it is worth it.

C MEMORY USE
C     All work arrays are provided by parent.
C
C INCLUDE FILES
#include "numerical_constants.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "global.fh"
#include "rimp2_timers.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer P, Q, S, QShLo, QShHi, QBFLo, QBFHi, NQXF, Low, High, MaxQ
      Integer PCenLo, PCenHi, QCenLo, QCenHi
      Logical Status, MustDo
C
      NQXF = QXFHi - QXFLo + 1
      Status = Bas_NumBF( AOBas, MaxQ)
C
      Call dlaset( 'Full', NQXF, PDim*SDim, FP_Zero, FP_Zero,
     $     Interm, NQXF)
C
C     This is the starting place for our romp through the Q space
C
      QBFLo = 1
C
C     This is where we want end up -- careful not to run off the end of
c     the basis, since the inquiry routines don't appreciate that.
C
 1000 QBFHi = Min( QBFLo + QDim - 1, MaxQ)
C
C     Find out what contractions these belong to
C
      Status = Bas_BF2Cn( AOBas, QBFLo, QShLo)
      Status = Bas_BF2Cn( AOBas, QBFHi, QShHi)
C
C     We must be at the beginning of QShLo, so reset QBFLo to guarantee
c     this.
C
      Status = Bas_Cn2BFR( AOBas, QShLo, QBFLo, High)
C
C     And we need to be at the first shell boundary below QBFHi.  This
c     may necessitate backing off one shell if QBFHi is not already on a
c     boundary.
C
      Status = Bas_Cn2BFR( AOBas, QShHi, Low, High)
      If ( High .gt. QBFHi) then
         QShHi = QShHi - 1
         Status = Bas_Cn2BFR( AOBas, QShHi, Low, QBFHi)
      EndIf
C
C     Now (finally) we have a good range to use: QShLo:QShHi, or
c     QBFLo:QBFHi for shells or functions!
C
C     ***************************************
C     * See if we can skip the entire batch *
C     ***************************************
C     Use the atom-level Schwarz info to check that we have work to do
c     at this level.
C
      Status = .TRUE.
      Status = Status .AND. Bas_Cn2Ce( AOBas,  PShLo, PCenLo)
      Status = Status .AND. Bas_Cn2Ce( AOBas,  PShHi, PCenHi)
      Status = Status .AND. Bas_Cn2Ce( AOBas,  QShLo, QCenLo)
      Status = Status .AND. Bas_Cn2Ce( AOBas,  QShHi, QCenHi)
C
      If ( .NOT. Status) Call ErrQuit(
     $   'XF3cI_Step12b: Problems with center inquiries', PSHLo,
     &       BASIS_ERR)
C
      MustDo = .FALSE.
      Do P = PCenLo, PCenHi
         Do Q = QCenLo, QCenHi
            MustDo = MustDo
     $         .OR. (Schwarz_Atom( P, Q) * Schwarz_Max() .gt. Neglect)
         EndDo                  ! Q
      EndDo                     ! P
C
      If ( MustDo ) then
C        
C        ************************************************
C        * Grab the transformation matrix for this pass *
C        ************************************************
C
         Call GA_Get(G_C, QBFlo, QBFhi, QXFlo, QXFhi, CQ, QDim)
C
         Call PStat_On( PS_Int_Gen)
C
         Call Eval_3ci_Block( UseERI, AOBas, QShLo, QShHi, PShLo, PShHi,
     $      FitBas, SShLo, SShHi, Neglect, Int, LInt, Scr, LScr, IBuf,
     $      QDim, PDim, SDim)
C
         Call PStat_Off( PS_Int_Gen)
         Call PStat_On( PS_Step12)
C
C        Transform this block: C_{qi}^T (qp|s) --> (ip|s)
C        
         FLOPs = FLOps + 2 * NQXF * PDim*SDim * (QBFHi-QBFLo+1)
         Call dgemm('T', 'N', NQXF, PDim*SDim, QBFHi-QBFLo+1,
     $      FP_One, CQ, QDim, IBuf, QDim,
     $      FP_One, Interm, NQXF)
C
      Call PStat_Off( PS_Step12)
C     
      EndIf                     ! Schwarz test
C        
C     Pick the next starting point
C
      If ( QBFHi .lt. MaxQ) then
         QBFLo = QBFHi+1
         Goto 1000
      EndIf
C
C     (ip|s) --> (pi|s) (necessary to be able to do a matrix
c     multiplication for the second index too, unfortunately)
C
      Call PStat_On( PS_Step12)
C     
      Do S = 1, SDim
         Call DGECop('T', PDim, NQXF, Interm(1, 1, S), NQXF,
     $      Out(1, 1, S), LDOut)
      EndDo
C     
      Call PStat_Off( PS_Step12)
C
      Return
      End

      SUBROUTINE ccsdt_lr_alpha_offdiag_12_16_2(d_a,k_a_offset,d_b,k_b_o
     &ffset,d_c,k_c_offset)
C     $Id: ccsdt_lr_alpha_offdiag_12_16_2.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h8 h13 )_vcb + = 1 * Sum ( p1 ) * b ( p1 h13 )_b * i3 ( h8 p1 )_vc
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h8b
      INTEGER h13b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER p1b_1
      INTEGER h13b_1
      INTEGER h8b_2
      INTEGER p1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h8b = 1,noab
      DO h13b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h13b-
     &1).ne.4)) THEN
      IF (int_mb(k_spin+h8b-1) .eq. int_mb(k_spin+h13b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),int_mb(k_sym+h13b-1)) .eq. ieor(irrep
     &_v,ieor(irrep_c,irrep_b))) THEN
      dimc = int_mb(k_range+h8b-1) * int_mb(k_range+h13b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_12_16_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h13b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h13b-1)) .eq. irrep_b) T
     &HEN
      CALL TCE_RESTRICTED_2(p1b,h13b,p1b_1,h13b_1)
      CALL TCE_RESTRICTED_2(h8b,p1b,h8b_2,p1b_2)
      dim_common = int_mb(k_range+p1b-1)
      dima_sort = int_mb(k_range+h13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h8b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_12_16_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_12_16_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h13b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &2_16_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_12_16_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_12_16_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (h8b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p1b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &2_16_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_12_16_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_12_16_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_12_16_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h13b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h13b 
     &- 1 + noab * (h8b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &2_16_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_12_16_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine esp_dalloc
c
c $Id: esp_dalloc.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "esp_params.fh"
#include "esp_common.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "bas.fh"
c
      if(.not.ma_pop_stack(l_v))
     + call md_abort('esp: ma_pop_stack v failed',me)
      if(.not.ma_pop_stack(l_g))
     + call md_abort('esp: ma_pop_stack g failed',me)
      if(.not.ma_pop_stack(l_c))
     + call md_abort('esp: ma_pop_stack c failed',me)
      if(.not.ma_pop_stack(l_b))
     + call md_abort('esp: ma_pop_stack b failed',me)
      if(.not.ma_pop_stack(l_ak))
     + call md_abort('esp: ma_pop_stack Ak failed',me)
      if(.not.ma_pop_stack(l_a))
     + call md_abort('esp: ma_pop_stack A failed',me)
      if(.not.ma_pop_stack(l_o))
     + call md_abort('esp: ma_pop_stack o failed',me)
      if(.not.ma_pop_stack(l_e))
     + call md_abort('esp: ma_pop_stack e failed',me)
      if(.not.ma_pop_stack(l_d))
     + call md_abort('esp: ma_pop_stack d failed',me)
      if(.not.ma_pop_stack(l_l))
     + call md_abort('esp: ma_pop_stack l failed',me)
      if(.not.ma_pop_stack(l_n))
     + call md_abort('esp: ma_pop_stack n failed',me)
      if(.not.ma_pop_stack(l_qf))
     + call md_abort('esp: ma_pop_stack qf failed',me)
      if(.not.ma_pop_stack(l_qk))
     + call md_abort('esp: ma_pop_stack qk failed',me)
      if(.not.ma_pop_stack(l_q))
     + call md_abort('esp: ma_pop_stack q failed',me)
      if(.not.ma_pop_stack(l_x))
     + call md_abort('esp: ma_pop_stack x failed',me)
      if(.not.ma_pop_stack(l_t))
     + call md_abort('esp: ma_pop_stack t failed',me)
c
      if(.not.bas_destroy(ibasis))
     + call md_abort('esp: bas_destroy failed',me)
      if(.not.geom_destroy(igeom))
     + call md_abort('esp: geom_destroy failed',me)
c
      return
      end

c
c $Id: pspw_Three.F 25011 2013-12-19 17:45:25Z d3y133 $
c

*     *************************
*     *                       *
*     *     pspw_Three_init   *
*     *                       *
*     *************************
      subroutine pspw_Three_init(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"
#include "pspw_Three.fh"
#include "stdio.fh"
#include "errquit.fh"

*     **** local variables
      logical value
      integer taskid
      integer MASTER
      parameter(MASTER=0)

      integer i,j,l,k,nn,ntriple,shift
      integer nkatm,nkatm_qm,nkatm2
      character*50 rtdbname

*     **** external functions ****
      character*4 ion_atom
      character*7 c_index_name
      integer     ion_nkatm,ion_nkatm_qm
      integer     ion_katm
      external    ion_atom
      external    c_index_name
      external    ion_nkatm,ion_nkatm_qm
      external    ion_katm
      
      nkatm    = ion_nkatm()
      nkatm_qm = ion_nkatm_qm()
      nkatm2 = nkatm*nkatm

      value = rtdb_parallel(.true.)

*     **** determine the ntriples ****
      include_qm = .false.
      ntriples = 0
      do k=1,nkatm
         do j=1,nkatm
            do i=1,nkatm

*          **** check for standard triple potentials ****
           rtdbname='pspw_Three_ion_ion_ion_ntriple:'
     >              //ion_atom(i)//ion_atom(j)//ion_atom(k)
            if (rtdb_get(rtdb,rtdbname,mt_int,1,ntriple)) then
                ntriples = ntriples + ntriple
                if ((i.le.nkatm_qm).and.
     >              (j.le.nkatm_qm).and.
     >              (k.le.nkatm_qm)) 
     >             include_qm = .true.
            end if
         end do
      end do

      if (ntriples.gt.0) then

*        **** allocate Three parameters ****
         value = MA_alloc_get(mt_int,nkatm*nkatm*nkatm,
     >                 'ntriple_all',ntriple_all(2),ntriple_all(1))
         value = value.and.
     >        MA_alloc_get(mt_int,nkatm*nkatm*nkatm,
     >                 'triple_start',triple_start(2),triple_start(1))
         if (.not. value) 
     >   call errquit('pspw_Three_init:out of heap memory',1,MA_ERR)
         call icopy(nkatm*nkatm*nkatm,0,0,int_mb(ntriple_all(1)),1)
         call icopy(nkatm*nkatm*nkatm,0,0,int_mb(triple_start(1)),1)

         value = value.and.
     >        MA_alloc_get(mt_int,ntriples,
     >                 'type_all',type_all(2),type_all(1))
         value = value.and.
     >        MA_alloc_get(mt_dbl,4*ntriples,
     >                 'param_all',param_all(2),param_all(1))
         if (.not. value) 
     >   call errquit('pspw_Three_init:out of heap memory',2,MA_ERR)

*        **** Generate Three potential parameters ****
         nn = 0
         do k=1,nkatm
          do j=1,nkatm
            do i=1,nkatm

*              **** read and add standard pair potentials ****
               rtdbname='pspw_Pair_ion_ion_ion_ntriple:'
     >                  //ion_atom(i)//ion_atom(j)//ion_atom(k)
               if (.not.rtdb_get(rtdb,rtdbname,mt_int,1,ntriple))
     >            ntriple = 0

               shift = (k-1)*nkatm2+(j-1)*nkatm+(i-1)
               int_mb(ntriple_all(1)+shift)  = npair
               int_mb(triple_start(1)+shift) = nn
               do l=1,ntriple
                  rtdbname = 'pspw_Three_ion_ion_ion_type:'
     >                     //c_index_name(l)
     >                     //ion_atom(i)//ion_atom(j)//ion_atom(k)
                  value = value.and.
     >                    rtdb_get(rtdb,rtdbname,mt_int,1,
     >                             int_mb(type_all(1)+nn))

                  rtdbname = 'pspw_Three_ion_ion_ion_param:'
     >                     //c_index_name(l)
     >                     //ion_atom(i)//ion_atom(j)//ion_atom(k)
                  value = value.and.
     >                    rtdb_get(rtdb,rtdbname,mt_dbl,4,
     >                             dbl_mb(param_all(1)+4*nn))
                  nn = nn + 1
               end do

            end do
          end do
         end do

*        **** write out Three potential data ****
         call Parallel_taskid(taskid)
         if (taskid.eq.MASTER) then
             write(luout,*)
     >       'Three-Body Ion-Ion-Ion Parameters (units=a.u.):'
             if (include_qm)
     >          write(luout,*) 
     >          '- including QM/QM Three-Body interactions'
             do i=1,nkatm
             do j=i,nkatm
             do k=j,nkatm
               shift = (k-1)*nkatm2+(j-1)*nkatm+(i-1))
               ntriple = int_mb(ntriple_all(1)+shift)
               nn      = int_mb(triple_start(1)+shift)
               if (ntriple.gt.0) then
                  write(luout,'(A4,1x,A4,1x,A4)') 
     >            ion_atom(i),ion_atom(j),ion_atom(k)

                  do l=1,ntriple
                     if (int_mb(type_all(1)+nn+l-1).eq.1) then

                write(luout,'(4x,A49,E14.6,A5,E14.6,A3,E14.6,A3,E14.6)')
     >              '- Potential=A*exp(-rij/rho)-C/rij**6-D/rij**8, A:',  
     >                    dbl_mb(param_all(1)+4*(nn+l-1)),
     >                    ' rho:',  
     >                    dbl_mb(param_all(1)+4*(nn+l-1)+1),
     >                    ' C:',  
     >                    dbl_mb(param_all(1)+4*(nn+l-1)+2),
     >                    ' D:',  
     >                    dbl_mb(param_all(1)+4*(nn+l-1)+3)

                     end if
                  end do
               endif
             end do
             end do
             end do
             write(luout,*)
         end if

      end if !*** ntriples.gt.0 ****

      return
      end

*     *************************
*     *                       *
*     *     pspw_Three_end    *
*     *                       *
*     *************************
      subroutine pspw_Three_end()
      implicit none

#include "mafdecls.fh"
#include "pspw_Three.fh"
#include "errquit.fh"

      logical value

      if (ntriples.gt.0) then
         value =           MA_free_heap(ntriple_all(2))
         value = value.and.MA_free_heap(triple_start(2))
         value = value.and.MA_free_heap(type_all(2))
         value = value.and.MA_free_heap(param_all(2))
         if (.not.value) 
     >      call errquit('pspw_Three_end: error MA_free_heap',
     >                   0,MA_ERR)
      end if
      return
      end

c     *************************************
c     *                                   *
c     *       pspw_gen_Neighbor_List      *
c     *                                   *
c     *************************************
      subroutine pspw_gen_Neighbor_List(nion,rion,
     >               nshl3d,rcell,
     >               r2max,nlist_max,nlist)
      implicit none
      integer nion
      real*8 rion(3,*)
      integer nshl3d
      real*8 rcell(3,*)
      real*8 rmax
      integer nlist_max,nlist(nlist_max,*)

      ijkmax(1) = 0
      ijkmax(2) = 0
      ijkmax(3) = 0
      ijkmin(1) = 99999
      ijkmin(2) = 99999
      ijkmin(2) = 99999
      imax = 0
      do k=1,nion
         ijk(1,k) = nint(rion(1,k)/rmax)
         ijk(2,k) = nint(rion(2,k)/rmax)
         ijk(3,k) = nint(rion(3,k)/rmax)

         if (ijk(1,k).gt.ijkmax(1)) ijkmax(1) = ijk(1,k)
         if (ijk(2,k).gt.ijkmax(2)) ijkmax(2) = ijk(2,k)
         if (ijk(3,k).gt.ijkmax(3)) ijkmax(3) = ijk(3,k)

         if (ijk(1,k).lt.ijkmin(1)) ijkmin(1) = ijk(1,k)
         if (ijk(2,k).lt.ijkmin(2)) ijkmin(2) = ijk(2,k)
         if (ijk(3,k).lt.ijkmin(3)) ijkmin(3) = ijk(3,k)
      end do
      nijk(1) = ijkmax(1)-ijkmin(1)+1
      nijk(2) = ijkmax(2)-ijkmin(2)+1
      nijk(3) = ijkmax(3)-ijkmin(3)+1

      do k=ijkmin(3),ijkmax(3)
         do j=ijkmin(2),ijkmax(2)
            do i=ijkmin(1),ijkmax(1)
            end do
         end do
      end do

      return
      end



c     *************************************
c     *                                   *
c     *           pspw_Three_E            *
c     *                                   *
c     *************************************
      real*8 function pspw_Three_E(nion,nion_qm,katm,
     >                          nfrag,indx_frag_start,size_frag,kfrag,
     >                          self_interaction,lmbda,
     >                          nshl3d,rcell,
     >                          rion)
      implicit none
      integer nion,nion_qm
      integer katm(*)
      integer nfrag
      integer indx_frag_start(*),size_frag(*)
      integer kfrag(*)
      logical self_interaction(*)
      real*8  lmbda
      integer nshl3d
      real*8  rcell(nshl3d,3)
      real*8  rion(3,*)

#include "mafdecls.fh"
#include "pspw_Three.fh"

*     **** local variables ****
      integer dutask,taskid,np
      integer i,j,ii,jj,nkatm,nkatm2
      integer w1,a,k1,kk1,n1,npair,istart,k
      integer w2,b,k2,kk2
      real*8  E

*     **** external functions ****
      integer  ion_nkatm
      real*8   pspw_VThree_E_periodic,pspw_VThree_E_periodic_self
      real*8   pspw_VThree_E_onecell,pspw_VThree_E_periodic_image
      external ion_nkatm
      external pspw_VThree_E_periodic,pspw_VThree_E_periodic_self
      external pspw_VThree_E_onecell,pspw_VThree_E_periodic_image
      
      call nwpw_timing_start(40)
      E = 0.0d0

      if (ntriple.gt.0) then

      call Parallel_np(np)
      call Parallel_taskid(taskid)
      nkatm = ion_nkatm()
      nkatm2 = nkatm*nkatm

      dutask = 0

c     **** create neighbor list ****
      do k=1,nion
         nlist = 0
         do j=1,nion
            r2 = (rion(1,j)-rion(1,k))**2
               + (rion(2,j)-rion(2,k))**2
               + (rion(3,j)-rion(3,k))**2
            if (r2.le.r2_neighbor) then
               int_mb(list_neighbor(1)+(k-1)*nion+nlist) = j
               nlist = nlist + 1
            end if
         end do
         int_mb(nlist_neighbor(1)+k-1) = nlist
      end do


c     **** QM/QM VThree energy ****
      if (include_qm) then
         do k = 1,nion_qm-1
           if (dutask.eq.taskid) then
              kk = katm(k)

              nlist = int_mb(nlist_neighbor(1)+k-1)
              do r=1,nlist
                 j=int_mb(list_neighbor(1)+(k-1)*nion+r)
                 jj = katm(j)
                 do s=1,nlist
                    i=int_mb(list(1)+(k-1)*nion+s)
                    ii = katm(i)

                     shift = (kk-1)*nkatm2 +(jj-1)*nkatm+ii-1
                     ntriple  = int_mb(ntriple_all(1)+shift)
                     istart = int_mb(pair_start(1)+shift)
                     if (ntriple.gt.0)
     >                  E = E + pspw_VThree_E_periodic(ntriple,
     >                           int_mb(type_all(1) +istart),
     >                           dbl_mb(param_all(1)+4*istart),
     >                           rion(1,i),rion(1,j),rion(1,k)
     >                           nshl3d,rcell)
                 end do
              end do
           end if
           dutask = mod(dutask+1,np)
         end do
      end if

c     **** QM/MM VPower energy ****
      do j = nion_qm+1,nion
         if (dutask.eq.taskid) then
         jj = katm(j)
         do i=1,nion_qm
            ii = katm(i)
            npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
            istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
            if (npair.gt.0)
     >         E = E + pspw_VPair_E_periodic(npair,
     >                        int_mb(type_all(1) +istart),
     >                        dbl_mb(param_all(1)+4*istart),
     >                        rion(1,i),rion(1,j),
     >                        nshl3d,rcell)
         end do
         end if
         dutask = mod(dutask+1,np)
      end do

c     **** MM/MM VPower 1 cell energy ****
      do w1 = 1,nfrag-1
      if (dutask.eq.taskid) then
      do w2 = w1+1,nfrag
         k1 = indx_frag_start(w1)
         k2 = indx_frag_start(w2)
         kk1 = k1
         do a=1,size_frag(w1)
            kk2 = k2
            do b=1,size_frag(w2)
               ii = katm(kk1)
               jj = katm(kk2)
               npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
               istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
               if (npair.gt.0) 
     >            E = E + pspw_VPair_E_onecell(npair,
     >                        int_mb(type_all(1) +istart),
     >                        dbl_mb(param_all(1)+4*istart),
     >                        rion(1,kk1),rion(1,kk2))
               kk2 = kk2 + 1
            end do
            kk1 = kk1 + 1
         end do
      end do
      end if
      dutask = mod(dutask+1,np)
      end do

c     **** MM/MM VPower self energy ****
      do w1=1,nfrag
         if (self_interaction(kfrag(w1))) then
         if (dutask.eq.taskid) then
           k1 = indx_frag_start(w1)
           n1 = size_frag(w1)
           kk1 = k1
           do a=1,n1-1
             kk2 = kk1 + 1
             do b=a+1,n1
               ii = katm(kk1)
               jj = katm(kk2)
               npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
               istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
               if (npair.gt.0)
     >            E = E + pspw_VPair_E_onecell(npair,
     >                        int_mb(type_all(1) +istart),
     >                        dbl_mb(param_all(1)+4*istart),
     >                        rion(1,kk1),rion(1,kk2))
               kk2 = kk2 + 1
             end do
             kk1 = kk1 + 1
           end do
         end if
         dutask = mod(dutask+1,np)
         end if
      end do

c     **** MM/MM VPair self image energy ****
      if (nshl3d.gt.1) then

      do j = nion_qm+1,nion
       if (dutask.eq.taskid) then
         jj = katm(j)
         npair  = int_mb(npair_all(1) +(jj-1)*nkatm+jj-1)
         istart = int_mb(pair_start(1)+(jj-1)*nkatm+jj-1)
         if (npair.gt.0)
     >      E = E + pspw_VPair_E_periodic_image(npair,
     >                  int_mb(type_all(1) +istart),
     >                  dbl_mb(param_all(1)+4*istart),
     >                  nshl3d,rcell)

       end if
       dutask = mod(dutask+1,np)
      end do


c     **** MM/MM VPair image energy ****
      do j = (nion_qm+1),(nion-1)
         if (dutask.eq.taskid) then
         jj = katm(j)
         do i=j+1,nion
            ii = katm(i)
            npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
            istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
            if (npair.gt.0)
     >         E = E + pspw_VPair_E_periodic_self(npair,
     >                  int_mb(type_all(1) +istart),
     >                  dbl_mb(param_all(1)+4*istart),
     >                  rion(1,i),rion(1,j),
     >                  nshl3d,rcell)
         end do
         end if
         dutask = mod(dutask+1,np)
      end do

      end if

      if (np.gt.1) call Parallel_SumAll(E)

      end if !*** npairs.gt.0 ***

      call nwpw_timing_end(40)

      pspw_Pair_E = E
      return
      end



c     *********************************************
c     *                                           *
c     *              pspw_VPair_E_onecell        *
c     *                                           *
c     *********************************************

      real*8 function pspw_VPair_E_onecell(n,t,p,r1,r2)
      implicit none
      integer n,t(*)
      real*8 p(4,*)
      real*8 r1(3)
      real*8 r2(3)

*     **** local variables ****
      integer k
      real*8  dx,dy,dz,r
      real*8  E,u,u6,u12

      dx = r1(1) - r2(1)
      dy = r1(2) - r2(2)
      dz = r1(3) - r2(3)
      r = dsqrt(dx**2 + dy**2 + dz**2)

      E = 0.0d0
      do k=1,n
         if (t(k).eq.1) then
            u   = (p(2,k)/r)
            u6  = u**6
            u12 = u6**2
            E = E + 4.0d0*p(1,k)*(u12-u6)
         else if (t(k).eq.2) then
            E = E + p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6
         else if (t(k).eq.3) then
            E = E + p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6 - p(4,k)/r**8
         else if (t(k).eq.4) then
            E = E + p(1,k)*( (r-p(2,k))**p(3,k) )
         else if (t(k).eq.5) then
            E = E + p(1,k)*dexp(-r/p(2,k))
         else if (t(k).eq.6) then
            E = E + p(1,k)*(1.0d0-dexp(-p(2,k)*(r-p(3,k))))**2
         endif
      end do

      pspw_VPair_E_onecell = E
      return
      end


c     *********************************************
c     *                                           *
c     *              pspw_VPair_E_periodic        *
c     *                                           *
c     *********************************************

      real*8 function pspw_VPair_E_periodic(n,t,p,r1,r2,
     >                                    nshl3d,rcell)
      implicit none
      integer n,t(*)
      real*8  p(4,*)
      real*8  r1(3)
      real*8  r2(3)
      integer nshl3d
      real*8  rcell(nshl3d,3)

*     **** local variables ****
      integer l,k
      real*8  dx,dy,dz
      real*8  x,y,z,r
      real*8  E,u,u6,u12

      E         = 0.0d0
      dx = r1(1) - r2(1)
      dy = r1(2) - r2(2)
      dz = r1(3) - r2(3)
      do l=1,nshl3d
         x = dx + rcell(l,1)
         y = dy + rcell(l,2)
         z = dz + rcell(l,3)
         r = dsqrt(x**2 + y**2 + z**2)
         do k=1,n
            if (t(k).eq.1) then
               u   = (p(2,k)/r)
               u6  = u**6
               u12 = u6**2
               E = E + 4.0d0*p(1,k)*(u12-u6)
            else if (t(k).eq.2) then
               E = E + p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6
            else if (t(k).eq.3) then
               E = E+ p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6 - p(4,k)/r**8
            else if (t(k).eq.4) then
                E = E + p(1,k)*( (r-p(2,k))**p(3,k) )
            else if (t(k).eq.5) then
                E = E + p(1,k)*dexp(-r/p(2,k))
            else if (t(k).eq.6) then
                E = E + p(1,k)*(1.0d0-dexp(-p(2,k)*(r-p(3,k))))**2
            endif
         end do
      end do
      pspw_VPair_E_periodic = E
      return
      end


c     *********************************************
c     *                                           *
c     *         pspw_VPair_E_periodic_self        *
c     *                                           *
c     *********************************************
      real*8 function pspw_VPair_E_periodic_self(n,t,p,r1,r2,
     >                                         nshl3d,rcell)
      implicit none
      integer n,t(*)
      real*8 p(4,*)
      real*8 r1(3)
      real*8 r2(3)
      integer nshl3d
      real*8  rcell(nshl3d,3)

*     **** local variables ****
      integer l,k
      real*8  dx,dy,dz
      real*8  x,y,z,r
      real*8  E,u,u6,u12

      E         = 0.0d0
      dx = r1(1) - r2(1)
      dy = r1(2) - r2(2)
      dz = r1(3) - r2(3)
      do l=2,nshl3d
         x = dx + rcell(l,1)
         y = dy + rcell(l,2)
         z = dz + rcell(l,3)
         r = dsqrt(x**2 + y**2 + z**2)
         do k=1,n
            if (t(k).eq.1) then
               u   = (p(2,k)/r)
               u6  = u**6
               u12 = u6**2
               E = E + 4.0d0*p(1,k)*(u12-u6)
            else if (t(k).eq.2) then
               E = E + p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6
            else if (t(k).eq.3) then
               E = E+ p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6 - p(4,k)/r**8
            else if (t(k).eq.4) then
               E = E + p(1,k)*( (r-p(2,k))**p(3,k) )
            else if (t(k).eq.5) then
               E = E + p(1,k)*dexp(-r/p(2,k))
            else if (t(k).eq.6) then
                E = E + p(1,k)*(1.0d0-dexp(-p(2,k)*(r-p(3,k))))**2
            endif
         end do
      end do

      pspw_VPair_E_periodic_self = E
      return
      end

c     *********************************************
c     *                                           *
c     *           pspw_VPair_E_periodic_image    *
c     *                                           *
c     *********************************************
      real*8 function pspw_VPair_E_periodic_image(n,t,p,nshl3d,rcell)
      implicit none
      integer n,t(*)
      real*8 p(4,*)
      integer nshl3d
      real*8  rcell(nshl3d,3)

*     **** local variables ****
      integer l,k
      real*8  x,y,z,r
      real*8  E,u,u6,u12

      E = 0.0d0
      do l=2,nshl3d
         x = rcell(l,1)
         y = rcell(l,2)
         z = rcell(l,3)
         r = dsqrt(x**2 + y**2 + z**2)
         do k=1,n
            if (t(k).eq.1) then
               u   = (p(2,k)/r)
               u6  = u**6
               u12 = u6**2
               !E = E + 4.0d0*p(1,k)*(u12-u6)
               E = E + 2.0d0*p(1,k)*(u12-u6)
            else if (t(k).eq.2) then
               !E = E + p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6
               E = E + 0.5d0*p(1,k)*dexp(-r/p(2,k)) - p(3,k)/r**6
            else if (t(k).eq.3) then
               E=E+0.5d0*p(1,k)*dexp(-r/p(2,k))-p(3,k)/r**6-p(4,k)/r**8
            else if (t(k).eq.4) then
               !E = E +p(1,k)*( (r-p(2,k))**p(3,k) )
               E = E + 0.5d0*p(1,k)*( (r-p(2,k))**p(3,k) )
            else if (t(k).eq.5) then
               !E = E + p(1,k)*dexp( r/p(2,k) )
               E = E + 0.5d0*p(1,k)*dexp(-r/p(2,k))
            else if (t(k).eq.6) then
                E = E+0.50d0*p(1,k)*(1.0d0-dexp(-p(2,k)*(r-p(3,k))))**2
            endif
         end do
      end do
      pspw_VPair_E_periodic_image = E
      return
      end




c     *************************************
c     *                                   *
c     *           pspw_Pair_fion          *
c     *                                   *
c     *************************************
      subroutine pspw_Pair_fion(nion,nion_qm,katm,
     >                        nfrag,indx_frag_start,size_frag,
     >                        kfrag,
     >                        self_interaction,lmbda,
     >                        nshl3d,rcell,
     >                        rion,fion)
      implicit none
      integer nion,nion_qm
      integer katm(*)
      integer nfrag
      integer indx_frag_start(*),size_frag(*) 
      integer kfrag(*)
      logical self_interaction(*)
      real*8  lmbda
      integer nshl3d
      real*8  rcell(nshl3d,3)
      real*8  rion(3,*)
      real*8  fion(3,*)

#include "mafdecls.fh"
#include "pspw_Pair.fh"

*     **** local variables ****
      integer dutask,taskid,np
      integer i,j,ii,jj,nkatm,npair,istart
      integer w1,a,k1,kk1,n1
      integer w2,b,k2,kk2
      real*8  e1,s1,e2,s2

*     **** external functions ****
      integer  ion_nkatm
      external ion_nkatm

      call nwpw_timing_start(40)

      if (npairs.gt.0) then

      call Parallel_np(np)
      call Parallel_taskid(taskid)
      nkatm = ion_nkatm()
      dutask = 0

c     **** QM/QM Pair force ****
      if (include_qm) then
         do j = 1,nion_qm-1
            if (dutask.eq.taskid) then
            jj = katm(j)
            do i=j+1,nion_qm
               ii = katm(i)
               npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
               istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
               if (npair.gt.0) 
     >            call pspw_VPair_fion_periodic(npair,
     >                             int_mb(type_all(1)+istart),
     >                             dbl_mb(param_all(1)+4*istart),
     >                             rion(1,i),fion(1,i),
     >                             rion(1,j),fion(1,j),
     >                             nshl3d,rcell)
            end do
            end if
            dutask = mod(dutask+1,np)
         end do
      end if

c     **** QM/MM LJ energy ****
      do j = nion_qm+1,nion
         if (dutask.eq.taskid) then
         jj = katm(j)
         do i=1,nion_qm
            ii = katm(i)
            npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
            istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
            if (npair.gt.0) 
     >         call pspw_VPair_fion_periodic(npair,
     >                             int_mb(type_all(1) +istart),
     >                             dbl_mb(param_all(1)+4*istart),
     >                             rion(1,i),fion(1,i),
     >                             rion(1,j),fion(1,j),
     >                             nshl3d,rcell)
         end do
         end if
         dutask = mod(dutask+1,np)
      end do

c     **** MM/MM LJ 1 cell energy ****
      do w1 = 1,nfrag-1
      if (dutask.eq.taskid) then
      do w2 = w1+1,nfrag
         k1 = indx_frag_start(w1)
         k2 = indx_frag_start(w2)
         kk1 = k1
         do a=1,size_frag(w1)
            kk2 = k2
            do b=1,size_frag(w2)
               ii = katm(kk1)
               jj = katm(kk2)
               npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
               istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
               if (npair.gt.0) 
     >            call pspw_VPair_fion_onecell(npair,
     >                             int_mb(type_all(1) +istart),
     >                             dbl_mb(param_all(1)+4*istart),
     >                             rion(1,kk1),fion(1,kk1),
     >                             rion(1,kk2),fion(1,kk2))
               kk2 = kk2 + 1
            end do
            kk1 = kk1 + 1
         end do
      end do
      end if
      dutask = mod(dutask+1,np)
      end do

c     **** MM/MM Pair self energy ****
      do w1=1,nfrag
         if (self_interaction(kfrag(w1))) then
         if (dutask.eq.taskid) then
           k1 = indx_frag_start(w1)
           n1 = size_frag(w1)
           kk1 = k1
           do a=1,n1-1
             kk2 = kk1 + 1
             do b=a+1,n1
               ii = katm(kk1)
               jj = katm(kk2)
               npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
               istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
               if (npair.gt.0) 
     >            call pspw_VPair_fion_onecell(npair,
     >                             int_mb(type_all(1) +istart),
     >                             dbl_mb(param_all(1)+4*istart),
     >                             rion(1,kk1),fion(1,kk1),
     >                             rion(1,kk2),fion(1,kk2))
               kk2 = kk2 + 1
             end do
             kk1 = kk1 + 1
           end do
         end if
         dutask = mod(dutask+1,np)
         end if
      end do

      if (nshl3d.gt.1) then

c     **** MM/MM Pair self image energy - no force ****
c     **** MM/MM Pair image energy ****
      do j = (nion_qm+1),(nion-1)
         if (dutask.eq.taskid) then
         jj = katm(j)
         do i=j+1,nion
            ii = katm(i)
            npair  = int_mb(npair_all(1) +(jj-1)*nkatm+ii-1)
            istart = int_mb(pair_start(1)+(jj-1)*nkatm+ii-1)
            if (npair.gt.0) 
     >         call pspw_VPair_fion_periodic_self(npair,
     >                             int_mb(type_all(1) +istart),
     >                             dbl_mb(param_all(1)+4*istart),
     >                             rion(1,i),fion(1,i),
     >                             rion(1,j),fion(1,j),
     >                             nshl3d,rcell)
         end do
         end if
         dutask = mod(dutask+1,np)
      end do

      end if !*** nshl3d.gt.1 ***

      end if !*** npairs.gt.0 ***


      call nwpw_timing_end(40)
      return
      end


c     *********************************************
c     *                                           *
c     *           pspw_VPair_fion_periodic        *
c     *                                           *
c     *********************************************
      subroutine pspw_VPair_fion_periodic(n,t,p,
     >                                  r1,f1,r2,f2,
     >                                  nshl3d,rcell)
      implicit none
      integer n,t(*)
      real*8 p(4,*)
      real*8 r1(3),f1(3)
      real*8 r2(3),f2(3)
      integer nshl3d
      real*8  rcell(nshl3d,3)

*     **** local variables ****
      integer l,k
      real*8  dx,dy,dz
      real*8  x,y,z,r
      real*8  dVPair,u,u6,u12

      dx = r1(1) - r2(1)
      dy = r1(2) - r2(2)
      dz = r1(3) - r2(3)
      do l=1,nshl3d
         x = dx + rcell(l,1)
         y = dy + rcell(l,2)
         z = dz + rcell(l,3)
         r = dsqrt(x**2 + y**2 + z**2)
         do k=1,n
            if (t(k).eq.1) then
               u = (p(2,k)/r)
               u6  = u**6
               u12 = u6**2
               dVPair = -(4.0d0*p(1,k)/r)*(12.0d0*u12-6.0d0*u6)
            else if (t(k).eq.2) then
               dVPair= -p(1,k)/p(2,k)*dexp(-r/p(2,k))+6.0d0*p(3,k)/r**7
            else if (t(k).eq.3) then
               dVPair= -p(1,k)/p(2,k)*dexp(-r/p(2,k))+6.0d0*p(3,k)/r**7
     >                                               +8.0d0*p(4,k)/r**9
            else if (t(k).eq.4) then
               dVPair =  p(1,k)*p(3,k)*( (r-p(2,k))**(p(3,k)-1.0d0) )
            else if (t(k).eq.5) then
               dVPair = -p(1,k)/p(2,k)*dexp(-r/p(2,k))
            else if (t(k).eq.6) then
               dVpair = 2.0d0*p(1,k)*(1.0d0-dexp(-p(2,k)*(r-p(3,k))))
     >                       *p(2,k)*dexp(-p(2,k)*(r-p(3,k)))
            else
               dVPair = 0.0d0
            endif
            f1(1) = f1(1) - (x/r)*dVPair
            f1(2) = f1(2) - (y/r)*dVPair
            f1(3) = f1(3) - (z/r)*dVPair
            f2(1) = f2(1) + (x/r)*dVPair
            f2(2) = f2(2) + (y/r)*dVPair
            f2(3) = f2(3) + (z/r)*dVPair
         end do
      end do

      return
      end



c     *********************************************
c     *                                           *
c     *      pspw_VPair_fion_periodic_self       *
c     *                                           *
c     *********************************************
      subroutine pspw_VPair_fion_periodic_self(n,t,p,
     >                                       r1,f1,r2,f2,
     >                                       nshl3d,rcell)
      implicit none
      integer n,t(*)
      real*8  p(4,*)
      real*8 r1(3),f1(3)
      real*8 r2(3),f2(3)
      integer nshl3d
      real*8  rcell(nshl3d,3)

*     **** local variables ****
      integer l,k
      real*8  dx,dy,dz
      real*8  x,y,z,r
      real*8  dVPair,u,u6,u12

      dx = r1(1) - r2(1)
      dy = r1(2) - r2(2)
      dz = r1(3) - r2(3)
      do l=2,nshl3d
         x = dx + rcell(l,1)
         y = dy + rcell(l,2)
         z = dz + rcell(l,3)
         r = dsqrt(x**2 + y**2 + z**2)
         do k=1,n
            if (t(k).eq.1) then
               u = (p(2,k)/r)
               u6  = u**6
               u12 = u6**2
               dVPair = -(4.0d0*p(1,k)/r)*(12.0d0*u12-6.0d0*u6)
            else if (t(k).eq.2) then
               dVPair= -p(1,k)/p(2,k)*dexp(-r/p(2,k))+6.0d0*p(3,k)/r**7
            else if (t(k).eq.3) then
               dVPair= -p(1,k)/p(2,k)*dexp(-r/p(2,k))+6.0d0*p(3,k)/r**7
     >                                               +8.0d0*p(4,k)/r**9
            else if (t(k).eq.4) then
               dVPair = p(1,k)*p(3,k)*( (r-p(2,k))**(p(3,k)-1.0d0) )
            else if (t(k).eq.5) then
               dVPair = -p(1,k)/p(2,k)*dexp(-r/p(2,k))
            else if (t(k).eq.6) then
               dVpair = 2.0d0*p(1,k)*(1.0d0-dexp(-p(2,k)*(r-p(3,k))))
     >                       *p(2,k)*dexp(-p(2,k)*(r-p(3,k)))
            else
               dVPair = 0.0d0
            endif
            f1(1) = f1(1) - (x/r)*dVPair
            f1(2) = f1(2) - (y/r)*dVPair
            f1(3) = f1(3) - (z/r)*dVPair
            f2(1) = f2(1) + (x/r)*dVPair
            f2(2) = f2(2) + (y/r)*dVPair
            f2(3) = f2(3) + (z/r)*dVPair
         end do
      end do

      return
      end


c     *********************************************
c     *                                           *
c     *          pspw_VPair_fion_onecell          *
c     *                                           *
c     *********************************************
      subroutine pspw_VPair_fion_onecell(n,t,p,r1,f1,r2,f2)
      implicit none
      integer n,t(*)
      real*8 p(4,*)
      real*8 r1(3),f1(3)
      real*8 r2(3),f2(3)

*     **** local variables ****
      integer k
      real*8  x,y,z,r
      real*8  dVPair,u,u6,u12

      x = r1(1) - r2(1)
      y = r1(2) - r2(2)
      z = r1(3) - r2(3)
      r = dsqrt(x**2 + y**2 + z**2)
      do k=1,n
         if (t(k).eq.1) then
            u = (p(2,k)/r)
            u6  = u**6
            u12 = u6**2
            dVPair = -(4.0d0*p(1,k)/r)*(12.0d0*u12-6.0d0*u6)
         else if (t(k).eq.2) then
            dVPair= -p(1,k)/p(2,k)*dexp(-r/p(2,k))+6.0d0*p(3,k)/r**7
         else if (t(k).eq.3) then
            dVPair= -p(1,k)/p(2,k)*dexp(-r/p(2,k))+6.0d0*p(3,k)/r**7
     >                                            +8.0d0*p(4,k)/r**9
         else if (t(k).eq.4) then
            dVPair =  p(1,k)*p(3,k)*( (r-p(2,k))**(p(3,k)-1.0d0) )
         else if (t(k).eq.5) then
            dVPair = -p(1,k)/p(2,k)*dexp(-r/p(2,k))
         else if (t(k).eq.6) then
            dVpair = 2.0d0*p(1,k)*(1.0d0-dexp(-p(2,k)*(r-p(3,k))))
     >                    *p(2,k)*dexp(-p(2,k)*(r-p(3,k)))
         else
            dVpair = 0.0d0
         endif
         f1(1) = f1(1) - (x/r)*dVPair
         f1(2) = f1(2) - (y/r)*dVPair
         f1(3) = f1(3) - (z/r)*dVPair
         f2(1) = f2(1) + (x/r)*dVPair
         f2(2) = f2(2) + (y/r)*dVPair
         f2(3) = f2(3) + (z/r)*dVPair
      end do

      return
      end

      SUBROUTINE stpr_uprcase (ANSWER)
c $Id: stpr_uprcase.f 19708 2010-10-29 18:04:21Z d3y133 $
C
C     Converts ANSWER to upper case letters.
C
      CHARACTER*(*) ANSWER
      IA=ICHAR('a')
      IZ=ICHAR('z')
      IDIF=ICHAR('A')-IA
      DO 10 I=1,LEN(ANSWER)
        J=ICHAR(ANSWER(I:I))
        IF ((J.GE.IA).AND.(J.LE.IZ)) ANSWER(I:I)=CHAR(J+IDIF)
   10 CONTINUE
      RETURN
      END

      SUBROUTINE ccsdt_y_tr1_14(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: ccsdt_y_tr1_14.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h2 p1 )_vtry + = 1/2 * Sum ( p15 p12 h13 h14 h11 ) * y ( h11 h13 h14 p1 p12 p15 )_y * i1 ( h2 p12 p15 h11 h13 h14 )_vtr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h11b
      INTEGER h13b
      INTEGER h14b
      INTEGER p12b
      INTEGER p15b
      INTEGER h11b_1
      INTEGER h13b_1
      INTEGER h14b_1
      INTEGER p1b_1
      INTEGER p12b_1
      INTEGER p15b_1
      INTEGER h2b_2
      INTEGER p12b_2
      INTEGER p15b_2
      INTEGER h11b_2
      INTEGER h13b_2
      INTEGER h14b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperh(3)
      INTEGER isuperh
      INTEGER nsubp(2)
      INTEGER isubp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h2b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &v,ieor(irrep_tr,irrep_y))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h11b = 1,noab
      DO h13b = h11b,noab
      DO h14b = h13b,noab
      DO p12b = noab+1,noab+nvab
      DO p15b = p12b,noab+nvab
      IF (int_mb(k_spin+h11b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b
     &-1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p12b-1)+int_mb(k_spin+
     &p15b-1)) THEN
      IF (ieor(int_mb(k_sym+h11b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_m
     &b(k_sym+h14b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p12b-1)
     &,int_mb(k_sym+p15b-1)))))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_6(h11b,h13b,h14b,p1b,p12b,p15b,h11b_1,h13b_1,h
     &14b_1,p1b_1,p12b_1,p15b_1)
      CALL TCE_RESTRICTED_6(h2b,p12b,p15b,h11b,h13b,h14b,h2b_2,p12b_2,p1
     &5b_2,h11b_2,h13b_2,h14b_2)
      dim_common = int_mb(k_range+h11b-1) * int_mb(k_range+h13b-1) * int
     &_mb(k_range+h14b-1) * int_mb(k_range+p12b-1) * int_mb(k_range+p15b
     &-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr1_14',2,MA_ERR)
      IF ((p15b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p15b_1 - noab - 1 + nvab * (p12b_1 - noab - 
     &1 + nvab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (h11b_1 - 1))
     &)))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+p12
     &b-1),int_mb(k_range+p15b-1),int_mb(k_range+p1b-1),6,5,4,3,2,1,1.0d
     &0)
      END IF
      IF ((p12b .lt. p1b) .and. (p1b .le. p15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p12b_1 - noab - 
     &1 + nvab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (h11b_1 - 1))
     &)))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+p12
     &b-1),int_mb(k_range+p1b-1),int_mb(k_range+p15b-1),5,6,4,3,2,1,-1.0
     &d0)
      END IF
      IF ((p1b .le. p12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p1b_1 - noab - 
     &1 + nvab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (h11b_1 - 1))
     &)))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+p1b
     &-1),int_mb(k_range+p12b-1),int_mb(k_range+p15b-1),4,6,5,3,2,1,1.0d
     &0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr1_14',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr1_14',5,MA_ERR)
      IF ((h2b .le. p12b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h14b_
     &2 - 1 + noab * (h13b_2 - 1 + noab * (h11b_2 - 1 + noab * (p15b_2 -
     & noab - 1 + nvab * (p12b_2 - noab - 1 + nvab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+p15b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),1,3,2,6,5,4,1.0d
     &0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr1_14',6,MA_ERR
     &)
      nsuperh(1) = 1
      nsuperh(2) = 1
      nsuperh(3) = 1
      isuperh = 1
      IF (h11b .eq. h13b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      IF (h13b .eq. h14b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      nsubp(1) = 1
      nsubp(2) = 1
      isubp = 1
      IF (p12b .eq. p15b) THEN
      nsubp(isubp) = nsubp(isubp) + 1
      ELSE
      isubp = isubp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,12.0d0/FACTORIAL
     &(nsuperh(1))/FACTORIAL(nsuperh(2))/FACTORIAL(nsuperh(3))/FACTORIAL
     &(nsubp(1))/FACTORIAL(nsubp(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(
     &k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr1_14',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr1_14',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr1_14',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p1b-1),1,2,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h2b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr1_14',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr1_14',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine rohf_rotate_movecs(step, g_search)
*
* $Id: rohf_rotate.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "cscf.fh"
c
      double precision step
      integer g_search
c
c     Rotate the movecs (ga handle in common) by exp(step*search)
c
      integer g_tmp
      double precision scale
c
      if (step .ne. 0.0d0) then
         if (.not. ga_create(MT_DBL, nbf, nmo, 
     $        'rohf_rotate_movecs: tmp', 32, 32, g_tmp)) call errquit
     $        ('rohf_rotate_movecs: ga create failed', nbf, GA_ERR)
         call ga_dscal(g_search, step)
         call rohf_k2cf(basis, nbf, nmo, nclosed,
     $        nopen, g_search, g_movecs, g_tmp)
         scale = 1.0d0/step
         call ga_dscal(g_search, scale)
         call ga_copy(g_tmp, g_movecs)
         if (.not. ga_destroy(g_tmp)) call errquit
     $        ('rohf_nr_solve: tmp?', 0, GA_ERR)
      endif
c     
      end

      subroutine smd_charge_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_charge,sp_param,sp_atom,sp_type
      character*32 tag,pname
      character*255 filename
      logical result

      pname = "smd_charge_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "charge"
      call smd_system_get_component(sp_charge,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_charge_init(sp_charge)
      call smd_chargefile_input(filename,result)
      if(result) then
        call smd_charge_read(filename) 
      else
        call smd_charge_set()
      end if
c
      return
      end

      subroutine smd_charge_init(sp_charge)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_charge_data.fh"
c     
      character*(*) sp_charge
c
      character*32 pname
      character*255 filename
      integer na
c
      integer ndims, type, ga_charges
      integer dims(1), chunk(1)
      integer rtdb
c
      pname = "smd_charge_init"
c
c      write(*,*) "in "//pname
c
      type = MT_DBL
      ndims = 1
c
c     get total number of atoms 
c     -------------------------
      call smd_atom_ntot(na)
      if(na.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)
c
c     create charge data structures
c     ---------------------------
      call smd_namespace_create(sp_charge)
      call smd_data_create(sp_charge,"charge",na,MT_DBL)
      return
      end

      subroutine smd_charge_set()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 pname,tag
      integer na
      logical result
      integer i_q,i_q0,i_id
      integer i,j
      double precision q0
c
      pname = "smd_charge_set"
c
c      write(*,*) "in "//pname
c
      tag = "charge"
      call smd_get_ind_size(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      tag = "param:charge"
      call smd_get_ind(tag,i_q0,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "type:id"
      call smd_get_ind(tag,i_id,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      do i=1,na
       j=int_mb(i_id+i-1)
       q0=dbl_mb(i_q0+j-1)
       dbl_mb(i_q+i-1)=q0
      end do

      return
      end

      subroutine smd_charge_ga_set_all()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer nr
      integer i
      character*36 pname
      logical mode
c
      pname = "smd_charge_ga_set_all"
c
c      write(pname,*)"smd_charge_ga_set_all",ga_nodeid()
c
c      write(*,*) "1 in "//pname, ga_nodeid()
c      call util_flush(6)

      call smd_system_nres(nr)

c      mode = rtdb_parallel(.false.)
      do i=1,nr
       call smd_charge_ga_set(i)
      end do
c      mode = rtdb_parallel(mode)

c      write(*,*) "2 in "//pname, ga_nodeid()
c      call util_flush(6)
c      call smd_charge_ga_print()
      return
      end

      subroutine smd_charge_ga_get_all()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer nr
      integer i
      character*32 pname
c
      pname = "smd_charge_ga_get_all"
c
c      write(*,*) "in "//pname

      call smd_system_nres(nr)

      do i=1,nr
       call smd_charge_ga_get(i)
      end do

      return
      end

      subroutine smd_charge_ga_set(im)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer im
      character*32 sp_charge
      character*32 sp_atom
c
      character*32 pname,tag
      logical result
      integer i_q,i_q0,i_id
      integer i,j
      double precision q0
      integer rtdb,ga_charges
      integer na,nm,i0
      integer lo(1), hi(1), ld(1)
      integer i_ir
c
      pname = "smd_charge_ga_set"
c      write(pname,*) "smd_charge_ga_set",ga_nodeid()
c
c      write(*,*) "in "//pname
c      call util_flush(6)
c
      tag = "charge"
      call smd_system_get_component(sp_charge,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


c
      tag = "charge"
      call smd_get_ind_size(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      tag = "atom:resid"
      call smd_get_ind(tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

c      write(*,*) "9 "//pname
c      call util_flush(6)
 
      call smd_charge_ga_handle(ga_charges)
      call smd_geom_monomer_index_size(im,na,int_mb(i_ir),nm,i0)

      lo(1) = i0
      hi(1) = i0+nm-1
      ld(1) = 1
c      write(*,*) "10 "//pname
c      call util_flush(6)
      call nga_put(ga_charges,lo, hi, dbl_mb(i_q+i0-1), ld)

c      write(*,*) "out "//pname
c      call util_flush(6)
      return
      end

      subroutine smd_charge_ga_set1(im)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer im
      character*32 sp_charge
      character*32 sp_atom
c
      character*32 pname,tag
      logical result
      integer i_q,i_q0,i_id
      integer i,j
      double precision q0
      integer rtdb,ga_charges
      integer na,nm,i0
      integer lo(1), hi(1), ld(1)
      integer i_ir
c
      pname = "smd_charge_ga_set1"
c      write(pname,*) "smd_charge_ga_set",ga_nodeid()
c
c      write(*,*) "in "//pname
c      call util_flush(6)
c
c
      tag = "charge"
      call smd_get_ind_size(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      tag = "atom:resid"
      call smd_get_ind(tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      call smd_charge_ga_handle(ga_charges)
      call smd_geom_monomer_index_size(im,na,int_mb(i_ir),nm,i0)

      lo(1) = i0
      hi(1) = i0+nm-1
      ld(1) = 1
c      write(*,*) "10 "//pname
c      call util_flush(6)
      call nga_put(ga_charges,lo, hi, dbl_mb(i_q+i0-1), ld)

c      write(6,*) "updated charges from", ga_nodeid()
c      write(6,*) "monomer",im,i0,nm
c      call smd_util_print_charge_array(6,na,lo(1),hi(1),
c     >                           dbl_mb(i_q))

c      write(*,*) "out "//pname
c      call util_flush(6)
      return
      end

      subroutine smd_charge_ga_get(im)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer im
      character*32 sp_charge
      character*32 sp_atom
c
      character*32 pname,tag
      logical result
      integer i_q,i_q0,i_id
      integer i,j
      double precision q0
      integer rtdb,ga_charges
      integer na,nm,i0
      integer lo(1), hi(1), ld(1)
      integer i_ir
c
      pname = "smd_charge_ga_get"
c
c      write(*,*) "in "//pname
c
c
      tag = "charge"
      call smd_get_ind_size(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      tag = "atom:resid"
      call smd_get_ind(tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
 
      call smd_geom_monomer_index_size(im,na,int_mb(i_ir),nm,i0)
      call smd_charge_ga_handle(ga_charges)

      lo(1) = i0
      hi(1) = i0+nm-1
      ld(1) = 1
      call nga_get(ga_charges,lo, hi, dbl_mb(i_q+i0-1), ld)

      return
      end

      subroutine smd_charge_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer un
c
      character*72 sp_charge
      character*32 pname,tag
      integer na
      logical result
      integer i_q
      integer i
c
      pname = "smd_charge_print"
c
c      write(*,*) "in "//pname
c
      tag = "charge"
      call smd_get_ind_size(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      do i=1,na
       write(un,*) i,dbl_mb(i_q+i-1)
      end do

      return
      end

      subroutine smd_charge_write(filename)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) filename
c
      integer un
      character*72 sp_charge
      character*32 pname,tag
      integer na
      logical result
      integer i_q
      integer i
c
      pname = "smd_charge_write"
c
c      write(*,*) "in "//pname
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
      open(unit=un,status="unknown",form="formatted",file=filename)
c
      tag = "charge"
      call smd_get_ind_size(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      do i=1,na
       write(un,*) dbl_mb(i_q+i-1)
      end do

      close(un)

      return
      end

      subroutine smd_charge_write_default()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(255) filename
      logical result
      call smd_chargefile_output(filename,result)
c
      write(*,*) "writing charge to",filename
      if(result) then
        call smd_charge_write(filename) 
      end if
      return
      end

      subroutine smd_charge_read(filename)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) filename
c
      integer un
      character*72 sp_charge
      character*32 pname,tag
      integer na
      logical result
      integer i_q
      integer i
c
      pname = "smd_charge_read"
c
c      write(*,*) "in "//pname
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
      open(unit=un,status="old",form="formatted",file=filename)
c
      tag = "charge"
      call smd_get_ind_size(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      do i=1,na
       read(un,*) dbl_mb(i_q+i-1)
      end do

      close(un)

      return
      end

      subroutine smd_charge_ga_print()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 pname,tag
      logical result
      integer rtdb,ga_charges
c
      pname = "smd_charge_ga_print"
c
c      write(*,*) "in "//pname

c      call smd_rtdb_get_handle(rtdb)
c      if (.not.rtdb_get(rtdb,"ga_charges",mt_int,1,ga_charges)) 
c     >      call errquit(pname//'failed to store ga_charges',0,
c     >       RTDB_ERR)

      call smd_charge_ga_handle(ga_charges)
      call ga_print_distribution(ga_charges)
      call ga_print(ga_charges)

      return
      end

      subroutine smd_charge_ga_handle(ga_handle)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "smd_charge_data.fh"
c     
      integer ga_handle
c     
      ga_handle = smd_charge_ga
      return
      end

      subroutine smd_chargefile_output(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_chargefile_input"

      result = .true.
      call smd_rtdb_get_string("smd:charge:output",1,
     >                           filename,result)

      end

      subroutine smd_chargefile_input(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_chargefile_input"

      result = .true.
      call smd_rtdb_get_string("smd:charge:input",1,
     >                           filename,result)

      end
c $Id: smd_charge.F 22502 2012-05-20 06:11:57Z d3y133 $

*> \brief \b DGELQ2 computes the LQ factorization of a general rectangular matrix using an unblocked algorithm.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DGELQ2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dgelq2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dgelq2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dgelq2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DGELQ2( M, N, A, LDA, TAU, WORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, LDA, M, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DGELQ2 computes an LQ factorization of a real m by n matrix A:
*> A = L * Q.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix A.  M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the m by n matrix A.
*>          On exit, the elements on and below the diagonal of the array
*>          contain the m by min(m,n) lower trapezoidal matrix L (L is
*>          lower triangular if m <= n); the elements above the diagonal,
*>          with the array TAU, represent the orthogonal matrix Q as a
*>          product of elementary reflectors (see Further Details).
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is DOUBLE PRECISION array, dimension (min(M,N))
*>          The scalar factors of the elementary reflectors (see Further
*>          Details).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (M)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup doubleGEcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The matrix Q is represented as a product of elementary reflectors
*>
*>     Q = H(k) . . . H(2) H(1), where k = min(m,n).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**T
*>
*>  where tau is a real scalar, and v is a real vector with
*>  v(1:i-1) = 0 and v(i) = 1; v(i+1:n) is stored on exit in A(i,i+1:n),
*>  and tau in TAU(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DGELQ2( M, N, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, K
      DOUBLE PRECISION   AII
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARF, DLARFG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGELQ2', -INFO )
         RETURN
      END IF
*
      K = MIN( M, N )
*
      DO 10 I = 1, K
*
*        Generate elementary reflector H(i) to annihilate A(i,i+1:n)
*
         CALL DLARFG( N-I+1, A( I, I ), A( I, MIN( I+1, N ) ), LDA,
     $                TAU( I ) )
         IF( I.LT.M ) THEN
*
*           Apply H(i) to A(i+1:m,i:n) from the right
*
            AII = A( I, I )
            A( I, I ) = ONE
            CALL DLARF( 'Right', M-I, N-I+1, A( I, I ), LDA, TAU( I ),
     $                  A( I+1, I ), LDA, WORK )
            A( I, I ) = AII
         END IF
   10 CONTINUE
      RETURN
*
*     End of DGELQ2
*
      END
c $Id: dgelq2.f 24343 2013-06-22 05:35:15Z d3y133 $

      SUBROUTINE ccsdtq_lambda3(d_f1,d_i0,d_t1,d_t2,d_t3,d_v2,d_y1,d_y2,
     &d_y3,d_y4,k_f1_offset,k_i0_offset,k_t1_offset,k_t2_offset,k_t3_off
     &set,k_v2_offset,k_y1_offset,k_y2_offset,k_y3_offset,k_y4_offset)
C     $Id: ccsdtq_lambda3.F 19700 2010-10-29 17:11:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1 * P( 9 ) * y ( h4 p1 )_y * v ( h5 h6 p2 p3 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = 1 * P( 9 ) * y ( h4 h5 p1 p2 )_y * i1 ( h6 p3 )_f
C         i1 ( h4 p1 )_f + = 1 * f ( h4 p1 )_f
C         i1 ( h4 p1 )_vt + = 1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h4 h8 p1 p7 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( h9 ) * y ( h4 h9 p1 p2 )_y * i1 ( h5 h6 h9 p3 )_v
C         i1 ( h4 h5 h9 p1 )_v + = 1 * v ( h4 h5 h9 p1 )_v
C         i1 ( h4 h5 h9 p1 )_vt + = -1 * Sum ( p7 ) * t ( p7 h9 )_t * v ( h4 h5 p1 p7 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( p7 ) * y ( h4 h5 p1 p7 )_y * v ( h6 p7 p2 p3 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = -1 * P( 3 ) * Sum ( h11 ) * y ( h4 h5 h11 p1 p2 p3 )_y * i1 ( h6 h11 )_f
C         i1 ( h4 h11 )_f + = 1 * f ( h4 h11 )_f
C         i1 ( h4 h11 )_ft + = 1 * Sum ( p7 ) * t ( p7 h11 )_t * i2 ( h4 p7 )_f
C             i2 ( h4 p7 )_f + = 1 * f ( h4 p7 )_f
C             i2 ( h4 p7 )_vt + = 1 * Sum ( h10 p9 ) * t ( p9 h10 )_t * v ( h4 h10 p7 p9 )_v
C         i1 ( h4 h11 )_vt + = 1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h4 h8 h11 p7 )_v
C         i1 ( h4 h11 )_vt + = -1/2 * Sum ( h10 p7 p8 ) * t ( p7 p8 h10 h11 )_t * v ( h4 h10 p7 p8 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = 1 * P( 3 ) * Sum ( p12 ) * y ( h4 h5 h6 p1 p2 p12 )_y * i1 ( p12 p3 )_f
C         i1 ( p12 p1 )_f + = 1 * f ( p12 p1 )_f
C         i1 ( p12 p1 )_vt + = -1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h8 p12 p1 p7 )_v
C         i1 ( p12 p1 )_vt + = 1/2 * Sum ( h9 h10 p8 ) * t ( p8 p12 h9 h10 )_t * v ( h9 h10 p1 p8 )_v
C         i1 ( p12 p1 )_vtt + = -1 * Sum ( h8 ) * t ( p12 h8 )_t * i2 ( h8 p1 )_vt
C             i2 ( h8 p1 )_vt + = 1 * Sum ( h10 p9 ) * t ( p9 h10 )_t * v ( h8 h10 p1 p9 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1/2 * P( 3 ) * Sum ( h12 h11 ) * y ( h4 h11 h12 p1 p2 p3 )_y * i1 ( h5 h6 h11 h12 )_v
C         i1 ( h4 h5 h11 h12 )_v + = 1 * v ( h4 h5 h11 h12 )_v
C         i1 ( h4 h5 h11 h12 )_vt + = -2 * Sum ( p7 ) * t ( p7 h11 )_t * i2 ( h4 h5 h12 p7 )_v
C             i2 ( h4 h5 h12 p7 )_v + = 1 * v ( h4 h5 h12 p7 )_v
C             i2 ( h4 h5 h12 p7 )_vt + = -1/2 * Sum ( p9 ) * t ( p9 h12 )_t * v ( h4 h5 p7 p9 )_v
C         i1 ( h4 h5 h11 h12 )_vt + = 1/2 * Sum ( p7 p8 ) * t ( p7 p8 h11 h12 )_t * v ( h4 h5 p7 p8 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( h12 p9 ) * y ( h4 h5 h12 p1 p2 p9 )_y * i1 ( h6 p9 h12 p3 )_v
C         i1 ( h4 p9 h12 p1 )_v + = 1 * v ( h4 p9 h12 p1 )_v
C         i1 ( h4 p9 h12 p1 )_vt + = -1 * Sum ( p7 ) * t ( p7 h12 )_t * v ( h4 p9 p1 p7 )_v
C         i1 ( h4 p9 h12 p1 )_vt + = -1 * Sum ( h10 p8 ) * t ( p8 p9 h10 h12 )_t * v ( h4 h10 p1 p8 )_v
C         i1 ( h4 p9 h12 p1 )_vtt + = 1 * Sum ( h10 ) * t ( p9 h10 )_t * i2 ( h4 h10 h12 p1 )_vt
C             i2 ( h4 h10 h12 p1 )_vt + = 1 * Sum ( p7 ) * t ( p7 h12 )_t * v ( h4 h10 p1 p7 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1/2 * P( 3 ) * Sum ( p8 p7 ) * y ( h4 h5 h6 p1 p7 p8 )_y * v ( p7 p8 p2 p3 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = 1 * Sum ( h14 p15 ) * y ( h4 h5 h6 h14 p1 p2 p3 p15 )_y * i1 ( p15 h14 )_f
C         i1 ( p15 h14 )_f + = 1 * f ( p15 h14 )_f
C         i1 ( p15 h14 )_ft + = -1 * Sum ( h13 ) * t ( p15 h13 )_t * i2 ( h13 h14 )_f
C             i2 ( h13 h14 )_f + = 1 * f ( h13 h14 )_f
C             i2 ( h13 h14 )_ft + = 1 * Sum ( p7 ) * t ( p7 h14 )_t * i3 ( h13 p7 )_f
C                 i3 ( h13 p7 )_f + = 1 * f ( h13 p7 )_f
C                 i3 ( h13 p7 )_vt + = -1 * Sum ( h12 p11 ) * t ( p11 h12 )_t * v ( h12 h13 p7 p11 )_v
C             i2 ( h13 h14 )_vt + = -1 * Sum ( h10 p9 ) * t ( p9 h10 )_t * v ( h10 h13 h14 p9 )_v
C             i2 ( h13 h14 )_vt + = 1/2 * Sum ( h10 p7 p8 ) * t ( p7 p8 h10 h14 )_t * v ( h10 h13 p7 p8 )_v
C         i1 ( p15 h14 )_ft + = 1 * Sum ( p11 ) * t ( p11 h14 )_t * i2 ( p15 p11 )_f
C             i2 ( p15 p11 )_f + = 1 * f ( p15 p11 )_f
C             i2 ( p15 p11 )_vt + = 1 * Sum ( h10 p9 ) * t ( p9 h10 )_t * v ( h10 p15 p9 p11 )_v
C             i2 ( p15 p11 )_vt + = -1/2 * Sum ( h9 h10 p8 ) * t ( p8 p15 h9 h10 )_t * v ( h9 h10 p8 p11 )_v
C         i1 ( p15 h14 )_vt + = -1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h8 p15 h14 p7 )_v
C         i1 ( p15 h14 )_ft + = 1 * Sum ( h9 p8 ) * t ( p8 p15 h9 h14 )_t * i2 ( h9 p8 )_f
C             i2 ( h9 p8 )_f + = 1 * f ( h9 p8 )_f
C             i2 ( h9 p8 )_vt + = 1 * Sum ( h12 p11 ) * t ( p11 h12 )_t * v ( h9 h12 p8 p11 )_v
C         i1 ( p15 h14 )_vt + = 1/2 * Sum ( h9 h10 p8 ) * t ( p8 p15 h9 h10 )_t * v ( h9 h10 h14 p8 )_v
C         i1 ( p15 h14 )_vt + = 1/2 * Sum ( h10 p7 p8 ) * t ( p7 p8 h10 h14 )_t * v ( h10 p15 p7 p8 )_v
C         i1 ( p15 h14 )_vt + = 1/4 * Sum ( h11 h12 p8 p9 ) * t ( p8 p9 p15 h11 h12 h14 )_t * v ( h11 h12 p8 p9 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1/2 * P( 3 ) * Sum ( h13 h16 p15 ) * y ( h4 h5 h13 h16 p1 p2 p3 p15 )_y * i1 ( h6 p15 h13 h16 )_v
C         i1 ( h4 p15 h13 h16 )_v + = -1 * v ( h4 p15 h13 h16 )_v
C         i1 ( h4 p15 h13 h16 )_vt + = 1 * Sum ( h11 ) * t ( p15 h11 )_t * i2 ( h4 h11 h13 h16 )_v
C             i2 ( h4 h11 h13 h16 )_v + = 1 * v ( h4 h11 h13 h16 )_v
C             i2 ( h4 h11 h13 h16 )_vt + = 2 * Sum ( p7 ) * t ( p7 h16 )_t * i3 ( h4 h11 h13 p7 )_v
C                 i3 ( h4 h11 h13 p7 )_v + = 1 * v ( h4 h11 h13 p7 )_v
C                 i3 ( h4 h11 h13 p7 )_vt + = -1/2 * Sum ( p9 ) * t ( p9 h13 )_t * v ( h4 h11 p7 p9 )_v
C             i2 ( h4 h11 h13 h16 )_vt + = 1/2 * Sum ( p7 p8 ) * t ( p7 p8 h13 h16 )_t * v ( h4 h11 p7 p8 )_v
C         i1 ( h4 p15 h13 h16 )_vt + = -2 * Sum ( p7 ) * t ( p7 h16 )_t * i2 ( h4 p15 h13 p7 )_v
C             i2 ( h4 p15 h13 p7 )_v + = 1 * v ( h4 p15 h13 p7 )_v
C             i2 ( h4 p15 h13 p7 )_vt + = -1/2 * Sum ( p9 ) * t ( p9 h13 )_t * v ( h4 p15 p7 p9 )_v
C         i1 ( h4 p15 h13 h16 )_ft + = -1 * Sum ( p9 ) * t ( p9 p15 h13 h16 )_t * i2 ( h4 p9 )_f
C             i2 ( h4 p9 )_f + = 1 * f ( h4 p9 )_f
C             i2 ( h4 p9 )_vt + = 1 * Sum ( h12 p11 ) * t ( p11 h12 )_t * v ( h4 h12 p9 p11 )_v
C         i1 ( h4 p15 h13 h16 )_vt + = -2 * Sum ( h10 p8 ) * t ( p8 p15 h10 h16 )_t * i2 ( h4 h10 h13 p8 )_v
C             i2 ( h4 h10 h13 p8 )_v + = 1 * v ( h4 h10 h13 p8 )_v
C             i2 ( h4 h10 h13 p8 )_vt + = -1 * Sum ( p11 ) * t ( p11 h13 )_t * v ( h4 h10 p8 p11 )_v
C         i1 ( h4 p15 h13 h16 )_vt + = -1/2 * Sum ( p7 p8 ) * t ( p7 p8 h13 h16 )_t * v ( h4 p15 p7 p8 )_v
C         i1 ( h4 p15 h13 h16 )_vt + = 1/2 * Sum ( h12 p8 p9 ) * t ( p8 p9 p15 h12 h13 h16 )_t * v ( h4 h12 p8 p9 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1/2 * P( 3 ) * Sum ( h14 p13 p15 ) * y ( h4 h5 h6 h14 p1 p2 p13 p15 )_y * i1 ( p13 p15 h14 p3 )_v
C         i1 ( p13 p15 h14 p1 )_v + = -1 * v ( p13 p15 h14 p1 )_v
C         i1 ( p13 p15 h14 p1 )_vt + = 1 * Sum ( p7 ) * t ( p7 h14 )_t * v ( p13 p15 p1 p7 )_v
C         i1 ( p13 p15 h14 p1 )_vt + = -1/2 * Sum ( h9 h10 ) * t ( p13 p15 h9 h10 )_t * i2 ( h9 h10 h14 p1 )_v
C             i2 ( h9 h10 h14 p1 )_v + = 1 * v ( h9 h10 h14 p1 )_v
C             i2 ( h9 h10 h14 p1 )_vt + = -1 * Sum ( p11 ) * t ( p11 h14 )_t * v ( h9 h10 p1 p11 )_v
C         i1 ( p13 p15 h14 p1 )_vt + = -2 * Sum ( h10 p8 ) * t ( p8 p15 h10 h14 )_t * v ( h10 p13 p1 p8 )_v
C         i1 ( p13 p15 h14 p1 )_vt + = 1/2 * Sum ( h11 h12 p9 ) * t ( p9 p13 p15 h11 h12 h14 )_t * v ( h11 h12 p1 p9 )_v
C         i1 ( p13 p15 h14 p1 )_vtt + = -2 * Sum ( h10 ) * t ( p15 h10 )_t * i2 ( h10 p13 h14 p1 )_vt
C             i2 ( h10 p13 h14 p1 )_vt + = -1 * Sum ( p7 ) * t ( p7 h14 )_t * v ( h10 p13 p1 p7 )_v
C         i1 ( p13 p15 h14 p1 )_vtt + = 2 * Sum ( h12 ) * t ( p13 h12 )_t * i2 ( h12 p15 h14 p1 )_vt
C             i2 ( h12 p15 h14 p1 )_vt + = 1 * Sum ( h10 p8 ) * t ( p8 p15 h10 h14 )_t * v ( h10 h12 p1 p8 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = -1 * P( 9 ) * Sum ( h13 ) * i1 ( h4 h5 h13 p1 )_yt * v ( h6 h13 p2 p3 )_v
C         i1 ( h4 h5 h13 p1 )_yt + = -1 * Sum ( p7 ) * t ( p7 h13 )_t * y ( h4 h5 p1 p7 )_y
C         i1 ( h4 h5 h13 p1 )_yt + = 1/2 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h13 )_t * y ( h4 h5 h9 p1 p7 p8 )_y
C         i1 ( h4 h5 h13 p1 )_yt + = -1/12 * Sum ( h11 h10 p9 p8 p7 ) * t ( p7 p8 p9 h10 h11 h13 )_t * y ( h4 h5 h10 h11 p1 p7 p8 p9 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytf + = -1 * P( 3 ) * Sum ( h7 ) * i1 ( h4 h5 h6 h7 p1 p2 )_yt * f ( h7 p3 )_f
C         i1 ( h4 h5 h6 h7 p1 p2 )_yt + = 1 * Sum ( p8 ) * t ( p8 h7 )_t * y ( h4 h5 h6 p1 p2 p8 )_y
C         i1 ( h4 h5 h6 h7 p1 p2 )_yt + = 1/2 * Sum ( h10 p9 p8 ) * t ( p8 p9 h7 h10 )_t * y ( h4 h5 h6 h10 p1 p2 p8 p9 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = 1 * P( 9 ) * Sum ( h10 h12 ) * i1 ( h4 h5 h10 h12 p1 p2 )_yt * v ( h6 h12 h10 p3 )_v
C         i1 ( h4 h5 h10 h12 p1 p2 )_yt + = 1 * Sum ( p7 ) * t ( p7 h12 )_t * y ( h4 h5 h10 p1 p2 p7 )_y
C         i1 ( h4 h5 h10 h12 p1 p2 )_yt + = 1/2 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h12 )_t * y ( h4 h5 h9 h10 p1 p2 p7 p8 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = 1 * P( 3 ) * Sum ( h12 p10 ) * i1 ( h4 h5 h6 h12 p1 p10 )_yt * v ( h12 p10 p2 p3 )_v
C         i1 ( h4 h5 h6 h12 p1 p10 )_yt + = -1 * Sum ( p7 ) * t ( p7 h12 )_t * y ( h4 h5 h6 p1 p7 p10 )_y
C         i1 ( h4 h5 h6 h12 p1 p10 )_yt + = -1/2 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h12 )_t * y ( h4 h5 h6 h9 p1 p7 p8 p10 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = 1 * P( 3 ) * Sum ( h10 h8 p9 ) * i1 ( h4 h5 h6 h10 h8 p1 p2 p9 )_yt * v ( h8 p9 h10 p3 )_v
C         i1 ( h4 h5 h6 h10 h8 p1 p2 p9 )_yt + = 1 * Sum ( p7 ) * t ( p7 h8 )_t * y ( h4 h5 h6 h10 p1 p2 p7 p9 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = 1/2 * P( 9 ) * Sum ( p13 ) * i1 ( h4 p13 p1 p2 )_yt * v ( h5 h6 p3 p13 )_v
C         i1 ( h4 p13 p1 p2 )_yt + = -1 * Sum ( h10 h9 p7 ) * t ( p7 p13 h9 h10 )_t * y ( h4 h9 h10 p1 p2 p7 )_y
C         i1 ( h4 p13 p1 p2 )_yt + = 1/6 * Sum ( h12 h11 h10 p8 p7 ) * t ( p7 p8 p13 h10 h11 h12 )_t * y ( h4 h10 h11 h12 p1 p2 p7 p8 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = -1/4 * P( 3 ) * Sum ( h14 h15 ) * i1 ( h4 h5 h6 h14 h15 p1 )_yt * v ( h14 h15 p2 p3 )_v
C         i1 ( h4 h5 h6 h14 h15 p1 )_yt + = -1 * Sum ( p8 p7 ) * t ( p7 p8 h14 h15 )_t * y ( h4 h5 h6 p1 p7 p8 )_y
C         i1 ( h4 h5 h6 h14 h15 p1 )_yt + = -1/3 * Sum ( h10 p9 p8 p7 ) * t ( p7 p8 p9 h10 h14 h15 )_t * y ( h4 h5 h6 h10 p1 p7 p8 p9 )_y
C         i1 ( h4 h5 h6 h14 h15 p1 )_ytt + = 2 * Sum ( p7 ) * t ( p7 h14 )_t * i2 ( h4 h5 h6 h15 p1 p7 )_yt
C             i2 ( h4 h5 h6 h15 p1 p7 )_yt + = -1 * Sum ( p9 ) * t ( p9 h15 )_t * y ( h4 h5 h6 p1 p7 p9 )_y
C         i1 ( h4 h5 h6 h14 h15 p1 )_ytt + = 2 * Sum ( p11 ) * t ( p11 h15 )_t * i2 ( h4 h5 h6 h14 p1 p11 )_yt
C             i2 ( h4 h5 h6 h14 p1 p11 )_yt + = -1 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h14 )_t * y ( h4 h5 h6 h9 p1 p7 p8 p11 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = 1/2 * P( 3 ) * Sum ( h11 p8 ) * i1 ( h4 h11 p8 p1 p2 p3 )_yt * v ( h5 h6 h11 p8 )_v
C         i1 ( h4 h11 p8 p1 p2 p3 )_yt + = -1 * Sum ( h10 h9 p7 ) * t ( p7 p8 h9 h10 )_t * y ( h4 h9 h10 h11 p1 p2 p3 p7 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = 1/2 * P( 9 ) * Sum ( p8 p11 ) * i1 ( h4 h5 p8 p1 p2 p11 )_yt * v ( h6 p11 p3 p8 )_v
C         i1 ( h4 h5 p8 p1 p2 p11 )_yt + = 1 * Sum ( h10 h9 p7 ) * t ( p7 p8 h9 h10 )_t * y ( h4 h5 h9 h10 p1 p2 p7 p11 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_vty + = 1/12 * P( 3 ) * Sum ( p7 h10 h11 h12 ) * y ( h4 h10 h11 h12 p1 p2 p3 p7 )_y * i1 ( h5 h6 p7 h10 h11 h12 )_vt
C         i1 ( h4 h5 p7 h10 h11 h12 )_vt + = 1 * Sum ( p8 p9 ) * t ( p7 p8 p9 h10 h11 h12 )_t * v ( h4 h5 p8 p9 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_vty + = 1/4 * P( 9 ) * Sum ( p7 p8 h10 h11 ) * y ( h4 h5 h10 h11 p1 p2 p7 p8 )_y * i1 ( h6 p7 p8 h10 h11 p3 )_vt
C         i1 ( h4 p7 p8 h10 h11 p1 )_vt + = 1 * Sum ( h12 p9 ) * t ( p7 p8 p9 h10 h11 h12 )_t * v ( h4 h12 p1 p9 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yttv + = -1/2 * P( 3 ) * Sum ( h11 h8 h10 ) * i1 ( h4 h5 h6 h11 h8 h10 p1 p2 )_ytt * v ( h8 h10 h11 p3 )_v
C         i1 ( h4 h5 h6 h11 h8 h10 p1 p2 )_ytt + = 1 * Sum ( p7 ) * t ( p7 h8 )_t * i2 ( h4 h5 h6 h11 h10 p1 p2 p7 )_yt
C             i2 ( h4 h5 h6 h11 h10 p1 p2 p7 )_yt + = 1 * Sum ( p9 ) * t ( p9 h10 )_t * y ( h4 h5 h6 h11 p1 p2 p7 p9 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_yttv + = -1/2 * P( 3 ) * Sum ( p8 p11 ) * i1 ( h4 p8 p11 p1 p2 p3 )_ytt * v ( h5 h6 p8 p11 )_v
C         i1 ( h4 p8 p11 p1 p2 p3 )_ytt + = 1 * Sum ( h12 ) * t ( p11 h12 )_t * i2 ( h4 h12 p8 p1 p2 p3 )_yt
C             i2 ( h4 h12 p8 p1 p2 p3 )_yt + = -1 * Sum ( h10 h9 p7 ) * t ( p7 p8 h9 h10 )_t * y ( h4 h9 h10 h12 p1 p2 p3 p7 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_yttv + = -1/2 * P( 9 ) * Sum ( p14 h13 ) * i1 ( h4 h5 p14 h13 p1 p2 )_ytt * v ( h6 h13 p3 p14 )_v
C         i1 ( h4 h5 p14 h13 p1 p2 )_ytt + = 1 * Sum ( h12 ) * t ( p14 h12 )_t * i2 ( h4 h5 h12 h13 p1 p2 )_yt
C             i2 ( h4 h5 h12 h13 p1 p2 )_yt + = 1 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h13 )_t * y ( h4 h5 h9 h12 p1 p2 p7 p8 )_y
C         i1 ( h4 h5 p14 h13 p1 p2 )_ytt + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p14 h9 h10 )_t * i2 ( h4 h5 h9 h10 h13 p1 p2 p7 )_yt
C             i2 ( h4 h5 h9 h10 h13 p1 p2 p7 )_yt + = 1 * Sum ( p11 ) * t ( p11 h13 )_t * y ( h4 h5 h9 h10 p1 p2 p7 p11 )_y
C     i0 ( h4 h5 h6 p1 p2 p3 )_yttv + = 1/2 * P( 3 ) * Sum ( p13 h10 h12 ) * i1 ( h4 h5 h6 p13 h10 h12 p1 p2 )_ytt * v ( h10 h12 p3 p13 )_v
C         i1 ( h4 h5 h6 p13 h10 h12 p1 p2 )_ytt + = 1 * t ( p13 h12 )_t * i2 ( h4 h5 h6 h10 p1 p2 )_yt
C             i2 ( h4 h5 h6 h10 p1 p2 )_yt + = 1 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h10 )_t * y ( h4 h5 h6 h9 p1 p2 p7 p8 )_y
C         i1 ( h4 h5 h6 p13 h10 h12 p1 p2 )_yttt + = 1 * Sum ( h8 ) * t ( p13 h8 )_t * i2 ( h4 h5 h6 h8 h10 h12 p1 p2 )_ytt
C             i2 ( h4 h5 h6 h8 h10 h12 p1 p2 )_ytt + = 1 * Sum ( p9 ) * t ( p9 h10 )_t * i3 ( h4 h5 h6 h8 h12 p1 p2 p9 )_yt
C                 i3 ( h4 h5 h6 h8 h12 p1 p2 p9 )_yt + = 1 * Sum ( p11 ) * t ( p11 h12 )_t * y ( h4 h5 h6 h8 p1 p2 p9 p11 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_y3
      INTEGER k_y3_offset
      INTEGER d_y4
      INTEGER k_y4_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER l_i2_offset
      INTEGER size_i2
      INTEGER d_t3
      INTEGER k_t3_offset
      INTEGER d_i3
      INTEGER k_i3_offset
      INTEGER l_i3_offset
      INTEGER size_i3
      CHARACTER*255 filename
c#if !defined(CCSDTQ)
c      CALL ERRQUIT('CCSDTQ not compiled',0,CAPMIS_ERR)
c      RETURN
c      END
c#else
      CALL ccsdtq_lambda3_1(d_y1,k_y1_offset,d_v2,k_v2_offset,d_i0,k_i0_
     &offset)
      CALL OFFSET_ccsdtq_lambda3_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_2_1(d_f1,k_f1_offset,d_i1,k_i1_offset)
      CALL ccsdtq_lambda3_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_2(d_y2,k_y2_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_3_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_3_1(d_v2,k_v2_offset,d_i1,k_i1_offset)
      CALL ccsdtq_lambda3_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_3(d_y2,k_y2_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_4(d_y2,k_y2_offset,d_v2,k_v2_offset,d_i0,k_i0_
     &offset)
      CALL OFFSET_ccsdtq_lambda3_5_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_5_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_5_1(d_f1,k_f1_offset,d_i1,k_i1_offset)
      CALL OFFSET_ccsdtq_lambda3_5_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_5_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_5_2_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_5_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_5_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_5_3(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL ccsdtq_lambda3_5_4(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_5(d_y3,k_y3_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_6_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_6_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_6_1(d_f1,k_f1_offset,d_i1,k_i1_offset)
      CALL ccsdtq_lambda3_6_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL ccsdtq_lambda3_6_3(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL OFFSET_ccsdtq_lambda3_6_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_6_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_6_4_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_6_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_6(d_y3,k_y3_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_7_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_7_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_7_1(d_v2,k_v2_offset,d_i1,k_i1_offset)
      CALL OFFSET_ccsdtq_lambda3_7_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_7_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_7_2_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_7_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_7_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_7_3(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_7(d_y3,k_y3_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_8_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_8_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_8_1(d_v2,k_v2_offset,d_i1,k_i1_offset)
      CALL ccsdtq_lambda3_8_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL ccsdtq_lambda3_8_3(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL OFFSET_ccsdtq_lambda3_8_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_8_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_8_4_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_8_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_8(d_y3,k_y3_offset,d_i1,k_i1_offset,d_i0,k_i0_
     &offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_9(d_y3,k_y3_offset,d_v2,k_v2_offset,d_i0,k_i0_
     &offset)
      CALL OFFSET_ccsdtq_lambda3_10_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_10_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_10_1(d_f1,k_f1_offset,d_i1,k_i1_offset)
      CALL OFFSET_ccsdtq_lambda3_10_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_10_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_10_2_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL OFFSET_ccsdtq_lambda3_10_2_2_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdtq_lambda3_10_2_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdtq_lambda3_10_2_2_1(d_f1,k_f1_offset,d_i3,k_i3_offset)
      CALL ccsdtq_lambda3_10_2_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdtq_lambda3_10_2_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_10_2_3(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL ccsdtq_lambda3_10_2_4(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_10_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_10_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_10_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_10_3_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_10_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL ccsdtq_lambda3_10_3_3(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_10_3(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_10_4(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL OFFSET_ccsdtq_lambda3_10_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_10_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_10_5_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_10_5_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_10_5(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_10_6(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_10_7(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_10_8(d_t3,k_t3_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_10(d_y4,k_y4_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_11_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_11_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_11_1(d_v2,k_v2_offset,d_i1,k_i1_offset)
      CALL OFFSET_ccsdtq_lambda3_11_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_11_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_11_2_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL OFFSET_ccsdtq_lambda3_11_2_2_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdtq_lambda3_11_2_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdtq_lambda3_11_2_2_1(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL ccsdtq_lambda3_11_2_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdtq_lambda3_11_2_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_11_2_3(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_11_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_11_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_11_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_11_3_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_11_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_11_3(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_11_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_11_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_11_4_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_11_4_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_11_4(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_11_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_11_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_11_5_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_11_5_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_11_5(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_11_6(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_11_7(d_t3,k_t3_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_11(d_y4,k_y4_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_12_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_12_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_12_1(d_v2,k_v2_offset,d_i1,k_i1_offset)
      CALL ccsdtq_lambda3_12_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL OFFSET_ccsdtq_lambda3_12_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_12_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_12_3_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdtq_lambda3_12_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_12_3(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL ccsdtq_lambda3_12_4(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_12_5(d_t3,k_t3_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL OFFSET_ccsdtq_lambda3_12_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_12_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_12_6_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_12_6(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_12_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_12_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_12_7_1(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_12_7(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_12(d_y4,k_y4_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_13_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_13_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_13_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_13_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_13_3(d_t3,k_t3_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_13(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_14_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_14_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_14_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_14_2(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_14(d_i1,k_i1_offset,d_f1,k_f1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_15_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_15_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_15_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_15_2(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_15(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_16_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_16_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_16_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_16_2(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_16(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_17_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_17_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_17_1(d_t1,k_t1_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_17(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_18_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_18_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_18_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_18_2(d_t3,k_t3_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_18(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_19_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_19_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_19_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i1,k_
     &i1_offset)
      CALL ccsdtq_lambda3_19_2(d_t3,k_t3_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL OFFSET_ccsdtq_lambda3_19_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_19_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_19_3_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_19_3(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_19_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_19_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_19_4_1(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_19_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_19(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_20_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_20_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_20_1(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_20(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_21_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_21_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_21_1(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_21(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_22_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_22_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_22_1(d_t3,k_t3_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_22(d_y4,k_y4_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_23_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_23_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdtq_lambda3_23_1(d_t3,k_t3_offset,d_v2,k_v2_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_23(d_y4,k_y4_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_24_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_24_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdtq_lambda3_24_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_24_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_24_1_1(d_t1,k_t1_offset,d_y4,k_y4_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_24_1(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_24(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_25_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_25_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdtq_lambda3_25_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_25_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_25_1_1(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_25_1(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_25(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_26_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_26_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdtq_lambda3_26_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_26_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_26_1_1(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_26_1(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_26_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_26_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_26_2_1(d_t1,k_t1_offset,d_y4,k_y4_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_26_2(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_26(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_27_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdtq_lambda3_27_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdtq_lambda3_27_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_27_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdtq_lambda3_27_1_1(d_t2,k_t2_offset,d_y4,k_y4_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_27_1(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL OFFSET_ccsdtq_lambda3_27_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdtq_lambda3_27_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdtq_lambda3_27_2_1_1(l_i3_offset,k_i3_offset,size_i
     &3)
      CALL TCE_FILENAME('ccsdtq_lambda3_27_2_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdtq_lambda3_27_2_1_1(d_t1,k_t1_offset,d_y4,k_y4_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdtq_lambda3_27_2_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdtq_lambda3_27_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdtq_lambda3_27(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdtq_lambda3',
     &-1,MA_ERR)
      RETURN
      END
c#endif

*
* $Id: mmmdv1.F 23434 2013-01-15 18:55:23Z bylaska $
*

***********************************************************************
*                      mmmdv1                                         *

*     This is a developing Born-Oppenheimer MD code for NWCHEM        *
*                                                                     *
***********************************************************************

      logical function mmmdv1(rtdb,flag)
      implicit none
      integer rtdb
      integer flag

#include "global.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"

#include "nwpw_timing.fh"

*     *** local variables and parameters ****
      double precision kb
      parameter (kb=3.16679d-6)

      
*     **** parallel variables ****
      integer  taskid,np
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d
      real*8  a,b,c,alpha,beta,gamma
    

*     ***** energy variables ****
      real*8  E(30),en(2)
      real*8  dipole(3)
      real*8  stress(3,3),lstress(6)

*     **** gradient variables ****
      integer fion(2)

*     **** error variables ****
      logical value,newpsi
      integer ierr

*     **** local variables ****
      logical oprint,lprint,hprint,qmmm,found,nose,SA
      logical calc_pressure
      real*8  gx,gy,gz,cx,cy,cz
      real*8  vgx,vgy,vgz,vcx,vcy,vcz,ekg,eki0,eki1,dt
      real*8  sum,w,emotion_time_shift,wa,wr
      real*8  EV,EV0,pi,esum1,esum2,eave,evar,dr
      real*8  ratio,aratio
      real*8  icharge,r,cv,E25,E26
      real*8  sa_alpha(2),sa_decay(2),ssr,tt2
      real*8  Tr_new,Tr_init,p1,p2,pressure
      integer i,k,ia,nion,minimizer,mapping,it,icount_shift,icount
      integer nbq,it_in,it_out

      character*50 filename
      character*255 full_filename


*     **** external functions ****
      real*8      mmq_zv,ewald_rcut
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg,ion_amass
      integer     ewald_ncut,ewald_nshl3d,ewald_npack
      integer     ewald_grid_nx,ewald_grid_ny,ewald_grid_nz
      integer     psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      integer     psp_nprj,psp_psp_type
      character*4 ion_atom,ion_aname
      external    mmq_zv,ewald_rcut
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg,ion_amass
      external    ewald_ncut,ewald_nshl3d,ewald_npack
      external    ewald_grid_nx,ewald_grid_ny,ewald_grid_nz
      external    psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      external    psp_nprj,psp_psp_type
      external    ion_atom,ion_aname
      
      external      psp_comment
      character*255 psp_comment,comment

      real*8   control_tole,control_tolc,control_tolr,ion_rion,ion_vion
      external control_tole,control_tolc,control_tolr,ion_rion,ion_vion
      real*8   control_time_step,control_fake_mass
      external control_time_step,control_fake_mass
      logical  control_read,control_move,ion_init,control_out_of_time
      external control_read,control_move,ion_init,control_out_of_time
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      integer  pspw_charge_nion
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external pspw_charge_nion

      character*12 control_boundry
      external     control_boundry
      character*50 control_cell_name
      external     control_cell_name

      real*8   md_energy
      external md_energy
      real*8   ion_TotalCharge
      external ion_TotalCharge
      logical  control_check_charge_multiplicity,control_rotation
      external control_check_charge_multiplicity,control_rotation
      logical   pspw_charge_found,ion_q_FixIon
      external  pspw_charge_found,ion_q_FixIon
      integer  control_minimizer,control_scf_algorithm
      external control_minimizer,control_scf_algorithm
      integer  control_ks_algorithm
      external control_ks_algorithm
      real*8   control_ks_alpha
      external control_ks_alpha
      logical  control_print,control_balance,control_translation
      external control_print,control_balance,control_translation
      integer  control_mapping
      external control_mapping

      logical pspw_bqext
      external pspw_bqext

      integer  control_bo_steps_in,control_bo_steps_out
      integer  control_bo_algorithm
      real*8   control_bo_time_step,control_rti,ion_ke,ion_Temperature
      external control_bo_steps_in,control_bo_steps_out
      external  control_bo_algorithm
      external control_bo_time_step,control_rti,ion_ke,ion_Temperature
      real*8   ion_com_Temperature
      external ion_com_Temperature
      logical  control_Nose,control_SA,control_pressure
      real*8   control_Nose_Te,control_Nose_Tr,control_SA_decay,Nose_ssr
      real*8   Nose_Pr,Nose_Pe,Nose_Ee0,Nose_Er0,Nose_dXr
      real*8   Nose_Tr,Nose_Te,Nose_Qr,Nose_Qe,Nose_r_energy
      integer  Nose_Mchain,Nose_Nchain
      external control_Nose,control_SA,control_pressure
      external control_Nose_Te,control_Nose_Tr,control_SA_decay,Nose_ssr
      external Nose_Pr,Nose_Pe,Nose_Ee0,Nose_Er0,Nose_dXr
      external Nose_Tr,Nose_Te,Nose_Qr,Nose_Qe,Nose_r_energy
      external Nose_Mchain,Nose_Nchain


*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(30,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      value = control_read(12,rtdb)
      if (.not. value) 
     > call errquit('error reading control',0, INPUT_ERR)

      oprint= ((taskid.eq.MASTER).and.control_print(print_medium))
      lprint= ((taskid.eq.MASTER).and.control_print(print_low))
      hprint= ((taskid.eq.MASTER).and.control_print(print_high))


      if (oprint) call current_second(cpu1)

*     ***** print out header ****
      if (oprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1031)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
      end if
      

*     **** initialize lattice data structure ****
      call lattice_init()

*     **** read ions ****
      value = ion_init(rtdb)

*     **** read in ion charges ****
      call mmq_init()

*     **** initialize ewald data structures ****
      if (control_version().eq.3) call ewald_init()

*     **** initialize QM/MM ****
      call pspw_qmmm_init(rtdb)
      call pspw_charge_init(rtdb)

*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)


*     **** initialize pressure ****
      calc_pressure = control_pressure().and.(control_version().eq.3)
      pressure      = 0.0d0
      p1            = 0.0d0
      p2            = 0.0d0


*     ******************************
*     **** scaling ion velocity ****
*     ******************************
      call ion_init_ke(ekg,eki0,eki1)


*     **** Initialize thermostats ****
      nose = control_Nose()
      if (nose) call Nose_Init(2,0.01d0)

*     **** Initialize simulated annealing ****
      SA       = .false.
      Tr_init  = 0.0d0
      sa_alpha(2) = 1.0d0
      if (control_SA()) then
         if (nose) then
            SA          = .true.
            sa_decay(2) = control_SA_decay(2)
            Tr_init     = control_Nose_Tr()
         else
            dt = control_bo_time_step()
            SA          = .false.
            sa_decay(2) = control_SA_decay(2)
            sa_alpha(2) = dexp( -(dt/control_SA_decay(2)) )
         end if
      end if


*                |**************************|
******************   summary of input data  **********************
*                |**************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)

      if (oprint) then
         write(luout,1111) np
         write(luout,1115)

         write(luout,1121) control_boundry(),control_version()

         write(luout,1140)
         do ia = 1,ion_nkatm()
           write(luout,1150) ia,ion_atom(ia),mmq_zv(ia)
         end do

         icharge = 0.0d0
         icharge = icharge + ion_TotalCharge()
         write(luout,1159) icharge

         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())

         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         call pspw_charge_Print(luout)

         write(luout,1181)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz

         write(luout,1230)
         write(luout,1233) control_cell_name()
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1231) lattice_omega()
         if (control_version().eq.3) then
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()
         write(luout,1252) 
     >        ewald_grid_nx(),ewald_grid_ny(),ewald_grid_nz(),
     >        ewald_npack(),ewald_npack()
         end if

         write(luout,1270)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_tole(),control_tolc()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()

         write(luout,1310)
         if (.not.control_translation()) write(luout,1271)
         if (.not.control_rotation())    write(luout,1272)
         write(luout,1320) control_bo_time_step(),
     >    control_bo_steps_in()*control_bo_steps_out(),
     >    control_bo_steps_in(),control_bo_steps_out()
         if (control_bo_algorithm().eq.0) write(luout,1330) "Verlet"

         write(luout,1340) control_rti()
         write(luout,1222) eki0,ekg
         write(luout,1223) eki1
         write(luout,1224) (eki1-eki0)
         if (nose) then
           write(luout,1395)
           do i=1,Nose_Nchain()
             write(luout,1398) i,control_Nose_Tr(),Nose_Qr(i),
     >                   Nose_Pr(i),Nose_Er0(i)
           end do
         else
           write(luout,1394)
         end if
        if (calc_pressure) write(6,1293)
         if (control_SA()) then
           write(luout,1396) sa_decay(2)
         end if
         write(luout,1300)
         call util_flush(luout)
      end if

*                |***************************|
******************     simple MD loop        **********************
*                |***************************|
      if (taskid.eq.MASTER) call current_second(cpu2)
      if (taskid.eq.MASTER) call nwpw_message(10)


*     **** write initial position to xyz data ****
      call xyz_init()          ! unit=18
      call MOTION_init(rtdb)   ! unit=19

*     ************************************
*     **** open up other MOTION files ****
*     ************************************
*     **** open EMOTION file ****
      E25=0.0d0
      E26=0.0d0
      icount_shift = 0
      if (.not.rtdb_cget(rtdb,'nwpw:emotion_filename',1,filename))
     >  call util_file_prefix('emotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER) then

         emotion_time_shift = 0.0d0
         icount_shift       = 0
         inquire(file=full_filename,exist=found)
         if (found) then
           open(unit=31,file=full_filename,form='formatted',
     >          status='old')
           do while (found)
           read(31,*,end=100) emotion_time_shift,w,sum
           E25 = E25 + sum   !*** take care of running sums ***
           E26 = E26 + sum*sum
           icount_shift = icount_shift + 1
           end do
  100      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(GCC46)
           backspace 31
#endif
         else
           open(unit=31,file=full_filename,form='formatted',
     >          status='new')
         end if
      end if

      call xyz_write()


*     ****  allocate fion ***
      nion = ion_nion()
      if (pspw_charge_found().and.
     >    (.not.pspw_bqext())) nion = nion + pspw_charge_nion()

      value = MA_push_get(mt_dbl,(3*nion),
     >                       'fion',fion(2),fion(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)



*     ***** do a simple md loop ***
      dt = control_bo_time_step()
      call control_reduce_print()
      EV = md_energy()
      call md_energy_gradient(dbl_mb(fion(1)))
      eki1 = ion_ke()

      r = 1.0d0 
      if (nose) r =  (1.0d0-0.5d0*dt*Nose_dXr())
      call ion_newton_step(dbl_mb(fion(1)),sa_alpha(2)*r)
      if (nose) call Nose_Newton_Step(0.01d0,eki1)

      call xyz_write()

      it_out = control_bo_steps_out()
      it_in  = control_bo_steps_in()
      icount = 0
      if (it_out.lt.1) goto 102


  101 continue
         icount = icount + 1

c       **** inner loop ****
        do i=1,it_in
           call ion_shift()
          if (nose) call Nose_shift()

           EV = md_energy()
           call md_energy_gradient(dbl_mb(fion(1)))
           eki1 = ion_ke()
           if (nose) then
              ssr = Nose_ssr()
              call ion_nose_step(ssr,dbl_mb(fion(1)))
              call Nose_Verlet_Step(0.01d0,eki1)
           else
              call ion_verlet_step(dbl_mb(fion(1)),sa_alpha(2))
           end if
        end do
        eki1 = ion_ke()
        E25 = E25 + EV
        E26 = E26 + EV*EV


        if (oprint) then
           if (nose) then
           write(luout,1350) icount*it_in,EV+eki1+Nose_r_energy(),
     >                       EV,eki1,ion_Temperature()
           write(31,1360) icount*it_in*dt+emotion_time_shift,
     >                    EV+eki1+Nose_r_energy(),
     >                    EV,eki1,ion_Temperature()
           else
           write(luout,1350) icount*it_in,EV+eki1,EV,eki1,
     >                       ion_Temperature()
           write(31,1360) icount*it_in*dt+emotion_time_shift,
     >                    EV+eki1,EV,eki1,ion_Temperature()
           end if
           call util_flush(luout)
           call util_flush(31)
        end if

        call xyz_write()
        call MOTION_write(icount*it_in*dt)


*        **** update thermostats using SA decay ****
         if (SA) then
           tt2 = icount*it_in*dt/sa_decay(2)
           Tr_new = Tr_init*dexp(-tt2)
           call Nose_reset_T(Tr_new,Tr_new)
         end if

*        **** exit early ****
         if (control_out_of_time()) then
            if (oprint)
     >       write(luout,*) ' *** out of time. iteration terminated'
            go to 102
         end if
      if (icount.lt.it_out) go to 101
      if (oprint) write(luout,*)
     > '*** arived at the Maximum iteration.   terminated.'

*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::
      call control_up_print()

  102 continue


*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::

*     **** close xyz and MOTION files ****
      call xyz_end()
      call MOTION_end()
      if (taskid.eq.MASTER) then
        close(unit=31)
      end if

*                |***************************|
****************** report summary of results **********************
*                |***************************|

      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)

      if (oprint) then
         call print_elapsed_time(icount*it_in*dt)
         write(luout,1300)
         write(luout,1410)
         write(luout,1420)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         write(luout,1421)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
      end if

      EV = md_energy()

      if (oprint) then

         write(luout,1300)
         write(luout,1472) ion_ke(),ion_ke()/ion_nion()

*       **** write out Temperatures ****
         eki0 = ion_Temperature()
         write(luout,1480) eki0
         write(luout,1490) ion_com_Temperature()

         eave = E25/dble(icount+icount_shift)
         evar = E26/dble(icount+icount_shift)
         evar = evar - eave*eave
         cv = (evar)/(kb*ion_Temperature()**2)
         cv = cv/dble(ion_nion())
         write(luout,1492) eave
         write(luout,1493) evar
         write(luout,1494) cv

      end if


*     **** extra energy output for QA test ****
      if (lprint) write(luout,1600) EV

*     **** calculate the spin contamination ****

*     **** calculate the dipole ***

*     **** calculate the stress tensor ****


*     *************************************************************
*     **** output energy, dipole, and gradient to rtdb for use ****
*     **** by task_energy and task_gradient                    ****
*     *************************************************************
      if (flag.gt.-1) then
      value = rtdb_put(rtdb,'pspw:energy',mt_dbl,1,EV)
      value = value.and.
     >        rtdb_put(rtdb,'pspw:dipole',mt_dbl,
     >                 3,dipole)
      end if
      if (flag.gt.0) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:gradient',mt_dbl,
     >                 3*nion,dbl_mb(fion(1)))
      end if
      if (flag.eq.3) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:stress',mt_dbl,
     >                 9,stress)
        value = value.and.
     >        rtdb_put(rtdb,'pspw:lstress',mt_dbl,
     >                 6,lstress)
      end if
      value = value.and.MA_pop_stack(fion(2))
      if (.not. value) call errquit('cgmdv5: error writing rtdb',0,
     &       RTDB_ERR)

      if (taskid.eq.MASTER) call current_second(cpu3)

*                |***************************|
******************         Epilogue          **********************
*                |***************************|

      call ion_write(rtdb)

*     **** deallocate heap memory ****
      if (control_version().eq.3) call ewald_end()
   
      call mmq_end()
      call pspw_charge_end()
      call pspw_qmmm_end()
      if (nose) call Nose_end()
      call ion_end()
      call ion_end_FixIon()

*     **** do anaylysis on MOTION files ****
c      call cpmd_properties(rtdb)



*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (lprint) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(icount*it_in)
         write(luout,1801)
         write(luout,1802)
         write(luout,1803) T1
         write(luout,1804) T2
         write(luout,1805) T3
         write(luout,1806) T4
         write(luout,1807) AV,icount*it_in

         call nwpw_timing_print_final(oprint,icount*it_in)

         write(luout,*)
         CALL nwpw_MESSAGE(4)
      end if 


      call Parallel_Finalize()
      mmmdv1 = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*               NWPW PSPW Calculation              *')
 1030 FORMAT(10X,'*     [      Born-Oppenheimer molecular       ]    *')
 1031 FORMAT(10X,'*     [          dynamics simulation          ]    *')
 1035 FORMAT(10x,'*     [  NorthWest Chemistry implementation   ]    *')
 1040 FORMAT(10X,'*            version #1.00   07/18/06              *')
 1041 FORMAT(10X,'*    This code was developed by Eric J. Bylaska.   *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I3)
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1122 FORMAT(5X,' qmmm simulation')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)

 1159 FORMAT(/' total charge:',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I5))
 1180 FORMAT(/' initial position of ions (au):')
 1181 FORMAT(/' initial velocity of ions after scaling (au):')

 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - fixed')
 1192 FORMAT(5X, I4, A5  ,' (',3F11.5,' )')

 1200 FORMAT(5X,'  G.C. ',' (',3F11.5,' )')
 1210 FORMAT(5X,' C.O.M.',' (',3F11.5,' )')
 1219 FORMAT(/' number of active electrons: spin up=',F6.2,
     >        '  down=',F6.2,A)
 1220 FORMAT(/' number of active electrons: spin up=',I6,  
     >        '  down=',I6,A)
 1221 FORMAT( ' number of active orbitals : spin up=',I6,  
     >        '  down=',I6,A)

 1222 format(5x,' initial kinetic energy=',e12.5,' (ion)',2x,
     >                                     e12.5,' (c.o.m.)')
 1223 format(5x,' after scaling=         ',e12.5,' (ion)')
 1224 format(5x,' increased energy=      ',e12.5,' (ion)')
 1226 format(/' final kinetic energy= ',   e12.5,' (ion)',2x,
     >                                     e12.5,' (c.o.m.)')

 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,'             omega=',F8.1)
 1232 FORMAT(5x,' lattice:    a=    ',f8.3,' b=   ',f8.3,' c=    ',f8.3,
     >      /5x,'             alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1233 FORMAT(5x,' cell_name:  ',A)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1250 FORMAT(/5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1252 FORMAT(5X,' ewald fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
  
 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters for minimizer:')
 1271 FORMAT(5x, ' translation constrained')
 1272 FORMAT(5x, ' rotation constrained')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I8, 
     >           ' ( ',I4,' inner ',I4,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (density)')
 1291 FORMAT(/' Kohn-Sham scf parameters:')
 1292 FORMAT(5X, ' Kohn-Sham algorithm  = ',A)
 1293 FORMAT(5X, ' SCF algorithm        = ',A)
 1294 FORMAT(5X, ' SCF mixing parameter =',F7.4)
 1295 FORMAT(5X, ' Kohn-Sham iterations = ',I3,
     >           ' (',I3,' outer)')
 1300 FORMAT(//)
 1310 FORMAT(/' molecular dynamics parameters:')
 1320 FORMAT(5X, ' time step=',F10.2,5X,'iterations=',I8,
     >           ' ( ',I4,' inner ',I4,' outer )')
 1330 FORMAT(5X, ' integration agorithm=   ',A)
 1340 FORMAT(/5X, ' cooling/heatting rate= ',e12.5,' (ion)')
 1350 FORMAT(I8,2E19.10,E14.5,4F14.2,2E19.10,F8.4)
 1360 format(100e19.10)

 1393 format(/' Pressure Output Generated         ')
 1394 format(/' Constant Energy Simulation                     ')
 1395 format(/' Nose-Hoover Simulation - Thermostat Parameters:')
 1396 format(5x, 'SA decay rates  =',e10.3,' (ion)')
 1397 format(5x, 'link = ',I3,
     > ' Te =',f8.2,' Qe =',e10.3,' 2*pi/we=',e10.3,' Ee0=',e10.3)
 1398 format(5x, 'link = ',I3,
     > ' Tr =',f8.2,' Qr =',e10.3,' 2*pi/wr=',e10.3,' Er0=',e10.3)

 1399 format(//' Mulliken Analysis Output Generated            ')
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT(/' final position of ions:')
 1421 FORMAT(/' final velocity of ions:')
 1471 FORMAT(/' Kinetic energy (elc)    :',E19.10,' (',E15.5,'/elc)')
 1472 FORMAT( ' Kinetic energy (ion)    :',E19.10,' (',E15.5,'/ion)')
 1473 FORMAT( ' thermostat energy (elc) :',E19.10,' (',E15.5,'/elc)')
 1474 FORMAT( ' thermostat energy (ion) :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(' Temperature :    ',F10.1,' K (ion)')
 1490 FORMAT('             :    ',F10.1,' K (c.o.m.)')
 1491 FORMAT(' Temperature :    ',F10.1,' K (elc)')
 1492 FORMAT(/' Eaverage           :    ',E19.10)
 1493 FORMAT( ' Evariance          :    ',E19.10)
 1494 FORMAT( ' Cv - f*kb/(2*nion) :    ',E19.10)
 1600 FORMAT(/' Total PSPW energy   :',E19.10)
 1801 FORMAT(//'== Timing ==')
 1802 FORMAT(/'cputime in seconds')
 1803 FORMAT( '  prologue    : ',E14.6)
 1804 FORMAT( '  main loop   : ',E14.6)
 1805 FORMAT( '  epilogue    : ',E14.6)
 1806 FORMAT( '  total       : ',E14.6)
 1807 FORMAT( '  cputime/step: ',E14.6,
     >        '       (',I8,' evalulations)')
 1808 FORMAT(A,E14.6,E14.6)
 1809 FORMAT(//A,2A14)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(6,9010) ierr
      call Parallel_Finalize()

      mmmdv1 = value
      return
      END

* $Id: test_calc2.f 19696 2010-10-29 16:53:42Z d3y133 $
c=================================================================
c Only for test calculations :
c
cccc  subroutine test_cent4(num_bas_ij,num_bas_kl,l_blsize)
      subroutine test_cent4(num_bas_ij,num_bas_kl,l_blscr )
      implicit real*8 (a-h,o-z)
      logical more_int
c-----------------------------------
c ordinary four center two-electron integrals
c-----------------------------------
      parameter (leri= 129 600) 
      parameter (nquart=10 000)
      parameter(l_blsize=3 000 000)
c-----------------------------------
      common /multi_basis/ num_bas_1,num_bas_2,num_bas_3,
     *                     ncs_bas_1,ncs_bas_2,ncs_bas_3,
     *                     nps_bas_1,nps_bas_2,nps_bas_3,
     *                     nat_bas_1,nat_bas_2,nat_bas_3,
     *                     ncf_bas_1,ncf_bas_2,ncf_bas_3 
c-----------------------------------
      common /check_int/ integ_check
c-----------------------------------
      dimension blscr(l_blsize)
c-----------------------------------
c returning integrals and indeces :
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
      dimension ra(3),rb(3),rc(3),rd(3)
c requested shells :
      dimension ics(nquart),jcs(nquart),kcs(nquart),lcs(nquart)
      dimension q4(nquart)
c-------------------------
      dimension stsum(5,3)
c--------------------------------------------------------------
      write(6,*) '-------------------------------'
      write(6,*) '***   ENTERING TEST_CENT4   ***'
      write(6,*) 'fixed   l_blsize=',l_blsize,' avail.l_blscr=',l_blscr
      if(l_blscr.gt.l_blsize) stop 'fixed size .lt. needed'    
      write(6,*) '-------------------------------'
c--------------------------------------------------------------
      call txs_second(tcal1)
c-------------------------
      ij_basis=num_bas_ij
      kl_basis=num_bas_kl
c-------------------------
      integ_check=0
c-------------------------
      do 10 ii=1,3 
      do 10 jj=1,5
      stsum(jj,ii)=0.d0
   10 continue
c-------------------------
      more_int=.false.
c-------------------------
c total number of cont.shell quartets :
c
c ij 
c     if(num_bas_ij.eq.num_bas_1) then  ! take care of compiler warnings
         ish_b=1
         ish_e=ncs_bas_1
         jsh_b=1
         jsh_e=ncs_bas_1
         ij_shell=ncs_bas_1*(ncs_bas_1 + 1)/2
c     endif
      if(num_bas_ij.eq.num_bas_2) then
         ish_b=ncs_bas_1+1
         ish_e=ncs_bas_2
         jsh_b=ncs_bas_1+1
         jsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         ij_shell=n_shell*(n_shell+1)/2
      endif
c kl 
c     if(num_bas_kl.eq.num_bas_1) then  ! take care of compiler warnings
         ksh_b=1
         ksh_e=ncs_bas_1
         lsh_b=1
         lsh_e=ncs_bas_1
         kl_shell=ncs_bas_1*(ncs_bas_1 + 1)/2
c     endif
      if(num_bas_kl.eq.num_bas_2) then
         ksh_b=ncs_bas_1+1
         ksh_e=ncs_bas_2
         lsh_b=ncs_bas_1+1
         lsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         kl_shell=n_shell*(n_shell+1)/2
      endif
c
      if(ij_basis.eq.kl_basis) then
         nquartets=ij_shell*(ij_shell+1)/2
      else
         nquartets=ij_shell*kl_shell
      endif
c
c-------------------------
c
      integrals=0
      ncalls=0
      nqrt=0
      ijkl=0
      ijsh=0
      ish=0
c-------------------------
      nqrt=0
      do 100 ish1=ish_b,ish_e
      ish=ish+1
        jsh=0
        do 200 jsh1=jsh_b,ish1
        jsh=jsh+1
          ijsh=ijsh+1
          klsh=0
          ksh=0
          do 300 ksh1=ksh_b,ksh_e
          ksh=ksh+1
            lsh=0
            do 400 lsh1=lsh_b,ksh1
            lsh=lsh+1
            klsh=klsh+1
c>>>>       if(ijsh.ge.klsh) then
            if(ijsh.ge.klsh .OR. ij_basis.ne.kl_basis) then
               ijkl=ijkl+1
               nqrt=nqrt+1
  410          continue
               if(nqrt.lt.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                  if(ijkl.eq.nquartets) then
                     ncalls=ncalls+1
ccccccccccccccc      write(6,*)'* texas_hf called ',ncalls,' time *'
  451                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'scfd_int')
ccc  *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
ccc  *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
c
ccccc   call print_int1(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sums(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 451
                   endif
                else if(nqrt.eq.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                     ncalls=ncalls+1
ccccccccccccccc      write(6,*)'* texas_hf called ',ncalls,' time *'
  452                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'scfd_int')
ccc  *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
ccc  *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
ccccc   call print_int1(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sums(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 452
                  nqrt=0
                else
                  nqrt=1
                  go to 410
                endif
            endif
  400       continue
  300     continue
  200   continue
  100 continue
c
c-------------------------
      write(6,*)'-------------------------------------------------'
      write(6,*)'       Four-center two-electron integrals    '
      write(6,*)'total number of integrals processed =',integrals
      write(6,*)'total number of integrals checked in=',integ_check
      write(6,*)'-------------------------------------------------'
      call print_check(stsum)
c-------------------------
      call txs_second(tcal2)
      write(6,66) tcal2-tcal1
   66 format('Total CPU check-sum time =',f10.2)
      write(6,*)'-------------------------------------------------'
c--------------------------------------------------------------
c
      write(6,*) '***   LEAVING TEST_CENT4   ***'
c
c--------------------------------------------------------------
c
      end
c=================================================================
      subroutine check_sums(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
      implicit real*8 (a-h,o-z)
      common /check_int/ integ_check
      dimension stsum(5,3)
      dimension icf(*),jcf(*),kcf(*),lcf(*)
      dimension eri(*)
c
      eps=10.d0**(-7.5d0)
c
      int=0
      do 100 ii=1,integ_n0
      x=eri(ii)
      if(abs(x).gt.eps) then
        int=int+1
        x2=x*x
        i=icf(ii)
        j=jcf(ii)
        k=kcf(ii)
        l=lcf(ii)
        denom=1.d0/(1.d0 + x2)
c
        s1=dble(i+j+k+l)
        xij=dble(i-j)
        xkl=dble(k-l)
        xij=abs(xij)
        xkl=abs(xkl)
        d1=abs(xij-xkl)
c
        stsum(1,1)=stsum(1,1)+x
        stsum(2,1)=stsum(2,1)+abs(x)
        stsum(3,1)=stsum(3,1)+x2
        stsum(4,1)=stsum(4,1)+x*denom
        stsum(5,1)=stsum(5,1)+x2*denom
c
        stsum(1,2)=stsum(1,2)+x        *s1
        stsum(2,2)=stsum(2,2)+abs(x)   *s1
        stsum(3,2)=stsum(3,2)+x2       *s1
        stsum(4,2)=stsum(4,2)+x*denom  *s1
        stsum(5,2)=stsum(5,2)+x2*denom *s1
c
        stsum(1,3)=stsum(1,3)+x        *d1
        stsum(2,3)=stsum(2,3)+abs(x)   *d1
        stsum(3,3)=stsum(3,3)+x2       *d1
        stsum(4,3)=stsum(4,3)+x*denom  *d1
        stsum(5,3)=stsum(5,3)+x2*denom *d1
      endif
c
  100 continue
c
      integ_check=integ_check+int
c
      end
c=================================================================
      subroutine print_check(stsum)
      implicit real*8 (a-h,o-z)
      dimension stsum(5,3)
c
      write(6,*)'-------------------------------------------------'
      write(6,*)'check_sums '
      write(6,*)' '
      do ii=1,3
      write(6,66) (stsum(jj,ii),jj=1,5)
      enddo
  66  format(5(1pd15.8,3x))
      write(6,*)'-------------------------------------------------'
c
      end
c=================================================================
      subroutine blprint(number,ibas,inuc,na,ncs,nsh,ncf,inx,
     *                   datbas,datnuc)
      implicit real*8 (a-h,o-z)
      dimension datbas(13,nsh),datnuc(5,*) 
      dimension inx(12,*)
c
      write(8,*)' from blprint call number=',number
      write(8,11) ncs,nsh,ncf, ibas,inuc
   11 format('ncs=',i3,' nsh=',i3,' ncf=',i3,' ibas=',i5,' inuc=',i5)
c
      write(8,*)' datbas :'
      do 100 i=1,13
      write(8,88) (datbas(i,ii),ii=1,nsh)
   88 format(5(f12.7,2x))
  100 continue
c     
      write(8,*)' datnuc :'
      do 200 i=1,5
      write(8,88) (datnuc(i,ii),ii=1,na)
  200 continue
c     
      write(8,*)' inx    :'
      do 300 i=1,12
      write(8,77) (inx(i,ii),ii=1,ncs)
   77 format(5(i5,2x))
  300 continue
c
      end
c=====================================================================
      subroutine print_int1(ncall, eri,leri,icf,jcf,kcf,lcf,integ_n0 )
      implicit real*8 (a-h,o-z)
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
c
ccc     write(6,*)'call no=',ncall,' ; ',integ_n0,' non-zero integ.'
c
        do ii=1,integ_n0
        i1=icf(ii)
        j1=jcf(ii)
        k1=kcf(ii)
        l1=lcf(ii)
             write(6,44) i1,j1,k1,l1,eri(ii)
        enddo
c
   44 format(4(i4,1x),1x,f30.20 )
      end
c=====================================================================
      subroutine print_int2(ncall,eri,leri,ics,jcs,kcs,lcs,integ_n0,
     *                      nquart)
c no labels 
      implicit real*8 (a-h,o-z)
      dimension eri(leri) 
      dimension ics(nquart),jcs(nquart),kcs(nquart),lcs(nquart)
c
        write(6,*)'call no=',ncall,' ; ',integ_n0,' integrals (all)'
        write(6,*)' no of quartets=',nquart
c
        do iis=1,nquart
          is=ics(iis)
          js=jcs(iis)
          ks=kcs(iis)
          ls=lcs(iis)
          write(6,22) is,js,ks,ls
   22     format('shells =',4(i4,1x))
        enddo
c
        do ii=1,integ_n0
          write(6,44) eri(ii)
        enddo
c
   33 format(3(i4,1x),1x,f30.20,6x,a5 )
   44 format(20x     ,1x,f30.20 )
      end
c=====================================================================
      subroutine test_cent2(num_bas_ij,num_bas_kl,l_blsize)
c-----------------------------------
c ONLY 2-center integrals (I0 | K0)
c nshells includes an additional S0-shell (the last one)
c-----------------------------------
      implicit real*8 (a-h,o-z)
      logical more_int
c-----------------------------------
c     parameter (leri= 2 000 000) 
c     parameter (nquart=1000)
c     parameter(l_blscr=3 000 000)
      parameter (leri= 100 000) 
      parameter (nquart=1000)
      parameter(l_blscr=100 000)
c-----------------------------------
      common /multi_basis/ num_bas_1,num_bas_2,num_bas_3,
     *                     ncs_bas_1,ncs_bas_2,ncs_bas_3,
     *                     nps_bas_1,nps_bas_2,nps_bas_3,
     *                     nat_bas_1,nat_bas_2,nat_bas_3,
     *                     ncf_bas_1,ncf_bas_2,ncf_bas_3 
c-----------------------------------
      common /check_int/ integ_check
c-----------------------------------
      dimension blscr(l_blscr)
c-----------------------------------
c returning integrals and indeces :
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
      dimension ra(3),rb(3),rc(3),rd(3)
c requested shells :
      dimension ics(nquart),jcs(nquart),kcs(nquart),lcs(nquart)
      dimension q4(nquart)
c-------------------------
      dimension stsum(5,3)
c--------------------------------------------------------------
c
      write(6,*) '-------------------------------'
      write(6,*) '***   ENTERING TEST_CENT2   ***'
      write(6,*) '-------------------------------'
c
c--------------------------------------------------------------
      call txs_second(tcal1)
c-------------------------
      ij_basis=num_bas_ij
      kl_basis=num_bas_kl
c-------------------------
      integ_check=0
c-------------------------
      do 10 ii=1,3 
      do 10 jj=1,5
      stsum(jj,ii)=0.d0
   10 continue
c-------------------------
      more_int=.false.
c-------------------------
c total number of cont.shell quartets :
c (I 0 | K 0)
c
c ij 
c     if(num_bas_ij.eq.num_bas_1) then   ! take care of compiler warnings
         ish_b=1
         ish_e=ncs_bas_1
         jsh_b=1
         jsh_e=ncs_bas_1
         ij_shell=ncs_bas_1
c     endif
      if(num_bas_ij.eq.num_bas_2) then
         ish_b=ncs_bas_1+1
         ish_e=ncs_bas_2
         jsh_b=ncs_bas_1+1
         jsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         ij_shell=n_shell
      endif
      if(num_bas_ij.eq.num_bas_3) then
         ish_b=ncs_bas_2+1
         ish_e=ncs_bas_3
         jsh_b=ncs_bas_2+1
         jsh_e=ncs_bas_3
         n_shell=ncs_bas_3 - ncs_bas_2
         ij_shell=n_shell
      endif
c kl 
c     if(num_bas_kl.eq.num_bas_1) then   ! take care of compiler warnings
         ksh_b=1
         ksh_e=ncs_bas_1
         lsh_b=1
         lsh_e=ncs_bas_1
         kl_shell=ncs_bas_1
c     endif
      if(num_bas_kl.eq.num_bas_2) then
         ksh_b=ncs_bas_1+1
         ksh_e=ncs_bas_2
         lsh_b=ncs_bas_1+1
         lsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         kl_shell=n_shell
      endif
      if(num_bas_kl.eq.num_bas_3) then
         ksh_b=ncs_bas_2+1
         ksh_e=ncs_bas_3
         lsh_b=ncs_bas_2+1
         lsh_e=ncs_bas_3
         n_shell=ncs_bas_3 - ncs_bas_2
         kl_shell=n_shell
      endif
c
      if(ij_basis.eq.kl_basis) then
         nquartets=ij_shell*(ij_shell+1)/2
      else
         nquartets=ij_shell*kl_shell
      endif
c-------------------------
c
      integrals=0
      ncalls=0
      nqrt=0
      ijkl=0
      ijsh=0
c
      ish=0
      do 100 ish1=ish_b,ish_e
      ish=ish+1
        do 200 jsh=0,0
          ijsh=ijsh+1
          klsh=0
          ksh=0
          do 300 ksh1=ksh_b,ksh_e
          ksh=ksh+1
            do 400 lsh=0,0
            klsh=klsh+1
            if(ijsh.ge.klsh .OR. ij_basis.ne.kl_basis) then
               ijkl=ijkl+1
               nqrt=nqrt+1
  410          continue
               if(nqrt.lt.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                  if(ijkl.eq.nquartets) then
                     ncalls=ncalls+1
                     write(6,*)'* texas_hf called ',ncalls,' time *'
  451                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
cccc *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
c
c       call print_in2c(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sum2(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 451
                  endif
               else if(nqrt.eq.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                     ncalls=ncalls+1
                     write(6,*)'* texas_hf called ',ncalls,' time *'
  452                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
cccc *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
c       call print_in2c(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sum2(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 452
                  nqrt=0
               else
                  nqrt=1
                  go to 410
               endif
            endif
  400       continue
  300     continue
  200   continue
  100 continue
c
c-------------------------
      write(6,*)'-------------------------------------------------'
      write(6,*)'       Two-center two-electron integrals    '
      write(6,*)'total number of integrals processed =',integrals
      write(6,*)'total number of integrals checked in=',integ_check
      write(6,*)'-------------------------------------------------'
      call print_check(stsum)
c-------------------------
      call txs_second(tcal2)
      write(6,66) tcal2-tcal1
   66 format('Total CPU check-sum time =',f10.2)
      write(6,*)'-------------------------------------------------'
c--------------------------------------------------------------
c
      write(6,*) '***   LEAVING TEST_CENT2   ***'
c
c--------------------------------------------------------------
c
      end
c=================================================================
      subroutine check_sum2(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
      implicit real*8 (a-h,o-z)
      common /check_int/ integ_check
      dimension stsum(5,3)
      dimension icf(*),jcf(*),kcf(*),lcf(*)
      dimension eri(*)
c
      eps=10.d0**(-7.5d0)
c
      int=0
      do 100 ii=1,integ_n0
      x=eri(ii)
      if(abs(x).gt.eps) then
        int=int+1
        x2=x*x
        i=icf(ii)
c>>>>   j=jcf(ii)
        j=0       
        k=kcf(ii)
c>>>>   l=lcf(ii)
        l=0
        denom=1.d0/(1.d0 + x2)
c
        s1=dble(i+j+k+l)
        xij=dble(i-j)
        xkl=dble(k-l)
        xij=abs(xij)
        xkl=abs(xkl)
        d1=abs(xij-xkl)
c
        stsum(1,1)=stsum(1,1)+x
        stsum(2,1)=stsum(2,1)+abs(x)
        stsum(3,1)=stsum(3,1)+x2
        stsum(4,1)=stsum(4,1)+x*denom
        stsum(5,1)=stsum(5,1)+x2*denom
c
        stsum(1,2)=stsum(1,2)+x        *s1
        stsum(2,2)=stsum(2,2)+abs(x)   *s1
        stsum(3,2)=stsum(3,2)+x2       *s1
        stsum(4,2)=stsum(4,2)+x*denom  *s1
        stsum(5,2)=stsum(5,2)+x2*denom *s1
c
        stsum(1,3)=stsum(1,3)+x        *d1
        stsum(2,3)=stsum(2,3)+abs(x)   *d1
        stsum(3,3)=stsum(3,3)+x2       *d1
        stsum(4,3)=stsum(4,3)+x*denom  *d1
        stsum(5,3)=stsum(5,3)+x2*denom *d1
      endif
c
  100 continue
c
      integ_check=integ_check+int
c
      end
c=================================================================
      subroutine print_in2c(ncall, eri,leri,icf,jcf,kcf,lcf,integ_n0 )
      implicit real*8 (a-h,o-z)
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
c
        write(6,*)'call no=',ncall,' ; ',integ_n0,' non-zero integ.'
c
        do ii=1,integ_n0
        i1=icf(ii)
c>>>>   j1=jcf(ii)
        k1=kcf(ii)
c>>>>   l1=lcf(ii)
c 2-center
             write(6,44) i1,k1,eri(ii)
        enddo
c
   44 format(2(i4,1x),1x,f30.20 )
      end
c=====================================================================
      subroutine test_cent3i_kl(num_bas_ij,num_bas_kl,l_blsize)
c-----------------------------------
c 3-center integrals (I 0 | K L)
c-----------------------------------
      implicit real*8 (a-h,o-z)
      logical more_int
c-----------------------------------
c     parameter (leri= 2 000 000) 
c     parameter (nquart=1000)
c     parameter(l_blscr=3 000 000)
      parameter (leri= 100 000) 
      parameter (nquart=1000)
      parameter(l_blscr=500 000)
c-----------------------------------
      common /multi_basis/ num_bas_1,num_bas_2,num_bas_3,
     *                     ncs_bas_1,ncs_bas_2,ncs_bas_3,
     *                     nps_bas_1,nps_bas_2,nps_bas_3,
     *                     nat_bas_1,nat_bas_2,nat_bas_3,
     *                     ncf_bas_1,ncf_bas_2,ncf_bas_3 
c-----------------------------------
      common /check_int/ integ_check
c-----------------------------------
      dimension blscr(l_blscr)
c-----------------------------------
c returning integrals and indeces :
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
      dimension ra(3),rb(3),rc(3),rd(3)
c requested shells :
      dimension ics(nquart),jcs(nquart),kcs(nquart),lcs(nquart)
      dimension q4(nquart)
c-------------------------
      dimension stsum(5,3)
c--------------------------------------------------------------
c
      write(6,*) '-------------------------------'
      write(6,*) '*** ENTERING TEST_CENT3i_kl ***'
c     write(6,*) '-------------------------------'
c
c--------------------------------------------------------------
      call txs_second(tcal1)
c-------------------------
      ij_basis=num_bas_ij
      kl_basis=num_bas_kl
c-------------------------
      integ_check=0
c-------------------------
      do 10 ii=1,3 
      do 10 jj=1,5
      stsum(jj,ii)=0.d0
   10 continue
c-------------------------
      more_int=.false.
c-------------------------
c total number of cont.shell quartets :
c (I 0 | K L)
c
c ij 
c     if(num_bas_ij.eq.num_bas_1) then   ! take care of compiler warnings
         ish_b=1
         ish_e=ncs_bas_1
         jsh_b=1
         jsh_e=ncs_bas_1
         ij_shell=ncs_bas_1
c     endif
      if(num_bas_ij.eq.num_bas_2) then
         ish_b=ncs_bas_1+1
         ish_e=ncs_bas_2
         jsh_b=ncs_bas_1+1
         jsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         ij_shell=n_shell
      endif
c kl 
c     if(num_bas_kl.eq.num_bas_1) then   ! take care of compiler warnings
         ksh_b=1
         ksh_e=ncs_bas_1
         lsh_b=1
         lsh_e=ncs_bas_1
         kl_shell=ncs_bas_1*(ncs_bas_1 + 1)/2
c     endif
      if(num_bas_kl.eq.num_bas_2) then
         ksh_b=ncs_bas_1+1
         ksh_e=ncs_bas_2
         lsh_b=ncs_bas_1+1
         lsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         kl_shell=n_shell*(n_shell+1)/2
      endif
c
      nquartets=ij_shell*kl_shell
c-------------------------
c
      integrals=0
      ncalls=0
      nqrt=0
      ijkl=0
      ish=0
      do 100 ish1=ish_b,ish_e
      ish=ish+1
        do 200 jsh=0,0
          ksh=0
          do 300 ksh1=ksh_b,ksh_e
          ksh=ksh+1
            lsh=0
            do 400 lsh1=lsh_b,ksh1
            lsh=lsh+1
               ijkl=ijkl+1
               nqrt=nqrt+1
  410          continue
               if(nqrt.lt.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                  if(ijkl.eq.nquartets) then
                     ncalls=ncalls+1
                     write(6,*)'* texas_hf called ',ncalls,' time *'
  451                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
ccc  *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
c
c       call print_i_kl(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sikl(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 451
                  endif
               else if(nqrt.eq.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                     ncalls=ncalls+1
                     write(6,*)'* texas_hf called ',ncalls,' time *'
  452                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
cc   *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
c       call print_i_kl(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sikl(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 452
                  nqrt=0
               else
                  nqrt=1
                  go to 410
               endif
  400       continue
  300     continue
  200   continue
  100 continue
c
c-------------------------
      write(6,*)'-------------------------------------------------'
      write(6,*)'       Three-center two-electron integrals    '
      write(6,*)'total number of integrals processed =',integrals
      write(6,*)'total number of integrals checked in=',integ_check
      write(6,*)'-------------------------------------------------'
      call print_check(stsum)
c-------------------------
      call txs_second(tcal2)
      write(6,66) tcal2-tcal1
   66 format('Total CPU check-sum time =',f10.2)
      write(6,*)'-------------------------------------------------'
c--------------------------------------------------------------
c
      write(6,*) '*** LEAVING TEST_CENT3 i_kl ***'
c
c--------------------------------------------------------------
c
      end
c=================================================================
      subroutine check_sikl(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
      implicit real*8 (a-h,o-z)
      common /check_int/ integ_check
      dimension stsum(5,3)
      dimension icf(*),jcf(*),kcf(*),lcf(*)
      dimension eri(*)
c
      eps=10.d0**(-7.5d0)
c
      int=0
      do 100 ii=1,integ_n0
      x=eri(ii)
      if(abs(x).gt.eps) then
        int=int+1
        x2=x*x
        i=icf(ii)
c>>>>   j=jcf(ii)
        j=0       
        k=kcf(ii)
        l=lcf(ii)
        denom=1.d0/(1.d0 + x2)
c
        s1=dble(i+j+k+l)
        xij=dble(i-j)
        xkl=dble(k-l)
        xij=abs(xij)
        xkl=abs(xkl)
        d1=abs(xij-xkl)
c
        stsum(1,1)=stsum(1,1)+x
        stsum(2,1)=stsum(2,1)+abs(x)
        stsum(3,1)=stsum(3,1)+x2
        stsum(4,1)=stsum(4,1)+x*denom
        stsum(5,1)=stsum(5,1)+x2*denom
c
        stsum(1,2)=stsum(1,2)+x        *s1
        stsum(2,2)=stsum(2,2)+abs(x)   *s1
        stsum(3,2)=stsum(3,2)+x2       *s1
        stsum(4,2)=stsum(4,2)+x*denom  *s1
        stsum(5,2)=stsum(5,2)+x2*denom *s1
c
        stsum(1,3)=stsum(1,3)+x        *d1
        stsum(2,3)=stsum(2,3)+abs(x)   *d1
        stsum(3,3)=stsum(3,3)+x2       *d1
        stsum(4,3)=stsum(4,3)+x*denom  *d1
        stsum(5,3)=stsum(5,3)+x2*denom *d1
      endif
c
  100 continue
c
      integ_check=integ_check+int
c
      end
c=================================================================
      subroutine print_i_kl(ncall, eri,leri,icf,jcf,kcf,lcf,integ_n0 )
      implicit real*8 (a-h,o-z)
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
c
        write(6,*)'call no=',ncall,' ; ',integ_n0,' non-zero integ.'
c
        do ii=1,integ_n0
        i1=icf(ii)
c>>>>   j1=jcf(ii)
        k1=kcf(ii)
        l1=lcf(ii)
             write(6,44) i1,k1,l1,eri(ii)
        enddo
c
   44 format('< ',i3,' |',i3,1x,i3,' >',3x,f30.20 )
      end
c=====================================================================
      subroutine test_cent3ij_k(num_bas_ij,num_bas_kl,l_blsize)
c-----------------------------------
c ONLY 3-center integrals (I J | K 0)
c nshells includes an additional S0-shell (the last one)
c-----------------------------------
      implicit real*8 (a-h,o-z)
      logical more_int
c-----------------------------------
c     parameter (leri= 2 000 000) 
c     parameter (nquart=1000)
c     parameter(l_blscr=3 000 000)
      parameter (leri= 100 000) 
      parameter (nquart=1000)
      parameter(l_blscr=500 000)
c-----------------------------------
      common /multi_basis/ num_bas_1,num_bas_2,num_bas_3,
     *                     ncs_bas_1,ncs_bas_2,ncs_bas_3,
     *                     nps_bas_1,nps_bas_2,nps_bas_3,
     *                     nat_bas_1,nat_bas_2,nat_bas_3,
     *                     ncf_bas_1,ncf_bas_2,ncf_bas_3 
c-----------------------------------
      common /check_int/ integ_check
c-----------------------------------
      dimension blscr(l_blscr)
c-----------------------------------
c returning integrals and indeces :
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
      dimension ra(3),rb(3),rc(3),rd(3)
c requested shells :
      dimension ics(nquart),jcs(nquart),kcs(nquart),lcs(nquart)
      dimension q4(nquart)
c-------------------------
      dimension stsum(5,3)
c--------------------------------------------------------------
      write(6,*) '-------------------------------'
      write(6,*) '*** ENTERING TEST_CENT3ij_k ***'
      write(6,*) '-------------------------------'
c--------------------------------------------------------------
      call txs_second(tcal1)
c-------------------------
      ij_basis=num_bas_ij
      kl_basis=num_bas_kl
c-------------------------
      integ_check=0
c-------------------------
      do 10 ii=1,3 
      do 10 jj=1,5
      stsum(jj,ii)=0.d0
   10 continue
c-------------------------
      more_int=.false.
c-------------------------
c total number of cont.shell quartets :
c (I J | K 0)
c
c ij 
c     if(num_bas_ij.eq.num_bas_1) then   ! take care of compiler warnings
         ish_b=1
         ish_e=ncs_bas_1
         jsh_b=1
         jsh_e=ncs_bas_1
         ij_shell=ncs_bas_1*(ncs_bas_1+1)/2
c     endif
      if(num_bas_ij.eq.num_bas_2) then
         ish_b=ncs_bas_1+1
         ish_e=ncs_bas_2
         jsh_b=ncs_bas_1+1
         jsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         ij_shell=n_shell*(n_shell+1)/2
      endif
c kl 
c     if(num_bas_kl.eq.num_bas_1) then   ! take care of compiler warnings
         ksh_b=1
         ksh_e=ncs_bas_1
         lsh_b=1
         lsh_e=ncs_bas_1
         kl_shell=ncs_bas_1
c     endif
      if(num_bas_kl.eq.num_bas_2) then
         ksh_b=ncs_bas_1+1
         ksh_e=ncs_bas_2
         lsh_b=ncs_bas_1+1
         lsh_e=ncs_bas_2
         n_shell=ncs_bas_2 - ncs_bas_1
         kl_shell=n_shell
      endif
c
      nquartets=ij_shell*kl_shell
c-------------------------
c
      integrals=0
      ncalls=0
      nqrt=0
      ijkl=0
      ish=0
      do 100 ish1=ish_b,ish_e
      ish=ish+1
        jsh=0
        do 200 jsh1=jsh_b,ish1
        jsh=jsh+1
          ksh=0
          do 300 ksh1=ksh_b,ksh_e
          ksh=ksh+1
            do 400 lsh=0,0
               ijkl=ijkl+1
               nqrt=nqrt+1
  410          continue
               if(nqrt.lt.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                  if(ijkl.eq.nquartets) then
                     ncalls=ncalls+1
                     write(6,*)'* texas_hf called ',ncalls,' time *'
  451                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
cc   *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
c
c       call print_ij_k(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sijk(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 451
                  endif
               else if(nqrt.eq.nquart) then
                  ics(nqrt)=ish
                  jcs(nqrt)=jsh
                  kcs(nqrt)=ksh
                  lcs(nqrt)=lsh
                     ncalls=ncalls+1
                     write(6,*)'* texas_hf called ',ncalls,' time *'
  452                continue
                     call texas_hf2_m(ij_basis,ics,jcs,kl_basis,kcs,lcs,
CCC  *                     nqrt,q4,use_q4,
     *                     nqrt,q4,.false.,
     *                     ra,rb,rc,rd,.false., eri,leri,
     *                     icf,jcf,kcf,lcf,integ_n0,.true.,
     *                     more_int,blscr,l_blscr,0.0d0,'der2_int')
ccc  *                     more_int,blscr,l_blscr,0.0d0,'der1_int')
c       call print_ij_k(ncalls,eri,leri,icf,jcf,kcf,lcf,integ_n0 )
                     call check_sijk(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
                     integrals=integrals+integ_n0
                     if(more_int) go to 452
                  nqrt=0
               else
                  nqrt=1
                  go to 410
               endif
  400       continue
  300     continue
  200   continue
  100 continue
c
c-------------------------
      write(6,*)'-------------------------------------------------'
      write(6,*)'       Three-center two-electron integrals    '
      write(6,*)'total number of integrals processed =',integrals
      write(6,*)'total number of integrals checked in=',integ_check
      write(6,*)'-------------------------------------------------'
      call print_check(stsum)
c-------------------------
      call txs_second(tcal2)
      write(6,66) tcal2-tcal1
   66 format('Total CPU check-sum time =',f10.2)
      write(6,*)'-------------------------------------------------'
c--------------------------------------------------------------
c
      write(6,*) '*** LEAVING TEST_CENT3 ij_k ***'
c
c--------------------------------------------------------------
c
      end
c=================================================================
      subroutine check_sijk(integ_n0,icf,jcf,kcf,lcf,eri,stsum)
      implicit real*8 (a-h,o-z)
      common /check_int/ integ_check
      dimension stsum(5,3)
      dimension icf(*),jcf(*),kcf(*),lcf(*)
      dimension eri(*)
c
      eps=10.d0**(-7.5d0)
c
      int=0
      do 100 ii=1,integ_n0
      x=eri(ii)
      if(abs(x).gt.eps) then
        int=int+1
        x2=x*x
        i=icf(ii)
        j=jcf(ii)
        k=kcf(ii)
c>>>>   l=lcf(ii)
        l=0
        denom=1.d0/(1.d0 + x2)
c
        s1=dble(i+j+k+l)
        xij=dble(i-j)
        xkl=dble(k-l)
        xij=abs(xij)
        xkl=abs(xkl)
        d1=abs(xij-xkl)
c
        stsum(1,1)=stsum(1,1)+x
        stsum(2,1)=stsum(2,1)+abs(x)
        stsum(3,1)=stsum(3,1)+x2
        stsum(4,1)=stsum(4,1)+x*denom
        stsum(5,1)=stsum(5,1)+x2*denom
c
        stsum(1,2)=stsum(1,2)+x        *s1
        stsum(2,2)=stsum(2,2)+abs(x)   *s1
        stsum(3,2)=stsum(3,2)+x2       *s1
        stsum(4,2)=stsum(4,2)+x*denom  *s1
        stsum(5,2)=stsum(5,2)+x2*denom *s1
c
        stsum(1,3)=stsum(1,3)+x        *d1
        stsum(2,3)=stsum(2,3)+abs(x)   *d1
        stsum(3,3)=stsum(3,3)+x2       *d1
        stsum(4,3)=stsum(4,3)+x*denom  *d1
        stsum(5,3)=stsum(5,3)+x2*denom *d1
      endif
c
  100 continue
c
      integ_check=integ_check+int
c
      end
c=================================================================
      subroutine print_ij_k(ncall, eri,leri,icf,jcf,kcf,lcf,integ_n0 )
      implicit real*8 (a-h,o-z)
      dimension eri(leri) 
      dimension icf(leri),jcf(leri),kcf(leri),lcf(leri)
c
        write(6,*)'call no=',ncall,' ; ',integ_n0,' non-zero integ.'
c
        do ii=1,integ_n0
        i1=icf(ii)
        j1=jcf(ii)
        k1=kcf(ii)
c>>>>   l1=lcf(ii)
c 
             write(6,44) i1,j1,k1,eri(ii)
        enddo
   44 format('< ',i3,1x,i3,' |',i3,' >',3x,f30.20 )
c
      end
c=====================================================================

*
* $Id: butter.F 19707 2010-10-29 17:59:36Z d3y133 $
*

c     ****************************************
c     *                                      *
c     *          Butter_levels               *
c     *                                      *
c     ****************************************
c
c  This routine computes log(dble(np_j))/log(2.0d0)
c
      integer function Butter_levels(np_j)
      implicit none
      integer np_j

*     *** local variables ***
      integer Level,v

      Level = -1
      v     = 1
      do while (v.le.np_j)
        Level = Level + 1
        v     = 2*v
      end do

      Butter_levels = Level
      return
      end


c     ****************************************
c     *                                      *
c     *          Butter_size                 *
c     *                                      *
c     ****************************************

      integer function Butter_size(taskid_j,np_j,na)
      implicit none
      integer taskid_j,np_j,na(*)

*     *** local variables ***
      integer i,l,pr,size,rsize,Level,shift,pfrom

*     *** external functions ****
      integer  Butter_levels
      external Butter_levels

      !Level = (log(dble(np_j))/log(2.0d0))
      Level = Butter_levels(np_j)

      rsize = na(taskid_j+1)
      do l=0,(Level-1)
         shift = 2**l
         pfrom = mod(taskid_j  +shift,np_j)

         size = shift
         if (l.eq.(Level-1)) then 
           size = ((np_j-2**Level)/2) + 1
         end if

         do i=0,(size-1)
            pr = mod(pfrom    + i,np_j)
            rsize = rsize + na(pr+1)
         end do
      end do

      Butter_size = rsize
      return
      end



c     ****************************************
c     *                                      *
c     *          Butter_indexes              *
c     *                                      *
c     ****************************************

      subroutine Butter_indexes(l,taskid_j,np_j,na,
     >                          istart,iend,jstart,jend,
     >                          imodn,imodtask)
      implicit none
      integer l,taskid_j,np_j,na(*)
      integer istart,iend,jstart,jend
      integer imodn,imodtask

*     *** local variables ***
      integer i,shift,size,rsize,rindx,pr,Level,pfrom

*     **** external functions ****
      integer  Butter_levels
      external Butter_levels

      imodn    = 1
      imodtask = 0

      if (l.eq.0) then
         istart =  1
         iend   =  na(taskid_j+1)
         jstart =  1
         jend   =  na(taskid_j+1)
      else
         !Level = (log(dble(np_j))/log(2.0d0))
         Level = Butter_levels(np_j)
         shift = 2**(l-1)
         pfrom = mod(taskid_j + shift,np_j)

         size  = shift
         if (l.eq.Level) then
            size = ((np_j-2**Level)/2) + 1
         endif

         rsize = 0
         do i=0,size-1
           pr = mod(pfrom + i,np_j)
           rsize = rsize + na(pr+1)
         end do

         rindx = 1
         do i=0,shift-1
           pr    = mod(taskid_j + i,np_j)
           rindx = rindx + na(pr+1)
         end do
         istart =  1
         iend   =  na(taskid_j+1)
         jstart = rindx
         jend   = rindx + rsize - 1

*        *** last level and even ***
         if ((l.eq.Level).and.(mod(np_j,2).eq.0)) then

*           *** first np_j/2 procs do even computations, ***
*           *** second np_j/2 proces do odd computations ***
            imodn    = 2
            imodtask = taskid_j/(np_j/2)
            if (imodtask.eq.1) then
              rindx  = istart
              istart = jstart
              jstart = rindx

              rindx = iend
              iend  = jend
              jend  = rindx
            end if
        end if
      end if

      return
      end


c     ****************************************
c     *                                      *
c     *          Butter_indexes_L1           *
c     *                                      *
c     ****************************************

      subroutine Butter_indexes_L1(taskid_j,np_j,na,
     >                             istart,iend,jstart,jend,
     >                             imodn,imodtask)
      implicit none
      integer taskid_j,np_j,na(*)
      integer istart,iend,jstart,jend
      integer imodn,imodtask

*     *** local variables ***
      integer i,shift,size,rsize,rindx,pr,Level,pfrom,rs2

*     **** external functions ****
      integer  Butter_levels
      external Butter_levels

      imodn    = 1
      imodtask = 0

      Level = Butter_levels(np_j)
      shift = 2**(Level-1)
      pfrom = mod(taskid_j + shift,np_j)

      size = ((np_j-2**Level)/2) + 1

      rsize = 0
      do i=0,size-1
        pr = mod(pfrom + i,np_j)
        rsize = rsize + na(pr+1)
      end do

      pr = mod(pfrom + size-1,np_j)
      rs2 = na(pr+1)

      rindx = 1
      do i=0,shift-1
        pr    = mod(taskid_j + i,np_j)
        rindx = rindx + na(pr+1)
      end do
      istart = 1
      iend   = na(taskid_j+1)
      jstart = rindx
      jend   = rindx + rsize - 1
      jend   = jend - rs2 

      return
      end


c     ****************************************
c     *                                      *
c     *          Butter_indexes_L2           *
c     *                                      *
c     ****************************************

      subroutine Butter_indexes_L2(taskid_j,np_j,na,
     >                             istart,iend,jstart,jend,
     >                             imodn,imodtask)
      implicit none
      integer taskid_j,np_j,na(*)
      integer istart,iend,jstart,jend
      integer imodn,imodtask

*     *** local variables ***
      integer i,shift,size,rsize,rindx,pr,Level,pfrom,rs2

*     **** external functions ****
      integer  Butter_levels
      external Butter_levels

      imodn    = 1
      imodtask = 0

      Level = Butter_levels(np_j)
      shift = 2**(Level-1)
      pfrom = mod(taskid_j + shift,np_j)

      size = ((np_j-2**Level)/2) + 1

      rsize = 0
      do i=0,size-1
        pr = mod(pfrom + i,np_j)
        rsize = rsize + na(pr+1)
      end do

      pr = mod(pfrom + size-1,np_j)
      rs2 = na(pr+1)

      rindx = 1
      do i=0,shift-1
        pr    = mod(taskid_j + i,np_j)
        rindx = rindx + na(pr+1)
      end do
      istart = 1
      iend   = na(taskid_j+1)
c      jstart = rindx
      jend   = rindx + rsize - 1
      jstart = jend - rs2 + 1

*     *** last level and even ***
      if (mod(np_j,2).eq.0) then

*        *** first np_j/2 procs do even computations, ***
*        *** second np_j/2 proces do odd computations ***
         imodn    = 2
         imodtask = taskid_j/(np_j/2)
         if (imodtask.eq.1) then
           rindx  = istart
           istart = jstart
           jstart = rindx

           rindx = iend
           iend  = jend
           jend  = rindx
         end if
      end if

      return
      end

C> \ingroup nwint
C> @{
C>
C> \brief Compute integral 2nd derivative of the ECP integrals
C>
C> Compute the integral 2nd derivatives of the 1-electron Hamiltonian
C> \f{eqnarray*}{
C>    \sum_C\frac{\partial^2(\mu|\hat{H}_{C}|\rho)}{\partial X_x\partial X_y}
C>    = \sum_C\int_{-\infty}^{\infty}
C>    \frac{\partial^2\chi_\mu(R_A;r_1)\hat{H}_C\chi_\rho(R_B;r_1)}{\partial X_x\partial X_y} dr_1
C> \f}
C> The integrals are returned in an order that is equivalent to the 
C> dimensions `H1a(nint,ncoord,ncoord,natom*(natom+1)/2)`, where `nint`
C> is the number of integrals generated by the shell pair, `ncoord` is the
C> number of Cartesian coordinates, and `natom` is the number of atoms.
C> The first `ncoord` coordinates correspond to the Cartesian coordinates of
C> the atom that goes with `ish`, and the second `ncoord` coordinates go with
C> `jsh`. The atom numbers generate a triangle where `jat` is greater equal than
C> `iat`.
C> 
      subroutine intdd_1eecp1(i_basis,ish,j_basis,jsh,lscr,scr,
     &       lH1a,H1a)
C $Id: intdd_1eecp1.F 23281 2012-12-14 18:58:42Z d3y133 $
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
c
c layer routine to compute the derivative 1 electron hamiltonian integrals
c for shells/contractions ish,jsh
c
c Order is...   nint*3*nat (3=> xyz, nat=number of atoms)
c
c  /                   |   
c | nint,d <ij>        |
c |      --------------|
c  \     d[idatom(1),x]|
c                          |
c       nint,d <ij>        |
c            --------------|
c            d[idatom(1),y]|
c                              |
c           nint,d <ij>        |
c                --------------|
c                d[idatom(1),z]|
c                                  |
c               nint,d <ij>        |
c                    --------------|
c                    d[idatom(2),x]|
c                                      |
c                   nint,d <ij>        |
c                        --------------|
c                        d[idatom(2),y]|
c                                           |
c                       nint,d <ij>         |
c                            -------------- |
c                            d[idatom(2),z] |
c
c                                  . . . 
c                                                            |
c                                         nint,d <ij>        |
c                                              --------------|
c                                            d[idatom(nat),x]|
c                                                                |
c                                             nint,d <ij>        |
c                                                  --------------|
c                                                d[idatom(nat),y]|
c                                                                    \
c                                                 nint,d <ij>         |
c                                                      -------------- |
c                                                    d[idatom(nat),z]/
c      
c::functions
      integer int_nint_cart
      external int_nint_cart
c::passed
      integer i_basis   !< [Input] ish basis set handle
      integer ish       !< [Input] `i` contraction index
      integer j_basis   !< [Input] jsh basis set handle
      integer jsh       !< [Input] `j` contraction index
      integer lscr      !< [Input] length of scratch space
      integer lH1a      !< [Input] number of h1 integral derivatives in shells ish and jsh
c                       ! NOTE: nint*3 integral derivatives returned per unique center
      double precision scr(lscr) !< [Input] scratch array
      double precision H1a(*)    !< [Output] derivative integrals
c
c::local
      integer nint, offset, nat
c
      nat = ncenter(ibs_geom((i_basis + Basis_Handle_Offset)))
c
      nint = int_nint_cart(i_basis,ish,j_basis,jsh,0,0,0,0)
      if (nint*3*3*(nat*(nat-1)/2+nat).gt.lH1a) then
        write(luout,*) 'nint*3*3*(nat*(nat-1)/2+nat) = ',
     &                 nint*3*3*(nat*(nat-1)/2+nat)
        write(luout,*) 'lH1a       = ',lH1a
        call errquit('intd_1eecp: nint>lH1a error',911, INT_ERR)
      endif
c
      call intdd_1eecp1P(i_basis,ish,j_basis,jsh,
     &       lscr,scr,nint,H1a,nat)
c
      end
      subroutine intdd_1eecp1P(i_basis,ish,j_basis,jsh,lscr,scr,
     &       nint,H1a,nat)
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "apiP.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
c::external subroutines used
c... errquit
c::passed
      integer i_basis   ! [input] ish basis set handle
      integer ish       ! [input] ``i'' contraction index
      integer j_basis   ! [input] jsh basis set handle
      integer jsh       ! [input] ``j'' contraction index
      integer lscr      ! [input] length of scratch space 
      integer nat       ! [input] number of atoms
      integer nint      ! [input] number of integrals in shells ish and jsh
c                       ! NOTE: nint*3*3 integral derivatives returned per unique center
      double precision scr(lscr) ! [input] scratch array
      double precision H1a(nint,3,3,nat*(nat-1)/2+nat)    ! [output] derivative integrals (nint,3,3,n_atoms)
c::local
      logical doT
      integer ucont
      integer ibas,iatom,inp,igen,iexp,icf,itype,igeom
      integer jbas,jatom,jnp,jgen,jexp,jcf,jtype,jgeom
      integer i_nbf_x, j_nbf_x
      integer i_nbf_s, j_nbf_s
      integer nint_x, nint_s
      integer zatom, zyx1, zyx2, nintV, offset
c
      logical any_spherical
c
c  Temporary variable that needs to be taken out after testing!
c
c     integer itemp,jtemp,ktemp,ltemp
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c  check if gencon/sp shells
c
      call int_nogencont_check(i_basis,'intd_1eh1P:i_basis')
      call int_nogencont_check(j_basis,'intd_1eh1P:j_basis')
      call int_nospshell_check(i_basis,'intd_1eh1P:i_basis')
      call int_nospshell_check(j_basis,'intd_1eh1P:j_basis')
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
c
      ucont = (sf_ibs_cn2ucn(ish,ibas))
      inp   = infbs_cont(CONT_NPRIM,ucont,ibas)
      igen  = infbs_cont(CONT_NGEN,ucont,ibas)
      iexp  = infbs_cont(CONT_IEXP,ucont,ibas)
      icf   = infbs_cont(CONT_ICFP,ucont,ibas)
      itype = infbs_cont(CONT_TYPE,ucont,ibas) 
      igeom = ibs_geom(ibas)
      iatom = (sf_ibs_cn2ce(ish,ibas))
c
      ucont = (sf_ibs_cn2ucn(jsh,jbas))
      jnp   = infbs_cont(CONT_NPRIM,ucont,jbas)
      jgen  = infbs_cont(CONT_NGEN,ucont,jbas)
      jexp  = infbs_cont(CONT_IEXP,ucont,jbas)
      jcf   = infbs_cont(CONT_ICFP,ucont,jbas)
      jtype = infbs_cont(CONT_TYPE,ucont,jbas) 
      jgeom = ibs_geom(jbas)
      jatom = (sf_ibs_cn2ce(jsh,jbas))
c
      if (igeom.ne.jgeom) then
        write(luout,*)'intdd_1eh1P.F: two different geometries for',
     &         ' derivatives?'
        call errquit('intdd_1eh1P: geom error ',911, GEOM_ERR)
      endif
c
      if (iatom.eq.jatom) then
        doT = .false.
      else
        doT = .true.
      endif
c       
      nat = ncenter(igeom)  ! needed for both ecp and spherical
        nintV = int_nbf_x(itype)*int_nbf_x(jtype)
        call intdd_ecp_hf1(
     &      coords(1,iatom,igeom),
     &      dbl_mb(mb_exndcf(iexp,ibas)),
     &      dbl_mb(mb_exndcf(icf,ibas)),
     &      inp,igen,itype,iatom,
c
     &      coords(1,jatom,jgeom),
     &      dbl_mb(mb_exndcf(jexp,jbas)),
     &      dbl_mb(mb_exndcf(jcf,jbas)),
     &      jnp,jgen,jtype,jatom,
c
     &      H1a,nintV,nat,
     &      scr,lscr,
     &      .false.)
c
      any_spherical = bas_spherical(ibas).or.bas_spherical(jbas)
      if (.not.any_spherical) return
c
c ... reset general contractions for sp shells to 1 since they are handled
c     as a block of 4.
c
      if (itype.eq.-1) igen = 1
      if (jtype.eq.-1) jgen = 1
c
      if (bas_spherical(ibas).and.bas_spherical(jbas)) then
*... transform both i and j integrals
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = int_nbf_s(Itype)
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = int_nbf_s(Jtype)
c
        do zatom = 1,(nat*(nat-1)/2+nat)
         do zyx2 = 1,3
          do zyx1 = 1,3
            call spcart_tran1e(H1a(1,zyx1,zyx2,zatom),scr,
     &          j_nbf_x,i_nbf_x,Jtype,jgen,
     &          j_nbf_s,i_nbf_s,Itype,igen,
     &          .false.)
          enddo
         enddo
        enddo
      else if (bas_spherical(ibas)) then
*.. transform on i component
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = int_nbf_s(Itype)
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = j_nbf_x
        do zatom = 1,(nat*(nat-1)/2+nat)
         do zyx2 = 1,3
          do zyx1 = 1,3
            call spcart_tran1e(H1a(1,zyx1,zyx2,zatom),scr,
     &          j_nbf_x,i_nbf_x,0,jgen,
     &          j_nbf_s,i_nbf_s,Itype,igen,
     &          .false.)
          enddo
         enddo
        enddo
      else if (bas_spherical(jbas)) then
*.. transform on j component
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = i_nbf_x
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = int_nbf_s(Jtype)
        do zatom = 1,(nat*(nat-1)/2+nat)
         do zyx2 = 1,3
          do zyx1 = 1,3
            call spcart_tran1e(H1a(1,zyx1,zyx2,zatom),scr,
     &          j_nbf_x,i_nbf_x,Jtype,jgen,
     &          j_nbf_s,i_nbf_s,0,igen,
     &          .false.)
          enddo
         enddo
        enddo
      else
      call errquit(
     &        'intdd_1eecp1P: cant do sphericals',911 ,INT_ERR)
      endif
c
c now shuffle transformed buffers to contiguous space
c
      nint_x = i_nbf_x*j_nbf_x
      nint_s = i_nbf_s*j_nbf_s
      if (nint_s.gt.nint_x) then
        call errquit
     &   ('intdd_1eecp1P: nint_s >.nint_x diff=',(nint_s-nint_x),
     &   INT_ERR)
      elseif (nint_s.eq.nint_x) then
        return
      else
        call int_c2s_mv 
     &      (H1a,nint_x,nint_s,(9*(nat*(nat-1)/2+nat)),scr,lscr,
     &       'intdd_1eecp1P')
      endif
c
      end
C> @}

      double precision function schwarz_atom(iat, jat)
C$Id: schwarz_atom.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "cschwarz.fh"
#include "mafdecls.fh"
      integer iat, jat
      double precision value
#include "itri.fh"
c
      call comp4_extract(int_mb(k_cat), itri(iat,jat), value, nb_per_i)
      schwarz_atom = value
c
      end

*> \brief \b DLAEDA used by sstedc. Computes the Z vector determining the rank-one modification of the diagonal matrix. Used when the original matrix is dense.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLAEDA + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlaeda.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlaeda.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlaeda.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLAEDA( N, TLVLS, CURLVL, CURPBM, PRMPTR, PERM, GIVPTR,
*                          GIVCOL, GIVNUM, Q, QPTR, Z, ZTEMP, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            CURLVL, CURPBM, INFO, N, TLVLS
*       ..
*       .. Array Arguments ..
*       INTEGER            GIVCOL( 2, * ), GIVPTR( * ), PERM( * ),
*      $                   PRMPTR( * ), QPTR( * )
*       DOUBLE PRECISION   GIVNUM( 2, * ), Q( * ), Z( * ), ZTEMP( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLAEDA computes the Z vector corresponding to the merge step in the
*> CURLVLth step of the merge process with TLVLS steps for the CURPBMth
*> problem.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*> \endverbatim
*>
*> \param[in] TLVLS
*> \verbatim
*>          TLVLS is INTEGER
*>         The total number of merging levels in the overall divide and
*>         conquer tree.
*> \endverbatim
*>
*> \param[in] CURLVL
*> \verbatim
*>          CURLVL is INTEGER
*>         The current level in the overall merge routine,
*>         0 <= curlvl <= tlvls.
*> \endverbatim
*>
*> \param[in] CURPBM
*> \verbatim
*>          CURPBM is INTEGER
*>         The current problem in the current level in the overall
*>         merge routine (counting from upper left to lower right).
*> \endverbatim
*>
*> \param[in] PRMPTR
*> \verbatim
*>          PRMPTR is INTEGER array, dimension (N lg N)
*>         Contains a list of pointers which indicate where in PERM a
*>         level's permutation is stored.  PRMPTR(i+1) - PRMPTR(i)
*>         indicates the size of the permutation and incidentally the
*>         size of the full, non-deflated problem.
*> \endverbatim
*>
*> \param[in] PERM
*> \verbatim
*>          PERM is INTEGER array, dimension (N lg N)
*>         Contains the permutations (from deflation and sorting) to be
*>         applied to each eigenblock.
*> \endverbatim
*>
*> \param[in] GIVPTR
*> \verbatim
*>          GIVPTR is INTEGER array, dimension (N lg N)
*>         Contains a list of pointers which indicate where in GIVCOL a
*>         level's Givens rotations are stored.  GIVPTR(i+1) - GIVPTR(i)
*>         indicates the number of Givens rotations.
*> \endverbatim
*>
*> \param[in] GIVCOL
*> \verbatim
*>          GIVCOL is INTEGER array, dimension (2, N lg N)
*>         Each pair of numbers indicates a pair of columns to take place
*>         in a Givens rotation.
*> \endverbatim
*>
*> \param[in] GIVNUM
*> \verbatim
*>          GIVNUM is DOUBLE PRECISION array, dimension (2, N lg N)
*>         Each number indicates the S value to be used in the
*>         corresponding Givens rotation.
*> \endverbatim
*>
*> \param[in] Q
*> \verbatim
*>          Q is DOUBLE PRECISION array, dimension (N**2)
*>         Contains the square eigenblocks from previous levels, the
*>         starting positions for blocks are given by QPTR.
*> \endverbatim
*>
*> \param[in] QPTR
*> \verbatim
*>          QPTR is INTEGER array, dimension (N+2)
*>         Contains a list of pointers which indicate where in Q an
*>         eigenblock is stored.  SQRT( QPTR(i+1) - QPTR(i) ) indicates
*>         the size of the block.
*> \endverbatim
*>
*> \param[out] Z
*> \verbatim
*>          Z is DOUBLE PRECISION array, dimension (N)
*>         On output this vector contains the updating vector (the last
*>         row of the first sub-eigenvector matrix and the first row of
*>         the second sub-eigenvector matrix).
*> \endverbatim
*>
*> \param[out] ZTEMP
*> \verbatim
*>          ZTEMP is DOUBLE PRECISION array, dimension (N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit.
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERcomputational
*
*> \par Contributors:
*  ==================
*>
*> Jeff Rutter, Computer Science Division, University of California
*> at Berkeley, USA
*
*  =====================================================================
      SUBROUTINE DLAEDA( N, TLVLS, CURLVL, CURPBM, PRMPTR, PERM, GIVPTR,
     $                   GIVCOL, GIVNUM, Q, QPTR, Z, ZTEMP, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            CURLVL, CURPBM, INFO, N, TLVLS
*     ..
*     .. Array Arguments ..
      INTEGER            GIVCOL( 2, * ), GIVPTR( * ), PERM( * ),
     $                   PRMPTR( * ), QPTR( * )
      DOUBLE PRECISION   GIVNUM( 2, * ), Q( * ), Z( * ), ZTEMP( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, HALF, ONE
      PARAMETER          ( ZERO = 0.0D0, HALF = 0.5D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            BSIZ1, BSIZ2, CURR, I, K, MID, PSIZ1, PSIZ2,
     $                   PTR, ZPTR1
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMV, DROT, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, INT, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -1
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAEDA', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine location of first number in second half.
*
      MID = N / 2 + 1
*
*     Gather last/first rows of appropriate eigenblocks into center of Z
*
      PTR = 1
*
*     Determine location of lowest level subproblem in the full storage
*     scheme
*
      CURR = PTR + CURPBM*2**CURLVL + 2**( CURLVL-1 ) - 1
*
*     Determine size of these matrices.  We add HALF to the value of
*     the SQRT in case the machine underestimates one of these square
*     roots.
*
      BSIZ1 = INT( HALF+SQRT( DBLE( QPTR( CURR+1 )-QPTR( CURR ) ) ) )
      BSIZ2 = INT( HALF+SQRT( DBLE( QPTR( CURR+2 )-QPTR( CURR+1 ) ) ) )
      DO 10 K = 1, MID - BSIZ1 - 1
         Z( K ) = ZERO
   10 CONTINUE
      CALL DCOPY( BSIZ1, Q( QPTR( CURR )+BSIZ1-1 ), BSIZ1,
     $            Z( MID-BSIZ1 ), 1 )
      CALL DCOPY( BSIZ2, Q( QPTR( CURR+1 ) ), BSIZ2, Z( MID ), 1 )
      DO 20 K = MID + BSIZ2, N
         Z( K ) = ZERO
   20 CONTINUE
*
*     Loop through remaining levels 1 -> CURLVL applying the Givens
*     rotations and permutation and then multiplying the center matrices
*     against the current Z.
*
      PTR = 2**TLVLS + 1
      DO 70 K = 1, CURLVL - 1
         CURR = PTR + CURPBM*2**( CURLVL-K ) + 2**( CURLVL-K-1 ) - 1
         PSIZ1 = PRMPTR( CURR+1 ) - PRMPTR( CURR )
         PSIZ2 = PRMPTR( CURR+2 ) - PRMPTR( CURR+1 )
         ZPTR1 = MID - PSIZ1
*
*       Apply Givens at CURR and CURR+1
*
         DO 30 I = GIVPTR( CURR ), GIVPTR( CURR+1 ) - 1
            CALL DROT( 1, Z( ZPTR1+GIVCOL( 1, I )-1 ), 1,
     $                 Z( ZPTR1+GIVCOL( 2, I )-1 ), 1, GIVNUM( 1, I ),
     $                 GIVNUM( 2, I ) )
   30    CONTINUE
         DO 40 I = GIVPTR( CURR+1 ), GIVPTR( CURR+2 ) - 1
            CALL DROT( 1, Z( MID-1+GIVCOL( 1, I ) ), 1,
     $                 Z( MID-1+GIVCOL( 2, I ) ), 1, GIVNUM( 1, I ),
     $                 GIVNUM( 2, I ) )
   40    CONTINUE
         PSIZ1 = PRMPTR( CURR+1 ) - PRMPTR( CURR )
         PSIZ2 = PRMPTR( CURR+2 ) - PRMPTR( CURR+1 )
         DO 50 I = 0, PSIZ1 - 1
            ZTEMP( I+1 ) = Z( ZPTR1+PERM( PRMPTR( CURR )+I )-1 )
   50    CONTINUE
         DO 60 I = 0, PSIZ2 - 1
            ZTEMP( PSIZ1+I+1 ) = Z( MID+PERM( PRMPTR( CURR+1 )+I )-1 )
   60    CONTINUE
*
*        Multiply Blocks at CURR and CURR+1
*
*        Determine size of these matrices.  We add HALF to the value of
*        the SQRT in case the machine underestimates one of these
*        square roots.
*
         BSIZ1 = INT( HALF+SQRT( DBLE( QPTR( CURR+1 )-QPTR( CURR ) ) ) )
         BSIZ2 = INT( HALF+SQRT( DBLE( QPTR( CURR+2 )-QPTR( CURR+
     $           1 ) ) ) )
         IF( BSIZ1.GT.0 ) THEN
            CALL DGEMV( 'T', BSIZ1, BSIZ1, ONE, Q( QPTR( CURR ) ),
     $                  BSIZ1, ZTEMP( 1 ), 1, ZERO, Z( ZPTR1 ), 1 )
         END IF
         CALL DCOPY( PSIZ1-BSIZ1, ZTEMP( BSIZ1+1 ), 1, Z( ZPTR1+BSIZ1 ),
     $               1 )
         IF( BSIZ2.GT.0 ) THEN
            CALL DGEMV( 'T', BSIZ2, BSIZ2, ONE, Q( QPTR( CURR+1 ) ),
     $                  BSIZ2, ZTEMP( PSIZ1+1 ), 1, ZERO, Z( MID ), 1 )
         END IF
         CALL DCOPY( PSIZ2-BSIZ2, ZTEMP( PSIZ1+BSIZ2+1 ), 1,
     $               Z( MID+BSIZ2 ), 1 )
*
         PTR = PTR + 2**( TLVLS-K )
   70 CONTINUE
*
      RETURN
*
*     End of DLAEDA
*
      END
c $Id: dlaeda.f 24343 2013-06-22 05:35:15Z d3y133 $

c
c $Id: nwpw_library.F 21796 2012-01-17 01:52:35Z bylaska $
c
	subroutine nwpw_libgeninp(iopt,element,filename)
	implicit none
        integer iopt
	character*(*) element ! [in]
	character*(*) filename

#include "errquit.fh"
#include "inp.fh"
#include "stdio.fh"


c
	character*255 elem_fname
	integer lef,unitrc,library_type
	logical isopen
c
	call nwpw_libfile(iopt,elem_fname,element,library_type)
	lef=inp_strlen(elem_fname)
c
c       open the library file
c
	unitrc = 68
 1	continue
	unitrc = unitrc + 1
	if (unitrc.gt.80) then
	   write(luout,*)' could not find a free unit 69->80'
	   call errquit('bas_input: no free units for library',911,
     &       BASIS_ERR)
	endif
	inquire(unit=unitrc,opened=isopen)
	if (isopen) goto 1
	open (unit=unitrc,  file=elem_fname,
     &        status='old', err=98,
     &        form='formatted',
     &        access='sequential')
	open (unit=unitrc+1,  file=filename,
     &        status='new', err=99,
     &        form='formatted',
     &        access='sequential')
	call nwpw_libparse(library_type,unitrc,unitrc+1)
	close(unitrc)
	close(unitrc+1)

        call util_file_copy(elem_fname,filename)

	return
 98	continue
	write(luout,*) 'problems opening library file ',elem_fname
	call errquit('nwpw_libgeninp: nwpw failed ',0, DISK_ERR)
 99	continue
	write(luout,*) 'problems opening psp input file ',filename
	call errquit('nwpw failed ',0, DISK_ERR)
	return
	end
	integer function nwpw_libglmax(atom)
	implicit none
#include "nwpw_inp.fh"
 	character*(*) atom
	nwpw_libglmax= lmax_read
	return
	end
	integer function nwpw_libglocp(atom)
	implicit none
#include "nwpw_inp.fh"
	character*(*) atom
	nwpw_libglocp= locp_read
	return
	end

	integer function nwpw_libgpsp_type(atom)
	implicit none
#include "nwpw_inp.fh"
	character*(*) atom
	nwpw_libgpsp_type= psp_type
	return
	end

	integer function nwpw_libgefg_type(atom)
	implicit none
#include "nwpw_inp.fh"
	character*(*) atom
	nwpw_libgefg_type= efg_type
	return
	end

	double precision function nwpw_libgrlocal(atom)
	implicit none
#include "nwpw_inp.fh"
	character*(*) atom
	nwpw_libgrlocal = rlocal_read
	return
	end

	double precision function nwpw_libgcutoff(atom)
	implicit none
#include "nwpw_inp.fh"
	character*(*) atom
	nwpw_libgcutoff = cutoff_read
	return
	end

	subroutine nwpw_libparse(library_type,u_library,u_psp_inp)
	implicit none
#include "errquit.fh"
#include "inp.fh"
#include "nwpw_inp.fh"
        integer library_type
	integer u_library,u_psp_inp
	character*1024 line
	character*12 keyread
c
	integer l_lgth,i,sqptr_l,sqptr_r,k_lgth
	integer read_int
	double precision read_float
	logical gotsq
c
c       square parenthesis [] are used for lmax locp rlocal
c
	lmax_read=-1
	locp_read=-1
	rlocal_read=1.d0
        psp_type=0
        efg_type=0
        cutoff_read = 30.0d0

        if      (library_type.eq.2) then
          psp_type = 2
        else if (library_type.eq.3) then
          psp_type = 3
        end if

 1	continue
	read(u_library,'(A)',end=2001,err=2002) line
	l_lgth=inp_strlen(line)
c
c       scan for [
c
	gotsq=.false.
	do i=1,l_lgth
	   if(line(i:i).eq.'[') then
	      gotsq=.true.
	      sqptr_l=i
	   endif
	enddo
	if(gotsq) then
	   do i=sqptr_l,l_lgth
	      if(line(i:i).eq.']') then
		 sqptr_r=i
	      endif
	   enddo
	   keyread=line(sqptr_l+1:sqptr_r-1)
	   k_lgth=sqptr_r-sqptr_l-1
c       keyword recognition
c       lmax
	   if(keyread(1:k_lgth).eq.'lmax') then
	      read(line(sqptr_r+1:l_lgth),*) lmax_read
	   elseif(keyread(1:k_lgth).eq.'locp') then
	      read(line(sqptr_r+1:l_lgth),*) locp_read
	   elseif(keyread(1:k_lgth).eq.'rlocal') then
	      read(line(sqptr_r+1:l_lgth),*) rlocal_read
	   elseif(keyread(1:k_lgth).eq.'cutoff') then
	      read(line(sqptr_r+1:l_lgth),*) cutoff_read
	   elseif(keyread(1:k_lgth).eq.'psp_type') then
	      read(line(sqptr_r+1:l_lgth),*) psp_type
	   elseif(keyread(1:k_lgth).eq.'efg_type') then
	      read(line(sqptr_r+1:l_lgth),*) efg_type
	   else
	      write(0,*) ' failed keyword recognition for',
     .  keyread(1:k_lgth)
c       should be put warning for non recognized keyword?
	   endif
	else
	   write(u_psp_inp,*) line(1:l_lgth)
	endif
	goto 1
 2001	continue
	return
 2002	call errquit('read error in nwpwlibparse',0, DISK_ERR)
	end

      subroutine argos_cafe_initb(id,ntot,nbt,nbp,nht,nhp,ndt,
     + ndp,nit,nip,ntt,ntp,nxt,nxp,na)
c
c     argos_cafe_init initializes the classical forces API routines
c
c     in:  nbt, integer number of bond types
c          nbp, integer number of parameters per bond type
c          nht, integer number of angle types
c          nhp, integer number of parameters per angle type
c          ndt, integer number of dihedral types
c          ndp, integer number of parameters per dihedral type
c          nit, integer number of improper dihedral types
c          nip, integer number of parameters per improper dihedral type
c
c     this routine allocates the memory necessary to store all
c     force field parameters
c
      implicit none
c
      integer id,ntot,nbt,nbp,nht,nhp,ndt,ndp,nit,nip,ntt,ntp,nxt,nxp
      integer na
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      nbs=nbs+1
      if(nbs.gt.mbs) call md_abort('Error 1 in initb',0)
      if(id.ne.nbs) call md_abort('Error 2 in initb',0)
c
      numb(id)=nbt
      numh(id)=nht
      numd(id)=ndt
      numi(id)=nit
      numt(id)=ntt
      numx(id)=nxt
c
      mbt(id)=max(1,nbt)
      mbp(id)=max(1,nbp)
      mht(id)=max(1,nht)
      mhp(id)=max(1,nhp)
      mdt(id)=max(1,ndt)
      mdp(id)=max(1,ndp)
      mit(id)=max(1,nit)
      mip(id)=max(1,nip)
      mtt(id)=max(ntot,ntt)
      mtp(id)=max(2,ntp)
      mxt(id)=max(ntot,nxt)
      mxp(id)=max(2,nxp)
c
c     allocate memory
c
c     for bond types
c
      if(.not.ma_push_get(mt_dbl,mbt(id)*mbp(id)*mset,'bnd',
     + l_bnd(id),i_bnd(id)))
     + call md_abort('Allocation failed for bnd',0)
      if(.not.ma_push_get(mt_int,mbt(id)*mbp(id)*3,'ibnd',
     + l_ibnd(id),i_ibnd(id)))
     + call md_abort('Allocation failed for ibnd',0)
      if(.not.ma_push_get(mt_dbl,mbt(id)*2,'rbnd',
     + l_rbnd(id),i_rbnd(id)))
     + call md_abort('Allocation failed for rbnd',0)
c
c     for angle types
c
      if(.not.ma_push_get(mt_dbl,mht(id)*mhp(id)*mset,'ang',
     + l_ang(id),i_ang(id)))
     + call md_abort('Allocation failed for ang',0)
      if(.not.ma_push_get(mt_int,mht(id)*mhp(id)*4,'iang',
     + l_iang(id),i_iang(id)))
     + call md_abort('Allocation failed for iang',0)
      if(.not.ma_push_get(mt_dbl,mht(id)*2,'rang',
     + l_rang(id),i_rang(id)))
     + call md_abort('Allocation failed for rang',0)
c
c     for Urey-Bradley terms
c
      if(.not.ma_push_get(mt_dbl,mht(id)*2,'rub',
     + l_rub(id),i_rub(id)))
     + call md_abort('Allocation failed for rub',0)
c
c     for dihedral types
c
      if(.not.ma_push_get(mt_dbl,mdt(id)*mdp(id)*mset,'dih',
     + l_dih(id),i_dih(id)))
     + call md_abort('Allocation failed for dih',0)
      if(.not.ma_push_get(mt_int,mdt(id)*mdp(id)*5,'idih',
     + l_idih(id),i_idih(id)))
     + call md_abort('Allocation failed for idih',0)
      if(.not.ma_push_get(mt_dbl,mdt(id)*2,'rdih',
     + l_rdih(id),i_rdih(id)))
     + call md_abort('Allocation failed for rdih',0)
c
c     for improper dihedral types
c
      if(.not.ma_push_get(mt_dbl,mit(id)*mip(id)*mset,'imp',
     + l_imp(id),i_imp(id)))
     + call md_abort('Allocation failed for imp',0)
      if(.not.ma_push_get(mt_int,mit(id)*mip(id)*5,'iimp',
     + l_iimp(id),i_iimp(id)))
     + call md_abort('Allocation failed for iimp',0)
      if(.not.ma_push_get(mt_dbl,mit(id)*2,'rimp',
     + l_rimp(id),i_rimp(id)))
     + call md_abort('Allocation failed for rimp',0)
c
c     for third neighbor lists
c
      if(.not.ma_push_get(mt_int,(mtt(id)+1)*mtp(id),'trd',
     + l_itrd(id),i_itrd(id)))
     + call md_abort('Allocation failed for trd',0)
c
c     for excluded or non-bonded lists
c
      if(.not.ma_push_get(mt_int,(mxt(id)+1)*mxp(id),'xcl',
     + l_ixcl(id),i_ixcl(id)))
     + call md_abort('Allocation failed for xcl',0)
c
      if(id.eq.1.and.mwa.gt.0) then
      if(.not.ma_push_get(mt_int,mwa,'iwa',l_iwa,i_iwa))
     + call md_abort('Allocation failed for iw',0)
      if(.not.ma_push_get(mt_int,mwa,'iwq',l_iwq,i_iwq))
     + call md_abort('Allocation failed for iwq',0)
      endif
c
      if(id.eq.2.and.msm.gt.0) then
      if(.not.ma_push_get(mt_dbl,msm,'wsm',l_wsm,i_wsm))
     + call md_abort('Allocation failed for wsm',0)
c
      endif
c
      return
      end
c $Id: argos_cafe_initb.F 21176 2011-10-10 06:35:49Z d3y133 $

C $Id: pmlqa.F 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine drdy_pmlqa (n3tm,n3,ndbar,x,dx,fmat,hess,amass,dels,
     *    vec0,vec1,u0,xlam,alpha,ierr)
C
C Given x, dx, fmat, and fold compute next step along the MEP using
C   the Page-McIver LQA algorithm
C
C   x     - vector of mass-weighted coordinates
C   dx    - vector of mass-weighted gradient
C   fmat  - hessian matrix in mass-weighted coordinates
C   amass - vector of the sqrt root of the ratio of the atomic and reduced masses
C   dels  - step size in s
C   vec0,vec1,u0,xlam,alpha - scratch arrays
C   ierr  - error flag
C
      Implicit none
#include "errquit.fh"
C
      Integer n3tm,n3,ndbar,ierr
      Double Precision x(n3),dx(n3),fmat(n3tm,n3),hess(ndbar),
     *   amass(n3),dels,vec0(n3),vec1(n3),u0(n3tm,n3),xlam(n3),
     *   alpha(n3)
C
      Integer i,ic1,ic2,j
      Double Precision arg,delt,ft,ftlast,s,slast,sum,t,ts,xnorm
C
      Integer icmax
      Data icmax/1000000/
      Integer fu6
      Data fu6/6/
C
      ierr = 0
C Normalize gradient
      xnorm = 0.0d00
      do i = 1,n3
         xnorm = xnorm + dx(i)*dx(i)
      enddo
      xnorm = sqrt(xnorm)
      do i = 1,n3
         vec0(i) = dx(i)/xnorm
      enddo
C      write (fu6,*) ' in pmlqa, fmat='
C      write (fu6,*) ((fmat(j,i),j=1,i),i=1,n3)
      Call drdy_diagf
     &      (n3tm,n3,fmat,hess,xlam,u0,alpha,vec1,ierr)
      if (ierr.ne.0) then
         write(fu6,6000) ierr
         call errquit('drdy_pmlqa:drdy_diagf error',555, UNKNOWN_ERR)
      endif
C Page-McIver LQA algorithm
C Construct u0(transpose)*vec0 and put into vec1, and scale xlam by xnorm
      do i = 1,n3
         xlam(i) = xlam(i)/xnorm
         vec1(i) = 0.0d00
         do j = 1,n3
            vec1(i) = vec1(i) + u0(j,i)*vec0(j)
         enddo
      enddo
C      write (fu6,668) (xlam(i),i=1,n3)
C      write (fu6,669) (vec1(i),i=1,n3)
C Integrate expression that relates s to t
      delt = 0.2d00*dels
      t = 1.0d10
      ts = 0.0d00
      ic1 = 0
      ic2 = 0
C Loop over step size for integration (delt) until converged or maximum
C   iterations
      do while (abs(1.0d00-ts/t).gt.1.d-6.and.ic1.le.15.and.
     *          ic2.lt.icmax)
         ic1 = ic1 + 1
         ts = t
         delt = 0.5d00*delt
         t = 0.0d00
C Get integrand at t=0
         Call drdy_dsdt (n3,vec1,xlam,t,ft)
         s = 0.0d00
         ic2 = 0
C Integration loop, integrate until s>dels using trapezoidal rule
         do while (s.lt.dels .and. ic2.le.icmax)
            ic2 = ic2 + 1
            slast = s
            ftlast = ft
            t = t + delt
            Call drdy_dsdt (n3,vec1,xlam,t,ft)
            s = s + 0.5d00*delt*(ft + ftlast)
         enddo
C Integration complete, linearly interpolate t to s=dels
         t = t - (dels-s)*delt/(slast-s)
C         write (fu6,670) ic1,ic2,delt,t,1.0-ts/t
      enddo
      if (abs(1.0d00-t/ts).le.1.d-6) then
C Construct alpha*g0'
         do i = 1,n3
            arg = xlam(i)*t
            if (abs(arg).lt.1.d-8) then
               alpha(i) = -t*(1.0d00-arg*(0.5d00-arg/6.0d00))*vec1(i)
            else
               alpha(i) = (exp(-arg) - 1.0d00)*vec1(i)/xlam(i)
            endif
         enddo
C  Take step and unscale XLAM
         do i = 1,n3
            xlam(i) = xnorm*xlam(i)
            sum = x(i)
            do j = 1,n3
               sum = sum + u0(i,j)*alpha(j)
            enddo
            x(i) = sum
         enddo
      else
         write (fu6,6002) ic1,ic2
         ierr = 1
      end if
      return
668   format (' xlam=',/,(1x,1p5e15.7))
669   format (' go=',/,(1x,1p5e15.7))
670   format (' ic1,ic2,delt,t,err=',2i10,1p3e15.7)
6000  Format (' in subroutine diagf error in call to eispack routine',
     *   ' rsp, ierr=', I5)
6002  FORMAT (' In subroutine PMLQA, Page-McIver LQA algorithm,',
     * ' problem with integration of s(t)',/,
     * ' iterations, ic1,ic2=',2i10)
      end

c     $Id: paw_cgsd_energy.F 20365 2011-05-20 20:54:03Z d3p852 $                       


*     ***************************
*     *                         *
*     *    paw_cgsd_energy      *
*     *                         *
*     ***************************

      real*8 function paw_cgsd_energy(newpsi)
      implicit none

#include "stdio.fh"
#include "util.fh"
#include "mafdecls.fh"
#include "frac_occ.fh"
c#include "global.fh"
c#include "rtdb.fh"
#include "errquit.fh"

      logical newpsi
      integer MASTER
      parameter (MASTER=0)

      logical stalled,value,oprint,psitmp
      integer taskid
      integer minimizer
      integer i,j,ms,neall,NN,ispin
      integer it_in,it_out,icount,bfgscount
      real*8  EV,virial
      real*8  tole,tolc,deltae,deltac,deltae_old
      real*8  cx,cy,cz
      real*8  gx,gy,gz
      real*8  en(2),en1(2),en2(2),r_charge
      real*8  E(30),eorb,ecoul,exc
      integer rtdb

*     **** external functions ****
      logical     control_out_of_time
      logical     control_print,control_psi_tmp
      character*4 ion_aname
      integer     control_it_in, control_it_out,control_minimizer
      integer     ion_nion,ion_katm,paw_psi_ne,paw_psi_ispin
      integer     control_rtdb
      real*8      control_tole,control_tolc
      real*8      ion_rion,paw_psi_eigenvalue,ion_amass
      external control_out_of_time
      external ion_aname
      external control_it_in, control_it_out,control_minimizer
      external ion_nion,ion_katm,paw_psi_ne,paw_psi_ispin,control_rtdb
      external control_print,control_psi_tmp
      external control_tole,control_tolc
      external ion_rion,paw_psi_eigenvalue,ion_amass


      call Parallel_taskid(taskid)
      oprint = ((taskid.eq.MASTER).and.control_print(print_medium))

      psitmp = control_psi_tmp()

*     **** set the minimizer ****
      minimizer = control_minimizer()

*     **** generate phaze factors and local psp and core density ****
      call paw_electron_gen_vl_potential()


*     :::::::::::  begin electron iteration  :::::::::::::::::::::::
      if (oprint) then
         !write(luout,1300)
         write(luout,1301)
         !write(luout,1302)
         write(luout,1304)
         if (minimizer.eq.1) write(luout,1305)
         if (minimizer.eq.2) write(luout,1306)
         if (minimizer.eq.3) write(luout,1307)
         if (minimizer.eq.4) write(luout,1308)
         if (minimizer.eq.5) write(luout,1309)
         if (minimizer.eq.6) write(luout,1311)
         if (minimizer.eq.7) write(luout,1312)
         call util_flush(luout)
      end if

      stalled = .false.
      deltae  = -1.0d-03
      icount=0
      bfgscount=0
      it_in  = control_it_in()
      it_out = control_it_out()
      tole   = control_tole()
      tolc   = control_tolc()
      E(1)=0.0d0
      if (oprint) then
        if (minimizer.eq.5) then
          call nwpw_message(7)
        else
          call nwpw_message(2)
        end if
      end if

      if (oprint) call util_flush(luout)
      if (minimizer.gt.1) call paw_Grsm_list_start()
      if (minimizer.eq.5) it_out = 1
      if (newpsi) then
        call paw_sdminimize(15)
        !call bybminimize(E,deltae,deltac,1,.true.,2)
      end if
   2  continue
         icount = icount + 1
         if (stalled) then
           call paw_sdminimize(0)
           bfgscount = 0 
         end if

         deltae_old = deltae
         if (minimizer.eq.1) then
           bfgscount = bfgscount + 1
           call paw_cgminimize(E,deltae,deltac,bfgscount,it_in)
         else if (minimizer.eq.2) then
           bfgscount = bfgscount + 1
           call paw_bfgsminimize(E,deltae,deltac,bfgscount,minimizer)
         else if (minimizer.eq.3) then
           bfgscount = bfgscount + 1
           !call bfgsminimize(E,deltae,deltac,bfgscount,minimizer)
         else if (minimizer.eq.4) then
           bfgscount = bfgscount + 1
           !call cgminimize2(E,deltae,deltac,bfgscount)
         else if (minimizer.eq.5) then
           bfgscount = bfgscount + 1
           !call bybminimize(E,deltae,deltac,bfgscount,.false.,1)
         else if (minimizer.eq.6) then
           bfgscount = bfgscount + 1
           !call bfgsminimize3(E,deltae,deltac,bfgscount,minimizer)
         else if (minimizer.eq.7) then
           bfgscount = bfgscount + 1
           !call bfgsminimize2(E,deltae,deltac,bfgscount,minimizer)
         end if

         if ((dabs(deltae).gt.dabs(deltae_old)).or.
     >       (dabs(deltae).gt.1.0d-2)          .or.
     >       (deltae.gt.0.0d0)) then
            stalled = .true.
         else
            stalled = .false.
         end if
        
         if (psitmp) then
            call psi_tmp_write()
         end if

         if ((oprint).and.(minimizer.ne.5)) then 
           write(luout,1310) icount*it_in,E(1),deltae,deltac
           call util_flush(luout)
         end if
         if (deltae.gt.0.0d0) then
            if (oprint) 
     >       write(luout,*) 
     >       ' *** energy going up. iteration not terminated'
             stalled = .true.
            !go to 3
         end if
         deltae = dabs(deltae)
         if ((deltae.lt.tole).and.
     >       (deltac.lt.tolc)) then
            if (oprint) 
     >       write(luout,*) ' *** tolerance ok. iteration terminated'
            go to 3
         end if
         if (control_out_of_time()) then
            if (oprint) 
     >       write(luout,*) ' *** out of time. iteration terminated'
           go to 3
         end if

      if (icount.lt.it_out) go to 2
      if (oprint) 
     > write(luout,*) '*** arived at the Maximum iteration.  terminated'

*     :::::::::::  end of electron iteration loop  :::::::::::::::::::::

   3  continue
      if (minimizer.gt.1) call paw_Grsm_list_end()
      if (oprint) CALL NWPW_MESSAGE(3)


*     **** diagonalize hamiltonian and rotate psi  ****
*     **** but skip if doing an SIC calculations   ****
c     BUG!!!!!!
      call paw_psi_spin_density(en1,en2)
      en(1) = en1(1)+en2(1)
      en(2) = en1(2)+en2(2)

      call paw_psi_1gen_hml()

      call paw_psi_diagonalize_hml()
      call paw_psi_1rotate2()
      call paw_psi_2to1()

 

*     **** geometrical center and center of mass of the cluster ****
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)



*:::::::::::::::::   report summary of results  :::::::::::::::::::::::
      if (oprint) then
         neall = (paw_psi_ne(1)+paw_psi_ne(2))
         write(6,1304)
         write(6,1410)
         write(6,*)
c         write(6,1321) r_charge,' (real space)'
         write(6,1320) en(1), en(paw_psi_ispin()),' (real space)'
         write(6,1322) en1(1),en1(paw_psi_ispin()),' (real space)'
         write(6,1323) en2(1),en2(paw_psi_ispin()),' (real space)'

         call paw_energy_output(luout,ion_nion(),neall,E)

*        **** write out KS eigenvalues ****
         write(6,1500)
         NN=paw_psi_ne(1)-paw_psi_ne(2)
         EV=27.2116d0
         do I=1,NN
           write(luout,1510) paw_psi_eigenvalue(1,I),
     >                       paw_psi_eigenvalue(1,I)*EV
         end do
         do I=1,paw_psi_ne(2)
           write(luout,1510)  paw_psi_eigenvalue(1,I+NN),
     >                        paw_psi_eigenvalue(1,I+NN)*EV,
     >                        paw_psi_eigenvalue(2,I),
     >                        paw_psi_eigenvalue(2,I)*EV
         end do

      end if


      paw_cgsd_energy = E(1)
      return



 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F6.3,' ')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1300 FORMAT(//'======================')
 1301 FORMAT(//'== Energy Calculation ==')
 1302 FORMAT(  '======================')
 1304 FORMAT(/)
 1305 FORMAT(10X,'====== Grassmann conjugate gradient iteration ======')
 1306 FORMAT(10X,'============ Grassmann lmbfgs iteration ============')
 1307 FORMAT(10X,'============ Grassmann diis iteration ==============')
 1308 FORMAT(10X,'======= Stiefel conjugate gradient iteration =======')
 1309 FORMAT(10X,'============= Kohn-Sham scf iteration ==============')
 1310 FORMAT(I8,E20.10,3E15.5)
 1311 FORMAT(10X,'======= Projected Grassmann lmbfgs iteration =======')
 1312 FORMAT(10X,'============= Stiefel lmbfgs iteration =============')
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1321 FORMAT(' total charge of system:',F11.5,A)
 1322 FORMAT('     plane-wave part:         ',F11.5,'       ',F11.5,A)
 1323 FORMAT('      augmented part:         ',F11.5,'       ',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1331 FORMAT(/' Diagonal Elements of Hamiltonian matrix')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1341 FORMAT(I3,2I3,' H=',E16.6)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
c1410 FORMAT(10X,'=============  summary of results  =================')
 1410 FORMAT('==  Summary Of Results  ==')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1431 FORMAT(/' QM Energies')
 1432 FORMAT( '------------')
 1433 FORMAT( ' total  QM energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1455 FORMAT( ' SIC-hartree energy  :',E19.10,' (',E15.5,'/electron)')
 1456 FORMAT( ' SIC-exc-corr energy :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1491 FORMAT( ' K.S. Vl+Vqm/mm      :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1499 FORMAT( ' K.S. SIC-hartree energy  :',E19.10,
     >        ' (',E15.5,'/electron)')
 1501 FORMAT( ' K.S. SIC-exc-corr energy :',E19.10,
     >        ' (',E15.5,'/electron)')
 1500 FORMAT(/' orbital energies:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1511 FORMAT(2(E18.7,' (',F8.3,'eV) occ=',F5.3))

 1700 FORMAT(/' QM/MM-pol-vib/CAV Energies')
 1701 FORMAT( ' --------------------------')
 1702 FORMAT( ' QM/MM energy                     :',E19.10)
 1703 FORMAT(/' MM/MM energy                     :',E19.10)
 1704 FORMAT(/' MM Polarization energy           :',E19.10)
 1705 FORMAT( ' MM Vibration energy              :',E19.10)
 1706 FORMAT( ' (QM+MM)/Cavity energy            :',E19.10)
 1707 FORMAT( ' - MM Charge Field/QM Electron    :',E19.10)
 1708 FORMAT( ' - MM Charge Field/QM Ion         :',E19.10)
 1709 FORMAT( ' - MM LJ/QM LJ                    :',E19.10)
 1710 FORMAT( ' - MM Charge Field/MM Charge Field:',E19.10)
 1711 FORMAT( ' - MM LJ/MM LJ                    :',E19.10)

 1800 FORMAT(/' Charge Field Energies')
 1801 FORMAT( ' ---------------------')
 1802 FORMAT( ' - Charge Field/Electron    :',E19.10)
 1803 FORMAT( ' - Charge Field/Ion         :',E19.10)
 1804 FORMAT( ' - Charge Field/Charge Field:',E19.10)
 1805 FORMAT( ' Charge Field Energy        :',E19.10)
   
      end

*     ***********************************
*     *                                 *
*     *     paw_cgsd_energy_gradient    *
*     *                                 *
*     ***********************************

      subroutine paw_cgsd_energy_gradient(G1)
      implicit none
      real*8 G1(3,*)

#include "stdio.fh"
#include "util.fh"

      logical allow_translation,lprint,mprint
      integer MASTER
      parameter (MASTER=0)
      integer i,k,taskid,nion,nion1
      integer i1
      real*8  GG
      real*8  fmx,fmy,fmz
      real*8  fmx2,fmy2,fmz2

*     **** external functions ****
      logical     control_allow_translation,ion_q_FixIon,control_print
      character*4 ion_aname
      integer     ion_katm,ion_nion,control_version
      real*8      ion_rion
      external control_allow_translation,ion_q_FixIon,control_print
      external ion_aname
      external ion_katm,ion_nion,control_version
      external ion_rion


      nion = ion_nion()
      call dcopy(3*nion,0.0d0,0,G1,1)
      call paw_set_mult_energy_coeff()
      call paw_psi_1force(G1)

*     **** remove ion forces using ion_FixIon ****
      allow_translation = control_allow_translation()
      call ion_FixIon(G1)

      if (.not.allow_translation) then
        call center_F_mass(G1,fmx,fmy,fmz)
        do i=1,nion
         G1(1,i) = G1(1,i) - fmx
         G1(2,i) = G1(2,i) - fmy
         G1(3,i) = G1(3,i) - fmz
        end do
      end if
      call center_F_mass(G1,fmx2,fmy2,fmz2)

      GG = 0.0d0
      do i=1,nion
         GG = GG + G1(1,i)**2 + G1(2,i)**2 + G1(3,i)**2
      end do

      call Parallel_taskid(taskid)
      mprint = ((taskid.eq.MASTER).and.control_print(print_medium))
      lprint = ((taskid.eq.MASTER).and.control_print(print_low))

      if (taskid.eq.MASTER) then
        if (mprint) then
        !write(luout,1300)
        write(luout,1301)
        !write(luout,1302)
        end if

        if (lprint) then
        write(luout,1304)
        if (.not.allow_translation) write(luout,1400) fmx,fmy,fmz
        write(luout,1304)
        write(luout,1410)
        end if

        if (mprint) then
        write(luout,1420)
        do I=1,ion_nion()
          if (ion_q_FixIon(I)) then
           write(6,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3)
          else
           write(6,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3)
          end if
        end do
        end if

        if (lprint) then
        write(luout,1421)
        write(luout,1190)(i,ion_aname(I),
     >                  (G1(K,I),K=1,3),I=1,ion_nion())


        write(luout,1210) fmx2,fmy2,fmz2  
        write(luout,1425)
        write(luout,1426) dsqrt(GG)
        end if
      end if

c     call dscal(3*nion,(-1.0d0),G1,1)

      return
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' )')
 1191 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - fixed')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1300 FORMAT(//'========================')
 1301 FORMAT(//'== Gradient Calculation ==')
 1302 FORMAT(  '========================')
 1304 FORMAT(/)
 1400 FORMAT('Translation force removed: (',3F11.5,')')
 1410 FORMAT(10X,'=============  Ion Gradients =================')
 1425 FORMAT(10X,'===============================================')
 1426 FORMAT(10X,'|F|=',E21.10//)
 1420 FORMAT( ' Ion Positions:')
 1421 FORMAT( ' Ion Forces:')
      end

      SUBROUTINE ccsdtq_lr_alpha_15_13(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_13.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p13 p17 h15 h16 )_ytrbtra + = 1/96 * Sum ( h14 h2 h5 h6 p8 p4 ) * tra ( p4 p8 p13 p17 h2 h5 h6 h14 )_tra * i2 ( h2 h5 h6 h14 h15 h16 p4 p8 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER p17b
      INTEGER h15b
      INTEGER h16b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p8b
      INTEGER h2b
      INTEGER h5b
      INTEGER h6b
      INTEGER h14b
      INTEGER p13b_1
      INTEGER p17b_1
      INTEGER p4b_1
      INTEGER p8b_1
      INTEGER h2b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h14b_1
      INTEGER h2b_2
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h14b_2
      INTEGER h15b_2
      INTEGER h16b_2
      INTEGER p4b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(4)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p13b = noab+1,noab+nvab
      DO p17b = p13b,noab+nvab
      DO h15b = 1,noab
      DO h16b = h15b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b
     &-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+h16b-1).ne.8)) THEN
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b-1) .eq. int_mb(k_spin
     &+h15b-1)+int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+h15b-1),int_mb(k_sym+h16b-1)))) .eq. ieor(irrep_y,ieor(irr
     &ep_trb,irrep_tra))) THEN
      dimc = int_mb(k_range+p13b-1) * int_mb(k_range+p17b-1) * int_mb(k_
     &range+h15b-1) * int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_13',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO p8b = p4b,noab+nvab
      DO h2b = 1,noab
      DO h5b = h2b,noab
      DO h6b = h5b,noab
      DO h14b = h6b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b-1)+int_mb(k_spin+p4b-
     &1)+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h2b-1)+int_mb(k_spin+h5
     &b-1)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h14b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+p4b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h2b-1),i
     &eor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+h14b
     &-1)))))))) .eq. irrep_tra) THEN
      CALL TCE_RESTRICTED_8(p13b,p17b,p4b,p8b,h2b,h5b,h6b,h14b,p13b_1,p1
     &7b_1,p4b_1,p8b_1,h2b_1,h5b_1,h6b_1,h14b_1)
      CALL TCE_RESTRICTED_8(h2b,h5b,h6b,h14b,h15b,h16b,p4b,p8b,h2b_2,h5b
     &_2,h6b_2,h14b_2,h15b_2,h16b_2,p4b_2,p8b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+p8b-1) * int_m
     &b(k_range+h2b-1) * int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) *
     & int_mb(k_range+h14b-1)
      dima_sort = int_mb(k_range+p13b-1) * int_mb(k_range+p17b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h15b-1) * int_mb(k_range+h16b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_13',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_13',2,MA_ERR)
      IF ((p8b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (h2b_1 - 1 
     &+ noab * (p17b_1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (
     &p8b_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+p13b-1),int_mb(k_range+p17b-
     &1),int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+h14b-1),4,3,8,7,6,5,2,1,1.0d0)
      END IF
      IF ((p4b .le. p13b) .and. (p13b .lt. p8b) .and. (p8b .le. p17b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (h2b_1 - 1 
     &+ noab * (p17b_1 - noab - 1 + nvab * (p8b_1 - noab - 1 + nvab * (p
     &13b_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p8b-1),int_mb(k_range+p17b-
     &1),int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+h14b-1),4,2,8,7,6,5,3,1,-1.0d0)
      END IF
      IF ((p4b .le. p13b) .and. (p17b .lt. p8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (h2b_1 - 1 
     &+ noab * (p8b_1 - noab - 1 + nvab * (p17b_1 - noab - 1 + nvab * (p
     &13b_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p17b-1),int_mb(k_range+p8b-
     &1),int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+h14b-1),3,2,8,7,6,5,4,1,1.0d0)
      END IF
      IF ((p13b .lt. p4b) .and. (p8b .le. p17b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (h2b_1 - 1 
     &+ noab * (p17b_1 - noab - 1 + nvab * (p8b_1 - noab - 1 + nvab * (p
     &4b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1),int_mb(k_range+p17b-
     &1),int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+h14b-1),4,1,8,7,6,5,3,2,1.0d0)
      END IF
      IF ((p13b .lt. p4b) .and. (p4b .le. p17b) .and. (p17b .lt. p8b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (h2b_1 - 1 
     &+ noab * (p8b_1 - noab - 1 + nvab * (p17b_1 - noab - 1 + nvab * (p
     &4b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p4b-1),int_mb(k_range+p17b-1),int_mb(k_range+p8b-
     &1),int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+h14b-1),3,1,8,7,6,5,4,2,-1.0d0)
      END IF
      IF ((p17b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (h2b_1 - 1 
     &+ noab * (p8b_1 - noab - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p1
     &7b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p17b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-
     &1),int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+h14b-1),2,1,8,7,6,5,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_13',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_13',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_13',5,MA_ERR)
      IF ((h16b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h16b_2 - 1 + noab
     & * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h6b_2 - 1 + noab * (
     &h5b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h16b-1),int_mb(k_range+p4b
     &-1),int_mb(k_range+p8b-1),6,5,4,3,2,1,8,7,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_13',6
     &,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p4b .eq. p8b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      nsubh(4) = 1
      isubh = 1
      IF (h2b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h6b .eq. h14b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,48.0d0/FACTORIAL
     &(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(n
     &subh(2))/FACTORIAL(nsubh(3))/FACTORIAL(nsubh(4)),dbl_mb(k_a_sort),
     &dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima
     &_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &13',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &13',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_13',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+p17b-1),int_mb(k_range+p13
     &b-1),4,3,2,1,1.0d0/96.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h15b - 1 + noab * (p17b - noab - 1 + nvab * (p13b - 
     &noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_13',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &13',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      Subroutine hf2mkr(Axyz,Bxyz,Cxyz,Dxyz,alpha_p,alpha_q,R0,IJK,
     &    Pxyz,Qxyz,PQ,ff,R,ffscr,rscr,NPP,NPQ,Lr,Lr3)
c
c $Id: hf2mkr.F 22721 2012-08-15 18:54:15Z niri $

      implicit none
#include "case.fh"
c
      double precision PI,P1
      Parameter (PI=3.1415926535898D0,P1=4.D0/PI)

c--> ints
      integer npp,npq
      integer Lr, Lr3
      integer IJK(0:Lr,0:Lr,0:Lr)

c--> Cartesian Coordinates
      double precision Axyz(3),Bxyz(3),Cxyz(3),Dxyz(3)

c--> Exponents

      double precision alpha_p(2,NPP),alpha_q(2,NPQ)

c--> Auxiliary Function Integrals & Index

      double precision R0((NPP*NPQ),Lr3)

c--> Scratch Space

      double precision Pxyz(3,NPP),Qxyz(3,NPQ),PQ((NPP*NPQ),3),
     &  ff(2,(NPP*NPQ)), R((NPP*NPQ),0:Lr,Lr3)
c
      double precision ffscr(2,(NPP*NPQ)), Rscr((NPP*NPQ),0:Lr,Lr3),
     & rhoscaled,radd

      integer mp, mq, mr, j, n
      double precision a,b,c,d,f1,f2,p,q,rho
      double precision PQx, PQy, PQz 
c
c Evaluate the auxiliary function integrals. These integrals are scaled by a 
c factor appropriate for ERIs, defined as
c
c                          1/2
c  ES = ((4/PI)*(pq/(p+q)))           where p = a + b and q = c + d.
c
c******************************************************************************
c
c Define the center "P".

      do 100 mp = 1,NPP

       a = alpha_p(1,mp)
       b = alpha_p(2,mp)

       f1 = a/(a+b)
       f2 = b/(a+b)

       Pxyz(1,mp) = f1*Axyz(1) + f2*Bxyz(1)
       Pxyz(2,mp) = f1*Axyz(2) + f2*Bxyz(2)
       Pxyz(3,mp) = f1*Axyz(3) + f2*Bxyz(3)

  100 continue

c Define the center "Q".

      do 110 mq = 1,NPQ

       c = alpha_q(1,mq)
       d = alpha_q(2,mq)

       f1 = c/(c+d)
       f2 = d/(c+d)

       Qxyz(1,mq) = f1*Cxyz(1) + f2*Dxyz(1)
       Qxyz(2,mq) = f1*Cxyz(2) + f2*Dxyz(2)
       Qxyz(3,mq) = f1*Cxyz(3) + f2*Dxyz(3)

  110 continue

c Define factors necessary to compute incomplete gamma function and the
c auxiliary functions.

      mr = 0
      do 125 mp = 1,NPP
        do 120 mq = 1,NPQ
          mr = mr + 1

          p = alpha_p(1,mp) + alpha_p(2,mp)
          q = alpha_q(1,mq) + alpha_q(2,mq)

          rho = p*q/(p+q)

          PQx = Pxyz(1,mp) - Qxyz(1,mq)
          PQy = Pxyz(2,mp) - Qxyz(2,mq)
          PQz = Pxyz(3,mp) - Qxyz(3,mq)

          PQ(mr,1) = PQx
          PQ(mr,2) = PQy
          PQ(mr,3) = PQz
c
          R(mr,0,1) = rho*(PQx**2 + PQy**2 + PQz**2)
          ff(1,mr) = 2.d0*dsqrt(rho/pi)
          ff(2,mr) = -2.D0*rho
c
          if (doscreen) then
           rhoscaled = rho
           call case_md(rhoscaled)
           Rscr(mr,0,1) = rhoscaled*(PQx**2 + PQy**2 + PQz**2)
           ffscr(1,mr) = 2.d0*dsqrt(rhoscaled/pi)
           ffscr(2,mr) = -2.D0*rhoscaled
          end if
c
  120   continue
  125 continue

c Evaluate the incomplete gamma function.

      call igamma(R,(NPP*NPQ),Lr)
      if (doscreen) call igamma(Rscr,(NPP*NPQ),Lr)

c Define the initial auxiliary functions (i.e., R000j, j=1,Lr).

      do 135 j = 0,Lr
        do 130 mr = 1,(NPP*NPQ)
             R(mr,j,1) = ff(1,mr)*R(mr,j,1)
             ff(1,mr) = ff(1,mr)*ff(2,mr)
             if (doscreen) then
               Rscr(mr,j,1) = ffscr(1,mr)*Rscr(mr,j,1)
               ffscr(1,mr) = ffscr(1,mr)*ffscr(2,mr)
             end if
  130   continue
  135 continue

c Recursively build the remaining auxiliary functions (i.e., RIJKj, j=0).
        
      call hfmkr(R,IJK,PQ,(NPP*NPQ),Lr,Lr3)
      if (doscreen) call hfmkr(Rscr,IJK,PQ,(NPP*NPQ),Lr,Lr3)
       
c Transfer to R0 array.
        
c       write(6,*) "cam_alpha:",cam_alpha
c       write(6,*) "cam_beta:",cam_beta
c       write(6,*) "doscreen:",doscreen
c       write(6,*) "cam_srhf:",cam_srhf
c
      do 145 n = 1,Lr3
        do 140 mr = 1,(NPP*NPQ)
         if (doscreen) then
           if (cam_srhf) then ! for pure short-range HF (1-erf(r)/r)
             R0(mr,n) = R(mr,0,n)-Rscr(mr,0,n)
           else
             R0(mr,n) = cam_alpha*R(mr,0,n)+cam_beta*Rscr(mr,0,n)
           end if 
         else
           R0(mr,n) = R(mr,0,n)
         end if
 140    continue
 145  continue
        
      end

      subroutine smd_rtdb_init(parallel,rtdb)
      implicit none
#include "rtdb.fh"
#include "inp.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "smd_const_data.fh"

      logical parallel
      integer rtdb
c
      character*(smd_string_size) namespace
      character*(smd_string_size) tag
      logical ignore,result,oldmode
      character*256 big_buffer
      character*(smd_string_size) buffer1
      logical oscratch(smd_rtdb_nmax)
      character*30 pname
      integer i
      integer istart,iend

      pname = "smd_rtdb_init"
      oldmode = rtdb_parallel(parallel)
      smd_rtdb = rtdb
c
      smd_istart=0
      smd_iend  =0
      smd_nproc =0
      ignore = rtdb_get(rtdb,"smd:istart",mt_int,1,smd_istart)
      ignore = rtdb_get(rtdb,"smd:iend",mt_int,1,smd_iend)
      ignore = rtdb_get(rtdb,"smd:nproc",mt_int,1,smd_nproc)

c
c     create rtdb namespace
c     ---------------------
      tag = "rtdb"
      call smd_system_get_component(namespace,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
      call smd_namespace_create(namespace)
c
c     fetch and store rtdb name
c     -------------------------
      if(.not. rtdb_getfname(rtdb, big_buffer)) call
     *        errquit('rtdb_getfname failed',0,0)
      istart = 0
   10 if (inp_strtok(big_buffer, '/', istart, iend)) then
      buffer1 = big_buffer(istart:iend)
      goto 10
      endif
c
      tag  = "smd:rtdb_name"
      call smd_data_create(namespace,tag,smd_rtdb_nmax,
     >                         MT_STR)
      call smd_data_put_string1(namespace,tag,1,1,
     >                              buffer1)
c
c     store prefix
c     ------------
      call util_file_prefix_get(buffer1)
      tag  = "smd:prefix"
      call smd_data_create(namespace,tag,smd_rtdb_nmax,
     >                         MT_STR)
      call smd_data_put_string1(namespace,tag,1,1,
     >                         buffer1)
c
c     store location of rtdb (perm by default)
c     ---------------------------------------
      tag  = "smd:rtdb_scratch"
      call smd_data_create(namespace,tag,smd_rtdb_nmax,
     >                         MT_LOG)
      do i=1,smd_rtdb_nmax
        oscratch(i)=.false.
      end do
      call smd_data_put_log1(namespace,tag,1,1,
     >                         .false.)
c
c     store rtdb pointer
c     ------------------
      tag  = "smd:rtdb_pointer"
      call smd_data_create(namespace,tag,1,
     >                         MT_INT)
      call smd_data_put_int1(namespace,tag,1,1,
     >                         1)
c
c     store rtdb handle
c     ------------------
      tag  = "smd:rtdb_handle"
      call smd_data_create(namespace,tag,1,
     >                         MT_INT)
      call smd_data_put_int1(namespace,tag,1,1,
     >                         rtdb)
c
c     digest some of rtdb contents
c     ----------------------------
      call smd_data_namespace_rtdb_get(rtdb,namespace,"smd")
      call smd_data_namespace_rtdb_get(rtdb,namespace,"geom:source")
      call smd_data_namespace_rtdb_get(rtdb,namespace,"task:theory")
      call smd_data_namespace_rtdb_get(rtdb,namespace,"task:operation")
c
c     restore rtdb access mode
c     -----------------------
      oldmode = rtdb_parallel(oldmode)
c    
      return
      end 

      subroutine smd_rtdb_close(action)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) action
c
      integer rtdb
      logical result
      character*30 pname

      pname = "smd_rtdb_close"
      call smd_rtdb_get_handle(rtdb)
      if(rtdb.lt.0) call errquit(pname//"no rtdb to close")
      if(.not.rtdb_close(rtdb,action)) 
     >     call errquit(pname//" while rtdb_close",0,0)
      call smd_rtdb_set_handle(-1000)

      end 

      subroutine smd_rtdb_open(rtdb)
c     opens rtdb whose name was already stored
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
c
      integer rtdb
c
      logical result
      character*30 pname
      character*(smd_path_size) rtdb_name
      character*(smd_string_size) prefix
      logical oscratch

      pname = "smd_rtdb_open"
c     check if other rtdb is open
c     ---------------------------
      call smd_rtdb_get_handle(rtdb)
      if(rtdb.ge.0) call errquit(pname//"close rtdb first",0,0)
c     get new rtdb name
c     -----------------
      call smd_rtdb_get_name_full(rtdb_name)
c      note that mode is to old so the actual file should be there!
      if(.not.rtdb_open(rtdb_name,"old",rtdb)) 
     >     call errquit(pname//" cannot find rtdb "//rtdb_name,0,0)
      call smd_rtdb_set_handle(rtdb)
      call smd_rtdb_get_prefix(prefix)
      call util_file_prefix_set(prefix)

      end 

      subroutine smd_rtdb_push_open_clone(taskid,oscratch,rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "rtdb.fh"
      integer taskid
      logical oscratch
      integer rtdb
c     
      character*30 pname
c
      pname = "smd_rtdb_push_open_clone"
      call smd_rtdb_push_clone(taskid,oscratch)
      call smd_rtdb_open(rtdb)
      call ga_sync()

      return
      end

      subroutine smd_rtdb_push_clone(taskid,oscratch)
c     rtdb cloning
c     1. make a numbered name (taskid)
c     2. copy file
c
c     taskid[IN] task number
c     rtdb[OUT]  rtdb handle
c
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "rtdb.fh"
      integer taskid
      logical oscratch
c     
      character*(smd_string_size)  sname
      character*(smd_string_size)  rtdb_name0,rtdb_name
      character*(smd_path_size)  rtdb_name_full0
      character*(smd_path_size)  rtdb_name_full
      integer i1,i2
      logical result
      logical master
      character*(smd_string_size) prefix, prefix0
      integer rtdb
      integer n,nmax
      character*30 pname
c
      pname = "smd_rtdb_push_clone1"
c      
      call ga_sync()
      master = ga_nodeid().eq.0
c     get full path to current rtdb 
      call smd_rtdb_get_name_full(rtdb_name_full0)
c
c     create new prefix name
c     ----------------------
      call smd_rtdb_get_prefix(prefix0)
      i1 = inp_strlen(prefix0)
      write(prefix,'(A,I4.4)')
     >    prefix0(1:i1),taskid
      i1 = inp_strlen(prefix)
      write(rtdb_name,'(A,A3)')
     >    prefix(1:i1),".db"
c
c     push names in 
c     -------------
      call util_flush(6)
      call smd_rtdb_push_name(rtdb_name,prefix,oscratch)
c
c     get full path to new rtdb 
c     ----------------------------
      call smd_rtdb_get_name_full(rtdb_name_full)
c
c     actually copy the file
c     ----------------------
      if(master) then
        inquire(file=rtdb_name_full0,exist=result)
        if(.not.result) then
          call errquit("cannot find rtdb"//
     >                 rtdb_name_full0,
     >                 0,0)
        end if
        call util_file_copy(rtdb_name_full0,rtdb_name_full)
      end if
c
      call ga_sync()

      return
      end

      subroutine smd_rtdb_pop()
c
      implicit none
#include "errquit.fh"
      character*30 pname
c
      pname = "smd_rtdb_pop"
c      
      call smd_rtdb_close("delete")
      call smd_rtdb_pop_name()
      return
      end

      subroutine smd_rtdb_get_handle(rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
c
      integer rtdb
c
      logical result
      character*30 pname
      character*(smd_string_size) tag,sname

      pname = "smd_rtdb_get_handle"
      tag = "rtdb"
      call smd_system_get_component(sname,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "smd:rtdb_handle"
      call smd_data_get_int1(sname,tag,1,1,rtdb)

      end 

      subroutine smd_rtdb_set_handle(rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
c
      integer rtdb
c
      logical result
      character*30 pname
      character*(smd_string_size) tag,sname

      pname = "smd_rtdb_get_handle"
      tag = "rtdb"
      call smd_system_get_component(sname,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "smd:rtdb_handle"
      call smd_data_put_int1(sname,tag,1,1,rtdb)

      end 

      subroutine smd_rtdb_get_istart(istart)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer istart
c
      logical result
      character*30 pname
c
      pname = "smd_rtdb_get_istart"
      call smd_rtdb_get_int("smd:fragment_istart",1,istart,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_get_iend(iend)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer iend
c
      logical result
      character*30 pname
c
      pname = "smd_rtdb_get_iend"
      call smd_rtdb_get_int("smd:fragment_iend",1,iend,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_get_nproc(nproc)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer nproc
c
      logical result
      character*30 pname
c
      pname = "smd_rtdb_get_nproc"
      call smd_rtdb_get_int("smd:fragment_nproc",1,nproc,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_get_prefix(aname)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c
      character*(*) aname
c
      character*(smd_string_size)  buffer
      character*(smd_string_size)  tag,sname
      integer rtdb
      character*30 pname
      integer n
      logical result

      pname = "smd_rtdb_get_prefix"
      tag = "rtdb"
      call smd_system_get_component(sname,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_data_get_int1(sname,"smd:rtdb_pointer",1,1,
     >                         n)

      call smd_data_get_string1(sname,"smd:prefix",n,n,
     >                          buffer)


      aname = buffer

      end 

      subroutine smd_rtdb_get_name(rtdb_name)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c
      character*(*) rtdb_name
c
      character*(smd_string_size)  buffer
      character*(smd_string_size)  tag,sname
      integer rtdb
      character*30 pname
      integer n
      logical result

      pname = "smd_rtdb_get_name"
      tag = "rtdb"
      call smd_system_get_component(sname,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_data_get_int1(sname,"smd:rtdb_pointer",1,1,
     >                         n)

      call smd_data_get_string1(sname,"smd:rtdb_name",n,n,
     >                          buffer)


      rtdb_name = buffer

      end 

      subroutine smd_rtdb_get_name_full(rtdb_name)
c     obtain current rtdb name with fully resolved path
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c
      character*(*) rtdb_name
c
      character*(smd_string_size)  tag,sname
      character*30 pname
      integer n
      logical result
      logical oscratch

      pname = "smd_rtdb_get_name_full"
      tag = "rtdb"
      call smd_system_get_component(sname,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "smd:rtdb_pointer"
      call smd_data_get_int1(sname,tag,1,1,n)

      tag = "smd:rtdb_name"
      call smd_data_get_string1(sname,tag,n,n,rtdb_name)

      tag  = "smd:rtdb_scratch"
      call smd_data_get_log1(sname,tag,n,n,oscratch)

      call util_file_name_resolve(rtdb_name,oscratch)

      end 

      subroutine smd_rtdb_push_name(rtdb_name,prefix,oscratch)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c
      character*(*) rtdb_name,prefix
      logical oscratch
c
      character*(smd_string_size)  buffer(smd_rtdb_nmax)
      character*(smd_string_size)  tag,sname
      integer rtdb
      character*30 pname
      integer n
      logical result

      pname = "smd_rtdb_push_name"
      tag = "rtdb"
      call smd_system_get_component(sname,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      tag = "smd:rtdb_pointer"
      call smd_data_get_int1(sname,tag,1,1, n)
      if(.not.result) call errquit(pname//"no component "//tag,0,0)
c
      n=n+1
      if(n.gt.smd_rtdb_nmax) 
     > call errquit(pname//"out of stack",0,0)
      tag = "smd:rtdb_pointer"
      call smd_data_put_int1(sname,tag,1,1,n)

      tag = "smd:rtdb_name"
      call smd_data_put_string1(sname,tag,n,n,rtdb_name)

      tag = "smd:prefix"
      call smd_data_put_string1(sname,tag,n,n,prefix)

      tag  = "smd:rtdb_scratch"
      call smd_data_put_log1(sname,tag,n,n,oscratch)

      return
      end 

      subroutine smd_rtdb_pop_name()
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "smd_const_data.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c
      character*(smd_string_size)  tag,sname
      integer rtdb
      character*30 pname
      integer n
      logical result

      pname = "smd_rtdb_pop_name"
      tag = "rtdb"
      call smd_system_get_component(sname,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "smd:rtdb_pointer"
      call smd_data_get_int1(sname,tag,1,1, n)
      if(.not.result) call errquit(pname//"no component "//tag,0,0)
      if(n-1.le.0) 
     > call errquit(pname//"out of stack",0,0)
c
      tag = "smd:rtdb_name"
      call smd_data_put_string1(sname,tag,n,n," ")

      tag = "smd:prefix"
      call smd_data_put_string1(sname,tag,n,n," ")
c
      n=n-1
      tag = "smd:rtdb_pointer"
      call smd_data_put_int1(sname,tag,1,1,n)

      return
      end 

      subroutine smd_rtdb_get_operiodic(operiodic)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      logical operiodic
c
      double precision latt(3,3)
      character*32 pname
      character*80 tag
      double precision a(3)
      integer i
c
      pname = "smd_lat_rtdb_read"
c
c      write(*,*) "in "//pname
c
      tag="smd:operiodic"
      if (rtdb_get(smd_rtdb,tag,mt_log,1,operiodic)) 
     >    return

      operiodic = .true.
      tag="smd:lat_a"
      if (.not.rtdb_get(smd_rtdb,tag,mt_dbl,3,a(1))) 
     >      operiodic=.false.


      end 

      subroutine smd_rtdb_get_paramfile(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) filename
      logical result
c
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:paramfile',1,filename))
     >   result = .false.
      end 

      subroutine smd_rtdb_get_coordfile(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_rtdb_get_coordfile"
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:coordfile',1,filename))
     >   result = .false.

      end 

      subroutine smd_rtdb_get_veloc_input(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_rtdb_get_veloc:input"
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:veloc:input',1,filename))
     >   result = .false.

      end 

      subroutine smd_rtdb_get_log(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      logical datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_get_log"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_log(sname,dname,ndim,datum,result)
      return
      end

      subroutine smd_rtdb_get_int(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      integer datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_get_int"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_int(sname,dname,ndim,datum,result)
      return
      end

      subroutine smd_rtdb_put_int(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      integer datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_put_int"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) return
      call smd_data_put_int(sname,dname,ndim,datum)
      return
      end

      subroutine smd_rtdb_get_dbl(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      double precision datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_get_dbl"
     
      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_dbl(sname,dname,ndim,datum,result)
      return
      end

      subroutine smd_rtdb_get_string(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
#include "inp.fh"
      character*(*) dname
      integer ndim
      integer dtype
      character*(*) datum(ndim)
c
      integer ind
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1
      integer chunk
      logical result
      character*(smd_string_size) sname

      pname = "smd_rtdb_get_string"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_string(sname,dname,ndim,datum,result)
      return
      end

c $Id: smd_rtdb_data.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup nwint
C> @{
C>
C> \brief Compute the 1-electron derivative integrals
C>
C> This routine compute the 1-electron derivative integrals. The routine
C> computes the nuclear attraction integral derivatives
C> \f{eqnarray*}{
C>   \sum_A\frac{\partial (\mu|Z_AR_A^{-1}|\nu)}{\partial R_x} &=&
C>      \sum_A\int \frac{\partial [g_\mu(X_\mu,r_1)Z_AR^{-1}_{A1}g_\nu(X_\nu,r_1)]}
C>                      {\partial X_x}dr_1
C> \f}
C> It also adds the kinetic energy integral derivatives
C> \f{eqnarray*}{
C>   -\frac{1}{2}\frac{\partial (\mu|\nabla_1^2|\nu)}{\partial R_x} &=&
C>   -\frac{1}{2}\int \frac{\partial [g_\mu(X_\mu,r_1)\nabla_1^2g_\nu(X_\nu,r_1)]}
C>                         {\partial X_x}dr_1
C> \f}
C> The results are stored in `H1a` as if that variable was declared as
C> `H1a(nint,ncoord,natom)` where `nint` is the number of integrals for a given
C> pair of shells, `ncoord` is the number of Cartesian coordinates, and `natom`
C> is the number of atoms.
C>
      subroutine intd_1eh1(i_basis,ish,j_basis,jsh,lscr,scr,
     &       lH1a,H1a)
C $Id: intd_1eh1.F 23255 2012-12-07 00:44:42Z d3y133 $
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
c
c layer routine to compute the derivative 1 electron hamiltonian integrals
c for shells/contractions ish,jsh
c
c Order is...   nint*3*nat (3=> xyz, nat=number of atoms)
c
c  /                   |   
c | nint,d <ij>        |
c |      --------------|
c  \     d[idatom(1),x]|
c                          |
c       nint,d <ij>        |
c            --------------|
c            d[idatom(1),y]|
c                              |
c           nint,d <ij>        |
c                --------------|
c                d[idatom(1),z]|
c                                  |
c               nint,d <ij>        |
c                    --------------|
c                    d[idatom(2),x]|
c                                      |
c                   nint,d <ij>        |
c                        --------------|
c                        d[idatom(2),y]|
c                                           |
c                       nint,d <ij>         |
c                            -------------- |
c                            d[idatom(2),z] |
c
c                                  . . . 
c                                                            |
c                                         nint,d <ij>        |
c                                              --------------|
c                                            d[idatom(nat),x]|
c                                                                |
c                                             nint,d <ij>        |
c                                                  --------------|
c                                                d[idatom(nat),y]|
c                                                                    \
c                                                 nint,d <ij>         |
c                                                      -------------- |
c                                                    d[idatom(nat),z]/
c      
c::functions
      integer int_nint_cart
      external int_nint_cart
c::passed
      integer i_basis   !< [Input] ish basis set handle
      integer ish       !< [Input] ``i'' contraction index
      integer j_basis   !< [Input] jsh basis set handle
      integer jsh       !< [Input] ``j'' contraction index
      integer lscr      !< [Input] length of scratch space
      integer lH1a      !< [Input] number of h1 integral derivatives in shells ish and jsh
c                       ! NOTE: nint*3 integral derivatives returned per unique center
      double precision scr(lscr) !< [Input] scratch array
      double precision H1a(*)    !< [Output] derivative integrals
c
c::local
      integer nint, offset, scrsize, nat
c
      nat = ncenter(ibs_geom((i_basis + Basis_Handle_Offset)))
c
      nint = int_nint_cart(i_basis,ish,j_basis,jsh,0,0,0,0)
      if (nint*3*nat.gt.lH1a) then
        write(luout,*) 'nint*3*nat = ',nint*3*nat
        write(luout,*) 'lH1a       = ',lH1a
        call errquit('intd_1eh1: nint>lH1a error',911, INT_ERR)
      endif
c
      offset = nint*3*2       ! scratch for Ta array in intd_1eh1P routine
      scrsize = lscr - offset ! new scratch array size
      offset = offset + 1     ! increment for passing to intd_1eh1P
c
      call intd_1eh1P(i_basis,ish,j_basis,jsh,
     &       scrsize,scr(offset),nint,H1a,scr)
c
      end
      subroutine intd_1eh1P(i_basis,ish,j_basis,jsh,lscr,scr,
     &       nint,H1a,Ta)
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "apiP.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geom.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "rel_nwc.fh"
c::external subroutines used
c... errquit
c::functions
      logical cando_hnd_1e
      logical cando_nw
      external cando_hnd_1e
      external cando_nw
c::passed
      integer i_basis   ! [input] ish basis set handle
      integer ish       ! [input] ``i'' contraction index
      integer j_basis   ! [input] jsh basis set handle
      integer jsh       ! [input] ``j'' contraction index
      integer lscr      ! [input] length of scratch space 
      integer nint      ! [input] number of integrals in shells ish and jsh
c                       ! NOTE: nint*3 integral derivatives returned per unique center
      double precision scr(lscr) ! [input] scratch array
      double precision H1a(nint,3,*)    ! [output] derivative integrals (nint,3,n_atoms)
      double precision Ta(nint,3,2)     ! [scratch] space for kinetic integrals
c::local
      logical doT
      integer ucont,uconts
      integer ibas,iatom,inp,igen,iexp,icf,itype,igeom,isbas,icfS
      integer jbas,jatom,jnp,jgen,jexp,jcf,jtype,jgeom,jsbas,jcfS
      integer nat
      integer nintV
      integer offset
c
      logical any_spherical
      logical orel, oirel, ojrel, oNR
      logical ohnd_ok, onw_ok
      integer i_nbf_x, j_nbf_x
      integer i_nbf_s, j_nbf_s
      integer nint_x, nint_s
      integer zatom, zyx
      integer lbas, sbas, abas
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c  check if gencon/sp shells
c
      call int_nogencont_check(i_basis,'intd_1eh1P:i_basis')
      call int_nogencont_check(j_basis,'intd_1eh1P:j_basis')
      call int_nospshell_check(i_basis,'intd_1eh1P:i_basis')
      call int_nospshell_check(j_basis,'intd_1eh1P:j_basis')
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
      oNR = .true.
      oirel = .false.
      ojrel = .false.
      orel = .false.
c
      if (dyall_mod_dir) then
c
c     get basis set handles; relativistic integral option only valid
c     if both ibas and jbas are the ao basis.
c
        lbas = lc_bsh + BASIS_HANDLE_OFFSET
        sbas = sc_bsh + BASIS_HANDLE_OFFSET
        abas = ao_bsh + BASIS_HANDLE_OFFSET
        orel = ibas .eq. abas .and. jbas .eq. abas
      end if
c
c   i shell
c
      ucont = (sf_ibs_cn2ucn(ish,ibas))
c
c     check for relativistic shell
c
      if (orel .and. (infbs_cont(CONT_RELLS ,ucont,ibas) .ne. 0)) then
        oirel = .true.
        isbas = sbas
        uconts = ao_to_ls(ucont)
        if (uconts .eq. 0) call errquit (
     &      'intd_1eh1: no relativistic pointer',911, INT_ERR)
        if (nesc_1e_approx) then
          ibas = lbas
          ucont = uconts
        end if
      else
        uconts = ucont
        isbas = ibas
      end if
c
      inp   = infbs_cont(CONT_NPRIM,ucont,ibas)
      igen  = infbs_cont(CONT_NGEN,ucont,ibas)
      iexp  = infbs_cont(CONT_IEXP,ucont,ibas)
      icf   = infbs_cont(CONT_ICFP,ucont,ibas)
      itype = infbs_cont(CONT_TYPE,ucont,ibas) 
      igeom = ibs_geom(ibas)
      iatom = (sf_ibs_cn2ce(ish,ibas))
      icfS  = infbs_cont(CONT_ICFP ,uconts,isbas)
c
c   j shell
c
      ucont = (sf_ibs_cn2ucn(jsh,jbas))
c
c     check for relativistic shell
c
      if (orel .and. (infbs_cont(CONT_RELLS ,ucont,jbas) .ne. 0)) then
        ojrel = .true.
        jsbas = sbas
        uconts = ao_to_ls(ucont)
        if (uconts .eq. 0) call errquit (
     &      'intd_1eh1: no relativistic pointer',911, INT_ERR)
        if (nesc_1e_approx) then
          jbas = lbas
          ucont = uconts
        end if
      else
        uconts = ucont
        jsbas = jbas
      end if
c
      jnp   = infbs_cont(CONT_NPRIM,ucont,jbas)
      jgen  = infbs_cont(CONT_NGEN,ucont,jbas)
      jexp  = infbs_cont(CONT_IEXP,ucont,jbas)
      jcf   = infbs_cont(CONT_ICFP,ucont,jbas)
      jtype = infbs_cont(CONT_TYPE,ucont,jbas) 
      jgeom = ibs_geom(jbas)
      jatom = (sf_ibs_cn2ce(jsh,jbas))
      jcfS  = infbs_cont(CONT_ICFP ,uconts,jsbas)
c
      oNR = .not.(oirel.and.ojrel)
      orel = oirel.or.ojrel
c
      if (igeom.ne.jgeom) then
        write(luout,*)'intd_1eh1P.F: two different geometries for',
     &         ' derivatives?'
        call errquit('intd_1eh1P: geom error ',911, INT_ERR)
      endif
c
      if (iatom.eq.jatom) then
        doT = .false.
      else
        doT = .true.
      endif
c
      ohnd_ok = cando_hnd_1e(i_basis,ish,0)
     &    .and. cando_hnd_1e(j_basis,jsh,0)
     &    .and. (.not.geom_any_finuc (igeom))
     &    .and. (.not.geom_any_finuc (jgeom))
      onw_ok = cando_nw(i_basis,ish,0) .and. cando_nw(j_basis,jsh,0)
c        
      if (orel) then
        call rel_oneld (
     &      coords(1,iatom,igeom),
     &      dbl_mb(mb_exndcf(iexp,ibas)),
     &      dbl_mb(mb_exndcf(icf,ibas)),
     &      dbl_mb(mb_exndcf(icfS,isbas)),inp,igen,itype,iatom,
     &      coords(1,jatom,jgeom),
     &      dbl_mb(mb_exndcf(jexp,jbas)),
     &      dbl_mb(mb_exndcf(jcf,jbas)),
     &      dbl_mb(mb_exndcf(jcfS,jsbas)),jnp,jgen,jtype,jatom,
     &      coords(1,1,igeom),charge(1,igeom),
     &      geom_invnucexp(1,igeom),ncenter(igeom),
c........................     doS   doT  doV    canAB  
     &      scr,Ta,H1a,nint,.false.,doT,.true.,.false.,onw_ok,
c...........       nonrel dryrun
     &      ohnd_ok,oNR,.false.,scr,lscr,rel_dbg,rel_typ)
      else if (onw_ok) then
        call hf1d(
     &      coords(1,iatom,igeom),
     &      dbl_mb(mb_exndcf(iexp,ibas)),
     &      dbl_mb(mb_exndcf(icf,ibas)),
     &      inp,igen,itype,iatom,
c
     &      coords(1,jatom,jgeom),
     &      dbl_mb(mb_exndcf(jexp,jbas)),
     &      dbl_mb(mb_exndcf(jcf,jbas)),
     &      jnp,jgen,jtype,jatom,
c
     &      coords(1,1,igeom),charge(1,igeom),
     &      geom_invnucexp(1,igeom),ncenter(igeom),
     &      scr,Ta,H1a,nint,
c..............overlap, k-e,  pot-e,  canab,   dryrun
     &      .false., doT, .true., .false., .false.,
     &      scr,lscr)
      elseif (ohnd_ok) then
        call hnd_stvintd(
     &      coords(1,iatom,igeom),
     &      dbl_mb(mb_exndcf(iexp,ibas)),
     &      dbl_mb(mb_exndcf(icf,ibas)),
     &      inp,igen,itype,iatom,
c
     &      coords(1,jatom,jgeom),
     &      dbl_mb(mb_exndcf(jexp,jbas)),
     &      dbl_mb(mb_exndcf(jcf,jbas)),
     &      jnp,jgen,jtype,jatom,
c
     &      coords(1,1,igeom),charge(1,igeom),ncenter(igeom),
     &      scr,Ta,H1a,nint,
c............overlap, k-e,     pot-e,
     &      .false.,  doT, .true.,
     &      scr,lscr)
      else
        call errquit('intd_1eh1: could not do hnd or nw integrals',
     &                0, INT_ERR)
      endif
c
c if needed add in Ta derivative integrals
c
      if (doT) then
        call daxpy(nint*3,1.0d00,Ta(1,1,1),1,H1a(1,1,iatom),1)
        call daxpy(nint*3,1.0d00,Ta(1,1,2),1,H1a(1,1,jatom),1)
      endif
c
c check for ecp 
c
*
* this should move to hf1dsp when sp is enabled.
*
      nat = ncenter(igeom)  ! needed for both ecp and spherical
      if (any_ecp) then
        nintV = int_nbf_x(itype)*int_nbf_x(jtype)
        offset = nintV*3*nat + 1
*       write(luout,*)' lscr to ecp_hf1:',(lscr-nintV)
*       call dcopy(nintV*3*nat,0.0d00,0,scr,1) ! buffer zeroed in ecp_gradient
        call intd_ecp_hf1(
     &      coords(1,iatom,igeom),
     &      dbl_mb(mb_exndcf(iexp,ibas)),
     &      dbl_mb(mb_exndcf(icf,ibas)),
     &      inp,igen,itype,iatom,
c
     &      coords(1,jatom,jgeom),
     &      dbl_mb(mb_exndcf(jexp,jbas)),
     &      dbl_mb(mb_exndcf(jcf,jbas)),
     &      jnp,jgen,jtype,jatom,
c
     &      scr,nintV,nat,
     &      scr(offset),(lscr-offset-1),
     &      .false.)
c 
*... sum ecp into derivative H1 block
        call daxpy(nintV*3*nat,1.0d00,scr,1,H1a,1)
      endif
c
*     H1a now has the cartesian integral block  (jlo:jhi,ilo:ihi)
*      
      any_spherical = bas_spherical(ibas).or.bas_spherical(jbas)
      if (.not.any_spherical) return
c
c ... reset general contractions for sp shells to 1 since they are handled
c     as a block of 4.
c
      if (itype.eq.-1) igen = 1
      if (jtype.eq.-1) jgen = 1
c
      if (bas_spherical(ibas).and.bas_spherical(jbas)) then
*... transform both i and j integrals
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = int_nbf_s(Itype)
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = int_nbf_s(Jtype)
c        
        do zatom = 1,nat
          do zyx = 1,3
            call spcart_tran1e(H1a(1,zyx,zatom),scr,
     &          j_nbf_x,i_nbf_x,Jtype,jgen,
     &          j_nbf_s,i_nbf_s,Itype,igen,
     &          .false.)
          enddo
        enddo
      else if (bas_spherical(ibas)) then
*.. transform on i component
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = int_nbf_s(Itype)
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = j_nbf_x
        do zatom = 1,nat
          do zyx = 1,3
            call spcart_tran1e(H1a(1,zyx,zatom),scr,
     &          j_nbf_x,i_nbf_x,0,jgen,
     &          j_nbf_s,i_nbf_s,Itype,igen,
     &          .false.)
          enddo
        enddo
      else if (bas_spherical(jbas)) then
*.. transform on j component
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = i_nbf_x
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = int_nbf_s(Jtype)
        do zatom = 1,nat
          do zyx = 1,3
            call spcart_tran1e(H1a(1,zyx,zatom),scr,
     &        j_nbf_x,i_nbf_x,Jtype,jgen,
     &        j_nbf_s,i_nbf_s,0,igen,
     &        .false.)
          enddo
        enddo
      else
        call errquit(
     &        'int_1eh1: should never reach transform blocked else',
     &        911, INT_ERR)
      endif
c
c now shuffle transformed buffers to contiguous space
c
      nint_x = i_nbf_x*j_nbf_x
      nint_s = i_nbf_s*j_nbf_s
      if (nint_s.gt.nint_x) then
        call errquit
     &      ('intd_1eh1: nint_s >.nint_x diff=',(nint_s-nint_x),
     &      INT_ERR)
      elseif (nint_s.eq.nint_x) then
        return
      else
        call int_c2s_mv
     &      (H1a,nint_x,nint_s,(3*nat),scr,lscr,'intd_1eh1')
      endif
c

      end
C> @}

      Logical Function RIMP2( RTDB )
C$Id: rimp2.F 24516 2013-08-16 01:59:29Z edo $
      Implicit NONE
#include "errquit.fh"
      Integer RTDB
C
#include "stdio.fh"
#include "bas.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "pstat.fh"
#include "rimp2_timers.fh"
#include "numerical_constants.fh"
#include "util.fh"
#ifdef RIMP2_USE_DA
#include "dra.fh"
#endif
C
      Logical MOVecs_Read_Header, MOVecs_Read, MOVecs_Gather,
     $   Int_Normalize
      External MOVecs_Read_Header, MOVecs_Read, MOVecs_Gather,
     $   Int_Normalize
C
      Integer LNBlnk
      External LNBlnk
C
      Logical RIMP2_XF_Driver, RIMP2_V_E2, SCF, dft_energy
      External RIMP2_XF_Driver, RIMP2_V_E2, SCF, dft_energy
C
      Integer MaxSpin
      Parameter (MaxSpin = 2)
C
      Integer MinChunk
      Parameter (MinChunk = 64)
C
      Integer MxTBatch, MxEBatch(2)
C
      Character*(*) Def_Int, Def_MOVec
      Parameter (Def_Int = 'mo3cint', Def_MOVec = 'movecs')
      Character*(*) Geom_Name, AOBasName, FitBasName
      Parameter (Geom_Name = 'geometry', AOBasName = 'ao basis',
     $   FitBasName = 'ri-mp2 basis')
C
      Character*(*) My_Ctx
      Parameter (My_Ctx = 'mp2')
C
      Integer AOBas, FitBas, Bases(2), Geom
      Integer NAOBF, TopSpin, NFit, RefNAO, NFrzOcc, NFrzVir
      Integer ALo(MaxSpin), AHi(MaxSpin), ILo(MaxSpin), IHi(MaxSpin)
      Integer I, Me
      Integer H_Contrib, Contrib_Idx
      Double precision Thresh, CorEner, RefEner, TotEner, MinEVal
      Character*(80) FNInt, Approx
      character*255 actualname
      Character*(255) AOName, AONameT, FitName, FitNameT, JobTitle
      Logical Status
      Character*(1) Mem_Opt
C
C     Handles and indices to for the "correlated" basis
C
      Integer H_Occ, H_EVal
      Integer I_Occ, I_EVal
      Integer G_AOXF(MaxSpin)
      Integer NCorBF(MaxSpin), MxNCorBF
C
C     "Handles" for the integral file(s) (either logical unit numbers
C     or disk array handles)
C
      Integer D_Int(MaxSpin)
C
C     Print controls
C
      Logical PrInfo
C
#ifdef RIMP2_USE_DA
C
      Integer MaxDASiz, TotDASiz, Size, SizeB
#endif
C
C     Stuff for SCF reference
C
      Double precision ThreshSCF
c
c     dftmp2 functional stuff: DFT += c2*MP2
c
      logical dftmp2            ! use DFT reference orbitals and energy
      double precision mp2fac   ! coefficient on MP2 contribution to total energy
c
      double precision fss, fos ! Spin Component Scaled (SCS) MP2
      logical scs               ! SCS flag
C
C     Initialize this module
C
      Status = .TRUE.
C
      Call RIMP2_PStat_Init
      Call PStat_On( PS_Overall)
C
      Me = GA_NodeID()
C
#ifndef RIMP2_USE_DA
C
C     Initialize integral file LUNs if not using DAs
C
      Do I = 1, MaxSpin
         D_Int(i) = 9 + i
      EndDo
#endif
C
C     Get necessary info from database
C
      Call Util_Print_Push
      Call Util_Print_RTDB_Load(RTDB, My_Ctx)
      PrInfo = Util_Print('information', Print_Low)
C
      call ecce_print_module_entry('mp2')
C
      If (.NOT. RTDB_CGet(RTDB, 'title', 1, JobTitle)) JobTitle = ' '
C
C     ************************************
C     * Check for adequate SCF reference *
C     ************************************
c
      if (.not. rtdb_get(rtdb,'dft:dftmp2',mt_log,1,dftmp2))
     $     dftmp2 = .false.
c
      if (dftmp2) then  ! get thresholds for dftmp2
        if (.not. rtdb_get(rtdb,'dft:e_conv',mt_dbl,1,threshscf))
     $       threshscf = 1.0d-4
        if (threshscf .gt. 1.0d-6) then
           threshscf = 1.0d-6
           if (.not. rtdb_put(rtdb,'dft:e_conv',mt_dbl,1,threshscf))
     $          call errquit('mp2_grad: failed setting dft:e_conv',0,
     &                       RTDB_ERR)
           status = rtdb_delete(rtdb,'dft:converged')
        endif
c
      else  ! traditional HF
c
        if (.not. rtdb_get(rtdb,'scf:thresh',mt_dbl,1,threshscf))
     $     threshscf = 1.0d-4
        if (threshscf .gt. 1.0d-6) then
         threshscf = 1.0d-6
         if (.not. rtdb_put(rtdb,'scf:thresh',mt_dbl,1,threshscf))
     $        call errquit('mp2_grad: failed setting scf:thresh',0,
     &       RTDB_ERR)
         status = rtdb_delete(rtdb,'scf:converged') ! Status irrelevant
        endif
      end if  ! dftmp2
c
c     Get the DFT/HF energy
c
      if (dftmp2) then
        if (.not.dft_energy(rtdb)) then
           call ecce_print_module_exit('mp2','failed')
           call errquit('rimp2: DFT did not converged',0,RTDB_ERR)
        endif
        if (.not.rtdb_get(rtdb,'dft:mp2fac',mt_dbl,1,mp2fac)) then
          mp2fac = 1.0d0
          if (Me.eq.0) then
            write(LuOut,*) 'dft:mp2fac not found, using 1.0'
          endif
        endif
      else
        if (.not. scf(rtdb)) then
           rimp2 = .false.
           call ecce_print_module_exit('mp2','failed')
           Call Util_Print_pop
           return
        endif
      endif
C
C     *****************
C     * Module header *
C     *****************
C
      If ( Me .eq. 0 .AND. PrInfo) then
C
         Call Util_Print_Centered(LuOut, 'NWChem RI-MP2 Module', 40,
     $   .TRUE.)
         If ( JobTitle .ne. ' ') Call Util_Print_Centered( LuOut,
     $      JobTitle, 40, .FALSE.)
         Write (LuOut, '(//)')
      EndIf
C
      If ( .NOT. Geom_Create( Geom, Geom_Name) )
     $   Call ErrQuit('rimp2: geom_create failed', Geom, GEOM_ERR)
      If ( .NOT. Geom_RTDB_Load( RTDB, Geom, Geom_Name) )
     $   Call ErrQuit('rimp2: geom_rtdb_load failed', Geom, RTDB_ERR)
C
      If ( .NOT. Bas_Create( AOBas, AOBasName) )
     $   Call ErrQuit('rimp2: aobas bas_create failed', AOBas,
     &       BASIS_ERR)
      If ( .NOT. Bas_RTDB_Load( RTDB, Geom, AOBas, AOBasName) )
     $   Call ErrQuit('rimp2: aobas bas_rtdb_load failed', AOBas,
     &       BASIS_ERR)
      If ( .NOT. Int_Normalize( RTDB, AOBas) )
     $   Call ErrQuit('rimp2: aobas int_normalize failed', AOBas,
     &       INT_ERR)
C
      If ( .NOT. Bas_Create( FitBas, FitBasName) )
     $   Call ErrQuit('rimp2: fitbas bas_create failed', FitBas,
     &       BASIS_ERR)
      If ( .NOT. Bas_RTDB_Load( RTDB, Geom, FitBas, FitBasName) )
     $   Call ErrQuit('rimp2: fitbas bas_rtdb_load failed', FitBas,
     &       BASIS_ERR)
      If ( .NOT. Int_Normalize( RTDB, FitBas) )
     $   Call ErrQuit('rimp2: fitbas int_normalize failed', FitBas,
     &       INT_ERR)
C
C     Get other controls -- threshold for neglect of integrals, etc.
C
      Call RIMP2_Get_Param( RTDB, Thresh, MxTBatch, Mem_Opt, MxEBatch,
     $   Approx, MinEVal)
C
C     Figure out file names.  Munging to get the full name is done in
C     open_3ci, not here!
C
      if (.not. RTDB_CGet(rtdb, 'mp2:mo 3-center integral file',
     $     1, FNInt)) FNInt = Def_Int
C
C     Get some info about the basis sets for later use
C
      If ( .NOT. Bas_NumBF( AOBas, NAOBF) )
     $   Call ErrQuit('rimp2: aobas bas_numbf failed', AOBas, BASIS_ERR)
      If ( .NOT. Bas_NumBF( FitBas, NFit) )
     $   Call ErrQuit('rimp2: fitbas bas_numbf failed', FitBas,
     &       BASIS_ERR)
      If ( .NOT. Bas_Name( AOBas, AOName, AONameT) )
     $   Call ErrQuit('rimp2: aobas bas_name failed', AOBas,
     &       BASIS_ERR)
      If ( .NOT. Bas_Name( FitBas, FitName, FitNameT) )
     $   Call ErrQuit('rimp2: fitbas bas_name failed', FitBas,
     &       BASIS_ERR)
C
      Call Corr_Mk_Ref(RTDB, My_Ctx, Geom, AOBas, .false.,
     . RefNAO, TopSpin, NCorBF,G_AOXF, MinChunk, MinChunk, MaxSpin, 
     .     H_Occ, H_EVal, NFrzOcc, NFrzVir, .False.)
C
      If (RefNAO .ne. NAOBF) Call ErrQuit(
     $     'RIMP2: Incompatible reference AO basis size', RefNAO-NAOBF,
     &       INPUT_ERR)
      MxNCorBF = NAOBF
      If ( .NOT. MA_Get_Index(H_Occ, I_Occ) ) Call ErrQuit(
     $     'RIMP2: Failed to get index for occ vector', H_Occ, MA_ERR)
      If ( .NOT. MA_Get_Index(H_EVal, I_EVal) ) Call ErrQuit(
     $     'RIMP2: Failed to get index for eval vector', H_EVal, MA_ERR)
C
C     Determine ranges to transform.
C
      Do I = 1, TopSpin
         Call Occ_Ranges( NCorBF(I), Dbl_MB(I_Occ + MxNCorBF * (I-1) ),
     $      ILo(I), IHi(I), ALo(I), AHi(I) )
      EndDo
C
      If ( .NOT. MA_Free_Heap( H_Occ) ) Call ErrQuit(
     $   'RIMP2: Unable to free local array H_Occ', H_Occ, MA_ERR)

c     flag and scaling factors for SCS-MP2

      if (.not. rtdb_get(rtdb, 'mp2:fss', mt_dbl, 1, fss))
     $  fss = 1.0d0/3.0d0   ! same spin scaling factor for SCS-MP2
      if (.not. rtdb_get(rtdb, 'mp2:fos', mt_dbl, 1, fos))
     $  fos = 1.2d0         ! opposite spin scaling factor for SCS-MP2
      if (.not. rtdb_get(rtdb, 'mp2:scs', mt_log, 1, scs))
     $  scs = .false.       ! flag for SCS
C
C     **********************************************
C     * Print out calculation information for user *
C     **********************************************
C
      If ( Me .eq. 0 .AND. PrInfo) then
C
         Write (LuOut,'(1X, A)' ) 'RI-MP2 Calculation Information:'
         Write (LuOut, 8520) 'Nr. of AO basis functions:', NAOBF
         Write (LuOut, 8520) 'Nr. of fitting basis functions:', NFit
         Write (LuOut, 8520) 'Nr. of MO spin cases:', TopSpin
         Write (LuOut, 8520) 'Nr. of MOs to be correlated:',
     $      (NCorBF(i), i = 1, TopSpin)
         Write (LuOut, 8520) 'Nr. of occupied MOs correlated:',
     $      (IHi(i)-ILo(i)+1, i = 1, TopSpin)
         Write (LuOut, 8520) 'Nr. of virtual MOs correlated:',
     $      (AHi(i)-ALo(i)+1, i = 1, TopSpin)
         Write (LuOut, *)
C
         if (scs) then
           Write (LuOut, 8530) 'SCS-MP2:', scs
           Write (LuOut, 8510) 'Same spin scaling factor:', fss
           Write (LuOut, 8510) 'Opposite spin scaling factor:', fos
           Write (LuOut, *)
         endif
         Write (LuOut, 8500) 'RI integral approximation:',
     $      Approx(:LNBlnk(Approx))
         Write (LuOut, 8510) 'Threshold for Schwarz screening:', Thresh
         Write (LuOut, 8510)
     $      'Smallest eigenvalue retained in fit:', MinEVal
         If ( MxTBatch .gt. 0) then
            Write (LuOut, 8520) 'Max. batch size for transformation:',
     $         MxTBatch
         EndIf
         If ( MxEBatch(1) .gt. 0 .OR. MxEBatch(2) .gt. 0) then
            Write (LuOut, 8520) 'Max. batch size for energy:',
     $         MxEBatch
         EndIf
         Write (LuOut, 8500) 'Base file name for MO integrals',
     $      FNInt(:LNBlnk(FNInt))
#ifdef RIMP2_USE_DA
         Write (LuOut, 8500) 'Type of storage for MO integrals',
     $      'disk arrays'
#else
         Write (LuOut, 8500) 'Type of storage for MO integrals',
     $      'EAF library'
#endif
         Write (LuOut, *)
C
         if (util_print('geometry',print_high)) then
            if (.not. geom_print(geom))
     $         call errquit('RIMP2: geom_print', 0, GEOM_ERR)
            write(LuOut,*)
         endif
         if (util_print('basis', print_high)) then
            if (.not. bas_print(AOBas)) 
     $           call errquit('RIMP2: bas_print', 0, BASIS_ERR)
            write(LuOut,*)
            if (.not. bas_print(FitBas)) 
     $           call errquit('RIMP2: bas_print', 0, BASIS_ERR)
            write(LuOut,*)
         endif
         if (util_print('geombas', print_debug)) then
            if (.not. gbs_map_print(AOBas)) 
     $           call errquit('RIMP2:gmp', 0, BASIS_ERR)
            write(LuOut,*)
            if (.not. gbs_map_print(FitBas)) 
     $           call errquit('RIMP2:gmp', 0, BASIS_ERR)
            write(LuOut,*)
         endif
         call util_flush(LuOut)
      EndIf
C
 8500 Format(1X, A35, 1X, '''', A, '''')
 8505 Format(1X, A35, 2X, A)
 8510 Format(1X, A35, 4(1X, 1PE10.3), (/36X, 4(1X, I10)) )
 8520 Format(1X, A35, 4(1X, I10), (/36X, 4(1X,I10)) )
 8530 Format(1X, A35, 1X, L1)
C
 9050 Format(1X, 'The following mapping relates the ''correlated ',
     $       'basis'' to the original SCF basis.')
 9051 Format(1X, 'This correlated calculation is based on an SCF ',
     $       'reference in which'/
     $   1X, 'orbitals have been frozen or rearranged relative to ',
     $        'the result of the'/
     $   1X, 'SCF calculation.  From this point on, the orbitals ',
     $       'are labeled in the'/
     $   1X, '''correlated basis''.'/)
C
C     *************************************
C     * Integral transformation (to disk) *
C     *************************************
C
#ifdef RIMP2_USE_DA
C
C     Compute largest and total DA sizes (in bytes)
C
      MaxDASiz = 0
      TotDASiz = 0
      Do I = 1, TopSpin
         Size =  (IHi(i)-ILo(i)+1) * (AHi(i)-ALo(i)+1) * NFit
         SizeB = MA_SizeOf(MT_Dbl, Size, MT_Byte)
         MaxDASiz = Max( MaxDASiz, SizeB)
         TotDASiz = TotDASiz + SizeB
      EndDo
C
C     Initialize DAs.  We know everything but how much memory to give it.
C
      If (DRA_Init(TopSpin, MaxDASiz, TotDASiz, -1) .ne. 0)
     $   Call ErrQuit('RIMP2: DRA_Init failed', 0, CALC_ERR)
#endif
C
C
C     Initialize integrals
C
      Bases(1) = AOBas
      Bases(2) = FitBas
C
      Call Int_Init(RTDB, 2, Bases)
C
C
      If ( .NOT. RIMP2_XF_Driver( RTDB, Geom, AOBas, FitBas,
     $   TopSpin, D_Int, FNInt, ALo, AHi, ILo, IHi, MxTBatch, Thresh,
     $   MinEVal, Approx, G_AOXF,actualname) ) Call ErrQuit(
     $   'rimp2: rimp2_xf_driver failed', 911, CALC_ERR)
C
C     Finished with the AO transformation
C
      Status = .TRUE.
      Do I = TopSpin, 1, -1
         Status = Status .AND.  GA_Destroy( G_AOXF(I))
      EndDo
      If ( .NOT. Status) Call ErrQuit(
     $   'RIMP2: Unable to destroy AO transformation', 0, GA_ERR)
C
C     Done computing integrals
C
      Call Int_Terminate
C
C     Shift ranges of virtual and occupieds into the _number_ of each
C
      Do I = 1, TopSpin
         AHi(I) = AHi(I) - ALo(I) + 1
         ALo(I) = 1
         IHi(I) = IHi(I) - ILo(I) + 1
         ILo(I) = 1
      EndDo
C
C     Create matrix to hold spin case breakdown of E(2)
C
      If ( .NOT. MA_Push_Get( MT_Dbl, TopSpin*TopSpin,
     $   'E(2) spin case breakdown', H_Contrib, Contrib_Idx) ) Call
     $   ErrQuit('rimp2: can''t allocate spin contribution matrix', 911,
     &       MA_ERR)
C
C     **********************
C     * Energy calculation *
C     **********************
C
      If ( .NOT. RIMP2_V_E2( rtdb, D_Int, FNInt, TopSpin, NCorBF, IHi, 
     $   AHi, NFit, FitBas, Dbl_MB(I_Eval), MxNCorBF, 
     $   Dbl_MB(Contrib_Idx),CorEner, Mem_Opt, MxEBatch(1), MxEBatch(2),
     ,     actualname)) Call ErrQuit(
     $   'rimp2: rimp2_v_e2 failed', 911, CALC_ERR)
C
C     Also get the SCF energy so we can report the total energy
C
      if (dftmp2) then
        if (.not.rtdb_get(rtdb, 'dft:energy', mt_dbl, 1, RefEner)) then
           call errquit('rimp2: failed to get dft:energy from RTDB',
     1                  0,RTDB_ERR)
        endif
      else
        if (.not.rtdb_get(rtdb, 'scf:energy', mt_dbl, 1, RefEner)) then
           call errquit('rimp2: failed to get scf:energy from RTDB',
     1                  0,RTDB_ERR)
        endif
      endif
C
      if (dftmp2) then
        TotEner = RefEner + mp2fac*CorEner
      else
        TotEner = RefEner + CorEner
      endif
C
c
c      old output printing
c
c      If ( Me .eq. 0) then
c         Call Banner(LuOut,'RI-MP2 energy','-',.TRUE.,.TRUE.,.FALSE.)
c         if (dftmp2) then
c           Write(LuOut,'(1X,A,F30.15)') 'Using DFT reference'
c         endif
c         Write(LuOut,'(1X,A,F30.15)') 'Reference energy:    ',RefEner
c         Write(LuOut,'(1X,A,F30.15)') 'Correlation energy:  ',CorEner
c         if (dftmp2) then
c           Write(LuOut,'(1X,A,F30.15)') 'Total DFT+PT2 energy: ',TotEner
c         else
c           Write(LuOut,'(1X,A,F30.15)') 'Total RI-MP2 energy: ',TotEner
c         endif
c      EndIf
c
c       same format as MP2 and directMP2
c
        if (Me.eq.0) then
          if (dftmp2) then
            write(6,998) RefEner,CorEner,TotEner
 998        format(//,10x,43('-'),
     $              /,10x,'DFT energy             ',f20.12,
     $              /,10x,'Unscaled MP2 energy    ',f20.12,
     $              /,10x,'Total DFT+MP2 energy   ',f20.12,
     $              /,10x,43('-'),/)
          else if (.not.scs) then
            write(6,999) RefEner,CorEner,TotEner
 999        format(//,10x,43('-'),
     $              /,10x,'SCF energy         ',f24.12,
     $              /,10x,'Correlation energy ',f24.12,
     $              /,10x,'Total MP2 energy   ',f24.12,
     $              /,10x,43('-'),/)
          else
            write(6,997) RefEner,CorEner,TotEner
 997        format(//,10x,47('-'),
     $              /,10x,'SCF energy             ',f24.12,
     $              /,10x,'SCS Correlation energy ',f24.12,
     $              /,10x,'Total SCS-MP2 energy   ',f24.12,
     $              /,10x,47('-'),/)
          endif
        endif
C
C     Write our energy out to the database
C
      Status = RTDB_Put(RTDB,'rimp2:correlation energy',MT_Dbl,1,
     $   CorEner)
      Status = Status.AND.RTDB_Put(RTDB,'rimp2:energy',MT_Dbl,1,
     $     TotEner)
      if (dftmp2) then
        Status = Status.AND.RTDB_Put(RTDB,'dft:energy',MT_Dbl,1,
     $     TotEner)
      endif
      If (.NOT.Status) then
         Call ErrQuit('rimp2: unable to store energies in rtdb',911,
     2                RTDB_ERR)
      endif
C
#ifdef RIMP2_USE_DA
C
      If ( DRA_Terminate() .ne. 0) Call ErrQuit(
     $   'RIMP2: DRA_Terminate failed', 0, CALC_ERR)
#endif
C
C     ***********
C     * Cleanup *
C     ***********
C
      Status = .TRUE.
      Status = Status .AND. MA_Pop_Stack( H_Contrib)
      Status = Status .AND.  MA_Free_Heap(H_Eval)
      If (.NOT.Status) then
         Call ErrQuit('RIMP2: Unable to destroy local arrays',0,MA_ERR)
      endif
C
      Status = Status .AND. Geom_Destroy(Geom)
      Status = Status .AND. Bas_Destroy(FitBas)
      Status = Status .AND. Bas_Destroy(AOBas)
      If (.NOT.Status) then
         Call ErrQuit('RIMP2: Failed to destroy geometry and basis',0,
     2                BASIS_ERR)
      Endif
C
      Call Util_Print_Pop
      call ecce_print_module_exit('mp2', 'ok')
C
      Call PStat_Off( PS_Overall)
      Call RIMP2_PStat_Print
      Call RIMP2_PStat_Term
C
      RIMP2 = .TRUE.
      Return
      End

c
c     $Id: bybminimize2.F 24484 2013-08-08 01:49:15Z bylaska $                       
c

*  ************************************************************
*  *                                                          *
*  *             Band by Band Kohn-Sham Minimizer             *
*  *                    (mixing densities)                    *
*  *                                                          *
*  *                                                          *
*  ************************************************************
  
      subroutine bybminimize2(E,deltae,deltac,current_iteration,
     >                       set_iterations,iterations,failed)
      implicit none
      real*8     E(*)
      real*8     deltae,deltac
      integer    current_iteration
      logical    set_iterations
      integer    iterations
      logical    failed


#include "stdio.fh"
#include "mafdecls.fh"
#include "util.fh"

*     **** local variables ****
      integer MAX_SD_COUNT
      parameter (MAX_SD_COUNT = 1)
      integer MASTER,taskid
      parameter (MASTER=0)

      real*8  deltat_min
      parameter (deltat_min=1.0d-3)
       
      integer rho_in(2),rho_out(2),rho_junk(2)
      real*8  E0,dE0,deltae_old,Ein,deltae_history(10)
      real*8  ks_deltae,deltav,dV,deltav_old,diis_error
      integer nx,ny,nz,stalled_count,sd_count


      real*8     tole,tolc
      real*8     ehartree,eorbit,exc,pxc,eion
      real*8     Enew,Eold,alpha
      !common / cgsd_block / Enew,Eold,alpha

      integer it,it_in,i,ispin,bfgscount,icount,sd_it,cg_it,it2

      logical value,precondition,done,stalled,deltav_bad(4),oprint
      logical dohfx
      integer n2ft3d
      !real*8  e_ionmm,e_qmmm,e_mmmm,e_pol,e_vib,e_cav
      !real*8  e_qmmm_e,e_qmmm_q,e_qmmm_lj,e_mmmm_q,e_mmmm_lj
      real*8 e_lj,e_q,e_spring
      real*8 ehfx,phfx
      


*     **** external functions ****
      logical control_print,control_fractional
      integer  control_ispin,control_scf_algorithm,control_ks_algorithm
      integer  control_it_in,control_it_out,psi_ne,control_version
      real*8   control_tole,control_tolc,control_ks_alpha
      real*8   rho_error,psi_1energy,psi_error
      real*8   dng_1ehartree,lattice_omega
      real*8   psi_1ke
      real*8   psi_1vl,psi_1v_field
      real*8   psi_1vnl
      real*8   rho_1exc
      real*8   rho_1pxc
      real*8   ewald_e,ion_ion_e
      real*8   psi_1eorbit,psi_smearcorrection
   
      external control_print,control_fractional
      external control_ispin,control_scf_algorithm,control_ks_algorithm
      external control_it_in,control_it_out,psi_ne,control_version
      external control_tole,control_tolc,control_ks_alpha
      external rho_error,psi_1energy,psi_error
      external dng_1ehartree,lattice_omega
      external psi_1ke
      external psi_1vl,psi_1v_field
      external psi_1vnl
      external rho_1exc
      external rho_1pxc
      external ewald_e,ion_ion_e
      external psi_1eorbit,psi_smearcorrection

*     ***** QM/MM external functions ****
      logical  pspw_qmmm_found
      real*8   pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E
      external pspw_qmmm_found
      external pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E

*     ***** pspw_charge external functions ****
      logical  pspw_charge_found,control_precondition,pspw_HFX
      logical  pspw_HFX_relaxed,psp_U_psputerm,meta_found
      real*8   pspw_charge_Energy_ion,pspw_charge_Energy_charge
      external pspw_charge_found,control_precondition,pspw_HFX
      external pspw_HFX_relaxed,psp_U_psputerm,meta_found
      external pspw_charge_Energy_ion,pspw_charge_Energy_charge

      real*8   psi_1_noupdate_energy,psi_eigenvalue
      external psi_1_noupdate_energy,psi_eigenvalue
      logical  nwpw_meta_gga_on,ion_disp_on
      external nwpw_meta_gga_on,ion_disp_on
      real*8   psi_1meta_gga_pxc,ion_disp_energy
      external psi_1meta_gga_pxc,ion_disp_energy


   
      Ein = E(1)
      call Parallel_taskid(taskid)
      oprint = (taskid.eq.MASTER).and.control_print(print_medium)
      dohfx = (pspw_HFX().and.pspw_HFX_relaxed())


      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      dV = lattice_omega()/dble(nx*ny*nz)
      if (set_iterations) then
        it_in = iterations
        sd_it = 2 
        cg_it = 1 
      else
        it_in = control_it_in()*control_it_out()
        sd_it = 10
        cg_it = 10
      end if
      tole  = control_tole()
      tolc  = control_tolc()
      precondition = control_precondition()
      ispin = control_ispin()
      deltav_old = 10.0d0
      deltav     = 0.0d0

      stalled       = .false.
      deltae_history(1) = 0.0d0
      deltae_history(2) = 0.0d0
      deltae_history(3) = 0.0d0
      deltae_history(4) = 0.0d0
      stalled_count     = 0
      sd_count          = 0

      call D3dB_n2ft3d(1,n2ft3d)

*     **** allocate rho_in and rho_out ****
      value = MA_push_get(mt_dbl,2*n2ft3d,
     >                     'rho_in',rho_in(2),rho_in(1))
      value = value.and.
     >        MA_push_get(mt_dbl,2*n2ft3d,
     >                     'rho_out',rho_out(2),rho_out(1))
      value = value.and.
     >        MA_push_get(mt_dbl,2*n2ft3d,
     >                   'rho_junk',rho_junk(2),rho_junk(1))
      if (.not. value) 
     >   call errquit('bybminimize2:out of stack memory',0,0)

*     **** ion-ion energy ****
      eion = 0.0d0
      if (control_version().eq.3) eion = ewald_e()
      if (control_version().eq.4) eion = ion_ion_e()


*     **********************
*     **** bybminimizer2 ****
*     **********************


*     **** set the initial density ****
      if (current_iteration.eq.1) then
         Enew   = psi_1energy()
         alpha = control_ks_alpha()
         deltae = -9232323299.0d0
         ks_deltae = tole
         call electron_gen_vall()
         call psi_get_density(1,dbl_mb(rho_in(1)))
         call psi_get_density(1,dbl_mb(rho_out(1)))

         call psi_1gen_hml()
         call psi_diagonalize_hml_assending()
         call psi_1rotate2()
         call psi_2to1()
         if (dohfx) call psi_1genrho()
         if (control_fractional()) call psi_1reverse_occupation()
      else
         call psi_get_density(1,dbl_mb(rho_in(1)))
         call psi_get_density(1,dbl_mb(rho_out(1)))
      end if
      call psi_set_density(1,dbl_mb(rho_out(1)))
  
*     **** iniitialize SCF Mixing ****    
      call nwpw_scf_mixing_init(control_scf_algorithm(),alpha,
     >                5,ispin,n2ft3d,dbl_mb(rho_out(1)))

*     **** iniitialize RMM-DIIS ****
      if (control_ks_algorithm().eq.1) call pspw_rmmdiis_init(5)


*     ***** diis loop ****
      it2 = -4
      it   = 0
 2    it   = it + 1
      it2 = it2 + 1
      
*     **** diaganolize KS matrix ****
      call psi_KS_update(1,
     >                   control_ks_algorithm(),
     >                   precondition,
     >                   ks_deltae)
      call rho_1to2()

*     **** rotate orbitals ****
      call psi_1gen_hml()
      call psi_diagonalize_hml_assending()
      call psi_1rotate2()
      call psi_2to1()

*     **** define fractional occupation ****
      if (control_fractional()) call psi_1define_occupation(.false.)

      Eold = Enew
      Enew = psi_1energy()

      deltae = Enew-Eold

      !call electron_gen_vall()
      call psi_get_density(1,dbl_mb(rho_in(1)))

*     **** compute deltaV ****
      call dcopy(ispin*n2ft3d,
     >           dbl_mb(rho_in(1)),1,
     >           dbl_mb(rho_junk(1)),1)
      call daxpy(ispin*n2ft3d,
     >              (-1.0d0),
     >              dbl_mb(rho_out(1)),1,
     >              dbl_mb(rho_junk(1)),1)
      deltav = ddot(ispin*n2ft3d,
     >                 dbl_mb(rho_junk(1)),1,
     >                 dbl_mb(rho_junk(1)),1)
      call D3dB_SumAll(deltav)
      deltav = deltav*dV
      


*     **** update vall using density mixing ****
c      if ((it.le.0) .or.
c     >    ((dabs(deltae).lt.1.0d1) .and.
c     >    (deltav       .lt.1.0d1) .and.
c     >    (.not.stalled          ))) then
      if ((it2.le.0) .or.
     >    ((dabs(deltae).lt.1.0d5) .and.
     >     (deltav.lt.1.0d5) .and.
     >     (.not.stalled          ))) then

         call nwpw_scf_mixing(dbl_mb(rho_in(1)),dbl_mb(rho_out(1)),
     >                        deltae,diis_error)

*     **** bad convergence - try fixed step steepest descent ****
      else
  30     call sdminimize(sd_it)
         sd_count = sd_count + 1
         Eold   = Enew
         Enew   = psi_1energy()
         it2 = -4
        
         if ((Enew.gt.Eold).and.(sd_count.lt.MAX_SD_COUNT)) go to 30

         call dcopy(ispin*n2ft3d,
     >              dbl_mb(rho_out(1)),1,
     >              dbl_mb(rho_junk(1)),1)

         call psi_get_density(1,dbl_mb(rho_out(1)))
         call nwpw_scf_mixing_reset(dbl_mb(rho_out(1)))


         call daxpy(ispin*n2ft3d,
     >              (-1.0d0),
     >              dbl_mb(rho_out(1)),1,
     >              dbl_mb(rho_junk(1)),1)
         deltav = ddot(ispin*n2ft3d,
     >                 dbl_mb(rho_junk(1)),1,
     >                 dbl_mb(rho_junk(1)),1)
         call D3dB_SumAll(deltav)
         deltav = deltav*dV

         call psi_1gen_hml()
         call psi_diagonalize_hml_assending()
         call psi_1rotate2()
         call psi_2to1()
         if (dohfx) call psi_1genrho()

         stalled       = .false.
         deltae_history(1) = 0.0d0
         deltae_history(2) = 0.0d0
         deltae_history(3) = 0.0d0
         deltae_history(4) = 0.0d0
         stalled_count     = 0

      end if
      call psi_set_density(1,dbl_mb(rho_out(1)))
      
          
*     **** tolerance checks ****
      deltae = Enew-Eold   
      deltac = rho_error()
      E(1)   = Enew+eion

      if ((oprint).and.(.not.set_iterations)) then 
        write(luout,1310) it,E(1),deltae,deltac,deltav
        call util_flush(luout)
      end if
 1310 FORMAT(I8,E20.10,3E15.5)


      !**** set ks_deltae ****
      ks_deltae = 0.001d0*dabs(deltae)
      if (ks_deltae.lt.(0.1d0*tole)) ks_deltae = 0.1d0*tole
      if (ks_deltae.gt.1.0d-4) ks_deltae = 1.0d-4
      !ks_deltae = 0.1d0*tole

      deltav_old = deltav

      deltae_history(1)    = deltae_history(2)
      deltae_history(2)    = deltae_history(3)
      deltae_history(3)    = deltae_history(4)
      deltae_history(4)    = deltae        

      if (stalled_count .gt.4) then
        stalled = (deltae_history(4)
     >            +deltae_history(3)
     >            +deltae_history(2)
     >            +deltae_history(1)).gt.0.0d0
      else
         stalled = .false.
      end if
      stalled_count = stalled_count + 1
      stalled = .false.

      precondition = precondition.and.(dabs(deltae).gt.1*tole)

      done = ( (    (dabs(deltae).lt.tole)
     >         .and.(deltae.lt.0.0d0)
     >         .and.(deltac      .lt.tolc))
     >       .or. (it.ge.it_in))
c     >       .or. (sd_count.ge.MAX_SD_COUNT))

      if (.not.done) go to 2


*     **** free memory ****
      call nwpw_scf_mixing_end()
      if (control_ks_algorithm().eq.1) call pspw_rmmdiis_end()
      value =           MA_pop_stack(rho_junk(2))
      value = value.and.MA_pop_stack(rho_out(2))
      value = value.and.MA_pop_stack(rho_in(2))
      if (.not. value) 
     >  call errquit('bybminimize2: popping stack',1,0)

c      call psi_check()


*     **** set return energies **** - This is duplicate code
      !Enew     = psi_1energy()
      eorbit   = psi_1eorbit()
      ehartree = dng_1ehartree()
      exc      = rho_1exc()
      pxc      = rho_1pxc()

      E(1)  = Enew + eion
      E(2)  = eorbit
      E(3)  = ehartree
      E(4)  = exc
      E(5)  = eion
      E(6)  = psi_1ke()
      E(7)  = psi_1vl()
      E(8)  = psi_1vnl()
      E(9)  = 2.0d0*ehartree
      E(10) = pxc
      if (pspw_qmmm_found()) then
         e_lj     = pspw_qmmm_LJ_E()
         e_q      = pspw_qmmm_Q_E()
         e_spring = pspw_qmmm_spring_E()
         E(1)  = E(1) + e_lj + e_q + e_spring

         E(11) = e_lj
         E(12) = e_q
         E(13) = e_spring
      end if

*     **** get pspw_charge  energies ****
      if (pspw_charge_found()) then
         E(19)  = psi_1v_field()
         E(20)  = pspw_charge_Energy_ion()
         E(21)  = pspw_charge_Energy_charge()
         E(1)   = E(1) + E(20) + E(21)
      end if

*     **** HFX terms ****
      if (pspw_HFX()) then
         call electron_HFX_energies(ehfx,phfx)
         E(26) = ehfx
         E(27) = phfx
      end if

*     **** DFT+U terms ****
      if (psp_U_psputerm()) then
         call electron_U_energies(ehfx,phfx)
         E(29) =  ehfx
         E(30) =  phfx
      end if

*     **** Metadynamics potential terms ****
      if (meta_found()) then
         call electron_meta_energies(ehfx,phfx)
         E(31) =  ehfx
         E(32) =  phfx
      end if


      if (control_fractional()) then
        E(28) = psi_smearcorrection()
        E(1)  = E(1) + E(28)
      end if


*     **** Metadynamics GGA Tau potential term ****
      if (nwpw_meta_gga_on()) then
         E(10) = E(10) - psi_1meta_gga_pxc()
      end if

*     **** Dispersion energy ****
      if (ion_disp_on()) then
         E(33) = ion_disp_energy()
         E(1)  = E(1) + E(33)
      end if

ccc      failed = (sd_count.ge.MAX_SD_COUNT)
      failed = .false.

      return
      end
 

      program nwchem
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "tcgmsg.fh"
#include "pstat.fh"
#include "util.fh"
#include "inp.fh"
#include "bgj_common.fh"
#include "stdio.fh"
      integer rtdb
      integer stack
      integer heap
      integer global
      logical status
      logical overify, ohardfail
#ifdef CRAY_T3D
      integer oldact, fsigctl
#endif
#ifdef PSCALE
      integer io_code
#else
      integer*4 io_code
#endif
c
c  $Id: nwchem.F 26080 2014-08-27 18:12:07Z d3y133 $
c
c  ======================================================================================================
C> \mainpage Northwest Computational Chemistry Package (NWChem) 6.5
C>
C> NWChem is an open-source computational chemistry package distributed under the terms of
C> the Educational Community License (ECL) 2.0
C>
C> This software and its documentation were developed at the EMSL at Pacific Northwest National Laboratory,
C> a multiprogram national laboratory, operated for the U.S. Department of Energy by Battelle under
C> Contract Number DE-AC05-76RL01830. Support for this work was provided by the Department of Energy
C> Office of Biological and Environmental Research, Office of Basic Energy Science, and the Office of
C> Advanced Scientific Computing.
C>
C> Licensed under the Educational Community License, Version 2.0 (the "License"); you may
C> not use this file except in compliance with the License. You may obtain a copy of the
C> License at <a href="http://www.osedu.org/licenses/ECL-2.0">http://www.osedu.org/licenses/ECL-2.0</a>.
C>
C> Unless required by applicable law or agreed to in writing, software distributed under the
C> License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
C> either express or implied. See the License for the specific language governing
C> permissions and limitations under the License.
C>
C> Further information, including user documentation and forums, may be found at
C> <a href="http://www.nwchem-sw.org/">http://www.nwchem-sw.org/</a>. Alternatively,
C> the paper
C>
C> * M. Valiev, E.J. Bylaska, N. Govind, K. Kowalski, T.P. Straatsma, H.J.J. Van Dam,
C>   D. Wang, J. Nieplocha, E. Apra, T.L. Windus, W.A. de Jong (2010)<br>
C>   "NWChem: A comprehensive and scalable open-source solution for large scale molecular simulations"<br>
C>   <I>Computer Physics Communications</I>, <b>181</b>, 1477–1489, DOI: <a href="http://dx.doi.org/10.1016/j.cpc.2010.04.018">10.1016/j.cpc.2010.04.018</a>
C>
C> provides details on the codes capabilities.
C>
C> Copyright (c) 1994-2014 Pacific Northwest National Laboratory, Battelle Memorial Institute
C>
C> Environmental Molecular Sciences Laboratory (EMSL)<br>
C> Pacific Northwest National Laboratory<br>
C> Richland, WA 99352
c
c  ======================================================================================================
c
      character*(nw_max_path_len) input_filename, rtdb_name
      double precision total_wall, total_cpu
#ifdef USE_OFFLOAD
      integer ppnout
      logical offload_master
      external offload_master
#endif

      logical ostartup, ocontinue, orestart
      logical  input_parse
      external input_parse
c
c     Create parallel processes and initialize IPC layer
c
      call pbeginf()
c
c     MXINIT is needed by PeIGS and PFFT to initialize
c     the communication fabric they use.
c
      call mxinit
c
c     Initialize timers so they are relative to job start
c
      total_wall = -util_wallsec()
      total_cpu  = -util_cpusec()
c
c     Only process 0 opens the input file 
c     (note that ga_nodeid() does not work yet!)
c
      if (nodeid() .eq. 0) then   
c
c     Get the name of the input file from the command line
c
         call get_input_filename(input_filename)
c
         open(LuIn, file=input_filename, status='old', form='formatted',
     $        err=10000)
         goto 10001
10000    call errquit('nwchem: failed to open the input file', 0,
     &       INPUT_ERR)
10001    continue
c
      else
#if !(defined(KSR) || defined(IBM) || defined(FUJITSU_SOLARIS) ||defined(FUJITSU_VPP) ||defined(FUJITSU_VPP64))
         close(LuIn)
#endif
      endif
c
c     Look for memory directive in the input ... must eventually
c     open the rtdb first so that can get memory directive out of that
c     if it is not in the input
c
C     The user input model has well-defined categories of memory,
C     each of which has a specific size.  How we use these limits
C     depends on the platform we are running on.
C
      call input_mem_size(stack, heap, global, overify, ohardfail)
c
c     Initialize local memory allocator & global array tools
C
      call ga_initialize_ltd(ma_sizeof(mt_dbl,global,mt_byte))
      if ( ga_uses_ma() ) then
        if (.not.ma_init(mt_dbl, stack, heap+global))
     &      call errquit('nwchem.F: ma_init failed (ga_uses_ma=T)',911,
     &      MA_ERR)
      else
        if (.not.ma_init(mt_dbl,stack,heap))
     &      call errquit('nwchem.F: ma_init failed (ga_uses_ma=F)',911,
     &      MA_ERR)
      endif
      call rtdb_init()
c
*
*     More for amusement then efficiency force all MA allocated entities 
*     to be aligned at the beginning of a 128 byte cache line
*
!      if (.not. ma_set_numalign(7))
!     $     call errquit('nwchem.F: ma_set_numalign failed',911, MA_ERR)
c aligned to 64byte record
      if (.not. ma_set_numalign(6))
     $     call errquit('nwchem.F: ma_set_numalign failed',911, MA_ERR)
*
*
*old:------------------------------------------------------- START ---------
*old:C     GA allocations come out of MA space, so lump them together
*old:C     and let MA impose the limits on GA sizes instead of actually
*old:C     using the global limit.
*old:C
*old:      if ( ga_uses_ma() ) then
*old:         if (.not. ma_init(mt_dbl, stack, heap+global))
*old:     $      call errquit('nwchem: ma_init failed', -1)
*old:         call ga_initialize
*old:C
*old:C     GA allocations are separate from MA, so the separate limit
*old:C     must be enforced.  Note GA only understands bytes.
*old:C
*old:      else
*old:         if (.not. ma_init(mt_dbl, stack, heap))
*old:     $      call errquit('nwchem: ma_init failed', -1)
*old:         call ga_initialize_ltd(ma_sizeof(mt_dbl, global, mt_byte) )
*old:      endif
*old:------------------------------------------------------- END -----------
c
*****      call nxtval_ga_initialize()
c
c     Trap SIGFPE after GA to override handler
c
*****      call ieeetrap()
#if defined(DECOSF) || defined(LINUXALPHA)
      call dec_fpe  ! To avoid underflow problems on Alpha in Texas
#endif
#ifdef CRAY_T3D
*     This as a temporary fix for SIGFPE in Texas that does not seem
*     to affect the final results
      oldact = fsigctl('IGNORE','SIGFPE',0)
#endif
#ifdef LINUX
c      uncommenting this line turns on sigfpe trapping under linux
!      call linux_trapfpe()
#endif
#if defined(MACX)
c      uncommenting this line turns on sigfpe trapping under Mac OSX
!      call macx_trapfpe()
#endif
c
c     Hard fail is good for development but means that we cannot
c     respond to allocation problems. Disable by default.
c
      status = ma_set_auto_verify(overify)
      status = ma_set_hard_fail(ohardfail)
      status = ma_set_error_print(ohardfail)
c
c     Initialize pstat
c
      if (.not. pstat_init(20, 1, ' ')) call errquit
     $     ('nwchem: pstat_init failed', 0, UNKNOWN_ERR)
c
      call input_file_info(input_filename, rtdb_name,
     &    ostartup, ocontinue)
c
c     Now are ready to summarize the environment
c
      call nwchem_banner(input_filename, rtdb_name,
     &    ostartup, ocontinue)
c
c     Actually open the database and store the file prefix 
c
c     Note that only process 0 has the database name ... that is OK.
c
      if (ostartup) then
         if (.not. rtdb_open(rtdb_name, 'empty', rtdb))
     $        call errquit('start: rtdb_open empty failed ', 0,
     &       RTDB_ERR)
      else
         if (.not. rtdb_open(rtdb_name, 'old', rtdb))
     $        call errquit('start: rtdb_open old failed ', 0, RTDB_ERR)
      endif
C
C     initialize nxtask
C
      call nxtask_init(rtdb)
c!!! BGJ
      bgj_rtdb = rtdb
c!!! BGJ
c
c
      
      if (ostartup.or.ocontinue) then
        orestart = .false.
      else
        orestart = .true.
      endif
c
      call util_set_rtdb_state(rtdb,ostartup,ocontinue,orestart)
c
      call util_file_info_rtdb(rtdb) ! Save file info for restart
c
      call movecs_ecce_print_on()
c
      call geom_hnd_parallel(.true.)
c
      call perfm_start()

#ifdef USE_OFFLOAD
      call util_getppn(ppnout)
      if(ga_nodeid().eq.0)write(luout,*)  ga_nodeid(),' ppn ',ppnout
      if(offload_master()) then
      if(ga_nodeid().lt.ppnout)
     w        write(luout,*)  ga_nodeid(),' offload_master '
      call util_mic_set_affinity()
      endif
#endif

      if (orestart .or. ocontinue) call nw_print_restart_info(rtdb)
c
c if continue then go right to task stored on rtdb do not further parse
c input.  If input is required then user should have used restart
c
      if (ocontinue) call task(rtdb) 
c
c
c     Parse input data, shove into the database and execute tasks
c
 10   if (input_parse(rtdb)) then ! while (tasks to do)
         call util_print_rtdb_load(rtdb,' ') ! High level print
         if (util_print('tcgmsg',print_never)) then 
            call setdbg(1)
         else
            call setdbg(0)
         endif
#ifdef CATAMOUNT
         call util_allocga()
#endif
         call task(rtdb)
         goto 10                !    end while
      endif
c
c     Close the RTDB
c
      call util_print_rtdb_load(rtdb,' ') ! High level print
      if (util_print('rtdbvalues', print_debug)) then
         if (.not. rtdb_print(rtdb, .true.))
     $     call errquit('control: rtdb_print failed', 0, RTDB_ERR)
      else if (util_print('rtdb', print_high)) then
         if (.not. rtdb_print(rtdb, .false.))
     $     call errquit('control: rtdb_print failed', 0, RTDB_ERR)
      endif
c
      if (.not. rtdb_close(rtdb, 'keep'))
     $     call errquit('nwchem: rtdb_close failed', rtdb, RTDB_ERR)
c
      if (util_print('rtdb', print_high) .or.
     $    util_print('rtdbvalues', print_high)) then
         call rtdb_print_usage  ! Called after closing so memory leaks apparent
      endif
c
c     Tidy up pstat
c
      if (.not. pstat_terminate()) call errquit
     $     ('nwchem: pstat_terminate failed', 0, UNKNOWN_ERR)
c
****      call nxtval_ga_terminate()
c
c     Print memory and other info
c
      call ga_sync()
      if (ga_nodeid() .eq. 0) then
         if (util_print('ga summary', print_default))
     $        call ga_summarize(0)
         if (util_print('ga stats', print_default)) then
            call ga_print_stats()
            write(LuOut,*)
         endif
         if (util_print('ma summary', print_default))
     $        call ma_summarize_allocated_blocks()
         if (util_print('ma stats', print_high)) then
            call ma_print_stats(.true.)
         else if (util_print('ma stats', print_default)) then
            call ma_print_stats(.false.)
         endif
         if (util_print('version', print_debug))
     $        call util_version
         if (util_print('citation', print_none))
     &       call util_cite()
      endif
      call perfm_end()
      total_wall = total_wall + util_wallsec()
      total_cpu  = total_cpu  + util_cpusec()
      if (ga_nodeid() .eq. 0) then
        if (util_print('total time', print_none)) then
          write(LuOut,1,iostat=io_code) total_cpu, total_wall
 1        format(/' Total times  cpu:',f11.1,'s     wall:',f11.1,'s')
          if(io_code.ne.0.and.
     A         util_print('total time', print_high))  then
             write(luout,*) ' iostat ',io_code
           endif
           call util_flush(LuOut)
        endif
      endif
      call ecce_print1('all tasks cpu time',mt_dbl,total_cpu,1)
      call ecce_print1('all tasks wall time',mt_dbl,total_wall,1)
      call ga_sync()
c
c     Tidy up the global memory
c
      call ga_terminate()
c
c     Tidy up the parallel environment
c
      call pend()
c
c     Close the ECCE' output file if there is one
c
      call ecce_print_file_close()
c
c     Done
c
      end
      subroutine nwchem_banner(input_filename, rtdb_name, ostartup,
     &    ocontinue)
      implicit none
#include "global.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "stdio.fh"
c
c     Print a banner at the top of the output to identify the origin
c     of the code along with hostname, no. of processors, date, ...
c
      character*(*) input_filename, rtdb_name
      logical ostartup
      logical ocontinue
c
      double precision dbletomb
      character*80 hostname, compiled, batchid
      character*(nw_max_path_len) executable, srcdir, file_prefix
      character*(nw_max_path_len) branch, nwchem_rev, ga_rev
      character*26 date
#if defined(CRAY)
      integer ilen,ierror
#endif
      integer heap, stack, global, global_b, total, nproc
      logical status
#ifdef CATAMOUNT
      integer istatus,setvbuf3f
      external setvbuf3f
#endif
      character*3 cstatus, fstatus
      character*10 cstart
      Character*40 GStatus
c
#ifdef CATAMOUNT
      istatus=setvbuf3f(luout, 0, 4096)
      istatus=setvbuf3f(0, 0, 4096)
#endif
      if (ga_nodeid() .ne.0) goto 10101
c
      call util_print_centered(LuOut,
     $     '                                                          ',
     $     40, .true.)
      write(LuOut,*)
      write(LuOut,*)
      call util_print_centered(LuOut,
     $     'Northwest Computational Chemistry Package (NWChem) 6.5',
     $     40, .true.)
      write(LuOut,*)
      write(LuOut,*)
      call util_print_centered(LuOut,
     $      'Environmental Molecular Sciences Laboratory',
     $     40, .false.)
      call util_print_centered(LuOut,
     $     'Pacific Northwest National Laboratory',
     $     40, .false.)
      call util_print_centered(LuOut,'Richland, WA 99352',
     $     40, .false.)
      write(LuOut,*)
      call util_print_centered(LuOut,'Copyright (c) 1994-2014',
     $     40, .false.)
      call util_print_centered(LuOut,
     $     'Pacific Northwest National Laboratory',
     $     40, .false.)
      call util_print_centered(LuOut,'Battelle Memorial Institute',
     $     40, .false.)
      write(LuOut,*)
      call util_print_centered(LuOut,
     $'NWChem is an open-source computational chemistry package'
     $ , 40, .false.)
      call util_print_centered(LuOut,
     $'distributed under the terms of the'
     $ , 40, .false.)
      call util_print_centered(LuOut,
     $'Educational Community License (ECL) 2.0'
     $ , 40, .false.)
      call util_print_centered(LuOut,
     $'A copy of the license is included with this distribution' 
     $ , 40, .false.)
      call util_print_centered(LuOut,
     $'in the LICENSE.TXT file'
     $ , 40, .false.)
      write(LuOut,*)
      call util_legal()
c
      call util_getarg(0,executable)
      call util_hostname(hostname)
      call util_date(date)
      nproc = ga_nnodes()
      if (ostartup) then
         cstart = 'startup'
      else
        if (ocontinue) then
          cstart = 'continue'
        else
          cstart = 'restart'
        endif
      endif
      call util_file_prefix(' ',file_prefix)
c
      compiled =
     & COMPILATION_DATE
      call util_nwchem_srcdir(srcdir)
      srcdir = srcdir(1:max(1,inp_strlen(srcdir)-4))
      branch =
     & NWCHEM_BRANCH   
      call util_nwchem_version(nwchem_rev)
      call util_ga_version(ga_rev)
C
C     See if we can get the batch system id.  We understand NQS and
C     LoadLeveler at present
C
      BatchID = ' '
      Call Util_GetEnv('QSUB_REQID', batchid)
      If ( Inp_StrLen(batchid) .eq. 0 ) then
         Call Util_GetEnv('LOADL_JOB_NAME', batchid)
        If ( inp_strlen(batchid) .eq. 0 ) then
            call util_getenv('LSB_JOBID', batchid)
         endif
      EndIf
C
      call util_print_centered(LuOut, 'Job information', 17, .true.)
      write(LuOut,2) 
     $     hostname(1:inp_strlen(hostname)),
     $     executable(1:inp_strlen(executable)),
     $     date(1:inp_strlen(date)),
     $     compiled(1:inp_strlen(compiled)),
     $     srcdir(1:inp_strlen(srcdir)),
     &     branch(1:inp_strlen(branch)),
     &     nwchem_rev(1:inp_strlen(nwchem_rev)),
     &     ga_rev(1:inp_strlen(ga_rev)),
     $     input_filename(1:inp_strlen(input_filename)),
     $     file_prefix(1:inp_strlen(file_prefix)),
     $     rtdb_name(1:inp_strlen(rtdb_name)),
     $     cstart(1:inp_strlen(cstart)),
     $     nproc,
     $     util_batch_job_time_remaining()
C
C  Print version information to ecce.out file
C
      compiled(inp_strlen(compiled)+1:inp_strlen(compiled)+25) = 
     $         ' Version 6.5'
      call ecce_print_version(compiled(1:inp_strlen(compiled)))
C
      If ( Inp_StrLen(BatchID) .gt. 0) then
         Write(LuOut,22) BatchID(:Inp_StrLen(BatchID))
      Else
         Write(LuOut,'(//)') 
      EndIf
C
 2    format(/
     $     '    hostname        = ', a/
     $     '    program         = ', a/
     $     '    date            = ', a/
     $     '    compiled        = ', a/
     $     '    source          = ', a/
     $     '    nwchem branch   = ', a/
     $     '    nwchem revision = ', a/
     $     '    ga revision     = ', a/
     $     '    input           = ', a/
     $     '    prefix          = ', a/
     $     '    data base       = ', a/
     $     '    status          = ', a/
     $     '    nproc           = ', i8/,
     $     '    time left       = ', i6,'s')
 22   format(
     $     '    batch job id    = ', a/)
c
c     Determine, without altering, setting of memory verification
c     and hardfail.
c
      status = ma_set_auto_verify(.true.)
      if (status) then
         cstatus = 'yes'
      else
         cstatus = 'no '
      endif
      status = ma_set_auto_verify(status)
c
      status = ma_set_hard_fail(.true.)
      if (status) then
         fstatus = 'yes'
      else
         fstatus = 'no '
      endif
      status = ma_set_hard_fail(status)
C
C     Memory size information.  Note:  Subtleties of MA & friends
C     will likely result in actual heap and stack sizes _slightly_ 
C     larger than requested at initialization, and other slight
C     "inconsistencies".  It has to do with the overhead associated
C     with an allocation.
C
      heap  = ma_inquire_heap(MT_Dbl)
      stack = ma_inquire_stack(MT_Dbl)
C
C     If GA cannot determine a limit on the available memory, it
C     will return a negative number, which MA_SizeOf does not
C     appreciate.  This should not happen in NWChem, but we might
C     as well play it safe.
C
      global_b = ga_memory_avail()
      If ( Global_B .ge. 0) then
         global = MA_SizeOf(MT_Byte, global_b, MT_Dbl)
      Else
         global = 0
      EndIf
      
C
      Total = Heap + Stack
      If ( .NOT. GA_Uses_MA() ) Total = Total + Global
C
      If ( GA_Uses_MA() ) then
         GStatus = '(within heap+stack)'
      Else
         GStatus = '(distinct from heap & stack)'
      EndIf
c
      call util_print_centered(LuOut, 'Memory information', 19, .true.)
c
*old:      write(LuOut,3) heap, stack, global, GStatus, total, cstatus,
*old:     $     fstatus
*old: 3    format(/
*old:     $     '    heap      = ', i10,' doubles'/
*old:     $     '    stack     = ', i10,' doubles'/
*old:     $     '    global    = ', i10,' doubles ', A/
*old:     $     '    total     = ', i10,' doubles'/
*old:     $     '    verify    = ', a3/
*old:     $     '    hardfail  = ', a3//)
      dbletomb = 8.0d00/(1024.0d00*1024.0d00)
      write(LuOut,3)
     &    heap,((dble(heap)*dbletomb)),
     &    stack,((dble(stack)*dbletomb)),
     &    global,((dble(global)*dbletomb)),
     &    GStatus(1:inp_strlen(gstatus)),
     &    total,((dble(total)*dbletomb)),
     &    cstatus,
     &    fstatus
 3    format(/
     $     '    heap     = ', i10,' doubles',' = ',f8.1,' Mbytes',/,
     $     '    stack    = ', i10,' doubles',' = ',f8.1,' Mbytes',/,
     $     '    global   = ', i10,' doubles',' = ',f8.1,' Mbytes',
     &     ' ',A,/,
     $     '    total    = ', i10,' doubles',' = ',f8.1,' Mbytes',/,
     $     '    verify   = ', a3,/,
     $     '    hardfail = ', a3,//)
c
      call util_print_centered(LuOut, 
     &     'Directory information', 20, .true.)
      write(LuOut,*)
c
c     Below here back to parallel execution
c
10101 call util_file_print_dirs()
      if(ga_nodeid().eq.0) write(LuOut,*)
c
      end
c
      subroutine nw_print_restart_info(rtdb)
      implicit none
#include "global.fh"
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "util.fh"
      integer rtdb
c
c     Summarize the status of a restart calculation
c
      logical mode, task_qmmm, ignore, lstatus
      character*30 operation, status
      character*32 theory
c
      if (ga_nodeid() .eq. 0) then
         mode = rtdb_parallel(.false.)
         if (.not.rtdb_get(rtdb,'task:QMMM',mt_log,1,task_qmmm))
     &        task_qmmm = .false.
c      
         if (.not. rtdb_cget(rtdb, 'task:operation', 1, operation))
     $        operation = ' '
c
         if(.not.rtdb_cget(rtdb,'task:theory',1,theory))
     $        theory = ' '
c
         if (.not. rtdb_get(rtdb, 'task:ignore', mt_log, 1, ignore))
     $        ignore = .false.
c
         if (rtdb_get(rtdb, 'task:status', mt_log, 1, lstatus)) then
            if (lstatus) then
               status = 'ok'
            else
               status = 'fail'
            endif
         else
            status = 'unknown'
         endif
c
         if (theory.ne.' ' .or. operation.ne.' ' .or. task_qmmm) then
            call util_print_centered(LuOut,'Previous task information',
     $           22, .true.)
            write(LuOut,1) theory, operation, status, task_qmmm, ignore
 1          format(/,
     $           '    Theory    = ', a,/,
     $           '    Operation = ', a,/,
     $           '    Status    = ', a,/,
     $           '    Qmmm      = ', l1,/,
     $           '    Ignore    = ', l1,/)
         endif
         call geom_print_known_geoms(rtdb)
         call bas_print_known_bases(rtdb)
         call util_flush(LuOut)
         mode = rtdb_parallel(mode)
      endif
c
      call ga_sync()
c
      end
      

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_mkstep(
     &       HIEIGS,GISR,VC,STEP,SELECT,SCRVEC,ATMASS,
     &       ENERGY, CONVGE, CONVGG, CONVGGM, GRAD_MAX,
     &       E2NEW,NINTER,NAT3,NMODE,TRUSTI,BCKSTP,
     &       CNVGRD,rtdb)
c $Id: stpr_mkstep.F 25540 2014-05-01 22:33:27Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
#include "errquit.fh"
      LOGICAL BCKSTP,CNVGRD,LPRINT, oprint, oprint_step
#include "chow.fh"
#include "util.fh"
      integer rtdb
      COMMON / THRESH / RCONVG,RSTD
      COMMON / CFACE / IWCTR,NATOM,ICALC
      DIMENSION HIEIGS(NINTER),GISR(NINTER),VC(NAT3,NINTER),
     &          STEP(NAT3),SELECT(NAT3),SCRVEC(NAT3),
     &          ATMASS(NATOM)
C
C     Convergence/symmetry tolerances.
C
#include "stpr_clean.fh"
      IATOM(I)  = (I+2)/3
c      LPRINT = .TRUE.
      LPRINT = util_print('makestep',print_debug)
      oprint = util_print('information', print_default)
      oprint_step = util_print('step', print_low)
      IF (MWC) THEN
        CONVGG=1.0D-08
      ENDIF
C
C     Write Hessian eigenvalues.
C
      IF(LPRINT)THEN
        WRITE(6,*)'  Hessian eigenvalues: '
        CALL stpr_matout(HIEIGS,NINTER,1,NINTER)
c        WRITE(6,*)(HIEIGS(I),I=1,NINTER)
      ENDIF
C
C     Write gradient components.
C
      IF(LPRINT)THEN
        WRITE(6,*)'  Gradient components in the spectral ',
     &            'representation: '
        CALL stpr_matout(GISR,NINTER,1,NINTER)
c        WRITE(6,*)(GISR(I),I=1,NINTER)
      ENDIF
C
C     Calculate gradient norm.
C
      GLNGTH = 0.0D0
      DO 10 I = 1,NINTER
        GLNGTH = GLNGTH + GISR(I)**2
   10 CONTINUE
      GLNGTH = SQRT(GLNGTH)
C
C     gradient maximum
C
      GMXMUM = GRAD_MAX
C
C     Count the number of negative eigenvalues.
C
      NNEG = 0
      DO 20 N = 1, NINTER
        IF(HIEIGS(N).LT.0.D0)THEN
          NNEG = NNEG + 1
        ENDIF
   20 CONTINUE
C
C     Check whether convergence has been reached.
C     Also set any TRUST info.
C
      CALL stpr_cheker(ENERGY,EOLD,E2OLD,EDIFF,
     &                 GMXMUM,GLNGTH,ERATIO,
     &                 CONVGE, CONVGG, CONVGGM,
     &                 TRUSTI,TRUST,TRUSTO,SOLD,NNEG,NWALK,
     &                 BCKSTP,CNVGRD)
C
C     Make the steepest descent step if appropriate
C
   25 CONTINUE
      IF (STD) THEN
         if (oprint)
     $        WRITE(6,*)'  Calculating the steepest descent step. '
         DO 30 I = 1,NINTER
           STEP(I) = -GISR(I)
   30    CONTINUE
C
C        Find the length of the steepest descent STEP.
C
         SLNGTH = 0.0D0
         DO 35 I = 1,NINTER
           SLNGTH = SLNGTH + STEP(I)**2
   35    CONTINUE
         SLNGTH = SQRT(SLNGTH)
C
C        Check and scale step if needed
C
C
C        Step too long ...
C
         IF (SLNGTH.GT.RSTD) THEN
           DO 7117 I=1,NINTER
             STEP(I) = STEP(I)*RSTD/SLNGTH
 7117      CONTINUE
         ELSE
C
C        Step shorter than RSTD and TRTR is true
C
           IF (TRTR) THEN
             DO 7127 I=1,NINTER
               STEP(I) = STEP(I)*RSTD/SLNGTH
 7127        CONTINUE
             GOTO 75
           ENDIF
C
C        Step shorter than RSTD, TROT is true, NMODE's
C        hessian eigenvalue still negative
C
           IF(TROT.AND.(HIEIGS(NMODE).LT.0.D0)) THEN
             DO 7137 I=1,NINTER
               STEP(I) = STEP(I)*RSTD/SLNGTH
 7137        CONTINUE
             GOTO 75
           ENDIF
         ENDIF
         GOTO 75
      ENDIF
C
C     TS or OMIN walks
C
C     Make the N-R step if:
C     - all hessian eigenvalues positive and minimization
C     - one hessian eigenvalue negative and walk to a transition state
C
      IF((NNEG.EQ.0.AND.OMIN).OR.
     &(NNEG.EQ.1.AND.TS.AND.(HIEIGS(1).LT.0.D0))) THEN
C
C       Determine the N-R step.
C
         if (oprint)
     $        WRITE(6,*)'  Calculating the Newton-Raphson step. '
        DO 40 I = 1,NINTER
          IF(ABS(HIEIGS(I)).GT.1.D-14)THEN
            STEP(I) = -GISR(I)/HIEIGS(I)
          ELSE
            IF (I.EQ.NMODE) THEN
              STEP(I) = DSIGN(TRUST,GISR(I))
            ELSE
              STEP(I) = DSIGN(TRUST,-GISR(I))
            ENDIF
          ENDIF
          IF ((ABS(STEP(I)).GT.TRUST).AND.(ICALC).EQ.2) THEN
            STEP(I) = DSIGN(TRUST,STEP(I))
          ENDIF
   40   CONTINUE
C
C     Minimization with some negative hessian eigenvalues
C
      ELSEIF (OMIN) THEN
        DO 50 I = 1,NINTER
          IF(ABS(HIEIGS(I)).GT.1.D-14)THEN
            IF (HIEIGS(I).GT.0.D0) THEN
              STEP(I) = -GISR(I)/HIEIGS(I)
            ELSE
              STEP(I) = DSIGN(TRUST,-GISR(I))
            ENDIF
          ELSE
            STEP(I) = DSIGN(TRUST,-GISR(I))
          ENDIF
          IF ((ABS(STEP(I)).GT.TRUST).AND.(ICALC).EQ.2) THEN
            STEP(I) = DSIGN(TRUST,STEP(I))
          ENDIF
   50   CONTINUE
C
C     Uphill along NMODE with all hessian eigenvalues positive
C
      ELSEIF (TS.AND.(NNEG.EQ.0)) THEN
        DO 60 I = 1,NINTER
          IF(ABS(HIEIGS(I)).GT.1.D-14)THEN
            IF (I.EQ.NMODE) THEN
              STEP(I) = DSIGN(TRUST,GISR(I))
            ELSE
              STEP(I) = -GISR(I)/HIEIGS(I)
            ENDIF
          ELSE
            IF (I.EQ.NMODE) THEN
              STEP(I) = DSIGN(TRUST,GISR(I))
            ELSE
              STEP(I) = DSIGN(TRUST,-GISR(I))
            ENDIF
          ENDIF
          IF ((ABS(STEP(I)).GT.TRUST).AND.(ICALC).EQ.2) THEN
            STEP(I) = DSIGN(TRUST,STEP(I))
          ENDIF
   60   CONTINUE
C
C     Uphill with fishy hessian structure
C
      ELSEIF (TS.AND.(NNEG.GT.0)) THEN
        DO 70 I = 1,NINTER
          IF(ABS(HIEIGS(I)).GT.1.D-14)THEN
            IF (I.EQ.NMODE) THEN
              IF (HIEIGS(I).LT.0.D0) THEN
                STEP(I) = -GISR(I)/HIEIGS(I)
              ELSE
                STEP(I) = DSIGN(TRUST,GISR(I))
              ENDIF
            ELSE
              IF (HIEIGS(I).GT.0.D0) THEN
                STEP(I) = -GISR(I)/HIEIGS(I)
              ELSE
                STEP(I) = DSIGN(TRUST,-GISR(I))
              ENDIF
            ENDIF
          ELSE
            IF (I.EQ.NMODE) THEN
              STEP(I) = DSIGN(TRUST,GISR(I))
            ELSE
              STEP(I) = DSIGN(TRUST,-GISR(I))
            ENDIF
          ENDIF
          IF ((ABS(STEP(I)).GT.TRUST).AND.(ICALC).EQ.2) THEN
            STEP(I) = DSIGN(TRUST,STEP(I))
          ENDIF
   70   CONTINUE
      ELSE
        WRITE(6,*) 'Unexpected type of walk. Program aborts'
        call errquit('stepper:mkstep: fatal error',911, CALC_ERR)
      ENDIF
   75 CONTINUE
      IF(LPRINT)THEN
         WRITE(6,*)'  The STEP in the spectral representation'
         CALL stpr_matout(STEP,NINTER,1,NINTER)
c     WRITE(6,*)(STEP(I),I=1,NINTER)
      ENDIF
C
C     Temporarily store this STEP in SCRVEC for later printing.
C
      DO 76 I = 1,NINTER
        SCRVEC(I) = STEP(I)
   76 CONTINUE
C
C     Find the length of STEP.
C
      SLNGTH = 0.0D0
      DO 80 I = 1,NINTER
        SLNGTH = SLNGTH + STEP(I)**2
   80 CONTINUE
      SLNGTH = SQRT(SLNGTH)
C
C     Calculation with first derivatives only
C     Scale down the step if needed
C
      IF ((SLNGTH.GT.TRUST).AND.(ICALC.EQ.1)) THEN
        DO 85 I=1,NINTER
           STEP(I) = STEP(I)*TRUST/SLNGTH
 85     CONTINUE
        IF(LPRINT)THEN
          WRITE(6,*)'  After scaling down ....',
     $          ' the STEP in the spectral representation'
          CALL stpr_matout(STEP,NINTER,1,NINTER)
c          WRITE(6,*)(STEP(I),I=1,NINTER)
        ENDIF
C
C       Find the length of STEP.
C
        SLNGTH = 0.0D0
        DO 90 I = 1,NINTER
          SLNGTH = SLNGTH + STEP(I)**2
 90     CONTINUE
        SLNGTH = SQRT(SLNGTH)
*        THRCLN=1.0D-04   ! RJH ... use data set 1e-6 to keep symm better
      ENDIF
      if (oprint)
     $     WRITE(6,'(a,f10.6)')
     $     '  The length (norm) of the STEP is ',SLNGTH
C
C     Determine TRUSTN for STD and first derivative walks
C
      IF (STD) THEN
        TRUSTN = MIN(RSTD,SLNGTH)
      ENDIF
      IF ((TS.OR.OMIN).AND.(ICALC.EQ.1)) THEN
        TRUSTN = MIN(TRUST,SLNGTH)
      ENDIF
C
C     Print small amount of useful information.
C
      if (oprint) then
         WRITE(6,1000)
         WRITE(6,1001)
         IEND = MIN(10,NINTER)
         DO 100 I = 1, IEND
            WRITE(6,1002)I,HIEIGS(I),GISR(I),SCRVEC(I),STEP(I)
 100     CONTINUE
 1000    FORMAT(/,'  The lowest few components in the bases ',/,
     &        '  generated by the spectral decomposition ',/,
     &        '  of the internal hessian (non-zero force). ')
 1001    FORMAT(/,'  Component  Hessian     Grad      Step',
     &        '   Scaled-Step',
     &        /,'  ---------  --------  --------  --------',
     &        ' -----------')
 1002    FORMAT('  ',4X,I2,4X,4(1X,D8.2,1X))
         WRITE(6,*)
      endif
C
C     Back transform STEP from the spectral decomp. to cart.
C     Store temporarily in SCRVEC.
C
      DO 120 I = 1,NAT3
        SCRVEC(I) = 0.0D0
        DO 110 J = 1,NINTER
          SCRVEC(I) = SCRVEC(I) + VC(I,J)*STEP(J)
  110   CONTINUE
        IF (MWC) THEN
          SCRVEC(I)=SCRVEC(I)/SQRT(ATMASS(IATOM(I)))
        ENDIF
  120 CONTINUE
C
C     End of stepping algorithm.  Wrap it up and return.
C
C     Clean up the STEP ... truncate any noise in the step
C     less then THRCLN.  Clean up the step in both the
C     cartesian basis and in the spectral representation.
C
      if (oprint)
     $     WRITE(6,'(a,f10.6)')
     $     '  Clean-up the step; truncate at: ',THRCLN
      CALL stpr_clnstp(STEP,THRCLN)
      CALL stpr_clnstp(SCRVEC,THRCLN)
C
C     Was this step meaningful?
C
      SLNGTH = 0.0D0
      DO 130 I = 1,NAT3
        SLNGTH = SLNGTH + SCRVEC(I)**2
 130  CONTINUE
      SLNGTH = SQRT(SLNGTH)
      if (oprint_step) then
         WRITE(6,'(a,f10.6)')
     $        '  In cartesian coordinates; norm of this step is: ',
     $        SLNGTH
      endif
c
c     RJH .. this was causing premature convergence.
c
c$$$      IF (SLNGTH.LE.CONVGG) THEN
c$$$         if (oprint_step) then
c$$$            WRITE(6,'(a,f10.6)')
c$$$     $           '  Norm of this step is less than ',CONVGG
c$$$            WRITE(6,*)'  This geometry walk is HISTORY. '
c$$$         endif
c$$$         CNVGRD = .TRUE.
c$$$        RETURN
c$$$      ENDIF
C
C     Find the largest component of STEP.
C
      SLNGTH = 0.0D0
      DO 140 I = 1,NINTER
        SLNGTH = MAX(ABS(SLNGTH),ABS(STEP(I)))
  140 CONTINUE
      IF ((TS.OR.OMIN).AND.(ICALC.EQ.2)) THEN
        TRUSTN = MIN(TRUST,SLNGTH)
      ENDIF
C
C     Get the predicted 2nd order energy.
C
C      ... Change STEP in the scaled coordinate back
C          to Y to calculate the energy expression (2nd order).
C
      FTERM = 0.0D0
      QTERM = 0.0D0
      DO 150 I=1,NINTER
        FTERM = FTERM + STEP(I)*GISR(I)
        QTERM = QTERM + 0.5D0*HIEIGS(I)*STEP(I)**2
  150 CONTINUE
      E2NEW = FTERM + QTERM
C
C     In the case of the STD walk check whether the predicted
C     energy change is negative
C
      IF (STD.AND.(E2NEW.GT.0.D0)) THEN
         if (oprint_step) then
            WRITE(6,*)'  For RSTD = ',RSTD,' the predicted energy '
            WRITE(6,*)'  change was positive',E2NEW
            RSTD=RSTD/2.D0
            WRITE(6,*)'  RSTD has been decreased to ',RSTD
         endif
        GOTO 25
      ENDIF
C
C     Move the step vector in the cartesian basis currently
C     stored in SCRVEC) into vector STEP replacing the step vector
C     in the spectral representation.
C
      call dfill(NAT3,0.0d00,STEP,1)
      DO 160 I = 1,NAT3
        STEP(I) = SCRVEC(I)
  160 CONTINUE
c
      call stpr_active(rtdb,step,nat3)
C
C     Put step parameters to save common and write them to tape 41.
C
      CALL stpr_putp(GMXMUM,GLNGTH,SLNGTH,EOLD,ENERGY,
     &           EDIFF,E2OLD,ERATIO,TRUSTO,TRUST,TRUSTN,
     &           E2NEW,NWALK,NNEG)
      RETURN
      END
      subroutine stpr_active(rtdb,step,nat3)
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "util.fh"
      integer rtdb    ! [input] rtdb handle
      integer nat3    ! [input] 3*number of atoms (dimen. of step)
      double precision step(nat3) ! step vector
c
      logical oprint  ! print info here
      integer nat       ! number of atoms
      integer nactive   ! number of active atoms
      integer h_actlist ! ma handle for actlist
      integer k_actlist ! ma index for actlist
      integer h_step    ! ma handle for copy of step
      integer k_step    ! ma index for copy of step
      integer i         ! loop index
      integer atom      ! atom index
      integer indx      ! offset in step and h_step
      integer ma_type
c
* check for active atom list
*..
      if (.not.rtdb_ma_get(rtdb,'geometry:actlist', ma_type, 
     $     nactive,h_actlist)) return
c
      oprint = util_print('step',print_debug)
      if (oprint) then
        write(luout,*)' step before removal of active atoms'
        call output(step,1,nat3,1,1,nat3,1,1)
      endif
c
      nat = nat3/3
      if (nactive.le.0 .or. nactive.gt.nat) call errquit
     &    ('stpr_active: invalid number of active atoms',nactive,
     &       INPUT_ERR)
      if (.not.MA_get_index(h_actlist,k_actlist)) call errquit
     &    ('stpr_active: ma_get_index failed for actlist',911, MA_ERR)
*
* .. get space for step
*
      if (.not.MA_push_get(mt_dbl,nat3,'stpr:alloc:active:step',
     &    h_step,k_step)) call errquit
     &    ('stpr_active: ma_push_get failed for step',911, MA_ERR)
*
* .. copy step to scratch space
*
      call dcopy(nat3,step,1,dbl_mb(k_step),1)
      call dfill(nat3,0.0d00,step,1)
*
*.. modify step to have active atoms with steps
*
      do i = 0,(nactive-1)
        atom = int_mb(k_actlist+i)
        indx = 3*(atom-1) + 1
        step(indx)   = dbl_mb(k_step+indx-1)
        step(indx+1) = dbl_mb(k_step+indx)
        step(indx+2) = dbl_mb(k_step+indx+1)
      enddo
      if (.not.MA_free_heap(h_actlist)) call errquit
     &    ('stpr_active: ma_free_heap failed for actlist',911, MA_ERR)
      if (.not.MA_pop_stack(h_step)) call errquit
     &    ('stpr_active: ma_pop_stack failed for h_step',911, MA_ERR)
c
      if (oprint) then
        write(luout,*)' '
        write(luout,*)' step after removal of active atoms'
        call output(step,1,nat3,1,1,nat3,1,1)
      endif
c
      end
C> @}

      SUBROUTINE beta_3_7_2_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: beta_3_7_2_1.F 19698 2010-10-29 17:03:09Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h3 h9 )_ytrb + = -1 * Sum ( h7 p5 p6 ) * trb ( p5 p6 h7 h9 )_trb * y ( h3 h7 p5 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER h7b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h9b_1
      INTEGER h7b_1
      INTEGER h3b_2
      INTEGER h7b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h9b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h9b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h9b-1)) .eq. ieor(irrep_
     &y,irrep_trb)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('beta_3_7_2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h7b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+h7b-1)))) .eq. irrep_trb) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h9b,h7b,p5b_1,p6b_1,h9b_1,h7b_1)
      CALL TCE_RESTRICTED_4(h3b,h7b,p5b,p6b,h3b_2,h7b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+h7b-1)
      dima_sort = int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('beta_3_7_2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &beta_3_7_2_1',2,MA_ERR)
      IF ((h7b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h9b-1)
     &,4,3,2,1,1.0d0)
      END IF
      IF ((h9b .lt. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h9b-1),int_mb(k_range+h7b-1)
     &,3,4,2,1,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('beta_3_7_2_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('beta_3_7_2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &beta_3_7_2_1',5,MA_ERR)
      IF ((h7b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab 
     &* (h7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,2,1,4,3,-1.0d0)
      END IF
      IF ((h3b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,1,2,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('beta_3_7_2_1',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('beta_3_7_2_1',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('beta_3_7_2_1',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &beta_3_7_2_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h9b-1),1,2,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('beta_3_7_2_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('beta_3_7_2_1',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* $Id: hghppv1.F 22549 2012-06-02 21:11:04Z bylaska $
*

*     **************************************
*     *                                    *
*     *           hghppv1                  *
*     *                                    *
*     **************************************

      logical function hghppv1(oprint_in,version,
     >                  psp_filename,formatted_filename,
     >                  ngrid,unita,rlocal)
      implicit none

#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "errquit.fh"
#include "util.fh"
#include "stdio.fh"

      logical          oprint_in
      integer          version
      character*50     psp_filename,formatted_filename
      integer          ngrid(3)
      double precision unita(3,3)
      real*8  rlocal
      character*255 full_filename

      logical value,mprint,hprint,oprint

      integer taskid,MASTER,msglen
      parameter (MASTER=0)

*     **** 1d pseudopotential data ****
      character*80 comment

      character*2 atom
      integer Zion
      double precision zv,amass

      double precision rloc,C1,C2,C3,C4
      double precision r(0:3),H(3,0:3),K(3,0:3)
      double precision Gijl(9*4),Gtmp(3,3,0:3)
      double precision rcore

      integer lmax,locp

      integer n_prj_indx,l_prj_indx,m_prj_indx,b_prj_indx
      integer n_prj_hndl,l_prj_hndl,m_prj_hndl,b_prj_hndl

*     ***** ngrid data *****
      integer Ylm_indx,vl_indx,vnl_indx,G_indx
      integer Ylm_hndl,vl_hndl,vnl_hndl,G_hndl

*     **** other variables ****
      double precision unitg(3,3)
      integer nsize,i,j,n,l,m,psp_type,indx
      integer nfft1,nfft2,nfft3
      integer nmax,nprj

*     **** external functions ****
      logical  control_print
      external control_print




c      call Parallel_init()
      call Parallel_taskid(taskid)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)
      mprint = (taskid.eq.MASTER).and.control_print(print_medium)
      oprint = (oprint_in.or.hprint)

      value = .false.
  
*     ***** read in pseudopotential data ****
      if (taskid.eq.MASTER) then
         call util_file_name_noprefix(psp_filename,.false.,.false.,
     >                       full_filename)
         l = index(full_filename,' ') - 1
         open(unit=11,file=full_filename(1:l),
     >                status='old',form='formatted')
         read(11,*) psp_type
         read(11,'(A2)') atom
         read(11,*) Zion
         read(11,*) lmax
         read(11,*) rloc,C1,C2,C3,C4

         if (lmax.ge.0) then
            read(11,*) r(0),H(1,0),H(2,0),H(3,0)
            do l=1,lmax
              read(11,*) r(l),H(1,l),H(2,l),H(3,l)
              read(11,*)      K(1,l),K(2,l),K(3,l)
            end do
         end if
         read(11,'(A)') comment
         close(11)


         !**** determine nmax ****
         nmax = 0
         do l=0,lmax
            do i=1,3 
              if ((H(i,l).ne.0.0d0) .and. (i.gt.nmax)) nmax = i
            end do
         end do
      end if


      msglen = 1
      call BRDCST(9+MSGINT,psp_type,mitob(msglen),MASTER)
      call BRDCST(9+MSGINT,Zion,mitob(msglen),MASTER)
      call BRDCST(9+MSGINT,lmax,mitob(msglen),MASTER)
      call BRDCST(9+MSGINT,nmax,mitob(msglen),MASTER)

      call BRDCST(9+MSGDBL,rloc,mdtob(msglen),MASTER)
      call BRDCST(9+MSGDBL,C1,mdtob(msglen),MASTER)
      call BRDCST(9+MSGDBL,C2,mdtob(msglen),MASTER)
      call BRDCST(9+MSGDBL,C3,mdtob(msglen),MASTER)
      call BRDCST(9+MSGDBL,C4,mdtob(msglen),MASTER)

      msglen = 4
      call BRDCST(9+MSGDBL,r,mdtob(msglen),MASTER)

      msglen = 12
      call BRDCST(9+MSGDBL,H,mdtob(msglen),MASTER)
      call BRDCST(9+MSGDBL,K,mdtob(msglen),MASTER)



*     **** set the maximum angular momentum ****

*     **** set the local potential ****
      locp = lmax+1

*     **** set the local potential ****
      rlocal = 1.0d0
      
      !**** determine nprj ****
      nprj= 0
      do l=0,lmax
            !write(luout,*) "???H :",l,(H(i,l),i=1,3)
      do i=1,3 
        if ((H(i,l).ne.0.0d0)) nprj = nprj + (2*l+1)
      end do
      end do
      !write(luout,*) "???nprj:", nprj
        


*     **** set the projector coeficients ****
      call dcopy(9*4,0.0d0,0,Gtmp,1)
      call dcopy(9*4,0.0d0,0,Gijl,1)
      Gtmp(1,1,0) = H(1,0)
      Gtmp(2,2,0) = H(2,0)
      Gtmp(3,3,0) = H(3,0)
      Gtmp(1,2,0) = -0.5d0*dsqrt(3.0d0/5.0d0)   *Gtmp(2,2,0)
      Gtmp(2,1,0) = Gtmp(1,2,0)
      Gtmp(1,3,0) =  0.5d0*dsqrt(5.0d0/21.0d0)  *Gtmp(3,3,0)
      Gtmp(3,1,0) = Gtmp(1,3,0)
      Gtmp(2,3,0) = -0.5d0*dsqrt(100.0d0/63.0d0)*Gtmp(3,3,0)
      Gtmp(3,2,0) = Gtmp(2,3,0)


      Gtmp(1,1,1) = H(1,1)
      Gtmp(2,2,1) = H(2,1)
      Gtmp(3,3,1) = H(3,1)
      Gtmp(1,2,1) = -0.5d0*dsqrt(5.0d0/7.0d0)   *Gtmp(2,2,1)
      Gtmp(2,1,1) = Gtmp(1,2,1)
      Gtmp(1,3,1) =  (1.0d0/6.0d0)*dsqrt(35.0d0/11.0d0)*Gtmp(3,3,1)
      Gtmp(3,1,1) = Gtmp(1,3,1)
      Gtmp(2,3,1) = -(14.0d0/6.0d0)*dsqrt(1.0d0/11.0d0)*Gtmp(3,3,1)
      Gtmp(3,2,1) = Gtmp(2,3,1)

      Gtmp(1,1,2) = H(1,2)
      Gtmp(2,2,2) = H(2,2)
      Gtmp(3,3,2) = H(3,2)
      Gtmp(1,2,2) = -0.5d0*dsqrt(7.0d0/9.0d0)   *Gtmp(2,2,2)
      Gtmp(2,1,2) = Gtmp(1,2,2)
      Gtmp(1,3,2) =  0.5d0*dsqrt(63.0d0/143.0d0)*Gtmp(3,3,2)
      Gtmp(3,1,2) = Gtmp(1,3,2)
      Gtmp(2,3,2) = -0.5d0*18.0d0*dsqrt(1.0d0/143.0d0)*Gtmp(3,3,2)
      Gtmp(3,2,2) = Gtmp(2,3,2)

      Gtmp(1,1,3) = H(1,3)
      Gtmp(2,2,3) = H(2,3)
      Gtmp(3,3,3) = H(3,3)



      do l=0,lmax
        do i=1,nmax
        do j=1,nmax
           Gijl(i+(j-1)*nmax+l*nmax*nmax) = Gtmp(i,j,l)
        end do
        end do
      end do


*     **** allocate vl, vnl, G ****
      nsize = (ngrid(1)/2+1)*ngrid(2)*ngrid(3)
      value = MA_alloc_get(mt_dbl,nsize,
     >                        'vl',vl_hndl,vl_indx)
      value = value.and.MA_alloc_get(mt_dbl,nsize*(nprj),
     >                        'vnl',vnl_hndl, vnl_indx)
      value = value.and.MA_alloc_get(mt_dbl,nsize,
     >                        'Ylm',Ylm_hndl, Ylm_indx)

      value = value.and.MA_alloc_get(mt_dbl,nsize*(3),
     >                        'G',G_hndl, G_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'n_prj', n_prj_hndl, n_prj_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'l_prj', l_prj_hndl, l_prj_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'm_prj', m_prj_hndl, m_prj_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'b_prj', b_prj_hndl, b_prj_indx)
      if(.not.value)
     >    call errquit('hghppv1: out of heap memory', 0, MA_ERR)


      !**** determine n_prj, l_prj, and m_prj arrays ****
      indx  = 0
      nfft1 = 1
      do l=0,lmax
      do i=1,3 
        if ((H(i,l).ne.0.0d0)) then
          do m=-l,l
            int_mb(n_prj_indx+indx) = i
            int_mb(l_prj_indx+indx) = l
            int_mb(m_prj_indx+indx) = m
            int_mb(b_prj_indx+indx) = nfft1
            indx = indx + 1
          end do 
          nfft1=nfft1+1
        end if
      end do
      end do


*     **** preparation of constants ****
      nfft1=ngrid(1)
      nfft2=ngrid(2)
      nfft3=ngrid(3)
      call setup_kbpp(nfft1,nfft2,nfft3,unita,unitg,dbl_mb(G_indx))
      zv = dble(Zion)

      call HGH_local(version,rlocal,
     >               zv,rloc,C1,C2,C3,C4,
     >               nfft1,nfft2,nfft3,
     >               dbl_mb(G_indx),
     >               dbl_mb(vl_indx))

      do i=1,nprj
         n=int_mb(n_prj_indx+i-1)
         l=int_mb(l_prj_indx+i-1)
         m=int_mb(m_prj_indx+i-1)
         call Tesseral(l,m,
     >                 nfft1,nfft2,nfft3,
     >                 dbl_mb(G_indx),
     >                 dbl_mb(Ylm_indx))
         call HGH_nonlocal(n,l,
     >                     r(l),
     >                     nfft1,nfft2,nfft3,
     >                     dbl_mb(G_indx),
     >                     dbl_mb(vnl_indx+(i-1)*nsize))
         if ((taskid.eq.MASTER).and.(oprint)) 
     >      write(luout,*) "creating projector:",n,l,m
         do j=1,nsize
          dbl_mb(vnl_indx+(i-1)*nsize+j-1)
     >    = dbl_mb(vnl_indx+(i-1)*nsize+j-1)*dbl_mb(Ylm_indx+j-1)
         end do

      end do


      if ((taskid.eq.MASTER).and.(oprint)) then
      write(luout,*) "     ********************************************"
      write(luout,*) "     *                                          *"
      write(luout,*) "     *    HGHPPV1 - Pseudopotential Formatter   *"
      write(luout,*) "     *                                          *"
      write(luout,*) "     *      version last updated 11/13/03       *"
      write(luout,*) "     *                                          *"
      write(luout,*) "     *       developed by Eric J. Bylaska       *"
      write(luout,*) "     *                                          *"
      write(luout,*) "     ********************************************"
      call nwpw_message(1)
      write(luout,*)
      write(luout,*) "Pseudpotential Data"
      write(luout,*) "-------------------"
      write(luout,*) "  atom     :",atom
      write(luout,*) "  charge   :",Zion
      write(luout,*) "  highest angular component used :",lmax
      write(luout,*) "  highest radial  component used :",nmax
      write(luout,*) "  number of non-local projectors :",nprj
      write(luout,111) "   projector cutoffs: ",(r(i), i=0,lmax)
      write(luout,*)
      write(luout,111) " local psp cutoff       : ",rloc
      write(luout,111) " local psp coefficients : ",C1,C2,C3,C4
      if (version.eq.4) 
     >   write(luout,*) "  aperiodic cutoff radius        :",rlocal
      
      write(luout,*)
      write(luout,*) "Simulation Cell"
      write(luout,*) "---------------"
      if (version.eq.3) write(luout,112) "  boundry: periodic"
      if (version.eq.4) write(luout,112) "  boundry: aperiodic"
      write(luout,113) "  ngrid  :",ngrid
      write(luout,114) "  unita  :",unita(1,1),unita(2,1),unita(3,1)
      write(luout,114) "          ",unita(1,2),unita(2,2),unita(3,2)
      write(luout,114) "          ",unita(1,3),unita(2,3),unita(3,3)
      write(luout,*)
  111 format(a,10f10.3)
  112 format(a)
  113 format(a,3I4)
  114 format(a,3F10.3)
  115 format(a,2E14.6)
      end if




      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(formatted_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      if (mprint) then
      write(luout,*)
      write(luout,*) "Generated formatted_filename: ",full_filename(1:l)
      !write(luout,*)
      end if
      call openfile(2,full_filename,l,'w',l)     

         call cwrite(2,comment,80)
         call iwrite(2,psp_type,1)
         call iwrite(2,version,1)
         call iwrite(2,ngrid,3)
         call dwrite(2,unita,9)
         call cwrite(2,atom,2)
         call dwrite(2,amass,1)
         call dwrite(2,zv,1)
         call iwrite(2,lmax,1)
         call iwrite(2,locp,1)
     
         call iwrite(2,nmax,1)
         call dwrite(2,r,lmax+1)

         
         call iwrite(2,nprj,1)
         if (nprj.gt.0) then
          call iwrite(2,int_mb(n_prj_indx),nprj)
          call iwrite(2,int_mb(l_prj_indx),nprj)
          call iwrite(2,int_mb(m_prj_indx),nprj)
          call iwrite(2,int_mb(b_prj_indx),nprj)
          call dwrite(2,Gijl,(nmax*nmax*(lmax+1)))
         end if

         if (version.eq.4) call dwrite(2,rlocal,1)
         rcore = 0.0d0
         call dwrite(2,rcore,1)

         call dwrite(2,dbl_mb(vl_indx),nsize)
         if (nprj.gt.0) then
           call dwrite(2,dbl_mb(vnl_indx),nsize*nprj)
         end if

      call closefile(2)
      end if
     
*     **** free heap space ****
      value = MA_free_heap(vl_hndl)
      value = value.and.MA_free_heap(vnl_hndl)
      value = value.and.MA_free_heap(Ylm_hndl)
      value = value.and.MA_free_heap(G_hndl)
      value = value.and.MA_free_heap(n_prj_hndl)
      value = value.and.MA_free_heap(l_prj_hndl)
      value = value.and.MA_free_heap(m_prj_hndl)
      value = value.and.MA_free_heap(b_prj_hndl)
      if(.not.value)
     >  call errquit('hghppv1: deallocatin heap memory', 0, MA_ERR)

      
      if ((taskid.eq.MASTER).and.(oprint)) call nwpw_message(4)
      hghppv1 = value
      return

 9999 call errquit('hghppv1:Error reading psp_filename',0, DISK_ERR)

      END

C stub routines for texas integral code.
C these routines are only called by various api routines
C 
C RA Kendall 11/95 PNNL
C
* $Id: texas_stubs.F 19696 2010-10-29 16:53:42Z d3y133 $
#define USE_TEXAS
#if defined(USE_TEXAS)
      subroutine texas_using_it4pnl()
      end
#else
      subroutine texas_terminate()
      end
      subroutine texas_init()
      end
      subroutine texas_set_accy()
      end
      subroutine texas_hf2_m()
#include "errquit.fh"
      call errquit(' use_texas is NOPE. should never get here ',911,
     &       INT_ERR)
      end
#endif

      subroutine hfmkr_1(R,PQ,IJK,NAB,Lr,Lr3)
c $Id: hfmkr_1.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
c
      integer NAB, Lr, Lr3
      integer IJK(0:Lr,0:Lr,0:Lr)
      double precision PQ(NAB,3)
      double precision R(NAB,0:Lr,Lr3)
c
      integer m
      double precision x,y,z
c
      IJK(0,0,0)=1
      if(Lr.eq.0) goto 00001
      IJK(1,0,0)=2
      IJK(0,1,0)=3
      IJK(0,0,1)=4
c
00001 continue
      if(Lr.eq.0) goto 00002
      do 00100 m=1,NAB
        X=PQ(m,1)
        Y=PQ(m,2)
        Z=PQ(m,3)
        R(M,0,2)=X*R(m,1,1)
        R(M,0,3)=Y*R(m,1,1)
        R(M,0,4)=Z*R(m,1,1)
00100 continue
c
00002 continue
c
      end

      SUBROUTINE ccsdtq_lambda1_14_11_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdtq_lambda1_14_11_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 h6 p13 p3 p4 p5 )_yt + = 1 * Sum ( h12 h11 p9 ) * t ( p9 p13 h11 h12 )_t * y ( h2 h6 h11 h12 p3 p4 p5 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p13b
      INTEGER h6b
      INTEGER p3b
      INTEGER p4b
      INTEGER p5b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER h11b
      INTEGER h12b
      INTEGER p13b_1
      INTEGER p9b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER h2b_2
      INTEGER h6b_2
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h2b = 1,noab
      DO p13b = noab+1,noab+nvab
      DO h6b = 1,noab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO p5b = p4b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p13b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+
     &int_mb(k_spin+p5b-1).ne.12)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p13b-1
     &) .eq. int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p13b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),in
     &t_mb(k_sym+p5b-1)))))) .eq. ieor(irrep_y,irrep_t)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+p13b-1) * int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_
     &mb(k_range+p5b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_14_11_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      DO h11b = 1,noab
      DO h12b = h11b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p9b-1) .eq. int_mb(k_spin+
     &h11b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p9b-1),ieor(int_mb
     &(k_sym+h11b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p13b,p9b,h11b,h12b,p13b_1,p9b_1,h11b_1,h12b_
     &1)
      CALL TCE_RESTRICTED_8(h2b,h6b,h11b,h12b,p3b,p4b,p5b,p9b,h2b_2,h6b_
     &2,h11b_2,h12b_2,p3b_2,p4b_2,p5b_2,p9b_2)
      dim_common = int_mb(k_range+p9b-1) * int_mb(k_range+h11b-1) * int_
     &mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_14_11_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_14_11_1',2,MA_ERR)
      IF ((p9b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p13b_1 - noab - 1 + nvab * (p
     &9b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b
     &-1),2,4,3,1,1.0d0)
      END IF
      IF ((p13b .lt. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p9b_1 - noab - 1 + nvab * (p1
     &3b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b
     &-1),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_14_11_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_14_11_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_14_11_1',5,MA_ERR)
      IF ((h12b .lt. h6b) .and. (h6b .lt. h2b) .and. (p9b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h6b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,3,4,2,1,5,1.0d0)
      END IF
      IF ((h12b .lt. h6b) .and. (h6b .lt. h2b) .and. (p3b .le. p9b) .and
     &. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h6b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,3,4,2,1,6,-1.0d0)
      END IF
      IF ((h12b .lt. h6b) .and. (h6b .lt. h2b) .and. (p4b .le. p9b) .and
     &. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h6b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,3,4,2,1,7,1.0d0)
      END IF
      IF ((h12b .lt. h6b) .and. (h6b .lt. h2b) .and. (p5b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h6b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,3,4,2,1,8,-1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .le. h12b) .and. (h12b .lt. h2b) .a
     &nd. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,2,4,3,1,5,-1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .le. h12b) .and. (h12b .lt. h2b) .a
     &nd. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,2,4,3,1,6,1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .le. h12b) .and. (h12b .lt. h2b) .a
     &nd. (p4b .le. p9b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,2,4,3,1,7,-1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .le. h12b) .and. (h12b .lt. h2b) .a
     &nd. (p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,2,4,3,1,8,1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .lt. h2b) .and. (h2b .le. h12b) .an
     &d. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,2,3,4,1,5,1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .lt. h2b) .and. (h2b .le. h12b) .an
     &d. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,2,3,4,1,6,-1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .lt. h2b) .and. (h2b .le. h12b) .an
     &d. (p4b .le. p9b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,2,3,4,1,7,1.0d0)
      END IF
      IF ((h11b .lt. h6b) .and. (h6b .lt. h2b) .and. (h2b .le. h12b) .an
     &d. (p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,2,3,4,1,8,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h12b .lt. h2b) .and. (p9b .lt. p3b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,1,4,3,2,5,1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h12b .lt. h2b) .and. (p3b .le. p9b) .an
     &d. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,1,4,3,2,6,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h12b .lt. h2b) .and. (p4b .le. p9b) .an
     &d. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,1,4,3,2,7,1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h12b .lt. h2b) .and. (p5b .le. p9b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,1,4,3,2,8,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h11b .lt. h2b) .and. (h2b .le. h12b) .a
     &nd. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,1,3,4,2,5,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h11b .lt. h2b) .and. (h2b .le. h12b) .a
     &nd. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,1,3,4,2,6,1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h11b .lt. h2b) .and. (h2b .le. h12b) .a
     &nd. (p4b .le. p9b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,1,3,4,2,7,-1.0d0)
      END IF
      IF ((h6b .le. h11b) .and. (h11b .lt. h2b) .and. (h2b .le. h12b) .a
     &nd. (p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,1,3,4,2,8,1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h11b) .and. (p9b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,1,2,4,3,5,1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h11b) .and. (p3b .le. p9b) .and
     &. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,1,2,4,3,6,-1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h11b) .and. (p4b .le. p9b) .and
     &. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,1,2,4,3,7,1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h11b) .and. (p5b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,1,2,4,3,8,-1.0d0)
      END IF
      IF ((h12b .lt. h2b) .and. (h2b .le. h6b) .and. (p9b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h2b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h2b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h12b .lt. h2b) .and. (h2b .le. h6b) .and. (p3b .le. p9b) .and
     &. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h2b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h2b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,4,3,2,1,6,1.0d0)
      END IF
      IF ((h12b .lt. h2b) .and. (h2b .le. h6b) .and. (p4b .le. p9b) .and
     &. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h2b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h2b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,4,3,2,1,7,-1.0d0)
      END IF
      IF ((h12b .lt. h2b) .and. (h2b .le. h6b) .and. (p5b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h2b_2 - 1
     & + noab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h2b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,4,3,2,1,8,1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,4,2,3,1,5,1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,4,2,3,1,6,-1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p4b .le. p9b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,4,2,3,1,7,1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h12b) .and. (h12b .lt. h6b) .a
     &nd. (p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,4,2,3,1,8,-1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h6b) .and. (h6b .le. h12b) .an
     &d. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,3,2,4,1,5,-1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h6b) .and. (h6b .le. h12b) .an
     &d. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,3,2,4,1,6,1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h6b) .and. (h6b .le. h12b) .an
     &d. (p4b .le. p9b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,3,2,4,1,7,-1.0d0)
      END IF
      IF ((h11b .lt. h2b) .and. (h2b .le. h6b) .and. (h6b .le. h12b) .an
     &d. (p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h11b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,3,2,4,1,8,1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h12b .lt. h6b) .and. (p9b .lt. p3b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,4,1,3,2,5,-1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h12b .lt. h6b) .and. (p3b .le. p9b) .an
     &d. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,4,1,3,2,6,1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h12b .lt. h6b) .and. (p4b .le. p9b) .an
     &d. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,4,1,3,2,7,-1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h12b .lt. h6b) .and. (p5b .le. p9b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h12b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h6b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,4,1,3,2,8,1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,3,1,4,2,5,1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,3,1,4,2,6,-1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p4b .le. p9b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,3,1,4,2,7,1.0d0)
      END IF
      IF ((h2b .le. h11b) .and. (h11b .lt. h6b) .and. (h6b .le. h12b) .a
     &nd. (p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h6b_2 - 
     &1 + noab * (h11b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,3,1,4,2,8,-1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (h6b .le. h11b) .and. (p9b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p9b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,6,2,1,4,3,5,-1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (h6b .le. h11b) .and. (p3b .le. p9b) .and
     &. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p5b-1),8,7,5,2,1,4,3,6,1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (h6b .le. h11b) .and. (p4b .le. p9b) .and
     &. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p5b-1),8,6,5,2,1,4,3,7,-1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (h6b .le. h11b) .and. (p5b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 -
     & 1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),7,6,5,2,1,4,3,8,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_14_11_1',
     &6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h11b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_14_1
     &1_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_14_1
     &1_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_14_11_1',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p3b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p13b-1),5,4,6,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (p4b - noab - 1 + nvab * (p3b - noab - 1 + nvab
     & * (p13b - noab - 1 + nvab * (h6b - 1 + noab * (h2b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_14_11_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_14_1
     &1_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine smd_force_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_force,sp_atom
      character*32 tag,pname
      logical result

      pname = "smd_force_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "force"
      call smd_system_get_component(sp_force,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_force_init(sp_force,sp_atom)
c
      return
      end

      subroutine smd_force_init(sp_force,sp_atom)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_force
      character*(*) sp_atom
c
      character*32 pname
      integer na
c
      pname = "smd_force_init"
c
c      write(*,*) "in "//pname
c
c     get total number of atoms 
c     -------------------------
      call smd_atom_ntot(sp_atom,na)
      if(na.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)
c
c     create force data structures
c     ---------------------------
      call smd_namespace_create(sp_force)
      call smd_data_create(sp_force,"force",3*na,MT_DBL)
      return
      end

      subroutine smd_force_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer un
c
      character*72 sp_force
      character*32 pname,tag
      integer na
      logical result
      integer i_f
      integer i,k
c
      pname = "smd_force_print"
c
      write(*,*) "in "//pname
c
      call smd_system_get_component(sp_force,"force",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no energy ',0,0)

c
      tag = "force"
      call smd_data_get_index(sp_force,tag,i_f,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      call smd_data_get_size(sp_force,tag,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)
      na = na/3

      call smd_util_print_force_array(un,na,dbl_mb(i_f))

      return
      end

      subroutine smd_force_zero()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer un
c
      character*72 sp_force
      character*32 pname,tag
      integer na
      logical result
      integer i_f
      integer i,k
c
      pname = "smd_force_print"
c
      write(*,*) "in "//pname
c
      call smd_system_get_component(sp_force,"force",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no energy ',0,0)

c
      tag = "force"
      call smd_data_get_index(sp_force,tag,i_f,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      call smd_data_get_size(sp_force,tag,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      call dfill(na,
     +             0.d0,
     +             dbl_mb(i_f),
     +             1)


      return
      end

      subroutine smd_force_compute()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_system.fh"
c     
      integer un
c
      character*32 pname
c
      pname = "smd_force_compute"
c
      write(*,*) "in "//pname

      call smd_force_zero()
      call smd_coulomb_compute()
      call smd_pot_compute()
      return
      end
c $Id: smd_force.F 22502 2012-05-20 06:11:57Z d3y133 $

c
c     $Id: c_nominimize.F 24489 2013-08-08 20:12:41Z bylaska $ 
c

      subroutine c_nominimize(E)
      implicit none
      real*8     E(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      integer neall,npack1,nbrillq,taskid
      integer G1_tag
      real*8  ehartree,eorbit,exc,pxc,eion,ehfx,phfx
      real*8  E0,Enew


*     **** external functions ****
      logical  band_HFX
      integer  cpsi_neq,Pneb_nbrillq,cpsi_data_alloc
      real*8   c_dng_1ehartree
      real*8   cpsi_1ke
      real*8   cpsi_1vl
      real*8   cpsi_1vnl
      real*8   c_rho_1exc
      real*8   c_rho_1pxc
      real*8   ewald_e
      real*8   cpsi_1eorbit,cpsi_smearcorrection
      real*8   cpsi_1vnlso
      external band_HFX
      external cpsi_neq,Pneb_nbrillq,cpsi_data_alloc
      external c_dng_1ehartree
      external cpsi_1ke
      external cpsi_1vl
      external cpsi_1vnl
      external c_rho_1exc
      external c_rho_1pxc
      external ewald_e
      external cpsi_1eorbit,cpsi_smearcorrection
      external cpsi_1vnlso
      logical  ion_disp_on
      external ion_disp_on
      real*8   ion_disp_energy
      external ion_disp_energy


      call Cram_max_npack(npack1)
      neall  = cpsi_neq(1)+cpsi_neq(2)
      nbrillq = Pneb_nbrillq()


*     **** allocate G1 ****
      G1_tag = cpsi_data_alloc(nbrillq,neall,2*npack1)

      call cpsi_1get_Tgradient(G1_tag,E0)
      Enew = E0

c      call cpsi_1toelectron() 

      eion = ewald_e()

      eorbit   = cpsi_1eorbit()
      ehartree = c_dng_1ehartree()
      exc      = c_rho_1exc()
      pxc      = c_rho_1pxc()

      E(1)  = Enew + eion
      E(2)  = eorbit
      E(3)  = ehartree
      E(4)  = exc
      E(5)  = eion
      E(6)  = cpsi_1ke()
      E(7)  = cpsi_1vl()
      E(8)  = cpsi_1vnl()
      E(9)  = 2.0d0*ehartree
      E(10) = pxc
      E(11) = cpsi_1vnlso()

c     **** HFX terms ****
      if (band_HFX()) then
         call c_electron_HFX_energies(ehfx,phfx)
         E(26) = ehfx
         E(27) = phfx
      end if

*     **** Dispersion energy ****
      if (ion_disp_on()) then
         E(33) = ion_disp_energy()
         E(1)  = E(1) + E(33)
      end if

      call cpsi_data_dealloc(G1_tag)

      return
      end
 

*
* $Id: fci_diags.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_diags(hd,ecore,h,g,ionel,nonemx,kpt,mkpt)
      implicit none
#include "fciinfo.fh"
c     
c     construct the diagonals of the hamiltonian 
c     
      double precision hd(ndets) ! [output] The diagonals
      double precision ecore    ! [input] Nuclear repulsion + frozen core
      double precision h(nacttr) ! [input] 1-e integrals
      double precision g(nacttr,nacttr) ! [input] 2-e integrals
      integer nonemx            ! [input] dimension of ionel
      integer ionel(5,nonemx)   ! [scratch] workspace for coupling coeff
      integer kpt(nonemx)       ! [scratch] workspace
      integer mkpt(ndetmx+1)    ! [scratch] workspace
c
      integer kwalk, kelbas, keltop, jprev, kkel,
     $     kel, k, l, kl, jdet, iello, ielhi, iel, idet, i, j, ij,
     $     nonel, iiel
      integer kocc(nactmx), kdim, kbase, ksym, kns, kdet
      double precision ekl, eijkl
c     
c     loop thru intermediate walks, compute all non-zero 1 e- coeffs
c     and also provide index into the coeffs based on intermediate
c     determinant
c     
      call fci_tstart(5,.false.)
      call dfill(ecore,hd,1,ndets)
      do 10 kwalk = 1,nwalko
         call fci_owalk_info(kwalk,kocc,kns,kbase,kdim,ksym)
         call fci_onelcc(kocc,kbase,kdim,ksym,ionel,nonel,nonemx)
         if (nonel.gt.0) then
            call fci_srt1cc(ionel,nonel,kbase,kdim,kpt,mkpt)
c     loop thru non-zero <k|ekl|j>
            do 20 kdet = 1,kdim
               kelbas = mkpt(kdet) + 1
               keltop = mkpt(kdet+1)
               jprev = -1
               do 30 kkel = kelbas,keltop
                  kel = kpt(kkel)
                  k = max(ionel(1,kel),ionel(2,kel))
                  l = min(ionel(1,kel),ionel(2,kel))
                  kl = k*(k-1)/2 + l
                  jdet = ionel(4,kel)
                  ekl = ionel(5,kel)
c     do the one electron term
                  if (ksym .eq. statesym) then
                     if (jdet .eq. kdet+kbase) then
                        hd(jdet) = hd(jdet) +  ekl * h(kl)
                     endif
                  endif
                  ekl = ekl * 0.5d0
                  if (jdet.ne.jprev) then
c     look for last element with this jdet and kdet ... will be nearby
                     jprev = jdet
                     iello = kkel
                     ielhi = kkel
                     do 40 iiel = kkel+1,keltop
                        if (ionel(4,kpt(iiel)).ne.jdet) goto 50
                        ielhi = ielhi+1
 40                  continue
                  endif
c     loop thru non-zero <i|eij|k> for idet=jdet
 50               do 60 iiel = iello,ielhi
                     iel = kpt(iiel)
                     idet = ionel(4,iel)
                     i = max(ionel(1,iel),ionel(2,iel))
                     j = min(ionel(1,iel),ionel(2,iel))
                     ij = i*(i-1)/2 + j
                     eijkl = ionel(5,iel) * ekl
                     hd(jdet) = hd(jdet) + eijkl*g(ij,kl)
 60               continue
 30            continue
 20         continue
         endif
 10   continue
*      write(6,*) ' diagonals from diags '
*      write(6,1) hd
* 1    format(1x,6f12.6)
c     
      call fci_tfinish(5,.false.)
c
      end

ckbn  Kiran Bhaskaran-Nair modified from tce_x2_offset.F
      SUBROUTINE tce_eax2_offset(l_a_offset,k_a_offset,size)
C     $Id: tce_eax2_offset.F 25748 2014-06-08 07:53:05Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     x ( p2 p4 h1 h3 )_x
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "stdio.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p2b
      INTEGER p4b
      INTEGER h1b
      INTEGER h3b
      length = 0
      DO p2b = noab+1,noab+nvab
      DO p4b = p2b,noab+nvab
      DO h1b = 1,noab
c#ifndef EACCSD
c      DO h3b = h1b,noab
c      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
c     &1b-1)+int_mb(k_spin+h3b-1)) THEN
c      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
c     &k_sym+h1b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_x) THEN
c      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1
c     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h3b-1).ne.8)) THEN
c#else
      DO h3b = 1,1
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+ ea_unused_spin) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),ea_unused_sym))) .eq. irrep_x) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+ ea_unused_spin .ne.8)) THEN
c#endif
      length = length + 1
      END IF
      END IF
      END IF
c#ifndef EACCSD
      END DO
c#endif
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'tce_x2_offset',l_a_offset,
     1k_a_offset)) CALL ERRQUIT('tce_x2_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p2b = noab+1,noab+nvab
      DO p4b = p2b,noab+nvab
      DO h1b = 1,noab
c#ifndef EACCSD
c      DO h3b = h1b,noab
c      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
c     &1b-1)+int_mb(k_spin+h3b-1)) THEN
c      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
c     &k_sym+h1b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_x) THEN
c      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1
c     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h3b-1).ne.8)) THEN
c#else
      DO h3b = 1,1
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+ ea_unused_spin ) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1), ea_unused_sym))) .eq. irrep_x) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+ ea_unused_spin .ne.8)) THEN
c#endif
      addr = addr + 1
      int_mb(k_a_offset+addr) = h3b - 1 + noab * (h1b - 1 + noab * (p4b 
     &- noab - 1 + nvab * (p2b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
ckbn      write(LuOut,*) "Leng addr key size ",length,addr,
ckbn     + h3b - 1 + noab * (h1b - 1 + noab * (p4b- noab - 1 + nvab * 
ckbn     + (p2b - noab - 1))), size
ckbn       call util_flush(LuOut)
ckbn      size = size + int_mb(k_range+p2b-1) * int_mb(k_range+p4b-1) * int_
ckbn     &mb(k_range+h1b-1) * int_mb(k_range+h3b-1)
      size = size + int_mb(k_range+p2b-1) * int_mb(k_range+p4b-1) * int_
     &mb(k_range+h1b-1) * 1
      END IF
      END IF
      END IF
c#ifndef EACCSD
      END DO
c#endif
      END DO
      END DO
      END DO
      RETURN
      END

C> \ingroup task
C> @{
C>
C> \brief Interface to a charge transfer probability
C>
C> \return Return .true. if successfull, and .false. otherwise.
C>
      logical function task_et(rtdb)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "stdio.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb
c
      logical status
      double precision cpu, wall, Vba
      logical task_et_doit
      external task_et_doit
      character*32 theory
c
      cpu  = util_cpusec()
      wall = util_wallsec()
c
      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $     call errquit('task:energy: theory not specified',0, RTDB_ERR)

      if ((theory.ne.'scf').and.(theory.ne.'dft')) then
         write(LuOut,*) 'Electron Transfer has been',
     &  ' implemented only for HF and DFT. NWChem will skip this task!.'
         task_et = .false.
         return
      endif
c
      status = task_et_doit(rtdb,Vba)
c
      if (.not. rtdb_put(rtdb, 'task:et', mt_dbl, 1, Vba))
     $     call errquit('task_et: failed storing Vba',0, RTDB_ERR)
c
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - wall
c
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, status))
     $     call errquit('task_et: failed to store status',0, RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:cputime', mt_dbl, 1, cpu))
     $     call errquit('task_et: failed storing cputime',0, RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:walltime', mt_dbl, 1, wall))
     $     call errquit('task_et: failed storing walltime',0, RTDB_ERR)
c
      call ecce_print1('cpu time', mt_dbl, cpu, 1)
      call ecce_print1('wall time', mt_dbl, wall, 1)
      if (status) then
         call geom_print_rtdb_ecce(rtdb)
         call ecce_print1('Vba', mt_dbl, Vba, 1)
         call ecce_print_module_exit('task et', 'ok')
      else
         call ecce_print_module_exit('task et', 'failed')
      endif
c         
      task_et = status
c
      end
C> @}
c===========================================================================
      logical function task_et_doit(rtdb,Vba)
      implicit none
c
c     This function actually calculates Vba
*
* $Id: task_et.F 24528 2013-08-19 20:24:07Z niri $
c
*
#include "rtdb.fh"
#include "mafdecls.fh"
c#include "inp.fh"
c#include "util.fh"
c#include "global.fh"
c#include "apiP.fh"
c#include "bas.fh"
c#include "geom.fh"
c#include "cscf.fh"
c
c     Generic NWChem interface to compute Vba. SCF of DFT determinants
c     can be used.
c
c     RTDB output parameters
c     ----------------------
c     task:status (logical)- T/F for success/failure
c     if (status) then
c     .  task:et (real)   - Vba (electron transfer matrix element)
c     .  task:cputime (real)  - cpu time to execute the task
c     .  task:walltime (real) - wall time to execute the task
c
c     Also returns status through the function value
c
      integer rtdb
      logical status
      external et_calc, et_calc_fmo
      logical  et_calc, et_calc_fmo
      double precision Vba
      integer fmo
c
      task_et_doit = .false.
      if (.not.rtdb_get(rtdb,'et:fmo',MT_INT,1,fmo)) then
         status = et_calc(rtdb,Vba)
      else
         status = et_calc_fmo(rtdb, Vba)
      endif
c
      task_et_doit = status
c
      return
      end

      subroutine smd_rtdb_get_handle(rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer rtdb
c
      rtdb= smd_rtdb

      end 

      subroutine smd_rtdb_get_istart(istart)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer istart
c
      istart= smd_istart

      end 

      subroutine smd_rtdb_get_iend(iend)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer iend
c
      iend= smd_iend

      end 

      subroutine smd_rtdb_get_nproc(nproc)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer nproc
c
      nproc= smd_nproc

      end 

      subroutine smd_rtdb_get_name(rtdb_name)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) rtdb_name
c
      rtdb_name= smd_rtdb_name

      end 

      subroutine smd_rtdb_set_handle(rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer rtdb
c
      smd_rtdb = rtdb

      end 

      subroutine smd_rtdb_get_operiodic(operiodic)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      logical operiodic
c
      double precision latt(3,3)
      character*32 pname
      character*80 tag
      double precision a(3)
      integer i
c
      pname = "smd_lat_rtdb_read"
c
c      write(*,*) "in "//pname
c
      tag="smd:operiodic"
      if (rtdb_get(smd_rtdb,tag,mt_log,1,operiodic)) 
     >    return

      operiodic = .true.
      tag="smd:lat_a"
      if (.not.rtdb_get(smd_rtdb,tag,mt_dbl,3,a(1))) 
     >      operiodic=.false.


      end 

      subroutine smd_rtdb_get_paramfile(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) filename
      logical result
c
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:paramfile',1,filename))
     >   result = .false.
      end 

      subroutine smd_rtdb_get_coordfile(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_rtdb_get_coordfile"
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:coordfile',1,filename))
     >   result = .false.

      end 

      subroutine smd_rtdb_init(rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"

      integer rtdb
c
      logical ignore
      smd_rtdb = rtdb
      if(.not. rtdb_getfname(rtdb, smd_rtdb_name)) call
     *        errquit('rtdb_getfname failed',0,0)

      smd_istart=0
      smd_iend  =0
      smd_nproc =0
      ignore = rtdb_get(rtdb,"smd:istart",mt_int,1,smd_istart)
      ignore = rtdb_get(rtdb,"smd:iend",mt_int,1,smd_iend)
      ignore = rtdb_get(rtdb,"smd:nproc",mt_int,1,smd_nproc)
      end 
c $Id: smd_rtdb_data.F 22502 2012-05-20 06:11:57Z d3y133 $

      logical function argos_prep_boxsiz(xw,xwc,mwm,mwmc,mwa,
     + nwm,nwmc,nwa,xs,msa,nsa,box,iopt)
c
c $Id: argos_prep_boxsiz.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer mwm,mwmc,mwa,nwm,nwmc,nwa,msa,nsa,iopt
      real*8 xw(3,mwa,mwm),xwc(3,mwa,mwmc),xs(3,msa),box(3)
c
      integer i,j,k
      real*8 s
c
      if(nsa.le.0.and.nwm.le.0.and.nwmc.le.0) goto 9999
c
      do 1 k=1,3
      s=0.0d0
      do 2 i=1,nsa
      if(xs(k,i).gt.s) s=xs(k,i)
      if(xs(k,i).lt.-s) s=-xs(k,i)
    2 continue
      if(nwm.gt.0) then
      do 3 i=1,nwm
      do 4 j=1,nwa
      if(xw(k,j,i).gt.s) s=xw(k,j,i)
      if(xw(k,j,i).lt.-s) s=-xw(k,j,i)
    4 continue
    3 continue
      endif
      if(nwmc.gt.0) then
      do 5 i=1,nwmc
      do 6 j=1,nwa
      if(xwc(k,j,i).gt.s) s=xwc(k,j,i)
      if(xwc(k,j,i).lt.-s) s=-xwc(k,j,i)
    6 continue
    5 continue
      endif
      box(k)=s+s
    1 continue
c
      if(iopt.eq.1.or.iopt.eq.4) then
      s=0.0d0
      do 7 i=1,nsa
      s=max(s,xs(2,i)**2+xs(3,i)**2)
    7 continue
      if(nwm.gt.0) then
      do 8 i=1,nwm
      do 9 j=1,nwa
      s=max(s,xw(2,j,i)**2+xw(3,j,i)**2)
    9 continue
    8 continue
      endif
      if(nwmc.gt.0) then
      do 10 i=1,nwmc
      do 11 j=1,nwa
      s=max(s,xwc(2,j,i)**2+xwc(3,j,i)**2)
   11 continue
   10 continue
      endif
      box(2)=2.0d0*sqrt(s)
      box(3)=2.0d0*sqrt(s)
      endif
      if(iopt.eq.2.or.iopt.eq.4) then
      s=0.0d0
      do 12 i=1,nsa
      s=max(s,xs(1,i)**2+xs(3,i)**2)
   12 continue
      if(nwm.gt.0) then
      do 13 i=1,nwm
      do 14 j=1,nwa
      s=max(s,xw(1,j,i)**2+xw(3,j,i)**2)
   14 continue
   13 continue
      endif
      if(nwmc.gt.0) then
      do 15 i=1,nwmc
      do 16 j=1,nwa
      s=max(s,xwc(1,j,i)**2+xwc(3,j,i)**2)
   16 continue
   15 continue
      endif
      box(1)=2.0d0*sqrt(s)
      box(3)=2.0d0*sqrt(s)
      endif
      if(iopt.eq.3.or.iopt.eq.4) then
      s=0.0d0
      do 17 i=1,nsa
      s=max(s,xs(1,i)**2+xs(2,i)**2)
   17 continue
      if(nwm.gt.0) then
      do 18 i=1,nwm
      do 19 j=1,nwa
      s=max(s,xw(1,j,i)**2+xw(2,j,i)**2)
   19 continue
   18 continue
      endif
      if(nwmc.gt.0) then
      do 20 i=1,nwmc
      do 21 j=1,nwa
      s=max(s,xwc(1,j,i)**2+xwc(2,j,i)**2)
   21 continue
   20 continue
      endif
      box(1)=2.0d0*sqrt(s)
      box(2)=2.0d0*sqrt(s)
      endif
c
      argos_prep_boxsiz=.true.
      return
c
 9999 continue
      box(1)=0.0d0
      box(2)=0.0d0
      box(3)=0.0d0
      argos_prep_boxsiz=.true.
      return
      end

      subroutine smd_res_init(namespace,rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      integer rtdb
c
      character*32 pname
      character*80 tag
      character*255 filename
      integer nr,nt
      integer i_s,i_t,i_ind
      logical result
c
      pname = "smd_res_init"
c
      write(*,*) "in "//pname
c
      if(.not.rtdb_cget(rtdb,'smd:coordfile',1,filename))
     >  call errquit(
     >       pname//'error reading coordinate file',0, RTDB_ERR)
      write(*,*) "found coordinates",filename
c
c     get number of residues
c     ----------------------
      call smd_pdb_nres(filename,nr)
      write(*,*) "number of res",nr
c
c     get number of atoms
c     -------------------
      call smd_atom_ntot(namespace,nt)
      write(*,*) "number of atoms",nt
c
c     create residue data structures
c     ------------------------------
      call smd_data_create(namespace,"res:name",16*nr,MT_BYTE)
      call smd_data_create(namespace,"res:size",nr,MT_INT)
      call smd_data_create(namespace,"res:",nr,MT_INT)

      tag = "atom:res"
      call smd_data_get_index(namespace,tag,i_ind,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "res:size"
      call smd_data_get_index(namespace,tag,i_s,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "res:name"
      call smd_data_get_index(namespace,tag,i_t,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)


      call smd_pdb_read_res(filename,nt,nr,
     +                         byte_mb(i_t),
     +                         int_mb(i_ind),
     +                         int_mb(i_s))

      return
      end
c $Id: smd_res.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine argos_cafe_cmw(xw,xwm,iwfr,iwto,iwa,wgt)
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      integer iwfr,iwto,iwa(mwa)
      real*8 xw(mwm,3,mwa),xwm(mwm,3),wgt(mat,mset)
c
      integer i,j,k
      real*8 factor
c
      if(iwfr.eq.0.or.iwfr.gt.iwto) return
c
      factor=zero
      do 1 i=1,mwa
      factor=factor+wgt(iwa(i),iset)
    1 continue
      factor=one/factor
c
      do 2 j=1,3
      do 3 i=iwfr,iwto
      xwm(i,j)=zero
      do 4 k=1,mwa
      xwm(i,j)=xwm(i,j)+wgt(iwa(k),iset)*xw(i,j,k)
    4 continue
      xwm(i,j)=factor*xwm(i,j)
    3 continue
    2 continue
c
      return
      end
c $Id: argos_cafe_cmw.F 21176 2011-10-10 06:35:49Z d3y133 $

c===============================================================c
c                                                               c
c       NCC - a New Coupled-Cluster code for NWChem             c
c                                                               c
c       Developed by:                                           c
c                                                               c
c               Jeff R. Hammond                                 c
c               Leadership Computing Facility                   c
c               Argonne National Laboratory                     c
c               jhammond@mcs.anl.gov                            c
c                                                               c
c               Karol Kowalski                                  c
c               Environmental Molecular Sciences Laboratory     c
c               Pacific Northwest National Laboratory           c
c               karol.kowalski@pnl.gov                          c
c                                                               c
c               Marta Włoch                                     c
c               Department of Chemistry                         c
c               Michigan Technological University               c
c               wloch@mtu.edu                                   c
c                                                               c
c===============================================================c
      logical function ncc_driver(rtdb)
c
c $Id: ncc_driver.F 21494 2011-11-09 23:09:16Z jhammond $
c
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "inp.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "schwarz.fh"
c===============================================================c
c                                                               c
#include "ncc_input.fh"
c                                                               c
c      ...defines these common variables:                       c
c                                                               c
c      integer debugmode                                        c
c      double precision thresh                                  c
c      character*20 method                                      c
c                                                               c
c      I am using common variables to pass from this routine    c
c      into the NCC module so that I don't have to use the      c
c      RTDB since that would involve disk access.               c
c                                                               c
c===============================================================c
c
c     object handles
c
      integer rtdb             ! RTDB handle
      integer geom             ! GEOM handle
      integer basis            ! BASIS handle
c
c     low-level (GA, etc.) variables
c
      integer bytes                           ! Number of bytes in a double
      integer i,j,k,l
c
c     SCF code variables
c
      integer reference
      integer mult                            ! Ground state spin multiplicity
      integer ipol
      integer nclosed, nopen
      integer nbf,nshells                     ! Number of AO basis functions and shells
      integer nbfold
      integer nocc(2)                         ! Number of alpha, beta electrons
      integer nvir(2)                         ! Number of alpha, beta electrons
      integer nmo(2)                          ! Number of alpha, beta orbitals
      integer nfc(2),nfv(2)                   ! Number of frozen cores/virtuals
c
c     GA and MA handles
c
      integer g_moveca, k_moveca, l_moveca
      integer g_movecb, k_movecb, l_movecb
      integer k_eiga,l_eiga
      integer k_eigb,l_eigb
      integer k_occa,l_occa
      integer k_occb,l_occb
      integer k_irra,l_irra
      integer k_irrb,l_irrb
c
c     low-level (GA, etc.) variables
c
      double precision cpu     ! CPU sec counter
      double precision wall    ! WALL sec counter
c
c     SCF code variables
c
      double precision scf_energy
c
c     four-index variables
c
      double precision blk_norm
      integer k_v2oooo,l_v2oooo
      integer k_v2ooov,l_v2ooov
      integer k_v2oovv,l_v2oovv
      integer k_v2ovvv,l_v2ovvv
      integer k_v2vvvv,l_v2vvvv
c
c     amplitudes
c
      integer t2info(8)                ! T2 amplitude "struct"
c
c     low-level (GA, etc.) variables
c
      logical nodezero         ! am I node 0?
      logical debug            ! debug mode?
      logical stat             ! status
c
c     SCF code variables
c
      logical scf_status       ! did SCF finish?
c
c     four-index variables
c
      logical use_symm
c
c     SCF code variables
c
      character*4 scftype
      character*8 group
      character*255 scf_movecs ! SCF MO vector file name
      character*255 title      ! Title
      character*255 basisname  ! Basis set name
c
c     external routines
c
      logical scf
      external scf
      logical int_normalize
      external int_normalize
      logical movecs_read
      external movecs_read
      logical movecs_read_header
      external movecs_read_header
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
      double precision dnrm2
      external dnrm2
c
#ifdef DEBUG_PRINT
      print*,'top of ncc_driver'
      debug = (ga_nodeid().eq.0)
c      debug = .true. ! debug from all nodes
#else
      debug = .false.
#endif
c
      ncc_driver = .false.
c
      nodezero = (ga_nodeid().eq.0)
c
      bytes = ma_sizeof(mt_dbl,1,mt_byte)
c
c===============================================================c
c                                                               c
c     Run the SCF code, get GEOM, BASIS and MOVECS information  c
c                                                               c
c===============================================================c
c
      scf_status = scf(rtdb)
c
      if (.not.rtdb_get(rtdb,'scf:energy',mt_dbl,1,scf_energy)) then
        call errquit('ncc_driver: rtdb_get failed',0,RTDB_ERR)
      endif
c
c     ---------------------
c     Geometry and symmetry
c     ---------------------
c
      if (.not.geom_create(geom,'geometry')) then
        call errquit('ncc_driver: geom_create failed',0,GEOM_ERR)
      endif
      if (.not.geom_rtdb_load(rtdb,geom,'geometry')) then
        call errquit('ncc_driver: no geometry found',0,GEOM_ERR)
      endif
c
      call sym_group_name(geom,group)
      use_symm = (group(1:2) .ne. 'C1')
c
c     ---------
c     Basis set
c     ---------
c
      if (.not.bas_create(basis,'ao basis')) then
        call errquit('ncc_driver: bas_create failed',0,BASIS_ERR)
      endif
      if (.not.bas_rtdb_load(rtdb,geom,basis,'ao basis')) then
        call errquit('ncc_driver: no ao basis found',0,BASIS_ERR)
      endif
      if (.not.bas_numbf(basis,nbf)) then
        call errquit('ncc_driver: failed to read nbf',0,BASIS_ERR)
      endif
c
c     ----------------------
c     Integral code
c     ----------------------
c
      call int_init(rtdb,1,basis)
      call schwarz_init(geom,basis)
      if (.not.int_normalize(rtdb,basis)) then
        call errquit('ncc_driver: int_normalize failed',0,INT_ERR)
      endif
c
c     ------------------------------------------------------
c     Number of electrons and orbitals and spin multiplicity
c     ------------------------------------------------------
c
      if(.not.rtdb_cget(rtdb,'scf:scftype',1,scftype)) then
        call errquit('ncc_driver: failed to read scftype',0,RTDB_ERR)
      endif
      if (scftype.eq.'RHF') then
        reference = 0
      else if(scftype.eq.'ROHF')then
        reference = 1
      else if (scftype.eq.'UHF') then
        reference = 2
      else
        call errquit('ncc_driver: invalid reference',0,RTDB_ERR)
        reference = -1
      endif
c
      if(.not. geom_freeze(rtdb, geom,'ncc',nfc(1))) then
         call errquit('ncc_driver: geom_freeze failed',0,GEOM_ERR)
      endif
      nfc(2) = nfc(1) ! always freeze in pairs
c
      if (.not.rtdb_get(rtdb,'scf:nclosed',mt_int,1,nclosed)) then
        call errquit('ncc_driver: failed to read nclosed',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'scf:nopen',mt_int,1,nopen)) then
        call errquit('ncc_driver: failed to read nopen',0,RTDB_ERR)
      endif
      nocc(1) = nclosed + nopen
      nocc(2) = nclosed
c
c     ----------
c     MO vectors
c     ----------
c
      if (.not.rtdb_cget(rtdb,'scf:output vectors',1,scf_movecs)) then
        call errquit('ncc_driver: SCF movecs not found',0,RTDB_ERR)
      endif

      g_moveca = ga_create_atom_blocked(geom,basis,'alpha movecs')
      g_movecb = ga_create_atom_blocked(geom,basis,'beta movecs')
c
      if (.not. movecs_read_header(scf_movecs,title,basisname,
     1          scftype,nbfold,ipol,nmo,2)) then
        call errquit('ncc_driver: cannot read MO vectors header',0,
     1               INPUT_ERR)
      endif
      nmo(2) = nmo(1)
c
      if (nbf.ne.nbfold) then
        call errquit('ncc_driver: nbf-nbfold = ',nbf-nbfold,CALC_ERR)
      endif
c
      if (.not.ma_push_get(mt_dbl,nbf,'eiga',l_eiga,k_eiga)) then
          call errquit ('ncc_driver: ma_push_get eiga',nbf,MA_ERR)
      endif
      if (.not.ma_push_get(mt_dbl,nbf,'eigb',l_eigb,k_eigb)) then
          call errquit ('ncc_driver: ma_push_get eigb',nbf,MA_ERR)
      endif
c
      if (.not.ma_push_get(mt_dbl,nbf,'occa',l_occa,k_occa)) then
          call errquit ('ncc_driver: ma_push_get occa',nbf,MA_ERR)
      endif
      if (.not.ma_push_get(mt_dbl,nbf,'occb',l_occb,k_occb)) then
          call errquit ('ncc_driver: ma_push_get occb',nbf,MA_ERR)
      endif
c
      if (.not.ma_push_get(mt_int,nbf,'irra',l_irra,k_irra)) then
          call errquit ('ncc_driver: ma_push_get irra',nbf,MA_ERR)
      endif
      if (.not.ma_push_get(mt_int,nbf,'irrb',l_irrb,k_irrb)) then
          call errquit ('ncc_driver: ma_push_get irrb',nbf,MA_ERR)
      endif
c
c     read alpha movecs
c
      stat = movecs_read(scf_movecs,1,dbl_mb(k_occa),
     1                   dbl_mb(k_eiga),g_moveca)
      if (.not.stat) then
        call errquit('ncc_driver: cannot read MO vectors',1,CALC_ERR)
      endif
      if (.not.rtdb_get(rtdb,'scf:alpha irreps',mt_int,nbf,
     1                  int_mb(k_irra))) then
        call errquit('ncc_driver: no alpha irreps found',1,RTDB_ERR)
      endif
c
c     read beta movecs
c     max(reference,1) means beta is different only for UHF
c
      stat = movecs_read(scf_movecs,max(reference,1),dbl_mb(k_occb),
     1                   dbl_mb(k_eigb),g_movecb)
      if (.not.stat) then
        call errquit('ncc_driver: cannot read MO vectors',2,CALC_ERR)
      endif
      if (reference .eq. 0) then ! RHF
        do i=1,nbf
          int_mb(k_irrb+i-1) = int_mb(k_irra+i-1)
        enddo
      else ! ROHF or UHF
        if (.not.rtdb_get(rtdb,'scf:beta irreps',mt_int,nbf,
     1                    int_mb(k_irrb))) then
          call errquit('ncc_driver: no beta irreps found',1,RTDB_ERR)
        endif
      endif
c
c===============================================================c
c                                                               c
c     Author information etc.                                   c
c                                                               c
c===============================================================c
c
      if (nodezero) then
        write(LuOut,1000)
        call util_flush(LuOut)
      endif
c
c===============================================================c
c                                                               c
c     Four-index transformation algorithms                      c
c                                                               c
c===============================================================c
c
      if (use_symm) then
!        call errquit('ncc_driver: disable symmetry',0,INPUT_ERR)
        write(LuOut,*) ' BE CAREFUL!  Using symmetry: ',group
        call util_flush(LuOut)
      endif
c
c     =======================
c     Get MO vectors
c     =======================
c
      if (nodezero) call bas_print_labels(basis)
c
      call scf_lindep(rtdb, geom, basis, g_moveca, nmo(1))
      if (nodezero) write(LuOut,2001) 'alpha',nbf,nmo(1)
c
      if (.not.ma_push_get(mt_dbl,nbf*nmo(1),'moveca',
     1                     l_moveca,k_moveca)) then
          call errquit ('ncc_driver: ma_push_get moveca',nbf,MA_ERR)
      endif
      call ga_get(g_moveca,1,nbf,1,nmo(1),dbl_mb(k_moveca),nbf)
!       call ga_print(g_moveca)
!       call ncc_print_movecs(nbf,nmo(1),dbl_mb(k_moveca))
c      call ncc_print_dvec(nbf,dbl_mb(k_eiga))
c      call ncc_print_dvec(nbf,dbl_mb(k_occa))
c      call ncc_print_ivec(nbf,int_mb(k_irra))
c
      call scf_lindep(rtdb, geom, basis, g_movecb, nmo(2))
      if (nodezero) write(LuOut,2001) 'beta ',nbf,nmo(2)
c
      if (.not.ma_push_get(mt_dbl,nbf*nmo(2),'movecb',
     1                     l_movecb,k_movecb)) then
          call errquit ('ncc_driver: ma_push_get movecb',nbf,MA_ERR)
      endif
      call ga_get(g_moveca,1,nbf,1,nmo(2),dbl_mb(k_movecb),nbf)
!       call ga_print(g_movecb)
!       call ncc_print_movecs(nbf,nmo(2),dbl_mb(k_movecb))
c      call ncc_print_dvec(nbf,dbl_mb(k_eigb))
c      call ncc_print_dvec(nbf,dbl_mb(k_occb))
c      call ncc_print_ivec(nbf,int_mb(k_irrb))
c
c     =======================
c     Computer 2-e integrals
c     =======================
c
      nvir(1) = nmo(1) - nocc(1)
      nvir(2) = nmo(2) - nocc(2)
! c
! c     allocate v2oooo
! c
!       if (.not.ma_push_get(mt_dbl,nocc(1)*nocc(1)*nocc(1)*nocc(1),
!      1                     'v2oooo',l_v2oooo,k_v2oooo)) then
!           call errquit ('ncc_driver: ma_push_get v2oooo',
!      1                  nocc(1)*nocc(1)*nocc(1)*nocc(1),MA_ERR)
!       endif
! c
! c     allocate v2ooov
! c
!       if (.not.ma_push_get(mt_dbl,nocc(1)*nocc(1)*nocc(1)*nvir(1),
!      1                     'v2ooov',l_v2ooov,k_v2ooov)) then
!           call errquit ('ncc_driver: ma_push_get v2ooov',
!      1                  nocc(1)*nocc(1)*nocc(1)*nvir(1),MA_ERR)
!       endif
! c
! c     allocate v2oovv
! c
!       if (.not.ma_push_get(mt_dbl,nocc(1)*nocc(1)*nvir(1)*nvir(1),
!      1                     'v2oovv',l_v2oovv,k_v2oovv)) then
!           call errquit ('ncc_driver: ma_push_get v2oovv',
!      1                  nocc(1)*nocc(1)*nvir(1)*nvir(1),MA_ERR)
!       endif
! c
! c     allocate v2ovvv
! c
!       if (.not.ma_push_get(mt_dbl,nocc(1)*nvir(1)*nvir(1)*nvir(1),
!      1                     'v2ovvv',l_v2ovvv,k_v2ovvv)) then
!           call errquit ('ncc_driver: ma_push_get v2ovvv',
!      1                  nocc(1)*nvir(1)*nvir(1)*nvir(1),MA_ERR)
!       endif
! c
! c     allocate v2vvvv
! c
!       if (.not.ma_push_get(mt_dbl,nvir(1)*nvir(1)*nvir(1)*nvir(1),
!      1                     'v2vvvv',l_v2vvvv,k_v2vvvv)) then
!           call errquit ('ncc_driver: ma_push_get v2vvvv',
!      1                  nvir(1)*nvir(1)*nvir(1)*nvir(1),MA_ERR)
!       endif
c
!       call ncc_fourindex(rtdb,basis,
!      1                   nocc(1),nocc(2),nvir(1),nvir(2),
!      2                   nmo(1),nmo(2),nbf,
!      3                   dbl_mb(k_v2oooo),dbl_mb(k_v2ooov),
!      4                   dbl_mb(k_v2oovv),dbl_mb(k_v2ovvv),
!      5                   dbl_mb(k_v2vvvv),
!      6                   dbl_mb(k_moveca),dbl_mb(k_movecb))
c
      call ncc_doubles_create_aa(t2info,      ! output array
     1                           "T2",        ! character name for this array
     2                           nocc(1),     ! number of occupied orbitals
     3                           nvir(1),     ! number of virtual orbitals
     4                           occtile,     ! tilesize of occupied orbitals
     5                           virtile)     ! tilesize of virtual orbitals
c
      call ncc_doubles_destroy(t2info)
c
c===============================================================c
c                                                               c
c     Close any open object references and stack blocks         c
c                                                               c
c===============================================================c
c
#ifdef DETAILED_FREE
!       if (.not.ma_pop_stack(l_v2vvvv)) then
!         call errquit('ncc_driver: MA problem v2vvvv ',0,MA_ERR)
!       endif
!       if (.not.ma_pop_stack(l_v2ovvv)) then
!         call errquit('ncc_driver: MA problem v2ovvv ',0,MA_ERR)
!       endif
!       if (.not.ma_pop_stack(l_v2oovv)) then
!         call errquit('ncc_driver: MA problem v2oovv ',0,MA_ERR)
!       endif
!       if (.not.ma_pop_stack(l_v2ooov)) then
!         call errquit('ncc_driver: MA problem v2ooov ',0,MA_ERR)
!       endif
!       if (.not.ma_pop_stack(l_v2oooo)) then
!         call errquit('ncc_driver: MA problem v2oooo ',0,MA_ERR)
!       endif
c
      if (.not.ma_pop_stack(l_movecb)) then
        call errquit('ncc_driver: MA problem movecb ',0,MA_ERR)
      endif
      if (.not.ma_pop_stack(l_moveca)) then
        call errquit('ncc_driver: MA problem moveca ',0,MA_ERR)
      endif
      if (.not.ma_pop_stack(l_irrb)) then
        call errquit('ncc_driver: MA problem irrb ',0,MA_ERR)
      endif
      if (.not.ma_pop_stack(l_irra)) then
        call errquit('ncc_driver: MA problem irra ',0,MA_ERR)
      endif
      if (.not.ma_pop_stack(l_occb)) then
        call errquit('ncc_driver: MA problem occb ',0,MA_ERR)
      endif
      if (.not.ma_pop_stack(l_occa)) then
        call errquit('ncc_driver: MA problem occa ',0,MA_ERR)
      endif
      if (.not.ma_pop_stack(l_eigb)) then
        call errquit('ncc_driver: MA problem eigb ',0,MA_ERR)
      endif
      if (.not.ma_pop_stack(l_eiga)) then
        call errquit('ncc_driver: MA problem eiga ',0,MA_ERR)
      endif
#else
      if (.not. ma_chop_stack(l_eiga)) then
        call errquit('ncc_driver: stack corrupt ',0, MA_ERR)
      endif
#endif
c
      call schwarz_tidy()
      call int_terminate()
c
      if (.not.ga_destroy(g_moveca)) then
        call errquit('ncc_driver: failed to destroy g_moveca',1,GA_ERR)
      endif
      if (.not.ga_destroy(g_movecb)) then
        call errquit('ncc_driver: failed to destroy g_movecb',2,GA_ERR)
      endif
c
      if (.not.bas_destroy(basis)) then
        call errquit('ncc_driver: bas_destroy failed',0,BASIS_ERR)
      endif
      if (.not.geom_destroy(geom)) then
        call errquit('tce_tidy: geom_destroy failed',0,GEOM_ERR)
      endif
c
c===============================================================c
c                                                               c
c                           THE END                             c
c                                                               c
c===============================================================c
c
      ncc_driver = .true.
c
#ifdef DEBUG_PRINT
      print*,'end of ncc_driver'
#endif
c
      return
c
 1000 format(/,' ==============================================',/,/,
     &         3x,'NCC - a New Coupled-Cluster code for NWChem',/,
     &         3x,'Developed by:',/,/,
     &         3x,'Jeff R. Hammond',/,
     &         3x,'Leadership Computing Facility',/,
     &         3x,'Argonne National Laboratory',/,
     &         3x,'jhammond@mcs.anl.gov',/,/,
     &         3x,'Karol Kowalski',/,
     &         3x,'Environmental Molecular Sciences Laboratory',/,
     &         3x,'Pacific Northwest National Laboratory',/,
     &         3x,'karol.kowalski@pnl.gov',/,/,
     &         3x,'Marta Włoch',/,
     &         3x,'Department of Chemistry',/,
     &         3x,'Michigan Technological University',/,
     &         3x,'wloch@mtu.edu',/,/,
     &         ' ==============================================',/)
 2001 format(/,3x,'for ',a5,' MO vectors:',/,
     &         3x,'number of basis functions    = ',i8,/,
     &         3x,'number of molecular orbitals = ',i8,/)

c
      end

      SUBROUTINE ccsdtq_lambda1_14_10_1_2(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdtq_lambda1_14_10_1_2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h2 h5 h10 p3 p4 p8 )_y + = 1 * y ( h2 h5 h10 p3 p4 p8 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h5b
      INTEGER h10b
      INTEGER p3b
      INTEGER p4b
      INTEGER p8b
      INTEGER dimc
      INTEGER h2b_1
      INTEGER h5b_1
      INTEGER h10b_1
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER p8b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h2b = 1,noab
      DO h5b = 1,noab
      DO h10b = h5b,noab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO p8b = p4b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+
     &int_mb(k_spin+p8b-1).ne.12)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h10b-1
     &) .eq. int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h10b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),in
     &t_mb(k_sym+p8b-1)))))) .eq. irrep_y) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h10b-1) * int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_
     &mb(k_range+p8b-1)
      CALL TCE_RESTRICTED_6(h2b,h5b,h10b,p3b,p4b,p8b,h2b_1,h5b_1,h10b_1,
     &p3b_1,p4b_1,p8b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+h10b-1) * int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) *
     & int_mb(k_range+p8b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_14_10_1_2',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_14_10_1_2',1,MA_ERR)
      IF ((h10b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p8b_1
     & - noab - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1 
     &+ nvab * (h2b_1 - 1 + noab * (h10b_1 - 1 + noab * (h5b_1 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1),6,5,4,2,1,3,1.0d0)
      END IF
      IF ((h5b .lt. h2b) .and. (h2b .le. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p8b_1
     & - noab - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1 
     &+ nvab * (h10b_1 - 1 + noab * (h2b_1 - 1 + noab * (h5b_1 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1),6,5,4,3,1,2,-1.0d0)
      END IF
      IF ((h2b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p8b_1
     & - noab - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1 
     &+ nvab * (h10b_1 - 1 + noab * (h5b_1 - 1 + noab * (h2b_1 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1),6,5,4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_14_10_1_2
     &',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_14_10_1_2',3,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h2b-1),6,5,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p8b -
     & noab - 1 + nvab * (p4b - noab - 1 + nvab * (p3b - noab - 1 + nvab
     & * (h10b - 1 + noab * (h5b - 1 + noab * (h2b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_14_10_1_2
     &',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_14_1
     &0_1_2',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

C> \ingroup selci
C> @{
      subroutine selci_tred1(nm,n,a,d,e,e2)
*
* $Id: tred1.f 24790 2013-11-11 18:56:49Z d3y133 $
*
c
      integer i,j,k,l,n,ii,nm,jp1
      double precision a(nm,n),d(n),e(n),e2(n)
      double precision f,g,h,scale
c
c     this subroutine is a translation of the algol procedure tred1,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix
c     to a symmetric tridiagonal matrix using
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        a contains information about the orthogonal trans-
c          formations used in the reduction in its strict lower
c          triangle.  the full upper triangle of a is unaltered.
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        e2 contains the squares of the corresponding elements of e.
c          e2 may coincide with e if the squares are not needed.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      do 100 i = 1, n
         d(i) = a(n,i)
         a(n,i) = a(i,i)
  100 continue
c     .......... for i=n step -1 until 1 do -- ..........
      do 300 ii = 1, n
         i = n + 1 - ii
         l = i - 1
         h = 0.0d0
         scale = 0.0d0
         if (l .lt. 1) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + dabs(d(k))
c
         if (scale .ne. 0.0d0) go to 140
c
         do 125 j = 1, l
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = 0.0d0
  125    continue
c
  130    e(i) = 0.0d0
         e2(i) = 0.0d0
         go to 300
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         e2(i) = scale * scale * h
         f = d(l)
         g = -dsign(dsqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
         if (l .eq. 1) go to 285
c     .......... form a*u ..........
         do 170 j = 1, l
  170    e(j) = 0.0d0
c
         do 240 j = 1, l
            f = d(j)
            g = e(j) + a(j,j) * f
            jp1 = j + 1
            if (l .lt. jp1) go to 220
c
            do 200 k = jp1, l
               g = g + a(k,j) * d(k)
               e(k) = e(k) + a(k,j) * f
  200       continue
c
  220       e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0d0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         h = f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250    e(j) = e(j) - h * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = d(j)
            g = e(j)
c
            do 260 k = j, l
  260       a(k,j) = a(k,j) - f * e(k) - g * d(k)
c
  280    continue
c
  285    do 290 j = 1, l
            f = d(j)
            d(j) = a(l,j)
            a(l,j) = a(i,j)
            a(i,j) = f * scale
  290    continue
c
  300 continue
c
      return
      end
C> @}

      logical function argos_prepare_rstsiz(lfnrst,filrst,nwm,nwa,nsa,
     + nwmc)
c
c $Id: argos_prepare_rstsiz.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer lfnrst,nwm,nwa,nwmc
      character*255 filrst
c
      character*1 cdummy
      integer i,j,nsa,npbtyp,nbxtyp,nsm,nhist
      real*8 rdummy
c
      open(unit=lfnrst,file=filrst(1:index(filrst,' ')-1),
     + status='old',err=9999)
      rewind(lfnrst)
c
      do 1 i=1,3
      read(lfnrst,1000) cdummy
 1000 format(a1)
    1 continue
      read(lfnrst,1006) nhist
 1006 format(32x,i5)
      if(nhist.gt.0) then
      do 2 i=1,nhist
      read(lfnrst,1000) cdummy
    2 continue
      endif
      read(lfnrst,1002) npbtyp,nbxtyp,(rdummy,j=1,9)
 1002 format(2i5,/,(3f12.6))
      read(lfnrst,1003) rdummy
 1003 format(e12.5)
      read(lfnrst,1004) rdummy,rdummy,rdummy
 1004 format(3f12.6)
      read(lfnrst,1005) nwm,nwa,nsm,nsa,nwmc
 1005 format(7i10,2i5)
c
      close(unit=lfnrst)
c
c      nwm=nwm-nwmc
c
      argos_prepare_rstsiz=.true.
      return
c
 9999 continue
      argos_prepare_rstsiz=.false.
      return
      end

      subroutine argos_diana_xaver(xtrj,xa)
c
c      x,xa,nx,mx,nave)
c
c $Id: argos_diana_xaver.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "msgids.fh"
#include "global.fh"
#include "argos_diana_common.fh"
c
      real*8 zero
      parameter(zero=0.0d0)
c
      real*8 xtrj(ntrj,3,nfrdim),xa(nsa,3)
c
      integer i,j,k
c
      if(nsa.ne.ntrj) call md_abort('xaver dimension problem',0)
c
      do 1 j=1,3
      do 2 i=1,nsa
      xa(i,j)=zero
    2 continue
      do 3 k=1,nfrme
      do 4 i=1,ntrj
      xa(i,j)=xa(i,j)+xtrj(i,j,k)
    4 continue
    3 continue
    1 continue
c
c     global sum
c
      call ga_dgop(mag_d08,xa,3*nsa,'+')
c
      do 5 j=1,3
      do 6 i=1,ntrj
      xa(i,j)=xa(i,j)/dble(nfrtot)
    6 continue
    5 continue
c
      if(me.eq.0) then
      write(*,'(a)') ' Coordinates averaged'
      endif
c
      return
      end

*> \brief \b SGEMV
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
* 
*       .. Scalar Arguments ..
*       REAL ALPHA,BETA
*       INTEGER INCX,INCY,LDA,M,N
*       CHARACTER TRANS
*       ..
*       .. Array Arguments ..
*       REAL A(LDA,*),X(*),Y(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SGEMV  performs one of the matrix-vector operations
*>
*>    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
*>
*> where alpha and beta are scalars, x and y are vectors and A is an
*> m by n matrix.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>           On entry, TRANS specifies the operation to be performed as
*>           follows:
*>
*>              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
*>
*>              TRANS = 'T' or 't'   y := alpha*A**T*x + beta*y.
*>
*>              TRANS = 'C' or 'c'   y := alpha*A**T*x + beta*y.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>           On entry, M specifies the number of rows of the matrix A.
*>           M must be at least zero.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the number of columns of the matrix A.
*>           N must be at least zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is REAL
*>           On entry, ALPHA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is REAL array of DIMENSION ( LDA, n ).
*>           Before entry, the leading m by n part of the array A must
*>           contain the matrix of coefficients.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program. LDA must be at least
*>           max( 1, m ).
*> \endverbatim
*>
*> \param[in] X
*> \verbatim
*>          X is REAL array of DIMENSION at least
*>           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
*>           and at least
*>           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
*>           Before entry, the incremented array X must contain the
*>           vector x.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           X. INCX must not be zero.
*> \endverbatim
*>
*> \param[in] BETA
*> \verbatim
*>          BETA is REAL
*>           On entry, BETA specifies the scalar beta. When BETA is
*>           supplied as zero then Y need not be set on input.
*> \endverbatim
*>
*> \param[in,out] Y
*> \verbatim
*>          Y is REAL array of DIMENSION at least
*>           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
*>           and at least
*>           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
*>           Before entry with BETA non-zero, the incremented array Y
*>           must contain the vector y. On exit, Y is overwritten by the
*>           updated vector y.
*> \endverbatim
*>
*> \param[in] INCY
*> \verbatim
*>          INCY is INTEGER
*>           On entry, INCY specifies the increment for the elements of
*>           Y. INCY must not be zero.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup single_blas_level2
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 2 Blas routine.
*>  The vector and matrix arguments are not referenced when N = 0, or M = 0
*>
*>  -- Written on 22-October-1986.
*>     Jack Dongarra, Argonne National Lab.
*>     Jeremy Du Croz, Nag Central Office.
*>     Sven Hammarling, Nag Central Office.
*>     Richard Hanson, Sandia National Labs.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
*
*  -- Reference BLAS level2 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      REAL ALPHA,BETA
      INTEGER INCX,INCY,LDA,M,N
      CHARACTER TRANS
*     ..
*     .. Array Arguments ..
      REAL A(LDA,*),X(*),Y(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL ONE,ZERO
      PARAMETER (ONE=1.0E+0,ZERO=0.0E+0)
*     ..
*     .. Local Scalars ..
      REAL TEMP
      INTEGER I,INFO,IX,IY,J,JX,JY,KX,KY,LENX,LENY
*     ..
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (.NOT.LSAME(TRANS,'N') .AND. .NOT.LSAME(TRANS,'T') .AND.
     +    .NOT.LSAME(TRANS,'C')) THEN
          INFO = 1
      ELSE IF (M.LT.0) THEN
          INFO = 2
      ELSE IF (N.LT.0) THEN
          INFO = 3
      ELSE IF (LDA.LT.MAX(1,M)) THEN
          INFO = 6
      ELSE IF (INCX.EQ.0) THEN
          INFO = 8
      ELSE IF (INCY.EQ.0) THEN
          INFO = 11
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('SGEMV ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR.
     +    ((ALPHA.EQ.ZERO).AND. (BETA.EQ.ONE))) RETURN
*
*     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
*     up the start points in  X  and  Y.
*
      IF (LSAME(TRANS,'N')) THEN
          LENX = N
          LENY = M
      ELSE
          LENX = M
          LENY = N
      END IF
      IF (INCX.GT.0) THEN
          KX = 1
      ELSE
          KX = 1 - (LENX-1)*INCX
      END IF
      IF (INCY.GT.0) THEN
          KY = 1
      ELSE
          KY = 1 - (LENY-1)*INCY
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
*     First form  y := beta*y.
*
      IF (BETA.NE.ONE) THEN
          IF (INCY.EQ.1) THEN
              IF (BETA.EQ.ZERO) THEN
                  DO 10 I = 1,LENY
                      Y(I) = ZERO
   10             CONTINUE
              ELSE
                  DO 20 I = 1,LENY
                      Y(I) = BETA*Y(I)
   20             CONTINUE
              END IF
          ELSE
              IY = KY
              IF (BETA.EQ.ZERO) THEN
                  DO 30 I = 1,LENY
                      Y(IY) = ZERO
                      IY = IY + INCY
   30             CONTINUE
              ELSE
                  DO 40 I = 1,LENY
                      Y(IY) = BETA*Y(IY)
                      IY = IY + INCY
   40             CONTINUE
              END IF
          END IF
      END IF
      IF (ALPHA.EQ.ZERO) RETURN
      IF (LSAME(TRANS,'N')) THEN
*
*        Form  y := alpha*A*x + y.
*
          JX = KX
          IF (INCY.EQ.1) THEN
              DO 60 J = 1,N
                  IF (X(JX).NE.ZERO) THEN
                      TEMP = ALPHA*X(JX)
                      DO 50 I = 1,M
                          Y(I) = Y(I) + TEMP*A(I,J)
   50                 CONTINUE
                  END IF
                  JX = JX + INCX
   60         CONTINUE
          ELSE
              DO 80 J = 1,N
                  IF (X(JX).NE.ZERO) THEN
                      TEMP = ALPHA*X(JX)
                      IY = KY
                      DO 70 I = 1,M
                          Y(IY) = Y(IY) + TEMP*A(I,J)
                          IY = IY + INCY
   70                 CONTINUE
                  END IF
                  JX = JX + INCX
   80         CONTINUE
          END IF
      ELSE
*
*        Form  y := alpha*A**T*x + y.
*
          JY = KY
          IF (INCX.EQ.1) THEN
              DO 100 J = 1,N
                  TEMP = ZERO
                  DO 90 I = 1,M
                      TEMP = TEMP + A(I,J)*X(I)
   90             CONTINUE
                  Y(JY) = Y(JY) + ALPHA*TEMP
                  JY = JY + INCY
  100         CONTINUE
          ELSE
              DO 120 J = 1,N
                  TEMP = ZERO
                  IX = KX
                  DO 110 I = 1,M
                      TEMP = TEMP + A(I,J)*X(IX)
                      IX = IX + INCX
  110             CONTINUE
                  Y(JY) = Y(JY) + ALPHA*TEMP
                  JY = JY + INCY
  120         CONTINUE
          END IF
      END IF
*
      RETURN
*
*     End of SGEMV .
*
      END
c $Id: sgemv.f 24342 2013-06-22 05:32:15Z d3y133 $

      logical function pre_gensgm(lfnout,lfnfrg,lfnsgm,
     + lsgm,csgm,msgm,nsgm)
c
c $Id: pre_gensgm.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     function to generate segment files
c
c     in  : lfnfrg    = fragment file logical file number
c           lfnsgm    = segment file logical file number
c           lfnout    = output file logical file number
c           mseq      = dimension of the sequence list
c           lsgm(1,i) = number of segments of type i
c           lsgm(2,i) = source: 0=not found; 1=s; 2=x; 3=u; 4=t;
c           csgm(i)   = segment name
c
      implicit none
c
#include "mafdecls.fh"
#include "util.fh"
#include "pre_common.fh"
c
c
      logical pre_mksgm
      external pre_mksgm
c
      integer lfnout,lfnfrg,lfnsgm
      integer msgm,nsgm
      integer lsgm(3,msgm)
      character*5 csgm(msgm)
c
      character*255 filfrg,filsgm,dirnam,dirnm2
c
      integer len,len2,length
      integer i
c
      if(util_print('where',print_debug)) then
      write(lfnout,2000)
 2000 format(/,'pre_gensgm ')
      endif
c
      do 1 i=1,nsgm
      if(lsgm(2,i).lt.0) then
c
      length=index(csgm(i),' ')-1
      if(length.le.0) length=5
c
      dirnam=dirpar(-lsgm(2,i))
      len=index(dirnam,' ')-1
      dirnm2=dirpar(mdirpar)
      len2=index(dirnm2,' ')-1
c
      filfrg=dirnam(1:len)//csgm(i)(1:length)//'.frg '
      filsgm=dirnm2(1:len2)//csgm(i)(1:length)//'.sgm '
c
      if(util_print('where',print_debug)) then
      write(lfnout,2001) filfrg(1:index(filfrg,' ')-1),
     + filsgm(1:index(filsgm,' ')-1)
 2001 format(' Converting ',a,'into ',a)
      endif
c
      if(.not.pre_mksgm(lfnout,lfnfrg,filfrg,lfnsgm,filsgm))
     + call md_abort('pre_mksgm failed',9999)
c
      lsgm(2,i)=mdirpar
      endif
    1 continue
c
      pre_gensgm=.true.
      return
c
 9999 continue
      pre_gensgm=.false.
      return
      end

      subroutine sym_grad_symmetrize(geom, grad)
C     $Id: sym_g_sym.F 20089 2011-03-14 20:27:45Z d3p852 $
      implicit none
#include "errquit.fh"
#include "sym.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "geom.fh"
      integer geom
      double precision grad(3,*)
      logical geom_isystype_set
      external geom_isystype_set
c     
c     Apply a projection operator to the gradient
c     so that it posesses the symmetry of the group
c     to machine precision.
c     
      integer iat, jat, k, op
      integer nops, nat, l_tmp, k_tmp
      double precision rnew(3)
      integer save_sys
c     
      nops = sym_number_ops(geom)
      if (nops .eq. 0) return
c     
      if (.not. geom_ncent(geom, nat)) call errquit('s_g_s: geom?',0,
     &       GEOM_ERR)
      if (.not. ma_push_get(mt_dbl, 3*nat, 'gradtmp', l_tmp, k_tmp))
     $     call errquit('sym_grad_sym: scratch space', 3*nat, MA_ERR)
c     
      if (util_print('sym_grad_sym', print_debug)) then
         write(6,*) ' sym_grad_sym: Input gradient'
         call output(grad, 1, 3, 1, nat, 3, nat, 1)
      endif
c
      call dcopy(3*nat, grad, 1, dbl_mb(k_tmp), 1)
c
! sym_apply_cart_op() wraps back into the box, which is wrong for gradients
      if (.not. geom_systype_get(geom, save_sys))
     $     call errquit('sym_grad_symmetrize:systype?',0, GEOM_ERR)
      if (.not.geom_isystype_set(geom,0))
     >     call errquit('sym_grad_symmetrize:failed to set isystype',
     >                  0,GEOM_ERR)
! Call with minu op to tell sym_apply_op() to not apply translatsion
! which is also wrong for gradients
      do iat = 1, nat
         do op = 1, nops
            jat = sym_center_map(geom, iat, op)
            call sym_apply_cart_op(geom,-op, grad(1,iat), rnew)
            do k = 1, 3
               dbl_mb(k_tmp-1 + k + (jat-1)*3) = 
     $              dbl_mb(k_tmp-1 + k + (jat-1)*3) + rnew(k)
            enddo
         end do
      end do
      if (.not.geom_isystype_set(geom,save_sys))
     >     call errquit('sym_grad_symmetrize:failed to set isystype',
     >                  0,GEOM_ERR)
c     
      call dscal(3*nat, 1.0d0/dble(nops+1), dbl_mb(k_tmp), 1)
c
      call dcopy(3*nat, dbl_mb(k_tmp), 1, grad, 1)
c
      if (util_print('sym_grad_sym', print_debug)) then
         write(6,*) ' sym_grad_sym: Output gradient'
         call output(grad, 1, 3, 1, nat, 3, nat, 1)
      endif
c
      if (.not.ma_pop_stack(l_tmp)) call errquit('s_g_s: ma?',0, MA_ERR)
c
      end
      subroutine sym_hess_symmetrize(geom, h)
C     $Id: sym_g_sym.F 20089 2011-03-14 20:27:45Z d3p852 $
      implicit none
#include "errquit.fh"
#include "sym.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "geom.fh"
      integer geom
      double precision h(*)     ! Assumed (3*nat,3*nat)
c     
c     Apply a projection operator to the hessian
c     so that it posesses the symmetry of the group
c     to machine precision.
c     
      integer iat, jat, op, iatnew, jatnew
      integer nops, nat, l_tmp, k_tmp
      double precision hold(3,3), hnew(3,3)
      integer nat3
c
      nops = sym_number_ops(geom)
      if (nops .eq. 0) return
c     
      if (.not. geom_ncent(geom, nat)) call errquit('s_g_s: geom?',0,
     &       GEOM_ERR)
      nat3 = nat*3
      if (.not. ma_push_get(mt_dbl, (nat3)**2, 'htmp', l_tmp, k_tmp))
     $     call errquit('sym_hess_sym: scratch space', (nat3)**2,
     &       MA_ERR)
c     
      if (util_print('sym_hess_sym', print_debug)) then
         write(6,*) ' sym_hess_sym: Input hessian'
         call output(h, 1, nat3, 1, nat3, nat3, nat3, 1)
      endif
c
      call dcopy(nat3**2, h, 1, dbl_mb(k_tmp), 1)
c
      do iat = 1, nat
         do jat = 1, nat
            call sym_copy_h_block(iat,jat,nat,h,hold)
            do op = 1, nops
               iatnew = sym_center_map(geom, iat, op)
               jatnew = sym_center_map(geom, jat, op)
               call sym_apply_hess_op(geom, op, hold, hnew)
               call sym_add_h_block(iatnew, jatnew, nat, 
     &             dbl_mb(k_tmp), hnew)
            enddo
         end do
      end do
c     
      call dscal(nat3**2, 1.0d0/dble(nops+1), dbl_mb(k_tmp), 1)
c
      call dcopy(nat3**2, dbl_mb(k_tmp), 1, h, 1)
c
      if (util_print('sym_hess_sym', print_debug)) then
         write(6,*) ' sym_hess_sym: Output hessian'
         call output(h, 1, nat3, 1, nat3, nat3, nat3, 1)
      endif
c
      if (.not.ma_pop_stack(l_tmp)) call errquit('s_h_s: ma?',0, MA_ERR)
c
      end
      subroutine sym_der_dip_symmetrize(geom, d)
C     $Id: sym_g_sym.F 20089 2011-03-14 20:27:45Z d3p852 $
      implicit none
#include "errquit.fh"
#include "sym.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "geom.fh"
      integer geom
      double precision d(*)     ! Assumed (3,3,nat)
c     
c     Apply a projection operator to the derivative dipole moment
c     so that it posesses the symmetry of the group
c     to machine precision.
c
      integer iat, op, iatnew
      integer nops, nat, l_tmp, k_tmp
      double precision dold(3,3), dnew(3,3)
      integer nat3
c
      nops = sym_number_ops(geom)
c     
      if (.not. geom_ncent(geom, nat)) call errquit('s_d_s: geom?',0,
     &       GEOM_ERR)
      nat3 = nat*3
      if (.not. ma_push_get(mt_dbl, 3*nat3, 'dtmp', l_tmp, k_tmp))
     $     call errquit('sym_dip_sym: scratch space', (nat3)**2, MA_ERR)
c     
      if (util_print('sym_dip_sym', print_debug)) then
         write(6,*) ' sym_dip_sym: Input derivative dipole'
         call output(d, 1, 3, 1, nat3, 3, nat3, 1)
      endif
c
      call dcopy(3*nat3, d, 1, dbl_mb(k_tmp), 1)
c
      do iat = 1, nat
         call sym_copy_h_block(1,iat,1,d,dold)
         do op = 1, nops
            iatnew = sym_center_map(geom, iat, op)
            call sym_apply_hess_op(geom, op, dold, dnew)
            call sym_add_h_block(1,iatnew, 1, 
     &           dbl_mb(k_tmp), dnew)
         enddo
      end do
c     
      call dscal(3*nat3, 1.0d0/dble(nops+1), dbl_mb(k_tmp), 1)
c
      call dcopy(3*nat3, dbl_mb(k_tmp), 1, d, 1)
c
      if (util_print('sym_dip_sym', print_debug)) then
         write(6,*) ' sym_dip_sym: Output deriviative dipole'
         call output(d, 1, 3, 1, nat3, 3, nat3, 1)
      endif
c
      if (.not.ma_pop_stack(l_tmp)) call errquit('s_d_s: ma?',0, MA_ERR)
c
      end
      subroutine sym_apply_hess_op(geom, opnum, h, h1)
      implicit none
c
#include "nwc_const.fh"
#include "geomP.fh"
c
      integer geom, opnum
      double precision h(3,3), h1(3,3)
      integer i, j, k, l
c
c     Apply operators to atom block of Hessian ... R*H*RT
c
c     Hik =  sum(jl) Rij hjl  Rkl
c
c     THIS HAS ONLY BE DESIGNED WITH MOLECULAR SYSTEM IN MIND
c     .... TRANSLATION TERMS NEED ADDING FOR PERIODIC
c
c     stupid 3**4 version for easy debugging
c
      do i = 1, 3
         do k = 1, 3
            h1(i,k) = 0.0d0
            do j = 1, 3
               do l = 1, 3
                  h1(i,k) = h1(i,k) + 
     $                 sym_ops((opnum-1)*3+i,j,geom)*
     $                 sym_ops((opnum-1)*3+k,l,geom)*h(j,l)
               enddo
            enddo
         enddo
      enddo
c
      end
      subroutine sym_copy_h_block(iat,jat,nat,h,hold)
      implicit none
      integer iat, jat, nat
      double precision h(3,nat,3,*)
      double precision hold(3,3)
c
      integer i, j
c
      do i = 1, 3
         do j = 1, 3
            hold(i,j) = h(i,iat,j,jat)
         enddo
      enddo
c
      end
      subroutine sym_add_h_block(iat,jat,nat,h,hnew)
      implicit none
      integer iat, jat, nat
      double precision h(3,nat,3,*)
      double precision hnew(3,3)
c
      integer i, j
c
      do i = 1, 3
         do j = 1, 3
             h(i,iat,j,jat) =  h(i,iat,j,jat) + hnew(i,j)
         enddo
      enddo
c
      end

*
* $Id: semicore_force.F 19707 2010-10-29 17:59:36Z d3y133 $
*

#define TCGMSG

*     ***************************
*     *                         *
*     *    semicore_xc_F        *
*     *                         *
*     ***************************

      subroutine semicore_xc_F(ispin,xcp,fion)
      implicit none
#include "errquit.fh"
      integer ispin
      real*8  xcp(*)

      real*8 fion(3,*)

#include "mafdecls.fh"

*     **** semicore common block ****
c     real*8  ncore(nfft3d,nkatmx),rcore(nkatmx)
c     logocal semicore(0:nkatmx)
      integer ncore(2),rcore(2)
      integer semicore(2)
      common / ccore / ncore,rcore,semicore

*     **** local variables ****
      logical value
      integer npack0,nfft3d,n2ft3d
      integer ii,ia,nx,ny,nz
      real*8  sumx,sumy,sumz
      real*8  scal1,scal2
      integer exi(2),vxcG(2)
      integer Gx(2),Gy(2),Gz(2)
      integer dng(2)
      integer dngx(2),dngy(2),dngz(2)

*     **** external functions ****
      integer  ion_nion,ion_katm,G_indx
      real*8   lattice_omega
      external ion_nion,ion_katm,G_indx
      external lattice_omega


      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()

      call D3dB_nfft3d(1,nfft3d)
      call D3dB_n2ft3d(1,n2ft3d)
      call Pack_npack(0,npack0)

      value = MA_push_get(mt_dcpl,nfft3d,'exi', exi(2), exi(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'vxcG',vxcG(2),vxcG(1))

      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gx',Gx(2),Gx(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gy',Gy(2),Gy(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gz',Gz(2),Gz(1))

      value = value.and.
     >        MA_push_get(mt_dcpl, nfft3d,'dng',dng(2),dng(1))
      value = value.and.
     >        MA_push_get(mt_dcpl, nfft3d,'dngx',dngx(2),dngx(1))
      value = value.and.
     >        MA_push_get(mt_dcpl, nfft3d,'dngy',dngy(2),dngy(1))
      value = value.and.
     >        MA_push_get(mt_dcpl, nfft3d,'dngz',dngz(2),dngz(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


      call D3dB_rr_Sum(1,xcp(1),
     >                   xcp(1+(ispin-1)*n2ft3d),
     >                   dcpl_mb(vxcG(1)))
c     call D3dB_r_SMul(1,0.5d0,dcpl_mb(vxcG(1)),dcpl_mb(vxcG(1)))
      call D3dB_r_Zero_Ends(1,dcpl_mb(vxcG(1)))


*     **** define Gx, Gy, and Gz in packed space ****
      call D3dB_t_Copy(1,dbl_mb(G_indx(1)),dbl_mb(Gx(1)))
      call D3dB_t_Copy(1,dbl_mb(G_indx(2)),dbl_mb(Gy(1)))
      call D3dB_t_Copy(1,dbl_mb(G_indx(3)),dbl_mb(Gz(1)))
      call Pack_t_pack(0,dbl_mb(Gx(1)))
      call Pack_t_pack(0,dbl_mb(Gy(1)))
      call Pack_t_pack(0,dbl_mb(Gz(1)))


      do ii=1,ion_nion()
         ia = ion_katm(ii)

         if (log_mb(semicore(1)+ia)) then

*          **** structure factor and local pseudopotential ****
           call strfac(ii,dcpl_mb(exi(1)))
           call Pack_c_pack(0,dcpl_mb(exi(1)))

*          **** put sqrt(core-density) at atom position ****
           call Pack_tc_Mul(0,
     >               dbl_mb(ncore(1)+(ia-1)*5*npack0),
     >              dcpl_mb(exi(1)),
     >              dcpl_mb(dng(1)))

           call Pack_tc_iMul(0,dbl_mb(Gx(1)),dcpl_mb(dng(1)),
     >                                       dcpl_mb(dngx(1)))
           call Pack_tc_iMul(0,dbl_mb(Gy(1)),dcpl_mb(dng(1)),
     >                                       dcpl_mb(dngy(1)))
           call Pack_tc_iMul(0,dbl_mb(Gz(1)),dcpl_mb(dng(1)),
     >                                       dcpl_mb(dngz(1)))
c          call Pack_c_SMul(0,(-1.0d0),dcpl_mb(dngx(1)),
c    >                                 dcpl_mb(dngx(1)))
c          call Pack_c_SMul(0,(-1.0d0),dcpl_mb(dngy(1)),
c    >                                 dcpl_mb(dngy(1)))
c          call Pack_c_SMul(0,(-1.0d0),dcpl_mb(dngz(1)),
c    >                                 dcpl_mb(dngz(1)))

*          **** put dng,dngx,dngy,dngz in real space ****
           call Pack_c_unpack(0,dcpl_mb(dng(1)))
           call Pack_c_unpack(0,dcpl_mb(dngx(1)))
           call Pack_c_unpack(0,dcpl_mb(dngy(1)))
           call Pack_c_unpack(0,dcpl_mb(dngz(1)))

           call D3dB_cr_fft3b(1,dcpl_mb(dng(1)))
           call D3dB_cr_fft3b(1,dcpl_mb(dngx(1)))
           call D3dB_cr_fft3b(1,dcpl_mb(dngy(1)))
           call D3dB_cr_fft3b(1,dcpl_mb(dngz(1)))
c           call D3dB_rr_Mul(1,dcpl_mb(dng(1)),
c     >                        dcpl_mb(dngx(1)),
c     >                        dcpl_mb(dngx(1)))
c           call D3dB_rr_Mul(1,dcpl_mb(dng(1)),
c     >                        dcpl_mb(dngy(1)),
c     >                        dcpl_mb(dngy(1)))
c           call D3dB_rr_Mul(1,dcpl_mb(dng(1)),
c     >                        dcpl_mb(dngz(1)),
c     >                        dcpl_mb(dngz(1)))
           call D3dB_rr_Mul2(1,dcpl_mb(dng(1)),dcpl_mb(dngx(1)))
           call D3dB_rr_Mul2(1,dcpl_mb(dng(1)),dcpl_mb(dngy(1)))
           call D3dB_rr_Mul2(1,dcpl_mb(dng(1)),dcpl_mb(dngz(1)))

           call D3dB_rr_dot(1,dcpl_mb(dngx(1)),dcpl_mb(vxcG(1)),sumx)
           call D3dB_rr_dot(1,dcpl_mb(dngy(1)),dcpl_mb(vxcG(1)),sumy)
           call D3dB_rr_dot(1,dcpl_mb(dngz(1)),dcpl_mb(vxcG(1)),sumz)

           fion(1,ii) = fion(1,ii) + sumx*scal2*scal1
           fion(2,ii) = fion(2,ii) + sumy*scal2*scal1
           fion(3,ii) = fion(3,ii) + sumz*scal2*scal1

c          write(*,*) "semicore-force:",sumx*scal2*scal1,
c    >                                  sumy*scal2*scal1,
c    >                                  sumz*scal2*scal1
         end if

      end do

      value = MA_pop_stack(dngz(2))
      value = value.and.MA_pop_stack(dngy(2))
      value = value.and.MA_pop_stack(dngx(2))
      value = value.and.MA_pop_stack(dng(2))
      value = value.and.MA_pop_stack(Gz(2))
      value = value.and.MA_pop_stack(Gy(2))
      value = value.and.MA_pop_stack(Gx(2))
      value = value.and.MA_pop_stack(vxcG(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not. value) 
     > call errquit('semicore_force:error popping stack',0, MA_ERR)

      return
      end

      Subroutine Module_Census
* $Id: census.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
C
C     Eventually this routine should print out a list of modules or
C     tasks or something which are incorporated into the present
C     build of the program.
C
C     For now, let's not worry too much
C
      Write (6, *) 'I dont''t know which modules are in this build.'
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine argos(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'argos is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine argos_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'argos_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine crossing(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'crossing is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine debtest(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'debtest is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine dia_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'dia_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine diana(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'diana is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine gasdev(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'gasdev is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine geninterface(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'geninterface is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine jantest(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'jantest is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine jvltest(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'jvltest is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine jvltest2(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'jvltest2 is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine kgdtest(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'kgdtest is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine leps_energy(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'leps_energy is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine leps_gradient(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'leps_gradient is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine lucia(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'lucia is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine mc_data(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'mc_data is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine mc_driver(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'mc_driver is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine mc_init(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'mc_init is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine mc_main(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'mc_main is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine md_data(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'md_data is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine md_driver(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'md_driver is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine md_set(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'md_set is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine moints_screen(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'moints_screen is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine mymc_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'mymc_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine mymd_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'mymd_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine nbo_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'nbo_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine python_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'python_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine raktest(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'raktest is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine rimp2g(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'rimp2g is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine rism_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'rism_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine rjhtest(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'rjhtest is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine smd_input(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'smd_input is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_fragment_energy(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_fragment_energy is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_nbo(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_nbo is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_python(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_python is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_rism(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_rism is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_smd(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_smd is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_smd_dynamics(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_smd_dynamics is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_smd_energy(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_smd_energy is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine task_smd_fragment(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'task_smd_fragment is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine uccsdt(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'uccsdt is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine uccsdtest(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'uccsdtest is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End
* $Id: stub.skeleton 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine urand(RTDB)
#include "errquit.fh"
      Integer RTDB
      Call ErrQuit(
     $   'urand is not in this build of NWChem',
     $    0, CAPMIS_ERR)
      Return
      End

      SUBROUTINE ccsdt_y_tr1_14_1_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_
     &c_offset)
C     $Id: ccsdt_y_tr1_14_1_4.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 p12 h11 p4 )_vt + = -2/3 * Sum ( h10 p8 ) * t ( p8 p12 h10 h11 )_t * i3 ( h2 h10 p4 p8 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p12b
      INTEGER h11b
      INTEGER p4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p8b
      INTEGER h10b
      INTEGER p12b_1
      INTEGER p8b_1
      INTEGER h11b_1
      INTEGER h10b_1
      INTEGER h2b_2
      INTEGER h10b_2
      INTEGER p4b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO p12b = noab+1,noab+nvab
      DO h11b = 1,noab
      DO p4b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p12b-
     &1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p12b-1) .eq. int_mb(k_spin+
     &h11b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_mb
     &(k_sym+h11b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_v,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p12b-1) * int_mb(k_r
     &ange+h11b-1) * int_mb(k_range+p4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14_1_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p8b = noab+1,noab+nvab
      DO h10b = 1,noab
      IF (int_mb(k_spin+p12b-1)+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+
     &h11b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb
     &(k_sym+h11b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p12b,p8b,h11b,h10b,p12b_1,p8b_1,h11b_1,h10b_
     &1)
      CALL TCE_RESTRICTED_4(h2b,h10b,p4b,p8b,h2b_2,h10b_2,p4b_2,p8b_2)
      dim_common = int_mb(k_range+p8b-1) * int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p12b-1) * int_mb(k_range+h11b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14_1_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr1_14_1_4',2,MA_ERR)
      IF ((p8b .le. p12b) .and. (h10b .le. h11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (p12b_1 - noab - 1 + nvab * (p
     &8b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),4,2,3,1,1.0d0)
      END IF
      IF ((p8b .le. p12b) .and. (h11b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p12b_1 - noab - 1 + nvab * (p
     &8b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+h11b-1),int_mb(k_range+h10b
     &-1),3,2,4,1,-1.0d0)
      END IF
      IF ((p12b .lt. p8b) .and. (h10b .le. h11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (p8b_1 - noab - 1 + nvab * (p1
     &2b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),4,1,3,2,-1.0d0)
      END IF
      IF ((p12b .lt. p8b) .and. (h11b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p8b_1 - noab - 1 + nvab * (p1
     &2b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+h11b-1),int_mb(k_range+h10b
     &-1),3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr1_14_1_4',3,MA
     &_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14_1_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr1_14_1_4',5,MA_ERR)
      IF ((h10b .lt. h2b) .and. (p8b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab 
     &* (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_mb(k_range+p4b-1
     &),4,2,1,3,1.0d0)
      END IF
      IF ((h10b .lt. h2b) .and. (p4b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab 
     &* (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1
     &),3,2,1,4,-1.0d0)
      END IF
      IF ((h2b .le. h10b) .and. (p8b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h2b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p8b-1),int_mb(k_range+p4b-1
     &),4,1,2,3,-1.0d0)
      END IF
      IF ((h2b .le. h10b) .and. (p4b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h2b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1
     &),3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr1_14_1_4',6,MA
     &_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr1_14_1_4'
     &,7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr1_14_1_4'
     &,8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr1_14_1_4',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h11b-1),int_mb(k_range+p12b-
     &1),2,4,3,1,-2.0d0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (h11b - 1 + noab * (p12b - noab - 1 + nvab * (h
     &2b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr1_14_1_4',10,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr1_14_1_4'
     &,11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      logical function argos_prep_misfit(lfnout,lfnmat,
     + isfnd,xs,csa,qsa,isgm,msa,nsa,
     + idsb,cdsb,msb,nsb,grid,mgrid,ngrid,gdist,nmis,iwater,iwfnd,xw,
     + qwa,mwm,mwa,nwm,nwa,npbtyp,box,fcount,nrgrid,iogrid,rogrid)
c
c $Id: argos_prep_misfit.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      integer util_nint
      external util_nint
#endif
      logical md_zmat
      external md_zmat
c
      integer lfnout,lfnmat
      integer msa,nsa,msb,nsb,mgrid,nmis,iwater,mwm,mwa,nwm,nwa
      integer isfnd(msa),idsb(2,msb),iwfnd(mwm),npbtyp,isgm(msa)
      real*8 cdsb(msb),xs(3,msa),qsa(msa)
      character*16 csa(msa)
      real*8 xw(3,mwa,mwm),qwa(mwa),box(3),fcount
      character*255 filmat
      integer nrgrid,iogrid(5),rogrid(2,5)
c
      real*8 grid(4,mgrid),distx,disty,distz
      integer i,ic,j,nn,nndx(10),nnn,nnndx(10),nm,miss
      real*8 d(3),c(3),p(3),t(3),r,dr,dd,px(3),pn(3),pz(3),pw(3)
      real*8 xmax(3),xmin(3),dx(3),dist2,gdist,gdist2,angle,boxh(3)
      integer ix,iy,iz,k,l,m,imax,imin,ngrid,iwm,isa,iwm2,iwa,num
c
      integer isg,ioff,jz,kz,lz
      real*8 dz,az,tz,dgrid
      logical lmat,fndone
c
      if(nmis.gt.0) then
c
c     process z-matrices for missing atoms
c     ------------------------------------
c
   32 continue
      dr=0.0d0
      ioff=0
      isg=0
      lmat=.false.
      fndone=.false.
      do 30 i=1,nsa
      if(isgm(i).ne.isg) then
      isg=isgm(i)
      ioff=i-1
      filmat=csa(i)(1:index(csa(i),' ')-1)//'.mat '
      lmat=.false.
      if(lmat) close(unit=lfnmat)
      open(unit=lfnmat,file=filmat(1:index(filmat,' ')-1),
     + form='formatted',status='old',err=30)
      lmat=.true.
      endif
      if(lmat.and.isfnd(i).ne.1) then
      rewind(lfnmat)
   31 continue
      read(lfnmat,1000,end=30,err=30) iz,jz,kz,lz,dz,az,tz
 1000 format(4i5,3f12.6)
      if(i.eq.iz+ioff.and.isfnd(ioff+jz).ne.0.and.
     + isfnd(ioff+kz).ne.0.and.isfnd(ioff+lz).ne.0) then
      if(md_zmat(xs(1,i),xs(1,ioff+jz),xs(1,ioff+kz),xs(1,ioff+lz),
     + dz,az,tz)) then
      isfnd(i)=1
      write(*,'(a,i7,a,a,3f10.5)') ' Generated from z-matrix: ',
     + isg,':',csa(i),(xs(k,i),k=1,3)
      fndone=.true.
      endif
      else
      goto 31
      endif
      endif
   30 continue
      if(lmat) close(unit=lfnmat)
      if(fndone) goto 32
c
      if(util_print('restart',print_default)) then
      write(lfnout,2000)
 2000 format(' Z-matrix definitions done',/)
      endif
c
c     generate missing coordinates based on simple rules
c     --------------------------------------------------
c
      gdist2=gdist*gdist
      boxh(1)=0.5d0*box(1)
      boxh(2)=0.5d0*box(2)
      boxh(3)=0.5d0*box(3)
c
c     loop over all solute atoms
c     --------------------------
c
      ngrid=0
      miss=0
c
      do 1 i=1,nsa
c
c     for each atom without coordinates
c     ---------------------------------
c
      if(isfnd(i).ne.1) then
      if(util_print('coordinates',print_debug)) then
      write(lfnout,'(a,i7,5x,a16)') 'Not found: atom ',i,csa(i)
      endif
      nn=0
c
c     find all bonded atoms
c     ---------------------
c
      do 2 j=1,nsb
      if(idsb(1,j).eq.i) then
      nn=nn+1
      nndx(nn)=idsb(2,j)
      endif
      if(idsb(2,j).eq.i) then
      nn=nn+1
      nndx(nn)=idsb(1,j)
      endif
    2 continue
c
      if(nn.eq.0) goto 1
c
c     if bound to single other existing atom
c
      if(nn.eq.1.and.isfnd(nndx(1)).eq.1) then
c
c     find atoms bound to that atom
c
      nnn=0
      do 3 j=1,nsb
      if(idsb(1,j).eq.nndx(1)) then
      nnn=nnn+1
      nnndx(nnn)=idsb(2,j)
      endif
      if(idsb(2,j).eq.nndx(1)) then
      nnn=nnn+1
      nnndx(nnn)=idsb(1,j)
      endif
      if(idsb(1,j).eq.i.or.idsb(2,j).eq.i) dr=cdsb(j)
    3 continue
c
c     count the number of missing atoms
c
      nm=0
      do 4 j=1,nnn
      if(isfnd(nnndx(j)).ne.1) nm=nm+1
    4 continue
c
c     if j is only missing atom
c
      if(nm.eq.1) then
      c(1)=xs(1,nndx(1))
      c(2)=xs(2,nndx(1))
      c(3)=xs(3,nndx(1))
      d(1)=0.0d0
      d(2)=0.0d0
      d(3)=0.0d0
      num=0
      do 5 j=1,nnn
      if(nnndx(j).ne.i) then
      d(1)=d(1)+xs(1,nnndx(j))
      d(2)=d(2)+xs(2,nnndx(j))
      d(3)=d(3)+xs(3,nnndx(j))
      num=num+1
      endif
    5 continue
      d(1)=d(1)/dble(num)-c(1)
      d(2)=d(2)/dble(num)-c(2)
      d(3)=d(3)/dble(num)-c(3)
      r=sqrt(d(1)*d(1)+d(2)*d(2)+d(3)*d(3))
      if(r.lt.0.0001)
     + call md_abort('argos_prep_misfit: vector too small',9001)
      xs(1,i)=c(1)-dr*d(1)/r
      xs(2,i)=c(2)-dr*d(2)/r
      xs(3,i)=c(3)-dr*d(3)/r
      if(nnn.eq.2) then
      p(1)=xs(1,i)
      p(2)=xs(2,i)
      p(3)=xs(3,i)
      t(1)=p(2)*c(3)-c(2)*p(3)+c(1)
      t(2)=p(3)*c(1)-c(3)*p(1)+c(2)
      t(3)=p(1)*c(2)-c(1)*p(2)+c(3)
      angle=1.047198d0
      call rotate(c,t,angle,p,xs(1,i))
      endif
      isfnd(i)=1
      endif
c
c     if j is one of two missing atoms
c
      if(nm.eq.2) then
      c(1)=xs(1,nndx(1))
      c(2)=xs(2,nndx(1))
      c(3)=xs(3,nndx(1))
      d(1)=0.0d0
      d(2)=0.0d0
      d(3)=0.0d0
      ic=0
      num=0
      do 6 j=1,nnn
      if(nnndx(j).ne.i.and.isfnd(nnndx(j)).eq.1) then
      d(1)=d(1)+xs(1,nnndx(j))
      d(2)=d(2)+xs(2,nnndx(j))
      d(3)=d(3)+xs(3,nnndx(j))
      ic=nnndx(j)
      num=num+1
      endif
    6 continue
      d(1)=d(1)/dble(num)-c(1)
      d(2)=d(2)/dble(num)-c(2)
      d(3)=d(3)/dble(num)-c(3)
      r=sqrt(d(1)*d(1)+d(2)*d(2)+d(3)*d(3))
      if(r.lt.0.0001)
     + call md_abort('argos_prep_misfit: vector too small',9002)
      d(1)=dr*d(1)/r
      d(2)=dr*d(2)/r
      d(3)=dr*d(3)/r
      if(nnn.eq.3) then
      if(abs(d(1)).le.abs(d(2)).and.abs(d(1)).le.abs(d(3))) then
      t(1)=d(1)+c(1)
      t(2)=d(3)+c(2)
      t(3)=-d(2)+c(3)
      elseif(abs(d(2)).le.abs(d(1)).and.abs(d(2)).le.abs(d(3))) then
      t(1)=d(3)+c(1)
      t(2)=d(2)+c(2)
      t(3)=-d(1)+c(3)
      else
      t(1)=d(2)+c(1)
      t(2)=-d(1)+c(2)
      t(3)=d(3)+c(3)
      endif
      d(1)=d(1)+c(1)
      d(2)=d(2)+c(2)
      d(3)=d(3)+c(3)
      angle=2.094395102d0
      call rotate(c,t,angle,d,p)
      xs(1,i)=p(1)
      xs(2,i)=p(2)
      xs(3,i)=p(3)
      isfnd(i)=1
      else
      d(1)=d(1)+c(1)
      d(2)=d(2)+c(2)
      d(3)=d(3)+c(3)
      r=sqrt((xs(1,ic)-c(1))**2+(xs(2,ic)-c(2))**2+(xs(3,ic)-c(3))**2)
      if(r.lt.0.0001)
     + call md_abort('argos_prep_misfit: vector too small',9004)
      t(1)=dr*(xs(1,ic)-c(1))/r+c(1)
      t(2)=dr*(xs(2,ic)-c(2))/r+c(2)
      t(3)=dr*(xs(3,ic)-c(3))/r+c(3)
      angle=1.570796327d0
      call rotate(c,d,angle,t,p)
      d(1)=d(1)-c(1)
      d(2)=d(2)-c(2)
      d(3)=d(3)-c(3)
      t(1)=t(1)-c(1)
      t(2)=t(2)-c(2)
      t(3)=t(3)-c(3)
      c(1)=d(2)*t(3)-t(2)*d(3)+xs(1,nndx(1))
      c(2)=d(3)*t(1)-t(3)*d(1)+xs(2,nndx(1))
      c(3)=d(1)*t(2)-t(1)*d(2)+xs(3,nndx(1))
      d(1)=xs(1,nndx(1))
      d(2)=xs(2,nndx(1))
      d(3)=xs(3,nndx(1))
      angle=3.141592654d0
      call rotate(d,c,angle,p,t)
      xs(1,i)=t(1)
      xs(2,i)=t(2)
      xs(3,i)=t(3)
      isfnd(i)=1
      endif
      endif
c
c     if j is one of three missing atoms
c
      if(nm.eq.3) then
      c(1)=xs(1,nndx(1))
      c(2)=xs(2,nndx(1))
      c(3)=xs(3,nndx(1))
      d(1)=0.0d0
      d(2)=0.0d0
      d(3)=0.0d0
      ic=0
      num=0
      do 7 j=1,nnn
      if(nnndx(j).ne.i.and.isfnd(nnndx(j)).eq.1) then
      d(1)=d(1)+xs(1,nnndx(j))
      d(2)=d(2)+xs(2,nnndx(j))
      d(3)=d(3)+xs(3,nnndx(j))
      ic=nnndx(j)
      num=num+1
      endif
    7 continue
      d(1)=d(1)/dble(num)-c(1)
      d(2)=d(2)/dble(num)-c(2)
      d(3)=d(3)/dble(num)-c(3)
      r=sqrt(d(1)*d(1)+d(2)*d(2)+d(3)*d(3))
      if(r.lt.0.0001)
     + call md_abort('argos_prep_misfit: vector too small',9005)
      d(1)=dr*d(1)/r
      d(2)=dr*d(2)/r
      d(3)=dr*d(3)/r
      if(nnn.eq.4) then
      if(abs(d(1)).le.abs(d(2)).and.abs(d(1)).le.abs(d(3))) then
      t(1)=d(1)+c(1)
      t(2)=d(3)+c(2)
      t(3)=-d(2)+c(3)
      elseif(abs(d(2)).le.abs(d(1)).and.abs(d(2)).le.abs(d(3))) then
      t(1)=d(3)+c(1)
      t(2)=d(2)+c(2)
      t(3)=-d(1)+c(3)
      else
      t(1)=d(2)+c(1)
      t(2)=-d(1)+c(2)
      t(3)=d(3)+c(3)
      endif
      d(1)=d(1)+c(1)
      d(2)=d(2)+c(2)
      d(3)=d(3)+c(3)
      angle=1.910633236d0
      call rotate(c,t,angle,d,p)
      xs(1,i)=p(1)
      xs(2,i)=p(2)
      xs(3,i)=p(3)
      isfnd(i)=1
      else
c
c     three missing hydrogens from atom with other than 4 neighbors
c
      call md_abort('argos_prep_misfit: not implemented for atom',i)
      endif
      endif
c
      endif
      endif
c
    1 continue
c
      if(util_print('restart',print_default)) then
      write(lfnout,2001)
 2001 format(' Geometric rules definitions done',/)
      endif
c
      do 8 i=1,nsa
c
c     for each atom without coordinates
c     ---------------------------------
c
      if(isfnd(i).ne.1) then
      nn=0
c
c     find all bonded atoms
c     ---------------------
c
      do 9 j=1,nsb
      if(idsb(1,j).eq.i) then
      nn=nn+1
      nndx(nn)=idsb(2,j)
      endif
      if(idsb(2,j).eq.i) then
      nn=nn+1
      nndx(nn)=idsb(1,j)
      endif
    9 continue
c
c
c     if not bound to any atom
c     ------------------------
c
      if(nn.eq.0) then
      if(util_print('coordinates',print_debug)) then
      write(lfnout,'(a,i7)') 'Setting up grid for atom ',i
      endif
c
c     setup grid
c
      if(ngrid.eq.0) then
      do 10 j=1,nsa
      if(isfnd(j).eq.1) then
      xmax(1)=xs(1,j)
      xmax(2)=xs(2,j)
      xmax(3)=xs(3,j)
      xmin(1)=xs(1,j)
      xmin(2)=xs(2,j)
      xmin(3)=xs(3,j)
      goto 11
      endif
   10 continue
   11 continue
      do 12 k=1,3
      do 13 j=1,nsa
      if(isfnd(j).eq.1) then
      if(xmax(k).lt.xs(k,j)) xmax(k)=xs(k,j)
      if(xmin(k).gt.xs(k,j)) xmin(k)=xs(k,j)
      endif
   13 continue
      dx(k)=(xmax(k)-xmin(k)+4.0d0*gdist)/(mgrid-1)
      xmin(k)=xmin(k)-2.0d0*gdist
   12 continue
c
      if(ngrid.gt.0.and.util_print('coordinates',print_debug)) then
      do 555 k=1,nrgrid
      write(lfnout,'(a,i5,2f12.5)') 'grid option ',
     + iogrid(k),rogrid(1,k),rogrid(2,k)
  555 continue
      endif
      ngrid=1
      do 14 ix=1,mgrid
      do 15 iy=1,mgrid
      do 16 iz=1,mgrid
      grid(1,ngrid)=xmin(1)+dble(ix-1)*dx(1)
      grid(2,ngrid)=xmin(2)+dble(iy-1)*dx(2)
      grid(3,ngrid)=xmin(3)+dble(iz-1)*dx(3)
      if(nrgrid.gt.0) then
      do 217 k=1,nrgrid
      if(iogrid(k).eq.1) then
      if(grid(1,ngrid).lt.rogrid(1,k)) goto 16
      if(grid(1,ngrid).gt.rogrid(2,k)) goto 16
      elseif(iogrid(k).eq.2) then
      if(grid(1,ngrid).gt.rogrid(1,k).and.grid(1,ngrid).lt.rogrid(2,k))
     + goto 16
      elseif(iogrid(k).eq.3) then
      if(grid(2,ngrid).lt.rogrid(1,k)) goto 16
      if(grid(2,ngrid).gt.rogrid(2,k)) goto 16
      elseif(iogrid(k).eq.4) then
      if(grid(2,ngrid).gt.rogrid(1,k).and.grid(2,ngrid).lt.rogrid(2,k))
     + goto 16
      elseif(iogrid(k).eq.5) then
      if(grid(3,ngrid).lt.rogrid(1,k)) goto 16
      if(grid(3,ngrid).gt.rogrid(2,k)) goto 16
      elseif(iogrid(k).eq.6) then
      if(grid(3,ngrid).gt.rogrid(1,k).and.grid(3,ngrid).lt.rogrid(2,k))
     + goto 16
      elseif(iogrid(k).eq.7) then
      dgrid=sqrt(grid(1,ngrid)**2+grid(2,ngrid)**2)
      if(dgrid.lt.rogrid(1,k)) goto 16
      if(dgrid.gt.rogrid(2,k)) goto 16
      elseif(iogrid(k).eq.8) then
      dgrid=sqrt(grid(1,ngrid)**2+grid(2,ngrid)**2)
      if(dgrid.gt.rogrid(1,k).and.dgrid.lt.rogrid(2,k)) goto 16
      elseif(iogrid(k).eq.9) then
      dgrid=sqrt(grid(1,ngrid)**2+grid(2,ngrid)**2+grid(3,ngrid)**2)
      if(dgrid.lt.rogrid(1,k)) goto 16
      if(dgrid.gt.rogrid(2,k)) goto 16
      elseif(iogrid(k).eq.10) then
      dgrid=sqrt(grid(1,ngrid)**2+grid(2,ngrid)**2+grid(2,ngrid)**2)
      if(dgrid.gt.rogrid(1,k).and.dgrid.lt.rogrid(2,k)) goto 16
      endif
  217 continue
      endif
c      write(*,'(a,4i5)') 'grid ',ix,iy,iz
      do 17 k=1,nsa
      if(isfnd(k).eq.1) then
      if(npbtyp.eq.0) then
      dist2=(grid(1,ngrid)-xs(1,k))**2+(grid(2,ngrid)-xs(2,k))**2+
     + (grid(3,ngrid)-xs(3,k))**2
      else
      distx=grid(1,ngrid)-xs(1,k)
      disty=grid(2,ngrid)-xs(2,k)
      distz=grid(3,ngrid)-xs(3,k)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      if(abs(distx).gt.boxh(1))
     + distx=distx-util_nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2))
     + disty=disty-util_nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3))
     + distz=distz-util_nint(distx/box(3))*box(3)
#else
      if(abs(distx).gt.boxh(1)) distx=distx-nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2)) disty=disty-nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3)) distz=distz-nint(distx/box(3))*box(3)
#endif
      dist2=distx**2+disty**2+distz**2
      endif
      if(dist2.lt.gdist2) goto 16
      endif
   17 continue
      if(iwater.gt.0) then
      do 117 k=1,nwm
      if(iwfnd(k).gt.0) then
      do 118 l=1,iwfnd(k)
      if(npbtyp.eq.0) then
      dist2=(grid(1,ngrid)-xw(1,l,k))**2+(grid(2,ngrid)-xw(2,l,k))**2+
     + (grid(3,ngrid)-xw(3,l,k))**2
      else
      distx=grid(1,ngrid)-xw(1,l,k)
      disty=grid(2,ngrid)-xw(2,l,k)
      distz=grid(3,ngrid)-xw(3,l,k)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      if(abs(distx).gt.boxh(1))
     + distx=distx-util_nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2))
     + disty=disty-util_nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3))
     + distz=distz-util_nint(distx/box(3))*box(3)
#else
      if(abs(distx).gt.boxh(1)) distx=distx-nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2)) disty=disty-nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3)) distz=distz-nint(distx/box(3))*box(3)
#endif
      dist2=distx**2+disty**2+distz**2
      endif
      if(dist2.lt.gdist2) goto 16
  118 continue
      endif
  117 continue
      endif
      ngrid=ngrid+1
   16 continue
   15 continue
   14 continue
      ngrid=ngrid-1
c
      if(ngrid.le.0) call md_abort('No grid points 0',9999)
c
c     calculate grid potential
c
      do 18 k=1,ngrid
      grid(4,k)=0.0d0
      do 19 j=1,nsa
      if(isfnd(j).eq.1) then
      if(npbtyp.eq.0) then
      dist2=dsqrt((grid(1,k)-xs(1,j))**2+
     + (grid(2,k)-xs(2,j))**2+(grid(3,k)-xs(3,j))**2)
      else
      distx=grid(1,ngrid)-xs(1,k)
      disty=grid(2,ngrid)-xs(2,k)
      distz=grid(3,ngrid)-xs(3,k)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      if(abs(distx).gt.boxh(1))
     + distx=distx-util_nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2))
     + disty=disty-util_nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3))
     + distz=distz-util_nint(distx/box(3))*box(3)
#else
      if(abs(distx).gt.boxh(1)) distx=distx-nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2)) disty=disty-nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3)) distz=distz-nint(distx/box(3))*box(3)
#endif
      dist2=distx**2+disty**2+distz**2
      endif
      grid(4,k)=grid(4,k)+fcount*qsa(j)/dist2
      endif
   19 continue
      if(iwater.gt.0) then
      do 119 m=1,nwm
      if(iwfnd(m).gt.0) then
      do 120 l=1,iwfnd(m)
      if(npbtyp.eq.0) then
      dist2=(grid(1,ngrid)-xw(1,l,m))**2+(grid(2,ngrid)-xw(2,l,m))**2+
     + (grid(3,ngrid)-xw(3,l,m))**2
      else
      distx=grid(1,ngrid)-xw(1,l,m)
      disty=grid(2,ngrid)-xw(2,l,m)
      distz=grid(3,ngrid)-xw(3,l,m)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      if(abs(distx).gt.boxh(1))
     + distx=distx-util_nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2))
     + disty=disty-util_nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3))
     + distz=distz-util_nint(distx/box(3))*box(3)
#else
      if(abs(distx).gt.boxh(1)) distx=distx-nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2)) disty=disty-nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3)) distz=distz-nint(distx/box(3))*box(3)
#endif
      dist2=distx**2+disty**2+distz**2
      endif
      grid(4,k)=grid(4,k)+qwa(l)/dist2
  120 continue
      endif
  119 continue
      endif
   18 continue
c
      endif
c
      if(ngrid.le.0) call md_abort('No grid points 1',9999)
c
c     find extrema
c
      imax=1
      imin=1
      do 20 j=1,ngrid
      if(grid(4,j).gt.grid(4,imax)) imax=j
      if(grid(4,j).lt.grid(4,imin)) imin=j
   20 continue
c
c     choose best grid point
c
      if(qsa(i).gt.0.0d0) then
      xs(1,i)=grid(1,imin)
      xs(2,i)=grid(2,imin)
      xs(3,i)=grid(3,imin)
      else
      xs(1,i)=grid(1,imax)
      xs(2,i)=grid(2,imax)
      xs(3,i)=grid(3,imax)
      imin=imax
      endif
      isfnd(i)=1
      if(util_print('restart',print_medium)) then
      write(lfnout,6000) fcount*qsa(i)*grid(4,imin)*138.9354d0
 6000 format(' Added counterion with energy ',t40,f12.3,' kJ/mol')
      endif
c
c     remove all grid points within gdist from imin from grid
c
      d(1)=grid(1,imin)
      d(2)=grid(2,imin)
      d(3)=grid(3,imin)
c
      imax=ngrid
      ngrid=0
      do 21 j=1,imax
      if(npbtyp.eq.0) then
      dist2=(grid(1,j)-d(1))**2+(grid(2,j)-d(2))**2+(grid(3,j)-d(3))**2
      else
      distx=grid(1,j)-d(1)
      disty=grid(2,j)-d(2)
      distz=grid(3,j)-d(3)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      if(abs(distx).gt.boxh(1))
     + distx=distx-util_nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2))
     + disty=disty-util_nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3))
     + distz=distz-util_nint(distx/box(3))*box(3)
#else
      if(abs(distx).gt.boxh(1)) distx=distx-nint(distx/box(1))*box(1)
      if(abs(disty).gt.boxh(2)) disty=disty-nint(distx/box(2))*box(2)
      if(abs(distz).gt.boxh(3)) distz=distz-nint(distx/box(3))*box(3)
#endif
      dist2=distx**2+disty**2+distz**2
      endif
      if(dist2.ge.gdist2) then
      ngrid=ngrid+1
      grid(1,ngrid)=grid(1,j)
      grid(2,ngrid)=grid(2,j)
      grid(3,ngrid)=grid(3,j)
      dist2=dsqrt((grid(1,ngrid)-xs(1,i))**2+
     + (grid(2,ngrid)-xs(2,i))**2+(grid(3,ngrid)-xs(3,i))**2)
      grid(4,ngrid)=grid(4,j)+fcount*qsa(i)/dist2
      endif
   21 continue
c
      if(ngrid.le.0) call md_abort('No grid points left',9999)
c
      else
      miss=miss+1
      if(util_print('restart',print_none)) then
      write(lfnout,9998) isgm(i),csa(i)
 9998 format(' Coordinates missing for atom ',i5,':',a)
      endif
      endif
      endif
    8 continue
c
      if(util_print('restart',print_default)) then
      write(lfnout,2002)
 2002 format(' Grid specifications for non-bonded atoms done',/)
      endif
c
      if(miss.ne.0) then
      call md_abort('argos_prep_misfit: missing non hydrogen',9999)
      endif
c
      endif
c
c     crystal waters
c
      if(iwater.gt.0) then
      do 23 iwm=1,nwm
      if(iwfnd(iwm).eq.1) then
      px(1)=0.0d0
      px(2)=0.0d0
      px(3)=0.0d0
      do 24 isa=1,nsa
      dx(1)=(xs(1,isa)-xw(1,1,iwm))
      dx(2)=(xs(2,isa)-xw(2,1,iwm))
      dx(3)=(xs(3,isa)-xw(3,1,iwm))
      dd=dx(1)*dx(1)+dx(2)*dx(2)+dx(3)*dx(3)
      px(1)=px(1)+qsa(isa)*dx(1)/dd
      px(2)=px(2)+qsa(isa)*dx(2)/dd
      px(3)=px(3)+qsa(isa)*dx(3)/dd
   24 continue
      do 25 iwm2=1,nwm
      if(iwfnd(iwm2).eq.3) then
      do 26 iwa=1,3
      dx(1)=(xw(1,iwa,iwm2)-xw(1,1,iwm))
      dx(2)=(xw(2,iwa,iwm2)-xw(2,1,iwm))
      dx(3)=(xw(3,iwa,iwm2)-xw(3,1,iwm))
      dd=dx(1)*dx(1)+dx(2)*dx(2)+dx(3)*dx(3)
      px(1)=px(1)+qwa(iwa)*dx(1)/dd
      px(2)=px(2)+qwa(iwa)*dx(2)/dd
      px(3)=px(3)+qwa(iwa)*dx(3)/dd
   26 continue
      endif
   25 continue
      dd=sqrt(px(1)*px(1)+px(2)*px(2)+px(3)*px(3))
      pw(1)=-0.1d0*px(1)/dd
      pw(2)=-0.1d0*px(2)/dd
      pw(3)=-0.1d0*px(3)/dd
      px(1)=pw(2)
      px(2)=pw(3)
      px(3)=pw(1)
      pn(1)=pw(2)*px(3)-pw(3)*px(2)
      pn(2)=pw(3)*px(1)-pw(1)*px(3)
      pn(3)=pw(1)*px(2)-pw(2)*px(1)
      pz(1)=0.0d0
      pz(2)=0.0d0
      pz(3)=0.0d0
      angle=0.95120d0
      call rotate(pz,pn,angle,pw,dx)
      xw(1,2,iwm)=xw(1,1,iwm)+dx(1)
      xw(2,2,iwm)=xw(2,1,iwm)+dx(2)
      xw(3,2,iwm)=xw(3,1,iwm)+dx(3)
      angle=-0.95120d0
      call rotate(pz,pn,angle,pw,dx)
      xw(1,3,iwm)=xw(1,1,iwm)+dx(1)
      xw(2,3,iwm)=xw(2,1,iwm)+dx(2)
      xw(3,3,iwm)=xw(3,1,iwm)+dx(3)
c
      iwfnd(iwm)=3
      endif
   23 continue
      endif
c
      if(util_print('restart',print_default)) then
      write(lfnout,2003)
 2003 format(' Crystal waters done',/)
      endif
c
      argos_prep_misfit=.true.
      return
 9999 continue
      argos_prep_misfit=.false.
      return
      end

      subroutine scf_vectors_guess(rtdb, tol2e, geom, basis, trans, 
     &                             movecs_in, movecs_out, movecs_guess,
     &                             scftype, nclosed, nopen, nbf, nmo,
     &                             nalpha, nbeta,  k_eval, k_occ, k_irs,
     &                             g_movecs, g_dens, vecs_or_dens, 
     &                             calling_module, title, oskel, oadapt, 
     &                             oinitialized) 
c
c     $Id: scf_vec_guess.F 25548 2014-05-02 21:30:18Z d3y133 $
c
      implicit none
#include "errquit.fh"
c
c     arguments:
c
c     tol2e         = 2-e integral selection threshold for energy/gradient
c     geom          = Geometry handle
c     basis         = Basis handle
c     trans         = Translated basis set name
c     movecs_in     = Name of input movecs file
c     movecs_out    = Name of output movecs file
c     movecs_guess  = Name of source of guess orbtials (=movecs_in initially)
c     scftype       = type of SCF (UHF/ROHF)
c     nclosed       = no. of closed shells
c     nopen         = no. of open shells
c     nbf           = no. of basis functions
c     nmo           = no. of linearly indep. MOs (= nbf for now)
c     nalpha        = no. of alpha spin electrons for UHF only
c     nbeta         = no. of beta spin electrons for UHF only
c     k_eval        = scf eigen values (ma index)
c     k_occ         = scf occupation (ma index)
c     k_irs         = MO symmetries (2*nmo for UHF) (ma index)
c     g_movecs      = eigen-vectors (global ga handle) (2x array for UHF)
c     g_dens        = AO densisty (global ga handle) (2x array for UHF)
c     vecs_or_dens  = "vectors" or "density" requested
c     calling_module= calculation type; SCF and DFT currently recognized
c     title         = Job Title
c     oskel         = if true use symmetry in fock building
c     oadapt        = if true force symmetry on the MOs
c     oinitialized  = true if initialized
c
      integer geom, basis, nopen, nclosed, nbf, nmo
      integer nalpha, nbeta
      double precision tol2e,ssmear
      logical oskel, oadapt, oinitialized
      integer g_movecs(2), g_dens(2)
      character*255 movecs_in, movecs_out, title, trans
      character*8 movecs_guess
      character*7 vecs_or_dens
      character*4 scftype
      character*3 calling_module
      integer k_eval, k_occ, k_irs
c
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "bas.fh"
#include "rtdb.fh"
c#include "cscf.fh"
#include "cfock.fh"
c
c     Form guess vectors on disk for SCF wavefunctions
c
      integer rtdb
c
c     local variables
c
      logical oprint
      integer g_tmp, g_tmp2
      integer i, nprint
      character*255 title_vecs, bas_vecs
      integer nbf_vecs, nsets, nmo_vecs(2)
      logical status, fon
      double precision tolguess, zero, one, two
      character*20 file_scftype
      character*255 string
      integer type, nelem, swap, handle
c
c     externals
c
      integer ga_create_atom_blocked
      logical movecs_read_header, movecs_write, movecs_read
      parameter (zero = 0.d0, one = 1.d0, two = 2.d0)
      external movecs_read_header, movecs_write, movecs_read
      external ga_create_atom_blocked
      logical quickguess
c
      if (.not. oinitialized) call errquit
     &     ('scf_v_g: not initialized?', 0, UNKNOWN_ERR)
c
      if(.not.rtdb_get(rtdb,'tolguess',mt_dbl,1,tolguess)) then
        if (owritefile) then
           tolguess = tol2e
        else
          tolguess = 1d-7        ! 1e-5 broke too many large basis SCFs
        endif
      endif
c
      oprint = util_print('mo guess', print_default) .and.
     &     ga_nodeid().eq.0
*      if (oprint)write(6,*)' Calling module = ',calling_module
c
c     check if smearing is on
c
      if (.not. rtdb_get(rtdb, 'dft:smear_sigma', mt_dbl, 1,
     &   ssmear)) then
         ssmear=0.d0
      endif
c
c     check if fon is on
c
      if (.not. rtdb_get(rtdb, 'dft:fon', mt_log, 1, fon)) then
         fon=.false.
      endif
c
c     Analyze linear dependence ... put eigenvectors of S into g_movecs
c     and if necessary reallocate the mo vectors to reflect the number
c     of independent MO vectors.
c
      call scf_lindep(rtdb, geom, basis, g_movecs, nmo)
      if (nmo .ne. nbf) then
         if (.not. ga_create(MT_DBL, nbf, nmo, 'scf_v_g: tmp MOs',
     &        32, 32, g_tmp)) call errquit('scf_v_g: tmp MOs', 0,
     &       GA_ERR)
         call ga_copy_patch('n', 
     &        g_movecs, 1, nbf, 1, nmo, g_tmp, 1, nbf, 1, nmo)
         if (.not. ga_destroy(g_movecs)) 
     &        call errquit('scf_v_g: ga_destroy?',0, GA_ERR)
         if (scftype .eq. 'UHF') then
            if (.not. ga_destroy(g_movecs(2))) 
     &           call errquit('scf_v_g: ga_destroy(2)?',0, GA_ERR)
            if (.not. ga_create(MT_DBL, nbf, nmo, 'scf_v_g: alpha MOs',
     &           32, 32, g_movecs)) call errquit('scf_v_g: alpha MOs',0,
     &       GA_ERR)
            if (.not. ga_create(MT_DBL, nbf, nmo, 'scf_v_g beta MOs',
     &           32, 32, g_movecs(2)))call errquit('scf_v_g:beta MOs',0,
     &       GA_ERR)
         else
            if (.not. ga_create(MT_DBL, nbf, nmo, 'scf_g_g: MOs',
     &           32,32, g_movecs)) call errquit('scf_v_g: MOs', 0,
     &       GA_ERR)
         endif
         call ga_copy(g_tmp, g_movecs)
         if (.not. ga_destroy(g_tmp)) 
     &        call errquit('scf_v_g: ga_destroy?',0, GA_ERR)
      endif
c
c     Need to force higher accuracy if linear dependence is
c     detected.  Also turn off density screening.  Have to do 
c     this also in the datebase so that subsequent invocations
c     of scf_get_fock_param() do the right thing no matter where
c     they are called from (e.g., scf, mp2, cphf, ...).
c
      if (nmo .ne. nbf) then
         tol2e = min(tol2e, 1d-10)
         dentolmax = 1d-9
         odensityscreen = .false.
         if (.not. rtdb_put(rtdb,'scf:tol2e',mt_dbl,1,tol2e))
     $        call errquit('scf_vec_guess: rtdb failed?',0, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'fock:dentolmax',mt_dbl,1,dentolmax))
     $        call errquit('scf_vec_guess: rtdb failed?',0, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'fock:densityscreen',mt_log,1,
     $        odensityscreen))
     $        call errquit('scf_vec_guess: rtdb failed?',0, RTDB_ERR)
      endif
c
 3212 continue
      if (movecs_in .eq. 'hcore' .or. movecs_in .eq. 'atomic') then
c
c     hcore or atomic guess
c
         if (.not.inp_compare(.false., 'dft', calling_module))then
            g_dens(1) = 
     &         ga_create_atom_blocked(geom, basis, 'Guess density')
         endif
         call ga_zero(g_dens(1))
         if (movecs_in .eq. 'atomic') then
            call guess_dens(rtdb, geom, basis, g_dens(1))
         endif
         if(.not.rtdb_get(rtdb,'quickguess',mt_log,1,quickguess)) 
     .        quickguess=.false.
         if (quickguess) return
c
c     Since the caching of integrals may be turned on automagically
c     we always need to use the full integral precision in the starting 
c     guess
c
c     Modified by RJH so that unless writing of integrals has been
c     forced on, it will do a quick and dirty initial guess and
c     not store any integrals at all.
c
         if (.not. owritefile) then
            call fock_force_direct(rtdb)
         endif
*         write(6,*) ' tolguess', tolguess
         call rhf_dens_to_mo(rtdb, geom, basis, 2*nclosed+nopen,
     &        nbf, nmo, tolguess,
     &        g_dens(1), g_movecs, oskel, dbl_mb(k_eval))
c
         if (.not. oreadfile) call scf_get_fock_param(rtdb,tol2e)
c
         if (scftype .eq. 'UHF') then
            call ga_copy(g_movecs(1),g_movecs(2))
            call dcopy(nbf,dbl_mb(k_eval),1,dbl_mb(k_eval+nbf),1)
         endif
c
         if (.not.inp_compare(.false., 'dft', calling_module))then
            if (.not. ga_destroy(g_dens(1))) call errquit
     &        ('scf_vectors_guess: destroy of density failed',0,
     &       GA_ERR)
         endif
c
      else if (movecs_in .eq. 'project') then
c         if (nmo .ne. nbf) call errquit
c     &        ('projection not yet working with linear dependence ',0)
c
c        Project from a smaller basis set ... must orthog before
c        the symmetry adaption. Also, sym adapt thoroughly
c        since the strong linear dependence in the 
c        random vectors may cause loss of precision.
c
         call movecs_project(rtdb, nmo, geom, basis, g_movecs,1,
     A        calling_module,k_eval)
         call ga_orthog_mos(basis, g_movecs)
         if (oadapt) then
            call scf_movecs_sym_adapt(basis, g_movecs, .false.,
     &           0, '- projected ', .true.,int_mb(k_irs))
            call scf_movecs_sym_adapt(basis, g_movecs, .false.,
     &           0, '- projected ', .true.,int_mb(k_irs))
         endif
         if (scftype .eq. 'UHF') then
         call movecs_project(rtdb, nmo, geom, basis, g_movecs,2,
     A           calling_module,k_eval+nbf)
         call ga_orthog_mos(basis, g_movecs(2))
         if (oadapt) then
            call scf_movecs_sym_adapt(basis, g_movecs(2), .false.,
     &           0, '- projected ', .true.,int_mb(k_irs+nmo))
            call scf_movecs_sym_adapt(basis, g_movecs(2), .false.,
     &           0, '- projected ', .true.,int_mb(k_irs+nmo))
          endif
          endif
c
      else if (movecs_in .eq. 'rotate') then
         nsets = 1
         if (scftype .eq. 'UHF') nsets = 2
         call movecs_rotate(rtdb, geom, basis,nsets, g_movecs,
     .        dbl_mb(k_eval),dbl_mb(k_occ))
c
      else if (movecs_in .eq. 'fragment') then
         if (scftype .ne. 'UHF') then
            call movecs_fragment(rtdb, geom, basis, 
     &           calling_module(1:inp_strlen(calling_module)), 1,
     &           nclosed, nopen, g_movecs(1), dbl_mb(k_eval))
         else
            call movecs_fragment(rtdb, geom, basis, 
     &           calling_module(1:inp_strlen(calling_module)), 1,
     &           0, nalpha, g_movecs(1), dbl_mb(k_eval))
            call movecs_fragment(rtdb, geom, basis, 
     &           calling_module(1:inp_strlen(calling_module)), 2,
     &           0, nbeta, g_movecs(2), dbl_mb(k_eval+nbf))
         endif
      else
c
c        Attempt to read vectors from file movecs_in and see if 
c        they make sense
c
         status = movecs_read_header(movecs_in, title_vecs, bas_vecs,
     &        file_scftype, nbf_vecs, nsets, nmo_vecs, 2)
         if (status) then
c     
c        Check that:
c        1) nbf from file = current nbf
c        2) name of basis from file = current basis name
c        3) nmo from file = current nmo (in case of change of linear dep)
c     
            if (nbf.eq.nbf_vecs .and. bas_vecs.eq.trans .and.
     &         nmo.eq.nmo_vecs(1)) then
c
c              If there is linear dependency, save the eigen vectors of
c              S, read in the MOs (perhaps from another geometry), and project
c              them into the linearly independent MO space of this geometry.
c
               if (nbf .ne. nmo) then
                  if (.not. ga_create(MT_DBL, nbf, nmo, 'scf_v_g:tmp',
     &                 32,32, g_tmp)) call errquit('scf_v_g: tmp', 0,
     &       GA_ERR)
                  call ga_copy(g_movecs, g_tmp)
               endif
c
c              Try reading movecs
c
               if (.not. movecs_read(movecs_in, 1,
     &            dbl_mb(k_occ), dbl_mb(k_eval), g_movecs))
     &            call errquit('scf_movecs_read failed ',0, DISK_ERR)
c
               if (scftype .eq. 'UHF') then
                  if (.not. movecs_read(movecs_in, 2,
     &               dbl_mb(k_occ+nbf), dbl_mb(k_eval+nbf),
     &               g_movecs(2))) then
                     if (ga_nodeid() .eq. 0 .and.
     &                  util_print('information', print_default)) then
                        write(6,*) 
     &                  '  Duplicating RHF/ROHF vectors for UHF'
                     endif
                     call ga_copy(g_movecs(1), g_movecs(2))
                     call dcopy(nbf,dbl_mb(k_occ),1,dbl_mb(k_occ+nbf),1)
                     call dcopy(nbf,dbl_mb(k_eval),1,dbl_mb(k_eval+nbf),
     &                          1)
                     if (inp_compare(.false., 'dft', 
     &                    calling_module)) 
     &                    call dscal(2*nbf,0.5d0,dbl_mb(k_occ),1)
                     
                  endif
               endif
c               call scf_movecs_read
*
               if (nbf .ne. nmo) then
                  if (.not. ga_create(MT_DBL, nmo, nmo, 'scf_v_g:tmp2',
     &                 32,32, g_tmp2)) call errquit('scf_v_g: tmp2', 0,
     &       GA_ERR)
                  call ga_dgemm('t', 'n', nmo, nmo, nbf, 1.0d0, 
     &                 g_tmp, g_movecs, 0.0d0, g_tmp2)
                  call ga_dgemm('n', 'n', nbf, nmo, nmo, 1.0d0,
     &                 g_tmp, g_tmp2, 0.0d0, g_movecs)
                  if (scftype .eq. 'UHF') then
                     call ga_dgemm('t', 'n', nmo, nmo, nbf, 1.0d0,
     &                    g_tmp, g_movecs(2), 0.0d0, g_tmp2)
                     call ga_dgemm('n', 'n', nbf, nmo, nmo, 1.0d0, 
     &                    g_tmp, g_tmp2, 0.0d0, g_movecs(2))
                  endif
                  if (.not. ga_destroy(g_tmp))
     &                 call errquit('scf_v_g: ga_destroy?',0, GA_ERR)
                  if (.not. ga_destroy(g_tmp2))
     &                 call errquit('scf_v_g: ga_destroy?',0, GA_ERR)
               endif
            else
               if (ga_nodeid() .eq. 0 .and. 
     $              util_print('warning',print_low)) then
                  write(6,111) nbf, nbf_vecs, nmo, nmo_vecs(1),
     &              trans(1:inp_strlen(trans)),
     &              bas_vecs(1:inp_strlen(bas_vecs))
 111              format(/' !! nbf/nmo/basis-name mismatch '/
     &                 10x, ' nbf=', i4, ' nbf_file=',i4/
     &                 10x, ' nmo=', i4, ' nmo_file=',i4/
     &                 10x, ' basis="',a,'"', ' basis_file="',a,'"'/)
                  write(6,*) ' Either an incorrect movecs file was ',
     &                 'specified, or linear dependence has changed,'
                  write(6,*) ' or the basis name was changed. '
                  call util_flush(6)
               endif
               status = .false.
            endif
            if (oprint) then
               write(6,77) title_vecs(1:inp_strlen(title_vecs))
 77            format(/' Loading old vectors from job with title :'//a/)
               call util_flush(6)
            endif
         endif
         if (.not. status) then
*     Rather then failing simply force atomic guess
*     call errquit('rhf: failed to load vectors',0)
            if (ga_nodeid() .eq. 0 .and. 
     $           util_print('warning',print_low)) then
               write(6,*) 
               write(6,*) ' Load of old vectors failed. ',
     &              '  Forcing atomic density guess'
               write(6,*) 
            endif
            movecs_in = 'atomic'
            goto 3212
         endif
      endif
c
c     Apply any swaps of orbitals
c
      call movecs_swap(rtdb, 
     &     calling_module(1:inp_strlen(calling_module)), scftype, 
     &     g_movecs, dbl_mb(k_occ), dbl_mb(k_eval))
c
c
c    Apply any swaps of nuclei in the mapping of mo vectors
c
       if ( rtdb_ma_get(rtdb, 'reorder', type, nelem, handle)) then
         call movecs_swap_nuclei(rtdb,basis,geom, scftype,g_movecs)
       endif
c
c
c     Optionally symmetry adapt the initial molecular orbitals
c
      if (oadapt) then
         if (scftype .eq. 'UHF') then
c     
c     This may not be a good idea for UHF, but we will do it
c     if we are asked to!
c     
            nprint = min(nalpha+10,nmo)
            if (util_print('all vector symmetries', print_high))
     &           nprint = nmo
            call scf_movecs_sym_adapt(basis, g_movecs, oprint,
     &           nprint, '- initial alpha',.true.,int_mb(k_irs))
            call scf_movecs_sym_adapt(basis, g_movecs(2), oprint,
     &           nprint, '- initial beta', .true.,int_mb(k_irs+nmo))
         else
            nprint = min(nclosed+nopen+10,nmo)
            if (util_print('all vector symmetries', print_high))
     &           nprint = nmo
            call scf_movecs_sym_adapt(basis, g_movecs, oprint,
     &           nprint, '- initial ', .true.,int_mb(k_irs))
         endif
      endif
c
c     Orthogonalize all input/guess vectors ... do not mix the occupied
c     with the virtuals.  For the hcore/atomic guess we will have done a
c     diagonalization so there is no need to orthog. again.
c     (also if the symmetry projection found mixing an orthog is done)
c
c     Also record if this is a restart or a startup.
c
      if ((movecs_in.eq.'atomic' .or. movecs_in.eq.'hcore')) then
         movecs_guess = 'start'
      else
         movecs_guess = 'restart'
      endif
c
      if (movecs_guess.eq.'restart') then
         call ga_orthog_mos(basis, g_movecs)
         if (scftype .eq. 'UHF') call ga_orthog_mos(basis, g_movecs(2))
      endif
      if(ssmear.lt.1.e-9 .and. (.not. fon)) then
c
c     Generate correct occupation numbers
c
      if (scftype .eq. 'UHF') then
         call dfill(2*nbf, 0.0d0, dbl_mb(k_occ), 1)
         do i = 1, nalpha
            dbl_mb(i-1+k_occ) = 1.0d0
         enddo
         do i = 1, nbeta
            dbl_mb(i-1+nbf+k_occ) = 1.0d0
         enddo
      else
         call dfill(nbf, 0.0d0, dbl_mb(k_occ), 1) ! Current occupations
         do i = 1, nclosed
            dbl_mb(i-1+k_occ) = 2.0d0
         enddo
         do i = nclosed+1,nclosed+nopen
            dbl_mb(i-1+k_occ) = 1.0d0
         enddo
      endif
      endif
c
c     Apply phase conventions
c
      call movecs_fix_phase(g_movecs)
      if (scftype .eq. 'UHF') call movecs_fix_phase(g_movecs(2))
c
      if (util_print('initial vectors', print_debug)) then
         if (ga_nodeid() .eq. 0) then
            write(6,*)
            call util_print_centered(6,'Initial MO vectors',40,.true.)
            write(6,*)
            call util_flush(6)
         endif
         call ga_print(g_movecs)
         if (scftype .eq. 'UHF') call ga_print(g_movecs(2))
      endif
c
c     Save vectors to disk
c
      nmo_vecs(1) = nmo
      if (scftype .eq. 'UHF') then
         nsets = 2
         nmo_vecs(2) = nmo
      else
         nsets = 1
      endif
c
      if (.not. movecs_write(rtdb, basis, movecs_out, 
     &     calling_module(1:inp_strlen(calling_module)), title, 
     &     nbf, nsets, nmo_vecs,
     &     dbl_mb(k_occ), nbf, dbl_mb(k_eval),
     &     nbf, g_movecs)) call errquit
     &     ('scf_v_g: movecs_write failed', 0, DISK_ERR)
c
c      call scf_movecs_write(rtdb)
c     
c     Overwrite the input movecs option with where the final movecs
c     will end up so that a restart automatically picks them up
c
      string = ' '
      write(string,'(a,a)') 
     &   calling_module(1:inp_strlen(calling_module)),':input vectors'
      if (.not. rtdb_cput(rtdb, string(1:inp_strlen(string)),
     &     1, movecs_out)) 
     &     call errquit('scf_v_g:rtdb_cput failed scf:input vectors',0,
     &       RTDB_ERR)
      string = ' '
      write(string,'(a,a)') 
     &   calling_module(1:inp_strlen(calling_module)),':output vectors'
      if (.not. rtdb_cput(rtdb, string(1:inp_strlen(string)),
     &     1, movecs_out)) 
     &     call errquit('scf_v_g:rtdb_cput failed scf:output vectors',0,
     &       RTDB_ERR)
c
      movecs_in = movecs_out
c
c     Print out an analysis if explicitly requested
c
      if (util_print('initial vector analysis', print_debug)) then
         nprint = min(nclosed+nopen+30,nmo)
         if (scftype.eq.'RHF' .or. scftype.eq.'ROHF') then
            call movecs_print_anal(basis, 1,
     &           nprint, 0.15d0, g_movecs, 
     &           'ROHF Initial Molecular Orbital Analysis', 
     &           .true., dbl_mb(k_eval), oadapt, int_mb(k_irs),
     &           .true., dbl_mb(k_occ))
         else
            nprint = min(nalpha+20,nmo)
            call movecs_print_anal(basis, max(1,nbeta-20),
     &           nprint, 0.15d0, g_movecs, 
     &           'UHF Initial Alpha Molecular Orbital Analysis', 
     &           .true., dbl_mb(k_eval), oadapt, int_mb(k_irs),
     &           .true., dbl_mb(k_occ))
            call movecs_print_anal(basis, max(1,nbeta-20),
     &           nprint, 0.15d0, g_movecs(2), 
     &           'UHF Initial Beta Molecular Orbital Analysis', 
     &           .true., dbl_mb(k_eval+nbf), oadapt, int_mb(k_irs+nmo),
     &           .true., dbl_mb(k_occ+nbf))
         endif
      endif
c
c     If 'density' has been requested form it here before returning.
c
      if (inp_compare(.false., 'density', vecs_or_dens))then
         if (scftype .eq. 'UHF') then
            call ga_dgemm('n', 't', nbf, nmo, nalpha, one, g_movecs(1),
     &      g_movecs(1), zero, g_dens(1))
            call ga_dgemm('n', 't', nbf, nmo, nbeta, one, g_movecs(2),
     &      g_movecs(2), zero, g_dens(2))
         else
            call ga_dgemm('n', 't', nbf, nmo, nclosed, two, g_movecs(1),
     &      g_movecs(1), zero, g_dens(1))
         endif
c
c        Symmetrize the guess density
c
         if (oadapt)then
            call sym_symmetrize(geom, basis, .true., g_dens(1))
            if (scftype .eq. 'UHF')
     &         call sym_symmetrize(geom, basis, .true., g_dens(2))
         endif
c
c        Print guess density if debugging
c
         if (util_print('initial density', print_debug)) then
            if (ga_nodeid() .eq. 0) then
               write(6,*)
               call util_print_centered(6,'Initial Density',40,.true.)
               write(6,*)
               call util_flush(6)
            endif
            call ga_print(g_dens)
            if (scftype .eq. 'UHF') call ga_print(g_dens(2))
         endif
c
      endif
      return
      end

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     CCDen_Interm2 -- Form two-index intermediates for density
C
C REVISION
C     $Id: ccden_interm2.F 20114 2011-03-20 06:11:15Z d3y133 $
C
C SYNOPSIS
      Subroutine CCDen_Interm2(NOcc, NVir, T1, LDT1, g_T2,
     $   Z1, LDZ1, g_Z2,
     $   Omega1, LDO1, Omega2, LDO2, Omega3, LDO3, Omega4, LDO4)
      Implicit NONE
#include "errquit.fh"
      Integer NOcc, NVir, LDT1, LDZ1, LDO1, LDO2, LDO3, LDO4
      Integer g_T2, g_Z2
      Double Precision T1(LDT1, NVir), Z1(LDT1, NVir)
      Double Precision Omega1(LDO1, NVir), Omega2(LDO2, NVir),
     $   Omega3(LDO3, NVir), Omega4(LDO4, NOcc)
C
C ARGUMENTS
C DESCRIPTION
C     Compute 2-index intermediates used in coupled cluster 1PDM and 
C     2PDM evaluation
C
C     Outputs are small (NVir*NVir at most), so we replicate them.
C
C REFERENCES
C     Alistair P. Rendell and Timothy J. Lee, J. Chem. Phys. 94, 
C     6219--6228 (1991). Especially Eq. 52--55
C
C     Note:  The 2-index [tZ] terms (eq. 56--57) are trivial to compute
C     on the fly and are only used in two places each, so we don't
C     bother computing them now.
C
C INCLUDE FILES
#include "numerical_constants.fh"
#include "msgids.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "global.fh"
#include "util.fh"
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer T2_ILo, T2_IHi, T2_JLo, T2_JHi
      Integer H_Scr1, I_Scr1, H_Scr2, I_Scr2
      Integer I, J, M, N
      Logical oprint
C
C     Get print information
C
      oprint = util_print('information', print_low)
C
      Call DGeWr(NOcc, NVir, T1, LDT1, 0, 0, LUOut,
     $   'T1', 80, 'F20.15')
      Call DGeWr(NOcc, NVir, Z1, LDT1, 0, 0, LUOut,
     $   'Z1', 80, 'F20.15')
C
C     **********************
C     * Initialize Outputs *
C     **********************
C
      Call DFill(LDO1*NVir, FP_Zero, Omega1, 1)
      Call DFill(LDO2*NVir, FP_Zero, Omega2, 1)
      Call DFill(LDO3*NVir, FP_Zero, Omega3, 1)
      Call DFill(LDO4*NOcc, FP_Zero, Omega4, 1)
C
C     ***************************
C     * Local patch of T2 & Z2? *
C     ***************************
C     Note:  Not local in the scrictest sense (as required for ga_access)
C
      Call CCSD_T2_MyIJ(GA_NodeID(), NVir, G_T2, T2_ILo, T2_IHi,
     $     T2_JLo, T2_JHi)
      If (.NOT. GA_Compare_Distr(g_T2, g_Z2) ) Call ErrQuit(
     $   'CCDen_Interm2: T2 and Z2 must have same dist.', 0,
     &       GA_ERR)
C
      If (oprint) Write (LuOut, *) 'CCDen_Interm2 ', GA_NodeID(), 
     $   ': T2 region (',
     $   T2_ILo, ':', T2_IHi, ', ', T2_JLo, ':', T2_JHi, ')'
C
C     ********************************************
C     * Omega1(i,a) = sum(m,e) t(i,m,a,e) Z(m,e) *
C     * APR & TJL Eq. 52                         *
C     ********************************************
C     Get the whole vv patch for each t(i,m) and contract it with the
C     appropriate row of Z1 (vector-matrix multiply)
C
      If (.NOT. MA_Push_Get( MT_Dbl, NVir*NVir, 'CC Density scratch 1',
     $   H_Scr1, I_Scr1)) Call ErrQuit(
     $   'CCDen_Interm2: unable to allocate scratch', NVir*NVir, MA_ERR)
C
      Do I = T2_ILo, T2_IHi
         Do M = T2_JLo, T2_JHi
c$$$C
c$$$            If (oprint) Write (LuOut, *) GA_NodeID(), ': Omega1 (', I, ',', M, ')'
c$$$C
            Call GA_Get(g_T2, (I-1)*NVir+1, I*NVir, (M-1)*NVir+1,
     $         M*NVir, Dbl_MB(I_Scr1), NVir)
            Call dgemm('N', 'T', 1, NVir, NVir,
     $         FP_One, Z1(M,1), LDT1, Dbl_MB(I_Scr1), NVir,
     $         FP_One, Omega1(I,1), LDO1)
c$$$C
c$$$            Call DGeWr(1, NVir, Z1(M,1), LDZ1, 0, 0, LUOut,
c$$$     $         'Z1 patch', 80, 'F20.15')
c$$$            Call DGeWr(NVir, NVir, Dbl_MB(I_Scr1), NVir, 0, 0, LuOut,
c$$$     $         'T2 patch', 80, 'F20.15')
c$$$            Call DGeWr(NOcc, NVir, Omega1, LDO1, 0, 0, LUOut,
c$$$     $         'Partial Omega1', 80, 'F20.15')
c$$$C
         EndDo
      EndDo
C
C     Sum the partial results to complete Omega1
C
      Call GA_DGop(Msg_CCDen_1, Omega1, LDO1*NVir, '+')
c$$$C
c$$$      Call DGeWr(NOcc, NVir, Omega1, LDO1, 0, 0, LUOut,
c$$$     $   'Final Omega1', 80, 'F20.15')
C
C     *****************************************************
C     * Omega2(i,a) = sum(m,e) tau(m,i,a,e) Z(m,e)        *
C     *             = Omega1(i,a) + t(m,a) t(i,e) Z(m,e) -  ?  *
C     * APR & TJL Eq. 53                                  *
C     *****************************************************
C
      Do M = T2_ILo, T2_IHi
         Do I = T2_JLo, T2_JHi
c$$$C
c$$$            If (oprint) Write (LuOut, *) GA_NodeID(), ':Omega2 (', M, ',', I, ')'
c$$$C
            Call GA_Get(g_T2, (M-1)*NVir+1, M*NVir, (I-1)*NVir+1,
     $         I*NVir, Dbl_MB(I_Scr1), NVir)
            Call dgemm('N', 'T', 1, NVir, NVir,
     $         FP_One, Z1(M,1), LDT1, Dbl_MB(I_Scr1), NVir,
     $         FP_One, Omega2(I,1), LDO2)
c$$$C
c$$$            Call DGeWr(NVir, NVir, Dbl_MB(I_Scr1), NVir, 0, 0, LuOut,
c$$$     $         'T2 patch', 80, 'F20.15')
c$$$            Call DGeWr(NOcc, NVir, Omega2, LDO2, 0, 0, LUOut,
c$$$     $         'Partial Omega2', 80, 'F20.15')
c$$$C
         EndDo
      EndDo
C
C     Sum the partial results
C
      Call GA_DGop(Msg_CCDen_2, Omega2, LDO1*NVir, '+')
c$$$C
c$$$      Call DGeWr(NOcc, NVir, Omega1, LDO1, 0, 0, LUOut,
c$$$     $   'Summed Partial Omega2', 80, 'F20.15')
C
C     Add in the t1 t1 z1 terms
C
      Call dgemm('T', 'N', NVir, NVir, NOcc,
     $   FP_One, Z1, LDZ1, T1, LDT1,
     $   FP_Zero, Dbl_MB(I_Scr1), NVir)
c$$$C
c$$$      Call DGeWr(NVir, NVir, Dbl_MB(I_Scr1), NVir, 0, 0, LuOut,
c$$$     $   'Z(m,e) T(m,a)', 80, 'F20.15')
C
      Call dgemm('N', 'N', NOcc, NVir, NVir,
     $   FP_One, T1, LDT1, Dbl_MB(I_Scr1), NVir,
     $   FP_One, Omega2, LDO2)
c$$$C
c$$$      Call DGeWr(NOcc, NVir, Omega2, LDO1, 0, 0, LUOut,
c$$$     $   'Final Omega2', 80, 'F20.15')
C
C     **************************************************
C     * Omega3(a,b) = sum(m,n,e) t(m,n,a,e) z(m,n,b,e) *
C     * APR & TJL Eq. 54                               *
C     **************************************************
C
      If (.NOT. MA_Push_Get( MT_Dbl, NVir*NVir, 'CC Density scratch 2',
     $   H_Scr2, I_Scr2)) Call ErrQuit(
     $   'CCDen_Interm2: unable to allocate scratch', NVir*NVir, MA_ERR)
C
      Do M = T2_ILo, T2_IHi
         Do N = T2_JLo, T2_JHi
c$$$C
c$$$            If (oprint) Write (LuOut, *) GA_NodeID(), ': Omega3 (', M, ',', N, ')'
c$$$C
            Call GA_Get(g_T2, (M-1)*NVir+1, M*NVir, (N-1)*NVir+1,
     $         N*NVir, Dbl_MB(I_Scr1), NVir)
            Call GA_Get(g_Z2, (M-1)*NVir+1, M*NVir, (N-1)*NVir+1,
     $         N*NVir, Dbl_MB(I_Scr2), NVir)
            Call dgemm('N', 'T', NVir, NVir, NVir,
     $         FP_One, Dbl_MB(I_Scr1), NVir, Dbl_MB(I_Scr2), NVir,
     $         FP_One, Omega3, LDO3)
c$$$C
c$$$            Call DGeWr(NVir, NVir, Dbl_MB(I_Scr1), NVir, 0, 0, LuOut,
c$$$     $         'T2 patch', 80, 'F20.15')
c$$$            Call DGeWr(NVir, NVir, Dbl_MB(I_Scr2), NVir, 0, 0, LuOut,
c$$$     $         'Z2 patch', 80, 'F20.15')
c$$$            Call DGeWr(NVir, NVir, Omega3, LDO3, 0, 0, LUOut,
c$$$     $         'Partial Omega3', 80, 'F20.15')
c$$$C
         EndDo
      EndDo
C
      If (.NOT. MA_Pop_Stack( H_Scr2 ) ) Call ErrQuit(
     $   'CCDen_Interm2: unable to free scratch', 2, MA_ERR)
      If (.NOT. MA_Pop_Stack( H_Scr1 ) ) Call ErrQuit(
     $   'CCDen_Interm2: unable to free scratch', 1,
     &       MA_ERR)
C
C     Sum the partial results to complete Omega3
C
      Call GA_DGop(Msg_CCDen_3, Omega3, LDO3*NVir, '+')
c$$$C
c$$$      Call DGeWr(NVir, NVir, Omega3, LDO3, 0, 0, LUOut,
c$$$     $   'Final Omega3', 80, 'F20.15')
C
C     **************************************************
C     * Omega4(i,j) = sum(m,e,f) t(i,m,e,f) z(j,m,e,f) *
C     * APR & TJL Eq. 55                               *
C     **************************************************
C     This amounts to dot products between entire bands of t and z.
C
C     Using GA_DDot_Patch, each node computes its contribution
C     to the dot product and returns immediately, so the Omega4
C     we construct this way is must be summed over all nodes.
C
c     Call GA_Sync
      Do I = 1, NOcc
         Do J = 1, NOcc
            Omega4(i,j) = GA_DDot_Patch(
     $         g_T2, 'N', (I-1)*NVir+1, I*NVir, 1, NOcc*NVir,
     $         g_Z2, 'N', (J-1)*NVir+1, J*NVir, 1, NOcc*NVir)
c$$$C
c$$$            If (oprint) Write (LuOut, *) GA_NodeID(), ':Omega4 (', I, ',', J, ') =',
c$$$     $         Omega4(i,j)
c$$$C
         EndDo
      EndDo
c     Call GA_Sync
C
C     Sum the partial results to complete Omega4
C
c     Call GA_DGop(Msg_CCDen_4, Omega4, LDO4*NOcc, '+')
c$$$C
c$$$      Call DGeWr(NOcc, NOcc, Omega4, LDO4, 0, 0, LUOut,
c$$$     $   'Final Omega4', 80, 'F20.15')
C
      Return
      End
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C REVISION
C     $Id: ccden_interm2.F 20114 2011-03-20 06:11:15Z d3y133 $
C SYNOPSIS
      Subroutine CCSD_T2_MyIJ(Node, NVir, g_T2, ILo, IHi, JLo, JHi)
      Implicit NONE
      Integer Node, NVir
      Integer g_T2
      Integer ILo, IHi, JLo, JHi
C
C ARGUMENTS
C DESCRIPTION
C     Determines the range of i and j indices local to the specified
C     process for a T2-like global array of size NVir*NOcc x NVir*NOcc,
C     with the NVir dimension running fastest in both directions.
C
C     The range returned is such that the (ILo,JLo) block is the first
C     complete block for this process, and the lower and right edges
C     (IHi,JLo:JHi) and (ILo:IHi,JHi) reside partly (but not necessarily 
C     completely) on this process.
C
C     Consequently, the ranges returned by this routine are NOT
C     suitable for use with ga_access!
C
C INCLUDE FILES
#include "global.fh"
C
C EXTERNAL ROUTINES
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer IALo, IAHi, JBLo, JBHi
C
      Call GA_Distribution(G_T2, Node, IALo, IAHi, JBLo, JBHi)
C
      If ( IALo .eq. 0 .AND. IAHi .eq. -1) then
         ILo = 0
         IHi = -1
      Else
         ILo = IALo / NVir + 1 ! Lowest I that _starts_ on this proc.
         IHi = IAHi / NVir + 1 ! Must watch out for possible exact match
         If ( Mod(IAHi, NVir) .eq. 0) IHi = IHi - 1
      EndIf
C
      If ( JBLo .eq. 0 .AND. JBHi .eq. -1) then
         JLo = 0
         JHi = -1
      Else
         JLo = JBLo / NVir + 1 ! Lowest J that _starts_ on this proc.
         JHi = JBHi / NVir + 1 ! Must watch out for possible exact match
         If ( Mod(JBHi, NVir) .eq. 0) JHi = JHi - 1
      EndIf
C
      Return
      End

      subroutine tce_mrcc_create_cas(rtdb)
        implicit none
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_mrcc.fh"
#include "tce_main.fh"
#include "geom.fh"

        integer iactel,iactorb
        integer rtdb
ckbn gf -2      integer nodezero,nprocs
      logical nodezero
        character*4 irrepname
        integer i,j,irrep
c        integer nref,iref
        integer iref
        integer k,n
        integer id,ia,ib
        integer mrfactorial
        external mrfactorial
        integer itotal
        integer iacounts(maxorb)
        integer ibcounts(maxorb)
        integer iapos(maxorb+1)
        integer ibpos(maxorb+1)
        integer itotreal,idbocc(10240,maxorb)
        character*10240 s
        integer iactshift
        character*8 t1
        character*3 t2
        integer ic

        nodezero = (ga_nodeid().eq.0)

        t1 = 'bwcc:ref'

      if (.not.rtdb_get(rtdb,'mrcc:iactel',mt_int,1,iactel))
     2   call  errquit('tce_mrcc_cas',2,UNKNOWN_ERR)
      if (.not.rtdb_get(rtdb,'mrcc:iactorb',mt_int,1,iactorb))
     2    call  errquit('tce_mrcc_cas',3,UNKNOWN_ERR)

        if(nodezero) then

          write(LuOut,"(/,'Active elec :',I4)")iactel
          write(LuOut,"('Active orbs :',I4,/)")iactorb

          if(mod(iactel,2).eq.1)
     1 write(LuOut,"('Odd number of elec.',I4,/)")iactel/2

        endif

        itotal = 0

        do i=1,min(iactel/2,iactorb)
          id=iactel/2-i+1
          ia=i-1+mod(iactel,2)
          ib=i-1
          itotal = itotal +
     1 mrfactorial(iactorb)/(mrfactorial(id)*
     4 mrfactorial(ia)*mrfactorial(ib)*
     5 mrfactorial(iactorb-id-ia-ib))

c        if(nodezero)
c     1  write(LuOut,"('Category ',I5,I5,I5,' has ',I8,
c     2 ' possibilities')")id,ia,ib,
c     3 mrfactorial(iactorb)/(mrfactorial(id)*
c     4 mrfactorial(ia)*mrfactorial(ib)*
c     5 mrfactorial(iactorb-id-ia-ib))

        enddo


        do k=1,iactorb
            iacounts(k) = 0
            ibcounts(k) = 0
          if(k.le.id) then
            iacounts(k) = 1
            ibcounts(k) = 1
          else
           if(k.le.(id+ia)) iacounts(k) = 1
           if(k.le.(id+ib)) ibcounts(k) = 1
          endif
        enddo

        if(nodezero) then
          write(LuOut,"(/,'Alpha ',100I1)")(iacounts(k),k=1,iactorb)
          write(LuOut,"('Beta  ',100I1,/)")(ibcounts(k),k=1,iactorb)
        endif

        do k=1,id+ib
          ibpos(k) = k   
        enddo

          ibpos(id+ib+1) = iactorb+1

        itotreal = 0
 8746   continue

        do i=1,id+ib
             if(i.gt.1) then
               if(ibpos(id+ib-i+1).lt.(iactorb-i+1)) then
             ibpos(id+ib-i+1)=ibpos(id+ib-i+1)+1
                 do n=1,i-1
                   ibpos(id+ib-n+1)=ibpos(id+ib-i+1)+i-n
                 enddo
               goto 8746
               else
               goto 8745
               endif
             endif
         do k=ibpos(id+ib-i+1),ibpos(id+ib-i+2)
           if(k.eq.(ibpos(id+ib-i+2))) then
            if((ibpos(id+ib-i+1)+1).lt.(ibpos(id+ib-i+2))) then
             ibpos(id+ib-i+1)=ibpos(id+ib-i+1)+1
             if(i.gt.1) goto 8746
            endif
            goto 8745
           endif
           do n=1,iactorb
            ibcounts(n) = 0
           enddo
           do n=1,id+ib
            if(n.eq.(id+ib+1-i)) then
            ibcounts(k) = 1
            else
            ibcounts(ibpos(n)) = 1
            endif
           enddo
c           if(nodezero)write(LuOut,"(100I1)")(ibcounts(n),n=1,iactorb)
           itotreal = itotreal + 1
           do n=1,iactorb
             idbocc(itotreal,n)=ibcounts(n)
           enddo
         enddo
 8745    continue
        enddo

corg        if(ibpos(1).lt.(iactorb-id-ib)) goto 8746
         do i=1,(nocc(1)+nocc(2)-iactel)/2
           s(i:i)='2'
         enddo

         iactshift = (nocc(1)+nocc(2)-iactel)/2

c         write(6,*)iactshift,nocc(1),nocc(2)

         ic = 0

         do i=1,itotreal
           do k=1,itotreal
           irrep = 0
           do n=1,iactorb
             if((idbocc(i,n)+idbocc(k,n)).eq.2) then
               s(n+iactshift:n+iactshift)='2'
             elseif(idbocc(i,n).eq.1) then
               s(n+iactshift:n+iactshift)='a'
               irrep = ieor(irrep,int_mb(k_irs(1)+n+iactshift-1))
             elseif(idbocc(k,n).eq.1) then
               s(n+iactshift:n+iactshift)='b'
               irrep = ieor(irrep,int_mb(k_irs(2)+n+iactshift-1))
             else
               s(n+iactshift:n+iactshift)='0'
             endif
           enddo
           call sym_irrepname(geom,irrep+1,irrepname)
        if(targetsym.eq.irrepname) then

          ic = ic + 1

             if(nodezero)write(LuOut,*)s(1:iactorb+iactshift),' ',
     1 ic

      write(t2,"(I3.3)")ic
      if (.not.rtdb_cput(rtdb,t1//t2,1,s))
     1   call errquit('tce_mrcc_cas: failed writing to rtdb',0,
     2   RTDB_ERR)

           endif

           enddo
         enddo

        if(nodezero)
     1  write(LuOut,"(/,'Total no. of references:',I5,/)")ic

      if (.not.rtdb_put(rtdb,'bwcc:nref',mt_int,1,ic))
     1   call errquit('tce_mrcc_input: failed writing to rtdb',0,
     2   RTDB_ERR)

c       this routine has to be rewritten at some point

ckbn    check whether number of references go beyond maxref
        if(ic .gt. maxref)  then
        if(nodezero)  
     +   write(LuOut,'(A,I5,A,I5)') "Number of references: ",ic,
     +   " greater than maximum number of references: " , maxref
        if(nodezero) call util_flush(LuOut)
        call errquit('tce_mrcc_create_cas: nref > maxref',3,RTDB_ERR)
        endif

        return
        end

        integer function mrfactorial(input)
         implicit none
         integer input,res
         integer i

         res = 1
         do i=1,input
           res = res*i
         enddo

         mrfactorial = res

        end


c $Id: tce_mrcc_create_cas.F 24345 2013-06-22 06:19:30Z d3y133 $

      subroutine tce_zero(d_sf,size)
c
c $Id: tce_zero.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Zero scratch a file
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_sf
      integer size
      integer nblocks,blocksize
      integer l_temp,k_temp
      integer i,j,k
      logical nodezero
cc      integer nxtval 
      integer next, nprocs, count
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical noloadbalance
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_sf))))
      nblocks = size/buffer_size
      if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
      blocksize = size/nblocks
      if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
      if (nodezero.and.util_print('zero',print_debug)) then
        write(LuOut,9190) d_sf,size
        write(LuOut,9200) nblocks,blocksize
      endif
      if (ioalg.eq.2) then
        call ga_zero(d_sf)
      else if (ioalg.eq.5) then
        if (fileisga(d_sf)) then
          call ga_zero(filehandles(d_sf))
        else
          call dratoga(d_sf)
          call ga_zero(filehandles(d_sf))
          call gatodra(d_sf)
        endif
      else if ((ioalg.eq.6).and.fileisga(d_sf)) then
        call ga_zero(filehandles(d_sf))
      else
        if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1    l_temp,k_temp))
     2    call errquit('tce_zero: MA problem',0,MA_ERR)
        nprocs = GA_NNODES()
        count = 0
cc        next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
        do i = 1,nblocks
          if (noloadbalance.or.(next.eq.count)) then
            k = 0
            do j = (i-1)*blocksize+1,min(size,i*blocksize)
              k = k + 1
              dbl_mb(k_temp+k-1) = 0.0d0
            enddo
            if (util_print('zero',print_debug))
     1        write(LuOut,9210) ga_nodeid(),(i-1)*blocksize,
     2                          min(size,i*blocksize)-(i-1)*blocksize
            call put_block(d_sf,dbl_mb(k_temp),
     1        min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
cc            next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
cc        next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
        if (.not.ma_pop_stack(l_temp))
     1    call errquit('createfile: MA problem',1,MA_ERR)
        call ga_sync()
      endif
 9190 format(/,1x,'Zero scratch handle:',i10,' size:',i10)
 9200 format(  1x,'            nblocks:',i10,' size:',i10)
 9210 format(  1x,i3,'          offset:',i10,' size:',i10)
      return
      end















      subroutine tce_zero_sf(d_sf,size)
c
c $Id: tce_zero.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Zero scratch a file
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_sf
      integer size
      integer nblocks,blocksize
      integer l_temp,k_temp
      integer i,j,k
      logical nodezero
cc      integer nxtval 
      integer next, nprocs, count
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical noloadbalance
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = .false.
      nblocks = size/buffer_size
      if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
      blocksize = size/nblocks
      if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
      if (nodezero.and.util_print('zero',print_debug)) then
        write(LuOut,9190) d_sf,size
        write(LuOut,9200) nblocks,blocksize
      endif
c
c      else
c
        if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1    l_temp,k_temp))
     2    call errquit('tce_zero: MA problem',0,MA_ERR)
        nprocs = GA_NNODES()
        count = 0
cc        next = NXTVAL(nprocs)
        next = NXTASK(nprocs, 1)
        do i = 1,nblocks
          if (noloadbalance.or.(next.eq.count)) then
            k = 0
            do j = (i-1)*blocksize+1,min(size,i*blocksize)
              k = k + 1
              dbl_mb(k_temp+k-1) = 0.0d0
            enddo
            if (util_print('zero',print_debug))
     1        write(LuOut,9210) ga_nodeid(),(i-1)*blocksize,
     2                          min(size,i*blocksize)-(i-1)*blocksize
c
c            call put_block(d_sf,dbl_mb(k_temp),
c
            call put_block_sf(d_sf,dbl_mb(k_temp),
c
     1        min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
cc            next = NXTVAL(nprocs)
            next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
cc        next = NXTVAL(-nprocs)
        next = NXTASK(-nprocs, 1)
        if (.not.ma_pop_stack(l_temp))
     1    call errquit('createfile: MA problem',1,MA_ERR)
        call ga_sync()
c
c      endif
c
 9190 format(/,1x,'Zero scratch handle:',i10,' size:',i10)
 9200 format(  1x,'            nblocks:',i10,' size:',i10)
 9210 format(  1x,i3,'          offset:',i10,' size:',i10)
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      subroutine rdpar
#include "common.fh"
      double precision x,ran1
      integer i,j
      integer me
c
c    This subroutine reads in the molecular simulation parameters
c
      me = ga_nodeid()
      if (me.eq.0) open (unit=5,file='md_lj.in',status='old')
c
c     Line 1
c
c       nstep: total number of steps in simulation
c
c       tau: time step increment
c
c       nsc: number of special control steps
c
c       iseed: random number seed (this should be a NEGATIVE
c              integer)
c
      nstep = 0
      tau = 0.0d00
      nsc = 0
      iseed = 0
      if (me.eq.0) then
        read(5,*) nstep,tau,nsc,iseed
      endif
      call ga_igop(2,nstep,1,'+')
      call ga_dgop(3,tau,1,'+')
      call ga_igop(4,nsc,1,'+')
      call ga_igop(5,iseed,1,'+')
c
c     Line 2
c
c       rcut: cutoff for use in neighbor list calculation
c
c       ilist: number of steps taken before updating
c              neighbor list
c
c       icut: cutoff parameter for potential
c
c           (0) only potential set to zero at cutoff
c
c           (1) potential and forces set to zero at cutoff
c
      rcut = 0.0d00
      ilist = 0
      icut = 0
      if (me.eq.0) then
        read(5,*) rcut,ilist,icut
      endif
      call ga_dgop(6,rcut,1,'+')
      call ga_igop(7,ilist,1,'+')
      call ga_igop(8,icut,1,'+')
c
c     Line 3
c
c       dflalg: default algorithm
c
c            1: constant energy 3 point Gear algorithm
c            2: constant pressure algorithm
c            3: constant temperature algorithm (velocity scaling)
c            4: constant temperature algorithm (Nose' dynmamics)
c            5: constant pressure and temperature algorithm
c            6: Boltzmann velocity step
c            7: adjust volume to specified target volume
c               (available only as a special step)
c            8: adjust kinetic energy based on average temperature
c               since last call to this step so that temperature
c               matches target temperature.
c               (available only as a special step)
c            9: constant pressure and temperature algorithm with
c               independent box adjustments
c            10: constant pressure and temperature algorithm with
c               independent box adjustments in only the x and y
c               dimensions
c
c       dftmp: default temperature
c
c       dfprs: default pressure
c
c       dftm: default mass for temperature
c
c       dfpm: default mass for pressure
c
      dflalg = 0
      dftmp = 0.0d00
      dfprs = 0.0d00
      dftm = 0.0d00
      dfpm = 0.0d00
      if (me.eq.0) then
        read(5,*) dflalg,dftmp,dfprs,dftm,dfpm
      endif
      call ga_igop(9,dflalg,1,'+')
      call ga_dgop(1,dftmp,1,'+')
      call ga_dgop(2,dfprs,1,'+')
      call ga_dgop(3,dftm,1,'+')
      call ga_dgop(4,dfpm,1,'+')
c
c     Line 4.1 - 4.nsc
c
c     special step control instructions
c
c       isc(i,1): begining step for special instruction
c
c       isc(i,2): final step for special instruction
c
c       isc(i,3): increment for special instruction
c
c       isc(i,4): stepping algorithm for special instruction
c                 (see documentation on dflalg)
c
c       rsc(i,1): temperature (in K) if temperature scaling or
c                 Boltzmann algorithm is specified
c
c       rsc(i,2): pressure if constant pressure
c                 algorithms are specified. If volume adjustment
c                 algorithm is specified then this is the target
c                 volume in A**3.
c
c       rsc(i,3): mass (in g A**2 /mole) for Nose temperature
c                 algorithm
c
c       rsc(i,4): mass (in g/(mole A**4)) for constant pressure
c                 algorithm
c
      do 100 i=1,nsc
        do j=1,4 
          isc(i,j) = 0.0d00
          rsc(i,j) = 0.0d00
        end do
        if (me.eq.0) then
          read(5,*) (isc(i,j),j=1,4),(rsc(i,j),j=1,4)
        endif
        do j=1,4 
          call ga_igop(4,isc(i,j),1,'+')
          call ga_dgop(5,rsc(i,j),1,'+')
        end do
  100 continue
c
c     Line 5
c
c       istart: startup format
c               1: start from single configuration
c               2: start from configuration plus velocity
c
c       istop: write-out format
c               1: single configuration
c               2: configuration plus velocity
c
      istart = 0
      istop = 0
      if (me.eq.0) then
        read(5,*) istart,istop
      endif
      call ga_igop(6,istart,1,'+')
      call ga_igop(7,istop,1,'+')
c
c     Line 6
c
c     istat: frequency to print out simulation information 
c
      istat = 0
      if (me.eq.0) then
        read(5,*) istat
      endif
      call ga_igop(8,istat,1,'+')
c
c     Line 7
c
c     equil_1: number of steps in first equilibration regime
c
c     equil_2: number of steps in second equilibration regime
c
c     equil_3: number of steps in third equilibration regime
c
      equil_1 = 0
      equil_2 = 0
      equil_3 = 0
      if (me.eq.0) then
        read(5,*) equil_1, equil_2, equil_3
      endif
      call ga_igop(9,equil_1,1,'+')
      call ga_igop(1,equil_2,1,'+')
      call ga_igop(2,equil_3,1,'+')
      window_1 = int(0.2d00*dble(equil_3-equil_2))
      window_1 = equil_2 + window_1
      window_2 = int(0.4d00*dble(equil_3-equil_2))
      window_2 = window_1 + window_2
c
c     Line 7
c
c     cl_prssr: pressure that is applied to cluster
c
c     mc_tmprtr: temperature used in Monte Carlo steps
c
      cl_prssr = 0.0d00
      mc_tmprtr = 0.0d00
      if (me.eq.0) then
        read(5,*) cl_prssr, mc_tmprtr
      endif
      call ga_dgop(3,cl_prssr,1,'+')
      call ga_dgop(4,mc_tmprtr,1,'+')
c
c     Line 8
c
c     mcfreq: frequency to apply Monte Carlo step on radius
c
c     mcbins: number of bins to accumulate radius in
c
      mcfreq = 0
      mcbins = 0
      if (me.eq.0) then
        read(5,*) mcfreq, mcbins
      endif
      call ga_igop(7,mcfreq,1,'+')
      call ga_igop(8,mcbins,1,'+')
c
      if (me.eq.0) close(5)
c
c    Write out simulation information to output file
c
      if (me.eq.0.and.l_stdio) then
        write(6,1300) nstep
        write(6,1400) 1000.0 * tau
        write(6,4325) rcut
        write(6,4350) ilist
        if (icut.eq.0) then
          write(6,4400)
        else
          write(6,4420)
        endif
        write(6,1500) dflalg
        write(6,1600)
        write(6,1700) dftmp
        write(6,1800) dfprs
        write(6,1900) dftm
        write(6,2000) dfpm
        write(6,2100)
        do 300 i = 1, nsc
          if (i.eq.1) then
             write(6,2200)
          else
             if (isc(i-1,4).eq.7) write(6,2200)
          endif
          if (isc(i,4).ne.7) then
            write(6,2300) (isc(i,j),j=1,4),(rsc(i,j),j=1,4)
          else
            write(6,2400) 
            write(6,2500) (isc(i,j),j=1,4)
            write(6,2600) rsc(i,1)
            write(6,2700) rsc(i,2)
          endif
  300   continue
        write(6,3400) istat
        write(6,3800) mcfreq
        write(6,3500) equil_1
        write(6,3600) equil_2
        write(6,3700) equil_3
        if (istart.eq.1) then
          write(6,2800)
        else
          write(6,2900)
        endif
        if (istop.eq.1) then
          write(6,3000)
        else
          write(6,3100)
        endif
        write(6,3200) iseed
        write(6,4500) ga_pgroup_nodeid(ga_pgroup_get_world())
      endif
      iseed = iseed - 10*me
      x = ran1(iseed)
      r_cluster = 0.0d00
      mc_cnt = 0
c
      return
 1300 format('Total number of steps in simulation                :',i9)
 1400 format('Time step interval                                 :'
     +       ,f16.6)
 1500 format('Default algorithm                                  :',i9)
 1600 format('     Default algorithm parameters ')
 1700 format('        Default temperature                        :'
     +       ,f16.6)
 1800 format('        Default pressure                           :'
     +       ,f16.6)
 1900 format('        Default temperature mass                   :'
     +       ,f16.6)
 2000 format('        Default pressure mass                      :'
     +       ,f16.6)
 2100 format('Special step instructions:')
 2200 format('   begin     end  incrmt algrthm    T       P      ',
     +'T mass  P mass  ')
 2300 format(4i8,2f8.3,1pe9.2,1pe9.2)
 2400 format('   begin     end  incrmt algrthm')
 2500 format(4i8)
 2600 format('     Temperature for volume adjustment             :'
     +       ,f16.6)
 2700 format('     Target volume for volume adjustment           :'
     +       ,f16.6)
 2800 format('Initial configuration is coordinates only')
 2900 format('Initial configuration is coordinates and velocities')
 3000 format('Final configuration is coordinates only')
 3100 format('Final configuration is coordinates and velocities')
 3200 format('Random number seed                                 :',i9)
 3400 format('Frequency to print out simulation information      :',i9)
 3500 format('Number of steps in first equilibration regime      :',i9)
 3600 format('Number of steps in second equilibration regime     :',i9)
 3700 format('Number of steps in third equilibration regime      :',i9)
 3800 format('Frequency to take Monte Carlo step                 :',i9)
 4325 format('Cutoff distance                                    :',
     +       f16.6)
 4350 format('Neighbor list update frequency                     :',i9)
 4400 format('Potential set to zero at cutoff distance')
 4420 format('Potential and forces set to zero at cutoff distance')
 4500 format('Writing from node                                  :',i9)
      end
c
      subroutine rdcfg
#include "common.fh"
c
      double precision scl,gasdev
      integer inode,icnt,i,j,k,pnum,ilast,ifirst,me
      character*32 filename
c
c   This subroutine reads in the initial coordinates of all atoms in
c   the system. First determine which coordinates each processor
c   should read.
c
      me = ga_nodeid()
      pnum = ga_nnodes()
c
c  clean up everything
c
      atot = 0
      ctot = 0
      antot = 0
      do k = 1, 8
        do j = 1, 3
          do i = 1, MAXAT
            ra(i,j,k) = 0.0d00
          end do
        end do
      end do
      do i = 1, MAXAT
        mass(i) = 0.0d00
        at(i) = 0
        aidx(i) = 0
c
        xcrd(i) = 0.0d00
        ycrd(i) = 0.0d00
        zcrd(i) = 0.0d00
        xfrc(i) = 0.0d00
        yfrc(i) = 0.0d00
        zfrc(i) = 0.0d00
        xacc(i) = 0.0d00
        yacc(i) = 0.0d00
        zacc(i) = 0.0d00
        mbuf(i) = 0.0d00
        bat(i) = 0
        bidx(i) = 0
      end do
      btot = 0
c
      if (task_id.lt.10) then
        write(filename,100) task_id
      else if (task_id.ge.10.and.task_id.lt.100) then
        write(filename,101) task_id
      else if (task_id.ge.100.and.task_id.lt.1000) then
        write(filename,102) task_id
      else if (task_id.ge.1000.and.task_id.lt.10000) then
        write(filename,103) task_id
      endif
  100 format('md.cfg',i1)
  101 format('md.cfg',i2)
  102 format('md.cfg',i3)
  103 format('md.cfg',i4)
      atot = 0
      if (me.eq.0) then
        open (unit=2,file=filename,status='old')
        read(2,*) atot
        close(2)
      endif
      call ga_igop(5,atot,1,'+')
      ilast = nint(dble((me+1)*atot)/dble(pnum))
      ifirst = nint(dble(me*atot)/dble(pnum))
      ifirst = ifirst + 1
c
c   read in portions of MD configuration on each node
c
      do inode = 0, pnum - 1
        call ga_sync()
        if (me.eq.inode) then
          open (unit=2,file=filename,status='old')
c
          read(2,*) atot
          read(2,*) xbox,ybox,zbox
          xbox2 = xbox/2.0d00
          ybox2 = ybox/2.0d00
          zbox2 = zbox/2.0d00
c
          cl_lower = 0.0d00
          if (xbox.lt.ybox.and.xbox.lt.zbox) then
            cl_upper = xbox2
          else if (ybox.lt.xbox.and.ybox.lt.zbox) then
            cl_upper = ybox2
          else
            cl_upper = zbox2
          endif
          mc_step = (cl_upper-cl_lower)/dble(mcbins)
c
          icnt = 0
          if (istart.eq.1.or.(.not.l_oldcfg)) then
            do i = 1, ilast
              if (i.lt.ifirst) then
                read(2,*)
              else
                icnt = icnt + 1
                read(2,*) at(icnt),(ra(icnt,j,1),j=1,3)
                if (at(icnt).eq.2) ctot = ctot + 1
c
c    generate atomic velocities from a Maxwell-Boltzmann distribution
c
                do j = 1, 3
                  scl = sqrt(dftmp / amass(at(icnt)))
                  ra(icnt,j,2) = scl * gasdev(0)
                end do
                aidx(icnt) = i
              endif
            end do
          else
            do i = 1, ilast
              if (i.lt.ifirst) then
                read(2,*)
              else
                icnt = icnt + 1
                read(2,*) at(icnt),(ra(icnt,j,1),j=1,3),
     +                    (ra(icnt,j,2),j=1,3)
                if (at(icnt).eq.2) ctot = ctot + 1
                aidx(icnt) = i
              endif
            end do
          endif
          close(2)
        endif
      end do
      antot = icnt
      call ga_igop(9,ctot,1,'+')
c
      if (me.eq.0.and.l_stdio) then
        write(6,1100) atot
        write(6,1000) xbox,ybox,zbox
      endif
c
c   initialize absolute coordinates
c
      do j = 1, 3
        do i = 1, antot
          ra(i,j,6) = ra(i,j,1)
        end do
      end do
c
      call fixper
c
      return
 1000 format('The initial box size parameters are '/
     +       '      x dimension = ',f9.4,' A'/
     +       '      y dimension = ',f9.4,' A'/
     +       '      z dimension = ',f9.4,' A') 
 1100 format('The total number of atoms in simulation            :',i9)
      end
c
      subroutine atomin
#include "common.fh"
c
      double precision epsln,sigma
      integer i,j,ipairs,ip,ktrnc
      integer me
      logical ichk(50,50)
c
c    This subroutine reads in atomic parameters from a parameter
c    file. These parameters will be used to construct the
c    system potential function.
c
      me = ga_nodeid()
      do i = 1, 50
        do j = 1, 50
          ichk(i,j) = .false.
        end do
      end do
c
      if (me.eq.0) then
        open(unit=2,file='atom.inp',status='old')
      endif
c
      if (me.eq.0) then
        read (2,*) amass(1)
        read (2,*) amass(2)
        read (2,*) amass(3)
        read (2,*) amass(4)
        atnum = 4
      else
        amass(1) = 0.0d00
        amass(2) = 0.0d00
        amass(3) = 0.0d00
        amass(4) = 0.0d00
        atnum = 0
      endif
      call ga_dgop(1,amass(1),4,'+')
      call ga_igop(2,atnum,1,'+')
c
c   read in atomic parameters
c
      if (me.eq.0) then
        read(2,*) ipairs
      else
        ipairs = 0
      endif
      call ga_igop(3,ipairs,1,'+')
c
      do 100 ip = 1, ipairs
        i = 0
        j = 0
        ktrnc = 0
        epsln = 0.0d00
        sigma = 0.0d00
        if (me.eq.0) then
          read (2,*) i,j,ktrnc,epsln,sigma
        endif
        call ga_igop(1,i,1,'+')
        call ga_igop(2,j,1,'+')
        call ga_igop(3,ktrnc,1,'+')
        call ga_dgop(4,epsln,1,'+')
        call ga_dgop(5,sigma,1,'+')
        ichk(i,j) = .true.
        if (i.ne.j) ichk(j,i) = .true.
        e12(i,j) = 4.0d00*epsln*sigma**12
        e6(i,j) = 4.0d00*epsln*sigma**6
        if (i.ne.j) e12(j,i) = e12(i,j)
        if (i.ne.j) e6(j,i) = e6(i,j)
        if (ktrnc.eq.1) then
          acut(i,j) = exp(log(2.0d00)/6.0d00)*sigma
          acut(j,i) = exp(log(2.0d00)/6.0d00)*sigma
        else
          acut(i,j) = rcut * sigma
          acut(j,i) = rcut * sigma
        endif
        acut2(i,j) = acut(i,j)**2
        acut2(j,i) = acut(j,i)**2
  100 continue
c
      if (me.eq.0) close(2)
      return
      end

c +++++++++++   ga_lkain_ext() ++++++++++++ START
c Note.- Useful for AOresponse calculations (FA-12-10-12)
      subroutine ga_lkain_ext(
     &               rtdb,
     &               g_x, 
     &               g_b, 
     &               product, 
     &               precond, 
     $               tol, 
     &               mmaxsub, 
     &               maxiter, 
     &               odiff, 
     &               oprint)
c
c Note.- Modified from original aoresponse source code
c        for extension to spin-unrestricted case
c        original aoresponse source code was written by 
c        J. Autschbach et.al. and appears on nwchem-devtrunk (date:03-02-12)
c Author of changes: Fredy W. Aquino, Northwestern University
c Date             : 03-15-12
c --> Experimental (not published yet)

      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
#include "rtdb.fh"

      integer g_x               ! [input/output] Initial guess/solution
      integer g_b               ! [input] Right-hand side vectors
      external product          ! [input] product routine
      external precond          ! [input] preconditioner routine
      double precision tol      ! [input] convergence threshold
      integer mmaxsub           ! [input] maximum subspace dimension
      integer maxiter           ! [input] maximum no. of iterations
      logical odiff             ! [input] use differences in product
      logical oprint            ! [input] print flag
      integer rtdb
      logical debug
      external ga_svd_solve_seq
c
c     Solves the linear equations A(X)=0 for multiple vectors.
c
c     call product(acc,g_x, g_Ax)
c     . acc is the accuracy trequired for each element of the product
c     . g_x contains the vectors and g_Ax should be filled
c     .     with the product vectors.  The no. of vectors (columns) in
c     . g_x might differ from the no. of vectors input to ga_lkain().
c
c     call precond(g_x,shift)
c     . apply preconditioning directly to the vectors in g_x with the
c     . optional shift (not used here but used by the diagonalizer)
c
c     On input g_x should contain an initial guess.  It returns the
c     solution.
c
c     maxsub should be at least 3*nvec and can be beneficially increased
c     to about 10*nvec.
c
c     Needs to be extended to store the sub-space vectors out-of-core
c     at least while the product() routine is being executed.

      integer iter, n, nvec, nsub, isub, type, maxsub
      integer g_y, g_Ay, g_Ax, g_r, g_a, g_bb, g_c, g_xold, g_Axold
      double precision factor_x
      double precision rmax, acc, ga_svd_tol
      logical converged
      logical odebug
      debug=.false. ! FA-added4debugging

c      debug=.true.

      odebug = util_print('debug lsolve', print_never) .and. 
     $     ga_nodeid().eq.0
      if (.not.rtdb_get(rtdb,'cphf:acc',mt_dbl,1,acc)) acc=0.01d0*tol
      call ga_inquire(g_x, type, n, nvec)
      maxsub = mmaxsub          ! So don't modify input scalar arg
      if (maxsub .lt. 3*nvec) maxsub = 3*nvec
      maxsub = (maxsub/nvec)*nvec

      if (.not.rtdb_get(rtdb,'cphf:ga_svd_tol',mt_dbl,1,
     &                  ga_svd_tol)) then
c       See comment just before the ga_svd_solve_seq call to
c       understand these choices.
        if ((100*maxsub).lt.n) then
          ga_svd_tol = 1d-7
        else
          ga_svd_tol = 1d-14
        endif 
      endif

      if (oprint .and. ga_nodeid().eq.0) then
         write(6,1) n, nvec, maxsub, maxiter, tol, util_wallsec()
 1       format(//,'Iterative solution of linear equations',/,
     $        '  No. of variables', i9,/,
     $        '  No. of equations', i9,/,
     $        '  Maximum subspace', i9,/,
     $        '        Iterations', i9,/,
     $        '       Convergence', 1p,d9.1,/,
     $        '        Start time', 0p,f9.1,/)
         call util_flush(6)
      end if

      if (.not. ga_create(MT_DBL, n, maxsub, 'lkain: Y', 
     $     0, 0, g_y))
     $     call errquit('lkain: failed allocating subspace', maxsub,
     &       GA_ERR)
      if (.not. ga_create(MT_DBL, n, maxsub, 'lkain: Ay', 
     $     0, 0, g_Ay))
     $     call errquit('lkain: failed allocating subspace2', maxsub,
     &       GA_ERR)
      if (.not. ga_create(MT_DBL, n, nvec, 'lkain: Ax',
     $     0, 0, g_Ax))
     $     call errquit('lkain: failed allocating subspace3', nvec,
     &       GA_ERR)
      if (.not. ga_create(MT_DBL, n, nvec, 'lkain: r',
     $     0, 0, g_r))
     $     call errquit('lkain: failed allocating subspace4', nvec,
     &       GA_ERR)
      if (odiff) then
         if (.not. ga_create(MT_DBL, n, nvec, 'lkain: xold',
     $        0, 0, g_xold))
     $        call errquit('lkain: failed allocating subspace5', nvec,
     &       GA_ERR)
         if (.not. ga_create(MT_DBL, n, nvec, 'lkain: xold',
     $        0, 0, g_Axold))
     $        call errquit('lkain: failed allocating subspace6', nvec,
     &       GA_ERR)
         call ga_zero(g_xold)
         call ga_zero(g_Axold)
      end if
      call ga_zero(g_y)
      call ga_zero(g_Ay)
      call ga_zero(g_Ax)
      call ga_zero(g_r)

      if (oprint .and. ga_nodeid().eq.0) then
         write(6,2)
         call util_flush(6)
 2       format(/
     $        '   iter   nsub   residual    time',/,
     $        '   ----  ------  --------  ---------')
      end if
      nsub = 0
      converged = .false.
          if (debug) then  
           if (ga_nodeid().eq.0)
     &      write(*,*) '---- g_x guess-------- START'
            call ga_print(g_x)
           if (ga_nodeid().eq.0)
     &      write(*,*) '---- g_x guess--------  END'
          endif ! end-if-debug

      do iter = 1, maxiter
         if (odiff) then
            call ga_add(1.0d0, g_x, -1.0d0, g_xold,  g_x)
         end if
c ======== visualize input to product ============ START
          if (debug) then
             if (ga_nodeid().eq.0) then
              write(*,112) iter
 112          format('------ prod-g_x-1(',i3,')------ START')
             endif
             call ga_print(g_x)
             if (ga_nodeid().eq.0) then
              write(*,113) iter
 113          format('------ prod-g_x-1(',i3,')------ END')
             endif
             if (ga_nodeid().eq.0) then
              write(*,114) iter
 114          format('------ prod-g_Ax-1(',i3,')------ START')
             endif
             call ga_print(g_Ax)
             if (ga_nodeid().eq.0) then
              write(*,115) iter
 115          format('------ prod-g_Ax-1(',i3,')------ END')
             endif
          endif ! end-if-debug
c ======== visualize input to product ============ END

         call product(acc,g_x, g_Ax)
          
c ======== visualize output to product ============ START
          if (debug) then
             if (ga_nodeid().eq.0) then
              write(*,116) iter
 116          format('------ prod-g_x-2(',i3,')------ START')
             endif
             call ga_print(g_x)
             if (ga_nodeid().eq.0) then
              write(*,117) iter
 117          format('------ prod-g_x-2(',i3,')------ END')
             endif
             if (ga_nodeid().eq.0) then
              write(*,118) iter
 118          format('------ prod-g_Ax-2(',i3,')------ START')
             endif
             call ga_print(g_Ax)
             if (ga_nodeid().eq.0) then
              write(*,119) iter
 119          format('------ prod-g_Ax-2(',i3,')------ END')
             endif
          endif ! end-if-debug
c ======== visualize output to product ============ END

         if (odiff) then
            call ga_add(1.0d0, g_Ax, 1.0d0, g_Axold, g_Ax)
            call ga_add(1.0d0, g_x,  1.0d0, g_xold,  g_x)
            call ga_copy(g_x, g_xold)
            call ga_copy(g_Ax, g_Axold)
         end if
          call ga_zero(g_r)
          call ga_add_patch( 1.0d0,g_b ,1,n,1,nvec, 
     $                      -1.0d0,g_Ax,1,n,1,nvec,
     $                             g_r ,1,n,1,nvec) ! The residual

         if (debug) then  
             if (ga_nodeid().eq.0) then
              write(*,120) iter
 120          format('------ prod-g_b(',i3,')------ START')
             endif
             call ga_print(g_b)
             if (ga_nodeid().eq.0) then
              write(*,121) iter
 121          format('------ prod-g_b(',i3,')------ END')
             endif
             if (ga_nodeid().eq.0) then
              write(*,122) iter
 122          format('------ prod-g_r(',i3,')------ START')
             endif
             call ga_print(g_r)
             if (ga_nodeid().eq.0) then
              write(*,123) iter
 123          format('------ prod-g_r(',i3,')------ END')
             endif
         endif ! end-if-debug

         call ga_maxelt(g_r, rmax)
         if (oprint .and. ga_nodeid().eq.0) then
            write(6,3) iter, nsub+nvec, rmax, util_wallsec()
            call util_flush(6)
 3          format(' ', i5, i7, 3x,1p,d9.2,0p,f10.1)
         end if
         if (rmax .lt. tol) then
            converged = .true.
           if (debug) then
             if (ga_nodeid().eq.0)
     &       write(*,*) 'Convergence achieved !'           
             if (ga_nodeid().eq.0)
     &       write(*,*) '---- g_xsol-------- START'
             call ga_print(g_x)
             if (ga_nodeid().eq.0)
     &       write(*,*) '---- g_xsol--------  END'
           endif ! end-if-debug
            goto 100
         end if
         call precond(g_Ax,0.0d0)
         call precond(g_r,0.0d0)
c
c     Copy the vectors to the subspace work area

         call ga_copy_patch('n', 
     $        g_Ax, 1, n, 1, nvec, 
     $        g_Ay, 1, n, nsub+1, nsub+nvec)
         call ga_copy_patch('n', 
     $        g_x, 1, n, 1, nvec, 
     $        g_y, 1, n, nsub+1, nsub+nvec)
         nsub = nsub + nvec
c
c     Form and solve the subspace equations using SVD in order
c     to manage near linear dependence in the subspace.
c     
         if (.not. ga_create(MT_DBL, nsub, nsub, 'lkain: A', 0, 0, g_a))
     $        call errquit('lkain: allocating g_a?', nsub, GA_ERR)
         if (.not. ga_create(MT_DBL, nsub, nvec, 'lkain: B', 0, 0,g_bb))
     $        call errquit('lkain: allocating g_bb?', nsub, GA_ERR)
         if (.not. ga_create(MT_DBL, nsub, nvec, 'lkain: C', 0, 0, g_c))
     $        call errquit('lkain: allocating g_c?', nsub, GA_ERR)
         call ga_zero(g_a)
         call ga_zero(g_bb)
         call ga_zero(g_c)
         call ga_dgemm('t','n',nsub,nsub,n,1.0d0,g_y,g_Ay,0.0d0,g_a)
         call ga_dgemm('t','n',nsub,nvec,n,1.0d0,g_y,g_r ,0.0d0,g_bb)
         if (odebug) call ga_print(g_a)
         if (odebug) call ga_print(g_c)
c
c     The threshold used here should reflect the accuracy in the
c     products.  If very accurate products are used, then there is big
c     advantage for small cases (maxsub close to n) in using a very
c     small threshold in the SVD solve (e.g., 1e-14), but for more
c     realistic examcall ga_sync() ! FA-added 08-13-12ples (maxsub << n) there is only a little
c     advantage and in the precence of real noise in the products
c     screening with a realistic threshold is important.

         call ga_svd_solve_seq(g_a,g_bb,g_c,ga_svd_tol)

         if (odebug) call ga_print(g_c)
c
c     Form and add the correction, in parts, onto the solution
         call ga_dgemm('n','n',n,nvec,nsub,-1.0d0,g_Ay,g_c,1.0d0,g_r)
         if (odebug) then
            write(6,*) ' The update in the complement '
            call ga_print(g_r)
         end if
         call ga_add(1.0d0, g_r, 1.0d0, g_x, g_x)
         call ga_dgemm('n','n',n,nvec,nsub,1.0d0,g_y,g_c,0.0d0,g_r)
         if (odebug) then
            write(6,*) ' The update in the subspace '
            call ga_print(g_r)
         end if
         call ga_add(1.0d0, g_r, 1.0d0, g_x, g_x)
         if (.not. ga_destroy(g_a)) call errquit('lkain: a',0, GA_ERR)
         if (.not. ga_destroy(g_bb))call errquit('lkain: b',0, GA_ERR)
         if (.not. ga_destroy(g_c)) call errquit('lkain: c',0, GA_ERR)

c     Reduce the subspace as necessary
         if (nsub .eq. maxsub) then
          do isub = nvec+1, maxsub, nvec
            call ga_copy_patch('n',g_Ay,1,n,isub,isub+nvec-1, 
     $                             g_Ay,1,n,isub-nvec,isub-1)
            call ga_copy_patch('n',g_y ,1,n,isub,isub+nvec-1, 
     $                             g_y ,1,n,isub-nvec,isub-1)
          end do
          nsub = nsub - nvec
         end if
      enddo                    ! iter = 1,maxiter
 100  continue

      if (odiff) then
         if (.not. ga_destroy(g_xold)) call errquit('lkain: destroy',1,
     &       GA_ERR)
         if (.not. ga_destroy(g_Axold)) call errquit('lkain: destroy',2,
     &       GA_ERR)
      end if
      if (.not. ga_destroy(g_Ax)) call errquit('lkain: destroy',20,
     &       GA_ERR)
      if (.not. ga_destroy(g_Ay)) call errquit('lkain: destroy',3,
     &       GA_ERR)
      if (.not. ga_destroy(g_y)) call errquit('lkain: destroy',4,
     &       GA_ERR)
      if (.not. ga_destroy(g_r)) call errquit('lkain: destroy',5,
     &       GA_ERR)

      if (.not. converged) call errquit('lkain: not converged',0,
     &       CALC_ERR)

      end
c +++++++++++   ga_lkain_ext() ++++++++++++ END
c $Id: ga_lkain_ext.F 24349 2013-06-23 04:30:58Z d3y133 $

      logical function argos_prepare_sgmnum(lfnout,
     + lseq,cseq,mseq,nseq,nsgm)
c
c $Id: argos_prepare_sgmnum.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to scan database for unique segments in sequence
c
c     in  : filnam    = dbase file name
c           lfnout    = output file logical file number
c           lseq(1,*) = sequence segment numbers
c           cseq(2,*) = sequence segment names
c           mseq      = dimension of the sequence list
c           nseq      = length of sequence list
c
c     out : lseq(2,*) = index to segment list
c
      implicit none
c
#include "util.fh"
c
      integer lfnout,mseq,nseq,nsgm
      integer lseq(6,mseq)
      character*5 cseq(2,mseq)
c
      integer i,j
c
      if(util_print('sequence',print_high)) then
      write(lfnout,2000)
 2000 format(/,' Unique segments  ',/)
      endif
c
      nsgm=0
      do 1 i=1,nseq
      do 2 j=1,i-1
      if(cseq(2,i).eq.cseq(2,j)) then
      lseq(2,i)=lseq(2,j)
      goto 1
      endif
    2 continue
      nsgm=nsgm+1
      lseq(2,i)=nsgm
      if(util_print('sequence',print_high)) then
      write(lfnout,2001) lseq(2,i),cseq(2,i)
 2001 format(i5,2x,a)
      endif
    1 continue
c
      argos_prepare_sgmnum=.true.
      return
      end

* $Id: c_geodesic.F 25318 2014-03-11 17:49:04Z bylaska $
*


*     ***********************************
*     *			                *
*     *		c_geodesic_init	        *
*     *					*
*     ***********************************
*
*     Uses - c_geodesic common block
*

      subroutine c_geodesic_init()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"

*     **** local variables ****
      integer npack1,neall,nemax,nbrillq

*     **** external functions **** 
      integer  cpsi_ne,cpsi_neq,cpsi_nbrillq,Pneb_w_size
      integer  cpsi_data_alloc
      external cpsi_ne,cpsi_neq,cpsi_nbrillq,Pneb_w_size
      external cpsi_data_alloc

      call Cram_max_npack(npack1)
      neall  = cpsi_neq(1)+cpsi_neq(2)
      nemax  = cpsi_ne(1)+cpsi_ne(2)
      nbrillq = cpsi_nbrillq()
      
      U_tag  = cpsi_data_alloc(nbrillq,neall,2*npack1)
      Vt_tag = cpsi_data_alloc(nbrillq,1,2*Pneb_w_size(0,1))
      S_tag  = cpsi_data_alloc(nbrillq,nemax,1)
      return
      end

*     ***********************************
*     *					*
*     *		c_geodesic_finalize	*
*     *					*
*     ***********************************
*
*     Uses - c_geodesic common block
*
      subroutine c_geodesic_finalize()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"


      call cpsi_data_dealloc(U_tag)
      call cpsi_data_dealloc(Vt_tag)
      call cpsi_data_dealloc(S_tag)
      return
      end



*     ***********************************
*     *					*
*     *		c_geodesic_start        *
*     *					*
*     ***********************************
*
*     Uses - c_geodesic common block
*

      subroutine c_geodesic_start(A_tag,max_sigma,dE)
      implicit none
      integer A_tag
      real*8  max_sigma,dE

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"

*     **** local variables ****
      integer nb,i,nbrillq,neall,npack1
      integer ashift,ushift,sshift,vshift,vtshift,V_tag
      real*8 tmp
      
*     **** external functions **** 
      integer  cpsi_nbrillq,cpsi_neq,Pneb_w_size
      integer  cpsi_data_push_stack,cpsi_data_get_chnk
      real*8   c_electron_eorbit
      external cpsi_nbrillq,cpsi_neq,Pneb_w_size
      external cpsi_data_push_stack,cpsi_data_get_chnk
      external c_electron_eorbit


      call nwpw_timing_start(10)   

      call Cram_max_npack(npack1)
      nbrillq = cpsi_nbrillq()
      neall   = cpsi_neq(1)+cpsi_neq(2)

*     **** allocate tmp space ****
      V_tag = cpsi_data_push_stack(nbrillq,1,2*Pneb_w_size(0,1))

      max_sigma = -1.0d200
      do nb=1,nbrillq 
         ashift  = cpsi_data_get_chnk(A_tag,nb)
         ushift  = cpsi_data_get_chnk(U_tag,nb)
         vshift  = cpsi_data_get_chnk(V_tag,nb)
         sshift  = cpsi_data_get_chnk(S_tag,nb)
         vtshift = cpsi_data_get_chnk(Vt_tag,nb)

*        **** HomeGrown SVD ****
         call Pneb_SVD(0,nb,npack1, 
     >              dbl_mb(ashift),
     >              dbl_mb(ushift),
     >              dbl_mb(sshift),
     >              dbl_mb(vshift) )

*        **** calculate Vt ****
         call Pneb_w_copy_dagger(0,nb,dbl_mb(vshift),dbl_mb(vtshift))

*        **** find max_sigma ****
         do i=1,neall
            tmp=dabs(dbl_mb(sshift))
            if (tmp.gt.max_sigma) max_sigma=tmp
            sshift=sshift+1
         end do

      end do
      call K1dB_MaxAll(max_sigma)

*     **** calculate 2*<A|H|psi> ****
      dE = 2.0d0*c_electron_eorbit(A_tag)
       
*     **** deallocate tmp space ****     
      call cpsi_data_pop_stack(V_tag)
     
      call nwpw_timing_end(10)
      return
      end



*     *******************************
*     *		            	    *
*     *		c_geodesic_get	    *
*     *			            *
*     *******************************
*
*     Uses - c_geodesic common block
*

      subroutine c_geodesic_get(t,Yold_tag,Ynew_tag)
      implicit none
      real*8     t
      integer    Yold_tag
      integer    Ynew_tag

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"

*     **** local variables ****
      complex*16 zero,one
      parameter (zero=(0.0d0,0.0d0), one=(1.0d0,0.0d0))

      logical value
      integer nb,npack1,nemax,nbrillq
      integer tmp1(2),tmp2(2),tmp3(2),tmpC(2),tmpS(2)
      integer yoldshift,ynewshift,ushift,sshift,vtshift


*     **** external functions ****
      logical  Pneb_w_push_get,Pneb_w_pop_stack
      integer  cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk
      external Pneb_w_push_get,Pneb_w_pop_stack
      external cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk
 
      call nwpw_timing_start(10)
      call Cram_max_npack(npack1)
      nemax   = cpsi_ne(1)+cpsi_ne(2)
      nbrillq = cpsi_nbrillq()

*     **** allocate tmp space ****
      value =           Pneb_w_push_get(0,1,tmp1)
      value = value.and.Pneb_w_push_get(0,1,tmp2)
      value = value.and.Pneb_w_push_get(0,1,tmp3)
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpC',tmpC(2),tmpC(1))
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpS',tmpS(2),tmpS(1))
      if (.not. value) 
     > call errquit('c_geodesic_get: out of stack memory',0,MA_ERR)

      do nb=1,nbrillq
         yoldshift = cpsi_data_get_chnk(Yold_tag,nb)
         ynewshift = cpsi_data_get_chnk(Ynew_tag,nb)
         ushift    = cpsi_data_get_chnk(U_tag,nb)
         sshift    = cpsi_data_get_chnk(S_tag,nb)
         vtshift   = cpsi_data_get_chnk(Vt_tag,nb)
         call Pneb_SCVtrans1(0,nb,t,
     >                    dbl_mb(sshift),
     >                    dbl_mb(vtshift),
     >                    dcpl_mb(tmp1(1)),
     >                    dcpl_mb(tmp3(1)),
     >                    dbl_mb(tmpC(1)),
     >                    dbl_mb(tmpS(1)))

         call Pneb_www_Multiply2(0,nb,
     >                    one,
     >                    dbl_mb(vtshift),
     >                    dcpl_mb(tmp1(1)),
     >                    zero,
     >                    dcpl_mb(tmp2(1)))

         call Pneb_fwf_Multiply(0,nb,
     >                    one,
     >                    dbl_mb(yoldshift),npack1,
     >                    dcpl_mb(tmp2(1)),
     >                    zero,
     >                    dbl_mb(ynewshift))

         call Pneb_fwf_Multiply(0,nb,
     >                    one,
     >                    dbl_mb(ushift),npack1,
     >                    dcpl_mb(tmp3(1)),
     >                    one,
     >                    dbl_mb(ynewshift))

*        **** Orthonormality Check ****
         call Pneb_orthoCheckMake(.true.,0,nb,npack1,dbl_mb(ynewshift))
      end do

*     **** deallocate tmp space ****     
      value =           MA_pop_stack(tmpS(2))
      value = value.and.MA_pop_stack(tmpC(2))
      value = value.and.Pneb_w_pop_stack(tmp3)
      value = value.and.Pneb_w_pop_stack(tmp2)
      value = value.and.Pneb_w_pop_stack(tmp1)
      if (.not. value) 
     > call errquit('error popping stack memory',0, MA_ERR)

      call nwpw_timing_end(10)

      return
      end

*     ***********************************
*     *					*
*     *		c_geodesic_transport	*
*     *					*
*     ***********************************
*
*     Uses - geodesic common block
*

      subroutine c_geodesic_transport(t,Yold_tag,Ynew_tag)
      implicit none
      real*8   t
      integer  Yold_tag
      integer  Ynew_tag

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"

*     **** local variables ****
      complex*16 zero,one,mone
      parameter (zero=(0.0d0,0.0d0), one=(1.0d0,0.0d0))
      parameter (mone=(-1.0d0,0.0d0))

      logical    value
      integer    nb,npack1,nemax,nbrillq
      integer    tmp1(2),tmp2(2),tmp3(2),tmpC(2),tmpS(2)
      integer    yoldshift,ynewshift,ushift,sshift,vtshift

*     **** external functions ****
      logical  Pneb_w_push_get,Pneb_w_pop_stack
      integer  cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk
      external Pneb_w_push_get,Pneb_w_pop_stack
      external cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk

      call nwpw_timing_start(10)
      call Cram_max_npack(npack1)
      nemax   = cpsi_ne(1)+cpsi_ne(2)
      nbrillq = cpsi_nbrillq()

*     **** allocate tmp space ****
      value =           Pneb_w_push_get(0,1,tmp1)
      value = value.and.Pneb_w_push_get(0,1,tmp2)
      value = value.and.Pneb_w_push_get(0,1,tmp3)
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpC',tmpC(2),tmpC(1))
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpS',tmpS(2),tmpS(1))
      if (.not. value) 
     > call errquit('c_geodesic_transport:out of stack memory',0,MA_ERR)

      do nb=1,nbrillq
         yoldshift = cpsi_data_get_chnk(Yold_tag,nb)
         ynewshift = cpsi_data_get_chnk(Ynew_tag,nb)
         ushift    = cpsi_data_get_chnk(   U_tag,nb)
         sshift    = cpsi_data_get_chnk(   S_tag,nb)
         vtshift   = cpsi_data_get_chnk(  Vt_tag,nb)

         call Pneb_SCVtrans2(0,nb,t,
     >                   dbl_mb(sshift),
     >                   dbl_mb(vtshift),
     >                   dcpl_mb(tmp1(1)),
     >                   dcpl_mb(tmp3(1)),
     >                   dbl_mb(tmpC(1)),
     >                   dbl_mb(tmpS(1)))
         call Pneb_www_Multiply2(0,nb,
     >                   one,
     >                   dbl_mb(vtshift),
     >                   dcpl_mb(tmp1(1)),
     >                   zero,
     >                   dcpl_mb(tmp2(1)))

         call Pneb_fwf_Multiply(0,nb,
     >                   mone,
     >                   dbl_mb(yoldshift),npack1,
     >                   dcpl_mb(tmp2(1)),
     >                   zero,
     >                   dbl_mb(ynewshift))

         call Pneb_fwf_Multiply(0,nb,
     >                   one,
     >                   dbl_mb(ushift),npack1,
     >                   dcpl_mb(tmp3(1)),
     >                   one,
     >                   dbl_mb(ynewshift))
      end do
*     **** deallocate tmp space ****     
      value =           MA_pop_stack(tmpS(2))
      value = value.and.MA_pop_stack(tmpC(2))
      value = value.and.Pneb_w_pop_stack(tmp3)
      value = value.and.Pneb_w_pop_stack(tmp2)
      value = value.and.Pneb_w_pop_stack(tmp1)
      if (.not. value) 
     > call errquit('c_geodesic_transport:error popping stack',0,MA_ERR)

      call nwpw_timing_end(10)

      return
      end


*     ***********************************
*     *					*
*     *		c_geodesic_Gtransport	*
*     *					*
*     ***********************************
*
*     Uses - geodesic common block
*

      subroutine c_geodesic_Gtransport(t,Yold_tag,tG_tag)
      implicit none
      real*8   t
      integer  Yold_tag
      integer  tG_tag

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"

*     **** local variables ****
      complex*16 zero,one,mone
      parameter (zero=(0.0d0,0.0d0), one=(1.0d0,0.0d0))
      parameter (mone=(-1.0d0,0.0d0))

      logical  value
      integer  nb,npack1,nemax,nbrillq
      integer  tmp1(2),tmp2(2),tmp3(2),tmpC(2),tmpS(2)
      integer  yoldshift,tGshift,ushift,sshift,vtshift

*     **** external functions ****
      logical  Pneb_w_push_get,Pneb_w_pop_stack
      integer  cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk
      external Pneb_w_push_get,Pneb_w_pop_stack
      external cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk

      call nwpw_timing_start(10)
      call Cram_max_npack(npack1)
      nemax   = cpsi_ne(1)+cpsi_ne(2)
      nbrillq = cpsi_nbrillq()


*     **** allocate tmp space ****
      value =           Pneb_w_push_get(0,1,tmp1)
      value = value.and.Pneb_w_push_get(0,1,tmp2)
      value = value.and.Pneb_w_push_get(0,1,tmp3)
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpC',tmpC(2),tmpC(1))
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpS',tmpS(2),tmpS(1))
      if (.not. value)
     > call errquit('c_geodesic_transport:out of stack memory',0,MA_ERR)


      do nb=1,nbrillq
         yoldshift = cpsi_data_get_chnk(Yold_tag,nb)
         tGshift   = cpsi_data_get_chnk(  tG_tag,nb)
         ushift    = cpsi_data_get_chnk(   U_tag,nb)
         sshift    = cpsi_data_get_chnk(   S_tag,nb)
         vtshift   = cpsi_data_get_chnk(  Vt_tag,nb)
         
         call Pneb_ffw_Multiply(0,nb,
     >                   dbl_mb(ushift),
     >                   dbl_mb(tGshift),npack1,
     >                   dcpl_mb(tmp2(1)))
         call Pneb_SCVtrans3(0,nb,t,
     >                   dbl_mb(sshift),
     >                   dcpl_mb(tmp2(1)),
     >                   dcpl_mb(tmp1(1)),
     >                   dcpl_mb(tmp3(1)),
     >                   dbl_mb(tmpC(1)),
     >                   dbl_mb(tmpS(1)))
         call Pneb_www_Multiply2(0,nb,
     >                   one,
     >                   dbl_mb(vtshift),
     >                   dcpl_mb(tmp1(1)),
     >                   zero,
     >                   dcpl_mb(tmp2(1)))
         call Pneb_fwf_Multiply(0,nb,
     >                   mone,
     >                   dbl_mb(yoldshift),npack1,
     >                   dcpl_mb(tmp2(1)),
     >                   one,
     >                   dbl_mb(tGshift))
         call Pneb_fwf_Multiply(0,nb,
     >                   mone,
     >                   dbl_mb(ushift),npack1,
     >                   dcpl_mb(tmp3(1)),
     >                   one,
     >                   dbl_mb(tGshift))
      end do

*     **** deallocate tmp space ****
      value =           MA_pop_stack(tmpS(2))
      value = value.and.MA_pop_stack(tmpC(2))
      value = value.and.Pneb_w_pop_stack(tmp3)
      value = value.and.Pneb_w_pop_stack(tmp2)
      value = value.and.Pneb_w_pop_stack(tmp1)
      if (.not. value)
     > call errquit('c_geodesic_transport:error popping stack',0,MA_ERR)

      call nwpw_timing_end(10)

      return
      end


*     *******************************************
*     *						*
*     *		c_geodesic_transport_junk	*
*     *						*
*     *******************************************
*
*   Temporary code until BGrsm_list fixed
*     Uses - geodesic common block
*

      subroutine c_geodesic_transport_junk(t,Yold_tag,Ynew)
      implicit none
      real*8   t
      integer Yold_tag
      complex*16  Ynew(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"

*     **** local variables ****
      complex*16 zero,one,mone
      parameter (zero=(0.0d0,0.0d0), one=(1.0d0,0.0d0))
      parameter (mone=(-1.0d0,0.0d0))

      logical    value
      integer    nb,npack1,nemax,nbrillq
      integer    tmp1(2),tmp2(2),tmp3(2),tmpC(2),tmpS(2)
c      integer    yoldshift,ynewshift,ushift,sshift,vtshift
      integer    yoldshift,ushift,sshift,vtshift
      integer    nbshift

*     **** external functions ****
      logical  Pneb_w_push_get,Pneb_w_pop_stack
      integer  cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk
      external Pneb_w_push_get,Pneb_w_pop_stack
      external cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk

      call nwpw_timing_start(10)
      call Cram_max_npack(npack1)
      nemax   = cpsi_ne(1)+cpsi_ne(2)
      nbrillq = cpsi_nbrillq()
      nbshift = nemax*npack1

*     **** allocate tmp space ****
      value =           Pneb_w_push_get(0,1,tmp1)
      value = value.and.Pneb_w_push_get(0,1,tmp2)
      value = value.and.Pneb_w_push_get(0,1,tmp3)
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpC',tmpC(2),tmpC(1))
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpS',tmpS(2),tmpS(1))
      if (.not. value) 
     > call errquit('c_geodesic_transport:out of stack memory',0,MA_ERR)

      do nb=1,nbrillq
         yoldshift = cpsi_data_get_chnk(Yold_tag,nb)
c         ynewshift = cpsi_data_get_chnk(Ynew_tag,nb)
         ushift    = cpsi_data_get_chnk(   U_tag,nb)
         sshift    = cpsi_data_get_chnk(   S_tag,nb)
         vtshift   = cpsi_data_get_chnk(  Vt_tag,nb)

         call Pneb_SCVtrans2(0,nb,t,
     >                   dbl_mb(sshift),
     >                   dbl_mb(vtshift),
     >                   dcpl_mb(tmp1(1)),
     >                   dcpl_mb(tmp3(1)),
     >                   dbl_mb(tmpC(1)),
     >                   dbl_mb(tmpS(1)))
         call Pneb_www_Multiply2(0,nb,
     >                   one,
     >                   dbl_mb(vtshift),
     >                   dcpl_mb(tmp1(1)),
     >                   zero,
     >                   dcpl_mb(tmp2(1)))

         call Pneb_fwf_Multiply(0,nb,
     >                   mone,
     >                   dbl_mb(yoldshift),npack1,
     >                   dcpl_mb(tmp2(1)),
     >                   zero,
     >                   Ynew(1+(nb-1)*nbshift))

         call Pneb_fwf_Multiply(0,nb,
     >                   one,
     >                   dbl_mb(ushift),npack1,
     >                   dcpl_mb(tmp3(1)),
     >                   one,
     >                   Ynew(1+(nb-1)*nbshift))
      end do
*     **** deallocate tmp space ****     
      value =           MA_pop_stack(tmpS(2))
      value = value.and.MA_pop_stack(tmpC(2))
      value = value.and.Pneb_w_pop_stack(tmp3)
      value = value.and.Pneb_w_pop_stack(tmp2)
      value = value.and.Pneb_w_pop_stack(tmp1)
      if (.not. value) 
     > call errquit('c_geodesic_transport:error popping stack',0,MA_ERR)

      call nwpw_timing_end(10)

      return
      end


*     *******************************************
*     *						*
*     *		c_geodesic_Gtransport_junk	*
*     *						*
*     *******************************************
*
*   Temporary code until BGrsm_list fixed

*     Uses - geodesic common block
*

      subroutine c_geodesic_Gtransport_junk(t,Yold_tag,tG)
      implicit none
      real*8   t
      integer   Yold_tag
      complex*16 tG(*)
c      integer  tG_tag

#include "mafdecls.fh"
#include "errquit.fh"
#include "c_geodesic_common.fh"

*     **** local variables ****
      complex*16 zero,one,mone
      parameter (zero=(0.0d0,0.0d0), one=(1.0d0,0.0d0))
      parameter (mone=(-1.0d0,0.0d0))

      logical  value
      integer  nb,npack1,nemax,nbrillq
      integer  tmp1(2),tmp2(2),tmp3(2),tmpC(2),tmpS(2)
c      integer  yoldshift,tGshift,ushift,sshift,vtshift
      integer  yoldshift,ushift,sshift,vtshift
      integer  nbshift

*     **** external functions ****
      logical  Pneb_w_push_get,Pneb_w_pop_stack
      integer  cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk
      external Pneb_w_push_get,Pneb_w_pop_stack
      external cpsi_ne,cpsi_nbrillq,cpsi_data_get_chnk

      call nwpw_timing_start(10)
      call Cram_max_npack(npack1)
      nemax   = cpsi_ne(1)+cpsi_ne(2)
      nbrillq = cpsi_nbrillq()
      nbshift = nemax*npack1


*     **** allocate tmp space ****
      value =           Pneb_w_push_get(0,1,tmp1)
      value = value.and.Pneb_w_push_get(0,1,tmp2)
      value = value.and.Pneb_w_push_get(0,1,tmp3)
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpC',tmpC(2),tmpC(1))
      value = value.and.MA_push_get(mt_dbl,nemax,'tmpS',tmpS(2),tmpS(1))
      if (.not. value)
     > call errquit('c_geodesic_transport:out of stack memory',0,MA_ERR)


      do nb=1,nbrillq
         yoldshift = cpsi_data_get_chnk(Yold_tag,nb)
c         tGshift   = cpsi_data_get_chnk(  tG_tag,nb)
         ushift    = cpsi_data_get_chnk(   U_tag,nb)
         sshift    = cpsi_data_get_chnk(   S_tag,nb)
         vtshift   = cpsi_data_get_chnk(  Vt_tag,nb)
         
         call Pneb_ffw_Multiply(0,nb,
     >                   dbl_mb(ushift),
     >                   tG(1+(nb-1)*nbshift),npack1,
     >                   dcpl_mb(tmp2(1)))
         call Pneb_SCVtrans3(0,nb,t,
     >                   dbl_mb(sshift),
     >                   dcpl_mb(tmp2(1)),
     >                   dcpl_mb(tmp1(1)),
     >                   dcpl_mb(tmp3(1)),
     >                   dbl_mb(tmpC(1)),
     >                   dbl_mb(tmpS(1)))
         call Pneb_www_Multiply2(0,nb,
     >                   one,
     >                   dbl_mb(vtshift),
     >                   dcpl_mb(tmp1(1)),
     >                   zero,
     >                   dcpl_mb(tmp2(1)))
         call Pneb_fwf_Multiply(0,nb,
     >                   mone,
     >                   dbl_mb(yoldshift),npack1,
     >                   dcpl_mb(tmp2(1)),
     >                   one,
     >                   tG(1+(nb-1)*nbshift))
         call Pneb_fwf_Multiply(0,nb,
     >                   mone,
     >                   dbl_mb(ushift),npack1,
     >                   dcpl_mb(tmp3(1)),
     >                   one,
     >                   tG(1+(nb-1)*nbshift))
      end do

*     **** deallocate tmp space ****
      value =           MA_pop_stack(tmpS(2))
      value = value.and.MA_pop_stack(tmpC(2))
      value = value.and.Pneb_w_pop_stack(tmp3)
      value = value.and.Pneb_w_pop_stack(tmp2)
      value = value.and.Pneb_w_pop_stack(tmp1)
      if (.not. value)
     > call errquit('c_geodesic_transport:error popping stack',0,MA_ERR)

      call nwpw_timing_end(10)

      return
      end

       subroutine create_mr_evl_sorted(k_f1_offsetm)
        implicit none
#include "tce.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "sym.fh"
#include "tce_mrcc.fh"
#include "tce_main.fh"
#include "global.fh"



      integer k_f1_offsetm(maxref)
c      integer nref,iref
      integer iref
c      logical nodezero 
      integer g6b,g5b
      integer i,j,k,l
      integer l_f1,k_f1
      integer size
      integer offsetf

c      nodezero = (ga_nodeid().eq.0)

      do iref=1,nref


         k = 0
         k_sym = k_symm(iref)
         k_offset = k_offsetm(iref)
         k_range = k_rangem(iref)
         k_spin = k_spinm(iref)
         k_movecs_sorted = k_movecs_sortedm(iref)

         noa = nblcks(1,iref)
         nob = nblcks(2,iref)
         nva = nblcks(3,iref)
         nvb = nblcks(4,iref)

         noab = noa+nob
         nvab = nva+nvb

      DO g6b = 1,noab+nvab
      g5b = g6b
      IF (int_mb(k_spin+g6b-1) .eq. int_mb(k_spin+g5b-1)) THEN
      IF (ieor(int_mb(k_sym+g6b-1),int_mb(k_sym+g5b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+g6b-1)+int_mb(k_spin+g5b-1
     &).ne.4)) THEN

        size = int_mb(k_range+g6b-1) * int_mb(k_range+g5b-1)

        if (.not.ma_push_get(mt_dbl,size,'f1mi',l_f1,k_f1))
     1   call errquit('tce_mrcc_iface_f1: MA problem get',0,MA_ERR)


        call get_hash_block(d_f1m(iref),dbl_mb(k_f1),size,
     1   int_mb(k_f1_offsetm(iref)),g6b-1+(noab+nvab)*(g5b-1))
        l = 0
        do i=1,int_mb(k_range+g6b-1)
        do j=1,int_mb(k_range+g5b-1)
        l = l + 1
           if(i.eq.j) then
             k = k + 1
             dbl_mb(k_evl_sortedm(iref)+k-1) = dbl_mb(k_f1-1+l)
           endif
        enddo
        enddo

        if (.not.ma_pop_stack(l_f1))
     1   call errquit('tce_mrcc_iface_f1: MA problem pop',1,MA_ERR)

      
      END IF
      END IF
      END IF
      END DO

      enddo

      return
      end

c $Id: create_mr_evl_sorted.F 24345 2013-06-22 06:19:30Z d3y133 $

      function smd_monomer_energy(im)
      implicit none
c     calculates monomer (im) energy
c     in the field (classical) of others
c     im[IN]  monomer id
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "global.fh"
      logical smd_monomer_energy
      integer im,rtdb
c
      character*72 namespace
      character*32 pname
      logical result
      double precision qm_energy
      logical task_energy_doit
      external task_energy_doit
      logical esp
      external esp
      integer util_sgroup_mygroup
      external util_sgroup_mygroup
      logical mode
      character*72 tag
      character*256 movecs
      character*16 theory
      double precision e1, e2,e3,e4,e5,e6,e7,e8,e9,e10,e11
      character*255 prefix, prefix0,key
      integer i1
      integer group_id

      pname = "smd_monomer_energy"
c
c
      call util_file_prefix_get(prefix0)
      i1 = inp_strlen(prefix0)
      write(prefix,'(A,I4.4)')
     >    prefix0(1:i1),im
      call util_file_prefix_set(prefix)
c
      if (.not.(rtdb_cget(rtdb,'smd:theory',1,theory)))
     *     theory = "dft"
      if (.not.(rtdb_cput(rtdb,'task:theory',1,theory)))
     *     call errquit('rtdb_put task:theory failed',0,0)

      call smd_fragment_charge_get_all()
c
      call smd_geom_monomer_create(im)
      if(ga_nodeid().eq.0)
     >  write(*,*) "smd theory is set to",theory,group_id
      result = task_energy_doit(rtdb,theory,qm_energy)
c
      if(ga_nodeid().eq.0)
     >  write(*,*) "finished energy",theory,group_id
c
      if(theory.ne."dft") goto 100
      if(.not.rtdb_put(rtdb,'esp:newgrd',mt_int,1,1))
     +     call errquit('esp: rtdb_put newgrd failed',0,0)


      if(.not.esp(rtdb))
     &    call errquit(pname//'failed esp call', 100,
     &                 RTDB_ERR)
c
      call util_message("finished esp")
c
      call smd_geom_push_charges(im)
      if(ga_nodeid().eq.0)
     &     call smd_fragment_charge_set(im)

      call util_message("finished smd_geom_push_charges")

100   continue
      call smd_geom_monomer_end()
      call util_message("smd_geom_monomer_end")

      write(key,'(a,'':converged'')') theory(1:inp_strlen(theory))
      if (.not. rtdb_put(rtdb, key, mt_log, 1, .false.))
     &    call errquit(pname//'  rtdb_put', 0,
     &                 RTDB_ERR)
      call smd_fragment_charge_print()

      call util_file_prefix_set(prefix0)
      smd_monomer_energy = .true.

      return
      end function

c $Id: smd_monomer.F 22502 2012-05-20 06:11:57Z d3y133 $

      logical function tce_mrcc_energy(rtdb)
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "sf.fh"
#include "inp.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_hetio.fh"
#include "tce_diis.fh"
#include "tce_prop.fh"
#include "tce_restart.fh"

#ifdef MRCC_METHODS
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
#endif

      integer rtdb
      logical se4t
      logical nodezero
      logical no_aposteriori
      character*255 modelname
      character*255 filename
      double precision ref     ! Ground state energy
      logical dft_energy
      external dft_energy
      logical scf
      external scf
ckbn      logical mcscf
ckbn      external mcscf
      integer g_ao1e(2)        ! GA handle for AO Fock matrices
      integer d_ao2e           ! SF handle for AO 2e integrals
ckbn  integer i,j,iref,nref,yref
      integer i,j,iref,yref
c     logical mrccdebug
      integer l_f1_offsetm(maxref),k_f1_offsetm(maxref)
      integer l_v2_offsetm(maxref),k_v2_offsetm(maxref)
      integer size_1em(maxref)
      integer size_2em(maxref)
      logical int2e_file_close
      external int2e_file_close
      character*3 namechunk
      character*3 namechunk2
      double precision cpu     ! CPU sec counter
      double precision wall    ! WALL sec counter
      double precision itcpu,itcpu2     ! CPU sec counter
      double precision itwall,itwall2    ! WALL sec counter
      integer d_v2m(maxref)
      logical needt1
      logical needt2
      logical needt3
      logical needt3a
      logical needr3act
      logical needr4act
      integer d_t1m(maxref)             ! SF handle for t1 amplitudes
      integer l_t1_offsetm(maxref)      ! Offset for t1 file
      integer k_t1_offsetm(maxref)      ! Offset for t1 file
      integer size_t1m(maxref)          ! File size in doubles
      integer d_t2m(maxref)             ! SF handle for t2 amplitudes
      integer d_t3m(maxref)             ! SF handle for t3 amplitudes
      integer l_t2_offsetm(maxref)      ! Offset for t2 file
      integer k_t2_offsetm(maxref)      ! Offset for t2 file
      integer size_t2m(maxref)          ! File size in doubles
      integer l_t3_offsetm(maxref)      ! Offset for t3 file
      integer k_t3_offsetm(maxref)      ! Offset for t3 file
      integer size_t3m(maxref)          ! File size in doubles
      integer l_r1_offsetm(maxref),k_r1_offsetm(maxref)
      integer l_r2_offsetm(maxref),k_r2_offsetm(maxref)
      integer l_r3_offsetm(maxref),k_r3_offsetm(maxref)
      integer size_r3m(maxref),d_r3m(maxref)
      integer d_r3am(maxref)
      integer size_r3am(maxref)
      integer l_r3a_offsetm(maxref),k_r3a_offsetm(maxref)
      integer d_r4am(maxref)
      integer size_r4am(maxref)
      integer l_r4a_offsetm(maxref),k_r4a_offsetm(maxref)
      integer d_r2actm(maxref)
      integer size_r2actm(maxref)
      integer l_r2act_offsetm(maxref),k_r2act_offsetm(maxref)
      integer l_e_offsetm(maxref),k_e_offsetm(maxref)
      integer size_em(maxref),size_r1m(maxref),size_r2m(maxref)
      integer d_em(maxref),d_r1m(maxref),d_r2m(maxref)
      integer d_corr
ckbn  integer d_corr2
ckbn      double precision dbwcorr,dbwcorrf,dbwcorrf2
ckbn      double precision dbench1

c t1 localization
c      integer l_t1_local,k_t1_local
c IC logic 
      logical ic_cc,icrunl
c intermediate file
      integer d_c2
c
      double precision r1(maxref)      ! Residual t1
      double precision r2(maxref)      ! Residual t2
      double precision eone,etwo,enrep,energy
      integer dummy            ! Dummy argument for DIIS
      double precision residual,corr
      integer g5b,g6b
      double precision edelta
      double precision norm_r1,norm_r2
ckbn      double precision dsummary(5000,2)  !Print summary in the end
      integer k_movecs,l_movecs
      logical lcheckpoints
      integer icheckpoint
ckbn      logical lsave2e
ckbn      logical lread2e,lreadt
ckbn gf -2      integer lbwcorr 
      logical lbwcorr 
      logical lcas
      integer innodes
      integer inodesperref
      integer ifreenodes
      integer inofg, isum
      integer ipg,igg
      logical lstatus
      integer k
      integer isubsize
      integer d_f1mtmp(maxref)
      integer jref
      double precision dfirstterm
      integer istartmk
      double precision ddotr1,ddotr2
ckbn-5
      integer irefpt
      integer imkconv,iiref
      integer irefpth,jrefpth
ckbn      double precision pt3_1m(maxref),pt3_2m(maxref),pt3_3m(maxref)
      double precision pt3_3m(maxref)
ckbn      double precision pt_heff(maxref*maxref)
      integer l_t1_localpt,k_t1_localpt
      integer l_f1_localpt,k_f1_localpt
      integer l_f1_local,k_f1_local
      integer l_t1_local,k_t1_local
      integer pgidtobrdcst 
      integer k_ptheff,l_ptheff
ckbn      double precision hcnubycmu(maxref*maxref)
ckbn      double precision pt3_off2m(maxref*maxref)
      integer ipt,jpt
      integer itargetx
      double precision itcpu3  ! CPU sec counter
      double precision itwall3 ! WALL sec counter
      double precision itcpu3_1,itcpu3_2
      double precision itwall3_1,itwall3_2
      integer itmpkk,itmpkkk
      double precision dmint1,dmint2
      integer ioff
      double precision dmaxt1,dmaxt2
      double precision dresr1r2,dr1dotr1,dr2dotr2
      integer itype,idim1, idim2(4)
      integer tg_heff, ngheff, dg_heff
      integer sub_test

c      logical lusesamefock
c (t)
c PNNL: new variables
c === jaguar ===
      integer unitn,recforio
      logical diskint,dlogic
c === eaf ======
      integer eaf_han(maxref)   !handles of eaf files for v2(iref)
      logical eafl,eafa
      character*255 filemr(maxref)
c===============
cjb
C The number of bytes in double
      bytes = 8
#ifdef MRCC_METHODS
      tce_mrcc_energy = .false.
      nodezero=(ga_nodeid().eq.0)
      residual = 0.0d0
      lconverged = .false.
      ddotr1 = 0.0d0
      ddotr2 = 0.0d0

ckbn introduce all checks in this block before going to actual calculation
c
c     ======================
c     Initialize parameters
c     ======================
c
       lsubterm = .false.
       if (.not.rtdb_get(rtdb,'mrcc:debug',mt_log,1,mrccdebug))
     1 mrccdebug = .false.
      if (.not.rtdb_get(rtdb,'mrcc:checkpoints',mt_log,1,lcheckpoints))
     1   lcheckpoints = .false.
      if (.not.rtdb_get(rtdb,'mrcc:icheckpoint',mt_int,1,icheckpoint))
     1   icheckpoint = 0
      if (.not.rtdb_get(rtdb,'mrcc:save2e',mt_log,1,lsave2e))
     1   lsave2e = .false.
      if (.not.rtdb_get(rtdb,'mrcc:read2e',mt_log,1,lread2e))
     1   lread2e = .false.
      if (.not.rtdb_get(rtdb,'mrcc:readt',mt_log,1,lreadt))
     1   lreadt = .false.
      if (.not.rtdb_get(rtdb,'mrcc:forcedegen',mt_log,1,forcedegen))
     1   forcedegen = .false.
      if (.not.rtdb_get(rtdb,'mrcc:bwcorr',mt_log,1,lbwcorr))
     1   lbwcorr = .false.
      if (.not.rtdb_get(rtdb,'mrcc:cas',mt_log,1,lcas))
     2   lcas = .false.
ckbn sub -2
c      if (.not.rtdb_get(rtdb,'mrcc:subgroups',mt_log,1,lusesub))
c     +
         lusesub = .false.
      if (.not.rtdb_get(rtdb,'mrcc:subsize',mt_int,1,isubsize))
     2   isubsize = -1
      if (.not.rtdb_get(rtdb,'mrcc:istartmk',mt_int,1,istartmk))
     2   istartmk = -1
      if (.not.rtdb_get(rtdb,'mrcc:useeaf2el',mt_log,1,luseeaf2e))
     2   luseeaf2e = .false.
      if (.not.rtdb_get(rtdb,'mrcc:fullheff',mt_log,1,lfullheff))
     2   lfullheff = .false.

      if (.not.rtdb_get(rtdb,'mrcc:usesamefock_it',mt_log,1,
     +     lusesamefock_it))
     +   lusesamefock_it = .false.
       if(nodezero) write(*,*) "usesamefock_it",lusesamefock_it

       if (.not.rtdb_get(rtdb,'mrcc:ignorecomplex',mt_log,1,
     +   ignorecomplex)) ignorecomplex= .false.
       if(nodezero) write(*,*) "ignorecomplex",ignorecomplex
     
      if (.not.rtdb_get(rtdb,'mrcc:savet',mt_log,1,lsavet))
     1   lsavet = .false.
       if(nodezero) write(*,*) "savet",lsavet

ckbn-4
      if (.not.rtdb_get(rtdb,'mrcc:se4t',mt_log,1,se4t))
     2   se4t = .false.
      if(nodezero) write(*,*) "se4t", se4t

ckbn-4
      if (.not.rtdb_get(rtdb,'mrcc:no_aposteriori',
     +     mt_log,1,no_aposteriori)) no_aposteriori = .false.
      if(nodezero) write(*,*) "no_aposteriori", no_aposteriori


ckbn-13 placed it here and added to common block
       if (.not.rtdb_get(rtdb,'mrcc:usescffermiv',mt_log,1,lusescffv))
     + lusescffv = .false.
       if(nodezero) write(*,*) "Using fermivacuum by default" 
       lusescffv = .true.

ckbn roottooverlap
       if (.not.rtdb_get(rtdb,'mrcc:rootfromoverlap',mt_log,1,
     +  lrootfromoverlap))
     + lrootfromoverlap = .false.
       if(nodezero)  write(LuOut,*) 
     +  "Using rootfromoverlap ",lrootfromoverlap
       if(lrootfromoverlap) then
       if (.not.rtdb_get(rtdb,'mrcc:iroottooverlap',mt_int,1,
     +  iroottooverlap))
     +  call errquit('No root to overlap ',1,rtdb_err)
       if (.not.rtdb_get(rtdb,'mrcc:iroottooverlapiter',mt_int,1,
     +  iroottooverlapiter))
     +  call errquit('No iteration number to select root to overlap ',1,
     + rtdb_err)
       if(nodezero)
     +   write(LuOut,'(A,I5,A,I5)') 
     +   "Using rootfromoverlap with right eigen vector ",
     +    iroottooverlap," from iteration ", iroottooverlapiter
        lrootfromoverlap = .false. ! Turn it on from iroottooverlapiter
       endif


       if (.not.rtdb_get(rtdb,'mrcc:improvetiling',mt_log,1,limprovet))
     + limprovet = .false.
       if (.not.rtdb_get(rtdb,'mrcc:diistype',mt_int,1,idiis))
     +  idiis=0
       if (.not.rtdb_get(rtdb,'mrcc:zignore',mt_int,1,iignore))
     + iignore = 0
       if (.not.rtdb_get(rtdb,'mrcc:rootmuc',mt_int,1,nrootmuc))
     + nrootmuc = 0
       if (.not.rtdb_get(rtdb,'bwcc:targetroot',mt_int,1,iitarget))
     + iitarget = 0

       if (.not.rtdb_get(rtdb,'tce:tceiop',mt_int,1,recforio)) then
        rec_mem=1
       else
        rec_mem=recforio
       end if

c IC logic 
       icrunl=.false.
       if (.not.rtdb_get(rtdb,'tce:icrun',mt_log,1,icrunl)) then
        ic_cc=.false.
       else
        ic_cc=icrunl
       end if
c
       if(nodezero) then
        if(ic_cc) then
         write(LuOut,*)'IC version of CCSD is used'
        else
         write(LuOut,*)'standard version of CCSD is used'
        end if  
        call util_flush(LuOut)
       end if
c DISKINT
       dlogic=.false.
       if (.not.rtdb_get(rtdb,'tce:dlogic',mt_log,1,dlogic)) then
        diskint=.false.
       else
        diskint=dlogic
       end if
c EAF
       eafa=.false.
       if (.not.rtdb_get(rtdb,'tce:eafl',mt_log,1,eafa)) then
        eafl=.false.
       else
        eafl=eafa
       end if
c
       if(nodezero) then
        if(diskint.or.luseeaf2e) then
         write(LuOut,*)'DISK-MEMORY option enabled for integrals'
          if(eafl.or.luseeaf2e) then
           write(LuOut,*)'EAF files will be used'
          else 
           write(LuOut,*)'Standard direct access file will be used'
          end if
        else
         write(LuOut,*)'All integrlas stored in memory'
        end if
        call util_flush(LuOut)
       end if 
c *** debug ***
      if(nodezero) then
       write(LuOut,*)'BYTES BYTES',bytes
       call util_flush(6)
      end if

c     =========================
c     Ground-state HF/DFT first
c     =========================
c
      if (.not.rtdb_get(rtdb,'tce:reference',mt_int,1,reference)) then
        reference = 1
        if (.not.rtdb_put(rtdb,'tce:reference',mt_int,1,reference))
     1    call errquit('tce_energy: failed to write reference',0,
     2    RTDB_ERR)
      endif
      if (reference.eq.0) then
        if (.not.dft_energy(rtdb)) return
        if (.not.rtdb_get(rtdb,'dft:energy',mt_dbl,1,ref))
     1    call errquit('tce_energy: failed to get dft energy',0,
     2    RTDB_ERR)
      else if (reference.eq.1) then
        if (.not.scf(rtdb)) return
        if (.not.rtdb_get(rtdb,'scf:energy',mt_dbl,1,ref))
     1    call errquit('tce_energy: failed to get scf energy',0,
     2    RTDB_ERR)
ckbn has to be tested      else if (reference.eq.2) then
ckbn has to be tested        if (.not.mcscf(rtdb)) return
ckbn has to be tested        if (.not.rtdb_get(rtdb,'mcscf:energy',mt_dbl,1,ref))
ckbn has to be tested     1   call errquit('tce_energy: failed to get mcscf energy',0,
ckbn has to be tested     2    RTDB_ERR)
      else
        call errquit('tce_energy: illegal reference',reference,
     1    UNKNOWN_ERR)
      endif
c
c
c
c        general model space even if RHF/ROHF orbitals 
c        are employed
c
c
         restricted=.false.
ckbn introduce all checks above this block before going to actual calculation end


ckbn analyze reference for mrcc calculation
c     ===================
c     Print utility start
c     ===================
      call util_print_push
      call util_print_rtdb_load(rtdb,'tce')

c     ==========
c     Initialize
c     ==========

ckbn MR-r      call tce_mrcc_init(rtdb)
ckbn replaced tce_mrcc_init with standard tce_init	!has to be tested
c      call tce_mrcc_init(rtdb)
      
      call tce_init(rtdb)

ckbn  check for maxorb
      if( ((nmo(1)-nfv(1)-nfc(1)) .gt. maxorb) .or. 
     +    ((nmo(2)-nfv(2)-nfc(2)) .gt. maxorb) ) then
       write(LuOut,'(A,I5,A,I5)') 'Maximum number of MOs ',
     +  maxorb,' is lower than current number of MOs',
     +  max((nmo(1)-nfv(1)-nfc(1)),(nmo(2)-nfv(2)-nfc(2)))
       call util_flush(LuOut)
        call errquit
     + ('tce_mrcc_energy: Above maximum number of MOs',0,RTDB_ERR)
      endif

ckbn Exit if diis is greater than maxdiis
      if(diis .gt. maxdiism) then
       write(LuOut,'(A,I5,A,I5)') 'Current diis value', diis,
     + ' is larger than maximum', maxdiism
       call util_flush(LuOut)
        call errquit
     + ('tce_mrcc_energy: Above maximum diis value',0,RTDB_ERR)
      endif

c      write(*,*) "ioalg", ioalg
c      if(ioalg .ne. 2 ) call errquit
c     + ('tce_mrcc_energy: TCE MRCC needs ioalgorithm',0,INPUT_ERR)

ckbn MR-r      if(lcas)call tce_mrcc_create_cas(rtdb)
c      if(lcas)call tce_mrcc_create_cas(rtdb)
      if(lcas)call tce_mrcc_create_cas1(rtdb)
      if (.not.rtdb_get(rtdb,'bwcc:nref', mt_int, 1, nref))
     1  call ERRQUIT('tce_mrcc_readref',1,RTDB_ERR)
ckbn MR-r      call tce_mrcc_readref(rtdb) 
      call tce_mrcc_readref(rtdb) 

      if (.not.rtdb_get(rtdb,'bwcc:targetroot',mt_int,1,itargetx)) then
c       write(*,*) "I am here1","itargetx",itargetx
       if(.not.rtdb_get(rtdb,'mrcc:roottooverlap',mt_int,1,
     +  iroottooverlap)) call errquit
     +  ('tce_mrcc_read: rtdb failed reading root to overlap',
     +  0,RTDB_ERR)
      else
        mkrootold = itargetx
        mkroot    = itargetx
c        write(*,*) "I am here1 mkroot",itargetx,mkrootold,mkroot
      endif
ckbn analyze reference for mrcc calculation end



      if (nodezero) call util_flush(LuOut)

ckbn Test for MA and GA 
ckbn @todo : Here test for memory bottle-neck and exit if it is not met.
ckbn			Use ga_memory_avail()
ckbn 			Add a brdcst test whether everybody else has same value
      call sf_test()

c     ================
c     Arrays for tile
c     ================
      cpu = - util_cpusec()
      wall = - util_wallsec()
      call tce_mrcc_tile(rtdb)                     ! more or less ok
      cpu = cpu + util_cpusec()
      wall = wall + util_wallsec()

      if(nodezero) then
       write(LuOut,"(/,'MRCC tiling completed in ',2f15.1)") cpu, wall
       call util_flush(LuOut)
      endif

      call tce_mrcc_fillindexarray(rtdb)           ! ok

c     ==============
c     1-e integrals 
c     ==============
      do iref=1,nref
       g_movecs(1) = g_movecsm(iref,1)
       g_movecs(2) = g_movecsm(iref,2)
       k_sym = k_symm(iref)
       k_offset = k_offsetm(iref)
       k_range = k_rangem(iref)        
       k_spin = k_spinm(iref)
       k_movecs_sorted = k_movecs_sortedm(iref)
       noa = nblcks(1,iref)
       nob = nblcks(2,iref)      
       nva = nblcks(3,iref)
       nvb = nblcks(4,iref)
       noab = noa+nob
       nvab = nva+nvb

       cpu  = - util_cpusec()
       wall = - util_wallsec()
       call tce_ao1e_fock2e(rtdb,g_ao1e,lzorafromdft) ! F in AO first, g_ao1e destroyed in the mo1e routine
       cpu  = cpu  + util_cpusec()
       wall = wall + util_wallsec()
       if(nodezero) then
        write(LuOut,'(A,2f15.5)')"tce_ao1e_fock2e", cpu, wall
        call util_flush(LuOut)
       endif

       write(namechunk,"(I3.3)")iref
       call tce_filename('f1m'//namechunk,filename)
       call tce_mo1e_offset(l_f1_offsetm(iref),
     1 k_f1_offsetm(iref),size_1em(iref))


      if((nodezero .and. (.not.lusesub)).or.
     +((ga_pgroup_nodeid(mypgid).eq.0) .and. lusesub))
     +write(*,'(A,I5,A,I20)')"F: ",iref," in bytes = ",size_1em(iref)*8

         call createfile(filename,d_f1m(iref),size_1em(iref))
c PNNL: add read option
       if(lread2e) then
          call tce_filenameindexed(iref,'mr_f',filename)
          unitn=76
          call read_tensor(filename,d_f1m(iref),size_1em(iref),unitn)
c         close(unitn)
         call reconcilefile(d_f1m(iref),size_1em(iref))
       else
         cpu  = - util_cpusec()
         wall = - util_wallsec()
         call tce_mo1e(g_ao1e,d_f1m(iref),k_f1_offsetm(iref))
         cpu  = cpu  + util_cpusec()
         wall = wall + util_wallsec()
         if(nodezero) then
           write(LuOut,'(A,2f15.5)')"tce_mo1e", cpu, wall
           call util_flush(LuOut)
         endif
        if(lsave2e) then
           call tce_filenameindexed(iref,'mr_f',filename)
           unitn=76
           call write_tensor(filename,d_f1m(iref),size_1em(iref),unitn)
c          close(unitn)
           call reconcilefile(d_f1m(iref),size_1em(iref))
         endif
       endif
c PNNL: add write option
c PNNL: kill d_f1m(iref)
c         call gatoeaf(d_f1m(iref))
c         call ga_print(d_f1m(iref))

         cpu = - util_cpusec()
         wall = - util_wallsec()
         call mrcc_uhf_energy(g_movecs, eone, etwo, enrep, energy,
     +    lzorafromdft)
         duhfens(iref) = eone+etwo
         cpu = cpu + util_cpusec()
         wall = wall + util_wallsec()
         if(nodezero) then
           write(LuOut,'(A,2f15.5)')"mrcc_uhf_energy", cpu, wall
           call util_flush(LuOut)
         endif

ckbn zoroa
c        if(nodezero) then
c         call ga_print(d_f1m(iref))
cc         call ga_print(size_1em(iref))
c         write(*,*) "UHF Starts"
c         call ga_print(d_f1m(1))
c         call ga_print(size_1em(1))
c         write(*,*)"E1",energy
c        endif
c        call ga_sync()

c DISKINT
c         if(diskint) then
c          call tce_filenameindexed(iref,'mrfn_r',filename)
c          unitn=76+(iref-1)*2+1
c          call write_tensor(filename,d_f1m(iref),size_1em(iref),unitn)
c          call deletefile(d_f1m(iref))
c         end if
c
      if (.not. int2e_file_close(.false.))
     $     call errquit('tce_mrcc_energy: closing aoints?', 0, INT_ERR)
      enddo

c
c     ==============
c        Subgroups
c     ==============
c
      if (.not.rtdb_get(rtdb,'mrcc:subgroupsize',mt_log,1,lusesub))
     2   lusesub = .false.

          if(nodezero.and.lusesub)
     1    write(LuOut,"(/,'Subgroups will be used',/,
     1                    '======================',/)")
        


c         if(lusesub) then 
cckbn
cckbn          write(LuOut,*) "GA_CLUSTER_NNODES",GA_CLUSTER_NNODES()
cckbn          call ga_sync()
cckbn          call util_flush(LuOut)
cckbn          write(LuOut,*) "GA_CLUSTER_NODEID",GA_CLUSTER_NODEID()
cckbn          call ga_sync()
cckbn          call util_flush(LuOut)
c          sub_test = GA_CLUSTER_NODEID()
cckbn          write(LuOut,*) "GA_CLUSTER_NPROCS",GA_CLUSTER_NPROCS(sub_test)
cckbn          call ga_sync()
cckbn          call util_flush(LuOut)
c          isubsize =  GA_CLUSTER_NNODES()/nref
c          if(nodezero) write(*,*) "isubsize ",isubsize
c          if(isubsize .lt. 1) 
c     +    call errquit("tce_mrcc_energy: isubsize",0,MA_ERR)
cckbn          write(LuOut,*) "Subgroup size 1 ", isubsize
cckbn          call ga_sync()
cckbn          call util_flush(LuOut)
c
c          isubsize =  GA_CLUSTER_NPROCS(sub_test) * isubsize
c          if(nodezero) write(LuOut,*) "Subgroup size", isubsize
c          if(isubsize .lt. 
c     +     ((GA_CLUSTER_NNODES()*GA_CLUSTER_NPROCS(sub_test))/nref))then
c             write(LuOut,*) "Warning: Number of free processors",
c     +        ((GA_CLUSTER_NNODES()*GA_CLUSTER_NPROCS(sub_test))
c     +        - (isubsize*nref))
c           call util_flush(LuOut)
c          endif
c        
c        endif       
c




        innodes = ga_nnodes()
        if(lusesub) then 
c        if(nodezero) write(LuOut,"('NNodes: ',I8)") innodes
         if(nodezero) 
     +    write(LuOut,"('Total Number of cores: ',I8)") innodes
         call util_flush(LuOut)
        endif

      if (.not.ma_push_get(mt_int,innodes*2,"all innodes",
     2  l_innodes,k_innodes))
     3  call errquit("tce_mrcc_energy: MA problem",0,MA_ERR)

      if (.not.ma_push_get(mt_int,innodes,"sg sizes",
     2  l_sgsizes,k_sgsizes))
     3  call errquit("tce_mrcc_energy: MA problem",0,MA_ERR)

      if (.not.ma_push_get(mt_int,innodes,"sghandles",
     2  l_sghandles,k_sghandles))
     3  call errquit("tce_mrcc_energy: MA problem",0,MA_ERR)

      if (.not.ma_push_get(mt_int,nref,"nref affiliation",
     2  l_refafi,k_refafi))
     3  call errquit("tce_mrcc_energy: MA problem",0,MA_ERR)

        do i=1,innodes
          int_mb(k_innodes+i-1) = i-1
          int_mb(k_sgsizes+i-1) = 0
          int_mb(k_sghandles+i-1) = 0
        enddo

        if(isubsize.le.0) then

        inodesperref = (innodes/nref)
        if(inodesperref.eq.0) inodesperref = 1

        ifreenodes = mod(innodes,nref) 
        if(innodes.le.nref) ifreenodes = 0

        inofg = min(innodes,nref)

        else

        inodesperref = isubsize
        inofg = innodes/isubsize 
c        inofg = (innodes-
c     +        ((GA_CLUSTER_NNODES()*GA_CLUSTER_NPROCS(sub_test))
c     +        - (isubsize*nref)))/isubsize 
        ifreenodes = innodes - (isubsize*inofg)

        endif


        if(lusesub) then 
        if(nodezero) then
          write(LuOut,"(/,'Nodes per ref: ',I8)")inodesperref
          write(LuOut,"('Free nodes left: ',I8)")ifreenodes
          write(LuOut,"('Total number of non-overlapping groups: '
     1 ,I8,/)")inofg
        endif
        endif

      if (.not.ma_push_get(mt_int,inofg,"g offsets",
     2  l_goffset,k_goffset))
     3  call errquit("tce_mrcc_energy: MA problem",0,MA_ERR)

        do i=1,inofg
            int_mb(k_sgsizes+i-1) = inodesperref
        enddo
        do i=1,ifreenodes
            int_mb(k_sgsizes+i-1) = int_mb(k_sgsizes+i-1)+1
        enddo

        isum = 0
        do i=1,inofg
           int_mb(k_goffset+i-1) = isum
           isum = isum + int_mb(k_sgsizes+i-1)
        enddo

        if(lusesub) then
        do i=1,inofg
        int_mb(k_sghandles+i-1) = ga_pgroup_create(int_mb(k_innodes+
     1 int_mb(k_goffset+i-1)),int_mb(k_sgsizes+i-1))
        enddo
        endif

        do i=1,nref
          int_mb(k_refafi+i-1) = int_mb(k_sghandles+mod(i-1,inofg))
        enddo

        k = 0
        do j=1,inofg
        do i=1,int_mb(k_sgsizes+j-1)
           k = k + 1
          int_mb(k_innodes+innodes+k-1) = int_mb(k_sghandles+j-1)
        enddo
        enddo

        if(lusesub) then 
         if(nodezero) then

          write(LuOut,"(/,'Processor distribution',/,
     1                    '======================',/)")

          do i=1,inofg
          write(LuOut,"('Subgroup no. ',I6,' size: ',I6)")
     1 int_mb(k_sghandles+i-1),
     1 ga_pgroup_nnodes(int_mb(k_sghandles+i-1))
          enddo

          write(LuOut,"(/,'Reference static distribution',/,
     1                    '=============================',/)")
          do i=1,nref
          write(LuOut,"('Reference no. ',I6,' will run on: ',I6)")i,
     1 int_mb(k_refafi+i-1)
          enddo
           write(LuOut,*)' '
         endif
        endif

         mypgid = int_mb(k_innodes+ga_nodeid()+ga_nnodes())
c         write(LuOut,'(A,I5,I5,I5,I5)') "mypgid2 ",mypgid,ga_nodeid(),
c     +       ga_pgroup_get_default(),ga_nnodes()
         call util_flush(LuOut) 

c -------
c      call create_mr_evl_sorted(nref,k_f1_offsetm)
      call create_mr_evl_sorted(k_f1_offsetm)

      
#ifdef MRCC_LOCAL_FOCK
c      call ga_print(d_f1m(1))
      if(lusesub) then
       do iref = 1, nref 
c         k_sym = k_symm(iref)
c         k_offset = k_offsetm(iref)
c         k_range = k_rangem(iref)
c         k_spin = k_spinm(iref)
c         k_movecs_sorted = k_movecs_sortedm(iref)
c         k_evl_sorted = k_evl_sortedm(iref)
c         k_active = k_active_tmpm(iref)
c         noa = nblcks(1,iref)
c         nob = nblcks(2,iref)
c         nva = nblcks(3,iref)
c         nvb = nblcks(4,iref)
c         noab = noa+nob
c         nvab = nva+nvb

        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1   +innodes+ga_nodeid())).or.(.not.lusesub)) then
         if(.not.MA_PUSH_GET(mt_dbl,size_1em(iref),'f1_local',
     +    l_f1_local,k_f1_local)) call errquit('f1_local',1,MA_ERR)
         call ma_zero(dbl_mb(k_f1_local),size_1em(iref))
         if( ga_pgroup_nodeid(mypgid) .eq. 0) then
          call ga_get(d_f1m(iref),1,size_1em(iref),1,1,
     +                dbl_mb(k_f1_local),1) 
         endif
         call ga_pgroup_brdcst(mypgid,65549,dbl_mb(k_f1_local),
     +    MA_sizeof(MT_DBL,1,MT_BYTE)*size_1em(iref)*1,0)
        endif
       enddo
      endif
#endif
      


ckbn @todo : this is our present memory bottle-neck
ckbn @todo : This part has to be rewritten
c     ==============
c     2-e integrals 
c     ==============
      do iref=1,nref
c       if( ga_pgroup_nodeid(mypgid).eq.0) 
c     +   write(*,'(A,I3,A,I3,A,I3)') "F",int_mb(k_refafi+iref-1),
c     +          "S",int_mb(k_innodes+innodes+ga_nodeid()),"iref",iref
       if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then
        g_movecs(1) = g_movecsm(iref,1)
        g_movecs(2) = g_movecsm(iref,2)
        k_sym = k_symm(iref)
        k_offset = k_offsetm(iref)
        k_range = k_rangem(iref)
        k_spin = k_spinm(iref)
        k_movecs_sorted = k_movecs_sortedm(iref)
        k_active = k_active_tmpm(iref)
        noa = nblcks(1,iref)
        nob = nblcks(2,iref)
        nva = nblcks(3,iref)
        nvb = nblcks(4,iref)
        noab = noa+nob
        nvab = nva+nvb
c  2-e integrals first half
        if(.not.lread2e) then
         cpu = - util_cpusec()
         wall = - util_wallsec()
         if(fast2e.eq.1) then
          call tce_mrcc_ao2e(rtdb,d_ao2e,iref)
         else
          write(LuOut,9123)fast2e
          call errquit('tce_energy: invalid 2emet: ',fast2e,CALC_ERR)
         end if
         cpu = cpu + util_cpusec()
         wall = wall + util_wallsec()
c        if((nodezero) .or. (ga_pgroup_nodeid(mypgid).eq.0)) then
         if((nodezero .and. (.not.lusesub)).or.
     +       ((ga_pgroup_nodeid(mypgid).eq.0) .and. lusesub)) then
         write(LuOut,'(A,I4,A,2f15.2)')"Ref.",iref," Half 2-e",cpu, wall
         call util_flush(LuOut)
         endif
        endif !read2e
c  2-e integrals second half
        write(namechunk,"(I3.3)")iref
        cpu = - util_cpusec()
        wall = - util_wallsec()
        call tce_mo2e_offset(l_v2_offsetm(iref),k_v2_offsetm(iref),
     1                       size_2em(iref))
        call tce_filename('v2'//namechunk,filename)
c       if((nodezero) .or. (ga_pgroup_nodeid(mypgid).eq.0)) 
        if((nodezero .and. (.not.lusesub)).or.
     +       ((ga_pgroup_nodeid(mypgid).eq.0) .and. lusesub))
     +   write(LuOut,'(A,A,A,I18)')
     +    "V 2-e ",filename(1:20)," in bytes= ",size_2em(iref)*8
        if(fast2e.eq.1) then
         if(lusesub) then
          call pgcreatefile(filename,d_v2m(iref),size_2em(iref),
     1    int_mb(k_innodes+innodes+ga_nodeid()))
         else
          call createfile(filename,d_v2m(iref),size_2em(iref))
         endif
         if(lread2e) then
          call tce_filenameindexed(iref,'mrvn_r',filename)
          unitn=77
          call read_tensor(filename,d_v2m(iref),size_2em(iref),unitn)
c         close(unitn)
c          if(nodezero) write(*,*) "I am here read mrvn_r"
          if(lusesub) then
           call ga_pgroup_sync(mypgid)
          else
           call reconcilefile(d_v2m(iref),size_2em(iref))
          endif
         else
          call tce_mrcc_mo2e(rtdb,d_ao2e,d_v2m(iref),k_v2_offsetm(iref),
     1     iref,d_v2m(1),k_v2_offsetm(1))
          if((nodezero .and. (.not.lusesub)).or.
     +       ((ga_pgroup_nodeid(mypgid).eq.0) .and. lusesub))
     +    write(LuOut,'(A,I4,A)')"Ref.",iref," 2-e transform. completed"
          if(lusesub) then
           call ga_pgroup_sync(mypgid)
          else
           call reconcilefile(d_v2m(iref),size_2em(iref))
          endif
          if(lsave2e) then
           call tce_filenameindexed(iref,'mrvn_r',filename)
           unitn=77
           call write_tensor(filename,d_v2m(iref),size_2em(iref),unitn)
c          close(unitn)
           if(lusesub) then
            call ga_pgroup_sync(mypgid)
           else
            call reconcilefile(d_v2m(iref),size_2em(iref))
           endif
          endif
         endif
         if(luseeaf2e) then 
          call ga_sync()
          call eaf_w_mrcc(eaf_han(iref),d_v2m(iref),size_2em(iref))
          call ga_sync()
          call deletefile(d_v2m(iref))
         endif
        else
         call errquit('tce_energy: invalid 2emet: ',fast2e,CALC_ERR)
        endif
c        if((nodezero) .or. (ga_pgroup_nodeid(mypgid).eq.0)) 
c     +   write(LuOut,*)'v2-size iref: ',size_2em(iref),iref
        cpu = cpu + util_cpusec()
        wall = wall + util_wallsec()
        if(((nodezero) .or. (ga_pgroup_nodeid(mypgid).eq.0)) 
     +   .and. mrccdebug) then
          write(LuOut,"('MO 2-e ints ',2f15.1)") cpu, wall
          call util_flush(LuOut)
        endif
       endif ! subgroups
      enddo ! nref
c
c     =========================
c       Allocations of T files
c     =========================
c
      if(nodezero) then
         write(LuOut,"(/,'Integral replication completed.',/,
     1 'Proceeding the allocation of the memory for intermediates.',/)")
      endif

      needt1 = .false.
      needt2 = .false.
      needt3 = .false.
      needt3a= .false.
      needr3act = .false.
      needr4act = .false.

      if (model.eq.'bwccsd') then
         needt1 = .true.
         needt2 = .true.
      elseif (model.eq.'bwccsdt') then
         needt1 = .true.
         needt2 = .true.
         needt3 = .true.
      elseif (model.eq.'mkccsd') then
         needt1 = .true.
         needt2 = .true.
      elseif (model.eq.'mkccsdt') then
         needt1 = .true.
         needt2 = .true.
         needt3 = .true.
      elseif (model.eq.'succsd') then
         needt1 = .true.
         needt2 = .true.
      endif

      do iref=1,nref

c        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
c     1 +innodes+ga_nodeid())).or.(.not.lusesub).or.
c     2 (model.eq.'mkccsd')) then
        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then


         k_sym = k_symm(iref)
         k_offset = k_offsetm(iref)
         k_range = k_rangem(iref)
         k_spin = k_spinm(iref)
         k_movecs_sorted = k_movecs_sortedm(iref)

c         k_evl_sorted = k_evl_sortedm(iref)
c         k_active = k_active_tmpm(iref)

         noa = nblcks(1,iref)
         nob = nblcks(2,iref)
         nva = nblcks(3,iref)
         nvb = nblcks(4,iref)

         noab = noa+nob
         nvab = nva+nvb

      if(needt2) then

        write(namechunk,"(I3.3)")iref
        call tce_filename('t2'//namechunk,filename)
        call tce_t2_offset(l_t2_offsetm(iref),k_t2_offsetm(iref),
     1 size_t2m(iref))

      if((nodezero .and. (.not.lusesub)).or.
     +((ga_pgroup_nodeid(mypgid).eq.0) .and. lusesub)) then
       write(LuOut,'(A,I5,A,I20)')
     +  "T2: ",iref," in bytes = ",size_t2m(iref)*8
       call util_flush(LuOut)
      endif
        if(lusesub.and..not.(model.eq.'mkccsd')) then
        call pgcreatefile(filename,d_t2m(iref),size_t2m(iref),
     1 int_mb(k_innodes+innodes+ga_nodeid()))
        else
          call createfile(filename,d_t2m(iref),size_t2m(iref))
          call reconcilefile(d_t2m(iref),size_t2m(iref))
        endif

        if(lreadt) then
           call tce_filenameindexed(iref,'mrt2',filename)
           unitn=79
           call read_tensor(filename,d_t2m(iref),size_t2m(iref),unitn)
c           close(unitn)
           call reconcilefile(d_t2m(iref),size_t2m(iref))
c           if(nodezero) write(*,*) "I am here read mrt2"
        endif

      endif



      if(needt1) then

        write(namechunk,"(I3.3)")iref
        call tce_filename('t1'//namechunk,filename)
        call tce_t1_offset(l_t1_offsetm(iref),k_t1_offsetm(iref),
     1 size_t1m(iref))

      if((nodezero .and. (.not.lusesub)).or.
     +((ga_pgroup_nodeid(mypgid).eq.0) .and. lusesub)) then
       write(LuOut,'(A,I5,A,I20)')
     +  "T1: ",iref," in bytes = ",size_t1m(iref)*8
       call util_flush(LuOut)
      endif
        if(lusesub.and..not.(model.eq.'mkccsd')) then
        call pgcreatefile(filename,d_t1m(iref),size_t1m(iref),
     1 int_mb(k_innodes+innodes+ga_nodeid()))
        else
        call createfile(filename,d_t1m(iref),size_t1m(iref))
        call reconcilefile(d_t1m(iref),size_t1m(iref))
        endif

        if(lreadt) then
           call tce_filenameindexed(iref,'mrt1',filename)
           unitn=78
           call read_tensor(filename,d_t1m(iref),size_t1m(iref),unitn)
c           close(unitn)
           call reconcilefile(d_t1m(iref),size_t1m(iref))
c           if(nodezero) write(*,*) "I am here read mrt1"
        endif

      endif




      if(needt3) then

        write(namechunk,"(I3.3)")iref
        call tce_filename('t3'//namechunk,filename)
        call tce_t3_offset(l_t3_offsetm(iref),k_t3_offsetm(iref),
     1 size_t3m(iref))
       if(nodezero) write(*,'(A,I5,I20)')"T3sz for",iref,size_t3m(iref)
        call createfile(filename,d_t3m(iref),size_t3m(iref))
c        call gatoeaf(d_t3m(iref))
c        call ga_zero(d_t3m(iref))
        call reconcilefile(d_t3m(iref),size_t3m(iref))

      endif
 
      if(lfullheff) then

c        write(namechunk,"(I3.3)")iref

c        call tce_filename('r3act'//namechunk,filename)
      call tce_t3ac_offset(l_r3a_offsetm(iref),k_r3a_offsetm(iref),
     1 size_r3am(iref),iref)
c        call createfile(filename,d_r3am(iref),size_r3am(iref))

c        call tce_filename('r4act'//namechunk,filename)
      call tce_r4ac_offset(l_r4a_offsetm(iref),k_r4a_offsetm(iref),
     1 size_r4am(iref),iref)
c        call createfile(filename,d_r4am(iref),size_r4am(iref))

      endif

      endif !sub

      enddo



c
c     =======================
c     Create residual offsets
c     =======================
c
      do iref=1,nref

         k_sym = k_symm(iref)
         k_offset = k_offsetm(iref)
         k_range = k_rangem(iref)
         k_spin = k_spinm(iref)
         k_movecs_sorted = k_movecs_sortedm(iref)
         k_active = k_active_tmpm(iref)
         noa = nblcks(1,iref)
         nob = nblcks(2,iref)
         nva = nblcks(3,iref)
         nvb = nblcks(4,iref)

         noab = noa+nob
         nvab = nva+nvb
  
      call tce_e_offset(l_e_offsetm(iref),k_e_offsetm(iref),
     1 size_em(iref))
      if (needt1) call tce_t1_offset(l_r1_offsetm(iref),
     1 k_r1_offsetm(iref),size_r1m(iref))
      if (needt2) then
         call tce_t2_offset(l_r2_offsetm(iref),
     1 k_r2_offsetm(iref),size_r2m(iref))
      endif
      if (needt3) call tce_t3_offset(l_r3_offsetm(iref),
     1 k_r3_offsetm(iref),size_r3m(iref))
c      if (needr3act) call tce_r3_offset(l_r3act_offsetm(iref),
c     1 k_r3act_offsetm(iref),size_r3actm(iref))
c      if (needr4act) call tce_r4_offset(l_r4act_offsetm(iref),
c     1 k_r4act_offsetm(iref),size_r4actm(iref))

c       if(nodezero)
c     1 write(LuOut,"(/,'Tasks for ref: ',I5,2I8)")iref,
c     2 int_mb(k_r1_offsetm(iref)), int_mb(k_r2_offsetm(iref))
 
      enddo
c
c     ======================
c        k_evl_sorted
c     ======================
c
c      call create_mr_evl_sorted(nref,k_f1_offsetm)
c
c     ======================
c        Heff matrix alloc
c     ======================
c
      if (.not.ma_push_get(mt_dbl,nref*nref,'Heff',l_heff,k_heff))
     1 call errquit('tce_mrcc_energy: MA problem',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,nref*nref,'sqc',l_sqc,k_sqc))
     1 call errquit('tce_sqc: MA problem',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,nref*nref,'sqc',l_sqcl,k_sqcl))
     1 call errquit('tce_sqcl: MA problem',0,MA_ERR)

      if(lusesub) then
        call tce_filename('g_heff',filename)
        call createfile(filename,g_heff,nref*nref)
        if(lbwcorr) then
        call tce_filename('corr',filename)
        call createfile(filename,d_corr,nref)
        endif
      endif

      if(nodezero) then
         write(LuOut,"('Done.',/)")
      endif
c
c     ===================
c       Refs symmetries
c     ===================
c
c      call tce_mrcc_refs_sym(nref)
      call tce_mrcc_refs_sym()
c
c     ================================
c       Set degenerated orb energies
c     ================================
c
c      if(forcedegen)call tce_mrcc_force_orben(nref)
      if(forcedegen)call tce_mrcc_force_orben()



c
c     ==============
c        Methods
c     ==============
c
#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
      if(lusesub) then
       do iref = 1, nref 
        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1   +innodes+ga_nodeid())).or.(.not.lusesub)) then
         if(.not.MA_PUSH_GET(mt_dbl,size_t1m(iref),'t1_local',
     +    l_t1_local,k_t1_local)) call errquit('t1_local',1,MA_ERR)
        call ma_zero(dbl_mb(k_t1_local),size_t1m(iref))
         if( ga_pgroup_nodeid(mypgid) .eq. 0) then
          call ga_get(d_t1m(iref),1,size_t1m(iref),1,1,
     +                dbl_mb(k_t1_local),1) 
         endif
         call ga_pgroup_brdcst(mypgid,65568,dbl_mb(k_t1_local),
     +    MA_sizeof(MT_DBL,1,MT_BYTE)*size_t1m(iref)*1,0)
        endif
       enddo
      endif
#endif





      if(lusesub) call ga_sync()

c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd begin
c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd begin
c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd begin


      if (model.eq.'bwccsd') then

       if(nodezero) write (LuOut,"('MR BWCCSD, version 1.0')")

       lsubterm = .true.

       cpu = - util_cpusec()
       wall = - util_wallsec()

       call tce_mrcc_diis_init()

       edelta =0.0d0

       do iter=1,maxiter

        itcpu2 = - util_cpusec()
        itwall2 = - util_wallsec()

c        if(nodezero) write(*,*) "I am here1"

#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
        if(lusesub) then
         do iref = 1, nref 
c         k_sym = k_symm(iref)
c         k_offset = k_offsetm(iref)
c         k_range = k_rangem(iref)
c         k_spin = k_spinm(iref)
c         k_movecs_sorted = k_movecs_sortedm(iref)
c         k_evl_sorted = k_evl_sortedm(iref)
c         k_active = k_active_tmpm(iref)
c         noa = nblcks(1,iref)
c         nob = nblcks(2,iref)
c         nva = nblcks(3,iref)
c         nvb = nblcks(4,iref)
c         noab = noa+nob
c         nvab = nva+nvb

          if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1     +innodes+ga_nodeid())).or.(.not.lusesub)) then
c           if(.not.MA_PUSH_GET(mt_dbl,size_t1m(iref),'t1_local',
c     +     l_t1_local,k_t1_local)) call errquit('t1_local',1,MA_ERR)
           call ma_zero(dbl_mb(k_t1_local),size_t1m(iref))
           if( ga_pgroup_nodeid(mypgid) .eq. 0) then
            call ga_get(d_t1m(iref),1,size_t1m(iref),1,1,
     +                dbl_mb(k_t1_local),1) 
           endif
           call ga_pgroup_brdcst(mypgid,65568,dbl_mb(k_t1_local),
     +         MA_sizeof(MT_DBL,1,MT_BYTE)*size_t1m(iref)*1,0)
          endif
         enddo
        endif
#endif



c        if(.not. lusesub) then
cckbn rootto overlap intialization
cc      if(nodezero) then
cc      write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+0)
cc      write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+1)
cc      write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+0)
cc      write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+1)
cc      endif
c         if(iter.eq.3) then
c          if(iroottooverlap.gt.0) then
c           if(nodezero) write(*,*) "iroottooverlap ", iroottooverlap
c           do i=1,nref
c            bwcoefwanted(i) = dbl_mb(k_sqc+(i-1)*nref+iroottooverlap-1) 
c           enddo
c           lrootfromoverlap = .true.
c           do i=1,nref
c            if(nodezero) write(*,'(A,F17.10)') 
c     +                   "bwcoefwanted",bwcoefwanted(i)
c           enddo
c          endif
c          mkrootold = mkroot
c          endif

ckbn root to overlap intialization
        if(.not. lusesub) then !ckbn can be removed
c         if(nodezero) then
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+0)
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+1)
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+0)
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+1)
c         endif
         if(iter.eq.iroottooverlapiter) then
          if(iroottooverlap.gt.0) then
c           if(nodezero) write(*,*) "iroottooverlap ", iroottooverlap
           if(nodezero) write(LuOut,'(A,I5,A,I5)')
     +      "Overlap selected from iteration ", iroottooverlapiter,
     +      " with respect to root ", iroottooverlap
           do i=1,nref
            bwcoefwanted(i) = dbl_mb(k_sqc+(i-1)*nref+iroottooverlap-1)
           enddo
           lrootfromoverlap = .true.
           do i=1,nref
            if(nodezero) write(*,'(A,I5,F17.10)')
     +       "Overlapping right eigen vector ",i,bwcoefwanted(i)
           enddo
          else
           call errquit('root to overlap not natural number',0,RTDB_ERR)
          endif
          mkrootold = mkroot
         endif


ckbn check if roots swapped
         if(iter.gt.4) then
          if(nodezero) then
c           write(LuOut,'(A,I3,A,I3)')
c     +          "mkroot",mkroot,"mkrootold",mkrootold
           if(mkroot.ne.mkrootold) then
            write(LuOut,'(A,I5,A,I5)') 
     +      "Warning: Eigenvector swap occured from",
     +      mkrootold," to ",mkroot
            call util_flush(LuOut)
           endif
          endif
          mkrootold = mkroot
         endif
        endif !.not. lusesub

c        if(nodezero) write(*,*) "I am here3"

        do iref=1,nref        

         if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1     +innodes+ga_nodeid())).or.(.not.lusesub)) then

          if(lusesub)
     1      ipg = int_mb(k_innodes+ga_nnodes()+ga_nodeid())

          g_movecs(1) = g_movecsm(iref,1)
          g_movecs(2) = g_movecsm(iref,2)

          k_sym = k_symm(iref)
          k_offset = k_offsetm(iref)
          k_range = k_rangem(iref)
          k_spin = k_spinm(iref)
          k_movecs_sorted = k_movecs_sortedm(iref)
          k_evl_sorted = k_evl_sortedm(iref)
          k_active = k_active_tmpm(iref)

          noa = nblcks(1,iref)
          nob = nblcks(2,iref)
          nva = nblcks(3,iref)
          nvb = nblcks(4,iref)

          noab = noa+nob
          nvab = nva+nvb

          write(namechunk,"(I3.3)")iref

c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step5 iter ref',iter,iref
c       call util_flush(6)
c      endif
c kk ---
          if(luseeaf2e) then
           call tce_filename('v2',filename)
           call createfile(filename,d_v2m(iref),size_2em(iref))
           call eaf_r_mrcc(eaf_han(iref),d_v2m(iref),size_2em(iref))
           call ga_sync()
          end if
c
          d_v2orb=d_v2m(iref)
c
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step6 iter ref',iter,iref
c       call util_flush(6)
c      endif
c kk ---
          call tce_filename('e'//namechunk,filename)

          if(lusesub) then
          call pgcreatefile(filename,d_em(iref),size_em(iref),mypgid)
#ifdef MRCC_LOCAL_FOCK
ckbn @todo : localize fock
#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
          call cxsd_e(k_f1_local,d_em(iref),k_t1_local,
     1                d_t2m(iref),d_v2m(iref),
     1                k_f1_offsetm(iref),k_e_offsetm(iref),
     2                k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                k_v2_offsetm(iref),ipg)
#else
          call cxsd_e(k_f1_local,d_em(iref),d_t1m(iref),
     1                d_t2m(iref),d_v2m(iref),
     1                k_f1_offsetm(iref),k_e_offsetm(iref),
     2                k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                k_v2_offsetm(iref),ipg)
#endif
#else
          call cxsd_e(d_f1m(iref),d_em(iref),d_t1m(iref),
     1                d_t2m(iref),d_v2m(iref),
     1                k_f1_offsetm(iref),k_e_offsetm(iref),
     2                k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                k_v2_offsetm(iref),ipg)
#endif

          else
          call createfile(filename,d_em(iref),size_em(iref))
          call mr_ccsd_e(d_f1m(iref),d_em(iref),d_t1m(iref),
     1               d_t2m(iref),d_v2m(iref),
     1               k_f1_offsetm(iref),k_e_offsetm(iref),
     2               k_t1_offsetm(iref),k_t2_offsetm(iref),
     2               k_v2_offsetm(iref))
        endif
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step6 iter ref',iter,iref
c       write(6,*)'ga mem used6',ga_inquire_memory()
c       write(6,*)'ga mem avail6',ga_memory_avail()
c       call util_flush(6)
c      endif
c kk ---

          call tce_filename('r1'//namechunk,filename)
       if(lusesub) then
          call pgcreatefile(filename,d_r1m(iref),size_r1m(iref),mypgid)
#ifdef MRCC_LOCAL_FOCK
ckbn @did : localize fock
#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
          call cxsd_t1(k_f1_local,d_r1m(iref),k_t1_local,
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r1_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),mypgid)
#else
          call cxsd_t1(k_f1_local,d_r1m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r1_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),mypgid)
#endif
#else
          call cxsd_t1(d_f1m(iref),d_r1m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r1_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),mypgid)
#endif
       else
          call createfile(filename,d_r1m(iref),size_r1m(iref))
          call mr_ccsd_t1(d_f1m(iref),d_r1m(iref),d_t1m(iref),
     1                d_t2m(iref),d_v2m(iref),
     1                k_f1_offsetm(iref),k_r1_offsetm(iref),
     2                k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                k_v2_offsetm(iref))
       endif
ccx          call reconcilefile(d_r1m(iref),size_r1m(iref))
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step7 iter ref',iter,iref
c       call util_flush(6)
c      endif
c kk ---



          call tce_filename('r2'//namechunk,filename)
       if(lusesub) then
          call pgcreatefile(filename,d_r2m(iref),size_r2m(iref),mypgid)
#ifdef MRCC_LOCAL_FOCK
ckbn @did : localize fock
#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
          call cxsd_t2(k_f1_local,d_r2m(iref),k_t1_local,
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r2_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),size_r2m(iref),mypgid)
#else
          call cxsd_t2(k_f1_local,d_r2m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r2_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),size_r2m(iref),mypgid)
#endif
#else
          call cxsd_t2(d_f1m(iref),d_r2m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r2_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),size_r2m(iref),mypgid)
#endif
       else
          call createfile(filename,d_r2m(iref),size_r2m(iref))
          call mr_ccsd_t2(d_f1m(iref),d_r2m(iref),d_t1m(iref),
     1                d_t2m(iref),d_v2m(iref),
     1                k_f1_offsetm(iref),k_r2_offsetm(iref),
     2                k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                k_v2_offsetm(iref),size_r2m(iref))
       endif
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step9 iter ref',iter,iref
c       call util_flush(6)
c      endif
c kk ---
c
c - T1/X1 LOCALIZATION --
          if(ic_cc) then
           if(.not.MA_POP_STACK(l_t1_local))
     &       call errquit('l_t1_local',2,MA_ERR)
          end if
c -----------------------
c
c kk ---

c          if(nodezero) write(*,*) "I am here4"

c_blocked_for_now      if(lfullheff) then
c_blocked_for_now
c_blocked_for_now          itcpu = - util_cpusec()
c_blocked_for_now          itwall = - util_wallsec()
c_blocked_for_now
c_blocked_for_now          call tce_filename('r3act'//namechunk,filename)
c_blocked_for_now          call createfile(filename,d_r3am(iref),size_r3am(iref))
c_blocked_for_nowc kk--
c_blocked_for_now          call ccsd_activet3(d_f1m(iref),d_r3am(iref),d_t1m(iref),
c_blocked_for_now     1                 d_t2m(iref),d_v2m(iref),
c_blocked_for_now     1                 k_f1_offsetm(iref),k_r3a_offsetm(iref),
c_blocked_for_now     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
c_blocked_for_now     2                 k_v2_offsetm(iref))
c_blocked_for_now          call reconcilefile(d_r3am(iref),size_r3am(iref))
c_blocked_for_now
c_blocked_for_now          itcpu = itcpu + util_cpusec()
c_blocked_for_now          itwall = itwall + util_wallsec()
c_blocked_for_now
c_blocked_for_now          if(nodezero) then
c_blocked_for_now            write(LuOut,"('R3 active: ',2f15.1)") itcpu, itwall
c_blocked_for_now            call util_flush(LuOut)
c_blocked_for_now          endif
c_blocked_for_now
c_blocked_for_now          itcpu = - util_cpusec()
c_blocked_for_now          itwall = - util_wallsec()
c_blocked_for_now
c_blocked_for_now          call tce_filename('r4act'//namechunk,filename)
c_blocked_for_now          call createfile(filename,d_r4am(iref),size_r4am(iref))
c_blocked_for_now
c_blocked_for_nowc kk--
c_blocked_for_now          call ccsd_activet4(d_r4am(iref),d_t1m(iref),d_t2m(iref),
c_blocked_for_now     1                 d_v2m(iref),k_r4a_offsetm(iref),
c_blocked_for_now     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
c_blocked_for_now     3                 k_v2_offsetm(iref))
c_blocked_for_now          call reconcilefile(d_r4am(iref),size_r4am(iref))
c_blocked_for_now
c_blocked_for_now          itcpu = itcpu + util_cpusec()
c_blocked_for_now          itwall = itwall + util_wallsec()
c_blocked_for_now
c_blocked_for_now          if(nodezero) then
c_blocked_for_now            write(LuOut,"('R4 active: ',2f15.1)") itcpu, itwall
c_blocked_for_now            call util_flush(LuOut)
c_blocked_for_now          endif
c_blocked_for_nowc kk--
c_blocked_for_now        endif

c          if (nodezero) call util_flush(LuOut)

c          call tce_residual_t1(d_r1m(iref),k_r1_offsetm(iref),r1(iref))
c          call tce_residual_t2(d_r2m(iref),k_r2_offsetm(iref),r2(iref))
c
c PNNL: kill global arrays for d_f1m(iref) & d_v2m(iref)
c DISKINT
          if(diskint.or.luseeaf2e) then
c           call deletefile(d_f1m(iref))
            call deletefile(d_v2m(iref))
          end if

         endif ! subgroups
c
        enddo !iref

        if(lusesub) call ga_sync()

c        do iref=1,nref
c        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
c     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then
c        if((lusesub.and.(ga_pgroup_nodeid(int_mb(k_innodes
c     1 +innodes+ga_nodeid())).eq.0)).or.
c     2 ((.not.lusesub).and.nodezero)) then
c            call tce_mrcc_debug_pfile(d_r2m(iref),size_r2m(iref),
c     1 'R2er',iter,iref)
c            call tce_mrcc_debug_pfile(d_r1m(iref),size_r1m(iref),
c     1 'R1er',iter,iref)
c        endif
c        endif
c          enddo
c
c     ==========================
c        Construction of Heff
c     ==========================
c
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step11 iter',iter
c       write(6,*)'ga mem used11',ga_inquire_memory()
c       write(6,*)'ga mem avail11',ga_memory_avail()
c       call util_flush(6)
c      endif
c kk ---
        do i=1,nref*nref
          dbl_mb(k_heff+i-1) = 0.0d0
        enddo

c          itcpu = - util_cpusec()
c          itwall = - util_wallsec()

c        if(nodezero) write(*,*) "I am here5"

        call tce_heff(d_em,k_e_offsetm,k_r1_offsetm,
     1       k_r2_offsetm,k_r3a_offsetm,k_r4a_offsetm,d_r1m,d_r2m,
     2       d_r3am,d_r4am,.true.,.true.,lfullheff,lfullheff,rtdb)

c        if(nodezero) write(*,*) "I am here6"


c          itcpu = itcpu + util_cpusec()
c          itwall = itwall + util_wallsec()

c          if(nodezero.and.lusesub) then
c            write(LuOut,"('HEFF: ',2f15.1)") itcpu, itwall
c            call util_flush(LuOut)
c          endif


c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step12 iter',iter
c       write(6,*)'ga mem used12',ga_inquire_memory()
c       write(6,*)'ga mem avail12',ga_memory_avail()
c       call util_flush(6)
c      endif
c kk ---
c          itcpu = - util_cpusec()
c          itwall = - util_wallsec()

c        if(nodezero) write(*,*) "I am here7"

c       call ga_sync()
        call tce_diagonalize_heff(rtdb,iter)
c       call ga_sync()
ckbn subg -4
c        write(LuOut,'(A,F17.10,I5,I5)') "ckbn epsilon",
c     + epsilon,iter,ga_nodeid()
c        call util_flush(LuOut)

c          itcpu = itcpu + util_cpusec()
c          itwall = itwall + util_wallsec()

c          if(nodezero) then
c            write(LuOut,"('DIAG: ',2f15.1)") itcpu, itwall
c            call util_flush(LuOut)
c          endif

c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step13 iter',iter
c       write(6,*)'ga mem used13',ga_inquire_memory()
c       write(6,*)'ga mem avail13',ga_memory_avail()
c       call util_flush(6)
c      endif
c kk ---

c        if(nodezero) write(*,*) "I am here8"

        if (nodezero) write(LuOut,"(/,'BWCC iter. #',I4,2f24.13,2f24.13,
     1     2f18.13)")iter,epsilon,enrep+epsilon,epsilon-edelta
ckbn        dsummary(iter,1) = enrep+epsilon
ckbn        dsummary(iter,2) = epsilon-duhfens(mkroot)
c
c     ==========================
c             Converged
c     ==========================
c
ckbn -4
c        if(nodezero) write(LuOut,"('ddot Rckbn:',3F16.12)")
c     1    dsqrt(ddotr1),dsqrt(ddotr2),(sqrt(ddotr2)+sqrt(ddotr1))

ckbn sub-2
ckbn sub-2        
c        call ga_sync()

        if(((abs(epsilon-edelta).lt.thresh).and.
     1    ((sqrt(ddotr2)+sqrt(ddotr1)).lt.thresh)).or.lconverged) then

         if(.not.lconverged) then
          lconverged = .true.
          if(nodezero) write (LuOut,
     +      "(/,'The MR-BWCCSD iteration has converged.',/)")

ckbnttttt
c         if(.not. lusesub) then
          if(lsavet) then
           if(nodezero) then
            write(LuOut,*) "Stored amplitudes are before ap correction"
            call util_flush(LuOut)
           endif
           do iref=1,nref
            call tce_filenameindexed(iref,'mrt1',filename)
            unitn=78
            call write_tensor(filename,d_t1m(iref),size_t1m(iref),unitn)
c           close(unitn)
            call tce_filenameindexed(iref,'mrt2',filename)
            unitn=79
            call write_tensor(filename,d_t2m(iref),size_t2m(iref),unitn)
c           close(unitn)
           enddo
          endif
c         endif
ckbnttttt

cxxx
ckbn-2 avoid a posteriori correction
c          if(nodezero)write(*,'(A,3F17.12)') 
c     +        "Tckbn ", epsilon,edelta,abs(epsilon-edelta)
          if(nodezero) 
     +      write (LuOut,"('No a posteriori correction to Energy: Iter',
     +      I4,3f24.13)") iter, epsilon, enrep+epsilon, epsilon-edelta
ckbn subg -2
          call ga_sync()
          if(no_aposteriori) goto 1333
cxxx

          goto 1222  ! a posteriori

         endif ! not lconverged
ckbnjjjj
ckbn*******************************************************************
ckbn**************************BWCCSD(T)********************************
ckbn*******************************************************************
 1333    continue ! After avoiding a posteriori correction

cx       if(lconverged)write(*,*) "Before", lconverged,ga_nodeid()
       if(se4t .and. lconverged )  then
ckbn subg -4
c       call dfill(maxref,0.d0,pt3_1m,1)
c       call dfill(maxref,0.d0,pt3_2m,1)
       call dfill(maxref,0.d0,pt3_3m,1)
       if(ga_pgroup_nodeid(mypgid).eq.0) call util_flush(LuOut)
       call ga_sync()
       if(lusesub)call ga_pgroup_sync(mypgid)
          itcpu3 = - util_cpusec()
          itwall3 = - util_wallsec()
          itcpu3_1 =  util_cpusec()
          itwall3_1 =  util_wallsec()

        if(lusesub) then
        if( ga_pgroup_nodeid(mypgid).eq.0) then
         if (.not.MA_PUSH_GET(mt_dbl,nref*nref,'(T) ptheff',l_ptheff,
     1        k_ptheff)) call errquit('ptheff: MA error',3,MA_ERR)
         call dfill(nref*nref,0.d0,dbl_mb(k_ptheff),1)
        endif
        endif

c        if(lusesub) call ga_print(g_heff)

        do irefpt=1,nref

        if((int_mb(k_refafi+irefpt-1).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then

         k_sym = k_symm(irefpt)
         k_offset = k_offsetm(irefpt)
         k_range = k_rangem(irefpt)
         k_spin = k_spinm(irefpt)
         k_movecs_sorted = k_movecs_sortedm(irefpt)
         k_evl_sorted = k_evl_sortedm(irefpt)
         k_active = k_active_tmpm(irefpt)

         noa = nblcks(1,irefpt)
         nob = nblcks(2,irefpt)
         nva = nblcks(3,irefpt)
         nvb = nblcks(4,irefpt)
         noab = noa+nob
         nvab = nva+nvb
       if(lusesub) then

        if (.not.MA_PUSH_GET(mt_dbl,size_r1m(irefpt),'t1_localpt',
     1      l_t1_localpt,k_t1_localpt))
     1      call errquit('t1_localpt',1,MA_ERR)
        call ma_zero(dbl_mb(k_t1_localpt),size_r1m(irefpt))
c    copy d_t1 ==> k_t1_local
         if( ga_pgroup_nodeid(mypgid) .eq. 0) then
          call ga_get(d_t1m(irefpt),1,size_r1m(irefpt),1,1,
     &                dbl_mb(k_t1_localpt),1) 
        endif
          call ga_pgroup_brdcst(mypgid,65540,dbl_mb(k_t1_localpt),
     +     MA_sizeof(MT_DBL,1,MT_BYTE)*size_r1m(irefpt)*1,0)

        if (.not.MA_PUSH_GET(mt_dbl,size_1em(irefpt),'f1_localpt',
     1      l_f1_localpt,k_f1_localpt))
     1      call errquit('f1_localpt',1,MA_ERR)
        call ma_zero(dbl_mb(k_f1_localpt),size_1em(irefpt))
c    copy d_f1 ==> k_f1_local
         if( ga_pgroup_nodeid(mypgid) .eq. 0) then
          call ga_get(d_f1m(irefpt),1,size_1em(irefpt),1,1,
     &                dbl_mb(k_f1_localpt),1) 
        endif
          call ga_pgroup_brdcst(mypgid,65541,dbl_mb(k_f1_localpt),
     +     MA_sizeof(MT_DBL,1,MT_BYTE)*size_1em(irefpt)*1,0)

       endif
       
       if(lusesub) then
        call tce_mrcc_ccsdpt_subg(k_t1_localpt,k_t1_offsetm(irefpt),
     +                           d_t2m(irefpt),k_t2_offsetm(irefpt),
     +                           d_v2m(irefpt),k_v2_offsetm(irefpt),
     +                           k_f1_localpt,
     +                           k_f1_offsetm(irefpt),
c     +                           pt3_1m(irefpt),pt3_2m(irefpt),
     +                           pt3_3m(irefpt),irefpt)

         else
          call tce_mrcc_ccsdpt(d_t1m(irefpt),k_t1_offsetm(irefpt),
     +                           d_t2m(irefpt),k_t2_offsetm(irefpt),
     +                           d_v2m(irefpt),k_v2_offsetm(irefpt),
     +                           d_f1m(irefpt),
     +                           k_f1_offsetm(irefpt),
c     +                           pt3_1m(irefpt),pt3_2m(irefpt),
     +                           pt3_3m(irefpt),irefpt)
       endif

        if(lusesub) then
c        if( ga_pgroup_nodeid(mypgid) .eq. 0) write(LuOut,'(A,I10)') 
c     +     "I am here my pgroup_nodeid ",ga_pgroup_nodeid(mypgid)
        call util_flush(LuOut)
        if( ga_pgroup_nodeid(mypgid) .eq. 0) then
         dbl_mb(k_ptheff+((irefpt-1)*nref+(irefpt-1)))=pt3_3m(irefpt)
        endif
        endif

        if(lusesub) then
         if(.not.MA_POP_STACK(l_f1_localpt))
     &      call errquit('l_t1_localpt',2,MA_ERR)
         if(.not.MA_POP_STACK(l_t1_localpt))
     &      call errquit('l_t1_localpt',2,MA_ERR)
        endif

c        if(lusesub) then
c        if( ga_pgroup_nodeid(mypgid).eq.0) then
c         write(LuOut,'(A,I5,F15.10)')"Correction to Heff from iref " ,
c     +     irefpt,pt3_3m(irefpt)
c        call util_flush(LuOut)
c        endif
c        else 
c        if(nodezero) then
c         write(LuOut,'(A,I5,F15.10)')"Correction to Heff from iref " ,
c     +     irefpt,pt3_3m(irefpt)
c        call util_flush(LuOut)
c        endif 
c        endif ! lusesub

       endif ! .not. lusesub
       end do

       if(lusesub) then
        if( ga_pgroup_nodeid(mypgid).eq.0)
     +    call ga_acc(g_heff,1,nref*nref,1,1,dbl_mb(k_ptheff),1,1.0d0)
       endif
       call ga_sync()

      if(.not.lusesub) then 
      do i=1,nref
       dbl_mb(k_heff+((i-1)*nref+(i-1)))=
     +       dbl_mb(k_heff+((i-1)*nref+(i-1)))+pt3_3m(i)
      enddo
      endif

        if(lusesub) then
        if( ga_pgroup_nodeid(mypgid).eq.0) then
         if (.not.MA_POP_STACK(l_ptheff)) 
     1    call errquit('ccsd_t',3,MA_ERR)
        endif
        endif

c        if(lusesub) call ga_print(g_heff)

       if(nodezero) then
        write(LuOut,"(/,'Final1 MR-BWCCSD energy before (T) correction:
     +     ',2F18.12)")epsilon+enrep
       endif

        call tce_diagonalize_heff(rtdb,iter)

       if(nodezero) then
        write(LuOut,"(/,'Final2 MR-BWCCSD energy after (T) correction:
     +     ',2F18.12)")epsilon+enrep
       endif

         itcpu3 = itcpu3 + util_cpusec()
         itwall3 = itwall3 + util_wallsec()
         itcpu3_2 =  util_cpusec()
         itwall3_2 = util_wallsec()
         call ga_dgop(mt_dbl,itcpu3 ,1,'max')
         call ga_dgop(mt_dbl,itwall3,1,'max')
         if(nodezero) then
            write(LuOut,"('Iter cpu (t) ',2f15.5)") itcpu3, itwall3
           write(LuOut,"('Iter cpu (t)n ',2f15.5)") (itcpu3_2-itcpu3_1),
     +                     (itwall3_2-itwall3_1)
            call util_flush(LuOut)
         endif

       endif

ckbn*******************************************************************

cxxx
         cpu = cpu + util_cpusec()
         wall = wall + util_wallsec()

         do iref=1,nref
          if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1      +innodes+ga_nodeid())).or.(.not.lusesub)) then
           call deletefile(d_em(iref))
           call deletefile(d_r1m(iref))
           call deletefile(d_r2m(iref))
           if(lfullheff) then
            call deletefile(d_r3am(iref))
            call deletefile(d_r4am(iref))
           endif
          endif !sub
         enddo ! nref
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step14 iter',iter
c       call util_flush(6)
c      endif
c kk ---

         call tce_mrcc_diis_tidy()

         if(nodezero) then
c     +     write(LuOut,"(/,'Final MR-BWCCSD energy and ecorr: ',2F18.12,
c     1     2F18.12)")epsilon+enrep,epsilon-duhfens(1)
c          write(LuOut,"('A posteriori correction: ',2F18.12,
c     1     2F18.12,/)")epsilon-edelta
ckbn          call tce_mrcc_print_summary(iter,dsummary)

          write(LuOut,*)""
          write(LuOut,'(A)')
     +"=================================================="//
     +"==================================================="
          write(LuOut,*)""
          if( .not. se4t ) then
           if(.not. no_aposteriori) write(LuOut,9080) 
     +      "BW-MRCCSD with a posteriori correction ",
     +      epsilon+enrep
           if(no_aposteriori) write(LuOut,9080)
     +      "BW-MRCCSD without a posteriori correction ",
     +      epsilon+enrep
          else
           if(.not. no_aposteriori) write(LuOut,9080)
     +      "BW-MRCCSD(T) with a posteriori correction ",
     +      epsilon+enrep
           if(no_aposteriori) write(LuOut,9080)
     +      "BW-MRCCSD(T) without a posteriori correction ",
     +      epsilon+enrep
          endif
          if(iter.le.6) write(LuOut,*) "Converged below 6 iterations!"//
     +     " Please rerun with higher convergence threshold."
          write(LuOut,*)""
          write(LuOut,'(A)')
     +"=================================================="//
     +"==================================================="
          write(LuOut,*)""
          write(LuOut,9220) cpu, wall
          call util_flush(LuOut)
         endif ! nodezero 

         tce_mrcc_energy = .true.
         if (.not.rtdb_put(rtdb,'tce:energy',mt_dbl,1,epsilon+enrep))
     1        call errquit('tce_energy: RTDB problem',0,MA_ERR)
         if (nodezero) call util_flush(LuOut)

c      call ga_print(d_f1m(1))
c      call ga_print(d_f1m(2))
c      call ga_print(d_f1m(3))
c      call ga_print(d_f1m(4))
         goto 1000

        endif ! energy convergence check
c
c     ==========================
c             Update T's  
c     ==========================
c
 1222   continue
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step15 iter',iter
c       call util_flush(6)
c      endif
c kk ---

        do iref=1,nref
c        write(6,*)'TEST1',ga_nodeid(),iref
         if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1    +ga_nnodes()+ga_nodeid())).or.(.not.lusesub)) then

          g_movecs(1) = g_movecsm(iref,1)
          g_movecs(2) = g_movecsm(iref,2)

          k_sym = k_symm(iref)
          k_offset = k_offsetm(iref)
          k_range = k_rangem(iref)
          k_spin = k_spinm(iref)
          k_movecs_sorted = k_movecs_sortedm(iref)
          k_evl_sorted = k_evl_sortedm(iref)

          noa = nblcks(1,iref)
          nob = nblcks(2,iref)
          nva = nblcks(3,iref)
          nvb = nblcks(4,iref)

          noab = noa+nob
          nvab = nva+nvb

          mrccshift = epsilon - dbl_mb(k_heff+iref-1+(iref-1)*nref) ! Global denominator shift
c         write(6,*)'BWSHIFT: ',mrccshift,ga_nodeid(),int_mb(k_innodes+
c     1 ga_nnodes()+ga_nodeid())
          if(lconverged) mrccshift = 0.0d0 ! a posteriori corr

c
c     ==========================
c       Add DCl,L and UL terms
c     ==========================
c
          if(.not.lconverged) then      ! a posteriori corr
c           write(*,*) "I am here 1 dcl ul"

           itcpu = - util_cpusec()
           itwall = - util_wallsec()

         if(lusesub) then
#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
          call xalf_t1t1_1(d_r1m(iref),k_r1_offsetm(iref),k_t1_local,
     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
          call ga_pgroup_sync(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
#else
          call xalf_t1t1_1(d_r1m(iref),k_r1_offsetm(iref),d_t1m(iref),
     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
          call ga_pgroup_sync(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
#endif
         else
           call mr_half_t1t1_1(d_r1m(iref),k_r1_offsetm(iref),
     +           d_t1m(iref),k_t1_offsetm(iref),d_r2m(iref),
     +           k_r2_offsetm(iref))
           call reconcilefile(d_r2m(iref),size_r2m(iref))
         endif

         if(lusesub) then
#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
          call xcl_t1t1_1(k_t1_local,k_t1_offsetm(iref),k_t1_local,
     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
          call ga_pgroup_sync(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
#else
          call xcl_t1t1_1(d_t1m(iref),k_t1_offsetm(iref),d_t1m(iref),
     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
          call ga_pgroup_sync(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
#endif
         else
           call dcl_t1t1_1(d_t1m(iref),k_t1_offsetm(iref),d_t1m(iref),
     &           k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
           call reconcilefile(d_r2m(iref),size_r2m(iref))
         endif

           itcpu = itcpu + util_cpusec()   
           itwall = itwall + util_wallsec()


          endif ! not lconverged
c kk ---
c      if(nodezero) then
c       write(6,*)'mrcc step16 iter',iter
c       call util_flush(6)
c      endif
c kk ---
c        write(6,*)'TEST2',ga_nodeid(),iref
          itcpu = - util_cpusec()
          itwall = - util_wallsec()

c          residual = residual + sqrt(ga_ddot(d_r2m(iref),d_r2m(iref)))/
c     1 size_t2m(iref)
cnewdii      call tce_mrcc_diis_new(.false.,iter,.true.,.true.,.true.,.false.,
cnewdii     1  d_r1m,d_t1m,k_t1_offsetm,size_t1m,
cnewdii     2  d_r2m,d_t2m,k_t2_offsetm,size_t2m,
cnewdii     3  d_r3m,d_t3m,k_t3_offsetm,size_t3m,
cnewdii     4  dummy,dummy,dummy,dummy,
cnewdii     5  rtdb,iref)

          call tce_mrcc_diis(.false.,iter,.true.,.true.,.false.,.false.,
     1                  d_r1m(iref),d_t1m(iref),k_t1_offsetm(iref),
     1                  size_t1m(iref),d_r2m(iref),d_t2m(iref),
     2                  k_t2_offsetm(iref),size_t2m(iref),
     3                  dummy,dummy,dummy,dummy,
     4                  dummy,dummy,dummy,dummy,rtdb,iref)


          itcpu = itcpu + util_cpusec()
          itwall = itwall + util_wallsec()



         endif !sub
        enddo !iref


ckbn #ifdef MRCC_LOCAL_T1 as update was done on d_t1(iref) in tce_jacobi_sub_t1 zero global part
        call tce_internal_t_zero(d_t1m,d_t2m,k_t1_offsetm,
     1        k_t2_offsetm,.false.,dummy,dummy,rtdb)

c
c     ==========================
c             DDOT conv.
c     ==========================
c

c        if(.not.lusesub) then
c
c        call tce_internal_t_zero(d_r1m,d_r2m,k_t1_offsetm,
c     1 k_t2_offsetm,nref,.false.,dummy,dummy,rtdb)

c          ddotr1 = 0.0d0
c          ddotr2 = 0.0d0

c        do iref=1,nref
c
c          ddotr1 = ga_ddot(d_r1m(iref),d_r1m(iref))
c          ddotr2 = ga_ddot(d_r2m(iref),d_r2m(iref))

c        enddo
c
c         if(nodezero)write(LuOut,"('ddot R:',2F16.12)")sqrt(ddotr1),
c     1 sqrt(ddotr2)

c        endif


        do iref=1,nref
         if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1    +ga_nnodes()+ga_nodeid())).or.(.not.lusesub)) then
          call deletefile(d_em(iref))
          call deletefile(d_r1m(iref))
          call deletefile(d_r2m(iref))
          if(lfullheff) then
           call deletefile(d_r3am(iref))
           call deletefile(d_r4am(iref))
          endif
          if (nodezero) call util_flush(LuOut)
         endif
        enddo


        edelta = epsilon

        itcpu2 = itcpu2 + util_cpusec()
        itwall2 = itwall2 + util_wallsec()

        if(nodezero) then
          write(LuOut,9222) itcpu2, itwall2
          call util_flush(LuOut)
        endif

        if(lcheckpoints) then
         if(mod(iter,icheckpoint).eq.0) then
          do iref=1,nref
           call tce_filenameindexed(iref,'mrt1',filename)
           unitn=76
           call write_tensor(filename,d_t1m(iref),size_t1m(iref),unitn)
c          close(unitn)
           call tce_filenameindexed(iref,'mrt2',filename)
           unitn=77
           call write_tensor(filename,d_t2m(iref),size_t2m(iref),unitn)
c          close(unitn)
          enddo
         endif
        endif

       enddo !maxiter

       call errquit('tce_energy: maxiter exceeded',iter,CALC_ERR)

 1000  continue
c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd end
c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd end
c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd end
c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd end
c bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd bwccsd end

c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd begin 
c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd begin 
c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd begin 

c
c     ===============
c     Mk CCSD method
c     ===============
c
      else if (model.eq.'mkccsd') then

       if(nodezero) write (LuOut,"('MR MkCCSD, version 1.0')")

ckbn
       if(lusesub) then
        if(nodezero) write (LuOut,
     +    "('In this version MR MkCCSD in subgroup doesnt work')")
        call errquit('Subgroups not present in MR MKCCSD',1,MA_ERR)
       endif

       cpu = - util_cpusec()
       wall = - util_wallsec()

       call tce_mrcc_diis_init()

       edelta =0.0d0

c      call ga_sync()

c -----------------
c  Loop over iters
c -----------------
c
       do iter=1,maxiter

        itcpu = - util_cpusec()
        itwall = - util_wallsec()


cckbn root to overlap intialization
c        if(.not. lusesub) then !ckbn can be removed
cc         if(nodezero) then
cc         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+0)
cc         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+1)
cc         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+0)
cc         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+1)
cc         endif
c         if(iter.eq.3) then
c          if(iroottooverlap.gt.0) then
c           if(nodezero) write(*,*) "iroottooverlap ", iroottooverlap
c           do i=1,nref
c            bwcoefwanted(i) = dbl_mb(k_sqc+(i-1)*nref+iroottooverlap-1) 
c           enddo
c           lrootfromoverlap = .true.
c           do i=1,nref
c            if(nodezero)
c     +        write(*,'(A,F17.10)')"bwcoefwanted",bwcoefwanted(i)
c           enddo
c          endif
c          mkrootold = mkroot
c         endif

ckbn root to overlap intialization
        if(.not. lusesub) then !ckbn can be removed
c         if(nodezero) then
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+0)
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(0)*nref+1)
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+0)
c         write(*,*)"ckbn iter",iter,dbl_mb(k_sqc+(1)*nref+1)
c         endif
         if(iter.eq.iroottooverlapiter) then
          if(iroottooverlap.gt.0) then
c           if(nodezero) write(*,*) "iroottooverlap ", iroottooverlap
           if(nodezero) write(LuOut,'(A,I5,A,I5)')
     +      "Overlap selected from iteration ", iroottooverlapiter,
     +      " with respect to root ", iroottooverlap
           do i=1,nref
            bwcoefwanted(i) = dbl_mb(k_sqc+(i-1)*nref+iroottooverlap-1)
           enddo
           lrootfromoverlap = .true.
           do i=1,nref
            if(nodezero) write(*,'(A,I5,F17.10)')
     +       "Overlapping right eigen vector ",i,bwcoefwanted(i)
           enddo
          else
           call errquit('root to overlap not natural number',0,RTDB_ERR)
          endif
          mkrootold = mkroot
         endif



ckbn check if roots swapped
         if(iter.gt.4) then
          if(nodezero) then
c           write(LuOut,'(A,I3,A,I3)')"mkroot",mkroot,
c     +      "mkrootold",mkrootold
           call util_flush(LuOut)
           if(mkroot.ne.mkrootold) then
             write(LuOut,'(A,I5,A,I5)') 
     +      "Warning: Eigenvector swap occured from",
     +      mkrootold," to ",mkroot
           endif
          endif
          mkrootold = mkroot
         endif
         call util_flush(LuOut)
        endif ! ckbn can be removed

c
c -----------------
c  Loop over refs
c -----------------
c
        do iref=1,nref
c

        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then

        if(lusesub)
     1   ipg = int_mb(k_innodes+ga_nnodes()+ga_nodeid())

         g_movecs(1) = g_movecsm(iref,1)
         g_movecs(2) = g_movecsm(iref,2)

         k_sym = k_symm(iref)
         k_offset = k_offsetm(iref)
         k_range = k_rangem(iref)
         k_spin = k_spinm(iref)
         k_movecs_sorted = k_movecs_sortedm(iref)
         k_evl_sorted = k_evl_sortedm(iref)
         k_active = k_active_tmpm(iref)

         noa = nblcks(1,iref)
         nob = nblcks(2,iref)
         nva = nblcks(3,iref)
         nvb = nblcks(4,iref)

         noab = noa+nob
         nvab = nva+nvb

          write(namechunk,"(I3.3)")iref
c
c - T1/X1 LOCALIZATION ----------
        if(ic_cc) then
        if (.not.MA_PUSH_GET(mt_dbl,size_r1m(iref),'t1_local',
     1      l_t1_local,k_t1_local))
     1      call errquit('t1_local',1,MA_ERR)
        call ma_zero(dbl_mb(k_t1_local),size_r1m(iref))
c    copy d_t1 ==> l_t1_local
        call ga_get(d_t1m(iref),1,size_r1m(iref),1,1,
     &       dbl_mb(k_t1_local),1)
        end if

c kk ---
c PNNL: create global arrays for d_f1m(iref) & d_v2m(iref)
c PNNL: read on d_f1m(iref) d_v2m(iref) from a disk
c PNNL: set d_v2orb to the current handle of d_v2m(iref)
c
          d_v2orb=d_v2m(iref)

          call tce_filename('e'//namechunk,filename)
          if(lusesub) then
          call pgcreatefile(filename,d_em(iref),size_em(iref),mypgid)
          call cxsd_e(d_f1m(iref),d_em(iref),d_t1m(iref),
     1                d_t2m(iref),d_v2m(iref),
     1                k_f1_offsetm(iref),k_e_offsetm(iref),
     2                k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                k_v2_offsetm(iref),ipg)
          else
          call createfile(filename,d_em(iref),size_em(iref))
          call mr_ccsd_e(d_f1m(iref),d_em(iref),d_t1m(iref),
     1                d_t2m(iref),d_v2m(iref),
     1                k_f1_offsetm(iref),k_e_offsetm(iref),
     2                k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                k_v2_offsetm(iref))
          endif
          call tce_filename('r1'//namechunk,filename)
       if(lusesub) then
          call pgcreatefile(filename,d_r1m(iref),size_r1m(iref),mypgid)
          call cxsd_t1(d_f1m(iref),d_r1m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r1_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),mypgid)
       else
          call createfile(filename,d_r1m(iref),size_r1m(iref))
          call mr_ccsd_t1(d_f1m(iref),d_r1m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r1_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref))
       endif


          call tce_filename('r2'//namechunk,filename)
       if(lusesub) then
          call pgcreatefile(filename,d_r2m(iref),size_r2m(iref),mypgid)
          call cxsd_t2(d_f1m(iref),d_r2m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r2_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),size_r2m(iref),mypgid)
       else
          call createfile(filename,d_r2m(iref),size_r2m(iref))
          call mr_ccsd_t2(d_f1m(iref),d_r2m(iref),d_t1m(iref),
     1                 d_t2m(iref),d_v2m(iref),
     1                 k_f1_offsetm(iref),k_r2_offsetm(iref),
     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
     2                 k_v2_offsetm(iref),size_r2m(iref))
       endif

c - T1/X1 LOCALIZATION --
        if(ic_cc) then
         if(.not.MA_POP_STACK(l_t1_local))
     &      call errquit('l_t1_local',2,MA_ERR)
        end if
c -----------------------

c_blocked_for_now      if(lfullheff) then
c_blocked_for_now
c_blocked_for_now          call tce_filename('r3act'//namechunk,filename)
c_blocked_for_now          call createfile(filename,d_r3am(iref),size_r3am(iref))
c_blocked_for_nowc kk--
c_blocked_for_now          call ccsd_activet3(d_f1m(iref),d_r3am(iref),d_t1m(iref),
c_blocked_for_now     1                 d_t2m(iref),d_v2m(iref),
c_blocked_for_now     1                 k_f1_offsetm(iref),k_r3a_offsetm(iref),
c_blocked_for_now     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
c_blocked_for_now     2                 k_v2_offsetm(iref))
c_blocked_for_now          call reconcilefile(d_r3am(iref),size_r3am(iref))
c_blocked_for_now
c_blocked_for_now          call tce_filename('r4act'//namechunk,filename)
c_blocked_for_now          call createfile(filename,d_r4am(iref),size_r4am(iref))
c_blocked_for_now
c_blocked_for_nowc kk--
c_blocked_for_now          call ccsd_activet4(d_r4am(iref),d_t1m(iref),d_t2m(iref),
c_blocked_for_now     1                 d_v2m(iref),k_r4a_offsetm(iref),
c_blocked_for_now     2                 k_t1_offsetm(iref),k_t2_offsetm(iref),
c_blocked_for_now     3                 k_v2_offsetm(iref))
c_blocked_for_now          call reconcilefile(d_r4am(iref),size_r4am(iref))
c_blocked_for_nowc kk--
c_blocked_for_now        endif

          if (nodezero) call util_flush(LuOut)

         if(diskint) then
c          call deletefile(d_f1m(iref))
          call deletefile(d_v2m(iref))
         end if

        endif ! sub filter

        enddo !iref

        if(lusesub) call ga_sync()

c
c     ==========================
c        Construction of Heff
c     ==========================
c
        do i=1,nref*nref
          dbl_mb(k_heff+i-1) = 0.0d0
        enddo

        do i=1,nref*nref
          dbl_mb(k_sqc+i-1) = 0.0d0
        enddo


c        call tce_heff(nref,d_em,k_e_offsetm,k_r1_offsetm,
        call tce_heff(d_em,k_e_offsetm,k_r1_offsetm,
     1 k_r2_offsetm,k_r3a_offsetm,k_r4a_offsetm,d_r1m,d_r2m,
     2 d_r3am,d_r4am,.true.,.true.,lfullheff,lfullheff,rtdb)


c        call tce_diagonalize_heff(nref,rtdb)
        call tce_diagonalize_heff(rtdb,iter)

        if (nodezero) write(LuOut,"(/,'MkCC iter. #',I4,2f24.13,2f24.13,
     1 2f18.13)")iter,epsilon,enrep+epsilon,epsilon-edelta
        if (nodezero) call util_flush(LuOut)

ckbn        dsummary(iter,1) = enrep+epsilon
ckbn        dsummary(iter,2) = epsilon-duhfens(1)
c
c     ==========================
c             Converged
c     ==========================
c
ckbn diis ***
c         if(nodezero)write(LuOut,"('ddot Rckbn:',i5,4F16.12)")iref,
c     1 dsqrt(ddotr1),dsqrt(ddotr2),
c     1 sqrt(ddotr1),sqrt(ddotr2)
        if(((abs(epsilon-edelta).lt.thresh).and.
     1 ((sqrt(ddotr2)+sqrt(ddotr1)).lt.thresh)).or.lconverged) then

          if(.not.lconverged) then
             lconverged = .true.
             if(nodezero) then
             write(LuOut,"(/,'The MR-MkCCSD iteration has converged.',
     1 /)")
             call util_flush(LuOut)
             end if
c             goto 1223
          endif
ckbnttttt
        if(lsavet) then
          if(nodezero) 
     +     write(LuOut,*) "Stored amplitudes"
          call util_flush(LuOut)
          do iref=1,nref
           call tce_filenameindexed(iref,'mrt1',filename)
           unitn=78
           call write_tensor(filename,d_t1m(iref),size_t1m(iref),unitn)
c           close(unitn)
           call tce_filenameindexed(iref,'mrt2',filename)
           unitn=79
           call write_tensor(filename,d_t2m(iref),size_t2m(iref),unitn)
c           close(unitn)
          enddo
        endif
ckbnttttt

ckbn*******************************************************************
ckbn**************************MkCCSD(T)********************************
ckbn*******************************************************************
ckbn   SE4T for MkCC
c       if((se4t .and. lconverged) .or. (uncoup_pt3 .and. lconverged)) 
       if((se4t .and. lconverged) ) then
        call ga_sync()
        if(lusesub) call errquit(
     +   'tce_mrcc_energy: Subgroups not supported in Mk-MRCCSD(T)',30,
     +    INPUT_ERR)

          itcpu3 = - util_cpusec()
          itwall3 = - util_wallsec()
c       call dfill(maxref,0.d0,pt3_1m,1)
c       call dfill(maxref,0.d0,pt3_2m,1)
       call dfill(maxref,0.d0,pt3_3m,1)

        do irefpt=1,nref

         k_sym = k_symm(irefpt)
         k_offset = k_offsetm(irefpt)
         k_range = k_rangem(irefpt)
         k_spin = k_spinm(irefpt)
         k_movecs_sorted = k_movecs_sortedm(irefpt)
         k_evl_sorted = k_evl_sortedm(irefpt)
         k_active = k_active_tmpm(irefpt)
         noa = nblcks(1,irefpt)
         nob = nblcks(2,irefpt)
         nva = nblcks(3,irefpt)
         nvb = nblcks(4,irefpt)
         noab = noa+nob
         nvab = nva+nvb

c          if(nodezero) write(*,*) "Call tce_mrcc_ccsdpt"
          call tce_mrcc_ccsdpt(d_t1m(irefpt),k_t1_offsetm(irefpt),
     +                           d_t2m(irefpt),k_t2_offsetm(irefpt),
     +                           d_v2m(irefpt),k_v2_offsetm(irefpt),
     +                           d_f1m(irefpt),
     +                           k_f1_offsetm(irefpt),
c     +                           pt3_1m(irefpt),pt3_2m(irefpt),
     +                           pt3_3m(irefpt),irefpt)
c       if(nodezero) then
cckbn       write(*,*)"E4T  ","iref",irefpt," ",pt3_1m(irefpt) 
c        write(*,'(A,I5,F15.10)')"Correction to Heff from iref " ,
c     +    irefpt,pt3_3m(irefpt)
c       endif 


        end do

      do i=1,nref
       dbl_mb(k_heff+((i-1)*nref+(i-1)))=
     +       dbl_mb(k_heff+((i-1)*nref+(i-1)))+pt3_3m(i)
      enddo

       if(nodezero) then
        write(LuOut,"(/,'Final1 MR-MkCCSD energy before (T) correction:
     +     ',2F18.12)")epsilon+enrep
       endif

        call ga_sync()
        call tce_diagonalize_heff(rtdb,iter)

       if(nodezero) then
        write(LuOut,"(/,'Final2 MR-MkCCSD energy after (T) correction:
     +     ',2F18.12)")epsilon+enrep
       endif
         itcpu3 = itcpu3 + util_cpusec()
         itwall3 = itwall3 + util_wallsec()
         if(nodezero) then
            write(LuOut,"('Iter cpu (t) ',2f15.5)") itcpu3, itwall3
            call util_flush(LuOut)
         endif

       endif ! se4t
ckbn*******************************************************************



          do iref=1,nref
        if((int_mb(k_refafi+iref-1).eq.mypgid).or.(.not.lusesub)) then
           call deletefile(d_em(iref))
           call deletefile(d_r1m(iref))
           call deletefile(d_r2m(iref))
           if(lfullheff)call deletefile(d_r3am(iref))
           if(lfullheff)call deletefile(d_r4am(iref))
        endif
          enddo

          call tce_mrcc_diis_tidy()

          if(nodezero) then
ckbn           call tce_mrcc_print_summary(iter,dsummary)

           write(LuOut,*) ""
           write(LuOut,'(A)')
     +"=================================================="//
     +"==================================================="
           write(LuOut,*)""
           if(.not. se4t) write(LuOut,9080)
     +     "Mk-MRCCSD ",epsilon+enrep

           if(se4t) write(LuOut,9080)
     +     "Mk-MRCCSD(T) ",epsilon+enrep

          if(iter.le.6) write(LuOut,*) "Converged below 6 iterations!"//
     +     " Please rerun with higher convergence threshold."

           write(LuOut,*) ""
           write(LuOut,'(A)')
     +"=================================================="//
     +"==================================================="
           write(LuOut,*)""
           call util_flush(LuOut)
          endif

           tce_mrcc_energy = .true.
           if (.not.rtdb_put(rtdb,'tce:energy',mt_dbl,1,epsilon+enrep))
     1        call errquit('tce_energy: RTDB problem',0,MA_ERR)

          if (nodezero) call util_flush(LuOut)

           goto 1001

        endif
c
c     ==============================
c             Update R's and T's  
c     ==============================
c
 1223   continue

        call tce_mrcc_diis_save(.false.,iter,
     1 .true.,.true.,.false.,.false.,
     1  d_r1m,d_t1m,k_t1_offsetm,size_t1m,
     2  d_r2m,d_t2m,k_t2_offsetm,size_t2m,
     3  dummy,dummy,dummy,dummy,
     4  dummy,dummy,dummy,dummy,
     5  rtdb)

cjb update r's
        do iref=1,nref

        if((int_mb(k_refafi+iref-1).eq.mypgid).or.(.not.lusesub)) then

         g_movecs(1) = g_movecsm(iref,1)
         g_movecs(2) = g_movecsm(iref,2)

         k_sym = k_symm(iref)
         k_offset = k_offsetm(iref)
         k_range = k_rangem(iref)
         k_spin = k_spinm(iref)
         k_movecs_sorted = k_movecs_sortedm(iref)
         k_evl_sorted = k_evl_sortedm(iref)
         k_active = k_active_tmpm(iref)

         noa = nblcks(1,iref)
         nob = nblcks(2,iref)
         nva = nblcks(3,iref)
         nvb = nblcks(4,iref)

         noab = noa+nob
         nvab = nva+nvb


c
c     ==========================
c       Add DCl,L and UL terms
c     ==========================
c
c_blocked         if(iter.le.istartmk) then
c_blocked
c_blocked         lsubterm = .true.
c_blocked         diis = 0

c_blocked         mrccshift = epsilon - dbl_mb(k_heff+iref-1+(iref-1)*nref) ! Global denominator shift

c_blocked_for_now         if(lusesub) then
c_blocked_for_now          call xalf_t1t1_1(d_r1m(iref),k_r1_offsetm(iref),d_t1m(iref),
c_blocked_for_now     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
c_blocked_for_now          call ga_pgroup_sync(mypgid)
c_blocked_for_now         else
c_blocked          call half_t1t1_1(d_r1m(iref),k_r1_offsetm(iref),d_t1m(iref),
c_blocked     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
c_blocked          call reconcilefile(d_r2m(iref),size_r2m(iref))
c_blocked_for_now         endif
c_blocked_for_now
c_blocked_for_now         if(lusesub) then
c_blocked_for_now          call xcl_t1t1_1(d_t1m(iref),k_t1_offsetm(iref),d_t1m(iref),
c_blocked_for_now     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
c_blocked_for_now          call ga_pgroup_sync(mypgid)
c_blocked_for_now         else
c_blocked          call dcl_t1t1_1(d_t1m(iref),k_t1_offsetm(iref),d_t1m(iref),
c_blocked     & k_t1_offsetm(iref),d_r2m(iref),k_r2_offsetm(iref))
c_blocked          call reconcilefile(d_r2m(iref),size_r2m(iref))
c_blocked_for_now         endif
c_blocked_for_now
c_blocked         else

        lsubterm = .false.

         if(iter.eq.(istartmk+1)) then
      if (.not.rtdb_get(rtdb,'tce:diis',mt_int,1,diis)) then
        diis = 5
         endif
         endif

         cpu = - util_cpusec()
         wall = - util_wallsec()

c         call tce_mrcc_c1(size_t1m,k_t1_offsetm,d_t1m,nref,iref,
c     1 d_r1m,k_r1_offsetm)
         call tce_mrcc_c1(size_t1m,k_t1_offsetm,d_t1m,iref,
     1 d_r1m,k_r1_offsetm)

         cpu = cpu + util_cpusec()
         wall = wall + util_wallsec()

c         if(iref.eq.1) then
c            write(LuOut,"('C1 ',2f15.1,I4)") cpu, wall,iref
c            call util_flush(LuOut)
c         endif

         cpu = - util_cpusec()
         wall = - util_wallsec()

c         call tce_mrcc_c2(size_t2m,k_t1_offsetm,d_t1m,nref,iref,
c     1 k_t2_offsetm,d_t2m,d_r2m,k_r2_offsetm,size_t1m)
         call tce_mrcc_c2(size_t2m,k_t1_offsetm,d_t1m,iref,
     1 k_t2_offsetm,d_t2m,d_r2m,k_r2_offsetm,size_t1m)

         cpu = cpu + util_cpusec()
         wall = wall + util_wallsec()

c         if(nodezero) then
c         if(iref.eq.1) then
c            write(LuOut,"('C2 ',2f15.1,I4)") cpu, wall,iref
c            call util_flush(LuOut)
c         endif
c         endif

c_blocked        endif
        endif
        enddo

cjb continue in updating of T's 

        if(lusesub)call ga_sync()

        call tce_internal_t_zero(d_r1m,d_r2m,k_t1_offsetm,
     1 k_t2_offsetm,.false.,dummy,dummy,rtdb)

c             DDOT conv.
        if(.not.lusesub) then
          ddotr1 = 0.0d0
          ddotr2 = 0.0d0
         do iref=1,nref
          ddotr1 = ddotr1 + ga_ddot(d_r1m(iref),d_r1m(iref)) *
     2             dbl_mb(k_sqc+(iref-1)*nref+mkroot-1)*
     3             dbl_mb(k_sqc+(iref-1)*nref+mkroot-1)

          ddotr2 = ddotr2 + ga_ddot(d_r2m(iref),d_r2m(iref)) *
     2             dbl_mb(k_sqc+(iref-1)*nref+mkroot-1)*
     3             dbl_mb(k_sqc+(iref-1)*nref+mkroot-1)

c          if(nodezero) write(LuOut,"('ddot R:',i5,2F16.12)")iref,
c     1                      dsqrt(ddotr1),dsqrt(ddotr2)
         enddo
        endif

          if(nodezero) write(LuOut,"('ddot R:',2F16.12)")
     1                      dsqrt(ddotr1),dsqrt(ddotr2)


        call tce_mrcc_diis_new(.false.,iter,
     1       .true.,.true.,.false.,.false.,
     1       d_r1m,d_t1m,k_t1_offsetm,size_t1m,
     2       d_r2m,d_t2m,k_t2_offsetm,size_t2m,
     3       dummy,dummy,dummy,dummy,
     4       dummy,dummy,dummy,dummy,
     5       rtdb,iref)
ckbn
c        call ga_sync()


        do iref=1,nref
         if((int_mb(k_refafi+iref-1).eq.mypgid).or.(.not.lusesub)) then
          call deletefile(d_em(iref))
          call deletefile(d_r1m(iref))
          call deletefile(d_r2m(iref))
          if (lfullheff) call deletefile(d_r3am(iref))
          if (lfullheff) call deletefile(d_r4am(iref))
         endif
        enddo !iref

        edelta = epsilon

        if(lusesub)call ga_sync()

        itcpu = itcpu + util_cpusec()
        itwall = itwall + util_wallsec()
        if(nodezero) then
          write(LuOut,"('Iter cpu ',2f15.1,I4)") itcpu, itwall,iter
          call util_flush(LuOut)
        endif

        if(lcheckpoints) then
         if(mod(iter,icheckpoint).eq.0) then
          do iref=1,nref
           call tce_filenameindexed(iref,'mrt1',filename)
           unitn=76
           call write_tensor(filename,d_t1m(iref),size_t1m(iref),unitn)
c           close(unitn)
           call tce_filenameindexed(iref,'mrt2',filename)
           unitn=77
           call write_tensor(filename,d_t2m(iref),size_t2m(iref),unitn)
c           close(unitn)
          enddo
         endif
        endif

       enddo !maxiter

       call errquit('tce_energy: maxiter exceeded',iter,CALC_ERR)

 1001  continue

c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd end 
c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd end 
c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd end 
c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd end 
c mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd mkccsd end 

      else
       call errquit('tce_mrcc_energy: unkown method',INPUT_ERR)
      endif !methods 

c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup begin
c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup begin
c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup begin

ckbn------------------------------- clean up--------------------------------
ckbn If there is some final cleanup issue check it carefully it may be a bug
ckbn------------------------------- clean up--------------------------------
c
c     ===============
c     Destroy a mutex
c     ===============
c
c      if (.not.ga_destroy_mutexes())
c     1  call errquit('tce_energy: GA problem',1,GA_ERR)
c
c     ==================
c     Deallocate arrays
c     ==================
c
c      if(nodezero) write(*,*) "I am here1"
c      call ga_print(d_f1m(1))
c      call ga_print(d_f1m(2))
c      call ga_print(d_f1m(3))
c      call ga_print(d_f1m(4))

      do iref=1,nref

        if (.not.ga_destroy(g_movecsm(iref,1)))
     1    call errquit('tce_mrcc_energy: GA problem',1,GA_ERR)
        if (.not.ga_destroy(g_movecsm(iref,2)))
     1    call errquit('tce_mrcc_energy: GA problem',1,GA_ERR)

      enddo

#ifdef MRCC_LOCAL_T1
ckbn @did : localize t1amp
       if(lusesub) then
        do iref=1,nref
         if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     +      +innodes+ga_nodeid())).or.(.not.lusesub)) then
          if(.not.MA_POP_STACK(l_t1_local)) 
     +     call errquit('t1_local',1,MA_ERR)
         endif
        enddo
       endif
#endif


      if (.not.ma_pop_stack(l_sqcl))
     1 call errquit("tce_mrcc_energy: MA problem",331,MA_ERR)

      if (.not.ma_pop_stack(l_sqc))
     1 call errquit("tce_mrcc_energy: MA problem",332,MA_ERR)

      if (.not.ma_pop_stack(l_heff))
     1 call errquit("tce_mrcc_energy: MA problem",58,MA_ERR)

      if(lusesub) then
          lstatus = ga_destroy(g_heff)
      endif





      if((.not.diskint).and.(.not.luseeaf2e)) then
       do iref=1,nref
        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then
          call deletefile(d_v2m(iref))
        endif
       enddo 
      end if
c
      do iref=1,nref
        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub).or.
     2 (model.eq.'mkccsd')) then
         if(needt2) call deletefile(d_t2m(iref))
         if(needt1) call deletefile(d_t1m(iref))
         if(needt3) call deletefile(d_t3m(iref))
        endif
      enddo

      do i=1,nref

c       if(needr4act) then
c         if (.not.ma_pop_stack(l_r4act_offsetm(nref-i+1)))
cc     1    call errquit("tce_energy: MA problem",61,MA_ERR)
c       endif
       if(needt3) then
         if (.not.ma_pop_stack(l_r3_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",60,MA_ERR)
       endif
       if(needt2) then
         if (.not.ma_pop_stack(l_r2_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",58,MA_ERR)
        endif
        if(needt1) then
         if (.not.ma_pop_stack(l_r1_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",57,MA_ERR)
        endif

       if (.not.ma_pop_stack(l_e_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",59,MA_ERR)

      enddo

      do i=1,nref

        if((int_mb(k_refafi+nref-i).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub).or.
     2 (model.eq.'mkccsd')) then

       if(lfullheff) then
         if (.not.ma_pop_stack(l_r4a_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",56,MA_ERR)
         if (.not.ma_pop_stack(l_r3a_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",56,MA_ERR)
       endif
        if(needt1) then
         if (.not.ma_pop_stack(l_t1_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",55,MA_ERR)
        endif
       if(needt2) then
         if (.not.ma_pop_stack(l_t2_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",56,MA_ERR)
        endif
       if(needt3) then
         if (.not.ma_pop_stack(l_t3_offsetm(nref-i+1)))
     1    call errquit("tce_energy: MA problem",88,MA_ERR)
        endif

        endif

      enddo

c      if(nodezero) write(*,*) "I am here2"
c      call ga_print(d_f1m(1))
c      call ga_print(d_f1m(2))
c      call ga_print(d_f1m(3))
c      call ga_print(d_f1m(4))

c      do i=1,nref

c       if(lfullheff) then
c         if (.not.ma_pop_stack(l_r4a_offsetm(nref-i+1)))
c     1    call errquit("tce_energy: MA problem",88,MA_ERR)
c        endif
c       if(lfullheff) then
c         if (.not.ma_pop_stack(l_r3a_offsetm(nref-i+1)))
c     1    call errquit("tce_energy: MA problem",56,MA_ERR)
c        endif

c      enddo

      do i=1,nref

        if((int_mb(k_refafi+nref-i).eq.int_mb(k_innodes
     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then

      if (.not.ma_pop_stack(l_v2_offsetm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",54,MA_ERR)

        endif

      enddo

c      if(nodezero) write(*,*) "I am here3"
c      call ga_print(d_f1m(1))
c      call ga_print(d_f1m(2))
c      call ga_print(d_f1m(3))
c      call ga_print(d_f1m(4))
c PNNL
c#ifdef MRCC_LOCAL_FOCK
c      if(lusesub) then
c       do iref=1,nref
c        call deletefile(d_f1m(iref))
c       enddo
c      else
c       do iref=1,nref
c        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
c     +     +innodes+ga_nodeid())).or.(.not.lusesub)) then
c         call deletefile(d_f1m(iref))
c        endif
c       enddo
c      endif
c#else
      do iref=1,nref
c        if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
c     1 +innodes+ga_nodeid())).or.(.not.lusesub)) then
         call deletefile(d_f1m(iref))
c        endif
      enddo
c#endif

#ifdef MRCC_LOCAL_FOCK
ckbn @todo : localize fock
       if(lusesub) then
        do iref=1,nref
         if((int_mb(k_refafi+iref-1).eq.int_mb(k_innodes
     +      +innodes+ga_nodeid())).or.(.not.lusesub)) then
             if(.not.MA_POP_STACK(l_f1_local)) 
     +        call errquit('f1_local',1,MA_ERR)
         endif
        enddo
       endif
#endif

      if (.not.ma_pop_stack(l_goffset))
     1    call errquit("tce_mrcc_energy: MA problem",611,MA_ERR)

      if (.not.ma_pop_stack(l_refafi))
     1    call errquit("tce_mrcc_energy: MA problem",612,MA_ERR)

      if (.not.ma_pop_stack(l_sghandles))
     1    call errquit("tce_mrcc_energy: MA problem",613,MA_ERR)

      if (.not.ma_pop_stack(l_sgsizes))
     1    call errquit("tce_mrcc_energy: MA problem",614,MA_ERR)

      if (.not.ma_pop_stack(l_innodes))
     1    call errquit("tce_mrcc_energy: MA problem",615,MA_ERR)
 
      do i=1,nref

      if (.not.ma_pop_stack(l_f1_offsetm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",44,MA_ERR)

      enddo

      do i=1,nref

      if (.not.ma_pop_stack(l_alpham(nref-i+1)))
     1  call errquit("tce_energy: MA problem",4,MA_ERR)
      if (.not.ma_pop_stack(l_offsetm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",5,MA_ERR)
      if (.not.ma_pop_stack(l_rangem(nref-i+1)))
     1  call errquit("tce_energy: MA problem",6,MA_ERR)
      if (.not.ma_pop_stack(l_symm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",7,MA_ERR)
      if (.not.ma_pop_stack(l_spinm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",8,MA_ERR)

      enddo

      do i=1,ipol

      if (.not.ma_pop_stack(l_irs_tile(ipol-i+1)))
     1  call errquit("tce_energy: MA problem",9,MA_ERR)
      if (.not.ma_pop_stack(l_evl_tile(ipol-i+1)))
     1  call errquit("tce_energy: MA problem",9,MA_ERR)

      enddo

      do i=1,nref

      if (.not.ma_pop_stack(l_active_tmpm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",9,MA_ERR)
      if (.not.ma_pop_stack(l_range_tmpm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",9,MA_ERR)
      if (.not.ma_pop_stack(l_sym_tmpm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",10,MA_ERR)
      if (.not.ma_pop_stack(l_spin_tmpm(nref-i+1)))
     1  call errquit("tce_energy: MA problem",11,MA_ERR)

      enddo

      do i=1,nref
       j = nref - i + 1
      if(.not.ma_pop_stack(l_isactive(j)))
     1  call errquit("tce_mrcc_tile: ma problem",95,MA_ERR)
      if(.not.ma_pop_stack(l_mo_indexm(j)))
     1  call errquit("tce_mrcc_tile: ma problem",85,MA_ERR)
      if (.not.ma_pop_stack(l_evl_sortedm(j)))
     1  call errquit("tce_mrcc_tile: MA problem",9,MA_ERR)
      if (.not.ma_pop_stack(l_irs_sortedm(j)))
     1  call errquit("tce_mrcc_tile: MA problem",10,MA_ERR)
      if (.not.ma_pop_stack(l_spin_sortedm(j)))
     1  call errquit("tce_mrcc_tile: MA problem",11,MA_ERR)
      if (.not.ma_pop_stack(l_movecs_sortedm(j)))
     1  call errquit("tce_mrcc_tile: MA problem",12,MA_ERR)

      end do

c PNNL
c      do iref=1,nref
c         call deletefile(d_f1m(iref))
c      enddo
c      if(.not.diskint) then
c       do iref=1,nref
c          call deletefile(d_v2m(iref))
c       enddo
c      end if
c
c      do iref=1,nref
c         if(needt1) call deletefile(d_t1m(iref))
c         if(needt2) call deletefile(d_t2m(iref))
c         if(needt3) call deletefile(d_t3m(iref))
c      enddo

c
c     =========
c     Terminate
c     =========
c
ckbn
      call ga_sync()
      call tce_tidy(rtdb)
      call util_print_pop

c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup end
c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup end
c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup end
c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup end
c cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup cleanup end

      return

 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9100 format(1x,i4,2f18.13,2f8.1,2f18.13)
 9123 format(1x,'4-index algorithm nr.',i4,1x,'is used')
 9220 format(1x,'MRCC cpu & wall time / sec',2f15.1)
 9222 format(1x,'Residues and T update / sec',2f15.1)

 9080 format(1x,A,'(Hartrees) = ',f25.15)

#else
      CALL ERRQUIT('MRCC Methods not compiled (tce_mrcc_energy.F) 
     + Compile  with "export MRCC_METHODS=y"',0,CAPMIS_ERR)
#endif

      end

c $Id: tce_mrcc_energy.F 24385 2013-07-10 20:23:59Z bhas990 $

      subroutine argos_cafe_lsh(lself,iga,idt,istemp,
     + isfr,isto,jsfr,jsto,
     + idh,nsh,nangls,mangls,nconst,langls,itemp)
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      integer nsh,mangls
      integer idh(nsh,5)
      integer iga(msa),idt(msa)
      integer langls(1)
      integer itemp(nsatot),istemp(msa)
      integer isa,jsa,isfr,isto,jsfr,jsto,isafr,isato,jsafr,jsato
      integer ish,nhi,nangls,nconst
      integer ishloc,ihloc,jhloc,khloc,iq,jq,kq
      logical lself
c
#include "bitops.fh"
c
      if(numh(2).eq.0) return
c
c     This subroutine evaluates the solute angles list
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
c
      nangls=0
      nconst=0
c
      do 1 isa=1,nsatot
      itemp(isa)=0
    1 continue
      do 2 jsa=jsafr,jsato
      itemp(iga(jsa))=4
    2 continue
      do 3 isa=isafr,isato
      itemp(iga(isa))=1
    3 continue
c
      do 4 ish=1,numh(2)
c
c     skip angles with negative ishs
c
      if(idh(ish,4).ge.0) then
c
      nhi=itemp(idh(ish,1))
      if(nhi.gt.0) then
      nhi=nhi+itemp(idh(ish,2))
      if(nhi.gt.1) then
      nhi=nhi+itemp(idh(ish,3))
      if(nhi.gt.2) then
      if((lself.and.nhi.eq.3).or.
     + (.not.lself.and.(nhi.eq.6.or.nhi.eq.9))) then
      nangls=nangls+1
      if(idh(ish,4).eq.1) nconst=nconst+1
      if(nangls.gt.mangls)
     + call md_abort('Insufficient memory for angle list',0)
      langls(nangls)=ish
      endif
      endif
      endif
      endif
      endif
    4 continue
c
      return
      end
c $Id: argos_cafe_lsh.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup nwint
C> @{
C>
C> \brief Computes the electron - COSMO charge interactions
C>
C> Compute derivatives of the integrals
C> \f{eqnarray*}{
C>    (\mu\rho|q) = \int_{-\infty}^{\infty}
C>    \chi_\mu(R_A;r)\chi_\rho(R_B;r)|r-R_C|^{-1}q_C dr
C> \f}
C> In this case we need all the derivatives with respect to centers
C> \f$A\f$, \f$B\f$, and \f$C\f$. The reason is that each COSMO charge
C> is associated with a particular atom to which it is fixed. So there
C> are a number of scenarios:
C>
C> - The COSMO charge is associated with C which is neither A or B.
C>   The COSMO charge contributes a force to all 3 centers
C>
C> - The COSMO charge is associated with A.
C>   The COSMO charge imposes a force on the basis functions centered
C>   on A and the basis functions generate a force on the COSMO charge,
C>   but these now cancel. Only the forces on the functions centered
C>   at A and the COSMO charge associated with A due to the basis 
C>   functions centered at B survive.
C>
C> - The COSMO charge is associated with B.
C>   The is the same as above but now the role of centers A and B is 
C>   interchanged.
C>
C> - The COSMO charge is associated with A and A equals B.
C>   In this case all forces must cancel.
C>
C> In practice the derivative integrals can be calculated in a number
C> of ways. Because we need the derivatives with respect to all three
C> centers a suitable approach is to calculate
C> \f{eqnarray*}{
C>    \frac{d(\mu\rho|q)}{dA} && \\\\
C>    \frac{d(\mu\rho|q)}{dB} && \\\\
C>    \frac{d(\mu\rho|q)}{dC} &=& -\frac{d(\mu\rho|q)}{dA}
C>                                -\frac{d(\mu\rho|q)}{dB}
C> \f}
C> The advantage is that the top two lines are easy to evaluate. The
C> derivative of a Gaussian function with respect to the coordinates
C> of its center is again a Gaussian function (just with a higher 
C> angular momentum). So we can use the standard integral codes to
C> evaluate these expressions. The derivative of center C can then be
C> constructed using translational invariance, as specified in the
C> last equation. 
c
      subroutine intd_1epot_cosmo(i_basis,ish,j_basis,jsh,lscr,scr,
     &           lH1a,H1a,efc_c,efc_q,nefc)
C $Id: intd_1epot_cosmo.F 24347 2013-06-23 04:26:26Z d3y133 $
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
c
c layer routine to compute the derivative 1 electron hamiltonian integrals
c for shells/contractions ish,jsh
c
c Order is...   nint*3*nat (3=> xyz, nat=number of atoms)
c
c  /                   |   
c | nint,d <ij>        |
c |      --------------|
c  \     d[idatom(1),x]|
c                          |
c       nint,d <ij>        |
c            --------------|
c            d[idatom(1),y]|
c                              |
c           nint,d <ij>        |
c                --------------|
c                d[idatom(1),z]|
c                                  |
c               nint,d <ij>        |
c                    --------------|
c                    d[idatom(2),x]|
c                                      |
c                   nint,d <ij>        |
c                        --------------|
c                        d[idatom(2),y]|
c                                           |
c                       nint,d <ij>         |
c                            -------------- |
c                            d[idatom(2),z] |
c
c                                  . . . 
c                                                            |
c                                         nint,d <ij>        |
c                                              --------------|
c                                            d[idatom(nat),x]|
c                                                                |
c                                             nint,d <ij>        |
c                                                  --------------|
c                                                d[idatom(nat),y]|
c                                                                    \
c                                                 nint,d <ij>         |
c                                                      -------------- |
c                                                    d[idatom(nat),z]/
c      
c::functions
      integer int_nint_cart
      external int_nint_cart
c::passed
      integer i_basis   !< [Input] ish basis set handle
      integer ish       !< [Input] ``i'' contraction index
      integer j_basis   !< [Input] jsh basis set handle
      integer jsh       !< [Input] ``j'' contraction index
      integer lscr      !< [Input] length of scratch space
      integer lH1a      !< [Input] number of h1 integral derivatives in shells ish and jsh
c                       !< NOTE: nint*3 integral derivatives returned per unique center
      integer nefc      !< [Input] the number of COSMO charges
      double precision efc_c(3,nefc) !< [Input] COSMO charge coordinates
      double precision efc_q(nefc) !< [Input] COSMO charges
      double precision scr(lscr) !< [Input] scratch array
      double precision H1a(*)    !< [Output] derivative integrals
c
c::local
      integer nint, offset, scrsize, nat
c
      nat = ncenter(ibs_geom((i_basis + Basis_Handle_Offset)))
c
      nint = int_nint_cart(i_basis,ish,j_basis,jsh,0,0,0,0)
      if (nint*3*nat.gt.lH1a) then
        write(luout,*) 'nint*3*nat = ',nint*3*nat
        write(luout,*) 'lH1a       = ',lH1a
        call errquit('intd_1eh1: nint>lH1a error',911, INT_ERR)
      endif
c
      offset = nint*3*2       ! scratch for Ta array in intd_1eh1P routine
      scrsize = lscr - offset ! new scratch array size
      offset = offset + 1     ! increment for passing to intd_1eh1P
c
      call intd_1epotP_cosmo(i_basis,ish,j_basis,jsh,
     &       scrsize,scr(offset),nint,H1a,efc_c,efc_q,nefc)
c
      end
      subroutine intd_1epotP_cosmo(i_basis,ish,j_basis,jsh,lscr,scr,
     &       nint,H1a,efc_c,efc_q,nefc)
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "apiP.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geom.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "rel_nwc.fh"
#include "prop.fh"
c::external subroutines used
c... errquit
c::functions
      logical cando_hnd_1e
      logical cando_nw
      external cando_hnd_1e
      external cando_nw
c::passed
      integer i_basis   ! [input] ish basis set handle
      integer ish       ! [input] ``i'' contraction index
      integer j_basis   ! [input] jsh basis set handle
      integer jsh       ! [input] ``j'' contraction index
      integer lscr      ! [input] length of scratch space 
      integer nint      ! [input] number of integrals in shells ish and jsh
c                       ! NOTE: nint*3 integral derivatives returned per unique center
      integer nefc      ! [input] the number of COSMO charges
      double precision efc_c(3) ! [input] the COSMO charges coordinates
      double precision efc_q ! [input] the COSMO charges
      double precision H1a(nint,3,3)    ! [output] derivative integrals (nint,3,n_atoms)
      double precision scr(lscr) ! [scratch] 
c::local
      logical doT
      integer ucont,uconts
      integer ibas,iatom,inp,igen,iexp,icf,itype,igeom,isbas,icfS
      integer jbas,jatom,jnp,jgen,jexp,jcf,jtype,jgeom,jsbas,jcfS
      integer nat
      integer nintV
      integer offset
c
      logical any_spherical
      logical orel, oirel, ojrel, oNR
      logical ohnd_ok, onw_ok
      integer i_nbf_x, j_nbf_x
      integer i_nbf_s, j_nbf_s
      integer nint_x, nint_s
      integer zatom, zyx
      integer lbas, sbas, abas
c 
      integer ib,bq_ncent,nb
      integer i_qbq,i_cbq
      integer i_qbq0,i_cbq0,i_xbq0
      integer h_qbq0,h_cbq0,h_xbq0
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c  check if gencon/sp shells
c
      call int_nogencont_check(i_basis,'intd_1eh1P:i_basis')
      call int_nogencont_check(j_basis,'intd_1eh1P:j_basis')
      call int_nospshell_check(i_basis,'intd_1eh1P:i_basis')
      call int_nospshell_check(j_basis,'intd_1eh1P:j_basis')
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
      oNR = .true.
      oirel = .false.
      ojrel = .false.
      orel = .false.
c
      if (dyall_mod_dir) then
c
c     get basis set handles; relativistic integral option only valid
c     if both ibas and jbas are the ao basis.
c
        lbas = lc_bsh + BASIS_HANDLE_OFFSET
        sbas = sc_bsh + BASIS_HANDLE_OFFSET
        abas = ao_bsh + BASIS_HANDLE_OFFSET
        orel = ibas .eq. abas .and. jbas .eq. abas
      end if
c
c   i shell
c
      ucont = (sf_ibs_cn2ucn(ish,ibas))
c
c     check for relativistic shell
c
      if (orel .and. (infbs_cont(CONT_RELLS ,ucont,ibas) .ne. 0)) then
        oirel = .true.
        isbas = sbas
        uconts = ao_to_ls(ucont)
        if (uconts .eq. 0) call errquit (
     &      'intd_1eh1: no relativistic pointer',911, INT_ERR)
        if (nesc_1e_approx) then
          ibas = lbas
          ucont = uconts
        end if
      else
        uconts = ucont
        isbas = ibas
      end if
c
      inp   = infbs_cont(CONT_NPRIM,ucont,ibas)
      igen  = infbs_cont(CONT_NGEN,ucont,ibas)
      iexp  = infbs_cont(CONT_IEXP,ucont,ibas)
      icf   = infbs_cont(CONT_ICFP,ucont,ibas)
      itype = infbs_cont(CONT_TYPE,ucont,ibas) 
      igeom = ibs_geom(ibas)
      iatom = (sf_ibs_cn2ce(ish,ibas))
      icfS  = infbs_cont(CONT_ICFP ,uconts,isbas)
c
c   j shell
c
      ucont = (sf_ibs_cn2ucn(jsh,jbas))
c
c     check for relativistic shell
c
      if (orel .and. (infbs_cont(CONT_RELLS ,ucont,jbas) .ne. 0)) then
        ojrel = .true.
        jsbas = sbas
        uconts = ao_to_ls(ucont)
        if (uconts .eq. 0) call errquit (
     &      'intd_1eh1: no relativistic pointer',911, INT_ERR)
        if (nesc_1e_approx) then
          jbas = lbas
          ucont = uconts
        end if
      else
        uconts = ucont
        jsbas = jbas
      end if
c
      jnp   = infbs_cont(CONT_NPRIM,ucont,jbas)
      jgen  = infbs_cont(CONT_NGEN,ucont,jbas)
      jexp  = infbs_cont(CONT_IEXP,ucont,jbas)
      jcf   = infbs_cont(CONT_ICFP,ucont,jbas)
      jtype = infbs_cont(CONT_TYPE,ucont,jbas) 
      jgeom = ibs_geom(jbas)
      jatom = (sf_ibs_cn2ce(jsh,jbas))
      jcfS  = infbs_cont(CONT_ICFP ,uconts,jsbas)
c
      oNR = .not.(oirel.and.ojrel)
      orel = oirel.or.ojrel
c
      if (igeom.ne.jgeom) then
        write(luout,*)'intd_1eh1P.F: two different geometries for',
     &         ' derivatives?'
        call errquit('intd_1eh1P: geom error ',911, INT_ERR)
      endif
c
      if (iatom.eq.jatom) then
        doT = .false.
      else
        doT = .true.
      endif
c
      ohnd_ok = cando_hnd_1e(i_basis,ish,0)
     &    .and. cando_hnd_1e(j_basis,jsh,0)
     &    .and. (.not.geom_any_finuc (igeom))
     &    .and. (.not.geom_any_finuc (jgeom))
      ohnd_ok = .false.
      onw_ok = cando_nw(i_basis,ish,0) .and. cando_nw(j_basis,jsh,0)
c
c     get external charges here (MV)
c     ------------------------------
c     if(.not.geom_extbq_on())
c    >   call errquit('int_1eefc:no active bqs',0,0) 
c     nefc = ncenter(cosmo_geom_efc)
c     i_cbq = geom_extbq_coord()
c     i_qbq = geom_extbq_charge()
c     nb = nefc+ncenter(igeom)
c     nb = nefc+2
      nb = 3

c     if(.not.ma_push_get(mt_dbl,3*nb,'cbq',h_cbq0,i_cbq0))
c    +     call errquit( 'intd1_epot_cosmo',0,0)
c     if(.not.ma_push_get(mt_dbl,nb,'qbq',h_qbq0,i_qbq0))
c    +     call errquit( 'intd1_epot_cosmo',0,0)
c     if(.not.ma_push_get(mt_dbl,nb,'xbq',h_xbq0,i_xbq0))
c    +     call errquit( 'intd1_epot_cosmo',0,0)

c     call dfill(nb,0.d0,dbl_mb(i_xbq0),1)
c
c     Create joined geometry data for the QM centers + COSMO centers
c
c     call dcopy(3,coords(1,iatom,igeom),1,dbl_mb(i_cbq0),1)
c     call dcopy(3,coords(1,jatom,igeom),1,dbl_mb(i_cbq0+3),1)
c     call dcopy(3*nefc,efc_c,1,dbl_mb(i_cbq0+6),1)
c
c     call dcopy(1,efc_q,1,dbl_mb(i_qbq0),1)
c     call dcopy(1,efc_q,1,dbl_mb(i_qbq0+1),1)
c     call dcopy(nefc,efc_q,1,dbl_mb(i_qbq0+2),1)
c
c     call dcopy(1,geom_invnucexp(iatom,igeom),1,dbl_mb(i_xbq0),1)
c     call dcopy(1,geom_invnucexp(jatom,igeom),1,dbl_mb(i_xbq0+1),1)
c
c     call dcopy(3*ncenter(igeom),coords(1,1,igeom),1,
c    >           dbl_mb(i_cbq0),1)
c     call dcopy(3*nefc,coords(1,1,cosmo_geom_efc),1,
c    >           dbl_mb(i_cbq0+3*ncenter(igeom)),1)
c
c     call dcopy(ncenter(igeom),charge(1,igeom),1,
c    >           dbl_mb(i_qbq0),1)
c     call dcopy(nefc,charge(1,cosmo_geom_efc),1,
c    >           dbl_mb(i_qbq0+ncenter(igeom)),1)
c
c     call dcopy(ncenter(igeom),geom_invnucexp(1,igeom),1,
c    >           dbl_mb(i_xbq0),1)
c
c     Junk
c
c     call dcopy(3,coords(1,iatom,igeom),1,dbl_mb(i_cbq0),1)
c     call dcopy(3,coords(1,jatom,igeom),1,dbl_mb(i_cbq0+3),1)
c     call dcopy(3*nefc,coords(1,1,cosmo_geom_efc),1,
c    >           dbl_mb(i_cbq0+6),1)
c
c     call dcopy(1,1.0d0,1,dbl_mb(i_qbq0),1)
c     call dcopy(1,1.0d0,1,dbl_mb(i_qbq0+1),1)
c     call dcopy(nefc,charge(1,cosmo_geom_efc),1,dbl_mb(i_qbq0+2),1)
c
c     call dcopy(1,geom_invnucexp(iatom,igeom),1,dbl_mb(i_xbq0),1)
c     call dcopy(1,geom_invnucexp(jatom,igeom),1,dbl_mb(i_xbq0+1),1)
c        
      if (orel) then
        call rel_oneld_cosmo (
     &      coords(1,iatom,igeom),
     &      dbl_mb(mb_exndcf(iexp,ibas)),
     &      dbl_mb(mb_exndcf(icf,ibas)),
     &      dbl_mb(mb_exndcf(icfS,isbas)),inp,igen,itype,iatom,
     &      coords(1,jatom,jgeom),
     &      dbl_mb(mb_exndcf(jexp,jbas)),
     &      dbl_mb(mb_exndcf(jcf,jbas)),
     &      dbl_mb(mb_exndcf(jcfS,jsbas)),jnp,jgen,jtype,jatom,
c     &      coords(1,1,cosmo_geom_efc),charge(1,cosmo_geom_efc),
c     &      geom_invnucexp(1,cosmo_geom_efc),ncenter(cosmo_geom_efc),
     &      efc_c,efc_q,
     &      H1a,nint,.false.,onw_ok,
c    &      dbl_mb(i_cbq0),dbl_mb(i_qbq0),
c    &      dbl_mb(i_xbq0),nb,
c........................     doS   doT  doV    canAB  
c    &      scr,Ta,H1a,nint,.false.,doT,.true.,.false.,onw_ok,
c...........       nonrel dryrun
     &      ohnd_ok,oNR,.false.,scr,lscr,rel_dbg,rel_typ)
      else if (onw_ok) then
        call hf1d_cosmo(
     &      coords(1,iatom,igeom),
     &      dbl_mb(mb_exndcf(iexp,ibas)),
     &      dbl_mb(mb_exndcf(icf,ibas)),
     &      inp,igen,itype,iatom,
c
     &      coords(1,jatom,jgeom),
     &      dbl_mb(mb_exndcf(jexp,jbas)),
     &      dbl_mb(mb_exndcf(jcf,jbas)),
     &      jnp,jgen,jtype,jatom,
c
c    &      iat_efc,
c    &      coords(1,1,cosmo_geom_efc),charge(1,cosmo_geom_efc),
c    &      geom_invnucexp(1,cosmo_geom_efc),ncenter(cosmo_geom_efc),
     &      efc_c,efc_q,
     &      H1a,nint,
c........... canab,   dryrun
     &      .false., .false.,
     &      scr,lscr)
c     elseif (ohnd_ok) then
c       call hnd_stvintd_cosmo(
c    &      coords(1,iatom,igeom),
c    &      dbl_mb(mb_exndcf(iexp,ibas)),
c    &      dbl_mb(mb_exndcf(icf,ibas)),
c    &      inp,igen,itype,iatom,
c
c    &      coords(1,jatom,jgeom),
c    &      dbl_mb(mb_exndcf(jexp,jbas)),
c    &      dbl_mb(mb_exndcf(jcf,jbas)),
c    &      jnp,jgen,jtype,jatom,
c
c    &      efc_c,efc_q,nefc,
c    &      H1a,nint,
c    &      scr,lscr)
      else
        call errquit('intd_1epotP_cosmo: could not do nw integrals',
     &                0, INT_ERR)
      endif
c
c     if(.not.ma_pop_stack(h_xbq0))
c    +     call errquit( 'intd1_epot',0,0)
c     if(.not.ma_pop_stack(h_qbq0))
c    +     call errquit( 'intd1_epot',0,0)
c     if(.not.ma_pop_stack(h_cbq0))
c    +     call errquit( 'intd1_epot',0,0)

c
c check for ecp 
c
*
* this should move to hf1dsp when sp is enabled.
*
c     nat = ncenter(igeom)  ! needed for both ecp and spherical
c     if (any_ecp) then
c       nintV = int_nbf_x(itype)*int_nbf_x(jtype)
c       offset = nintV*3*nat + 1
c       call errquit("intd_1epot_cosmo: not done ecps yet",0,CAPMIS_ERR)
c       call intd_ecp_hf1(
c    &      coords(1,iatom,igeom),
c    &      dbl_mb(mb_exndcf(iexp,ibas)),
c    &      dbl_mb(mb_exndcf(icf,ibas)),
c    &      inp,igen,itype,iatom,
c
c    &      coords(1,jatom,jgeom),
c    &      dbl_mb(mb_exndcf(jexp,jbas)),
c    &      dbl_mb(mb_exndcf(jcf,jbas)),
c    &      jnp,jgen,jtype,jatom,
c
c    &      scr,nintV,nat,
c    &      scr(offset),(lscr-offset-1),
c    &      .false.)
c 
*... sum ecp into derivative H1 block
c       call daxpy(nintV*3*nat,1.0d00,scr,1,H1a,1)
c     endif
c
*     H1a now has the cartesian integral block  (jlo:jhi,ilo:ihi)
*      
      any_spherical = bas_spherical(ibas).or.bas_spherical(jbas)
      if (.not.any_spherical) return
c
c ... reset general contractions for sp shells to 1 since they are handled
c     as a block of 4.
c
      if (itype.eq.-1) igen = 1
      if (jtype.eq.-1) jgen = 1
c
      if (bas_spherical(ibas).and.bas_spherical(jbas)) then
*... transform both i and j integrals
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = int_nbf_s(Itype)
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = int_nbf_s(Jtype)
c        
        do zatom = 1,3
          do zyx = 1,3
            call spcart_tran1e(H1a(1,zyx,zatom),scr,
     &          j_nbf_x,i_nbf_x,Jtype,jgen,
     &          j_nbf_s,i_nbf_s,Itype,igen,
     &          .false.)
          enddo
        enddo
      else if (bas_spherical(ibas)) then
*.. transform on i component
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = int_nbf_s(Itype)
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = j_nbf_x
        do zatom = 1,3
          do zyx = 1,3
            call spcart_tran1e(H1a(1,zyx,zatom),scr,
     &          j_nbf_x,i_nbf_x,0,jgen,
     &          j_nbf_s,i_nbf_s,Itype,igen,
     &          .false.)
          enddo
        enddo
      else if (bas_spherical(jbas)) then
*.. transform on j component
        i_nbf_x = int_nbf_x(Itype)
        i_nbf_s = i_nbf_x
        j_nbf_x = int_nbf_x(Jtype)
        j_nbf_s = int_nbf_s(Jtype)
        do zatom = 1,3
          do zyx = 1,3
            call spcart_tran1e(H1a(1,zyx,zatom),scr,
     &        j_nbf_x,i_nbf_x,Jtype,jgen,
     &        j_nbf_s,i_nbf_s,0,igen,
     &        .false.)
          enddo
        enddo
      else
        call errquit(
     &        'int_1epot_cosmo: should never reach transform blocked '//
     &        'else', 911, INT_ERR)
      endif
c
c now shuffle transformed buffers to contiguous space
c
      nint_x = i_nbf_x*j_nbf_x
      nint_s = i_nbf_s*j_nbf_s
      if (nint_s.gt.nint_x) then
        call errquit
     &      ('intd_1eh1: nint_s >.nint_x diff=',(nint_s-nint_x),
     &      INT_ERR)
      elseif (nint_s.eq.nint_x) then
        return
      else
        call int_c2s_mv
     &      (H1a,nint_x,nint_s,9,scr,lscr,'intd_1eh1')
      endif
c

      end
C> @}

*
* $Id: integrate_kbppv3_ray.f 24639 2013-10-12 00:43:28Z bylaska $
*

      subroutine integrate_kbppv3_ray(version,rlocal,
     >                            nrho,drho,lmax,locp,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nray,G_ray,vl_ray,vnl_ray,
     >                            semicore,rho_sc_r,rho_sc_k_ray,
     >                            ierr)
      implicit none
      integer          version
      double precision rlocal
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:lmax)
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nray
      double precision G_ray(nray)
      double precision vl_ray(nray)
      double precision vnl_ray(nray,0:lmax)

      logical semicore
      double precision rho_sc_r(nrho,2)
      double precision rho_sc_k_ray(nray,2)
      integer ierr

      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      logical fast_erf
      integer task_count
      integer k1,i,l
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3,p
      double precision a,q,d

*     **** Error function parameters ****
      real*8 yerf,xerf
      real*8 c1,c2,c3,c4,c5,c6
      parameter (c1=0.07052307840d0,c2=0.04228201230d0)
      parameter (c3=0.00927052720d0)
      parameter (c4=0.00015201430d0,c5=0.00027656720d0)
      parameter (c6=0.00004306380d0)


*     **** external functions ****
      logical          control_fast_erf
      external         control_fast_erf
      double precision dsum,simp,util_erf
      external         dsum,simp,util_erf

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      fast_erf = control_fast_erf()

      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      IF((NRHO/2)*2.EQ.NRHO) THEN
        IERR=2
        RETURN
      ENDIF

      P0=DSQRT(FORPI)
      P1=DSQRT(3.0d0*FORPI)
      P2=DSQRT(15.0d0*FORPI)
      P3=DSQRT(105.0d0*FORPI)

*======================  Fourier transformation  ======================
      call dcopy(nray,0.0d0,0,vl_ray,1)
      call dcopy((lmax+1)*nray,0.0d0,0,vnl_ray,1)
      call dcopy(2*nray,0.0d0,0,rho_sc_k_ray,1)
      task_count = -1
      DO 700 k1=2,nray
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        Q=G_ray(k1)

        DO I=1,NRHO
          CS(I)=DCOS(Q*RHO(I))
          SN(I)=DSIN(Q*RHO(I))
        END DO

        GO TO (500,400,300,200), lmax+1


*::::::::::::::::::::::::::::::  f-wave  ::::::::::::::::::::::::::::::
  200   CONTINUE
        if (locp.ne.3) then
           F(1)=0.0d0
           do I=2,NRHO
             A=SN(I)/(Q*RHO(I))
             A=15.0d0*(A-CS(I))/(Q*RHO(I))**2 - 6*A + CS(I)
             F(I)=A*WP(I,3)*VP(I,3)
           end do
           D=P3*SIMP(NRHO,F,DRHO)/Q
           vnl_ray(k1,3)=D
        end if
*::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
  300   CONTINUE
        if (locp.ne.2) then
          F(1)=0.0d0
          DO I=2,NRHO
            A=3.0d0*(SN(I)/(Q*RHO(I))-CS(I))/(Q*RHO(I))-SN(I)
            F(I)=A*WP(I,2)*VP(I,2)
          END DO
          D=P2*SIMP(NRHO,F,DRHO)/Q
          vnl_ray(k1,2)=D
        end if
*::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
  400   CONTINUE
        if (locp.ne.1) then
           F(1)=0.0d0
           DO I=2,NRHO
             F(I)=(SN(I)/(Q*RHO(I))-CS(I))*WP(I,1)*VP(I,1)
           END DO
           P=P1*SIMP(NRHO,F,DRHO)/Q
           vnl_ray(k1,1)=P
        end if
*::::::::::::::::::::::::::::::  s-wave  :::::::::::::::::::::::::::::::
  500   CONTINUE
        if (locp.ne.0) then
          DO I=1,NRHO
            F(I)=SN(I)*WP(I,0)*VP(I,0)
          END DO
          vnl_ray(k1,0)=P0*SIMP(NRHO,F,DRHO)/Q
        end if

*::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
  600   CONTINUE


        if (version.eq.3) then
        DO  I=1,NRHO
          F(I)=RHO(I)*VP(I,locp)*SN(I)
        END DO
        vl_ray(k1)=SIMP(NRHO,F,DRHO)*FORPI/Q-ZV*FORPI*CS(NRHO)/(Q*Q)
        end if
 
        if (version.eq.4) then
        if (fast_erf) then
           do I=1,NRHO
             xerf=RHO(I)/rlocal
             yerf = (1.0d0
     >            + xerf*(c1 + xerf*(c2
     >            + xerf*(c3 + xerf*(c4
     >            + xerf*(c5 + xerf*c6))))))**4
             yerf = (1.0d0 - 1.0d0/yerf**4)
             F(I)=(RHO(I)*VP(I,locp)+ZV*yerf)*SN(I)
           end do
        else
           do I=1,NRHO
             xerf=RHO(I)/rlocal
             yerf = util_erf(xerf)
             F(I)=(RHO(I)*VP(I,locp)+ZV*yerf)*SN(I)
           end do
        end if
        vl_ray(k1)=SIMP(NRHO,F,DRHO)*FORPI/Q
        end if


*::::::::::::::::::::: semicore density :::::::::::::::::::::::::::::::
        if (semicore) then
           do i=1,nrho
              f(i) = rho(i)*dsqrt(rho_sc_r(i,1))*sn(i)
           end do
           rho_sc_k_ray(k1,1) = SIMP(nrho,f,drho)*forpi/Q

           do i=1,nrho
             f(i)=(sn(i)/(Q*rho(i))-cs(i))*rho_sc_r(i,2)*rho(i)
           end do
           P = SIMP(nrho,f,drho)*forpi/Q
           rho_sc_k_ray(k1,2)=P
        end if
    
  700 CONTINUE
      call Parallel_Vector_SumAll(2*nray,rho_sc_k_ray)
      call Parallel_Vector_SumAll(nray,vl_ray)
      call Parallel_Vector_Sumall((lmax+1)*nray,vnl_ray)

*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      
      if (version.eq.3) then
      DO I=1,NRHO
        F(I)=VP(I,locp)*RHO(I)**2
      END DO
      vl_ray(1)=FORPI*SIMP(NRHO,F,DRHO)+TWOPI*ZV*RHO(NRHO)**2
      end if

      if (version.eq.4) then
      if (fast_erf) then
         do I=1,NRHO
           xerf=RHO(I)/rlocal
           yerf = (1.0d0
     >          + xerf*(c1 + xerf*(c2
     >          + xerf*(c3 + xerf*(c4
     >          + xerf*(c5 + xerf*c6))))))**4
           yerf = (1.0d0 - 1.0d0/yerf**4)
           F(I)=(VP(I,locp)*RHO(I)+ZV*yerf)*RHO(I)
         end do
      else
         do I=1,NRHO
           xerf=RHO(I)/rlocal
           yerf = util_erf(xerf)
           F(I)=(VP(I,locp)*RHO(I)+ZV*yerf)*RHO(I)
         end do
      end if
      vl_ray(1)=FORPI*SIMP(NRHO,F,DRHO)
      end if

*     **** semicore density ****
      if (semicore) then
         do i=1,nrho
            f(i) = dsqrt(rho_sc_r(i,1))*rho(i)**2
         end do
         rho_sc_k_ray(1,1) = forpi*SIMP(nrho,f,drho)
         rho_sc_k_ray(1,2) = 0.0d0
      end if

      do l=0,lmax
        vnl_ray(1,l)=0.0d0
      end do
*     *** only j0 is non-zero at zero ****
      if (locp.ne.0) then
         DO  I=1,NRHO
           F(I)=RHO(I)*WP(I,0)*VP(I,0)
         END DO
         vnl_ray(1,0)=P0*SIMP(NRHO,F,DRHO)
      end if

      IERR=0
      RETURN
      END

*> \brief \b CSROT
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CSROT( N, CX, INCX, CY, INCY, C, S )
* 
*       .. Scalar Arguments ..
*       INTEGER           INCX, INCY, N
*       REAL              C, S
*       ..
*       .. Array Arguments ..
*       COMPLEX           CX( * ), CY( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CSROT applies a plane rotation, where the cos and sin (c and s) are real
*> and the vectors cx and cy are complex.
*> jack dongarra, linpack, 3/11/78.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the order of the vectors cx and cy.
*>           N must be at least zero.
*> \endverbatim
*>
*> \param[in,out] CX
*> \verbatim
*>          CX is COMPLEX array, dimension at least
*>           ( 1 + ( N - 1 )*abs( INCX ) ).
*>           Before entry, the incremented array CX must contain the n
*>           element vector cx. On exit, CX is overwritten by the updated
*>           vector cx.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           CX. INCX must not be zero.
*> \endverbatim
*>
*> \param[in,out] CY
*> \verbatim
*>          CY is COMPLEX array, dimension at least
*>           ( 1 + ( N - 1 )*abs( INCY ) ).
*>           Before entry, the incremented array CY must contain the n
*>           element vector cy. On exit, CY is overwritten by the updated
*>           vector cy.
*> \endverbatim
*>
*> \param[in] INCY
*> \verbatim
*>          INCY is INTEGER
*>           On entry, INCY specifies the increment for the elements of
*>           CY. INCY must not be zero.
*> \endverbatim
*>
*> \param[in] C
*> \verbatim
*>          C is REAL
*>           On entry, C specifies the cosine, cos.
*> \endverbatim
*>
*> \param[in] S
*> \verbatim
*>          S is REAL
*>           On entry, S specifies the sine, sin.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex_blas_level1
*
*  =====================================================================
      SUBROUTINE CSROT( N, CX, INCX, CY, INCY, C, S )
*
*  -- Reference BLAS level1 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER           INCX, INCY, N
      REAL              C, S
*     ..
*     .. Array Arguments ..
      COMPLEX           CX( * ), CY( * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER           I, IX, IY
      COMPLEX           CTEMP
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.0 )
     $   RETURN
      IF( INCX.EQ.1 .AND. INCY.EQ.1 ) THEN
*
*        code for both increments equal to 1
*
         DO I = 1, N
            CTEMP = C*CX( I ) + S*CY( I )
            CY( I ) = C*CY( I ) - S*CX( I )
            CX( I ) = CTEMP
         END DO
      ELSE
*
*        code for unequal increments or equal increments not equal
*          to 1
*
         IX = 1
         IY = 1
         IF( INCX.LT.0 )
     $      IX = ( -N+1 )*INCX + 1
         IF( INCY.LT.0 )
     $      IY = ( -N+1 )*INCY + 1
         DO I = 1, N
            CTEMP = C*CX( IX ) + S*CY( IY )
            CY( IY ) = C*CY( IY ) - S*CX( IX )
            CX( IX ) = CTEMP
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      RETURN
      END
c $Id: csrot.f 24342 2013-06-22 05:32:15Z d3y133 $

      subroutine smd_shakelist_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_bond,sp_type,sp_shakelist
      character*32 tag,pname
      logical result

      pname = "smd_shakelist_init_system"
c
      tag = "bond"
      call smd_system_get_component(sp_bond,tag,result)
      if(.not.result) goto 200

      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "shakelist"
      call smd_system_get_component(sp_shakelist,tag,result)
      if(.not.result) 
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_shakelist_init(sp_shakelist,result)

200   continue
      if(.not.result) then
       tag = "shakelist"
       call smd_system_unset_component(tag)
      end if
c
      return
      end

      subroutine smd_shakelist_init(sp_shakelist,result)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_shakelist
      integer rtdb
      logical result
c
      character*32 pname
      character*80 tag
      character*255 filename
      integer na,nb,ns
      integer i_it
      integer i_ib1,i_ib2,i_db,i_itb
      integer h_is1t,i_is1t
      integer h_is2t,i_is2t
      integer h_dst,i_dst
      integer i_is1
      integer i_is2
      integer i_ds
      integer i
c
      pname = "smd_shakelist_init"
c
c      write(*,*) "in "//pname
c
c     get array of types
c     ------------------
      tag = "type:id"
      call smd_get_ind_size(tag,i_it,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c     get bond arrays
c     ---------------
      tag = "bond:i1"
      call smd_get_ind(tag,i_ib1,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:i2"
      call smd_get_ind(tag,i_ib2,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:distance"
      call smd_get_ind(tag,i_db,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:type"
      call smd_get_ind_size(tag,i_itb,nb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)


c
c     allocate initial storage for shake list
c     ---------------------------------------
      ns = na
      if(.not.ma_push_get(mt_int,ns,'tmp i1',h_is1t,i_is1t))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_int,ns,'tmp i2',h_is2t,i_is2t))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_dbl,ns,'tmp d',h_dst,i_dst))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)


      call smd_shakelist_set(ns,nb,na,
     >                       int_mb(i_is1t),
     >                       int_mb(i_is2t),
     >                       dbl_mb(i_dst),
     >                       int_mb(i_ib1),
     >                       int_mb(i_ib2),
     >                       int_mb(i_itb),
     >                       dbl_mb(i_db),
     >                       int_mb(i_it))
c
c     create shake list structure
c     ---------------------------
      if(ns.eq.0) then
        result = .false.
        goto 200
      end if
      call smd_namespace_create(sp_shakelist)
      tag = "shake:i1"
      call smd_data_create_get(sp_shakelist,tag,ns,MT_INT,i_is1)
      tag = "shake:i2"
      call smd_data_create_get(sp_shakelist,tag,ns,MT_INT,i_is2)
      tag = "shake:distance"
      call smd_data_create_get(sp_shakelist,tag,ns,MT_DBL,i_ds)

      do i=1,ns
       int_mb(i_is1+i-1) = int_mb(i_is1t+i-1)
       int_mb(i_is2+i-1) = int_mb(i_is2t+i-1)
       dbl_mb(i_ds+i-1)  = dbl_mb(i_dst+i-1)
      end do

200   continue
      if(.not.ma_pop_stack(h_dst))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_is2t))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_is1t))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      return
      end

      subroutine smd_shakelist_set(ns,nb,na,
     >                       is1,
     >                       is2,
     >                       ds,
     >                       ib1,
     >                       ib2,
     >                       itb,
     >                       db,
     >                       it)
c
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer ns,nb,na
      integer is1(ns)
      integer is2(ns)
      double precision  ds(ns)
      integer ib1(nb)
      integer ib2(nb)
      integer itb(nb)
      double precision  db(ns)
      integer it(na)
c
      integer i,i1,i2,j,nlist
c
      nlist = 0
      do i=1,nb
       if(itb(i).eq.1) then
        i1=0
        i2=0
        do j=1,na
         if(it(j).eq.ib1(i)) i1=j
         if(it(j).eq.ib2(i)) i2=j
         if(i1*i2.ne.0) then
          nlist = nlist + 1
          is1(nlist) = min(i1,i2)
          is2(nlist) = max(i1,i2)
          ds(nlist)  = db(i)
          i1=0
          i2=0
         end if
        end do
       end if
      end do
      ns = nlist

      return
      end

c $Id: smd_shakelist.F 22502 2012-05-20 06:11:57Z d3y133 $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     XForm_3cInts -- Produce transformed three-center integrals
C
C REVISION
C     $Id: xform_3cints.F 19697 2010-10-29 16:57:34Z d3y133 $
C
C SYNOPSIS
      Logical Function XForm_3cInts(RTDB, Geom, Type3ci, AOBas, FitBas,
     $   ALo, AHi, ILo, IHi, G_C, XFFit, G_V,
     $   Dest, G_Out, IntFil, Neglect)
      Implicit NONE
#include "errquit.fh"
      Integer RTDB, AOBas, FitBas
      Integer IntFil
      Integer ALo, AHi, ILo, IHi
      Integer G_Out, G_C, G_V, Geom
      Character*1 Type3ci, XFFit, Dest
      Double precision Neglect
C
C ARGUMENTS
C     Type3ci  Type of 3-center integrals to be used ('E'RI or 'O'verlap) [IN]
C     AOBas    Handle to basis for two of the indices ("AO basis") [IN]
C     FitBas   Handle to basis for the third index ("fitting basis") [IN]
C     ALo      Lower limit of target index range for first AO basis index [IN]
C     AHi      Upper limit of target index range for first AO basis index [IN]
C     ILo      Lower limit of target index range for 2nd AO basis index [IN]
C     IHi      Lower limit of target index range for 2nd AO basis index [IN]
C     G_C      GA handle for transformation matrix for AO basis indices [IN]
C     XFFit    'Y'es to transform fitting basis index, 'N'o to skip it [IN]
C     G_V      GA handle for transformation matrix for fitting basis index [IN]
C     Dest     Send transformed integrals to 'D'isk or 'M'emory [IN]
C     G_Out    GA handle for output buffer of integrals [IN]
C     IntFil   LUN for file to hold transformed integrals [IN]
C     Neglect  Neglect raw integrals smaller than this value [IN]
C
C RETURN VALUE
C     .TRUE.   Successful completion
C     .FALSE.  Errors in routine or dependents
C
C DESCRIPTION
C     Produce transformed three-center integrals either in disk or in memory.
C
C     The global arrays G_Out, G_C, G_V must be created and filled
C     as appropriate before entry.
C
C NOTES
C     Since the Schwarz routines aren't really general enough to
c     accomodate 3 center integrals yet, the NEGLECT threshold passed in
c     may have been manipulated to account for the size of the (s|s)
c     integrals that form the second term of the limit.  Neglect may in
c     fact be different on each node, since that's the obvious way to
c     get the best possible screening in the current circumstances.  But
c     only node 0 reports Neglect to the user, so it may be a little
c     misleading.
C
C LIMITATIONS
C     Currently DEST must be 'D'isk.
C     G_Out must be the same size
C
C MEMORY USE
C     Not here, but our dependents do use some.  I'd rather not talk about
C     it at the moment.
C
C INCLUDE FILES
#include "numerical_constants.fh"
#include "stdio.fh"
#include "bas.fh"
#include "global.fh"
#include "rimp2_timers.fh"
#include "mafdecls.fh"
#include "util.fh"
C
C EXTERNAL ROUTINES
      Logical LSame     ! From BLAS-[23]
      External LSame
      Logical  XF3cI_Step12, XF3cI_Step3, Put_3cInts
      External XF3cI_Step12, XF3cI_Step3, Put_3cInts
      Integer LNBlnk
      External LNBlnk
      Logical GA_Create_One_by_Shells
      External GA_Create_One_by_Shells
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Logical Status, TransFit, Disk
      Integer Dim1, Dim2, GAType, NFit, G_Int
      Integer IBlkSiz, OutBlkSiz, NA, NI, NJ, NK, JLo, JHi, KLo, KHi
      Character*256 String1
C
C     Since we'll synchronize pretty soon on the GA creations,
C     let's do it here to make the timings look right
C
      Call GA_Sync
      Call PStat_On( PS_XForm)
C
C     ***********************
C     * Sanity check inputs *
C     ***********************
C     Type3ci is handled by XF3cI_Step12, and it takes little time to
C     get to that point, so leave that check out here.
C
      Disk = LSame( Dest, 'D')
      If ( .NOT. (Disk .or. LSame( Dest, 'M'))) then
         Write (LuErr, *) 'XForm_3cInts: Can only place result on ',
     $      'Disk or in Memory.'
         XForm_3cInts = .False.
         Return
      EndIf
      TransFit = LSame( XFFit, 'Y')
      If ( .NOT. (TransFit .or. LSame( XFFit, 'N'))) then
         Write (LuErr, *) 'XForm_3cInts: Transform fitting basis ',
     $      'is a Y/N question.'
         XForm_3cInts = .False.
         Return
      EndIf
C
C     Basis sets
C
      Status = .TRUE.
      Status = Status .AND.
     $   Bas_Check_Handle( AOBas, 'XForm_3cInts: AO basis')
      Status = Status .AND.
     $   Bas_Check_Handle( FitBas, 'XForm_3cInts: Fitting basis')
C
C     Message already printed by the checking routine
C
      If ( .NOT. Status ) then
         XForm_3cInts = .False.
         Return
      EndIf
C
C     Global arrays which should be already created
C
      Call GA_Check_Handle( G_C, 'XForm_3cInts: AO transformation')
      If ( TransFit )
     $   Call GA_Check_Handle( G_V, 'XForm_3cInts: Fit transformation')
      If ( TransFit .or. .not. Disk)
     $   Call GA_Check_Handle( G_Out, 'XForm_3cInts: output array')
C
#ifndef RIMP2_USE_DA
C
C     If we're supposed to put the results on disk, the file had better
C     already be setup because we don't do it!
C
! not available for EAF
!      If ( Disk ) then
!         Inquire(Unit=IntFil, Opened=Status)
!      EndIf
#endif
C
C     Now sanity check the index ranges provided.
C
      Status = .TRUE.
      Status = Status .AND. ALo .gt. 0 .AND. AHi .gt. 0
     $   .AND. AHi .ge. ALo
      Status = Status .AND. ILo .gt. 0 .AND. IHi .gt. 0
     $   .AND. IHi .ge. ILo
C
      If ( .NOT. Status ) then
         Write (LuErr, 9000) ALo, AHi, ILo, IHi
         XForm_3cInts = .False.
         Return
      EndIf
 9000 Format (1X, 'XForm_3cInts: Bad range for transformation: (',
     $   I5, ':', I5, ', ', I5, ':', I5, ')')
C
C     Compute some basic quantities
C
      NA = AHi - Alo + 1
      NI = IHi - Ilo + 1
C
      Status = Bas_NumBF( FitBas, NFit)
      If ( .NOT. Status ) then
         Write (LuErr, *) 'XForm_3cInts: Unable to get basis info.'
         XForm_3cInts = .FALSE.
         Return
      EndIf
C
C     ******************************
C     * Determine number of passes *
C     ******************************
C     Use the sizes of the GAs passed in to determine block sizes.
C     This may have to change somewhat when we want to put results
C     in GAs instead of to disk.
C
      Call GA_Inquire( G_Out, GAType, Dim1, Dim2)
      IBlkSiz = Dim1 / NA
C
C     Also verify the size
C
      If ( Dim1 .lt. NA .OR. Dim2 .lt. NFit) then
         Write (LuErr, 9010) Dim1, Dim2, NA, NFit
         XForm_3cInts = .FALSE.
         Return
      EndIf
C
      If ( TransFit ) then
         Call GA_Inquire( G_Out, GAType, Dim1, Dim2)
         OutBlkSiz = Dim1 / NA
C
C        Also verify the size
C
         If ( Dim1 .lt. NA .OR. Dim2 .lt. NFit) then
            Write (LuErr, 9010) Dim1, Dim2, NA, NFit
            XForm_3cInts = .FALSE.
            Return
         EndIf
      Else
         OutBlkSiz = IBlkSiz
      EndIf
C
 9010 Format( 1X, 'XForm_3cInts: GA matrix dimensions ',
     $   'inconsistent with request:'
     $   /1X, I5, 'x', I5, ' vs. ', I5, 'x', I5, '.')
C
C     Provide some info to the user
C
      If ( Util_Print('information', Print_Low)
     $   .AND. GA_NodeID() .eq. 0) then
C
         Write (LuOut, 9110) IBlkSiz, (NI + IBlkSiz - 1) / IBlkSiz
      EndIf
C
 9110 Format(1X, 'Transformation block size', I5, ', requiring ',
     $   I5, ' integral passes.')
C
C     ****************************************************
C     * Cover the requested range of I in several passes *
C     ****************************************************
C     The block size is determined by the global array G_Out.
C     The current range of I is [JLo,JHi].
C
      Do JLo = ILo, IHi, IBlkSiz
         JHi = Min( JLo+IBlkSiz-1, IHi)
         NJ = JHi - JLo + 1
C
C        Create the GA needed for the first 2/3 transformation
C
         If ( .NOT. GA_Create_One_By_Shells( MT_Dbl, NA * NJ,
     $      FitBas, 'xf3ci: 2/3 integral matrix', G_Int) )
     $        Call ErrQuit(
     $        'XForm_3cInts: Unable to allocate temporary GA', 0,
     &       GA_ERR)
C
C        Generate blocks of (ai|s) (or (ais) ) integrals for the
C        specified range of I.
C
         Status = XF3cI_Step12( RTDB, Geom, Type3ci, ALo, AHi,
     $      JLo, JHi, AOBas, G_C, FitBas, G_Int, Neglect)
         If ( .NOT. Status ) then
            Write (LuErr, 9020) JLo, JHi, Ilo, Ihi
            XForm_3cInts = .FALSE.
            Return
         EndIf
 9020    Format( 1x, 'XForm_3cInts: Error occurred in integral block ',
     $      I5, ':', I5, ' of requested ', I5, ':', I5, '.')
C
         If ( Util_Print('2/3 ints', Print_Debug) ) Call GA_Print(G_Int)
C
C        Transform fitting basis & write out the result
C
         If ( TransFit ) then
C
C           For this transformation, we need another global array in 
C           which to deposit the results.  It may not be the same size
C           as G_Int -- for space efficiency when the results ultimately
C           go to disk, for example, G_Out should hold only a single I.
C
            Do KLo = JLo, JHi, OutBlkSiz
               KHi = Min( KLo+OutBlkSiz-1, JHi)
               NK = KHi - KLo + 1
C
C              Do the final 1/3 transformation.  Note that here
C              we specify the region to transform relative to the
C              existing global array, not relative to absolute
C              indices of the occupied & virtual orbitals.
C
               Call GA_Zero(G_Out)
               Status = XF3cI_Step3( G_Int, NA, NJ, 1, NA,
     $            KLo-JLo+1, KHi-JLo+1, 1, NFit,
     $            G_V, 1, NFit, G_Out, NA, NK, 1, 1, 1)
               If ( .NOT. Status ) then
                  Write (LuErr, 9030) KLo, KHi, JLo, JHi, ILo, IHi
                  XForm_3cInts = .FALSE.
                  Return
               EndIf
C
C              Now we're back to actual indices of the occupied
C              and virtual orbitals.
C
               If ( Disk ) then
                  Call PStat_On( PS_Wr_3ci)
                  Status = Put_3cInts(IntFil, G_Out, NA, KLo, KHi)
                  If ( .NOT. Status ) then
                     Write (LuErr, 9030) KLo, KHi, JLo, JHi, ILo, IHi
                     XForm_3cInts = .FALSE.
                     Return
                  EndIf
                  Call PStat_Off( PS_Wr_3ci)
               EndIf
C
               If ( Util_Print('mo ints', Print_Debug) )
     $            Call GA_Print(G_Out)
            EndDo               ! KLo
C
C           If we are skipping the final 1/3-transformation, we
C           can just write directly from G_Int in one go.
C
         Else
            If ( Disk ) then
               Call PStat_On( PS_Wr_3ci)
               Status = Put_3cInts(IntFil, G_Int, NA, JLo, JHi)
               If ( .NOT. Status ) then
                  Write (LuErr, 9030) JLo, JHi, JLo, JHi, ILo, IHi
                  XForm_3cInts = .FALSE.
                  Return
               EndIf
               Call PStat_Off( PS_Wr_3ci)
            EndIf
C
            If ( Util_Print('mo ints', Print_Debug) )
     $         Call GA_Print(G_Out)
C
         EndIf
 9030    Format( 1X, 'XForm_3cInts: Error occurred in output block ',
     $      I5, ':', I5, ' of integral block ', I5, ':', I5,
     $      ' of requested ', I5, ':', I5, '.')
C
C        Free 2/3 integral array to allow it to be resized next pass
C
         If ( .NOT. GA_Destroy( G_Int) ) Call ErrQuit(
     $        'XForm_3cInts: Unable to deallocate temporary GA', 0,
     &       GA_ERR)
C
C        Print out a progress report.  Eventually want to make this
C        dependent on user desires and time required by each pass.
C
         If ( Util_Print('progress reports', Print_Default) ) then
            Write (String1, 9200) JLo, JHi
 9200       Format('XForm_3cInts: Completed ', I5, ':', I5, ' pass.')
            Call Progress_Report(LuOut, String1(:LNBlnk(String1)) )
         EndIf
      EndDo                     ! JLo
C
      Call GA_Sync
C
      XForm_3cInts = .TRUE.
C
      Call PStat_Off( PS_XForm)
C
      Return
      End

*
* $Id: fci_cntone.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_cntone(nonelt,nonemx)
      implicit none
#include "fciinfo.fh"
c     
c     1) count all non-zero one-electron coupling coefficents -> nonelt
c     2) find the maximum involving any given orbital configuration -> nonemx
c
c     This new version just estimates the information.
c     nonemx is about 2x too big, nonelt is about 50% too big
c     
      integer nonelt            ! [output]
      integer nonemx            ! [output]
c
      integer kocc(nactmx),indbar(nactmx)
      logical oprint
c
      integer ns, k, nspt, mkdim, ntest,kwalk, kdet, nd
c
      oprint =.false.
      nonelt = 0
      nonemx = 0
      
      call fci_tstart(11,.false.)
c     find occupancy, compute no. of open shells and indbar vector
      do 5 kwalk = 1,nwalko
         call fci_ofind_occ(kwalk,kocc)
         kdet = indexo(kwalk)
         ns = 0
         nd = 0
         do 10 k = 1,nactiv
            if (kocc(k).eq.2) ns = ns + 1
            if (kocc(k).eq.3) nd = nd + 1
            indbar(k) = ns
 10      continue
         nspt = ns/2 + 1
         mkdim = mnsdet(ns)
         if (mkdim.eq.0) goto 5
         ntest = nd*(1+2*(nactiv+1-ns-nd)) + ns*(nactiv+1)
         ntest = ntest*mkdim
         if (nonemx .lt. ntest) nonemx = ntest
         nonelt = nonelt + ntest
 5    continue
      call fci_tfinish(11,.false.)
c
      end

      subroutine writel(p,newbas,oprint)
C$Id: writel.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
      logical oprint
      real *8 p(*)
      integer newbas
c
      integer ind, i, j
c
      integer m5, m, n
c
      ind(i,j)=max0(i,j)*(max0(i,j)-1)/2+min0(i,j)
c
      m5=12
      if(oprint) m5=8
      m=1
      n=m5
   6  if(newbas.lt.m)return
      if(n.gt.newbas)n=newbas
      if(.not.oprint)write(6,200)(i,i=m,n)
      if(oprint)write(6,100)(i,i=m,n)
100   format(//3x,8i14)
200   format(//12i9)
      write(6,101)
101   format(/)
      do 1 j=1,newbas
      if(oprint)write(6,102)j,(p(ind(i,j)),i=m,n)
      if(.not.oprint)write(6,202)j,(p(ind(i,j)),i=m,n)
 1    continue
102   format(7x,i3,8f14.7)
202   format(1x,i3,12f9.4)
      m=m+m5
      n=n+m5
      goto 6
      end

      subroutine put_2pdm_hhpp(d_2pdm,k_2pdm_offset,
     1                         d_hhpp,k_hhpp_offset)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
c
      integer d_2pdm,k_2pdm_offset
      integer d_hhpp,k_hhpp_offset
c
      integer h1b,h2b,p3b,p4b
      integer h1,h2,p3,p4
      integer k_r2,l_r2,k_r2_sort,l_r2_sort,size
      integer i
c
      integer next
      integer count
      integer nxtask
      integer nprocs
      external nxtask
c
      nprocs=ga_nnodes()
      count=0
      next=nxtask(nprocs,1)
c
      do h1b = 1,noab
      do h2b = 1,noab
      do p3b = noab+1,noab+nvab
      do p4b = noab+1,noab+nvab
         if(next.eq.count) then
c
         if (int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)
     1       .eq. int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)) then
         if ((.not.restricted).or.
     1      (int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     2       int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1).ne.8)) then
         if (ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),
     1       ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+p4b-1))))
     2       .eq. irrep_e) then
             size = int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
     1            * int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1)
             if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1       call errquit('put_2pdm_hhpp: MA problem',0,MA_ERR)
c
             if (.not.ma_push_get(mt_dbl,size,'r2_sort',l_r2_sort,
     1           k_r2_sort))
     1       call errquit('put_2pdm_hhpp: MA problem',0,MA_ERR)

c
             if (p4b.ge.p3b.and.h2b.ge.h1b) then
                call get_hash_block(d_hhpp,dbl_mb(k_r2),size,
     1               int_mb(k_hhpp_offset),((((h1b-1)*noab+h2b-1)
     2               *nvab+p3b-noab-1)*nvab+p4b-noab-1))
c               
                call put_hash_block(d_2pdm,dbl_mb(k_r2),size,
     1               int_mb(k_2pdm_offset),
     1               (p4b-1)+(p3b-1)*(noab+nvab)+
     1               (h2b-1)*(noab+nvab)*(noab+nvab)+
     1               (h1b-1)*(noab+nvab)*(noab+nvab)*(noab+nvab))
             endif
c
             if (p4b.ge.p3b.and.h2b.lt.h1b) then
                call get_hash_block(d_hhpp,dbl_mb(k_r2),size,
     1               int_mb(k_hhpp_offset),((((h2b-1)*noab+h1b-1)
     2               *nvab+p3b-noab-1)*nvab+p4b-noab-1))
c
                i=0
                do h2=1,int_mb(k_range+h2b-1)
                do h1=1,int_mb(k_range+h1b-1)
                do p3=1,int_mb(k_range+p3b-1)
                do p4=1,int_mb(k_range+p4b-1)
                   dbl_mb(k_r2_sort+p4-1+(p3-1)*int_mb(k_range+p4b-1)+
     1             (h2-1)*int_mb(k_range+p4b-1)*int_mb(k_range+p3b-1)+
     1             (h1-1)*int_mb(k_range+p4b-1)*int_mb(k_range+p3b-1)*
     1             int_mb(k_range+h2b-1)) = - dbl_mb(k_r2+i)
                   i=i+1
                enddo
                enddo
                enddo
                enddo
c
                call put_hash_block(d_2pdm,dbl_mb(k_r2_sort),size,
     1               int_mb(k_2pdm_offset),
     1               (p4b-1)+(p3b-1)*(noab+nvab)+
     1               (h2b-1)*(noab+nvab)*(noab+nvab)+
     1               (h1b-1)*(noab+nvab)*(noab+nvab)*(noab+nvab))
             endif
c
             if (p4b.lt.p3b.and.h2b.ge.h1b) then
                call get_hash_block(d_hhpp,dbl_mb(k_r2),size,
     1               int_mb(k_hhpp_offset),((((h1b-1)*noab+h2b-1)
     2               *nvab+p4b-noab-1)*nvab+p3b-noab-1))
c
                i=0
                do h1=1,int_mb(k_range+h1b-1)
                do h2=1,int_mb(k_range+h2b-1)
                do p4=1,int_mb(k_range+p4b-1)
                do p3=1,int_mb(k_range+p3b-1)
                   dbl_mb(k_r2_sort+p4-1+(p3-1)*int_mb(k_range+p4b-1)+
     1             (h2-1)*int_mb(k_range+p4b-1)*int_mb(k_range+p3b-1)+
     1             (h1-1)*int_mb(k_range+p4b-1)*int_mb(k_range+p3b-1)*
     1             int_mb(k_range+h2b-1)) = - dbl_mb(k_r2+i)
                   i=i+1
                enddo
                enddo
                enddo
                enddo
c
                call put_hash_block(d_2pdm,dbl_mb(k_r2_sort),size,
     1               int_mb(k_2pdm_offset),
     1               (p4b-1)+(p3b-1)*(noab+nvab)+
     1               (h2b-1)*(noab+nvab)*(noab+nvab)+
     1               (h1b-1)*(noab+nvab)*(noab+nvab)*(noab+nvab))
             endif
c
             if (p4b.lt.p3b.and.h2b.lt.h1b) then
                call get_hash_block(d_hhpp,dbl_mb(k_r2),size,
     1               int_mb(k_hhpp_offset),((((h2b-1)*noab+h1b-1)
     2               *nvab+p4b-noab-1)*nvab+p3b-noab-1))
c
                i=0
                do h2=1,int_mb(k_range+h2b-1)
                do h1=1,int_mb(k_range+h1b-1)
                do p4=1,int_mb(k_range+p4b-1)
                do p3=1,int_mb(k_range+p3b-1)
                   dbl_mb(k_r2_sort+p4-1+(p3-1)*int_mb(k_range+p4b-1)+
     1             (h2-1)*int_mb(k_range+p4b-1)*int_mb(k_range+p3b-1)+
     1             (h1-1)*int_mb(k_range+p4b-1)*int_mb(k_range+p3b-1)*
     1             int_mb(k_range+h2b-1)) = dbl_mb(k_r2+i)
                   i=i+1
                enddo
                enddo
                enddo
                enddo
c
                call put_hash_block(d_2pdm,dbl_mb(k_r2_sort),size,
     1               int_mb(k_2pdm_offset),
     1               (p4b-1)+(p3b-1)*(noab+nvab)+
     1               (h2b-1)*(noab+nvab)*(noab+nvab)+
     1               (h1b-1)*(noab+nvab)*(noab+nvab)*(noab+nvab))
             endif
c
            if (.not.ma_pop_stack(l_r2_sort))
     1      call errquit('put_1pdm_hh: MA problem',1,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2))
     1      call errquit('put_1pdm_hh: MA problem',1,MA_ERR)
         endif
         endif
         endif
         next=nxtask(nprocs,1)
         endif
         count=count+1
c
      enddo
      enddo
      enddo
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c
      end
c $Id: put_2pdm_hhpp.F 21176 2011-10-10 06:35:49Z d3y133 $

C $Id: ecp_int0.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_int0 (mem_max,DryRun,
     &    l_a,n_prim_a,n_cont_a,coef_a,zeta_a,n_na,
     &    l_b,n_prim_b,n_cont_b,coef_b,zeta_b,n_nb,
     &    l_ecp,n_prim_c,n_coef_c,
     &    ind_z,ind_c,n_z_tot,n_c_tot,l_ecp_max,n_cent,
     &    zeta_c,coef_c,p_min,p_max,tol,sphcart,tmp,l_tmp,
     &    csco,lcsco,
     &    ecp_ints,n_blk,ibug)
*                                                                      *
*   Calculate Type 0 nonlocal integrals for a given ECP centre         *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   mem_max (out) - maximum scratch memory required                    *
*   DryRun (inp) - logical to only return memory if true               *
*   l_a (inp) - (maximum) angular momentum of functions on centre A    *
*   n_prim_a (inp) - number of primitive functions on centre A         *
*   n_cont_a (inp) - number of contracted functions on centre A        *
*   coef_a (inp) - centre A contraction coefficients                   *
*   zeta_a (inp) - centre A exponents                                  *
*   n_na (inp) - number of cartesian components for centre A           *
*   l_b (inp) - (maximum) angular momentum of functions on centre B    *
*   n_prim_b (inp) - number of primitive functions on centre B         *
*   n_cont_b (inp) - number of contracted functions on centre B        *
*   coef_b (inp) - centre B contraction coefficients                   *
*   zeta_b (inp) - centre B exponents                                  *
*   n_nb (inp) - number of cartesian components for centre B           *
*   l_ecp (inp) - maximum angular momentum of ECP projectors           *
*   n_prim_c (inp) - number of primitive functions for each power of r *
*                    in ECP expansion                                  *
*   n_coef_c (inp) - array of number of coefficients/exponents for     *
*                    each projector                                    *
*   ind_z (inp) - array of addresses of first exponent for each l      *
*   ind_c (inp) - array of addresses of first coefficient for each l   *
*   n_z_tot (inp) - total number of ECP exponents                      *
*   n_c_tot (inp) - total number of ECP coefficients                   *
*   l_ecp_max (inp) - maximum angular momentum of any ECP projector    *
*   n_cent (inp) - number of ECP centres                               *
*   zeta_c - ECP exponents                                             *
*   coef_c - ECP contraction coefficients                              *
*   p_min - minimum power of r in ECP expansion                        *
*   p_max - maximum power of r in ECP expansion                        *
*   tol (inp) - maximum relative error in bessel functions             *
*   sphcart (inp) - 1 for spherical basis, 0 for cartesian basis.      *
*   tmp (scr) - work array                                             *
*   l_tmp (inp) - length of tmp                                        *
*   csco (inp) - cartesian/spherical transformation                    *
*   lcsco (inp) - length of cartesian/spherical transformation         *
*   ecp_ints - integrals over ECP                                      *
*   n_blk (inp) - 1 for scalar only, 3 for s-o only, 4 for both        *
*   ibug - debug flag. 0 for no debug, 1 for address printing, 2 for   *
*          array printing, 3 for both.                                 *
*                                                                      *
*   Notes:                                                             *
*   -----                                                              *
*                                                                      *
*   The integrals come out in the order cmpt_a, cont_a, cmpt_b, cont_b *
*      where cont = contracted functions, cmpt = cartesian components  *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
#include "stdio.fh"
#include "ecp_consts.fh"
#include "util.fh"
#include "errquit.fh"
      integer l_a,n_prim_a,n_cont_a,n_na,l_b,n_prim_b,n_cont_b,n_nb,
     &    l_ecp,l_ecp_max,n_z_tot,n_c_tot,n_cent,l_tmp,p_min,p_max,
     &    sphcart,mem_max,n_blk,ibug
      integer n_coef_c(-1:l_ecp_max,n_cent,2),
     &    n_prim_c(p_min:p_max,-1:l_ecp_max,n_cent,2),
     &    ind_z(-1:l_ecp_max,n_cent,2),ind_c(-1:l_ecp_max,n_cent,2)
      integer i,j,m,i_wrk,i_prm,i_tmp,i_Q_int,i_coef,i_scr,i_free,i_ang,
     &    i_ze,i_cont_c,i_off,i_co,l_c,l_c_min,l_c_max,l_cmp,
     &    n_ab,nc_ab,ncab,n_l,n_co,n_co_tot,n_co_max,n_cont_c
      integer n_all_a,n_all_b,n_ang,n_x,n_pass
      integer lcsco
      logical DryRun,debug_gen,debug_addresses,debug_arrays,skip
      double precision zeta_c(n_z_tot),coef_c(n_c_tot),
     &    coef_a(n_prim_a,n_cont_a),coef_b(n_prim_b,n_cont_b),
     &    zeta_a(n_prim_a),zeta_b(n_prim_b),
     &    tmp(l_tmp),ecp_ints(n_na,n_cont_a,n_nb,n_cont_b,n_blk),
     &    tol,wa,wb,wc
      double precision csco(lcsco)
*
      debug_gen = ibug .gt. 0
      debug_addresses = mod(ibug,2) .eq. 1
      debug_arrays = (mod(ibug,10)/2 .eq. 1) .and. .not.DryRun
*
      if (debug_gen) write (LuOut,'(//A,/)') 'Entering ecp_int0 ...'
*
      if (debug_addresses) then
        write (LuOut,*) 'n_prim_a,n_prim_b,n_cont_a,n_cont_b',
     &      n_prim_a,n_prim_b,n_cont_a,n_cont_b
        write (LuOut,*) 'n_cent,n_c_tot',n_cent,n_c_tot
      end if
      n_ab = n_prim_a*n_prim_b
      nc_ab = n_prim_a*n_cont_b
      ncab = n_cont_a*n_cont_b
      n_all_a = n_cont_a*n_na
      n_all_b = n_cont_b*n_nb
      if (debug_addresses) then
        write (LuOut,*) 'n_ab,nc_ab,ncab',n_ab,nc_ab,ncab
      end if
      if (DryRun) mem_max = 0
*
*   Check angular momenta
*
      if (sphcart .eq. 0) then
        if (mod(l_a+l_b,2) .ne. 0) return
        l_c_min = mod(l_b,2)
        l_c_max = min(l_a,l_b,l_ecp)
      else
        if (l_a .ne. l_b) return
        if (l_a .gt. l_ecp) return
        l_c_min = l_a
        l_c_max = l_a
      end if
*
*   Loop over ECP angular momentum projectors (l values)
*
      if (debug_addresses) write (LuOut,*) 'l_c_min,l_c_max,l_ecp',
     &    l_c_min,l_c_max,l_ecp
      do l_c = l_c_min,l_c_max,2
*
*     Define parameters for the different integral class cases
*
        call ecp_ind_var (l_c,n_blk,n_coef_c(l_c,1,1),n_coef_c(l_c,1,2),
     &      ind_c(l_c,1,1),ind_c(l_c,1,2),ind_z(l_c,1,1),ind_z(l_c,1,2),
     &      n_x,n_co_tot,n_co_max,i_off,n_pass,i_cont_c,n_cont_c,skip)
        if (debug_addresses) write (LuOut,*) 'l_c,n_x,skip',l_c,n_x,skip
        if (skip) go to 10
*
*     Set up pointers for radial integral evaluation
*
        i_Q_int = 1
        i_tmp = i_Q_int+ncab*max(n_cont_c,n_pass)
        i_prm = i_tmp+n_ab
        i_wrk = i_prm+n_ab*n_co_max
        i_coef = i_wrk+nc_ab
        i_free = i_coef+n_co_tot
        if (debug_addresses) write (LuOut,*) 
     &      'i_Q_int,i_tmp,i_prm,i_wrk,i_coef,i_free',
     &      i_Q_int,i_tmp,i_prm,i_wrk,i_coef,i_free
        if (DryRun) then
          mem_max = max(mem_max,i_free-1)
          if (debug_addresses) write (LuOut,*) 'mem_max',mem_max
        else
          if (i_free-1 .gt. l_tmp) call errquit(
     &        ' Insufficient memory in ecp_int0',99, MEM_ERR)
          i = i_cont_c
          j = i_Q_int
          do m = 1,n_pass
            i_ze = ind_z(l_c,1,i)
            i_co = ind_c(l_c,1,i)
            n_co = n_coef_c(l_c,1,i)
            call dcopy (n_co,coef_c(i_co),1,tmp(i_coef),1)
            if (n_cont_c .eq. 2) call dcopy 
     &          (n_co,coef_c(ind_c(l_c,1,2)),1,tmp(i_coef+n_co),1)
            if (debug_addresses) write (LuOut,*) 
     &          'l_c,i_ze,i_co,n_co',
     &          l_c,i_ze,i_co,n_co
            call ecp_radint0 (p_min,p_max,
     &          n_prim_c(p_min,l_c,1,i),n_co,n_cont_c,
     &          zeta_c(i_ze),tmp(i_coef),
     &          l_a,n_prim_a,n_cont_a,zeta_a,coef_a,
     &          l_b,n_prim_b,n_cont_b,zeta_b,coef_b,
     &          tmp(i_prm),tmp(i_tmp),tmp(i_wrk),tmp(j),
     &          (ibug/10))
            i = i+1
            j = j+ncab
          end do
        end if
*
        n_l = 2*l_c+1
        if (sphcart .eq. 0) then
*
*       Cartesian integrals.
*
          wa = n_l
          wa = pi/wa
          wb = wa+wa
          if (debug_addresses) write (LuOut,*) 'n_l,n_na,n_x',
     &        n_l,n_na,n_x
          i_ang = i_tmp+n_l*n_na
          n_ang = n_l**2
          i_scr = i_ang+n_ang*n_x
          i_free = i_scr+max(n_na*n_nb,n_ang)
          if (debug_addresses) write (LuOut,*) 'i_ang,i_free',i_ang,
     &        i_free
          if (DryRun) then
            mem_max = max(mem_max,i_free-1)
            if (debug_addresses) write (LuOut,*) 'mem_max',mem_max
          else
            if (i_free-1 .gt. l_tmp) call errquit(
     &          ' Insufficient memory in ecp_int0',99, MEM_ERR)
*
*       Set up angular overlap/spin-orbit matrix
*
            call dcopy (n_ang*n_x,zero,0,tmp(i_ang),1)
*
*         scalar potential
*
            i = i_ang
            if (n_x .ne. 3) then
              call dfill (n_l,wb,tmp(i),n_l+1)
              tmp(i_ang+2*l_c*(l_c+1)) = wb+wb
              i = i+n_ang
            end if
*
*         spin-orbit potentials 
*
            if ((n_x .ne. 1) .and. (l_c .gt. 0)) then
*
*           z spin-orbit potential 
*
              j = i
              do m = -l_c,l_c
                j = j+l_c+l_c
                tmp(j) = m
                tmp(j) = tmp(j)*wb
              end do
*
*           y,x spin-orbit potentials
*
              i = i+n_ang
              j = i+n_ang+l_c+l_c-1
              do m = -l_c,l_c-1
                wc = (l_c-m)*(l_c+m+1)
                wc = sqrt(wc)*wa
                if ((m .eq. 0) .or. (m .eq. -1)) wc = wc+wc
                if (m .ge. 0) wc = -wc
                if (m .eq. -1) then
                  i = i+n_l+1
                else
                  i = i+1
                  tmp(i) = -wc
                  i = i+l_c+l_c
                  tmp(i) = wc
                  i = i+1
                end if
                tmp(j) = wc
                j = j+l_c+l_c
                if ((m .lt. -1) .or. (m .gt. 0)) then
                  tmp(j+2) = wc
                end if
              end do
            end if
*
            i = i_ang
            do j = 1,n_x
              m = j+i_off
              if (debug_arrays) call ecp_matpr (tmp(i),-l_c,l_c,
     &            -l_c,l_c,-l_c,l_c,-l_c,l_c,'Spherical tensor overlap',
     &            'F',78,4)
              call ecp_cstrans (l_a,n_na,n_l,l_c,l_c,l_cmp,tmp(i_tmp),
     &            n_na,tmp(i),n_l,csco,lcsco,csco,-1,-1,1)
              if (debug_arrays) call ecp_matpr (tmp(i_tmp),1,n_na,-l_c,
     &            l_c,1,n_na,-l_c,l_c,'Transformed for l_a','F',78,4)
              call ecp_cstrans (l_b,n_nb,n_na,l_c,l_c,l_cmp,tmp(i_scr),
     &            n_na,tmp(i_tmp),n_na,csco,lcsco,csco,-1,1,1)
              if (debug_arrays) call ecp_matpr (tmp(i_scr),1,n_na,
     &            1,n_nb,1,n_na,1,n_nb,'Angular integrals','F',78,4)
              if (debug_arrays) call ecp_matpr (tmp(i_Q_int),1,n_cont_a,
     &            1,n_cont_b,1,n_cont_a,1,n_cont_b,'Radial integrals',
     &            'F',78,4)
              call ecp_angrad (n_na,n_cont_a,n_nb,n_cont_b,
     &            tmp(i_scr),tmp(i_Q_int),ecp_ints(1,1,1,1,m))
              if (debug_arrays) call ecp_matpr (ecp_ints(1,1,1,1,m),
     &            1,n_all_b,1,n_all_a,1,n_all_b,1,n_all_a,
     &            'Assembled integrals','E',78,4)
              if ((j .eq. 1) .and. (n_x .eq. 4)) 
     &            i_Q_int = i_Q_int+ncab
              i = i+n_ang
            end do
          end if
        else
          if (n_blk .gt. 1) call errquit (
     &        'Cannot do spherical ecp spin-orbit type 0 integrals',
     &        99, INT_ERR)
*
*       Spherical integrals (assume here that sphericals are normalized)
*
          wa = 1
          m = i_Q_int
          do i = 1,n_cont_b
            do j = 1,n_l
              call daxpy (n_cont_a,wa,tmp(m),1,ecp_ints(j,1,j,i,1),n_l)
            end do
            m = m+n_cont_a
          end do
        end if
   10   continue
      end do
      if (debug_arrays) then
        do j = 1,n_blk
          call ecp_matpr (ecp_ints(1,1,1,1,j),1,n_all_b,1,n_all_a,
     &        1,n_all_b,1,n_all_a,'ECP integrals','E',78,4)
        end do
      end if
      if (debug_gen) write (LuOut,*) 'Exiting ecp_int0'
*
      return
      end

      subroutine smd_param_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_param
      character*32 tag,pname
      logical result

      pname = "smd_param_init_system"
c
      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_param_init(sp_param)

      return
      end

      subroutine smd_param_init(namespace)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
c
      character*32 pname
      character*80 tag
      character*255 filename
      integer na
      integer i_ta,i_tt,i_tr,i_q,i_m
      logical result
c
      pname = "smd_param_init"
c
c      write(*,*) "in "//pname
c
c
c     get total number of atoms in parameter file
c     -------------------------------------------
      call smd_paramfile_natoms(na)
      write(*,*) "number of atoms in parameter space",na
      if(na.le.0)
     >  call errquit(
     >       pname//'no parameters fond',0, 0)

c
      call smd_namespace_create(namespace)
c
c     create parameter data structures
c     ---------------------------
      call smd_data_create(namespace,"param:atomname",16*na,MT_BYTE)
      call smd_data_create(namespace,"param:typename",16*na,MT_BYTE)
      call smd_data_create(namespace,"param:charge",na,MT_DBL)
      call smd_data_create(namespace,"param:mass",na,MT_DBL)
      call smd_data_create(namespace,"param:resname",16*na,MT_BYTE)

c
c     fill in names and coordinates from parameter file
c     -------------------------------------------------
      tag = "param:atomname"
      call smd_data_get_index(namespace,tag,i_ta,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "param:typename"
      call smd_data_get_index(namespace,tag,i_tt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

      tag = "param:resname"
      call smd_data_get_index(namespace,tag,i_tr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

      tag = "param:mass"
      call smd_data_get_index(namespace,tag,i_m,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

      tag = "param:charge"
      call smd_data_get_index(namespace,tag,i_q,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)


      call smd_paramfile_read_atom(na,
     +                         byte_mb(i_ta),
     +                         byte_mb(i_tt),
     +                         byte_mb(i_tr),
     +                         dbl_mb(i_m),
     +                         dbl_mb(i_q))

      return
      end

      subroutine smd_param_ntot(namespace,ntot)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      integer ntot
c
      character*72 tag
      character*30 pname
      logical result

      pname = "smd_param_ntot"
      tag = "param:charge"
      call smd_data_get_size(namespace,tag,ntot,result)
      if(.not. result)  
     >  call errquit(
     >       pname//'error getting size for '//tag,0, 0)
      ntot = ntot

      return
      end

c $Id: smd_param.F 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE ccsdt_2pdm_hhhh_mo(d_i0,d_t1,d_t2,d_t3,d_y2,d_y3,k_i0_o
     &ffset,k_t1_offset,k_t2_offset,k_t3_offset,k_y2_offset,k_y3_offset)
C     $Id: ccsdt_2pdm_hhhh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 h1 h2 )_yt + = 1/2 * Sum ( p5 p6 ) * t ( p5 p6 h1 h2 )_t * y ( h3 h4 p5 p6 )_y
C     i0 ( h3 h4 h1 h2 )_yt + = 1/6 * Sum ( h8 p5 p6 p7 ) * t ( p5 p6 p7 h1 h2 h8 )_t * y ( h3 h4 h8 p5 p6 p7 )_y
C     i0 ( h2 h3 h1 h4 )_ytt + = -1/2 * P( 2 ) * Sum ( p9 ) * t ( p9 h1 )_t * i1 ( h2 h3 h4 p9 )_yt
C         i1 ( h2 h3 h1 p9 )_yt + = 1 * Sum ( p6 ) * t ( p6 h1 )_t * y ( h2 h3 p6 p9 )_y
C         i1 ( h2 h3 h1 p9 )_yt + = -1 * Sum ( h7 p5 p6 ) * t ( p5 p6 h1 h7 )_t * y ( h2 h3 h7 p5 p6 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_t3
      INTEGER k_t3_offset
      INTEGER d_y3
      INTEGER k_y3_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      CHARACTER*255 filename
      CALL ccsdt_2pdm_hhhh_mo_1(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i0,k
     &_i0_offset)
      CALL ccsdt_2pdm_hhhh_mo_2(d_t3,k_t3_offset,d_y3,k_y3_offset,d_i0,k
     &_i0_offset)
      CALL OFFSET_ccsdt_2pdm_hhhh_mo_3_1(l_i1_offset,k_i1_offset,size_i1
     &)
      CALL TCE_FILENAME('ccsdt_2pdm_hhhh_mo_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_2pdm_hhhh_mo_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i1
     &,k_i1_offset)
      CALL ccsdt_2pdm_hhhh_mo_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i1
     &,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_2pdm_hhhh_mo_3(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k
     &_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_2pdm_hhhh_
     &mo',-1,MA_ERR)
      RETURN
      END
      SUBROUTINE ccsdt_2pdm_hhhh_mo_1(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdt_2pdm_hhhh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 h1 h2 )_yt + = 1/2 * Sum ( p5 p6 ) * t ( p5 p6 h1 h2 )_t * y ( h3 h4 p5 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h1b,h2b,p5b_1,p6b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,p5b,p6b,h3b_2,h4b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_1',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_1',6,
     &MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1)
     &,2,1,4,3,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h4b - 1 + noab * (h3b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_1',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_2pdm_hhhh_mo_2(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdt_2pdm_hhhh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 h1 h2 )_yt + = 1/6 * Sum ( h8 p5 p6 p7 ) * t ( p5 p6 p7 h1 h2 h8 )_t * y ( h3 h4 h8 p5 p6 p7 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h8b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p7b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h8b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER h8b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(3)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h8b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h8b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h8b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p5b,p6b,p7b,h1b,h2b,h8b,p5b_1,p6b_1,p7b_1,h1
     &b_1,h2b_1,h8b_1)
      CALL TCE_RESTRICTED_6(h3b,h4b,h8b,p5b,p6b,p7b,h3b_2,h4b_2,h8b_2,p5
     &b_2,p6b_2,p7b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+p7b-1) * int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_2',2,MA_ERR)
      IF ((h8b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 + noab * (p7b_1 - noa
     &b - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,4,3,2,1,1.0d0)
      END IF
      IF ((h1b .le. h8b) .and. (h8b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 + noab * (p7b_1 - noa
     &b - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h2b-1),6,4,5,3,2,1,-1.0d0)
      END IF
      IF ((h2b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p7b_1 - noa
     &b - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h8b-1),5,4,6,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_2',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_2',5,MA_ERR)
      IF ((h8b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),3,2,1,6,5,4,1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (h8b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),3,1,2,6,5,4,-1.0d0)
      END IF
      IF ((h4b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h8b_2 - 1 + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h8b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),2,1,3,6,5,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_2',6,
     &MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      nsuperp(3) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      IF (p6b .eq. p7b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,6.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsuperp(3)),dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1)
     &,2,1,4,3,1.0d0/6.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h4b - 1 + noab * (h3b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_2',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_2pdm_hhhh_mo_3(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdt_2pdm_hhhh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h2 h3 h1 h4 )_ytt + = -1/2 * P( 2 ) * Sum ( p9 ) * t ( p9 h1 )_t * i1 ( h2 h3 h4 p9 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h3b
      INTEGER h1b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER p9b_1
      INTEGER h1b_1
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h1b = 1,noab
      DO h4b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h4b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h4b-1)))) .eq. ieor(irrep_y,ieor(irrep_t
     &,irrep_t))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+p9b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p9b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p9b,h1b,p9b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h2b,h3b,h4b,p9b,h2b_2,h3b_2,h4b_2,p9b_2)
      dim_common = int_mb(k_range+p9b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb
     &(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p9b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1 + noab * (h2b_
     &2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),int_mb(k_range+p9b-1)
     &,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3',9,MA_ERR)
      IF ((h1b .le. h4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (h2b - 1)))))
      END IF
      IF ((h4b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1)
     &,3,2,1,4,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h2b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_2pdm_hhhh_mo_3_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdt_2pdm_hhhh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 h3 h1 p9 )_yt + = 1 * Sum ( p6 ) * t ( p6 h1 )_t * y ( h2 h3 p6 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h3b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER p9b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p6b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p6b,h1b,p6b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h2b,h3b,p9b,p6b,h2b_2,h3b_2,p9b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb
     &(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p6b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3_1',5,MA_ERR)
      IF ((p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab 
     &* (h2b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+p6b-1),int_mb(k_range+p9b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((p9b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab 
     &* (h2b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p6b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3_1',
     &6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h3b - 1 + noab * (h2b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsdt_2pdm_hhhh_mo_3_1(l_a_offset,k_a_offset,siz
     &e)
C     $Id: ccsdt_2pdm_hhhh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 h3 h1 p9 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h2b
      INTEGER h3b
      INTEGER h1b
      INTEGER p9b
      length = 0
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p9b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (h3b - 1 + noab * (h2b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+p9b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsdt_2pdm_hhhh_mo_3_2(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdt_2pdm_hhhh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 h3 h1 p9 )_yt + = -1 * Sum ( h7 p5 p6 ) * t ( p5 p6 h1 h7 )_t * y ( h2 h3 h7 p5 p6 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h3b
      INTEGER h1b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER h7b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h7b_1
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER h7b_2
      INTEGER p9b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h1b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h7b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h7b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h1b,h7b,p5b_1,p6b_1,h1b_1,h7b_1)
      CALL TCE_RESTRICTED_6(h2b,h3b,h7b,p9b,p5b,p6b,h2b_2,h3b_2,h7b_2,p9
     &b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+h7b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb
     &(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3_2',2,MA_ERR)
      IF ((h7b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h1b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h1b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h7b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3_2',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_2pdm_hhhh_mo_3_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3_2',5,MA_ERR)
      IF ((h7b .lt. h2b) .and. (p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),6,3,2,1,5,4,1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (p5b .le. p9b) .and. (p9b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),5,3,2,1,6,4,-1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,3,2,1,6,5,1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (h7b .lt. h3b) .and. (p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h3b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),6,3,1,2,5,4,-1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (h7b .lt. h3b) .and. (p5b .le. p9b) .and.
     & (p9b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h3b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),5,3,1,2,6,4,1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (h7b .lt. h3b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h3b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h3b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,3,1,2,6,5,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h7b_2 - 1 + noab * (h3b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h7b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),6,2,1,3,5,4,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (p5b .le. p9b) .and. (p9b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h7b_2 - 1 + noab * (h3b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h7b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),5,2,1,3,6,4,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h7b_2 - 1 + noab * (h3b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h7b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,2,1,3,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3_2',
     &6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_2pdm_hhhh_mo_3_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h3b - 1 + noab * (h2b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_3_2',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_2pdm_hhhh_mo_
     &3_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine sym_symmetrize(geom, basis, odensity, g_a)
C$Id: sym_sym.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "geom.fh"
#include "bas.fh"
#include "mafdecls.fh"
#include "tcgmsg.fh"
*     KAP on SGI breaks this routine
c*$*optimize(0)
c*$*scalar optimize(0)
      integer geom, basis, g_a
      logical odensity
c
c     Symmetrize a skeleton matrix (in a global array) in the
c     given basis set.
c
c     B = (1/2h) * sum(R) [RT * (A + AT) * R]
c
c     where h = the order of the group and R = operators of the
c     group (including the identity)
c
c     Note that density matrices tranform according to slightly
c     different rules to Hamiltonian matrices if components
c     of a shell (e.g., cartesian d's) are not orthonormal.
c     (see Dupuis and King, IJQC 11, 613-625, 1977)
c
      integer g_b
      integer icent, jcent, idim, jdim
      integer l_aij, k_aij, l_aji, k_aji, l_tmp, k_tmp, l_r, k_r
      integer max_at_bf, maxd,  ncent, ilo, ihi, ncont
      integer maxf, maxr, ang_max
      integer l_ce_cnr, l_ce_bfr, l_cn_info, l_cn_bfr
      integer k_ce_cnr, k_ce_bfr, k_cn_info, k_cn_bfr
      logical status
c
      integer next, ijcent, nproc
      integer nxtask
      external nxtask
c
*: ang_max used below
      if (.not. bas_high_angular(basis, ang_max))
     $     call errquit('sym_symmetrize: bas_high_angular', basis,
     &       BASIS_ERR)
*rak:      status = bas_is_spherical(basis)
*rak:      if (status.and.(ang_max.gt.1)) then
*rak:        if (ga_nodeid().eq.0) then
*rak:          write(6,*)' spherical basis set and symmetry ',
*rak:     &        'are not allowed yet'
*rak:          write(6,*)
*rak:     &        ' you can use no symmetry and spherical basis sets '
*rak:          write(6,*)'or'
*rak:          write(6,*)' cartesian basis sets with symmetry'
*rak:        endif
*rak:        call errquit('sym_symmetrize: fatal error',911)
*rak:      endif
*
      call ga_sync()
      if (.not. ga_duplicate(g_a, g_b, 'sym_sym: b')) call errquit
     $     ('sym_symmetrize: failed to allocate temp GA', 0, GA_ERR)
      call ga_zero(g_b)
c
c     Get all basis set information for efficiency (for small
c     basis C60 test case bas routine dominate timings, but for
c     all other cases bas times are small).
c
      if (.not. geom_ncent(geom, ncent)) call errquit
     $     ('sym_symmetrize: geom_ncent ?', geom, GEOM_ERR)
      if (.not. bas_numcont(basis, ncont)) call errquit
     $     ('sym_symmetrize: basis handle?', 0, BASIS_ERR)
      status = .true.
      status = status .and. ma_push_get(MT_INT, 2*ncent, 'cecnr',
     $     l_ce_cnr, k_ce_cnr)
      status = status .and. ma_push_get(MT_INT, 2*ncent, 'cebfr',
     $     l_ce_bfr, k_ce_bfr)
      status = status .and. ma_push_get(MT_INT, 4*ncont, 'cninf',
     $     l_cn_info, k_cn_info)
      status = status .and. ma_push_get(MT_INT, 2*ncont, 'cnbfr',
     $     l_cn_bfr, k_cn_bfr)
      call bas_all_ce_info(basis, int_mb(k_ce_cnr), int_mb(k_ce_bfr))
      call bas_all_cn_info(basis, int_mb(k_cn_info),int_mb(k_cn_bfr))
c
c     Figure out size of largest atom block and highest angular
c     momentum and then allocate memory
c
      max_at_bf = 0
      do icent = 1, ncent
         if (.not. bas_ce2bfr(basis, icent, ilo, ihi))
     $        call errquit('rhf_fock_2e: bas_ce2bfr failed', icent,
     &       BASIS_ERR)
         max_at_bf = max(max_at_bf, ihi-ilo+1)
      end do
      maxd = max_at_bf**2       ! Size of largest atom block
c
      maxf = ((ang_max+1)*(ang_max+2))/2 ! Size of largest cart. shell
      maxr = (ang_max+1)*maxf*maxf ! Size of transformation matrices
c
      status = .true.
      status = status .and. ma_push_get(MT_DBL, maxd, 'aij',
     $     l_aij, k_aij)
      status = status .and. ma_push_get(MT_DBL, maxd, 'aji',
     $     l_aji, k_aji)
      status = status .and. ma_push_get(MT_DBL, maxd, 'tmp',
     $     l_tmp, k_tmp)
      status = status .and. ma_push_get(MT_DBL, maxr, 'r',
     $     l_r, k_r)
      if (.not. status) call errquit
     $     ('sym_symmetrize: ma failed', 2*maxd + maxr, MA_ERR)
c
      nproc  = ga_nnodes()
      ijcent = 0
      next   = nxtask(nproc, 1)
      do icent = 1, ncent
         do jcent = 1, ncent
            if (next .eq. ijcent) then
               call get_atom_block(g_a, basis, icent, jcent,
     $              dbl_mb(k_aij), idim, jdim)
               call get_atom_block(g_a, basis, jcent, icent,
     $              dbl_mb(k_aji), jdim, idim)
               
               call sym_symm2(geom, basis, g_b, icent, jcent,
     $              dbl_mb(k_aij), dbl_mb(k_aji), dbl_mb(k_tmp),
     $              idim, jdim, dbl_mb(k_r), maxf, ang_max,
     $              odensity, int_mb(k_ce_cnr), int_mb(k_ce_bfr),
     $              int_mb(k_cn_info), int_mb(k_cn_bfr))
c
               next = nxtask(nproc, 1)
            end if
            ijcent = ijcent + 1
         end do
      end do
c
      next = nxtask(-nproc, 1)
c
      status = status .and. ma_pop_stack(l_r)
      status = status .and. ma_pop_stack(l_tmp)
      status = status .and. ma_pop_stack(l_aji)
      status = status .and. ma_pop_stack(l_aij)
      status = status .and. ma_pop_stack(l_cn_bfr)
      status = status .and. ma_pop_stack(l_cn_info)
      status = status .and. ma_pop_stack(l_ce_bfr)
      status = status .and. ma_pop_stack(l_ce_cnr)
      if (.not. status) call errquit('sym_symmetrize: ma pop?', 0,
     &       MA_ERR)
c
      call ga_copy(g_b, g_a)
      if (.not. ga_destroy(g_b)) call errquit
     $     ('sym_symmetrize: ga_destroy of b', 0, GA_ERR)
      call ga_sync()
c
c*$*optimize(1)
c*$*scalar optimize(1)
c
      end
      subroutine sym_symm2(geom, basis, g_b, icent, jcent, aij, aji,
     $     tmp, idim, jdim, r, maxf, ang_max, odensity, ce_cnr,
     $     ce_bfr, cn_info, cn_bfr)
      implicit none
#include "errquit.fh"
#include "bas.fh"
      integer geom, basis, g_b
      integer icent, jcent, idim, jdim, maxf, ang_max
      double precision aij(idim,jdim), aji(jdim,idim), tmp(idim, jdim),
     $     r(maxf, maxf, 0:ang_max)
      logical odensity
      integer ce_cnr(2,*), ce_bfr(2,*), cn_info(4,*), cn_bfr(2,*)
c
c     Arrive in here with atomic blocks Aij and Aji ... fold them
c     together and loop thru the operations in the group to symmetrize
c
      integer i, j, k, l, ilo, ihi, jlo, jhi, ni, nj, ioff, joff
      integer icn, jcn, icnlo, icnhi, jcnlo, jcnhi
      integer icebflo, icebfhi, jcebflo, jcebfhi
      integer ish, jsh, ish_type, jsh_type
      integer ingen, jngen, itype, jtype, inprim, jnprim
      integer isphcart, jsphcart, i_nbf_per_sh, j_nbf_per_sh
      integer op, icent_new, jcent_new, opinv
      logical do_spherical
c
      double precision sum(28,28), scale, factor, test
      integer sym_center_map, sym_number_ops
      external sym_center_map, sym_number_ops
c
      scale = 1.0d0 / (2.0d0 * (sym_number_ops(geom)+1))
c
      test = 0.0d0
      do i = 1, idim
         do j = 1, jdim
            aij(i,j) = scale*(aij(i,j) + aji(j,i))
            test = test + aij(i,j)*aij(i,j)
         end do
      end do
      if (test .eq. 0.0d0) return
c
      do_spherical = bas_is_spherical(basis)
c
c     Figure out range of basis functions on this atom
c
      icebflo = ce_bfr(1,icent)
      icebfhi = ce_bfr(2,icent)
      jcebflo = ce_bfr(1,jcent)
      jcebfhi = ce_bfr(2,jcent)
      icnlo   = ce_cnr(1,icent)
      icnhi   = ce_cnr(2,icent)
      jcnlo   = ce_cnr(1,jcent)
      jcnhi   = ce_cnr(2,jcent)
c     
c     handle the identity
c
      call upd_atom_block(g_b, basis, icent, jcent, aij)
c
c     loop thru other operators
c
      do op = 1, sym_number_ops(geom)
         call dfill(idim*jdim, 0.0d0, tmp, 1)
c
         if (.not. odensity) then
            icent_new = sym_center_map(geom, icent, op)
            jcent_new = sym_center_map(geom, jcent, op)
         else
            call sym_inv_op(geom, op, opinv)
            icent_new = sym_center_map(geom, icent, opinv)
            jcent_new = sym_center_map(geom, jcent, opinv)
         end if
c
         call sym_bas_op(geom, op, r, maxf, ang_max, do_spherical)
c     
c     loop thru general contractions on each center
c
         do icn = icnlo, icnhi
            itype    = cn_info(1,icn)
            inprim   = cn_info(2,icn)
            ingen    = cn_info(3,icn)
            isphcart = cn_info(4,icn)
            ilo      = cn_bfr(1,icn)
            ihi      = cn_bfr(2,icn)
            if (itype .ge. 0) then
               i_nbf_per_sh = (ihi - ilo + 1) / ingen
            else if (itype .eq. -1) then
               i_nbf_per_sh = 1
            else
               i_nbf_per_sh = 0   ! to get rid of compiler warning
               call errquit('sym_sym2: invalid shell type', itype,
     &       INPUT_ERR)
            end if
            do jcn = jcnlo, jcnhi
               jtype    = cn_info(1,jcn)
               jnprim   = cn_info(2,jcn)
               jngen    = cn_info(3,jcn)
               jsphcart = cn_info(4,jcn)
               jlo      = cn_bfr(1,jcn)
               jhi      = cn_bfr(2,jcn)
               if (jtype .ge. 0) then
                  j_nbf_per_sh = (jhi - jlo + 1) / jngen
               else if (jtype .eq. -1) then
                  j_nbf_per_sh = 1
               else
                  j_nbf_per_sh = 0  ! to get rid of compiler warning
                  call errquit('sym_sym2: invalid shell type', jtype,
     &       INPUT_ERR)
               end if
c
               if (i_nbf_per_sh.gt.28 .or. j_nbf_per_sh.gt.28)
     $              call errquit('sym_symmetrize: sum not big enuf',0,
     &       INPUT_ERR)
c
c     Loop thru shells in each general contraction and construct
c     indexes and types of a single shell block
c
               do ish = 1, ingen
                  ioff = (ilo - icebflo) + i_nbf_per_sh*(ish-1)
                  if (itype .ge. 0) then
                     ish_type = itype
                  else if (ish .eq. 1) then
                     ish_type = 0 ! S component of sp shell
                  else 
                     ish_type = 1 ! P component of sp shell
                  end if
                  do jsh = 1, jngen
                     joff = (jlo - jcebflo) + j_nbf_per_sh*(jsh-1)
                     if (jtype .ge. 0) then
                        jsh_type = jtype
                     else if (jsh .eq. 1) then
                        jsh_type = 0 ! S component of sp shell
                     else 
                        jsh_type = 1 ! P component of sp shell
                     end if
c
c     Finally have all of the necessary indices ... apply the
c     operator ... number of functions here assumes that we
c     have cartesian functions
c
                     if (do_spherical) then
                       ni = 2*ish_type+1
                       nj = 2*jsh_type+1
                     else
                       ni = ((ish_type+1)*(ish_type+2))/2
                       nj = ((jsh_type+1)*(jsh_type+2))/2
                     endif
c
c     tmp(i,j) <- sum(k,l) R(k,i)*A(k,l)*R(l,j)
c
c
c     In the following it is important to use the sparsity of
c     the operators
c
                     if (odensity) then
c
c     Density matrix ... R*D*RT
c
                        do j = 1, nj
                           do k = 1, ni
                              sum(k,j)=0.0d0
                           end do
                           do l = 1, nj
                              factor = R(j,l,jsh_type)
                              if (factor .ne. 0.0d0) then
                                 do k = 1, ni
                                    sum(k,j) = sum(k,j) + 
     $                                   aij(ioff+k,joff+l)*factor
                                 end do
                              end if
                           end do
                        end do
                        do k = 1, ni
                           do i = 1, ni
                              factor = R(i,k,ish_type)
                              if (factor .ne. 0.0d0) then
                                 do j = 1, nj
                                    tmp(ioff+i,joff+j) =
     $                                   tmp(ioff+i,joff+j) +
     $                                   factor*sum(k,j)
                                 end do
                              end if
                           end do
                        end do
                     else
c
c     Hamiltonian matrix ... RT*H*R
c
                        do j = 1, nj
                           do k = 1, ni
                              sum(k,j)=0.0d0
                           end do
                           do l = 1, nj
                              factor = R(l,j,jsh_type)
                              if (factor .ne. 0.0d0) then
                                 do k = 1, ni
                                    sum(k,j) = sum(k,j) + 
     $                                   aij(ioff+k,joff+l)*factor
                                 end do
                              end if
                           end do
                        end do
                        do k = 1, ni
                           do i = 1, ni
                              factor = R(k,i,ish_type)
                              if (factor .ne. 0.0d0) then
                                 do j = 1, nj
                                    tmp(ioff+i,joff+j) =
     $                                   tmp(ioff+i,joff+j) +
     $                                   factor*sum(k,j)
                                 end do
                              end if
                           end do
                        end do
                     end if
                  end do         ! jsh  
               end do            ! ish  
            end do               ! jcn
         end do                  ! icn
         call upd_atom_block(g_b, basis, icent_new, jcent_new, tmp)
      end do                     ! op
c
      end

*
* $Id: cpsi_lmbda.F 19707 2010-10-29 17:59:36Z d3y133 $
*
*     ****************************************************
*     *                                                  *
*     *                 cpsi_lmbda                       *
*     *                                                  *
*     ****************************************************
      subroutine cpsi_lmbda(ms,nb,npack1,
     >                     psi1,psi2,
     >                     dte,
     >                     tmp,ierr)
      implicit none
      integer ms,nb,npack1
      complex*16 psi1(*)
      complex*16 psi2(*)
      real*8     dte
      complex*16 tmp(*)
      integer    ierr


*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)
  
      logical value,gramschmidt
      integer it
      integer nn
      integer s11,s12,s21,s22,st1,st2,sa1,sa0
      real*8 adiff
      complex*16 zero,one,dtec
c      complex*16 zadiff
*     ::::  iteration limit and tolerence for non-liner equations  ::::
      integer itrlmd
      real*8  convg
      parameter (itrlmd=20, convg=1.d-10)

*     **** external functions ****
      integer  Pneb_w_size
      real*8   Pneb_w_dmax
      external Pneb_w_size
      external Pneb_w_dmax

      call Parallel_taskid(taskid)

      gramschmidt = .false.
      ierr = 0
      one  = dcmplx(1.0d0,0.0d0)
      zero = dcmplx(0.0d0,0.0d0)
      dtec = dcmplx(dte,0.0d0)
*     **** set the matrices dimensions ****
      nn   = Pneb_w_size(0,nb)
      
      s11  = 0*nn + 1
      s12  = 1*nn + 1
      s21  = 2*nn + 1
      s22  = 3*nn + 1
      sa0  = 4*nn + 1
      sa1  = 5*nn + 1
      st1  = 6*nn + 1
      st2  = 7*nn + 1

      call zcopy(8*nn,zero,0,tmp,1)
     
*::::::::::::::::::::::  Lagrangian multipliers  ::::::::::::::::::::::

        call Pneb_ffw_hermit_Multiply(ms,nb,psi2,psi2,npack1,tmp(s22))
        call Pneb_ffw_hermit_Multiply(ms,nb,psi2,psi1,npack1,tmp(s21))
        call Pneb_ffw_hermit_Multiply(ms,nb,psi2,psi1,npack1,tmp(s12))
        call Pneb_ffw_hermit_Multiply(ms,nb,psi1,psi1,npack1,tmp(s11))

        call Pneb_w_scale_s22(ms,nb,dte,tmp(s22))
        call Pneb_w_scale_s21(ms,nb,dte,tmp(s21))
        call Pneb_w_scale_s21(ms,nb,dte,tmp(s12))
        call Pneb_w_scale_s11(ms,nb,dte,tmp(s11))


        call zcopy(nn,tmp(s22),1,tmp(sa0),1)
        do it=1,itrlmd
          call zcopy(nn,tmp(s22),1,tmp(sa1),1)

          call Pneb_www_Multiply1(ms,nb,
     >                            one,
     >                            tmp(s21),tmp(sa0),
     >                            one,
     >                            tmp(sa1))

          call Pneb_www_Multiply2(ms,nb,
     .                            one,
     >                            tmp(sa0),tmp(s12),
     >                            one,
     >                            tmp(sa1))

          call Pneb_www_Multiply3(ms,nb,
     >                            one,
     >                            tmp(s11),tmp(sa0),
     >                            zero,
     >                            tmp(st1))
          call Pneb_www_Multiply1(ms,nb,
     >                            one,
     >                            tmp(sa0),tmp(st1),
     >                            one,
     >                            tmp(sa1))
          call zcopy(nn,tmp(sa1),1,tmp(st1),1)
          call zaxpy(nn,-one,tmp(sa0),1,tmp(st1),1)

          adiff = Pneb_w_dmax(ms,nb,tmp(st1))
          if(adiff.lt.convg) GO TO 630
          call zcopy(nn,tmp(sa1),1,tmp(sa0),1)
        end do

        ierr=10
        if (taskid.eq.MASTER) then
          WRITE(6,*)
     >     'Warning: Lagrange Multiplier tolerance too high:',adiff
          WRITE(6,*) '        +Try using a smaller time step'
          WRITE(6,*) '        +Gram-Schmidt being performed, spin:',ms
        end if
        call Pneb_orthoCheckMake(.true.,ms,nb,npack1,psi2)
        gramschmidt = .true.

  630   continue

         if (.not.gramschmidt)
     >     call Pneb_fwf_Multiply(ms,nb,
     >                       dtec,
     >                       psi1,npack1,
     >                       tmp(sa1),
     >                       one,
     >                       psi2)

      return
      end

*
* $Id: rak28.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      logical function raktask_geomcalc(rtdb)
*test geom calc stuff
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "geom.fh"
*::passed
      integer rtdb
*::local
      integer geom
*::code
      raktask_geomcalc = .false.
      if (.not.geom_create(geom,'geometry')) call errquit
     &    ('geom create failed',911, GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'geometry')) call errquit
     &    ('geom_rtdb_load failed',911, RTDB_ERR)
      if (.not.geom_print_distances(geom)) stop ' dist die '
      if (.not.geom_print_angles(geom))    stop ' angl die '
      if (.not.geom_print_dihedrals(geom)) stop ' dihd die '
      raktask_geomcalc = geom_destroy(geom)
      end

C $Id: ecp_t2_p1pow.F 19696 2010-10-29 16:53:42Z d3y133 $  
************************************************************************
*                                                                      *
      subroutine ecp_t2_p1pow (n,m,k,alpha,beta,gamma,term,test,temp,
     &    Q,tol)
*                                                                      *
*   Calculate Q^{|k|+1}_{m+km} functions for k = 1,0,-1, by single     *
*   power series expansion of bessel function in radial integral.      *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   n (inp) - number of Q functions to be evaluated for given          *
*             order                                                    *
*   m (inp) - order of Q function                                      *
*   k (inp) - rank of Q function                                       *
*   alpha (inp) - array of values a/2sqrt(c)                           *
*   beta (inp) - array of values b/2sqrt(c)                            *
*   gamma - array of values 1/sqrt(c)                                  *
*   term (scr) - array of terms alpha^j/(2j)!!(2m+2j+1)!!              *
*   test (scr) - array of ratios of terms to sums                      *
*   temp (scr) - work array, used for Q_m^{m+2j} recursion             *
*   Q (out) - Q functions                                              *
*   tol (inp) - maximum relative error in Q functions                  *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
#include "ecp_consts.fh"
      integer i,idamax,j1,j2,j3,k,k_abs,m,n
      double precision alpha(n),beta(n),gamma(n),term(n),test(n),Q(n),
     &    temp(n,9),tol,fac0,fac1,fac2,fac3,fac4,fac5,fac0i,fac1i,fac2i
      double precision vbig,renorm,eps
      parameter (vbig=30.0,eps=1.d-50)
*
*   Set up factors for recursion
*
      if (n .eq. 0) return
      fac1 = m+1+min(k,0)
      fac1 = fac1+half
      fac2 = 1-max(k,0)
      fac3 = half
      fac4 = m+1
      fac5 = fac4+one+half
C      write (6,'(5F10.4)') fac1,fac2,fac3,fac4,fac5
*
*   First term for k < 1 is Q^m+1_m; this is needed for the recursion
*   in any case. Generate Q^m+3_m by recursion from Q^m+1_m, Q^m+2_m+1
*
      do i = 1,n
        Q(i) = one
      end do
      call ecp_t1_Q1int (n,m,beta,Q,temp,temp(1,3),temp(1,9),tol)
      call ecp_t1_Q1int (n,m+1,beta,Q,temp(1,2),temp(1,3),temp(1,9),tol)
      fac1i = one/fac1
      do i = 1,n
        temp(i,2) = beta(i)*temp(i,2) + fac4*temp(i,1)
        Q(i) = fac2*temp(i,1)
        temp(i,4) = alpha(i)**2
        temp(i,5) = beta(i)**2
        if (k .eq. 1) then
          term(i) = one
        else
          term(i) = fac1i*temp(i,4)
        end if
        test(i) = one
	temp(i,9) = -alpha(i)*(beta(i)+beta(i)+alpha(i))
      end do
      j1 = 0
C      write (6,'(5F10.4)') fac1,fac2,fac3,fac4,fac5
    1 i = idamax(n,test,1)
      if (test(i) .ge .tol) then
        j1 = mod(j1,3)+1
        j2 = mod(j1,3)+1
        j3 = mod(j2,3)+1
        fac0 = max(fac2,one)
        fac1 = fac1+one
        fac2 = fac2+one
        fac0i = one/fac0
        fac1i = one/fac1
        fac2i = one/fac2
        do i = 1,n
          if (test(i) .gt. tol) then
c      write(6,*) 'B',temp(i,1),temp(i,2),temp(i,3),term(i)
            renorm = 0.0d0
               if (abs(temp(i,1)).lt.eps) then
                  temp(i,1) = 0.0d0
               elseif (abs(log10(abs(temp(i,1)))).gt.renorm) then
                  renorm = abs(log10(abs(temp(i,1))))
               endif
               if (abs(temp(i,2)).lt.eps) then
                  temp(i,2) = 0.0d0
               elseif (abs(log10(abs(temp(i,2)))).gt.renorm) then
                  renorm = abs(log10(abs(temp(i,2))))
               endif
               if (abs(temp(i,3)).lt.eps) then
                  temp(i,3) = 0.0d0
               elseif (abs(log10(abs(temp(i,3)))).gt.renorm) then
                  renorm = abs(log10(abs(temp(i,3))))
               endif
            if (renorm.gt.vbig) then
               temp(i,1) = temp(i,1) / 10.0d0**(int(renorm))
               temp(i,2) = temp(i,2) / 10.0d0**(int(renorm))
               temp(i,3) = temp(i,3) / 10.0d0**(int(renorm))
               term(i) = term(i) * 10.0d0**(int(renorm))
            endif
c       write(6,*) 'B',temp(i,1),temp(i,2),temp(i,3),temp(i,4),temp(i,5)
c       write(6,*) 'B',(fac5+temp(i,5))*temp(i,j2),
c    &              fac3*fac4*fac0i*temp(i,j1)
c       write(6,*) 'B',fac3,fac4,fac0i,temp(i,j1)
c       write(6,*) 'B',fac1i,term(i),temp(i,4)
            Q(i) = Q(i)+temp(i,j2)*term(i)
            temp(i,j3) = ((fac5+temp(i,5))*temp(i,j2)
     &                 - fac3*fac4*fac0i*temp(i,j1))*fac2i
            term(i) = term(i)*temp(i,4)*fac1i
c       write(6,*) 'B',term(i),temp(i,j3),Q(i)
c       write(6,*)
            test(i) = (term(i)*temp(i,j3))/Q(i)
          end if
        end do
        fac3 = fac3+one
        fac4 = fac4+one
        fac5 = fac5+two
        go to 1
      end if
      i = fac3+one
C      write (6,*) ' Terms in single power series: ',i
C      write (6,*) 'beta,Q^0_mm values'
C      write (6,'(1p2e20.10)') (beta(i),Q(i),i=1,n)
*
*   Prefactor is (2*alpha)^{m-|k|}/(2(m-|k|)+1)!! /sqrt(c)^(m+|k|)
*
      k_abs = abs(k)
      fac1 = half
      fac5 = one
      do i = 1,m+k
        fac1 = fac1+one
        fac5 = fac5/fac1
      end do
C      write (6,*) fac1,fac5
      do i = 1,n
        Q(i) = Q(i)*alpha(i)**(m+k)*fac5*(gamma(i)**(k_abs+2))
      end do
*
*   Perform remaining exponent shift.
*
      do i = 1,n
        Q(i) = Q(i)*exp(temp(i,9))
      end do
*
      return
      end

      SUBROUTINE OFFSET_ccsdtq_lr_alpha_1_12_1(l_a_offset,k_a_offset,siz
     &e)
C     $Id: offset_ccsdtq_lr_alpha_1_12_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h6 h7 h8 h9 h13 p3 p4 p5 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h6b
      INTEGER h7b
      INTEGER h8b
      INTEGER h9b
      INTEGER h13b
      INTEGER p3b
      INTEGER p4b
      INTEGER p5b
      length = 0
      DO h6b = 1,noab
      DO h7b = h6b,noab
      DO h8b = h7b,noab
      DO h9b = h8b,noab
      DO h13b = 1,noab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO p5b = p4b,noab+nvab
      IF (int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b-1)
     &+int_mb(k_spin+h9b-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+p3b
     &-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),ieor(int_mb(k_sym+h7b-1),ieor(int_mb(
     &k_sym+h8b-1),ieor(int_mb(k_sym+h9b-1),ieor(int_mb(k_sym+h13b-1),ie
     &or(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+p5b-1
     &)))))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1
     &)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h13b-1)+
     &int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1).ne.
     &16)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lr_alpha_1_12_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h6b = 1,noab
      DO h7b = h6b,noab
      DO h8b = h7b,noab
      DO h9b = h8b,noab
      DO h13b = 1,noab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO p5b = p4b,noab+nvab
      IF (int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b-1)
     &+int_mb(k_spin+h9b-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+p3b
     &-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),ieor(int_mb(k_sym+h7b-1),ieor(int_mb(
     &k_sym+h8b-1),ieor(int_mb(k_sym+h9b-1),ieor(int_mb(k_sym+h13b-1),ie
     &or(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+p5b-1
     &)))))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1
     &)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h13b-1)+
     &int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1).ne.
     &16)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p5b - noab - 1 + nvab * (p4b - noab - 1 
     &+ nvab * (p3b - noab - 1 + nvab * (h13b - 1 + noab * (h9b - 1 + no
     &ab * (h8b - 1 + noab * (h7b - 1 + noab * (h6b - 1)))))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h6b-1) * int_mb(k_range+h7b-1) * int_
     &mb(k_range+h8b-1) * int_mb(k_range+h9b-1) * int_mb(k_range+h13b-1)
     & * int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_range+
     &p5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

*
* $Id: band_sd.F 24513 2013-08-14 17:43:02Z bylaska $
*

***********************************************************************
*                      band_sd                                        *
*                                                                     *
*     This is a developing steepest descent code for BAND             *
*                                                                     *
*                                                                     *
***********************************************************************

      logical function band_sd(rtdb)
      implicit none
      integer rtdb

#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"
      

*     **** parallel variables ****
      integer  taskid,np,np_i,np_j,np_k
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d
      integer npack1,npack0

*     **** electronic variables ****
      logical spin_orbit,newpsi
      real*8 icharge
      integer ispin,ispinq,nbrillioun,nbrillq
      integer ne(2),n1(2),n2(2),nemax,neq(2),nemaxq,neall
      real*8  en(2)
      real*8  dipole(3)

      integer psi1_tag,psi2_tag,psir_tag,Hpsi_tag,next
      integer psi1_shift,psi2_shift
      integer dn(2)
    

*     ***** energy variables ****
      real*8  E(50)

      integer eig_tag,hml_tag,lmd_tag,svec_tag
      integer eig_shift,hml_shift,lmd_shift,svec_shift

*     **** psi smearing block ****
      logical fractional
      integer smearoccupation,smeartype
      real*8 smearfermi(2),smearcorrection,smearkT


*     **** error variables ****
      integer ierr

*     **** local variables ****
      complex*16 zero,one
      parameter (zero=(0.0d0,0.0d0), one=(1.0d0,0.0d0))

      logical lprint,mprint,hprint
      integer ms,mapping,mapping1d
      real*8  deltae,deltac,deltar
      real*8  gx,gy,gz,cx,cy,cz,sum1,sum2
      real*8  EV,pi,f0,f1,f2,f3,f4,f5,f6
      integer i,j,k,ia,n,nn,nb
      integer ii,jj,indx,indx1,if1,if2
      integer icount,it_in,it_out
      real*8 w,sumall,virial,a,b,c,alpha,beta,gamma
      integer nfft3
      parameter (nfft3=32)
      character*255 full_filename

      logical value,psi_nogrid
      integer hversion,hnfft(3),hispin,hne(2)
      real*8 hunita(3,3)
      integer ind,vers

      character*255 filename
      character*50 control_input_psi
      external     control_input_psi
      logical  c_wvfnc_expander
      external c_wvfnc_expander


*     **** external functions ****
      real*8      cpsp_zv,cpsp_rc,ewald_rcut,ion_amass,ion_TotalCharge
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg,brillioun_weight
      integer     ewald_ncut,ewald_nshl3d
      integer     cpsp_nprj,cpsp_lmax,cpsp_locp,cpsp_psp_type
      character*4 ion_aname,ion_atom
      external    cpsp_zv,cpsp_rc,ewald_rcut,ion_amass,ion_TotalCharge
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg,brillioun_weight
      external    ewald_ncut,ewald_nshl3d
      external    cpsp_nprj,cpsp_lmax,cpsp_locp,cpsp_psp_type
      external    ion_aname,ion_atom

      logical  control_fractional
      external control_fractional
      real*8   control_fractional_temperature
      external control_fractional_temperature
      real*8   control_fractional_kT,control_fractional_smeartype
      external control_fractional_kT,control_fractional_smeartype
      real*8   control_tole,control_tolc,control_tolr,ion_rion
      external control_tole,control_tolc,control_tolr,ion_rion
      real*8   control_time_step,control_fake_mass
      external control_time_step,control_fake_mass
      logical  control_read,control_move,ion_init,ion_q_FixIon
      external control_read,control_move,ion_init,ion_q_FixIon
      logical  ion_q_zFixIon,band_HFX,band_HFX_relaxed
      external ion_q_zFixIon,band_HFX,band_HFX_relaxed

      logical  brillioun_print
      external brillioun_print
      real*8   brillioun_k_brdcst,brillioun_ks_brdcst
      external brillioun_k_brdcst,brillioun_ks_brdcst
      real*8   brillioun_weight_brdcst
      external brillioun_weight_brdcst
      real*8   cpsi_eig_brdcst_tag,cpsi_occ_brdcst_tag
      external cpsi_eig_brdcst_tag,cpsi_occ_brdcst_tag
      real*8   cpsi_sv_brdcst_tag
      external cpsi_sv_brdcst_tag

      integer  Cram_nwave_brdcst,Cram_nwave_all_brdcst
      external Cram_nwave_brdcst,Cram_nwave_all_brdcst
 
      integer  psi_get_version,brillioun_nbrillioun
      integer  Pneb_ispinq,Pneb_nbrillq,Pneb_w_size
      integer  cpsi_data_alloc,cpsi_data_get_next,cpsi_data_get_chnk
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave
      integer  ion_nion,ion_natm,ion_katm,ion_nkatm
      external psi_get_version,brillioun_nbrillioun
      external Pneb_ispinq,Pneb_nbrillq,Pneb_w_size
      external cpsi_data_alloc,cpsi_data_get_next,cpsi_data_get_chnk
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave
      external  ion_nion,ion_natm,ion_katm,ion_nkatm

      character*12 control_boundry
      external     control_boundry

      logical      pspw_reformat_c_wvfnc
      logical      pspw_HFX,pspw_HFX_relaxed
      logical      cpsp_semicore,control_Mulliken
      real*8       cpsp_rcore,cpsp_ncore
      external     pspw_reformat_c_wvfnc
      external     pspw_HFX,pspw_HFX_relaxed
      external     cpsp_semicore,control_Mulliken
      external     cpsp_rcore,cpsp_ncore
      logical      control_check_charge_multiplicity
      external     control_check_charge_multiplicity
      real*8       nwpw_timing
      external     nwpw_timing
      integer      control_np_dimensions
      integer      control_mapping,control_mapping1d
      external     control_np_dimensions
      external     control_mapping,control_mapping1d

      logical  control_print
      logical  control_translation,control_rotation,control_balance
      external control_print
      external control_translation,control_rotation,control_balance

      logical  Dneall_m_allocate,Dneall_m_free,ion_disp_on
      external Dneall_m_allocate,Dneall_m_free,ion_disp_on

      complex*16 Pneb_w_value
      external   Pneb_w_value
      character*9 ion_amm
      external    ion_amm

      character*255 cpsp_comment,comment
      external      cpsp_comment
      integer  ion_nconstraints,ion_ndof
      external ion_nconstraints,ion_ndof



*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(30,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      
      if (.not.control_read(13,rtdb))
     >   call errquit('band_sd:error reading control',0,DISK_ERR)


      lprint = ((taskid.eq.MASTER).and.(control_print(print_low)))
      mprint = ((taskid.eq.MASTER).and.(control_print(print_medium)))
      hprint = ((taskid.eq.MASTER).and.(control_print(print_high)))

      if (taskid.eq.MASTER) call current_second(cpu1)

*     ***** print out header ****
      if (mprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1042)
         write(luout,1043)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
      end if

      call Parallel3d_Init(control_np_dimensions(2),
     >                     control_np_dimensions(3))
      call Parallel3d_np_i(np_i)
      call Parallel3d_np_j(np_j)
      call Parallel3d_np_k(np_k)

      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      mapping = control_mapping()

*     **** initialize D3dB data structure ****
      call C3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call C3dB_nfft3d(1,nfft3d)

*     **** initialize psi_data ****
      call cpsi_data_init(20)

*     **** initialize lattice and packing data structure ****
      call lattice_init()
      call c_G_init()
      call brillioun_init()
      call Cram_Init()
      call C3dB_pfft_init()

*     ***** Initialize double D3dB data structure ****
      if ((control_gga().ge.10).and.(control_gga().le.200)) then
         call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
         call G_init()
         call mask_init()
      end if

*     **** read ions ****
      value = ion_init(rtdb)
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call cpsp_init()
      call cpsp_readall()
      if (cpsp_semicore(0)) call c_semicore_check()


*     **** initialize G,mask,ke,and coulomb data structures ****
      call cstrfac_init()
      call cke_init()
      call c_coulomb_init()
      call ewald_init()


*     **** generate initial wavefunction if it does not exist ****
      if (.not.control_check_charge_multiplicity()) then
        call cpsi_new()
        newpsi = .true.
      else
         newpsi = .false.

*        **** convert from pspw format to band format ****
         vers = psi_get_version()
         if ((vers.eq.3).or.(vers.eq.4)) then
           newpsi = .true.
           value = rtdb_parallel(.false.)
           if (taskid.eq.MASTER) then
             value= pspw_reformat_c_wvfnc(1)
           end if
           value = rtdb_parallel(.true.)
         end if
      end if

      call psi_get_ne(ispin,ne)
      if (ispin.eq.3) then
         spin_orbit = .true.
         ispin=2
      else
         spin_orbit = .false.
      end if
      nbrillioun = brillioun_nbrillioun()
      call Pneb_init(ispin,ne,nbrillioun,spin_orbit)
      call Pneb_neq(neq)


*     ***** allocate psi2,and psi1 wavefunctions ****
      call psi_get_ne_occupation(ispin,ne,smearoccupation)
      if (smearoccupation.gt.0) then
         fractional = .true.
      else
         fractional = .false.
      end if
      mapping1d = control_mapping1d()
      ispinq  = Pneb_ispinq()
      nbrillq = Pneb_nbrillq()

      call Cram_npack(0,npack0)
      call Cram_max_npack(npack1)
      nemaxq = neq(1)+neq(2)
      neall  = ne(1) +ne(2)

      psi2_tag = cpsi_data_alloc(nbrillq,nemaxq,2*npack1)
      psi1_tag = cpsi_data_alloc(nbrillq,nemaxq,2*npack1)

*     *** fractional orbitals ***
      if (smearoccupation.gt.0) then
        call cpsi_data_set_next(psi2_tag,
     >                 cpsi_data_alloc(nbrillq,nemaxq,1))
        call cpsi_data_set_next(psi1_tag,
     >                 cpsi_data_alloc(nbrillq,nemaxq,1))
        smeartype = control_fractional_smeartype()
        smearkT   = control_fractional_kT()
      end if

c     **** allocate other variables ****
      Hpsi_tag = cpsi_data_alloc(nbrillq,nemaxq,2*npack1)
      psir_tag = cpsi_data_alloc(nbrillq,nemaxq,2*nfft3d)
      hml_tag  = cpsi_data_alloc(nbrillq,1,2*Pneb_w_size(0,1))
      eig_tag  = cpsi_data_alloc(nbrillq,ne(1)+ne(2),1)
      svec_tag = cpsi_data_alloc(nbrillq,neq(1),3)
      value = MA_alloc_get(mt_dbl,2*nfft3d,'dn',dn(2),dn(1))
      if (.not. value)
     >  call errquit('band_sd:out of heap memory',0,MA_ERR)


*     *****  read initial wavefunctions into psi2  ****
      if (.not.rtdb_get(rtdb,'nwpw:psi_nogrid',
     >                  mt_log,1,psi_nogrid))
     >   psi_nogrid = .true.

      if (psi_nogrid) then

        call psi_get_header(hversion,hnfft,hunita,hispin,hne)

        if ( (hnfft(1).ne.control_ngrid(1)) .or.
     >       (hnfft(2).ne.control_ngrid(2)) .or.
     >       (hnfft(3).ne.control_ngrid(3)) ) then

        hnfft(1) = control_ngrid(1)
        hnfft(2) = control_ngrid(2)
        hnfft(3) = control_ngrid(3)
        call Parallel_taskid(taskid)

        call ga_sync()
        value = rtdb_parallel(.false.)
        call ga_sync()
        if (hprint) then

          filename =  control_input_psi()

          ind = index(filename,' ') - 1
          if (.not. rtdb_cput(rtdb,'c_xpndr:old_wavefunction_filename',
     >                    1,filename(1:ind)))
     >     call errquit(
     >     'c_wvfnc_expander_input: rtdb_cput failed', 0, RTDB_ERR)

          if (.not. rtdb_cput(rtdb,'c_xpndr:new_wavefunction_filename',
     >                    1,filename(1:ind)))
     >     call errquit(
     >     'c_wvfnc_expander_input: rtdb_cput failed', 0, RTDB_ERR)

          if (.not. rtdb_put(rtdb,'c_xpndr:ngrid',mt_int,3,hnfft))
     >     call errquit(
     >     'c_wvfnc_expander_input: rtdb_put failed', 0, RTDB_ERR)

          write(*,*)
          write(*,*) "Grid is being converted:"
          write(*,*) "------------------------"
          write(*,*)
          write(*,*) "To turn off automatic grid conversion:"
          write(*,*)
          write(*,*) "set nwpw:psi_nogrid .false."
          write(*,*)
          value = c_wvfnc_expander(rtdb)

        end if
        call ga_sync()
        value = rtdb_parallel(.true.)

        end if
      end if

*     *****  read psi2 wavefunctions ****
      call cpsi_read(spin_orbit,ispin,ne,nbrillioun,psi2_tag)

*     **** Ortho Check ****
      call Pneb_orthoCheckMake_tag(.true.,0,0,npack1,psi2_tag)

*     **** initialize SIC and HFX  ****
c      call pspw_init_SIC(rtdb,ne)
       call band_init_HFX(rtdb,nbrillioun,ispin,ne)

*     **** initialize QM/MM ****
c      call pspw_init_APC(rtdb)
c      call pspw_qmmm_init(rtdb)


*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)


*                |**************************|
******************   summary of input data  **********************
*                |**************************|


*     **** determine en ****
      if (.not.spin_orbit) then
        next    = cpsi_data_get_next(psi2_tag)
        icharge = 0.0d0
        en(1)   = 0.0d0
        en(2)   = 0.0d0
        b = dble(3-ispin)
        do nb=1,nbrillq
        w = brillioun_weight(nb)
        do ms=1,ispin
          do i=1,ne(ms)
            if (next.lt.0) then
               a = 1.0d0
            else
               indx = cpsi_data_get_chnk(next,nb)+i-1
               if (.not.spin_orbit) indx = indx + (ms-1)*ne(1)
               a = dbl_mb(indx)
            end if
            icharge = icharge - b*a*w
            en(ms)  = en(ms) + a*w
          end do
        end do
        end do
        call K1dB_Vector_SumAll(2,en)
        call K1dB_SumAll(icharge)
      else
        icharge   = -ne(1)
        en(1)     =  ne(1)
        en(ispin) =  ne(ispin)
      end if


      if (mprint) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j,np_k
         if (mapping.eq.1) write(luout,1112)
         if (mapping.eq.2) write(luout,1113)
         if (mapping.eq.3) write(luout,1118)

         write(luout,1115)
         IF(control_move()) THEN
           write(luout,1120) 'yes'
         ELSE
           write(luout,1120) 'no'
         ENDIF
         write(luout,1121) control_boundry(),control_version()
         if (.not.spin_orbit) then
            if (ispin.eq.1) write(luout,1130) 'restricted'
            if (ispin.eq.2) write(luout,1130) 'unrestricted'
         else
            write(luout,1130) 'spin orbit'
         end if

         call v_bwexc_print(luout,control_gga())

c         if (fractional) write(6,1132)
c         call pspw_print_SIC(6)
c         call pspw_print_HFX(6)
         write(luout,1140)
         do ia = 1,ion_nkatm()
           write(luout,1150) ia,ion_atom(ia),
     >                    cpsp_zv(ia),cpsp_lmax(ia)

           comment = cpsp_comment(ia)
           i = inp_strlen(comment)
           write(luout,1157) comment(1:i)
           write(luout,1158) cpsp_psp_type(ia)
           write(luout,1152) cpsp_lmax(ia)
           write(luout,1153) cpsp_locp(ia)
           write(luout,1154) cpsp_nprj(ia)
           if (cpsp_semicore(ia)) 
     >         write(luout,1155) cpsp_rcore(ia),cpsp_ncore(ia)
           write(luout,1151) (cpsp_rc(i,ia),i=0,cpsp_lmax(ia))
         end do


         icharge = icharge + ion_TotalCharge()
         write(6,1159) icharge

         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz
         write(luout,1211) ion_nconstraints(),ion_ndof()

         write(luout,1220) en(1),en(ispin),' (Fourier space)'
         write(luout,1221) ne(1),neq(1),
     >                     ne(ispin),neq(ispin),' (Fourier space)'

         write(luout,1230)
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         write(luout,1231) lattice_omega()
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()

         write(luout,1255)
         write(luout,1256) brillioun_nbrillioun()
      end if


c         write(6,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
c     >                 pack_nwave_all(0),pack_nwave(0)
c         write(6,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
c     >                 pack_nwave_all(1),pack_nwave(1)

c     **** print brillioun zone - extra logic for distributed kpoints ****
      if (brillioun_print()) then
         do i=1,brillioun_nbrillioun()
            f0 = brillioun_weight_brdcst(i)
            f1 = brillioun_ks_brdcst(1,i)
            f2 = brillioun_ks_brdcst(2,i)
            f3 = brillioun_ks_brdcst(3,i)
            f4 = brillioun_k_brdcst(1,i)
            f5 = brillioun_k_brdcst(2,i)
            f6 = brillioun_k_brdcst(3,i)
            if (mprint) write(luout,1257) f0,f1,f2,f3,f4,f5,f6
         end do
      else
        if (mprint) write(luout,1258)
      end if

      if1 = Cram_nwave_all_brdcst(0)
      if2 = Cram_nwave_brdcst(0)
      if (mprint) then
         write(luout,1249)
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                     if1,if2
      end if

      if (brillioun_print()) then
        do i=1,brillioun_nbrillioun()
          if1 = Cram_nwave_all_brdcst(i)
          if2 = Cram_nwave_brdcst(i)
          if (mprint) then
          write(luout,1251) i,lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                      if1,if2
          end if
        end do
      else
        if (mprint) write(luout,1252)
      end if


      if (mprint) then
         
         write(luout,1270)
         if (.not.control_translation()) write(luout,1271)
         if (.not.control_rotation())    write(luout,1272)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_tole(),control_tolc(),control_tolr()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()

         if (control_fractional()) then
           write(6,1297)
           if (control_fractional_smeartype().eq.0)
     >       write(6,1298) "step function"
           if (control_fractional_smeartype().eq.1)
     >       write(6,1298) "Fermi-Dirac"
           if (control_fractional_smeartype().eq.2)
     >       write(6,1298) "Gaussian"
           write(6,1299) control_fractional_kT(),
     >                   control_fractional_temperature()
         end if
         write(luout,1300)
         write(luout,1305)
         call util_flush(luout)
      end if
c
c*                |***************************|
c******************     start iterations      **********************
c*                |***************************|
c
      if (taskid.eq.MASTER) call current_second(cpu2)
      if (taskid.eq.MASTER) CALL nwpw_MESSAGE(2)
      it_in  = control_it_in()
      it_out = control_it_out()
      icount = 0
   1  continue
         icount = icount + 1
         call band_inner_loop(ispin,ispinq,ne,neq,nbrillioun,nbrillq,
     >                      nfft3d,
     >                      psi1_tag,psi2_tag,dbl_mb(dn(1)),
     >                      it_in,E,deltae,deltac,deltar,
     >                      hml_tag,
     >                      psir_tag,Hpsi_tag)

         if (mprint) then 
           write(luout,1310) icount*it_in,E(1),deltae,deltac,deltar
           call util_flush(luout)
         end if
         if ((deltae.gt.0.0d0).and.(icount.gt.1)) then
            if (mprint) 
     >       write(luout,*) 
     >       ' *** Energy going up.  iteration terminated.'
            go to 2
         end if
         deltae = dabs(deltae)
         if ((deltae.lt.control_tole()).and.
     >       (deltac.lt.control_tolc()).and.
     >       (deltar.lt.control_tolr())) then
            if (mprint) 
     >       write(luout,*) 
     >       ' *** tolerance ok.     iteration terminated.'
            go to 2
         end if
      if (icount.lt.it_out) go to 1
      if (mprint) 
     > write(luout,*) 
     > '*** arived at the Maximum iiteration.   terminated.'

*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::

   2  continue
      if (taskid.eq.MASTER) CALL nwpw_MESSAGE(3)
      if (taskid.eq.MASTER) call current_second(cpu3)



*         |****************************************|
*********** produce CHECK file and diagonalize hml *****************
*         |****************************************|

*     **** produce CHECK FILE ****
      if (taskid.eq.MASTER) then
         call util_file_name('CHECK',.true.,
     >                               .false.,
     >                        full_filename)
         open(unit=17,file=full_filename,form='formatted')
      end if

*     **** check total number of electrons ****
      do ms =1,ispin
         call C3dB_r_dsum(1,dbl_mb(dn(1)+(ms-1)*nfft3d),sumall)
         en(ms) = sumall*lattice_omega()
     >             /dble(ngrid(1)*ngrid(2)*ngrid(3))
      end do
      if (taskid.eq.MASTER) then
         write(17,1320) (en(ms),ms=1,ispin)
      end if

*     **** comparison between hamiltonian an lambda matrix ****
*     **** not done - because this can generate a very large data file ****

*     **** check orthonormality ****
      if (taskid.eq.MASTER) then
         write(17,1350)
      end if
      
c      lmd_tag   = cpsi_data_alloc(1,1,2*Pneb_w_size(0,1))
c      lmd_shift = cpsi_data_get_chnk(lmd_tag,1)
c      do nb=1,nbrillq
c        psi1_shift = cpsi_data_get_chnk(psi1_tag,nb)
c        call Pneb_ffw_Multiply(nb,0,dbl_mb(psi1_shift),
c     >                              dbl_mb(psi1_shift),
c     >                              dbl_mb(lmd_shift))
c         do ms=1,ispin
c            do j=1,ne(ms)
c            do i=j,ne(ms)
c               if (taskid.eq.MASTER) 
c     >         write(17,1360) ms,i,j,
c     >                        Pneb_w_value(nb,ms,i,j,dbl_mb(lmd_shift))
c            end do
c            end do
c         end do
c      end do
c      call cpsi_data_dealloc(lmd_tag)

*     **** close check file ****
      if (taskid.eq.MASTER) then
         close(17)
      end if



*     ***** diagonalize the hamiltonian matrix but don't rotate ****
      call cpsi_data_update(hml_tag)
      call cpsi_data_update(eig_tag)
      do nb=1,nbrillq
        hml_shift = cpsi_data_get_chnk(hml_tag,nb)
        eig_shift = cpsi_data_get_chnk(eig_tag,nb)
        call Pneb_w_diag(0,nb,dbl_mb(eig_shift),dbl_mb(hml_shift))
      end do
      call cpsi_data_noupdate(hml_tag)
      call cpsi_data_noupdate(eig_tag)


*     ***** diagonalize and rotate the hamiltonian matrix ****
      call cpsi_data_update(psi2_tag)
      do nb=1,nbrillq
        psi1_shift = cpsi_data_get_chnk(psi1_tag,nb)
        psi2_shift = cpsi_data_get_chnk(psi2_tag,nb)
        hml_shift  = cpsi_data_get_chnk(hml_tag,nb)
        call Pneb_fwf_Multiply(0,nb,
     >                       one,
     >                       dbl_mb(psi1_shift),npack1,
     >                       dbl_mb(hml_shift),
     >                       zero,
     >                       dbl_mb(psi2_shift))
      end do
      call cpsi_data_noupdate(psi2_tag)



*                |***************************|
****************** report summary of results **********************
*                |***************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

      if (mprint) then
         write(luout,1300)
         write(luout,1410)
         write(luout,1420)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           else if (ion_q_zFixIon(I)) then
           write(6,1193) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0,ion_amm(i)
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz
         write(luout,1211) ion_nconstraints(),ion_ndof()


         write(luout,*)
         write(luout,1320) en(1),en(ispin),' (real space)'

         write(luout,1430) E(1),E(1)/ion_nion()
         write(luout,1440) E(2),E(2)/neall
         write(luout,1450) E(3),E(3)/neall
         write(luout,1460) E(4),E(4)/neall
         if (band_HFX()) then
           write(luout,1457) E(20),E(20)/n2(ispin)
         end if

         write(luout,1470) E(5),E(5)/ion_nion()
         write(luout,1480) E(6),E(6)/neall
         write(luout,1490) E(7),E(7)/neall
         write(luout,1495) E(8),E(8)/neall
         write(luout,1496) E(9),E(9)/neall
         write(luout,1497) E(10),E(10)/neall
         if (band_HFX().and.band_HFX_relaxed())  then
           write(luout,1502) E(21),E(21)/n2(ispin)
         end if
         virial = (E(10)+E(9)+E(8)+E(7))/E(6)
         write(luout,1498) virial

        if (ion_disp_on()) then
            write(luout,1720) E(33)
        end if

      end if

      NN=ne(1)-ne(2)
      EV=27.2116d0
      if (mprint) then
        if (control_fractional()) then
          if (ispin.eq.1) then
            write(luout,1507) smearfermi(1),smearfermi(1)*EV
          else
            write(luout,1507) smearfermi(1),smearfermi(1)*EV,
     >                        smearfermi(2),smearfermi(2)*EV
          end if
        end if
      end if

*     *** generate spinorbit vector ***
      if (spin_orbit) call Pneb_f_SOSpins_tag(psi2_tag,svec_tag)

*     *** printout the eigenvalue spetra ****
      if (brillioun_print()) then
      do nb=1,brillioun_nbrillioun()
        f0 = brillioun_weight_brdcst(nb)
        f1 = brillioun_ks_brdcst(1,nb)
        f2 = brillioun_ks_brdcst(2,nb)
        f3 = brillioun_ks_brdcst(3,nb)
        f4 = brillioun_k_brdcst(1,nb)
        f5 = brillioun_k_brdcst(2,nb)
        f6 = brillioun_k_brdcst(3,nb)
        if (mprint) then
          write(luout,1508) nb,f0,f1,f2,f3,f4,f5,f6
          write(luout,1500)
        end if
        next = cpsi_data_get_next(psi1_tag)
        if (spin_orbit) then
c          if (mprint) write(luout,1511)
          do i=0,ne(1)-1
            f1=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag, nb,1,ne(1)-i)
            f2=cpsi_sv_brdcst_tag( spin_orbit,svec_tag,nb,ne(1)-i,1)
            f3=cpsi_sv_brdcst_tag( spin_orbit,svec_tag,nb,ne(1)-i,2)
            f4=cpsi_sv_brdcst_tag( spin_orbit,svec_tag,nb,ne(1)-i,3)
            f0 = dsqrt(f2*f2 + f3*f3 + f4*f4)
            f5=cpsi_occ_brdcst_tag(ne,spin_orbit,next,    nb,1,ne(1)-i)
            if (mprint) write(luout,1512) f1,f1*EV,f0,f2,f3,f4,f5
          end do
        else
          do i=0,NN-1
            f1=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag,nb,1,ne(1)-i)
            f2=cpsi_occ_brdcst_tag(ne,spin_orbit,next,   nb,1,ne(1)-i)
            if (mprint) write(luout,1510) f1,f1*EV,f2
          end do
          do i=0,ne(2)-1
           f1=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag,nb,1,ne(1)-i-NN)
           f2=cpsi_occ_brdcst_tag(ne,spin_orbit,next,   nb,1,ne(1)-i-NN)
           f3=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag,nb,2,ne(2)-i)
           f4=cpsi_occ_brdcst_tag(ne,spin_orbit,next,   nb,2,ne(2)-i)
           if (mprint) write(luout,1510) f1,f1*EV,f2,f3,f3*EV,f4
          end do
        end if
      end do
      endif



*     ***** extra energy output for QA test ****
      if (mprint) then
         write(luout,1600) E(1)
      end if

*                |***************************|
******************         Prologue          **********************
*                |***************************|
c
c*     **** calculate spin contamination ****
c      call Calculate_psi_spin2(ispin,ne,npack1,dcpl_mb(psi2(1)),
c     >                         fractional,dbl_mb(occ2(1)),w)
c
c*     **** calculate the Dipole ***
c      call Calculate_Dipole(ispin,ne,n2ft3d,dbl_mb(dn(1)),dipole)
c      
c*     **** perfom Lubin and Mulliken analysis ***
c      if (control_Mulliken()) then
c
c*       **** Lubin Water Analysis ***
c        call pspw_Lubin_water_analysis(rtdb,ispin,ne,n2ft3d,
c     >                                 dbl_mb(dn(1)))
c
c*       **** Analysis ***
c        call pspw_analysis(0,rtdb,ispin,ne,dcpl_mb(psi2(1)),
c     >                                   dbl_mb(eig(1)))
c
c*       **** generate APC *****
c        call pspw_dngen_APC(ispin,ne,dbl_mb(dn(1)))
c        call pspw_print_APC(6)
c
c      end if

*     *****  write psi2 wavefunctions ****
      call cpsi_write(spin_orbit,ispin,ne,nbrillioun,psi2_tag)

*     **** write geometry to rtdb ****
      call ion_write(rtdb)


*     **** deallocate heap memory ****
      call ewald_end()
      call cstrfac_end()
      call c_coulomb_end()
      call cke_end()
      call cpsp_end()
      call Cram_end()
      call c_G_end()
      call brillioun_end()

      call ion_end()
      call ion_end_FixIon()
c      call pspw_end_SIC()
      call band_end_HFX()
c      call pspw_end_APC()
c      call pspw_qmmm_end()
c
      call cpsi_data_dealloc(Hpsi_tag)
      call cpsi_data_dealloc(psir_tag)
      next = cpsi_data_get_next(psi1_tag)
      if (next.ge.0) call cpsi_data_dealloc(next)
      call cpsi_data_dealloc(psi1_tag)

      next = cpsi_data_get_next(psi2_tag)
      if (next.ge.0) call cpsi_data_dealloc(next)
      call cpsi_data_dealloc(psi2_tag)
      call cpsi_data_dealloc(hml_tag)
      call cpsi_data_dealloc(eig_tag)
      call cpsi_data_dealloc(svec_tag)
      value = MA_free_heap(dn(2))
      if (.not. value)
     >  call errquit('band_sd:freeing heap memory',0,MA_ERR)


      call C3dB_pfft_end()
      call cpsi_data_end()
      call C3dB_end(1)
      if ((control_gga().ge.10).and.(control_gga().le.200)) then
         call mask_end()
         call G_end()
         call D3dB_end(1)
      end if

*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (taskid.eq.MASTER) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(icount*it_in)
         write(6,*)
         write(6,*) '-----------------'
         write(6,*) 'cputime in seconds'
         write(6,*) 'prologue    : ',T1
         write(6,*) 'main loop   : ',T2
         write(6,*) 'epilogue    : ',T3
         write(6,*) 'total       : ',T4
         write(6,*) 'cputime/step: ',AV
         write(6,*)
         call nwpw_timing_print_final(.true.,(icount*it_in))
         CALL nwpw_MESSAGE(4)
      end if 


      call Parallel3d_Finalize()
      call Parallel_Finalize()
      band_sd = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*     Car-Parrinello solid-state calculation       *')
 1030 FORMAT(10X,'*     [     steepest descent minimization   ]      *')
 1035 FORMAT(10x,'*     [ NorthWest Chemistry implementation ]       *')
 1040 FORMAT(10X,'*            version #1.00   03/14/09              *')
 1041 FORMAT(10X,'*    This code was developed by Eric J. Bylaska    *')
 1042 FORMAT(10X,'*                                                  *')
 1043 FORMAT(10X,'*                                                  *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ BAND input data ===================')
 1111 FORMAT(/' number of processors used:',I16)
 1112 FORMAT( ' parallel mapping         :         1d slab')
 1113 FORMAT( ' parallel mapping         :      2d hilbert')
 1114 FORMAT( ' parallel mapping         :        balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1117 FORMAT( ' processor grid           :',I4,' x',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         :       2d hcurve')
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I1)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)

 1159 FORMAT(/' total charge=',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A2,':',I3))
 1180 FORMAT(/' initial position of ions:')
 1190 FORMAT(5X, I4, A5, ' (',3F11.5,' ) - atomic mass= ',F7.3,' ',A)
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F6.3,' - fixed ',A)
 1193 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - z fixed')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1211 FORMAT(5X,'   number of constraints = ', I6,' ( DOF = ',I6,' )' )
 1220 FORMAT(/' number of electrons: spin up=',F6.2, 16x,
     >                               '  down=',F6.2,A)
c 1220 FORMAT(/' number of electrons: spin up=',I6,
c     >        ' (',I4,' per task)',
c     >        '  down=',I6,
c     >        ' (',I4,' per task)',
c     >        A)
 1221 FORMAT( ' number of orbitals : spin up=',I6,  
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,' volume : ',F10.1)
 1232 FORMAT(/5x,' lattice:    a=',f8.3,'    b=',f8.3,'     c=',f8.3,
     >       /5x,'         alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1249 FORMAT(/' computational grids:')
 1250 FORMAT(5X,' density     cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc ',I3,' cutoff=',F7.3,
     &        '  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1252 FORMAT(5x, ' wavefunction grids not printed - ',
     >           'number of k-point is very large')

 1255 FORMAT(/' brillouin zone:')
 1256 FORMAT(5x,' number of zone points:',I3)
 1257 FORMAT(5x,' weight=',f8.3,'  ks=<',3f8.3,' >, k=<',3f8.3,'>')
 1258 FORMAT(5x,' number of k-point is very large or distributed')

 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters:')
 1271 FORMAT(5x, ' translation constrained')
 1272 FORMAT(5x, ' rotation constrained')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (electron)',E12.3,' (ion)')
 1297 FORMAT(/' fractional smearing parameters:')
 1298 FORMAT(5X, ' smearing algorithm   = ',A)
 1299 FORMAT(5X, ' smearing parameter   = ',E9.3,' (',F7.1,' K)')
 1300 FORMAT(//)
 1305 FORMAT(10X,'================ iteration =========================')
 1310 FORMAT(I8,E20.10,3E15.5)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1331 FORMAT(/' Elements of Hamiltonian matrix (up/restricted)')
 1332 FORMAT(/' Elements of Hamiltonian matrix (down)')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1341 FORMAT(I3,2I3,' H=',E16.6)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,'(',2E18.7,')')
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(//' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1431 FORMAT(/' QM Energies')
 1432 FORMAT( '------------')
 1433 FORMAT( ' total  QM energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1455 FORMAT( ' SIC-hartree energy  :',E19.10,' (',E15.5,'/electron)')
 1456 FORMAT( ' SIC-exc-corr energy :',E19.10,' (',E15.5,'/electron)')
 1457 FORMAT( ' HF exchange energy  :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1499 FORMAT( ' K.S. SIC-hartree energy  :',E19.10,
     >        ' (',E15.5,'/electron)')
 1501 FORMAT( ' K.S. SIC-exc-corr energy :',E19.10,
     >        ' (',E15.5,'/electron)')
 1502 FORMAT( ' K.S. HFX energy     :',E19.10,
     >        ' (',E15.5,'/electron)')
 1500 FORMAT(/' orbital energies:')
 1507 FORMAT(/' Fermi energy =',2(E18.7,' (',F8.3,'eV)'))
 1508 FORMAT(/' Brillouin zone point: ',i3,
     >       /'    weight=',f10.6,
     >       /'    k     =<',3f8.3,'> . <b1,b2,b3> ',
     >       /'          =<',3f8.3,'>')
 1510 FORMAT(4(E18.7,' (',F8.3,'eV) occ=',F5.3))
 1511 FORMAT(33x,"Spin(Sz,Sy,Sz)")
 1512 FORMAT(E18.7,' (',F8.3,' eV) (|s| =',F6.3, 
     >       ', s = <',F7.3,',',F7.3,',',F7.3,'> ) occ=',F5.3)

 1600 FORMAT(/' Total BAND energy   :',E19.10)

 1700 FORMAT(/' QM/MM-pol-vib/CAV Energies')
 1701 FORMAT( ' --------------------------')
 1702 FORMAT( ' LJ energy              :',E19.10)
 1703 FORMAT( ' Residual Coulomb energy:',E19.10)
 1704 FORMAT( ' MM Vibration energy    :',E19.10)
 1705 FORMAT( ' MM Vibration energy    :',E19.10)
 1706 FORMAT( ' (QM+MM)/Cavity energy  :',E19.10)

 1720 FORMAT(/' Dispersion energy   :',E19.10)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(6,9010) ierr
      call Parallel_Finalize()

      band_sd = value
      return
      END

      SUBROUTINE tce_ao2e_cholesky_orb(rtdb,d_v2,kax_v2_alpha_offset,
     1                                 size_2e)
C     $Id: tce_ao2e_cholesky_orb.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     t ( p1 p2 h3 h4 )_t
      IMPLICIT NONE
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
c
      integer rtdb                 ! Run-time database
      integer d_v2                 ! MO integrals
      integer kax_v2_alpha_offset  ! MO integrals offset
      integer size_2e              ! 2e file size
c
      INTEGER size_2g2a,l_2g2a,k_2g2a
      INTEGER azone1,azone2,azone3,azone4
      INTEGER g1b,g2b,g3b,g4b
      INTEGER igi1,igi2,igi3,igi4
      INTEGER ii,i,j,k,l,N,ipos1,ipos2,ipos3,ipos4
      INTEGER del1,del2,p1rel,p2rel
      INTEGER size_4a,l_4a,k_4a
c
      integer mu,nu,rho,sigma
      integer mu_lo,mu_hi
      integer nu_lo,nu_hi
      integer rho_lo,rho_hi
      integer sigma_lo,sigma_hi
      integer mu_range
      integer nu_range
      integer rho_range
      integer sigma_range
      integer mu1,nu1,rho1,sigma1
      integer shift_mu,shift_nu
      integer shift_rho,shift_sigma
      integer work1,work2          ! Work array sizes
      integer l_work1,k_work1      ! Work array 1
      integer l_work2,k_work2      ! Work array 2
      integer imu1,inu1,irho1,isigma1
c
      integer l_movecs_orb,k_movecs_orb
      integer l_gpair,k_gpair
      integer len_pair,g12_shift
c ATTENTION,ACHTUNG,UWAGA 2000 - max # of CPU
c
      integer size_2g2z,l_2g2z,k_2g2z
      integer tot_azone1_sh,tot_azone2_sh
      integer tot_azone3_sh,tot_azone4_sh
      integer ixi,jxi,point_pair
c
      integer iha,ihb !number of corr. alpha, beta holes
      integer ipa,ipb !number of corr. alpha, beta particles
c compression
      integer max_size_temp,size_temp,sumx
      double precision wall,cpu,wall1,cpu1,wall2,cpu2,wall3,cpu3
c
      double precision tot_zone(1000)
c
      integer l_3a1m_offset,k_3a1m_offset,size_3a1mf
      integer l_1a3m_offset,k_1a3m_offset,size_1a3mf
      integer d_1a3m,d_3a1m
      integer size_3a1m
      integer l_3a1m,k_3a1m
      integer size_amc
      integer key_3a1m,offset_3a1m
      integer l_4a_sort,k_4a_sort
      integer size_2a2m,l_2a2m,k_2a2m
      integer l_3a1m_sort,k_3a1m_sort
      integer l_2a2m_aux,k_2a2m_aux
      integer key_1a3m,offset_1a3m
      integer l_1a3m,k_1a3m,size_1a3m 
      integer l_1a3m_sort,k_1a3m_sort
      INTEGER IROW,ICOL,IRES
      INTEGER INDEX_PAIR
      integer l_4m,k_4m,size_4m,key_4m,offset_4m
      integer sf3a1m_chunk,sf1a3m_chunk
c
      integer l_integral,l_coeff
      integer k_integral,k_coeff
      integer size_ic,size_icc,size_integral,size_coeff,max_na
c 
      integer l_4af_offset,k_4af_offset,d_4af
      integer k_2a2m_offset,l_2a2m_offset
      integer sf_chunk,request
      integer key_4af,offset_4af,size_4af
      integer sf2a2m_chunk,key_2a2m,offset_2a2m
      integer d_2a2m,size_2a2mf
      character*255 filename
c
      integer size_max1,size_max2,ip_max1,ip_max2
      integer chunk_max1,chunk_max2,i_from_x,i_to_x
      integer isizef(5),imaxch(5)
      integer d_max1,d_max2
c
      integer l_a4_offset,k_a4_offset
      integer offset_bl4a,size_bl4a,a4_ini,a4_fin
      integer offset_ismall,length_a4,key_ini 
      integer l_a3_offset,k_a3_offset
      integer length_a3,offset_bl3a1m,size_bl3a1m
      integer size_3a1mi,a3_ini,a3_fin
c
      integer l_a2_offset,k_a2_offset,length_a2
      integer offset_bl2a2m,size_bl2a2m,a2_ini,a2_fin
      integer size_1a3mi,size_2a2mi
c
      integer length_a1
      integer l_a1_offset,k_a1_offset
      integer offset_bl1a3m,size_bl1a3m,a1_ini,a1_fin
c I/O improvements
      integer handle_4a,handle_3a1m,handle_2a2m,handle_1a3m
c
c *** debug ***
      double precision xxx,xmax
c      integer iqx
      integer ierrcode1,ierrcode2
c *************
c 
      logical parallel
c
      INTEGER length
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      EXTERNAL NXTASK
      integer nxtval
      external nxtval
      logical nodezero
      logical idiskl
c
c
c
ccx      idisk=.true.
      if(idisk.eq.0) then
       idiskl=.false.
      else
       idiskl=.true.
      end if
c
      parallel = .true.
c
c
      max_size_temp=imaxsize**4
c
c
      do ii=1,1000
       tot_zone(ii)=0.0d0
      enddo
      if(atpart.gt.1000) 
     &  call errquit('tce_zones: atpart too big',1,MA_ERR)
      sumx=0
      do ii=1,atpart
       tot_zone(ii)=sumx
       sumx=sumx+nalength(ii)
      enddo
c
      nodezero=(ga_nodeid().eq.0)
c
c *** debug ***
c      if(nodezero) then
c        write(6,*)'--------- NEW LOOP STRUCTURE --------' 
c        call util_flush(6)
c      end if
c *************
c
c this module is called only if intorb = .true.
c N is the number of correlated orbitals
        N = nmo(1) - nfc(1) - nfv(1)
        iha = nocc(1)-nfc(1)
        ihb = nocc(ipol)-nfc(ipol)
        ipa = nmo(1)-nocc(1)-nfv(1)
        ipb = nmo(ipol)-nocc(ipol)-nfv(ipol)
c
      sf_chunk=(imaxsize+10)**4
      sf3a1m_chunk=((imaxsize+10)**3)*tile_dim
      sf2a2m_chunk=((tile_dim)**2)*((imaxsize+10)**2)
      sf1a3m_chunk=((tile_dim)**3)*(imaxsize+10)
c
c l_integral and l_coeff local files are opened here
c ATTENTION,ACHTUNG,UWAGA - "manually" defined
cc      size_ic=2*(imaxsize+10)**4
cc      size_ic=2*(imaxsize)**4
      max_na=0
      do ixi=1,atpart
       if(nalength(ixi).gt.max_na) max_na=nalength(ixi)
      enddo
c     it was
cc      size_ic=2*(max_na)**4+1
c it is
        size_ic=2*((max_na)**4)+1
        size_icc=tile_dim*max_na
c
       if(nodezero) then
        write(6,*)'2_EL_BATCH AND COEFF MATRIX'
        write(6,*)'size_ic',size_ic
        write(6,*)'size_icc',size_icc
        write(6,*)'tile_dim',tile_dim
        write(6,*)'max_na',max_na
        call util_flush(6)
       end if
c
      if (.not.ma_push_get(mt_dbl,size_ic,'l_int',
     1  l_integral,k_integral))
     1  call errquit('tce_4s: MA problem l_int',0,MA_ERR)
c
      if (.not.ma_push_get(mt_dbl,size_icc,'l_coeff',
     1  l_coeff,k_coeff))
     1  call errquit('tce_4s: MA problem l_coeff',0,MA_ERR)
c
       call tce_4a_offsetx2(l_4af_offset,k_4af_offset,size_4af)
       call tce_3a1m_offsetx2(l_3a1m_offset,k_3a1m_offset,size_3a1mf)
       call tce_2a2m_offsetx2(l_2a2m_offset,k_2a2m_offset,size_2a2mf)
       call tce_1a3m_offsetx2(l_1a3m_offset,k_1a3m_offset,size_1a3mf)
c
c choose two largeast size_4af,size_3a1mf,size_2a2mf,size_1a3mf,size_2e
c size_max1 > size_max2
       size_max1=0
       size_max2=0
c
       chunk_max1=0
       chunk_max2=0 
c     
       isizef(1)=size_4af
       isizef(2)=size_3a1mf
       isizef(3)=size_2a2mf
       isizef(4)=size_1a3mf
       isizef(5)=size_2e
c
       imaxch(1)=sf_chunk
       imaxch(2)=sf3a1m_chunk
       imaxch(3)=sf2a2m_chunk
       imaxch(4)=sf1a3m_chunk
       imaxch(5)=tile_dim**4
c 
       do i=1,5
        if(isizef(i).gt.size_max1) then
         size_max1=isizef(i)
         ip_max1=i
         chunk_max1=imaxch(i)
        end if
       enddo
       do i=1,5
       if(i.eq.ip_max1) go to 771
        if(isizef(i).gt.size_max2) then
         size_max2=isizef(i)
         ip_max2=i
         chunk_max2=imaxch(i)
        end if
 771   continue
       enddo
c
c CHUNK_SIZE IS PROPERLY DEFINED HERE
c
       chunk_max1=size_ic
       chunk_max2=size_ic
c
c
c
       if(nodezero) then
        write(6,*)'INTERMEDIATE FILES'
        write(6,*)'size_4af',size_4af
        write(6,*)'size_3a1mf',size_3a1mf
        write(6,*)'size_2a2mf',size_2a2mf
        write(6,*)'size_1a3mf',size_1a3mf
        write(6,*)'size_2e',size_2e
       end if 
c
c DISK USAGE ONLY !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c 
      if(idiskl) then
        if(.not.parallel) 
     1       call errquit('sf only for parallel runs',1,DISK_ERR)
cx        if(parallel) call ga_sync()
cx        call util_file_name('max1',.false.,.false.,filename)
cx        if (sf_create(filename,dfloat(bytes)*dfloat(size_max1),
cx     1    dfloat(bytes)*dfloat(size_max1),chunk_max1,d_max1).ne.0)
cx     2    call errquit('4-index: sf problem a',0,DISK_ERR)
c
cx        call util_file_name('max2',.false.,.false.,filename)
cx        if (sf_create(filename,dfloat(bytes)*dfloat(size_max2),
cx     1    dfloat(bytes)*dfloat(size_max2),chunk_max2,d_max2).ne.0)
cx     2    call errquit('4-index: sf problem b',0,DISK_ERR)
c
c       call createfile(filename,d_v2,size_2e)
c       call ga_zero(d_v2)
c
      else
       if(.not.parallel)
     1       call errquit('sf only for parallel runs',1,DISK_ERR)
       if(parallel) call ga_sync()
        if(size_4af.le.size_max2) then        
         call createfile(filename,d_max1,size_max1)
         call reconcilefile(d_max1,size_max1)
         call ga_zero(d_max1)
         call createfile(filename,d_max2,size_max2)
         call reconcilefile(d_max2,size_max2)
         call ga_zero(d_max2)
        else
         call createfile(filename,d_max2,size_max2)
         call reconcilefile(d_max2,size_max2)
         call ga_zero(d_max2)
         call createfile(filename,d_max1,size_max1)
         call reconcilefile(d_max1,size_max1)
         call ga_zero(d_max1)
        end if
      end if 
c
c
c alpha orbitals only
c
      if (.not.ma_push_get(mt_dbl,nbf*(iha+ipa)
     1  ,"sorted MO coeffs",
     2  l_movecs_orb,k_movecs_orb))
     3  call errquit('tce_mo2e_zone: MA problem 1',0,
     2    BASIS_ERR)
      call dfill(nbf*(iha+ipa),0.0d0, dbl_mb(k_movecs_orb), 1)
      do i=1,iha
      do isigma1=1,nbf
       dbl_mb(k_movecs_orb+(i-1)*nbf+isigma1-1)=
     & dbl_mb(k_movecs_sorted+(i-1)*nbf+isigma1-1)
      enddo
      enddo
      do i=iha+1,iha+ipa
      do isigma1=1,nbf
       dbl_mb(k_movecs_orb+(i-1)*nbf+isigma1-1)=
     & dbl_mb(k_movecs_sorted+(i+ihb-1)*nbf+isigma1-1)
      enddo
      enddo
c
c
      call int_mem_2e4c(work1,work2)
      if (.not.ma_push_get(mt_dbl,work1,'work1',l_work1,k_work1))
     1  call errquit('tce_ao2e: MA problem work1',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,work2,'work2',l_work2,k_work2))
     1  call errquit('tce_ao2e: MA problem work2',1,MA_ERR)
c
c
c 
c 4af file formed here
c
ccx      if(size_4af.le.size_max2) then
ccx       i_to_x=d_max2
ccx      else
ccx       i_to_x=d_max1
ccx      end if
c
c DISK CHANGES =============== 4A
c opening handle_4a file
c ** debug **
      if(nodezero) then
        write(6,*)'before sf_create'
        call util_flush(6)
      end if  
c
      if(idiskl) then
        call util_file_name('4af',.false.,.false.,filename)
        if (sf_create(filename,dfloat(bytes)*dfloat(size_4af),
     1    dfloat(bytes)*dfloat(size_4af),chunk_max1,handle_4a).ne.0)
     2    call errquit('4-index: sf problem opening 4af',0,DISK_ERR)
        i_to_x=handle_4a
      end if
c
      if(nodezero) then
        write(6,*)'after sf_create'
        call util_flush(6)
      end if
c ============================ 

             cpu1 = - util_cpusec()
             wall1 = - util_wallsec()
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
      DO azone3 = 1,atpart      !sigma
      DO azone4 = azone3,atpart !rho
      IF (next.eq.count) THEN
c ---------------------------
        size_4a = nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
        if(.not.ma_push_get(mt_dbl,size_4a,'4a',l_4a,k_4a))
     1     call errquit('tce_4af_zones1: MA problem',0,MA_ERR)
        call dfill(size_4a, 0.0d0, dbl_mb(k_4a), 1)
         shift_mu = 0
         do mu    = a2length(azone2)+1,a2length(azone2+1)
            if (.not.bas_cn2bfr(ao_bas_han,mu,mu_lo,mu_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            mu_range = mu_hi - mu_lo + 1
         shift_nu = 0
         do nu    = a2length(azone1)+1,a2length(azone1+1)
            if (.not.bas_cn2bfr(ao_bas_han,nu,nu_lo,nu_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            nu_range = nu_hi - nu_lo + 1
         shift_rho = 0
         do rho   = a2length(azone4)+1,a2length(azone4+1)
            if (.not.bas_cn2bfr(ao_bas_han,rho,rho_lo,rho_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            rho_range = rho_hi - rho_lo + 1
         shift_sigma = 0
         do sigma = a2length(azone3)+1,a2length(azone3+1)
            if (.not.bas_cn2bfr(ao_bas_han,sigma,sigma_lo,sigma_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            sigma_range = sigma_hi - sigma_lo + 1
            if (schwarz_shell(rho,sigma)*schwarz_shell(mu,nu)
     1          .ge. tol2e) then
            call int_2e4c(ao_bas_han,mu,nu,ao_bas_han,rho,sigma,
     1           work2,dbl_mb(k_work2),work1,dbl_mb(k_work1))
            i=0
             do mu1     = 1,mu_range
             do nu1     = 1,nu_range
             do rho1    = 1,rho_range
             do sigma1  = 1,sigma_range
            i=i+1
            inu1=nu1+shift_nu
            isigma1=sigma1+shift_sigma
            imu1=mu1+shift_mu
            irho1=rho1+shift_rho
c (isigma1,irho1|inu1, imu1)
c differnce with other versiosn
c here 
            ipos1=(((inu1-1)*nalength(azone2)+imu1-1)*
     1            nalength(azone3)+isigma1-1)*nalength(azone4)
     2            +irho1 
            dbl_mb(k_4a+ipos1-1)=dbl_mb(k_work1+i-1)
            enddo
            enddo
            enddo
            enddo
            end if !schwarz  screening
         shift_sigma = shift_sigma + sigma_range
         enddo !sigma
         shift_rho   = shift_rho + rho_range
         enddo !rho
         shift_nu    = shift_nu + nu_range
         enddo !nu
         shift_mu    = shift_mu + mu_range
         enddo !mu
c
c fixing offsets and sf_writing
         key_4af=azone4 - 1 + atpart * (azone3 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
         call tce_hash(int_mb(k_4af_offset),key_4af,offset_4af)
      if(idiskl) then !----
        ierrcode1=sf_write(i_to_x,dfloat(bytes)*dfloat(offset_4af),
     1    dfloat(bytes)*dfloat(size_4a),dbl_mb(k_4a),request)
ccx        if (sf_write(i_to_x,dfloat(bytes)*dfloat(offset_4af),
ccx     1    dfloat(bytes)*dfloat(size_4a),dbl_mb(k_4a),request).ne.0)
ccx     1    THEN
        if(ierrcode1.ne.0) then
          write(6,8154)ierrcode1
          write(6,8155)ga_nodeid(),key_4af,offset_4af,size_4a
          call util_flush(6)
          call errquit('zones put: sf problem2x1',1,DISK_ERR)
        end if 
        ierrcode2=sf_wait(request)
ccx        if (sf_wait(request).ne.0) 
        if(ierrcode2.ne.0) then       
           write(6,8153)ierrcode2
           call util_flush(6)
           call errquit('zones put: sf problem3x1',2,DISK_ERR)
        end if 
      else
        call ga_put(i_to_x,offset_4af+1,offset_4af+size_4a,1,1,
     1    dbl_mb(k_4a),1)
      end if          !----
c closing l_4a file
        if (.not.ma_pop_stack(l_4a))
     1   call errquit('tce_mo2e_4af2: l_4a',15,MA_ERR)
c ---------------------------
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO !azone4
      ENDDO !azone3
      ENDDO !azone2
      ENDDO !azone1
c
c
       call ga_sync()
       next = nxtval(-nprocs)
c
c
c
      if(nodezero) then
        write(6,*)'STEP2 4index'
        call util_flush(6)
      end if
c
c
c
c
c
ccx       i_from_x=i_to_x
ccx       if(i_from_x.eq.d_max1) then
ccx        i_to_x=d_max2 
c size check-out
ccx        if(size_max2.lt.size_3a1mf) 
ccx     1    call errquit('tce_4s: 1a',15,MA_ERR)
ccx       else
ccx        i_to_x=d_max1
c size check-out
ccx        if(size_max1.lt.size_3a1mf)
ccx     1    call errquit('tce_4s: 1b',15,MA_ERR)
ccx       end if
c
c DISK CHANGES =============== 3A1M
c closing/reopening handle_4a file
c opening handle_3a1m file
      if(idiskl) then
c       
        if(sf_rwtor(handle_4a).ne.0)
     2    call errquit('4-index: sf_rwtor 4a',0,DISK_ERR)
c *** debug ***
c        if(nodezero) then
c          write(6,*)'STEP2 tests'
c          write(6,*)'handle_4a',handle_4a
c          call util_flush(6)
c        endif
c *************
c
        call util_file_name('3a1mf',.false.,.false.,filename)
        if (sf_create(filename,dfloat(bytes)*dfloat(size_3a1mf),
     1    dfloat(bytes)*dfloat(size_3a1mf),chunk_max1,handle_3a1m).ne.0)
     2    call errquit('4-index: sf problem opening 3a1mf',0,DISK_ERR)
        i_from_x=handle_4a
        i_to_x=handle_3a1m
c *** debug ***
c        if(nodezero) then
c         write(6,*)'i_from_x=',i_from_x
c         write(6,*)'i_to_x=',i_to_x
c         write(6,*)'handle_4a=',handle_4a
c         write(6,*)'handle_3a1m=',handle_3a1m
c         write(6,*)'size_3a1mf=',size_3a1mf
c         write(6,*)'size_4af=',size_4af
c         call util_flush(6)
c        end if
c *************
      end if
c ============================

c
c 3A1M part here
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
c
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
      DO g4b = 1,noa+nva        !k
      DO azone3 = 1,atpart      !sigma
ccx      DO g4b = 1,noa+nva        !k
c
      IF (next.eq.count) THEN
c
      size_3a1m=int_mb(k_range_alpha+g4b-1)
     1          *nalength(azone1)*nalength(azone2)*nalength(azone3)
      if (.not.ma_push_get(mt_dbl,size_3a1m,'3a1m',l_3a1m,k_3a1m))
     1    call errquit('tce_4ind: step1_1',0,MA_ERR)
      call dfill(size_3a1m, 0.0d0, dbl_mb(k_3a1m), 1)
c 
c    routine for offset 
c
      call a4_offset(azone1,azone2,azone3,size_ic,
     &           l_a4_offset,k_a4_offset)
c      
      length_a4=int_mb(k_a4_offset) 
      DO ii=1,length_a4
       a4_ini      = int_mb(k_a4_offset+ii)
       a4_fin      = int_mb(k_a4_offset+length_a4+ii)
       key_ini=a4_ini - 1 + atpart * (azone3 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
       call tce_hash(int_mb(k_4af_offset),key_ini,offset_bl4a)
c
       size_bl4a   = int_mb(k_a4_offset+2*length_a4+ii) 
      if(idiskl) then !---------
        ierrcode1=sf_read(i_from_x,dfloat(bytes)*dfloat(offset_bl4a),
     1    dfloat(bytes)*dfloat(size_bl4a),dbl_mb(k_integral),
     1    request)
ccx        if (sf_read(i_from_x,dfloat(bytes)*dfloat(offset_bl4a),
ccx     1    dfloat(bytes)*dfloat(size_bl4a),dbl_mb(k_integral),
ccx     1    request).ne.0) THEN
         if(ierrcode1.ne.0) THEN
          write(6,*)'STEP2_step1'
          write(6,8153)ierrcode1 
          write(6,8155)ga_nodeid(),key_ini,offset_bl4a,size_bl4a
          write(6,*)'length_a4',length_a4
          write(6,*)'ii=',ii
          write(6,*)'i_from_x',i_from_x
          call util_flush(6)
          call errquit('zones put: sf problem2x2',1,DISK_ERR)
        end if
        ierrcode2=sf_wait(request)
ccx        if (sf_wait(request).ne.0)
        if (ierrcode2.ne.0) then
           write(6,8154)ierrcode2
           call util_flush(6)
           call errquit('zones put: sf problem3x2',2,DISK_ERR)
        end if 
      else
        call ga_get(i_from_x,offset_bl4a+1,offset_bl4a+size_bl4a,1,1,
     1    dbl_mb(k_integral),1)
      end if !--------------
c
      offset_ismall=0
      do i=a4_ini,a4_fin ! over small i ------------------
      tot_azone4_sh=tot_zone(i)
      j=0
      do irho1   =  1,nalength(i)
      do igi4=1,int_mb(k_range_alpha+g4b-1)
       j=j+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+j-1)=dbl_mb(k_movecs_orb+ipos1-1)
      enddo
      enddo
c C(g4b irho)* v(irho,isigma,imu,inu)
      call dgemm('N','N',
     &   int_mb(k_range_alpha+g4b-1),
     &   nalength(azone1)*nalength(azone2)*nalength(azone3),
     &   nalength(i),
     &   1.0d0,dbl_mb(k_coeff),int_mb(k_range_alpha+g4b-1),
     &   dbl_mb(k_integral+offset_ismall),nalength(i),1.0d0,
     &   dbl_mb(k_3a1m),int_mb(k_range_alpha+g4b-1))
c
       offset_ismall=offset_ismall+nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(i)
       enddo ! over small i ----------------------
c
      ENDDO  ! over ii
        if (.not.ma_pop_stack(l_a4_offset))
     1   call errquit('tce_mo2e_trans_zones: uu l_2g2z',15,MA_ERR)
c
c
c
c
      DO azone4 = 1, azone3-1  ! second part ----
c getting piece of 4a
        size_4a = nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
       if(azone3.le.azone4) then
         key_4af=azone4 - 1 + atpart * (azone3 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
       else
         key_4af=azone3 - 1 + atpart * (azone4 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
       end if 
         call tce_hash(int_mb(k_4af_offset),key_4af,offset_4af)
      if(idiskl) then !---------
        ierrcode1=sf_read(i_from_x,dfloat(bytes)*dfloat(offset_4af),
     1 dfloat(bytes)*dfloat(size_4a),dbl_mb(k_integral),request)
ccx        if (sf_read(i_from_x,dfloat(bytes)*dfloat(offset_4af),
ccx     1 dfloat(bytes)*dfloat(size_4a),dbl_mb(k_integral),request).ne.0)
ccx     1    THEN
        if(ierrcode1.ne.0) then
          write(6,*)'STEP2-step1b'
          write(6,8153)ierrcode1
          write(6,8155)ga_nodeid(),key_4af,offset_4af,size_4a
          call errquit('zones put: sf problem2x3',1,DISK_ERR)
        end if
        ierrcode2=sf_wait(request)
ccx        if (sf_wait(request).ne.0)
        if(ierrcode2.ne.0) then
           write(6,8154)ierrcode2
           call util_flush(6)
           call errquit('zones put: sf problem3x3',2,DISK_ERR)
        end if
      else
        call ga_get(i_from_x,offset_4af+1,offset_4af+size_4a,1,1,
     1    dbl_mb(k_integral),1)
      end if !--------------
c
      if(azone4.lt.azone3) then
        if(.not.ma_push_get(mt_dbl,size_4a,'4a_s',l_4a_sort,k_4a_sort))
     1     call errquit('tce_4af_zones1: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_4a_sort),
     & nalength(azone3),nalength(azone4),
     & nalength(azone2),nalength(azone1),
     &2,1,3,4,1.0d0)
      do i=1,size_4a
       dbl_mb(k_integral+i-1)=dbl_mb(k_4a_sort+i-1)
      enddo
        if (.not.ma_pop_stack(l_4a_sort))
     1   call errquit('tce_mo2e_trans_zones: uu l_2g2z',15,MA_ERR)
      end if 
c
c  C(g4b irho) ==> l_2g2z
c
      size_amc=int_mb(k_range_alpha+g4b-1) *
     1         nalength(azone4)
      i=0
      tot_azone4_sh=tot_zone(azone4)
      do irho1   =  1,nalength(azone4)
      do igi4=1,int_mb(k_range_alpha+g4b-1)
       i=i+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
      enddo
      enddo  
c C(g4b irho)* v(irho,isigma,imu,inu)
      call dgemm('N','N',
     &   int_mb(k_range_alpha+g4b-1),
     &   nalength(azone1)*nalength(azone2)*nalength(azone3),
     &   nalength(azone4),
     &   1.0d0,dbl_mb(k_coeff),int_mb(k_range_alpha+g4b-1),
     &   dbl_mb(k_integral),nalength(azone4),1.0d0,
     &   dbl_mb(k_3a1m),int_mb(k_range_alpha+g4b-1))
c
      ENDDO
c write to file
          key_3a1m =  azone3-1+atpart*(g4b-1+(noa+nva)*
     &    (azone2 - 1 + atpart * (azone1 - 1)))
         call tce_hash(int_mb(k_3a1m_offset),key_3a1m,offset_3a1m)
       if(idiskl) then ! --------
        ierrcode1=sf_write(i_to_x,dfloat(bytes)*dfloat(offset_3a1m),
     r    dfloat(bytes)*dfloat(size_3a1m),dbl_mb(k_3a1m),request)
        if (ierrcode1.ne.0) then
          write(6,*)'WRITE STEP3'
          write(6,8156) ierrcode1
          write(6,*)'offset_3a1m=',offset_3a1m
          write(6,*)'size_3a1m=',size_3a1m
          write(6,*)'i_to_x',i_to_x 
          call util_flush(6)
          call errquit('zones put: sf problem21-b',1,DISK_ERR)
        end if
        ierrcode2=sf_wait(request)
ccx        if (sf_wait(request).ne.0)
        if(ierrcode2.ne.0) then
          write(6,8157)ierrcode2
          call errquit('zones put: sf problem31-b',2,DISK_ERR)
        end if 
       else
        call ga_put(i_to_x,offset_3a1m+1,offset_3a1m+size_3a1m,1,1,
     1    dbl_mb(k_3a1m),1)
       end if ! ---------
c
      if (.not.ma_pop_stack(l_3a1m))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
c
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO
      ENDDO
      ENDDO
      ENDDO
c 3A1P fully done here
      call ga_sync()
      next = nxtval(-nprocs)
c
c
c
c
      if(nodezero) then
        write(6,*)'STEP3 4index'
        call util_flush(6)
      end if
c
c
c
c
c
c 2A2M part here
c
ccx       i_from_x=i_to_x
ccx       if(i_from_x.eq.d_max1) then
ccx        i_to_x=d_max2
c size check-out
ccx        if(size_max2.lt.size_2a2mf)
ccx     1    call errquit('tce_4s: 2a',15,MA_ERR)
ccx       else
ccx        i_to_x=d_max1
c size check-out
ccx        if(size_max1.lt.size_2a2mf)
ccx     1    call errquit('tce_4s: 2b',15,MA_ERR)
ccx       end if
c
c
c DISK CHANGES =============== 2A2M
c destroying handle_4a
c closing/reopening handle_3a1m file
c opening handle_2a2m file
      if(idiskl) then
c
       if (sf_destroy(handle_4a).ne.0)
     1   call errquit('tce_sf_destroy: sf problem handle_4a',15,MA_ERR)
c
        if(sf_rwtor(handle_3a1m).ne.0) 
     2    call errquit('4-index: sf_rwtor 3a1m',0,DISK_ERR)
c *** debug ***
c      if(nodezero) then
c       write(6,*)'handle_3a1m',handle_3a1m
c      end if 
c *************
c
        call util_file_name('2a2mf',.false.,.false.,filename)
        if (sf_create(filename,dfloat(bytes)*dfloat(size_2a2mf),
     1    dfloat(bytes)*dfloat(size_2a2mf),chunk_max1,handle_2a2m).ne.0)
     2    call errquit('4-index: sf problem opening 2a2mf',0,DISK_ERR)
        i_from_x=handle_3a1m
        i_to_x=handle_2a2m
      end if
c *** debug ***
       if(nodezero) then
        write(6,*)'STEP3 test'
c        write(6,*)'handle_2a2m=',handle_2a2m 
c        write(6,*)'size_2a2mf=',size_2a2mf
c        write(6,*)'i_from_x=',i_from_x
c        write(6,*)'i_to_x=',i_to_x
        call util_flush(6)
       end if
c *************
c ============================
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
c
      DO g3b = 1,noa+nva   !k
      DO g4b = g3b,noa+nva !l
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
ccx      DO g3b = 1,noa+nva   !k
ccx      DO g4b = g3b,noa+nva !l
c
      IF (next.eq.count) THEN
c
      size_2a2m=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1          *nalength(azone1)*nalength(azone2)
      if (.not.ma_push_get(mt_dbl,size_2a2m,'2a2m',l_2a2m,k_2a2m))
     1    call errquit('tce_4ind: step1_1',0,MA_ERR)
      call dfill(size_2a2m, 0.0d0, dbl_mb(k_2a2m), 1)
c
      call a3_offset(azone1,azone2,g3b,size_ic,
     &           l_a3_offset,k_a3_offset)
      length_a3=int_mb(k_a3_offset)
c 
      DO ii=1,length_a3     ! ii---loop

       a3_ini    = int_mb(k_a3_offset+ii)
       a3_fin    = int_mb(k_a3_offset+length_a3+ii)
       key_ini   = a3_ini-1+atpart*(g3b-1+(noa+nva)*
     &    (azone2 - 1 + atpart * (azone1 - 1)))
       call tce_hash(int_mb(k_3a1m_offset),key_ini,offset_bl3a1m)
c
       size_bl3a1m   = int_mb(k_a3_offset+2*length_a3+ii)
c
c
       if(idiskl) then ! -------
        ierrcode1=sf_read(i_from_x,dfloat(bytes)*dfloat(offset_bl3a1m),
     2    dfloat(bytes)*dfloat(size_bl3a1m),
     2    dbl_mb(k_integral),request)
         if(ierrcode1.ne.0) then
          write(6,*)'STEP3-step1a'
          write(6,8153) ierrcode1
          write(6,*)'offset_bl3a1m=',offset_bl3a1m
          write(6,*)'size_bl3a1m=',size_bl3a1m
          write(6,*)'ii=',ii
          write(6,*)'length_a3=',length_a3
          call util_flush(6)
          call errquit('zones put: sf problem21-b',1,DISK_ERR)
         end if 
         ierrcode2=sf_wait(request)
         if(ierrcode2.ne.0) then 
          write(6,*)'STEP3-step1a'
          write(6,8154) ierrcode2
          call util_flush(6)
          call errquit('zones put: sf problem31-b',2,DISK_ERR)
         end if
       else 
        call ga_get(i_from_x,offset_bl3a1m+1,offset_bl3a1m+size_bl3a1m,
     1       1,1,dbl_mb(k_integral),1) 
       end if ! -------
      offset_ismall=0
      do i=a3_ini,a3_fin ! over small i ------------------
      size_3a1mi=nalength(azone1)*nalength(azone2)*
     1            nalength(i)*int_mb(k_range_alpha+g3b-1)
      if (.not.ma_push_get(mt_dbl,size_3a1mi,'3a1m',
     1 l_3a1m_sort,k_3a1m_sort))
     1    call errquit('tce_4ind: step1_1',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral+offset_ismall),
     & dbl_mb(k_3a1m_sort),
     & int_mb(k_range_alpha+g3b-1),nalength(i),
     & nalength(azone2),nalength(azone1),
     &2,1,3,4,1.0d0)
      do j=1,size_3a1mi
       dbl_mb(k_integral+offset_ismall+j-1)=dbl_mb(k_3a1m_sort+j-1)
      enddo
      if (.not.ma_pop_stack(l_3a1m_sort))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
c  C(g4b isigma)
      j=0
      tot_azone3_sh=tot_zone(i)
      do isigma1   =  1,nalength(i)
      do igi4=1,int_mb(k_range_alpha+g4b-1)
       j=j+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone3_sh
     &       +isigma1
       dbl_mb(k_coeff+j-1)=dbl_mb(k_movecs_orb+ipos1-1)
      enddo
      enddo
c C(g4b isigma)* v(isigma,g3b,imu,inu)
      call dgemm('N','N',
     &   int_mb(k_range_alpha+g4b-1),
     &   nalength(azone1)*nalength(azone2)*int_mb(k_range_alpha+g3b-1),
     &   nalength(i),
     &   1.0d0,dbl_mb(k_coeff),int_mb(k_range_alpha+g4b-1),
     &   dbl_mb(k_integral+offset_ismall),nalength(i),1.0d0,
     &   dbl_mb(k_2a2m),int_mb(k_range_alpha+g4b-1))
c
      offset_ismall=offset_ismall+nalength(azone1)*nalength(azone2)*
     1            nalength(i)*int_mb(k_range_alpha+g3b-1)
      enddo ! over small i ----------------------
      ENDDO                 ! ii---loop
c
        if (.not.ma_pop_stack(l_a3_offset))
     1   call errquit('tce_mo2e_trans_zones: uu l_2g2z',15,MA_ERR)
c write to file
          key_2a2m= azone2 - 1 + atpart*( azone1 - 1 +
     & atpart*(g4b - 1 + (noa+nva) * (g3b-1)))
         call tce_hash(int_mb(k_2a2m_offset),key_2a2m,offset_2a2m)
       if(idiskl) then ! -------
        ierrcode1=sf_write(i_to_x,dfloat(bytes)*dfloat(offset_2a2m),
     2    dfloat(bytes)*dfloat(size_2a2m),dbl_mb(k_2a2m),request)
        if(ierrcode1.ne.0) then 
         write(6,*)'STEP3 write'
         write(6,8156) ierrcode1
         write(6,*)'offset_2a2m=',offset_2a2m
         write(6,*)'size_2a2m=',size_2a2m
         write(6,*)'key_2a2m=',key_2a2m
         write(6,*)'i_to_x=',i_to_x
         call util_flush(6) 
         call errquit('zones put: sf problem21-b',1,DISK_ERR)
        end if 
        ierrcode2=sf_wait(request)
        if(ierrcode2.ne.0) then
         call errquit('zones put: sf problem31-b',2,DISK_ERR)
        end if
       else 
        call ga_put(i_to_x,offset_2a2m+1,offset_2a2m+size_2a2m,1,1,
     1    dbl_mb(k_2a2m),1)
       end if  ! --------
c
      if (.not.ma_pop_stack(l_2a2m))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
c
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO
      ENDDO
      ENDDO
      ENDDO
c 2A2P fully done here
      call ga_sync()
      next = nxtval(-nprocs)
c
c
c
c
c
      if(nodezero) then
        write(6,*)'STEP4 4index'
        call util_flush(6)
      end if
c
c
c
c
c
c
c 1A3M part here ([g4b][g3b]|[mu][nu]) =>([g4b][g3b]|[g2b][nu])
c                            [mu]>[nu] (azone2>=azone1)
c
c
cx       i_from_x=i_to_x
cx       if(i_from_x.eq.d_max1) then
cx        i_to_x=d_max2
c size check-out
cx        if(size_max2.lt.size_1a3mf)
cx     1    call errquit('tce_4s: 3a',15,MA_ERR)
cx       else
cx        i_to_x=d_max1
c size check-out
cx        if(size_max1.lt.size_1a3mf)
cx     1    call errquit('tce_4s: 3b',15,MA_ERR)
cx       end if
c
c
c
c
c DISK CHANGES =============== 1A3M
c destroying handle_3a1m
c closing/reopening handle_2a2m file
c opening handle_1a3m file
      if(idiskl) then
c
       if (sf_destroy(handle_3a1m).ne.0)
     1  call errquit('tce_sf_destroy: sf problem handle_3a1m',15,MA_ERR)
c
        if(sf_rwtor(handle_2a2m).ne.0)
     2    call errquit('4-index: sf_rwtor 2a2m',0,DISK_ERR)
c
        call util_file_name('1a3mf',.false.,.false.,filename)
        if (sf_create(filename,dfloat(bytes)*dfloat(size_1a3mf),
     1    dfloat(bytes)*dfloat(size_1a3mf),chunk_max1,handle_1a3m).ne.0)
     2    call errquit('4-index: sf problem opening 1a3mf',0,DISK_ERR)
        i_from_x=handle_2a2m
        i_to_x=handle_1a3m
      end if
c ============================
c
c
c
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
c
      DO g3b = 1,noa+nva   !k
      DO g4b = g3b,noa+nva !l
      DO g2b = 1,noa+nva   !
      DO azone1 = 1,atpart      !nu
ccx      DO g3b = 1,noa+nva   !k
ccx      DO g4b = g3b,noa+nva !l
c
      IF (next.eq.count) THEN
      size_1a3m=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1         *int_mb(k_range_alpha+g2b-1)*nalength(azone1)
      if (.not.ma_push_get(mt_dbl,size_1a3m,'1a3m',l_1a3m,k_1a3m))
     1    call errquit('tce_4ind: step1_1',0,MA_ERR)
      call dfill(size_1a3m, 0.0d0, dbl_mb(k_1a3m), 1)
c azone2 >= azone1 - PART1
c
c
      call a2_offset(azone1,g4b,g3b,size_ic,
     &           l_a2_offset,k_a2_offset)
c
      length_a2=int_mb(k_a2_offset)
      DO ii=1,length_a2  !=========================================
       a2_ini      = int_mb(k_a2_offset+ii)
       a2_fin      = int_mb(k_a2_offset+length_a2+ii)
       key_ini=a2_ini - 1 + atpart*( azone1 - 1 +
     & atpart*(g4b - 1 + (noa+nva) * (g3b-1)))
       call tce_hash(int_mb(k_2a2m_offset),key_ini,offset_bl2a2m)
c
       size_bl2a2m   = int_mb(k_a2_offset+2*length_a2+ii)
      if(idiskl) then !---------
        if (sf_read(i_from_x,dfloat(bytes)*dfloat(offset_bl2a2m),
     1    dfloat(bytes)*dfloat(size_bl2a2m),dbl_mb(k_integral),
     1    request).ne.0) THEN
          write(6,8155)ga_nodeid(),key_4af,offset_4af,size_4a
          call errquit('zones put: sf problem2x4',1,DISK_ERR)
        end if
        if (sf_wait(request).ne.0)
     1     call errquit('zones put: sf problem3x4',2,DISK_ERR)
      else
        call ga_get(i_from_x,offset_bl2a2m+1,
     1    offset_bl2a2m+size_bl2a2m,1,1,dbl_mb(k_integral),1)
      end if !--------------
c
c *** debug ***
c         xmax=0.0d0
c         do i=1,size_bl2a2m
c          xmax=xmax+dbl_mb(k_integral+i-1)
c         enddo
c         if (util_print('mo2e',print_debug)) write(6,411) 
c     &       azone1,g2b,g4b,g3b,a2_ini,a2_fin,size_bl2a2m,key_ini,xmax
c 411     format('    1A3M part1 ',4i3,2x,2i4,2x,i9,2x,i9,f17.8)
c         call util_flush(6)
c *************
c
      offset_ismall=0
      do i=a2_ini,a2_fin ! over small i ------------------
ccc       TRANSPOZYCJA
        size_2a2mi=nalength(azone1)*nalength(i)*
     1     int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
        if (.not.ma_push_get(mt_dbl,size_2a2mi,'2a2m_sort',
     1   l_2a2m_aux,k_2a2m_aux))
     1     call errquit('tce_4ind: step1_1',0,MA_ERR)
        CALL TCE_SORT_4KG_(dbl_mb(k_integral+offset_ismall),
     &   dbl_mb(k_2a2m_aux),
     &   int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1),
     &   nalength(i),nalength(azone1),
     &   1,2,4,3,1.0d0)
        do j=1,size_2a2mi
         dbl_mb(k_integral+offset_ismall+j-1)=dbl_mb(k_2a2m_aux+j-1)
        enddo
        if (.not.ma_pop_stack(l_2a2m_aux))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
c  C(azone2 g2b) 
      j=0
      tot_azone2_sh=tot_zone(i)
      do igi2=1,int_mb(k_range_alpha+g2b-1)
      do imu1   =  1,nalength(i)
       j=j+1
       ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone2_sh
     &       +imu1
       dbl_mb(k_coeff+j-1)=dbl_mb(k_movecs_orb+ipos1-1)
      enddo
      enddo
c  v(g4b,g3b,inu,imu) C(imu,g2b)
        size_1a3mi=int_mb(k_range_alpha+g4b-1)
     & *int_mb(k_range_alpha+g3b-1)*nalength(azone1)
     & *int_mb(k_range_alpha+g2b-1) 
        if (.not.ma_push_get(mt_dbl,size_1a3mi,'1a3m',
     1   l_1a3m_sort,k_1a3m_sort))
     1     call errquit('tce_4ind: step1_1',0,MA_ERR)
c dgemm
      call dgemm('N','N',
     &   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     &   *nalength(azone1),
     &   int_mb(k_range_alpha+g2b-1),
     &   nalength(i),
     &   1.0d0,dbl_mb(k_integral+offset_ismall),
     &   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     &  *nalength(azone1),
     &   dbl_mb(k_coeff),nalength(i),0.0d0,
     &   dbl_mb(k_1a3m_sort),
     &   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     &  *nalength(azone1))
c transpose
        j=0
        do inu1=1,nalength(azone1)
        do igi2=1,int_mb(k_range_alpha+g2b-1)
        do igi3=1,int_mb(k_range_alpha+g3b-1)
        do igi4=1,int_mb(k_range_alpha+g4b-1)
        j=j+1
        ipos1=igi4+int_mb(k_range_alpha+g4b-1)*(
     &   igi3-1+int_mb(k_range_alpha+g3b-1)*(
     &   inu1-1+nalength(azone1)*(igi2-1)))
        dbl_mb(k_1a3m+j-1)=dbl_mb(k_1a3m+j-1)+
     &                     dbl_mb(k_1a3m_sort+ipos1-1)
        enddo
        enddo
        enddo
        enddo
        if (.not.ma_pop_stack(l_1a3m_sort))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
       offset_ismall=offset_ismall+nalength(azone1)*nalength(i)*
     1      int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
       enddo ! over small i ----------------------
      ENDDO  ! over ii !===========================================
        if (.not.ma_pop_stack(l_a2_offset))
     1   call errquit('tce_mo2e_trans_zones: uu l_2g2z',15,MA_ERR)
c
c
c azone2 < azone1  - PART2 

      DO azone2 = 1,azone1-1 ! PART2 two cases here only one is followed 
       size_2a2m=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1           *nalength(azone1)*nalength(azone2)
       if (.not.ma_push_get(mt_dbl,size_2a2m,'2a2m',l_2a2m,k_2a2m))
     1    call errquit('tce_4ind: step1_1',0,MA_ERR)
       if(azone2.ge.azone1) then
          key_2a2m= azone2 - 1 + atpart*( azone1 - 1 +
     & atpart*(g4b - 1 + (noa+nva) * (g3b-1)))
         call tce_hash(int_mb(k_2a2m_offset),key_2a2m,offset_2a2m)
        if(idiskl) then !------
        if (sf_read(i_from_x,dfloat(bytes)*dfloat(offset_2a2m),
     r    dfloat(bytes)*dfloat(size_2a2m),dbl_mb(k_2a2m),request).ne.0)
     2    call errquit('zones put: sf problem21-b',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('zones put: sf problem31-b',2,DISK_ERR)
        else
        call ga_get(i_from_x,offset_2a2m+1,offset_2a2m+size_2a2m,1,1,
     1    dbl_mb(k_2a2m),1)
        end if !-----
       else 
          key_2a2m= azone1 - 1 + atpart*( azone2 - 1 +
     & atpart*(g4b - 1 + (noa+nva) * (g3b-1)))
         call tce_hash(int_mb(k_2a2m_offset),key_2a2m,offset_2a2m)
        if(idiskl) then ! ------
        if (sf_read(i_from_x,dfloat(bytes)*dfloat(offset_2a2m),
     r    dfloat(bytes)*dfloat(size_2a2m),dbl_mb(k_2a2m),request).ne.0)
     2    call errquit('zones put: sf problem21-b',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('zones put: sf problem31-b',2,DISK_ERR)
c *** debug ***
c         xmax=0.0d0
c         do i=1,size_2a2m
c          xmax=xmax+dbl_mb(k_2a2m+i-1)
c         enddo
c         if (util_print('mo2e',print_debug)) write(6,412)
c     &       azone1,g2b,g4b,g3b,azone2,size_2a2m,key_2a2m,xmax
c 412     format('    1A3M part2 ',4i3,2x,i4,2x,i9,2x,i9,2x,f17.8)
c         call util_flush(6)
c *************
        else
        call ga_get(i_from_x,offset_2a2m+1,offset_2a2m+size_2a2m,1,1,
     1    dbl_mb(k_2a2m),1)
        end if ! ------
        end if ! xxxxxx
       if(azone2.ge.azone1) then
ccc       TRANSPOZYCJA
        if (.not.ma_push_get(mt_dbl,size_2a2m,'2a2m_sort',
     1   l_2a2m_aux,k_2a2m_aux))
     1     call errquit('tce_4ind: step1_1',0,MA_ERR)
        CALL TCE_SORT_4KG_(dbl_mb(k_2a2m),dbl_mb(k_2a2m_aux),
     &   int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1),
     &   nalength(azone2),nalength(azone1),
     &   1,2,4,3,1.0d0)
        do i=1,size_2a2m
         dbl_mb(k_2a2m+i-1)=dbl_mb(k_2a2m_aux+i-1)
        enddo
        if (.not.ma_pop_stack(l_2a2m_aux))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
       end if
c
c  C(imu g2b) ==> l_2g2z
c
      size_amc=int_mb(k_range_alpha+g2b-1) *
     1         nalength(azone2)
      if (.not.ma_push_get(mt_dbl,size_amc,'2g2z',l_2g2z,k_2g2z))
     1    call errquit('tce_r2_divide3: xx-MA problem',0,MA_ERR)
      i=0
      tot_azone2_sh=tot_zone(azone2)
      do igi2=1,int_mb(k_range_alpha+g2b-1)
      do imu1   =  1,nalength(azone2)
       i=i+1
c       ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone1_sh
c     &       +inu1
       ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone2_sh
     &       +imu1
       dbl_mb(k_2g2z+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
      enddo
      enddo
c  v(g4b,g3b,inu,imu) C(imu,g2b)
        if (.not.ma_push_get(mt_dbl,size_1a3m,'1a3m',
     1   l_1a3m_sort,k_1a3m_sort))
     1     call errquit('tce_4ind: step1_1',0,MA_ERR)
c dgemm
      call dgemm('N','N',
     &   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     &   *nalength(azone1),
     &   int_mb(k_range_alpha+g2b-1),
     &   nalength(azone2),
     &   1.0d0,dbl_mb(k_2a2m),
     &   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     &  *nalength(azone1),
     &   dbl_mb(k_2g2z),nalength(azone2),0.0d0,
     &   dbl_mb(k_1a3m_sort),
     &   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     &  *nalength(azone1))
c transpose
        i=0
        do inu1=1,nalength(azone1)
        do igi2=1,int_mb(k_range_alpha+g2b-1)
        do igi3=1,int_mb(k_range_alpha+g3b-1)
        do igi4=1,int_mb(k_range_alpha+g4b-1)
        i=i+1
        ipos1=igi4+int_mb(k_range_alpha+g4b-1)*(
     &   igi3-1+int_mb(k_range_alpha+g3b-1)*(
     &   inu1-1+nalength(azone1)*(igi2-1)))
        dbl_mb(k_1a3m+i-1)=dbl_mb(k_1a3m+i-1)+
     &                     dbl_mb(k_1a3m_sort+ipos1-1)
        enddo
        enddo
        enddo
        enddo
c
        if (.not.ma_pop_stack(l_1a3m_sort))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
        if (.not.ma_pop_stack(l_2g2z))
     1   call errquit('tce_mo2e_trans_zones: uu l_2g2z',15,MA_ERR)
        if (.not.ma_pop_stack(l_2a2m))
     1   call errquit('tce_mo2e_trans_zones: uu l_2g2z',15,MA_ERR)
      ENDDO ! PART2 ends up here ------------------------------------------
c
c
c
c write to file
        key_1a3m= azone1-1+atpart*(g2b-1+(noa+nva)*
     &  (g4b-1+(noa+nva)*(g3b-1)))
         call tce_hash(int_mb(k_1a3m_offset),key_1a3m,offset_1a3m)
       if(idiskl) then !---------
        if (sf_write(i_to_x,dfloat(bytes)*dfloat(offset_1a3m),
     r    dfloat(bytes)*dfloat(size_1a3m),dbl_mb(k_1a3m),request).ne.0)
     2    call errquit('zones put: sf problem21-b',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('zones put: sf problem31-b',2,DISK_ERR)
       else
        call ga_put(i_to_x,offset_1a3m+1,offset_1a3m+size_1a3m,1,1,
     1    dbl_mb(k_1a3m),1)
       end if ! -------------
c
      if (.not.ma_pop_stack(l_1a3m))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)
c
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO
      ENDDO
      ENDDO
      ENDDO
c 1A3P fully done here
      call ga_sync()
      next = nxtval(-nprocs)
c
c
c
c
c
      if(nodezero) then
        write(6,*)'STEP5 4index'
        call util_flush(6)
      end if
c
c
c
c
c 4M starts here
c
c
ccx      if(idiskl) then !----------------
ccx       i_from_x=i_to_x
ccx      else !------------------
ccx        i_from_x=i_to_x
ccx        if(i_from_x.eq.d_max1) then
ccx         i_to_x=d_max2
ccx         d_v2=i_to_x
c size check-out
ccx         if(size_max2.lt.size_2e)
ccx     1     call errquit('tce_4s: 5a',15,MA_ERR)
ccx        else
ccx         i_to_x=d_max1
ccx         d_v2=i_to_x
c size check-out
ccx         if(size_max1.lt.size_2e)
ccx     1     call errquit('tce_4s: 5b',15,MA_ERR)
ccx        end if
ccx      end if !----------------------
c
c DISK CHANGES =============== 4M
c destroying handle_2a2m
c closing/reopening handle_1a3m file
c opening handle_4m file
      if(idiskl) then
c
       if (sf_destroy(handle_2a2m).ne.0)
     1  call errquit('tce_sf_destroy: sf problem handle_2a2m',15,MA_ERR)
c
        if(sf_rwtor(handle_1a3m).ne.0) 
     2    call errquit('4-index: sf_rwtor 1a3m',0,DISK_ERR)
c
        i_from_x=handle_1a3m
      end if
c ============================
c
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
c
      DO g1b = 1,noa+nva      !nu
      DO g2b = g1b,noa+nva   !
      DO g3b = 1,noa+nva   !k
      DO g4b = g3b,noa+nva !l
      IF (next.eq.count) THEN
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &    ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1))))
     &    .eq. irrep_v) THEN
c reversed order
      ICOL=INDEX_PAIR(g4b,g3b)
      IROW=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      IRES=INDEX_PAIR(IROW,ICOL)
      size_4m=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1         *int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g1b-1)
      if (.not.ma_push_get(mt_dbl,size_4m,'4m',l_4m,k_4m))
     1    call errquit('tce_4ind: step1_1',0,MA_ERR)
      call dfill(size_4m, 0.0d0, dbl_mb(k_4m), 1)
c
      call a1_offset(g1b,g2b,g4b,size_ic,
     &           l_a1_offset,k_a1_offset)
      length_a1=int_mb(k_a1_offset)
      DO ii=1,length_a1     ! ii---loop
       a1_ini    = int_mb(k_a1_offset+ii)
       a1_fin    = int_mb(k_a1_offset+length_a1+ii)
       key_ini   = a1_ini-1+atpart*(g4b-1+(noa+nva)*
     &  (g2b-1+(noa+nva)*(g1b-1)))
       call tce_hash(int_mb(k_1a3m_offset),key_ini,offset_bl1a3m)
c
       size_bl1a3m  = int_mb(k_a1_offset+2*length_a1+ii)
       if(idiskl) then ! -------
        if (sf_read(i_from_x,dfloat(bytes)*dfloat(offset_bl1a3m),
     2    dfloat(bytes)*dfloat(size_bl1a3m),
     2    dbl_mb(k_integral),request).ne.0)
     2    call errquit('zones put: sf problem21-b',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('zones put: sf problem31-b',2,DISK_ERR)
       else
        call ga_get(i_from_x,offset_bl1a3m+1,offset_bl1a3m+size_bl1a3m,
     1       1,1,dbl_mb(k_integral),1)
       end if ! -------
      offset_ismall=0
      do i=a1_ini,a1_fin ! over small i ------------------
c  C(azone1 g3b)
      j=0
      tot_azone1_sh=tot_zone(i)
      do igi3=1,int_mb(k_range_alpha+g3b-1)
      do inu1   =  1,nalength(i)
       j=j+1
       ipos1=(int_mb(k_offset_alpha+g3b-1)+igi3-1)*nbf+tot_azone1_sh
     &       +inu1
       dbl_mb(k_coeff+j-1)=dbl_mb(k_movecs_orb+ipos1-1)
      enddo
      enddo
c v(g2b,g1b,g4b,inu)*C(inu g3b)
      call dgemm('N','N',
     &   int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g1b-1)
     &   *int_mb(k_range_alpha+g4b-1),
     &   int_mb(k_range_alpha+g3b-1),
     &   nalength(i),
     &   1.0d0,dbl_mb(k_integral+offset_ismall),
     &   int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g1b-1)
     &  *int_mb(k_range_alpha+g4b-1),
     &   dbl_mb(k_coeff),nalength(i),1.0d0,
     &   dbl_mb(k_4m),
     &   int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g1b-1)
     &  *int_mb(k_range_alpha+g4b-1))
c
      offset_ismall=offset_ismall+nalength(i)
     1       *int_mb(k_range_alpha+g4b-1)
     1       *int_mb(k_range_alpha+g1b-1)*int_mb(k_range_alpha+g2b-1)
c
      enddo ! over small i ----------------------
      ENDDO                 ! ii---loop
        if (.not.ma_pop_stack(l_a1_offset))
     1   call errquit('tce_mo2e_trans_zones: uu l_2g2z',15,MA_ERR)
c
c zapis
c
         key_4m=ires
         call tce_hash_n(int_mb(kax_v2_alpha_offset),key_4m,offset_4m)
      call put_block(d_v2,dbl_mb(k_4m),size_4m,
     &               offset_4m)
c
      if (.not.ma_pop_stack(l_4m))
     1  call errquit('tce_mo2e_trans_zones: abc-MA problem',15,MA_ERR)

      END IF
      END IF
      END IF
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO
      ENDDO
      ENDDO
      ENDDO
c
       call ga_sync()
       next = nxtval(-nprocs)
c
c
c
c
c
c
c
c
c
      if(nodezero) then
      write(6,*)'DONE --- DONE ---- DONE ---- DONE'
      end if
c
      if (.not.ma_pop_stack(l_work2))
     1  call errquit('tce_ao2e: MA problem',14,MA_ERR)
      if (.not.ma_pop_stack(l_work1))
     1  call errquit('tce_ao2e: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_movecs_orb))
     1  call errquit('tce_ao2e: MA problem',15,MA_ERR)
c
c
c DISK CHANGES =============== AFTER 4M
c destroying handle_1a3m
      if(idiskl) then
c
       if (sf_destroy(handle_1a3m).ne.0)
     1  call errquit('tce_sf_destroy: sf problem handle_1a3m',15,MA_ERR)
c
      end if
c ============================
c
c
      if(idiskl) then
c       if (.not.sf_destroy(d_max2))
c     1   call errquit('tce_sf_destroy22: sf problem',15,MA_ERR)
c         if (parallel) call ga_sync()
c       if (.not.sf_destroy(d_max1))
c     1   call errquit('tce_sf_destroy33: sf problem',15,MA_ERR)
c         if (parallel) call ga_sync()
      else
       call deletefile(i_from_x)
       call ga_sync() 
cccx       call deletefile(d_4af)
cccx       call ga_sync()
      end if
c
      if (.not.ma_pop_stack(l_1a3m_offset))
     1  call errquit('tce_off_1a3m: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_2a2m_offset))
     1  call errquit('tce_off_2a2m: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_3a1m_offset))
     1  call errquit('tce_off_3a1m: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_4af_offset))
     1  call errquit('tce_off_4a: MA problem',15,MA_ERR)
c
c
c     closing two large local files
c
      if (.not.ma_pop_stack(l_coeff))
     1  call errquit('tce_off_4a: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_integral))
     1  call errquit('tce_off_4a: MA problem',15,MA_ERR)
c

c
      call ga_sync()
c *** debug ***
c 800  format('DGEMM1 MAX',i5,2x,3f15.5)
c 801  format('DGEMM2 ',i5,2x,3f15.5)
 8153 format('SF_READ ERROR CODE = ',2x,i10)
 8154 format('SF_READ_WAIT ERROR CODE = ',2x,i10)
 8156 format('SF_WRITE ERROR CODE = ',2x,i10)
 8157 format('SF_WRITE_WAIT ERROR CODE = ',2x,i10)
 8155 format('FU',i6,2x,3i20)
 9000 format('PART1',i4,1x,'Cpu  wall ',2(f17.12,1x),3x,'g4b g3b',2i5)
c 9001 format('PART2',i4,1x,'Cpu  wall ',2(f17.12,1x),3x,'g4b g3b',2i5)
c 9003 format('PART1-4a',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9004 format('PART1-2g2z',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9005 format('PART1-dgemm',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9010 format('  P1-mnrs',i3,1x,2i5,1x,2i5,1x,'Cpu  wall ',2(f17.12,1x))
  555  format('atom loop ',2x,i5,3x,2i5,3x,2i5,i12)
  556  format('atom time',2x,i5,3x,2i5,3x,2i5,'Cpu wall ',2(f12.7,1x))
  777  format('main do loop ',2x,i5,3x,2i5,3x,2i5)
  775  format('main loop step1 ',2x,i5,3x,2i5,3x,2i5)
  776  format('main loop step2 ',2x,i5,3x,2i5,3x,2i5)
  778  format('PART1',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',2(f17.12,1x))
  779  format('PART2',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',2(f17.12,1x))
  780  format('ADD BLOCK',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',
     &        2(f17.12,1x))
c *************
c
      RETURN
      END
c
c
c
      SUBROUTINE tce_4a_offsetx2(l_a_offset,k_a_offset,size)
C     $Id: tce_ao2e_cholesky_orb.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER mu
      INTEGER nu
      INTEGER rho
      INTEGER sigma
      INTEGER azone1,azone2,azone3,azone4
      length = 0
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
      DO azone3 = 1,atpart      !sigma
      DO azone4 = azone3,atpart !rho
      length = length + 1
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_t2_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
      DO azone3 = 1,atpart      !sigma
      DO azone4 = azone3,atpart !rho
      addr = addr + 1
      int_mb(k_a_offset+addr) = azone4 - 1 + atpart * (azone3 - 1 + 
     &  atpart * (azone2 - 1 + atpart * (azone1 - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + nalength(azone1) * nalength(azone2) * 
     &  nalength(azone3) * nalength(azone4)
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
c
c
      SUBROUTINE tce_3a1m_offsetx2(l_a_offset,k_a_offset,size)
C     $Id: tce_ao2e_cholesky_orb.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER mu
      INTEGER nu
      INTEGER rho
      INTEGER sigma
      INTEGER azone1,azone2,azone3
      INTEGER g2b
      length = 0
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
      DO g2b    =  1,noa+nva    !g2b
      DO azone3 = 1,atpart      !sigma
      length = length + 1
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_t2_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
      DO g2b    =  1,noa+nva    !g2b
      DO azone3 = 1,atpart      !sigma
      addr = addr + 1
      int_mb(k_a_offset+addr) = azone3-1+atpart*(g2b-1+(noa+nva)*
     &    (azone2 - 1 + atpart * (azone1 - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + nalength(azone1) * nalength(azone2) * 
     &  nalength(azone3) * int_mb(k_range_alpha+g2b-1)
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
c
c
c
c
      SUBROUTINE tce_2a2m_offsetx2(l_a_offset,k_a_offset,size)
C     $Id: tce_ao2e_cholesky_orb.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER g1b,g2b
      INTEGER azone1,azone2
      length = 0
      DO g1b = 1,noa+nva   !k
      DO g2b = g1b,noa+nva !l
      DO azone1 = 1,atpart !nu
      DO azone2 = azone1,atpart !mu
      length = length + 1
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_t2_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO g1b = 1,noa+nva   !k
      DO g2b = g1b,noa+nva !l
      DO azone1 = 1,atpart !nu
      DO azone2 = azone1,atpart !mu
      addr = addr + 1
      int_mb(k_a_offset+addr) = azone2 - 1 + atpart*( azone1 - 1 +
     & atpart*(g2b - 1 + (noa+nva) * (g1b-1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + 
     &   int_mb(k_range_alpha+g1b-1) * int_mb(k_range_alpha+g2b-1)
     &      *  nalength(azone1) * nalength(azone2)
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
c
c
c
      SUBROUTINE tce_1a3m_offsetx2(l_a_offset,k_a_offset,size)
C     $Id: tce_ao2e_cholesky_orb.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER g1b,g2b,g4b
      INTEGER azone1,azone2
      length = 0
      DO g1b = 1,noa+nva   !k
      DO g2b = g1b,noa+nva !l
      DO g4b = 1,noa+nva   !i
      DO azone1 = 1,atpart !nu
      length = length + 1
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_t2_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO g1b = 1,noa+nva   !k
      DO g2b = g1b,noa+nva !l
      DO g4b = 1,noa+nva   !i
      DO azone1 = 1,atpart !nu
      addr = addr + 1
      int_mb(k_a_offset+addr) = azone1-1+atpart*(g4b-1+(noa+nva)*
     &  (g2b-1+(noa+nva)*(g1b-1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + 
     &   int_mb(k_range_alpha+g1b-1) * int_mb(k_range_alpha+g2b-1)
     &      * int_mb(k_range_alpha+g4b-1) *  nalength(azone1)
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
c
      subroutine a4_offset(azone1,azone2,azone3,size_ic,
     &           l_a4_offset,k_a4_offset)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER azone1,azone2,azone3,size_ic,l_a4_offset,k_a4_offset
      INTEGER i,j,k,size_int,length_a4,azone4,a4_ini,a4_fin,offset_a4
      length_a4=0
      size_int=0
      do azone4=azone3,atpart
       size_int=size_int+nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
       if(size_int.gt.size_ic) then
        length_a4=length_a4+1 
        size_int= nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
       end if
      enddo
      if(size_int.ne.0) length_a4=length_a4+1
      IF (.not.MA_PUSH_GET(mt_int,3*length_a4+1,'noname',
     &l_a4_offset,k_a4_offset))
     & CALL ERRQUIT('tce_a4_offset',0,MA_ERR)
      int_mb(k_a4_offset) = length_a4
c     
      i=0 
      a4_ini=azone3 
      size_int=0
      do azone4=azone3,atpart
       size_int=size_int+nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
       if(size_int.gt.size_ic) then
        i=i+1
        int_mb(k_a4_offset+i)=a4_ini
        int_mb(k_a4_offset+length_a4+i)=azone4-1
        int_mb(k_a4_offset+2*length_a4+i)=size_int-
     1            nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
        size_int= nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
        a4_ini=azone4 
       end if
      enddo
      if(size_int.ne.0) then
        i=i+1
        int_mb(k_a4_offset+i)=a4_ini
        int_mb(k_a4_offset+length_a4+i)=atpart
        int_mb(k_a4_offset+2*length_a4+i)=size_int
      end if 
      if(i.ne.length_a4) 
     & CALL ERRQUIT('tce_a4_off problems',0,MA_ERR)
      return 
      end
c
c
c
      subroutine a3_offset(azone1,azone2,g3b,size_ic,
     &           l_a3_offset,k_a3_offset)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER azone1,azone2,g3b,size_ic,l_a3_offset,k_a3_offset
      INTEGER i,j,k,size_int,length_a3,azone3,a3_ini,a3_fin,offset_a3
      length_a3=0
      size_int=0
      do azone3=1,atpart
       size_int=size_int+nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*int_mb(k_range_alpha+g3b-1)
       if(size_int.gt.size_ic) then
        length_a3=length_a3+1 
        size_int= nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*int_mb(k_range_alpha+g3b-1)
       end if
      enddo
      if(size_int.ne.0) length_a3=length_a3+1
      IF (.not.MA_PUSH_GET(mt_int,3*length_a3+1,'noname',
     &l_a3_offset,k_a3_offset))
     & CALL ERRQUIT('tce_a3_offset',0,MA_ERR)
      int_mb(k_a3_offset) = length_a3
c     
      i=0 
      a3_ini=1
      size_int=0
      do azone3=1,atpart
       size_int=size_int+nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*int_mb(k_range_alpha+g3b-1)
       if(size_int.gt.size_ic) then
        i=i+1
        int_mb(k_a3_offset+i)=a3_ini
        int_mb(k_a3_offset+length_a3+i)=azone3-1
        int_mb(k_a3_offset+2*length_a3+i)=size_int-
     1            nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*int_mb(k_range_alpha+g3b-1)
        size_int= nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*int_mb(k_range_alpha+g3b-1)
        a3_ini=azone3 
       end if
      enddo
      if(size_int.ne.0) then
        i=i+1
        int_mb(k_a3_offset+i)=a3_ini
        int_mb(k_a3_offset+length_a3+i)=atpart
        int_mb(k_a3_offset+2*length_a3+i)=size_int
      end if 
      if(i.ne.length_a3) 
     & CALL ERRQUIT('tce_a3_off problems',0,MA_ERR)
      return 
      end
c
c
c
      subroutine a2_offset(azone1,g4b,g3b,size_ic,
     &           l_a2_offset,k_a2_offset)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER azone1,g4b,g3b,size_ic,l_a2_offset,k_a2_offset
      INTEGER i,j,k,size_int,length_a2,azone2,a2_ini,a2_fin,offset_a2
      length_a2=0
      size_int=0
      do azone2=azone1,atpart
       size_int=size_int+nalength(azone1)*nalength(azone2)*
     1           int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
       if(size_int.gt.size_ic) then
        length_a2=length_a2+1 
        size_int= nalength(azone1)*nalength(azone2)*
     1         int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
       end if
      enddo
      if(size_int.ne.0) length_a2=length_a2+1
      IF (.not.MA_PUSH_GET(mt_int,3*length_a2+1,'noname',
     &l_a2_offset,k_a2_offset))
     & CALL ERRQUIT('tce_a2_offset',0,MA_ERR)
      int_mb(k_a2_offset) = length_a2
c     
      i=0 
      a2_ini=azone1
      size_int=0
      do azone2=azone1,atpart
       size_int=size_int+nalength(azone1)*nalength(azone2)*
     1          int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
       if(size_int.gt.size_ic) then
        i=i+1
        int_mb(k_a2_offset+i)=a2_ini
        int_mb(k_a2_offset+length_a2+i)=azone2-1
        int_mb(k_a2_offset+2*length_a2+i)=size_int-
     1            nalength(azone1)*nalength(azone2)*
     1       int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
        size_int= nalength(azone1)*nalength(azone2)*
     1       int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
        a2_ini=azone2 
       end if
      enddo
      if(size_int.ne.0) then
        i=i+1
        int_mb(k_a2_offset+i)=a2_ini
        int_mb(k_a2_offset+length_a2+i)=atpart
        int_mb(k_a2_offset+2*length_a2+i)=size_int
      end if 
      if(i.ne.length_a2) 
     & CALL ERRQUIT('tce_a2_off problems',0,MA_ERR)
      return 
      end
c
c
c
      subroutine a1_offset(g1b,g2b,g3b,size_ic,
     &           l_a1_offset,k_a1_offset)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER g1b,g2b,g3b,size_ic,l_a1_offset,k_a1_offset
      INTEGER i,j,k,size_int,length_a1,azone1,a1_ini,a1_fin,offset_a1
      length_a1=0
      size_int=0
      do azone1=1,atpart
       size_int=size_int+nalength(azone1)*int_mb(k_range_alpha+g1b-1)*
     1          int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g3b-1)
       if(size_int.gt.size_ic) then
        length_a1=length_a1+1 
        size_int= nalength(azone1)*int_mb(k_range_alpha+g1b-1)*
     1        int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g3b-1)
       end if
      enddo
      if(size_int.ne.0) length_a1=length_a1+1
      IF (.not.MA_PUSH_GET(mt_int,3*length_a1+1,'noname',
     &l_a1_offset,k_a1_offset))
     & CALL ERRQUIT('tce_a1_offset',0,MA_ERR)
      int_mb(k_a1_offset) = length_a1
c       
      i=0 
      a1_ini=1
      size_int=0
      do azone1=1,atpart
       size_int=size_int+nalength(azone1)*int_mb(k_range_alpha+g1b-1)*
     1        int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g3b-1)
       if(size_int.gt.size_ic) then
        i=i+1
        int_mb(k_a1_offset+i)=a1_ini
        int_mb(k_a1_offset+length_a1+i)=azone1-1
        int_mb(k_a1_offset+2*length_a1+i)=size_int-
     1        nalength(azone1)*int_mb(k_range_alpha+g1b-1)*
     1        int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g3b-1)
        size_int=nalength(azone1)*int_mb(k_range_alpha+g1b-1)*
     1        int_mb(k_range_alpha+g2b-1)*int_mb(k_range_alpha+g3b-1) 
        a1_ini=azone1 
       end if
      enddo
      if(size_int.ne.0) then
        i=i+1
        int_mb(k_a1_offset+i)=a1_ini
        int_mb(k_a1_offset+length_a1+i)=atpart
        int_mb(k_a1_offset+2*length_a1+i)=size_int
      end if 
      if(i.ne.length_a1) 
     & CALL ERRQUIT('tce_a1_off problems',0,MA_ERR)
      return 
      end

* $Id: time.f 19696 2010-10-29 16:53:42Z d3y133 $
      SUBROUTINE txs_SECOND(T)
      common /intgop/ ncache,maxprice,iprint,iblock
      double precision T
c     REAL*8 T
      double precision util_cpusec
      external util_cpusec
*
*     rjh ... no point timing if not printing
*
      t = 0.d0
      if (iprint .le. 0) return
*
C      DIMENSION ITIME(4) 
C     I1=TIMES(ITIME)
C     WRITE(*,*) ITIME
C     T=DBLE(ITIME(1)+ITIME(2)+ITIME(3)+ITIME(4))/100.0D0         
C      T=MCLOCK()/100.0D0
      T = util_cpusec()
C  
      RETURN
      END
C
*rak:      SUBROUTINE FDATE(X)
*rak:      CHARACTER*24 BLANK,X
*rak:      DATA BLANK /'                        '/
*rak:      X=BLANK
*rak:      END

      logical function argos_prepare_pdbsiz(iunit,filnam,lfnout,
     + model,natm,nseq,nssb,nlnk,namslv,numslv,altloc,chain)
c
c $Id: argos_prepare_pdbsiz.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to read dimensions from a pdb formatted file
c
c     in  : iunit  = pdb file logical file number
c           filnam = pdb file name
c           lfnout = output file logical file number
c           model  = model number
c
c     out : natm = number of atoms
c           nseq = number of segments
c           nssb = number of SS bonds
c           nlnk = number of other links
c
c     return value:
c          .false. : specified file does not exist or an error
c                    occurred during reading
c          .true.  : specified file read succesfully
c
      implicit none
c
#include "util.fh"
c
      integer iunit,lfnout,model,natm,nseq,nssb,nchain,nlnk
      character*255 filnam
      integer numslv,lrgpdb
      character*3 namslv
      character*1 ,altloc,chain,pchain
c
      character*80 card
      integer length,mdl,nsgm,isgm,i,ioff
      logical lslvnt
c
      natm=0
      nseq=0
      nssb=0
      nchain=0
      mdl=0
      isgm=0
      nsgm=0
      nlnk=0
      ioff=0
      lslvnt=.false.
      numslv=0
      pchain=' '
      lrgpdb=0
c
      length=index(filnam,' ')-1
c
      if(util_print('where',print_debug)) then
      write(lfnout,2006) filnam(1:length)
 2006 format(/,'pdb_size  ',a)
      endif
c
      open(iunit,file=filnam(1:length),form='formatted',
     + status='old',err=9999)
c
      if(util_print('where',print_debug)) then
      write(lfnout,2000) filnam(1:length)
 2000 format(' PDB OPEN  ',a)
      endif
c
    1 continue
c
      read(iunit,1000,end=999,err=9999) card
 1000 format(a)
c
c     lrgpdb option
c
      if(card(1:6).eq.'LRGPDB') then
      lrgpdb=1
      goto 1
      endif
c
c     MODEL
c
      if(model.ne.mdl) then
      if(card(1:6).eq.'MODEL ') then
      read(card(7:14),1002) mdl
 1002 format(i8)
      if(model.eq.mdl.and.util_print('where',print_high)) then
      write(lfnout,2005) model
 2005 format(10x,'MODEL ',i8)
      endif
      goto 1
      endif
      endif
c
c     END and ENDMDL
c
c
      if(card(1:6).eq.'ENDMDL') then
      if(model.eq.mdl) goto 9
      goto 1
      endif
      if(card(1:6).eq.'END   ') goto 9
c
c     HEADER
c
      if(card(1:6).eq.'HEADER') then
      if(util_print('where',print_debug)) then
      write(lfnout,2001) card
 2001 format(10x,a)
      endif
      goto 1
      endif
c
c     FORMUL
c
      if(card(1:6).eq.'FORMUL'.and.card(19:19).eq.'*') then
      namslv=card(13:15)
      endif
c
c     SEQRES
c
      if(card(1:6).eq.'SEQRES') then
      read(card(14:17),1001) nseq
 1001 format(i4)
      goto 1
      endif
c
c     SSBOND
c
      if(card(1:6).eq.'SSBOND') then
      nssb=nssb+1
      goto 1
      endif
c
c     LINK
c
      if(card(1:6).eq.'LINK  ') then
      nlnk=nlnk+1
      goto 1
      endif
c
c     ATOM
c
      if(card(1:4).eq.'ATOM') then
      if(card(17:17).ne.' '.and.
     + card(17:17).ne.altloc.and.altloc.ne.'*') goto 1
      if(card(22:22).ne.' '.and.
     + card(22:22).ne.chain.and.chain.ne.'*') goto 1
      if(mdl.eq.model) then
      if(card(18:20).eq.namslv) lslvnt=.true.
      if(.not.lslvnt) natm=natm+1
      if(lrgpdb.eq.0) then
      read(card(23:26),1003) i
 1003 format(i4)
      else
      read(card(21:26),1023) i
 1023 format(i6)
      endif
      if(i.ne.isgm.or.card(22:22).ne.pchain) then
      if(i+ioff.lt.isgm) ioff=isgm+1-i
      isgm=i+ioff
      if(lslvnt) then
      numslv=numslv+1
      else
      nsgm=nsgm+1
      nchain=nchain+1
      endif
      endif
      pchain=card(22:22)
      endif
      goto 1
      endif
c
c     HETATM
c
      if(card(1:6).eq.'HETATM') then
      if(card(17:17).ne.' '.and.
     + card(17:17).ne.altloc.and.altloc.ne.'*') goto 1
      if(card(22:22).ne.' '.and.
     + card(22:22).ne.chain.and.chain.ne.'*') goto 1
      if(mdl.eq.model) then
      if(card(18:20).eq.namslv) lslvnt=.true.
      if(.not.lslvnt) natm=natm+1
      read(card(23:26),1004) i
 1004 format(i4)
      if(i.ne.isgm.or.card(22:22).ne.pchain) then
      isgm=i
      if(lslvnt) then
      numslv=numslv+1
      else
      nsgm=nsgm+1
      nchain=nchain+1
      endif
      endif
      pchain=card(22:22)
      endif
      goto 1
      endif
c
c     TER
c
      if(card(1:6).eq.'TER   ') then
      nchain=0
      endif
c
      goto 1
c
  999 continue
c
      if(util_print('where',print_high)) then
      write(lfnout,2004)
 2004 format('PDB EOF encountered')
      endif
c
    9 continue
c
      close(iunit)
c
      if(nsgm.gt.nseq) then
      nseq=nsgm
      if(util_print('where',print_debug)) then
      write(lfnout,2008)
 2008 format(10x,'number of segments read from ATOM cards')
      endif
      endif
c
      if(util_print('where',print_high)) then
      write(lfnout,2002) filnam(1:length),natm,nseq,nssb,numslv
 2002 format(' PDB file',t40,a,/,
     + ' Number of atoms',t40,i10,/,
     + ' Number of segments',t40,i10,/,
     + ' Number of SS-bonds',t40,i10,/,
     + ' Number of solvent molecules',t40,i10,/)
      endif
c
      argos_prepare_pdbsiz=.true.
      return
c
 9999 continue
c
      if(util_print('where',print_none)) then
      write(lfnout,2003) filnam(1:length)
 2003 format('PDB ERROR ',a)
      endif
c
      argos_prepare_pdbsiz=.false.
      return
      end

      subroutine cf_rdgeom(snam)
c $Id: cf_rdgeom.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "cf_common.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "geom.fh"
c
      real*8 releps,c(3),q,w
      character*16 tag,snam(nsatot)
      integer natyps,nqtyps,igeom
c
      real*8 rdata(9),vadata(6),vrdata(6)
      integer idata(16)
      character*6 cdata(3)
      integer i,j,itemp(4)
      integer naw,nbw,nhw,ndw,now,ntw,nnw
      integer nas,nbt,nhs,nds,nos,nts,nxs
      integer numbl,numbi,numbd
c
      logical lstate
c
      lstate=rtdb_parallel(.false.)
c
      if(me.eq.0) then
c
      nwc=0
      nsc=0
      nmult(1)=0
      nmult(2)=0
      nmult(3)=0
      nmult(4)=0
c
      q14fac=one
      releps=one
      qfac=sqrt(1.389354428d+02/releps)
      natyps=nsatot
      nqtyps=nsatot
c
      call cf_inita(natyps,4,nqtyps,4)
c
      if(.not.geom_create(igeom,'geometry'))
     + call md_abort('cf_rdgeom: geom_create failed',0)
      if(.not.geom_rtdb_load(irtdb,igeom,'geometry'))
     + call md_abort('cf_rdgeom: geom_rtdb_load failed',0)
      if(.not.geom_ncent(igeom,nsa))
     + call md_abort('cf_rdgeom: geom_ncent failed',0)
c
      do 1 i=1,natyps
      if(.not.geom_cent_get(igeom,i,tag,c,q))
     + call md_abort('cf_rdgeom: geom_cent_get failed',i)
      if(.not.geom_mass_get(igeom,i,w))
     + call md_abort('cf_rdgeom: geom_mass_get failed',i)
      snam(i)='      '//tag(1:10)
      do 2 j=1,3
      cdata(j)=tag(1:6)
      rdata(j)=w
      idata(j)=int(q)
      vadata(2*j-1)=q
      vadata(2*j)=0.0d0
    2 continue
      call cf_para(i,cdata(1),rdata(1),idata(1))
      call cf_parq(i,vadata)
    1 continue
      if(.not.geom_destroy(igeom))
     + call md_abort('arg_rdqdim: geom_destroy failed',0)
c
      do 3 i=1,6
      vadata(i)=0.0d0
      vrdata(i)=0.0d0
    3 continue
      do 4 i=1,natyps
      do 5 j=i,natyps
      call cf_parv(i,j,vadata,vrdata)
    5 continue
    4 continue
c
      naw=0
      nbw=0
      nhw=0
      ndw=0
      now=0
      ntw=0
      nnw=0
      call cf_initb(1,1,nbw,2,nhw,2,ndw,3,now,3,ntw,2,nnw,2,naw)
c
      nas=nsatot
      nbt=0
      nhs=0
      nds=0
      nos=0
      nts=0
      nxs=0
      call cf_initb(2,nas,nbt,2,nhs,2,nds,3,nos,3,nts,2,nxs,2,0)
c
      ewc(1)=0.0d0
      ewc(2)=0.0d0
      ewc(3)=0.0d0
c
      endif
c
      lstate=rtdb_parallel(.true.)
c
      if(np.gt.1) then
c
      numbl=ma_sizeof(mt_log,1,mt_byte)
      numbi=ma_sizeof(mt_int,1,mt_byte)
      numbd=ma_sizeof(mt_dbl,1,mt_byte)
c
c     broadcast dimensions
c
      idata(1)=natyps
      idata(2)=nqtyps
      idata(3)=nbw
      idata(4)=nhw
      idata(5)=ndw
      idata(6)=now
      idata(7)=ntw
      idata(8)=nnw
      idata(9)=naw
      idata(10)=nas
      idata(11)=nbt
      idata(12)=nhs
      idata(13)=nds
      idata(14)=nos
      idata(15)=nts
      idata(16)=nxs
      call ga_brdcst(mcf_01,idata,16*numbi,0)
      natyps=idata(1)
      nqtyps=idata(2)
      nbw=idata(3)
      nhw=idata(4)
      ndw=idata(5)
      now=idata(6)
      ntw=idata(7)
      nnw=idata(8)
      naw=idata(9)
      nas=idata(10)
      nbt=idata(11)
      nhs=idata(12)
      nds=idata(13)
      nos=idata(14)
      nts=idata(15)
      nxs=idata(16)
c
c     initialize on nodes other than 0
c
      if(me.ne.0) then
      call cf_inita(natyps,4,nqtyps,4)
      call cf_initb(1,1,nbw,2,nhw,2,ndw,3,now,3,ntw,2,nnw,2,naw)
      call cf_initb(2,nas,nbt,2,nhs,2,nds,3,nos,3,nts,2,nxs,2,0)
      endif
c
c     broadcast force field parameters
c
c      call ga_brdcst(mcf_02,byte_mb(i_nam),16*mat,0)
c
      call ga_brdcst(mcf_02,int_mb(i_typ),3*mat,0)
      call ga_brdcst(mcf_03,dbl_mb(i_mas),6*mat*numbd,0)
      call ga_brdcst(mcf_04,int_mb(i_num),3*mat*numbi,0)
      call ga_brdcst(mcf_05,dbl_mb(i_vdw),6*mat*mat*map*numbd,0)
      call ga_brdcst(mcf_06,dbl_mb(i_chg),6*mqt*mqp*numbd,0)
      call ga_brdcst(mcf_07,int_mb(i_iwa),mwa*numbi,0)
      call ga_brdcst(mcf_08,int_mb(i_iwq),mwa*numbi,0)
      call ga_brdcst(mcf_09,int_mb(i_ibnd(1)),4*mbt(1)*numbi,0)
      call ga_brdcst(mcf_10,int_mb(i_ibnd(2)),4*mbt(2)*numbi,0)
      call ga_brdcst(mcf_11,dbl_mb(i_bnd(1)),6*mbp(1)*mbt(1)*numbd,0)
      call ga_brdcst(mcf_12,dbl_mb(i_bnd(2)),6*mbp(2)*mbt(2)*numbd,0)
      call ga_brdcst(mcf_13,int_mb(i_iang(1)),5*mht(1)*numbi,0)
      call ga_brdcst(mcf_14,int_mb(i_iang(2)),5*mht(2)*numbi,0)
      call ga_brdcst(mcf_15,dbl_mb(i_ang(1)),6*mhp(1)*mht(1)*numbd,0)
      call ga_brdcst(mcf_16,dbl_mb(i_ang(2)),6*mhp(2)*mht(2)*numbd,0)
      call ga_brdcst(mcf_17,int_mb(i_idih(1)),6*mdt(1)*numbi,0)
      call ga_brdcst(mcf_18,int_mb(i_idih(2)),6*mdt(2)*numbi,0)
      call ga_brdcst(mcf_19,dbl_mb(i_dih(1)),6*mdp(1)*mdt(1)*numbd,0)
      call ga_brdcst(mcf_20,dbl_mb(i_dih(2)),6*mdp(2)*mdt(2)*numbd,0)
      call ga_brdcst(mcf_21,int_mb(i_iimp(1)),6*mit(1)*numbi,0)
      call ga_brdcst(mcf_22,int_mb(i_iimp(2)),6*mit(2)*numbi,0)
      call ga_brdcst(mcf_23,dbl_mb(i_imp(1)),6*mip(1)*mit(1)*numbd,0)
      call ga_brdcst(mcf_24,dbl_mb(i_imp(2)),6*mip(2)*mit(2)*numbd,0)
      call ga_brdcst(mcf_25,int_mb(i_itrd(1)),2*(mtt(1)+1)*numbi,0)
      call ga_brdcst(mcf_26,int_mb(i_itrd(2)),2*(mtt(2)+1)*numbi,0)
      call ga_brdcst(mcf_27,int_mb(i_ixcl(1)),2*(mxt(1)+1)*numbi,0)
      call ga_brdcst(mcf_28,int_mb(i_ixcl(2)),2*(mxt(2)+1)*numbi,0)
      call ga_brdcst(mcf_29,nmult,4*numbi,0)
      call ga_brdcst(mcf_30,ith,24*numbl,0)
      call ga_brdcst(mcf_31,ip2,24*numbl,0)
      call ga_brdcst(mcf_32,ip3,24*numbl,0)
      call ga_brdcst(mcf_56,qfac,numbd,0)
c
      do 6 i=1,nsatot
      tag=snam(i)
      call util_char_ga_brdcst(mcf_66,tag,0)
      if(me.ne.0) snam(i)=tag
    6 continue
c
c      call ga_brdcst(mcf_66,byte_mb(i_snam),16*nsatot,0)
c
c      if(lanal) then
c      call ana_select(byte_mb(i_snam))
c      call ana_initx()
c      endif
c
      itemp(1)=nwc
      itemp(2)=nsc
      call ga_brdcst(mcf_33,itemp,2*ma_sizeof(mt_int,1,mt_byte),0)
      nwc=itemp(1)
      nsc=itemp(2)
c
      endif
c
      mmult=2*nmult(1)+3*nmult(2)+4*(nmult(3)+nmult(4))
      mmuli=nmult(1)+nmult(2)+nmult(3)+nmult(4)
      if(mmult.gt.0) then
      if(.not.ma_push_get(mt_int,mmuli,'ixmul',l_ixmul,i_ixmul))
     + call md_abort('Failed to allocate memory for ixmul',0)
      if(.not.ma_push_get(mt_int,4*mmult,'imul',l_imul,i_imul))
     + call md_abort('Failed to allocate memory for imul',0)
      if(.not.ma_push_get(mt_dbl,3*mmult,'xmul',l_xmul,i_xmul))
     + call md_abort('Failed to allocate memory for xmul',0)
      if(.not.ma_push_get(mt_dbl,3*mmult,'fmul',l_fmul,i_fmul))
     + call md_abort('Failed to allocate memory for fmul',0)
      call cf_lstmul(int_mb(i_ixmul),int_mb(i_imul),
     + mbt(2),int_mb(i_ibnd(2)),mht(2),int_mb(i_iang(2)),
     + mdt(2),int_mb(i_idih(2)),mit(2),int_mb(i_iimp(2)))
      endif
c
      factmw=zero
      factms=zero
      factmp=zero
      if(nwm*(3*nwa-nwc)-3*islow.gt.0)
     + factmw=two/(rgas*dble(nwm*(3*nwa-nwc)-3*islow))
      if(3*nsa-nsc-3*islow.gt.0)
     + factms=two/(rgas*dble(3*nsa-nsc-3*islow))
      if(nwm*(3*nwa-nwc)+3*nsa-nsc-3*islow.gt.0)
     + factmp=two/(rgas*dble(nwm*(3*nwa-nwc)+3*nsa-nsc-3*islow))
c
      return
      end

* $Id: precalc2.F 24693 2013-10-23 21:23:26Z bert $
c--------------------------------------------------------------------
      subroutine prec2ij(ibl,nblock1, bl,inx)
      implicit real*8 (a-h,o-z)
#include "mafdecls.fh"
      common /route/ iroute
      common /infob/ inuc,ibas,na,nbf,nsh,ncf,ncs
      common /primij/ iabprim, ijdim ,ijpar1 
      common /time0/ tprec2
c
      common /map4uniq/ nij_uniqe, ij_uniqe_p, map_ij,
     *                  nkl_uniqe, kl_uniqe_p, map_kl
c
      dimension bl(*)
      dimension inx(12,*)
      dimension nblock1(*)
c---------------------------------------
      call txs_second(tprec2b)
c---------------------------------------
c get : nij_uniqe=no of unique pairs and the pointer to the list
c
c10   call get_uniq(ibl,nij_uniqe,ij_uniqe_p,bl)
c
c nij_uniqe = number of uniqe pairs in ibl block of pairs
c (no of present pairs)
c ij_uniqe_p = pointer to the list
c---------------------------------------
      call dimenij(ibl,inx,nij_uniqe,nblock1,ijdim,ijcont)
c---------------------------------------
      IF( iroute.eq.1 ) THEN
         call getmem(3*ijdim,iabprim)
         call ab_prim_1(ibl, dbl_mb(inuc),dbl_mb(ibas),inx,
     *                  bl(iabprim),ijcont,
     *                  nij_uniqe,bl(ij_uniqe_p) )
      ELSE
         call getmem(2*ijcont+ijdim,iabprim)
         iapb =iabprim
         i1apb=iabprim+ijcont
         isab =iabprim+ijcont*2
         call ab_prim_2(ibl, dbl_mb(inuc),dbl_mb(ibas),inx,
     *                  bl(iapb),bl(i1apb),bl(isab),ijcont,
     *                  nij_uniqe,bl(ij_uniqe_p) ) 
      ENDIF
c---------------------------------------
      call txs_second(tprec2e)
      tprec2=tprec2+tprec2e-tprec2b
c---------------------------------------
      end
c=======================
      subroutine prec2kl(kbl,nblock1, bl,inx)
      implicit real*8 (a-h,o-z)
#include "mafdecls.fh"
      common /route/ iroute
      common /infob/ inuc,ibas,na,nbf,nsh,ncf,ncs
      common /primkl/ kabprim, kldim ,klpar1 
      common /time0/ tprec2
c
      common /map4uniq/ nij_uniqe, ij_uniqe_p, map_ij,
     *                  nkl_uniqe, kl_uniqe_p, map_kl
c
      dimension bl(*)
      dimension inx(12,*)
      dimension nblock1(*)
c---------------------------------------
      call txs_second(tprec2b)
c---------------------------------------
c10   call get_uniq(kbl,nkl_uniqe,kl_uniqe_p,bl)
c---------------------------------------
      call dimenij(kbl,inx,nkl_uniqe,nblock1,kldim,klcont)
c---------------------------------------
      IF( iroute.eq.1 ) THEN
         call getmem(3*kldim,kabprim)
         call ab_prim_1(kbl, dbl_mb(inuc),dbl_mb(ibas),inx,
     *                  bl(kabprim),klcont,
     *                  nkl_uniqe,bl(kl_uniqe_p) )
      ELSE
         call getmem(2*klcont+kldim,kabprim)
         icpd =kabprim
         i1cpd=kabprim+klcont
         iscd =kabprim+klcont*2
         call ab_prim_2(kbl,dbl_mb(inuc),dbl_mb(ibas),inx,
     *                  bl(icpd),bl(i1cpd),bl(iscd),klcont,
     *                  nkl_uniqe,bl(kl_uniqe_p) )
      ENDIF
c---------------------------------------
      call txs_second(tprec2e)
      tprec2=tprec2+tprec2e-tprec2b
c---------------------------------------
      end
c====================================================================
      subroutine dimenij(ibl,inx,nparij,nblock1,ijdim,ijcont)
      dimension inx(12,*),nblock1(*)   ! (0:ncs)
c
      call get_ics_jcs(nblock1,ibl,1,ics1,jcs1)
c
      icont=inx(5,ics1)-inx(1,ics1)
      jcont=inx(5,jcs1)-inx(1,jcs1)
      ijcont=icont*jcont
      ijdim=nparij*ijcont
c
      end
c====================================================================
      subroutine precdiag
      implicit real*8 (a-h,o-z)
c---------------------------------------------------------------
      common /route/ iroute
      common /memor5x/ ieab,iecd
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c---------------------------------------------------------------
c* for a diagonal case : npklx=0
c
c* since this is for a diagonal block
c* pairs IJ and KL are the same
c
      ixcd=ixab
      ixq =ixp
      ixqn=ixpn
      ixqq=ixpp
c   
      icpd=iapb
      i1cpd=i1apb
      ickl=icij
      ifkl=ifij
      iscd=isab
c
      icc=iaa
      idd=ibb
c
      icks=icis
      icls=icjs
c
      iecd=ieab
c
      itxcd=itxab
c
      icdnia=iabnia
c-----------------------------------
      IF( iroute.eq.1 ) THEN
        igck=igci
        igcl=igcj
      ELSE
        igckl=igcij
      ENDIF
c-----------------------------------
      end
c====================================================================
      subroutine ab_prim_1(ibl, datnuc,datbas,inx, abprim,ijcont,
     *                     nij_uniqe,ij_uniqe )
      implicit real*8 (a-h,o-z)
      common /number/ zero,half,one,two,three,four,five,ten,ten6,tenm8,p
     1i,acc
c
      dimension inx(12,*)
      dimension datbas(13,*),datnuc(5,*)
      dimension abprim(nij_uniqe,ijcont,3)
      dimension ij_uniqe(nij_uniqe) 
c---------------------------------------------------------------
ctest
c     write(6,*)' from ab_prim : ibl=',ibl,' nij_uniqe=',nij_uniqe
c     call prt_uniqe(ij_uniqe,nij_uniqe)
c     call prt_uniqe(ibl,ij_uniqe,nij_uniqe,1111     )
c     write(6,*)' from ab_prim : ij1=',ij1,' ij2=',ij2   
ctest
c
cccc  do 100 ijpar=1,nparij
cccc  ijcs=ijbl(ibl,ijpar)
cnew 
c
      do 100 ijpar =1,nij_uniqe   ! over uniqe pairs 
c
      ijcs=ij_uniqe(ijpar)
      call get_ij_half(ijcs,ics,jcs)
c
      ia=inx(1,ics)+1
      ie=inx(5,ics)
      iat=inx(2,ics)
        ja=inx(1,jcs)+1
        je=inx(5,jcs)
        jat=inx(2,jcs)
c
c center23 (atom number 0 is the one with s-orbital/zero-exp.)
c
        if(iat.eq.0) iat=jat
        if(jat.eq.0) jat=iat
c
        if(iat.eq.0 .and. jat.eq.0) then
           xab=zero
           yab=zero
           zab=zero
        else
           xab=datnuc(2,iat)-datnuc(2,jat)
           yab=datnuc(3,iat)-datnuc(3,jat)
           zab=datnuc(4,iat)-datnuc(4,jat)
        endif
c
        rr=xab*xab+yab*yab+zab*zab
c
        ij=0
           do 200 is=ia,ie
           aa=datbas(1,is)
c----------------------------------
             do 200 js=ja,je
             bb=datbas(1,js)
             ij=ij+1
c----------------------------------
c Sab=(a*b)**3/4 * (a+b)**-1 * exp( -ab/(a+b) * Rab**2)
c
             if(aa.gt.zero .and. bb.gt.zero) then
cold            axb=aa*bb
cold            apb=aa+bb
cold            apb1=one/apb
cold            e=axb*apb1
cold            abprim(ijpar,ij,1)=apb
cold            abprim(ijpar,ij,2)=apb1
cold            abprim(ijpar,ij,3)=apb1*sqrt(sqrt(axb))**3*exp(-e*rr)
cnew98.......................................................
c
                axb=aa*bb
                apb=aa+bb
                apb1=one/apb
                e=axb*apb1
c98
                err=e*rr
                if(err.gt.46) then ! was 32  exp(-32)=1.27*10**-14
                   exp_err=0.d0         ! exp(-46) = 1e-20
                else
                   exp_err=exp(-err)
                endif
c98
                abprim(ijpar,ij,1)=apb
                abprim(ijpar,ij,2)=apb1
                abprim(ijpar,ij,3)=apb1*sqrt(sqrt(axb))**3*exp_err
cnew98.......................................................
             else
c center23:
                if(aa.le.zero .and. bb.gt.zero) then
c>>>>>>>>>         write(8,*)' exp_a=zero ; ics=',ics
                   apb=aa+bb
                   apb1=one/apb
                   abprim(ijpar,ij,1)=apb
                   abprim(ijpar,ij,2)=apb1
c>>*a-3/4          abprim(ijpar,ij,3)=     sqrt(bb)             !Sbb
                   abprim(ijpar,ij,3)=one/sqrt(sqrt(bb))   !sqrt(Sbb)
                endif
                if(aa.gt.zero .and. bb.le.zero) then
c>>>>>>>>          write(8,*)' exp_b=zero ; jcs=',jcs
                   apb=aa+bb
                   apb1=one/apb
                   abprim(ijpar,ij,1)=apb
                   abprim(ijpar,ij,2)=apb1
c>>>>>>>>>>>>      abprim(ijpar,ij,3)=sqrt(sqrt(aa)) ! sqrt(Saa)
c>>*a-3/4          abprim(ijpar,ij,3)=     sqrt(aa)             !Saa
                   abprim(ijpar,ij,3)=one/sqrt(sqrt(aa))   !sqrt(Saa)
                endif
                if(aa.le.zero .and. bb.le.zero) then
                   abprim(ijpar,ij,1)=zero
                   abprim(ijpar,ij,2)=zero
                   abprim(ijpar,ij,3)=zero
                endif
             endif
c----------------------------------
  200     continue
  100 continue
      end
c============================================================
      subroutine precalc2_1(isupb,bl,mmax,mmax1,nhabcd,nfumax,
     *                      nbl2,nbls, inx,ibl,kbl,npkl) 
c
c  npkl=ndiag 
c
      implicit real*8 (a-h,o-z)
#include "mafdecls.fh"
c-----------------------------------------------------------
      common /primij/ iabprim, ijdim ,ijpar1
      common /primkl/ kabprim, kldim ,klpar1
      common /ilepar/ lpar_exe,lpar_num
c
      common /infob/ inuc,ibas,na,nbf,nsh,ncf,ncs
c
      common /types/itype,jtype,ktype,ltype,itype1,jtype1,ktype1,ltype1 
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
      common /gcont/ ngci1,ngcj1,ngck1,ngcl1,ngcd
c
      common /memor5x/ ieab,iecd
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5d/ iabnix,icdnix,ixpnx,ixqnx,ihabcdx
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c
      common /map4uniq/ nij_uniqe, ij_uniqe_p, map_ij,
     *                  nkl_uniqe, kl_uniqe_p, map_kl
c
      dimension bl(*), inx(12,*)
c---------------------------------------------------------------
c precalculations for pairs ij
c
      call precal2x_1(iabprim,ijdim,iapb,i1apb,isab)
c--------
      lpar_exe=lpar_exe+1
      lpar_num=lpar_num+nij_uniqe
      call precal2a_1(dbl_mb(ibas),dbl_mb(inuc),inx, ibl, nbl2,
     *              bl(iabprim      ),
     *              lcij,bl(iaa),bl(ibb),bl(ieab),bl(icis),bl(icjs),
     *              bl(ixab),bl(ixp),bl(icij),bl(ifij), bl(itxab),
     *              bl(igci),bl(igcj),ngci1,ngcj1,'left ',
     *              nij_uniqe,bl(ij_uniqe_p) )
c----------
c for abnia
      if(mmax.gt.2) then
         call precal2b_1(mmax1,lcij, bl(i1apb), bl(iabnia),
     *                   nij_uniqe,bl(ij_uniqe_p) )
      endif
c----------------------------------------
c precalculations for pairs kl
c
c10   if(kbl.eq.ibl) then
c10       kabprim=iabprim
c10       kldim  =ijdim
c10   endif
c10   if(npkl.ne.0) then
          call precal2x_1(kabprim,kldim,icpd,i1cpd,iscd)
c
          lpar_exe=lpar_exe+1
          lpar_num=lpar_num+nkl_uniqe
          call precal2a_1(dbl_mb(ibas),dbl_mb(inuc),inx,kbl,nbl2,
     *                  bl(kabprim      ),
     *                  lckl,bl(icc),bl(idd),bl(iecd),bl(icks),bl(icls),
     *                  bl(ixcd),bl(ixq),bl(ickl),bl(ifkl), bl(itxcd),
     *                  bl(igck),bl(igcl),ngck1,ngcl1,'right',
     *                  nkl_uniqe,bl(kl_uniqe_p) )
c--
c for cdnia
         if(mmax.gt.2) then
            call precal2b_1(mmax1,lckl,bl(i1cpd), bl(icdnia),
     *                      nkl_uniqe,bl(kl_uniqe_p))
         endif
c10   else
c10       call precdiag
c10   endif
c----------------------------------------
c for habcd
c
      if(mmax.gt.2) then
         call precal2c_1(bl(i1apb),bl(i1cpd),bl(ihabcd),nhabcd,nfumax,
     *               nij_uniqe,bl(ij_uniqe_p),nkl_uniqe,bl(kl_uniqe_p))
      endif
c---------------------------------------------------------------
c check for numerical stablility :
c
      call num_stability_1(dbl_mb(ibas),inx,bl(icij),bl(ickl),
     *               nij_uniqe,bl(ij_uniqe_p),nkl_uniqe,bl(kl_uniqe_p))
c---------------------------------------------------------------
      end
c====================================================================
      subroutine precal2a_1(datbas,datnuc,inx, ibl,nbl2, abprim,lcij,
     *                      aaa,bbb,estab,cis,cjs,
     *                      xab,xparij,coefij,factij,txab, 
     *                      gci,gcj,ngci1,ngcj1,which ,
     *                      nij_uniqe,ij_uniqe )
c
      implicit real*8 (a-h,o-z)
      character*5 which
c
      COMMON /types/itype,jtype,ktype,ltype,ityp,jtyp,ktyp,ltyp
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lc12,lc34
      common /number/ zero,half,one,two,three,four,five,ten,ten6,tenm8,p
     1i,acc
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
c
c
      dimension inx(12,*)
      dimension abprim(nij_uniqe,lcij,3)
      dimension datbas(13,*),datnuc(5,*)
c
      dimension aaa(nij_uniqe,*),bbb(nij_uniqe,*)
      dimension cis(nij_uniqe,*),cjs(nij_uniqe,*)
      dimension xab(nij_uniqe,3), xparij(nij_uniqe,3,lcij,3)
      dimension estab(nij_uniqe,lcij)
      dimension coefij(nij_uniqe,lcij), factij(nij_uniqe,lcij)
      dimension txab(nij_uniqe,3,*)
      dimension gci(nij_uniqe,ngci1,*),gcj(nij_uniqe,ngcj1,*)
c
      dimension ij_uniqe(nij_uniqe)
c
      dimension xa(3),xb(3)
c---------------------------------------------------------------
cnot  par268=eps1*8.d0
      par268=     8.d0
c---------------------------------------------------------------
c
      if(which.eq.'left ') then
          itypp=ityp
          jtypp=jtyp
          ngcii=ngci
          ngcjj=ngcj
          nqii=nqi
          nqjj=nqj
          lcii=lci
          lcjj=lcj
      else
          itypp=ktyp
          jtypp=ltyp
          ngcii=ngck
          ngcjj=ngcl
          nqii=nqk
          nqjj=nql
          lcii=lck
          lcjj=lcl
      endif
c
c-------------------------------------------------------------
c for integral neglect (to massage contraction coef.)
c
      contrij=dble(lcii*lcjj)
      contrij=sqrt(contrij)
c-------------------------------------------------------------
c for gen.contr
c
      ngctot=ngci+ngcj+ngck+ngcl
c-------------------------------------------------------------
c precalculations for the pairs IJ :
c
c-------------------------------old
cccc  ijpar=0
cccc  do 100 ijp=nijbeg,nijend
cccc  ijpar=ijpar+1
cccc    ijcs=ijbl(ibl,ijp)
c-------------------------------old
c
      do 100 ijpar=1,nij_uniqe
        ijcs=ij_uniqe(ijpar)
        call get_ij_half(ijcs,ics,jcs)
c
        fact1=one
cpnl    if(ics.eq.jcs) then
cpnl       if(ngctot.eq.0) fact1=fact1*half
cpnl    endif
c
c      starting contr
        ia=inx(1,ics)+1
        ja=inx(1,jcs)+1
c      last contr
        ie=inx(5,ics)
        je=inx(5,jcs)
c
c       number of general contr.
c       ngci=inx(4,ics)
c       ngcj=inx(4,jcs)
c in the common block contr
c
        iatom=inx(2,ics)
        jatom=inx(2,jcs)
c
c center23 (atom number 0 is the one with s-orbital/zero-exp.)
c
        if(iatom.eq.0) iatom=jatom
        if(jatom.eq.0) jatom=iatom
c
          do 150 i=1,3
          if(iatom.eq.0 .and. jatom.eq.0) then
            xa(i)=zero
            xb(i)=zero
          else
            xa(i)=datnuc(1+i,iatom)
            xb(i)=datnuc(1+i,jatom)
          endif
          xab(ijpar,i)=xa(i)-xb(i)
  150     continue
c
         ji=0
         is1=0
         do 200 is=ia,ie
            is1=is1+1
            aa=datbas(1,is)
            aaa(ijpar,is1)=aa
               if(ngctot.eq.0) then
                  csi=datbas(2,is)
                  cpi=datbas(3,is)
                  coefi=csi
                  est_is=csi
                  est_ip=1.d0
                  if(itypp.eq.3) then
                     est_ip=cpi
                     coefi=cpi
                     csi=csi/cpi
                     facti=csi
                  endif
                  coefi=coefi*fact1
                  if(which.eq.'right') coefi=coefi*par268
                  cis(ijpar,is1)=csi
               else              
c gen.contr. shell is somewhere
                  est_is=one
                  do 210 ig=0,ngcii
                  gci(ijpar,ig+1,is1)=datbas(ig+2,is)
  210             continue
               endif
c
         js1=0
         do 200 js=ja,je
            js1=js1+1
            ji=ji+1
            bb=datbas(1,js)
            bbb(ijpar,js1)=bb
               if(ngctot.eq.0) then
                  csj=datbas(2,js)
                  cpj=datbas(3,js)
                  coefj=csj
                  est_js=csj
                  est_jp=1.d0
                  if(jtypp.eq.3) est_jp=cpj
                  if(jtypp.eq.3) coefj=cpj
c
                  coefij(ijpar,ji )=coefi*coefj
c
                  if(jtypp.eq.3) then
                     csj=csj/cpj
                     factj=csj
                     if(itypp.eq.3) then
                       factij(ijpar,ji  )=facti*factj
                     endif
                  endif
                     cjs(ijpar,js1)=csj
               else              
c gen.contr.
                  coefij(ijpar,ji )=one
                  est_js=one
                  if(which.eq.'right') coefij(ijpar,ji)=par268
c
                  do 220 jg=0,ngcjj
                  gcj(ijpar,jg+1,js1)=datbas(jg+2,js)
  220             continue
               endif
c
            sab=   abprim(ijpar,ji,3)
            aa1=aa*abprim(ijpar,ji,2)
            bb1=bb*abprim(ijpar,ji,2)
            coefij(ijpar,ji)=coefij(ijpar,ji)     *sab
c
            do 230 l=1,3
            xparij(ijpar,l,ji,1)=aa1*xa(l)+bb1*xb(l) ! xp(ijpar,l,ji)
            xxl=xa(l)
            if(nqii.lt.nqjj) xxl=xb(l)
            xparij(ijpar,l,ji,2)=xparij(ijpar,l,ji,1)-xxl  ! xpn
            xparij(ijpar,l,ji,3)=aa*xa(l)+bb*xb(l)         ! xpp
c center23:
            if(aa.le.zero .or. bb.le.zero) then
               xparij(ijpar,l,ji,2)=zero
            endif
  230       continue
c------------------------------------------------------------------
c For integral neglect :
c no l-shells
                if(itypp.ne.3 .and. jtypp.ne.3) then
                   factab=abs( est_is*est_js )
                endif
c l-shells
                if(itypp.eq.3 .and. jtypp.ne.3) then
                   fcts= abs( est_is*est_js )
                   fctp= abs( est_ip*est_js )
                   factab=max( fcts , fctp )
                endif
                if(itypp.ne.3 .and. jtypp.eq.3) then
                   fcts= abs( est_is*est_js )
                   fctp= abs( est_is*est_jp )
                   factab=max( fcts , fctp )
                endif
                if(itypp.eq.3 .and. jtypp.eq.3) then
                   fctss= abs( est_is*est_js )
                   fctsp= abs( est_is*est_jp )
                   fctps= abs( est_ip*est_js )
                   fctpp= abs( est_ip*est_jp )
                   factab=max(fctss,fctsp,fctps,fctpp)
                endif
c
c----
            factab=factab*contrij
            if(factab.gt.1.d0) factab=1.d0
c----
            estab(ijpar,ji)=factab*sab
            estab(ijpar,ji)=estab(ijpar,ji)*estab(ijpar,ji)
c
c------------------------------------------------------------------
c
  200    continue
  100 continue
c
ctxab
c
      if(nqii.ge.nqjj) then
         ijs1=0
         do 151 is1=1,lcii
         do 151 js1=1,lcjj
         ijs1=ijs1+1
         do 151 ijpar=1,nij_uniqe
            txab(ijpar,1,ijs1)=-bbb(ijpar,js1)*xab(ijpar,1)
            txab(ijpar,2,ijs1)=-bbb(ijpar,js1)*xab(ijpar,2)
            txab(ijpar,3,ijs1)=-bbb(ijpar,js1)*xab(ijpar,3)
c center23:
            aa=aaa(ijpar,is1)
            if(aa.le.zero) then
               txab(ijpar,1,ijs1)=zero
               txab(ijpar,2,ijs1)=zero
               txab(ijpar,3,ijs1)=zero
            endif
  151    continue
         
      else
         ijs1=0
         do 152 is1=1,lcii
         do 152 js1=1,lcjj
         ijs1=ijs1+1
         do 152 ijpar=1,nij_uniqe
            txab(ijpar,1,ijs1)= aaa(ijpar,is1)*xab(ijpar,1)
            txab(ijpar,2,ijs1)= aaa(ijpar,is1)*xab(ijpar,2)
            txab(ijpar,3,ijs1)= aaa(ijpar,is1)*xab(ijpar,3)
c center23:
            bb=bbb(ijpar,js1)
            if(bb.le.zero) then
               txab(ijpar,1,ijs1)=zero
               txab(ijpar,2,ijs1)=zero
               txab(ijpar,3,ijs1)=zero
            endif
  152    continue
      endif
c 
c for the case with mmax=2 - special cases
c
      if ( mmax.eq.2 ) then
         if (itypp.gt.1 .or. jtypp.gt.1 ) then
           do 153 ijs1=1,lcij
           do 153 ijpar=1,nij_uniqe
              rapb1=abprim(ijpar,ijs1,2)
              txab(ijpar,1,ijs1)=txab(ijpar,1,ijs1)*rapb1
              txab(ijpar,2,ijs1)=txab(ijpar,2,ijs1)*rapb1
              txab(ijpar,3,ijs1)=txab(ijpar,3,ijs1)*rapb1
  153      continue
         endif
      endif
c------------------------------------------------------------------
c for gradient derivative integrals rescale exponents by 2 :
c
         do is1=1,lcii
            do ijpar=1,nij_uniqe
               aaa(ijpar,is1)= aaa(ijpar,is1)+aaa(ijpar,is1)
            enddo
         enddo
         do js1=1,lcjj
            do ijpar=1,nij_uniqe
               bbb(ijpar,js1)= bbb(ijpar,js1)+bbb(ijpar,js1)
            enddo
         enddo
c------------------------------------------------------------------
c
      end
c====================================================================
      subroutine precal2b_1(mmax1,lcij,rapb,abnia, nij_uniqe,ij_uniqe )
c-------------------------------------------------------------------
c  OUTPUT
c  -------
c  For each pair of primitive shells ij (kl) from IJ (KL) contracted
c  pair belonging to a given block of quartets with total ang.mom. MMAX
c
c  1. ABNIA(IJ,L,ij) -   L*( 0.5/(a+b) )  with L=1,2,...MMAX-1
c-------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension rapb(nij_uniqe,*),abnia(nij_uniqe,mmax1,*)
      dimension ij_uniqe(nij_uniqe)
      data half /0.5d0/
c--------------------------
      do 150 ij=1,lcij
         do 200 ijpar=1,nij_uniqe
            apb2=half*rapb(ijpar,ij)
            abnia(ijpar,1,ij)=apb2
               do 250 i=2,mmax1
                  abnia(ijpar,i,ij)=abnia(ijpar,i-1,ij)+apb2
  250          continue
  200    continue
  150  continue
c
      end
c====================================================================
      subroutine precal2c_1(rapb,rcpd, habcd,nhabcd,nfumax, 
     *                      nij_uniqe,ij_uniqe, nkl_uniqe,kl_uniqe)
c-----------------------------------------------------------------------
c  OUTPUT
c  ------
c  For each pair of primitive shells ij (kl) from IJ (KL) contracted
c  pair belonging to a given block of quartets with total ang.mom. MMAX
c
c  3. HABCD(IJ,lx,ifu,ij)  or  HABCD(KL,lx,ifu,kl) 
c
c  where IFU denotes number of elementary function from 1 up to the
c  total number of functions corresponding to the MMAX-1 /for example
c  for mmax=3 it is from 1 to 10 - s,x,y,z,xx,yy,zz,xy,xz,yz /
c  The second index lx stays for x,y or z and is used to find the power
c  of an elementary function in these directions from matrix HNIA which
c  is constant and is set up in BLOCK DATA logobsa. For example :
c
c     habcd(klpar,1=x,ifu,kl)=hnia(1,ifu)*rcpd(klpar,kl)
c
c  HABCD is used only in TRACY's recursive in routines TRACIJ, TRACKL
c-----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
#include "texas_lpar.fh"
c
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
c
      dimension rapb(nij_uniqe,*),rcpd(nkl_uniqe,*)
      dimension habcd(nhabcd,3,nfumax,*)
      dimension ij_uniqe(nij_uniqe),kl_uniqe(nkl_uniqe)
c-----------------------
         do 170 kl=1,lckl
           do 180 ifu=1,nfumax
           hx=hnia(1,ifu)
           hy=hnia(2,ifu)
           hz=hnia(3,ifu)
cccccccc     do 190 klpar=1,npkl
             do 190 klpar=1,nkl_uniqe
             habcd(klpar,1,ifu,kl)=hx*rcpd(klpar,kl)
             habcd(klpar,2,ifu,kl)=hy*rcpd(klpar,kl)
             habcd(klpar,3,ifu,kl)=hz*rcpd(klpar,kl)
  190        continue
  180      continue
  170    continue
c
      end
c====================================================================
      subroutine prec4neg_1(nbls_n0 , map_n0, ij,kl,lc12,lc34,
     *                      estab,estcd, apb,cpd,coefij,coefkl,xp,xq, 
     *                      map_ij, map_kl, nij_uniqe,nkl_uniqe,
coutput
     *                      rppq,rhoapb,rhocpd,rys,const,nbls1,index)
c--------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      common /types/iityp,jjtyp,kktyp,lltyp, ityp,jtyp,ktyp,ltyp
      common /neglect/ eps,eps1,epsr
c-------
      dimension map_n0(*)
c2002 dimension map_ij(isbl_size),map_kl(isbl_size)
      dimension map_ij(  *      ),map_kl(  *      )
      dimension index(*)
c-------
      dimension apb(nij_uniqe,lc12),cpd(nkl_uniqe,lc34)
      dimension coefij(nij_uniqe,lc12),coefkl(nkl_uniqe,lc34)
      dimension  estab(nij_uniqe,lc12), estcd(nkl_uniqe,lc34)
      dimension xp(nij_uniqe,3,*),xq(nkl_uniqe,3,*)
c----output
      dimension rppq(*),rhoapb(*),rhocpd(*),rys(*),const(*)
c
      data zero,one /0.d0 , 1.d0/
c---------------------------------------------------------------
      sqrpold=one
      rpold=one
      abpcd1r=zero
      abpcdr=zero
c-----------------------------------------------------------------
c     ijkl1=0
c     ijklp=0
c     do 100 iqp=1,isbl_size
c     iq=isbl_q(isbl_point+iqp)
c     if(iq.eq.0) go to 100
c
c        ijklp=ijklp+1
c2002 
c
      ijkl1=0
      do 100 ijklp=1,nbls_n0
         iqp=map_n0(ijklp)
         ijpar=map_ij(iqp)    ! map to uniqe pairs 
         klpar=map_kl(iqp)
c
         apb1=apb(ijpar,ij)
         cpd1=cpd(klpar,kl)
c
         abpcd1=apb1+cpd1
         if(abpcd1.ne.abpcd1r) then
            abpcd1r=abpcd1
            abpcdr=one/abpcd1r
         endif
c
         estim=estab(ijpar,ij)*estcd(klpar,kl)*abpcdr
         if(estim.gt.epsr) then
            ijkl1=ijkl1+1
            index(ijkl1)=ijklp
c
            rppq(ijkl1)=abpcdr
            rhoapb(ijkl1)=abpcdr*cpd1
            rhocpd(ijkl1)=abpcdr*apb1
            abxcd=apb1*cpd1
            rho1=abxcd*abpcdr
c
            x1= xp(ijpar,1,ij) - xq(klpar,1,kl)
            x2= xp(ijpar,2,ij) - xq(klpar,2,kl)
            x3= xp(ijpar,3,ij) - xq(klpar,3,kl)
c
            rr2=x1*x1 + x2*x2 + x3*x3
            rys(ijkl1)=rr2*rho1
c
            if(abpcdr.ne.rpold) then
               rpold=abpcdr
               sqrpold=sqrt(rpold)
            endif
c
            const(ijkl1)=coefij(ijpar,ij)*coefkl(klpar,kl)*sqrpold
c
         endif
 100  continue
c
      nbls1=ijkl1
c
      end
c====================================================================
      subroutine precspec_1(nbls_n0 , map_n0, ij,kl,lc12,lc34,
     *                      indxij,indxkl,
     *                      estab,estcd, apb,cpd,coefij,coefkl,xp,xq,
     *                      rapb,rcpd,txab,txcd,
     *                      map_ij,map_kl,
     *                      nij_uniqe,nkl_uniqe,
c output
     *                      rys,const,xpqr,txxr,nbls1,index)
c-------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      common /types/iityp,jjtyp,kktyp,lltyp, ityp,jtyp,ktyp,ltyp
      common /neglect/ eps,eps1,epsr
c---------------
      dimension map_n0(*)
c2002 dimension map_ij(isbl_size),map_kl(isbl_size)
      dimension map_ij(  *      ),map_kl(  *      )
      dimension indxij(*),indxkl(*),index(*)
c---------------
      dimension apb(nij_uniqe,lc12),cpd(nkl_uniqe,lc34)
      dimension rapb(nij_uniqe,*),rcpd(nkl_uniqe,*)
      dimension coefij(nij_uniqe,lc12),coefkl(nkl_uniqe,lc34)
      dimension  estab(nij_uniqe,lc12), estcd(nkl_uniqe,lc34)
      dimension txab(nij_uniqe,3,*),txcd(nkl_uniqe,3,*)
      dimension xp(nij_uniqe,3,*),xq(nkl_uniqe,3,*)
c
      dimension rys(*),const(*)
      dimension xpqr(3,*),txxr(3,*)
c
      data zero,one /0.d0 , 1.d0/
c---------------------------------------------------------------
      sqrpold=one
      rpold=one
c
      abpcd1r=zero
      abpcdr=zero
c-----------------------------
c2002 ijkl1=0
c     ijklp=0
c     do 100 iqp=1,isbl_size
c     iq=isbl_q(isbl_point+iqp)
c     if(iq.eq.0) go to 100
c        ijklp=ijklp+1
c-----------------------------
c
c
      ijkl1=0
      do 100 ijklp=1,nbls_n0
         iqp=map_n0(ijklp)
c
         ijpar=map_ij(iqp)       ! map to uniqe pairs
         klpar=map_kl(iqp)
c
         apb1=apb(ijpar,ij)
         cpd1=cpd(klpar,kl)
c
         abpcd1=apb1+cpd1
         if(abpcd1.ne.abpcd1r) then
            abpcd1r=abpcd1
            abpcdr=one/abpcd1r
         endif
c
         estim=estab(ijpar,ij)*estcd(klpar,kl)*abpcdr
         if(estim.gt.epsr) then
            ijkl1=ijkl1+1
            index(ijkl1)=ijklp
c
            abxcd=apb1*cpd1
            rho1=abxcd*abpcdr
c
            x1= xp(ijpar,1,ij) - xq(klpar,1,kl)
            x2= xp(ijpar,2,ij) - xq(klpar,2,kl)
            x3= xp(ijpar,3,ij) - xq(klpar,3,kl)
c
            xpqr(1,ijkl1)=x1*rho1
            xpqr(2,ijkl1)=x2*rho1
            xpqr(3,ijkl1)=x3*rho1
c
            rr2=x1*x1 + x2*x2 + x3*x3
            rys(ijkl1)=rr2*rho1
c
            if(abpcdr.ne.rpold) then
               rpold=abpcdr
               sqrpold=sqrt(rpold)
            endif
c
            const(ijkl1)=coefij(ijpar,ij)*coefkl(klpar,kl)*sqrpold
c
         endif
 100  continue
c
      nbls1=ijkl1
      if(nbls1.eq.0) return
c
cnew
      if (ityp.gt.1 .or. jtyp.gt.1 ) then
        do 210 i=1,nbls1
        ijkl=index(i)
        ijpar=indxij(ijkl)                   ! uniqe pair 
c
        xpqr(1,i)=xpqr(1,i)*rapb(ijpar,ij)
        xpqr(2,i)=xpqr(2,i)*rapb(ijpar,ij)
        xpqr(3,i)=xpqr(3,i)*rapb(ijpar,ij)
c
        txxr(1,i)=txab(ijpar,1,ij)
        txxr(2,i)=txab(ijpar,2,ij)
        txxr(3,i)=txab(ijpar,3,ij)
  210   continue
      endif
c
      if (ktyp.gt.1 .or. ltyp.gt.1 ) then
        do 220 i=1,nbls1
        ijkl=index(i)
        klpar=indxkl(ijkl)
        xpqr(1,i)=xpqr(1,i)*rcpd(klpar,kl)
        xpqr(2,i)=xpqr(2,i)*rcpd(klpar,kl)
        xpqr(3,i)=xpqr(3,i)*rcpd(klpar,kl)
c
        txxr(1,i)=txcd(klpar,1,kl)
        txxr(2,i)=txcd(klpar,2,kl)
        txxr(3,i)=txcd(klpar,3,kl)
  220   continue
      endif
c
      end
c====================================================================
      subroutine xwpq_1(nbls1,xwp,xwq,p1234, lcij,lckl,
     *                  indxij,indxkl,index, nij_uniqe,nkl_uniqe,
     *                  rppq,xp,xq,xpp,xqq,
     *                  txab,txcd,apb,rcpd,cpd,rapb)
c-----------------------------------------------
c  OUTPUT
c
c  XWP(ijkl1) - coordinates of W-P,  where W=(XPP+XQQ)/(a+b+c+d)
c  XWQ(ijkl1) - coordinates of W-Q
c  P1234(ijkl1)=(txab+txcd)*(rcpd OR rapb)
c-----------------------------------------------
c
      implicit real*8 (a-h,o-z)
c
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
c
      dimension xwp(nbls1,3),xwq(nbls1,3),p1234(nbls1,3)
c
      dimension indxij(*),indxkl(*),index(*)
c
      dimension  xp(nij_uniqe,3,*), xq(nkl_uniqe,3,*)
      dimension xpp(nij_uniqe,3,*),xqq(nkl_uniqe,3,*)
      dimension apb(nij_uniqe,*),rapb(nij_uniqe,*)
      dimension cpd(nkl_uniqe,*),rcpd(nkl_uniqe,*)
      dimension txab(nij_uniqe,3,*),txcd(nkl_uniqe,3,*)
      dimension rppq(*)
c---------------------------------------------------------------
         do 100 i=1,nbls1
c
            ijkl=index(i)
            ijpar=indxij(ijkl)          ! uniqe pair now !!!!
            klpar=indxkl(ijkl)          ! uniqe pair now !!!!
c
            rppq1=rppq(i)
c
            xwl=( xpp(ijpar,1,lcij) + xqq(klpar,1,lckl) )*rppq1
            ywl=( xpp(ijpar,2,lcij) + xqq(klpar,2,lckl) )*rppq1
            zwl=( xpp(ijpar,3,lcij) + xqq(klpar,3,lckl) )*rppq1
c
            XWP(i,1)=xwl-XP(ijpar,1,lcij)
            XWP(i,2)=ywl-XP(ijpar,2,lcij)
            XWP(i,3)=zwl-XP(ijpar,3,lcij)
c
            XWQ(i,1)=XWL-XQ(klpar,1,lckl)
            XWQ(i,2)=YWL-XQ(klpar,2,lckl)
            XWQ(i,3)=ZWL-XQ(klpar,3,lckl)
c
c for Tracy's recursive :
c
            rcpd1=rcpd(klpar,lckl)
c
            p1234(i,1)=(txab(ijpar,1,lcij)+txcd(klpar,1,lckl))*rcpd1
            p1234(i,2)=(txab(ijpar,2,lcij)+txcd(klpar,2,lckl))*rcpd1
            p1234(i,3)=(txab(ijpar,3,lcij)+txcd(klpar,3,lckl))*rcpd1
c
  100    continue
c---------------------------------------------------------------
c
      end
c====================================================================
      subroutine specase_1(bl,first,nbls,nbls1, index,indxij,indxkl,
     *                     npij,npkl,ii,jj,kk,ll,
     *                     cis,cjs,cks,cls,
     *                     buf,buf1, const,rysx,xpqr,txxr,concoe)
c*
      implicit real*8 (a-h,o-z)
      logical first
      common /types/iityp,jjtyp,kktyp,lltyp, ityp,jtyp,ktyp,ltyp
      common /number/ zero,half,one,two,three,four,five,ten,ten6,tenm8,p
     1i,acc
      common /rys/ xrys,rysr(10),rysw(10),t,f0,f1,f2,f3,f4,f5,nroots
c
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,mmax,
     * nqi,nqj,nqk,nql,nsij,nskl,
     * nqij,nqij1,nsij1,nqkl,nqkl1,nskl1,ijbeg,klbeg
c
c-------------------------------------------------------------------
c
      dimension bl(*)
      dimension index(*),indxij(*),indxkl(*)
      dimension xpqr(3,*),txxr(3,*)
      dimension cis(npij,*),cjs(npij,*),cks(npkl,*),cls(npkl,*)
      dimension const(*),rysx(*),concoe(*)
      dimension buf(nbls,*),buf1(nbls1,4)
c
c-------------------------------------------------------------------
c  this routine constitues the special code for
c  two types of integrals over nbls quartets of primitive shells
c  1. (ss|ss)
c  2. (xs|ss),(sx|ss),(ss|xs),(ss|sx) where x=p or l
c  these integrals are also contracted here.
c
c
c  input
c  ------
c  all precalculated values for whole block :
c
c  const(nbls) - contains consts=pi3sabcd/(pqsqrt(ppq)) for all int.
c  rysx(nbls) - contains  xrys i.e. arguments for fm,ft0 routines
c  xp,xp      - geometry for p,q
c
c  output
c  ------
c  buf(nbls,) -contains final contracted integrals
c-------------------------------------------------------------------
c
c memory for f00,f11 :
c
      call getmem(nbls1,if00)
      call getmem(nbls1,if11)
c
      if00=if00-1
      if11=if11-1
c
c
         do 100 i=1,nbls1
            xrys=rysx(i)
            call ft0
            bl(if00+i)=f0
            bl(if11+i)=f1
 100     continue
c
c special code for (ss ss) integrals
c
      if(mmax.eq.1) then
          do 2031 i=1,nbls1
          buf1(i,1)=const(i)*bl(if00+i)
 2031     continue
      go to 203
      endif
c
c *** special code for (ps ss), (sp ss) (ss ps) and (ss sp)
c
cxxxx if(mmax.eq.2) then
      intct=0
      if (ityp.gt.1) then
        do 101 i=1,nbls1
        xpqr(1,i)=xpqr(1,i)*bl(if11+i) - txxr(1,i)*bl(if00+i)
        xpqr(2,i)=xpqr(2,i)*bl(if11+i) - txxr(2,i)*bl(if00+i)
        xpqr(3,i)=xpqr(3,i)*bl(if11+i) - txxr(3,i)*bl(if00+i)
 101    continue
      else if (jtyp.gt.1) then
        do 102 i=1,nbls1
        xpqr(1,i)=xpqr(1,i)*bl(if11+i) + txxr(1,i)*bl(if00+i)
        xpqr(2,i)=xpqr(2,i)*bl(if11+i) + txxr(2,i)*bl(if00+i)
        xpqr(3,i)=xpqr(3,i)*bl(if11+i) + txxr(3,i)*bl(if00+i)
 102    continue
      else if (ktyp.gt.1) then
        do 103 i=1,nbls1
        xpqr(1,i)=-xpqr(1,i)*bl(if11+i) - txxr(1,i)*bl(if00+i)
        xpqr(2,i)=-xpqr(2,i)*bl(if11+i) - txxr(2,i)*bl(if00+i)
        xpqr(3,i)=-xpqr(3,i)*bl(if11+i) - txxr(3,i)*bl(if00+i)
 103    continue
      else
        do 104 i=1,nbls1
        xpqr(1,i)=-xpqr(1,i)*bl(if11+i) + txxr(1,i)*bl(if00+i)
        xpqr(2,i)=-xpqr(2,i)*bl(if11+i) + txxr(2,i)*bl(if00+i)
        xpqr(3,i)=-xpqr(3,i)*bl(if11+i) + txxr(3,i)*bl(if00+i)
 104    continue
      endif
c
        if( max(ityp,jtyp,ktyp,ltyp).eq.3) then
          if(ityp.eq.3) then
            do 1051 i=1,nbls1
            ijkl=index(i)
            ijpar=indxij(ijkl)                 ! uniqe pair now !!
            concoe(i)=const(i)*cis(ijpar,ii)
 1051       continue
          endif
          if(jtyp.eq.3) then
            do 1052 i=1,nbls1
            ijkl=index(i)
            ijpar=indxij(ijkl)
            concoe(i)=const(i)*cjs(ijpar,jj)
 1052       continue
          endif
          if(ktyp.eq.3) then
            do 1053 i=1,nbls1
            ijkl=index(i)
            klpar=indxkl(ijkl)
            concoe(i)=const(i)*cks(klpar,kk)
 1053       continue
          endif
          if(ltyp.eq.3) then
            do 1054 i=1,nbls1
            ijkl=index(i)
            klpar=indxkl(ijkl)
            concoe(i)=const(i)*cls(klpar,ll)
 1054       continue
          endif
c
           do 105 i=1,nbls1
           buf1(i,1)=concoe(i)*bl(if00+i)
  105      continue
           intct=1
        endif
c
        do 106 i=1,nbls1
          buf1(i,intct+1)=-xpqr(1,i)*const(i)
          buf1(i,intct+2)=-xpqr(2,i)*const(i)
          buf1(i,intct+3)=-xpqr(3,i)*const(i)
106     continue
c
c**********************************************************
c
  203 continue
      if(first) then
         do 204 icx=1,lnijkl
         do 204 i=1,nbls1
         ijkl=index(i)
         buf(ijkl,icx)=buf1(i,icx)
  204    continue
         first=.false.
      else
         do 205 icx=1,lnijkl
         do 205 i=1,nbls1
         ijkl=index(i)
         buf(ijkl,icx)=buf(ijkl,icx)+buf1(i,icx)
  205    continue
      endif
c
c relise memory
c
      call retmem(2)
c
      end
c====================================================================
      subroutine precal2x_1(iabprim,ijdim,iapb,i1apb,isab)
c-------------------------------------------------------------
c precalculations for the pairs IJ :
c
      iapb =iabprim
      i1apb=iabprim   + ijdim
      isab =iabprim   + ijdim*2
c
      end
c====================================================================
      subroutine ab_prim_2(ibl, datnuc,datbas,inx,apb,rapb,sab,ijcont,
     *                     nij_uniqe,ij_uniqe )
      implicit real*8 (a-h,o-z)
      common /neglect/ eps,eps1,epsr
      common /number/ zero,half,one,two,three,four,five,ten,ten6,tenm8,p
     1i,acc
c
      dimension inx(12,*)
      dimension datbas(13,*),datnuc(5,*)
cccc  dimension abprim(nparij,ijcont,3)
      dimension apb(ijcont),rapb(ijcont),sab(nij_uniqe,ijcont)
      dimension ij_uniqe(nij_uniqe)
c
      integer dimmx
      parameter(dimmx=1500)
      dimension sqrtx(dimmx),eexx(dimmx)
c---------------------------------------------------------------
cccc  do 100 ijpar=1,nparij
cccc  ijcs=ijbl(ibl,ijpar)
cnew
      do 100 ijpar =1,nij_uniqe   ! over uniqe pairs
c
      ijcs=ij_uniqe(ijpar)
      call get_ij_half(ijcs,ics,jcs)
c
      ia=inx(1,ics)+1
      ie=inx(5,ics)
      iat=inx(2,ics)
        ja=inx(1,jcs)+1
        je=inx(5,jcs)
        jat=inx(2,jcs)
c
c center23 (atom number 0 is the one with s-orbital/zero-exp.)
c
        if(iat.eq.0) iat=jat
        if(jat.eq.0) jat=iat
c
        if(iat.eq.0 .and. jat.eq.0) then
           xab=zero
           yab=zero
           zab=zero
        else
           xab=datnuc(2,iat)-datnuc(2,jat)
           yab=datnuc(3,iat)-datnuc(3,jat)
           zab=datnuc(4,iat)-datnuc(4,jat)
        endif
c
        rr=xab*xab+yab*yab+zab*zab
c
           ij=0
           if((ie-ia+1)*(je-ja+1).gt.dimmx) call errquit(
     A          ' ab_prim_2: increased dimmx to ',
     C          (ie-ia+1)*(je-ja+1),0)
           do 200 is=ia,ie
           aa=datbas(1,is)
c----------------------------------
             do 200 js=ja,je
             bb=datbas(1,js)
             ij=ij+1
c----------------------------------
             if(aa.gt.zero .and. bb.gt.zero) then
                if(ijpar.eq.1) then
                  axb=aa*bb
                  apb(ij)=aa+bb
                  rapb(ij)=one/apb(ij)
                  e=axb*rapb(ij)
                  eexx(ij)=e
                  sqrtx(ij)=sqrt(sqrt(axb))**3
                  sqrt3=sqrtx(ij)
                else
                  sqrt3=sqrtx(ij)
                  e=eexx(ij)
                endif
cold            sab(ijpar,ij)=rapb(ij)*sqrt3*exp(-e*rr)
cnew98......
                err=e*rr
                if(err.gt.46.d0) then ! was 32
                   sab(ijpar,ij)=0.d0
                else
                   sab(ijpar,ij)=rapb(ij)*sqrt3*exp(-err)
                endif
cnew98......
             else
c center23:
                if(aa.le.zero .and. bb.gt.zero) then
c>>>>>>>>>         write(8,*)' exp_a=zero ; ics=',ics
                   if(ijpar.eq.1) then
                      apb(ij)=aa+bb
                      rapb(ij)=one/apb(ij)
c>>*b-3/4             sqrtx(ij)=     sqrt(bb)       ! Sbb 
                      sqrtx(ij)=one/sqrt(sqrt(bb))  ! sqrt(Sbb)
                      sqrt3=sqrtx(ij)
                   else
                      sqrt3=sqrtx(ij)
                   endif
                   sab(ijpar,ij)=sqrt3               ! Sbb
                endif
                if(aa.gt.zero .and. bb.le.zero) then
c>>>>>>>           write(8,*)' exp_b=zero ; jcs=',jcs
                   if(ijpar.eq.1) then
                      apb(ij)=aa+bb
                      rapb(ij)=one/apb(ij)
c>>>*a-3/4            sqrtx(ij)=     sqrt(aa)       ! Saa 
                      sqrtx(ij)=one/sqrt(sqrt(aa))  ! sqrt(Saa)
                      sqrt3=sqrtx(ij)
                   else
                      sqrt3=sqrtx(ij)
                   endif
                   sab(ijpar,ij)=sqrt3              ! Saa
                endif
                if(aa.le.zero .and. bb.le.zero) then
                   apb(ij)=zero
                   rapb(ij)=zero
                   sab(ijpar,ij)=zero
                endif
             endif
c
c----------------------------------
  200     continue
  100 continue
      end
c============================================================
      subroutine precalc2_2(isupb,bl,mmax,mmax1,nfumax,
     *                      nbl2,nbls, inx,ibl,kbl,npkl)
      implicit real*8 (a-h,o-z)
#include "mafdecls.fh"
c-----------------------------------------------------------
      common /primij/ iabprim, ijdim ,ijpar1
      common /primkl/ kabprim, kldim ,klpar1
      common /ilepar/ lpar_exe,lpar_num
c
      common /infob/ inuc,ibas,na,nbf,nsh,ncf,ncs
c
      common /types/itype,jtype,ktype,ltype,itype1,jtype1,ktype1,ltype1 
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
      common /gcont/ ngci1,ngcj1,ngck1,ngcl1,ngcd
c
      common /memor5x/ ieab,iecd
      common /memor5a/ iaa,ibb,icc,idd,icis,icjs,icks,icls,
     * ixab,ixp,ixpn,ixpp,iabnia,iapb,i1apb,ifij,icij,isab,
     * ixcd,ixq,ixqn,ixqq,icdnia,icpd,i1cpd,ifkl,ickl,iscd
      common /memor5c/ itxab,itxcd,iabcd,ihabcd
      common /memor5d/ iabnix,icdnix,ixpnx,ixqnx,ihabcdx
      common /memor5e/ igci,igcj,igck,igcl,indgc,igcoef,
     *                 icfg,jcfg,kcfg,lcfg, igcij,igckl
c
      common /map4uniq/ nij_uniqe, ij_uniqe_p, map_ij,
     *                  nkl_uniqe, kl_uniqe_p, map_kl
c
      dimension bl(*), inx(12,*)
c---------------------------------------------------------------
c precalculations for pairs ij
c
      call precal2x_2(iabprim,lcij,iapb,i1apb,isab)
c----------
      lpar_exe=lpar_exe+1
      lpar_num=lpar_num+nij_uniqe
      call precal2a_2(dbl_mb(ibas),dbl_mb(inuc),inx,ibl,nbl2,
     *               bl(iabprim+lcij),bl(iabprim+2*lcij),
     *               lcij,bl(iaa),bl(ibb),bl(ieab),bl(icis),bl(icjs),
     *               bl(ixab),bl(ixp),bl(icij),bl(ifij), bl(itxab),
     *               bl(igcij),ngci1,ngcj1,'left ',
     *               nij_uniqe,bl(ij_uniqe_p) )
c----------
c for abnia
      if(mmax.gt.2) then
         call precal2b_2(mmax1,lcij, bl(i1apb),bl(iabnia))
      endif
c----------------------------------------
c precalculations for pairs kl
c
c10   if(kbl.eq.ibl) then
c10       kabprim=iabprim
c10       kldim  =ijdim
c10   endif
c10   if(npkl.ne.0) then
          call precal2x_2(kabprim,lckl,icpd,i1cpd,iscd)
c
          lpar_exe=lpar_exe+1
          lpar_num=lpar_num+nkl_uniqe
          call precal2a_2(dbl_mb(ibas),dbl_mb(inuc),inx,kbl,nbl2,
     *                  bl(kabprim+lckl),bl(kabprim+2*lckl),
c not an error, icc should be twice :
     *                  lckl,bl(icc),bl(icc),bl(iecd),bl(icks),bl(icls),
     *                  bl(ixcd),bl(ixq),bl(ickl),bl(ifkl), bl(itxcd),
     *                  bl(igckl),ngck1,ngcl1,'right',
     *                  nkl_uniqe,bl(kl_uniqe_p) )
c--
c for cdnia
         if(mmax.gt.2) then
            call precal2b_2(mmax1,lckl, bl(i1cpd),bl(icdnia))
         endif
c10   else
c10       call precdiag
c10   endif
c----------------------------------------
c for habcd
c
      if(mmax.gt.2) then
         call precal2c_2(lcij,lckl,bl(i1apb),bl(i1cpd),
     *                   bl(ihabcd),nfumax )
      endif
c---------------------------------------------------------------
c check for numerical stablility :
c
      call num_stability_2(dbl_mb(ibas),inx,bl(icij),bl(ickl),
     *               nij_uniqe,bl(ij_uniqe_p),nkl_uniqe,bl(kl_uniqe_p))
c---------------------------------------------------------------
      end
c====================================================================
      subroutine precal2a_2(datbas,datnuc,inx,ibl,nbl2,
     *                      rapb,sab,lcij,
     *                      aaa,bbb,estab, cis,cjs,
     *                      xab,xparij,coefij,factij,txab,
     *                      gcij,ngci1,ngcj1,which ,
     *                      nij_uniqe,ij_uniqe )
c
      implicit real*8 (a-h,o-z)
      character*5 which
c
c for gradient derivatives only :
      character*11 scftype
      character*8 where
      common /runtype/ scftype,where
c
      COMMON /types/itype,jtype,ktype,ltype,ityp,jtyp,ktyp,ltyp
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lc12,lc34
      common /number/ zero,half,one,two,three,four,five,ten,ten6,tenm8,p
     1i,acc
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
c
      common /neglect/ eps,eps1,epsr
c---------------------------------------------------------------
      dimension rapb(lcij),sab(nij_uniqe,lcij) 
      dimension datbas(13,*),datnuc(5,*)
      dimension inx(12,*)
c
      dimension cis(*),cjs(*)
      dimension xab(nij_uniqe,3), xparij(nij_uniqe,3,lcij,3)
      dimension estab (nij_uniqe,lcij)
      dimension coefij(nij_uniqe,lcij), factij(lcij)
      dimension txab(nij_uniqe,3,*)
      dimension gcij(ngcj1,ngci1,lcij)
      dimension aexp(100),bexp(100)
c only for where='forc' or 'hess'
      dimension aaa(nij_uniqe,*),bbb(nij_uniqe,*)
c
      dimension ij_uniqe(nij_uniqe)
c
      dimension xa(3),xb(3)
c---------------------------------------------------------------
cnot  par268=eps1*8.d0
      par268=     8.d0
c---------------------------------------------------------------
c
      if(which.eq.'left ') then
          itypp=ityp
          jtypp=jtyp
          ngcii=ngci
          ngcjj=ngcj
          nqii=nqi
          nqjj=nqj
          lcii=lci
          lcjj=lcj
      else
          itypp=ktyp
          jtypp=ltyp
          ngcii=ngck
          ngcjj=ngcl
          nqii=nqk
          nqjj=nql
          lcii=lck
          lcjj=lcl
      endif
c
c-------------------------------------------------------------
c for integral neglect (to massage contraction coef.)
c
      contrij=dble(lcii*lcjj)
      contrij=sqrt(contrij)
c-------------------------------------------------------------
c for gen.contr
c
      ngctot=ngci+ngcj+ngck+ngcl
c-------------------------------------------------------------
c precalculations for the pairs IJ :
c
      do 100 ijpar=1,nij_uniqe
        ijcs=ij_uniqe(ijpar)
        call get_ij_half(ijcs,ics,jcs)
c
        fact1=one
cpnl    if(ics.eq.jcs) then
cpnl       if(ngctot.eq.0) fact1=fact1*half
cpnl    endif
c
c      starting contr
        ia=inx(1,ics)+1
        ja=inx(1,jcs)+1
c      last contr
        ie=inx(5,ics)
        je=inx(5,jcs)
c       number of general contr.
c       ngci=inx(4,ics)
c       ngcj=inx(4,jcs)
c in the common block contr
c
        iatom=inx(2,ics)
        jatom=inx(2,jcs)
c
c center23 (atom number 0 is the one with s-orbital/zero-exp.)
c
        if(iatom.eq.0) iatom=jatom
        if(jatom.eq.0) jatom=iatom
c
          do 150 i=1,3
          if(iatom.eq.0 .and. jatom.eq.0) then
            xa(i)=zero
            xb(i)=zero
          else
            xa(i)=datnuc(1+i,iatom)
            xb(i)=datnuc(1+i,jatom)
          endif
          xab(ijpar,i)=xa(i)-xb(i)
  150     continue
c
         ji=0
         is1=0
         do 200 is=ia,ie
            is1=is1+1
            aa=datbas(1,is)
            aexp(is1)=aa
cmoved down if(where.eq.'forc') aaa(ijpar,is1)=aa
cmoved down if(where.eq.'hess') aaa(ijpar,is1)=aa
               if(ngctot.eq.0) then
                  csi=datbas(2,is)
                  cpi=datbas(3,is)
                  coefi=csi
                  est_is=csi
                  est_ip=one
                  if(itypp.eq.3) then
                     est_ip=cpi
                     coefi=cpi
                     csi=csi/cpi
                     facti=csi
                  endif
                  coefi=coefi*fact1
                  if(which.eq.'right') coefi=coefi*par268
                  cis(is1)=csi
               endif
c
         js1=0
         do 200 js=ja,je
            js1=js1+1
            ji=ji+1
            bb=datbas(1,js)
            bexp(js1)=bb
cmoved down if(where.eq.'forc' .and. which.eq.'left ') bbb(ijpar,js1)=bb
cmoved down if(where.eq.'hess' .and. which.eq.'left ') bbb(ijpar,js1)=bb
               if(ngctot.eq.0) then
                  csj=datbas(2,js)
                  cpj=datbas(3,js)
                  coefj=csj
                  est_js=csj
                  est_jp=one
                  if(jtypp.eq.3) est_jp=cpj
                  if(jtypp.eq.3) coefj=cpj
                  coefij(ijpar,ji )=coefi*coefj
                  if(jtypp.eq.3) then
                     csj=csj/cpj
                     factj=csj
                     if(itypp.eq.3) then
                       factij(ji)=facti*factj
                     endif
                  endif
                  cjs(js1)=csj
               else              
c                 gen.contr.
                  est_is=one
                  est_js=one
                  coefij(ijpar,ji )=one
                  if(which.eq.'right') coefij(ijpar,ji)=par268
               endif
c
c--------------------------------
c for general contractions :
               if(ngctot.gt.0 .and. ijpar.eq.1) then
                  do 210 ig=0,ngcii
                  gci=datbas(ig+2,is)
                     do 210 jg=0,ngcjj
                       gcj=gci*datbas(jg+2,js)
                       gcij(jg+1,ig+1,ji)=gcj
  210                continue
               endif
c--------------------------------
c
            rapb1=rapb(ji)
            sab1 =sab(ijpar,ji)
            aa1=aa*rapb1
            bb1=bb*rapb1
c
c-overlap   coefij(ijpar,ji)=coefij(ijpar,ji)*rapb1*sab1
            coefij(ijpar,ji)=coefij(ijpar,ji)      *sab1
c--------------------------------
c
            do 230 l=1,3
            xparij(ijpar,l,ji,1)=aa1*xa(l) + bb1*xb(l)  ! xp(ijpar,l,ji
                xxl=xa(l)
                if(nqii.lt.nqjj) xxl=xb(l)
            xparij(ijpar,l,ji,2)=xparij(ijpar,l,ji,1)-xxl  ! xpn
            xparij(ijpar,l,ji,3)=aa*xa(l)+bb*xb(l)         ! xpp
c center23:
            if(aa.le.zero .or. bb.le.zero) then
               xparij(ijpar,l,ji,2)=zero
            endif
c
  230       continue
c------------------------------------------------------------------
c For integral neglect :
c no l-shells
                if(itypp.ne.3 .and. jtypp.ne.3) then
                   factab=abs( est_is*est_js )
                endif
c l-shells
                if(itypp.eq.3 .and. jtypp.ne.3) then
                   fcts= abs( est_is*est_js )
                   fctp= abs( est_ip*est_js )
                   factab=max( fcts , fctp )
                endif
                if(itypp.ne.3 .and. jtypp.eq.3) then
                   fcts= abs( est_is*est_js )
                   fctp= abs( est_is*est_jp )
                   factab=max( fcts , fctp )
                endif
                if(itypp.eq.3 .and. jtypp.eq.3) then
                   fctss= abs( est_is*est_js )
                   fctsp= abs( est_is*est_jp )
                   fctps= abs( est_ip*est_js )
                   fctpp= abs( est_ip*est_jp )
                   factab=max(fctss,fctsp,fctps,fctpp)
                endif
c
c----
            factab=factab*contrij
            if(factab.gt.1.d0) factab=1.d0
c----
            estab(ijpar,ji)=factab*sab1
            estab(ijpar,ji)=estab(ijpar,ji)*estab(ijpar,ji)
c
c------------------------------------------------------------------
c
  200    continue
  100 continue
c
ctxab
c
      if(nqii.ge.nqjj) then
         ijs1=0
         do 151 is1=1,lcii
         aa1=aexp(is1)
         do 151 js1=1,lcjj
         bb1=bexp(js1)
         ijs1=ijs1+1
         do 151 ijpar=1,nij_uniqe
            txab(ijpar,1,ijs1)=-bb1*xab(ijpar,1)
            txab(ijpar,2,ijs1)=-bb1*xab(ijpar,2)
            txab(ijpar,3,ijs1)=-bb1*xab(ijpar,3)
c center23:
            if(aa1.le.zero) then
               txab(ijpar,1,ijs1)=zero
               txab(ijpar,2,ijs1)=zero
               txab(ijpar,3,ijs1)=zero
            endif
  151    continue
      else
         ijs1=0
         do 152 is1=1,lcii
         aa1=aexp(is1)
         do 152 js1=1,lcjj
         bb1=bexp(js1)
         ijs1=ijs1+1
         do 152 ijpar=1,nij_uniqe
            txab(ijpar,1,ijs1)= aa1*xab(ijpar,1)
            txab(ijpar,2,ijs1)= aa1*xab(ijpar,2)
            txab(ijpar,3,ijs1)= aa1*xab(ijpar,3)
c center23:
            if(bb1.le.zero) then
               txab(ijpar,1,ijs1)=zero
               txab(ijpar,2,ijs1)=zero
               txab(ijpar,3,ijs1)=zero
            endif
  152    continue
      endif
c 
c for the case with mmax=2 - special cases
c
      if ( mmax.eq.2 ) then
         if (itypp.gt.1 .or. jtypp.gt.1 ) then
           do 153 ijs1=1,lcij
           rapb1=rapb(ijs1)
cold       do 153 ijpar=1,npij
           do 153 ijpar=1,nij_uniqe
              txab(ijpar,1,ijs1)=txab(ijpar,1,ijs1)*rapb1
              txab(ijpar,2,ijs1)=txab(ijpar,2,ijs1)*rapb1
              txab(ijpar,3,ijs1)=txab(ijpar,3,ijs1)*rapb1
  153      continue
         endif
      endif
c------------------------------------------------------------------
c for gradient derivative integrals save exponents rescaled by 2 :
c
      if(where.eq.'forc' .or. where.eq.'hess') then
         do is1=1,lcii
            aaa(1,is1)=aexp(is1)+aexp(is1)
         enddo
         if(which.eq.'left ') then
            do js1=1,lcjj
               bbb(1,js1)=bexp(js1)+bexp(js1)
            enddo
         endif
      endif
c------------------------------------------------------------------
      end
c====================================================================
      subroutine precal2b_2(mmax1,lcij, rapb, abnia)
      implicit real*8 (a-h,o-z)
      dimension rapb(*), abnia(mmax1,*)
      data half /0.5d0/
c
      do 150 ij=1,lcij
            apb2=half*rapb(ij)
            abnia(1,ij)=apb2
               do 250 i=2,mmax1
               abnia(i,ij)=abnia(i-1,ij)+apb2
  250          continue
  150 continue
c
      end
c====================================================================
      subroutine precal2c_2(lcij,lckl,rapb,rcpd,habcd,nfumax)
      implicit real*8 (a-h,o-z)
#include "texas_lpar.fh"
c
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
c
      dimension rapb(*),rcpd(*), habcd(3,nfumax,*)
c
c-----------------------
c Do it only for one pair (the first one)
c
         do 170 kl=1,lckl
         rcpdkl=rcpd(kl)
           do 180 ifu=1,nfumax
           hx=hnia(1,ifu)
           hy=hnia(2,ifu)
           hz=hnia(3,ifu)
             habcd(1,ifu,kl)=hx*rcpdkl
             habcd(2,ifu,kl)=hy*rcpdkl
             habcd(3,ifu,kl)=hz*rcpdkl
  180      continue
  170    continue
c
      end
c====================================================================
c2002 subroutine prec4neg_2(isbl_size,isbl_point,isbl_q,ndiag,
      subroutine prec4neg_2(nbls_n0 , map_n0,
     *                      ij,kl, lc12, lc34,
     *                      estab,estcd, apb,cpd,coefij,coefkl,xp,xq, 
     *                      map_ij,map_kl,
     *                      nij_uniqe,nkl_uniqe,
coutput
     *                      rppq,rhoapb,rhocpd,rys,const,nbls1,index)
c--------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      common /neglect/ eps,eps1,epsr
c-------
      dimension map_n0(*)
c2002 dimension map_ij(isbl_size),map_kl(isbl_size)
      dimension map_ij(  *      ),map_kl(  *      )
      dimension index(*)
c-------
      dimension apb(lc12),cpd(lc34)
      dimension coefij(nij_uniqe,lc12),coefkl(nkl_uniqe,lc34)
      dimension  estab(nij_uniqe,lc12), estcd(nkl_uniqe,lc34)
      dimension xp(nij_uniqe,3,*),xq(nkl_uniqe,3,*)
c----output
ccc   dimension rppq(*),rhoapb(*),rhocpd(*),rys(*),const(*)
c now scalars:  rppq,rhoapb,rhocpd  
      dimension rys(*),const(*)
c
      data one /1.d0/
c---------------------------------------------------------------
c NEWER
         apb1=apb(ij)
         cpd1=cpd(kl)
c
         abpcd1=apb1+cpd1
         abxcd=apb1*cpd1
         abpcdr=one/abpcd1
         rho1=abxcd*abpcdr
c        
         sqrpold=sqrt(abpcdr)
c
         rppq  =abpcdr
         rhoapb=abpcdr*cpd1
         rhocpd=abpcdr*apb1
c-----------------------------------------------------------------
c     ijkl1=0
c     ijklp=0
c     do 100 iqp=1,isbl_size
c     iq=isbl_q(isbl_point+iqp)
c     if(iq.eq.0) go to 100
c
c        ijklp=ijklp+1
c
c2002 
c
      ijkl1=0
      do 100 ijklp=1,nbls_n0
         iqp=map_n0(ijklp)
c
         ijpar=map_ij(iqp)    !  map to uniqe pairs 
         klpar=map_kl(iqp)
c
         estim=estab(ijpar,ij)*estcd(klpar,kl)*abpcdr
         if(estim.gt.epsr) then
            ijkl1=ijkl1+1
            index(ijkl1)=ijklp
c
            x1= xp(ijpar,1,ij) - xq(klpar,1,kl)
            x2= xp(ijpar,2,ij) - xq(klpar,2,kl)
            x3= xp(ijpar,3,ij) - xq(klpar,3,kl)
            rr2=x1*x1 + x2*x2 + x3*x3
c
            rys(ijkl1)=rr2*rho1
            const(ijkl1)=coefij(ijpar,ij)*coefkl(klpar,kl)*sqrpold
c
         endif
 100  continue
c
      nbls1=ijkl1
c
      end
c====================================================================
c2002 subroutine precspec_2(isbl_size,isbl_point, isbl_q,ndiag,
      subroutine precspec_2(nbls_n0 , map_n0,
     *                      ij,kl, lc12, lc34, indxij,indxkl,
     *                      estab,estcd, apb,cpd,coefij,coefkl,xp,xq,
     *                      rapb,rcpd,txab,txcd,
     *                      map_ij,map_kl, nij_uniqe,nkl_uniqe,
c     output
     *                      rys,const,xpqr,txxr,nbls1,index)
c-------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      common /types/iityp,jjtyp,kktyp,lltyp, ityp,jtyp,ktyp,ltyp
      common /neglect/ eps,eps1,epsr
c---------------
      dimension map_n0(*)
c2002 dimension map_ij(isbl_size),map_kl(isbl_size)
      dimension map_ij(  *      ),map_kl(  *      )
      dimension indxij(*),indxkl(*),index(*)
c---------------
      dimension apb(lc12),cpd(lc34)
      dimension rapb(lc12),rcpd(lc34)
      dimension coefij(nij_uniqe,lc12),coefkl(nkl_uniqe,lc34)
      dimension  estab(nij_uniqe,lc12), estcd(nkl_uniqe,lc34)
      dimension txab(nij_uniqe,3,*),txcd(nkl_uniqe,3,*)
      dimension xp(nij_uniqe,3,*),xq(nkl_uniqe,3,*)
c
      dimension rys(*),const(*)
      dimension xpqr(3,*),txxr(3,*)
c     
      data one /1.d0/
c---------------------------------------------------------------
      apb1=apb(ij)
      cpd1=cpd(kl)
c     
      abpcd1=apb1+cpd1
      abxcd=apb1*cpd1
      abpcd1r=abpcd1
      abpcdr=one/abpcd1r
      rho1=abxcd*abpcdr
c     
      sqrpold=sqrt(abpcdr)
c------------
c     ijkl1=0
c     ijklp=0
c     do 100 iqp=1,isbl_size
c        iq=isbl_q(isbl_point+iqp)
c        if(iq.eq.0) go to 100
c     
c        ijklp=ijklp+1
c2002
c
      ijkl1=0
      do 100 ijklp=1,nbls_n0
         iqp=map_n0(ijklp)
c
         ijpar=map_ij(iqp)    !  map to uniqe pairs 
         ijpar=map_ij(iqp)      ! map to uniqe pairs
         klpar=map_kl(iqp)
c
         estim=estab(ijpar,ij)*estcd(klpar,kl)*abpcdr
         if(estim.gt.epsr) then
            ijkl1=ijkl1+1
            index(ijkl1)=ijklp
c     
            x1= xp(ijpar,1,ij) - xq(klpar,1,kl)
            x2= xp(ijpar,2,ij) - xq(klpar,2,kl)
            x3= xp(ijpar,3,ij) - xq(klpar,3,kl)
c     
            xpqr(1,ijkl1)=x1*rho1
            xpqr(2,ijkl1)=x2*rho1
            xpqr(3,ijkl1)=x3*rho1
c     
            rr2=x1*x1 + x2*x2 + x3*x3
            rys(ijkl1)=rr2*rho1
c     
            const(ijkl1)=coefij(ijpar,ij)*coefkl(klpar,kl)*sqrpold
c
         endif
 100  continue
c     
      nbls1=ijkl1
      if(nbls1.eq.0) return
c     
c     new
      if (ityp.gt.1 .or. jtyp.gt.1 ) then
         rapbxxx=rapb(ij)
         do 210 i=1,nbls1
            ijkl=index(i)
            ijpar=indxij(ijkl)                  ! uniqe pair
            xpqr(1,i)=xpqr(1,i)*rapbxxx 
            xpqr(2,i)=xpqr(2,i)*rapbxxx 
            xpqr(3,i)=xpqr(3,i)*rapbxxx
c     
            txxr(1,i)=txab(ijpar,1,ij)
            txxr(2,i)=txab(ijpar,2,ij)
            txxr(3,i)=txab(ijpar,3,ij)
 210     continue
      endif
c     
      if (ktyp.gt.1 .or. ltyp.gt.1 ) then
         rcpdxxx=rcpd(kl)
         do 220 i=1,nbls1
            ijkl=index(i)
            klpar=indxkl(ijkl)
            xpqr(1,i)=xpqr(1,i)*rcpdxxx     
            xpqr(2,i)=xpqr(2,i)*rcpdxxx    
            xpqr(3,i)=xpqr(3,i)*rcpdxxx   
c     
            txxr(1,i)=txcd(klpar,1,kl)
            txxr(2,i)=txcd(klpar,2,kl)
            txxr(3,i)=txcd(klpar,3,kl)
 220     continue
      endif
c     
      end
c====================================================================
      subroutine xwpq_2(nbls1,xwp,xwq,p1234,lc12, lc34,lcij,lckl,
     *                  indxij,indxkl,index, nij_uniqe,nkl_uniqe,
     *                  rppq,xp,xq,xpp,xqq,
     *                  txab,txcd,     apb,rcpd,cpd,rapb)
c98  *                  txab,txcd,abcd,apb,rcpd,cpd,rapb)
c---------------------------------------------------------------
c const_max is maximum of abs values of const(nbls1) 
c OUTPUT :  xwp(nbls1,3),xwq(nbls1,3),p1234(nbls1,3)
c---------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      common /flops/ iflop(20)
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
c
      dimension xwp(nbls1,3),xwq(nbls1,3),p1234(nbls1,3)
      dimension indxij(*),indxkl(*),index(*)
c
      dimension xp(nij_uniqe,3,*),xq(nkl_uniqe,3,*)
      dimension xpp(nij_uniqe,3,*),xqq(nkl_uniqe,3,*)
      dimension txab(nij_uniqe,3,*),txcd(nkl_uniqe,3,*)
c
      dimension apb(lc12),rapb(lc12)
      dimension cpd(lc34),rcpd(lc34)
c---------------------------------------------------------------
      rppq1=rppq
      rcpd1=rcpd(lckl)
c
      do 100 i=1,nbls1
         ijkl=index(i)
         ijpar=indxij(ijkl)
         klpar=indxkl(ijkl)
c
         xwl=( xpp(ijpar,1,lcij) + xqq(klpar,1,lckl) )*rppq1
         ywl=( xpp(ijpar,2,lcij) + xqq(klpar,2,lckl) )*rppq1
         zwl=( xpp(ijpar,3,lcij) + xqq(klpar,3,lckl) )*rppq1
c
         XWP(i,1)=xwl-XP(ijpar,1,lcij)
         XWP(i,2)=ywl-XP(ijpar,2,lcij)
         XWP(i,3)=zwl-XP(ijpar,3,lcij)
c
         XWQ(i,1)=XWL-XQ(klpar,1,lckl)
         XWQ(i,2)=YWL-XQ(klpar,2,lckl)
         XWQ(i,3)=ZWL-XQ(klpar,3,lckl)
c
c for Tarcy's recursive :
c
         p1234(i,1)=(txab(ijpar,1,lcij)+txcd(klpar,1,lckl))*rcpd1
         p1234(i,2)=(txab(ijpar,2,lcij)+txcd(klpar,2,lckl))*rcpd1
         p1234(i,3)=(txab(ijpar,3,lcij)+txcd(klpar,3,lckl))*rcpd1
c
  100 continue
c
c---------------------------------------------------------------
      end
c====================================================================
      subroutine specase_2(bl,first,nbls,nbls1, index,
     *                     npij,npkl,ii,jj,kk,ll,
     *                     cis,cjs,cks,cls,
     *                     buf,buf1, const,rysx,xpqr,txxr,concoe)
      implicit real*8 (a-h,o-z)
      logical first
      common /types/iityp,jjtyp,kktyp,lltyp, ityp,jtyp,ktyp,ltyp
      common /number/ zero,half,one,two,three,four,five,ten,ten6,tenm8,p
     1i,acc
      common /rys/ xrys,rysr(10),rysw(10),t,f0,f1,f2,f3,f4,f5,nroots
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,mmax,
     * nqi,nqj,nqk,nql,nsij,nskl,
     * nqij,nqij1,nsij1,nqkl,nqkl1,nskl1,ijbeg,klbeg
c
      dimension bl(*)
      dimension index(*)
      dimension xpqr(3,*),txxr(3,*)
      dimension cis(*),cjs(*),cks(*),cls(*)
      dimension const(*),rysx(*),concoe(*)
      dimension buf(nbls,*),buf1(nbls1,4)
c---------------------------------------------------------------
c  this subroutine constitues the special code for
c  two types of integrals over nbls quartets of primitive shells
c  1. (ss|ss)
c  2. (xs|ss),(sx|ss),(ss|xs),(ss|sx) where x=p or l
c  these integrals are also contracted here.
c
c  this routine is called from the twoe subroutine.
c
c
c  input
c  ------
c  all precalculated values for whole block :
c
c  const(nbls) - contains consts=pi3sabcd/(pqsqrt(ppq)) for all int.
c  rysx(nbls) - contains  xrys i.e. arguments for fm,ft0 routines
c  xp,xp      - geometry for p,q
c
c  output
c  ------
c  buf(nbls,) -contains final contracted integrals
c---------------------------------------------------------------
c
c memory for f00,f11 :
c
      call getmem(nbls1,if00)
      call getmem(nbls1,if11)
c
      if00=if00-1
      if11=if11-1
c
      do 100 i=1,nbls1
      xrys=rysx(i)
      call ft0
      bl(if00+i)=f0
      bl(if11+i)=f1
  100 continue
c
c special code for (ss ss) integrals
c
      if(mmax.eq.1) then
          do 2031 i=1,nbls1
          buf1(i,1)=const(i)*bl(if00+i)
 2031     continue
      go to 203
      endif
c
c  special code for (ps ss), (sp ss) (ss ps) and (ss sp)
c
cxxxx if(mmax.eq.2) then
      intct=0
      if (ityp.gt.1) then
        do 101 i=1,nbls1
        xpqr(1,i)=xpqr(1,i)*bl(if11+i) - txxr(1,i)*bl(if00+i)
        xpqr(2,i)=xpqr(2,i)*bl(if11+i) - txxr(2,i)*bl(if00+i)
        xpqr(3,i)=xpqr(3,i)*bl(if11+i) - txxr(3,i)*bl(if00+i)
 101    continue
      else if (jtyp.gt.1) then
        do 102 i=1,nbls1
        xpqr(1,i)=xpqr(1,i)*bl(if11+i) + txxr(1,i)*bl(if00+i)
        xpqr(2,i)=xpqr(2,i)*bl(if11+i) + txxr(2,i)*bl(if00+i)
        xpqr(3,i)=xpqr(3,i)*bl(if11+i) + txxr(3,i)*bl(if00+i)
 102    continue
      else if (ktyp.gt.1) then
        do 103 i=1,nbls1
        xpqr(1,i)=-xpqr(1,i)*bl(if11+i) - txxr(1,i)*bl(if00+i)
        xpqr(2,i)=-xpqr(2,i)*bl(if11+i) - txxr(2,i)*bl(if00+i)
        xpqr(3,i)=-xpqr(3,i)*bl(if11+i) - txxr(3,i)*bl(if00+i)
 103    continue
      else
        do 104 i=1,nbls1
        xpqr(1,i)=-xpqr(1,i)*bl(if11+i) + txxr(1,i)*bl(if00+i)
        xpqr(2,i)=-xpqr(2,i)*bl(if11+i) + txxr(2,i)*bl(if00+i)
        xpqr(3,i)=-xpqr(3,i)*bl(if11+i) + txxr(3,i)*bl(if00+i)
 104    continue
      endif
c------------------- NEW ------------------------
        if( max(ityp,jtyp,ktyp,ltyp).eq.3) then
c
          if(ityp.eq.3) then
            coeff=cis(ii)
            do 1051 i=1,nbls1
            concoe(i)=const(i)*coeff 
 1051       continue
          endif
          if(jtyp.eq.3) then
            coeff=cjs(jj)
            do 1052 i=1,nbls1
            concoe(i)=const(i)*coeff
 1052       continue
          endif
          if(ktyp.eq.3) then
            coeff=cks(kk)
            do 1053 i=1,nbls1
            concoe(i)=const(i)*coeff 
 1053       continue
          endif
          if(ltyp.eq.3) then
            coeff=cls(ll)
            do 1054 i=1,nbls1
            concoe(i)=const(i)*coeff
 1054       continue
          endif
           do 105 i=1,nbls1
           buf1(i,1)=concoe(i)*bl(if00+i)
  105      continue
           intct=1
        endif
c------------------- NEW end --------------------
        do 106 i=1,nbls1
          buf1(i,intct+1)=-xpqr(1,i)*const(i)
          buf1(i,intct+2)=-xpqr(2,i)*const(i)
          buf1(i,intct+3)=-xpqr(3,i)*const(i)
106     continue
c------------------------------------------------
  203 continue
      if(first) then
         do 204 icx=1,lnijkl
         do 204 i=1,nbls1
         ijkl=index(i)
         buf(ijkl,icx)=buf1(i,icx)
  204    continue
         first=.false.
      else
         do 205 icx=1,lnijkl
         do 205 i=1,nbls1
         ijkl=index(i)
         buf(ijkl,icx)=buf(ijkl,icx)+buf1(i,icx)
  205    continue
      endif
c
c relise memory
c
      call retmem(2)
c
      end
c====================================================================
      subroutine precal2x_2(iabprim,lcij, iapb,i1apb,isab)
c-------------------------------------------------------------
c* precalculations for the pairs IJ :
c
c     iapb =iabprim
c     i1apb=iabprim   + ijdim
c     isab =iabprim   + ijdim*2
      iapb =iabprim
      i1apb=iabprim+lcij
      isab =iabprim+2*lcij
c--------------
      end
c====================================================================
      subroutine num_stability_2(datbas,inx,coefij,coefkl,
     *                        nij_uniqe,ij_uniqe,nkl_uniqe,kl_uniqe)
      implicit real*8 (a-h,o-z)
      logical stable_2
      logical stable_kind_1,stable_kind_2
      common /stability_2/ stable_2,stable_kind_1,stable_kind_2   ! use here and in abcd_
      common /stability_3/ b_over_a(1000)                         ! use here and in abcd_
c 1000 above is enough for contractions as long as 31 (31*31=961)
c
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,mmax,
     * nqi,nqj,nqk,nql,nsij,nskl,
     * nqij,nqij1,nsij1,nqkl,nqkl1,nskl1,ijbeg,klbeg
c number of digit allowed to loose 
      common /allow_lost/ lost_allow
c
      dimension datbas(13,*)
      dimension inx(12,*)
      dimension ij_uniqe(nij_uniqe)
      dimension kl_uniqe(nkl_uniqe)
      dimension coefij(nij_uniqe,*),coefkl(nkl_uniqe,*)
c-------------------------------------------------------------
c June 1998
c Numerical stability of Tracy's recursive depends on the relative
c value of exponents involved. For (ab/cd) instability occurs when
c the second exponent (b) is much bigger than others.
c In such a case one has to proceed as follows:
c construct (s,s|i+j+k+l,s) integrals and then shift ang.mom.
c (s,s|i+j+k+l,s) ---> (i+j,s|k+l,s)
c from center 3 to center 1 (tracy's recursive) 
c 
c Before numerical instability in Tracy's recursive has been
c realized the program calculated (i+j+k+l,s|s,s) for nsij.GE.nskl
c and onother way aroubd for nsij.LT.nskl .
c then shifted ang. mom. from 1 to 3 or fro 3 to 1.
c-------------------------------------------------------------
c calculate maximum of 2*b/max(1,a) and maximum of 1/(c+d)
c these two above will determine numerical stability in
c Tracy's recursive 
c-------------------------------------------------------------
c Lost digit :
c 
c in one recursive step :
c
c
c                    2*b
c          log[-------------------]
c                max(1,a) * (c+d)
c
c in all (nskl-1) steps :
c
c                    2*b
c          log[-------------------] * (nskl-1) + log(const_max)
c                max(1,a) * (c+d)
c
c
c where const_max is max of const(ijkl) constracted in prec4neg_ .
c
c Number of lost digit given above gives the final accuracy for 
c calculated integrals :
c
c          acc_obatained = 10**-(14-lost_digit)
c
c The requested accuracy is given by the user's threshold
c
c          acc_requested = 10**-10 =10**-(14-4)  for example.
c
c (14 comes from double precission)
c-------------------------------------------------------------
c-------------------------------------------------------------
c const=c_ij*c_kl*Sij*Skl/(a+b+c+d)  - S -radial overlap.
c maximum of it is needed
c-------------------------------------------------------------
c
      stable_2     =.true.
      stable_kind_1=.true.
      stable_kind_2=.true.
c
      if(mmax.gt.2 .and. nskl.gt.1) then
c
c left side pairs:
c
         const_ij_max=0.d0     ! ij-part of const
         do ijpar=1,nij_uniqe
            ijcs=ij_uniqe(ijpar)
            call get_ij_half(ijcs,ics,jcs)
            ia=inx(1,ics)+1    !  starting contr
            ja=inx(1,jcs)+1
            ie=inx(5,ics)      !      last contr
            je=inx(5,jcs)
            ij=0
            do is=ia,ie
               do js=ja,je
                  ij=ij+1
                  const_ij=abs(coefij(ijpar,ij))
                  if(const_ij.gt.const_ij_max) const_ij_max=const_ij
               enddo
            enddo
         enddo
         if (const_ij_max.eq.0.0d0) const_ij_max=1d-20
c
c---------------------------------------------------
c right side pairs:
c
         const_kl_max=0.d0     ! kl-part of const
         do klpar=1,nkl_uniqe
            klcs=kl_uniqe(klpar)
            call get_ij_half(klcs,kcs,lcs)
            ka=inx(1,kcs)+1    !  starting contr
            la=inx(1,lcs)+1
            ke=inx(5,kcs)      !      last contr
            le=inx(5,lcs)
            kl=0
            do ks=ka,ke
               do ls=la,le
                  kl=kl+1
                  const_kl=abs(coefkl(klpar,kl))
                  if(const_kl.gt.const_kl_max) const_kl_max=const_kl
               enddo
            enddo
         enddo 
         if (const_kl_max.eq.0.0d0) const_kl_max=1d-20
c---------------------------------------------------
         ijcs=ij_uniqe(1)    
         call get_ij_half(ijcs,ics,jcs)
         ie=inx(5,ics)
         ia=inx(1,ics)+1
         je=inx(5,jcs)
         ja=inx(1,jcs)+1
            a_exp_max=datbas(1,ia)
            b_exp_max=datbas(1,ja)
            a_exp_min=datbas(1,ie)
            b_exp_min=datbas(1,je)
            a_1_max=max(1.d0,a_exp_min)
c---------------------------------------------------
         klcs=kl_uniqe(1)    
         call get_ij_half(klcs,kcs,lcs)
         ke=inx(5,kcs)
         le=inx(5,lcs)
            c_exp_min=datbas(1,ke)
            d_exp_min=datbas(1,le)
            cpd_min=c_exp_min+d_exp_min
            cpd_max=1.d0/cpd_min
c---------------------------------------------------
c
         apb_min=a_exp_min+b_exp_min
         apb_max=a_exp_max+b_exp_max
         cpd_min=c_exp_min+d_exp_min
         cpd_max=1.d0/cpd_min
c
         sqrt_abcd=sqrt(1.d0/(apb_min+cpd_min))
         const_max=const_ij_max*const_kl_max*sqrt_abcd
         lost_const  = nint( log10(const_max) )
         lost_const  = max( -14, lost_const )
c---------------------------------------------------
c test
c        write(6,*)'num_stability_2: BEG'
c              write(6,*)'MAX of: const=',const_max ,
c    *         'min of : a+b=',apb_min,' c+d=',cpd_min,
c    *     ' coef_ij,kl=',const_ij_max,const_kl_max
ctest
c---------------------------------------------------
c for stability of the first  kind :
c
         a_1_max=max(1.d0,a_exp_min)
         boa_max=2.d0*b_exp_max/a_1_max
c
         if(boa_max .ge. 10.d0) then
            if(boa_max.GE.1.0d+07) then
               stable_kind_1=.false.
ctest
c              write(6,*)'Lost : due to 2b/max(1,a)=',
c    *            int( log10( boa_max) )
c              write(6,*)'==> stable_kind_1=',stable_kind_1,
c    *         ' a.m. (',nqi-1,nqj-1,'|',nqk-1,nql-1,')'
ctest
            else
               xost_digit  = (nskl-1)*log10(boa_max*cpd_max) 
               lost_digit  = nint( xost_digit)
               if(lost_digit.GT.0) then
                  lost_digit  = lost_digit + lost_const
                  if(lost_digit.gt.lost_allow) stable_kind_1=.false.
               endif  !  if(lost_digit.GT.0) then
ctest..................................................................
c              write(6,*)'I st-kind stability: ','boa_max =',boa_max 
c              write(6,*)'Lost : in ',nskl-1,' steps =',
c    *            int( xost_digit ),
c    *         '; due to const=',int( log10(const_max) ),
c    *         '; TOTAL=',lost_digit,'(allowed=',lost_allow,')'
c              write(6,*)'==> stable_kind_1=',stable_kind_1,
c    *         ' a.m. (',nqi-1,nqj-1,'|',nqk-1,nql-1,')'
ctest..................................................................
            endif     !  if(boa_max.GE.1.0d+07) then
         endif
c---------------------------------------------------
c for stability of the second kind :
c
         abcd_max=apb_max*cpd_max
         if(abcd_max.ge. 10.d0) then
            xost_digit_1= log10(abcd_max) ! RJH was 0.5*
*     xost_digit  = (nskl-3)*xost_digit_1  ! RJH bad
            xost_digit  = (nskl-1)*xost_digit_1
            lost_digit  = nint( xost_digit ) + lost_const
            if(lost_digit.gt.lost_allow) stable_kind_2=.false.
ctest..................................................................
c              write(6,*)'IIed-kind stability: ','abcd_max=',abcd_max
c              write(6,*)'Lost : in ',nskl-1,' steps =',
c    *            int( xost_digit ),
c    *         '; due to const=',lost_const,
c    *         '; TOTAL=',lost_digit,'(allowed=',lost_allow,')'
c              write(6,*)'==> stable_kind_2=',stable_kind_2,
c    *         ' a.m. (',nqi-1,nqj-1,'|',nqk-1,nql-1,')'
ctest..................................................................
         endif
c
c        write(6,*)'num_stability_2: END'
c-------------------------------------------------------------
c final stability :
c
         if(.not.stable_kind_1) stable_2=.false.
         if(.not.stable_kind_2) stable_2=.false.
c
c-------------------------------------------------------------
         if(.not.stable_kind_1) then
c
c calculate and save 2*b/max(1,a) for each left side contraction 
c
            ij=0
            do is=ia,ie
               aa=datbas(1,is)
               a_1_max=max(1.d0,aa)
               a2=2.d0/a_1_max
               do js=ja,je
                  bb=datbas(1,js)
                  ij=ij+1
                  b_over_a(ij)=0.d0
                  boa=bb*a2
                  if(boa .ge. 10.d0) then
                     boa_max_cpd=boa*cpd_max
                     xost_digit_1= log10( boa_max_cpd )
                     xost_digit  = (nskl-1)*xost_digit_1 
                     lost_digit  = nint( xost_digit )
                     lost_digit  = lost_digit + lost_const
                     if(lost_digit.gt.lost_allow) then
                        b_over_a(ij)=boa
                     endif
                  endif
               enddo ! js=ja,je
            enddo    ! is=ia,ie
         endif       ! if(.not.stable_kind_1) then
c-------------------------------------------------------------
      endif   !  if(mmax.gt.2 .and. nskl.gt.1) then
c
      end
c===================================================================
      subroutine num_stability_1(datbas,inx,coefij,coefkl,
     *                        nij_uniqe,ij_uniqe,nkl_uniqe,kl_uniqe)
      implicit real*8 (a-h,o-z)
      logical stable_2
      logical stable_kind_1,stable_kind_2
      common /stability_2/ stable_2,stable_kind_1,stable_kind_2   ! use here and in abcd_
      common /stability_3/ b_over_a(1000)                         ! use here and in abcd_
c 1000 above is enough for contractions as long as 31 (31*31=961)
c
      character*11 scftype
      character*8 where
      common /runtype/ scftype,where
c
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,mmax,
     * nqi,nqj,nqk,nql,nsij,nskl,
     * nqij,nqij1,nsij1,nqkl,nqkl1,nskl1,ijbeg,klbeg
c number of digit allowed to loose 
      common /allow_lost/ lost_allow
c
      dimension datbas(13,*)
      dimension inx(12,*)
      dimension ij_uniqe(nij_uniqe)
      dimension kl_uniqe(nkl_uniqe)
      dimension coefij(nij_uniqe,*),coefkl(nkl_uniqe,*)
c-------------------------------------------------------------
c for description see num_stability_2()
c-------------------------------------------------------------
c calculate maximum of 2*b/max(1,a) and maximum of 1/(c+d)
c these two above will determine numerical stability in
c Tracy's recursive 
c-------------------------------------------------------------
c const=c_ij*c_kl*Sij*Skl/(a+b+c+d)  - S -radial overlap.
c maximum of it is needed
c-------------------------------------------------------------
c
      stable_2     =.true.
      stable_kind_1=.true.
      stable_kind_2=.true.
c
      if(mmax.gt.2 .and. nskl.gt.1) then
c
c left side pairs:
c
c        write(6,*)'num_stability_1:'
c
         const_ij_max=0.d0     ! ij-part of const
         a_exp_min=1.0d+10     ! for stable_kind_1
         b_exp_min=1.0d+10     ! for both
         a_exp_max=0.0d0       ! for stable_kind_2
         b_exp_max=0.0d0       ! for both
         do ijpar=1,nij_uniqe
            ijcs=ij_uniqe(ijpar)
            call get_ij_half(ijcs,ics,jcs)
c
            ia=inx(1,ics)+1    !  starting contr
            ja=inx(1,jcs)+1
            ie=inx(5,ics)      !      last contr
            je=inx(5,jcs)
c
            do is=ia,ie
               aa=datbas(1,is)
               if(aa.lt.a_exp_min) a_exp_min=aa
               if(aa.gt.a_exp_max) a_exp_max=aa
            enddo
            do js=ja,je
               bb=datbas(1,js)
               if(bb.lt.b_exp_min) b_exp_min=bb
               if(bb.gt.b_exp_max) b_exp_max=bb
            enddo
            ij=0
            do is=ia,ie
               do js=ja,je
                  ij=ij+1
                  const_ij=abs(coefij(ijpar,ij))
                  if(const_ij.gt.const_ij_max) const_ij_max=const_ij
               enddo
            enddo
         enddo
c
c---------------------------------------------------
c
c right side pairs:
c
         const_kl_max=0.d0     ! kl-part of const
         c_exp_min=1.0d+10
         d_exp_min=1.0d+10
         do klpar=1,nkl_uniqe
            klcs=kl_uniqe(klpar)
            call get_ij_half(klcs,kcs,lcs)
c
            ka=inx(1,kcs)+1    !  starting contr
            la=inx(1,lcs)+1
            ke=inx(5,kcs)      !      last contr
            le=inx(5,lcs)
c
            do ks=ka,ke
               cc=datbas(1,ks)
               if(cc.lt.c_exp_min) c_exp_min=cc
            enddo
            do ls=la,le
               dd=datbas(1,ls)
               if(dd.lt.d_exp_min) d_exp_min=dd
            enddo
            kl=0
            do ks=ka,ke
               do ls=la,le
                  kl=kl+1
                  const_kl=abs(coefkl(klpar,kl))
                  if(const_kl.gt.const_kl_max) const_kl_max=const_kl
               enddo
            enddo
         enddo 
c
         apb_min=a_exp_min+b_exp_min
         apb_max=a_exp_max+b_exp_max
         cpd_min=c_exp_min+d_exp_min
         cpd_max=1.d0/cpd_min
c
         sqrt_abcd=sqrt(1.d0/(apb_min+cpd_min))
         const_max=const_ij_max*const_kl_max*sqrt_abcd
c---------------------------------------------------
c test
c        write(6,*)'num_stability_1: BEG'
c              write(6,*)'MAX of: const=',const_max ,
c    *         'min of : a+b=',apb_min,' c+d=',cpd_min,
c    *     ' coef_ij,kl=',const_ij_max,const_kl_max
ctest
c---------------------------------------------------
c for stability of the first  kind :
c
         a_1_max=max(1.d0,a_exp_min)
         boa_max=2.d0*b_exp_max/a_1_max
c
         if(boa_max .ge. 10.d0) then
            if(boa_max.GE.1.0d+07) then
               stable_kind_1=.false.
ctest
c              write(6,*)'Lost : due to 2b/max(1,a)=',
c    *            int( log10( boa_max) )
c              write(6,*)'==> stable_kind_1=',stable_kind_1,
c    *         ' a.m. (',nqi-1,nqj-1,'|',nqk-1,nql-1,')'
ctest
            else
               xost_digit  = (nskl-1)*log10(boa_max*cpd_max) 
               lost_digit  = nint( xost_digit)
               if(lost_digit.GT.0) then
                  if(const_max.gt.1d-14) then
                     lost_const  = nint( log10(const_max) )
                  else
                     lost_const=-14
                  endif
                  lost_const  = max( -14, lost_const )
                  lost_digit  = lost_digit + lost_const
                  if(lost_digit.gt.lost_allow) stable_kind_1=.false.
               endif  !  if(lost_digit.GT.0) then
ctest..................................................................
c              write(6,*)'I st-kind stability: ','boa_max =',boa_max 
c              write(6,*)'Lost : in ',nskl-1,' steps =',
c    *            int( xost_digit ),
c    *         '; due to const=',int( log10(const_max) ),
c    *         '; TOTAL=',lost_digit,'(allowed=',lost_allow,')'
c              write(6,*)'==> stable_kind_1=',stable_kind_1,
c    *         ' a.m. (',nqi-1,nqj-1,'|',nqk-1,nql-1,')'
ctest..................................................................
            endif     !  if(boa_max.GE.1.0d+07) then
         endif
c---------------------------------------------------
c for stability of the second kind :
c
         abcd_max=apb_max*cpd_max
         if(abcd_max.ge. 10.d0) then
            xost_digit_1= log10(abcd_max) ! RJH was 0.5d0*
*            xost_digit  = (nskl-3)*xost_digit_1 ! RJH BAD
            xost_digit  = (nskl-1)*xost_digit_1
            if(const_max.gt.1d-14) then
               lost_const  = nint( log10(const_max) )
            else
               lost_const=-14
            endif
            lost_const  = max( -14, lost_const )
            lost_digit  = nint( xost_digit ) + lost_const
            if(lost_digit.gt.lost_allow) stable_kind_2=.false.
ctest..................................................................
c              write(6,*)'IIed-kind stability: ','abcd_max=',abcd_max
c              write(6,*)'Lost : in ',nskl-1,' steps =',
c    *            int( xost_digit ),
c    *         '; due to const=',lost_const,
c    *         '; TOTAL=',lost_digit,'(allowed=',lost_allow,')'
c              write(6,*)'==> stable_kind_2=',stable_kind_2,
c    *         ' a.m. (',nqi-1,nqj-1,'|',nqk-1,nql-1,')'
ctest..................................................................
         endif
c
c        write(6,*)'num_stability_1: END'
c-------------------------------------------------------------
c final stability :
c
         if(.not.stable_kind_1) stable_2=.false.
         if(.not.stable_kind_2) stable_2=.false.
c
c-------------------------------------------------------------
c        if(stable_2) return
c-------------------------------------------------------------
c calculate and save 2*b/max(1,a) for each left side contraction 
c
c        do ijpar=1,nij_uniqe
c           ijcs=ij_uniqe(ijpar)
c           call get_ij_half(ijcs,ics,jcs)
c           ia=inx(1,ics)+1  
c           ja=inx(1,jcs)+1
c           ie=inx(5,ics)   
c           je=inx(5,jcs)
c           ij=0
c           do is=ia,ie
c              aa=datbas(1,is)
c              a_1_max=max(1.d0,aa)
c              a2=2.d0/a_1_max
c              do js=ja,je
c                 bb=datbas(1,js)
c                 ij=ij+1
c
c                 b_over_a(ij)=0.d0
c                 boa=bb*a2
c                 boa_max_cpd=boa*cpd_max
c                 if(boa_max_cpd .ge. 10.d0) then
c                    xost_digit_1= log10( boa_max_cpd )
c                    xost_digit  = (nskl-1)*xost_digit_1
c                    lost_digit  = int( xost_digit )
c                    if(lost_digit.gt.lost_allow) then
c                       b_over_a(ijpar,ij)=boa
c                    endif
c                 endif
c              enddo ! js=ja,je
c           enddo    ! is=ia,ie
c        enddo       ! ijpar=1,nij_uniqe
c-------------------------------------------------------------
      endif   !  if(mmax.gt.2 .and. nskl.gt.1) then
c
      end
c===================================================================
      subroutine get_max_const(nbls1,const,ngcd,indx,gcoef,const_max)
c
c  called from abcd_2() only
c
      implicit real*8 (a-h,o-z)
      dimension const(nbls1),gcoef(ngcd,*)  ! gcoef(ngcd,nbls)
      dimension indx(*)
c
      if(ngcd.EQ.1) then
         const_max=0.d0
         do i=1,nbls1
            c_abs=abs(const(i))
            if(c_abs.gt.const_max) const_max=c_abs
         enddo
      else
         const_max=0.d0
         do i=1,nbls1
            const_i=const(i)
            ijkl=indx(i)
            gcoef_i=0.d0
               do ijklg=1,ngcd
                  gc_abs=abs( gcoef(ijklg,ijkl) )
                  if(gc_abs.gt.gcoef_i) gcoef_i=gc_abs
               enddo
            c_abs=abs( const_i * gcoef_i )
            if(c_abs.gt.const_max) const_max=c_abs
         enddo
      endif
c
      end
c===============================================================
      subroutine get_max_gcoef(gcoef,ngcd,gc_max)
c
c  called from abcd_1() only
c
      implicit real*8 (a-h,o-z)
      dimension gcoef(ngcd)
c
      gc_max=0.d0
      do iqu=1,ngcd
         gc_abs=abs(gcoef(iqu))
         if(gc_abs.gt.gc_max) gc_max=gc_abs
      enddo
c
      end
c====================================================================

      subroutine fock_2e_task(
     $     geom, basis, oskel,
     $     iatlo, jatlo, katlo, latlo,
     $     iathi, jathi, kathi, lathi,
     $     ijk_prev,
     $     nfock, vg_dens, vg_fock,
     $     jfac, kfac, 
     $     dij, dik, dli, djk, dlj, dlk,
     $     fij, fik, fli, fjk, flj, flk,
     $     tmp, tol2e, dentol)
      implicit none
#include "errquit.fh"
#include "schwarz.fh"
#include "bas.fh"
#include "cfock.fh"
#include "cscfps.fh"
#include "sym.fh"
c
c     $Id: fock_2e_task.F 19707 2010-10-29 17:59:36Z d3y133 $
c
c     Given an block of atomic quartets, fetch the necessary blocks
c     of the density matrices, call fock_2e_b to add in
c     in the fock matrix contribution and then accumulate
c     the contributions.
c
      integer geom
      integer basis
      logical oskel
      integer iatlo, jatlo, katlo, latlo
      integer iathi, jathi, kathi, lathi
      integer ijk_prev(3,2)
      integer nfock
      integer vg_dens(nfock), vg_fock(nfock)
      double precision jfac(nfock), kfac(nfock)
      double precision dij(nfock,*), dik(nfock,*), dli(nfock,*),
     $     djk(nfock,*), dlj(nfock,*), dlk(nfock,*)
      double precision fij(nfock,*), fik(nfock,*), fli(nfock,*),
     $     fjk(nfock,*), flj(nfock,*), flk(nfock,*)
      double precision tmp(*)
      double precision tol2e, dentol
c      
c     Given a task which comprises computing the contributions
c     arising from a quartet of blocks of atoms, do everything necessary
c
      double precision sij, sijkl, q4, smax
      logical otest, otestij
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      integer iat, jat, kat, lat, lattop, kattop, jattop
      logical oij, okl, oikjl
      integer junk
      logical int2e_set_bf_range
      external int2e_set_bf_range
c
c     With caching get density and flush necessary fock blocks
c     and return magnitude of density blocks for screening
c
      if (.not. bas_ce2bfr(basis, iatlo, ilo, junk))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
      if (.not. bas_ce2bfr(basis, iathi, junk, ihi))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
c
      if (.not. bas_ce2bfr(basis, jatlo, jlo, junk))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
      if (.not. bas_ce2bfr(basis, jathi, junk, jhi))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
c
      if (.not. bas_ce2bfr(basis, katlo, klo, junk))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
      if (.not. bas_ce2bfr(basis, kathi, junk, khi))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
c
      if (.not. bas_ce2bfr(basis, latlo, llo, junk))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
      if (.not. bas_ce2bfr(basis, lathi, junk, lhi))
     $     call errquit('fock_2e_task: ce2bfr failed', 0, BASIS_ERR)
c
      if (owritefile) then
         if (.not. int2e_set_bf_range(
     $        ilo, ihi, jlo, jhi, klo, khi, llo, lhi))
     $        call errquit('should not happen', 0, UNKNOWN_ERR)
      end if
c     
      call fock_init_cmul(ihi-ilo+1,jhi-jlo+1,lhi-llo+1)
c
      call fock_2e_cache_dens_fock(
     $     ilo, jlo, klo, llo,
     $     ihi, jhi, khi, lhi,
     $     ijk_prev,
     $     nfock, vg_dens, vg_fock,
     $     jfac, kfac, 
     $     dij, dik, dli, djk, dlj, dlk,
     $     fij, fik, fli, fjk, flj, flk,
     $     tmp)
c
      q4 = 1.0d0
      oij   = iatlo.eq.jatlo
      okl   = katlo.eq.latlo
      oikjl = (iatlo.eq.katlo) .and. (jatlo.eq.latlo)
c
      if (oscfps) call pstat_on(ps_fock_add)
      if (onoblock) then
         smax = schwarz_max()
         do iat = iatlo, iathi
            jattop = jathi
            if (oij) jattop = iat
            do jat = jatlo, jattop
               sij = schwarz_atom(iat,jat)
               otestij = (sij*smax) .gt. dentol
               if (otestij) then
                  kattop = kathi
                  if (oikjl) kattop = iat
                  do kat = katlo, kattop
                     lattop = lathi
                     if (okl) lattop = kat
                     if (oikjl .and. kat.eq.iat) lattop = jat
                     do lat = latlo,lattop
                        sijkl = sij*schwarz_atom(kat,lat)
                        otest = sijkl .gt. dentol
                        if (otest .and. oskel) otest = sym_atom_quartet
     $                       (geom, iat, jat, kat, lat, q4)
                        if (otest) then
                           call fock_2e_b(basis, nfock, sijkl, tol2e,
     $                          dentol, q4, iat, jat, kat, lat, 
     $                          ilo, jlo, klo, llo, ihi, jhi, khi, lhi,
     $                          dij, dik, dli, djk, dlj, dlk,
     $                          fij, fik, fli, fjk, flj, flk)
                        end if
                     end do
                  end do
               end if
            end do
         end do
      else
         call fock_2e_texas(
     $        geom, basis, oskel,
     $        iatlo, jatlo, katlo, latlo,
     $        iathi, jathi, kathi, lathi,
     $        ijk_prev,
     $        nfock, vg_dens, vg_fock,
     $        jfac, kfac,
     $        ilo, jlo, klo, llo, ihi, jhi, khi, lhi,
     $        dij, dik, dli, djk, dlj, dlk,
     $        fij, fik, fli, fjk, flj, flk,
     $        tmp, tol2e, dentol, oij, okl, oikjl)
      end if
      if (oscfps) call pstat_off(ps_fock_add)
c     
c     Update F blocks
c     
      if (oscfps) call pstat_on(ps_gaops)
      call fock_upd_blk(nfock, vg_fock,
     $     llo, lhi, ilo, ihi, kfac, fli, tmp)
      call fock_upd_blk(nfock, vg_fock,
     $     llo, lhi, jlo, jhi, kfac, flj, tmp)
      call fock_upd_blk(nfock, vg_fock,
     $     llo, lhi, klo, khi, jfac, flk, tmp)
      if (oscfps) call pstat_off(ps_gaops)
c     
      end
      subroutine fock_2e_texas(
     $     geom, basis, oskel,
     $     iatlo, jatlo, katlo, latlo,
     $     iathi, jathi, kathi, lathi,
     $     ijk_prev,
     $     nfock, vg_dens, vg_fock,
     $     jfac, kfac, 
     $     ilo, jlo, klo, llo, ihi, jhi, khi, lhi,
     $     dij, dik, dli, djk, dlj, dlk,
     $     fij, fik, fli, fjk, flj, flk,
     $     tmp, tol2e, dentol, oij, okl, oikjl)
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "schwarz.fh"
#include "bas.fh"
#include "cfock.fh"
#include "cscfps.fh"
#include "sym.fh"
#include "geom.fh"
#include "mafdecls.fh"
c
      integer geom
      integer basis
      logical oskel
      integer iatlo, jatlo, katlo, latlo
      integer iathi, jathi, kathi, lathi
      integer ijk_prev(3,2)
      integer nfock
      integer ilo, jlo, klo, llo, ihi, jhi, khi, lhi
c
      integer vg_dens(nfock), vg_fock(nfock)
      double precision jfac(nfock), kfac(nfock)
      double precision dij(nfock,*), dik(nfock,*), dli(nfock,*),
     $     djk(nfock,*), dlj(nfock,*), dlk(nfock,*)
      double precision fij(nfock,*), fik(nfock,*), fli(nfock,*),
     $     fjk(nfock,*), flj(nfock,*), flk(nfock,*)
      double precision tmp(*)
      double precision tol2e, dentol
      double precision smax, sijkl
      logical oij, okl, oikjl
      integer iat, jat, kat, lat, nsh
c
c     These for sorting shells within each atom pair block
c
      integer max_pair_t, max_sh, max_at
      parameter (max_at = 10)
      parameter (max_pair_t = 100000, max_sh = 64) ! Should dynamically alloc
      double precision skl(max_sh*max_sh) ! Should be just max shell block
      double precision sij(max_sh*max_sh) ! Should be just max shell block
      integer ijlist(2,max_sh*max_sh), ij
      integer kllist(2,max_sh*max_sh), kl
      integer nt_ij
      integer nt_kl
      integer k_ijinfo,l_ijinfo,k_klinfo,l_klinfo
c
      integer max_q, max_p
      parameter (max_q = 10000)
      integer ijkl(max_q,4)
      double precision q4(max_q)
      double precision rdij(max_at,max_at), rdik(max_at,max_at), 
     $     rdli(max_at,max_at),
     $     rdjk(max_at,max_at), rdlj(max_at,max_at), rdlk(max_at,max_at)
c
      integer ncent, ncent_unique
      integer i
      integer ia,ja,ka,la
      integer ijt, klt
      integer ish, jsh, ksh, lsh
      integer nq
c
c     These need to be refined
c
      double precision q4_at(max_at,max_at,max_at,max_at)
c
      integer maxcn
      parameter (maxcn = nw_max_shells)
      integer cn_to_ce(maxcn)
c
      logical status
      double precision q2, qq4, sijat, sklat
c
c     Form q4 factors over atoms and mapping from shells to atoms
c     ... very crude now for debug purposes
c
      if ((iathi-iatlo+1).gt.max_at) call errquit('too many ats',0,
     &       UNKNOWN_ERR)
      if ((jathi-jatlo+1).gt.max_at) call errquit('too many ats',0,
     &       UNKNOWN_ERR)
      if ((kathi-katlo+1).gt.max_at) call errquit('too many ats',0,
     &       UNKNOWN_ERR)
      if ((lathi-latlo+1).gt.max_at) call errquit('too many ats',0,
     &       UNKNOWN_ERR)
c
      smax = schwarz_max()
c
      call fock_den_sum(basis, nfock, iatlo, iathi, jatlo, jathi,
     $     dij, ilo, ihi, jlo, jhi, rdij, max_at, dentol/smax)
      call fock_den_sum(basis, nfock, iatlo, iathi, katlo, kathi,
     $     dik, ilo, ihi, klo, khi, rdik, max_at, dentol/smax)
      call fock_den_sum(basis, nfock, latlo, lathi, iatlo, iathi,
     $     dli, llo, lhi, ilo, ihi, rdli, max_at, dentol/smax)
      call fock_den_sum(basis, nfock, jatlo, jathi, katlo, kathi,
     $     djk, jlo, jhi, klo, khi, rdjk, max_at, dentol/smax)
      call fock_den_sum(basis, nfock, latlo, lathi, jatlo, jathi,
     $     dlj, llo, lhi, jlo, jhi, rdlj, max_at, dentol/smax)
      call fock_den_sum(basis, nfock, latlo, lathi, katlo, kathi,
     $     dlk, llo, lhi, klo, khi, rdlk, max_at, dentol/smax)
c
      if (oskel) then
         do iat = iatlo, iathi
            ia = iat-iatlo+1
            do jat = jatlo, jathi
               ja = jat-jatlo+1
               sijat = schwarz_atom(iat,jat)
               do kat = katlo, kathi
                  ka = kat-katlo+1
                  do lat = latlo, lathi
                     la = lat-latlo+1
                     sklat = schwarz_atom(kat,lat)
                     if (sklat*sijat .gt. dentol) then
                        status = sym_atom_quartet(geom, 
     $                       iat, jat, kat, lat, q4_at(ia,ja,ka,la))
                     else
                        q4_at(ia,ja,ka,la) = 0.0d0
                     end if
                  end do
               end do
            end do
         end do
      end if
c
*      write(6,*) ' tol2e, dentol ', tol2e, dentol
c
      if (.not. bas_numcont(basis, nsh)) call errquit('bas?',0,
     &       BASIS_ERR)
      if (nsh .gt. maxcn) call errquit('maxcn?',0, UNKNOWN_ERR)
      do i = 1, nsh
         if (.not. bas_cn2ce(basis, i, cn_to_ce(i)))
     $        call errquit('bas?',0, BASIS_ERR)
      end do
c
c     Form list of sorted interacting shell pairs
c
      if (.not. geom_ncent(geom,ncent)) call errquit('ftx:geom?',0,
     &       GEOM_ERR)
      if (.not. geom_ncent_unique(geom,ncent_unique)) 
     $     call errquit('ftx:geom?',0, GEOM_ERR)
      max_p = int(dble(max_q*ncent)/dble(ncent_unique))
      if (oikjl) max_p = max_p*2
      max_p = sqrt(dble(max_p))
c      
      if(.not.ma_alloc_get(MT_int, 2*max_pair_t,'ijinfo', 
     .     l_ijinfo, k_ijinfo)) call errquit(
     .     ' fock2etask: pushget failed ',2*max_pair_t, MA_ERR)
      call fock_pairs(basis, max_p, oij, iatlo, iathi, jatlo, jathi, 
     $     dentol, ijlist, sij, int_mb(k_ijinfo), max_pair_t, nt_ij)
      if(.not.ma_alloc_get(MT_int, 2*max_pair_t,'klinfo', 
     .     l_klinfo, k_klinfo)) call errquit(
     .     ' fock2etask: pushget failed ',2*max_pair_t, MA_ERR)
      call fock_pairs(basis, max_p, okl, katlo, kathi, latlo, lathi, 
     $     dentol, kllist, skl, int_mb(k_klinfo), max_pair_t, nt_kl)
c
c     Loop over pairs of pairs (have i>=j and k>=l already)
c
      nq = 0
      do ijt = 1,nt_ij
*         write(6,*) ' nij ', ijinfo(2,ijt)-ijinfo(1,ijt)+1
         do klt = 1, nt_kl
*            write(6,*) '      nkl ', klinfo(2,klt)-klinfo(1,klt)+1
            do ij = int_mb(k_ijinfo+(ijt-1)*2), 
     ,              int_mb(k_ijinfo+(ijt-1)*2+1) 
               ish = ijlist(1,ij)
               jsh = ijlist(2,ij)
               iat = cn_to_ce(ish)-iatlo+1
               jat = cn_to_ce(jsh)-jatlo+1
               q2 = 1.0d0
               if (oij .and. ish.eq.jsh) q2 = q2*0.5d0
               do kl = int_mb(k_klinfo+(klt-1)*2), 
     ,              int_mb(k_klinfo+(klt-1)*2+1) 
                  qq4 = q2
                  ksh = kllist(1,kl)
                  lsh = kllist(2,kl)
                  kat = cn_to_ce(ksh)-katlo+1
                  lat = cn_to_ce(lsh)-latlo+1
c     ikjl diagonal
                  if (oikjl) then
                     if (ish.lt.ksh) then
                        goto 300 ! Next kl
                     else if (ish.eq.ksh) then
                        if (jsh.lt.lsh) then
                           goto 300 ! Next kl
                        else if (jsh.eq.lsh) then
                           qq4 = qq4 * 0.5d0
                        end if
                     end if
                  end if
c     symmetry test
                  if (oskel) then
                     qq4 = qq4*q4_at(iat,jat,kat,lat)
                     if (qq4 .eq. 0.0d0) goto 300 ! Next kl
                  end if
c     sparsity test
                  sijkl = sij(ij)*skl(kl)
                  if (sijkl .lt. dentol) goto 300 ! Next kl
c     density screening
                  if (odensityscreen .and. (.not. owritefile)) then
                     sijkl=sijkl*max(
     $                    rdij(iat,jat),rdik(iat,kat),rdli(lat,iat),
     $                    rdjk(jat,kat),rdlj(lat,jat),rdlk(lat,kat))
                     if (sijkl .lt. tol2e) goto 300 ! Next kl
                  end if
c     kl diagonal
                  if (okl .and. ksh.eq.lsh) qq4 = qq4*0.5d0
c     do it!
                  if (nq .eq. max_q) then
                     call fock_txs(basis, nfock, vg_dens, vg_fock,
     $                    ilo, jlo, klo, llo, ihi, jhi, khi, lhi,
     $                    dij, dik, dli, djk, dlj, dlk,
     $                    fij, fik, fli, fjk, flj, flk,
     $                    dentol, nq, ijkl(1,1), ijkl(1,2),
     $                    ijkl(1,3),ijkl(1,4), q4)
                     nq = 0
                  end if
                  nq = nq + 1
                  ijkl(nq,1) = ish
                  ijkl(nq,2) = jsh
                  ijkl(nq,3) = ksh
                  ijkl(nq,4) = lsh
                  q4(nq)     = qq4
 300           end do            ! Next KL pair
            end do
            call fock_txs(basis, nfock, vg_dens, vg_fock,
     $           ilo, jlo, klo, llo, ihi, jhi, khi, lhi,
     $           dij, dik, dli, djk, dlj, dlk,
     $           fij, fik, fli, fjk, flj, flk,
     $           dentol, nq, ijkl(1,1), ijkl(1,2),
     $           ijkl(1,3),ijkl(1,4), q4)
            nq = 0
         end do
      end do
      if (.not. ma_free_heap(l_ijinfo))
     $     call errquit('fock2etask: cannot free iji',l_ijinfo, MA_ERR)
      if (.not. ma_free_heap(l_klinfo))
     $     call errquit('fock2etask: cannot free kli',l_klinfo, MA_ERR)
c     
      end
      subroutine fock_txs(basis, nfock, vg_dens, vg_fock,
     $     ilo, jlo, klo, llo, ihi, jhi, khi, lhi,
     $     dij, dik, dli, djk, dlj, dlk,
     $     fij, fik, fli, fjk, flj, flk,
     $     tol2e, nq, iq, jq, kq, lq, q4)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "cfock.fh"
#include "util.fh"
#include "stdio.fh"
c
      double precision ncomputed
      common /ctemp/ ncomputed
c
      integer basis
      integer nfock
      integer ilo, jlo, klo, llo, ihi, jhi, khi, lhi
      integer vg_dens(nfock), vg_fock(nfock)
      double precision dij(nfock,*), dik(nfock,*), dli(nfock,*),
     $     djk(nfock,*), dlj(nfock,*), dlk(nfock,*)
      double precision fij(nfock,*), fik(nfock,*), fli(nfock,*),
     $     fjk(nfock,*), flj(nfock,*), flk(nfock,*)
      double precision tol2e
      integer nq
      integer iq(*), jq(*), kq(*), lq(*)
      double precision q4(*)
c
      integer lenscr, leneri, lenlab, maxg
      integer l_eri, k_eri, l_lab, k_lab, l_scr, k_scr
      integer k_i, k_j, k_k, k_l
c
      integer neri
      double precision block_eff
      logical more
c
      logical int2e_file_write, intb_2e4c, intb_init4c
      external int2e_file_write, intb_2e4c, intb_init4c
c
      if (nq .le. 0) return
*      write(6,*) ' fock_txs : ', nq
c
      if (maxscr .eq. 0) then
*1 quartet         call int_mem_2e4c(maxg, lenscr)
         call intb_mem_2e4c(maxg, lenscr) ! blocking algorithm
      else
         lenscr = maxscr
      end if
      leneri = max(maxeri,maxg)
      lenlab = 4*leneri
      if (.not. ma_push_get(mt_dbl, leneri, 'eri', l_eri, k_eri))
     $     call errquit('fock_txs: no room for eri',leneri, MA_ERR)
      if (.not. ma_push_get(mt_dbl, lenscr, 'scr', l_scr, k_scr))
     $     call errquit('fock_txs: no room for scr',lenscr, MA_ERR)
      if (.not. ma_push_get(mt_int, lenlab, 'lab', l_lab, k_lab))
     $     call errquit('fock_txs: no room for lab',lenlab, MA_ERR)
c
      k_i = k_lab
      k_j = k_i   + leneri
      k_k = k_j   + leneri
      k_l = k_k   + leneri
c
      if (.not. intb_init4c(basis, iq, jq, basis, kq, lq,
     $     nq, q4, .true., lenscr, dbl_mb(k_scr), leneri, block_eff))
     $     call errquit('intb_init?',nq, INT_ERR)
c     
 50   more = intb_2e4c(basis, iq, jq, basis, kq, lq,
     $     nq, q4, .true., tol2e, .false.,
     $     int_mb(k_i), int_mb(k_j), int_mb(k_k), int_mb(k_l),
     $     dbl_mb(k_eri), leneri, neri, lenscr, dbl_mb(k_scr))
c
      if (neri .gt. 0) then
c
         ncomputed = ncomputed + neri
c     
c     Cache integrals if desired
c     
         if (owritefile) then
            if (.not. int2e_file_write(neri,
     $           int_mb(k_i), int_mb(k_j), int_mb(k_k), int_mb(k_l),
     $           dbl_mb(k_eri))) then
                  write(luout,*) 
                  write(luout,*) ' CHANGE TO DIRECT SCF '
                  write(luout,*) 
               call errquit(
     .        ' fock_2e_task: write failed with neri=',neri, INT_ERR)
            endif
         end if
c     
         call fock_2e_label(nfock, tol2e, neri,
     $        int_mb(k_i), int_mb(k_j), int_mb(k_k), int_mb(k_l),
     $        dbl_mb(k_eri),
     $        ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $        dij, dik, dli, djk, dlj, dlk,
     $        fij, fik, fli, fjk, flj, flk )
      endif
c     
      if (more) goto 50
c
 100  if (.not. ma_pop_stack(l_lab))
     $     call errquit('fock_txs: cannot free lab',lenlab, MA_ERR)
      if (.not. ma_pop_stack(l_scr))
     $     call errquit('fock_txs: cannot free scr',lenlab, MA_ERR)
      if (.not. ma_pop_stack(l_eri))
     $     call errquit('fock_txs: cannot free eri',lenlab, MA_ERR)
c
      end
      subroutine fock_den_sum(basis, nfock,
     $     iatlo, iathi, jatlo, jathi,
     $     dij, ilo, ihi, jlo, jhi, rdij, ldim, tol)
      implicit none
#include "errquit.fh"
#include "bas.fh"
#include "schwarz.fh"
c
      integer basis
      integer nfock
      double precision tol
      integer iatlo, iathi, jatlo, jathi
      integer ilo, ihi, jlo, jhi
      double precision dij(nfock,ilo:ihi,jlo:jhi)
      integer ldim
      double precision rdij(ldim,*)
c
      integer iat, jat, i, j, ifock
      integer ibflo, ibfhi, jbflo, jbfhi
      double precision sum
c
      do iat = iatlo, iathi
         if (.not. bas_ce2bfr(basis,iat,ibflo,ibfhi))
     $        call errquit('fock_den_sum :bas_ce2bfr iat', iat,
     &       BASIS_ERR)
         do jat = jatlo, jathi
            if (.not. bas_ce2bfr(basis,jat,jbflo,jbfhi))
     $           call errquit('fock_den_sum :bas_ce2bfr jat', jat,
     &       BASIS_ERR)
            sum = 0.0d0
            if (schwarz_atom(iat,jat).ge.tol) then
               if (nfock .eq. 1) then
                  do j = jlo, jhi
                     do i = ilo, ihi
                        sum = sum + abs(dij(1,i,j))
                     end do
                  end do
               else
                  do j = jlo, jhi
                     do i = ilo, ihi
                        do ifock = 1, nfock
                           sum = sum + abs(dij(ifock,i,j))
                        end do
                     end do
                  end do
               end if
            end if
            rdij(iat-iatlo+1,jat-jatlo+1) = sum
         end do
      end do
c
      end

* $Id: convert.f 19696 2010-10-29 16:53:42Z d3y133 $
c-----------------------------------------------------------------------
C This files contains a set of routines used to convert pair
c quantities into quartet quantities. These routines used to
c be included in different files, usually where they are called
c from. They are called with ...BL(IADDRESS).. double precision 
c parameters which then are of the INTEGER type in the routines. 
c It causes problems of incompatibile types for some compilers.
c-----------------------------------------------------------------------
c List of subroutines with previous location :
c
c amshift.f:      subroutine convr3(bl,m,nbls,npij,npkl,idx1,idx2,
c 
c derivat.f:      subroutine conv24x(nbls,npij,npkl,idx1,idx2 ,
c derivat.f:      subroutine conv24r(nbls,npij,idx1,xab,xabq)
c 
c spec_calcint.f: subroutine conv1x_1(nbls1,mmax1,npij,lcij, idx1,indx,
c spec_calcint.f: subroutine conv1der_1(nbls1,npij,lci,idx1,indx, aa, 
c spec_calcint.f: subroutine conv1der_2(nbls1,npij,lci,idx1,indx, aa,
c spec_calcint.f: subroutine conv1x_2(nbls1,mmax1,npij,lcij, idx1,indx,
c spec_calcint.f: subroutine conv2x(nbls1,nfumax1,npkl,lckl, idx2,indx,
c-----------------------------------------------------------------------
c=======================================================================
      subroutine convr3(bl,m,nbls,npij,npkl,idx1,idx2,
     *                   xab,xcd, ixabn,ixcdn)
      implicit real*8 (a-h,o-z)
      dimension bl(*)
      dimension idx1(*),idx2(*)
      dimension xab(npij,3),xcd(npkl,3)
c
      nbls1=nbls
      nbls2=nbls*2
      nbls3=nbls*3
      nbls1=nbls1*m
      nbls2=nbls2*m
      nbls3=nbls3*m
      call getmem(nbls3,ixabn)
      call getmem(nbls3,ixcdn)
c
       ixab1=ixabn-1
       ixcd1=ixcdn-1
c
      ijklnmr=0
      do 100 ijkl=1,nbls
      ijpar=idx1(ijkl)
      klpar=idx2(ijkl)
c
      xab1=xab(ijpar,1)
      xab2=xab(ijpar,2)
      xab3=xab(ijpar,3)
      xcd1=xcd(klpar,1)
      xcd2=xcd(klpar,2)
      xcd3=xcd(klpar,3)
c
        do 100 nmr=1,m
        ijklnmr=ijklnmr+1
        bl(ixab1+ijklnmr)      =xab1
        bl(ixab1+ijklnmr+nbls1)=xab2
        bl(ixab1+ijklnmr+nbls2)=xab3
c
        bl(ixcd1+ijklnmr)      =xcd1
        bl(ixcd1+ijklnmr+nbls1)=xcd2
        bl(ixcd1+ijklnmr+nbls2)=xcd3
c
  100 continue
      return
      end
c=======================================================================
      subroutine conv24x(nbls,npij,npkl,idx1,idx2 ,
     *                  xab ,xcd, xyab, xycd ,
     *                  xabq,xcdq,xyabq,xycdq )
      implicit real*8 (a-h,o-z)
c
      dimension idx1(nbls),idx2(nbls)
      dimension xab(npij,3) ,xcd(npkl,3) ,xyab(npij,3) ,xycd(npkl,3)
      dimension xabq(nbls,3),xcdq(nbls,3),xyabq(nbls,3),xycdq(nbls,3)
c
      do 100 ijkl=1,nbls
      ijpar=idx1(ijkl)
      klpar=idx2(ijkl)
        do 150 i=1,3
        xabq(ijkl,i)=xab(ijpar,i)
        xcdq(ijkl,i)=xcd(klpar,i)
        xyabq(ijkl,i)=xyab(ijpar,i)
        xycdq(ijkl,i)=xycd(klpar,i)
  150   continue
  100 continue
c
      end
c=======================================================================
      subroutine conv24r(nbls,npij,idx1,xab,xabq)
      implicit real*8 (a-h,o-z)
c
      dimension idx1(nbls)
      dimension xab(npij,3),xabq(nbls,3)
c
      do 100 ijkl=1,nbls
      ijpar=idx1(ijkl)
c     klpar=idx2(ijkl)
        do 150 i=1,3
        xabq(ijkl,i)=xab(ijpar,i)
c       xcdq(ijkl,i)=xcd(klpar,i)
  150   continue
  100 continue
      end
c=======================================================================
      subroutine conv1x_1(nbls1,mmax1,npij,lcij, idx1,indx,
     *                    abnia,xpn,abnix,xpnx )
c-------------------------------------------------------------------
c npij = number of uniqe pairs now
c-------------------------------------------------------------------
c
      implicit real*8 (a-h,o-z)
      dimension idx1(*),indx(*)
      dimension xpn(npij,3,*)
      dimension abnia(npij,mmax1,*)
c
      dimension xpnx(nbls1,3)
      dimension abnix(nbls1,mmax1)
c 
      do 10 i=1,nbls1
      ijkl=indx(i)
      ijpar=idx1(ijkl)
        xpnx(i,1)=xpn(ijpar,1,lcij)
        xpnx(i,2)=xpn(ijpar,2,lcij)
        xpnx(i,3)=xpn(ijpar,3,lcij)
   10 continue
c
      do 20 m=1,mmax1
      do 20 i=1,nbls1
      ijkl=indx(i)
      ijpar=idx1(ijkl)
        abnix(i,m)=abnia(ijpar,m,lcij)
   20 continue
      end
c=======================================================================
      subroutine conv1x_2(nbls1,mmax1,npij,lcij, idx1,indx,xpn,xpnx )
c
c npij = number of uniqe pairs now
c
c
      implicit real*8 (a-h,o-z)
      dimension idx1(*),indx(*)
      dimension xpn(npij,3,*)
      dimension xpnx(nbls1,3)
c 
      do 10 i=1,nbls1
      ijkl=indx(i)
      ijpar=idx1(ijkl)
        xpnx(i,1)=xpn(ijpar,1,lcij)
        xpnx(i,2)=xpn(ijpar,2,lcij)
        xpnx(i,3)=xpn(ijpar,3,lcij)
   10 continue
c
      end
c=======================================================================
      subroutine conv1der_1(nbls1,npij,lci,idx1,indx, aa, aax)
c
c npij = number of uniqe pairs now
c exponents are already rescaled by 2 in precal2a_1
c
      implicit real*8 (a-h,o-z)
      dimension idx1(*),indx(*)
      dimension aa(npij,*)
c output :
      dimension aax(nbls1)
c 
      do 10 i=1,nbls1
      ijkl=indx(i)
      ijpar=idx1(ijkl)
cccc    aax(i)=aa(ijpar,lci)*2.0d0   ! already rescaled
        aax(i)=aa(ijpar,lci)
   10 continue
c
      end
c=======================================================================
      subroutine conv1der_2(nbls1,npij,lci,idx1,indx, aa, aax)
c
c npij = number of uniqe pairs now
c
      implicit real*8 (a-h,o-z)
      dimension idx1(*),indx(*)
      dimension aa(npij,*)
c output :
      dimension aax(nbls1)
c-------------------------------------------------------------------
c this is for iroute=2 only: all exponents in a block are the same:
c exponents are already rescaled by 2 in precal2a_2
c-------------------------------------------------------------------
      aax(1)=aa(1,lci)
c
c     ijkl1 =indx(1)
c     ijpar1=idx1(ijkl1)
c     aax(1)=aa(ijpar1,lci)*2.d0
c----------------------------------------------
c     do 10 i=1,nbls1
c     ijkl=indx(i)
c     ijpar=idx1(ijkl)
c       aax(i)=aa(ijpar,lci)*2.0d0
c  10 continue
c----------------------------------------------
c
      end
c=======================================================================
      subroutine conv2x(nbls1,nfumax1,npkl,lckl, idx2,indx,
     *                  habcd,nfumax, habcdx  )
c
c npkl = number of uniqe pairs now
c
      implicit real*8 (a-h,o-z)
      dimension idx2(*),indx(*)
      dimension habcd(npkl,3,nfumax,*)
      dimension habcdx(nbls1,3,nfumax)
c
         do 32 ifu=1,nfumax1
         do 32 i=1,nbls1
         ijkl=indx(i)
         klpar=idx2(ijkl)
           habcdx(i,1,ifu)=habcd(klpar,1,ifu,lckl)
           habcdx(i,2,ifu)=habcd(klpar,2,ifu,lckl)
           habcdx(i,3,ifu)=habcd(klpar,3,ifu,lckl)
   32    continue
      end
c=======================================================================

      subroutine argos_space_prefetch_next(iwl,xw,isl,xs)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
c
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(2),ps(2)
      real*8 pwp(2),psp(2)
      logical lfetch,lnext
      integer ibbl,nfetched
c
      if(icbbl.ge.nbbl) return
c
      nfetched=0
      do 1 ibbl=icbbl+1,nbbl
      call argos_space_ibbl_prefetch(ibbl,int_mb(i_bb),int_mb(i_ipl),
     + int_mb(i_jpl),iwl,int_mb(i_packw),xw,pw,pwp,isl,int_mb(i_pack),
     + xs,ps,psp,.false.,lfetch,lnext)
      icbbl=ibbl
      if(lfetch) nfetched=nfetched+1
      if(nfetched.gt.0.and..not.lnext) return
 1    continue
c
      return
      end
 
c $Id: argos_space_prefetch_next.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_setbox(vl)
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      real*8 vl(3,3)
c
      integer i,j
c
      do 1 i=1,3
      box(i)=vl(i,i)
      boxh(i)=half*box(i)
      do 2 j=1,3
      vlat(i,j)=vl(i,j)
    2 continue
    1 continue
      volume=box(1)*box(2)*box(3)
c
      return
      end
c $Id: argos_cafe_setbox.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: lcao_generate_vlmatrix.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      subroutine lcao_generate_vlmatrix(vlmatrix,phi1,phi2)
      implicit none
#include "errquit.fh"
      integer vlmatrix
      complex*16 phi1(*)
      complex*16 phi2(*)

#include "mafdecls.fh"
#include "global.fh"

*     **** local variables ****
      logical move,value
      integer i,j,nbasis,npack1,n2ft3d,nfft3d
      integer nx,ny,nz
      real*8  sum,fion(3),scal1,scal2
      complex*16 junk(2)
      integer vl(2),vlr_l(2),rgrid(2),vpsi

*     ***** external functions ****
      integer  aorbs_nbasis,control_version
      real*8   lattice_omega
      external aorbs_nbasis,control_version
      external lattice_omega

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()

      call Pack_npack(1,npack1)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      value = MA_push_get(mt_dcpl,nfft3d,'vall',vl(2),vl(1))
      value = value.and.
     >        MA_push_get(mt_dbl,n2ft3d,'vlr_l',vlr_l(2),vlr_l(1))
      vpsi = vlr_l(1)
      if (control_version().eq.4)
     >  value = value.and.
     >        MA_push_get(mt_dbl,(3*n2ft3d),'rgrid',rgrid(2),rgrid(1))
      if (.not. value) 
     > call errquit('lcao_generate_vlmatrix: out of stack memory',0,
     &       MA_ERR)


*     *****************************************
*     **** generate local pseudopotential  ****
*     *****************************************
      move =.false.
      call v_local(dcpl_mb(vl(1)),
     >             move,
     >             junk,
     >             fion)
*     *** long-range psp for charge systems ***
      if (control_version().eq.4) then
        call lattice_r_grid(dbl_mb(rgrid(1)))
        call v_lr_local(dbl_mb(rgrid(1)),
     >                  dbl_mb(vlr_l(1)))
        value = MA_pop_stack(rgrid(2))
      end if

*     **********************************************************
*     **** add up k-space potentials, vall = scal2*vsr_l    ****
*     **********************************************************
c      call Pack_c_SMul(0,scal2,dcpl_mb(vl(1)),dcpl_mb(vl(1)))
      call Pack_c_SMul1(0,scal2,dcpl_mb(vl(1)))


*     **********************************************
*     **** fourier transform k-space potentials ****
*     **********************************************
      call Pack_c_unpack(0,dcpl_mb(vl(1)))
      call D3dB_cr_pfft3b(1,0,dcpl_mb(vl(1)))

*     **********************************
*     **** add vlr_l                ****
*     **********************************
      if (control_version().eq.4) then
c        call D3dB_rr_Sum(1,dcpl_mb(vl(1)),
c     >                   dbl_mb(vlr_l(1)),
c     >                   dcpl_mb(vl(1)))
        call D3dB_rr_Sum2(1,dbl_mb(vlr_l(1)),dcpl_mb(vl(1)))
      end if



      nbasis = aorbs_nbasis()
      do j=1,nbasis

*        **** get phi2 ****
         call aorbs_aorb(j,phi2)
   
*       **** get psi_r ****
         call Pack_c_Copy(1,phi2,dbl_mb(vpsi))
         call Pack_c_unpack(1,dbl_mb(vpsi))
         call D3dB_cr_pfft3b(1,1,dbl_mb(vpsi))
         call D3dB_r_Zero_Ends(1,dbl_mb(vpsi))

c         call D3dB_rr_Mul(1,dcpl_mb(vl(1)),
c     >                      dbl_mb(vpsi),
c     >                      dbl_mb(vpsi))
         call D3dB_rr_Mul2(1,dcpl_mb(vl(1)),dbl_mb(vpsi))

*        *******************************
*        **** get vpsi_r in k-space ****
*        *******************************
         call D3dB_rc_pfft3f(1,1,dbl_mb(vpsi))
         call Pack_c_pack(1,dbl_mb(vpsi))
         call Pack_c_Copy(1,dbl_mb(vpsi),phi2)

         do i=1,j

*           **** get phi1 ****
            call aorbs_aorb(i,phi1)
            call Pack_cc_dot(1,phi1,phi2,sum)
            sum = sum*scal1

            call ga_fill_patch(vlmatrix,i,i,j,j,sum)
            call ga_fill_patch(vlmatrix,j,j,i,i,sum)
         end do
      end do

      value = MA_pop_stack(vlr_l(2))
      value = MA_pop_stack(vl(2))
     
      return
      end

      subroutine tce_grad_force(rtdb,model,basis,geom,
     1       d_1pdm, k_1pdm_offset, size_1pdm,
     1       d_1pwdm,k_1pwdm_offset,size_1pwdm,
     1       d_2pdm, k_2pdm_offset, size_2pdm,
     1       noab,nvab,k_range,k_offset,k_spin,
     1       k_movecs_sorted,restricted)
c     $Id: tce_grad_force.F 19706 2010-10-29 17:52:31Z d3y133 $
C     calculate energy gradients with respect to nuclear coordinates
C------------------------------------------------------------------------------
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "bas.fh"
#include "geom.fh"
#include "util.fh"
#include "sym.fh"
#include "stdio.fh"
#include "msgids.fh"
#include "apiP.fh"
#include "inp.fh"

      integer rtdb, basis,geom
c
      character*10 model
      integer d_1pdm,  k_1pdm_offset,  size_1pdm
      integer d_1pwdm, k_1pwdm_offset, size_1pwdm
      integer d_2pdm,  k_2pdm_offset,  size_2pdm
      integer noab,nvab,k_range,k_offset,k_movecs_sorted,k_spin
      integer k_2pdm_ao,l_2pdm_ao,k,l
      logical restricted
      integer g_1pdm,  g_1pwdm
      integer d_2pdm_ao,l_2pdm_ao_offset,k_2pdm_ao_offset,size_2pdm_ao
      integer idim,jdim,kdim,ldim,i_ind,j_ind,k_ind,l_ind,i1,j1,k1,l1
      integer ib,jb,kb,lb
      character*255 filename
      double precision res
c     ====================
c     atomic orbital tiles
c     ====================
      integer atpart2
      integer nalength2(200)
      integer a2length2(200)
c
      integer g1b
      integer g1
      integer l_a,k_a,l_dim_shb,k_dim_shb
      integer l_mo_tmp,k_mo_tmp,dima
      
c
      double precision cpu_tim(2), wall_tim(2)
c
      integer  ga_create_atom_blocked
      external ga_create_atom_blocked
c
      integer g_dens(6),        ! density matrices(up to 6)
     $        g_wdens,          ! energy weighted density
     $        g_eigen_diag,     ! eigenvalue diagonal matrix or lagrangian
     $        g_force           ! forces on atoms(cartesian)
c
      character*255 movecs_in
c
      integer nproc, nat, nbf, nsh,max_sh_bf, max_at_bf, nopen,
     &        nclosed, 
     $        ndens, nbf2, nocc, max1e, max2e, mscratch_1e, mscratch_2e,
     $        lbuf, lscratch, lsqa, lsqatom, i, j, iat
c
      integer l_shmap, l_shglo, l_shghi, l_bfmap, l_rbfmap, 
     $        l_bfglo, l_bfghi, l_labels, l_list, l_q4, l_bftoat
      integer k_shmap, k_shglo, k_shghi, k_bfmap, k_rbfmap, 
     $        k_bfglo, k_bfghi, k_labels, k_list, k_q4, k_bftoat
      integer l_shbflo, l_shbfhi
      integer k_shbflo, k_shbfhi
c      
      integer lforce, l_force, k_force, l_evals, k_evals, l_occ, k_occ,
     $        l_act, k_act, 
     $        l_buf, k_buf, l_scr, k_scr, l_dens, k_dens, 
     1        l_wdens, k_wdens,
     $        k_frc_nuc, k_frc_kin, k_frc_2el, k_frc_wgh, k_frc_cd,
     $        l_frc_nuc, l_frc_kin, l_frc_2el, l_frc_wgh, l_frc_cd,
     $        l_frc_mp2, k_frc_mp2

c     pdm2d is now used by all methods.  pdm2/a/b/c only by MCSCF
      integer l_pdm2, l_pdm2a, l_pdm2b, l_pdm2c, l_pdm2d ! MCSCF 2-pdm
      integer k_pdm2, k_pdm2a, k_pdm2b, k_pdm2c, k_pdm2d ! MCSCF 2-pdm
      integer l_coeff, k_coeff  ! MCSCF local copy of Active space MOs

      integer nactive, nshblocks

      integer blen              ! bf-blocking size for shell ordering
      integer maxblen           ! maximum value for blen = max no. bf in group
      integer maxsh             ! maximum no. of shells in a group
      integer maxq              ! max quartets in a request
      parameter (maxblen=36, maxsh=10)
      parameter (maxq=maxsh**4)
c
      integer 
     $     lh_ij,  ld_ij, lh_kl, ld_kl, lh_ik, ld_ik, 
     $     lh_jl,  ld_jl, lh_il, ld_il,
     $     lh_jk,  ld_jk, 
     $     lh_ij2, ld_ij2, lh_kl2, ld_kl2, lh_ik2, ld_ik2,
     $     lh_jl2, ld_jl2, lh_il2, ld_il2, lh_jk2, ld_jk2,
     $     lh_ij3, ld_ij3, lh_kl3, ld_kl3, lh_ik3, ld_ik3,
     $     lh_jl3, ld_jl3, lh_il3, ld_il3, lh_jk3, ld_jk3,
     $     lh_ij4, ld_ij4, lh_kl4, ld_kl4, lh_ik4, ld_ik4,
     $     lh_jl4, ld_jl4, lh_il4, ld_il4, lh_jk4, ld_jk4

      double precision crd(3),  ! atomic coordinates
     $     tol2e, q

      double precision grad_norm, grad_max

      external grad_norm, grad_max

      character*16 tag
      character*32 theory
      character*8  scftype
      character*32 rtdb_string

c    
c     Stuff for Douglas-Kroll
c
      logical  dkdiv_energy, num_grad, file_write_ga  ! Three data blocks needed
      external dkdiv_energy, num_grad, file_write_ga  ! for the possible addition
      integer  l_dkdivfrc,   k_dkdivfrc               ! of Douglas-Kroll contribution
      character*(nw_max_path_len) dkdiv_name
      character*128 mytheory
c
*     Stuff for DFT

      integer ipol, numfunc, noc(2)
      integer ld_ik5,ld_jl5,ld_il5,ld_jk5,
     $        ld_ik6,ld_jl6,ld_il6,ld_jk6,
     $        ld_ik7,ld_jl7,ld_il7,ld_jk7,
     $        ld_ik8,ld_jl8,ld_il8,ld_jk8

c
c     cosmo flag
c
      logical odbug
      logical ocosmo
      logical osome

      parameter (numfunc = 40)
      logical oskel, omp2, odft, ocdfit, status,frac_occ
      double precision xfac(numfunc), jfac, kfac
c->pdfan
      logical otce
      integer nprocs
      integer count
      integer next
      integer nxtask
      external nxtask
c<-pdfan

      nproc = ga_nnodes()

      jfac = 1.0d0              ! Only changed for DFT
      kfac = 1.0d0
C     get information about basis set
      if (.not. geom_ncent(geom,nat))
     $     call errquit('tce_grad_force: could not get natoms',0, 
     2     GEOM_ERR)
      if (.not. bas_numbf(basis,nbf))
     $     call errquit('tce_grad_force: could not get nbf',0, 
     1     BASIS_ERR)
      if (.not. bas_numcont(basis,nsh))
     $     call errquit('tce_grad_force: could not get nsh',0, 
     1     BASIS_ERR)
c     
c     Atom blocking now only used for the 1-e integrals (history)
c     
      if (.not. bas_nbf_ce_max(basis,max_at_bf))
     $     call errquit('tce_grad_force: could not get max_at_bf',0, 
     1     BASIS_ERR)
      if (.not. bas_nbf_cn_max(basis,max_sh_bf))
     $     call errquit('tce_grad_force: could not get max_sh_bf',0, 
     1     BASIS_ERR)

      blen = min(nbf,maxblen,6*max_sh_bf) ! d(6)*6=36, 6**4=1296 quartets

      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $     call errquit('tce_grad_force: failed getting theory',0, 
     1     RTDB_ERR)

C     get SCF MO vectors for density

      odft = .false.
      if (theory .eq. 'mcscf') then
         if (.not. rtdb_cget(rtdb, 'mcscf:input vectors', 1, movecs_in))
     $      call errquit('tce_grad_force: MCSCF MO vectors not defined',
     1      0,RTDB_ERR)
         scftype = 'mcscf'
      else if (theory .eq. 'dft') then
         odft = .true.
         if (.not. rtdb_cget(rtdb, 'dft:input vectors', 1, movecs_in))
     $        call errquit('tce_grad_force: DFT MO vectors not defined',
     1        0,RTDB_ERR)
         if (.not. rtdb_get(rtdb, 'dft:cdfit', mt_log, 1, ocdfit))
     $        ocdfit = .false.
         if (.not. rtdb_get(rtdb, 'dft:xfac', mt_dbl, numfunc, xfac))
     $        call errquit('tce_grad_force: xfac not in rtdb ', 0,
     &        RTDB_ERR)
         if (.not. rtdb_get(rtdb, 'dft:ipol', mt_int, 1, ipol))
     $        ipol = 1
         if (ipol .eq. 1) then
            scftype = 'rhf'
         else
            scftype = 'uhf'
         endif
         jfac = 1.0d0
         if (ocdfit) jfac = 0.0d0
         kfac = xfac(1)
      else
         if (.not. rtdb_cget(rtdb, 'scf:scftype', 1, scftype))
     $        call errquit('tce_grad_force: scftype not defined',0,
     &        RTDB_ERR)
         if (.not. rtdb_cget(rtdb, 'scf:input vectors', 1, movecs_in))
     $        call errquit('tce_grad_force: SCF MO vectors not defined',
     1        0,RTDB_ERR)
      end if

C     get information about type of calculation

      if ((theory .eq. 'mp2') 
     $     .or.(theory .eq. 'semi_dir_mp2')
     $     .or.(theory .eq. 'direct_mp2')) then
         omp2 = .true.
      else
         omp2 = .false.
      end if
c
c->pdfan
      if (theory.eq.'tce') then
        otce = .true.
      else
        otce = .false.
      endif
c<-pdfan
c
C     scftype: MCSCF, RHF, ROHF or UHF

      if (scftype .eq. 'mcscf') then
         if (.not. rtdb_get(rtdb, 'mcscf:nclosed', mt_int, 1, nclosed))
     $        nclosed = 0
         if (.not. rtdb_get(rtdb, 'mcscf:nact', mt_int, 1, nopen))
     $        call errquit('tce_grad_force: no mcscf active orbitals?',
     1        0,RTDB_ERR)
      else if (odft) then
         if (.not. rtdb_get(rtdb, 'dft:noc', mt_int, 2, noc))
     &        call errquit('tce_grad_force: rtdb_get of noc failed', 0,
     &       RTDB_ERR)
         if (ipol .eq. 1) then
            nclosed = noc(1)
            nopen   = 0
         else
            nclosed = min(noc(1),noc(2))
            nopen   = abs(noc(1) - noc(2))
         endif
      else
         if (.not. rtdb_get(rtdb, 'scf:nopen', mt_int, 1, nopen))
     $        nopen = 0
         if (.not. rtdb_get(rtdb, 'scf:nclosed', mt_int, 1, nclosed))
     $        call errquit('tce_grad_force: get of nclosed? ', 0, 
     1        RTDB_ERR)
         
C     is it MP2?
c         if (.not. omp2) then
          if((.not.omp2).and.(.not.otce)) then
            if (ga_nodeid() .eq. 0) then
               if (util_print('information', print_medium)) then
                  if (odft) then
                     write(luout,101) ' dft ', ipol
 101                 format(/'  wavefunction    =   ', a, ' ipol =',i2/)
                  else
                     write(luout,1) scftype
 1                   format(/'  wavefunction    =   ', a/)
                  endif
                  call util_flush(luout)
               end if
            end if
         end if
c         
      end if
c
c->pengdong.fan
c tce
      if (otce) then
         if (ga_nodeid().eq.0) then
            if (util_print('information',print_medium)) then
               if (model.eq.'ccsd') then
                   write(luout,11) scftype,'CCSD'
11                 format(/'  wavefunction    =   TCE ', a,a/)
               else if(model.eq.'ccsdt') then
                   write(luout,11) scftype,'CCSDT'
               else if(model.eq.'ccsdtq') then
                   write(luout,11) scftype,'CCSDTQ'
               else if(model.eq.'mbpt2') then
                   write(luout,11) scftype,'MP2'
               else if(model.eq.'mbpt3') then
                   write(luout,11) scftype,'MP3'
               else if(model.eq.'mbpt4') then
                   write(luout,11) scftype,'MP4'
               else if(model.eq.'cis') then
                   write(luout,11) scftype,'CIS'
               else if(model.eq.'cisd') then
                   write(luout,11) scftype,'CISD'
               else if(model.eq.'cisdt') then
                   write(luout,11) scftype,'CISDT'
               else if(model.eq.'cisdtq') then
                   write(luout,11) scftype,'CISDTQ'               
               else
                  call errquit('tce_grad_force: not implement yet',109,
     1                 capmis_err)
               endif
            endif
         endif
      endif
c 
      call inp_ucase(scftype)

C     # of eigenvalues and density matrices
      if (omp2) then
         if (scftype .eq. 'UHF') then
            nbf2 = 2 * nbf
            ndens = 5
         else if (scftype .eq. 'RHF') then
            nbf2 = nbf
            ndens = 3
         else                   ! ROHF
            nbf2 = nbf
            ndens = 3
            call errquit('tce_grad_force:no ROMP2 gradients yet', 110, 
     1      CAPMIS_ERR)
         end if
      else                      ! SCF
         if (scftype .eq. 'UHF') then
            nbf2 = 2 * nbf
            ndens = 2
         else if (scftype .eq. 'RHF') then
            nbf2 = nbf
            ndens = 1
         else if (scftype .eq. 'MCSCF') then
            nbf2 = nbf
            ndens = 1
         else                   ! ROHF
            nbf2 = nbf
            ndens = 3
         end if
      end if

C     allocate and initialize global and local memory

C     forces on atoms(3xnat)
*ga:1:0
      if (.not. ga_create(mt_dbl, 3, nat, 'forces', 3, 0, g_force))
     $     call errquit('tce_grad_force: failed to create force GA',0,
     &       GA_ERR)
      call ga_zero(g_force)

C     local replication(separate for the different pieces)
      lforce = nat * 3
      if (.not. ma_push_get(mt_dbl,lforce,'forces',l_force,k_force))
     $     call errquit('tce_grad_force:could not allocate l_force',
     1     lforce,MA_ERR)
      if (.not. ma_push_get(mt_dbl, lforce, 'forces', l_frc_nuc, 
     $     k_frc_nuc)) call errquit
     &    ('tce_grad_force:could not allocate l_force',lforce, MA_ERR)
      if (.not. ma_push_get(mt_dbl, lforce, 'forces', l_frc_kin, 
     $     k_frc_kin)) call errquit
     &    ('tce_grad_force:could not allocate l_force',lforce, MA_ERR)
      if (.not. ma_push_get(mt_dbl, lforce, 'forces', l_frc_wgh, 
     $     k_frc_wgh)) call errquit
     &    ('tce_grad_force:could not allocate l_force',lforce, MA_ERR)
      if (.not. ma_push_get(mt_dbl, lforce, 'forces', l_frc_2el, 
     $     k_frc_2el)) call errquit
     &    ('tce_grad_force:could not allocate l_force',lforce, MA_ERR)
      if (omp2) then
         if (.not. ma_push_get(mt_dbl, lforce, 'forces', l_frc_mp2, 
     $        k_frc_mp2)) call errquit
     &      ('tce_grad_force:could not allocate l_force',lforce, MA_ERR)
      end if
      if (odft) then
         if (.not. ma_push_get(mt_dbl, lforce, 'forces', l_frc_cd, 
     $        k_frc_cd)) call errquit
     &      ('tce_grad_force:could not allocate l_force',lforce, MA_ERR)
      end if

C     global density
c      do i=1, ndens
c         g_dens(i) = ga_create_atom_blocked(geom, basis, 
c     $        'density matrix')
c      end do
       g_1pdm = ga_create_atom_blocked(geom, basis,
     $        'density matrix')
c     
      if (scftype .eq. 'MCSCF') then
         if (.not. ma_push_get(mt_dbl, nopen**4, 'pdm2', 
     $        l_pdm2 , k_pdm2 )) call errquit
     $        ('tce_grad_force:failed allocating pdm2',nopen**4, MA_ERR)
         if (.not. ma_push_get(mt_dbl, (blen**1)*(nopen**3), 'pdm2a',
     $        l_pdm2a, k_pdm2a)) call errquit
     $        ('tce_grad_force:failed allocating pdm2a',
     1        (blen**1)*(nopen**3),
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, (blen**2)*(nopen**2), 'pdm2b',
     $        l_pdm2b, k_pdm2b)) call errquit
     $        ('tce_grad_force:failed allocating pdm2b',
     1        (blen**2)*(nopen**2),
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, (blen**3)*(nopen**1), 'pdm2c',
     $        l_pdm2c, k_pdm2c)) call errquit
     $        ('tce_grad_force:failed allocating pdm2c',
     1        (blen**3)*(nopen**1),
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, nopen*nbf, 'coeff',
     $        l_coeff, k_coeff)) call errquit
     $        ('tce_grad_force:failed allocating coeff',nopen*nbf,
     1        MA_ERR)
      else
         k_pdm2  = 1            ! To avoid SEGV
         k_pdm2a = 1
         k_pdm2b = 1
         k_pdm2c = 1
         k_coeff = 1
      end if
c     
      if (.not. ma_push_get(mt_dbl, blen**4, 'pdm2d',
     $     l_pdm2d, k_pdm2d)) call errquit
     $     ('tce_grad_force:failed allocating pdm2d',blen**4, MA_ERR)

C     lookup table and list of active atoms
      if (.not. ma_push_get(MT_LOG,nat,'active atoms',l_act,k_act))
     $     call errquit('tce_grad_force: could not allocate l_act',nat,
     1     MA_ERR)

C     symmetry or not
      if (.not. rtdb_get(rtdb, 'gradients:use symmetry', mt_log, 1,
     $     oskel)) then
         if (.not. rtdb_get(rtdb, 'scf:skeleton', mt_log, 1,
     $        oskel)) then
            oskel = sym_number_ops(geom) .gt. 0
         end if
      end if
c     
      if (oskel .and. ga_nodeid().eq.0 .and. 
     $     util_print('information', print_default)) then
         write(luout,*) ' Using symmetry'
         call util_flush(luout)
      end if
c     
C     energy weighted density(NxN)
c      g_wdens = ga_create_atom_blocked(geom, basis, 'weighted density')
      g_1pwdm = ga_create_atom_blocked(geom, basis, 'weighted density')

C     eigenvalue diagonal matrix for forming energy weighted density
      nocc = nopen + nclosed
*ga:1:0
      if (.not. ga_create(mt_dbl, nocc, nocc,'eigen_diag', 0, nocc, 
     $     g_eigen_diag)) call errquit('tce_grad_force: ga diags?',
     1     nocc*nocc,
     &     GA_ERR)
      call ga_zero(g_eigen_diag)

C     eigenvalues
      if (.not. ma_push_get(mt_dbl, nbf2,'MO evals', l_evals, k_evals))
     $     call errquit('tce_grad_force: could not allocate l_evals',
     1     nbf2,
     &     MA_ERR)
C     occupation numbers
      if (.not. ma_push_get(mt_dbl, nbf2,'occ. numbers', l_occ, k_occ))
     $     call errquit('tce_grad_force: could not allocate l_occ',
     1     nbf2,
     &     MA_ERR)
c     
      call grad_active_atoms(rtdb, nat, log_mb(k_act), nactive)
c     
c
c     check if smearing is on
c
      if (.not.rtdb_get(rtdb, 'dft:fractional_occup', mt_log, 1,
     & frac_occ  )) frac_occ=.false.
c
c->pengdong.fan
c      call tce_grad_dens(geom, basis, g_dens, g_wdens, g_eigen_diag, 
c     $     dbl_mb(k_evals), dbl_mb(k_occ), ndens, nbf, nbf2, 
c     $     nopen, nclosed, scftype, movecs_in, omp2, 
c     $     dbl_mb(k_pdm2), dbl_mb(k_coeff),frac_occ,.false.)
c
c       call ga_put(g_dens,1,nbf,1,nbf,dbl_mb(k_1pdm_ao),nbf)
c       call ga_put(g_wdens,1,nbf,1,nbf,dbl_mb(k_1pwdm_ao),nbf)
        call ao_tiles(atpart2,nalength2,a2length2,30)
c        call print_1pdm_mo(d_1pdm,k_1pdm_offset,size_1pdm)
        call btrans1(d_1pdm,k_1pdm_offset,g_1pdm,atpart2,nalength2)
        call ga_symmetrize(g_1pdm)
c        call ga_print(g_1pdm)
        call dscalfile(-1.d0,d_1pwdm,size_1pwdm)
c        call print_1pdm_mo(d_1pwdm,k_1pwdm_offset,size_1pwdm)
        call btrans1(d_1pwdm,k_1pwdm_offset,g_1pwdm,atpart2,nalength2)
        call ga_symmetrize(g_1pwdm)
c->debug
c       write(6,*) 'debug g_wdens'
c       call ga_print(g_wdens)
c       write(6,*) 'end of debug g_wdens'
c<-denug
c
c<-pengdong.fan
c            
C     free temporary arrays
      if (.not. ga_destroy(g_eigen_diag))
     $     call errquit('tce_grad_force: could not destroy g_eigen_diag'
     1     ,1,
     &     GA_ERR)

      if (.not.ma_pop_stack(l_occ))
     $     call errquit('tce_grad_force:ma free occ',1, MA_ERR)
      if (.not.ma_pop_stack(l_evals))
     $     call errquit('tce_grad_force:ma free eval',1, MA_ERR)

C     initialize for integral gradients
c->d3p975
      call int_init(rtdb, 1, basis)
      call schwarz_init(geom, basis)
      call int_terminate()
      call intd_init(rtdb, 1, basis)
c<-d3p975
      call dfill(lforce, 0.0D0, dbl_mb(k_force), 1)
      call dfill(lforce, 0.0D0, dbl_mb(k_frc_nuc), 1)
      call dfill(lforce, 0.0D0, dbl_mb(k_frc_kin), 1)
      call dfill(lforce, 0.0D0, dbl_mb(k_frc_wgh), 1)
      call dfill(lforce, 0.0D0, dbl_mb(k_frc_2el), 1)
      call int_mem(max1e, max2e, mscratch_1e, mscratch_2e)
      call intb_mem_2e4c(max2e, mscratch_2e) ! blocking algorithm
      max2e = max(max2e,1296*100)            ! 100 D quartets 
      lbuf = max(max1e, max2e)
      lscratch = max(mscratch_1e, mscratch_2e)
C     one-electron contribution
C     buffers for one electron integral derivatives

      if (.not. ma_push_get(mt_dbl,lbuf,'deriv buffer',l_buf,k_buf))
     $     call errquit('tce_grad_force:could not allocate buffer',lbuf,
     &       MA_ERR)
*      call ma_summarize_allocated_blocks()
      if (.not. ma_push_get(mt_dbl,lscratch,'deriv scratch', 
     $     l_scr, k_scr))
     1     call errquit('tce_grad_force: scratch alloc failed',
     $     lscratch, MA_ERR)
      if (.not. ma_push_get(mt_int,lbuf/3,'labels',l_labels,k_labels))
     $     call errquit('tce_grad_force: could not allocate labels',
     1     lbuf/3,
     &     MA_ERR)
c     
C     local density matrix block 
      lsqatom = max_at_bf * max_at_bf
      if (.not. ma_push_get(mt_dbl,lsqatom,'local_density',
     $     l_dens,k_dens))
     $     call errquit('tce_grad_force:could not allocate l_dens',
     1     lsqatom,
     &     MA_ERR)
      if (.not. ma_push_get(mt_dbl,lsqatom,'local_w_density',l_wdens, 
     $     k_wdens)) call errquit
     &    ('tce_grad_force:could not allocate l_wdens',lsqatom, MA_ERR)
c     
      cpu_tim(1)  = util_cpusec()
      wall_tim(1) = util_wallsec()
c      call tce_grad1(dbl_mb(k_buf),lbuf,dbl_mb(k_scr),lscratch,
c     $     dbl_mb(k_dens), dbl_mb(k_wdens), dbl_mb(k_frc_nuc),
c     $     dbl_mb(k_frc_kin), dbl_mb(k_frc_wgh), g_force,
c     $     g_dens, g_wdens, basis, geom, nproc, nat, max_at_bf,
c     $     rtdb, oskel)
      call tce_grad1(dbl_mb(k_buf),lbuf,dbl_mb(k_scr),lscratch,
     $     dbl_mb(k_dens), dbl_mb(k_wdens), dbl_mb(k_frc_nuc),
     $     dbl_mb(k_frc_kin), dbl_mb(k_frc_wgh), g_force,
     $     g_1pdm, g_1pwdm, basis, geom, nproc, nat, max_at_bf,
     $     rtdb, oskel)
c
c
c     ----- cosmo contribution -----
c
      odbug=.false.
      odbug=odbug.and.ga_nodeid().eq.0
      if ( rtdb_get(rtdb,'slv:cosmo',mt_log,1,ocosmo)) then
         if(odbug) then
            write(luout,*) '-cosmo- ... found in -gradients-',
     $                     ocosmo,ga_nodeid()
         endif
         if(ocosmo) then
            if(odbug) then
               osome=.true.
            else
               osome=.false.
            endif
            osome=osome.and.ga_nodeid().eq.0
            if(odbug) then
               write(luout,*) '-cosmo- ... found and .true. ',
     $                        ocosmo,ga_nodeid()
               write(luout,*) 'calling -cosder- ...'
            endif
c
c     .....
c
c            call grad_hnd_cos( dbl_mb(k_buf), lbuf, dbl_mb(k_scr), 
c     $           lscratch,
c     $           dbl_mb(k_dens), dbl_mb(k_wdens), dbl_mb(k_frc_nuc),
c     $           dbl_mb(k_frc_kin), dbl_mb(k_frc_wgh), g_force,
c     $           g_dens, g_wdens, basis, geom, nproc, nat, max_at_bf,
c     $           rtdb, oskel)
            call grad_hnd_cos( dbl_mb(k_buf), lbuf, dbl_mb(k_scr),
     $           lscratch,
     $           dbl_mb(k_dens), dbl_mb(k_wdens), dbl_mb(k_frc_nuc),
     $           dbl_mb(k_frc_kin), dbl_mb(k_frc_wgh), g_force,
     $           g_1pdm, g_1pwdm, basis, geom, nproc, nat, max_at_bf,
     $           rtdb, oskel)
         else
            if(odbug) then
               write(luout,*) '-cosmo- ... found but .false.',
     $                        ocosmo,ga_nodeid()
            endif
         endif
      else
         if(odbug) then
            write(luout,*) '-cosmo- not found in -gradients-'
         endif
      endif
      call ga_sync()
c
c     Check if we have to deal with Douglas-Kroll type integrals. If so,
c     we have to add the numerical derivative of the integral type
c     (Douglas-Kroll - Non-Relativistic). In this way the non-relativistic
c     kinetic and potential energy integral derivatives are computed
c     analytically and only the relativistic "Douglas-Kroll" correction
c     is done numerically. Numerical errors are reduced in this way and
c     at the same time the construction of the complex Douglas-Kroll
c     integral derivatives is avoided.
c
      if (doug_kroll) then
c
         call intd_terminate()
c
c        Write density to file for use by Douglas-Kroll energy routine
c
         call util_file_name('dkdiv_density',.true.,.true.,dkdiv_name)
c         if (.not. file_write_ga(dkdiv_name,g_dens(1)))
c     $       call errquit('tce_grad_force:file_write_ga density failed',
c     1       0,DISK_ERR)
c
         if (.not. file_write_ga(dkdiv_name,g_1pdm))
     $       call errquit('tce_grad_force:file_write_ga density failed',
     1       0,DISK_ERR)
c
c
c        Do numerical gradient for (Douglas-Kroll - Non-relativistic)
c
         if (ga_nodeid() .eq. 0) then
            call util_print_centered(luout,'Douglas-Kroll gradients',
     $                               40,.true.)
            write(luout,105) 
  105       format(/
     $           12x,
     $           'The Douglas-Kroll correction to the gradient is '/
     $           12x,
     $           'computed numerically and added to the analytical '/
     $           12x,
     $           'non-relativistic gradients.'//)
         endif
         mytheory = 'Douglas-Kroll correction to'
         if (.not. num_grad(rtdb,dkdiv_energy,'grad_dk:dkdiv_energy',
     $       'grad_dk:dkdiv_frc', mytheory, .false.))
     $       call errquit('tce_grad_force: task_num_grad failed',0,
     &       UNKNOWN_ERR)
c
c        Add total Douglas-Kroll - Non-relativistic contribution to 
c        array on node 0. There is a global sum later on.
c
         if (ga_nodeid() .eq. 0) then
            status = rtdb_parallel(.false.)
            if (.not. ma_push_get(mt_dbl, 3*nat, 'dkdiv_frc',
     $          l_dkdivfrc, k_dkdivfrc)) call errquit
     $          ('tce_grad_force: ma_push_get dkdiv_frc failed',0,
     1          RTDB_ERR)
            if (.not. rtdb_get(rtdb, 'grad_dk:dkdiv_frc', mt_dbl,
     $          3*nat, dbl_mb(k_dkdivfrc))) call errquit
     $          ('tce_grad_force: could not read grad_dk:dkdiv_frc',0,
     &          RTDB_ERR)
            do i = 0, 3*nat-1
               dbl_mb(k_force+i) = dbl_mb(k_force+i) +
     $                             dbl_mb(k_dkdivfrc+i)
            enddo
            if (.not. ma_pop_stack(l_dkdivfrc))
     $         call errquit('tce_grad_force: ma_pop_stack failed',0,
     1         MA_ERR)
            status = rtdb_parallel(.true.)
         endif
         call util_file_unlink(dkdiv_name)
         call intd_init(rtdb, 1, basis)
      endif
c
      call ga_sync
c
      cpu_tim(1)  = util_cpusec() - cpu_tim(1)
      wall_tim(1) = util_wallsec() - wall_tim(1)
c     
      if (.not. ma_pop_stack(l_wdens)) 
     1     call errquit('tce_grad_force: MA?',0,
     &     MA_ERR)
      if (.not. ma_pop_stack(l_dens)) 
     1     call errquit('tce_grad_force: MA?',0,
     &     MA_ERR)
c      if (.not. ga_destroy(g_wdens)) 
c     1     call errquit('tce_grad_force: GA?',0,
c     &     GA_ERR)
      if (.not. ga_destroy(g_1pwdm))
     1     call errquit('tce_grad_force: GA?',0,
     &     GA_ERR)


C     two-electron contribution
C     allocate arrays for two-electron integral stuff(or rename old ones)
C     blocks of density matrix:

      lsqa = blen*blen

      if (.not. ma_push_get(mt_dbl, lsqa, 'ld_ij', lh_ij, ld_ij))
     $     call errquit('tce_grad_force:could not allocate ld_ij',lsqa, 
     1     MA_ERR)
      if (.not. ma_push_get(mt_dbl, lsqa, 'ld_kl', lh_kl, ld_kl))
     $     call errquit('tce_grad_force:could not allocate ld_kl',lsqa, 
     1     MA_ERR)
      if (.not. ma_push_get(mt_dbl, lsqa, 'ld_ik', lh_ik, ld_ik))
     $     call errquit('tce_grad_force:could not allocate ld_ik',lsqa, 
     1     MA_ERR)
      if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jl', lh_jl, ld_jl))
     $     call errquit('tce_grad_force:could not allocate ld_jl',lsqa, 
     1     MA_ERR)
      if (.not. ma_push_get(mt_dbl, lsqa, 'ld_il', lh_il, ld_il))
     $     call errquit('tce_grad_force:could not allocate ld_il',lsqa, 
     1     MA_ERR)
      if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jk', lh_jk, ld_jk))
     $     call errquit('tce_grad_force:could not allocate ld_jk',lsqa, 
     1     MA_ERR)
c     
      if (scftype .eq. 'UHF' .or. 
     $     scftype .eq. 'ROHF' .or. omp2) then ! UHF or ROHF or MP2
         if (scftype .eq. 'ROHF' .or. omp2) then
            if (.not. ma_push_get(mt_dbl,lsqa,'ld_ij2',lh_ij2,ld_ij2))
     $           call errquit('tce_grad_force:could not allocate ld_ij2'
     1           ,lsqa,
     &           MA_ERR)
            if (.not. ma_push_get(mt_dbl,lsqa,'ld_kl2',lh_kl2,ld_kl2))
     $           call errquit('tce_grad_force:could not allocate ld_kl2'
     1           ,lsqa,
     &           MA_ERR)
         end if          
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_ik2', lh_ik2, ld_ik2))
     $        call errquit('tce_grad_force:could not allocate ld_ik2',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jl2', lh_jl2, ld_jl2))
     $        call errquit('tce_grad_force:could not allocate ld_jl2',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_il2', lh_il2, ld_il2))
     $        call errquit('tce_grad_force:could not allocate ld_il2',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jk2', lh_jk2, ld_jk2))
     $        call errquit('tce_grad_force:could not allocate ld_jk2',
     1        lsqa,
     &        MA_ERR)
      end if

      if (scftype .eq. 'UHF' .and. omp2) then
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_ij3', lh_ij3, ld_ij3))
     $        call errquit('tce_grad_force:could not allocate ld_ij3',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_kl3', lh_kl3, ld_kl3))
     $        call errquit('tce_grad_force:could not allocate ld_jl3',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_ik3', lh_ik3, ld_ik3))
     $        call errquit('tce_grad_force:could not allocate ld_ik3',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jl3', lh_jl3, ld_jl3))
     $        call errquit('tce_grad_force:could not allocate ld_jl3',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_il3', lh_il3, ld_il3))
     $        call errquit('tce_grad_force:could not allocate ld_il3',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jk3', lh_jk3, ld_jk3))
     $        call errquit('tce_grad_force:could not allocate ld_jk3',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_ij4', lh_ij4, ld_ij4))
     $        call errquit('tce_grad_force:could not allocate ld_ij4',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_kl4', lh_kl4, ld_kl4))
     $        call errquit('tce_grad_force:could not allocate ld_kl4',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_ik4', lh_ik4, ld_ik4))
     $        call errquit('tce_grad_force:could not allocate ld_ik4',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jl4', lh_jl4, ld_jl4))
     $        call errquit('tce_grad_force:could not allocate ld_jl4',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_il4', lh_il4, ld_il4))
     $        call errquit('tce_grad_force:could not allocate ld_il4',
     1        lsqa,
     &        MA_ERR)
         if (.not. ma_push_get(mt_dbl, lsqa, 'ld_jk4', lh_jk4, ld_jk4))
     $        call errquit('tce_grad_force:could not allocate ld_jk4',
     1        lsqa,
     &        MA_ERR)
      end if
c
c     set SO ma handles to zero to keep compiler quier
c     all this stuff is used on SO only
c
      ld_ik5=0
      ld_jl5=0
      ld_il5=0
      ld_jk5=0
      ld_ik6=0
      ld_jl6=0
      ld_il6=0
      ld_jk6=0
      ld_ik7=0
      ld_jl7=0
      ld_il7=0
      ld_jk7=0
      ld_ik8=0
      ld_jl8=0
      ld_il8=0
      ld_jk8=0

C     define threshold for Schwarz screening(same as in SCF)
      if (.not. rtdb_get(rtdb, 'scf:tol2e', mt_dbl, 1, tol2e)) then
         if (rtdb_get(rtdb,'scf:thresh',mt_dbl,1,tol2e)) then
            tol2e = min(1d-7,tol2e * 1d-2)
         else
            tol2e = 1.0d-7
         end if
      end if
c     
c     Block the shells for Texas
c     
      if (.not. ma_push_get(mt_int, nsh, 'shmap', l_shmap, k_shmap))
     $     call errquit('tce_grad_force:could not allocate shmap',nsh,
     &       MA_ERR)
      if (.not. ma_push_get(mt_int, nsh, 'shglo', l_shglo, k_shglo))
     $     call errquit('tce_grad_force:could not allocate blo',nsh,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nsh, 'shghi', l_shghi, k_shghi))
     $     call errquit('tce_grad_force:could not allocate bhi',nsh,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nsh, 'shbflo', l_shbflo, k_shbflo))
     $     call errquit('tce_grad_force:could not allocate bflo',nsh,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nsh, 'shbfhi', l_shbfhi, k_shbfhi))
     $     call errquit('tce_grad_force:could not allocate bfhi',nsh,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nbf, 'bfglo', l_bfglo, k_bfglo))
     $     call errquit('tce_grad_force:could not allocate blo',nbf,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nbf, 'bfghi', l_bfghi, k_bfghi))
     $     call errquit('tce_grad_force:could not allocate bhi',nbf,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nbf, 'bfmap', l_bfmap, k_bfmap))
     $     call errquit('tce_grad_force:could not allocate bfmap',nbf,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nbf, 'rbfmap', l_rbfmap, k_rbfmap))
     $     call errquit('tce_grad_force:could not allocate rbfmap',nbf,
     1     MA_ERR)
      if (.not. ma_push_get(mt_int, nbf, 'bftoat', l_bftoat, k_bftoat))
     $     call errquit('tce_grad_force:could not allocate bftoat',nbf,
     1     MA_ERR)

      call grad_shorder(basis, nsh, nbf, maxsh, blen,
     $     nshblocks, int_mb(k_shglo), int_mb(k_shghi),
     &     int_mb(k_shmap), 
     $     int_mb(k_bfmap), int_mb(k_rbfmap), int_mb(k_bfglo),
     $     int_mb(k_bfghi), int_mb(k_shbflo), int_mb(k_shbfhi))
c-> debug
c      do i=1,nshblocks
c         print *,'debug bfglo=',i,int_mb(k_bfglo+i-1)
c         print *,'debug bfghi=',i,int_mb(k_bfghi+i-1)
c      enddo
c<- debug
      do i = 1, nbf
         if (.not. bas_bf2ce(basis, i, iat)) call errquit('bf2ce',i,
     &       BASIS_ERR)
         int_mb(k_bftoat+i-1) = iat
      end do
c
c     ==================================================================
c
c     BEWARE:  below here all AO indices have been put in texas order!
c
c     ==================================================================
c     
c     Now reorder all of the arrays with AO indices according to the map
c     
c     ==============
c     reorder movecs
c     ==============
c
      if (.not. ma_push_get(mt_dbl,nbf,'mo_tmp',l_mo_tmp,k_mo_tmp))
     1   call errquit('tce_grad_force: could not allocate mo_tmp',
     1   01,ma_err)
c
      do g1b=1,noab+nvab
         do g1=1,int_mb(k_range+g1b-1)
         do i=1,nbf
            dbl_mb(k_mo_tmp+int_mb(k_rbfmap+i-1)-1)=
     1      dbl_mb(k_movecs_sorted+(i-1)
     1      +(int_mb(k_offset+g1b-1)+g1-1)*nbf)
         enddo
         do i=1,nbf
            dbl_mb(k_movecs_sorted+(i-1)
     1      +(int_mb(k_offset+g1b-1)+g1-1)*nbf)=dbl_mb(k_mo_tmp+i-1)
         enddo
         enddo
      enddo
c      
      if (.not. ma_pop_stack(l_mo_tmp))
     1   call errquit('tce_grad_force: could not release l_mo_tmp',
     1   02, ma_err)
c
c      next=nxtask(-nprocs,1)  
c      call  ga_sync( )
c    ========================================
c    REMOVE HF REFERENCE CONTRIBUTION TO 1PDM
c    ========================================
      nprocs=ga_nnodes( )
      count=0
      next=nxtask(nprocs,1)
c      
      do g1b=1,noab
         if(next.eq.count) then
c
         if ((.not.restricted).or.(int_mb(k_spin+g1b-1).ne.2)) then
            dima=int_mb(k_range+g1b-1)*int_mb(k_range+g1b-1)
            if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
     1      call errquit('ccsd_gradients: ma problem',2,ma_err)
            call get_hash_block(d_1pdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            do g1=1,int_mb(k_range+g1b-1)
               dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))=
     1         dbl_mb(k_a+(g1-1)+(g1-1)*int_mb(k_range+g1b-1))-1.d0
            enddo
            call put_hash_block(d_1pdm,dbl_mb(k_a),dima,
     1           int_mb(k_1pdm_offset),(g1b-1)+(g1b-1)*(noab+nvab))
            if (.not.ma_pop_stack(l_a))
     1      call errquit('ccsd_gradients: ma problem',3,ma_err)
         endif
         next=nxtask(nprocs,1)
         endif
         count=count+1
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c     ======================================
c     allocate l_list and l_q4 for tce_grad2
c     ======================================
      if (.not. ma_push_get(mt_int, 4*maxq, 'list', l_list, k_list))
     $     call errquit('tce_grad_force:could not allocate list',4*maxq,
     1     MA_ERR)
      if (.not. ma_push_get(mt_dbl, maxq, 'q4', l_q4, k_q4))
     $     call errquit('tce_grad_force:could not allocate q4',maxq,
     1     MA_ERR)
c     ===============================================================
c     do the back transformation on d_2pdm with the reordered mo vecs
c     and the nblocked atomic tiles
c     ===============================================================
c      if(.not.ma_push_get(mt_dbl,nbf*nbf*nbf*nbf, '2pdm_ao',
c     1     l_2pdm_ao, k_2pdm_ao))
c     $     call errquit('tce_grad_force:could not allocate k_2pdm_ao',
c     1     ma_err)
c      do i=1,nbf*nbf*nbf*nbf
c         dbl_mb(k_2pdm_ao+i-1)=0.d0
c      enddo
      if(.not.ma_push_get(mt_int,nshblocks, 'dim_shb',
     1     l_dim_shb, k_dim_shb))
     $     call errquit('tce_grad_force:could not allocate dim_shb',
     1     ma_err)
c
      do i=1,nshblocks
         int_mb(k_dim_shb+i-1) =
     1   int_mb(k_bfghi+i-1)-int_mb(k_bfglo+i-1)+1
c         print *,'ishblock',i,int_mb(k_bfglo+i-1),int_mb(k_bfghi+i-1)
      enddo
c      call ga_sync( )
c
      call offset_btrans2_i0(l_2pdm_ao_offset,k_2pdm_ao_offset,
     1     size_2pdm_ao,nshblocks,int_mb(k_dim_shb))
      call tce_filename('2pdm_ao',filename)
      call createfile(filename,d_2pdm_ao,size_2pdm_ao)
c     =======================
c     DEBUG PRINT OUT 2PDM MO
c     =======================
c      call print_2pdm_mo(d_2pdm,k_2pdm_offset,size_2pdm)
c     ==========================
c     TRANSFORM 2PDM ON MO TO AO
c     ==========================
c
c      call btrans2(d_2pdm,k_2pdm_offset,d_1pdm,k_1pdm_offset,
c     1           k_2pdm_ao,atpart2,nalength2)
c
c      call ga_sync( )
c      next=nxtask(-nprocs,1)
      call btrans2(d_2pdm,k_2pdm_offset,d_1pdm,k_1pdm_offset,
     1             d_2pdm_ao,k_2pdm_ao_offset,size_2pdm_ao,
     1             nshblocks,int_mb(k_dim_shb),int_mb(k_bfglo),
     1             int_mb(k_bfghi))
c      call ga_sync( )
c      print *,'after btrans2'
c      call print_2pdm_ao(d_2pdm_ao,k_2pdm_ao_offset,nshblocks,
c     1     int_mb(k_bfglo),int_mb(k_bfghi))
c      call ga_sync( )

c      print *,'symmetrization'
c
      call sym_2pdm_ao(d_2pdm_ao,k_2pdm_ao_offset,nshblocks,
     1     int_mb(k_bfglo),int_mb(k_bfghi))
c      call ga_sync( )
c
c      if(.not.ma_pop_stack(l_dim_shb))
c     1  call errquit('tce_grad_force:',3,ma_err)      

c      call sym_2pdm_ao(d_2pdm_ao,k_2pdm_ao_offset,nshblocks,
c     1     int_mb(k_bfglo),int_mb(k_bfghi))
c     =========================================================
c     READ 2PDM AO FROM FILE
c     =========================================================
c     ======================
c     READ d_i0 to k_2pdm_ao
c     ======================
c      i_ind=0
c      do ib=1,nshblocks
c         idim = int_mb(k_dim_shb+ib-1)
c      j_ind=0
c      do jb=1,nshblocks
c         jdim = int_mb(k_dim_shb+jb-1)
c      k_ind=0
c      do kb=1,nshblocks
c         kdim = int_mb(k_dim_shb+kb-1)
c      l_ind=0
c      do lb=1,nshblocks
c         ldim = int_mb(k_dim_shb+lb-1)
c         dima=idim*jdim*kdim*ldim
c         if (.not.ma_push_get(mt_dbl,dima,'noname',l_a,k_a))
c     1   call errquit('btrans2: ma problem',3,ma_err)
c         call get_hash_block(d_2pdm_ao,dbl_mb(k_a),dima,
c     1        int_mb(k_2pdm_ao_offset),
c     1        (lb-1)+(kb-1)*nshblocks+(jb-1)*nshblocks*nshblocks+
c     1        (ib-1)*nshblocks*nshblocks*nshblocks)
c         do i=1,idim
c            i1=i_ind+i
c         do j=1,jdim
c            j1=j_ind+j
c         do k=1,kdim
c            k1=k_ind+k
c         do l=1,ldim
c            l1=l_ind+l
c            dbl_mb(k_2pdm_ao+(l1-1)+(j1-1)*nbf+(k1-1)*nbf*nbf
c     1      +(i1-1)*nbf*nbf*nbf) =
c     1      dbl_mb(k_2pdm_ao+(l1-1)+(j1-1)*nbf+(k1-1)*nbf*nbf
c     1      +(i1-1)*nbf*nbf*nbf) +
c     1      dbl_mb(k_a+(l-1)+(k-1)*ldim+(j-1)*ldim*kdim+
c     1      (i-1)*ldim*kdim*jdim)
c         enddo
c         enddo
c         enddo
c         enddo
c         if(.not.ma_pop_stack(l_a))
c     1   call errquit('btrans2: ma problem',4,ma_err)
c         l_ind=l_ind+ldim
c      enddo
c      k_ind=k_ind+kdim
c      enddo
c      j_ind=j_ind+jdim
c      enddo
c      i_ind=i_ind+idim
c      enddo
c     ====================================================================
c      do i=1,nbf
c      do j=1,nbf
c      do k=1,nbf
c      do l=1,nbf
c          write(6,'(a,4i5,a,f20.16)') 'FINAL 2PDM AO',i,j,k,l,'=',
c     1     dbl_mb(k_2pdm_ao+(l-1)+(k-1)*nbf+(j-1)*nbf*nbf
c     1       +(i-1)*nbf*nbf*nbf)
c      enddo
c      enddo
c      enddo
c      enddo
c
c      do i=1,nbf
c      do j=1,nbf
c      do k=1,nbf
c      do l=1,nbf
c         res=1.d0/8.d0*(
c     1       dbl_mb(k_2pdm_ao+(l-1)+(k-1)*nbf+(j-1)*nbf*nbf
c     1       +(i-1)*nbf*nbf*nbf)+
c     1       dbl_mb(k_2pdm_ao+(l-1)+(k-1)*nbf+(i-1)*nbf*nbf
c     1       +(j-1)*nbf*nbf*nbf)+
c     1       dbl_mb(k_2pdm_ao+(k-1)+(l-1)*nbf+(j-1)*nbf*nbf
c     1       +(i-1)*nbf*nbf*nbf)+
c     1       dbl_mb(k_2pdm_ao+(k-1)+(l-1)*nbf+(i-1)*nbf*nbf
c     1       +(j-1)*nbf*nbf*nbf)+
c     1       dbl_mb(k_2pdm_ao+(j-1)+(i-1)*nbf+(l-1)*nbf*nbf
c     1       +(k-1)*nbf*nbf*nbf)+
c     1       dbl_mb(k_2pdm_ao+(i-1)+(j-1)*nbf+(l-1)*nbf*nbf
c     1       +(k-1)*nbf*nbf*nbf)+
c     1       dbl_mb(k_2pdm_ao+(j-1)+(i-1)*nbf+(k-1)*nbf*nbf
c     1       +(l-1)*nbf*nbf*nbf)+
c     1       dbl_mb(k_2pdm_ao+(i-1)+(j-1)*nbf+(k-1)*nbf*nbf
c     1       +(l-1)*nbf*nbf*nbf))
c
c         dbl_mb(k_2pdm_ao+(l-1)+(k-1)*nbf+(j-1)*nbf*nbf
c     1       +(i-1)*nbf*nbf*nbf) = res
c         dbl_mb(k_2pdm_ao+(l-1)+(k-1)*nbf+(i-1)*nbf*nbf
c     1       +(j-1)*nbf*nbf*nbf) = res
c         dbl_mb(k_2pdm_ao+(k-1)+(l-1)*nbf+(j-1)*nbf*nbf
c     1       +(i-1)*nbf*nbf*nbf) = res
c         dbl_mb(k_2pdm_ao+(k-1)+(l-1)*nbf+(i-1)*nbf*nbf
c     1       +(j-1)*nbf*nbf*nbf) = res
c         dbl_mb(k_2pdm_ao+(j-1)+(i-1)*nbf+(l-1)*nbf*nbf
c     1       +(k-1)*nbf*nbf*nbf) = res
c         dbl_mb(k_2pdm_ao+(i-1)+(j-1)*nbf+(l-1)*nbf*nbf
c     1       +(k-1)*nbf*nbf*nbf) = res
c         dbl_mb(k_2pdm_ao+(j-1)+(i-1)*nbf+(k-1)*nbf*nbf
c     1       +(l-1)*nbf*nbf*nbf) = res
c         dbl_mb(k_2pdm_ao+(i-1)+(j-1)*nbf+(k-1)*nbf*nbf
c     1       +(l-1)*nbf*nbf*nbf) = res
c      enddo
c      enddo
c      enddo
c      enddo
c
c      do i=1,nbf
c      do j=1,nbf
c      do k=1,nbf
c      do l=1,nbf
c          write(6,'(a,4i5,a,f20.16)') 'FINAL 2PDM AO',i,j,k,l,'=',
c     1     dbl_mb(k_2pdm_ao+(l-1)+(k-1)*nbf+(j-1)*nbf*nbf
c     1       +(i-1)*nbf*nbf*nbf)
c      enddo
c      enddo
c      enddo
c      enddo
c
c     =========================================================
      
c      if(.not.ma_pop_stack(l_2pdm_ao))
c     1  call errquit('tce_grad_force:',3,ma_err)
c
c      call btrans2(d_2pdm,k_2pdm_offset,size_2pdm,
c     1             d_1pdm,k_1pdm_offset,size_1pdm,
c     1             d_2pdm_ao,k_2pdm_ao_offset,size_2pdm_ao,
c     1             nshblocks,
c     1             int_mb(k_bfglo),int_mb(k_bfghi))
c      print *,'BTRANS2 IS FINE!'
c     ==================
c     SYMMETRIZE 2PDM AO
c     ==================
c      call sym_2pdm_ao(d_2pdm_ao,k_2pdm_ao_offset,nshblocks,
c     1     int_mb(k_bfglo),int_mb(k_bfghi))
c     ==========================
c     DEBUG PRINT OUT 2PDM ON AO
c     ==========================
c      call ga_sync( )
c      call print_2pdm_ao(d_2pdm_ao,k_2pdm_ao_offset,nshblocks,
c     1     int_mb(k_bfglo),int_mb(k_bfghi))
c      call ga_sync( )
c     
c     
      cpu_tim(2)  = util_cpusec()
      wall_tim(2) = util_wallsec()
      if (jfac.ne.0.0d0 .or. kfac.ne.0.0d0) then
c->debug
c         do i=1,blen**4
c            dbl_mb(k_pdm2d+i-1)=0.d0
c         enddo
c<-debug
c         call tce_grad2(k_2pdm_ao,
c     $     dbl_mb(ld_ij), dbl_mb(ld_kl), dbl_mb(ld_ik),
c     $     dbl_mb(ld_jl), dbl_mb(ld_il), dbl_mb(ld_jk), 
c     $     dbl_mb(ld_ij2),dbl_mb(ld_kl2),dbl_mb(ld_ik2),
c     $     dbl_mb(ld_jl2),dbl_mb(ld_il2),dbl_mb(ld_jk2),
c     $     dbl_mb(ld_ij3),dbl_mb(ld_kl3),dbl_mb(ld_ik3),
c     $     dbl_mb(ld_jl3),dbl_mb(ld_il3),dbl_mb(ld_jk3),
c     $     dbl_mb(ld_ij4),dbl_mb(ld_kl4),dbl_mb(ld_ik4),
c     $     dbl_mb(ld_jl4),dbl_mb(ld_il4),dbl_mb(ld_jk4),
c     $     dbl_mb(ld_ik5),dbl_mb(ld_jl5),dbl_mb(ld_il5),
c     .     dbl_mb(ld_jk5),
c     $     dbl_mb(ld_ik6),dbl_mb(ld_jl6),dbl_mb(ld_il6),
c     .     dbl_mb(ld_jk6),
c     $     dbl_mb(ld_ik7),dbl_mb(ld_jl7),dbl_mb(ld_il7),
c     .     dbl_mb(ld_jk7),
c     $     dbl_mb(ld_ik8),dbl_mb(ld_jl8),dbl_mb(ld_il8),
c     .     dbl_mb(ld_jk8),
c     $     dbl_mb(k_frc_2el), g_dens, g_force, blen,
c     $     geom, basis, nproc, nat, 
c     $     lscratch, dbl_mb(k_scr), lbuf/12, dbl_mb(k_buf), 
c     $     int_mb(k_labels), maxq, int_mb(k_list), dbl_mb(k_q4),
c     $     tol2e, nsh, 
c     $     log_mb(k_act), oskel, scftype, omp2, nopen, nbf,
c     $     dbl_mb(k_pdm2),dbl_mb(k_pdm2a),dbl_mb(k_pdm2b), ! MCSCF
c     $     dbl_mb(k_pdm2c),dbl_mb(k_pdm2d), dbl_mb(k_coeff), ! MCSCF
c     $     nshblocks,
c     $     int_mb(k_shmap), int_mb(k_shglo), int_mb(k_shghi), 
c     $     int_mb(k_bfglo), int_mb(k_bfghi), 
c     $     int_mb(k_bfmap), int_mb(k_rbfmap), 
c     $     int_mb(k_bftoat), int_mb(k_shbflo), int_mb(k_shbfhi),
c     $     jfac, kfac,.false.)
c         print *,'BEFORE TCE_GRAD2'
         call tce_grad2(d_2pdm_ao,k_2pdm_ao_offset,
     $     dbl_mb(ld_ij), dbl_mb(ld_kl), dbl_mb(ld_ik),
     $     dbl_mb(ld_jl), dbl_mb(ld_il), dbl_mb(ld_jk),
     $     dbl_mb(ld_ij2),dbl_mb(ld_kl2),dbl_mb(ld_ik2),
     $     dbl_mb(ld_jl2),dbl_mb(ld_il2),dbl_mb(ld_jk2),
     $     dbl_mb(ld_ij3),dbl_mb(ld_kl3),dbl_mb(ld_ik3),
     $     dbl_mb(ld_jl3),dbl_mb(ld_il3),dbl_mb(ld_jk3),
     $     dbl_mb(ld_ij4),dbl_mb(ld_kl4),dbl_mb(ld_ik4),
     $     dbl_mb(ld_jl4),dbl_mb(ld_il4),dbl_mb(ld_jk4),
     $     dbl_mb(ld_ik5),dbl_mb(ld_jl5),dbl_mb(ld_il5),
     .     dbl_mb(ld_jk5),
     $     dbl_mb(ld_ik6),dbl_mb(ld_jl6),dbl_mb(ld_il6),
     .     dbl_mb(ld_jk6),
     $     dbl_mb(ld_ik7),dbl_mb(ld_jl7),dbl_mb(ld_il7),
     .     dbl_mb(ld_jk7),
     $     dbl_mb(ld_ik8),dbl_mb(ld_jl8),dbl_mb(ld_il8),
     .     dbl_mb(ld_jk8),
     $     dbl_mb(k_frc_2el), g_1pdm, g_force, blen,
     $     geom, basis, nproc, nat,
     $     lscratch, dbl_mb(k_scr), lbuf/12, dbl_mb(k_buf),
     $     int_mb(k_labels), maxq, int_mb(k_list), dbl_mb(k_q4),
     $     tol2e, nsh,
     $     log_mb(k_act), oskel, scftype, omp2, nopen, nbf,
     $     dbl_mb(k_pdm2),dbl_mb(k_pdm2a),dbl_mb(k_pdm2b), ! MCSCF
     $     dbl_mb(k_pdm2c),dbl_mb(k_pdm2d), dbl_mb(k_coeff), ! MCSCF
     $     nshblocks,
     $     int_mb(k_shmap), int_mb(k_shglo), int_mb(k_shghi),
     $     int_mb(k_bfglo), int_mb(k_bfghi),
     $     int_mb(k_bfmap), int_mb(k_rbfmap),
     $     int_mb(k_bftoat), int_mb(k_shbflo), int_mb(k_shbfhi),
     $     jfac, kfac,.false.)
c         print *,'AFTER TCE_GRAD2'
c
      endif
      cpu_tim(2)  = util_cpusec()  - cpu_tim(2)
      wall_tim(2) = util_wallsec() - wall_tim(2)
c
      call deletefile(d_2pdm_ao)
      if (.not.ma_pop_stack(l_2pdm_ao_offset))
     1   call errquit('tce_grad_force: ma problem',1,ma_err) 
      if (.not.ma_pop_stack(l_dim_shb))
     1   call errquit('tce_grad_force:',2,ma_err)
c      if(.not.ma_pop_stack(l_2pdm_ao))
c     1  call errquit('tce_grad_force:',3,ma_err)
c
c     
c     terminate integrals
c     
      call schwarz_tidy()
      call intd_terminate()

C     
      call ga_sync()
      call ga_dgop(msg_grad_nuc, dbl_mb(k_frc_nuc), 3*nat, '+')
      call ga_dgop(msg_grad_wgh, dbl_mb(k_frc_wgh), 3*nat, '+')
      call ga_dgop(msg_grad_kin, dbl_mb(k_frc_kin), 3*nat, '+')
      call ga_dgop(msg_grad_nuc, dbl_mb(k_frc_2el), 3*nat, '+')
      call ga_sync()
c     
      if (ga_nodeid() .eq. 0) then

         status = rtdb_parallel(.false.)
c->debug
         call sym_grad_symmetrize(geom, dbl_mb(k_frc_2el))
         call sym_grad_symmetrize(geom, dbl_mb(k_frc_nuc))
         call sym_grad_symmetrize(geom, dbl_mb(k_frc_wgh))
         call sym_grad_symmetrize(geom, dbl_mb(k_frc_kin))
c<-debug
         do i=0, 3*nat-1
            dbl_mb(k_force+i) = dbl_mb(k_force+i) +
     $           dbl_mb(k_frc_2el+i) + dbl_mb(k_frc_nuc+i) +
     $           dbl_mb(k_frc_wgh+i) + dbl_mb(k_frc_kin+i)
c->debug
c           write(6,'(a,i4,f20.16)') 'k_frc_2el',i,dbl_mb(k_frc_2el+i)
c           write(6,'(a,i4,f20.16)') 'k_frc_nuc',i,dbl_mb(k_frc_nuc+i)
c           write(6,'(a,i4,f20.16)') 'k_frc_wgh',i,dbl_mb(k_frc_wgh+i)
c           write(6,'(a,i4,f20.16)') 'k_frc_kin',i,dbl_mb(k_frc_kin+i)
c           write(6,'(a,i4,f20.16)') 'k_force', i, dbl_mb(k_force+i)
c<-debug
         end do

         if (odft) then
            if (.not. rtdb_get(rtdb, 'dft:cd+xc gradient', 
     $           mt_dbl, 3*nat, dbl_mb(k_frc_cd))) call errquit
     $           ('tce_grad_force: no dft cd+xc gradient',110, RTDB_ERR)
            do i=0, 3*nat-1
               dbl_mb(k_force+i) = dbl_mb(k_force+i) + 
     $              dbl_mb(k_frc_cd+i) 
            end do
         endif

         if (omp2) then
            if (.not. rtdb_get(rtdb, 'mp2:nonseparable gradient', 
     $           mt_dbl, 3*nat, dbl_mb(k_frc_mp2))) call errquit
     $           ('tce_grad_force: no nonseparable gradient',110,
     1           RTDB_ERR)
            do i=0, 3*nat-1
               dbl_mb(k_force+i) = dbl_mb(k_force+i) + 
     $              dbl_mb(k_frc_mp2+i) 
            end do
         end if

C     zero force contributions on inactive atoms
         call zero_forces(dbl_mb(k_force), log_mb(k_act), nat)
         
C     symmetrize
         if (oskel) then
            call sym_grad_symmetrize(geom, dbl_mb(k_force))
         end if

         if (.not. omp2) then
            if (scftype .eq. 'MCSCF') then
               theory = 'MCSCF'
            else if (omp2) then
               if (scftype .eq. 'UHF') then
                  theory = 'MP2(UHF)'
               else
                  theory = 'MP2(RHF)'
               end if
            else if (odft) then
               theory = 'DFT'
            else
               theory = scftype
            end if
         end if

         if (util_print('forces', print_high)) then
            write(luout,2200) 'nuclear repulsion gradient',' ',' ',
     $           ((dbl_mb(k_frc_nuc+i-1+3*(j-1)),i=1,3),j=1,nat)
            write(luout,2200) 'weighted density gradient',' ',' ',
     $           ((dbl_mb(k_frc_wgh+i-1+3*(j-1)),i=1,3),j=1,nat)
            write(luout,2200) 'kinetic energy gradient',' ',' ',
     $           ((dbl_mb(k_frc_kin+i-1+3*(j-1)),i=1,3),j=1,nat)
            write(luout,2200) '2-electron gradient',' ',' ',
     $           ((dbl_mb(k_frc_2el+i-1+3*(j-1)),i=1,3),j=1,nat)
            if (omp2) write(luout,2200) theory(1:inp_strlen(theory)),
     $           ' ', 'non-separable gradient',
     $           ((dbl_mb(k_frc_mp2+i-1+3*(j-1)),i=1,3),j=1,nat)
            if (odft) write(luout,2200) theory(1:inp_strlen(theory)),
     $           ' ', 'CD+XC gradient',
     $           ((dbl_mb(k_frc_cd+i-1+3*(j-1)),i=1,3),j=1,nat)
            write(luout,2200) 'total ',
     $           theory(1:inp_strlen(theory)), ' gradient',
     $           ((dbl_mb(k_force+i-1+3*(j-1)),i=1,3),j=1,nat)
 2200       format(A,A,A/,1000(3(1x,F12.6),/))
            call util_flush(luout)
         end if

C     store in rtdb
         if (omp2) then
            rtdb_string = 'mp2:gradient'
         else if (scftype.eq. 'MCSCF') then
            rtdb_string = 'mcscf:gradient'
         else if (odft) then
            rtdb_string = 'dft:gradient'
c->pdfan
         else if (otce) then
            rtdb_string = 'tce:gradient'
c<-pdfan
         else
            rtdb_string = 'scf:gradient'
         end if
         if (.not. rtdb_put(rtdb, rtdb_string, mt_dbl, 3*nat, 
     $        dbl_mb(k_force)))call errquit
     $        ('tce_grad_force: could not store gradients',1, RTDB_ERR)
c     
         status = rtdb_parallel(.true.)
c     
      end if
c     
      call ga_sync
c     

C     default: print the total forces 
      if (ga_nodeid() .eq. 0 
     $     .and. util_print('forces', print_low)) then
c         write(luout,1000) theory(1:inp_strlen(theory)),
c     $        'x','y','z','x','y','z'
         write(luout,1000) model,
     $        'x','y','z','x','y','z'
c         if (model.eq.'ccsd') then
c             write(luout,1000) 'CCSD',
c     $        'x','y','z','x','y','z'
c         else if(model.eq.'ccsdt') then
c             write(luout,1000) 'CCSDT',
c     $        'x','y','z','x','y','z'
c         else if(model.eq.'ccsdtq') then
c             write(luout,1000) 'CCSDTQ',
c     $        'x','y','z','x','y','z'
c         endif
c
         do 30, i=1, nat
            if (.not. geom_cent_get(geom, i, tag, crd, q)) call errquit
     $           ('tce_grad_force: geometry corrupt?',0, GEOM_ERR)
            write(luout,2000) i, tag,(crd(j),j=1,3),
     $           (dbl_mb(k_force+3*(i-1)+j),j=0,2)
 30      continue
         write(luout,*)
 1000    format(/,/,25X,A,' ENERGY GRADIENTS',/,/,4X,'atom',15X,
     $        'coordinates',
     $        24X,'gradient',/,6X,2(1X,(3(10X,A1))))
 2000    format(1X,I3,1X,A4,2(1X,3(1X,F10.6)))
         call util_flush(luout)
      end if

C     print timing information
      if (ga_nodeid().eq.0 .and.
     $     util_print('timing', print_default)) then
         write(luout,03000)cpu_tim,wall_tim
03000    format(17x,40('-'),/,
     &        17x,'|  Time  |  1-e(secs)   |  2-e(secs)   |',/,
     &        17x,40('-'),/,
     &        17x,'|  CPU   |',f11.2,3x,'|',f11.2,3x,'|',/,
     &        17x,40('-'),/,
     &        17x,'|  WALL  |',f11.2,3x,'|',f11.2,3x,'|',/,
     &        17x,40('-'))
         call util_flush(luout)
      end if
c     
      call ga_sync()

C     free memory

      if (.not. ma_verify_allocator_stuff())
     $     call errquit('tce_grad_force: ma corrupt',0, MA_ERR)

      if (.not. ma_chop_stack(l_force)) 
     $     call errquit('tce_grad_force: failed chopping MA stack',0,
     1     MA_ERR)
c     
      if (.not. ga_destroy(g_force)) 
     1   call errquit('tce_grad_force: GA?',0, GA_ERR)
c     
c      do i=1, ndens
c         if (.not. ga_destroy(g_dens(i))) call errquit 
c     $        ('tce_grad_force:error destroying density', 1, GA_ERR)
c      end do
       if (.not. ga_destroy(g_1pdm)) call errquit
     $    ('tce_grad_force:error destroying density', 1, GA_ERR)


c     
      end
c      double precision function grad_norm(frc, nat)
c      implicit none
c
c      integer nat
c      double precision frc(3*nat)
c
c      integer i
c      double precision g2
c
c      g2 = 0
c      do i=1, 3*nat
c        g2 = g2 + frc(i)*frc(i)
c      end do
c
c      grad_norm = sqrt(g2)
c
c      return
c      end
c      double precision function grad_max(frc, nat)
c      implicit none
c
c      integer nat
c      double precision frc(3,nat)
c
c      integer i
c      double precision norm, mxnorm
c
c      mxnorm = 0
c      do i=1, nat
c        norm = frc(1,i)*frc(1,i) + frc(2,i)*frc(2,i) + frc(3,i)*frc(3,i) 
c        mxnorm = max(norm,mxnorm)
c      end do
c
c      grad_max = sqrt(mxnorm)
c
c      return
c      end
c      subroutine grad_active_atoms(rtdb, natoms, oactive, nactive)
c      implicit none
c#include "errquit.fh"
c#include "rtdb.fh"
c#include "mafdecls.fh"
c#include "util.fh"
c#include "global.fh"
cc
c      integer rtdb              ! [input]
c      integer natoms            ! [input]
c      logical oactive(natoms)   ! [output]
c      integer nactive           ! [output]
cc
c      integer ma_type, l_actlist, k_actlist, i
cc
cc**** list of active atoms ****
c      if (rtdb_ma_get(rtdb, 'geometry:actlist', ma_type, 
c     $     nactive, l_actlist)) then
c         if (.not. ma_get_index(l_actlist, k_actlist))
c     $        call errquit('grad_act_at: ma_get_inded failed',l_actlist,
c     &       MA_ERR)
c         if (nactive.le.0 .or. nactive.gt.natoms)
c     $        call errquit
c     $        ('grad_act_at: invalid number of active atoms',
c     $        natoms*10000+nactive, INPUT_ERR)
cC     fill lookup table
c         do i=1, natoms
c            oactive(i) = .false.
c         end do
c         do i=1, nactive
c            if (int_mb(k_actlist+i-1).le.0 .or. 
c     $           int_mb(k_actlist+i-1).gt.natoms) call errquit
c     $           ('grad_act_at: invalid active atom', INPUT_ERR,
c     $           int_mb(k_actlist+i-1))
c            oactive(int_mb(k_actlist+i-1)) = .true.
c         end do
c         if (.not. ma_free_heap(l_actlist)) call errquit
c     $        ('grad_act_at: free of actlist?',0, MA_ERR)
cc
cc**** list of inactive atoms ****
c      else if (rtdb_ma_get(rtdb, 'geometry:inactlist', ma_type, 
c     $     nactive, l_actlist)) then
c         if (.not. ma_get_index(l_actlist, k_actlist))
c     $        call errquit('grad_act_at: ma_get_inded failed',l_actlist,
c     &       MA_ERR)
c         if (nactive.le.0 .or. nactive.gt.natoms)
c     $        call errquit
c     $        ('grad_act_at: invalid number of inactive atoms',
c     $        natoms*10000+nactive, INPUT_ERR)
cC     fill lookup table
c         do i=1, natoms
c            oactive(i) = .true.
c         end do
c         do i=1, nactive
c            if (int_mb(k_actlist+i-1).le.0 .or. 
c     $           int_mb(k_actlist+i-1).gt.natoms) call errquit
c     $           ('grad_act_at: invalid active atom', INPUT_ERR,
c     $           int_mb(k_actlist+i-1))
c            oactive(int_mb(k_actlist+i-1)) = .false.
c         end do
cc
c         if (util_print('active atoms', print_low) .and. 
c     $       ga_nodeid().eq.0)   then
c           write(6,1) (int_mb(k_actlist+i-1),i=1,nactive)
c 1         format('  gradient active atoms ',15i4)
c*           write(6,2) (oactive(i),i=1,natoms)
c* 2         format('  oactive ',30l2)
c	 end if
cc
c         if (.not. ma_free_heap(l_actlist)) call errquit
c     $        ('grad_act_at: free of actlist?',0, MA_ERR)
cc
c      else
c         do i = 1, natoms
c            oactive(i) = .true.
c         end do
c         nactive = natoms
c      end if
cc
c      end
c
c      subroutine grad_shorder( basis, nsh, nbf, maxsh, blen,
c     $     nshblocks, shglo, shghi, shmap,
c     $     bfmap, rbfmap, bfglo, bfghi, shbflo, shbfhi)
c      implicit none
c#include "errquit.fh"
c#include "global.fh"
c#include "util.fh"
c#include "bas.fh"
c      integer basis             ! [input] basis handle
c      integer nsh, nbf          ! [input] no. of shells and basis functions
c      integer maxsh             ! [input]  Max. no. of shells in block
c      integer blen              ! [input]  Max no. of basis func in block
c      integer nshblocks         ! [output] Number of groups formed
c      integer shglo(*)          ! [output] First new shell in group
c      integer shghi(*)          ! [output] Last new shell in group
c      integer shmap(nsh)        ! [output] Shell new  --> orig
c      integer bfmap(nbf)        ! [output] Basis new  --> orig
c      integer rbfmap(nbf)       ! [output] Basis orig --> new
c      integer bfglo(*)          ! [output] First new basis func in group
c      integer bfghi(*)          ! [output] Last new basis func in group
c      integer shbflo(nsh)       ! [output] First new bf in new shell
c      integer shbfhi(nsh)       ! [output] Last new bf in new shell
cc     
c      logical oreorder          ! if true then actually reorder shells
c      logical oprint
cc
c      integer iuat, iatsh, itype, inprim, ingen, spch, iat, i, j
c      integer shlo, shhi, tmp, iold, bflo, bfhi, shdim, prevtype
c      integer shlen, bflen, newbf
c      double precision thetype
cc
c      data oreorder/.true./
cc
c      thetype(iuat,iatsh,itype,inprim,ingen) = 
c     $     iuat-1 + 32.0d0*(iatsh-1 + 32.0d0*(inprim-1 + 32.0d0*(
c     $     ingen-1 + 32.0d0*(itype+1))))
cc
c      oprint = util_print('reorder', print_debug) .and. ga_nodeid().eq.0
c      if (oreorder) then
cc
cc     Order shells by type (Texas 93 with suborder by uniq atom for Texas 95)
cc
c      do i = 1, nsh
c         if (.not. bas_continfo(basis,i,itype,inprim,ingen,spch))
c     $        call errquit('fock_pairs: basis corrupt ',0,
c     &       BASIS_ERR)
c         if (.not. bas_cn2uce(basis,i,iuat))
c     $        call errquit('fock_pairs: basis corrupt ',0, BASIS_ERR)
c         if (.not. bas_cn2ce(basis,i,iat))
c     $        call errquit('fock_pairs: basis corrupt ',0, BASIS_ERR)
c         if (.not. bas_ce2cnr(basis,iat,shlo,shhi))
c     $        call errquit('fock_pairs: basis corrupt ',0, BASIS_ERR)
c         iatsh = i-shlo+1
cc     reorder L,s,p (-1,0,1) into order by complexity s,p,L (-1,0,1)
c         if (itype.eq.-1) then
c            itype = 1
c         else if (itype.eq.0) then
c            itype = -1
c         else if (itype.eq.1) then
c            itype = 0
c         end if
c         bfmap(i) = thetype(iuat,iatsh,itype,inprim,ingen) ! bfmap workspace
c         shmap(i) = i
c         do j = 1, i-1          ! Dumb nsh^2 sort into increaing order
c            if (bfmap(j).gt.bfmap(i)) then 
c               tmp = bfmap(j)
c               bfmap(j) = bfmap(i)
c               bfmap(i) = tmp
c               tmp = shmap(j)
c               shmap(j) = shmap(i)
c               shmap(i) = tmp
c            end if
c         end do
c      end do
c      else
c         do i = 1, nsh
c            shmap(i) = i
c            bfmap(i) = 1
c         end do
c      end if
cc
c      if (oprint) then
c         write(6,1) (shmap(i),i=1,nsh)
c 1       format('  shmap ', 12(i3,3x))
c         write(6,11)(bfmap(i),i=1,nsh)
c 11      format('  type  ', 12i9)
c      end if
cc
cc     Now have shmap (new to old shell map) and in bfmap the type of
cc     each new shell.  Perform the blocking subject to constraints 
cc     from blen and maxsh.
cc
c      iold = shmap(1)
c      if (.not. bas_cn2bfr(basis,iold,bflo,bfhi))
c     $     call errquit('fock_pairs: basis corrupt ',0, BASIS_ERR)
c      shdim = bfhi - bflo + 1   ! Size of first new shell
cc
c      nshblocks = 1
c      shglo(1) = 1
c      bfglo(1) = 1
c      prevtype = bfmap(1)
c      shlen = 1
c      bflen = shdim
c      do i = 2, nsh
c         iold = shmap(i)
c         if (.not. bas_cn2bfr(basis,iold,bflo,bfhi))
c     $        call errquit('fock_pairs: basis corrupt ',0, BASIS_ERR)
c         shdim = bfhi - bflo + 1
c         itype = bfmap(i)
c         if (itype.ne.prevtype .or. shlen.eq.maxsh .or. 
c     $        (bflen+shdim).gt.blen) then
c            shghi(nshblocks) = shglo(nshblocks)+shlen-1
c            bfghi(nshblocks) = bfglo(nshblocks)+bflen-1
c            nshblocks = nshblocks + 1
c            shlen = 0
c            bflen = 0
c            shglo(nshblocks) = i
c            bfglo(nshblocks) = bfghi(nshblocks-1)+1
c            prevtype = itype
c         end if
c         shlen = shlen + 1
c         bflen = bflen + shdim
c      end do
c      shghi(nshblocks) = nsh
c      bfghi(nshblocks) = nbf
c      if (oprint) then
c         write(6,2) nshblocks, blen, maxsh
c 2       format(' nshblocks ', i3, '   blen ',i2,'  maxsh ',i2)
c         write(6,3) (shglo(i),i=1,nshblocks)
c 3       format('  shglo ', 12(i3,3x))
c         write(6,4) (shghi(i),i=1,nshblocks)
c 4       format('  shghi ', 12(i3,3x))
c         write(6,5) (bfglo(i),i=1,nshblocks)
c 5       format('  bfglo ', 12(i3,3x))
c         write(6,6) (bfghi(i),i=1,nshblocks)
c 6       format('  bfghi ', 12(i3,3x))
c      end if
cc
cc     Now have shmap, shglo/hi and bfglo/hi, and nshblocks
cc
cc     Just need to make the remaining maps
cc     bfmap(i) = new to old basis functions
cc     rbfmap(i) = old to new basis functions
cc
c      newbf = 0
c      do i = 1, nsh
c         iold = shmap(i)
c         if (.not. bas_cn2bfr(basis,iold,bflo,bfhi))
c     $        call errquit('fock_pairs: basis corrupt ',0, BASIS_ERR)
c         shbflo(i) = newbf + 1
c         do j = bflo,bfhi
c            newbf = newbf + 1
c            rbfmap(j) = newbf
c            bfmap(newbf) = j
c         end do
c         shbfhi(i) = newbf
c      end do
c      if (newbf .ne. nbf) call errquit('newbf is bad',0, BASIS_ERR)
cc
c      if (oprint) then
c         write(6,7) (bfmap(i),i=1,nbf)
c 7       format('  bfmap ', 12(i3,3x))
c         write(6,8) (rbfmap(i),i=1,nbf)
c 8       format(' rbfmap ', 12(i3,3x))
c         write(6,9) (shbflo(i),i=1,nsh)
c 9       format(' shbflo ', 12(i3,3x))
c         write(6,10) (shbfhi(i),i=1,nsh)
c 10      format(' shbfhi ', 12(i3,3x))
c      end if
cc
c      end
c      subroutine zero_forces ( force, oactive, nat )
c
c      double precision force, zero
c      logical oactive
c      integer nat
c
c      parameter ( zero = 0.D0 )
c
c      dimension force(3,nat)
c      dimension oactive(nat)
c
c      do i=1, nat
c        if ( .not.oactive(i) ) then
c          force(1,i) = zero
c          force(2,i) = zero
c          force(3,i) = zero
c        end if
c      end do
c
c      return
cc      end

      subroutine argos_space_getda(jnode,jsfr,jsto,
     + isl,isga,isq3,xs,ndxda)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
c
      integer jnode,jsfr,jsto,ndxda
      integer isga(msa),isq3(msa),isl(msa,mis2)
      real*8 xs(msa,3)
c
      integer il,ih,jl,jh
      integer l_islt,i_islt
c
      if(.not.ma_push_get(mt_int,msa*mis2,'islt',l_islt,i_islt))
     + call md_abort('Failed to allocate memory for islt',0)
      call argos_space_gtda(jnode,jsfr,jsto,int_mb(i_islt),
     + int_mb(i_pack),isga,isq3,xs,ndxda)
      if(.not.ma_pop_stack(l_islt))
     + call md_abort('Failed to deallocate memory for islt',0)
c
      return
      end
c $Id: argos_space_getda.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE tce_e_offset(l_a_offset,k_a_offset,size)
C     $Id: tce_e_offset.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     e ( )_e
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      length = 1
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'tce_e_offset',l_a_offset,
     1k_a_offset)) CALL ERRQUIT('tce_e_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 1
      size = 0
      int_mb(k_a_offset+addr) = 0
      int_mb(k_a_offset+length+addr) = size
      RETURN
      END

c===============================================================c
c                                                               c
c       NCC - a New Coupled-Cluster code for NWChem             c
c                                                               c
c       Developed by:                                           c
c                                                               c
c               Jeff R. Hammond                                 c
c               Leadership Computing Facility                   c
c               Argonne National Laboratory                     c
c               jhammond@mcs.anl.gov                            c
c                                                               c
c               Karol Kowalski                                  c
c               Environmental Molecular Sciences Laboratory     c
c               Pacific Northwest National Laboratory           c
c               karol.kowalski@pnl.gov                          c
c                                                               c
c               Marta Włoch                                     c
c               Department of Chemistry                         c
c               Michigan Technological University               c
c               wloch@mtu.edu                                   c
c                                                               c
c===============================================================c
c
c     prints shell batch of 2-e AO integrals
c
      subroutine ncc_print_ao2e(ilo,ihi,jlo,jhi,klo,khi,llo,lhi,
     1                           buf,tol2e)
      implicit none
#include "stdio.fh"
      integer i, j, k, l
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      double precision tol2e
      double precision buf(llo:lhi,klo:khi,jlo:jhi,ilo:ihi)
      do i = ilo, ihi
         do j = jlo, jhi
            do k = klo, khi
               do l = llo, lhi
                  if (abs(buf(l,k,j,i)).ge.tol2e) then
                     write(6,1) i,j,k,l,buf(l,k,j,i)
 1                   format(' ao ',4i5,f20.14)
                  endif
               enddo
            enddo
         enddo
      enddo
      call util_flush(LuOut)
      end
c
c     print MO vectors
c
      subroutine ncc_print_movecs(nbf,nmo,buf)
      implicit none
#include "stdio.fh"
      integer ao, mo, nbf, nmo
      double precision buf(nbf,nmo)
      write(6,*)
      write(6,11)
 11   format('      mo      ao       movec(ao,mo)')
      do mo = 1, nmo
         do ao = 1, nbf
            write(6,12) mo,ao,buf(ao,mo)
 12         format(2i8,f20.14)
         enddo
      enddo
      write(6,*)
      call util_flush(LuOut)
      end
c
c     print simple vector of doubles
c
      subroutine ncc_print_dvec(nbf,buf)
      implicit none
#include "stdio.fh"
      integer ao, nbf
      double precision buf(nbf)
      write(6,*)
      write(6,21)
 21   format('      ao       vec(ao)')
      do ao = 1, nbf
         write(6,22) ao,buf(ao)
 22      format(i8,f20.14)
      enddo
      write(6,*)
      call util_flush(LuOut)
      end
c
c     print simple vector of integers
c
      subroutine ncc_print_ivec(nbf,buf)
      implicit none
#include "stdio.fh"
      integer ao, nbf
      integer buf(nbf)
      write(6,*)
      write(6,21)
 21   format('      ao       vec(ao)')
      do ao = 1, nbf
         write(6,22) ao,buf(ao)
 22      format(i8,i20)
      enddo
      write(6,*)
      call util_flush(LuOut)
      end
c
c
c
      subroutine put_ao2e_to_buf(ilo,ihi,jlo,jhi,
     1                           klo,khi,llo,lhi,
     2                           nbf,buf_in,buf_out)
      implicit none
      integer i, j, k, l
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi, nbf
      double precision buf_in(llo:lhi,klo:khi,jlo:jhi,ilo:ihi)
      double precision buf_out(1:nbf,1:nbf,1:nbf,1:nbf)
      do i = ilo, ihi
         do j = jlo, jhi
            do k = klo, khi
               do l = llo, lhi
                 buf_out(l,k,j,i) = buf_in(l,k,j,i)
               enddo
            enddo
         enddo
      enddo
      end
c $Id: ncc_util.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine smd_ewald_get_alpha(aalpha)
      implicit none
#include "smd_ewald_data.fh"

      double precision aalpha

      aalpha = alpha

      end 

      subroutine smd_ewald_get_ralphsq(aralphsq)
      implicit none
#include "smd_ewald_data.fh"

      double precision aralphsq

      aralphsq = ralphsq

      end 

      subroutine smd_ewald_get_rksqmax(arksqmax)
      implicit none
#include "smd_ewald_data.fh"

      double precision arksqmax

      arksqmax = rksqmax

      end 

      subroutine smd_ewald_get_kmax(akmax)
      implicit none
#include "smd_ewald_data.fh"

      integer akmax(3)
      integer i

      do i=1,3
        akmax(i) = kmax(i)
      end do

      end 

      subroutine smd_ewald_set_alpha(aalpha)
      implicit none
#include "smd_ewald_data.fh"

      double precision aalpha

      alpha = aalpha

      end 

      subroutine smd_ewald_set_ralphsq(aralphsq)
      implicit none
#include "smd_ewald_data.fh"

      double precision aralphsq

      ralphsq = aralphsq

      end 

      subroutine smd_ewald_set_rksqmax(arksqmax)
      implicit none
#include "smd_ewald_data.fh"

      double precision arksqmax

      rksqmax = arksqmax

      end 

      subroutine smd_ewald_set_kmax(akmax)
      implicit none
#include "smd_ewald_data.fh"

      integer akmax(3)
      integer i

      do i=1,3
        kmax(i) = akmax(i)
      end do

      end 

      subroutine smd_ewald_print(un)
      implicit none
#include "smd_ewald_data.fh"

      integer un

      write(un,*) "ewald data"
      write(un,*) "kmax",kmax(1),kmax(2),kmax(3)
      write(un,*) "alpha",alpha
      write(un,*) "ralphsq",ralphsq
      write(un,*) "rksqmax",rksqmax

      end 
c $Id: smd_ewald_data.F 22502 2012-05-20 06:11:57Z d3y133 $

#define NBLOCKS 2

*
* $Id: C3dB_pfft.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************************************
*     *								*
*     *   		   C3dB_pfft library	 		*
*     *			(MPI implemenation)			*
*     *								*
*     *   Author - Eric Bylaska					*
*     *   date   - 3/23/96					*
*     *								*
*     ***********************************************************

*     ***********************************
*     *					*
*     *	        C3dB_pfft_init		*
*     *					*
*     ***********************************

      subroutine C3dB_pfft_init()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"
#include "C3dB_pfft.fh"

*     **** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)

      double precision eps
      parameter (eps=1d-12)

      logical value,yrow,zrow,yzslab
      integer nxh,nyh,nzh,q,p
      integer k1,k2,k3,fb,nbb
      integer i,j,k
      integer index2
      double precision ggcut,g1,g2,g3,gg
      integer zero_arow2(2),zero_arow3(2)

*     **** external functions ***
      integer  control_pfft3_qsize,brillioun_nbrillq
      real*8   lattice_ggcut,lattice_wggcut,lattice_unitg
      real*8   brillioun_k
      external control_pfft3_qsize,brillioun_nbrillq
      external lattice_ggcut,lattice_wggcut,lattice_unitg
      external brillioun_k

      call Parallel3d_taskid_i(taskid)
      nxh = nx(1)/2
      nyh = ny(1)/2
      nzh = nz(1)/2

      if (mapping.eq.1) then
         
         value =           MA_alloc_get(mt_log,nx(1)*nq(1),
     >                     'zero_row3',zero_row3(2,0),zero_row3(1,0))
         value = value.and.MA_alloc_get(mt_log,nx(1)*nq(1),
     >                     'zero_row3',zero_row3(2,1),zero_row3(1,1))

         value = value.and.MA_alloc_get(mt_log,nx(1)*nq(1),
     >                     'zero_row2',zero_row2(2,0),zero_row2(1,0))
         value = value.and.MA_alloc_get(mt_log,nx(1)*nq(1),
     >                     'zero_row2',zero_row2(2,1),zero_row2(1,1))

         value = value.and.MA_alloc_get(mt_log,nx(1),
     >               'zero_slab23',zero_slab23(2,0),zero_slab23(1,0))
         value = value.and.MA_alloc_get(mt_log,nx(1),
     >               'zero_slab23',zero_slab23(2,1),zero_slab23(1,1))
         if (.not. value) call errquit('out of heap memory',0, MA_ERR)

         value = value.and.MA_push_get(mt_log,(nx(1)*ny(1)),
     >                     'zero_arow3',zero_arow3(2),zero_arow3(1))
         if (.not. value) call errquit('out of stack memory',0,MA_ERR)


         !*** fb==0 - density, fb=1 - all wavefunctions/brillioun zones ***
         do fb=0,1

         if (fb.eq.0) then
            ggcut = lattice_ggcut()
         else
            ggcut = lattice_wggcut()
         end if

*        **** find zero_row3 - (i,*,k) rows that are zero ****
*        **** note the crazy notation used below ****
         do q=1,nx(1)*nq(1)
             log_mb(zero_row3(1,fb)+q-1) =.true.
         end do
         do q=1,nx(1)*ny(1)
           log_mb(zero_arow3(1)+q-1) =.true.
         end do


         do k2 = -nyh+1, nyh-1
         do k1 = -nxh+1, nxh-1
          i=k1
          j=k2
          if (i .lt. 0) i = i + nx(1)
          if (j .lt. 0) j = j + ny(1)
          i=i+1
          j=j+1
          zrow = .true.
          do k3 = -nzh+1, nzh-1
            if (fb.eq.0) then
               g1 = k1*lattice_unitg(1,1)
     >            + k3*lattice_unitg(1,2)
     >            + k2*lattice_unitg(1,3)
               g2 = k1*lattice_unitg(2,1)
     >            + k3*lattice_unitg(2,2)
     >            + k2*lattice_unitg(2,3)
               g3 = k1*lattice_unitg(3,1)
     >            + k3*lattice_unitg(3,2)
     >            + k2*lattice_unitg(3,3)
               gg = g1*g1 + g2*g2 + g3*g3
               gg= gg-ggcut
               if (gg.lt.-eps) zrow = .false.
            else
               do nbb=1,brillioun_nbrillq()
                  g1 = k1*lattice_unitg(1,1)
     >               + k3*lattice_unitg(1,2)
     >               + k2*lattice_unitg(1,3)
     >               + brillioun_k(1,nbb)
                  g2 = k1*lattice_unitg(2,1)
     >               + k3*lattice_unitg(2,2)
     >               + k2*lattice_unitg(2,3)
     >               + brillioun_k(2,nbb)
                  g3 = k1*lattice_unitg(3,1)
     >               + k3*lattice_unitg(3,2)
     >               + k2*lattice_unitg(3,3)
     >               + brillioun_k(3,nbb)
                  gg = g1*g1 + g2*g2 + g3*g3
                  gg= gg-ggcut
                  if (gg.lt.-eps) zrow = .false.
               end do
            endif

          end do
          if (.not.zrow) then
            log_mb(zero_arow3(1)+(i-1)+nx(1)*(j-1)) =.false.
            call C3dB_ktoqp(1,j,q,p)
            if (p.eq.taskid) then
              index2 = i + nx(1)*(q-1)
              log_mb(zero_row3(1,fb)+index2-1) =.false.
            end if
          end if

         end do
         end do

         call C3dB_c_ptranspose_jk_init(fb,log_mb(zero_arow3(1)))


*        **** find zero_slab23 - (i,*,*) slabs that are zero ****
         do k1 = 1,nx(1)
           log_mb(zero_slab23(1,fb)+k1-1) =.true.
         end do

         do k1 = -nxh+1, nxh-1
          i=k1
          if (i .lt. 0) i = i + nx(1)
          i=i+1
          yzslab = .true.
          do k3 = -nzh+1, nzh-1
          do k2 = -nyh+1, nyh-1
            if (fb.eq.0) then
               g1 = k1*lattice_unitg(1,1)
     >            + k2*lattice_unitg(1,2)
     >            + k3*lattice_unitg(1,3)
               g2 = k1*lattice_unitg(2,1)
     >            + k2*lattice_unitg(2,2)
     >            + k3*lattice_unitg(2,3)
               g3 = k1*lattice_unitg(3,1)
     >            + k2*lattice_unitg(3,2)
     >            + k3*lattice_unitg(3,3)
               gg = g1*g1 + g2*g2 + g3*g3
               gg= gg-ggcut
               if (gg.lt.-eps) yzslab = .false.
            else
               do nbb=1,brillioun_nbrillq()
                  g1 = k1*lattice_unitg(1,1)
     >               + k2*lattice_unitg(1,2)
     >               + k3*lattice_unitg(1,3)
     >               + brillioun_k(1,nbb)
                  g2 = k1*lattice_unitg(2,1)
     >               + k2*lattice_unitg(2,2)
     >               + k3*lattice_unitg(2,3)
     >               + brillioun_k(2,nbb)
                  g3 = k1*lattice_unitg(3,1)
     >               + k2*lattice_unitg(3,2)
     >               + k3*lattice_unitg(3,3)
     >               + brillioun_k(3,nbb)
                  gg = g1*g1 + g2*g2 + g3*g3
                  gg= gg-ggcut
                  if (gg.lt.-eps) yzslab = .false.
               end do
            end if
          end do
          end do
          if (.not.yzslab) then
            log_mb(zero_slab23(1,fb)+i-1) =.false.
          end if

         end do

*        **** find zero_row2 - (i,*,k) rows that are zero after fft of (i,j,*) ****
         do k3 = 1,nz(1)
         do k1 = 1,nx(1)
           call C3dB_ktoqp(1,k3,q,p)
           if (p.eq.taskid) then
            index2 = k1 + nx(1)*(q-1)
            log_mb(zero_row2(1,fb)+index2-1) 
     >       = log_mb(zero_slab23(1,fb)+k1-1)
           end if
         end do
         end do

        
         end do !*fb*
         value = MA_pop_stack(zero_arow3(2))
         if (.not. value) call errquit('error freeing stack',0,MA_ERR)

      !*** mapping == 2 ***
      else
         value =           MA_alloc_get(mt_log,nq3(1),
     >                     'zero_row3',zero_row3(2,0),zero_row3(1,0))
         value = value.and.MA_alloc_get(mt_log,nq3(1),
     >                     'zero_row3',zero_row3(2,1),zero_row3(1,1))

         value = value.and.MA_alloc_get(mt_log,nq2(1),
     >                     'zero_row2',zero_row2(2,0),zero_row2(1,0))
         value = value.and.MA_alloc_get(mt_log,nq2(1),
     >                     'zero_row2',zero_row2(2,1),zero_row2(1,1))

         value = value.and.MA_alloc_get(mt_log,nx(1),
     >               'zero_slab23',zero_slab23(2,0),zero_slab23(1,0))
         value = value.and.MA_alloc_get(mt_log,nx(1),
     >               'zero_slab23',zero_slab23(2,1),zero_slab23(1,1))
         if (.not. value) call errquit('out of heap memory',0, MA_ERR)

         value = value.and.MA_push_get(mt_log,nx(1)*nz(1),
     >                     'zero_arow2',zero_arow2(2),zero_arow2(1))
         value = value.and.MA_push_get(mt_log,nx(1)*ny(1),
     >                     'zero_arow3',zero_arow3(2),zero_arow3(1))
         if (.not. value) call errquit('out of stack memory',0,MA_ERR)

         !*** fb==0 - density, fb=1 - all wavefunctions/brillioun zones ***
         do fb=0,1

         if (fb.eq.0) then
            ggcut = lattice_ggcut()
         else
            ggcut = lattice_wggcut()
         end if

*        **** find zero_row3 - (i,j,*) rows that are zero ****
         do q = 1,nq3(1)
           log_mb(zero_row3(1,fb)+q-1) =.true.
         end do
         do q = 1,nx(1)*ny(1)
           log_mb(zero_arow3(1)+q-1) =.true.
         end do

         do k2 = -nyh+1, nyh-1
         do k1 = -nxh+1, nxh-1
          i=k1
          j=k2
          if (i .lt. 0) i = i + nx(1)
          if (j .lt. 0) j = j + ny(1)
          i=i+1
          j=j+1
          zrow = .true.
          do k3 = -nzh+1, nzh-1
            if (fb.eq.0) then
               g1 = k1*lattice_unitg(1,1)
     >            + k2*lattice_unitg(1,2)
     >            + k3*lattice_unitg(1,3)
               g2 = k1*lattice_unitg(2,1)
     >            + k2*lattice_unitg(2,2)
     >            + k3*lattice_unitg(2,3)
               g3 = k1*lattice_unitg(3,1)
     >            + k2*lattice_unitg(3,2)
     >            + k3*lattice_unitg(3,3)
               gg = g1*g1 + g2*g2 + g3*g3
               gg= gg-ggcut
               if (gg.lt.-eps) zrow = .false.
            else
               do nbb=1,brillioun_nbrillq()
                  g1 = k1*lattice_unitg(1,1)
     >               + k2*lattice_unitg(1,2)
     >               + k3*lattice_unitg(1,3)
     >               + brillioun_k(1,nbb)
                  g2 = k1*lattice_unitg(2,1)
     >               + k2*lattice_unitg(2,2)
     >               + k3*lattice_unitg(2,3)
     >               + brillioun_k(2,nbb)
                  g3 = k1*lattice_unitg(3,1)
     >               + k2*lattice_unitg(3,2)
     >               + k3*lattice_unitg(3,3)
     >               + brillioun_k(3,nbb)
                  gg = g1*g1 + g2*g2 + g3*g3
                  gg= gg-ggcut
                  if (gg.lt.-eps) zrow = .false.
               end do
            end if
          end do
          if (.not.zrow) then
            log_mb(zero_arow3(1)+(i-1)+nx(1)*(j-1)) =.false.
            q = int_mb(q_map3(1,1)+(i-1)+(j-1)*(nx(1)))
            p = int_mb(p_map3(1,1)+(i-1)+(j-1)*(nx(1)))
            if (p.eq.taskid) then
              log_mb(zero_row3(1,fb)+q-1) =.false.
            end if
          end if

         end do
         end do

*        **** find zero_slab23 - (i,*,*) slabs that are zero ****
         do k1 = 1,nx(1)
           log_mb(zero_slab23(1,fb)+k1-1) =.true.
         end do

         do k1 = -nxh+1, nxh-1
          i=k1
          if (i .lt. 0) i = i + nx(1)
          i=i+1
          yzslab = .true.
          do k3 = -nzh+1, nzh-1
          do k2 = -nyh+1, nyh-1
            if (fb.eq.0) then
               g1 = k1*lattice_unitg(1,1)
     >            + k2*lattice_unitg(1,2)
     >            + k3*lattice_unitg(1,3)
               g2 = k1*lattice_unitg(2,1)
     >            + k2*lattice_unitg(2,2)
     >            + k3*lattice_unitg(2,3)
               g3 = k1*lattice_unitg(3,1)
     >            + k2*lattice_unitg(3,2)
     >            + k3*lattice_unitg(3,3)
               gg = g1*g1 + g2*g2 + g3*g3
               gg= gg-ggcut
               if (gg.lt.-eps) yzslab = .false.
            else
               do nbb=1,brillioun_nbrillq()
                  g1 = k1*lattice_unitg(1,1)
     >               + k2*lattice_unitg(1,2)
     >               + k3*lattice_unitg(1,3)
     >               + brillioun_k(1,nbb)
                  g2 = k1*lattice_unitg(2,1)
     >               + k2*lattice_unitg(2,2)
     >               + k3*lattice_unitg(2,3)
     >               + brillioun_k(2,nbb)
                  g3 = k1*lattice_unitg(3,1)
     >               + k2*lattice_unitg(3,2)
     >               + k3*lattice_unitg(3,3)
     >               + brillioun_k(3,nbb)
                  gg = g1*g1 + g2*g2 + g3*g3
                  gg= gg-ggcut
                  if (gg.lt.-eps) yzslab = .false.
               end do
            end if
          end do
          end do
          if (.not.yzslab) then
            log_mb(zero_slab23(1,fb)+i-1) =.false.
          end if

         end do


*        **** find zero_row2 - (i,*,k) rows that are zero after fft of (i,j,*) ****
         do k = 1,nz(1)
         do i = 1,nx(1)
           q = int_mb(q_map2(1,1)+(k-1)+(i-1)*(nz(1)))
           p = int_mb(p_map2(1,1)+(k-1)+(i-1)*(nz(1)))

           log_mb(zero_arow2(1)+i-1+nx(1)*(k-1))
     >       = log_mb(zero_slab23(1,fb)+i-1)
           if (p.eq.taskid) then
            log_mb(zero_row2(1,fb)+q-1)
     >       = log_mb(zero_slab23(1,fb)+i-1)
           end if
         end do
         end do

         call C3dB_c_ptranspose_ijk_init(fb,
     >                                   log_mb(zero_arow2(1)),
     >                                   log_mb(zero_arow3(1)))


         end do

       value =           MA_pop_stack(zero_arow3(2))
       value = value.and.MA_pop_stack(zero_arow2(2))
       if (.not. value) call errquit('error pop stack',0,MA_ERR)


      end if

      call C3dB_pfft3_queue_init(control_pfft3_qsize())

      return
      end




*     ***********************************
*     *                                 *
*     *         C3dB_pfft_end           *
*     *                                 *
*     ***********************************

      subroutine C3dB_pfft_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"
#include "C3dB_pfft.fh"



*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk1 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start

*     **** indexing variables ****
      integer jq_to_i1(2,0:1)
      integer jq_to_i2(2,0:1)
      integer jz_to_i2(2,0:1)
      integer j1_start(2,0:1)
      integer j2_start(2,0:1)
      common / c_ptrans_blk2 / jq_to_i1,jq_to_i2,jz_to_i2,
     >                       j1_start,j2_start


*     *** hilbert tranpose data structure ****
      integer h_iq_to_i1(2,6,0:1)
      integer h_iq_to_i2(2,6,0:1)
      integer h_iz_to_i2(2,6,0:1)
      integer h_iz_to_i2_count(6,0:1)
      integer h_i1_start(2,6,0:1)
      integer h_i2_start(2,6,0:1)
      common / c_ptrans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_iz_to_i2,
     >                         h_iz_to_i2_count,
     >                         h_i1_start,
     >                         h_i2_start


      logical value
      integer i

      value =           MA_free_heap(zero_row2(2,0))
      value = value.and.MA_free_heap(zero_row2(2,1))
      value = value.and.MA_free_heap(zero_row3(2,0))
      value = value.and.MA_free_heap(zero_row3(2,1))
      value = value.and.MA_free_heap(zero_slab23(2,0))
      value = value.and.MA_free_heap(zero_slab23(2,1))

      if (mapping.eq.1) then
      value = value.and.MA_free_heap(iq_to_i1(2,0))
      value = value.and.MA_free_heap(iq_to_i1(2,1))
      value = value.and.MA_free_heap(iq_to_i2(2,0))
      value = value.and.MA_free_heap(iq_to_i2(2,1))
      value = value.and.MA_free_heap(iz_to_i2(2,0))
      value = value.and.MA_free_heap(iz_to_i2(2,1))
      value = value.and.MA_free_heap(i1_start(2,0))
      value = value.and.MA_free_heap(i1_start(2,1))
      value = value.and.MA_free_heap(i2_start(2,0))
      value = value.and.MA_free_heap(i2_start(2,1))

      value = value.and.MA_free_heap(jq_to_i1(2,0))
      value = value.and.MA_free_heap(jq_to_i1(2,1))
      value = value.and.MA_free_heap(jq_to_i2(2,0))
      value = value.and.MA_free_heap(jq_to_i2(2,1))
      value = value.and.MA_free_heap(jz_to_i2(2,0))
      value = value.and.MA_free_heap(jz_to_i2(2,1))
      value = value.and.MA_free_heap(j1_start(2,0))
      value = value.and.MA_free_heap(j1_start(2,1))
      value = value.and.MA_free_heap(j2_start(2,0))
      value = value.and.MA_free_heap(j2_start(2,1))
      end if

      if (mapping.eq.2) then
      do i=1,6
      value = value.and.MA_free_heap(h_i1_start(2,i,0))
      value = value.and.MA_free_heap(h_i2_start(2,i,0))
      value = value.and.MA_free_heap(h_iq_to_i1(2,i,0))
      value = value.and.MA_free_heap(h_iq_to_i2(2,i,0))
      value = value.and.MA_free_heap(h_iz_to_i2(2,i,0))
      value = value.and.MA_free_heap(h_i1_start(2,i,1))
      value = value.and.MA_free_heap(h_i2_start(2,i,1))
      value = value.and.MA_free_heap(h_iq_to_i1(2,i,1))
      value = value.and.MA_free_heap(h_iq_to_i2(2,i,1))
      value = value.and.MA_free_heap(h_iz_to_i2(2,i,1))
      end do
      end if

      if (.not. value) call errquit('error freeing heap',0,MA_ERR)

      call C3dB_pfft3_queue_end()
      return
      end




*     ***********************************
*     *					*
*     *	        C3dB_cr_pfft3b		*
*     *					*
*     ***********************************

      subroutine C3dB_cr_pfft3b(nb,nbb,A)

*****************************************************
*                                                   *
*      This routine performs the operation of       *
*      a three dimensional complex to complex       *
*      inverse fft                                  *
*           A(nx,ny(nb),nz(nb)) <- FFT3^(-1)[A(kx,ky,kz)]   * 
*                                                   *
*      Entry - 					    *
*              A: a column distribuded 3d block     *
*              tmp: tempory work space must be at   *
*                    least the size of (complex)    *
*                    (nfft*nfft + 1) + 10*nfft      * 
*                                                   *
*       Exit - A is transformed and the imaginary   *
*              part of A is set to zero             *
*       uses - C3dB_c_ptranspose_jk, dcopy           *
*                                                   *
*****************************************************

      implicit none
      integer nb,nbb
      complex*16  A(*)

#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz


*     *** local variables ***
      integer i,j,k,q,indx,fb
      integer indx2
#ifdef MLIB
      integer ierr
#endif

      
      !integer tmp1(2),tmp2(2),tmp3(2)
      integer tmp2(2),tmp3(2)
      logical value


      call nwpw_timing_start(1)

      !*** set fb ***
      if (nbb.eq.0) then
         fb = 0 
      else
         fb = 1 
      end if
 

*     ***** allocate temporary space ****
      !call C3dB_nfft3d(nb,nfft3d)
      value = MA_push_get(mt_dcpl,(nfft3d(nb)),'ffttmp2',
     >                    tmp2(2),tmp2(1))
      value = value.and.
     >      MA_push_get(mt_dcpl,(nfft3d(nb)),'ffttmp3',tmp3(2),tmp3(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

*     ****************************************************
*     ***     do fft along ky dimension                ***
*     ***  A(kx,ny(nb),kz) <- fft1d^(-1)[A(kx,ky,kz)]  ***
*     ****************************************************
#ifdef MLIB
      !call z1dfft(dbl_mb(tmp3(1)),nz(nb),dcpl_mb(tmpz(1)),-3,ierr)
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nx(nb)
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then

         indx = i + (q-1)*nx(nb)*nz(nb)
         call zcopy(nz(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
         call z1dfft(dcpl_mb(tmp2(1)),nz(nb),
     >               dcpl_mb(tmpz(1,nb)),-2,ierr)
         call zcopy(nz(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))

       end if
      end do
      end do

#else
      !call dcffti(nz(nb),dcpl_mb(tmp1(1)))
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nx(nb)
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(nb)*nz(nb)
         call zcopy(nz(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
         call dcfftb(nz(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpz(1,nb)))
         call zcopy(nz(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))
       end if
      end do
      end do
#endif

*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***   A(kx,kz,ny(nb)) <- A(kx,ny(nb),kz)  ***
*     ********************************************
      call C3dB_c_ptranspose1_jk(fb,A,dcpl_mb(tmp2(1)),dcpl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(kx,nz(nb),ny(nb)) <- fft1d^(-1)[A(kx,kz,ny(nb))]  ***
*     *************************************************
#ifdef MLIB
     
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nx(nb)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then
          indx = i + (q-1)*nx(nb)*ny(nb)
          call zcopy(ny(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
          call z1dfft(dcpl_mb(tmp2(1)),ny(nb),
     >               dcpl_mb(tmpy(1,nb)),-2,ierr)
          call zcopy(ny(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))
        end if
      end do
      end do
      
#else
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nx(nb)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(nb)*ny(nb)
         call zcopy(ny(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
         call dcfftb(ny(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpy(1,nb)))
         call zcopy(ny(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))
        end if
      end do
      end do
#endif

*     *********************************************************************
*     ***     do fft along kx dimension                                 ***
*     ***   A(nx(nb),nz(nb),ny(nb)) <- fft1d^(-1)[A(kx,nz(nb),ny(nb))]  ***
*     *********************************************************************
#ifdef MLIB
      !call drc1ft (dbl_mb(tmp3(1)),nx(nb),dcpl_mb(tmp1(1)),-3,ierr)
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         call z1dfft(A(indx),nx(nb),
     >               dcpl_mb(tmpx(1,nb)),-2,ierr)
         indx = indx + nx(nb)
      end do
      end do
#else
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         call dcfftb(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nx(nb)
      end do
      end do
#endif


      !*************************
      !**** hilbert mapping ****
      !*************************
      else

*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(nz(nb),kx,ky) <- fft1d^(-1)[A(kz,kx,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call z1dfft(A(indx),nz(nb),dcpl_mb(tmpz(1,nb)),-2,ierr)
         end if
         indx = indx + nz(nb)
      end do
#else
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call dcfftb(nz(nb),A(indx),dcpl_mb(tmpz(1,nb)))
         end if
         indx = indx + nz(nb)
      end do
#endif

      call C3dB_c_ptranspose_ijk(fb,3,A,
     >                           dcpl_mb(tmp2(1)),
     >                           dcpl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(ny(nb),nz(nb),kx) <- fft1d^(-1)[A(ky,nz(nb),kx)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call z1dfft(A(indx),ny(nb),dcpl_mb(tmpy(1,nb)),-2,ierr)
         end if
         indx = indx + ny(nb)
      end do
#else
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call dcfftb(ny(nb),A(indx),dcpl_mb(tmpy(1,nb)))
         end if
         indx = indx + ny(nb)
      end do
#endif

      call C3dB_c_ptranspose_ijk(fb,4,A,
     >                           dcpl_mb(tmp2(1)),
     >                           dcpl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(nb),ny(nb),nz(nb)) <- fft1d^(-1)[A(kx,ny(nb),nz(nb))]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq1(nb)
         call z1dfft(A(indx),nx(nb),dcpl_mb(tmpx(1,nb)),-2,ierr)
         indx = indx + nx(nb)
      end do
#else
      indx = 1
      do q=1,nq1(nb)
         call dcfftb(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nx(nb)
      end do
#endif

      end if
    
*     **** deallocate temporary space  ****
      value = MA_pop_stack(tmp3(2))
      value = MA_pop_stack(tmp2(2))
      !value = MA_pop_stack(tmp1(2))

      call nwpw_timing_end(1)
      return
      end




*     ***********************************
*     *					*
*     *	        C3dB_rc_pfft3f		*
*     *					*
*     ***********************************

      subroutine C3dB_rc_pfft3f(nb,nbb,A)

*****************************************************
*                                                   *
*      This routine performs the operation of       *
*      a three dimensional complex to complex fft   *
*           A(kx,ky,kz) <- FFT3[A(nx(nb),ny(nb),nz(nb))]        * 
*                                                   *
*      Entry - 					    *
*              A: a column distribuded 3d block     *
*              tmp: tempory work space must be at   *
*                    least the size of (complex)    *
*                    (nfft*nfft + 1) + 10*nfft      * 
*                                                   *
*       Exit - A is transformed                     *
*                                                   *
*       uses - ptranspose1 subroutine                *
*                                                   *
*****************************************************

      implicit none
      integer nb,nbb
      complex*16  A(*)

#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz

*     *** local variables ***
      integer i,j,k,q,indx,indx1,indx2,fb
#ifdef MLIB
      integer ierr
#endif

      !integer tmp1(2),tmp2(2),tmp3(2)
      integer tmp2(2),tmp3(2)
      logical value


      call nwpw_timing_start(1)

      !*** set fb ***
      if (nbb.eq.0) then
         fb = 0
      else
         fb = 1
      end if

*     ***** allocate temporary space ****
      !call C3dB_nfft3d(nb,nfft3d)
      value = MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp2',tmp2(2),tmp2(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp3',tmp3(2),tmp3(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
*     ********************************************
*     ***     do fft along nx(nb) dimension        ***
*     ***   A(kx,nz(nb),ny(nb)) <- fft1d[A(nx(nb),nz(nb),ny(nb))]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         call z1dfft(A(indx),nx(nb),dcpl_mb(tmpx(1,nb)),1,ierr)
         indx = indx + nx(nb)
      end do
      end do
#else
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         call dcfftf(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nx(nb)
      end do
      end do
#endif


*     ********************************************
*     ***     do fft along nz(nb) dimension        ***
*     ***   A(kx,kz,nz(nb)) <- fft1d[A(kx,nz(nb),ny(nb))]  ***
*     ********************************************

#ifdef MLIB
      
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nx(nb)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then

         indx = i + (q-1)*nx(nb)*ny(nb)
         call zcopy(ny(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
         call z1dfft(dcpl_mb(tmp2(1)),ny(nb),dcpl_mb(tmpy(1,nb)),1,ierr)
         call zcopy(ny(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))

        end if
      end do
      end do
#else

       indx2 = 0
       do q=1,nq(nb)
       do i=1,nx(nb)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then

          indx = i + (q-1)*nx(nb)*ny(nb)
          call zcopy(ny(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
          call dcfftf(ny(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpy(1,nb)))
          call zcopy(ny(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))
        end if
       end do
       end do

#endif

*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(ky,ny(nb),kz) <- A(kx,kz,ny(nb))      ***
*     ********************************************
      call C3dB_c_ptranspose2_jk(fb,A,dcpl_mb(tmp2(1)),dcpl_mb(tmp3(1)))


*     ********************************************
*     ***     do fft along ny(nb) dimension        ***
*     ***   A(kx,ky,kz) <- fft1d[A(kx,ny(nb),kz)]  ***
*     ********************************************
#ifdef MLIB
      
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nx(nb)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(nb)*ny(nb)
         call zcopy(nz(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
         call z1dfft(dcpl_mb(tmp2(1)),nz(nb),dcpl_mb(tmpz(1,nb)),1,ierr)
         call zcopy(nz(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))

        end if
      end do
      end do
#else

       indx2 = 0
       do q=1,nq(nb)
       do i=1,nx(nb)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then
          indx = i + (q-1)*nx(nb)*ny(nb)
          call zcopy(nz(nb),A(indx),nx(nb),dcpl_mb(tmp2(1)),1)
          call dcfftf(nz(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpz(1,nb)))
          call zcopy(nz(nb),dcpl_mb(tmp2(1)),1,A(indx),nx(nb))
        end if
       end do
       end do

#endif


      !*************************
      !**** hilbert mapping ****
      !*************************
      else

*     ********************************************
*     ***     do fft along nx(nb) dimension        ***
*     ***   A(kx,ny(nb),nz(nb)) <- fft1d[A(nx(nb),ny(nb),nz(nb))]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq1(nb)
         call z1dfft(A(indx),nx(nb),dcpl_mb(tmpx(1,nb)),1,ierr)
         indx = indx + nx(nb)
      end do
#else
      indx = 1
      do q=1,nq1(nb)
         call dcfftf(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nx(nb)
      end do
#endif

      call C3dB_c_ptranspose_ijk(fb,1,A,
     >                           dcpl_mb(tmp2(1)),
     >                           dcpl_mb(tmp3(1)))

*     ********************************************
*     ***     do fft along ny(nb) dimension        ***
*     ***   A(ky,nz(nb),kx) <- fft1d[A(ny(nb),nz(nb),kx)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call z1dfft(A(indx),ny(nb),dcpl_mb(tmpy(1,nb)),1,ierr)
         end if
         indx = indx + ny(nb)
      end do
#else
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call dcfftf(ny(nb),A(indx),dcpl_mb(tmpy(1,nb)))
         end if
         indx = indx + ny(nb)
      end do
#endif

      call C3dB_c_ptranspose_ijk(fb,2,A,
     >                          dcpl_mb(tmp2(1)),
     >                          dcpl_mb(tmp3(1)))

*     ********************************************
*     ***     do fft along nz(nb) dimension        ***
*     ***   A(kz,kx,ky) <- fft1d[A(nz(nb),kx,ky)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call z1dfft(A(indx),nz(nb),dcpl_mb(tmpz(1,nb)),1,ierr)
         end if
         indx = indx + nz(nb)
      end do
#else
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call dcfftf(nz(nb),A(indx),dcpl_mb(tmpz(1,nb)))
         end if
         indx = indx + nz(nb)
      end do
#endif

      end if


*     **** deallocate temporary space  ****
      value = MA_pop_stack(tmp3(2))
      value = MA_pop_stack(tmp2(2))
      !value = MA_pop_stack(tmp1(2))

      call nwpw_timing_end(1)
      return
      end




*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose_jk_init	*
*     *					*
*     ***********************************

      subroutine C3dB_c_ptranspose_jk_init(fb,zero_arow3)
      implicit none
      integer fb
      logical zero_arow3(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"


*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / c_ptrans_blk1 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start

*     **** indexing variables ****
      integer jq_to_i1(2,0:1)
      integer jq_to_i2(2,0:1)
      integer jz_to_i2(2,0:1)
      integer j1_start(2,0:1)
      integer j2_start(2,0:1)
      common / c_ptrans_blk2 / jq_to_i1,jq_to_i2,jz_to_i2,
     >                       j1_start,j2_start



*     **** local variables ****
      integer proc_to,proc_from
      integer pto,qto,np,taskid
      integer pfrom,qfrom
      integer phere,qhere
      integer index1,index2,index3
      integer jndex1,jndex2,jndex3
      integer itmp,ii,jj
      integer i,j,k,it
      logical value



*     **** allocate ptrans_blk1 and ptrans_blk2 common block ****
      value = MA_alloc_get(mt_int,(nx(1)*ny(1)*nq(1)),
     >                     'piq_to_i1',iq_to_i1(2,fb),iq_to_i1(1,fb))
      value=value.and.MA_alloc_get(mt_int,(nx(1)*ny(1)*nq(1)),
     >                     'piq_to_i2',iq_to_i2(2,fb),iq_to_i2(1,fb))
      value=value.and.MA_alloc_get(mt_int,(nx(1)*ny(1)*nq(1)),
     >                     'piz_to_i2',iz_to_i2(2,fb),iz_to_i2(1,fb))

      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'pi1_start',i1_start(2,fb),i1_start(1,fb))
      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'pi2_start',i2_start(2,fb),i2_start(1,fb))


      value = MA_alloc_get(mt_int,(nx(1)*ny(1)*nq(1)),
     >                     'riq_to_i1',jq_to_i1(2,fb),jq_to_i1(1,fb))
      value=value.and.MA_alloc_get(mt_int,(nx(1)*ny(1)*nq(1)),
     >                     'riq_to_i2',jq_to_i2(2,fb),jq_to_i2(1,fb))
      value=value.and.MA_alloc_get(mt_int,(nx(1)*ny(1)*nq(1)),
     >                     'riz_to_i2',jz_to_i2(2,fb),jz_to_i2(1,fb))

      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'ri1_start',j1_start(2,fb),j1_start(1,fb))
      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'ri2_start',j2_start(2,fb),j2_start(1,fb))

      if (.not. value) 
     > call errquit('C3dB_ptranspose_jk_init:out of heap',0,MA_ERR)

      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)


      index1 = 1 
      index2 = 1
      index3 = 1
      jndex1 = 1 
      jndex2 = 1
      jndex3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(i1_start(1,fb)+it) = index1
         int_mb(i2_start(1,fb)+it) = index2
         int_mb(j1_start(1,fb)+it) = jndex1
         int_mb(j2_start(1,fb)+it) = jndex2

         do k=1,nz(1)
         do j=1,ny(1)

*           **** packing scheme **** 
            call C3dB_ktoqp(1,k,qhere,phere)
            call C3dB_ktoqp(1,j,qto,pto)
            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               do i=1,nx(1)
                  ii = i + nx(1)*(k-1)
                  jj = i + nx(1)*(j-1)
                  itmp = i + (j-1)*nx(1) 
     >                     + (qhere-1)*nx(1)*ny(1)

                  if (.not.zero_arow3(ii)) then
                  int_mb(iq_to_i1(1,fb)+index1-1) = itmp
                  index1 = index1 + 1
                  end if

                  if (.not.zero_arow3(jj)) then
                  int_mb(jq_to_i1(1,fb)+jndex1-1) = itmp
                  jndex1 = jndex1 + 1
                  end if

               end do
            end if
             
*           **** unpacking scheme ****
            call C3dB_ktoqp(1,j,qhere,phere)
            call C3dB_ktoqp(1,k,qfrom,pfrom)
            if ((phere.eq.taskid).and.(pfrom.eq.proc_from)) then
               do i=1,nx(1)
                  ii = i + nx(1)*(k-1)
                  jj = i + nx(1)*(j-1)
                  itmp = i + (k-1)*nx(1)
     >                     + (qhere-1)*nx(1)*ny(1)
                  if (zero_arow3(ii)) then
                  int_mb(iz_to_i2(1,fb)+index3-1) = itmp
                  index3 = index3 + 1
                  else
                  int_mb(iq_to_i2(1,fb)+index2-1) = itmp
                  index2 = index2 + 1
                  end if

                  if (zero_arow3(jj)) then
                  int_mb(jz_to_i2(1,fb)+jndex3-1) = itmp
                  jndex3 = jndex3 + 1
                  else
                  int_mb(jq_to_i2(1,fb)+jndex2-1) = itmp
                  jndex2 = jndex2 + 1
                  end if
               end do
            end if
         end do
         end do
      end do
      int_mb(i1_start(1,fb)+np) = index1
      int_mb(i2_start(1,fb)+np) = index2
      int_mb(j1_start(1,fb)+np) = jndex1
      int_mb(j2_start(1,fb)+np) = jndex2


      return
      end





*     ***********************************
*     *					*
*     *	   C3dB_c_ptranspose_ijk_init	*
*     *					*
*     ***********************************

      subroutine C3dB_c_ptranspose_ijk_init(fb,zero_arow2,zero_arow3)
      implicit none
      integer fb
      logical zero_arow2(*)
      logical zero_arow3(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"


*     *** hilbert tranpose data structure ****
      integer h_iq_to_i1(2,6,0:1)
      integer h_iq_to_i2(2,6,0:1)
      integer h_iz_to_i2(2,6,0:1)
      integer h_iz_to_i2_count(6,0:1)
      integer h_i1_start(2,6,0:1)
      integer h_i2_start(2,6,0:1)
      common / c_ptrans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_iz_to_i2,
     >                         h_iz_to_i2_count,
     >                         h_i1_start,
     >                         h_i2_start

*     **** local variables ****
      logical value,iszero
      integer proc_to,proc_from
      integer pto,qto,np,taskid
      integer phere,qhere
      integer index1,index2,index3,itmp
      integer i,j,k,it


      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)


*     ********************************************************
*     **** map1to2 mapping - done - tranpose operation #1  ***
*     ****   (ny,nz,nx)  <-- (nx,ny,nz)                    ***
*     ****   use zero_arow2                                ***
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nx(1)*nq1(1)),
     >                     'h_iq_to_i1_1',
     >                      h_iq_to_i1(2,1,fb),
     >                      h_iq_to_i1(1,1,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i2_1',
     >                      h_iq_to_i2(2,1,fb),
     >                      h_iq_to_i2(1,1,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iz_to_i2_1',
     >                      h_iz_to_i2(2,1,fb),
     >                      h_iz_to_i2(1,1,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_1',
     >                      h_i1_start(2,1,fb),
     >                      h_i1_start(1,1,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_1',
     >                      h_i2_start(2,1,fb),
     >                      h_i2_start(1,1,fb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_initt:out of heap',0,MA_ERR)

      index1 = 1 
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,1,fb)+it) = index1
         int_mb(h_i2_start(1,1,fb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,nx(1)
            iszero = zero_arow2(i+(k-1)*nx(1)) 

*           **** packing scheme **** 
            phere = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qhere = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))

            pto   = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qto   = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))
            
           
            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = i + (qhere-1)*nx(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,1,fb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if
             
*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = j + (qto-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,1,fb)+index2-1) =  itmp
               index2 = index2 + 1
               else
               int_mb(h_iz_to_i2(1,1,fb)+index3-1) =  itmp
               index3 = index3 + 1
               end if
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,1,fb)+np) = index1
      int_mb(h_i2_start(1,1,fb)+np) = index2
      h_iz_to_i2_count(1,fb) = index3 - 1





*     *********************************************************
*     **** map2to3 mapping - done - transpose operation #2 ****
*     ****    (nz,nx,ny)  <-- (ny,nz,nx)                   ****
*     ****    use zero_arow3                               ****
*     *********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i1_2',
     >                      h_iq_to_i1(2,2,fb),
     >                      h_iq_to_i1(1,2,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i2_2',
     >                      h_iq_to_i2(2,2,fb),
     >                      h_iq_to_i2(1,2,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iz_to_i2_2',
     >                      h_iz_to_i2(2,2,fb),
     >                      h_iz_to_i2(1,2,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_2',
     >                      h_i1_start(2,2,fb),
     >                      h_i1_start(1,2,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_2',
     >                      h_i2_start(2,2,fb),
     >                      h_i2_start(1,2,fb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,2,fb)+it) = index1
         int_mb(h_i2_start(1,2,fb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,nx(1)

            iszero = zero_arow3(i+(j-1)*nx(1))

*           **** packing scheme ****
            phere = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qhere = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))

            pto   = int_mb(p_map3(1,1)+(i-1)+(j-1)*nx(1))
            qto   = int_mb(q_map3(1,1)+(i-1)+(j-1)*nx(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = j + (qhere-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,2,fb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = k + (qto-1)*nz(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,2,fb)+index2-1) = itmp
               index2 = index2 + 1
               else  
               int_mb(h_iz_to_i2(1,2,fb)+index3-1) = itmp
               index3 = index3 + 1
               end if
            end if


         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,2,fb)+np) = index1
      int_mb(h_i2_start(1,2,fb)+np) = index2
      h_iz_to_i2_count(2,fb) = index3 - 1






*     ********************************************************
*     **** map3to2 mapping - done - tranpose operation #3 ****
*     ****  (ny,nz,nx)  <-- (nz,nx,ny)                    ****
*     ****   use zero_arow3                               ****
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i1_3',
     >                      h_iq_to_i1(2,3,fb),
     >                      h_iq_to_i1(1,3,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i2_3',
     >                      h_iq_to_i2(2,3,fb),
     >                      h_iq_to_i2(1,3,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iz_to_i2_3',
     >                      h_iz_to_i2(2,3,fb),
     >                      h_iz_to_i2(1,3,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_3',
     >                      h_i1_start(2,3,fb),
     >                      h_i1_start(1,3,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_3',
     >                      h_i2_start(2,3,fb),
     >                      h_i2_start(1,3,fb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,3,fb)+it) = index1
         int_mb(h_i2_start(1,3,fb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,nx(1)

            iszero = zero_arow3(i+(j-1)*nx(1))

*           **** packing scheme ****
            phere = int_mb(p_map3(1,1)+(i-1)+(j-1)*nx(1))
            qhere = int_mb(q_map3(1,1)+(i-1)+(j-1)*nx(1))

            pto   = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qto   = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = k + (qhere-1)*nz(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,3,fb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = j + (qto-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,3,fb)+index2-1) = itmp
               index2 = index2 + 1
               else
               int_mb(h_iz_to_i2(1,3,fb)+index3-1) = itmp
               index3 = index3 + 1
               end if
            end if


         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,3,fb)+np) = index1
      int_mb(h_i2_start(1,3,fb)+np) = index2
      h_iz_to_i2_count(3,fb) = index3 - 1




*     ********************************************************
*     **** map2to1 mapping - done - tranpose operation #4 ****
*     ****  (nx,ny,nz)  <-- (ny,nz,nx)                    ****
*     ****  use zero_arow2                                ****
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i1_4',
     >                      h_iq_to_i1(2,4,fb),
     >                      h_iq_to_i1(1,4,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nx(1)*nq1(1)),
     >                     'h_iq_to_i2_4',
     >                      h_iq_to_i2(2,4,fb),
     >                      h_iq_to_i2(1,4,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nx(1)*nq1(1)),
     >                     'h_iz_to_i2_4',
     >                      h_iz_to_i2(2,4,fb),
     >                      h_iz_to_i2(1,4,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_4',
     >                      h_i1_start(2,4,fb),
     >                      h_i1_start(1,4,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_4',
     >                      h_i2_start(2,4,fb),
     >                      h_i2_start(1,4,fb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,4,fb)+it) = index1
         int_mb(h_i2_start(1,4,fb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,nx(1)

            iszero = zero_arow2(i+(k-1)*nx(1))

*           **** packing scheme ****
            phere = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qhere = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))

            pto   = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qto   = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = j + (qhere-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,4,fb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = i + (qto-1)*nx(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,4,fb)+index2-1) = itmp
               index2 = index2 + 1
               else
               int_mb(h_iz_to_i2(1,4,fb)+index3-1) = itmp
               index3 = index3 + 1
               end if
            end if


         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,4,fb)+np) = index1
      int_mb(h_i2_start(1,4,fb)+np) = index2
      h_iz_to_i2_count(4,fb) = index3 - 1





*     **********************************************************
*     **** map1to3 mapping  - done - tranpose operation # 5 ****
*     **********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nx(1)*nq1(1)),
     >                     'h_iq_to_i1_5',
     >                      h_iq_to_i1(2,5,fb),
     >                      h_iq_to_i1(1,5,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i2_5',
     >                      h_iq_to_i2(2,5,fb),
     >                      h_iq_to_i2(1,5,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iz_to_i2_5',
     >                      h_iz_to_i2(2,5,fb),
     >                      h_iz_to_i2(1,5,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_5',
     >                      h_i1_start(2,5,fb),
     >                      h_i1_start(1,5,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_5',
     >                      h_i2_start(2,5,fb),
     >                      h_i2_start(1,5,fb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,5,fb)+it) = index1
         int_mb(h_i2_start(1,5,fb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,nx(1)

*           **** packing scheme ****
            phere = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qhere = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))

            pto   = int_mb(p_map3(1,1)+(i-1)+(j-1)*nx(1))
            qto   = int_mb(q_map3(1,1)+(i-1)+(j-1)*nx(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = i + (qhere-1)*nx(1)
               int_mb(h_iq_to_i1(1,5,fb)+index1-1) = itmp
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = k + (qto-1)*nz(1)
               int_mb(h_iq_to_i2(1,5,fb)+index2-1) = itmp
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,5,fb)+np) = index1
      int_mb(h_i2_start(1,5,fb)+np) = index2
      h_iz_to_i2_count(5,fb) = index3 - 1






*     *************************
*     **** map3to1 mapping ****
*     *************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i1_6',
     >                      h_iq_to_i1(2,6,fb),
     >                      h_iq_to_i1(1,6,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nx(1)*nq1(1)),
     >                     'h_iq_to_i2_6',
     >                      h_iq_to_i2(2,6,fb),
     >                      h_iq_to_i2(1,6,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nx(1)*nq1(1)),
     >                     'h_iz_to_i2_6',
     >                      h_iz_to_i2(2,6,fb),
     >                      h_iz_to_i2(1,6,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_6',
     >                      h_i1_start(2,6,fb),
     >                      h_i1_start(1,6,fb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_6',
     >                      h_i2_start(2,6,fb),
     >                      h_i2_start(1,6,fb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,6,fb)+it) = index1
         int_mb(h_i2_start(1,6,fb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,nx(1)

*           **** packing scheme ****
            phere = int_mb(p_map3(1,1)+(i-1)+(j-1)*nx(1))
            qhere = int_mb(q_map3(1,1)+(i-1)+(j-1)*nx(1))

            pto   = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qto   = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = k + (qhere-1)*nz(1)
               int_mb(h_iq_to_i1(1,6,fb)+index1-1) = itmp
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = i + (qto-1)*nx(1)
               int_mb(h_iq_to_i2(1,6,fb)+index2-1) = itmp
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,6,fb)+np) = index1
      int_mb(h_i2_start(1,6,fb)+np) = index2
      h_iz_to_i2_count(6,fb) = index3 - 1


      return
      end



*     ***********************************
*     *                                 *
*     *         C3dB_pfftfx             *
*     *                                 *
*     ***********************************
*
*     do fft along nx(1) dimension       
*
*        A(kx,ny(1),nz(1)) <- fft1d[A(nx(1),ny(1),nz(1))] 
*     

      subroutine C3dB_pfftfx(nbb,A,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 A(*)
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz

      !*** local variables ***
      integer j,q,indx,fb

      if (nbb.eq.0) then
         fb = 0
      else
         fb = 1
      end if

      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
      call nwpw_timing_start(31)
#ifdef MLIB
      indx = 1
      do q=1,nq(1)
      do j=1,ny(1)
         call z1dfft(A(indx),nx(1),dcpl_mb(tmpx(1,1)),1,ierr)
         indx = indx + nx(1)
      end do
      end do

#else
      indx = 1
      do q=1,nq(1)
      do j=1,ny(1)
         call dcfftf(nx(1),A(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nx(1)
      end do
      end do
#endif
      call dcopy(2*nx(1)*ny(1)*nq(1),A,1,tmp1,1)
      call nwpw_timing_end(31)


      !*************************
      !**** hilbert mapping ****
      !*************************
      else
      call nwpw_timing_start(31)

#ifdef MLIB
      indx = 1
      do q=1,nq1(1)
         call z1dfft(A(indx),nx(1),dcpl_mb(tmpx(1,1)),1,ierr)
         indx = indx + nx(1)
      end do
#else
      indx = 1
      do q=1,nq1(1)
         call dcfftf(nx(1),A(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nx(1)
      end do
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_start(fb,1,A,tmp1,tmp2,
     >                                 request,reqcnt,40)
      call nwpw_timing_end(32)

      end if

      return
      end


*     ***********************************
*     *                                 *
*     *         C3dB_pfftfy             *
*     *                                 *
*     ***********************************
*
*     do fft along ny(1) dimension       
*
*        A(kx,ny(1),nz(1)) <- fft1d[A(nx(1),ny(1),nz(1))] 
*     

      subroutine C3dB_pfftfy(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz


      !*** local variables ***
      integer i,j,k,indx,indx2,q,fb

      if (nbb.eq.0) then
         fb = 0
      else
         fb = 1
      end if

      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along ny(1) dimension        ***
*     ***   A(kx,ky,nz(1)) <- fft1d[A(kx,ny(1),nz(1))]  ***
*     ********************************************

#ifdef MLIB

      indx2 = 0
      do q=1,nq(1)
      do i=1,nx(1)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(1)*ny(1)
         call zcopy(ny(1),tmp1(indx),nx(1),tmp2,1)
         call z1dfft(tmp2,ny(1),dcpl_mb(tmpy(1,1)),1,ierr)
         call zcopy(ny(1),tmp2,1,tmp1(indx),nx(1))
        end if
      end do
      end do
#else
       indx2 = 0
       do q=1,nq(1)
       do i=1,nx(1)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then
          indx = i + (q-1)*nx(1)*ny(1)
          call zcopy(ny(1),tmp1(indx),nx(1),tmp2,1)
          call dcfftf(ny(1),tmp2,dcpl_mb(tmpy(1,1)))
          call zcopy(ny(1),tmp2,1,tmp1(indx),nx(1))
        end if
       end do
       end do
#endif


*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(ky,nz(1),ky) <- A(kx,ky,nz(1))      ***
*     ********************************************
      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose2_jk_start(fb,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,41)
      call nwpw_timing_end(32)




      !*************************
      !**** hilbert mapping ****
      !*************************
      else
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_end(fb,1,tmp1,tmp2,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along ny(1) dimension        ***
*     ***   A(ky,nz(1),kx) <- fft1d[A(ny(1),nz(1),kx)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call z1dfft(tmp1(indx),ny(1),dcpl_mb(tmpy(1,1)),1,ierr)
         end if
         indx = indx + ny(1)
      end do
#else
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call dcfftf(ny(1),tmp1(indx),dcpl_mb(tmpy(1,1)))
         end if
         indx = indx + ny(1)
      end do
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_start(fb,2,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,42)
      call nwpw_timing_end(32)


      end if

      return
      end





*     ***********************************
*     *                                 *
*     *         C3dB_pfftfz             *
*     *                                 *
*     ***********************************
*

      subroutine C3dB_pfftfz(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz


      !*** local variables ***
      integer i,k,q,fb
      integer indx,indx2

#ifdef MLIB
      integer ierr
#endif

      if (nbb.eq.0) then
         fb = 0
      else
         fb = 1
      end if

      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

      call nwpw_timing_start(32)
      call C3dB_c_ptranspose2_jk_end(fb,tmp2,tmp1,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along nz(1) dimension        ***
*     ***   A(kx,kz,ky) <- fft1d[A(kx,nz(1),ky)]  ***
*     ********************************************

#ifdef MLIB
      indx2 = 0
      do q=1,nq(1)
      do i=1,nx(1)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(1)*nz(1)
         call zcopy(nz(1),tmp2(indx),nx(1),tmp1,1)
         call z1dfft(tmp1,nz(1),dcpl_mb(tmpz(1,1)),1,ierr)
         call zcopy(nz(1),tmp1,1,tmp2(indx),nx(1))
        end if
      end do
      end do
#else
      indx2 = 0
      do q=1,nq(1)
      do i=1,nx(1)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then
          indx = i + (q-1)*nx(1)*nz(1)
          call zcopy(nz(1),tmp2(indx),nx(1),tmp1,1)
          call dcfftf(nz(1),tmp1,dcpl_mb(tmpz(1,1)))
          call zcopy(nz(1),tmp1,1,tmp2(indx),nx(1))
        end if
      end do
      end do
      call nwpw_timing_end(31)

#endif


      !*************************
      !**** hilbert mapping ****
      !*************************
      else
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_end(fb,2,tmp2,tmp1,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along nz(1) dimension        ***
*     ***   A(kz,kx,ky) <- fft1d[A(nz(1),kx,ky)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call z1dfft(tmp2(indx),nz(1),dcpl_mb(tmpz(1,1)),1,ierr)
         end if
         indx = indx + nz(1)
      end do
#else
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call dcfftf(nz(1),tmp2(indx),dcpl_mb(tmpz(1,1)))
         end if
         indx = indx + nz(1)
      end do
#endif
      call nwpw_timing_end(31)

      end if



      call nwpw_timing_start(32)
      call Cram_c_pack_start(nbb,tmp2,tmp1,request,reqcnt,43)
      call nwpw_timing_end(32)

      return
      end



*     ***********************************
*     *                                 *
*     *         C3dB_pfftf_final        *
*     *                                 *
*     ***********************************
*

      subroutine C3dB_pfftf_final(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt

#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"

      call nwpw_timing_start(32)
      call Cram_c_pack_end(nbb,tmp2,request,reqcnt)
      call nwpw_timing_end(32)

      return
      end




*     ***********************************
*     *                                 *
*     *         C3dB_pfftf_step         *
*     *                                 *
*     ***********************************
*

      subroutine C3dB_pfftf_step(step,nbb,A,tmp1,tmp2,request,reqcnt)
      implicit none
      integer step
      integer nbb
      complex*16 A(*)
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


      if (step.eq.1) then
         call C3dB_pfftfx(nbb,A,tmp1,tmp2,request,reqcnt)
      else if (step.eq.2) then
         call C3dB_pfftfy(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.3) then
         call C3dB_pfftfz(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.4) then
         call C3dB_pfftf_final(nbb,tmp1,tmp2,request,reqcnt)
      end if

      return
      end




*     ***********************************
*     *					*
*     *	        C3dB_pfftbz		*
*     *					*
*     ***********************************

*                                                  
*      This routine performs the operation of      
*      a three dimensional complex to complex     
*      inverse fft                                
*           A(nx,ny(1),nz(1)) <- FFT3^(-1)[A(kx,ky,kz)]  
*                                                  
*      Entry -                                     
*              A: a column distribuded 3d block    
*              tmp: tempory work space must be at  
*                    least the size of (complex)   
*                    (nfft*nfft + 1) + 10*nfft     
*                                               
*       Exit - A is transformed and the imaginary
*              part of A is set to zero          
*       uses - C3dB_c_ptranspose_jk, dcopy        
*                                                  


      subroutine C3dB_pfftbz(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16  tmp1(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt
      

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"
#include "C3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz



*     *** local variables ***
      integer i,k,q,indx,ierr
      integer indx2,fb

      if (nbb.eq.0) then
         fb = 0
      else
         fb = 1
      end if

      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(kx,nz(1),ky) <- fft1d^(-1)[A(kx,kz,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx2 = 0
      do q=1,nq(1)
      do i=1,nx(1)
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(1)*nz(1)
         call zcopy(nz(1),tmp1(indx),nx(1),tmp2,1)
         call z1dfft(tmp2,nz(1),dcpl_mb(tmpz(1,1)),-2,ierr)
         call zcopy(nz(1),tmp2,1,tmp1(indx),nx(1))
       end if
      end do
      end do
#else
      indx2 = 0
      do q=1,nq(1)
      do i=1,nx(1)
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(1)*nz(1)
         call zcopy(nz(1),tmp1(indx),nx(1),tmp2,1)
         call dcfftb(nz(1),tmp2,dcpl_mb(tmpz(1,1)))
         call zcopy(nz(1),tmp2,1,tmp1(indx),nx(1))
       end if
      end do
      end do
#endif

*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(kx,ky,nz(1)) <- A(kx,nz(1),ky)      ***
*     ********************************************
      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose1_jk_start(fb,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,44)
      call nwpw_timing_end(32)


      !*************************
      !**** hilbert mapping ****
      !*************************
      else


      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(nz(1),kx,ky) <- fft1d^(-1)[A(kz,kx,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call z1dfft(tmp1(indx),nz(1),dcpl_mb(tmpz(1,1)),-2,ierr)
         end if
         indx = indx + nz(1)
      end do
#else
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,fb)+q-1)) then
         call dcfftb(nz(1),tmp1(indx),dcpl_mb(tmpz(1,1)))
         end if
         indx = indx + nz(1)
      end do
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_start(fb,3,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,45)
      call nwpw_timing_end(32)


      end if
    
      return
      end





*     ***********************************
*     *					*
*     *	        C3dB_pfftby		*
*     *					*
*     ***********************************

      subroutine C3dB_pfftby(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16  tmp1(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"
#include "C3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz


*     *** local variables ***
      integer i,j,q,indx,ierr
      integer indx2,fb

      if (nbb.eq.0) then
         fb = 0
      else
         fb = 1
      end if
      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then


*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(kx,ky,nz(1)) <- A(kx,nz(1),ky)      ***
*     ********************************************
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose1_jk_end(fb,tmp2,tmp1,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(kx,ny(1),nz(1)) <- fft1d^(-1)[A(kx,ky,nz(1))]  ***
*     *************************************************
#ifdef MLIB
     
      indx2 = 0
      do q=1,nq(1)
      do i=1,nx(1)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then
          indx = i + (q-1)*nx(1)*nz(1)
          call zcopy(ny(1),tmp2(indx),nx(1),tmp1,1)
          call z1dfft(tmp1,ny(1),dcpl_mb(tmpy(1,1)),-2,ierr)
          call zcopy(ny(1),tmp1,1,tmp2(indx),nx(1))
        end if
      end do
      end do
#else
      indx2 = 0
      do q=1,nq(1)
      do i=1,nx(1)
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,fb)+indx2-1)) then
         indx = i + (q-1)*nx(1)*nz(1)
         call zcopy(ny(1),tmp2(indx),nx(1),tmp1,1)
         call dcfftb(ny(1),tmp1,dcpl_mb(tmpy(1,1)))
         call zcopy(ny(1),tmp1,1,tmp2(indx),nx(1))
        end if
      end do
      end do
#endif

      call nwpw_timing_end(31)


      !*************************
      !**** hilbert mapping ****
      !*************************
      else

      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_end(fb,3,tmp2,tmp1,request,reqcnt)

      call nwpw_timing_end(32)
      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(ny(1),nz(1),kx) <- fft1d^(-1)[A(ky,nz(1),kx)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call z1dfft(tmp2(indx),ny(1),dcpl_mb(tmpy(1,1)),-2,ierr)
         end if
         indx = indx + ny(1)
      end do
#else
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,fb)+q-1)) then
         call dcfftb(ny(1),tmp2(indx),dcpl_mb(tmpy(1,1)))
         end if
         indx = indx + ny(1)
      end do
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_start(fb,4,tmp2,tmp1,tmp2,
     >                                 request,reqcnt,46)
      call nwpw_timing_end(32)


      end if

      return
      end




*     ***********************************
*     *					*
*     *	        C3dB_pfftbx		*
*     *					*
*     ***********************************

      subroutine C3dB_pfftbx(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16  tmp1(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"
#include "C3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / C3dB_fft / tmpx,tmpy,tmpz

*     *** local variables ***
      integer j,q,indx,ierr,fb


      if (nbb.eq.0) then
         fb = 0
      else
         fb = 1
      endif
      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(1),ny(1),nz(1)) <- fft1d^(-1)[A(kx,ny(1),nz(1))]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq(1)
      do j=1,ny(1)
         call z1dfft(tmp2(indx),nx(1),dcpl_mb(tmpx(1,1)),-2,ierr)
         indx = indx + nx(1)
      end do
      end do

#else
      indx = 1
      do q=1,nq(1)
      do j=1,ny(1)
         call dcfftb(nx(1),tmp2(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nx(1)
      end do
      end do
#endif
      call dcopy(2*nx(1)*ny(1)*nq(1),tmp2,1,tmp1,1)



      call nwpw_timing_end(31)
*     *************************************************
      !*************************
      !**** hilbert mapping ****
      !*************************
      else

      call nwpw_timing_start(32)
      call C3dB_c_ptranspose_ijk_end(fb,4,tmp1,tmp2,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(1),ny(1),nz(1)) <- fft1d^(-1)[A(kx,ny(1),nz(1))]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq1(1)
         call z1dfft(tmp1(indx),nx(1),dcpl_mb(tmpx(1,1)),-2,ierr)
         indx = indx + nx(1)
      end do
#else
      indx = 1
      do q=1,nq1(1)
         call dcfftb(nx(1),tmp1(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nx(1)
      end do
#endif
      call nwpw_timing_end(31)

      end if
    
      return
      end


*     ***********************************
*     *                                 *
*     *         C3dB_pfftb_step         *
*     *                                 *
*     ***********************************
*

      subroutine C3dB_pfftb_step(step,nbb,A,tmp1,tmp2,request,reqcnt)
      implicit none
      integer step
      integer nbb
      complex*16 A(*)
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"


      if (step.eq.1) then
         call nwpw_timing_start(32)
         call Cram_c_unpack_start(nbb,A,tmp1,request,reqcnt,47)
         call nwpw_timing_end(32)
      else if (step.eq.2) then
         call nwpw_timing_start(32)
         call Cram_c_unpack_end(nbb,tmp1,tmp2,request,reqcnt)
         call nwpw_timing_end(32)
      else if (step.eq.3) then
         call C3dB_pfftbz(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.4) then
         call C3dB_pfftby(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.5) then
         call C3dB_pfftbx(nbb,tmp1,tmp2,request,reqcnt)
      end if

      return
      end


*     ***********************************
*     *                                 *
*     *     C3dB_pfft3_queue_init       *
*     *                                 *
*     ***********************************

      subroutine C3dB_pfft3_queue_init(qmax_in)
      implicit none
      integer qmax_in


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      !**** pfft_queues ****
      integer aqindx(2),aqstatus(2)
      integer atmp(2),arequest(2),areqcnt(2),aqnbb(2)
      integer aqmax,aqsize,alast_index
      common / c_pfft_aqueue_common / aqindx,aqstatus,atmp,arequest,
     >                              areqcnt,aqnbb,
     >                              aqmax,aqsize,alast_index
      integer bqindx(2),bqstatus(2)
      integer btmp(2),brequest(2),breqcnt(2),bqnbb(2)
      integer bqmax,bqsize,blast_index
      common / c_pfft_bqueue_common / bqindx,bqstatus,btmp,brequest,
     >                              breqcnt,bqnbb,
     >                              bqmax,bqsize,blast_index
      

      logical value
      integer np,size

      call Parallel3d_np_i(np)

c     **** allocate aqueue ****
      aqmax       = qmax_in
      aqsize      = 0
      alast_index = aqmax
      size  = nfft3d(1)*aqmax*2
      value = MA_alloc_get(mt_dcpl,size,'atmp',atmp(2),atmp(1))
      size  = np*aqmax*2
      value = value.and.
     >      MA_alloc_get(mt_int,size,'arequest',arequest(2),arequest(1))
      size  = aqmax
      value = value.and.
     >        MA_alloc_get(mt_int,size,'aqindx',aqindx(2),aqindx(1))
      value = value.and.
     >      MA_alloc_get(mt_int,size,'aqstatus',aqstatus(2),aqstatus(1))
      value = value.and.
     >        MA_alloc_get(mt_int,size,'areqcnt',areqcnt(2),areqcnt(1))
      value = value.and.
     >        MA_alloc_get(mt_int,size,'aqnbb',aqnbb(2),aqnbb(1))


c     **** allocate bqueue ****
      bqmax       = qmax_in
      bqsize      = 0
      blast_index = bqmax
      size  = nfft3d(1)*bqmax*2
      value = MA_alloc_get(mt_dcpl,size,'btmp',btmp(2),btmp(1))
      size  = np*bqmax*2
      value = value.and.
     >      MA_alloc_get(mt_int,size,'brequest',brequest(2),brequest(1))
      size  = bqmax
      value = value.and.
     >        MA_alloc_get(mt_int,size,'bqindx',bqindx(2),bqindx(1))
      value = value.and.
     >      MA_alloc_get(mt_int,size,'bqstatus',bqstatus(2),bqstatus(1))
      value = value.and.
     >        MA_alloc_get(mt_int,size,'breqcnt',breqcnt(2),breqcnt(1))
      value = value.and.
     >        MA_alloc_get(mt_int,size,'bqnbb',bqnbb(2),bqnbb(1))

      return
      end




*     ***********************************
*     *                                 *
*     *     C3dB_pfft3_queue_end        *
*     *                                 *
*     ***********************************

      subroutine C3dB_pfft3_queue_end()
      implicit none


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"



      !**** pfft_queues ****
      integer aqindx(2),aqstatus(2)
      integer atmp(2),arequest(2),areqcnt(2),aqnbb(2)
      integer aqmax,aqsize,alast_index
      common / c_pfft_aqueue_common / aqindx,aqstatus,atmp,arequest,
     >                              areqcnt,aqnbb,
     >                              aqmax,aqsize,alast_index
      integer bqindx(2),bqstatus(2)
      integer btmp(2),brequest(2),breqcnt(2),bqnbb(2)
      integer bqmax,bqsize,blast_index
      common / c_pfft_bqueue_common / bqindx,bqstatus,btmp,brequest,
     >                              breqcnt,bqnbb,
     >                              bqmax,bqsize,blast_index



      logical value

      value =           MA_free_heap(atmp(2))
      value = value.and.MA_free_heap(arequest(2))
      value = value.and.MA_free_heap(aqindx(2))
      value = value.and.MA_free_heap(aqstatus(2))
      value = value.and.MA_free_heap(areqcnt(2))
      value = value.and.MA_free_heap(aqnbb(2))

      value = value.and.MA_free_heap(btmp(2))
      value = value.and.MA_free_heap(brequest(2))
      value = value.and.MA_free_heap(bqindx(2))
      value = value.and.MA_free_heap(bqstatus(2))
      value = value.and.MA_free_heap(breqcnt(2))
      value = value.and.MA_free_heap(bqnbb(2))

      if (.not. value) call errquit('error freeing heap',0,MA_ERR)

      return
      end







*     ***********************************
*     *                                 *
*     *     C3dB_cr_pfft3_queue_filled  *
*     *                                 *
*     ***********************************

      logical function C3dB_cr_pfft3_queue_filled()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"




      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2),qnbb(2)
      integer qmax,qsize,last_index
      common / c_pfft_aqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qnbb,qmax,qsize,last_index

      C3dB_cr_pfft3_queue_filled = (qsize.ge.qmax)
      return
      end



*     ***********************************
*     *                                 *
*     *     C3dB_rc_pfft3_queue_filled  *
*     *                                 *
*     ***********************************

      logical function C3dB_rc_pfft3_queue_filled()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2),qnbb(2)
      integer qmax,qsize,last_index
      common / c_pfft_bqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qnbb,qmax,qsize,last_index

      C3dB_rc_pfft3_queue_filled = (qsize.ge.qmax)
      return
      end




*     ***********************************
*     *                                 *
*     *     C3dB_rc_pfft3f_queuein      *
*     *                                 *
*     ***********************************

      subroutine C3dB_rc_pfft3f_queuein(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2),qnbb(2)
      integer qmax,qsize,last_index
      common / c_pfft_bqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qnbb,qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,status,np

      call nwpw_timing_start(30)
      call Parallel3d_np_i(np)

      do q=1,qsize
         indx   = int_mb(qindx(1)+q-1)
         int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
         status = int_mb(qstatus(1)+indx-1)
         shift1=nfft3d(1)*(2*(indx-1))
         shift2=nfft3d(1)*(2*(indx-1)+1)
         shift3=2*np*(indx-1)
         call C3dB_pfftf_step(status,
     >                        int_mb(qnbb(1)+indx-1),
     >                        A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
      end do

      qsize = qsize + 1
      last_index = last_index+1
      if (last_index.gt.qmax) last_index = 1
      int_mb(qindx(1)+qsize-1)        = last_index
      int_mb(qstatus(1)+last_index-1) = 1
      status = 1
      int_mb(qnbb(1)+last_index-1) = nbb
      shift1=nfft3d(1)*(2*(last_index-1))
      shift2=nfft3d(1)*(2*(last_index-1)+1)
      shift3=2*np*(last_index-1)

      call C3dB_pfftf_step(status,nbb,A,
     >                     dcpl_mb(tmp(1)+shift1),
     >                     dcpl_mb(tmp(1)+shift2),
     >                     int_mb(request(1)+shift3),
     >                     int_mb(reqcnt(1)+last_index-1))


      call nwpw_timing_end(30)
      return
      end




*     ***********************************
*     *                                 *
*     *     C3dB_rc_pfft3f_queueout     *
*     *                                 *
*     ***********************************

      subroutine C3dB_rc_pfft3f_queueout(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2),qnbb(2)
      integer qmax,qsize,last_index
      common / c_pfft_bqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qnbb,qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,indx1,status,np

      call nwpw_timing_start(30)
      call Parallel3d_np_i(np)

      indx1   = int_mb(qindx(1))
      do while (int_mb(qstatus(1)+indx1-1).lt.4)
         do q=1,qsize
            indx   = int_mb(qindx(1)+q-1)
            int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
            status = int_mb(qstatus(1)+indx-1)
            shift1=nfft3d(1)*(2*(indx-1))
            shift2=nfft3d(1)*(2*(indx-1)+1)
            shift3=2*np*(indx-1)
            call C3dB_pfftf_step(status,
     >                        int_mb(qnbb(1)+indx-1),
     >                        A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
         end do
      end do

      qsize = qsize -1
      do q=1,qsize
        int_mb(qindx(1)+q-1) = int_mb(qindx(1)+q)
      end do

      shift2=nfft3d(1)*(2*(indx1-1)+1)
      call Cram_c_Copy(nbb,dcpl_mb(tmp(1)+shift2),A)

      call nwpw_timing_end(30)
      return
      end





*     ***********************************
*     *                                 *
*     *     C3dB_cr_pfft3b_queuein      *
*     *                                 *
*     ***********************************

      subroutine C3dB_cr_pfft3b_queuein(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2),qnbb(2)
      integer qmax,qsize,last_index
      common / c_pfft_aqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qnbb,qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,status,np

      call nwpw_timing_start(30)
      call Parallel3d_np_i(np)

      do q=1,qsize
         indx   = int_mb(qindx(1)+q-1)
         int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
         status = int_mb(qstatus(1)+indx-1)
         shift1=nfft3d(1)*(2*(indx-1))
         shift2=nfft3d(1)*(2*(indx-1)+1)
         shift3=2*np*(indx-1)
         call C3dB_pfftb_step(status,
     >                        int_mb(qnbb(1)+indx-1),
     >                        A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
      end do

      qsize = qsize + 1
      last_index = last_index+1
      if (last_index.gt.qmax) last_index = 1
      int_mb(qindx(1)+qsize-1)        = last_index
      int_mb(qstatus(1)+last_index-1) = 1
      status = 1
      int_mb(qnbb(1)+last_index-1) = nbb
      shift1=nfft3d(1)*(2*(last_index-1))
      shift2=nfft3d(1)*(2*(last_index-1)+1)
      shift3=2*np*(last_index-1)

      call C3dB_pfftb_step(status,nbb,A,
     >                     dcpl_mb(tmp(1)+shift1),
     >                     dcpl_mb(tmp(1)+shift2),
     >                     int_mb(request(1)+shift3),
     >                     int_mb(reqcnt(1)+last_index-1))

      call nwpw_timing_end(30)
      return
      end




*     ***********************************
*     *                                 *
*     *     C3dB_cr_pfft3b_queueout     *
*     *                                 *
*     ***********************************

      subroutine C3dB_cr_pfft3b_queueout(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "C3dB.fh"
#include "C3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2),qnbb(2)
      integer qmax,qsize,last_index
      common / c_pfft_aqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qnbb,qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,indx1,status,np

      call Parallel3d_np_i(np)

      call nwpw_timing_start(30)

      indx1   = int_mb(qindx(1))
      do while (int_mb(qstatus(1)+indx1-1).lt.5)
         do q=1,qsize
            indx   = int_mb(qindx(1)+q-1)
            int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
            status = int_mb(qstatus(1)+indx-1)
            shift1=nfft3d(1)*(2*(indx-1))
            shift2=nfft3d(1)*(2*(indx-1)+1)
            shift3=2*np*(indx-1)
            call C3dB_pfftb_step(status,
     >                        int_mb(qnbb(1)+indx-1),
     >                        A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
         end do
      end do

      qsize = qsize -1
      do q=1,qsize
        int_mb(qindx(1)+q-1) = int_mb(qindx(1)+q)
      end do

      shift1=nfft3d(1)*(2*(indx1-1))
      call dcopy(2*nfft3d(1),dcpl_mb(tmp(1)+shift1),1,A,1)

      call nwpw_timing_end(30)
      return
      end

*
*     $Id: nwpw_diis.F 19707 2010-10-29 17:59:36Z d3y133 $                       
*

*     *****************************************
*     *                                       *
*     *              nwpw_diis_init           *
*     *                                       *
*     *****************************************

      subroutine nwpw_diis_init(max_m0,nsize0,rho_in)
      implicit none
      integer max_m0,nsize0
      real*8 rho_in(*)

#include "mafdecls.fh"
#include "nwpw_diis_common.fh"

*     **** local variables ****
      integer i

      max_m = max_m0
      nsize = nsize0

      call nwpw_list_start(1,2*max_m,nsize)
      call nwpw_diis_reset(rho_in)

      return
      end


*     *****************************************
*     *                                       *
*     *              nwpw_diis_reset          *
*     *                                       *
*     *****************************************

      subroutine nwpw_diis_reset(rho_in)
      implicit none
      real*8 rho_in(*)

#include "mafdecls.fh"
#include "nwpw_diis_common.fh"

*     **** local variables ****
      integer i

      call dcopy(max_list*max_list,0.0d0,0,B,1)
      call dcopy(max_list,0.0d0,0,d,1)
      do i=2,max_list
        B(i,1) = 1.0d0
        B(1,i) = 1.0d0
      end do
      d(1) = 1.0d0

      m = 1
      call nwpw_list_store(1,2*m,rho_in)
      return
      end




*     *****************************************
*     *                                       *
*     *              nwpw_diis                *
*     *                                       *
*     *****************************************

      subroutine nwpw_diis(rho_in,v_in,v_out,diis_error)
      implicit none
      real*8 rho_in(*)
      real*8 v_in(*)
      real*8 v_out(*)
      real*8 diis_error


#include "mafdecls.fh"
#include "nwpw_diis_common.fh"

*     **** local variables ****
      integer i,j,iwork(max_list)
      real*8 sum, scal,ferr,berr,rcond
      real*8 AP(max_list*(max_list+1)/2)
      real*8 AFP(max_list*(max_list+1)/2)
      real*8 work(3*max_list)
      real*8 A2(max_list,max_list),eig(max_list)
      integer rr_ptr,gg_ptr,ipiv(max_list),info
      integer rr1,rr2,rr3

*     **** external functions ****
      real*8   ddot
      external ddot


*     **** rho(2*m) = rho_in - rho(2*m) ****
      call nwpw_list_ptr(1,2*m,rr_ptr)
      call daxpy(nsize,(-1.0d0),rho_in,1,dbl_mb(rr_ptr),1)
      call dscal(nsize,(-1.0d0),dbl_mb(rr_ptr),1)


*     **** store v_in in rho(2*m-1) ***
      call nwpw_list_store(1,2*m-1,v_in)

*     **** update B matrix ****
      sum = ddot(nsize,dbl_mb(rr_ptr),1,dbl_mb(rr_ptr),1)
      call D3dB_SumAll(sum)

      B(m+1,m+1) = sum
      diis_error = sum

      do i=1,m-1
         call nwpw_list_ptr(1,2*i,gg_ptr)
         sum = ddot(nsize,dbl_mb(gg_ptr),1,dbl_mb(rr_ptr),1)
         call D3dB_SumAll(sum)
         B(i+1,m+1) = sum
         B(m+1,i+1) = sum
      end do

c     !*** swap vectors and residuals ***
c     if ((B(m+1,m+1).gt.B(m,m)).and.
c    >   (B(m,m)     .gt.0.0d0)) then
c        call nwpw_diis_swap(m,m-1)
c     end if


c DEBUG
c     !*** look at eigenvalues of B*B ***
c     call dcopy(max_list*max_list,0.0d0,1,A2,1)
c     call dcopy(max_list*max_list,0.0d0,1,A,1)
c     do j=1,m
c     do i=1,m
c       A(i,j) = B(i+1,j+1)
c     end do
c     end do
c     call DMMUL(max_list,m,A,A,A2)
c     call eigen_unsort(max_list,m,A2,eig,A,info)
c     write(*,*)
c     write(*,*)
c     do i=1,m
c       write(*,*) "   eigenvalue:",i,eig(i)
c     end do
c     write(*,*)
c     write(*,*)
c
c     !*** swap vectors and residuals using Bubble Sort ***
c     do i=m,2,-1
c     do j=i-1,1,-1
c     if (eig(j).gt.eig(i)) then
c        call nwpw_diis_swap(i,j)
c        sum    = eig(i)
c        eig(i) = eig(j)
c        eig(j) = sum
c     end if
c     end do
c     end do
c     write(*,*)
c     write(*,*)
c     do i=1,m
c       write(*,*) "  seigenvalue:",i,eig(i)
c     end do
c     write(*,*)
c     write(*,*)
c     
c     !*** remove small vectors ****
c     j = m-2 
c     do i=1,j
c       if ((eig(i)/eig(m)).lt.1.0d-8) then
c        call nwpw_diis_shift()
c        m = m-1
c       end if
c     end do
c DEBUG



*     **** solve Bc = d ****
 20   continue
      call dcopy(max_list,d,1,c,1)

      !call dcopy(max_list*max_list,B,1,A,1)
      !call dgesv(m+1,1,A,max_list,ipiv,c,max_list,info)
      do j=1,m+1
      do i=1,j
        AP(i+(j-1)*j/2) = B(i,j)
      end do
      end do
      call dspsvx( 'N', 'U', m+1, 1, AP, AFP,
     >             ipiv, d,  m+1, c, m+1,
     >             rcond, ferr, berr, 
     >             work,iwork,
     >             info)

*     **** check for linear dependency ****
c     sum = 0.0d0
c     do i=2,m+1
c        sum = sum+dabs(c(i))
c     end do
c     write(*,*) "DEBUG: sum=",sum,"  count=",(m+1),
c    >           "   info=",info,"   rcond=",rcond

      !if (sum.gt.1.2d0) then
      !   call nwpw_diis_gram_schmidt() !*** this routine does not work ***
      !   go to 20
      !end if

      if ((info.ne.0).or.(rcond.lt.1.0d-10)) then
         call nwpw_diis_shift()
         m = m-1
         go to 20
      end if


*     **** s = sum(i) c(i) * gg(i) ****
      call dcopy(nsize,0.0d0,0,v_out,1)
      call daxpy(nsize,c(m+1),v_in,1,v_out,1)

      sum = c(m+1)
      do i=1,m-1
         sum = sum + c(i+1)
         !write(*,*) i+1,c(i+1),sum
         call nwpw_list_ptr(1,2*i-1, gg_ptr)
         call daxpy(nsize,c(i+1),dbl_mb(gg_ptr),1,v_out,1)
      end do

*     **** shift B and diis list ****
      if (m.lt.max_m) then
         m = m+1
      else
         call nwpw_diis_shift()
      end if
      call nwpw_list_store(1,2*m,rho_in)
     
      return 
      end

*     *****************************************
*     *                                       *
*     *           nwpw_diis_shift             *
*     *                                       *
*     *****************************************

      subroutine nwpw_diis_shift()
      implicit none

#include "mafdecls.fh"
#include "nwpw_diis_common.fh"

*     **** local variables ****
      integer i,j

      call nwpw_list_shift(1)
      call nwpw_list_shift(1)
      do j=2,m
      do i=2,m
        B(i,j) = B(i+1,j+1)
      end do
      end do

      return
      end

*     *****************************************
*     *                                       *
*     *           nwpw_diis_remove            *
*     *                                       *
*     *****************************************

      subroutine nwpw_diis_remove(k)
      implicit none
      integer k

#include "mafdecls.fh"
#include "nwpw_diis_common.fh"

*     **** local variables ****
      integer i,j

      !*** remove k residual and density ***
      call nwpw_list_remove(1,2*k)
      call nwpw_list_remove(1,2*k-1)

      !**** remove k row ****
      do i=k,m
      do j=2,m+1
        B(i,j) = B(i+1,j)
      end do
      end do

      !**** remove k column  ****
      do j=k,m
      do i=2,m
        B(i,j) = B(i,j+1)
      end do
      end do

      m = m-1

      return
      end

*     *****************************************
*     *                                       *
*     *           nwpw_diis_swap              *
*     *                                       *
*     *****************************************

      subroutine nwpw_diis_swap(k,l)
      implicit none
      integer k,l

#include "mafdecls.fh"
#include "nwpw_diis_common.fh"

*     **** local variables ****
      integer i,j
      real*8  tmp

      !*** swap  k and l residual and density ***
      call nwpw_list_swap(1,2*k,  2*l)
      call nwpw_list_swap(1,2*k-1,2*l-1)


      !**** swap k and l rows ****
      do j=2,m+1
        tmp      = B(l+1,j)
        B(l+1,j) = B(k+1,j)
        B(k+1,j) = tmp
      end do

      !**** swap k and l columns ****
      do i=2,m+1
        tmp      = B(i,l+1)
        B(i,l+1) = B(i,k+1)
        B(i,k+1) = tmp
      end do


      return
      end


*     *****************************************
*     *                                       *
*     *           nwpw_diis_gram_schmidt      *
*     *                                       *
*     *****************************************

      subroutine nwpw_diis_gram_schmidt()
      implicit none
      
#include "mafdecls.fh"
#include "nwpw_diis_common.fh"

*     **** local variables ****
      integer i,j,n
      integer ri_ptr,rj_ptr,vi_ptr,vj_ptr
      real*8  sum,sum1

*     **** external functions ****
      real*8   ddot
      external ddot

      !**** Gram-Schmidt ****
      do i=m,2,-1
        call nwpw_list_ptr(1,2*i,  ri_ptr)
        call nwpw_list_ptr(1,2*i-1,vi_ptr)
        do j= i-1, 1,-1
          call nwpw_list_ptr(1,2*j,  rj_ptr)
          call nwpw_list_ptr(1,2*j-1,vj_ptr)
          sum  = ddot(nsize,dbl_mb(rj_ptr),1,dbl_mb(ri_ptr),1)
          sum1 = ddot(nsize,dbl_mb(rj_ptr),1,dbl_mb(rj_ptr),1)
          call D3dB_SumAll(sum)
          call D3dB_SumAll(sum1)
          call daxpy(nsize,(-sum/sum1),
     >              dbl_mb(rj_ptr),1,
     >              dbl_mb(ri_ptr),1)
          call daxpy(nsize,(-sum/sum1),
     >              dbl_mb(vj_ptr),1,
     >              dbl_mb(vi_ptr),1)

        end do
      end do

      !*** remove small residuals ***
      n = m
      do i=n-1,1,-1
        call nwpw_list_ptr(1,2*i,  ri_ptr)
        sum1 = ddot(nsize,dbl_mb(ri_ptr),1,dbl_mb(ri_ptr),1)
        call D3dB_SumAll(sum1)
        write(*,*) "sum1:",i,sum1
        if (sum1.lt.1.0d-3) then
           call nwpw_list_remove(1,2*i)
           call nwpw_list_remove(1,2*i-1)
           m = m - 1
        end if
      end do

      !*** regenerate B ***
      do j=1,m
         call nwpw_list_ptr(1,2*j,rj_ptr)
         do i=j,m
           call nwpw_list_ptr(1,2*i,ri_ptr)
           sum = ddot(nsize,dbl_mb(ri_ptr),1,dbl_mb(rj_ptr),1)
           call D3dB_SumAll(sum)
           B(i+1,j+1) = sum
           B(j+1,i+1) = sum
         end do
      end do

      return
      end 

*
* $Id: fci_intchk.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_intchk(h, g)
      implicit none
#include "fciinfo.fh"
      double precision h(nacttr) ! [input/output]
      double precision g(nacttr,nacttr) ! [input/output]
c
c     Ensure that the integrals have the correct symmetry
c     and force small integrals that should be zero to a hard zero.
c
c     This is just an interim routine until we have full symmetry packing
c
      integer i, j, k, l, ij, kl, symij, symkl
#include "bitops.fh"
c
      do i = 1, nactiv
         do j = 1, i
            ij = iky(i)+j
            symij = ieor(orbsym(i),orbsym(j))
            if (symij .ne. 0) then
               if (abs(h(ij)) .gt. 1d-6) then 
                  write(6,*) ' h ', i, j, h(ij)
                  call fci_err('fci_intchk:should be zero',ij)
               endif
               h(ij) = 0.0d0
            endif
            do k = 1, nactiv
               do l = 1, k
                  kl = iky(k)+l
                  symkl = ieor(orbsym(k),orbsym(l))
                  if (ieor(symij,symkl).ne.0) then
                     if (abs(g(ij,kl)) .gt. 1d-6) then 
                        write(6,*) ' g ', i, j, k, l, g(ij,kl)
                        call fci_err('fci_intchk:should be zero',0)
                     endif
                     g(ij,kl) = 0.0d0
                  endif
               enddo
            enddo
         enddo
      enddo
c
c     While we are it it check the ij -- kl symmetry
c
      do ij = 1, (nactiv*(nactiv+1))/2
         do kl = 1, ij-1
            if (abs(g(ij,kl)-g(kl,ij)) .gt. 1d-10) 
     $           call fci_err('fci_intchk: g is not symmetric',0)
            g(ij,kl) = 0.5d0*(g(ij,kl)+g(kl,ij))
            g(kl,ij) = g(ij,kl)
         enddo
      enddo
c
      end

      subroutine tce_ao2e_cholesky_2d(rtdb,              ! input
     &                               d_ao2e)            ! output (first full AO matrix, then replaced by full Cholesky factor)
c
c $Id: tce_ao2e_cholesky_2d.F 20285 2011-05-05 19:26:13Z d3p852 $
c
c     Returns a SF handle for the AO 2-e integral matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sf.fh"
#include "errquit.fh"
c#include "tce.fh"
#include "tce_main.fh"
      integer rtdb                    ! Run-time database
      logical nodezero                ! True if node zero
      integer d_ao2e                  ! AO integral GA handle
      integer work1,work2             ! Work array sizes
      integer l_work1,k_work1         ! Work array 1
      integer l_work2,k_work2         ! Work array 2
      integer l_ijkl,k_ijkl           ! AO integral patch
      integer ish,jsh,ksh,lsh         ! Integral shell indices
      integer i,j,k,l,kl              ! Integral indices
      integer ikjl_offset,ijkl_offset ! 
      integer ilo,ihi,jlo,jhi         ! Integral shell index range
      integer klo,khi,llo,lhi         ! Integral shell index range
      integer irange,jrange           ! Integral shell index range size
      integer krange,lrange           ! Integral shell index range size
      integer kloff,joff,loff         ! Offset temporaries
      integer nxtval
      external nxtval
      integer next,count,nprocs
c      character*255 filename
c
c     New variables: formerly from tce_main.fh, now defined locally.
c     This is not the multigrid code so I can use the global variables - if I want.
c
c      integer geom                          ! determined in this subroutine
c      character*255 basis_name              ! determined in this subroutine
c      integer ao_bas_han                  ! determined in this subroutine
c      integer nbf                           ! determined in this subroutine
c      integer nshells                       ! determined in this subroutine
c      double precision tol2e
c      logical int_normalize
c      external int_normalize
c
c     New variables for the Cholesky code
c
      integer size_aoints
      integer rank_aoints
      integer ijkl_patch_size
      integer ikjl_patch_size
      integer ij_sh_offset_lo,ij_sh_offset_hi
      integer kl_sh_offset_lo,kl_sh_offset_hi
c
c     =========
c     Basis set
c     =========
c
c#ifdef DEBUG_PRINT
c      print*,'initialize basis set'
c#endif
c      basis_name = 'ao basis'
c      if (.not.bas_create(ao_bas_han,basis_name))
c     1  call errquit('tce_ao2e_cholesky_2d: bas_create failed',
c     2               0,BASIS_ERR)
c      if (.not.bas_rtdb_load(rtdb,geom,ao_bas_han,basis_name))
c     1  call errquit('tce_ao2e_cholesky_2d: basis not found',
c     2               0,BASIS_ERR)
c      if (.not.int_normalize(rtdb,ao_bas_han))
c     1  call errquit('tce_ao2e_cholesky_2d: int_normalize failed',
c     2               0,INT_ERR)
c      if (.not.bas_numbf(ao_bas_han,nbf))
c     1  call errquit('tce_ao2e_cholesky_2d: failed to read nbf',
c     2               0,BASIS_ERR)
c      if (.not.bas_numcont(ao_bas_han,nshells))
c     1  call errquit('tce_ao2e_cholesky_2d: failed to read nshells',
c     2               0,BASIS_ERR)
c
c     ===========
c     Allocate GA
c     ===========
c
      nodezero=(ga_nodeid().eq.0)

#ifdef DEBUG_PRINT
      print*,'starting GA allocation'
#endif
c      if (.not.(ioalg.eq.2)) then ! ioalg not accessible variable right now
c        call errquit('tce_ao2e_cholesky_2d: you must use ioalg=2 (GA);
c     1                your chosen ioalg is',ioalg,GA_ERR)
c      endif
      rank_aoints = nbf*nbf
      size_aoints = rank_aoints*rank_aoints
      if (nodezero.and.util_print('ao2e',print_default)) then
        write(LuOut,*)
        write(LuOut,9000) rank_aoints
        write(LuOut,9001) size_aoints
      endif
 9000 format(1x,'rank of AO integral matrix = ',i8)
 9001 format(1x,'size of AO integral matrix = ',i8)
      if (.not.ga_create(mt_dbl,rank_aoints,rank_aoints,'ao2e',-1,-1,
     1  d_ao2e)) then
        write(LuOut,*) ' available GA memory ',
     1    ga_memory_avail(),' bytes' 
        call errquit('tce_ao2e_cholesky_2d: ga_create failed; 
     1                filesize in MB is',size_aoints,GA_ERR)
      endif
c
c     =======================
c     Initialize integral API
c     =======================
c
c#ifdef DEBUG_PRINT
c      print*,'initialize integral API'
c#endif
      call int_mem_2e4c(work1,work2)
      if (.not.ma_push_get(mt_dbl,work1,'work1',l_work1,k_work1))
     1  call errquit('tce_ao2e_cholesky_2d: MA problem work1',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,work2,'work2',l_work2,k_work2))
     1  call errquit('tce_ao2e_cholesky_2d: MA problem work2',1,MA_ERR)
c
c     ================
c     Loop over shells
c     ================
c
#ifdef DEBUG_PRINT
      print*,'begin loop over shells'
#endif
      nprocs = ga_nnodes()
      count = 0
      next = nxtval(nprocs)
c
c     BEGIN KL LOOPS
c
#ifdef DEBUG_PRINT
      print*,'nshells = ',nshells
      do ish=1,nshells
        if (.not.bas_cn2bfr(ao_bas_han,ish,ilo,ihi))
     1    call errquit('tce_ao2e_cholesky_2d: basis fn range problem i',
     2                 ish,BASIS_ERR)
          irange = ihi - ilo + 1
          write(LuOut,9900) 'i',ish,ilo,ihi,irange
      enddo
c      call errquit('manual stop',0,CALC_ERR)
#endif
c
      do lsh=1,nshells
        do ksh=1,nshells
          if (next.eq.count) then
            if (util_print('ao2e',print_debug))
     1        write(LuOut,9190) ksh,lsh,ga_nodeid()
c
            if (.not.bas_cn2bfr(ao_bas_han,ksh,klo,khi))
     1        call errquit('tce_ao2e_cholesky_2d: 
     2        basis fn range problem K',ksh,BASIS_ERR)
            krange = khi - klo + 1
c
            if (.not.bas_cn2bfr(ao_bas_han,lsh,llo,lhi))
     1        call errquit('tce_ao2e_cholesky_2d: 
     2        basis fn range problem L',lsh,BASIS_ERR)
            lrange = lhi - llo + 1
c
            ijkl_patch_size = rank_aoints*krange*lrange
            if (.not.ma_push_get(mt_dbl,ijkl_patch_size,'ao2e',
     1        l_ijkl,k_ijkl)) call errquit('tce_ao2e_cholesky_2d: 
     2        MA problem k_ijkl',ijkl_patch_size,MA_ERR)
c
            do ijkl_offset = 1,ijkl_patch_size
              dbl_mb(k_ijkl+ijkl_offset-1) = 0.0d0
            enddo
c
c           BEGIN IJ LOOPS
c
            do jsh=1,nshells
              do ish=1,nshells
                tol2e = 0.0d0 ! no screening right now
                if (schwarz_shell(ish,ksh)*schwarz_shell(jsh,lsh) 
     1            .ge. tol2e) then
c
                  if (util_print('ao2e',print_debug))
     1              write(LuOut,9191) ish,jsh,ga_nodeid()
c
                  if (.not.bas_cn2bfr(ao_bas_han,ish,ilo,ihi))
     1              call errquit('tce_ao2e_cholesky_2d: 
     2              basis fn range problem I',ish,BASIS_ERR)
                  irange = ihi - ilo + 1
c
                  if (.not.bas_cn2bfr(ao_bas_han,jsh,jlo,jhi))
     1              call errquit('tce_ao2e_cholesky_2d: 
     2              basis fn range problem J',jsh,BASIS_ERR)
                  jrange = jhi - jlo + 1
c
c                 dbl_mb(k_work1) = eri
c                 eri = <bra_g(ish).bra_g(jsh) | ket_g(ksh).ket_g(lsh)>
c
c#ifdef DEBUG_PRINT
c                  print*,'calling int_2e4c'
c#endif
                  call int_2e4c(ao_bas_han,ish,ksh,ao_bas_han,jsh,
     1              lsh,work2,dbl_mb(k_work2),work1,dbl_mb(k_work1))
c
c =============== BEGIN INNER LOOPS ==============
c
c This should be replaced by a tce_sort-like routine.
c
c#ifdef DEBUG_PRINT
c                  print*,'start transpose'
c#endif
                  kl = 0
                  do l = llo,lhi
                    do k = klo,khi
                      kl = kl + 1
                      kloff = (kl-1)*rank_aoints
                      do j = jlo,jhi
                        joff = (j-1)*nbf
                        do i = ilo,ihi
                          ikjl_offset = (
     1                                   (
     2                                    (i-ilo)*krange+(k-klo)
     3                                   )*jrange+(j-jlo)
     4                                  )*lrange+(l-llo)
                          dbl_mb(k_ijkl+kloff+joff+i-1) = 
     1                      dbl_mb(k_work1+ikjl_offset)
                        enddo              ! i
                      enddo                ! j
                    enddo                  ! k
                  enddo                    ! l
c#ifdef DEBUG_PRINT
c                  print*,'end transpose'
c#endif
c
c =============== END INNER LOOPS ==============
c
                endif                      ! schwarz_shell
c
c             Put local stuff into GA
c
              ij_sh_offset_lo = 0
              ij_sh_offset_hi = 0
              kl_sh_offset_lo = 0
              kl_sh_offset_hi = 0
              ijkl_patch_size = 0
#ifdef DEBUG_PRINT
                  write(LuOut,9900) 'i',ish,ilo,ihi,irange
                  write(LuOut,9900) 'j',jsh,jlo,jhi,jrange
                  write(LuOut,9900) 'k',ksh,klo,khi,krange
                  write(LuOut,9900) 'l',lsh,llo,lhi,lrange
c                  print*,'call ga_put'
#endif
c              call ga_put(d_ao2e, ij_sh_offset_lo, ij_sh_offset_hi, 
c     1                    kl_sh_offset_lo, kl_sh_offset_hi, 
c     2                    dbl_mb(k_ijkl), ijkl_patch_size)
              enddo                        ! ish
            enddo                          ! jsh
c
c           END IJ LOOPS
c
            if (.not.ma_pop_stack(l_ijkl)) 
     1        call errquit('tce_ao2e_cholesky_2d: 
     2                     ma_pop_stack of l_ijkl failed',16,MA_ERR)
            next = nxtval(nprocs)
          endif
          count = count + 1
        enddo                              ! ksh
      enddo                                ! lsh
c
c     END KL LOOPS
c
      next = nxtval(-nprocs)
      call ga_sync() ! only necessary in parallel but that variable not available right now
c
c     ==========
c     Deallocate
c     ==========
c
      if (.not.ma_pop_stack(l_work2)) 
     1  call errquit('tce_ao2e: MA problem',14,MA_ERR)
      if (.not.ma_pop_stack(l_work1)) 
     1  call errquit('tce_ao2e: MA problem',15,MA_ERR)
c
c     ======
c     Return
c     ======
c
 8000 format(1x,'cpu & wall time in seconds for ',A,2f20.1)
 9190 format(/,'k- and l-shells',2i3,' have been assigned to node ',i3)
 9191 format(/,'i- and j-shells',2i3,' have been assigned to node ',i3)
 9200 format(/,'k and l',2i3)
 9900 format(a1,'-shell number ',i3,': lo = ',i3,' hi = ',i3,
     &                                             ' range = ',i3)
      return
      end

#define NBLOCKS 2

*
* $Id: c_trans.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************
*     *					*
*     *	   C3dB_c_transpose_ijk_init	*
*     *					*
*     ***********************************

      subroutine C3dB_c_transpose_ijk_init(nb)
      implicit none
      integer nb

#include "mafdecls.fh"
#include "errquit.fh"
#include "C3dB.fh"


*     *** hilbert tranpose data structure ****
      integer h_iq_to_i1(2,6,NBLOCKS)
      integer h_iq_to_i2(2,6,NBLOCKS)
      integer h_i1_start(2,6,NBLOCKS)
      integer h_i2_start(2,6,NBLOCKS)
      common / c_trans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_i1_start,
     >                         h_i2_start

*     **** local variables ****
      logical value
      integer proc_to,proc_from
      integer pto,qto,np,taskid
      integer phere,qhere
      integer index1,index2,itmp
      integer i,j,k,it


      call Parallel3d_taskid_i(taskid)
      call Parallel3d_np_i(np)


*     ********************************************************
*     **** map1to2 mapping - done - tranpose operation #1 ****
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nx(nb)*nq1(nb)),
     >                     'h_iq_to_i1_1',
     >                      h_iq_to_i1(2,1,nb),
     >                      h_iq_to_i1(1,1,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(nb)*nq2(nb)),
     >                     'h_iq_to_i2_1',
     >                      h_iq_to_i2(2,1,nb),
     >                      h_iq_to_i2(1,1,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_1',
     >                      h_i1_start(2,1,nb),
     >                      h_i1_start(1,1,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_1',
     >                      h_i2_start(2,1,nb),
     >                      h_i2_start(1,1,nb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_initt:out of heap',0,MA_ERR)

      index1 = 1 
      index2 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,1,nb)+it) = index1
         int_mb(h_i2_start(1,1,nb)+it) = index2

         do k=1,nz(nb)
         do j=1,ny(nb)
         do i=1,nx(nb)

*           **** packing scheme **** 
            phere = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            qhere = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))

            pto   = int_mb(p_map2(1,nb)+(k-1)+(i-1)*nz(nb))
            qto   = int_mb(q_map2(1,nb)+(k-1)+(i-1)*nz(nb))
            
           
            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = i + (qhere-1)*nx(nb)
               int_mb(h_iq_to_i1(1,1,nb)+itmp-1) = index1
               index1 = index1 + 1
            end if
             
*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = j + (qto-1)*ny(nb)
               int_mb(h_iq_to_i2(1,1,nb)+itmp-1) = index2
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,1,nb)+np) = index1
      int_mb(h_i2_start(1,1,nb)+np) = index2





*     *********************************************************
*     **** map2to3 mapping - done - transpose operation #2 ****
*     *********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(ny(nb)*nq2(nb)),
     >                     'h_iq_to_i1_2',
     >                      h_iq_to_i1(2,2,nb),
     >                      h_iq_to_i1(1,2,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(nb)*nq3(nb)),
     >                     'h_iq_to_i2_2',
     >                      h_iq_to_i2(2,2,nb),
     >                      h_iq_to_i2(1,2,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_2',
     >                      h_i1_start(2,2,nb),
     >                      h_i1_start(1,2,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_2',
     >                      h_i2_start(2,2,nb),
     >                      h_i2_start(1,2,nb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,2,nb)+it) = index1
         int_mb(h_i2_start(1,2,nb)+it) = index2

         do k=1,nz(nb)
         do j=1,ny(nb)
         do i=1,nx(nb)

*           **** packing scheme ****
            phere = int_mb(p_map2(1,nb)+(k-1)+(i-1)*nz(nb))
            qhere = int_mb(q_map2(1,nb)+(k-1)+(i-1)*nz(nb))

            pto   = int_mb(p_map3(1,nb)+(i-1)+(j-1)*nx(nb))
            qto   = int_mb(q_map3(1,nb)+(i-1)+(j-1)*nx(nb))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = j + (qhere-1)*ny(nb)
               int_mb(h_iq_to_i1(1,2,nb)+itmp-1) = index1
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = k + (qto-1)*nz(nb)
               int_mb(h_iq_to_i2(1,2,nb)+itmp-1) = index2
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,2,nb)+np) = index1
      int_mb(h_i2_start(1,2,nb)+np) = index2






*     ********************************************************
*     **** map3to2 mapping - done - tranpose operation #3 ****
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nz(nb)*nq3(nb)),
     >                     'h_iq_to_i1_3',
     >                      h_iq_to_i1(2,3,nb),
     >                      h_iq_to_i1(1,3,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(nb)*nq2(nb)),
     >                     'h_iq_to_i2_3',
     >                      h_iq_to_i2(2,3,nb),
     >                      h_iq_to_i2(1,3,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_3',
     >                      h_i1_start(2,3,nb),
     >                      h_i1_start(1,3,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_3',
     >                      h_i2_start(2,3,nb),
     >                      h_i2_start(1,3,nb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,3,nb)+it) = index1
         int_mb(h_i2_start(1,3,nb)+it) = index2

         do k=1,nz(nb)
         do j=1,ny(nb)
         do i=1,nx(nb)

*           **** packing scheme ****
            phere = int_mb(p_map3(1,nb)+(i-1)+(j-1)*nx(nb))
            qhere = int_mb(q_map3(1,nb)+(i-1)+(j-1)*nx(nb))

            pto   = int_mb(p_map2(1,nb)+(k-1)+(i-1)*nz(nb))
            qto   = int_mb(q_map2(1,nb)+(k-1)+(i-1)*nz(nb))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = k + (qhere-1)*nz(nb)
               int_mb(h_iq_to_i1(1,3,nb)+itmp-1) = index1
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = j + (qto-1)*ny(nb)
               int_mb(h_iq_to_i2(1,3,nb)+itmp-1) = index2
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,3,nb)+np) = index1
      int_mb(h_i2_start(1,3,nb)+np) = index2




*     ********************************************************
*     **** map2to1 mapping - done - tranpose operation #4 ****
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(ny(nb)*nq2(nb)),
     >                     'h_iq_to_i1_4',
     >                      h_iq_to_i1(2,4,nb),
     >                      h_iq_to_i1(1,4,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nx(nb)*nq1(nb)),
     >                     'h_iq_to_i2_4',
     >                      h_iq_to_i2(2,4,nb),
     >                      h_iq_to_i2(1,4,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_4',
     >                      h_i1_start(2,4,nb),
     >                      h_i1_start(1,4,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_4',
     >                      h_i2_start(2,4,nb),
     >                      h_i2_start(1,4,nb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,4,nb)+it) = index1
         int_mb(h_i2_start(1,4,nb)+it) = index2

         do k=1,nz(nb)
         do j=1,ny(nb)
         do i=1,nx(nb)

*           **** packing scheme ****
            phere = int_mb(p_map2(1,nb)+(k-1)+(i-1)*nz(nb))
            qhere = int_mb(q_map2(1,nb)+(k-1)+(i-1)*nz(nb))

            pto   = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            qto   = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = j + (qhere-1)*ny(nb)
               int_mb(h_iq_to_i1(1,4,nb)+itmp-1) = index1
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = i + (qto-1)*nx(nb)
               int_mb(h_iq_to_i2(1,4,nb)+itmp-1) = index2
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,4,nb)+np) = index1
      int_mb(h_i2_start(1,4,nb)+np) = index2





*     **********************************************************
*     **** map1to3 mapping  - done - tranpose operation # 5 ****
*     **********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nx(nb)*nq1(nb)),
     >                     'h_iq_to_i1_5',
     >                      h_iq_to_i1(2,5,nb),
     >                      h_iq_to_i1(1,5,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(nb)*nq3(nb)),
     >                     'h_iq_to_i2_5',
     >                      h_iq_to_i2(2,5,nb),
     >                      h_iq_to_i2(1,5,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_5',
     >                      h_i1_start(2,5,nb),
     >                      h_i1_start(1,5,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_5',
     >                      h_i2_start(2,5,nb),
     >                      h_i2_start(1,5,nb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,5,nb)+it) = index1
         int_mb(h_i2_start(1,5,nb)+it) = index2

         do k=1,nz(nb)
         do j=1,ny(nb)
         do i=1,nx(nb)

*           **** packing scheme ****
            phere = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            qhere = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))

            pto   = int_mb(p_map3(1,nb)+(i-1)+(j-1)*nx(nb))
            qto   = int_mb(q_map3(1,nb)+(i-1)+(j-1)*nx(nb))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = i + (qhere-1)*nx(nb)
               int_mb(h_iq_to_i1(1,5,nb)+itmp-1) = index1
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = k + (qto-1)*nz(nb)
               int_mb(h_iq_to_i2(1,5,nb)+itmp-1) = index2
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,5,nb)+np) = index1
      int_mb(h_i2_start(1,5,nb)+np) = index2






*     *************************
*     **** map3to1 mapping ****
*     *************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nz(nb)*nq3(nb)),
     >                     'h_iq_to_i1_6',
     >                      h_iq_to_i1(2,6,nb),
     >                      h_iq_to_i1(1,6,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nx(nb)*nq1(nb)),
     >                     'h_iq_to_i2_6',
     >                      h_iq_to_i2(2,6,nb),
     >                      h_iq_to_i2(1,6,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_6',
     >                      h_i1_start(2,6,nb),
     >                      h_i1_start(1,6,nb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_6',
     >                      h_i2_start(2,6,nb),
     >                      h_i2_start(1,6,nb))
      if (.not.value)
     > call errquit('C3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,6,nb)+it) = index1
         int_mb(h_i2_start(1,6,nb)+it) = index2

         do k=1,nz(nb)
         do j=1,ny(nb)
         do i=1,nx(nb)

*           **** packing scheme ****
            phere = int_mb(p_map3(1,nb)+(i-1)+(j-1)*nx(nb))
            qhere = int_mb(q_map3(1,nb)+(i-1)+(j-1)*nx(nb))

            pto   = int_mb(p_map1(1,nb)+(j-1)+(k-1)*ny(nb))
            qto   = int_mb(q_map1(1,nb)+(j-1)+(k-1)*ny(nb))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = k + (qhere-1)*nz(nb)
               int_mb(h_iq_to_i1(1,6,nb)+itmp-1) = index1
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = i + (qto-1)*nx(nb)
               int_mb(h_iq_to_i2(1,6,nb)+itmp-1) = index2
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,6,nb)+np) = index1
      int_mb(h_i2_start(1,6,nb)+np) = index2


      return
      end

      SUBROUTINE eomccsd_o1(d_f1,d_i0,d_t1,d_x1,d_x2,k_f1_offset,k_i0_of
     &fset,k_t1_offset,k_x1_offset,k_x2_offset)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_xf + = -1 * Sum ( h3 ) * x ( p2 h3 )_x * i1 ( h3 h1 )_f
C         i1 ( h3 h1 )_f + = 1 * f ( h3 h1 )_f
C         i1 ( h3 h1 )_ft + = 1 * Sum ( p4 ) * t ( p4 h1 )_t * f ( h3 p4 )_f
C     i0 ( p2 h1 )_xf + = 1 * Sum ( p3 ) * x ( p3 h1 )_x * f ( p2 p3 )_f
C     i0 ( p2 h1 )_xf + = 1 * Sum ( p4 h3 ) * x ( p2 p4 h1 h3 )_x * f ( h3 p4 )_f
C     i0 ( p2 h1 )_fxt + = -1 * Sum ( h3 ) * t ( p2 h3 )_t * i1 ( h3 h1 )_fx
C         i1 ( h3 h1 )_fx + = 1 * Sum ( p4 ) * x ( p4 h1 )_x * f ( h3 p4 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_x1
      INTEGER k_x1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER d_x2
      INTEGER k_x2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      CHARACTER*255 filename
      CALL OFFSET_eomccsd_o1_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('eomccsd_o1_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL eomccsd_o1_1_1(d_f1,k_f1_offset,d_i1,k_i1_offset)
      CALL eomccsd_o1_1_2(d_t1,k_t1_offset,d_f1,k_f1_offset,d_i1,k_i1_of
     &fset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL eomccsd_o1_1(d_x1,k_x1_offset,d_i1,k_i1_offset,d_i0,k_i0_offs
     &et)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('eomccsd_o1',-1,M
     &A_ERR)
      CALL eomccsd_o1_2(d_x1,k_x1_offset,d_f1,k_f1_offset,d_i0,k_i0_offs
     &et)
      CALL eomccsd_o1_3(d_x2,k_x2_offset,d_f1,k_f1_offset,d_i0,k_i0_offs
     &et)
      CALL OFFSET_eomccsd_o1_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('eomccsd_o1_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL eomccsd_o1_4_1(d_x1,k_x1_offset,d_f1,k_f1_offset,d_i1,k_i1_of
     &fset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL eomccsd_o1_4(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_offs
     &et)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('eomccsd_o1',-1,M
     &A_ERR)
      RETURN
      END
      SUBROUTINE eomccsd_o1_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_xf + = -1 * Sum ( h3 ) * x ( p2 h3 )_x * i1 ( h3 h1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p2b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER h1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &x,irrep_f)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_o1_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h3b-1)) .eq. irrep_x) TH
     &EN
      CALL TCE_RESTRICTED_2(p2b,h3b,p2b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,h1b,h3b_2,h1b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_o1_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_o1_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (p2b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_o1_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_o1_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_o1_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h1b_2
     & - 1 + noab * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_o1_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_o1_1',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_o1_1',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_o1_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_o1_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_o1_1',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_o1_1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h1 )_f + = 1 * f ( h3 h1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h1b
      INTEGER dimc
      INTEGER h3b_1
      INTEGER h1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_f) TH
     &EN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h1b-1)
      CALL TCE_RESTRICTED_2(h3b,h1b,h3b_1,h1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_o1_1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_o1_1_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + (noab+nvab) * (h3b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_o1_1_1',2,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_o1_1_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h3b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_o1_1_1',4,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_o1_1_1',5,M
     &A_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_eomccsd_o1_1_1(l_a_offset,k_a_offset,size)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER h1b
      length = 0
      DO h3b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('eomccsd_o1_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h1b - 1 + noab * (h3b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+h1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE eomccsd_o1_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h1 )_ft + = 1 * Sum ( p4 ) * t ( p4 h1 )_t * f ( h3 p4 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &f,irrep_t)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_o1_1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      IF (int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p4b,h1b,p4b_1,h1b_1)
      CALL TCE_RESTRICTED_2(h3b,p4b,h3b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_o1_1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_o1_1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p4b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_o1_1_2',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_o1_1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_o1_1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p4b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_o1_1_2',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_o1_1_2',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_o1_1_2',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_o1_1_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h1b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_o1_1_2',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_o1_1_2',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_o1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_xf + = 1 * Sum ( p3 ) * x ( p3 h1 )_x * f ( p2 p3 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &x,irrep_f)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_o1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_x) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h1b,p3b_1,h1b_1)
      CALL TCE_RESTRICTED_2(p2b,p3b,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_o1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_o1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_o1_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_o1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_o1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_o1_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_o1_2',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_o1_2',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_o1_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_o1_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_o1_2',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_o1_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_xf + = 1 * Sum ( p4 h3 ) * x ( p2 p4 h1 h3 )_x * f ( h3 p4 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER h3b
      INTEGER p2b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &x,irrep_f)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_o1_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO h3b = 1,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_x) THEN
      CALL TCE_RESTRICTED_4(p2b,p4b,h1b,h3b,p2b_1,p4b_1,h1b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,p4b,h3b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_o1_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_o1_3',2,MA_ERR)
      IF ((p4b .lt. p2b) .and. (h3b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h1b-1)
     &,4,2,3,1,1.0d0)
      END IF
      IF ((p4b .lt. p2b) .and. (h1b .le. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h1b-1),int_mb(k_range+h3b-1)
     &,3,2,4,1,-1.0d0)
      END IF
      IF ((p2b .le. p4b) .and. (h3b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h3b-1),int_mb(k_range+h1b-1)
     &,4,1,3,2,-1.0d0)
      END IF
      IF ((p2b .le. p4b) .and. (h1b .le. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h3b-1)
     &,3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_o1_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_o1_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_o1_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p4b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_o1_3',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_o1_3',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_o1_3',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_o1_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_o1_3',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_o1_3',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_o1_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_fxt + = -1 * Sum ( h3 ) * t ( p2 h3 )_t * i1 ( h3 h1 )_fx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p2b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER h1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &f,ieor(irrep_x,irrep_t))) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_o1_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h3b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p2b,h3b,p2b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,h1b,h3b_2,h1b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_o1_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_o1_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (p2b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_o1_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_o1_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_o1_4',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h1b_2
     & - 1 + noab * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_o1_4',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_o1_4',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_o1_4',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_o1_4',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_o1_4',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_o1_4',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_o1_4_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h1 )_fx + = 1 * Sum ( p4 ) * x ( p4 h1 )_x * f ( h3 p4 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &f,irrep_x)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_o1_4_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      IF (int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+h1b-1)) .eq. irrep_x) TH
     &EN
      CALL TCE_RESTRICTED_2(p4b,h1b,p4b_1,h1b_1)
      CALL TCE_RESTRICTED_2(h3b,p4b,h3b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_o1_4_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_o1_4_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p4b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_o1_4_1',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_o1_4_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_o1_4_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p4b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_o1_4_1',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_o1_4_1',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_o1_4_1',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_o1_4_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h1b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_o1_4_1',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_o1_4_1',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_eomccsd_o1_4_1(l_a_offset,k_a_offset,size)
C     $Id: eomccsd_o1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h1 )_fx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER h1b
      length = 0
      DO h3b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &f,irrep_x)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('eomccsd_o1_4_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &f,irrep_x)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h1b - 1 + noab * (h3b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+h1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END

      subroutine soints_block(basis, nbf,
     $     ishuqlo, ishuqhi, ioff, irange, 
     $     jshuqlo, jshuqhi, joff, jrange,
     $     kshuqlo, kshuqhi, koff, krange,
     $     lshuqlo, lshuqhi, loff, lrange,
     $     tol, g)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "nwc_const.fh"
#include "cbassym.fh"
      integer basis
      integer nbf
      integer ishuqlo, ishuqhi, irange(2,0:7), ioff(nbf)
      integer jshuqlo, jshuqhi, jrange(2,0:7), joff(nbf,0:7)
      integer kshuqlo, kshuqhi, krange(2,0:7), koff(nbf,0:7)
      integer lshuqlo, lshuqhi, lrange(2,0:7), loff(nbf,0:7)
      logical odirac
      double precision tol
      double precision g(*)
c
c     Assumes that int_init(), schwarz_init(), sym_abelian_init(),
c     have all been called and that soints_block_info() was used
c     to generate the addressing arrays *off() and *range().
c
c     For SOs arising from unique AO shells in the given ranges,
c     compute the 2-electron integrals in the SO basis using
c     the symmetry-blocked, or second, labelling for the SOs.
c     In this scheme SOs are blocked by irrep and within the
c     irrep are in the natural order of symmetry unique basis 
c     functions. See sym_abelian() for  more info on the labelling.
c
c     g(i,j,k,l) = (ij|kl)
c
c     The integrals non-zero by symmetry are stored densely as if
c     g() were declared as g(i,j,symj,k,l,syml,symkl) corresponding
c     to the below loops.  The array can also be thought as
c     being in the order g(ij,kl,symkl) where ij and kl run
c     over the pairs with symmetry kl.  The offset to the first 
c     element of a given symkl is symkloff(symkl).
c     
c     ind = 0
c     do symkl = 0, nir-1
c     .  symij = symkl
c     .  do syml = 0, nir-1
c     .     symk = ieor(syml,symkl)
c     .     do l = SOs of syml from l-shell-block
c     .        do k = SOs of symk from k-shell-block
c     .           do symj = 0, nir-1
c     .              symi = ieor(symij,symj)
c     .              do j = SOs of symj from j-shell-block
c     .                 do i = SOs of symi from i-shell-block
c     .                    ind = ind + 1
c     .                    g(ind) = (ij|kl) or <ij|kl>
c
c     The block of integrals may be addressed using arrays generated 
c     by soints_block_info()
c     (this will only work for indices non-zero by symmetry)
c     
c     ijkl = ioff(i) + joff(j,symij) + koff(k,symkl) 
c     .      + loff(l,symkl)
c     integral = g(ijkl)
c
c     Also useful,
c
c     irange(1,symi) = first orbital i of symi in i shell block 
c     irange(2,symi) = last  orbital i of symi in i shell block 
c     ditto for j, k, l
c     lenij(symij) = no. of ij pairs in the block with symmetry ij
c     lenkl(symkl) = ditto  kl
c     symkloff(symkl) = first integral in the symkl block.
c
      integer xishuq, xjshuq, xkshuq, xlshuq
      integer ishuq, jshuq, kshuq, lshuq, lopuq, kopuq, jopuq
      integer ish, jsh, ksh, lsh, jdim, kdim, ldim
      integer i, j, k, l, i2, j2, k2, l2, ijkl, ind, iuq
*      integer ngot
      integer symi, symj, symk, syml, symij, symkl
      integer juq, kuq, luq, jnw, knw, lnw, jshnw, kshnw, lshnw, nsh
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      integer nopuq
      integer l_q4, l_scr, l_eri, l_lab, l_q, l_ao
      integer k_q4, k_scr, k_eri, k_lab, k_q, k_ao
      integer k_iq, k_jq, k_kq, k_lq
      integer k_ilab, k_jlab, k_klab, k_llab
      integer leneri, lenscr, lenao
      integer maxq, nq, idimuq
      double precision smax, skl, gijkl, c(8,8)
      integer nops, geom
      integer sym_number_ops
      external sym_number_ops
      integer mapi(nw_max_nbf_small), mapj(nw_max_nbf_small), 
     $     mapk(nw_max_nbf_small), mapl(nw_max_nbf_small)
c
      if (.not. bas_geom(basis,geom)) call errquit
     $     ('soints_block: basis?', 0, BASIS_ERR)
      if (.not. bas_numcont(basis,nsh)) call errquit
     $     ('soints_block: basis?', 0, BASIS_ERR)
c
c     AO integrals are stored with symmetry unique i, and all symmetry 
c     related j, k, l in natural order.  map{ijkl} maps from NWChem AO 
c     labels into this order offset and modified to address the array.
c
      call ifill(nbf,99999999,mapi,1)
      call ifill(nbf,99999999,mapj,1)
      call ifill(nbf,99999999,mapk,1)
      call ifill(nbf,99999999,mapl,1)
      jdim = sh_uq_bf(2,jshuqhi) - sh_uq_bf(1,jshuqlo) + 1
      kdim = sh_uq_bf(2,kshuqhi) - sh_uq_bf(1,kshuqlo) + 1
      ldim = sh_uq_bf(2,lshuqhi) - sh_uq_bf(1,lshuqlo) + 1
      idimuq = 0
      do xishuq = ishuqlo, ishuqhi
         ish = sh_uq(xishuq)
         if (.not. bas_cn2bfr(basis, ish, ilo, ihi))
     $        call errquit('soints_block: cn2bfr?', ish, BASIS_ERR)
         do i = ilo,ihi
            mapi(i) = idimuq + i - ilo
         end do
         idimuq = idimuq + ihi - ilo + 1
      end do
      lenao = idimuq*jdim*kdim*ldim
c
      jlo = sh_uq_bf(1,jshuqlo)
      jhi = sh_uq_bf(2,jshuqhi)
      do j = jlo, jhi
         mapj(bf_nat(2,j)) = (j-jlo)*idimuq
      end do
      klo = sh_uq_bf(1,kshuqlo)
      khi = sh_uq_bf(2,kshuqhi)
      do k = klo, khi
         mapk(bf_nat(2,k)) = (k-klo)*(idimuq*jdim)
      end do
      llo = sh_uq_bf(1,lshuqlo)
      lhi = sh_uq_bf(2,lshuqhi)
      do l = llo, lhi
         mapl(bf_nat(2,l)) = (l-llo)*(idimuq*jdim*kdim)
      end do
c     
c     Allocate memory for the integrals.  Cannot do them all at once since
c     Texas internal memory allocation fails if we give it more than
c     10000 quartets at once.
c     
      nops = sym_number_ops(geom) + 1
      maxq = 5000
*      maxq = (ishuqhi-ishuqlo+1)*(jshuqhi-jshuqlo+1)*
*     $     (kshuqhi-kshuqlo+1)*(lshuqhi-lshuqlo+1)*(nops**3)
c
      call intb_mem_2e4c(leneri, lenscr)
      leneri = max(leneri,100*(6**4)) ! Room for 100 (dd|dd)
      lenscr = lenscr + lenscr/2
C
      if (.not. ma_push_get(mt_dbl, maxq, 'q4', l_q4, k_q4))
     $     call errquit('soints_block: ma q4?',maxq, MA_ERR)
      if (.not. ma_push_get(mt_int, 4*maxq, 'quartets', l_q, k_q))
     $     call errquit('soints_block: ma q?', 4*maxq, MA_ERR)
      if (.not. ma_push_get(mt_int, 4*leneri, 'labels', l_lab, k_lab))
     $     call errquit('soints_block: ma lab?', 4*leneri, MA_ERR)
      if (.not. ma_push_get(mt_dbl, leneri, 'eri', l_eri, k_eri))
     $     call errquit('soints_block: ma eri?', leneri, MA_ERR)
      if (.not. ma_push_get(mt_dbl, lenscr, 'scr', l_scr, k_scr))
     $     call errquit('soints_block: ma scr?', lenscr, MA_ERR)
      if (.not. ma_push_get(mt_dbl, lenao, 'ao', l_ao, k_ao))
     $     call errquit('soints_block: ma ao?',lenao, MA_ERR)
      k_iq = k_q          
      k_jq = k_q + maxq   
      k_kq = k_q + maxq*2 
      k_lq = k_q + maxq*3 
      k_ilab = k_lab       
      k_jlab = k_lab + leneri  
      k_klab = k_lab + leneri*2
      k_llab = k_lab + leneri*3
      call dfill(lenao, 0d0, dbl_mb(k_ao), 1)
c
c     Loop thru symmetry unique shells, then symmetry related shells jkl
c
      nq = 0
      smax = schwarz_max()
      do xlshuq = lshuqlo, lshuqhi
         lshuq = sh_uq(xlshuq)
         do xkshuq = kshuqlo, kshuqhi
            kshuq = sh_uq(xkshuq)
            do xjshuq = jshuqlo, jshuqhi
               jshuq = sh_uq(xjshuq)
               do xishuq = ishuqlo, ishuqhi
                  ishuq = sh_uq(xishuq)
                  ish = ishuq   ! Don't use related ish
                  do lopuq = 1, sh_n_uq_op(lshuq)
                     lsh = sh_op_map(sh_uq_op(lopuq,lshuq),lshuq)
                     do kopuq = 1, sh_n_uq_op(kshuq)
                        ksh = sh_op_map(sh_uq_op(kopuq,kshuq),kshuq)
                        skl = schwarz_shell(ksh,lsh)
                        if (skl*smax.gt.tol) then
                           do jopuq = 1, sh_n_uq_op(jshuq)
                              jsh=sh_op_map(sh_uq_op(jopuq,jshuq),jshuq)
                              if (skl*schwarz_shell(ish,jsh).gt.tol)then

                                 if ( ish.le.0.or.ish.gt.nsh.or.
     $                                jsh.le.0.or.jsh.gt.nsh.or.
     $                                ksh.le.0.or.ksh.gt.nsh.or.
     $                                lsh.le.0.or.lsh.gt.nsh) then
                                    write(6,*) ish,jsh,ksh,lsh
                                    call errquit('bad sh',0, BASIS_ERR)
                                 end if
                                 int_mb(k_iq + nq) = ish
                                 int_mb(k_jq + nq) = jsh
                                 int_mb(k_kq + nq) = ksh
                                 int_mb(k_lq + nq) = lsh
                                 dbl_mb(k_q4 + nq) = 1.0d0
                                 nq = nq + 1
c
                                 if (nq .eq. maxq) then
                                    call soints_aoints(basis, nq,
     $                                   int_mb(k_iq), int_mb(k_jq), 
     $                                   int_mb(k_kq), int_mb(k_lq), 
     $                                   dbl_mb(k_q4), tol, 
     $                                   int_mb(k_ilab), int_mb(k_jlab),
     $                                   int_mb(k_klab), int_mb(k_llab),
     $                                   dbl_mb(k_eri), leneri, 
     $                                   dbl_mb(k_scr), lenscr,
     $                                   mapi, mapj, mapk, mapl, 
     $                                   dbl_mb(k_ao), lenao)
                                    nq = 0
                                 end if
                              end if
                           end do
                        end if
                     end do
                  end do
               end do
            end do
         end do
      end do
      if (nq .gt. 0) call soints_aoints(basis, nq,
     $     int_mb(k_iq), int_mb(k_jq), 
     $     int_mb(k_kq), int_mb(k_lq), 
     $     dbl_mb(k_q4), tol, 
     $     int_mb(k_ilab), int_mb(k_jlab),
     $     int_mb(k_klab), int_mb(k_llab),
     $     dbl_mb(k_eri), leneri, 
     $     dbl_mb(k_scr), lenscr,
     $     mapi, mapj, mapk, mapl, 
     $     dbl_mb(k_ao), lenao)
c
c$$$ 789  format(i6,4x,4i5,f12.6)
c$$$      write(6,*) ' The AO integrals'
c$$$      ind = 0
c$$$      ngot = 0
c$$$      do l = sh_uq_bf(1,lshuqlo), sh_uq_bf(2,lshuqhi)
c$$$         do k = sh_uq_bf(1,kshuqlo), sh_uq_bf(2,kshuqhi)
c$$$            do j = sh_uq_bf(1,jshuqlo), sh_uq_bf(2,jshuqhi)
c$$$               do iuq = sh_uq_bf(3,ishuqlo), sh_uq_bf(4,ishuqhi)
c$$$                  gijkl = dbl_mb(k_ao+ind) ! The integral
c$$$                  ind = ind + 1
c$$$                  if (abs(gijkl).gt.1e-6) then
c$$$                      write(6,789) ind, iuq,j,k,l,gijkl
c$$$                      ngot = ngot + 1
c$$$                   end if
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c$$$      write(6,*) ngot
c
c     Now have all of the AO integrals.
c
c     For each of lsh, ksh, and jsh loop thru the generators 
c     (symmetry unique/lexically highest functions) in the block of 
c     unique shells and transform them to the SO basis.
c
      do lshuq = lshuqlo, lshuqhi ! Loop thru unique shells
         lshnw = sh_uq(lshuq)     ! NWChem order shell
         nopuq  = sh_n_uq_op(lshnw) ! No. of related functions
         do luq = sh_uq_bf(3,lshuq), sh_uq_bf(4,lshuq)
            lnw = bf_uq(luq)
            call soints_uq_to_so_matrix(luq, c)
c$$$            write(6,*) ' luq ', luq, ' nopuq ', nopuq, ' lnw ', lnw,
c$$$     $           ' mapl ', mapl(lnw)
c$$$            call output(c,1,nopuq,1,nopuq,8,8,1)
            call soints_inplace_mxm(idimuq*jdim*kdim, nopuq, 1,
     $           dbl_mb(k_ao+mapl(lnw)), ldim, c)
         end do
      end do
c$$$      write(6,*) ' After L'
c$$$      ind = 0
c$$$      ngot = 0
c$$$      do l = sh_uq_bf(1,lshuqlo), sh_uq_bf(2,lshuqhi)
c$$$         do k = sh_uq_bf(1,kshuqlo), sh_uq_bf(2,kshuqhi)
c$$$            do j = sh_uq_bf(1,jshuqlo), sh_uq_bf(2,jshuqhi)
c$$$               do iuq = sh_uq_bf(3,ishuqlo), sh_uq_bf(4,ishuqhi)
c$$$                  gijkl = dbl_mb(k_ao+ind) ! The integral
c$$$                  ind = ind + 1
c$$$                  if (abs(gijkl).gt.1e-6) then
c$$$                      write(6,789) ind, iuq,j,k,l,gijkl
c$$$                      ngot = ngot + 1
c$$$                   end if
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c$$$      write(6,*) ngot
      do kshuq = kshuqlo, kshuqhi ! Loop thru unique shells
         kshnw = sh_uq(kshuq)     ! NWChem order shell
         nopuq  = sh_n_uq_op(kshnw) ! No. of related functions
         do kuq = sh_uq_bf(3,kshuq), sh_uq_bf(4,kshuq)
            knw = bf_uq(kuq)
            call soints_uq_to_so_matrix(kuq, c)
            call soints_inplace_mxm(idimuq*jdim, nopuq, ldim,
     $           dbl_mb(k_ao+mapk(knw)), kdim, c)
         end do
      end do
c$$$      write(6,*) ' After K'
c$$$      ind = 0
c$$$      ngot = 0
c$$$      do l = sh_uq_bf(1,lshuqlo), sh_uq_bf(2,lshuqhi)
c$$$         do k = sh_uq_bf(1,kshuqlo), sh_uq_bf(2,kshuqhi)
c$$$            do j = sh_uq_bf(1,jshuqlo), sh_uq_bf(2,jshuqhi)
c$$$               do iuq = sh_uq_bf(3,ishuqlo), sh_uq_bf(4,ishuqhi)
c$$$                  gijkl = dbl_mb(k_ao+ind) ! The integral
c$$$                  ind = ind + 1
c$$$                  if (abs(gijkl).gt.1e-6) then
c$$$                      write(6,789) ind, iuq,j,k,l,gijkl
c$$$                      ngot = ngot + 1
c$$$                   end if
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c$$$      write(6,*) ngot
      do jshuq = jshuqlo, jshuqhi ! Loop thru unique shells
         jshnw = sh_uq(jshuq)     ! NWChem order shell
         nopuq  = sh_n_uq_op(jshnw) ! No. of related functions
         do juq = sh_uq_bf(3,jshuq), sh_uq_bf(4,jshuq)
            jnw = bf_uq(juq)
            call soints_uq_to_so_matrix(juq, c)
            call soints_inplace_mxm(idimuq, nopuq, kdim*ldim,
     $           dbl_mb(k_ao+mapj(jnw)), jdim, c)
         end do
      end do
c$$$      write(6,*) ' After K'
c$$$      ind = 0
c$$$      ngot = 0
c$$$      do l = sh_uq_bf(1,lshuqlo), sh_uq_bf(2,lshuqhi)
c$$$         do k = sh_uq_bf(1,kshuqlo), sh_uq_bf(2,kshuqhi)
c$$$            do j = sh_uq_bf(1,jshuqlo), sh_uq_bf(2,jshuqhi)
c$$$               do iuq = sh_uq_bf(3,ishuqlo), sh_uq_bf(4,ishuqhi)
c$$$                  gijkl = dbl_mb(k_ao+ind) ! The integral
c$$$                  ind = ind + 1
c$$$                  if (abs(gijkl).gt.1e-6) then
c$$$                      write(6,789) ind, iuq,j,k,l,gijkl
c$$$                      ngot = ngot + 1
c$$$                   end if
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c$$$      write(6,*) ngot
c
c     The transformation is complete.  Only the unique ish were
c     computed and they were not transformed, but the transformation
c     of the other three indices act as a projector for their
c     symmetry.
c
c     A range of unique shells will give rise to the same ranges
c     for both basis functions and SOs in natural order.
c
      ind = 0
      do l = sh_uq_bf(1,lshuqlo), sh_uq_bf(2,lshuqhi)
         syml = so_lab1(1,l)
         l2   = so_lab1(2,l)
         do k = sh_uq_bf(1,kshuqlo), sh_uq_bf(2,kshuqhi)
            symk = so_lab1(1,k)
            k2   = so_lab1(2,k)
            symkl= ieor(symk,syml)
            symij= symkl
            do j = sh_uq_bf(1,jshuqlo), sh_uq_bf(2,jshuqhi)
               symj = so_lab1(1,j)
               j2   = so_lab1(2,j)
               symi = ieor(symij,symj)
               do iuq = sh_uq_bf(3,ishuqlo), sh_uq_bf(4,ishuqhi)
                  i2  = so_uq_to_lab(2,symi,iuq)
c
                  gijkl = dbl_mb(k_ao+ind) ! The integral
                  ind = ind + 1
                  if (i2 .lt. 0) then
                     if (abs(gijkl) .gt. 1d-6) then
                        write(6,*) i2,j2,k2,l2,gijkl
                        call errquit('should be zero?',ijkl,
     &       UNKNOWN_ERR)
                     end if
                  else
                     ijkl = ioff(i2) + joff(j2,symij) + 
     $                       koff(k2,symkl) + loff(l2,symkl)
                     g(ijkl) = gijkl
                  end if
               end do
            end do
         end do
      end do
c
      if (.not. ma_chop_stack(l_q4)) call errquit
     $     ('soints_aoblock: ma corrupted?',0, MA_ERR)
c
      end
      subroutine soints_block_info(basis, nbf,
     $     ishuqlo, ishuqhi, ioff, irange, 
     $     jshuqlo, jshuqhi, joff, jrange,
     $     kshuqlo, kshuqhi, koff, krange,
     $     lshuqlo, lshuqhi, loff, lrange,
     $     lenij, lenkl, symkloff, leng)
      implicit none
#include "errquit.fh"
      integer basis
      integer nbf
      integer ishuqlo, ishuqhi, irange(2,0:7), ioff(nbf)
      integer jshuqlo, jshuqhi, jrange(2,0:7), joff(nbf,0:7)
      integer kshuqlo, kshuqhi, krange(2,0:7), koff(nbf,0:7)
      integer lshuqlo, lshuqhi, lrange(2,0:7), loff(nbf,0:7)
      integer lenij(0:7), lenkl(0:7), symkloff(0:7), leng
c
c     See the comments in soints_block() for detailed info.
c
c     lenij(symij) is the number of ij pairs for a given symmetry
c     lenkl(symkl) ................ kl ..........................
c     symkloff(symkl) = index of the first element in the symkl block.
c     leng returns the no. of integrals non-zero by symmetry.
c     
      integer symi, symj, symk, syml, symij, symkl
      integer i, j, k, l, ijkl, count
      integer leni, lenk
c
c     Generate the ranges of SOs in each block of shells
c
      call soints_shblock_info(basis, ishuqlo, ishuqhi, irange)
      call soints_shblock_info(basis, jshuqlo, jshuqhi, jrange)
      call soints_shblock_info(basis, kshuqlo, kshuqhi, krange)
      call soints_shblock_info(basis, lshuqlo, lshuqhi, lrange)
c
c     Generate the addressing arrays for the integrals.  Only entries
c     within the given blocks will be valid.
c
      call ifill(  nbf, 99999999, ioff, 1)
      call ifill(8*nbf, 99999999, joff, 1)
      call ifill(8*nbf, 99999999, koff, 1)
      call ifill(8*nbf, 99999999, loff, 1)
c
c     ioff(i) is just the index within its symmetry block
c
      do symi = 0, 7
         do i = irange(1,symi), irange(2,symi)
            ioff(i) = 1 + i - irange(1,symi)
         end do
      end do
c
c     For given (symij, symj) the matrix (i,j) is dense 
c     ... joff(j,symij) is the offset to the top of the
c     j'th column within the given symmetry, plus the size of
c     all the preceeding i symmetries.
c
      do symij = 0, 7
         lenij(symij) = 0
         do symj = 0, 7
            symi = ieor(symij,symj)
            do j = jrange(1,symj),jrange(2,symj)
               joff(j,symij) = lenij(symij)
               leni = max(0, irange(2,symi)-irange(1,symi)+1)
               lenij(symij) = lenij(symij) + leni
            end do
         end do
      end do
c
c     koff is offset within its symmetry block * lenij
c
      do symkl = 0,7
         symij = symkl
         do syml = 0, 7
            symk = ieor(symkl,syml)
            do k = krange(1,symk), krange(2,symk)
               koff(k,symkl) = (k - krange(1,symk))*lenij(symij)
            end do
         end do
      end do
c
c     loff as for joff but * lenij and accumulate all previous kl symmetries
c
      count = 0
      do symkl = 0, 7
         symij = symkl
         lenkl(symkl) = 0
         symkloff(symkl) = count + 1
         do syml = 0, 7
            symk = ieor(symkl,syml)
            do l = lrange(1,syml),lrange(2,syml)
               loff(l,symkl) = count
               lenk = max(0, krange(2,symk)-krange(1,symk)+1)
               lenkl(symkl) = lenkl(symkl) + lenk
               count = count + lenk*lenij(symij)
            end do
         end do
      end do
c
c     Verify the indexing ... comment this out when we are sure
c     it is working since it is O(N^4).
c
      count = 0
      do symkl = 0, 7
         symij = symkl
         do syml = 0, 7
            symk = ieor(symkl,syml)
            do l = lrange(1,syml),lrange(2,syml)
               do k = krange(1,symk),krange(2,symk)
                  do symj = 0, 7
                     symi = ieor(symij,symj)
                     do j = jrange(1,symj),jrange(2,symj)
                        do i = irange(1,symi),irange(2,symi)
                           count = count + 1
                           ijkl = ioff(i) + joff(j,symij) +
     $                          koff(k,symkl) + loff(l,symkl)
                           if (ijkl .ne. count) then
                              write(6,*) symi, symj, symk, syml,
     $                             symij, symkl
                              write(6,*) i,j,k,l,ioff(i),joff(j,symij),
     $                             koff(k,symkl),loff(l,symkl),
     $                             ijkl, count
                              call errquit(' soints_block_info: bad',0,
     &       UNKNOWN_ERR)
                           endif
                        end do
                     end do
                  end do
               end do
            end do
         end do
      end do
c
      leng = count
c
      end
      subroutine soints_shblock_info(basis, ishuqlo, ishuqhi, irange)
      implicit none
#include "bas.fh"
#include "nwc_const.fh"
#include "cbassym.fh"
      integer basis, ishuqlo, ishuqhi ! [input]
      integer irange(2,0:7)     ! [output]
c
c     Given a range of symmetry unique AO shells determine
c     the range of SO functions within each irrep (in the
c     second labelling scheme).
c
c     Loop thru all of the unique basis functions.  Find the
c     first/last function in natural in the first/last shell. 
c     If there are no functions in an irrep, the range is set
c     to [0,-1].
c
      integer ir, lab1, lab1lo, lab1hi
c
      do ir = 0, 7
         irange(1,ir) = 0
         irange(2,ir) = -1
      end do
c
c     Determine the range of basis functions in natural order
c     ... the range of SOs in natual order (lab1) will be the same.
c
      lab1lo = sh_uq_bf(1,ishuqlo)
      lab1hi = sh_uq_bf(2,ishuqhi)
c
c     Loop forward thru the SOs to determine the first in each irrep
c     then backward to get the last, mapping into the symmetry
c     blocked order (lab2) at the same time.
c
      do ir = 0,7
         do lab1 = lab1lo,lab1hi
            if (so_lab1(1,lab1).eq.ir .and. irange(1,ir).eq.0) then
               irange(1,ir) = so_lab1(2,lab1)
               goto 10
            endif
         end do
 10      continue
      end do
      do ir = 0,7
         do lab1 = lab1hi,lab1lo,-1
            if (so_lab1(1,lab1).eq.ir .and. irange(2,ir).eq.-1) then
               irange(2,ir) = so_lab1(2,lab1)
               goto 20
            end if
         end do
 20      continue
      end do
c
c$$$      write(6,*) ' SO UQSHRANGE: ', ishuqlo, ishuqhi
c$$$      write(6,1) (irange(1,ir),irange(2,ir),ir=0,7)
c$$$ 1    format(8(2i4,4x))
c
      end
      subroutine soints_uq_to_so_matrix(luq, c)
      implicit none
#include "nwc_const.fh"
#include "cbassym.fh"
      integer luq               ! [input]
      double precision c(8,8)   ! [output]
c
c     For symmetry unique basis function number luq return
c     in C the matrix that transforms the symmetry related
c     AO functions into SO basis
c
c     |iruq> = sum(k=1..nopuq) C(iruq,luq) |k>
c
c     where iruq runs over the irreducible representations arising
c     from this generator (the actual irrep is ir=bf_so_ir(iruq,luq))
c
c     and k runs over the functions related by symmetry to the
c     unique basis function (their NWChem numbering is given 
c     as bf_op_map(bf_uq_op(opuq),bf_uq(luq)), opuq=1,nopuq. 
c
      integer nopuq, opuq, op, iruq, ir, lnw
      double precision scale, phase
c
      call dfill(8*8, 1d300, c, 1) ! Make unitialized numbers bad news
c
      lnw = bf_uq(luq)          ! NWChem label for unique function
      nopuq  = bf_n_uq_op(lnw)  ! No. of related functions
      scale = 1d0/dble(nopuq)
      do opuq = 1,nopuq
         op = bf_uq_op(opuq,lnw)
         phase = bf_phase(op,lnw)*scale
         do iruq = 1, nopuq
            ir = bf_so_ir(iruq,luq)
            c(iruq,opuq) = char_tab(op,ir)*phase
         end do
      end do
c
      end
      subroutine soints_inplace_mxm(n, nopuq, m, a, dim2, c)
      implicit none
      integer n, nopuq, m, dim2
      double precision a(n,dim2,m), c(8,8)
c
c     c() is a small matrix that transforms a set of symmetry
c     related functions from the AO to SO bases and a() is
c     a set of integrals that are to be transformed.
c
c     a(i,iruq,j) <= sum(opuq=1,nopuq) a(i,opuq,j)*c(iruq,opuq)
c
c     This routine does the transformation inplace via a 
c     small buffer.
c     
      integer maxbuf
      parameter (maxbuf = 64)
      double precision buf(maxbuf,8)
      integer ilo, ihi, idim, i, j, ii, opuq, iruq
c
      do j = 1, m
         do ilo = 1, n, maxbuf
            ihi = min(n,ilo+maxbuf-1)
            idim = ihi-ilo+1
            do iruq = 1, nopuq
               do i = 1, idim
                  buf(i,iruq) = 0d0
               end do
            end do
            do opuq = 1, nopuq
               do iruq = 1, nopuq
                  do i = ilo,ihi
                     ii = i-ilo+1 
                     buf(ii,iruq) = buf(ii,iruq) +
     $                    a(i,opuq,j)*c(iruq,opuq)
                  end do
               end do
            end do
            do iruq = 1, nopuq
               do i = ilo,ihi
                  ii = i-ilo+1 
                  a(i,iruq,j) = buf(ii,iruq)
               end do
            end do
         end do
      end do
c
      end
      subroutine soints_aoints(basis, nq, iq, jq, kq, lq,
     $        q4, tol, ilab, jlab, klab, llab, eri, leneri,
     $        scr, lenscr, mapi, mapj, mapk, mapl, ao, lenao)
      implicit none
#include "errquit.fh"
      integer basis
      integer nq
      integer iq(*), jq(*), kq(*), lq(*)
      integer ilab(*), jlab(*), klab(*), llab(*)
      integer mapi(*), mapj(*), mapk(*), mapl(*)
      integer leneri, lenscr, lenao
      double precision q4(*), tol, eri(*), scr(*), ao(*)
c     
      integer neri, ieri, ijkl
      logical more
      double precision block_eff
      logical intb_init4c, intb_2e4c
      external intb_init4c, intb_2e4c
c      
      if (nq .le. 0) return
c
      if (.not. intb_init4c(
     $     basis, iq, jq, basis, kq, lq,
     $     nq, q4, .true., 
     $     lenscr, scr, leneri, block_eff))
     $     call errquit('intb_init?',nq, INT_ERR)
c
 10   more = intb_2e4c(
     $     basis, iq, jq, basis, kq, lq,
     $     nq, q4, .true., tol, .false.,
     $     ilab, jlab, klab, llab, 
     $     eri, leneri, neri, lenscr, scr)
c     
c     Map the labels from NWChem order into symmetry natural order
c     
      do ieri = 1, neri
         ijkl = 1 + 
     $        mapi(ilab(ieri)) +
     $        mapj(jlab(ieri)) + 
     $        mapk(klab(ieri)) +
     $        mapl(llab(ieri))
         if (ijkl.lt.1 .or. ijkl.gt.lenao) call errquit('ijkl',ijkl,
     &       UNKNOWN_ERR)
         ao(ijkl) = eri(ieri)
      end do
c
      if (more) goto 10
c
      end
      subroutine soints_sovecs(nbf,nmo,c,order)
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "cbassym.fh"
      integer nbf, nmo, order
      double precision c(nbf,nmo)
c
c     On input C() contains a set of molecular orbital coefficients 
c     in the atomic orbital basis ... transform the AO index into the 
c     symmetry-adapted orbital basis.  
c
c     Order determines the output labelling
c
c     if (order == 1) then
c     .  The SOs are in natural order (not blocked).
c     else if (order == 2) then
c     .  The SOs are blocked by symmetry (second labelling scheme).
c     else
c     .  Error
c     endif
c
c     Assumes cbassym has been initialized.
c
      integer i, j, juq, nopuq, iruq, opuq
      double precision t(nw_max_nbf_small), s(8,8), sum
c
      if (order.lt.1 .or. order.gt.2) call errquit('what order?',0,
     &       INPUT_ERR)
c
      write(6,*) ' INPUT'
      call output(c,1,nbf,1,nmo,nbf,nmo,1)
c     
c     First reorder the AO functions into symmetry natural order,
c     and transform into SOs in natural order, then copy back
c     in blocked order. 
c
      do i = 1, nmo
         do j = 1, nbf
            t(bf_nat(1,j)) = c(j,i)
         end do
         j = 0
         do juq = 1, bf_n_uq
            nopuq = bf_n_uq_op(bf_uq(juq))
            call soints_uq_to_so_matrix(juq, s)
            do iruq = 1, nopuq
               sum = 0d0
               do opuq = 1, nopuq
                  sum = sum + s(iruq,opuq)*t(j+opuq)
               end do
               if (order .eq. 1) then
                  c(j+iruq,i) = sum
               else 
                  c(so_lab1(2,j+iruq),i) = sum
               endif
            end do
            j = j + nopuq
         end do
      end do
c
      write(6,*) ' OUTPUT in order ', order
      call output(c,1,nbf,1,nmo,nbf,nmo,1)
c
      end
      subroutine soints_uqshblock(uqlo, uqhi, maxnbf, blocks, nblocks)
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "cbassym.fh"
      integer uqlo, uqhi        ! [input]
      integer maxnbf            ! [input]
      integer blocks(2,*)       ! [output]
      integer nblocks           ! [output]
c
c     Group the given range of symmetry unqiue shells into blocks so
c     that there are no more than maxnbf functions arising from each
c     block.
c
c     nblocks returns the no. of blocks
c     blocks(1,*) = first symmetry unique shell in the block
c     blocks(2,*) = last ...
c
      integer ninblock, ishuq, ishuqlo, shdim, iblock
c
      ninblock = 0
      nblocks = 0
      ishuqlo = uqlo
      do ishuq = uqlo,uqhi
         shdim = sh_uq_bf(2,ishuq) - sh_uq_bf(1,ishuq) + 1
         if (shdim .gt. maxnbf) call errquit
     $        ('soints_uqshblock: shell block > maxnbf?', shdim,
     &       BASIS_ERR)
         if ((ninblock+shdim .gt. maxnbf) .or. (ishuq.eq.sh_n_uq)) then
            nblocks = nblocks + 1
            blocks(1,nblocks) = ishuqlo
            blocks(1,nblocks) = ishuq - 1
            if (ishuq .eq. sh_n_uq) blocks(1,nblocks) = ishuq
            ishuqlo = ishuq
            ninblock = 0
         else
            ninblock = ninblock + shdim
         end if
      end do
c
      write(6,*) ' UNIQUE shell blocking maxnbf = ', maxnbf
      do iblock = 1, nblocks
         write(6,1) iblock, blocks(1,iblock), blocks(2,iblock)
 1       format(1x,i5,5x,2i5)
      end do
c
      end

c $Id: soints.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function pre_rdgeom(irtdb,csa,isar,isgm,isfnd,xs,vs,
     + msa,nsa,nmis,msm,nsm)
c
c $Id: pre_rdgeom.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "geom.fh"
c
      real*8 cau2nm
      parameter(cau2nm=5.29177249d-02)
c
      integer irtdb,msa,nsa,nmis,msm,nsm
      character*16 csa(msa)
      integer isar(msa),isgm(msa),isfnd(msa)
      real*8 xs(3,msa),vs(3,msa)
c
      integer igeom,i
      character*16 tag
      real*8 chrg,coord(3)
c
      if(.not.geom_create(igeom,'geometry'))
     + call md_abort('pre_rdgeom: geom_create failed',9999)
      if(.not.geom_rtdb_load(irtdb,igeom,'geometry'))
     + call md_abort('pre_rdgeom: geom_rtdb_load failed',9999)
c
      do 1 i=1,msa
      if(.not.geom_cent_get(igeom,i,tag,coord,chrg))
     + call md_abort('pre_rdgeom: geom_cent_get failed',9999)
      xs(1,i)=cau2nm*coord(1)
      xs(2,i)=cau2nm*coord(2)
      xs(3,i)=cau2nm*coord(3)
      vs(1,i)=0.0d0
      vs(2,i)=0.0d0
      vs(3,i)=0.0d0
      isfnd(i)=1
      isar(i)=0
    1 continue
      nsa=msa
      nmis=0
c
      if(.not.geom_destroy(igeom))
     + call md_abort('pre_rdgeom: geom_destroy failed',9999)
c
      pre_rdgeom=.true.
      return
c
 9999 continue
      pre_rdgeom=.false.
      return
      end

      subroutine argos_start
c
c $Id: argos_start.F 19828 2011-01-04 20:25:43Z d3j191 $
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
c     determine the partition of processes, process ids, etc
c     ------------------------------------------------------
c
      call argos_partition
c
c     generate file names and open all files
c     --------------------------------------
c
      call argos_fopen(.false.)
c
c     print input information
c     -----------------------
c
      call argos_print()
c
c     start the spacial decomposition API
c     -----------------------------------
c
      call argos_space_start(lfnout,lfntop,filtop,lfnrst,filrst,lfnsyn,
     + filsyn,
     + nfsync,rshort,rlong,zero,rsgm,
     + npx,npy,npz,nbx,nby,nbz,
     + npbtyp,nbxtyp,box,vlat,lpbc,
     + nwm,mwm,nwa,mwa,nsf,msf,nsm,msm,nsa,msa,
     + loadb,lbpair,factld,ipolt.ne.0,.false.,temp,tempw,temps,
     + iguide,lfndbg,idebug,projct,mbbreq,nserie,isload,ireset,icntrl,
     + nseq,i_lseq,ndums,nbget,nprec,madbox)
c
c     start the analysis API
c     ----------------------
c
c      if(nfanal.gt.0) call ana_init(nsa,msa,.false.)
c
c     start the classical forces API
c     ------------------------------
c
      call argos_cafe_start(irtdb,lfnout,lfntop,filtop,ndistr,npmf,
     + npmfi,
     + nwm,mwm,nwa,mwa,nsf,msf,nsm,msm,nsa,msa,
     + mdalgo,npbtyp,nbxtyp,rshort,rlong,box,
     + ipme,morder,ngx,ngy,ngz,nodpme,pmetol,
     + tstep,tlwsha,mshitw,mshits,noshak,
     + ipolt,itscal,ipscal,ipopt,tmpext,prsext,
     + tmprlx,tmsrlx,prsrlx,scaleq,facpmf,
     + 0,temp,tempw,temps,compr,ntype,iset,isetp1,isetp2,
     + issscl,delta,nfanal,lpbc,npgdec,xfield,xfvect,xffreq,
     + npener,icntrl,nbias,mropt,includ,ltwin,
     + nseq,i_lseq,nfhop,rhop,thop,ndums,ipbtyp,lfnhop,iradgy,
     + 0,nprec)
c     + nbget)
c
      if(mlambd.gt.0.and.ilambd.gt.0.and.ilambd.le.mlambd)
     + call argos_cafe_lambda(lamtyp,irun,maxlam,elam,lfnout,lfnpmf,
     + rlambd,dlambd,filnam)
c
c     print topology information
c     --------------------------
c
      call argos_cafe_print_top(lfnout,npatom,nptopw,nptops)
c
      msm=max(1,nsm)
      msf=max(1,nsf)
      mst=max(msm,nseq)
c
c     start the property API
c     ----------------------
c
      call argos_prop_start(nserie,ntype,nftri,lfnrst,filrst,lfnout,
     + lfnprp,lfngib,nfoutp,nfstat,nfprop,iprop,
     + .true.,.true.,ltwin,ipolt.ne.0,ipme.ne.0,
     + npstep.ne.0,npener.ne.0,npstat,
     + nwm,msf,nsf,mpe,mdacq,mrun,iset,isetp1,isetp2,tstep,msm,nsm,
     + nsa,ddacq,edacq,iprof,npmf,npener,ndistr,lpbc,nbias,nodpme,npmfi,
     + iguide.ne.0,iradgy,idifco,nbget,meg,npg)
c
c     allocate memory for coordinates, velocities, etc.
c     -------------------------------------------------
c
      if(.not.ma_push_get(mt_int,mwm*miw2,'iw',l_iw,i_iw))
     + call md_abort('Failed to allocate memory for iw',0)
      if(.not.ma_push_get(mt_int,msa*mis2,'is',l_is,i_is))
     + call md_abort('Failed to allocate memory for is',0)
      if(.not.ma_push_get(mt_int,mwm,'iwz',l_iwz,i_iwz))
     + call md_abort('Failed to allocate memory for iw',0)
      if(.not.ma_push_get(mt_int,msa,'isz',l_isz,i_isz))
     + call md_abort('Failed to allocate memory for is',0)
      if(.not.ma_push_get(mt_dbl,3*mwa*mwm,'xw',l_xw,i_xw))
     + call md_abort('Failed to allocate memory for xw',0)
      if(.not.ma_push_get(mt_dbl,3*mwm,'xwm',l_xwm,i_xwm))
     + call md_abort('Failed to allocate memory for xwm',0)
      if(.not.ma_push_get(mt_dbl,mwm,'rtos',l_rtos,i_rtos))
     + call md_abort('Failed to allocate memory for rtos',0)
      if(.not.ma_push_get(mt_dbl,3*msa,'xs',l_xs,i_xs))
     + call md_abort('Failed to allocate memory for xs',0)
      if(.not.ma_push_get(mt_dbl,3*mwa*mwm,'yw',l_yw,i_yw))
     + call md_abort('Failed to allocate memory for yw',0)
      if(.not.ma_push_get(mt_dbl,3*msa,'ys',l_ys,i_ys))
     + call md_abort('Failed to allocate memory for ys',0)
      if(.not.ma_push_get(mt_dbl,3*mwa*mwm,'vw',l_vw,i_vw))
     + call md_abort('Failed to allocate memory for vw',0)
      if(.not.ma_push_get(mt_dbl,3*msa,'vs',l_vs,i_vs))
     + call md_abort('Failed to allocate memory for vs',0)
      if(.not.ma_push_get(mt_dbl,3*mwa*mwm,'vwt',l_vwt,i_vwt))
     + call md_abort('Failed to allocate memory for vwt',0)
      if(.not.ma_push_get(mt_dbl,3*msa,'vst',l_vst,i_vst))
     + call md_abort('Failed to allocate memory for vst',0)
      if(.not.ma_push_get(mt_dbl,6*mwa*mwm,'fw',l_fw,i_fw))
     + call md_abort('Failed to allocate memory for fw',0)
      if(.not.ma_push_get(mt_dbl,6*msa,'fs',l_fs,i_fs))
     + call md_abort('Failed to allocate memory for fs',0)
      if(.not.ma_push_get(mt_dbl,3*mwm,'xwcr',l_xwcr,i_xwcr))
     + call md_abort('Failed to allocate memory for xwcr',0)
      if(.not.ma_push_get(mt_dbl,3*msm,'xsm',l_xsm,i_xsm))
     + call md_abort('Failed to allocate memory for xsm',0)
      if(.not.ma_push_get(mt_dbl,4*mst,'tsm',l_tsm,i_tsm))
     + call md_abort('Failed to allocate memory for tsm',0)
      if(.not.ma_push_get(mt_dbl,3*msm,'xsm',l_xsmp,i_xsmp))
     + call md_abort('Failed to allocate memory for xsmp',0)
      if(.not.ma_push_get(mt_dbl,8*msm,'gsm',l_gsm,i_gsm))
     + call md_abort('Failed to allocate memory for gsm',0)
      if(.not.ma_push_get(mt_dbl,3*msm,'xscr',l_xscr,i_xscr))
     + call md_abort('Failed to allocate memory for xscr',0)
      if(.not.ma_push_get(mt_dbl,msm,'dsr',l_dsr,i_dsr))
     + call md_abort('Failed to allocate memory for dsr',0)
      if(.not.ma_push_get(mt_dbl,18*msm,'zs',l_zs,i_zs))
     + call md_abort('Failed to allocate memory for zs',0)
      if(.not.ma_push_get(mt_dbl,2*mpe*msf,'esw',l_esw,i_esw))
     + call md_abort('Failed to allocate memory for esw',0)
      if(.not.ma_push_get(mt_dbl,2*mpe*msf*msf,'ess',l_ess,i_ess))
     + call md_abort('Failed to allocate memory for ess',0)
      if(.not.ma_push_get(mt_dbl,6*msf*msf,'fss',l_fss,i_fss))
     + call md_abort('Failed to allocate memory for fss',0)
      if(.not.ma_push_get(mt_dbl,msf,'esk',l_esk,i_esk))
     + call md_abort('Failed to allocate memory for esk',0)
      if(.not.ma_push_get(mt_dbl,mwa+msa,'wws',l_wws,i_wws))
     + call md_abort('Failed to allocate memory for wws',me)
      if(npener.eq.0) then
      if(.not.ma_push_get(mt_dbl,1,'esa',l_esa,i_esa))
     + call md_abort('Failed to allocate memory for esa',0)
      else
      if(.not.ma_push_get(mt_dbl,2*nsa,'esa',l_esa,i_esa))
     + call md_abort('Failed to allocate memory for esa',0)
      endif
      if(ipolt.gt.0) then
      if(.not.ma_push_get(mt_dbl,6*mwa*mwm,'pw',l_pw,i_pw))
     + call md_abort('Failed to allocate memory for pw',0)
      if(.not.ma_push_get(mt_dbl,6*msa,'ps',l_ps,i_ps))
     + call md_abort('Failed to allocate memory for ps',0)
      if(lpert2.or.lpert3) then
      if(.not.ma_push_get(mt_dbl,12*mwa*mwm,'pwp',l_pwp,i_pwp))
     + call md_abort('Failed to allocate memory for pwp',0)
      if(.not.ma_push_get(mt_dbl,12*msa,'psp',l_psp,i_psp))
     + call md_abort('Failed to allocate memory for psp',0)
      endif
      endif
      if(iguide.gt.0) then
      if(.not.ma_push_get(mt_dbl,3*mwa*mwm,'gw',l_gw,i_gw))
     + call md_abort('Failed to allocate memory for gw',0)
      if(.not.ma_push_get(mt_dbl,3*msa,'gs',l_gs,i_gs))
     + call md_abort('Failed to allocate memory for gs',0)
      endif
      if(icmopt.gt.0) then
      if(.not.ma_push_get(mt_dbl,5*msm,'fcm',l_fcm,i_fcm))
     + call md_abort('Failed to allocate memory for fcm',0)
      endif
c
      if(imembr.gt.0) then
      if(.not.ma_push_get(mt_int,2*msa,'mm',l_mm,i_mm))
     + call md_abort('Failed to allocate memory for mm',me)
      if(.not.ma_push_get(mt_dbl,7*msm,'fm',l_fm,i_fm))
     + call md_abort('Failed to allocate memory for fm',me)
      endif
c
c     retrieve current coordinates for this node
c     ------------------------------------------
c
      call argos_space_setup(me,int_mb(i_iw),dbl_mb(i_xw),
     + dbl_mb(i_xwcr),
     + dbl_mb(i_vw),dbl_mb(i_gw),nwmloc,
     + int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_xscr),dbl_mb(i_vs),
     + dbl_mb(i_gs),nsaloc,lpack)
      call argos_space_update_i(nsaloc,int_mb(i_is),nwmloc,int_mb(i_iw))
c
c     initialize packing
c     ------------------
c
      if(lpack)
     + call argos_space_pack_init(int_mb(i_is),nsaloc,int_mb(i_iw),
     + nwmloc)
c
c     spacial decomposition
c     ---------------------
c
      call argos_space_travel(box,dbl_mb(i_xw),dbl_mb(i_vw),
     + dbl_mb(i_xwcr),
     + dbl_mb(i_gw),int_mb(i_iw),nwmloc,dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_gs),int_mb(i_is),nsaloc)
c
c     calculate mass factors
c     ----------------------
c
      call argos_cafe_weight(nwmloc,nsaloc,int_mb(i_is+(lsatt-1)*msa),
     + int_mb(i_is+(lsmol-1)*msa),int_mb(i_is+(lshop-1)*msa),wbox)
c
c     calculate centers of mass
c     -------------------------
c
      call argos_cafe_cenmas(nwmloc,dbl_mb(i_xw),dbl_mb(i_xwm),nsaloc,
     + int_mb(i_is+(lsatt-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_gsm))
c
c     fix
c     ------------
c
      if(me.eq.0.and.numfix.gt.0) then
      open(unit=lfncmd,file=filcmd(1:index(filcmd,' ')-1),
     + form='formatted',status='old')
      rewind(lfncmd)
      endif
      call argos_cafe_fix(lfnout,lfncmd,numfix,
     + int_mb(i_iw+(lwgmn-1)*mwm),
     + int_mb(i_iw+(lwdyn-1)*mwm),nwmloc,
     + int_mb(i_is+(lsgan-1)*msa),int_mb(i_is+(lsatt-1)*msa),
     + int_mb(i_is+(lsdyn-1)*msa),int_mb(i_is+(lssgm-1)*msa),nsaloc,
     + dbl_mb(i_xwm),dbl_mb(i_xs))
      if(me.eq.0.and.numfix.gt.0) then
      close(unit=lfncmd)
      endif
      call argos_space_update_i(nsaloc,int_mb(i_is),nwmloc,int_mb(i_iw))
c
c     print decomposition information
c     -------------------------------
c
      call argos_space_print()
c
      call argos_prop_setup(wbox)
c
c     write file headers
c     ------------------
c
      if(me.eq.0.and.ntype.ne.3) then
      if(nfcoor.gt.0.or.nfscoo.gt.0.or.nfvelo.gt.0.or.nfsvel.gt.0)
     + call argos_cafe_trjhdr(lfntrj)
      endif
c
      if(npg.gt.1.and.me.eq.0) then
c      root=filnam(1:ibl)//gid
c      filrst=filnam(1:ibl)//gid//'.rst'
c      rfile=filrst
      filrst=rfile
      endif
c
      if(.not.ma_verify_allocator_stuff())
     + call md_abort('ma problems at end of argos_start',me)
      return
      end

      subroutine smd_comp_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
c     
      character*(smd_string_size) namespace

      namespace = "component"
      call smd_namespace_create(namespace)
      return
      end

      subroutine smd_system_set_component(aname,sp_name)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_const_data.fh"
c     
      character*(*) aname
      character*(*) sp_name
c
      character*(smd_string_size) namespace
      character*(smd_string_size) pname,tag
      integer nrec
      integer i
      logical result
      logical ocase
c
      pname = "smd_system_set_component"
c
      namespace = "component"
c
c      write(*,*) "in "//pname
c
      call smd_data_put_string(namespace,aname,1,sp_name)
c
      return
      end

      subroutine smd_system_get_component(aname,sp_name,result)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_const_data.fh"
c     
      character*(*) aname
      character*(*) sp_name
      logical result
c
      character*(smd_string_size) namespace
      character*(smd_string_size) pname,tag
      integer nrec
      integer i
      logical ocase
c
      pname = "smd_system_set_component"
c
      namespace = "component"
c
c      write(*,*) "in "//pname
c
      call smd_data_get_string(namespace,sp_name,1,aname,result)
c
      return
      end

      subroutine smd_system_unset_component(aname)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_const_data.fh"
c     
      character*(*) aname
      logical result
c
      character*(smd_string_size) namespace
      character*(smd_string_size) pname,tag
      integer nrec
      integer i
      logical ocase
c
      pname = "smd_system_set_component"
c
      namespace = "component"
c
c      write(*,*) "in "//pname
c
      call smd_data_destroy(namespace,aname,result)
c
      return
      end

      subroutine smd_system_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
c     
      integer un
c
      integer i
c
      character*30 pname
      pname = "smd_system_print"

      call smd_data_namespace_print("component",un)
c
      
      return
      end
c $Id: smd_system_data.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function pre_hybrid(xatm,latm,matm,natm,lbnd,mbnd,nbnd)
c
c $Id: pre_hybrid.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     in  : xatm(3,matm) = atomic coordinates
c         : latm(2,matm) = atomic numbers
c         : matm         = dimension of coordinate list
c         : natm         = number of atoms
c
      implicit none
c
      real*8 angl
      external angl
c
      integer matm,natm
      real*8 xatm(3,matm)
      integer latm(5,matm)
      integer mbnd,nbnd
      integer lbnd(2,mbnd)
c
      integer i,j,k,l,m,nn,nl(100),ia,ib,ic,id,ie,ig
      real*8 angle1,angle2,angle3,angle4,angle5,angle6
c
      do 1 i=1,natm
      if(latm(2,i).gt.0) then
      nn=0
      do 2 j=1,natm
      if(latm(2,j).gt.0.and.i.ne.j) then
      if(i.eq.j) goto 2
      do 6 k=1,nbnd
      if((lbnd(1,k).eq.i.and.lbnd(2,k).eq.j).or.
     + (lbnd(1,k).eq.j.and.lbnd(2,k).eq.i)) then
      nn=nn+1
      nl(nn)=j
      goto 2
      endif
    6 continue
      endif
    2 continue
      latm(3,i)=0
      if(nn.eq.1) then
      if(latm(2,i).eq.7) latm(3,i)=4
      elseif(nn.eq.2) then
      angle1=angl(xatm(1,nl(1)),xatm(1,i),xatm(1,nl(2)))
      ia=0
      if(angle1.ge.1.48d0.and.angle1.lt.1.66d0) ia=6
      if(angle1.ge.1.83d0.and.angle1.lt.2.01d0) ia=4
      if(angle1.ge.2.01d0.and.angle1.lt.2.18d0) ia=3
      if(angle1.ge.2.96d0.and.angle1.lt.3.15d0) ia=2
      latm(3,i)=ia
      if(latm(2,i).eq.7) latm(3,i)=3
      if(latm(2,i).eq.8) latm(3,i)=2
      elseif(nn.eq.3) then
      angle1=angl(xatm(1,nl(1)),xatm(1,i),xatm(1,nl(2)))
      ia=0
      if(angle1.ge.1.48d0.and.angle1.lt.1.66d0) ia=6
      if(angle1.ge.1.83d0.and.angle1.lt.2.01d0) ia=4
      if(angle1.ge.2.01d0.and.angle1.lt.2.18d0) ia=3
      if(angle1.ge.2.96d0.and.angle1.lt.3.15d0) ia=2
      angle2=angl(xatm(1,nl(1)),xatm(1,i),xatm(1,nl(3)))
      ib=0
      if(angle2.ge.1.48d0.and.angle2.lt.1.66d0) ib=6
      if(angle2.ge.1.83d0.and.angle2.lt.2.01d0) ib=4
      if(angle2.ge.2.01d0.and.angle2.lt.2.18d0) ib=3
      if(angle2.ge.2.96d0.and.angle2.lt.3.15d0) ib=2
      angle3=angl(xatm(1,nl(2)),xatm(1,i),xatm(1,nl(3)))
      ic=0
      if(angle3.ge.1.48d0.and.angle3.lt.1.66d0) ic=6
      if(angle3.ge.1.83d0.and.angle3.lt.2.01d0) ic=4
      if(angle3.ge.2.01d0.and.angle3.lt.2.18d0) ic=3
      if(angle3.ge.2.96d0.and.angle3.lt.3.15d0) ic=2
      if(ia.eq.ib.and.ib.eq.ic) latm(3,i)=ia
      latm(3,i)=4
      if(angle1+angle2+angle3.gt.6.0) latm(3,i)=3
      elseif(nn.eq.4) then
      angle1=angl(xatm(1,nl(1)),xatm(1,i),xatm(1,nl(2)))
      ia=0
      if(angle1.ge.1.48d0.and.angle1.lt.1.66d0) ia=6
      if(angle1.ge.1.83d0.and.angle1.lt.2.01d0) ia=4
      if(angle1.ge.2.01d0.and.angle1.lt.2.18d0) ia=3
      if(angle1.ge.2.96d0.and.angle1.lt.3.15d0) ia=2
      angle2=angl(xatm(1,nl(1)),xatm(1,i),xatm(1,nl(3)))
      ib=0
      if(angle2.ge.1.48d0.and.angle2.lt.1.66d0) ib=6
      if(angle2.ge.1.83d0.and.angle2.lt.2.01d0) ib=4
      if(angle2.ge.2.01d0.and.angle2.lt.2.18d0) ib=3
      if(angle2.ge.2.96d0.and.angle2.lt.3.15d0) ib=2
      angle3=angl(xatm(1,nl(1)),xatm(1,i),xatm(1,nl(4)))
      ic=0
      if(angle3.ge.1.48d0.and.angle3.lt.1.66d0) ic=6
      if(angle3.ge.1.83d0.and.angle3.lt.2.01d0) ic=4
      if(angle3.ge.2.01d0.and.angle3.lt.2.18d0) ic=3
      if(angle3.ge.2.96d0.and.angle3.lt.3.15d0) ic=2
      angle4=angl(xatm(1,nl(2)),xatm(1,i),xatm(1,nl(3)))
      id=0
      if(angle4.ge.1.48d0.and.angle4.lt.1.66d0) id=6
      if(angle4.ge.1.83d0.and.angle4.lt.2.01d0) id=4
      if(angle4.ge.2.01d0.and.angle4.lt.2.18d0) id=3
      if(angle4.ge.2.96d0.and.angle4.lt.3.15d0) id=2
      angle5=angl(xatm(1,nl(2)),xatm(1,i),xatm(1,nl(4)))
      ie=0
      if(angle5.ge.1.48d0.and.angle5.lt.1.66d0) ie=6
      if(angle5.ge.1.83d0.and.angle5.lt.2.01d0) ie=4
      if(angle5.ge.2.01d0.and.angle5.lt.2.18d0) ie=3
      if(angle5.ge.2.96d0.and.angle5.lt.3.15d0) ie=2
      angle6=angl(xatm(1,nl(3)),xatm(1,i),xatm(1,nl(4)))
      ig=0
      if(angle6.ge.1.48d0.and.angle6.lt.1.66d0) ig=6
      if(angle6.ge.1.83d0.and.angle6.lt.2.01d0) ig=4
      if(angle6.ge.2.01d0.and.angle6.lt.2.18d0) ig=3
      if(angle6.ge.2.96d0.and.angle6.lt.3.15d0) ig=2
      if(ia.eq.ib.and.ia.eq.ic.and.ia.eq.id.and.ia.eq.ie.and.ia.eq.ig)
     + latm(3,i)=ia
      if(latm(2,i).eq.6) latm(3,i)=4
      endif
      endif
    1 continue
c
c     sanity checks
c     -------------
c
      do 3 i=1,natm
      nn=0
      if(latm(2,i).gt.0) then
      do 4 j=1,natm
      if(latm(2,j).gt.0.and.i.ne.j) then
      if(i.eq.j) goto 4
      do 7 k=1,nbnd
      if((lbnd(1,k).eq.i.and.lbnd(2,k).eq.j).or.
     + (lbnd(1,k).eq.j.and.lbnd(2,k).eq.i)) then
      nn=nn+1
      nl(nn)=j
      goto 4
      endif
    7 continue
      endif
    4 continue
      endif
c
c     for following checks:
c 
c     latm(2,i) : atomic number of atom i
c     latm(3,i) : hybridization of atom i: number of neighboring atoms
c     nn        : number of non-hydrogen neighbors of atom i
c     nl(1:nn)  : id's of atoms nn non-hydrogen neighbors of atom i
c
c     c attached to peptide c should be methyl group
c
      if(latm(2,i).eq.6.and.nn.eq.3) then
      l=0
      m=0
      do 5 k=1,3
      if(latm(2,nl(k)).eq.8.and.latm(3,nl(k)).eq.1) l=l+1
      if(latm(2,nl(k)).eq.7.and.latm(3,nl(k)).eq.3) l=l+1
      if(latm(2,nl(k)).eq.6.and.latm(3,nl(k)).eq.0) then
      l=l+1
      m=k
      endif
    5 continue
      if(l.eq.3.and.m.ne.0) latm(3,nl(m))=4
      endif
c
c     c between saturated atoms must be saturated
c
      if(latm(2,i).eq.6.and.nn.eq.2) then
      if(latm(2,nl(1)).eq.6.and.latm(3,nl(1)).eq.4.and.
     + latm(2,nl(2)).eq.6.and.latm(3,nl(2)).eq.4) latm(3,i)=4
      endif
c
c     NH2-C(sp2)
c
      if(latm(2,i).eq.7.and.nn.eq.1) then
      if(latm(2,nl(1)).eq.6.and.latm(3,nl(1)).eq.3) latm(3,i)=3
      endif
c
c     N(sp2)-CH-N(sp2)
c
      if(latm(2,i).eq.6.and.nn.eq.2) then
      if(latm(2,nl(1)).eq.7.and.latm(3,nl(1)).eq.3.and.
     + latm(2,nl(2)).eq.7.and.latm(3,nl(2)).eq.3) latm(3,i)=3
      endif
c
    3 continue
c
      pre_hybrid=.true.
      return
      end

      subroutine argos_diana_select(sgmnam,isel,wt,x,numsel)
c
c $Id: argos_diana_select.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa)
      real*8 x(nsa,3)
      integer numsel
c
      integer i,j
      real*8 rtag,rtag2,r2
      character*80 target
      integer l_list,i_list
c
c     do selection on node 0
c
      if(me.eq.0) then
c
      read(card(11:80),1000) rtag,target
 1000 format(f12.6,a)
c
      if(.not.ma_push_get(mt_int,nsa,'list',l_list,i_list))
     + call md_abort('Failed to allocate list',0)
c
      call argos_diana_selection(sgmnam,nsa,target,int_mb(i_list))
c
      do 1 i=1,nsa
      if(int_mb(i_list-1+i).eq.1) then
      isel(i)=1
      if(rtag.gt.0.0d0) then
      rtag2=rtag*rtag
      do 2 j=1,nsa
      r2=(x(j,1)-x(i,1))**2+(x(j,2)-x(i,2))**2+(x(j,3)-x(i,3))**2
      if(r2.le.rtag2) isel(j)=1
    2 continue
      endif
      endif
    1 continue
c
      if(.not.ma_pop_stack(l_list))
     + call md_abort('Failed to deallocate list',0)
c
      endif
c
c     broadcast to all nodes
c
      if(np.gt.1) then
      call ga_brdcst(mag_d06,isel,nsa*ma_sizeof(mt_int,1,mt_byte),0)
      endif
c
      numsel=0
      do 6 i=1,nsa
      wt(i)=1.0d0
      if(isel(i).eq.0) wt(i)=0.0d0
      numsel=numsel+isel(i)
    6 continue
c
      return
      end

      subroutine hf2d_2b(
     &    Axyz,Aprims,Acoefs,NPA,NCA,La,ictra,
     &    Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    bERI,Nint,canAB,canCD,canPQ,dryrun,
     &    W0,maxW0)
C $Id: hf2d_2b.F 19696 2010-10-29 16:53:42Z d3y133 $
      Implicit None
      Logical canAB,canCD,canPQ,dryrun
      
c--> Cartesian Coordinates, Primitives & Contraction Coefficients
      
      Integer La, Lb, Lc, Ld, Nint, MaxW0
      Integer NPA, NCA, NPB, NCB, NPC, NCC, NPD, NCD
      Double Precision Axyz(3),Aprims(NPA),Acoefs(NPA,NCA)
      Double Precision Bxyz(3),Bprims(NPB),Bcoefs(NPB,NCB)
      Double Precision Cxyz(3),Cprims(NPC),Ccoefs(NPC,NCC)
      Double Precision Dxyz(3),Dprims(NPD),Dcoefs(NPD,NCD)
      Integer ictra,ictrb,ictrc,ictrd
c--> Block of Electron Repulsion Integrals
      
      Double Precision bERI(Nint,*)
      
c--> Scratch Space
      
      Double Precision W0(maxW0)
c
      integer npb1, npb2
      integer b_exp, b_cof
      integer maxw0new, k0s, icont, pw0, kaddint
      integer mem1, mem1add
      integer mem2, mem2add
c
      npb1  = npb/2
      if (mod(npb,2).eq.1) npb1 = npb1 + 1
      npb2  = npb - npb1        ! size of second block
c... do first block
      b_exp = 1                 ! exponent block
      b_cof = b_exp + npb1      ! coeff block
      k0s  = b_cof + npb1*NCB   ! start of scratch
      maxw0new = maxw0 - k0s    ! new scratch size

      mem1add = k0s             ! take care of compiler warnings
      mem1    = mem1add
      mem2add = mem1

      if (dryrun) then
        mem1add = k0s
      else
        call dcopy(npb1,Bprims,1,W0(b_exp),1) ! copy exponents
        do 00100 icont = 1,NCB
          pw0 = b_cof+(icont-1)*npb1
          call dcopy(npb1,Bcoefs(1,icont),1,W0(pw0),1) ! copy coeffs
00100   continue
      endif
c
      call hf2dold(
     &    Axyz,Aprims,Acoefs,NPA,NCA,La,ictra,
     &    Bxyz,W0(b_exp),W0(b_cof),NPB1,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    bERI,Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) mem1 = maxW0new + mem1add
c... do second block
      b_exp    = 1
      b_cof    = b_exp + npb2
      kaddint = b_cof + npb2*NCB
      k0s     = kaddint + 12*nint
      maxw0new = maxw0 - k0s
      if (dryrun) then
        mem2add = k0s
      else
        call dcopy(npb2,Bprims(npb1+1),1,W0(b_exp),1)
        do 00200 icont = 1,NCB
          pw0 = b_cof+(icont-1)*npb2
          call dcopy(npb2,Bcoefs((npb1+1),icont),1,W0(pw0),1)
00200   continue
      endif
      call hf2dold(
     &    Axyz,Aprims,Acoefs,NPA,NCA,La,ictra,
     &    Bxyz,W0(b_exp),W0(b_cof),NPB2,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    W0(kaddint),Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) then
        mem2 = maxw0new + mem2add
        maxw0 = max(mem1,mem2)
      else
c... sum both blocks
        call daxpy((nint*12),1.0d00,w0(kaddint),1,beri,1)
      endif
      end

*> \brief \b ZLAQR1 sets a scalar multiple of the first column of the product of 2-by-2 or 3-by-3 matrix H and specified shifts.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZLAQR1 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zlaqr1.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zlaqr1.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zlaqr1.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZLAQR1( N, H, LDH, S1, S2, V )
* 
*       .. Scalar Arguments ..
*       COMPLEX*16         S1, S2
*       INTEGER            LDH, N
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         H( LDH, * ), V( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>      Given a 2-by-2 or 3-by-3 matrix H, ZLAQR1 sets v to a
*>      scalar multiple of the first column of the product
*>
*>      (*)  K = (H - s1*I)*(H - s2*I)
*>
*>      scaling to avoid overflows and most underflows.
*>
*>      This is useful for starting double implicit shift bulges
*>      in the QR algorithm.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is integer
*>              Order of the matrix H. N must be either 2 or 3.
*> \endverbatim
*>
*> \param[in] H
*> \verbatim
*>          H is COMPLEX*16 array of dimension (LDH,N)
*>              The 2-by-2 or 3-by-3 matrix H in (*).
*> \endverbatim
*>
*> \param[in] LDH
*> \verbatim
*>          LDH is integer
*>              The leading dimension of H as declared in
*>              the calling procedure.  LDH.GE.N
*> \endverbatim
*>
*> \param[in] S1
*> \verbatim
*>          S1 is COMPLEX*16
*> \endverbatim
*>
*> \param[in] S2
*> \verbatim
*>          S2 is COMPLEX*16
*>
*>          S1 and S2 are the shifts defining K in (*) above.
*> \endverbatim
*>
*> \param[out] V
*> \verbatim
*>          V is COMPLEX*16 array of dimension N
*>              A scalar multiple of the first column of the
*>              matrix K in (*).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complex16OTHERauxiliary
*
*> \par Contributors:
*  ==================
*>
*>       Karen Braman and Ralph Byers, Department of Mathematics,
*>       University of Kansas, USA
*>
*  =====================================================================
      SUBROUTINE ZLAQR1( N, H, LDH, S1, S2, V )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      COMPLEX*16         S1, S2
      INTEGER            LDH, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         H( LDH, * ), V( * )
*     ..
*
*  ================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO
      PARAMETER          ( ZERO = ( 0.0d0, 0.0d0 ) )
      DOUBLE PRECISION   RZERO
      PARAMETER          ( RZERO = 0.0d0 )
*     ..
*     .. Local Scalars ..
      COMPLEX*16         CDUM, H21S, H31S
      DOUBLE PRECISION   S
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( DBLE( CDUM ) ) + ABS( DIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
      IF( N.EQ.2 ) THEN
         S = CABS1( H( 1, 1 )-S2 ) + CABS1( H( 2, 1 ) )
         IF( S.EQ.RZERO ) THEN
            V( 1 ) = ZERO
            V( 2 ) = ZERO
         ELSE
            H21S = H( 2, 1 ) / S
            V( 1 ) = H21S*H( 1, 2 ) + ( H( 1, 1 )-S1 )*
     $               ( ( H( 1, 1 )-S2 ) / S )
            V( 2 ) = H21S*( H( 1, 1 )+H( 2, 2 )-S1-S2 )
         END IF
      ELSE
         S = CABS1( H( 1, 1 )-S2 ) + CABS1( H( 2, 1 ) ) +
     $       CABS1( H( 3, 1 ) )
         IF( S.EQ.ZERO ) THEN
            V( 1 ) = ZERO
            V( 2 ) = ZERO
            V( 3 ) = ZERO
         ELSE
            H21S = H( 2, 1 ) / S
            H31S = H( 3, 1 ) / S
            V( 1 ) = ( H( 1, 1 )-S1 )*( ( H( 1, 1 )-S2 ) / S ) +
     $               H( 1, 2 )*H21S + H( 1, 3 )*H31S
            V( 2 ) = H21S*( H( 1, 1 )+H( 2, 2 )-S1-S2 ) + H( 2, 3 )*H31S
            V( 3 ) = H31S*( H( 1, 1 )+H( 3, 3 )-S1-S2 ) + H21S*H( 3, 2 )
         END IF
      END IF
      END
c $Id: zlaqr1.f 24343 2013-06-22 05:35:15Z d3y133 $

      block data initial_smd_energy_data
      implicit none
#include "smd_energy_data.fh"
c     
      data smd_energy_name /"total",
     c                      "kinetic",
     c                      "vdw",
     c                      "electrostatic",
     c                      "ewald self",
     c                      "ewald reciprocal",
     c                      "ewald excluded",
     c                      "ewald real"/


      end

      subroutine smd_energy_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_energy
      character*32 tag,pname
      logical result

      pname = "smd_energy_init_system"
c
      tag = "energy"
      call smd_system_get_component(sp_energy,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_energy_init(sp_energy)

      return
      end

      subroutine smd_energy_init(sp_energy)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_energy_data.fh"
c     
      character*(*) sp_energy
c
      character*32 pname
      integer na
c
      pname = "smd_energy_init"
c
c      write(*,*) "in "//pname
c
c     create energy data structures
c     ---------------------------
      call smd_namespace_create(sp_energy)
      call smd_data_create(sp_energy,"energy",smd_energy_nc,MT_DBL)
      call smd_data_create(sp_energy,"oenergy",smd_energy_nc,MT_LOG)
      return
      end

      subroutine smd_energy_set_component(aname,avalue)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_energy_data.fh"
c     
      character*(*) aname
      double precision avalue
c
      character*32 pname
      integer nrec
      integer i
      logical result
      logical ocase
      integer i_e
      integer i_oe
      character*32 sp_energy
      character*32 tag
c
      pname = "smd_energy_set_component"
c
      write(*,*) "in "//pname
c
      call smd_system_get_component(sp_energy,"energy",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no energy ',0,0)

      tag = "energy"
      call smd_data_get_index(sp_energy,tag,i_e,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "oenergy"
      call smd_data_get_index(sp_energy,tag,i_oe,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

c
c     case sensitive
      ocase = .true.
c
      nrec = smd_energy_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_energy_name,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      dbl_mb(i_e+i-1) = avalue
      log_mb(i_oe+i-1) = .true.
      
      return
      end

      subroutine smd_energy_unset_component(aname)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_energy_data.fh"
c     
      character*(*) aname
c
      character*32 pname
      integer nrec
      integer i
      logical result
      logical ocase
      integer i_e
      integer i_oe
      character*32 sp_energy
      character*32 tag
cc
      pname = "smd_energy_set_component"
c
      write(*,*) "in "//pname
c
      call smd_system_get_component(sp_energy,"energy",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no energy ',0,0)

      tag = "energy"
      call smd_data_get_index(sp_energy,tag,i_e,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "oenergy"
      call smd_data_get_index(sp_energy,tag,i_oe,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     case sensitive
      ocase = .true.
c
      nrec = smd_energy_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_energy_name,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      log_mb(i_oe+i-1) = .false. 
      dbl_mb(i_e+i-1) = 0.0d0
      
      return
      end

      subroutine smd_energy_get_component(avalue,aname,oexist)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_energy_data.fh"
c     
      character*(*) aname
      double precision avalue
c
      character*32 pname
      integer nrec
      integer i
      logical oexist,result
      logical ocase
      integer i_e
      integer i_oe
      character*32 sp_energy
      character*32 tag
c
      pname = "smd_energy_get_component"
c
      write(*,*) "in "//pname
c
      call smd_system_get_component(sp_energy,"energy",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no energy ',0,0)

      tag = "energy"
      call smd_data_get_index(sp_energy,tag,i_e,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "oenergy"
      call smd_data_get_index(sp_energy,tag,i_oe,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     case sensitive
      ocase = .true.
c
      nrec = smd_energy_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_energy_name,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      avalue = dbl_mb(i_e+i-1)
      oexist = log_mb(i_oe+i-1)
      
      return
      end

      subroutine smd_energy_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_energy_data.fh"
c     
      integer un
c
      character*32 pname
      integer nrec
      integer i
      logical oexist,result
      logical ocase
      integer i_e
      integer i_oe
      character*32 sp_energy
      character*32 tag
c
      pname = "smd_energy_print"
c
      write(*,*) "in "//pname
c
      call smd_system_get_component(sp_energy,"energy",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no energy ',0,0)

      tag = "energy"
      call smd_data_get_index(sp_energy,tag,i_e,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "oenergy"
      call smd_data_get_index(sp_energy,tag,i_oe,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      do i=1,smd_energy_nc
        oexist = log_mb(i_oe+i-1)
        if(oexist)
     >     write(un,'(A16," : ", F12.6)') 
     >     smd_energy_name(i),dbl_mb(i_e+i-1)
      end do
      write(91,*) dbl_mb(i_e),dbl_mb(i_e+3),dbl_mb(i_e+2)
     
      return
      end

      subroutine smd_energy_compute()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_energy_data.fh"
c     
      integer un
c
      character*32 pname
      integer nrec
      integer i
      logical oexist,result
      logical ocase
      integer i_e
      integer i_oe
      character*32 sp_energy
      character*32 tag
c
      pname = "smd_energy_compute"
c
      write(*,*) "in "//pname
c
      call smd_system_get_component(sp_energy,"energy",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no energy ',0,0)

      tag = "energy"
      call smd_data_get_index(sp_energy,tag,i_e,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      tag = "oenergy"
      call smd_data_get_index(sp_energy,tag,i_oe,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      dbl_mb(i_e+3) = 0.0d0
      do i=5,8
          dbl_mb(i_e+3) = dbl_mb(i_e+3)+ dbl_mb(i_e+i-1)
      end do
      log_mb(i_oe+3) = .true.

      dbl_mb(i_e) = 0.0d0
      do i=2,4
          dbl_mb(i_e) = dbl_mb(i_e)+ dbl_mb(i_e+i-1)
      end do
      log_mb(i_oe) = .true.
      
      return
      end

c $Id: smd_energy.F 22502 2012-05-20 06:11:57Z d3y133 $

c     $Id: et_2e.F 19708 2010-10-29 18:04:21Z d3y133 $
      subroutine et_2e(rtdb,nbf,basis,geom,max2e,mem2,tol2e,
     &                 g_pa,g_pb,omega2)
      implicit none
#include "errquit.fh"
c
c     calculates the two-electron contribution to Vba, omega2
c
c     nbf, basis, geom                                          [input]
c     max2e, mem2 (for int_2e4c)                                [input]
c     g_pa, g_pb (handles for alpha and beta densities)         [input]
c     omega2 (two electron contrib to Vab)                      [output]
c
#include "rtdb.fh"
#include "schwarz.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "apiP.fh"
#include "bas.fh"
#include "geom.fh"
#include "msgids.fh"   
#include "stdio.fh"   
c
      integer lpa_ij, kpa_ij, lpa_kl, kpa_kl, lpa_ji, kpa_ji
      integer lpa_lk, kpa_lk, lpa_il, kpa_il, lpa_kj, kpa_kj
      integer lpa_jl, kpa_jl, lpa_ki, kpa_ki, lpa_ik, kpa_ik
      integer lpa_lj, kpa_lj, lpa_jk, kpa_jk, lpa_li, kpa_li
      integer lpb_ij, kpb_ij, lpb_kl, kpb_kl, lpb_ji, kpb_ji
      integer lpb_lk, kpb_lk, lpb_il, kpb_il, lpb_kj, kpb_kj
      integer lpb_jl, kpb_jl, lpb_ki, kpb_ki, lpb_ik, kpb_ik
      integer lpb_lj, kpb_lj, lpb_jk, kpb_jk, lpb_li, kpb_li
      integer rtdb
      integer g_pa,g_pb
      integer nbf, geom, basis,max2e, mem2
      integer l_gJ, k_gJ, l_scr, k_scr, l_den, k_den
      integer ish, jsh, ksh, lsh, nsh
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      integer nproc, blen, max_sh_bf
      integer maxlsh, shellnum, ng, numi, numj
      double precision omega2, omega2_val
      integer nxtask, next
      external nxtask
      double precision smax, sij, skl
      double precision norm, G(10000), dij
      double precision tol2e
      double precision dabsmax, adenmax,bdenmax
      external  dabsmax
c     -------------------------------------------     
c     find the maximum value of the alpha density
c     -------------------------------------------     
c
      call ga_distribution(g_pa,ga_nodeid(),ilo,ihi,jlo,jhi)   
      numi=ihi-ilo+1
      numj=jhi-jlo+1
c
        if (.not.ma_push_get(MT_DBL,numi*numj,'temp dens',l_den,k_den))
     $  call errquit('et_2e:ma_push_get failed for temp dens',k_den,
     &       MA_ERR)
        call dfill(numi*numj, 0.0d0, dbl_mb(k_den), 1)
c
        call ga_get(g_pa, ilo, ihi, jlo, jhi, dbl_mb(k_den),1)
        adenmax = dabsmax(numi*numj,dbl_mb(k_den))
c
        call ga_sync()
c
        call ga_dgop(msg_et_adens,adenmax,1,'max')
c
c     -------------------------------------------     
c     find the maximum value of the beta density
c     -------------------------------------------     
c
      call ga_distribution(g_pb,ga_nodeid(),ilo,ihi,jlo,jhi)   
      numi=ihi-ilo+1
      numj=jhi-jlo+1
c
        call dfill(numi*numj, 0.0d0, dbl_mb(k_den), 1)
c
        call ga_get(g_pb, ilo, ihi, jlo, jhi, dbl_mb(k_den),1)
        bdenmax = dabsmax(numi*numj,dbl_mb(k_den))
c
        if (.not. ma_pop_stack(l_den)) call errquit('et_2e: pop',1,
     &       MA_ERR)
c
        call ga_sync()
c
        call ga_dgop(msg_et_bdens,bdenmax,1,'max')
c
c     -------------------------------------------------
c     initialize omega2 and establish 2e and scr arrays
c     -------------------------------------------------
c     
      omega2 = 0.0d0
c     
      if (.not.ma_push_get(MT_DBL, max2e, '2e buffer', l_gJ, k_gJ))
     $     call errquit('et_2e:ma_push_get failed for 2e J buffer',k_gJ,
     &       MA_ERR)
c     
      if (.not.ma_push_get(MT_DBL, mem2, '2e scr', l_scr, k_scr))
     $     call errquit('et_2e:ma_push_get failed for 2e scratch',k_scr,
     &       MA_ERR)
c     
c     ------------------
c     get basis set info
c     ------------------
c     
      if (.not. bas_numcont(basis, nsh)) call errquit
     $     ('et_2e: bas_numcont failed', basis, BASIS_ERR)
c     
      if (.not. bas_nbf_cn_max(basis,max_sh_bf))
     $     call errquit('et_2e: could not get max_sh_bf',0, BASIS_ERR)

      blen = min(nbf,36,6*max_sh_bf) ! d(6)*6=36, 6**4=1296 quartets
c
c     ----------------------------------
c     set and print screening parameters
c     ----------------------------------
c
      call schwarz_init(geom, basis)
      smax = schwarz_max() 
      dij = max(adenmax*adenmax,bdenmax*bdenmax)
c
 1212 format (1x,a30,1x,a1,1pE14.4)
      if (ga_nodeid().eq.0) then
      write(LuOut,*)
      write(LuOut,*)'Start two-electron contribution,  H2(RP)...'
      write(LuOut,1212)'Density screening tolerance   ',':',dij
      write(LuOut,1212)'Largest two-electron integral ',':',smax
      write(LuOut,1212)'Integral screening threshold  ',':',tol2e
      write(LuOut,*)
      endif
c
c     ---------------------------------
c     allocate temporary density arrays
c     ---------------------------------
c
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_ij', lpa_ij, kpa_ij))
     $     call errquit('et_2e:could not allocate lpa_ij',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_kl', lpa_kl, kpa_kl))
     $     call errquit('et_2e:could not allocate lpa_kl',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_ji', lpa_ji, kpa_ji))
     $     call errquit('et_2e:could not allocate lpa_ji',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_lk', lpa_lk, kpa_lk))
     $     call errquit('et_2e:could not allocate lpa_lk',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_il', lpa_il, kpa_il))
     $     call errquit('et_2e:could not allocate lpa_il',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_kj', lpa_kj, kpa_kj))
     $     call errquit('et_2e:could not allocate lpa_kj',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_jl', lpa_jl, kpa_jl))
     $     call errquit('et_2e:could not allocate lpa_jl',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_ki', lpa_ki, kpa_ki))
     $     call errquit('et_2e:could not allocate lpa_ki',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_ik', lpa_ik, kpa_ik))
     $     call errquit('et_2e:could not allocate lpa_ik',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_lj', lpa_lj, kpa_lj))
     $     call errquit('et_2e:could not allocate lpa_lj',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_jk', lpa_jk, kpa_jk))
     $     call errquit('et_2e:could not allocate lpa_jk',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pa_li', lpa_li, kpa_li))
     $     call errquit('et_2e:could not allocate lpa_li',0, MA_ERR)
c
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_ij', lpb_ij, kpb_ij))
     $     call errquit('et_2e:could not allocate lpb_ij',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_kl', lpb_kl, kpb_kl))
     $     call errquit('et_2e:could not allocate lpb_kl',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_ji', lpb_ji, kpb_ji))
     $     call errquit('et_2e:could not allocate lpb_ji',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_lk', lpb_lk, kpb_lk))
     $     call errquit('et_2e:could not allocate lpb_lk',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_il', lpb_il, kpb_il))
     $     call errquit('et_2e:could not allocate lpb_il',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_kj', lpb_kj, kpb_kj))
     $     call errquit('et_2e:could not allocate lpb_kj',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_jl', lpb_jl, kpb_jl))
     $     call errquit('et_2e:could not allocate lpb_jl',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_ki', lpb_ki, kpb_ki))
     $     call errquit('et_2e:could not allocate lpb_ki',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_ik', lpb_ik, kpb_ik))
     $     call errquit('et_2e:could not allocate lpb_ik',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_lj', lpb_lj, kpb_lj))
     $     call errquit('et_2e:could not allocate lpb_lj',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_jk', lpb_jk, kpb_jk))
     $     call errquit('et_2e:could not allocate lpb_jk',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, blen*blen, 'pb_li', lpb_li, kpb_li))
     $     call errquit('et_2e:could not allocate lpb_li',0, MA_ERR)
c
c     ----------------------     
c     begin loop over shells
c     ----------------------     
c     
      call ga_sync()
      shellnum = 0
      nproc = ga_nnodes()
      next = nxtask(nproc,1)
c
      do ish = nsh, 1, -1
         if (.not. bas_cn2bfr(basis, ish, ilo, ihi))
     $        call errquit('et_2e: bas_cn2bfr', ish, BASIS_ERR)
c     
         do jsh = ish, 1, -1
            if (.not. bas_cn2bfr(basis, jsh, jlo, jhi))
     $           call errquit('et_2e: bas_cn2bfr', jsh, BASIS_ERR)
c
              sij = schwarz_shell(ish,jsh)
                if (sij*smax*dij .gt. tol2e) then
c     
               do ksh = ish, 1, -1
                  if (.not. bas_cn2bfr(basis, ksh, klo, khi))
     $                 call errquit('et_2e: bas_cn2bfr', ksh, BASIS_ERR)
c     
                  maxlsh = ksh
                  if (ksh.EQ.ish) maxlsh = jsh
                  do lsh = maxlsh, 1, -1
                     if (.not. bas_cn2bfr(basis, lsh, llo, lhi))
     $                 call errquit('et_2e: bas_cn2bfr', lsh, BASIS_ERR)
c
                   if (shellnum.eq.next) then
c
                     skl = schwarz_shell(ksh,lsh)      
c
                   call ga_get(g_pa,ilo,ihi,jlo,jhi,dbl_mb(kpa_ij),blen)
                   call ga_get(g_pa,klo,khi,llo,lhi,dbl_mb(kpa_kl),blen)
                   call ga_get(g_pa,jlo,jhi,ilo,ihi,dbl_mb(kpa_ji),blen)
                   call ga_get(g_pa,llo,lhi,klo,khi,dbl_mb(kpa_lk),blen)
                   call ga_get(g_pa,ilo,ihi,llo,lhi,dbl_mb(kpa_il),blen)
                   call ga_get(g_pa,klo,khi,jlo,jhi,dbl_mb(kpa_kj),blen)
                   call ga_get(g_pa,jlo,jhi,llo,lhi,dbl_mb(kpa_jl),blen)
                   call ga_get(g_pa,klo,khi,ilo,ihi,dbl_mb(kpa_ki),blen)
                   call ga_get(g_pa,ilo,ihi,klo,khi,dbl_mb(kpa_ik),blen)
                   call ga_get(g_pa,llo,lhi,jlo,jhi,dbl_mb(kpa_lj),blen)
                   call ga_get(g_pa,jlo,jhi,klo,khi,dbl_mb(kpa_jk),blen)
                   call ga_get(g_pa,llo,lhi,ilo,ihi,dbl_mb(kpa_li),blen)
                   call ga_get(g_pb,ilo,ihi,jlo,jhi,dbl_mb(kpb_ij),blen)
                   call ga_get(g_pb,klo,khi,llo,lhi,dbl_mb(kpb_kl),blen)
                   call ga_get(g_pb,jlo,jhi,ilo,ihi,dbl_mb(kpb_ji),blen)
                   call ga_get(g_pb,llo,lhi,klo,khi,dbl_mb(kpb_lk),blen)
                   call ga_get(g_pb,ilo,ihi,llo,lhi,dbl_mb(kpb_il),blen)
                   call ga_get(g_pb,klo,khi,jlo,jhi,dbl_mb(kpb_kj),blen)
                   call ga_get(g_pb,jlo,jhi,llo,lhi,dbl_mb(kpb_jl),blen)
                   call ga_get(g_pb,klo,khi,ilo,ihi,dbl_mb(kpb_ki),blen)
                   call ga_get(g_pb,ilo,ihi,klo,khi,dbl_mb(kpb_ik),blen)
                   call ga_get(g_pb,llo,lhi,jlo,jhi,dbl_mb(kpb_lj),blen)
                   call ga_get(g_pb,jlo,jhi,klo,khi,dbl_mb(kpb_jk),blen)
                   call ga_get(g_pb,llo,lhi,ilo,ihi,dbl_mb(kpb_li),blen)
c
                        call dens_prod(nbf,
     $                    ilo,ihi,jlo,jhi,klo,khi,llo,lhi, 
     $                    ish,jsh,ksh,lsh, norm,G,ng,blen,
     $                    dbl_mb(kpa_ij),dbl_mb(kpa_kl),dbl_mb(kpa_ji),
     $                    dbl_mb(kpa_lk),dbl_mb(kpa_il),dbl_mb(kpa_kj),
     $                    dbl_mb(kpa_jl),dbl_mb(kpa_ki),dbl_mb(kpa_ik),
     $                    dbl_mb(kpa_lj),dbl_mb(kpa_jk),dbl_mb(kpa_li),
     $                    dbl_mb(kpb_ij),dbl_mb(kpb_kl),dbl_mb(kpb_ji),
     $                    dbl_mb(kpb_lk),dbl_mb(kpb_il),dbl_mb(kpb_kj),
     $                    dbl_mb(kpb_jl),dbl_mb(kpb_ki),dbl_mb(kpb_ik),
     $                    dbl_mb(kpb_lj),dbl_mb(kpb_jk),dbl_mb(kpb_li))
c
                        if (sij*skl*smax*norm.gt.tol2e) then
c
                           call int_2e4c(basis, ish, jsh, basis, 
     $                          ksh, lsh, mem2, dbl_mb(k_scr), max2e, 
     $                          dbl_mb(k_gJ))
c     
                           call omega2_mult(ilo,ihi,jlo,jhi,
     &                          klo,khi,llo,lhi,
     &                          ish,jsh,ksh,lsh,
     &                          G,ng,dbl_mb(k_gJ),omega2_val)
c
                           omega2 = omega2 + omega2_val
c     
                       endif  !norm screening
                   next = nxtask(nproc,1)
                   endif   !shellnum
                   shellnum = shellnum + 1
                  enddo
               enddo
            endif  !sij x smax
         enddo
      enddo
c     
      next = nxtask(-nproc,1)
      call ga_sync()
c     
      call ga_dgop(msg_et_2e,omega2,1,'+')
c     
c     destroy arrays
c     ==============
      call schwarz_tidy()
c     
      if (.not. ma_pop_stack(lpb_li)) call errquit('et_2e: pop',1,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_jk)) call errquit('et_2e: pop',2,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_lj)) call errquit('et_2e: pop',3,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_ik)) call errquit('et_2e: pop',4,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_ki)) call errquit('et_2e: pop',5,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_jl)) call errquit('et_2e: pop',6,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_kj)) call errquit('et_2e: pop',7,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_il)) call errquit('et_2e: pop',8,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_lk)) call errquit('et_2e: pop',9,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_ji)) call errquit('et_2e: pop',10,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_kl)) call errquit('et_2e: pop',11,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpb_ij)) call errquit('et_2e: pop',12,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_li)) call errquit('et_2e: pop',13,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_jk)) call errquit('et_2e: pop',14,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_lj)) call errquit('et_2e: pop',15,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_ik)) call errquit('et_2e: pop',16,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_ki)) call errquit('et_2e: pop',17,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_jl)) call errquit('et_2e: pop',18,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_kj)) call errquit('et_2e: pop',19,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_il)) call errquit('et_2e: pop',20,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_lk)) call errquit('et_2e: pop',21,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_ji)) call errquit('et_2e: pop',22,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_kl)) call errquit('et_2e: pop',23,
     &       MA_ERR)
      if (.not. ma_pop_stack(lpa_ij)) call errquit('et_2e: pop',24,
     &       MA_ERR)
      if (.not. ma_pop_stack(l_scr)) call errquit('et_2e: pop',25,
     &       MA_ERR)
      if (.not. ma_pop_stack(l_gJ))  call errquit('et_2e: pop',26,
     &       MA_ERR)
c
c
      return
      end

      function task_smd(rtdb)
      implicit none
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"
      integer rtdb
      logical task_smd
c
      character*40 operation
      character*40 pname
c
      pname = " task_smd"

      if (.not. rtdb_cget(rtdb,'task:operation', 1,operation))
     $      call errquit(pname,0, RTDB_ERR)

      write(*,*) "found operation",operation
      write(*,*) "Goodbye from task_smd"
      task_smd = .true.
      return
      END
c $Id: task_smd.F 22502 2012-05-20 06:11:57Z d3y133 $

c     $Id: pspw_energy.F 19707 2010-10-29 17:59:36Z d3y133 $
      logical function pspw_energy(rtdb)
      implicit none
      integer rtdb

      logical  cgsdv5
      external cgsdv5

      pspw_energy = cgsdv5(rtdb,0)
      return
      end

c
c $Id: psp_generator_input.F 24686 2013-10-23 00:23:24Z bylaska $
c

*     ***************************************
*     *					    *
*     *          psp_generator_input        *
*     *	  				    *
*     ***************************************
      subroutine psp_generator_input(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c

      integer rtdb
c
      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 35)
      integer NMAX              ! maximum wavfunctions
      parameter (NMAX = 100)
 
      character*30 dirs(num_dirs)
      character*255 test,dir_name,sdir_name

      character*255 pspgenerator
      character*4  element
      double precision charge
      double precision mass_number
      character*25  pseudopotential_type
      character*25  solver_type
      character*25  correlation_type
      character*25  exchange_type,semicore_type
      character*255 pseudopotential_filename
      integer number_core,number_valence
      integer n_number(NMAX)
      character l_char
      integer l_number(NMAX)
      real*8 filling(NMAX)
      real*8 rcut(10)
      integer max_rcut,l_rcut(10)
      real*8 rlocal,clocal
      integer vstates
      integer v_n(NMAX)
      integer v_l(NMAX)
      real*8  v_eig(NMAX)
      real*8  v_rcut(NMAX)
      real*8  r_semicore
      integer lmax00,locp00,efg00
      real*8  rlocal00,screening_cut

      character lmax,locp
      integer h,i,j,k,debug,print
      data dirs / 'element:',
     >            'charge:',
     >            'mass_number:',
     >            'pseudopotential_type:',
     >            'atomic_filling:',
     >            'cutoff:',
     >            'maximum_angular_momentum:',
     >            'pseudopotential_filename:',
     >            'solver_type:',
     >            'correlation_type:',
     >            'exchange_type:',
     >            'vanderbilt_local:',
     >            'vanderbilt_states:',
     >            'semicore_radius:',
     >            'element',
     >            'charge',
     >            'mass_number',
     >            'pseudopotential_type',
     >            'atomic_filling',
     >            'cutoff',
     >            'maximum_angular_momentum',
     >            'pseudopotential_filename',
     >            'solver_type',
     >            'correlation_type',
     >            'exchange_type',
     >            'vanderbilt_local',
     >            'vanderbilt_states',
     >            'semicore_radius',
     >            'lmax',
     >            'locp',
     >            'aperiodic_cutoff',
     >            'screening_cutoff',
     >            'semicore_type',
     >            'efg_type',
     >            'end'/



*     ***** initializations ****
      correlation_type     = 'vosko'
      exchange_type        = 'dirac'
      solver_type          = 'pauli'
      pseudopotential_type = 'hamann'
      element = 'H'
      charge = 1.0d0
      mass_number = 1.0d0
      number_core =0
      number_valence =1
      n_number(1) = 1
      l_number(1) = 0
      filling(1) = 1.0d0
      rlocal     = -1.0d0
      clocal     = 0.0d0
      vstates    = -1
      max_rcut = 0
      lmax = '?'
      locp = '?'
      r_semicore = -1.0d0
      semicore_type = 'fuchs'
      rlocal00  = 1.0d0
      screening_cut = 0.0d0
      efg00 = 0

 10   if (.not. inp_read()) 
     >     call errquit(
     >           'psp_generator_input: inp_read failed', 0, INPUT_ERR)
      if (.not. inp_a(test))
     >     call errquit(
     >           'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit(
     >           'psp_generator_input: unknown directive', 0, INPUT_ERR)


      goto ( 100,  200, 300, 400, 500, 600, 700,800,900,
     >       1000,1100,1200,1300,1400,
     >       100,  200, 300, 400, 500, 600, 700,800,900,
     >       1000,1100,1200,1300,1400,
     >       700,710,1500,1600,1450,1700,
     >      9999) ind
      call errquit(
     >      'psp_generator_input: unimplemented directive', ind,
     &       INPUT_ERR)


c     
c  element
c     
 100  if (.not. inp_a(element))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c charge
c
 200  if (.not. inp_f(charge))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c  mass_number
c 
 300  if (.not. inp_f(mass_number))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)

      goto 10

c
c  pseudopotential_type
c 
 400  if (.not. inp_a(pseudopotential_type))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10

c
c  atomic_filling
c 
 500  if (.not. inp_i(number_core))
     >     call errquit(
     >          'psp_generator_input: failed to read ncore', 0,
     &       INPUT_ERR)

      if (.not. inp_i(number_valence))
     >     call errquit(
     >          'psp_generator_input: failed to read nvalence', 0,
     &       INPUT_ERR)

      do i=1,(number_core+number_valence)
         if (.not. inp_read()) 
     >        call errquit(
     >           'psp_generator_input: inp_read failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(n_number(i)))
     >     call errquit(
     >          'psp_generator_input: inp_i(n_number) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_a(l_char))
     >     call errquit(
     >          'psp_generator_input: inp_i(l_char) failed', 0,
     &       INPUT_ERR)

           if (l_char.eq.'s') l_number(i) = 0
           if (l_char.eq.'p') l_number(i) = 1
           if (l_char.eq.'d') l_number(i) = 2
           if (l_char.eq.'f') l_number(i) = 3
           if (l_char.eq.'g') l_number(i) = 4
           if (l_char.eq.'S') l_number(i) = 0
           if (l_char.eq.'P') l_number(i) = 1
           if (l_char.eq.'D') l_number(i) = 2
           if (l_char.eq.'F') l_number(i) = 3
           if (l_char.eq.'G') l_number(i) = 4
           if (l_char.eq.'0') l_number(i) = 0
           if (l_char.eq.'1') l_number(i) = 1
           if (l_char.eq.'2') l_number(i) = 2
           if (l_char.eq.'3') l_number(i) = 3
           if (l_char.eq.'4') l_number(i) = 4

           if (.not. inp_f(filling(i)))
     >     call errquit(
     >          'psp_generator_input: inp_f(filling) failed', 0,
     &       INPUT_ERR)

      end do
      goto 10
 
c
c  cutoff 
c 
 600  if (.not. inp_i(max_rcut))
     >     call errquit(
     >          'psp_generator_input: failed to read max_rcut', 0,
     &       INPUT_ERR)

      do i=1,(max_rcut)
         if (.not. inp_read()) 
     >        call errquit(
     >           'psp_generator_input: inp_read failed', 0, INPUT_ERR)

           if (.not. inp_a(l_char))
     >     call errquit(
     >          'psp_generator_input: inp_i(l_char) failed', 0,
     &       INPUT_ERR)

           if (l_char.eq.'s') l_rcut(i) = 0
           if (l_char.eq.'p') l_rcut(i) = 1
           if (l_char.eq.'d') l_rcut(i) = 2
           if (l_char.eq.'f') l_rcut(i) = 3
           if (l_char.eq.'g') l_rcut(i) = 4
           if (l_char.eq.'S') l_rcut(i) = 0
           if (l_char.eq.'P') l_rcut(i) = 1
           if (l_char.eq.'D') l_rcut(i) = 2
           if (l_char.eq.'F') l_rcut(i) = 3
           if (l_char.eq.'G') l_rcut(i) = 4
           if (l_char.eq.'0') l_rcut(i) = 0
           if (l_char.eq.'1') l_rcut(i) = 1
           if (l_char.eq.'2') l_rcut(i) = 2
           if (l_char.eq.'3') l_rcut(i) = 3
           if (l_char.eq.'4') l_rcut(i) = 4
           if (.not. inp_f(rcut(i)))
     >     call errquit(
     >          'psp_generator_input: inp_f(rcut) failed', 0,
     &       INPUT_ERR)
      end do

      goto 10
 
 
c
c  maximum_angular_momentum - lmax
c 
 700  if (.not. inp_a(lmax))
     >     call errquit(
     >          'psp_generator_input: failed to read lmax', 0,
     &       INPUT_ERR)
      goto 10

c
c  local potential - locp
c 
 710  if (.not. inp_a(locp))
     >     call errquit(
     >          'psp_generator_input: failed to read locp',0,0)
      goto 10

 
c
c  pseudopotential_filename
c 
 800  if (.not. inp_a(pseudopotential_filename))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10

c
c  solver_type
c 
 900  if (.not. inp_a(solver_type))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10

c
c  correlation_type
c 
 1000 if (.not. inp_a(correlation_type))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10

c
c  exchange_type
c 
 1100 if (.not. inp_a(exchange_type))
     >     call errquit(
     >          'psp_generator_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c  vanderbilt_local
c 
 1200 if (.not. inp_f(rlocal))
     >     call errquit(
     >          'psp_generator_input: failed to read rlocal', 0,
     &       INPUT_ERR)
      if (.not. inp_f(clocal))
     >     call errquit(
     >          'psp_generator_input: failed to read clocal', 0,
     &       INPUT_ERR)
      goto 10


c
c  vanderbilt_states
c
 1300 if (.not. inp_i(vstates))
     >  call errquit(
     >   'psp_generator_input: failed to read vstates', 0,
     &       INPUT_ERR)
  
      do i=1,vstates
         if (.not. inp_read()) 
     >        call errquit(
     >           'psp_generator_input: inp_read failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(v_n(i)))
     >     call errquit(
     >          'psp_generator_input: inp_i(v_n) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_a(l_char))
     >     call errquit(
     >          'psp_generator_input: inp_i(l_char) failed', 0,
     &       INPUT_ERR)

           if (l_char.eq.'s') v_l(i) = 0
           if (l_char.eq.'p') v_l(i) = 1
           if (l_char.eq.'d') v_l(i) = 2
           if (l_char.eq.'f') v_l(i) = 3
           if (l_char.eq.'g') v_l(i) = 4
           if (l_char.eq.'S') v_l(i) = 0
           if (l_char.eq.'P') v_l(i) = 1
           if (l_char.eq.'D') v_l(i) = 2
           if (l_char.eq.'F') v_l(i) = 3
           if (l_char.eq.'G') v_l(i) = 4
           if (l_char.eq.'0') v_l(i) = 0
           if (l_char.eq.'1') v_l(i) = 1
           if (l_char.eq.'2') v_l(i) = 2
           if (l_char.eq.'3') v_l(i) = 3
           if (l_char.eq.'4') v_l(i) = 4

           if (.not. inp_f(v_eig(i)))
     >     call errquit(
     >          'psp_generator_input: inp_f(v_eig) failed', 0,
     &       INPUT_ERR)
         if (.not. inp_f(v_rcut(i)))
     >     call errquit(
     >          'psp_generator_input: inp_f(v_rcut) failed', 0,
     &       INPUT_ERR)
         
      end do

      goto 10
c
c  semicore_radius
c 
 1400 if (.not. inp_f(r_semicore))
     >     call errquit(
     >     'psp_generator_input: failed to read semicore_radius',0,
     &       INPUT_ERR)
      goto 10

c
c  semicore_type
c 
 1450 if (.not. inp_a(semicore_type))
     >     call errquit(
     >     'psp_generator_input: failed to read semicore_type',0,
     &       INPUT_ERR)
      goto 10
 
 
c
c  aperiodic cutoff radius
c 
 1500 if (.not. inp_f(rlocal00)) rlocal00 = 1.0d0
      goto 10
 
c
c  screening cutoff radius
c
 1600 if (.not. inp_f(screening_cut)) screening_cut = 0.0d0
      goto 10

c
c  efg_type
c
 1700 if (.not. inp_i(efg00)) efg00 = 1
      goto 10


*     ***** generate temporary data file  and run pspsolve ****
 9999 continue
      k = index(pseudopotential_filename,' ') -1
      pspgenerator = pseudopotential_filename(1:k)//'.generator'
      call util_file_name_noprefix(pspgenerator, 
     >                             .true.,
     >                             .false.,
     >                             test)
      h = index(test,' ')-1
      open(unit=17,file=test(1:h),form='formatted')
      write(17,*) "<atom>"
      write(17,*) element
      write(17,111) charge,mass_number,number_core,number_valence
 111  format(2E14.6,2I4)
      do i=1,(number_core+number_valence)
         write(17,112) n_number(i),l_number(i),filling(i)
      end do
 112  format(2I4,E14.6)
      write(17,*) "<end>"
      write(17,*) "<solver> ",solver_type," <end>"
      write(17,*) "<correlation>  ",correlation_type,"  <end>"
      write(17,*) "<exchange>     ",exchange_type,   "  <end>"
      write(17,*) "<pseudopotential> ",pseudopotential_type," <end>"
      if (r_semicore.gt. 0.0d0) then
        write(17,*) "<semicore> ",r_semicore," <end>" 
        write(17,*) "<semicore_type> ",semicore_type," <end>" 
      end if
      if (lmax.ne.'?') write(17,*) "<lmax> ",lmax," <end>"
      if (max_rcut.gt.0) then
         write(17,*) "<rcut>"
         do i=1,max_rcut
            write(17,113) l_rcut(i),rcut(i)
         end do
         write(17,*) "<end>"
      end if
 113  format(I4,E14.6)

      if (rlocal.gt.0.0) then
         write(17,*) "<vanderbilt-local>", rlocal,clocal," <end>"
      end if
      if (vstates.gt.0) then
         write(17,*) "<npsp-states>",vstates," <end>"
         write(17,*) "<vanderbilt-states>"
         do i=1,vstates
            write(17,114) (i-1),v_n(i),v_l(i),v_eig(i),v_rcut(i)
         end do
         write(17,*) "<end>"
      end if
 114  format(3I4,2E14.6)

      if (screening_cut.gt.0.0)
     >  write(17,*) "<screening_cut> ",screening_cut," <end>" 

      close(17)

      write(*,*) 
     >   ">>>> PSPW Serial Module - 1d pseudopotential solver <<<<"

      call util_directory_name(sdir_name,.true.,0)
      call util_directory_name(dir_name,.false.,0)
      h = index(sdir_name,' ') -1
      i = index(dir_name,' ') -1
      j = index(pspgenerator,' ')-1
      k = index(pseudopotential_filename,' ') -1

      debug = 1
      print = 1
      lmax00   = -1
      if (lmax.eq.'s') lmax00 = 0
      if (lmax.eq.'p') lmax00 = 1
      if (lmax.eq.'d') lmax00 = 2
      if (lmax.eq.'f') lmax00 = 3
      if (lmax.eq.'g') lmax00 = 4
      if (lmax.eq.'S') lmax00 = 0
      if (lmax.eq.'P') lmax00 = 1
      if (lmax.eq.'D') lmax00 = 2
      if (lmax.eq.'F') lmax00 = 3
      if (lmax.eq.'G') lmax00 = 4
      if (lmax.eq.'0') lmax00 = 0
      if (lmax.eq.'1') lmax00 = 1
      if (lmax.eq.'2') lmax00 = 2
      if (lmax.eq.'3') lmax00 = 3
      if (lmax.eq.'4') lmax00 = 4

      locp00   = -1
      if (locp.eq.'s') locp00 = 0
      if (locp.eq.'p') locp00 = 1
      if (locp.eq.'d') locp00 = 2
      if (locp.eq.'f') locp00 = 3
      if (locp.eq.'g') locp00 = 4
      if (locp.eq.'S') locp00 = 0
      if (locp.eq.'P') locp00 = 1
      if (locp.eq.'D') locp00 = 2
      if (locp.eq.'F') locp00 = 3
      if (locp.eq.'G') locp00 = 4
      if (locp.eq.'0') locp00 = 0
      if (locp.eq.'1') locp00 = 1
      if (locp.eq.'2') locp00 = 2
      if (locp.eq.'3') locp00 = 3
      if (locp.eq.'4') locp00 = 4

      !rlocal00 = 1.0d0 ! 
      call pspsolve(print,debug,
     >              lmax00,locp00,rlocal00,efg00,
     >              sdir_name(1:h),   h,
     >              dir_name(1:i),    i,
     >              pspgenerator(1:j),j,
     >              pseudopotential_filename(1:k),k)
      call nwpw_message(4) 

c      write(6,*)"done with psp gen pspsolve!"
c      call flush(6)

      return
      end

*     ***************************************
*     *					    *
*     *          psp_generator_auto         *
*     *					    *
*     ***************************************
      subroutine psp_generator_auto(iopt,atom,lmax,locp,rlocal)
      implicit none

#include "inp.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "stdio.fh"

      integer iopt
      character*4 atom
      double precision rlocal
      integer	    locp,lmax
c
      integer MASTER,taskid,msglen
      parameter (MASTER=0)

      logical value,hprint
      character*255 dir_name,sdir_name
      character*16 psp_in,psp_out
      integer h,i,j,k,ka,debug,psp_type,print,efg_type
      character ch_tmp

*     **** external functions ****
      logical  control_print
      integer  nwpw_libglmax,nwpw_libglocp,control_gga
      integer  nwpw_libgpsp_type
      integer  nwpw_libgefg_type
      double precision nwpw_libgrlocal
      external control_print
      external nwpw_libglmax,nwpw_libglocp,control_gga
      external nwpw_libgpsp_type
      external nwpw_libgefg_type
      external nwpw_libgrlocal
c
      call Parallel_taskid(taskid)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)

      value = rtdb_parallel(.false.)
      if (taskid.eq.MASTER) then

      call util_directory_name(sdir_name,.true.,0)
      call util_directory_name(dir_name,.false.,0)
      h = index(sdir_name,' ') - 1
      i = index(dir_name,' ') - 1
c      
c     clean crap
c
      open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='unknown')
      close(unit=99,status='delete')
      psp_in = "junk.inp "
      ka = index(atom,' ') - 1
      if (ka.lt.0) ka = 4
      if (iopt.eq.1) psp_out = atom(1:ka)//".psp "
      if (iopt.eq.2) psp_out = atom(1:ka)//"_basis "
      j = index(psp_in,' ')  - 1
      k = index(psp_out,' ') - 1

      call nwpw_libgeninp(iopt,atom,sdir_name(1:h)//'/junk.inp')
      lmax=nwpw_libglmax(atom)
      locp=nwpw_libglocp(atom)
      rlocal=nwpw_libgrlocal(atom)
      psp_type=nwpw_libgpsp_type(atom)
      efg_type=nwpw_libgefg_type(atom)
       
c      if (hprint) then
      write(luout,*) "Generating 1d pseudopotential for ",atom

c      end if

      if ((psp_type.eq.0).or.(psp_type.eq.7)) then


c        *** add GGA options to junk.inp ***
*  
c        *** Vosko ***
         if (control_gga().eq.0) then
           if (hprint) write(*,*) "+ generated using Vosko et al."

c        *** PBE96 ***
         else if ((control_gga().eq.10).or.(control_gga().eq.110)) then
           if (hprint) write(*,*) "+ generated using PBE96"
           open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
           do while(.true.)
             read(99,*,ERR=30,END=30) ch_tmp
           end do
   30      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(MACX) || defined(GCC46)
           backspace 99
#endif
           write(99,*) '<exchange>    pbe96 <end>'
           write(99,*) '<correlation> pbe96 <end>'
           close(unit=99)

c        *** BLYP ***
         else if ((control_gga().eq.11).or.(control_gga().eq.115)) then
           if (hprint) write(*,*) "+ generated using BLYP"
           open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
           do while(.true.)
             read(99,*,ERR=31,END=31) ch_tmp
           end do
   31      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(MACX) || defined(GCC46)
           backspace 99
#endif
           write(99,*) '<exchange>    becke <end>'
           write(99,*) '<correlation> lyp   <end>'
           close(unit=99)

c        *** revPBE ***
         else if ((control_gga().eq.12).or.(control_gga().eq.112)) then
           if (hprint) write(*,*) "+ generated using revPBE"
           open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
           do while(.true.)
             read(99,*,ERR=32,END=32) ch_tmp
           end do
   32      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(MACX) || defined(GCC46)
           backspace 99
#endif
           write(99,*) '<exchange>    revpbe <end>'
           write(99,*) '<correlation> revpbe <end>'
           close(unit=99)
         end if

         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call pspsolve(print,debug,
     >        lmax,locp,rlocal,efg_type,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k)

      !*** HGH pseudopotential format ***
      else if (psp_type.eq.1) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call hgh_parse(debug,    
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k)

      !*** CPI pseudopotential format ***
      else if (psp_type.eq.2) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call cpi_parse(debug,    
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      !*** TETER pseudopotential format ***
      else if (psp_type.eq.3) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call teter_parse(debug,    
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      !*** PAW basis format ***
      else if (psp_type.eq.4) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call paw_atom_driver(debug,
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      !*** QMMM format ***
      else if (psp_type.eq.5) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call qmmm_parse(debug,    
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      !*** CARTER pseudopotential format ***
      else if (psp_type.eq.6) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call carter_parse(debug,    
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)
      end if

      open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
      close(unit=99,status='delete')


      end if !** taskid.eq.MASTER **
      value = rtdb_parallel(.true.)

      call ga_sync()

      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,lmax)
      call Parallel_Brdcst_ivalues(MASTER,msglen,locp)
      call Parallel_Brdcst_values(MASTER,msglen,rlocal)

      return
      end



*     ***************************************
*     *					    *
*     *          psp_generator_auto1        *
*     *					    *
*     ***************************************
      subroutine psp_generator_auto1(atom,lmax,locp,rlocal)
      implicit none

#include "inp.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "stdio.fh"

      character*4 atom
      double precision rlocal
      integer	    locp,lmax
c
      integer MASTER,taskid,msglen
      parameter (MASTER=0)

      logical value,hprint
      character*255 dir_name,sdir_name
      character*16 psp_in,psp_out
      integer h,i,j,k,ka,debug,psp_type,print
      character ch_tmp

*     **** external functions ****
      logical  control_print
      integer  nwpw_libglmax,nwpw_libglocp,control_gga
      integer  nwpw_libgpsp_type
      double precision nwpw_libgrlocal
      external control_print
      external nwpw_libglmax,nwpw_libglocp,control_gga
      external nwpw_libgpsp_type
      external nwpw_libgrlocal
c
      call Parallel_taskid(taskid)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)

      value = rtdb_parallel(.false.)
      if (taskid.eq.MASTER) then

      call util_directory_name(sdir_name,.true.,0)
      call util_directory_name(dir_name,.false.,0)
      h = index(sdir_name,' ') - 1
      i = index(dir_name,' ') - 1
c      
c     clean crap
c
      open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='unknown')
      close(unit=99,status='delete')
      psp_in = "junk.inp "
      ka = index(atom,' ') - 1
      if (ka.lt.0) ka = 4
      psp_out = atom(1:ka)//".psp1"
      j = index(psp_in,' ')  - 1
      k = index(psp_out,' ') - 1

      call nwpw_libgeninp(1,atom,sdir_name(1:h)//'/junk.inp')
      lmax=nwpw_libglmax(atom)
      locp=nwpw_libglocp(atom)
      rlocal=nwpw_libgrlocal(atom)
      psp_type=nwpw_libgpsp_type(atom)
       
      if (hprint) then
      write(luout,*) "Generating 1d atomic orbitals for ",atom
      end if

      !*** CPI pseudopotential format ***
      if (psp_type.eq.2) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call cpi_parse(debug,
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      !*** TETER pseudopotential format ***
      else if (psp_type.eq.3) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call teter_parse(debug,
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      !*** PAW pseudopotential format ***
      else if (psp_type.eq.4) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call paw_atom_driver(debug,
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      else if (psp_type.eq.6) then
         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call carter_parse(debug,
     >        lmax,locp,rlocal,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k,
     >        atom(1:ka),ka)

      else

c        *** add GGA options to junk.inp ***
*  
c        *** Vosko ***
         if (control_gga().eq.0) then
           if (hprint) write(*,*) "+ generated using Vosko et al."

c        *** PBE96 ***
         else if ((control_gga().eq.10).or.(control_gga().eq.110)) then
           if (hprint) write(*,*) "+ generated using PBE96"
           open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
           do while(.true.)
             read(99,*,ERR=30,END=30) ch_tmp
           end do
   30      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(MACX) || defined(GCC46)
           backspace 99
#endif
           write(99,*) '<exchange>    pbe96 <end>'
           write(99,*) '<correlation> pbe96 <end>'
           close(unit=99)

c        *** BLYP ***
         else if (control_gga().eq.11) then
           if (hprint) write(*,*) "+ generated using BLYP"
           open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
           do while(.true.)
             read(99,*,ERR=31,END=31) ch_tmp
           end do
   31      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(MACX) || defined(GCC46)
           backspace 99
#endif
           write(99,*) '<exchange>    becke <end>'
           write(99,*) '<correlation> lyp   <end>'
           close(unit=99)

c        *** revPBE ***
         else if ((control_gga().eq.12).or.(control_gga().eq.112)) then
           if (hprint) write(*,*) "+ generated using revPBE"
           open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
           do while(.true.)
             read(99,*,ERR=32,END=32) ch_tmp
           end do
   32      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(MACX) || defined(GCC46)
           backspace 99
#endif
           write(99,*) '<exchange>    revpbe <end>'
           write(99,*) '<correlation> revpbe <end>'
c           write(99,*) '<correlation> off   <end>'
           close(unit=99)


         end if


         debug = 0
         print = 0
         if (control_print(print_debug)) debug = 1
         if (control_print(print_high)) print  = 1
         call pspsolve(print,debug,
     >        lmax,locp,rlocal,0,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in(1:j),j,
     >        psp_out(1:k),k)


      end if
      open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
      close(unit=99,status='delete')


      end if !** taskid.eq.MASTER **
      value = rtdb_parallel(.true.)

      call ga_sync()

      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,lmax)
      call Parallel_Brdcst_ivalues(MASTER,msglen,locp)
      call Parallel_Brdcst_values(MASTER,msglen,rlocal)

      return
      end

      logical function  CCT_UHF (rtdb)
c 
c....  development version UHF CCSD(T)
c      ==========================================
c      CHECK
c      c/a symmetry
c      triangular symmetries (ij/ab in summation)
c      are sorted in  cct_uhf_t2  ......
c      can be (but are not)sorted by the factors in the occ's
c      ==========================================
c
c...    SYMMETRY of integrals requires careful CONSIDERATION
c...    SYMMETRY of T's requires careful CONSIDERATION
c...    All needws careful checking
c
c...   dgemmm description'
c
c...   call dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
c...   C:= alpha*A*B + beta*C
c...   transa,transb : 'N' : asis ; 'T' transposed
c...   m : # rows A,C            : nar
c...   n : # columns B,C         : nbc
c...   k : # columns A, rows B   : nac (nlink)
c...   (refers to matrix after possible transpose)
c...   ld : leading dimensions
c
*
* $Id: cct_UHF.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      implicit none
#include "util.fh"
c
c
c...   symbolic matrix elements are all mapped onto A3A
c     (ij)t(ij,ce)*t(ij,af)  *  (bk) <ba||ek><bc||fk>
c        T(ij)(ceaf)  (Y)           I(bk)(aecf) (X)
c...   ...  integrals and T';s are treated alike   ...
c...   properties :   RESULT  SUM1 SUM2
c                     a e c f  b k  i j 
c     *note*
c     b,k are running indices for first contraction type(*,1)
c     a,e are on same and c,f are on same "integral" for ,1
c     i,j are running indices for second contraction type(*,2)
c     a,f are on same and c,e are on same "integral" for ,2
c     --------------------------------------------------------
c     e,f are complete ranges / a,c get batched
c     e,f (2,4)  are the  unweighted
c     --------------------------------------------------------
c
c      sij=sce=saf / sbk=sae=scf
c      do sbk=1,nirr
c       do sij=1,nirr
c        do sa=1,nirr
c        for "symmetric" batch of c,a ; all e,f in core
c        within summation bk/ij may be batched (saves space)
c
c      storage
c      bk,ea, so for one a all e's and then bk's
c      The result is (ae,cf) / (af,ce)
c      in each column/row the e/f are the fastest running indices
c         
c
      integer rtdb
c
      double precision r_a2a,r_a2b,r_b2b,r_a3a,r_a3b,r_b3b
      double precision r_a4a,r_a4b,r_b4b
      double precision r_a1a,r_a1b,r_b1b,flop
      double precision cct_uhf_T2
c
      integer ncase_a2a,ncase_a2b,ncase_b2b
      integer ncase_a3a,ncase_a3b,ncase_b3b
      integer ncase_a4a,ncase_a4b,ncase_b4b
      integer ncase_11a,ncase_11b,ncase_14a,ncase_14b
      parameter (ncase_a2a=5,ncase_a2b=6,ncase_b2b=5)
      parameter (ncase_a3a=5,ncase_a3b=6,ncase_b3b=5)
      parameter (ncase_a4a=4,ncase_a4b=6,ncase_b4b=4)
      parameter (ncase_11a=4,ncase_11b=4,ncase_14a=6,ncase_14b=6)
c
      integer cases_a2a(9,ncase_a2a),occ_a2a(11)
      character*20 a2a,type_a2a(2,2)
      integer cases_a2b(9,ncase_a2b),occ_a2b(11)
      character*20 a2b,type_a2b(2,2)
      integer cases_b2b(9,ncase_b2b),occ_b2b(11)
      character*20 b2b,type_b2b(2,2)
c
      integer cases_a3a(9,ncase_a3a),occ_a3a(11)
      character*20 a3a,type_a3a(2,2)
      integer cases_a3b(9,ncase_a3b),occ_a3b(11)
      character*20 a3b,type_a3b(2,2)
      integer cases_b3b(9,ncase_b3b),occ_b3b(11)
      character*20 b3b,type_b3b(2,2)
c
      integer cases_a4a(9,ncase_a4a),occ_a4a(11)
      character*20 a4a,type_a4a(2,2)
      integer cases_a4b(9,ncase_a4b),occ_a4b(11)
      character*20 a4b,type_a4b(2,2)
      integer cases_b4b(9,ncase_b4b),occ_b4b(11)
      character*20 b4b,type_b4b(2,2)
c
      integer cases_11a(9,ncase_11a),occ_11a(11)
      character*20 a11,type_11a(2,2)
      integer cases_11b(9,ncase_11b),occ_11b(11)
      character*20 b11,type_11b(2,2)
c
      integer cases_14a(9,ncase_14a),occ_14a(11)
      character*20 a14,type_14a(2,2)
      integer cases_14b(9,ncase_14b),occ_14b(11)
      character*20 b14,type_14b(2,2)
c
c======================================================================
      data a2a/'A2A'/
c                     k e i f  a b  j c  fac
      data cases_a2a/ 1,1,1,1, 1,1, 0,0,  1,
     2                2,2,2,2, 2,2, 0,0,  1,
     3                1,2,1,2, 1,2, 2,1,  2,
     4                2,1,2,1, 1,2, 1,2,  2,
     5                2,1,1,2, 1,2, 0,0,  4/
      data occ_a2a  / 1,2,1,2, 1,2, 1,2, -2,      1,3/
      data type_a2a /'<ab||ek>(abek)','<ab||ek>(abek)',
     1               'T(ij,ab)(aibj)','T(ij,ab)(aibj)'/
c======================================================================
      data a2b/'A2B'/
c                     i n k e  a b  j c
      data cases_a2b/ 1,1,1,1, 1,1, 0,0,  1,
     2                2,2,2,2, 2,2, 0,0,  1,
     3                1,2,2,1, 1,2, 0,0,  2,
     4                2,1,1,2, 1,2, 0,0,  2,
     5                2,1,2,1, 1,2, 1,2,  2,
     6                1,2,1,2, 1,2, 2,1,  2/
      data occ_a2b  / 1,1,1,2, 2,2, 1,2, +2,      1,3/
      data type_a2b /'T(ij,ab)(abij)','<ba||ek>(baek)',
     1               'T(ij,ab)(aibj)','<ij||an>(iajn)'/
c======================================================================
      data b2b/'B2B'/
c                     k m i n  a b  j c
      data cases_b2b/ 1,1,1,1, 1,1, 0,0,  1,
     2                2,2,2,2, 2,2, 0,0,  1,
     3                1,2,1,2, 1,2, 2,1,  2,
     4                2,1,2,1, 1,2, 1,2,  2,
     5                2,1,1,2, 1,2, 0,0,  4/
      data occ_b2b  / 1,1,1,1, 2,2, 1,2, -2,      1,3/
      data type_b2b /'T(ij,ab)(abij)','T(ij,ab)(abij)',
     1               '<ij||an>(iajn)','<ij||an>(iajn)'/
c======================================================================
      data a3a/'A3A'/
c...  cases contains the spin cases and the factor to multiply by
c...  occ contains the occupations (1=occ,2=virt) and the divide factor
c...  and (to be save) the indices to be weighted in the intermediate)
c...  type contains types for intgrals/t's in first and second mult
c                     1 2 3 4  5 6  7 8
c                     a e c f  b k  i j, fac 
      data cases_a3a/ 1,1,1,1, 0,0, 1,1,  1,
     2                2,2,2,2, 0,0, 2,2,  1,
     3                1,2,1,2, 2,1, 1,2,  2,
     4                2,1,2,1, 1,2, 1,2,  2,
     5                1,1,2,2, 0,0, 1,2, -4/
c..    above since we seem to get abab while specifying abba
c    5                1,1,2,2, 0,0, 1,2,  4/
      data occ_a3a  / 2,2,2,2, 2,1, 1,1,  2,   1,3/
      data type_a3a /'<ba||ek>(bkea)','<ba||ek>(bkea)',
     1               'T(ij,ce)(ijec)','T(ij,ce)(ijec)'/
c======================================================================
      data a3b/'A3B'/
c                     c n a e  b k  i j
      data cases_a3b/ 1,1,1,1, 0,0, 1,1,  1,
     2                2,2,2,2, 0,0, 2,2,  1,
     3                1,1,2,2, 0,0, 1,2,  2,
     4                2,2,1,1, 0,0, 1,2,  2,
     5                1,2,1,2, 2,1, 1,2,  2,
     6                2,1,2,1, 1,2, 1,2,  2/
      data occ_a3b  / 2,1,2,2, 2,1, 1,1, -2,   1,3/
      data type_a3b /'T(ij,ab)(aibj)','<ba||ek>(bkea)',
     1               'T(ij,ab)(aibj)','<ij||an>(ijan)'/
c======================================================================
      data b3b/'B3B'/
c                     a m c n  b k  i j
      data cases_b3b/ 1,1,1,1, 0,0, 1,1,  1,
     2                2,2,2,2, 1,1, 2,2,  1,
     3                1,2,1,2, 2,1, 1,2,  2,
     4                2,1,2,1, 1,2, 1,2,  2,
     5                2,2,1,1, 0,0, 1,2,  4/
      data occ_b3b  / 2,1,2,1, 2,1, 1,1, -2,   1,3/
      data type_b3b /'T(ij,ce)(ciej)','T(ij,ce)(ciej)',
     1               '<cm||ij>(ijcm)','<cm||ij>(ijcm)'/
c======================================================================
      data a4a/'A4A'/
c                     1 2 3 4  5 6  7 8
c                     j e b f  a k  c i, fac 
      data cases_a4a/ 1,1,1,1, 0,0, 0,0,  1,
     2                2,2,2,2, 0,0, 0,0,  1,
     3                1,1,2,2, 1,2, 0,0,  2,
     4                2,2,1,1, 2,1, 0,0,  2/
      data occ_a4a  / 1,2,2,2, 2,1, 2,1,  1,   1,3/
      data type_a4a /'T(ij,ce)(ciej)','<ba||ek>(bkea)',
     1               'T(ij,ce)(ciej)','<ba||ek>(bkea)'/
c======================================================================
      data a4b/'A4B'/
c                     b e j n  a k  c i
      data cases_a4b/ 1,1,1,1, 0,0, 0,0,  1,
     2                2,2,2,2, 0,0, 0,0,  1,
     3                2,1,1,2, 1,2, 0,0,  1,
     4                1,2,2,1, 2,1, 0,0,  1,
     5                1,1,2,2, 0,0, 2,1,  1,
     6                2,2,1,1, 0,0, 1,2,  1/
      data occ_a4b  / 2,2,1,1, 2,1, 2,1, -1,   1,3/
      data type_a4b /'<ba||ek>(bkea)','<ba||ek>(bkea)',
     1               'T(ij,ab)(aibj)','T(ij,ab)(aibj)'/
c======================================================================
      data b4b/'B4B'/
c                     b m j n  a k  c i
      data cases_b4b/ 1,1,1,1, 0,0, 0,0,  1,
     2                2,2,2,2, 0,0, 0,0,  1,
     3                2,1,1,2, 1,2, 0,0,  2,
     4                1,2,2,1, 2,1, 0,0,  2/
      data occ_b4b  / 2,1,1,1, 2,1, 2,1,  1,   1,3/
      data type_b4b /'T(ij,ab)(aibj)','<ba||ek>(bkea)',
     1               'T(ij,ab)(aibj)','<ba||ek>(bkea)'/
c======================================================================
c
c     T1 diagrams (cf the T1 comments) "UNCHECKED"
c
c======================================================================
      data a11/'11A'/
c                     1 2 3 4  5 6  7 8
c                     i j f k  a b  c 0, fac 
      data cases_11a/ 1,1,1,1, 1,1, 1,0,  1,
     2                2,2,2,2, 2,2, 2,0,  1,
     3                1,2,2,1, 1,2, 1,0,  4,
     4                2,1,1,2, 1,2, 2,0,  4/
      data occ_11a  / 1,1,2,1, 2,2, 2,0,  4,   0,3/
      data type_11a /'<ij||ab>(abij)','<ij||ab>(abij)',
     1               'T(k,c)(ck)','T(ij,ce)(ceij)'/
c======================================================================
      data b11/'11B'/
c                     1 2 3 4  5 6  7 8
c                     i j n k  a b  c 0, fac 
      data cases_11b/ 1,1,1,1, 1,1, 1,0,  1,
     2                2,2,2,2, 2,2, 2,0,  1,
     3                1,2,2,1, 1,2, 1,0,  4,
     4                2,1,1,2, 1,2, 2,0,  4/
      data occ_11b  / 1,1,1,1, 2,2, 2,0,  4,   0,3/
      data type_11b /'T(ij,ce)(ceij)','<ij||ab>(abij)',
     1               'T(k,c)(ck)','<ij||ab>(abij)'/
c======================================================================
      data a14/'14A'/
c                     1 2 3 4  5 6  7 8
c                     b i f k  a j  c 0, fac 
      data cases_14a/ 1,1,1,1, 0,0, 1,0,  1,
     2                2,2,2,2, 0,0, 2,0,  1,
     3                2,2,1,1, 0,0, 1,0,  1,
     4                1,1,2,2, 0,0, 2,0,  1,
     5                2,1,2,1, 1,2, 1,0,  1,
     6                1,2,1,2, 2,1, 2,0,  1/
      data occ_14a  / 2,1,2,1, 2,1, 2,0, -1,   0,3/
      data type_14a /'T(ij,ce)(ciej)','<ij||ab>(aibj)',
     1               'T(k,c)(ck)','<ij||ab>(aibj)'/
c======================================================================
      data b14/'14B'/
c                     1 2 3 4  5 6  7 8
c                     b i n k  a j  c 0, fac 
      data cases_14b/ 1,1,1,1, 0,0, 1,0,  1,
     2                2,2,2,2, 0,0, 2,0,  1,
     3                2,2,1,1, 0,0, 1,0,  1,
     4                1,1,2,2, 0,0, 2,0,  1,
     5                2,1,2,1, 1,2, 1,0,  1,
     6                1,2,1,2, 2,1, 2,0,  1/
      data occ_14b  / 2,1,1,1, 2,1, 2,0,  1,   0,3/
      data type_14b /'<ij||ab>(aibj)','<an||kj>(ankj)',
     1               'T(k,c)(ck)','T(ij,ce)(ceij)'/
c======================================================================
c
c     r_a2a = cct_uhf_T2(a2a,occ_a2a,cases_a2a,ncase_a2a,type_a2a,
c    1                   r_a1a)
c     r_a2b = cct_uhf_T2(a2b,occ_a2b,cases_a2b,ncase_a2b,type_a2b,
c    1                   r_a1b)
c     r_b2b = cct_uhf_T2(b2b,occ_b2b,cases_b2b,ncase_b2b,type_b2b,
c    1                   r_b1b)
c     print *,' a2a ',r_a2a
c     print *,' a2b ',r_a2b
c     print *,' b2b ',r_b2b
c     print *,' total term2 ',r_a2a+r_a2b+r_b2b
c
      print *,' diagram ',A3A,ncase_a3a
      r_a3a = cct_uhf_T2(a3a,occ_a3a,cases_a3a,ncase_a3a,type_a3a,
     1                   flop)
c     r_a3b = cct_uhf_T2(a3b,occ_a3b,cases_a3b,ncase_a3b,type_a3b,
c    1                   flop)
c     r_b3b = cct_uhf_T2(b3b,occ_b3b,cases_b3b,ncase_b3b,type_b3b,
c    1                   flop)
      print *,' a3a ',r_a3a
c     print *,' a3b ',r_a3b
c     print *,' b3b ',r_b3b
c     print *,' total term3 ',r_a3a+r_a3b+r_b3b
         stop
c
      r_a4a = cct_uhf_T2(a4a,occ_a4a,cases_a4a,ncase_a4a,type_a4a,
     1                   flop)
      r_a4b = cct_uhf_T2(a4b,occ_a4b,cases_a4b,ncase_a4b,type_a4b,
     1                   flop)
      r_b4b = cct_uhf_T2(b4b,occ_b4b,cases_b4b,ncase_b4b,type_b4b,
     1                   flop)
      print *,' a4a ',r_a4a
      print *,' a4b ',r_a4b
      print *,' b4b ',r_b4b
      print *,' total term4 ',r_a4a+r_a4b+r_b4b
c
      CCT_UHF = .true.
c
      return
      end
      subroutine cct_uhf_address(nirr_in,mult_in,iro_in,
     1                           occa,occb,norb)
c
c...  set up cct_uhf adddressing
c     
c...  all alpha's first / beta's second in numbering
c
c...   for t2 vectors, t1 vectors ...
c...  normal ordering is ij ; i.ge.j, so goes for symmetry as well
c...  e.g.
c...  total symmetry 1  orbsym : (1,1) (2,2) (3,3) (4,4)
c...  total symmetry 2  orbsym : (1,2) (3,4)
c...  total symmetry 3  orbsym : (1,3) (2,4)
c...  total symmetry 4  orbsym : (1,4) (2,1)
c...   and (4,1) = -(1,4) transposed
c
c     universal order
c     do j=1,n
c      do i=1,n
c       a(i,j)
c     so if i< j => + (apart from it's own sign)
c
      implicit none
c
      integer nirr_in,mult_in(8,8),iro_in(*),occa,occb,norb
c
c...  cct_table_uhf
c
#include "cct_table_uhf.fh"
c
      integer sij,si,sj,i,spin,k,spinx,spiny
      integer nbk,nij,nab
c
      nirr = nirr_in
c
      do si=1,nirr
       do sj=1,nirr
        mult(si,sj) = mult_in(si,sj)
       end do
      end do
c
      orb = norb
      virt(1) = orb-occa
      virt(2) = orb-occb
      occ(1) = occa
      occ(2) = occb
c
      k = 0
      do spin=1,2
       do i=1,occ(spin)
        k = k + 1
        iocc(k) = 1
        ispin(k) = spin
       end do
       do i=1,virt(spin)
        k = k + 1
        iocc(k) = 2
        ispin(k) = spin
       end do
      end do
c
      do i=1,norb
       iro(i) = iro_in(i)
       iro(i+norb) = iro_in(i+norb)
       do spin=1,2
        k = i+(spin-1)*norb
        if (i.le.occ(spin)) then
          nocc(iro(k),spin) = nocc(iro(k),spin) + 1
        else
          nvirt(iro(k),spin) = nvirt(iro(k),spin) + 1
        end if
       end do
      end do
c
c...  some addressing
c     spin can be deduced from above norb
c
      i = 1
      do spin=1,2
       do si = 1,nirr
        socc(si,spin) = i
        i = i + nocc(si,spin)
       end do
       socc(nirr+1,spin) = i
       do si = 1,nirr
        svirt(si,spin) = i
        i = i + nvirt(si,spin)
       end do
       svirt(nirr+1,spin) = i
      end do
c
c...  len_bk
c...  spinx => virtual, spiny => occupied (if applicable)
c
      do spinx = 1,2
       do spiny = 1,2
        do sij=1,nirr
         nbk = 0
         nij = 0
         nab = 0
         do si=1,nirr
          sj = mult(sij,si)
          nbk = nbk + nocc(si,spiny)*nvirt(sj,spinx)
          if (si.eq.sj.and.spinx.eq.spiny) then
           nij = nij + nocc(si,spinx)*(nocc(si,spinx)+1)/2
           nab = nab + nvirt(si,spinx)*(nvirt(si,spinx)+1)/2
          else if (si.le.sj) then
           nij = nij + nocc(si,spinx)*nocc(sj,spiny)
           nab = nab + nvirt(si,spinx)*nvirt(sj,spiny)
          end if
         end do
         lenbk(sij,spinx,spiny) = nbk
         lenij(sij,spinx,spiny) = nij
         lenab(sij,spinx,spiny) = nab
        end do
       end do
      end do
c
c...  calculate various constants
c
      do i = 1, 2*orb
         fac(i) = 1.0d0
      end do
c
      return
      end
      
      double precision function cct_uhf_T2
     1       (diagram,occupation,cases,ncase,type,
     2        value_X1X)
c
c...  CCT T2 diagram evaluator; modelled for A3A
c
c...  if diagram is A2A,A2B or B2B we can generate the 
c...  corresponding A1A,A1B and B1B simultaneously => value_X1X
c
      implicit none
#include "errquit.fh"
c
c     (ij)t(ij,ce)*t(ij,af)  *  (bk) <ba||ek><bc||fk>
c        T(ij)(ceaf)  (Y)           I(bk)(aecf) (X)
c
c...  scheme 
c     get as many integrals in (Global) core
c     calculate X ; then corresponding T and be done
c...  deciding factor is the aecf (n**4) storage.
c...  storage :
c     sbk : store  <ba||ek> as bk,ae (bk along columns)
c          do sb=1,nirr
c           sk = mult(sbk,sb)
c           if (sk.lt.sb) skip
c          same scheme for ae (along rows)
c         
c
c...   symbolic matrix element (for A3A)
c
c...   output : accumulated value
c...   input : diagram : text string to identify diagram
c...           occuption,cases,ncase,type:diagram definition (see below)
c
c     integer ncase,case
c     parameter (ncase=5)
c     integer cases(9,ncase),occupation(9)
c     integer c,e,a,f,i,j,b,k
c...    (occupations of these)
c     character*20 type(2,2)
c...  cases contains the spin cases and the factor to multiply by
c...  occ contains the occupations (1=occ,2=virt) and the divide factor
c...  type contains types for intgrals/t's in first and second mult
c     (ij)t(ij,ce)*t(ij,af)  *  (bk) <ba||ek><bc||fk>
c                 1 2 3 4  5 6  7 8
c                 a e c f  b k  i j  fac 
c     data cases/ 1,1,1,1, 0,0, 1,1,  1,
c    1            2,2,2,2, 0,0, 2,2,  1,
c    2            1,2,1,2, 2,1, 1,2,  2,
c    3            2,1,2,1, 1,2, 1,2,  2,
c    4            1,1,2,2, 0,0, 1,2,  4/
c     data occupation  / 2,2,2,2, 2,1, 1,1,  2/
c     data type /'<ba||ek>(bkea)','<ba||ek>(bkea)',
c    1           'T(ij,ce)(ijec)','T(ij,ce)(ijec)'/
c
c     *note*
c     b,k are running indices for first contraction type(*,1)
c     a,e are on same and c,f are on same "integral" for ,1
c     i,j are running indices for second contraction type(*,2)
c     a,f are on same and c,e are on same "integral" for ,2
c     --------------------------------------------------------
c     e,f are complete ranges / a,c get batched
c     e,f (2,4)  are the  unweighted
c     --------------------------------------------------------
c
c
      integer occupation(9),ncase,cases(9,ncase)
      double precision value_X1X
      character*(*) diagram,type(2,2)
c
#include "mafdecls.fh"
#include "cct_table_uhf.fh"
c
      logical ga_create,ga_destroy
      integer avail_ga,ga_memory_avail,ga_memory,ga_nnodes
      integer g_RESULT,g_TESULT
c
      integer spinc,spine,spina,spinf,spini,spinj,spinb,spink,spin
      integer a,e,c,f,b,k,i,j
      integer eb,fb,bb,kb,ab,ae,cb,ce,ib,jb
      integer na,nc,ne,nf
      integer nae,ncf,naf,nce
      integer sbk,sij,sa,se,sf,sc
      integer case,nbatch,nbcha,nbchc,size,size_1
      logical symmetry,a2a,a1a
      double precision factor,cct_sum,sum,cct_sum_a1a
      double precision deb1,deb2,deb3,deb4
c
      sum = 0.0d0
      a2a = diagram.eq.'A2A'.or.diagram.eq.'A2B'.or.diagram.eq.'B2B'
c..    (could deduce this from fact that both c and a are occupied)
      if (a2a) value_X1X = 0.0d0
c
c...   get available global memory
c...   be sure to have 2 local ne arrays per processor in final stage
c
       avail_ga = ga_memory_avail()/8
       call ga_igop(13,avail_ga,1,'min')
c...    remember that there is overhead (in space) as well
       ga_memory = ga_nnodes()*avail_ga*0.9
c     
c                 1 2 3 4  5 6  7 8
c                 a e c f  b k  i j  fac 
       print *,' diagram ',diagram
      a = occupation(1)
      e = occupation(2)
      c = occupation(3)
      f = occupation(4)
      b = occupation(5)
      k = occupation(6)
      i = occupation(7)
      j = occupation(8)
c
      if (a2a.and.(a.eq.2.or.c.eq.2)) call errquit('A2A error',0,
     &       UNKNOWN_ERR)
c
      do  case=1,ncase
c
       spina = cases(1,case)
       spine = cases(2,case)
       spinc = cases(3,case)
       spinf = cases(4,case)
       spinb = cases(5,case)
       spink = cases(6,case)
       spini = cases(7,case)
       spinj = cases(8,case)
c
       factor = cases(9,case)/(occupation(9)*1.0D0)
c
c...   handle triangular factors 
c
       if (i.eq.j.and.spini.eq.spinj) factor = factor*2
       if (b.eq.k.and.spinb.eq.spink) factor = factor*2
c
       eb = s_occ_virt(1,spine,e)
       fb = s_occ_virt(1,spinf,f)
c
       do sbk=1,nirr
        do sij=1,nirr
         do sa=1,nirr
          sf = mult(sij,sa)
          se = mult(sbk,sa)
          sc = mult(sbk,sf)
          if (sc.lt.sa.or.sf.lt.se) go to 10
c
          ne = n_occ_virt(se,spine,e)
          nf = n_occ_virt(sf,spinf,f)
c
          a1a = a2a.and.spina.eq.spinc.and.se.eq.sf
          size_1 = 0
          if (a1a) size_1 = 2*ne**2
c
          symmetry = (se.eq.sf).and.spin.eq.spin 
          size = ne*nf*n_occ_virt(sa,spina,a)*n_occ_virt(sc,spinc,c) 
c         if (.not.symmetry) size = size * 2 ?
          nbatch = max(size/(ga_memory-size_1),1)
c...   'squares' for now  CHECK !!!
          nbcha = dsqrt((nbatch-1)*1.0d0) + 1.00001d0 
          nbchc = (nbatch-1)/nbcha + 1 
          na = (n_occ_virt(sa,spina,a)-1)/nbcha+1 
          nc = (n_occ_virt(sc,spinc,c)-1)/nbchc+1 
c
          do ab=s_occ_virt(sa,spina,a),s_occ_virt(sa+1,spina,a)-1,na
           ae = min(ab+na,s_occ_virt(sa+1,spina,a))-1
           na = ae-ab+1
           do cb=s_occ_virt(sc,spinc,c),s_occ_virt(sc+1,spinc,c)-1,nc
            ce = min(cb+nc,s_occ_virt(sc+1,spinc,c))-1
            nc = ce-cb+1
c
            nae = na*ne
            ncf = nc*nf
            naf = na*nf
            nce = nc*ne
c
            if (.not.ga_create(MT_DBL,nae,ncf,'Result',0,0,g_RESULT))
     1          call errquit('no global space for RESULT',0, GA_ERR)
            call ga_zero(g_RESULT)
c
c...    loop over bk spin if sbk = 0 
c
            spin = spinb
            if (spin.eq.0.and.spink.ne.0) 
     1          call errquit('whats this spin',0, UNKNOWN_ERR)
            spinb = max(spinb,1)
            spink = max(spink,1)
5           bb = s_occ_virt(sbk,spinb,b)
            kb = s_occ_virt(sbk,spink,k)
c...   * I(aa+bb)(aaaa)
            call mult_cct(bb,kb,eb,fb,
     1                    type(1,1),ab,ae,
     1                    type(2,1),cb,ce,
     1                    g_RESULT)
            if (spin.eq.0) then
             spin = 1
             spinb = 2
             spink = 2
             go to 5
            end if
c
            call cct_scale_ac(g_RESULT,ab,ne,cb,nf)
c
c...    check if the I and the T are actually identical (A4A)
c
            if (ab.eq.cb.and.ae.eq.ce.and.bb.eq.ib.and.kb.eq.jb.and.
     1         type(1,1).eq.type(1,2).and.type(2,1).eq.type(2,2)) then
             sum = sum + cct_sum(g_RESULT,g_RESULT,na,nc,ne,nf) * factor
             go to  9
            end if
c
c      * T(aa)(aaaa)
            if (.not.ga_create(MT_DBL,naf,nce,'Tesult',0,0,g_TESULT))
     1          call errquit('no global space for TESULt',0, GA_ERR)
            call ga_zero(g_TESULT)
c
            spin = spini
            if (spin.eq.0.and.spinj.ne.0) 
     1          call errquit('whats this spini',0, UNKNOWN_ERR)
            spini = max(spini,1)
            spinj = max(spinj,1)
6           ib = s_occ_virt(sbk,spini,i)
            jb = s_occ_virt(sbk,spinj,j)
            call mult_cct(ib,jb,fb,eb,
     1                    type(1,2),ab,ae,
     1                    type(2,2),cb,ce,
     1                     g_TESULT)
            if (spin.eq.0) then
             spin = 1
             spini = 2
             spinj = 2
             go to 6 
            end if
c
            call cct_scale_ac(g_TESULT,ab,ne,cb,nf)
c           
c           sum = sum + cct_sum(g_RESULT,g_TESULT,na,nc,ne,nf) * factor
            deb1 = cct_sum(g_RESULT,g_TESULT,na,nc,ne,nf) * factor
            print *,' case ',case,' intermediate ',deb1
            sum = sum + deb1
c
            if (a1a.and.ab.eq.cb) then
             value_X1X = value_X1X +  
     1                   cct_sum_a1a(g_RESULT,g_TESULT,na,ne) * factor
            end if
 
c
c           if (cb.eq.ab) then
c             sum = sum + cct_sum(g_RESULT,g_TESULT,na,nc,ne,nf) * factor
c            else
c             call ga_zero(g_TESULT)
c             spin = spini
c             spini = max(spini,1)
c             spinj = max(spinj,1)
c7            ib = s_occ_virt(sbk,spini,i)
c             jb = s_occ_virt(sbk,spinj,j)
c             call mult_cct(ib,jb,eb,fb,
c     1                     type(1,2),cb,ce,
c     1                     type(2,2),ab,ae,
c     1                      g_TESULT)
c             if (spin.eq.0) then
c              spin = 1
c              spini = 2
c              spinj = 2
c              go to 7 
c             end if
c
c            call cct_scale_ac(g_TESULT,ab,ne,cb,nf)
c
c             sum = sum + cct_sum(g_RESULT,g_TESULT,na,nc,ne,nf) * factor
c            end if
c
            if (.not.ga_destroy(g_TESULT)) 
     1          call errquit('unable to destroy TESULT',0, GA_ERR)
            if (.not.ga_destroy(g_RESULT)) 
     1          call errquit('unable to destroy RESULT',0, GA_ERR)
c
9          end do
          end do
10       end do
        end do
       end do
      end do
c
      cct_uhf_T2 = sum
c
      return
      end
      subroutine mult_cct(bb,kb,eb,fb,
     1                    typeA,ab,ae, typeB,cb,ce,
     1                    g_RESULT)
c
      implicit none
#include "errquit.fh"
c
c...   general (:)) routine to do t*t or int*int (asymmetric)
c...   notation taken from A3A Integral*Integral
c...                       (bk)<ba||ek><bc||fk>
c...                        integrals as (bk,ea) 
c
c...   the first bb and bk are used to denote the full range
c...   of that spin/space/occupation "symmetry" => bbb,bbk
c...   the first be and bf are used to denote full range of
c...   that  spin/occupation "symmetry"  => eb,fb
c
c...   IS SYMMETRY FULLY EXPLOITED ?
c
#include "mafdecls.fh"
#include "cct_table_uhf.fh"
c
      integer g_RESULT
c
      integer bb,kb,eb,fb,ab,ae,cb,ce
      character*(*) typeA,typeB
c
      logical ga_create,ga_destroy
      integer ga_memory_avail,ga_nnodes,avail_ga
      integer g_MATA,g_MATB,size
      integer se,sf,sbk,ee,fe,la,lc,lea,lcf,lbk,llbk,len
      integer batch,nbatch,bkb,bke
      integer spina,spine,spinc,spinf,spinb,spink
      integer occe,occf,occb,occk
      logical symmetric
c
c...   get available global memory
c
       avail_ga = ga_memory_avail()/8
       call ga_igop(13,avail_ga,1,'min')
c...    remember that there is overhead (in space) as well
        avail_ga = ga_nnodes()*avail_ga*0.9
c
c...  figure out spins
c
      spina = ispin(ab)
      spinc = ispin(cb)
      spine = ispin(eb)
      spinf = ispin(fb)
      spinb = ispin(bb)
      spink = ispin(kb)
c...  figure occupations (1=occ,2-virt)
      occe = iocc(eb)
      occf = iocc(fb)
      occb = iocc(bb)
      occk = iocc(kb)
c
      symmetric = (ab.eq.cb.and.ae.eq.ce.and.typeA.eq.typeB.and.
     1             spine.eq.spinf)
      size = avail_ga
      if (.not.symmetric) size = size/2
c
c...  can use symmetry to save a get; we have to use sqrt(fac) then
c
      if (iro(ae).ne.iro(ab)) call errquit('sym in mult_cct',0,
     &       UNKNOWN_ERR)
      if (iro(ce).ne.iro(cb)) call errquit('sym in mult_cct',0,
     &       UNKNOWN_ERR)
c
      sbk = mult(iro(bb),iro(kb))
      se = mult(iro(ab),sbk)
      sf = mult(iro(cb),sbk)
      eb = s_occ_virt(se,spine,occe)
      ee = s_occ_virt(se+1,spine,occe)-1
      fb = s_occ_virt(sf,spinf,occf)
      fe = s_occ_virt(sf+1,spinf,occf)-1
      la = ae-ab+1
      lc = ce-cb+1
      lea = (ee-eb+1)*la
      lcf = (fe-fb+1)*lc
      lbk = lenxy(sbk,spinb,spink,occb+occk)
      llbk = lbk
      len = lbk*(la+lc)*(ee-eb+1)*(fe-fb+1)
      nbatch = (len-1)/size + 1
      len = (lbk-1)/nbatch + 1
c
c...  get global integral array's
c
      if (.not.ga_create(MT_DBL,len,lea,'matA(a,e)',0,0,g_MATA))
     1   call errquit('unable to crate global arrray matA',0, GA_ERR)
      if (.not.symmetric) then
       if (.not.ga_create(MT_DBL,len,lcf,'matA(c,f)',0,0,g_MATB))
     1     call errquit('unable to create global arrray matB',0, GA_ERR)
      else
       g_MATB = g_MATA
      end if
c
      bke = 0
      do batch=1,nbatch
       bkb = bke + 1
       bke = min(bke+len,llbk)
       lbk = (bke-bkb+1)
       call get_cct(g_MATA,typeA,bkb,bke,spinb,spink,
     1              eb,ee,spine,ab,ae,spina)
       if (.not.symmetric)
     1 call get_cct(g_MATB,typeB,bkb,bke,spinb,spink,
     2              fb,fe,spinf,cb,ce,spinc)
c
c...  note ;, the integrals are weighted for the summation indices
c   
       call ga_dgemm('T','N',lea,lcf,lbk,1.0d0,g_MATA,g_MATB,
     1               1.0d0,g_RESULT)
c
      end do
c
      if (.not.symmetric) then
       if (.not.ga_destroy(g_MATB)) call errquit('cant destroy MATB',0,
     &       GA_ERR)
      end if
      if (.not.ga_destroy(g_MATA)) call errquit('cant destroy MATA',0,
     &       GA_ERR)
c
      return
      end
      subroutine cct_scale_ac(g_R,ab,ne,cb,nf)
c
c...  subroutine to add scaling factors to the intermediates
c...  in the global array g_result
c...  the a/c are always the slower changing indices
c...  ae and cf are pairs
c...  template taken from ga_screen (from 1995) and RJH
c
       implicit none
c
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
c
       integer g_R,ab,cb,ne,nf
c
       integer ilo, ihi, jlo, jhi, idim, jdim, ld, ind
c
       call ga_sync()
c
       call ga_distribution(g_R, ga_nodeid(), ilo, ihi, jlo, jhi)
       if (ihi.gt.0 .and. jhi.gt.0) then
          idim = ihi - ilo + 1
          jdim = jhi - jlo + 1
          call ga_access(g_R, ilo, ihi, jlo, jhi, ind, ld)
          call cct_do_scale(dbl_mb(ind), ld, ilo, ihi, jlo, jhi,
     1                      ab,ne,cb,nf)
          call ga_release_update(g_R, ilo, ihi, jlo, jhi)
       endif
c
       call ga_sync()
c
       end
      subroutine cct_do_scale(a, ld, ilo, ihi, jlo, jhi,
     1                        ab,ne,cb,nf)
c
c...  apply scaling factors to intermediate in part of 
c...  global array a; Note the the scaling is sqrt(scale)
c
      implicit none
c
#include "cct_table_uhf.fh"
c
      integer ld, ilo, ihi, jlo, jhi, ab,cb,ne,nf,i,j
      double precision a(ilo:ilo+ld-1,jlo:jhi),facj
c
      do j = jlo, jhi
         facj = fac((j-1)/nf+cb)
         do i = ilo, ihi
            a(i,j) = a(i,j)*fac((i-1)/ne+ab)*facj
         end do
      end do
c
      end
      double precision function cct_sum(g_R,g_T,na,nc,ne,nf)
c
      implicit none
#include "errquit.fh"
c
c...  function to sum the partial contributions in global arrays R,T
c...  sum R(ae,cf)*T(af,ce)
c...  e and f are the fastest moving indices (and are "complete")
c...  this uses a bit of ma_memory (routine above should be aware)
c
      integer g_R,g_T,na,nc,ne,nf
      integer a,c,f
      integer ihi_R,ilo_R,jlh_R,ilh_T,jlo_T,jhi_T
      integer l_R,k_R,l_T,k_T
      integer type_cct_sum
      data type_cct_sum/42/
      double precision sum,ddot
c
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
c
      if (.not. ma_push_get(mt_dbl, ne,'R',l_R, k_R))
     1    call errquit('cannot allocate R in cct_sum',0, MA_ERR)
      if (.not. ma_push_get(mt_dbl, ne,'T',l_T, k_T))
     1    call errquit('cannot allocate T in cct_sum',0, MA_ERR)

      sum = 0.0d0
      do a=1,na
       do c=1,nc
        do f=ga_nodeid()+1,nf,ga_nnodes()
c...     get all e's
         ilo_R = (a-1)*ne+1
         ihi_R = ilo_R+ne-1
         jlh_R = (c-1)*nf+f
         jlo_T = (c-1)*ne+1
         jhi_T = jlo_T+ne-1
         ilh_T = (a-1)*nf+f
c
         call ga_get(g_T,ilh_T,ilh_T,jlo_T,jhi_T,dbl_mb(k_T),1)
         call ga_get(g_R,ilo_R,ihi_R,jlh_R,jlh_R,dbl_mb(k_R),ne)
         sum = sum + ddot(ne,dbl_mb(k_R),1,dbl_mb(k_T),1)
c
        end do
       end do
      end do
c
      if (.not. ma_pop_stack(l_T)) call errquit('mapop T in cct_sum',0,
     &       MA_ERR)
      if (.not. ma_pop_stack(l_R)) call errquit('mapop R in cct_sum',0,
     &       MA_ERR)
c
      call ga_dgop(type_cct_sum,sum,1,'+')
c
      cct_sum = sum
c
      return
      end
      double precision function cct_sum_a1a(g_R,g_T,na,ne)
c
      implicit none
#include "errquit.fh"
c
c...  function to sum the partial contributions in global arrays R,T
c...  for "diagonal" A1A case  (so a=c)
c...  sum R(ae,cf)*T(af,ce)
c...  e and f are the fastest moving indices (and are "complete")
c...  this uses a bit of ga_memory which should be availabele
c
      integer g_R,g_T,na,ne
      integer g_RR,g_TT,a,ihi,ilo
      logical ga_create,ga_destroy
      double precision ga_ddot
c
#include "mafdecls.fh"
c
      if (.not.ga_create(MT_DBL,ne,ne,'A1A-aaRR',0,0,g_RR))
     1   call errquit('cannot create global A1A-RR',0, GA_ERR)
      if (.not.ga_create(MT_DBL,ne,ne,'A1A-aaTT',0,0,g_TT))
     1   call errquit('cannot create global A1A-TT',0, GA_ERR)
      call ga_zero(g_RR)
      call ga_zero(g_TT)
c
      do a=1,na
       ilo = (a-1)*ne+1
       ihi = ilo+ne-1
       call ga_add_patch(1.0d0,g_R,ilo,ihi,ilo,ihi,
     1                   1.0d0,g_RR,1,ne,1,ne,
     2                   1.0d0,g_RR,1,ne,1,ne)
       call ga_add_patch(1.0d0,g_T,ilo,ihi,ilo,ihi,
     1                   1.0d0,g_TT,1,ne,1,ne,
     2                   1.0d0,g_TT,1,ne,1,ne)
      end do
c
      cct_sum_a1a = ga_ddot(g_RR,g_TT)
c
      if (.not.ga_destroy(g_RR)) call errquit('cannot destroy RR',0,
     &       GA_ERR)
      if (.not.ga_destroy(g_TT)) call errquit('cannot destroy TT',0,
     &       GA_ERR)
c
      return
      end
      double precision function cct_uhf_T1
     1       (diagram,occupation,cases,ncase,type,
     2        value_X1X)
c
c...  CCT T1 diagram evaluator; modelled after the T2 version
c...  may well disappear and be replaced by ifs+comments
c
      implicit none
c
c     examples:
c
c     (c)T(k,c)*T<in||cb>  *  (aj)<ab||ij><an||kj>  (14B)
c                        or
c     (kc)T(k,c)T(kj,cf)  *  (ab)<ij||ab><fi||ab>  (12A)
c...  the kc contractions are sort of the diagonal of the c
c     they are ther for each case !!
c
c     the 4-4 contraction is always first
c     so the T1's follow ...
c
c     map to CCT T2 diagram evaluator; modelled for A3A
c     (ij)t(ij,ce)*t(ij,af)  *  (bk) <ba||ek><bc||fk>
c        T(ij)(ceaf)  (Y)           I(bk)(aecf) (X)
c
c     (j<=>k,a<=>b
c     (c)T(j,c)*T<in||ca>  *  (bk)<ba||ik><bn||jk>  (14B)
c     i=>e,n<=>c,j=>f (watch weighting) then n=>i
c     (i)T(f,i)*T<ec||ia>  *  (bk)<ba||ek><bc||fk>  (14B)
c     (and of course occupations not intentional)
c                 1 2 3 4  5 6  7 8
c                 a e c f  b k  i j  fac 
c                 b i n k  a j  c 0
c      rationale :
c        b,k (5,6) : summation indices of first contraction
c        i   (7)   : summation index of 2nd contract ; j=0
c        f   (4)   : other index of T1 (always occ)
c        still a,e / c,f on same
c      **this will allow it all in same routine**
c..     does require a bit of testing on j=0
c
c     *note*
c     b,k are running indices for first contraction type(*,1)
c     a,e are on same and c,f are on same "integral" for ,1
c     n is running index for second contraction type(*,2)
c     the second contraction is quite different (T1)
c     --------------------------------------------------------
c     e,f are complete ranges / a,c get batched
c     weights are applied to all except c (now)
c     --------------------------------------------------------
c     
c     *note* due to the t1 contraction that global  array is weird
c     also it's always a2a but differently
c
      integer occupation(9),ncase,cases(9,ncase)
      double precision value_X1X
      character*(*) diagram,type(2,2)
c
      return
      end
      subroutine mult_cct_t1(bb,kb,ke,eb,fb,
     1                    typeA,ab,ae, typeB,cb,ce,
     1                    g_RESULT)
c
      implicit none
#include "errquit.fh"
c*********************** incomplete develop
c
c...   general (:)) routine to do t1*t or t1*int (asymmetric)
c...   notation taken from 11A T1*T2 but translated a bit 
c...                  (c)T(k,c)*T(ij,cf) =>
c...                  (b)T(k,b)*T(ij,bf)
c...   should be able to do as well
c...                  (bk)T(k,b)*T(kj,bf)
c
c
#include "mafdecls.fh"
#include "cct_table_uhf.fh"
c
      integer g_RESULT
c
      integer bb,kb,ke,eb,fb,ab,ae,cb,ce
      character*(*) typeA,typeB
c
      logical ga_create,ga_destroy
      integer ga_memory_avail,ga_nnodes,avail_ga
      integer g_MATA,g_MATB,size
      integer se,sf,sbk,ee,fe,la,lc,lea,lcf,lbk,llbk,len
      integer batch,nbatch,bkb,bke
      integer spina,spine,spinc,spinf,spinb,spink
      integer occe,occf,occb,occk
      logical symmetric
c
c...   get available global memory
c
       avail_ga = ga_memory_avail()/8
       call ga_igop(13,avail_ga,1,'min')
c...    remember that there is overhead (in space) as well
        avail_ga = ga_nnodes()*avail_ga*0.9
c
c...  figure out spins
c
      spina = ispin(ab)
      spinc = ispin(cb)
      spine = ispin(eb)
      spinf = ispin(fb)
      spinb = ispin(bb)
      spink = ispin(kb)
c...  figure occupations (1=occ,2-virt)
      occe = iocc(eb)
      occf = iocc(fb)
      occb = iocc(bb)
      occk = iocc(kb)
c
      symmetric = (ab.eq.ae.and.cb.eq.ce.and.typeA.eq.typeB.and.
     1             spine.eq.spinf.and.spine.eq.spinf)
      size = avail_ga
      if (.not.symmetric) size = size/2
c
c...  can use symmetry to save a get; we have to use sqrt(fac) then
c
      if (iro(ae).ne.iro(ab)) call errquit('sym',0, UNKNOWN_ERR)
      if (iro(ce).ne.iro(cb)) call errquit('sym',0, UNKNOWN_ERR)
c
      sbk = mult(iro(bb),iro(kb))
      se = mult(iro(ab),sbk)
      sf = mult(iro(cb),sbk)
      eb = s_occ_virt(se,spine,occe)
      ee = s_occ_virt(se+1,spine,occe)-1
      fb = s_occ_virt(sf,spinf,occf)
      fe = s_occ_virt(sf+1,spinf,occf)-1
      la = ae-ab+1
      lc = ce-cb+1
      lea = (ee-eb+1)*la
      lcf = (fe-fb+1)*lc
      lbk = lenxy(sbk,spinb,spink,occb+occk)
      llbk = lbk
      len = lbk*(la+lc)*(ee-eb+1)*(fe-fb+1)
      nbatch = (size-1)/len + 1
      len = (lbk-1)/nbatch + 1
c
c...  get global integral array's
c
      if (.not.ga_create(MT_DBL,len,lea,'matA(a,e)',0,0,g_MATA))
     1   call errquit('matA',0, GA_ERR)
      if (.not.symmetric) then
       if (.not.ga_create(MT_DBL,len,lcf,'matA(c,f)',0,0,g_MATB))
     1     call errquit('matB',0, GA_ERR)
      end if
c
c
      bke = 0
      do batch=1,nbatch
       bkb = bke + 1
       bke = min(bke+len,llbk)
       lbk = (bke-bkb+1)
       call get_cct(g_MATA,typeA,bkb,bke,spinb,spink,
     1              eb,ee,spine,ab,ae,spina)
       if (.not.symmetric)
     1 call get_cct(g_MATB,typeB,bkb,bke,spinb,spink,
     2              fb,fe,spinf,ab,ae,spina)
c
c...  weigth mata (with sqrt(fac) if symmetric)
c
******       call cct_weigth(g_MATA,bkb,bke,sbk,spinb,spink,symmetric)
c   
       call ga_dgemm('T','N',lea,lcf,lbk,1.0d0,g_MATA,g_MATB,
     1               1.0d0,g_RESULT)
c
      end do
c
      if (symmetric) then
       if (.not.ga_destroy(g_MATB)) call errquit('destroy MATB',0,
     &       GA_ERR)
      end if
      if (.not.ga_destroy(g_MATA)) call errquit('destroy MATA',0,
     &       GA_ERR)
c
      return
      end

      subroutine tce_init_new(rtdb)
c
c $Id: tce_init_new.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Initialize for many-electron calculations.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "dra.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
#include "tce_prop.fh"
c
      integer rtdb             ! RTDB handle
      integer nbf_verify       ! nbf read from movecs_read_header
      integer ipol_verify      ! ipol read from movecs_read_header
      character*255 movecs_out ! MO vector file name
      character*255 title      ! Title
      character*255 basisname  ! Basis set name
      character*255 scftype    ! Type of SCF
      character*4 hftype
      character*3 onoff1,onoff2
      integer i,j,n
      integer nclosed, nopen
      double precision a
      character*60 ctype
      character*60 cperturbative
      integer itol2e
      logical nodezero
      logical dummy
      logical rohf
      logical int_normalize
      external int_normalize
      logical movecs_read,movecs_read_header
      external movecs_read,movecs_read_header
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
      logical xc_gotxc
      external xc_gotxc
      character*10 module
      character*8 multchar(8)
      data multchar/'singlet ','doublet ','triplet ','quartet ',
     1              'quintet ','sextet  ','septet  ','octet   '/
       character*26 date
       integer ma_type
c
c
      nodezero=(ga_nodeid().eq.0)
c
c     -----------------------
c     Initialize stop watches
c     -----------------------
c
      do i = 1,max_clocks
        cpusecs(i) = 0.0d0
      enddo
c
c     ---------------------
c     Geometry and symmetry
c     ---------------------
c
      bytes = ma_sizeof(mt_dbl,1,mt_byte)
      if (.not.geom_create(geom,'geometry'))
     1  call errquit('tce_init_new: geom_create failed',0,GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'geometry'))
     1  call errquit('tce_init_new: no geometry found',0,GEOM_ERR)
      if (.not.rtdb_get(rtdb,'dft:skeleton',mt_log,1,oskel)) then
        oskel=sym_number_ops(geom).gt.0
      endif
      if (.not.rtdb_get(rtdb,'dft:adapt',mt_log,1,oadapt)) then
        oadapt=sym_number_ops(geom).gt.0
      endif
      if (.not.sym_abelian_group(geom))
     1  call errquit('tce_init_new: non-Abelian symmetry not
     2                permitted',0,GEOM_ERR)
c
c     ---------
c     Basis set
c     ---------
c
      if (.not.bas_create(ao_bas_han,'ao basis'))
     1  call errquit('tce_init_new: bas_create failed',0,BASIS_ERR)
      if (.not.bas_rtdb_load(rtdb,geom,ao_bas_han,'ao basis'))
     1  call errquit('tce_init_new: no ao basis found',0,BASIS_ERR)
      if (.not.int_normalize(rtdb,ao_bas_han))
     1  call errquit('tce_init_new: int_normalize failed',0,INT_ERR)
      if (.not.bas_numbf(ao_bas_han,nbf))
     1  call errquit('tce_init_new: failed to read nbf',0,BASIS_ERR)
      if (.not.bas_numcont(ao_bas_han,nshells))
     1  call errquit('tce_init_new: failed to read nshells',0,BASIS_ERR)
c
c     ----------
c     MO vectors
c     ----------
c
      if (reference.eq.0) then
        if (.not.rtdb_cget(rtdb,'dft:output vectors',1,movecs_out))
     1    call errquit('tce_init_new: no final MO found',0,RTDB_ERR)
      else if (reference.eq.1) then
        if (.not.rtdb_cget(rtdb,'scf:output vectors',1,movecs_out))
     1    call errquit('tce_init_new: no final MO found',0,RTDB_ERR)
      endif
c
c     ------------------------------------------------------
c     Number of electrons and orbitals and spin multiplicity
c     ------------------------------------------------------
c
      if (reference.eq.0) then
        rohf = .false.
        if (.not.rtdb_get(rtdb,'dft:ipol',mt_int,1,ipol))
     1    call errquit('tce_init_new: failed to read ipol',0,RTDB_ERR)
        if (.not.rtdb_get(rtdb,'dft:noc',mt_int,2,nocc))
     1    call errquit('tce_init_new: failed to read nocc',0,RTDB_ERR)
        if (.not.rtdb_get(rtdb,'dft:mult',mt_int,1,mult))
     1    call errquit('tce_init_new: failed to read mult',0,RTDB_ERR)
        if (ipol.eq.1) then
          restricted = .true.
        else
          restricted = .false.
        endif
      else if (reference.eq.1) then
        if (.not.rtdb_get(rtdb,'scf:nclosed',mt_int,1,nclosed))
     1    call errquit('tce_init_new: failed to read
     2                  nclosed',0,RTDB_ERR)
        if (.not.rtdb_get(rtdb,'scf:nopen',mt_int,1,nopen))
     1    call errquit('tce_init_new: failed to read nopen',0,RTDB_ERR)
        nocc(1) = nclosed + nopen
        nocc(2) = nclosed
        mult = nopen + 1
        if(.not.rtdb_cget(rtdb,'scf:scftype',1,hftype))
     1    call errquit('tce_init_new: failed to read
     2                  scftype',0,RTDB_ERR)
        if (hftype.eq.'RHF') then
          restricted = .true.
          rohf = .false.
          ipol = 1
        else if (hftype.eq.'UHF') then
          restricted = .false.
          rohf = .false.
          ipol = 2
        else if(hftype.eq.'ROHF')then
          restricted = .false.
          rohf = .true.
          ipol = 2
        endif
      endif
c     ---------
c     TCE input
c     ---------
c
      if(.not. geom_freeze(rtdb, geom, 'tce', nfc(1))) then
         call errquit('tce_init_new: failed to get number of cores',0,
     1   GEOM_ERR)
      endif
      if (ipol.eq.2) nfc(2) = nfc(1)
      if (.not.rtdb_get(rtdb,'tce:frozen virtual',
     1  mt_int,1,nfv(1))) nfv(1) = 0
      if (ipol.eq.2) nfv(2) = nfv(1)
      if (.not.rtdb_cget(rtdb,'tce:module',1,module)) then
        module='tce'
      endif
      if (.not.rtdb_cget(rtdb,'tce:model2e',1,model2e))
     1  call errquit('tce_init_new: model2e not  specified',0,RTDB_ERR)
      if (.not.rtdb_cget(rtdb,'tce:model',1,model))
     1  call errquit('tce_init_new: no theory specified',0,RTDB_ERR)
      if (.not.rtdb_cget(rtdb,'tce:perturbative',1,perturbative)) then
        perturbative = 'none'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1  call errquit('tce_init_new: failed to write perturbative',0,
     2  RTDB_ERR)
      endif
      if (.not.rtdb_cget(rtdb,'tce:ccsdvar',1,ccsd_var)) then
        ccsd_var = 'none'
        if (.not.rtdb_cput(rtdb,'tce:ccsdvar',1,ccsd_var))
     1  call errquit('tce_init_new: failed to write ccsdvar',0,
     2  RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:thresh',mt_dbl,1,thresh)) then
        thresh = 1.0d-6
        if (.not.rtdb_put(rtdb,'tce:thresh',mt_dbl,1,thresh))
     1  call errquit('tce_init_new: failed to write thresh',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:zlshift',mt_dbl,1,zlshift)) then
        zlshift = 0.0d0
        if (.not.rtdb_put(rtdb,'tce:zlshift',mt_dbl,1,zlshift))
     1  call errquit('tce_init_new: failed to write zlshift',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:maxiter',mt_int,1,maxiter)) then
        maxiter = 100
        if (.not.rtdb_put(rtdb,'tce:maxiter',mt_int,1,maxiter))
     1  call errquit('tce_init_new: failed to write maxiter',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:ioalg',mt_int,1,ioalg)) then
        ioalg = 2
        if (.not.rtdb_put(rtdb,'tce:ioalg',mt_int,1,ioalg))
     1  call errquit('tce_init_new: failed to write ioalg',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:diis',mt_int,1,diis)) then
        diis = 5
        if (.not.rtdb_put(rtdb,'tce:diis',mt_int,1,diis))
     1  call errquit('tce_init_new: failed to write diis',0,RTDB_ERR)
      endif
      if (diis .gt. maxdiis) then
        diis = maxdiis
        if (.not.rtdb_put(rtdb,'tce:diis',mt_int,1,diis))
     1  call errquit('tce_init_new: failed to write diis',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:nroots',mt_int,1,nroots)) then
        nroots = 0
        if (.not.rtdb_put(rtdb,'tce:nroots',mt_int,1,nroots))
     1  call errquit('tce_init_new: failed to write nroots',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:hbard',mt_int,1,hbard)) then
        hbard = 500
        if (.not.rtdb_put(rtdb,'tce:hbard',mt_int,1,hbard))
     1  call errquit('tce_init_new: failed to write hbard',0,RTDB_ERR)
      endif
c 4index trans.
      if (.not.rtdb_get(rtdb,'tce:maxs',mt_int,1,imaxsize)) then
        imaxsize = 30
        if (.not.rtdb_put(rtdb,'tce:maxs',mt_int,1,imaxsize))
     1  call errquit('tce_init_new: failed to write maxs',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:ichopx',mt_int,1,ichop)) then
        ichop = 1
        if (.not.rtdb_put(rtdb,'tce:ichopx',mt_int,1,ichop))
     1  call errquit('tce_init_new: failed to write ichop',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:i4im',mt_int,1,fast2e)) then
        fast2e = 1
        if (.not.rtdb_put(rtdb,'tce:i4im',mt_int,1,fast2e))
     1  call errquit('tce_init_new: failed to write i4im',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:idiskx',mt_int,1,idisk)) then
        idisk = 0
        if (.not.rtdb_put(rtdb,'tce:idiskx',mt_int,1,idisk))
     1  call errquit('tce_init_new: failed to write idiskx',0,RTDB_ERR)
      endif
c CC2 and LR-CCSD
      if (.not.rtdb_cget(rtdb,'tce:ccsdvar',1,ccsd_var)) then
        ccsd_var='none'
        if (.not.rtdb_cput(rtdb,'tce:ccsdvar',1,ccsd_var))
     1  call errquit('tce_init_new: failed to write ccsdvar',0,RTDB_ERR)
      endif
c
      if (.not.rtdb_get(rtdb,'tce:target',mt_int,1,target)) then
         target=1
        if (.not.rtdb_put(rtdb,'tce:target',mt_int,1,target))
     1  call errquit('tce_init_new: failed to write target',0,RTDB_ERR)
      endif
      if (.not.rtdb_cget(rtdb,'tce:targetsym',1,targetsym)) then
        targetsym='none'
        if (.not.rtdb_cput(rtdb,'tce:targetsym',1,targetsym))
     1  call errquit('tce_init_new: failed to write
     2                targetsym',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:symmetry',mt_log,1,symmetry)) then
        symmetry=.false.
        if (.not.rtdb_put(rtdb,'tce:symmetry',mt_log,1,symmetry))
     1  call errquit('tce_init_new: failed to write
     2                symmetry',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:left',mt_log,1,left)) then
        left=.false.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1  call errquit('tce_init_new: failed to write left',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:multipole',mt_int,1,multipole)) then
        multipole=0
        if (.not.rtdb_put(rtdb,'tce:multipole',mt_int,1,multipole))
     1  call errquit('tce_init_new: failed to write
     2                multipole',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:diagnt1',mt_log,1,diagnt1)) then
        diagnt1=.false.
        if (.not.rtdb_put(rtdb,'tce:diagnt1',mt_log,1,diagnt1))
     1  call errquit('tce_init_new: failed to write diagnt1',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:ampnorms',mt_log,1,ampnorms)) then
        ampnorms=.false.
        if (.not.rtdb_put(rtdb,'tce:ampnorms',mt_log,1,ampnorms))
     1  call errquit('tce_init_new: failed to write
     2                ampnorms',0,RTDB_ERR)
      endif
c
c    Beginning of response property input section
c
      if (.not.rtdb_get(rtdb,'tce:lineresp',mt_log,1,lineresp)) then
        lineresp=.false.
        if (.not.rtdb_put(rtdb,'tce:lineresp',mt_log,1,lineresp))
     1  call errquit('tce_init_new: failed to write
     2                lineresp',0,RTDB_ERR)
      endif
      if (lineresp) then
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1  call errquit('tce_init_new: failed to write left',0,RTDB_ERR)
      endif
c
      if (.not.rtdb_get(rtdb,'tce:leftresp',mt_log,1,leftresp)) then
        leftresp=.false.
        if (.not.rtdb_put(rtdb,'tce:leftresp',mt_log,1,leftresp))
     1  call errquit('tce_init_new: failed to write
     2                leftresp',0,RTDB_ERR)
      endif
c
      if (.not.rtdb_get(rtdb,'tce:quadresp',mt_log,1,quadresp)) then
        quadresp=.false.
        if (.not.rtdb_put(rtdb,'tce:quadresp',mt_log,1,quadresp))
     1  call errquit('tce_init_new: failed to write
     2                quadresp',0,RTDB_ERR)
      endif
c
      if (.not.rtdb_get_info(rtdb,'tce:afreq',ma_type,anumfreq,
     1  date)) then
        anumfreq = 1
        if (.not.rtdb_put(rtdb,'tce:anumfreq',mt_int,1,anumfreq))
     1   call errquit('tce_init_new: failed to write
     2                anumfreq',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:afreq',mt_dbl,anumfreq,
     1  afreq)) then
        afreq(1) = 0.0d0
        if (.not.rtdb_put(rtdb,'tce:afreq',mt_dbl,anumfreq,afreq))
     1    call errquit('tce_init_new: failed to write afreq',0,RTDB_ERR)
      endif
c
      if (.not.rtdb_get_info(rtdb,'tce:bfreq',ma_type,bnumfreq,
     1  date)) then
        bnumfreq = 1
        if (.not.rtdb_put(rtdb,'tce:bnumfreq',mt_int,1,bnumfreq))
     1   call errquit('tce_init_new: failed to write
     2                bnumfreq',0,RTDB_ERR)
      endif
      if (.not.rtdb_get(rtdb,'tce:bfreq',mt_dbl,bnumfreq,
     1  bfreq)) then
        bfreq(1) = 0.0d0
        if (.not.rtdb_put(rtdb,'tce:bfreq',mt_dbl,bnumfreq,bfreq))
     1    call errquit('tce_init_new: failed to write bfreq',0,RTDB_ERR)
      endif
c
      if (.not.rtdb_get(rtdb,'tce:respaxis',mt_log,3,respaxis)) then
        respaxis(1) = .true.
        respaxis(2) = .true.
        respaxis(3) = .true.
        if (.not.rtdb_put(rtdb,'tce:respaxis',mt_log,3,respaxis))
     1    call errquit('tce_init_new: failed to write
     2                respaxis',0,RTDB_ERR)
      endif
c
c     End of response property input section
c
      if ((symmetry).and.(targetsym.eq.'none')) then
        symmetry=.false.
        if (.not.rtdb_put(rtdb,'tce:symmetry',mt_log,1,symmetry))
     1    call errquit('tce_init_new: failed to write
     2                symmetry',0,RTDB_ERR)
      endif
c
c     ----------------------
c     2-e integral tolerance
c     ----------------------
c
      if (reference.eq.0) then
        if (.not.rtdb_get(rtdb,'dft:itol2e',mt_int,1,itol2e))
     1    call errquit('tce_init_new: failed to read itol2e',0,RTDB_ERR)
        tol2e=10.0d0**(-itol2e)
      else if (reference.eq.1) then
        if (.not.rtdb_get(rtdb,'scf:tol2e',mt_dbl,1,tol2e))
     1    tol2e = 1.0d-10
      endif
c
c     ----------------------
c     2-e storage
c     ----------------------
c
      intorb=.false.
      if (model2e.eq.'2eorb') intorb=.true.
      if(intorb) then
      if(.not.(intorb.and.(hftype.eq.'RHF'.or.hftype.eq.'ROHF'))) then
        call errquit('tce_init_new: 2eorb needs RHF or ROHF
     2                ref.',0,RTDB_ERR)
      endif
      endif
c
c     --------------------------
c     Determine calculation type
c     --------------------------
c
      activecalc = .false.
c
      if (reference.eq.0) then
        if (xc_gotxc()) write(LuOut,9500)
      endif
      if ((perturbative.ne.'none').and.
     1    (model.ne.'ccsd').and.(model.ne.'ccsdt'))
     2  call errquit('tce_init_new: unknown theory',0,CAPMIS_ERR)
      cperturbative = 'none'
      if (model.eq.'ccd') then
        ctype='Coupled-cluster doubles'
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'uccd'))
     3    call errquit('tce_init_new: ucc/uccd module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'lccd') then
        ctype='Linearized coupled-cluster doubles'
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'ulccd'))
     3    call errquit('tce_init_new: ucc/ulccd module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'ccsd') then
        if (perturbative.eq.'none') then
          ctype='Coupled-cluster singles & doubles'
        else if (perturbative.eq.'(t)') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = '(T)'
        else if (perturbative.eq.'[t]') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = '[T] or +T(CCSD)'
        else if (perturbative.eq.'cr_(t)') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = 'Completely renormalized (T)'
        else if (perturbative.eq.'lr_(t)') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = 'locally renormalized (T)'
        else if (perturbative.eq.'lr_(tq1)') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = 'locally renormalized (TQ)-1'
        else if (perturbative.eq.'lr_(tq1p)') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = 'locally renormalized (TQ)'
        else if (perturbative.eq.'cr_[t]') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = 'Completely renormalized [T]'
        else if (perturbative.eq.'2_t') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = '(2) triples only'
        else if (perturbative.eq.'2_tq') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = '(2) triples & quadruples (nonfactorized)'
        else if (perturbative.eq.'emb1') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = 'reduced completely renorm. EOMCCSD(T)-I'
        else if (perturbative.eq.'emb2') then
         ctype='Coupled-cluster singles & doubles w/ perturbation'
         cperturbative = 'reduced completely renormalized EOMCCSD(T)-II'
        else if (perturbative.eq.'creom_(t)') then
          ctype='Coupled-cluster singles & doubles w/ perturbation'
          cperturbative = 'completely renormalized EOMCCSD(T)'
        endif
        if (model.eq.'ccsd') then
         if(ccsd_var.eq.'cc2') then
          ctype='CC2 calculations'
         end if
         if(ccsd_var.eq.'lr-ccsd') then
          ctype='Locally renormalized CCSD calculations'
         end if
        end if
c
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'uccsd').and.
     3      (module.ne.'uccsd(t)').and.
     4      (module.ne.'uccsd[t]').and.
     6      (module.ne.'cr-ccsd(t)').and.
     6      (module.ne.'lr-ccsd(t)').and.
     6      (module.ne.'lrsd(tq1p)').and.
     6      (module.ne.'lrsd(tq)-1').and.
     6      (module.ne.'creom_(t)').and.
     6      (module.ne.'emb1').and.
     6      (module.ne.'emb2').and.
     7      (module.ne.'cr-ccsd[t]'))
     8    call errquit('tce_init_new: ucc/uccsd module overridden',0,
     9    UNKNOWN_ERR)
      else if (model.eq.'lccsd') then
        ctype='Linearized coupled-cluster singles & doubles'
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'ulccsd'))
     3    call errquit('tce_init_new: ucc/ulccsd module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'ccsdta') then
        activecalc = .true.
        ctype='Coupled-cluster singles, doubles, & active triples'
        if (perturbative.eq.'2_q') then
          ctype='Coupled-cluster through triples w/ perturbation'
          cperturbative = '(2) quadruples (nonfactorized)'
        endif
         if(intorb) then
          call errquit('tce_init_new: 2eorb with active
     1                  calc.',0,RTDB_ERR)
         endif
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'uccsdt'))
     3    call errquit('tce_init_new: ucc/uccsdt module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'ccsdt') then
        ctype='Coupled-cluster singles, doubles, & triples'
        if (perturbative.eq.'2_q') then
          ctype='Coupled-cluster through triples w/ perturbation'
          cperturbative = '(2) quadruples (nonfactorized)'
        endif
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'uccsdt'))
     3    call errquit('tce_init_new: ucc/uccsdt module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'ccsdtq') then
        ctype='Coupled-cluster singles, doubles, triples, & quadruples'
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'uccsdtq'))
     3    call errquit('tce_init_new: ucc/uccsdtq module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'qcisd') then
        ctype='Quadratic configuration interaction singles & doubles'
        if ((module.ne.'tce').and.
     1      (module.ne.'ucc').and.
     2      (module.ne.'uqcisd'))
     3    call errquit('tce_init_new: ucc/uqcisd module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'cisd') then
        ctype='Configuration interaction singles & doubles'
        if ((module.ne.'tce').and.
     1      (module.ne.'uci').and.
     2      (module.ne.'ucisd'))
     3    call errquit('tce_init_new: uci/ucisd module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'cisdt') then
        ctype='Configuration interaction singles, doubles, & triples'
        if ((module.ne.'tce').and.
     1      (module.ne.'uci').and.
     2      (module.ne.'ucisdt'))
     3    call errquit('tce_init_new: uci/ucisdt module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'cisdtq') then
        ctype='Configuration interaction singles through quadruples'
        if ((module.ne.'tce').and.
     1      (module.ne.'uci').and.
     2      (module.ne.'ucisdtq'))
     3    call errquit('tce_init_new: uci/ucisdtq module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'mbpt2') then
        ctype='Second-order tensor many-body perturbation theory'
        if ((module.ne.'tce').and.
     1      (module.ne.'umbpt').and.
     2      (module.ne.'umbpt2'))
     3    call errquit('tce_init_new: umbpt/umbpt2 module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'mbpt3') then
        ctype='Third-order tensor many-body perturbation theory'
        if ((module.ne.'tce').and.
     1      (module.ne.'umbpt').and.
     2      (module.ne.'umbpt3'))
     3    call errquit('tce_init_new: umbpt/umbpt3 module overridden',0,
     4    UNKNOWN_ERR)
      else if (model.eq.'mbpt4') then
        ctype='Fourth-order tensor many-body perturbation theory'
        if ((module.ne.'tce').and.
     1      (module.ne.'umbpt').and.
     2      (module.ne.'umbpt4'))
     3    call errquit('tce_init_new: umbpt/umbpt4 module overridden',0,
     4    UNKNOWN_ERR)
      else
        call errquit('tce_init_new: unknown theory',0,CAPMIS_ERR)
      endif
c
c     -------------------------------------
c     Allocate global arrays for MO vectors
c     -------------------------------------
c
      do i=1,ipol
        if (.not.ma_push_get(mt_dbl,nbf,'eigenvalues',
     1    l_evl(i),k_evl(i))) call errquit
     2    ('tce_init_new: failed to allocate evl',0,MA_ERR)
        if (.not.ma_push_get(mt_dbl,nbf,'occupancy',
     1    l_occ(i),k_occ(i))) call errquit
     2    ('tce_init_new: failed to allocate occ',0,MA_ERR)
        if (.not.ma_push_get(mt_int,nbf,'irreps',
     1    l_irs(i),k_irs(i))) call errquit
     2    ('tce_init_new: failed to allocate irs',0,MA_ERR)
      enddo
      if (.not.movecs_read_header(movecs_out,title,basisname,
     1  scftype,nbf_verify,ipol_verify,nmo,2)) call errquit
     2  ('tce_init_new: failed to read MO file header',0,RTDB_ERR)
      if (nbf.ne.nbf_verify) call errquit
     1  ('tce_init_new: corrupted MO vectors',0,RTDB_ERR)
      if (rohf) nmo(2) = nmo(1)
      do i=1,ipol
        g_movecs(i)=ga_create_atom_blocked
     1    (geom,ao_bas_han,'MO eigenvectors')
        if (rohf.and.(i.eq.2)) then
          call ga_copy(g_movecs(1),g_movecs(2))
          do j = 1,nbf
            dbl_mb(k_evl(2)+j-1) = dbl_mb(k_evl(1)+j-1)
            dbl_mb(k_occ(2)+j-1) = dbl_mb(k_occ(1)+j-1)
          enddo
        else
          if (.not.movecs_read(movecs_out,i,
     1      dbl_mb(k_occ(i)),dbl_mb(k_evl(i)),g_movecs(i)))
     2      call errquit('tce_init_new: failed to read MO vectors',0,
     3      RTDB_ERR)
        endif
        if (util_print('MO vectors',print_debug)) then
          if (nodezero) call ma_print(dbl_mb(k_evl(i)),
     1      nbf,1,'Eigenvalues')
          if (nodezero) call ma_print(dbl_mb(k_occ(i)),
     1      nbf,1,'Occupancies')
          call ga_print(g_movecs(i))
        endif
      enddo
      if (reference.eq.0) then
        if (.not.rtdb_get(rtdb,'dft:alpha irreps',mt_int,
     1    nbf,int_mb(k_irs(1))))
     2    call errquit('tce_init_new: no alpha irreps found',0,RTDB_ERR)
      else if (reference.eq.1) then
        if (.not.rtdb_get(rtdb,'scf:alpha irreps',mt_int,
     1    nbf,int_mb(k_irs(1))))
     2    call errquit('tce_init_new: no alpha irreps found',1,RTDB_ERR)
      endif
      do i=1,nbf
        if (oadapt) then
          int_mb(k_irs(1)+i-1) = int_mb(k_irs(1)+i-1) - 1
        else
          int_mb(k_irs(1)+i-1) = 0
        endif
      enddo
      if (ipol.eq.2) then
        if (reference.eq.0) then
          if (.not.rtdb_get(rtdb,'dft:beta irreps',mt_int,
     1      nbf,int_mb(k_irs(2))))
     2      call errquit('tce_init_new: no beta irreps
     3                    found',0,RTDB_ERR)
        else if (reference.eq.1) then
          if (rohf) then
            do j = 1,nbf
              int_mb(k_irs(2)+j-1) = int_mb(k_irs(1)+j-1) + 1
            enddo
          else
            if (.not.rtdb_get(rtdb,'scf:beta irreps',mt_int,
     1        nbf,int_mb(k_irs(2))))
     2        call errquit('tce_init_new: no beta irreps
     3                      found',1,RTDB_ERR)
          endif
        endif
        do i=1,nbf
          if (oadapt) then
            int_mb(k_irs(2)+i-1) = int_mb(k_irs(2)+i-1) - 1
          else
            int_mb(k_irs(2)+i-1) = 0
          endif
        enddo
      endif
c
c     ---------------
c     Active orbitals
c     ---------------
c
      if(activecalc) THEN
      if (.not.rtdb_get(rtdb,'tce:active_oa',mt_int,1,oactive(1)))
     1  call errquit('tce_init_new: failed to read oactive',0,RTDB_ERR)
      if (.not.rtdb_get(rtdb,'tce:active_ob',mt_int,1,oactive(2)))
     1  call errquit('tce_init_new: failed to read oactive',0,RTDB_ERR)
      if (.not.rtdb_get(rtdb,'tce:active_va',mt_int,1,vactive(1)))
     1  call errquit('tce_init_new: failed to read oactive',0,RTDB_ERR)
      if (.not.rtdb_get(rtdb,'tce:active_vb',mt_int,1,vactive(2)))
     1  call errquit('tce_init_new: failed to read oactive',0,RTDB_ERR)
      if (.not.rtdb_get(rtdb,'tce:act_excit_lvl',mt_int,1,numact))
     1  call errquit('tce_init_new: failed to read numact',0,RTDB_ERR)
      if (restricted) then
        oactive(2) = oactive(1)
        vactive(2) = vactive(1)
      endif
      do i = 1, ipol
        if (oactive(i).gt.nocc(i)-nfc(i)) call errquit
     1  ('tce_init_new: reduce the active space',0,RTDB_ERR)
        if (vactive(i).gt.nmo(i)-nocc(i)-nfv(i)) call errquit
     1  ('tce_init_new: reduce the active space',0,RTDB_ERR)
      enddo
        if (numact.le.0.or.numact.gt.3) call errquit
     1  ('tce_init_new: change active excit. level: t3a_lvl',0,RTDB_ERR)
      do i = 1, ipol
        if (oactive(i).le.0) call errquit
     1  ('tce_init_new: incorrect size of active space',0,RTDB_ERR)
        if (vactive(i).le.0) call errquit
     1  ('tce_init_new: incorrect size of active space',0,RTDB_ERR)
      enddo
      end if
      if(.not.activecalc) THEN
       oactive(1) = 0
       oactive(2) = 0
       vactive(1) = 0
       vactive(2) = 0
      end if
c
c     ----------------------
c     Initialize integrators
c     ----------------------
c
      call int_init(rtdb,1,ao_bas_han)
      call schwarz_init(geom,ao_bas_han)
c
c     ----------------------
c     Initialize file system
c     ----------------------
c
      nfiles = 0
      if (ioalg.eq.5) then
        if (dra_init(max_files,1.0d11,1.0d11,
     1    dfloat(buffer_size)*dfloat(bytes)).ne.0)
     2    call errquit('tce_init_new: dra initialization failed',0,
     3    DISK_ERR)
      endif
c
c     -------------
c     Printing info
c     -------------
c
      if (nodezero.and.util_print('information',print_low)) then
        call util_print_centered
     1  (LuOut,'NWChem Extensible Many-Electron Theory Module',
     2   40,.true.)
        write(LuOut,*)
        call util_print_centered
     1  (LuOut,'======================================================',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'This portion of the program was automatically',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'generated by a Tensor Contraction Engine (TCE).',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'The development of this portion of the program',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'and TCE was supported by US Department of Energy,',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'Office of Science, Office of Basic Energy Science.',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'TCE is a product of Battelle and PNNL.',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'Please cite: S.Hirata, J.Phys.Chem.A 107, 9887 (2003).',
     2  40,.false.)
        call util_print_centered
     1  (LuOut,'======================================================',
     2  40,.false.)
        write(LuOut,*)
        if (title.ne.' ') then
          call util_print_centered(LuOut,title,40,.false.)
          write(LuOut,*)
          write(LuOut,*)
        endif
      endif
      if (nodezero.and.util_print('general information',
     1  print_default)) then
        call util_print_centered
     1    (LuOut,'General Information',20,.true.)
        write(LuOut,9200) ga_nnodes()
        if (ipol.eq.1) then
          if (reference.eq.0) then
            write(LuOut,9010) 'Restricted Kohn-Sham'
          else if (reference.eq.1) then
            write(LuOut,9010) 'Restricted Hartree-Fock'
          endif
          write(LuOut,9030) nocc(1)*2,nocc(1),nocc(1)
        else if (ipol.eq.2) then
          if (reference.eq.0) then
            write(LuOut,9010) 'Unrestricted Kohn-Sham'
          else if (reference.eq.1) then
            if (rohf) then
              write(LuOut,9010) 'Restricted open-shell Hartree-Fock'
            else
              write(LuOut,9010) 'Unrestricted Hartree-Fock'
            endif
          endif
          write(LuOut,9030) nocc(1)+nocc(2),nocc(1),nocc(2)
        endif
        if (ipol.eq.1) then
          write(LuOut,9410) nmo(1)*2,nmo(1),nmo(1)
        else if (ipol.eq.2) then
          write(LuOut,9410) nmo(1)+nmo(2),nmo(1),nmo(2)
        endif
        if (ipol.eq.1) then
          write(LuOut,9430) nfc(1),nfc(1)
        else if (ipol.eq.2) then
          write(LuOut,9430) nfc(1),nfc(2)
        endif
        if (ipol.eq.1) then
          write(LuOut,9440) nfv(1),nfv(1)
        else if (ipol.eq.2) then
          write(LuOut,9440) nfv(1),nfv(2)
        endif
        if(activecalc) then
         write(LuOut,9540) oactive(1),oactive(2)
         write(LuOut,9550) vactive(1),vactive(2)
         write(LuOut,9555) numact
        end if
        write(LuOut,9420) multchar(mult)
        write(LuOut,9050) nbf
        write(LuOut,9060) nshells
        if (oskel) then
          onoff1='on '
        else
          onoff1='off'
        endif
        if (oadapt) then
          onoff2='on '
        else
          onoff2='off'
        endif
        write(LuOut,9040) onoff1,onoff2
        write(LuOut,9100) tol2e
        if (ipol.eq.1) then
          if (nmo(1).lt.nbf) write(LuOut,9400)
        else
          if ((nmo(1).lt.nbf).or.(nmo(2).lt.nbf))
     1      write(LuOut,9400)
        endif
      endif
      if (nodezero.and.util_print('correlation information',
     1  print_default)) then
        write(LuOut,*)
        call util_print_centered
     1    (LuOut,'Correlation Information',20,.true.)
        write(LuOut,9000) ctype
        write(LuOut,9230) cperturbative
        write(LuOut,9130) maxiter
        write(LuOut,9110) thresh
        write(LuOut,9115) zlshift
        if (diis .gt. 0) then
          write(LuOut,9150) diis,'-th order DIIS'
        else
          write(LuOut,9160) 'Jacobi'
        endif
        if (nroots .gt. 0) then
          write(LuOut,9170) nroots
          write(LuOut,9180) target
          write(LuOut,9190) targetsym
          if (symmetry) then
            write(LuOut,9210) 'on '
          else
            write(LuOut,9210) 'off'
          endif
          if (left) then
            write(LuOut,9220) 'on '
          else
            write(LuOut,9220) 'off'
          endif
        endif
        if (ioalg.eq.0) then
          write(LuOut,9140) 'Fortran77 Direct Access'
        else if (ioalg.eq.1) then
          write(LuOut,9140) 'Exclusive Access File Library'
        else if (ioalg.eq.2) then
          write(LuOut,9140) 'Global Array Library'
        else if (ioalg.eq.3) then
          write(LuOut,9140) 'Shared File Library'
        else if (ioalg.eq.4) then
          write(LuOut,9140) 'Replicated Exclusive Access Files'
        else if (ioalg.eq.5) then
          write(LuOut,9140) 'Disk Resident Array Algorithm'
        else if (ioalg.eq.6) then
          write(LuOut,9140) 'GA/EAF Replicated Algorithm'
        else
          call errquit('tce_init_new: unknown I/O
     1                  scheme',ioalg,CAPMIS_ERR)
        endif
      endif
      if (nodezero) call util_flush(LuOut)
 9200 format(3x,'   Number of processors :',2x,i4)
 9000 format(3x,'       Calculation type : ',a)
 9230 format(3x,'Perturbative correction : ',a)
 9010 format(3x,'      Wavefunction type : ',a)
 9030 format(3x,'       No. of electrons :',2x,i4,/,
     1       3x,'        Alpha electrons :',2x,i4,/,
     2       3x,'         Beta electrons :',2x,i4)
 9410 format(3x,'        No. of orbitals :',2x,i4,/,
     1       3x,'         Alpha orbitals :',2x,i4,/,
     2       3x,'          Beta orbitals :',2x,i4)
 9430 format(3x,'     Alpha frozen cores :',2x,i4,/,
     1       3x,'      Beta frozen cores :',2x,i4)
 9440 format(3x,'  Alpha frozen virtuals :',2x,i4,/,
     1       3x,'   Beta frozen virtuals :',2x,i4)
 9420 format(3x,'      Spin multiplicity : ',a)
 9040 format(3x,'     Use of symmetry is : ',a3,/,
     1       3x,'   Symmetry adaption is : ',a3)
 9050 format(3x,' Number of AO functions :',2x,i4)
 9060 format(3x,'    Number of AO shells :',2x,i4)
 9100 format(3x,'      Schwarz screening : ',d8.2)
 9110 format(3x,'     Residual threshold : ',d8.2)
 9115 format(3x,'       DIIS level shift : ',d8.2)
 9130 format(3x,'         Max iterations :',2x,i7)
 9140 format(3x,'             I/O scheme : ',a)
 9150 format(3x,'       Amplitude update : ',i2,a)
 9160 format(3x,'       Amplitude update : ',a)
 9170 format(3x,'  No. of excited states :',2x,i4)
 9180 format(3x,'            Target root :',2x,i4)
 9190 format(3x,'        Target symmetry :',1x,a4)
 9210 format(3x,'   Symmetry restriction :',1x,a3)
 9220 format(3x,'Dipole & oscillator str :',1x,a3)
 9400 format(/,2x,
     1  '!! WARNING !! The number of MO is less than the number of AO')
 9500 format(/,2x,
     1  '!! WARNING !! A non-HF reference wave function')
 9540 format(3x,' Alpha active occupieds :',2x,i4,/,
     1       3x,'  Beta active occupieds :',2x,i4)
 9550 format(3x,'  Alpha active virtuals :',2x,i4,/,
     1       3x,'   Beta active virtuals :',2x,i4)
 9555 format(3x,'  T3 active excitation level :',2x,i4)
c
c     ------
c     Return
c     ------
c
      return
      end

      subroutine hf1_tran_shift(Gab,Gabcp,ngen,la,lb,nca,ncb)
* $Id: hf1_tran.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
      integer la, lb
      integer nca, ncb
      integer ngen
      double precision
     &      Gabcp(1:((lb+1)*(lb+2)/2),1:((la+1)*(la+2)/2),ngen)
      double precision
     &      Gab(1:ncb*((lb+1)*(lb+2)/2),1:nca*((la+1)*(la+2)/2))
c
      integer kgen, igen, la2, lb2, ninta, nintb
      integer ica, icb, ia, ib
c
      la2 = (la+1)*(la+2)/2
      lb2 = (lb+1)*(lb+2)/2
*      write(6,*)' nca     = ',nca
*      write(6,*)' ncb     = ',ncb
*      write(6,*)' la/la2  = ',la,la2
*      write(6,*)' lb/lb2  = ',lb,lb2
      igen = 0
      do ica = 1,nca
        do icb = 1,ncb
          kgen = igen + 1
          do ia = 1,la2
            ninta=(ica-1)*la2+ia
            do ib = 1,lb2
              nintb=(icb-1)*lb2+ib
*              write(6,*)'nintb,ninta,ib,ia,kgen,igen',
*     &              nintb,ninta,ib,ia,kgen,igen,ica,icb
              Gab(nintb,ninta) = Gabcp(ib,ia,kgen)
            enddo
          enddo
          igen = igen + 1
        enddo
      enddo
c
*      igen = 0
*      do ica = 1,nca
*        do icb = 1,ncb
*          igen = igen + 1
*          write(6,*)' ica ',ica,' icb ',icb,' igen ',igen
*        enddo
*      enddo
*      do igen = 1,ngen
*        write(6,*)' gabcp matrix for general contraction ',igen
*        call output(gabcp(1,1,igen),1,lb2,1,la2,lb2,la2,1)
*      enddo
*      igen = 0
*      kgen = 0
*      do ica = 1,nca
*        do icb = 1,ncb
*          igen = igen + 1
*          do ia = 1,la2
*            do ib = 1,lb2
*              if (abs(gabcp(ib,ia,igen)).gt.1.0d-08) then
*                kgen = kgen + 1
*              endif
*            enddo
*          enddo
*        enddo
*      enddo
*      write(6,*)' number of non-zero gabcp elements ',kgen
*      write(6,*)' gab transformed '
*      call output(gab,1,(lb2*ncb),1,(la2*nca),(lb2*ncb),(la2*nca),1)
*      kgen = 0
*      do ia = 1,(nca*la2)
*        do ib = 1,(ncb*lb2)
*          if (abs(gab(ib,ia)).gt.1.0d-08) then
*            kgen = kgen + 1
*          endif
*        enddo
*      enddo
*      write(6,*)' number of non-zero gab elements ',kgen
c
      end
      subroutine hf1_tran_gen(gctrana,gctranb,PAIRp,NPP,
     &      Acoefs,NPA,NCA,Bcoefs,NPB,NCB)
      implicit none
c
c      form the general contraction transformation matrix for 1e (2 index quantities)
c
#include "stdio.fh"
c::passed
      integer NPP  ! [input] number of primitive pairs used on center P (=A,B)
      integer NPA  ! [input] number of primitives on center A
      integer NPB  ! [input] number of primitives on center B
      integer NCA  ! [input] number of contractions on center A
      integer NCB  ! [input] number of contractions on center B
      integer PAIRp (2,NPP) ! [input] kept indices of contraction coeffs
      double precision Acoefs(NPA,NCA) ! [input] conctraction coeffs on center A
      double precision Bcoefs(NPB,NCB) ! [input] conctraction coeffs on center B
      double precision gctrana(NPP,NCA) ! [output] general contraction coefs for A multiply
      double precision gctranb(NCB,NPP) ! [output] general contraction coefs for B multiply
c::local
      integer ica,icb,ipp
c
      do 00100 ica = 1,NCA
        do 00200 ipp = 1,NPP
*          write(6,*)' ica,ipp,pair = ',ica, ipp,PAIRP(1,ipp)
          gctrana(ipp,ica) = Acoefs(PAIRP(1,ipp),ica)
00200   continue
00100 continue
      do 00300 icb = 1,NCB
        do 00400 ipp = 1,NPP
*          write(6,*)' icb,ipp,pair = ',icb, ipp,PAIRP(2,ipp)
          gctranb(icb,ipp) = Bcoefs(PAIRP(2,ipp),icb)
00400   continue
00300 continue
      end

      subroutine tce_mrcc_diis_tidy
c
c     Terminates the DIIS
c
      implicit none
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
      integer i,iref
c
      do iref=1,maxref
      do i = 1,maxdiism
        if (t1_diis_existm(i,iref))
     1    call deletefile(t1_diism(i,iref)) 
        if (r1_diis_existm(i,iref))
     1    call deletefile(r1_diism(i,iref)) 
        if (t2_diis_existm(i,iref))
     1    call deletefile(t2_diism(i,iref)) 
        if (r2_diis_existm(i,iref))
     1    call deletefile(r2_diism(i,iref)) 
        if (t3_diis_existm(i,iref))
     1    call deletefile(t3_diism(i,iref)) 
        if (r3_diis_existm(i,iref))
     1    call deletefile(r3_diism(i,iref)) 
        if (t4_diis_existm(i,iref))
     1    call deletefile(t4_diism(i,iref)) 
        if (r4_diis_existm(i,iref))
     1    call deletefile(r4_diism(i,iref)) 
      enddo
      enddo

      return
      end
c $Id: tce_mrcc_diis_tidy.F 24345 2013-06-22 06:19:30Z d3y133 $

      logical function argos_prep_seqsiz(lfnout,lfnseq,filseq,nseq,nlnk)
c
c $Id: argos_prep_seqsiz.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to scan the sequence file for the number of segments
c
      implicit none
c
#include "util.fh"
c
      integer lfnout,lfnseq,nseq,nlnk
      character*255 filseq
      character*80 card
      integer length,ival,ncrd,ncnt
c
      length=index(filseq,' ')-1
      open(unit=lfnseq,file=filseq(1:length),form='formatted',
     + status='old',err=9999)
c
      nseq=0
      nlnk=0
      ncnt=1
      ncrd=0
c
    1 continue
      read(lfnseq,1000,end=9999,err=9999) card
 1000 format(a)
      if(ncrd.eq.0) ncnt=1
      if(ncrd.gt.0) ncrd=ncrd-1
      if(card(1:4).eq.'stop') goto 9
      if(card(1:6).eq.'repeat') then
      read(card,1002) ncrd,ncnt
 1002 format(6x,2i5)
      goto 1
      endif
      if(card(1:4).eq.'link') then
      nlnk=nlnk+1
      goto 1
      endif
      if(card(1:4).eq.'LINK') then
      nlnk=nlnk+1
      goto 1
      endif
c
      read(card(1:5),1001,err=1) ival
 1001 format(i5)
      nseq=nseq+ncnt
      goto 1
c
    9 continue
c
      close(unit=lfnseq)
c
      argos_prep_seqsiz=.true.
      return
c
 9999 continue
      argos_prep_seqsiz=.false.
      return
      end

      subroutine argos_cafe_parq(ia,chgi)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer ia
      real*8 chgi(24,3)
c
      integer i
c
      if(ia.lt.1.or.ia.gt.mqt) call md_abort('Error in parq',0)
c
      call argos_cafe_copyq(ia,chgi,dbl_mb(i_chg))
c
      if(lfree) then
      do 1 i=1,2
      if(abs(chgi(1,i)-chgi(2,i)).gt.tiny) ip2(15+i)=.true.
      if(abs(chgi(1,i)-chgi(3,i)).gt.tiny) ip3(15+i)=.true.
      if(abs(chgi(2,i)-chgi(3,i)).gt.tiny) ith(15+i)=.true.
    1 continue
      endif
c
      return
      end
c $Id: argos_cafe_parq.F 21176 2011-10-10 06:35:49Z d3y133 $

       subroutine omega2_mult(ilo,ihi,jlo,jhi,klo,khi,llo,lhi,
     &                   ish,jsh,ksh,lsh,G,ng,gJ,omega2)
       implicit none
c
c  this routine multiplies the integrals and density product, G,
c  and returns the contribution to the 2e part of Vab.
c
c  variables are defined in et_dens_mult.F
c
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "apiP.fh"
#include "bas.fh"
#include "geom.fh"
c
       integer ng
       integer i,j,k,l
       integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi 
       integer ish, jsh, ksh, lsh
       integer maxj, maxk, maxl
       double precision gJ(llo:lhi,klo:khi,jlo:jhi,ilo:ihi)
       double precision G(ng)
       double precision omega2
c
c  initialize omega2 and ng
c  =========================
c
       omega2 = 0.0d0
       ng = 0
c
c  loop over bf indices
c  ===================
c
      do i = ilo, ihi
c
          maxj = jhi
          if(jsh.eq.ish) maxj = i
          do j = jlo, maxj
c
            maxk = khi
            if(ksh.eq.ish.AND.jsh.eq.lsh) maxk = i
            do k = klo, maxk
c
              maxl = lhi
              if(lsh.eq.ksh) maxl = k
              if(ish.eq.ksh.AND.jsh.eq.lsh.AND.k.eq.i) maxl=j
              do l = llo, maxl
c
             ng = ng + 1
c
               omega2 = omega2 + gJ(l,k,j,i)*G(ng)
c
               enddo
            enddo
         enddo
      enddo
c
 1111 format (2(F20.16),4x,2(F20.16))
       return
       end


c $Id: et_omega2_mult.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_congra(iwdt,xw,yw,vw,fw,pcgw,
     + isdt,xs,ys,vs,fs,pcgs,ww,ws)
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      logical frequency
      external frequency
c
      integer iwdt(mwm),isdt(msa)
      real*8 xw(mwm,3,mwa),yw(mwm,3,mwa),vw(mwm,3,mwa),fw(mwm,3,mwa)
      real*8 xs(msa,3),ys(msa,3),vs(msa,3),fs(msa,3)
      real*8 pcgw(mwm,3,mwa),pcgs(msa,3),ww(mwa),ws(msa)
c
      integer iwa,iwm,isa,ix,inner
      logical ldone
      real*8 alpha,beta1,beta2,beta3,beta4,beta5,gamma,zeta
      real*8 dx,ecgnew,eqrs,ecgold,ecgdif,edt,dxf
      real*8 dxsmax,dxwmax,fnorm1,fnorm2,ypa,ypb,pnorm,dxstep
      real*8 dxmax,dxfi,ecg0,ecg1,ecg2,epcgw,epcgsw,epcgs
      character*1 cqrs
c
      if(me.eq.0) write(lfnout,1000)
 1000 format(/,' CONJUGATE GRADIENT MINIMIZATION',//,
     + '   Step File     Energy       Energy       Energy   ',
     + '    Energy       Energy     Largest  ',/,
     + '        wrt     gradient       Total      solvent   ',
     + '   slv-sol       solute  displacement',/,
     + '                 kJ/mol       kJ/mol       kJ/mol   ',
     + '    kJ/mol       kJ/mol        nm',/)
c
      dx=dx0cg
      beta1=zero
      icgit=0
      lpair=.true.
      lload=.true.
      lhop=.false.
c
      call timer_start(201)
c
c     atomic forces and potential energies
c
      call argos_finit(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs),
     + dbl_mb(i_xsm),dbl_mb(i_xsmp))
      call argos_forces(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs))
c
      call argos_prop_proper(isdit,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme,
     + epot,epotw,epotsw,epots,volume,dwr,dbl_mb(i_dsr),ekin,etot,
     + npolit,dbl_mb(i_gsm),dbl_mb(i_esa),box,dbl_mb(i_xsm))
c
      ecgnew=epot
      eqrs=epot
      ecgold=ecgnew
      ecgdif=zero
      edt=zero
c
c     copy initial coordinates into vw and vs
c     initialize search direction vectors pcgw and pcgs to zero
c
      if(nwmloc.gt.0) then
      do 1 iwa=1,nwa
      do 2 ix=1,3
      do 3 iwm=1,nwmloc
      vw(iwm,ix,iwa)=xw(iwm,ix,iwa)
      pcgw(iwm,ix,iwa)=zero
    3 continue
    2 continue
    1 continue
      endif
      if(nsaloc.gt.0) then
      do 4 ix=1,3
      do 5 isa=1,nsaloc
      vs(isa,ix)=xs(isa,ix)
      pcgs(isa,ix)=zero
    5 continue
    4 continue
      endif
c
c     take one steepest descent step to get initial search direction
c
      dxf=half*dx/fmax
      if(nwmloc.gt.0) then
      do 6 iwa=1,nwa
      do 7 ix=1,3
      do 8 iwm=1,nwmloc
      yw(iwm,ix,iwa)=xw(iwm,ix,iwa)
      if(iand(iwdt(iwm),mfixed).ne.lfixed) then
      xw(iwm,ix,iwa)=xw(iwm,ix,iwa)+dxf*fw(iwm,ix,iwa)/ww(iwa)
      endif
    8 continue
    7 continue
    6 continue
      endif
      if(nsaloc.gt.0) then
      do 9 ix=1,3
      do 10 isa=1,nsaloc
      ys(isa,ix)=xs(isa,ix)
      if(iand(isdt(isa),mfixed).ne.lfixed) then
      xs(isa,ix)=xs(isa,ix)+dxf*fs(isa,ix)/ws(isa)
      endif
   10 continue
    9 continue
      endif
c
c     shake
c
      call argos_shake(dbl_mb(i_xw),dbl_mb(i_yw),int_mb(i_iw),
     + dbl_mb(i_xs),dbl_mb(i_ys),int_mb(i_is),dxmax)
c
      fnorm1=zero
      dxfi=one/dxf
      if(nwmloc.gt.0) then
      do 11 iwa=1,nwa
      do 12 ix=1,3
      do 13 iwm=1,nwmloc
      fw(iwm,ix,iwa)=(xw(iwm,ix,iwa)-yw(iwm,ix,iwa))*dxfi*ww(iwa)
      fnorm1=fnorm1+fw(iwm,ix,iwa)**2
   13 continue
   12 continue
   11 continue
      endif
      if(nsaloc.gt.0) then
      do 14 ix=1,3
      do 15 isa=1,nsaloc
      fs(isa,ix)=(xs(isa,ix)-ys(isa,ix))*dxfi*ws(isa)
      fnorm1=fnorm1+fs(isa,ix)**2
   15 continue
   14 continue
      endif
c
c     global sum fnorm1
c
      call ga_dgop(mrg_d08,fnorm1,1,'+')
c
      ecg0=ecgnew
      ecg1=ecgnew
      ecg2=ecgnew
      icgit=0
c
      call timer_stop(201)
c
c     outer loop
c
  100 continue
c
      if(icgit.eq.(icgit/ncgcy)*ncgcy) beta1=zero
      icgit=icgit+1
      lpair=frequency(icgit,nfpair)
      lload=frequency(icgit,nfload)
      lhop=.false.
c
      ypa=zero
      pnorm=zero
      if(nwmloc.gt.0) then
      do 16 iwa=1,nwa
      do 17 ix=1,3
      do 18 iwm=1,nwmloc
      pcgw(iwm,ix,iwa)=fw(iwm,ix,iwa)+beta1*pcgw(iwm,ix,iwa)
      pnorm=pnorm+pcgw(iwm,ix,iwa)**2
      ypa=ypa+pcgw(iwm,ix,iwa)*fw(iwm,ix,iwa)
   18 continue
   17 continue
   16 continue
      endif
      if(nsaloc.gt.0) then
      do 19 ix=1,3
      do 20 isa=1,nsaloc
      pcgs(isa,ix)=fs(isa,ix)+beta1*pcgs(isa,ix)
      pnorm=pnorm+pcgs(isa,ix)**2
      ypa=ypa+pcgs(isa,ix)*fs(isa,ix)
   20 continue
   19 continue
      endif
c
c     accumulate pnorm
c
      call ga_dgop(mrg_d09,ypa,1,'+')
      call ga_dgop(mrg_d10,pnorm,1,'+')
c
      if(pnorm.lt.zero) call md_abort('congra: pnorm<zero',0)
      pnorm=sqrt(pnorm)
c
      alpha=zero
      ecg1=ecg2
      beta2=dx/pnorm
      inner=0
c
c     inner loop
c
  200 continue
      call timer_start(201)
c
      inner=inner+1
c
      if(nwmloc.gt.0) then
      do 21 iwa=1,nwa
      do 22 ix=1,3
      do 23 iwm=1,nwmloc
      if(iand(iwdt(iwm),mfixed).ne.lfixed) then
      xw(iwm,ix,iwa)=vw(iwm,ix,iwa)+beta2*pcgw(iwm,ix,iwa)/ww(iwa)
      endif
   23 continue
   22 continue
   21 continue
      endif
      if(nsaloc.gt.0) then
      do 24 ix=1,3
      do 25 isa=1,nsaloc
      if(iand(isdt(isa),mfixed).ne.lfixed) then
      xs(isa,ix)=vs(isa,ix)+beta2*pcgs(isa,ix)/ws(isa)
      endif
   25 continue
   24 continue
      endif
c
c     atomic forces and potential energies
c
      call argos_finit(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs),
     + dbl_mb(i_xsm),dbl_mb(i_xsmp))
      call argos_forces(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs))
      call argos_em_fnorm(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs))
c
      lpair=.false.
      lload=.false.
      lhop=.false.
c
      beta3=beta2*pnorm/fnorm
c
      if(nwmloc.gt.0) then
      do 26 iwa=1,nwa
      do 27 ix=1,3
      do 28 iwm=1,nwmloc
      yw(iwm,ix,iwa)=xw(iwm,ix,iwa)
      dxstep=beta3*fw(iwm,ix,iwa)/ww(iwa)
      if(iand(iwdt(iwm),mfixed).ne.lfixed) then
      xw(iwm,ix,iwa)=yw(iwm,ix,iwa)+dxstep
      endif
   28 continue
   27 continue
   26 continue
      endif
      if(nsaloc.gt.0) then
      do 29 ix=1,3
      do 30 isa=1,nsaloc
      ys(isa,ix)=xs(isa,ix)
      dxstep=beta3*fs(isa,ix)/ws(isa)
      if(iand(isdt(isa),mfixed).ne.lfixed) then
      xs(isa,ix)=ys(isa,ix)+dxstep
      endif
   30 continue
   29 continue
      endif
c
c     shake
c
      call argos_shake(dbl_mb(i_xw),dbl_mb(i_yw),int_mb(i_iw),
     + dbl_mb(i_xs),dbl_mb(i_ys),int_mb(i_is),dxmax)
c
c     find constrained forces
c
      ypb=zero
      if(nwmloc.gt.0) then
      do 34 iwa=1,nwa
      do 35 ix=1,3
      do 36 iwm=1,nwmloc
      fw(iwm,ix,iwa)=(xw(iwm,ix,iwa)-yw(iwm,ix,iwa))*ww(iwa)/beta3
      ypb=ypb+pcgw(iwm,ix,iwa)*fw(iwm,ix,iwa)
   36 continue
   35 continue
   34 continue
      endif
      if(nsaloc.gt.0) then
      do 37 ix=1,3
      do 38 isa=1,nsaloc
      fs(isa,ix)=(xs(isa,ix)-ys(isa,ix))*ws(isa)/beta3
      ypb=ypb+pcgs(isa,ix)*fs(isa,ix)
   38 continue
   37 continue
      endif
      call ga_dgop(mrg_d11,ypb,1,'+')
c
      call argos_prop_proper(isdit,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme,
     + epot,epotw,epotsw,epots,volume,dwr,dbl_mb(i_dsr),ekin,etot,
     + npolit,dbl_mb(i_gsm),dbl_mb(i_esa),box,dbl_mb(i_xsm))
c
      ecg2=epot
      epcgw=epotw
      epcgsw=epotsw
      epcgs=epots
      ecgdif=ecg2-ecgold
      edt=ecg2-ecg0
      call timer_stop(201)
c
c     check if interval is appropriate
c
      if(ypb.ge.zero.and.ecg2.lt.ecg1) then
      alpha=beta2
      ecg1=ecg2
      ypa=ypb
      beta2=two*beta2
      goto 200
      endif
      call timer_start(201)
c
c     find interpolation in interval
c
      zeta=three*(ecg1-ecg2)/(beta2-alpha)-ypa-ypb
      gamma=zeta**2-ypa*ypb
c
      if(gamma.lt.zero) then
      gamma=zero
      else
      gamma=sqrt(gamma)
      endif
c
      beta4=beta2-(gamma-zeta-ypb)*(beta2-alpha)/(ypa-ypb+two*gamma)
c
c     advance coordinates to interpolated point
c
      dxmax=zero
      if(nwmloc.gt.0) then
      do 39 iwa=1,nwa
      do 40 ix=1,3
      do 41 iwm=1,nwmloc
      yw(iwm,ix,iwa)=vw(iwm,ix,iwa)
      dxstep=beta4*pcgw(iwm,ix,iwa)/ww(iwa)
      if(iand(iwdt(iwm),mfixed).ne.lfixed) then
      xw(iwm,ix,iwa)=vw(iwm,ix,iwa)+dxstep
      if(abs(dxstep).gt.dxmax) dxmax=abs(dxstep)
      endif
   41 continue
   40 continue
   39 continue
      endif
      if(nsaloc.gt.0) then
      do 42 ix=1,3
      do 43 isa=1,nsaloc
      ys(isa,ix)=vs(isa,ix)
      dxstep=beta4*pcgs(isa,ix)/ws(isa)
      if(iand(isdt(isa),mfixed).ne.lfixed) then
      xs(isa,ix)=vs(isa,ix)+dxstep
      if(abs(dxstep).gt.dxmax) dxmax=abs(dxstep)
      endif
   43 continue
   42 continue
      endif
      call ga_dgop(mrg_d12,dxmax,1,'max')
c
c     shake
c
      call argos_shake(dbl_mb(i_xw),dbl_mb(i_yw),int_mb(i_iw),
     + dbl_mb(i_xs),dbl_mb(i_ys),int_mb(i_is),dxmax)
c
c     atomic forces and potential energies
c
      call argos_finit(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs),
     + dbl_mb(i_xsm),dbl_mb(i_xsmp))
      call argos_forces(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs))
c
      call argos_prop_proper(isdit,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme,
     + epot,epotw,epotsw,epots,volume,dwr,dbl_mb(i_dsr),ekin,etot,
     + npolit,dbl_mb(i_gsm),dbl_mb(i_esa),box,dbl_mb(i_xsm))
c
      dxmax=zero
      dxwmax=zero
      dxsmax=zero
c
      beta5=beta4*pnorm/fnorm
c
c     advance coordinates with these forces
c
      if(nwmloc.gt.0) then
      do 44 iwa=1,nwa
      do 45 ix=1,3
      do 46 iwm=1,nwmloc
      yw(iwm,ix,iwa)=xw(iwm,ix,iwa)
      dxstep=beta5*fw(iwm,ix,iwa)/ww(iwa)
      if(iand(iwdt(iwm),mfixed).ne.lfixed) then
      xw(iwm,ix,iwa)=yw(iwm,ix,iwa)+dxstep
      if(abs(dxstep).gt.dxwmax) dxwmax=abs(dxstep)
      endif
   46 continue
   45 continue
   44 continue
      if(dxwmax.gt.dxmax) dxmax=dxwmax
      endif
      if(nsaloc.gt.0) then
      do 47 ix=1,3
      do 48 isa=1,nsaloc
      ys(isa,ix)=xs(isa,ix)
      dxstep=beta5*fs(isa,ix)/ws(isa)
      if(iand(isdt(isa),mfixed).ne.lfixed) then
      xs(isa,ix)=ys(isa,ix)+dxstep
      if(abs(dxstep).gt.dxsmax) dxsmax=abs(dxstep)
      endif
   48 continue
   47 continue
      if(dxsmax.gt.dxmax) dxmax=dxsmax
      endif
      call ga_dgop(mrg_d12,dxmax,1,'max')
c
c     shake
c
      call argos_shake(dbl_mb(i_xw),dbl_mb(i_yw),int_mb(i_iw),
     + dbl_mb(i_xs),dbl_mb(i_ys),int_mb(i_is),dxmax)
c
      fnorm2=zero
c
      if(nwmloc.gt.0) then
      do 52 iwa=1,nwa
      do 53 ix=1,3
      do 54 iwm=1,nwmloc
      fw(iwm,ix,iwa)=(xw(iwm,ix,iwa)-yw(iwm,ix,iwa))*ww(iwa)/beta5
      pcgw(iwm,ix,iwa)=(yw(iwm,ix,iwa)-vw(iwm,ix,iwa))*ww(iwa)/beta4
      vw(iwm,ix,iwa)=yw(iwm,ix,iwa)
      fnorm2=fnorm2+fw(iwm,ix,iwa)**2
   54 continue
   53 continue
   52 continue
      endif
      if(nsaloc.gt.0) then
      do 55 ix=1,3
      do 56 isa=1,nsaloc
      fs(isa,ix)=(xs(isa,ix)-ys(isa,ix))*ws(isa)/beta5
      pcgs(isa,ix)=(ys(isa,ix)-vs(isa,ix))*ws(isa)/beta4
      vs(isa,ix)=ys(isa,ix)
      fnorm2=fnorm2+fs(isa,ix)**2
   56 continue
   55 continue
      endif
c
c     global sum fnorm2
c
      call ga_dgop(mrg_d13,fnorm2,1,'+')
c
      beta1=sqrt(fnorm2/fnorm1)
      fnorm1=fnorm2
c
      ecg2=epot
      epcgw=epotw
      epcgsw=epotsw
      epcgs=epots
c
      ecgdif=ecg2-ecgold
      ecgold=ecg2
      edt=ecg2-ecg0
      ecg1=ecg2
      ecgnew=ecg2
c
c     record to lfntrj
c
      lxw=frequency(mdstep,nfcoor)
      lxs=frequency(mdstep,nfscoo)
c
      if(lxw.or.lxs) then
      call argos_space_wrttrj(lfntrj,lxw,.false.,.false.,lxs,.false.,
     + .false.,
     + stime,pres,temp,tempw,temps,
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_fw),
     + dbl_mb(i_xwcr),int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_fs))
      endif
c
c     write restart file
c
      ldone=.not.(icgit.lt.mcgit.and.dxmax.gt.dxcgmx.and.ecgdif.lt.zero)
c
      cqrs=' '
      if(frequency(icgit,nfqrs).or.(ldone.and.eqrs.gt.epot)) then
      write(projct,4000) nserie,msdit,icgit,filnam(1:56)
 4000 format(i2,' em ',i7,' + ',i7,' ',a)
      call argos_wrtrst(lfnqrs,filqrs,.false.)
      cqrs='*'
      eqrs=ecg1
      endif
      if(me.eq.0.and.frequency(icgit,nfprop)) call argos_prop_record()
c
c     print minimization step data to output
c
      if(me.eq.0) then
      write(lfnout,600) icgit,cqrs,ecgdif,ecg1,epcgw,epcgsw,epcgs,dxmax
  600 format(i7,1x,a1,3x,5(1pe13.5),0pf12.8)
      endif
c
      if(itest.gt.0) call argos_test()
c
      call timer_stop(201)
      if(.not.ldone) goto 100
c
      ecgdif=edt
c
      return
      end
c $Id: argos_congra.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine dia_gettop
c
c $Id: dia_gettop.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     read the topology file
c     ----------------------
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer l_tmp,i_tmp
c
      filtop=card(8:80)
      call dia_siztop()
      if(.not.ma_push_get(mt_int,7*msgm,'iram',l_iram,i_iram))
     + call md_abort('Could not allocate iram',0)
      if(.not.ma_push_get(mt_int,msa,'imol',l_imol,i_imol))
     + call md_abort('Could not allocate imol',0)
      if(.not.ma_push_get(mt_int,msa,'iequi',l_iequi,i_iequi))
     + call md_abort('Could not allocate iequi',0)
      if(.not.ma_push_get(mt_int,2*msb,'sbnd',l_sbnd,i_sbnd))
     + call md_abort('Could not allocate sbnd',0)
      call dia_rdtop(byte_mb(i_snam),dbl_mb(i_qdat),dbl_mb(i_qwdat),
     + int_mb(i_iram),int_mb(i_imol),int_mb(i_atmn),int_mb(i_sbnd))
      if(.not.ma_push_get(mt_int,2*nsa,'tmp',l_tmp,i_tmp))
     + call md_abort('Failed to allocate temp array',0)
      call dia_equivalent(byte_mb(i_snam),int_mb(i_imol),
     + int_mb(i_iequi),int_mb(i_tmp))
      if(.not.ma_pop_stack(l_tmp))
     + call md_abort('Failed to deallocate temp array',0)
c
      if(me.eq.0) then
      if(ltop) then
      write(*,'(a,a)') ' Topology read from ',
     + filtop(1:index(filtop,' ')-1)
      else
      write(*,'(a,a)') ' Topology could not be read from ',
     + filtop(1:index(filtop,' ')-1)
      endif
      endif
c
      return
      end
      subroutine dia_equivalent(sgmnam,imol,iequi,itmp)
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      character*16 sgmnam(msa)
      integer imol(msa),iequi(msa),itmp(nsa,2)
c
      integer i,ism,jsm,nsm,nsmi,nsmj,isa,jsa
c
      if(me.eq.0) then
c
      do 1 i=1,nsa
      iequi(i)=0
      itmp(imol(i),2)=i
    1 continue
      nsm=imol(nsa)
      itmp(1,1)=1
      do 2 i=2,nsm
      itmp(i,1)=itmp(i-1,2)+1
    2 continue
c
      do 3 ism=1,nsm-1
      nsmi=itmp(ism,2)-itmp(ism,1)+1
      do 4 jsm=ism+1,nsm
      if(nsmi.eq.itmp(jsm,2)-itmp(jsm,1)+1) then
      do 5 i=1,nsmi
      isa=itmp(ism,1)+i-1
      jsa=itmp(jsm,1)+i-1
      if(sgmnam(isa)(1:10).ne.sgmnam(jsa)(1:10)) goto 4
    5 continue
      jsa=itmp(jsm,1)-1
      do 6 i=itmp(ism,1),itmp(ism,2)
      iequi(i)=jsa+i-itmp(ism,1)+1
    6 continue
      goto 3
      endif
    4 continue
    3 continue
c
c      write(*,'(3i7,1x,a)') (i,imol(i),iequi(i),sgmnam(i),i=1,nsa)
c
      endif
      if(np.gt.1) then
      call ga_brdcst(mag_d06,iequi,nsa*ma_sizeof(mt_int,1,mt_byte),0)
      endif
c
      return
      end

C> \ingroup nwint
C> @{
C>
C> routine to compute multipole integrals at a given lvalue.
C> 
C> The general form is <shell|pole|shell>
C>
C> the returned buffer is logically (mpole range, jlo:jhi, ilo:ihi)
C> where mpole range is 1:((lval+1)*(lval+2)/2)
C>
C> Integrals are returned in shell blocks of <L|ish|jsh> L=lval
C> one block for the given L value.  
C> for ish = d and Lval = 1 and jsh = p you would get:
C> (6*3*3)=54 integrals
C> order would be 
C> \code
C>   <xx|x|x> <xx|y|x> <xx|z|x> ( 1- 3)
C>   <xx|x|y> <xx|y|y> <xx|z|y> ( 4- 6) 
C>   <xx|x|z> <xx|y|z> <xx|z|z> ( 7- 9)
C>   <xy|x|x> <xy|y|x> <xy|z|x> (10-12)
C>   <xy|x|y> <xy|y|y> <xy|z|y> (13-15)
C>   <xy|x|z> <xy|y|z> <xy|z|z> (16-18)
C>   <xz|x|x> <xz|y|x> <xz|z|x> (19-21)
C>   <xz|x|y> <xz|y|y> <xz|z|y> (22-24)
C>   <xz|x|z> <xz|y|z> <xz|z|z> (25-27)
C>   <yy|x|x> <yy|y|x> <yy|z|x> (28-30)
C>   <yy|x|y> <yy|y|y> <yy|z|y> (31-33)
C>   <yy|x|z> <yy|y|z> <yy|z|z> (34-36)
C>   <yz|x|x> <yz|y|x> <yz|z|x> (37-39)
C>   <yz|x|y> <yz|y|y> <yz|z|y> (40-42)
C>   <yz|x|z> <yz|y|z> <yz|z|z> (43-45)
C>   <zz|x|x> <zz|y|x> <zz|z|x> (46-48)
C>   <zz|x|y> <zz|y|y> <zz|z|y> (49-51)
C>   <zz|x|z> <zz|y|z> <zz|z|z> (52-54)
C> \endcode
C>
C>
C> for ish = p and Lval = 2 and jsh = p you would get:
C> (3*6*3) = 54 integrals
C> order would be 
C> \code
C>   <x|xx|x> <x|xy|x> <x|xz|x> <x|yy|x> <x|yz|x> <x|zz|x>  ( 1- 6)
C>   <x|xx|y> <x|xy|y> <x|xz|y> <x|yy|y> <x|yz|y> <x|zz|y>  ( 7-12)
C>   <x|xx|z> <x|xy|z> <x|xz|z> <x|yy|z> <x|yz|z> <x|zz|z>  (13-18)
C>   <y|xx|x> <y|xy|x> <y|xz|x> <y|yy|x> <y|yz|x> <y|zz|x>  (19-24)
C>   <y|xx|y> <y|xy|y> <y|xz|y> <y|yy|y> <y|yz|y> <y|zz|y>  (25-30)
C>   <y|xx|z> <y|xy|z> <y|xz|z> <y|yy|z> <y|yz|z> <y|zz|z>  (31-36)
C>   <z|xx|x> <z|xy|x> <z|xz|x> <z|yy|x> <z|yz|x> <z|zz|x>  (37-42)
C>   <z|xx|y> <z|xy|y> <z|xz|y> <z|yy|y> <z|yz|y> <z|zz|y>  (43-48)
C>   <z|xx|z> <z|xy|z> <z|xz|z> <z|yy|z> <z|yz|z> <z|zz|z>  (49-54)
C> \endcode
C>
C> for ish = s and lval = 4 and jsh = p you would get:
C> (1*15*3) = 45 integrals
C> \code
C>   <s|xxxx|x> <s|xxxy|x> <s|xxxz|x> <s|xxyy|x> <s|xxyz|x> <s|xxzz|x> ( 1- 6)
C>   <s|xyyy|x> <s|xyyz|x> <s|xyzz|x> <s|xzzz|x> <s|yyyy|x> <s|yyyz|x> ( 7-12)
C>   <s|yyzz|x> <s|yzzz|x> <s|zzzz|x>                                  (13-15)
C>   <s|xxxx|y> <s|xxxy|y> <s|xxxz|y> <s|xxyy|y> <s|xxyz|y> <s|xxzz|y> (16-21)
C>   <s|xyyy|y> <s|xyyz|y> <s|xyzz|y> <s|xzzz|y> <s|yyyy|y> <s|yyyz|y> (22-27)
C>   <s|yyzz|y> <s|yzzz|y> <s|zzzz|y>                                  (28-30)
C>   <s|xxxx|z> <s|xxxy|z> <s|xxxz|z> <s|xxyy|z> <s|xxyz|z> <s|xxzz|z> (31-36)
C>   <s|xyyy|z> <s|xyyz|z> <s|xyzz|z> <s|xzzz|z> <s|yyyy|z> <s|yyyz|z> (37-42)
C>   <s|yyzz|z> <s|yzzz|z> <s|zzzz|z>                                  (43-45)
C> \endcode
C>
C>
      subroutine int_mpolel(i_basis, ish, j_basis, jsh, lval, centerl,
     &    lscr, scr, lmpint, MP, num_mpint)
*
* $Id: int_mpolel.F 23369 2013-01-04 21:01:05Z d3y133 $
*
c
c routine to compute multipole integrals at a given lvalue.
c 
c The general form is <shell|pole|shell>
c
c the returned buffer is logically (mpole range, jlo:jhi, ilo:ihi)
c where mpole range is 1:((lval+1)*(lval+2)/2)
c
c  Integrals are returned in shell blocks of <L|ish|jsh> L=lval
c  one block for the given L value.  
c  for ish = d and Lval = 1 and jsh = p you would get:
c      (6*3*3)=54 integrals
c  order would be 
c   <xx|x|x> <xx|y|x> <xx|z|x> ( 1- 3)
c   <xx|x|y> <xx|y|y> <xx|z|y> ( 4- 6) 
c   <xx|x|z> <xx|y|z> <xx|z|z> ( 7- 9)
c   <xy|x|x> <xy|y|x> <xy|z|x> (10-12)
c   <xy|x|y> <xy|y|y> <xy|z|y> (13-15)
c   <xy|x|z> <xy|y|z> <xy|z|z> (16-18)
c   <xz|x|x> <xz|y|x> <xz|z|x> (19-21)
c   <xz|x|y> <xz|y|y> <xz|z|y> (22-24)
c   <xz|x|z> <xz|y|z> <xz|z|z> (25-27)
c   <yy|x|x> <yy|y|x> <yy|z|x> (28-30)
c   <yy|x|y> <yy|y|y> <yy|z|y> (31-33)
c   <yy|x|z> <yy|y|z> <yy|z|z> (34-36)
c   <yz|x|x> <yz|y|x> <yz|z|x> (37-39)
c   <yz|x|y> <yz|y|y> <yz|z|y> (40-42)
c   <yz|x|z> <yz|y|z> <yz|z|z> (43-45)
c   <zz|x|x> <zz|y|x> <zz|z|x> (46-48)
c   <zz|x|y> <zz|y|y> <zz|z|y> (49-51)
c   <zz|x|z> <zz|y|z> <zz|z|z> (52-54)
c
c
c  for ish = p and Lval = 2 and jsh = p you would get:
c      (3*6*3) = 54 integrals
c  order would be 
c   <x|xx|x> <x|xy|x> <x|xz|x> <x|yy|x> <x|yz|x> <x|zz|x>  ( 1- 6)
c   <x|xx|y> <x|xy|y> <x|xz|y> <x|yy|y> <x|yz|y> <x|zz|y>  ( 7-12)
c   <x|xx|z> <x|xy|z> <x|xz|z> <x|yy|z> <x|yz|z> <x|zz|z>  (13-18)
c   <y|xx|x> <y|xy|x> <y|xz|x> <y|yy|x> <y|yz|x> <y|zz|x>  (19-24)
c   <y|xx|y> <y|xy|y> <y|xz|y> <y|yy|y> <y|yz|y> <y|zz|y>  (25-30)
c   <y|xx|z> <y|xy|z> <y|xz|z> <y|yy|z> <y|yz|z> <y|zz|z>  (31-36)
c   <z|xx|x> <z|xy|x> <z|xz|x> <z|yy|x> <z|yz|x> <z|zz|x>  (37-42)
c   <z|xx|y> <z|xy|y> <z|xz|y> <z|yy|y> <z|yz|y> <z|zz|y>  (43-48)
c   <z|xx|z> <z|xy|z> <z|xz|z> <z|yy|z> <z|yz|z> <z|zz|z>  (49-54)
c
c  for ish = s and lval = 4 and jsh = p you would get:
c     (1*15*3) = 45 integrals
c   <s|xxxx|x> <s|xxxy|x> <s|xxxz|x> <s|xxyy|x> <s|xxyz|x> <s|xxzz|x> ( 1- 6)
c   <s|xyyy|x> <s|xyyz|x> <s|xyzz|x> <s|xzzz|x> <s|yyyy|x> <s|yyyz|x> ( 7-12)
c   <s|yyzz|x> <s|yzzz|x> <s|zzzz|x>                                  (13-15)
c   <s|xxxx|y> <s|xxxy|y> <s|xxxz|y> <s|xxyy|y> <s|xxyz|y> <s|xxzz|y> (16-21)
c   <s|xyyy|y> <s|xyyz|y> <s|xyzz|y> <s|xzzz|y> <s|yyyy|y> <s|yyyz|y> (22-27)
c   <s|yyzz|y> <s|yzzz|y> <s|zzzz|y>                                  (28-30)
c   <s|xxxx|z> <s|xxxy|z> <s|xxxz|z> <s|xxyy|z> <s|xxyz|z> <s|xxzz|z> (31-36)
c   <s|xyyy|z> <s|xyyz|z> <s|xyzz|z> <s|xzzz|z> <s|yyyy|z> <s|yyyz|z> (37-42)
c   <s|yyzz|z> <s|yzzz|z> <s|zzzz|z>                                  (43-45)
c
c
      implicit none
#include "errquit.fh"
#include "apiP.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
#include "util.fh"
c
c::functions
      logical int_chk_init
      integer int_nint_cart, int_nint
      external int_chk_init
      external int_nint_cart, int_nint
c::passed
      integer i_basis             !< [Input] basis set handle for ish
      integer ish                 !< [Input] i shell/contraction
      integer j_basis             !< [Input] basis set handle for jsh
      integer jsh                 !< [Input] j shell/contraction
      integer lval                !< [Input] maximum lvalue for 
                                  !< multipole integrals in this batch
      double precision centerl(3) !< [Input] coordinates of multipole
      integer lscr                !< [Input] length of scratch array
      double precision scr(lscr)  !< [Input] scratch array
      integer lmpint              !< [Input] length of multipole 
                                  !< integrals array
      double precision MP(lmpint) !< [Output] multipole integrals
      integer num_mpint           !< [Output] number of multipole integrals
c::local      
      logical any_spherical
      logical shells_ok
      integer ibas, Li, i_prim, i_gen, i_iexp, i_icfp, i_cent, i_geom
      integer jbas, Lj, j_prim, j_gen, j_iexp, j_icfp, j_cent, j_geom
      integer ucont
      integer l_int, ij_int, ij_int_x, num_int
      integer lpole
      logical inline_chk_sh      
c
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c... statement function for int_chk_sh
      inline_chk_sh(ibas,ish) =
     $     ((ish.gt.0) .and. (ish.le.ncont_tot_gb(ibas)))
c
c check initialization
c      
      if (.not.int_chk_init('int_mpolel'))
     &       call errquit('int_mpolel: int_init was not called' ,0,
     &          INT_ERR)
c
c  check if gencon/sp shells
c
      call int_nogencont_check(i_basis,'int_mpolel:i_basis')
      call int_nogencont_check(j_basis,'int_mpolel:j_basis')
      call int_nospshell_check(i_basis,'int_mpolel:i_basis')
      call int_nospshell_check(j_basis,'int_mpolel:j_basis')
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
c
      shells_ok = inline_chk_sh(ibas,ish)
      shells_ok = shells_ok .and. inline_chk_sh(jbas,jsh)
      if (.not. shells_ok)
     &       call errquit('int_mpolel: invalid contraction/shell',0,
     &         BASIS_ERR)
c
      any_spherical = bas_spherical(ibas).or.bas_spherical(jbas)
c
***   set defNxyz such that it can handle the maximum multi-pole
c
      lpole = lval/4 + 1
      call defNxyz(lpole)
c
      ucont   = (sf_ibs_cn2ucn(ish,ibas))
      Li      = infbs_cont(CONT_TYPE ,ucont,ibas)
      i_prim  = infbs_cont(CONT_NPRIM,ucont,ibas)
      i_gen   = infbs_cont(CONT_NGEN ,ucont,ibas)
      i_iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      i_icfp  = infbs_cont(CONT_ICFP ,ucont,ibas)
      i_cent  = (sf_ibs_cn2ce(ish,ibas))
      i_geom  = ibs_geom(ibas)
c
      ucont   = (sf_ibs_cn2ucn(jsh,jbas))
      Lj      = infbs_cont(CONT_TYPE ,ucont,jbas)
      j_prim  = infbs_cont(CONT_NPRIM,ucont,jbas)
      j_gen   = infbs_cont(CONT_NGEN ,ucont,jbas)
      j_iexp  = infbs_cont(CONT_IEXP ,ucont,jbas)
      j_icfp  = infbs_cont(CONT_ICFP ,ucont,jbas)
      j_cent  = (sf_ibs_cn2ce(jsh,jbas))
      j_geom  = ibs_geom(jbas)
c
      if (i_geom.ne.j_geom.and.WarnP.eq.0) then
        write(luout,*)'int_mpolel: WARNING: possible geometry',
     &      ' inconsistency'
        write(luout,*)'i_basis geometry handle:',i_geom
        write(luout,*)'j_basis geometry handle:',j_geom
        WarnP = 1
      endif
c
      if (i_gen.gt.1 .or. j_gen.gt.1) then
        write(luout,*)
     &      ' hf3ois does not handle general contractions yet'
        call errquit('int_mpolel: general contraction error ',911,
     &             INT_ERR)
      endif
c
      l_int    = int_nbf_x(lval) ! (lval+1)*(lval+2)/2
      ij_int_x = int_nint_cart(i_basis, ish, j_basis, jsh, 0,0, 0,0)
      ij_int   = int_nint(i_basis, ish, j_basis, jsh, 0,0, 0,0)
      num_int  =  l_int*ij_int
      if ((l_int*ij_int_x).gt.lmpint) then
        write(luout,*)' int_mpolel: lmpint           = ',lmpint
        write(luout,*)' int_mpolel: (l_int*ij_int_x) = ',
     &      (l_int*ij_int_x)
        call errquit('int_mpolel: lmpint too small ',911, INT_ERR)
      endif
      call hf3ois(
     &    coords(1,i_cent,i_geom),dbl_mb(mb_exndcf(i_iexp,ibas)),
     &    dbl_mb(mb_exndcf(i_icfp,ibas)),i_prim, Li,
     &    coords(1,j_cent,j_geom),dbl_mb(mb_exndcf(j_iexp,jbas)),
     &    dbl_mb(mb_exndcf(j_icfp,jbas)),j_prim, Lj,
     &    centerl,DCexp,
     &    DCcoeff, 1,  lval,
c.....................TriDiag..DryRun
     &    MP,(l_int*ij_int_x),.false.,.false.,scr,lscr)
      num_mpint = num_int
      if (any_spherical) then
        if (Li.eq.-1) i_gen = 1
        if (Lj.eq.-1) j_gen = 1
        call spcart_3ctran(MP,scr,lscr,
     &      int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &      int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &      int_nbf_x(lval),int_nbf_x(lval),lval,1,.false.,
     &      .false.)
      endif
      end
C> @}

      subroutine tce_create_t2(d_t2,l_t2_offset,k_t2_offset,size_t2,
     &                         irrep,title,
     &                         d_t1,k_t1_offset,size_t1,
     &                         d_f1,k_f1_offset,size_1e,
     &                         d_v2,k_v2_offset,size_2e,
     &                         ref,needt1,ioalg,model)
c
c $Id: tce_create_t2.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
c#include "rtdb.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "errquit.fh"
c#include "tce.fh"
c#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
c#include "tce_amps.fh"
c#include "tce_diis.fh"
      logical needt1
      integer ioalg
      integer d_t1             ! SF handle for t1 amplitudes
      integer l_t1_offset      ! Offset for t1 file
      integer k_t1_offset      ! Offset for t1 file
      integer size_t1          ! File size in doubles
      integer d_t2             ! SF handle for t2 amplitudes
      integer l_t2_offset      ! Offset for t2 file
      integer k_t2_offset      ! Offset for t2 file
      integer size_t2          ! File size in doubles
      integer d_t3             ! SF handle for t3 amplitudes
      integer l_t3_offset      ! Offset for t3 file
      integer k_t3_offset      ! Offset for t3 file
      integer size_t3          ! File size in doubles
      integer d_t4             ! SF handle for t4 amplitudes
      integer l_t4_offset      ! Offset for t4 file
      integer k_t4_offset      ! Offset for t4 file
      integer size_t4          ! File size in doubles
      integer d_f1             ! SF handle for MO 1e integrals
      integer l_f1_offset      ! Offset for 1e integral file
      integer k_f1_offset      ! Offset for 1e integral file
      integer size_1e          ! File size in doubles
      integer d_v2             ! SF handle for MO 2e integrals
      integer l_v2_offset      ! Offset for 2e integral file
      integer k_v2_offset      ! Offset for 2e integral file
      integer size_2e          ! File size in doubles
      logical nodezero         ! True if node 0
      double precision cpu     ! CPU sec counter
      double precision wall    ! WALL sec counter
      double precision ref     ! Ground state energy
      double precision corr    ! Correlation energy
      integer irrep
      character*8 title
      character*10 model
      character*255 filename
c
      nodezero=(ga_nodeid().eq.0)
      if (nodezero) write(LuOut,*) '============================='
c
      cpu = - util_cpusec()
      call tce_filename(title,filename)
      call tce_t2_offset_new(l_t2_offset,k_t2_offset,size_t2,irrep)
#if defined(DEBUG_PRINT)
        if(nodezero) write(LuOut,*) 'l_t2_offset = ',l_t2_offset
#endif
c ------------
c      if(nodezero) then
c       write(LuOut,*)'T2-number-of-boxes',int_mb(k_t2_offset)
c       call util_flush(LuOut)
c      end if
c -------------
      call createfile(filename,d_t2,size_t2)
c     if(nodezero) then
c       write(LuOut,*)'before tce_guess_t2'
c       call util_flush(LuOut)
c     end if
      call tce_guess_t2(d_v2,k_v2_offset,d_t2,k_t2_offset)
      call reconcilefile(d_t2,size_t2)
c     if(nodezero) then
c       write(LuOut,*)'after tce_guess_t2'
c       call util_flush(LuOut)
c     end if
c starts for t1 amplitudes t1(in the second order of MBPT)
c (only if ga option is used)
ccccc      if(needt1.and.(model.eq.'ccsd')) then
      if(needt1) then ! fix problem with CCSDT?
        if(ioalg.eq.2) then
          call t1mp2(d_f1,d_t1,d_t2,d_v2,k_f1_offset,k_t1_offset,
     &    k_t2_offset,k_v2_offset)
          call reconcilefile(d_t1,size_t1)
          call tce_guess_t1(d_t1,k_t1_offset)
          call reconcilefile(d_t1,size_t1)
        end if
      end if
c -----
      if (util_print('mbpt2',print_debug)) then
        call tce_mbpt2(d_v2,k_v2_offset,d_t2,k_t2_offset,corr)
        if (nodezero) then
          write(LuOut,9030) corr
          write(LuOut,9040) ref + corr
        endif
      endif
      cpu = cpu + util_cpusec()
      if (nodezero.and.util_print(title,print_default)) then
c        write(LuOut,*)
        write(LuOut,9000) title,size_t2
        write(LuOut,9010) title,filename(1:120)
#if defined(DEBUG_PRINT)
        write(LuOut,9090) title,d_t2
#endif
c       write(LuOut,9020) cpu
        call util_flush(LuOut)
      endif
c
      return
 9000 format(1x,A,' file size   = ',i16)
 9010 format(1x,A,' file name   = ',A)
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9030 format(/,1x,'MBPT(2) correlation energy / hartree = ',f25.15)
 9040 format(1x,'MBPT(2) total energy / hartree       = ',f25.15)
 9090 format(1x,A,' file handle = ',i10)
      end

      subroutine argos_diana_task
c
c $Id: argos_diana_task.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      call argos_diana_init()
c
    1 continue
c
      call argos_diana_getcmd()
c
c     read reference coordinates
c     --------------------------
c
      if(cmd.eq.'refer ') then
      call argos_diana_getref()
c
c     read topology file
c     ------------------
c
      elseif(cmd.eq.'topol ') then
      call argos_diana_gettop()
c
c     set io mode
c     -----------
c
      elseif(cmd.eq.'iomode') then
      call argos_diana_setiomode()
c
c     read trajectory file header
c     ---------------------------
c
      elseif(cmd.eq.'file  ') then
      call argos_diana_gethdr()
c
c     select which frames to read
c     ---------------------------
c
      elseif(cmd.eq.'frame ') then
      call argos_diana_gettrj()
c
c     atom selection
c     --------------
c
      elseif(cmd.eq.'select') then
      call argos_diana_getsel()
c
c     save atom selection
c     -------------------
c
      elseif(cmd.eq.'savsel') then
      call argos_diana_savsel()
      elseif(cmd.eq.'savsls') then
      call argos_diana_savssl()
c
c     read atom selection
c     -------------------
c
      elseif(card(1:5).eq.'rdsel') then
      call argos_diana_rdsel()
      elseif(cmd.eq.'rdsels') then
      call argos_diana_rdssl()
c
c     geometric selections
c
      elseif(cmd.eq.'distan') then
      call argos_diana_adddistance()
      elseif(cmd.eq.'angle') then
      call argos_diana_addangle()
      elseif(cmd.eq.'torsio') then
      call argos_diana_addtorsion()
      elseif(cmd.eq.'improp') then
      elseif(cmd.eq.'order') then
      call argos_diana_addorder()
c
c     superimpose all stored frames
c     -----------------------------
c
      elseif(card(1:5).eq.'super') then
      call argos_diana_super()
c
c     calculate average coordinates
c     -----------------------------
c
      elseif(cmd.eq.'xaver ') then
      call argos_diana_average()
c
c     calculate one-dimensional root mean square deviation
c     ----------------------------------------------------
c
      elseif(cmd.eq.'rmsdev') then
      call argos_diana_rmsd()
c
c     build covariance matrix
c     -----------------------
c
      elseif(cmd.eq.'covar ') then
      call argos_diana_covar()
c
c     pca projection
c     --------------
c
      elseif(cmd.eq.'projec') then
      call argos_diana_project()
c
      elseif(cmd.eq.'evalua') then
      call argos_diana_evaluate()
c
      elseif(cmd.eq.'espplt') then
      call argos_diana_espplt()
c
      elseif(cmd.eq.'rama  ') then
      call argos_diana_rama()
      else
      goto 9
      endif
      goto 1
c
    9 continue
      call argos_diana_final()
c
      return
      end

      Subroutine hfnai_er(ncenters,E,R0C,IJK,Vab,Nint,NPP,
     &     La,Lb,Li,Lp,Lp3,canAB)
c $Id: hfnai_er.F 19696 2010-10-29 16:53:42Z d3y133 $

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Logical canAB

c--> Hermite Linear Expansion Coefficients

      Dimension E(3,NPP,0:((La+Li)+(Lb+Li)),0:(La+Li),0:(Lb+Li))

c--> Auxiliary Function Integrals & Index

      Dimension R0C(ncenters,NPP,Lp3),IJK(0:Lp,0:Lp,0:Lp)

c--> Nuclear Attraction Integrals

      Dimension Vab(ncenters,Nint)

c--> Scratch Space

      Dimension Nxyz(3)
c
c Compute the nuclear attraction integrals.
c
c     formula:
c           __
c           \    Ia,Ib    Ja,Jb    Ka,Kb
c     Vab = /  Ex     * Ey     * Ez     * R
c           --   Ip       Jp       Kp      Ip,Jp,Kp
c        Ip,Jp,Kp
c
c******************************************************************************

c Initialize the block of NAIs.
      do 10 nn = 1,Nint
      do 10 ic=1,ncenters
       Vab(ic,nn) = 0.D0
   10 continue

c Define the number of shell components on each center.

      La2 = ((La+1)*(La+2))/2
      Lb2 = ((Lb+1)*(Lb+2))/2

c Loop over shell components.

      nn = 0

      do 50 ma = 1,La2

c Define the angular momentum indices for shell "A".

       call getNxyz(La,ma,Nxyz)

       Ia = Nxyz(1)
       Ja = Nxyz(2)
       Ka = Nxyz(3)

       if( canAB )then
        mb_limit = ma
       else
        mb_limit = Lb2
       end if

       do 40 mb = 1,mb_limit

c Define the angular momentum indices for shell "B".

        call getNxyz(Lb,mb,Nxyz)

        Ib = Nxyz(1)
        Jb = Nxyz(2)
        Kb = Nxyz(3)

        nn = nn + 1

        do 30 Ip = 0,Ia+Ib
        do 30 Jp = 0,Ja+Jb
        do 30 Kp = 0,Ka+Kb

         np = IJK(Ip,Jp,Kp)

         do 20 mp = 1,NPP
           fact=E(1,mp,Ip,Ia,Ib)*E(2,mp,Jp,Ja,Jb)*E(3,mp,Kp,Ka,Kb)
           call daxpy(ncenters,fact,R0C(1,mp,np),1,Vab(1,nn),1)
   20    continue

   30   continue

   40  continue

   50 continue

      end

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     mk_fit_xf -- Form fitting basis transformation
C
C REVISION
C     $Id: mk_fit_xf.F 19707 2010-10-29 17:59:36Z d3y133 $
C
C SYNOPSIS
      Logical Function Mk_Fit_Xf(Approx, Split, Basis, MinEval, G_V)
      Implicit NONE
#include "errquit.fh"
      Character*(*) Approx, Split
      Integer Basis, G_V
      Double Precision MinEval
C
C ARGUMENTS
C     Approx   RI approximation used (SVS, S, or V) [IN]
C     Split    Whether or not to return the square root of the matrix
C              so that it can be used to transform both sets of 3c ints.
C              Y or N [IN]
C     Basis    Handle for basis set in which to evaluate V [IN]
C     MinEval  Minimum eigenvalue of V matrix to be retained in 
C              the inversion [IN]
C     G_V      Global array handle to the V^{-1/2} matrix [OUT]
C
C RETURN VALUE
C     .TRUE.  if successful, even if some eigenvalues fell below MinEval.
C     .FALSE. if errors occured in dynamic memory (MA or GA) operations,
C             inquiries about Basis, or in obtaining the required integrals.
C
C DESCRIPTION
C     Forms V^{-1/2} for the specified basis set and returns it in 
C     the newly created global array G_V.
C
C NOTES
C     The integral package must be initialized before calling this routine.
C
C MEMORY USE
C     Creates and returns a global array (G_V) the size of 
C     Bas_NumBF(Basis)^2.
C
C     Additional temporary usage consists of the largest of:
C     1) Integral requirements, reported by Int_Mem_2e2c.
C     2) Bas_NumBF(Basis)^2 + Bas_NumBF(Basis) + whatever additional
C        space is required by GA_Diag_Std.
C     3) 2 * Bas_NumBF(Basis)^2
C
C INCLUDE FILES
#include "global.fh"
#include "mafdecls.fh"
#include "numerical_constants.fh"
#include "stdio.fh"
#include "bas.fh"
#include "inp.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C CONSTANTS
      Integer MinChunk, MinTasks
      Parameter (MinChunk = 10, MinTasks = 10)
C
C LOCAL VARIABLES
      Logical Status, DoSplit
      Integer NBF, Type, G_Tmp, G_S
C
      If ( Inp_Compare(.FALSE., Approx, 'SVS') ) then
         Type = 1
      ElseIf ( Inp_Compare(.FALSE., Approx, 'S') ) then
         Type = 2
      ElseIf ( Inp_Compare(.FALSE., Approx, 'V') ) then
         Type = 3
      Else
         Write (LuErr, 9000) Approx
         Call ErrQuit('Mk_Fit_XF: Bad argument', 1, INPUT_ERR)
      EndIf
      If ( Inp_Compare(.FALSE., Split, 'Y') ) then
         DoSplit = .TRUE.
      ElseIf ( Inp_Compare(.FALSE., Split, 'N') ) then
         DoSplit = .FALSE.
      Else
         Write (LuErr, 9010) Split
         Call ErrQuit('Mk_Fit_XF: Bad argument', 2, INPUT_ERR)
      EndIf
 9000 Format(1X, 'Mk_Fit_XF: Unknown approximation requested: ', A)
 9010 Format(1X, 'Mk_Fit_XF: ''split'' argument is Y/N: ', A)
C
C     ****************************
C     * Get basis set parameters *
C     ****************************
C
      Status = .TRUE.
      Status = Status .AND. Bas_NumBF( Basis, NBF)
      If (.NOT. Status )
     $   Call ErrQuit('Mk_Fit_XF: Failed to get expansion basis info',
     $   0, BASIS_ERR)
C
      If (Type .eq. 1) then
C
C        **************************************************
C        * Produce S^{-1}VS^{-1} or (S^{-1}VS^{-1})^{1/2} *
C        **************************************************
C        This is the matrix that will eventually be returned to the caller.
C
C        Do not worry about shell or atom-based blocking at the moment,
C        since this should not be a time-consuming routine.
C
         If ( .NOT. GA_Create( MT_Dbl, NBF, NBF, 'S integral matrix',
     $      -MinChunk, -MinChunk, G_S) )
     $      Call ErrQuit('Mk_Fit_XF: Unable to allocate S temporary',
     $      0, GA_ERR)
C
         Call GA_Zero(G_S)
C
C        The GA_Zero is SIMD, so it should sync us all
C
         Call Int_2c_GA( Basis, Basis, G_S, 'overlap', FP_One)
         Call GA_Sync
C
C        Form S^-1
C
         Call GA_MatPow( G_S, -FP_One, MinEval)
C
C        Form V
C
         If ( .NOT. GA_Create( MT_Dbl, NBF, NBF, 'SVS integral matrix',
     $      -MinChunk, -MinChunk, G_V) ) 
     $      Call ErrQuit('Mk_Fit_XF: Unable to allocate SVS',
     $      0, GA_ERR)
C
         Call GA_Zero(G_V)
C
C        The GA_Zero is SIMD, so it should sync us all
C
         Call Int_2c_GA( Basis, Basis, G_V, 'eri', FP_One)
         Call GA_Sync
C
C        Multiply everyone together
C
         If ( .NOT. GA_Create( MT_Dbl, NBF, NBF, 'tmp integral matrix',
     $      -MinChunk, -MinChunk, G_Tmp) )
     $      Call ErrQuit('Mk_Fit_XF: Unable to allocate temporary',
     $      0, GA_ERR)
C
         Call GA_DGEMM('N', 'N', NBF, NBF, NBF,
     $      FP_One, G_S, G_V, FP_Zero, G_Tmp)
C
         Call GA_DGEMM('N', 'N', NBF, NBF, NBF,
     $      FP_One, G_Tmp, G_S, FP_Zero, G_V)
C
         Status = .TRUE.
         Status = Status .AND. GA_Destroy(G_Tmp)
         Status = Status .AND. GA_Destroy(G_S)
C
         If (.NOT. Status)
     $      Call ErrQuit('Mk_Fit_XF: Unable to deallocate temporaries',
     $      0, GA_ERR)

      ElseIf (Type .eq. 2) then
C
C        ******************************
C        * Produce S^{-1} or S^{-1/2} *
C        ******************************
C        This is the matrix that will eventually be returned to the caller.
C
C        Do not worry about shell or atom-based blocking at the moment,
C        since this should not be a time-consuming routine.
C
         If ( .NOT. GA_Create( MT_Dbl, NBF, NBF, 'S integral matrix',
     $      -MinChunk, -MinChunk, G_V) ) 
     $      Call ErrQuit('Mk_Fit_XF: Unable to allocate S',
     $      0, GA_ERR)
C
         Call GA_Zero(G_V)
C
C        The GA_Zero is SIMD, so it should sync us all
C
         Call Int_2c_GA( Basis, Basis, G_V, 'overlap', FP_One)
         Call GA_Sync
C
      ElseIf (Type .eq. 3) then
C
C        ******************************
C        * Produce V^{-1} or V^{-1/2} *
C        ******************************
C        This is the matrix that will eventually be returned to the caller.
C
C        Do not worry about shell or atom-based blocking at the moment,
C        since this should not be a time-consuming routine.
C
         If ( .NOT. GA_Create( MT_Dbl, NBF, NBF, 'V integral matrix',
     $      -MinChunk, -MinChunk, G_V) )
     $      Call ErrQuit('Mk_Fit_XF: Unable to allocate V',
     $      0, GA_ERR)
C
         Call GA_Zero(G_V)
C
C        The GA_Zero is SIMD, so it should sync us all
C
         Call Int_2c_GA( Basis, Basis, G_V, 'eri', FP_One)
         Call GA_Sync
      EndIf
C
C     ****************************************
C     * Compute M^{1/2}, M^{-1/2}, or M^{-1} *
C     ****************************************
C     As appropriate to the approximation and "split" requested
C
      If (DoSplit .AND. Type .eq. 1) then
         Call GA_MatPow( G_V, FP_Half, MinEval)
      ElseIf ( DoSplit .AND. (Type .eq. 2 .OR. Type .eq. 3) ) then
         Call GA_MatPow( G_V, -FP_Half, MinEval)
      ElseIf ( .NOT. DoSplit .AND. (Type .eq. 2 .OR. Type .eq. 3) ) then
         Call GA_MatPow( G_V, -FP_One, MinEval)
      EndIf
C
      Mk_Fit_Xf = .TRUE.
C
      Return
      End

c
c $Id: borbs_formatter.F 22503 2012-05-20 06:58:57Z d3y133 $
c

*     ***************************************
*     *                                     *
*     *		borbs_formatter_auto        *
*     *                                     *
*     ***************************************
      subroutine borbs_formatter_auto(atom,rcut,lmbda)
      implicit none
      character*4  atom
      real*8 rcut,lmbda


#include "mafdecls.fh"
#include "errquit.fh"

*     ***** local variables *****
      logical       value
      integer       i,j,l,nb
      integer	    locp,lmax,kv(2),nbrillioun
      character*50  psp_filename,formatted_filename
      character*4   element
      real*8        rlocal

*     ***** simulation cell  variables *****
      double precision unita(3,3)
      integer          ngrid(3),version

*     ***** external functions *****
      integer      control_version,brillioun_nbrillioun
      integer      control_ngrid
      real*8       control_unita,brillioun_all_k
      logical      kbpp_band_orb, nwpw_filefind
      external     control_version,brillioun_nbrillioun
      external     control_ngrid
      external     control_unita,brillioun_all_k
      external     kbpp_band_orb, nwpw_filefind

      value  = .true.

*     **** get lmax,locp,and rlocal from psp library ****
      lmax  = -1
      locp  = -1
      rlocal = 1.0d0

*     **** define psp_filename and formatted_filename ****
      element = '    '
      element = atom
      l = index(element,' ') - 1
      psp_filename       = element(1:l)//'.psp1'
      formatted_filename = element(1:l)//'.borb'


*     **** generate one-dimensional pseudopotential file ****
      if (.not.nwpw_filefind(psp_filename)) then
        call psp_generator_auto1(atom,lmax,locp,rlocal)

*     **** get lmax,locp,and rlocal from rtdb ****
      else
         call control_pspparameters(atom,lmax,locp,rlocal)
      end if


*     **** cell information ****
      version = control_version()
      do i=1,3
         ngrid(i) = control_ngrid(i)
         do j=1,3
           unita(i,j) = control_unita(i,j)
         end do
      end do

*     **** brillioun zone information ****
      nbrillioun = brillioun_nbrillioun()
      value = MA_push_get(mt_dbl,3*nbrillioun,'kv',kv(2),kv(1))
      do nb=1,nbrillioun
         dbl_mb(kv(1)+3*(nb-1))   = brillioun_all_k(1,nb)
         dbl_mb(kv(1)+3*(nb-1)+1) = brillioun_all_k(2,nb)
         dbl_mb(kv(1)+3*(nb-1)+2) = brillioun_all_k(3,nb)
      end do

      value = value.and.
     >     kbpp_band_orb(.false.,
     >            version,psp_filename,formatted_filename,ngrid,unita,
     >            locp,lmax,
     >            nbrillioun,dbl_mb(kv(1)),rcut,lmbda)

*     *** exit if error found ***
      value = value.and.MA_pop_stack(kv(2))
      if(.not. value) call errquit('borb_formatter_auto: error',0,
     >       CALC_ERR)

      return
      end

*
* $Id: nwpw_mapping.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************************************
*     *															*
*     *   		   nwpw_mapping library							*
*     *															*
*     *   Author - Eric Bylaska									*
*     *   date   - 10/09/01										*
*     *															*
*     ***********************************************************

*	The nwpw_mapping  library is to  be used for handling parallel
* mapping of three-dimensional grids {A(n1(nb),n2(nb),n3(nb))}.
*
*	The three-dimensional grids are distributed across threads, p, in
* the k {i.e. n3(nb)} dimension using a cyclic decomposition.  So that
* three-dimensional grid A is defined as  A(n1(nb),n2(nb),nq(nb)) on
* each thread.  
*
*	Where 
*		np = number of threads
*		nq(nb) = ceil(nz(nb)/np).
*		0 <= p < np
*		1 <= qq <= nq(nb)
*		1 <= k <= n3(nb)
*
*		1 <= i <= n1(nb)
*		1 <= j <= n2(nb)
*       1 <= q <= (n1(nb)*n2(nb)*nq(nb))
* 
* 	The mapping of i,j,k -> q,p is defined as:
*	
*       
*		k  = ((qq-1)*np + p) + 1
*		qq = ((k-1) - p)/np + 1
*		p  = (k-1) mod np
*
*       q  = i + (j-1)*n1(nb) + (qq-1)*n1(nb)*n2(nb)
*
*

*     ***********************************
*     *									*
*     *	       nwpw_mapping_start		*	
*     *									*
*     ***********************************
      subroutine nwpw_mapping_start()
      implicit none

***** nwpw_mapping_block ****
#include "nwpw_mapping.fh"

*     **** initialize lists ****
      call nwpw_ilist_init(mem_n1)
      call nwpw_ilist_init(mem_n2)
      call nwpw_ilist_init(mem_n3)
      call nwpw_ilist_init(mem_nq)

      call nwpw_ilist_init(mem_qmap1)
      call nwpw_ilist_init(mem_qmap2)

      call nwpw_ilist_init(mem_pmap1)
      call nwpw_ilist_init(mem_pmap2)

      call nwpw_ilist_init(mem_kmap1)
      call nwpw_ilist_init(mem_kmap2)

      return
      end


*     ***********************************
*     *									*
*     *	       nwpw_mappint_init		*	
*     *									*
*     ***********************************

      subroutine nwpw_mapping_init(nb,nx,ny,nz)
      implicit none
#include "errquit.fh"
      integer nb
      integer nx,ny,nz
     
#include "mafdecls.fh"

***** nwpw_mapping_block ****
#include "nwpw_mapping.fh"


      integer qmap(2),pmap(2),kmap(2)
      integer k,q,p
      integer taskid,np,nq
      logical value
      character*16 id
      

*     **** allocate q_map,p_map,k_map *****
      id='qmap'//CHAR(ICHAR('a')+nb)
      value = MA_alloc_get(mt_int,nz,id,qmap(2),qmap(1))

      id='pmap'//CHAR(ICHAR('a')+nb)
      value = value.and.
     >        MA_alloc_get(mt_int,nz,id,pmap(2),pmap(1))

      id='kmap'//CHAR(ICHAR('a')+nb)
      value = MA_alloc_get(mt_int,nz,id,kmap(2),kmap(1))
      if (.not. value) then
        call errquit('nwpw_mapping_init: out of heap memory',0, MA_ERR)
      end if


      call Parallel_np(np)
      call Parallel_taskid(taskid)

*     ****************************
*     ****** cyclic mapping ******
*     ****************************
      p = 0
      q = 1
      do k=1,nz
         int_mb(qmap(1)+k-1) = q
         int_mb(pmap(1)+k-1) = p
         if (p .eq. taskid) nq = q

         p        = p+1
         if (p .ge. np) then
            p = 0
            q = q + 1
         end if
      end do


      do k=1,nz
         if (int_mb(pmap(1)+k-1) .eq. taskid) then
            int_mb(kmap(1)+int_mb(qmap(1)+k-1)-1) = k
         end if
      end do



*     *** add to lists ****
      call nwpw_ilist_add(mem_n1, nb,nx)
      call nwpw_ilist_add(mem_n2, nb,ny)
      call nwpw_ilist_add(mem_n3, nb,nz)
      call nwpw_ilist_add(mem_nq, nb,nq)

      call nwpw_ilist_add(mem_qmap1, nb,qmap(1))
      call nwpw_ilist_add(mem_qmap2, nb,qmap(2))

      call nwpw_ilist_add(mem_pmap1, nb,pmap(1))
      call nwpw_ilist_add(mem_pmap2, nb,pmap(2))

      call nwpw_ilist_add(mem_kmap1, nb,kmap(1))
      call nwpw_ilist_add(mem_kmap2, nb,kmap(2))

      return
      end

*     ***********************************
*     *									*
*     *	        nwpw_mapping_end   		*	
*     *									*
*     ***********************************
      subroutine nwpw_mapping_end(nb)
      implicit none
#include "errquit.fh"
      integer nb

#include "mafdecls.fh"

***** nwpw_mapping_block ****
#include "nwpw_mapping.fh"


*     **** local variables ****
      logical value
      integer qmap2,pmap2,kmap2


*     **** free maps from heap ****
      call nwpw_ilist_get(mem_qmap2, nb,qmap2)
      call nwpw_ilist_get(mem_pmap2, nb,pmap2)
      call nwpw_ilist_get(mem_kmap2, nb,kmap2)
      value = MA_free_heap(qmap2)
      value = value.and.
     >        MA_free_heap(pmap2)
      value = value.and.
     >        MA_free_heap(kmap2)
      if (.not. value) then
        call errquit('nwpw_mapping_end: error freeing heap memory',0,
     &       MA_ERR)
      end if

*     **** delete id from lists ****
      call nwpw_ilist_delete(mem_n1, nb)
      call nwpw_ilist_delete(mem_n2, nb)
      call nwpw_ilist_delete(mem_n3, nb)
      call nwpw_ilist_delete(mem_nq, nb)

      call nwpw_ilist_delete(mem_qmap1, nb)
      call nwpw_ilist_delete(mem_qmap2, nb)

      call nwpw_ilist_delete(mem_pmap1, nb)
      call nwpw_ilist_delete(mem_pmap2, nb)

      call nwpw_ilist_delete(mem_kmap1, nb)
      call nwpw_ilist_delete(mem_kmap2, nb)

      return
      end

         
*     ***********************************
*     *									*
*     *	       nwpw_mapping_pqtoijk		*
*     *									*
*     ***********************************

      subroutine nwpw_mapping_qptoijk(nb,q,p,i,j,k)      
      implicit none
      integer nb
      integer q,p
      integer i,j,k

#include "mafdecls.fh"
      
***** nwpw_mapping_block ****
#include "nwpw_mapping.fh"
      
*     ***** local variables ****
      integer kmap
      integer n1,n2,qq,tq


      call nwpw_ilist_get(mem_kmap1, nb,kmap)
      call nwpw_ilist_get(mem_n1, nb,n1)
      call nwpw_ilist_get(mem_n2, nb,n2)

      tq = q

      qq = tq/(n1*n2) + 1
      tq = tq - (qq-1)*n1*n2

      j  = tq/n1 + 1
      i = tq - (j-1)*n1

      k = int_mb(kmap+qq-1)

      return
      end


*     ***********************************
*     *									*
*     *	        nwpw_mapping_ijktoqp	*	
*     *									*
*     ***********************************

      subroutine nwpw_mapping_ijktoqp(nb,i,j,k,q,p)      
      implicit none
      integer nb
      integer i,j,k,q,p

#include "mafdecls.fh"

***** nwpw_mapping_block ****
#include "nwpw_mapping.fh"

*     ***** local variables ****
      integer qmap,pmap
      integer n1,n2,qq

      call nwpw_ilist_get(mem_n1, nb,n1)
      call nwpw_ilist_get(mem_n2, nb,n2)
      call nwpw_ilist_get(mem_qmap1, nb,qmap)
      call nwpw_ilist_get(mem_pmap1, nb,pmap)
      
      p  = int_mb(pmap+k-1)
      qq = int_mb(qmap+k-1)

      q = i + (j-1)*n1 + (qq-1)*n1*n2

      return
      end

*     ***********************************
*     *									*
*     *	      nwpw_mapping_nfft3d		*
*     *									*
*     ***********************************

      subroutine nwpw_mapping_nfft3d(nb,nfft3d)
      implicit none
      integer nb
      integer nfft3d

#include "mafdecls.fh"

***** nwpw_mapping_block ****
#include "nwpw_mapping.fh"

*     ***** local variables ****
      integer n1,n2,nq

      call nwpw_ilist_get(mem_n1, nb,n1)
      call nwpw_ilist_get(mem_n2, nb,n2)
      call nwpw_ilist_get(mem_nq, nb,nq)

      nfft3d = n1*n2*nq
      return
      end

      subroutine ana_edinit()
c
c $Id: ana_covar.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
c
      if(me.eq.0) then
      write(*,1000) (ma_sizeof(mt_dbl,3*nsel,mt_byte)+
     + ma_sizeof(mt_int,6*nsel,mt_byte))/104857,
     + ma_inquire_avail(mt_byte)/1048576,
     + ma_sizeof(mt_dbl,18*nsel*nsel/np,mt_byte)/1048576,
     + ga_memory_avail()/1048576
 1000 format(/,' Memory   Required    Available',//,
     + '   ma   ',2i10,' MB',/,
     + '   ga   ',2i10,' MB',/)
      endif
      print*,'nsel=',nsel
c
c     create nsel x nsel global array covariance matrix
c
      if(.not.ga_create(mt_dbl,3*nsel,3*nsel,'covar',0,3*nsel,ga_cov))
     + call md_abort('Failed to create global array covar',me)
      call ga_zero(ga_cov)
      if(.not.ga_create(mt_dbl,3*nsel,3*nsel,'vector',0,3*nsel,ga_vec))
     + call md_abort('Failed to create global array vector',me)
c
c     allocate memory
c
      if(.not.ma_push_get(mt_int,3*nsel,'ndx',l_ndx,i_ndx))
     + call md_abort('Failed to allocate memory for ndx',me)
      if(.not.ma_push_get(mt_dbl,3*nsel,'cov',l_cov,i_cov))
     + call md_abort('Failed to allocate memory for cov',me)
      if(.not.ma_push_get(mt_int,3*nsel,'ord',l_ord,i_ord))
     + call md_abort('Failed to allocate memory for ord',me)
c
      if(me.eq.0) then
      write(*,1002) 3*nsel
 1002 format(' Memory allocated for covariance ',i5)
      endif
c
      return
      end
      subroutine ana_edfinal()
c
      implicit none
c
#include "ana_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
c
c     deallocate memory
c
      if(.not.ma_pop_stack(l_ord))
     + call md_abort('Failed to deallocate memory for ord',me)
      if(.not.ma_pop_stack(l_cov))
     + call md_abort('Failed to deallocate memory for cov',me)
      if(.not.ma_pop_stack(l_ndx))
     + call md_abort('Failed to deallocate memory for ndx',me)
c
c     destroy global array covariance matrix
c
      if(.not.ga_destroy(ga_vec))
     + call md_abort('Failed to destroy global array vector',me)
      if(.not.ga_destroy(ga_cov))
     + call md_abort('Failed to destroy global array covar',me)
c
      return
      end
      subroutine ana_covar(ndx,cov,isel,x,xa)
c
      implicit none
c
#include "ana_params.fh"
#include "ana_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      integer ndx(*)
      real*8 cov(*)
      real*8 x(msa,3),xa(msa,3)
      integer isel(msa)
c
      integer i,j,ia,ja,ix,jx
      integer il,ih,jl,jh
c
      j=0
      do 1 i=1,nsa
      if(isel(i).ne.0) then
      j=j+1
      ndx(j)=i
      endif
    1 continue
c
      call ga_distribution(ga_cov,me,il,ih,jl,jh)
c
      do 2 i=il,ih
      ia=ndx((i+2)/3)
      ix=mod(i+2,3)+1
      do 3 j=jl,jh
      ja=ndx((j+2)/3)
      jx=mod(j+2,3)+1
      cov(j-jl+1)=(x(ia,ix)-xa(ia,ix))*(x(ja,jx)-xa(ja,jx))
c      if(i.eq.1.and.j.eq.1) then
c      write(*,'(5i5,2f12.6,2i5,2f12.6)') me,i,j,
c     + ia,ix,xa(ia,ix),x(ia,ix),
c     + ja,jx,xa(ja,jx),x(ja,jx)
c      endif
    3 continue
      call ga_acc(ga_cov,i,i,jl,jh,cov,1,one)
    2 continue
c
      call ga_sync()
      return
      end
      subroutine ana_projec(ndx,vct,isel,x,xa,mx,val,xp)
c
      implicit none
c
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
c
      integer mx
      integer ndx(nsel)
      real*8 vct(nsel),val,pnorm,vval
      real*8 x(mx,3),xa(mx,3),xp(nsa,3)
      integer isel(nsa)
c
      integer i,j,k
c
      val=0.0d0
      pnorm=0.0d0
      k=0
      do 1 i=1,nsel
      vval=0.0d0
      do 2 j=1,3
      k=k+1
      val=val+(x(ndx(i),j)-xa(ndx(i),j))*vct(k)
      vval=vval+(x(ndx(i),j)-xa(ndx(i),j))*vct(k)
      pnorm=pnorm+vct(k)*vct(k)
    2 continue
    1 continue
      val=val/sqrt(pnorm)
c
      k=0
      do 3 i=1,nsel
      do 4 j=1,3
      k=k+1
      xp(ndx(i),j)=val*vct(k)+xa(ndx(i),j)
    4 continue
    3 continue
c
      if(valmin.gt.valmax) then
      call ana_wrtpdb(lfnmax,filmax,byte_mb(i_snam),isel,xp,
     + isel,xp,.true.,.false.,int_mb(i_ndxw))
      valmax=val
      call ana_wrtpdb(lfnmin,filmin,byte_mb(i_snam),isel,xp,
     + isel,xp,.true.,.false.,int_mb(i_ndxw))
      valmin=val
      elseif(val.lt.valmin) then
      call ana_wrtpdb(lfnmin,filmin,byte_mb(i_snam),isel,xp,
     + isel,xp,.true.,.false.,int_mb(i_ndxw))
      valmin=val
      elseif(val.gt.valmax) then
      call ana_wrtpdb(lfnmax,filmax,byte_mb(i_snam),isel,xp,
     + isel,xp,.true.,.false.,int_mb(i_ndxw))
      valmax=val
      endif
c
      return
      end

      subroutine ccsd_trpdrv(t1,
     &     f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,eorb,
     &     eccsdt,g_objo,g_objv,g_coul,g_exch,
     &     ncor,nocc,nvir,iprt,emp4,emp5,
     &     oseg_lo,oseg_hi,
     $     kchunk, Tij, Tkj, Tia, Tka, Xia, Xka, Jia, Jka, Kia, Kka,
     $     Jij, Jkj, Kij, Kkj, Dja, Djka, Djia)
C     $Id: ccsd_trpdrv.F 25364 2014-03-20 18:17:06Z jhammond $
      implicit none
c
#include "global.fh"
#include "ccsd_len.fh"
#include "ccsdps.fh"
c     
      double precision t1(*),
     &     f1n(*),f1t(*),f2n(*),
     &     f2t(*),f3n(*),f3t(*),f4n(*),f4t(*),eorb(*),
     &     emp4,emp5
      double precision Tij(*), Tkj(*), Tia(*), Tka(*), Xia(*), Xka(*), 
     $     Jia(*), Jka(*), Kia(*), Kka(*),
     $     Jij(*), Jkj(*), Kij(*), Kkj(*), Dja(*), Djka(*), Djia(*)

      integer g_objo,g_objv,ncor,nocc,nvir,iprt,g_coul,
     &     g_exch,oseg_lo,oseg_hi
c     
      double precision eaijk,eccsdt
      integer a,b,c,i,j,k,akold,av,inode,len,
     &     next,nxtask
      external nxtask
C     
      Integer Nodes, IAm
c     
      integer klo, khi, start, end
      integer kchunk
c 
#ifdef DEBUG_PRINT
      integer tt
      double precision tt0,tt1,trp_time(26)
#endif
c
      double precision zip
      data zip/0.0d00/
c     
c     apr      call ga_print(g_coul)
c     apr      call ga_print(g_exch)
      Nodes = GA_NNodes()
      IAm = GA_NodeID()
C     
      call ga_sync()
      if (occsdps) then
         call pstat_on(ps_trpdrv)
      else
         call qenter('trpdrv',0)
      endif
      inode=-1
      next=nxtask(nodes, 1)
c     
#ifdef DEBUG_PRINT
      do tt = 1, 26
        trp_time(tt) = 0.0d0
      enddo
#endif
c
      do klo = 1, nocc, kchunk
         akold=0
         khi = min(nocc, klo+kchunk-1)
         do a=oseg_lo,oseg_hi
            av=a-ncor-nocc
            do j=1,nocc
               inode=inode+1
               if (inode.eq.next)then
c     
c     Get Dja = Dci,ja for given j, a, all ci
c     
                  start = 1 + (j-1)*lnov
                  len   = lnov
                  end   = start + len - 1
#ifdef DEBUG_PRINT
                  tt0 = ga_wtime()
#endif
                  call ga_get(g_objv,start,end,av,av,Dja,len)
#ifdef DEBUG_PRINT
                  tt1 = ga_wtime()
                  trp_time(1) = trp_time(1) + (tt1-tt0)
#endif
c     
c     Get Tkj = T(b,c,k,j) for given j, klo<=k<=khi, all bc
c     
                  start = (klo-1)*lnvv + 1
                  len   = (khi-klo+1)*lnvv
                  end   = start + len - 1
#ifdef DEBUG_PRINT
                  tt0 = ga_wtime()
#endif
                  call ga_get(g_objo,start,end,j,j,Tkj,len)
#ifdef DEBUG_PRINT
                  tt1 = ga_wtime()
                  trp_time(2) = trp_time(2) + (tt1-tt0)
#endif
c     
c     Get Jkj = J(c,l,k,j) for given j, klo<=k<=khi, all cl
c     
                  start = lnovv + (klo-1)*lnov + 1
                  len   = (khi-klo+1)*lnov
                  end   = start + len - 1
#ifdef DEBUG_PRINT
                  tt0 = ga_wtime()
#endif
                  call ga_get(g_objo,start,end,j,j,Jkj,len)
#ifdef DEBUG_PRINT
                  tt1 = ga_wtime()
                  trp_time(3) = trp_time(3) + (tt1-tt0)
#endif
c     
c     Get Kkj = K(c,l,k,j) for given j, klo<=k<=khi, all cl
c     
                  start = lnovv + lnoov + (klo-1)*lnov + 1
                  len   = (khi-klo+1)*lnov
                  end   = start + len - 1
#ifdef DEBUG_PRINT
                  tt0 = ga_wtime()
#endif
                  call ga_get(g_objo,start,end,j,j,Kkj,len)
#ifdef DEBUG_PRINT
                  tt1 = ga_wtime()
                  trp_time(4) = trp_time(4) + (tt1-tt0)
#endif
c     
                  if (akold .ne. a) then
                     akold = a
c     
c     Get Jka = J(b,c,k,a) for given a, klo<=k<=khi, all bc
c     
                     start = (a-oseg_lo)*nocc + klo
                     len   = (khi-klo+1)
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_coul,1,lnvv,start,end,Jka,lnvv)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(5) = trp_time(5) + (tt1-tt0)
#endif
c     
c     Get Kka = K(b,c,k,a) for given a, klo<=k<=khi, all bc
c     
                     start = (a-oseg_lo)*nocc + klo
                     len   = (khi-klo+1)
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_exch,1,lnvv,start,end,Kka,lnvv)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(6) = trp_time(6) + (tt1-tt0)
#endif
c     
c     Get Tka = Tbl,ka for given a, klo<=k<=khi, all bl
c     
                     start = 1 + lnoov + (klo-1)*lnov
                     len   = (khi-klo+1)*lnov
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objv,start,end,av,av,Tka,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(7) = trp_time(7) + (tt1-tt0)
#endif
c     
c     Get Xka = Tal,kb for given a, klo<=k<=khi, all bl
c     
                     start = 1 + lnoov + lnoov + (klo-1)*lnov
                     len   = (khi-klo+1)*lnov
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objv,start,end,av,av,Xka,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(8) = trp_time(8) + (tt1-tt0)
#endif
                  endif
c     
c     Get Djka = Dcj,ka for given j, a, klo<=k<=khi, all c
c     
#ifndef  CRAYXT
                  do k = klo, khi
                     start = 1 + (j-1)*nvir + (k-1)*lnov
                     len   = nvir
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objv,start,end,av,av,
     $                    Djka(1+(k-klo)*nvir),len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(9) = trp_time(9) + (tt1-tt0)
#endif
                  enddo
#else
      call ccsd_getdjka(djka,
     G     g_objv,nvir,lnov,
     K     j,av,klo,khi)
#endif
c     
c     Get Tia = Tbl,ia for given a,  all i,bl
c     
                     start = 1 + lnoov 
                     len   = lnov*nocc
                     end   = start + len - 1
                     call ga_get(g_objv,start,end,av,av,Tia,len)
c     
c     Get Xia = Tal,ib for given a, all i,bl
c     
                     start = 1 + lnoov + lnoov 
                     len   = lnov*nocc
                     end   = start + len - 1
                     call ga_get(g_objv,start,end,av,av,Xia,len)
c     
c     Get Jij = J(c,l,i,j) for given j, all i,cl
c     
                     start = lnovv +  1
                     len   = lnov*nocc
                     end   = start + len - 1
                     call ga_get(g_objo,start,end,j,j,Jij,len)
c     
c     Get Kij = K(c,l,i,j) for given j, all,i cl
c     
                     start = lnovv + lnoov +  1
                     len   = lnov*nocc
                     end   = start + len - 1
                     call ga_get(g_objo,start,end,j,j,Kij,len)
c     
c     Get Dia = Dcj,ia for given j, i, a, all c
c     
                     call ccsd_getdjka(djia,
     G                    g_objv,nvir,lnov,
     K                    j,av,1,nocc)
c     
                  do i=1,nocc
c     
c     Get Tij = T(b,c,i,j) for given j, i, all bc
c     
                     start = (i-1)*lnvv + 1
                     len   = lnvv
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objo,start,end,j,j,Tij,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(10) = trp_time(10) + (tt1-tt0)
#endif
#ifndef CRAXYT
c     
c     Get Jij = J(c,l,i,j) for given j, i, all cl
c     
                     start = lnovv + (i-1)*lnov + 1
                     len   = lnov
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objo,start,end,j,j,Jij,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(11) = trp_time(11) + (tt1-tt0)
#endif
c     
c     Get Kij = K(c,l,i,j) for given j, i, all cl
c     
                     start = lnovv + lnoov + (i-1)*lnov + 1
                     len   = lnov
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objo,start,end,j,j,Kij,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(12) = trp_time(12) + (tt1-tt0)
#endif
#endif
c     
c     Get Jia = J(b,c,i,a) for given a, i, all bc
c     
                     start = (a-oseg_lo)*nocc + i
                     len   = 1
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_coul,1,lnvv,start,end,Jia,lnvv)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(13) = trp_time(13) + (tt1-tt0)
#endif
c     
c     Get Kia = K(b,c,i,a) for given a, i, all bc
c     
                     start = (a-oseg_lo)*nocc + i
                     len   = 1
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_exch,1,lnvv,start,end,Kia,lnvv)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(14) = trp_time(14) + (tt1-tt0)
#endif
#if 0
c     
c     Get Dia = Dcj,ia for given j, i, a, all c
c     
                     start = 1 + (j-1)*nvir + (i-1)*lnov
                     len   = nvir
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objv,start,end,av,av,Djia,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(15) = trp_time(15) + (tt1-tt0)
#endif
c     
c     Get Tia = Tbl,ia for given a, i, all bl
c     
                     start = 1 + lnoov + (i-1)*lnov
                     len   = lnov
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objv,start,end,av,av,Tia,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(16) = trp_time(16) + (tt1-tt0)
#endif
c     
c     Get Xia = Tal,ib for given a, i, all bl
c     
                     start = 1 + lnoov + lnoov + (i-1)*lnov
                     len   = lnov
                     end   = start + len - 1
#ifdef DEBUG_PRINT
                     tt0 = ga_wtime()
#endif
                     call ga_get(g_objv,start,end,av,av,Xia,len)
#ifdef DEBUG_PRINT
                     tt1 = ga_wtime()
                     trp_time(17) = trp_time(17) + (tt1-tt0)
#endif
#endif
c     
                     do k=klo,min(khi,i)
                        call dcopy(lnvv,zip,0,f1n,1)
                        call dcopy(lnvv,zip,0,f1t,1)
                        call dcopy(lnvv,zip,0,f2n,1)
                        call dcopy(lnvv,zip,0,f2t,1)
                        call dcopy(lnvv,zip,0,f3n,1)
                        call dcopy(lnvv,zip,0,f3t,1)
                        call dcopy(lnvv,zip,0,f4n,1)
                        call dcopy(lnvv,zip,0,f4t,1)
c     
c     sum(d) (Jia, Kia)bd * Tkj,cd -> Fbc
c     
                        call ccsd_dovvv(Jia, Kia,
     $                       Tkj(1+(k-klo)*lnvv),f1n,f2n,f3n,f4n,
     $                       nocc,nvir)
c     
c     sum(d) (Jka, Kka)bd * Tij,cd -> Fbc
c     
                        call ccsd_dovvv(Jka(1+(k-klo)*lnvv),
     $                       Kka(1+(k-klo)*lnvv),
     $                       Tij,f1t,f2t,f3t,f4t,nocc,nvir)
c     
c     sum(l) (Jij, Kij)cl  * Tkl,ab -> Fbc
c     
                        call ccsd_doooo(Jkj(1+(k-klo)*lnov),
     $                       Kkj(1+(k-klo)*lnov),
     $                       Tia(1+(i-1)*lnov),Xia(1+(i-1)*lnov),
     $                       f1n,f2n,
     $                       f3n,f4n,nocc,nvir)
c     
c     sum(l) (Jkj, Kkj)cl  * Tli,ba -> Fbc
c     
                        call ccsd_doooo(Jij(1+(i-1)*lnov), 
     K                       Kij(1+(i-1)*lnov),
     $                       Tka(1+(k-klo)*lnov),Xka(1+(k-klo)*lnov),
     $                       f1t,f2t,
     $                       f3t,f4t,nocc,nvir)
c
                        if (iprt.gt.50)then
                           call prtfmat(f1n,f1t,f2n,f2t,f3n,f3t,f4n,
     $                          f4t, nvir)
                        end if
c
                        eaijk=eorb(ncor+i)+eorb(ncor+j)+eorb(ncor+k)
     $                       -eorb(a)
c
                        call ccsd_tengy(f1n,f1t,f2n,f2t,f3n,f3t,f4n,
     $                       f4t,
     &                       Dja(1+(i-1)*nvir),Djia(1+(i-1)*nvir),
     $                       t1((k-1)*nvir+1),eorb,eaijk,emp4,emp5,
     $                       ncor,nocc,nvir)
c     
                        if (i.ne.k)then
                           call ccsd_tengy(f1t,f1n,f2t,f2n,
     $                          f3t,f3n,f4t,f4n,
     $                          Dja(1+(k-1)*nvir),Djka(1+(k-klo)*nvir), 
     $                          t1((i-1)*nvir+1),eorb,eaijk,emp4,emp5,
     $                          ncor,nocc,nvir)
c     
                        end if
                     end do
                  end do
                  if (iprt.gt.50)then
                     write(6,1234)iam,a,j,emp4,emp5
 1234                format(' iam aijk',3i5,2e15.5)
                  end if
                  next=nxtask(nodes, 1)
               end if
            end do
         end do
      end do
c     
#ifdef DEBUG_PRINT
c
      do tt = 1, 17
        !write(6,97) IAm,tt,trp_time(tt)
        trp_time(24) = trp_time(24) + trp_time(tt)
      enddo
      call util_flush(6)
   97 format('node ',i5,': ga_get timer(',i2,') = ',1e15.5)
c
      do tt = 18, 21
        !write(6,98) IAm,tt,trp_time(tt)
        trp_time(25) = trp_time(25) + trp_time(tt)
      enddo
      call util_flush(6)
   98 format('node ',i5,': dgemm timer(',i2,') = ',1e15.5)
c
      do tt = 22, 23
        !write(6,99) IAm,tt,trp_time(tt)
        trp_time(26) = trp_time(26) + trp_time(tt)
      enddo
      call util_flush(6)
   99 format('node ',i5,': tengy timer(',i2,') = ',1e15.5)
c
      call ga_sync()
      if (IAm.eq.0) write(6,87)
   87 format(2x,'node',6x,'ga_get',9x,'dgemm',10x,'tengy')
      call ga_sync()
      write(6,88) IAm,trp_time(24),trp_time(25),trp_time(26)
   88 format(i7,3e15.5)
c
#endif
c
      next=nxtask(-nodes, 1)
      call ga_sync()
      if (occsdps) then
         call pstat_off(ps_trpdrv)
      else
         call qexit('trpdrv',0)
      endif
c     
      end

      subroutine ccsd_doooo(eintc,eintx,t2c,t2x,f1,f2,f3,f4,nocc,nvir)
      implicit none
      double precision eintc(*),eintx(*),t2c(*),t2x(*),
     &                 f1(*),f2(*),f3(*),f4(*)
      integer nocc,nvir
      double precision one
      data one/1.0d00/
#include "ccsdps.fh"
      if (occsdps) then
         call pstat_on(ps_doooo)
      else
         call qenter('doooo',0)
      endif
c
c      f1n(b,c)=f1n(b,c)-t2(b,l,a,i)*vooo(c,k,l,j)
      call dgemm('n','n',nvir,nvir,nocc,-one,t2c,nvir,
     &           eintx,nocc,one,f1,nvir)
c      f2n(b,c)=f2n(b,c)-t2(a,l,b,i)*vooo(c,k,l,j)
      call dgemm('n','n',nvir,nvir,nocc,-one,t2x,nvir,
     &           eintx,nocc,one,f2,nvir)
c      f3n(b,c)=f3n(b,c)-t2(b,l,a,i)*vooo(c,j,l,k)
      call dgemm('n','n',nvir,nvir,nocc,-one,t2c,nvir,
     &           eintc,nocc,one,f3,nvir)
c      f4n(b,c)=f4n(b,c)-t2(a,l,b,i)*vooo(c,j,l,k)
      call dgemm('n','n',nvir,nvir,nocc,-one,t2x,nvir,
     &           eintc,nocc,one,f4,nvir)
      if (occsdps) then
         call pstat_off(ps_doooo)
      else
         call qexit('doooo',0)
      endif
      return
      end






      subroutine ccsd_dovvv(fintc,fintx,t2,f1,f2,f3,f4,nocc,nvir)
      implicit none
      double precision fintc(*),fintx(*),t2(*),f1(*),f2(*),f3(*),f4(*)
      integer nocc,nvir
      double precision one,zero
      data one/1.0d00/
      data zero/0.0d00/
#include "ccsdps.fh"
      if (occsdps) then
         call pstat_on(ps_dovvv)
      else
         call qenter('dovvv',0)
      endif
c
c --  f1n(b,c)=f1n(b,c)+vvvo(b,d,a,i)*t2(d,j,c,k)
      call dgemm('n','t',nvir,nvir,nvir,one,fintc,nvir,
     &           t2,nvir,one,f1,nvir)
c --  f2n(b,c)=f2n(b,c)+vvvo(a,d,b,i)*t2(d,j,c,k)
      call dgemm('n','t',nvir,nvir,nvir,one,fintx,nvir,
     &           t2,nvir,one,f2,nvir)
c --  f3n(b,c)=f3n(b,c)+vvvo(b,d,a,i)*t2(d,k,c,j)
      call dgemm('n','n',nvir,nvir,nvir,one,fintc,nvir,
     &           t2,nvir,one,f3,nvir)
c --  f4n(b,c)=f4n(b,c)+vvvo(a,d,b,i)*t2(d,k,c,j)
      call dgemm('n','n',nvir,nvir,nvir,one,fintx,nvir,
     &           t2,nvir,one,f4,nvir)
      if (occsdps) then
         call pstat_off(ps_dovvv)
      else
         call qexit('dovvv',0)
      endif
      return
      end

      subroutine ccsd_tengy(f1n,f1t,f2n,f2t,f3n,f3t,f4n,f4t,
     &                      dintc,dintx,t1v,eorb,eaijk,
     $                      emp4,emp5,ncor,nocc,nvir)
      implicit none
#include "ccsdps.fh"
      integer ncor,nocc,nvir
      integer b,c
      double precision eaijk,emp4,emp5,denom
      double precision one,two,three,four
      double precision f1n(nvir,nvir),f1t(nvir,nvir)
      double precision f2n(nvir,nvir),f2t(nvir,nvir)
      double precision f3n(nvir,nvir),f3t(nvir,nvir)
      double precision f4n(nvir,nvir),f4t(nvir,nvir)
      double precision dintc(nvir),dintx(nvir),t1v(nvir),eorb(*)
      data one/1.0d00/,two/2.0d00/,three/3.0d00/,four/4.0d00/
c
      if (occsdps) then
         call pstat_on(ps_tengy)
      else
         call qenter('tengy',0)
      endif
c
      do b=1,nvir
        do c=1,nvir
          denom=one/(eaijk-eorb(ncor+nocc+b)-eorb(ncor+nocc+c))
          emp4=emp4+denom*
     &         (f1t(b,c)+f1n(c,b)+f2t(c,b)+f3n(b,c)+f4n(c,b))*
     &         (f1t(b,c)-two*f2t(b,c)-two*f3t(b,c)+f4t(b,c))
c
          emp4=emp4-denom*
     &         (f1n(b,c)+f1t(c,b)+f2n(c,b)+f3n(c,b))*
     &         (two*f1t(b,c)-f2t(b,c)-f3t(b,c)+two*f4t(b,c))
c
          emp4=emp4+three*denom*(
     &         f1n(b,c)*(f1n(b,c)+f3n(c,b)+two*f4t(c,b))+
     &         f2n(b,c)*f2t(c,b)+f3n(b,c)*f4t(b,c))
c
          emp5=emp5+denom*t1v(b)*dintx(c)*
     &        (     f1t(b,c)+f2n(b,c)+f4n(c,b)
     &         -two*(f3t(b,c)+f4n(b,c)+f2n(c,b)+
     &              f1n(b,c)+f2t(b,c)+f3n(c,b))
     &         +four*(f3n(b,c)+f4t(b,c)+f1n(c,b)))
          emp5=emp5+denom*t1v(b)*dintc(c)*
     &        (     f1n(b,c)+f4n(b,c)+f1t(c,b)
     &          -two*(f2n(b,c)+f3n(b,c)+f2t(c,b)))
c
        enddo
      enddo
c
      if (occsdps) then
         call pstat_off(ps_tengy)
      else
         call qexit('tengy',0)
      endif
c
      return
      end
      subroutine ccsd_getdjka(djka,
     G     g_objv,nvir,lnov,
     K     j,av,klo,khi)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      double precision djka(*)
      integer g_objv, nvir,lnov
      integer av,klo,khi,j
c
      integer k,l_kk,k_kk,lenk,start,end,iptr,i,startc
      logical failed
c
      start = 1 + (j-1)*nvir + (klo-1)*lnov
      end =  (j-1)*nvir + (khi)*lnov
      lenk=end-start+1
      lenk=min(lenk,(ma_inquire_avail(MT_DBL)*66)/100)
crestrict to 5M to avoid OOMs
      lenk=min(lenk,5000000)
 1    continue
      failed=.not.ma_push_get(MT_Dbl,lenk,
     Q     'tdjka',l_kk,k_kk)
      if(failed) then
         lenk=lenk/2
         goto 1
      endif
c     round it to the nearest multiple of lnov
      lenk=(lenk/lnov)*lnov
      iptr=1
      failed=.false.
 2    continue
c      if(ga_nodeid().eq.0) write(6,'(A,2I8,I10,I8,2I14)') 
c     I     ' kk av j lenk lenkfull ' ,
c     A     klo,khi,av,j,lenk,end-start+1
      call ccsd_cpyloop(g_objv,start,end,lenk,
     V     av,nvir,lnov, iptr,
     A     dbl_mb(k_kk),djka)
      if(start-1.ne.end)then
         if(failed)
     A     call errquit('getdjka:error ', 0, 0)
         lenk=end-start+1
         goto 2
      endif
      if (.not.ma_pop_stack(l_kk))
     &     call errquit('ccsdgetdjka: cannot pop stack',11,0)

      return
      end
      subroutine ccsd_cpyloop(g_objv,start,end,lenk,
     V     av,nvir,lnov, iptr,
     A     kk,djka)
      implicit none
      integer g_objv,start,end,lenk,
     V     av,nvir,lnov
      double precision kk(*),djka(*)
c
      integer startc,iptr,i,k
c
      do i=1,(end-start+1)/lenk
         call ga_get(g_objv,start,start+lenk-1,av,av,
     $        kk,lenk)
         startc=1
         do k = 1,lenk/lnov
            call dcopy(nvir,kk(startc),1,Djka(iptr),1)
            iptr=iptr+nvir
            startc=startc+lnov
         enddo
         start=start+lenk
      enddo
      return
      end

      subroutine tce_make_denom1(d_denom1,k_denom1_offset,irrep,
     1                           denom_power,omega,shift)
c
c $Id: tce_make_denom1.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_denom1
      integer p1b
      integer h2b
      integer p1
      integer h2
      integer k_denom1_offset
      integer size
      integer l_denom1,k_denom1
      integer i,irrep
      integer nprocs
      integer count
      integer next
      INTEGER NXTASK
      EXTERNAL NXTASK
      integer denom_power
      double precision shift,omega
      logical nodezero
      logical noloadbalance
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_denom1))))
      nprocs = ga_nnodes()
      count = 0
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (noloadbalance.or.(next.eq.count)) then
            if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then 
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1))
     1                                   .eq.irrep) then
              size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
              if (.not.ma_push_get(mt_dbl,size,'e1',l_denom1,k_denom1))
     1          call errquit('make_denom1: MA problem',0,MA_ERR)
              i = 0
              do p1 = 1,int_mb(k_range+p1b-1)
                do h2 = 1,int_mb(k_range+h2b-1)
                   i = i + 1
c                   dbl_mb(k_denom1+i-1) = dbl_mb(k_denom1+i-1)
c     1          /  (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
c     2              +dbl_mb(k_evl_sorted+int_mb(k_offset+h2b-1)+h2-1))
                dbl_mb(k_denom1+i-1) =
     1          (( -dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2             +dbl_mb(k_evl_sorted+int_mb(k_offset+h2b-1)+h2-1) )
     3           **denom_power-omega**denom_power+shift)
                enddo
              enddo
              call put_hash_block(d_denom1,dbl_mb(k_denom1),size,
     1          int_mb(k_denom1_offset),((p1b-noab-1)*noab+h2b-1))
              if (.not.ma_pop_stack(l_denom1))
     1          call errquit('make_denom1: MA problem',1,MA_ERR)
            endif
            endif
            endif
            next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end

      subroutine argos_diana_wthdr(fmt,sgmnam,tag,isel,logw)
c
c $Id: argos_diana_wthdr.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_diana_common.fh"
c
      character*16 cwa,sgmnam(msa)
      integer isel(msa)
      integer iunit
      character*3 fmt
      character*4 cdnum
      character*255 fname
      character*24 tag(msa,2)
      logical logw
c
      character*80 label
c
      integer i,ib,j,jb,nsb,lq,nwb
      logical binary
      character*4 dcdhdr
      character*80 dcdtit(10)
      integer*4 icntrl(20),numtit
c
      character*1 cdummy
      character*2 elemnt
      character*18 name
c
      if(me.eq.0) then
c
c      if(fmt.eq.'pov') then
c      if(iunit.eq.lfncop) filpov=filcop
c      if(iunit.eq.lfnsup) filpov=filsup
c      npov=0
c      return
c      endif
c
      binary=fmt(1:1).eq.'b'.or.fmt.eq.'dcd'
c
c      if(iunit.eq.lfncop) then
c      fname=filcop
c      if(mcopf.gt.0) then
c      lq=index(filcop,'.')
c      write(cdnum,'(a1,i3.3)') '_',icopf
c      fname=filcop(1:lq-1)//cdnum//filcop(lq:index(filcop,' ')-1)
c      endif
c
      if(binary) then
      open(unit=lfncop,file=filcop(1:index(filcop,' ')-1),
     + form='unformatted',status='unknown',err=9999)
      else
      open(unit=lfncop,file=filcop(1:index(filcop,' ')-1),
     + form='formatted',status='unknown',err=9999)
      endif
      write(*,3333) filcop(1:index(filcop,' ')-1)
 3333 format(/,' Opening copy file ',a,/)
c
c      endif
c
c      if(iunit.eq.lfnsup) then
c      fname=filsup
c      if(msupf.gt.0) then
c      lq=index(filsup,'.')
c      write(cdnum,'(a1,i3.3)') '_',isupf
c      fname=filsup(1:lq-1)//cdnum//filsup(lq:index(filsup,' ')-1)
c      endif
c      if(binary) then
c      open(unit=lfnsup,file=fname(1:index(fname,' ')-1),
c     + form='unformatted',status='unknown',err=9999)
c      else
c      open(unit=lfnsup,file=fname(1:index(fname,' ')-1),
c     + form='formatted',status='unknown',err=9999)
c      endif
c      write(*,3333) fname(1:index(fname,' ')-1)
c 3334 format(/,' Opening super file ',a,/)
c      endif
c
c
      if(fmt.eq.'trj') then
      write(lfncop,1000)
 1000 format('header')
      open(unit=44,file='.header',form='formatted',
     + status='unknown')
      rewind(44)
      read(44,4401) nwa,nsa,nsb,nwb
      if(logw) then
      write(lfncop,4401) nwa,nsa,nsb,nwb,nwsel
      else
      write(lfncop,4401) nwa,nsa,nsb,nwb,0
      endif
 4401 format(5i10)
      do 1 i=1,nwa
      read(44,4402) cwa
 4402 format(a16,i10,i5)
      write(lfncop,4402) cwa,i
    1 continue
      do 2 i=1,nsa
      read(44,4402) cwa
      write(lfncop,4402) cwa,i,isel(i)
    2 continue
      do 3 i=1,nsb+nwb
      read(44,4403) ib,jb
      write(lfncop,4403) ib,jb
 4403 format(2i8)
    3 continue
      close(unit=44)
      endif
c
      if(fmt.eq.'arc') then
      write(lfncop,2000)
 2000 format('!BIOSYM archive 3',/,'PBC=OFF')
      endif
c
      if(fmt.eq.'amb') then
      label='AMBER trajectory file'
      write(lfncop,3000) label
 3000 format(a80)
      endif
c
      if(fmt.eq.'crd') then
      label='AMBER trajectory file'
      write(lfncop,3000) label
      endif
c
      if(fmt.eq.'bam') then
      label='AMBER binary trajectory file'
      write(lfncop) label
      endif
c
      if(fmt.eq.'mvm') then
      label='ecce mvm trajectory file'
      write(lfncop,4000) label
 4000 format('# ',a)
      write(lfncop,4001)
 4001 format('type:           molecule')
      write(lfncop,4002)
 4002 format('centering:      0')
      write(lfncop,4003) nsa
 4003 format('num_atoms:      ',i7)
      write(lfncop,4004)
 4004 format('atom_info:      symbol cart')
      open(unit=44,file='.header',form='formatted',
     + status='unknown')
      rewind(44)
      read(44,4401) nwa,nsa,nsb,nwb
      do 4 i=1,nwa+nsa
      read(44,4402) cdummy
    4 continue
      write(lfncop,6003) nsb
 6003 format('num_bonds:      ',i7,/,'bond_list:')
      do 5 i=1,nsb
      read(44,4403) ib,jb
      write(lfncop,4403) ib,jb
    5 continue
      close(unit=44)
      endif
c
      if(fmt.eq.'eci') then
      label='EcceImport 1.1'
      write(lfncop,5000) label
 5000 format(a,/,' ')
      endif
c
      if(fmt.eq.'frm') then
      write(lfncop,6001) nsel
 6001 format('Atoms {',/,i8)
      do 6 i=1,nsa
      if(isel(i).ne.0) then
      elemnt=sgmnam(i)(6:7)
      name=sgmnam(i)(11:16)//':'//sgmnam(i)(1:5)//':'//sgmnam(i)(6:10)
      do 7 j=8,14
      if(name(j:j).eq.' ') name(j:j)='_'
    7 continue
      if(elemnt(1:1).eq.'1'.or.elemnt(1:1).eq.'2'.or.
     + elemnt(1:1).eq.'3'.or.elemnt(1:1).eq.'4') elemnt(1:1)=' '
      write(lfncop,6002) elemnt,name,tag(i,1)(1:index(tag(i,1),' ')-1),
     + tag(i,2)(1:index(tag(i,2),' ')-1)
 6002 format(a2,1x,a18,1x,a,1x,a)
      endif
    6 continue
      open(unit=44,file='.header',form='formatted',
     + status='unknown')
      rewind(44)
      read(44,4401) nwa,nsa,nsb,nwb
      do 8 i=1,nwa+nsa
      read(44,4402) cdummy
    8 continue
      if(nsel.eq.nsa) then
      write(lfncop,6005) nsb
      else
      write(lfncop,6005) 0
      endif
 6005 format('}',/,'Bonds {',/,i8)
      if(nsel.eq.nsa) then
      do 9 i=1,nsb
      read(44,6006) ib,jb
      write(lfncop,6006) ib,jb
 6006 format(2i8)
    9 continue
      endif
      close(unit=44)
      write(lfncop,6007)
 6007 format('}')
      endif
c
      if(fmt.eq.'dcd') then
      dcdhdr='CORD'
      do 21 i=1,20
      icntrl(i)=0
   21 continue
c     number of frames
      icntrl(1)=(ifrto-ifrfr+1)/ifrsk
      icntrl(2)=ifrfr
      icntrl(3)=1
      icntrl(4)=ifrto-ifrfr+1
      icntrl(8)=1
      icntrl(10)=1026003170
      icntrl(20)=22
      write(lfncop) dcdhdr,icntrl
      dcdtit(1)='charmm dcd formatted trajectory file'
      numtit=1
      write(lfncop) numtit,dcdtit(1)
      ldcd=.false.
      endif
c
      endif
c
      return
c
 9999 continue
      call md_abort('Failed to open file',lfncop)
      return
      end

      subroutine argos_diana_ramhdr(sgmnam,iram)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      integer iram(msgm,7)
c
      integer i,j,number
c
      number=0
      do 1 i=1,nsa
      if(i.eq.nsa) goto 2
      if(sgmnam(i)(11:16).ne.sgmnam(i+1)(11:16)) goto 2
      goto 1
    2 continue
      read(sgmnam(i)(11:16),'(i6)') j
      if(iram(j,1).gt.0.or.iram(j,5).gt.0) number=number+1
    1 continue
c
      write(lfnram,1000) number
 1000 format(i5)
c
      do 3 i=1,nsa
      if(i.eq.nsa) goto 4
      if(sgmnam(i)(11:16).ne.sgmnam(i+1)(11:16)) goto 4
      goto 3
    4 continue
      read(sgmnam(i)(11:16),'(i6)') j
      if(iram(j,1).gt.0.or.iram(j,5).gt.0)
     + write(lfnram,1002) sgmnam(i)(1:5),sgmnam(i)(11:16)
 1002 format(a5,a6)
    3 continue
c
      return
      end
c $Id: argos_diana_ramhdr.F 21176 2011-10-10 06:35:49Z d3y133 $

c
c $Id: qmmm_pes.F 22841 2012-09-12 06:55:13Z d3y133 $
c
C> \ingroup task
C> @{
      function task_qmmm_pes(irtdb)
c     $Id: qmmm_pes.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
#include "msgids.fh"
#include "tcgmsg.fh"
      integer irtdb
      logical task_qmmm_pes
c     
      character*30 operation
      character*30 theory
      logical  status
c     
      character*32 pname
c     
      logical   task_qmmm_energy_sp
      external  task_qmmm_energy_sp

      logical   qmmm_dynamics
      external  qmmm_dynamics

      logical   task_qmmm_gradient
      external  task_qmmm_gradient

      logical   task_qmmm_property
      external  task_qmmm_property

      logical   task_qmmm_esp
      external  task_qmmm_esp

      logical   qmmm_mixed_optimization
      external  qmmm_mixed_optimization

      logical ignore
      character*255 filename, prefix
      character*255 rst_in, movecs_in, espfile
      character*255 rst_perm,rst_tmp,movecs_perm
      character*255 rst_old
      character*255 geom_in,geom_tmp
      character*255 logfile
      double precision rb(2)
      integer ii
      integer np
      integer ip
      integer in
      double precision dr
      double precision r
      integer i1,i2,i3
      integer ilog
      logical ofile,ofile1
      logical backward
      logical loadrst
      logical loadmovecs
      integer ncycles
      integer istart
      integer iend
      logical pes_spring
      character*84 inmovecs_tag
      character*84 outmovecs_tag
      character*84 espmovecs_tag
      double precision energy
      double precision bq_el_energy
      double precision bq_nuc_energy
      double precision mm_energy
      double precision qm_energy
      double precision temp
      logical lvel
      logical operm
      integer tce_ref
 
      pname = "task_qmmm_pes"
c
c     which operation or theory?
c     -------------------------
      if (.not. rtdb_cget(irtdb, 'task:operation', 1, operation))
     $     operation = ' '
      if(.not.rtdb_cget(irtdb,'task:theory',1,theory))
     + call errquit('task: no task input for theory?',0, RTDB_ERR)
      
      if(theory.eq.'esp') operation=theory
c
c     default file prefix from mm module
c     ----------------------------------
      call mm_system_prefix(prefix)
      prefix = prefix(1:inp_strlen(prefix))//"_pes"
c
      call mm_restart_filename(rst_old)
c
c     get number of cycles 
c     --------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_ncycles',mt_int,
     +                    1,ncycles))
     + ncycles = 1
c
c
c     get lower/upper  limits for pes scan
c     ------------------------------------
      pes_spring = .true.
      if (.not. rtdb_get(irtdb,'qmmm:pes_bounds',mt_dbl,
     +                    2,rb))
     + pes_spring = .false.

c
c     get number of points for pes scan
c     ------------------------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_npoints',mt_int,
     +                    1,np))
     + call errquit(pname//'Failed to get pes points',
     + 1, RTDB_ERR)
c
c     get starting point
c     ------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_istart',mt_int,
     +                    1,istart))
     +    istart = 1
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_iend',mt_int,
     +                    1,iend))
     +    iend = np
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_backward',mt_log,
     +                    1,backward))
     +  backward = .false.
c
      if (.not. rtdb_cget(irtdb,'qmmm:pes_geom_input',
     +                    1,geom_in))
     +  geom_in = " "
c
      if (.not. rtdb_cget(irtdb,'qmmm:pes_rst_input',
     +                    1,rst_in))
     +  rst_in = " "
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_rst_perm',mt_log,
     +                    1,operm))
     +  operm = .true.
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_vel',mt_log,
     +                    1,lvel))
     +  lvel = .false.
c
      if (.not. rtdb_cget(irtdb,'qmmm:pes_vectors_input',
     +                    1,movecs_in))
     +  movecs_in = " "
c
c     was logfile unit number provided
c     (created for abc calculations)
c     -------------------------------- 
      if (.not. rtdb_get(irtdb,'qmmm:pes_logfile',mt_int,1,ilog))
     +  ilog = -1
c      
      if(rst_in .eq. " ") then
       loadrst = .false.
       rst_in = prefix
      else
       loadrst = .true.
      end if

      if(movecs_in .eq. " ") then
       loadmovecs = .false.
       movecs_in = prefix 
      else
       loadmovecs = .true.
      end if
c
      if(theory.eq."dft") then
        inmovecs_tag = 'dft:input vectors'
        outmovecs_tag = 'dft:output vectors'
      else if(theory.eq."tce") then
        if (.not.rtdb_get(irtdb,'tce:reference',mt_int,1,tce_ref))
     +    call errquit('failed to get  tce:reference',0,RTDB_ERR)

        if(tce_ref.eq.0) then
        inmovecs_tag = 'dft:input vectors'
        outmovecs_tag = 'dft:output vectors'
        else
        inmovecs_tag = "scf:input vectors"
        outmovecs_tag = "scf:output vectors"
        end if
      else if(theory.eq."mp2") then
        inmovecs_tag = "scf:input vectors"
        outmovecs_tag = "scf:output vectors"
       else if(theory.eq."scf") then
        inmovecs_tag = "scf:input vectors"
        outmovecs_tag = "scf:output vectors"
      else if(theory.eq."esp") then
        inmovecs_tag = "esp:input vectors"
        outmovecs_tag = "esp:input vectors"
      else
        call errquit(pname//'theory not supported'//theory,0,0)
      end if
c
      espmovecs_tag = "esp:input vectors"
c
c     this will force property module
c     not to recalculate movecs
c     -------------------------------
      if(operation.eq."property") then
        inmovecs_tag = "prop:vectors"
        outmovecs_tag = "prop:vectors"
      end if

c 
c     set increments and initial value for spring
c     -------------------------------------------
      if(pes_spring) then
        dr = (rb(2)-rb(1))/(np-1)
        r  = rb(1)
      end if

      do in=1,ncycles
      if(backward) then
        i1=iend
        i2=istart
        i3=-1
      else
        i1=istart
        i2=iend
        i3=1
      end if


      ignore = rtdb_delete(irtdb,outmovecs_tag)
      ignore = rtdb_delete(irtdb,inmovecs_tag)
c
c     actually do the scan
c     --------------------
      do ip=i1,i2,i3
        if(pes_spring) then
          r  = rb(1)+dr*(ip-1) 
          if(ga_nodeid().eq.0) then
            write(*,15) ip,r
          end if
          if (.not. rtdb_put(irtdb,'qmmm:r_spring',mt_dbl,
     +                       1,r))
     +    call errquit(pname//'Failed to set r_spring',
     +    1, RTDB_ERR)
        else
          if(ga_nodeid().eq.0) then
            write(*,23) ip
          end if
        end if

c
c       initiating restart files
c       -----------------------
        rst_tmp  = " "
        rst_perm = " "
        write(rst_tmp,21) rst_in(1:inp_strlen(rst_in)), ip
 21     format(a,i3.3,'.rst')
        rst_perm = rst_tmp
        ii = index(rst_perm,".rst")-1
        espfile = rst_perm(1:ii)//".esp"
        if (.not.rtdb_cput(irtdb,'qmmm:esp:save:file',1,espfile)) 
     >   call errquit(pname,0,RTDB_ERR)
        if(operm)  
     >    call util_file_name_resolve(rst_perm, .false.)
        if(loadrst) then
          if(ga_nodeid().eq.0) then 
            inquire(file=rst_perm,exist=ofile)
            if(ofile) then 
             write(*,*) "pes: found restart file ",
     >                 rst_perm(1:inp_strlen(rst_perm))
             if(operm)  
     >          call util_file_copy(rst_perm(1:inp_strlen(rst_perm)),
     >                          rst_tmp(1:inp_strlen(rst_tmp)))
            else
             write(*,*) "pes: cannot find restart file "
            end if
          end if
          call ga_brdcst(msg_qmmm_misc, ofile, mitob(1), 0)
          call ga_sync()
          if(ofile) then
            call mm_reload_rst(irtdb,rst_tmp)
          else
            call errquit(pname//'cannot find rst file'//rst_perm,
     >                   0,0) 
          end if
        end if
        call mm_get_temp(temp)
c
c       initiating movecs files
c       ----------------------
        movecs_perm = ' '
        write(movecs_perm,22) movecs_in(1:inp_strlen(movecs_in)), ip
 22     format(a,i3.3,'.movecs')
        if(loadmovecs) then
          ignore = rtdb_delete(irtdb,inmovecs_tag)
          if (.not. rtdb_cput(irtdb,inmovecs_tag,
     +                      1,movecs_perm))
     +    call errquit(pname//'Failed to set movecs',0,0)
        end if
        ignore = rtdb_delete(irtdb,outmovecs_tag)
        if (.not. rtdb_cput(irtdb,espmovecs_tag,
     +                    1,movecs_perm))
     +  call errquit(pname//'Failed to set movecs',0,0)
        if (.not. rtdb_cput(irtdb,outmovecs_tag,
     +                    1,movecs_perm))
     +  call errquit(pname//'Failed to set movecs',0,0)
c
c       loading geometries if any
c       -------------------------
        if(geom_in.ne." ") then
          write(geom_tmp,34) geom_in(1:inp_strlen(geom_in)), ip
 34       format(a,i3.3,'.xyzi')
c          call util_file_name_resolve(geom_tmp, .false.)
          write(*,*) geom_tmp
          call mm_set_solute_coord_file(geom_tmp)
        end if

        if(operation.eq."energy") then
          status = task_qmmm_energy_sp(irtdb) 
        else if (operation.eq."gradient") then
          status = task_qmmm_gradient(irtdb)
        else if (operation.eq."dynamics") then
          status = qmmm_dynamics(irtdb)
          lvel =.true.
        else if (operation.eq."optimize") then
          status = qmmm_mixed_optimization(irtdb)
        else if (operation.eq."property") then
          status = task_qmmm_property(irtdb)
        else if (operation.eq."esp") then
          status = task_qmmm_esp(irtdb)
        end if 
 
        if(ga_nodeid().eq.0) then 
           write(*,*) "pes: saving restart file",
     >                 rst_perm
        end if
        call mm_write_restart_named(rst_perm,lvel)
        if(operm) then
        if(ga_nodeid().eq.0) then 
          if(rst_tmp.ne.rst_old) then
            write(*,*) "pes: removing file",rst_tmp
            call util_file_unlink(rst_tmp)
          end if
        end if
        end if

        if(operation.eq."energy".or.
     >     operation.eq."gradient".or.
     >     operation.eq."optimize") then
           if (.not. rtdb_get(irtdb,'qmmm:qm_energy',
     $                        mt_dbl,1,qm_energy))
     $          call errquit(pname//" qm energy", 0, RTDB_ERR)
           if (.not. rtdb_get(irtdb,'qmmm:mm_energy',
     $                        mt_dbl,1,mm_energy))
     $          call errquit(pname//" mm energy", 0, RTDB_ERR)
           if (.not. rtdb_get(irtdb,'qmmm:energy',
     $                        mt_dbl,1,energy))
     $         call errquit('qmmm: failed get energy', 0, RTDB_ERR)
           if (.not. rtdb_get(irtdb,'dft:bq_energy',
     $                        mt_dbl,1,bq_el_energy))
     $         bq_el_energy = 0.0d0
           if (.not. rtdb_get(irtdb,'qmmm:bq_nuc_energy',mt_dbl,1,
     >                   bq_nuc_energy))
     $     bq_nuc_energy = 0.0d0

          if(ga_nodeid().eq.0) then
            if(ilog.ne.-1)
     >       write(ilog,*) temp,energy,mm_energy,qm_energy,
     >                     bq_el_energy,bq_nuc_energy
            if(pes_spring) then
              write(*,24) ip ,energy, r
            else
              write(*,25) ip ,energy
            end if
          end if
        end if

        if(.not.loadmovecs) then
          ignore = rtdb_delete(irtdb,inmovecs_tag)
          if (.not. rtdb_cput(irtdb,inmovecs_tag,
     +                      1,movecs_perm))
     +    call errquit(pname//'Failed to set movecs',0,0)
        end if
 
        call ga_sync()

      end do
      backward = .not.backward
      loadrst = .true.
      loadmovecs = .true.
      end do
c
c     restore old restart filename
c     in case of more tasks
c     -----------------------------
      call mm_set_restart_file(irtdb,rst_old)
      ignore = rtdb_delete(irtdb,outmovecs_tag)
      ignore = rtdb_delete(irtdb,inmovecs_tag)
      

      task_qmmm_pes = status

 13      format(a,'/',a,'_neb',i3.3,'.rst')
 14      format(a,'_neb',i3.3,'.rst')
 15      format("@pes: point ", I2,3X,"spring length = ",F12.6)
 16      format("@pes: energy =  ", F18.12,3X,"length = ",F12.6)
 17      format(a,'/',a,'_pes',i3.3,'.movecs')
 23      format("@pes: processing point ", I2)
 24      format("@pes: point = ",I2,
     >          " energy =  ", F18.12,3X,
     >          " spring length = ",F12.6)
 25      format("@pes: point = ",I2,
     >          " energy =  ", F18.12,3X)

      return
      end
C> @}

      subroutine ccsd_z2pm(basis,nsh,ncor,nocc,nvir,nbf,g_sz2,g_nz2,cmo,
     &                     scra,scrb)
C     $Id: ccsd_z2pm.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
      integer basis,nsh,ncor,nocc,nvir,nbf,g_sz2,g_nz2
      double precision cmo(nbf,nbf),scra(nbf*nbf),scrb(nbf*nbf)
#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "bas.fh"
#include "rtdb.fh"
#include "ccsdps.fh"
c
      integer g_sz2t,lnoo
      integer i,j,k,l,ad1,ad2,ad3,g_jlo,g_jhi,g_ilo,g_ihi,
     &        ish,ilo,ihi,jsh,jlo,jhi,ksh,klo,khi,lsh,llo,lhi,
     &        xy,x,y,ipp,imm,ii,jj,iijj,jjii
c
      Integer Nodes, IAm
      Nodes = GA_NNodes()
      IAM = GA_NodeID()
c
      if (occsdps) then
         call pstat_on(ps_z2pm)
      else
         call qenter('z2pm',0)
      endif
C
      lnoo=nocc*nocc
c
*ga:1:0
      if (.not.ga_create(MT_DBL,nbf*nbf,lnoo,'sz2t',
     &                   nbf*nbf,0,g_sz2t))
     &     call errquit('ccsd_z2pm: ga_create g_sz2t failed',0, GA_ERR)
c
      call ga_distribution(g_nz2,iam,g_jlo,g_jhi,g_ilo,g_ihi)
      do i=1,nocc
        ad1=(i-1)*nvir
        if (ad1+1.ge.g_ilo.and.ad1+1.le.g_ihi)then
          do j=1,nocc
            ad2=(j-1)*nvir
            if (ad2+1.ge.g_jlo.and.ad2+1.le.g_jhi)then
              call ga_get(g_nz2,ad2+1,ad2+nvir,ad1+1,ad1+nvir,
     &                    scra,nvir)
              call dgemm('n','t',nvir,nbf,nvir,1.0d00,scra,nvir,
     &                   cmo(1,ncor+nocc+1),nbf,0.0d00,scrb,nvir)
              call dgemm('n','n',nbf,nbf,nvir,1.0d00,cmo(1,ncor+nocc+1),
     &                   nbf,scrb,nvir,0.0d00,scra,nbf)
              ad3=0
              do ksh=1,nsh
                if (.not. bas_cn2bfr(basis,ksh,klo,khi))
     &              call errquit('vvvv: bas_cn2bfr',ksh, BASIS_ERR)
                do lsh=1,nsh
                  if (.not. bas_cn2bfr(basis,lsh,llo,lhi))
     &                call errquit('vvvv: bas_cn2bfr',lsh, BASIS_ERR)
                  do k=klo,khi
                    do l=llo,lhi
                      ad3=ad3+1
                      scrb(ad3)=scra((k-1)*nbf+l)
                    enddo
                  enddo
                enddo
              enddo
              ad3=(i-1)*nocc+j
              call ga_put(g_sz2t,1,nbf*nbf,ad3,ad3,
     &                    scrb,nbf*nbf)
            endif
          enddo
        endif
      enddo
c
      call ga_transpose(g_sz2t,g_sz2)
      if (.not.ga_destroy(g_sz2t))
     &    call errquit('ga_dest g_sz2t fail',0, GA_ERR)
c
c ------------------------------------------------------------
c - form z2+/- (see gustavos paper)
c - z2+ = t_ij^ab + t_ij^ba 
c - z2- = t_ij^ab - t_ij^ba 
c - some prefactors absorbed
c ------------------------------------------------------------
      call ga_distribution(g_sz2,iam,g_jlo,g_jhi,g_ilo,g_ihi)
      xy=0
      do ish=1,nsh
        if (.not. bas_cn2bfr(basis,ish,ilo,ihi))
     $      call errquit('vvvv: bas_cn2bfr',ish, BASIS_ERR)
        do jsh=1,nsh
          if (.not. bas_cn2bfr(basis,jsh,jlo,jhi))
     $        call errquit('vvvv: bas_cn2bfr',jsh, BASIS_ERR)
          do x=ilo,ihi
            do y=jlo,jhi
              xy=xy+1
              if (xy.ge.g_ilo.and.xy.le.g_ihi)then
                call ga_get(g_sz2,1,lnoo,xy,xy,scra,lnoo)
                ipp=0
                imm=nocc*(nocc+1)/2
                do ii=1,nocc
                  do jj=1,ii-1
                    iijj=(ii-1)*nocc+jj
                    jjii=(jj-1)*nocc+ii
                    ipp=ipp+1
                    imm=imm+1
                    scrb(ipp)=(scra(iijj)+scra(jjii))
                    scrb(imm)=(scra(iijj)-scra(jjii))
                  enddo
                  iijj=(ii-1)*nocc+ii
                  ipp=ipp+1
                  scrb(ipp)=scra(iijj)+scra(iijj)
                enddo
                if (x.eq.y)then
                  call dscal(lnoo,0.25d00,scrb,1)
                else
                  call dscal(lnoo,0.5d00,scrb,1)
                endif
                call ga_put(g_sz2,1,lnoo,xy,xy,scrb,lnoo)
              endif
            enddo
          enddo
        enddo
      enddo
c
      if (occsdps) then
         call pstat_off(ps_z2pm)
      else
         call qexit('z2pm',0)
      endif
c
      return
      end
      subroutine ccsd_hz2pm(basis,nsh,ncor,nocc,nvir,nbf,g_shz2,
     &                      g_nhz2,cmo,
     &                      scra,scrb,offsh)
      implicit none
#include "errquit.fh"
      integer basis,nsh,ncor,nocc,nvir,nbf,g_shz2,g_nhz2,
     &        offsh(nsh,nsh)
      double precision cmo(nbf,nbf),scra(nbf*nbf),scrb(nbf*nbf)

#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "bas.fh"
#include "rtdb.fh"
#include "ccsd_debug.fh"
#include "ccsdps.fh"
c
      integer g_shz2t,g_jlo,g_jhi,g_ilo,g_ihi,
     &        ish,ilo,ihi,jsh,jlo,jhi,ksh,klo,khi,lsh,llo,lhi,
     &        x,y,xy,ymax,nfi,nfj,ipp,imm,ii,jj,iijj,
     &        jjii,i,j,k,l,ad1,ad2,ad3,lnoo,a,b
c
      Integer Nodes, IAm
      Nodes = GA_NNodes()
      IAM = GA_NodeID()
c
      if (occsdps) then
         call pstat_on(ps_hz2pm)
      else
         call qenter('hz2pm',0)
      endif
c
      lnoo=nocc*nocc
c
      call ga_distribution(g_shz2,iam,g_jlo,g_jhi,g_ilo,g_ihi)
      do ish=1,nsh
        if (.not. bas_cn2bfr(basis,ish,ilo,ihi))
     $      call errquit('vvvv: bas_cn2bfr',ish, BASIS_ERR)
        nfi=ihi-ilo+1
        do jsh=1,ish
          if (.not. bas_cn2bfr(basis,jsh,jlo,jhi))
     $        call errquit('vvvv: bas_cn2bfr',jsh, BASIS_ERR)
          nfj=jhi-jlo+1
          do x=1,nfi
            ymax=nfj
            if (ish.eq.jsh)ymax=x
            do y=1,ymax
              xy=offsh(ish,jsh)+(x-1)*nfj+y
              if (xy.ge.g_ilo.and.xy.le.g_ihi)then
                call ga_get(g_shz2,1,lnoo,xy,xy,scra,lnoo)
                ipp=0
                imm=nocc*(nocc+1)/2
                do ii=1,nocc
                  do jj=1,ii-1
                    ipp=ipp+1
                    imm=imm+1
                    iijj=(ii-1)*nocc+jj
                    jjii=(jj-1)*nocc+ii
                    scrb(iijj)=scra(ipp)+scra(imm)
                    scrb(jjii)=scra(ipp)-scra(imm)
                  enddo
                  iijj=(ii-1)*nocc+ii
                  ipp=ipp+1
                  scrb(iijj)=scra(ipp)
                enddo
                call ga_put(g_shz2,1,lnoo,xy,xy,scrb,lnoo)
                if (ish.ne.jsh.or.x.ne.y)then
                  xy=offsh(jsh,ish)+(y-1)*nfi+x
                  do ii=1,nocc
                    do jj=1,nocc
                     iijj=(ii-1)*nocc+jj
                     jjii=(jj-1)*nocc+ii
                     scra(iijj)=scrb(jjii)
                    enddo
                  enddo
                  call ga_put(g_shz2,1,lnoo,xy,xy,scra,lnoo)
                endif
              endif
            enddo
          enddo
        enddo
      enddo
      call ga_sync()
c
c ------------------------------------------------------------
c - transform ao indices of hz2 array into the mo basis
c ------------------------------------------------------------

*ga:1:0
      if (.not.ga_create(MT_DBL,nbf*nbf,lnoo,'shz2t',
     &                   nbf*nbf,0,g_shz2t))
     &     call errquit('ccsd_hz2pm: ga_create g_shz2t failed',0,
     &       GA_ERR)

      call ga_transpose(g_shz2,g_shz2t)
c - redefine g_shz2
      if (.not.ga_destroy(g_shz2))
     &    call errquit('ga_dest g_shz2 fail',0, GA_ERR)
*ga:1:0
      if (.not.ga_create(MT_DBL,nbf*nbf,lnoo,'shz2',
     &                   nbf*nbf,0,g_shz2))
     &     call errquit('ccsd_hz2pm: ga_create g_shz2 failed',0, GA_ERR)

      call ga_distribution(g_nhz2,iam,g_jlo,g_jhi,g_ilo,g_ihi)
      do i=1,nocc
        ad1=(i-1)*nvir
        if (ad1+1.ge.g_ilo.and.ad1+1.le.g_ihi)then
          do j=1,nocc
            ad2=(j-1)*nvir
            if (ad2+1.ge.g_jlo.and.ad2+1.le.g_jhi)then
            ad3=(i-1)*nocc+j
              call ga_get(g_shz2t,1,nbf*nbf,ad3,ad3,
     &                    scrb,nbf*nbf)
              ad3=0
              do ksh=1,nsh
                if (.not. bas_cn2bfr(basis,ksh,klo,khi))
     &              call errquit('vvvv: bas_cn2bfr',ksh, BASIS_ERR)
                do lsh=1,nsh
                  if (.not. bas_cn2bfr(basis,lsh,llo,lhi))
     &                call errquit('vvvv: bas_cn2bfr',lsh, BASIS_ERR)
                  do k=klo,khi
                    do l=llo,lhi
                      ad3=ad3+1
                      scra((k-1)*nbf+l)=scrb(ad3)
                    enddo
                  enddo
                enddo
              enddo
              call dgemm('n','n',nbf,nbf,nbf,1.0d00,scra,nbf,
     &                   cmo(1,ncor+1),nbf,0.0d00,scrb,nbf)
              call dgemm('t','n',nbf,nbf,nbf,1.0d00,cmo(1,ncor+1),nbf,
     &                   scrb,nbf,0.0d00,scra,nbf)
              ad3=(i-1)*nocc+j
              call ga_put(g_shz2,1,nbf*nbf,ad3,ad3,
     &                    scra,nbf*nbf)
c
              if (dob(1).eq.2)then
                ad3=0
                do a=nocc+1,nbf
                  do b=nocc+1,nbf
                    ad3=ad3+1
                    scrb(ad3)=-scra((a-1)*nbf+b)
                  enddo
                enddo
                call ga_acc(g_nhz2,ad2+1,ad2+nvir,ad1+1,ad1+nvir,
     &                      scrb,nvir,1.0d00)
              endif
c
            endif
          enddo
        endif
      enddo
      if (.not.ga_destroy(g_shz2t))
     &    call errquit('ga_dest g_shz2t fail',0, GA_ERR)
c
      if (occsdps) then
         call pstat_off(ps_hz2pm)
      else
         call qexit('hz2pm',0)
      endif
c
      return
      end

      logical function rjhtest(rtdb)
*     
*     $Id: rjhtest.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "inp.fh"
      integer rtdb
c
      integer basis, geom, nbf
      integer l_aoint, k_aoint        ! nbf**4 array of AO integrals
      character*255 movecs      ! Name of movector file
      character*80 title, name_of_basis, scftype
      integer nbf_file, nsets, nmo_file(2)
      logical movecs_read, movecs_read_header
      external movecs_read, movecs_read_header
c
      integer nmo, nalpha, nbeta, g_tmp, l_occ, k_occ,
     $     l_aeval, k_aeval, l_beval, k_beval, l_amos, k_amos,
     $     l_bmos, k_bmos
      integer nocc, nvirt, nso, l_sos, k_sos, l_seval, k_seval,
     $     l_sospin, k_sospin, l_tmp, k_tmp, l_soint, k_soint
      integer l_t2, k_t2, l_t1, k_t1
      integer l_r2, k_r2, l_r1, k_r1
      integer i, iter
      logical int_normalize
      external int_normalize
c     
c     load the geometry/basis set and get info
c
      if (.not. geom_create(geom, 'geometry'))
     $     call errquit('scf_init: geom_create?', 0, GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, 'geometry'))
     $     call errquit('scf_init: no geometry ', 0, RTDB_ERR)
      if (.not. bas_create(basis, 'ao basis'))
     $     call errquit('scf_init: bas_create?', 0, BASIS_ERR)
      if (.not. bas_rtdb_load(rtdb, geom, basis, 'ao basis')) 
     $        call errquit('scf_init: no ao basis set', 0, RTDB_ERR)
      if (.not.int_normalize(rtdb, basis))
     $           call errquit('scf:int_normalize failed', 0, INT_ERR)
      if (.not. bas_numbf(basis, nbf)) call errquit
     $     ('scf_init: basis info',0, BASIS_ERR)
c
c     Read the MO vectors and evals from a UHF calculation
c
      call util_file_name('movecs',.false.,.false.,movecs)
      if (.not. movecs_read_header(movecs, title, name_of_basis,
     $     scftype, nbf_file, nsets, nmo_file, 2)) call errquit
     $     ('rjhtest: failed to read movecs header',0, DISK_ERR)
      if (nsets.ne.2) call errquit('rjhtest:UHF ONLY!',0, INPUT_ERR)
      write(6,*) ' Read movecs header from ', movecs
      write(6,*) ' Job title :                ', 
     $     title(1:inp_strlen(title))
      write(6,*) ' Basis name:                ', 
     $     name_of_basis(1:inp_strlen(name_of_basis))
      nmo = nmo_file(1)
      if (nmo_file(1).ne.nmo_file(2)) call errquit('rjhtest:Uh?',0,
     &       UNKNOWN_ERR)
      if (.not. rtdb_get(rtdb, 'scf:nalpha', mt_int, 1, nalpha))
     $     call errquit('rjhtest:nalpha?',0, RTDB_ERR)
      if (.not. rtdb_get(rtdb, 'scf:nbeta', mt_int, 1, nbeta))
     $     call errquit('nbeta?',0, RTDB_ERR)
      nocc = nalpha+nbeta
      nso  = nmo*2
      nvirt= nso - nocc
      write(6,*) ' No. of alpha electrons:    ', nalpha
      write(6,*) ' No. of beta  electrons:    ', nbeta
      write(6,*) ' No. of molecular orbitals: ', nmo
      write(6,*) ' No. of basis functions:    ', nbf
      write(6,*) ' No. of spin-orbitals (SO)  ', nso
      write(6,*) ' No. of occupied SOs:       ', nocc
      write(6,*) ' No. of virtual SOs:        ', nvirt
c
      if (.not. ga_create(mt_dbl, nbf, nmo, 'tmp', 1, 1, g_tmp))
     &     call errquit('scf_v_g: tmp', 0, GA_ERR)
      if (.not. ma_push_get(mt_dbl, nbf,'occ',l_occ, k_occ))
     $     call errquit('ma occ', nbf, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nbf,'aeval',l_aeval, k_aeval))
     $     call errquit('ma eval', nbf, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nbf,'beval',l_beval, k_beval))
     $     call errquit('ma eval', nbf, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nbf*nbf,'amos', l_amos, k_amos))
     $     call errquit('ma amos', nbf*nbf, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nbf*nbf,'bmos', l_bmos, k_bmos))
     $     call errquit('ma bmos', nbf*nbf, MA_ERR)
c
      if (.not. movecs_read(movecs, 1, dbl_mb(k_occ), dbl_mb(k_aeval), 
     $     g_tmp)) call errquit('movecs_read of amos failed ',0,
     &       DISK_ERR)
      call ga_get(g_tmp, 1, nbf, 1, nmo, dbl_mb(k_amos), nbf)
      if (.not. movecs_read(movecs, 2, dbl_mb(k_occ), dbl_mb(k_beval), 
     $     g_tmp)) call errquit('movecs_read of amos failed ',0,
     &       DISK_ERR)
      call ga_get(g_tmp, 1, nbf, 1, nmo, dbl_mb(k_bmos), nbf)
c
      write(6,*) ' Alpha eigenvalues '
      call output(dbl_mb(k_aeval),1,nmo,1,1,nmo,1,1)
      write(6,*) ' Beta  eigenvalues '
      call output(dbl_mb(k_beval),1,nmo,1,1,nmo,1,1)
c$$$      write(6,*) ' Alpha MOs'
c$$$      call output(dbl_mb(k_amos),1,nbf,1,nmo,nbf,nmo,1)
c$$$      write(6,*) ' Beta  MOs'
c$$$      call output(dbl_mb(k_bmos),1,nbf,1,nmo,nbf,nmo,1)
c
      if (.not. ga_destroy(g_tmp)) call errquit(' ga bad?',0, GA_ERR)
c
c     So now have nalpha, nbeta, nmo, a/beval, a/bmos
c
c     For brute force approach form the spin-orbitals in the order
c
c     beta occupied, alpha occupied, beta virtual, alpha virtual
c
      if (.not. ma_push_get(mt_dbl, nbf*nso,'sos', l_sos, k_sos))
     $     call errquit('ma sos', nbf*nso, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nso,'sos', l_seval, k_seval))
     $     call errquit('ma seval', nso, MA_ERR)
      if (.not. ma_push_get(mt_int, nso,'sospin', l_sospin, k_sospin))
     $     call errquit('ma sospin', nso, MA_ERR)
      call rjh_munge_mo_to_so(nbf, nmo, nso, nalpha, nbeta,
     $     dbl_mb(k_aeval), dbl_mb(k_beval), dbl_mb(k_amos),
     $     dbl_mb(k_bmos), dbl_mb(k_seval), dbl_mb(k_sos),
     $     int_mb(k_sospin))
c
      write(6,*) ' Spin-orbital eigenvalues '
      call output(dbl_mb(k_seval), 1, nso, 1, 1, nso, 1, 1)
c$$$      write(6,*) ' Spin-orbitals '
c$$$      call output(dbl_mb(k_sos), 1, nbf, 1, nso, nbf, nso, 1)
      write(6,*) ' Spin-orbital spins'
      do i = 1, nso
         write(6,11) i, int_mb(k_sospin+i-1)
 11      format(i5,2x,i2)
      end do
c
c     Now do a brute force transformation to the spin-orbit basis
c     zeroing out afterwards the components that are zero by spin
c
      if (.not. ma_push_get(mt_dbl, nso**4,'soint', l_soint, k_soint))
     $     call errquit('ma soint', nso**4, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nso**4,'tmp', l_tmp, k_tmp))
     $     call errquit('ma tmp', nso**4, MA_ERR)
      if (.not. ma_push_get(mt_dbl,nbf**4,'aoint',l_aoint,k_aoint))
     $     call errquit('allocation of AO integrals failed',nbf**4,
     &       MA_ERR)
c
      call rjh_all_ao_integrals(rtdb,basis,nbf,'dirac',dbl_mb(k_aoint))
      call rjh_uhf_trans(nbf, nso, int_mb(k_sospin),
     $     dbl_mb(k_sos), dbl_mb(k_aoint), 
     $     dbl_mb(k_tmp), dbl_mb(k_soint))
      if (.not. ma_chop_stack(l_tmp))call errquit('chopping from tmp',0,
     &       MA_ERR)
c
c     Compute the MP2 energy from the plain SO integrals
c
      call rjh_uhf_mp2(nocc, nso, dbl_mb(k_seval), dbl_mb(k_soint))
c
c     Antisymmetrize the SO integrals and write to file ASOINTS
c
      call rjh_so_asym(nso, dbl_mb(k_soint))
c
c     Make the first-order T2 amplitudes and recompute the MP2 energy
c     from them.  Write T2 to file T2.  Write a zero T1 to T1.
c
      if (.not. ma_push_get(mt_dbl, (nocc**2)*(nvirt**2),'t2', 
     $     l_t2, k_t2))
     $     call errquit('ma tmp', (nocc**2)*(nvirt**2),
     &       MA_ERR)
c
      call rjh_uhf_mp2_from_asoint(nocc, nvirt, nso, 
     $     dbl_mb(k_seval), dbl_mb(k_soint), dbl_mb(k_t2))
c
c     Now do some CC iterations
c
      if (.not. ma_push_get(mt_dbl, (nocc**2)*(nvirt**2),'t1', 
     $     l_t1, k_t1))
     $     call errquit('ma tmp', (nocc**2)*(nvirt**2),
     &       MA_ERR)
      call dfill(nvirt*nocc, 0.0d0, dbl_mb(k_t1), 1)
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,int_mb(k_sospin),
     $     dbl_mb(k_t1), dbl_mb(k_t2), 0)
c
      if (.not. ma_push_get(mt_dbl, (nocc**2)*(nvirt**2),'r2', 
     $     l_r2, k_r2))
     $     call errquit('ma tmp', (nocc**2)*(nvirt**2), MA_ERR)
      if (.not. ma_push_get(mt_dbl, (nocc**2)*(nvirt**2),'r1', 
     $     l_r1, k_r1))
     $     call errquit('ma tmp', (nocc**2)*(nvirt**2), MA_ERR)
      do iter = 1, 50
         call rjh_uhf_cc_energy(nocc, nvirt, nso,
     $        dbl_mb(k_t1), dbl_mb(k_t2),
     $        dbl_mb(k_seval), dbl_mb(k_soint))
         call rjh_uhf_cc_rhs(nocc, nvirt, nso, int_mb(k_sospin),
     $        dbl_mb(k_t1), dbl_mb(k_t2),
     $        dbl_mb(k_seval), dbl_mb(k_soint),
     $        dbl_mb(k_r1), dbl_mb(k_r2))
         call rjh_uhf_cc_update(nocc, nvirt, nso,
     $        dbl_mb(k_t1), dbl_mb(k_t2),
     $        dbl_mb(k_seval),
     $        dbl_mb(k_r1), dbl_mb(k_r2))
      end do
      call rjh_t1_t2_print(nocc,nvirt,nso,dbl_mb(k_t1),dbl_mb(k_t2))

c
c     Tidy up
c
      if (.not. ma_chop_stack(l_occ)) call errquit(' ma chop?', 0,
     &       MA_ERR)
      if (.not. bas_destroy(basis)) call errquit(' bas ?',0, BASIS_ERR)
      if (.not. geom_destroy(geom)) call errquit(' geom ?',0, GEOM_ERR)
c
      rjhtest = .true.
c
      end
      subroutine rjh_all_ao_integrals(rtdb, basis, nbf, order, ao)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "bas.fh"
      integer rtdb, basis, nbf
      double precision ao(nbf,nbf,nbf,nbf)
      character*(*) order
c
      integer nsh, k_i, k_j, k_k, k_l, l_i, l_j, l_k, l_l,
     $     maxg2, maxs2, k_buf, l_buf, k_scr, l_scr
c
      call int_init(rtdb, 1, basis)
      if ( .not. bas_numcont(basis, nsh) ) call errquit(
     $     'ao_fock_2e: problem with call to bas_numcont', basis,
     &       BASIS_ERR)
      call int_mem_2e4c(maxg2,maxs2)
      if (.not. ma_push_get(mt_dbl,maxs2,'scr',l_scr, k_scr))
     $   call errquit('ma scr',maxg2, MA_ERR)
      if (.not. ma_push_get(mt_dbl,maxg2,'buf',l_buf, k_buf))
     $   call errquit('ma buf',maxg2, MA_ERR)
      if (.not. ma_push_get(mt_int,maxg2,'i',l_i, k_i))
     $   call errquit('ma ibuf',maxg2, MA_ERR)
      if (.not. ma_push_get(mt_int,maxg2,'j',l_j, k_j))
     $   call errquit('ma jbuf',maxg2, MA_ERR)
      if (.not. ma_push_get(mt_int,maxg2,'k',l_k, k_k))
     $   call errquit('ma kbuf',maxg2, MA_ERR)
      if (.not. ma_push_get(mt_int,maxg2,'l',l_l, k_l))
     $   call errquit('ma lbuf',maxg2, MA_ERR)
c
      call rjh_do_all_ao_integrals(basis, dbl_mb(k_buf), dbl_mb(k_scr),
     $     int_mb(k_i), int_mb(k_j), int_mb(k_k), int_mb(k_l),
     $     maxg2, maxs2, nbf, nsh, order, ao)
c
      if (.not. ma_chop_stack(l_scr)) call errquit('rjhallao: ma?',0,
     &       MA_ERR)
c
      call int_terminate
c
      end
      subroutine rjh_do_all_ao_integrals(
     $     basis, buf, scr, ilab, jlab, klab,
     $  llab, maxg2, maxs2, nbf, nsh, order, ao)
      implicit none
#include "errquit.fh"
c
      integer basis, nbf, nsh, maxg2, maxs2
      double precision buf(maxg2), scr(maxs2)
      integer ilab(maxg2), jlab(maxs2), klab(maxs2), llab(maxs2)
      integer i, j, k ,l, ish, jsh, ksh, lsh, ijkl, nint
      character*(*) order
      double precision ao(nbf,nbf,nbf,nbf)
      double precision zerotol
      logical omulliken
c
      if (order .eq. 'mulliken') then
         omulliken = .true.
      else if (order .eq. 'dirac') then
         omulliken = .false.
      else
         call errquit(' unknown order',0, UNKNOWN_ERR)
      end if
c
      call dfill(nbf**4, 0.0d0, ao, 1)
      zerotol = 1d-12
c  
      do ish = 1, nsh
         do jsh = 1, nsh
            do ksh = 1, nsh
               do lsh = 1, nsh
                  call int_l2e4c(basis, ish, jsh, basis, ksh, lsh,
     &                 zerotol, .false., maxg2, buf, nint, 
     $                 ilab, jlab, klab, llab, maxs2, scr)
                  do ijkl = 1, nint
                     i = ilab(ijkl)
                     j = jlab(ijkl)
                     k = klab(ijkl)
                     l = llab(ijkl)
                     if (omulliken) then
                        ao(i,j,k,l) = buf(ijkl)
                     else
                        ao(i,k,j,l) = buf(ijkl)
                     end if
                  end do
               end do
            end do
         end do
      end do
c
c$$$      write(6,*)
c$$$      write(6,*) ' AO integrals '
c$$$      write(6,*)
c$$$      do i = 1, nbf
c$$$         do j = 1, nbf
c$$$            do k = 1, nbf
c$$$               do l = 1, nbf
c$$$                  if ( abs(ao(i,j,k,l)) .gt. 1e-6 ) 
c$$$     $                 write(6,7) i,j,k,l,ao(i,j,k,l)
c$$$ 7                format(1x,4i5,2x,f12.6)
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c
      end
      subroutine rjh_munge_mo_to_so(nbf, nmo, nso, nalpha, nbeta,
     $     aeval, beval, amos, bmos, seval, sos, sospin)
      implicit none
#include "errquit.fh"
      integer nbf, nmo, nso, nalpha, nbeta, sospin(nso)
      double precision aeval(nmo), beval(nmo), seval(nso)
      double precision amos(nbf,nmo), bmos(nbf,nmo), sos(nbf,nso)
c
      integer i, j, cnt
c
      cnt = 0
c
      do i = 1, nbeta
         cnt = cnt + 1
         sospin(cnt)= -1
         seval(cnt) = beval(i)
         do j = 1, nbf
            sos(j,cnt) = bmos(j,i)
         end do
      end do
      do i = 1, nalpha
         cnt = cnt + 1
         sospin(cnt)= 1
         seval(cnt) = aeval(i)
         do j = 1, nbf
            sos(j,cnt) = amos(j,i)
         end do
      end do
      do i = nbeta+1,nmo
         cnt = cnt + 1
         sospin(cnt)= -1
         seval(cnt) = beval(i)
         do j = 1, nbf
            sos(j,cnt) = bmos(j,i)
         end do
      end do
      do i = nalpha+1,nmo
         cnt = cnt + 1
         sospin(cnt)= 1
         seval(cnt) = aeval(i)
         do j = 1, nbf
            sos(j,cnt) = amos(j,i)
         end do
      end do
c
      if (cnt .ne. nso) call errquit('munge: mismatch', cnt,
     &       UNKNOWN_ERR)
c
      end

      subroutine rjh_uhf_trans(nbf, nso, sospin, sos, ao, tmp, soint)
      implicit none
      integer nbf, nso
      integer sospin(nso)
      double precision sos(nbf,nso)
      double precision ao(nbf,nbf,nbf,nbf)
      double precision tmp(nso,nso,nso,nso)
      double precision soint(nso,nso,nso,nso)
c
      integer i, j, k, l        ! AO indices
      integer p, q, r, s        ! SO indices
c
c$$$      call dfill(nso**4, 0.0d0, soint, 1)
c$$$      do i = 1, nbf
c$$$         do j = 1, nbf
c$$$            do k = 1, nbf
c$$$               do l = 1, nbf
c$$$                  do s = 1, nso
c$$$                     do r = 1, nso
c$$$                        do q = 1, nso
c$$$                           do p = 1, nso
c$$$                              soint(p,q,r,s) = soint(p,q,r,s) + 
c$$$     $                             ao(i,j,k,l)*
c$$$     $                             sos(i,p)*sos(j,q)*sos(k,r)*sos(l,s)
c$$$                           end do
c$$$                        end do
c$$$                     end do
c$$$                  end do
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c$$$c
c$$$      goto 999
c
      call dfill(nso**4, 0.0d0, tmp, 1)
      do i = 1, nbf
         do j = 1, nbf
            do k = 1, nbf
               do l = 1, nbf
                  do p = 1, nso
                     tmp(p,k,j,i) = tmp(p,k,j,i) + ao(l,k,j,i)*sos(l,p)
                  end do
               end do
            end do
         end do
      end do
c
      call dfill(nso**4, 0.0d0, soint, 1)
      do i = 1, nbf
         do j = 1, nbf
            do k = 1, nbf
               do q = 1, nso
                  do p = 1, nso
                     soint(p,q,j,i)=soint(p,q,j,i)+tmp(p,k,j,i)*sos(k,q)
                  end do
               end do
            end do
         end do
      end do
c
      call dfill(nso**4, 0.0d0, tmp, 1)
      do i = 1, nbf
         do j = 1, nbf
            do r = 1, nso
               do q = 1, nso
                  do p = 1, nso
                     tmp(p,q,r,i)=tmp(p,q,r,i)+soint(p,q,j,i)*sos(j,r)
                  end do
               end do
            end do
         end do
      end do
c
      call dfill(nso**4, 0.0d0, soint, 1)
      do i = 1, nbf
         do s = 1, nso
            do r = 1, nso
               do q = 1, nso
                  do p = 1, nso
                     soint(p,q,r,s)=soint(p,q,r,s)+tmp(p,q,r,i)*sos(i,s)
                  end do
               end do
            end do
         end do
      end do
c
c     Now zero out spin-forbidden terms ... DIRAC ORDERING <pq|rs>
c
      do s = 1, nso
         do r = 1, nso
            do q = 1, nso
               do p = 1, nso
                  if ( sospin(p).ne.sospin(r) .or. 
     $                 sospin(q).ne.sospin(s) ) soint(p,q,r,s)=0.0d0
               end do
            end do
         end do
      end do
c
c$$$ 999  write(6,*)
c$$$      write(6,*) ' Spin-orbit integrals '
c$$$      write(6,*)
c$$$      do s = 1, nso
c$$$         do r = 1, nso
c$$$            do q = 1, nso
c$$$               do p = 1, nso
c$$$                  if ( abs(soint(p,q,r,s)) .gt. 1e-6 ) 
c$$$     $                 write(6,7) p,q,r,s,
c$$$     $                 sospin(p),sospin(q),sospin(r),sospin(s), 
c$$$     $                 soint(p,q,r,s)
c$$$ 7                format(1x,4i5,2x,4i5,2x,f12.6)
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c
      end
      subroutine rjh_uhf_mp2(nocc, nso, seval, soint)
      implicit none
c
      integer nocc, nso
      double precision seval(nso), soint(nso,nso,nso,nso)
c
      integer i, j, a, b
      double precision energy, numerator, denominator
c
      energy = 0.0d0
      do i = 1, nocc
         do j = 1, i-1
            do a = nocc+1, nso
               do b = nocc+1, a
                  numerator = (soint(a,b,i,j)-soint(b,a,i,j))**2
                  denominator = seval(i)+seval(j)-seval(a)-seval(b)
                  energy = energy + numerator/denominator
               end do
            end do
         end do
      end do
c
      write(6,1) energy
 1    format(//' MP2 energy from SO integrals ', f20.10)
c
      end
      subroutine rjh_so_asym(nso, soint)
      implicit none
      integer nso
      double precision soint(nso,nso,nso,nso)
      double precision tmp
      integer i, j, k, l
c
      do l = 1, nso
         do k= 1, l
            do j = 1, nso
               do i = 1, nso
                  tmp = soint(i,j,k,l)-soint(i,j,l,k)
                  soint(i,j,k,l) =  tmp
                  soint(i,j,l,k) = -tmp
               end do
            end do
         end do
      end do
c
c$$$      open(1,file='ASOINTS',form='formatted',status='unknown')
c$$$      write(1,*) nso
c$$$      do l = 1, nso
c$$$         do k= 1, nso
c$$$            do j = 1, nso
c$$$               do i = 1, nso
c$$$                  if (abs(soint(i,j,k,l)).gt. 1d-9) 
c$$$     $                 write(1,10) i, j, k, l, soint(i,j,k,l)
c$$$ 10               format(4i5,f20.10)
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c$$$      close(1,status='keep')
c$$$      write(6,*) ' Wrote antisymmetrized spin-orbit integrals'
c
      end
      subroutine rjh_uhf_mp2_from_asoint(nocc, nvirt, nso, 
     $     seval, asoint, t2)
      implicit none
c
      integer nocc, nso, nvirt
      double precision seval(nso), asoint(nso,nso,nso,nso)
      double precision t2(nvirt,nvirt,nocc,nocc)
c
      integer i, j, a, b
      double precision energy
c
      energy = 0.0d0
      do i = 1, nocc
         do j = 1, nocc
            do a = 1, nvirt
               do b = 1, nvirt
                  t2(a,b,i,j) = asoint(a+nocc,b+nocc,i,j)/
     $                 (seval(i)+seval(j)-seval(a+nocc)-seval(b+nocc))
                  energy = energy + 
     $                 t2(a,b,i,j)*asoint(a+nocc,b+nocc,i,j)
               end do
            end do
         end do
      end do
c
      energy = energy / 4.0d0
c
      write(6,1) energy
 1    format(//' MP2 energy from ASO integrals ', f20.10)
c
c$$$      open(1,file='T2',form='formatted',status='unknown')
c$$$      write(1,*) nocc, nvirt
c$$$      do i = 1, nocc
c$$$         do j = 1, nocc
c$$$            do a = 1, nvirt
c$$$               do b = 1, nvirt
c$$$                  if (abs(t2(a,b,i,j)).gt.1d-9) 
c$$$     $                 write(1,10) i, j, a, b, t2(a,b,i,j)
c$$$ 10               format(4i5,f20.10)
c$$$               end do
c$$$            end do
c$$$         end do
c$$$      end do
c$$$      close(1,status='keep')
c$$$      write(6,*) ' Wrote T2 amplitudes '
c$$$c
c$$$      open(1,file='EVALS',form='formatted',status='unknown')
c$$$      write(1,*) nso
c$$$      do i = 1, nso
c$$$         write(1,11) i, seval(i)
c$$$ 11      format(i5,f20.10)
c$$$      end do
c$$$      close(1,status='keep')
c$$$      write(6,*) ' Wrote eigenvalues '
c
      end
      subroutine rjh_uhf_cc_rhs(nocc,nvirt,nso,sospin,
     $     t1,t2,eval,g,r1,r2)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
c
      integer nocc, nvirt, nso
      double precision t1(nvirt,nocc) ! Input amplitudes
      double precision t2(nvirt,nvirt,nocc,nocc)
      double precision eval(nso) ! Eigenvalues of spin-orbitals
      double precision g(nso,nso,nso,nso) ! Antisym, spin-orb integrals
      double precision r1(nvirt,nocc) ! Output vectors
      double precision r2(nvirt,nvirt,nocc,nocc)
      integer sospin(nso)
c
c     Given the input amplitudes t1 and t2 form the RHS of the
c     spin-orbital CCSD equations as given by Bartlett, MEST II p1067.
c
      integer l_(14), k_(14), size(14)
      character*8 name
      integer i
c
c     Allocate memory for the intermediates and zero them out
c
      size(1) = nocc*nvirt
      size(2) = nvirt*nvirt
      size(3) = nocc*nocc
      size(4) = nocc*nocc
      size(5) = (nvirt**3)*nocc
      size(6) = (nvirt**3)*nocc
      size(7) = nvirt**4
      size(8) = (nocc**3)*nvirt
      size(9) = nocc**4
      size(10)= (nocc**2)*(nvirt**2)
      size(11)= (nocc**2)*(nvirt**2)
      size(12)= (nocc**2)*(nvirt**2)
      size(13)= (nvirt**3)*nocc
      size(14)= (nocc**3)*nvirt
c
      do i = 1, 14
         write(name,'(''temp'',i4)')
         if (.not. ma_push_get(mt_dbl, size(i), name, l_(i), k_(i)))
     $        call errquit(' rjh_uhf_cc_rhs: error allocating ', i,
     &       MA_ERR)
         call dfill(size(i), 0.0d0, dbl_mb(k_(i)), 1)
      end do
c
c     Now make the intermediates
c
      call rjh_uhf_cc_inter(nocc,nvirt,nso,t1,t2,eval,g,
     $     dbl_mb(k_( 1)),dbl_mb(k_( 2)),dbl_mb(k_( 3)),dbl_mb(k_( 4)),
     $     dbl_mb(k_( 5)),dbl_mb(k_( 6)),dbl_mb(k_( 7)),dbl_mb(k_( 8)),
     $     dbl_mb(k_( 9)),dbl_mb(k_(10)),dbl_mb(k_(11)),dbl_mb(k_(12)),
     $     dbl_mb(k_(13)),dbl_mb(k_(14)))
c
c     Form the product
c
      call dfill(nocc*nvirt, 0.0d0, r1, 1)
      call dfill((nocc*nvirt)**2, 0.0d0, r2, 1)
      call rjh_uhf_cc_product(nocc,nvirt,nso,t1,t2,eval,g,
     $     dbl_mb(k_( 1)),dbl_mb(k_( 2)),dbl_mb(k_( 3)),dbl_mb(k_( 4)),
     $     dbl_mb(k_( 5)),dbl_mb(k_( 6)),dbl_mb(k_( 7)),dbl_mb(k_( 8)),
     $     dbl_mb(k_( 9)),dbl_mb(k_(10)),dbl_mb(k_(11)),dbl_mb(k_(12)),
     $     dbl_mb(k_(13)),dbl_mb(k_(14)), r1, r2, sospin)
*      call rjh_uhf_cc_product_dumb(nocc,nvirt,nso,t1,t2,eval,g,
*     $     r1, r2, sospin)
c
      if (.not. ma_chop_stack(l_(1))) call errquit
     $     ('rjh_cc_prod: ma corrupt', 0,
     &       MA_ERR)
c
      end
      subroutine rjh_uhf_cc_inter(nocc,nvirt,nso,t1,t2,eval,g,
     $     x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13, x14)
      implicit none
#include "mafdecls.fh"
c
      integer nocc, nvirt, nso
      double precision t1(nvirt,nocc) ! Input amplitudes
      double precision t2(nvirt,nvirt,nocc,nocc)
      double precision eval(nso) ! Eigenvalues of spin-orbitals
      double precision g(nso,nso,nso,nso) ! Antisym, spin-orb integrals
c
c     In indexing the intermediates, the convention is upper indices
c     first, followed by lower indices, in order from left to right.
c
      double precision  x1(nocc,nvirt)
      double precision  x2(nvirt,nvirt)
      double precision  x3(nocc,nocc)
      double precision  x4(nocc,nocc)
      double precision  x5(nvirt,nvirt,nvirt,nocc)
      double precision  x6(nvirt,nvirt,nvirt,nocc)
      double precision  x7(nvirt,nvirt,nvirt,nvirt)
      double precision  x8(nocc,nocc,nocc,nvirt)
      double precision  x9(nocc,nocc,nocc,nocc)
      double precision x10(nocc,nvirt,nocc,nvirt)
      double precision x11(nocc,nvirt,nocc,nvirt)
      double precision x12(nocc,nvirt,nocc,nvirt)
      double precision x13(nvirt,nvirt,nocc,nvirt)
      double precision x14(nocc,nocc,nvirt,nocc)
c
      integer voff
      integer i, j, k, l, m, n, a, b, c, d, e, f
c
      voff = nocc
c
      do e = 1, nvirt
         do a = 1, nvirt
            do m = 1, nocc
               do i = 1, nocc
                  x1(i,a) = x1(i,a) + g(i,m,a+voff,e+voff)*t1(e,m)
               end do
            end do
         end do
      end do
c
      do b = 1, nvirt
         do a = 1, nvirt
            do e = 1, nvirt
               do m = 1, nocc
                  x2(a,b) = x2(a,b) + 
     $                 g(a+voff,m,b+voff,e+voff)*t1(e,m)
               end do
            end do
            do m = 1, nocc
               x2(a,b) = x2(a,b) - x1(m,b)*t1(a,m)
            end do
            do n = 1, nocc
               do m = 1, nocc
                  do e = 1, nvirt
                     x2(a,b) = x2(a,b) - 0.5d0*g(e+voff,b+voff,m,n)*
     $                    t2(e,a,m,n)
                  end do
               end do
            end do
         end do
      end do
c
      do j = 1, nocc
         do i = 1, nocc
            do m = 1, nocc
               do e = 1, nvirt
                  x3(j,i) = x3(j,i) + g(e+voff,j,m,i)*t1(e,m)
               end do
            end do
            do m = 1, nocc
               do f = 1, nvirt
                  do e = 1, nvirt
                     x3(j,i) = x3(j,i) + 0.5d0*g(e+voff,f+voff,m,i)*
     $                    t2(e,f,m,j)
                  end do
               end do
            end do
         end do
      end do
c
      do j = 1, nocc
         do i = 1, nocc
            x4(j,i) = x3(j,i)
            do e = 1, nvirt
               x4(j,i) = x4(j,i) + x1(i,e)*t1(e,j)
            end do
         end do
      end do
c
      do i = 1, nocc
         do b = 1, nvirt
            do c = 1, nvirt
               do a = 1, nvirt
                  x5(a,b,c,i) = g(a+voff,i,b+voff,c+voff)
                  do m = 1, nocc
                     x5(a,b,c,i) = x5(a,b,c,i) - 
     $                    0.5d0*g(m,i,b+voff,c+voff)*t1(a,m)
                  end do
               end do
            end do
         end do
      end do
c
      do i = 1, nocc
         do b = 1, nvirt
            do c = 1, nvirt
               do a = 1, nvirt
                  x6(a,b,c,i) = x5(a,b,c,i)
                  do m = 1, nocc
                     x6(a,b,c,i) = x6(a,b,c,i) - 
     $                    0.5d0*g(m,i,b+voff,c+voff)*t1(a,m)
                  end do
               end do
            end do
         end do
      end do
c
      do d= 1, nvirt
         do c = 1, nvirt
            do b = 1, nvirt
               do a = 1, nvirt
                  x7(a,b,c,d) = g(a+voff,b+voff,c+voff,d+voff)
               end do
            end do
            do m = 1, nocc
               do b = 1, nvirt
                  do a = 1, nvirt
                     x7(a,b,c,d) = x7(a,b,c,d) - 
     $                    (x5(a,c,d,m)*t1(b,m) - x5(b,c,d,m)*t1(a,m))
                  end do
               end do
            end do
         end do
      end do
c
      do a = 1, nvirt
         do j = 1, nocc
            do i = 1, nocc
               do k = 1, nocc
                  x8(k,i,j,a) = g(i,j,k,a+voff)
                  do e = 1, nvirt
                     x8(k,i,j,a) = x8(k,i,j,a) + 
     $                    0.5d0*g(e+voff,a+voff,i,j)*t1(e,k)
                  end do
               end do
            end do
         end do
      end do
c
      do j = 1, nocc
         do i = 1, nocc
            do l = 1, nocc
               do k = 1, nocc
                  x9(k,l,i,j) = g(k,l,i,j)
               end do
            end do
            do e = 1, nvirt
               do l = 1, nocc
                  do k = 1, nocc
                     x9(k,l,i,j) = x9(k,l,i,j) 
     $                    + x8(k,i,j,e)*t1(e,l) - x8(l,i,j,e)*t1(e,k)
                  end do
               end do
            end do
            do l = 1, nocc
               do k = 1, nocc
                  do f = 1, nvirt
                     do e = 1, nvirt
                        x9(k,l,i,j) = x9(k,l,i,j) + 
     $                       g(e+voff,f+voff,i,j)*t2(e,f,k,l)*0.5d0
                     end do
                  end do
               end do
            end do
         end do
      end do
c
      do b = 1, nvirt
         do i = 1, nocc
            do a = 1, nvirt
               do j = 1, nocc
                  x10(j,a,i,b) = g(i,a+voff,j,b+voff)
                  do m = 1, nocc
                     x10(j,a,i,b) = x10(j,a,i,b) - 
     $                    g(i,m,j,b+voff)*t1(a,m)
                  end do
                  do e = 1, nvirt
                     x10(j,a,i,b) = x10(j,a,i,b) + x5(a,b,e,i)*t1(e,j)
                  end do
               end do
            end do
         end do
      end do
c
      do b = 1, nvirt
         do i = 1, nocc
            do a = 1, nvirt
               do j = 1, nocc
                  x11(j,a,i,b) = x10(j,a,i,b)
                  do m = 1, nocc
                     x11(j,a,i,b) = x11(j,a,i,b) - 
     $                    g(m,i,b+voff,j)*t1(a,m)
                  end do
               end do
            end do
            do e = 1, nvirt
               do a = 1, nvirt
                  do j = 1, nocc
                     x11(j,a,i,b) = x11(j,a,i,b) + x6(a,b,e,i)*t1(e,j)
                  end do
               end do
            end do
         end do
      end do
c
      do b = 1, nvirt
         do i = 1, nocc
            do a = 1, nvirt
               do j = 1, nocc
                  x12(j,a,i,b) = x11(j,a,i,b)
               end do
            end do
            do m = 1, nocc
               do j = 1, nocc
                  do a = 1, nvirt
                     do e = 1, nvirt
                        x12(j,a,i,b) = x12(j,a,i,b) -
     $                       g(e+voff,b+voff,i,m)*t2(e,a,j,m)*0.5d0
                     end do
                  end do
               end do
            end do
         end do
      end do
c
      do c = 1, nvirt
         do i = 1, nocc
            do b = 1, nvirt
               do a = 1, nvirt
                  x13(a,b,i,c) = g(a+voff,b+voff,c+voff,i)
                  do e = 1, nvirt
                     x13(a,b,i,c) = x13(a,b,i,c) + 
     $                    0.5d0*g(e+voff,c+voff,b+voff,a+voff)*t1(e,i)
                  end do
               end do
            end do
            do m = 1, nocc
               do b = 1, nvirt
                  do a = 1, nvirt
                     x13(a,b,i,c) = x13(a,b,i,c) - 
     $                    (x10(i,a,m,c)*t1(b,m)-x10(i,b,m,c)*t1(a,m))
                  end do
               end do
            end do
         end do
      end do
c
      do i = 1, nocc
         do a = 1, nvirt
            do m = 1, nocc
               do k = 1, nocc
                  do j= 1, nocc
                     x14(j,k,a,i) = x14(j,k,a,i) + 
     $                    g(j,k,i,m)*t1(a,m)
                  end do
               end do
            end do
         end do
      end do
c
      end
      subroutine rjh_uhf_cc_product(nocc,nvirt,nso,t1,t2,eval,g,
     $     x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13, x14,
     $     r1, r2, sospin)
      implicit none
#include "mafdecls.fh"
c
      integer nocc, nvirt, nso
      double precision t1(nvirt,nocc) ! Input amplitudes
      double precision t2(nvirt,nvirt,nocc,nocc)
      double precision eval(nso) ! Eigenvalues of spin-orbitals
      double precision g(nso,nso,nso,nso) ! Antisym, spin-orb integrals
c
c     Final step in computing the CC RHS
c
c     In indexing the intermediates, the convention is upper indices
c     first, followed by lower indices, in order from left to right.
c
      double precision  x1(nocc,nvirt)
      double precision  x2(nvirt,nvirt)
      double precision  x3(nocc,nocc)
      double precision  x4(nocc,nocc)
      double precision  x5(nvirt,nvirt,nvirt,nocc)
      double precision  x6(nvirt,nvirt,nvirt,nocc)
      double precision  x7(nvirt,nvirt,nvirt,nvirt)
      double precision  x8(nocc,nocc,nocc,nvirt)
      double precision  x9(nocc,nocc,nocc,nocc)
      double precision x10(nocc,nvirt,nocc,nvirt)
      double precision x11(nocc,nvirt,nocc,nvirt)
      double precision x12(nocc,nvirt,nocc,nvirt)
      double precision x13(nvirt,nvirt,nocc,nvirt)
      double precision x14(nocc,nocc,nvirt,nocc)
      double precision  r1(nvirt,nocc)
      double precision  r2(nvirt,nvirt,nocc,nocc)
c
      integer sospin(nso)
c
      integer voff
      integer i, j, m, n, a, b, e, f
c
      voff = nocc
c
      do i = 1, nocc
         do a = 1, nvirt
            do e = 1, nvirt
               r1(a,i) = r1(a,i) + x2(a,e)*t1(e,i)
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,2)
            do m = 1, nocc
               r1(a,i) = r1(a,i) - x3(i,m)*t1(a,m)
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,21)
            do m = 1, nocc
               do e = 1, nvirt
                  r1(a,i) = r1(a,i) + g(e+voff,i,m,a+voff)*t1(e,m)
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,3)
            do m = 1, nocc
               do e = 1, nvirt
                  r1(a,i) = r1(a,i) + x1(m,e)*t2(e,a,m,i)
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,33)
            do m = 1, nocc
               do f = 1, nvirt
                  do e = 1, nvirt
                     r1(a,i) = r1(a,i) +
     $                    0.5d0*g(e+voff,f+voff,m,a+voff)*t2(e,f,m,i)
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,4)
            do n = 1, nocc
               do m = 1, nocc
                  do e = 1, nvirt
                     r1(a,i) = r1(a,i) - 
     $                    0.5d0*g(e+voff,i,m,n)*t2(e,a,m,n)
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,5)
         end do
      end do
c
      do j = 1, nocc
         do i = 1, nocc
            do b = 1, nvirt
               do a = 1, nvirt
                  r2(a,b,i,j) = g(a+voff,b+voff,i,j)
                  do e = 1, nvirt
                     r2(a,b,i,j) = r2(a,b,i,j) + 
     $                    x2(b,e)*t2(a,e,i,j) - x2(a,e)*t2(b,e,i,j)
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,6)
            do m = 1, nocc
               do b = 1, nvirt
                  do a = 1, nvirt
                     r2(a,b,i,j) = r2(a,b,i,j) -
     $                    (x4(j,m)*t2(a,b,i,m) - x4(i,m)*t2(a,b,j,m))
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,7)
            do f = 1, nvirt
               do e = 1, nvirt
                  do b = 1, nvirt
                     do a = 1, nvirt
                        r2(a,b,i,j) = r2(a,b,i,j) + 
     $                       0.5d0*x7(a,b,e,f)*t2(e,f,i,j)
                     end do
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,8)
            do n = 1, nocc
               do m = 1, nocc
                  do b = 1, nvirt
                     do a = 1, nvirt
                        r2(a,b,i,j) = r2(a,b,i,j) +
     $                       0.5d0*x9(i,j,m,n)*t2(a,b,m,n)
                     end do
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,9)
            do e = 1, nvirt
               do m = 1, nocc
                  do b = 1, nvirt
                     do a = 1, nvirt
                        r2(a,b,i,j) = r2(a,b,i,j)
     $                       - x12(i,b,m,e)*t2(a,e,m,j)
     $                       + x12(j,b,m,e)*t2(a,e,m,i)
     $                       + x12(i,a,m,e)*t2(b,e,m,j)
     $                       - x12(j,a,m,e)*t2(b,e,m,i)
                     end do
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,10)
            do e = 1, nvirt
               do b = 1, nvirt
                  do a = 1, nvirt
                     r2(a,b,i,j) = r2(a,b,i,j)
     $                    + x13(a,b,j,e)*t1(e,i) - x13(a,b,i,e)*t1(e,j)
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,11)
            do m = 1, nocc
               do b = 1, nvirt
                  do a = 1, nvirt
                     r2(a,b,i,j) = r2(a,b,i,j)
     $                    -(x14(i,j,b,m)*t1(a,m) + x14(i,j,a,m)*t1(b,m))
                  end do
               end do
            end do
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,12)
         end do
      end do
c
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,1)

c
      end
      subroutine rjh_uhf_cc_energy(nocc,nvirt,nso,t1,t2,eval,g)
      implicit none
#include "mafdecls.fh"
c
      integer nocc, nvirt, nso
      double precision t1(nvirt,nocc) ! Input amplitudes
      double precision t2(nvirt,nvirt,nocc,nocc)
      double precision eval(nso) ! Eigenvalues of spin-orbitals
      double precision g(nso,nso,nso,nso) ! Antisym, spin-orb integrals
c
      double precision energy
      integer i, j, a, b
c
      energy = 0.0d0
      do j = 1, nocc
         do i = 1, nocc
            do b = 1, nvirt
               do a = 1, nvirt
                  energy = energy + g(a+nocc,b+nocc,i,j)*
     $                 (t2(a,b,i,j) + t1(a,i)*t1(b,j) - t1(b,i)*t1(a,j))
                  if (abs(t2(a,b,i,j)).gt.1e-6 .and. 
     $                 abs(g(a+nocc,b+nocc,i,j)).lt.1e-6) then
                     write(6,*) ' ?? ', i, j, a, b, 
     $                    g(a+nocc,b+nocc,i,j), t2(a,b,i,j)
                  end if
               end do
            end do
         end do
      end do
      energy = energy * 0.25d0
c
      write(6,1) energy
 1    format(' CCSD energy = ', f20.10)
c
      end
      subroutine rjh_uhf_cc_update(nocc,nvirt,nso,t1,t2,eval,r1,r2)
      implicit none
#include "mafdecls.fh"
c
      integer nocc, nvirt, nso
      double precision t1(nvirt,nocc) ! Input amplitudes
      double precision t2(nvirt,nvirt,nocc,nocc)
      double precision eval(nso) ! Eigenvalues of spin-orbitals
      double precision r1(nvirt,nocc) ! Input amplitudes
      double precision r2(nvirt,nvirt,nocc,nocc)
c
      double precision denom, t1norm, t2norm, damp
      integer i, j, a, b
c
      damp = 0.0d0
c
      t2norm = 0.0d0
      do j = 1, nocc
         do i = 1, nocc
            do b = 1, nvirt
               do a = 1, nvirt
                  denom = eval(i) + eval(j) - 
     $                 eval(a+nocc) - eval(b+nocc)
                  r2(a,b,i,j) = r2(a,b,i,j) / denom
                  t2norm = t2norm + (r2(a,b,i,j)-t2(a,b,i,j))**2
                  t2(a,b,i,j) = damp*t2(a,b,i,j) + 
     $                 (1.0d0-damp)*r2(a,b,i,j)
               end do
            end do
         end do
      end do
c
      t1norm = 0.0d0
      do i = 1, nocc
         do a = 1, nvirt
            denom = eval(i) - eval(a+nocc)
            r1(a,i) = r1(a,i) / denom
            t1norm = t1norm + (r1(a,i)-t1(a,i))**2
            t1(a,i) = damp*t1(a,i) + (1.0d0-damp)*r1(a,i)
*            t1(a,i) = 0.0d0
         end do
      end do
c
      write(6,1) sqrt(t1norm), sqrt(t2norm)
 1    format('  Residuals:  t1 ',1p,d9.1,'   t2 ',d9.1)
c
      end
      subroutine rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,code)
      implicit none
#include "errquit.fh"
      integer nocc, nvirt, nso, code, sospin(nso)
      double precision r1(nvirt,nocc)
      double precision r2(nvirt,nvirt,nocc,nocc)
      integer i, j, a, b
c
      do i = 1, nocc
         do a = 1, nvirt
            if (abs(r1(a,i)).gt.1d-10 .and. 
     $           sospin(i).ne.sospin(a+nocc)) then
               write(6,*) ' Spin forbidden ', i, a, r1(a,i), 
     $              sospin(i), sospin(nocc+a)
               call errquit(' bad t1 ', code, UNKNOWN_ERR)
            end if
         end do
      end do
      do j = 1, nocc
         do i = 1, nocc
            do b = 1, nvirt
               do a = 1, nvirt
                  if ( abs(r2(a,b,i,j)).gt.1d-10  .and.
     $                 (sospin(i)*sospin(j)).ne.
     $                 (sospin(a+nocc)*sospin(b+nocc))) 
     $                 then
                     write(6,*) ' Spin forbidden ', i, j, a, b, 
     $                    r2(a,b,i,j)
                     call errquit(' bad t2 ', code, UNKNOWN_ERR)
                  end if
                  if ((i.eq.j .or. a.eq.b) .and. 
     $                 abs(r2(a,b,i,j)).gt.1d-10) then
                     write(6,*) ' Non-zero diagonal t2 ',
     $                    i, j, a, b, r2(a,b,i,j)
                     call errquit(' bad t2 ', code, UNKNOWN_ERR)
                  end if
               end do
            end do
         end do
      end do
c
      end
      subroutine rjh_t1_t2_print(nocc,nvirt,nso,r1,r2)
      implicit none
      integer nocc, nvirt, nso
      double precision r1(nvirt,nocc)
      double precision r2(nvirt,nvirt,nocc,nocc)
      integer i, j, a, b
      do i = 1, nocc
         do j = 1, nocc
            do b = 1, nvirt
               do a = 1, nvirt
                  if(abs(r2(a,b,i,j)).gt.1e-6) then
                     write(6,1) a, b, i, j, r2(a, b, i, j)
 1                   format(4i5,f12.6)
                  end if
               end do
            end do
         end do
      end do
      do i = 1, nocc
         do a = 1, nvirt
            if(abs(r1(a,i)).gt.1e-6) then
               write(6,2) a, i, r1(a,i)
 2             format(2i5,f12.6)
            end if
         end do
      end do
c
      end
      subroutine rjh_uhf_cc_product_dumb(nocc,nvirt,nso,t1,t2,eval,g,
     $     r1, r2, sospin)
      implicit none
#include "mafdecls.fh"
c
      integer nocc, nvirt, nso
      double precision t1(nvirt,nocc) ! Input amplitudes
      double precision t2(nvirt,nvirt,nocc,nocc)
      double precision r1(nvirt,nocc) ! Input amplitudes
      double precision r2(nvirt,nvirt,nocc,nocc)
      double precision eval(nso) ! Eigenvalues of spin-orbitals
      double precision g(nso,nso,nso,nso) ! Antisym, spin-orb integrals
      integer sospin(nso)
c
c     Final step in computing the CC RHS ... DUMB version CCD only
c
      integer i, j, k, l, a, b, c, d, voff
c
      voff = nocc
c
      do j = 1, nocc
         do i = 1, nocc
            do b = 1, nvirt
               do a = 1, nvirt
                  r2(a,b,i,j) = g(a+voff,b+voff,i,j)
                  do d = 1, nvirt
                     do c = 1, nvirt
                        r2(a,b,i,j) = r2(a,b,i,j) + 0.5d0*
     $                       g(c+voff,d+voff,a+voff,b+voff)*
     $                       t2(c,d,i,j)
                     enddo
                  enddo
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,81)
                  do l = 1, nocc
                     do k = 1, nocc
                        r2(a,b,i,j) = r2(a,b,i,j) + 0.5d0*
     $                       g(k,l,i,j)*t2(a,b,k,l)
                     enddo
                  enddo
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,82)
                  do k = 1, nocc
                     do c = 1, nvirt
                        r2(a,b,i,j) = r2(a,b,i,j)
     $                       + g(c+voff,j,a+voff,k)*t2(b,c,i,k) 
     $                       - g(c+voff,j,b+voff,k)*t2(a,c,i,k) 
     $                       - g(c+voff,i,a+voff,k)*t2(b,c,j,k) 
     $                       + g(c+voff,i,b+voff,k)*t2(a,c,j,k) 
                     enddo
                  enddo
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,83)
                  do k = 1, nocc
                     do l = 1, nocc
                        do d = 1, nvirt
                           do c = 1, nvirt
                              r2(a,b,i,j) = r2(a,b,i,j) + 
     $                             g(c+voff,d+voff,k,l) * (
     $                             + t2(a,c,i,k)*t2(d,b,l,j)
     $                             - t2(b,c,i,k)*t2(d,a,l,j)

     $                             - t2(c,d,k,i)*t2(a,b,l,j)*0.5d0
     $                             + t2(c,d,k,j)*t2(a,b,l,i)*0.5d0

     $                             - t2(c,a,k,l)*t2(d,b,i,j)*0.5d0
     $                             + t2(c,b,k,l)*t2(d,a,i,j)*0.5d0

     $                             + t2(c,d,i,j)*t2(a,b,k,l)*0.25d0)
                           enddo
                        enddo
                     enddo
                  enddo
      call rjh_t1_t2_spin_check(nocc,nvirt,nso,sospin,r1,r2,84)
               enddo
            enddo
         enddo
      enddo
c
      end

*
* $Id: wvfnc_expand_cell.F 23384 2013-01-07 02:25:22Z bylaska $
*

*     *******************************************
*     *						*
*     *	 	   wvfnc_expand_cell		*
*     *						*
*     *******************************************

      logical function wvfnc_expand_cell(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"

      logical value
      integer version
 
      integer ierr

      integer ne(2),ispin,dne(2)

      character*50 new_wavefunction_filename
      character*50 old_wavefunction_filename
      character*255 full_filename,full_filename2


      integer ngrid(3)
      integer dngrid(3)
      integer cell_expand(3),i,j,k
      integer cfull(2),dcfull(2)
      integer nfft3d,n2ft3d
      integer dnfft3d,dn2ft3d
      integer ms,n,l,occupation


      double precision unita(3,3)

      value = .false.
      version = 3

*     **** get wavefunction information ****
      value = rtdb_cget(rtdb,'xpndr:old_wavefunction_filename',
     >                  1,old_wavefunction_filename)
      value = rtdb_cget(rtdb,'xpndr:new_wavefunction_filename',
     >                  1,new_wavefunction_filename)

      value = rtdb_get(rtdb,'nwpw:cell_expand',mt_int,3,cell_expand)

 
      call util_file_name_noprefix(old_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin,1)
      call iread(5,ne,2)
      call iread(5,occupation,1)
 
      dngrid(1) = cell_expand(1)*ngrid(1)
      dngrid(2) = cell_expand(2)*ngrid(2)
      dngrid(3) = cell_expand(3)*ngrid(3)
      dne(1) = cell_expand(1)*cell_expand(2)*cell_expand(3)*ne(1)
      dne(2) = cell_expand(1)*cell_expand(2)*cell_expand(3)*ne(2)
      unita(1,1) = unita(1,1)*cell_expand(1)
      unita(2,1) = unita(2,1)*cell_expand(1)
      unita(3,1) = unita(3,1)*cell_expand(1)
      unita(1,2) = unita(1,2)*cell_expand(2)
      unita(2,2) = unita(2,2)*cell_expand(2)
      unita(3,2) = unita(3,2)*cell_expand(2)
      unita(1,3) = unita(1,3)*cell_expand(3)
      unita(2,3) = unita(2,3)*cell_expand(3)
      unita(3,3) = unita(3,3)*cell_expand(3)
      call util_file_name('wvfnc_expander',
     >                    .true.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      call openfile(6,full_filename,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,dngrid,3)
      call dwrite(6,unita,9)
      call iwrite(6,ispin,1)
      call iwrite(6,dne,2)
      call iwrite(6,occupation,1)

       
       nfft3d = ( ngrid(1)/2+1)* ngrid(2)* ngrid(3)
      dnfft3d = (dngrid(1)/2+1)*dngrid(2)*dngrid(3)
       n2ft3d = 2* nfft3d
      dn2ft3d = 2*dnfft3d

      write(*,109) old_wavefunction_filename
      write(*,110) new_wavefunction_filename
      write(*,111) ngrid(1), ngrid(2), ngrid(3),
     >            dngrid(1),dngrid(2),dngrid(3)
  109 format(' old_filename: ',A)
  110 format(' new_filename: ',A)
  111 format(' converting  : ',I3,'x',I3,'x',I3,' --> ', 
     >                     I3,'x',I3,'x',I3)
 
*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull(2),cfull(1))

      value = MA_alloc_get(mt_dcpl,dnfft3d,
     >                     'dcfull',dcfull(2),dcfull(1))

      do ms=1,ispin
        do n=1,ne(ms)
          call dread(5,dcpl_mb(cfull(1)),n2ft3d)

          write(*,'(A,I5,A,I2)') "converting .... psi:", n," spin:",ms
          do k=0,cell_expand(3)-1
          do j=0,cell_expand(2)-1
          do i=0,cell_expand(1)-1
          write(*,*) "           ....    :", i,j,k
          call wvfnc_expand_cell_convert(i,j,k,
     >                               ngrid,dcpl_mb(cfull(1)),
     >                               dngrid,dcpl_mb(dcfull(1)))

          call dwrite(6,dcpl_mb(dcfull(1)),dn2ft3d)
          end do
          end do
          end do

        end do
      end do
      call closefile(5)
      call closefile(6)

c     *** copy wvfnc_expander to new_wavefunction_filename ****
      call util_file_name_noprefix(new_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)
      call util_file_copy(full_filename,full_filename2)
      call util_file_unlink(full_filename)
      IERR=0
      GO TO 9999
 
 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999
 
 9999 value = MA_free_heap(cfull(2))
      value = MA_free_heap(dcfull(2))
      !IF(IERR.EQ.0) THEN
      !  WRITE(6,*) ' JOB HAS BEEN COMPLETED.  CODE=',IERR
      !ELSE
      !  WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
      !  value = .false.
      !ENDIF
      !call nwpw_message(4)
      
      wvfnc_expand_cell = value
      return 
      end
 

*     ***************************************************
*     *							*
*     *	 	   wvfnc_expand_cell_convert   		*
*     *							*
*     ***************************************************

      subroutine wvfnc_expand_cell_convert(ishift,jshift,kshift,
     >                              ngrid,psi1,dngrid,psi2)
      implicit none
      integer ishift,jshift,kshift
      integer ngrid(3)
      complex*16 psi1(*)
      integer dngrid(3)
      complex*16 psi2(*)

*     **** local variables ****
      integer nfft3d,dnfft3d,n2ft3d,dn2ft3d
      integer inc2,inc3,dinc2,dinc3
      integer nxh,nyh,nzh
      integer i,j,k
      integer i1,j1,k1
      integer i2,j2,k2
      integer fi,fj,fk
      integer indx,dindx
      real*8  pi,gi,gj,gk
      complex*16 bw1,bw2,bw3
      complex*16 cw1,cw2,cw3
       
       nfft3d = ( ngrid(1)/2+1)* ngrid(2)* ngrid(3)
      dnfft3d = (dngrid(1)/2+1)*dngrid(2)*dngrid(3)
       n2ft3d = 2* nfft3d
      dn2ft3d = 2*dnfft3d
       inc2 = ( ngrid(1)/2+1)
      dinc2 = (dngrid(1)/2+1)
       inc3 = ( ngrid(1)/2+1)* ngrid(2)
      dinc3 = (dngrid(1)/2+1)*dngrid(2)

      nxh = ngrid(1)/2
      nyh = ngrid(2)/2
      nzh = ngrid(3)/2
      fi  = dngrid(1)/ngrid(1)
      fj  = dngrid(2)/ngrid(2)
      fk  = dngrid(3)/ngrid(3)
      gi  = 1.0d0/dble(fi)
      gj  = 1.0d0/dble(fj)
      gk  = 1.0d0/dble(fk)

      pi = 4.0d0*datan(1.0d0)
      cw1=dcmplx(dcos(0.5d0*ishift*pi),-dsin(0.5d0*ishift*pi))
      cw2=dcmplx(dcos(0.5d0*jshift*pi),-dsin(0.5d0*jshift*pi))
      cw3=dcmplx(dcos(0.5d0*kshift*pi),-dsin(0.5d0*kshift*pi))
c     write(*,*) "cws:",cw1,cw2,cw3
      cw1=dcmplx(dcos(gi*pi*ishift),-dsin(gi*pi*ishift))
      cw2=dcmplx(dcos(gj*pi*jshift),-dsin(gj*pi*jshift))
      cw3=dcmplx(dcos(gk*pi*kshift),-dsin(gk*pi*kshift))

      call dcopy(dn2ft3d,0.0d0,0,psi2,1)
      do k=-nzh+1,nzh-1
      do j=-nyh+1,nyh-1
      do i=0,nxh-1

         i1 = i
         j1 = j
         k1 = k
         !if (i1.ge.0) i2 = fi*i1 + ishift
         !if (i1.lt.0) i2 = fi*i1 - ishift
         !if (j1.ge.0) j2 = fj*j1 + jshift
         !if (j1.lt.0) j2 = fj*j1 - jshift
         !if (k1.ge.0) k2 = fk*k1 + kshift
         !if (k1.lt.0) k2 = fk*k1 - kshift
         i2 = fi*i1 + ishift
         j2 = fj*j1 + jshift
         k2 = fk*k1 + kshift
         



         if (i1 .lt. 0) i1 = i1 + ngrid(1)
         if (j1 .lt. 0) j1 = j1 + ngrid(2)
         if (k1 .lt. 0) k1 = k1 + ngrid(3)

         if (i2 .lt. 0) i2 = i2 + dngrid(1)
         if (j2 .lt. 0) j2 = j2 + dngrid(2)
         if (k2 .lt. 0) k2 = k2 + dngrid(3)

         indx   = (k1)*inc3  +(j1)*inc2  + i1+1
         dindx  = (k2)*dinc3 +(j2)*dinc2 + i2+1

       
         psi2(dindx) = psi1(indx)*cw1*cw2*cw3


c        i1 = i
c        j1 = -j
c        k1 = -k
c        i2 = fi*i1
c        j2 = fj*j1
c        k2 = fk*k1

c        if (i1 .lt. 0) i1 = i1 + ngrid(1)
c        if (j1 .lt. 0) j1 = j1 + ngrid(2)
c        if (k1 .lt. 0) k1 = k1 + ngrid(3)

c        if (i2 .lt. 0) i2 = i2 + dngrid(1)
c        if (j2 .lt. 0) j2 = j2 + dngrid(2)
c        if (k2 .lt. 0) k2 = k2 + dngrid(3)

c        indx   = (k1)*inc3  +(j1)*inc2  + i1+1
c        dindx  = (k2)*dinc3 +(j2)*dinc2 + i2+1

c        psi2(dindx) = psi1(indx)


      end do
      end do
      end do

      return 
      end
 

*     *********************************************
*     *                                           *
*     *          nwpw_kbpp_calc_Gmax              *
*     *                                           *
*     *********************************************

      double precision function nwpw_kbpp_calc_Gmax(nfft1,nfft2,nfft3,
     >                                              unita)
      implicit none
      integer nfft1,nfft2,nfft3
      double precision unita(3,3)

*     *** local variables ****
      integer k1,k2,k3
      double precision qmax,gx,gy,gz
      double precision unitg(3,3)

      call nwpw_kbpp_get_unitg(unita,unitg)
      k1 = nfft1/2
      k2 = nfft2/2
      k3 = nfft3/2
      gx = k1*unitg(1,1) + k2*unitg(1,2) +k3*unitg(1,3)
      gy = k1*unitg(2,1) + k2*unitg(2,2) +k3*unitg(2,3)
      gz = k1*unitg(3,1) + k2*unitg(3,2) +k3*unitg(3,3)

      qmax = dsqrt(gx**2 + gy**2 + gz**2)

*     *** make Gmax = Gmax + 2.0d0 ****
      qmax = qmax + 2.0d0

      nwpw_kbpp_calc_Gmax = qmax
      return
      end


*     *********************************************
*     *                                           *
*     *            nwpw_kbpp_calc_dGmin           *
*     *                                           *
*     *********************************************

      double precision function nwpw_kbpp_calc_dGmin(unita)
      implicit none
      double precision unita(3,3)

*     *** local variables ****
      double precision gx,gy,gz,q,dqmin
      double precision unitg(3,3)

      call nwpw_kbpp_get_unitg(unita,unitg)

      gx = unitg(1,1)
      gy = unitg(2,1)
      gz = unitg(3,1)
      q = dsqrt(gx**2 + gy**2 + gz**2)
      dqmin = q

      gx = unitg(1,2)
      gy = unitg(2,2)
      gz = unitg(3,2)
      q = dsqrt(gx**2 + gy**2 + gz**2)
      dqmin = q

      gx = unitg(1,3)
      gy = unitg(2,3)
      gz = unitg(3,3)
      q = dsqrt(gx**2 + gy**2 + gz**2)
      dqmin = q

*     *** make fine dqmin ****
      dqmin = 0.01d0*dqmin

      nwpw_kbpp_calc_dGmin = dqmin
      return
      end


*     *********************************************
*     *                                           *
*     *             nwpw_kbpp_calc_nray           *
*     *                                           *
*     *********************************************
      integer function nwpw_kbpp_calc_nray(nfft1,nfft2,nfft3,unita)
      implicit none
      integer nfft1,nfft2,nfft3
      double precision unita(3,3)

*     ***** local variables ****
      double precision dG,Gmax
      integer nray

*     ***** external functions ****
      real*8   nwpw_kbpp_calc_dGmin,nwpw_kbpp_calc_Gmax
      external nwpw_kbpp_calc_dGmin,nwpw_kbpp_calc_Gmax

      dG   = nwpw_kbpp_calc_dGmin(unita)
      Gmax = nwpw_kbpp_calc_Gmax(nfft1,nfft2,nfft3,unita)
      nray = Gmax/dG + 1.0d0
      if (nray.lt.10) nray = 10

      nwpw_kbpp_calc_nray = nray
      return
      end


*     *********************************************
*     *                                           *
*     *           nwpw_kbpp_generate_G_ray        *
*     *                                           *
*     *********************************************
      subroutine nwpw_kbpp_generate_G_ray(nfft1,nfft2,nfft3,unita,G_ray)
      implicit none
      integer nfft1,nfft2,nfft3 
      double precision unita(3,3)
      double precision G_ray(*)

*     **** local variables ***
      integer i,nray
      double precision dG
*     ***** external functions ****
      real*8   nwpw_kbpp_calc_dGmin,nwpw_kbpp_calc_Gmax
      integer  nwpw_kbpp_calc_nray
      external nwpw_kbpp_calc_dGmin,nwpw_kbpp_calc_Gmax
      external nwpw_kbpp_calc_nray

      dG   = nwpw_kbpp_calc_dGmin(unita)
      nray = nwpw_kbpp_calc_nray(nfft1,nfft2,nfft3,unita)
      do i=1,nray
       G_ray(i) = dG*dble(i-1)
      end do
      return
      end


*     *********************************************
*     *                                           *
*     *             nwpw_kbpp_filter_ray          *
*     *                                           *
*     *********************************************
      subroutine nwpw_kbpp_filter_ray(nray,G_ray,ecut,V_ray)
      implicit none
      integer nray
      double precision G_ray(*)
      double precision ecut
      double precision V_ray(*)

*     **** local variables ****
      !real*8 ncut,eps
      !parameter (eps=1.0d-12,ncut=15.0d0)
      integer ncut
      parameter (ncut=15)
      integer i
      double precision g,qmax,fac

c      qmax = dsqrt(ecut+ecut)
c     >      /(-log(1.0d0-(1.0d0-eps)**(1.0d0/ncut)))**(1.0d0/ncut)
      qmax = dsqrt(ecut+ecut)
      do i=1,nray
         g = G_ray(i)
         if (g.gt.(qmax-0.2d0)) then
            fac = 1.0d0 - (1.0d0-exp(-(g/qmax)**ncut))**ncut
            V_ray(i) = V_ray(i)*fac
         end if
      end do
      return
      end


      subroutine nwpw_kbpp_get_unitg(unita,unitg)
      implicit none

******************************************************************************
*                                                                            *
*     This routine computes primitive vectors                                *
*               in reciporocal space and the volume of primitive cell.       *
*                                                                            *
*     Inputs:                                                                *
*             unita  --- primitive vectors in coordination space             *
*                                                                            *
*     Outputs:                                                               *
*             unitg  --- primitive vectors in reciprocal space               *
*                                                                            *
*     Library:  dscal from BLAS                                              *
*                                                                            *
*     Last modification:  3/30/99  by Eric Bylaska                           *
*                                                                            *
******************************************************************************


*     ------------------
*     argument variables
*     ------------------
      double precision unita(3,3), unitg(3,3)

*     ---------------
*     local variables
*     ---------------
      double precision volume
      double precision twopi

      twopi = 8.0d0*datan(1.0d0)

*     -----------------------------------------
*     primitive vectors in the reciprocal space 
*     -----------------------------------------
      unitg(1,1) = unita(2,2)*unita(3,3) - unita(3,2)*unita(2,3)
      unitg(2,1) = unita(3,2)*unita(1,3) - unita(1,2)*unita(3,3)
      unitg(3,1) = unita(1,2)*unita(2,3) - unita(2,2)*unita(1,3)
      unitg(1,2) = unita(2,3)*unita(3,1) - unita(3,3)*unita(2,1)
      unitg(2,2) = unita(3,3)*unita(1,1) - unita(1,3)*unita(3,1)
      unitg(3,2) = unita(1,3)*unita(2,1) - unita(2,3)*unita(1,1)
      unitg(1,3) = unita(2,1)*unita(3,2) - unita(3,1)*unita(2,2)
      unitg(2,3) = unita(3,1)*unita(1,2) - unita(1,1)*unita(3,2)
      unitg(3,3) = unita(1,1)*unita(2,2) - unita(2,1)*unita(1,2)
      volume = unita(1,1)*unitg(1,1)
     >       + unita(2,1)*unitg(2,1)
     >       + unita(3,1)*unitg(3,1)
      call dscal(9,twopi/volume,unitg,1)

*     ---------------------
*     volume of a unit cell
*     ---------------------
      volume=dabs(volume)

      return
      end





c $Id: nwpw_kbpp_ray.F 25745 2014-06-08 07:46:01Z d3y133 $

*
* $Id: Parallel-tcgmsg.F 25953 2014-07-30 10:46:17Z bylaska $
*

* Parallel.f
* Author - Eric Bylaska
*
*   These routines are to be used to keep track of the parallel message
* passing variables, as well as iniitialize and deinitialize the
* message passing routines.
*


*     *************************************
*     *                                   *
*     *        Parallel_Init              *
*     *                                   *
*     *************************************

      subroutine Parallel_Init()
      implicit none

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"

#include "tcgmsg.fh"
#include "global.fh"

c      include 'mpif.h'
c      integer mpierr

*     **** local variables ****
      integer i

      np     = nnodes()
      taskid = nodeid()


*     **** set up 3d processor grid = np x 1 x 1****
      if (.not.MA_alloc_get(mt_int,np,'procNd',procNd(2),procNd(1)))
     >  call errquit('Parallel_init:out of heap memory',0, MA_ERR)

      np_i = np
      np_j = 1
      np_k = 1
      do i=0,np-1
        int_mb(procNd(1)+i) = i
      end do
      taskid_i = taskid
      taskid_j = 0
      taskid_k = 0
      comm_i   = ga_pgroup_get_world()
      comm_j   = -99 
      comm_k   = -99 

      return 
      end


*     *************************************
*     *                                   *
*     *        Parallel2d_Init            *
*     *                                   *
*     *************************************

*     Sset up the 2d processor grid = np_i x np_j, 
*     where np_i = ncolumns, and np_j = np/np_i
*
      subroutine Parallel2d_Init(ncolumns)
      implicit none
      integer ncolumns

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"

*     *** local variables ***
      integer i,j,icount
      integer tmp(2)

      np_i = np/ncolumns
      np_j = ncolumns

      if (np_j.gt.1) then

      icount = 0
      do j=0,np_j-1
      do i=0,np_i-1
        if (icount.eq.taskid) then
           taskid_i = i
           taskid_j = j
        end if
        int_mb(procNd(1) + i + j*np_i) = icount
        icount = mod((icount+1),np)
      end do
      end do

      if (.not.MA_push_get(mt_int,np,'tmppp2',tmp(2),tmp(1)))
     >  call errquit('Parallel2d_init:out of stack memory',0, MA_ERR)
        do i=0,np_i-1
          int_mb(tmp(1)+i) = int_mb(procNd(1) + i + taskid_j*np_i) 
        end do
        comm_i = ga_pgroup_create(int_mb(tmp(1)),np_i)
        do j=0,np_j-1
          int_mb(tmp(1)+j) = int_mb(procNd(1) + taskid_i + j*np_i) 
        end do
        comm_j = ga_pgroup_create(int_mb(tmp(1)),np_j)
      if (.not.MA_pop_stack(tmp(2)))
     >  call errquit('Parallel2d_init:popping stack memory',0, MA_ERR)

      end if

      return
      end


*     *************************************
*     *                                   *
*     *        Parallel2d_Finalize        *
*     *                                   *
*     *************************************

      subroutine Parallel2d_Finalize()
      implicit none

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"

       if (np_j.gt.1) then

*      **** free comm_i and comm_j communicators ****
       if (.not.ga_pgroup_destroy(comm_i))
     >  call errquit('Parallel2d_Finalize: error destoying comm_i',0,0)
       if (.not.ga_pgroup_destroy(comm_j))
     >  call errquit('Parallel2d_Finalize: error destoying comm_j',0,1)

      end if
      return
      end


*     *************************************
*     *                                   *
*     *        Parallel3d_Init            *
*     *                                   *
*     *************************************

*     Sset up the 3d processor grid = np_i x np_j x np_k, 
*     where np_i = np/(np_j*np_k), and np_j = ncolumns and np_k=nzones
*
      subroutine Parallel3d_Init(ncolumns,nzones)
      implicit none
      integer ncolumns,nzones

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"

*     *** local variables ***
      integer i,j,k,icount
      integer tmp(2)

      np_i = np/(ncolumns*nzones)
      np_j = ncolumns
      np_k = nzones

      if ((np_j.gt.1).or.(np_k.gt.1)) then

      icount = 0
      do k=0,np_k-1
      do j=0,np_j-1
      do i=0,np_i-1
        if (icount.eq.taskid) then
           taskid_i = i
           taskid_j = j
           taskid_k = k
        end if
        int_mb(procNd(1) + i + j*np_i + k*np_i*np_j) = icount
        icount = mod((icount+1),np)
      end do
      end do
      end do

      if (.not.MA_push_get(mt_int,np,'tmppp2',tmp(2),tmp(1)))
     >  call errquit('Parallel3d_init:out of stack memory',0, MA_ERR)
        do i=0,np_i-1
          int_mb(tmp(1)+i) = int_mb(procNd(1) 
     >                             + i 
     >                             + taskid_j*np_i
     >                             + taskid_k*np_i*np_j) 
        end do
        comm_i = ga_pgroup_create(int_mb(tmp(1)),np_i)
        do j=0,np_j-1
          int_mb(tmp(1)+j) = int_mb(procNd(1)
     >                              + taskid_i 
     >                              + j*np_i
     >                              + taskid_k*np_i*np_j) 
        end do
        comm_j = ga_pgroup_create(int_mb(tmp(1)),np_j)
        do k=0,np_k-1
          int_mb(tmp(1)+k) = int_mb(procNd(1)
     >                              + taskid_i 
     >                              + taskid_j*np_i
     >                              + k*np_i*np_j) 
        end do
        comm_k = ga_pgroup_create(int_mb(tmp(1)),np_k)
      if (.not.MA_pop_stack(tmp(2)))
     >  call errquit('Parallel3d_init:popping stack memory',0, MA_ERR)

      end if

      return
      end


*     *************************************
*     *                                   *
*     *        Parallel3d_Finalize        *
*     *                                   *
*     *************************************

      subroutine Parallel3d_Finalize()
      implicit none

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"

      if ((np_j.gt.1).or.(np_k.gt.1)) then

*      **** free comm_i and comm_j communicators ****
       if (.not.ga_pgroup_destroy(comm_i))
     >  call errquit('Parallel3d_Finalize: error destoying comm_i',0,0)
       if (.not.ga_pgroup_destroy(comm_j))
     >  call errquit('Parallel3d_Finalize: error destoying comm_j',0,1)
       if (.not.ga_pgroup_destroy(comm_k))
     >  call errquit('Parallel3d_Finalize: error destoying comm_k',0,2)

      end if
      return
      end



*     ***********************************
*     *                                 *
*     *         Parallel_MaxAll         *
*     *                                 *
*     ***********************************

      subroutine Parallel_MaxAll(sum)
c     implicit none
      real*8  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         call GA_DGOP(9+MSGDBL,sum,1,'max')
      end if

      return
      end





*     ***********************************
*     *                                 *
*     *         Parallel_IMaxAll        *
*     *                                 *
*     ***********************************
      subroutine Parallel_IMaxAll(isum)
c     implicit none
      integer isum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         call GA_IGOP(9+MSGINT,isum,1,'max')
      end if
      return
      end




*     ***********************************
*     *                                 *
*     *         Parallel_SumAll         *
*     *                                 *
*     ***********************************

      subroutine Parallel_SumAll(sum)
c     implicit none
      real*8  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         call GA_DGOP(9+MSGDBL,sum,1,'+')
      end if

      return
      end



*     ***********************************
*     *                                 *
*     *         Parallel_ISumAll        *
*     *                                 *
*     ***********************************

      subroutine Parallel_ISumAll(sum)
c     implicit none
      integer  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         call GA_IGOP(9+MSGINT,sum,1,'+')
      end if
      
      return
      end


*     ***********************************
*     *                                 *
*     *      Parallel_Vector_SumAll     *
*     *                                 *
*     ***********************************
      subroutine Parallel_Vector_SumAll(n,sum)
c     implicit none
      integer n
      real*8  sum(*)

#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "errquit.fh"
#include "Parallel.fh"


      call nwpw_timing_start(2)
      if (np.gt.1) then
         call GA_DGOP(9+MSGDBL,sum,n,'+')
      end if
      call nwpw_timing_end(2)
      return
      end



*     ***********************************
*     *                                 *
*     *     Parallel_Vector_ISumAll     *
*     *                                 *
*     ***********************************

      subroutine Parallel_Vector_ISumAll(n,sum)
c     implicit none
      integer n
      integer  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"


      call nwpw_timing_start(2)
      if (np.gt.1) then
         call GA_IGOP(9+MSGINT,sum,n,'+')
      end if
      call nwpw_timing_end(2)

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_value      *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_value(psend,sum)
      implicit none
      integer psend
      real*8  sum

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

*     **** local variables ****
      integer msglen

      if (np.gt.1) then
         msglen = 1
         call BRDCST(9+MSGDBL,sum,mdtob(msglen),psend)
      end if

      return
      end


*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_values     *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_values(psend,nsize,sum)
      implicit none
      integer psend,nsize
      real*8  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"


      if (np.gt.1) then
         call BRDCST(9+MSGDBL,sum,mdtob(nsize),psend)
      end if

      return
      end

*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_ivalue     *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_ivalue(psend,isum)
      implicit none
      integer psend
      integer isum

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

*     **** local variables ****
      integer msglen

      if (np.gt.1) then
         msglen = 1
         call BRDCST(9+MSGINT,isum,mitob(msglen),psend)
      end if

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_ivalues     *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_ivalues(psend,nsize,isum)
      implicit none
      integer psend,nsize
      integer  isum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         call BRDCST(9+MSGINT,isum,mitob(nsize),psend)
      end if
      return
      end




*     ***********************************
*     *                                 *
*     *         Parallela_MaxAll        *
*     *                                 *
*     ***********************************

      subroutine Parallela_MaxAll(ic,sum)
c     implicit none
      integer ic
      real*8  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         if (ic.eq.1) then
            call GA_PGROUP_DGOP(comm_i,9+MSGDBL,sum,1,'max')
         else if (ic.eq.2) then
            call GA_PGROUP_DGOP(comm_j,9+MSGDBL,sum,1,'max')
         else if (ic.eq.3) then
            call GA_PGROUP_DGOP(comm_k,9+MSGDBL,sum,1,'max')
         else
            call GA_DGOP(9+MSGDBL,sum,1,'max')
         end if
      end if

      return
      end




*     ***********************************
*     *                                 *
*     *         Parallela_SumAll        *
*     *                                 *
*     ***********************************

      subroutine Parallela_SumAll(ic,sum)
c     implicit none
      integer ic
      real*8  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         if (ic.eq.1) then
            call GA_PGROUP_DGOP(comm_i,9+MSGDBL,sum,1,'+')
         else if (ic.eq.1) then
            call GA_PGROUP_DGOP(comm_j,9+MSGDBL,sum,1,'+')
         else if (ic.eq.3) then
            call GA_PGROUP_DGOP(comm_k,9+MSGDBL,sum,1,'+')
         else 
            call GA_DGOP(9+MSGDBL,sum,1,'+')
         end if
      end if

      return
      end



*     ***********************************
*     *                                 *
*     *         Parallela_ISumAll       *
*     *                                 *
*     ***********************************

      subroutine Parallela_ISumAll(ic,sum)
c     implicit none
      integer ic
      integer  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         if (ic.eq.1) then
            call GA_PGROUP_IGOP(comm_i,9+MSGINT,sum,1,'+')
         else if (ic.eq.2) then
            call GA_PGROUP_IGOP(comm_j,9+MSGINT,sum,1,'+')
         else if (ic.eq.3) then
            call GA_PGROUP_IGOP(comm_k,9+MSGINT,sum,1,'+')
         else 
            call GA_IGOP(9+MSGINT,sum,1,'+')
         end if
      end if
      
      return
      end


*     ***********************************
*     *                                 *
*     *      Parallela_Vector_SumAll    *
*     *                                 *
*     ***********************************
      subroutine Parallela_Vector_SumAll(ic,n,sum)
c     implicit none
      integer ic
      integer n
      real*8  sum(*)

#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "errquit.fh"
#include "Parallel.fh"


      call nwpw_timing_start(2)
      if (np.gt.1) then
         if (ic.eq.1) then
            call GA_PGROUP_DGOP(comm_i,9+MSGDBL,sum,n,'+')
         else if (ic.eq.2) then
            call GA_PGROUP_DGOP(comm_j,9+MSGDBL,sum,n,'+')
         else if (ic.eq.3) then
            call GA_PGROUP_DGOP(comm_k,9+MSGDBL,sum,n,'+')
         else
            call GA_DGOP(9+MSGDBL,sum,n,'+')
         end if
      end if
      call nwpw_timing_end(2)
      return
      end



*     ***********************************
*     *                                 *
*     *     Parallela_Vector_ISumAll    *
*     *                                 *
*     ***********************************

      subroutine Parallela_Vector_ISumAll(ic,n,sum)
c     implicit none
      integer ic
      integer n
      integer  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"


      call nwpw_timing_start(2)
      if (np.gt.1) then
         if (ic.eq.1) then
            call GA_PGROUP_IGOP(comm_i,9+MSGINT,sum,n,'+')
         else if (ic.eq.2) then
            call GA_PGROUP_IGOP(comm_j,9+MSGINT,sum,n,'+')
         else if (ic.eq.3) then
            call GA_PGROUP_IGOP(comm_k,9+MSGINT,sum,n,'+')
         else 
            call GA_IGOP(9+MSGINT,sum,n,'+')
         end if
      end if
      call nwpw_timing_end(2)

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_value      *
*     *                                 *
*     ***********************************

      subroutine Parallela_Brdcst_value(ic,psend,sum)
      implicit none
      integer ic
      integer psend
      real*8  sum

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

*     **** local variables ****
      integer msglen

      if (np.gt.1) then
         msglen = 1
         if (ic.eq.1) then
          call GA_PGROUP_BRDCST(comm_i,9+MSGDBL,sum,mdtob(msglen),psend)
         else if (ic.eq.2) then
          call GA_PGROUP_BRDCST(comm_j,9+MSGDBL,sum,mdtob(msglen),psend)
         else if (ic.eq.3) then
          call GA_PGROUP_BRDCST(comm_k,9+MSGDBL,sum,mdtob(msglen),psend)
         else
            call GA_BRDCST(9+MSGDBL,sum,mdtob(msglen),psend)
         end if
      end if

      return
      end


*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_values    *
*     *                                 *
*     ***********************************

      subroutine Parallela_Brdcst_values(ic,psend,nsize,sum)
      implicit none
      integer ic
      integer psend,nsize
      real*8  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"


      if (np.gt.1) then
         if (ic.eq.1) then
           call GA_PGROUP_BRDCST(comm_i,9+MSGDBL,sum,mdtob(nsize),psend)
         else if (ic.eq.2) then
           call GA_PGROUP_BRDCST(comm_j,9+MSGDBL,sum,mdtob(nsize),psend)
         else if (ic.eq.3) then
           call GA_PGROUP_BRDCST(comm_k,9+MSGDBL,sum,mdtob(nsize),psend)
         else
            call GA_BRDCST(9+MSGDBL,sum,mdtob(nsize),psend)
         end if
      end if

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_ivalue    *
*     *                                 *
*     ***********************************
      subroutine Parallela_Brdcst_ivalue(ic,psend,isum)
      implicit none
      integer ic
      integer psend
      integer isum

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

*     **** local variables ****
      integer msglen

      if (np.gt.1) then
         msglen = 1
         if (ic.eq.1) then
         call GA_PGROUP_BRDCST(comm_i,9+MSGINT,isum,mitob(msglen),psend)
         else if (ic.eq.2) then
         call GA_PGROUP_BRDCST(comm_j,9+MSGINT,isum,mitob(msglen),psend)
         else if (ic.eq.3) then
         call GA_PGROUP_BRDCST(comm_k,9+MSGINT,isum,mitob(msglen),psend)
         else
         call GA_BRDCST(9+MSGINT,isum,mitob(msglen),psend)
         end if
      end if

      return
      end




*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_ivalues   *
*     *                                 *
*     ***********************************

      subroutine Parallela_Brdcst_ivalues(ic,psend,nsize,isum)
      implicit none
      integer ic
      integer psend,nsize
      integer  isum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "Parallel.fh"

      if (np.gt.1) then
         if (ic.eq.1) then
          call GA_PGROUP_BRDCST(comm_i,9+MSGINT,isum,mitob(nsize),psend)
         else if (ic.eq.2) then
          call GA_PGROUP_BRDCST(comm_j,9+MSGINT,isum,mitob(nsize),psend)
         else if (ic.eq.3) then
          call GA_PGROUP_BRDCST(comm_k,9+MSGINT,isum,mitob(nsize),psend)
         else 
            call GA_BRDCST(9+MSGINT,isum,mitob(nsize),psend)
         end if
      end if
      return
      end



*     ***********************************
*     *                                 *
*     *      Parallela_start_rotate     *
*     *                                 *
*     ***********************************

      subroutine Parallela_start_rotate(ic,shift,
     >                                  A1,nsize1,
     >                                  A2,nsize2,request)
      implicit none
      integer ic,shift
      real*8  A1(*)
      integer nsize1
      real*8  A2(*)
      integer nsize2
      integer request(*)

#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "errquit.fh"

#include "Parallel.fh"


*     **** local variables ****
      integer i,mynp,mytaskid,msglen,msgype,mpierr,proc_to,proc_from
      integer rcv_proc,rcv_len,psr,tmp(2),pto

*     ***** external functions ****
      integer  Parallel3d_convert_taskid_i
      integer  Parallel3d_convert_taskid_j
      integer  Parallel3d_convert_taskid_k
      external Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_j
      external Parallel3d_convert_taskid_k

      if (ic.eq.1) then
         mynp     = np_i
         mytaskid = taskid_i
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)

         proc_to   = Parallel3d_convert_taskid_i(proc_to)
         proc_from = Parallel3d_convert_taskid_i(proc_from)
      else if (ic.eq.2) then
         mynp     = np_j
         mytaskid = taskid_j
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)

         proc_to   = Parallel3d_convert_taskid_j(proc_to)
         proc_from = Parallel3d_convert_taskid_j(proc_from)
      else if (ic.eq.3) then
         mynp     = np_k
         mytaskid = taskid_k
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)

         proc_to   = Parallel3d_convert_taskid_k(proc_to)
         proc_from = Parallel3d_convert_taskid_k(proc_from)
      else
         mynp     = np
         mytaskid = taskid
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)
      end if

*      /* determine psr - should be made w/o using tmp array! */
      if (.not.MA_push_get(mt_int,mynp,'tmppp2',tmp(2),tmp(1)))
     >  call errquit('Parallela_start_rotate:out of stack',0,MA_ERR)
      do i=0,np-1
         int_mb(tmp(1)+i) = 0
      end do
      do i=0,np-1
         pto = mod(i+shift+mynp,mynp)
         if ((int_mb(tmp(1)+i).eq.0).and.(int_mb(tmp(1)+pto).eq.0)) then
            int_mb(tmp(1)+i)   = 1
            int_mb(tmp(1)+pto) = 2
         end if
      end do
      psr = int_mb(tmp(1)+mytaskid)
      if (psr.eq.0) psr = 2
      if (.not.MA_pop_stack(tmp(2)))
     >  call errquit('Parallela_start_rotate:popping stack',0,MA_ERR)

*     **** send then receive ****
      if (psr.eq.1) then

         if (nsize1.gt.0) then
            msglen  = nsize1
            call SND(9+MSGDBL,A1,mdtob(msglen),proc_to,1)
            request(4) = 1
         else
            request(4) = 0
         end if

         if (nsize2.gt.0) then
            msglen  = nsize2
            call RCV(9+MSGDBL,A2,mdtob(msglen),rcv_len,
     >            proc_from,rcv_proc,1)
            request(3) = 1
         else
            request(3) = 0
         end if

*     **** receive then receive ****
      else
         if (nsize2.gt.0) then
            msglen  = nsize2
            call RCV(9+MSGDBL,A2,mdtob(msglen),rcv_len,
     >            proc_from,rcv_proc,1)
            request(3) = 1
         else
            request(3) = 0
         end if

         if (nsize1.gt.0) then
            msglen  = nsize1
            call SND(9+MSGDBL,A1,mdtob(msglen),proc_to,1)
            request(4) = 1
         else
            request(4) = 0
         end if
      end if

      if ((request(3).eq.1).and.(request(4).eq.1)) then
         request(3) = 1
      else if (request(3).eq.1) then
         request(3) = 2
      else if (request(4).eq.1) then
         request(3) = 3
      else
         request(3) = 4
      end if

      return
      end


*     ***********************************
*     *                                 *
*     *      Parallela_start_Irotate    *
*     *                                 *
*     ***********************************
      subroutine Parallela_start_Irotate(ic,shift,
     >                                  A1,nsize1,
     >                                  A2,nsize2,request)
      implicit none
      integer ic,shift
      integer A1(*)
      integer nsize1
      integer A2(*)
      integer nsize2
      integer request(*)

#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "errquit.fh"

#include "Parallel.fh"


*     **** local variables ****
      integer i,mynp,mytaskid,msglen,msgype,mpierr,proc_to,proc_from
      integer rcv_proc,rcv_len,psr,tmp(2),pto

*     ***** external functions ****
      integer  Parallel3d_convert_taskid_i
      integer  Parallel3d_convert_taskid_j
      integer  Parallel3d_convert_taskid_k
      external Parallel3d_convert_taskid_i
      external Parallel3d_convert_taskid_j
      external Parallel3d_convert_taskid_k

      if (ic.eq.1) then
         mynp     = np_i
         mytaskid = taskid_i
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)

         proc_to   = Parallel3d_convert_taskid_i(proc_to)
         proc_from = Parallel3d_convert_taskid_i(proc_from)
      else if (ic.eq.2) then
         mynp     = np_j
         mytaskid = taskid_j
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)

         proc_to   = Parallel3d_convert_taskid_j(proc_to)
         proc_from = Parallel3d_convert_taskid_j(proc_from)
      else if (ic.eq.3) then
         mynp     = np_k
         mytaskid = taskid_k
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)

         proc_to   = Parallel3d_convert_taskid_k(proc_to)
         proc_from = Parallel3d_convert_taskid_k(proc_from)
      else
         mynp     = np
         mytaskid = taskid
         proc_to   = mod(mytaskid+shift+mynp,mynp)
         proc_from = mod(mytaskid-shift+mynp,mynp)
      end if

*      /* determine psr - should be made w/o using tmp array! */
      if (.not.MA_push_get(mt_int,mynp,'tmppp2',tmp(2),tmp(1)))
     >  call errquit('Parallela_start_rotate:out of stack',0,MA_ERR)
      do i=0,np-1
         int_mb(tmp(1)+i) = 0
      end do
      do i=0,np-1
         pto = mod(i+shift+mynp,mynp)
         if ((int_mb(tmp(1)+i).eq.0).and.(int_mb(tmp(1)+pto).eq.0)) then
            int_mb(tmp(1)+i)   = 1
            int_mb(tmp(1)+pto) = 2
         end if
      end do
      psr = int_mb(tmp(1)+mytaskid)
      if (psr.eq.0) psr = 2
      if (.not.MA_pop_stack(tmp(2)))
     >  call errquit('Parallela_start_rotate:popping stack',0,MA_ERR)

*     **** send then receive ****
      if (psr.eq.1) then

         if (nsize1.gt.0) then
            msglen  = nsize1
            call SND(9+MSGINT,A1,mitob(msglen),proc_to,1)
            request(4) = 1
         else
            request(4) = 0
         end if

         if (nsize2.gt.0) then
            msglen  = nsize2
            call RCV(9+MSGINT,A2,mitob(msglen),rcv_len,
     >            proc_from,rcv_proc,1)
            request(3) = 1
         else
            request(3) = 0
         end if

*     **** receive then receive ****
      else
         if (nsize2.gt.0) then
            msglen  = nsize2
            call RCV(9+MSGINT,A2,mitob(msglen),rcv_len,
     >            proc_from,rcv_proc,1)
            request(3) = 1
         else
            request(3) = 0
         end if

         if (nsize1.gt.0) then
            msglen  = nsize1
            call SND(9+MSGINT,A1,mitob(msglen),proc_to,1)
            request(4) = 1
         else
            request(4) = 0
         end if
      end if

      if ((request(3).eq.1).and.(request(4).eq.1)) then
         request(3) = 1
      else if (request(3).eq.1) then
         request(3) = 2
      else if (request(4).eq.1) then
         request(3) = 3
      else
         request(3) = 4
      end if

      return
      end






*     ***********************************
*     *                                 *
*     *      Parallela_end_rotate       *
*     *                                 *
*     ***********************************

      subroutine Parallela_end_rotate(request)
      implicit none
      integer request(*)

*     **** wait for completion of mp_send, also do a sync ****
      !*** do nothing ***

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallel_send_characters   *
*     *                                 *
*     ***********************************
      subroutine Parallel_send_characters(pto,msgtype,nsize,cval)
      implicit none
      integer pto,msgtype,nsize
      character cval(*)

#include "tcgmsg.fh"
#include "msgtypesf.h"

      integer  rcv_len,rcv_proc

      call SND(9+MSGCHR,cval,nsize,pto,1)
      return
      end

*     ***********************************
*     *                                 *
*     *      Parallel_send_values       *
*     *                                 *
*     ***********************************
      subroutine Parallel_send_values(pto,msgtype,nsize,rval)
      implicit none                     
      integer pto,msgtype,nsize
      character rval(*)                 

#include "tcgmsg.fh"
#include "msgtypesf.h"

      call SND(9+MSGDBL,rval,mdtob(nsize),pto,1)
      return
      end

*     ***********************************
*     *                                 *
*     *      Parallel_send_ivalues      *
*     *                                 *
*     ***********************************
      subroutine Parallel_send_ivalues(pto,msgtype,nsize,ival)
      implicit none
      integer pto,msgtype,nsize
      integer   ival(*)

#include "tcgmsg.fh"
#include "msgtypesf.h"

      call SND(9+MSGINT,ival,mitob(nsize),pto,1)
      return
      end





*     ***********************************
*     *                                 *
*     *      Parallel_recv_characters   *
*     *                                 *
*     ***********************************
      subroutine Parallel_recv_characters(pfrom,msgtype,nsize,cval)
      implicit none
      integer  pfrom,msgtype,nsize
      character cval(*)

#include "tcgmsg.fh"
#include "msgtypesf.h"

      integer  rcv_len,rcv_proc

      call RCV(9+MSGCHR,cval,nsize,rcv_len,pfrom,rcv_proc,1)
      return
      end


*     ***********************************
*     *                                 *
*     *      Parallel_recv_values       *
*     *                                 *
*     ***********************************
      subroutine Parallel_recv_values(pfrom,msgtype,nsize,rval)
      implicit none
      integer  pfrom,msgtype,nsize
      real*8   rval(*)

#include "tcgmsg.fh"
#include "msgtypesf.h"

      integer  rcv_len,rcv_proc

      call RCV(9+MSGDBL,rval,mdtob(nsize),rcv_len,pfrom,rcv_proc,1)
      return
      end


*     ***********************************
*     *                                 *
*     *      Parallel_recv_ivalues      *
*     *                                 *
*     ***********************************
      subroutine Parallel_recv_ivalues(pfrom,msgtype,nsize,ival)
      implicit none
      integer  pfrom,msgtype,nsize
      integer  ival(*)

#include "tcgmsg.fh"
#include "msgtypesf.h"

      integer  rcv_len,rcv_proc

      call RCV(9+MSGINT,ival,mitob(nsize),rcv_len,pfrom,rcv_proc,1)
      return
      end

c
c     Calculate or read the density matrix
c
      subroutine esp_denmat(occ,ene)
c
c $Id: esp_denmat.F 26040 2014-08-26 03:43:05Z niri $
c
      implicit none
c
#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "stdio.fh"
#include "esp_params.fh"
#include "esp_common.fh"
#include "util.fh"
c  
      integer  ga_create_atom_blocked
      external ga_create_atom_blocked
c
      logical movecs_read,movecs_read_header
      external movecs_read,movecs_read_header
c
      real*8 ene(2*nbf),occ(2*nbf), scale
c
      integer ilo,ihi,jlo,jhi,lthi,lthj,i
      integer lg_s,k_scr,l_scr,icol,iset, lg_p(2)
      integer ioff
c
      character*20 scftyp
      character*255 dmat_file
c
      logical ao_1prdm_read
      external ao_1prdm_read
c
c     allocate global arrays
c
      lg_d    =ga_create_atom_blocked(igeom,ibasis,'density')
      lg_v    =ga_create_atom_blocked(igeom,ibasis,'vector')
      lg_s    =ga_create_atom_blocked(igeom,ibasis,'scr')
      lg_p(1)   =ga_create_atom_blocked(igeom,ibasis,'density')
c
      call ga_zero(lg_d)
      call ga_zero(lg_v)
      call ga_zero(lg_s)
      call ga_zero(lg_p(1))
c
      if (denmat.ne.0) then
c
c       read density matrix
c
        call util_file_name('dmat',.false.,.false.,dmat_file) !
        if (.not. ao_1prdm_read(nbf,lg_d,dmat_file))
     &     call errquit('esp_denmat: ao_1prdm_read failed',0,0)
c
      else ! denmat
c
c       calculate density matrix from movecs
c
        if (movfil.eq.' ') then
           call util_file_name('movecs',.false.,.false.,movfil)
        else
           call util_file_name_resolve(movfil,.false.)
        end if
        if(.not.movecs_read_header(movfil,title,basnam,scftyp,nbf,nset,
     +       nmo,2)) call md_abort('esp: movecs_read_header failed',me)
c
c       if nset=2, put the first set's occupation numbers and eigenvalues
c       in 1:nbf, put the second set's in nbf+1:2*nbf, and allocate
c       beta density matrix.
c
        if (nset.gt.1) then
          ioff = nbf
          lg_p(2)   =ga_create_atom_blocked(igeom,ibasis,'beta density')
          call ga_zero(lg_p(2))
        else
          ioff = 0
        endif
c
        nocc=0
        charge=chgnuc
c
c     read orbital occupations, energies and vectors from movecs
c
      do 1 iset=1,nset
c
      if (.not. movecs_read(movfil, iset, dbl_mb(ioptr+ioff),
     &     dbl_mb(ieptr+ioff), lg_v))
     & call md_abort('esp_denmat:movecs_read failed ',0)
c
      do 2 i=1,nbf
      if(dbl_mb(ioptr+i-1+ioff).gt.small) then
         charge=charge-dbl_mb(ioptr+i-1+ioff)
      endif
      occ(i+ioff) = dbl_mb(ioptr+i-1+ioff)
      ene(i+ioff) = dbl_mb(ieptr+i-1+ioff)
    2 continue
c
      call ga_copy(lg_v,lg_s)
      call ga_sync()
c
      call ga_distribution(lg_s,me,ilo,ihi,jlo,jhi)
      lthi=ihi-ilo+1
      lthj=jhi-jlo+1
c
      if(lthi.ne.0.and.lthj.ne.0) then
      if(lthi.lt.0.or.lthj.lt.0) 
     + call md_abort('esp_denmat: distribution error',me)
c
      if(.not.ma_push_get(mt_dbl,lthi,'vector',l_scr,k_scr))
     + call md_abort('esp_denmat: failed to allocate vector',me)
c
      do 3 icol=jlo,jhi
      call ga_get(lg_s,ilo,ihi,icol,icol,dbl_mb(k_scr),1)
cx
cx      write(*,6666) icol,(dbl_mb(k_scr+i),i=0,nbf-1)
cx 6666 format(//,'Vector',i5,/,(10f10.6))
cx
      scale=dbl_mb(ioptr+icol-1+ioff)
cx
cx      write(*,'(a,i5,f12.6)') 'Scale ',icol,scale
cx
      call dscal(lthi,scale,dbl_mb(k_scr),1)
      call ga_put(lg_s,ilo,ihi,icol,icol,dbl_mb(k_scr),1)
cx      call ga_get(lg_s,ilo,ihi,icol,icol,dbl_mb(k_scr),1)
cx
cx      write(*,6667) (dbl_mb(k_scr+i),i=0,nbf-1)
cx 6667 format(10f10.6)
cx
    3 continue
c
      if(.not.ma_pop_stack(l_scr))
     + call md_abort('esp_denmat: failed to deallocate vector',me)
c
      endif
c
      call ga_sync()
      call ga_dgemm('n','t',nbf,nbf,nbf,1.d0,lg_v,lg_s,0.d0,lg_p(iset))
c
    1 continue 
c
      if (nset.eq.1) then
        call ga_copy(lg_p(1),lg_d)
      else 
        call ga_dadd(1.0d0,lg_p(1),1.0d0,lg_p(2),lg_d) ! consolidate the density matrices
      endif
c
      endif !denmat
c
      call ga_sync()
c
c     deallocate global arrays lg_s, lg_v and lg_d
c
      if(.not.ga_destroy(lg_p(1)))
     + call md_abort('esp_denmat: failed to destroy lg_p',me)
      if (nset.eq.2) then
        if(.not.ga_destroy(lg_p(2)))
     +  call md_abort('esp_denmat: failed to destroy lg_p',me)
      endif
      if(.not.ga_destroy(lg_s))
     + call md_abort('esp_denmat: failed to destroy lg_s',me)
      if(.not.ga_destroy(lg_v))
     + call md_abort('esp_denmat: ga_destroy lg_v failed',me)
c
      return
      end

C> \ingroup selci
C> @{
C>
      subroutine selci_check(node)
*
* $Id: selci_check.f 24780 2013-11-07 21:23:59Z d3y133 $
*
      logical opn
      character*80 filename
      do i = 1, 99
         if (i.ne.5 .and. i.ne.6) then
            inquire(i,opened=opn,name=filename)
            if (opn) then
               write(6,*) ' node ', node, ' unit ', i,
     $              ' name ', filename
            endif
         endif
      enddo
      end
C>
C> @}

*
* $Id: cprmdv1.F 25932 2014-07-23 16:49:34Z bylaska $
*

***********************************************************************
*                      cprmdv1-mpi  (MPI code)                        *
*                                                                     *
* This is a developing Car-Parrinello-Rahman parallel code for NWChem *
*       + mpi message passing library used                            *
*       + ngp is used instead of nfft in this proceudure              *
*       + error checking is based on aimd.h parameters                *
*         then control file                                           *
*       + my own slap-decomposed parallel 3d-FFT(real->complex) used  *
*                                                                     *
*                                                                     *
***********************************************************************

      logical function cprmdv1(rtdb)
CDEC$ OPTIMIZE:0
      implicit none
      integer rtdb

#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
      
      logical value

      real*8 kb
      parameter (kb=3.16679d-6)
      real*8 autoatm
      parameter (autoatm =290.360032539d6)


      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d

*     **** electronic variables ****
      real*8 icharge
      integer ispin
      integer ne(2),n1(2),n2(2),nemax,neall,neq(2),nemaxq
      real*8  en(2)
      real*8 dipole(3)

*     complex*16 psi1(nfft3d,nemax)
*     complex*16 psi2(nfft3d,nemax)
*     real*8     dn(n2ft3d,2)
*     complex*16 Hpsi(nfft3d,nemax)
*     complex*16 psir(nfft3d,nemax)
      integer psi0(2),psi1(2),psi2(2)
      integer occ0(2),occ1(2),occ2(2)
      integer dn(2)
      integer Hpsi(2),psir(2)
    

*     ***** energy variables ****
      real*8  E(40),eke,eave,evar,cv,have,hvar

*     real*8  eig(2*nemax)
*     real*8  hml(2*nemax*nemax)
*     real*8  lmd(2*nemax*nemax)
      integer eig(2),hml(2),lmd(2)

*     **** psi smearing block ****
      logical fractional
      integer smearoccupation,smeartype
      real*8 smearfermi(2),smearcorrection,smearkT

*     **** error variables ****
      integer ierr

*     **** local variables ****
      logical verlet,mulliken,SA,found,calc_pressure,found_bak
      integer ms
      real*8  gx,gy,gz,cx,cy,cz
      real*8  vgx,vgy,vgz,vcx,vcy,vcz
      real*8  ekg,eki0,eki1,sum
      real*8  eke0,eke1
      real*8  EV,pi,dt
      real*8  emotion_time_shift
      integer i,j,k,ia,n,nn
      integer ii,jj,index,indx
      integer icount,it_in,it_out,icount_shift
      real*8 w,sumall,pressure,stress(3,3),p1,p2
      real*8 Te_init,Tr_init,Te_new,Tr_new,sa_decay(2),sa_alpha(2)
      double precision tollz
      parameter(tollz=1d-16)
      integer mapping,mapping1d
      character*50 filename
      character*255 full_filename,full_bak
  


*     **** external functions ****
      real*8      psp_zv,psp_rc,ewald_rcut,ion_amass
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg
      integer     ewald_ncut,ewald_nshl3d
      integer     psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      character*4 ion_atom,ion_aname
      external    psp_zv,psp_rc,ewald_rcut,ion_amass
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg
      external    ewald_ncut,ewald_nshl3d
      external    psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      external    ion_atom,ion_aname

      real*8   control_rti,control_rte,ion_rion
      real*8   ion_vion,ion_com_ke,ion_ke
      real*8   ion_Temperature,ion_com_Temperature
      external control_rti,control_rte,ion_rion
      external ion_vion,ion_com_ke,ion_ke
      external ion_Temperature,ion_com_Temperature
      real*8   control_time_step,control_fake_mass
      external control_time_step,control_fake_mass
      logical  control_read,control_move,ion_init,ion_q_FixIon
      external control_read,control_move,ion_init,ion_q_FixIon
      logical  ion_q_zFixIon
      external ion_q_zFixIon

      integer  pack_nwave_all
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external pack_nwave_all
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm

      character*12 control_boundry
      external     control_boundry

      logical      psp_semicore,pspw_qmmm_found
      real*8       psp_rcore,psp_ncore,psp_rlocal
      external     psp_semicore,pspw_qmmm_found
      external     psp_rcore,psp_ncore,psp_rlocal

      logical  control_Nose,control_Mulliken,Nose_restart
      external control_Nose,control_Mulliken,Nose_restart

      integer  Nose_Mchain,Nose_Nchain
      external Nose_Mchain,Nose_Nchain
  
      real*8   control_Nose_Te,Nose_Qe,Nose_Pe,Nose_Ee0
      external control_Nose_Te,Nose_Qe,Nose_Pe,Nose_Ee0

      real*8   control_Nose_Tr,Nose_Qr,Nose_Pr,Nose_Er0
      external control_Nose_Tr,Nose_Qr,Nose_Pr,Nose_Er0
      logical      v_psi_filefind
      external     v_psi_filefind
      real*8   nwpw_timing
      external nwpw_timing

      logical  control_out_of_time,control_new_vpsi
      external control_out_of_time,control_new_vpsi

      logical  control_SA,control_Fei,pspw_SIC,pspw_HFX,control_pressure
      real*8   control_SA_decay
      external control_SA,control_Fei,pspw_SIC,pspw_HFX,control_pressure
      external control_SA_decay

      integer  control_np_orbital,control_mapping,control_mapping1d
      external control_np_orbital,control_mapping,control_mapping1d


      logical  control_translation,control_rotation,control_balance
      external control_translation,control_rotation,control_balance
     
      logical  Dneall_m_allocate,Dneall_m_free,control_parallel_io
      external Dneall_m_allocate,Dneall_m_free,control_parallel_io

      real*8   Dneall_m_value
      external Dneall_m_value

      logical  meta_found,tamd_found,psp_U_psputerm,ion_disp_on
      external meta_found,tamd_found,psp_U_psputerm,ion_disp_on

      integer  ion_nconstraints,ion_ndof
      external ion_nconstraints,ion_ndof


*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(30,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      if (taskid.eq.MASTER) call current_second(cpu1)

*     ***** print out header ****
      if (taskid.eq.MASTER) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1031)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1042)
         write(luout,1043)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
         call util_flush(luout)
      end if
      call ga_sync()
      
      value = control_read(2,rtdb)
      call Parallel2d_Init(control_np_orbital())
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      mapping = control_mapping()

*     **** initialize psi_data ****
      call psi_data_init(100)


*     **** initialize D3dB data structure ****
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      if (control_version().eq.4) 
     >   call D3dB_Init(2,2*ngrid(1),2*ngrid(2),2*ngrid(3),mapping)


*     **** initialize lattice data structure ****
      call lattice_init()
      call G_init()
      call mask_init()
      call ga_sync()

*     ***** allocate psi2, psi1, and psi0 wavefunctions ****
      call psi_get_ne_occupation(ispin,ne,smearoccupation)
      if (smearoccupation.gt.0) then
         fractional = .true.
      else
         fractional = .false.
      end if
      mapping1d = control_mapping1d()
      call Dne_init(ispin,ne,mapping1d)
      call Dneall_neq(neq)
      nemaxq = neq(1)+neq(2)

      value = MA_alloc_get(mt_dcpl,nfft3d*(neq(1)+neq(2)),
     >                     'psi2',psi2(2),psi2(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d*(neq(1)+neq(2)),
     >                     'psi1',psi1(2),psi1(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d*(neq(1)+neq(2)),
     >                     'psi0',psi0(2),psi0(1))
      if (fractional) then
      value = value.and.
     >        MA_alloc_get(mt_dbl,(ne(1)+ne(2)),'occ0',occ0(2),occ0(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(ne(1)+ne(2)),'occ1',occ1(2),occ1(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(ne(1)+ne(2)),'occ2',occ2(2),occ2(1))
      end if
      if (.not.value) call errquit('out of heap memory',0, MA_ERR)



*     *****  read psi2 wavefunctions ****
      call psi_read_nopack(ispin,ne,dcpl_mb(psi2(1)),
     >              smearoccupation,dbl_mb(occ2(1)))


*     **** move  wavefunction velocities ****
      if (control_new_vpsi()) then
        call v_psi_delete()
      end if


*     **** generate initial wavefunction velocities if it does not exist ****
      if (.not.v_psi_filefind()) then
        call v_psi_new(ispin,ne)
      end if


*     *****  read psi0 wavefunctions ****
      call dcopy(2*nfft3d*(neq(1)+neq(2)),0.0d0,0,dcpl_mb(psi1(1)),1)
      call v_psi_read_nopack(ispin,ne,dcpl_mb(psi1(1)))
      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1)+1
      n2(2) = ne(1)+ne(2)
      nemax = ne(1)+ne(2)

*     **** allocate other variables *****
      value = MA_alloc_get(mt_dbl,(2*nemax),'eig',eig(2),eig(1))
      value = value.and.Dneall_m_allocate(0,hml)
      value = value.and.Dneall_m_allocate(0,lmd)

      value = value.and.
     >        MA_alloc_get(mt_dbl,(4*nfft3d),
     >                     'dn',dn(2),dn(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d*(neq(1)+neq(2)),
     >                     'Hpsi',Hpsi(2),Hpsi(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d*(neq(1)+neq(2)),
     >                     'psir',psir(2),psir(1))
      if (.not.value) call errquit('out of heap memory',0, MA_ERR)



*     **** read ions ****
      value = ion_init(rtdb)


*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)


*     **** allocate psp data structure and read in psedupotentials into it ****
      call psp_init_nopack()
      call psp_readall_nopack()
      if (psp_semicore_nopack(0)) call semicore_check()


*     **** initialize G,mask,ke,and coulomb data structures ****
      call ke_init_nopack()
      if (control_version().eq.3) call coulomb_init_nopack()
      call strfac_init()
      if (control_version().eq.3) call ewald_init()
      
*     **** initialize QM/MM ****
      call pspw_qmmm_init(rtdb)

*     ******************************
*     **** scaling psi velocity ****
*     ******************************
      call dcopy(2*(neq(1)+neq(2))*nfft3d,dcpl_mb(psi1(1)),1,
     >                                  dcpl_mb(psi0(1)),1)
      call dscal(2*(neq(1)+neq(2))*nfft3d,control_rte(),
     >           dcpl_mb(psi1(1)),1)
      eke0 = 0.0d0
      eke1 = 0.0d0
      do i=1,(neq(1)+neq(2))
         call D3dB_cc_dot(1,dcpl_mb(psi0(1)+(i-1)*nfft3d),
     >                      dcpl_mb(psi0(1)+(i-1)*nfft3d),
     >                     sum)
         eke0 = eke0 + sum
         call D3dB_cc_dot(1,dcpl_mb(psi1(1)+(i-1)*nfft3d),
     >                      dcpl_mb(psi1(1)+(i-1)*nfft3d),
     >                    sum)
         eke1 = eke1 + sum
      end do

      call D1dB_SumAll(eke0)
      call D1dB_SumAll(eke1)
      eke0 = control_fake_mass()*eke0
      eke1 = control_fake_mass()*eke1
      call ion_init_ke(ekg,eki0,eki1)


*     **** Initialize thermostats ****
      if (control_Nose()) then
         call ke_ave(ispin,neq,dcpl_mb(psi2(1)),w,
     >               fractional,dbl_mb(occ2(1)))
         call Nose_Init((ne(1)+ne(2)),w)
      end if


*     **** Initialize simulated annealing ****
      SA       = .false.
      Te_init  = 0.0d0
      Tr_init  = 0.0d0
      sa_alpha(1) = 1.0d0
      sa_alpha(2) = 1.0d0
      if (control_SA()) then
         if (control_Nose()) then
            SA          = .true.
            sa_decay(1) = control_SA_decay(1)
            sa_decay(2) = control_SA_decay(2)
            Te_init     = control_Nose_Te()
            Tr_init     = control_Nose_Tr()
         else
            dt = control_time_step()
            SA          = .false.
            sa_decay(1) = control_SA_decay(1)
            sa_decay(2) = control_SA_decay(2)
            sa_alpha(1) = dexp( -(dt/control_SA_decay(1)) ) 
            sa_alpha(2) = dexp( -(dt/control_SA_decay(2)) ) 
         end if
      end if



*     **** initialize metadynamics and tamd ****
      call meta_initialize(rtdb)
      call tamd_initialize(rtdb)

*     **** initialize dplot ****
      call dplot_iteration_init()

c*     **** initialize frac_occ data structure ****
c      call frac_occ_init(rtdb,ispin,ne)

*     **** initialize SIC and HFX ****
      call pspw_init_SIC(rtdb,ne)
      call pspw_init_HFX(rtdb,ispin,ne)


*     **** initialize DFT+U ****
      call psp_U_init()

*     **** initialize META GGA ****
      call nwpw_meta_gga_init()


*     **** initialize pressure ****
      calc_pressure = control_pressure().and.(control_version().eq.3)
      pressure      = 0.0d0
      p1            = 0.0d0
      p2            = 0.0d0
      if (calc_pressure) then
         call psp_stress_init_nopack()
         call psp_stress_readall_nopack()
      end if








*                |**************************|
******************   summary of input data  **********************
*                |**************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)
      mulliken = control_Mulliken()

      if (taskid.eq.MASTER) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j
         if (mapping.eq.1) write(luout,1112)
         if (mapping.eq.2) write(luout,1113)
         if (mapping.eq.3) write(luout,1118)
         if (control_balance()) then
           write(luout,1114)
         else
           write(luout,1116)
         end if
         if (control_parallel_io()) then
           write(luout,1119)
         else
           write(luout,1120)
         end if

         write(luout,1115)
         write(luout,1121) control_boundry(),control_version()
         if (ispin.eq.1) write(luout,1130) 'restricted'
         if (ispin.eq.2) write(luout,1130) 'unrestricted'

         call v_bwexc_print(luout,control_gga())

         if (fractional) write(luout,1132)
         call pspw_print_SIC(luout)
         call pspw_print_HFX(luout)
         write(luout,1140)
         do ia = 1,ion_nkatm()
            call psp_print(ia)
c           write(luout,1150) ia,ion_atom(ia),
c     >                    psp_zv(ia),psp_lmax(ia)
c           write(luout,1152) psp_lmax(ia)
c           write(luout,1153) psp_locp(ia)
c           write(luout,1154) psp_lmmax(ia)
c           if (control_version().eq.4) write(luout,1156) psp_rlocal(ia)
c           if (psp_semicore(ia))
c     >         write(luout,1155) psp_rcore(ia),psp_ncore(ia)
c           write(luout,1151) (psp_rc(i,ia),i=0,psp_lmax(ia))
         end do

         icharge = -(ne(1)+ne(ispin))
         en(1)     = ne(1)
         en(ispin) = ne(ispin)
         if (fractional) then
            icharge = 0.0d0
            do ms=1,ispin
            en(ms) =0.0
            do i=n1(ms),n2(ms)
              icharge = icharge - (3-ispin)*dbl_mb(occ2(1)+i-1)
              en(ms) = en(ms) + dbl_mb(occ2(1)+i-1)
            end do
            end do
         end if

         do ia=1,ion_nkatm()
           icharge = icharge + ion_natm(ia)*psp_zv(ia)
         end do
         write(luout,1159) icharge

         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),
     >                    (ion_rion(K,I),K=1,3),ion_amass(i)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),
     >                    (ion_rion(K,I),K=1,3),ion_amass(i)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz


         write(luout,1181)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
         write(luout,1211) ion_nconstraints(),ion_ndof()


         if (fractional) then
           write(luout,1219) en(1),en(ispin),' (   fractional)'
           write(luout,1221) ne(1),neq(1),
     >                   ne(ispin),neq(ispin),' (Fourier space)'
         else
           write(luout,1220) ne(1),neq(1),
     >                   ne(ispin),neq(ispin),' (Fourier space)'
           write(luout,1221) ne(1),neq(1),
     >                   ne(ispin),neq(ispin),' (Fourier space)'
         end if
         write(luout,1230)
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         write(luout,1231) lattice_omega()
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(0),pack_nwave(0)
         write(luout,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(1),pack_nwave(1)
         if (control_version().eq.3) then
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()
         end if
         write(luout,1270)
         if (.not.control_translation()) write(luout,1271)
         if (.not.control_rotation())    write(luout,1272)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_rte(),control_rti()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()
         write(luout,1222) eke0,eki0,ekg
         write(luout,1223) eke1,eki1
         write(luout,1224) (eke1-eke0),(eki1-eki0)
         if (control_Nose()) then
           write(luout,1295)
           if (Nose_restart()) then
              write(luout,*) "    thermostats resused"
           else
              write(luout,*) "    thermostats initialized"
           end if
           do i=1,Nose_Mchain()
             write(luout,1297) i,control_Nose_Te(),Nose_Qe(i),
     >                     Nose_Pe(i),Nose_Ee0(i)
           end do
           do i=1,Nose_Nchain()
             write(luout,1298) i,control_Nose_Tr(),Nose_Qr(i),
     >                   Nose_Pr(i),Nose_Er0(i)
           end do
         else
           write(luout,1294)
         end if
        if (calc_pressure) write(luout,1293)
        if (control_SA()) then
           write(luout,1296) sa_decay(1),sa_decay(2)
         end if


         if (mulliken) write(luout,1299)
         write(luout,1300)
         write(luout,1305)
         call util_flush(luout)
      end if

*                |***************************|
******************     start iterations      **********************
*                |***************************|
*     **** open xyz and MOTION file ****
      call xyz_init()          ! unit=18
      call MOTION_init(rtdb)   ! unit=19

*     *** fei io ****
      call fei_init(rtdb)

*     **** ecce print ****
      call ecce_print_module_entry('task Car-Parrinello')
      !call ecce_print_module_entry('driver')
      call movecs_ecce_print_off()




*     ************************************
*     **** open up other MOTION files ****
*     ************************************


*     **** open EMOTION file ****
      if (.not.rtdb_cget(rtdb,'cpmd:emotion_filename',1,filename))
     >  call util_file_prefix('emotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER) then

*        **** check for backup file ****
         call util_file_name_noprefix('EMOTION99-bak',.false.,
     >                                .false.,
     >                                full_bak)
         inquire(file=full_bak,exist=found_bak)
         if (found_bak) then
            write(*,*) 
            write(*,*) "EMOTION99-bak exists:"
            i=index(full_bak,' ')
            j=index(full_filename,' ')
            write(*,*) "   Copying ",full_bak(1:i),
     >                 " to ",full_filename(1:j)
            write(*,*)
            call util_file_copy(full_bak,full_filename)
         end if

         emotion_time_shift = 0.0d0
         icount_shift       = 0
         inquire(file=full_filename,exist=found)
         if (found) then

*          **** make a new backup file ***
           call util_file_copy(full_filename,full_bak)

           open(unit=31,file=full_filename,form='formatted',
     >          status='old')
           do while (found)
           read(31,*,end=100) emotion_time_shift,w,sum
           E(25) = E(25) + sum                          !*** take care of running sums ***
           E(26) = E(26) + sum*sum
           icount_shift = icount_shift + 1
           end do
  100      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(GCC46)
           backspace 31
#endif
         else
           open(unit=31,file=full_filename,form='formatted',
     >          status='new')
         end if
      end if


*     **** open EIGMOTION file ****
      if (mulliken) then
        if (.not.rtdb_cget(rtdb,'cpmd:eigmotion_filename',1,filename))
     >    call util_file_prefix('eigmotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER) 
     >   open(unit=32,file=full_filename,form='formatted')
      end if

*     **** open HMOTION file ****
      if (mulliken) then
       if (.not.rtdb_cget(rtdb,'cpmd:hmotion_filename',1,filename))
     >  call util_file_prefix('hmotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER) 
     >   open(unit=34,file=full_filename,form='formatted')
      end if

*     **** open OMOTION file ****
      if (mulliken) call Orb_Init(rtdb,ispin,ne) !unit=33

c*     **** write initial position to xyz data ****
c      call xyz_write()

*     ***** first step using velocity ****
      verlet = .false.
      call inner_loop_cprmd(verlet,sa_alpha,ispin,ne,neq,
     >             nfft3d,nemaxq,
     >             dcpl_mb(psi0(1)),
     >             dcpl_mb(psi1(1)),
     >             dcpl_mb(psi2(1)),
     >             dbl_mb(dn(1)),
     >             1,0,E,
     >             dbl_mb(hml(1)),dbl_mb(lmd(1)),
     >             dcpl_mb(Hpsi(1)),dcpl_mb(psir(1)),
     >             calc_pressure,pressure,p1,p2,
     >             fractional,
     >             dbl_mb(occ0(1)),dbl_mb(occ1(1)),dbl_mb(occ2(1)))


      if (taskid.eq.MASTER) call current_second(cpu2)
      if ((taskid.eq.MASTER).and.(.not.calc_pressure)) 
     >   CALL nwpw_message(6)
      if ((taskid.eq.MASTER).and.(calc_pressure)) 
     >   CALL nwpw_message(9)
      
      it_in  = control_it_in()
      it_out = control_it_out()
      icount = 0
      verlet = .true.
      eke    = 0.0d0
      if (it_out.lt.1) goto 102



      dt = control_time_step()

      Te_new = Te_init
      Tr_new = Tr_init
  101 continue
         icount = icount + 1
         call inner_loop_cprmd(verlet,sa_alpha,ispin,ne,neq,
     >             nfft3d,nemaxq,
     >             dcpl_mb(psi0(1)),
     >             dcpl_mb(psi1(1)),
     >             dcpl_mb(psi2(1)),
     >             dbl_mb(dn(1)),
     >             it_in,((icount-1)*it_in),
     >             E,
     >             dbl_mb(hml(1)),dbl_mb(lmd(1)),
     >             dcpl_mb(Hpsi(1)), dcpl_mb(psir(1)),
     >             calc_pressure,pressure,p1,p2,
     >             fractional,
     >             dbl_mb(occ0(1)),dbl_mb(occ1(1)),dbl_mb(occ2(1)))

         eke = eke + E(3)


         !**** metadynamics and tamd update ****
         call meta_update(ispin,neq,dcpl_mb(psi1(1)),E)
         call tamd_update(ispin,neq,dcpl_mb(psi1(1)),E)

         if (taskid.eq.MASTER) then 

           if (calc_pressure) then
             if (SA) then
             write(luout,1309) icount*it_in,E(1),E(2),E(3),E(4),
     >                     Te_new,Tr_new,pressure*autoatm
             else
             write(luout,1310) icount*it_in,E(1),E(2),E(3),E(4),
     >                     ion_Temperature(),pressure*autoatm
             end if
           else
             if (SA) then
             write(luout,1309) icount*it_in,E(1),E(2),E(3),E(4),
     >                     Te_new,Tr_new
             else
             write(luout,1310) icount*it_in,E(1),E(2),E(3),E(4),
     >                     ion_Temperature()
             end if
           end if
           call util_flush(luout)

*          **** write out EMOTION data ****
           eave = E(25)/dble(icount+icount_shift)
           evar = E(26)/dble(icount+icount_shift)
           evar = evar - eave*eave
           have = E(27)/dble(icount+icount_shift)
           hvar = E(28)/dble(icount+icount_shift)
           hvar = hvar - have*have
           if (control_Nose()) then
             write(31,1311) icount*it_in*dt + emotion_time_shift,
     >                    e(1),e(2),e(3),e(4),e(5),e(6),
     >                    e(7),e(8),e(9),e(10),
     >                    eave,evar,have,hvar,ion_Temperature(),pressure
           else
             write(31,1311) icount*it_in*dt + emotion_time_shift,
     >                    e(1),e(2),e(3),e(4),e(5),e(6),
     >                    e(7),e(8),
     >                    eave,evar,have,hvar,ion_Temperature(),pressure
           end if
           call util_flush(31)

*          **** write out EIGMOTION data -diagonal hml matrix ****
           if (mulliken) then
           write(32,1311) icount*it_in*dt,
     >       (( dbl_mb(hml(1)+ii-1+(ii-1)*ne(1)+(ms-1)*ne(1)*ne(1)), 
     >         ii=1,ne(ms)),ms=1,ispin)
           call util_flush(32)
           end if

*          **** write out HMOTION data - hml matrix ****
           if (mulliken) then
           write(34,1312) icount*it_in*dt,ispin
           do ms=1,ispin
             write(34,1313) ms,ne(ms),ne(ms)
             do ii=1,ne(ms)
               write(34,1311) 
     >         (dbl_mb(hml(1)+ii-1+(jj-1)*ne(1)+(ms-1)*ne(1)*ne(1)), 
     >          jj=1,ne(ms))
             end do
           end do
           call util_flush(34)
           end if

         end if


*        **** write xyz data ****
         call xyz_write()
         call MOTION_write((icount*it_in*control_time_step()))

*        **** write OMOTION data ****
         if (mulliken) call Orb_Write(dcpl_mb(psi1(1)))

*        **** update thermostats using SA decay ****
         if (SA) then
           if(abs(sa_decay(1)).gt.tollz) 
     *     t1 = icount*it_in*dt/sa_decay(1)
           if(abs(sa_decay(2)).gt.tollz) 
     *     t2 = icount*it_in*dt/sa_decay(2)
           Te_new = Te_init*dexp(-t1)
           Tr_new = Tr_init*dexp(-t2)
           call Nose_reset_T(Te_new,Tr_new)
         end if


*        **** exit early ****
         if (control_out_of_time()) then
            if (taskid.eq.MASTER) 
     >       write(luout,*) ' *** out of time. iteration terminated'
            go to 102
         end if
      if (icount.lt.it_out) go to 101
      if (taskid.eq.MASTER) 
     > write(luout,*)
     > '*** arived at the Maximum iteration.   terminated.'
 
*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::

  102 continue

*     **** close xyz and MOTION files ****
      call xyz_end()
      call MOTION_end()
      if (taskid.eq.MASTER) then
        close(unit=31)
        close(unit=32)
        close(unit=34)

*        **** remove EMOTION backup file ***
         call util_file_name_noprefix('EMOTION99-bak',.false.,
     >                                .false.,
     >                                full_bak)
         call util_file_unlink(full_bak)
      end if

*     *** close fei io ****
      call fei_end()

*     **** close OMOTION file ****
      if (mulliken) call Orb_End()

*     **** ecce print ****
      !call ecce_print_module_exit('driver', 'ok')
      call ecce_print_module_exit('task Car-Parrinello', 'ok')


*     **** finalize pressure ****
      if (calc_pressure) then
         call psp_stress_end()
      end if


      if (taskid.eq.MASTER) CALL nwpw_message(3)
      if (taskid.eq.MASTER) call current_second(cpu3)


*         |****************************************|
*********** produce CHECK file and diagonalize hml *****************
*         |****************************************|

*     **** produce CHECK FILE ****
      if (taskid.eq.MASTER) then
         call util_file_name('CHECK',.true.,
     >                               .false.,
     >                       full_filename)
         open(unit=17,file=full_filename,form='formatted')
      end if

*     **** check total number of electrons ****
      do ms =1,ispin
         call D3dB_r_dsum(1,dbl_mb(dn(1)+(ms-1)*n2ft3d),sumall)
         en(ms) = sumall*lattice_omega()
     >             /dble(ngrid(1)*ngrid(2)*ngrid(3))
      end do
      if (taskid.eq.MASTER) then
         write(17,1320) (en(ms),ms=1,ispin)
      end if

*     **** comparison between hamiltonian an lambda matrix ****
      if (taskid.eq.MASTER) write(17,1330)
      do ms=1,ispin
         do i=1,ne(ms)
         do j=1,ne(ms)
            w   = Dneall_m_value(0,ms,i,j,dbl_mb(hml(1)))
            sum = Dneall_m_value(0,ms,i,j,dbl_mb(lmd(1)))

            if (taskid.eq.MASTER)
     >      write(17,1340) ms,i,j,w,sum,w-sum

         end do
         end do
      end do

*     **** check orthonormality ****
      if (taskid.eq.MASTER) then
         write(17,1350)
      end if

      call Dneall_ffm_Multiply_nopack(0,dcpl_mb(psi1(1)),
     >                           dcpl_mb(psi1(1)),nfft3d,
     >                           dbl_mb(lmd(1)))
      do ms=1,ispin
         do j=1,ne(ms)
         do i=j,ne(ms)
            w  = Dneall_m_value(0,ms,i,j,dbl_mb(lmd(1)))
            if (taskid.eq.MASTER) write(17,1360) ms,i,j,w
         end do
         end do
      end do

*     **** close check file ****
      if (taskid.eq.MASTER) then
         close(17)
      end if



*     ***** do not diagonalize the hamiltonian matrix *****
      if (pspw_SIC()) then
        call dcopy(2*nfft3d*nemaxq,
     >             dcpl_mb(psi1(1)),1,
     >             dcpl_mb(psi2(1)),1)
      
*     ***** diagonalize the hamiltonian matrix *****
      else

c         if (fractional) then
c           call Dneall_m_HmltimesSA(0,dbl_mb(hml(1)),dbl_mb(fweight(1)))
c         end if

         call Dneall_m_diagonalize(0,dbl_mb(hml(1)),
     >                               dbl_mb(eig(1)),.false.)


c         if (fractional) then
c         do ii=1,ne(ms)
c           dbl_mb(eig(1)+(ii-1)+(ms-1)*n)
c     >       =dbl_mb(eig(1)+(ii-1)+(ms-1)*n)
c     >       /dbl_mb(fweight(1)+(ii-1)+(ms-1)*n)
c         end do
c         end if


*        *** rotate current psi ***
         call Dneall_fmf_Multiply_nopack(0,dcpl_mb(psi1(1)),nfft3d,
     >                              dbl_mb(hml(1)),  1.0d0,
     >                              dcpl_mb(psi2(1)),0.0d0)


*        *** rotate current v_psi ***
         call dcopy(2*nfft3d*nemaxq,dcpl_mb(psi0(1)),1,
     >                              dcpl_mb(psi1(1)),1)

         call Dneall_fmf_Multiply_nopack(0,dcpl_mb(psi1(1)),nfft3d,
     >                              dbl_mb(hml(1)),  1.0d0,
     >                              dcpl_mb(psi0(1)),0.0d0)

      end if



*                |***************************|
****************** report summary of results **********************
*                |***************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)

      if (taskid.eq.MASTER) then
         call print_elapsed_time(icount*it_in*dt)
         write(luout,1300)
         write(luout,1410)
         write(luout,1420)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(6,1193) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz


         write(luout,1421)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
         write(luout,1211) ion_nconstraints(),ion_ndof()


         write(luout,*)
         write(luout,1320) en(1),en(ispin),' (real space)'
         write(luout,1430) E(2),E(2)/ion_nion()
         write(luout,1440) E(5),E(5)/n2(ispin)
         write(luout,1450) E(6),E(6)/n2(ispin)
         write(luout,1460) E(7),E(7)/n2(ispin)
         if (pspw_SIC()) then
           write(luout,1455) E(16),E(16)/n2(ispin)
           write(luout,1456) E(17),E(17)/n2(ispin)
         end if
         if (pspw_HFX()) then
           write(luout,1457) E(20),E(20)/n2(ispin)
         end if
         if (psp_U_psputerm()) then
           write(luout,1458) E(29),E(29)/n2(ispin)
         end if
         if (meta_found()) then
           write(luout,1459) E(31),E(31)/ion_nion()
         end if
         if (tamd_found()) then
           write(luout,1461) E(34),E(34)/ion_nion()
         end if
         write(luout,1470) E(8),E(8)/ion_nion()
         write(luout,1471) E(3),E(3)/n2(ispin)
         write(luout,1472) ion_ke(),ion_ke()/ion_nion()


         if (pspw_qmmm_found()) then
            write(luout,1700)
            write(luout,1701)
            write(luout,1702) E(11)
            write(luout,1703) E(12)
            write(luout,1704) E(13)
c            write(luout,1705) E(14)
c            write(luout,1706) E(15)
         end if
        if (ion_disp_on()) then
            write(luout,1720) E(33)
        end if


         if (control_Nose()) then
           write(luout,1473) E(9),E(9)/n2(ispin)
           write(luout,1474) E(10),E(10)/ion_nion()
         end if
         write(luout,1226) E(3),ion_ke(),ion_com_ke()
         eke = eke/dble(it_out)
         eke = 2.0d0*eke/kb/(ne(1)+ne(ispin))/pack_nwave_all(1)
         !eke = 2.0d0*eke/kb/(ne(1)+ne(ispin))

*       **** write out Temperatures ****
         write(luout,1491) eke
         eki0 = ion_Temperature()
c         if (pspw_qmmm_found()) then
c            eki1 =pspw_qmmm_Temperature()
c            sum = ion_nion() + pspw_qmmm_nion() - 2.0d0
c            eki0 = eki0*((ion_nion()-2.0d0)/sum)
c     >           + eki1*((pspw_qmmm_nion()-2.0d0)/sum)
c         end if
         write(luout,1480) eki0
         write(luout,1490) ion_com_Temperature()

         eave = E(25)/dble(icount+icount_shift)
         evar = E(26)/dble(icount+icount_shift)
         evar = evar - eave*eave
         have = E(27)/dble(icount+icount_shift)
         hvar = E(28)/dble(icount+icount_shift)
         hvar = hvar - have*have
         cv = (evar)/(kb*ion_Temperature()**2)
         cv = cv/dble(ion_nion())
         write(luout,1492) eave,have
         write(luout,1493) evar,hvar
         write(luout,1494) cv

*        **** write out diagonal <psi|H|psi> matrix ****
         if (pspw_SIC()) then

           n = ne(1)
           nn = n*n
           do ms=1,ispin
             if (ms.eq.1) write(luout,1331)
             if (ms.eq.2) write(luout,1332)
             !*** call Gainsville matrix output ***
             call output(dbl_mb(hml(1)+(ms-1)*nn),
     >                    1,ne(ms),1,ne(ms),
     >                    n,n,1)
           end do


*        **** write out KS eigenvalues ****
         else
         write(luout,1500)
         NN=NE(1)-NE(2)
         EV=27.2116d0

         if (fractional) then
           do i=1,NN
             write(luout,1511) dbl_mb(EIG(1)+i-1),
     >                     dbl_mb(EIG(1)+i-1)*EV,
     >                     dbl_mb(occ2(1)+i-1)
           end do
           do i=1,ne(2)
             write(luout,1511) dbl_mb(EIG(1)+i-1+NN),
     >                     dbl_mb(EIG(1)+i-1+NN)*EV,
     >                     dbl_mb(occ2(1)+i-1+NN),
     >                     dbl_mb(EIG(1)+i-1+n1(2)-1),
     >                     dbl_mb(EIG(1)+i-1+n1(2)-1)*EV,
     >                     dbl_mb(occ2(1)+i-1+n1(2)-1)
           end do
         else
           do i=1,NN
             write(luout,1510) dbl_mb(EIG(1)+i-1),dbl_mb(EIG(1)+i-1)*EV
           end do
           do i=1,ne(2)
             write(luout,1510) dbl_mb(EIG(1)+i-1+NN),
     >                     dbl_mb(EIG(1)+i-1+NN)*EV,
     >                     dbl_mb(EIG(1)+i-1+n1(2)-1),
     >                     dbl_mb(EIG(1)+i-1+n1(2)-1)*EV
           end do
         end if

         end if

*        *** Extra energy output added for QA test ****
         write(luout,1600) E(2)
      end if

*                |***************************|
******************         Prologue          **********************
*                |***************************|

c*     **** calculate spin contamination ****
c      call Calculate_psi_spin2(ispin,ne,npack1,dcpl_mb(psi2(1)),
c     >                         fractional,dbl_mb(occ2(1)),
c     >                         dipole)

*     **** calculate the Dipole ***
      call Calculate_Dipole(ispin,ne,n2ft3d,dbl_mb(dn(1)),dipole)

      
*     ***** write wavefunctions and v_wavefunctions ****
      call psi_write(ispin,ne,dcpl_mb(psi2(1)),
     >               smearoccupation,dbl_mb(occ2(1)))
      call v_psi_write(ispin,ne,dcpl_mb(psi0(1)))

*     **** write geometry to rtdb ****
      call ion_write(rtdb)

*     **** deallocate heap memory ****
      if (control_version().eq.3) call ewald_end()
      call strfac_end()
      if (controL_version().eq.3) call coulomb_end()
      if (controL_version().eq.4) call coulomb2_end()
      call ke_end()
      call mask_end()
      call Pack_end()
      call G_end()
      call ion_end()
      call psp_end()
      call ion_end_FixIon()
      call psp_U_end()
      call nwpw_meta_gga_end()
      call pspw_end_SIC()
      call pspw_end_HFX()
      call pspw_qmmm_end()
      call meta_finalize(rtdb)
      call tamd_finalize(rtdb)
      call dplot_iteration_end()
c      call frac_occ_end()
      if (control_Nose()) call Nose_end()

      value = MA_free_heap(psir(2))
      value = MA_free_heap(Hpsi(2))
      value = MA_free_heap(dn(2))
      value = MA_free_heap(eig(2))
      value = Dneall_m_free(hml)
      value = Dneall_m_free(lmd)
      value = MA_free_heap(psi0(2))
      value = MA_free_heap(psi1(2))
      value = MA_free_heap(psi2(2))
      if (fractional) then
      value = MA_free_heap(occ0(2))
      value = MA_free_heap(occ1(2))
      value = MA_free_heap(occ2(2))
      end if
      call D3dB_pfft_end()
      call D3dB_end(1)
      if (control_version().eq.4) call D3dB_end(2)
      call Dne_end()
      call psi_data_end()

*     **** do anaylysis on MOTION files ****
      call cpmd_properties(rtdb)


*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (taskid.eq.MASTER) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(icount*it_in)
         write(luout,*)
         write(luout,*) '-----------------'
         write(luout,*) 'cputime in seconds'
         write(luout,*) 'prologue    : ',T1
         write(luout,*) 'main loop   : ',T2
         write(luout,*) 'epilogue    : ',T3
         write(luout,*) 'total       : ',T4
         write(luout,*) 'cputime/step: ',AV
         write(luout,*)

         call nwpw_timing_print_final(.true.,(icount*it_in))
         CALL nwpw_message(4)
      end if 


      call Parallel2d_Finalize()
      call Parallel_Finalize()
      cpmdv5 = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*  Car-Parrinello-Rahman microcluster calculation  *')
 1030 FORMAT(10X,'*      [   extended Lagrangian molecular   ]       *')
 1031 FORMAT(10X,'*      [        dynamics simulation        ]       *')
 1035 FORMAT(10x,'*      [ NorthWest Chemistry implementation ]      *')
 1040 FORMAT(10X,'*            version #5.00   06/01/99              *')
 1041 FORMAT(10X,'*  This code was developed by Eric J. Bylaska.     *')
 1042 FORMAT(10X,'*  The code uses a stripped down pspw infra-       *')
 1043 FORMAT(10X,'*  structure (no packing) because unitcell changes *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I10)
 1112 FORMAT( ' parallel mapping         :      1d slab')
 1113 FORMAT( ' parallel mapping         :   2d hilbert')
 1114 FORMAT( ' parallel mapping         :     balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1117 FORMAT( ' processor grid           :',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         :    2d hcurve')
 1119 FORMAT( ' parallel io              :        on')
 1120 FORMAT( ' parallel io              :       off')
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I1)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i2)
 1153 FORMAT(12X,' local potential used           : ',i2)
 1154 FORMAT(12X,' number of non-local projections: ',i2)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1159 FORMAT(/' total charge=',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I5))
 1180 FORMAT(/' initial position of ions:')
 1181 FORMAT(/' initial velocity of ions:')
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5  ,' (',3F11.5,
     >       ' ) - atomic mass= ',F6.3,' - fixed')
 1192 FORMAT(5X, I4, A5  ,' (',3F11.5,' )')
 1193 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - z fixed')

 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1211 FORMAT(5X,'   number of constraints = ', I6,' ( DOF = ',I6,' )' )
 1219 FORMAT(/' number of electrons: spin up=',F6.2,'  down=',F6.2,A)
 1220 FORMAT(/' number of electrons: spin up=',I6,
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1221 FORMAT( ' number of orbitals : spin up=',I6,
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1222 format(5x,' initial kinetic energy: ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)',/50x,
     >                                      e12.5,' (c.o.m.)')
 1223 format(5x,' after scaling:          ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)')
 1224 format(5x,' increased energy:       ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)')
 1226 format(/' final kinetic energy:  ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)',/44x,
     >                                      e12.5,' (c.o.m.)')
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,' volume : ',F12.1)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1250 FORMAT(5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
  
 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters:')
 1271 FORMAT(5x, ' translation constrained')
 1272 FORMAT(5x, ' rotation constrained')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' cooling/heatting rates: ',e12.5,' (psi)',2x,
     >                                       e12.5,' (ion)')
 
 1293 format(/' Pressure Output Generated         ')
 1294 format(/' Constant Energy Simulation                     ')
 1295 format(/' Nose-Hoover Simulation - Thermostat Parameters:')
 1296 format(5x, 'SA decay rates  =',e10.3,' (elc)',e10.3,' (ion)')
 1297 format(5x, 'link = ',I3,
     > ' Te =',f8.2,' Qe =',e10.3,' 2*pi/we=',e10.3,' Ee0=',e10.3)
 1298 format(5x, 'link = ',I3,
     > ' Tr =',f8.2,' Qr =',e10.3,' 2*pi/wr=',e10.3,' Er0=',e10.3)
 1299 format(//' Mulliken Analysis Output Generated            ')
 1300 FORMAT(//)
 1305 FORMAT(10X,'============ Car-Parrinello iteration ==============')
 1309 FORMAT(I8,2E19.10,2E14.5,2F9.1,3E11.3)
 1310 FORMAT(I8,2E19.10,2E14.5,F14.2,3E11.3)
 1311 format(100e19.10)
 1312 format(e14.6,i3)
 1313 format(3i4)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1331 FORMAT(/' Elements of Hamiltonian matrix (up/restricted)')
 1332 FORMAT(/' Elements of Hamiltonian matrix (down)')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1341 FORMAT(I3,2I3,' H=',E16.6)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT(/' final position of ions:')
 1421 FORMAT(/' final velocity of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1455 FORMAT( ' SIC-hartree energy  :',E19.10,' (',E15.5,'/electron)')
 1456 FORMAT( ' SIC-exc-corr energy :',E19.10,' (',E15.5,'/electron)')
 1457 FORMAT( ' HF exchange energy  :',E19.10,' (',E15.5,'/electron)')
 1458 FORMAT( ' DFT+U     energy    :',E19.10,' (',E15.5,'/ion)')
 1459 FORMAT( ' Metadynamics energy :',E19.10,' (',E15.5,'/ion)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1461 FORMAT( ' TAMD energy         :',E19.10,' (',E15.5,'/ion)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1471 FORMAT(/' Kinetic energy (elc)    :',E19.10,' (',E15.5,'/elc)')
 1472 FORMAT( ' Kinetic energy (ion)    :',E19.10,' (',E15.5,'/ion)')
 1473 FORMAT( ' thermostat energy (elc) :',E19.10,' (',E15.5,'/elc)')
 1474 FORMAT( ' thermostat energy (ion) :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(' Temperature :    ',F10.1,' K (ion)')
 1490 FORMAT('             :    ',F10.1,' K (c.o.m.)')
 1491 FORMAT(' Temperature :    ',F10.1,' K (elc)')
 1492 FORMAT(/' Vaverage  Eaverage :    ',E19.10, E19.10)
 1493 FORMAT( ' Vvariance Evariance:    ',E19.10, E19.10)
 1494 FORMAT( ' Cv - f*kb/(2*nion) :    ',E19.10)
 1499 FORMAT( ' K.S. SIC-hartree energy  :',E19.10,
     >        ' (',E15.5,'/electron)')
 1501 FORMAT( ' K.S. SIC-exc-corr energy :',E19.10,
     >        ' (',E15.5,'/electron)')
 
 1500 FORMAT(/' orbital energies:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1511 FORMAT(2(E18.7,' (',F8.3,'eV) occ=',F6.3))
 1600 FORMAT(/' Total PSPW energy   :',E19.10)

 1700 FORMAT(/' QM/MM-pol-vib/CAV Energies')
 1701 FORMAT( ' --------------------------')
 1702 FORMAT( ' LJ energy              :',E19.10)
 1703 FORMAT( ' Residual Coulomb energy:',E19.10)
 1704 FORMAT( ' MM Vibration energy    :',E19.10)
 1705 FORMAT( ' MM Vibration energy    :',E19.10)
 1706 FORMAT( ' (QM+MM)/Cavity energy  :',E19.10)

 1720 FORMAT(/' Dispersion energy   :',E19.10)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(luout,9010) ierr
      call Parallel2d_Finalize()
      call Parallel_Finalize()

      cpmdv5 = value
      return
      END

c
c Now in nwpw/utilities
c
c      subroutine print_elapsed_time(autime)
c      implicit none
c      real*8 autime
c
c#include "stdio.fh"
c
c      real*8 sectime
c
c      sectime = autime*2.41889d-17
c
c      if (sectime.lt.1.0d-12) then
c         write(luout,1800) (sectime/1.0d-15)," fs"
c      else if (sectime.lt.1.0d-9) then
c         write(luout,1800) (sectime/1.0d-12)," ps"
c      else 
c         write(luout,1800) (sectime/1.0d-9 )," ns"
c      end if
c
c      return
c 1800 format(//' Elapsed time of simulation was',F8.3,A)
c      end

      subroutine argos_cafe_rddrs(lfntop,idrs,rdrs)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer lfntop
      integer idrs(ndrs,2)
      real*8 rdrs(ndrs,6)
c
      integer i,j
c
      if(me.eq.0) then
      do 1 i=1,ndrs
      read(lfntop,1000) (idrs(i,j),j=1,2),(rdrs(i,j),j=1,5)
 1000 format(2i10,3f12.6,/,20x,2e12.5)
      rdrs(i,6)=zero
    1 continue
      endif
c
      call ga_sync()
      call ga_brdcst(mcf_57,idrs,ma_sizeof(mt_int,ndrs*2,mt_byte),0)
      call ga_brdcst(mcf_58,rdrs,ma_sizeof(mt_dbl,ndrs*6,mt_byte),0)
c
      return
      end
c $Id: argos_cafe_rddrs.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine esp_grdcnt(x,q)
c
c $Id: esp_grdcnt.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "esp_params.fh"
#include "esp_common.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      real*8 x(3,natoms),q(natoms),g(3)
c
      integer i,ia,ix,iy,iz
      real*8 d,dmin,rad2,rcut2
c
      mxgrid=0
      if(me.eq.0) then
      rcut2=rcut*rcut
      mxgrid=1
      do 1 iz=0,mgrid(3)+1
      do 2 iy=0,mgrid(2)+1
      do 3 ix=0,mgrid(1)+1
      g(1)=xmin(1)-rcut+dble(ix)*spac
      g(2)=xmin(2)-rcut+dble(iy)*spac
      g(3)=xmin(3)-rcut+dble(iz)*spac
      dmin=rcut2
      ia=1
      do 4 i=1,natoms
      rad2=(cnm2au*radius(int(q(i))))**2
      d=(g(1)-x(1,i))*(g(1)-x(1,i))
     + +(g(2)-x(2,i))*(g(2)-x(2,i))
     + +(g(3)-x(3,i))*(g(3)-x(3,i))
c      if(d.lt.rad2) goto 3
       if(rad2-d.gt.small) goto 3
c      if(d.lt.dmin) dmin=d
      if(dmin-d.gt.small) dmin=d
    4 continue
c      if(dmin.lt.rcut2) then
      if(rcut2-dmin.gt.small) then
      mxgrid=mxgrid+1
      endif
    3 continue
    2 continue
    1 continue
      endif
c
      if(np.gt.0) then
      call ga_brdcst(mre_001,mxgrid,ma_sizeof(mt_int,1,mt_byte),0)
      endif
c
      return
      end

      SUBROUTINE ccsdtq_lambda1_21_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lambda1_21_3.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 p15 p18 p19 h13 h14 h16 h17 )_vt + = -1/3 * Sum ( h10 p6 ) * t ( p6 p15 p18 p19 h10 h13 h14 h16 )_t * i2 ( h2 h10 h17 p6 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p15b
      INTEGER p18b
      INTEGER p19b
      INTEGER h13b
      INTEGER h14b
      INTEGER h16b
      INTEGER h17b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER h10b
      INTEGER p15b_1
      INTEGER p18b_1
      INTEGER p19b_1
      INTEGER p6b_1
      INTEGER h13b_1
      INTEGER h14b_1
      INTEGER h16b_1
      INTEGER h10b_1
      INTEGER h2b_2
      INTEGER h10b_2
      INTEGER h17b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h2b = 1,noab
      DO p15b = noab+1,noab+nvab
      DO p18b = p15b,noab+nvab
      DO p19b = p18b,noab+nvab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      DO h16b = h14b,noab
      DO h17b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p15b-
     &1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+p19b-1)+int_mb(k_spin+h13b-
     &1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+h17b-
     &1).ne.16)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p15b-1)+int_mb(k_spin+p18b-
     &1)+int_mb(k_spin+p19b-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+
     &h14b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+h17b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p15b-1),ieor(int_mb
     &(k_sym+p18b-1),ieor(int_mb(k_sym+p19b-1),ieor(int_mb(k_sym+h13b-1)
     &,ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h16b-1),int_mb(k_sym+
     &h17b-1)))))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p15b-1) * int_mb(k_r
     &ange+p18b-1) * int_mb(k_range+p19b-1) * int_mb(k_range+h13b-1) * i
     &nt_mb(k_range+h14b-1) * int_mb(k_range+h16b-1) * int_mb(k_range+h1
     &7b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_21_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      DO h10b = 1,noab
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+p19b
     &-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+
     &h14b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p18b-1),ieor(int_m
     &b(k_sym+p19b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(k_sym+h13b-1)
     &,ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h16b-1),int_mb(k_sym+
     &h10b-1)))))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_8(p15b,p18b,p19b,p6b,h13b,h14b,h16b,h10b,p15b_
     &1,p18b_1,p19b_1,p6b_1,h13b_1,h14b_1,h16b_1,h10b_1)
      CALL TCE_RESTRICTED_4(h2b,h10b,h17b,p6b,h2b_2,h10b_2,h17b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1) * int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p15b-1) * int_mb(k_range+p18b-1) * int_
     &mb(k_range+p19b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+h14b-
     &1) * int_mb(k_range+h16b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h17b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_21_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_21_3',2,MA_ERR)
      IF ((p6b .le. p15b) .and. (h10b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (h10b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p15b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p15b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h10b-1),int_mb(k_range+h13b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,6,4,3,2,5,1,1.0d0)
      END IF
      IF ((p6b .le. p15b) .and. (h13b .lt. h10b) .and. (h10b .le. h14b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h10b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p15b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p15b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h10b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,5,4,3,2,6,1,-1.0d0)
      END IF
      IF ((p6b .le. p15b) .and. (h14b .lt. h10b) .and. (h10b .le. h16b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p15b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p15b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &10b-1),int_mb(k_range+h16b-1),8,6,5,4,3,2,7,1,1.0d0)
      END IF
      IF ((p6b .le. p15b) .and. (h16b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p15b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p15b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &16b-1),int_mb(k_range+h10b-1),7,6,5,4,3,2,8,1,-1.0d0)
      END IF
      IF ((p15b .lt. p6b) .and. (p6b .le. p18b) .and. (h10b .le. h13b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (h10b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p6b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h10b-1),int_mb(k_range+h13b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,6,4,3,1,5,2,-1.0d0)
      END IF
      IF ((p15b .lt. p6b) .and. (p6b .le. p18b) .and. (h13b .lt. h10b) .
     &and. (h10b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h10b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p6b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h10b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,5,4,3,1,6,2,1.0d0)
      END IF
      IF ((p15b .lt. p6b) .and. (p6b .le. p18b) .and. (h14b .lt. h10b) .
     &and. (h10b .le. h16b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p6b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &10b-1),int_mb(k_range+h16b-1),8,6,5,4,3,1,7,2,-1.0d0)
      END IF
      IF ((p15b .lt. p6b) .and. (p6b .le. p18b) .and. (h16b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab 
     &* (p6b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p18b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &16b-1),int_mb(k_range+h10b-1),7,6,5,4,3,1,8,2,1.0d0)
      END IF
      IF ((p18b .lt. p6b) .and. (p6b .le. p19b) .and. (h10b .le. h13b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (h10b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p6b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h10b-1),int_mb(k_range+h13b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,6,4,2,1,5,3,1.0d0)
      END IF
      IF ((p18b .lt. p6b) .and. (p6b .le. p19b) .and. (h13b .lt. h10b) .
     &and. (h10b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h10b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p6b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h10b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,5,4,2,1,6,3,-1.0d0)
      END IF
      IF ((p18b .lt. p6b) .and. (p6b .le. p19b) .and. (h14b .lt. h10b) .
     &and. (h10b .le. h16b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p6b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &10b-1),int_mb(k_range+h16b-1),8,6,5,4,2,1,7,3,1.0d0)
      END IF
      IF ((p18b .lt. p6b) .and. (p6b .le. p19b) .and. (h16b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p19b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p6b-1),int_mb(k_range+p19b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &16b-1),int_mb(k_range+h10b-1),7,6,5,4,2,1,8,3,-1.0d0)
      END IF
      IF ((p19b .lt. p6b) .and. (h10b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (h10b_1 -
     & 1 + noab * (p6b_1 - noab - 1 + nvab * (p19b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p19b-1),int_mb(k_range+p6b
     &-1),int_mb(k_range+h10b-1),int_mb(k_range+h13b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,6,3,2,1,5,4,-1.0d0)
      END IF
      IF ((p19b .lt. p6b) .and. (h13b .lt. h10b) .and. (h10b .le. h14b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h10b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p6b_1 - noab - 1 + nvab * (p19b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p19b-1),int_mb(k_range+p6b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h10b-1),int_mb(k_range+h
     &14b-1),int_mb(k_range+h16b-1),8,7,5,3,2,1,6,4,1.0d0)
      END IF
      IF ((p19b .lt. p6b) .and. (h14b .lt. h10b) .and. (h10b .le. h16b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p6b_1 - noab - 1 + nvab * (p19b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p19b-1),int_mb(k_range+p6b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &10b-1),int_mb(k_range+h16b-1),8,6,5,3,2,1,7,4,-1.0d0)
      END IF
      IF ((p19b .lt. p6b) .and. (h16b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p6b_1 - noab - 1 + nvab * (p19b_1 - noab - 1 + nvab *
     & (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p19b-1),int_mb(k_range+p6b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h
     &16b-1),int_mb(k_range+h10b-1),7,6,5,3,2,1,8,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_21_3',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_21_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_21_3',5,MA_ERR)
      IF ((h17b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (h17b_2 - 1 + noab * (h10b_2 - 1 + noab * (h2
     &b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h17b-1),int_mb(k_range+p6b-
     &1),3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_21_3',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_21_3
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_21_3
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_21_3',9,MA_ERR)
      IF ((h16b .le. h17b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h17b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h16b-1),int_mb(k_range+h14b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+p19b-1),int_mb(k_range+p
     &18b-1),int_mb(k_range+p15b-1),2,8,7,6,5,4,3,1,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h17b 
     &- 1 + noab * (h16b - 1 + noab * (h14b - 1 + noab * (h13b - 1 + noa
     &b * (p19b - noab - 1 + nvab * (p18b - noab - 1 + nvab * (p15b - no
     &ab - 1 + nvab * (h2b - 1)))))))))
      END IF
      IF ((h17b .le. h13b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h17b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h16b-1),int_mb(k_range+h14b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+p19b-1),int_mb(k_range+p
     &18b-1),int_mb(k_range+p15b-1),2,8,7,6,1,5,4,3,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (h17b - 1 + noa
     &b * (p19b - noab - 1 + nvab * (p18b - noab - 1 + nvab * (p15b - no
     &ab - 1 + nvab * (h2b - 1)))))))))
      END IF
      IF ((h13b .le. h17b) .and. (h17b .le. h14b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h17b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h16b-1),int_mb(k_range+h14b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+p19b-1),int_mb(k_range+p
     &18b-1),int_mb(k_range+p15b-1),2,8,7,6,5,1,4,3,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h17b - 1 + noab * (h13b - 1 + noa
     &b * (p19b - noab - 1 + nvab * (p18b - noab - 1 + nvab * (p15b - no
     &ab - 1 + nvab * (h2b - 1)))))))))
      END IF
      IF ((h14b .le. h17b) .and. (h17b .le. h16b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h17b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h16b-1),int_mb(k_range+h14b
     &-1),int_mb(k_range+h13b-1),int_mb(k_range+p19b-1),int_mb(k_range+p
     &18b-1),int_mb(k_range+p15b-1),2,8,7,6,5,4,1,3,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h17b - 1 + noab * (h14b - 1 + noab * (h13b - 1 + noa
     &b * (p19b - noab - 1 + nvab * (p18b - noab - 1 + nvab * (p15b - no
     &ab - 1 + nvab * (h2b - 1)))))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_21_3',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_21_3
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

C $Id: potset_nwchem.F 19708 2010-10-29 18:04:21Z d3y133 $
      subroutine potset_nwchem(rtdb)
*
* check for basis sets and theoretical method
*
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "bas.fh"
#include "rtdb.fh"
*::passed:
      integer rtdb
*::local:
      character*32 theory
      logical okay
*
      okay = .true.
*
      okay = okay.and.bas_rtdb_in(rtdb)
      if (.not.okay) then
        write(luout,*)' no basis set info on rtdb '
        call util_flush(luout)
        call errquit('potset_nwchem: fatal error ',911, RTDB_ERR)
      endif
      if (.not.rtdb_cget(rtdb,'drdy:theory',1,theory)) then
        write(luout,*)' default theory for drdy set to scf '
        call util_flush(luout)
        theory = 'scf'
        if (.not.rtdb_cput(rtdb,'drdy:theory',1,theory))
     &        call errquit('potset_nwchem: could not set theory',911,
     &       RTDB_ERR)
      endif
      end

      SUBROUTINE ccsdtq_lambda2_30_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lambda2_30_3.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 h4 p15 h13 h14 p1 )_yttt + = 1 * Sum ( h6 ) * t ( p15 h6 )_t * i2 ( h3 h4 h6 h13 h14 p1 )_ytt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p15b
      INTEGER p1b
      INTEGER h13b
      INTEGER h14b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h6b
      INTEGER p15b_1
      INTEGER h6b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER h6b_2
      INTEGER p1b_2
      INTEGER h13b_2
      INTEGER h14b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p15b = noab+1,noab+nvab
      DO p1b = noab+1,noab+nvab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p15b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+h13b-1)
     &+int_mb(k_spin+h14b-1).ne.12)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+p15b-1
     &) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h1
     &4b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p15b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+h13b-1),i
     &nt_mb(k_sym+h14b-1)))))) .eq. ieor(irrep_y,ieor(irrep_t,ieor(irrep
     &_t,irrep_t)))) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p15b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+h13b-1) * int
     &_mb(k_range+h14b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_30_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h6b = 1,noab
      IF (int_mb(k_spin+p15b-1) .eq. int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),int_mb(k_sym+h6b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p15b,h6b,p15b_1,h6b_1)
      CALL TCE_RESTRICTED_6(h3b,h4b,h6b,p1b,h13b,h14b,h3b_2,h4b_2,h6b_2,
     &p1b_2,h13b_2,h14b_2)
      dim_common = int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p15b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+h14b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_30_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_30_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (p15b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+h6b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_30_3',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_30_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_30_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h14b_
     &2 - 1 + noab * (h13b_2 - 1 + noab * (p1b_2 - noab - 1 + nvab * (h6
     &b_2 - 1 + noab * (h4b_2 - 1 + noab * (h3b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),6,5,4,2,1,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_30_3',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_30_3
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_30_3
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_30_3',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+p1b-1),int_mb(k_range+h4b-
     &1),int_mb(k_range+h3b-1),int_mb(k_range+p15b-1),5,4,6,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h14b 
     &- 1 + noab * (h13b - 1 + noab * (p1b - noab - 1 + nvab * (p15b - n
     &oab - 1 + nvab * (h4b - 1 + noab * (h3b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_30_3',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_30_3
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      program test
C$Id: test_ilist.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "inp.fh"
      character*30 aval
      integer i, ival, ival2, ival3, line, N, maxlist, j
      Parameter (MaxList = 100)
      Integer List(MaxList)
      double precision dval
c
      line = 0
      call inp_init(5,6)
 10   if (inp_read()) then
         line = line + 1
         call inp_outrec()
c$$$         do i = 1, inp_n_field()
            if (inp_ilist(MaxList, List, N)) then
               write(6,6) line, i, N, (List(j), j=1, N)
 6             format(' line=',i2,', field=',i2,', elements=',i8,
     $            /' data = ', 7i8/(8X,7i8))
            Else
               Write (6, 6) line, i, n
               Call Inp_ErrOut()
            EndIf
c$$$            Elseif (inp_i(ival)) then
c$$$               write(6,1) line, i, ival
c$$$ 1             format(' line=',i2,', field=',i2,', integer=',i8)
c$$$            Elseif (inp_irange(ival, ival2, ival3)) then
c$$$               write(6,5) line, i, ival, ival2, ival3
c$$$ 5             format(' line=',i2,', field=',i2,', integers=',3i8)
c$$$            else if (inp_f(dval)) then
c$$$               write(6,2) line, i, dval
c$$$ 2             format(' line=',i2,', field=',i2,', double=',1pd9.2)
c$$$            else if (inp_a(aval)) then
c$$$               write(6,3) line, i, aval
c$$$ 3             format(' line=',i2,', field=',i2,', string=',a)
c$$$            else
c$$$               write(6,4) line, i
c$$$ 4             format(' line=',i2,', field=',i2,', error!')
c$$$               call inp_errout()
c$$$            endif
c$$$         enddo
         goto 10
      else 
         if (inp_eof()) then
            write(6,*) ' EOF detected at line ', line
         else
            write(6,*) ' input failed at line ', line
         endif
         call inp_errout()
      endif
c
      end

c
c     $Id: perfm_flop.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      double precision function perfm_flop()
      implicit none
#include "perfm.fh"
#ifdef USE_PAPI
      integer ii
      integer*4 arg1
      if(lfailed) then
	perfm_flop=0d0
        return
      endif
#ifdef PAPI_FPINS
      call PAPIf_flips( real_time, proc_time, flpins, mflops, retval )
      perfm_flop=flpins*conv2m
!      if (retval .NE. PAPI_OK) call 
!     $ perfm_error(retval,
!     $ ' perfm_start: could not init papi flpins ')
#else
c
c     addtional papi events
c
#endif
#else
      perfm_flop=0d0
#endif
      return
      end

      integer function tce_diis_switch(iter)
c
c $Id: tce_diis_switch.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Returns DIIS order
c
      implicit none
#include "tce_diis.fh"
c      integer iter
c
      if (diis .le. 0) then
        tce_diis_switch = 0
        return
      endif
      if (mod(iter,2) .ne. 0) then
        tce_diis_switch = 0
        return
      endif
      if (iter .lt. 20) then
        tce_diis_switch = min(diis,iter)
      else
        tce_diis_switch = diis
      endif
      return
      end

      logical function argos_prepare_dihsel(catm,nparms,nparmsp,matm,
     + natm,
     + ldih,mdih,ndih)
c
c $Id: argos_prepare_dihsel.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_prepare_common.fh"
c
      integer argos_prepare_atnum
      external argos_prepare_atnum
c
      integer matm,natm,mdih,ndih,nparms,nparmsp
      integer ldih(4,mdih)
      character*6 catm(nparmsp,matm)
c
      integer i,j,nd
c
      if(ffield(1:6).eq.'gromos') then
c
      nd=ndih
      ndih=0
      do 1 i=1,nd
      do 2 j=1,ndih
      if(ldih(2,i).eq.ldih(2,j).and.ldih(3,i).eq.ldih(3,j)) then
      if(argos_prepare_atnum(catm(1,ldih(1,
     + i)))+argos_prepare_atnum(catm(1,ldih(4,i))).lt.
     + argos_prepare_atnum(catm(1,ldih(1,
     + j)))+argos_prepare_atnum(catm(1,ldih(4,j)))) then
      ldih(2,i)=ldih(2,j)
      ldih(4,i)=ldih(4,j)
      endif
      goto 1
      endif
    2 continue
      ndih=ndih+1
      ldih(1,ndih)=ldih(1,i)
      ldih(2,ndih)=ldih(2,i)
      ldih(3,ndih)=ldih(3,i)
      ldih(4,ndih)=ldih(4,i)
    1 continue
      endif
c
      argos_prepare_dihsel=.true.
c
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c FNAME - filename for test program
c
#define BASE_NAME  'da.try'
#define BASE_NAME1 'da1.try'
#ifdef  HPIODIR
#  define FNAME   HPIODIR//BASE_NAME
#  define FNAME1  HPIODIR//BASE_NAME1
#else
#  define FNAME   BASE_NAME
#  define FNAME1  BASE_NAME1
#endif

      program io
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
      integer status, me
      integer max_arrays
      integer stack, heap
      double precision max_sz, max_disk, max_mem 
      data max_arrays, max_sz, max_disk, max_mem /10,1d9,1d10, 1d6/
#if   defined(IBM)|| defined(CRAY_T3E)
      data stack, heap /6000000, 4000000/
#else
      data stack, heap /1200000, 800000/
#endif
c
#include "mp3.fh"
      if(.not. ga_uses_ma())then
         stack = 10000 
         heap  = 10000 
      endif
c
      if(ma_init(MT_F_DBL, stack, heap) ) then
        call ga_initialize()
        me    = ga_nodeid()
        if(dra_init(max_arrays, max_sz, max_disk, max_mem).ne.0)then
                call ga_error('dra_init failed: ',0)
        endif
        if (me.eq.0) print *,'  '
        if(me.eq.0)print *, 'TESTING PERFORMANCE OF DISK ARRAYS'
        if (me.eq.0) print *,' '
        call test_io_dbl()
        status = dra_terminate()
        call ga_terminate()
      else
        print *,'ma_init failed'
      endif
      if(me.eq.0)print *, 'all done ...'
      call MP_FINALIZE()
      end



      subroutine test_io_dbl
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
#include "mp3def.fh"
      integer n,m
      parameter (n=10000)
      parameter (m = 2*n)
      double precision   err, tt0, tt1, mbytes
      integer g_a, g_b,  d_a, d_b
      double precision drand
      integer i,j, req, loop
      integer dilo,dihi,djlo,djhi
      integer gilo,gihi,gjlo,gjhi
      integer ielem, jelem
      integer me, nproc
      integer index, ld
      integer iran
      logical status
      integer util_mdtob
      external  drand
      external util_mdtob
      intrinsic int, dble
      iran(i) = int(drand(0)*dble(i-1)) + 1
c    
      loop  = 30
      req = -1
      nproc = ga_nnodes()
      me    = ga_nodeid()
c    
      if (me.eq.0) print *, 'creating global arrays ',n,' x',n
      if (me.eq.0)call ffflush(6)
      call ga_sync()
      if(.not. ga_create(MT_DBL, n, n, 'a', 1, 1, g_a))
     &         call ga_error('ga_create failed: a', 0)
      if(.not. ga_create(MT_DBL, n, n, 'b', 1, 1, g_b))
     &         call ga_error('ga_create failed: b', 0)
      if (me.eq.0) print *,'done '
      if (me.eq.0)call ffflush(6)
c
c     initialize g_a, g_b with random values
c     ... use ga_access to avoid allocating local buffers for ga_put
c
      call ga_sync()
      call ga_distribution(g_a, me, gilo,gihi,gjlo,gjhi)
      call ga_access(g_a, gilo,gihi,gjlo,gjhi, index, ld)
      call fill_random(DBL_MB(index), gihi-gilo+1, gjhi-gjlo+1, ld)
      call ga_sync()
*     if (me.eq.0) print *,'done '
*     if (me.eq.0)call ffflush(6)
c
      call ga_zero(g_b)
c
c
c.......................................................................
      if (me.eq.0) print *, 'creating disk array ',n,' x',n
      if (me.eq.0)call ffflush(6)
      if(dra_create(MT_DBL, n, n, 'A', FNAME, 
     &      DRA_RW, n, n, d_a).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
c
      if(me.eq.0) print *, 'alligned blocking write'
      if (me.eq.0)call ffflush(6)
      tt0 = MP_TIMER()
      if(dra_write(g_a, d_a,req).ne.0)
     $   CALL ga_error('dra_write failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      mbytes = 1e-6*util_mdtob(n*n)
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
c
      if(dra_close(d_a).ne.0)call ga_error('dra_close failed: ',d_a)
      tt1 = MP_TIMER() -tt0
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'disk array closed '
      if (me.eq.0)call ffflush(6)
c.......................................................................
c
c
      if (me.eq.0) print *, 'creating disk array ',m,' x',m
      if (me.eq.0)call ffflush(6)
      if(dra_create(MT_DBL, m, m, 'A', FNAME1,
     &      DRA_RW, n, n, d_b).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
c
      if(me.eq.0) print *, 'non alligned blocking write'
      if (me.eq.0)call ffflush(6)
c
      gilo =1 
      gjlo =1 
      gihi =n
      gjhi =n
      tt0 = MP_TIMER()
      if(dra_write_section(.false.,     g_a, gilo, gihi, gjlo, gjhi,
     &               d_b, gilo+1, gihi+1, gjlo+1, gjhi+1, req).ne.0)
     &         call  ga_error('dra_write_section failed:',0)

      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      mbytes = 1e-6*util_mdtob(n*n)
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
c
      if(dra_close(d_b).ne.0)call ga_error('dra_close failed: ',d_b)
      tt1 = MP_TIMER() -tt0
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'disk array closed '
      if (me.eq.0)call ffflush(6)
c.......................................................................
c
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'opening disk array'
      if(dra_open(FNAME,DRA_R, d_a).ne.0)
     &            call ga_error('dra_open failed',0)
      if(me.eq.0) print *, 'alligned blocking read'
      if (me.eq.0)call ffflush(6)
      tt0 = MP_TIMER()
      if(dra_read(g_b, d_a, req).ne.0)
     $   CALL ga_error('dra_read failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
      call ga_dadd(1d0, g_a, -1d0, g_b, g_b)
      err = ga_ddot(g_b, g_b)
      if(err.ne.0) then
          if (me.eq.0) print *,'BTW, we have error =', err
          call ga_print(g_b) 
      else
          if (me.eq.0) print *,'OK'
      endif
      if(dra_delete(d_a).ne.0)
     &            call ga_error('dra_delete failed',0)
c.......................................................................
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'opening disk array'
      if(dra_open(FNAME1,DRA_R, d_b).ne.0)
     &            call ga_error('dra_open failed',0)
      if(me.eq.0) print *, 'non alligned blocking read'
      if (me.eq.0)call ffflush(6)
      gilo =1 
      gjlo =1 
      gihi =n
      gjhi =n
      tt0 = MP_TIMER()
      if(dra_read_section(.false.,   g_b, gilo, gihi, gjlo, gjhi,
     &               d_b, gilo+1, gihi+1, gjlo+1, gjhi+1, req).ne.0)
     &        call   ga_error('dra_read_section failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
      call ga_dadd(1d0, g_a, -1d0, g_b, g_b)
      err = ga_ddot(g_b, g_b)
      if(err.ne.0) then
          if (me.eq.0) print *,'BTW, we have error =', err
      else
          if (me.eq.0) print *,'OK'
      endif
      if(dra_delete(d_b).ne.0)
     &            call ga_error('dra_delete failed',0)
c.......................................................................
      status = ga_destroy(g_a)
      status = ga_destroy(g_b)
100   format(g11.2,' MB  time=',g11.2,' rate=',g11.3,'MB/s')
      end



      subroutine swap(a,b)
      integer a, b, temp
         temp = a
         a = b
         b = temp
      end


      subroutine init_char(str, len, char)
      character*(*) str
      character*1 char
      integer i
      do i = 1, len -1 
         str(i:i+1) = char
      enddo
      end
          
      
      subroutine fill_random(a, n,m, ld)
      integer ld, n,m
      double precision a(ld,*), drand, seed
      integer i,j
      external  drand
c
      do j=1,m
         seed = drand(j)
         do i=1,n
            a(i,j)=seed*i
         enddo
      enddo
      end

      block data bfileprefix
      implicit none
#include "cfileprefix.fh"
      data file_prefix /'calc'/
      data scratch_dir/' '/, permanent_dir/' '/
c
      end
      subroutine util_file_info_rtdb(rtdb)
      implicit none
#include "errquit.fh"
#include "cfileprefix.fh"
#include "rtdb.fh"
      integer rtdb
c
c     Store the file prefix in the database.  If the scratch_dir
c     and permanent_dir have been set by the user then store them
c     otherwise restore them from the database.  They are stored
c     as 'scratch_dir' and 'permanent_dir' so that unset can
c     be used to delete them so that defaults may be restored.
c
      if (.not. rtdb_cput(rtdb, 'file_prefix', 1, file_prefix))
     $     call errquit('rtdb_put of file_prefix failed', 0, RTDB_ERR)
c
      if (scratch_dir .ne. ' ') then
         if (.not. rtdb_cput(rtdb, 'scratch_dir', 1, scratch_dir))
     $        call errquit('rtdb_put of scratch_dir failed', 0,
     &       RTDB_ERR)
      else
         if (.not. rtdb_cget(rtdb, 'scratch_dir', 1, scratch_dir))
     $        scratch_dir = ' '
      endif
c
      if (permanent_dir .ne. ' ') then
         if (.not. rtdb_cput(rtdb, 'permanent_dir', 1, permanent_dir))
     $        call errquit('rtdb_put of permanent_dir failed', 0,
     &       RTDB_ERR)
      else
         if (.not. rtdb_cget(rtdb, 'permanent_dir', 1, permanent_dir))
     $        permanent_dir = ' '
      endif
c
      end
      subroutine util_file_prefix_get(fullname)
      implicit none
#include "cfileprefix.fh"
      character*(*) fullname
      external bfileprefix  ! This for T3D linker

      fullname = file_prefix
c
      end
      subroutine util_file_prefix_set(fullname)
      implicit none
#include "cfileprefix.fh"
      character*(*) fullname
      external bfileprefix  ! This for T3D linker

      file_prefix = fullname
c
      end
      subroutine util_file_prefix(name, fullname)
      implicit none
#include "errquit.fh"
#include "cfileprefix.fh"
#include "inp.fh"
#include "stdio.fh"
      character*(*) name, fullname
      external bfileprefix  ! This for T3D linker
c
c     prepend the file_prefix onto name as <file_prefix>.name
c     returning the result in fullname.
c
      if ((inp_strlen(name)+inp_strlen(file_prefix)+1) .gt.
     $     len(fullname)) then
         write(LuOut,*) ' file_prefix: name = ', name
         write(LuOut,*) ' file_prefix: prfx = ', file_prefix
         call util_flush(LuOut)
         call errquit('file_prefix: insufficient space ', len(fullname),
     &       DISK_ERR)
      endif
c
      fullname = ' '
      write(fullname,'(a,''.'',a)')
     $     file_prefix(1:inp_strlen(file_prefix)),
     $     name(1:inp_strlen(name))
c
      end
      subroutine util_file_name(stub, oscratch, oparallel, name)
      implicit none
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"      
#include "cfileprefix.fh"
#include "global.fh"
#include "stdio.fh"
c
      character*(*) stub      ! [input] stub name for file
      logical oscratch        ! [input] true=scratch, false=permanent
      logical oparallel       ! [input] true=append .nodeid
      character*(*) name      ! [output] full filename
c
      character*(nw_max_path_len) dir, tmp
      integer ltmp, ldir, me
      logical util_file_parse_dir
      external util_file_parse_dir
c
      me = ga_nodeid()
c
      call util_directory_name(dir, oscratch, me)
c
*     write(LuOut,*) 'a stub= |',stub(1:inp_strlen(stub)),'|'
*     write(LuOut,*) 'a dir = |', dir(1:inp_strlen(dir)),'|'
c
      call util_file_prefix(stub, tmp)
      ltmp = inp_strlen(tmp)
      ldir  = inp_strlen(dir)
      if (ltmp+ldir+1 .gt. len(name)) then
         write(LuOut,*) ' util_file_name: stub = ', stub
         write(LuOut,*) ' util_file_name: ltmp, ldir, lname',
     $        ltmp, ldir, len(name)
         call util_flush(LuOut)
         call errquit('util_file_name: name too small', ltmp+ldir+1,
     &       INPUT_ERR)
      endif
      if (dir .ne. ' ') then
         name = dir
         name(ldir+1:ldir+1) = '/'
         name(ldir+2:) = tmp
      else
         name = tmp
      endif
c
      if (oparallel) then
         if (inp_strlen(name) .gt. len(tmp)) then
            write(LuOut,*) ' util_file_name: name = ', name
            call util_flush(LuOut)
            call errquit('util_file_name: tmp too small',
     $           inp_strlen(name), INPUT_ERR)
         endif
         tmp = name
         call util_pname(tmp, name)
      endif
c
      end
      subroutine util_file_print_dirs()
      implicit none
#include "util.fh"
#include "inp.fh"      
#include "cfileprefix.fh"
#include "stdio.fh"
#include "global.fh"
c
c     Print a summary of the permanent and scratch file directories
c
      character*(nw_max_path_len) sdir, pdir, prevsdir, prevpdir
      integer node
      logical util_file_parse_dir
      external util_file_parse_dir
c
      prevpdir = ' '
      prevsdir = ' '
      if (ga_nodeid().eq.0) then
         do node = 0, ga_nnodes()-1
c
            call util_directory_name(sdir, .true., node)
            call util_directory_name(pdir, .false., node)
c
            if ((pdir.ne.prevpdir .or. sdir.ne.prevsdir)) then
               write(LuOut,1) node, pdir(1:inp_strlen(pdir)), node,
     $              sdir(1:inp_strlen(sdir))
 1             format(i3,' permanent = ', a/
     $              i3,' scratch   = ', a)
            endif
            prevpdir = pdir
            prevsdir = sdir
         enddo
         write(LuOut,*)
         call util_flush(LuOut)
      endif
c
      end
      logical function util_file_parse_dir(dirlist, dir, nodeid)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
      character*(*) dirlist     ! [input] List of dirs (by host/proc)
      character*(*) dir         ! [output] Returns matching dir
c
c     Dirlist is the input line from the scratch_dir/permanent_dir
c     directives ... attempt to find a match for process nodeid.
c
c     Return true if a match was found, or false (with dir=' ')
c
      character*256 hostname
      character*1024 default, specific
      character*1 numbers(10)
      integer nodeid
c
      integer istart, iend, i, ind, p, ihostend, def1, spe1, nspe, ndef
      data numbers /'0','1','2','3','4','5','6','7','8','9'/
c
*      write(LuOut,*) nodeid, ' dirlist in ufpd |',dirlist,'|'
c
#if defined(CYGNUS) || defined(WIN32)
      call fix_windows_path(dirlist)
#endif
      util_file_parse_dir = .true.
      ndef = 0                  ! No. of default dirs found
      nspe = 0                  ! No. of host specific dirs found
      def1 = 1                  ! Pointer to end of default list 
      spe1 = 1                  ! Pointer to end of specific list 
      default = ' '
      specific = ' '
      hostname = ' '
c
c     Go thru and assemble a space separated list of directories that
c     are either specific to this host or are defaults for all processes.
c     If we encounter a process specific directory immediately return.
c
      istart = 0
 10   if (inp_strtok(dirlist, ' ', istart, iend)) then ! While loop
c
c     Check if there is a host/id present ... a colon in the token
c     On Windows platforms this could be part of a legitimate local
c     path name, so we let it through - note that this precludes
c     specification of hosts this way here
#if !defined(CYGNUS) && !defined(WIN32)
         do i = istart, iend
            if (dirlist(i:i) .eq. ':') goto 20
         enddo
#endif
         ndef = ndef + 1
         default(def1:) = dirlist(istart:iend) ! No colon=add to default list
         def1 = def1 + iend - istart + 2
         goto 10
 20      ihostend = i-1
         if (ihostend .lt. istart) call errquit
     $        ('util_dir_parse: colon at start of dirname?',0,
     &       INPUT_ERR)
c
c     Found host/process ID in dirlist(istart:ihostend).  If the
c     first character is a number, then assume it's all a process id
c     
         if (inp_match(10, .true., dirlist(istart:istart),
     $        numbers, ind)) then
            p = 0
            do i = istart, ihostend
               if (.not. inp_match(10, .true., dirlist(i:i),
     $              numbers, ind)) call errquit
     $              ('util_dir_parse: bad character in process id',0,
     &       INPUT_ERR)
               p = p*10 + ind - 1
            enddo
*            write(LuOut,*) ' p ',p
            if (p .eq. nodeid) then ! Dir for me and only me
               dir = dirlist(ihostend+2:iend)
               return
            endif
         else
            if (hostname .eq. ' ') call util_hostname(hostname)
*            write(LuOut,*) ' hostname ', hostname
*            write(LuOut,*) ' ........ ', dirlist(istart:ihostend)
            if (inp_compare(.false., hostname,
     $           dirlist(istart:ihostend))) then
               specific(spe1:) = dirlist(ihostend+2:iend)
               nspe = nspe + 1
               spe1 = spe1 + iend - ihostend-2 + 2
*               write(LuOut,*) ' set spe to |',specific,'|'
            endif
         endif
         goto 10
      endif                     ! End of while
c
c     Round robin allocation from either host specific or default lists.
c     Exploit sequential number of processes on a given host.
c
      if (nspe .gt. 0) then
         istart = 0
         do i = 0, mod(nodeid,nspe)
            if (.not. inp_strtok(specific, ' ', istart, iend))
     $           call errquit('util_file_parse_dir: internal err?',0,
     &       INPUT_ERR)
         enddo
         dir = specific(istart:iend)
         return
      endif
      if (ndef .gt. 0) then
         istart = 0
         do i = 0, mod(nodeid,ndef)
            if (.not. inp_strtok(default, ' ', istart, iend))
     $           call errquit('util_file_parse_dir: internal err?',1,
     &       INPUT_ERR)
         enddo
         dir = default(istart:iend)
         return
      endif
c
c     Nothing matched
c
      dir = ' '
      util_file_parse_dir = .false.
c
      end
c
c-----------------------------------------------------------------------
c
      subroutine util_set_default_scratch_dir(scratch_dir)
      implicit none
c
c     Sets the default scratch directory name (this may yet be 
c     overriden by the name specified in the input). 
c
c     The order of precedence is as follows:
c     1) the value of NWCHEM_SCRATCH_DIR environment variable
c     2) the value of scratch_dir key in nwchemrc file(s)
c     3) the value of the compiled in name
c
#include "stdio.fh"
#include "inp.fh"
#include "util.fh"
c
      character*(*) scratch_dir ! output
c
      logical from_environment
      logical from_nwchemrc
      logical from_compile
      logical debug
c
      debug = .false.
c
c     1: check for NWCHEM_SCRATCH_DIR environment variable
c
      call util_getenv('NWCHEM_SCRATCH_DIR',scratch_dir)
      if (debug) then
        write(luout,*)
     &      'env return value of NWCHEM_SCRATCH_DIR <',
     &      scratch_dir(1:inp_strlen(scratch_dir)),'>'
      endif
      from_environment = (inp_strlen(scratch_dir).gt.0)
c
c     2: check for scratch_dir defined in nwchemrc config file(s)
c
      if (.not.from_environment) then
        if (.not.util_nwchemrc_get('scratch_dir',scratch_dir)) then
          if (debug) then
            write(luout,*)'util_nwchemrc_get failed for scratch_dir'
          endif
        else
          from_nwchemrc = .true.
          if (debug) then
            write(luout,*)
     &          'nwchemrc return value of scratch_dir <',
     &          scratch_dir(1:inp_strlen(scratch_dir)),'>'
          endif
        endif
      endif
c
c     3: use compiled in default setting
c
      if (.not.from_environment.and..not.from_nwchemrc) then
        scratch_dir = ' '
        from_compile = .true.
      endif
c
      end
c
c-----------------------------------------------------------------------
c
      subroutine util_set_default_permanent_dir(permanent_dir)
      implicit none
c
c     Sets the default permanent directory name (this may yet be 
c     overriden by the name specified in the input). 
c
c     The order of precedence is as follows:
c     1) the value of NWCHEM_PERMANENT_DIR environment variable
c     2) the value of permanent_dir key in nwchemrc file(s)
c     3) the value of the compiled in name
c
#include "stdio.fh"
#include "inp.fh"
#include "util.fh"
c
      character*(*) permanent_dir ! output
c
      logical from_environment
      logical from_nwchemrc
      logical from_compile
      logical debug
c
      debug = .false.
c
c     1: check for NWCHEM_PERMANENT_DIR environment variable
c
      call util_getenv('NWCHEM_PERMANENT_DIR',permanent_dir)
      if (debug) then
        write(luout,*)
     &      'env return value of NWCHEM_PERMANENT_DIR <',
     &      permanent_dir(1:inp_strlen(permanent_dir)),'>'
      endif
      from_environment = (inp_strlen(permanent_dir).gt.0)
c
c     2: check for scratch_dir defined in nwchemrc config file(s)
c
      if (.not.from_environment) then
        if (.not.util_nwchemrc_get('permanent_dir',permanent_dir)) then
          if (debug) then
            write(luout,*)'util_nwchemrc_get failed for permanent_dir'
          endif
        else
          from_nwchemrc = .true.
          if (debug) then
            write(luout,*)
     &          'nwchemrc return value of permanent_dir <',
     &          permanent_dir(1:inp_strlen(permanent_dir)),'>'
          endif
        endif
      endif
c
c     3: use compiled in default setting
c
      if (.not.from_environment.and..not.from_nwchemrc) then
        permanent_dir = ' '
        from_compile = .true.
      endif
c
      end
c
c-----------------------------------------------------------------------
c
      subroutine input_file_info(input_filename, 
     $     rtdb_name, ostartup, ocontinue)
C$Id: util_file_name.F 24862 2013-11-21 18:43:30Z d3y133 $
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgids.fh"
#include "cfileprefix.fh"
#include "util.fh"
#include "stdio.fh"
      character*(*) input_filename ! [input]
      character*(*) rtdb_name   ! [output]
      logical ostartup           ! [output]
      logical ocontinue          ! [output]
c
      character*(nw_max_path_len) ecce_file_name
      character*(nw_max_path_len) a_temporary_file
      logical status, odirective, echo
      logical bad_permanent_dir, bad_scratch_dir
      logical already
      integer nkeys, istart, iend
      parameter (nkeys = 7)
      logical iocheckk
      character*16 keys(nkeys), field
      data keys/'start','restart','continue',
     &    'scratch_dir','permanent_dir', 'ecce_print',
     $     'echo'/
c
c     Scan the input for start/restart directives and attempt
c     to figure out the name of the desired data base, if the
c     job is a startup or a restart, what the file_prefix is.
c
c     While we're doing this also scan for scratch_dir and permanent_dir
c
c     (start || restart) [<file_prefix> = 'from input file base'] \
c                        [rtdb <rtdb_file_name>]
c
c     scratch_dir <read rest of line as character string>
c     permanent_dir <read rest of line as character string>
c
c     Only process 0 reads ... everyone else jumps to the broadcast
c
      scratch_dir = ' '
      permanent_dir = ' '
      call util_set_default_scratch_dir(scratch_dir)
      call util_set_default_permanent_dir(permanent_dir)
      iocheckk=.true.
#if defined(CRAYXT) || defined(BGP) || defined(BGQ)
c     on catamount all fs are parallel, therefore we need only node0
c     on BGP/BGQ all fs are parallel, therefore we need only node0
      iocheckk=ga_nodeid().eq.0
#endif     
c
      if (nodeid() .gt. 0) goto 10000
c
c     default is a startup with name extracted from that of the input
c     file unless a database of that name is present in which case
c     you get a restart.  Overriden by presenting start/restart.
c
      odirective = .false.      ! True if find a start/restart/continue
      ostartup   = .true.
      ocontinue  = .false.
      echo       = .false.
      rtdb_name  = ' '
      call input_default_file_prefix(input_filename,file_prefix)
c
      rewind LuIn
      call inp_init(LuIn,LuOut)
 10   if (inp_search(.false., keys, nkeys)) then ! While
         if (.not. inp_a(field)) call errquit('input_start: inp?',0,
     &       INPUT_ERR)
         if (inp_compare(.false.,'start',field)) then
            odirective = .true.
            ostartup = .true.
            ocontinue = .false.
            call util_read_start_dir(file_prefix, rtdb_name)
         else if (inp_compare(.false.,'continue',field)) then
            call errquit('continue directive is no longer supported',
     *        555, INPUT_ERR)
            odirective = .true.
            ostartup = .false.
            ocontinue = .true.
            call util_read_start_dir(file_prefix, rtdb_name)
         else if (inp_compare(.false.,'restart',field)) then
            odirective = .true.
            ostartup = .false.
            ocontinue = .false.
            call util_read_start_dir(file_prefix, rtdb_name)
         else if (inp_compare(.false.,'scratch_dir',field)) then
            status = inp_line(scratch_dir)
            istart = 0
            status = inp_strtok(scratch_dir,' ',istart, iend)
            scratch_dir(istart:iend) = ' '
         else if (inp_compare(.false.,'permanent_dir',field)) then
            status = inp_line(permanent_dir)
            istart = 0
            status = inp_strtok(permanent_dir,' ',istart, iend)
            permanent_dir(istart:iend) = ' '
         else if (inp_compare(.false.,'echo',field)) then
            echo = .true.
         else if (inp_compare(.false.,'ecce_print', field)) then
            if (inp_a(ecce_file_name)) then
               call ecce_print_file_open(ecce_file_name)
               call ecce_print_echo_input(input_filename)
            endif
         else
            call errquit('input_start_opt: wierd error',0, INPUT_ERR)
         endif
         goto 10                ! End while
      endif
      rewind LuIn
      call inp_init(LuIn,LuOut)
c
      if (echo) call input_echo(LuIn,LuOut)
c
      if (rtdb_name .eq. ' ')
     $     call util_file_name('db',.false.,.false.,rtdb_name)
c
      if (.not. odirective) then
c
c     No start/restart directive presented.  See if we can find a database,
c     if so, assume a restart.  Otherwise it must be a startup.
c
         inquire(file=rtdb_name,exist=status)
         ostartup = .not. status
      endif
c
      rewind LuIn
      call inp_init(LuIn,LuOut)
c
c     Broadcast start options to everyone else
c
10000 call ga_brdcst(Msg_StartUp, ostartup, mitob(1), 0)
      call ga_brdcst(Msg_StartUp, ocontinue, mitob(1), 0)
      call util_char_ga_brdcst(Msg_startup, file_prefix, 0)
      call util_char_ga_brdcst(Msg_startup, scratch_dir, 0)
      call util_char_ga_brdcst(Msg_startup, permanent_dir, 0)
*
* now confirm (on each node) that scratch_dir and permanent_dir
* can have files
*
      call ga_sync()
*check permanent directory
      if(iocheckk) then
        call util_file_name('dir_check_p',.false.,.true.,
     &                      a_temporary_file)
        inquire(file=a_temporary_file, exist=already)
        bad_permanent_dir = .true.
        if(already) then
          iend = inp_strlen(a_temporary_file)
          write(luout,*)' Warning: test file already existed: ',
     &                  a_temporary_file(1:iend)
C         Assume all is well in the world, since file might be 
C         chmod 000
          bad_permanent_dir = .false.
        else
          open(UNIT=42,FILE=a_temporary_file,STATUS="new",ERR=91111)
          close(UNIT=42,STATUS="delete")
          call util_file_unlink(a_temporary_file)
          bad_permanent_dir = .false.
        endif
91111   continue
*check scratch directory
        call util_file_name('dir_check_s',.true.,.true.,
     &                      a_temporary_file)
        inquire(file=a_temporary_file, exist=already)
        bad_scratch_dir = .true.
        if(already) then
          iend = inp_strlen(a_temporary_file)
          write(luout,*)' Warning: test file already existed: ',
     &                  a_temporary_file(1:iend)
C         Assume all is well in the world, since file might be
C         chmod 000
          bad_scratch_dir = .false.
        else
          open(UNIT=43,FILE=a_temporary_file,STATUS="new",ERR=91122)
          close(UNIT=43,STATUS="delete")
          call util_file_unlink(a_temporary_file)
          bad_scratch_dir = .false.
        endif
91122   continue
      else
        bad_permanent_dir=.false.
        bad_scratch_dir=.false.
      endif
*
      if (bad_permanent_dir) then
        iend = inp_strlen(permanent_dir)
        write(luout,*)' could not open a file in permanent directory: ',
     &      permanent_dir(1:iend)
      endif
      if (bad_scratch_dir) then
        iend = inp_strlen(scratch_dir)
        write(luout,*)' could not open a file in scratch directory: ',
     &      scratch_dir(1:iend)
      endif
      if (bad_permanent_dir.and.bad_scratch_dir) then
        write(luout,*)
     &      ' Both permanent and scratch directory not accessible'
        call errquit('******** Fatal Error ********',911, INPUT_ERR)
      else if (bad_permanent_dir) then
        call errquit
     &      ('Fatal Error: permanent directory not accessible',911,
     &       INPUT_ERR)
      else if (bad_scratch_dir) then
        call errquit
     &      ('Fatal Error: scratch directory not accessible',911,
     &       INPUT_ERR)
      else
        return
      endif
c
      end
      subroutine input_default_file_prefix(input_file_name,file_prefix)
      implicit none
#include "inp.fh"
      character*(*) input_file_name, file_prefix
c
      integer i, start, end
c
      end = inp_strlen(input_file_name)
      do start = end,1,-1           ! Ignore any directories in the path
         if (input_file_name(start:start) .eq. '/') goto 10
      enddo
 10   start = start + 1
c
      do i = end,start,-1       ! Remove last trailing .*
         if (input_file_name(i:i) .eq. '.') then
            end = i - 1
            goto 20
         endif
      enddo
c
 20   if (end .lt. start) then
         file_prefix = 'calc'   ! Confused ... just punt
      else
         file_prefix = input_file_name(start:end)
      endif
c
      end
      subroutine util_read_start_dir(file_prefix, rtdb_name)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "util.fh"
      character*(*) file_prefix, rtdb_name 
c
c     (start|restart|continue) [<file_prefix>] [rtdb <rtdb_name>]
c
      character*(nw_max_path_len) test
c
 10   if (inp_a(test)) then
         if (inp_compare(.false.,test,'rtdb')) then
            if (.not. inp_a(rtdb_name)) call errquit
     $           ('util_read_start_directive: missing rtdb name',0,
     &       INPUT_ERR)
         else
            file_prefix = test
         endif
         goto 10
      endif
c
      end
      subroutine util_directory_name(dir, oscratch, node)
      implicit none
#include "cfileprefix.fh"
#include "inp.fh"
#include "global.fh"
      character*(*) dir         ! [output]
      logical oscratch          ! [input]
      integer node              ! [input]
      logical util_file_parse_dir
      external util_file_parse_dir
      character*1024 envscr
      integer istart,util_getblnk,lencrd
      external util_getblnk
c
c     return the name of the scratch/permanent directory for the
c     specified process
c
      if (oscratch) then
         call util_getenv('SCRATCH_DIR',envscr) 
         if(.not.util_file_parse_dir(envscr, dir, ga_nodeid()))
     I    then
         if (.not. util_file_parse_dir(scratch_dir, dir, node)) then
            dir = '. ' ! Final default is blank
         endif
         endif
      else
         call util_getenv('PERMANENT_DIR',envscr) 
         if(.not.util_file_parse_dir(envscr, dir, ga_nodeid()))
     I    then
         if (.not. util_file_parse_dir(permanent_dir, dir, node)) then
            dir = '. ' ! Final default is blank
         endif
         endif
      endif
c
      end
      double precision function util_scratch_dir_avail_for_me()
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "util.fh"
#include "eaf.fh"
#include "cfileprefix.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "msgids.fh"
c
c     Return the amount of space in Kb available in the scratch
c     directory for this process.
c
c     Eventually this will be hooked up to input control.
c     Presently, it does the following.
c
c     For the IBM SP if the directory is /scratch or the same
c     as the default scratch directory, then  it assumes that a 
c     local (non-shared) scratch directory is being used.  
c     FOR ALL OTHER MACHINES it tries to determine the number of
c     processes sharing the directory by looping thru all nodes
c     and seeing if they map to the same directory.  This is valid
c     for machines with shared filesystems.
c
      integer me, nproc,  ierr
      character*(nw_max_path_len) mine
      integer nuse
      integer avail0,avail1
      integer fd
      character*8 fstype
      integer l1megabyte,i_k,l_k,nuse_fail,nattpt,
     ,     availmin
      character*255 dirscr
      parameter(l1megabyte=2*1000000)
      logical util_file_parse_dir,oprint
      external util_file_parse_dir
c
      oprint=util_print('available disk',print_high)
c
c     Construct a name in the scratch directory of the current 
c     process and inquire how much space is available
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      nattpt=0
      avail0=0
      avail1=0
#ifdef NOFSCHECK
      avail0=10**8
      nuse=ga_nnodes()
      avail1=-16d0*nuse+avail0
#else
1025  call util_file_name('junk',.true.,.true.,mine)
      ierr=eaf_delete(mine)
      ierr=eaf_open(mine, eaf_rw, fd)
      if(ierr.ne.0) call errquit('utilscratchavail: eaf_open',ierr,
     &       DISK_ERR)
      call ga_sync()
      ierr = eaf_stat(mine, avail0, fstype)
c
c     now write 5M of doubles
c
      if (.not.ma_push_get(MT_Dbl,l1megabyte,'cc',l_k,i_k))
     &   call errquit('utilfname: cannot allocate ',0, MA_ERR)
      call dcopy(l1megabyte,0d0,0,dbl_mb(i_k),1)
      ierr = eaf_write(fd, 0d0, dbl_mb(i_k),8*l1megabyte)
      if (.not.ma_pop_stack(l_k))
     &   call errquit('utilfname: cannot deallocate ',0, MA_ERR)
      ierr=eaf_close(fd)
      call ga_sync()
      ierr = eaf_stat(mine, avail1, fstype)
      if (ierr .ne. 0) call errquit('util_scratch_avail: eaf_stat',ierr,
     &       DISK_ERR)
      ierr=eaf_delete(mine)
      nuse=nint((avail0-avail1)/16d0)
      nuse_fail=0
      if (nuse .le. 0) nuse_fail= 1
      call ga_igop(msg_utscr,nuse_fail,1,'+')
      if(nuse_fail.ne.0) then
        if(oprint.and.ga_nodeid().eq.0) write(luout,*) ' negative nuse'
        nattpt=nattpt+1
        if(nattpt.gt.3) then
           if(oprint.and.ga_nodeid().eq.0) then
              write(luout,*)'utilscravail: too many attempts',nattpt
              write(luout,*)'utilscravail:  set nuse = ga_nnodes'
           endif
c
c    something wrong with filesystem: go for upper bound, ie nuse=nproc
c
           nuse=ga_nnodes()
        else
          goto 1025
        endif
      endif
#endif
c
c     get min disk space (if you have thin & fat nodes)
c
      availmin=avail0/nuse
      call ga_igop(msg_utscr2,availmin,1,'min')
      if(oprint) then
         call util_directory_name(dirscr, .true., ga_nodeid())
         write(luout,11) ga_nodeid(),nuse,(avail0-avail1)/16d0,
     .     availmin,avail0/nuse,
     .     dirscr(1:inp_strlen(dirscr))
 11      format(i4,': nuse=',i4,'(',f6.1,') avail=',i9,'Mb (out of',
     .   i9,'Mb) on ',A)
      endif
c
c     now eaf_stat returns Mb instead of kb
c
!      avail=avail0*1024

c     
      util_scratch_dir_avail_for_me = 1024d0*dble(availmin)
c
      end
      subroutine util_file_name_resolve(filename, oscratch)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "stdio.fh"
      character*(*) filename    ! [input/output] 
      logical oscratch          ! [input] 
c
c     If the given filename is not a full path (begins with /)
c     or explicitly relative to the current directory (./ or ../)
c     then resolve it to the scratch/permanent directory for the
c     current process according to oscratch.
c
c     Note that this resolution cannot happen at input time since only
c     process 0 reads the input and the directories are process specific.
cc
      character*(nw_max_path_len) dir
      integer flen, dlen
c
      if ((filename(1:1).ne.'/')  .and. (filename(1:2).ne.'./')
     $     .and. (filename(1:3).ne.'../')) then
         call util_directory_name(dir, oscratch, ga_nodeid())
c
*        write(LuOut,*) 'b fnm = |',filename(1:inp_strlen(filename)),'|'
*        write(LuOut,*) 'b dir = |',dir(1:inp_strlen(dir)),'|'
c
         dlen = inp_strlen(dir)
         if (dlen .gt. 0) then
            flen = inp_strlen(filename)
            if ((flen+dlen+1).gt.len(filename)) call errquit
     $           ('util_file_name_resolve: filename too small',
     $           flen+dlen+1, INPUT_ERR)
            dir(dlen+1:dlen+1) = '/'
            dir(dlen+2:) = filename
c     
*            write(6,*) ' RESOLVED ', filename(1:flen), ' TO ', 
*     $           dir(1:inp_strlen(dir))
c     
            filename = dir
         endif
      endif
c
      end
      subroutine fix_windows_path(path)
      implicit none
#include "inp.fh"
      character*(*) path        ! [input/output] 
#if defined(CYGNUS) || defined(WIN32)
      integer i, l
c     On Windows platforms a backslash is a valid directory separator.
c     Replace backslashes with forward slashes so these pathnames are
c     accepted.
      l = inp_strlen(path)
      do i = 1, l
#if defined(CYGNUS)
         if (path(i:i) .eq. '\\') then
#elif defined(WIN32)
         if (path(i:i) .eq. '\') then
#endif
            path(i:i) = '/'
         endif
      enddo
#endif
      return
      end

c     **** added by EJB 11/7/00 ****
      subroutine util_file_name_noprefix(stub, oscratch, 
     >                                         oparallel, 
     >                                         name)
      implicit none
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"      
#include "cfileprefix.fh"
#include "global.fh"
#include "stdio.fh"
c
      character*(*) stub      ! [input] stub name for file
      logical oscratch        ! [input] true=scratch, false=permanent
      logical oparallel       ! [input] true=append .nodeid
      character*(*) name      ! [output] full filename
c
      character*(nw_max_path_len) dir, tmp
      integer ltmp, ldir, me
      logical util_file_parse_dir
      external util_file_parse_dir
c
      me = ga_nodeid()
c
      call util_directory_name(dir, oscratch, me)
c
*     write(LuOut,*) 'c stub= |',stub(1:inp_strlen(stub)),'|'
*     write(LuOut,*) 'c dir = |', dir(1:inp_strlen(dir)),'|'
c

      tmp   = stub
      ltmp  = inp_strlen(tmp)
      ldir  = inp_strlen(dir)
      if (ltmp+ldir+1 .gt. len(name)) then
         write(LuOut,*) ' util_file_name: stub = ', stub
         write(LuOut,*) ' util_file_name: ltmp, ldir, lname',
     $        ltmp, ldir, len(name)
         call util_flush(LuOut)
         call errquit('util_file_name: name too small', ltmp+ldir+1,
     &       INPUT_ERR)
      endif
      if (dir .ne. ' ') then
         name = dir
         name(ldir+1:ldir+1) = '/'
         name(ldir+2:) = tmp
      else
         name = tmp
      endif
c
      if (oparallel) then
         if (inp_strlen(name) .gt. len(tmp)) then
            write(LuOut,*) ' util_file_name: name = ', name
            call util_flush(LuOut)
            call errquit('util_file_name: tmp too small',
     $           inp_strlen(name), INPUT_ERR)
         endif
         tmp = name
         call util_pname(tmp, name)
      endif
c
      end
      logical function util_find_dir(dname)
      implicit none
c
c     hack that returns true if directory exists
c
#include "eaf.fh"
#include "inp.fh"
      character*(*) dname
c
      double precision availkb
      character*20 fstype
c
      util_find_dir=eaf_stat(dname(1:inp_strlen(dname)),
     .     availkb, fstype).eq.0
      return
      end
c
      subroutine util_full_file_name(filename, oscratch, name)
      implicit none
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "cfileprefix.fh"
#include "global.fh"
#include "stdio.fh"
c
      character*(*) filename          ! [input] raw file name
      logical oscratch                ! [input] true=scratch, false=permanent
      character*(*) name              ! [output] full filename including scratch path
c
      character*(nw_max_path_len) dir, tmp
      integer ltmp, ldir, me
      logical util_file_parse_dir
      external util_file_parse_dir
c
      me = ga_nodeid()
c
      call util_directory_name(dir, oscratch, me)
c
*     write(LuOut,*) 'd fnm = |',filename(1:inp_strlen(filename)),'|'
*     write(LuOut,*) 'd dir = |', dir(1:inp_strlen(dir)),'|'
c
      tmp   = filename
      ltmp  = inp_strlen(tmp)
      ldir  = inp_strlen(dir)
      if (ltmp+ldir+1 .gt. len(name)) then
        write(LuOut,*) ' util_full_file_name: filename = ', filename
        write(LuOut,*) ' util_full_file_name: ltmp, ldir, lname',
     $        ltmp, ldir, len(name)
        call util_flush(LuOut)
        call errquit('util_full_file_name: name too small', ltmp+ldir+1,
     &       INPUT_ERR)
      endif
      if (dir .ne. ' ') then
         name = dir
         name(ldir+1:ldir+1) = '/'
         name(ldir+2:) = tmp
      else
         name = tmp
      endif
c
      end

#define NBLOCKS 2

*
* $Id: D3dB_pfft.F 24856 2013-11-20 21:52:44Z bylaska $
*

*     ***********************************************************
*     *								*
*     *   		   D3dB_pfft library	 		*
*     *			(MPI implemenation)			*
*     *								*
*     *   Author - Eric Bylaska					*
*     *   date   - 3/23/96					*
*     *								*
*     ***********************************************************

*     ***********************************
*     *					*
*     *	        D3dB_pfft_init		*
*     *					*
*     ***********************************

      subroutine D3dB_pfft_init()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "D3dB.fh"
#include "D3dB_pfft.fh"

*     **** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)

      double precision eps
      parameter (eps=1d-12)

      logical value,yrow,zrow,yzslab
      integer nxh,nyh,nzh,q,p
      integer k1,k2,k3,ii,nb
      integer i,j,k
      integer index,index2
      double precision ggcut,g1,g2,g3,gg
      integer zero_arow2(2),zero_arow3(2)

*     **** external functions ***
      integer  control_pfft3_qsize
      real*8   lattice_ggcut,lattice_wggcut,lattice_unitg
      external control_pfft3_qsize
      external lattice_ggcut,lattice_wggcut,lattice_unitg



      call Parallel2d_taskid_i(taskid)
      nxh = nx(1)/2
      nyh = ny(1)/2
      nzh = nz(1)/2

      if (mapping.eq.1) then
         
         value =           MA_alloc_get(mt_log,(nxh+1)*nq(1),
     >                     'zero_row3',zero_row3(2,0),zero_row3(1,0))
         value = value.and.MA_alloc_get(mt_log,(nxh+1)*nq(1),
     >                     'zero_row3',zero_row3(2,1),zero_row3(1,1))

         value = value.and.MA_alloc_get(mt_log,(nxh+1)*nq(1),
     >                     'zero_row2',zero_row2(2,0),zero_row2(1,0))
         value = value.and.MA_alloc_get(mt_log,(nxh+1)*nq(1),
     >                     'zero_row2',zero_row2(2,1),zero_row2(1,1))

         value = value.and.MA_alloc_get(mt_log,(nxh+1),
     >               'zero_slab23',zero_slab23(2,0),zero_slab23(1,0))
         value = value.and.MA_alloc_get(mt_log,(nxh+1),
     >               'zero_slab23',zero_slab23(2,1),zero_slab23(1,1))
         if (.not. value) call errquit('out of heap memory',0, MA_ERR)

         value = value.and.MA_push_get(mt_log,(nxh+1)*ny(1),
     >                     'zero_arow3',zero_arow3(2),zero_arow3(1))
         if (.not. value) call errquit('out of stack memory',0,MA_ERR)


         do nb=0,1



         if (nb.eq.0) then
            ggcut = lattice_ggcut()
         else
            ggcut = lattice_wggcut()
         end if

*        **** find zero_row3 - (i,j,*) rows that are zero ****
         do q=1,(nxh+1)*nq(1)
             log_mb(zero_row3(1,nb)+q-1) =.true.
         end do
         do q=1,(nxh+1)*ny(1)
           log_mb(zero_arow3(1)+q-1) =.true.
         end do


         do k2 = -nyh+1, nyh-1
         do k1 = 0,nxh-1
          i=k1
          j=k2
          if (i .lt. 0) i = i + nx(1)
          if (j .lt. 0) j = j + ny(1)
          i=i+1
          j=j+1
          zrow = .true.
          do k3 = -nzh+1, nzh-1
            g1 = k1*lattice_unitg(1,1)
     >         + k3*lattice_unitg(1,2)
     >         + k2*lattice_unitg(1,3)
            g2 = k1*lattice_unitg(2,1)
     >         + k3*lattice_unitg(2,2)
     >         + k2*lattice_unitg(2,3)
            g3 = k1*lattice_unitg(3,1)
     >         + k3*lattice_unitg(3,2)
     >         + k2*lattice_unitg(3,3)
            gg = g1*g1 + g2*g2 + g3*g3
            gg= gg-ggcut
            if (gg.lt.-eps) zrow = .false.
          end do
          if (.not.zrow) then
            log_mb(zero_arow3(1)+i-1+(nxh+1)*(j-1)) =.false.
            call D3dB_ktoqp(1,j,q,p)
            if (p.eq.taskid) then
              index2 = i + (nxh+1)*(q-1)
              log_mb(zero_row3(1,nb)+index2-1) =.false.
            end if
          end if

         end do
         end do

         call D3dB_c_ptranspose_jk_init(nb,log_mb(zero_arow3(1)))


*        **** find zero_slab23 - (i,*,*) slabs that are zero ****
         do k1 = 1,nxh+1
           log_mb(zero_slab23(1,nb)+k1-1) =.true.
         end do

         do k1 = 0,nxh-1
          i=k1
          if (i .lt. 0) i = i + nx(1)
          i=i+1
          yzslab = .true.
          do k3 = -nzh+1, nzh-1
          do k2 = -nyh+1, nyh-1
            g1 = k1*lattice_unitg(1,1)
     >         + k2*lattice_unitg(1,2)
     >         + k3*lattice_unitg(1,3)
            g2 = k1*lattice_unitg(2,1)
     >         + k2*lattice_unitg(2,2)
     >         + k3*lattice_unitg(2,3)
            g3 = k1*lattice_unitg(3,1)
     >         + k2*lattice_unitg(3,2)
     >         + k3*lattice_unitg(3,3)
            gg = g1*g1 + g2*g2 + g3*g3
            gg= gg-ggcut
            if (gg.lt.-eps) yzslab = .false.
          end do
          end do
          if (.not.yzslab) then
            log_mb(zero_slab23(1,nb)+i-1) =.false.
          end if

         end do

*        **** find zero_row2 - (i,*,k) rows that are zero after fft of (i,j,*) ****
         do k3 = 1,nz(1)
         do k1 = 1,nxh+1
           call D3dB_ktoqp(1,k3,q,p)
           if (p.eq.taskid) then
            index2 = k1 + (nxh+1)*(q-1)
            log_mb(zero_row2(1,nb)+index2-1) 
     >       = log_mb(zero_slab23(1,nb)+k1-1)
           end if
         end do
         end do



        
         end do
         value = MA_pop_stack(zero_arow3(2))
         if (.not. value) call errquit('error freeing stack',0,MA_ERR)

      !*** mapping == 2 ***
      else
         value =           MA_alloc_get(mt_log,nq3(1),
     >                     'zero_row3',zero_row3(2,0),zero_row3(1,0))
         value = value.and.MA_alloc_get(mt_log,nq3(1),
     >                     'zero_row3',zero_row3(2,1),zero_row3(1,1))

         value = value.and.MA_alloc_get(mt_log,nq2(1),
     >                     'zero_row2',zero_row2(2,0),zero_row2(1,0))
         value = value.and.MA_alloc_get(mt_log,nq2(1),
     >                     'zero_row2',zero_row2(2,1),zero_row2(1,1))

         value = value.and.MA_alloc_get(mt_log,(nxh+1),
     >               'zero_slab23',zero_slab23(2,0),zero_slab23(1,0))
         value = value.and.MA_alloc_get(mt_log,(nxh+1),
     >               'zero_slab23',zero_slab23(2,1),zero_slab23(1,1))
         if (.not. value) call errquit('out of heap memory',0, MA_ERR)

         value = value.and.MA_push_get(mt_log,(nxh+1)*nz(1),
     >                     'zero_arow2',zero_arow2(2),zero_arow2(1))
         value = value.and.MA_push_get(mt_log,(nxh+1)*ny(1),
     >                     'zero_arow3',zero_arow3(2),zero_arow3(1))
         if (.not. value) call errquit('out of stack memory',0,MA_ERR)


         do nb=0,1
         if (nb.eq.0) then
            ggcut = lattice_ggcut()
         else
            ggcut = lattice_wggcut()
         end if

*        **** find zero_row3 - (i,j,*) rows that are zero ****
         do q = 1,nq3(1)
           log_mb(zero_row3(1,nb)+q-1) =.true.
         end do
         do q = 1,(nxh+1)*ny(1)
           log_mb(zero_arow3(1)+q-1) =.true.
         end do

         do k2 = -nyh+1, nyh-1
         do k1 = 0,nxh-1
          i=k1
          j=k2
          if (i .lt. 0) i = i + nx(1)
          if (j .lt. 0) j = j + ny(1)
          i=i+1
          j=j+1
          zrow = .true.
          do k3 = -nzh+1, nzh-1
            g1 = k1*lattice_unitg(1,1)
     >         + k2*lattice_unitg(1,2)
     >         + k3*lattice_unitg(1,3)
            g2 = k1*lattice_unitg(2,1)
     >         + k2*lattice_unitg(2,2)
     >         + k3*lattice_unitg(2,3)
            g3 = k1*lattice_unitg(3,1)
     >         + k2*lattice_unitg(3,2)
     >         + k3*lattice_unitg(3,3)
            gg = g1*g1 + g2*g2 + g3*g3
            gg= gg-ggcut
            if (gg.lt.-eps) zrow = .false.
          end do
          if (.not.zrow) then
            log_mb(zero_arow3(1)+i-1+(nxh+1)*(j-1)) =.false.
            q = int_mb(q_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))
            p = int_mb(p_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))
            if (p.eq.taskid) then
              log_mb(zero_row3(1,nb)+q-1) =.false.
            end if
          end if

         end do
         end do

*        **** find zero_slab23 - (i,*,*) slabs that are zero ****
         do k1 = 1,nxh+1
           log_mb(zero_slab23(1,nb)+k1-1) =.true.
         end do

         do k1 = 0,nxh-1
          i=k1
          if (i .lt. 0) i = i + nx(1)
          i=i+1
          yzslab = .true.
          do k3 = -nzh+1, nzh-1
          do k2 = -nyh+1, nyh-1
            g1 = k1*lattice_unitg(1,1)
     >         + k2*lattice_unitg(1,2)
     >         + k3*lattice_unitg(1,3)
            g2 = k1*lattice_unitg(2,1)
     >         + k2*lattice_unitg(2,2)
     >         + k3*lattice_unitg(2,3)
            g3 = k1*lattice_unitg(3,1)
     >         + k2*lattice_unitg(3,2)
     >         + k3*lattice_unitg(3,3)
            gg = g1*g1 + g2*g2 + g3*g3
            gg= gg-ggcut
            if (gg.lt.-eps) yzslab = .false.
          end do
          end do
          if (.not.yzslab) then
            log_mb(zero_slab23(1,nb)+i-1) =.false.
          end if

         end do


*        **** find zero_row2 - (i,*,k) rows that are zero after fft of (i,j,*) ****
         do k = 1,nz(1)
         do i = 1,nxh+1
           q = int_mb(q_map2(1,1)+(k-1)+(i-1)*(nz(1)))
           p = int_mb(p_map2(1,1)+(k-1)+(i-1)*(nz(1)))

           log_mb(zero_arow2(1)+i-1+(nxh+1)*(k-1))
     >       = log_mb(zero_slab23(1,nb)+i-1)
           if (p.eq.taskid) then
            log_mb(zero_row2(1,nb)+q-1)
     >       = log_mb(zero_slab23(1,nb)+i-1)
           end if
         end do
         end do

         call D3dB_c_ptranspose_ijk_init(nb,
     >                                   log_mb(zero_arow2(1)),
     >                                   log_mb(zero_arow3(1)))



         end do

       value =           MA_pop_stack(zero_arow3(2))
       value = value.and.MA_pop_stack(zero_arow2(2))
       if (.not. value) call errquit('error pop stack',0,MA_ERR)


      end if

      call D3dB_pfft3_queue_init(control_pfft3_qsize())

      return
      end




*     ***********************************
*     *                                 *
*     *         D3dB_pfft_end           *
*     *                                 *
*     ***********************************

      subroutine D3dB_pfft_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "D3dB.fh"
#include "D3dB_pfft.fh"



*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / ptrans_blk1 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start

*     **** indexing variables ****
      integer jq_to_i1(2,0:1)
      integer jq_to_i2(2,0:1)
      integer jz_to_i2(2,0:1)
      integer j1_start(2,0:1)
      integer j2_start(2,0:1)
      common / ptrans_blk2 / jq_to_i1,jq_to_i2,jz_to_i2,
     >                       j1_start,j2_start


*     *** hilbert tranpose data structure ****
      integer h_iq_to_i1(2,6,0:1)
      integer h_iq_to_i2(2,6,0:1)
      integer h_iz_to_i2(2,6,0:1)
      integer h_iz_to_i2_count(6,0:1)
      integer h_i1_start(2,6,0:1)
      integer h_i2_start(2,6,0:1)
      common / ptrans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_iz_to_i2,
     >                         h_iz_to_i2_count,
     >                         h_i1_start,
     >                         h_i2_start


      logical value
      integer i

      value =           MA_free_heap(zero_row2(2,0))
      value = value.and.MA_free_heap(zero_row2(2,1))
      value = value.and.MA_free_heap(zero_row3(2,0))
      value = value.and.MA_free_heap(zero_row3(2,1))
      value = value.and.MA_free_heap(zero_slab23(2,0))
      value = value.and.MA_free_heap(zero_slab23(2,1))

      if (mapping.eq.1) then
      value = value.and.MA_free_heap(iq_to_i1(2,0))
      value = value.and.MA_free_heap(iq_to_i1(2,1))
      value = value.and.MA_free_heap(iq_to_i2(2,0))
      value = value.and.MA_free_heap(iq_to_i2(2,1))
      value = value.and.MA_free_heap(iz_to_i2(2,0))
      value = value.and.MA_free_heap(iz_to_i2(2,1))
      value = value.and.MA_free_heap(i1_start(2,0))
      value = value.and.MA_free_heap(i1_start(2,1))
      value = value.and.MA_free_heap(i2_start(2,0))
      value = value.and.MA_free_heap(i2_start(2,1))

      value = value.and.MA_free_heap(jq_to_i1(2,0))
      value = value.and.MA_free_heap(jq_to_i1(2,1))
      value = value.and.MA_free_heap(jq_to_i2(2,0))
      value = value.and.MA_free_heap(jq_to_i2(2,1))
      value = value.and.MA_free_heap(jz_to_i2(2,0))
      value = value.and.MA_free_heap(jz_to_i2(2,1))
      value = value.and.MA_free_heap(j1_start(2,0))
      value = value.and.MA_free_heap(j1_start(2,1))
      value = value.and.MA_free_heap(j2_start(2,0))
      value = value.and.MA_free_heap(j2_start(2,1))
      end if

      if (mapping.eq.2) then
      do i=1,6
      value = value.and.MA_free_heap(h_i1_start(2,i,0))
      value = value.and.MA_free_heap(h_i2_start(2,i,0))
      value = value.and.MA_free_heap(h_iq_to_i1(2,i,0))
      value = value.and.MA_free_heap(h_iq_to_i2(2,i,0))
      value = value.and.MA_free_heap(h_iz_to_i2(2,i,0))
      value = value.and.MA_free_heap(h_i1_start(2,i,1))
      value = value.and.MA_free_heap(h_i2_start(2,i,1))
      value = value.and.MA_free_heap(h_iq_to_i1(2,i,1))
      value = value.and.MA_free_heap(h_iq_to_i2(2,i,1))
      value = value.and.MA_free_heap(h_iz_to_i2(2,i,1))
      end do
      end if

      if (.not. value) 
     > call errquit('D3dB_pfft_end:error freeing heap',0,MA_ERR)

      call D3dB_pfft3_queue_end()
      return
      end




*     ***********************************
*     *					*
*     *	        D3dB_cr_pfft3b		*
*     *					*
*     ***********************************

      subroutine D3dB_cr_pfft3b(nb,nbb,A)

*****************************************************
*                                                   *
*      This routine performs the operation of       *
*      a three dimensional complex to complex       *
*      inverse fft                                  *
*           A(nx,ny(nb),nz(nb)) <- FFT3^(-1)[A(kx,ky,kz)]   * 
*                                                   *
*      Entry - 					    *
*              A: a column distribuded 3d block     *
*              tmp: tempory work space must be at   *
*                    least the size of (complex)    *
*                    (nfft*nfft + 1) + 10*nfft      * 
*                                                   *
*       Exit - A is transformed and the imaginary   *
*              part of A is set to zero             *
*       uses - D3dB_c_ptranspose_jk, dcopy           *
*                                                   *
*****************************************************

      implicit none
      integer nb,nbb
      complex*16  A(*)

#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz


*     *** local variables ***
      integer i,j,k,q,indx,ierr
      integer nxh,nxhy,nxhz,indx0,indx1,indx2

      
      !integer tmp1(2),tmp2(2),tmp3(2)
      integer tmp2(2),tmp3(2)
      logical value


      call nwpw_timing_start(1)

*     ***** allocate temporary space ****
      !call D3dB_nfft3d(nb,nfft3d)
      value = MA_push_get(mt_dcpl,(nfft3d(nb)),'ffttmp2',
     >                    tmp2(2),tmp2(1))
      value = value.and.
     >      MA_push_get(mt_dbl,(n2ft3d(nb)),'ffttmp3',tmp3(2),tmp3(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

       nxh = (nx(nb)/2+1)
       nxhz = nxh*nz(nb)
       nxhy = nxh*ny(nb)
      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
*     ********************************************
*     ***         Do a transpose of A          ***
*     ***      A(kx,kz,ky) <- A(kx,ky,kz)      ***
*     ********************************************
c     call D3dB_c_transpose_jk(nb,A,dcpl_mb(tmp2(1)),dbl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(kx,nz(nb),ky) <- fft1d^(-1)[A(kx,kz,ky)]  ***
*     *************************************************
#ifdef MLIB
      !call z1dfft(dbl_mb(tmp3(1)),nz(nb),dcpl_mb(tmpz(1)),-3,ierr)
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

         indx = i+indx0
         indx1 = indx
         do k=1,nz(nb)
            dcpl_mb(tmp2(1)+k-1) = A(indx)
            indx = indx + nxh
         end do
         call z1dfft(dcpl_mb(tmp2(1)),nz(nb),
     >               dcpl_mb(tmpz(1,nb)),-2,ierr)
         do k=1,nz(nb)
            A(indx1) = dcpl_mb(tmp2(1)+k-1)
            indx1 = indx1 + nxh
         end do
       end if
      end do
      indx0 = indx0+nxhz
      end do
      !call dscal((nx(nb)+2)*ny(nb)*nq(nb),dble(nz(nb)),A,1)

#else
      !call dcffti(nz(nb),dcpl_mb(tmp1(1)))
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

#ifdef FFTW3
         indx  = i + indx0
         call dfftw_execute_dft(plans(7,nb),A(indx),A(indx))

#else
         indx  = i + indx0
         indx1 = indx
         do k=1,nz(nb)
            dcpl_mb(tmp2(1)+k-1) = A(indx)
            indx = indx + nxh
         end do
         call dcfftb(nz(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpz(1,nb)))
         do k=1,nz(nb)
            A(indx1) = dcpl_mb(tmp2(1)+k-1)
            indx1 = indx1 + nxh
         end do
#endif

       end if
      end do
      indx0 = indx0 + nxhz
      end do
#endif

*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(kx,ky,nz(nb)) <- A(kx,nz(nb),ky)      ***
*     ********************************************
      call D3dB_c_ptranspose1_jk(nbb,A,dcpl_mb(tmp2(1)),dbl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(kx,ny(nb),nz(nb)) <- fft1d^(-1)[A(kx,ky,nz(nb))]  ***
*     *************************************************
#ifdef MLIB
     
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

          indx  = i + indx0
          indx1 = indx
          do j=1,ny(nb)
            dcpl_mb(tmp2(1)+j-1) = A(indx)
            indx = indx + nxh
          end do
          call z1dfft(dcpl_mb(tmp2(1)),ny(nb),
     >               dcpl_mb(tmpy(1,nb)),-2,ierr)
          do j=1,ny(nb)
            A(indx1) = dcpl_mb(tmp2(1)+j-1)
            indx1 = indx1 + nxh
          end do
        end if
      end do
      indx0 = indx0 + nxhy
      end do
      
#else
    
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
        indx2 = indx2 + 1

        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

#ifdef FFTW3
         indx  = i + indx0
         call dfftw_execute_dft(plans(8,nb),A(indx),A(indx))
#else
         indx  = i + indx0
         indx1 = indx
         do j=1,ny(nb)
            dcpl_mb(tmp2(1)+j-1) = A(indx)
            indx = indx + nxh
         end do
         call dcfftb(ny(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpy(1,nb)))
         do j=1,ny(nb)
            A(indx1) = dcpl_mb(tmp2(1)+j-1)
            indx1 = indx1 + nxh
         end do
#endif

        end if
      end do
      indx0 = indx0 + nxhy
      end do
#endif

*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(nb),ny(nb),nz(nb)) <- fft1d^(-1)[A(kx,ny(nb),nz(nb))]  ***
*     *************************************************
#ifdef MLIB
      !call drc1ft (dbl_mb(tmp3(1)),nx(nb),dcpl_mb(tmp1(1)),-3,ierr)
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         call drc1ft(A(indx),nx(nb),dcpl_mb(tmpx(1,nb)),-2,ierr)
         indx = indx + nxh
      end do
      end do

#else
#ifdef FFTW3
      call dfftw_execute_dft_c2r(plans(3,nb),A,A)

#else
      call cshift1_fftb(nx(nb),ny(nb),nq(nb),1,A)
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         !indx = 1 + (j-1)*(nx(nb)/2+1) + (q-1)*(nx(nb)/2+1)*ny(nb)
         call drfftb(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nxh
      end do
      end do
      call zeroend_fftb(nx(nb),ny(nb),nq(nb),1,A)
#endif
#endif


      !*************************
      !**** hilbert mapping ****
      !*************************
      else


*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(nz(nb),kx,ky) <- fft1d^(-1)[A(kz,kx,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
         call z1dfft(A(indx),nz(nb),dcpl_mb(tmpz(1,nb)),-2,ierr)
         end if
         indx = indx + nz(nb)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dfftw_execute_dft(plans(17,nb),A(indx),A(indx))
         end if
         indx = indx + nz(nb)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftbz_sub2(nq3(nb),nz(nb),
     >                     log_mb(zero_row3(1,nbb)),
     >                     dcpl_mb(tmpz(1,nb)),A)
#else
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dcfftb(nz(nb),A(indx),dcpl_mb(tmpz(1,nb)))
         end if
         indx = indx + nz(nb)
      end do
#endif
#endif
#endif

      call D3dB_c_ptranspose_ijk(nbb,3,A,
     >                           dcpl_mb(tmp2(1)),
     >                           dbl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(ny(nb),nz(nb),kx) <- fft1d^(-1)[A(ky,nz(nb),kx)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
         call z1dfft(A(indx),ny(nb),dcpl_mb(tmpy(1,nb)),-2,ierr)
         end if
         indx = indx + ny(nb)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
            call dfftw_execute_dft(plans(18,nb),A(indx),A(indx))
         end if
         indx = indx + ny(nb)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftby_sub2(nq2(nb),ny(nb),
     >                     log_mb(zero_row2(1,nbb)),
     >                     dcpl_mb(tmpy(1,nb)),A)
#else
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
            call dcfftb(ny(nb),A(indx),dcpl_mb(tmpy(1,nb)))
         end if
         indx = indx + ny(nb)
      end do
#endif
#endif
#endif

      call D3dB_c_ptranspose_ijk(nbb,4,A,
     >                           dcpl_mb(tmp2(1)),
     >                           dbl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(nb),ny(nb),nz(nb)) <- fft1d^(-1)[A(kx,ny(nb),nz(nb))]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq1(nb)
         !indx = 1 + (q-1)*(nx(nb)/2+1)
         call drc1ft(A(indx),nx(nb),dcpl_mb(tmpx(1,nb)),-2,ierr)
         indx = indx + nxh
      end do
#else

#ifdef FFTW3
         call dfftw_execute_dft_c2r(plans(13,nb),A,A)
#else
#ifdef USE_OPENMP
      call cshift1_fftb(nx(nb),nq1(nb),1,1,A)
      call D3dB_pfftbx_sub(nq1(nb),nx(nb),nxh,dcpl_mb(tmpx(1,nb)),A)
      call zeroend_fftb(nx(nb),nq1(nb),1,1,A)
#else

      call cshift1_fftb(nx(nb),nq1(nb),1,1,A)
      indx = 1
      do q=1,nq1(nb)
         call drfftb(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nxh
      end do
      call zeroend_fftb(nx(nb),nq1(nb),1,1,A)
#endif
#endif
#endif

      end if
    
*     **** deallocate temporary space  ****
      value = MA_pop_stack(tmp3(2))
      value = MA_pop_stack(tmp2(2))
      !value = MA_pop_stack(tmp1(2))

      call nwpw_timing_end(1)
      return
      end




*     ***********************************
*     *					*
*     *	        D3dB_rc_pfft3f		*
*     *					*
*     ***********************************

      subroutine D3dB_rc_pfft3f(nb,nbb,A)

*****************************************************
*                                                   *
*      This routine performs the operation of       *
*      a three dimensional complex to complex fft   *
*           A(kx,ky,kz) <- FFT3[A(nx(nb),ny(nb),nz(nb))]        * 
*                                                   *
*      Entry - 					    *
*              A: a column distribuded 3d block     *
*              tmp: tempory work space must be at   *
*                    least the size of (complex)    *
*                    (nfft*nfft + 1) + 10*nfft      * 
*                                                   *
*       Exit - A is transformed                     *
*                                                   *
*       uses - ptranspose1 subroutine                *
*                                                   *
*****************************************************

      implicit none
      integer nb,nbb
      complex*16  A(*)

#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz


*     *** local variables ***
      integer i,j,k,q,indx,indx1,ierr,indx2,indx0
      integer nxh,nxhy,nxhz

      !integer tmp1(2),tmp2(2),tmp3(2)
      integer tmp2(2),tmp3(2)
      logical value


      call nwpw_timing_start(1)


*     ***** allocate temporary space ****
      !call D3dB_nfft3d(nb,nfft3d)
      value = MA_push_get(mt_dcpl,(nfft3d(nb)),'tmp2',tmp2(2),tmp2(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d(nb)),'tmp3',tmp3(2),tmp3(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      nxh = (nx(nb)/2+1)
      nxhz = nxh*nz(nb)
      nxhy = nxh*ny(nb)

      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
*     ********************************************
*     ***     do fft along nx(nb) dimension        ***
*     ***   A(kx,ny(nb),nz(nb)) <- fft1d[A(nx(nb),ny(nb),nz(nb))]  ***
*     ********************************************
#ifdef MLIB
      call drcfts(A,nx(nb),1,ny(nb)*nq(nb),
     >                  nx(nb)+2,1,ierr)

#else

#ifdef FFTW3
      call dfftw_execute_dft_r2c(plans(4,nb),A,A)

#else
      !call drffti(nx(nb),dcpl_mb(tmp1(1)))
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         call drfftf(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nxh
      end do
      end do
      call cshift_fftf(nx(nb),ny(nb),nq(nb),1,A)
#endif
#endif


*     ********************************************
*     ***     do fft along ny(nb) dimension        ***
*     ***   A(kx,ky,nz(nb)) <- fft1d[A(kx,ny(nb),nz(nb))]  ***
*     ********************************************

#ifdef MLIB
      
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

         indx  = i + indx0
         indx1 = indx
         do j=1,ny(nb)
            dcpl_mb(tmp2(1)+j-1) = A(indx)
            indx = indx + nxh
         end do
         call z1dfft(dcpl_mb(tmp2(1)),ny(nb),dcpl_mb(tmpy(1,nb)),1,ierr)
         do j=1,ny(nb)
            A(indx1) = dcpl_mb(tmp2(1)+j-1)
            indx1 = indx1 + nxh
         end do
        
        end if
      end do
      indx0 = indx0 + nxhy
      end do
#else

       indx0 = 0
       indx2 = 0
       do q=1,nq(nb)
       do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

#ifdef FFTW3
          indx  = i + indx0
          call dfftw_execute_dft(plans(9,nb),A(indx),A(indx))

#else
          indx  = i + indx0
          indx1 = indx
          do k=1,ny(nb)
             dcpl_mb(tmp2(1)+k-1) = A(indx)
             indx = indx + nxh
          end do
          call dcfftf(ny(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpy(1,nb)))
          do k=1,ny(nb)
             A(indx1) = dcpl_mb(tmp2(1)+k-1)
             indx1 = indx1 + nxh
          end do
#endif

        end if
       end do
       indx0 = indx0 + nxhy
       end do

#endif


*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(ky,nz(nb),ky) <- A(kx,ky,nz(nb))      ***
*     ********************************************
      call D3dB_c_ptranspose2_jk(nbb,A,dcpl_mb(tmp2(1)),dbl_mb(tmp3(1)))
c      call D3dB_c_transpose_jk(nbb,A,dcpl_mb(tmp2(1)),dbl_mb(tmp3(1)))


*     ********************************************
*     ***     do fft along nz(nb) dimension        ***
*     ***   A(kx,kz,ky) <- fft1d[A(kx,nz(nb),ky)]  ***
*     ********************************************
#ifdef MLIB
      
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

         indx  = i + indx0
         indx1 = indx
         do k=1,nz(nb)
            dcpl_mb(tmp2(1)+k-1) = A(indx)
            indx = indx + nxh
         end do
         call z1dfft(dcpl_mb(tmp2(1)),nz(nb),dcpl_mb(tmpz(1,nb)),1,ierr)
         do k=1,nz(nb)
            A(indx1) = dcpl_mb(tmp2(1)+k-1)
            indx1 = indx1 + nxh
         end do
        end if
      end do
      indx0 = indx0 + nxhz
      end do
#else

       indx0 = 0
       indx2 = 0
       do q=1,nq(nb)
       do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then
 
#ifdef FFTW3
          indx  = i + indx0
          call dfftw_execute_dft(plans(10,nb),A(indx),A(indx))

#else
          indx  = i + indx0
          indx1 = indx
          do k=1,nz(nb)
             dcpl_mb(tmp2(1)+k-1) = A(indx)
             indx = indx + nxh
          end do
          call dcfftf(nz(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpz(1,nb)))
          do k=1,nz(nb)
             A(indx1) = dcpl_mb(tmp2(1)+k-1)
             indx1 = indx1 + nxh
          end do
#endif
 
        end if
       end do
       indx0 = indx0 + nxhz
       end do

#endif

*     ********************************************
*     ***         Do a transpose of A          ***
*     ***      A(kx,ky,kz) <- A(kx,kz,ky)      ***
*     ********************************************
c     call D3dB_c_transpose_jk(nb,A,dcpl_mb(tmp2(1)),dbl_mb(tmp3(1)))



      !*************************
      !**** hilbert mapping ****
      !*************************
      else

*     ********************************************
*     ***     do fft along nx(nb) dimension        ***
*     ***   A(kx,ny(nb),nz(nb)) <- fft1d[A(nx(nb),ny(nb),nz(nb))]  ***
*     ********************************************
#ifdef MLIB
      call drcfts(A,nx(nb),1,nq1(nb),
     >                  nx(nb)+2,1,ierr)
#else

#ifdef FFTW3
          call dfftw_execute_dft_r2c(plans(14,nb),A,A)

#else
#ifdef USE_OPENMP
      call D3dB_pfftfx_sub(nq1(nb),nx(nb),nxh,dcpl_mb(tmpx(1,nb)),A)
      call cshift_fftf(nx(1),nq1(1),1,1,A)
#else
      indx = 1
      do q=1,nq1(nb)
         call drfftf(nx(nb),A(indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nxh
      end do
      call cshift_fftf(nx(nb),nq1(nb),1,1,A)
#endif
#endif
#endif

      call D3dB_c_ptranspose_ijk(nbb,1,A,
     >                           dcpl_mb(tmp2(1)),
     >                           dbl_mb(tmp3(1)))

*     ********************************************
*     ***     do fft along ny(nb) dimension        ***
*     ***   A(ky,nz(nb),kx) <- fft1d[A(ny(nb),nz(nb),kx)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
         call z1dfft(A(indx),ny(nb),dcpl_mb(tmpy(1,nb)),1,ierr)
         end if
         indx = indx + ny(nb)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
            call dfftw_execute_dft(plans(19,nb),A(indx),A(indx))
         end if
         indx = indx + ny(nb)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftfy_sub2(nq2(nb),ny(nb),
     >                     log_mb(zero_row2(1,nbb)),
     >                     dcpl_mb(tmpy(1,nb)),A)
#else
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
            call dcfftf(ny(nb),A(indx),dcpl_mb(tmpy(1,nb)))
         end if
         indx = indx + ny(nb)
      end do
#endif
#endif
#endif

      call D3dB_c_ptranspose_ijk(nbb,2,A,
     >                          dcpl_mb(tmp2(1)),
     >                          dbl_mb(tmp3(1)))

*     ********************************************
*     ***     do fft along nz(nb) dimension        ***
*     ***   A(kz,kx,ky) <- fft1d[A(nz(nb),kx,ky)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
         call z1dfft(A(indx),nz(nb),dcpl_mb(tmpz(1,nb)),1,ierr)
         end if
         indx = indx + nz(nb)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dfftw_execute_dft(plans(20,nb),A(indx),A(indx))
         end if
         indx = indx + nz(nb)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftfz_sub2(nq3(nb),nz(nb),
     >                     log_mb(zero_row3(1,nbb)),
     >                     dcpl_mb(tmpz(1,nb)),A)
#else
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dcfftf(nz(nb),A(indx),dcpl_mb(tmpz(1,nb)))
         end if
         indx = indx + nz(nb)
      end do
#endif
#endif
#endif

      end if

*     **** deallocate temporary space  ****
      value = MA_pop_stack(tmp3(2))
      value = MA_pop_stack(tmp2(2))
      !value = MA_pop_stack(tmp1(2))
      call nwpw_timing_end(1)
      return
      end





*     ***********************************
*     *					*
*     *	   D3dB_c_ptranspose_jk_init	*
*     *					*
*     ***********************************

      subroutine D3dB_c_ptranspose_jk_init(nbb,zero_arow3)
      implicit none
      integer nbb
      logical zero_arow3(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "D3dB.fh"


*     **** indexing variables ****
      integer iq_to_i1(2,0:1)
      integer iq_to_i2(2,0:1)
      integer iz_to_i2(2,0:1)
      integer i1_start(2,0:1)
      integer i2_start(2,0:1)
      common / ptrans_blk1 / iq_to_i1,iq_to_i2,iz_to_i2,
     >                       i1_start,i2_start

*     **** indexing variables ****
      integer jq_to_i1(2,0:1)
      integer jq_to_i2(2,0:1)
      integer jz_to_i2(2,0:1)
      integer j1_start(2,0:1)
      integer j2_start(2,0:1)
      common / ptrans_blk2 / jq_to_i1,jq_to_i2,jz_to_i2,
     >                       j1_start,j2_start



*     **** local variables ****
      integer proc_to,proc_from
      integer pto,qto,np,taskid
      integer pfrom,qfrom
      integer phere,qhere
      integer index1,index2,index3
      integer jndex1,jndex2,jndex3
      integer itmp,ii,jj
      integer i,j,k,it
      logical value



*     **** allocate ptrans_blk1 and ptrans_blk2 common block ****
      value = MA_alloc_get(mt_int,((nx(1)/2+1)*ny(1)*nq(1)),
     >                     'piq_to_i1',iq_to_i1(2,nbb),iq_to_i1(1,nbb))
      value=value.and.MA_alloc_get(mt_int,((nx(1)/2+1)*ny(1)*nq(1)),
     >                     'piq_to_i2',iq_to_i2(2,nbb),iq_to_i2(1,nbb))
      value=value.and.MA_alloc_get(mt_int,((nx(1)/2+1)*ny(1)*nq(1)),
     >                     'piz_to_i2',iz_to_i2(2,nbb),iz_to_i2(1,nbb))

      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'pi1_start',i1_start(2,nbb),i1_start(1,nbb))
      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'pi2_start',i2_start(2,nbb),i2_start(1,nbb))


      value = MA_alloc_get(mt_int,((nx(1)/2+1)*ny(1)*nq(1)),
     >                     'riq_to_i1',jq_to_i1(2,nbb),jq_to_i1(1,nbb))
      value=value.and.MA_alloc_get(mt_int,((nx(1)/2+1)*ny(1)*nq(1)),
     >                     'riq_to_i2',jq_to_i2(2,nbb),jq_to_i2(1,nbb))
      value=value.and.MA_alloc_get(mt_int,((nx(1)/2+1)*ny(1)*nq(1)),
     >                     'riz_to_i2',jz_to_i2(2,nbb),jz_to_i2(1,nbb))

      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'ri1_start',j1_start(2,nbb),j1_start(1,nbb))
      value = value.and.MA_alloc_get(mt_int,(nz(1)+1),
     >                     'ri2_start',j2_start(2,nbb),j2_start(1,nbb))

      if (.not. value) 
     > call errquit('D3dB_ptranspose_jk_init:out of heap',0,MA_ERR)

      call Parallel2d_taskid_i(taskid)
      call Parallel2d_np_i(np)


      index1 = 1 
      index2 = 1
      index3 = 1
      jndex1 = 1 
      jndex2 = 1
      jndex3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(i1_start(1,nbb)+it) = index1
         int_mb(i2_start(1,nbb)+it) = index2
         int_mb(j1_start(1,nbb)+it) = jndex1
         int_mb(j2_start(1,nbb)+it) = jndex2

         do k=1,nz(1)
         do j=1,ny(1)

*           **** packing scheme **** 
            call D3dB_ktoqp(1,k,qhere,phere)
            call D3dB_ktoqp(1,j,qto,pto)
            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               do i=1,(nx(1)/2+1)
                  ii = i + (nx(1)/2+1)*(k-1)
                  jj = i + (nx(1)/2+1)*(j-1)
                  itmp = i + (j-1)*(nx(1)/2+1) 
     >                     + (qhere-1)*(nx(1)/2+1)*ny(1)

                  if (.not.zero_arow3(ii)) then
                  int_mb(iq_to_i1(1,nbb)+index1-1) = itmp
                  index1 = index1 + 1
                  end if

                  if (.not.zero_arow3(jj)) then
                  int_mb(jq_to_i1(1,nbb)+jndex1-1) = itmp
                  jndex1 = jndex1 + 1
                  end if

               end do
            end if
             
*           **** unpacking scheme ****
            call D3dB_ktoqp(1,j,qhere,phere)
            call D3dB_ktoqp(1,k,qfrom,pfrom)
            if ((phere.eq.taskid).and.(pfrom.eq.proc_from)) then
               do i=1,(nx(1)/2+1)
                  ii = i + (nx(1)/2+1)*(k-1)
                  jj = i + (nx(1)/2+1)*(j-1)
                  itmp = i + (k-1)*(nx(1)/2+1) 
     >                     + (qhere-1)*(nx(1)/2+1)*ny(1)
                  if (zero_arow3(ii)) then
                  int_mb(iz_to_i2(1,nbb)+index3-1) = itmp
                  index3 = index3 + 1
                  else
                  int_mb(iq_to_i2(1,nbb)+index2-1) = itmp
                  index2 = index2 + 1
                  end if

                  if (zero_arow3(jj)) then
                  int_mb(jz_to_i2(1,nbb)+jndex3-1) = itmp
                  jndex3 = jndex3 + 1
                  else
                  int_mb(jq_to_i2(1,nbb)+jndex2-1) = itmp
                  jndex2 = jndex2 + 1
                  end if
               end do
            end if
         end do
         end do
      end do
      int_mb(i1_start(1,nbb)+np) = index1
      int_mb(i2_start(1,nbb)+np) = index2
      int_mb(j1_start(1,nbb)+np) = jndex1
      int_mb(j2_start(1,nbb)+np) = jndex2


      return
      end





*     ***********************************
*     *					*
*     *	   D3dB_c_ptranspose_ijk_init	*
*     *					*
*     ***********************************

      subroutine D3dB_c_ptranspose_ijk_init(nbb,zero_arow2,zero_arow3)
      implicit none
      integer nbb
      logical zero_arow2(*)
      logical zero_arow3(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "D3dB.fh"


*     *** hilbert tranpose data structure ****
      integer h_iq_to_i1(2,6,0:1)
      integer h_iq_to_i2(2,6,0:1)
      integer h_iz_to_i2(2,6,0:1)
      integer h_iz_to_i2_count(6,0:1)
      integer h_i1_start(2,6,0:1)
      integer h_i2_start(2,6,0:1)
      common / ptrans_blk_ijk / h_iq_to_i1,
     >                         h_iq_to_i2,
     >                         h_iz_to_i2,
     >                         h_iz_to_i2_count,
     >                         h_i1_start,
     >                         h_i2_start

*     **** local variables ****
      logical value,iszero
      integer proc_to,proc_from
      integer pto,qto,np,taskid
      integer phere,qhere
      integer index1,index2,index3,itmp
      integer i,j,k,it


      call Parallel2d_taskid_i(taskid)
      call Parallel2d_np_i(np)


*     ********************************************************
*     **** map1to2 mapping - done - tranpose operation #1  ***
*     ****   (ny,nz,nx/2+1)  <-- (nx/2+1,ny,nz)            ***
*     ****   use zero_arow2                                ***
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,((nx(1)/2+1)*nq1(1)),
     >                     'h_iq_to_i1_1',
     >                      h_iq_to_i1(2,1,nbb),
     >                      h_iq_to_i1(1,1,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i2_1',
     >                      h_iq_to_i2(2,1,nbb),
     >                      h_iq_to_i2(1,1,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iz_to_i2_1',
     >                      h_iz_to_i2(2,1,nbb),
     >                      h_iz_to_i2(1,1,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_1',
     >                      h_i1_start(2,1,nbb),
     >                      h_i1_start(1,1,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_1',
     >                      h_i2_start(2,1,nbb),
     >                      h_i2_start(1,1,nbb))
      if (.not.value)
     > call errquit('D3dB_transpose_ijk_initt:out of heap',0,MA_ERR)

      index1 = 1 
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,1,nbb)+it) = index1
         int_mb(h_i2_start(1,1,nbb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,(nx(1)/2+1)
            iszero = zero_arow2(i+(k-1)*(nx(1)/2+1)) 

*           **** packing scheme **** 
            phere = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qhere = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))

            pto   = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qto   = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))
            
           
            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = i + (qhere-1)*(nx(1)/2+1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,1,nbb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if
             
*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = j + (qto-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,1,nbb)+index2-1) =  itmp
               index2 = index2 + 1
               else
               int_mb(h_iz_to_i2(1,1,nbb)+index3-1) =  itmp
               index3 = index3 + 1
               end if
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,1,nbb)+np) = index1
      int_mb(h_i2_start(1,1,nbb)+np) = index2
      h_iz_to_i2_count(1,nbb) = index3 - 1





*     *********************************************************
*     **** map2to3 mapping - done - transpose operation #2 ****
*     ****    (nz,nx/2+1,ny)  <-- (ny,nz,nx/2+1)           ****
*     ****    use zero_arow3                               ****
*     *********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i1_2',
     >                      h_iq_to_i1(2,2,nbb),
     >                      h_iq_to_i1(1,2,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i2_2',
     >                      h_iq_to_i2(2,2,nbb),
     >                      h_iq_to_i2(1,2,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iz_to_i2_2',
     >                      h_iz_to_i2(2,2,nbb),
     >                      h_iz_to_i2(1,2,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_2',
     >                      h_i1_start(2,2,nbb),
     >                      h_i1_start(1,2,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_2',
     >                      h_i2_start(2,2,nbb),
     >                      h_i2_start(1,2,nbb))
      if (.not.value)
     > call errquit('D3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,2,nbb)+it) = index1
         int_mb(h_i2_start(1,2,nbb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,(nx(1)/2+1)

            iszero = zero_arow3(i+(j-1)*(nx(1)/2+1))

*           **** packing scheme ****
            phere = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qhere = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))

            pto   = int_mb(p_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))
            qto   = int_mb(q_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = j + (qhere-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,2,nbb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = k + (qto-1)*nz(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,2,nbb)+index2-1) = itmp
               index2 = index2 + 1
               else  
               int_mb(h_iz_to_i2(1,2,nbb)+index3-1) = itmp
               index3 = index3 + 1
               end if
            end if


         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,2,nbb)+np) = index1
      int_mb(h_i2_start(1,2,nbb)+np) = index2
      h_iz_to_i2_count(2,nbb) = index3 - 1






*     ********************************************************
*     **** map3to2 mapping - done - tranpose operation #3 ****
*     ****  (ny,nz,nx/2+1)  <-- (nz,nx/2+1,ny)            ****
*     ****   use zero_arow3                               ****
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i1_3',
     >                      h_iq_to_i1(2,3,nbb),
     >                      h_iq_to_i1(1,3,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i2_3',
     >                      h_iq_to_i2(2,3,nbb),
     >                      h_iq_to_i2(1,3,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iz_to_i2_3',
     >                      h_iz_to_i2(2,3,nbb),
     >                      h_iz_to_i2(1,3,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_3',
     >                      h_i1_start(2,3,nbb),
     >                      h_i1_start(1,3,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_3',
     >                      h_i2_start(2,3,nbb),
     >                      h_i2_start(1,3,nbb))
      if (.not.value)
     > call errquit('D3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,3,nbb)+it) = index1
         int_mb(h_i2_start(1,3,nbb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,(nx(1)/2+1)

            iszero = zero_arow3(i+(j-1)*(nx(1)/2+1))

*           **** packing scheme ****
            phere = int_mb(p_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))
            qhere = int_mb(q_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))

            pto   = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qto   = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = k + (qhere-1)*nz(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,3,nbb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = j + (qto-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,3,nbb)+index2-1) = itmp
               index2 = index2 + 1
               else
               int_mb(h_iz_to_i2(1,3,nbb)+index3-1) = itmp
               index3 = index3 + 1
               end if
            end if


         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,3,nbb)+np) = index1
      int_mb(h_i2_start(1,3,nbb)+np) = index2
      h_iz_to_i2_count(3,nbb) = index3 - 1




*     ********************************************************
*     **** map2to1 mapping - done - tranpose operation #4 ****
*     ****  (nx/2+1,ny,nz)  <-- (ny,nz,nx/2+1)            ****
*     ****  use zero_arow2                                ****
*     ********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(ny(1)*nq2(1)),
     >                     'h_iq_to_i1_4',
     >                      h_iq_to_i1(2,4,nbb),
     >                      h_iq_to_i1(1,4,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,((nx(1)/2+1)*nq1(1)),
     >                     'h_iq_to_i2_4',
     >                      h_iq_to_i2(2,4,nbb),
     >                      h_iq_to_i2(1,4,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,((nx(1)/2+1)*nq1(1)),
     >                     'h_iz_to_i2_4',
     >                      h_iz_to_i2(2,4,nbb),
     >                      h_iz_to_i2(1,4,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_4',
     >                      h_i1_start(2,4,nbb),
     >                      h_i1_start(1,4,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_4',
     >                      h_i2_start(2,4,nbb),
     >                      h_i2_start(1,4,nbb))
      if (.not.value)
     > call errquit('D3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,4,nbb)+it) = index1
         int_mb(h_i2_start(1,4,nbb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,(nx(1)/2+1)

            iszero = zero_arow2(i+(k-1)*(nx(1)/2+1))

*           **** packing scheme ****
            phere = int_mb(p_map2(1,1)+(k-1)+(i-1)*nz(1))
            qhere = int_mb(q_map2(1,1)+(k-1)+(i-1)*nz(1))

            pto   = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qto   = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = j + (qhere-1)*ny(1)
               if (.not.iszero) then
               int_mb(h_iq_to_i1(1,4,nbb)+index1-1) = itmp
               index1 = index1 + 1
               end if
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = i + (qto-1)*(nx(1)/2+1)
               if (.not.iszero) then
               int_mb(h_iq_to_i2(1,4,nbb)+index2-1) = itmp
               index2 = index2 + 1
               else
               int_mb(h_iz_to_i2(1,4,nbb)+index3-1) = itmp
               index3 = index3 + 1
               end if
            end if


         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,4,nbb)+np) = index1
      int_mb(h_i2_start(1,4,nbb)+np) = index2
      h_iz_to_i2_count(4,nbb) = index3 - 1





*     **********************************************************
*     **** map1to3 mapping  - done - tranpose operation # 5 ****
*     **********************************************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,((nx(1)/2+1)*nq1(1)),
     >                     'h_iq_to_i1_5',
     >                      h_iq_to_i1(2,5,nbb),
     >                      h_iq_to_i1(1,5,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i2_5',
     >                      h_iq_to_i2(2,5,nbb),
     >                      h_iq_to_i2(1,5,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iz_to_i2_5',
     >                      h_iz_to_i2(2,5,nbb),
     >                      h_iz_to_i2(1,5,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_5',
     >                      h_i1_start(2,5,nbb),
     >                      h_i1_start(1,5,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_5',
     >                      h_i2_start(2,5,nbb),
     >                      h_i2_start(1,5,nbb))
      if (.not.value)
     > call errquit('D3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,5,nbb)+it) = index1
         int_mb(h_i2_start(1,5,nbb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,(nx(1)/2+1)

*           **** packing scheme ****
            phere = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qhere = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))

            pto   = int_mb(p_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))
            qto   = int_mb(q_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = i + (qhere-1)*(nx(1)/2+1)
               int_mb(h_iq_to_i1(1,5,nbb)+index1-1) = itmp
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = k + (qto-1)*nz(1)
               int_mb(h_iq_to_i2(1,5,nbb)+index2-1) = itmp
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,5,nbb)+np) = index1
      int_mb(h_i2_start(1,5,nbb)+np) = index2
      h_iz_to_i2_count(5,nbb) = index3 - 1






*     *************************
*     **** map3to1 mapping ****
*     *************************

*     **** allocate trans_blk_ijk common block ****
      value = MA_alloc_get(mt_int,(nz(1)*nq3(1)),
     >                     'h_iq_to_i1_6',
     >                      h_iq_to_i1(2,6,nbb),
     >                      h_iq_to_i1(1,6,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,((nx(1)/2+1)*nq1(1)),
     >                     'h_iq_to_i2_6',
     >                      h_iq_to_i2(2,6,nbb),
     >                      h_iq_to_i2(1,6,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,((nx(1)/2+1)*nq1(1)),
     >                     'h_iz_to_i2_6',
     >                      h_iz_to_i2(2,6,nbb),
     >                      h_iz_to_i2(1,6,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i1_start_6',
     >                      h_i1_start(2,6,nbb),
     >                      h_i1_start(1,6,nbb))
      value = value.and.
     >        MA_alloc_get(mt_int,(np+1),
     >                     'h_i2_start_6',
     >                      h_i2_start(2,6,nbb),
     >                      h_i2_start(1,6,nbb))
      if (.not.value)
     > call errquit('D3dB_transpose_ijk_init:out of heap',0,MA_ERR)

      index1 = 1
      index2 = 1
      index3 = 1
      do it=0,np-1
         proc_to   = mod(taskid+it,np)
         proc_from = mod(taskid-it+np,np)
         int_mb(h_i1_start(1,6,nbb)+it) = index1
         int_mb(h_i2_start(1,6,nbb)+it) = index2

         do k=1,nz(1)
         do j=1,ny(1)
         do i=1,(nx(1)/2+1)

*           **** packing scheme ****
            phere = int_mb(p_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))
            qhere = int_mb(q_map3(1,1)+(i-1)+(j-1)*(nx(1)/2+1))

            pto   = int_mb(p_map1(1,1)+(j-1)+(k-1)*ny(1))
            qto   = int_mb(q_map1(1,1)+(j-1)+(k-1)*ny(1))


            if ((phere.eq.taskid).and.(pto.eq.proc_to)) then
               itmp = k + (qhere-1)*nz(1)
               int_mb(h_iq_to_i1(1,6,nbb)+index1-1) = itmp
               index1 = index1 + 1
            end if

*           **** unpacking scheme ****
            if ((pto.eq.taskid).and.(phere.eq.proc_from)) then
               itmp = i + (qto-1)*(nx(1)/2+1)
               int_mb(h_iq_to_i2(1,6,nbb)+index2-1) = itmp
               index2 = index2 + 1
            end if

         end do
         end do
         end do

      end do
      int_mb(h_i1_start(1,6,nbb)+np) = index1
      int_mb(h_i2_start(1,6,nbb)+np) = index2
      h_iz_to_i2_count(6,nbb) = index3 - 1


      return
      end






*     ***********************************
*     *					*
*     *	        D3dB_cr_mpfft3b		*
*     *					*
*     ***********************************

      subroutine D3dB_cr_mpfft3b(nb,nbb,m,A)

*****************************************************
*                                                   *
*      This routine performs the operation of       *
*      a three dimensional complex to complex       *
*      inverse fft                                  *
*           A(nx,ny(nb),nz(nb)) <- FFT3^(-1)[A(kx,ky,kz)]   * 
*                                                   *
*      Entry - 					    *
*              A: a column distribuded 3d block     *
*              tmp: tempory work space must be at   *
*                    least the size of (complex)    *
*                    (nfft*nfft + 1) + 10*nfft      * 
*                                                   *
*       Exit - A is transformed and the imaginary   *
*              part of A is set to zero             *
*       uses - D3dB_c_ptranspose_jk, dcopy           *
*                                                   *
*****************************************************

      implicit none
      integer nb,nbb,m
      complex*16  A(*)

#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz



*     *** local variables ***
      integer i,j,k,q,indx,ierr,ii,shift,shift0
      integer nxh,nxhy,nxhz,indx0,indx1,indx2

      
      !integer tmp1(2),tmp2(2),tmp3(2)
      integer tmp2(2),tmp3(2)
      logical value


      call nwpw_timing_start(1)

*     ***** allocate temporary space ****
      !call D3dB_nfft3d(nb,nfft3d)
      value = MA_push_get(mt_dcpl,(nfft3d(nb)),'ffttmp2',
     >                    tmp2(2),tmp2(1))
      value = value.and.
     >      MA_push_get(mt_dbl,(n2ft3d(nb)),'ffttmp3',tmp3(2),tmp3(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

       nxh = (nx(nb)/2+1)
       nxhz = nxh*nz(nb)
       nxhy = nxh*ny(nb)
      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

      shift = 1
      do ii=1,m
      shift0=shift-1
*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(kx,nz(nb),ky) <- fft1d^(-1)[A(kx,kz,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

         indx = i+indx0
         indx1 = indx
         do k=1,nz(nb)
            dcpl_mb(tmp2(1)+k-1) = A(indx+shift0)
            indx = indx + nxh
         end do
         call z1dfft(dcpl_mb(tmp2(1)),nz(nb),
     >               dcpl_mb(tmpz(1,nb)),-2,ierr)
         do k=1,nz(nb)
            A(indx1+shift0) = dcpl_mb(tmp2(1)+k-1)
            indx1 = indx1 + nxh
         end do
       end if
      end do
      indx0 = indx0+nxhz
      end do
      !call dscal((nx(nb)+2)*ny(nb)*nq(nb),dble(nz(nb)),A(shift),1)

#else


      !call dcffti(nz(nb),dcpl_mb(tmp1(1)))
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

#ifdef FFTW3
         indx = i+indx0+shift0
         call dfftw_execute_dft(plans(7,nb),A(indx),A(indx))

#else
         indx  = i + indx0
         indx1 = indx
         do k=1,nz(nb)
            dcpl_mb(tmp2(1)+k-1) = A(shift0+indx)
            indx = indx + nxh
         end do
         call dcfftb(nz(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpz(1,nb)))
         do k=1,nz(nb)
            A(shift0+indx1) = dcpl_mb(tmp2(1)+k-1)
            indx1 = indx1 + nxh
         end do
#endif

       end if
      end do
      indx0 = indx0 + nxhz
      end do
#endif


*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(kx,ky,nz(nb)) <- A(kx,nz(nb),ky)      ***
*     ********************************************
      call D3dB_c_ptranspose1_jk(nbb,A(shift),
     >                           dcpl_mb(tmp2(1)),
     >                           dbl_mb(tmp3(1)))
      shift = shift + nfft3d(nb)
      end do

      shift = 1
      do ii=1,m
      shift0 = shift-1
*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(kx,ny(nb),nz(nb)) <- fft1d^(-1)[A(kx,ky,nz(nb))]  ***
*     *************************************************
#ifdef MLIB
     
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

          indx  = i + indx0
          indx1 = indx
          do j=1,ny(nb)
            dcpl_mb(tmp2(1)+j-1) = A(shift0+indx)
            indx = indx + nxh
          end do
          call z1dfft(dcpl_mb(tmp2(1)),ny(nb),
     >               dcpl_mb(tmpy(1,nb)),-2,ierr)
          do j=1,ny(nb)
            A(shift0+indx1) = dcpl_mb(tmp2(1)+j-1)
            indx1 = indx1 + nxh
          end do
        end if
      end do
      indx0 = indx0 + nxhy
      end do
      
#else
    
      indx0 = 0
      indx2 = 0
      do q=1,nq(nb)
      do i=1,nxh
        indx2 = indx2 + 1

        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

#ifdef FFTW3
         indx = i+indx0+shift0
         call dfftw_execute_dft(plans(8,nb),A(indx),A(indx))
#else
         indx  = i + indx0
         indx1 = indx
         do j=1,ny(nb)
            dcpl_mb(tmp2(1)+j-1) = A(shift0+indx)
            indx = indx + nxh
         end do
         call dcfftb(ny(nb),dcpl_mb(tmp2(1)),dcpl_mb(tmpy(1,nb)))
         do j=1,ny(nb)
            A(shift0+indx1) = dcpl_mb(tmp2(1)+j-1)
            indx1 = indx1 + nxh
         end do
#endif

        end if
      end do
      indx0 = indx0 + nxhy
      end do
#endif

*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(nb),ny(nb),nz(nb)) <- fft1d^(-1)[A(kx,ny(nb),nz(nb))]  ***
*     *************************************************
#ifdef MLIB
      !call drc1ft (dbl_mb(tmp3(1)),nx(nb),dcpl_mb(tmp1(1)),-3,ierr)
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         call drc1ft(A(shift0+indx),nx(nb),dcpl_mb(tmpx(1,nb)),-2,ierr)
         indx = indx + nxh
      end do
      end do

#else

#ifdef FFTW3
      call dfftw_execute_dft_c2r(plans(3,nb),A(shift0),A(shift0))

#else
      call cshift1_fftb(nx(nb),ny(nb),nq(nb),1,A(shift))
      indx = 1
      do q=1,nq(nb)
      do j=1,ny(nb)
         !indx = 1 + (j-1)*(nx(nb)/2+1) + (q-1)*(nx(nb)/2+1)*ny(nb)
         call drfftb(nx(nb),A(shift0+indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nxh
      end do
      end do
      call zeroend_fftb(nx(nb),ny(nb),nq(nb),1,A(shift))
#endif

#endif

      shift = shift + nfft3d(nb)
      end do

      !*************************
      !**** hilbert mapping ****
      !*************************
      else

      shift = 1
      do ii=1,m
      shift0=shift-1

*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(nz(nb),kx,ky) <- fft1d^(-1)[A(kz,kx,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
         call z1dfft(A(shift0+indx),nz(nb),dcpl_mb(tmpz(1,nb)),-2,ierr)
         end if
         indx = indx + nz(nb)
      end do
#else
      indx = 1
      do q=1,nq3(nb)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then

#ifdef FFTW3
         call dfftw_execute_dft(plans(17,nb),
     >                          A(indx+shift0),A(indx+shift0))
#else
         call dcfftb(nz(nb),A(shift0+indx),dcpl_mb(tmpz(1,nb)))
#endif

         end if
         indx = indx + nz(nb)
      end do
#endif

      call D3dB_c_ptranspose_ijk(nbb,3,A(shift),
     >                           dcpl_mb(tmp2(1)),
     >                           dbl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(ny(nb),nz(nb),kx) <- fft1d^(-1)[A(ky,nz(nb),kx)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
         call z1dfft(A(shift0+indx),ny(nb),dcpl_mb(tmpy(1,nb)),-2,ierr)
         end if
         indx = indx + ny(nb)
      end do
#else
      indx = 1
      do q=1,nq2(nb)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then

#ifdef FFTW3
         call dfftw_execute_dft(plans(18,nb),
     >                          A(indx+shift0),A(indx+shift0))
#else
         call dcfftb(ny(nb),A(shift0+indx),dcpl_mb(tmpy(1,nb)))
#endif

         end if
         indx = indx + ny(nb)
      end do
#endif

      call D3dB_c_ptranspose_ijk(nbb,4,A(shift),
     >                           dcpl_mb(tmp2(1)),
     >                           dbl_mb(tmp3(1)))

*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(nb),ny(nb),nz(nb)) <- fft1d^(-1)[A(kx,ny(nb),nz(nb))]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq1(nb)
         !indx = 1 + (q-1)*(nx(nb)/2+1)
         call drc1ft(A(shift0+indx),nx(nb),dcpl_mb(tmpx(1,nb)),-2,ierr)
         indx = indx + nxh
      end do
#else

#ifdef FFTW3
      call dfftw_execute_dft_c2r(plans(13,nb),A(shift0),A(shift0))

#else
      call cshift1_fftb(nx(nb),nq1(nb),1,1,A(shift))
      indx = 1
      do q=1,nq1(nb)
         !indx = 1 + (q-1)*(nx(nb)/2+1)
         call drfftb(nx(nb),A(shift0+indx),dcpl_mb(tmpx(1,nb)))
         indx = indx + nxh
      end do
      call zeroend_fftb(nx(nb),nq1(nb),1,1,A(shift))
#endif

#endif

      shift = shift + nfft3d(nb)
      end do


      end if
    
*     **** deallocate temporary space  ****
      value = MA_pop_stack(tmp3(2))
      value = MA_pop_stack(tmp2(2))
      !value = MA_pop_stack(tmp1(2))

      call nwpw_timing_end(1)
      return
      end






*     ***********************************
*     *                                 *
*     *         D3dB_pfftfx             *
*     *                                 *
*     ***********************************
*
*     do fft along nx(1) dimension       
*
*        A(kx,ny(1),nz(1)) <- fft1d[A(nx(1),ny(1),nz(1))] 
*     

      subroutine D3dB_pfftfx(nbb,A,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 A(*)
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz

      !*** local variables ***
      integer j,q,indx,nxh


       nxh = (nx(1)/2+1)

      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
      call nwpw_timing_start(31)
#ifdef MLIB
      call drcfts(A,nx(1),1,ny(1)*nq(1),
     >                  nx(1)+2,1,ierr)
#else

#ifdef FFTW3
      call dfftw_execute_dft_r2c(plans(4,1),A,A)

#else

#ifdef USE_OPENMP
      call D3dB_pfftfx_sub(ny(1)*nq(1),nx(1),nxh,dcpl_mb(tmpx(1,1)),A)
      call cshift_fftf(nx(1),ny(1),nq(1),1,A)

#else
      indx = 1
      do q=1,nq(1)
      do j=1,ny(1)
         call drfftf(nx(1),A(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nxh
      end do
      end do
      call cshift_fftf(nx(1),ny(1),nq(1),1,A)
#endif
#endif
#endif
      call dcopy((nx(1)+2)*ny(1)*nq(1),A,1,tmp1,1)
      call nwpw_timing_end(31)


      !*************************
      !**** hilbert mapping ****
      !*************************
      else
      call nwpw_timing_start(31)

#ifdef MLIB
      call drcfts(A,nx(1),1,nq1(1),
     >                  nx(1)+2,1,ierr)
#else

#ifdef FFTW3
      call dfftw_execute_dft_r2c(plans(14,1),A,A)

#else
#ifdef USE_OPENMP
      call D3dB_pfftfx_sub(nq1(1),nx(1),nxh,dcpl_mb(tmpx(1,1)),A)
      call cshift_fftf(nx(1),nq1(1),1,1,A)

#else
      indx = 1
      do q=1,nq1(1)
         call drfftf(nx(1),A(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nxh
      end do
      call cshift_fftf(nx(1),nq1(1),1,1,A)
#endif
#endif
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_start(nbb,1,A,tmp1,tmp2,
     >                                 request,reqcnt,40)
      call nwpw_timing_end(32)

      end if

      return
      end

      subroutine  D3dB_pfftfx_sub(n,nx,nxh,tmpx,A)
      implicit none
      integer n,nx,nxh
      real*8     tmpx(2*nx+15)
      !complex*16 A(nxh,n)
      real*8 A(2*nxh,n)
      integer i,indx
!$omp parallel do default(private) shared(A,n) private(i)
!$omp& firstprivate(nx,tmpx)
      do i=1,n
         call drfftf(nx,A(1,i),tmpx)
      end do
!$omp end parallel do
      return
      end


*     ***********************************
*     *                                 *
*     *         D3dB_pfftfy             *
*     *                                 *
*     ***********************************
*
*     do fft along ny(1) dimension       
*
*        A(kx,ny(1),nz(1)) <- fft1d[A(nx(1),ny(1),nz(1))] 
*     

      subroutine D3dB_pfftfy(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz


      !*** local variables ***
      integer i,j,k,indx,indx0,indx1,indx2,q,nxh,nxhy

      nxh = (nx(1)/2+1)
      nxhy = nxh*ny(1)


      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along ny(1) dimension        ***
*     ***   A(kx,ky,nz(1)) <- fft1d[A(kx,ny(1),nz(1))]  ***
*     ********************************************

#ifdef MLIB
      indx0 = 0
      indx2 = 0
      do q=1,nq(1)
      do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

         indx  = i + indx0
         indx1 = indx
         do j=1,ny(1)
            tmp2(j) = tmp1(indx)
            indx = indx + nxh
         end do
         call z1dfft(tmp2,ny(1),dcpl_mb(tmpy(1,1)),1,ierr)
         do j=1,ny(1)
            tmp1(indx1) = tmp2(j)
            indx1 = indx1 + nxh
         end do

        end if
      end do
      indx0 = indx0 + nxhy
      end do
#else

#ifdef FFTW3
       indx0 = 0
       indx2 = 0
       do q=1,nq(1)
       do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then
          indx  = i + indx0
          call dfftw_execute_dft(plans(9,1),tmp1(indx),tmp1(indx))
        end if
       end do
       indx0 = indx0 + nxhy
       end do

#else
       indx0 = 0
       indx2 = 0
       do q=1,nq(1)
       do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then
          indx  = i + indx0
          indx1 = indx
          do k=1,ny(1)
             tmp2(k) = tmp1(indx)
             indx = indx + nxh
          end do
          call dcfftf(ny(1),tmp2,dcpl_mb(tmpy(1,1)))
          do k=1,ny(1)
             tmp1(indx1) = tmp2(k)
             indx1 = indx1 + nxh
          end do
        end if
       end do
       indx0 = indx0 + nxhy
       end do
#endif
#endif


*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(ky,nz(1),ky) <- A(kx,ky,nz(1))      ***
*     ********************************************
      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose2_jk_start(nbb,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,41)
      call nwpw_timing_end(32)


      !*************************
      !**** hilbert mapping ****
      !*************************
      else
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_end(nbb,1,tmp1,tmp2,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along ny(1) dimension        ***
*     ***   A(ky,nz(1),kx) <- fft1d[A(ny(1),nz(1),kx)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
         call z1dfft(tmp1(indx),ny(1),dcpl_mb(tmpy(1,1)),1,ierr)
         end if
         indx = indx + ny(1)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
         call dfftw_execute_dft(plans(19,1),tmp1(indx),tmp1(indx))
         end if
         indx = indx + ny(1)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftfy_sub2(nq2(1),ny(1),
     >                     log_mb(zero_row2(1,nbb)),
     >                     dcpl_mb(tmpy(1,1)),tmp1)
#else
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
            call dcfftf(ny(1),tmp1(indx),dcpl_mb(tmpy(1,1)))
         end if
         indx = indx + ny(1)
      end do
#endif
#endif
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_start(nbb,2,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,42)
      call nwpw_timing_end(32)


      end if

      return
      end

      subroutine  D3dB_pfftfy_sub2(n,ny,row2,tmpy,A)
      implicit none
      integer n,ny
      logical    row2(n)
      real*8     tmpy(4*ny+15)
      !complex*16 A(ny,n)
      real*8     A(2*ny,n)
      integer i
!$omp parallel do default(private) shared(A,n) private(i)
!$omp& firstprivate(ny,tmpy,row2) schedule(dynamic)
      do i=1,n
         if (.not.row2(i)) then
            call dcfftf(ny,A(1,i),tmpy)
         end if
      end do
!$omp end parallel do
      return
      end







*     ***********************************
*     *                                 *
*     *         D3dB_pfftfz             *
*     *                                 *
*     ***********************************
*

      subroutine D3dB_pfftfz(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz


      !*** local variables ***
      integer i,k,q,nxh,nxhz
      integer indx,indx0,indx1,indx2


       nxh = (nx(1)/2+1)
       nxhz = nxh*nz(1)



      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

      call nwpw_timing_start(32)
      call D3dB_c_ptranspose2_jk_end(nbb,tmp2,tmp1,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along nz(1) dimension        ***
*     ***   A(kx,kz,ky) <- fft1d[A(kx,nz(1),ky)]  ***
*     ********************************************

#ifdef MLIB

      indx0 = 0
      indx2 = 0
      do q=1,nq(1)
      do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

         indx  = i + indx0
         indx1 = indx
         do k=1,nz(1)
            tmp1(k) = tmp2(indx)
            indx = indx + nxh
         end do
         call z1dfft(tmp1,nz(1),dcpl_mb(tmpz(1,1)),1,ierr)
         do k=1,nz(1)
            tmp2(indx1) = tmp1(k)
            indx1 = indx1 + nxh
         end do
        end if
      end do
      indx0 = indx0 + nxhz
      end do
#else

       indx0 = 0
       indx2 = 0
       do q=1,nq(1)
       do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

#ifdef FFTW3
          indx  = i + indx0
          call dfftw_execute_dft(plans(10,1),tmp2(indx),tmp2(indx))

#else
          indx  = i + indx0
          indx1 = indx
          do k=1,nz(1)
             tmp1(k) = tmp2(indx)
             indx = indx + nxh
          end do
          call dcfftf(nz(1),tmp1,dcpl_mb(tmpz(1,1)))
          do k=1,nz(1)
             tmp2(indx1) = tmp1(k)
             indx1 = indx1 + nxh
          end do
#endif

        end if
       end do
       indx0 = indx0 + nxhz
       end do
      call nwpw_timing_end(31)

#endif


      !*************************
      !**** hilbert mapping ****
      !*************************
      else
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_end(nbb,2,tmp2,tmp1,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     ********************************************
*     ***     do fft along nz(1) dimension        ***
*     ***   A(kz,kx,ky) <- fft1d[A(nz(1),kx,ky)]  ***
*     ********************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
         call z1dfft(tmp2(indx),nz(1),dcpl_mb(tmpz(1,1)),1,ierr)
         end if
         indx = indx + nz(1)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dfftw_execute_dft(plans(20,1),tmp2(indx),tmp2(indx))
         end if
         indx = indx + nz(1)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftfz_sub2(nq3(1),nz(1),
     >                     log_mb(zero_row3(1,nbb)),
     >                     dcpl_mb(tmpz(1,1)),tmp2)
#else
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dcfftf(nz(1),tmp2(indx),dcpl_mb(tmpz(1,1)))
         end if
         indx = indx + nz(1)
      end do
#endif
#endif
#endif
      call nwpw_timing_end(31)

      end if

      call nwpw_timing_start(32)
      call Pack_c_pack_start(nbb,tmp2,tmp1,request,reqcnt,43)
      call nwpw_timing_end(32)

      return
      end

      subroutine  D3dB_pfftfz_sub2(n,nz,row3,tmpz,A)
      implicit none
      integer n,nz
      logical    row3(n)
      real*8     tmpz(4*nz+15)
      !complex*16 A(nz,n)
      real*8     A(2*nz,n)
      integer i
!$omp parallel do default(private) shared(A,n) private(i)
!$omp& firstprivate(nz,tmpz,row3) schedule(dynamic)
      do i=1,n
         if (.not.row3(i)) then
            call dcfftf(nz,A(1,i),tmpz)
         end if
      end do
!$omp end parallel do
      return
      end




*     ***********************************
*     *                                 *
*     *         D3dB_pfftf_final        *
*     *                                 *
*     ***********************************
*

      subroutine D3dB_pfftf_final(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      call nwpw_timing_start(32)
      call Pack_c_pack_end(nbb,tmp2,request,reqcnt)
      call nwpw_timing_end(32)

      return
      end




*     ***********************************
*     *                                 *
*     *         D3dB_pfftf_step         *
*     *                                 *
*     ***********************************
*

      subroutine D3dB_pfftf_step(step,nbb,A,tmp1,tmp2,request,reqcnt)
      implicit none
      integer step
      integer nbb
      complex*16 A(*)
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


      if (step.eq.1) then
         call D3dB_pfftfx(nbb,A,tmp1,tmp2,request,reqcnt)
      else if (step.eq.2) then
         call D3dB_pfftfy(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.3) then
         call D3dB_pfftfz(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.4) then
         call D3dB_pfftf_final(nbb,tmp1,tmp2,request,reqcnt)
      end if

      return
      end




*     ***********************************
*     *					*
*     *	        D3dB_pfftbz		*
*     *					*
*     ***********************************

*                                                  
*      This routine performs the operation of      
*      a three dimensional complex to complex     
*      inverse fft                                
*           A(nx,ny(1),nz(1)) <- FFT3^(-1)[A(kx,ky,kz)]  
*                                                  
*      Entry -                                     
*              A: a column distribuded 3d block    
*              tmp: tempory work space must be at  
*                    least the size of (complex)   
*                    (nfft*nfft + 1) + 10*nfft     
*                                               
*       Exit - A is transformed and the imaginary
*              part of A is set to zero          
*       uses - D3dB_c_ptranspose_jk, dcopy        
*                                                  


      subroutine D3dB_pfftbz(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16  tmp1(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt
      

#include "mafdecls.fh"
#include "errquit.fh"
#include "D3dB.fh"
#include "D3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz



*     *** local variables ***
      integer i,k,q,indx,ierr
      integer nxh,nxhz,indx0,indx1,indx2



       nxh = (nx(1)/2+1)
       nxhz = nxh*nz(1)
      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(kx,nz(1),ky) <- fft1d^(-1)[A(kx,kz,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx0 = 0
      indx2 = 0
      do q=1,nq(1)
      do i=1,nxh
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

         indx = i+indx0
         indx1 = indx
         do k=1,nz(1)
            tmp2(k) = tmp1(indx)
            indx = indx + nxh
         end do
         call z1dfft(tmp2,nz(1),
     >               dcpl_mb(tmpz(1,1)),-2,ierr)
         do k=1,nz(1)
            tmp1(indx1) = tmp2(k)
            indx1 = indx1 + nxh
         end do
       end if
      end do
      indx0 = indx0+nxhz
      end do

#else
      indx0 = 0
      indx2 = 0
      do q=1,nq(1)
      do i=1,nxh
       indx2 = indx2 + 1
       if (.not.log_mb(zero_row3(1,nbb)+indx2-1)) then

#ifdef FFTW3
         indx  = i + indx0
         call dfftw_execute_dft(plans(7,1),tmp1(indx),tmp1(indx))
#else

         indx  = i + indx0
         indx1 = indx
         do k=1,nz(1)
            tmp2(k) = tmp1(indx)
            indx = indx + nxh
         end do
         call dcfftb(nz(1),tmp2,dcpl_mb(tmpz(1,1)))
         do k=1,nz(1)
            tmp1(indx1) = tmp2(k)
            indx1 = indx1 + nxh
         end do
#endif

       end if
      end do
      indx0 = indx0 + nxhz
      end do
#endif

*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(kx,ky,nz(1)) <- A(kx,nz(1),ky)      ***
*     ********************************************
      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose1_jk_start(nbb,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,44)
      call nwpw_timing_end(32)


      !*************************
      !**** hilbert mapping ****
      !*************************
      else


      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along kz dimension             ***
*     ***   A(nz(1),kx,ky) <- fft1d^(-1)[A(kz,kx,ky)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
         call z1dfft(tmp1(indx),nz(1),dcpl_mb(tmpz(1,1)),-2,ierr)
         end if
         indx = indx + nz(1)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dfftw_execute_dft(plans(17,1),tmp1(indx),tmp1(indx))
         end if
         indx = indx + nz(1)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftbz_sub2(nq3(1),nz(1),
     >                     log_mb(zero_row3(1,nbb)),
     >                     dcpl_mb(tmpz(1,1)),tmp1)
#else
      indx = 1
      do q=1,nq3(1)
         if (.not.log_mb(zero_row3(1,nbb)+q-1)) then
            call dcfftb(nz(1),tmp1(indx),dcpl_mb(tmpz(1,1)))
         end if
         indx = indx + nz(1)
      end do
#endif
#endif
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_start(nbb,3,tmp1,tmp2,tmp1,
     >                                 request,reqcnt,45)
      call nwpw_timing_end(32)

      end if
      return
      end

      subroutine  D3dB_pfftbz_sub2(n,nz,row3,tmpz,A)
      implicit none
      integer n,nz
      logical    row3(n)
      real*8     tmpz(4*nz+15)
      !complex*16 A(nz,n)
      real*8     A(2*nz,n)
      integer i
!$omp parallel do default(private) shared(A,n) private(i)
!$omp& firstprivate(nz,tmpz,row3) schedule(dynamic)
      do i=1,n
         if (.not.row3(i)) then
            call dcfftb(nz,A(1,i),tmpz)
         end if
      end do
!$omp end parallel do
      return
      end





*     ***********************************
*     *					*
*     *	        D3dB_pfftby		*
*     *					*
*     ***********************************

      subroutine D3dB_pfftby(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16  tmp1(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt

#include "mafdecls.fh"
#include "errquit.fh"
#include "D3dB.fh"
#include "D3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz


*     *** local variables ***
      integer i,j,q,indx,ierr
      integer nxh,nxhy,indx0,indx1,indx2

      

       nxh = (nx(1)/2+1)
       nxhy = nxh*ny(1)
      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then


*     ********************************************
*     ***         Do a ptranspose of A          ***
*     ***      A(kx,ky,nz(1)) <- A(kx,nz(1),ky)      ***
*     ********************************************
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose1_jk_end(nbb,tmp2,tmp1,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(kx,ny(1),nz(1)) <- fft1d^(-1)[A(kx,ky,nz(1))]  ***
*     *************************************************
#ifdef MLIB
     
      indx0 = 0
      indx2 = 0
      do q=1,nq(1)
      do i=1,nxh
        indx2 = indx2 + 1
        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

          indx  = i + indx0
          indx1 = indx
          do j=1,ny(1)
            tmp1(j) = tmp2(indx)
            indx = indx + nxh
          end do
          call z1dfft(tmp1,ny(1),
     >               dcpl_mb(tmpy(1,1)),-2,ierr)
          do j=1,ny(1)
            tmp2(indx1) = tmp1(j)
            indx1 = indx1 + nxh
          end do
        end if
      end do
      indx0 = indx0 + nxhy
      end do
      
#else
    
      indx0 = 0
      indx2 = 0
      do q=1,nq(1)
      do i=1,nxh
        indx2 = indx2 + 1

        if (.not.log_mb(zero_row2(1,nbb)+indx2-1)) then

#ifdef FFTW3
         indx  = i + indx0
         call dfftw_execute_dft(plans(8,1),tmp2(indx),tmp2(indx))

#else
         indx  = i + indx0
         indx1 = indx
         do j=1,ny(1)
            tmp1(j) = tmp2(indx)
            indx = indx + nxh
         end do
         call dcfftb(ny(1),tmp1,dcpl_mb(tmpy(1,1)))
         do j=1,ny(1)
            tmp2(indx1) = tmp1(j)
            indx1 = indx1 + nxh
         end do
#endif

        end if
      end do
      indx0 = indx0 + nxhy
      end do
#endif

      call nwpw_timing_end(31)


      !*************************
      !**** hilbert mapping ****
      !*************************
      else

      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_end(nbb,3,tmp2,tmp1,request,reqcnt)

      call nwpw_timing_end(32)
      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along ky dimension             ***
*     ***   A(ny(1),nz(1),kx) <- fft1d^(-1)[A(ky,nz(1),kx)]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
         call z1dfft(tmp2(indx),ny(1),dcpl_mb(tmpy(1,1)),-2,ierr)
         end if
         indx = indx + ny(1)
      end do
#else
#ifdef FFTW3
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
            call dfftw_execute_dft(plans(18,1),tmp2(indx),tmp2(indx))
         end if
         indx = indx + ny(1)
      end do
#else
#ifdef USE_OPENMP
      call D3dB_pfftby_sub2(nq2(1),ny(1),
     >                     log_mb(zero_row2(1,nbb)),
     >                     dcpl_mb(tmpy(1,1)),tmp2)
#else
      indx = 1
      do q=1,nq2(1)
         if (.not.log_mb(zero_row2(1,nbb)+q-1)) then
            call dcfftb(ny(1),tmp2(indx),dcpl_mb(tmpy(1,1)))
         end if
         indx = indx + ny(1)
      end do
#endif
#endif
#endif

      call nwpw_timing_end(31)
      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_start(nbb,4,tmp2,tmp1,tmp2,
     >                                 request,reqcnt,46)
      call nwpw_timing_end(32)


      end if

      return
      end

      subroutine  D3dB_pfftby_sub2(n,ny,row2,tmpy,A)
      implicit none
      integer n,ny
      logical    row2(n)
      real*8     tmpy(4*ny+15)
      !complex*16 A(ny,n)
      real*8     A(2*ny,n)
      integer i
!$omp parallel do default(private) shared(A,n) private(i)
!$omp& firstprivate(ny,tmpy,row2) schedule(dynamic)
      do i=1,n
         if (.not.row2(i)) then
            call dcfftb(ny,A(1,i),tmpy)
         end if
      end do
!$omp end parallel do
      return
      end





*     ***********************************
*     *					*
*     *	        D3dB_pfftbx		*
*     *					*
*     ***********************************

      subroutine D3dB_pfftbx(nbb,tmp1,tmp2,request,reqcnt)
      implicit none
      integer nbb
      complex*16  tmp1(*)
      complex*16  tmp2(*)
      integer     request(*),reqcnt

#include "mafdecls.fh"
#include "errquit.fh"
#include "D3dB.fh"
#include "D3dB_pfft.fh"

      integer tmpx(2,NBLOCKS),tmpy(2,NBLOCKS),tmpz(2,NBLOCKS)
      common    / D3dB_fft / tmpx,tmpy,tmpz



*     *** local variables ***
      integer j,q,indx,ierr
      integer nxh


      nxh = (nx(1)/2+1)
      
      !**********************
      !**** slab mapping ****
      !**********************
      if (mapping.eq.1) then

      call nwpw_timing_start(31)
*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(1),ny(1),nz(1)) <- fft1d^(-1)[A(kx,ny(1),nz(1))]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq(1)
      do j=1,ny(1)
         call drc1ft(tmp2(indx),nx(1),dcpl_mb(tmpx(1,1)),-2,ierr)
         indx = indx + nxh
      end do
      end do

#else

#ifdef FFTW3
      call dfftw_execute_dft_c2r(plans(3,1),tmp2,tmp2)

#else
#ifdef USE_OPENMP
      call cshift1_fftb(nx(1),ny(1),nq(1),1,tmp2)
      call D3dB_pfftbx_sub(nq(1)*ny(1),nx(1),nxh,
     >                     dcpl_mb(tmpx(1,1)),tmp2)
      call zeroend_fftb(nx(1),ny(1),nq(1),1,tmp2)
#else
      call cshift1_fftb(nx(1),ny(1),nq(1),1,tmp2)
      indx = 1
      do q=1,nq(1)
      do j=1,ny(1)
         call drfftb(nx(1),tmp2(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nxh
      end do
      end do
      call zeroend_fftb(nx(1),ny(1),nq(1),1,tmp2)
#endif
#endif
#endif
      call dcopy((nx(1)+2)*ny(1)*nq(1),tmp2,1,tmp1,1)



      call nwpw_timing_end(31)
*     *************************************************
      !*************************
      !**** hilbert mapping ****
      !*************************
      else



      call nwpw_timing_start(32)
      call D3dB_c_ptranspose_ijk_end(nbb,4,tmp1,tmp2,request,reqcnt)
      call nwpw_timing_end(32)
      call nwpw_timing_start(31)

*     *************************************************
*     ***     do fft along kx dimension             ***
*     ***   A(nx(1),ny(1),nz(1)) <- fft1d^(-1)[A(kx,ny(1),nz(1))]  ***
*     *************************************************
#ifdef MLIB
      indx = 1
      do q=1,nq1(1)
         call drc1ft(tmp1(indx),nx(1),dcpl_mb(tmpx(1,1)),-2,ierr)
         indx = indx + nxh
      end do
#else

#ifdef FFTW3
      call dfftw_execute_dft_c2r(plans(13,1),tmp1,tmp1)

#else
#ifdef USE_OPENMP
      call cshift1_fftb(nx(1),nq1(1),1,1,tmp1)
      call D3dB_pfftbx_sub(nq1(1),nx(1),nxh,dcpl_mb(tmpx(1,1)),tmp1)
      call zeroend_fftb(nx(1),nq1(1),1,1,tmp1)
#else
      call cshift1_fftb(nx(1),nq1(1),1,1,tmp1)
      indx = 1
      do q=1,nq1(1)
         call drfftb(nx(1),tmp1(indx),dcpl_mb(tmpx(1,1)))
         indx = indx + nxh
      end do
      call zeroend_fftb(nx(1),nq1(1),1,1,tmp1)
#endif
#endif
#endif

      call nwpw_timing_end(31)
      end if
    
      return
      end


      subroutine  D3dB_pfftbx_sub(n,nx,nxh,tmpx,A)
      implicit none
      integer n,nx,nxh
      real*8     tmpx(2*nx+15)
      !complex*16 A(nxh,n)
      real*8     A(2*nxh,n)
      integer i
!$omp parallel do default(private) shared(A,n) private(i)
!$omp& firstprivate(nx,tmpx) schedule(static)
      do i=1,n
         call drfftb(nx,A(1,i),tmpx)
      end do
!$omp end parallel do

      return
      end



*     ***********************************
*     *                                 *
*     *         D3dB_pfftb_step         *
*     *                                 *
*     ***********************************
*

      subroutine D3dB_pfftb_step(step,nbb,A,tmp1,tmp2,request,reqcnt)
      implicit none
      integer step
      integer nbb
      complex*16 A(*)
      complex*16 tmp1(*)
      complex*16 tmp2(*)
      integer    request(*),reqcnt


#include "mafdecls.fh"

      integer tmp1z(2),tmp2z(2)
      common / pfft_queuez_common / tmp1z,tmp2z


      if (step.eq.1) then
         call nwpw_timing_start(32)
         call Pack_c_unpack_start(nbb,A,tmp1,request,reqcnt,47)
         call nwpw_timing_end(32)
      else if (step.eq.2) then
         call nwpw_timing_start(32)
         call Pack_c_unpack_mid(nbb,tmp1,tmp2,
     >                          dcpl_mb(tmp1z(1)),dcpl_mb(tmp2z(1)),
     >                          request,reqcnt,48)
         call nwpw_timing_end(32)
      else if (step.eq.3) then
         call nwpw_timing_start(32)
         call Pack_c_unpack_end(nbb,tmp1,
     >                          dcpl_mb(tmp1z(1)),dcpl_mb(tmp2z(1)),
     >                          request,reqcnt)
         call nwpw_timing_end(32)
      else if (step.eq.4) then
         call D3dB_pfftbz(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.5) then
         call D3dB_pfftby(nbb,tmp1,tmp2,request,reqcnt)
      else if (step.eq.6) then
         call D3dB_pfftbx(nbb,tmp1,tmp2,request,reqcnt)
      end if

      return
      end


*     ***********************************
*     *                                 *
*     *     D3dB_pfft3_queue_init       *
*     *                                 *
*     ***********************************

      subroutine D3dB_pfft3_queue_init(qmax_in)
      implicit none
      integer qmax_in


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queues ****
      integer aqindx(2),aqstatus(2)
      integer atmp(2),arequest(2),areqcnt(2)
      integer aqmax,aqsize,alast_index
      common / pfft_aqueue_common / aqindx,aqstatus,atmp,arequest,
     >                              areqcnt,aqmax,aqsize,alast_index
      integer bqindx(2),bqstatus(2)
      integer btmp(2),brequest(2),breqcnt(2)
      integer bqmax,bqsize,blast_index
      common / pfft_bqueue_common / bqindx,bqstatus,btmp,brequest,
     >                              breqcnt,bqmax,bqsize,blast_index
      
      integer tmp1z(2),tmp2z(2)
      common / pfft_queuez_common / tmp1z,tmp2z

      logical value
      integer np,size,zplane_sizetmp

      call Parallel2d_np_i(np)

c     **** allocate aqueue ****
      aqmax       = qmax_in
      aqsize      = 0
      alast_index = aqmax
      size  = nfft3d(1)*aqmax*2
      value = MA_alloc_get(mt_dcpl,size,'atmp',atmp(2),atmp(1))
      size  = np*aqmax*2
      value = value.and.
     >      MA_alloc_get(mt_int,size,'arequest',arequest(2),arequest(1))
      size  = aqmax
      value = value.and.
     >        MA_alloc_get(mt_int,size,'aqindx',aqindx(2),aqindx(1))
      value = value.and.
     >      MA_alloc_get(mt_int,size,'aqstatus',aqstatus(2),aqstatus(1))
      value = value.and.
     >        MA_alloc_get(mt_int,size,'areqcnt',areqcnt(2),areqcnt(1))
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)
      call dcopy(4*nfft3d(1)*aqmax,0.0d0,0,dcpl_mb(atmp(1)),1)


c     **** allocate bqueue ****
      bqmax       = qmax_in
      bqsize      = 0
      blast_index = bqmax
      size  = nfft3d(1)*bqmax*2
      value = MA_alloc_get(mt_dcpl,size,'btmp',btmp(2),btmp(1))
      size  = np*bqmax*2
      value = value.and.
     >      MA_alloc_get(mt_int,size,'brequest',brequest(2),brequest(1))
      size  = bqmax
      value = value.and.
     >        MA_alloc_get(mt_int,size,'bqindx',bqindx(2),bqindx(1))
      value = value.and.
     >      MA_alloc_get(mt_int,size,'bqstatus',bqstatus(2),bqstatus(1))
      value = value.and.
     >        MA_alloc_get(mt_int,size,'breqcnt',breqcnt(2),breqcnt(1))
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)
      call dcopy(4*nfft3d(1)*bqmax,0.0d0,0,dcpl_mb(btmp(1)),1)



      call D3dB_zplane_size(1,zplane_sizetmp)
      value = value.and.
     >        MA_alloc_get(mt_dcpl,(zplane_sizetmp),
     >                    'tmp1z',tmp1z(2),tmp1z(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,(zplane_sizetmp),
     >                    'tmp2z',tmp2z(2),tmp2z(1))
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)
      


      return
      end




*     ***********************************
*     *                                 *
*     *     D3dB_pfft3_queue_end        *
*     *                                 *
*     ***********************************

      subroutine D3dB_pfft3_queue_end()
      implicit none


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queues ****
      integer aqindx(2),aqstatus(2)
      integer atmp(2),arequest(2),areqcnt(2)
      integer aqmax,aqsize,alast_index
      common / pfft_aqueue_common / aqindx,aqstatus,atmp,arequest,
     >                              areqcnt,aqmax,aqsize,alast_index

      integer bqindx(2),bqstatus(2)
      integer btmp(2),brequest(2),breqcnt(2)
      integer bqmax,bqsize,blast_index
      common / pfft_bqueue_common / bqindx,bqstatus,btmp,brequest,
     >                              breqcnt,bqmax,bqsize,blast_index

      integer tmp1z(2),tmp2z(2)
      common / pfft_queuez_common / tmp1z,tmp2z

      logical value

      value =           MA_free_heap(atmp(2))
      value = value.and.MA_free_heap(arequest(2))
      value = value.and.MA_free_heap(aqindx(2))
      value = value.and.MA_free_heap(aqstatus(2))
      value = value.and.MA_free_heap(areqcnt(2))

      value = value.and.MA_free_heap(btmp(2))
      value = value.and.MA_free_heap(brequest(2))
      value = value.and.MA_free_heap(bqindx(2))
      value = value.and.MA_free_heap(bqstatus(2))
      value = value.and.MA_free_heap(breqcnt(2))

      value = value.and.MA_free_heap(tmp1z(2))
      value = value.and.MA_free_heap(tmp2z(2))
      if (.not. value) 
     > call errquit('D3dB_pfft3_queue_end:error freeing heap',0,MA_ERR)

      return
      end







*     ***********************************
*     *                                 *
*     *     D3dB_cr_pfft3_queue_filled  *
*     *                                 *
*     ***********************************

      logical function D3dB_cr_pfft3_queue_filled()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2)
      integer qmax,qsize,last_index
      common / pfft_aqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qmax,qsize,last_index

      D3dB_cr_pfft3_queue_filled = (qsize.ge.qmax)
      return
      end



*     ***********************************
*     *                                 *
*     *     D3dB_rc_pfft3_queue_filled  *
*     *                                 *
*     ***********************************

      logical function D3dB_rc_pfft3_queue_filled()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2)
      integer qmax,qsize,last_index
      common / pfft_bqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qmax,qsize,last_index

      D3dB_rc_pfft3_queue_filled = (qsize.ge.qmax)
      return
      end




*     ***********************************
*     *                                 *
*     *     D3dB_rc_pfft3f_queuein      *
*     *                                 *
*     ***********************************

      subroutine D3dB_rc_pfft3f_queuein(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2)
      integer qmax,qsize,last_index
      common / pfft_bqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,status,np

c      call nwpw_timing_start(1)
      call nwpw_timing_start(30)
      call Parallel2d_np_i(np)

      do q=1,qsize
         indx   = int_mb(qindx(1)+q-1)
         int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
         status = int_mb(qstatus(1)+indx-1)
         shift1=nfft3d(1)*(2*(indx-1))
         shift2=nfft3d(1)*(2*(indx-1)+1)
         shift3=2*np*(indx-1)
         call D3dB_pfftf_step(status,nbb,A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
      end do

      qsize = qsize + 1
      last_index = last_index+1
      if (last_index.gt.qmax) last_index = 1
      int_mb(qindx(1)+qsize-1)        = last_index
      int_mb(qstatus(1)+last_index-1) = 1
      status = 1
      shift1=nfft3d(1)*(2*(last_index-1))
      shift2=nfft3d(1)*(2*(last_index-1)+1)
      shift3=2*np*(last_index-1)

      call D3dB_pfftf_step(status,nbb,A,
     >                     dcpl_mb(tmp(1)+shift1),
     >                     dcpl_mb(tmp(1)+shift2),
     >                     int_mb(request(1)+shift3),
     >                     int_mb(reqcnt(1)+last_index-1))

c      call nwpw_timing_end(1)
      call nwpw_timing_end(30)
      return
      end




*     ***********************************
*     *                                 *
*     *     D3dB_rc_pfft3f_queueout     *
*     *                                 *
*     ***********************************

      subroutine D3dB_rc_pfft3f_queueout(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2)
      integer qmax,qsize,last_index
      common / pfft_bqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,indx1,status,np

c      call nwpw_timing_start(1)
      call nwpw_timing_start(30)
      call Parallel2d_np_i(np)

c      do q=1,qsize
c         indx   = int_mb(qindx(1)+q-1)
c         int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
c         status = int_mb(qstatus(1)+indx-1)
c         shift1=nfft3d(1)*(2*(indx-1))
c         shift2=nfft3d(1)*(2*(indx-1)+1)
c         shift3=2*np*(indx-1)
c         call D3dB_pfftf_step(status,nbb,A,
c     >                        dcpl_mb(tmp(1)+shift1),
c     >                        dcpl_mb(tmp(1)+shift2),
c     >                        int_mb(request(1)+shift3),
c     >                        int_mb(reqcnt(1)+indx-1))
c      end do

      indx1   = int_mb(qindx(1))
      do while (int_mb(qstatus(1)+indx1-1).lt.4)
         do q=1,qsize
            indx   = int_mb(qindx(1)+q-1)
            int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
            status = int_mb(qstatus(1)+indx-1)
            shift1=nfft3d(1)*(2*(indx-1))
            shift2=nfft3d(1)*(2*(indx-1)+1)
            shift3=2*np*(indx-1)
            call D3dB_pfftf_step(status,nbb,A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
         end do
      end do

      qsize = qsize -1
      do q=1,qsize
        int_mb(qindx(1)+q-1) = int_mb(qindx(1)+q)
      end do

      shift2=nfft3d(1)*(2*(indx1-1)+1)
      call Pack_c_Copy(nbb,dcpl_mb(tmp(1)+shift2),A)

c      call nwpw_timing_end(1)
      call nwpw_timing_end(30)
      return
      end





*     ***********************************
*     *                                 *
*     *     D3dB_cr_pfft3b_queuein      *
*     *                                 *
*     ***********************************

      subroutine D3dB_cr_pfft3b_queuein(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2)
      integer qmax,qsize,last_index
      common / pfft_aqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,status,np

c      call nwpw_timing_start(1)
      call nwpw_timing_start(30)
      call Parallel2d_np_i(np)

      do q=1,qsize
         indx   = int_mb(qindx(1)+q-1)
         int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
         status = int_mb(qstatus(1)+indx-1)
         shift1=nfft3d(1)*(2*(indx-1))
         shift2=nfft3d(1)*(2*(indx-1)+1)
         shift3=2*np*(indx-1)
         call D3dB_pfftb_step(status,nbb,A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
      end do

      qsize = qsize + 1
      last_index = last_index+1
      if (last_index.gt.qmax) last_index = 1
      int_mb(qindx(1)+qsize-1)        = last_index
      int_mb(qstatus(1)+last_index-1) = 1
      status = 1
      shift1=nfft3d(1)*(2*(last_index-1))
      shift2=nfft3d(1)*(2*(last_index-1)+1)
      shift3=2*np*(last_index-1)

      call D3dB_pfftb_step(status,nbb,A,
     >                     dcpl_mb(tmp(1)+shift1),
     >                     dcpl_mb(tmp(1)+shift2),
     >                     int_mb(request(1)+shift3),
     >                     int_mb(reqcnt(1)+last_index-1))

c      call nwpw_timing_end(1)
      call nwpw_timing_end(30)
      return
      end




*     ***********************************
*     *                                 *
*     *     D3dB_cr_pfft3b_queueout     *
*     *                                 *
*     ***********************************

      subroutine D3dB_cr_pfft3b_queueout(nbb,A)
      implicit none
      integer nbb
      complex*16 A(*)


#include "mafdecls.fh"
#include "errquit.fh"

#include "D3dB.fh"
#include "D3dB_pfft.fh"


      !**** pfft_queue ****
      integer qindx(2),qstatus(2)
      integer tmp(2),request(2),reqcnt(2)
      integer qmax,qsize,last_index
      common / pfft_aqueue_common / qindx,qstatus,tmp,request,reqcnt,
     >                             qmax,qsize,last_index

      !*** local variables ***
      integer shift1,shift2,shift3
      integer q,indx,indx1,status,np

      call Parallel2d_np_i(np)

c      call nwpw_timing_start(1)
      call nwpw_timing_start(30)



c      do q=1,qsize
c         indx   = int_mb(qindx(1)+q-1)
c         int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
c         status = int_mb(qstatus(1)+indx-1)
c         shift1=nfft3d(1)*(2*(indx-1))
c         shift2=nfft3d(1)*(2*(indx-1)+1)
c         shift3=2*np*(indx-1)
c         call D3dB_pfftb_step(status,nbb,A,
c     >                        dcpl_mb(tmp(1)+shift1),
c     >                        dcpl_mb(tmp(1)+shift2),
c     >                        int_mb(request(1)+shift3),
c     >                        int_mb(reqcnt(1)+indx-1))
c      end do

      indx1   = int_mb(qindx(1))
      do while (int_mb(qstatus(1)+indx1-1).lt.6)
         do q=1,qsize
            indx   = int_mb(qindx(1)+q-1)
            int_mb(qstatus(1)+indx-1) = int_mb(qstatus(1)+indx-1) + 1
            status = int_mb(qstatus(1)+indx-1)
            shift1=nfft3d(1)*(2*(indx-1))
            shift2=nfft3d(1)*(2*(indx-1)+1)
            shift3=2*np*(indx-1)
            call D3dB_pfftb_step(status,nbb,A,
     >                        dcpl_mb(tmp(1)+shift1),
     >                        dcpl_mb(tmp(1)+shift2),
     >                        int_mb(request(1)+shift3),
     >                        int_mb(reqcnt(1)+indx-1))
         end do
      end do

      qsize = qsize -1
      do q=1,qsize
        int_mb(qindx(1)+q-1) = int_mb(qindx(1)+q)
      end do

      shift1=nfft3d(1)*(2*(indx1-1))
      call dcopy(2*nfft3d(1),dcpl_mb(tmp(1)+shift1),1,A,1)

c      call nwpw_timing_end(1)
      call nwpw_timing_end(30)
      return
      end

      subroutine smd_pdb_natoms(filename,nt)
      implicit none
#include "errquit.fh"
#include "util.fh"
      character*(*) filename
      integer nt
c
      character*(4) buffer
      integer un
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)

      nt = 0
100   continue
      read(un,'(A4)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        nt = nt + 1
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_pdb_read_coords(filename,nt,c)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
      character*(*) filename
      integer nt
      double precision c(nt,3)
c
      character*(180) buffer
      character*(4)  tag
      integer i
      integer un
      character*(30) pname

      pname = "smd_pdb_read_coords"
c
      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)
      i = 0
100   continue
      read(un,'(A180)',end=200) buffer
      call util_flush(34)
      if(buffer(1:4).eq."ATOM") then
        i = i +1
        if(i.gt.nt)
     >  call errquit(pname//"insufficient array size",0,0)
        read(buffer,*) tag,tag,tag,tag,tag,
     >                 c(i,1),c(i,2),c(i,3)
       end if
      goto 100
200   continue
      close(un)

      if(i.ne.nt)
     >  call errquit(pname//"incompatible array sizes",0,0)
      return

      end

      subroutine smd_pdb_read_atomres(filename,nt,ta,tr,ir)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      character*(*) filename
      integer nt
      character*(smd_string_size) ta(nt)
      character*(smd_string_size) tr(nt)
      integer ir(nt)
c
      character*(180) buffer
      character*(4)  tag
      integer i
      integer un
      character*(30) pname

      pname = "smd_pdb_read_atomres"
c
      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)
      i = 0
100   continue
      read(un,'(A180)',end=200) buffer
      call util_flush(34)
      if(buffer(1:4).eq."ATOM") then
        i = i +1
        if(i.gt.nt)
     >  call errquit(pname//"insufficient array size",0,0)
        read(buffer,*) tag,tag,ta(i),tr(i),ir(i),
     >                 tag,tag,tag
        call util_flush(6)
       end if
      goto 100
200   continue
      close(un)

      if(i.ne.nt)
     >  call errquit(pname//"incompatible array sizes",0,0)
      return

      end

      subroutine smd_pdb_read(filename,nt,ta,tr,ir,c)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      character*(*) filename
      integer nt
      character*(smd_string_size) ta(nt)
      character*(smd_string_size) tr(nt)
      integer ir(nt)
      double precision c(3,nt)
c
      character*(180) buffer
      character*(4)  tag
      integer i
      integer un
      character*(30) pname

      pname = "smd_pdb_read"
c
      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)
      i = 0
100   continue
      read(un,'(A180)',end=200) buffer
      call util_flush(34)
      if(buffer(1:4).eq."ATOM") then
        i = i +1
        if(i.gt.nt)
     >  call errquit(pname//"insufficient array size",0,0)
        read(buffer,*) tag,tag,ta(i),tr(i),ir(i),
     >                 c(1,i),c(2,i),c(3,i)
        call util_flush(6)
       end if
      goto 100
200   continue
      close(un)

      if(i.ne.nt)
     >  call errquit(pname//"incompatible array sizes",0,0)
      return

      end

      subroutine smd_pdb_nres(filename,nr)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
      character*(*) filename
      integer nr
c
      character*(180) buffer
      character*(4)  tag
      integer ir0,ir
      integer un
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)

c      reset residue arrays to be the size of number of residues only
      nr = 0
      ir0 = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        read(buffer,*) tag,tag,tag,tag,ir
        if(ir0.ne.ir) then
          nr = nr + 1
          ir0=ir
        end if
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_pdb_read_res(filename,nt,nr,tr,ir,nm)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      character*(*) filename
      integer nt,nr,nc
      character*(smd_string_size) tr(nr)
      integer ir(nt)
      integer nm(nr)
c
      character*(30) pname
      character*(180) buffer
      character*(4)  tag
      character*(smd_string_size)  rtag,rtag0
      integer ir0,nr0
      integer ncenter
      integer un
c
      pname = "sg_read_res"
c
      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)

      ncenter = 0
      nr0 = 0
      rtag0 = " "
      ir0 = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        ncenter = ncenter + 1
        read(buffer,*) tag,tag,tag,rtag,ir(ncenter)
        write(*,*) "ir",ncenter,ir(ncenter)
        if(ir0.ne.ir(ncenter)) then
          ir0=ir(ncenter)
          nr0 = nr0 + 1
          if(ncenter.gt.nt)
     >  call errquit(pname//"insufficient array size",0,0)
          if(nr0.gt.nr)
     >  call errquit(pname//"insufficient array size",0,0)
          tr(nr0) = rtag
          rtag0=rtag 
        end if
        ir(ncenter) = nr0
        nm(nr0) = nm(nr0) + 1
      end if
      goto 100
200   continue

      close(un)

      write(*,*) "ncenter,nt",ncenter,nt
      if(ncenter.ne.nt)
     >  call errquit(pname//"incompatible atom array sizes",
     >             ncenter,nt)

      if(nr.ne.nr0)
     >  call errquit(pname//"incompatible residue array sizes",nr0,nr)

      return
      end
c $Id: smd_pdb.F 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE ccsdt_lr_alpha_offdiag_12_3_5_1(d_a,k_a_offset,d_b,k_b_
     &offset,d_c,k_c_offset)
C     $Id: ccsdt_lr_alpha_offdiag_12_3_5_1.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h7 p11 h9 p1 )_vt + = -1 * Sum ( p3 ) * t ( p3 h9 )_t * v ( h7 p11 p1 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER p11b
      INTEGER h9b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p3b_1
      INTEGER h9b_1
      INTEGER h7b_2
      INTEGER p11b_2
      INTEGER p1b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h7b = 1,noab
      DO p11b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+p11b-
     &1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      IF (int_mb(k_spin+h7b-1)+int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+
     &h9b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),ieor(int_mb(k_sym+p11b-1),ieor(int_mb
     &(k_sym+h9b-1),int_mb(k_sym+p1b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+p11b-1) * int_mb(k_r
     &ange+h9b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_12_3_5_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h9b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h9b,p3b_1,h9b_1)
      CALL TCE_RESTRICTED_4(h7b,p11b,p1b,p3b,h7b_2,p11b_2,p1b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1) * int_mb(k_range+p11b-1) * int_m
     &b(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_12_3_5_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_12_3_5_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h9b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &2_3_5_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_12_3_5_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_12_3_5_1',5,MA_ERR)
      IF ((p3b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (p11b_2 - 1 + (noa
     &b+nvab) * (h7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p3b-1),int_mb(k_range+p1b-1
     &),4,2,1,3,-1.0d0)
      END IF
      IF ((p1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (p11b_2 - 1 + (noa
     &b+nvab) * (h7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p1b-1),int_mb(k_range+p3b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &2_3_5_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_12_3_5_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_12_3_5_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_12_3_5_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+h7b-1),int_mb(k_range+h9b-1
     &),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h9b - 1 + noab * (p11b - noab - 1 + nvab * (h7
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &2_3_5_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_12_3_5_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      integer function idamin(n,dx,incx)
*
* $Id: idamin.f 19707 2010-10-29 17:59:36Z d3y133 $
*
c
c     finds the index of element having min. absolute value.
C     Trivial modification of BLAS idamax routine!
c
      double precision dx(*),dmin
      integer i,incx,ix,n
c
      idamin = 0
      if( n.lt.1 .or. incx.le.0 ) return
      idamin = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmin = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(dabs(dx(ix)).ge.dmin) go to 5
         idamin = i
         dmin = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 dmin = dabs(dx(1))
      do 30 i = 2,n
         if(dabs(dx(i)).ge.dmin) go to 30
         idamin = i
         dmin = dabs(dx(i))
   30 continue
      return
      end

      subroutine hf2d_2a2b(
     &      Axyz,Aprims,Acoefs,NPA,NCA,La,ictra,
     &      Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,ictrb,
     &      Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &      Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &      bERI,Nint,canAB,canCD,canPQ,dryrun,
     &      W0,maxW0)
C $Id: hf2d_2a2b.F 19696 2010-10-29 16:53:42Z d3y133 $
      Implicit None
      Logical canAB,canCD,canPQ,dryrun
      
c--> Cartesian Coordinates, Primitives & Contraction Coefficients
      
      Integer La, Lb, Lc, Ld, Nint, MaxW0
      Integer NPA, NCA, NPB, NCB, NPC, NCC, NPD, NCD
      Double Precision Axyz(3),Aprims(NPA),Acoefs(NPA,NCA)
      Double Precision Bxyz(3),Bprims(NPB),Bcoefs(NPB,NCB)
      Double Precision Cxyz(3),Cprims(NPC),Ccoefs(NPC,NCC)
      Double Precision Dxyz(3),Dprims(NPD),Dcoefs(NPD,NCD)
      Integer ictra,ictrb,ictrc,ictrd
c--> Block of Electron Repulsion Integrals
      
      Double Precision bERI(Nint,*)
      
c--> Scratch Space
      
      Double Precision W0(maxW0)
c
      integer npa1, npa2, npb1, npb2
      integer a_exp, a_cof, b_exp, b_cof
      integer k0s, maxw0new, pw0, kaddint, icont
      integer mem1, mem2, mem3, mem4
      integer mem1add, mem2add, mem3add, mem4add
c
      npa1  = npa/2
      if (mod(npa,2).eq.1) npa1 = npa1 + 1
      npa2 = npa - npa1
      npb1  = npb/2
      if (mod(npb,2).eq.1) npb1 = npb1 + 1
      npb2 = npb - npb1
c... do first of 4 blocks  (a1|b1|*)
      a_exp  = 1
      a_cof  = a_exp + npa1
      b_exp  = a_cof + npa1*NCA
      b_cof  = b_exp + npb1
      k0s    = b_cof + npb1*NCB
      maxw0new = maxw0 - k0s

      mem1    = k0s         ! take care of compiler warnings
      mem2    = k0s
      mem3    = k0s
      mem1add = mem1
      mem2add = mem2
      mem3add = mem3
      mem4add = mem3

      if (dryrun) then
        mem1add = k0s
      else
        call dcopy(npa1,Aprims,1,W0(a_exp),1)
        call dcopy(npb1,Bprims,1,W0(b_exp),1)
        do 00100 icont = 1,NCA
          pw0 = a_cof+(icont-1)*npa1
          call dcopy(npa1,Acoefs(1,icont),1,W0(pw0),1)
00100   continue
        do 00200 icont = 1,NCB
          pw0 = b_cof+(icont-1)*npb1
          call dcopy(npb1,Bcoefs(1,icont),1,W0(pw0),1)
00200   continue
      endif
      call hf2dold(
     &    Axyz,W0(a_exp),W0(a_cof),NPA1,NCA,La,ictra,
     &    Bxyz,W0(b_exp),W0(b_cof),NPB1,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    bERI,Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
c
      if (dryrun) mem1 = maxW0new + mem1add
c
c... do second of 4 blocks   (a1|b2|*)
      b_cof  = b_exp + npb2
      kaddint = b_cof + npb2*NCB
      k0s = kaddint + 12*nint
      maxw0new = maxw0 - k0s
      if (dryrun) then
        mem2add = k0s
      else
        call dcopy(npb2,Bprims(npb1+1),1,W0(b_exp),1)
        do 00300 icont = 1,NCB
          pw0 = b_cof+(icont-1)*npb2
          call dcopy(npb2,Bcoefs((npb1+1),icont),1,W0(pw0),1)
00300   continue
      endif
      call hf2dold(
     &    Axyz,W0(a_exp),W0(a_cof),NPA1,NCA,La,ictra,
     &    Bxyz,W0(b_exp),W0(b_cof),NPB2,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    W0(kaddint),Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) then
        mem2 = maxw0new + mem2add
      else
c... sum blocks 1+2
        call daxpy((nint*12),1.0d00,w0(kaddint),1,beri,1)
      endif
c
c... do third of 4 blocks   (a2|b1|*)
      a_exp  = 1
      a_cof  = a_exp + npa2
      b_exp  = a_cof + npa2*NCA
      b_cof  = b_exp + npb1
      kaddint = b_cof + npb1*NCB
      k0s = kaddint + 12*nint
      maxw0new = maxw0 - k0s
      if (dryrun) then
        mem3add = k0s
      else
        call dcopy(npa2,Aprims(npa1+1),1,W0(a_exp),1)
        call dcopy(npb1,Bprims,1,W0(b_exp),1)
        do 00400 icont = 1,NCA
          pw0 = a_cof+(icont-1)*npa2
          call dcopy(npa2,Acoefs((npa1+1),icont),1,W0(pw0),1)
00400   continue
        do 00500 icont = 1,NCB
          pw0 = b_cof+(icont-1)*npb1
          call dcopy(npb1,Bcoefs(1,icont),1,W0(pw0),1)
00500   continue
      endif
      call hf2dold(
     &    Axyz,W0(a_exp),W0(a_cof),NPA2,NCA,La,ictra,
     &    Bxyz,W0(b_exp),W0(b_cof),NPB1,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    W0(kaddint),Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) then
        mem3 = maxw0new + mem3add
      else
c... sum blocks 1,2 + 3
        call daxpy((nint*12),1.0d00,w0(kaddint),1,beri,1)
      endif
c
c... do fourth of 4 blocks   (a2|b2|*)
      b_cof  = b_exp + npb2
      kaddint = b_cof + npb2*NCB
      k0s = kaddint + 12*nint
      maxw0new = maxw0 - k0s
      if (dryrun) then
        mem4add = k0s
      else
        call dcopy(npb2,Bprims(npb1+1),1,W0(b_exp),1)
        do 00600 icont = 1,NCB
          pw0 = b_cof+(icont-1)*npb2
          call dcopy(npb2,Bcoefs((npb1+1),icont),1,W0(pw0),1)
00600   continue
      endif
      call hf2dold(
     &    Axyz,W0(a_exp),W0(a_cof),NPA2,NCA,La,ictra,
     &    Bxyz,W0(b_exp),W0(b_cof),NPB2,NCB,Lb,ictrb,
     &    Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,ictrc,
     &    Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,ictrd,
     &    W0(kaddint),Nint,canAB,canCD,canPQ,dryrun,
     &    W0(k0s),maxW0new)
      if (dryrun) then
        mem4 = maxw0new + mem4add
        maxw0 = max(mem1,mem2,mem3,mem4)
      else
c... sum blocks 1,2,3 + 4
        call daxpy((nint*12),1.0d00,w0(kaddint),1,beri,1)
      endif
c
      end

      subroutine ana_inirms(xref,xrms,wt)
c
c $Id: ana_inirms.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_common.fh"
#include "ana_params.fh"
c
      real*8 xref(nsa,3),xrms(nsa),wt(nsa)
c
      integer i
c
      do 1 i=1,nsa
      xrms(i)=zero
      wt(i)=one
    1 continue
c
      return
      end

      subroutine xlm_norm(lmax, q, lq)
*
* $Id: xlm_poles.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "xlm.fh"
      integer lmax, lq
      double precision q(-lq:lq,0:lmax)
c     
c     Return in q the normalization constants qn ... see xlm_init
c
      integer l, m
c
      do l = 0, lmax
         do m = -l, l
            q(m,l) = qn(m,l)
         enddo
      enddo
c
      end
      subroutine xlm_thresh(lmax, q, lq, thresh, dist, luse)
      implicit none
#include "xlm.fh"
      integer lmax, lq, luse
      double precision q(-lq:lq,0:lmax), thresh, dist
c
c     Return in luse the angular momentum required to obtain
c     the required accuracy in the potential at a distance dist.
c
c     For use in the FMM dist should be (ws+0.5)*box.  
c
c     If all components are negligble luse=-1 is returned.
c
      integer l, m
      double precision scale, test, sum
c
      scale = 1.0d0/dist**(lmax+1)
      sum = 0.0d0
      do l = lmax,0,-1
         test = 0.0d0
         do m = -l, l
            test = test + abs(q(m,l)*fieldmax(m,l))
         enddo
         sum = sum + test*scale
         if (sum .gt. thresh) goto 10
         scale = scale * dist
      enddo
 10   luse = l
c
      end
      subroutine xlm_m2l_thresh(lmax, q, lq, thresh, dist, box, luse)
      implicit none
#include "xlm.fh"
      integer lmax, lq, luse
      double precision q(-lq:lq,0:lmax), thresh, dist, box
c
c     Return in luse the angular momentum required to obtain
c     the required accuracy in the Taylor series of the potential 
c     at a distance dist in a box of size box.
c
c     For use in the FMM dist should be (ws+0.5)*box.  
c
c     If all components are negligble luse=-1 is returned.
c
      integer l, m, k
      double precision scale, test, sum, factorial
      external factorial
c
      scale = 1.0d0/dist**(lmax+1)
      sum = 0.0d0
      do l = lmax,0,-1
         test = 0.0d0
         do m = -l, l
            test = test + abs(q(m,l)*fieldmax(m,l))
         enddo
         sum = sum + test*scale
         if (sum .gt. thresh) goto 10
         scale = scale * dist
      enddo
 10   continue
c
c     l is the order of mpole required to get the potential
c     accurate ... but perhaps the taylor series needs even
c     higher order?
c
      if (l.gt.-1 .and. l.lt.lmax) then
         k = l+1
         test = test*(0.87d0*box/dist)**k * factorial(l+k)/
     $        (factorial(l)*factorial(k))
         do k = l+1, lmax
            if (test .lt. thresh) goto 20
            test = test*(l+k+1)*0.5d0*box/(dist*(k+1))
         end do
 20      k = k - 1
         if (l .lt. k) then
            write(6,*) ' Increasing l ', l, k
            l = k
         endif
      endif
c
      luse = l
c
      end
      subroutine xlm_slower(lmax, x, y, z, q, lq)
      implicit none
#include "xlm.fh"
c
      integer lmax, lq
      double precision x, y, z, q(-lq:lq, 0:lmax)
c
      integer l, m, lp1
      double precision r2, twolp1
c
c     compute the unnormalized real solid spherical harmonics
c     up to order lmax at the point x, y, z.
c     lq specifies the dimension of q.
c
      if (lmax .gt. lq) then
         write(6,*) ' invalid dimension for q ', lmax, lq
         stop 1
      end if
***      call dfill((2*lq+1)*(lmax+1), 0.0d0, q, 1)
      do l = 0,lmax             ! NOTE that |m| = l+1 is referenced
         do m = -lq,lq
            q(m,l) = 0.0d0
         end do
      end do
      q(0,0) = 1.0d0            ! MUST be after zero
      if (lmax.ge.1) then
         q(-1,1) = y
         q( 0,1) = z
         q( 1,1) = x
      end if
c
      r2 = x*x + y*y + z*z
      do l = 1, lmax-1
         lp1 = l + 1
         twolp1 = 2*l + 1
         q( lp1, lp1) = twolp1*(x*q( l,l) - y*q(-l,l))
         q(-lp1, lp1) = twolp1*(x*q(-l,l) + y*q( l,l))
         q(0,lp1) = (twolp1*z*q(0,l) - l*r2*q(0,l-1))*fastdiv(l+1)
c$$$         do m = 1,l
c$$$            q( m,lp1) = (twolp1*z*q( m,l) - (l+m)*r2*q( m,l-1))/(l-m+1)
c$$$            q(-m,lp1) = (twolp1*z*q(-m,l) - (l+m)*r2*q(-m,l-1))/(l-m+1)
c$$$         end do
         do m = 1,l
            q( m,lp1) = (twolp1*z*q( m,l) - (l+m)*r2*q( m,l-1)) *
     $           fastdiv(l-m+1)
            q(-m,lp1) = (twolp1*z*q(-m,l) - (l+m)*r2*q(-m,l-1)) *
     $           fastdiv(l-m+1)
         end do
      end do
c
      end
      subroutine xlm(lmax, x, y, z, q, lq)
      implicit none
#include "xlm.fh"
c
      integer lmax, lq
      double precision x, y, z, q(-lq:lq, 0:lmax)
c
      integer l, m, lp1
      double precision r2, twolp1, twolp1_z, lmr2
c
c     compute the unnormalized real solid spherical harmonics
c     up to order lmax at the point x, y, z.
c     lq specifies the dimension of q.
c
c     fast(er) version
c
      q(0,0) = 1.0d0
      if (lmax .eq. 0) return
      q(-1,1) = y
      q( 0,1) = z
      q( 1,1) = x
      if (lmax .eq. 1) return
      q(-2,2) = 6.0d0*x*y
      q(-1,2) = 3.0d0*y*z
      q( 0,2) = z*z - 0.5d0*(x*x+y*y)
      q( 1,2) = 3.0d0*x*z
      q( 2,2) = 3.0d0*(x*x-y*y)
      if (lmax .eq. 2) return
c
      r2 = x*x + y*y + z*z
      twolp1 = 5.0d0
      do l = 2, lmax-1
         lp1 = l + 1
         q( lp1, lp1) = twolp1*(x*q( l,l) - y*q(-l,l))
         q(-lp1, lp1) = twolp1*(x*q(-l,l) + y*q( l,l))
c
         twolp1_z = twolp1 * z
c
         lmr2 = dble(l)*r2
         q(0,lp1) = (twolp1_z*q(0,l) - lmr2*q(0,l-1))*fastdiv(l+1)
         do m = 1,l-1
            lmr2 = lmr2 + r2
            q( m,lp1) = (twolp1_z*q( m,l) - lmr2*q( m,l-1)) *
     $           fastdiv(l-m+1)
            q(-m,lp1) = (twolp1_z*q(-m,l) - lmr2*q(-m,l-1)) *
     $           fastdiv(l-m+1)
         end do
         q( l,lp1) = twolp1_z*q( l,l)
         q(-l,lp1) = twolp1_z*q(-l,l)
c
         twolp1 = twolp1 + 2.0d0
      end do
c
      end
      double precision function factorial(n)
      implicit none
      integer n, i
      double precision f
c
      f = 1.0d0
      do i = 1, n
         f = f * dble(i)
      enddo
c
      factorial = f
c
      end
      double precision function double_factorial(n)
      implicit none
      integer n, i
      double precision f
c
      f = 1.0d0
      do i = n, 1, -2
         f = f * dble(i)
      enddo
c
      double_factorial = f
c
      end
      subroutine xlm_coeff_inv(lmax,d,dinv)
      implicit none
      integer lmax
      double precision d(((lmax+1)*(lmax+2))/2, -lmax:lmax, 0:lmax)
      double precision 
     $     dinv(((lmax+1)*(lmax+2)*(lmax+3))/6,-lmax:lmax,0:lmax)
c
c     NOTE differing dimensions for d and dinv
c
c     Compute the coefficients of the solid harmonics for expanding
c     the cartesian basis ... the inverse of xlm_coeff.  I.e., return
c     in dinv
c
c     x^i y^j z^k = sum(l=i+j+k,0,-2) sum(m=-l..l) 
c     .                     r^(l-i-j-k) dinv(ijk,m,l) Xlm
c
c     Also returned (as an extra, added bonus for the wary shopper)
c     is d from xlm_coeff.
c
c     Xlm = sum(ijk) x^i y^j z^k d(ijk,m,l)
c     
c     dinv(ijk,lm) = <Xlm * x^iy^jz^k>/<Xlm^2>  
c
c     and use expansion of Xlm to obtain
c
c     dinv(ijk,lm) = sum(i'j'k') di'j'k',lm <x^(i+i')y^(j+j')z^(k+k')> 
c     .              / <Xlm^2> 
c
c     <x^i y^j z^k> = 4Pi (i-1)!!(j-1)!!(k-1)!!/(i+j+k+1)!!
c
c     <Xlm^2> = 4Pi [(l+|m|)!/(l-|m|)!] / [(2-delta(m,0))(2l+1)]
c
c     (<> = integral over unit sphere)
c
      integer i, j, k, l, lp, m, mp, itri, ind, ijk, loff,
     $     ip, jp, kp, ijkp
      double precision numerator, denominator, sum
      double precision double_factorial, factorial
      external double_factorial, factorial
c
      itri(i,j)  = (i*(i-1))/2 + j
      ind(i,j,l) = itri(l-i+1,l-i-j+1) ! Index of x^i*y^j*z^(l-i-j)
      loff(l) = ((l*(l+1)*(l+2))/6)
c
      call xlm_coeff(lmax, d)
c
      call dfill((((lmax+1)*(lmax+2)*(lmax+3))/6)*(2*lmax+1)*(lmax+1),
     $     0.0d0, dinv, 1)
c
      do l = 0, lmax
         do i = l, 0, -1
            do j = l-i, 0, -1
               k = l-i-j
               ijk = loff(l) + ind(i,j,l)
               do lp = l, 0, -2
                  do ip = lp, 0, -1
                     do jp = lp-ip, 0, -1
                        kp = lp-ip-jp
                        if ( (mod(i+ip,2).eq.0) .and. 
     $                       (mod(j+jp,2).eq.0) .and. 
     $                       (mod(k+kp,2).eq.0) ) then
                        numerator = 
     $                       double_factorial(i+ip-1)*
     $                       double_factorial(j+jp-1)*
     $                       double_factorial(k+kp-1)/
     $                       double_factorial(i+ip+j+jp+k+kp+1)
                        ijkp = ind(ip,jp,lp)
                        do mp = 0, lp
                           denominator = factorial(lp+mp)/
     $                          (factorial(lp-mp)*(lp+lp+1))
*                           write(6,*) l, i, j, k
*                           write(6,*) lp, ip, jp, kp
*                           write(6,*) ijk, ijkp
*                           write(6,*) numerator, denominator, 
*     $                          d(ijkp, mp,lp),
*     $                          d(ijkp, -mp,lp)
                           if (mp .ne. 0) 
     $                          denominator = denominator*0.5d0
                           dinv(ijk,mp,lp) = dinv(ijk,mp,lp) + 
     $                          d(ijkp, mp,lp)*numerator/denominator
                           if (mp .ne. 0) 
     $                          dinv(ijk,-mp,lp) = dinv(ijk,-mp,lp) + 
     $                          d(ijkp,-mp,lp)*numerator/denominator
                        enddo
                        endif
                     enddo
                  enddo
               enddo
*               write(6,22) i, j, k, ijk
* 22            format(' Expansion for ', 3i5, 2x, i5)
*               do lp = l, 0, -2
*                  do mp = -lp,lp
*                     if (dinv(ijk,mp,lp) .ne. 0.0d0)
*     $                    write(6,1) mp, lp, l-lp, dinv(ijk,mp,lp)
* 1                   format(1x,2i5,3x,i5,3x,g20.10)
*                  end do
*               enddo
            enddo
         enddo
      enddo
c
c     Check what we can for paranoia.  The norm of a solid harmonic
c     is unchanged by converting to cartesians and back again.
c
      do l = 0, lmax
         do m = -l, l
            sum = 0.0d0
            do i = l, 0, -1
               do j = l-i, 0, -1
                  k = l-i-j
                  ijk = ind(i,j,l)
                  sum = sum + d(ijk,m,l)*dinv(loff(l)+ijk,m,l)
               enddo
            enddo
            if (abs(sum-1.0d0) .gt. 1d-10) then
               write(0,*) ' errror ',abs(sum-1.0d0)
	    endif
         enddo
      enddo
c
      end
      
      subroutine xlm_coeff(lmax, d)
      implicit none
      integer lmax
      double precision d(((lmax+1)*(lmax+2))/2, -lmax:lmax, 0:lmax)
c
c     compute the coefficients of cartesian polynomials for the
c     unnormalized real solid spherical harmonics up to order lmax
c
      integer i, j, k, l, m, itri, ind, lp1, ijk
      double precision twolp1

      itri(i,j)  = (i*(i-1))/2 + j
      ind(i,j,l) = itri(l-i+1,l-i-j+1) ! Index of x^i*y^j*z^(l-i-j)
c
      call dfill((((lmax+1)*(lmax+2))/2)*(2*lmax+1)*(lmax+1),
     $     0.0d0, d, 1)
c
      d(1, 0,0) = 1.0d0         ! Constant
c
      if (lmax .ge. 1) then
         d(1, 1,1) = 1.0d0      ! x
         d(2,-1,1) = 1.0d0      ! y
         d(3, 0,1) = 1.0d0      ! z
      end if
c
      do l = 1, lmax-1
         lp1 = l + 1
         twolp1 = 2*l + 1
c     
         do i = lp1, 0, -1
            do j = lp1-i, 0, -1
               k = lp1 - i - j
c
               ijk = ind(i,j,lp1)
c
*     q( lp1, lp1) = twolp1*(x*q( l,l) - y*q(-l,l))
               if (i.gt.0) d(ijk,lp1,lp1) =
     $              d(ijk,lp1,lp1) + twolp1*
     $              d(ind(i-1,j,l),l,l)
               if (j.gt.0) d(ijk,lp1,lp1) = 
     $              d(ijk,lp1,lp1) - twolp1*
     $              d(ind(i,j-1,l),-l,l)

*     q(-lp1, lp1) = twolp1*(x*q(-l,l) + y*q( l,l))
               if (i.gt.0) d(ijk,-lp1,lp1) =
     $              d(ijk,-lp1,lp1) + twolp1*
     $              d(ind(i-1,j,l),-l,l)
               if (j.gt.0) d(ijk,-lp1,lp1) = 
     $              d(ijk,-lp1,lp1) + twolp1*
     $              d(ind(i,j-1,l),l,l)

*     q(0,lp1) = (twolp1*z*q(0,l) - l*r2*q(0,l-1))/(l+1)
               if (k.gt.0) d(ijk,0,lp1) =
     $              d(ijk,0,lp1) + twolp1*
     $              d(ind(i,j,l),0,l) / dble(l+1)
               if (i.gt.1) d(ijk,0,lp1) =
     $              d(ijk,0,lp1) - l*
     $              d(ind(i-2,j,l-1),0,l-1) / dble(l+1)
               if (j.gt.1) d(ijk,0,lp1) =
     $              d(ijk,0,lp1) - l*
     $              d(ind(i,j-2,l-1),0,l-1) / dble(l+1)
               if (k.gt.1) d(ijk,0,lp1) =
     $              d(ijk,0,lp1) - l*
     $              d(ind(i,j,l-1),0,l-1) / dble(l+1)

               do m = 1,l
*     q( m,lp1) = (twolp1*z*q( m,l) - (l+m)*r2*q( m,l-1))/(l-m+1)
*     q(-m,lp1) = (twolp1*z*q(-m,l) - (l+m)*r2*q(-m,l-1))/(l-m+1)

                  if (k.gt.0) then
                     d(ijk, m,lp1) = d(ijk, m,lp1) +
     $                    twolp1*d(ind(i,j,l), m,l)/dble(l-m+1)
                     d(ijk,-m,lp1) = d(ijk,-m,lp1) +
     $                    twolp1*d(ind(i,j,l),-m,l)/dble(l-m+1)
                  end if
                  if (i.gt.1) then
                     d(ijk, m,lp1) = d(ijk, m,lp1) -
     $                    (l+m)*d(ind(i-2,j,l-1), m,l-1)/dble(l-m+1)
                     d(ijk,-m,lp1) = d(ijk,-m,lp1) -
     $                    (l+m)*d(ind(i-2,j,l-1),-m,l-1)/dble(l-m+1)
                  end if
                  if (j.gt.1) then
                     d(ijk, m,lp1) = d(ijk, m,lp1) -
     $                    (l+m)*d(ind(i,j-2,l-1), m,l-1)/dble(l-m+1)
                     d(ijk,-m,lp1) = d(ijk,-m,lp1) -
     $                    (l+m)*d(ind(i,j-2,l-1),-m,l-1)/dble(l-m+1)
                  end if
                  if (k.gt.1) then
                     d(ijk, m,lp1) = d(ijk, m,lp1) -
     $                    (l+m)*d(ind(i,j,l-1), m,l-1)/dble(l-m+1)
                     d(ijk,-m,lp1) = d(ijk,-m,lp1) -
     $                    (l+m)*d(ind(i,j,l-1),-m,l-1)/dble(l-m+1)
                  end if
               end do
c
c$$$               do m = -lp1,lp1
c$$$                  if (d(ijk,m,lp1) .ne. 0.0d0)
c$$$     $                 write(6,1) lp1, m, i, j, k, d(ijk,m,lp1)
c$$$ 1                format(1x,2i5,3x,3i3,3x,g20.10)
c$$$               end do
            end do
         end do
      end do
c$$$      stop 31
c
      end
      subroutine xlm_init
      implicit none
#include "xlm.fh"
c
c     initialize data for unnormalized solid spherical harmonics
c
c     b(m,l) = e(m) / (l + |m|)! , |m| <= l, 0 otherwise
c     c(m,l) = e(m) * (l - |m|)! , |m| <= l, 0 otherwise
c     bcp0(m,l) = (b(m,l)*c(-m,l) + b(-m,l)*c(m,l))*phase(l+m) , m > 0
c     .           b(0,l)*c(0,l)*phase(l), m = 0
c     e(m) = -1 if m > 0 and m odd
c             1 otherwise
c     s(m) = -1 if m < 0
c             0 if m = 0
c             1 if m > 0
c     phase(m) = -1 if m odd  
c              =  1 if m even
c     qn(m,l) = normalization constant required by Condon & Shortley
c               so that the unnormalized xml satisfy
c               qn( m,l) * x( m,l) = r^l * Re (Yml) m >= 0
c               qn(-m,l) * x(-m,l) = r^l * Im (Yml) m >= 0
c               |m| <= l, 0 otherwise
c     rqn = 1.0d0 / qn
c     ee(m2,m1) = used to accellerate multipole_to_local
c     w, v are workspace
c     fastdiv(l) = 1.0d0/l, l=1,max2l+1
c
      integer l, m, nsample
      double precision pi4, pi
      integer m1, m2, m1m2, m1mm2, itheta, iphi
      double precision pe1, pe1m, theta, phi, x, y, z, test
      logical initialized
      data initialized/.false./

      if (initialized) return
      initialized = .true.

      numphi = 0                ! For caching rotation info
      numtheta = 0
      call ifill(maxhash, -1, iphis, 1)
      call ifill(maxhash, -1, ithetas, 1)

      do l = 1, maxl2+1
         fastdiv(l) = 1.0d0/dble(l)
      end do
      do l = 0, maxl
         do m = -maxl, maxl
            qn(m,l) = 0.0d0
            w(m,l) = 0.0d0
            v(m,l) = 0.0d0
         end do
      end do
      do l = 0, maxl2
         do m = -maxl2, maxl2
            b(m,l) = 0.0d0
            c(m,l) = 0.0d0
         end do
      end do
      do m = -maxl2, 0
         e(m) = 1.0d0
      end do
      do m = 1, maxl2, 2
         e(m) = -1.0d0
         if (m.lt.maxl2) e(m+1) = 1.0d0
      end do
      do m = -maxl2, maxl2
         s(m) = sign(1.0d0, dble(m))
      end do
      s(0) = 0.0d0
      phase(-maxl4) = 1.0d0
      do m = 1-maxl4, maxl4
         phase(m) = -phase(m-1)
      end do
c
      b(0,0) = 1.0d0
      c(0,0) = 1.0d0
      do l = 1, maxl2
         b(0,l) = b(0,l-1)/dble(l)
         c(0,l) = c(0,l-1)*dble(l)
         do m = 1, l
            b( m, l) = -b(m-1, l) / dble(l+m)
            b(-m, l) = abs(b(m,l))
            c(m, l) = -c(m-1, l) / dble(l-m+1)
            c(-m,l) = abs(c(m,l))
         end do
      end do
c
      do l = 0, maxl
         bcp0(0,l) = b(0,l)*c(0,l)*phase(l)
         do m = 1, l
            bcp0(m,l) = (b(m,l)*c(-m,l) + b(-m,l)*c(m,l))*phase(l+m)
         end do
      end do
c
c     This defintion of the normalization constant is now correct
c     and agrees with numerical quadrature of the functions.
c     It also yields unitary rotation matrices.  
c
c     ANY changes must be checked for impact everywhere qn is used
c     since the correct normalization and unitary property 
c     are relied upon.
c
      pi4 = 4.0d0*3.1415926535897932d0
      do l = 0, maxl
         do m = -l, l
            qn( m,l) = sqrt(2.0d0*(2*l+1)*b(m,l)*c(m,l)/pi4)*e(m)
            rqn(m,l) = 1.0d0/qn(m,l)
         end do
         qn(0,l) = qn(0,l) / sqrt(2.0d0)
         rqn(0,l) = 1.0d0/qn(0,l)
      end do
c
      do l = 0, maxl
         do m = -l,l
            twobc(m,l) = 2.0d0*b(m,l)*c(m,l)*rqn(m,l)
            rtwobcqnbp(m,l) = b(m,l)*phase(l+m)/twobc(m,l)
         enddo
         rtwobcqnbp(0,l) = rtwobcqnbp(0,l) * 2.0d0
      enddo
c
      do l = 0,maxl
         brqnp(0,l) = b(0,l)*0.5d0*rqn(0,l)
         do m = 1, l
            brqnp( m,l) = b(m,l)*rqn( m,l)
            brqnp(-m,l) = b(m,l)*rqn(-m,l)*phase(m)
         enddo
      enddo
c
      do m1 = 0, maxl
         pe1 = phase(m1)*e(m1)
         pe1m= phase(-m1)
*         if (m1 .eq. 0) pe1 = pe1 * 0.5d0
*         if (m1 .eq. 0) pe1m = pe1m * 0.5d0
         do m2 = 0, maxl
            m1m2 = m1+m2
            m1mm2 = m1-m2
            ee( m2, m1) = (e(m2)*pe1*e(m1m2)+pe1m*e(-m1m2))*e(m1)
            ee(-m2, m1) = (pe1*e(m1mm2)+e(m2)*pe1m*e(-m1mm2))*e(m1)
         end do
      end do
c
c     Compute the maximum value taken on by the field terms over
c     the surface of a unit sphere - used for screening interactions
c
      do l = 0, maxl
         do m = -l, l
            fieldmax(m,l) = 0.0d0
         enddo
      enddo
      nsample = maxl*2          ! No. of sampling points in pi/2
      pi = pi4/4.0d0
      do itheta = 0, 2*nsample  ! Search in +ve octant
         do iphi = 0, nsample
            phi = dble(iphi)*0.5d0*pi/dble(nsample)
            theta = dble(itheta)*0.5d0*pi/dble(2*nsample)

            z = cos(theta)
            x = sin(theta)*cos(phi)
            y = sin(theta)*sin(phi)

            call xlm(maxl, x, y, z, w, maxl)
            do l = 0, maxl
               do m = -l, l
                  test = pi4*w(m,l)*qn(m,l)*qn(m,l)/dble(l+l+1)
                  fieldmax(m,l) = max(abs(test),fieldmax(m,l))
               enddo
            enddo
         enddo
      enddo
c
*      write(6,*) ' b coefficients'
*      call xlm_print(maxl, b, maxl)
*      write(6,*) ' c coefficients'
*      call xlm_print(maxl, c, maxl)
*      write(6,*) ' qn coefficients'
*      call xlm_print(maxl, qn, maxl)
c
      end
      double precision function xlm_combin(n,m)
      implicit none
      integer n, m
c
c     Return n!/((n-m)!m!)
c
      double precision result
      integer i
c
      result = 1.0d0
      do i = n-m+1, n
         result = result * dble(i)
      enddo
      do i = 1, m
         result = result / dble(i)
      enddo
c
      xlm_combin = result
c
      end
      subroutine xlm_apply_z_y_rotation(lmax,alpha,beta,q,lq)
      implicit none
#include "xlm.fh"
      integer lmax,lq
      double precision alpha, beta, q(-lq:lq,0:lmax)
c
c     Apply a rotation of alpha radians about Z-axis followed
c     by a rotation of beta radians about the new Y-axis.
c
      call xlm_apply_z_rotation(lmax,alpha,q,lq)
      call xlm_apply_y_rotation(lmax,beta,q,lq)
c
      end
      subroutine xlm_apply_z_rotation(lmax,alpha,q,lq)
      implicit none
#include "xlm.fh"
      integer lmax,lq
      double precision alpha, q(-lq:lq,0:lmax)
c
c     Apply a rotation about the z axis of alpha radians
c     to the coefficients of unnormalized solid harmonics
c
      double precision cosa(0:maxl), sina(0:maxl), xp, xm
      integer l, m
c
      do m = 0,lmax
         cosa(m) = cos(m*alpha)
         sina(m) = sin(m*alpha)
      enddo
c
      do l = 1, lmax
         do m = 1, l
            xp = cosa(m)*q(m,l) + sina(m)*q(-m,l)
            xm =-sina(m)*q(m,l) + cosa(m)*q(-m,l)
            q( m,l) = xp
            q(-m,l) = xm
         enddo
      enddo
c
      end
      subroutine xlm_apply_y_rotation(lmax,beta,q,lq)
      implicit none
#include "xlm.fh"
      integer lmax,lq
      double precision beta, q(-lq:lq,0:lmax)
c
c     Apply a rotation about the y axis of beta radians
c     to the coefficients of unnormalized solid harmonics
c
      double precision dp((maxl+1)*(maxl+1)), 
     $     dm(maxl*maxl), qq(-maxl:maxl)
      integer l, m, mp, ind
c
      do l = 0, lmax
         call xlm_y_rotation_matrix(l,beta,dp,dm)
         do m = -l, l
            qq(m) = q(m,l)*rqn(m,l) ! Precondition
            q(m,l) = 0.0d0
         enddo
         ind = 1
         do mp = 0, l
            do m = 0, l
               q(m,l) = q(m,l) + dp(ind)*qq(mp)
               ind = ind + 1
            enddo
         enddo
         if (l .gt. 0) then
            ind = 1
            do mp = -l,-1
               do m = -l,-1
                  q(m,l) = q(m,l) + dm(ind)*qq(mp)
                  ind = ind + 1
               enddo
            enddo
         endif
         do m = -l, l
            q(m,l) = q(m,l)*qn(m,l) ! Undo preconditioning
         enddo
      enddo
c
      end
      subroutine xlm_y_rotation_matrix(l,beta,dp,dm)
      implicit none
#include "errquit.fh"
#include "xlm.fh"
c
      integer l
      double precision beta, dp(0:l,0:l),dm(l,l)
c
c     Return in dp and dm the matrices corresponding to the
c     operator rotating about the y axis by angle beta.
c
c     For numerical stability, the rotation matrices are
c     PRECONDITIONED with qn(m,l), the normalization constant
c     for the funciton.
c
c     Note that the preconditioned matrices are unitary.
c
c     Thus,
c
c     qn(m,l)*Xlm (theta+angle) = sum(m') Xlm' (theta)*qn(m',l)*dp(m',m)
c     qn(-m,l)*Xl-m(theta+angle) = sum(m') Xl-m'(theta)*qn(-m',l)*dp(-m',-m)
c
c     Or, to apply the operator to a set of coefficients consider
c
c     f(theta) = sum(m) Cm Xlm(theta) 
c     .        = sum(m) (Cm/qn(m))*(Xlm(theta)*qn(m))
c     .        = sum(m,m') (Cm/qn(m))*(Xlm'(theta+angle)*qn(m')*Dm'm)
c     .        = sum(m') Xlm'(theta+angle)*qn(m')*[sum(m) Dm'm*(Cm/qn(m))]
c     
c     i.e., the coeff of Xlm'(theta+beta) is qn(m')*sum(m) Dm'm*(Cm/qn(m))
c     which are formed by first dividing the coeffs by qn(m), multiplying 
c     by Dm'm and then multiplying by qn(m').
c
c     This is much more numerically stable than not scaling.
c
c     This routine is meant to be correct and accurate, but there
c     are MUCH faster ways of generating these matrices.
c     
      integer k, info, ipiv(maxl+1), m
      double precision theta, pi, x, y, z, rx, ry, rz, phi
      double precision a(0:maxl,0:maxl)
c
      pi = 3.1415926535897932d0
c
      do k = 0, l
         theta = dble(k)*pi/dble(l+1)
         z = cos(theta+beta)
         x = sin(theta+beta)
         y = 0.0d0
         call xlm(l, x, y, z, w, maxl)
         do m = 0, l
            dp(k,m) = w(m,l)*qn(m,l) ! Condition with qn
         enddo
         z = cos(theta)
         x = sin(theta)
         y = 0.0d0
         call xlm(l, x, y, z, w, maxl)
         do m = 0, l
            a(k,m) = w(m,l)*qn(m,l) ! Condition with qn
         enddo
      enddo
c
      call dgesv(l+1,l+1,a,maxl+1,ipiv,dp,l+1,info)
      if (info .ne. 0) call errquit('xlm_y_rot_mat: Pinfo ', info,
     &       FMM_ERR)
c
c$$$      do m = 0, l
c$$$         dp(m,m) = dp(m,m) - 1.0d0
c$$$      enddo
c$$$      write(6,*) ' DP '
c$$$      call doutput(dp,1,l+1,1,l+1,l+1,l+1,1)
c$$$      call dfill((l+1)**2,0.0d0,dp,1)
c$$$      do m = 0, l
c$$$         dp(m,m) = dp(m,m) + 1.0d0
c$$$      enddo
c
      if (l .gt. 0) then
         phi = pi/dble(2*l+1)     ! -ve m components are zero at phi=0
         do k = 1, l
            theta = dble(k)*pi/dble(l+1)
            z = cos(theta)
            x = sin(theta)*cos(phi)
            y = sin(theta)*sin(phi)
            call xlm(l, x, y, z, w, maxl)
            do m = 1, l
               a(k,l-m+1) = w(-m,l)*qn(-m,l)
            enddo
c     
            rx = x*cos(-beta) - z*sin(-beta)
            ry = y
            rz = z*cos(-beta) + x*sin(-beta)
            call xlm(l, rx, ry, rz, w, maxl)
            do m = 1, l
               dm(k,l-m+1) = w(-m,l)*qn(-m,l)
            enddo
         enddo
c
         call dgesv(l,l,a(1,1),maxl+1,ipiv,dm,l,info)
         if (info .ne. 0) call errquit('xlm_y_rot_mat: Minfo ', info,
     &       FMM_ERR)
c
c$$$         do m = 1, l
c$$$            dm(m,m) = dm(m,m) - 1.0d0
c$$$         enddo
c$$$         write(6,*) ' DM '
c$$$         call doutput(dm,1,l,1,l,l,l,1)
c$$$         call dfill(l*l,0.0d0,dm,1)
c$$$         do m = 1, l
c$$$            dm(m,m) = dm(m,m) + 1.0d0
c$$$         enddo
      endif
c
      end
      subroutine xlm_translate2(lmax, x, y, z, q, lq)
      implicit none
#include "xlm.fh"
c
      double precision x, y, z
      integer lmax, lq
      double precision q(-lq:lq,0:lmax)
      integer lbig, l, m, mmp, mp, mmpa, lp, llp, mpa, lo, hi
      double precision sump, summ, bfac
c
c     given a set of unnormalized multipoles about the origin in q
c     translate the center to (x,y,z).
c
      if (lmax .gt. maxl) then
         write(6,*) ' parameter exceeded', lmax, maxl
         stop 1
      end if
c
      do l = lmax, 0, -1
         do m = -l, l
            if (abs(q(m,l)) .gt. 0.0d0) goto 10
         enddo
      enddo

 10   lbig = l
      if (lbig .lt. 0) then
         do l = 0, lmax
            do m = -l, l
               q(m,l) = 0.0d0
            enddo
         enddo
         return
      endif
c
      call xlm(lmax, -x, -y, -z, w, maxl)
c
c     transfer the charge, then everything else
c
      do l = 0, lmax
         do m = -l, l
*            q(m,l) = q(m,l) ! UH ?
*            w(m,l) = w(m,l)
            v(m,l) = w(m,l) * q(0,0) * b(abs(m),l) * b(0,0)
         end do
      end do
c
      do l = 1, lmax
         do m = 0, l
            sump = 0.0d0
            summ = 0.0d0
            do lp = 1, min(l,lbig)
               llp = l - lp
               hi = min(lp,max(l-lp+m,lp-l+m))
               lo = max(-lp,min(l-lp+m,lp-l+m,-lp))
               do mp = lo, hi
                  mmp = m - mp
                  mmpa = abs(mmp)
                     bfac = b(mmp,llp)*b(mp,lp)
                     mpa = abs(mp)
                     sump = sump + (w(mmpa,llp)*q(mpa,lp) - 
     $                    w(-mmpa,llp)*q(-mpa,lp)*s(mmp)*s(mp))*bfac
                     summ = summ + (w(mmpa,llp)*q(-mpa,lp)*s(mp) +
     $                    w(-mmpa,llp)*q(mpa,lp)*s(mmp))*bfac
               end do
            end do
            v(-m,l) = v(-m,l) + summ
            v( m,l) = v( m,l) + sump
         end do
      end do
c
      do l = 0, lmax
         do m = -l, l
            q(m,l) = v(m,l) / b(abs(m),l)
         end do
      end do
c
      end
      subroutine xlm_translate(lmax, x, y, z, q, lq)
      implicit none
#include "xlm.fh"
c
      double precision x, y, z
      integer lmax, lq
      double precision q(-lq:lq,0:lmax)
      integer lbig, l, m, mmp, mp, mmpa, lp, llp, mpa
      double precision sump, summ, bfac
c
c     given a set of unnormalized multipoles about the origin in q
c     translate the center to (x,y,z).
c
      if (lmax .gt. maxl) then
         write(6,*) ' parameter exceeded', lmax, maxl
         stop 1
      end if
c
      do l = lmax, 0, -1
         do m = -l, l
            if (abs(q(m,l)) .gt. 0.0d0) goto 10
         enddo
      enddo

 10   lbig = l
      if (lbig .lt. 0) then
         do l = 0, lmax
            do m = -l, l
               q(m,l) = 0.0d0
            enddo
         enddo
         return
      endif
c
      call xlm(lmax, -x, -y, -z, w, maxl)
c
c     transfer the charge, then everything else
c
      do l = 0, lmax
         do m = -l, l
*            q(m,l) = q(m,l) ! UH ?
*            w(m,l) = w(m,l)
            v(m,l) = w(m,l) * q(0,0) * b(abs(m),l) * b(0,0)
         end do
      end do
c
      do l = 1, lmax
         do m = 0, l
            sump = 0.0d0
            summ = 0.0d0
            do lp = 1, min(l,lbig)
               llp = l - lp
               do mp = -lp, lp
                  mmp = m - mp
                  mmpa = abs(mmp)
                  if (mmpa .le. llp) then
                     bfac = b(mmp,llp)*b(mp,lp)
                     mpa = abs(mp)
                     sump = sump + (w(mmpa,llp)*q(mpa,lp) - 
     $                    w(-mmpa,llp)*q(-mpa,lp)*s(mmp)*s(mp))*bfac
                     summ = summ + (w(mmpa,llp)*q(-mpa,lp)*s(mp) +
     $                    w(-mmpa,llp)*q(mpa,lp)*s(mmp))*bfac
                  end if
               end do
            end do
            v(-m,l) = v(-m,l) + summ
            v( m,l) = v( m,l) + sump
         end do
      end do
c
      do l = 0, lmax
         do m = -l, l
            q(m,l) = v(m,l) / b(abs(m),l)
         end do
      end do
c
      end
      subroutine xlm_local_translate(lmax, x, y, z, q, lq)
      implicit none
#include "xlm.fh"
c
      integer lmax, lq
      double precision x, y, z, q(-lq:lq,0:lmax)
c
c     Given a local spherical taylor series for the potential 
c     translate the center of the expansion to (x,y,z).  
c
c     If the routine xlm_translate does
c     .   Qml(r-a) <= sum(m'l')Tmlm'l'(-a)Qm'l'(r)
c     this routine does
c     .   Qml(r-a) <= sum(m'l')Qm'l'(r)Tm'l'ml(a)
c
      integer l, m, mp, mmp, mmpa, mpa, lp, llp, lo, hi
      double precision bfac
c
      if (lmax .gt. maxl) then
         write(6,*) ' parameter exceeded', lmax, maxl
         stop 1
      end if
c
      call xlm(lmax, x, y, z, w, maxl)
c
      do l = 0, lmax
         do m = -l, l
            q(m,l) = q(m,l) / b(abs(m),l)
            v(m,l) = 0.0d0
         end do
      end do
c
      do l = 0, lmax
         do m = 0, l
            do lp = 0, l
               llp = l - lp
*
               hi = min(lp,max(l-lp+m,lp-l+m))
               lo = max(-lp,min(l-lp+m,lp-l+m,-lp))
               do mp = lo, hi
*
*               do mp = -lp, lp
                  mmp = m - mp
                  mmpa = abs(mmp)
*                  if (mmpa .le. llp) then
                     bfac = b(mmp,llp)*b(mp,lp)
                     mpa = abs(mp)

*                     Tm,l,mpa,lp  +=  w(mmpa,llp)*bfac
*                     Tm,l,-mpa,lp += -w(-mmpa,llp)*s(mmp)*s(mp)*bfac
*                     T-m,l,-mpa,lp += w(mmpa,llp)*s(mp)*bfac
*                     T-m,l,mpa,lp  += w(-mmpa,llp)*s(mmp))*bfac

                     v( mpa,lp) = v( mpa,lp) + bfac*(
     $                    w(mmpa,llp)*q(m,l) + 
     $                    w(-mmpa,llp)*s(mmp)*q(-m,l))
                     v(-mpa,lp) = v(-mpa,lp) + bfac*(
     $                    w(mmpa,llp)*s(mp)*q(-m,l) - 
     $                    w(-mmpa,llp)*s(mmp)*s(mp)*q(m,l))

*                  end if
               end do
            end do
         end do
      end do
c
      do l = 0, lmax
         do m = -l, l
            q(m,l) = v(m,l)
         end do
      end do
c
      end
      double precision function xlm_coulomb(lmax, ax, ay, az, aq, la,
     $     bx, by, bz, bq, lb)
      implicit none
#include "xlm.fh"
c
      integer lmax, la, lb
      double precision ax, ay, az, bx, by, bz
      double precision aq(-la:la, 0:lmax), bq(-lb:lb, 0:lmax)
c
c     compute the coulomb interaction between two unnormalized
c     real solid multipole expansions at centers a and b
c
      double precision xx, yy, zz, rsq, r1, r12, energy, ei, ereal
      integer l1, l2, m1, m2, l2max, m1a, m2a, l12, m12, m12a
      double precision bcpr, bq_plus, bq_minus, aq_plus, aq_minus
      double precision qnorm, eimag
c
      xx = bx - ax
      yy = by - ay
      zz = bz - az
      rsq = 1.0d0 / (xx*xx + yy*yy + zz*zz)
      call xlm(2*lmax, xx, yy, zz, u, maxl2)
c
      energy = 0.0d0
      ei = 0.0d0
      r1 = dsqrt(rsq)
      do l1 = 0, lmax
         l2max = lmax        ! Full summation
         do m1 = -l1, l1
            qnorm = abs(aq(m1,l1)) + abs(aq(-m1,l1))
            if (qnorm .ne. 0.0d0) then
               m1a = abs(m1)
               ereal = 0.0d0
               eimag = 0.0d0
               r12 = r1 * b(m1,l1) ! Included b here to keep no.s small
               do l2 = 0, l2max
                  do m2 = -l2, l2
                     m2a = abs(m2)
                     l12 = l1+l2
                     m12 = -(m1+m2)
                     m12a = abs(m12)
                     bcpr = (b(m2,l2)*r12)*(c(m12,l12)*phase(l2+m12))
                     bq_plus = (bq(m2a,l2)*bcpr)
                     bq_minus= (bq(-m2a,l2)*bcpr)
                     ereal = ereal + (bq_plus*u(m12a,l12) -
     $                    bq_minus*u(-m12a,l12)*s(m2)*s(m12))
                     eimag = eimag + (bq_minus*s(m2)*u(m12a,l12)+
     $                    bq_plus*u(-m12a,l12)*s(m12))
                  end do
                  r12 = r12 * rsq
               end do
               aq_plus = (aq(m1a,l1))
               aq_minus= (aq(-m1a,l1))
               energy = energy + 
     $              (ereal*aq_plus - eimag*aq_minus*s(m1))
               ei = ei + (ereal*aq_minus*s(m1)+eimag*aq_plus)
            end if
         end do
         r1 = r1 * rsq
      end do
*      if (abs(ei) .gt. 1.0d-10) then
*         write(6,*) ' xlmcoul: imaginary part of potential is large',
*     $        energy, ei
*      end if
c
      xlm_coulomb = energy
c
      end
      subroutine xlm_print(lmax, q, lq)
      implicit double precision (a-h, o-z)
      dimension q(-lq:lq, 0:lmax)
      parameter(mchunk = 6)
c
      do l = 0, lmax
         sum = 0.0d0
         do m = -l,l
            sum = sum + abs(q(m,l))
         end do
         if (sum .le. 1d-40) then
*            write(6,3) l
* 3          format(' l = ',i2,' is zero')
*            continue
         else
            write(6,1) l
 1          format(' l = ',i2)
            do mlow = -l, l, mchunk
               mhi = min(l, mlow+mchunk-1)
               write(6,2) (q(m,l),m=mlow,mhi)
 2             format('      ',1p,6d12.4)
            end do
         end if
      end do
c
      end
      double precision function xlm_potential(ax, ay, az, 
     $     bx, by, bz, bq, lb, lmax)
      implicit none
#include "xlm.fh"
c
      integer lb, lmax
      double precision ax, ay, az, bx, by, bz
      double precision bq(-lb:lb, 0:lmax)
c
c     compute the coulomb potential at A from the unnormalized 
c     real-solid multipole distribution at B.
c
      double precision xx, yy, zz, rsq
      double precision energy, r12
      integer l, m
c
      xx = bx - ax
      yy = by - ay
      zz = bz - az
      rsq = 1.0d0 / (xx*xx + yy*yy + zz*zz)
      call xlm(lmax, xx, yy, zz, u, maxl2)
c
      energy = 0.0d0
      r12 = dsqrt(rsq)
      do l = 0, lmax
         energy = energy + bcp0(0,l)*r12*bq(0,l)*u(0,l)
         do m = 1, l
            energy = energy + (bq(m,l)*u(m,l) +
     $           bq(-m,l)*u(-m,l))*bcp0(m,l)*r12
         end do
         r12 = r12 * rsq
      end do
c
      xlm_potential = energy
c
      end
      double precision function xlm_potential_test(ax, ay, az, 
     $     bx, by, bz, bq, lb, lmax)
      implicit none
#include "xlm.fh"
c
      integer lb, lmax
      double precision ax, ay, az, bx, by, bz
      double precision bq(-lb:lb, 0:lmax)
c
c     This version of xlm_potential just to make sure
c     the formula in the paper is correct!  It is.
c
      double precision xx, yy, zz, rsq
      double precision energy, r12, fourpi, sum
      integer l, m
c
      xx = bx - ax
      yy = by - ay
      zz = bz - az
      rsq = 1.0d0 / (xx*xx + yy*yy + zz*zz)
      call xlm(lmax, xx, yy, zz, u, maxl2)
      fourpi = 4.0d0*3.1415926535897932d0
c
      energy = 0.0d0
      r12 = dsqrt(rsq)
      do l = 0, lmax
         sum = 0.0d0
         do m = -l, l
            sum = sum + bq(m,l)*qn(m,l)*qn(m,l)*u(m,l)
         end do
         energy = energy + sum*fourpi*r12/dble(l+l+1)
         r12 = -r12 * rsq
      end do
c
      xlm_potential_test = energy
c
      end
      double precision function xlm_local_potential(x, y, z, 
     $     aq, la, lmax)
      implicit none
#include "xlm.fh"
      double precision x, y, z
      integer la, lmax
      double precision aq(-la:la,0:lmax)
c
c     Given in aq() an expansion of the local potential compute
c     it at the given point.  Note, that if the potential is 
c     expanded about some point A, then the coordinates relative
c     to A (r-a) should be passed in.
c
      integer l, m
      double precision sum
c
      call xlm(lmax, x, y, z, w, maxl)
      sum = 0.0d0
      do l = 0, lmax
         do m = -l,l
            sum = sum + w(m,l)*aq(m,l)
         end do
      end do
c
      xlm_local_potential = sum
c
      end
      subroutine xlm_unpack(lmax, p, q, lq)
      implicit none
      integer lmax, lq
      double precision p(*), q(-lq:lq, 0:lmax)
c
c     Unpack the multipoles in p (which are stored contiguously
c     with no space between) into the easier to use array q()
c
      integer l, m, ind
c
      ind = 1
      do l = 0, lmax
         do m = -l, l
            q(m,l) = p(ind)
            ind = ind + 1
         end do
      end do
c
      end
      subroutine xlm_pack(lmax, p, q, lq)
      implicit none
      integer lmax, lq
      double precision p(*), q(-lq:lq, 0:lmax)
c
c     Pack the multipoles into p (which are stored contiguously
c     with no space between) from the easier to use array q()
c
      integer l, m, ind
c
      ind = 1
      do l = 0, lmax
         do m = -l, l
            p(ind) = q(m,l)
            ind = ind + 1
         end do
      end do
c
      end
      subroutine xlm_accumulate_to_packed(lmax, p, q, lq)
      implicit none
      integer lmax, lq
      double precision p(*), q(-lq:lq, 0:lq)
c
c     Add into the packed multipoles p (which are stored contiguously
c     with no space between) from the easier to use array q()
c
      integer l, m, ind
c
      ind = 1
      do l = 0, lmax
         do m = -l, l
            p(ind) = p(ind) + q(m,l)
            ind = ind + 1
         end do
      end do
c
      end
      subroutine xlm_multipole_to_local(lmax, ax, ay, az, aq, la,
     $     bx, by, bz, bq, lb)
      implicit none
#include "xlm.fh"
c     
      integer lmax, la, lb
      double precision ax, ay, az, bx, by, bz
      double precision aq(-la:la, 0:la), bq(-lb:lb, 0:lb)
c     
c     Put into aq() the multipolar potential from the unnormalized
c     real solid multipole expansion at center B computed at center A.
c     
c     I.e., the potential at a point r near A due to the multipoles
c     at B may be computed as  
c     
c     .     sum(lm) Xlm(r-a)AQlm
c
c     
      double precision xx, yy, zz, rsq, r12, ereal, eimag
      integer l1, l2, m1, m2, l2max, l12, m12, m12a
      integer m1m2, m1mm2
      double precision urpp, urmm, uipp, uimm
**      integer flops
      double precision ww(0:maxl,0:maxl)
      double precision wv(0:maxl,0:maxl)
      double precision vw(0:maxl,0:maxl)
      double precision vv(0:maxl,0:maxl)
c
      do l1 = 0, la
         do m1 = -l1,l1
            aq(m1,l1) = 0.0d0
         enddo
      enddo
c
      do l2 = lmax,0,-1
         do m2 = -l2,l2
            if (abs(bq(m2,l2)) .gt. 0.0d0) goto 10
         enddo
      enddo
 10   l2max = l2
c
      if (l2max .lt. 0) return
c         
      xx = bx - ax
      yy = by - ay
      zz = bz - az
      rsq = 1.0d0 / (xx*xx + yy*yy + zz*zz)
      call xlm(lmax+l2max, xx, yy, zz, u, maxl2)
c
**      flops = 0
c
      do l2 = 0, l2max
         do m2 = 0, l2
            w(m2,l2) = bq( m2,l2)*b(m2,l2)*phase(l2+m2)*e(m2)
            v(m2,l2) = bq(-m2,l2)*b(m2,l2)*phase(l2+m2)*s(m2)*e(m2)
         enddo
         w(0,l2) = w(0,l2)*0.5d0
         v(0,l2) = v(0,l2)*0.5d0
      enddo
c
      do l12 = 0, lmax+l2max
         do m12 = -l12,l12
            m12a = abs(m12)
            ur(m12,l12) = u( m12a,l12)*c(-m12,l12)*e(m12)
            ui(m12,l12) = u(-m12a,l12)*c(-m12,l12)*s(-m12)*e(m12)
         end do
      end do
c
      r12 = sqrt(rsq)
      do l12 = 0, lmax+l2max
*         call dfill((maxl+1)**2,0.0d0,ww,1)
*         call dfill((maxl+1)**2,0.0d0,wv,1)
*         call dfill((maxl+1)**2,0.0d0,vw,1)
*         call dfill((maxl+1)**2,0.0d0,vv,1)
         do m1 = 0, min(l12,lmax)
            do m2 = 0, min(m1,l12-m1,l2max)
               m1m2 = m1+m2
               m1mm2 = m1-m2
               urpp = ur(m1m2, l12)*ee( m2,m1)
               urmm = ur(m1mm2,l12)*ee(-m2,m1)
               ww(m2,m1) = urpp + urmm
               ww(m1,m2) = ww(m2,m1)
               vv(m2,m1) = urpp - urmm
               vv(m1,m2) = vv(m2,m1)
c
               uipp = ui(m1m2, l12)*ee( m2,m1)
               uimm = ui(m1mm2,l12)*ee(-m2,m1)
               wv(m2,m1) = uimm - uipp
               vw(m1,m2) = -wv(m2,m1)
               vw(m2,m1) = uimm + uipp
               wv(m1,m2) = -vw(m2,m1)
            enddo
**            flops = flops + 8*(1+min(m1,l12-m1,l2max))
         enddo
c$$$         lll = min(l12+1,lmax+1)
c$$$         write(6,*) l12, ' ww '
c$$$         call doutput(ww, 1, lll, 1, lll, maxl+1, maxl+1, 1)
c$$$         write(6,*) l12, ' vv '
c$$$         call doutput(vv, 1, lll, 1, lll, maxl+1, maxl+1, 1)
c$$$         write(6,*) l12, ' wv '
c$$$         call doutput(wv, 1, lll, 1, lll, maxl+1, maxl+1, 1)
c$$$         write(6,*) l12, ' vw '
c$$$         call doutput(vw, 1, lll, 1, lll, maxl+1, maxl+1, 1)
         do l1 = max(0,l12-l2max), min(l12,lmax)
            l2 = l12 - l1
            ereal = ww(0,0)*w(0,l2)
            do m2 = 1, l2
               ereal = ereal+ww(m2,0)*w(m2,l2)+wv(m2,0)*v(m2,l2)
            end do
            aq( 0,l1) = aq( 0,l1) + ereal*r12
**            flops = flops + 3 + l2*4
            do m1 = 1, l1
               ereal = ww(0,m1)*w(0,l2)
               eimag = vw(0,m1)*w(0,l2)
               do m2 = 1, l2
                  ereal = ereal+ww(m2,m1)*w(m2,l2)+wv(m2,m1)*v(m2,l2)
                  eimag = eimag+vw(m2,m1)*w(m2,l2)+vv(m2,m1)*v(m2,l2)
               end do
               aq( m1,l1) = aq( m1,l1) + ereal*r12
               aq(-m1,l1) = aq(-m1,l1) - eimag*r12
            end do
**            flops = flops + l1*(6+l2*8)
         end do
         r12 = r12 * rsq
      end do
c
      do l1 = 0,lmax
         aq( 0,l1) = aq(0,l1)*b(0,l1)*0.5d0
         do m1 = 1, l1
            aq( m1,l1) = aq( m1,l1)*b(m1,l1)
            aq(-m1,l1) = aq(-m1,l1)*b(m1,l1)*s(m1)
         enddo
      enddo
c
c
**       write(6,*) ' oldflops ', flops
*       stop
c
      end
      subroutine xlm_multipole_to_local_z(lmax, az, aq, la, bq, lb)
      implicit none
#include "xlm.fh"
c     
      integer lmax, la, lb
      double precision az
      double precision aq(-la:la, 0:la), bq(-lb:lb, 0:lb)
c     
c     Put into aq() the multipolar potential from the unnormalized
c     real solid multipole expansion at center B computed at center A.
c
c     RESTRTICTED TO Z ONLY TRANSLATION
c     
c     I.e., the potential at a point r near A due to the multipoles
c     at B may be computed as  
c     
c     .     sum(lm) Xlm(r-a)AQlm
c     
      double precision r, r12, r12ww
      integer l1, l2, m1, l2max, l12, minl1l2
      double precision ww
c
      do l1 = 0, la
         do m1 = -l1,l1
            aq(m1,l1) = 0.0d0
         enddo
      enddo
c
c$$$      do l2 = lmax,0,-1
c$$$         do m2 = -l2,l2
c$$$            if (abs(bq(m2,l2)) .gt. 0.0d0) goto 10
c$$$         enddo
c$$$      enddo
c$$$ 10   l2max = l2
      l2max = lmax
c
c$$$      if (l2max .lt. 0) return
c
c$$$      do l2 = 0, l2max
c$$$         do m2 = -l2, l2
c$$$            w(m2,l2) = bq( m2,l2)*b(m2,l2)*phase(l2+m2)
c$$$         enddo
c$$$      enddo
c$$$      do l2 = 0, l2max
c$$$         do m2 = -l2, l2
c$$$            w(m2,l2) = bq(m2,l2)
c$$$         enddo
c$$$      enddo
c
      r = 1.0d0/az
      r12 = r
c
c     l12 = 0 
c
      ww = 2.0d0
      aq(0,0) = aq(0,0) + r12*ww*bq(0,0)
      r12 = r12 * r
c
c     l12 = 1
c
      if (lmax+l2max .ge. 1) then
         ww = -ww
         r12ww = r12*ww
         aq(0,0) = aq(0,0) + r12ww*bq(0,1) ! l1=0, l2=1
         aq(0,1) = aq(0,1) + r12ww*bq(0,0) ! l1=1, l2=0
         r12 = r12 * r
      endif
c
c     Can't this be done in L^2 ops?  
c
      do l12 = 2, lmax+l2max
         ww = -ww * dble(l12) ! (-1)^l * 2 * l!
         do l1 = max(0,l12-l2max), min(l12,lmax)
            l2 = l12 - l1
            minl1l2 = min(l1,l2)
            r12ww = r12*ww
            do m1 = -minl1l2, minl1l2
               aq( m1,l1) = aq( m1,l1) + r12ww*bq(m1,l2)
            end do
         end do
         r12 = r12 * r
      end do
c
c$$$      rsign = sign(1.0d0,r)
c$$$      do l1 = 0,lmax
c$$$         aq( 0,l1) = aq(0,l1)*b(0,l1)*0.5d0*rsign
c$$$         do m1 = 1, l1
c$$$            aq( m1,l1) = aq( m1,l1)*(b(m1,l1)*rsign)
c$$$            aq(-m1,l1) = aq(-m1,l1)*(b(m1,l1)*rsign)*phase(m1)
c$$$         enddo
c$$$      enddo
c
      end
      subroutine xlm_multipole_to_local_swap(lmax,
     $     ax, ay, az, aq, ap, la,
     $     bx, by, bz, bq, bp, lb)
      implicit none
#include "xlm.fh"
c     
      integer lmax, la, lb
      double precision ax, ay, az, bx, by, bz
      double precision aq(-la:la, 0:la), bq(-lb:lb, 0:lb)
      double precision ap(-la:la, 0:la), bp(-lb:lb, 0:lb)
c     
c     Put into ap() the multipolar potential from the unnormalized
c     real solid multipole expansion at center B computed at center A
c     and similarly pu the potential from aq() into bp()
c     
c     I.e., the potential at a point r near A due to the multipoles
c     at B may be computed as  
c     
c     .     sum(lm) Xlm(r-a)APlm
c
c     and vice versa
c     
      double precision xx, yy, zz, rsq, r12, r12ph
      double precision ereala, eimaga, erealb, eimagb 
      integer l1, l2, m1, m2, l12, m12, m12a
      integer m1m2, m1mm2, lmax2
      double precision urpp, urmm, uipp, uimm, ce, bpe
      integer flops
      double precision ww(0:maxl,0:maxl)
      double precision wv(0:maxl,0:maxl)
      double precision vw(0:maxl,0:maxl)
      double precision vv(0:maxl,0:maxl)
      double precision wa(0:maxl,0:maxl), va(0:maxl,0:maxl)
      double precision wb(0:maxl,0:maxl), vb(0:maxl,0:maxl)
c
      lmax2 = lmax+lmax
c
      do l1 = 0, la
         do m1 = -l1,l1
            ap(m1,l1) = 0.0d0
         enddo
      enddo
      do l1 = 0, lb
         do m1 = -l1,l1
            bp(m1,l1) = 0.0d0
         enddo
      enddo
c         
      xx = bx - ax
      yy = by - ay
      zz = bz - az
      rsq = 1.0d0 / (xx*xx + yy*yy + zz*zz)
      call xlm(lmax2, xx, yy, zz, u, maxl2)
c
      flops = 0
c
      do l2 = 0, lmax
         do m2 = 0, l2
            bpe = b(m2,l2)*phase(l2+m2)*e(m2)
            wa(m2,l2) = aq( m2,l2)*bpe
            va(m2,l2) = aq(-m2,l2)*(bpe*s(m2))
            wb(m2,l2) = bq( m2,l2)*bpe
            vb(m2,l2) = bq(-m2,l2)*(bpe*s(m2))
         enddo
         wa(0,l2) = wa(0,l2)*0.5d0
         wb(0,l2) = wb(0,l2)*0.5d0
      enddo
c
      do l12 = 0, lmax2
         do m12 = -l12,l12
            m12a = abs(m12)
            ce = c(-m12,l12)*e(m12)
            ur(m12,l12) = u( m12a,l12)*ce
            ui(m12,l12) = u(-m12a,l12)*ce*s(-m12)
         end do
      end do
c
      r12   = sqrt(rsq)
      r12ph = r12
      do l12 = 0, lmax2
         do m1 = 0, min(l12,lmax)
            do m2 = 0, min(m1,l12-m1,lmax)
               m1m2 = m1+m2
               m1mm2 = m1-m2
               urpp = ur(m1m2, l12)*ee( m2,m1)
               urmm = ur(m1mm2,l12)*ee(-m2,m1)
               ww(m2,m1) = urpp + urmm
               ww(m1,m2) = ww(m2,m1)
               vv(m2,m1) = urpp - urmm
               vv(m1,m2) = vv(m2,m1)
c
               uipp = ui(m1m2, l12)*ee( m2,m1)
               uimm = ui(m1mm2,l12)*ee(-m2,m1)
               wv(m2,m1) = uimm - uipp
               vw(m1,m2) = -wv(m2,m1)
               vw(m2,m1) = uimm + uipp
               wv(m1,m2) = -vw(m2,m1)
            enddo
*            flops = flops + 8*(1+min(m1,l12-m1,lmax))
         enddo
         do l1 = max(0,l12-lmax), min(l12,lmax)
            l2 = l12 - l1
            ereala = ww(0,0)*wa(0,l2)
            erealb = ww(0,0)*wb(0,l2)
            do m2 = 1, l2
               ereala = ereala + ww(m2,0)*wa(m2,l2)+wv(m2,0)*va(m2,l2)
               erealb = erealb + ww(m2,0)*wb(m2,l2)+wv(m2,0)*vb(m2,l2)
            end do
            ap( 0,l1) = ap( 0,l1) + erealb*r12
            bp( 0,l1) = bp( 0,l1) + ereala*r12ph
*            flops = flops + 3 + l2*4
            do m1 = 1, l1
               ereala = ww(0,m1)*wa(0,l2)
               eimaga = vw(0,m1)*wa(0,l2)
               do m2 = 1, l2
                  eimaga =eimaga+vw(m2,m1)*wa(m2,l2)+vv(m2,m1)*va(m2,l2)
                  ereala =ereala+ww(m2,m1)*wa(m2,l2)+wv(m2,m1)*va(m2,l2)
               enddo
               bp( m1,l1) = bp( m1,l1) + ereala*r12ph
               bp(-m1,l1) = bp(-m1,l1) - eimaga*r12ph
               erealb = ww(0,m1)*wb(0,l2)
               eimagb = vw(0,m1)*wb(0,l2)
               do m2 = 1, l2    ! SUN slower with merged loops ?
                  erealb =erealb+ww(m2,m1)*wb(m2,l2)+wv(m2,m1)*vb(m2,l2)
                  eimagb =eimagb+vw(m2,m1)*wb(m2,l2)+vv(m2,m1)*vb(m2,l2)
               end do
               ap( m1,l1) = ap( m1,l1) + erealb*r12
               ap(-m1,l1) = ap(-m1,l1) - eimagb*r12
            end do
*            flops = flops + l1*(6+l2*8)
         end do
         r12 = r12 * rsq
         r12ph = -r12ph * rsq
      end do
c
      do l1 = 0,lmax
         ap( 0,l1) = ap( 0,l1)*b(0,l1)*0.5d0
         bp( 0,l1) = bp( 0,l1)*b(0,l1)*0.5d0
         do m1 = 1, l1
            ap( m1,l1) = ap( m1,l1)*b(m1,l1)
            ap(-m1,l1) = ap(-m1,l1)*b(m1,l1)*s(m1)
            bp( m1,l1) = bp( m1,l1)*b(m1,l1)
            bp(-m1,l1) = bp(-m1,l1)*b(m1,l1)*s(m1)
         enddo
      enddo
c
c
*       write(6,*) ' flops ', flops
*       stop
c
      end
      subroutine xlm_new_multipole_to_local(lmax, 
     $     xp, yp, zp, p, lp, xq, yq, zq, q, lq)
      implicit none
#include "errquit.fh"
#include "xlm.fh"
c     
      double precision flops, flopsv, flopst, calls
      common /xlmflops/flops, flopsv, flopst, calls
c     
      integer lmax, lq, lp
      double precision xp, yp, zp, xq, yq, zq
      double precision q(-lq:lq,0:lmax), p(-lp:lp,0:lp)
c     
      double precision theta, phi, x, y, z, zz, phisign, qqp, qqm
      double precision rr, r12, ww, r12ww, pp, pm
      double precision pi, thetasign
      double precision qq(-maxl:maxl,0:maxl), tmp(-maxl:maxl)
      integer l, m, mp, ihash, iphi, itheta, indp, indm
      integer l1, l2, l12, m1, minl1l2
c     
c     From the multipole-potential q() at (xq,yq,zq) compute
c     the local Taylor series potential at (xp,yp,zp), in p() 
c     using a rotation-based algorithm.  
c     
c     Under the assumption that only a limited no. of angles
c     will be used, cache rotation matrix info.
c     
      x = xp - xq
      y = yp - yq
      z = zp - zq
      rr = 1.0d0/sqrt(x*x + y*y + z*z)
c     
c     Determine the required rotations
c     
      pi = 3.1415926535897932d0
      if (x.eq.0.0d0 .and. y.eq.0.0d0) then
         phi = 0.0d0
         theta = 0.0d0
         if (z .lt. 0.0d0) theta = pi
      else 
         zz = z*rr
         if (abs(zz) .gt. 1.0d0) zz = sign(1.0d0,zz)
         theta = acos(zz)
         phi = atan2(y,x)
      endif
c     
c     Rotate the source multipoles.  The actual potential
c     is roughly 2*qml*bml*cml*xml/r^(2l+1), so before we
c     rotate we must include these additional factors.
c     
c     Hash into the list of cached angles to get the rotation info.
c     The cached phis are all positive so need to track the sign.
c     The cached thetas are all 0-pi/2, so if phi is pi/2-pi then
c     must rotate with theta-pi and use negative translation.
c     
      ihash = int(abs(phi*1000.0d0))
      if (ihash .gt. maxhash) call errquit('xlm_n_m_l: phi hash',ihash,
     &       FMM_ERR)
      if (iphis(ihash) .gt. 0) then
         if (abs(phis(ihash)-abs(phi)) .gt. 1d-12) then
            write(6,*) ' ihash phi phis ', ihash, phi, phis(ihash)
            call errquit('xlm_n_m_l: duplicate phi hash',0,
     &       FMM_ERR)
         endif
      else
         call xlm_cache_phi(phi)
      endif
      iphi = iphis(ihash)
      phisign = sign(1.0d0,phi)
c     
      if (theta .le. 0.5d0*pi) then
         thetasign = 1.0d0
      else
         theta = theta - pi
         thetasign = -1.0d0
      endif
      ihash = int(abs(theta*1000.0d0))
      if (ihash .gt. maxhash)call errquit('xlm_n_m_l: theta hash',ihash,
     &       FMM_ERR)
      if (ithetas(ihash) .gt. 0) then
         if (abs(thetas(ihash)-abs(theta)) .gt. 1d-12) then
            write(6,*) ' ihash theta thetas ', ihash, theta, 
     $           thetas(ihash)
            call errquit('xlm_n_m_l: duplicate theta hash',0, FMM_ERR)
         endif
      else
         call xlm_cache_theta(theta)
      endif
      itheta = ithetas(ihash)
c     
c     Add extra weights, apply Z rotation, apply preconditioning
c     
      if (phisign .gt. 0.0d0) then
         do l = 0, lmax
            do m = 1, l
               qqp = cosmphi(m,iphi)*q( m,l) + sinmphi(m,iphi)*q(-m,l)
               qqm = cosmphi(m,iphi)*q(-m,l) - sinmphi(m,iphi)*q( m,l)
               qq( m,l) = qqp*twobc(m,l)
               qq(-m,l) = qqm*twobc(-m,l)
            enddo
            qq(0,l) = q(0,l)*rqn(0,l)
         enddo
      else
         do l = 0, lmax
            do m = 1, l
               qqp = cosmphi(m,iphi)*q( m,l) - sinmphi(m,iphi)*q(-m,l)
               qqm = cosmphi(m,iphi)*q(-m,l) + sinmphi(m,iphi)*q( m,l)
               qq( m,l) = qqp*twobc(m,l)
               qq(-m,l) = qqm*twobc(-m,l)
            enddo
            qq(0,l) = q(0,l)*rqn(0,l)
         enddo
      endif
*      flops = flops + 1 + 5*lmax + 4*lmax*lmax
c     
c     Apply Y rotation
c     
      indp = 2
      indm = 1
      do l = 1, lmax
         do m = -l, l
            tmp(m) = qq(m,l)
            qq(m,l) = 0.0d0
         enddo
c     
*         flopsv = flopsv + l*l*2 + (l+1)*(l+1)*2
c     
         if (l .gt. 3) then
            call xlm_m2l_rot1(l, qq(-l,l), tmp(-l),
     $           cdp(indp,itheta), cdm(indm,itheta), thetasign)
            indp = indp + (l+1)*(l+1)
            indm = indm + l*l
         else
            if (thetasign .gt. 0.0d0) then
               do mp = 0, l
                  do m = 0, l
                     qq(m,l) = qq(m,l) + cdp(indp+m,itheta)*tmp(mp)
                  enddo
                  indp = indp + l + 1
               enddo
               do mp = -l,-1
                  indm = indm + l
                  do m = -l,-1
                     qq(m,l) = qq(m,l) + cdm(indm+m,itheta)*tmp(mp)
                  enddo
               enddo
            else
               do m = 0, l
                  do mp = 0, l
                     qq(m,l) = qq(m,l) + cdp(indp+mp,itheta)*tmp(mp)
                  enddo
                  indp = indp + l + 1
               enddo
               do m = -l,-1
                  indm = indm + l
                  do mp = -l,-1
                     qq(m,l) = qq(m,l) + cdm(indm+mp,itheta)*tmp(mp)
                  enddo
               enddo
            endif
         endif
      enddo
c     
c     Remove precond and weights and add extra weights for translate
c
      do l = 0, lmax
         do m = -l, l
            qq(m,l) = qq(m,l)*rtwobcqnbp(m,l)
            p(m,l) = 0.0d0
         enddo
      enddo
*      flops = flops + (lmax+1)*(lmax+1)
c     
c     Translate 0,0,r
c
      rr = thetasign * rr
      r12 = rr
c
c     l12 = 0 
c
      ww = 2.0d0
      p(0,0) = p(0,0) + r12*ww*qq(0,0)
      r12 = r12 * rr
c
*      flopst = flopst + 3d0
c
c     l12 = 1
c
      if (lmax .gt. 0) then
         ww = -ww
         r12ww = r12*ww
         p(0,0) = p(0,0) + r12ww*qq(0,1) ! l1=0, l2=1
         p(0,1) = p(0,1) + r12ww*qq(0,0) ! l1=1, l2=0
         r12 = r12 * rr
*         flopst = flopst + 7d0
      endif
c
      do l12 = 2, lmax+lmax
         ww = -ww * dble(l12) ! (-1)^l * 2 * l12!
         do l1 = max(0,l12-lmax), min(l12,lmax)
            l2 = l12 - l1
            minl1l2 = min(l1,l2)
            r12ww = r12*ww
            do m1 = -minl1l2, minl1l2
               p( m1,l1) = p( m1,l1) + r12ww*qq(m1,l2)
            end do
*            flopst = flopst + 4*minl1l2 + 5d0
         end do
         r12 = r12 * rr
*         flopst = flopst + 1
      end do
c
      if (thetasign .gt. 0.0d0) then
         do l = 0, lmax
            do m = -l, l
               p(m,l) = p(m,l) * brqnp(m,l)
            enddo
         enddo
      else
         do l = 0, lmax
            do m = -l, l
               p(m,l) = -p(m,l) * brqnp(m,l)
            enddo
         enddo
      endif
*      flops = flops + 2*lmax + 1
c     
c     Rotate the potentials back
c     
c     Precondition
c
      indp = 2
      indm = 1
      do l = 1, lmax
c     
c     Apply Y rotation
c     
         do m = -l, l
            tmp(m) = p(m,l)
            p(m,l) = 0.0d0
         enddo
c     
*         flopsv = flopsv + l*l*2 + (l+1)*(l+1)*2
c$$$         if (l .gt. -1) then
            call xlm_m2l_rot1(l, p(-l,l), tmp(-l),
     $           cdp(indp,itheta), cdm(indm,itheta), -thetasign)
            indp = indp + (l+1)*(l+1)
            indm = indm + l*l
c$$$         else
c$$$            if (thetasign .lt. 0.0d0) then
c$$$               do mp = 0, l
c$$$                  do m = 0, l
c$$$                     p(m,l) = p(m,l) + cdp(indp+m,itheta)*tmp(mp)
c$$$                  enddo
c$$$                  indp = indp + l + 1
c$$$               enddo
c$$$               do mp = -l,-1
c$$$                  indm = indm + l
c$$$                  do m = -l,-1
c$$$                     p(m,l) = p(m,l) + cdm(indm+m,itheta)*tmp(mp)
c$$$                  enddo
c$$$               enddo
c$$$            else
c$$$               do m = 0, l
c$$$                  do mp = 0, l
c$$$                     p(m,l) = p(m,l) + cdp(indp+mp,itheta)*tmp(mp)
c$$$                  enddo
c$$$                  indp = indp + l + 1
c$$$               enddo
c$$$               do m = -l,-1
c$$$                  indm = indm + l
c$$$                  do mp = -l,-1
c$$$                     p(m,l) = p(m,l) + cdm(indm+mp,itheta)*tmp(mp)
c$$$                  enddo
c$$$               enddo
c$$$            endif
c$$$         endif
      enddo
c
c     Undo preconditioning and apply Z rotation
c
      if (phisign .gt. 0.0d0) then
         do l = 0, lmax
            p(0,l) = p(0,l) * qn(0,l)
            do m = 1, l
               pp = p( m,l)*qn( m,l)
               pm = p(-m,l)*qn(-m,l)
               qqp = cosmphi(m,iphi)*pp - sinmphi(m,iphi)*pm
               qqm = cosmphi(m,iphi)*pm + sinmphi(m,iphi)*pp
               p( m,l) = qqp
               p(-m,l) = qqm
            enddo
         enddo
      else
         do l = 0, lmax
            p(0,l) = p(0,l) * qn(0,l)
            do m = 1, l
               pp = p( m,l)*qn( m,l)
               pm = p(-m,l)*qn(-m,l)
               qqp = cosmphi(m,iphi)*pp + sinmphi(m,iphi)*pm
               qqm = cosmphi(m,iphi)*pm - sinmphi(m,iphi)*pp
               p( m,l) = qqp
               p(-m,l) = qqm
            enddo
         enddo
      endif
*      flops = flops + 1 + 5*lmax + 4*lmax*l
c     
*      calls = calls + 1
c     
      end
      subroutine xlm_cache_phi(phi)
      implicit none
#include "errquit.fh"
#include "xlm.fh"
      double precision phi
c
c     Add to the list of phis with cached rotation info
c
      integer m, ihash
c
      if (numphi.lt.0 .or. numphi.ge.maxnumphi) call errquit
     $     ('xlm_cache_phi: numphi is invalid ', numphi, FMM_ERR)
      numphi = numphi + 1
c
      ihash = int(abs(phi*1000.0d0))
      if (iphis(ihash) .gt. 0) call errquit
     $     ('xlm_cache_phi: duplicate hash ', ihash, FMM_ERR)
      iphis(ihash) = numphi
      phis(ihash) = abs(phi)
c
      do m = 1, maxl
         cosmphi(m,numphi) = cos(dble(m)*abs(phi))
         sinmphi(m,numphi) = sin(dble(m)*abs(phi))
      end do
c
*      write(6,1) abs(phi), ihash, numphi
* 1    format(' xlm_cache_phi: added phi=',f9.6,
*     $     '   ihash=',i5,'   iphi=',i4)
c
      end
      subroutine xlm_cache_theta(theta)
      implicit none
#include "errquit.fh"
#include "xlm.fh"
      double precision theta
c
c     Add to the list of thetas with cached rotation info
c
      integer l, ihash, indp, indm
c
      if (numtheta.lt.0 .or. numtheta.ge.maxnumtheta) call errquit
     $     ('xlm_cache_theta: numtheta is invalid ', numtheta, FMM_ERR)
      numtheta = numtheta + 1
c
      ihash = int(abs(theta*1000.0d0))
      if (ithetas(ihash) .gt. 0) call errquit
     $     ('xlm_cache_theta: duplicate hash ', ihash, FMM_ERR)
      ithetas(ihash) = numtheta
      thetas(ihash) = abs(theta)
c
      indp = 1
      indm = 1
c$$$      write(6,*) ' theta ', theta
      do l = 0, maxl
         call xlm_y_rotation_matrix(l, abs(theta),
     $        cdp(indp,numtheta), cdm(indm,numtheta))
c$$$         if (l .lt. 4) then
c$$$            write(6,*)  l
c$$$            call output(cdp(indp,numtheta),1,l+1,1,l+1,l+1,l+1,1)
c$$$         endif
         indp = indp + (l+1)*(l+1)
         indm = indm + l*l
      end do
      if (indm-1 .ne. dmdim) call errquit
     $     ('xlm_theta_cache: bad indm ', indm, FMM_ERR)
      if (indp-1 .ne. dpdim) call errquit
     $     ('xlm_theta_cache: bad indp ', indp, FMM_ERR)
c
*      write(6,1) abs(theta), ihash, numtheta
* 1    format(' xlm_cache_theta: added theta=',f9.6,
*     $     '   ihash=',i5,'   itheta=',i4)
c
      end
c$$$      subroutine xlm_m2l_rot1(l,qq,tmp,cdp,cdm,thetasign)
c$$$      implicit none
c$$$      integer l, lmax, maxl
c$$$      double precision qq(-l:l), tmp(-l:l)
c$$$      double precision cdp(0:l,0:l), cdm(-l:-1,-l:-1)
c$$$      double precision thetasign
c$$$c     
c$$$      integer m, mp
c$$$c     
c$$$      if (thetasign .gt. 0.0d0) then
c$$$         do mp = 0, l
c$$$            do m = 0, l
c$$$               qq(m) = qq(m) + cdp(m,mp)*tmp(mp)
c$$$            enddo
c$$$         enddo
c$$$         do mp = -l,-1
c$$$            do m = -l,-1
c$$$               qq(m) = qq(m) + cdm(m,mp)*tmp(mp)
c$$$            enddo
c$$$         enddo
c$$$      else
c$$$         do m = 0, l
c$$$            do mp = 0, l
c$$$               qq(m) = qq(m) + cdp(mp,m)*tmp(mp)
c$$$            enddo
c$$$         enddo
c$$$         do m = -l,-1
c$$$            do mp = -l,-1
c$$$               qq(m) = qq(m) + cdm(mp,m)*tmp(mp)
c$$$            enddo
c$$$         enddo
c$$$      endif
c$$$c
c$$$      end

      
C****************************************************************
C   Translated by Pacific-Sierra Research VAST-2          
C   Version 6.1C1 on  4/ 3/99 at 11:38:11
C****************************************************************
C
      subroutine xlm_m2l_rot1(l,qq,tmp,cdp,cdm,thetasign)
      implicit none
      integer l
      double precision qq(-l:l), tmp(-l:l)
      double precision cdp(0:l,0:l), cdm(-l:-1,-l:-1)
      double precision thetasign
c      
      integer m, mp
c      
      integer j1, j2, j3, j4, mp1, mp2, m1, m2, m3, m4
      doubleprecision d1, d2, d3, d4, d5, qq1, qq2, qq3, qq4, qq5, d11, 
     .d12, d13, d14, d15, qq6, qq7, qq8, qq9, qq10, qq61, qq62, qq63, qq
     .11, qq12, qq13, d27, d28, d29, d30, d31, d32, d33, d34, d35, d36, 
     .d37, d38, d39, d40, d41, d42
      if (thetasign .gt. 0.0d0) then
*      if (l + 1 .gt. 0) then
         j1 = iand(l + 1,3)
         do mp = 1, j1
            m4 = iand(max0(l + 1,0),3)
            do m = 1, m4
               qq(m-1) = qq(m-1) + cdp(m-1,mp-1)*tmp(mp-1)
            end do
            do m = m4 + 1, l + 1, 4
               d39 = qq(m-1) + cdp(m-1,mp-1)*tmp(mp-1)
               d40 = qq(m) + cdp(m,mp-1)*tmp(mp-1)
               d41 = qq(m+1) + cdp(m+1,mp-1)*tmp(mp-1)
               d42 = qq(m+2) + cdp(m+2,mp-1)*tmp(mp-1)
               qq(m-1) = d39
               qq(m) = d40
               qq(m+1) = d41
               qq(m+2) = d42
            end do
         end do
         do mp = j1 + 1, l + 1, 4
            m3 = iand(max0(l + 1,0),3)
            do m = 1, m3
               qq(m-1) = qq(m-1) + cdp(m-1,mp-1)*tmp(mp-1) + cdp(m-1,mp)
     1            *tmp(mp) + cdp(m-1,mp+1)*tmp(mp+1) + cdp(m-1,mp+2)*tmp
     2            (mp+2)
            end do
            do m = m3 + 1, l + 1, 4
               d35 = qq(m-1) + cdp(m-1,mp-1)*tmp(mp-1) + cdp(m-1,mp)*tmp
     1            (mp) + cdp(m-1,mp+1)*tmp(mp+1) + cdp(m-1,mp+2)*tmp(mp+
     2            2)
               d36 = qq(m) + cdp(m,mp-1)*tmp(mp-1) + cdp(m,mp)*tmp(mp)
     1             + cdp(m,mp+1)*tmp(mp+1) + cdp(m,mp+2)*tmp(mp+2)
               d37 = qq(m+1) + cdp(m+1,mp-1)*tmp(mp-1) + cdp(m+1,mp)*tmp
     1            (mp) + cdp(m+1,mp+1)*tmp(mp+1) + cdp(m+1,mp+2)*tmp(mp+
     2            2)
               d38 = qq(m+2) + cdp(m+2,mp-1)*tmp(mp-1) + cdp(m+2,mp)*tmp
     1            (mp) + cdp(m+2,mp+1)*tmp(mp+1) + cdp(m+2,mp+2)*tmp(mp+
     2            2)
               qq(m-1) = d35
               qq(m) = d36
               qq(m+1) = d37
               qq(m+2) = d38
            end do
         end do
*      endif
*      if (l .gt. 0) then
         j2 = iand(l,3)
         do mp = 1, j2
            m2 = iand(max0(l,0),3)
            do m = 1, m2
               qq(m-1-l) = qq(m-1-l) + cdm(m-1-l,mp-1-l)*tmp(mp-1-l)
            end do
            do m = m2 + 1, l, 4
               d31 = qq(m-1-l) + cdm(m-1-l,mp-1-l)*tmp(mp-1-l)
               d32 = qq(m-l) + cdm(m-l,mp-1-l)*tmp(mp-1-l)
               d33 = qq(m+1-l) + cdm(m+1-l,mp-1-l)*tmp(mp-1-l)
               d34 = qq(m+2-l) + cdm(m+2-l,mp-1-l)*tmp(mp-1-l)
               qq(m-1-l) = d31
               qq(m-l) = d32
               qq(m+1-l) = d33
               qq(m+2-l) = d34
            end do
         end do
         do mp = j2 + 1, l, 4
            m1 = iand(max0(l,0),3)
            do m = 1, m1
               qq(m-1-l) = qq(m-1-l) + cdm(m-1-l,mp-1-l)*tmp(mp-1-l) + 
     1            cdm(m-1-l,mp-l)*tmp(mp-l) + cdm(m-1-l,mp+1-l)*tmp(mp+1
     2            -l) + cdm(m-1-l,mp+2-l)*tmp(mp+2-l)
            end do
            do m = m1 + 1, l, 4
               d27 = qq(m-1-l) + cdm(m-1-l,mp-1-l)*tmp(mp-1-l) + cdm(m-1
     1            -l,mp-l)*tmp(mp-l) + cdm(m-1-l,mp+1-l)*tmp(mp+1-l) + 
     2            cdm(m-1-l,mp+2-l)*tmp(mp+2-l)
               d28 = qq(m-l) + cdm(m-l,mp-1-l)*tmp(mp-1-l) + cdm(m-l,mp-
     1            l)*tmp(mp-l) + cdm(m-l,mp+1-l)*tmp(mp+1-l) + cdm(m-l,
     2            mp+2-l)*tmp(mp+2-l)
               d29 = qq(m+1-l) + cdm(m+1-l,mp-1-l)*tmp(mp-1-l) + cdm(m+1
     1            -l,mp-l)*tmp(mp-l) + cdm(m+1-l,mp+1-l)*tmp(mp+1-l) + 
     2            cdm(m+1-l,mp+2-l)*tmp(mp+2-l)
               d30 = qq(m+2-l) + cdm(m+2-l,mp-1-l)*tmp(mp-1-l) + cdm(m+2
     1            -l,mp-l)*tmp(mp-l) + cdm(m+2-l,mp+1-l)*tmp(mp+1-l) + 
     2            cdm(m+2-l,mp+2-l)*tmp(mp+2-l)
               qq(m-1-l) = d27
               qq(m-l) = d28
               qq(m+1-l) = d29
               qq(m+2-l) = d30
            end do
         end do
*      endif
      else
*      if (l + 1 .gt. 0) then
         j3 = iand(l + 1,3)
         do m = 1, j3
            qq1 = qq(m-1)
            mp2 = iand(max0(l + 1,0),3)
            do mp = 1, mp2
               qq1 = qq1 + cdp(mp-1,m-1)*tmp(mp-1)
            end do
            qq11 = 0.D0
            qq12 = 0.D0
            qq13 = 0.D0
            do mp = mp2 + 1, l + 1, 4
               qq1 = qq1 + cdp(mp-1,m-1)*tmp(mp-1)
               qq11 = qq11 + cdp(mp,m-1)*tmp(mp)
               qq12 = qq12 + cdp(mp+1,m-1)*tmp(mp+1)
               qq13 = qq13 + cdp(mp+2,m-1)*tmp(mp+2)
            end do
            qq1 = qq1 + qq11 + qq12 + qq13
            qq(m-1) = qq1
         end do
         do m = j3 + 1, l + 1, 4
            qq2 = qq(m-1)
            qq3 = qq(m)
            qq4 = qq(m+1)
            qq5 = qq(m+2)
            do mp = 1, l + 1
               d1 = tmp(mp-1)
               d1 = tmp(mp-1)
               d1 = tmp(mp-1)
               d1 = tmp(mp-1)
               d2 = qq2 + cdp(mp-1,m-1)*d1
               d3 = qq3 + cdp(mp-1,m)*d1
               d4 = qq4 + cdp(mp-1,m+1)*d1
               d5 = qq5 + cdp(mp-1,m+2)*d1
               qq2 = d2
               qq3 = d3
               qq4 = d4
               qq5 = d5
            end do
            qq(m+2) = qq5
            qq(m+1) = qq4
            qq(m) = qq3
            qq(m-1) = qq2
         end do
*      endif
*      if (l .gt. 0) then
         j4 = iand(l,3)
         do m = 1, j4
            qq6 = qq(m-1-l)
            mp1 = iand(max0(l,0),3)
            do mp = 1, mp1
               qq6 = qq6 + cdm(mp-1-l,m-1-l)*tmp(mp-1-l)
            end do
            qq61 = 0.D0
            qq62 = 0.D0
            qq63 = 0.D0
            do mp = mp1 + 1, l, 4
               qq6 = qq6 + cdm(mp-1-l,m-1-l)*tmp(mp-1-l)
               qq61 = qq61 + cdm(mp-l,m-1-l)*tmp(mp-l)
               qq62 = qq62 + cdm(mp+1-l,m-1-l)*tmp(mp+1-l)
               qq63 = qq63 + cdm(mp+2-l,m-1-l)*tmp(mp+2-l)
            end do
            qq6 = qq6 + qq61 + qq62 + qq63
            qq(m-1-l) = qq6
         end do
         do m = j4 + 1, l, 4
            qq7 = qq(m-1-l)
            qq8 = qq(m-l)
            qq9 = qq(m+1-l)
            qq10 = qq(m+2-l)
            do mp = 1, l
               d11 = tmp(mp-1-l)
               d11 = tmp(mp-1-l)
               d11 = tmp(mp-1-l)
               d11 = tmp(mp-1-l)
               d12 = qq7 + cdm(mp-1-l,m-1-l)*d11
               d13 = qq8 + cdm(mp-1-l,m-l)*d11
               d14 = qq9 + cdm(mp-1-l,m+1-l)*d11
               d15 = qq10 + cdm(mp-1-l,m+2-l)*d11
               qq7 = d12
               qq8 = d13
               qq9 = d14
               qq10 = d15
            end do
            qq(m+2-l) = qq10
            qq(m+1-l) = qq9
            qq(m-l) = qq8
            qq(m-1-l) = qq7
         end do
*      endif
      endif
c      
      end

*
* $Id: c_v_wvfnc_new.F 19707 2010-10-29 17:59:36Z d3y133 $
*

      subroutine c_v_wvfnc_new(v_wavefunction_filename,
     >                      version,
     >                      ngrid,
     >                      unita,
     >                      ispin,
     >                      ne,nbrillioun,spin_orbit)
      implicit none
      character*50 v_wavefunction_filename
      integer      version
      integer      ngrid(3)
      real*8       unita(3,3)
      integer      ispin,ne(2),nbrillioun
      logical      spin_orbit

#include "mafdecls.fh"
 
*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)
      logical value
      character*255 full_filename
      integer nfft1,nfft2,nfft3,nfft3d,n2ft3d
      integer occupation
      integer cfull_indx,cfull_hndl,l
      integer ms,n,ierr,ispin0,nb

      call Parallel_taskid(taskid)
      if (taskid.eq.MASTER) then 
      value = .false.

*     ***** constants *****
      nfft1=ngrid(1)
      nfft2=ngrid(2)
      nfft3=ngrid(3)
      nfft3d=nfft1*nfft2*nfft3
      n2ft3d=2*nfft3d

*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull_hndl,cfull_indx)
      call dcopy(n2ft3d,0.0d0,0,dcpl_mb(cfull_indx),1)

 
*:::::::::::::::::  write wavefunction in CPMDV3 format ::::::::::::::
      call util_file_name_noprefix(v_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      call openfile(6,full_filename,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,ngrid,3)
      call dwrite(6,unita,9)
      if (spin_orbit) then
         ispin0 = 3
      else
         ispin0 = ispin
      end if
      call iwrite(6,ispin0,1)
      call iwrite(6,ne,2)
      call iwrite(6,nbrillioun,1)
      occupation = -1
      call iwrite(6,occupation,1)
 

      do nb=1,nbrillioun
      do ms=1,ispin
        if (ne(ms).LE.0) GO TO 150
        do n=1,ne(ms)
          call dwrite(6,dcpl_mb(cfull_indx),n2ft3d)
        end do  
  150   continue
      end do
      end do
 
      call closefile(6)

      ierr=0
      GO TO 9999
 
 9110 ierr=10
      GO TO 9999
 9111 ierr=11
      GO TO 9999
 
 9999 value = MA_free_heap(cfull_hndl)

      write(*,*) 
     >  "Generated initial cwavefunctions velocities:",
     >  v_wavefunction_filename
      end if
      call ga_sync()
      
      return 
      end
 

      logical function argos_prep_master(lfnfrg,lfnout,nparms,nparmsp,
     + latm,catm,qatm,matm,natm,lbnd,mbnd,nbnd,izmat,zmat,mzmat,nzmat,
     + dir,fils,ndx,ndx2)
c
      implicit none
c
#include "util.fh"
#include "argos_prep_common.fh"
c
      integer lfnfrg,lfnout,matm,natm,mbnd,nbnd,mzmat,nzmat
      integer nparms,nparmsp
      integer latm(6,matm),lbnd(2,mbnd),izmat(mzmat,4)
      integer ndx(matm),ndx2(matm)
      character*6 catm(nparmsp,matm)
      real*8 qatm(nparms,2,matm),zmat(mzmat,3)
      character*255 dir,fils(nparmsp)
c
      character*255 filfrg,card
      character*10 date,time
c
      integer i,j,k,l,length,number
c
      call swatch(date,time)
c
      do 1 i=1,nparms
      write(filfrg,'(a,a)') dir(1:index(dir,' ')-1),
     + fils(i)(1:index(fils(i),' ')-1)//'.frg '
      length=index(filfrg,' ')-1
      open(unit=lfnfrg,file=filfrg(1:length),form='formatted',
     + status='unknown',err=9999)
      write(lfnfrg,1000) fils(i)(1:index(fils(i),' ')),date,time
 1000 format('$',a,/,'# ',2a10)
      number=0
      do 2 j=1,natm
      ndx2(j)=0
      if(catm(i+1,j)(6:6).ne.'D') then
      number=number+1
      ndx(number)=j
      ndx2(j)=number
      endif
    2 continue
      write(lfnfrg,1002) number,1,1,nzmat,fils(i)(1:index(fils(i),' '))
 1002 format(4i5,/,a)
      do 3 k=1,number
      j=ndx(k)
      write(lfnfrg,1003) k,catm(1,j),catm(i+1,j),
     + (latm(l,j),l=1,5),qatm(i,1,j),qatm(i,2,j)
 1003 format(i5,2a6,5i5,2f12.6)
    3 continue
      do 4 k=1,nbnd
      if(ndx2(lbnd(1,k)).gt.0.and.ndx2(lbnd(2,k)).gt.0) then
      write(lfnfrg,1004) ndx2(lbnd(1,k)),ndx2(lbnd(2,k))
 1004 format(2i5)
      endif
    4 continue
      close(unit=lfnfrg,status='keep')
    1 continue
 
c
  999 continue
c
      argos_prep_master=.true.
      return
c
 9999 continue
      argos_prep_master=.false.
      return
      end
c $Id: argos_prep_master.F 21176 2011-10-10 06:35:49Z d3y133 $

c
c     $Id: sdminimize.F 19707 2010-10-29 17:59:36Z d3y133 $                       
c

      subroutine sdminimize(flag)
      implicit none
      integer flag

#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"

*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)

      logical oprint
      integer it,it_in
      real*8 dt,dte

*     **** external functions ****
      logical  control_print
      integer  control_it_in
      real*8   control_time_step,control_fake_mass

      external control_print
      external control_it_in
      external control_time_step,control_fake_mass

      dt = control_time_step()
      dte = dt/dsqrt(control_fake_mass())
      it_in = control_it_in()
      if (flag.gt.0) it_in = flag

      do it=1,it_in
         call psi1to2_sd_update(dte)
         call psi_2to1()
      end do

      call Parallel_taskid(taskid)
      oprint = (taskid.eq.MASTER).and.control_print(print_medium)
      if (oprint) then
        write(luout,'(A,I3,A)') "     - ",
     >             it_in," steepest descent iterations performed"
      end if
  
      return
      end
 

      subroutine sdminimize_virtual(flag)
      implicit none
      integer flag

#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"

*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)

      logical oprint
      integer it,it_in
      real*8 dt,dte

*     **** external functions ****
      logical  control_print
      integer  control_it_in
      real*8   control_time_step,control_fake_mass

      external control_print
      external control_it_in
      external control_time_step,control_fake_mass

      write(*,*) "Warning - sdminimize_virutal not finished"
      dt = control_time_step()
      dte = dt/dsqrt(control_fake_mass())
      it_in = control_it_in()
      if (flag.gt.0) it_in = flag

      do it=1,it_in
c         call epsi1to2_sd_update_virtual(dte)
         call epsi_2to1()
      end do

      call Parallel_taskid(taskid)
      oprint = (taskid.eq.MASTER).and.control_print(print_medium)
      if (oprint) then
        write(luout,'(A,I3,A)') "     - ",
     >             it_in," steepest descent iterations performed"
      end if

      return
      end

      subroutine argos_space_initf(fw,fs,llng,iwz,isz,lpair)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      integer iwz(mwm),isz(msa)
      logical llng,lpair
c
      integer i,j,k,l,m,il,ih,jl,jh
c
      llong=llng
c
      m=1
      if(llong) m=2
c
      do 1 l=1,m
      if(nwm.gt.0) then
      do 2 k=1,mwa
      do 3 j=1,3
      do 4 i=1,mwm
      fw(i,j,k,l)=zero
    4 continue
    3 continue
    2 continue
      endif
      if(nsa.gt.0) then
      do 5 j=1,3
      do 6 i=1,msa
      fs(i,j,l)=zero
    6 continue
    5 continue
      endif
    1 continue
c
      if(nwm.gt.0) then
      call ga_distribution(ga_w,me,il,ih,jl,jh)
      call ga_put(ga_w,il,ih,jl+6*mwa+3,jl+9*mwa+2,fw,mwm)
      if(llong) call ga_put(ga_w,il,ih,jl+9*mwa+3,jl+12*mwa+2,
     + fw(1,1,1,2),mwm)
      endif
      if(nsa.gt.0) then
      call ga_distribution(ga_s,me,il,ih,jl,jh)
      call ga_put(ga_s,il,ih,jl+6,jl+8,fs,msa)
      if(llong) call ga_put(ga_s,il,ih,jl+9,jl+11,fs(1,1,2),msa)
      endif
c
      if(lpair) then
      do 7 i=1,mwm
      iwz(i)=0
    7 continue
      do 8 i=1,msa
      isz(i)=0
    8 continue
      call ga_zero(ga_iwz)
      call ga_zero(ga_isz)
      endif
c
      return
      end
c $Id: argos_space_initf.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine obftrans(ovbf,ovbftrn,tr,nsy,nchan,nscat,nsch,nlm,
     1 ngauss,ngch,nbfmax,lmtop,nchnl,iprint,ovbftrnp,ovbfp,istat,ioft)
       implicit real*8 (a-h,o-z)
       character*8 istat,ioft
c
c  transform the bound index of the bound-free overlaps
c
      real*8 tr(nbfmax,nbfmax)
      complex*16 ovbf(lmtop,nbfmax,nchnl),ovbfp(lmtop,nbfmax,nchnl)
      complex*16 ovbftrn(lmtop,nbfmax,nchnl)
      complex*16 ovbftrnp(lmtop,nbfmax,nchnl)
      integer nscat(nchnl),ngauss(nchnl),nlm(nchnl),nsch(nbfmax,nchnl)
      integer ngch(nbfmax,nchnl)
      do 100 ic=1,nchan
      nlmic=nlm(ic)
      nsic=nscat(ic)
      do 110 i=1,nlmic
      do 110 j=1,nsic
      ovbftrnp(i,j,ic)=0.0
110   ovbftrn(i,j,ic)=0.0
      ngic=ngauss(ic)
      if(istat.eq.ioft)then
      do 102 kkc=1,ngic
      do 102 ilm=1,nlmic
      do 102 isc=1,nsic
 102     ovbftrnp(ilm,isc,ic)=ovbftrnp(ilm,isc,ic) +
     1   ovbfp(ilm,kkc,ic)*tr(ngch(kkc,ic),nsch(isc,ic))
      endif
      do 100 kkc=1,ngic
      do 100 ilm=1,nlmic
      do 100 isc=1,nsic
100   ovbftrn(ilm,isc,ic)=ovbftrn(ilm,isc,ic) +
     1   ovbf(ilm,kkc,ic)*tr(ngch(kkc,ic),nsch(isc,ic))
      if(iprint.ne.0) then
      do 200 ic=1,nchan
      write(6,107) ic
107   format(//' transformed bound free overlaps for channel:',i4)
      nlmic=nlm(ic)
      nsic=nscat(ic)
      do 200 ilm=1,nlmic
200   write(6,101) ilm,(ovbftrn(ilm,j,ic),j=1,nsic)
101   format(1x,i3,3("(",f8.5,3x,f8.5,")",3x),/,
     &     (4x,3("(",f8.5,3x,f8.5,")",3x)))
      if(istat.eq.ioft)then
      do 201 ic=1,nchan
      write(6,108) ic
 108  format(//' transformed bound free (p) overlaps for channel:',i4)
      nlmic=nlm(ic)
      nsic=nscat(ic)
      do 201 ilm=1,nlmic
 201     write(6,101) ilm,(ovbftrnp(ilm,j,ic),j=1,nsic)     
      endif
      endif
      return
      end
c $Id: obftrans.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function tce_ccsd_lambda_response_driver(title,thresh,
     &        maxiter,
     &        d_yr1,k_yr1_offset,size_yr1,d_yr2,k_yr2_offset,size_yr2,
     &        d_y1,k_y1_offset,d_y2,k_y2_offset,
     &        d_tr1,k_tr1_offset,size_tr1,d_tr2,k_tr2_offset,size_tr2,
     &        d_t1,k_t1_offset,size_t1,d_t2,k_t2_offset,size_t2,
     &        d_f1,k_f1_offset,d_v2,k_v2_offset,d_o1,k_o1_offset,omega)
c
c $Id: tce_ccsd_lambda_response_driver.F 19706 2010-10-29 17:52:31Z d3y133 $
c 
c Main routine for many-electron theory calculations.
c Some of the subroutines have been generated by 
c operator/tensor contraction engines.
c
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "sf.fh"
#include "inp.fh"
#include "errquit.fh"
#include "tce.fh"
c#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
c#include "tce_amps.fh"
c#include "tce_diis.fh"
c
c     CI, CC, & MBPT
c
      integer iter,maxiter
      logical nodezero         ! True if node 0
      logical recompf          ! True if recompute Fock
      double precision cpu     ! CPU sec counter
      double precision wall    ! WALL sec counter
      integer irrep
      integer irrep_g
      integer d_yr1             ! SF handle for yr1 amplitudes
      integer k_yr1_offset      ! Offset for yr1 file
      integer size_yr1          ! File size in doubles
      integer d_yr2             ! SF handle for yr2 amplitudes
      integer k_yr2_offset      ! Offset for yr2 file
      integer size_yr2          ! File size in doubles
      integer d_yrr1            ! SF handle for yrr1 amplitudes
      integer d_yrr2            ! SF handle for yrr2 amplitudes
      integer d_tr1             ! SF handle for tr1 amplitudes
      integer k_tr1_offset      ! Offset for tr1 file
      integer size_tr1          ! File size in doubles
      integer d_tr2             ! SF handle for tr2 amplitudes
      integer k_tr2_offset      ! Offset for tr2 file
      integer size_tr2          ! File size in doubles
      integer d_rr1             ! SF handle for rr1 amplitudes
      integer d_rr2             ! SF handle for rr2 amplitudes
      integer d_o1
      integer k_o1_offset
      integer size_o1
      integer d_f1             ! SF handle for MO 1e integrals
      integer k_f1_offset      ! Offset for 1e integral file
      integer size_1e          ! File size in doubles
      integer d_v2             ! SF handle for MO 2e integrals
      integer k_v2_offset      ! Offset for 2e integral file
      integer size_2e          ! File size in doubles
      integer d_t1             ! SF handle for t1 amplitudes
      integer k_t1_offset      ! Offset for t1 file
      integer size_t1          ! File size in doubles
      integer d_t2             ! SF handle for t2 amplitudes
      integer k_t2_offset      ! Offset for t2 file
      integer size_t2          ! File size in doubles
      integer d_y1             ! Lambda 1 file
      integer d_y2             ! Lambda 2 file
      integer k_y1_offset      ! Offset for Lambda 1 file
      integer size_y1          ! File size in doubles
      integer k_y2_offset      ! Offset for Lambda 2 file
      integer size_y2          ! File size in doubles
      double precision rr1      ! Residual t1
      double precision rr2      ! Residual t2
      double precision residual! Largest residual
      double precision thresh
      double precision ddotfile
      double precision omega
      external ddotfile
      integer dummy            ! Dummy argument for DIIS
      character*8 yrr1filename ! File name stub
      data yrr1filename/'yrr1  '/
      character*8 yrr2filename ! File name stub
      data yrr2filename/'yrr2  '/
      character*255 filename
      character*20 title
      character*4 irrepname
      irrep_g=0
      nodezero=(ga_nodeid().eq.0)
      call tce_diis_init()
      do iter=1,maxiter
        cpu=-util_cpusec()
        wall=-util_wallsec()
        if (nodezero.and.(iter.eq.1))
     &    write(LuOut,9400) title
        call tce_filename(yrr1filename,filename)
        call createfile(filename,d_yrr1,size_yr1)
        call tce_zero(d_yrr1,size_yr1)
        call daxpyfile(1,omega,d_yr1,d_yrr1,size_yr1)
        irrep_y=irrep_g ! using Lambda(0) amplitudes
        call ccsd_y_o1(d_yrr1,d_o1,d_t1,d_t2,
     1       d_y1,d_y2,k_yr1_offset,
     2       k_o1_offset,k_t1_offset,k_t2_offset,
     3       k_y1_offset,k_y2_offset)
        irrep_y=irrep_g ! using Lambda(0) amplitudes
        call ccsd_y_tr1(d_f1,d_yrr1,d_t1,d_t2,d_v2,
     1       d_tr1,d_tr2,d_y1,
     2       d_y2,k_f1_offset,k_yr1_offset,
     3       k_t1_offset,k_t2_offset,k_v2_offset,
     4       k_tr1_offset,k_tr2_offset,
     5       k_y1_offset,k_y2_offset)
        irrep_y=irrep_d ! using Lambda(1) amplitudes
        call eomccsd_y1(d_f1,d_yrr1,d_t1,d_t2,d_v2,
     1       d_yr1,d_yr2,k_f1_offset,
     2       k_yr1_offset,k_t1_offset,k_t2_offset,
     3       k_v2_offset,k_yr1_offset,k_yr2_offset)
        call tce_filename(yrr2filename,filename)
        call createfile(filename,d_yrr2,size_yr2)
        call tce_zero(d_yrr2,size_yr2)
        call daxpyfile(1,omega,d_yr2,d_yrr2,size_yr2)
        irrep_y=irrep_g ! using Lambda(0) amplitudes
        call ccsd_y_o2(d_yrr2,d_o1,d_t1,
     1       d_y1,d_y2,k_yr2_offset,
     2       k_o1_offset,k_t1_offset,
     3       k_y1_offset,k_y2_offset)
        irrep_y=irrep_g ! using Lambda(0) amplitudes
        call ccsd_y_tr2(d_f1,d_yrr2,d_t1,d_v2,
     1       d_tr1,d_tr2,d_y1,
     2       d_y2,k_f1_offset,k_yr2_offset,
     3       k_t1_offset,k_v2_offset,
     4       k_tr1_offset,k_tr2_offset,
     5       k_y1_offset,k_y2_offset)
        irrep_y=irrep_d ! using Lambda(1) amplitudes
        call eomccsd_y2(d_f1,d_yrr2,d_t1,d_t2,d_v2,
     1       d_yr1,d_yr2,k_f1_offset,
     2       k_yr2_offset,k_t1_offset,k_t2_offset,
     3       k_v2_offset,k_yr1_offset,k_yr2_offset)
        call reconcilefile(d_yrr1,size_yr1)
        call reconcilefile(d_yrr2,size_yr2)
        rr1 = ddotfile(d_yrr1,d_yrr1,size_yr1)
        rr2 = ddotfile(d_yrr2,d_yrr2,size_yr2)
        residual = max(rr1,rr2)
        cpu=cpu+util_cpusec()
        wall=wall+util_wallsec()
        if (nodezero) write(LuOut,9420) iter,residual,cpu,wall
        if (residual .lt. thresh) then
          if (nodezero) write(LuOut,9410)
          call deletefile(d_yrr2)
          call deletefile(d_yrr1)
          call tce_diis_tidy()
          tce_ccsd_lambda_response_driver=.true.
          return
        endif
        irrep_y=irrep_d
        call tce_diis2(.true.,iter,.true.,.true.,.false.,.false.,
     1       d_yrr1,d_yr1,k_yr1_offset,size_yr1,
     3       d_yrr2,d_yr2,k_yr2_offset,size_yr2,
     5       dummy,dummy,dummy,dummy,
     6       dummy,dummy,dummy,dummy)
        call deletefile(d_yrr2)
        call deletefile(d_yrr1)
        if (nodezero) call util_flush(LuOut)
      enddo
      call tce_diis_tidy()
      tce_ccsd_lambda_response_driver=.false.
      return  
c
c     ======
c     Format
c     ======
c
 9000 format(1x,A,' file size   = ',i16)
 9010 format(1x,A,' file name   = ',A)
 9090 format(1x,A,' file handle = ',i10)
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9480 format(1x,'Cpu & wall time / sec for ',A,2f15.1)
 9050 format(/,1x,A,' iterations',/,
     1  1x,'--------------------------------------------------------',/
     2  1x,'Iter          Residuum       Correlation     Cpu    Wall',/
     3  1x,'--------------------------------------------------------')
 9060 format(
     1  1x,'--------------------------------------------------------',/
     2  1x,'Iterations converged')
 9070 format(1x,A,' correlation energy / hartree = ',f25.15)
 9080 format(1x,A,' total energy / hartree       = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
 9120 format(1x,A)
 9250 format(1x,'Ground-state symmetry is ',A4)
 9210 format(/,1x,'Iteration ',i3,' using ',i4,' trial vectors')
 9230 format(1x,f17.13,f18.13,f11.5,2f8.1)
 9240 format(1x,
     1'--------------------------------------------------------------'
     2,/,1x,'Iterations converged')
 9310 format(1x,A,' ground state energy / hartree  =',f25.15)
 9400 format(/,1x,A,' iterations',/,
     1  1x,'--------------------------------------',/
     2  1x,'Iter          Residuum     Cpu    Wall',/
     3  1x,'--------------------------------------')
 9410 format(
     1  1x,'--------------------------------------',/
     2  1x,'Iterations converged')
 9420 format(1x,i4,f18.13,2f8.1)
 9440 format(1x,A3,' axis ( ',A4,'symmetry)')
      end

*
* $Id: fci_spnad.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_spin_adapt_nvec
     $     (ns, direction, det, ldd, csf, ldc, nvec)
      implicit none
#include "fciinfo.fh"
c     
c     Given NVEC sets of coefficients of either determinants or CSF
c     corresponding to a single orbital occupation with ns open shells,
c     then do the following
c     
c     if (direction == 1)
c     ... project from determinants to CSF with multiplicity multi (fci_init)
c     ... if there is spin contamination norm will not be conserved
c     else if (direction == 2)
c     ... project from CSF with multiplicity multi to determinants
c     ... norm should be conserved
c     else
c     ... invalid value for direction
c     endif
c     
      integer ns                ! [input] No. of open shells
      integer direction         ! [input] 1=det to csf, 2=csf to det
      integer ldd, ldc          ! [input] Leading dimensions
      integer nvec              ! [input] No. of sets of coefficients
      double precision det(ldd,nvec) ! [in/out] coefficients of determinants
      double precision csf(ldc,nvec) ! [in/out] coefficients of csf
c     
      integer iocc(nsmax)       ! CSF walk
      integer mocc(nsmax)       ! determinant walk
      double precision csum(nsmax) ! CSF intermediate spin values
      double precision dsum     ! determinant intermediate Sz values
c
      integer mdet, mcsf, iwalk, icsf, is, mwalk, ivec
      double precision sum, rnum, rden, rs, rm, coeff
c     
      mdet = mnsdet(ns)
      mcsf = mnscsf(ns)
c
      if (direction .eq. 1) then
         call dfill(0.0d0, csf, 1, mcsf)
      else
         call dfill(0.0d0, det, 1, mdet)
      endif
c     
c     Loop thru CSF by looping thru walks on the determinant graph.  
c     Any that only have positive intermediate spin values can be used 
c     as a CSF walk and they will occur in the correct lexical order. 
c     
      iwalk = 0
      do 30 icsf=1,mdet
         call fci_mfind_occ(icsf,iocc,ns)
         sum = 0.0d0
         do 20 is = 1,ns
            sum = sum + 1.5d0 - dfloat(iocc(is))
            if (sum .lt. -0.0001d0) goto 30 ! Not a valid CSF
            csum(is) = sum
 20      continue
         iwalk = iwalk + 1      ! Lexical index of this CSF
c     
         do 40 mwalk = 1,mdet
            call fci_mfind_occ(mwalk,mocc,ns)
            rnum = 1.0d0
            rden = 1.0d0
            dsum = 0.0d0
            do 50 is = 1,ns
               dsum = dsum + 1.5d0 - dfloat(mocc(is))
c
               rs = csum(is)
               rm = dsum
               if (iocc(is).eq.1) then
                  if (mocc(is).eq.1) then
                     rnum = rnum*(rs+rm) ! s=+ m=+
                     rden = rden*2.0d0*rs
                  else
                     rnum = rnum*(rs-rm) ! s=+ m=-
                     rden = rden*2.0d0*rs
                  endif
               else
                  if (mocc(is).eq.1) then
                     rnum = -rnum*(rs-rm+1) ! s=- m=+
                     rden = rden*(2.0d0*rs+2.0d0)
                  else
                     rnum = rnum*(rs+rm+1.0d0) ! s=- m=-
                     rden = rden*(2.0d0*rs+2.0d0)
                  endif
               endif
               if (rnum .eq. 0.0d0) goto 40
 50         continue
c     
c     Coefficient of determinant mwalk in CSF iwalk
c     
            coeff = sign(sqrt(abs(rnum/rden)),rnum)
c     
            if (direction .eq. 1) then
               do ivec = 1, nvec
                  csf(iwalk,ivec) = csf(iwalk,ivec) + 
     $                 coeff*det(mwalk,ivec)
               enddo
            else
               do ivec = 1, nvec
                  det(mwalk,ivec) = det(mwalk,ivec) + 
     $                 coeff*csf(iwalk,ivec)
               enddo
            endif
c
 40      continue
 30   continue
      if (iwalk .ne. mcsf) call fci_err('spnad: bad #csf ', iwalk)
c     
      end
      subroutine fci_spin_adapt(ns, direction, det, csf)
      implicit none
#include "fciinfo.fh"
c     
c     Given a set of coefficients of either determinants or CSF
c     corresponding to a single orbital occupation with ns open shells,
c     then do the following
c     
c     if (direction == 1)
c     ... project from determinants to CSF with multiplicity multi (fci_init)
c     ... if there is spin contamination norm will not be conserved
c     else if (direction == 2)
c     ... project from CSF with multiplicity multi to determinants
c     ... norm should be conserved
c     else
c     ... invalid value for direction
c     endif
c     
      integer ns                ! [input] No. of open shells
      integer direction         ! [input] 1=det to csf, 2=csf to det
      double precision det(*)   ! [in/out] coefficients of determinants
      double precision csf(*)   ! [in/out] coefficients of csf
c     
      integer iocc(nsmax)       ! CSF walk
      integer mocc(nsmax)       ! determinant walk
      double precision csum(nsmax) ! CSF intermediate spin values
      double precision dsum     ! determinant intermediate Sz values
c
      integer mdet, mcsf, iwalk, icsf, is, mwalk
      double precision sum, rnum, rden, rs, rm, coeff
c     
      mdet = mnsdet(ns)
      mcsf = mnscsf(ns)
c
      if (direction .eq. 1) then
         call dfill(0.0d0, csf, 1, mcsf)
      else
         call dfill(0.0d0, det, 1, mdet)
      endif
c     
c     Loop thru CSF by looping thru walks on the determinant graph.  
c     Any that only have positive intermediate spin values can be used 
c     as a CSF walk and they will occur in the correct lexical order. 
c     
      iwalk = 0
      do 30 icsf=1,mdet
         call fci_mfind_occ(icsf,iocc,ns)
         sum = 0.0d0
         do 20 is = 1,ns
            sum = sum + 1.5d0 - dfloat(iocc(is))
            if (sum .lt. -0.0001d0) goto 30 ! Not a valid CSF
            csum(is) = sum
 20      continue
         iwalk = iwalk + 1      ! Lexical index of this CSF
c     
         do 40 mwalk = 1,mdet
            call fci_mfind_occ(mwalk,mocc,ns)
            rnum = 1.0d0
            rden = 1.0d0
            dsum = 0.0d0
            do 50 is = 1,ns
               dsum = dsum + 1.5d0 - dfloat(mocc(is))
c
               rs = csum(is)
               rm = dsum
               if (iocc(is).eq.1) then
                  if (mocc(is).eq.1) then
                     rnum = rnum*(rs+rm) ! s=+ m=+
                     rden = rden*2.0d0*rs
                  else
                     rnum = rnum*(rs-rm) ! s=+ m=-
                     rden = rden*2.0d0*rs
                  endif
               else
                  if (mocc(is).eq.1) then
                     rnum = -rnum*(rs-rm+1) ! s=- m=+
                     rden = rden*(2.0d0*rs+2.0d0)
                  else
                     rnum = rnum*(rs+rm+1.0d0) ! s=- m=-
                     rden = rden*(2.0d0*rs+2.0d0)
                  endif
               endif
               if (rnum .eq. 0.0d0) goto 40
 50         continue
c     
c     Coefficient of determinant mwalk in CSF iwalk
c     
            coeff = sign(sqrt(abs(rnum/rden)),rnum)
c     
            if (direction .eq. 1) then
               csf(iwalk) = csf(iwalk) + coeff*det(mwalk)
            else
               det(mwalk) = det(mwalk) + coeff*csf(iwalk)
            endif
c
 40      continue
 30   continue
      if (iwalk .ne. mcsf) call fci_err('spnad: bad #csf ', iwalk)
c     
      end

      subroutine bsse_input(rtdb)
      implicit none
c
c     This subroutine read the input lines in bsse     
c     to get info about monomers that build the
c     super molecule.  nmon identify monomers, mon(nmon), 
c     each monomer have mon_atm(nmon). Name of monomers is
c     allocated in mon_name(nmon)
c
#include "stdio.fh"
#include "errquit.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
#include "geom.fh"
c here are defined common variables
#include "bsse_common.fh"      
c
      integer rtdb              ! [input]
c
      integer geom
      integer atm_tot           ! to check total atoms
      integer qtot              ! to print total charge
      integer nopen             ! to print spin multiplicity
      integer i, j,l,k
      integer nfield
      integer nopt
      parameter (nopt = 9)
      integer ind
c
      character*80 buf
      character*255 field
      character*18 opt (nopt)
c
      logical status
      logical do_bsse
c
c:
      logical bsse_rtdb_store
      external bsse_rtdb_store
      logical bsse_rtdb_load
      external bsse_rtdb_load
c
      data opt /'end', 'on', 'off','tidy','charge', 'input',
     &  'input_wghost', 'mon', 'mult'/

c
c     ------------------welcome------------------------
c
      buf = ' '
      write(buf,*) ' Input BSSE Module - Counter Poise Approach'
      write(LuOut,*)
      write(LuOut,*)
      call util_print_centered(LuOut,buf,40,.true.)
      write(LuOut,*)
c
c     -------------------------------------------------
c     -----   get info supermolecule geometry   -------
c     -------------------------------------------------
c
      if (.not. rtdb_cget(rtdb,'geometry', 1, spr_name))
     $     spr_name = 'geometry'
c

      if (.not. geom_create(geom, spr_name)) 
     $ call errquit('bsse_input: geom_create failed !', 0,GEOM_ERR)
c

      if (.not. geom_rtdb_load(rtdb, geom, spr_name))
     $ call errquit('bsse_input: no geometry load form rtdb', 0,
     $        GEOM_ERR)

      if (.not. geom_ncent(geom, natoms)) call errquit
     $     ('bsse_input: geom_ncent ?', 0, GEOM_ERR)
c     -------------------------------------------------
c     -----        reading  input  fields      --------
c     -------------------------------------------------
c

      call inp_set_field(0)     ! goto the begin of line

c
c:    preliminaries
c
      qtot    = 0
      atm_tot = 0
      nmon    = 0 
      do_bsse = .true.

c

      call ifill(mx_atm,1,mmon,1)     ! multiplicity default
      call dfill(mx_atm,0.0d0,qmon,1) ! charge default
      call cfill(mx_atm,' ',input,1) ! charge default
c
 100  if(.not.inp_read())
     $  call errquit('bsse_input: unexpected eof ',911,INPUT_ERR )
c
      nfield = inp_n_field()
c
 150  if (.not.inp_a(field))
     $  call errquit('bsse_input: failed to read field',911,INPUT_ERR )
c
      if (.not. inp_match(nopt, .false., field, opt, ind)) 
     $    goto 10 

      goto (900,  850, 800, 700, 600, 500, 400, 300, 200) ind

c
c:    none 
c

  10  write(LuOut,20)

  20  format

     $(/' valid bsse structure input : '/
     $  ' bsse                     '/
     $  '   mon <character name fragment> <integer list atoms>'/    
     $  '     input <input line>  '/
     $  '     input_wghost <input line>  '/
     $  '     charge <double charge> '/
     $  '     mult <integer multiplicity> '/
     $  '   off                    '/
     $  '   on                     '/
     $  ' end                      '/
     $/)
c
      call errquit('bsse_input: unknown directive', 911,INPUT_ERR)
c
c
c:    mon
c

 300  continue 
c
      nmon  = nmon + 1
c   
      mon_name(nmon) = field  ! took the first field however use to name
c
      if (.not.inp_a(mon_name(nmon)))
     $  call errquit
     $          ('bsse_input: failed to read name field',911,INPUT_ERR)
c
c     Read the atom numbers and count the number of atoms as we go along.
c     If we read something else than an integer it might be the next
c     keyword on the line. So, leave the loop, and check if we have reached
c     the end of the line. If we are not at the end of the line goto 150
c     to read the next keyword, otherwise goto 100 to read the next line.
c
      i = 0
      do while (inp_i(mon(nmon,i+1)))
        i = i + 1
        mon_atm(nmon) = i
        atm_tot = atm_tot + 1
      enddo
      if (inp_cur_field().lt.nfield) goto 150
c
      go to 100
c
c:    mult
c
 200  continue
        if(nmon.eq.0) goto 10
        if (.not. inp_i(mmon(nmon) )) call errquit
     $    ('bsse_input: failed reading monomer multiplicity',
     $     nmon,INPUT_ERR)
        if (mmon(nmon).eq.0) call errquit
     $    ('bsse_input: invalid multiplicity ',mmon(nmon),
     $     INPUT_ERR)
        if (inp_cur_field().lt.nfield) goto 150
      goto 100
c
c:    input_wghost
c
 400  continue
c
      if(nmon.eq.0) goto 10

      i=(nmon)*2

      if (.not. inp_a(input(i) )) call errquit
     $  ('bsse_input: failed reading input [input]',911,INPUT_ERR)
      if (inp_cur_field().lt.nfield) goto 150

      go to 100
c
c:    input
c
 500  continue
      if(nmon.eq.0) goto 10

      i=(nmon-1)*2+1

      if (.not. inp_a(input(i))) 
     $  call errquit
     $     ('bsse_input: failed reading input [input]',911,INPUT_ERR)
c
      if (inp_cur_field().lt.nfield) goto 150
c
      go to 100
c

 600  continue
c
c:    charge
c
      if(nmon.eq.0) goto 10
c
      if(.not. inp_f( qmon(nmon)))
     $  call errquit('bsse_input: reading monomer charge',911,INPUT_ERR)
c
      if (inp_cur_field().lt.nfield) goto 150

      go to 100
c
c:    tidy
c       clean database of any bsse info
  700 continue
c
c:    off
c
      if(.not. rtdb_delete(rtdb, 'bsse'))
     $  call errquit('bsse_input: cannot clean database',911,RTDB_ERR)
      goto 100
c 
  800 continue

      do_bsse=.false.
      buf = ' '
      write(buf,*) ' Any BSSE operations are off'
      write(LuOut,*)
      write(LuOut,*)
      call util_print_centered(LuOut,buf,40,.true.)
      write(LuOut,*)

      goto 100
c     
c
  850 continue
  
      do_bsse=.true.  
      if(.not.bsse_rtdb_load(rtdb))
     $  call errquit('bsse_input: load data input in db',911,RTDB_ERR)
c 
      atm_tot= natoms
c
      goto 100
c
c:    end
c
  900 continue

      if(do_bsse) then

        goto 1000

      else

        goto 1100

      endif
c
c:    done
c
 1000 continue

c     ------------------------------------------------------
c     check : total atoms
c     ------------------------------------------------------

      if (atm_tot.ne.natoms) 
c     $ goto 10
     $ call errquit
     $ ('bsse_input: number of atoms is wrong',911,INPUT_ERR) 

c     ------------------------------------------------------
c     check : dont repeat atoms
c     ------------------------------------------------------

      do j = 1, nmon

        do i = 1, mon_atm(j)

          do l = j, nmon

            do k = 1, mon_atm(l)

              if((i.eq.k).and.(j.eq.l)) then

                status=.true.

              elseif (mon(j,i).eq.mon(l,k)) then
  
              call errquit
     $       ('bsse_input: there are some atoms repeated',911,INPUT_ERR)
              endif
            enddo
          enddo
        enddo
      enddo

c----------------------------------------------------
c        check the atoms are correct
c----------------------------------------------------
      do j = 1, nmon
        do i = 1, mon_atm(j)

              if( mon(j,i).gt.natoms) then
              call errquit
     $       ('bsse_input: incorrect atom number',mon(j,i),INPUT_ERR)
              endif
        enddo
      enddo

c     ------------------------------------------------------
c     check : total charge
c     ------------------------------------------------------

      do j = 1, nmon

        qtot = qtot + qmon(j)

      enddo
c
c     ------------------------------------------------------
c     check : unpaired electrons
c     ------------------------------------------------------
c
      nopen = 0
      do j = 1, nmon
        nopen = nopen + abs(mmon(j)) - 1
      enddo
c
      write(LuOut, 60)  spr_name, nmon,
     $                  mod(nopen,2)+1, nopen+1, qtot
 60   format(/
     $  '    supermolecule geometry name = ', a50/
     $  '             number of monomers = ', i4/
     $  '             total multiplicity = ', i4,' to ',i4/
     $  '                   total charge = ', i4/)
c

      write(LuOut, *) 
     $  '       atoms for each monomer  ' 

      do j=1, nmon

        write(LuOut, 70) mon_name(j)
 70     format(/ 
     $      '              monomer     ',  a10,' : ',$)
c

        do i=1, mon_atm(j) 

          write(LuOut, 90)  mon(j,i)

 90       format (i3,$) 

        enddo
      enddo

      write(LuOut,*)
      call util_flush(luout)

c
      go to 1100
c
c: db is done and geometry is destroyed
c
c 1100 continue
c

 1100 continue
c
      if (do_bsse) then
c
        if (.not. rtdb_put(rtdb,'bsse',mt_log,1,.true.))
     $    call errquit('bsse_input: rtdb_put failed',911,RTDB_ERR)
c
      else
c
         if (.not. rtdb_put(rtdb,'bsse',mt_log,1,.false.))
     $     call errquit('bsse_input: rtdb_put failed',911,RTDB_ERR)
c
      endif
c
      if(.not. geom_destroy(geom))
     $  call errquit('bsse_input: geom_destroy failed', 911,RTDB_ERR)
c
      if(.not.bsse_rtdb_store(rtdb))
     $  call errquit('bsse_input: store data input in db',911,RTDB_ERR)
c
      return
c
      end
C>
C> \brief Initialize monomer calculation 
C>
C> Initialize the monomer calculation by modifying the contents of
C> the RunTime Data Base for the current calculation.
C>
      subroutine bsse_param(rtdb, mult, charge, j_mon_name, 
     &                      i_input,theory)
      implicit none
      integer rtdb !< [Input] The RTDB handle
      character*(*) j_mon_name !< [Input] Monomer name
      character*(*) i_input !< [Input] Line of input for monomer calculation
      character*(*) theory !< [Input] The theory to apply
      integer mult !< [Input] Monomer spin multiplicity
      double precision charge !< [Input] Monomer charge
      logical first_j
      character*255 vec_dbi, vec_dbo,tmp
      integer lentheo, lenname
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "inp.fh"
#include "stdio.fh"
c
      logical nw_inp_from_character
      external nw_inp_from_character
c
      if (.not. rtdb_get(rtdb,'bsse:first_j',mt_log,1,first_j))
     $  first_j=.true.
c
c     if (.not. rtdb_cget(rtdb,'theory', 1, theory))
c    &  call errquit('bsse_param: get theory',0)
c      
      lenname = inp_strlen(j_mon_name)
c
      lentheo = inp_strlen(theory)
c
c:    multiplicity
c:      density methods
      if ( theory(1:lentheo).eq.'dft' .or.
     $     theory(1:lentheo).eq.'tddft') then
        if (.not. rtdb_put(rtdb, 'dft:mult', mt_int, 1, mult))
     $    call errquit('bsse_param: rtdb_put of mult failed',
     $                 0,RTDB_ERR )
c:      wavefuntion methods

      elseif( theory(1:lentheo).ne.'dft' .and.
     $        theory(1:lentheo).ne.'tddft') then
        if (.not. rtdb_put(rtdb,'scf:nopen', MT_INT, 1, mult-1))
     $    call errquit('bsse_param: rtdb_put of nopen failed',
     $                 0,RTDB_ERR)
      endif
c
      if (charge .ne. -999.0d0) then
c
         if (.not. rtdb_put(rtdb,'charge',mt_dbl,1,charge))
     $        call errquit('bsse_param:setting charge?',911, RTDB_ERR)
c
      end if
c
      if (j_mon_name .ne. ' ') then
c
         if (.not. rtdb_cput(rtdb,'geometry',1,j_mon_name))
     $        call errquit('bsse_param: setting geometry?',911,RTDB_ERR)
c
      end if
c
        if (first_j) then
c
          tmp = 'atomic'
c
        else
c
          tmp = ' '
          tmp = j_mon_name(1:lenname)//'.bsse.movecs'
c
        endif
c MP2 SCF DFT vectors
c
        vec_dbi = ' '
        vec_dbo = ' '
c
c       if(theory(1:lentheo).ne.'scf' .or. theory(1:lentheo).ne.'dft'
c    &    .or. theory(1:lentheo).ne.'mcscf') then
        if(theory(1:lentheo).eq.'dft') then
          vec_dbi= theory(1:lentheo)//':input vectors'
          vec_dbo= theory(1:lentheo)//':output vectors'
c
       elseif (theory(1:lentheo).eq.'mcscf') then
          vec_dbi= theory(1:lentheo)//':input vectors'
          vec_dbo= theory(1:lentheo)//':output vectors'
c
        else
          vec_dbi = 'scf:input vectors'
          vec_dbo = 'scf:output vectors'

        endif
c
c       
        if (.not. rtdb_cput(rtdb, vec_dbi, 1, tmp))
     &    call errquit('bsse_param: input_vectors',0,RTDB_ERR)
c
        tmp = ' '
        tmp = j_mon_name(1:lenname)//'.bsse.movecs'
c
        if (.not. rtdb_cput(rtdb, vec_dbo, 1,tmp))
     &   call errquit('bsse_param: output_vectors',0,RTDB_ERR)
c
c
      if (i_input .ne. ' ') then

         if (.not. nw_inp_from_character(rtdb,i_input))
     $     call errquit('bsse_param: error processing input string',
     &     060,INPUT_ERR)

      endif
c
      end
c
c
      logical function bsse_rtdb_store(rtdb)
      implicit none
#include "rtdb.fh"
#include "errquit.fh"
c#include "tcgmsg.fh"
#include "bsse_common.fh"
#include "mafdecls.fh"
#include "stdio.fh"
      
c      the propose is store bsse's sets into db 

      integer rtdb              ![input]
c     integer itmp ,k
      character*255 ctmp
c
      ctmp = 'bsse:natoms'
       if (.not. rtdb_put( rtdb, ctmp, mt_int, 1,natoms ))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
c
      ctmp = 'bsse:nmon'
       if (.not. rtdb_put( rtdb, ctmp, mt_int, 1,nmon ))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
       ctmp = 'bsse:mon_name'
       if(.not.rtdb_cput(rtdb, ctmp, nmon,  mon_name ))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c     
       ctmp = 'bsse:spr_name'
       if(.not.rtdb_cput(rtdb, ctmp, 1,  spr_name ))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
      ctmp = 'bsse:mon_atm'
       if (.not. rtdb_put( rtdb, ctmp, mt_int, nmon, mon_atm ))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
      ctmp = 'bsse:mon'
       if (.not. rtdb_put( rtdb, ctmp, mt_int,mx_atm*mx_atm,  mon))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
      ctmp = 'bsse:qmon'
       if (.not. rtdb_put( rtdb, ctmp, mt_dbl ,nmon, qmon))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
      ctmp = 'bsse:mmon'
       if (.not. rtdb_put( rtdb, ctmp, mt_int ,nmon, mmon))
     $   call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
      ctmp= 'bsse:input'
       if(.not.rtdb_cput(rtdb, ctmp, nmon*2, input))
     $    call errquit('bsse_rtdb_store: rtdb_put failed',0,RTDB_ERR)
c
      bsse_rtdb_store = .true.
      return
      end
c
      logical function bsse_rtdb_load(rtdb)
      implicit none
#include "rtdb.fh"
#include "errquit.fh"
#include "stdio.fh"
c#include "tcgmsg.fh"
#include "bsse_common.fh"
#include "mafdecls.fh"
      integer rtdb              ![input]
      character*255 ctmp
c
c      the propose is load bsse's sets from db 
c
      ctmp = 'bsse:natoms'
       if (.not.rtdb_get( rtdb, ctmp, mt_int, 1, natoms))
     $   call errquit('bsse_rtdb_load: rtdb_put failed',0,RTDB_ERR)
c
      ctmp = 'bsse:nmon'
       if(.not.rtdb_get( rtdb, ctmp, mt_int,   1 , nmon))
     $   call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
        ctmp = 'bsse:mon_name'
        if(.not.rtdb_cget( rtdb, ctmp, nmon,   mon_name))
     $    call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
        ctmp = 'bsse:spr_name'
        if(.not.rtdb_cget( rtdb, ctmp, 1,   spr_name))
     $    call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
      ctmp = 'bsse:mon_atm'
       if(.not.rtdb_get( rtdb, ctmp, mt_int, nmon,mon_atm))
     $   call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
      ctmp = 'bsse:mon'
       if (.not.rtdb_get( rtdb, ctmp, mt_int, mx_atm*mx_atm,mon))
     $   call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
      ctmp = 'bsse:qmon'
       if (.not.rtdb_get( rtdb, ctmp, mt_dbl, nmon,    qmon ))
     $   call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
      ctmp = 'bsse:mmon'
       if (.not. rtdb_get( rtdb, ctmp, mt_int ,nmon, mmon))
     $   call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
      ctmp = 'bsse:input'
        if(.not.rtdb_cget( rtdb, ctmp, nmon*2,  input))
     $    call errquit('bsse_rtdb_load: rtdb_get failed',0,RTDB_ERR)
c
      bsse_rtdb_load = .true.
      return
      end
      logical function bsse_create_geom(rtdb)
      implicit none
#include "nwc_const.fh"
#include "errquit.fh"
#include "inp.fh"
#include "stdio.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "geomP.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "bsse_common.fh"       
c     
c     This logical function generate the geometries of monomers
c     with ghost atoms and store them into DB.
c
      integer rtdb              ![input]
      integer geom              ![input]
c
      character*255 name           
      character*16 tag_old  (mx_atm)
      character*16 tag_new  (mx_atm)
c
      integer mon_hnd
      integer k,j,l,m
c
      logical is_atm
      integer atn ![output]
      double precision mass(mx_atm)
      character*2 symbol
      character*16 element

c
      double precision q_old (mx_atm), q_new (mx_atm)
      double precision c(3,mx_atm)
      double precision ctmp(3,mx_atm)
c
      logical bsse_rtdb_store
      external bsse_rtdb_store
c
      lenname= inp_strlen(spr_name) 
c
      if (.not. geom_create(geom,spr_name(1:lenname))) 
     $   call errquit('bsse_create_geom: geom_create failed !',
     $                0,GEOM_ERR)
c
      if (.not. geom_rtdb_load(rtdb, geom, spr_name))
     $   call errquit('bsse_create_geom: no geometry load form rtdb',
     $                0,GEOM_ERR)
c      
      if (.not. geom_cart_get(geom, natoms, tag_old, c, q_old))
     $   call errquit('bsse_create_geom: get geom info fail !',
     $                0,GEOM_ERR)
c
c     -------------------------------------------
c     rename atoms tag to ghost and create geoms
c     -------------------------------------------
c
      do j = 1, nmon
        do l = 1, natoms
c
c         initialize all centers as bqX
c
          tag_new(l) = 'bq' // tag_old(l)
          q_new(l) = 0.0d0
c
          do k = 1, mon_atm(j)
c
c           only do bsse with atoms
c
            is_atm = geom_tag_to_element(tag_old(l),symbol,element,atn)
            if ((.not. is_atm) .and. symbol.ne.'bq')
     $        call errquit('bsse_create_geom: not atom or bq',
     $                     0,GEOM_ERR)
c
c           compare and if this is center is an atom then
c           set its tag and charge to the proper values
c
            if (l.eq.(mon(j,k))) then
              tag_new(l) = tag_old(l)
              q_new(l)   = q_old(l)
              go to 100
            endif
          enddo
 100      continue 
        enddo
c
c       Sort out the masses of the various centers
c
        do l = 1, natoms
          is_atm = geom_tag_to_element(tag_new(l),symbol,element,atn)
          if ((.not. is_atm) .and. symbol.ne.'bq')
     $       call errquit('bsse_create_geom: not atom or bq',
     $                    0,GEOM_ERR)
          if (.not.geom_atn_to_default_mass(atn,mass(l)))
     $       call errquit('bsse_create_geom: default mass failed',
     $                    911,GEOM_ERR)
        enddo
c
        lenname= inp_strlen(mon_name(j)) 
c
        if (.not. geom_create(mon_hnd, mon_name(j)(1:lenname)//'g')) 
     $    call errquit('bsse_create_geom: geom_create failed !',
     $                 0,GEOM_ERR)
c
        if (.not. geom_cart_set(mon_hnd, natoms, tag_new, c, q_new))
     $    call errquit('bsse_create_geom: geom_cart_set failed',
     $                 0,GEOM_ERR)
c
        if (.not. geom_masses_set(mon_hnd, natoms, mass))
     $    call errquit('bsse_create_geom: geom_masses_set failed',
     $                 0,GEOM_ERR)
c:debug proposes
c     if (nodeid().eq. 0) then
c       if (.not. geom_print(mon_hnd))
c    $        call errquit('geom_input: print failed ', 0)
c     endif
c 
        if (.not.geom_rtdb_store(rtdb, mon_hnd,
     $                           mon_name(j)(1:lenname)//'g'))
     $    call errquit('bsse_create_geom: geom_rtdb_store failed',
     $                 60,GEOM_ERR)
c
        if (.not. geom_destroy(mon_hnd))
     $    call errquit('bsse_create_geom: geom_destroy failed',
     $                 60,GEOM_ERR)
c
c       creating and storing monomers without  ghost  
c
        if (.not. geom_create(mon_hnd, mon_name(j)(1:lenname)))
     $    call errquit('bsse_create_geom: geom_create failed!',0,
     $                 GEOM_ERR)
c
        m = 0
        do l = 1, natoms
          do k = 1, mon_atm(j)
            if (l.eq.(mon(j,k))) then
              m = m + 1
              tag_new(m) = tag_old(l)
              q_new  (m) = q_old  (l)
              ctmp(1,m) = c(1,l)
              ctmp(2,m) = c(2,l)
              ctmp(3,m) = c(3,l)
            endif
          enddo
        enddo
c      
        if (.not. geom_cart_set(mon_hnd,mon_atm(j),tag_new,ctmp,q_new))
     $    call errquit('bsse_create_geom: geom_cart_set failed',
     $                 0,GEOM_ERR)
c
c       Work out the masses of the atoms
c
        do l=1, mon_atm(j) 
          is_atm = geom_tag_to_element(tag_new(l),symbol,element,atn)
          if ((.not. is_atm) .and. symbol.ne.'bq')
     $      call errquit('bsse_create_geom: center is neither atom '//
     $                   'nor bq',0,GEOM_ERR)
c..       set default mass
          if(.not.geom_atn_to_default_mass(atn,mass(l)))
     &      call errquit('bsse_create_geom: default mass failed',
     &                   911,GEOM_ERR)
        enddo
c
        if (.not. geom_masses_set(mon_hnd, mon_atm(j), mass))
     $    call errquit('bsse_create_geom: geom_masses_set failed',
     $                 0,GEOM_ERR)
c
        if (nodeid() .eq. 0) then
          if(.not. geom_print(mon_hnd))
     $      call errquit('bsse_create_geom: print failed ', 0, GEOM_ERR)
        endif
c
        if (.not.geom_rtdb_store(rtdb, mon_hnd, mon_name(j)(1:lenname)))
     $    call errquit('bsse_create_geom: geom_rtdb_store failed',
     $                 0,GEOM_ERR)
c
        if (.not. geom_destroy(mon_hnd))
     $    call errquit('bsse_create_geom: geom_destroy failed',
     $                 0,GEOM_ERR)
c
c:debug proposes
c     if (.not. rtdb_print(rtdb, .true.)) call errquit('print failed',0)
c
c ======================================================
c  create basis
c     
c     status=bsse_create_basis(rtdb,geom, tag_new,natoms)
c========================================================
      enddo
c
      if(.not. geom_destroy(geom))
     $  call errquit('geom_input: geom_destroy failed', 0, GEOM_ERR)
c 
      bsse_create_geom = .true.
c
      return
      end
      logical function bsse_energy(rtdb,theory,final_spr_energy)
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "bsse_common.fh"
c
      integer rtdb              ![input]
c
      integer j ! run over monomers
      integer i 
      integer m_spr
c tmp
      character*(*) theory
      character*255 vec_spr
      character*255 vec_dbi, vec_dbo
c
      character*255 tmp
c
      double precision q_spr
c
      logical task_energy_doit
      external task_energy_doit
c
      logical bsse_rtdb_load
      external bsse_rtdb_load
c
      logical bsse_create_geom
      external bsse_create_geom
c
c
      bsse_energy=.false.
c
      if(ga_nodeid().eq.0) then
        write(LuOut,*)
        write(LuOut,*)
        call util_print_centered(LuOut,
     $      'BSSE Energy Correction',
     $      40,.true.)
        write(LuOut,*)
        write(LuOut,*)
      endif
c
        if (.not. rtdb_get(rtdb,'bsse:first_j',mt_log,1,first_j))
     $  first_j=.true.
c
c
      if(.not.bsse_rtdb_load(rtdb))
     $  call errquit('bsse_energy: load data input in db', 911,RTDB_ERR)
c
c
      lentheo = inp_strlen(theory)
      lenname = inp_strlen(spr_name)
c
      if (.not. task_energy_doit(rtdb,theory,spr_energy))
     $  call errquit('bsse_energy: no geometry ',0,UNKNOWN_ERR)
c
c: take supermolecule total charge
      if(.not. rtdb_get(rtdb, 'charge', MT_DBL, 1, q_spr))
     $  q_spr = 0.0d0


c: multiplicity
c:    density methods
        if ( theory(1:lentheo).eq.'dft' .or.
     $       theory(1:lentheo).eq.'tddft') then
          if (.not. rtdb_get(rtdb, 'dft:mult', mt_int, 1, m_spr))
     $      call errquit('bsse_energy: rtdb_get of mult failed',
     $                   0,RTDB_ERR )
c:   wavefuntion methods

        elseif( theory(1:lentheo).ne.'dft' .and.
     $          theory(1:lentheo).ne.'tddft') then
          if (.not. rtdb_get(rtdb,'scf:nopen', MT_INT, 1, m_spr))
     $      call errquit('bsse_energy: rtdb_get of nopen failed',
     $                   0,RTDB_ERR)

        endif

c
c: name of the original movecs
        if(theory(1:lentheo).eq.'dft' .or.
     $     theory(1:lentheo).eq.'tddft') then
          vec_dbo= 'dft:output vectors'
          vec_dbi= 'dft:input vectors'
        elseif (theory(1:lentheo).eq.'mcscf') then
          vec_dbo= 'mcscf:output vectors'
          vec_dbi= 'mcscf:input vectors'
        else
          vec_dbo = 'scf:output vectors'
          vec_dbi = 'scf:input vectors'
        endif
c
      if (.not. rtdb_cget(rtdb, vec_dbo, 1, vec_spr))
     $ call errquit('bsse_energy: get vectors file failed', 0,RTDB_ERR)
c
c: create geom for monomers within supermolecular geom


      if(.not.bsse_create_geom(rtdb))
     $  call errquit('bsse_energy: bsse_create_geom',911,UNKNOWN_ERR)


c
c:Obtain monomers energies from frozen geometries;
c:it makes a couple jobs for each monomer (no ghost, ghost)
c

      j = 1

      do i = 1, nmon*2 

        j_mon_name =  mon_name(j)
        lenname = inp_strlen(mon_name(j))
c

        if (mod(i,2).eq.0) then

          j_mon_name = j_mon_name(1:lenname)//'g'
          lenname = lenname + 1

        endif
c      
        call bsse_param(rtdb, mmon(j), qmon(j), j_mon_name, input(i),
     $                  theory)
c
c:evaluate energy
        if (.not. task_energy_doit(rtdb,theory, mon_energy(i)))
     $    call 
     $ errquit('bsse_energy: failed calling task_energy',0,UNKNOWN_ERR)

c
        if (mod(i,2).eq.0) then
          j = j +1
        endif

      enddo


c-----------------------------------------------------------------------
c      Evaluate BSSE error for supermolecular geometry
c-----------------------------------------------------------------------


        bsse_error = 0.0d0

        i = 1

        do j = 1, nmon

          m_error(j) = mon_energy(i) - mon_energy(i+1)
          bsse_error = bsse_error + m_error(j)
          i= i + 2

        enddo

      final_spr_energy = spr_energy + bsse_error    
c
c:return to original active geom


      lenname = inp_strlen(spr_name)


      if (.not. rtdb_cput(rtdb,'geometry',1,spr_name(1:lenname)))
     $  call errquit('bsse_energy: no geometry ',0, RTDB_ERR)

c:return to original output vectors
c
      if (.not. rtdb_cput(rtdb, vec_dbi, 1, vec_spr))
     &  call errquit('bsse_energy: input_vectors',0, RTDB_ERR)
c

      if (.not. rtdb_cput(rtdb, vec_dbo, 1,vec_spr))
     &  call errquit('bsse_energy: output_vectors',0, RTDB_ERR)


c
c:return to original  charge


      if (.not. rtdb_put(rtdb, 'charge', MT_DBL, 1, q_spr))
     $  call errquit
     $  ('bsse_energy: failed to write charge to rtdb', 0, RTDB_ERR)


c: multiplicity

c:    density methods

        if ( theory(1:lentheo).eq.'dft' .or.
     $       theory(1:lentheo).eq.'tddft') then

          if (.not. rtdb_put(rtdb, 'dft:mult', mt_int, 1, m_spr))
     $      call errquit('bsse_energy: rtdb_put of mult failed',
     $                   0, RTDB_ERR)

c:   wavefuntion methods

        elseif( theory(1:lentheo).ne.'dft' .and.
     $          theory(1:lentheo).ne.'tddft') then

          if (.not. rtdb_put(rtdb,'scf:nopen', MT_INT, 1, m_spr))
     $      call errquit('bsse_energy: rtdb_put of nopen failed',
     $                   0, RTDB_ERR)


        endif
c
c:put into db final energy associated with theory


      tmp = theory(1:lentheo)//':energy'
c
      if (.not. rtdb_put(rtdb,tmp,
     $                                      MT_DBL,1,final_spr_energy))
     $  call 
     $ errquit('bsse_energy: failed to write charge to rtdb',0,RTDB_ERR)


c:debug proposes vama
c     if (.not. rtdb_print(rtdb, .true.)) call errquit('print failed',0)
c
c     if (nodeid().eq.0) then
c       do j = 1, nmon
c         write(LuOut,10) j, m_error(j)
c 10      format
c    $      (/' error  for monomer ', i4, ' =', f20.12/)
c       enddo
c

      if(ga_nodeid().eq.0) then

        write(LuOut,20) bsse_error, spr_energy, final_spr_energy
  20  format (/'             BSSE error = ', f20.12/
     $         '  Supermolecular energy = ', f20.12/
     $         '       Corrected energy = ', f20.12/)

        call util_flush(luout)

      endif
c

        if (.not. rtdb_put(rtdb,'bsse:first_j',mt_log,1,.false.))
     $    call errquit('bsse_energy: rtdb_put failed',0,RTDB_ERR)

c
      call ga_sync
c
      bsse_energy = .true.
      end
      logical function bsse_gradient(rtdb,theory,final_spr_energy, 
     $                                gx_spr)
c:debug
#include "global.fh"
#include "errquit.fh"
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "inp.fh"
#include "stdio.fh"
#include "bsse_common.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "tcgmsg.fh"
c
c
      integer rtdb              ![input]
c
      integer j,i,l,k,n
      integer n_cart
      integer n_cartmon
      integer geom
c
      character*255 vec_dbi, vec_dbo
      character*255 vec_spr
      character*(*) theory
      character*16 tag
      character*255 tmp
c
      double precision q_spr
      double precision gx_spr(3,*)
      double precision gx_mon(3,mx_atm)
      double precision crd(3), q
c
      logical task_gradient_doit
      external task_gradient_doit
      logical bsse_rtdb_load
      external bsse_rtdb_load
      logical bsse_create_geom
      external bsse_create_geom
c
c
      bsse_gradient=.false.
c
      if (nodeid().eq.0) then
        write(LuOut,*)
        write(LuOut,*)
        call util_print_centered(LuOut,
     $      'BSSE Correction to Energy Gradient',
     $      40,.true.)
        write(LuOut,*)
        write(LuOut,*)
      endif
c
        if (.not. rtdb_get(rtdb,'bsse:firt_j',MT_LOG,1,first_j))
     $  first_j=.true.
c
      if(.not.bsse_rtdb_load(rtdb))
     $  call 
     $ errquit('bsse_gradient: load data input in db',911,UNKNOWN_ERR)
c

      lentheo = inp_strlen(theory)
      lenname = inp_strlen(spr_name)
c

      n_cart= 3*natoms
c
c: get supermolecular gradient and energy


      if (.not.task_gradient_doit(rtdb,theory,spr_energy, gx_spr))
     $   call 
     $ errquit('bsse_gradient: no task gradient do it ',0,UNKNOWN_ERR)


c: get supermolecule charge

      if (.not. rtdb_get(rtdb, 'charge', MT_DBL, 1, q_spr))
     $   q_spr = 0.0d0

      
c
c: multiplicity
c
c:    wavefuntion methods
        if( theory(1:lentheo).ne.'dft') then
          if (.not. rtdb_get(rtdb,'scf:nopen', MT_INT, 1, m_spr))
     $      call 
     $  errquit('bsse_gradient: rtdb_get of nopen failed',0,RTDB_ERR)
c
c:    density methods
        elseif ( theory(1:lentheo).eq.'dft') then
          if (.not. rtdb_get(rtdb, 'dft:mult', mt_int, 1, m_spr))
     $      call 
     $  errquit('bsse_gradient: rtdb_get failed', 0,RTDB_ERR)
        endif
c
c: name of the original movecs

        if(theory(1:lentheo).eq.'dft') then
          vec_dbo= 'dft:output vectors'
          vec_dbi= 'dft:input vectors'
        elseif (theory(1:lentheo).eq.'mcscf') then
          vec_dbo= 'mcscf:output vectors'
          vec_dbi= 'mcscf:input vectors'
        else
          vec_dbo = 'scf:output vectors'
          vec_dbi = 'scf:input vectors'
        endif
c
      if (.not. rtdb_cget(rtdb, vec_dbo, 1, vec_spr))
     $ call 
     $ errquit('bsse_gradient: get vectors file failed', 0,RTDB_ERR)
c
c
c: create geom for monomers within supermolecular geom


      if(.not.bsse_create_geom(rtdb))
     $  call errquit('bsse_gradient: bsse_create_geom',60,UNKNOWN_ERR)

c
c: Obtain monomers energies from forzen geometries
c: it makes a couple job for each monomer (no ghost, ghost)
      j = 1
      do i = 1, nmon*2 
        j_mon_name =  mon_name(j)
        lenname = inp_strlen(mon_name(j))

c
        if (mod(i,2).eq.0) then
          j_mon_name = j_mon_name(1:lenname)//'g'
          lenname = lenname + 1 
        endif
c      
        call bsse_param(rtdb, mmon(j), qmon(j), j_mon_name, input(i),
     $                  theory)
c
c: evaluate gradient

      if (.not.task_gradient_doit(rtdb,theory,mon_energy(i),gx_mon))
     $  call 
     $  errquit('bsse_gradient: error calling task gradient spr',
     $   0,UNKNOWN_ERR)

        if (mod(i,2).eq.0) then
          n_cartmon=n_cart
        else
          n_cartmon=3*mon_atm(j)
        endif
c
c: mix monomers grads with supermolecule grad
        if (mod(i,2).eq.0) then

          do k = 1, natoms

            do n=1 ,3
              gx_spr(n,k) = gx_spr(n,k) - gx_mon(n,k)
            enddo

          enddo
c: go for next monomer
          j = j +1
c
        else
c
          do k = 1 , natoms
            do l = 1, mon_atm(j)
              if (k.eq.mon(j,l)) then
                do n = 1,  3
                 gx_spr(n,k)=gx_spr(n,k) + gx_mon(n,l)
                enddo
              endif
            enddo
          enddo
        endif
c
      enddo


c-----------------------------------------------------------------------      
c      Evaluate supermolecular energy free of BSSE
c-----------------------------------------------------------------------      

      bsse_error = 0.0d0

      i = 1

      do j = 1, nmon
        bsse_error = bsse_error +  mon_energy(i) - mon_energy(i+1)
        i= i + 2     
      enddo
c

      final_spr_energy = spr_energy + bsse_error
c

      lenname = inp_strlen(spr_name)
c
c
      if (.not. rtdb_cput(rtdb,'geometry', 1, spr_name(1:lenname)))
     $  call errquit('bsse_gradient: no geometry ',0,RTDB_ERR)


c:return to original  charge 

      if (.not. rtdb_put(rtdb, 'charge', MT_DBL, 1, q_spr))
     $  call errquit
     $  ('bsse_gradientt: failed to write charge to rtdb', 0,RTDB_ERR)


c:return to original output vectors
c
      if (.not. rtdb_cput(rtdb, vec_dbi, 1, vec_spr))
     &  call errquit('bsse_gradient: store input_vectors',60,RTDB_ERR)
c

      if (.not. rtdb_cput(rtdb, vec_dbo, 1,vec_spr))
     &  call errquit('bsse_gradient: store output_vectors',60,RTDB_ERR)



c:   wavefuntion methods

        if( theory(1:lentheo).ne.'dft') then
          if (.not. rtdb_put(rtdb,'scf:nopen', MT_INT, 1, m_spr))
     $      call 
     $  errquit('bsse_gradient: rtdb_put of nopen failed',0,RTDB_ERR)

c:    density methods

        elseif ( theory(1:lentheo).eq.'dft') then
          if (.not. rtdb_put(rtdb, 'dft:mult', mt_int, 1, m_spr))
     $      call errquit('bsse_gradient: rtdb_put failed', 0,RTDB_ERR)
        endif
c
c:put into db final gradien associated with theory


      tmp=theory(1:lentheo)//':gradient'     
      if (.not. rtdb_put(rtdb,tmp  ,mt_dbl,
     $    3*natoms, gx_spr)) call errquit
     $     ('bsse_gradient: could not store gradients',1, RTDB_ERR)
c
c:put into db final energy associated with theory
c
      tmp=theory(1:lentheo)//':energy'     
c
      if (.not. rtdb_put(rtdb,tmp,
     $                             MT_DBL,1,final_spr_energy))
     $  call 
     $  errquit('bsse_gradient: failed to write charge to rtdb'
     $   ,0,RTDB_ERR)

c
        if (.not. geom_create(geom, spr_name(1:lenname))) call errquit
     $   ('bsse_gradient: geom_create final failed !', 0,GEOM_ERR)
c
c
        if (.not.geom_rtdb_load(rtdb, geom, spr_name(1:lenname)))
     $   call errquit('bsse_gradient: load geom failed !',0, GEOM_ERR)

c:print final energy gradient

      if(nodeid().eq.0) then
c 
        write(luout,1000) theory(1:inp_strlen(theory)),
     $        'x','y','z','x','y','z'

        do  i=1, natoms
          if (.not. geom_cent_get(geom, i, tag, crd, q)) call errquit
     $           ('bsse_gradient: geometry corrupt?',0, GEOM_ERR)
          write(luout,2000) i, tag,(crd(j),j=1,3),
     $           (gx_spr(j,i),j=1,3)
        enddo

        write(luout,*)
        write(luout,*)

 1000   format(/,/,25X,A,' BSSE ENERGY GRADIENTS',/,/,4X,'atom',15X,
     $        'coordinates',
     $        24X,'gradient',/,6X,2(1X,(3(10X,A1))))

 2000   format(1X,I3,1X,A4,2(1X,3(1X,F10.6)))
c
c
        write(LuOut,20) bsse_error, spr_energy, final_spr_energy

  20    format (/'             BSSE error = ', f20.12/
     $           '  Supermolecular energy = ', f20.12/
     $           '       Corrected energy = ', f20.12/)
        call util_flush(luout)

      endif


        if(.not. geom_destroy(geom))
     $   call errquit('bsse_gradient: geom_destroy failed', 0,GEOM_ERR)
c
c      

        if (.not. rtdb_put(rtdb,'bsse:first_j',mt_log,1,.false.))
     $    call errquit('bsse_gradient: rtdb_put failed',0,RTDB_ERR)
c
      call ga_sync
c

      bsse_gradient = .true.
      end
      logical function bsse_hessian(rtdb)
      implicit none
#include "util.fh"
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "bsse_common.fh"
#include "stdio.fh"
#include "tcgmsg.fh"
#include "errquit.fh"
c
      integer rtdb              ![input]
c
c     Call task_hessian_doit for each monomer
c     and supermolecule and store each one hessian matrix
c     in different files. As out put write .hess file with
c     hessian taking account the BSSE
c
      logical status
      integer j, i
c
      character*255 vec_dbi, vec_dbo
      character*255 vec_spr
      character*32  theory
c
      character*16 mult(8)
      character*(nw_max_path_len) filehess
      character*(nw_max_path_len) filehesstmp
      integer m_spr
      double precision q_spr
      integer lenhess
      integer nopen
c
      logical  task_hessian_doit
      external task_hessian_doit
c
      logical bsse_rtdb_load
      external bsse_rtdb_load
c
      logical bsse_create_geom
      external bsse_create_geom
c
c     double precision final_spr_energy
c
      data mult/'singlet','doublet','triplet','quartet',
     $ 'quintet','sextet','septet','octet'/
c
c     call ecce_print_module_entry('task hessian')
c
      bsse_hessian= .false.
c
      if (nodeid().eq.0) then
        write(LuOut,*)
        write(LuOut,*)
        call util_print_centered(LuOut,
     $        'BSSE Hessian Correction',
     $         40,.true.)
        write(LuOut,*)
        write(LuOut,*)
      endif
c

        if (.not. rtdb_get(rtdb,'bsse:firt_j',mt_log,1,first_j))
     $  first_j=.true.
c

      if(.not.bsse_rtdb_load(rtdb))
     $  call errquit('bsse_hessian: load data input in db',
     $    911,UNKNOWN_ERR )
c
c

        if (.not. rtdb_cget(rtdb,'task:theory', 1, theory))
     &    call errquit('bsse_hessian: get input_vectors',0,RTDB_ERR)


      lentheo = inp_strlen(theory)
      lenname = inp_strlen(spr_name)
c
c

      if(.not.task_hessian_doit(rtdb))
     $  call errquit('bsse_hessian: error calling hessian doit failed',
     $      0,UNKNOWN_ERR)
c
      if (.not.rtdb_get
     $  (rtdb,'task:energy',mt_dbl,1,spr_energy))
     $  call errquit('bsse_hessian: cannot get energy ',0,RTDB_ERR)


c  store original sets
c: take supermolecule total charge

      if(.not. rtdb_get(rtdb, 'charge', MT_DBL, 1, q_spr))
     $  q_spr = 0.0d0

c: multiplicity
c:   wavefuntion methods

      if( theory(1:lentheo).ne.'dft') then

        if (.not. rtdb_get(rtdb,'scf:nopen', MT_INT, 1, m_spr))
     $    call errquit('bsse_hessian: rtdb_put of nopen failed',
     $      0,RTDB_ERR)

c:    density methods

      elseif ( theory(1:lentheo).eq.'dft') then

        if (.not. rtdb_get(rtdb, 'dft:mult', mt_int, 1, m_spr))
     $   call errquit('bsse_hessian: rtdb_put mult failed', 0, RTDB_ERR)

      endif
c
c: name of the original movecs
        if(theory(1:lentheo).eq.'dft') then
          vec_dbo= 'dft:output vectors'
          vec_dbi= 'dft:input vectors'
        elseif (theory(1:lentheo).eq.'mcscf') then
          vec_dbo= 'mcscf:output vectors'
          vec_dbi= 'mcscf:input vectors'
        else
          vec_dbo = 'scf:output vectors'
          vec_dbi = 'scf:input vectors'
        endif
c
      if (.not. rtdb_cget(rtdb, vec_dbo, 1, vec_spr))
     $ call util_file_name('movecs',.false.,.false.,vec_spr)
c    $ call errquit('bsse_hessian: get vectors file failed', 0)
c
c: name of hessian file

      call util_file_name('hess',  .false., .false.,filehess)
c:copy to operate the sum at the end|
c
      if (nodeid().eq.0) then

        lenhess= inp_strlen(filehess)

        filehesstmp = ' '
        filehesstmp= filehess(1:lenhess)//'.spr'

        call util_file_copy(filehess, filehesstmp)

      endif

c: create geom for monomers within supermolecular geom

      if(.not.bsse_create_geom(rtdb))
     $  call errquit('bsse_hessian: bsse_create_geom',911,UNKNOWN_ERR)

c
c:  Obtain monomers energies from forzen geometries;
c:  it makes a couple jobs for each monomer (no ghost, ghost)
c:monomers

      j=1

      do i=1, nmon*2   

        j_mon_name =  mon_name(j)
        lenname = inp_strlen(mon_name(j))
c
        if (mod(i,2).eq.0) then

          j_mon_name = j_mon_name(1:lenname)//'g'
          lenname = lenname + 1

        endif
c

        if (.not. rtdb_cput(rtdb,'geometry', 1, j_mon_name(1:lenname)))
     $    call errquit('bsse_hessian: no geometry ',0,RTDB_ERR)
c
c

        call bsse_param(rtdb, mmon(j), qmon(j), j_mon_name, input(i),
     $                  theory)
c
c
c
        if(.not.task_hessian_doit(rtdb))
     $    call errquit('bsse_hessian: error calling hessiandoit',
     $ 0,UNKNOWN_ERR)

c:get evaluated energy

        if (.not.rtdb_get
     $    (rtdb,'task:energy', mt_dbl, 1, mon_energy(i)))
     $     call errquit('bsse_hessian: get monomer energy',0,RTDB_ERR)

c:copy to operate the sum at the end|
c
        if(nodeid().eq.0) then
c

          filehesstmp= filehess(1:lenhess)//'.'//
     &      j_mon_name(1:lenname)

          call util_file_copy(filehess, filehesstmp)

        endif
c
        if (mod(i,2).eq.0) then
          j = j +1
        endif

      enddo
c
      bsse_error = 0.0d0

      i = 1

      do j = 1, nmon

        m_error(j) = mon_energy(i) - mon_energy(i+1)
        bsse_error = bsse_error + m_error(j)
        i= i + 2

      enddo
c
      final_spr_energy = spr_energy + bsse_error
c
c sum matrix

      if(ga_nodeid().eq.0) then

        call  hessian_matrix_sum (rtdb)

      endif
c
c: return original geom and parameters
c: store supermolecule parameters
c
      if (.not. rtdb_cput(rtdb, vec_dbi, 1, vec_spr))
     &  call errquit('bsse_hessian: put input_vectors',0,RTDB_ERR)
c

      if (.not. rtdb_cput(rtdb, vec_dbo, 1,vec_spr))
     &  call errquit('bsse_hessian: output_vectors',0,RTDB_ERR)



c:return to original active geom

c
      lenname = inp_strlen(spr_name)

      if (.not. rtdb_cput(rtdb,'geometry', 1, spr_name(1:lenname)))
     $   call errquit ('bsse_hessian: no geometry ',0,RTDB_ERR)

c: store supermolecule total charge

      if (.not. rtdb_get(rtdb, 'charge', MT_DBL, 1, q_spr))
     $   q_spr = 0.0d0

c: store multiplicity
c:   wavefuntion methods

      if( theory(1:lentheo).ne.'dft') then

        if (.not. rtdb_put(rtdb,'scf:nopen', MT_INT, 1, m_spr))
     $    call errquit('bsse_hessian: rtdb_put of nopen failed'
     $  , 0, RTDB_ERR)

c:    density methods

      elseif ( theory(1:lentheo).eq.'dft') then

        if (.not. rtdb_put(rtdb, 'dft:mult', mt_int, 1, m_spr))
     $    call errquit('bsse_gradient:cant put m_spr rtdb',0, RTDB_ERR)

      endif

c

      if(ga_nodeid().eq.0) then

        write(LuOut,20) bsse_error, spr_energy, final_spr_energy
  20  format (/'             BSSE error = ', f20.12/
     $         '  Supermolecular energy = ', f20.12/
     $         '       Corrected energy = ', f20.12/)

         call util_flush(luout)

      endif


      if (.not. rtdb_put(rtdb,'bsse:first_j',mt_log,1,.false.))
     $  call errquit('bsse_hessian: rtdb_put failed',0, RTDB_ERR)

c


      bsse_hessian = .true.

c
      call ga_sync
c
      end
      subroutine hessian_matrix_sum(rtdb)
c
c  This function makes the apropiate sum to mix the hessian of monomers matrixes
C  (with ghost and without ghost) to supermolecular hessian matrix
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "inp.fh"
#include "stdio.fh"
#include "bsse_common.fh"
#include "errquit.fh"
c
      integer rtdb
      integer j,i
      integer iii
      integer k
      integer nat2
      integer lenhess
      double precision dval

      integer nhesst
      character*(nw_max_path_len) filehess
c
      integer k_exy_mont
      integer k_exy_mon
      integer k_exy_spr
      integer k_exycp
      integer k_exybt
      integer k_exybs
c
      integer l_exycp
      integer l_exybt
      integer l_exy_mon
      integer l_exy_mont
      integer l_exybs
      integer n3xyz
c
      n3xyz=3*natoms
      nhesst=n3xyz*(n3xyz+1)/2
      nat2=n3xyz*n3xyz
c
      if (.not.ma_push_get(mt_dbl,nat2,'bsse exybs ',
     *  l_exybs,k_exybs))
     *  call errquit('bsse_hessian_exy: cannot allocate',650, MA_ERR)
      call dfill(nat2,0.0d00,dbl_mb(k_exybs),1)
c
      if (.not.ma_push_get(mt_dbl,nhesst,'bsse exybt ',
     *  l_exybt,k_exybt))
     *  call errquit('bsse_hessian_exy: cannot allocate',650, MA_ERR)
      call dfill(nhesst,0.0d00,dbl_mb(k_exybt),1)
c
      if (.not.ma_push_get(mt_dbl,nat2,'bsse exycp ',
     *  l_exycp,k_exycp))
     *  call errquit('bsse_hessian_exy: cannot allocate',650, MA_ERR)
      call dfill(nat2,0.0d00,dbl_mb(k_exycp),1)
c
      if (.not.ma_push_get(mt_dbl,nat2,'bsse:hessian:exy mon',
     *  l_exy_mon,k_exy_mon))
     *  call errquit('bsse_hessian_exy: cannot allocate',650, MA_ERR)
c
      if (.not.ma_push_get(MT_DBL,nhesst,'bsse:hessian:exyt mon',
     *  l_exy_mont,k_exy_mont))
     *  call errquit('bsse_hessian_exy: cannot allocate',650, MA_ERR)
c
c:read triangle matrix super and do square


      call util_file_name('hess', .false., .false.,filehess)
c

      lenhess=inp_strlen(filehess)
      filehess=filehess(1:lenhess)//'.spr'
c

      open(unit=69,file=filehess,form='formatted',status='old',
     &    err=99900,access='sequential')
      do iii = 0,(nhesst-1)
        read(69,*,err=99901,end=99902) dval
        dbl_mb(k_exybt+iii) = dval
      enddo
      close(unit=69,status='keep')
c

      call trin2squa(dbl_mb(k_exybs),dbl_mb(k_exybt),n3xyz)
c

      j=1

      do i=1, nmon*2

        j_mon_name =  mon_name(j)
        lenname = inp_strlen(mon_name(j))

        if (mod(i,2).eq.0) then

          j_mon_name = j_mon_name(1:lenname)//'g'

          lenname = lenname + 1
          filehess=filehess(1:lenhess)//'.'//j_mon_name

          n3xyz=3*natoms

          nhesst = n3xyz*(n3xyz+1)/2
c:read triangle matrix monomer and do square
          open(unit=69,file=filehess,form='formatted',status='old',
     &    err=99900,access='sequential')

          do iii = 0,(nhesst - 1)
            read(69,*,err=99901,end=99902) dval

            dbl_mb(k_exy_mont+iii) = dval

          enddo

          close(unit=69,status='keep')
    
          call trin2squa(dbl_mb(k_exy_mon),dbl_mb(k_exy_mont),n3xyz)
c:substract entire ghost matrix case
          do k = 0,(nat2- 1)

            dval=dbl_mb(k_exybs+k)-dbl_mb(k_exy_mon+k)
            dbl_mb(k_exybs+k)=dval

          enddo
c:visit other monomer

          j = j +1

        else

          n3xyz=3*mon_atm(j)

          nhesst = n3xyz*(n3xyz+1)/2
c:read triangle matrix monomer 

          filehess=filehess(1:lenhess)//'.'//j_mon_name
c

          open(unit=69,file=filehess,form='formatted',status='old',

     &    err=99900,access='sequential')

          do iii = 0,(nhesst - 1)

            read(69,*,err=99901,end=99902) dval
            dbl_mb(k_exy_mont+iii) = dval

          enddo

          close(unit=69,status='keep')

c: do square
          call trin2squa(dbl_mb(k_exy_mon),dbl_mb(k_exy_mont),n3xyz)

c:sum of no-ghost monomer case
          call dcopy(nat2,dbl_mb(k_exybs),1,dbl_mb(k_exycp),1)

c
          call sum_small_matrix(dbl_mb(k_exybs),dbl_mb(k_exycp),
     $                             dbl_mb(k_exy_mon),3*natoms, n3xyz, j)
        endif
      enddo
c
c     n3xyz=3*natoms
c
c:write the final hessian
c
      call util_file_name('hess', .false., .false.,filehess)
c
      call  stpr_wrt_fd_from_sq(dbl_mb(k_exybs),n3xyz,filehess)

c:clean memory 

      if (.not.ma_chop_stack(l_exy_mont))
     *   call errquit('hess_read: cannot deallocate Exyt',555, MA_ERR)

      if (.not.ma_chop_stack(l_exy_mon))
     *   call errquit('hess_read: cannot deallocate Exyt',555, MA_ERR)

      if (.not.ma_chop_stack(l_exycp))
     *  call errquit('hess_read: cannot deallocate l_Exycp',555, MA_ERR)

      if (.not.ma_chop_stack(l_exybt))
     *  call errquit('hess_read: cannot deallocate l_Exybt',555, MA_ERR)

      if (.not.ma_chop_stack(l_exybs))
     *  call errquit('hess_read: cannot deallocate l_Exybs',555, MA_ERR)
c
      return
99900 continue
      write(luout,*)'hess_file => ',filehess
      call errquit('error opening file: "filehess"',
     1             DISK_ERR,911)
99901 continue
      write(luout,*)'hess_file => ',filehess
      call errquit('error reading file: "filehess"',
     1             DISK_ERR,911)
99902 continue
      write(luout,*)'hess_file => ',filehess
      call errquit('unexpected EOF reading file: "filehess"',
     1             DISK_ERR,911)
      end
c
      subroutine sum_small_matrix(d,a,b,dim_a,dim_b,j)
c
c     this routine sums a monomer matrix in fractions 3x3  of each atom 
c     to the supermolecular matrix
c vama
#include "bsse_common.fh"
      integer i,k,m,n,l,g,r,c
      integer dim_a  ! dimension matrix super
      integer dim_b  ! dimension matrix monomer
      integer j      ! monomer j, used to take the list of atoms
      double precision d(dim_a,dim_a) ! matrix super resul
      double precision a(dim_a,dim_a) ! matrix super
      double precision b(dim_b,dim_b) ! matrix monomer
      double precision dval 
c
      do i = 1 , natoms
        do k = 1 , natoms
c
          do m= 1, mon_atm(j)
            do n= 1, mon_atm(j)
c
              l= mon(j,n)
              g= mon(j,m)
c
              if(l.eq.k.and.g.eq.i) then
c
                do r=0, 2
                  do c=0,2
                    dval=a((i-1)*3+1+r,(k-1)*3+1 +c)+ 
     $                                        b((m-1)*3+1+r,(n-1)*3+1+c)

                    d((i-1)*3+1+r,(k-1)*3+1+c)=dval 
                    d((k-1)*3+1+c,(i-1)*3+1+r)=dval
                  enddo
                enddo
              endif   
            enddo
          enddo
        enddo
      enddo
      end
c
      subroutine trin2squa(a,b,dime)
c
c     convert a triangular matrix to a simetric square matrix
c
      integer dime
      integer j, l, i
      double precision a(dime,dime) !squ
      double precision b((dime*(dime+1))/2) !tri
      double precision dval
c
      i = 1
      do j=1, dime
        do l= 1, j
          dval=b(i)
          a(j,l)=dval
          a(l,j)=dval
          i=i+1
        enddo
      enddo
      end
      subroutine cfill(n,val,a,ia)
      implicit none
      integer n, ia
      character*(*) val, a(*)
      integer i
c
c     initialise characters array
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

c $Id: task_bsse.F 25875 2014-07-02 01:13:02Z d3y133 $

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
      program scf
C$Id: scf.F,v 1.18 2007/03/23 19:24:36 d3g293 Exp $
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
c
      integer*8 nints, maxint                                           !cste
c
c     CAUTION: integer precision requirements
c     nints, maxint, etc. are proportional to the number of basis functions
c     to the fourth power! 216**4 is greater than the largest number 
c     that can be represented as a 32-bit signed interger, so 64-bit 
c     arithmetic is needed to count integrals when calculating more than
c     14 Be atoms with 15 basis functions each. Since integrals are counted
c     over all iterations, 18 iterations with 7 atoms can result in precision
c     problems. Note that the wave function could be calculated correctly 
c     for much larger basis sets without 64-bit integers because the required 
c     indexing is usually proportional to nbfn**2, which is good to 46,340 
c     basis functions, except that the task counter runs as (nbfn/ichunk)**4, 
c     so with ichunk = 10, 32-bit integers yield correct wavefunctions out to 
c     2145 basis functions (maxatom=143), or 4290 (maxatom=286) with ichunk = 20, ...
c
c     This warning applies to the Global Arrays implementation as well! 
c     functions of special concern are ga_igop and nga_read_inc.
c
#define USE_TRANSFORM 1
      integer heap, stack
      data tinit, tonel, ttwoel, tdiag, tdens, tprint /6*0.0d0/
      data eone, etwo, energy, deltad /4*0.0d0/
c     
c     initalize the parallel message passing environment
c     
#include "mp3.fh"
      call ga_initialize()
c
c   Allocate memory
c
      heap =  32000000  
      stack = 32000000
      if (.not.ma_init(MT_DBL, stack, heap))
     +   call ga_error("ma_init failed",-1)
      call flush(6)
      me = ga_nodeid()
      nproc = ga_nnodes()
c     
c     initialize a bunch of stuff and initial density matrix
c     
      rjunk = timer()
c
c     get input from file be.inpt
c
      call input
c
c     create and allocate global arrays
c
      call setarrays
      if (ga_nodeid().eq.0) write(6,*) 'bytes of memory used by node 0:'
     +                                 ,ga_inquire_memory()
      call ininrm
c
c     create initial guess for density matrix by using single atom
c     densities
c
      call denges
      tinit = timer()
#if USE_TRANSFORM
c
c     make initial orthogonal orbital set for solution method using
c     similarity transform
c
      call makeob      
#endif
c     
c     make info for sparsity test
c     
      call makesz(schwmax)
c
c     print preliminary data before any long compute segments start
      if (ga_nodeid().eq.0) call flush(6)       
c     
c     *** iterate ***
c
      do 10 iter = 1, mxiter
c
c     make the one particle contribution to the fock matrix
c     and get the partial contribution to the energy
c    
         call oneel(schwmax, eone)
         tonel = tonel + timer()
c     
c     compute the two particle contributions to the fock matrix and
c     get the total energy.
c     
         call twoel(schwmax, etwo)
         ttwoel = ttwoel + timer()
c     
c     Diagonalize the fock matrix. The diagonalizers used in this
c     subroutine are actually sequential, not parallel.
c
         call diagon(tester,iter)
         tdiag = tdiag + timer()
c     
c     make the new density matrix in g_work from orbitals in g_orbs,
c     compute the norm of the change in the density matrix and
c     then update the density matrix in g_dens with damping.
c     
         call makden
         deltad = dendif()
         if (iter.eq.1) then
            scale = 0.0d0
         else if (iter .le. 5) then
            if (nbfn .gt. 60) then
               scale = 0.5d0
            else
               scale = 0.0d0
            endif
         else
            scale = 0.0d0
         endif
         call damp(scale)
         tdens = tdens + timer()
c     
c     add up energy and print out convergence information
c     
         if (me.eq.0) then
           energy = enrep + eone + etwo
           call prnout(iter, energy, deltad, tester)
           tprint = tprint + timer()
         endif
c     
c     if converged then exit iteration loop
c     
         if (deltad .lt. tol) goto 20
         call ga_igop(9, icut4, 1, '+')                         !cste
         if(icut4 .eq. 0) then                                  !cste
c     something has gone wrong--print what you know and quit.   
            write(6,*) 'no two-electron integrals computed!'    !cste
            goto 20                                             !cste
         endif                                                  !cste
 10   continue
      iter = iter - 1                                           !cste
      if(me.eq.0)
     $     write(6,*) ' SCF failed to converge in ', iter, ' iters'     
c...v....1....v....2....v....3....v....4....v....5....v....6....v....7..
c     
c     finished ... print out eigenvalues and occupied orbitals
c     
 20   continue
      call ga_igop(6, icut1, 1, '+')
      call ga_igop(7, icut2, 1, '+')
      call ga_igop(8, icut3, 1, '+')
      if (me.eq.0) then
c     
c     print out timing information
c     
         call prnfin(energy)
         write(6,1) tinit, tonel, ttwoel, tdiag, tdens, tprint,
     $        nproc
 1       format(/5x,' init ',4x,' onel ',4x,' twoel ',4x,' diag ',4x,   
     $          ' dens      print  ncpu'/                               
     $           5x,'------',4x,'------',4x,'-------',4x,'------',4x,   
     $          '------    ------ ------'/                            
     $          2f10.2,f11.2,3f10.2, i7/)
         totsec = tinit+tonel+ttwoel+tdiag+tdens+tprint 
         write(6,*)'elapsed time in seconds ',totsec   
c     
c     print out information on # integrals evaluated each iteration
c     

          nints = icut1+icut2+icut3
                  frac  = dble(icut3)/dble(nints)

               write(6,2) icut1, icut2, icut3, nints, frac
 2       format(/'No. of integrals screened or computed (all iters) '
     $          /'-------------------------------------'/
     $        /1x,' failed #ij test failed #kl test',
     $            '        #compute          #total',
     $            ' fraction',
     $        /1x,' --------------- ---------------',
     $            ' --------------- ---------------',
     $            ' --------',
     $        /1x,4(1x,i15),f9.6)
         maxint = nbfn                                  !cste   
         maxint = maxint**4 * iter                      !cste
         if(nints .ne. maxint) then                     !cste
            write(6,*)'Inconsistent number of integrals, should be ',   !cste
     $                 maxint                                           !cste
            write(6,*)'Note: largest 32-bit integer is 2,147,483,647'   !cste
       write(6,*)'Probably due to insufficient integer precision in GA.'!cste
         endif                                                          !cste
#ifdef MPI
         call ga_print_stats()
#else
         call stats
#endif
      endif
c     
      call closearrays
      call ga_terminate
#ifdef MPI
      call mpi_finalize
#else
      call pend
#endif
c     
      end
c
      subroutine makesz(schwmax)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      dimension work(ichunk,ichunk)
      integer lo(2),hi(2),i,j,iloc,jloc,ld
      logical dotask, next_chunk
c
c     schwarz(ij) = (ij|ij) for sparsity test
c
      icut1 = 0
      icut2 = 0
      icut3 = 0
c
      call ga_zero(g_schwarz)
      call ga_zero(g_counter)
      schwmax = 0.0d0
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while (dotask)
        do i = lo(1), hi(1)
          iloc = i - lo(1) + 1
          do j = lo(2), hi(2)
            jloc = j - lo(2) + 1
            call g(gg,i,j,i,j)
            work(iloc,jloc) = sqrt(gg)
            schwmax = max(schwmax, work(iloc,jloc))
          end do
        end do
        call nga_put(g_schwarz,lo,hi,work,ld)
        dotask = next_chunk(lo,hi)
      end do
      call ga_dgop(11,schwmax,1,'max')
c
      return
      end
c
      subroutine ininrm
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer*8 maxint          
c
c     write a little welcome message
c
      maxint = nbfn             
      maxint = maxint**4        
      if (ga_nodeid().eq.0) then                                
      write(6,1) natom, nocc, nbfn, maxint, tol, ichunk
1     format(/' Example Direct Self Consistent Field Program '/
     $        ' -------------------------------------------- '//
     $        ' no. of atoms .............. ',i5/       
     $        ' no. of occupied orbitals .. ',i5/       
     $        ' no. of basis functions .... ',i5/       
     $        ' basis functions^4 '          ,i15/      
     $        ' convergence threshold ..... ',1pd9.2/
     $        ' chunk size .................',i5)   
      write(6,*)                                                !cste
      call flush(6)                                             !cste
      endif                                                     !cste
c
c     generate normalisation coefficients for the basis functions
c     and the index array iky
c
      do 10 i = 1, nbfn
         iky(i) = i*(i-1)/2
 10   continue
c
      do 20 i = 1, nbfn
         rnorm(i) = (expnt(i)*2.0d0/pi)**0.75d0
 20   continue
c
c     initialize common for computing f0
c
      call setfm
c
      end
      double precision function h(i,j)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
cvd$r novector
cvd$r noconcur
c
c     generate the one particle hamiltonian matrix element
c     over the normalized primitive 1s functions i and j
c
      f0val = 0.0d0
      sum = 0.0d0
      rab2 = (x(i)-x(j))**2 + (y(i)-y(j))**2 + (z(i)-z(j))**2
      facij = expnt(i)*expnt(j)/(expnt(i)+expnt(j))
      expij = exprjh(-facij*rab2)
      repij = (2.0d0*pi/(expnt(i)+expnt(j))) * expij
c
c     first do the nuclear attraction integrals
c
      do 10 iat = 1, natom
         xp = (x(i)*expnt(i) + x(j)*expnt(j))/(expnt(i)+expnt(j))
         yp = (y(i)*expnt(i) + y(j)*expnt(j))/(expnt(i)+expnt(j))
         zp = (z(i)*expnt(i) + z(j)*expnt(j))/(expnt(i)+expnt(j))
         rpc2 = (xp-ax(iat))**2 + (yp-ay(iat))**2 + (zp-az(iat))**2
c
         call f0(f0val, (expnt(i)+expnt(j))*rpc2)
         sum = sum - repij * q(iat) * f0val
 10   continue
c
c     add on the kinetic energy term
c
      sum = sum + facij*(3.0d0-2.0d0*facij*rab2) *
     $     (pi/(expnt(i)+expnt(j)))**1.5d0 * expij
c
c     finally multiply by the normalization constants
c
      h = sum * rnorm(i) * rnorm(j)
c
      end
      double precision function s(i,j)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
c
c     generate the overlap matrix element between the normalized
c     primitve gaussian 1s functions i and j
c
      rab2 = (x(i)-x(j))**2 + (y(i)-y(j))**2 + (z(i)-z(j))**2
      facij = expnt(i)*expnt(j)/(expnt(i)+expnt(j))
      s = (pi/(expnt(i)+expnt(j)))**1.5d0 * exprjh(-facij*rab2) *
     $     rnorm(i)*rnorm(j)
c
      end
      subroutine makden
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
c      dimension work(maxnbfn,maxnbfn), torbs(maxnbfn,maxnbfn)
      dimension work(ichunk,ichunk), orbsi(ichunk,maxnbfn)
      dimension orbsj(ichunk,maxnbfn)
      integer lo(2), hi(2), tlo(2), thi(2), i, j, iloc, jloc, ld
      logical dotask, next_chunk
c
c     generate density matrix from orbitals in g_orbs. the first
c     nocc orbitals are doubly occupied.
c
      call ga_zero(g_counter)
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while (dotask)
        tlo(1) = lo(1)
        thi(1) = hi(1)
        tlo(2) = 1
        thi(2) = nocc
        call nga_get(g_orbs,tlo,thi,orbsi,ld)
        tlo(1) = lo(2)
        thi(1) = hi(2)
        call nga_get(g_orbs,tlo,thi,orbsj,ld)
        do i = lo(1), hi(1)
          iloc = i - lo(1) + 1
          do j = lo(2), hi(2)
            jloc = j - lo(2) + 1
            p = 0.0d00
            do k = 1, nocc
              p = p + orbsi(iloc,k)*orbsj(jloc,k)
            end do
            work(iloc,jloc) = 2.0d00*p
          end do
        end do
        call nga_put(g_work,lo,hi,work,ld)
        dotask = next_chunk(lo,hi)
      end do
      return
      end
c
      subroutine oneel(schwmax, eone)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer lo(2), hi(2), i, j, iloc, jloc, ld
      dimension work(ichunk,ichunk),tfock(ichunk,ichunk)
      logical dotask, next_chunk
c
c     fill in the one-electron part of the fock matrix and
c     compute the one-electron energy contribution
c

      me = ga_nodeid()
      nproc = ga_nnodes()
c
      call ga_zero(g_counter)
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while (dotask)
        call nga_get(g_schwarz,lo,hi,work,ld)
        do j = lo(2), hi(2)
          jloc = j - lo(2) + 1
          do i = lo(1), hi(1)
            iloc = i - lo(1) + 1
            tfock(iloc,jloc) = 0.0d00
            if (work(iloc,jloc)*schwmax.gt.tol2e)
     +        tfock(iloc,jloc) = h(i,j)
          end do
        end do
        call nga_put(g_fock,lo,hi,tfock,ld)
        dotask = next_chunk(lo,hi)
      end do
      eone = 0.5d00*contract_matrices(g_fock,g_dens)
c
      end
#if 0
      integer function nxtask(nproc)
      parameter (ichunk = 10)
      save icount, nleft
      data nleft, icount /0, 0/
c
c     wrapper round nxtval() to increase granularity
c     and thus reduce no. of requests to shared counter
c
      if(nproc.gt.0) then
         if(nleft.eq.0) then
#ifdef MPI
            icount = nxtval_ga(nproc) * ichunk
#else
            icount = nxtval(nproc) * ichunk
#endif
            nleft = ichunk
         endif
         nxtask = icount
         icount = icount + 1
         nleft = nleft -1
      else
          nleft = 0
          nxtask = 0
#ifdef MPI
          junk = nxtval_ga(nproc)
#else
          junk = nxtval(nproc)
#endif
      endif
c
c     following does dumb static load balancing
c
c$$$      if(nproc.gt.0) then
c$$$         if (nleft .eq. 0) then
c$$$            icount = ga_nodeid()
c$$$            nleft = 1
c$$$         endif
c$$$         nxtask = icount
c$$$         icount = icount + ga_nnodes()
c$$$      else
c$$$          nleft = 0
c$$$          nxtask = 0
c$$$      endif
      end
#endif
c
      logical function next_chunk(lo,hi)
#include "cscf.h"
      integer one
      parameter (one = 1)
      integer imax, lo(2), hi(2), ilo, jlo
      itask = nga_read_inc(g_counter,one,one)
      imax = nbfn/ichunk
      if (nbfn - ichunk*imax.gt.0) imax = imax + 1 
      if (itask.lt.imax*imax) then
        ilo = mod(itask,imax)
        jlo = (itask-ilo)/imax
        lo(1) = ilo*ichunk + 1
        lo(2) = jlo*ichunk + 1
        hi(1) = min((ilo+1)*ichunk,nbfn)
        hi(2) = min((jlo+1)*ichunk,nbfn)
        next_chunk = .true.
      else
        next_chunk = .false.
      endif
      return
      end
c
      logical function next_4chunk(lo,hi,ilo,jlo,klo,llo)
#include "cscf.h"
      integer one
      parameter (one = 1)
      integer*8 imax, itask, itmp                               !cste
      integer lo(4), hi(4), ilo, jlo, klo, llo                  !cste
c
      itask = nga_read_inc(g_counter,one,one)
      imax = nbfn/ichunk
      if (nbfn - ichunk*imax.gt.0) imax = imax + 1
      if (itask. lt. 0) then                                    !cste
         write(6,*) 'next_4chunk: itask negative:',itask,       !cste
     *             ' imax:',imax,' nbfn:',nbfn,' ichunk:',ichunk!cste
         write(6,*) 'probable GA integer precision problem if ' !cste
     *             ,'imax^4 > 2^31'                             !cste
         call flush(6)                                          !cste
         stop 'next_4chunk'                                     !cste
      end if                                                    !cste
      if (itask.lt.imax**4) then
        ilo = mod(itask,imax)
        itmp = (itask - ilo)/imax
        jlo = mod(itmp,imax)
        itmp = (itmp - jlo)/imax
        klo = mod(itmp,imax)
        llo = (itmp - klo)/imax
        lo(1) = ilo*ichunk + 1
        lo(2) = jlo*ichunk + 1
        lo(3) = klo*ichunk + 1
        lo(4) = llo*ichunk + 1
        hi(1) = min((ilo+1)*ichunk,nbfn)
        hi(2) = min((jlo+1)*ichunk,nbfn)
        hi(3) = min((klo+1)*ichunk,nbfn)
        hi(4) = min((llo+1)*ichunk,nbfn)
        next_4chunk = .true.
      else
        next_4chunk = .false.
      endif
      return
      end
c
      subroutine clean_chunk(chunk)
#include "cscf.h"
      double precision chunk(ichunk,ichunk)
      integer i,j
      do j = 1, ichunk
        do i = 1, ichunk
          chunk(i,j) = 0.0d00
        end do
      end do
      return
      end
c
      subroutine twoel(schwmax, etwo)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      double precision f_ij(ichunk,ichunk),d_kl(ichunk,ichunk)
      double precision f_ik(ichunk,ichunk),d_jl(ichunk,ichunk)
      double precision s_ij(ichunk,ichunk),s_kl(ichunk,ichunk)
      double precision schwmax, one
cste  integer nproc                                             !cste
      integer*8 ijkls, ijcnt,klcnt,ijklcnt                      !cste
      integer lo(4),hi(4),lo_ik(2),hi_ik(2),lo_jl(2),hi_jl(2)   !cste
      integer i,j,k,l,iloc,jloc,kloc,lloc,ld,ich,it,jt,kt,lt    !cste
      logical dotask, next_4chunk
c     
c     add in the two-electron contribution to the fock matrix
c     
cste  nproc = ga_nnodes()
      one = 1.0d00
      ijcnt = icut1                                     !cste
      klcnt = icut2                                     !cste
      ijklcnt = icut3                                   !cste
c
      call ga_zero(g_counter)
      ld = maxnbfn
      ich = ichunk
      dotask = next_4chunk(lo,hi,it,jt,kt,lt)
      itask = 0
cste  ijkls = 0                                         !cste
      do while (dotask)
cste  ijkl=(hi(1)-lo(1)+1)*(hi(2)-lo(2)+1)*             !cste
cste *     (hi(3)-lo(3)+1)*(hi(4)-lo(4)+1)              !cste
cste  ijkls = ijkls + ijkl                              !cste
cste  write(6,*)itask,lo,hi,ijkl,ijkls                  !cste
        lo_ik(1) = lo(1)
        lo_ik(2) = lo(3)
        hi_ik(1) = hi(1)
        hi_ik(2) = hi(3)
        lo_jl(1) = lo(2)
        lo_jl(2) = lo(4)
        hi_jl(1) = hi(2)
        hi_jl(2) = hi(4)
        call nga_get(g_schwarz,lo,hi,s_ij,ich)
        call nga_get(g_schwarz,lo(3),hi(3),s_kl,ich)
        call nga_get(g_dens,lo(3),hi(3),d_kl,ich)
        call nga_get(g_dens,lo_jl,hi_jl,d_jl,ich)
        itask = itask + 1
        call clean_chunk(f_ij)
        call clean_chunk(f_ik)
        do i = lo(1), hi(1)
          iloc = i-lo(1) + 1
          do j = lo(2), hi(2)
            jloc = j-lo(2) + 1
            if (s_ij(iloc,jloc)*schwmax .lt. tol2e) then
              icut1 = icut1 + (hi(3)-lo(3)+1)*(hi(4)-lo(4)+1)   !cste
            else
              do k = lo(3), hi(3)
                kloc = k-lo(3) + 1
                do l = lo(4), hi(4)
                  lloc = l-lo(4) + 1
                  if (s_ij(iloc,jloc)*s_kl(kloc,lloc).lt.tol2e) then
                    icut2 = icut2 + 1
                  else
                    call g(gg, i, j, k, l)
                    f_ij(iloc,jloc) = f_ij(iloc,jloc)
     +                              + gg*d_kl(kloc,lloc)
                    f_ik(iloc,kloc) = f_ik(iloc,kloc)
     +                              - 0.5d00*gg*d_jl(jloc,lloc)
                    icut3 = icut3 + 1
                  endif
                end do
              end do
            endif
          end do
        end do
        call nga_acc(g_fock,lo,hi,f_ij,ich,one)
        call nga_acc(g_fock,lo_ik,hi_ik,f_ik,ich,one)
        dotask = next_4chunk(lo,hi,it,jt,kt,lt)
      end do
      etwo = 0.5d00*contract_matrices(g_fock,g_dens)
      ijcnt = icut1 - ijcnt
      klcnt = icut2 - klcnt
      ijklcnt = icut3 - ijklcnt
cste  write(6,*) 'node ', ga_nodeid(), ijcnt, klcnt, ijklcnt    !cste
cste *           ,icut1,icut2,icut3                             !cste
cste  call flush(6)                                             !cste
      icut4 = icut3                                             !cste
      if (icut3 .gt. 0) return                                  !cste
c
c    no integrals may be calculated if there is no work for 
c    this node (ichunk too big), or, something is wrong
c
      write(6,*) 'no two-electron integrals computed by node',  !cste
     *            ga_nodeid()                                   !cste
      call flush(6)                                             !cste
      return
cste  stop 'twoel computed no integrals'                        !cste
      end
c
      subroutine damp(fac)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
c
c    create damped density matrix as a linear combination of
c    old density matrix and density matrix formed from new orbitals
c
      ofac = 1.0d0 - fac
      call ga_add(fac,g_dens,ofac,g_work,g_dens)
      return
      end
c
      subroutine prnout(iter, energy, deltad, tester)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
c
c     printout results of each iteration
c
      if (ga_nodeid().ne.0) return
      write(6,1) iter, energy, deltad, tester
      call flush(6)
1     format(' iter=',i3,', energy=',f15.8,', deltad=',1pd9.2,  
     $     ', deltaf=',d9.2)
      return
      end
c
      double precision function dendif()
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      double precision xdiff
      dimension dens_c(ichunk,ichunk),work_c(ichunk,ichunk)
      integer lo(2), hi(2), i, j, ld
      logical dotask, next_chunk
c
c     compute largest change in density matrix elements
c
      denmax = 0.0d0
      call ga_zero(g_counter)
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while(dotask)
        call nga_get(g_dens,lo,hi,dens_c,ld)
        call nga_get(g_work,lo,hi,work_c,ld)
        do j = 1, hi(2)-lo(2)+1
          do i = 1, hi(1)-lo(1)+1
            xdiff = abs(dens_c(i,j)-work_c(i,j))
            if (xdiff.gt.denmax) denmax = xdiff
          end do
        end do
        dotask = next_chunk(lo,hi)
      end do
      call ga_dgop(1,denmax,1,'max')
      dendif = denmax
      return
      end
c
      double precision function testfock()
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      double precision xmax, xtmp
      dimension work(ichunk,ichunk)
      integer lo(2), hi(2), i, j, iloc, jloc, ld
      logical dotask, next_chunk
c
c     compute largest change in density matrix elements
c
      xmax = 0.0d0
      call ga_zero(g_counter)
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while(dotask)
        call nga_get(g_fock,lo,hi,work,ld)
        do j = lo(2), hi(2)
          jloc = j - lo(2) + 1
          do i = lo(1), hi(1)
            iloc = i - lo(1) + 1
            if (i.ne.j) then
              xtmp = abs(work(iloc,jloc))
              if (xtmp.gt.xmax) xmax = xtmp
            endif
          end do
        end do
        dotask = next_chunk(lo,hi)
      end do
      call ga_dgop(1,xmax,1,'max')
      testfock = xmax
      return
      end
c
      subroutine shiftfock(shift)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      double precision shift
      dimension work(ichunk,ichunk)
      integer lo(2), hi(2), i, j, iloc, jloc, ld, icnt
      logical dotask, next_chunk
c
c     compute largest change in density matrix elements
c
      call ga_zero(g_counter)
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while(dotask)
        call nga_get(g_fock,lo,hi,work,ld)
        icnt = 0
        do j = lo(2), hi(2)
          jloc = j - lo(2) + 1
          do i = lo(1), hi(1)
            iloc = i - lo(1) + 1
            if (i.eq.j.and.i.gt.nocc) then
              work(iloc,jloc) = work(iloc,jloc) + shift
              icnt = icnt + 1
            endif
          end do
        end do
        if (icnt.gt.0) call nga_put(g_fock,lo,hi,work,ld)
        dotask = next_chunk(lo,hi)
      end do
      return
      end
c
      subroutine prnfin(energy)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      dimension orbs(maxnbfn, maxnbfn)
      integer lo(2),hi(2),ld
c
c     printout final results
c
      if (ga_nodeid().ne.0) return
      write(6,1) energy
 1    format(//' final energy = ',f18.11//' eigenvalues') 
      call output(eigv, 1, min(nbfn,nocc+5), 1, 1, nbfn, 1, 1)
c
      return
      end
      subroutine g(value,i,j,k,l)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
c
c     compute the two electon integral (ij|kl) over normalized
c     primitive 1s gaussians
c
      f0val = 0.0d0
      rab2 = (x(i)-x(j))**2 + (y(i)-y(j))**2 + (z(i)-z(j))**2
      rcd2 = (x(k)-x(l))**2 + (y(k)-y(l))**2 + (z(k)-z(l))**2
      facij = expnt(i)*expnt(j)/(expnt(i)+expnt(j))
      fackl = expnt(k)*expnt(l)/(expnt(k)+expnt(l))
      exijkl = exprjh(- facij*rab2 - fackl*rcd2)
      denom = (expnt(i)+expnt(j))*(expnt(k)+expnt(l)) *
     $        sqrt(expnt(i)+expnt(j)+expnt(k)+expnt(l))
      fac = (expnt(i)+expnt(j))*(expnt(k)+expnt(l)) /
     $        (expnt(i)+expnt(j)+expnt(k)+expnt(l))
c
      xp = (x(i)*expnt(i) + x(j)*expnt(j))/(expnt(i)+expnt(j))
      yp = (y(i)*expnt(i) + y(j)*expnt(j))/(expnt(i)+expnt(j))
      zp = (z(i)*expnt(i) + z(j)*expnt(j))/(expnt(i)+expnt(j))
      xq = (x(k)*expnt(k) + x(l)*expnt(l))/(expnt(k)+expnt(l))
      yq = (y(k)*expnt(k) + y(l)*expnt(l))/(expnt(k)+expnt(l))
      zq = (z(k)*expnt(k) + z(l)*expnt(l))/(expnt(k)+expnt(l))
      rpq2 = (xp-xq)**2 + (yp-yq)**2 + (zp-zq)**2
c
      call f0(f0val, fac*rpq2)
      value = (2.0d0 * pi**2.5d0 / denom) * exijkl * f0val *
     $    rnorm(i)*rnorm(j)*rnorm(k)*rnorm(l)
      return
      end
c
      subroutine diagon(tester, iter)
c      subroutine diagon(fock, orbs, evals, work, tester, iter)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      double precision r_zero, r_one, shift, tester
c
#if USE_TRANSFORM
c
c     use similarity transform to solve standard eigenvalue problem
c     (overlap matrix has been transformed out of the problem)
c
      r_one = 1.0d00
      r_zero = 0.0d00
      call ga_dgemm('n','n',nbfn,nbfn,nbfn,r_one,g_fock,g_orbs,
     +               r_zero,g_tfock)
      call ga_dgemm('t','n',nbfn,nbfn,nbfn,r_one,g_orbs,g_tfock,
     +               r_zero,g_fock)
      tester = testfock()
      shift = 0.0d00
      if (tester.gt.0.3d0) then
        shift = 0.3d0
      else
        if (nbfn .gt. 60) then
          shift = 0.1d0
        else
          shift = 0.0d0
        endif
      endif
      if (iter.ge.2.and.shift.ne.0.0d00) then
        call shiftfock(shift)
      endif
      call ga_copy(g_orbs,g_tfock)
      call ga_diag_std_seq(g_fock, g_work, eigv)
c
c     Back transform eigenvectors
c
      call ga_dgemm('n','n',nbfn,nbfn,nbfn,r_one,g_tfock,g_work,
     +               r_zero,g_orbs)
      if (iter.ge.2.and.shift.ne.0.0d00) then
         do 50 i = nocc+1, nbfn
            eigv(i) = eigv(i) - shift
 50      continue
      endif
#else
c
c     Keep remaking overlap matrix since ga_diag_seq does not
c     guarantee that g_ident is preserved.
c
         call makoverlap
         call ga_diag_seq(g_fock, g_ident, g_orbs, eigv)
         tester = 0.0d00
#endif
      return
      end
c
      subroutine makeob
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      double precision work(ichunk,ichunk),orbs(ichunk,ichunk)
      double precision eval(maxnbfn)
      integer lo(2),hi(2),ld,me,i,j,iloc,jloc
      logical dotask, next_chunk
c
c     generate set of orthonormal vectors by creating a random
c     symmetric matrix and solving associated generalized eigenvalue
c     problem using the correct overlap matrix.
c
      me = ga_nodeid()
      call ga_zero(g_counter)
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while (dotask)
        do j = lo(2), hi(2)
          jloc = j - lo(2) + 1
          do i = lo(1), hi(1)
            iloc = i - lo(1) + 1
            work(iloc,jloc) = s(i,j)
            orbs(iloc,jloc) = drand(0)
          end do
        end do
        call nga_put(g_ident,lo,hi,work,ld)
        call nga_put(g_fock,lo,hi,orbs,ld)
        dotask = next_chunk(lo,hi)
      end do
      call ga_symmetrize(g_fock)
      call ga_diag_seq(g_fock, g_ident, g_orbs, eval)
c
      return
      end
c
      subroutine denges
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
c
c     Form guess density from superposition of atomic densities in the AO
c     basis set ... instead of doing the atomic SCF hardwire for this
c     small basis set for the Be atom.
c
      integer one, itask, lo(2), hi(2), ld
      dimension atdens(15,15)
      data atdens/
     $     0.000002,0.000027,0.000129,0.000428,0.000950,0.001180,
     $     0.000457,-0.000270,-0.000271,0.000004,0.000004,0.000004,
     $     0.000004,0.000004,0.000004,0.000027,0.000102,0.000987,
     $     0.003269,0.007254,0.009007,0.003492,-0.002099,-0.002108,
     $     0.000035,0.000035,0.000035,0.000035,0.000035,0.000035,
     $     0.000129,0.000987,0.002381,0.015766,0.034988,0.043433,
     $     0.016835,-0.010038,-0.010082,0.000166,0.000166,0.000166,
     $     0.000166,0.000166,0.000166,0.000428,0.003269,0.015766,
     $     0.026100,0.115858,0.144064,0.055967,-0.035878,-0.035990,
     $     0.000584,0.000584,0.000584,0.000584,0.000584,0.000584,
     $     0.000950,0.007254,0.034988,0.115858,0.128586,0.320120,
     $     0.124539,-0.083334,-0.083536,0.001346,0.001346,0.001346,
     $     0.001346,0.001346,0.001346,0.001180,0.009007,0.043433,
     $     0.144064,0.320120,0.201952,0.159935,-0.162762,-0.162267,
     $     0.002471,0.002471,0.002471,0.002471,0.002471,0.002471,
     $     0.000457,0.003492,0.016835,0.055967,0.124539,0.159935,
     $     0.032378,-0.093780,-0.093202,0.001372,0.001372,0.001372,
     $     0.001372,0.001372,0.001372,-0.000270,-0.002099,-0.010038,
     $     -0.035878,-0.083334,-0.162762,-0.093780,0.334488,0.660918,
     $     -0.009090,-0.009090,-0.009090,-0.009090,-0.009090,-0.009090,
     $     -0.000271,-0.002108,-0.010082,-0.035990,-0.083536,-0.162267,
     $     -0.093202,0.660918,0.326482,-0.008982,-0.008982,-0.008981,
     $     -0.008981,-0.008981,-0.008982,0.000004,0.000035,0.000166,
     $     0.000584,0.001346,0.002471,0.001372,-0.009090,-0.008982,
     $     0.000062,0.000124,0.000124,0.000124,0.000124,0.000124,
     $     0.000004,0.000035,0.000166,0.000584,0.001346,0.002471,
     $     0.001372,-0.009090,-0.008982,0.000124,0.000062,0.000124,
     $     0.000124,0.000124,0.000124,0.000004,0.000035,0.000166,
     $     0.000584,0.001346,0.002471,0.001372,-0.009090,-0.008981,
     $     0.000124,0.000124,0.000062,0.000124,0.000124,0.000124,
     $     0.000004,0.000035,0.000166,0.000584,0.001346,0.002471,
     $     0.001372,-0.009090,-0.008981,0.000124,0.000124,0.000124,
     $     0.000062,0.000124,0.000124,0.000004,0.000035,0.000166,
     $     0.000584,0.001346,0.002471,0.001372,-0.009090,-0.008981,
     $     0.000124,0.000124,0.000124,0.000124,0.000062,0.000124,
     $     0.000004,0.000035,0.000166,0.000584,0.001346,0.002471,
     $     0.001372,-0.009090,-0.008982,0.000124,0.000124,0.000124,
     $     0.000124,0.000124,0.000062/
c
c   Create initial guess for density matrix in global array
c
      call ga_zero(g_dens)
      call ga_zero(g_counter)
      one = 1
      ld = 15
c
c   Correct for a factor of two along the diagonal
c
      do i = 1, ld
        atdens(i,i) = 2.0d00*atdens(i,i)
      end do
      itask = nga_read_inc(g_counter,one,one)
      do while(itask.lt.natom)
        ioff = itask*15
        lo(1) = ioff+1
        lo(2) = ioff+1
        hi(1) = ioff+15
        hi(2) = ioff+15
        call nga_put(g_dens,lo,hi,atdens,ld)
        itask = nga_read_inc(g_counter,one,one)
      end do
      call ga_sync
      return
      end
c
      subroutine setarrays
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer one, two, dims(2)
      logical status
      one = 1
      two = 2
      g_counter = ga_create_handle()
      call ga_set_data(g_counter,one,one,MT_INT)
      status = ga_allocate(g_counter)
      call ga_zero(g_counter)

      dims(1) = nbfn
      dims(2) = nbfn
      g_dens = ga_create_handle()
      call ga_set_data(g_dens, two, dims, MT_DBL)
      status = ga_allocate(g_dens)
      call ga_zero(g_dens)

      g_schwarz = ga_create_handle()
      call ga_set_data(g_schwarz, two, dims, MT_DBL)
      status = ga_allocate(g_schwarz)
      call ga_zero(g_schwarz)

      g_fock = ga_create_handle()
      call ga_set_data(g_fock, two, dims, MT_DBL)
      status = ga_allocate(g_fock)
      call ga_zero(g_fock)

      
      g_tfock = ga_create_handle()
      call ga_set_data(g_tfock, two, dims, MT_DBL)
      status = ga_allocate(g_tfock)
      call ga_zero(g_tfock)

      g_work = ga_create_handle()
      call ga_set_data(g_work, two, dims, MT_DBL)
      status = ga_allocate(g_work)
      call ga_zero(g_work)

      g_ident = ga_create_handle()
      call ga_set_data(g_ident, two, dims, MT_DBL)
      status = ga_allocate(g_ident)
      call ga_zero(g_ident)

      g_orbs = ga_create_handle()
      call ga_set_data(g_orbs, two, dims, MT_DBL)
      status = ga_allocate(g_orbs)
      call ga_zero(g_orbs)

      return
      end
      subroutine closearrays
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      logical status
c
      status = ga_destroy(g_counter)
      status = ga_destroy(g_dens)
      status = ga_destroy(g_schwarz)
      status = ga_destroy(g_fock)
      status = ga_destroy(g_tfock)
      status = ga_destroy(g_work)
      status = ga_destroy(g_ident)
      status = ga_destroy(g_orbs)
c
      return
      end
c
      subroutine makoverlap
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer me, lo(2), hi(2), ptr, ld(2)
      integer ld1, ld2
      me = ga_nodeid()
      call nga_distribution(g_ident, me, lo, hi)
      call nga_access(g_ident, lo, hi, ptr, ld)
      ld1 = hi(1) - lo(1) + 1
      ld2 = hi(2) - lo(2) + 1
      call setoverlap(dbl_mb(ptr),lo,hi,ld1,ld2)
      call nga_release(g_ident)
      return
      end
c
      subroutine setoverlap(a,lo,hi,ld1,ld2)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer lo(2), hi(2)
      integer ld1, ld2, ii, jj
      double precision a(ld1,ld2)
      do i = 1, ld1
        ii = i + lo(1) - 1
        do j = 1, ld2
          jj = j + lo(2) - 1
#if USE_TRANSFORM
          if (ii.eq.jj) then
            a(i,j) = 1.0d00
          else
            a(i,j) = 0.0d00
          endif
#else
          a(i,j) = s(ii,jj)
#endif
        end do
      end do
      return
      end
c
      subroutine print_ga_block(g_a)
      implicit double precision(a-h,o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer lo(2), hi(2), ptr, ld1, ld2
c
      me = ga_nodeid()
      call nga_distribution(g_a, me, lo, hi)
      ld1 = hi(1) - lo(1) + 1
      ld2 = hi(2) - lo(2) + 1
      call nga_access(g_a, lo, hi, ptr, ld)
      call dump_chunk(dbl_mb(ptr),ld1,ld2)
      call nga_release(g_a)
c
      return
      end
c
      subroutine print_ga_block_ij(g_a,tlo)
      implicit double precision(a-h,o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer lo(2), hi(2), ptr, ld1, ld2
c
      me = ga_nodeid()
      call nga_distribution(g_a, me, lo, hi)
      ld1 = hi(1) - lo(1) + 1
      ld2 = hi(2) - lo(2) + 1
      call nga_access(g_a, tlo, hi, ptr, ld)
      call dump_chunk(dbl_mb(ptr),ld1,ld2)
      call nga_release(g_a)
c
      return
      end
c
      subroutine dump_chunk(a,ld1,ld2)
      implicit double precision (a-h, o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer ld1, ld2
      double precision a(ld1, ld2)
      do i = 1, min(10,ld1)
        write(6,100) (a(i,j), j = 1, min(10,ld2))
      end do
      write(6,*)
      trace = 0.0d0
      do i=1,ld2
         trace = trace +a(i,i)
      end do
      write(6,*) 'trace=',trace
  100 format(10f10.4)
      return
      end
c
      double precision function contract_matrices(g_a,g_b)
      implicit double precision(a-h,o-z)
#include "cscf.h"
#include "mafdecls.fh"
#include "global.fh"
#include "mp3def.fh"
      integer lo(2), hi(2), ptr_a, ptr_b, ld, ld1, ld2
      double precision a(ichunk,ichunk),b(ichunk,ichunk)
      double precision value
      logical dotask, next_chunk
c
c   evalute sum_ij a_ij*b_ij
c
      value = 0.0d00
      call ga_zero(g_counter)
      dotask = next_chunk(lo,hi)
      ld = ichunk
      do while (dotask)
        call nga_get(g_a,lo,hi,a,ld)
        call nga_get(g_b,lo,hi,b,ld)
        do j = 1, hi(2)-lo(2)+1
          do i = 1, hi(1)-lo(1)+1
            value = value + a(i,j)*b(i,j)
          end do
        end do
        dotask = next_chunk(lo,hi)
      end do
      call ga_dgop(3,value,1,'+')
      contract_matrices=value
c
      return
      end

      subroutine argos_cafe_pr_angles(lfnout,nsh,msh,msp,iang,
     + ang,rang,rub,snam)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      integer lfnout,nsh,msh,msp
      integer iang(msh,4)
      real*8 ang(msh,msp,mset),rang(msh,2),rub(msh,2)
      character*16 snam(nsatot)
c
      integer i,j
c
      if(np.gt.1) call ga_dgop(mcf_52,rang,2*msh,'+')
      if(np.gt.1.and.iffld.eq.2) call ga_dgop(mcf_81,rub,2*msh,'+')
      if(me.ne.0) return
c
      write(lfnout,1000)
 1000 format(/,' Solute angles',/,
     + '      i      j      k     atom_i           atom_j           ',
     + 'atom_k            c     th_0       C          th         U',/)
c
      do 1 i=1,nsh
      write(lfnout,1001) (iang(i,j),j=1,3),
     + (snam(iang(i,j))(12:16)//':'//snam(iang(i,j))(1:11),j=1,3),
     + iang(i,4),(ang(i,j,iset),j=1,2),(rang(i,j),j=1,2)
 1001 format(3i7,3a17,i7,f10.5,e12.5,f10.5,f12.6)
    1 continue
c
      if(iffld.eq.2) then
c
      write(lfnout,1002)
 1002 format(/,' Solute Urey-Bradley terms',/,
     + '      i      k     atom_i           atom_k           ',
     + ' c     s_0        C          s          U',/)
c
      do 2 i=1,nsh
      if(ang(i,3,iset).gt.0.0d0) then
      write(lfnout,1003) iang(i,1),iang(i,3),
     + snam(iang(i,1))(12:16)//':'//snam(iang(i,1))(1:11),
     + snam(iang(i,3))(12:16)//':'//snam(iang(i,3))(1:11),
     + iang(i,4),(ang(i,j,iset),j=3,4),(rub(i,j),j=1,2)
 1003 format(2i7,2a17,i7,f10.5,e12.5,f10.5,f12.6)
      endif
    2 continue
c
      endif
c
      return
      end
c $Id: argos_cafe_pr_angles.F 21176 2011-10-10 06:35:49Z d3y133 $

c $Id: intb_init4c.F 23168 2012-11-29 16:54:25Z d3y133 $  
*
C> \ingroup nwint
C> @{
C>
C> \brief Initialize the blocking integral API based on the input
C> of a group of shell quartets (a block)
C>
C> Initialize the blocking integral API based on the input
C> of a group of shell quartets (a block). This routine must be called
C> before attempting to calculate the integrals of the block.
C>
C> The shell quartet information may be reordered
C> since this routine pulls out blocks that consist of only \f$s\f$, \f$p\f$, 
C> and \f$sp\f$ functions.  These blocks are computed using the \f$sp\f$ rotated
C> axis code since it is faster than even the Texas integral code.
C>
C> \return Returns .true. if the initialization was successfull and the
C> integrals are ready to be calculated by `intb_2e4c`, and .false.
C> otherwise (i.e. a problem was detected).
C>
C> The following code excerpt describes the proper use of the blocking
C> API routines:
C> 
C> * begin atom/shell loops
C> 
C> \code
C>       call collect_group_of_shells()
C>       okay = intb_init4c($\cdots$) ! with group of shells info     
C>       if (.not.okay) stop ' error setting up blocking interface '
C> 00001 continue
C>       more = intb_2e4c($\cdots$) ! with group of shells info
C>       call use_integrals_in_some_way()
C>       if (more) goto 00001
C> \endcode
C> 
C> * end atom/shell loops
C> 
c:tex-\subsection{intb\_init4c}
c:tex-This logical function sets up the blocking integral API based on the
c:tex-input of a group of shell quartets (a block).  
c:tex-
c:tex-{\it Return Values:}
c:tex-\begin{tabular}{|c|p{60mm}|} \hline
c:tex- .true.  & blocking API initialization okay\\ \hline
c:tex- .false. & blocking API detected a problem \\ \hline
c:tex-\end{tabular}
c:tex-
c:tex-{\it Side Effects:}  The shell quartet information may be reordered
c:tex-since this routine pulls out blocks that consist of only $s$, $p$, 
c:tex-and $sp$ functions.  Thes blocks are computed using the $sp$ rotated
c:tex-axis code since it is faster than even the Texas integral code.
c:tex-
c:tex-The following code excerpt describes the proper use of the blocking
c:tex-API routines.\\
c:tex-{\it Pseudo Code:}
c:tex-\begin{verbatim}
c:tex-
c:tex-* begin atom/shell loops
c:tex-
c:tex-      call collect_group_of_shells()
c:tex-      okay = intb_init4c($\cdots$) ! with group of shells info     
c:tex-      if (.not.okay) stop ' error setting up blocking interface '
c:tex-00001 continue
c:tex-      more = intb_2e4c($\cdots$) ! with group of shells info
c:tex-      call use_integrals_in_some_way()
c:tex-      if (more) goto 00001
c:tex-
c:tex-* end atom/shell loops
c:tex-
c:tex-\end{verbatim}
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      logical function intb_init4c(brain, icl, jcl, ketin, kcl, lcl,
     &    num_q, q4, use_q4, lscr, scr, l_erilab, block_eff)
c:tex-\end{verbatim}
      implicit none
*
c
c blocking initialization routine for 2 electron 4 center integrals
c
*
c:tex-\begin{verbatim}
      integer brain      !< [Input] basis set handle for bra basis
      integer ketin      !< [Input] basis set handle for ket basis
      integer num_q      !< [Input] number of quartets
      integer icl(num_q) !< [Input] i-contraction labels for quartets
      integer jcl(num_q) !< [Input] j-contraction labels for quartets
      integer kcl(num_q) !< [Input] k-contraction labels for quartets
      integer lcl(num_q) !< [Input] l-contraction labels for quartets
      double precision q4(num_q) !< [Input] scaling factors
      logical use_q4            !< [Input] true if scaling
      integer l_erilab   !< [Input] size of eri and label arrays that 
                         !< will be used in `intb_2e4c`
      integer lscr       !< [Input] length of scratch array
      double precision scr(lscr)  !< [Input] scratch array
      double precision block_eff  !< [Output] blocking efficiency 
c:tex-\end{verbatim}
#include "mafdecls.fh"
#include "candoP.fh"
#include "numb_qP.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "bas_ibs_dec.fh"
#include "stdio.fh"
c
      logical status
c
      logical cando_txs
      external cando_txs
c
      integer iu, ju, ku, lu
      integer itype, jtype, ktype, ltype
      integer inprim, jnprim, knprim, lnprim
      integer ingen, jngen, kngen, lngen
      integer nprimtest
      integer iq, bra, ket
      double precision tmp
#include "bas_ibs_sfn.fh"
c
      num_q_start = 1           
      num_q_last  = -1
c
      more_ints_txs = .false. 
      intb_init4c = .true.
      block_eff = -1.0d00
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
c
c     The SP integrals are faster than texas for S and SP shells with
c     contraction of 3 or greater.  Select quartets which have only
c     S or SP shells of which all have contraction greater than or
c     equal to 3.  These shells are put onto the end of the list and
c     then evaluated first using the existing NW blocking interface.
c
#if (defined(SUN) || defined(SOLARIS))
c     scalar machines ... older SUNS use 1 ... ultra-2 wants 3
*      nprimtest = 1
      nprimtest = 3
#else 
c     pipelined/vector machines
      nprimtest = 3
#endif
      nsp = 0
      if (.not. (user_cando_sp.and.(.not.def_cando_sp))) then
         do 10 iq = 1, num_q
            iu = (sf_ibs_cn2ucn(icl(iq),bra))
            itype = infbs_cont(CONT_TYPE,  iu, bra)
            if (itype .gt. 0) goto 10
            inprim= infbs_cont(CONT_NPRIM, iu, bra)
            if (inprim .lt. nprimtest) goto 10
            ingen = infbs_cont(CONT_NGEN,  iu, bra)
            if (itype.eq.0 .and. ingen.gt.1) goto 10
c     
            ju = (sf_ibs_cn2ucn(jcl(iq),bra))
            jtype = infbs_cont(CONT_TYPE,  ju, bra)
            if (jtype .gt. 0) goto 10
            jnprim= infbs_cont(CONT_NPRIM, ju, bra)
            if (jnprim .lt. nprimtest) goto 10
            jngen = infbs_cont(CONT_NGEN,  ju, bra)
            if (jtype.eq.0 .and. jngen.gt.1) goto 10
c     
            ku = (sf_ibs_cn2ucn(kcl(iq),bra))
            ktype = infbs_cont(CONT_TYPE,  ku, ket)
            if (ktype .gt. 0) goto 10
            knprim= infbs_cont(CONT_NPRIM, ku, ket)
            if (knprim .lt. nprimtest) goto 10
            kngen = infbs_cont(CONT_NGEN,  ku, ket)
            if (ktype.eq.0 .and. kngen.gt.1) goto 10
c     
            lu = (sf_ibs_cn2ucn(lcl(iq),bra))
            ltype = infbs_cont(CONT_TYPE,  lu, ket)
            if (ltype .gt. 0) goto 10
            lnprim= infbs_cont(CONT_NPRIM, lu, ket)
            if (lnprim .lt. nprimtest) goto 10
            lngen = infbs_cont(CONT_NGEN,  lu, ket)
            if (ltype.eq.0 .and. lngen.gt.1) goto 10
c     
c     Now have a shell quartet that fits the criteria.  Swap to beginning
c     of the list
c     
            nsp = nsp + 1
            if (iq .ne. nsp) then
               iu       = icl(iq)
               ju       = jcl(iq)
               ku       = kcl(iq)
               lu       = lcl(iq)
               icl(iq)  = icl(nsp)
               jcl(iq)  = jcl(nsp)
               kcl(iq)  = kcl(nsp)
               lcl(iq)  = lcl(nsp)
               icl(nsp) = iu
               jcl(nsp) = ju
               kcl(nsp) = ku
               lcl(nsp) = lu
               if (use_q4) then
                  tmp     = q4(iq)
                  q4(iq)  = q4(nsp)
                  q4(nsp) = tmp
               endif
            endif
 10      enddo
#if defined(DEBUG_TXS)
         write(luout,*) ' num_q nsp ', num_q, nsp
#endif
      endif
c

*.... check shells for txs only after intb_init is called and established        
      txs_b2e4c = .true.
      status = .true.
*.... check first 20 quartets but every other one
      do iq = 1,min(20,num_q),2
        status = status.and. (cando_txs(brain,icl(iq),jcl(iq)))
        status = status.and. (cando_txs(ketin,kcl(iq),lcl(iq)))
        if (.not.status) then
          txs_b2e4c = .false.
          return
        endif
      enddo
      end
C> @}

C> \ingroup task
C> @{
C>
C> \brief A generic interface to save restart information
C>
C> Each module saves any files/database entries neccessary
C> to restart the calculation at its current point by appending the
C> given suffix to any names.
C>    
C> The exact (and perhaps only) application of this routine is in
C> computation of derivatives by finite difference.  The energy/gradient
C> is computed at a reference geometry (or zero field) and then
C> the wavefunction is saved by calling this routine.  Subsequent
C> calculations at displaced geometries (or non-zero fields) call
C> task_restore_state() in order to use the wavefunction at the
C> reference geometry as a starting guess for the calculation
C> at the displaced geometry.  Thus, there is no need to save basis
C> or geometry (or field) information.  E.g., in the SCF only the
C> MO vector file is saved.
C>
C> \return Return .true. if successfull, and .false. otherwise.
C>
      logical function task_save_state(rtdb,suffix)
*     
*     $Id: task_save_state.F 22850 2012-09-13 07:05:49Z d3y133 $
*     
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb              !< [Input] The RTDB handle
      character*(*) suffix      !< [Input] The file name suffix
c     
c     Each module saves any files/databse entries neccessary
c     to restart the calculation at its current point by appending the
c     given suffix to any names.
c     
c     The exact (and perhaps only) application of this routine is in
c     computation of derivatives by finite difference.  The energy/gradient
c     is computed at a reference geometry (or zero field) and then
c     the wavefunction is saved by calling this routine.  Subsequent
c     calculations at displaced geometries (or non-zero fields) call
c     task_restore_state() in order to use the wavefunction at the
c     reference geometry as a starting guess for the calculation
c     at the displaced geometry.  Thus, there is no need to save basis
c     or geometry (or field) information.  E.g., in the SCF only the
c     MO vector file is saved.
c     
c     Input argument ... the suffix
c     
c     RTDB arguments ... the theory name
c     
c     Output ... function value T/F on success/failure
c     
      logical status
      character*32 theory
      character*(nw_max_path_len) vectors, name, done(3)
      character*8 methods(3)
      logical oexist, oprint, odone
      integer nmethods, method, i
c     
      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $     call errquit('task_save_state: theory not specified',0,
     &       RTDB_ERR)
      oprint = util_print('task_save_state',print_default)
c     
      if (ga_nodeid() .eq. 0) then
         status = rtdb_parallel(.false.)
         if (oprint) then
            write(6,1) theory(1:inp_strlen(theory)), suffix
 1          format(/' Saving state for ',a, ' with suffix ', a)
            call util_flush(6)
         endif
c     
c     Save the MO vector file ... rather than trying to figure out
c     which theory generated the MO vectors just save all MO vectors
c     known by theories that generate MOs (currently SCF, DFT and MCSCF)
c     or the default name.  Also, don't complain if they are not there.
c     
         if ( inp_compare(.false.,'scf',theory) .or.
     $        inp_compare(.false.,'dft',theory) .or.
     $        inp_compare(.false.,'mcscf',theory) ) then
            nmethods = 1
            methods(1) = theory
         else
            nmethods = 3
            methods(1) = 'scf'
            methods(2) = 'dft'
            methods(3) = 'mcscf'
         end if
         do method = 1, nmethods
            write(name,'(a,'':input vectors'')') 
     $           methods(method)(1:inp_strlen(methods(method)))
            done(method) = ' ' 
            if (rtdb_cget(rtdb,name,1,vectors)) then
               call util_file_name_resolve(vectors, .false.)
               done(method) = vectors
               odone = .false.
               do i = 1, method-1
                  odone = odone .or. inp_compare(.true.,done(i),vectors)
               end do
               if (.not. odone) then
                  inquire(file=vectors,exist=oexist)
                  if (oexist) then
                     name = ' '
                     write(name,'(a,''.'',a)') 
     $                    vectors(1:inp_strlen(vectors)),
     $                    suffix(1:inp_strlen(suffix))
                     call util_file_name_resolve(name, .false.)
                     if (oprint) then
                        write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                        call util_flush(6)
                     endif
                     call util_file_copy(vectors, name)
                  end if
               end if
            end if
         end do
c     
c     Also do the default name
c     
         call util_file_name('movecs',.false.,.false.,vectors)
         call util_file_name_resolve(vectors, .false.)
         odone = .false.
         do i = 1, nmethods
            odone = odone .or. inp_compare(.true.,done(i),vectors)
         end do
         if (.not. odone) then
            inquire(file=vectors,exist=oexist)
            if (oexist) then
               name = ' '
               write(name,'(a,''.'',a)') 
     $              vectors(1:inp_strlen(vectors)),
     $              suffix(1:inp_strlen(suffix))
               call util_file_name_resolve(name, .false.)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
               call util_file_copy(vectors, name)
            end if
         end if
c     
c     Selci and MCSCF have CI vectors
c     
         if (theory.eq.'mcscf' .or. theory.eq.'selci') then
            call util_file_name('civec',.false.,.false.,vectors)
            inquire(file=vectors,exist=oexist)
            if (oexist) then
               name = ' '
               write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $              suffix(1:inp_strlen(suffix))
               call util_file_copy(vectors, name)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
            endif
         endif
c     
         if (theory(1:4).eq.'ccsd') then
c     
c     Also need to save the CCSD amplitudes
c     
            call util_file_name('t2',.false.,.false.,vectors)
            inquire(file=vectors,exist=oexist)
            if (oexist) then
               name = ' '
               write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $              suffix(1:inp_strlen(suffix))
               call util_file_copy(vectors, name)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
            endif
         endif
c     
         if (theory .eq. 'selci') then
c     
c     Also need to save the CI vectors, and ciconf file (moints?)
c     
            call util_file_name('civecs',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            call util_file_copy(vectors, name)
            if (oprint) then
               write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
               call util_flush(6)
            endif
c     
            call util_file_name('ciconf',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            call util_file_copy(vectors, name)
            if (oprint) then
               write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
               call util_flush(6)
            endif
         endif
c     
         if (oprint) then
            write(6,*)
            call util_flush(6)
         endif
         status = rtdb_parallel(.true.)
      endif
c     
      call ga_sync()
c     
      task_save_state = .true.
c     
      end
      logical function task_restore_state(rtdb,suffix)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "tcgmsg.fh"
      integer rtdb              ! [input]
      character*(*) suffix      ! [input]
c     
c     See comments in task_save_state
c     
      logical ignore, status
      character*32 theory
      character*(nw_max_path_len) vectors, name, done(3)
      character*8 methods(3)
      logical oexist, oprint, odone
      integer nmethods, method, i
c     
      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $     call errquit('task_restore_state: theory not specified',0,
     &       RTDB_ERR)
      oprint = util_print('task_restore_state',print_high)
c
      status = .true.           ! Set to false if there was nothing to restore
c     
      if (ga_nodeid() .eq. 0) then
         ignore = rtdb_parallel(.false.)
         if (oprint) then
            write(6,1) theory(1:inp_strlen(theory)), suffix
 1          format(/' Restoring state for ',a, ' with suffix ', a)
            call util_flush(6)
         endif
c     
c     Restore the MO vector file ... rather than trying to figure out
c     which theory generated the MO vectors just save all MO vectors
c     known by theories that generate MOs (currently SCF, DFT and MCSCF)
c     or the default name.  Also, don't complain if they are not there.
c     
         if ( inp_compare(.false.,'scf',theory) .or.
     $        inp_compare(.false.,'dft',theory) .or.
     $        inp_compare(.false.,'mcscf',theory) ) then
            nmethods = 1
            methods(1) = theory
         else
            nmethods = 3
            methods(1) = 'scf'
            methods(2) = 'dft'
            methods(3) = 'mcscf'
         end if
         do method = 1, nmethods
            write(name,'(a,'':input vectors'')') 
     $           methods(method)(1:inp_strlen(methods(method)))
            done(method) = ' ' 
            if (rtdb_cget(rtdb,name,1,vectors)) then
               call util_file_name_resolve(vectors, .false.)
               done(method) = vectors
               odone = .false.
               do i = 1, method-1
                  odone = odone .or. inp_compare(.true.,done(i),vectors)
               end do
               if (.not. odone) then
                  name = ' '
                  write(name,'(a,''.'',a)') 
     $                 vectors(1:inp_strlen(vectors)),
     $                 suffix(1:inp_strlen(suffix))
                  call util_file_name_resolve(name, .false.)
                  inquire(file=name,exist=oexist)
                  if (oexist) then
                     if (oprint) then
                        write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                        call util_flush(6)
                     endif
                     call util_file_copy(name, vectors)
                  end if
               end if
            end if
         end do
c     
c     Also do the default name
c     
         call util_file_name('movecs',.false.,.false.,vectors)
         call util_file_name_resolve(vectors, .false.)
         odone = .false.
         do i = 1, nmethods
            odone = odone .or. inp_compare(.true.,done(i),vectors)
         end do
         if (.not. odone) then
            name = ' '
            write(name,'(a,''.'',a)') 
     $           vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            call util_file_name_resolve(name, .false.)
            inquire(file=name,exist=oexist)
            if (oexist) then
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
               call util_file_copy(name, vectors)
            end if
         end if
c
         if (theory.eq.'mcscf' .or. theory.eq.'selci') then
c     
c     Also need to restore the CI vectors for MCSCF.  Don't know if
c     the selci used SCF or MCSCF so just copy the file if it exists.
c     
            call util_file_name('civec',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            inquire(file=name,exist=oexist)
            if (oexist) then
               call util_file_copy(name,vectors)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
            endif
         endif
c
         if (theory.eq.'ccsd' .or. theory.eq.'ccsd(t)'
     $        .or. theory.eq.'ccsd+t(ccsd)') then
c     
c     Also need to restore the CCSD amplitudes
c     
            call util_file_name('t2',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            inquire(file=name,exist=oexist)
            if (oexist) then
               call util_file_copy(name,vectors)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
            endif
         endif
c
         if (theory .eq. 'selci') then
c     
c     Also need to restore the CI vectors, and ciconf file (moints?)
c     
            call util_file_name('civecs',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            inquire(file=name,exist=oexist)
            if (oexist) then
               call util_file_copy(name, vectors)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
               call util_file_name('ciconf',.false.,.false.,vectors)
               name = ' '
               write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $              suffix(1:inp_strlen(suffix))
               call util_file_copy(name, vectors)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
            else
               if (oprint) write(6,*) name(1:inp_strlen(name)),
     $              ' does not exist'
               status = .false.
               goto 555
            endif
         endif
c
 555     if (oprint) then
            write(6,*)
            call util_flush(6)
         endif
         ignore = rtdb_parallel(.true.)
      endif
c     
      call ga_sync()
      call ga_brdcst(88, status, mitob(1), 0)
c     
      task_restore_state = status
c     
      end
      logical function task_delete_state(rtdb,suffix)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb              ! [input]
      character*(*) suffix      ! [input]
c     
c     See comments in task_save_state
c     
      logical status
      character*32 theory
      character*(nw_max_path_len) vectors, name
      logical oexist, oprint
c     
      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $     call errquit('task_delete_state: theory not specified',0,
     &       RTDB_ERR)
      oprint = util_print('task_delete_state',print_default)
c     
      if (ga_nodeid() .eq. 0) then
         status = rtdb_parallel(.false.)
         if (oprint) then
            write(6,1) theory(1:inp_strlen(theory)), suffix
 1          format(/' Deleting state for ',a, ' with suffix ', a)
            call util_flush(6)
         endif
c     
c     Get original name from the database entry "theory:vectors <suffix>"
c     or use the default if this is not present
c     
         name = ' '
         write(name,'(a,'':vectors '',a)') 
     $        theory(1:inp_strlen(theory)),
     $        suffix(1:inp_strlen(suffix))
         if (rtdb_cget(rtdb,name,1,vectors)) then
c     Delete the database entry
            if (.not. rtdb_delete(rtdb, name)) call errquit
     $           ('task_delete_state: rtdb corrupt',0, RTDB_ERR)
         else
            call util_file_name('movecs',.false.,.false.,vectors)
         endif
c     
c     Now delete the backup file
c     
         name = ' '
         write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $        suffix(1:inp_strlen(suffix))
         call util_file_unlink(name)
c     
         if (oprint) then
            write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
            call util_flush(6)
         endif
c     
         if (theory.eq.'mcscf' .or. theory.eq.'selci') then
c     
c     Delete the MCSCF CI vectors
c     
            call util_file_name('civec',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            inquire(file=name,exist=oexist)
            if (oexist) then
               call util_file_unlink(name)
               if (oprint) then
                  write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
                  call util_flush(6)
               endif
            endif
         endif
c
         if (theory .eq. 'selci') then
c     
c     Delete the selected ci files ciconf and civecs
c     
            call util_file_name('civecs',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            call util_file_unlink(name)
            if (oprint) then
               write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
               call util_flush(6)
            endif
c
            call util_file_name('ciconf',.false.,.false.,vectors)
            name = ' '
            write(name,'(a,''.'',a)') vectors(1:inp_strlen(vectors)),
     $           suffix(1:inp_strlen(suffix))
            call util_file_unlink(name)
            if (oprint) then
               write(6,'(8x,a)') vectors(1:inp_strlen(vectors))
               call util_flush(6)
            endif
         endif
c     
         if (oprint) then
            write(6,*)
            call util_flush(6)
         endif
         status = rtdb_parallel(.true.)
      endif
c     
      call ga_sync()
c     
      task_delete_state = .true.
c     
      end
C> @}

c $Id: dgami.f 24349 2013-06-23 04:30:58Z d3y133 $
*DECK D9GMIT
      DOUBLE PRECISION FUNCTION D9GMIT (A, X, ALGAP1, SGNGAM, ALX)
C***BEGIN PROLOGUE  D9GMIT
C***SUBSIDIARY
C***PURPOSE  Compute Tricomi's incomplete Gamma function for small
C            arguments.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      DOUBLE PRECISION (R9GMIT-S, D9GMIT-D)
C***KEYWORDS  COMPLEMENTARY INCOMPLETE GAMMA FUNCTION, FNLIB, SMALL X,
C             SPECIAL FUNCTIONS, TRICOMI
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Compute Tricomi's incomplete gamma function for small X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DLNGAM, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900720  Routine changed from user-callable to subsidiary.  (WRB)
C***END PROLOGUE  D9GMIT
      DOUBLE PRECISION A, X, ALGAP1, SGNGAM, ALX, AE, AEPS, ALGS, ALG2,
     1  BOT, EPS, FK, S, SGNG2, T, TE, D1MACH, DLNGAM
      LOGICAL FIRST
      SAVE EPS, BOT, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  D9GMIT
      IF (FIRST) THEN
         EPS = 0.5D0*D1MACH(3)
         BOT = LOG (D1MACH(1))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. 0.D0) CALL XERMSG ('SLATEC', 'D9GMIT',
     +   'X SHOULD BE GT 0', 1, 2)
C
      MA = A + 0.5D0
      IF (A.LT.0.D0) MA = A - 0.5D0
      AEPS = A - MA
C
      AE = A
      IF (A.LT.(-0.5D0)) AE = AEPS
C
      T = 1.D0
      TE = AE
      S = T
      DO 20 K=1,200
        FK = K
        TE = -X*TE/FK
        T = TE/(AE+FK)
        S = S + T
        IF (ABS(T).LT.EPS*ABS(S)) GO TO 30
 20   CONTINUE
      CALL XERMSG ('SLATEC', 'D9GMIT',
     +   'NO CONVERGENCE IN 200 TERMS OF TAYLOR-S SERIES', 2, 2)
C
 30   IF (A.GE.(-0.5D0)) ALGS = -ALGAP1 + LOG(S)
      IF (A.GE.(-0.5D0)) GO TO 60
C
      ALGS = -DLNGAM(1.D0+AEPS) + LOG(S)
      S = 1.0D0
      M = -MA - 1
      IF (M.EQ.0) GO TO 50
      T = 1.0D0
      DO 40 K=1,M
        T = X*T/(AEPS-(M+1-K))
        S = S + T
        IF (ABS(T).LT.EPS*ABS(S)) GO TO 50
 40   CONTINUE
C
 50   D9GMIT = 0.0D0
      ALGS = -MA*LOG(X) + ALGS
      IF (S.EQ.0.D0 .OR. AEPS.EQ.0.D0) GO TO 60
C
      SGNG2 = SGNGAM * SIGN (1.0D0, S)
      ALG2 = -X - ALGAP1 + LOG(ABS(S))
C
      IF (ALG2.GT.BOT) D9GMIT = SGNG2 * EXP(ALG2)
      IF (ALGS.GT.BOT) D9GMIT = D9GMIT + EXP(ALGS)
      RETURN
C
 60   D9GMIT = EXP (ALGS)
      RETURN
C
      END
*DECK D9LGIC
      DOUBLE PRECISION FUNCTION D9LGIC (A, X, ALX)
C***BEGIN PROLOGUE  D9LGIC
C***SUBSIDIARY
C***PURPOSE  Compute the log complementary incomplete Gamma function
C            for large X and for A .LE. X.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      DOUBLE PRECISION (R9LGIC-S, D9LGIC-D)
C***KEYWORDS  COMPLEMENTARY INCOMPLETE GAMMA FUNCTION, FNLIB, LARGE X,
C             LOGARITHM, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Compute the log complementary incomplete gamma function for large X
C and for A .LE. X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900720  Routine changed from user-callable to subsidiary.  (WRB)
C***END PROLOGUE  D9LGIC
      DOUBLE PRECISION A, X, ALX, EPS, FK, P, R, S, T, XMA, XPA, D1MACH
      SAVE EPS
      DATA EPS / 0.D0 /
C***FIRST EXECUTABLE STATEMENT  D9LGIC
      IF (EPS.EQ.0.D0) EPS = 0.5D0*D1MACH(3)
C
      XPA = X + 1.0D0 - A
      XMA = X - 1.D0 - A
C
      R = 0.D0
      P = 1.D0
      S = P
      DO 10 K=1,300
        FK = K
        T = FK*(A-FK)*(1.D0+R)
        R = -T/((XMA+2.D0*FK)*(XPA+2.D0*FK)+T)
        P = R*P
        S = S + P
        IF (ABS(P).LT.EPS*S) GO TO 20
 10   CONTINUE
      CALL XERMSG ('SLATEC', 'D9LGIC',
     +   'NO CONVERGENCE IN 300 TERMS OF CONTINUED FRACTION', 1, 2)
C
 20   D9LGIC = A*ALX - X + LOG(S/XPA)
C
      RETURN
      END
*DECK D9LGIT
      DOUBLE PRECISION FUNCTION D9LGIT (A, X, ALGAP1)
C***BEGIN PROLOGUE  D9LGIT
C***SUBSIDIARY
C***PURPOSE  Compute the logarithm of Tricomi's incomplete Gamma
C            function with Perron's continued fraction for large X and
C            A .GE. X.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      DOUBLE PRECISION (R9LGIT-S, D9LGIT-D)
C***KEYWORDS  FNLIB, INCOMPLETE GAMMA FUNCTION, LOGARITHM,
C             PERRON'S CONTINUED FRACTION, SPECIAL FUNCTIONS, TRICOMI
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Compute the log of Tricomi's incomplete gamma function with Perron's
C continued fraction for large X and for A .GE. X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900720  Routine changed from user-callable to subsidiary.  (WRB)
C***END PROLOGUE  D9LGIT
      DOUBLE PRECISION A, X, ALGAP1, AX, A1X, EPS, FK, HSTAR, P, R, S,
     1  SQEPS, T, D1MACH
      LOGICAL FIRST
      SAVE EPS, SQEPS, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  D9LGIT
      IF (FIRST) THEN
         EPS = 0.5D0*D1MACH(3)
         SQEPS = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LE. 0.D0 .OR. A .LT. X) CALL XERMSG ('SLATEC', 'D9LGIT',
     +   'X SHOULD BE GT 0.0 AND LE A', 2, 2)
C
      AX = A + X
      A1X = AX + 1.0D0
      R = 0.D0
      P = 1.D0
      S = P
      DO 20 K=1,200
        FK = K
        T = (A+FK)*X*(1.D0+R)
        R = T/((AX+FK)*(A1X+FK)-T)
        P = R*P
        S = S + P
        IF (ABS(P).LT.EPS*S) GO TO 30
 20   CONTINUE
      CALL XERMSG ('SLATEC', 'D9LGIT',
     +   'NO CONVERGENCE IN 200 TERMS OF CONTINUED FRACTION', 3, 2)
C
 30   HSTAR = 1.0D0 - X*S/A1X
      IF (HSTAR .LT. SQEPS) CALL XERMSG ('SLATEC', 'D9LGIT',
     +   'RESULT LESS THAN HALF PRECISION', 1, 1)
C
      D9LGIT = -X - ALGAP1 - LOG(HSTAR)
      RETURN
C
      END
*DECK D9LGMC
      DOUBLE PRECISION FUNCTION D9LGMC (X)
C***BEGIN PROLOGUE  D9LGMC
C***SUBSIDIARY
C***PURPOSE  Compute the log Gamma correction factor so that
C            LOG(DGAMMA(X)) = LOG(SQRT(2*PI)) + (X-5.)*LOG(X) - X
C            + D9LGMC(X).
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      DOUBLE PRECISION (R9LGMC-S, D9LGMC-D, C9LGMC-C)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, CORRECTION TERM, FNLIB,
C             LOG GAMMA, LOGARITHM, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Compute the log gamma correction factor for X .GE. 10. so that
C LOG (DGAMMA(X)) = LOG(SQRT(2*PI)) + (X-.5)*LOG(X) - X + D9lGMC(X)
C
C Series for ALGM       on the interval  0.          to  1.00000E-02
C                                        with weighted error   1.28E-31
C                                         log weighted error  30.89
C                               significant figures required  29.81
C                                    decimal places required  31.48
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DCSEVL, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900720  Routine changed from user-callable to subsidiary.  (WRB)
C***END PROLOGUE  D9LGMC
      DOUBLE PRECISION X, ALGMCS(15), XBIG, XMAX, DCSEVL, D1MACH
      LOGICAL FIRST
      SAVE ALGMCS, NALGM, XBIG, XMAX, FIRST
      DATA ALGMCS(  1) / +.1666389480 4518632472 0572965082 2 D+0      /
      DATA ALGMCS(  2) / -.1384948176 0675638407 3298605913 5 D-4      /
      DATA ALGMCS(  3) / +.9810825646 9247294261 5717154748 7 D-8      /
      DATA ALGMCS(  4) / -.1809129475 5724941942 6330626671 9 D-10     /
      DATA ALGMCS(  5) / +.6221098041 8926052271 2601554341 6 D-13     /
      DATA ALGMCS(  6) / -.3399615005 4177219443 0333059966 6 D-15     /
      DATA ALGMCS(  7) / +.2683181998 4826987489 5753884666 6 D-17     /
      DATA ALGMCS(  8) / -.2868042435 3346432841 4462239999 9 D-19     /
      DATA ALGMCS(  9) / +.3962837061 0464348036 7930666666 6 D-21     /
      DATA ALGMCS( 10) / -.6831888753 9857668701 1199999999 9 D-23     /
      DATA ALGMCS( 11) / +.1429227355 9424981475 7333333333 3 D-24     /
      DATA ALGMCS( 12) / -.3547598158 1010705471 9999999999 9 D-26     /
      DATA ALGMCS( 13) / +.1025680058 0104709120 0000000000 0 D-27     /
      DATA ALGMCS( 14) / -.3401102254 3167487999 9999999999 9 D-29     /
      DATA ALGMCS( 15) / +.1276642195 6300629333 3333333333 3 D-30     /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  D9LGMC
      IF (FIRST) THEN
         NALGM = INITDS (ALGMCS, 15, REAL(D1MACH(3)) )
         XBIG = 1.0D0/SQRT(D1MACH(3))
         XMAX = EXP (MIN(LOG(D1MACH(2)/12.D0), -LOG(12.D0*D1MACH(1))))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LT. 10.D0) CALL XERMSG ('SLATEC', 'D9LGMC',
     +   'X MUST BE GE 10', 1, 2)
      IF (X.GE.XMAX) GO TO 20
C
      D9LGMC = 1.D0/(12.D0*X)
      IF (X.LT.XBIG) D9LGMC = DCSEVL (2.0D0*(10.D0/X)**2-1.D0, ALGMCS,
     1  NALGM) / X
      RETURN
C
 20   D9LGMC = 0.D0
      CALL XERMSG ('SLATEC', 'D9LGMC', 'X SO BIG D9LGMC UNDERFLOWS', 2,
     +   1)
      RETURN
C
      END
*DECK DCSEVL
      DOUBLE PRECISION FUNCTION DCSEVL (X, CS, N)
C***BEGIN PROLOGUE  DCSEVL
C***PURPOSE  Evaluate a Chebyshev series.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C3A2
C***TYPE      DOUBLE PRECISION (CSEVL-S, DCSEVL-D)
C***KEYWORDS  CHEBYSHEV SERIES, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C  Evaluate the N-term Chebyshev series CS at X.  Adapted from
C  a method presented in the paper by Broucke referenced below.
C
C       Input Arguments --
C  X    value at which the series is to be evaluated.
C  CS   array of N terms of a Chebyshev series.  In evaluating
C       CS, only half the first coefficient is summed.
C  N    number of terms in array CS.
C
C***REFERENCES  R. Broucke, Ten subroutines for the manipulation of
C                 Chebyshev series, Algorithm 446, Communications of
C                 the A.C.M. 16, (1973) pp. 254-256.
C               L. Fox and I. B. Parker, Chebyshev Polynomials in
C                 Numerical Analysis, Oxford University Press, 1968,
C                 page 56.
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770401  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900329  Prologued revised extensively and code rewritten to allow
C           X to be slightly outside interval (-1,+1).  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DCSEVL
      DOUBLE PRECISION B0, B1, B2, CS(*), ONEPL, TWOX, X, D1MACH
      LOGICAL FIRST
      SAVE FIRST, ONEPL
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DCSEVL
      IF (FIRST) ONEPL = 1.0D0 + D1MACH(4)
      FIRST = .FALSE.
      IF (N .LT. 1) CALL XERMSG ('SLATEC', 'DCSEVL',
     +   'NUMBER OF TERMS .LE. 0', 2, 2)
      IF (N .GT. 1000) CALL XERMSG ('SLATEC', 'DCSEVL',
     +   'NUMBER OF TERMS .GT. 1000', 3, 2)
      IF (ABS(X) .GT. ONEPL) CALL XERMSG ('SLATEC', 'DCSEVL',
     +   'X OUTSIDE THE INTERVAL (-1,+1)', 1, 1)
C
      B1 = 0.0D0
      B0 = 0.0D0
      TWOX = 2.0D0*X
      DO 10 I = 1,N
         B2 = B1
         B1 = B0
         NI = N + 1 - I
         B0 = TWOX*B1 - B2 + CS(NI)
   10 CONTINUE
C
      DCSEVL = 0.5D0*(B0-B2)
C
      RETURN
      END
*DECK DGAMI
      DOUBLE PRECISION FUNCTION DGAMI (A, X)
C***BEGIN PROLOGUE  DGAMI
C***PURPOSE  Evaluate the incomplete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      DOUBLE PRECISION (GAMI-S, DGAMI-D)
C***KEYWORDS  FNLIB, INCOMPLETE GAMMA FUNCTION, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Evaluate the incomplete gamma function defined by
C
C DGAMI = integral from T = 0 to X of EXP(-T) * T**(A-1.0) .
C
C DGAMI is evaluated for positive values of A and non-negative values
C of X.  A slight deterioration of 2 or 3 digits accuracy will occur
C when DGAMI is very large or very small, because logarithmic variables
C are used.  The function and both arguments are double precision.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DGAMIT, DLNGAM, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DGAMI
      DOUBLE PRECISION A, X, FACTOR, DLNGAM, DGAMIT
C***FIRST EXECUTABLE STATEMENT  DGAMI
      IF (A .LE. 0.D0) CALL XERMSG ('SLATEC', 'DGAMI',
     +   'A MUST BE GT ZERO', 1, 2)
      IF (X .LT. 0.D0) CALL XERMSG ('SLATEC', 'DGAMI',
     +   'X MUST BE GE ZERO', 2, 2)
C
      DGAMI = 0.D0
      IF (X.EQ.0.0D0) RETURN
C
C THE ONLY ERROR POSSIBLE IN THE EXPRESSION BELOW IS A FATAL OVERFLOW.
      FACTOR = EXP (DLNGAM(A) + A*LOG(X))
C
      DGAMI = FACTOR * DGAMIT (A, X)
C
      RETURN
      END
*DECK DGAMIT
      DOUBLE PRECISION FUNCTION DGAMIT (A, X)
C***BEGIN PROLOGUE  DGAMIT
C***PURPOSE  Calculate Tricomi's form of the incomplete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7E
C***TYPE      DOUBLE PRECISION (GAMIT-S, DGAMIT-D)
C***KEYWORDS  COMPLEMENTARY INCOMPLETE GAMMA FUNCTION, FNLIB,
C             SPECIAL FUNCTIONS, TRICOMI
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C   Evaluate Tricomi's incomplete Gamma function defined by
C
C   DGAMIT = X**(-A)/GAMMA(A) * integral from 0 to X of EXP(-T) *
C              T**(A-1.)
C
C   for A .GT. 0.0 and by analytic continuation for A .LE. 0.0.
C   GAMMA(X) is the complete gamma function of X.
C
C   DGAMIT is evaluated for arbitrary real values of A and for non-
C   negative values of X (even though DGAMIT is defined for X .LT.
C   0.0), except that for X = 0 and A .LE. 0.0, DGAMIT is infinite,
C   which is a fatal error.
C
C   The function and both arguments are DOUBLE PRECISION.
C
C   A slight deterioration of 2 or 3 digits accuracy will occur when
C   DGAMIT is very large or very small in absolute value, because log-
C   arithmic variables are used.  Also, if the parameter  A  is very
C   close to a negative integer (but not a negative integer), there is
C   a loss of accuracy, which is reported if the result is less than
C   half machine precision.
C
C***REFERENCES  W. Gautschi, A computational procedure for incomplete
C                 gamma functions, ACM Transactions on Mathematical
C                 Software 5, 4 (December 1979), pp. 466-481.
C               W. Gautschi, Incomplete gamma functions, Algorithm 542,
C                 ACM Transactions on Mathematical Software 5, 4
C                 (December 1979), pp. 482-489.
C***ROUTINES CALLED  D1MACH, D9GMIT, D9LGIC, D9LGIT, DGAMR, DLGAMS,
C                    DLNGAM, XERCLR, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920528  DESCRIPTION and REFERENCES sections revised.  (WRB)
C***END PROLOGUE  DGAMIT
      DOUBLE PRECISION A, X, AEPS, AINTA, ALGAP1, ALNEPS, ALNG, ALX,
     1  BOT, H, SGA, SGNGAM, SQEPS, T, D1MACH, DGAMR, D9GMIT, D9LGIT,
     2  DLNGAM, D9LGIC
      LOGICAL FIRST
      SAVE ALNEPS, SQEPS, BOT, FIRST
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DGAMIT
      IF (FIRST) THEN
         ALNEPS = -LOG (D1MACH(3))
         SQEPS = SQRT(D1MACH(4))
         BOT = LOG (D1MACH(1))
      ENDIF
      FIRST = .FALSE.
C
      IF (X .LT. 0.D0) CALL XERMSG ('SLATEC', 'DGAMIT', 'X IS NEGATIVE'
     +   , 2, 2)
C
      IF (X.NE.0.D0) ALX = LOG (X)
      SGA = 1.0D0
      IF (A.NE.0.D0) SGA = SIGN (1.0D0, A)
      AINTA = AINT (A + 0.5D0*SGA)
      AEPS = A - AINTA
C
      IF (X.GT.0.D0) GO TO 20
      DGAMIT = 0.0D0
      IF (AINTA.GT.0.D0 .OR. AEPS.NE.0.D0) DGAMIT = DGAMR(A+1.0D0)
      RETURN
C
 20   IF (X.GT.1.D0) GO TO 30
      IF (A.GE.(-0.5D0) .OR. AEPS.NE.0.D0) CALL DLGAMS (A+1.0D0, ALGAP1,
     1  SGNGAM)
      DGAMIT = D9GMIT (A, X, ALGAP1, SGNGAM, ALX)
      RETURN
C
 30   IF (A.LT.X) GO TO 40
      T = D9LGIT (A, X, DLNGAM(A+1.0D0))
      IF (T.LT.BOT) CALL XERCLR
      DGAMIT = EXP (T)
      RETURN
C
 40   ALNG = D9LGIC (A, X, ALX)
C
C EVALUATE DGAMIT IN TERMS OF LOG (DGAMIC (A, X))
C
      H = 1.0D0
      IF (AEPS.EQ.0.D0 .AND. AINTA.LE.0.D0) GO TO 50
C
      CALL DLGAMS (A+1.0D0, ALGAP1, SGNGAM)
      T = LOG (ABS(A)) + ALNG - ALGAP1
      IF (T.GT.ALNEPS) GO TO 60
C
      IF (T.GT.(-ALNEPS)) H = 1.0D0 - SGA * SGNGAM * EXP(T)
      IF (ABS(H).GT.SQEPS) GO TO 50
C
      CALL XERCLR
      CALL XERMSG ('SLATEC', 'DGAMIT', 'RESULT LT HALF PRECISION', 1,
     +   1)
C
 50   T = -A*ALX + LOG(ABS(H))
      IF (T.LT.BOT) CALL XERCLR
      DGAMIT = SIGN (EXP(T), H)
      RETURN
C
 60   T = T - A*ALX
      IF (T.LT.BOT) CALL XERCLR
      DGAMIT = -SGA * SGNGAM * EXP(T)
      RETURN
C
      END
*DECK DGAMLM
      SUBROUTINE DGAMLM (XMIN, XMAX)
C***BEGIN PROLOGUE  DGAMLM
C***PURPOSE  Compute the minimum and maximum bounds for the argument in
C            the Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A, R2
C***TYPE      DOUBLE PRECISION (GAMLIM-S, DGAMLM-D)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, LIMITS, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C Calculate the minimum and maximum legal bounds for X in gamma(X).
C XMIN and XMAX are not the only bounds, but they are the only non-
C trivial ones to calculate.
C
C             Output Arguments --
C XMIN   double precision minimum legal value of X in gamma(X).  Any
C        smaller value of X might result in underflow.
C XMAX   double precision maximum legal value of X in gamma(X).  Any
C        larger value of X might cause overflow.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  DGAMLM
      DOUBLE PRECISION XMIN, XMAX, ALNBIG, ALNSML, XLN, XOLD, D1MACH
C***FIRST EXECUTABLE STATEMENT  DGAMLM
      ALNSML = LOG(D1MACH(1))
      XMIN = -ALNSML
      DO 10 I=1,10
        XOLD = XMIN
        XLN = LOG(XMIN)
        XMIN = XMIN - XMIN*((XMIN+0.5D0)*XLN - XMIN - 0.2258D0 + ALNSML)
     1    / (XMIN*XLN+0.5D0)
        IF (ABS(XMIN-XOLD).LT.0.005D0) GO TO 20
 10   CONTINUE
      CALL XERMSG ('SLATEC', 'DGAMLM', 'UNABLE TO FIND XMIN', 1, 2)
C
 20   XMIN = -XMIN + 0.01D0
C
      ALNBIG = LOG (D1MACH(2))
      XMAX = ALNBIG
      DO 30 I=1,10
        XOLD = XMAX
        XLN = LOG(XMAX)
        XMAX = XMAX - XMAX*((XMAX-0.5D0)*XLN - XMAX + 0.9189D0 - ALNBIG)
     1    / (XMAX*XLN-0.5D0)
        IF (ABS(XMAX-XOLD).LT.0.005D0) GO TO 40
 30   CONTINUE
      CALL XERMSG ('SLATEC', 'DGAMLM', 'UNABLE TO FIND XMAX', 2, 2)
C
 40   XMAX = XMAX - 0.01D0
      XMIN = MAX (XMIN, -XMAX+1.D0)
C
      RETURN
      END
*DECK UTIL_DGAMMA
      DOUBLE PRECISION FUNCTION UTIL_DGAMMA (X)
C***BEGIN PROLOGUE  UTIL_DGAMMA
C***PURPOSE  Compute the complete Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (GAMMA-S, DGAMMA-D, CGAMMA-C)
C***KEYWORDS  COMPLETE GAMMA FUNCTION, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C UTIL_DGAMMA(X) calculates the double precision complete Gamma function
C for double precision argument X.
C
C Series for GAM        on the interval  0.          to  1.00000E+00
C                                        with weighted error   5.79E-32
C                                         log weighted error  31.24
C                               significant figures required  30.00
C                                    decimal places required  32.05
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMC, DCSEVL, DGAMLM, INITDS, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920618  Removed space from variable name.  (RWC, WRB)
C***END PROLOGUE  UTIL_DGAMMA
      DOUBLE PRECISION X, GAMCS(42), DXREL, PI, SINPIY, SQ2PIL, XMAX,
     1  XMIN, Y, D9LGMC, DCSEVL, D1MACH
      LOGICAL FIRST
C
      SAVE GAMCS, PI, SQ2PIL, NGAM, XMIN, XMAX, DXREL, FIRST
      DATA GAMCS(  1) / +.8571195590 9893314219 2006239994 2 D-2      /
      DATA GAMCS(  2) / +.4415381324 8410067571 9131577165 2 D-2      /
      DATA GAMCS(  3) / +.5685043681 5993633786 3266458878 9 D-1      /
      DATA GAMCS(  4) / -.4219835396 4185605010 1250018662 4 D-2      /
      DATA GAMCS(  5) / +.1326808181 2124602205 8400679635 2 D-2      /
      DATA GAMCS(  6) / -.1893024529 7988804325 2394702388 6 D-3      /
      DATA GAMCS(  7) / +.3606925327 4412452565 7808221722 5 D-4      /
      DATA GAMCS(  8) / -.6056761904 4608642184 8554829036 5 D-5      /
      DATA GAMCS(  9) / +.1055829546 3022833447 3182350909 3 D-5      /
      DATA GAMCS( 10) / -.1811967365 5423840482 9185589116 6 D-6      /
      DATA GAMCS( 11) / +.3117724964 7153222777 9025459316 9 D-7      /
      DATA GAMCS( 12) / -.5354219639 0196871408 7408102434 7 D-8      /
      DATA GAMCS( 13) / +.9193275519 8595889468 8778682594 0 D-9      /
      DATA GAMCS( 14) / -.1577941280 2883397617 6742327395 3 D-9      /
      DATA GAMCS( 15) / +.2707980622 9349545432 6654043308 9 D-10     /
      DATA GAMCS( 16) / -.4646818653 8257301440 8166105893 3 D-11     /
      DATA GAMCS( 17) / +.7973350192 0074196564 6076717535 9 D-12     /
      DATA GAMCS( 18) / -.1368078209 8309160257 9949917230 9 D-12     /
      DATA GAMCS( 19) / +.2347319486 5638006572 3347177168 8 D-13     /
      DATA GAMCS( 20) / -.4027432614 9490669327 6657053469 9 D-14     /
      DATA GAMCS( 21) / +.6910051747 3721009121 3833697525 7 D-15     /
      DATA GAMCS( 22) / -.1185584500 2219929070 5238712619 2 D-15     /
      DATA GAMCS( 23) / +.2034148542 4963739552 0102605193 2 D-16     /
      DATA GAMCS( 24) / -.3490054341 7174058492 7401294910 8 D-17     /
      DATA GAMCS( 25) / +.5987993856 4853055671 3505106602 6 D-18     /
      DATA GAMCS( 26) / -.1027378057 8722280744 9006977843 1 D-18     /
      DATA GAMCS( 27) / +.1762702816 0605298249 4275966074 8 D-19     /
      DATA GAMCS( 28) / -.3024320653 7353062609 5877211204 2 D-20     /
      DATA GAMCS( 29) / +.5188914660 2183978397 1783355050 6 D-21     /
      DATA GAMCS( 30) / -.8902770842 4565766924 4925160106 6 D-22     /
      DATA GAMCS( 31) / +.1527474068 4933426022 7459689130 6 D-22     /
      DATA GAMCS( 32) / -.2620731256 1873629002 5732833279 9 D-23     /
      DATA GAMCS( 33) / +.4496464047 8305386703 3104657066 6 D-24     /
      DATA GAMCS( 34) / -.7714712731 3368779117 0390152533 3 D-25     /
      DATA GAMCS( 35) / +.1323635453 1260440364 8657271466 6 D-25     /
      DATA GAMCS( 36) / -.2270999412 9429288167 0231381333 3 D-26     /
      DATA GAMCS( 37) / +.3896418998 0039914493 2081663999 9 D-27     /
      DATA GAMCS( 38) / -.6685198115 1259533277 9212799999 9 D-28     /
      DATA GAMCS( 39) / +.1146998663 1400243843 4761386666 6 D-28     /
      DATA GAMCS( 40) / -.1967938586 3451346772 9510399999 9 D-29     /
      DATA GAMCS( 41) / +.3376448816 5853380903 3489066666 6 D-30     /
      DATA GAMCS( 42) / -.5793070335 7821357846 2549333333 3 D-31     /
      DATA PI / 3.1415926535 8979323846 2643383279 50 D0 /
      DATA SQ2PIL / 0.9189385332 0467274178 0329736405 62 D0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  UTIL_DGAMMA
      IF (FIRST) THEN
         NGAM = INITDS (GAMCS, 42, 0.1*REAL(D1MACH(3)) )
C
         CALL DGAMLM (XMIN, XMAX)
         DXREL = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS(X)
      IF (Y.GT.10.D0) GO TO 50
C
C COMPUTE GAMMA(X) FOR -XBND .LE. X .LE. XBND.  REDUCE INTERVAL AND FIND
C GAMMA(1+Y) FOR 0.0 .LE. Y .LT. 1.0 FIRST OF ALL.
C
      N = X
      IF (X.LT.0.D0) N = N - 1
      Y = X - N
      N = N - 1
      UTIL_DGAMMA = 0.9375D0 + DCSEVL (2.D0*Y-1.D0, GAMCS, NGAM)
      IF (N.EQ.0) RETURN
C
      IF (N.GT.0) GO TO 30
C
C COMPUTE GAMMA(X) FOR X .LT. 1.0
C
      N = -N
      IF (X .EQ. 0.D0) CALL XERMSG ('SLATEC', 'DGAMMA', 'X IS 0', 4, 2)
      IF (X .LT. 0.0 .AND. X+N-2 .EQ. 0.D0) CALL XERMSG ('SLATEC',
     +   'DGAMMA', 'X IS A NEGATIVE INTEGER', 4, 2)
      IF (X .LT. (-0.5D0) .AND. ABS((X-AINT(X-0.5D0))/X) .LT. DXREL)
     +   CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DO 20 I=1,N
        UTIL_DGAMMA = UTIL_DGAMMA/(X+I-1 )
 20   CONTINUE
      RETURN
C
C GAMMA(X) FOR X .GE. 2.0 AND X .LE. 10.0
C
 30   DO 40 I=1,N
        UTIL_DGAMMA = (Y+I) * UTIL_DGAMMA
 40   CONTINUE
      RETURN
C
C GAMMA(X) FOR ABS(X) .GT. 10.0.  RECALL Y = ABS(X).
C
 50   IF (X .GT. XMAX) CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'X SO BIG GAMMA OVERFLOWS', 3, 2)
C
      UTIL_DGAMMA = 0.D0
      IF (X .LT. XMIN) CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'X SO SMALL GAMMA UNDERFLOWS', 2, 1)
      IF (X.LT.XMIN) RETURN
C
      UTIL_DGAMMA = EXP ((Y-0.5D0)*LOG(Y) - Y + SQ2PIL + D9LGMC(Y) )
      IF (X.GT.0.D0) RETURN
C
      IF (ABS((X-AINT(X-0.5D0))/X) .LT. DXREL) CALL XERMSG ('SLATEC',
     +   'DGAMMA',
     +   'ANSWER LT HALF PRECISION, X TOO NEAR NEGATIVE INTEGER', 1, 1)
C
      SINPIY = SIN (PI*Y)
      IF (SINPIY .EQ. 0.D0) CALL XERMSG ('SLATEC', 'DGAMMA',
     +   'X IS A NEGATIVE INTEGER', 4, 2)
C
      UTIL_DGAMMA = -PI/(Y*SINPIY*UTIL_DGAMMA)
C
      RETURN
      END
*DECK DGAMR
      DOUBLE PRECISION FUNCTION DGAMR (X)
C***BEGIN PROLOGUE  DGAMR
C***PURPOSE  Compute the reciprocal of the Gamma function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (GAMR-S, DGAMR-D, CGAMR-C)
C***KEYWORDS  FNLIB, RECIPROCAL GAMMA FUNCTION, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DGAMR(X) calculates the double precision reciprocal of the
C complete Gamma function for double precision argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DGAMMA, DLGAMS, XERCLR, XGETF, XSETF
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DGAMR
      DOUBLE PRECISION X, ALNGX, SGNGX, UTIL_DGAMMA
      EXTERNAL UTIL_DGAMMA
C***FIRST EXECUTABLE STATEMENT  DGAMR
      DGAMR = 0.0D0
      IF (X.LE.0.0D0 .AND. AINT(X).EQ.X) RETURN
C
      CALL XGETF (IROLD)
      CALL XSETF (1)
      IF (ABS(X).GT.10.0D0) GO TO 10
      DGAMR = 1.0D0/UTIL_DGAMMA(X)
      CALL XERCLR
      CALL XSETF (IROLD)
      RETURN
C
 10   CALL DLGAMS (X, ALNGX, SGNGX)
      CALL XERCLR
      CALL XSETF (IROLD)
      DGAMR = SGNGX * EXP(-ALNGX)
      RETURN
C
      END
*DECK DLGAMS
      SUBROUTINE DLGAMS (X, DLGAM, SGNGAM)
C***BEGIN PROLOGUE  DLGAMS
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (ALGAMS-S, DLGAMS-D)
C***KEYWORDS  ABSOLUTE VALUE OF THE LOGARITHM OF THE GAMMA FUNCTION,
C             FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLGAMS(X,DLGAM,SGNGAM) calculates the double precision natural
C logarithm of the absolute value of the Gamma function for
C double precision argument X and stores the result in double
C precision argument DLGAM.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  DLNGAM
C***REVISION HISTORY  (YYMMDD)
C   770701  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  DLGAMS
      DOUBLE PRECISION X, DLGAM, SGNGAM, DLNGAM
C***FIRST EXECUTABLE STATEMENT  DLGAMS
      DLGAM = DLNGAM(X)
      SGNGAM = 1.0D0
      IF (X.GT.0.D0) RETURN
C
      INT = MOD (-AINT(X), 2.0D0) + 0.1D0
      IF (INT.EQ.0) SGNGAM = -1.0D0
C
      RETURN
      END
*DECK DLNGAM
      DOUBLE PRECISION FUNCTION DLNGAM (X)
C***BEGIN PROLOGUE  DLNGAM
C***PURPOSE  Compute the logarithm of the absolute value of the Gamma
C            function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C7A
C***TYPE      DOUBLE PRECISION (ALNGAM-S, DLNGAM-D, CLNGAM-C)
C***KEYWORDS  ABSOLUTE VALUE, COMPLETE GAMMA FUNCTION, FNLIB, LOGARITHM,
C             SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C DLNGAM(X) calculates the double precision logarithm of the
C absolute value of the Gamma function for double precision
C argument X.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, D9LGMC, DGAMMA, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900727  Added EXTERNAL statement.  (WRB)
C***END PROLOGUE  DLNGAM
      DOUBLE PRECISION X, DXREL, PI, SINPIY, SQPI2L, SQ2PIL, XMAX,
     1  Y, UTIL_DGAMMA, D9LGMC, D1MACH, TEMP
      LOGICAL FIRST
      EXTERNAL UTIL_DGAMMA
      SAVE SQ2PIL, SQPI2L, PI, XMAX, DXREL, FIRST
      DATA SQ2PIL / 0.9189385332 0467274178 0329736405 62 D0 /
      DATA SQPI2L / +.2257913526 4472743236 3097614947 441 D+0    /
      DATA PI / 3.1415926535 8979323846 2643383279 50 D0 /
      DATA FIRST /.TRUE./
C***FIRST EXECUTABLE STATEMENT  DLNGAM
      IF (FIRST) THEN
         TEMP = 1.D0/LOG(D1MACH(2))
         XMAX = TEMP*D1MACH(2)
         DXREL = SQRT(D1MACH(4))
      ENDIF
      FIRST = .FALSE.
C
      Y = ABS (X)
      IF (Y.GT.10.D0) GO TO 20
C
C LOG (ABS (DGAMMA(X)) ) FOR ABS(X) .LE. 10.0
C
      DLNGAM = LOG (ABS (UTIL_DGAMMA(X)) )
      RETURN
C
C LOG ( ABS (DGAMMA(X)) ) FOR ABS(X) .GT. 10.0
C
 20   IF (Y .GT. XMAX) CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'ABS(X) SO BIG DLNGAM OVERFLOWS', 2, 2)
C
      IF (X.GT.0.D0) DLNGAM = SQ2PIL + (X-0.5D0)*LOG(X) - X + D9LGMC(Y)
      IF (X.GT.0.D0) RETURN
C
      SINPIY = ABS (SIN(PI*Y))
      IF (SINPIY .EQ. 0.D0) CALL XERMSG ('SLATEC', 'DLNGAM',
     +   'X IS A NEGATIVE INTEGER', 3, 2)
C
      IF (ABS((X-AINT(X-0.5D0))/X) .LT. DXREL) CALL XERMSG ('SLATEC',
     +   'DLNGAM',
     +   'ANSWER LT HALF PRECISION BECAUSE X TOO NEAR NEGATIVE INTEGER',
     +   1, 1)
C
      DLNGAM = SQPI2L + (X-0.5D0)*LOG(Y) - X - LOG(SINPIY) - D9LGMC(Y)
      RETURN
C
      END
*DECK INITDS
      FUNCTION INITDS (OS, NOS, ETA)
C***BEGIN PROLOGUE  INITDS
C***PURPOSE  Determine the number of terms needed in an orthogonal
C            polynomial series so that it meets a specified accuracy.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C3A2
C***TYPE      DOUBLE PRECISION (INITS-S, INITDS-D)
C***KEYWORDS  CHEBYSHEV, FNLIB, INITIALIZE, ORTHOGONAL POLYNOMIAL,
C             ORTHOGONAL SERIES, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C  Initialize the orthogonal series, represented by the array OS, so
C  that INITDS is the number of terms needed to insure the error is no
C  larger than ETA.  Ordinarily, ETA will be chosen to be one-tenth
C  machine precision.
C
C             Input Arguments --
C   OS     double precision array of NOS coefficients in an orthogonal
C          series.
C   NOS    number of coefficients in OS.
C   ETA    single precision scalar containing requested accuracy of
C          series.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891115  Modified error message.  (WRB)
C   891115  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  INITDS
      DOUBLE PRECISION OS(*)
C***FIRST EXECUTABLE STATEMENT  INITDS
      IF (NOS .LT. 1) CALL XERMSG ('SLATEC', 'INITDS',
     +   'Number of coefficients is less than 1', 2, 1)
C
      ERR = 0.
      DO 10 II = 1,NOS
        I = NOS + 1 - II
        ERR = ERR + ABS(REAL(OS(I)))
        IF (ERR.GT.ETA) GO TO 20
   10 CONTINUE
C
   20 IF (I .EQ. NOS) CALL XERMSG ('SLATEC', 'INITDS',
     +   'Chebyshev series too short for specified accuracy', 1, 1)
      INITDS = I
C
      RETURN
      END
*DECK XERCLR
      SUBROUTINE XERCLR
C***BEGIN PROLOGUE  XERCLR
C***PURPOSE  Reset current error number to zero.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XERCLR-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        This routine simply resets the current error number to zero.
C        This may be necessary in order to determine that a certain
C        error has occurred again since the last time NUMXER was
C        referenced.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XERCLR
C***FIRST EXECUTABLE STATEMENT  XERCLR
      JUNK = J4SAVE(1,0,.TRUE.)
      RETURN
      END
*DECK J4SAVE
      FUNCTION J4SAVE (IWHICH, IVALUE, ISET)
C***BEGIN PROLOGUE  J4SAVE
C***SUBSIDIARY
C***PURPOSE  Save or recall global variables needed by error
C            handling routines.
C***LIBRARY   SLATEC (XERROR)
C***TYPE      INTEGER (J4SAVE-I)
C***KEYWORDS  ERROR MESSAGES, ERROR NUMBER, RECALL, SAVE, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        J4SAVE saves and recalls several global variables needed
C        by the library error handling routines.
C
C     Description of Parameters
C      --Input--
C        IWHICH - Index of item desired.
C                = 1 Refers to current error number.
C                = 2 Refers to current error control flag.
C                = 3 Refers to current unit number to which error
C                    messages are to be sent.  (0 means use standard.)
C                = 4 Refers to the maximum number of times any
C                     message is to be printed (as set by XERMAX).
C                = 5 Refers to the total number of units to which
C                     each error message is to be written.
C                = 6 Refers to the 2nd unit for error messages
C                = 7 Refers to the 3rd unit for error messages
C                = 8 Refers to the 4th unit for error messages
C                = 9 Refers to the 5th unit for error messages
C        IVALUE - The value to be set for the IWHICH-th parameter,
C                 if ISET is .TRUE. .
C        ISET   - If ISET=.TRUE., the IWHICH-th parameter will BE
C                 given the value, IVALUE.  If ISET=.FALSE., the
C                 IWHICH-th parameter will be unchanged, and IVALUE
C                 is a dummy parameter.
C      --Output--
C        The (old) value of the IWHICH-th parameter will be returned
C        in the function value, J4SAVE.
C
C***SEE ALSO  XERMSG
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900205  Minor modifications to prologue.  (WRB)
C   900402  Added TYPE section.  (WRB)
C   910411  Added KEYWORDS section.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  J4SAVE
      LOGICAL ISET
      INTEGER IPARAM(9)
      SAVE IPARAM
      DATA IPARAM(1),IPARAM(2),IPARAM(3),IPARAM(4)/0,2,0,10/
      DATA IPARAM(5)/1/
      DATA IPARAM(6),IPARAM(7),IPARAM(8),IPARAM(9)/0,0,0,0/
C***FIRST EXECUTABLE STATEMENT  J4SAVE
      J4SAVE = IPARAM(IWHICH)
      IF (ISET) IPARAM(IWHICH) = IVALUE
      RETURN
      END
      SUBROUTINE XERMSG (LIBRAR, SUBROU, MESSG, NERR, LEVEL)
      implicit none
      CHARACTER*(*) LIBRAR, SUBROU, MESSG
      integer nerr,level
      call errquit(SUBROU//MESSG,NERR,0)
      return
      end
*DECK XSETF
      SUBROUTINE XSETF (KONTRL)
C***BEGIN PROLOGUE  XSETF
C***PURPOSE  Set the error control flag.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3A
C***TYPE      ALL (XSETF-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        XSETF sets the error control flag value to KONTRL.
C        (KONTRL is an input parameter only.)
C        The following table shows how each message is treated,
C        depending on the values of KONTRL and LEVEL.  (See XERMSG
C        for description of LEVEL.)
C
C        If KONTRL is zero or negative, no information other than the
C        message itself (including numeric values, if any) will be
C        printed.  If KONTRL is positive, introductory messages,
C        trace-backs, etc., will be printed in addition to the message.
C
C              ABS(KONTRL)
C        LEVEL        0              1              2
C        value
C          2        fatal          fatal          fatal
C
C          1     not printed      printed         fatal
C
C          0     not printed      printed        printed
C
C         -1     not printed      printed        printed
C                                  only           only
C                                  once           once
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Change call to XERRWV to XERMSG.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XSETF
      CHARACTER *8 XERN1
C***FIRST EXECUTABLE STATEMENT  XSETF
      IF (ABS(KONTRL) .GT. 2) THEN
         WRITE (XERN1, '(I8)') KONTRL
         CALL XERMSG ('SLATEC', 'XSETF',
     *      'INVALID ARGUMENT = ' // XERN1, 1, 2)
         RETURN
      ENDIF
C
      JUNK = J4SAVE(2,KONTRL,.TRUE.)
      RETURN
      END
*DECK D1MACH
      DOUBLE PRECISION FUNCTION D1MACH (I)
C***BEGIN PROLOGUE  D1MACH
C***PURPOSE  Return floating point machine dependent constants.
C***LIBRARY   SLATEC
C***CATEGORY  R1
C***TYPE      DOUBLE PRECISION (R1MACH-S, D1MACH-D)
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  Fox, P. A., (Bell Labs)
C           Hall, A. D., (Bell Labs)
C           Schryer, N. L., (Bell Labs)
C***DESCRIPTION
C
C   D1MACH can be used to obtain machine-dependent parameters for the
C   local machine environment.  It is a function subprogram with one
C   (input) argument, and can be referenced as follows:
C
C        D = D1MACH(I)
C
C   where I=1,...,5.  The (output) value of D above is determined by
C   the (input) value of I.  The results for various values of I are
C   discussed below.
C
C   D1MACH( 1) = B**(EMIN-1), the smallest positive magnitude.
C   D1MACH( 2) = B**EMAX*(1 - B**(-T)), the largest magnitude.
C   D1MACH( 3) = B**(-T), the smallest relative spacing.
C   D1MACH( 4) = B**(1-T), the largest relative spacing.
C   D1MACH( 5) = LOG10(B)
C
C   Assume double precision numbers are represented in the T-digit,
C   base-B form
C
C              sign (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C   where 0 .LE. X(I) .LT. B for I=1,...,T, 0 .LT. X(1), and
C   EMIN .LE. E .LE. EMAX.
C
C   The values of B, T, EMIN and EMAX are provided in I1MACH as
C   follows:
C   I1MACH(10) = B, the base.
C   I1MACH(14) = T, the number of base-B digits.
C   I1MACH(15) = EMIN, the smallest exponent E.
C   I1MACH(16) = EMAX, the largest exponent E.
C
C   To alter this function for a particular environment, the desired
C   set of DATA statements should be activated by removing the C from
C   column 1.  Also, the values of D1MACH(1) - D1MACH(4) should be
C   checked for consistency with the local operating system.
C
C***REFERENCES  P. A. Fox, A. D. Hall and N. L. Schryer, Framework for
C                 a portable library, ACM Transactions on Mathematical
C                 Software 4, 2 (June 1978), pp. 177-188.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   890213  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900618  Added DEC RISC constants.  (WRB)
C   900723  Added IBM RS 6000 constants.  (WRB)
C   900911  Added SUN 386i constants.  (WRB)
C   910710  Added HP 730 constants.  (SMR)
C   911114  Added Convex IEEE constants.  (WRB)
C   920121  Added SUN -r8 compiler option constants.  (WRB)
C   920229  Added Touchstone Delta i860 constants.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   920625  Added CONVEX -p8 and -pd8 compiler option constants.
C           (BKS, WRB)
C   930201  Added DEC Alpha and SGI constants.  (RWC and WRB)
C***END PROLOGUE  D1MACH
C
      INTEGER SMALL(4)
      INTEGER LARGE(4)
      INTEGER RIGHT(4)
      INTEGER DIVER(4)
      INTEGER LOG10(4)
C
      DOUBLE PRECISION DMACH(5)
      SAVE DMACH
C
      EQUIVALENCE (DMACH(1),SMALL(1))
      EQUIVALENCE (DMACH(2),LARGE(1))
      EQUIVALENCE (DMACH(3),RIGHT(1))
      EQUIVALENCE (DMACH(4),DIVER(1))
      EQUIVALENCE (DMACH(5),LOG10(1))
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING THE 68020/68881 COMPILER OPTION
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING SOFTWARE FLOATING POINT
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FDFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA SMALL(1), SMALL(2) / 16#00100000, 16#00000000 /
C     DATA LARGE(1), LARGE(2) / 16#7FFFFFFF, 16#FFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / 16#3CA00000, 16#00000000 /
C     DATA DIVER(1), DIVER(2) / 16#3CB00000, 16#00000000 /
C     DATA LOG10(1), LOG10(2) / 16#3FD34413, 16#509F79FF /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA SMALL(1) / ZC00800000 /
C     DATA SMALL(2) / Z000000000 /
C     DATA LARGE(1) / ZDFFFFFFFF /
C     DATA LARGE(2) / ZFFFFFFFFF /
C     DATA RIGHT(1) / ZCC5800000 /
C     DATA RIGHT(2) / Z000000000 /
C     DATA DIVER(1) / ZCC6800000 /
C     DATA DIVER(2) / Z000000000 /
C     DATA LOG10(1) / ZD00E730E7 /
C     DATA LOG10(2) / ZC77800DC0 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM
C
C     DATA SMALL(1) / O1771000000000000 /
C     DATA SMALL(2) / O0000000000000000 /
C     DATA LARGE(1) / O0777777777777777 /
C     DATA LARGE(2) / O0007777777777777 /
C     DATA RIGHT(1) / O1461000000000000 /
C     DATA RIGHT(2) / O0000000000000000 /
C     DATA DIVER(1) / O1451000000000000 /
C     DATA DIVER(2) / O0000000000000000 /
C     DATA LOG10(1) / O1157163034761674 /
C     DATA LOG10(2) / O0006677466732724 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS
C
C     DATA SMALL(1) / O1771000000000000 /
C     DATA SMALL(2) / O7770000000000000 /
C     DATA LARGE(1) / O0777777777777777 /
C     DATA LARGE(2) / O7777777777777777 /
C     DATA RIGHT(1) / O1461000000000000 /
C     DATA RIGHT(2) / O0000000000000000 /
C     DATA DIVER(1) / O1451000000000000 /
C     DATA DIVER(2) / O0000000000000000 /
C     DATA LOG10(1) / O1157163034761674 /
C     DATA LOG10(2) / O0006677466732724 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA SMALL(1) / Z"3001800000000000" /
C     DATA SMALL(2) / Z"3001000000000000" /
C     DATA LARGE(1) / Z"4FFEFFFFFFFFFFFE" /
C     DATA LARGE(2) / Z"4FFE000000000000" /
C     DATA RIGHT(1) / Z"3FD2800000000000" /
C     DATA RIGHT(2) / Z"3FD2000000000000" /
C     DATA DIVER(1) / Z"3FD3800000000000" /
C     DATA DIVER(2) / Z"3FD3000000000000" /
C     DATA LOG10(1) / Z"3FFF9A209A84FBCF" /
C     DATA LOG10(2) / Z"3FFFF7988F8959AC" /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA SMALL(1) / 00564000000000000000B /
C     DATA SMALL(2) / 00000000000000000000B /
C     DATA LARGE(1) / 37757777777777777777B /
C     DATA LARGE(2) / 37157777777777777777B /
C     DATA RIGHT(1) / 15624000000000000000B /
C     DATA RIGHT(2) / 00000000000000000000B /
C     DATA DIVER(1) / 15634000000000000000B /
C     DATA DIVER(2) / 00000000000000000000B /
C     DATA LOG10(1) / 17164642023241175717B /
C     DATA LOG10(2) / 16367571421742254654B /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn OR -pd8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CC0000000000000' /
C     DATA DMACH(4) / Z'3CD0000000000000' /
C     DATA DMACH(5) / Z'3FF34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'00010000000000000000000000000000' /
C     DATA DMACH(2) / Z'7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3F900000000000000000000000000000' /
C     DATA DMACH(4) / Z'3F910000000000000000000000000000' /
C     DATA DMACH(5) / Z'3FFF34413509F79FEF311F12B35816F9' /
C
C     MACHINE CONSTANTS FOR THE CRAY
C
C     DATA SMALL(1) / 201354000000000000000B /
C     DATA SMALL(2) / 000000000000000000000B /
C     DATA LARGE(1) / 577767777777777777777B /
C     DATA LARGE(2) / 000007777777777777774B /
C     DATA RIGHT(1) / 376434000000000000000B /
C     DATA RIGHT(2) / 000000000000000000000B /
C     DATA DIVER(1) / 376444000000000000000B /
C     DATA DIVER(2) / 000000000000000000000B /
C     DATA LOG10(1) / 377774642023241175717B /
C     DATA LOG10(2) / 000007571421742254654B /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C     NOTE - IT MAY BE APPROPRIATE TO INCLUDE THE FOLLOWING CARD -
C     STATIC DMACH(5)
C
C     DATA SMALL /    20K, 3*0 /
C     DATA LARGE / 77777K, 3*177777K /
C     DATA RIGHT / 31420K, 3*0 /
C     DATA DIVER / 32020K, 3*0 /
C     DATA LOG10 / 40423K, 42023K, 50237K, 74776K /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA DMACH(1) / '0000000000000010'X /
C     DATA DMACH(2) / 'FFFFFFFFFFFF7FFF'X /
C     DATA DMACH(3) / '0000000000003CC0'X /
C     DATA DMACH(4) / '0000000000003CD0'X /
C     DATA DMACH(5) / '79FF509F44133FF3'X /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FORMAT
C
C     DATA DMACH(1) / '0010000000000000'X /
C     DATA DMACH(2) / '7FEFFFFFFFFFFFFF'X /
C     DATA DMACH(3) / '3CA0000000000000'X /
C     DATA DMACH(4) / '3CB0000000000000'X /
C     DATA DMACH(5) / '3FD34413509F79FF'X /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA SMALL(1), SMALL(2) / Z'00000000', Z'00100000'/
C     DATA LARGE(1), LARGE(2) / Z'FFFFFFFF', Z'7FEFFFFF'/
C     DATA RIGHT(1), RIGHT(2) / Z'00000000', Z'3CA00000'/
C     DATA DIVER(1), DIVER(2) / Z'00000000', Z'3CB00000'/
C     DATA LOG10(1), LOG10(2) / Z'509F79FF', Z'3FD34413'/
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING D_FLOATING
C     (EXPRESSED IN INTEGER AND HEXADECIMAL)
C     THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS
C     THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS
C
C     DATA SMALL(1), SMALL(2) /        128,           0 /
C     DATA LARGE(1), LARGE(2) /     -32769,          -1 /
C     DATA RIGHT(1), RIGHT(2) /       9344,           0 /
C     DATA DIVER(1), DIVER(2) /       9472,           0 /
C     DATA LOG10(1), LOG10(2) /  546979738,  -805796613 /
C
C     DATA SMALL(1), SMALL(2) / Z00000080, Z00000000 /
C     DATA LARGE(1), LARGE(2) / ZFFFF7FFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z00002480, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z00002500, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z209A3F9A, ZCFF884FB /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING G_FLOATING
C     (EXPRESSED IN INTEGER AND HEXADECIMAL)
C     THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS
C     THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS
C
C     DATA SMALL(1), SMALL(2) /         16,           0 /
C     DATA LARGE(1), LARGE(2) /     -32769,          -1 /
C     DATA RIGHT(1), RIGHT(2) /      15552,           0 /
C     DATA DIVER(1), DIVER(2) /      15568,           0 /
C     DATA LOG10(1), LOG10(2) /  1142112243, 2046775455 /
C
C     DATA SMALL(1), SMALL(2) / Z00000010, Z00000000 /
C     DATA LARGE(1), LARGE(2) / ZFFFF7FFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z00003CC0, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z00003CD0, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z44133FF3, Z79FF509F /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C     (ASSUMING REAL*8 IS THE DEFAULT DOUBLE PRECISION)
C
C     DATA SMALL(1), SMALL(2) / '00100000'X,'00000000'X /
C     DATA LARGE(1), LARGE(2) / '7FEFFFFF'X,'FFFFFFFF'X /
C     DATA RIGHT(1), RIGHT(2) / '3CB00000'X,'00000000'X /
C     DATA DIVER(1), DIVER(2) / '3CC00000'X,'00000000'X /
C     DATA LOG10(1), LOG10(2) / '3FD34413'X,'509F79FF'X /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA SMALL(1), SMALL(2) / '20000000, '00000201 /
C     DATA LARGE(1), LARGE(2) / '37777777, '37777577 /
C     DATA RIGHT(1), RIGHT(2) / '20000000, '00000333 /
C     DATA DIVER(1), DIVER(2) / '20000000, '00000334 /
C     DATA LOG10(1), LOG10(2) / '23210115, '10237777 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA SMALL(1), SMALL(2) / O402400000000, O000000000000 /
C     DATA LARGE(1), LARGE(2) / O376777777777, O777777777777 /
C     DATA RIGHT(1), RIGHT(2) / O604400000000, O000000000000 /
C     DATA DIVER(1), DIVER(2) / O606400000000, O000000000000 /
C     DATA LOG10(1), LOG10(2) / O776464202324, O117571775714 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     THREE WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA SMALL(1), SMALL(2), SMALL(3) / 40000B,       0,       1 /
C     DATA LARGE(1), LARGE(2), LARGE(3) / 77777B, 177777B, 177776B /
C     DATA RIGHT(1), RIGHT(2), RIGHT(3) / 40000B,       0,    265B /
C     DATA DIVER(1), DIVER(2), DIVER(3) / 40000B,       0,    276B /
C     DATA LOG10(1), LOG10(2), LOG10(3) / 46420B,  46502B,  77777B /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     FOUR WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA SMALL(1), SMALL(2) /  40000B,       0 /
C     DATA SMALL(3), SMALL(4) /       0,       1 /
C     DATA LARGE(1), LARGE(2) /  77777B, 177777B /
C     DATA LARGE(3), LARGE(4) / 177777B, 177776B /
C     DATA RIGHT(1), RIGHT(2) /  40000B,       0 /
C     DATA RIGHT(3), RIGHT(4) /       0,    225B /
C     DATA DIVER(1), DIVER(2) /  40000B,       0 /
C     DATA DIVER(3), DIVER(4) /       0,    227B /
C     DATA LOG10(1), LOG10(2) /  46420B,  46502B /
C     DATA LOG10(3), LOG10(4) /  76747B, 176377B /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA SMALL(1), SMALL(2) / 00040000000B, 00000000000B /
C     DATA LARGE(1), LARGE(2) / 17737777777B, 37777777777B /
C     DATA RIGHT(1), RIGHT(2) / 07454000000B, 00000000000B /
C     DATA DIVER(1), DIVER(2) / 07460000000B, 00000000000B /
C     DATA LOG10(1), LOG10(2) / 07764642023B, 12047674777B /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA SMALL(1), SMALL(2) / Z00100000, Z00000000 /
C     DATA LARGE(1), LARGE(2) / Z7FFFFFFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z33100000, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z34100000, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z41134413, Z509F79FF /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C     ASSUMES THAT ALL ARITHMETIC IS DONE IN DOUBLE PRECISION
C     ON 8088, I.E., NOT IN 80 BIT FORM FOR THE 8087.
C
C     DATA SMALL(1) / 2.23D-308  /
C     DATA LARGE(1) / 1.79D+308  /
C     DATA RIGHT(1) / 1.11D-16   /
C     DATA DIVER(1) / 2.22D-16   /
C     DATA LOG10(1) / 0.301029995663981195D0 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR)
C
C     DATA SMALL(1), SMALL(2) / "033400000000, "000000000000 /
C     DATA LARGE(1), LARGE(2) / "377777777777, "344777777777 /
C     DATA RIGHT(1), RIGHT(2) / "113400000000, "000000000000 /
C     DATA DIVER(1), DIVER(2) / "114400000000, "000000000000 /
C     DATA LOG10(1), LOG10(2) / "177464202324, "144117571776 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR)
C
C     DATA SMALL(1), SMALL(2) / "000400000000, "000000000000 /
C     DATA LARGE(1), LARGE(2) / "377777777777, "377777777777 /
C     DATA RIGHT(1), RIGHT(2) / "103400000000, "000000000000 /
C     DATA DIVER(1), DIVER(2) / "104400000000, "000000000000 /
C     DATA LOG10(1), LOG10(2) / "177464202324, "476747767461 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1), SMALL(2) /    8388608,           0 /
C     DATA LARGE(1), LARGE(2) / 2147483647,          -1 /
C     DATA RIGHT(1), RIGHT(2) /  612368384,           0 /
C     DATA DIVER(1), DIVER(2) /  620756992,           0 /
C     DATA LOG10(1), LOG10(2) / 1067065498, -2063872008 /
C
C     DATA SMALL(1), SMALL(2) / O00040000000, O00000000000 /
C     DATA LARGE(1), LARGE(2) / O17777777777, O37777777777 /
C     DATA RIGHT(1), RIGHT(2) / O04440000000, O00000000000 /
C     DATA DIVER(1), DIVER(2) / O04500000000, O00000000000 /
C     DATA LOG10(1), LOG10(2) / O07746420232, O20476747770 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1), SMALL(2) /    128,      0 /
C     DATA SMALL(3), SMALL(4) /      0,      0 /
C     DATA LARGE(1), LARGE(2) /  32767,     -1 /
C     DATA LARGE(3), LARGE(4) /     -1,     -1 /
C     DATA RIGHT(1), RIGHT(2) /   9344,      0 /
C     DATA RIGHT(3), RIGHT(4) /      0,      0 /
C     DATA DIVER(1), DIVER(2) /   9472,      0 /
C     DATA DIVER(3), DIVER(4) /      0,      0 /
C     DATA LOG10(1), LOG10(2) /  16282,   8346 /
C     DATA LOG10(3), LOG10(4) / -31493, -12296 /
C
C     DATA SMALL(1), SMALL(2) / O000200, O000000 /
C     DATA SMALL(3), SMALL(4) / O000000, O000000 /
C     DATA LARGE(1), LARGE(2) / O077777, O177777 /
C     DATA LARGE(3), LARGE(4) / O177777, O177777 /
C     DATA RIGHT(1), RIGHT(2) / O022200, O000000 /
C     DATA RIGHT(3), RIGHT(4) / O000000, O000000 /
C     DATA DIVER(1), DIVER(2) / O022400, O000000 /
C     DATA DIVER(3), DIVER(4) / O000000, O000000 /
C     DATA LOG10(1), LOG10(2) / O037632, O020232 /
C     DATA LOG10(3), LOG10(4) / O102373, O147770 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'00010000000000000000000000000000' /
C     DATA DMACH(2) / Z'7FFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3F8E0000000000000000000000000000' /
C     DATA DMACH(4) / Z'3F8F0000000000000000000000000000' /
C     DATA DMACH(5) / Z'3FFD34413509F79FEF311F12B35816F9' /
C
C     MACHINE CONSTANTS FOR THE SUN 386i
C
C     DATA SMALL(1), SMALL(2) / Z'FFFFFFFD', Z'000FFFFF' /
C     DATA LARGE(1), LARGE(2) / Z'FFFFFFB0', Z'7FEFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'000000B0', Z'3CA00000' /
C     DATA DIVER(1), DIVER(2) / Z'FFFFFFCB', Z'3CAFFFFF'
C     DATA LOG10(1), LOG10(2) / Z'509F79E9', Z'3FD34413' /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES FTN COMPILER
C
C     DATA SMALL(1), SMALL(2) / O000040000000, O000000000000 /
C     DATA LARGE(1), LARGE(2) / O377777777777, O777777777777 /
C     DATA RIGHT(1), RIGHT(2) / O170540000000, O000000000000 /
C     DATA DIVER(1), DIVER(2) / O170640000000, O000000000000 /
C     DATA LOG10(1), LOG10(2) / O177746420232, O411757177572 /
C
C***FIRST EXECUTABLE STATEMENT  D1MACH
      IF (I .LT. 1 .OR. I .GT. 5) CALL XERMSG ('SLATEC', 'D1MACH',
     +   'I OUT OF BOUNDS', 1, 2)
C
      D1MACH = DMACH(I)
      RETURN
C
      END
*DECK XGETF
      SUBROUTINE XGETF (KONTRL)
C***BEGIN PROLOGUE  XGETF
C***PURPOSE  Return the current value of the error control flag.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      ALL (XGETF-A)
C***KEYWORDS  ERROR, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C   Abstract
C        XGETF returns the current value of the error control flag
C        in KONTRL.  See subroutine XSETF for flag value meanings.
C        (KONTRL is an output parameter only.)
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  XGETF
C***FIRST EXECUTABLE STATEMENT  XGETF
      KONTRL = J4SAVE(2,0,.FALSE.)
      RETURN
      END

*........................................#define DEBUG_D3O
      subroutine hfd3ois(
     &    Axyz,Aprims,Acoef,NPA,NCA,La,
     &    Bxyz,Bprims,Bcoef,NPB,NCB,Lb,
     &    Cxyz,Cprims,Ccoef,NPC,NCC,Lc,
     &    d3OI,Nintin,
     &    DryRun,W0,maxW0)
* $Id: hfd3oi.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
#include "stdio.fh"
*
*  This routine computes the 3 center overlap derivative integrals
*       for the contracted gaussian function information passed in
*  There are 3 component vectors d/dA d/dB and d/dC in the result 
*  matrix.
*

*:: passed
      integer La  ! [input] angular momentum of A function
      integer NPA ! [input] number of primitive gausians on A
      integer NCA ! [input] number of general contractions on B
      double precision Axyz(3)        ! [input] coordinates of center A
      double precision Aprims(NPA)    ! [input] primitive exponents on A
      double precision Acoef(NPA,NCA) ! [input] contraction coefficients on A 

      integer Lb  ! [input] angular momentum of B function
      integer NPB ! [input] number of primitive gausians on B
      integer NCB ! [input] number of general contractions on B
      double precision Bxyz(3) ! [input] coordinates of center B
      double precision Bprims(NPB)    ! [input] primitive exponents on B
      double precision Bcoef(NPB,NCB) ! [input] contraction coefficients on B 

      integer Lc  ! [input] angular momentum of C function
      integer NPC ! [input] number of primitive gausians on C
      integer NCC ! [input] number of general contractions on C
      double precision Cxyz(3) ! [input] coordinates of center C
      double precision Cprims(NPC)    ! [input] primitive exponents on C
      double precision Ccoef(NPC,NCC) ! [input] contraction coefficients on C 
      
      double precision d3OI(*) ! [output] 3-center derivative overlap integrals
      integer Nintin           ! [input] leading dimension of d3OI
      
      logical DryRun  ! [input]
      integer maxW0   ! if (!DryRun) [input]  size of scratch array
*                     ! if (DryRun)  [output] estimated size 
      double precision W0(maxW0) ! [scratch] array.

*:: local
      integer i_top   ! [W0 pointer] next pointer value in W0
      integer i_used  ! [W0 pointer] current memory used on stack of W0
      integer i_save  ! [W0 pointer] pointer set to mark reuse point on W0 stack
      integer i_alpha ! [W0 pointer] exponents and Kabc 
      integer i_G     ! [W0 pointer] Coordinates of global center 
*................................... This is exponent dependent
      integer i_E     ! [W0 pointer] Hermite expansion coefficients
      integer i_Gt    ! [W0 pointer] Coordinates of global center offset by recusrion center
      integer i_ABC2i ! [W0 pointer] 1/2(a+b+c) used for recursion
      integer i_exabc ! [W0 pointer] exponents for performance
      integer MaxMem  ! maximum memory determined with DryRun=True call
      integer Nabc    ! Number of exponent "triplets" after screening
      integer Lap, Lbp, Lcp ! incremented L values (for derivs)
      integer Labc    ! Total derivative angular momentum
      integer sizeE   ! Size of E hermite expansion coefficients
      integer nint    ! block of integral size
*:: exceptions
* right now general contractions are out      
      if ((NCA.gt.1).or.(NCB.gt.1).or.(NCC.gt.1)) then
        write(luout,*)' hfd3oi: General contractions not supported'
        stop ' hfd3oi: fatal error '
      endif
#if defined(DEBUG_D3O)
      write(6,*)' hfd3ois debug'
      write(6,*)' La, Lb, Lc ',La, Lb, Lc
      write(6,*)' Nintin ',Nintin
      write(6,*)' maxW0  ',maxW0
#endif
      call dfill(maxW0,0.0d00,W0,1)

* allocate memory on W0 stack
      i_alpha = 1                               ! needed always
      i_top   = i_alpha + (NPA*NPB*NPC)*4
      i_used  = i_top - 1
      i_save  = i_top ! all pointers needed

      if (i_used.gt.maxW0) then
        write(luout,*)' hfd3oi: insufficient scratch space '
        write(luout,*)' hfd3oi: scratch required  :',i_used
        write(luout,*)' hfd3oi: scratch allocated :',maxW0
        stop ' hfd3oi: fatal error '
      endif
      
      MaxMem = i_used  ! take care of compiler warnings

      if (DryRun) then
        MaxMem = i_used
        Nabc = NPA*NPB*NPC
      else
** Define the prefactor of the charge distributions 
** Determine the primitive exponents used after screening
        call hf1set3(
     &      Axyz,Aprims,Acoef,NPA,
     &      Bxyz,Bprims,Bcoef,NPB,
     &      Cxyz,Cprims,Ccoef,NPC,
     &      W0(i_alpha),Nabc)
      endif

** Define the global center of the charge distribution
*** shifted angular momentum      
      Lap  = La + 1   ! incremented for integral derivatives
      Lbp  = Lb + 1   ! incremented for integral derivatives
      Lcp  = Lc + 1   ! incremented for integral derivatives
      Labc = Lap + Lbp + Lcp ! maximum total angular momentum value 

*** determine size of expansion coefficient array E
      sizeE = Nabc*3         ! exponent range (1:Nabc) and xyz range (1:3)
      sizeE = sizeE*(Labc+1) ! total angular momentum range (0:Labc)
      sizeE = sizeE*(Lap+1)  ! angular momentum range for A (0:Lap)
      sizeE = sizeE*(Lbp+1)  ! angular momentum range for B (0:Lbp)      
      sizeE = sizeE*(Lcp+1)  ! angular momentum range for C (0:Lcp)
***: allocate off W0 stack
      i_E    = i_top          ! i_E needed always
      i_G    = i_E + sizeE    ! i_G needed only to compute E coeffs
      i_top  = i_G + Nabc*3
      i_save = i_G     ! i_alpha and i_E are needed later
      i_used = i_top - 1

      if (i_used.gt.maxW0) then
        write(luout,*)' hfd3oi: insufficient scratch space '
        write(luout,*)' hfd3oi: scratch required  :',i_used
        write(luout,*)' hfd3oi: scratch allocated :',maxW0
        stop ' hfd3oi: fatal error '
      endif

      if (DryRun) then
        MaxMem = max( MaxMem, i_used)
      else
        call hfctr3(Axyz,Bxyz,Cxyz,W0(i_alpha),W0(i_G),Nabc)
      endif

** Determine the Hermite expansion coefficients (E)      
*** compute memory pointer for W0 stack

      i_Gt     = i_top            ! i_Gt needed only to compute E
      i_ABC2I  = i_Gt    + Nabc*3 ! i_ABC2I needed only to compute E
      i_top    = i_ABC2I + Nabc*3 
      i_used   = i_top - 1 

      if (i_used.gt.maxW0) then
        write(luout,*)' hfd3oi: insufficient scratch space '
        write(luout,*)' hfd3oi: scratch required  :',i_used
        write(luout,*)' hfd3oi: scratch allocated :',maxW0
        stop ' hfd3oi: fatal error '
      endif

      if (DryRun) then
        MaxMem = max( MaxMem, i_used)
      else
#if defined(DEBUG_D3O)
        write(6,*)' i_alpha = ', i_alpha
        write(6,*)' i_G     = ', i_G
        write(6,*)' i_Gt    = ', i_Gt
        write(6,*)' i_ABC2I = ', i_ABC2I
        write(6,*)' i_E     = ', i_E
#endif
        call hf1mke3(Axyz,Bxyz,Cxyz,
     &      W0(i_alpha),
     &      W0(i_G),
     &      W0(i_Gt),
     &      W0(i_ABC2I),
     &      W0(i_E),
     &      Nabc,Lap,Lbp,Lcp)

      endif
c
** set up pointers to copy exponents to transformed array (for performance)
*compute-F-Separately:      Fsize = Nabc*3
*compute-F-Separately:      Fsize = Fsize*(La+1)
*compute-F-Separately:      Fsize = Fsize*(Lb+1)
*compute-F-Separately:      Fsize = Fsize*(Lc+1)
*compute-F-Separately:      Fsize = Fsize*2
*compute-F-Separately:      i_F     = isave
*compute-F-Separately:      i_exabc = i_F + Fsize
      i_exabc = i_save
      i_top   = i_exabc + Nabc*3
      i_used  = i_top - 1
      if (i_used.gt.maxW0) then
        write(luout,*)' hfd3oi: insufficient scratch space '
        write(luout,*)' hfd3oi: scratch required  :',i_used
        write(luout,*)' hfd3oi: scratch allocated :',maxW0
        stop ' hfd3oi: fatal error '
      endif

c Return the maximum amount of scratch space required by DryRun.

      if( DryRun )then
        MaxMem = max( MaxMem, i_used)
        maxW0 = MaxMem
        return
      end if

** copy exponents to performance array
      call hfdabc_exc(W0(i_alpha),W0(i_exabc),Nabc)
*compute-F-Separately:** compute F coefficients
*compute-F-Separately:      call hfmkF3(Nabc,La,Lb,Lc,Labc,W0(i_exabc),W0(i_F),W0(i_E))
** Compute the 3-center overlap derivative integrals

      nint =      (La+1)*(La+2)/2
      nint = nint*(Lb+1)*(Lb+2)/2
      nint = nint*(Lc+1)*(Lc+2)/2
      call hfdabc(W0(i_E),W0(i_exabc),d3oi,nint,Nabc,La,Lb,Lc,Labc)

      end
      subroutine hfdabc(E,ex,d3oi,nint,Nabc,La,Lb,Lc,Labc)
      implicit none
c
      integer La
      integer Lb
      integer Lc
      integer Labc
      integer Nabc
      integer nint
      
      double precision d3oi(nint,9)   ! 9 = d/dA,d/dB,d/dC

      double precision E(Nabc,3,0:Labc,0:(La+1),0:(Lb+1),0:(Lc+1))

      double precision ex(Nabc,3)  ! 1=A, 2=B, 3=C
c
      integer Nxyz(3)
      integer La2, Lb2, Lc2
      integer n
      integer m
      integer ica, icb, icc
      integer ia, ja, ka
      integer ib, jb, kb
      integer ic, jc, kc
      double precision sum1, sum2, sum3
      double precision a, b
      double precision E1, E2, E3
      double precision F1, F2, F3
c
      La2 = (La+1)*(La+2)/2
      Lb2 = (Lb+1)*(Lb+2)/2
      Lc2 = (Lc+1)*(Lc+2)/2
c
      n = 0
c
* loop over A center shell components
      do ica = 1,La2

        call getNxyz(La,ica,Nxyz)
        Ia = Nxyz(1)
        Ja = Nxyz(2)
        Ka = Nxyz(3)

        do icb = 1,Lb2

          call getNxyz(Lb,icb,Nxyz)
          Ib = Nxyz(1)
          Jb = Nxyz(2)
          Kb = Nxyz(3)

          do icc = 1,Lc2

            call getNxyz(Lc,icc,Nxyz)
            Ic = Nxyz(1)
            Jc = Nxyz(2)
            Kc = Nxyz(3)

            n = n + 1

            sum1 = 0.0d00
            sum2 = 0.0d00
            sum3 = 0.0d00
            do m = 1, Nabc
              E1 = E(m,1,0,Ia,Ib,Ic)
              E2 = E(m,2,0,Ja,Jb,Jc)
              E3 = E(m,3,0,Ka,Kb,Kc)
              a = ex(m,1)
              F1 = 2.0d00*a*E(m,1,0,(Ia+1),Ib,Ic) 
              if (Ia.gt.0) F1 = F1 -  dble(Ia)*E(m,1,0,(Ia-1),Ib,Ic)
              F2 = 2.0d00*a*E(m,2,0,(Ja+1),Jb,Jc) 
              if (Ja.gt.0) F2 = F2 -  dble(Ja)*E(m,2,0,(Ja-1),Jb,Jc)
              F3 = 2.0d00*a*E(m,3,0,(Ka+1),Kb,Kc) 
              if (Ka.gt.0) F3 = F3 -  dble(Ka)*E(m,3,0,(Ka-1),Kb,Kc)
              sum1 = sum1 + F1*E2*E3
              sum2 = sum2 + E1*F2*E3
              sum3 = sum3 + E1*E2*F3
            enddo
            d3oi(n,1) = sum1
            d3oi(n,2) = sum2
            d3oi(n,3) = sum3

            sum1 = 0.0d00
            sum2 = 0.0d00
            sum3 = 0.0d00
            do m = 1, Nabc
              E1 = E(m,1,0,Ia,Ib,Ic)
              E2 = E(m,2,0,Ja,Jb,Jc)
              E3 = E(m,3,0,Ka,Kb,Kc)
              b = ex(m,2)
              F1 = 2.0d00*b*E(m,1,0,Ia,(Ib+1),Ic) 
              if (Ib.gt.0) F1 = F1 - dble(Ib)*E(m,1,0,Ia,(Ib-1),Ic)
              F2 = 2.0d00*b*E(m,2,0,Ja,(Jb+1),Jc) 
              if (Jb.gt.0) F2 = F2 - dble(Jb)*E(m,2,0,Ja,(Jb-1),Jc)
              F3 = 2.0d00*b*E(m,3,0,Ka,(Kb+1),Kc) 
              if (Kb.gt.0) F3 = F3 - dble(Kb)*E(m,3,0,Ka,(Kb-1),Kc)
              sum1 = sum1 + F1*E2*E3
              sum2 = sum2 + E1*F2*E3
              sum3 = sum3 + E1*E2*F3
            enddo
            d3oi(n,4) = sum1
            d3oi(n,5) = sum2
            d3oi(n,6) = sum3

          enddo
        enddo
      enddo
c
* use translational invariance to compute d/dc = -d/da - d/db
c
*(1) d/dc = d/da
      call dcopy((3*nint),d3oi(1,1),1,d3oi(1,7),1)
*(2) d/dc = -d/da
      call dscal((3*nint),-1.0d00,d3oi(1,7),1)
*(3) d/dc = -d/da - d/db                  
      call daxpy((3*nint),-1.0d00,d3oi(1,4),1,d3oi(1,7),1)
      end
      subroutine hfdabc_exc(alpha,exabc,Nabc)
      implicit none
      integer Nabc
      double precision alpha(4,Nabc)
      double precision exabc(Nabc,3)
c
      integer i

      do i = 1, Nabc
        exabc(i,1) = alpha(1,i)
        exabc(i,2) = alpha(2,i)
        exabc(i,3) = alpha(3,i)
      enddo
      end
      subroutine hfmkF3(Nabc,La,Lb,Lc,Labc,exabc,F,E)
      implicit none
c
      integer Nabc
      integer Labc
      integer La
      integer Lb
      integer Lc
      double precision exabc(Nabc,3)
      double precision E(Nabc,3,0:Labc,0:(La+1),0:(Lb+1),0:(Lc+1))
      double precision F(Nabc,3,0:La,0:Lb,0:Lc,2)
c index description for F
c 1  [m]      Nabc
c 1  [xyz]    3
c 0  [ia]     La
c 0  [ib]     Lb
c 0  [ic]     Lc
c 1  [center] 2  (only centers 1 and 2 are computed center 3 by translational invariance
c
      integer ia, ib, ic
      integer m, ixyz
c
c for center A 
c
** ia = 0
      do ib = 0, Lb
        do ic = 0, Lc
          do ixyz = 1,3
            do m = 1,Nabc
              F(m,ixyz,0,ib,ic,1) =
     &            2.0d00*exabc(m,1)*E(m,ixyz,0,1,ib,ic)
            enddo
          enddo
        enddo
      enddo
** ia = 1 -> La
      do ia = 1, La
        do ib = 0, Lb
          do ic = 0, Lc
            do ixyz = 1,3
              do m = 1,Nabc
              F(m,ixyz,ia,ib,ic,1) =
     &              2.0d00*exabc(m,1)*E(m,ixyz,0,(ia+1),ib,ic) -
     &              dble(ia)*E(m,ixyz,0,(ia-1),ib,ic)
              enddo
            enddo
          enddo
        enddo
      enddo

c
c for center B 
c
** ib = 0
      do ia = 0, La
        do ic = 0, Lc
          do ixyz = 1,3
            do m = 1,Nabc
              F(m,ixyz,ia,0,ic,2) =
     &            2.0d00*exabc(m,2)*E(m,ixyz,0,ia,1,ic)
            enddo
          enddo
        enddo
      enddo
** ib = 1 -> Lb
      do ia = 0, La
        do ib = 1, Lb
          do ic = 0, Lc
            do ixyz = 1,3
              do m = 1,Nabc
                F(m,ixyz,ia,ib,ic,2) =
     &              2.0d00*exabc(m,2)*E(m,ixyz,0,ia,(ib+1),ic) -
     &              dble(ib)*E(m,ixyz,0,ia,(ib-1),ic)
              enddo
            enddo
          enddo
        enddo
      enddo
c
c for center C
c
*. . . .  These "F" values should not be needed since d/dc is computed
*         by translational invariance
*not-needed:** ic = 0
*not-needed:      do ia = 0, Lb
*not-needed:        do ib = 0, Lc
*not-needed:          do ixyz = 1,3
*not-needed:            do m = 1,Nabc
*not-needed:              F(m,ixyz,ia,ib,0,3) =
*not-needed:     &            2.0d00*exabc(m,3)*E(m,ixyz,0,ia,ib,1)
*not-needed:            enddo
*not-needed:          enddo
*not-needed:        enddo
*not-needed:      enddo
*not-needed:** ic = 1 -> Lc
*not-needed:      do ia = 0, La
*not-needed:        do ib = 0, Lb
*not-needed:          do ic = 1, Lc
*not-needed:            do ixyz = 1,3
*not-needed:              do m = 1,Nabc
*not-needed:              F(m,ixyz,ia,ib,ic,3) =
*not-needed:     &              2.0d00*exabc(m,3)*E(m,ixyz,0,ia,ib,(ic+1)) -
*not-needed:     &              dble(ic)*E(m,ixyz,0,ia,ib,(ic-1))
*not-needed:              enddo
*not-needed:            enddo
*not-needed:          enddo
*not-needed:        enddo
*not-needed:      enddo
c
      end

#define IO_TEST_SZ (1024*1024/8)
#define IO_NUM_FILES 4
#define MAX_ITER 4
#define DMAP(x) dble(IO_TEST_SZ*((x-1)*eaf_util_szint()))
#define MAX_FILE_SZ 2.0d9
#define BASE_NAME 'EAFfile'
#ifdef  HPIODIR
#  define FNAME   HPIODIR//BASE_NAME
#else
#  define FNAME   BASE_NAME
#endif

      subroutine util_eaf_test
c     
      implicit none
      call test1
      call test2
      call test3
c     call test4
c     
c     print *,' '
c     print *,'All tests completed'
      end

      subroutine test2
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "eaf.fh"
c     
      integer buf(IO_TEST_SZ, MAX_ITER), buf2(IO_TEST_SZ)
      character fname*200
      integer fnum,  iter
      integer i, nap
      real    dummy
      integer fd(IO_NUM_FILES)
      integer buf_sz
      integer aio(IO_NUM_FILES, MAX_ITER)
      integer stat2
      integer icountdown
      logical oeaf_probe
c
      oeaf_probe = .true.
c     
      buf_sz = (IO_TEST_SZ*eaf_util_szint())
c
c     write(6,*)
c     write(6,*) ' TEST 2 ... asynchronous read/write of multiple files'
c     write(6,*) ' ----------------------------------------------------'
c     write(6,*)
c     
 10   format (A,'.', I1,'.',I4.4)
c     
      do fnum = 1, IO_NUM_FILES
         write (fname, 10) FNAME, fnum, ga_nodeid()
c     
         call testerr(eaf_open(fname, eaf_rw, fd(fnum)))
c     
c        print *,'testing EAF_AWrite', ' file= ',fname
         do iter = 1, MAX_ITER
            do i = 1, IO_TEST_SZ
               buf(i,iter) = i + fnum + (iter*10000)
            enddo

            call testerr(eaf_awrite(fd(fnum),
     $           DMAP(iter),
     $           buf(1,iter), buf_sz, aio(fnum, iter)))

c           write(0,*) 'Submitted EAF_AWriteF  fnum=', fnum,
c    $           '   iter=',iter, '   aio=',aio(fnum, iter)
         enddo
      enddo

      do fnum = 1, IO_NUM_FILES
         do iter = 1, MAX_ITER
c           write(0,*) 'Waiting to close  fnum=', fnum,
c    $           '   iter=',iter
            call testerr(eaf_wait(fd(fnum), aio(fnum, iter)))
         enddo
c        call eaf_print_stats(fd(fnum))
         call testerr(eaf_close(fd(fnum)))
      enddo
      if (ga_nodeid().eq.0) then
         write(6,'(A)') ' eaf_awrite ....................... OK'
         write(6,'(A)') ' eaf_wait ......................... OK'
         write(6,'(A)') ' [Next test will take a few minutes]'
         call ffflush(6)
      endif

c.................................

c     print *,'testing EAF_ARead'
      do fnum = 1, IO_NUM_FILES

         write (fname, 10) FNAME, fnum, ga_nodeid()

         call testerr(eaf_open(fname, eaf_r, fd(fnum)))
         
         do iter = 1, MAX_ITER
            do i = 1, IO_TEST_SZ
               buf(i,iter) = i + fnum + (iter*10000)
            enddo

            call testerr(eaf_aread(fd(fnum), 
     $           DMAP(iter), 
     $           buf2, buf_sz, 
     $           aio(fnum,iter)))

            icountdown = 100
 1000       call testerr(eaf_probe(aio(fnum, iter), stat2))
c           write(0,999) stat2
 999        format(i5,i8)
            if(stat2 .ne. 0 .and. icountdown .ge. 0) then
               do nap=1, 2000000
                  dummy = 2.0**2.0+nap
               enddo
               icountdown = icountdown - 1
               goto 1000
            endif
            oeaf_probe = oeaf_probe.and.(stat2.eq.0.and.icountdown.ge.0)

            call util_sleep(10)
c           write(0,*) 'Finished reading file=',fnum, 
c    $           '  fd=',fd(fnum),
c    $           '  iter=',iter

            do i = 1, IO_TEST_SZ
               if(buf(i,iter) .ne. buf2(i)) then 
                  write(6,*) 'Bad read of file=',fnum, 
     $                 '  fd=',fd(fnum),
     $                 '  iter=',iter,'  offset=',i,'   buf1=',
     $                 buf(i,iter),'  buf2=',buf2(i)
                  stop 1
               endif
            enddo
         enddo
      enddo
c     
      do fnum = 1, IO_NUM_FILES
c        call eaf_print_stats(fd(fnum))
         call testerr(eaf_close(fd(fnum)))
         write (fname, 10) FNAME, fnum, ga_nodeid()
         call testerr(eaf_delete(fname))
      enddo
      oeaf_probe = .not.oeaf_probe
      call ga_igop(MT_LOG,oeaf_probe,1,"or")
      oeaf_probe = .not.oeaf_probe
      if (ga_nodeid().eq.0) then
         write(6,'(A)') ' eaf_aread ........................ OK'
         if (oeaf_probe) then
           write(6,'(A)') ' eaf_probe ........................ OK'
         else
           write(6,'(A)') ' eaf_probe ........................ fail'
         endif
         call ffflush(6)
      endif
c     
      end
      subroutine test1
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "eaf.fh"
      integer buf(IO_TEST_SZ), buf2(IO_TEST_SZ)
      character fname*200
      integer fnum,  iter
      integer i
      integer fd(IO_NUM_FILES)
      integer buf_sz
c     
      buf_sz = (IO_TEST_SZ*eaf_util_szint())
c
c     write(6,*)
c     write(6,*) ' TEST 1 ... synchronous read/write of multiple files'
c     write(6,*) ' ---------------------------------------------------'
c     write(6,*)
c     
      do fnum = 1, IO_NUM_FILES
         write (fname, 10) FNAME, fnum, ga_nodeid()

 10      format (A,'.', I1,'.',I4.4)
         call testerr(eaf_open(fname, eaf_rw, fd(fnum)))

c        print *, 'testing EAF_Write'
         do iter = 1, MAX_ITER
            do i = 1, IO_TEST_SZ
               buf(i) = i + fnum + (iter*10000)
            enddo
            call testerr(eaf_write(fd(fnum), 
     $           DMAP(iter),
     $           buf(1), buf_sz))
         enddo
      enddo
c     
      do fnum = 1, IO_NUM_FILES
c        call eaf_print_stats(fd(fnum))
         call testerr(eaf_close(fd(fnum)))
      enddo
      if (ga_nodeid().eq.0) then
         write(6,'(A)') ' eaf_open ......................... OK'
         write(6,'(A)') ' eaf_write ........................ OK'
         call ffflush(6)
      endif
c     
c.................................
c     
      do fnum = 1, IO_NUM_FILES
         write (fname, 10) FNAME, fnum, ga_nodeid()
c     
         call testerr(eaf_open(fname, eaf_r, fd(fnum)))
c     
c        print *, 'testing EAF_Read'
         do iter = 1, MAX_ITER
            do i = 1, IO_TEST_SZ
               buf(i) = i + fnum + (iter*10000)
            enddo
c     
            call testerr(eaf_read(fd(fnum), 
     $           DMAP(iter), 
     $           buf2(1), buf_sz))
            do i = 1, IO_TEST_SZ
               if(buf(i) .ne. buf2(i)) then 
                  write(6,*) 'Bad read of file=',fnum,
     $                 '  iter=',iter,'  offset=',i,'   buf1=',
     $                 buf(i),'  buf2=',buf2(i)
                  stop 1
               endif
            enddo
         enddo
      enddo
c     
      do fnum = 1, IO_NUM_FILES
c        call eaf_print_stats(fd(fnum))
         call testerr(eaf_close(fd(fnum)))
         write (fname, 10) FNAME, fnum, ga_nodeid()
         call testerr(eaf_delete(fname))
      enddo
      if (ga_nodeid().eq.0) then
         write(6,'(A)') ' eaf_read ......................... OK'
         write(6,'(A)') ' eaf_close ........................ OK'
         write(6,'(A)') ' eaf_delete ....................... OK'
         call ffflush(6)
      endif
c     
      end
      subroutine testerr(code)
      implicit none
#include "eaf.fh"
      integer code
      character*80 msg
      integer fstrlen
      external fstrlen
c     
      if (code .eq. 0) return
      call eaf_errmsg(code, msg)
      write(6,*) ' code ', code, ' = ', msg(1:fstrlen(msg))
***   stop 1
c
      end
      integer function fstrlen(a)
      implicit none
      character*(*) a
      integer i
      intrinsic len
c     
      do i = len(a),1,-1
         if (a(i:i) .ne. ' ') goto 10
      enddo
c     
 10   fstrlen = i
c     
      end
      subroutine test3
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "eaf.fh"
      character fname*200
      character*8 fstype
      integer avail, fd
      double precision length
c
c     write(6,*)
c     write(6,*) ' TEST 3 ... misc. functions'
c     write(6,*) ' --------------------------'
c     write(6,*)
c
      write (fname, 10) FNAME, 1, ga_nodeid()
 10   format (A,'.', I1,'.',I4.4)
c
      call testerr(eaf_stat(fname, avail, fstype))
c     write(6,*) ' avail = ', avail, ' fstype = ', fstype
c
      call testerr(eaf_open(fname, eaf_rw, fd))
      call testerr(eaf_length(fd,length))
c     write(6,*) ' file length = ', length
      call testerr(eaf_truncate(fd,129.0d0))
      call testerr(eaf_length(fd,length))
c     write(6,*) ' file length (should be 129) = ', length
      if (length .eq. 129.0d0) then
      if (ga_nodeid().eq.0) then
         write(6,'(A)') ' eaf_truncate ..................... OK'
         write(6,'(A)') ' eaf_length ....................... OK'
         call ffflush(6)
      endif
      else
         write(6,*) 'eaf_length, eaf_truncate error'
         stop
      endif
      call testerr(eaf_close(fd))
c
c     write(6,*) ' This delete should succeed'
      call testerr(eaf_delete(fname))
c
      call testerr(eaf_open(fname, eaf_rw, fd))
      call testerr(eaf_length(fd,length))
c     write(6,*) ' should be zero file length = ', length
      if (length .eq. 0.0d0) then
      if (ga_nodeid().eq.0) then
         write(6,'(A)') ' eaf_length (empty file) .......... OK'
         call ffflush(6)
      endif
      else
         write(6,*) 'eaf_length error'
         stop
      endif
      call testerr(eaf_close(fd))
      call testerr(eaf_delete(fname))
c
      end
      subroutine test4
      implicit none
#include "global.fh"
#include "eaf.fh"
      character*200 fname
      character*255 fstype
      integer avail, fd, i, nwrite, ierr, iolen4, iolen, loop
      integer offset, length
      double precision ofw
      double precision buf(IO_TEST_SZ)
c
      write(6,*)
      write(6,*) ' TEST 4 ... fill the file system '
      write(6,*) ' ------------------------------- '
      write(6,*)
c
      fname = ' '
      write (fname, 10) FNAME, 1, ga_nodeid()
 10   format (A,'.', I1,'.',I4.4)
c
      call testerr(eaf_stat(fname, avail, fstype))
      write(6,*) ' avail = ', avail, ' fstype = ', fstype
      avail = 0.95*avail
      length = 1024*1024.0d0*avail
      call testerr(eaf_open(fname, eaf_rw, fd))
      if(length.gt. MAX_FILE_SZ) then
         length = MAX_FILE_SZ
         write(6,*) ' trying max file length ', length,' bytes'
      else
         write(6,*) ' 95% available length ', length,' bytes'
      endif
c
      ofw = 0
      do offset = 0, length, (IO_TEST_SZ)*8
         nwrite = nint(min(length-offset+1.0d0,(IO_TEST_SZ)*8.0d0))
         call util_dfill_eaf(nwrite/8, dble(offset), buf, 1)
         if (ofw .le. offset) then
            write(6,*) ' writing at ',offset, nwrite
            ofw = ofw + 100000000.0d0
         endif
         ierr = eaf_write(fd, offset, buf, nwrite)
         if (ierr .ne. 0) then
           call testerr(ierr)
           call ga_error('bad write',ierr)
         endif
      enddo
c
      call eaf_print_stats(fd)
c
      ofw = 0
      do offset = 0, length, (IO_TEST_SZ)*8
         nwrite = nint(min(length-offset+1.0d0,(IO_TEST_SZ)*8.0d0))
         if (ofw .le. offset) then
            write(6,*) ' reading at ', offset, nwrite
            ofw = ofw + 100000000.0d0
         endif
         ierr = eaf_read(fd, offset, buf, nwrite)
         if (ierr .ne. 0) then
           call testerr(ierr)
           call ga_error('bad read',ierr)
         endif
         do i = 1, nwrite/8
            if (buf(i).ne.offset) call ga_error('bad ', i)
         enddo
      enddo
c
      call eaf_print_stats(fd)
c
      call testerr(eaf_close(fd))
c
c     random read and write
c
      buf(1) = eaf_util_random(35321)
      do iolen4 = 0,2
         iolen = 8*1024 * (4**iolen4)   ! 1024,4096,16384 doubles
         write(6,*) ' Random write: len=',iolen
         call testerr(eaf_open(fname, eaf_rw, fd))
         do loop = 1, int(length/iolen)/4
           offset = aint((length-iolen)*eaf_util_random(0))
           ierr = eaf_write(fd, offset, buf, iolen)
           if (ierr .ne. 0) then
             call testerr(ierr)
             call ga_error('bad write',ierr)
           endif
         enddo
         call eaf_print_stats(fd)
         write(6,*) ' Random read : len=',iolen
         call testerr(eaf_open(fname, eaf_rw, fd))
         do loop = 1, int(length/iolen)/4
           offset = aint((length-iolen)*eaf_util_random(0))
           ierr = eaf_read(fd, offset, buf, iolen)
           if (ierr .ne. 0) then
             call testerr(ierr)
             call ga_error('bad write',ierr)
           endif
         enddo
         call eaf_print_stats(fd)
         call testerr(eaf_close(fd))
      enddo
c
      call testerr(eaf_delete(fname))
c
      end

      subroutine util_dfill_eaf(n,val,a,ia)
      implicit none
      double precision  a(*), val
      integer n, ia, i
c
c     initialise double precision array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
      end

c $Id: util_eaf_test.F 21910 2012-02-01 21:38:29Z d3y133 $

      subroutine tce_residual_t1(d_r1,k_r1_offset,residual)
c
c $Id: tce_residual_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r1
      integer p1b
      integer h2b
      integer k_r1_offset
      integer size
      integer l_r1,k_r1
      integer g_residual
      double precision residual
      integer nprocs
      integer count
      integer next
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
c
c     new
c
      if (fileisga(d_r1)) then
        residual = ga_ddot(d_r1,d_r1)
        return
      endif
c
c     =====================
c     Zero scratch residual
c     =====================
c
      nodezero = (ga_nodeid().eq.0)
      if (.not.ga_create(mt_dbl,1,1,'residual',1,1,g_residual))
     1  call errquit('tce_residual_t1: GA problem',0,GA_ERR)
      residual = 0.0d0
      call ga_put(g_residual,1,1,1,1,residual,1)
      call ga_sync()
c
c     ================
c     Loop over blocks
c     ================
c
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (next.eq.count) then
            if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1)).eq.0) then
              size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
              if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1          call errquit('tce_residual_t1: MA problem',0,MA_ERR)
              call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1          int_mb(k_r1_offset),((p1b-noab-1)*noab+h2b-1))
              if (nodezero.and.util_print('residual',
     1          print_debug)) call ma_print_compact
     2          (dbl_mb(k_r1),size,1,'t1 residual')
              residual = ddot(size,dbl_mb(k_r1),1,dbl_mb(k_r1),1)
              call ga_acc(g_residual,1,1,1,1,residual,1,1.0d0)
              if (.not.ma_pop_stack(l_r1))
     1          call errquit('tce_residual_t1: MA problem',1,MA_ERR)
            endif
            endif
            endif
cc            next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      call ga_get(g_residual,1,1,1,1,residual,1)
      residual = 0.5d0*dsqrt(residual)
      if (.not.ga_destroy(g_residual))
     1  call errquit('tce_residual_t1: GA problem',1,GA_ERR)
      return
      end










      subroutine tce_residual_tr1(d_r1,k_r1_offset,residual)
c
c $Id: tce_residual_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r1
      integer p1b
      integer h2b
      integer k_r1_offset
      integer size
      integer l_r1,k_r1
      integer g_residual
      double precision residual
      integer nprocs
      integer count
      integer next
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
c
c     new
c
      if (fileisga(d_r1)) then
        residual = ga_ddot(d_r1,d_r1)
        return
      endif
c
c     =====================
c     Zero scratch residual
c     =====================
c
      nodezero = (ga_nodeid().eq.0)
      if (.not.ga_create(mt_dbl,1,1,'residual',1,1,g_residual))
     1  call errquit('tce_residual_tr1: GA problem',0,GA_ERR)
      residual = 0.0d0
      call ga_put(g_residual,1,1,1,1,residual,1)
      call ga_sync()
c
c     ================
c     Loop over blocks
c     ================
c
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (next.eq.count) then
            if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1)).eq.
     1        irrep_x) then
              size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
              if (.not.ma_push_get(mt_dbl,size,'rr1',l_r1,k_r1))
     1          call errquit('tce_residual_t1: MA problem',0,MA_ERR)
              call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1          int_mb(k_r1_offset),((p1b-noab-1)*noab+h2b-1))
              if (nodezero.and.util_print('residual',
     1          print_debug)) call ma_print_compact
     2          (dbl_mb(k_r1),size,1,'tr1 residual')
              residual = ddot(size,dbl_mb(k_r1),1,dbl_mb(k_r1),1)
              call ga_acc(g_residual,1,1,1,1,residual,1,1.0d0)
              if (.not.ma_pop_stack(l_r1))
     1          call errquit('tce_residual_tr1: MA problem',1,MA_ERR)
            endif
            endif
            endif
cc            next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      call ga_get(g_residual,1,1,1,1,residual,1)
      residual = 0.5d0*dsqrt(residual)
      if (.not.ga_destroy(g_residual))
     1  call errquit('tce_residual_tr1: GA problem',1,GA_ERR)
      return
      end

      subroutine argos_space_prtcnt(lcnt)
c
      implicit none
c
#include "argos_space_common.fh"
#include "msgids.fh"
#include "global.fh"
c
      integer lcnt(np,3)
c
      integer i,j
c
      do 1 i=1,np
      lcnt(i,1)=0
      lcnt(i,2)=0
      lcnt(i,3)=0
    1 continue
c
      lcnt(me+1,1)=mbxloc
      lcnt(me+1,2)=nwmloc*nwa
      lcnt(me+1,3)=nsaloc
c
      if(np.gt.1) call ga_igop(msp_08,lcnt,3*np,'+')
c
      if(me.eq.0) then
      write(lfnout,1000)
 1000 format(/,' Initial distribution p:b(w+s)',/)
      write(lfnout,1001) (i-1,(lcnt(i,j),j=1,3),i=1,np)
 1001 format(4(3x,i4,':',i5,'(',i7,'+',i7,')'))
      write(lfnout,1002) mwm,msa
 1002 format(/,' Dimension workarrays solvent ',i6,/,
     + 22x,'solute  ',i6)
      endif
c
      return
      end
c $Id: argos_space_prtcnt.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_alpha
c $Id: argos_cafe_alpha.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "argos_cafe_common.fh"
#include "argos_cafe_funcs_dec.fh"
c
      real*8 a,alow,ahigh,b
      integer i,n
c
#include "argos_cafe_funcs_sfn.fh"
c
      a=half
      i=0
    1 continue
      a=two*a
      i=i+1
      b=(erfc(a*rlong))/rlong
      if(b.ge.pmetol) goto 1
c
      n=i+60
      alow=zero
      ahigh=a
      do 2 i=1,n
      a=half*(alow+ahigh)
      b=(erfc(a*rlong))/rlong
      if(b.ge.pmetol) then
      alow=a
      else
      ahigh=a
      endif
    2 continue
      ealpha=a
c
      return
      end

      SUBROUTINE ccsdt_lambda2_10_8(d_a,k_a_offset,d_b,k_b_offset,d_c,k_
     &c_offset)
C     $Id: ccsdt_lambda2_10_8.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p13 h12 )_vt + = 1/4 * Sum ( h9 h10 p6 p7 ) * t ( p6 p7 p13 h9 h10 h12 )_t * v ( h9 h10 p6 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER h12b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p7b
      INTEGER h9b
      INTEGER h10b
      INTEGER p13b_1
      INTEGER p6b_1
      INTEGER p7b_1
      INTEGER h12b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p13b = noab+1,noab+nvab
      DO h12b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p13b-1)+int_mb(k_spin+h12b
     &-1).ne.4)) THEN
      IF (int_mb(k_spin+p13b-1) .eq. int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),int_mb(k_sym+h12b-1)) .eq. ieor(irre
     &p_v,irrep_t)) THEN
      dimc = int_mb(k_range+p13b-1) * int_mb(k_range+h12b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lambda2_10_8',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1
     &) .eq. int_mb(k_spin+h12b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h1
     &0b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb
     &(k_sym+p7b-1),ieor(int_mb(k_sym+h12b-1),ieor(int_mb(k_sym+h9b-1),i
     &nt_mb(k_sym+h10b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p13b,p6b,p7b,h12b,h9b,h10b,p13b_1,p6b_1,p7b_
     &1,h12b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_4(h9b,h10b,p6b,p7b,h9b_2,h10b_2,p6b_2,p7b_2)
      dim_common = int_mb(k_range+p6b-1) * int_mb(k_range+p7b-1) * int_m
     &b(k_range+h9b-1) * int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p13b-1) * int_mb(k_range+h12b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lambda2_10_8',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lambda2_10_8',2,MA_ERR)
      IF ((p7b .le. p13b) .and. (h10b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (p13b_1 - 
     &noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p13b-1),int_mb(k_range+h9b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h12b-1),6,3,5,4,2,1,1.0d0)
      END IF
      IF ((p7b .le. p13b) .and. (h9b .le. h12b) .and. (h12b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (h9b_1 - 1 + noab * (p13b_1 - 
     &noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p13b-1),int_mb(k_range+h9b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h10b-1),5,3,6,4,2,1,-1.0d0
     &)
      END IF
      IF ((p7b .le. p13b) .and. (h12b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h12b_1 - 1 + noab * (p13b_1 - 
     &noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p13b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),4,3,6,5,2,1,1.0d0)
      END IF
      IF ((p6b .le. p13b) .and. (p13b .lt. p7b) .and. (h10b .le. h12b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p6b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h12b-1),6,2,5,4,3,1,-1.0d0
     &)
      END IF
      IF ((p6b .le. p13b) .and. (p13b .lt. p7b) .and. (h9b .le. h12b) .a
     &nd. (h12b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (h9b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p6b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h10b-1),5,2,6,4,3,1,1.0d0)
      END IF
      IF ((p6b .le. p13b) .and. (p13b .lt. p7b) .and. (h12b .lt. h9b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h12b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p6b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p7b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),4,2,6,5,3,1,-1.0d0
     &)
      END IF
      IF ((p13b .lt. p6b) .and. (h10b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p13b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h12b-1),6,1,5,4,3,2,1.0d0)
      END IF
      IF ((p13b .lt. p6b) .and. (h9b .le. h12b) .and. (h12b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (h9b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p13b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h10b-1),5,1,6,4,3,2,-1.0d0
     &)
      END IF
      IF ((p13b .lt. p6b) .and. (h12b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (h12b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p13b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),4,1,6,5,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lambda2_10_8',3,MA
     &_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lambda2_10_8',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lambda2_10_8',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (h10b_2 - 1 + (noa
     &b+nvab) * (h9b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lambda2_10_8',6,MA
     &_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p6b .eq. p7b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h9b .eq. h10b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lambda2_10_8'
     &,7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lambda2_10_8'
     &,8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lambda2_10_8',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+p13b-1),2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h12b 
     &- 1 + noab * (p13b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lambda2_10_8',10,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lambda2_10_8'
     &,11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_rdrest(lfn,fil)
c
      implicit none
c
#include "argos.fh"
c
      integer lfn
      character*255 fil
c
      character*13 string
c
      if(me.eq.0) then
      open(unit=lfn,file=fil(1:index(fil,' ')-1),
     + status='old',form='formatted',err=9999)
      rewind(lfn)
c
    1 continue
      read(lfn,1000,end=9997) string
 1000 format(a13)
      if(string.ne.'restart input') goto 1
      read(lfn,1001,end=9998,err=9998) ntype,mdtype
 1001 format(11i7)
      read(lfn,1001) nfpair,nflong
      read(lfn,1001) lwtype,lstype,nfrest,keepr
      if(nserie.eq.1) then
      read(lfn,1002) krun,kequi,kdacq,mrun,mequi,mdacq,ldacq
 1002 format(7i7)
      else
      read(lfn,1002) krun,kequi,kdacq
      endif
      read(lfn,1003) stime,tstep
 1003 format(2f12.6)
      read(lfn,1004) rshort,rlong
 1004 format(2f12.6)
      read(lfn,1005) mshitw,tlwsha
      read(lfn,1005) mshits,tlssha
 1005 format(i7,f12.6)
      read(lfn,1006) ipscal,prsext,prsrlx,compr,ipopt
 1006 format(i5,e12.5,f12.6,e12.5,i5)
      read(lfn,1007) itscal,tmpext1,tmprlx,tmsrlx,tmpext2,
     + tann1,tann2
 1007 format(i5,6f12.6)
      read(lfn,1008) nfgaus,ivopt,tgauss,iseed
 1008 format(2i7,f12.6,i12)
      read(lfn,1009) nfoutp,nfstat,nfprop,nfnewf,ibatch
 1009 format(11i7)
      read(lfn,1009) ibinar,iformt
      read(lfn,1009) nfcoor,nfscoo,nfvelo,nfsvel,nfforc,nfsfor
      read(lfn,1009) nffree
      read(lfn,1009) nfcntr,nfslow
      read(lfn,1010) nfrdf,numrdf,ngc,ngr,ngl,ngrww,ngrsw,ngrss
 1010 format(8i7)
      read(lfn,1011) rrdf,drdf
 1011 format(2f12.6)
      read(lfn,1012) numdis,lendis
 1012 format(2i7)
      read(lfn,1013) numhis,lenhis
 1013 format(11i7)
      read(lfn,1014) nfdip,ndip,rdip
 1014 format(2i7,f12.6)
      read(lfn,1015) nfkirk,nkirk,rkirk
 1015 format(2i7,f12.6)
      endif
c
 9997 continue
      if(me.eq.0) close(unit=lfn)
      return
c
 9998 continue
      call md_abort('Unable to read restart file in argos_rest ',me)
      return
 9999 continue
      call md_abort('Unable to open restart file in argos_rest ',me)
      return
      end
c $Id: argos_rdrest.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsd_t_doubles_l_6dts(a_i0,
     &d_t2,d_v2,k_t2_offset,k_v2_offset,t
     &_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,toggle,
     &istart,istop,jstart,jstop,maxp4,maxp5)
C     $Id: ccsd_t_doubles_l_6dts.F 25597 2014-05-12 18:38:04Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = -1 * P( 9 ) * Sum ( h7 ) * t ( p4 p5 h1 h7 )_t * v ( h7 p6 h2 h3 )_v
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = -1 * P( 9 ) * Sum ( p7 ) * t ( p4 p7 h1 h2 )_t * v ( p5 p6 h3 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER toggle
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_v2
      INTEGER k_v2_offset
c -- 6DTS --
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
c ----------
      DOUBLE PRECISION a_i0(*)
c *** debug ***
c      write(6,*)'I am in ccsd_t_doubles',ga_nodeid()
c      call util_flush(6)
c *************
      IF (toggle .eq. 2) CALL ccsd_t_6dts_l_1(d_t2,
     &k_t2_offset,d_v2,k_v
     &2_offset,a_i0,t_p4b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b,
     &istart,istop,jstart,jstop,maxp4,maxp5)
      IF (toggle .eq. 2) CALL ccsd_t_6dts_l_2(d_t2,
     &k_t2_offset,d_v2,k_v
     &2_offset,a_i0,t_p4b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b,
     &istart,istop,jstart,jstop,maxp4,maxp5)
      RETURN
      END
      SUBROUTINE ccsd_t_6dts_l_1(d_a,k_a_offset,d_b,k_b_offset,
     &a_c,t_p4
     &b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b,
     &istart,istop,jstart,jstop,maxp4,maxp5)
C     $Id: ccsd_t_doubles_l_6dts.F 25597 2014-05-12 18:38:04Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = -1 * P( 9 ) * Sum ( h7 ) * t ( p4 p5 h1 h7 )_t * v ( h7 p6 h2 h3 )_v
c
c elimination of the transpositions (kowalski,august,2009)
c
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h7b
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER h7b_1
      INTEGER p6b_2
      INTEGER h7b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
c -- peta-exa --
      INTEGER a3(9,6)
      INTEGER ia6,ja6
c --------------
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
c --------------
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
c
cc      DO p4b = noab+1,noab+nvab
cc      DO p5b = p4b,noab+nvab
cc      DO p6b = noab+1,noab+nvab
cc      DO h1b = 1,noab
cc      DO h2b = 1,noab
cc      DO h3b = h2b,noab
c
c *** debug ***
c        write(6,*)'step1',ga_nodeid()
c        call util_flush(6)
c *************
        a3(1,1)=t_p4b
        a3(1,2)=t_p5b
        a3(1,3)=t_p6b
        a3(1,4)=t_h1b
        a3(1,5)=t_h2b
        a3(1,6)=t_h3b
c
        a3(2,1)=t_p4b
        a3(2,2)=t_p5b
        a3(2,3)=t_p6b
        a3(2,4)=t_h2b
        a3(2,5)=t_h1b
        a3(2,6)=t_h3b
c
        a3(3,1)=t_p4b
        a3(3,2)=t_p5b
        a3(3,3)=t_p6b
        a3(3,4)=t_h3b
        a3(3,5)=t_h1b
        a3(3,6)=t_h2b
c
        a3(4,1)=t_p5b
        a3(4,2)=t_p6b
        a3(4,3)=t_p4b
        a3(4,4)=t_h1b
        a3(4,5)=t_h2b
        a3(4,6)=t_h3b
c
        a3(5,1)=t_p5b
        a3(5,2)=t_p6b
        a3(5,3)=t_p4b
        a3(5,4)=t_h2b
        a3(5,5)=t_h1b
        a3(5,6)=t_h3b
c
        a3(6,1)=t_p5b
        a3(6,2)=t_p6b
        a3(6,3)=t_p4b
        a3(6,4)=t_h3b
        a3(6,5)=t_h1b
        a3(6,6)=t_h2b
c
        a3(7,1)=t_p4b
        a3(7,2)=t_p6b
        a3(7,3)=t_p5b
        a3(7,4)=t_h1b
        a3(7,5)=t_h2b
        a3(7,6)=t_h3b
c
        a3(8,1)=t_p4b
        a3(8,2)=t_p6b
        a3(8,3)=t_p5b
        a3(8,4)=t_h2b
        a3(8,5)=t_h1b
        a3(8,6)=t_h3b
c
        a3(9,1)=t_p4b
        a3(9,2)=t_p6b
        a3(9,3)=t_p5b
        a3(9,4)=t_h3b
        a3(9,5)=t_h1b
        a3(9,6)=t_h2b
c
        do ia6=1,8
         if(a3(ia6,1).ne.0) then
         do ja6=ia6+1,9
          if((a3(ia6,1).eq.a3(ja6,1)).and.(a3(ia6,2).eq.a3(ja6,2))
     &     .and.(a3(ia6,3).eq.a3(ja6,3)).and.(a3(ia6,4).eq.a3(ja6,4))
     &     .and.(a3(ia6,5).eq.a3(ja6,5)).and.(a3(ia6,6).eq.a3(ja6,6)))
     &     then
           a3(ja6,1)=0
           a3(ja6,2)=0
           a3(ja6,3)=0
           a3(ja6,4)=0
           a3(ja6,5)=0
           a3(ja6,6)=0
          end if
         enddo 
         end if
        enddo 
c *** debug ***
c        write(6,*)'step2',ga_nodeid()
c        call util_flush(6)
c *************
c
      do ia6=1,9
      p4b=a3(ia6,1)
      p5b=a3(ia6,2)
      p6b=a3(ia6,3)
      h1b=a3(ia6,4)
      h2b=a3(ia6,5)
      h3b=a3(ia6,6)
      if((p4b.le.p5b).and.(h2b.le.h3b).and.(p4b.ne.0)) then
      skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+p6b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
c
ccx      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
ccx     & ERRQUIT('ccsd_t_doubles_1',0,MA_ERR)
ccx      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1) !not created here
c
      DO h7b = 1,noab
c *** debug ***
c        write(6,*)'step3-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h7b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p4b,p5b,h1b,h7b,p4b_1,p5b_1,h1b_1,h7b_1)
      CALL TCE_RESTRICTED_4(p6b,h7b,h2b,h3b,p6b_2,h7b_2,h2b_2,h3b_2)
      dim_common = int_mb(k_range+h7b-1)
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb
     &(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+h2b-1) * int_mb
     &(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_t_doubles_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_t_doubles_1',2,MA_ERR)
c *** debug ***
c        write(6,*)'step4-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((h7b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h7b-1),int_mb(k_range+h1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
c *** debug ***
c        write(6,*)'step5-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((h1b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h7b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_t_doubles_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_t_doubles_1',4,MA_ERR)
ccx      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
ccx     &ccsd_t_doubles_1',5,MA_ERR)
c *** debug ***
c        write(6,*)'step6-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((h7b .le. p6b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b_sort),
     &dimb,int_mb(k_b_offset),(h3b_2
     & - 1 + (noab+nvab) * (h2b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (h7b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b_sort),
     &dimb,int_mb(k_b_offset),
     &(h3b_2
     & - 1 + (noab+nvab) * (h2b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (h7b_2 - 1)))),h3b_2,h2b_2,p6b_2,h7b_2)
      end if
ccx      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
ccx     &,int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1)
ccx     &,4,3,2,1,1.0d0)
      END IF
ccx      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_t_doubles_1',6,MA_E
ccx     &RR)
c *** debug ***
c        write(6,*)'step7-h7b loop last before if-s',ga_nodeid()
c        call util_flush(6)
c *************
c
ccx      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
ccx     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
ccx     &t),dima_sort)
c
c  no need to zero d_c - it has already been done in ccsd_t
c  k_c_sort is not used here
c
c contributions are calculated here
c
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,5,3,4,2,1,-1.0d0)
      call sd_tx1_1(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 1',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step7a-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,5,3,2,4,1,1.0d0)
      call sd_tx1_2(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 2',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step8-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,5,3,2,1,4,-1.0d0)
      call sd_tx1_3(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 3',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step9-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p6b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p5b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),3,6,5,4,2,1,-1.0d0)
      call sd_tx1_4(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 4',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step10-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p6b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p5b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),3,6,5,2,4,1,1.0d0)
      call sd_tx1_5(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 5',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step11-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p6b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p5b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),3,6,5,2,1,4,-1.0d0)
      call sd_tx1_6(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 6',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step12-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p5b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,3,5,4,2,1,1.0d0)
      call sd_tx1_7(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 7',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step13-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p5b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,3,5,2,4,1,-1.0d0)
      call sd_tx1_8(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 8',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step14-h7b loop',ga_nodeid()
c        call util_flush(6)
c *************
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p5b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
ccx     &mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,3,5,2,1,4,1.0d0)
      call sd_tx1_9(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+h7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)
c *** debug ***
c         write(6,*)'   after 9',ga_nodeid()
c         call util_flush(6)
c *************
      END IF
c *** debug ***
c        write(6,*)'step15-h7b loop',ga_nodeid()
c        call util_flush(6)
c
c
c
c
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_t_doubles_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_t_doubles_1',8
     &,MA_ERR)
c
      END IF
      END IF
      END IF
      END DO !h7b loop
c
      END IF
      END IF
      END IF
      END IF
c
      END IF
      END DO
      RETURN
      END
      SUBROUTINE ccsd_t_6dts_l_2(d_a,k_a_offset,d_b,k_b_offset,
     &a_c,t_p4
     &b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b,
     &istart,istop,jstart,jstop,maxp4,maxp5)
C     $Id: ccsd_t_doubles_l_6dts.F 25597 2014-05-12 18:38:04Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = -1 * P( 9 ) * Sum ( p7 ) * t ( p4 p7 h1 h2 )_t * v ( p5 p6 h3 p7 )_v
c
c elimination of the transpositions (kowalski,august,2009)
c
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p4b_1
      INTEGER p7b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER h3b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
c --------------
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
c -- peta-exa --
      INTEGER a3(9,6)
      INTEGER ia6,ja6
c --------------
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
c
cc      DO p4b = noab+1,noab+nvab
cc      DO p5b = noab+1,noab+nvab
cc      DO p6b = p5b,noab+nvab
cc      DO h1b = 1,noab
cc      DO h2b = h1b,noab
cc      DO h3b = 1,noab
c
        a3(1,1)=t_p4b
        a3(1,2)=t_p5b
        a3(1,3)=t_p6b
        a3(1,4)=t_h1b
        a3(1,5)=t_h2b
        a3(1,6)=t_h3b
c
        a3(2,1)=t_p4b
        a3(2,2)=t_p5b
        a3(2,3)=t_p6b
        a3(2,4)=t_h2b
        a3(2,5)=t_h3b
        a3(2,6)=t_h1b
c
        a3(3,1)=t_p4b
        a3(3,2)=t_p5b
        a3(3,3)=t_p6b
        a3(3,4)=t_h1b
        a3(3,5)=t_h3b
        a3(3,6)=t_h2b
c
        a3(4,1)=t_p5b
        a3(4,2)=t_p4b
        a3(4,3)=t_p6b
        a3(4,4)=t_h1b
        a3(4,5)=t_h2b
        a3(4,6)=t_h3b
c
        a3(5,1)=t_p5b
        a3(5,2)=t_p4b
        a3(5,3)=t_p6b
        a3(5,4)=t_h2b
        a3(5,5)=t_h3b
        a3(5,6)=t_h1b
c
        a3(6,1)=t_p5b
        a3(6,2)=t_p4b
        a3(6,3)=t_p6b
        a3(6,4)=t_h1b
        a3(6,5)=t_h3b
        a3(6,6)=t_h2b
c
        a3(7,1)=t_p6b
        a3(7,2)=t_p4b
        a3(7,3)=t_p5b
        a3(7,4)=t_h1b
        a3(7,5)=t_h2b
        a3(7,6)=t_h3b
c
        a3(8,1)=t_p6b
        a3(8,2)=t_p4b
        a3(8,3)=t_p5b
        a3(8,4)=t_h2b
        a3(8,5)=t_h3b
        a3(8,6)=t_h1b
c
        a3(9,1)=t_p6b
        a3(9,2)=t_p4b
        a3(9,3)=t_p5b
        a3(9,4)=t_h1b
        a3(9,5)=t_h3b
        a3(9,6)=t_h2b
c
        do ia6=1,8
         if(a3(ia6,1).ne.0) then
         do ja6=ia6+1,9
          if((a3(ia6,1).eq.a3(ja6,1)).and.(a3(ia6,2).eq.a3(ja6,2))
     &     .and.(a3(ia6,3).eq.a3(ja6,3)).and.(a3(ia6,4).eq.a3(ja6,4))
     &     .and.(a3(ia6,5).eq.a3(ja6,5)).and.(a3(ia6,6).eq.a3(ja6,6)))
     &     then
           a3(ja6,1)=0
           a3(ja6,2)=0
           a3(ja6,3)=0
           a3(ja6,4)=0
           a3(ja6,5)=0
           a3(ja6,6)=0
          end if
         enddo 
         end if
        enddo 
c
      do ia6=1,9
      p4b=a3(ia6,1)
      p5b=a3(ia6,2)
      p6b=a3(ia6,3)
      h1b=a3(ia6,4)
      h2b=a3(ia6,5)
      h3b=a3(ia6,6)
      if((p5b.le.p6b).and.(h1b.le.h2b).and.(p4b.ne.0)) then
      skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+p6b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
ccx      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
ccx     & ERRQUIT('ccsd_t_doubles_2',0,MA_ERR)
ccx      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p4b,p7b,h1b,h2b,p4b_1,p7b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(p5b,p6b,h3b,p7b,p5b_2,p6b_2,h3b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1)
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_t_doubles_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_t_doubles_2',2,MA_ERR)
      IF ((p7b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p7b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p4b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p7b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_t_doubles_2',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_t_doubles_2',4,MA_ERR)
ccx      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
ccx     &ccsd_t_doubles_2',5,MA_ERR)
      IF ((h3b .le. p7b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b_sort),dimb,
     &int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (p5b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b_sort),
     &dimb,int_mb(k_b_offset),
     &(p7b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (p5b_2 - 1)))),p7b_2,h3b_2,p6b_2,p5b_2)
      end if
ccx      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
ccx     &,int_mb(k_range+p6b-1),int_mb(k_range+h3b-1),int_mb(k_range+p7b-1)
ccx     &,3,2,1,4,1.0d0)
      END IF
ccx      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_t_doubles_2',6,MA_E
ccx     &RR)
c
ccx      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
ccx     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
ccx     &t),dima_sort)
c
c  no need to zero d_c - it has already been done in ccsd_t
c  k_c_sort is not used here
c
c contributions are calculated here
c


      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,3,2,5,4,1,-1.0d0)

      call sd_ty1_1(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)


      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,3,2,1,5,4,-1.0d0)

      call sd_ty1_2(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,3,2,5,1,4,1.0d0)

      call sd_ty1_3(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,6,2,5,4,1,1.0d0)

      call sd_ty1_4(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,6,2,1,5,4,1.0d0)

      call sd_ty1_5(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,6,2,5,1,4,-1.0d0)

      call sd_ty1_6(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,2,6,5,4,1,-1.0d0)

      call sd_ty1_7(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,2,6,1,5,4,-1.0d0)

      call sd_ty1_8(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,2,6,5,1,4,1.0d0)

      call sd_ty1_9(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     3               int_mb(k_range+p7b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort),
     5 istart,istop,jstart,jstop,maxp4,maxp5)

      END IF


      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_t_doubles_2',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_t_doubles_2',8
     &,MA_ERR)


      END IF
      END IF
      END IF
      END DO ! p7b loop
c
      END IF
      END IF
      END IF
      END IF
c
      END IF
      END DO
      RETURN
      END
c
c
c
c
c
c
      subroutine sd_tx1_1(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h2d,h1d,p6d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p4=istart,istop
      do p5=jstart,jstop
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h2,h1,p6,p5-jstart+1,p4-istart+1)=
     1     triplesx(h3,h2,h1,p6,p5-jstart+1,p4-istart+1)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_tx1_2(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h1d,h2d,p6d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p4=istart,istop
      do p5=jstart,jstop
      do p6=1,p6d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h1,h2,p6,p5-jstart+1,p4-istart+1)=
     1     triplesx(h3,h1,h2,p6,p5-jstart+1,p4-istart+1)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo  
      enddo
      return
      end
c
      subroutine sd_tx1_3(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h1d,h3d,h2d,p6d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p4=istart,istop
      do p5=jstart,jstop
      do p6=1,p6d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
      do h7=1,h7d
       triplesx(h1,h3,h2,p6,p5-jstart+1,p4-istart+1)=
     1     triplesx(h1,h3,h2,p6,p5-jstart+1,p4-istart+1)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_tx1_4(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h2d,h1d,p5d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p6=istart,istop
      do p4=jstart,jstop
      do p5=1,p5d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h2,h1,p5,p4-jstart+1,p6-istart+1)=
     1     triplesx(h3,h2,h1,p5,p4-jstart+1,p6-istart+1)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_tx1_5(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h1d,h2d,p5d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p6=istart,istop
      do p4=jstart,jstop
      do p5=1,p5d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h1,h2,p5,p4-jstart+1,p6-istart+1)=
     1     triplesx(h3,h1,h2,p5,p4-jstart+1,p6-istart+1)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_tx1_6(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h1d,h3d,h2d,p5d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p6=istart,istop
      do p4=jstart,jstop
      do p5=1,p5d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
      do h7=1,h7d
       triplesx(h1,h3,h2,p5,p4-jstart+1,p6-istart+1)=
     1     triplesx(h1,h3,h2,p5,p4-jstart+1,p6-istart+1)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_tx1_7(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h2d,h1d,p5d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p4=istart,istop
      do p6=jstart,jstop
      do p5=1,p5d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h2,h1,p5,p6-jstart+1,p4-istart+1)=
     1     triplesx(h3,h2,h1,p5,p6-jstart+1,p4-istart+1)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_tx1_8(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h3d,h1d,h2d,p5d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p4=istart,istop
      do p6=jstart,jstop
      do p5=1,p5d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
      do h7=1,h7d
       triplesx(h3,h1,h2,p5,p6-jstart+1,p4-istart+1)=
     1     triplesx(h3,h1,h2,p5,p6-jstart+1,p4-istart+1)
     1   - t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_tx1_9(h3d,h2d,h1d,p6d,p5d,p4d,
     1               h7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,h7d
      integer h3,h2,h1,p6,p5,p4,h7
      double precision triplesx(h1d,h3d,h2d,p5d,maxp5,maxp4)
      double precision t2sub(h7d,p4d,p5d,h1d)
      double precision v2sub(h3d,h2d,p6d,h7d)
      do p4=istart,istop
      do p6=jstart,jstop
      do p5=1,p5d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
      do h7=1,h7d
       triplesx(h1,h3,h2,p5,p6-jstart+1,p4-istart+1)=
     1     triplesx(h1,h3,h2,p5,p6-jstart+1,p4-istart+1)
     1   + t2sub(h7,p4,p5,h1)*v2sub(h3,h2,p6,h7)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_1(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h3d,h2d,h1d,p6d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p4=istart,istop
      do p5=jstart,jstop
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do p7=1,p7d
       triplesx(h3,h2,h1,p6,p5-jstart+1,p4-istart+1)=
     1     triplesx(h3,h2,h1,p6,p5-jstart+1,p4-istart+1)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_2(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h1d,h3d,p6d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p4=istart,istop
      do p5=jstart,jstop
      do p6=1,p6d
      do h3=1,h3d
      do h1=1,h1d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h1,h3,p6,p5-jstart+1,p4-istart+1)=
     1     triplesx(h2,h1,h3,p6,p5-jstart+1,p4-istart+1)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_3(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h3d,h1d,p6d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p4=istart,istop
      do p5=jstart,jstop
      do p6=1,p6d
      do h1=1,h1d
      do h3=1,h3d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h3,h1,p6,p5-jstart+1,p4-istart+1)=
     1     triplesx(h2,h3,h1,p6,p5-jstart+1,p4-istart+1)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_4(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h3d,h2d,h1d,p6d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p5=istart,istop
      do p4=jstart,jstop
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do p7=1,p7d
       triplesx(h3,h2,h1,p6,p4-jstart+1,p5-istart+1)=
     1     triplesx(h3,h2,h1,p6,p4-jstart+1,p5-istart+1)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_5(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h1d,h3d,p6d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p5=istart,istop
      do p4=jstart,jstop
      do p6=1,p6d
      do h3=1,h3d
      do h1=1,h1d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h1,h3,p6,p4-jstart+1,p5-istart+1)=
     1     triplesx(h2,h1,h3,p6,p4-jstart+1,p5-istart+1)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_6(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h3d,h1d,p6d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p5=istart,istop
      do p4=jstart,jstop
      do p6=1,p6d
      do h1=1,h1d
      do h3=1,h3d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h3,h1,p6,p4-jstart+1,p5-istart+1)=
     1     triplesx(h2,h3,h1,p6,p4-jstart+1,p5-istart+1)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_7(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h3d,h2d,h1d,p4d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p5=istart,istop
      do p6=jstart,jstop
      do p4=1,p4d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
      do p7=1,p7d
       triplesx(h3,h2,h1,p4,p6-jstart+1,p5-istart+1)=
     1     triplesx(h3,h2,h1,p4,p6-jstart+1,p5-istart+1)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_8(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h1d,h3d,p4d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p5=istart,istop
      do p6=jstart,jstop
      do p4=1,p4d
      do h3=1,h3d
      do h1=1,h1d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h1,h3,p4,p6-jstart+1,p5-istart+1)=
     1     triplesx(h2,h1,h3,p4,p6-jstart+1,p5-istart+1)
     1   - t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_ty1_9(h3d,h2d,h1d,p6d,p5d,p4d,
     1               p7d,
     2               triplesx,t2sub,v2sub,
     3 istart,istop,jstart,jstop,maxp4,maxp5)
      IMPLICIT NONE
      INTEGER istart,istop,jstart,jstop,maxp4,maxp5
      integer h3d,h2d,h1d,p6d,p5d,p4d,p7d
      integer h3,h2,h1,p6,p5,p4,p7
      double precision triplesx(h2d,h3d,h1d,p4d,maxp5,maxp4)
      double precision t2sub(p7d,p4d,h1d,h2d)
      double precision v2sub(p7d,h3d,p6d,p5d)
      do p5=istart,istop
      do p6=jstart,jstop
      do p4=1,p4d
      do h1=1,h1d
      do h3=1,h3d
      do h2=1,h2d
      do p7=1,p7d
       triplesx(h2,h3,h1,p4,p6-jstart+1,p5-istart+1)=
     1     triplesx(h2,h3,h1,p4,p6-jstart+1,p5-istart+1)
     1   + t2sub(p7,p4,h1,h2)*v2sub(p7,h3,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end

C> \ingroup nwint
C> @{
C>
C> \brief Compute 1-electron Gaussian periodic nuclear attraction
C> integrals
C>
C> See [1] for details.
C>
C> [1] JE Jaffe, AC Hess,
C>     <i>"Gaussian basis density functional theory for systems 
C>     periodic in two or three dimensions: Energy and forces"</i>,
C>    J.Chem.Phys. <b>105</b>, 10983-10998 (1996), DOI:
C>    <a href="http://dx.doi.org/10.1063/1.472866">
C>    10.1063/1.472866</a>
C>
      subroutine intp_1epe(i_basis,ish,Ri,j_basis,jsh,Rj,
     &    lscr,scr,lpe,Pe)
c $Id: intp_1epe.F 23392 2013-01-07 20:00:04Z d3y133 $
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
c::external subroutines used
c errquit
c::functions
      logical int_chk_init
      logical int_chk_sh
      logical cando_nw_1e
      logical cando_nw
      external int_chk_init
      external int_chk_sh
      external cando_nw_1e
      external cando_nw
c::passed
      integer i_basis !< [Input] basis set handle for ish functions
      integer j_basis !< [Input] basis set handle for jsh functions
      integer ish     !< [Input] lexical contraction/shell index
      integer jsh     !< [Input] lexical contraction/shell index
      integer lscr    !< [Input] length of the scratch array
      integer lpe     !< [Input] length of potential energy integral array
      double precision Pe(lpe)   !< [Output] nuclear attraction integral array
      double precision scr(lscr) !< [Scratch] scratch array
      double precision Ri(3)  !< [Input] translation vector for ish center (fractional coordinates)
      double precision Rj(3)  !< [Input] translation vector for jsh center (fractional coordinates)
c::local
      logical shells_ok
      integer i_geom, j_geom, ibas, jbas, ucont
      integer Li, i_prim, i_gen, i_iexp, i_icfp, i_cent
      integer Lj, j_prim, j_gen, j_iexp, j_icfp, j_cent
      double precision xyz_new_i(3)  ! new coordinates for ish function center
      double precision xyz_new_j(3)  ! new coordinates for jsh function center
c
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c check initialization and shells
c
      if (.not.int_chk_init('intp_1epe'))
     &       call errquit('intp_1epe: int_init was not called' ,0,
     &        INT_ERR)
c
      shells_ok = int_chk_sh(i_basis,ish)
      shells_ok = shells_ok .and. int_chk_sh(j_basis,jsh)
      if (.not.shells_ok)
     &       call errquit('intp_1epe: invalid contraction/shell',0,
     &         BASIS_ERR)
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
c
      ucont   = (sf_ibs_cn2ucn(ish,ibas))
      Li      = infbs_cont(CONT_TYPE ,ucont,ibas)
      i_prim  = infbs_cont(CONT_NPRIM,ucont,ibas)
      i_gen   = infbs_cont(CONT_NGEN ,ucont,ibas)
      i_iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      i_icfp  = infbs_cont(CONT_ICFP ,ucont,ibas)
      i_cent  = (sf_ibs_cn2ce(ish,ibas))
      i_geom  = ibs_geom(ibas)
c
      ucont   = (sf_ibs_cn2ucn(jsh,jbas))
      Lj      = infbs_cont(CONT_TYPE ,ucont,jbas)
      j_prim  = infbs_cont(CONT_NPRIM,ucont,jbas)
      j_gen   = infbs_cont(CONT_NGEN ,ucont,jbas)
      j_iexp  = infbs_cont(CONT_IEXP ,ucont,jbas)
      j_icfp  = infbs_cont(CONT_ICFP ,ucont,jbas)
      j_cent  = (sf_ibs_cn2ce(jsh,jbas))
      j_geom  = ibs_geom(jbas)
c
      if (i_geom.ne.j_geom.and.WarnP.eq.0) then
        write(luout,*)
     &      'intp_1epe: WARNING: possible geometry inconsistency'
        write(luout,*)'i_basis geometry handle:',i_geom
        write(luout,*)'j_basis geometry handle:',j_geom
        WarnP = 1
      endif
c.. translate ish center coordinates based on Ri
      call intp_txyz(i_cent,i_geom,Ri,xyz_new_i)
c.. translate jsh center coordinates based on Rj
      call intp_txyz(j_cent,j_geom,Rj,xyz_new_j)
c
      if (cando_nw_1e(i_basis,ish,0).and.cando_nw_1e(j_basis,jsh,0))
     &    then
        call int_hf1sp(
     &         xyz_new_i,dbl_mb(mb_exndcf(i_iexp,ibas)),
     &         dbl_mb(mb_exndcf(i_icfp,ibas)),
     &         i_prim, i_gen, Li, i_cent,
     &         xyz_new_j,dbl_mb(mb_exndcf(j_iexp,jbas)),
     &         dbl_mb(mb_exndcf(j_icfp,jbas)),
     &         j_prim, j_gen, Lj, j_cent,
     &         coords(1,1,i_geom),charge(1,i_geom),
     &         geom_invnucexp(1,i_geom),ncenter(i_geom),
c............................. doS     doT     doV    canonical
     &         scr,scr,Pe,lpe,.false.,.false.,.true.,.false.,
c.............. dryrun
     &         .false.,scr,lscr,'intp_1epe')
        if (bas_spherical(ibas).or.bas_spherical(jbas)) then
          if (Li.eq.-1) i_gen = 1
          if (Lj.eq.-1) j_gen = 1
          call spcart_2ctran(Pe,scr,lscr,
     &        int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &        int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &        .false.)          
        endif
      else
        call errquit('intp_1epe: could not do sp or nw integrals',0,
     &           INT_ERR)
      endif
c
      end
C> @}

      subroutine dia_rdhdr(sgmnam)
c
c $Id: dia_rdhdr.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "dia_common.fh"
#include "mafdecls.fh"
c
      integer ftell
      external ftell
c
      character*16 sgmnam(msa)
      character*255 fname
      integer i,lq
c
      integer ib,jb,nsb,nwb
c
      if(me.eq.0) then
c
      iscof=ifrst
      timoff=0.0d0
      time=0.0d0
      timr=0.0d0
      write(cnum,'(i3.3)') iscof
      ioffhd=0
      iofffr=0
c
      fname=filtrj
      lq=index(filtrj,'?')
      if(lq.gt.0) then
      fname=filtrj(1:lq-1)//cnum//filtrj(lq+1:index(filtrj,' ')-1)
      endif
c
      if(fmttrj.eq.'trj') then
      write(*,3333) fname(1:index(fname,' ')-1)
 3333 format(/,' Opening trj file ',a)
      open(unit=lfntrj,file=fname(1:index(fname,' ')-1),
     + status='old',err=9999)
      rewind(lfntrj)
      if(lrdf) call dia_rdfhdr(int_mb(i_rdf))
    1 continue
      read(lfntrj,1000,err=9998,end=9997) card
 1000 format(a)
      if(card(1:6).ne.'header') goto 1
      open(unit=44,file='.header',form='formatted',
     + status='unknown')
      rewind(44)
      read(lfntrj,1003) nwa,nsa,nsb,nwb,ib,nfilf
      if(nfilf.eq.0) nfilf=nframi
      write(44,1003) nwa,nsa,nsb,nwb,ib,nfilf
 1003 format(6i10)
      if(nsa.gt.msa) call md_abort('Error in trj',0)
      if(nwa.gt.0) then
      do 2 i=1,nwa
      read(lfntrj,1004) wnam(i)
      write(44,1004) wnam(i)
 1004 format(a16)
    2 continue
      endif
      if(nsa.gt.0) then
      do 3 i=1,nsa
      read(lfntrj,1005) sgmnam(i)
      write(44,1005) sgmnam(i)
 1005 format(a16)
    3 continue
      endif
      if(nsb+nwb.gt.0) then
      do 4 i=1,nsb+nwb
      read(lfntrj,1001) ib,jb
      write(44,1001) ib,jb
 1001 format(2i8)
    4 continue
      endif
      ioffhd=ftell(lfntrj)
      close(unit=44)
      elseif(fmttrj.eq.'sco'.or.fmttrj.eq.'coo') then
      open(unit=lfntrj,file=fname(1:index(fname,' ')-1),
     + status='old',err=9999)
      write(*,3333) fname(1:index(fname,' ')-1)
   11 continue
      read(lfntrj,1000,err=9998,end=9997) card
      if(card(1:18).eq.'num_solvent_atoms:')then
      read(card(19:26),'(i8)') nwa
      goto 11
      endif
      if(card(1:17).eq.'num_solute_atoms:') then
      read(card(18:25),'(i8)') nsa
      goto 11
      endif
      if(card(1:10).eq.'num_bonds:') then
      read(card(11:19),'(i9)') nsb
      else
      if(card(1:5).ne.'time:') goto 11
      if(.not.ltop) call md_abort('Format error trajectory file',0)
      endif
      rewind(lfntrj)
      nwa=0
      if(.not.ltop) then
      open(unit=44,file='.header',form='formatted',
     + status='unknown')
      rewind(44)
      write(44,1003) nwa,nsa,nsb,0
      endif
      if(nsa.gt.msa) call md_abort('Error in trj',0)
      if(fmttrj.ne.'coo') then
   12 continue
      read(lfntrj,1000,err=9998,end=9997) card
      if(card(1:11).ne.'atom_names:') goto 12
      do 13 i=1,nsa
      if(ltop) then
      read(lfntrj,1000,err=9998,end=9997) card
      else
      read(lfntrj,1005) sgmnam(i)
      write(44,1005) sgmnam(i)
      endif
   13 continue
      if(nsb.gt.0) then
   14 continue
      read(lfntrj,1000,err=9998,end=9997) card
      if(card(1:10).ne.'bond_list:') goto 14
      do 15 i=1,nsb
      read(lfntrj,1001) ib,jb
      if(.not.ltop) write(44,1001) ib,jb
   15 continue
      endif
      endif
      if(.not.ltop) close(unit=44)
      else
      call md_abort('Trajectory file format error',0)
      endif
c
      endif
c
      return
c
 9997 continue
      call md_abort('End of file reading trajectory file',0)
 9998 continue
      call md_abort('Error reading trajectory file',0)
 9999 continue
      call md_abort('Failed to open trajectory file',0)
      return
      end
      subroutine dia_getofffr()
c
      implicit none
c
#include "dia_common.fh"
c
      integer ftell
      external ftell
c
      character*5 string
c
      if(me.eq.0) then
      read(lfntrj,1000) string
    1 continue
      iofffr=ftell(lfntrj)
      read(lfntrj,1000) string
 1000 format(a5)
      if(string.ne.'frame') goto 1
      close(unit=lfntrj)
      endif
c
      return
      end

      SUBROUTINE ccsdtq_lr_alpha_15_13_3(d_a,k_a_offset,d_b,k_b_offset,d
     &_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_13_3.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 h5 h6 h14 h15 h16 p4 p8 )_ytrbt + = -2 * Sum ( p1 ) * t ( p1 h16 )_t * i3 ( h2 h5 h6 h14 h15 p1 p4 p8 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h5b
      INTEGER h6b
      INTEGER h14b
      INTEGER h16b
      INTEGER h15b
      INTEGER p4b
      INTEGER p8b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER p1b_1
      INTEGER h16b_1
      INTEGER h2b_2
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h14b_2
      INTEGER h15b_2
      INTEGER p4b_2
      INTEGER p8b_2
      INTEGER p1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO h5b = h2b,noab
      DO h6b = h5b,noab
      DO h14b = h6b,noab
      DO h16b = 1,noab
      DO h15b = 1,noab
      DO p4b = noab+1,noab+nvab
      DO p8b = p4b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h15b-1)
     &+int_mb(k_spin+h16b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b-1).n
     &e.16)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     &+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+h1
     &6b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h15b-1),i
     &eor(int_mb(k_sym+h16b-1),ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+p8b
     &-1)))))))) .eq. ieor(irrep_y,ieor(irrep_trb,irrep_t))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+h14b-1) * int_mb(k_range+h15b-1) * int
     &_mb(k_range+h16b-1) * int_mb(k_range+p4b-1) * int_mb(k_range+p8b-1
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_13_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h16b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p1b,h16b,p1b_1,h16b_1)
      CALL TCE_RESTRICTED_8(h2b,h5b,h6b,h14b,h15b,p4b,p8b,p1b,h2b_2,h5b_
     &2,h6b_2,h14b_2,h15b_2,p4b_2,p8b_2,p1b_2)
      dim_common = int_mb(k_range+p1b-1)
      dima_sort = int_mb(k_range+h16b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+h6b-1) * int_mb(k_range+h14b-1) * int_mb(k_range+h15b-1) 
     &* int_mb(k_range+p4b-1) * int_mb(k_range+p8b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_13_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_13_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h16b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_13_3'
     &,3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_13_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_13_3',5,MA_ERR)
      IF ((h15b .le. p1b) .and. (p1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h6b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p4b-
     &1),int_mb(k_range+p8b-1),8,7,5,4,3,2,1,6,1.0d0)
      END IF
      IF ((p4b .lt. p1b) .and. (p1b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h6b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+p4b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p8b-1),8,6,5,4,3,2,1,7,-1.0d0)
      END IF
      IF ((p8b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h6b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-
     &1),int_mb(k_range+p1b-1),7,6,5,4,3,2,1,8,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_13_3'
     &,6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &13_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &13_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_13_3',9,MA_ERR)
      IF ((h15b .le. h16b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h15b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+h16b-1),7,6,5,4,3,8,2,1,-1.0d0/1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p8b -
     & noab - 1 + nvab * (p4b - noab - 1 + nvab * (h16b - 1 + noab * (h1
     &5b - 1 + noab * (h14b - 1 + noab * (h6b - 1 + noab * (h5b - 1 + no
     &ab * (h2b - 1)))))))))
      END IF
      IF ((h16b .le. h15b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h15b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+h16b-1),7,6,5,4,8,3,2,1,1.0d0/1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p8b -
     & noab - 1 + nvab * (p4b - noab - 1 + nvab * (h15b - 1 + noab * (h1
     &6b - 1 + noab * (h14b - 1 + noab * (h6b - 1 + noab * (h5b - 1 + no
     &ab * (h2b - 1)))))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_13_3'
     &,10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &13_3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine tce_jacobi_t2(d_r2,d_t2,k_t2_offset,shift)
c
c $Id: tce_jacobi_t2.F 21254 2011-10-20 18:39:36Z kowalski $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r2
      integer d_t2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_t2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer nprocs
      integer count
      integer next
      integer iter 
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
      logical noloadbalance
      double precision shift
c
c      if(iter.le.100) then
c       shift=-(2.0d0)*zlshift
c      else
c       shift=0.0d0
c      end if
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or. 
     1                ((ioalg.eq.6).and.(.not.fileisga(d_r2))))
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do h3b = 1,noab
            do h4b = h3b,noab
              if (noloadbalance.or.(next.eq.count)) then
                if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1            .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
                if ((.not.restricted).or.
     1            (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2            int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
                if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1            ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2            .eq. 0) then
                  size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1                 * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                  if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1              call errquit('tce_jacobi_t2: MA problem',0,MA_ERR)
                  call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
                  i = 0
                  do p1 = 1,int_mb(k_range+p1b-1)
                    do p2 = 1,int_mb(k_range+p2b-1)
                      do h3 = 1,int_mb(k_range+h3b-1)
                        do h4 = 1,int_mb(k_range+h4b-1)
                          i = i + 1
                          dbl_mb(k_r2+i-1) = dbl_mb(k_r2+i-1)
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              +dbl_mb(k_evl_sorted+int_mb(k_offset+h3b-1)+h3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1)
     5             +shift)
                        enddo
                      enddo
                    enddo
                  enddo
                  call add_hash_block(d_t2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
c update of the res.-double vector to the form of increment used in DIIS proc.
ccx                  call put_hash_block(d_r2,dbl_mb(k_r2),size,
ccx     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
ccx     2              *noab+h3b-1)*noab+h4b-1))
c ----------------------------------------------------------------------------
                  if (nodezero.and.util_print('t2',print_debug)) 
     1              then
                    call get_hash_block(d_t2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
                    call ma_print_compact
     2              (dbl_mb(k_r2),size,1,'t2')
                  endif
                  if (.not.ma_pop_stack(l_r2))
     1              call errquit('tce_jacobi_t2: MA problem',1,MA_ERR)
                endif
                endif
                endif
cc                next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
              endif
              count = count + 1
            enddo
          enddo
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end
c
c
c
c
c
c
      subroutine tce_r2_divide(d_r2,k_t2_offset)
c
c $Id: tce_jacobi_t2.F 21254 2011-10-20 18:39:36Z kowalski $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_t2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer nprocs
      integer count
      integer next
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
      logical noloadbalance
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or. 
     1                ((ioalg.eq.6).and.(.not.fileisga(d_r2))))
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do h3b = 1,noab
            do h4b = h3b,noab
              if (noloadbalance.or.(next.eq.count)) then
                if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1            .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
                if ((.not.restricted).or.
     1            (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2            int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
                if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1            ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2            .eq. 0) then
                  size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1                 * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                  if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1              call errquit('tce_r2_divide: MA problem',0,MA_ERR)
                  call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
                  i = 0
                  do p1 = 1,int_mb(k_range+p1b-1)
                    do p2 = 1,int_mb(k_range+p2b-1)
                      do h3 = 1,int_mb(k_range+h3b-1)
                        do h4 = 1,int_mb(k_range+h4b-1)
                          i = i + 1
                          dbl_mb(k_r2+i-1) = dbl_mb(k_r2+i-1)
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              +dbl_mb(k_evl_sorted+int_mb(k_offset+h3b-1)+h3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1))
                        enddo
                      enddo
                    enddo
                  enddo
c update of the res.-double vector to the form of increment used in DIIS proc.
                  call put_hash_block(d_r2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
c ----------------------------------------------------------------------------
                  if (.not.ma_pop_stack(l_r2))
     1              call errquit('tce_r2_divide: MA problem',1,MA_ERR)
                endif
                endif
                endif
cc                next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
              endif
              count = count + 1
            enddo
          enddo
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end
c
c
c
c
c
      subroutine tce_jacobi_t2a(d_r2,d_t2,k_t2_offset,iter)
c
c $Id: tce_jacobi_t2.F 21254 2011-10-20 18:39:36Z kowalski $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r2
      integer d_t2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_t2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer nprocs
      integer count
      integer next
      LOGICAL is_active_1,is_active_2,is_active_3,is_active_4
cc      integer nxtval
c
      integer iter 
c
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
      logical noloadbalance
c --- shift ---
      double precision shift
c -------------
      if(iter.le.100) then
       shift=-(2.0d0)*zlshift
      else
       shift=0.0d0
      end if
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or. 
     1                ((ioalg.eq.6).and.(.not.fileisga(d_r2))))
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do h3b = 1,noab
            do h4b = h3b,noab
              if (noloadbalance.or.(next.eq.count)) then
                IF(is_active_4(p1b,p2b,h3b,h4b)) THEN
                if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1            .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
                if ((.not.restricted).or.
     1            (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2            int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
                if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1            ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2            .eq. 0) then
                  size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1                 * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                  if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1              call errquit('tce_jacobi_t2: MA problem',0,MA_ERR)
                  call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
                  i = 0
                  do p1 = 1,int_mb(k_range+p1b-1)
                    do p2 = 1,int_mb(k_range+p2b-1)
                      do h3 = 1,int_mb(k_range+h3b-1)
                        do h4 = 1,int_mb(k_range+h4b-1)
                          i = i + 1
                          dbl_mb(k_r2+i-1) = dbl_mb(k_r2+i-1)
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3              +dbl_mb(k_evl_sorted+int_mb(k_offset+h3b-1)+h3-1)
     4              +dbl_mb(k_evl_sorted+int_mb(k_offset+h4b-1)+h4-1)
     5              +shift)
                        enddo
                      enddo
                    enddo
                  enddo
                  call add_hash_block(d_t2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
c update of the res.-double vector to the form of increment used in DIIS proc.
ccx                  call put_hash_block(d_r2,dbl_mb(k_r2),size,
ccx     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
ccx     2              *noab+h3b-1)*noab+h4b-1))
c ----------------------------------------------------------------------------
                  if (nodezero.and.util_print('t2',print_debug)) 
     1              then
                    call get_hash_block(d_t2,dbl_mb(k_r2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
                    call ma_print_compact
     2              (dbl_mb(k_r2),size,1,'t2')
                  endif
                  if (.not.ma_pop_stack(l_r2))
     1              call errquit('tce_jacobi_t2: MA problem',1,MA_ERR)
                endif
                endif
                endif
                endif
cc                next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
              endif
              count = count + 1
            enddo
          enddo
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end
c

C> \ingroup nwint
C> @{
C>
C> \brief Compute the multipole integral derivatives
C>
C> Compute the multipole integral derivatives of the general form
C> \f{eqnarray*}{
C>   \frac{\partial (\mu|M_A|\nu)}{\partial R_x} &=&
C>      \int \frac{\partial [g_\mu(X_\mu,r_1)(R_A-r_1)_x^{n_x}(R_A-r_1)_y^{n_y}(R_A-r_1)_z^{n_z}g_\nu(X_\nu,r_1)]}{\partial X_x}dr_1
C> \f}
C> where the output buffer is logically organized as
C> `MP(mrange,jlo:jhi,ilo:ihi,ncoord,natom)` where 
C>
C> * `mrange` is the range of multipoles 1:((l+1)*(l+2)/2)
C>
C> * `jlo:jhi` is the range of basis functions associated with `jsh`
C>
C> * `ilo:ihi` is the range of basis functions associated with `ish`
C>
C> * `ncoord` represents the 3 Cartesian coordinates of the derivative
C>
C> * `natom` represents the 3 "atoms" involved in the integral, where
C>   1 is the center associated with `ish`, 2 is the center associate with
C>   `jsh`, and 3 is associated with the center of the multipole.
C>
C>  Integral derivatives are returned in shell blocks of <L|ish|jsh> L=lval
C>  one block for the given L value.  EACH block repeated for 9 (xyz,atoms)
C>  for ish = d and Lval = 1 and jsh = p you would get:
C>
C>  *   (6*3*3)*3*3=486 integral derivatives
C>  
C>  order would be 
C>  \code
C>       <xx|x|x> <xx|y|x> <xx|z|x> ( 1- 3)(x,atom1)
C>       <xx|x|y> <xx|y|y> <xx|z|y> ( 4- 6)(x,atom1)
C>       <xx|x|z> <xx|y|z> <xx|z|z> ( 7- 9)(x,atom1)
C>       <xy|x|x> <xy|y|x> <xy|z|x> (10-12)(x,atom1)
C>       <xy|x|y> <xy|y|y> <xy|z|y> (13-15)(x,atom1)
C>       <xy|x|z> <xy|y|z> <xy|z|z> (16-18)(x,atom1)
C>       <xz|x|x> <xz|y|x> <xz|z|x> (19-21)(x,atom1)
C>       <xz|x|y> <xz|y|y> <xz|z|y> (22-24)(x,atom1)
C>       <xz|x|z> <xz|y|z> <xz|z|z> (25-27)(x,atom1)
C>       <yy|x|x> <yy|y|x> <yy|z|x> (28-30)(x,atom1)
C>       <yy|x|y> <yy|y|y> <yy|z|y> (31-33)(x,atom1)
C>       <yy|x|z> <yy|y|z> <yy|z|z> (34-36)(x,atom1)
C>       <yz|x|x> <yz|y|x> <yz|z|x> (37-39)(x,atom1)
C>       <yz|x|y> <yz|y|y> <yz|z|y> (40-42)(x,atom1)
C>       <yz|x|z> <yz|y|z> <yz|z|z> (43-45)(x,atom1)
C>       <zz|x|x> <zz|y|x> <zz|z|x> (46-48)(x,atom1)
C>       <zz|x|y> <zz|y|y> <zz|z|y> (49-51)(x,atom1)
C>       <zz|x|z> <zz|y|z> <zz|z|z> (52-54)(x,atom1)
C>     repeat above for (y,atom1), (z,atom1)
C>   repeat above for atom2 and multipole center
C>  \endcode
C>
C>
C>
C>  For ish = p and Lval = 2 and jsh = p you would get:
C>
C>  *   (3*6*3)*3*3 = 486 integral derivatives
C>
C>  The order would be 
C>  \code
C>       <x|xx|x> <x|xy|x> <x|xz|x> <x|yy|x> <x|yz|x> <x|zz|x>  ( 1- 6)(x,atom1)
C>       <x|xx|y> <x|xy|y> <x|xz|y> <x|yy|y> <x|yz|y> <x|zz|y>  ( 7-12)(x,atom1)
C>       <x|xx|z> <x|xy|z> <x|xz|z> <x|yy|z> <x|yz|z> <x|zz|z>  (13-18)(x,atom1)
C>       <y|xx|x> <y|xy|x> <y|xz|x> <y|yy|x> <y|yz|x> <y|zz|x>  (19-24)(x,atom1)
C>       <y|xx|y> <y|xy|y> <y|xz|y> <y|yy|y> <y|yz|y> <y|zz|y>  (25-30)(x,atom1)
C>       <y|xx|z> <y|xy|z> <y|xz|z> <y|yy|z> <y|yz|z> <y|zz|z>  (31-36)(x,atom1)
C>       <z|xx|x> <z|xy|x> <z|xz|x> <z|yy|x> <z|yz|x> <z|zz|x>  (37-42)(x,atom1)
C>       <z|xx|y> <z|xy|y> <z|xz|y> <z|yy|y> <z|yz|y> <z|zz|y>  (43-48)(x,atom1)
C>       <z|xx|z> <z|xy|z> <z|xz|z> <z|yy|z> <z|yz|z> <z|zz|z>  (49-54)(x,atom1)
C>     repeat above for (y,atom1), (z,atom1)
C>   repeat above for atom2 and multipole center
C>  \endcode
C>
C>  For ish = s and lval = 4 and jsh = p you would get:
C>
C>  *  (1*15*3)*3*3 = 405 integral derivatives
C>
C>  and the order would be 
C>  \code
C>       <s|xxxx|x> <s|xxxy|x> <s|xxxz|x> <s|xxyy|x> <s|xxyz|x> <s|xxzz|x> ( 1- 6)(x,atom1)
C>       <s|xyyy|x> <s|xyyz|x> <s|xyzz|x> <s|xzzz|x> <s|yyyy|x> <s|yyyz|x> ( 7-12)(x,atom1)
C>       <s|yyzz|x> <s|yzzz|x> <s|zzzz|x>                                  (13-15)(x,atom1)
C>       <s|xxxx|y> <s|xxxy|y> <s|xxxz|y> <s|xxyy|y> <s|xxyz|y> <s|xxzz|y> (16-21)(x,atom1)
C>       <s|xyyy|y> <s|xyyz|y> <s|xyzz|y> <s|xzzz|y> <s|yyyy|y> <s|yyyz|y> (22-27)(x,atom1)
C>       <s|yyzz|y> <s|yzzz|y> <s|zzzz|y>                                  (28-30)(x,atom1)
C>       <s|xxxx|z> <s|xxxy|z> <s|xxxz|z> <s|xxyy|z> <s|xxyz|z> <s|xxzz|z> (31-36)(x,atom1)
C>       <s|xyyy|z> <s|xyyz|z> <s|xyzz|z> <s|xzzz|z> <s|yyyy|z> <s|yyyz|z> (37-42)(x,atom1)
C>       <s|yyzz|z> <s|yzzz|z> <s|zzzz|z>                                  (43-45)(x,atom1)
C>     repeat above for (y,atom1), (z,atom1)
C>   repeat above for atom2 and multipole center
C>  \endcode
C>
      subroutine intd_mpolel(i_basis, ish, j_basis, jsh, 
     &    lval, centerl,
     &    lscr, scr, lmpint, MP, num_mpint,
     &    idatom)
*
* $Id: intd_mpolel.F 23317 2012-12-21 18:21:44Z d3y133 $
*
c
c routine to compute multipole integral derivatives at a given lvalue 
c 
c The general form is <shell|pole|shell|3|3>
c
c the returned buffer is logically:
c           (mpole range, jlo:jhi, ilo:ihi, 3(xyz), 3(atom))
c where mpole range is 1:((lval+1)*(lval+2)/2)
c       3(xyz) is the x,y,z coordinate derivative for the atom index
c       3(atom) is at most three centers one is where ish exists
c                                        two is where jsh exists
c                                        three is the center of the multipole
c 
c  Integral derivatives are returned in shell blocks of <L|ish|jsh> L=lval
c  one block for the given L value.  EACH block repeated for by 9 (xyz,atoms)
c  for ish = d and Lval = 1 and jsh = p you would get:
c      (6*3*3)*3*3=486 integral derivatives
c  order would be 
c   <xx|x|x> <xx|y|x> <xx|z|x> ( 1- 3)(x,atom1)
c   <xx|x|y> <xx|y|y> <xx|z|y> ( 4- 6)(x,atom1)
c   <xx|x|z> <xx|y|z> <xx|z|z> ( 7- 9)(x,atom1)
c   <xy|x|x> <xy|y|x> <xy|z|x> (10-12)(x,atom1)
c   <xy|x|y> <xy|y|y> <xy|z|y> (13-15)(x,atom1)
c   <xy|x|z> <xy|y|z> <xy|z|z> (16-18)(x,atom1)
c   <xz|x|x> <xz|y|x> <xz|z|x> (19-21)(x,atom1)
c   <xz|x|y> <xz|y|y> <xz|z|y> (22-24)(x,atom1)
c   <xz|x|z> <xz|y|z> <xz|z|z> (25-27)(x,atom1)
c   <yy|x|x> <yy|y|x> <yy|z|x> (28-30)(x,atom1)
c   <yy|x|y> <yy|y|y> <yy|z|y> (31-33)(x,atom1)
c   <yy|x|z> <yy|y|z> <yy|z|z> (34-36)(x,atom1)
c   <yz|x|x> <yz|y|x> <yz|z|x> (37-39)(x,atom1)
c   <yz|x|y> <yz|y|y> <yz|z|y> (40-42)(x,atom1)
c   <yz|x|z> <yz|y|z> <yz|z|z> (43-45)(x,atom1)
c   <zz|x|x> <zz|y|x> <zz|z|x> (46-48)(x,atom1)
c   <zz|x|y> <zz|y|y> <zz|z|y> (49-51)(x,atom1)
c   <zz|x|z> <zz|y|z> <zz|z|z> (52-54)(x,atom1)
c   repeat above for (y,atom1), (z,atom1)
c   repeat above for atom2 and multipole center
c
c
c
c  for ish = p and Lval = 2 and jsh = p you would get:
c      (3*6*3)*3*3 = 486 integral derivatives
c  order would be 
c   <x|xx|x> <x|xy|x> <x|xz|x> <x|yy|x> <x|yz|x> <x|zz|x>  ( 1- 6)(x,atom1)
c   <x|xx|y> <x|xy|y> <x|xz|y> <x|yy|y> <x|yz|y> <x|zz|y>  ( 7-12)(x,atom1)
c   <x|xx|z> <x|xy|z> <x|xz|z> <x|yy|z> <x|yz|z> <x|zz|z>  (13-18)(x,atom1)
c   <y|xx|x> <y|xy|x> <y|xz|x> <y|yy|x> <y|yz|x> <y|zz|x>  (19-24)(x,atom1)
c   <y|xx|y> <y|xy|y> <y|xz|y> <y|yy|y> <y|yz|y> <y|zz|y>  (25-30)(x,atom1)
c   <y|xx|z> <y|xy|z> <y|xz|z> <y|yy|z> <y|yz|z> <y|zz|z>  (31-36)(x,atom1)
c   <z|xx|x> <z|xy|x> <z|xz|x> <z|yy|x> <z|yz|x> <z|zz|x>  (37-42)(x,atom1)
c   <z|xx|y> <z|xy|y> <z|xz|y> <z|yy|y> <z|yz|y> <z|zz|y>  (43-48)(x,atom1)
c   <z|xx|z> <z|xy|z> <z|xz|z> <z|yy|z> <z|yz|z> <z|zz|z>  (49-54)(x,atom1)
c   repeat above for (y,atom1), (z,atom1)
c   repeat above for atom2 and multipole center
c
c  for ish = s and lval = 4 and jsh = p you would get:
c     (1*15*3)*3*3 = 405 integral derivatives
c   <s|xxxx|x> <s|xxxy|x> <s|xxxz|x> <s|xxyy|x> <s|xxyz|x> <s|xxzz|x> ( 1- 6)(x,atom1)
c   <s|xyyy|x> <s|xyyz|x> <s|xyzz|x> <s|xzzz|x> <s|yyyy|x> <s|yyyz|x> ( 7-12)(x,atom1)
c   <s|yyzz|x> <s|yzzz|x> <s|zzzz|x>                                  (13-15)(x,atom1)
c   <s|xxxx|y> <s|xxxy|y> <s|xxxz|y> <s|xxyy|y> <s|xxyz|y> <s|xxzz|y> (16-21)(x,atom1)
c   <s|xyyy|y> <s|xyyz|y> <s|xyzz|y> <s|xzzz|y> <s|yyyy|y> <s|yyyz|y> (22-27)(x,atom1)
c   <s|yyzz|y> <s|yzzz|y> <s|zzzz|y>                                  (28-30)(x,atom1)
c   <s|xxxx|z> <s|xxxy|z> <s|xxxz|z> <s|xxyy|z> <s|xxyz|z> <s|xxzz|z> (31-36)(x,atom1)
c   <s|xyyy|z> <s|xyyz|z> <s|xyzz|z> <s|xzzz|z> <s|yyyy|z> <s|yyyz|z> (37-42)(x,atom1)
c   <s|yyzz|z> <s|yzzz|z> <s|zzzz|z>                                  (43-45)(x,atom1)
c   repeat above for (y,atom1), (z,atom1)
c   repeat above for atom2 and multipole center
c
c
      implicit none
#include "apiP.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
c
c::functions
      logical int_chk_init
      integer int_nint_cart
      external int_chk_init
      external int_nint_cart
c::passed
      integer i_basis             !< [Input] basis set handle for ish
      integer ish                 !< [Input] i shell/contraction
      integer j_basis             !< [Input] basis set handle for jsh
      integer jsh                 !< [Input] j shell/contraction
      integer lval                !< [Input] maximum lvalue for 
*.......................................... multipole integrals 
*.......................................... in this batch
      double precision centerl(3) !< [Input] coordinates of multipole
      integer lscr                !< [Input] length of scratch array
      double precision scr(lscr)  !< [Input] scratch array
      integer lmpint              !< [Input] length of multipole 
*.......................................... integrals array
      double precision MP(lmpint) !< [Output] multipole integrals
      integer num_mpint           !< [Output] number of multipole integrals
      integer idatom(3) !< [Output] array identifying centers for derivatives
c                       ! e.g., the first nint*3  derivatives go to center idatom(1)
c                       !       the second nint*3 derivatives go to center idatom(2)
c::local      
      logical shells_ok
      integer ibas, Li, i_prim, i_gen, i_iexp, i_icfp, i_cent, i_geom
      integer jbas, Lj, j_prim, j_gen, j_iexp, j_icfp, j_cent, j_geom
      integer ucont
      integer l_int, ij_int, num_int, num_intd
      integer lpole
      integer ioffj
      logical any_spherical
      logical inline_chk_sh      
c
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c... statement function for int_chk_sh
      inline_chk_sh(ibas,ish) =
     $     ((ish.gt.0) .and. (ish.le.ncont_tot_gb(ibas)))
c
c check initialization
c      
      if (.not.int_chk_init('intd_mpolel'))
     &       call errquit('intd_mpolel: int_init was not called' ,0,
     &           INT_ERR)
c
c  check if gencon/sp shells
c
      call int_nogencont_check(i_basis,'intd_mpolel:i_basis')
      call int_nogencont_check(j_basis,'intd_mpolel:j_basis')
      call int_nospshell_check(i_basis,'intd_mpolel:i_basis')
      call int_nospshell_check(j_basis,'intd_mpolel:j_basis')
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
c
      shells_ok = inline_chk_sh(ibas,ish)
      shells_ok = shells_ok .and. inline_chk_sh(jbas,jsh)
      if (.not. shells_ok)
     &       call errquit('intd_mpolel: invalid contraction/shell',0,
     &             BASIS_ERR)
c
***   set defNxyz such that it can handle the maximum multi-pole
c
      lpole = lval/4 + 1
      lpole = lpole + 1  ! for derivative
      call defNxyz(lpole)
c
      ucont   = (sf_ibs_cn2ucn(ish,ibas))
      Li      = infbs_cont(CONT_TYPE ,ucont,ibas)
      i_prim  = infbs_cont(CONT_NPRIM,ucont,ibas)
      i_gen   = infbs_cont(CONT_NGEN ,ucont,ibas)
      i_iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      i_icfp  = infbs_cont(CONT_ICFP ,ucont,ibas)
      i_cent  = (sf_ibs_cn2ce(ish,ibas))
      i_geom  = ibs_geom(ibas)
c
      ucont   = (sf_ibs_cn2ucn(jsh,jbas))
      Lj      = infbs_cont(CONT_TYPE ,ucont,jbas)
      j_prim  = infbs_cont(CONT_NPRIM,ucont,jbas)
      j_gen   = infbs_cont(CONT_NGEN ,ucont,jbas)
      j_iexp  = infbs_cont(CONT_IEXP ,ucont,jbas)
      j_icfp  = infbs_cont(CONT_ICFP ,ucont,jbas)
      j_cent  = (sf_ibs_cn2ce(jsh,jbas))
      j_geom  = ibs_geom(jbas)
c
      any_spherical = bas_spherical(ibas).or.bas_spherical(jbas)
c
      if (i_geom.ne.j_geom.and.WarnP.eq.0) then
        write(luout,*)'intd_mpolel: WARNING: possible geometry',
     &      ' inconsistency'
        write(luout,*)'i_basis geometry handle:',i_geom
        write(luout,*)'j_basis geometry handle:',j_geom
        WarnP = 1
      endif
c
      if (i_gen.gt.1 .or. j_gen.gt.1) then
        write(luout,*)
     &      ' hf3ois does not handle general contractions yet'
        call errquit('intd_mpolel: general contraction error ',911,
     &             INT_ERR)
      endif
c
      l_int    = (lval+1)*(lval+2)/2
      ij_int   = int_nint_cart(i_basis, ish, j_basis, jsh, 0,0, 0,0)
      num_int  =  l_int*ij_int
      num_intd = num_int*3*3
      if (num_intd.gt.lmpint) then
        write(luout,*)' intd_mpolel: lmpint   = ',lmpint
        write(luout,*)' intd_mpolel: num_intd = ',num_intd
        call errquit('intd_mpolel: lmpint too small ',911, INT_ERR)
      endif
      if ((lval.eq.0).and.(i_cent.eq.j_cent)) then
        call dcopy(num_intd,0.0d00,0,MP,1)
        call ifill(3,0,idatom,1)
        return
      endif
c
      call hfd3ois(
     &    coords(1,i_cent,i_geom),
     &    dbl_mb(mb_exndcf(i_iexp,ibas)),
     &    dbl_mb(mb_exndcf(i_icfp,ibas)),
     &    i_prim, 1, Li,
     &    coords(1,j_cent,j_geom),
     &    dbl_mb(mb_exndcf(j_iexp,jbas)),
     &    dbl_mb(mb_exndcf(j_icfp,jbas)),
     &    j_prim, 1, Lj,
     &    centerl,
     &    0.0d00,
     &    1.0d00,
     &    1, 1, lval,
c.....................DryRun
     &    MP,num_int,.false.,scr,lscr)
      num_mpint = num_intd
      if (i_cent.eq.j_cent) then
        idatom(1) = i_cent
        idatom(2) = 0
        idatom(3) = -3
        ioffj = num_int*3 + 1
        call daxpy(num_int*3,1.0d00,MP(ioffj),1,MP,1)
      else
        idatom(1) = i_cent
        idatom(2) = j_cent
        idatom(3) = -3
      endif
      if (any_spherical) then
        if (Li.eq.-1) i_gen = 1
        if (Lj.eq.-1) j_gen = 1
        call spcart_3cBtran(MP,scr,lscr,
     &      int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &      int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &      int_nbf_x(lval),int_nbf_x(lval),lval,1,.false.,
     &      9,.false.)
      endif
      end
C> @}

*
* $Id: paw_vloc.F 19707 2010-10-29 17:59:36Z d3y133 $
*


!**************************************************
!
!       Name: paw_vloc_init
!
!       Purpose: 
!
!       Created: Wed Feb 12 15:18:24 PST 2003
!**************************************************
      subroutine paw_vloc_init()
      implicit none

#include "mafdecls.fh"
#include "paw_ma.fh"
#include "paw_basis.fh"
#include "paw_geom.fh"
#include "paw_vloc_data.fh"

      logical ok
      integer npack0,nfft3d,nkatm


      !*** allocate storage for local pseudopotential ***
      nkatm = ion_nkatm()
      call Pack_npack(0,npack0)
      call D3dB_nfft3d(1,nfft3d)
      ok = my_alloc(mt_dbl,(nkatm*npack0),'vl',vl)
      if (.not.ok) 
     > call errquit('paw_vloc_init:out of heap memory',0,1)


      return
      end


!**************************************************
!
!       Name: paw_vloc_end
!
!       Purpose: 
!
!       Created: Wed Feb 12 15:18:24 PST 2003
!**************************************************
      subroutine paw_vloc_end()
      implicit none

#include "mafdecls.fh"
#include "paw_ma.fh"
#include "paw_vloc_data.fh"

      !**** local variables ****
      logical ok

      !*** deallocate storage for local pseudopotential ***
      ok = my_dealloc(vl)
      if (.not.ok) 
     > call errquit('paw_vloc_end:out of heap memory',0,1)

      return
      end

!**************************************************
!
!       Name: paw_vloc
!
!       Purpose: 
!
!       Created: Wed Feb 12 15:18:24 PST 2003
!**************************************************
      subroutine paw_vloc(vl_out,move,dng,fion)
      implicit none
      complex*16 vl_out(*)
      logical    move
      complex*16 dng(*)
      real*8     fion(3,*)

#include "mafdecls.fh"
#include "paw_ma.fh"
#include "paw_vloc_data.fh"


*     *** local variables ***
      integer nfft3d,npack0
      integer i,ii,ia
      integer exi(2),vtmp(2),xtmp(2),G(3)
      integer Gx(2),Gy(2),Gz(2)
      logical ok

*     **** external functions ****
      integer  G_indx,ion_nion,ion_katm
      external G_indx,ion_nion,ion_katm

      call nwpw_timing_start(5)
      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(0,npack0)

      ok = MA_push_get(mt_dcpl,npack0,'exi', exi(2), exi(1))
      ok = ok.and.
     >     MA_push_get(mt_dcpl,nfft3d,'vtmp',vtmp(2),vtmp(1))
      if (.not. ok) call errquit('paw_vloc:out of stack memory',0,0)
      if (move) then
        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'xtmp',xtmp(2),xtmp(1))
        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'Gx',Gx(2),Gx(1))
        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'Gy',Gy(2),Gy(1))
        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'Gz',Gz(2),Gz(1))
        if (.not. ok) call errquit('paw_vloc:out of stack memory',0,1)
        G(1)  = G_indx(1)
        G(2)  = G_indx(2)
        G(3)  = G_indx(3)

        !**** define Gx,Gy and Gz in packed space ****
        call D3dB_t_Copy(1,dbl_mb(G(1)),dbl_mb(Gx(1)))
        call D3dB_t_Copy(1,dbl_mb(G(2)),dbl_mb(Gy(1)))
        call D3dB_t_Copy(1,dbl_mb(G(3)),dbl_mb(Gz(1)))
        call Pack_t_pack(0,dbl_mb(Gx(1)))
        call Pack_t_pack(0,dbl_mb(Gy(1)))
        call Pack_t_pack(0,dbl_mb(Gz(1)))
      end if

      call dcopy((2*npack0),0.0d0,0,vl_out,1)
      do ii=1,ion_nion()
        ia=ion_katm(ii)

*       **** structure factor and local pseudopotential ****
        call strfac_pack(0,ii,dcpl_mb(exi(1)))

*       **** add to local psp ****
        call Pack_tc_Mul(0,dbl_mb(vl(1)+npack0*(ia-1)),
     >                   dcpl_mb(exi(1)),
     >                   dcpl_mb(vtmp(1)))
c        call Pack_cc_Sum(0,vl_out,dcpl_mb(vtmp(1)),vl_out)
        call Pack_cc_Sum2(0,dcpl_mb(vtmp(1)),vl_out)


        if (move) then

          do i=1,npack0
             dbl_mb(xtmp(1)+i-1)
     >          = dimag(dng(i))* dble(dcpl_mb(vtmp(1)+i-1))
     >           - dble(dng(i))*dimag(dcpl_mb(vtmp(1)+i-1))
          end do
         call Pack_tt_dot(0,dbl_mb(Gx(1)),dbl_mb(xtmp(1)),fion(1,ii))
         call Pack_tt_dot(0,dbl_mb(Gy(1)),dbl_mb(xtmp(1)),fion(2,ii))
         call Pack_tt_dot(0,dbl_mb(Gz(1)),dbl_mb(xtmp(1)),fion(3,ii))

       end if


      end do
      
      ok = .true.
      if (move) then
      ok = ok.and.MA_pop_stack(Gz(2))
      ok = ok.and.MA_pop_stack(Gy(2))
      ok = ok.and.MA_pop_stack(Gx(2))
      ok = ok.and.MA_pop_stack(xtmp(2))
      end if
      ok = ok.and.MA_pop_stack(vtmp(2))
      ok = ok.and.MA_pop_stack(exi(2))
      if (.not. ok) 
     > call errquit('paw_vloc:error popping stack ',0,2)

      call nwpw_timing_end(5)


      return
      end

!**************************************************
!
!       Name: paw_vloc_force
!
!       Purpose: 
!
!       Created: Wed Feb 12 15:18:24 PST 2003
!**************************************************
      subroutine paw_vloc_force(dng,fion)
      implicit none
      complex*16 dng(*)
      real*8     fion(3,*)

#include "mafdecls.fh"
#include "paw_ma.fh"
#include "paw_vloc_data.fh"


*     *** local variables ***
      integer nfft3d,npack0
      integer i,ii,ia
      integer exi(2),vtmp(2),xtmp(2),G(3)
      integer Gx(2),Gy(2),Gz(2)
      logical ok

*     **** external functions ****
      integer  G_indx,ion_nion,ion_katm
      external G_indx,ion_nion,ion_katm

      call nwpw_timing_start(5)
      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(0,npack0)

      ok = MA_push_get(mt_dcpl,npack0,'exi', exi(2), exi(1))
      ok = ok.and.
     >     MA_push_get(mt_dcpl,nfft3d,'vtmp',vtmp(2),vtmp(1))
      if (.not. ok) call errquit('paw_vloc:out of stack memory',0,0)

        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'xtmp',xtmp(2),xtmp(1))
        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'Gx',Gx(2),Gx(1))
        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'Gy',Gy(2),Gy(1))
        ok = ok.and.
     >       MA_push_get(mt_dbl, nfft3d,'Gz',Gz(2),Gz(1))
        if (.not. ok) call errquit('paw_vloc:out of stack memory',0,1)
        G(1)  = G_indx(1)
        G(2)  = G_indx(2)
        G(3)  = G_indx(3)

        !**** define Gx,Gy and Gz in packed space ****
        call D3dB_t_Copy(1,dbl_mb(G(1)),dbl_mb(Gx(1)))
        call D3dB_t_Copy(1,dbl_mb(G(2)),dbl_mb(Gy(1)))
        call D3dB_t_Copy(1,dbl_mb(G(3)),dbl_mb(Gz(1)))
        call Pack_t_pack(0,dbl_mb(Gx(1)))
        call Pack_t_pack(0,dbl_mb(Gy(1)))
        call Pack_t_pack(0,dbl_mb(Gz(1)))

      do ii=1,ion_nion()
        ia=ion_katm(ii)

*       **** structure factor and local pseudopotential ****
        call strfac_pack(0,ii,dcpl_mb(exi(1)))

*       **** add to local psp ****
        call Pack_tc_Mul(0,dbl_mb(vl(1)+npack0*(ia-1)),
     >                   dcpl_mb(exi(1)),
     >                   dcpl_mb(vtmp(1)))


*       **** force evaluation ****
        do i=1,npack0
           dbl_mb(xtmp(1)+i-1)
     >        = dimag(dng(i))* dble(dcpl_mb(vtmp(1)+i-1))
     >         - dble(dng(i))*dimag(dcpl_mb(vtmp(1)+i-1))
        end do
        call Pack_tt_dot(0,dbl_mb(Gx(1)),dbl_mb(xtmp(1)),fion(1,ii))
        call Pack_tt_dot(0,dbl_mb(Gy(1)),dbl_mb(xtmp(1)),fion(2,ii))
        call Pack_tt_dot(0,dbl_mb(Gz(1)),dbl_mb(xtmp(1)),fion(3,ii))


      end do
      
      ok = .true.
      ok = ok.and.MA_pop_stack(Gz(2))
      ok = ok.and.MA_pop_stack(Gy(2))
      ok = ok.and.MA_pop_stack(Gx(2))
      ok = ok.and.MA_pop_stack(xtmp(2))
      ok = ok.and.MA_pop_stack(vtmp(2))
      ok = ok.and.MA_pop_stack(exi(2))
      if (.not. ok) 
     > call errquit('paw_vloc:error popping stack ',0,2)

      call nwpw_timing_end(5)


      return
      end


      subroutine paw_vloc_ptr(ptr)
      implicit none
      integer ptr
#include "paw_vloc_data.fh"

      ptr = vl(1)
      return
      end

      SUBROUTINE XGEMM (TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,
     $                   BETA, C, LDC )
C     $Id: xgemm.F 19697 2010-10-29 16:57:34Z d3y133 $
      implicit none
#include "y64.fh"
*     .. Scalar Arguments ..
      CHARACTER*1        TRANSA, TRANSB
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE COMPLEX   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE COMPLEX   A( LDA, * ), B( LDB, * ), C( LDC, * )
c
      INTGR4            M4, N4, K4, LDA4, LDB4, LDC4
c
      M4=M
      N4=N
      K4=K
      LDA4=LDA
      LDB4=LDB
      LDC4=ldc
c
      CALL ZGEMM(TRANSA, TRANSB, M4, N4, K4, ALPHA, A, LDA4, B, LDB4,
     $                   BETA, C, LDC4 )
      RETURN
      END

      subroutine util_allocga()
c $Id: util_allocga.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      integer ncrap,g_crapa,g_crapb,
     A     mappa(8),ii
      integer global_b,global
      logical status
chack
chack one big ga_create to bypass shmem/armci bug 
chack for asymmetric armci memory allocation
chack 
c
      global_b = ga_memory_avail()
      If ( Global_B .ge. 0) then
         global = MA_SizeOf(MT_Byte, global_b, MT_Dbl)
      Else
         global = 0
      EndIf
      ncrap=sqrt(0.85d0*(global*ga_nnodes()))
#if 0
       if(ga_nodeid().eq.0)
     W      write(0,*) ga_nodeid(),' ncrap ',ncrap,global
       call ga_sync()
#endif
       mappa(1)=1
       do ii=2,ga_nnodes()
          mappa(ii)=(ii-1)*ncrap/ga_nnodes()+1
       enddo
      status =  ga_create_irreg(MT_DBL, ncrap, ncrap,'da',
     $     mappa, ga_nnodes(), 
     $     mappa, 1, g_crapa)
       if (.not. ga_destroy(g_crapa)) call errquit
     E      (' gadestroy failed ',0,0)
#if 0
       if(ga_nodeid().eq.0) write(0,*) ' gadestr ok'
#endif
       return
       end

*
* $Id: cgmdv5.F 25933 2014-07-23 16:50:45Z bylaska $
*

***********************************************************************
*                      cgmdv5                                         *

*     This is a developing Born-Oppenheimer MD code for NWCHEM        *
*                                                                     *
***********************************************************************

      logical function cgmdv5(rtdb,flag)
      implicit none
      integer rtdb
      integer flag

#include "global.fh"
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"

#include "nwpw_timing.fh"

*     *** local variables and parameters ****
      double precision kb
      parameter (kb=3.16679d-6)
      real*8 autoatm
      parameter (autoatm =290.360032539d6)

      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d
      real*8  a,b,c,alpha,beta,gamma
    

*     ***** energy variables ****
      integer ne(2),ms,ispin
      real*8  E(40),en(2)
      real*8  dipole(3)
      real*8  stress(3,3),lstress(6)

*     **** gradient variables ****
      integer fion(2),fion1(2)

*     **** error variables ****
      logical value,newpsi
      integer ierr

*     **** local variables ****
      logical verlet,mulliken,SA,calc_pressure,nose,bo_cpmd,vverlet
      logical oprint,lprint,hprint,qmmm,found,notfirststep,found_bak
      real*8  gx,gy,gz,cx,cy,cz
      real*8  vgx,vgy,vgz,vcx,vcy,vcz,ekg,eki0,eki1,dt,fmass,dte
      real*8  sum,w,emotion_time_shift,wa,wr
      real*8  EV,EV0,pi,esum1,esum2,eave,evar,dr,E25,E26
      real*8  ratio,aratio
      real*8  icharge,cv
      real*8  sa_alpha(2),sa_decay(2),tt1,tt2,ssr,r,p1,p2,pressure
      real*8 Te_new,Tr_new,Te_init,Tr_init
      integer i,k,ia,nion,minimizer,mapping,icount_shift,icount
      integer nbq,mapping1d,it_in,it_out

      character*50 filename
      character*255 full_filename,full_bak


*     **** external functions ****
      real*8      psp_zv,psp_rc,ewald_rcut
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg,ion_amass
      integer     ewald_ncut,ewald_nshl3d
      integer     psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      integer     psp_nprj,psp_psp_type
      character*4 ion_atom,ion_aname
      external    psp_zv,psp_rc,ewald_rcut
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg,ion_amass
      external    ewald_ncut,ewald_nshl3d
      external    psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      external    psp_nprj,psp_psp_type
      external    ion_atom,ion_aname
      
      external      psp_comment
      character*255 psp_comment,comment

      real*8   control_tole,control_tolc,control_tolr,ion_rion,ion_vion
      external control_tole,control_tolc,control_tolr,ion_rion,ion_vion
      real*8   control_time_step,control_fake_mass,control_bo_fake_mass
      external control_time_step,control_fake_mass,control_bo_fake_mass
      logical  control_read,control_move,ion_init,control_out_of_time
      external control_read,control_move,ion_init,control_out_of_time
      logical  control_translation,control_rotation,control_parallel_io
      external control_translation,control_rotation,control_parallel_io
      integer  pack_nwave_all
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      integer  pspw_charge_nion
      external pack_nwave_all
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external pspw_charge_nion

      character*12 control_boundry
      external     control_boundry
      character*50 control_cell_name
      external     control_cell_name

      logical      psp_semicore
      real*8       psp_rcore,psp_ncore,psp_rlocal
      external     psp_semicore
      external     psp_rcore,psp_ncore,psp_rlocal

      logical  psi_initialize, psi_finalize
      integer  psi_ispin,psi_ne,electron_count,linesearch_count
      external psi_initialize, psi_finalize
      external psi_ispin,psi_ne,electron_count,linesearch_count
      real*8   cgsd_energy,cgsd_noit_energy
      external cgsd_energy,cgsd_noit_energy
      logical  control_Mulliken,control_DOS
      external control_Mulliken,control_DOS
      real*8   ion_TotalCharge
      external ion_TotalCharge
      logical  control_check_charge_multiplicity
      external control_check_charge_multiplicity
      logical   pspw_charge_found,ion_q_FixIon,ion_q_zFixIon
      external  pspw_charge_found,ion_q_FixIon,ion_q_zFixIon
      integer  control_minimizer,control_scf_algorithm
      external control_minimizer,control_scf_algorithm
      integer  control_ks_algorithm
      external control_ks_algorithm
      real*8   control_ks_alpha,control_kerker_g0
      external control_ks_alpha,control_kerker_g0
      logical  control_print,control_balance
      external control_print,control_balance
      integer  control_mapping,control_mapping1d,control_np_orbital
      external control_mapping,control_mapping1d,control_np_orbital
      integer  control_ks_maxit_orb,control_ks_maxit_orbs
      external control_ks_maxit_orb,control_ks_maxit_orbs

      logical  pspw_bqext,control_bo_cpmd
      external pspw_bqext,control_bo_cpmd

      integer  control_bo_steps_in,control_bo_steps_out
      integer  control_bo_algorithm
      real*8   control_bo_time_step,control_rti,ion_ke,ion_Temperature
      external control_bo_steps_in,control_bo_steps_out 
      external control_bo_algorithm
      external control_bo_time_step,control_rti,ion_ke,ion_Temperature
      real*8   ion_com_Temperature
      external ion_com_Temperature
      logical  control_Nose,control_SA,control_pressure,Nose_restart
      real*8   control_Nose_Te,control_Nose_Tr,control_SA_decay,Nose_ssr
      real*8   Nose_Pr,Nose_Pe,Nose_Ee0,Nose_Er0,Nose_dXr
      real*8   Nose_Tr,Nose_Te,Nose_Qr,Nose_Qe,Nose_r_energy
      integer  Nose_Mchain,Nose_Nchain
      external control_Nose,control_SA,control_pressure,Nose_restart
      external control_Nose_Te,control_Nose_Tr,control_SA_decay,Nose_ssr
      external Nose_Pr,Nose_Pe,Nose_Ee0,Nose_Er0,Nose_dXr
      external Nose_Tr,Nose_Te,Nose_Qr,Nose_Qe,Nose_r_energy
      external Nose_Mchain,Nose_Nchain
      integer  ion_nconstraints,ion_ndof
      external ion_nconstraints,ion_ndof


*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(30,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      value = control_read(11,rtdb)
      if (.not. value) 
     > call errquit('error reading control',0, INPUT_ERR)

      call Parallel2d_Init(control_np_orbital())
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

      oprint= ((taskid.eq.MASTER).and.control_print(print_medium))
      lprint= ((taskid.eq.MASTER).and.control_print(print_low))
      hprint= ((taskid.eq.MASTER).and.control_print(print_high))


      if (oprint) call current_second(cpu1)

*     ***** print out header ****
      if (oprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1031)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
      end if
      
      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      minimizer = control_minimizer()
      mapping   = control_mapping()

*     **** initialize psi_data ****
      call psi_data_init(100)



*     **** initialize D3dB data structure ****
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d

*     ***** Initialize double D3dB data structure ****
      if (control_version().eq.4)
     >   call D3dB_Init(2,2*ngrid(1),2*ngrid(2),2*ngrid(3),mapping)

 
*     **** initialize lattice data structure ****
      call lattice_init()
      call G_init()
      call mask_init()
      call Pack_init()
      call D3dB_pfft_init()
      call ga_sync()

*     **** read ions ****
      value = ion_init(rtdb)

*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call psp_init()
      call psp_readall()
      if (psp_semicore(0)) call semicore_check()

*     **** initialize G,mask,ke,coulomb,and ewald data structures ****
      call ke_init()
      if (control_version().eq.3) call coulomb_init()
      if (control_version().eq.4) call coulomb2_init()
      call strfac_init()
      call phafac()
      if (control_version().eq.3) then
         call ewald_init()
         call ewald_phafac()
       end if

*     **** read in wavefunctions and initialize psi ****
      if (.not.control_check_charge_multiplicity()) then
        call psi_new()
        newpsi = .true.
      else
        newpsi = .false.
      end if

*     **** Initialize 1d mappings for ne spaces ****
      call psi_get_ne(ispin,ne)
      mapping1d   = control_mapping1d()
      call Dne_init(ispin,ne,mapping1d)


*     **** read in wavefunctions and initialize psi ****
      value = psi_initialize()


      !call D3dB_n_fft_init(1,psi_ne(1)+psi_ne(2))

*     **** electron and geodesic data structures ****
      call electron_init()
      if ((minimizer.eq.4).or.(minimizer.eq.7)) then  !debug
        call geodesic2_init()
      else
         call geodesic_init()
      end if

*     **** initialize QM/MM ****
      call pspw_init_APC(rtdb)
      call pspw_qmmm_init(rtdb)
      call pspw_charge_init(rtdb)

*     **** initialize SIC and HFX ****
      ne(1) = psi_ne(1)
      ne(2) = psi_ne(2)
      call pspw_init_SIC(rtdb,ne)
      call pspw_init_HFX(rtdb,psi_ispin(),ne)

*     **** initialize DFT+U ****
      call psp_U_init()

*     **** initialize Meta GGA ****
      call nwpw_meta_gga_init()

*     **** initialize metadynamics ****
      call meta_initialize(rtdb)




*     **** initialize pressure ****
      calc_pressure = control_pressure().and.(control_version().eq.3)
      pressure      = 0.0d0
      p1            = 0.0d0
      p2            = 0.0d0
      if (calc_pressure) then
         call psp_stress_init()
         call psp_stress_readall()
      end if


*     **** initialize frac_occ data structure ****
c      call frac_occ_init(rtdb,psi_ispin(),ne)

*     **** initialize linesearching ****
      call linesearch_init()


*     ******************************
*     **** scaling ion velocity ****
*     ******************************
      call ion_init_ke(ekg,eki0,eki1)


*     **** Initialize thermostats ****
      nose = control_Nose()
      if (nose) call Nose_Init((ne(1)+ne(2)),0.01d0)

*     **** Initialize simulated annealing ****
      SA       = .false.
      Tr_init  = 0.0d0
      sa_alpha(2) = 1.0d0
      if (control_SA()) then
         if (nose) then
            SA          = .true.
            sa_decay(2) = control_SA_decay(2)
            Tr_init     = control_Nose_Tr()
         else
            dt = control_bo_time_step()
            SA          = .false.
            sa_decay(2) = control_SA_decay(2)
            sa_alpha(2) = dexp( -(dt/control_SA_decay(2)) )
         end if
      end if

      bo_cpmd = control_bo_cpmd()
      vverlet = (control_bo_algorithm().eq.1)


*                |**************************|
******************   summary of input data  **********************
*                |**************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)
      mulliken = control_Mulliken()


      if (oprint) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j
         if (mapping.eq.1) write(luout,1112) 
         if (mapping.eq.2) write(luout,1113) 
         if (mapping.eq.3) write(luout,1118) 
         if (control_balance()) then
           write(luout,1114)
         else
           write(luout,1116)
         end if
         write(luout,1115)
         if (control_parallel_io()) then
           write(luout,1123)
         else
           write(luout,1124)
         end if

         write(luout,1121) control_boundry(),control_version()
         if (psi_ispin().eq.1) write(luout,1130) "restricted"
         if (psi_ispin().eq.2) write(luout,1130) "unrestricted"
         !if (qmmm) write(luout,1122)
         IF (control_gga().eq.-1) THEN
            write(luout,1131) 'off'
         ELSE IF (control_gga().eq.0) THEN
            write(luout,1131) 'LDA (Vosko et al) parameterization'
         ELSE IF (control_gga().eq.10) THEN
            write(luout,1131) 
     >      'PBE96 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.11) THEN
            write(luout,1131) 
     >      'BLYP (White and Bird) parameterization'
         ELSE IF (control_gga().eq.12) THEN
            write(luout,1131) 
     >      'revPBE (White and Bird) parameterization'
         ELSE IF (control_gga().eq.13) THEN
            write(luout,1131) 
     >      'PBEsol (White and Bird) parameterization'

         ELSE IF (control_gga().eq.110) THEN
            write(luout,1131) 
     >      'PBE0 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.112) THEN
            write(luout,1131) 
     >      'revPBE0 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.113) THEN
            write(luout,1131) 
     >      'BNL (White and Bird) parameterization'
         ELSE IF (control_gga().eq.114) THEN
            write(luout,1131) 
     >      'HSE (White and Bird) parameterization'
         ELSE IF (control_gga().eq.115) THEN
            write(luout,1131) 
     >      'B3LYP (White and Bird) parameterization'

         ELSE IF (control_gga().eq.200) THEN
            write(luout,1131) 'Hartree-Fock'
         ELSE
            write(luout,1131) 'unknown parameterization'
            call errquit('bad exchange_correlation',0, INPUT_ERR)
         END IF
         call pspw_print_SIC(luout)
         call pspw_print_HFX(luout)
         write(luout,1140)
         do ia = 1,ion_nkatm()
            call psp_print(ia)
c           write(luout,1150) ia,ion_atom(ia),
c     >                    psp_zv(ia),psp_lmax(ia)
c           comment = psp_comment(ia)
c           i = inp_strlen(comment)
c           write(luout,1157) comment(1:i)
c           write(luout,1158) psp_psp_type(ia)
c           write(luout,1152) psp_lmax(ia)
c           write(luout,1153) psp_locp(ia)
c           write(luout,1154) psp_nprj(ia)
c           if (control_version().eq.4) write(luout,1156) psp_rlocal(ia)
c           if (psp_semicore(ia))
c     >         write(luout,1155) psp_rcore(ia),psp_ncore(ia)
c           write(luout,1151) (psp_rc(i,ia),i=0,psp_lmax(ia))
c           write(luout,*)
         end do

         icharge = -(psi_ne(1)+psi_ne(psi_ispin()))
         en(1)     = psi_ne(1)
         en(psi_ispin()) = psi_ne(psi_ispin())

c         if (fractional) then
c            icharge = 0
c            do ms=1,psi_ispin()
c            en(ms) =0.0
c            do i=1,ne(ms)
c              k = fweight(1)+(i-1)+(ms-1)*ne(1)
c              icharge = icharge - (3-psi_ispin())*dbl_mb(k)
c              en(ms) = en(ms) + dbl_mb(k)
c            end do
c            end do
c         end if
         icharge = icharge + ion_TotalCharge()
         write(luout,1159) icharge

         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         !if (hprint) then
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         call pspw_charge_Print(luout)

         write(luout,1181)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
         write(luout,1211) ion_nconstraints(),ion_ndof()

         !end if

         !write(6,1220) psi_ne(1),psi_ne(psi_ispin()),' (Fourier space)'
c         if (fractional) then
c          write(6,1219) en(1),en(psi_ispin()),' (   fractional)'
c          write(6,1221) psi_ne(1),psi_ne(psi_ispin()),' (Fourier space)'
c         else
          write(luout,1220) psi_ne(1),psi_ne(psi_ispin()),
     >                      ' (Fourier space)'
          write(luout,1221) psi_ne(1),psi_ne(psi_ispin()),
     >                      ' (Fourier space)'
c         end if
         write(luout,1230)
         write(luout,1233) control_cell_name()
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1231) lattice_omega()
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(0),pack_nwave(0)
         write(luout,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(1),pack_nwave(1)
         if (control_version().eq.3) then
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()
         end if

         write(luout,1270)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_tole(),control_tolc()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()
         if ((minimizer.eq.5).or.(minimizer.eq.8)) then
           write(luout,1291)
           if (control_ks_algorithm().eq.0) 
     >       write(luout,1292) "conjugate gradient"
           if (control_ks_algorithm().eq.1) 
     >       write(luout,1292) "rmm-diis"
           write(luout,1295) control_ks_maxit_orb(),
     >                       control_ks_maxit_orbs()
           if (control_scf_algorithm().eq.0) 
     >       write(luout,1293) "simple mixing"
           if (control_scf_algorithm().eq.1) 
     >       write(luout,1293) "Anderson potential mixing"
           if (control_scf_algorithm().eq.2) 
     >       write(luout,1293) "Johnson-Pulay mixing"
           if (control_scf_algorithm().eq.3) 
     >       write(luout,1293) "Anderson density mixing"
           write(luout,1294) control_ks_alpha()
           write(luout,1301) control_kerker_g0()
         end if
         write(luout,1310)
         if (.not.control_translation()) write(luout,1271)
         if (.not.control_rotation())    write(luout,1272)
         if (.not.bo_cpmd) then
            write(luout,1320) control_bo_time_step(),
     >       control_bo_steps_in()*control_bo_steps_out(),
     >       control_bo_steps_in(),control_bo_steps_out() 
         else
            write(luout,1321) control_bo_time_step(),
     >       control_bo_fake_mass(),
     >       control_bo_steps_in()*control_bo_steps_out(),
     >       control_bo_steps_in(),control_bo_steps_out() 
        end if

         if(control_bo_algorithm().eq.0) write(6,1330) "Position Verlet"
         if(control_bo_algorithm().eq.1) write(6,1330) "Velocity Verlet"
         if(control_bo_algorithm().eq.2) write(6,1330) "Leap Frog"

         write(luout,1340) control_rti()
         write(luout,1222) eki0,ekg
         write(luout,1223) eki1
         write(luout,1224) (eki1-eki0)
         if (nose) then
           write(luout,1395)
           if (Nose_restart()) then
              write(luout,*) "    thermostats resused"
           else
              write(luout,*) "    thermostats initialized"
           end if
           do i=1,Nose_Nchain()
             write(luout,1398) i,control_Nose_Tr(),Nose_Qr(i),
     >                   Nose_Pr(i),Nose_Er0(i)
           end do
         else
           write(luout,1394)
         end if
        if (calc_pressure) write(luout,1393)
         if (control_SA()) then
           write(luout,1396) sa_decay(2)
         end if
         if (mulliken) write(luout,1399)
         write(luout,1300)
         call util_flush(luout)
      end if

*                |***************************|
******************     simple MD loop        **********************
*                |***************************|
      if (taskid.eq.MASTER) call current_second(cpu2)
      if ((taskid.eq.MASTER).and.(.not.calc_pressure)) 
     >   call nwpw_message(10)
      if ((taskid.eq.MASTER).and.(calc_pressure)) 
     >   call nwpw_message(11)


*     **** write initial position to xyz data ****
      call xyz_init()          ! unit=18
      call MOTION_init(rtdb)   ! unit=19


*     *** fei io ****
      call fei_init(rtdb)

*     **** ecce print ****
      call ecce_print_module_entry('task Born-Oppenheimer')
      !call ecce_print_module_entry('driver')
      call movecs_ecce_print_off()


*     **** finalize pressure ****
      if (calc_pressure) then
         call psp_stress_end()
      end if




*     ************************************
*     **** open up other MOTION files ****
*     ************************************
       
*     **** open EMOTION file ****
      E25 = 0.0d0
      E26 = 0.0d0
      icount_shift = 0
      if (.not.rtdb_cget(rtdb,'nwpw:emotion_filename',1,filename))
     >  call util_file_prefix('emotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER) then

*        **** check for backup file ****
         call util_file_name_noprefix('EMOTION99-bak',.false.,
     >                                .false.,
     >                                full_bak)
         inquire(file=full_bak,exist=found_bak)
         if (found_bak) then
            write(*,*)
            write(*,*) "EMOTION99-bak exists:"
            i=index(full_bak,' ')
            k=index(full_filename,' ')
            write(*,*) "   Copying ",full_bak(1:i),
     >                 " to ",full_filename(1:k)
            write(*,*)
            call util_file_copy(full_bak,full_filename)
         end if

         emotion_time_shift = 0.0d0
         icount_shift       = 0
         inquire(file=full_filename,exist=found)
         if (found) then
           open(unit=31,file=full_filename,form='formatted',
     >          status='old')
           do while (found)
           read(31,*,end=100) emotion_time_shift,w,sum
           E25 = E25 + sum   !*** take care of running sums ***
           E26 = E26 + sum*sum
           icount_shift = icount_shift + 1
           end do
  100      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1)
           backspace 31
#endif
         else
           open(unit=31,file=full_filename,form='formatted',
     >          status='new')
         end if
      end if

*     **** open EIGMOTION file ****
      if (mulliken) then
        if (.not.rtdb_cget(rtdb,'nwpw:eigmotion_filename',1,filename))
     >    call util_file_prefix('eigmotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER)
     >   open(unit=32,file=full_filename,form='formatted')
      end if

      call xyz_write()

*     ****  allocate fion ***
      nion = ion_nion()
      if (pspw_charge_found().and.
     >    (.not.pspw_bqext())) nion = nion + pspw_charge_nion()

      value = MA_push_get(mt_dbl,(3*nion),
     >                       'fion',fion(2),fion(1))
      if (vverlet) then
         value = value.and.MA_push_get(mt_dbl,(3*nion),
     >                                'fion1',fion1(2),fion1(1))
      end if
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


      if (bo_cpmd) call psi_cpmd_start()

*     ***** do a simple md loop ***
      notfirststep = .false.
      dt = control_bo_time_step()
      fmass = control_bo_fake_mass()
      dte = dt*dt/fmass
      call control_reduce_print()
      EV = cgsd_energy(newpsi)
      call cgsd_energy_gradient_md(dbl_mb(fion(1)))
      eki1 = ion_ke()

      r = 1.0d0
      if (nose) r =  (1.0d0-0.5d0*dt*Nose_dXr())
      call ion_newton_step(dbl_mb(fion(1)),sa_alpha(2)*r) 
      if (nose) call Nose_Newton_Step(0.01d0,eki1)

      call xyz_write()

      it_out = control_bo_steps_out()
      it_in  = control_bo_steps_in()
      icount = 0
      if (it_out.lt.1) goto 102


  101 continue
         icount = icount + 1

c       **** inner loop ****
        do i=1,it_in
           if (vverlet) then
              call dcopy(3*nion,dbl_mb(fion(1)),1,dbl_mb(fion1(1)),1)
              call ion_shift21() 
           else
              call ion_shift() 
              if (nose) call Nose_shift()
           end if

           if (bo_cpmd) then
              if (notfirststep) then
                 call psi_cpmd_step(dte)
              else
                 notfirststep = .true.
                 call psi_cpmd_step(0.5d0*dte)
              end if
           end if

           EV = cgsd_energy(.false.)
           call cgsd_energy_gradient_md(dbl_mb(fion(1)))


           eki1 = ion_ke()
           if (nose) then
              ssr = Nose_ssr()
              call ion_nose_step(ssr,dbl_mb(fion(1)))
              call Nose_Verlet_Step(0.01d0,eki1)
           else if (vverlet) then
              call ion_vverlet_step(dbl_mb(fion(1)),
     >                              dbl_mb(fion1(1)))  
              call ion_vshift()  
              call ion_newton_step(dbl_mb(fion(1)),sa_alpha(2))
           else
              call ion_verlet_step(dbl_mb(fion(1)),sa_alpha(2))
           end if
        end do
        eki1 = ion_ke()
        E25 = E25 + EV
        E26 = E26 + EV*EV


        if (calc_pressure) then
           call psi_1pressure_stress(pressure,p1,p2,stress)
        end if

        if (oprint) then
           if (calc_pressure) then
             if (nose) then
             write(luout,1350) icount*it_in,EV+eki1+Nose_r_energy(),
     >                         EV,eki1,ion_Temperature(),
     >                         pressure*autoatm
             write(31,1360) icount*it_in*dt+emotion_time_shift,
     >                      EV+eki1+Nose_r_energy(),
     >                      EV,eki1,ion_Temperature(),
     >                      pressure*autoatm
             else
             write(luout,1350) icount*it_in,EV+eki1,EV,eki1,
     >                         ion_Temperature(),
     >                         pressure*autoatm
             write(31,1360) icount*it_in*dt+emotion_time_shift,
     >                      EV+eki1,EV,eki1,ion_Temperature(),
     >                      pressure*autoatm
             end if
           else
             if (nose) then
             write(luout,1350) icount*it_in,EV+eki1+Nose_r_energy(),
     >                         EV,eki1,ion_Temperature()
             write(31,1360) icount*it_in*dt+emotion_time_shift,
     >                      EV+eki1+Nose_r_energy(),
     >                      EV,eki1,ion_Temperature()
             else
             write(luout,1350) icount*it_in,EV+eki1,EV,eki1,
     >                         ion_Temperature()
             write(31,1360) icount*it_in*dt+emotion_time_shift,
     >                      EV+eki1,EV,eki1,ion_Temperature()
             end if
           end if
           call util_flush(6)
           call util_flush(31)
        end if

        call fei_output(EV,dbl_mb(fion(1)))
        call xyz_write()
        call MOTION_write(icount*it_in*dt)

*        **** update thermostats using SA decay ****
         if (SA) then
           tt2 = icount*it_in*dt/sa_decay(2)
           Tr_new = Tr_init*dexp(-tt2)
           call Nose_reset_T(Tr_new,Tr_new)
         end if

*        **** exit early ****
         if (control_out_of_time()) then
            if (oprint)
     >       write(luout,*) ' *** out of time. iteration terminated'
            go to 102
         end if
      if (icount.lt.it_out) go to 101
      if (oprint) write(luout,*) 
     > '*** arived at the Maximum iteration.   terminated.'

*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::
      call control_up_print()

  102 continue
  
      if (bo_cpmd) call psi_cpmd_end()

*     **** close xyz and MOTION files ****
      call xyz_end()
      call MOTION_end()
      if (taskid.eq.MASTER) then
         close(unit=31)
         if (mulliken) close(unit=32)

*        **** remove EMOTION backup file ***
         call util_file_name_noprefix('EMOTION99-bak',.false.,
     >                                .false.,
     >                                full_bak)
         call util_file_unlink(full_bak)

      end if

*     *** close fei io ****
      call fei_end()



c*     ***** do a simple mc loop ***
c      call control_reduce_print()
c      dr = 0.08d0
c      aratio = 0.5d0
c      wa = 0.0d0
c      wr = 0.0d0
c      esum1 = 0.0d0
c      esum2 = 0.0d0
c      eave = 0.0d0
c      evar = 0.0d0
c      beta = util_random(39) !**seed the random number generator
c      beta = 1.0d0/(kb*298.15)
c      call xyz_write()
c      EV0 = cgsd_energy(newpsi)
c      do it=1,control_bo_steps()
c
c        call ion_MC_step(dr)
c        EV = cgsd_energy(.false.)
c        w = dexp(-beta*(EV-EV0))
c        alpha = util_random(0)
c
c        !*** accept the sequence ***
c        if (alpha.lt.w) then
c          EV0 = EV
c          !write(6,*) "   ----ACCEPTED----"
c          if (taskid.eq.MASTER)  then
c             write(6,1350) it,EV,EV0,w,alpha,wa,wr,eave,evar,dr
c             call util_flush(6)
c          end if
c          call xyz_write()
c          call MOTION_write(it*dt)
c          wa = wa + 1.0d0
c          esum1 = esum1 + EV
c          esum2 = esum2 + EV*EV
c          eave = esum1/wa
c          evar = esum2/wa
c          evar = evar - eave*eave
c
c        !*** reject the sequence ***
c        else
c           call ion_MC_reject_step()
c          !write(6,*) "   ----REJECTED----"
c          wr = wr + 1.0d0
c        end if
c
c        !*** adjust ***
c        if (mod(it,10).eq.0) then
c            ratio = wa/(wa+wr)
c            dr = dr*(ratio/aratio)
c            !if (ratio.lt.aratio) dr = dr*0.95d0
c            !if (ratio.gt.aratio) dr = dr*1.05d0
c        end if
c
c      end do
c
c      call control_up_print()

*                |***************************|
******************     simple MD loop        **********************
*                |***************************|


*                |***************************|
****************** report summary of results **********************
*                |***************************|

      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)

      if (oprint) then
         call print_elapsed_time(icount*it_in*dt)
         write(luout,1300)
         write(luout,1410)
         write(luout,1420)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         write(luout,1421)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
         write(luout,1211) ion_nconstraints(),ion_ndof()
      end if

      EV = cgsd_noit_energy()

      if (oprint) then

         write(luout,1300)
         write(luout,1472) ion_ke(),ion_ke()/ion_nion()

*       **** write out Temperatures ****
         eki0 = ion_Temperature()
         write(luout,1480) eki0
         write(luout,1490) ion_com_Temperature()

         eave = E25/dble(icount+icount_shift)
         evar = E26/dble(icount+icount_shift)
         evar = evar - eave*eave
         cv = (evar)/(kb*ion_Temperature()**2)
         cv = cv/dble(ion_nion())
         write(luout,1492) eave
         write(luout,1493) evar
         write(luout,1494) cv

      end if
      call cgsd_energy_gradient(dbl_mb(fion(1)))

*     **** calculate excited state orbitals ****
      call cgsd_excited()

*     **** calculate oep eigenvalues ****
      call cgsd_oep_eigenvalues()

*     **** extra energy output for QA test ****
      if (lprint) write(6,1600) EV

*     **** calculate the spin contamination ****
      if (flag.gt.-1) call psi_spin2(dipole(1))

*     **** calculate the dipole ***
      dipole(1) = 0.0d0
      dipole(2) = 0.0d0
      dipole(3) = 0.0d0
      if (flag.gt.-1) call rho_dipole(dipole)


*     **** calculate the stress tensor ****
      call dcopy(9,0.0d0,0,stress,1)
      call dcopy(6,0.0d0,0,lstress,1)
      if (flag.eq.3) then
         call psp_stress_init()
         call psp_stress_readall()
         call cgsd_energy_stress(stress,lstress)
         call psp_stress_end()
      end if


*     *************************************************************
*     **** output energy, dipole, and gradient to rtdb for use ****
*     **** by task_energy and task_gradient                    ****
*     *************************************************************
      if (flag.gt.-1) then
      value = rtdb_put(rtdb,'pspw:energy',mt_dbl,1,EV)
      value = value.and.
     >        rtdb_put(rtdb,'pspw:dipole',mt_dbl,
     >                 3,dipole)
      end if
      if (flag.gt.0) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:gradient',mt_dbl,
     >                 3*nion,dbl_mb(fion(1)))
      end if
      if (flag.eq.3) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:stress',mt_dbl,
     >                 9,stress)
        value = value.and.
     >        rtdb_put(rtdb,'pspw:lstress',mt_dbl,
     >                 6,lstress)
      end if
      value = value.and.MA_pop_stack(fion1(2))
      value = value.and.MA_pop_stack(fion(2))
      if (.not. value) call errquit('cgmdv5: error writing rtdb',0,
     &       RTDB_ERR)

      if (taskid.eq.MASTER) call current_second(cpu3)

*                |***************************|
******************         Epilogue          **********************
*                |***************************|

*     **** calculate Mulliken Populations ***
      if (control_Mulliken()) call psi_Mulliken(rtdb)




*     **** calculate Mulliken Populations ***

*     **** write wavefunctions to file and finalize psi ****
      if (flag.eq.-1) then
        value = psi_finalize(.false.)
      else
        value = psi_finalize(.true.)
      end if

*     **** write geometry to rtdb ****
      call pspw_charge_write(rtdb)
      call ion_write(rtdb)


*     **** deallocate heap memory ****
      call electron_finalize()
      if ((minimizer.eq.4).or.(minimizer.eq.7)) then
        call geodesic2_finalize()
      else
        call geodesic_finalize()
      end if
      if (control_version().eq.3) call ewald_end()
      call strfac_end()
      if (control_version().eq.3) call coulomb_end()
      if (control_version().eq.4) call coulomb2_end()
      call ke_end()
      call mask_end()
      call Pack_end()
      call G_end()
      call psp_U_end()
      call nwpw_meta_gga_end()
      call pspw_end_SIC()
      call pspw_end_HFX()
      call pspw_end_APC()
      call pspw_charge_end()
      call pspw_qmmm_end()
c      call frac_occ_end()
      call meta_finalize(rtdb)

      if (nose) call Nose_end()
      call ion_end()
      call psp_end()
      call ion_end_FixIon()
      !call D3dB_n_fft_end(1)
      call D3dB_pfft_end()
      call D3dB_end(1)
      if (control_version().eq.4) call D3dB_end(2)
      call Dne_end()
      call psi_data_end()


*     **** do anaylysis on MOTION files ****
      call cpmd_properties(rtdb)



*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (lprint) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(electron_count())
         write(6,1801)
         write(6,1802)
         write(6,1803) T1
         write(6,1804) T2
         write(6,1805) T3
         write(6,1806) T4
         write(6,1807) AV,electron_count(),linesearch_count()

         call nwpw_timing_print_final(oprint,electron_count())

         write(6,*)
         CALL nwpw_MESSAGE(4)
      end if 



      call Parallel_Finalize()
      cgmdv5 = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*               NWPW PSPW Calculation              *')
 1030 FORMAT(10X,'*     [      Born-Oppenheimer molecular       ]    *')
 1031 FORMAT(10X,'*     [          dynamics simulation          ]    *')
 1035 FORMAT(10x,'*     [  NorthWest Chemistry implementation   ]    *')
 1040 FORMAT(10X,'*            version #1.00   07/18/06              *')
 1041 FORMAT(10X,'*    This code was developed by Eric J. Bylaska.   *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I10)
 1112 FORMAT( ' parallel mapping         :      1d slab')
 1113 FORMAT( ' parallel mapping         :   2d hilbert')
 1114 FORMAT( ' parallel mapping         :     balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1117 FORMAT( ' processor grid           :',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         :    2d hcurve')
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1122 FORMAT(5X,' qmmm simulation')
 1123 FORMAT( ' parallel io              :        on')
 1124 FORMAT( ' parallel io              :       off')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I3)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)

 1159 FORMAT(/' total charge:',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I5))
 1180 FORMAT(/' initial position of ions (au):')
 1181 FORMAT(/' initial velocity of ions after scaling (au):')

 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - fixed')
 1192 FORMAT(5X, I4, A5  ,' (',3F11.5,' )')
 1193 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - z fixed')

 1200 FORMAT(5X,'    G.C. ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1211 FORMAT(5X,'   number of constraints = ', I6,' ( DOF = ',I6,' )' )
 1219 FORMAT(/' number of active electrons: spin up=',F6.2,
     >        '  down=',F6.2,A)
 1220 FORMAT(/' number of active electrons: spin up=',I6,  
     >        '  down=',I6,A)
 1221 FORMAT( ' number of active orbitals : spin up=',I6,  
     >        '  down=',I6,A)

 1222 format(5x,' initial kinetic energy=',e12.5,' (ion)',2x,
     >                                     e12.5,' (c.o.m.)')
 1223 format(5x,' after scaling=         ',e12.5,' (ion)')
 1224 format(5x,' increased energy=      ',e12.5,' (ion)')
 1226 format(/' final kinetic energy= ',   e12.5,' (ion)',2x,
     >                                     e12.5,' (c.o.m.)')

 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,'             omega=',F12.1)
 1232 FORMAT(5x,' lattice:    a=    ',f8.3,' b=   ',f8.3,' c=    ',f8.3,
     >      /5x,'             alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1233 FORMAT(5x,' cell_name:  ',A)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1250 FORMAT(/5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
  
 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters for minimizer:')
 1271 FORMAT(5x, ' translation constrained')
 1272 FORMAT(5x, ' rotation constrained')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10, 
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (density)')
 1291 FORMAT(/' Kohn-Sham scf parameters:')
 1292 FORMAT(5X, ' Kohn-Sham algorithm  = ',A)
 1293 FORMAT(5X, ' SCF algorithm        = ',A)
 1294 FORMAT(5X, ' SCF mixing parameter =',F7.4)
 1295 FORMAT(5X, ' Kohn-Sham iterations = ',I4,
     >           ' (',I4,' outer)')
 1300 FORMAT(//)
 1301 FORMAT(5X, ' Kerker damping       =',F7.4)
 1310 FORMAT(/' molecular dynamics parameters:')
 1320 FORMAT(5X, ' time step=',F10.2,5X,' iterations=',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1321 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1,
     >       /5X,' iterations=',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1330 FORMAT(5X, ' integration algorithm=   ',A)
 1340 FORMAT(/5X, ' cooling/heatting rate= ',e12.5,' (ion)')
 1350 FORMAT(I8,2E19.10,E14.5,4F14.2,2E19.10,2F8.4)
 1360 format(100e19.10)

 1393 format(/' Pressure Output Generated         ')
 1394 format(/' Constant Energy Simulation                     ')
 1395 format(/' Nose-Hoover Simulation - Thermostat Parameters:')
 1396 format(5x, 'SA decay rates  =',e10.3,' (ion)')
 1397 format(5x, 'link = ',I3,
     > ' Te =',f8.2,' Qe =',e10.3,' 2*pi/we=',e10.3,' Ee0=',e10.3)
 1398 format(5x, 'link = ',I3,
     > ' Tr =',f8.2,' Qr =',e10.3,' 2*pi/wr=',e10.3,' Er0=',e10.3)

 1399 format(//' Mulliken Analysis Output Generated            ')
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT(/' final position of ions:')
 1421 FORMAT(/' final velocity of ions:')
 1471 FORMAT(/' Kinetic energy (elc)    :',E19.10,' (',E15.5,'/elc)')
 1472 FORMAT( ' Kinetic energy (ion)    :',E19.10,' (',E15.5,'/ion)')
 1473 FORMAT( ' thermostat energy (elc) :',E19.10,' (',E15.5,'/elc)')
 1474 FORMAT( ' thermostat energy (ion) :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(' Temperature :    ',F10.1,' K (ion)')
 1490 FORMAT('             :    ',F10.1,' K (c.o.m.)')
 1491 FORMAT(' Temperature :    ',F10.1,' K (elc)')
 1492 FORMAT(/' Eaverage           :    ',E19.10)
 1493 FORMAT( ' Evariance          :    ',E19.10)
 1494 FORMAT( ' Cv - f*kb/(2*nion) :    ',E19.10)
 1600 FORMAT(/' Total PSPW energy   :',E19.10)
 1801 FORMAT(//'== Timing ==')
 1802 FORMAT(/'cputime in seconds')
 1803 FORMAT( '  prologue    : ',E14.6)
 1804 FORMAT( '  main loop   : ',E14.6)
 1805 FORMAT( '  epilogue    : ',E14.6)
 1806 FORMAT( '  total       : ',E14.6)
 1807 FORMAT( '  cputime/step: ',E14.6,
     >        '       (',I8,' evalulations,', I8,' linesearches)')
 1808 FORMAT(A,E14.6,E14.6)
 1809 FORMAT(//A,2A14)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(6,9010) ierr
      call Parallel_Finalize()

      cgmdv5 = value
      return
      END

      subroutine rhf_fock_2e( geom, basis, g_dens, g_fock, tol2e,
     $     ocoul, oexch, oskel )
*
* $Id: rhf_fock_2e.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
c     
c     Convenience wrapper routine that computes the standard
c     closed shell fock matrix from the input density matrix
c     no questions asked.  It is only called from the initial
c     guess routine with a superposition of atomic densities.
c     Now also called from moints_full to generate an effective
c     frozen-core hamiltonian
c     
      integer geom, basis
      integer g_dens, g_fock    ! [input] handles
      double precision tol2e    ! [input] integral selection threshold
      logical ocoul, oexch      ! [input] compute coulomb/exchange 
      logical oskel             ! [input] compute skeleton fock matrix
c     
c     
      integer vg_dens(2)
      integer vg_fock(2)
      integer nfock
      double precision jfac(2), kfac(2)

      if (ocoul) then
         jfac(1) = 1.d0
      else
         jfac(1) = 0.d0
      endif
      if (oexch) then
         kfac(1) = -0.5d0
      else
         kfac(1) = 0.d0
      endif
      nfock = 1
      vg_dens(1) = g_dens
      vg_fock(1) = g_fock

      call fock_2e( geom, basis, nfock, jfac, kfac, tol2e, oskel,
     $     vg_dens, vg_fock, .false.)
      
      return
      end

      subroutine tce_mrcc_diis(transpose,iter,t1,t2,t3,t4,
     1  d_r1,d_t1,k_t1_offset,size_t1,
     2  d_r2,d_t2,k_t2_offset,size_t2,
     3  d_r3,d_t3,k_t3_offset,size_t3,
     4  d_r4,d_t4,k_t4_offset,size_t4,
     5  rtdb,iref)
c     5  rtdb,iref,nref)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
#include "rtdb.fh"

      logical transpose
      logical t1, t2, t3, t4
      integer d_r1
      integer d_t1
      integer k_t1_offset
      integer d_r1_diis
      integer d_t1_diis
      integer size_t1
      integer d_r2
      integer d_t2
      integer k_t2_offset
      integer d_r2_diis
      integer d_t2_diis
      integer size_t2
      integer d_r3
      integer d_t3
      integer k_t3_offset
      integer d_r3_diis
      integer d_t3_diis
      integer size_t3
      integer d_r4
      integer d_t4
      integer k_t4_offset
      integer d_r4_diis
      integer d_t4_diis
      integer size_t4
      logical nodezero
      character*255 filename
      integer i,j
      double precision a(maxdiism+1,maxdiism+1)
      double precision b(maxdiism+1)
      integer iwork(maxdiism+1)
      integer info
      double precision ddotfile
      external ddotfile

c      integer nref,iref
      integer iref
c      logical mrccdebug
      integer rtdb
      character*3 namechunk
      character*3 namechunk2
c
c     ======================
c     Initialize parameters
c     ======================
c
c       if (.not.rtdb_get(rtdb,'mrcc:debug',mt_log,1,mrccdebug))
c      mrccdebug = .false.
c       if (.not.rtdb_get(rtdb,'bwcc:nref', mt_int, 1, nref))
c     1  call ERRQUIT('tce_mrcc_readref',1,RTDB_ERR)

       nodezero = (ga_nodeid() .eq. 0)
c
c     =====================
c     Jacobi if DIIS is off
c     =====================
c
      if (nodezero.and.mrccdebug) then
        write(LuOut,8000) 'createfile   ', cpusecs(1), cpusecs(51)
        write(LuOut,8000) 'deletefile   ', cpusecs(2), cpusecs(52)
        write(LuOut,8000) 'put_block    ', cpusecs(3), cpusecs(53)
        write(LuOut,8000) 'add_block    ', cpusecs(4), cpusecs(54)
        write(LuOut,8000) 'get_block    ', cpusecs(5), cpusecs(55)
        write(LuOut,8000) 'reconcilefile', cpusecs(6), cpusecs(56)
      endif
 8000 format(1x,'cpu & wall time in seconds for ',A,2f20.1)
c
c     ===================================
c     Trivial case: Jacobi if DIIS is off
c     ===================================
c
      if ((diis.le.0).or.lconverged) then
        if (transpose) then
          if (t1) call tce_jacobi_l1(d_r1,d_t1,k_t1_offset)
          if (t2) call tce_jacobi_l2(d_r2,d_t2,k_t2_offset)
          if (t3) call tce_jacobi_l3(d_r3,d_t3,k_t3_offset)
          if (t4) call tce_jacobi_l4(d_r4,d_t4,k_t4_offset)
        else
          if(.not.lusesub) then
          if (t1) call tce_mrcc_jacobi_t1(d_r1,d_t1,k_t1_offset,iter,
     +            iref)
          if (t2) call tce_mrcc_jacobi_t2(d_r2,d_t2,k_t2_offset,iter,
     +            iref)
          if (t3) call tce_jacobi_t3(d_r3,d_t3,k_t3_offset,iref)
          if (t4) call tce_jacobi_t4(d_r4,d_t4,k_t4_offset)
          else
       if (t1) call tce_jacobi_sub_t1(d_r1,d_t1,k_t1_offset,iter,iref)
       if (t2) call tce_jacobi_sub_t2(d_r2,d_t2,k_t2_offset,iter,iref)
          endif
        endif
        return
      endif
c
c     =====================
c         Copy T files
c     =====================
c
      if (t1) then
      t1_pointerm(iref) = t1_pointerm(iref) + 1
      if (t1_pointerm(iref) .gt. diis) t1_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(t1_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.t1_diis_existm(t1_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")t1_pointerm(iref)
        call tce_filename('t1.d'//namechunk//namechunk2,filename)
        if(lusesub) then
        call pgcreatefile(filename,d_t1_diis,size_t1,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
        else
        call createfile(filename,d_t1_diis,size_t1)
        endif
c        call gatoeaf(d_t1_diis)
c        call gatodra(d_t1_diis)
        t1_diism(t1_pointerm(iref),iref) = d_t1_diis
        t1_diis_existm(t1_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(t1_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_t1_diis = t1_diism(t1_pointerm(iref),iref)
      endif
      if(.not.lusesub) then
      call copyfile(d_t1,d_t1_diis,size_t1)
      else
      call tce_mrcc_gacp(d_t1,d_t1_diis,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()),size_t1)
      endif
      endif

      if (t2) then
      t2_pointerm(iref) = t2_pointerm(iref) + 1
      if (t2_pointerm(iref) .gt. diis) t2_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(t2_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.t2_diis_existm(t2_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")t2_pointerm(iref)
        call tce_filename('t2.d'//namechunk//namechunk2,filename)
        if(lusesub) then
        call pgcreatefile(filename,d_t2_diis,size_t2,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
        else
        call createfile(filename,d_t2_diis,size_t2)
        endif
c        call gatoeaf(d_t2_diis)
c        call gatodra(d_t2_diis)
        t2_diism(t2_pointerm(iref),iref) = d_t2_diis
        t2_diis_existm(t2_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(t2_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_t2_diis = t2_diism(t2_pointerm(iref),iref)
      endif
      if(.not.lusesub) then
      call copyfile(d_t2,d_t2_diis,size_t2)
      else
      call tce_mrcc_gacp(d_t2,d_t2_diis,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()),size_t2)
      endif
      endif
c
c     =====================
c         Copy r files
c     =====================
c
      if (t1) then
      r1_pointerm(iref) = r1_pointerm(iref) + 1
      if (r1_pointerm(iref) .gt. diis) r1_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*) 'diis_exist',(r1_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.r1_diis_existm(r1_pointerm(iref),iref)) then

        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")r1_pointerm(iref)
        call tce_filename("r1.d"//namechunk//namechunk2,filename)

        if(lusesub) then
        call pgcreatefile(filename,d_r1_diis,size_t1,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
        else
        call createfile(filename,d_r1_diis,size_t1)
        endif
c        call gatoeaf(d_r1_diis)
c        call gatodra(d_r1_diis)

        r1_diism(r1_pointerm(iref),iref) = d_r1_diis
        r1_diis_existm(r1_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(r1_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_r1_diis = r1_diism(r1_pointerm(iref),iref)
      endif
      if(.not.lusesub) then
      call copyfile(d_r1,d_r1_diis,size_t1)
      else
      call tce_mrcc_gacp(d_r1,d_r1_diis,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()),size_t1)
      endif
      endif

      if (t2) then
      r2_pointerm(iref) = r2_pointerm(iref) + 1
      if (r2_pointerm(iref) .gt. diis) r2_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(r2_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.r2_diis_existm(r2_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")r2_pointerm(iref)
        call tce_filename("r2.d"//namechunk//namechunk2,filename)
        if(lusesub) then
        call pgcreatefile(filename,d_r2_diis,size_t2,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
        else
        call createfile(filename,d_r2_diis,size_t2)
        endif
c        call gatoeaf(d_r2_diis)
c        call gatodra(d_r2_diis)
        r2_diism(r2_pointerm(iref),iref) = d_r2_diis
        r2_diis_existm(r2_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(r2_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_r2_diis = r2_diism(r2_pointerm(iref),iref)
      endif
      if(.not.lusesub) then
      call copyfile(d_r2,d_r2_diis,size_t2)
      else
      call tce_mrcc_gacp(d_r2,d_r2_diis,
     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()),size_t2)
      endif
      endif

c
c     ==============
c     DIIS or Jacobi
c     ==============
c
      IF (r1_pointerm(iref) .le. diis) THEN
        if (transpose) then
          if (t1) call tce_jacobi_l1(d_r1,d_t1,k_t1_offset)
          if (t2) call tce_jacobi_l2(d_r2,d_t2,k_t2_offset)
          if (t3) call tce_jacobi_l3(d_r3,d_t3,k_t3_offset)
          if (t4) call tce_jacobi_l4(d_r4,d_t4,k_t4_offset)
        else
          if(.not.lusesub) then
          if (t1) call tce_mrcc_jacobi_t1(d_r1,d_t1,k_t1_offset,iter,
     +            iref)
          if (t2) call tce_mrcc_jacobi_t2(d_r2,d_t2,k_t2_offset,iter,
     +            iref)
          if (t3) call tce_jacobi_t3(d_r3,d_t3,k_t3_offset,iref)
          if (t4) call tce_jacobi_t4(d_r4,d_t4,k_t4_offset)
          else
       if (t1) call tce_jacobi_sub_t1(d_r1,d_t1,k_t1_offset,iter,iref)
       if (t2) call tce_jacobi_sub_t2(d_r2,d_t2,k_t2_offset,iter,iref)
          endif
        endif
      END IF
       
c
c     Make Matrix A (at the end of DIIS cycle)
c
      IF(r1_pointerm(iref).eq.diis) THEN 

      if(nodezero.and.mrccdebug) then
      write(6,*)'MICROCYCLE DIIS UPDATE:',
     &          iter,r1_pointerm(iref)
      end if

cjb MAKE TRUE RESIDUES
c        write(6,*)'YES1',ga_nodeid(),iref

        do i=1,diis
         
         if(i.gt.1) then
          call ga_add(1.0d0,t1_diism(i,iref),-1.0d0,t1_diism(i-1,iref),
     1 r1_diism(i,iref))
         endif

         if(i.gt.1) then
          call ga_add(1.0d0,t2_diism(i,iref),-1.0d0,t2_diism(i-1,iref),
     1 r2_diism(i,iref))
         endif

        enddo

c        write(6,*)'YES2',ga_nodeid(),iref

c        if(lusesub) call ga_pgroup_sync(
c     1 int_mb(k_innodes+ga_nnodes()+ga_nodeid()))

cjb
        do i = 1, diis
          do j = i, diis
            a(i,j) = 0.0d0
            if (t1) a(i,j) = a(i,j)
     1      + ddotfile(r1_diism(i,iref),r1_diism(j,iref),size_t1)
            if (t2) a(i,j) = a(i,j)
     1      + ddotfile(r2_diism(i,iref),r2_diism(j,iref),size_t2)
            if (t3) a(i,j) = a(i,j)
     1      + ddotfile(r3_diism(i,iref),r3_diism(j,iref),size_t3)
            if (t4) a(i,j) = a(i,j)
     1      + ddotfile(r4_diism(i,iref),r4_diism(j,iref),size_t4)
            a(j,i) = a(i,j)
          enddo
        enddo
c        write(6,*)'YES3',ga_nodeid(),iref

        do i = 1,diis
          a(i,diis+1) = -1.0d0
          a(diis+1,i) = -1.0d0
        enddo
        a(diis+1,diis+1) = 0.0d0
        do i=1,maxdiism+1
         do j=diis+2,maxdiism+1
          a(i,j) = 0.0d0
          a(j,i) = 0.0d0
         enddo
        enddo
        if (nodezero.and.mrccdebug) then
          call ma_print(a,maxdiism+1,maxdiism+1,'A matrix')
          call util_flush(LuOut)
        endif
c
c     Make Vector B
c
        do i = 1,maxdiism+1
          b(i) = 0.0d0
        enddo
        b(diis+1) = -1.0d0
        if (nodezero.and.mrccdebug) then
          call ma_print(b,maxdiism+1,1,'B vector')
          call util_flush(LuOut)
        endif
c
c     Solve AX = B
c
        call dgesv(diis+1,1,a,maxdiism+1,iwork,b,maxdiism+1,info)
        if (info .ne. 0)
     1    call errquit('tce_diis: LU decomposition failed',0,
     2    UNKNOWN_ERR)
        if (nodezero.and.mrccdebug) then
          call ma_print(b,maxdiism+1,1,'X matrix')
          call util_flush(LuOut)
        endif
c        write(6,*)'YES4',ga_nodeid(),iref

c
c     Make New t's
c
       if(.not.lusesub) then
        if (t1) call mrcc_daxfile(diis,b,t1_diism,d_t1,size_t1,iref)
        if (t2) call mrcc_daxfile(diis,b,t2_diism,d_t2,size_t2,iref)
        if (t3) call mrcc_daxfile(diis,b,t3_diism,d_t3,size_t3,iref)
        if (t4) call mrcc_daxfile(diis,b,t4_diism,d_t4,size_t4,iref)
       else
        if (t1) call tce_mrcc_daxp(diis,b,t1_diism,d_t1,size_t1,iref)
        if (t2) call tce_mrcc_daxp(diis,b,t2_diism,d_t2,size_t2,iref)
        if (t3) call tce_mrcc_daxp(diis,b,t3_diism,d_t3,size_t3,iref)
        if (t4) call tce_mrcc_daxp(diis,b,t4_diism,d_t4,size_t4,iref)
       endif
c        write(6,*)'YES5',ga_nodeid(),iref

        if(lusesub) then
          call ga_pgroup_sync(int_mb(k_innodes+ga_nnodes()+ga_nodeid()))
        else
          call ga_sync()
        endif
      END IF



 9010 format(1x,A,' file name    = ',A)
 9020 format(1x,A,' file handles = ',20i5)

       return
       end
c
c ===================================================
c
      subroutine amp_stabilization(vl,vr,nref)
      double precision vl(nref,nref),vr(nref,nref)
      double precision tol,x,xsum
      integer aux1(nref)
      integer i,j,k,idiff,jdiff,jtot
c
      tol=1.0d-9
c vr part
      do j=1,nref  ! column
       do i=1,nref
        aux1(i)=0
       enddo
       idiff=1
       do i=1,nref
        if(aux1(i).eq.0) then
         x=dabs(vr(i,j))
         if(x.lt.tol) then
          aux1(i)=idiff
          go to 11
         end if
         do k=i,nref
          if(dabs(dabs(vr(k,j))-dabs(x)).le.tol) aux1(k)=idiff
         enddo
 11      continue
         idiff=idiff+1
        end if
       enddo
       idiff=idiff-1
       do jdiff=1,idiff
        jtot=0
        xsum=0.0d0
        do i=1,nref
         if(aux1(i).eq.jdiff) then
          jtot=jtot+1
          xsum=xsum+dabs(vr(i,j))
         end if
        enddo
c        xsum=xsum/dreal(jtot)
        xsum=xsum/dble(jtot)
        do i=1,nref
         if(aux1(i).eq.jdiff) then
           if(vr(i,j).lt.0.0d0) then
            vr(i,j)=-xsum
           else
            vr(i,j)=xsum
           end if
         end if
        enddo
       enddo
      enddo
c vl part
      do j=1,nref  ! column
       do i=1,nref
        aux1(i)=0
       enddo
       idiff=1
       do i=1,nref
        if(aux1(i).eq.0) then
         x=dabs(vl(i,j))
         if(x.lt.tol) then
          aux1(i)=idiff
          go to 12
         end if
         do k=i,nref
          if(dabs(dabs(vl(k,j))-dabs(x)).le.tol) aux1(k)=idiff
         enddo
 12      continue
         idiff=idiff+1
        end if
       enddo
       idiff=idiff-1
       do jdiff=1,idiff
        jtot=0
        xsum=0.0d0
        do i=1,nref
         if(aux1(i).eq.jdiff) then
          jtot=jtot+1
          xsum=xsum+dabs(vl(i,j))
         end if
        enddo
c        xsum=xsum/dreal(jtot)
        xsum=xsum/dble(jtot)
        do i=1,nref
         if(aux1(i).eq.jdiff) then
           if(vl(i,j).lt.0.0d0) then
            vl(i,j)=-xsum
           else
            vl(i,j)=xsum
           end if
         end if
        enddo
       enddo
      enddo
c
      return
      end
c
c ===================================================
c

c $Id: tce_mrcc_diis.F 24345 2013-06-22 06:19:30Z d3y133 $

c
c     write restart
c
      subroutine qmd_write_rst(rstfilename,rstfileunit,
     &  nat,iframe,esys,ekin,geom)
c
      implicit none
c
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "geom.fh"
#include "stdio.fh"
c
#include "qmd_common.fh"
c
      character*(*) rstfilename
      integer rstfileunit
      integer nat
      integer iframe
      double precision esys,ekin,etotal
      integer geom
c
      integer i
      double precision r(3,nat)
      double precision v(3,nat)
c
      character*32 pname
c
      pname = "qmd_write_rst: "
c
c     open file
      open(unit=rstfileunit,file=rstfilename,form='formatted',
     &        position='rewind',status='unknown')
c
c     write number of atoms, frame number and energy
      write(rstfileunit,110) nat
      etotal = esys + ekin
      write(rstfileunit,111) iframe,etotal,esys,ekin
      write(rstfileunit,112) targ_temp,final_temp
      if (.not.geom_cart_coords_get(geom,r))
     $  call errquit(pname//'geom_cart_coords_get',0,GEOM_ERR)
      if (.not.geom_vel_get(geom,v))
     $   call errquit(pname//'geom_vel_set',0,GEOM_ERR)
c
      write(rstfileunit,*) "Coordinates"
      do i=1,nat
         write(rstfileunit,113) r(1,i),r(2,i),r(3,i)
      end do
c
      write(rstfileunit,*) "Velocities"
      do i=1,nat
         write(rstfileunit,113) v(1,i),v(2,i),v(3,i)
      end do
c
      if (rstfileunit.ne.0) close(unit=rstfileunit)
c
  110 format(I5)
  111 format(I5,3f22.12)
  112 format(2f22.12)
  113 format(3f22.12)
c
      return
      end
c $Id: qmd_write_rst.F 24348 2013-06-23 04:29:20Z d3y133 $

      logical function pre_mknoe(lfnout,lfntop,filtop,lfncmd,filcmd,
     + lfnnoe,filnoe,mnoe,lfnpmf,filpmf,slvnam)
c
c $Id: pre_mknoe.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "mafdecls.fh"
#include "util.fh"
c
      logical pre_topsiz,pre_toprd,pre_disres,pre_select,pre_equiv
      external pre_topsiz,pre_toprd,pre_disres,pre_select,pre_equiv
c
      integer lfnout,lfntop,lfncmd,lfnnoe,lfnpmf
      character*255 filtop,filcmd,filnoe,filpmf
      character*255 card,card2
c
      integer nsa,nwa,noe
      integer mat,msa,mwa,mnoe,msm,nsm,msb,nsb
      integer nnoe,nqu,mseq,nseq
      character*3 slvnam
c
      integer l_cwa,i_cwa,l_mas,i_mas,l_num,i_num,l_sat,i_sat
      integer l_csa,i_csa,l_sgm,i_sgm,l_sml,i_sml,l_qsa,i_qsa
      integer l_inoe,i_inoe,l_dnoe,i_dnoe,l_qu,i_qu
      integer l_qwa,i_qwa,l_wat,i_wat,l_sfr,i_sfr
      integer l_isb,i_isb,l_csb,i_csb,l_eq,i_eq
      integer l_temp,i_temp,l_tempj,i_tempj
      integer l_lseq,i_lseq,i_ihop,l_ihop,l_istat,i_istat
c
      integer maxgrp,maxatm,maxpmf
      parameter(maxgrp=500)
      parameter(maxatm=2500)
      parameter(maxpmf=500)
c
      integer igroup(maxgrp,maxatm),lgroup(maxgrp),mgroup(maxgrp)
      integer numpmf,ipmf(maxpmf,5),iopt(maxpmf,3)
      real*8 rpmf(maxpmf,4)
      integer npmfr,ipmfr,nsarep
c
      integer i
c
      npmfr=0
      ipmfr=0
c
      do 2 i=1,maxgrp
      lgroup(i)=0
      mgroup(i)=0
    2 continue
      numpmf=0
c
      if(util_print('where',print_debug)) then
      write(lfnout,1000)
 1000 format(' NOE FILE GENERATION')
      endif
c
      if(.not.pre_topsiz(lfntop,filtop,lfnout,mat,msa,mwa,msb,nqu,nseq))
     + call md_abort('pre_topsiz failed',9999)
c
      if(util_print('where',print_high)) then
      write(lfnout,1001) filtop(1:index(filtop,' ')-1),mat,msa,mwa,msb
 1001 format(' Topology',t40,a,//,
     + ' Number of atom types',t40,i8,/,
     + ' Number of solute atoms',t40,i8,/,
     + ' Number of solvent atoms',t40,i8,/,
     + ' Number of solute bonds',t40,i8,/)
      endif
      nwa=0
      nsa=0
      nsb=0
      nnoe=0
      mseq=nseq
c
c     allocate memory
c     ---------------
c
c     character*16 cwa(mwa)  : solvent atom names
c     character*16 csa(msa)  : solute atom names
c     integer isar(msa)      : solute atom types
c     integer isgm(msa)      : solute segment numbers
c     integer isfnd(msa)     : solute atom found flags
c     real*8 qsa(msa)        : solute atom charges
c     real*8 xs(3,msa)       : solute atom coordinates
c
      if(.not.ma_push_get(mt_dbl,nqu,'qu',l_qu,i_qu))
     + call md_abort('Memory allocation failed for qu',9999)
      if(.not.ma_push_get(mt_int,2*mnoe,'inoe',l_inoe,i_inoe))
     + call md_abort('Memory allocation failed for inoe',9999)
      if(.not.ma_push_get(mt_dbl,5*mnoe,'dnoe',l_dnoe,i_dnoe))
     + call md_abort('Memory allocation failed for dnoe',9999)
      if(.not.ma_push_get(mt_int,mat,'anum',l_num,i_num))
     + call md_abort('Memory allocation failed for anum',9999)
      if(.not.ma_push_get(mt_dbl,mat,'amass',l_mas,i_mas))
     + call md_abort('Memory allocation failed for amass',9999)
      if(.not.ma_push_get(mt_byte,16*mwa,'cwa',l_cwa,i_cwa))
     + call md_abort('Memory allocation failed for cwa',9999)
      if(.not.ma_push_get(mt_dbl,mwa,'qwa',l_qwa,i_qwa))
     + call md_abort('Memory allocation failed for qwa',9999)
      if(.not.ma_push_get(mt_byte,16*msa,'csa',l_csa,i_csa))
     + call md_abort('Memory allocation failed for csa',9999)
      if(.not.ma_push_get(mt_int,mwa,'wat',l_wat,i_wat))
     + call md_abort('Memory allocation failed for wat',9999)
      if(.not.ma_push_get(mt_int,msa,'sat',l_sat,i_sat))
     + call md_abort('Memory allocation failed for sat',9999)
      if(.not.ma_push_get(mt_int,msa,'sgm',l_sgm,i_sgm))
     + call md_abort('Memory allocation failed for sgm',9999)
      if(.not.ma_push_get(mt_int,msa,'sfr',l_sfr,i_sfr))
     + call md_abort('Memory allocation failed for sfr',9999)
      if(.not.ma_push_get(mt_int,msa,'sml',l_sml,i_sml))
     + call md_abort('Memory allocation failed for sml',9999)
      if(.not.ma_push_get(mt_dbl,msa,'qsa',l_qsa,i_qsa))
     + call md_abort('Memory allocation failed for qsa',9999)
      if(.not.ma_push_get(mt_int,2*msb,'idsb',l_isb,i_isb))
     + call md_abort('Memory allocation failed for idsb',9999)
      if(.not.ma_push_get(mt_dbl,msb,'cdsb',l_csb,i_csb))
     + call md_abort('Memory allocation failed for cdsb',9999)
      if(.not.ma_push_get(mt_int,mseq,'lseq',l_lseq,i_lseq))
     + call md_abort('Memory allocation failed for lseq',9999)
      if(.not.ma_push_get(mt_int,msa,'ihop',l_ihop,i_ihop))
     + call md_abort('Memory allocation failed for ihop',9999)
      if(.not.ma_push_get(mt_int,msa,'istat',l_istat,i_istat))
     + call md_abort('Memory allocation failed for istat',9999)
c
      nwa=0
      nsa=0
      nsm=0
      noe=0
c
      if(util_print('where',print_debug)) then
      write(lfnout,1002) 
 1002 format(' Memory allocated')
      endif
c
c     read topology file
c     ------------------
c
      if(.not.pre_toprd(lfntop,filtop,lfnout,
     + int_mb(i_num),dbl_mb(i_mas),mat,
     + byte_mb(i_cwa),dbl_mb(i_qwa),mwa,nwa,
     + int_mb(i_wat),int_mb(i_sat),int_mb(i_sgm),int_mb(i_sml),
     + int_mb(i_sfr),
     + byte_mb(i_csa),dbl_mb(i_qsa),msa,nsa,nsm,int_mb(i_isb),
     + dbl_mb(i_csb),msb,nsb,dbl_mb(i_qu),nqu,slvnam,
     + mseq,nseq,int_mb(i_lseq),int_mb(i_ihop),int_mb(i_istat)))
     + call md_abort('pre_toprd failed',9999)
      if(util_print('coordinates',print_default)) then
      write(lfnout,1003) filtop(1:index(filtop,' ')-1)
 1003 format(' Topology',t40,a,/)
      endif
c
      msm=nsm
c
      if(.not.ma_push_get(mt_int,4*msm,'eq',l_eq,i_eq))
     + call md_abort('Memory allocation failed for eq',9999)
c
c     determine equivalent solute molecules
c     -------------------------------------
c
      if(.not.pre_equiv(byte_mb(i_csa),int_mb(i_sml),int_mb(i_sgm),
     + msa,nsa,int_mb(i_eq),msm,nsm))
     + call md_abort('Solute molecule equivalent test failed',0)
c
c     open the command file
c     ---------------------
c
      open(unit=lfncmd,file=filcmd(1:index(filcmd,' ')-1),
     + form='formatted',status='old',err=999)
      rewind(lfncmd)
c
    1 continue
c
      read(lfncmd,1101,end=9,err=9997) card
 1101 format(a)
c
      if(util_print('where',print_high)) then
      write(lfnout,1099) card
 1099 format('command card ',a)
      endif
c
c     read distance restraints
c     ========================
c
      if(card(1:6).eq.'disres') then
      read(lfncmd,1101,end=9,err=9997) card2
      if(.not.pre_disres(card,card2,int_mb(i_sgm),byte_mb(i_csa),msa,
     + nsa,int_mb(i_inoe),dbl_mb(i_dnoe),mnoe,nnoe))
     + call md_abort('pre_disres failed',9999)
      endif
c
c     read pmf replication
c     ====================
c
      if(card(1:7).eq.'rep_pmf') then
      read(card(8:22),'(i5,i10)') npmfr,nsarep
      ipmfr=numpmf
      endif
c
c     read group selection
c     ====================
c
      if(card(1:6).eq.'select') then
      if(.not.pre_select(card,int_mb(i_sgm),int_mb(i_sml),
     + byte_mb(i_csa),msa,
     + nsa,maxgrp,maxatm,igroup,lgroup,mgroup))
     + call md_abort('pre_select failed',9999)
      endif
c
c     read pmf
c     ========
c
      if(card(1:3).eq.'pmf') then
      numpmf=numpmf+1
      if(numpmf.gt.maxpmf) call md_abort('Increase maxpmf',maxpmf)
      ipmf(numpmf,1)=0
      if(card(5:7).eq.'con') ipmf(numpmf,1)=-1
      if(card(5:7).eq.'dis') ipmf(numpmf,1)=1
      if(card(5:7).eq.'ang') ipmf(numpmf,1)=2
      if(card(5:7).eq.'tor') ipmf(numpmf,1)=3
      if(card(5:7).eq.'imp') ipmf(numpmf,1)=4
      if(card(5:7).eq.'lin') ipmf(numpmf,1)=5
      if(card(5:7).eq.'pla') ipmf(numpmf,1)=6
      if(card(5:7).eq.'bas') ipmf(numpmf,1)=7
      if(card(5:7).eq.'zax') ipmf(numpmf,1)=8
      if(card(5:7).eq.'zdi') ipmf(numpmf,1)=9
      if(card(5:7).eq.'ZAX') ipmf(numpmf,1)=10
      read(card(8:90),'(7i5,2f12.6,2e12.5)')
     + (iopt(numpmf,i),i=1,3),(ipmf(numpmf,i),i=2,5),
     + (rpmf(numpmf,i),i=1,4)
      endif
c
      if(card(1:3).ne.'end') goto 1
c
    9 continue
      close(unit=lfncmd,err=999)
c
      if(nnoe.gt.0) then
      call pre_wrtnoe(lfntop,filtop,mnoe,nnoe,
     + int_mb(i_inoe),dbl_mb(i_dnoe))
      write(lfnout,1004)
 1004 format(/,' Distance restraints appended to topology')
      endif
c
      if(numpmf.gt.0) then
      if(.not.ma_push_get(mt_int,msa,'temp',l_temp,i_temp))
     + call md_abort('Memory allocation failed for temp',9999)
      if(.not.ma_push_get(mt_int,msa,'tempj',l_tempj,i_tempj))
     + call md_abort('Memory allocation failed for tempj',9999)
      call pre_wrtpmf(lfntop,filtop,numpmf,
     + maxpmf,ipmf,rpmf,iopt,maxgrp,maxatm,igroup,lgroup,mgroup,npmfr,
     + ipmfr,nsarep,msa,nsa,int_mb(i_sgm),int_mb(i_sml),byte_mb(i_csa),
     + int_mb(i_eq),msm,nsm,int_mb(i_temp),int_mb(i_tempj))
      if(.not.ma_pop_stack(l_tempj))
     + call md_abort('Memory deallocation failed for tempj',9999)
      if(.not.ma_pop_stack(l_temp))
     + call md_abort('Memory deallocation failed for temp',9999)
      write(lfnout,1005)
 1005 format(/,' Potential of mean force appended to topology')
      endif
c
  999 continue
c
c     deallocate memory
c     -----------------
c
      if(.not.ma_pop_stack(l_eq))
     + call md_abort('Memory deallocation failed for eq',9999)
      if(.not.ma_pop_stack(l_istat))
     + call md_abort('Memory deallocation failed for istat',9999)
      if(.not.ma_pop_stack(l_ihop))
     + call md_abort('Memory deallocation failed for ihop',9999)
      if(.not.ma_pop_stack(l_lseq))
     + call md_abort('Memory deallocation failed for lseq',9999)
      if(.not.ma_pop_stack(l_csb))
     + call md_abort('Memory deallocation failed for cdsb',9999)
      if(.not.ma_pop_stack(l_isb))
     + call md_abort('Memory deallocation failed for idsb',9999)
      if(.not.ma_pop_stack(l_qsa))
     + call md_abort('Memory deallocation failed for qsa',9999)
      if(.not.ma_pop_stack(l_sml))
     + call md_abort('Memory deallocation failed for qsa',9999)
      if(.not.ma_pop_stack(l_sfr))
     + call md_abort('Memory deallocation failed for sfr',9999)
      if(.not.ma_pop_stack(l_sgm))
     + call md_abort('Memory deallocation failed for sgm',9999)
      if(.not.ma_pop_stack(l_sat))
     + call md_abort('Memory deallocation failed for sat',9999)
      if(.not.ma_pop_stack(l_wat))
     + call md_abort('Memory deallocation failed for wat',9999)
      if(.not.ma_pop_stack(l_csa))
     + call md_abort('Memory deallocation failed for csa',9999)
      if(.not.ma_pop_stack(l_qwa))
     + call md_abort('Memory deallocation failed for qwa',9999)
      if(.not.ma_pop_stack(l_cwa))
     + call md_abort('Memory deallocation failed for cwa',9999)
      if(.not.ma_pop_stack(l_mas))
     + call md_abort('Memory deallocation failed for amass',9999)
      if(.not.ma_pop_stack(l_num))
     + call md_abort('Memory deallocation failed for anum',9999)
      if(.not.ma_pop_stack(l_dnoe))
     + call md_abort('Memory deallocation failed for dnoe',9999)
      if(.not.ma_pop_stack(l_inoe))
     + call md_abort('Memory deallocation failed for inoe',9999)
      if(.not.ma_pop_stack(l_qu))
     + call md_abort('Memory deallocation failed for qu',9999)
c
      pre_mknoe=.true.
      return
c
 9997 continue
      write(lfnout,1017) filcmd(1:index(filcmd,' ')-1)
 1017 format(' Error reading commands',t40,a,/)
      pre_mknoe=.false.
      return
c
 9999 continue
      pre_mknoe=.false.
      return
      end

*
* $Id: kbppv3-stress.F 22549 2012-06-02 21:11:04Z bylaska $
*


*     **************************************
*     *                                    *
*     *           kbppv3_stress            *
*     *                                    *
*     **************************************

      logical function kbppv3_stress(oprint_in,version,
     >                  psp_filename,formatted_filename,
     >                  ngrid,unita,locp,lmax,rlocal)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "util.fh"

      logical          oprint_in
      integer          version
      character*50     psp_filename,formatted_filename
      integer          ngrid(3)
      double precision unita(3,3)
      integer locp,lmax
      real*8  rlocal
      character*255 full_filename

      integer taskid,MASTER,msglen
      parameter (MASTER=0)

*     **** 1d pseudopotential data ****
      character*2 atom
      character*80 comment
      double precision zv,amass
      integer lmax0,lmmax,lmax1,locp1
      double precision rc(0:9),rlocal1
      integer nrho
      double precision drho
      integer rho_indx,vp_indx,wp_indx,sc_r_indx,sc_k_indx
      integer rho_hndl,vp_hndl,wp_hndl,sc_r_hndl,sc_k_hndl

      integer          isemicore
      logical          semicore
      double precision rcore

      integer f_indx,cs_indx,sn_indx
      integer f_hndl,cs_hndl,sn_hndl

*     ***** ngrid data *****
      integer vl_indx,vnl_indx,G_indx
      integer vl_hndl,vnl_hndl,G_hndl

*     **** ray data ****
      integer nray,G_ray_hndl,tmp_ray_hndl
      integer rho_sc_k_ray_hndl,dvnl_ray_hndl,dvl_ray_hndl
      integer G_ray_indx,tmp_ray_indx
      integer rho_sc_k_ray_indx,dvnl_ray_indx,dvl_ray_indx

*     **** other variables ****
      logical value,mprint,hprint,oprint,filter
      double precision unitg(3,3)
      integer nsize,i,l,ierr
      integer nfft1,nfft2,nfft3

*     **** external functions ****
      logical  control_print,control_kbpp_ray,control_kbpp_filter
      external control_print,control_kbpp_ray,control_kbpp_filter
      integer  kbpp_calc_nray
      external kbpp_calc_nray


c      call Parallel_init()
      call Parallel_taskid(taskid)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)
      mprint = (taskid.eq.MASTER).and.control_print(print_medium)
      oprint = (oprint_in.or.hprint)

      value = .false.
  
*     ***** read in pseudopotential data ****
      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(psp_filename,.false.,.false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      open(unit=11,file=full_filename(1:l),
     >             status='old',form='formatted')
      read(11,'(A2)') atom
      read(11,*) zv,amass,lmax0,lmax1,locp1,rlocal1
      read(11,*) (rc(i),i=0,lmax0)
      read(11,*) nrho,drho
      read(11,'(A)') comment
      end if

      msglen = 1
      call BRDCST(9+MSGDBL,zv,mdtob(msglen),MASTER)
      call BRDCST(9+MSGDBL,amass,mdtob(msglen),MASTER)
      call BRDCST(9+MSGINT,lmax0,mitob(msglen),MASTER)
      call BRDCST(9+MSGINT,lmax1,mitob(msglen),MASTER)
      call BRDCST(9+MSGINT,locp1,mitob(msglen),MASTER)
      msglen = lmax0+1
      call BRDCST(9+MSGDBL,rc,mdtob(msglen),MASTER)
      msglen = 1
      call BRDCST(9+MSGINT,nrho,mitob(msglen),MASTER)
      call BRDCST(9+MSGDBL,drho,mdtob(msglen),MASTER)


*     **** set the maximum angular momentum ****
      if (lmax.eq.-1)    lmax = lmax1
      if (lmax.gt.lmax0) lmax = lmax0
      if (lmax.lt.0)     lmax = lmax0

*     **** set the local potential ****
      if (locp.eq.-1)   locp = locp1
      if (locp.gt.lmax) locp = lmax
      if (locp.lt.0)    locp = lmax

      

*     **** allocate rho, vp, and wp ****
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'rho',rho_hndl,rho_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho*(lmax+1),
     >                        'vp',vp_hndl, vp_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho*(lmax+1),
     >                        'wp', wp_hndl, wp_indx)
      value = value.and.MA_alloc_get(mt_dbl,2*nrho,
     >                        'sc', sc_r_hndl, sc_r_indx)
      if (.not.value)
     >  call errquit('kbppv3_stress: out of heap memory',0,MA_ERR)

      if (taskid.eq.MASTER) then
      call read_vpwp(11,nrho,lmax,dbl_mb(rho_indx),
     >                         dbl_mb(vp_indx),
     >                         dbl_mb(wp_indx))
      call read_semicore(11,isemicore,rcore,nrho,dbl_mb(sc_r_indx))
      close(11)
      end if

      msglen = nrho
      call BRDCST(9+MSGDBL,dbl_mb(rho_indx),mdtob(msglen),MASTER)
      msglen = nrho*(lmax+1)
      call BRDCST(9+MSGDBL,dbl_mb(vp_indx),mdtob(msglen),MASTER)
      call BRDCST(9+MSGDBL,dbl_mb(wp_indx),mdtob(msglen),MASTER)

      msglen = 1
      call BRDCST(9+MSGINT,isemicore,mitob(msglen),MASTER)
      semicore = (isemicore.eq.1)
      if (semicore) then
      msglen = 2*nrho
      call BRDCST(9+MSGDBL,dbl_mb(sc_r_indx),mdtob(msglen),MASTER)
      else
         rcore = 0.0d0
      end if


*    **** more temporary space ****
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'f',f_hndl,f_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho,
     >                        'cs',cs_hndl,cs_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho,
     >                        'sn',sn_hndl,sn_indx)
      if (.not.value)
     >  call errquit('kbppv3_stress: out of heap memory',0,MA_ERR)

*     **** allocate vl,vnl,vnlnrm G ****
      lmmax = (lmax+1)**2 - (2*locp+1)
      nsize = (ngrid(1)/2+1)*ngrid(2)*ngrid(3)
      value = MA_alloc_get(mt_dbl,nsize,
     >                        'vl',vl_hndl,vl_indx)
      value = value.and.MA_alloc_get(mt_dbl,nsize*(lmmax)*3,
     >                        'vnl',vnl_hndl, vnl_indx)
      value = value.and.MA_alloc_get(mt_dbl,nsize*(3),
     >                        'G',G_hndl, G_indx)
      value = value.and.MA_alloc_get(mt_dbl,4*nsize,
     >                        'sc_k',sc_k_hndl,sc_k_indx)
      if (.not.value)
     >  call errquit('kbppv3_stress: out of heap memory',0,MA_ERR)


*     **** preparation of constants ****
      nfft1=ngrid(1)
      nfft2=ngrid(2)
      nfft3=ngrid(3)
      call setup_kbpp(nfft1,nfft2,nfft3,unita,unitg,dbl_mb(G_indx))
      filter = control_kbpp_filter()

      if (control_kbpp_ray()) then
        !**** allocate memory for rays ****
        nray = kbpp_calc_nray(nfft1,nfft2,nfft3,unita)

        value =           MA_alloc_get(mt_dbl,nray,
     >                  'G_ray',G_ray_hndl,G_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,2*nray,
     >                  'dvl_ray',dvl_ray_hndl,dvl_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,4*nray*(lmax+1),
     >                  'dvnl_ray',dvnl_ray_hndl,dvnl_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,2*nray,
     >              'rho_sc_k_ray',rho_sc_k_ray_hndl,rho_sc_k_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,nray,
     >                  'tmp_ray',tmp_ray_hndl,tmp_ray_indx)
        if (.not.value)
     >   call errquit('kbppv3_stress:out of heap memory',0,MA_ERR)

        call kbpp_generate_G_ray(nfft1,nfft2,nfft3,
     >                         unita,
     >                         dbl_mb(G_ray_indx))

        call integrate_stress_new(version,rlocal,
     >                      nrho,drho,lmax,locp,zv,
     >                                dbl_mb(vp_indx),
     >                                dbl_mb(wp_indx),
     >                                dbl_mb(rho_indx),
     >                                dbl_mb(f_indx),
     >                                dbl_mb(cs_indx),
     >                                dbl_mb(sn_indx),
     >                      nfft1,nfft2,nfft3,lmmax,
     >                                dbl_mb(G_indx),
     >                                dbl_mb(vl_indx),
     >                                dbl_mb(vnl_indx),
     >                                semicore,
     >                                dbl_mb(sc_r_indx),
     >                                dbl_mb(sc_k_indx),
     >                      nray,
     >                                dbl_mb(G_ray_indx),
     >                                dbl_mb(dvl_ray_indx),
     >                                dbl_mb(dvnl_ray_indx),
     >                                dbl_mb(rho_sc_k_ray_indx),
     >                                dbl_mb(tmp_ray_indx),
     >                                filter,
     >                      ierr)
        value = MA_free_heap(tmp_ray_hndl)
        value = value.and.MA_free_heap(rho_sc_k_ray_hndl)
        value = value.and.MA_free_heap(dvnl_ray_hndl)
        value = value.and.MA_free_heap(dvl_ray_hndl)
        value = value.and.MA_free_heap(G_ray_hndl)
        if (.not.value)
     >   call errquit('kbppv3_stress:Error freeing memory',0,MA_ERR)


      else

      call integrate_stress(version,rlocal,
     >                      nrho,drho,lmax,locp,zv,
     >                                dbl_mb(vp_indx),
     >                                dbl_mb(wp_indx),
     >                                dbl_mb(rho_indx),
     >                                dbl_mb(f_indx),
     >                                dbl_mb(cs_indx),
     >                                dbl_mb(sn_indx),
     >                      nfft1,nfft2,nfft3,lmmax,
     >                                dbl_mb(G_indx),
     >                                dbl_mb(vl_indx),
     >                                dbl_mb(vnl_indx),
     >                                semicore,
     >                                dbl_mb(sc_r_indx),
     >                                dbl_mb(sc_k_indx),
     >                      ierr)
      end if


      if ((taskid.eq.MASTER).and.(oprint)) then
      write(*,*) "     ***********************************************"
      write(*,*) "     *                                             *"
      write(*,*) "     *  KBPPV3-Stress - Pseudopotential Formatter  *"
      write(*,*) "     *                                             *"
      write(*,*) "     *      version last updated 4/15/99           *"
      write(*,*) "     *                                             *"
      write(*,*) "     ***********************************************"
      call nwpw_message(1)
      write(*,*)
      write(*,*) "Pseudpotential Data"
      write(*,*) "-------------------"
      write(*,*) "  atom     :",atom
      write(*,*) "  charge   :",zv
      write(*,*) "  mass no. :",amass
      write(*,*) "  highest angular component      :",lmax0
      write(*,*) "  highest angular component used :",lmax
      write(*,*) "  local potential used           :",locp

      if (semicore) then
        write(*,*)
        write(*,115) "  semi-core stress derivative added"
      end if
      write(*,*)
      write(*,*) "Simulation Cell"
      write(*,*) "---------------"
      if (version.eq.3) write(*,112) "  boundry: periodic"
      write(*,113) "  ngrid  :",ngrid
      write(*,114) "  unita  :",unita(1,1),unita(2,1),unita(3,1)
      write(*,114) "          ",unita(1,2),unita(2,2),unita(3,2)
      write(*,114) "          ",unita(1,3),unita(2,3),unita(3,3)
      write(*,*)
  111 format(a,10f10.3)
  112 format(a)
  113 format(a,3I4)
  114 format(a,3F10.3)
  115 format(a,2E14.6)
      end if


      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(formatted_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      if (mprint) then
      write(*,*)
      write(*,*) "Outputing formatted_stress_filename: ",
     >            full_filename(1:l)
      if (filter) write(*,*) "- filtering pseudopotential -"
      !write(*,*)
      end if

      
      call openfile(2,full_filename,l,'w',l)     
         call iwrite(2,version,1)
         call iwrite(2,ngrid,3)
         call dwrite(2,unita,9)
         call dwrite(2,dbl_mb(vl_indx),nsize)
         call dwrite(2,dbl_mb(vnl_indx),nsize*lmmax*3)
         if (semicore) then
           call dwrite(2,dbl_mb(sc_k_indx),nsize)
         end if
      call closefile(2)
      end if
     

*     **** free heap space ****
      value = MA_free_heap(rho_hndl)
      value = value.and.MA_free_heap(vp_hndl)
      value = value.and.MA_free_heap(wp_hndl)
      value = value.and.MA_free_heap(sc_r_hndl)
      value = value.and.MA_free_heap(sc_k_hndl)
      value = value.and.MA_free_heap(f_hndl)
      value = value.and.MA_free_heap(cs_hndl)
      value = value.and.MA_free_heap(sn_hndl)

      value = value.and.MA_free_heap(vl_hndl)
      value = value.and.MA_free_heap(vnl_hndl)
      value = value.and.MA_free_heap(G_hndl)
      if (.not.value)
     >  call errquit('kbppv3_stress: error freeing heap',0,MA_ERR)

      
      if ((taskid.eq.MASTER).and.(oprint)) call nwpw_message(4)

      kbppv3_stress = value
      return

 9999 kbppv3_stress = .false.
      call errquit('Error reading psp_filename',0, DISK_ERR)
      END

#if defined(SEMI)
      subroutine raktest_semi(rtdb)
* $Id: raktest_semi.F 23548 2013-02-07 02:58:11Z d3y133 $
      implicit none
#include "inp.fh"
#include "rtdb.fh"
#include "stdio.fh"
c#include "se_defs.fh"
c
c::passed
      integer rtdb ![input] rtdb handle
c::local
      character*30 mode_name
      integer se_mode
c
c in input deck put: 
*    set "semi:mode" "AM1"
      mode_name = 'MNDO'
      if (.not.rtdb_cget(rtdb,'semi:mode',1,mode_name))
     &    mode_name='MNDO'

      if (inp_compare(.false.,'am1',mode_name)) then
        write(luout,*)' am1 mode '
      elseif (inp_compare(.false.,'mndo',mode_name)) then
        write(luout,*)' am1 mode '
      else
        write(luout,*)' unknown mode '
      endif
      write(luout,*)' mode is ',mode_name
c--------------------------------------------
      if(mode_name.eq.'AM1')se_mode=SE_AM1
      if(mode_name.eq.'MNDO') se_mode=SE_MNDO
      call se_init(rtdb,se_mode)
c--------------------------------------------
c
      end
#else
      subroutine raktest_semi(rtdb)
      implicit none
      integer rtdb
      end
#endif

      subroutine scf_sym_screen(nclosed, nopen, nvir, irs,
     $                          g_v, ivoff, oprint, maxelt)
*
* $Id: scf_sym_scr.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
      integer nclosed, nopen, nvir ! [input] No. of MOs in each space
      integer irs(*) ! [input] symmetry of each MO
      integer g_v    ! [input/output] rotation vector to screen
      integer ivoff  ! [input] Offset within g_v to start of vector
      logical oprint ! [input] If true print warnings
      double precision maxelt ! [output] Returns maximum forbidden element
c
c     Screen the orbital rotation/gradient vector for symmetry
c     forbidden rotations.  Zero them and return the largest.
c
c     Vector is assumed to hold (nclosed+nopen)*nvir + nclosed*nopen
c
      integer i, a, ioff
      double precision test
      integer l_buf, k_buf
      double precision tmp(2)
      integer nmixed 
c
      if (.not. ma_push_get(mt_dbl, nclosed+nopen+nvir, 
     $     'scf_sym_screen', l_buf, k_buf)) 
     $     call errquit('scf_sym_screen: ma?',nclosed+nopen+nvir,
     &       MA_ERR)
c
      call ga_sync
c
      maxelt = 0.0d0
      nmixed = 0
      do i = 1+ga_nodeid(),nclosed+nopen,ga_nnodes()
        if ((nclosed+nopen)*nvir .gt. 0) then
          ioff = 1+(i-1)*nvir + ivoff
          call ga_get(g_v, ioff, ioff+nvir-1, 1, 1, dbl_mb(k_buf), 1)
          do a=1,nvir
            if (irs(i).ne.irs(a+nclosed+nopen)) then
               test = abs(dbl_mb(k_buf-1+a))
               maxelt = max(maxelt,test)
               dbl_mb(k_buf-1+a) = 0.0d0
               if (test.gt.1d-6) nmixed = nmixed + 1
            endif
          enddo
          call ga_put(g_v, ioff, ioff+nvir-1, 1, 1, dbl_mb(k_buf), 1)
        endif
c
        if (i.le.nclosed .and. nopen*nclosed.gt.0) then
          ioff = 1+(nclosed+nopen)*nvir+(i-1)*nopen + ivoff
          call ga_get(g_v, ioff, ioff+nopen-1, 1, 1, dbl_mb(k_buf), 1)
          do a=1,nopen
            if (irs(i).ne.irs(a+nclosed)) then
               test = abs(dbl_mb(k_buf-1+a))
               maxelt = max(maxelt,test)
               dbl_mb(k_buf-1+a) = 0.0d0
               if (test.gt.1d-2) nmixed = nmixed + 1
            endif
          enddo
          call ga_put(g_v, ioff, ioff+nopen-1, 1, 1, dbl_mb(k_buf), 1)
        endif
      enddo
c
      if (.not. ma_pop_stack(l_buf))
     $     call errquit('scf_sym_screen: ma?',-1, MA_ERR)
      call ga_sync
c
      tmp(1) = nmixed
      tmp(2) = maxelt
      call ga_dgop(88,tmp,2,'max')
      nmixed = tmp(1)
      maxelt = tmp(2)
      if (nmixed.gt.0 .and. oprint .and. ga_nodeid().eq.0) then
        write(6,1) nmixed, maxelt
 1      format(/' !!',i8,' symmetry forbidden rotations with max = ',
     $         1p,d9.2/)
        call util_flush(6)
      endif
c
      end
      subroutine scf_sym_mat_screen(g_m, nmo, irs)
      implicit none
#include "global.fh"
      integer g_m               ! [input/output] MO GA to be screened.
      integer nmo               ! [input] NO. of MOs
      integer irs(nmo)          ! [input] Symmetry of each MO
c
c     Force to zero elements of the MO array that should be zero
c     by symmetry.
c
c     Tested but no longer used.
c
      integer i, j
      integer ilo, ihi, jlo, jhi
c
      call ga_sync()
      call ga_distribution(g_m, ga_nodeid(), ilo, ihi, jlo, jhi)
      if (ilo.gt.0 .and. ilo.le.ihi) then
         do i = ilo, ihi
            do j = jlo, jhi
               if (irs(i).ne.irs(j)) 
     $              call ga_put(g_m, i, i, j, j, 0.0d0, 1)
            enddo
         enddo
      endif
      call ga_sync()
c
      end

      

      logical function argos_space_rdmri(lfnmri,stime,pres,
     + temp,tempw,temps,
     + iwl,xw,vw,xwcr,isl,xs,vs)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      logical argos_space_rmri
      external argos_space_rmri
c
      integer lfnmri
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 stime,pres,temp,tempw,temps
      real*8 xw(mwm,3,mwa),vw(mwm,3,mwa),xwcr(mwm,3)
      real*8 xs(msa,3),vs(msa,3)
c
      argos_space_rdmri=argos_space_rmri(lfnmri,stime,pres,
     + temp,tempw,temps,
     + iwl,int_mb(i_packw),xw,vw,xwcr,isl,int_mb(i_pack),xs,vs,
     + int_mb(i_ipl))
c
      return
      end
c $Id: argos_space_rdmri.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_pmec(ipset,xw,nwmloc,xs,isq,isgm,nsaloc,
     + ecorr,iwq,chg,lseq)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer ipset,nwmloc,nsaloc
      real*8 xw(mwm,3,mwa),xs(msa,3),ecorr
      integer isq(msa),iwq(mwa),isgm(msa),lseq(mseq)
      real*8 chg(mqt,mqp,mset)
c
      integer i,icset
c
      ecorr=zero
c
      if(nwmloc.gt.0) then
      do 1 i=1,nwa
      ecorr=ecorr-chg(iwq(i),1,ipset)*chg(iwq(i),1,ipset)
    1 continue
      ecorr=ecorr*dble(nwmloc)
      endif
c
      if(nfhop.eq.0) then
      if(nsaloc.gt.0) then
      do 2 i=1,nsaloc
      ecorr=ecorr-chg(isq(i),1,ipset)*chg(isq(i),1,ipset)
    2 continue
      endif
      else
      do 3 i=1,nsaloc
      icset=lseq(isgm(i))
      ecorr=ecorr-chg(isq(i),1,icset)*chg(isq(i),1,icset)
    3 continue
      endif
c
      ecorr=ealpha*ecorr/sqrt(pi)
c
      return
      end
c $Id: argos_cafe_pmec.F 21176 2011-10-10 06:35:49Z d3y133 $

      integer function nxtasksub(nproc,ichunk,p_handle)
      implicit none
#include "errquit.fh"
#include "global.fh"      
      logical odlb
      common /dlbinfo/ odlb
c#ifdef GANXTVAL
      logical f1stcall
      save f1stcall
      data f1stcall /.true./
      external util_tcesublock
      integer util_tcesublock
c#endif
c
      integer nproc, ichunk     ! [input]
      integer p_handle
c
      integer icount, nleft, nxtval, junk
      external nxtval
      save icount, nleft
      data nleft, icount /0, 0/
c#ifdef GANXTVAL
      if(f1stcall) then
         junk=util_tcesublock(0,p_handle)
         f1stcall=.false.
      endif
c#endif
c     
c     wrapper round nxtval() to increase granularity
c     and thus reduce no. of requests to shared counter
c
c     !! ichunk MUST not be changed during a parallel loop
c     !! AND all processors MUST agree on the value
c     
*      if(nproc.gt.0) then

      odlb = .true.

      if (odlb) then
      if(nproc.eq.ga_pgroup_nnodes(p_handle)) then
         if(nleft.eq.0) then
            icount = util_tcesublock(nproc,p_handle) * ichunk
            nleft = ichunk
         endif
         nxtasksub = icount
         icount = icount + 1
         nleft = nleft -1
*      else if (nproc.lt.0) then
      else if (nproc.eq.-ga_pgroup_nnodes(p_handle)) then
         nleft = 0
         nxtasksub = -1
         junk = util_tcesublock(nproc,p_handle) 
         f1stcall = .true.
      else 
         call errquit('nxtask: invalid nproc ', nproc, UNKNOWN_ERR)
      endif
c     
c     following does dumb static load balancing
c     
      else

         call errquit('nxtask: STATIC DIST !!! ', nproc, UNKNOWN_ERR)

      if(nproc.gt.0) then
         if (nleft .eq. 0) then
            icount = ga_nodeid()
            nleft = 1
         endif
         nxtasksub = icount
         icount = icount + ga_nnodes()
      else
         nleft = 0
         nxtasksub = 0
      endif

      endif
c     
c      if(nxtasksub.eq.-1) call ga_pgroup_sync(p_handle)

c      if(p_handle.eq.1) then
c        write(6,*) ga_nodeid(), ' got task ', nxtasksub
c      endif
c      call forflush(6)
c     
      end


c $Id: tce_subnxtask.F 24345 2013-06-22 06:19:30Z d3y133 $

      double precision function nwpw_double_factorial(n)

      integer n
      integer n11(-1:16)
      data (n11(i), i=-1,16) /1,1,1,2,3,8,15,48,105,384,945,
     >                        3840,10395,46080,135135,645120,
     >                        2027025,10321920/
                                         
      if( n.ge.(-1) .and. n.le.16) then
        nwpw_double_factorial = dble(n11(n))
      else
        nwpw_double_factorial = -999999.0d0
        call errquit("too big parameter in nwpw_double_factorial",1,0)
      end if

      end

c $Id: nwpw_double_factorial.F 25011 2013-12-19 17:45:25Z d3y133 $

      subroutine hnd_ddtxyz(xt,yt,zt,xs,ys,zs,ni,nj,aj)
* $Id: hnd_ddtxyz.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
c
      double precision xt, yt, zt, xs, ys, zs, aj
      integer ni, nj, i, j
c
      dimension xt(ni,nj),yt(ni,nj),zt(ni,nj)
      dimension xs(ni,nj+2),ys(ni,nj+2),zs(ni,nj+2)
c
      do 10 i=1,ni
      xt(i,1)=(xs(i,1  )            -xs(i,3  )*(aj+aj))*aj
      yt(i,1)=(ys(i,1  )            -ys(i,3  )*(aj+aj))*aj
      zt(i,1)=(zs(i,1  )            -zs(i,3  )*(aj+aj))*aj
   10 continue
c
      if(nj.eq.1) return
c
      do 20 i=1,ni
      xt(i,2)=(xs(i,2  )*dble(2+2-1)-xs(i,4  )*(aj+aj))*aj
      yt(i,2)=(ys(i,2  )*dble(2+2-1)-ys(i,4  )*(aj+aj))*aj
      zt(i,2)=(zs(i,2  )*dble(2+2-1)-zs(i,4  )*(aj+aj))*aj
   20 continue
c
      if(nj.eq.2) return
c
      do 30 j=3,nj
      do 30 i=1,ni
      xt(i,j)=(xs(i,j  )*dble(j+j-1)-xs(i,j+2)*(aj+aj))*aj
     1        -xs(i,j-2)*dble(((j-1)*(j-2))/2)
      yt(i,j)=(ys(i,j  )*dble(j+j-1)-ys(i,j+2)*(aj+aj))*aj
     1        -ys(i,j-2)*dble(((j-1)*(j-2))/2)
      zt(i,j)=(zs(i,j  )*dble(j+j-1)-zs(i,j+2)*(aj+aj))*aj
     1        -zs(i,j-2)*dble(((j-1)*(j-2))/2)
   30 continue
c
      return
      end

      subroutine trafsd(nsym,nbas,ndim,a,nbc,cont,nstrt,ffc)
C$Id: trafsd.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c.......................................................................
c     transform matrix a
c     from prim. to cont. basis.
c.......................................................................
      real *8 ffc(*), a(*), cont(*)
      integer nbas(*), nbc(*), nstrt(*)
      integer nsym, ndim
c
      real *8 sumc
      integer i, j, m, n, l
      integer mnstep, ijstep, k, ijbas, mnbas, nbc1, ij, jj
      integer m1, m2, n0, n2
c
      do i = 1 , ndim
         ffc(i) = a(i)
      enddo
      mnstep = 0
      ijstep = 0
      k = 1
      ijbas = 0
      mnbas = 0
      do  l = 1 , nsym
         nbc1 = nbc(l)
         do m = 1 , nbc1
            do n = 1 , m
               m1 = nstrt(mnbas+m)
               n0 = nstrt(mnbas+n)
               m2 = nstrt(mnbas+m+1) - 1
               n2 = nstrt(mnbas+n+1) - 1
               sumc = 0.0d0
               do i = m1 , m2
                  ij = ijstep + (i-ijbas-1)*(i-ijbas)/2
                  if (m.eq.n) then
                     n2 = i
                  end if
                  do j = n0 , n2
                     jj = j - ijbas
                     if (m.ne.n) then
                        sumc = sumc + cont(i)*cont(j)*ffc(ij+jj)
                     else if (i.ne.j) then
                        sumc = sumc + 2.0d0*cont(i)*cont(j)*ffc(ij+jj)
                     else
                        sumc = sumc + cont(i)*cont(j)*ffc(ij+jj)
                     end if
                  enddo
               enddo
               a(k) = sumc
               k = k + 1
            enddo
         enddo
         mnstep = mnstep + nbc(l)*(nbc(l)+1)/2
         ijstep = ijstep + nbas(l)*(nbas(l)+1)/2
         mnbas = mnbas + nbc(l)
         ijbas = ijbas + nbas(l)
      enddo
      return
      end

      subroutine argos_eminit(xw,yw,xs,ys)
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
c
      real*8 xw(mwm,3,mwa),yw(mwm,3,mwa)
      real*8 xs(msa,3),ys(msa,3)
c
      integer i,j
      real*8 dxmax
c
      if(nwmloc.gt.0) then
      do 1 j=1,nwa
      do 2 i=1,nwmloc
      yw(i,1,j)=xw(i,1,j)
      yw(i,2,j)=xw(i,2,j)
      yw(i,3,j)=xw(i,3,j)
    2 continue
    1 continue
      endif
c
      if(nsaloc.gt.0) then
      do 3 i=1,nsaloc
      ys(i,1)=xs(i,1)
      ys(i,2)=xs(i,2)
      ys(i,3)=xs(i,3)
    3 continue
      endif
c
      return
c
      lpair=.true.
      lload=.true.
      lhop=.false.
c
      call argos_finit(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs),
     + dbl_mb(i_xsm),dbl_mb(i_xsmp))
      call argos_forces(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs))
c
c     shake
c
      call argos_shake(dbl_mb(i_xw),dbl_mb(i_yw),int_mb(i_iw),
     + dbl_mb(i_xs),dbl_mb(i_ys),int_mb(i_is),dxmax)
c
      return
      end
c $Id: argos_eminit.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine mp2_read_tijab(nv_lo, nv_hi, irs, symia, 
     $     num_o, sym_hi_o, sym_lo_o, tunit, tunitptr, t)
*
* $Id: mp2_read_tiajb.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "eaf.fh"
#include "util.fh"
      integer nv_lo, nv_hi
      integer irs(*), num_o(0:*), sym_hi_o(0:*), sym_lo_o(0:*), symia
      integer tunit
      double precision tunitptr
      double precision t(*)
c
c     Read t(j,b,i,a) all j, b for given i, a taking into
c     account symmetry blocking
c
      integer count, b, symb, symj
c
#include "bitops.fh"
c
      count = 0
      do b = nv_lo, nv_hi
         symb=irs(b)
         symj=ieor(symb,symia)
         if(num_o(symj).ne.0) count = count + 
     $              sym_hi_o(symj) - sym_lo_o(symj) + 1
      enddo
      if (count .gt. 0) then
         if (eaf_read(tunit, tunitptr, t, 8*count).ne.0) 
     $        call errquit('mp2_pijab: problem reading t_a',0, DISK_ERR)
         tunitptr = tunitptr + 8*count
         if (util_print('tdebug',print_debug)) then
            write(6,12) ddot(count, t, 1, t, 1)
 12         format(1x,12x,f20.8)
         endif
      endif
c
      end

      SUBROUTINE yLAGTF( N, A, LAMBDA, B, C, TOL, D, IN, INFO )
c
* $Id: ylagtf.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
#include "y64.fh"
      INTEGER            INFO, N
      DOUBLE PRECISION   LAMBDA, TOL
*     ..
*     .. Array Arguments ..
      INTEGER            IN( * )
      DOUBLE PRECISION   A( * ), B( * ), C( * ), D( * )
c
      INTGR4            INFO4, N4,IN4(N)
      integer i
c
      n4=n
      call DLAGTF( N4, A, LAMBDA, B, C, TOL, D, IN4, INFO4 )
      do i=1,n
         in(i)=in4(i)
      enddo
      info=info4
      return
      end

      subroutine hnd_elfder(xyzi,expi,coefi,i_nprim,i_ngen, Li,
     1  xyzj,expj,coefj,j_nprim,j_ngen,Lj,nder,nint,elfder,scr,lscr,
     2  xyzpt, npt)
c
c $Id: hnd_elfder.F 21348 2011-10-31 22:51:25Z d3p852 $
c
      implicit double precision (a-h,o-z)
#include "hnd_pointers.fh"
      dimension xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension xyzpt(3,npt)
      dimension scr(lscr) 
      dimension elfder(*)
c
c
c     ----- Wrapper routine that sets the sizes of scratch blocks -----
c
      idim = max(nder*3,1)
c
      call hnd_elfder1(xyzi,expi,coefi,i_nprim,i_ngen, Li, xyzj,expj,
     1 coefj, j_nprim, j_ngen, Lj, nder, nint, elfder, xyzpt, npt, idim,
     2 scr(elpt(1)),scr(elpt(2)),scr(elpt(3)),scr(elpt(4)),scr(elpt(5)),
     3 scr(elpt(6)),scr(elpt(7)),scr(elpt(8)),scr(elpt(9)))
c
      return
      end
c
      subroutine hnd_elfder1(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     1  expj,coefj, j_nprim, j_ngen, Lj, nder, nint, elfder, xyzpt, npt,
     2  idim,xv,yv,zv,dxv,dyv,dzv,ddxv,ddyv,ddzv)
c
      implicit double precision (a-h,o-z)
#include "nwc_const.fh"
#include "hnd_rys.fh"
#include "stdio.fh"
#include "hnd_tol.fh"
      common/hnd_xyzder/xint,yint,zint,tx,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     1                  ni,nj,cx,cy,cz
      dimension w2(maxrys),w4(maxrys)
      dimension Nxyz(3),xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension xyzpt(3,npt),elfder(nint,idim,npt)
c
      dimension xv(Li+1,Lj+1,*)
      dimension yv(Li+1,Lj+1,*)
      dimension zv(Li+1,Lj+1,*)
      dimension dxv(Li+1,Lj+1,*)
      dimension dyv(Li+1,Lj+1,*)
      dimension dzv(Li+1,Lj+1,*)
      dimension ddxv(Li+1,Lj+1,*)
      dimension ddyv(Li+1,Lj+1,*)
      dimension ddzv(Li+1,Lj+1,*)
c
c     Routine calculates the following integrals for a given shell:
c
c     nder =-2 : Electronic wave function
c     nder =-1 : Electronic density
c     nder = 0 : Electrostatic potential
c     nder = 1 : Electric field
c     nder = 2 : Electric field gradient
c
c     Maximum scratch size needs to be Max(nder*3,1))*(Li+1)*(Lj+1)*((Li+Lj)/2+1)
c     Data format elfder will be (nints,ipts,Max(nder*3,1))
c
      data rln10  /2.30258d+00/
      data pi212  /1.1283791670955d+00/
c
      tol=rln10*itol
c
c     Zero integral array
c
      call dcopy(nint*max(nder*3,1)*npt,0.0d0,0,elfder,1)
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi = lit*(lit+1)/2
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj = ljt*(ljt+1)/2
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
      nroots=(lit+ljt+nder-2)/2+1

      if(nroots.gt.maxrys) then
         write(luout,9997) maxrys,lit,ljt,nroots
         call errquit('hnd_elfgrd: need higher Rys root',nroots,INT_ERR)
      endif
c
c     ----- i primitive -----
c
      do 7000 ig=1,i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do 6000 jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=1.0d0/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) go to 6000
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      dum1 = csi * fac
      dij = dum1 * csj
c
c     Electronic density integrals and electronic wave
c     function are done differently
c     then the electric field, electric field gradient, and
c     electrostatic potential integrals
c     Switch between the two classes here:
c
      if (nder.ge.0) goto 399
c
c     ----- electronic wave function / density integral -----
c
c     For wave function we simply set j to 0.0d0 and reset the
c     density factor appropriately
c
      if (nder.eq.-2) then
         dij = csi
         ax = xi
         ay = yi
         az = zi
         aa = ai
         ljt = 1
         maxj = 1
      endif
c
      do 300 ipt=1,npt
         x0=xyzpt(1,ipt)
         y0=xyzpt(2,ipt)
         z0=xyzpt(3,ipt)
         dum = aa*((x0-ax)**2+(y0-ay)**2+(z0-az)**2)
         if(dum.gt.tol) go to 300
         fac = exp(-dum)
c
c        ----- density values -----
c
         do 270 j=1,ljt
            nj=j
            do 270 i=1,lit
               ni=i
               call hnd_denxyz
               xv(i,j,1)=xint
               yv(i,j,1)=yint
               zv(i,j,1)=zint
  270    continue
c
c        ----- combining the pieces together -----
c
         ij=0
         do 290 j=1,maxj
            call getNxyz(Lj,j,Nxyz)
            jx = Nxyz(1) + 1
            jy = Nxyz(2) + 1
            jz = Nxyz(3) + 1
            do 290 i=1,maxi
               call getNxyz(Li,i,Nxyz)
               ix = Nxyz(1) + 1
               iy = Nxyz(2) + 1
               iz = Nxyz(3) + 1
               ij=ij+1
               elfder(ij,1,ipt)=elfder(ij,1,ipt)+fac*dij*xv(ix,jx,1)*
     1                          yv(iy,jy,1)*zv(iz,jz,1)
  290    continue
  300 continue
c
      goto 6000
c
c     ----- electric field (gradient) term -----
c
  399 dij = dij * pi212 * aa1
      aax=aa*ax
      aay=aa*ay
      aaz=aa*az
      do 500 ipt=1,npt
         znuc=1.0d0
         cx=xyzpt(1,ipt)
         cy=xyzpt(2,ipt)
         cz=xyzpt(3,ipt)
         yy=aa*((ax-cx)**2+(ay-cy)**2+(az-cz)**2)
         call hnd_droot
         do 420 iroot=1,nroots
            uu=u9(iroot)*aa
            u4=uu*uu
            ww=w9(iroot)*znuc
            w2(iroot)=ww*uu*2.0d0
            w4(iroot)=ww*u4*4.0d0
            w9(iroot)=ww
            tt=1.0d0/(aa+uu)
            tx= sqrt(tt)
            x0=(aax+uu*cx)*tt
            y0=(aay+uu*cy)*tt
            z0=(aaz+uu*cz)*tt
            do 410 i=1,lit
               ni=i
               do 410 j=1,ljt
                  nj=j
                  goto (402,401) nder+1
                  call hnd_dervxyz(2)
                  ddxv(i,j,iroot)=xint
                  ddyv(i,j,iroot)=yint
                  ddzv(i,j,iroot)=zint
  401             call hnd_dervxyz(1)
                  dxv(i,j,iroot)=xint
                  dyv(i,j,iroot)=yint
                  dzv(i,j,iroot)=zint
  402             call hnd_sxyz
                  xv(i,j,iroot)=xint
                  yv(i,j,iroot)=yint
                  zv(i,j,iroot)=zint
  410       continue
  420    continue
c
c        ----- combining the pieces together -----
c
         ij=0
         do 440 j=1,maxj
            call getNxyz(Lj,j,Nxyz)
            jx = Nxyz(1) + 1
            jy = Nxyz(2) + 1
            jz = Nxyz(3) + 1
            do 450 i=1,maxi
            call getNxyz(Li,i,Nxyz)
            ix = Nxyz(1) + 1
            iy = Nxyz(2) + 1
            iz = Nxyz(3) + 1
            ij=ij+1
            if (nder.eq.2) then
               dumxx=0.0d0
               dumyy=0.0d0
               dumzz=0.0d0
               dumxy=0.0d0
               dumxz=0.0d0
               dumyz=0.0d0
               do 430 iroot=1,nroots
                  dum=xv(ix,jx,iroot)*yv(iy,jy,iroot)*
     1                zv(iz,jz,iroot)*w2(iroot)
                  dumxx=dumxx - dum + ddxv(ix,jx,iroot)*  
     1                  yv(iy,jy,iroot)*zv(iz,jz,iroot)*w4(iroot)
                  dumyy=dumyy - dum + ddyv(iy,jy,iroot)*
     1                  xv(ix,jx,iroot)*zv(iz,jz,iroot)*w4(iroot)
                  dumzz=dumzz - dum + ddzv(iz,jz,iroot)* 
     1                  xv(ix,jx,iroot)*yv(iy,jy,iroot)*w4(iroot)
                  dumxy=dumxy + dxv(ix,jx,iroot)*dyv(iy,jy,iroot)*
     1                  zv(iz,jz,iroot)*w4(iroot)
                  dumxz=dumxz + dxv(ix,jx,iroot)*dzv(iz,jz,iroot)*
     1                  yv(iy,jy,iroot)*w4(iroot)
                  dumyz=dumyz + dyv(iy,jy,iroot)*dzv(iz,jz,iroot)*
     1                  xv(ix,jx,iroot)*w4(iroot)
  430          continue
               
               elfder(ij,1,ipt) = elfder(ij,1,ipt) + dumxx*dij 
               elfder(ij,2,ipt) = elfder(ij,2,ipt) + dumyy*dij
               elfder(ij,3,ipt) = elfder(ij,3,ipt) + dumzz*dij
               elfder(ij,4,ipt) = elfder(ij,4,ipt) + dumxy*dij
               elfder(ij,5,ipt) = elfder(ij,5,ipt) + dumxz*dij
               elfder(ij,6,ipt) = elfder(ij,6,ipt) + dumyz*dij
            elseif (nder.eq.1) then
               dumx=0.0d0
               dumy=0.0d0
               dumz=0.0d0
               do 431 iroot=1,nroots
                  dumx=dumx + dxv(ix,jx,iroot)*yv(iy,jy,iroot)*  
     1                 zv(iz,jz,iroot)*w2(iroot)
                  dumy=dumy + xv(ix,jx,iroot)*dyv(iy,jy,iroot)*  
     1                 zv(iz,jz,iroot)*w2(iroot)
                  dumz=dumz + xv(ix,jx,iroot)*yv(iy,jy,iroot)* 
     1                 dzv(iz,jz,iroot)*w2(iroot)
  431          continue
               elfder(ij,1,ipt) = elfder(ij,1,ipt) + dumx*dij 
               elfder(ij,2,ipt) = elfder(ij,2,ipt) + dumy*dij
               elfder(ij,3,ipt) = elfder(ij,3,ipt) + dumz*dij
            else
               dumx=0.0d0
               do 432 iroot=1,nroots
                  dumx=dumx + xv(ix,jx,iroot)*yv(iy,jy,iroot)*
     1                 zv(iz,jz,iroot)*w9(iroot)
  432          continue
               elfder(ij,1,ipt) = elfder(ij,1,ipt) + dumx*dij 
            endif
  450       continue
  440    continue
c
  500 continue
c
 6000 continue
 7000 continue 
c
      return
 9997 format(' in -elfgrd- , the rys quadrature is not implemented',
     1       ' beyond -nroots- = ',i3,/,
     2       ' lit,ljt,nroots = ',3i3)
      end

      SUBROUTINE ccsdtq_t4_12(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: ccsdtq_t4_12.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_vtt + = 1/4 * P( 16 ) * Sum ( h11 h12 ) * t ( p5 p6 p7 h1 h11 h12 )_t * i1 ( h11 h12 p8 h2 h3 h4 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER p8b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h11b
      INTEGER h12b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p7b_1
      INTEGER h1b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER p8b_2
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO p8b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h4b = h3b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+h1b-1)+i
     &nt_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.1
     &6)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-
     &1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1)
     &))))))) .eq. ieor(irrep_v,ieor(irrep_t,irrep_t))) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_t4_12',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h11b = 1,noab
      DO h12b = h11b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h12
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h11b-1),in
     &t_mb(k_sym+h12b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p5b,p6b,p7b,h1b,h11b,h12b,p5b_1,p6b_1,p7b_1,
     &h1b_1,h11b_1,h12b_1)
      CALL TCE_RESTRICTED_6(p8b,h11b,h12b,h2b,h3b,h4b,p8b_2,h11b_2,h12b_
     &2,h2b_2,h3b_2,h4b_2)
      dim_common = int_mb(k_range+h11b-1) * int_mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+p7b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p8b-1) * int_mb(k_range+h2b-1) * int_mb
     &(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_t4_12',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_t4_12',2,MA_ERR)
      IF ((h12b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h12b_1 - 1 + noab * (h11b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h1b-1),6,3,2,1,5,4,1.0d0)
      END IF
      IF ((h11b .lt. h1b) .and. (h1b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h1b_1 - 1 + noab * (h11b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h11b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+h12b-1),5,3,2,1,6,4,-1.0d0)
      END IF
      IF ((h1b .le. h11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h1b_1 - 1 + noab * (p7b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),4,3,2,1,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_t4_12',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_t4_12',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_t4_12',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h4b_2
     & - 1 + noab * (h3b_2 - 1 + noab * (h2b_2 - 1 + noab * (h12b_2 - 1 
     &+ noab * (h11b_2 - 1 + noab * (p8b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),6,5,4,1,3,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_t4_12',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h11b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_t4_12',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_t4_12',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_t4_12',9,MA_ERR)
      IF ((p7b .le. p8b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,6,4,5,3,2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(p8b - noab - 1 + nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p8b) .and. (h2b .le. h1b) .and. (h1b .le. h3b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,6,4,3,5,2,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * 
     &(p8b - noab - 1 + nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p8b) .and. (h3b .le. h1b) .and. (h1b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,6,4,3,2,5,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p8b - noab - 1 + nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p8b) .and. (h4b .le. h1b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,6,4,3,2,1,5,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p8b - noab - 1 + nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p8b .le. p5b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),4,8,7,6,5,3,2,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1 
     &+ nvab * (p8b - noab - 1)))))))))
      END IF
      IF ((p8b .le. p5b) .and. (h2b .le. h1b) .and. (h1b .le. h3b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),4,8,7,6,3,5,2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1 
     &+ nvab * (p8b - noab - 1)))))))))
      END IF
      IF ((p8b .le. p5b) .and. (h3b .le. h1b) .and. (h1b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),4,8,7,6,3,2,5,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1 
     &+ nvab * (p8b - noab - 1)))))))))
      END IF
      IF ((p8b .le. p5b) .and. (h4b .le. h1b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),4,8,7,6,3,2,1,5,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1 
     &+ nvab * (p8b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p8b) .and. (p8b .le. p6b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,4,7,6,5,3,2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p8b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p8b) .and. (p8b .le. p6b) .and. (h2b .le. h1b) .and.
     & (h1b .le. h3b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,4,7,6,3,5,2,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p8b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p8b) .and. (p8b .le. p6b) .and. (h3b .le. h1b) .and.
     & (h1b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,4,7,6,3,2,5,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p8b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p8b) .and. (p8b .le. p6b) .and. (h4b .le. h1b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,4,7,6,3,2,1,5,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p8b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p8b) .and. (p8b .le. p7b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,4,6,5,3,2,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p8b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p8b) .and. (p8b .le. p7b) .and. (h2b .le. h1b) .and.
     & (h1b .le. h3b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,4,6,3,5,2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p8b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p8b) .and. (p8b .le. p7b) .and. (h3b .le. h1b) .and.
     & (h1b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,4,6,3,2,5,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p8b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p8b) .and. (p8b .le. p7b) .and. (h4b .le. h1b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),8,7,4,6,3,2,1,5,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * 
     &(p7b - noab - 1 + nvab * (p8b - noab - 1 + nvab * (p6b - noab - 1 
     &+ nvab * (p5b - noab - 1)))))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_t4_12',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_t4_12',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* $Id: nwpw_ilist.F 19707 2010-10-29 17:59:36Z d3y133 $
*
#define NIL	-1

*     ***********************************************************
*     *															*
*     *   		   nwpw_ilist library							*
*     *															*
*     *   Author - Eric Bylaska									*
*     *   date   - 10/09/01										*
*     *															*
*     ***********************************************************

*	The nwpw_ilist  library is a linked list for integer values.
*
*

*     ***********************************
*     *									*
*     *	       nwpw_ilist_init			*	
*     *									*
*     ***********************************
      subroutine nwpw_ilist_init(mem)
      implicit none
      integer mem(2)


*     **** initialize list ****
      mem(1) = NIL
      mem(2) = NIL
      return
      end


*     ***********************************
*     *									*
*     *	       nwpw_ilist_add			*	
*     *									*
*     ***********************************

      subroutine nwpw_ilist_add(mem,tag,ivalue)
      implicit none
#include "errquit.fh"
      integer mem(2)
      integer tag
      integer ivalue
     
#include "mafdecls.fh"


*     **** local variables ****
      logical value
      integer node(2),cur
      character*16 id
      
*     **** allocate q_map,p_map,k_map *****
      id='ilist'//CHAR(ICHAR('a')+tag)
      value = MA_alloc_get(mt_int,4,id,node(2),node(1))
      if (.not. value) then
        call errquit('nwpw_ilist_add: out of heap memory',0, MA_ERR)
      end if

      int_mb(node(1))   = NIL
      int_mb(node(1)+1) = NIL
      int_mb(node(1)+2) = tag
      int_mb(node(1)+3) = ivalue


*     *** add to the end of list ***
      if (mem(1).eq.NIL) then
         mem(1) = node(1)
         mem(2) = node(2)
      else
        cur = mem(1)
        do while (int_mb(cur).ne.NIL)
          cur = int_mb(cur)
        end do
        int_mb(cur)   = node(1)
        int_mb(cur+1) = node(2)
      end if

      return
      end

*     ***********************************
*     *									*
*     *	        nwpw_ilist_get   		*	
*     *									*
*     ***********************************
      subroutine nwpw_ilist_get(mem,tag,ivalue)
      implicit none
#include "errquit.fh"
      integer mem(2)
      integer tag
      integer ivalue

#include "mafdecls.fh"

*     **** local variables ****
      integer cur

      cur = mem(1)
      if (cur.eq.NIL) then
         call errquit('nwpw_ilist_get: empty list',0, MEM_ERR)
      end if

      do while ((int_mb(cur+2).ne.tag).and.
     >          (int_mb(cur).ne.NIL))
        cur = int_mb(cur)
      end do

*     **** error - tag not found ****
      if  (int_mb(cur+2).ne.tag) then
         write(*,*) 'tag,mem:',tag,mem
         call errquit('nwpw_ilist_get: tag not found',0, INT_ERR)
      end if

      ivalue = int_mb(cur+3)

      return
      end

         
*     ***********************************
*     *									*
*     *	       nwpw_ilist_delete		*
*     *									*
*     ***********************************

      subroutine nwpw_ilist_delete(mem,tag)      
      implicit none
#include "errquit.fh"
      integer mem(2)
      integer tag

#include "mafdecls.fh"

*     **** local variables ****
      integer cur,prev,del_node(2),next(2)

      prev = mem(1)
      cur  = mem(1)
      if (cur.eq.NIL) then
         write(*,*) 'warning empty ilist, tag,mem:',tag,mem
         return
      end if

*     *** delete first node ****
      if (int_mb(cur+2).eq.tag) then
         del_node(1) = mem(1)
         del_node(2) = mem(2)
         mem(1) = int_mb(cur)
         mem(2) = int_mb(cur+1)

*     *** delete after first node ****
      else
         do while ((int_mb(cur+2).ne.tag).and.
     >             (int_mb(cur).ne.NIL))
           prev = cur
           cur  = int_mb(cur)
         end do

*        **** error - tag not found ****
         if  (int_mb(cur+2).ne.tag) then
            write(*,*) 'tag,mem:',tag,mem
            call errquit('nwpw_ilist_get: tag not found',0, INT_ERR)
         end if

         del_node(1) = int_mb(prev)
         del_node(2) = int_mb(prev+1)
         next(1) = int_mb(cur)
         next(2) = int_mb(cur+1)

         int_mb(prev)   = next(1)
         int_mb(prev+1) = next(2)
      end if

*     **** remove node from heap ****
      if (.not.MA_free_heap(del_node(2))) then
         call errquit('nwpw_ilist_delete: cannot free heap',0, MA_ERR)
      end if
      
      return
      end

      subroutine eomccsd_energy(d_rx1,d_rx2,size_x1,size_x2,
     1           k_x1_offset,k_x2_offset,
     1           d_f1,d_v2,d_t1,d_t2,k_f1_offset,k_v2_offset,
     2           k_t1_offset,k_t2_offset,k_omegax)
      implicit none
#include "global.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
c
      integer size_x1,size_x2
      integer k_x1_offset,k_x2_offset
      integer d_f1,d_v2
      integer d_t1,d_t2
      integer k_f1_offset,k_v2_offset
      integer k_t1_offset,k_t2_offset
c
c      integer iter,ivec
      integer ivec
      logical nodezero
      double precision cpu, wall
      logical needt1,needt2,needt3,needt4
      integer size_x3,size_x4
      integer k_x3_offset,k_x4_offset
      integer d_rx1,d_rx2,d_rx3,d_rx4
      integer k_residual,l_residual
      integer k_omegax, l_omegax
      double precision au2ev   ! Conversion factor from a.u. to eV
      parameter (au2ev=27.2113961d0)
c
      character*255 filename
      character*255 modelname
      logical converged
c
      nodezero=(ga_nodeid().eq.0)
      needt1=.true.
      needt2=.true.
      needt3=.false.
      needt4=.false.
c
      call tce_eom_xguess(needt1,needt2,needt3,needt4,
     1     size_x1,size_x2,size_x3,size_x4,
     2     k_x1_offset,k_x2_offset,k_x3_offset,k_x4_offset)
      if (nxtrials.eq.0) goto 200
      modelname = "EOM-CCSD right-hand side"
      if (nodezero) write(LuOut,9220)
     1   modelname(1:inp_strlen(modelname))
      do iter=1,maxiter
         if (nodezero.and.util_print('eom',print_default))
     1      write(LuOut,9210) iter,nxtrials
         do ivec = 1,nxtrials
            if (.not.xp1_exist(ivec)) then
               call tce_filenameindexed(ivec,'xp1',filename)
               call createfile(filename,xp1(ivec),size_x1)
               xp1_exist(ivec) = .true.
               call dratoga(x1(ivec))
               call dratoga(x2(ivec))
               call eomccsd_x1_grad(d_f1,xp1(ivec),d_t1,d_t2,d_v2,
     1            x1(ivec),x2(ivec),k_f1_offset,k_x1_offset,
     2            k_t1_offset,k_t2_offset,k_v2_offset,
     3            k_x1_offset,k_x2_offset)
               call reconcilefile(xp1(ivec),size_x1)
               call gatodra(x2(ivec))
               call gatodra(x1(ivec))
               call gatodra(xp1(ivec))
            endif
            if (.not.xp2_exist(ivec)) then
               call tce_filenameindexed(ivec,'xp2',filename)
               call createfile(filename,xp2(ivec),size_x2)
               xp2_exist(ivec) = .true.
               call dratoga(x1(ivec))
               call dratoga(x2(ivec))
               call eomccsd_x2_grad(d_f1,xp2(ivec),d_t1,d_t2,d_v2,
     1              x1(ivec),x2(ivec),k_f1_offset,k_x2_offset,
     2              k_t1_offset,k_t2_offset,k_v2_offset,
     3              k_x1_offset,k_x2_offset)
               call reconcilefile(xp2(ivec),size_x2)
               call gatodra(x2(ivec))
               call gatodra(x1(ivec))
               call gatodra(xp2(ivec))
            endif
         enddo
         if (.not.ma_push_get(mt_dbl,nxtrials,'residual',
     1       l_residual,k_residual))
     2       call errquit('eomccsd_energy: ma problem',10,ma_err)
         call tce_eom_xdiagon_grad(needt1,needt2,needt3,needt4,
     1        size_x1,size_x2,size_x3,size_x4,
     2        k_x1_offset,k_x2_offset,k_x3_offset,k_x4_offset,
     3        d_rx1,d_rx2,d_rx3,d_rx4,
     4        dbl_mb(k_omegax),dbl_mb(k_residual))
         cpu=cpu+util_cpusec()
         wall=wall+util_wallsec()
         converged = .true.
         do ivec = 1,nroots_reduced
            if (nodezero.and.(ivec.ne.nroots_reduced))
     1         write(LuOut,9230) dbl_mb(k_residual+ivec-1),
     2         dbl_mb(k_omegax+ivec-1),
     3         dbl_mb(k_omegax+ivec-1)*au2ev
            if (nodezero.and.(ivec.eq.nroots_reduced))
     1         write(LuOut,9230) dbl_mb(k_residual+ivec-1),
     2         dbl_mb(k_omegax+ivec-1),
     3         dbl_mb(k_omegax+ivec-1)*au2ev,cpu,wall
            if (nodezero) call util_flush(LuOut)
            if (dbl_mb(k_residual+ivec-1).gt.thresh)
     1         converged = .false.
         enddo
         cpu=-util_cpusec()
         wall=-util_wallsec()
         if (.not.ma_pop_stack(l_residual))
     1      call errquit("eomccsd_energy: ma problem",20,ma_err)
         if (converged) then
            call tce_eom_xtidy
            if (nodezero) then
               write(LuOut,9240)
               call util_flush(LuOut)
            endif
            goto 200
         endif
      enddo
      call errquit('tce_energy: maxiter exceeded',iter,CALC_ERR)
 200  continue
 9210 format(/,1x,'Iteration ',i3,' using ',i4,' trial vectors')
 9220 format(/,1x,A,' iterations',/,1x,
     1'--------------------------------------------------------------'
     2,/,1x,
     3'     Residuum       Omega / hartree  Omega / eV    Cpu    Wall'
     4,/,1x,
     5'--------------------------------------------------------------')
 9230 format(1x,f17.13,f18.13,f11.5,2f8.1)
 9240 format(1x,
     1'--------------------------------------------------------------'
     2,/,1x,'Iterations converged')
      end
c $Id: eomccsd_energy.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b DSYMM
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
* 
*       .. Scalar Arguments ..
*       DOUBLE PRECISION ALPHA,BETA
*       INTEGER LDA,LDB,LDC,M,N
*       CHARACTER SIDE,UPLO
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION A(LDA,*),B(LDB,*),C(LDC,*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DSYMM  performs one of the matrix-matrix operations
*>
*>    C := alpha*A*B + beta*C,
*>
*> or
*>
*>    C := alpha*B*A + beta*C,
*>
*> where alpha and beta are scalars,  A is a symmetric matrix and  B and
*> C are  m by n matrices.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>           On entry,  SIDE  specifies whether  the  symmetric matrix  A
*>           appears on the  left or right  in the  operation as follows:
*>
*>              SIDE = 'L' or 'l'   C := alpha*A*B + beta*C,
*>
*>              SIDE = 'R' or 'r'   C := alpha*B*A + beta*C,
*> \endverbatim
*>
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>           On  entry,   UPLO  specifies  whether  the  upper  or  lower
*>           triangular  part  of  the  symmetric  matrix   A  is  to  be
*>           referenced as follows:
*>
*>              UPLO = 'U' or 'u'   Only the upper triangular part of the
*>                                  symmetric matrix is to be referenced.
*>
*>              UPLO = 'L' or 'l'   Only the lower triangular part of the
*>                                  symmetric matrix is to be referenced.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>           On entry,  M  specifies the number of rows of the matrix  C.
*>           M  must be at least zero.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the number of columns of the matrix C.
*>           N  must be at least zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is DOUBLE PRECISION.
*>           On entry, ALPHA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
*>           m  when  SIDE = 'L' or 'l'  and is  n otherwise.
*>           Before entry  with  SIDE = 'L' or 'l',  the  m by m  part of
*>           the array  A  must contain the  symmetric matrix,  such that
*>           when  UPLO = 'U' or 'u', the leading m by m upper triangular
*>           part of the array  A  must contain the upper triangular part
*>           of the  symmetric matrix and the  strictly  lower triangular
*>           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
*>           the leading  m by m  lower triangular part  of the  array  A
*>           must  contain  the  lower triangular part  of the  symmetric
*>           matrix and the  strictly upper triangular part of  A  is not
*>           referenced.
*>           Before entry  with  SIDE = 'R' or 'r',  the  n by n  part of
*>           the array  A  must contain the  symmetric matrix,  such that
*>           when  UPLO = 'U' or 'u', the leading n by n upper triangular
*>           part of the array  A  must contain the upper triangular part
*>           of the  symmetric matrix and the  strictly  lower triangular
*>           part of  A  is not referenced,  and when  UPLO = 'L' or 'l',
*>           the leading  n by n  lower triangular part  of the  array  A
*>           must  contain  the  lower triangular part  of the  symmetric
*>           matrix and the  strictly upper triangular part of  A  is not
*>           referenced.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*>           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*>           least  max( 1, n ).
*> \endverbatim
*>
*> \param[in] B
*> \verbatim
*>          B is DOUBLE PRECISION array of DIMENSION ( LDB, n ).
*>           Before entry, the leading  m by n part of the array  B  must
*>           contain the matrix B.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>           On entry, LDB specifies the first dimension of B as declared
*>           in  the  calling  (sub)  program.   LDB  must  be  at  least
*>           max( 1, m ).
*> \endverbatim
*>
*> \param[in] BETA
*> \verbatim
*>          BETA is DOUBLE PRECISION.
*>           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*>           supplied as zero then C need not be set on input.
*> \endverbatim
*>
*> \param[in,out] C
*> \verbatim
*>          C is DOUBLE PRECISION array of DIMENSION ( LDC, n ).
*>           Before entry, the leading  m by n  part of the array  C must
*>           contain the matrix  C,  except when  beta  is zero, in which
*>           case C need not be set on entry.
*>           On exit, the array  C  is overwritten by the  m by n updated
*>           matrix.
*> \endverbatim
*>
*> \param[in] LDC
*> \verbatim
*>          LDC is INTEGER
*>           On entry, LDC specifies the first dimension of C as declared
*>           in  the  calling  (sub)  program.   LDC  must  be  at  least
*>           max( 1, m ).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup double_blas_level3
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 3 Blas routine.
*>
*>  -- Written on 8-February-1989.
*>     Jack Dongarra, Argonne National Laboratory.
*>     Iain Duff, AERE Harwell.
*>     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*>     Sven Hammarling, Numerical Algorithms Group Ltd.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
*
*  -- Reference BLAS level3 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA,BETA
      INTEGER LDA,LDB,LDC,M,N
      CHARACTER SIDE,UPLO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),B(LDB,*),C(LDC,*)
*     ..
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP1,TEMP2
      INTEGER I,INFO,J,K,NROWA
      LOGICAL UPPER
*     ..
*     .. Parameters ..
      DOUBLE PRECISION ONE,ZERO
      PARAMETER (ONE=1.0D+0,ZERO=0.0D+0)
*     ..
*
*     Set NROWA as the number of rows of A.
*
      IF (LSAME(SIDE,'L')) THEN
          NROWA = M
      ELSE
          NROWA = N
      END IF
      UPPER = LSAME(UPLO,'U')
*
*     Test the input parameters.
*
      INFO = 0
      IF ((.NOT.LSAME(SIDE,'L')) .AND. (.NOT.LSAME(SIDE,'R'))) THEN
          INFO = 1
      ELSE IF ((.NOT.UPPER) .AND. (.NOT.LSAME(UPLO,'L'))) THEN
          INFO = 2
      ELSE IF (M.LT.0) THEN
          INFO = 3
      ELSE IF (N.LT.0) THEN
          INFO = 4
      ELSE IF (LDA.LT.MAX(1,NROWA)) THEN
          INFO = 7
      ELSE IF (LDB.LT.MAX(1,M)) THEN
          INFO = 9
      ELSE IF (LDC.LT.MAX(1,M)) THEN
          INFO = 12
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DSYMM ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((M.EQ.0) .OR. (N.EQ.0) .OR.
     +    ((ALPHA.EQ.ZERO).AND. (BETA.EQ.ONE))) RETURN
*
*     And when  alpha.eq.zero.
*
      IF (ALPHA.EQ.ZERO) THEN
          IF (BETA.EQ.ZERO) THEN
              DO 20 J = 1,N
                  DO 10 I = 1,M
                      C(I,J) = ZERO
   10             CONTINUE
   20         CONTINUE
          ELSE
              DO 40 J = 1,N
                  DO 30 I = 1,M
                      C(I,J) = BETA*C(I,J)
   30             CONTINUE
   40         CONTINUE
          END IF
          RETURN
      END IF
*
*     Start the operations.
*
      IF (LSAME(SIDE,'L')) THEN
*
*        Form  C := alpha*A*B + beta*C.
*
          IF (UPPER) THEN
              DO 70 J = 1,N
                  DO 60 I = 1,M
                      TEMP1 = ALPHA*B(I,J)
                      TEMP2 = ZERO
                      DO 50 K = 1,I - 1
                          C(K,J) = C(K,J) + TEMP1*A(K,I)
                          TEMP2 = TEMP2 + B(K,J)*A(K,I)
   50                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = TEMP1*A(I,I) + ALPHA*TEMP2
                      ELSE
                          C(I,J) = BETA*C(I,J) + TEMP1*A(I,I) +
     +                             ALPHA*TEMP2
                      END IF
   60             CONTINUE
   70         CONTINUE
          ELSE
              DO 100 J = 1,N
                  DO 90 I = M,1,-1
                      TEMP1 = ALPHA*B(I,J)
                      TEMP2 = ZERO
                      DO 80 K = I + 1,M
                          C(K,J) = C(K,J) + TEMP1*A(K,I)
                          TEMP2 = TEMP2 + B(K,J)*A(K,I)
   80                 CONTINUE
                      IF (BETA.EQ.ZERO) THEN
                          C(I,J) = TEMP1*A(I,I) + ALPHA*TEMP2
                      ELSE
                          C(I,J) = BETA*C(I,J) + TEMP1*A(I,I) +
     +                             ALPHA*TEMP2
                      END IF
   90             CONTINUE
  100         CONTINUE
          END IF
      ELSE
*
*        Form  C := alpha*B*A + beta*C.
*
          DO 170 J = 1,N
              TEMP1 = ALPHA*A(J,J)
              IF (BETA.EQ.ZERO) THEN
                  DO 110 I = 1,M
                      C(I,J) = TEMP1*B(I,J)
  110             CONTINUE
              ELSE
                  DO 120 I = 1,M
                      C(I,J) = BETA*C(I,J) + TEMP1*B(I,J)
  120             CONTINUE
              END IF
              DO 140 K = 1,J - 1
                  IF (UPPER) THEN
                      TEMP1 = ALPHA*A(K,J)
                  ELSE
                      TEMP1 = ALPHA*A(J,K)
                  END IF
                  DO 130 I = 1,M
                      C(I,J) = C(I,J) + TEMP1*B(I,K)
  130             CONTINUE
  140         CONTINUE
              DO 160 K = J + 1,N
                  IF (UPPER) THEN
                      TEMP1 = ALPHA*A(J,K)
                  ELSE
                      TEMP1 = ALPHA*A(K,J)
                  END IF
                  DO 150 I = 1,M
                      C(I,J) = C(I,J) + TEMP1*B(I,K)
  150             CONTINUE
  160         CONTINUE
  170     CONTINUE
      END IF
*
      RETURN
*
*     End of DSYMM .
*
      END
c $Id: dsymm.f 24342 2013-06-22 05:32:15Z d3y133 $

*
* $Id: peigs_dgop.F 19708 2010-10-29 18:04:21Z d3y133 $
*
#define SIZE_OF_DOUBLE sizeof(double)
c     
      integer function peigs_dgop(ptype, xbuf, plen, op, scratch)
      integer ptype
      integer plen
      double precision xbuf(plen)
      double precision scratch(plen)
c     
      external op
      integer mxcombv1
      external mxcombv1
c     
      integer nprocs, iii
      integer proclist(512)
      integer nnodes
      external nnodes
c     
      nprocs = nnodes()
c     
      do i = 1, nprocs
         proclist(i) = i-1
      enddo
c     
      peigs_dgop = mxcombv1(xbuf, op, 8,
     $     plen, nprocs, proclist, ptype, scratch)
c     
c     
      return
      end

      

*> \brief \b ZTREXC
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZTREXC + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/ztrexc.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/ztrexc.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/ztrexc.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          COMPQ
*       INTEGER            IFST, ILST, INFO, LDQ, LDT, N
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         Q( LDQ, * ), T( LDT, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZTREXC reorders the Schur factorization of a complex matrix
*> A = Q*T*Q**H, so that the diagonal element of T with row index IFST
*> is moved to row ILST.
*>
*> The Schur form T is reordered by a unitary similarity transformation
*> Z**H*T*Z, and optionally the matrix Q of Schur vectors is updated by
*> postmultplying it with Z.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] COMPQ
*> \verbatim
*>          COMPQ is CHARACTER*1
*>          = 'V':  update the matrix Q of Schur vectors;
*>          = 'N':  do not update Q.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix T. N >= 0.
*> \endverbatim
*>
*> \param[in,out] T
*> \verbatim
*>          T is COMPLEX*16 array, dimension (LDT,N)
*>          On entry, the upper triangular matrix T.
*>          On exit, the reordered upper triangular matrix.
*> \endverbatim
*>
*> \param[in] LDT
*> \verbatim
*>          LDT is INTEGER
*>          The leading dimension of the array T. LDT >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] Q
*> \verbatim
*>          Q is COMPLEX*16 array, dimension (LDQ,N)
*>          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
*>          On exit, if COMPQ = 'V', Q has been postmultiplied by the
*>          unitary transformation matrix Z which reorders T.
*>          If COMPQ = 'N', Q is not referenced.
*> \endverbatim
*>
*> \param[in] LDQ
*> \verbatim
*>          LDQ is INTEGER
*>          The leading dimension of the array Q.  LDQ >= max(1,N).
*> \endverbatim
*>
*> \param[in] IFST
*> \verbatim
*>          IFST is INTEGER
*> \endverbatim
*>
*> \param[in] ILST
*> \verbatim
*>          ILST is INTEGER
*>
*>          Specify the reordering of the diagonal elements of T:
*>          The element with row index IFST is moved to row ILST by a
*>          sequence of transpositions between adjacent elements.
*>          1 <= IFST <= N; 1 <= ILST <= N.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex16OTHERcomputational
*
*  =====================================================================
      SUBROUTINE ZTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ
      INTEGER            IFST, ILST, INFO, LDQ, LDT, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         Q( LDQ, * ), T( LDT, * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            WANTQ
      INTEGER            K, M1, M2, M3
      DOUBLE PRECISION   CS
      COMPLEX*16         SN, T11, T22, TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLARTG, ZROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters.
*
      INFO = 0
      WANTQ = LSAME( COMPQ, 'V' )
      IF( .NOT.LSAME( COMPQ, 'N' ) .AND. .NOT.WANTQ ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.MAX( 1, N ) ) ) THEN
         INFO = -6
      ELSE IF( IFST.LT.1 .OR. IFST.GT.N ) THEN
         INFO = -7
      ELSE IF( ILST.LT.1 .OR. ILST.GT.N ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTREXC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.1 .OR. IFST.EQ.ILST )
     $   RETURN
*
      IF( IFST.LT.ILST ) THEN
*
*        Move the IFST-th diagonal element forward down the diagonal.
*
         M1 = 0
         M2 = -1
         M3 = 1
      ELSE
*
*        Move the IFST-th diagonal element backward up the diagonal.
*
         M1 = -1
         M2 = 0
         M3 = -1
      END IF
*
      DO 10 K = IFST + M1, ILST + M2, M3
*
*        Interchange the k-th and (k+1)-th diagonal elements.
*
         T11 = T( K, K )
         T22 = T( K+1, K+1 )
*
*        Determine the transformation to perform the interchange.
*
         CALL ZLARTG( T( K, K+1 ), T22-T11, CS, SN, TEMP )
*
*        Apply transformation to the matrix T.
*
         IF( K+2.LE.N )
     $      CALL ZROT( N-K-1, T( K, K+2 ), LDT, T( K+1, K+2 ), LDT, CS,
     $                 SN )
         CALL ZROT( K-1, T( 1, K ), 1, T( 1, K+1 ), 1, CS,
     $              DCONJG( SN ) )
*
         T( K, K ) = T22
         T( K+1, K+1 ) = T11
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL ZROT( N, Q( 1, K ), 1, Q( 1, K+1 ), 1, CS,
     $                 DCONJG( SN ) )
         END IF
*
   10 CONTINUE
*
      RETURN
*
*     End of ZTREXC
*
      END
c $Id: ztrexc.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine tce_ao2e_new(rtdb,              ! input
!      &                        geom,              ! input
     &                        basis_handle,      ! input
!      &                        tol2e,             ! input
!      &                        ipol,              ! input
     &                        d_ao2e)            ! output
c
c $Id: tce_ao2e_new.F 22501 2012-05-20 06:00:35Z d3y133 $
c
c     Returns a SF handle for the AO 2-e integral matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "inp.fh"
      integer rtdb                 ! Run-time database
      logical nodezero             ! True if node zero
      integer d_ao2e               ! AO integrals
      integer work1,work2          ! Work array sizes
      integer l_work1,k_work1      ! Work array 1
      integer l_work2,k_work2      ! Work array 2
      integer l_ijkl,k_ijkl        ! AO integrals
      integer l_ij,k_ij            ! AO integrals
      integer l_pj,k_pj            ! Quarter transformed
      integer l_pq,k_pq            ! Half transformed
      integer l_pq_packed,k_pq_packed! Packed
      integer g1b,g2b
      integer sf_size_pq
      integer sf_size_kl
      integer ish,jsh,ksh,lsh
      integer i,j,k,l,kl
      integer ikjl,ijkl
      integer ilo,ihi,jlo,jhi
      integer klo,khi,llo,lhi
      integer irange,jrange
      integer krange,lrange
      integer kloff
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      integer next,count,nprocs
      integer N
      character*255 filename
      double precision dbl_size
c
c     New variables: formerly from tce_main.fh, now defined locally
c
!       integer geom
!       integer ipol
      character*255 basis_name
      integer basis_handle
!       integer nbf,nshells
!       double precision tol2e
!       integer noa,nob,nva,nvb
!       integer noab,nvab
!       integer nmo(2)
!       integer max_clocks
!       parameter (max_clocks = 100)
!       double precision cpusecs(max_clocks)  ! to make compiler shut up, but not compatible with rest of TCE
!       integer max_size         ! A large number
!       parameter (max_size = 10000)
!       integer l_movecs_sorted,k_movecs_sorted ! MA handles for MO coeffs
!       integer l_range, k_range ! Length of blocks
!       integer nfc(2),nfv(2)
      logical int_normalize
      external int_normalize
c
c     Old variables, but must be after max_size
c
      integer joff(max_size)       ! j offset
      integer loff(max_size)       ! l offset

c
c     ---------
c     Basis set (formerly in tce_ao2e_new)
c     ---------
c
      basis_name = 'ao basis'
c
!       if (.not.bas_create(basis_handle,basis_name))
!      1  call errquit('tce_ao2e_new: bas_create failed',0,BASIS_ERR)
!       if (.not.bas_rtdb_load(rtdb,geom,basis_handle,basis_name))
!      1  call errquit('tce_ao2e_new: basis not found',0,BASIS_ERR)
!       if (.not.int_normalize(rtdb,basis_handle))
!      1  call errquit('tce_ao2e_new: int_normalize failed',0,INT_ERR)
!       if (.not.bas_numbf(basis_handle,nbf))
!      1  call errquit('tce_ao2e_new: failed to read nbf',0,BASIS_ERR)
!       if (.not.bas_numcont(basis_handle,nshells))
!      1  call errquit('tce_ao2e_new: failed to read nshells',0,BASIS_ERR)
c
c     ===========
c     Set offsets
c     ===========
c
      if (ipol.eq.1) then
        N = (nmo(1) - nfc(1) - nfv(1)) * 2
      else
        N = nmo(1) + nmo(2) - nfc(1) - nfc(2) - nfv(1) - nfv(2)
      endif
      nodezero = (ga_nodeid().eq.0)
      do j = 1, nbf
        joff(j) = (j-1)*nbf
      enddo
      do l = 1, nbf
        loff(l) = (l-1)*nbf
      enddo
c
c     ===========
c     Allocate SF
c     ===========
c
      sf_size_pq = 0
      dbl_size = 0.0d0
      do g1b = 1,noa+nob+nva+nvb
        do g2b = g1b,noa+nob+nva+nvb
          sf_size_pq = sf_size_pq + int_mb(k_range+g1b-1)
     1                            * int_mb(k_range+g2b-1)
          dbl_size   = dbl_size   + dfloat(int_mb(k_range+g1b-1))
     1                            * dfloat(int_mb(k_range+g2b-1))
        enddo
      enddo
c#if !defined(EXT_INT)
c      if ((dbl_size .gt. 16.0d0*1024.0d0**3).and.(ioalg.eq.0)) then
c        write(LuOut,*) '--------------------------------------------'
c        write(LuOut,*) 'Abort: 2 GB file size limit will be exceeded'
c        write(LuOut,*) 'Use GA/SF scheme or OS large file support'
c        write(LuOut,*) '--------------------------------------------'
c        call errquit('tce_ao2e: abort',0,UNKNOWN_ERR)
c      endif
c      if (dbl_size .gt. 2.0d0*1024.0d0**3) then
c        write(LuOut,*) '---------------------------------------------'
c        write(LuOut,*) 'Abort: 32 bit integer overflow is anticipated'
c        write(LuOut,*) 'Use a machine with a 64 bit operating system'
c        write(LuOut,*) '---------------------------------------------'
c        call errquit('tce_ao2e: abort',0,UNKNOWN_ERR)
c      endif
c#endif
      sf_size_kl = nbf**2
      if (nodezero.and.util_print('ao2e',print_default)) then
        write(LuOut,*)
        write(LuOut,9000) sf_size_pq*sf_size_kl
      endif
 9000 format(1x,'2-e (intermediate) file size = ',i15)
      call tce_filename('v2i',filename)
      if (nodezero.and.util_print('mo1e',print_default))
     1  write(LuOut,9010) filename(1:inp_strlen(filename))
 9010 format(1x,'2-e (intermediate) file name = ',A)
      call createfile(filename,d_ao2e,sf_size_pq*sf_size_kl)
c
c     =======================
c     Initialize integral API
c     =======================
c
      call int_mem_2e4c(work1,work2)
      if (.not.ma_push_get(mt_dbl,work1,'work1',l_work1,k_work1))
     1  call errquit('tce_ao2e: MA problem work1',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,work2,'work2',l_work2,k_work2))
     1  call errquit('tce_ao2e: MA problem work2',1,MA_ERR)
      if (.not.ma_push_get(mt_dbl,nbf*nbf,'ij',l_ij,k_ij))
     1  call errquit('tce_ao2e: MA problem k_ij',4,MA_ERR)
      if (.not.ma_push_get(mt_dbl,N*nbf,'pj',l_pj,k_pj))
     1  call errquit('tce_ao2e: MA problem p_ij',5,MA_ERR)
      if (.not.ma_push_get(mt_dbl,N*N,'pq',l_pq,k_pq))
     1  call errquit('tce_ao2e: MA problem k_pq',6,MA_ERR)
      if (.not.ma_push_get(mt_dbl,sf_size_pq,'pq_packed',
     1  l_pq_packed,k_pq_packed))
     2  call errquit('tce_ao2e: MA problem pq_packed',7,
     3  MA_ERR)
c
c     ================
c     Loop over shells
c     ================
c
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do lsh=1,nshells
        do ksh=1,nshells
          if (next.eq.count) then
            if (util_print('ao2e',print_debug))
     1        write(LuOut,9190) lsh,ksh,ga_nodeid()
            if (.not.bas_cn2bfr(basis_handle,ksh,klo,khi))
     1        call errquit('tce_ao2e: basis fn range problem 1',0,
     2        BASIS_ERR)
            krange = khi - klo + 1
            if (.not.bas_cn2bfr(basis_handle,lsh,llo,lhi))
     1        call errquit('tce_ao2e: basis fn range problem 2',1,
     2        BASIS_ERR)
            lrange = lhi - llo + 1
            if (.not.ma_push_get(mt_dbl,sf_size_kl*krange*lrange,
     1        'ao2e',l_ijkl,k_ijkl))
     2        call errquit('tce_ao2e: MA problem k_ijkl',18,MA_ERR)
            do ijkl = 1,sf_size_kl*krange*lrange
              dbl_mb(k_ijkl+ijkl-1) = 0.0d0
            enddo
            do jsh=1,nshells
              do ish=1,nshells
                if (schwarz_shell(ish,ksh)*schwarz_shell(jsh,lsh)
     1            .ge. tol2e) then
                  if (.not.bas_cn2bfr(basis_handle,ish,ilo,ihi))
     1              call errquit('tce_ao2e: basis fn range problem',2,
     2              BASIS_ERR)
                  irange = ihi - ilo + 1
                  if (.not.bas_cn2bfr(basis_handle,jsh,jlo,jhi))
     1              call errquit('tce_ao2e: basis fn range problem',3,
     2              BASIS_ERR)
                  jrange = jhi - jlo + 1
                  call int_2e4c(basis_handle,ish,ksh,basis_handle,jsh,
     1              lsh,work2,dbl_mb(k_work2),work1,dbl_mb(k_work1))
c---------------------------------------------------------------------
                  kl = 0
                  do l = llo,lhi
                    do k = klo,khi
                      kl = kl + 1
                      kloff = (kl-1)*sf_size_kl
                      do j = jlo,jhi
                        do i = ilo,ihi
                          ikjl = (((i-ilo)*krange+(k-klo))*jrange
     1                           +(j-jlo))*lrange+(l-llo)
                          dbl_mb(k_ijkl+kloff+joff(j)+i-1) =
     1                      dbl_mb(k_work1+ikjl)
                        enddo
                      enddo
                    enddo
                  enddo
c---------------------------------------------------------------------
                endif
              enddo
            enddo
c
c     Write to SF
c
            kl = 0
            do l = llo,lhi
              do k = klo,khi
                kl = kl + 1
                kloff = (kl-1)*sf_size_kl
c
c     Half transformation
c
                call dcopy(sf_size_kl,dbl_mb(k_ijkl+kloff),1,
     1            dbl_mb(k_ij),1)
                call dgemm('T','N',N,nbf,nbf,
     1            1.0d0,dbl_mb(k_movecs_sorted),nbf,
     2            dbl_mb(k_ij),nbf,
     3            0.0d0,dbl_mb(k_pj),N)
                call dgemm('N','N',N,N,nbf,
     1            1.0d0,dbl_mb(k_pj),N,
     2            dbl_mb(k_movecs_sorted),nbf,
     3            0.0d0,dbl_mb(k_pq),N)
                call ma_pack(dbl_mb(k_pq),dbl_mb(k_pq_packed),N)
                if (util_print('ao2e',print_debug)) then
                  write(LuOut,9200) l,k
                  call ma_print_compact(dbl_mb(k_pq_packed),
     1              sf_size_pq,1,'Half transformed MO 2e')
                endif
                call put_block(d_ao2e,dbl_mb(k_pq_packed),
     1            sf_size_pq,(loff(l)+k-1)*sf_size_pq)
              enddo
            enddo
            if (.not.ma_pop_stack(l_ijkl))
     1        call errquit('tce_ao2e: MA problem x1',16,MA_ERR)
cc            next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call reconcilefile(d_ao2e,sf_size_pq*sf_size_kl)
c
c     ==========
c     Deallocate
c     ==========
c
      if (.not.ma_pop_stack(l_pq_packed))
     1  call errquit('tce_ao2e: MA problem',8,MA_ERR)
      if (.not.ma_pop_stack(l_pq))
     1  call errquit('tce_ao2e: MA problem',9,MA_ERR)
      if (.not.ma_pop_stack(l_pj))
     1  call errquit('tce_ao2e: MA problem',10,MA_ERR)
      if (.not.ma_pop_stack(l_ij))
     1  call errquit('tce_ao2e: MA problem',11,MA_ERR)
      if (.not.ma_pop_stack(l_work2))
     1  call errquit('tce_ao2e: MA problem',14,MA_ERR)
      if (.not.ma_pop_stack(l_work1))
     1  call errquit('tce_ao2e: MA problem',15,MA_ERR)
      if (nodezero.and.util_print('time',print_debug)) then
        write(LuOut,8000) 'createfile   ', cpusecs(1), cpusecs(51)
        write(LuOut,8000) 'deletefile   ', cpusecs(2), cpusecs(52)
        write(LuOut,8000) 'put_block    ', cpusecs(3), cpusecs(53)
        write(LuOut,8000) 'add_block    ', cpusecs(4), cpusecs(54)
        write(LuOut,8000) 'get_block    ', cpusecs(5), cpusecs(55)
        write(LuOut,8000) 'reconcilefile', cpusecs(6), cpusecs(56)
      endif
c
c     ======
c     Return
c     ======
c
 8000 format(1x,'cpu & wall time in seconds for ',A,2f20.1)
 9190 format(/,'k- and l-shells',2i3,' has been assigned to node ',i3)
 9200 format(/,'k and l',2i3)
      return
      end

      SUBROUTINE ccsdtq_lambda2_26_5_1(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsdtq_lambda2_26_5_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h3 h8 h9 h10 h14 p1 p5 p6 )_yt + = 1 * Sum ( p11 ) * t ( p11 h14 )_t * y ( h3 h8 h9 h10 p1 p5 p6 p11 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h8b
      INTEGER h9b
      INTEGER h10b
      INTEGER p1b
      INTEGER h14b
      INTEGER p5b
      INTEGER p6b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p11b
      INTEGER p11b_1
      INTEGER h14b_1
      INTEGER h3b_2
      INTEGER h8b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER p1b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER p11b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h8b = 1,noab
      DO h9b = h8b,noab
      DO h10b = h9b,noab
      DO p1b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h8b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+p1b-1)+
     &int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1).ne
     &.16)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)
     &+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+h14
     &b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h8b-1),ieor(int_mb(
     &k_sym+h9b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+p1b-1),ie
     &or(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+p6b-
     &1)))))))) .eq. ieor(irrep_y,irrep_t)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h8b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h10b-1) * int_mb(k_range+p1b-1) * int_
     &mb(k_range+h14b-1) * int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_26_5_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p11b = noab+1,noab+nvab
      IF (int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+h14b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),int_mb(k_sym+h14b-1)) .eq. irrep_t) 
     &THEN
      CALL TCE_RESTRICTED_2(p11b,h14b,p11b_1,h14b_1)
      CALL TCE_RESTRICTED_8(h3b,h8b,h9b,h10b,p1b,p5b,p6b,p11b,h3b_2,h8b_
     &2,h9b_2,h10b_2,p1b_2,p5b_2,p6b_2,p11b_2)
      dim_common = int_mb(k_range+p11b-1)
      dima_sort = int_mb(k_range+h14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h8b-1) * int_mb
     &(k_range+h9b-1) * int_mb(k_range+h10b-1) * int_mb(k_range+p1b-1) *
     & int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_26_5_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_26_5_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (p11b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+h14b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_26_5_1',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_26_5_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_26_5_1',5,MA_ERR)
      IF ((h10b .lt. h3b) .and. (p11b .lt. p5b) .and. (p6b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,6,8,3,2,1,4,5,1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p5b .le. p11b) .and. (p11b .lt. p6b) .a
     &nd. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,5,8,3,2,1,4,6,-1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p6b .le. p11b) .and. (p11b .lt. p1b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p1b-1),6,5,8,3,2,1,4,7,1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p6b .lt. p1b) .and. (p1b .le. p11b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p11b-1),6,5,7,3,2,1,4,8,-1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p11b .lt. p5b) .and. (p5b .lt. p1b) .an
     &d. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,6,7,3,2,1,4,5,-1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p5b .le. p11b) .and. (p11b .lt. p1b) .a
     &nd. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,5,7,3,2,1,4,6,1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p5b .lt. p1b) .and. (p1b .le. p11b) .an
     &d. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,5,6,3,2,1,4,7,-1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p5b .lt. p1b) .and. (p1b .le. p6b) .and
     &. (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,5,6,3,2,1,4,8,1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p11b .lt. p1b) .and. (p1b .le. p5b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,6,3,2,1,4,5,1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p1b .le. p11b) .and. (p11b .lt. p5b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,5,3,2,1,4,6,-1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p1b .le. p5b) .and. (p5b .le. p11b) .an
     &d. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,6,5,3,2,1,4,7,1.0d0)
      END IF
      IF ((h10b .lt. h3b) .and. (p1b .le. p5b) .and. (p6b .le. p11b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,6,5,3,2,1,4,8,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p11b .lt. p5b) .an
     &d. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,6,8,4,2,1,3,5,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p5b .le. p11b) .an
     &d. (p11b .lt. p6b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,5,8,4,2,1,3,6,1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p6b .le. p11b) .an
     &d. (p11b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p1b-1),6,5,8,4,2,1,3,7,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p6b .lt. p1b) .and
     &. (p1b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p11b-1),6,5,7,4,2,1,3,8,1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p11b .lt. p5b) .an
     &d. (p5b .lt. p1b) .and. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,6,7,4,2,1,3,5,1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p5b .le. p11b) .an
     &d. (p11b .lt. p1b) .and. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,5,7,4,2,1,3,6,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p5b .lt. p1b) .and
     &. (p1b .le. p11b) .and. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,5,6,4,2,1,3,7,1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p5b .lt. p1b) .and
     &. (p1b .le. p6b) .and. (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,5,6,4,2,1,3,8,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p11b .lt. p1b) .an
     &d. (p1b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,6,4,2,1,3,5,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p1b .le. p11b) .an
     &d. (p11b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,5,4,2,1,3,6,1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p1b .le. p5b) .and
     &. (p5b .le. p11b) .and. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,6,5,4,2,1,3,7,-1.0d0)
      END IF
      IF ((h9b .lt. h3b) .and. (h3b .le. h10b) .and. (p1b .le. p5b) .and
     &. (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h3b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,6,5,4,2,1,3,8,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p11b .lt. p5b) .and
     &. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,6,8,4,3,1,2,5,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p5b .le. p11b) .and
     &. (p11b .lt. p6b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,5,8,4,3,1,2,6,-1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p6b .le. p11b) .and
     &. (p11b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p1b-1),6,5,8,4,3,1,2,7,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p6b .lt. p1b) .and.
     & (p1b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p11b-1),6,5,7,4,3,1,2,8,-1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p11b .lt. p5b) .and
     &. (p5b .lt. p1b) .and. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,6,7,4,3,1,2,5,-1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p5b .le. p11b) .and
     &. (p11b .lt. p1b) .and. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,5,7,4,3,1,2,6,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p5b .lt. p1b) .and.
     & (p1b .le. p11b) .and. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,5,6,4,3,1,2,7,-1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p5b .lt. p1b) .and.
     & (p1b .le. p6b) .and. (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,5,6,4,3,1,2,8,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p11b .lt. p1b) .and
     &. (p1b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,6,4,3,1,2,5,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p1b .le. p11b) .and
     &. (p11b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,5,4,3,1,2,6,-1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p1b .le. p5b) .and.
     & (p5b .le. p11b) .and. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,6,5,4,3,1,2,7,1.0d0)
      END IF
      IF ((h8b .lt. h3b) .and. (h3b .le. h9b) .and. (p1b .le. p5b) .and.
     & (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h8b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,6,5,4,3,1,2,8,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p11b .lt. p5b) .and. (p6b .lt. p1b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,6,8,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p5b .le. p11b) .and. (p11b .lt. p6b) .an
     &d. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p1b-1),7,5,8,4,3,2,1,6,1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p6b .le. p11b) .and. (p11b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p1b-1),6,5,8,4,3,2,1,7,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p6b .lt. p1b) .and. (p1b .le. p11b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p11b-1),6,5,7,4,3,2,1,8,1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p11b .lt. p5b) .and. (p5b .lt. p1b) .and
     &. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,6,7,4,3,2,1,5,1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p5b .le. p11b) .and. (p11b .lt. p1b) .an
     &d. (p1b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p11b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p6b-1),8,5,7,4,3,2,1,6,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p5b .lt. p1b) .and. (p1b .le. p11b) .and
     &. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,5,6,4,3,2,1,7,1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p5b .lt. p1b) .and. (p1b .le. p6b) .and.
     & (p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,5,6,4,3,2,1,8,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p11b .lt. p1b) .and. (p1b .le. p5b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p11b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p1b .le. p11b) .and. (p11b .lt. p5b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p11b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),8,7,5,4,3,2,1,6,1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p1b .le. p5b) .and. (p5b .le. p11b) .and
     &. (p11b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p11b-
     &1),int_mb(k_range+p6b-1),8,6,5,4,3,2,1,7,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (p1b .le. p5b) .and. (p6b .le. p11b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1
     & + nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 -
     & 1 + noab * (h8b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),int_mb(k_range+p11b-1),7,6,5,4,3,2,1,8,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_26_5_1',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_26_5
     &_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_26_5
     &_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_26_5_1',9,MA_ERR)
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h8b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h14b-1),7,6,5,4,3,8,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p6b -
     & noab - 1 + nvab * (p5b - noab - 1 + nvab * (h14b - 1 + noab * (p1
     &b - noab - 1 + nvab * (h10b - 1 + noab * (h9b - 1 + noab * (h8b - 
     &1 + noab * (h3b - 1)))))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_26_5_1',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_26_5
     &_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
      program ga_test
c $Id: pgtestmatmult.F,v 1.2.6.1 2007-04-25 21:49:59 manoj Exp $
c
c     test ga_dgemm
c     compile with make FLD_REN="optimized blas" testmatmult.x
c     Note: - change nummax for large arrays
c           - turn off "verify" for large arrays due to memory 
c             limitations, as verify=TRUE for large arrays produces 
c             segfault, dumps core,or any crap.
c     
c
      implicit none
      integer num_m,num_n,num_k,nummax,howmany,ntrans
      parameter (nummax=1024,howmany=2,ntrans=4)
      integer num1
      parameter(num1=nummax)
      integer i,ii
      real*8 h0(num1*num1)
      integer g_c,g_b,g_a
      real*8 a
      real*8 t1,mf,avg_t(ntrans),avg_mf(ntrans)
      integer itime,ntimes,me
      integer nums_m(howmany),nums_n(howmany),nums_k(howmany)
      character*1 transa(ntrans),transb(ntrans),ta,tb
      real *8 tmpa(nummax,nummax), tmpb(nummax,nummax)
      real *8 tmpc(nummax,nummax)
      logical verify,status
      integer grp_me, nproc, nprocs, proc_group(0:100), proclist(100)
      data transa/'n','t','n','t'/
      data transb/'n','n','t','t'/

      data nums_m/512,1024/
      data nums_n/512,1024/
      data nums_k/512,1024/

      

#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
#include "mp3.fh"
      if (.not.ma_init(MT_DBL,1,20000000)) then
         call ga_error('failed: ma_init(MT_DBL,1,20000000)',10)
      endif
      status = ma_set_auto_verify(.true.)
!      status = ma_set_hard_fail(.true.)
!      status = ma_set_error_print(.true.)
      call ga_initialize()
      me = ga_nodeid()
      nproc = ga_nnodes()
      if(nproc .ne. 8) then
         write(*,*) 'nproc =', nproc
         call ga_error('failed: need exactly 8 processors',10)
      endif
      call ga_sync()
      proclist(1) = 0
      proclist(2) = 1
      proclist(3) = 2
      proclist(4) = 3
      nprocs = 4
      proc_group(0) = ga_pgroup_create(proclist, nprocs)
      proclist(1) = 4
      proclist(2) = 5
      proclist(3) = 6
      proclist(4) = 7
      nprocs = 4
      proc_group(1) = ga_pgroup_create(proclist, nprocs)

      if (me.lt.4) then
         call ga_pgroup_set_default(proc_group(0))
      endif
      if (me.ge.4) then
         call ga_pgroup_set_default(proc_group(1))
      endif
      
      
c     get new proc ids for your default group 
      me = ga_nodeid()
      nproc = ga_nnodes()

      ii = 0
      do i = 1, num1*num1
         ii = ii + 1
         if(ii.gt.num1) then
            ii = 0
         endif
         h0(i) = ii
      enddo
      
c     
c     Compute times assuming 500 mflops and 5 second target time
c     
c     ntimes = max(3.0d0,5.0d0/(4.0d-9*num**3))
      ntimes = 5

      verify = .TRUE.           ! to verify ga_dgemm
c      verify = .FALSE.           ! to verify ga_dgemm

#if 1
      do ii=1,howmany
         num_m = nums_m(ii)
         num_n = nums_n(ii)
         num_k = nums_k(ii)
         a = 0.5d0/(num_m*num_n)
         if(num_m.gt.nummax .OR. num_n.gt.nummax .OR.
     &        num_k.gt.nummax) then
            call ga_error('Insufficient memory: check nummax', 0)
         endif
c     
c     
         if (.not.ga_create(MT_DBL,num_m,num_n,'g_c',
     &        0,0,g_c)) then
            call ga_error('failed: create g_c',20)
         endif
         if (.not.ga_create(MT_DBL,num_k,num_n,'g_b',
     &        0,0,g_b)) then
            call ga_error('failed: create g_b',30)
         endif
         if (.not.ga_create(MT_DBL,num_m,num_k,'g_a',
     &        0,0,g_a)) then
            call ga_error('failed: create g_a',40)
         endif
c     
c     Initialize matrices A and B
c     call load_ga_from_square(g_a,num_m,h0,num1)
c     call load_ga_from_square(g_b,num_m,h0,num1)
c     
         if(me.eq.0) then 
            call load_ga(g_a, h0, num_m, num_k)
            call load_ga(g_b, h0, num_k, num_n)
         endif
         call ga_zero(g_c)
         call ga_sync()

         if (ga_nodeid().eq.0) then
            write(*,*) ! for new line
            write(*,*) 'Matrix Multiplication C = A[', num_m, ',', 
     .           num_k, '] x B[', num_k, ',', num_n, ']'
            write(*,*) ! for new line
            call ffflush(6) 
         endif

         do i = 1, ntrans
            avg_t(i)  = 0.0d0
            avg_mf(i) = 0.0d0
         enddo

         do itime = 1, ntimes
            do i = 1, ntrans
               call ga_sync()
               ta = transa(i)
               tb = transb(i)
               t1 = util_timer()
               call ga_dgemm(ta,tb,num_m,num_n,num_k,
     &              1.0d0, g_a, g_b, 0.0d0, g_c) 
               t1 = util_timer() - t1
               if (me.eq.0) then
                  mf = 2d0*num_m*num_n*num_k/t1*1d-6/ga_nnodes()
                  avg_t(i)  = avg_t(i)+t1
                  avg_mf(i) = avg_mf(i) + mf
                  write(6,200) ' Run#', itime, t1, mf, ta, tb
                  call ffflush(6) 
                  if (verify .AND. itime.eq.1) then
                     call verify_ga_dgemm(ta, tb, num_m, num_n, num_k, 
     &                    1.0d0, g_a, g_b, 0.0d0, g_c,tmpa,tmpb,tmpc)
                  endif
               endif
            enddo
         enddo

         if (ga_nodeid().eq.0) then
            write(*,*)          ! for new line
            do i = 1, ntrans
               write(6,200) 'Average:',0,avg_t(i)/ntimes,
     .              avg_mf(i)/ntimes,transa(i),transb(i)
            enddo
            if(verify) write(*,*) 'All ga_dgemms are verified...O.K.'
            write(*,*)          ! for new line
            call ffflush(6) 
         endif

c
c         call ga_print(g_a)
c         call ga_print(g_b)
c         call ga_print(g_c)
c
         if (.not.ga_destroy(g_c)) then
            call ga_error('failed: destroy g_c',20)
         endif
         if (.not.ga_destroy(g_b)) then
            call ga_error('failed: destroy g_b',30)
         endif
         if (.not.ga_destroy(g_a)) then
            call ga_error('failed: destroy g_a',40)
         endif
      enddo
#endif     

 200  format(a15, i2, ': ', e12.4, ' seconds ',f12.1, 
     .     ' mflops/proc ', 3a2)
      
      call ga_pgroup_set_default(ga_pgroup_get_world())
      call ga_sync() 
      call ga_terminate
      call MP_FINALIZE()
c     
      end
c
c-----------------------------------------------------------------------
c     Verify for correctness. Process 0 computes BLAS dgemm 
c     locally. For larger arrays, disbale this test as memory
c     might not be sufficient
c
      subroutine verify_ga_dgemm(xt1, xt2, num_m, num_n, num_k, 
     $     alpha, g_a, g_b, beta, g_c, tmpa, tmpb, tmpc)
      implicit none
      character *1 xt1, xt2
      integer num_m, num_n, num_k, g_a, g_b, g_c
      double precision alpha, beta
      real *8 tmpa(num_m,num_k), tmpb(num_k,num_n), tmpc(num_m,num_n)

      integer i,j,type,dim1, dim2
      real *8 abs_value
#include "mafdecls.fh"
#include "testutil.fh"
#include "galinalg.fh"

      do i = 1,num_n
         do j = 1, num_m
            tmpc(j,i) = -1.0
            tmpa(j,i) = -2.0
         enddo
      enddo
      
      call ga_inquire(g_a, type, dim1, dim2)
      call ga_get(g_a, 1, dim1, 1, dim2, tmpa, dim1)
      
      call ga_inquire(g_b, type, dim1, dim2)
      call ga_get(g_b, 1, dim1, 1, dim2, tmpb, dim1)

c     compute dgemm sequentially
      call dgemm(xt1, xt2, num_m, num_n, num_k, alpha,
     &     tmpa, num_m, tmpb, num_k, beta, tmpc, num_m)
      
c     after computing c locally, verify it with the values in g_c
      call ga_inquire(g_c, type, dim1, dim2)
      call ga_get(g_c, 1, dim1, 1, dim2, tmpa, dim1)
      
      do i = 1,num_n
         do j = 1, num_m
            abs_value = abs(tmpc(j,i)-tmpa(j,i))
            if(abs_value .gt. 1.0 .OR. abs_value .lt. -1.0) then
               write(*,*) 'Values are = ', tmpc(j,i), tmpa(j,i)
               write(*,*) 'Values are = ', abs(tmpc(j,i)-tmpa(j,i)),
     .              abs_value
               call ffflush(6)
               call ga_error('verify ga_dgemm failed', 0)
            endif
         enddo
      enddo
      
      
      return 
      end
c
c-----------------------------------------------------------------------
c called by process '0' (or your master process )
c
      subroutine load_ga(handle,f, dim1,dim2)
      implicit none
      integer handle
      integer dim1,dim2,i
      real*8 f(dim1,dim2)
#include "mafdecls.fh"
      
      if(dim1.le.0)return
      if(dim2.le.0)return

      call ga_put(handle, 1, dim1, 1, dim2, f, dim1)

      return
      end
c
c-----------------------------------------------------------------------
c     must be called by all processors, if you need to fillup the 
c     entire array
c
      subroutine load_ga_from_square(handle,num,f,ndim)
      implicit none
      integer handle, memhandle
      integer num,ndim
      real*8 f(ndim,ndim)
      integer ilo, ihi, jlo, jhi, nx, ny, ibuff
      integer ga_nodeid, i1, i2, i, j, ix, jx
#include "mafdecls.fh"

      call ga_distribution(handle, ga_nodeid(), ilo, ihi, jlo, jhi)

      if(ihi.le.0)return
      if(jhi.le.0)return

c     nx = ihi - ilo + 1
c     ny = jhi - jlo + 1

      do i = ilo,ihi,ndim
         do j = jlo,jhi,ndim
            call ga_put(handle,i,min(ihi,i+ndim),j,min(jhi,j+ndim),
     &                    f,ndim)
         enddo
      enddo

      return
      end
c
c-----------------------------------------------------------------------
c     must be called by all processors, if you need to fillup the 
c     entire array
c
      subroutine load_ga_from_triangle(handle,f,ndim)
      implicit none
      integer handle, memhandle
      real*8 f(*)
      integer ndim
      integer ilo, ihi, jlo, jhi, nx, ny, ibuff
      integer ga_nodeid, i1, i2, i, j, ix, jx
#include "mafdecls.fh"

      call ga_distribution(handle, ga_nodeid(), ilo, ihi, jlo, jhi)

      if(ihi.le.0)return
      if(jhi.le.0)return

      nx = ihi - ilo + 1
      ny = jhi - jlo + 1

      if (.not.ma_alloc_get(MT_DBL,nx*ny,'flap',memhandle,ibuff)) then
         call ga_error('failed: allocate triangle',100)
      endif

      do i = 1,nx
         do j = 1,ny
            ix = i + ilo - 1
            jx = j + jlo - 1
            i1 = min(ix,jx)
            i2 = max(ix,jx)
            dbl_mb(ibuff + nx*(j-1) + (i-1) ) = f(i2*(i2-1)/2 + i1)
         enddo
      enddo

      call ga_put(handle,ilo,ihi,jlo,jhi,
     &              dbl_mb(ibuff),nx)

      if (.not.ma_free_heap(memhandle)) then
         call ga_error('failed: free triangle',100)
      endif

      return
      end

      subroutine argos_space_getxscr(xscr,xscrs)
c
      implicit none
c
#include "argos_space_common.fh"
c
      real*8 xscr(msm,3),xscrs(msm,3)
c
      integer i,j
c
      do 1 j=1,3
      do 2 i=1,nsm
      xscr(i,j)=xscrs(i,j)
    2 continue
    1 continue
c
      return
      end
c $Id: argos_space_getxscr.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine input_echo(ir,iw)
C$Id: input_echo.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "inp.fh"
      character*256 line
      integer ir, iw
c
      integer lenline
c
      rewind ir
      write(iw,*)
      write(iw,10000)
10000 format(/,/,30('='),' echo of input deck ',30('='))
00001 continue
      read(ir,'(a)',err=00002,end=00002)line
      lenline = inp_strlen(line)
      write(iw,'(a)')line(1:lenline)
      goto 00001
00002 continue
      write(iw,10001)
10001 format(80('='),/,/)
      rewind ir
      call inp_init(ir,iw)
      end

      SUBROUTINE ccsdtq_t4_4_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdtq_t4_4_1.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p9 )_f + = 1 * f ( p5 p9 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p9b
      INTEGER dimc
      INTEGER p5b_1
      INTEGER p9b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p5b = noab+1,noab+nvab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p9b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+p9b-1)) .eq. irrep_f) TH
     &EN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p9b-1)
      CALL TCE_RESTRICTED_2(p5b,p9b,p5b_1,p9b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p9b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_t4_4_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_t4_4_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p9b_1
     & - 1 + (noab+nvab) * (p5b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_t4_4_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_t4_4_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (p5b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_t4_4_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_t4_4_1',5,MA
     &_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

C> \ingroup selci
C> @{
      subroutine selci_orbanal(noconf, ioconf, nintpo, nbitpi, norbs,
     $     map)
      implicit none
*
* $Id: orbanal.F 24790 2013-11-11 18:56:49Z d3y133 $
*
      integer noconf, nintpo, nbitpi, norbs
      integer ioconf(nintpo, noconf)
      integer map(norbs)
c
c     Count the number of times each orbital is referenced in
c     an orbital configuration ... an attempt to partition the
c     reference space into computationally useful weakly and
c     strongly occupied orbital subspaces.
c
      integer iocc(255), npres(255)
      integer iconf, i, j, itmp
c
      call ifill(norbs, 0, npres, 1)
c
      do iconf = 1, noconf
         call selci_upkcon(norbs, iocc, ioconf(1,iconf), nintpo, nbitpi)
         do i = 1, norbs
            if (iocc(i) .eq. 1) then
               npres(i) = npres(i) + 1
            else if (iocc(i) .eq. 3) then
               npres(i) = npres(i) + 2
            endif
         enddo
      enddo
c
      write(6,1) 
      write(6,2) (dble(npres(i))/noconf, i=1,norbs)
 1    format(/' Average occupancy of each orbital ')
 2    format(15f5.2)
c
c     Now sort the orbitals by their occupation
c
      do i = 1, norbs
         map(i) = i
         do j = 1, i-1
            if (npres(map(j)).lt.npres(map(i))) then
              itmp = map(i)
              map(i) = map(j)
              map(j) = itmp
           endif
        enddo
      enddo
c
      write(6,*)
      write(6,*) ' Orbitals sorted by occupation number '
      write(6,3) (map(i),i=1,norbs)
 3    format(19i4)
      write(6,*)
c
      end
      subroutine makeicon4(noconf, ioconf, nintpo, nbitpi, norbs,
     $     map, icon4)
      implicit none
      integer noconf
      integer nintpo
      integer nbitpi
      integer ioconf(nintpo,noconf)
      integer norbs
      integer map(norbs)
      integer icon4(4,noconf)
c
c     In order to expedite figuring which configurations interact
c     compute the occupation of each reference in 4 arbitrary 
c     orbital subspaces.  The map is used so we can play with 
c     the ordering of orbitals.
c
      integer iconf, iocc(255),k
c
      call ifill(4*noconf, 0, icon4, 1)
c
      do iconf = 1, noconf
         call selci_upkcon(norbs, iocc, ioconf(1,iconf), nintpo, nbitpi)
         call doicon4(norbs,iocc,map,icon4(1,iconf))
         write(6,1) iconf,(icon4(k,iconf),k=1,4)
 1       format(1x,i5,5x,4i4)
      enddo
c
      end
      subroutine doicon4(norbs,iocc,map,icon4)
      implicit none
      integer norbs
      integer iocc(norbs)
      integer map(norbs)
      integer icon4(4)
c
      integer ilo, ihi, i, n4, k, itest
c
      n4 = norbs/4
      if (n4.eq.0) n4 = 1
c
      icon4(1)=0
      icon4(2)=0
      icon4(3)=0
      icon4(4)=0
c
      k = 1
      do ilo = 1, norbs, n4
         ihi = min(ilo+n4-1,norbs)
         do i = ilo, ihi
            itest = iocc(map(i))
            if (itest .eq. 1) then
               icon4(k) = icon4(k) + 1
            else if (itest .eq. 3) then
               icon4(k) = icon4(k) + 2
            endif
         enddo
         k = k + 1
      enddo
c
      end
C> @}

      subroutine argos_space_copyg(fw,fs)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
c
      real*8 fw(mwm,3,mwa),fs(msa,3)
c
      integer il,ih,jl,jh
c
      if(nwm.gt.0) then
      call ga_distribution(ga_w,me,il,ih,jl,jh)
      call ga_put(ga_w,il,ih,jl+6*mwa+3,jl+9*mwa+2,fw,mwm)
      endif
      if(nsa.gt.0) then
      call ga_distribution(ga_s,me,il,ih,jl,jh)
      call ga_put(ga_s,il,ih,jl+6,jl+8,fs,msa)
      endif
c
      return
      end
c $Id: argos_space_copyg.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine hnd_giaos100(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     & expj,coefj,j_nprim,j_ngen,Lj,nint,s10,scr,lscr)
c
c $Id: hnd_giaos100.F 21348 2011-10-31 22:51:25Z d3p852 $
c
c     ----- Wrapper routine that sets the sizes of scratch blocks -----
c
      implicit double precision (a-h,o-z)
#include "hnd_pointers.fh"
      dimension scr(lscr)
      dimension xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension s10(nint,3)
c
c Use scratch for temps in integral calculation
c Scratch needs are
c 6*(Li+1)*(Lj+1)
c
c The pointers are defined in hdn_pointers.fh
c
      call hnd_giaos1001(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,expj,
     1 coefj,j_nprim,j_ngen,Lj,nint,s10,scr(gh01(1)),scr(gh01(2)),
     2 scr(gh01(3)),scr(gh01(4)),scr(gh01(5)),scr(gh01(6)))
c
      return
      end
c
      subroutine hnd_giaos1001(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     1                 expj,coefj,j_nprim,j_ngen,Lj,nint,s10,
     2                 xs,ys,zs,xxs,yys,zzs)
c
      implicit double precision (a-h,o-z)
#include "nwc_const.fh"
#include "hnd_tol.fh"
      common/hnd_xyzder/xint,yint,zint,t,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     &                  ni,nj,cx,cy,cz
      dimension Nxyz(3),xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension s10(nint,3)
      dimension  xs(Li+1,Lj+2), ys(Li+1,Lj+2), zs(Li+1,Lj+2)
      dimension xxs(Li+1,Lj+2),yys(Li+1,Lj+2),zzs(Li+1,Lj+2)
      data rln10 /2.30258d+00/
C
      tol=rln10*itol
c
c     Zero integral array
c
      call dcopy(nint*3,0.0d0,0,s10,1)
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi = lit*(lit+1)/2
      litmod=lit+1
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj = ljt*(ljt+1)/2
      ljtmod=ljt+1
c
      tijx=xj
      tijy=yj
      tijz=zj
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
c
c     ----- i primitive -----
c
      do ig=1, i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do jg=1,j_nprim
         aj=expj(jg)
         aa=ai+aj
         aa1=1.0d0/aa
         dum=aj*arri*aa1
         if(dum.gt.tol) goto 1000
         fac= exp(-dum)
         csj=coefj(jg,j_ngen)
         ax=(axi+aj*xj)*aa1
         ay=(ayi+aj*yj)*aa1
         az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
         cij=csi*csj*fac
c
c     ----- x , y , z integrals -----
c
         t = sqrt(aa1)
         x0=ax
         y0=ay
         z0=az
         do i=1,lit
            ni=i
            do j=1,ljtmod
               nj=j
               call hnd_sxyz
               xs(i,j)=xint*t
               ys(i,j)=yint*t 
               zs(i,j)=zint*t 
            enddo
            do j=1,ljtmod
               xxs(i,j)=xs(i,j+1)
               yys(i,j)=ys(i,j+1)
               zzs(i,j)=zs(i,j+1)
            enddo
         enddo
c
         ij=0
         do j=1,maxj
            call getNxyz(Lj,j,Nxyz)
            jx = Nxyz(1) + 1
            jy = Nxyz(2) + 1
            jz = Nxyz(3) + 1
            do i=1,maxi
               call getNxyz(Li,i,Nxyz)
               ix = Nxyz(1) + 1
               iy = Nxyz(2) + 1
               iz = Nxyz(3) + 1
               ij=ij+1
               dum = xs(ix,jx)* ys(iy,jy)* zs(iz,jz)
               dumx=xxs(ix,jx)* ys(iy,jy)* zs(iz,jz)
               dumy= xs(ix,jx)*yys(iy,jy)* zs(iz,jz)
               dumz= xs(ix,jx)* ys(iy,jy)*zzs(iz,jz)
               s10(ij,1)=s10(ij,1)-cij*(tijy*dumz-tijz*dumy)
               s10(ij,2)=s10(ij,2)-cij*(tijz*dumx-tijx*dumz)
               s10(ij,3)=s10(ij,3)-cij*(tijx*dumy-tijy*dumx)
            enddo
         enddo
c
 1000 continue
c
      enddo
      enddo
c
      return
      end

*> \brief \b ZLARTG generates a plane rotation with real cosine and complex sine.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZLARTG + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zlartg.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zlartg.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zlartg.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZLARTG( F, G, CS, SN, R )
* 
*       .. Scalar Arguments ..
*       DOUBLE PRECISION   CS
*       COMPLEX*16         F, G, R, SN
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZLARTG generates a plane rotation so that
*>
*>    [  CS  SN  ]     [ F ]     [ R ]
*>    [  __      ]  .  [   ]  =  [   ]   where CS**2 + |SN|**2 = 1.
*>    [ -SN  CS  ]     [ G ]     [ 0 ]
*>
*> This is a faster version of the BLAS1 routine ZROTG, except for
*> the following differences:
*>    F and G are unchanged on return.
*>    If G=0, then CS=1 and SN=0.
*>    If F=0, then CS=0 and SN is chosen so that R is real.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] F
*> \verbatim
*>          F is COMPLEX*16
*>          The first component of vector to be rotated.
*> \endverbatim
*>
*> \param[in] G
*> \verbatim
*>          G is COMPLEX*16
*>          The second component of vector to be rotated.
*> \endverbatim
*>
*> \param[out] CS
*> \verbatim
*>          CS is DOUBLE PRECISION
*>          The cosine of the rotation.
*> \endverbatim
*>
*> \param[out] SN
*> \verbatim
*>          SN is COMPLEX*16
*>          The sine of the rotation.
*> \endverbatim
*>
*> \param[out] R
*> \verbatim
*>          R is COMPLEX*16
*>          The nonzero component of the rotated vector.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complex16OTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  3-5-96 - Modified with a new algorithm by W. Kahan and J. Demmel
*>
*>  This version has a few statements commented out for thread safety
*>  (machine parameters are computed on each entry). 10 feb 03, SJH.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE ZLARTG( F, G, CS, SN, R )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   CS
      COMPLEX*16         F, G, R, SN
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   TWO, ONE, ZERO
      PARAMETER          ( TWO = 2.0D+0, ONE = 1.0D+0, ZERO = 0.0D+0 )
      COMPLEX*16         CZERO
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
*     LOGICAL            FIRST
      INTEGER            COUNT, I
      DOUBLE PRECISION   D, DI, DR, EPS, F2, F2S, G2, G2S, SAFMIN,
     $                   SAFMN2, SAFMX2, SCALE
      COMPLEX*16         FF, FS, GS
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH, DLAPY2
      EXTERNAL           DLAMCH, DLAPY2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, INT, LOG,
     $                   MAX, SQRT
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1, ABSSQ
*     ..
*     .. Save statement ..
*     SAVE               FIRST, SAFMX2, SAFMIN, SAFMN2
*     ..
*     .. Data statements ..
*     DATA               FIRST / .TRUE. /
*     ..
*     .. Statement Function definitions ..
      ABS1( FF ) = MAX( ABS( DBLE( FF ) ), ABS( DIMAG( FF ) ) )
      ABSSQ( FF ) = DBLE( FF )**2 + DIMAG( FF )**2
*     ..
*     .. Executable Statements ..
*
*     IF( FIRST ) THEN
         SAFMIN = DLAMCH( 'S' )
         EPS = DLAMCH( 'E' )
         SAFMN2 = DLAMCH( 'B' )**INT( LOG( SAFMIN / EPS ) /
     $            LOG( DLAMCH( 'B' ) ) / TWO )
         SAFMX2 = ONE / SAFMN2
*        FIRST = .FALSE.
*     END IF
      SCALE = MAX( ABS1( F ), ABS1( G ) )
      FS = F
      GS = G
      COUNT = 0
      IF( SCALE.GE.SAFMX2 ) THEN
   10    CONTINUE
         COUNT = COUNT + 1
         FS = FS*SAFMN2
         GS = GS*SAFMN2
         SCALE = SCALE*SAFMN2
         IF( SCALE.GE.SAFMX2 )
     $      GO TO 10
      ELSE IF( SCALE.LE.SAFMN2 ) THEN
         IF( G.EQ.CZERO ) THEN
            CS = ONE
            SN = CZERO
            R = F
            RETURN
         END IF
   20    CONTINUE
         COUNT = COUNT - 1
         FS = FS*SAFMX2
         GS = GS*SAFMX2
         SCALE = SCALE*SAFMX2
         IF( SCALE.LE.SAFMN2 )
     $      GO TO 20
      END IF
      F2 = ABSSQ( FS )
      G2 = ABSSQ( GS )
      IF( F2.LE.MAX( G2, ONE )*SAFMIN ) THEN
*
*        This is a rare case: F is very small.
*
         IF( F.EQ.CZERO ) THEN
            CS = ZERO
            R = DLAPY2( DBLE( G ), DIMAG( G ) )
*           Do complex/real division explicitly with two real divisions
            D = DLAPY2( DBLE( GS ), DIMAG( GS ) )
            SN = DCMPLX( DBLE( GS ) / D, -DIMAG( GS ) / D )
            RETURN
         END IF
         F2S = DLAPY2( DBLE( FS ), DIMAG( FS ) )
*        G2 and G2S are accurate
*        G2 is at least SAFMIN, and G2S is at least SAFMN2
         G2S = SQRT( G2 )
*        Error in CS from underflow in F2S is at most
*        UNFL / SAFMN2 .lt. sqrt(UNFL*EPS) .lt. EPS
*        If MAX(G2,ONE)=G2, then F2 .lt. G2*SAFMIN,
*        and so CS .lt. sqrt(SAFMIN)
*        If MAX(G2,ONE)=ONE, then F2 .lt. SAFMIN
*        and so CS .lt. sqrt(SAFMIN)/SAFMN2 = sqrt(EPS)
*        Therefore, CS = F2S/G2S / sqrt( 1 + (F2S/G2S)**2 ) = F2S/G2S
         CS = F2S / G2S
*        Make sure abs(FF) = 1
*        Do complex/real division explicitly with 2 real divisions
         IF( ABS1( F ).GT.ONE ) THEN
            D = DLAPY2( DBLE( F ), DIMAG( F ) )
            FF = DCMPLX( DBLE( F ) / D, DIMAG( F ) / D )
         ELSE
            DR = SAFMX2*DBLE( F )
            DI = SAFMX2*DIMAG( F )
            D = DLAPY2( DR, DI )
            FF = DCMPLX( DR / D, DI / D )
         END IF
         SN = FF*DCMPLX( DBLE( GS ) / G2S, -DIMAG( GS ) / G2S )
         R = CS*F + SN*G
      ELSE
*
*        This is the most common case.
*        Neither F2 nor F2/G2 are less than SAFMIN
*        F2S cannot overflow, and it is accurate
*
         F2S = SQRT( ONE+G2 / F2 )
*        Do the F2S(real)*FS(complex) multiply with two real multiplies
         R = DCMPLX( F2S*DBLE( FS ), F2S*DIMAG( FS ) )
         CS = ONE / F2S
         D = F2 + G2
*        Do complex/real division explicitly with two real divisions
         SN = DCMPLX( DBLE( R ) / D, DIMAG( R ) / D )
         SN = SN*DCONJG( GS )
         IF( COUNT.NE.0 ) THEN
            IF( COUNT.GT.0 ) THEN
               DO 30 I = 1, COUNT
                  R = R*SAFMX2
   30          CONTINUE
            ELSE
               DO 40 I = 1, -COUNT
                  R = R*SAFMN2
   40          CONTINUE
            END IF
         END IF
      END IF
      RETURN
*
*     End of ZLARTG
*
      END
c $Id: zlartg.f 24343 2013-06-22 05:35:15Z d3y133 $

*
* $Id: slamch.f 19708 2010-10-29 18:04:21Z d3y133 $
*
      REAL             FUNCTION SLAMCH( CMACH )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992 
*
*     .. Scalar Arguments ..
      CHARACTER          CMACH
*     ..
*
*  Purpose
*  =======
*
*  SLAMCH determines single precision machine parameters.
*
*  Arguments
*  =========
*
*  CMACH   (input) CHARACTER*1
*          Specifies the value to be returned by SLAMCH:
*          = 'E' or 'e',   SLAMCH := eps
*          = 'S' or 's ,   SLAMCH := sfmin
*          = 'B' or 'b',   SLAMCH := base
*          = 'P' or 'p',   SLAMCH := eps*base
*          = 'N' or 'n',   SLAMCH := t
*          = 'R' or 'r',   SLAMCH := rnd
*          = 'M' or 'm',   SLAMCH := emin
*          = 'U' or 'u',   SLAMCH := rmin
*          = 'L' or 'l',   SLAMCH := emax
*          = 'O' or 'o',   SLAMCH := rmax
*
*          where
*
*          eps   = relative machine precision
*          sfmin = safe minimum, such that 1/sfmin does not overflow
*          base  = base of the machine
*          prec  = eps*base
*          t     = number of (base) digits in the mantissa
*          rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
*          emin  = minimum exponent before (gradual) underflow
*          rmin  = underflow threshold - base**(emin-1)
*          emax  = largest exponent before overflow
*          rmax  = overflow threshold  - (base**emax)*(1-eps)
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            FIRST, LRND
      INTEGER            BETA, IMAX, IMIN, IT
      REAL               BASE, EMAX, EMIN, EPS, PREC, RMACH, RMAX, RMIN,
     $                   RND, SFMIN, SMALL, T
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLAMC2
*     ..
*     .. Save statement ..
      SAVE               FIRST, EPS, SFMIN, BASE, T, RND, EMIN, RMIN,
     $                   EMAX, RMAX, PREC
*     ..
*     .. Data statements ..
      DATA               FIRST / .TRUE. /
*     ..
*     .. Executable Statements ..
*
      IF( FIRST ) THEN
         FIRST = .FALSE.
         CALL SLAMC2( BETA, IT, LRND, EPS, IMIN, RMIN, IMAX, RMAX )
         BASE = BETA
         T = IT
         IF( LRND ) THEN
            RND = ONE
            EPS = ( BASE**( 1-IT ) ) / 2
         ELSE
            RND = ZERO
            EPS = BASE**( 1-IT )
         END IF
         PREC = EPS*BASE
         EMIN = IMIN
         EMAX = IMAX
         SFMIN = RMIN
         SMALL = ONE / RMAX
         IF( SMALL.GE.SFMIN ) THEN
*
*           Use SMALL plus a bit, to avoid the possibility of rounding
*           causing overflow when computing  1/sfmin.
*
            SFMIN = SMALL*( ONE+EPS )
         END IF
      END IF
*
      IF( LSAME( CMACH, 'E' ) ) THEN
         RMACH = EPS
      ELSE IF( LSAME( CMACH, 'S' ) ) THEN
         RMACH = SFMIN
      ELSE IF( LSAME( CMACH, 'B' ) ) THEN
         RMACH = BASE
      ELSE IF( LSAME( CMACH, 'P' ) ) THEN
         RMACH = PREC
      ELSE IF( LSAME( CMACH, 'N' ) ) THEN
         RMACH = T
      ELSE IF( LSAME( CMACH, 'R' ) ) THEN
         RMACH = RND
      ELSE IF( LSAME( CMACH, 'M' ) ) THEN
         RMACH = EMIN
      ELSE IF( LSAME( CMACH, 'U' ) ) THEN
         RMACH = RMIN
      ELSE IF( LSAME( CMACH, 'L' ) ) THEN
         RMACH = EMAX
      ELSE IF( LSAME( CMACH, 'O' ) ) THEN
         RMACH = RMAX
      END IF
*
      SLAMCH = RMACH
      RETURN
*
*     End of SLAMCH
*
      END
*
************************************************************************
*
      SUBROUTINE SLAMC1( BETA, T, RND, IEEE1 )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      LOGICAL            IEEE1, RND
      INTEGER            BETA, T
*     ..
*
*  Purpose
*  =======
*
*  SLAMC1 determines the machine parameters given by BETA, T, RND, and
*  IEEE1.
*
*  Arguments
*  =========
*
*  BETA    (output) INTEGER
*          The base of the machine.
*
*  T       (output) INTEGER
*          The number of ( BETA ) digits in the mantissa.
*
*  RND     (output) LOGICAL
*          Specifies whether proper rounding  ( RND = .TRUE. )  or
*          chopping  ( RND = .FALSE. )  occurs in addition. This may not
*          be a reliable guide to the way in which the machine performs
*          its arithmetic.
*
*  IEEE1   (output) LOGICAL
*          Specifies whether rounding appears to be done in the IEEE
*          'round to nearest' style.
*
*  Further Details
*  ===============
*
*  The routine is based on the routine  ENVRON  by Malcolm and
*  incorporates suggestions by Gentleman and Marovich. See
*
*     Malcolm M. A. (1972) Algorithms to reveal properties of
*        floating-point arithmetic. Comms. of the ACM, 15, 949-951.
*
*     Gentleman W. M. and Marovich S. B. (1974) More on algorithms
*        that reveal properties of floating point arithmetic units.
*        Comms. of the ACM, 17, 276-277.
*
* =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            FIRST, LIEEE1, LRND
      INTEGER            LBETA, LT
      REAL               A, B, C, F, ONE, QTR, SAVEC, T1, T2
*     ..
*     .. External Functions ..
      REAL               SLAMC3
      EXTERNAL           SLAMC3
*     ..
*     .. Save statement ..
      SAVE               FIRST, LIEEE1, LBETA, LRND, LT
*     ..
*     .. Data statements ..
      DATA               FIRST / .TRUE. /
*     ..
*     .. Executable Statements ..
*
      IF( FIRST ) THEN
         FIRST = .FALSE.
         ONE = 1
*
*        LBETA,  LIEEE1,  LT and  LRND  are the  local values  of  BETA,
*        IEEE1, T and RND.
*
*        Throughout this routine  we use the function  SLAMC3  to ensure
*        that relevant values are  stored and not held in registers,  or
*        are not affected by optimizers.
*
*        Compute  a = 2.0**m  with the  smallest positive integer m such
*        that
*
*           fl( a + 1.0 ) = a.
*
         A = 1
         C = 1
*
*+       WHILE( C.EQ.ONE )LOOP
   10    CONTINUE
         IF( C.EQ.ONE ) THEN
            A = 2*A
            C = SLAMC3( A, ONE )
            C = SLAMC3( C, -A )
            GO TO 10
         END IF
*+       END WHILE
*
*        Now compute  b = 2.0**m  with the smallest positive integer m
*        such that
*
*           fl( a + b ) .gt. a.
*
         B = 1
         C = SLAMC3( A, B )
*
*+       WHILE( C.EQ.A )LOOP
   20    CONTINUE
         IF( C.EQ.A ) THEN
            B = 2*B
            C = SLAMC3( A, B )
            GO TO 20
         END IF
*+       END WHILE
*
*        Now compute the base.  a and c  are neighbouring floating point
*        numbers  in the  interval  ( beta**t, beta**( t + 1 ) )  and so
*        their difference is beta. Adding 0.25 to c is to ensure that it
*        is truncated to beta and not ( beta - 1 ).
*
         QTR = ONE / 4
         SAVEC = C
         C = SLAMC3( C, -A )
         LBETA = C + QTR
*
*        Now determine whether rounding or chopping occurs,  by adding a
*        bit  less  than  beta/2  and a  bit  more  than  beta/2  to  a.
*
         B = LBETA
         F = SLAMC3( B / 2, -B / 100 )
         C = SLAMC3( F, A )
         IF( C.EQ.A ) THEN
            LRND = .TRUE.
         ELSE
            LRND = .FALSE.
         END IF
         F = SLAMC3( B / 2, B / 100 )
         C = SLAMC3( F, A )
         IF( ( LRND ) .AND. ( C.EQ.A ) )
     $      LRND = .FALSE.
*
*        Try and decide whether rounding is done in the  IEEE  'round to
*        nearest' style. B/2 is half a unit in the last place of the two
*        numbers A and SAVEC. Furthermore, A is even, i.e. has last  bit
*        zero, and SAVEC is odd. Thus adding B/2 to A should not  change
*        A, but adding B/2 to SAVEC should change SAVEC.
*
         T1 = SLAMC3( B / 2, A )
         T2 = SLAMC3( B / 2, SAVEC )
         LIEEE1 = ( T1.EQ.A ) .AND. ( T2.GT.SAVEC ) .AND. LRND
*
*        Now find  the  mantissa, t.  It should  be the  integer part of
*        log to the base beta of a,  however it is safer to determine  t
*        by powering.  So we find t as the smallest positive integer for
*        which
*
*           fl( beta**t + 1.0 ) = 1.0.
*
         LT = 0
         A = 1
         C = 1
*
*+       WHILE( C.EQ.ONE )LOOP
   30    CONTINUE
         IF( C.EQ.ONE ) THEN
            LT = LT + 1
            A = A*LBETA
            C = SLAMC3( A, ONE )
            C = SLAMC3( C, -A )
            GO TO 30
         END IF
*+       END WHILE
*
      END IF
*
      BETA = LBETA
      T = LT
      RND = LRND
      IEEE1 = LIEEE1
      RETURN
*
*     End of SLAMC1
*
      END
*
************************************************************************
*
      SUBROUTINE SLAMC2( BETA, T, RND, EPS, EMIN, RMIN, EMAX, RMAX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      LOGICAL            RND
      INTEGER            BETA, EMAX, EMIN, T
      REAL               EPS, RMAX, RMIN
*     ..
*
*  Purpose
*  =======
*
*  SLAMC2 determines the machine parameters specified in its argument
*  list.
*
*  Arguments
*  =========
*
*  BETA    (output) INTEGER
*          The base of the machine.
*
*  T       (output) INTEGER
*          The number of ( BETA ) digits in the mantissa.
*
*  RND     (output) LOGICAL
*          Specifies whether proper rounding  ( RND = .TRUE. )  or
*          chopping  ( RND = .FALSE. )  occurs in addition. This may not
*          be a reliable guide to the way in which the machine performs
*          its arithmetic.
*
*  EPS     (output) REAL
*          The smallest positive number such that
*
*             fl( 1.0 - EPS ) .LT. 1.0,
*
*          where fl denotes the computed value.
*
*  EMIN    (output) INTEGER
*          The minimum exponent before (gradual) underflow occurs.
*
*  RMIN    (output) REAL
*          The smallest normalized number for the machine, given by
*          BASE**( EMIN - 1 ), where  BASE  is the floating point value
*          of BETA.
*
*  EMAX    (output) INTEGER
*          The maximum exponent before overflow occurs.
*
*  RMAX    (output) REAL
*          The largest positive number for the machine, given by
*          BASE**EMAX * ( 1 - EPS ), where  BASE  is the floating point
*          value of BETA.
*
*  Further Details
*  ===============
*
*  The computation of  EPS  is based on a routine PARANOIA by
*  W. Kahan of the University of California at Berkeley.
*
* =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            FIRST, IEEE, IWARN, LIEEE1, LRND
      INTEGER            GNMIN, GPMIN, I, LBETA, LEMAX, LEMIN, LT,
     $                   NGNMIN, NGPMIN
      REAL               A, B, C, HALF, LEPS, LRMAX, LRMIN, ONE, RBASE,
     $                   SIXTH, SMALL, THIRD, TWO, ZERO
*     ..
*     .. External Functions ..
      REAL               SLAMC3
      EXTERNAL           SLAMC3
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLAMC1, SLAMC4, SLAMC5
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Save statement ..
      SAVE               FIRST, IWARN, LBETA, LEMAX, LEMIN, LEPS, LRMAX,
     $                   LRMIN, LT
*     ..
*     .. Data statements ..
      DATA               FIRST / .TRUE. / , IWARN / .FALSE. /
*     ..
*     .. Executable Statements ..
*
      IF( FIRST ) THEN
         FIRST = .FALSE.
         ZERO = 0
         ONE = 1
         TWO = 2
*
*        LBETA, LT, LRND, LEPS, LEMIN and LRMIN  are the local values of
*        BETA, T, RND, EPS, EMIN and RMIN.
*
*        Throughout this routine  we use the function  SLAMC3  to ensure
*        that relevant values are stored  and not held in registers,  or
*        are not affected by optimizers.
*
*        SLAMC1 returns the parameters  LBETA, LT, LRND and LIEEE1.
*
         CALL SLAMC1( LBETA, LT, LRND, LIEEE1 )
*
*        Start to find EPS.
*
         B = LBETA
         A = B**( -LT )
         LEPS = A
*
*        Try some tricks to see whether or not this is the correct  EPS.
*
         B = TWO / 3
         HALF = ONE / 2
         SIXTH = SLAMC3( B, -HALF )
         THIRD = SLAMC3( SIXTH, SIXTH )
         B = SLAMC3( THIRD, -HALF )
         B = SLAMC3( B, SIXTH )
         B = ABS( B )
         IF( B.LT.LEPS )
     $      B = LEPS
*
         LEPS = 1
*
*+       WHILE( ( LEPS.GT.B ).AND.( B.GT.ZERO ) )LOOP
   10    CONTINUE
         IF( ( LEPS.GT.B ) .AND. ( B.GT.ZERO ) ) THEN
            LEPS = B
            C = SLAMC3( HALF*LEPS, ( TWO**5 )*( LEPS**2 ) )
            C = SLAMC3( HALF, -C )
            B = SLAMC3( HALF, C )
            C = SLAMC3( HALF, -B )
            B = SLAMC3( HALF, C )
            GO TO 10
         END IF
*+       END WHILE
*
         IF( A.LT.LEPS )
     $      LEPS = A
*
*        Computation of EPS complete.
*
*        Now find  EMIN.  Let A = + or - 1, and + or - (1 + BASE**(-3)).
*        Keep dividing  A by BETA until (gradual) underflow occurs. This
*        is detected when we cannot recover the previous A.
*
         RBASE = ONE / LBETA
         SMALL = ONE
         DO 20 I = 1, 3
            SMALL = SLAMC3( SMALL*RBASE, ZERO )
   20    CONTINUE
         A = SLAMC3( ONE, SMALL )
         CALL SLAMC4( NGPMIN, ONE, LBETA )
         CALL SLAMC4( NGNMIN, -ONE, LBETA )
         CALL SLAMC4( GPMIN, A, LBETA )
         CALL SLAMC4( GNMIN, -A, LBETA )
         IEEE = .FALSE.
*
         IF( ( NGPMIN.EQ.NGNMIN ) .AND. ( GPMIN.EQ.GNMIN ) ) THEN
            IF( NGPMIN.EQ.GPMIN ) THEN
               LEMIN = NGPMIN
*            ( Non twos-complement machines, no gradual underflow;
*              e.g.,  VAX )
            ELSE IF( ( GPMIN-NGPMIN ).EQ.3 ) THEN
               LEMIN = NGPMIN - 1 + LT
               IEEE = .TRUE.
*            ( Non twos-complement machines, with gradual underflow;
*              e.g., IEEE standard followers )
            ELSE
               LEMIN = MIN( NGPMIN, GPMIN )
*            ( A guess; no known machine )
               IWARN = .TRUE.
            END IF
*
         ELSE IF( ( NGPMIN.EQ.GPMIN ) .AND. ( NGNMIN.EQ.GNMIN ) ) THEN
            IF( ABS( NGPMIN-NGNMIN ).EQ.1 ) THEN
               LEMIN = MAX( NGPMIN, NGNMIN )
*            ( Twos-complement machines, no gradual underflow;
*              e.g., CYBER 205 )
            ELSE
               LEMIN = MIN( NGPMIN, NGNMIN )
*            ( A guess; no known machine )
               IWARN = .TRUE.
            END IF
*
         ELSE IF( ( ABS( NGPMIN-NGNMIN ).EQ.1 ) .AND.
     $            ( GPMIN.EQ.GNMIN ) ) THEN
            IF( ( GPMIN-MIN( NGPMIN, NGNMIN ) ).EQ.3 ) THEN
               LEMIN = MAX( NGPMIN, NGNMIN ) - 1 + LT
*            ( Twos-complement machines with gradual underflow;
*              no known machine )
            ELSE
               LEMIN = MIN( NGPMIN, NGNMIN )
*            ( A guess; no known machine )
               IWARN = .TRUE.
            END IF
*
         ELSE
            LEMIN = MIN( NGPMIN, NGNMIN, GPMIN, GNMIN )
*         ( A guess; no known machine )
            IWARN = .TRUE.
         END IF
***
* Comment out this if block if EMIN is ok
         IF( IWARN ) THEN
            FIRST = .TRUE.
            WRITE( 6, FMT = 9999 )LEMIN
         END IF
***
*
*        Assume IEEE arithmetic if we found denormalised  numbers above,
*        or if arithmetic seems to round in the  IEEE style,  determined
*        in routine SLAMC1. A true IEEE machine should have both  things
*        true; however, faulty machines may have one or the other.
*
         IEEE = IEEE .OR. LIEEE1
*
*        Compute  RMIN by successive division by  BETA. We could compute
*        RMIN as BASE**( EMIN - 1 ),  but some machines underflow during
*        this computation.
*
         LRMIN = 1
         DO 30 I = 1, 1 - LEMIN
            LRMIN = SLAMC3( LRMIN*RBASE, ZERO )
   30    CONTINUE
*
*        Finally, call SLAMC5 to compute EMAX and RMAX.
*
         CALL SLAMC5( LBETA, LT, LEMIN, IEEE, LEMAX, LRMAX )
      END IF
*
      BETA = LBETA
      T = LT
      RND = LRND
      EPS = LEPS
      EMIN = LEMIN
      RMIN = LRMIN
      EMAX = LEMAX
      RMAX = LRMAX
*
      RETURN
*
 9999 FORMAT( / / ' WARNING. The value EMIN may be incorrect:-',
     $      '  EMIN = ', I8, /
     $      ' If, after inspection, the value EMIN looks',
     $      ' acceptable please comment out ',
     $      / ' the IF block as marked within the code of routine',
     $      ' SLAMC2,', / ' otherwise supply EMIN explicitly.', / )
*
*     End of SLAMC2
*
      END
*
************************************************************************
*
      REAL             FUNCTION SLAMC3( A, B )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      REAL               A, B
*     ..
*
*  Purpose
*  =======
*
*  SLAMC3  is intended to force  A  and  B  to be stored prior to doing
*  the addition of  A  and  B ,  for use in situations where optimizers
*  might hold one of these in a register.
*
*  Arguments
*  =========
*
*  A, B    (input) REAL
*          The values A and B.
*
* =====================================================================
*
*     .. Executable Statements ..
*
      SLAMC3 = A + B
*
      RETURN
*
*     End of SLAMC3
*
      END
*
************************************************************************
*
      SUBROUTINE SLAMC4( EMIN, START, BASE )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            BASE, EMIN
      REAL               START
*     ..
*
*  Purpose
*  =======
*
*  SLAMC4 is a service routine for SLAMC2.
*
*  Arguments
*  =========
*
*  EMIN    (output) EMIN
*          The minimum exponent before (gradual) underflow, computed by
*          setting A = START and dividing by BASE until the previous A
*          can not be recovered.
*
*  START   (input) REAL
*          The starting point for determining EMIN.
*
*  BASE    (input) INTEGER
*          The base of the machine.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I
      REAL               A, B1, B2, C1, C2, D1, D2, ONE, RBASE, ZERO
*     ..
*     .. External Functions ..
      REAL               SLAMC3
      EXTERNAL           SLAMC3
*     ..
*     .. Executable Statements ..
*
      A = START
      ONE = 1
      RBASE = ONE / BASE
      ZERO = 0
      EMIN = 1
      B1 = SLAMC3( A*RBASE, ZERO )
      C1 = A
      C2 = A
      D1 = A
      D2 = A
*+    WHILE( ( C1.EQ.A ).AND.( C2.EQ.A ).AND.
*    $       ( D1.EQ.A ).AND.( D2.EQ.A )      )LOOP
   10 CONTINUE
      IF( ( C1.EQ.A ) .AND. ( C2.EQ.A ) .AND. ( D1.EQ.A ) .AND.
     $    ( D2.EQ.A ) ) THEN
         EMIN = EMIN - 1
         A = B1
         B1 = SLAMC3( A / BASE, ZERO )
         C1 = SLAMC3( B1*BASE, ZERO )
         D1 = ZERO
         DO 20 I = 1, BASE
            D1 = D1 + B1
   20    CONTINUE
         B2 = SLAMC3( A*RBASE, ZERO )
         C2 = SLAMC3( B2 / RBASE, ZERO )
         D2 = ZERO
         DO 30 I = 1, BASE
            D2 = D2 + B2
   30    CONTINUE
         GO TO 10
      END IF
*+    END WHILE
*
      RETURN
*
*     End of SLAMC4
*
      END
*
************************************************************************
*
      SUBROUTINE SLAMC5( BETA, P, EMIN, IEEE, EMAX, RMAX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      LOGICAL            IEEE
      INTEGER            BETA, EMAX, EMIN, P
      REAL               RMAX
*     ..
*
*  Purpose
*  =======
*
*  SLAMC5 attempts to compute RMAX, the largest machine floating-point
*  number, without overflow.  It assumes that EMAX + abs(EMIN) sum
*  approximately to a power of 2.  It will fail on machines where this
*  assumption does not hold, for example, the Cyber 205 (EMIN = -28625,
*  EMAX = 28718).  It will also fail if the value supplied for EMIN is
*  too large (i.e. too close to zero), probably with overflow.
*
*  Arguments
*  =========
*
*  BETA    (input) INTEGER
*          The base of floating-point arithmetic.
*
*  P       (input) INTEGER
*          The number of base BETA digits in the mantissa of a
*          floating-point value.
*
*  EMIN    (input) INTEGER
*          The minimum exponent before (gradual) underflow.
*
*  IEEE    (input) LOGICAL
*          A logical flag specifying whether or not the arithmetic
*          system is thought to comply with the IEEE standard.
*
*  EMAX    (output) INTEGER
*          The largest exponent before overflow
*
*  RMAX    (output) REAL
*          The largest machine floating-point number.
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E0, ONE = 1.0E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            EXBITS, EXPSUM, I, LEXP, NBITS, TRY, UEXP
      REAL               OLDY, RECBAS, Y, Z
*     ..
*     .. External Functions ..
      REAL               SLAMC3
      EXTERNAL           SLAMC3
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MOD
*     ..
*     .. Executable Statements ..
*
*     First compute LEXP and UEXP, two powers of 2 that bound
*     abs(EMIN). We then assume that EMAX + abs(EMIN) will sum
*     approximately to the bound that is closest to abs(EMIN).
*     (EMAX is the exponent of the required number RMAX).
*
      LEXP = 1
      EXBITS = 1
   10 CONTINUE
      TRY = LEXP*2
      IF( TRY.LE.( -EMIN ) ) THEN
         LEXP = TRY
         EXBITS = EXBITS + 1
         GO TO 10
      END IF
      IF( LEXP.EQ.-EMIN ) THEN
         UEXP = LEXP
      ELSE
         UEXP = TRY
         EXBITS = EXBITS + 1
      END IF
*
*     Now -LEXP is less than or equal to EMIN, and -UEXP is greater
*     than or equal to EMIN. EXBITS is the number of bits needed to
*     store the exponent.
*
      IF( ( UEXP+EMIN ).GT.( -LEXP-EMIN ) ) THEN
         EXPSUM = 2*LEXP
      ELSE
         EXPSUM = 2*UEXP
      END IF
*
*     EXPSUM is the exponent range, approximately equal to
*     EMAX - EMIN + 1 .
*
      EMAX = EXPSUM + EMIN - 1
      NBITS = 1 + EXBITS + P
*
*     NBITS is the total number of bits needed to store a
*     floating-point number.
*
      IF( ( MOD( NBITS, 2 ).EQ.1 ) .AND. ( BETA.EQ.2 ) ) THEN
*
*        Either there are an odd number of bits used to store a
*        floating-point number, which is unlikely, or some bits are
*        not used in the representation of numbers, which is possible,
*        (e.g. Cray machines) or the mantissa has an implicit bit,
*        (e.g. IEEE machines, Dec Vax machines), which is perhaps the
*        most likely. We have to assume the last alternative.
*        If this is true, then we need to reduce EMAX by one because
*        there must be some way of representing zero in an implicit-bit
*        system. On machines like Cray, we are reducing EMAX by one
*        unnecessarily.
*
         EMAX = EMAX - 1
      END IF
*
      IF( IEEE ) THEN
*
*        Assume we are on an IEEE machine which reserves one exponent
*        for infinity and NaN.
*
         EMAX = EMAX - 1
      END IF
*
*     Now create RMAX, the largest machine number, which should
*     be equal to (1.0 - BETA**(-P)) * BETA**EMAX .
*
*     First compute 1.0 - BETA**(-P), being careful that the
*     result is less than 1.0 .
*
      RECBAS = ONE / BETA
      Z = BETA - ONE
      Y = ZERO
      DO 20 I = 1, P
         Z = Z*RECBAS
         IF( Y.LT.ONE )
     $      OLDY = Y
         Y = SLAMC3( Y, Z )
   20 CONTINUE
      IF( Y.GE.ONE )
     $   Y = OLDY
*
*     Now multiply by BETA**EMAX to get RMAX.
*
      DO 30 I = 1, EMAX
         Y = SLAMC3( Y*BETA, ZERO )
   30 CONTINUE
*
      RMAX = Y
      RETURN
*
*     End of SLAMC5
*
      END

c $Id: int_chk_sum.F 19696 2010-10-29 16:53:42Z d3y133 $
*
*rak:      subroutine int_chk_sum(rtdb,basisin,print_ints)
*rak:      implicit none
*rak:#include "mafdecls.fh"
*rak:#include "errquit.fh"
*rak:#include "global.fh"
*rak:#include "bas.fh"
*rak:#include "msgids.fh"
*rak:#include "rtdb.fh"
*rak:#include "context.fh"
*rak:c::passed
*rak:      integer rtdb       ! [input] rtdb handle
*rak:      integer basisin    ! [input] basis set handle 
*rak:      logical print_ints ! [input] also print integral and label values 
*rak:c::local
*rak:      logical debug
*rak:      logical MAstatus
*rak:      integer max1bf, maxg, mscr1, mscr2, mscrh1, maxh1
*rak:c
*rak:      integer i,j,k,l, numleft, numtot, lend
*rak:      integer memb      ! memory buffer for integrals (1es and eri)
*rak:      integer mems      ! scratch space needed for integrals
*rak:      integer hmemb, hmems ! memory handles
*rak:      integer imemb, imems ! memory indexes
*rak:c
*rak:      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for labels buffers
*rak:      integer i_klab, h_klab, i_llab, h_llab   ! handles and index for labels buffers
*rak:c
*rak:      integer h_stats, i_stats
*rak:c
*rak:      logical print69
*rak:      logical dumm69
*rak:c
*rak:      integer ncont
*rak:      integer plevel
*rak:c
*rak:      integer me, nproc, idoit
*rak:c      
*rak:      data debug /.false./
*rak:      data plevel /0/
*rak:c 
*rak:c
*rak:c if debugging then up print level
*rak:c
*rak:      if (debug) plevel = 1
*rak:c
*rak:c get number of contractions (shells) ncont
*rak:c
*rak:      if (.not.bas_numcont(basisin,ncont))
*rak:     &    call errquit('int_chk_sum: numcont not obtained',ncont)
*rak:c
*rak:      call int_mem(max1bf,maxg,mscr1,mscr2)
*rak:      memb = max(max1bf,maxg)
*rak:      mems = max(mscr1,mscr2)
*rak:      call int_mem_h1(maxh1, mscrh1)
*rak:      memb = max(memb,maxh1)
*rak:      mems = max(mems,mscrh1)
*rak:      call int_mem_2e3c(maxg,mscr2)
*rak:      memb = max(memb,maxg)
*rak:      mems = max(mems,mscr2)
*rak:      call int_mem_2e2c(maxg,mscr2)
*rak:      memb = max(memb,maxg)
*rak:      mems = max(mems,mscr2)
*rak:c
*rak:c...  pray that ma has been initialized still need verification flag for
*rak:c...       consistency.
*rak:c
*rak:c
*rak:c.... eri/1e buffer
*rak:      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
*rak:     &    call errquit('int_chk_sum: allocation memb failed',memb)
*rak:c.... scratch for integrals
*rak:      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
*rak:     &    call errquit('int_chk_sum: allocation mems failed',mems)
*rak:c...  label buffers
*rak:      if (.not.MA_Push_Get(MT_Int,memb,'i label buffer',h_ilab,i_ilab))
*rak:     &    call errquit('int_chk_sum: allocation ilab failed',memb)
*rak:      if (.not.MA_Push_Get(MT_Int,memb,'j label buffer',h_jlab,i_jlab))
*rak:     &    call errquit('int_chk_sum: allocation jlab failed',memb)
*rak:      if (.not.MA_Push_Get(MT_Int,memb,'k label buffer',h_klab,i_klab))
*rak:     &    call errquit('int_chk_sum: allocation klab failed',memb)
*rak:      if (.not.MA_Push_Get(MT_Int,memb,'l label buffer',h_llab,i_llab))
*rak:     &    call errquit('int_chk_sum: allocation llab failed',memb)
*rak:c...  summary stats 1e and 2e.  i.e., allocate bigger
*rak:      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
*rak:     &    h_stats,i_stats))
*rak:     &    call errquit('int_chk_sum: allocation mems failed',(5*3))
*rak:c
*rak:c zero memory 
*rak:      call ifill(memb,0,    int_mb(i_ilab) ,1)
*rak:      call ifill(memb,0,    int_mb(i_jlab) ,1)
*rak:      call ifill(memb,0,    int_mb(i_klab) ,1)
*rak:      call ifill(memb,0,    int_mb(i_llab) ,1)
*rak:      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
*rak:      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
*rak:      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
*rak:c
*rak:c initialize parallelization flags
*rak:c
*rak:      me = ga_nodeid()
*rak:      nproc = ga_nnodes()
*rak:      call ga_sync()
*rak:      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
*rak:     &    write(6,*)' only integrals on node 0 will be printed. '
*rak:c
*rak:c loop over shells and compute S sums
*rak:c      
*rak:      print69 = .false.
*rak:      if (rtdb_get(rtdb,'int:ov69',MT_LOG,1,dumm69)) then
*rak:        print69 = dumm69
*rak:      endif
*rak:      idoit = (me-1)
*rak:      numtot = 0
*rak:      do 00100 i = 1,ncont
*rak:        do 00200 j = 1,i
*rak:          idoit = idoit + 1
*rak:          if(mod(idoit,nproc).eq.0) then
*rak:*            call int_1eov(basisin,i,basisin,j,
*rak:*     &          mems,dbl_mb(imems),memb,dbl_mb(imemb))
*rak:*            call int_lgen1e(basisin,i,basisin,j,1.0d-08,
*rak:*     &          int_mb(i_ilab),int_mb(i_jlab),memb,
*rak:*     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
*rak:            call int_l1eov(basisin,i,basisin,j,1.0d-08,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),memb,
*rak:     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
*rak:            if(print_ints.and.me.eq.0)
*rak:     &          call int_pgen1e('overlap',basisin,i,basisin,j,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),numleft,
*rak:     &          dbl_mb(imemb),plevel)
*rak:            call stsum1(numleft,numtot,
*rak:     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
*rak:     &          dbl_mb(i_stats),(print69.and.(me.eq.0)),
*rak:     &          'overlap')
*rak:          endif
*rak:00200   continue
*rak:00100 continue
*rak:      call ga_igop(Msg_IChkI,numtot,1,'+')
*rak:      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
*rak:      if (me.eq.0)
*rak:     &    call prt_stat_sum('overlap',dbl_mb(i_stats),numtot)
*rak:      call ga_sync()
*rak:c
*rak:c
*rak:c loop over shells and compute T sums
*rak:c      
*rak:      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
*rak:      print69 = .false.
*rak:      if (rtdb_get(rtdb,'int:ke69',MT_LOG,1,dumm69)) then
*rak:        print69 = dumm69
*rak:      endif
*rak:      idoit = (me-1)
*rak:      numtot = 0
*rak:      do 00101 i = 1,ncont
*rak:        do 00201 j = 1,i
*rak:          idoit = idoit + 1
*rak:          if(mod(idoit,nproc).eq.0) then
*rak:            call int_l1eke(basisin,i,basisin,j,1.0d-08,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),memb,
*rak:     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
*rak:            if(print_ints.and.me.eq.0)
*rak:     &          call int_pgen1e('kinetic energy',basisin,i,basisin,j,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),numleft,
*rak:     &          dbl_mb(imemb),plevel)
*rak:            call stsum1(numleft,numtot,
*rak:     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
*rak:     &          dbl_mb(i_stats),(print69.and.(me.eq.0)),
*rak:     &          'kinetic')
*rak:          endif
*rak:00201   continue
*rak:00101 continue
*rak:      call ga_igop(Msg_IChkI,numtot,1,'+')
*rak:      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
*rak:      if (me.eq.0)
*rak:     &    call prt_stat_sum('kinetic energy',dbl_mb(i_stats),numtot)
*rak:      call ga_sync()
*rak:c
*rak:c loop over shells and compute V sums
*rak:c      
*rak:      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
*rak:      print69 = .false.
*rak:      if (rtdb_get(rtdb,'int:pe69',MT_LOG,1,dumm69)) then
*rak:        print69 = dumm69
*rak:      endif
*rak:      idoit = (me-1)
*rak:      numtot = 0
*rak:      do 00102 i = 1,ncont
*rak:        do 00202 j = 1,i
*rak:          idoit = idoit + 1
*rak:          if(mod(idoit,nproc).eq.0) then
*rak:            call int_l1epe(basisin,i,basisin,j,1.0d-08,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),memb,
*rak:     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
*rak:            if(print_ints.and.me.eq.0)
*rak:     &          call int_pgen1e('pot. energy',basisin,i,basisin,j,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),numleft,
*rak:     &          dbl_mb(imemb),plevel)
*rak:            call stsum1(numleft,numtot,
*rak:     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
*rak:     &          dbl_mb(i_stats),(print69.and.(me.eq.0))
*rak:     &          ,'potential')
*rak:          endif
*rak:00202   continue
*rak:00102 continue
*rak:      call ga_igop(Msg_IChkI,numtot,1,'+')
*rak:      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
*rak:      if (me.eq.0)
*rak:     &    call prt_stat_sum('pot. energy',dbl_mb(i_stats),numtot)
*rak:      call ga_sync()
*rak:c
*rak:c loop over shells and compute h1 sums
*rak:c      
*rak:      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
*rak:      idoit = (me-1)
*rak:      print69 = .false.
*rak:      if (rtdb_get(rtdb,'int:h169',MT_LOG,1,dumm69)) then
*rak:        print69 = dumm69
*rak:      endif
*rak:      numtot = 0
*rak:      do 00103 i = 1,ncont
*rak:        do 00203 j = 1,i
*rak:          idoit = idoit + 1
*rak:          if(mod(idoit,nproc).eq.0) then
*rak:            call int_l1eh1(basisin,i,basisin,j,1.0d-08,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),memb,
*rak:     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
*rak:            if(print_ints.and.me.eq.0)
*rak:     &          call int_pgen1e('h1',basisin,i,basisin,j,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),numleft,
*rak:     &          dbl_mb(imemb),plevel)
*rak:            call stsum1(numleft,numtot,
*rak:     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
*rak:     &          dbl_mb(i_stats),(print69.and.(me.eq.0)),
*rak:     &          ' H1 (T+V)')
*rak:          endif
*rak:00203   continue
*rak:00103 continue
*rak:      call ga_igop(Msg_IChkI,numtot,1,'+')
*rak:      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
*rak:      if (me.eq.0)
*rak:     &    call prt_stat_sum('h1',dbl_mb(i_stats),numtot)
*rak:      call ga_sync()
*rak:c
*rak:c do canonical shell list for 2e integrals (4 center)
*rak:c
*rak:      print69 = .false.
*rak:      if (rtdb_get(rtdb,'int:4c69',MT_LOG,1,dumm69)) then
*rak:        print69 = dumm69
*rak:      endif
*rak:      idoit = (me-1)
*rak:      numtot = 0
*rak:      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
*rak:      do 01000 i = 1,ncont
*rak:        if((me.eq.0).and.(mod(i,10).eq.0)) then
*rak:          write(6,*)' 2e4c outer loop counter ',i,' of ',ncont
*rak:          call util_flush(6)
*rak:        endif
*rak:        do 02000 j = 1, i
*rak:          do 03000 k = 1, i
*rak:            lend = k
*rak:            if (i.eq.k) lend = j
*rak:            do 04000 l = 1, lend
*rak:              idoit = idoit + 1
*rak:              if(mod(idoit,nproc).eq.0) then
*rak:                call int_l2e4c(basisin,i,j,basisin,k,l,
*rak:c     &              1.0d-08,.true.,memb,dbl_mb(imemb),numleft,
*rak:     &              1.0d-08,.false.,memb,dbl_mb(imemb),numleft,
*rak:     &              int_mb(i_ilab),int_mb(i_jlab),
*rak:     &              int_mb(i_klab),int_mb(i_llab),
*rak:     &              mems,dbl_mb(imems))
*rak:                call stsum2(numleft,numtot,
*rak:     &              dbl_mb(imemb),
*rak:     &              int_mb(i_ilab),int_mb(i_jlab),
*rak:     &              int_mb(i_klab),int_mb(i_llab),
*rak:     &              dbl_mb(i_stats),
*rak:     &              (print_ints.and.me.eq.0),(print69.and.me.eq.0))
*rak:              endif
*rak:04000       continue
*rak:03000     continue
*rak:02000   continue
*rak:01000 continue
*rak:      call ga_igop(Msg_IChkI,numtot,1,'+')
*rak:      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
*rak:      if (me.eq.0)
*rak:     &    call prt_stat_sum('two electron',dbl_mb(i_stats),numtot)      
*rak:      call ga_sync()
*rak:c
*rak:c do canonical shell list for 2e integrals (3 center)
*rak:c
*rak:      print69 = .false.
*rak:      if (rtdb_get(rtdb,'int:3c69',MT_LOG,1,dumm69)) then
*rak:        print69 = dumm69
*rak:      endif
*rak:      idoit = (me-1)
*rak:      numtot = 0
*rak:      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
*rak:      do 01001 i = 1,ncont
*rak:        if((me.eq.0).and.(mod(i,10).eq.0)) then
*rak:          write(6,*)' 2e3c outer loop counter ',i,' of ',ncont
*rak:          call util_flush(6)
*rak:        endif
*rak:        do 02001 j = 1, i
*rak:          do 03001 k = 1, j
*rak:            idoit = idoit + 1
*rak:            if(mod(idoit,nproc).eq.0) then
*rak:              call int_l2e3c(basisin,i,basisin,j,k,
*rak:     &            1.0d-08,.true.,memb,dbl_mb(imemb),numleft,
*rak:     &            int_mb(i_ilab),int_mb(i_jlab),
*rak:     &            int_mb(i_klab),
*rak:     &            mems,dbl_mb(imems))
*rak:              call stsum2_3c(numleft,numtot,
*rak:     &            dbl_mb(imemb),
*rak:     &            int_mb(i_ilab),int_mb(i_jlab),
*rak:     &            int_mb(i_klab),
*rak:     &            dbl_mb(i_stats),(print_ints.and.me.eq.0),
*rak:     &            (print69.and.(me.eq.0)))
*rak:            endif
*rak:03001     continue
*rak:02001   continue
*rak:01001 continue
*rak:      call ga_igop(Msg_IChkI,numtot,1,'+')
*rak:      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
*rak:      if (me.eq.0)
*rak:     &    call prt_stat_sum
*rak:     &    ('3 center two electron',dbl_mb(i_stats),numtot)      
*rak:      call ga_sync()
*rak:c
*rak:c do canonical shell list for 2e integrals (2 center)
*rak:c
*rak:      print69 = .false.
*rak:      if (rtdb_get(rtdb,'int:2c69',MT_LOG,1,dumm69)) then
*rak:        print69 = dumm69
*rak:      endif
*rak:      idoit = (me-1)
*rak:      numtot = 0
*rak:      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
*rak:      do 01002 i = 1,ncont
*rak:        if((me.eq.0).and.(mod(i,10).eq.0)) then
*rak:          write(6,*)' 2e2c outer loop counter ',i,' of ',ncont
*rak:          call util_flush(6)
*rak:        endif
*rak:        do 02002 j = 1, i
*rak:          idoit = idoit + 1
*rak:          if(mod(idoit,nproc).eq.0) then
*rak:            call int_l2e2c(basisin,i,basisin,j,
*rak:     &          1.0d-08,memb,dbl_mb(imemb),numleft,
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),
*rak:     &          mems,dbl_mb(imems))
*rak:            call stsum2_2c(numleft,numtot,
*rak:     &          dbl_mb(imemb),
*rak:     &          int_mb(i_ilab),int_mb(i_jlab),
*rak:     &          dbl_mb(i_stats),(print_ints.and.me.eq.0),
*rak:     &            (print69.and.(me.eq.0)))
*rak:          endif
*rak:02002   continue
*rak:01002 continue
*rak:      call ga_igop(Msg_IChkI,numtot,1,'+')
*rak:      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
*rak:      if (me.eq.0)
*rak:     &    call prt_stat_sum
*rak:     &    ('2 center two electron',dbl_mb(i_stats),numtot)      
*rak:      call ga_sync()
*rak:      call ga_sync()
*rak:      call ga_sync()
*rak:c
*rak:c free memory in order
*rak:c
*rak:      MAstatus = MA_Pop_Stack(h_stats)
*rak:      MAstatus = MAstatus .and. MA_Pop_Stack(h_llab)
*rak:      MAstatus = MAstatus .and. MA_Pop_Stack(h_klab)
*rak:      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
*rak:      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
*rak:      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
*rak:      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
*rak:      if (.not.MAstatus)
*rak:     &       call errquit('int_chk_sum: error poping memory stack',0)
*rak:      call ga_sync()
*rak:      call ga_sync()
*rak:      end
      subroutine prt_stat_sum(msg,stats,numtot)
      implicit none
#include "inp.fh"
#include "stdio.fh"
c::passed
      character*(*) msg
      integer numtot
      double precision stats(5,3)
c::local
      integer lmsg
c
      lmsg = inp_strlen(msg)
      write(luout,10000)
      write(luout,*)' summary statistics for ',
     &    msg(1:lmsg),' integrals'
      write(luout,*)' total number of integrals processed: ',
     &    numtot
      write(luout,10001)
      write(luout,10002)stats
      write(luout,10001)
      call util_flush(luout)
10000 format(/,90('-'))
10001 format(90('-'))
10002 format(5(1pd15.8,3x))
      end      
!$HP$ OPTIMIZE OFF
      subroutine stsum1(num,numtot,Gen,ilab,jlab,stats,
     &    printem,print69,tag69)
      implicit none
#include "stdio.fh"
#include "inp.fh"
c::passed
      integer num                   ! number of 1e moieties
c
c...   numtot must be zeroed prior to first call to stsum1 ...
c
      integer numtot                ! accumulater
c
      integer ilab(num),jlab(num)   ! labels for moieties
      double precision Gen(num)     ! 1e moieties
      double precision stats(5,3)   ! stats array (zeroed elsewhere)
      logical printem               ! print to stdout
      logical print69               ! print to file 69 
*...................................!      (opened by calling routine)
      character*(*) tag69
      integer ltag69
c::local 
      integer ii,i,j
      double precision x,x2,denom,s1,d1
c
      ltag69 = inp_strlen(tag69)
      numtot = numtot + num
      do 00100 ii = 1,num
        i     = ilab(ii)
        j     = jlab(ii)
        s1    = i+j
        d1    = abs(i-j)
        x     = Gen(ii)
        x2    = x*x
        if(printem) then
          write(luout,'(1x,i5,i5,d20.10,3x,a)') i, j, x,
     &        tag69(1:ltag69)
        endif
        if(print69) then
          write(69,'(1x,i5,i5,d20.10,3x,a)') i, j, x, tag69(1:ltag69)
        endif
        denom = 1.0d00 + x2
c
        stats(1,1) = stats(1,1) + x
        stats(2,1) = stats(2,1) + abs(x)
        stats(3,1) = stats(3,1) + x2
        stats(4,1) = stats(4,1) + x/denom
        stats(5,1) = stats(5,1) + x2/denom
c
        stats(1,2) = stats(1,2) + x        * s1
        stats(2,2) = stats(2,2) + abs(x)   * s1
        stats(3,2) = stats(3,2) + x2       * s1
        stats(4,2) = stats(4,2) + x/denom  * s1
        stats(5,2) = stats(5,2) + x2/denom * s1
c
        stats(1,3) = stats(1,3) + x        * d1
        stats(2,3) = stats(2,3) + abs(x)   * d1
        stats(3,3) = stats(3,3) + x2       * d1
        stats(4,3) = stats(4,3) + x/denom  * d1
        stats(5,3) = stats(5,3) + x2/denom * d1
c
00100 continue
      end
      subroutine stsum_inve(num,Eri,ilab,jlab,klab,llab)
      implicit none
c::passed
      integer num                   ! number of 2e moieties
      integer ilab(num),jlab(num)   ! labels for moieties
      integer klab(num),llab(num)   ! labels for moieties
      double precision Eri(num)     ! 2e moieties
c
      integer ii, i, j, k, l
      double precision x
      logical coul, exch
c
      double precision ene
      integer icall, nused, nout
      save icall, nused, nout
      save ene
      data icall /0/
      data nused /0/
      data nout /0/
c
      if (icall.eq.0) ene = 0.0d00
      icall = icall + 1
c
      if (num.ne.-1) then
        do ii = 1,num
          i = ilab(ii)
          j = jlab(ii)
          k = klab(ii)
          l = llab(ii)
          x = Eri(ii)
          coul = (i.eq.j).and.(k.eq.l)
          exch = (i.eq.k).and.(j.eq.l)
          if (coul.and.exch) then
            ene = ene + 2*x
            nused = nused + 1
          elseif (coul.or.exch) then
            ene = ene + x
            nused = nused + 1
          else
            nout = nout + 1
          endif
        enddo
c
      else
        write(6,*)' stsum_inve: icall  =',icall
        write(6,*)' stsum_inve: nused  =',nused
        write(6,*)' stsum_inve: nout   =',nout
        write(6,*)' stsum_inve: n_sum  =',(nused+nout)
        write(6,*)' stsum_inve: energy =',ene
      endif
c
      end
      subroutine stsum2(num,numtot,Eri,ilab,jlab,klab,llab,
     &       stats,printem,print69,tagout)
      implicit none
#include "stdio.fh"
#include "inp.fh"
c::passed
      integer num                   ! number of 2e moieties
c
c...   numtot must be zeroed prior to first call to stsum2 ...
c
      integer numtot                ! accumulater
c
      integer ilab(num),jlab(num)   ! labels for moieties
      integer klab(num),llab(num)   ! labels for moieties
      double precision Eri(num)     ! 2e moieties
      double precision stats(5,3)   ! stats array (zeroed elsewhere)
      logical printem               ! print values as you go?
      logical print69               ! print values to unit 69?
      character*(*) tagout
c::local 
      integer ltagout
      integer ii,i,j,k,l,l4
      double precision x,x2,denom,s1,d1
c
      integer isym2,isym4
      ISYM2(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      ISYM4(I,J,K,L)=MAX(ISYM2(I,J),ISYM2(K,L))*
     &               (MAX(ISYM2(I,J),ISYM2(K,L))-1)/2+
     &               MIN(ISYM2(I,J),ISYM2(K,L))
c
      ltagout = inp_strlen(tagout)
      numtot = numtot + num
      do 00100 ii = 1,num
        i     = ilab(ii)
        j     = jlab(ii)
        k     = klab(ii)
        l     = llab(ii)
        s1    = i+j+k+l
        d1    = abs(abs(i-j)-abs(k-l))
        x     = Eri(ii)
        if (printem) then
          l4 = isym4(i,j,k,l)
          write(6,10001)l4,i,j,k,l,x,tagout(1:ltagout)
10001     format(i8,4(i4,1x),5x,1pd20.10,1x,a)
        endif
        if (print69) then
          l4 = isym4(i,j,k,l)
          write(69,10002)l4,i,j,k,l,x,tagout(1:ltagout)
10002     format(i8,4(i4,1x),1x,f30.20,1x,a)
        endif
        x2    = x*x
        denom = 1.0d00 + x2
c
        stats(1,1) = stats(1,1) + x
        stats(2,1) = stats(2,1) + abs(x)
        stats(3,1) = stats(3,1) + x2
        stats(4,1) = stats(4,1) + x/denom
        stats(5,1) = stats(5,1) + x2/denom
c
        stats(1,2) = stats(1,2) + x        * s1
        stats(2,2) = stats(2,2) + abs(x)   * s1
        stats(3,2) = stats(3,2) + x2       * s1
        stats(4,2) = stats(4,2) + x/denom  * s1
        stats(5,2) = stats(5,2) + x2/denom * s1
c
        stats(1,3) = stats(1,3) + x        * d1
        stats(2,3) = stats(2,3) + abs(x)   * d1
        stats(3,3) = stats(3,3) + x2       * d1
        stats(4,3) = stats(4,3) + x/denom  * d1
        stats(5,3) = stats(5,3) + x2/denom * d1
c
00100 continue
      end
      subroutine stsum3c(num,numtot,Eri,ilab,jlab,klab,
     &       stats,printem,print69,tagout)
      implicit none
#include "stdio.fh"
#include "inp.fh"
c::passed
      integer num                   ! number of 2e moieties
c
c...   numtot must be zeroed prior to first call to stsum_3c
c
      integer numtot                ! accumulater
c
      integer ilab(num),jlab(num)   ! labels for moieties
      integer klab(num)             ! labels for moieties
      double precision Eri(num)     ! 2e moieties
      double precision stats(5,3)   ! stats array (zeroed elsewhere)
      logical printem               ! print values as you go?
      logical print69
      character*(*) tagout
c::local 
      integer ltagout
*rak:      integer l31, l32
      integer ii,i,j,k
      double precision x,x2,denom,s1,d1
c
*rak:      integer isym2,isym3
*rak:      ISYM2(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
*rak:      ISYM3(I,J,K)=MAX(ISYM2(I,J),K)*
*rak:     &               (MAX(ISYM2(I,J),K)-1)/2+
*rak:     &               MIN(ISYM2(I,J),K)
c
      ltagout = inp_strlen(tagout)
      numtot = numtot + num
      do 00100 ii = 1,num
        i     = ilab(ii)
        j     = jlab(ii)
        k     = klab(ii)
        s1    = i+j+k
        d1    = abs(abs(i-j)-abs(k))
        x     = Eri(ii)
        if (printem) then
*rak:          l31 = isym3(i,j,k)
*rak:          l32 = isym3(j,k,i)
*rak:          write(6,10001)l31,l32,i,j,k,x,tagout(1:ltagout)
*rak:10001     format(1x,2(i8,1x),3(i4,1x),5x,1pd20.10,1x,a)
          write(6,10001)i,j,k,x,tagout(1:ltagout)
10001     format(1x,3(i4,1x),5x,1pd20.10,1x,a)
        endif
        if (print69) then
*rak:          l31 = isym3(i,j,k)
*rak:          l32 = isym3(j,k,i)
*rak:          write(69,10002)l31,l32,i,j,k,x,tagout(1:ltagout)
*rak:10002     format(2(i8,1x),3(i4,1x),1x,f30.20,1x,a)
          write(69,10002)i,j,k,x,tagout(1:ltagout)
10002     format(3(i4,1x),1x,f30.20,1x,a)
        endif
        x2    = x*x
        denom = 1.0d00 + x2
c
        stats(1,1) = stats(1,1) + x
        stats(2,1) = stats(2,1) + abs(x)
        stats(3,1) = stats(3,1) + x2
        stats(4,1) = stats(4,1) + x/denom
        stats(5,1) = stats(5,1) + x2/denom
c
        stats(1,2) = stats(1,2) + x        * s1
        stats(2,2) = stats(2,2) + abs(x)   * s1
        stats(3,2) = stats(3,2) + x2       * s1
        stats(4,2) = stats(4,2) + x/denom  * s1
        stats(5,2) = stats(5,2) + x2/denom * s1
c
        stats(1,3) = stats(1,3) + x        * d1
        stats(2,3) = stats(2,3) + abs(x)   * d1
        stats(3,3) = stats(3,3) + x2       * d1
        stats(4,3) = stats(4,3) + x/denom  * d1
        stats(5,3) = stats(5,3) + x2/denom * d1
c
00100 continue
      end
!$HP$ OPTIMIZE ON
*rak:      subroutine stsum2_2c(num,numtot,Eri,ilab,jlab,
*rak:     &       stats,printem,print69)
*rak:      implicit none
*rak:c::passed
*rak:      integer num                   ! number of 2e moieties
*rak:c
*rak:c...   numtot must be zeroed prior to first call to stsum2_2c
*rak:c
*rak:      integer numtot                ! accumulater
*rak:c
*rak:      integer ilab(num),jlab(num)   ! labels for moieties
*rak:      double precision Eri(num)     ! 2e moieties
*rak:      double precision stats(5,3)   ! stats array (zeroed elsewhere)
*rak:      logical printem               ! print values as you go?
*rak:      logical print69
*rak:c::local 
*rak:      integer ii,i,j
*rak:      double precision x,x2,denom,s1,d1
*rak:c
*rak:      numtot = numtot + num
*rak:      do 00100 ii = 1,num
*rak:        i     = ilab(ii)
*rak:        j     = jlab(ii)
*rak:        s1    = i+j
*rak:        d1    = abs(i-j)
*rak:        x     = Eri(ii)
*rak:        if (printem) then
*rak:          write(6,10001)i,j,x
*rak:10001    format(1x,2(i4,1x),5x,'eri(2c) = ',1pd20.10)
*rak:       endif
*rak:        if (print69) then
*rak:          write(69,10002)i,j,x,'2 center eri'
*rak:10002     format(2(i4,1x),1x,f30.20,1x,a)
*rak:        endif
*rak:        x2    = x*x
*rak:        denom = 1.0d00 + x2
*rak:c
*rak:        stats(1,1) = stats(1,1) + x
*rak:        stats(2,1) = stats(2,1) + abs(x)
*rak:        stats(3,1) = stats(3,1) + x2
*rak:        stats(4,1) = stats(4,1) + x/denom
*rak:        stats(5,1) = stats(5,1) + x2/denom
*rak:c
*rak:        stats(1,2) = stats(1,2) + x        * s1
*rak:        stats(2,2) = stats(2,2) + abs(x)   * s1
*rak:        stats(3,2) = stats(3,2) + x2       * s1
*rak:        stats(4,2) = stats(4,2) + x/denom  * s1
*rak:        stats(5,2) = stats(5,2) + x2/denom * s1
*rak:c
*rak:        stats(1,3) = stats(1,3) + x        * d1
*rak:        stats(2,3) = stats(2,3) + abs(x)   * d1
*rak:        stats(3,3) = stats(3,3) + x2       * d1
*rak:        stats(4,3) = stats(4,3) + x/denom  * d1
*rak:        stats(5,3) = stats(5,3) + x2/denom * d1
*rak:c
*rak:00100 continue
*rak:      end
*
      subroutine int_chk_sum_ov(rtdb,basisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      logical print_ints ! [input] also print integral/label values 
c::local
      logical debug
      logical MAstatus
      integer max1bf, maxg, mscr1, mscr2
c
      integer i, j, numleft, numtot
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for
*                                              ! labels and buffers
c
      integer h_stats, i_stats
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont
      integer plevel
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_ov: numcont not obtained',ncont,
     &           INT_ERR)
c
      call int_mem(max1bf,maxg,mscr1,mscr2)
      memb = max1bf
      mems = mscr1
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit('int_chk_sum_ov: allocation memb failed',memb,
     &            MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit('int_chk_sum_ov: allocation mems failed',mems,
     &           MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'i label buffer',h_ilab,i_ilab))
     &    call errquit('int_chk_sum_ov: allocation ilab failed',memb,
     &           MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'j label buffer',h_jlab,i_jlab))
     &    call errquit('int_chk_sum_ov: allocation jlab failed',memb,
     &          MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_ov: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      call ga_sync()
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:ovprint',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.ov',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c loop over shells and compute S sums
c      
      idoit = (me-1)
      numtot = 0
      do 00100 i = 1,ncont
        do 00200 j = 1,i
          idoit = idoit + 1
          if(mod(idoit,nproc).eq.0) then
            call int_l1eov(basisin,i,basisin,j,1.0d-08,
     &          int_mb(i_ilab),int_mb(i_jlab),memb,
     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
            call stsum1(numleft,numtot,
     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
     &          dbl_mb(i_stats),
     &          (print_ints.and.(me.eq.0)),
     &          print69,
     &          'overlap')
          endif
00200   continue
00100 continue
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum('overlap',dbl_mb(i_stats),numtot)
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &    call errquit
     &    ('int_chk_sum_ov: error poping memory stack',0, MEM_ERR)
c
* close file      
      close(unit=69,status='keep')
c      
      call ga_sync()
      end
      subroutine int_chk_sum_ke(rtdb,basisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      logical print_ints ! [input] also print integral/label values 
c::local
      logical debug
      logical MAstatus
      integer max1bf, maxg, mscr1, mscr2
c
      integer i, j, numleft, numtot
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for
*                                              ! labels and buffers
c
      integer h_stats, i_stats
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont
      integer plevel
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_ke: numcont not obtained',ncont,
     &           INT_ERR)
c
      call int_mem(max1bf,maxg,mscr1,mscr2)
      memb = max1bf
      mems = mscr1
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit('int_chk_sum_ke: allocation memb failed',memb,
     &           MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit('int_chk_sum_ke: allocation mems failed',mems,
     &             MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'i label buffer',h_ilab,i_ilab))
     &    call errquit('int_chk_sum_ke: allocation ilab failed',memb,
     &            MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'j label buffer',h_jlab,i_jlab))
     &    call errquit('int_chk_sum_ke: allocation jlab failed',memb,
     &            MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_ke: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      call ga_sync()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:keprint',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.ke',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c loop over shells and compute T sums
c      
      idoit = (me-1)
      numtot = 0
      do 00100 i = 1,ncont
        do 00200 j = 1,i
          idoit = idoit + 1
          if(mod(idoit,nproc).eq.0) then
            call int_l1eke(basisin,i,basisin,j,1.0d-08,
     &          int_mb(i_ilab),int_mb(i_jlab),memb,
     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
            call stsum1(numleft,numtot,
     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
     &          dbl_mb(i_stats),
     &          (print_ints.and.(me.eq.0)),
     &          print69,
     &          'kinetic')
          endif
00200   continue
00100 continue
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum('kinetic',dbl_mb(i_stats),numtot)
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &    call errquit
     &    ('int_chk_sum_ke: error poping memory stack',0, MEM_ERR)
c
* close file      
      close(unit=69,status='keep')
c      
      call ga_sync()
      end
      subroutine int_chk_sum_pe(rtdb,basisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      logical print_ints ! [input] also print integral/label values 
c::local
      logical debug
      logical MAstatus
      integer max1bf, maxg, mscr1, mscr2
c
      integer i, j, numleft, numtot
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for
*                                              ! labels and buffers
c
      integer h_stats, i_stats
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont
      integer plevel
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_pe: numcont not obtained',ncont,
     &             INT_ERR)
c
      call int_mem(max1bf,maxg,mscr1,mscr2)
      memb = max1bf
      mems = mscr1
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit('int_chk_sum_pe: allocation memb failed',memb,
     &           MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit('int_chk_sum_pe: allocation mems failed',mems,
     &            MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'i label buffer',h_ilab,i_ilab))
     &    call errquit('int_chk_sum_pe: allocation ilab failed',memb,
     &            MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'j label buffer',h_jlab,i_jlab))
     &    call errquit('int_chk_sum_pe: allocation jlab failed',memb,
     &           MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_pe: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      call ga_sync()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:peprint',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.pe',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c loop over shells and compute V sums
c      
      idoit = (me-1)
      numtot = 0
      do 00100 i = 1,ncont
        do 00200 j = 1,i
          idoit = idoit + 1
          if(mod(idoit,nproc).eq.0) then
            call int_l1epe(basisin,i,basisin,j,1.0d-08,
     &          int_mb(i_ilab),int_mb(i_jlab),memb,
     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
            call stsum1(numleft,numtot,
     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
     &          dbl_mb(i_stats),
     &          (print_ints.and.(me.eq.0)),
     &          print69,
     &          'potential')
          endif
00200   continue
00100 continue
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum('potential',dbl_mb(i_stats),numtot)
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &    call errquit
     &    ('int_chk_sum_pe: error poping memory stack',0, MEM_ERR)
c
* close file      
      close(unit=69,status='keep')
c      
      call ga_sync()
      end
      subroutine int_chk_sum_h1(rtdb,basisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      logical print_ints ! [input] also print integral/label values 
c::local
      logical debug
      logical MAstatus
      integer maxh1, mscrh1
c
      integer i, j, numleft, numtot
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for
*                                              ! labels and buffers
c
      integer h_stats, i_stats
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont
      integer plevel
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_h1: numcont not obtained',ncont,
     &          INT_ERR)
c
      call int_mem_h1(maxh1,mscrh1)
      memb = maxh1
      mems = mscrh1
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit('int_chk_sum_h1: allocation memb failed',memb,
     &           MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit('int_chk_sum_h1: allocation mems failed',mems,
     &            MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'i label buffer',h_ilab,i_ilab))
     &    call errquit('int_chk_sum_h1: allocation ilab failed',memb,
     &             MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'j label buffer',h_jlab,i_jlab))
     &    call errquit('int_chk_sum_h1: allocation jlab failed',memb,
     &             MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_h1: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      call ga_sync()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:h1print',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.h1',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c loop over shells and compute H1 sums
c      
      idoit = (me-1)
      numtot = 0
      do 00100 i = 1,ncont
        do 00200 j = 1,i
          idoit = idoit + 1
          if(mod(idoit,nproc).eq.0) then
            call int_l1eh1(basisin,i,basisin,j,1.0d-08,
     &          int_mb(i_ilab),int_mb(i_jlab),memb,
     &          dbl_mb(imemb),mems,dbl_mb(imems),numleft)
            call stsum1(numleft,numtot,
     &          dbl_mb(imemb),int_mb(i_ilab),int_mb(i_jlab),
     &          dbl_mb(i_stats),
     &          (print_ints.and.(me.eq.0)),
     &          print69,
     &          'H1 (T + V)')
          endif
00200   continue
00100 continue
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum('H1 (T + V)',dbl_mb(i_stats),numtot)
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &    call errquit
     &    ('int_chk_sum_h1: error poping memory stack',0, MEM_ERR)
c
* close file      
      close(unit=69,status='keep')
c      
      call ga_sync()
      end
      subroutine int_chk_sum_3ov(rtdb,basisin,ribasisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
#include "stdio.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      integer ribasisin  ! [input] basis set handle for fitting basis
      logical print_ints ! [input] also print integral/label values 
c::local
      logical debug
      logical MAstatus
      integer max3ov, mscr3ov
c
      integer i, j, k, numleft, numtot
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for
*                                              ! labels and buffers
      integer i_klab, h_klab
c
      integer h_stats, i_stats
c
      character*11 tagextra
      character*40 tag69
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont, rincont
      integer plevel
      integer ribasisuse
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_3ov: numcont not obtained',ncont,
     &            INT_ERR)
c
c  if (ribasisin = -1) then no ri basis is loaded so use 
c      regular ao basis
c
      if (ribasisin.eq.-1) then
        ribasisuse = basisin
        tagextra = '<ao,ao,ao> '
*        write(luout,*)
*     &      '3 center overlap integrals computed <ao,ao,ao>'
      else
        ribasisuse = ribasisin
        tagextra = '<ao,ao,fit>'
*        write(luout,*)
*     &      '3 center overlap integrals computed <ao,ao,fit>'
      endif
      tag69 = '3 center overlap'//' '//tagextra
c
      if (.not.bas_numcont(ribasisuse,rincont))
     &    call errquit
     &    ('int_chk_sum_3ov: rincont not obtained',rincont, INT_ERR)
c
      call int_mem_3ov(max3ov,mscr3ov)
      memb = max3ov
      mems = mscr3ov
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit('int_chk_sum_3ov: allocation memb failed',memb,
     &                MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit('int_chk_sum_3ov: allocation mems failed',mems,
     &           MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'i label buffer',h_ilab,i_ilab))
     &    call errquit('int_chk_sum_3ov: allocation ilab failed',memb,
     &               MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'j label buffer',h_jlab,i_jlab))
     &    call errquit('int_chk_sum_3ov: allocation jlab failed',memb, 
     &               MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'k label buffer',h_klab,i_klab))
     &    call errquit('int_chk_sum_3ov: allocation klab failed',memb,
     &               MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_3ov: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call ifill(memb,0,    int_mb(i_klab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      call ga_sync()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:3ovprint',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.3ov',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c loop over shells and compute 3 center overlap sums
c      
      idoit = (me-1)
      numtot = 0
      do i = 1,ncont
        do j = 1,i
          do k = 1,rincont
            idoit = idoit + 1
            if(mod(idoit,nproc).eq.0) then
              call int_l1e3ov(
     &            basisin,i,
     &            basisin,j,
     &            ribasisuse,k,
     &            1.0d-08,
     &            memb,dbl_mb(imemb),
     &            int_mb(i_ilab),
     &            int_mb(i_jlab),
     &            int_mb(i_klab),
     &            numleft,mems,dbl_mb(imems))
              call stsum3c(numleft,numtot,
     &            dbl_mb(imemb),
     &            int_mb(i_ilab),
     &            int_mb(i_jlab),
     &            int_mb(i_klab),
     &            dbl_mb(i_stats),
     &            (print_ints.and.(me.eq.0)),
     &            print69,
     &            tag69)
            endif
          enddo
        enddo
      enddo
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum(tag69,dbl_mb(i_stats),numtot)
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_klab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &    call errquit
     &    ('int_chk_sum_3ov: error poping memory stack',0, MEM_ERR)
c
* close file      
      close(unit=69,status='keep')
c      
      call ga_sync()
      end
      subroutine int_chk_sum_2e4c(rtdb,basisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
#include "stdio.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      logical print_ints ! [input] also print integral and label 
*........................!         values to stdout.
c::local
      logical debug
      logical MAstatus
      integer max1bf, maxg, mscr1, mscr2 
c
      integer i,j,k,l, numleft, numtot, lend
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab ! handles and index for labels buffers
      integer i_jlab, h_jlab ! handles and index for labels buffers
      integer i_klab, h_klab ! handles and index for labels buffers
      integer i_llab, h_llab ! handles and index for labels buffers
c
      integer h_stats, i_stats
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont
      integer plevel
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_2e4c: numcont not obtained',ncont, 
     &           INT_ERR)
c
      call int_mem(max1bf,maxg,mscr1,mscr2)
      memb = maxg
      mems = mscr2
c
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit
     &    ('int_chk_sum_2e4c: allocation memb failed',memb, MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit
     &    ('int_chk_sum_2e4c: allocation mems failed',mems, MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,'i label buffer',
     &    h_ilab,i_ilab))
     &    call errquit
     &    ('int_chk_sum_2e4c: allocation ilab failed',memb, MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,'j label buffer',
     &    h_jlab,i_jlab))
     &    call errquit
     &    ('int_chk_sum_2e4c: allocation jlab failed',memb, MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,'k label buffer',
     &    h_klab,i_klab))
     &    call errquit
     &    ('int_chk_sum_2e4c: allocation klab failed',memb, MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,'l label buffer',
     &    h_llab,i_llab))
     &    call errquit
     &    ('int_chk_sum_2e4c: allocation llab failed',memb, MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_2e4c: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call ifill(memb,0,    int_mb(i_klab) ,1)
      call ifill(memb,0,    int_mb(i_llab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      call ga_sync()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:2e4cprint',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.2e4c',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c do canonical shell list for 2e integrals (4 center)
c
      idoit = (me-1)
      numtot = 0
      do 01000 i = 1,ncont
        if((me.eq.0).and.(mod(i,10).eq.0)) then
          write(luout,*)' 2e4c outer loop counter ',i,' of ',ncont
          call util_flush(luout)
        endif
        do 02000 j = 1, i
          do 03000 k = 1, i
            lend = k
            if (i.eq.k) lend = j
            do 04000 l = 1, lend
              idoit = idoit + 1
              if(mod(idoit,nproc).eq.0) then
                call int_l2e4c(basisin,i,j,basisin,k,l,
     &              1.0d-08,.false.,memb,dbl_mb(imemb),numleft,
     &              int_mb(i_ilab),int_mb(i_jlab),
     &              int_mb(i_klab),int_mb(i_llab),
     &              mems,dbl_mb(imems))
                call stsum2(numleft,numtot,
     &              dbl_mb(imemb),
     &              int_mb(i_ilab),int_mb(i_jlab),
     &              int_mb(i_klab),int_mb(i_llab),
     &              dbl_mb(i_stats),
     &              (print_ints.and.(me.eq.0)),
     &              print69,'two electron (2e4c)')
              endif
04000       continue
03000     continue
02000   continue
01000 continue
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum('two electron (2e4c)',
     &    dbl_mb(i_stats),numtot)      
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_llab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_klab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &       call errquit
     &    ('int_chk_sum_2e4c: error poping memory stack',0, MEM_ERR)
* close file      
      close(unit=69,status='keep')
      call ga_sync()
      end
      subroutine int_chk_sum_2e3c(rtdb,basisin,ribasisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
#include "stdio.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      integer ribasisin  ! [input] basis set handle for fitting basis
      logical print_ints ! [input] also print integral/label values 
c::local
      logical debug
      logical MAstatus
      integer max2e3c, mscr2e3c
c
      integer i, j, k, numleft, numtot
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for
*                                              ! labels and buffers
      integer i_klab, h_klab
c
      integer h_stats, i_stats
c
      character*11 tagextra
      character*40 tag69
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont, rincont
      integer plevel
      integer ribasisuse
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_2e3c: numcont not obtained',ncont,
     &          MEM_ERR)
c
c  if (ribasisin = -1) then no ri basis is loaded so use 
c      regular ao basis
c
      if (ribasisin.eq.-1) then
        ribasisuse = basisin
        tagextra = '<ao|ao,ao> '
*        write(luout,*)
*     &      '2 electron 3 center ERI integrals computed <ao,ao,ao>'
      else
        ribasisuse = ribasisin
        tagextra = '<fit|ao,ao>'
*        write(luout,*)
*     &      '2 electron 3 center ERI integrals computed <fit,ao,ao>'
      endif
      tag69 = '2e-3 center ERI'//' '//tagextra
c
      if (.not.bas_numcont(ribasisuse,rincont))
     &    call errquit
     &    ('int_chk_sum_2e3c: rincont not obtained',rincont, MEM_ERR)
c
      call int_mem_2e3c(max2e3c,mscr2e3c)
      memb = max2e3c
      mems = mscr2e3c
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit
     &    ('int_chk_sum_2e3c: allocation memb failed',memb, MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit
     &    ('int_chk_sum_2e3c: allocation mems failed',mems, MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'i label buffer',h_ilab,i_ilab))
     &    call errquit
     &    ('int_chk_sum_2e3c: allocation ilab failed',memb, MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'j label buffer',h_jlab,i_jlab))
     &    call errquit
     &    ('int_chk_sum_2e3c: allocation jlab failed',memb, MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'k label buffer',h_klab,i_klab))
     &    call errquit
     &    ('int_chk_sum_2e3c: allocation klab failed',memb, MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_2e3c: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call ifill(memb,0,    int_mb(i_klab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      call ga_sync()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:2e3cprint',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.2e3c',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c loop over shells and compute 3 center overlap sums
c      
      idoit = (me-1)
      numtot = 0
      do i = 1,rincont
        do j = 1,ncont
          do k = 1,j
            idoit = idoit + 1
            if(mod(idoit,nproc).eq.0) then
              call int_l2e3c(
     &            ribasisuse,i,
     &            basisin,j,k,
     &            1.0d-08,.false.,
     &            memb,dbl_mb(imemb),
     &            numleft,
     &            int_mb(i_ilab),
     &            int_mb(i_jlab),
     &            int_mb(i_klab),
     &            mems,dbl_mb(imems))
              call stsum3c(numleft,numtot,
     &            dbl_mb(imemb),
     &            int_mb(i_ilab),
     &            int_mb(i_jlab),
     &            int_mb(i_klab),
     &            dbl_mb(i_stats),
     &            (print_ints.and.(me.eq.0)),
     &            print69,
     &            tag69)
            endif
          enddo
        enddo
      enddo
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum(tag69,dbl_mb(i_stats),numtot)
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_klab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &    call errquit
     &    ('int_chk_sum_2e3c: error poping memory stack',0, MEM_ERR)
c
* close file      
      close(unit=69,status='keep')
c      
      call ga_sync()
      end
      subroutine int_chk_sum_2e2c(rtdb,basisin,ribasisin,print_ints)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "msgids.fh"
#include "rtdb.fh"
#include "context.fh"
#include "stdio.fh"
c::passed
      integer rtdb       ! [input] rtdb handle
      integer basisin    ! [input] basis set handle 
      integer ribasisin  ! [input] basis set handle for fitting basis
      logical print_ints ! [input] also print integral/label values 
c::local
      logical debug
      logical MAstatus
      integer max2e2c, mscr2e2c
c
      integer i, j, numleft, numtot
      integer memb      ! memory buffer for integrals (1es and eri)
      integer mems      ! scratch space needed for integrals
      integer hmemb, hmems ! memory handles
      integer imemb, imems ! memory indexes
c
      integer i_ilab, h_ilab, i_jlab, h_jlab   ! handles and index for
*                                              ! labels and buffers

      integer h_stats, i_stats
c
      character*8 tagextra
      character*40 tag69
c
      character*255 name69
      logical print69
      logical dumm69
c
      integer ncont, rincont
      integer plevel
      integer ribasisuse
c
      integer me, nproc, idoit
c      
      data debug /.false./
      data plevel /0/
c 
c
c if debugging then up print level
c
      if (debug) plevel = 1
c
c get number of contractions (shells) ncont
c
      if (.not.bas_numcont(basisin,ncont))
     &    call errquit('int_chk_sum_2e2c: numcont not obtained',ncont,
     &           INT_ERR)
c
c  if (ribasisin = -1) then no ri basis is loaded so use 
c      regular ao basis
c
      if (ribasisin.eq.-1) then
        ribasisuse = basisin
c                   12345678901
        tagextra = '<ao|ao> '
*        write(luout,*)
*     &      '2 electron 2 center ERI integrals computed <ao|ao>'
      else
        ribasisuse = ribasisin
        tagextra = '<fit|ao>'
*        write(luout,*)
*     &      '2 electron 2 center ERI integrals computed <fit|ao>'
      endif
      tag69 = '2e-2 center ERI'//' '//tagextra
c
      if (.not.bas_numcont(ribasisuse,rincont))
     &    call errquit
     &    ('int_chk_sum_2e2c: rincont not obtained',rincont, INT_ERR)
c
      call int_mem_2e2c(max2e2c,mscr2e2c)
      memb = max2e2c
      mems = mscr2e2c
c
c.... eri/1e buffer
      if (.not.MA_Push_Get(MT_Dbl,memb,'int buffer',hmemb,imemb))
     &    call errquit
     &    ('int_chk_sum_2e2c: allocation memb failed',memb, MEM_ERR)
c.... scratch for integrals
      if (.not.MA_Push_Get(MT_Dbl,mems,'int scr buffer',hmems,imems))
     &    call errquit
     &    ('int_chk_sum_2e2c: allocation mems failed',mems, MEM_ERR)
c...  label buffers
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'i label buffer',h_ilab,i_ilab))
     &    call errquit
     &    ('int_chk_sum_2e2c: allocation ilab failed',memb, MEM_ERR)
      if (.not.MA_Push_Get(MT_Int,memb,
     &    'j label buffer',h_jlab,i_jlab))
     &    call errquit
     &    ('int_chk_sum_2e2c: allocation jlab failed',memb, MEM_ERR)
c...  summary stats 1e and 2e.  i.e., allocate bigger
      if (.not.MA_Push_Get(MT_Dbl,(5*3),'summary stats',
     &    h_stats,i_stats))
     &    call errquit
     &    ('int_chk_sum_2e2c: allocation stats failed',(5*3), MEM_ERR)
c
c zero memory 
      call ifill(memb,0,    int_mb(i_ilab) ,1)
      call ifill(memb,0,    int_mb(i_jlab) ,1)
      call dfill(memb,0.0d0,  dbl_mb(imemb)  ,1)
      call dfill(mems,0.0d0,  dbl_mb(imems)  ,1)
      call dfill((5*3),0.0d0, dbl_mb(i_stats),1)
c
c initialize parallelization flags
c
      me = ga_nodeid()
      nproc = ga_nnodes()
      call ga_sync()
      if ((me.eq.0).and.(nproc.gt.1).and.print_ints)
     &    write(6,*)' only integrals on node 0 will be printed. '
c
      print69 = .false.
      if (rtdb_get(rtdb,'intcsum:2e2cprint',MT_LOG,1,dumm69)) then
        print69 = dumm69
      endif
*
*-- open files for each node
*
      if (print69) then
        call util_file_name('csum.2e2c',.false.,.true.,name69)
        open(unit=69,file=name69,
     &      form='formatted',access='sequential',
     &      status='unknown')
      endif
c
c loop over shells and compute 3 center overlap sums
c      
      idoit = (me-1)
      numtot = 0
      do i = 1,rincont
        do j = 1,ncont
          idoit = idoit + 1
          if(mod(idoit,nproc).eq.0) then
            call int_l2e2c(
     &          ribasisuse,i,
     &          basisin,j,
     &          1.0d-08,
     &          memb,dbl_mb(imemb),
     &          numleft,
     &          int_mb(i_ilab),
     &          int_mb(i_jlab),
     &          mems,dbl_mb(imems))
            call stsum1(numleft,numtot,
     &          dbl_mb(imemb),
     &          int_mb(i_ilab),
     &          int_mb(i_jlab),
     &          dbl_mb(i_stats),
     &          (print_ints.and.(me.eq.0)),
     &          print69,
     &          tag69)
          endif
        enddo
      enddo
      call ga_igop(Msg_IChkI,numtot,1,'+')
      call ga_dgop(Msg_IChkD,dbl_mb(i_stats),(5*3),'+')
      if (me.eq.0)
     &    call prt_stat_sum(tag69,dbl_mb(i_stats),numtot)
c
c free memory in order
c
      MAstatus = MA_Pop_Stack(h_stats)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_jlab)
      MAstatus = MAstatus .and. MA_Pop_Stack(h_ilab)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmems)
      MAstatus = MAstatus .and. MA_Pop_Stack(hmemb)
      if (.not.MAstatus)
     &    call errquit
     &    ('int_chk_sum_2e2c: error poping memory stack',0, MEM_ERR)
c
* close file      
      close(unit=69,status='keep')
c      
      call ga_sync()
      end

*
* $Id: integrate_kbpp_e_band_stress_nonlocal.F 22503 2012-05-20 06:58:57Z d3y133 $
*

*     ******************************************
*     *                                        *
*     *   integrate_kbpp_e_band_stress_nonlocal  *
*     *                                        *
*     ******************************************

      subroutine integrate_kbpp_e_band_stress_nonlocal(version,kvec,
     >                            nrho,drho,lmax,locp,nmax,
     >                            n_extra,n_expansion,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nfft1,nfft2,nfft3,nprj,
     >                            G,dvnl,
     >                            ierr)
      implicit none
      integer          version
      double precision kvec(3)
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      integer          nmax
      integer          n_extra,n_expansion(0:lmax)
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:(lmax+n_extra))
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nfft1,nfft2,nfft3,nprj
      double precision G(nfft1,nfft2,nfft3,3)
      double precision dvnl(nfft1,nfft2,nfft3,3,nprj)

      integer ierr

      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      integer lcount,task_count,nfft3d
      integer k1,k2,k3,i,l,n,nb
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3,p,pp
      double precision gx,gy,gz,a,q,d,dd
      double precision duxdGx,duxdGy,duxdGz
      double precision duydGx,duydGy,duydGz
      double precision duzdGx,duzdGy,duzdGz
      double precision sumx,sumy,sumz
      double precision T,dTdux,dTduy,dTduz
      integer indx(5,0:3)

*     **** external functions ****
      double precision dsum,simp
      external         dsum,simp

*     **** set up indx(n,l) --> to wp ****
      nb = lmax+1
      do l=0,lmax
         indx(1,l) = l
         do n=2,n_expansion(l)
            indx(n,l) = nb
            nb = nb+1
         end do
      end do

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      nfft3d = (nfft1)*nfft2*nfft3
      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      if (lmax.gt.3) then
        ierr=1
        return
      end if
      if ((nrho/2)*2.eq.nrho) then
        ierr=2
        return
      end if

      p0=dsqrt(forpi)
      p1=dsqrt(3.0d0*forpi)
      p2=dsqrt(15.0d0*forpi)
      p3=dsqrt(105.0d0*forpi)

*======================  Fourier transformation  ======================
      call dcopy(3*nprj*nfft3d,0.0d0,0,dvnl,1)
      task_count = -1
      do 700 k3=1,nfft3
      do 700 k2=1,nfft2
      do 700 k1=1,nfft1
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700
        gx=G(k1,k2,k3,1)+kvec(1)
        gy=G(k1,k2,k3,2)+kvec(2)
        gz=G(k1,k2,k3,3)+kvec(3)

        q=dsqrt(gx**2 + gy**2 + gz**2)

        if (dabs(q).gt.1.0d-9) then

           gx=gx/q
           gy=gy/q
           gz=gz/q
           do i=1,nrho
             cs(i)=dcos(q*rho(i))
             sn(i)=dsin(q*rho(i))
           end do

*          **** calculate du_r/dG_s ****
           duxdGx = 1.0d0/q -gx*gx/q
           duxdGy = -gx*gy/q
           duxdGz = -gx*gz/q

           duydGx = -gy*gx/q
           duydGy = 1.0d0/q - gy*gy/q
           duydGz = -gy*gz/q

           duzdGx = -gz*gx/q
           duzdGy = -gz*gy/q
           duzdGz = 1.0d0/q - gz*gz/q

           lcount = nprj+1
           GO TO (500,400,300,200), LMAX+1


*::::::::::::::::::::::::::::::  f-wave  ::::::::::::::::::::::::::::::
  200      CONTINUE
        if (locp.ne.3) then
           do n=1,n_expansion(3)
           F(1)=0.0d0
           do i=2,nrho
             A=sn(i)/(q*rho(i))
             A=15.0d0*(A-cs(i))/(q*rho(i))**2 - 6*A + cs(i)
             f(i)=A*wp(i,indx(n,3))*vp(i,3)
           end do
           D=P3*SIMP(nrho,F,drho)/q

           F(1)=0.0d0
           do i=2,nrho
             A= -60.0d0*sn(i)/(rho(i)**3 * q**5)
     >        +  60.0d0*cs(i)/(rho(i)**2 * q**4)
     >        +  27.0d0*sn(i)/(rho(i)    * q**3)
     >        -   7.0d0*cs(i)/(q**2)
     >        -   rho(i)*sn(i)/q
             f(i)=A*wp(i,indx(n,3))*vp(i,3)
           end do
           DD=P3*SIMP(nrho,F,drho)

           lcount = lcount-1
           T = gx*(4.0d0*gx*gx - 3.0d0*(1.0d0-gz*gz))/dsqrt(24.0d0)
           dTdux = (12.0d0*gx*gx-3.0d0*(1.0d0-gz*gz))/dsqrt(24.0d0)
           dTduy = 0.0d0
           dTduz = 6.0d0*gx*gz/dsqrt(24.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T = gy*(3.0d0*(1.0d0-gz*gz)-4.0d0*gy*gy)/dsqrt(24.0d0)
           dTdux = 0.0d0
           dTduy = (3.0d0*(1.0d0-gz*gz)-12.0d0*gy*gy)/dsqrt(24.0d0)
           dTduz = -6.0d0*gy*gz/dsqrt(24.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =gz*(gx*gx - gy*gy)/2.0d0
           dTdux =  gx*gz
           dTduy = -gy*gz
           dTduz = (gx*gx-gy*gy)/2.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =gx*gy*gz
           dTdux = gy*gz
           dTduy = gx*gz
           dTduz = gx*gy
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =  gx*(5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0)
           dTdux = (5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0)
           dTduy = 0.0d0
           dTduz = 10.0d0*gx*gz/dsqrt(40.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T = gy*(5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0)
           dTdux = 0.0d0
           dTduy =(5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0)
           dTduz =10.0d0*gy*gz/dsqrt(40.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =gz*(5.0d0*gz*gz-3.0d0)/dsqrt(60.0d0)
           dTdux = 0.0d0
           dTduy = 0.0d0
           dTduz =(15.0d0*gz*gz -3.0d0)/dsqrt(60.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz
           end do
        end if



*::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
  300      CONTINUE
        if (locp.ne.2) then
          do n=1,n_expansion(2)
          F(1)=0.0d0
          DO i=2,nrho
            A=3.0d0*(sn(i)/(q*rho(i))-cs(i))/(q*rho(i))-sn(i)
            f(i)=A*wp(i,indx(n,2))*vp(i,2)
          END DO
          D=P2*SIMP(nrho,F,drho)/q

          F(1)=0.0d0
          DO i=2,nrho
            A= -9.0d0*sn(i)/(rho(i)**2 * q**4)
     >       +  9.0d0*cs(i)/(rho(i)    * q**3)
     >       +  4.0d0*sn(i)/(q**2)
     >       -  rho(i)*cs(i)/q
            f(i)=A*wp(i,indx(n,2))*vp(i,2)
          END DO
          DD=P2*SIMP(nrho,F,drho)

          lcount = lcount-1
          T = (3.0d0*gz*gz-1.0d0)/(2.0d0*dsqrt(3.0d0))
          dTdux = 0.0d0
          dTduy = 0.0d0
          dTduz = 6.0d0*gz/(2.0d0*dsqrt(3.0d0))
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = gx*gy
          dTdux = gy
          dTduy = gx
          dTduz = 0.0d0
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = gy*gz
          dTdux = 0.0d0
          dTduy = gz
          dTduz = gy
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = gz*gx
          dTdux = gz
          dTduy = 0.0d0
          dTduz = gx
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = (gx*gx-gy*gy)/2.0d0
          dTdux = gx
          dTduy = -gy
          dTduz = 0.0d0
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz
          end do
        end if


*::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
  400      CONTINUE
        if (locp.ne.1) then
           do n=1,n_expansion(1)
           F(1)=0.0d0
           DO i=2,nrho
             f(i)=(sn(i)/(q*rho(i)) - cs(i)) * wp(i,indx(n,1))*vp(i,1)
           END DO
           P=P1*SIMP(nrho,F,drho)/q

           F(1)=0.0d0
           DO i=2,nrho
             f(i)=wp(i,indx(n,1))*vp(i,1)*(-2.0d0*sn(i)/(rho(i)*q**3)
     >                                    + 2.0d0*cs(i)/(q**2)
     >                                    + rho(i)*sn(i)/q)
           END DO
           PP=P1*SIMP(nrho,F,drho)

           lcount = lcount-1
           T = gx
           dTdux = 1.0d0
           dTduy = 0.0d0
           dTduz = 0.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)= PP*T*gx + P*sumx
           dvnl(k1,k2,k3,2,lcount)= PP*T*gy + P*sumy
           dvnl(k1,k2,k3,3,lcount)= PP*T*gz + P*sumz


           lcount = lcount-1
           T = gy
           dTdux = 0.0d0
           dTduy = 1.0d0
           dTduz = 0.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)= PP*T*gx + P*sumx
           dvnl(k1,k2,k3,2,lcount)= PP*T*gy + P*sumy
           dvnl(k1,k2,k3,3,lcount)= PP*T*gz + P*sumz

           lcount = lcount-1
           T = gz
           dTdux = 0.0d0
           dTduy = 0.0d0
           dTduz = 1.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)= PP*T*gx + P*sumx
           dvnl(k1,k2,k3,2,lcount)= PP*T*gy + P*sumy
           dvnl(k1,k2,k3,3,lcount)= PP*T*gz + P*sumz
           end do
        end if



*::::::::::::::::::::::::::::::  s-wave  :::::::::::::::::::::::::::::::
  500      CONTINUE
        if (locp.ne.0) then
          do n=1,n_expansion(0)
          DO i=1,nrho
            f(i)=wp(i,indx(n,0))*vp(i,0) * ( -sn(i)/(q**2)
     >                              + rho(i)*cs(i)/q)
          END DO
          P = P0*SIMP(nrho,F,drho)
          lcount = lcount-1
          dvnl(k1,k2,k3,1,lcount) = P *gx
          dvnl(k1,k2,k3,2,lcount) = P *gy
          dvnl(k1,k2,k3,3,lcount) = P *gz
          end do
        end if


  600      CONTINUE

*:::::::::::::::::::::::::::::::  G+k=0  ::::::::::::::::::::::::::::::::      
      else

        do l=1,nprj
          dvnl(1,1,1,1,l)=0.0d0
          dvnl(1,1,1,2,l)=0.0d0
          dvnl(1,1,1,3,l)=0.0d0
        end do

       end if
    
  700 CONTINUE

      call Parallel_Vector_SumAll(3*nprj*nfft3d,dvnl)

      ierr=0
      return
      end

      subroutine argos_cafe_pmelam()
c
      implicit none
c
#include "argos_pme_common.fh"
c
      lcorr(1)=.false.
      lcorr(2)=.false.
      lcorr(3)=.false.
c
      return
      end
c $Id: argos_cafe_pmelam.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_diana_all(isel,ival,wt,numsel)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      integer isel(nsa)
      real*8 wt(nsa)
      integer i,ival,numsel
c
      do 1 i=1,nsa
      isel(i)=ival
    1 continue
c
      numsel=0
      if(ival.ne.0) numsel=nsa
      do 2 i=1,nsa
      wt(i)=1.0d0
      if(isel(i).eq.0) wt(i)=0.0d0
    2 continue
c
      return
      end
c $Id: argos_diana_all.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_diana_anahdr(sgmnam)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
c
      character*16 sgmnam(nsa)
      character*11 atom(4)
      integer i,j
c
      write(lfnana,1000) ndist,nangl,ntors,nimps
 1000 format(4i10)
c
      do 1 i=1,ndist
      do 11 j=1,2
      if(idist(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(idist(i,j,1))(12:16),':',
     + sgmnam(idist(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+idist(i,j,1),':',
     + wnam(idist(i,j,2))(6:10)
      endif
   11 continue
c
      write(lfnana,1001) (atom(j),j=1,2)
 1001 format(a11,'-',a11)
    1 continue
c
      do 2 i=1,nangl
      do 21 j=1,3
      if(iangl(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(iangl(i,j,1))(12:16),':',
     + sgmnam(iangl(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+iangl(i,j,1),':',
     + wnam(iangl(i,j,2))(6:10)
      endif
   21 continue
      write(lfnana,1002) (atom(j),j=1,3)
 1002 format(a11,'-',a11,'-',a11)
    2 continue
c
      do 3 i=1,ntors
      do 31 j=1,4
      if(itors(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(itors(i,j,1))(12:16),':',
     + sgmnam(itors(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+itors(i,j,1),':',
     + wnam(itors(i,j,2))(6:10)
      endif
   31 continue
      write(lfnana,1003) (atom(j),j=1,4)
 1003 format(a11,'-',a11,'-',a11,'-',a11)
    3 continue
c
      do 4 i=1,nimps
      do 41 j=1,4
      if(iimps(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(iimps(i,j,1))(12:16),':',
     + sgmnam(iimps(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+iimps(i,j,1),':',
     + wnam(iimps(i,j,2))(6:10)
      endif
   41 continue
      write(lfnana,1003) (atom(j),j=1,4)
    4 continue
c
      return
      end
c $Id: argos_diana_anahdr.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: xerbla.f 19708 2010-10-29 18:04:21Z d3y133 $
*
      SUBROUTINE XERBLA( SRNAME, INFO )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER*6        SRNAME
      INTEGER            INFO
*     ..
*
c
* $Id: xerbla.f 19708 2010-10-29 18:04:21Z d3y133 $
c
*  Purpose
*  =======
*
*  XERBLA  is an error handler for the LAPACK routines.
*  It is called by an LAPACK routine if an input parameter has an
*  invalid value.  A message is printed and execution stops.
*
*  Installers may consider modifying the STOP statement in order to
*  call system-specific exception-handling facilities.
*
*  Arguments
*  =========
*
*  SRNAME  (input) CHARACTER*6
*          The name of the routine which called XERBLA.
*
*  INFO    (input) INTEGER
*          The position of the invalid parameter in the parameter list
*          of the calling routine.
*
* =====================================================================
*
*     .. Executable Statements ..
*
      WRITE( *, FMT = 9999 )SRNAME, INFO
*
*      STOP
*      call errquit('xerbla:double: lapack error',911)
*
 9999 FORMAT( ' ** On entry to ', A6, ' parameter number ', I2, ' had ',
     $      'an illegal value' )
*
*     End of XERBLA
*
      END

      subroutine qhop_setup(mparms,nparms,matm,natm,mseq,nseq,
     + catm,latm,cseq,lseq,mbnd,nbnd,lbnd,rbnd,mang,nang,lang,rang)
c
c $Id: qhop_setup_good.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
c     input variables
c     ---------------
c
c     matm            : dimension of atom arrays
c     natm            : number of atoms
c     mseq            : dimension of residue arrays
c     nseq            : number of residues
c     nparms          : number of parameter sets
c     mparms          : number of parameter sets plus 1
c     cseq            : residue names
c     catm(1,1:natm)  : atom names
c     catm(k,1:natm)  : atom types in parameter set k-1
c     latm(5,1:natm)  : residue number
c     latm(10,1:natm) : + heavy atom attached to protonatable hydrogen
c                       - protonatable hydrogen, relative index to heavy atom
c     lseq(5,1:nseq)  : number of protonation states of residue
c     lseq(6,1:nseq)  : current protonation state of residue
c
c     mbnd            : dimension of bond index array
c     nbnd            : number of bonds
c     lbnd(1,1:nbnd)  : atom index i
c     lbnd(2,1:nbnd)  : atom index j
c
      integer matm,natm,mseq,nseq,nparms,mparms
      character*10 cseq(mseq)
      character*6 catm(mparms,matm)
      integer latm(10,matm),lseq(6,mseq)
      integer mbnd,nbnd
      integer lbnd(4,mbnd)
      real*8 rbnd(nparms,2,mbnd)
      integer mang,nang
      integer lang(5,mang)
      real*8 rang(nparms,2,mang)
c
      integer i,j,k,l,m,n
      integer mxseq,maxhv,maxpar,mxar
      parameter(mxseq=30)
      parameter(maxhv=4) 
      parameter(maxpar=10000)
      parameter(mxar=mxseq*30)
      integer numseq,numpar,mnprot,mnhv,nuseq,larat,nbnat
      integer prtin(2),flseq,flhv,nseql,eof,ptat(3)
      integer ptseq(mseq,2),numhv(mxseq),ihv,numprot(mxseq),
     + ptpar(maxpar),arat(mxar,4),ptarat(mxseq)
      integer shbit(5),nbseq,nbhv,nbpt
      real*8 deq(mxar),aneq(mxar)
      character*10 cuseq(mxseq),cseqin(2)
      character*6 chv(mxseq,maxhv),chvin(2)  
      character*80 fileinp,fileout    
c
      real*8 e12fxy(maxpar,3),defe12(maxpar,7),zpef(maxpar,6),
     + tdsgl(maxpar,6),tunnel(maxpar,7),tstval(maxpar,5) 
c
c
      fileinp='qhop.par'
      open(unit=11,file=fileinp(1:index(fileinp,' ')-1),err=112)
      fileout='qhopcmp.par'
      open(unit=12,file=fileout(1:index(fileout,' ')-1),err=113)      
c
c     Initializing variables
c
      mnprot=0
      mnhv=0
      numpar=0
      numseq=0	
      nuseq=0
      flhv=0
      flseq=0
      ptat(1)=0
      larat=0
      do 31 i=1,mxar
      do j=1,4
      arat(i,j)=0
      enddo
      deq(i)=0
      aneq(i)=0
   31 continue
      do 12 i=1,mxseq
      ptseq(i,1)=0
      ptseq(i,2)=0
      ptarat(i)=0
   12 continue
c
c     Setting pointers to static array cuseq(numseq) and calculating max
c     heavy atom #  and prot states  
c       
      do i=1,nbnd
      write(*,101)i,(lbnd(j,i),j=1,2),rbnd(1,1,i)
  101 format(3i5,f12.6)
      enddo
c
      do i=1,nang
      write(*,102)i,(lang(j,i),j=1,3),rang(1,1,i)
  102 format(4i5,f12.6)
      enddo
c	
      do 1 i=1,natm 
c
      write(*,1000) i,catm(1,i),latm(5,i),cseq(latm(5,i)),latm(10,i),
     + lseq(5,latm(5,i)),lseq(6,latm(5,i))
c
 1000 format(i5,1x,a6,1x,i5,1xa10,3i5)
c	
      if((i.gt.1.and.latm(5,i).ne.latm(5,i-1)).or.i.eq.1)then
      if(flhv.eq.1)then
      ptat(2)=i-1
      flhv=0
      endif
      ptat(3)=i
      endif
c

      if(latm(10,i).gt.0)then
      flseq=1
      j=1
      do while (j.le.numseq.and.flseq.ne.0)
      if(cuseq(j).eq.cseq(latm(5,i)))then
      flseq=0
      ptseq(latm(5,i),1)=j      
      ptseq(latm(5,i),2)=ptat(3)
      endif
      j=j+1
      enddo	
c
      if(flseq.ne.0)then           
c
      flhv=1	
      if(lseq(5,latm(5,i)).gt.mnprot)mnprot=lseq(5,latm(5,i))
      numseq=numseq+1
      nseql=latm(5,i)
      cuseq(numseq)=cseq(latm(5,i))
      ptseq(latm(5,i),1)=numseq
      ptseq(latm(5,i),2)=ptat(3)
      numhv(numseq)=1
      if(mnhv.eq.0)mnhv=1
      chv(numseq,1)=catm(1,i)
c
      if(ptat(1).gt.0)then
      ptarat(numseq-1)=larat+1
c      print 1212,'ptat',numseq,ptat(1),ptat(2)
c 1212 format(a5,3i5) 
      ihv=0
      do 13 k=ptat(1),ptat(2)
      if(latm(10,k).gt.0)ihv=ihv+1
      nbnat=0
      larat=larat+1
      do 14 j=1,nbnd
      do 28 m=1,2
      l=2**(2-m)
      if(lbnd(m,j).eq.k.and.(latm(10,k).lt.0.or.latm(10,lbnd(l,j))
     + .ge.0))then
      nbnat=nbnat+1
      arat(larat,nbnat)=lbnd(l,j)-k
c      print 1029,'check ',numseq-1,k,lbnd(l,j),arat(larat,nbnat),
c     + larat,nbnat
c 1029 format(a6,6i6)
      if(latm(10,k).lt.0)then 
      deq(larat)=rbnd(1,1,j)
      print 121,'larat ',numseq-1,k,arat(larat,1),
     + latm(10,k+arat(larat,1))
  121 format(a6,4i5)
      arat(larat,nbnat+1)=latm(10,k+arat(larat,1)) 
      arat(larat,nbnat+2)=ihv
c
      if(latm(10,k+1).ge.0)then
      do 25 n=1,-arat(larat,nbnat)
      arat(larat-n+1,nbnat+3)=-arat(larat,nbnat)
   25 continue
      endif
c
      if(arat(larat,nbnat+1).eq.1)then
      do 18 n=1,nang
      if(k.eq.50)
     + print 222,'angle ',k,lbnd(l,j),k+arat(larat,1)
     + +arat(larat+arat(larat,1),1)
  222 format(a6,1x,3i5)
      if((lang(1,n).eq.k+arat(larat,1)+arat(larat+arat(larat,1),1)
     + .and.lang(2,n).eq.lbnd(l,j).and.lang(3,n).eq.k).or.
     + (lang(3,n).eq.k+arat(larat,1)+arat(larat+arat(larat,1),1)
     + .and.lang(2,n).eq.lbnd(l,j).and.lang(1,n).eq.k))
     + aneq(larat)=rang(1,1,n) 
   18 continue
       
      endif
      endif    
      endif
   28 continue
   14 continue
   13 continue
      endif      
      ptat(1)=ptat(3)
c
      elseif(flhv.eq.1.and.latm(5,i).eq.nseql)then
      numhv(numseq)=numhv(numseq)+1
      if(numhv(numseq).gt.mnhv)mnhv=numhv(numseq)
      chv(numseq,numhv(numseq))=catm(1,i)
      else
      flhv=0
      endif
      endif
    1 continue
c
c     Writing array arat for last unique res   
c  
      if(ptat(1).ge.0)then
      ihv=0 
      ptarat(numseq)=larat+1
      do 15 k=1,ptat(2)-ptat(1)+1
      nbnat=0
      larat=larat+1
      do 16 j=1,nbnd
      do 29 m=1,2
      l=2**(m-1)
      if(lbnd(m,j).eq.k.and.(latm(10,k).lt.0.or.latm(10,lbnd(l,j))
     + .ge.0))then
      nbnat=nbnat+1
      arat(larat,nbnat)=lbnd(l,j)-k
      if(latm(10,k).lt.0)then
      deq(larat)=rbnd(1,1,j)
      arat(larat,nbnat+1)=latm(10,k+arat(larat,nbnat))
      arat(larat,nbnat+2)=ihv
   
      if(latm(10,k+1).ge.0)then
      do 23 n=1,-arat(larat,nbnat)
      arat(larat-n+1,nbnat+3)=-arat(larat,nbnat)
   23 continue
      endif

      if(arat(larat,nbnat+1).eq.1)then
      do 19 n=1,nang
      if((lang(1,n).eq.k+arat(larat,1)+arat(larat+arat(larat,1),1)
     + .and.lang(2,n).eq.lbnd(l,j).and.lang(3,n).eq.k).or.
     + (lang(3,n).eq.k+arat(larat,1)+arat(larat+arat(larat,1),1)
     + .and.lang(2,n).eq.lbnd(l,j).and.lang(1,n).eq.k))
     + aneq(larat)=rang(1,1,n) 
   19 continue
      endif
      endif       
      endif
   29 continue
   16 continue
   15 continue
      endif
c
c     Calculating number of bits for ptrs to parameter sets
c
      do while(2**nbpt.le.mnprot)
      nbpt=nbpt+1
      enddo
      do while(2**(nbhv).le.mnhv)
      nbhv=nbhv+1
      enddo
      do while(2**(nbseq).le.numseq)
      nbseq=nbseq+1
      enddo
c     
      shbit(1)=nbpt
      shbit(2)=shbit(1)+nbhv
      shbit(3)=shbit(2)+nbseq
      shbit(4)=shbit(3)+nbpt
      shbit(5)=shbit(4)+nbhv 
c      print 1011,(shbit(i),i=1,5),mnprot,mnhv,numseq
c 1011 format('shbit ',8i5)
c
c     reading in the relevant hopping parameters
c
      eof=1
      do while (eof.ge.0) 
c
      read(11,1001,end=8)cseqin(1),chvin(1),prtin(1),cseqin(2),chvin(2)
     + ,prtin(2)     
 1001 format(a10,a6,i3,10x,a10,a6,i3)
      if(cseqin(1).eq.'          ')goto 8
      read(11,1003) (e12fxy(numpar+1,i),i=1,3)
 1003 format(3f12.6)
      read(11,1004) (defe12(numpar+1,i),i=1,7)
 1004 format(3f12.6,f8.4,2f12.6,f12.8)
      read(11,1005) (zpef(numpar+1,i),i=1,6)
 1005 format(6f12.6)
      read(11,1006) (tdsgl(numpar+1,i),i=1,6)
 1006 format(6f12.6)
      read(11,1007) (tunnel(numpar+1,i),i=1,7)
 1007 format(f8.2,f8.3,f10.5,e12.3,f10.5,2e12.3)
      read(11,1008) (tstval(numpar+1,i),i=1,5)
 1008 format(f10.2,2f10.4,f10.6,f10.4)
      do 4 i=1,numseq
      if(cuseq(i).eq.cseqin(1))then  
      do 5 j=1,numseq   
      if(cuseq(j).eq.cseqin(2))then
      do 6 k=1,numhv(i)
      if(chvin(1).eq.chv(i,k))then
      do 7 l=1,numhv(j)
      if(chvin(2).eq.chv(j,l))then
c     MANCA UN CONTROLLO SUI NUMERI CHE LEGGE SUI PROT STATES
      numpar=numpar+1
      ptpar(numpar)=lshift(i,shbit(5))+lshift(k,shbit(4))+
     + lshift(prtin(1),shbit(3))+lshift(j,shbit(2))+
     + lshift(l,shbit(1))+prtin(2) 
c      write(12,1030) cseqin(1),chvin(1),prtin(1),cseqin(2),chvin(2)
c     + ,prtin(2),ptpar(numpar)
c 1030 format(a10,a6,i3,10x,a10,a6,i3,i10)
c      write(12,1009) i,k,prtin(1),j,l,prtin(2)
c      write(12,1003)(e12fxy(numpar,m),m=1,3)     	
c      write(12,1004)(defe12(numpar,m),m=1,7)
c      write(12,1005)(zpef(numpar,m),m=1,6)
c      write(12,1006)(tdsgl(numpar,m),m=1,6)
c      write(12,1007)(tunnel(numpar,m),m=1,7)
c      write(12,1008)(tstval(numpar,m),m=1,5)
 1009 format(3i7,5x,3i7)
      else
c     ERR HEAVY ATOM2 NOT FIND 
      endif
    7 continue
      else 
c     ERR HEAVY ATOM1 NOT FIND   
      endif
    6 continue	 
      endif
    5 continue	
      endif
    4 continue
      enddo      
    8 continue
c    
      do 9 i=1,nseq
      if(ptseq(i,1).ne.0)nuseq=nuseq+1
    9 continue
c
      write(12,1014)numseq,larat,numpar
 1014 format(2i5,i10)
c
      do 11 i=1,nseq
      write(12,1010) i,cseq(i),(ptseq(i,j),j=1,2)
 1010 format(i5,1x,a10,2i5)
   11 continue
c
      do 21 i=1,numseq
      write(12,1020) i,cuseq(i),ptarat(i)
 1020 format(i5,1x,a10,1x,i5)
   21 continue
c
      do 22 i=1,larat
      write(12,1021) i,(arat(i,j),j=1,4), deq(i),aneq(i)  
 1021 format(i5,4i4,2f8.4)
   22 continue
c
      do 10 i=1,numpar 
      write(12,1015)ptpar(i)
      write(12,1003)(e12fxy(i,m),m=1,3)     	
      write(12,1004)(defe12(i,m),m=1,7)
      write(12,1005)(zpef(i,m),m=1,6)
      write(12,1006)(tdsgl(i,m),m=1,6)
      write(12,1007)(tunnel(i,m),m=1,7)
      write(12,1008)(tstval(i,m),m=1,5)
   10 continue  
 1015 format(i10)
c
      close(11)
      close(12)         
      return
c
  112 write(*,1030) 'err opening input file'
 1030 format(a40)
      return
  113 write(*,1030) 'err opening output file'
      return
      end

      subroutine argos_zinit(iwz,isz)
c
      implicit none
c
#include "argos.fh"
c
      integer iwz(mwm),isz(msa)
c
      integer i
c
      do 1 i=1,mwm
      iwz(i)=0
    1 continue
c
      do 2 i=1,msa
      isz(i)=0
    2 continue
c
      return
      end
c $Id: argos_zinit.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function sym_atom(geom, iat, q1)
      implicit none
      integer geom              ! Geometry handle [input]
      integer iat               ! Atom index [input]
      double precision q1       ! Constituency number [output]
c
c     Return true if (iatom) is the lexically highest atom
c     symmetry equivalent atoms. If true also return the
c     constituency factor q1 (= no. of symmetry equivalent atoms)
c
c     As an optimization inline sym_center_map ... the only reason
c     geomP.fh and mafdecls.fh are included here ... the interface
c     is compatible with that of the actual routine.
c
#include "nwc_const.fh"
#include "geomP.fh"
#include "mafdecls.fh"
      integer iat_new
      integer nops, op
      integer n                 ! Counts no. of equivalent pairs
      integer sym_number_ops, sym_center_map_inline
      external sym_number_ops
#include "itri.fh"
      sym_center_map_inline(geom,iat,op) = int_mb(op - 1 + 
     $     sym_center_map_index(geom) + (iat-1)*sym_num_ops(geom))
c
      q1 = 0.0d0
      sym_atom = .false.
c
c     Loop thru operations in the group and map to new pairs
c
      nops = sym_number_ops(geom)
      n = 1                     ! Identity always counts
      do op = 1, nops
c
c     Map centers
c
         iat_new = sym_center_map_inline(geom, iat, op)
c
c     Compare index
c
         if (iat .lt. iat_new) then
            return
         else if (iat .eq. iat_new) then
            n = n + 1
         endif
      end do
c
      q1 = dble(nops + 1) / dble(n)
      sym_atom = .true.
c
      end
      logical function sym_shell(basis, ishell, q1)
C$Id: sym_sh_pair.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
#include "bas.fh"
#include "geom.fh"      
#include "global.fh"
      integer basis             ! Basis set handle [input]
      integer ishell            ! Shell index [input]
      double precision q1       ! Constituency number [output]
c
c     Return true if (ishell) is the lexically highest shell
c     of symmetry equivalent shells. If true, also return the
c     constituency factor q1 (= no. of symmetry equivalent shells).
c
      integer ice
      integer geom
      logical sym_atom
      external sym_atom
c
      sym_shell = .false.
c
c     Get geometry handle, centers where shells are located and
c     number of group operations
c
      if (.not. bas_geom(basis, geom)) call errquit
     $     ('sym_shell: bas_geom?', 0, BASIS_ERR)
      if (.not. bas_cn2ce(basis, ishell, ice)) call errquit
     $     ('sym_shell_pair: bas_cn2ce', ishell, BASIS_ERR)
c
      sym_shell = sym_atom(geom, ice, q1)
c
      end
      logical function sym_shell_pair(basis, ishell, jshell, q2)
C$Id: sym_sh_pair.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
#include "bas.fh"
#include "geom.fh"      
#include "global.fh"
      integer basis             ! Basis set handle [input]
      integer ishell, jshell    ! Shell indices [input]
      double precision q2       ! Constituency number [output]
c
c     Return true if (ishell,jshell) is the lexically highest
c     pair of symmetry equivalent shells. If true, also return the
c     constituency factor q2 (= no. of symmetry equivalent pairs).
c
c     This routine uses the exchange symmetry ishell <-> jshell
c     and incorporates a factor of two into q2 to account for
c     this.
c
      integer ice, jce
      integer geom
      logical sym_atom_pair
      external sym_atom_pair
c
      sym_shell_pair = .false.
      if (ishell.lt.jshell) return
c
c     Get geometry handle, centers where shells are located and
c     number of group operations
c

*      write(6,*) ' sym_shell_pair ', ga_nodeid(), ishell, jshell
*      call util_flush(6)
*      call ga_sync()

      if (.not. bas_geom(basis, geom)) call errquit
     $     ('sym_shell_pair: bas_geom?', 0, BASIS_ERR)
      if (.not. bas_cn2ce(basis, ishell, ice)) call errquit
     $     ('sym_shell_pair: bas_cn2ce', ishell, BASIS_ERR)
      if (.not. bas_cn2ce(basis, jshell, jce)) call errquit
     $     ('sym_shell_pair: bas_cn2ce', jshell, BASIS_ERR)
c
*      write(6,*) ' sym_shell_pair centers', ga_nodeid(), ice, jce
*      call util_flush(6)
*      call ga_sync()
c
      sym_shell_pair = sym_atom_pair(geom, ice, jce, q2)
      if (ishell .ne. jshell) q2 = q2 + q2
c
*      write(6,*) ' sym_shell_pair return ', ga_nodeid(),
*     $     sym_shell_pair, q2
*      call util_flush(6)
*      call ga_sync()
c
      end
      logical function sym_atom_pair(geom, iat, jat, q2)
      implicit none
      integer geom              ! Geometry handle [input]
      integer iat, jat          ! Atom indices [input]
      double precision q2       ! Constituency number [output]
c
c     Return true if (iatom,jatom) is the lexically highest
c     pair of symmetry equivalent atom. If true also return the
c     constituency factor q2 (= no. of symmetry equivalent pairs)
c
c     This routine uses the exchange symmetry iat <-> jat
c     but does not incorporate any factors into q2 to account for
c     this (q2 is point group symmetry only). 
c
c     As an optimization inline sym_center_map ... the only reason
c     geomP.fh and mafdecls.fh are included here ... the interface
c     is compatible with that of the actual routine.
c
#include "nwc_const.fh"
#include "geomP.fh"
#include "mafdecls.fh"
      integer iat_new, jat_new, ijat, ijat_new
      integer nops, op
      integer n                 ! Counts no. of equivalent pairs
      integer sym_number_ops, sym_center_map_inline
      external sym_number_ops
#include "itri.fh"
      sym_center_map_inline(geom,iat,op) = int_mb(op - 1 + 
     $     sym_center_map_index(geom) + (iat-1)*sym_num_ops(geom))
c
      q2 = 0.0d0
      sym_atom_pair = .false.
      if (iat .lt. jat) return
      ijat = itri(iat,jat)
c
c     Loop thru operations in the group and map to new pairs
c
      nops = sym_number_ops(geom)
      n = 1                     ! Identity always counts
      do op = 1, nops
c
c     Map centers
c
         iat_new = sym_center_map_inline(geom, iat, op)
         jat_new = sym_center_map_inline(geom, jat, op)
c
c     Compare canonical indices
c
         ijat_new = itri(iat_new, jat_new)
         if (ijat .lt. ijat_new) then
            return
         else if (ijat .eq. ijat_new) then
            n = n + 1
         endif
      end do
c
      q2 = dble(nops + 1) / dble(n)
      sym_atom_pair = .true.
c
      end
      logical function sym_atom_quartet(geom, iat, jat, kat, lat, q4)
      implicit none
      integer geom              ! Geometry handle [input]
      integer iat, jat, kat, lat ! Atom indices [input]
      double precision q4       ! Constituency number [output]
c
c     Return true if (iatom,jatom,katom,latom) is the lexically highest
c     quartet of symmetry equivalent atoms. If true also return the
c     constituency factor q4 (= no. of symmetry equivalent quartets)
c
c     This routine uses the standard three exchange symmetries
c
c     (iat<->jat) <-> (kat<->lat)
c
c     ... it is easy to extend it to not use these
c
#include "nwc_const.fh"
#include "geomP.fh"
#include "mafdecls.fh"
      integer iat_new, jat_new, kat_new, lat_new
      integer nops, op, ij, kl, ijkl, ijkl_new, ij_new, kl_new
      integer n                 ! Counts no. of equivalent pairs
      integer sym_number_ops, sym_center_map_inline
      external sym_number_ops
#include "itri.fh"
      sym_center_map_inline(geom,iat,op) = int_mb(op - 1 + 
     $     sym_center_map_index(geom) + (iat-1)*sym_num_ops(geom))
c
      sym_atom_quartet = .false.
c
c     Assume that the code is looping thru a unique set of 
c     indices but maybe not with conventional canonical order
c     ... so don't do the canonical check here
*      if (iat .lt. jat) return  ! Labels must be in canonical order
*      if (iat .lt. kat) return
*      if (kat .lt. lat) return
*      if (iat .eq. kat .and. jat .lt. lat) return
c
      q4 = 0.0d0
      ij   = itri(iat,jat)
      kl   = itri(kat,lat)
      ijkl = itri(ij, kl)
c
c     Loop thru operations in the group and map to new pairs
c
      nops = sym_number_ops(geom)
      n = 1                     ! Identity always counts
      do op = 1, nops
c
c     Map centers
c
         iat_new = sym_center_map_inline(geom, iat, op)
         jat_new = sym_center_map_inline(geom, jat, op)
         kat_new = sym_center_map_inline(geom, kat, op)
         lat_new = sym_center_map_inline(geom, lat, op)
c
c     Compare canonical indices
c
         ij_new   = itri(iat_new,jat_new)
         kl_new   = itri(kat_new,lat_new)
         ijkl_new = itri(ij_new, kl_new)
c
         if (ijkl .lt. ijkl_new) then
            return
         else if (ijkl .eq. ijkl_new) then
            n = n + 1
         endif
      end do
c
      q4 = dble(nops + 1) / dble(n)
      sym_atom_quartet = .true.
c
      end
      logical function sym_shell_quartet(basis,
     $     ishell, jshell, kshell, lshell, q4)
      implicit none
#include "errquit.fh"
#include "bas.fh"
#include "geom.fh"      
#include "global.fh"
      integer basis             ! Basis set handle [input]
      integer ishell, jshell    ! Shell indices [input]
      integer kshell, lshell    ! Shell indices [input]
      double precision q4       ! Constituency number [output]
c
      integer ice, jce, kce, lce
      integer geom
      logical sym_atom_gen_quartet
      external sym_atom_gen_quartet
c
      q4 = 0.0d0
      sym_shell_quartet = .false.
      if (ishell.lt.jshell) return
      if (kshell.lt.lshell) return
c
c     Get geometry handle, centers where shells are located and
c     number of group operations
c
      if (.not. bas_geom(basis, geom)) call errquit
     $     ('sym_shell_pair: bas_geom?', 0, BASIS_ERR)
      if (.not. bas_cn2ce(basis, ishell, ice)) call errquit
     $     ('sym_shell_pair: bas_cn2ce', ishell, BASIS_ERR)
      if (.not. bas_cn2ce(basis, jshell, jce)) call errquit
     $     ('sym_shell_pair: bas_cn2ce', jshell, BASIS_ERR)
      if (.not. bas_cn2ce(basis, kshell, kce)) call errquit
     $     ('sym_shell_pair: bas_cn2ce', kshell, BASIS_ERR)
      if (.not. bas_cn2ce(basis, lshell, lce)) call errquit
     $     ('sym_shell_pair: bas_cn2ce', lshell, BASIS_ERR)
c
      sym_shell_quartet = sym_atom_gen_quartet(
     $     geom, ice, jce, kce, lce, q4)
c
      end
      logical function sym_atom_gen_quartet(geom,
     $     iat, jat, kat, lat, q4)
      implicit none
#include "errquit.fh"
      integer geom              ! Geometry handle [input]
      integer iat, jat, kat, lat ! Atom indices [input]
      double precision q4       ! Constituency number [output]
c
#include "nwc_const.fh"
#include "geomP.fh"
#include "mafdecls.fh"
      integer iat_new, jat_new, kat_new, lat_new
      integer nops, op, ij, kl, ij_new, kl_new
      integer n                 ! Counts no. of equivalent pairs
      integer sym_number_ops, sym_center_map_inline
      external sym_number_ops
#include "itri.fh"
      sym_center_map_inline(geom,iat,op) = int_mb(op - 1 + 
     $     sym_center_map_index(geom) + (iat-1)*sym_num_ops(geom))
c
      q4 = 0.0d0
      sym_atom_gen_quartet = .false.
c
      if (iat .lt. jat) return  ! Labels must be in canonical order
      if (kat .lt. lat) return
c
      ij   = itri(iat,jat)
      kl   = itri(kat,lat)
c
c     Loop thru operations in the group and map to new pairs
c
      nops = sym_number_ops(geom)
      n = 1                     ! Identity always counts
      do op = 1, nops
c
c     Map centers
c
         iat_new = sym_center_map_inline(geom, iat, op)
         jat_new = sym_center_map_inline(geom, jat, op)
         kat_new = sym_center_map_inline(geom, kat, op)
         lat_new = sym_center_map_inline(geom, lat, op)
c
c     Compare canonical indices
c
         ij_new   = itri(iat_new,jat_new)
         kl_new   = itri(kat_new,lat_new)
c
         if (ij .lt. ij_new) return
         if (ij.eq.ij_new .and. kl.lt.kl_new) return
         if (ij.eq.ij_new .and. kl.eq.kl_new) then
            n = n + 1
         endif
      end do
c
      q4 = dble(nops+1) / dble(n)
      if (abs(q4-nint(q4)).gt.1e-12) call errquit
     $     ('sym_atom_gen_quartet: not divisible', 0, BASIS_ERR)
      sym_atom_gen_quartet = .true.
c
      end

       subroutine dens_prod(nbf,ilo,ihi,jlo,jhi,klo,khi,llo,lhi,
     &                     ish,jsh,ksh,lsh, norm,GG,ng,blen,
     &                     pa_ij,pa_kl,pa_ji,pa_lk,pa_il,pa_kj,
     &                     pa_jl,pa_ki,pa_ik,pa_lj,pa_jk,pa_li, 
     &                     pb_ij,pb_kl,pb_ji,pb_lk,pb_il,pb_kj,
     &                     pb_jl,pb_ki,pb_ik,pb_lj,pb_jk,pb_li) 
       implicit none
c
c  this routine multiplies the densities and forms the array GG
c  (a product of densities) and calculates the maximum value, which
c  is used as a screening parameter.
c
c      ilo,ihi,jlo,jhi,klo,khi,llo,lhi - bf index ranges [input]
c      ish,jsh,ksh,lsh - shell indixes                   [input]
c      pa,pb - alpha and beta densities                  [input]
c      norm                                              [output]
c      GG - densit products                              [output]
c      ng - number of elements in GG                     [output]
c 
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "apiP.fh"
#include "bas.fh"
#include "geom.fh"
c
       integer nbf,ng
       integer i,j,k,l, ii,jj,kk,ll
       integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi 
       integer ish, jsh, ksh, lsh
       integer maxj, maxk, maxl, blen
       double precision Gijkl,Gjikl,Gijlk,Gjilk
       double precision Gilkj,Giklj,Gjlki,Gjkli
       double precision GGijkl,GGilkj
       double precision dij,dkl,dijkl
       double precision delta
       double precision GG(10000), dabsmax, norm
       double precision pa_ij(blen,blen),pa_kl(blen,blen)
       double precision pa_ji(blen,blen),pa_lk(blen,blen)
       double precision pa_il(blen,blen),pa_kj(blen,blen)
       double precision pa_jl(blen,blen),pa_ki(blen,blen)
       double precision pa_ik(blen,blen),pa_lj(blen,blen)
       double precision pa_jk(blen,blen),pa_li(blen,blen)
       double precision pb_ij(blen,blen),pb_kl(blen,blen) 
       double precision pb_ji(blen,blen),pb_lk(blen,blen)
       double precision pb_il(blen,blen),pb_kj(blen,blen)
       double precision pb_jl(blen,blen),pb_ki(blen,blen)
       double precision pb_ik(blen,blen),pb_lj(blen,blen)
       double precision pb_jk(blen,blen),pb_li(blen,blen)
       external dabsmax
c
c
c  initialize ng
c  =============
c
       ng = 0
c
c  loop over bf indices
c  ====================
c
      do i = ilo, ihi
c
          maxj = jhi
          if(jsh.eq.ish) maxj = i
          do j = jlo, maxj
c
            maxk = khi
            if(ksh.eq.ish.AND.jsh.eq.lsh) maxk = i
            do k = klo, maxk
c
              maxl = lhi
              if(lsh.eq.ksh) maxl = k
              if(ish.eq.ksh.AND.jsh.eq.lsh.AND.k.eq.i) maxl=j
              do l = llo, maxl
c
              ii = i - ilo+1
              jj = j - jlo+1
              kk = k - klo+1
              ll = l - llo+1
c
                Gijkl =   pa_ij(ii,jj)*pa_kl(kk,ll)
     &                  + pa_ij(ii,jj)*pb_kl(kk,ll)
     &                  + pb_ij(ii,jj)*pa_kl(kk,ll)
     &                  + pb_ij(ii,jj)*pb_kl(kk,ll)
c
                Gjikl =   pa_ji(jj,ii)*pa_kl(kk,ll)
     &                  + pa_ji(jj,ii)*pb_kl(kk,ll)
     &                  + pb_ji(jj,ii)*pa_kl(kk,ll)
     &                  + pb_ji(jj,ii)*pb_kl(kk,ll)
c
                Gijlk =   pa_ij(ii,jj)*pa_lk(ll,kk)
     &                  + pa_ij(ii,jj)*pb_lk(ll,kk)
     &                  + pb_ij(ii,jj)*pa_lk(ll,kk)
     &                  + pb_ij(ii,jj)*pb_lk(ll,kk)
c
                Gjilk =   pa_ji(jj,ii)*pa_lk(ll,kk)
     &                  + pa_ji(jj,ii)*pb_lk(ll,kk)
     &                  + pb_ji(jj,ii)*pa_lk(ll,kk)
     &                  + pb_ji(jj,ii)*pb_lk(ll,kk)
c
                Gilkj = - pa_il(ii,ll)*pa_kj(kk,jj)
     &                  - pb_il(ii,ll)*pb_kj(kk,jj)
c
                Gjlki = - pa_jl(jj,ll)*pa_ki(kk,ii)
     &                  - pb_jl(jj,ll)*pb_ki(kk,ii)
c
                Giklj = - pa_ik(ii,kk)*pa_lj(ll,jj)
     &                  - pb_ik(ii,kk)*pb_lj(ll,jj)
c
                Gjkli = - pa_jk(jj,kk)*pa_li(ll,ii)
     &                  - pb_jk(jj,kk)*pb_li(ll,ii)
c
                dij = 0.0d0 
                if (i.eq.j) dij = 1.0d0
c
                dkl = 0.0d0 
                if (k.eq.l) dkl = 1.0d0
c
                dijkl = 0.0d0
                if (i.eq.k.AND.j.eq.l) dijkl = 1.0d0
c
                delta = (1.0d0+dij)*(1.0d0+dkl)
c
                GGijkl = Gijkl + Gjikl + Gijlk + Gjilk
                GGilkj = Gjlki + Gilkj + Gjkli + Giklj
c
                ng = ng + 1
                GG(ng)  = 2.0d0*((GGijkl + GGilkj)/delta)/(1.0d0+dijkl)
c
               enddo
            enddo
         enddo
      enddo
c
      norm = dabsmax(ng,GG)
c
      return
      end


c $Id: et_dens_prod.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdtq_t3_9(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: ccsdtq_t3_9.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = -1/2 * P( 3 ) * Sum ( h8 h9 p7 ) * t ( p4 p5 p6 p7 h1 h2 h8 h9 )_t * i1 ( h8 h9 h3 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h8b
      INTEGER h9b
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p7b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h8b_1
      INTEGER h9b_1
      INTEGER h8b_2
      INTEGER h9b_2
      INTEGER h3b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p4b = noab+1,noab+nvab
      DO p5b = p4b,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+p6b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_t3_9',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO h8b = 1,noab
      DO h9b = h8b,noab
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)
     &+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-
     &1)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+p6b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h8b-1),int_mb(k_sym+h9b-1)
     &))))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_8(p4b,p5b,p6b,p7b,h1b,h2b,h8b,h9b,p4b_1,p5b_1,
     &p6b_1,p7b_1,h1b_1,h2b_1,h8b_1,h9b_1)
      CALL TCE_RESTRICTED_4(h8b,h9b,h3b,p7b,h8b_2,h9b_2,h3b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+h8b-1) * int_m
     &b(k_range+h9b-1)
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb
     &(k_range+p6b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_t3_9',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_t3_9',2,MA_ERR)
      IF ((p7b .lt. p4b) .and. (h9b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),8,7,4,3,2,6,5,1,-1.0d0)
      END IF
      IF ((p7b .lt. p4b) .and. (h8b .lt. h1b) .and. (h1b .le. h9b) .and.
     & (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,6,4,3,2,7,5,1,1.0d0)
      END IF
      IF ((p7b .lt. p4b) .and. (h8b .lt. h1b) .and. (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,6,4,3,2,8,5,1,-1.0d0)
      END IF
      IF ((p7b .lt. p4b) .and. (h1b .le. h8b) .and. (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,5,4,3,2,7,6,1,-1.0d0)
      END IF
      IF ((p7b .lt. p4b) .and. (h1b .le. h8b) .and. (h8b .lt. h2b) .and.
     & (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,5,4,3,2,8,6,1,1.0d0)
      END IF
      IF ((p7b .lt. p4b) .and. (h2b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),6,5,4,3,2,8,7,1,-1.0d0)
      END IF
      IF ((p4b .le. p7b) .and. (p7b .lt. p5b) .and. (h9b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p7b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),8,7,4,3,1,6,5,2,1.0d0)
      END IF
      IF ((p4b .le. p7b) .and. (p7b .lt. p5b) .and. (h8b .lt. h1b) .and.
     & (h1b .le. h9b) .and. (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p7b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,6,4,3,1,7,5,2,-1.0d0)
      END IF
      IF ((p4b .le. p7b) .and. (p7b .lt. p5b) .and. (h8b .lt. h1b) .and.
     & (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p7b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,6,4,3,1,8,5,2,1.0d0)
      END IF
      IF ((p4b .le. p7b) .and. (p7b .lt. p5b) .and. (h1b .le. h8b) .and.
     & (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p7b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,5,4,3,1,7,6,2,1.0d0)
      END IF
      IF ((p4b .le. p7b) .and. (p7b .lt. p5b) .and. (h1b .le. h8b) .and.
     & (h8b .lt. h2b) .and. (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p7b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,5,4,3,1,8,6,2,-1.0d0)
      END IF
      IF ((p4b .le. p7b) .and. (p7b .lt. p5b) .and. (h2b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p7b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),6,5,4,3,1,8,7,2,1.0d0)
      END IF
      IF ((p5b .le. p7b) .and. (p7b .lt. p6b) .and. (h9b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),8,7,4,2,1,6,5,3,-1.0d0)
      END IF
      IF ((p5b .le. p7b) .and. (p7b .lt. p6b) .and. (h8b .lt. h1b) .and.
     & (h1b .le. h9b) .and. (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,6,4,2,1,7,5,3,1.0d0)
      END IF
      IF ((p5b .le. p7b) .and. (p7b .lt. p6b) .and. (h8b .lt. h1b) .and.
     & (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,6,4,2,1,8,5,3,-1.0d0)
      END IF
      IF ((p5b .le. p7b) .and. (p7b .lt. p6b) .and. (h1b .le. h8b) .and.
     & (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,5,4,2,1,7,6,3,-1.0d0)
      END IF
      IF ((p5b .le. p7b) .and. (p7b .lt. p6b) .and. (h1b .le. h8b) .and.
     & (h8b .lt. h2b) .and. (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,5,4,2,1,8,6,3,1.0d0)
      END IF
      IF ((p5b .le. p7b) .and. (p7b .lt. p6b) .and. (h2b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),6,5,4,2,1,8,7,3,-1.0d0)
      END IF
      IF ((p6b .le. p7b) .and. (h9b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),8,7,3,2,1,6,5,4,1.0d0)
      END IF
      IF ((p6b .le. p7b) .and. (h8b .lt. h1b) .and. (h1b .le. h9b) .and.
     & (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,6,3,2,1,7,5,4,-1.0d0)
      END IF
      IF ((p6b .le. p7b) .and. (h8b .lt. h1b) .and. (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 +
     & noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,6,3,2,1,8,5,4,1.0d0)
      END IF
      IF ((p6b .le. p7b) .and. (h1b .le. h8b) .and. (h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h2b-1),8,5,3,2,1,7,6,4,1.0d0)
      END IF
      IF ((p6b .le. p7b) .and. (h1b .le. h8b) .and. (h8b .lt. h2b) .and.
     & (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h9b-1),7,5,3,2,1,8,6,4,-1.0d0)
      END IF
      IF ((p6b .le. p7b) .and. (h2b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),6,5,3,2,1,8,7,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_t3_9',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_t3_9',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_t3_9',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (h3b_2 - 1 + noab * (h9b_2 - 1 + noab * (h8b_
     &2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h3b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_t3_9',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h8b .eq. h9b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_t3_9',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_t3_9',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_t3_9',9,MA_ERR)
      IF ((h2b .le. h3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,5,4,3,2,1,-1.0d0/2.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (p6b - noab - 1 + 
     &nvab * (p5b - noab - 1 + nvab * (p4b - noab - 1)))))))
      END IF
      IF ((h3b .le. h1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,5,4,1,3,2,-1.0d0/2.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * (p6b - noab - 1 + 
     &nvab * (p5b - noab - 1 + nvab * (p4b - noab - 1)))))))
      END IF
      IF ((h1b .le. h3b) .and. (h3b .le. h2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,5,4,3,1,2,1.0d0/2.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * (p6b - noab - 1 + 
     &nvab * (p5b - noab - 1 + nvab * (p4b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_t3_9',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_t3_9',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_space_numbb(ibownr,boxsiz)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
#include "util.fh"
c
      integer ibownr(maxbox,3)
      real*8 boxsiz(maxbox,3)
      logical lside,leven
c
      integer ibx,iby,ibz,ipx,ipy,ipz,ibox,inode
      integer jbx,jby,jbz,kbx,kby,kbz,jpx,jpy,jpz
      integer ilx,ihx,ily,ihy,ilz,ihz
      integer jbox,jnode,mbblb,i
      real*8 dx,dxtmp,dy,dytmp,dz,dztmp,dist2
      character*255 string
c
      if(iand(idebug,2).eq.2) then
      write(lfndbg,'(a,i6)') 'boxsiz in argos_space_numbb'
      write(lfndbg,'(6f12.6)') (boxsiz(i,1),i=1,nbx)
      write(lfndbg,'(6f12.6)') (boxsiz(i,2),i=1,nby)
      write(lfndbg,'(6f12.6)') (boxsiz(i,3),i=1,nbz)
      call util_flush(lfndbg)
      endif
c
c     determine size of box-box pairlist
c     ----------------------------------
c
      mbbl=0
      mbblb=0
      do 1 ibx=0,nbx-1
      ipx=ibownr(ibx+1,1)
      do 2 iby=0,nby-1
      ipy=ibownr(iby+1,2)
      do 3 ibz=0,nbz-1
      ipz=ibownr(ibz+1,3)
      ibox=(ibz*nby+iby)*nbx+ibx
      inode=(ipz*npy+ipy)*npx+ipx
      if(inode.eq.me) then
      do 4 jbx=0,nbx-1
      kbx=jbx-ibx
      jpx=ibownr(jbx+1,1)
c
      if(ibx.le.jbx) then
      ilx=ibx
      ihx=jbx
      else
      ilx=jbx
      ihx=ibx
      endif
c
      dx=zero
      if(ibx.ne.jbx) then
      dx=boxsiz(ihx,1)-boxsiz(ilx+1,1)
      if(npbtyp.gt.0) then
      dxtmp=zero
      if(ilx.gt.0) dxtmp=boxsiz(ilx,1)
      if(ihx.lt.nbx-1) dxtmp=dxtmp-boxsiz(ihx+1,1)+box(1)
      if(dxtmp.lt.dx) dx=dxtmp
      if(kbx.gt.0.and.kbx.gt.iabs(kbx-nbx)) kbx=kbx-nbx
      if(kbx.lt.0.and.-kbx.gt.iabs(kbx+nbx)) kbx=kbx+nbx
      endif
      endif
c
      do 5 jby=0,nby-1
      kby=jby-iby
      jpy=ibownr(jby+1,2)
c
      if(iby.le.jby) then
      ily=iby
      ihy=jby
      else
      ily=jby
      ihy=iby
      endif
c
      dy=zero
      if(iby.ne.jby) then
      dy=boxsiz(ihy,2)-boxsiz(ily+1,2)
      if(npbtyp.gt.0) then
      dytmp=zero
      if(ily.gt.0) dytmp=boxsiz(ily,2)
      if(ihy.lt.nby-1) dytmp=dytmp-boxsiz(ihy+1,2)+box(2)
      if(dytmp.lt.dy) dy=dytmp
      if(kby.gt.0.and.kby.gt.iabs(kby-nby)) kby=kby-nby
      if(kby.lt.0.and.-kby.gt.iabs(kby+nby)) kby=kby+nby
      endif
      endif
c
      do 6 jbz=0,nbz-1
      kbz=jbz-ibz
      jpz=ibownr(jbz+1,3)
c
      if(ibz.le.jbz) then
      ilz=ibz
      ihz=jbz
      else
      ilz=jbz
      ihz=ibz
      endif
c
      dz=zero
      if(ibz.ne.jbz) then
      dz=boxsiz(ihz,3)-boxsiz(ilz+1,3)
      if(npbtyp.eq.1) then
      dztmp=zero
      if(ilz.gt.0) dztmp=boxsiz(ilz,3)
      if(ihz.lt.nbz-1) dztmp=dztmp-boxsiz(ihz+1,3)+box(3)
      if(dztmp.lt.dz) dz=dztmp
      if(kbz.gt.0.and.kbz.gt.iabs(kbz-nbz)) kbz=kbz-nbz
      if(kbz.lt.0.and.-kbz.gt.iabs(kbz+nbz)) kbz=kbz+nbz
      endif
      endif
c
      jbox=(jbz*nby+jby)*nbx+jbx
      jnode=(jpz*npy+jpy)*npx+jpx
c
c     determine orientation jbox in relation to ibox
c
c     lside is true if
c
c     i: 0  j: 0  k:  +
c     i: 0  j:  + k:-0+
c     i:  + j:-0+ k:-0+
c
      lside=(kbx.eq.0.and.kby.eq.0.and.kbz.ge.0)
     + .or.(kbx.eq.0.and.kby.gt.0) .or. kbx.gt.0
c
c     determine if ibox is identical to jbox
c
c     lsame=kbx.eq.0.and.kby.eq.0.and.kbz.eq.0
c
c     determine if difference in box numbers is even or odd
c
      leven=2*(iabs(ibox-jbox)/2).eq.iabs(ibox-jbox)
c
c     calculate the distance between the two boxes
c
      if(nbxtyp.eq.1) then
      dist2=
     + (vlat(1,1)*dx/box(1)+vlat(1,2)*dy/box(2)+vlat(1,3)*dz/box(3))**2+
     + (vlat(2,1)*dx/box(1)+vlat(2,2)*dy/box(2)+vlat(2,3)*dz/box(3))**2+
     + (vlat(3,1)*dx/box(1)+vlat(3,2)*dy/box(2)+vlat(3,3)*dz/box(3))**2
      else
      dist2=dx*dx+dy*dy+dz*dz
      endif
c
c     keep half of the box pairs
c
c     this test also appears in argos_space_numbb
c     any changes need to be made in both routines
c
      if((inode.eq.jnode.and.ibox.ge.jbox).or.(inode.ne.jnode.and.
     + ((lside.and.leven).or.(.not.lside.and..not.leven)))) then
c
c     keep only those within maximum cutoff distance
c
      if(rbbl*rbbl.gt.dist2) mbbl=mbbl+1
      endif
      if(rbbl*rbbl.gt.dist2) mbblb=mbblb+1
 6    continue
 5    continue
 4    continue
      endif
 3    continue
 2    continue
 1    continue
c
      mbbl=mbbl+1
      if(mbblb+1.gt.mbbl) mbbl=mbblb+1
c
      if(np.gt.1) call ga_igop(msp_20,mbbl,1,'max')
      if(me.eq.0) then
      if(util_print('distribution',print_debug)) then
      write(lfnout,2001) mbbl
 2001 format(' Dimension of the cell-cell list is ',i7)
      endif
      endif
c
c     determine size of box-box pairlist assuming minimum cell sizes
c     --------------------------------------------------------------
c
      mbbl=0
      mbblb=0
      do 11 ibx=0,nbx-1
      ipx=ibownr(ibx+1,1)
      do 12 iby=0,nby-1
      ipy=ibownr(iby+1,2)
      do 13 ibz=0,nbz-1
      ipz=ibownr(ibz+1,3)
      ibox=(ibz*nby+iby)*nbx+ibx
      inode=(ipz*npy+ipy)*npx+ipx
      if(inode.eq.me) then
      do 14 jbx=0,nbx-1
      kbx=jbx-ibx
      jpx=ibownr(jbx+1,1)
c
      if(ibx.le.jbx) then
      ilx=ibx
      ihx=jbx
      else
      ilx=jbx
      ihx=ibx
      endif
c
      dx=zero
      if(ibx.ne.jbx) then
      dx=dble(ihx-ilx-1)*bxmin
      if(npbtyp.gt.0) then
      dxtmp=zero
      if(ilx.gt.0) dxtmp=dble(ilx)*bxmin
      if(ihx.lt.nbx-1) dxtmp=dxtmp+dble(nbx-ihx-1)*bxmin
      if(dxtmp.lt.dx) dx=dxtmp
      if(kbx.gt.0.and.kbx.gt.iabs(kbx-nbx)) kbx=kbx-nbx
      if(kbx.lt.0.and.-kbx.gt.iabs(kbx+nbx)) kbx=kbx+nbx
      endif
      endif
c
      do 15 jby=0,nby-1
      kby=jby-iby
      jpy=ibownr(jby+1,2)
c
      if(iby.le.jby) then
      ily=iby
      ihy=jby
      else
      ily=jby
      ihy=iby
      endif
c
      dy=zero
      if(iby.ne.jby) then
      dy=dble(ihy-ily-1)*bymin
      if(npbtyp.gt.0) then
      dytmp=zero
      if(ily.gt.0) dytmp=dble(ily)*bymin
      if(ihy.lt.nby-1) dytmp=dytmp+dble(nby-ihy-1)*bymin
      if(dytmp.lt.dy) dy=dytmp
      if(kby.gt.0.and.kby.gt.iabs(kby-nby)) kby=kby-nby
      if(kby.lt.0.and.-kby.gt.iabs(kby+nby)) kby=kby+nby
      endif
      endif
c
      do 16 jbz=0,nbz-1
      kbz=jbz-ibz
      jpz=ibownr(jbz+1,3)
c
      if(ibz.le.jbz) then
      ilz=ibz
      ihz=jbz
      else
      ilz=jbz
      ihz=ibz
      endif
c
      dz=zero
      if(ibz.ne.jbz) then
      dz=dble(ihz-ilz-1)*bzmin
      if(npbtyp.eq.1) then
      dztmp=zero
      if(ilz.gt.0) dztmp=dble(ilz)*bzmin
      if(ihz.lt.nbz-1) dztmp=dztmp-dble(nbz-ihz-1)*bzmin
      if(dztmp.lt.dz) dz=dztmp
      if(kbz.gt.0.and.kbz.gt.iabs(kbz-nbz)) kbz=kbz-nbz
      if(kbz.lt.0.and.-kbz.gt.iabs(kbz+nbz)) kbz=kbz+nbz
      endif
      endif
c
      jbox=(jbz*nby+jby)*nbx+jbx
      jnode=(jpz*npy+jpy)*npx+jpx
c
c     determine orientation jbox in relation to ibox
c
c     lside is true if
c
c     i: 0  j: 0  k:  +
c     i: 0  j:  + k:-0+
c     i:  + j:-0+ k:-0+
c
      lside=(kbx.eq.0.and.kby.eq.0.and.kbz.ge.0)
     + .or.(kbx.eq.0.and.kby.gt.0) .or. kbx.gt.0
c
c     determine if ibox is identical to jbox
c
c     lsame=kbx.eq.0.and.kby.eq.0.and.kbz.eq.0
c
c     determine if difference in box numbers is even or odd
c
      leven=2*(iabs(ibox-jbox)/2).eq.iabs(ibox-jbox)
c
c     calculate the distance between the two boxes
c
      if(nbxtyp.eq.1) then
      dist2=
     + (vlat(1,1)*dx/box(1)+vlat(1,2)*dy/box(2)+vlat(1,3)*dz/box(3))**2+
     + (vlat(2,1)*dx/box(1)+vlat(2,2)*dy/box(2)+vlat(2,3)*dz/box(3))**2+
     + (vlat(3,1)*dx/box(1)+vlat(3,2)*dy/box(2)+vlat(3,3)*dz/box(3))**2
      else
      dist2=dx*dx+dy*dy+dz*dz
      endif
c
c     keep half of the box pairs
c
c     this test also appears in argos_space_numbb
c     any changes need to be made in both routines
c
      if((inode.eq.jnode.and.ibox.ge.jbox).or.(inode.ne.jnode.and.
     + ((lside.and.leven).or.(.not.lside.and..not.leven)))) then
c
c     keep only those within maximum cutoff distance
c
      if(rbbl*rbbl.gt.dist2) mbbl=mbbl+1
      endif
      if(rbbl*rbbl.gt.dist2) mbblb=mbblb+1
   16 continue
   15 continue
   14 continue
      endif
   13 continue
   12 continue
   11 continue
c
      mbbl=mbbl+1
      if(mbblb+1.gt.mbbl) mbbl=mbblb+1
c
c
c     allocate memory for the box-box list
c
      if(np.gt.1) call ga_igop(msp_20,mbbl,1,'max')
c
      if(me.eq.0) then
      if(util_print('distribution',print_debug)) then
      write(lfnout,2002) mbbl
 2002 format(' Dimension of the cell-cell list is ',i7)
      endif
      endif
c
      if(mbblp.eq.0) then
      mbbl=max(mbbl,mbbreq)
      if(.not.ma_push_get(mt_int,mbb2*mbbl,'bb',l_bb,i_bb))
     + call md_abort('Failed to allocate memory for bb',0)
      mbblp=mbbl
      else
      if(mbbl.gt.mbblp) then
      write(string,1111) mbblp,mbbl,mbbreq
 1111 format('error: lbbl increase from ',i6,' to ',i6,'(',i6,')')
      call md_abort(string,me)
c      call md_abort('lbbl increased beyond allocated memory',me)
      endif
      endif
c
      return
      end
c $Id: argos_space_numbb.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: Parallel-mpi.F 25953 2014-07-30 10:46:17Z bylaska $
*

* Parallel.f
* Author - Eric Bylaska
*
*   These routines are to be used to keep track of the parallel message
* passing variables, as well as iniitialize and deinitialize the
* message passing routines.
*


*     *************************************
*     *                                   *
*     *        Parallel_Init              *
*     *                                   *
*     *************************************

      subroutine Parallel_Init()
      implicit none

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"

#include "tcgmsg.fh"
#include "global.fh"
#include "mpif.h"

#ifdef GA_DEV


ccc#include "ga_mpi.fh"
#ifndef GA_MPI_H_
#define GA_MPI_H_
!     usage: call ga_mpi_comm(OUT integer comm)
!     usage: call ga_mpi_comm_pgroup(OUT integer comm, IN integer grp)
!     usage: call ga_mpi_comm_pgroup_default(OUT integer comm)
      external ga_mpi_comm
      external ga_mpi_comm_pgroup
      external ga_mpi_comm_pgroup_default

#endif /* GA_MPI_H_ */

#endif /* GA_DEV */


#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer i,mpierr,mygroup,myio,mydepth
      character*50 nwfilename
      character*7 c_index_name
      external    c_index_name
      integer  util_sgroup_set_ioname,util_sgroup_mygroup
      integer  util_sgroup_depth
      external util_sgroup_set_ioname,util_sgroup_mygroup
      external util_sgroup_depth

c*     **** MPI initiializer *****
cc     call MPI_INIT(mpierr)
c      call MPI_COMM_RANK(MPI_COMM_WORLD,taskid,mpierr)
c      call MPI_COMM_SIZE(MPI_COMM_WORLD,np,mpierr)

#ifdef USE_SUBGROUPS

#ifdef GA_DEV
      call ga_mpi_comm_pgroup_default(comm_world)
#else
      comm_world = MPI_COMM_WORLD
#endif

#else
      comm_world = MPI_COMM_WORLD
#endif

#ifdef MPI4
      stupid_world   = comm_world
      stupid_sum     = MPI_SUM
      stupid_max     = MPI_MAX
      stupid_min     = MPI_MIN
      stupid_character = MPI_CHARACTER
      stupid_integer = MPI_INTEGER
      stupid_double  = MPI_DOUBLE_PRECISION
      stupid_complex = MPI_DOUBLE_COMPLEX
      stupid_comm_i   = comm_world
      stupid_comm_j   = -99
      stupid_comm_k   = -99
#endif

#ifdef USE_SUBGROUPS
#ifdef GA_DEV
      call MPI_COMM_RANK(comm_world,taskid,mpierr)
      call MPI_COMM_SIZE(comm_world,np,mpierr)
      mydepth = util_sgroup_depth()
      mygroup = util_sgroup_mygroup()
      if ((taskid.eq.MASTER).and.(mydepth.gt.0)) then
         myio = util_sgroup_set_ioname(
     >              "nwpw"//c_index_name(mygroup)//".output")
      end if
#else
      np     = nnodes()
      taskid = nodeid()
#endif

#else
      np     = nnodes()
      taskid = nodeid()
#endif


*     **** set up 3d processor grid = np x 1 x 1****
      if (.not.MA_alloc_get(mt_int,np,'procNd',procNd(2),procNd(1)))
     >  call errquit('Parallel_init:out of heap memory',0, MA_ERR)

      np_i = np
      np_j = 1
      np_k = 1
      do i=0,np-1
        int_mb(procNd(1)+i) = i
      end do
      taskid_i = taskid
      taskid_j = 0
      taskid_k = 0
      comm_i   = comm_world
      comm_j   = -99 
      comm_k   = -99 

      return 
      end



*     *************************************
*     *                                   *
*     *        Parallel2d_Init            *
*     *                                   *
*     *************************************

*     Sset up the 2d processor grid = np_i x np_j, 
*     where np_i = nrows, and np_j = np/np_i
*
      subroutine Parallel2d_Init(ncolumns)
      implicit none
      integer ncolumns

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     *** local variables ***
      integer i,j,icount,ierr
      integer tmp(2),tmp2(2),mpi_group

      if (ncolumns.gt.1) then

      np_i = np/ncolumns
      np_j = ncolumns


      icount = 0
      do j=0,np_j-1
      do i=0,np_i-1
        if (icount.eq.taskid) then
           taskid_i = i
           taskid_j = j
        end if
        int_mb(procNd(1) + i + j*np_i) = icount
        icount = mod((icount+1),np)
      end do
      end do

      if (.not.MA_push_get(mt_int,np,'tmppp2',tmp(2),tmp(1)))
     >  call errquit('Parallel2d_init:out of stack memory',0, MA_ERR)

#ifdef MPI4
      if (.not.MA_push_get(mt_int,np,'tmppp3',tmp2(2),tmp2(1)))
     >  call errquit('Parallel2d_init:out of stack memory',0, MA_ERR)
      stupid_np_i = np_i
      stupid_np_j = np_j
*     **** set global processor group ****
      call MPI_COMM_group(stupid_world,stupid_mpi_group,stupid_ierr)

      do i=0,np_i-1
        int_mb(tmp(1)+i) = int_mb(procNd(1) + i + taskid_j*np_i) 
      end do
      call stupid_icopy8to4(np_i,int_mb(tmp(1)),int_mb(tmp2(1)))
      call MPI_Group_incl(stupid_mpi_group,
     >                    stupid_np_i,
     >                    int_mb(tmp2(1)),
     >                    stupid_group_i,stupid_ierr)
      call MPI_Comm_create(stupid_world,stupid_group_i,
     >                     stupid_comm_i,stupid_ierr)

      do j=0,np_j-1
        int_mb(tmp(1)+j) = int_mb(procNd(1) + taskid_i + j*np_i) 
      end do
      call stupid_icopy8to4(np_j,int_mb(tmp(1)),int_mb(tmp2(1)))
      call MPI_Group_incl(stupid_mpi_group,stupid_np_j,
     >                    int_mb(tmp2(1)),
     >                    stupid_group_j,stupid_ierr)
      call MPI_Comm_create(stupid_world,stupid_group_j,stupid_comm_j,  
     >                     stupid_ierr)


      group_i = stupid_group_i
      comm_i  = stupid_comm_i
      group_j = stupid_group_j
      comm_j  = stupid_comm_j
      if (.not.MA_pop_stack(tmp2(2)))
     >  call errquit('Parallel2d_init:popping stack memory',0, MA_ERR)

#else
*     **** set global processor group ****
      call MPI_COMM_group(comm_world,mpi_group,ierr)

      do i=0,np_i-1
        int_mb(tmp(1)+i) = int_mb(procNd(1) + i + taskid_j*np_i) 
      end do
      call MPI_Group_incl(mpi_group,np_i,int_mb(tmp(1)),group_i,ierr)
      call MPI_Comm_create(comm_world,group_i,comm_i,  ierr)

      do j=0,np_j-1
        int_mb(tmp(1)+j) = int_mb(procNd(1) + taskid_i + j*np_i) 
      end do
      call MPI_Group_incl(mpi_group,np_j,int_mb(tmp(1)),group_j,ierr)
      call MPI_Comm_create(comm_world,group_j,comm_j,  ierr)
#endif

      if (.not.MA_pop_stack(tmp(2)))
     >  call errquit('Parallel2d_init:popping stack memory',0, MA_ERR)

      end if
      return
      end


*     *************************************
*     *                                   *
*     *        Parallel2d_Finalize        *
*     *                                   *
*     *************************************

      subroutine Parallel2d_Finalize()
      implicit none

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

#ifdef MPI4
      if (np_j.gt.1) then
*      **** free comm_i and comm_j communicators ****
      call MPI_Comm_free(stupid_comm_i,  stupid_ierr)
      call MPI_Group_free(stupid_group_i,stupid_ierr)
      call MPI_Comm_free(stupid_comm_j,  stupid_ierr)
      call MPI_Group_free(stupid_group_j,stupid_ierr)
      end if
#else
*     *** local variable ***
      integer mpierr

      if (np_j.gt.1) then
*      **** free comm_i and comm_j communicators ****
      call MPI_Comm_free(comm_i,  mpierr)
      call MPI_Group_free(group_i,mpierr)
      call MPI_Comm_free(comm_j,  mpierr)
      call MPI_Group_free(group_j,mpierr)
      end if
#endif

      return
      end



*     *************************************
*     *                                   *
*     *        Parallel3d_Init            *
*     *                                   *
*     *************************************

*     Sset up the 3d processor grid = np_i x np_j x np_k, 
*     where np_i = nrows=np/(np_j*np_k), 
*     np_j = ncolumns, and np_k = nzones
*
      subroutine Parallel3d_Init(ncolumns,nzones)
      implicit none
      integer ncolumns,nzones

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     *** local variables ***
      integer i,j,k,icount,ierr
      integer tmp(2),tmp2(2),mpi_group

      np_i = np/(ncolumns*nzones)
      np_j = ncolumns
      np_k = nzones

      icount = 0
      do k=0,np_k-1
      do j=0,np_j-1
      do i=0,np_i-1
        if (icount.eq.taskid) then
           taskid_i = i
           taskid_j = j
           taskid_k = k
        end if
        int_mb(procNd(1) + i + j*np_i + k*np_i*np_j) = icount
        icount = mod((icount+1),np)
      end do
      end do
      end do

      if (.not.MA_push_get(mt_int,np,'tmppp2',tmp(2),tmp(1)))
     >  call errquit('Parallel3d_init:out of stack memory',0, MA_ERR)

#ifdef MPI4
      if (.not.MA_push_get(mt_int,np,'tmppp3',tmp2(2),tmp2(1)))
     >  call errquit('Parallel3d_init:out of stack memory',0, MA_ERR)
      stupid_np_i = np_i
      stupid_np_j = np_j
      stupid_np_k = np_k
*     **** set global processor group ****
      call MPI_COMM_group(stupid_world,stupid_mpi_group,stupid_ierr)

      do i=0,np_i-1
        int_mb(tmp(1)+i) = int_mb(procNd(1) 
     >                           + i 
     >                           + taskid_j*np_i
     >                           + taskid_k*np_i*np_j) 
      end do
      call stupid_icopy8to4(np_i,int_mb(tmp(1)),int_mb(tmp2(1)))
      call MPI_Group_incl(stupid_mpi_group,
     >                    stupid_np_i,
     >                    int_mb(tmp2(1)),
     >                    stupid_group_i,stupid_ierr)
      call MPI_Comm_create(stupid_world,stupid_group_i,
     >                     stupid_comm_i,stupid_ierr)

      do j=0,np_j-1
        int_mb(tmp(1)+j) = int_mb(procNd(1) 
     >                           + taskid_i 
     >                           + j*np_i
     >                           + taskid_k*np_i*np_j) 
      end do
      call stupid_icopy8to4(np_j,int_mb(tmp(1)),int_mb(tmp2(1)))
      call MPI_Group_incl(stupid_mpi_group,stupid_np_j,
     >                    int_mb(tmp2(1)),
     >                    stupid_group_j,stupid_ierr)
      call MPI_Comm_create(stupid_world,stupid_group_j,stupid_comm_j,  
     >                     stupid_ierr)

      do k=0,np_k-1
        int_mb(tmp(1)+k) = int_mb(procNd(1)
     >                           + taskid_i
     >                           + taskid_j*np_i
     >                           + k*np_i*np_j)
      end do
      call stupid_icopy8to4(np_k,int_mb(tmp(1)),int_mb(tmp2(1)))
      call MPI_Group_incl(stupid_mpi_group,
     >                    stupid_np_k,
     >                    int_mb(tmp2(1)),
     >                    stupid_group_k,stupid_ierr)
      call MPI_Comm_create(stupid_world,stupid_group_k,
     >                     stupid_comm_k,stupid_ierr)

      group_i = stupid_group_i
      comm_i  = stupid_comm_i
      group_j = stupid_group_j
      comm_j  = stupid_comm_j
      group_k = stupid_group_k
      comm_k  = stupid_comm_k
      if (.not.MA_pop_stack(tmp2(2)))
     >  call errquit('Parallel3d_init:popping stack memory',0, MA_ERR)

#else
*     **** set global processor group ****
      call MPI_COMM_group(comm_world,mpi_group,ierr)

      do i=0,np_i-1
        int_mb(tmp(1)+i) = int_mb(procNd(1) 
     >                           + i 
     >                           + taskid_j*np_i 
     >                           + taskid_k*np_i*np_j) 
      end do
      call MPI_Group_incl(mpi_group,np_i,int_mb(tmp(1)),group_i,ierr)
      call MPI_Comm_create(comm_world,group_i,comm_i,ierr)

      do j=0,np_j-1
        int_mb(tmp(1)+j) = int_mb(procNd(1) 
     >                           + taskid_i 
     >                           + j*np_i
     >                           + taskid_k*np_i*np_j) 
      end do
      call MPI_Group_incl(mpi_group,np_j,int_mb(tmp(1)),group_j,ierr)
      call MPI_Comm_create(comm_world,group_j,comm_j,ierr)

      do k=0,np_k-1
        int_mb(tmp(1)+k) = int_mb(procNd(1) 
     >                           + taskid_i 
     >                           + taskid_j*np_i
     >                           + k*np_i*np_j) 
      end do
      call MPI_Group_incl(mpi_group,np_k,int_mb(tmp(1)),group_k,ierr)
      call MPI_Comm_create(comm_world,group_k,comm_k,ierr)
#endif

      if (.not.MA_pop_stack(tmp(2)))
     >  call errquit('Parallel3d_init:popping stack memory',0, MA_ERR)
      return
      end


*     *************************************
*     *                                   *
*     *        Parallel3d_Finalize        *
*     *                                   *
*     *************************************

      subroutine Parallel3d_Finalize()
      implicit none

#include "Parallel.fh"
#include "mafdecls.fh"
#include "errquit.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

#ifdef MPI4
*      **** free comm_i and comm_j communicators ****
      call MPI_Comm_free(stupid_comm_i,  stupid_ierr)
      call MPI_Group_free(stupid_group_i,stupid_ierr)
      call MPI_Comm_free(stupid_comm_j,  stupid_ierr)
      call MPI_Group_free(stupid_group_j,stupid_ierr)
      call MPI_Comm_free(stupid_comm_k,  stupid_ierr)
      call MPI_Group_free(stupid_group_k,stupid_ierr)
#else

*     *** local variable ***
      integer mpierr

*      **** free comm_i and comm_j communicators ****
      call MPI_Comm_free(comm_i,  mpierr)
      call MPI_Group_free(group_i,mpierr)
      call MPI_Comm_free(comm_j,  mpierr)
      call MPI_Group_free(group_j,mpierr)
      call MPI_Comm_free(comm_k,  mpierr)
      call MPI_Group_free(group_k,mpierr)
#endif

      return
      end


*     ***********************************
*     *                                 *
*     *         Parallel_MaxAll         *
*     *                                 *
*     ***********************************

      subroutine Parallel_MaxAll(sum)
c     implicit none
      real*8  sum

#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif
      real*8 sumall
#ifdef MPI4
      if (np.gt.1) then
         stupid_msglen = 1
         call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                      stupid_max,stupid_world,stupid_ierr)
         sum = sumall
      end if
#else
      integer msglen,mpierr
      if (np.gt.1) then
         msglen = 1
         call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                       MPI_MAX,comm_world,mpierr)
         sum = sumall
      end if
#endif
      return
      end


*     ***********************************
*     *                                 *
*     *         Parallel_IMaxAll        *
*     *                                 *
*     ***********************************

      subroutine Parallel_IMaxAll(isum)
c     implicit none
      integer  isum

#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif
#ifdef MPI4
      integer*4 isumall,isum2
      if (np.gt.1) then
         isum2 = isum
         stupid_msglen = 1
         call MPI_Allreduce(isum2,isumall,stupid_msglen,stupid_integer,
     >                      stupid_max,stupid_world,stupid_ierr)
         isum = isumall
      end if
#else
      integer msglen,mpierr
      integer isumall
      if (np.gt.1) then
         msglen = 1
         call MPI_Allreduce(isum,isumall,msglen,MPI_INTEGER,
     >                       MPI_MAX,comm_world,mpierr)
         isum = isumall
      end if
#endif
      return
      end




*     ***********************************
*     *                                 *
*     *         Parallel_SumAll         *
*     *                                 *
*     ***********************************

      subroutine Parallel_SumAll(sum)
c     implicit none
      real*8  sum


#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      real*8 sumall

#ifdef MPI4
      if (np.gt.1) then
         stupid_msglen = 1
         call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                      stupid_sum,stupid_world,stupid_ierr)
         sum = sumall
      end if
#else
      integer msglen,mpierr

      if (np.gt.1) then
         msglen = 1
         call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                       MPI_SUM,comm_world,mpierr)
         sum = sumall
      end if
#endif

      return
      end


*     ***********************************
*     *                                 *
*     *         Parallel_ISumAll        *
*     *                                 *
*     ***********************************

      subroutine Parallel_ISumAll(sum)
c     implicit none
      integer sum


#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

#ifdef MPI4
      integer*4 tsum,sumall

      if (np.gt.1) then
         stupid_msglen = 1
         tsum = sum
         call MPI_Allreduce(tsum,sumall,stupid_msglen,stupid_integer,
     >                       stupid_sum,stupid_world,stupid_ierr)
         sum = sumall
      end if
#else

      integer msglen,mpierr
      integer sumall

      if (np.gt.1) then
         msglen = 1

         call MPI_Allreduce(sum,sumall,msglen,MPI_INTEGER,
     >                       MPI_SUM,comm_world,mpierr)
         sum = sumall
      end if
#endif

      return
      end

*     ***********************************
*     *                                 *
*     *      Parallel_Vector_SumAll     *
*     *                                 *
*     ***********************************

      subroutine Parallel_Vector_SumAll(n,sum)
c     implicit none
      integer n
      real*8  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variable ****
      logical value
      integer msglen,mpierr

*     **** temporary workspace ****
      integer sumall(2)


      call nwpw_timing_start(2)
      if (np.gt.1) then

*     ***** allocate temporary space ****
      value = MA_push_get(mt_dbl,n,'sumall',sumall(2),sumall(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

#ifdef MPI4
      stupid_msglen = n
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),stupid_msglen,
     >                stupid_double,
     >                stupid_sum,stupid_world,stupid_ierr)
#else
      msglen = n
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),msglen,
     >                MPI_DOUBLE_PRECISION,
     >                MPI_SUM,comm_world,mpierr)
#endif

      call dcopy(n,dbl_mb(sumall(1)),1,sum,1)
      value = MA_pop_stack(sumall(2))
      if (.not.value) call errquit('dealloc stack memory',0,MA_ERR)

      end if
      call nwpw_timing_end(2)
      return
      end


*     ***********************************
*     *                                 *
*     *      Parallel_Vector_ISumAll    *
*     *                                 *
*     ***********************************

      subroutine Parallel_Vector_ISumAll(n,sum)
c     implicit none
      integer n
      integer  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      logical value
      integer msglen,mpierr

*     **** temporary workspace ****
      integer sumall(2),sumall1(2)


      call nwpw_timing_start(2)

      if (np.gt.1) then

*     ***** allocate temporary space ****
      value = MA_push_get(mt_int,n,'sumall',sumall(2),sumall(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

#ifdef MPI4
      if (.not.MA_push_get(mt_int,n,'sumall1',sumall1(2),sumall1(1)))
     > call errquit('out of stack memory',0, MA_ERR)

      stupid_msglen = n
      call stupid_icopy8to4(n,sum,int_mb(sumall1(1)))
      call MPI_Allreduce(int_mb(sumall1(1)),
     >                   int_mb(sumall(1)),stupid_msglen,
     >                stupid_integer,
     >                stupid_sum,stupid_world,stupid_ierr)
      call stupid_icopy4to8(n,int_mb(sumall(1)),sum)
      if (.not.MA_pop_stack(sumall1(2)))
     >   call errquit('error popping stack',0,MA_ERR)
#else
      msglen = n
      call MPI_Allreduce(sum,int_mb(sumall(1)),msglen,
     >                MPI_INTEGER,
     >                MPI_SUM,comm_world,mpierr)
      call icopy(n,int_mb(sumall(1)),1,sum,1)
#endif
      value = MA_pop_stack(sumall(2))
      if (.not. value) call errquit('error popping stack',0, MA_ERR)

      end if

      call nwpw_timing_end(2)
      return
      end





*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_value      *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_value(psend,sum)
      implicit none
      integer psend
      real*8  sum

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      integer*4 tpsend

      if (np.gt.1) then
         stupid_msglen = 1
         tpsend        = psend
         call MPI_Bcast(sum,stupid_msglen,stupid_double,
     >                  tpsend,stupid_world,stupid_ierr)
      end if
#else
      integer ierr

      if (np.gt.1) then
         call MPI_Bcast(sum,1,MPI_DOUBLE_PRECISION,
     >                  psend,comm_world,ierr)
      end if
#endif

      return
      end





*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_values     *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_values(psend,nsize,sum)
      implicit none
      integer psend,nsize
      real*8  sum(*)

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      integer*4 tpsend

      if (np.gt.1) then
         stupid_msglen = nsize
         tpsend        = psend
         call MPI_Bcast(sum,stupid_msglen,stupid_double,
     >                  tpsend,stupid_world,stupid_ierr)
      end if
#else
      integer ierr

      if (np.gt.1) then
         call MPI_Bcast(sum,nsize,MPI_DOUBLE_PRECISION,
     >                  psend,comm_world,ierr)
      end if
#endif

      return
      end

*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_ivalue     *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_ivalue(psend,isum)
      implicit none
      integer psend
      integer isum

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      integer*4 tpsend,isum4

      if (np.gt.1) then
         stupid_msglen = 1
         tpsend        = psend
         isum4 = isum
         call MPI_Bcast(isum4,stupid_msglen,stupid_integer,
     >                  tpsend,stupid_world,stupid_ierr)
         isum = isum4
      end if
#else
      integer ierr

      if (np.gt.1) then
         call MPI_Bcast(isum,1,MPI_DOUBLE_PRECISION,
     >                  psend,comm_world,ierr)
      end if
#endif

      return
      end




*     ***********************************
*     *                                 *
*     *      Parallel_Brdcst_ivalues    *
*     *                                 *
*     ***********************************

      subroutine Parallel_Brdcst_ivalues(psend,nsize,isum)
      implicit none
      integer psend,nsize
      integer isum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      logical   value
      integer*4 tpsend
      integer   sumall(2)

      if (np.gt.1) then
         stupid_msglen = nsize
         tpsend        = psend
         value = MA_push_get(mt_int,nsize,'sumall',sumall(2),sumall(1))
         if (.not. value) call errquit('out of stack memory',0, MA_ERR)

         call stupid_icopy8to4(nsize,isum,int_mb(sumall(1)))
         call MPI_Bcast(int_mb(sumall(1)),stupid_msglen,stupid_integer,
     >                  tpsend,stupid_world,stupid_ierr)
         call stupid_icopy4to8(nsize,int_mb(sumall(1)),isum)

         value = MA_pop_stack(sumall(2))
         if (.not. value) call errquit('error popping stack',0, MA_ERR)
      end if
#else
      integer ierr

      if (np.gt.1) then
         call MPI_Bcast(isum,nsize,MPI_INTEGER,
     >                  psend,comm_world,ierr)
      end if
#endif

      return
      end




#ifdef MPI4
      subroutine stupid_icopy8to4(n,array8,array4)
      implicit none
      integer n
      integer*8 array8(*)
      integer*4 array4(*)
      integer i
      do i=1,n
          array4(i) = array8(i)
      end do
      return
      end

      subroutine stupid_icopy4to8(n,array4,array8)
      implicit none
      integer n
      integer*4 array4(*)
      integer*8 array8(*)
      integer i
      do i=1,n
          array8(i) = array4(i)
      end do
      return
      end
#endif


*     ***********************************
*     *                                 *
*     *      Parallel_mpiWaitAll        *
*     *                                 *
*     ***********************************

      subroutine Parallel_mpiWaitAll(nreq,req)
      implicit none
      integer nreq,req(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"
#include "Parallel.fh"

*     *** local variables ***
#ifdef MPI4
#include "stupid_mpi4.fh"
      integer status(2),request2(2)
#else
      integer status(2),mpierr
#endif
     
      if (nreq.gt.0) then

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*nreq*4,
     >                     'status',status(2),status(1)))
     > call errquit('Parallel_mpiWaitAll:out of stack',0,MA_ERR)



*     **** wait for completion of mp_send, also do a sync ****

#ifdef MPI4

      if (.not.MA_push_get(mt_int,nreq,'rqst2',request2(2),request2(1)))
     > call errquit(' Parallel_mpiWaitAll:out of stack',1,MA_ERR)
      call stupid_icopy8to4(nreq,req,int_mb(request2(1)))
      stupid_msglen = nreq
      call MPI_WAITALL(stupid_msglen,
     >                 int_mb(request2(1)),
     >                 int_mb(status(1)),stupid_ierr)
c       call MPI_WAITALL(stupid_msglen,
c     >                 int_mb(request2(1)),
c     >                 MPI_STATUSES_IGNORE,stupid_ierr)
      if (.not.MA_pop_stack(request2(2)))
     > call errquit(' Parallel_mpiWaitAll:popping stack',1,MA_ERR)

c     *** danger! ***
      if (stupid_ierr.ne.0) then
         write(*,*) "MPI_WAITALL Failed on taskid=",taskid,
     >              "  mpierr=",stupid_ierr
         call util_flush(6)
      end if

#else
      call MPI_WAITALL(nreq,req,int_mb(status(1)),mpierr)
c      call MPI_WAITALL(nreq,req,MPI_STATUSES_IGNORE,mpierr)
#endif

*     *** may need to check status here??? ***

      !*** deallocate status memory ***
      if (.not.MA_pop_stack(status(2)))
     > call errquit(' Parallel_mpiWaitAll:popping stack',0,MA_ERR)

      end if
      return
      end




#ifdef MPI4
      integer*4 function getcomm(ic)
      implicit none
      integer   ic

#include "stupid_mpi4.fh"

      integer*4 icc
      if (ic.eq.1) then
        icc = stupid_comm_i
      else if (ic.eq.2) then
        icc = stupid_comm_j
      else if (ic.eq.3) then
        icc = stupid_comm_k
      else 
        icc = stupid_world
      end if

      getcomm = icc
      return
      end
#else
      integer function getcomm(ic)
      implicit none
      integer ic

#include "Parallel.fh"
#include "mpif.h"

      integer icc
      if (ic.eq.1) then
        icc = comm_i
      else if (ic.eq.2) then
        icc = comm_j
      else if (ic.eq.3) then
        icc = comm_k
      else 
        icc = comm_world
      end if

      getcomm = icc
      return
      end
#endif

*     ***********************************
*     *                                 *
*     *         Parallela_MaxAll        *
*     *                                 *
*     ***********************************

      subroutine Parallela_MaxAll(ic,sum)
c     implicit none
      real*8  sum

#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif
      integer ic
      real*8 sumall
#ifdef MPI4
      integer*4 getcomm
      external  getcomm

      if (np.gt.1) then
         stupid_msglen = 1
         call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                      stupid_max,getcomm(ic),stupid_ierr)
         sum = sumall
      end if
#else
      integer msglen,mpierr
      integer  getcomm
      external getcomm

      if (np.gt.1) then
         msglen = 1
         call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                       MPI_MAX,getcomm(ic),mpierr)
         sum = sumall
      end if
#endif
      return
      end





*     ***********************************
*     *                                 *
*     *         Parallela_SumAll        *
*     *                                 *
*     ***********************************

      subroutine Parallela_SumAll(ic,sum)
c     implicit none
      integer ic
      real*8  sum

#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      real*8 sumall

#ifdef MPI4
      integer*4 getcomm
      external  getcomm

      if (np.gt.1) then
         stupid_msglen = 1
         call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                      stupid_sum,getcomm(ic),stupid_ierr)
         sum = sumall
      end if
#else
      integer msglen,mpierr
      integer  getcomm
      external getcomm

      if (np.gt.1) then
         msglen = 1
         call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                       MPI_SUM,getcomm(ic),mpierr)
         sum = sumall
      end if
#endif

      return
      end


*     ***********************************
*     *                                 *
*     *         Parallela_ISumAll       *
*     *                                 *
*     ***********************************

      subroutine Parallela_ISumAll(ic,sum)
c     implicit none
      integer ic,sum


#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

#ifdef MPI4
      integer*4 tsum,sumall
      integer*4 getcomm
      external  getcomm

      if (np.gt.1) then
         stupid_msglen = 1
         tsum = sum
         call MPI_Allreduce(tsum,sumall,stupid_msglen,stupid_integer,
     >                       stupid_sum,getcomm(ic),stupid_ierr)
         sum = sumall
      end if
#else
      integer msglen,mpierr
      integer sumall
      integer  getcomm
      external getcomm

      if (np.gt.1) then
         msglen = 1

         call MPI_Allreduce(sum,sumall,msglen,MPI_INTEGER,
     >                       MPI_SUM,getcomm(ic),mpierr)
         sum = sumall
      end if
#endif

      return
      end

*     ***********************************
*     *                                 *
*     *      Parallela_Vector_SumAll    *
*     *                                 *
*     ***********************************

      subroutine Parallela_Vector_SumAll(ic,n,sum)
c     implicit none
      integer ic,n
      real*8  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variable ****
      logical value
      integer msglen,mpierr

*     **** temporary workspace ****
      integer sumall(2)

#ifdef MPI4
      integer*4 getcomm
      external  getcomm
#else
      integer  getcomm
      external getcomm
#endif


      call nwpw_timing_start(2)
      if (np.gt.1) then

*     ***** allocate temporary space ****
      value = MA_push_get(mt_dbl,n,'sumall',sumall(2),sumall(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

#ifdef MPI4
      stupid_msglen = n
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),stupid_msglen,
     >                stupid_double,
     >                stupid_sum,getcomm(ic),stupid_ierr)
#else
      msglen = n
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),msglen,
     >                MPI_DOUBLE_PRECISION,
     >                MPI_SUM,getcomm(ic),mpierr)
#endif

      call dcopy(n,dbl_mb(sumall(1)),1,sum,1)
      value = MA_pop_stack(sumall(2))

      end if
      call nwpw_timing_end(2)
      return
      end


*     ***********************************
*     *                                 *
*     *      Parallela_Vector_ISumAll   *
*     *                                 *
*     ***********************************

      subroutine Parallela_Vector_ISumAll(ic,n,sum)
c     implicit none
      integer ic,n
      integer  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      logical value
      integer msglen,mpierr

*     **** temporary workspace ****
      integer sumall(2),sumall1(2)

#ifdef MPI4
      integer*4 getcomm
      external  getcomm
#else
      integer  getcomm
      external getcomm
#endif

      call nwpw_timing_start(2)

      if (np.gt.1) then

*     ***** allocate temporary space ****
      value = MA_push_get(mt_int,n,'sumall',sumall(2),sumall(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

#ifdef MPI4
      if (.not.MA_push_get(mt_int,n,'sumall1',sumall1(2),sumall1(1)))
     > call errquit('out of stack memory',0, MA_ERR)

      stupid_msglen = n
      call stupid_icopy8to4(n,sum,int_mb(sumall1(1)))
      call MPI_Allreduce(int_mb(sumall1(1)),
     >                   int_mb(sumall(1)),stupid_msglen,
     >                stupid_integer,
     >                stupid_sum,getcomm(ic),stupid_ierr)
      call stupid_icopy4to8(n,int_mb(sumall(1)),sum)
      if (.not.MA_pop_stack(sumall1(2)))
     >   call errquit('error popping stack',0,MA_ERR)
#else
      msglen = n
      call MPI_Allreduce(sum,int_mb(sumall(1)),msglen,
     >                MPI_INTEGER,
     >                MPI_SUM,getcomm(ic),mpierr)
      call icopy(n,int_mb(sumall(1)),1,sum,1)
#endif
      value = MA_pop_stack(sumall(2))
      if (.not. value) call errquit('error popping stack',0, MA_ERR)

      end if

      call nwpw_timing_end(2)
      return
      end





*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_value     *
*     *                                 *
*     ***********************************

      subroutine Parallela_Brdcst_value(ic,psend,sum)
      implicit none
      integer ic,psend
      real*8  sum

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      integer*4 tpsend
      integer*4 getcomm
      external  getcomm

      if (np.gt.1) then
         stupid_msglen = 1
         tpsend        = psend
         call MPI_Bcast(sum,stupid_msglen,stupid_double,
     >                  tpsend,getcomm(ic),stupid_ierr)
      end if
#else
      integer ierr
      integer  getcomm
      external getcomm

      if (np.gt.1) then
         call MPI_Bcast(sum,1,MPI_DOUBLE_PRECISION,
     >                  psend,getcomm(ic),ierr)
      end if
#endif

      return
      end




*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_values     *
*     *                                 *
*     ***********************************

      subroutine Parallela_Brdcst_values(ic,psend,nsize,sum)
      implicit none
      integer ic,psend,nsize
      real*8  sum(*)

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      integer*4 tpsend
      integer*4 getcomm
      external  getcomm

      if (np.gt.1) then
         stupid_msglen = nsize
         tpsend        = psend
         call MPI_Bcast(sum,stupid_msglen,stupid_double,
     >                  tpsend,getcomm(ic),stupid_ierr)
      end if
#else
      integer ierr
      integer  getcomm
      external getcomm

      if (np.gt.1) then
         call MPI_Bcast(sum,nsize,MPI_DOUBLE_PRECISION,
     >                  psend,getcomm(ic),ierr)
      end if
#endif

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_ivalue    *
*     *                                 *
*     ***********************************

      subroutine Parallela_Brdcst_ivalue(ic,psend,isum)
      implicit none
      integer ic,psend
      integer isum

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      integer*4 tpsend,isum4
      integer*4 getcomm
      external  getcomm

      if (np.gt.1) then
         stupid_msglen = 1
         tpsend        = psend
         isum4         = isum
         call MPI_Bcast(isum4,stupid_msglen,stupid_double,
     >                  tpsend,getcomm(ic),stupid_ierr)
         isum         = isum4
      end if
#else
      integer ierr
      integer  getcomm
      external getcomm

      if (np.gt.1) then
         call MPI_Bcast(isum,1,MPI_DOUBLE_PRECISION,
     >                  psend,getcomm(ic),ierr)
      end if
#endif

      return
      end





*     ***********************************
*     *                                 *
*     *      Parallela_Brdcst_ivalues   *
*     *                                 *
*     ***********************************

      subroutine Parallela_Brdcst_ivalues(ic,psend,nsize,isum)
      implicit none
      integer ic,psend,nsize
      integer isum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      logical   value
      integer*4 tpsend
      integer   sumall(2)
      integer*4 getcomm
      external  getcomm

      if (np.gt.1) then
         stupid_msglen = nsize
         tpsend        = psend
         value = MA_push_get(mt_int,nsize,'sumall',sumall(2),sumall(1))
         if (.not. value) call errquit('out of stack memory',0, MA_ERR)

         call stupid_icopy8to4(nsize,isum,int_mb(sumall(1)))
         call MPI_Bcast(int_mb(sumall(1)),stupid_msglen,stupid_integer,
     >                  tpsend,getcomm(ic),stupid_ierr)
         call stupid_icopy4to8(nsize,int_mb(sumall(1)),isum)

         value = MA_pop_stack(sumall(2))
         if (.not. value) call errquit('error popping stack',0, MA_ERR)
      end if
#else
      integer ierr
      integer  getcomm
      external getcomm

      if (np.gt.1) then
         call MPI_Bcast(isum,nsize,MPI_INTEGER,
     >                  psend,getcomm(ic),ierr)
      end if
#endif

      return
      end





*     ***********************************
*     *                                 *
*     *      Parallela_start_rotate     *
*     *                                 *
*     ***********************************

      subroutine Parallela_start_rotate(ic,shift,msgtype0,
     >                                  A1,nsize1,
     >                                  A2,nsize2,request)
      implicit none
      integer ic,shift,msgtype0
      real*8  A1(*)
      integer nsize1
      real*8  A2(*)
      integer nsize2
      integer request(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variables ****
      integer mynp,mytaskid,msglen,msgtype,mpierr,proc_to,proc_from

*     ***** external functions ****
#ifdef MPI4
      integer*4 getcomm
      external  getcomm
#else
      integer  getcomm
      external getcomm
#endif

      if (ic.eq.1) then
         mynp     = np_i
         mytaskid = taskid_i
      else if (ic.eq.2) then
         mynp     = np_j
         mytaskid = taskid_j
      else if (ic.eq.3) then
         mynp     = np_k
         mytaskid = taskid_k
      else
         mynp     = np
         mytaskid = taskid
      end if
      proc_to   = mod(mytaskid+shift+mynp,mynp)
      proc_from = mod(mytaskid-shift+mynp,mynp)

#ifdef MPI4
         if (nsize2.gt.0) then
            stupid_msglen = nsize2
            stupid_type   = msgtype0
            stupid_taskid = proc_from
            call MPI_IRECV(A2,
     >                  stupid_msglen,stupid_double,
     >                  stupid_taskid,
     >                  stupid_type,getcomm(ic),
     >                  stupid_request,stupid_ierr)
            request(1) = 0
            request(3) = 1
            request(1) = stupid_request
         else
            request(3) = 0
         end if

         if (nsize1.gt.0) then
            stupid_msglen = nsize1
            stupid_type   = msgtype0
            stupid_taskid = proc_to
            call MPI_ISEND(A1,
     >                  stupid_msglen,stupid_double,
     >                  stupid_taskid,
     >                  stupid_type,getcomm(ic),
     >                  stupid_request,stupid_ierr)
            request(2) = 0
            request(4) = 1
            request(2) = stupid_request
         else
            request(4) = 0
         end if

#else
         if (nsize2.gt.0) then
         msglen  = nsize2
         msgtype = msgtype0
         call MPI_IRECV(A2,msglen,MPI_DOUBLE_PRECISION,
     >                  proc_from,
     >                  msgtype,getcomm(ic),
     >                  request(1),mpierr)
            request(3) = 1
         else
            request(3) = 0
         end if

         if (nsize1.gt.0) then
         msglen  = nsize1
         msgtype = msgtype0
         call MPI_ISEND(A1,msglen,MPI_DOUBLE_PRECISION,
     >                  proc_to,
     >                  msgtype,getcomm(ic),
     >                  request(2),mpierr)
            request(4) = 1
         else
            request(4) = 0
         end if
#endif

      if ((request(3).eq.1).and.(request(4).eq.1)) then
         request(3) = 1
      else if (request(3).eq.1) then
         request(3) = 2
      else if (request(4).eq.1) then
         request(3) = 3
      else
         request(3) = 4
      end if

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallela_start_Irotate     *
*     *                                 *
*     ***********************************

      subroutine Parallela_start_Irotate(ic,shift,msgtype0,
     >                                  IA1,nsize1,
     >                                  IA2,nsize2,request)
      implicit none
      integer ic,shift,msgtype0
      integer IA1(*)
      integer nsize1
      integer IA2(*)
      integer nsize2
      integer request(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Parallel.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variables ****
      integer mynp,mytaskid,msglen,msgtype,mpierr,proc_to,proc_from

*     ***** external functions ****
#ifdef MPI4
      integer*4 getcomm
      external  getcomm
#else
      integer  getcomm
      external getcomm
#endif

      if (ic.eq.1) then
         mynp     = np_i
         mytaskid = taskid_i
      else if (ic.eq.2) then
         mynp     = np_j
         mytaskid = taskid_j
      else if (ic.eq.3) then
         mynp     = np_k
         mytaskid = taskid_k
      else
         mynp     = np
         mytaskid = taskid
      end if
      proc_to   = mod(mytaskid+shift+mynp,mynp)
      proc_from = mod(mytaskid-shift+mynp,mynp)

#ifdef MPI4
         if (nsize2.gt.0) then
            stupid_msglen = nsize2
            stupid_type   = msgtype0
            stupid_taskid = proc_from
      write(*,*) "irecv, mytaskid,stupid_taskid,msglen=",mytaskid,
     >           stupid_taskid,stupid_msglen,IA2(1)
            call MPI_IRECV(IA2,
     >                  stupid_msglen,stupid_integer,
     >                  stupid_taskid,
     >                  stupid_type,getcomm(ic),
     >                  stupid_request,stupid_ierr)
            request(1) = 0
            request(1) = stupid_request
            request(3) = 1
         else
            request(3) = 0
         end if

         if (nsize1.gt.0) then
            stupid_msglen = nsize1
            stupid_type   = msgtype0
            stupid_taskid = proc_to
      write(*,*) "isend, mytaskid,stupid_taskid,msglen=",mytaskid,
     >           stupid_taskid,stupid_msglen,IA1(1)
            call MPI_ISEND(IA1,
     >                  stupid_msglen,stupid_integer,
     >                  stupid_taskid,
     >                  stupid_type,getcomm(ic),
     >                  stupid_request,stupid_ierr)
            request(2) = 0
            request(2) = stupid_request
            request(4) = 1
         else
            request(4) = 0
         end if

#else
         if (nsize2.gt.0) then
         msglen  = nsize2
         msgtype = msgtype0
         call MPI_IRECV(IA2,msglen,MPI_INTEGER,
     >                  proc_from,
     >                  msgtype,getcomm(ic),
     >                  request(1),mpierr)
            request(3) = 1
         else
            request(3) = 0
         end if

         if (nsize1.gt.0) then
         msglen  = nsize1
         msgtype = msgtype0
         call MPI_ISEND(IA1,msglen,MPI_INTEGER,
     >                  proc_to,
     >                  msgtype,getcomm(ic),
     >                  request(2),mpierr)
            request(4) = 1
         else
            request(4) = 0
         end if
#endif

      if ((request(3).eq.1).and.(request(4).eq.1)) then
         request(3) = 1
      else if (request(3).eq.1) then
         request(3) = 2
      else if (request(4).eq.1) then
         request(3) = 3
      else
         request(3) = 4
      end if

      return
      end



*     ***********************************
*     *                                 *
*     *      Parallela_end_rotate       *
*     *                                 *
*     ***********************************

      subroutine Parallela_end_rotate(request)
      implicit none
      integer request(*)

*     **** wait for completion of mp_send, also do a sync ****
      if (request(3).eq.1) then
         call Parallel_mpiWaitAll(2,request)
      else if (request(3).eq.2) then
         call Parallel_mpiWaitAll(1,request)
      else if (request(3).eq.3) then
         call Parallel_mpiWaitAll(1,request(2))
      endif

      return
      end





*     ***********************************
*     *                                 *
*     *      Parallel_send_values       *
*     *                                 *
*     ***********************************
      subroutine Parallel_send_values(pto,msgtype,nsize,rval)
      implicit none
      integer pto,msgtype,nsize
      real*8 rval(*)

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

#ifdef MPI4
      stupid_msglen = nsize
      stupid_taskid = pto
      stupid_type = msgtype
      call MPI_SEND(rval,stupid_msglen,stupid_double,
     >              stupid_taskid,
     >              stupid_type,stupid_world,stupid_ierr)
#else
      call MPI_SEND(rval,nsize,MPI_DOUBLE_PRECISION,
     >              pto,msgtype,comm_world,mpierr)
#endif
      return
      end 

*     ***********************************
*     *                                 *
*     *      Parallel_send_ivalues      *
*     *                                 *
*     ***********************************
      subroutine Parallel_send_ivalues(pto,msgtype,nsize,ival)
      implicit none
      integer pto,msgtype,nsize
      integer ival(*)

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

#ifdef MPI4
#include "mafdecls.fh"
#include "errquit.fh"

      logical value
      integer ival4(2)

*     ***** allocate temporary space ****
      value = MA_push_get(mt_int,nsize,'ival4',ival4(2),ival4(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      call stupid_icopy8to4(nsize,ival,int_mb(ival4(1)))
      stupid_msglen = nsize
      stupid_taskid = pto
      stupid_type = msgtype
      call MPI_SEND(int_mb(ival4(1)),stupid_msglen,stupid_integer,
     >              stupid_taskid,
     >              stupid_type,stupid_world,stupid_ierr)
      value = MA_pop_stack(ival4(2))
      if (.not.value) call errquit('popping stack memory',0,MA_ERR)
#else
      call MPI_SEND(ival,nsize,MPI_INTEGER,
     >              pto,msgtype,comm_world,mpierr)
#endif
      return
      end




*     ***********************************
*     *                                 *
*     *      Parallel_send_characters   *
*     *                                 *
*     ***********************************
      subroutine Parallel_send_characters(pto,msgtype,nsize,cval)
      implicit none
      integer pto,msgtype,nsize
      character cval(*)

#include "Parallel.fh"
#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

#ifdef MPI4
      stupid_msglen = nsize
      stupid_taskid = pto
      stupid_type   = msgtype
      call MPI_SEND(cval,stupid_msglen,stupid_character,
     >              stupid_taskid,
     >              stupid_type,stupid_world,stupid_ierr)
#else
      call MPI_SEND(cval,nsize,MPI_CHARACTER,
     >              pto,msgtype,comm_world,mpierr)
#endif
      return
      end



*     ***********************************
*     *                                 *
*     *      Parallel_recv_values       *
*     *                                 *
*     ***********************************
      subroutine Parallel_recv_values(pfrom,msgtype,nsize,rval)
      implicit none
      integer pfrom,msgtype,nsize
      real*8 rval(*)

#include "Parallel.fh"
#include "mpif.h"
#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

#include "mafdecls.fh"
#include "errquit.fh"

      logical value
      integer status(2),mpierr

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*4,
     >                     'status',status(2),status(1)))
     > call errquit('out of stack',0,MA_ERR)

#ifdef MPI4
      stupid_msglen = nsize
      stupid_taskid = pfrom
      stupid_type = msgtype
      call MPI_RECV(rval,stupid_msglen,stupid_double,
     >              stupid_taskid,
     >              stupid_type,stupid_world,int_mb(status(1)),
     >              stupid_ierr)
#else
      call MPI_RECV(rval,nsize,MPI_DOUBLE_PRECISION,
     >              pfrom,msgtype,comm_world,int_mb(status(1)),
     >              mpierr)
#endif

      value = MA_pop_stack(status(2))
      if (.not.value) call errquit('popping stack memory',0,MA_ERR)

      return
      end

*     ***********************************
*     *                                 *
*     *      Parallel_recv_ivalues       *
*     *                                 *
*     ***********************************
      subroutine Parallel_recv_ivalues(pfrom,msgtype,nsize,ival)
      implicit none
      integer pfrom,msgtype,nsize
      integer ival(*)

#include "Parallel.fh"
#include "mpif.h"
#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

#include "mafdecls.fh"
#include "errquit.fh"

      logical value
      integer ival4(2),status(2),mpierr

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*4,
     >                     'status',status(2),status(1)))
     > call errquit('out of stack',0,MA_ERR)

#ifdef MPI4
*     ***** allocate temporary space ****
      value = MA_push_get(mt_int,nsize,'ival4',ival4(2),ival4(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      stupid_msglen = nsize
      stupid_taskid = pfrom
      stupid_type = msgtype
      call MPI_RECV(int_mb(ival4(1)),stupid_msglen,stupid_integer,
     >              stupid_taskid,
     >              stupid_type,stupid_world,int_mb(status(1)),
     >              stupid_ierr)
      call stupid_icopy4to8(nsize,int_mb(ival4(1)),ival)
      value = MA_pop_stack(ival4(2))
      if (.not. value) call errquit('popping stack memory',0,MA_ERR)
      
#else
      call MPI_RECV(ival,nsize,MPI_INTEGER,
     >              pfrom,msgtype,comm_world,int_mb(status(1)),mpierr)
#endif

      value = MA_pop_stack(status(2))
      if (.not.value) call errquit('popping stack memory',0,MA_ERR)
      return
      end




*     ***********************************
*     *                                 *
*     *      Parallel_recv_characters   *
*     *                                 *
*     ***********************************
      subroutine Parallel_recv_characters(pfrom,msgtype,nsize,cval)
      implicit none
      integer  pfrom,msgtype,nsize
      character cval(*)

#include "Parallel.fh"

#include "mpif.h"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

#include "mafdecls.fh"
#include "errquit.fh"

      logical value
      integer status(2),mpierr

*     **** allocate status memory ****
      if (.not.MA_push_get(mt_int,MPI_STATUS_SIZE*4,
     >                     'status',status(2),status(1)))
     > call errquit('out of stack',0,MA_ERR)

#ifdef MPI4
      stupid_msglen = nsize
      stupid_taskid = pfrom
      stupid_type   = msgtype
      call MPI_RECV(cval,stupid_msglen,stupid_character,
     >              stupid_taskid,
     >              stupid_type,stupid_world,int_mb(status(1)),
     >              stupid_ierr)
#else
      call MPI_RECV(cval,nsize,MPI_CHARACTER,
     >              pfrom,msgtype,comm_world,int_mb(status(1)),
     >              mpierr)
#endif

      value = MA_pop_stack(status(2))
      if (.not.value) call errquit('popping stack memory',0,MA_ERR)
      return
      end

      logical function argos_prepare_solvat(islv,lfnout,boxs,xslv,vslv,
     + mwms,mwa,nwms,nwa,touch,box,iwmr,xw,vw,
     + mwm,nwm,xs,msa,nsa,xwc,vwc,mwmc,nwmc)
c
c $Id: argos_prepare_solvat.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      integer util_nint
      external util_nint
#endif
      integer islv,mwms,mwa,nwms,nwa,mwm,nwm,msa,nsa,lfnout
      integer nwmc,mwmc
      integer iwmr(mwm)
      real*8 xw(3,mwa,mwm),xs(3,nsa),xslv(3,mwa,mwms)
      real*8 xwc(3,mwa,mwmc),vwc(3,mwa,mwmc)
      real*8 vw(3,mwa,mwm),vslv(3,mwa,mwms)
      real*8 box(3),boxs(3),touch,dx,dy,dz
c
      integer i,j,k,is,ix,iy,iz,nx,ny,nz
      real*8 boxh(3),xc(3),touch2,x,y,z,pbc
      logical ltry
c
      if(islv.eq.0.or.nwms.le.0) goto 9999
c
      nwm=0
      touch2=touch*touch
c
      boxh(1)=0.5d0*box(1)
      boxh(2)=0.5d0*box(2)
      boxh(3)=0.5d0*box(3)
c
      nx=int(box(1)/boxs(1))+2
      ny=int(box(2)/boxs(2))+2
      nz=int(box(3)/boxs(3))+2
c
      do 4 is=1,nwms
      do 5 k=1,3
      x=0.0d0
      do 6 j=1,nwa
      x=x+xslv(k,j,is)
    6 continue
      xc(k)=x/dble(nwa)
    5 continue
c
      do 7 ix=-nx,nx
      do 8 iy=-ny,ny
      do 9 iz=-nz,nz
c
      x=xc(1)+dble(ix)*boxs(1)
      y=xc(2)+dble(iy)*boxs(2)
      z=xc(3)+dble(iz)*boxs(3)
c
      ltry=.false.
      if(islv.eq.1.or.islv.eq.3) then
      ltry=abs(x).lt.boxh(1).and.abs(y).lt.boxh(2).and.abs(z).lt.boxh(3)
      elseif(islv.eq.2) then
      ltry=(x*x+y*y+z*z).le.boxh(1)*boxh(1)
      endif
c
      if(ltry) then
      do 10 i=1,nsa
      dx=x-xs(1,i)
      dy=y-xs(2,i)
      dz=z-xs(3,i)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      dx=dx-util_nint(dx/box(1))*box(1)
      dy=dy-util_nint(dy/box(2))*box(2)
      dz=dz-util_nint(dz/box(3))*box(3)
#else
      dx=dx-nint(dx/box(1))*box(1)
      dy=dy-nint(dy/box(2))*box(2)
      dz=dz-nint(dz/box(3))*box(3)
#endif
      if(dx*dx+dy*dy+dz*dz.lt.touch2) goto 9
   10 continue
      if(nwmc.gt.0) then
      do 11 i=1,nwmc
      do 12 j=1,nwa
      dx=x-xwc(1,j,i)
      dy=y-xwc(2,j,i)
      dz=z-xwc(3,j,i)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      dx=dx-util_nint(dx/box(1))*box(1)
      dy=dy-util_nint(dy/box(2))*box(2)
      dz=dz-util_nint(dz/box(3))*box(3)
#else
      dx=dx-nint(dx/box(1))*box(1)
      dy=dy-nint(dy/box(2))*box(2)
      dz=dz-nint(dz/box(3))*box(3)
#endif
      if(dx*dx+dy*dy+dz*dz.lt.touch2) goto 9
   12 continue
   11 continue
      endif
      if(islv.eq.3) then
      pbc=aint(4.0d0*
     + (abs(x)/box(1)+abs(y)/box(2)+abs(z)/box(3))/3.0d0)
      if(pbc.ne.0.0d0) goto 9
      endif
      if(nwm.ge.mwm) 
     + call md_abort('argos_prepare_solvat: increase mwm',9999)
      nwm=nwm+1
      do 13 j=1,nwa
      xw(1,j,nwm)=xslv(1,j,is)+dble(ix)*boxs(1)
      xw(2,j,nwm)=xslv(2,j,is)+dble(iy)*boxs(2)
      xw(3,j,nwm)=xslv(3,j,is)+dble(iz)*boxs(3)
      iwmr(nwm)=0
      do 14 k=1,3
      vw(k,j,nwm)=vslv(k,j,is)
   14 continue
   13 continue
      endif
c
    9 continue
    8 continue
    7 continue
    4 continue
c
      if(util_print('restart',print_medium)) then
      if(islv.eq.1) write(lfnout,1000) box
 1000 format(/,' Solvated in box',t40,3f12.6)
      if(islv.eq.2) write(lfnout,1001) 0.5d0*box(1)
 1001 format(/,' Solvated in sphere with radius',t40,f12.6)
      if(islv.eq.3) write(lfnout,1002) box
 1002 format(/,' Solvated in truncated octahedron with size',t40,3f12.6)
      endif
c
      argos_prepare_solvat=.true.
      return
c
 9999 argos_prepare_solvat=.false.
      return
      end
 

*
* $Id: psi_lmbda_sic.f 21177 2011-10-10 17:09:43Z bylaska $
*

      subroutine psi_lmbda_sic(ispin,ne,nemaxq,npack1,
     >                     psi1,psi2,
     >                     dte,
     >                     lmbda,tmp,ierr)

      implicit none
      integer ispin,ne(2),nemaxq,npack1
      complex*16 psi1(npack1,nemaxq)
      complex*16 psi2(npack1,nemaxq)
      real*8     dte
      real*8     lmbda(*)
      real*8     tmp(*)
      integer	 ierr

*     **** parameters ****
      integer MASTER
      parameter (MASTER=0)

*     ::::  iteration limit and tolerence for non-liner equations  ::::
      integer itrlmd
      real*8  convg
      parameter (itrlmd=150, convg=1.0d-12)

*     **** local variables ****
      logical notgram
      integer taskid
      integer ms,it,nn
      integer s11,s12,s21,s22,st1,st2,sa1,sa0
      real*8  adiff
c      real*8  tmp1(1000000)

*     **** external functions ****
      real*8   Dneall_m_dmax
      external Dneall_m_dmax


      call nwpw_timing_start(3)

      call Dneall_m_size(1,nn)
      s11  = 0*nn + 1
      s12  = 1*nn + 1
      s21  = 2*nn + 1
      s22  = 3*nn + 1
      sa0  = 4*nn + 1
      sa1  = 5*nn + 1
      st1  = 6*nn + 1
      st2  = 7*nn + 1
      call dcopy(8*nn,0.0d0,0,tmp,1)

*     ::::::::::::::::::::::  Lagrangian multipliers  ::::::::::::::::::::::
      DO 640 ms=1,ispin
        notgram = .true.
        IF(ne(ms).le.0) GO TO 640

        call Dneall_ffm_sym_Multiply(ms,psi2,psi2,npack1,tmp(s22))
        call Dneall_ffm_sym_Multiply(ms,psi2,psi1,npack1,tmp(s21))
        call Dneall_ffm_sym_Multiply(ms,psi1,psi2,npack1,tmp(s12))
        call Dneall_ffm_sym_Multiply(ms,psi1,psi1,npack1,tmp(s11))

****  Begin  ADDED by Kiril *****
        call Dneall_m_Kiril_BTransform(ms,tmp(12),tmp(s21))
c        do ii=1,ne(ms)
c           do jj=1,ne(ms)
c             ii1 = -1+ii+jj*(ii-1)
c             tmp1(ii1+1)=0.5d0*(tmp(s12+ii1)+tmp(s21+ii1))
c
c           enddo
c        enddo
c
c        do ii=1,ne(ms)
c           do jj=1,ii-1
c             ii1 = -1+ii+jj*(ii-1)
c             tmp(s12+ii1)=tmp1(ii1+1)
c             tmp(s21+ii1)=tmp1(ii1+1)
c           enddo
c        enddo
****  End    ADDED by Kiril *****

*       ***** scale the overlap matrices ****
        call Dneall_m_scale_s22(ms,dte,tmp(s22))
        call Dneall_m_scale_s21(ms,dte,tmp(s21))
        call Dneall_m_scale_s21(ms,dte,tmp(s12))
        call Dneall_m_scale_s11(ms,dte,tmp(s11))
          
        call dcopy(nn,tmp(s22),1,tmp(sa0),1)

        do it=1,itrlmd
          CALL dcopy(nn,tmp(s22),1,tmp(sa1),1)

          call Dneall_mmm_Multiply(ms,
     >                              tmp(s21),tmp(sa0),1.0d0,
     >                              tmp(sa1),1.0d0)
          call Dneall_mmm_Multiply(ms,
     >                              tmp(sa0),tmp(s12),1.0d0,
     >                              tmp(sa1),1.0d0)
          call Dneall_mmm_Multiply(ms,
     >                              tmp(s11),tmp(sa0),1.0d0,
     >                              tmp(st1),0.0d0)
          call Dneall_mmm_Multiply(ms,
     >                              tmp(sa0),tmp(st1),1.0d0,
     >                              tmp(sa1),1.0d0)
          call dcopy(nn,tmp(sa1),1,tmp(st1),1)
          call daxpy(nn,(-1.0d0),tmp(sa0),1,tmp(st1),1)

          adiff = Dneall_m_dmax(ms,tmp(st1))
          if(adiff.lt.convg) GO TO 630
          call dcopy(nn,tmp(sa1),1,tmp(sa0),1)
        end do

        ierr=10
        call Parallel_taskid(taskid)
        if (taskid.eq.MASTER) then
          write(6,*) 
     >     'Warning: Lagrange Multiplier tolerance too high:',adiff
          write(6,*) '        +Try using a smaller time step'
          write(6,*) '        +Gram-Schmidt being performed, spin:',ms
        end if
c        call Dneall_f_ortho(ms,psi2,npack1)
        call Dneall_f_GramSchmidt(ms,psi2,npack1)
        notgram = .false.

  630   continue

*       :::::::::::::::::  correction due to the constraint  :::::::::::::::::
        if (notgram)
     >     call Dneall_fmf_Multiply(ms,
     >                             psi1,npack1,
     >                             tmp(sa1), dte,
     >                             psi2,1.0d0)
        call Dneall_mm_Expand(ms,tmp(sa1),lmbda)

  640 continue

c*:::::::::::::::::  correction due to the constraint  :::::::::::::::::
c      call Dneall_fmf_Multiply(0,
c     >                          psi1,npack1,
c     >                          lmbda, dte,
c     >                          psi2,1.0d0)

      call nwpw_timing_end(3)
      return
      end

      logical function argos_prepare_links(lfnout,lfnmod,filmod,
     + xatm,catm,latm,matm,lseq,cseq,mseq,nseq,
     + llnk,clnk,mlnk,nlnk,nlnkf)
c
c $Id: argos_prepare_links.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to scan database for link segments in sequence
c
c     in    lseq(1,*) = sequence segment numbers
c           mseq      = dimension of the sequence list
c           nseq      = length of sequence list
c
c     out   cseq(2,*) = sequence segment names
c
      implicit none
c
#include "util.fh"
#include "argos_prepare_common.fh"
c
c
      logical argos_prepare_short,argos_prepare_protein,
     + argos_prepare_nucleic
      integer argos_prepare_shorts
      external argos_prepare_short,argos_prepare_protein,
     + argos_prepare_nucleic,argos_prepare_shorts
c
      integer lfnout,matm,mseq,nseq,mlnk,nlnk,nlnkf,lfnmod
      character*255 filmod
      character*80 card
      real*8 xatm(3,matm)
      integer latm(5,matm)
      character*6 catm(3,matm)
      integer lseq(6,mseq),llnk(4,mlnk)
      character*5 cseq(2,mseq)
      character*4 clnk(2,mlnk)
      integer nshort,ishort(10),jshort(10)
      real*8 rshort(10)
c
      integer i,j,iu,k,l,m,nlnko,nlnkp
      integer link1,link2,link3,mol
      logical lwarn
c
      if(util_print('topology',print_debug)) then
      write(lfnout,2000)
 2000 format(/,'argos_prepare_links ')
      endif
c
c     get explicit links from input
c     -----------------------------
      open(unit=lfnmod,file=filmod(1:index(filmod,' ')-1),
     + form='formatted',status='old',err=999)
      rewind(unit=lfnmod)
   26 continue
      read(lfnmod,1000,end=99) card
 1000 format(a)
c
      if(card(1:4).eq.'link') then
      nlnk=nlnk+1
      read(card(6:80),1001)
     + llnk(1,nlnk),clnk(1,nlnk),llnk(2,nlnk),clnk(2,nlnk)
 1001 format(i5,a4,i5,a4)
      if(util_print('sequence',print_low)) then
      write(lfnout,1002)
     +  llnk(1,nlnk),clnk(1,nlnk),llnk(2,nlnk),clnk(2,nlnk)
 1002 format(' Input link   ',i5,':',a4,i5,':',a4)
      endif
      endif
      goto 26
   99 continue
      close(unit=lfnmod)
  999 continue
c
c     get atom index for links input from pdb
c     ---------------------------------------
c
      if(nlnk.gt.0) then
      do 21 i=1,nlnk
      do 22 j=1,nseq
      if(llnk(1,i).eq.lseq(1,j)) then
      llnk(1,i)=j
      goto 121
      endif
   22 continue
      call md_abort('Illegal link',i)
  121 continue
      do 212 j=1,nseq
      if(llnk(2,i).eq.lseq(1,j)) then
      llnk(2,i)=j
      goto 21
      endif
  212 continue
      call md_abort('Illegal link',i)
   21 continue
      do 23 i=1,nlnk
      do 24 j=lseq(3,llnk(1,i)),lseq(3,llnk(1,i)+1)-1
      if(clnk(1,i).eq.catm(2,j)(1:4)) llnk(3,i)=j
   24 continue
      do 25 j=lseq(3,llnk(2,i)),lseq(3,llnk(2,i)+1)-1
      if(clnk(2,i).eq.catm(2,j)(1:4)) llnk(4,i)=j
   25 continue
   23 continue
      endif
c
      nlnkf=0
      nlnkp=nlnk
      mol=0
c
c     check main chain links
c     ----------------------
c
      do 1 i=1,nseq-1
      mol=mol+1
      if(i.eq.1) lseq(4,i)=mol
      lseq(4,i+1)=mol+1
      nshort=argos_prepare_shorts(xatm,latm,matm,
     + lseq(3,i),lseq(3,i+1)-1,lseq(3,i+1),lseq(3,i+2)-1,
     + ishort,jshort,rshort)
      if(nshort.gt.0) then
      do 101 j=1,nshort
      lseq(4,i+1)=lseq(4,i)
      if(latm(5,ishort(j)).eq.0.or.latm(5,ishort(j)).gt.1) then
      latm(5,ishort(j))=2
      else
      call md_abort('inconsistent links',9999)
      endif
      if(latm(5,jshort(j)).eq.0.or.latm(5,jshort(j)).gt.1) then
      latm(5,jshort(j))=1
      else
      call md_abort('inconsistent links',9999)
      endif
      if(.not.argos_prepare_protein(ffield,cseq(1,i)).or.
     + .not.argos_prepare_protein(ffield,cseq(1,i+1))) then
      nlnk=nlnk+1
      if(nlnk.gt.mlnk) call md_abort('increase mlnk',9999)
      llnk(1,nlnk)=i
      llnk(2,nlnk)=i+1
      llnk(3,nlnk)=ishort(j)
      llnk(4,nlnk)=jshort(j)
      clnk(1,nlnk)=catm(2,ishort(j))(1:4)
      clnk(2,nlnk)=catm(2,jshort(j))(1:4)
      if(util_print('sequence',print_high)) then
      write(lfnout,1003) nlnk,
     + lseq(1,i),cseq(1,i),catm(2,ishort(j))(1:4),
     + lseq(1,i+1),cseq(1,i+1),catm(2,jshort(j))(1:4),
     + ishort(j),jshort(j),rshort(j),
     + latm(5,ishort(j)),latm(5,jshort(j))
 1003 format(' Chain link   ',i5,i5,a5,':',a6,5x,i5,a5,':',a6,
     + 3x,2i7,f12.6,2i5)
      endif
      endif
  101 continue
      endif
    1 continue
c
c     check side chain links
c     ----------------------
c
      do 2 i=1,nseq-2
      do 3 j=i+2,nseq
      nshort=argos_prepare_shorts(xatm,latm,matm,
     + lseq(3,i),lseq(3,i+1)-1,lseq(3,j),lseq(3,j+1)-1,
     + ishort,jshort,rshort)
      if(nshort.gt.0) then
      do 102 k=1,nshort
      if(latm(5,ishort(k)).ne.0) goto 102
      if(latm(5,jshort(k)).ne.0) goto 102
      if(latm(5,ishort(k)).eq.0) latm(5,ishort(k))=3
      if(latm(5,jshort(k)).eq.0) latm(5,jshort(k))=3
      nlnk=nlnk+1
      if(nlnk.gt.mlnk) call md_abort('increase mlnk',9999)
      llnk(1,nlnk)=i
      llnk(2,nlnk)=j
      llnk(3,nlnk)=ishort(k)
      llnk(4,nlnk)=jshort(k)
      clnk(1,nlnk)=catm(2,ishort(k))(1:4)
      clnk(2,nlnk)=catm(2,jshort(k))(1:4)
      if(util_print('sequence',print_high)) then
      write(lfnout,1004) nlnk,
     +  llnk(1,nlnk),clnk(1,nlnk),llnk(2,nlnk),clnk(2,nlnk),
     + ishort(k),jshort(k),rshort(k)
 1004 format(' Side link    ',2i5,':',a4,i5,':',a4,3x,2i7,f12.6)
      endif
      l=lseq(4,j)
      do 4 m=1,nseq
      if(lseq(4,m).eq.l) lseq(4,m)=lseq(4,i)
    4 continue
  102 continue
      endif
    3 continue
    2 continue
c
c     remove duplicate links
c     ----------------------
c
      if(nlnk.gt.0) then
      nlnko=nlnk
      nlnk=1
      if(nlnkp.ge.1) nlnkf=1
      do 5 i=2,nlnko
      do 6 j=1,nlnk
      if(llnk(1,i).eq.llnk(1,j).and.llnk(2,i).eq.llnk(2,j).and.
     + llnk(3,i).eq.llnk(3,j).and.llnk(4,i).eq.llnk(4,j).and.
     + clnk(1,i).eq.clnk(1,j).and.clnk(2,i).eq.clnk(2,j)) goto 5
      if(llnk(1,i).eq.llnk(2,j).and.llnk(2,i).eq.llnk(1,j).and.
     + llnk(3,i).eq.llnk(4,j).and.llnk(4,i).eq.llnk(3,j).and.
     + clnk(1,i).eq.clnk(2,j).and.clnk(2,i).eq.clnk(1,j)) goto 5
    6 continue
      nlnk=nlnk+1
      llnk(1,nlnk)=llnk(1,i)
      llnk(2,nlnk)=llnk(2,i)
      llnk(3,nlnk)=llnk(3,i)
      llnk(4,nlnk)=llnk(4,i)
      clnk(1,nlnk)=clnk(1,i)
      clnk(2,nlnk)=clnk(2,i)
      if(util_print('sequence',print_debug)) then
      write(lfnout,1005) nlnk,
     +  llnk(1,nlnk),clnk(1,nlnk),llnk(2,nlnk),clnk(2,nlnk)
 1005 format(' Link    ',2i5,':',a4,i5,':',a4)
      endif
      if(i.le.nlnkp) nlnkf=nlnk
    5 continue
      do 55 i=1,nlnk
      if(llnk(1,i).ne.llnk(2,i)) then
      if(latm(5,llnk(3,i)).eq.0) latm(5,llnk(3,i))=1
      if(latm(5,llnk(4,i)).eq.0) latm(5,llnk(4,i))=2
      endif
   55 continue
      endif
c
      do 7 i=1,nseq
      link1=0
      link2=0
      do 8 k=lseq(3,i),lseq(3,i+1)-1
      if(latm(5,k).eq.1) link1=k
      if(latm(5,k).eq.2) link2=k
    8 continue
      do 9 j=1,nseq
      if(cseq(1,i).eq.cseq(1,j)) then
      do 10 l=lseq(3,j),lseq(3,j+1)-1
      if(latm(5,l).ge.3) then
      if(catm(1,l).eq.catm(1,link1)) latm(5,l)=1
      if(catm(1,l).eq.catm(1,link2)) latm(5,l)=2
      endif
   10 continue
      endif
    9 continue
    7 continue
c
c     change amino acid segment names based on links
c     ----------------------------------------------
c
      do 11 i=1,nseq
      if(argos_prepare_protein(cseq(1,i))) goto 14
      if(argos_prepare_nucleic(cseq(1,i))) goto 16
      do 15 j=lseq(3,i),lseq(3,i+1)-1
      if(latm(5,j).eq.1) latm(5,j)=3
      if(latm(5,j).eq.2) latm(5,j)=3
   15 continue
      goto 11
   14 continue
      link1=0
      link2=0
      link3=0
      do 12 j=lseq(3,i),lseq(3,i+1)-1
      if(latm(5,j).eq.1) link1=link1+1
      if(latm(5,j).eq.2) link2=link2+1
      if(latm(5,j).ge.3) link3=link3+1
   12 continue
      iu=index(cseq(1,i),'_')
      if(iu.eq.0) iu=index(cseq(1,i),' ')
      if(link1.gt.0) then
      if(link2.eq.0) then
      cseq(1,i)(iu:iu+1)='_C'
      if(util_print('sequence',print_high)) then
      write(lfnout,1006) lseq(1,i),cseq(1,i)
 1006 format(' Segment renamed ',i5,a)
      endif
      endif
      else
      if(link2.gt.0) then
      cseq(1,i)(iu:iu+1)='_N'
      if(util_print('sequence',print_high)) then
      write(lfnout,1007) lseq(1,i),cseq(1,i)
 1007 format(' Segment renamed ',i5,a)
      endif
      else
      cseq(1,i)(iu:iu+1)='_M'
      if(util_print('sequence',print_high)) then
      write(lfnout,1008) lseq(1,i),cseq(1,i)
 1008 format(' Segment renamed ',i5,a)
      endif
      endif
      endif
      goto 11
   16 continue
      link1=0
      link2=0
      link3=0
      do 17 j=lseq(3,i),lseq(3,i+1)-1
      if(latm(5,j).eq.1) link1=link1+1
      if(latm(5,j).eq.2) link2=link2+1
      if(latm(5,j).ge.3) link3=link3+1
   17 continue
      iu=index(cseq(1,i),'_')
      if(iu.eq.0) iu=index(cseq(1,i),' ')
      if(link1.gt.0) then
      if(link2.eq.0) then
      cseq(1,i)(iu:iu+1)='_3'
      if(util_print('sequence',print_high)) then
      write(lfnout,1009) lseq(1,latm(1,i)),cseq(1,i)
 1009 format(' Segment renamed ',i5,a)
      endif
      endif
      else
      if(link2.gt.0) then
      cseq(1,i)(iu:iu+1)='_5'
      if(util_print('sequence',print_high)) then
      write(lfnout,1010) lseq(1,latm(1,i)),cseq(1,i)
 1010 format(' Segment renamed ',i5,a)
      endif
      else
      cseq(1,i)(iu:iu+1)='_M'
      if(util_print('sequence',print_high)) then
      write(lfnout,1011) lseq(1,latm(1,i)),cseq(1,i)
 1011 format(' Segment renamed ',i5,a)
      endif
      endif
      endif
   11 continue
c
c     adjust molecule number based on explicit links
c     ----------------------------------------------
c
      lwarn=.false.
      do 18 i=1,nlnk
      if(lseq(4,llnk(1,i)).ne.lseq(4,llnk(2,i))) then
      if(.not.lwarn) then
      write(lfnout,87)
   87 format(/,' Warning',//,
     + ' Explicit links were found that merge two molecules.',/,
     + ' This is usually indicative of a problem with the coordinates',
     + /,' or an incorrectly edited sequence file.',//)
      lwarn=.true.
      endif
      write(lfnout,88) i,llnk(1,i),llnk(2,i),
     + lseq(4,llnk(1,i)),lseq(4,llnk(2,i))
   88 format(' Molecule-molecule link ',5i7)
      j=lseq(4,llnk(2,i))
      do 19 k=1,nseq
      if(lseq(4,k).eq.j) then
      lseq(4,k)=lseq(4,llnk(1,i))
      elseif(lseq(4,k).gt.j) then
      lseq(4,k)=lseq(4,k)-1
      endif
   19 continue
      endif
   18 continue
c
c     assign molecule number
c     ----------------------
c
      argos_prepare_links=.true.
      return
      end

      logical function argos_prep_rdsgm(lfnout,nparms,mparms,
     + imol,isgm,igrp,
     + ipgrp,lfnsgm,filsgm,lfnmat,filmat,
     + latm,catm,qatm,matm,natm,lbnd,rbnd,mbnd,nbnd,
     + lang,rang,mang,nang,ldih,nfdih,kdih,rdih,mdih,ndih,
     + limp,kimp,rimp,mimp,nimp,
     + wcorr,npar,ipardef,itopol)
c
c $Id: argos_prep_rdsgm.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
#include "argos_prep_common.fh"
c
      external loc
      integer loc
c
      integer lfnout,lfnsgm,imol,isgm,igrp,ipgrp,lfnmat,nparms,mparms
      character*255 filsgm,filmat
      integer matm,natm,itopol
      integer latm(11,matm)
      character*6 catm(mparms,matm)
      real*8 qatm(nparms,2,matm)
      integer mbnd,nbnd
      integer lbnd(4,mbnd)
      real*8 rbnd(nparms,2,mbnd)
      integer mang,nang
      integer lang(5,mang)
      real*8 rang(nparms,4,mang)
      integer mdih,ndih
      integer ldih(6,mdih),nfdih(nparms,mdih),kdih(6,nparms,mdih)
      real*8 rdih(6,nparms,2,mdih)
      integer mimp,nimp
      integer limp(6,mimp),kimp(nparms,mimp)
      real*8 rimp(nparms,2,mimp)
      real*8 wcorr(10)
      real*8 version
c
      character*80 card
      integer i,j,k,l,length,na,jmol,nzmat,npar,ipardef,idhop
      integer nsatm,nsbnd,nsang,nsdih,nsimp,ld(6),md(10),izm(4)
      real*8 rd(10,2),zm(3)
c
      integer itemp
      real*8 dtemp
      character*6 ctemp
c
      jmol=imol
c
      length=index(filsgm,' ')-1
      open(unit=lfnsgm,file=filsgm(1:length),form='formatted',
     + status='old',err=9999)
c
      if(util_print('where',print_debug)) then
      write(lfnout,1110) filsgm(1:length)
 1110 format('READING SEGMENT FILE ',a)
      endif
c
    1 continue
      read(lfnsgm,1000) card
 1000 format(a)
      if(card(1:1).eq.'#'.or.card(1:1).eq.'$') goto 1
      read(card,1001,err=9999) version
 1001 format(f12.6)
      read(lfnsgm,1002,err=9999)
     + nsatm,nsbnd,nsang,nsdih,nsimp,nzmat,npar,ipardef
 1002 format(8i5)
      if(ipardef.eq.0) ipardef=1
      if(npar.gt.nparms) call md_abort('Error in number par sets',npar)
      do 2 i=1,npar
      read(lfnsgm,1003) wcorr(i)
 1003 format(f12.6)
    2 continue
      do 102 i=npar+1,nparms
      wcorr(i)=wcorr(npar)
  102 continue
c
      if(natm+nsatm.gt.matm) call md_abort('increase matm',9999)
      if(nbnd+nsbnd.gt.mbnd) call md_abort('increase mbnd',9999)
      if(nang+nsang.gt.mang) call md_abort('increase mang',9999)
      if(ndih+nsdih.gt.mdih) call md_abort('increase mdih',9998)
      if(nimp+nsimp.gt.mimp) call md_abort('increase mimp',9999)
c
c     read the atom list
c     ------------------
c
      na=natm
      do 3 i=1,nsatm
      natm=natm+1
      read(lfnsgm,1004) catm(1,natm),latm(3,natm),latm(4,natm),
     + latm(10,natm),latm(1,natm),latm(2,natm)
 1004 format(5x,a6,5i5)
c      write(*,1004) catm(1,natm),latm(3,natm),latm(4,natm),
c     + latm(10,natm),latm(1,natm),latm(2,natm)
      read(lfnsgm,1005) (catm(j+1,natm),qatm(j,1,natm),qatm(j,2,natm),
     + j=1,npar)
 1005 format(5x,a6,2f12.6)
c
      latm(5,natm)=isgm
      latm(6,natm)=jmol
      jmol=iabs(jmol)
      latm(1,natm)=latm(1,natm)+igrp
      latm(2,natm)=latm(2,natm)+ipgrp
c
      if(isgm.eq.0) then
      do 4 j=2,npar+1
      catm(j,natm)(6:6)='w'
    4 continue
      endif
c
      do 103 j=npar+1,nparms
      catm(j+1,natm)=catm(npar+1,natm)
      qatm(j,1,natm)=qatm(npar,1,natm)
      qatm(j,2,natm)=qatm(npar,2,natm)
  103 continue
c
      idhop=0
      do 1103 j=1,npar
      if(catm(j+1,natm)(6:6).ne.'D') idhop=idhop+2**(j-1)
 1103 continue
      latm(11,natm)=idhop
c
      if(util_print('connectivity',print_debug)) then
      write(lfnout,1004) catm(1,natm),(latm(j,natm),j=1,4)
      write(lfnout,1005) (catm(j+1,natm),qatm(j,1,natm),qatm(j,2,natm),
     + j=1,nparms)
      endif
c
      if(itopol.eq.0.and.ipardef.gt.1) then
      ctemp=catm(2,natm)
      catm(2,natm)=catm(1+ipardef,natm)
      catm(1+ipardef,natm)=ctemp
      dtemp=qatm(1,1,natm)
      qatm(1,1,natm)=qatm(ipardef,1,natm)
      qatm(ipardef,1,natm)=dtemp
      dtemp=qatm(1,2,natm)
      qatm(1,2,natm)=qatm(ipardef,2,natm)
      qatm(ipardef,2,natm)=dtemp
      endif
    3 continue
c
      igrp=latm(1,natm)
      ipgrp=latm(2,natm)
c
c     read the bond list
c     ------------------
c
      do 5 i=1,nsbnd
      nbnd=nbnd+1
      read(lfnsgm,1006) (lbnd(j,nbnd),j=1,4)
 1006 format(5x,4i5)
      read(lfnsgm,1007) (rbnd(j,1,nbnd),rbnd(j,2,nbnd),j=1,npar)
 1007 format(f12.6,e12.5)
c
      lbnd(1,nbnd)=lbnd(1,nbnd)+na
      lbnd(2,nbnd)=lbnd(2,nbnd)+na
c
      do 105 j=npar+1,nparms
      rbnd(j,1,nbnd)=rbnd(npar,1,nbnd)
      rbnd(j,2,nbnd)=rbnd(npar,2,nbnd)
  105 continue
c
      if(util_print('connectivity',print_debug)) then
      write(lfnout,1006) (lbnd(j,nbnd),j=1,4)
      write(lfnout,1007) (rbnd(j,1,nbnd),rbnd(j,2,nbnd),j=1,nparms)
      endif
c
      if(itopol.eq.0.and.ipardef.gt.1) then
      dtemp=rbnd(1,1,nbnd)
      rbnd(1,1,nbnd)=rbnd(ipardef,1,nbnd)
      rbnd(ipardef,1,nbnd)=dtemp
      dtemp=rbnd(1,2,nbnd)
      rbnd(1,2,nbnd)=rbnd(ipardef,2,nbnd)
      rbnd(ipardef,2,nbnd)=dtemp
      endif
c
    5 continue
c
c     read the angle list
c     -------------------
c
      do 6 i=1,nsang
      nang=nang+1
      read(lfnsgm,1008) (lang(j,nang),j=1,5)
 1008 format(5x,5i5)
      if(ffield(1:6).ne.'charmm') then
      read(lfnsgm,1009) (rang(j,1,nang),rang(j,2,nang),j=1,npar)
 1009 format(f10.6,e12.5)
      else
      read(lfnsgm,1019) (rang(j,1,nang),rang(j,2,nang),
     + rang(j,3,nang),rang(j,4,nang),j=1,npar)
 1019 format(2(f10.6,e12.5))
      endif
      lang(1,nang)=lang(1,nang)+na
      lang(2,nang)=lang(2,nang)+na
      lang(3,nang)=lang(3,nang)+na
c
      do 106 j=npar+1,nparms
      rang(j,1,nbnd)=rang(npar,1,nang)
      rang(j,2,nbnd)=rang(npar,2,nang)
      if(ffield(1:6).eq.'charmm') then
      rang(j,3,nbnd)=rang(npar,3,nang)
      rang(j,4,nbnd)=rang(npar,4,nang)
      endif
  106 continue
c
      if(util_print('connectivity',print_debug)) then
      write(lfnout,1008) (lang(j,nang),j=1,5)
      if(ffield(1:6).ne.'charmm') then
      write(lfnout,1009) (rang(j,1,nang),rang(j,2,nang),j=1,nparms)
      else
      write(lfnout,1019) (rang(j,1,nang),rang(j,2,nang),
     + rang(j,3,nang),rang(j,4,nang),j=1,nparms)
      endif
      endif
c
      if(itopol.eq.0.and.ipardef.gt.1) then
      dtemp=rang(1,1,nang)
      rang(1,1,nang)=rang(ipardef,1,nang)
      rang(ipardef,1,nang)=dtemp
      dtemp=rang(1,2,nang)
      rang(1,2,nang)=rang(ipardef,2,nang)
      rang(ipardef,2,nang)=dtemp
      if(ffield(1:6).eq.'charmm') then
      dtemp=rang(1,1,nang)
      rang(1,3,nang)=rang(ipardef,3,nang)
      rang(ipardef,3,nang)=dtemp
      dtemp=rang(1,4,nang)
      rang(1,4,nang)=rang(ipardef,4,nang)
      rang(ipardef,4,nang)=dtemp
      endif
      endif
c
    6 continue
c
c     read the torsion list
c     ---------------------
c
      do 7 i=1,nsdih
      read(lfnsgm,1010) (ld(j),j=1,6)
 1010 format(5x,6i5)
      read(lfnsgm,1011) (md(j),rd(j,1),rd(j,2),j=1,npar)
 1011 format(i3,f10.6,e12.5)
c
      if(itopol.eq.0.and.ipardef.gt.1) then
      itemp=md(1)
      md(1)=md(ipardef)
      md(ipardef)=itemp
      dtemp=rd(1,1)
      rd(1,1)=rd(ipardef,1)
      rd(ipardef,1)=dtemp
      dtemp=rd(1,2)
      rd(1,2)=rd(ipardef,2)
      rd(ipardef,2)=dtemp
      endif
c
      l=0
      do 8 j=1,npar
      if(md(j).ge.0) l=l+1
    8 continue
      if(l.eq.npar) then
      ndih=ndih+1
      do 9 j=1,nparms
      nfdih(j,ndih)=1
    9 continue
      do 10 j=1,6
      ldih(j,ndih)=ld(j)
   10 continue
      else
      do 11 j=1,npar
      if(md(j).lt.0) nfdih(j,ndih)=nfdih(j,ndih)+1
   11 continue
      endif
c
      do 12 l=1,nparms
      do 13 j=1,nparms
      rdih(nfdih(l,ndih),j,1,ndih)=rd(j,1)
      rdih(nfdih(l,ndih),j,2,ndih)=rd(j,2)
      kdih(nfdih(l,ndih),j,ndih)=md(j)
   13 continue
   12 continue
c
      ldih(1,ndih)=ldih(1,ndih)+na
      ldih(2,ndih)=ldih(2,ndih)+na
      ldih(3,ndih)=ldih(3,ndih)+na
      ldih(4,ndih)=ldih(4,ndih)+na
c
      do 107 j=npar+1,nparms
      nfdih(j,ndih)=nfdih(npar,ndih)
      do 117 k=1,nfdih(j,ndih)
      kdih(k,j,ndih)=kdih(k,npar,ndih)
      rdih(k,j,1,ndih)=rdih(k,npar,1,ndih)
      rdih(k,j,2,ndih)=rdih(k,npar,2,ndih)
  117 continue
  107 continue
c
      if(util_print('connectivity',print_debug)) then
      write(lfnout,1010) (ldih(j,ndih),j=1,6)
      write(lfnout,1011) ((kdih(l,j,ndih),rdih(l,j,1,ndih),
     + rdih(l,j,2,ndih),l=1,nfdih(j,ndih)),j=1,nparms)
      endif
c
    7 continue
c
c     read the improper torsion list
c     ------------------------------
c
      do 14 i=1,nsimp
      nimp=nimp+1
      if(ffield(1:5).eq.'amber') then
      read(lfnsgm,1012) limp(2,nimp),limp(3,nimp),limp(1,nimp),
     + (limp(j,nimp),j=4,6)
      else
      read(lfnsgm,1012) (limp(j,nimp),j=1,6)
      endif
 1012 format(5x,6i5)
      read(lfnsgm,1013) (kimp(j,nimp),rimp(j,1,nimp),
     + rimp(j,2,nimp),j=1,npar)
 1013 format(i3,f10.6,e12.5)
c
      limp(1,nimp)=limp(1,nimp)+na
      limp(2,nimp)=limp(2,nimp)+na
      limp(3,nimp)=limp(3,nimp)+na
      limp(4,nimp)=limp(4,nimp)+na
c
      do 114 j=npar+1,nparms
      kimp(j,nimp)=kimp(npar,nimp)
      rimp(j,1,nimp)=rimp(npar,1,nimp)
      rimp(j,2,nimp)=rimp(npar,2,nimp)
  114 continue
c
      if(util_print('connectivity',print_debug)) then
      write(lfnout,1012) (limp(j,nimp),j=1,6)
      write(lfnout,1013) (kimp(j,nimp),rimp(j,1,nimp),
     + rimp(j,2,nimp),j=1,nparms)
      endif
c
      if(itopol.eq.0.and.ipardef.gt.1) then
      itemp=kimp(1,nimp)
      kimp(1,nimp)=kimp(ipardef,nimp)
      kimp(ipardef,nimp)=itemp
      dtemp=rimp(1,1,nimp)
      rimp(1,1,nimp)=rimp(ipardef,1,nimp)
      rimp(ipardef,1,nimp)=dtemp
      dtemp=rimp(1,2,nimp)
      rimp(1,2,nimp)=rimp(ipardef,2,nimp)
      rimp(ipardef,2,nimp)=dtemp
      endif
c
   14 continue
c
c     copy the z-matrix information
c     -----------------------------
c
      if(nzmat.gt.0) then
      open(unit=lfnmat,file=filmat(1:index(filmat,' ')-1),
     + form='formatted',status='unknown',err=9999)
      do 15 i=1,nzmat
      read(lfnsgm,1014) izm,zm
      write(lfnmat,1015) izm,zm
 1014 format(5x,4i5,3f12.6)
 1015 format(4i5,3f12.6)
   15 continue
      close(unit=lfnmat)
      endif
c
      close(unit=lfnsgm)
c
      if(util_print('where',print_debug)) then
      write(lfnout,1120) filsgm(1:length)
 1120 format('READING SEGMENT FILE ',a,' DONE')
      endif
c
      argos_prep_rdsgm=.true.
      return
 9999 continue
      argos_prep_rdsgm=.false.
      return
      end
 

      logical function argos_prep_wrtnam(lfnout,lfntmp,
     + filtmp,catm,matm,natm)
c
c $Id: argos_prep_wrtnam.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
      integer lfnout,lfntmp,matm,natm
      character*255 filtmp
      character*6 catm(3,matm)
c
      integer i
c
      open(unit=lfntmp,file=filtmp(1:index(filtmp,' ')-1),
     + form='formatted',status='unknown',err=9999)
c
      do 1 i=1,natm
      write(lfntmp,1000) catm(1,i),catm(2,i)
 1000 format(2a6)
    1 continue
c
      close(unit=lfntmp)
c
      if(util_print('connectivity',print_debug)) then
      write(lfnout,1001) filtmp(1:index(filtmp,' ')-1)
 1001 format(' Atom names written to ',a)
      endif
c
      argos_prep_wrtnam=.true.
      return
c
 9999 continue
      argos_prep_wrtnam=.false.
      return
      end

      SUBROUTINE YLASET( UPLO, M, N, ALPHA, BETA, A, LDA )
c
* $Id: ylaset.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
#include "y64.fh"
      CHARACTER          UPLO
      INTEGER            LDA, M, N
      DOUBLE PRECISION   ALPHA, BETA
      DOUBLE PRECISION   A( LDA, * )
c
      INTGR4            LDA4, M4, N4
c
      lda4=lda
      m4=m
      n4=n
c
      call DLASET( UPLO, M4, N4, ALPHA, BETA, A, LDA4 )
*
      RETURN
      END

*> \brief \b DSYTRD
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DSYTRD + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dsytrd.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dsytrd.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dsytrd.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DSYTRD( UPLO, N, A, LDA, D, E, TAU, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, LWORK, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), D( * ), E( * ), TAU( * ),
*      $                   WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DSYTRD reduces a real symmetric matrix A to real symmetric
*> tridiagonal form T by an orthogonal similarity transformation:
*> Q**T * A * Q = T.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangle of A is stored;
*>          = 'L':  Lower triangle of A is stored.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*>          N-by-N upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading N-by-N lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>          On exit, if UPLO = 'U', the diagonal and first superdiagonal
*>          of A are overwritten by the corresponding elements of the
*>          tridiagonal matrix T, and the elements above the first
*>          superdiagonal, with the array TAU, represent the orthogonal
*>          matrix Q as a product of elementary reflectors; if UPLO
*>          = 'L', the diagonal and first subdiagonal of A are over-
*>          written by the corresponding elements of the tridiagonal
*>          matrix T, and the elements below the first subdiagonal, with
*>          the array TAU, represent the orthogonal matrix Q as a product
*>          of elementary reflectors. See Further Details.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          The diagonal elements of the tridiagonal matrix T:
*>          D(i) = A(i,i).
*> \endverbatim
*>
*> \param[out] E
*> \verbatim
*>          E is DOUBLE PRECISION array, dimension (N-1)
*>          The off-diagonal elements of the tridiagonal matrix T:
*>          E(i) = A(i,i+1) if UPLO = 'U', E(i) = A(i+1,i) if UPLO = 'L'.
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is DOUBLE PRECISION array, dimension (N-1)
*>          The scalar factors of the elementary reflectors (see Further
*>          Details).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The dimension of the array WORK.  LWORK >= 1.
*>          For optimum performance LWORK >= N*NB, where NB is the
*>          optimal blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup doubleSYcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  If UPLO = 'U', the matrix Q is represented as a product of elementary
*>  reflectors
*>
*>     Q = H(n-1) . . . H(2) H(1).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**T
*>
*>  where tau is a real scalar, and v is a real vector with
*>  v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in
*>  A(1:i-1,i+1), and tau in TAU(i).
*>
*>  If UPLO = 'L', the matrix Q is represented as a product of elementary
*>  reflectors
*>
*>     Q = H(1) H(2) . . . H(n-1).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**T
*>
*>  where tau is a real scalar, and v is a real vector with
*>  v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in A(i+2:n,i),
*>  and tau in TAU(i).
*>
*>  The contents of A on exit are illustrated by the following examples
*>  with n = 5:
*>
*>  if UPLO = 'U':                       if UPLO = 'L':
*>
*>    (  d   e   v2  v3  v4 )              (  d                  )
*>    (      d   e   v3  v4 )              (  e   d              )
*>    (          d   e   v4 )              (  v1  e   d          )
*>    (              d   e  )              (  v1  v2  e   d      )
*>    (                  d  )              (  v1  v2  v3  e   d  )
*>
*>  where d and e denote diagonal and off-diagonal elements of T, and vi
*>  denotes an element of the vector defining H(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DSYTRD( UPLO, N, A, LDA, D, E, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), D( * ), E( * ), TAU( * ),
     $                   WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER
      INTEGER            I, IINFO, IWS, J, KK, LDWORK, LWKOPT, NB,
     $                   NBMIN, NX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLATRD, DSYR2K, DSYTD2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.1 .AND. .NOT.LQUERY ) THEN
         INFO = -9
      END IF
*
      IF( INFO.EQ.0 ) THEN
*
*        Determine the block size.
*
         NB = ILAENV( 1, 'DSYTRD', UPLO, N, -1, -1, -1 )
         LWKOPT = N*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYTRD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      NX = N
      IWS = 1
      IF( NB.GT.1 .AND. NB.LT.N ) THEN
*
*        Determine when to cross over from blocked to unblocked code
*        (last block is always handled by unblocked code).
*
         NX = MAX( NB, ILAENV( 3, 'DSYTRD', UPLO, N, -1, -1, -1 ) )
         IF( NX.LT.N ) THEN
*
*           Determine if workspace is large enough for blocked code.
*
            LDWORK = N
            IWS = LDWORK*NB
            IF( LWORK.LT.IWS ) THEN
*
*              Not enough workspace to use optimal NB:  determine the
*              minimum value of NB, and reduce NB or force use of
*              unblocked code by setting NX = N.
*
               NB = MAX( LWORK / LDWORK, 1 )
               NBMIN = ILAENV( 2, 'DSYTRD', UPLO, N, -1, -1, -1 )
               IF( NB.LT.NBMIN )
     $            NX = N
            END IF
         ELSE
            NX = N
         END IF
      ELSE
         NB = 1
      END IF
*
      IF( UPPER ) THEN
*
*        Reduce the upper triangle of A.
*        Columns 1:kk are handled by the unblocked method.
*
         KK = N - ( ( N-NX+NB-1 ) / NB )*NB
         DO 20 I = N - NB + 1, KK + 1, -NB
*
*           Reduce columns i:i+nb-1 to tridiagonal form and form the
*           matrix W which is needed to update the unreduced part of
*           the matrix
*
            CALL DLATRD( UPLO, I+NB-1, NB, A, LDA, E, TAU, WORK,
     $                   LDWORK )
*
*           Update the unreduced submatrix A(1:i-1,1:i-1), using an
*           update of the form:  A := A - V*W**T - W*V**T
*
            CALL DSYR2K( UPLO, 'No transpose', I-1, NB, -ONE, A( 1, I ),
     $                   LDA, WORK, LDWORK, ONE, A, LDA )
*
*           Copy superdiagonal elements back into A, and diagonal
*           elements into D
*
            DO 10 J = I, I + NB - 1
               A( J-1, J ) = E( J-1 )
               D( J ) = A( J, J )
   10       CONTINUE
   20    CONTINUE
*
*        Use unblocked code to reduce the last or only block
*
         CALL DSYTD2( UPLO, KK, A, LDA, D, E, TAU, IINFO )
      ELSE
*
*        Reduce the lower triangle of A
*
         DO 40 I = 1, N - NX, NB
*
*           Reduce columns i:i+nb-1 to tridiagonal form and form the
*           matrix W which is needed to update the unreduced part of
*           the matrix
*
            CALL DLATRD( UPLO, N-I+1, NB, A( I, I ), LDA, E( I ),
     $                   TAU( I ), WORK, LDWORK )
*
*           Update the unreduced submatrix A(i+ib:n,i+ib:n), using
*           an update of the form:  A := A - V*W**T - W*V**T
*
            CALL DSYR2K( UPLO, 'No transpose', N-I-NB+1, NB, -ONE,
     $                   A( I+NB, I ), LDA, WORK( NB+1 ), LDWORK, ONE,
     $                   A( I+NB, I+NB ), LDA )
*
*           Copy subdiagonal elements back into A, and diagonal
*           elements into D
*
            DO 30 J = I, I + NB - 1
               A( J+1, J ) = E( J )
               D( J ) = A( J, J )
   30       CONTINUE
   40    CONTINUE
*
*        Use unblocked code to reduce the last or only block
*
         CALL DSYTD2( UPLO, N-I+1, A( I, I ), LDA, D( I ), E( I ),
     $                TAU( I ), IINFO )
      END IF
*
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of DSYTRD
*
      END
c $Id: dsytrd.f 24343 2013-06-22 05:35:15Z d3y133 $

      logical function argos_prep_parcnv(icomb,latt,patt,catt,matt,natt)
c
c $Id: argos_prep_parcom.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer icomb,matt,natt
      integer latt(2,matt)
      real*8 patt(4,2,matt,matt)
      character*6 catt(2,matt)
c
      integer i,j,k
      real*8 epsil,rstar
c
c     C6,C12 -> C6,C12
c
      if(icomb.eq.1) then
      endif
c
c     epsilon,sigma  -> C6,C12
c
      if(icomb.eq.2) then
      endif
c
c     epsilon,(1/2)R* -> C6,C12
c
      if(icomb.eq.3) then
      do 1 i=1,natt
      do 2 k=1,2
      epsil=patt(1,k,i,i)
      rstar=patt(2,k,i,i)
      patt(1,k,i,i)=2.0d0*epsil*((rstar+rstar)**6)
      patt(2,k,i,i)=epsil*((rstar+rstar)**12)
    2 continue
      do 3 j=i+1,natt
      if(i.ne.j) then
      do 4 k=1,2
      epsil=patt(1,k,i,j)
      rstar=patt(2,k,i,j)
      patt(1,k,i,j)=2.0d0*epsil*((rstar)**6)
      patt(1,k,j,i)=patt(1,k,i,j)
      patt(2,k,i,j)=epsil*((rstar)**12)
      patt(2,k,j,i)=patt(2,k,i,j)
    4 continue
      endif
    3 continue
    1 continue
      endif
c
c     modify parameters for self and dummy
c     ------------------------------------
c
      do 5 i=1,natt
      do 6 j=i,natt
      if((catt(1,i)(6:6).eq.'S'.and.catt(1,j)(6:6).ne.'S').or.
     + (catt(1,i)(6:6).ne.'S'.and.catt(1,j)(6:6).eq.'S')) then
      patt(1,1,i,j)=0.0d0
      patt(1,2,i,j)=0.0d0
      patt(2,1,i,j)=0.0d0
      patt(2,2,i,j)=0.0d0
      patt(1,1,j,i)=0.0d0
      patt(1,2,j,i)=0.0d0
      patt(2,1,j,i)=0.0d0
      patt(2,2,j,i)=0.0d0
      endif
    6 continue
      if(catt(1,i)(6:6).eq.'D') then
      patt(1,1,i,i)=0.0d0
      patt(1,2,i,i)=0.0d0
      patt(2,1,i,i)=0.0d0
      patt(2,2,i,i)=0.0d0
      do 7 j=1,natt
      patt(1,1,i,j)=0.0d0
      patt(1,2,i,j)=0.0d0
      patt(2,1,i,j)=0.0d0
      patt(2,2,i,j)=0.0d0
      patt(1,1,j,i)=0.0d0
      patt(1,2,j,i)=0.0d0
      patt(2,1,j,i)=0.0d0
      patt(2,2,j,i)=0.0d0
    7 continue
      endif
      if(catt(1,i)(6:6).eq.'Q'.or.catt(1,i)(6:6).eq.'H') then
      patt(1,1,i,i)=0.0d0
      patt(1,2,i,i)=0.0d0
      patt(2,1,i,i)=0.0d0
      patt(2,2,i,i)=0.0d0
      do 8 j=1,natt
      if(catt(1,j)(6:6).eq.'Q'.or.catt(1,j)(6:6).eq.'H') then
      patt(1,1,i,j)=0.0d0
      patt(1,2,i,j)=0.0d0
      patt(2,1,i,j)=0.0d0
      patt(2,2,i,j)=0.0d0
      patt(1,1,j,i)=0.0d0
      patt(1,2,j,i)=0.0d0
      patt(2,1,j,i)=0.0d0
      patt(2,2,j,i)=0.0d0
      endif
    8 continue
      endif
    5 continue
c
      argos_prep_parcnv=.true.
      return
      end
      logical function argos_prep_parcnv(icomb,latt,patt,matt,natt)
c
c $Id: argos_prep_parcom.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer icomb,matt,natt
      integer latt(2,matt)
      real*8 patt(4,2,matt,matt)
c
      integer i,j
c
c     C6,C12 -> C6,C12
c
      if(icomb.eq.1) then
      endif
c
c     epsilon,sigma  -> C6,C12
c
      if(icomb.eq.2) then
      endif
c
c     epsilon,(1/2)R* -> C6,C12
c
      if(icomb.eq.3) then
      do 1 i=1,natt
      do 2 k=1,2
      epsil=par(1,k,i,i)
      rstar=par(2,k,i,i)
      par(1,k,i,i)=2.0d0*epsil*epsil*((rstar*rstar)**6)
      par(2,k,i,i)=epsil*epsil*((rstar*rstar)**12)
    2 continue
      do 3 j=i+1,natt
      do 4 k=1,2
      epsil=par(1,k,i,j)
      rstar=par(2,k,i,j)
      par(1,k,i,i)=2.0d0*epsil*((rstar)**6)
      par(2,k,i,i)=epsil*((rstar)**12)
    4 continue
    3 continue
    1 continue
      endif
c
      argos_prep_parcom=.true.
      return
      end

      subroutine xaxpy(n,za,zx,incx,zy,incy)
*
* $Id: xaxpy.F 21373 2011-11-02 20:52:29Z d3p852 $
*
      implicit none
#include "y64.fh"
c
      double complex zx(*),zy(*),za
      integer incx,incy,n
c
      INTGR4 incx4,incy4,n4
c
      if(n.le.0)return
      incx4 = incx
      incy4 = incy
      n4 = n
      call zaxpy(n4,za,zx,incx4,zy,incy4)
      return
      end

*
* $Id: Dne.F 25846 2014-06-20 17:27:01Z bylaska $
*

#define NBLOCKS 4


*     ***********************************
*     *					*
*     *	        Dne_init		*	
*     *					*
*     ***********************************

      subroutine Dne_init(ispin_in,ne_in,map_in)
      implicit none
      integer ispin_in
      integer ne_in(2)
      integer map_in


#include "mafdecls.fh"
#include "errquit.fh"

#include "Dne.fh"

*     **** local variables ****
      logical value
      integer ms,k,i,j,npack1,nida1,n2ft3d
      integer nework,ncqmax
      integer ii,jj,icur,jcur,indx0,indx1,indx2

*     **** external functions ****
      logical  control_mparallelized
      external control_mparallelized
      integer  Parallel2d_comm_i,Parallel2d_comm_j
      external Parallel2d_comm_i,Parallel2d_comm_j
      integer  control_mreplicate_size
      external control_mreplicate_size

      ispin   = ispin_in
      ne(1)   = ne_in(1)
      ne(2)   = ne_in(2)
      

      neq(1) = 0
      neq(2) = 0
      call D1dB_init(1,ne(1),map_in)
      call D1dB_nq(1,neq(1))
      if ((ispin.eq.2).and.(ne(2).gt.0)) then
        call D1dB_init(2,ne(2),map_in)
        call D1dB_nq(2,neq(2))
      end if

      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)
      call Parallel2d_taskid_i(taskid_i)
      call Parallel2d_taskid_j(taskid_j)
      comm_i = Parallel2d_comm_i()
      comm_j = Parallel2d_comm_j()
      parallelized = (np_j.gt.1)
      mparallelized = (parallelized.and.control_mparallelized())
      mreplicate = ((np_i*np_j).gt.control_mreplicate_size())

      if (parallelized) then
         value = .true.
         mcq(1) = 0
         mcq(2) = 0
         ncq(1) = 0
         ncq(2) = 0
         ncqmax = 0
         do ms=1,ispin
             value = value.and.
     >               MA_alloc_get(mt_int,np_i,'ma',ma(2,ms),ma(1,ms))
             value = value.and.
     >               MA_alloc_get(mt_int,np_i,'ma1',ma1(2,ms),ma1(1,ms))
             value = value.and.
     >               MA_alloc_get(mt_int,np_i,'ma2',ma2(2,ms),ma2(1,ms))
             value = value.and.
     >               MA_alloc_get(mt_int,np_i,'mc',mc(2,ms),mc(1,ms))
             value = value.and.
     >               MA_alloc_get(mt_int,np_j,'na',na(2,ms),na(1,ms))
             value = value.and.
     >               MA_alloc_get(mt_int,np_j,'nc',nc(2,ms),nc(1,ms))
             if (.not.value) then
               call errquit('Dne_init: out of heap memory',0,MA_ERR)
             end if

             call icopy(np_i,0,0,int_mb(ma(1,ms)),1)
             call icopy(np_i,0,0,int_mb(ma1(1,ms)),1)
             call icopy(np_i,0,0,int_mb(ma2(1,ms)),1)
             call icopy(np_i,0,0,int_mb(mc(1,ms)),1)
             call icopy(np_j,0,0,int_mb(na(1,ms)),1)
             call icopy(np_j,0,0,int_mb(nc(1,ms)),1)

             i = 0
             j = 0
             do k=1,ne(ms)
                int_mb(mc(1,ms)+i) = int_mb(mc(1,ms)+i) + 1

                int_mb(nc(1,ms)+j) = int_mb(nc(1,ms)+j) + 1
                int_mb(na(1,ms)+j) = int_mb(na(1,ms)+j) + 1
                i = mod(i+1,np_i)
                j = mod(j+1,np_j)
             end do

             call Pack_npack(1,npack1)
             call Pack_nida(1, nida1)
             call D3dB_n2ft3d(1,n2ft3d)
             int_mb(ma(1,ms) +taskid_i) = 2*npack1
             int_mb(ma1(1,ms)+taskid_i) = 2*nida1
             int_mb(ma2(1,ms)+taskid_i) = n2ft3d
             call D3dB_Vector_iSumAll(np_i,int_mb(ma(1,ms)))
             call D3dB_Vector_iSumAll(np_i,int_mb(ma1(1,ms)))
             call D3dB_Vector_iSumAll(np_i,int_mb(ma2(1,ms)))

             mcq(ms) = int_mb(mc(1,ms)+taskid_i)
             ncq(ms) = int_mb(nc(1,ms)+taskid_j)
             ncqmax = 0
             do j=0,np_j-1
                if (int_mb(nc(1,1)+j).gt.ncqmax) 
     >             ncqmax = int_mb(nc(1,1)+j) 
             end do

             npack1_all = 0
             nida1_all  = 0
             n2ft3d_all = 0
             do i=0,np_i-1
                npack1_all = npack1_all + int_mb(ma(1,ms) +i)
                nida1_all  = nida1_all  + int_mb(ma1(1,ms)+i)
                n2ft3d_all = n2ft3d_all + int_mb(ma2(1,ms)+i)
             end do

         end do

         mdq = 0
         ndq = 0
         if ((ispin.eq.2).and.(ne(2).gt.0)) then
            value = MA_alloc_get(mt_int,np_i,'md',md(2),md(1))
            value = value.and.
     >              MA_alloc_get(mt_int,np_j,'nd',nd(2),nd(1))
            if (.not.value) then
               call errquit('Dne_init: out of heap memory',1,MA_ERR)
            end if
            call icopy(np_i,0,0,int_mb(md(1)),1)
            call icopy(np_j,0,0,int_mb(nd(1)),1)

            i = 0
            do k=1,ne(1)
               int_mb(md(1)+i) = int_mb(md(1)+i) + 1
               i = mod(i+1,np_i)
            end do

            j = 0
            do k=1,ne(2)
               int_mb(nd(1)+j) = int_mb(nd(1)+j) + 1
               j = mod(j+1,np_j)
            end do
            mdq = int_mb(md(1)+taskid_i)
            ndq = int_mb(nd(1)+taskid_j)
         end if


         value = value.and.MA_alloc_get(mt_dbl,
     >                                  2*2*64*int_mb(ma(1,1)+taskid_i),
     >                                  'work1',work1(2),work1(1))

         nework = 2*64*int_mb(nc(1,1)+taskid_j)
         if (nework.lt.mcq(1)*ncq(1)) nework = mcq(1)*ncq(1)
         value = value.and.MA_alloc_get(mt_dbl,
     >                                  3*nework,
     >                                  'work2',work2(2),work2(1))

         value = value.and.MA_alloc_get(mt_dbl,
     >                              ne(1)*ncqmax,
     >                              'bcolwork',bcolwork(2),bcolwork(1))
         value = value.and.MA_alloc_get(mt_dbl,
     >                              ne(1)*ncqmax,
     >                              'bwork2',bwork2(2),bwork2(1))
         nework = int_mb(na(1,1))
         value = value.and.MA_alloc_get(mt_dbl,
     >                              2*nework*int_mb(ma(1,1)+taskid_i),
     >                              'rwork1',rwork1(2),rwork1(1))
         value = value.and.MA_alloc_get(mt_dbl,
     >                              2*nework*int_mb(ma(1,1)+taskid_i),
     >                              'rwork2',rwork2(2),rwork2(1))
         nework = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         value = value.and.MA_alloc_get(mt_dbl,3*nework,
     >                              'mat_tmp',mat_tmp(2),mat_tmp(1))

         nework = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         value = value.and.MA_alloc_get(mt_int,nework,
     >                                 'mindx0',mindx(2,0),mindx(1,0))
         nework = mcq(1)*ncq(1)
         value = value.and.MA_alloc_get(mt_int,nework,
     >                                 'mindx1',mindx(2,1),mindx(1,1))
         if (ispin.eq.2) then
         nework = mcq(2)*ncq(2)
         value = value.and.MA_alloc_get(mt_int,nework,
     >                                 'mindx2',mindx(2,2),mindx(1,2))
         endif
         if (.not.value) 
     >      call errquit('Dne_init: out of heap memory',1,MA_ERR)

         mall(0)  = ne(1)*ne(1) + ne(2)*ne(2)
         mall(1)  = ne(1)*ne(1)
         mall(2)  = ne(2)*ne(2)
         mpack(0) = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         mpack(1) = mcq(1)*ncq(1)
         mpack(2) = mcq(2)*ncq(2)
         indx0=0
         indx1=0
         indx2=0
         jj   = 1
         jcur = 0
         do j=1,ne(1)
            ii   = 1
            icur = 0
            do i=1,ne(1)
               if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  int_mb(mindx(1,0)+indx0) = i+(j-1)*ne(1)
                  int_mb(mindx(1,1)+indx1) = i+(j-1)*ne(1)
                  indx0 = indx0 + 1
                  indx1 = indx1 + 1
               end if
               ii = ii+1
               if (ii.gt.int_mb(mc(1,1)+icur)) then
                  icur = icur + 1
                  ii   = 1
               end if
            end do
            jj = jj+1
            if (jj.gt.int_mb(nc(1,1)+jcur)) then
               jcur = jcur + 1
               jj   = 1
            end if
         end do
         if (ispin.eq.2) then
         jj   = 1
         jcur = 0
         do j=1,ne(2)
            ii   = 1
            icur = 0
            do i=1,ne(2)
               if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  int_mb(mindx(1,0)+indx0) = i+(j-1)*ne(2) + ne(1)*ne(1)
                  int_mb(mindx(1,2)+indx2) = i+(j-1)*ne(2)
                  indx0 = indx0 + 1
                  indx2 = indx2 + 1
               end if
               ii = ii+1
               if (ii.gt.int_mb(mc(1,2)+icur)) then
                  icur = icur + 1
                  ii   = 1
               end if
            end do
            jj = jj+1
            if (jj.gt.int_mb(nc(1,2)+jcur)) then
               jcur = jcur + 1
               jj   = 1
            end if
         end do
         end if

         if ((ispin.eq.2).and.(ne(2).gt.0)) then
            nework = mdq*ndq
            value = value.and.MA_alloc_get(mt_int,nework,
     >                                 'smindx',smindx(2),smindx(1))
            small  = ne(1)*ne(2)
            smpack = mdq*ndq
            indx2=0
            jj   = 1
            jcur = 0
            do j=1,ne(2)
               ii   = 1
               icur = 0
               do i=1,ne(1)
               if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
                  int_mb(smindx(1)+indx2) = i+(j-1)*ne(1)
                  indx2 = indx2 + 1
               end if
               ii = ii+1
               if (ii.gt.int_mb(md(1)+icur)) then
                  icur = icur + 1
                  ii   = 1
               end if
               end do
               jj = jj+1
               if (jj.gt.int_mb(nd(1)+jcur)) then
                  jcur = jcur + 1
                  jj   = 1
               end if
            end do
         end if

      end if

      return
      end


*     ***********************************
*     *					*
*     *	          Dne_end   		*	
*     *					*
*     ***********************************

      subroutine Dne_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "Dne.fh"

*     ***** local variables ****
      logical value
      integer ms

      call D1dB_end(1)
      if ((ispin.eq.2).and.(ne(2).gt.0)) call D1dB_end(2)
      if (parallelized) then
         value = .true.
         do ms=1,ispin
            value = value.and.MA_free_heap(ma(2,ms))
            value = value.and.MA_free_heap(ma1(2,ms))
            value = value.and.MA_free_heap(ma2(2,ms))
            value = value.and.MA_free_heap(na(2,ms))
            value = value.and.MA_free_heap(mc(2,ms))
            value = value.and.MA_free_heap(nc(2,ms))
         end do
         if ((ispin.eq.2).and.(ne(2).gt.0)) then
            value = value.and.MA_free_heap(md(2))
            value = value.and.MA_free_heap(nd(2))
            value = value.and.MA_free_heap(smindx(2))
         end if
         value = value.and.MA_free_heap(work1(2))
         value = value.and.MA_free_heap(work2(2))
         value = value.and.MA_free_heap(bcolwork(2))
         value = value.and.MA_free_heap(bwork2(2))
         value = value.and.MA_free_heap(rwork1(2))
         value = value.and.MA_free_heap(rwork2(2))
         value = value.and.MA_free_heap(mat_tmp(2))
         value = value.and.MA_free_heap(mindx(2,0))
         value = value.and.MA_free_heap(mindx(2,1))
         if (ispin.eq.2) value = value.and.MA_free_heap(mindx(2,2))
        if (.not.value) then
           call errquit('Dne_end: error deallocating heap memory',
     >                  0,MA_ERR)
        end if
      end if

      return
      end
         

*     ***********************************
*     *					*
*     *	          Dneall_ntoqp 		*	
*     *					*
*     ***********************************

      subroutine Dneall_ntoqp(n,q,p)      
      implicit none
      integer n,q,p

#include "Dne.fh"

      if (n.le.ne(1)) then
        call D1dB_ktoqp(1,n,q,p)
      else
        call D1dB_ktoqp(2,n-ne(1),q,p)
        q = q + neq(1)
      end if

      return
      end




*     ***********************************
*     *                                 *
*     *           Dneall_qton           *
*     *                                 *
*     ***********************************

      subroutine Dneall_qton(q,n)
      implicit none
      integer n,q

#include "Dne.fh"

      if (q.le.neq(1)) then
        call D1dB_qtok(1,q,n)
      else
        call D1dB_qtok(2,q-neq(1),n)
        n = n + ne(1)
      end if

      return
      end



*     ***********************************
*     *					*
*     *	        Dneall_neq		*	
*     *					*
*     ***********************************

      subroutine Dneall_neq(nqtmp)
      implicit none
      integer nqtmp(2)

#include "Dne.fh"

      nqtmp(1) = neq(1)
      nqtmp(2) = neq(2)
      return 
      end


*     ***********************************
*     *					*
*     *	        Dneall_ne 		*	
*     *					*
*     ***********************************

      subroutine Dneall_ne(netmp)
      implicit none
      integer netmp(2)

#include "Dne.fh"

      netmp(1) = ne(1)
      netmp(2) = ne(2)
      return 
      end



*     ***********************************
*     *                                 *
*     *         Dneall_na               *
*     *                                 *
*     ***********************************

      integer function Dneall_na(ms,jj)
      implicit none
      integer ms,jj

#include "mafdecls.fh"
#include "Dne.fh"

      Dneall_na = int_mb(na(1,ms)+jj)
      return
      end



*     ***********************************
*     *                                 *
*     *         Dneall_na_ptr           *
*     *                                 *
*     ***********************************

      integer function Dneall_na_ptr(ms)
      implicit none
      integer ms

#include "Dne.fh"

      Dneall_na_ptr = na(1,ms)
      return
      end


c
c
c
c     ****************************************
c     *                                      *
c     *        Dneall_m_size                 *
c     *                                      *
c     ****************************************
      subroutine Dneall_m_size(mb,size)
      implicit none
      integer mb
      integer size

#include "Dne.fh"
     
      if (mparallelized) then
         if (mb.eq.0) then
            size = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         else
            size = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then 
            size = ne(1)*ne(1) + ne(2)*ne(2)
         else
            size = ne(mb)*ne(mb)
         end if
      end if
     
      return
      end

c
c
c
c     ****************************************
c     *                                      *
c     *        Dneall_m_allocate_block       *
c     *                                      *
c     ****************************************
      logical function Dneall_m_allocate_block(mb,nb,hml)
      implicit none
      integer mb,nb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size
     
      if (mparallelized) then
         if (mb.eq.0) then
            size = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         else
            size = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then 
            size = ne(1)*ne(1) + ne(2)*ne(2)
         else
            size = ne(mb)*ne(mb)
         end if
      end if
     
      Dneall_m_allocate_block 
     > = MA_alloc_get(mt_dbl,nb*size,'hmlab',hml(2),hml(1))
      return
      end
c
c
c
c     ****************************************
c     *                                      *
c     *        Dneall_m_allocate             *
c     *                                      *
c     ****************************************
      logical function Dneall_m_allocate(mb,hml)
      implicit none
      integer mb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size
     
      if (mparallelized) then
         if (mb.eq.0) then
            size = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         else
            size = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then 
            size = ne(1)*ne(1) + ne(2)*ne(2)
         else
            size = ne(mb)*ne(mb)
         end if
      end if
     
      Dneall_m_allocate = MA_alloc_get(mt_dbl,size,'hmla',hml(2),hml(1))
      return
      end


c
c
c
c     ****************************************
c     *                                      *
c     *        Dneall_w_allocate             *
c     *                                      *
c     ****************************************
      logical function Dneall_w_allocate(mb,hml)
      implicit none
      integer mb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size

      if (mparallelized) then
         if (mb.eq.0) then
            size = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         else
            size = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then
            size = ne(1)*ne(1) + ne(2)*ne(2)
         else
            size = ne(mb)*ne(mb)
         end if
      end if

      Dneall_w_allocate=MA_alloc_get(mt_dcpl,size,'hmla',hml(2),hml(1))
      return
      end


c
c
c
c     ****************************************
c     *                                      *
c     *        Dneall_w_push_get             *
c     *                                      *
c     ****************************************
      logical function Dneall_w_push_get(mb,hml)
      implicit none
      integer mb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size

      if (mparallelized) then
         if (mb.eq.0) then
            size = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         else 
            size = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then
            size = ne(1)*ne(1) + ne(2)*ne(2)
         else
            size = ne(mb)*ne(mb)
         end if
      end if

      Dneall_w_push_get=MA_push_get(mt_dcpl,size,'hmla',hml(2),hml(1))
      return
      end


c
c     ****************************************
c     *                                      *
c     *        Dneall_m_free                 *
c     *                                      *
c     ****************************************
      logical function Dneall_m_free(hml)
      implicit none
      integer hml(2)

#include "mafdecls.fh"

      Dneall_m_free = MA_free_heap(hml(2))
      return
      end


c
c     ****************************************
c     *                                      *
c     *        Dneall_w_free                 *
c     *                                      *
c     ****************************************
      logical function Dneall_w_free(hml)
      implicit none
      integer hml(2)

#include "mafdecls.fh"

      Dneall_w_free = MA_free_heap(hml(2))
      return
      end

c
c     ****************************************
c     *                                      *
c     *        Dneall_m_push_get             *
c     *                                      *
c     ****************************************
      logical function Dneall_m_push_get(mb,hml)
      implicit none
      integer mb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size

      if (mparallelized) then
         if (mb.eq.0) then
            size = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         else
            size = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then
            size = ne(1)*ne(1) + ne(2)*ne(2)
         else
            size = ne(mb)*ne(mb)
         end if
      end if

      Dneall_m_push_get = MA_push_get(mt_dbl,size,'hmls',hml(2),hml(1))
      return
      end


c
c     ****************************************
c     *                                      *
c     *        Dneall_m_push_get_block       *
c     *                                      *
c     ****************************************
      logical function Dneall_m_push_get_block(mb,nb,hml)
      implicit none
      integer mb,nb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size

      if (mparallelized) then
         if (mb.eq.0) then
            size = mcq(1)*ncq(1) + mcq(2)*ncq(2)
         else
            size = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then
            size = ne(1)*ne(1) + ne(2)*ne(2)
         else
            size = ne(mb)*ne(mb)
         end if
      end if

      Dneall_m_push_get_block 
     >  = MA_push_get(mt_dbl,nb*size,'hmlsb',hml(2),hml(1))
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_m_pop_stack            *
c     *                                      *
c     ****************************************
      logical function Dneall_m_pop_stack(hml)
      implicit none
      integer hml(2)

#include "mafdecls.fh"

      Dneall_m_pop_stack = MA_pop_stack(hml(2))
      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_w_pop_stack            *
c     *                                      *
c     ****************************************
      logical function Dneall_w_pop_stack(hml)
      implicit none
      integer hml(2)

#include "mafdecls.fh"

      Dneall_w_pop_stack = MA_pop_stack(hml(2))
      return
      end


c
c
c
c     ****************************************
c     *                                      *
c     *        Dneall_sm_size                *
c     *                                      *
c     ****************************************
      subroutine Dneall_sm_size(size)
      implicit none
      integer size

#include "Dne.fh"

      if (mparallelized) then
         size = mdq*ndq
      else
         size = ne(1)*ne(2)
      end if
      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_sm_push_get            *
c     *                                      *
c     ****************************************
      logical function Dneall_sm_push_get(hml)
      implicit none
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size

      if (mparallelized) then
         size = mdq*ndq
      else
         size = ne(1)*ne(2)
      end if

      Dneall_sm_push_get = MA_push_get(mt_dbl,size,'hmls',hml(2),hml(1))
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_sm_pop_stack           *
c     *                                      *
c     ****************************************
      logical function Dneall_sm_pop_stack(hml)
      implicit none
      integer hml(2)

#include "mafdecls.fh"

      Dneall_sm_pop_stack = MA_pop_stack(hml(2))
      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_fmf_Multiply           *
c     *                                      *
c     ****************************************

*  uses rotation algorithm

      subroutine Dneall_fmf_Multiply(mb,Ain,npack1,
     >                                   hml,alpha,
     >                                   Aout,beta)
      implicit none
      integer    mb
      complex*16 Ain(*)
      integer    npack1
      real*8     hml(*)
      real*8     alpha
      complex*16 Aout(*)
      real*8     beta

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift,shift2,shift3,ishift2,ishift3

c      call Pack_npack(1,npack1)

      call nwpw_timing_start(16)
      if (parallelized) then
       if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
            ishift3 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
            ishift3 = 0
         end if

         if (mparallelized) then
         do ms=ms1,ms2
            shift  = 1 + (ms-1)*neq(1)*npack1
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm1_rot(npack1_all,ne(ms),ne(ms),
     >             alpha,
     >             Ain(shift),int_mb(ma(1,ms)+taskid_i),
     >                        int_mb(ma(1,ms)),
     >                        int_mb(na(1,ms)),
     >             hml(shift2),mcq(ms),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             beta,
     >             Aout(shift),int_mb(ma(1,ms)+taskid_i),
     >                         int_mb(ma(1,ms)),
     >                         int_mb(na(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(bcolwork(1)),dbl_mb(bwork2(1)),
     >             dbl_mb(rwork1(1)),dbl_mb(rwork2(1)))
         end do
         else
c         call Dneall_m_scatter(mpack(mb),int_mb(mindx(1,mb)),
c     >                         hml,dbl_mb(mat_tmp(1)))
         do ms=ms1,ms2
            shift  = 1 + (ms-1)*neq(1)*npack1
c            shift2 =     (ms-1)*ishift2
c            call DMatrix_dgemm1_rot(npack1_all,ne(ms),ne(ms),
c     >             alpha,
c     >             Ain(shift),int_mb(ma(1,ms)+taskid_i),
c     >                        int_mb(ma(1,ms)),
c     >                        int_mb(na(1,ms)),
c     >             dbl_mb(mat_tmp(1)+shift2),mcq(ms),
c     >                         int_mb(mc(1,ms)),
c     >                         int_mb(nc(1,ms)),
c     >             beta,
c     >             Aout(shift),int_mb(ma(1,ms)+taskid_i),
c     >                         int_mb(ma(1,ms)),
c     >                         int_mb(na(1,ms)),
c     >             taskid_i,taskid_j,
c     >             np_i,np_j,
c     >             comm_i, comm_j,
c     >             dbl_mb(bcolwork(1)),dbl_mb(bwork2(1)),
c     >             dbl_mb(rwork1(1)),dbl_mb(rwork2(1)))
            shift3 = 1 + (ms-1)*ishift3
            call DMatrix_dgemm1_rot2(npack1_all,ne(ms),ne(ms),
     >             alpha,
     >             Ain(shift),int_mb(ma(1,ms)+taskid_i),
     >                        int_mb(ma(1,ms)),
     >                        int_mb(na(1,ms)),
     >             hml(shift3),mcq(ms),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             beta,
     >             Aout(shift),int_mb(ma(1,ms)+taskid_i),
     >                         int_mb(ma(1,ms)),
     >                         int_mb(na(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(bcolwork(1)),dbl_mb(bwork2(1)),
     >             dbl_mb(rwork1(1)),dbl_mb(rwork2(1)))
         end do
         end if


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = ne(ms)
            if (n.le.0) go to 30
            shift  = 1 + (ms-1)*ne(1)*npack1
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('N','N',2*npack1,n,n,
     >                (alpha),
     >                Ain(shift),  2*npack1,
     >                hml(shift2),    n,
     >                (beta),
     >                Aout(shift),2*npack1)
   30       continue
         end do
      end if

      call nwpw_timing_end(16)
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_fmf_Multiply          *
c     *                                      *
c     ****************************************

*  uses summa algorithm

      subroutine Dneall_fmf_Multiply_summa(mb,Ain,npack1,
     >                                     hml,alpha,
     >                                     Aout,beta)
      implicit none
      integer    mb
      complex*16 Ain(*)
      integer    npack1
      real*8     hml(*)
      real*8     alpha
      complex*16 Aout(*)
      real*8     beta
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift,shift2,ishift2

c      call Pack_npack(1,npack1)

      call nwpw_timing_start(16)
      if (parallelized) then
       if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         if (mparallelized) then
         do ms=ms1,ms2
            shift  = 1 + (ms-1)*neq(1)*npack1
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm1(npack1_all,ne(ms),ne(ms),64,
     >             alpha,
     >             Ain(shift),int_mb(ma(1,ms)+taskid_i),
     >                        int_mb(ma(1,ms)),
     >                        int_mb(na(1,ms)),
     >             hml(shift2),mcq(ms),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             beta,
     >             Aout(shift),int_mb(ma(1,ms)+taskid_i),
     >                         int_mb(ma(1,ms)),
     >                         int_mb(na(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

         end do
         else
         call Dneall_m_scatter(mpack(mb),int_mb(mindx(1,mb)),
     >                         hml,dbl_mb(mat_tmp(1)))
         do ms=ms1,ms2
            shift  = 1 + (ms-1)*neq(1)*npack1
            shift2 =     (ms-1)*ishift2
            call DMatrix_dgemm1(npack1_all,ne(ms),ne(ms),64,
     >             alpha,
     >             Ain(shift),int_mb(ma(1,ms)+taskid_i),
     >                        int_mb(ma(1,ms)),
     >                        int_mb(na(1,ms)),
     >             dbl_mb(mat_tmp(1)+shift2),mcq(ms),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             beta,
     >             Aout(shift),int_mb(ma(1,ms)+taskid_i),
     >                         int_mb(ma(1,ms)),
     >                         int_mb(na(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

         end do
         end if
         
      else
         if (mb.eq.0) then
            ms1 = 1    
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = ne(ms)
            if (n.le.0) go to 30
            shift  = 1 + (ms-1)*ne(1)*npack1
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('N','N',2*npack1,n,n,
     >                (alpha),
     >                Ain(shift),  2*npack1,
     >                hml(shift2),    n,
     >                (beta),
     >                Aout(shift),2*npack1)
   30       continue
         end do
      end if

      call nwpw_timing_end(16)
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_ffm_sym_Multiply      *
c     *                                      *
c     ****************************************

      subroutine Dneall_ffm_sym_Multiply(mb,A1,A2,npack1,hml)
      implicit none
      integer    mb
      complex*16 A1(*),A2(*)
      integer    npack1
      real*8     hml(*)
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift,shift2,ishift2

      call nwpw_timing_start(15)
      if (parallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         if (mparallelized) then
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift  = 1 + (ms-1)*neq(1)*npack1
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),npack1_all,128,
     >             2.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i), 
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i), 
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             hml(shift2),int_mb(mc(1,ms)+taskid_i), 
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_dgemm2(ne(ms),ne(ms),nida1_all,128,
     >             -1.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i), 
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i), 
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             1.0d0,
     >             hml(shift2),int_mb(mc(1,ms)+taskid_i), 
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  20        continue
         end do
         else
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 21
            shift  = 1 + (ms-1)*neq(1)*npack1
            shift2 =     (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),npack1_all,128,
     >             2.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             dbl_mb(mat_tmp(1)+shift2),int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_dgemm2(ne(ms),ne(ms),nida1_all,128,
     >             -1.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             1.0d0,
     >             dbl_mb(mat_tmp(1)+shift2),int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  21        continue
         end do
         call Dneall_m_gather(mall(mb),mpack(mb),int_mb(mindx(1,mb)),
     >                        dbl_mb(mat_tmp(1)),hml)

         end if
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            shift  = 1 + (ms-1)*ne(1)*npack1
            shift2 = 1 + (ms-1)*ishift2
            n     = ne(ms)
            if (n.le.0) go to 30

            call Pack_ccm_sym_dot(1,n,
     >                        A1(shift),
     >                        A2(shift),
     >                        hml(shift2))
  30        continue
         end do
      end if

      call nwpw_timing_end(15)
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_ffm_Multiply          *
c     *                                      *
c     ****************************************

      subroutine Dneall_ffm_Multiply(mb,A1,A2,npack1,hml)
      implicit none
      integer    mb
      complex*16 A1(*),A2(*)
      integer    npack1
      real*8     hml(*)
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift2,ishift2,shift

      call nwpw_timing_start(15)
      if (parallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         if (mparallelized) then
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift  = 1 + (ms-1)*neq(1)*npack1
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),npack1_all,128,
     >             2.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             hml(shift2),int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_dgemm2(ne(ms),ne(ms),nida1_all,128,
     >             -1.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             1.0d0,
     >             hml(shift2),int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  20        continue
         end do
         else
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 21
            shift  = 1 + (ms-1)*neq(1)*npack1
            shift2 =     (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),npack1_all,128,
     >             2.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             dbl_mb(mat_tmp(1)+shift2),int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_dgemm2(ne(ms),ne(ms),nida1_all,128,
     >             -1.0d0,
     >             A1(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             1.0d0,
     >             dbl_mb(mat_tmp(1)+shift2),int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  21        continue
         end do
         call Dneall_m_gather(mall(mb),mpack(mb),int_mb(mindx(1,mb)),
     >                        dbl_mb(mat_tmp(1)),hml)
         end if
         
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            shift  = 1+(ms-1)*ne(1)*npack1
            shift2 = 1+(ms-1)*ishift2
            n     = ne(ms)
            if (n.le.0) go to 30

            call Pack_ccm_dot(1,n,
     >                        A1(shift),
     >                        A2(shift),
     >                        hml(shift2))
  30        continue
         end do
      end if

      call nwpw_timing_end(15)
      return
      end




c     ****************************************
c     *                                      *
c     *        Dneall_ffsm_Multiply          *
c     *                                      *
c     ****************************************

      subroutine Dneall_ffsm_Multiply(A1,A2,npack1,hml)
      implicit none
      complex*16 A1(*),A2(*)
      integer    npack1
      real*8     hml(*)
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift2,ishift2,shift

      call nwpw_timing_start(15)
      if (parallelized) then

         if (mparallelized) then

            if (ne(2).le.0) go to 20
            shift  = 1 + neq(1)*npack1
            call DMatrix_dgemm2(ne(1),ne(2),npack1_all,128,
     >             2.0d0,
     >             A1,       int_mb(ma(1,1)+taskid_i),
     >                       int_mb(ma(1,1)),
     >                       int_mb(na(1,1)),
     >             A2(shift),int_mb(ma(1,2)+taskid_i),
     >                       int_mb(ma(1,2)),
     >                       int_mb(na(1,2)),
     >             0.0d0,
     >             hml,        int_mb(md(1)+taskid_i),
     >                         int_mb(md(1)),
     >                         int_mb(nd(1)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_dgemm2(ne(1),ne(2),nida1_all,128,
     >             -1.0d0,
     >             A1,       int_mb(ma(1,1)+taskid_i),
     >                       int_mb(ma1(1,1)),
     >                       int_mb(na(1,1)),
     >             A2(shift),int_mb(ma(1,2)+taskid_i),
     >                       int_mb(ma1(1,2)),
     >                       int_mb(na(1,2)),
     >             1.0d0,
     >             hml,        int_mb(md(1)+taskid_i),
     >                         int_mb(md(1)),
     >                         int_mb(nd(1)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  20        continue

         else

            if (ne(2).le.0) go to 21
            shift  = 1 + neq(1)*npack1
            call DMatrix_dgemm2(ne(1),ne(2),npack1_all,128,
     >             2.0d0,
     >             A1,       int_mb(ma(1,1)+taskid_i),
     >                       int_mb(ma(1,1)),
     >                       int_mb(na(1,1)),
     >             A2(shift),int_mb(ma(1,2)+taskid_i),
     >                       int_mb(ma(1,2)),
     >                       int_mb(na(1,2)),
     >             0.0d0,
     >             dbl_mb(mat_tmp(1)),int_mb(md(1)+taskid_i),
     >                                int_mb(md(1)),
     >                                int_mb(nd(1)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_dgemm2(ne(1),ne(2),nida1_all,128,
     >             -1.0d0,
     >             A1,       int_mb(ma(1,1)+taskid_i),
     >                       int_mb(ma1(1,1)),
     >                       int_mb(na(1,1)),
     >             A2(shift),int_mb(ma(1,2)+taskid_i),
     >                       int_mb(ma1(1,2)),
     >                       int_mb(na(1,2)),
     >             1.0d0,
     >             dbl_mb(mat_tmp(1)),int_mb(md(1)+taskid_i),
     >                         int_mb(md(1)),
     >                         int_mb(nd(1)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call Dneall_m_gather(small,smpack,int_mb(smindx(1)),
     >                        dbl_mb(mat_tmp(1)),hml)

  21        continue
         end if
         
      else

         shift  = 1+ne(1)*npack1
         if (ne(2).le.0) go to 30

         call Pack_ccmn_dot(1,ne(1),ne(2),
     >                     A1,
     >                     A2(shift),
     >                     hml)
  30        continue
      end if

      call nwpw_timing_end(15)
      return
      end




c     ****************************************
c     *                                      *
c     *        Dneall_m_diagonalize         *
c     *                                      *
c     ****************************************

*   This routine diagonalizes hml = v*eig*v'.  On exit hml is replaced by v.

      subroutine Dneall_m_diagonalize(mb,hml,eig,assending)
      implicit none
      integer    mb
      real*8     hml(*),eig(*)
      logical    assending

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     ***** local variables ****
      integer MASTER
      parameter (MASTER=0)
      logical value
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,ierr
      integer tmp1(2),V(2),VV(2),Q(2),tu(2),ework(2)



      call nwpw_timing_start(17)
      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
            call dcopy((ne(1)+ne(2)),0.0d0,0,eig,1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            call dcopy(ne(mb),0.0d0,0,eig,1)
         end if
         value = MA_push_get(mt_dbl,mcq(1)*ncq(1),'V',V(2),V(1))
         value = value.and.
     >           MA_push_get(mt_dbl,mcq(1)*ncq(1),'VV',VV(2),VV(1))
         value = value.and.
     >           MA_push_get(mt_dbl,mcq(1)*ncq(1),'Q',Q(2),Q(1))
         value = value.and.
     >           MA_push_get(mt_dbl,ne(1),'tu',tu(2),tu(1))
         value = value.and.
     >           MA_push_get(mt_dbl,ne(1),'ework',ework(2),ework(1))
         if (.not. value) 
     >      call errquit('Dneall_m_diagonalize:out of stack',
     >                    0,MA_ERR)
         do ms=ms1,ms2
            shift1 = 1+(ms-1)*ishift1
            shift2 = 1+(ms-1)*ishift2

      
            call nwpw_timing_start(22)
            call DMatrix_tredq(ne(ms),
     >                hml(shift2),dbl_mb(Q(1)),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j,
     >                np_i,np_j,
     >                comm_i,comm_j,
     >                dbl_mb(work1(1)),dbl_mb(work2(1)),
     >                dbl_mb(V(1)),dbl_mb(VV(1)))
            call nwpw_timing_end(22)

            call nwpw_timing_start(23)
            call DMatrix_getdiags(ne(ms),
     >                eig(shift1),dbl_mb(tu(1)),
     >                hml(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j,
     >                np_i,np_j,
     >                comm_i,comm_j,
     >                dbl_mb(ework(1)))
            call dcopy(mcq(ms)*ncq(ms),dbl_mb(Q(1)),1,hml(shift2),1)
            call nwpw_timing_end(23)

            call nwpw_timing_start(24)
            call DMatrix_tqliq(ne(ms),
     >                eig(shift1),dbl_mb(tu(1)),
     >                hml(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j,
     >                np_i,np_j,
     >                comm_i,comm_j,
     >                dbl_mb(work1(1)),dbl_mb(work2(1)))
            call nwpw_timing_end(24)

            call nwpw_timing_start(25)
            if (.not.assending)
     >      call DMatrix_eigsrtq(ne(ms),
     >              eig(shift1),
     >              hml(shift2),
     >              mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >              taskid_i,taskid_j,
     >              np_i,np_j,
     >              comm_i,comm_j,
     >              dbl_mb(work1(1)),dbl_mb(work2(1)))
            call nwpw_timing_end(25)

         end do

  
 

         value =           MA_pop_stack(ework(2))
         value = value.and.MA_pop_stack(tu(2))
         value = value.and.MA_pop_stack(Q(2))
         value = value.and.MA_pop_stack(VV(2))
         value = value.and.MA_pop_stack(V(2))
         if (.not. value) 
     >    call errquit('error popping stack in Dneall_m_diagonalize',
     >                 0,MA_ERR)


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
            call dcopy((ne(1)+ne(2)),0.0d0,0,eig,1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            call dcopy(ne(mb),0.0d0,0,eig,1)
         end if

         value = MA_push_get(mt_dbl,(2*ne(1)*ne(1)),
     >                       'tmp1',tmp1(2),tmp1(1))
         if (.not. value) 
     >      call errquit('Dneall_m_diagonalize:out of stack',
     >                    1,MA_ERR)

*        ***** diagonalize the matrix *****
         do ms=ms1,ms2
            shift1 = 1+(ms-1)*ishift1
            shift2 = 1+(ms-1)*ishift2
            if (ne(ms).le.0) go to 30

            call DSYEV('V','U',ne(ms),
     >                 hml(shift2),ne(ms), 
     >                 eig(shift1),
     >                 dbl_mb(tmp1(1)),2*ne(1)*ne(1),
     >                 ierr)

            if (.not.assending)
     >         call eigsrt(eig(shift1),
     >                   hml(shift2),
     >                   ne(ms),ne(ms))

  30        continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,ne(1)*ne(1)+ne(2)*ne(2),
     >                                  hml)
         else
            call Parallel_Brdcst_values(MASTER,ne(mb)*ne(mb),hml)
         end if

         value = MA_pop_stack(tmp1(2))
         if (.not. value) 
     >    call errquit('error popping stack in Dneall_m_diagonalize',
     >                 0,MA_ERR)

      end if

      call nwpw_timing_end(17)
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_m_SVD                 *
c     *                                      *
c     ****************************************

*
*    Computes the SVD decomposition of A = U*S*V', where A is an neall x neall matrix.

      subroutine Dneall_m_SVD(mb,A,U,S,V)
      implicit none
      integer    mb
      real*8 A(*),U(*)
      real*8 S(*),V(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift,tmp2(2)
      integer nj
      real*8 sum

*     ***** external functions ****
      real*8   ddot
      external ddot

      if (mb.eq.0) then
         ms1 = 1
         ms2 = ispin
         nj  = ne(1)+ne(2)
      else
         ms1 = mb
         ms2 = mb
         nj  = ne(mb)
      end if

*     **** generate V and Sigma^2 ****
      call Dneall_mmm_Multiply2(mb,A,A,V)
      call Dneall_m_diagonalize(mb,V,S,.false.)

*     **** generate U*Sigma ****
      call Dneall_mmm_Multiply(mb,A,V,1.0d0,U,0.0d0)

*     **** normalize U*sigma ****
      do ms=1,ispin
         shift = 1+(ms-1)*ne(1)*ne(1)
         do n=1,ne(ms)
            sum = ddot(ne(ms),U(shift),1,U(shift),1)
            sum = 1.0d0/dsqrt(sum)
            call dscal(ne(ms),sum,U(shift),1)
            shift = shift + ne(ms)
         end do
      end do

*     **** calculated sqrt(S^2) ****
      do n=1,nj
         if (S(n).lt.0.0d0) S(n) = dabs(S(n))
         S(n) = dsqrt(S(n))
      end do

      return
      end







c     ****************************************
c     *                                      *
c     *        Dneall_f_SVD                 *
c     *                                      *
c     ****************************************

*   This routine computes the SVD decomposition of A = U*S*V'
*  where A has a dimension of A(npack1,neall)

      subroutine Dneall_f_SVD(mb,A,U,npack1,S,V)
      implicit none
      integer    mb
      complex*16 A(*),U(*)
      integer    npack1      
      real*8     S(*),V(*)

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift,tmp2(2)
      integer nj   

      if (mb.eq.0) then
         ms1 = 1
         ms2 = ispin
         nj  = ne(1)+ne(2)
      else
         ms1 = mb
         ms2 = mb
         nj  = ne(mb)
      end if

*     **** generate V and Sigma^2 ****
      call Dneall_ffm_sym_Multiply(mb,A,A,npack1,V)
      call Dneall_m_diagonalize(mb,V,S,.false.)

*     **** generate U*Sigma ****
      call Dneall_fmf_Multiply(mb,A,npack1,V,1.0d0,U,0.0d0)

      
*     **** normalize U*sigma ****
      if (.not. MA_push_get(mt_dbl,neq(1),'tmp2',tmp2(2),tmp2(1)))
     >   call errquit('Dneall_f_SVD:out of stack memory',0,MA_ERR)

      do ms=ms1,ms2
         if (neq(ms).le.0) go to 30
         shift = 1+(ms-1)*neq(1)*npack1
         do n=1,neq(ms)
            call Pack_cc_idot(1,U(shift),U(shift),dbl_mb(tmp2(1)+n-1))
            shift = shift + npack1
         end do
         call D3dB_Vector_SumAll(neq(ms),dbl_mb(tmp2(1)))

         do n=1,neq(ms)
            dbl_mb(tmp2(1)+n-1) = 1.0d0/dsqrt(dbl_mb(tmp2(1)+n-1))
         end do

         shift = 1+(ms-1)*neq(1)*npack1
         do n=1,neq(ms)
            call dscal(2*npack1,dbl_mb(tmp2(1)+n-1),U(shift),1)
            shift = shift + npack1
         end do

 30     continue
      end do

      if (.not.MA_pop_stack(tmp2(2))) 
     >  call errquit('Dneall_f_SVD: popping stack memory',0,MA_ERR)


*     **** calculated sqrt(S^2) ****
      do n=1,nj
         if (S(n).lt.0.0d0) S(n) = dabs(S(n))
         S(n) = dsqrt(S(n))
      end do

      return
      end

c     ****************************************
c     *                                     *
c     *        Dneall_f_ortho               *
c     *                                      *
c     ****************************************

      subroutine Dneall_f_ortho(mb,U,npack1)
      integer mb
      complex*16 U(*)
      integer    npack1      

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer taskid
      integer ms,ms1,ms2,n,shift,asize,j,k,indxk,indxj
      integer V(2),tmp2(2),S(2),A(2)
      real*8 sum1

      logical  Dneall_m_allocate,Dneall_m_free
      external Dneall_m_allocate,Dneall_m_free
 

      
      if (parallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            asize = (neq(1)+neq(2))*npack1
         else
            ms1 = mb
            ms2 = mb
            asize = neq(mb)*npack1
         end if

      
         if (.not.MA_push_get(mt_dcpl,asize,'A',A(2),A(1)))
     >   call errquit('Dneall_f_ortho:out of stack memory',0,MA_ERR)
         if (.not.Dneall_m_allocate(mb,V))
     >   call errquit('Dneall_f_ortho:out of stack memory',1,MA_ERR)
         if (.not.MA_push_get(mt_dbl,(ne(1)+ne(2)),'S',S(2),S(1)))
     >   call errquit('Dneall_f_ortho:out of stack memory',2,MA_ERR)


*        **** generate V and Sigma^2 ****
         call Dneall_ffm_sym_Multiply(mb,U,U,npack1,dbl_mb(V(1)))
         call Dneall_m_diagonalize(mb,dbl_mb(V(1)),dbl_mb(S(1)),.false.)
         if (.not.MA_pop_stack(S(2)))
     >   call errquit('Dneall_f_ortho: popping stack memory',2,MA_ERR)

*        **** generate U*Sigma ****
         call dcopy(2*asize,U,1,dcpl_mb(A(1)),1)
         call Dneall_fmf_Multiply(mb,dcpl_mb(A(1)),npack1,
     >                         dbl_mb(V(1)),1.0d0,U,0.0d0)

*        **** deallocate tmp space ****
         if (.not.Dneall_m_free(V))
     >     call errquit('Dneall_f_ortho: popping stack memory',0,MA_ERR)
         if (.not.Ma_pop_stack(A(2)))
     >     call errquit('Dneall_f_ortho: popping stack memory',1,MA_ERR)


*        **** normalize U*sigma ****
         if (.not. MA_push_get(mt_dbl,neq(1),'tmp2',tmp2(2),tmp2(1)))
     >      call errquit('Dneall_f_ortho:out of stack memory',3,MA_ERR)

         do ms=ms1,ms2
            if (neq(ms).le.0) go to 30
            shift = 1+(ms-1)*neq(1)*npack1
            do n=1,neq(ms)
              call Pack_cc_idot(1,U(shift),U(shift),dbl_mb(tmp2(1)+n-1))
              shift = shift + npack1
            end do
            call D3dB_Vector_SumAll(neq(ms),dbl_mb(tmp2(1)))

            do n=1,neq(ms)
               dbl_mb(tmp2(1)+n-1) = 1.0d0/dsqrt(dbl_mb(tmp2(1)+n-1))
            end do

            shift = 1+(ms-1)*neq(1)*npack1
            do n=1,neq(ms)
               call dscal(2*npack1,dbl_mb(tmp2(1)+n-1),U(shift),1)
               shift = shift + npack1
            end do

 30        continue
         end do
         if (.not.MA_pop_stack(tmp2(2)))
     >     call errquit('Dneall_f_ortho: popping stack memory',3,MA_ERR)



c     **** not parallized ****
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
         else
            ms1 = mb
            ms2 = mb
         end if
         shift = ne(1)*npack1

         !**** orthogonalize from the bottom -> up ****
         do ms=ms1,ms2
         do k=ne(ms),1,-1
            indxk = 1+(k-1)*npack1 + (ms-1)*shift
            call Pack_cc_dot(1,U(indxk),U(indxk),sum1)
            sum1 = 1.0d0/dsqrt(sum1)
c            call Pack_c_SMul(1,sum1,U(indxk),U(indxk))
            call Pack_c_SMul1(1,sum1,U(indxk))

            do j=k-1,1,-1
               indxj = 1+(j-1)*npack1 + (ms-1)*shift
               call Pack_cc_dot(1,U(indxk),U(indxj),sum1)
               sum1 = -sum1
               call Pack_cc_daxpy(1,sum1,U(indxk),U(indxj))
            end do
         end do
         end do


      end if

      return
      end 


c     ****************************************
c     *                                      *
c     *        Dneall_mm_transpose          *
c     *                                      *
c     ****************************************

      subroutine Dneall_mm_transpose(mb,Min,Mout)
      implicit none
      integer mb
      real*8  Min(*),Mout(*)


#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) goto 20
           shift2 = 1 + (ms-1)*ishift2
           call DMatrix_mm_transpose(ne(ms),
     >                 Min(shift2),Mout(shift2),
     >                 mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)))
 20        continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) goto 30
           shift2 = 1 + (ms-1)*ishift2
           call Dneall_mm_transpose_sub(ne(ms),
     >                 Min(shift2),Mout(shift2))
 30        continue
         end do
      end if

      return
      end

      subroutine Dneall_mm_transpose_sub(n,A,B)
      implicit none
      integer n
      real*8 A(n,n)
      real*8 B(n,n)
      integer i,j
      do j=1,n
         do i=1,n
            B(i,j) = A(j,i)
         end do
      end do
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_mm_SCtimesVtrans       *
c     *                                      *
c     ****************************************

      subroutine Dneall_mm_SCtimesVtrans(mb,t,S,Vt,A,B,SA,SB)
      implicit none
      integer mb
      real*8 t
      real*8 S(*)
      real*8 Vt(*)
      real*8 A(*),B(*)
      real*8 SA(*),SB(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j,indx1,indx2
      integer nj

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
            nj = ne(1)+ne(2)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nj = ne(mb)
         end if

         do j=1,nj
            SA(j) = dcos(S(j)*t)
            SB(j) = dsin(S(j)*t)
         end do

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ishift1
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_SASBtimesVtrans(ne(ms),
     >                SA(shift1),SB(shift1),
     >                Vt(shift2),A(shift2),B(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do
      
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
            nj = ne(1)+ne(2)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nj = ne(mb)
         end if

         do j=1,nj
            SA(j) = dcos(S(j)*t)
            SB(j) = dsin(S(j)*t)
         end do

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = 1 + (ms-1)*ishift1
           shift2 = 1 + (ms-1)*ishift2

           indx2 = shift2
           do k=1,ne(ms)
              indx1 = shift1
              do j=1,ne(ms)
                 A(indx2) = SA(indx1)*Vt(indx2)
                 B(indx2) = SB(indx1)*Vt(indx2)
                 indx2 = indx2 + 1
                 indx1 = indx1 + 1
              end do
           end do
   
 30        continue
         end do
      end if

      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_mm_SCtimesVtrans2     *
c     *                                      *
c     ****************************************

      subroutine Dneall_mm_SCtimesVtrans2(mb,t,S,Vt,A,B,SA,SB)
      implicit none
      integer mb
      real*8 t
      real*8 S(*)
      real*8 Vt(*)
      real*8 A(*),B(*)
      real*8 SA(*),SB(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j,indx1,indx2
      integer nj
 
      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
            nj = ne(1)+ne(2)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nj = ne(mb)
         end if

         do j=1,nj
            SA(j) = S(j)*dsin(S(j)*t)
            SB(j) = S(j)*dcos(S(j)*t)
         end do

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ishift1
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_SASBtimesVtrans(ne(ms),
     >                SA(shift1),SB(shift1),
     >                Vt(shift2),A(shift2),B(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
            nj = ne(1)+ne(2)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nj = ne(mb)
         end if

         do j=1,nj
            SA(j) = S(j)*dsin(S(j)*t)
            SB(j) = S(j)*dcos(S(j)*t)
         end do

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30

           shift1 = 1 + (ms-1)*ishift1
           shift2 = 1 + (ms-1)*ishift2

           indx2 = shift2
           do k=1,ne(ms)
              indx1 = shift1
              do j=1,ne(ms)
                 A(indx2) = SA(indx1)*Vt(indx2)
                 B(indx2) = SB(indx1)*Vt(indx2)
                 indx2 = indx2 + 1
                 indx1 = indx1 + 1
              end do
           end do

 30        continue
         end do
      end if

      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_mm_SCtimesVtrans3     *
c     *                                      *
c     ****************************************

      subroutine Dneall_mm_SCtimesVtrans3(mb,t,S,Vt,A,B,SA,SB)
      implicit none
      integer mb
      real*8 t
      real*8 S(*)
      real*8 Vt(*)
      real*8 A(*),B(*)
      real*8 SA(*),SB(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j,indx1,indx2
      integer nj

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
            nj = ne(1)+ne(2)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nj = ne(mb)
         end if

         do j=1,nj
            SA(j) = dsin(S(j)*t)
            SB(j) = 1.0d0-dcos(S(j)*t)
         end do

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ishift1
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_SASBtimesVtrans(ne(ms),
     >                SA(shift1),SB(shift1),
     >                Vt(shift2),A(shift2),B(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do
         
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
            nj = ne(1)+ne(2)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nj = ne(mb)
         end if

         do j=1,nj
            SA(j) = dsin(S(j)*t)
            SB(j) = 1.0d0-dcos(S(j)*t)
         end do

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = 1 + (ms-1)*ishift1
           shift2 = 1 + (ms-1)*ishift2

           indx2 = shift2
           do k=1,ne(ms)
              indx1 = shift1
              do j=1,ne(ms)
                 A(indx2) = SA(indx1)*Vt(indx2)
                 B(indx2) = SB(indx1)*Vt(indx2)
                 indx2 = indx2 + 1
                 indx1 = indx1 + 1
              end do
           end do

 30        continue
         end do
      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_mmm_Multiply2         *
c     *                                      *
c     ****************************************

      subroutine Dneall_mmm_Multiply2(mb,A,B,C)
      implicit none
      integer mb
      real*8 A(*),B(*),C(*)
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer ms,ms1,ms2,n,shift2,ishift2
  
      if (mparallelized) then
        if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),ne(ms),64,
     >             1.0d0,
     >             A(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             B(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             0.0d0,
     >             C(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('T','N',n,n,n,1.0d0,
     >                A(shift2), n,
     >                B(shift2), n,
     >                0.0d0,
     >                C(shift2), n)
   30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   ne(1)*ne(1)+ne(2)*ne(2),C)
         else
            call Parallel_Brdcst_values(MASTER,ne(mb)*ne(mb),C)
         end if

      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_mmm_Multiply3          *
c     *                                      *
c     ****************************************

      subroutine Dneall_mmm_Multiply3(mb,A,B,C)
      implicit none
      integer mb
      real*8 A(*),B(*),C(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer ms,ms1,ms2,n,shift2,ishift2

      if (mparallelized) then
        if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm3(ne(ms),ne(ms),ne(ms),64,
     >             1.0d0,
     >             A(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             B(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             0.0d0,
     >             C(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('N','T',n,n,n,1.0d0,
     >                A(shift2), n,
     >                B(shift2), n,
     >                0.0d0,
     >                C(shift2), n)
   30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   ne(1)*ne(1)+ne(2)*ne(2),C)
         else
            call Parallel_Brdcst_values(MASTER,ne(mb)*ne(mb),C)
         end if

      end if 

      return
      end





c     ****************************************
c     *                                      *
c     *        Dneall_mmm_Multiply           *
c     *                                      *
c     ****************************************

      subroutine Dneall_mmm_Multiply(mb,A,B,alpha,C,beta)
      implicit none
      integer mb
      real*8 A(*),B(*),C(*)
      real*8 alpha,beta
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer ms,ms1,ms2,n,shift2,ishift2
  
      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm1(ne(ms),ne(ms),ne(ms),64,
     >             alpha,
     >             A(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             B(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             beta,
     >             C(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('N','N',n,n,n,
     >                alpha,
     >                A(shift2), n,
     >                B(shift2), n,
     >                beta,
     >                C(shift2), n)
   30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   ne(1)*ne(1)+ne(2)*ne(2),C)
         else
            call Parallel_Brdcst_values(MASTER,ne(mb)*ne(mb),C)
         end if

      end if

      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_mmm_replicated         *
c     *                                      *
c     ****************************************
      subroutine  Dneall_mmm_replicated1(n,alpha,a,b,beta,c,ctmp)
      implicit none
      integer n
      real*8 alpha,beta
      real*8 a(n,n),b(n,n),c(n,n),ctmp(n,n)

      integer taskid,np
      integer i,j,k,icount
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      call dcopy(n*n,0.0d0,0,ctmp,1)
      icount = 0
      do j=1,n
         do i=1,n
            if (mod(icount,np).eq.taskid) then
               do k=1,n
                  c(i,j) = c(i,j) + a(i,k)*b(k,j)
               end do
            end if
            icount = icount + 1
         end do
      end do
      call Parallel_Vector_SumAll(n*n,ctmp)
      do j=1,n
         do i=1,n
            c(i,j) = beta*c(i,j) + alpha*ctmp(i,j)
         end do
      end do
      return 
      end

      subroutine  Dneall_mmm_replicated2(n,alpha,a,b,beta,c,ctmp)
      implicit none
      integer n
      real*8 alpha,beta
      real*8 a(n,n),b(n,n),c(n,n),ctmp(n,n)

      integer taskid,np
      integer i,j,k,icount
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      call dcopy(n*n,0.0d0,0,ctmp,1)
      icount = 0
      do j=1,n
         do i=1,n
            if (mod(icount,np).eq.taskid) then
               do k=1,n
                  c(i,j) = c(i,j) + a(k,i)*b(k,j)
               end do
            end if
            icount = icount + 1
         end do
      end do
      call Parallel_Vector_SumAll(n*n,ctmp)
      do j=1,n
         do i=1,n
            c(i,j) = beta*c(i,j) + alpha*ctmp(i,j)
         end do
      end do
      return
      end

      subroutine  Dneall_mmm_replicated3(n,alpha,a,b,beta,c,ctmp)
      implicit none
      integer n
      real*8 alpha,beta
      real*8 a(n,n),b(n,n),c(n,n),ctmp(n,n)

      integer taskid,np
      integer i,j,k,icount
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      call dcopy(n*n,0.0d0,0,ctmp,1)
      icount = 0
      do j=1,n
         do i=1,n
            if (mod(icount,np).eq.taskid) then
               do k=1,n
                  c(i,j) = c(i,j) + a(i,k)*b(j,k)
               end do
            end if
            icount = icount + 1
         end do
      end do
      call Parallel_Vector_SumAll(n*n,ctmp)
      do j=1,n
         do i=1,n
            c(i,j) = beta*c(i,j) + alpha*ctmp(i,j)
         end do
      end do
      return
      end







c     ****************************************
c     *                                      *
c     *           Dneall_m_trace             *
c     *                                      *
c     ****************************************

      double precision function Dneall_m_trace(mb,M)
      implicit none
      integer mb
      real*8  M(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,indx,i
      real*8  sum

*     ***** external functions ****
      real*8   DMatrix_trace
      external DMatrix_trace

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         sum = 0.0d0
         do ms=ms1,ms2
            shift2 = 1 + (ms-1)*ishift2
            sum =  sum + DMatrix_trace(ne(ms),
     >                                 M(shift2),mcq(ms),
     >                                           int_mb(mc(1,ms)),
     >                                           int_mb(nc(1,ms)),
     >                                 taskid_i,taskid_j)
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         sum = 0.0d0
         do ms=ms1,ms2

           if (ne(ms).le.0) goto 30
           shift2 = (ms-1)*ishift2

           do i=1,ne(ms)
              indx = i + (i-1)*ne(ms) + shift2
              sum = sum + M(indx)
           end do

 30        continue
         end do
      end if

      Dneall_m_trace = sum
      return
      end


c     ****************************************
c     *                                      *
c     *           Dneall_m_scal             *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_scal(mb,alpha,M)
      implicit none
      integer mb
      real*8  alpha
      real*8  M(*)

#include "Dne.fh"

*     **** local variables ****
      integer nn

      if (mparallelized) then
         if (mb.eq.0) then
            nn = mcq(1)*ncq(1)+mcq(2)*ncq(2)
         else
            nn = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then
            nn = ne(1)*ne(1) + ne(2)*ne(2)
         else
            nn = ne(mb)*ne(mb)
         end if
      end if

      call dscal(nn,alpha,M,1)
      return
      end



c     ****************************************
c     *                                      *
c     *           Dneall_m_diag_scal        *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_diag_scal(mb,diag,M)
      implicit none
      integer mb
      real*8  diag(*)
      real*8  M(*)

#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,indx,i

      if (mparallelized) then
         call errquit('Dneall_m_diag_scal not finished',0,0)
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2

            if (ne(ms).le.0) goto 30
            shift1 = (ms-1)*ishift1
            shift2 = (ms-1)*ishift2

            do i=1,ne(ms)
               indx = i + (i-1)*ne(ms) + shift2
               M(indx) = M(indx)*diag(i+shift1)
            end do

 30        continue
         end do
      end if

      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_m_diag_scal_inv       *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_diag_scal_inv(mb,diag,M)
      implicit none
      integer mb
      real*8  diag(*)
      real*8  M(*)

#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,indx,i

      if (mparallelized) then
         call errquit('Dneall_m_diag_scal_inv not finished',0,0)
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2

            if (ne(ms).le.0) goto 30
            shift1 = (ms-1)*ishift1
            shift2 = (ms-1)*ishift2

            do i=1,ne(ms)
               indx = i + (i-1)*ne(ms) + shift2
               M(indx) = M(indx)/diag(i+shift1)
            end do

 30        continue
         end do
      end if
      return
      end





c     ****************************************
c     *                                      *
c     *        Dneall_m_scale_s22           *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_scale_s22(mb,dte,s22)
      implicit none
      integer mb
      real*8 dte
      real*8 s22(*)


#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,k,j,indx,indxt

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         do ms=ms1,ms2
            shift2 = 1 + (ms-1)*ishift2
         
            call DMatrix_s22(ne(ms),dte,
     >                       s22(shift2),mcq(ms),
     >                                   int_mb(mc(1,ms)),
     >                                   int_mb(nc(1,ms)),
     >                       taskid_i,taskid_j)
         end do
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift2 = (ms-1)*ishift2

           do k=1,ne(ms)
              indx = k + (k-1)*ne(ms) + shift2
              s22(indx) = (1.0d0 - s22(indx))*0.5d0/dte

              do j=k+1,ne(ms)
                 indx  = j + (k-1)*ne(ms) + shift2
                 indxt = k + (j-1)*ne(ms) + shift2

                 s22(indx)  = -s22(indx)*0.5d0/dte
                 s22(indxt) = s22(indx)
              end do
           end do

 30        continue
         end do
      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_m_scale_s21           *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_scale_s21(mb,dte,s21)
      implicit none
      integer mb
      real*8 dte
      real*8 s21(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,k,j,indx,indxt

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         do ms=ms1,ms2
            shift2 = 1 + (ms-1)*ishift2

            call DMatrix_s21(ne(ms),dte,
     >                       s21(shift2),mcq(ms),
     >                                   int_mb(mc(1,ms)),
     >                                   int_mb(nc(1,ms)),
     >                       taskid_i,taskid_j)
         end do
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift2 = (ms-1)*ishift2

           do k=1,ne(ms)
              indx = k + (k-1)*ne(ms) + shift2
              s21(indx) = (1.0d0 - s21(indx))*0.5d0

              do j=k+1,ne(ms)
                 indx  = j + (k-1)*ne(ms) + shift2
                 indxt = k + (j-1)*ne(ms) + shift2

                 s21(indx)  = -s21(indx)*0.5d0
                 s21(indxt) = s21(indx)
              end do
           end do

 30        continue
         end do
      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_m_scale_s11           *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_scale_s11(mb,dte,s11)
      implicit none
      integer mb
      real*8 dte
      real*8 s11(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,k,j,indx,indxt

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         do ms=ms1,ms2
            shift2 = 1 + (ms-1)*ishift2

            call DMatrix_s11(ne(ms),dte,
     >                       s11(shift2),mcq(ms),
     >                                   int_mb(mc(1,ms)),
     >                                   int_mb(nc(1,ms)),
     >                       taskid_i,taskid_j)
         end do
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift2 = (ms-1)*ishift2

           do k=1,ne(ms)
              indx = k + (k-1)*ne(ms) + shift2
              s11(indx) = -s11(indx)*0.5d0*dte

              do j=k+1,ne(ms)
                 indx  = j + (k-1)*ne(ms) + shift2
                 indxt = k + (j-1)*ne(ms) + shift2

                 s11(indx)  = -s11(indx)*0.5d0*dte
                 s11(indxt) = s11(indx)
              end do
           end do

 30        continue
         end do
      end if
      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_m_Kiril_BTransform     *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_Kiril_BTransform(mb,s12,s21)
      implicit none
      integer mb
      real*8 s12(*),s21(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,i,j,ii
      real*8 tmp1

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 29
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_Kiril_BTransform(ne(ms),
     >                       s12(shift2),s21(shift2),
     >                       mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                       taskid_i,taskid_j)
 29         continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            do i=1,ne(ms)
               do j=1,(i-1)
                  ii = i + j*(i-1) + shift2
                  tmp1 = 0.5d0*(s12(ii)+s21(ii))
                  s12(ii) = tmp1
                  s21(ii) = tmp1
               end do
            end do
 30        continue
         end do

      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_m_dmax                 *
c     *                                      *
c     ****************************************

      double precision function Dneall_m_dmax(mb,A)
      implicit none
      integer mb
      real*8 A(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2
      double precision adiff1, adiff2

      integer  idamax
      external idamax

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         adiff1 = 0.0d0
         adiff2 = 0.0d0
         do ms=ms1,ms2
           if (ne(ms).le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2

            adiff1 = adiff2
            adiff2 = A(shift2-1+idamax(mcq(ms)*ncq(ms),A(shift2),1))
            adiff2 = dabs(adiff2)
            call DMatrix_MaxAll(adiff2)
            if (adiff2.gt.adiff1) adiff1 = adiff2
 20        continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         adiff1 = 0.0d0
         adiff2 = 0.0d0
         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift2 = 1 + (ms-1)*ishift2

           adiff1 = adiff2      
           adiff2 = A(shift2-1+idamax(ne(ms)*ne(ms),A(shift2),1))
           adiff2 = dabs(adiff2)
           if (adiff2.gt.adiff1) adiff1 = adiff2
 30        continue
         end do
      end if

      Dneall_m_dmax = adiff1
      return
      end




c     ****************************************
c     *                                      *
c     *        Dneall_mm_Expand             *
c     *                                      *
c     ****************************************

      subroutine Dneall_mm_Expand(mb,A,A0)
      implicit none
      integer mb
      real*8 A(*),A0(*)
           
#include "Dne.fh"

*     **** local variables ****
      integer shift2,nn
      
      shift2 = 1
      if (mparallelized) then

         if (mb.eq.0) then
            nn     = mcq(1)*ncq(1) + mcq(2)*ncq(2)
            shift2 = 1
         else if (mb.eq.1) then
            nn     = mcq(1)*ncq(1)
            shift2 = 1 
         else if (mb.eq.2) then
            nn     = mcq(2)*ncq(2)
            shift2 = 1+mcq(1)*ncq(1)
         end if

      else
         if (mb.eq.0) then
            nn     = ne(1)*ne(1) + ne(2)*ne(2)
            shift2 = 1
         else if (mb.eq.1) then
            nn     = ne(1)*ne(1)
            shift2 = 1 
         else if (mb.eq.2) then
            nn     = ne(2)*ne(2)
            shift2 = 1+ne(1)*ne(1)
         end if

      end if

      call dcopy(nn,A,1,A0(shift2),1)
      return
      end


      subroutine Dneall_m_print(mb,A)
      implicit none
      integer mb
      real*8  A(*)


#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,i,j
      integer taskid

      call Parallel_taskid(taskid)
      if (mparallelized) then
         if (mb.eq.0) then
            ms1=1 
            ms2=ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1=mb
            ms2=mb
            ishift2 = 0
         end if
         do ms=ms1,ms2
            shift2 = (ms-1)*ishift2
            write(*,*)
            write(*,*) taskid,taskid_i,taskid_j,
     >                 "  Dneall Matrix print, spin=",ms
            do i=1,mcq(ms)
               write(*,'(A,2I2,A,10F10.6)') 
     >                    "taskids=",taskid_i,taskid_j," : ",
     >                    (A(i+(j-1)*mcq(ms)+shift2), j=1,ncq(ms))
            end do
         end do

      else
         if (mb.eq.0) then
            ms1=1 
            ms2=ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1=mb
            ms2=mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            shift2 = (ms-1)*ishift2
            write(*,*)
            write(*,*) taskid,"  Dneall Matrix print, spin=",ms
            do i=1,ne(ms)
               write(*,'(A,I2,A,10F10.6)') "taskid=",taskid," : ",
     >                    (A(i+(j-1)*ne(ms)+shift2), j=1,ne(ms))
            end do
         end do
      end if

      return
      end



      real*8 function  Dneall_m_value(mb,ms,i,j,A)
      implicit none
      integer mb,ms,i,j
      real*8  A(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ishift2,shift2
      real*8 w

*     **** external functions ****
      real*8   DMatrix_m_get_value
      external DMatrix_m_get_value
      
      w = 0.0d0
      if (ne(ms).gt.0)  then
         if (mparallelized) then

            if (mb.eq.0) then
               ishift2 = mcq(1)*ncq(1)
            else
               ishift2 = 0
            end if
            shift2 = 1 + (ms-1)*ishift2
            w = DMatrix_m_get_value(i,j,A(shift2),
     >                 mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)))
         else
            shift2 = (ms-1)*ne(1)*ne(1)
            w = A(i+(j-1)*ne(ms)+shift2)
         end if
      end if

      Dneall_m_value = w
      return
      end



      subroutine Dneall_m_set_value(w,mb,ms,i,j,A)
      implicit none
      real*8 w
      integer mb,ms,i,j
      real*8  A(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ishift2,shift2

      if (ne(ms).gt.0)  then
         if (mparallelized) then
            if (mb.eq.0) then
               ishift2 = mcq(1)*ncq(1)
            else
               ishift2 = 0
            end if
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_m_set_value(w,i,j,A(shift2),
     >                 mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)))
         else
            shift2 = (ms-1)*ne(1)*ne(1)
            A(i+(j-1)*ne(ms)+shift2) = w
         end if
      end if

      return
      end




      subroutine Dneall_m_add_value(w,mb,ms,i,j,A)
      implicit none
      real*8 w
      integer mb,ms,i,j
      real*8  A(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ishift2,shift2

      if (ne(ms).gt.0)  then
         if (mparallelized) then
            if (mb.eq.0) then
               ishift2 = mcq(1)*ncq(1)
            else
               ishift2 = 0
            end if
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_m_add_value(w,i,j,A(shift2),
     >                 mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)))
         else
            if (mb.eq.0) then
               shift2 = (ms-1)*ne(1)*ne(1)
            else
               shift2 = 0
            end if
            A(i+(j-1)*ne(ms)+shift2) = A(i+(j-1)*ne(ms)+shift2) + w
         end if
      end if

      return
      end



      real*8 function  Dneall_sm_value(i,j,A)
      implicit none
      integer i,j
      real*8  A(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      real*8 w

*     **** external functions ****
      real*8   DMatrix_m_get_value
      external DMatrix_m_get_value

      w = 0.0d0
      if (ne(2).gt.0)  then
         if (mparallelized) then
            w = DMatrix_m_get_value(i,j,A,
     >                 mdq,int_mb(md(1)),int_mb(nd(1)))
         else
            w = A(i+(j-1)*ne(1))
         end if
      end if

      Dneall_sm_value = w
      return
      end


*     ***********************************
*     *                                 *
*     *       Dneall_m_add_sw1sw2       *
*     *                                 *
*     ***********************************
      subroutine Dneall_m_add_sw1sw2(mb,nprj,scal,sw1,sw2,S)
      implicit none
      integer mb,nprj
      real*8 scal
      real*8 sw1(*)
      real*8 sw2(*)
      real*8 S(*)

#include "mafdecls.fh"
#include "Dne.fh"
#include "errquit.fh"

*     **** local variables ****
      logical value
      integer ms,q,n,nn,nnq,shift1,shift2,ishift1,ishift2
      integer i,j,ii,jj,pto,taskid,ms1,ms2
      integer sw1b(2),sw2b(2)
      real*8  w

*     **** external functions ****
      real*8   ddot
      external ddot


      if (parallelized) then
         if (mb.eq.0) then
            nn  = ne(1)  + ne(2)
            nnq = neq(1) + neq(2)
         else
            nn  = ne(mb)
            nnq = neq(mb)
         end if
         value = MA_push_get(mt_dbl,nn*nprj,'sw1b',sw1b(2),sw1b(1))
         value = value.and.
     >           MA_push_get(mt_dbl,nn*nprj,'sw2b',sw2b(2),sw2b(1))
         if (.not.value)
     >   call errquit('Dneall_m_add_sw1sw2:push stack',0,MA_ERR)

         call dcopy(nn*nprj,0.0d0,0,dbl_mb(sw1b(1)),1)
         call dcopy(nn*nprj,0.0d0,0,dbl_mb(sw2b(1)),1)
         do q=1,nnq
            call Dneall_qton(q,n)
            !do prj = 1,nprj
            !   sw1b(n,prj) = sw1(q,prj)
            !   sw2b(n,prj) = sw2(q,prj)
            !end do
            call dcopy(nprj,sw1(q),nnq,dbl_mb(sw1b(1)+n-1),nn)
            call dcopy(nprj,sw2(q),nnq,dbl_mb(sw2b(1)+n-1),nn)
         end do
         call D1dB_SumAll(nn*nprj,dbl_mb(sw1b(1)))
         call D1dB_SumAll(nn*nprj,dbl_mb(sw2b(1)))

         if (mparallelized) then
            call Parallel_taskid(taskid)
            if (mb.eq.0) then
               ms1 = 1
               ms2 = ispin
               ishift1 = ne(1)
            else
               ms1 = mb
               ms2 = mb
               ishift1 = 0
            end if
            do ms=ms1,ms2
               shift1 =   (ms-1)*ishift1
               do j=1,ne(ms)
               do i=1,ne(ms)
                  call DMatrix_m_ijtoiijjp(i,j,ii,jj,pto,
     >                                     mcq(ms),
     >                                     int_mb(mc(1,ms)),
     >                                     int_mb(nc(1,ms)))
                  if (pto.eq.taskid) then
                     w = ddot(nprj,dbl_mb(sw1b(1)+i-1+shift1),nn,
     >                             dbl_mb(sw2b(1)+j-1+shift1),nn)
                     call Dneall_m_add_value(scal*w,mb,ms,i,j,S)
                  end if
               end do
               end do
            end do

         else
            if (mb.eq.0) then
               ms1 = 1
               ms2 = ispin
               ishift1 = ne(1)
               ishift2 = ne(1)*ne(1)
            else
               ms1 = mb
               ms2 = mb
               ishift1 = 0
               ishift2 = 0
            end if
            do ms=ms1,ms2
               shift1 =   (ms-1)*ishift1
               shift2 = 1+(ms-1)*ishift2
               call DGEMM('N','T',ne(ms),ne(ms),nprj,
     >                    scal,
     >                    dbl_mb(sw1b(1)+shift1), nn,
     >                    dbl_mb(sw2b(1)+shift1), nn,
     >                    1.0d0,
     >                    S(shift2),ne(ms))
            end do
         end if
         value =           MA_pop_stack(sw2b(2))
         value = value.and.MA_pop_stack(sw1b(2))
         if (.not.value)
     >   call errquit('Dneall_m_add_sw1sw2:pop stack',1,MA_ERR)
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
            nn = ne(1) + ne(2)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nn = ne(mb)
         end if
         do ms=ms1,ms2
           shift1 = 1+(ms-1)*ishift1
           shift2 = 1+(ms-1)*ishift2
           call DGEMM('N','T',
     >               ne(ms),ne(ms),nprj,
     >               scal,
     >               sw1(shift1), nn,
     >               sw2(shift1), nn,
     >               1.0d0,
     >               S(shift2), ne(ms))
         end do
      end if

      return
      end











c     ****************************************
c     *                                      *
c     *        Dneall_m_HmltimesSA           *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_HmltimesSA(mb,A,SA)
      implicit none
      integer mb
      real*8 A(*)
      real*8 SA(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j,indx1,indx2

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ishift1
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_HmltimesSA(ne(ms),
     >                SA(shift1),A(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do
      
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = 1 + (ms-1)*ishift1
           shift2 = 1 + (ms-1)*ishift2

           indx1 = shift1
           indx2 = shift2
           do k=1,ne(ms)
              do j=1,ne(ms)
                A(indx2) = A(indx2)*SA(indx1)
                indx2 = indx2 + 1
              end do
              indx1 = indx1 + 1
           end do
   
 30        continue
         end do
      end if

      return
      end







c     ****************************************
c     *                                      *
c     *        Dneall_m_HmldivideSA          *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_HmldivideSA(mb,A,SA)
      implicit none
      integer mb
      real*8 A(*)
      real*8 SA(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j,indx1,indx2

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ishift1
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_HmldivideSA(ne(ms),
     >                SA(shift1),A(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do
      
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = 1 + (ms-1)*ishift1
           shift2 = 1 + (ms-1)*ishift2

           indx1 = shift1
           indx2 = shift2
           do k=1,ne(ms)
              do j=1,ne(ms)
                A(indx2) = A(indx2)/SA(indx1)
                indx2 = indx2 + 1
              end do
              indx1 = indx1 + 1
           end do
   
 30        continue
         end do
      end if

      return
      end






c     ****************************************
c     *                                      *
c     *        Dneall_m_HmldivideDplusD      *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_HmldivideDplusD(mb,A,D)
      implicit none
      integer mb
      real*8 A(*)
      real*8 D(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j
      integer indx1,indx2,indx3

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ishift1
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_HmldivideDplusD(ne(ms),
     >                D(shift1),A(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = 1 + (ms-1)*ishift1
           shift2 = 1 + (ms-1)*ishift2

           indx1 = shift1
           indx2 = shift2
           do k=1,ne(ms)
              indx3 = shift1
              do j=1,ne(ms)
                A(indx2) = A(indx2)/(D(indx1)+D(indx3))
                indx2 = indx2 + 1
                indx3 = indx3 + 1
              end do
              indx1 = indx1 + 1
           end do

 30        continue
         end do
      end if

      return
      end




c     ****************************************
c     *                                      *
c     *        Dneall_m_Hmlfweightscale      *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_Hmlfweightscale(mb,A,fw)
      implicit none
      integer mb
      real*8 A(*)
      real*8 fw(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j
      integer indx1,indx2,indx3

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ishift1
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_Hmlfweightscale(ne(ms),
     >                fw(shift1),A(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = 1 + (ms-1)*ishift1
           shift2 = 1 + (ms-1)*ishift2

           indx1 = shift1
           indx2 = shift2
           do k=1,ne(ms)
              indx3 = shift1
              do j=1,ne(ms)
                A(indx2) = A(indx2)
     >                   *(2.0d0*fw(indx1)/(fw(indx1)+fw(indx3)))
                indx2 = indx2 + 1
                indx3 = indx3 + 1
              end do
              indx1 = indx1 + 1
           end do

 30        continue
         end do
      end if

      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_m_eye                  *
c     *                                      *
c     ****************************************

      subroutine Dneall_m_eye(mb,A,alpha)
      implicit none
      integer mb
      real*8 A(*)
      real*8 alpha

#include "mafdecls.fh"
#include "Dne.fh"


*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,k
      integer indx2

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_eye(ne(ms),ne(ms),alpha,
     >                A(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift2 = 1 + (ms-1)*ishift2
           call dcopy(ne(ms)*ne(ms),0.0d0,0,A(shift2),1)
           indx2 = shift2
           do k=1,ne(ms)
              A(indx2) = alpha
              indx2    = indx2 + (1+ne(ms))
           end do

 30        continue
         end do
      end if

      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_m_setdiag              *
c     *                                      *
c     ****************************************
      subroutine Dneall_m_setdiag(mb,A,alpha)
      implicit none
      integer mb
      real*8 A(*)
      real*8 alpha(*)

#include "mafdecls.fh"
#include "Dne.fh"


*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,k
      integer indx2,shift1

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift1 = 1 + (ms-1)*ne(1)
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_setdiag(ne(ms),ne(ms),alpha(shift1),
     >                A(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = (ms-1)*ne(1)
           shift2 = 1 + (ms-1)*ishift2
           call dcopy(ne(ms)*ne(ms),0.0d0,0,A(shift2),1)
           indx2 = shift2
           do k=1,ne(ms)
              A(indx2) = alpha(k+shift1)
              indx2    = indx2 + (1+ne(ms))
           end do

 30        continue
         end do
      end if

      return
      end






c     ****************************************
c     *                                      *
c     *        Dneall_w_eye                  *
c     *                                      *
c     ****************************************

      subroutine Dneall_w_eye(mb,A,alpha)
      implicit none
      integer mb
      complex*16 A(*)
      complex*16 alpha

#include "mafdecls.fh"
#include "Dne.fh"


*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,k
      integer indx2

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift2 = 1 + (ms-1)*ishift2
             call CMatrix_eye(ne(ms),ne(ms),alpha,
     >                A(shift2),
     >                mcq(ms),int_mb(mc(1,ms)),int_mb(nc(1,ms)),
     >                taskid_i,taskid_j)
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift2 = 1 + (ms-1)*ishift2
           call dcopy(2*ne(ms)*ne(ms),0.0d0,0,A(shift2),1)
           indx2 = shift2
           do k=1,ne(ms)
              A(indx2) = alpha
              indx2    = indx2 + (1+ne(ms))
           end do

 30        continue
         end do
      end if

      return
      end






c     ****************************************
c     *                                      *
c     *        Dneall_f_Sortho               *
c     *                                      *
c     ****************************************

      subroutine Dneall_f_Sortho(mb,U,SU,npack1)
      integer mb
      complex*16 U(*),SU(*)
      integer    npack1      

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer taskid
      integer ms,ms1,ms2,n,shift,asize,j,k,indxk,indxj
      integer V(2),tmp2(2),S(2),A(2)
      real*8 sum1

      logical  Dneall_m_allocate,Dneall_m_free
      external Dneall_m_allocate,Dneall_m_free
 

      
      if (parallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            asize = (neq(1)+neq(2))*npack1
         else
            ms1 = mb
            ms2 = mb
            asize = neq(mb)*npack1
         end if

      
         if (.not.MA_push_get(mt_dcpl,asize,'A',A(2),A(1)))
     >   call errquit('Dneall_f_ortho:out of stack memory',0,MA_ERR)
         if (.not.Dneall_m_allocate(mb,V))
     >   call errquit('Dneall_f_ortho:out of stack memory',1,MA_ERR)
         if (.not.MA_push_get(mt_dbl,(ne(1)+ne(2)),'S',S(2),S(1)))
     >   call errquit('Dneall_f_ortho:out of stack memory',2,MA_ERR)


*        **** generate V and Sigma^2 ****
         call Dneall_ffm_sym_Multiply(mb,U,SU,npack1,dbl_mb(V(1)))
         call Dneall_m_diagonalize(mb,dbl_mb(V(1)),dbl_mb(S(1)),.false.)
         if (.not.MA_pop_stack(S(2)))
     >   call errquit('Dneall_f_ortho: popping stack memory',2,MA_ERR)

*        **** generate U*Sigma ****
         call dcopy(2*asize,U,1,dcpl_mb(A(1)),1)
         call Dneall_fmf_Multiply(mb,dcpl_mb(A(1)),npack1,
     >                         dbl_mb(V(1)),1.0d0,U,0.0d0)

*        **** deallocate tmp space ****
         if (.not.Dneall_m_free(V))
     >     call errquit('Dneall_f_ortho: popping stack memory',0,MA_ERR)
         if (.not.Ma_pop_stack(A(2)))
     >     call errquit('Dneall_f_ortho: popping stack memory',1,MA_ERR)


*        **** normalize U*sigma ****
         if (.not. MA_push_get(mt_dbl,neq(1),'tmp2',tmp2(2),tmp2(1)))
     >      call errquit('Dneall_f_ortho:out of stack memory',3,MA_ERR)

         do ms=ms1,ms2
            if (neq(ms).le.0) go to 30
            shift = 1+(ms-1)*neq(1)*npack1
            do n=1,neq(ms)
             call Pack_cc_idot(1,U(shift),SU(shift),dbl_mb(tmp2(1)+n-1))
             shift = shift + npack1
            end do
            call D3dB_Vector_SumAll(neq(ms),dbl_mb(tmp2(1)))

            do n=1,neq(ms)
               dbl_mb(tmp2(1)+n-1) = 1.0d0/dsqrt(dbl_mb(tmp2(1)+n-1))
            end do

            shift = 1+(ms-1)*neq(1)*npack1
            do n=1,neq(ms)
               call dscal(2*npack1,dbl_mb(tmp2(1)+n-1),U(shift),1)
               shift = shift + npack1
            end do

 30        continue
         end do
         if (.not.MA_pop_stack(tmp2(2)))
     >    call errquit('Dneall_f_Sortho: popping stack memory',3,MA_ERR)



c     **** not parallized ****
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
         else
            ms1 = mb
            ms2 = mb
         end if
         shift = ne(1)*npack1

         !**** orthogonalize from the bottom -> up ****
         do ms=ms1,ms2
         do k=ne(ms),1,-1
            indxk = 1+(k-1)*npack1 + (ms-1)*shift
            call Pack_cc_dot(1,U(indxk),SU(indxk),sum1)
            sum1 = 1.0d0/dsqrt(sum1)
c            call Pack_c_SMul(1,sum1,U(indxk),U(indxk))
            call Pack_c_SMul1(1,sum1,U(indxk))

            do j=k-1,1,-1
               indxj = 1+(j-1)*npack1 + (ms-1)*shift
               call Pack_cc_dot(1,U(indxk),SU(indxj),sum1)
               sum1 = -sum1
               call Pack_cc_daxpy(1,sum1,U(indxk),U(indxj))
            end do
         end do
         end do

      end if

      return
      end 

      subroutine Dneall_m_gather(nall,npack,indx,A,B)
      implicit none
      integer nall,npack,indx(*)
      real*8 A(*),B(*)
      integer i
      call dcopy(nall,0.0d0,0,B,1)
      do i=1,npack
         B(indx(i)) = A(i)
      end do  
      call Parallel_Vector_SumAll(nall,B)
      return
      end

      subroutine DneAll_m_scatter(npack,indx,A,B)
      implicit none
      integer npack,indx(*)
      real*8 A(*),B(*)
      integer i
      do i=1,npack
         B(i) = A(indx(i))
      end do  
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_fm_QR                  *
c     *                                      *
c     ****************************************

      subroutine Dneall_fm_QR(mb,Q,npack1,R)
      implicit none
      integer mb
      complex*16 Q(*)
      integer    npack1      
      real*8     R(*)

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

c     **** local variables ****
      integer ms,ms1,ms2,shift,shift2,j,k,indxk,indxj,indxm
      integer jj,kk,rr,ss,jcur,kcur,rcur,scur
      integer tmp(2)
      real*8 w,RRM

      if (parallelized) then

c        **** allocate temporary memory ****
         if (.not.MA_push_get(mt_dcpl,npack1,'tmp',tmp(2),tmp(1)))
     >   call errquit('Dneall_fm_QR:out of stack memory',0,MA_ERR)

c        **** mparallized ****
         if (mparallelized) then

         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            shift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            shift2 = 0
         end if
         shift = neq(1)*npack1

         call dcopy((mcq(1)*ncq(1)+mcq(2)*ncq(2)),0.0d0,0,R,1)
         do ms=ms1,ms2
            rcur = 0
            scur = 0
            rr   = 0
            ss   = 0
            kcur = 0
            kk   = 0
            do k=1,ne(ms)

               if (kcur.eq.taskid_j) then
                  indxk = 1 + kk*npack1    + (ms-1)*shift
                  call Pack_cc_dot(1,Q(indxk),Q(indxk),w)
                  RRM = dsqrt(w)
                  w        = 1.0d0/RRM
c                  call Pack_c_SMul(1,w,Q(indxk),Q(indxk))
                  call Pack_c_SMul1(1,w,Q(indxk))
                  call dcopy(2*npack1,Q(indxk),1,dcpl_mb(tmp(1)),1)
               end if

*              *** Brdcst Q(indxk) ***
               call D1dB_Brdcst_values(kcur,2*npack1,dcpl_mb(tmp(1)))
               call D1dB_Brdcst_values(kcur,1,RRM)

c              *** set j = k+1 ***
               jj   = kk
               jcur = kcur
               jj = jj + 1
               if (jj.ge.int_mb(na(1,ms) + jcur)) then
                  jcur = jcur + 1
                  jj = 0
               end if

               rr   = 0
               rcur = 0
               do j=1,k
                  rr = rr + 1
                  if (rr.ge.int_mb(mc(1,ms) + rcur)) then
                     rcur = rcur + 1
                     rr = 0
                  end if
               end do
               if ((rcur.eq.taskid_i).and.(scur.eq.taskid_j)) then
                  indxm = (rr+1) + ss*mcq(ms) + (ms-1)*shift2
                  R(indxm) = RRM
               end if

               do j=k+1,ne(ms)
                  if (jcur.eq.taskid_j) then
                     indxj = 1 + jj*npack1    + (ms-1)*shift
                     call Pack_cc_dot(1,dcpl_mb(tmp(1)),Q(indxj),w)
                     RRM = w
                     w = -w
                     call Pack_cc_daxpy(1,w,dcpl_mb(tmp(1)),Q(indxj))
                  end if
                  call D1dB_Brdcst_values(jcur,1,RRM)

                  if ((rcur.eq.taskid_i).and.(scur.eq.taskid_j)) then
                     indxm = (rr+1) + ss*mcq(ms) + (ms-1)*shift2
                     R(indxm) = RRM
                  end if

                  jj = jj + 1
                  if (jj.ge.int_mb(na(1,ms) + jcur)) then
                     jcur = jcur + 1
                     jj = 0
                  end if

                  rr = rr + 1
                  if (rr.ge.int_mb(mc(1,ms) + rcur)) then
                     rcur = rcur + 1
                     rr = 0
                  end if
               end do

               kk = kk + 1
               if (kk.ge.int_mb(na(1,ms) + kcur)) then
                  kcur = kcur + 1
                  kk = 0
               end if

               ss = ss + 1
               if (ss.ge.int_mb(nc(1,ms) + scur)) then
                  scur = scur + 1
                  ss = 0
               end if

            end do
         end do


c        **** not mparallized ****
         else

         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            shift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            shift2 = 0
         end if
         shift = neq(1)*npack1

         call dcopy((ne(1)*ne(1)+ne(2)*ne(2)),0.0d0,0,R,1)
         do ms=ms1,ms2
            kcur = 0
            kk   = 0
            do k=1,ne(ms)

               if (kcur.eq.taskid_j) then
                  indxk = 1 + kk*npack1    + (ms-1)*shift
                  indxm = k + (k-1)*ne(ms) + (ms-1)*shift2
                  call Pack_cc_dot(1,Q(indxk),Q(indxk),w)
                  R(indxm) = dsqrt(w)
                  w        = 1.0d0/R(indxm)
c                  call Pack_c_SMul(1,w,Q(indxk),Q(indxk))
                  call Pack_c_SMul1(1,w,Q(indxk))
                  call dcopy(2*npack1,Q(indxk),1,dcpl_mb(tmp(1)),1)
               end if

c              *** Brdcst Q(indxk) ***
               call D1dB_Brdcst_values(kcur,2*npack1,dcpl_mb(tmp(1)))
         
c              *** set j = k+1 ***
               jj   = kk
               jcur = kcur
               jj = jj + 1
               if (jj.ge.int_mb(na(1,ms) + jcur)) then
                  jcur = jcur + 1
                  jj = 0
               end if
            
               do j=k+1,ne(ms)
                  if (jcur.eq.taskid_j) then
                     indxj = 1 + jj*npack1    + (ms-1)*shift
                     indxm = k + (j-1)*ne(ms) + (ms-1)*shift2
                     call Pack_cc_dot(1,dcpl_mb(tmp(1)),Q(indxj),w)
                     R(indxm) = w
                     w = -w
                     call Pack_cc_daxpy(1,w,dcpl_mb(tmp(1)),Q(indxj))
                  end if

                  jj = jj + 1
                  if (jj.ge.int_mb(na(1,ms) + jcur)) then
                     jcur = jcur + 1
                     jj = 0
                  end if
               end do

               kk = kk + 1
               if (kk.ge.int_mb(na(1,ms) + kcur)) then
                  kcur = kcur + 1
                  kk = 0
               end if

            end do
         end do
         call D1dB_Vector_SumAll((ne(1)*ne(1)+ne(2)*ne(2)),R)
         end if

c        **** deallocate local memory ****
         if (.not.MA_pop_stack(tmp(2)))
     >   call errquit('Dneall_fm_QR:popping stack memory',0,MA_ERR)

c     **** not parallized ****
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            shift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            shift2 = 0
         end if
         shift = ne(1)*npack1

c         **** modified Gram-Schmidt ****
         call dcopy((ne(1)*ne(1)+ne(2)*ne(2)),0.0d0,0,R,1)
         do ms=ms1,ms2
         do k=1,ne(ms)
            indxk = 1 + (k-1)*npack1 + (ms-1)*shift
            indxm = k + (k-1)*ne(ms) + (ms-1)*shift2
            call Pack_cc_dot(1,Q(indxk),Q(indxk),w)
            R(indxm) = dsqrt(w)
            w        = 1.0d0/R(indxm)
c            call Pack_c_SMul(1,w,Q(indxk),Q(indxk))
            call Pack_c_SMul1(1,w,Q(indxk))

            do j=k+1,ne(ms)
               indxj = 1 + (j-1)*npack1 + (ms-1)*shift
               indxm = k + (j-1)*ne(ms) + (ms-1)*shift2
               call Pack_cc_dot(1,Q(indxk),Q(indxj),w)
               R(indxm) = w
               w = -w
               call Pack_cc_daxpy(1,w,Q(indxk),Q(indxj))
            end do
         end do
         end do
      end if

      return
      end 

c
c     ****************************************
c     *                                      *
c     *        Dneall_4m_size                *
c     *                                      *
c     ****************************************
      subroutine Dneall_4m_size(mb,size)
      implicit none
      integer mb
      integer size

#include "Dne.fh"
     
      if (mparallelized) then
         if (mb.eq.0) then
            size = m2cq(1)*n2cq(1) + m2cq(2)*n2cq(2)
         else
            size = m2cq(mb)*n2cq(mb)
         end if
      else
         if (mb.eq.0) then 
            size = 4*(ne(1)*ne(1) + ne(2)*ne(2))
         else
            size = 4*ne(mb)*ne(mb)
         end if
      end if
     
      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_4m_allocate_block       *
c     *                                      *
c     ****************************************
      logical function Dneall_4m_allocate_block(mb,nb,hml)
      implicit none
      integer mb,nb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size
     
      if (mparallelized) then
         if (mb.eq.0) then
            size = m2cq(1)*n2cq(1) + m2cq(2)*n2cq(2)
         else
            size = m2cq(mb)*n2cq(mb)
         end if
      else
         if (mb.eq.0) then 
            size = 4*(ne(1)*ne(1) + ne(2)*ne(2))
         else
            size = 4*ne(mb)*ne(mb)
         end if
      end if
     
      Dneall_4m_allocate_block 
     > = MA_alloc_get(mt_dbl,nb*size,'hmlab',hml(2),hml(1))
      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_4m_allocate             *
c     *                                      *
c     ****************************************
      logical function Dneall_4m_allocate(mb,hml)
      implicit none
      integer mb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size
     
      if (mparallelized) then
         if (mb.eq.0) then
            size = m2cq(1)*n2cq(1) + m2cq(2)*n2cq(2)
         else
            size = m2cq(mb)*n2cq(mb)
         end if
      else
         if (mb.eq.0) then 
            size = 4*(ne(1)*ne(1) + ne(2)*ne(2))
         else
            size = 4*ne(mb)*ne(mb)
         end if
      end if
     
      Dneall_4m_allocate = MA_alloc_get(mt_dbl,size,'hma',hml(2),hml(1))
      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_4m_push_get            *
c     *                                      *
c     ****************************************
      logical function Dneall_4m_push_get(mb,hml)
      implicit none
      integer mb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size

      if (mparallelized) then
         if (mb.eq.0) then
            size = m2cq(1)*n2cq(1) + m2cq(2)*n2cq(2)
         else
            size = m2cq(mb)*n2cq(mb)
         end if
      else
         if (mb.eq.0) then
            size = 4*(ne(1)*ne(1) + ne(2)*ne(2))
         else
            size = 4*ne(mb)*ne(mb)
         end if
      end if

      Dneall_4m_push_get = MA_push_get(mt_dbl,size,'hmls',hml(2),hml(1))
      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_4m_push_get_block      *
c     *                                      *
c     ****************************************
      logical function Dneall_4m_push_get_block(mb,nb,hml)
      implicit none
      integer mb,nb
      integer hml(2)

#include "Dne.fh"
#include "mafdecls.fh"

      integer size

      if (mparallelized) then
         if (mb.eq.0) then
            size = m2cq(1)*n2cq(1) + m2cq(2)*n2cq(2)
         else
            size = m2cq(mb)*n2cq(mb)
         end if
      else
         if (mb.eq.0) then
            size = 4*(ne(1)*ne(1) + ne(2)*ne(2))
         else
            size = 4*ne(mb)*ne(mb)
         end if
      end if

      Dneall_4m_push_get_block 
     >  = MA_push_get(mt_dbl,nb*size,'hmlsb',hml(2),hml(1))
      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_AR_to_4m               *
c     *                                      *
c     ****************************************
      subroutine Dneall_AR_to_4m(mb,A,R,T)
      implicit none
      integer mb
      real*8 A(*),R(*),T(*)

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,ishift1,ishift2,shift1,shift2

      if (mparallelized) then
         call errquit('Dneall_AR_to_4m: mparallel not finished',0,0)
      else
        if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)*ne(1)
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if
         call dcopy(4*(ne(1)*ne(1)+ne(2)*ne(2)),0.0d0,0,T,1)
         do ms=ms1,ms2
             shift1 = 1+(ms-1)*ishift1
             shift2 = 1+(ms-1)*ishift2
             call Dneall_AR_to_4msub(ne(ms),
     >                               A(shift1),
     >                               R(shift1),
     >                               T(shift2))
         end do
      end if
      return
      end

      subroutine Dneall_AR_to_4msub(n,A,R,T)
      implicit none
      integer n
      real*8 A(n,n)
      real*8 R(n,n)
      real*8 T(2*n,2*n)

*     **** local variables ****
      integer i,j

*     **** copy A to upper-left of T ****
      do j=1,n
      do i=1,n
         T(i,j) = A(i,j)
      end do
      end do

*     **** copy R to lower-left of T ****
      do j=1,n
      do i=1,n
         T(i+n,j) = R(i,j)
      end do
      end do

*     **** copy -R^t to upper-right of T ****
      do j=1,n
      do i=1,n
         T(i,j+n) = -R(j,i)
      end do
      end do

      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_4m_to_MN               *
c     *                                      *
c     ****************************************
      subroutine Dneall_4m_to_MN(mb,R,M,N)
      implicit none
      integer mb
      real*8 R(*),M(*),N(*)

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,ishift1,ishift2,shift1,shift2

      if (mparallelized) then
         call errquit('Dneall_AR_to_4m: mparallel not finished',0,0)
      else
        if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = ne(1)*ne(1)
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 30
            shift1 = 1 + (ms-1)*ishift1
            shift2 = 1 + (ms-1)*ishift2
            call Dneall_4m_MN_sub(ne(ms),R(shift2),M(shift1),N(shift1))
  30        continue
         end do
      end if

      return
      end
      subroutine Dneall_4m_MN_sub(n,R,X,Y)
      implicit none
      integer n
      real*8 R(2*n,2*n)
      real*8 X(n,n)
      real*8 Y(n,n)
      integer i,j
      do j=1,n
      do i=1,n
         X(i,j) = R(i,j)
         Y(i,j) = R(i+n,j)
      end do
      end do

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_4m_FactorSkew          *
c     *                                      *
c     ****************************************

*  This routine factors a 4m skew matrix K such that
*  
*  K = U*Sigma*U^H, where U = (V+i*W)
*  
*     Entry - mb:  
*             K: 4mskew matrix - destroyed on output
*     Exit - V: real factor matrix 
*            W: imaginary factor matrix
*            Sigma: eigenvalues
*
      subroutine Dneall_4m_FactorSkew(mb,K,V,W,Sigma)
      implicit none
      integer    mb
      real*8     K(*),V(*),W(*),Sigma(*)

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2

      call nwpw_timing_start(17)

      if (mparallelized) then
        call errquit('Dneall_4m_FactorSkew: mparallel not finished',0,0)
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = 2*ne(1)
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if
         do ms=ms1,ms2
            shift1 = 1 + (ms-1)*ishift1
            shift2 = 1 + (ms-1)*ishift2

            call Factor_Skew(2*ne(ms),
     >                       K(shift2),
     >                       V(shift2),
     >                       W(shift2),
     >                       Sigma(shift1))
         end do
      end if

      call nwpw_timing_end(17)
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_4mm_transpose          *
c     *                                      *
c     ****************************************

      subroutine Dneall_4mm_transpose(mb,Min,Mout)
      implicit none
      integer mb
      real*8  Min(*),Mout(*)


#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = m2cq(1)*n2cq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) goto 20
           shift2 = 1 + (ms-1)*ishift2
           call DMatrix_mm_transpose(2*ne(ms),
     >                 Min(shift2),Mout(shift2),
     >                 m2cq(ms),int_mb(m2c(1,ms)),int_mb(n2c(1,ms)))
 20        continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) goto 30
           shift2 = 1 + (ms-1)*ishift2
           call Dneall_mm_transpose_sub(2*ne(ms),
     >                 Min(shift2),Mout(shift2))
 30        continue
         end do
      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_4m_RotateSkew         *
c     *                                      *
c     ****************************************

      subroutine Dneall_4m_RotateSkew(mb,t,V,W,Sigma,R)
      implicit none
      integer mb
      real*8 t
      real*8 V(*),W(*),Sigma(*),R(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      logical value
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,k,j,indx1,indx2
      integer nj
      integer A(2),B(2),SA(2),SB(2)

*     **** external functions ****
      logical  Dneall_4m_push_get,Dneall_m_pop_stack
      external Dneall_4m_push_get,Dneall_m_pop_stack

      if (mparallelized) then
        call errquit('Dneall_4mm_RotateSkew:mparallel not finished',0,0)
      
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = 2*ne(1)
            ishift2 = 4*ne(1)*ne(1)
            nj = 2*(ne(1)+ne(2))
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            nj = 2*ne(mb)
         end if
         value =           Dneall_4m_push_get(mb,A)
         value = value.and.Dneall_4m_push_get(mb,B)
         value = value.and.MA_push_get(mt_dbl,nj,'SA',SA(2),SA(1))
         value = value.and.MA_push_get(mt_dbl,nj,'SB',SB(2),SB(1))
         if (.not. value) 
     >   call errquit('Dneall_4mm_RotateSkew: pushing stack',0,MA_ERR)


         call Dneall_4mm_RotateSkew_sub1(nj,t,
     >                                   Sigma,
     >                                   dbl_mb(SA(1)),
     >                                   dbl_mb(SB(1)))
         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift1 = (ms-1)*ishift1
           shift2 = (ms-1)*ishift2
           call Dneall_4mm_RotateSkew_sub2(2*ne(ms),
     >                                     dbl_mb(SA(1)+shift1),
     >                                     dbl_mb(SB(1)+shift1),
     >                                     V(shift2+1),
     >                                     W(shift2+1),
     >                                     dbl_mb(A(1)+shift2),
     >                                     dbl_mb(B(1)+shift2))
 30        continue
         end do
         call Dneall_4mmm_Multiply3(mb,V,dbl_mb(A(1)),1.0d0,R,0.0d0)
         call Dneall_4mmm_Multiply3(mb,W,dbl_mb(B(1)),1.0d0,R,1.0d0)

         value =           MA_pop_stack(SB(2))
         value = value.and.MA_pop_stack(SA(2))
         value = value.and.Dneall_m_pop_stack(B)
         value = value.and.Dneall_m_pop_stack(A)
         if (.not. value) 
     >   call errquit('Dneall_4mm_FactorSkew:popping stack',0,MA_ERR)

      end if

      return
      end

      subroutine Dneall_4mm_RotateSkew_sub1(N,t,Sigma,SA,SB)
      implicit none
      integer N
      real*8 t
      real*8 Sigma(N),SA(N),SB(N)

      integer i
      do i=1,N
         SA(i) = dcos(Sigma(i)*t)
         SB(i) = dsin(Sigma(i)*t)
      end do
      return
      end

      subroutine Dneall_4mm_RotateSkew_sub2(N,SA,SB,V,W,A,B)
      implicit none
      integer N
      real*8 SA(N),SB(N)
      real*8 V(N,N),W(N,N)
      real*8 A(N,N),B(N,N)

      integer i,j

      do j=1,N
         do i=1,N
            A(i,j) = V(i,j)*SA(j) + W(i,j)*SB(j)
            B(i,j) = W(i,j)*SA(j) - V(i,j)*SB(j)
         end do
      end do
      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_4mmm_Multiply2         *
c     *                                      *
c     ****************************************

      subroutine Dneall_4mmm_Multiply2(mb,A,B,C)
      implicit none
      integer mb
      real*8 A(*),B(*),C(*)
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer ms,ms1,ms2,n,shift2,ishift2
  
      if (mparallelized) then
        if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = m2cq(1)*n2cq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n = 2*ne(ms)
            if (n.le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm2(n,n,n,64,
     >             1.0d0,
     >             A(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             B(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             0.0d0,
     >             C(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = 2*ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('T','N',n,n,n,1.0d0,
     >                A(shift2), n,
     >                B(shift2), n,
     >                0.0d0,
     >                C(shift2), n)
   30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   4*(ne(1)*ne(1)+ne(2)*ne(2)),C)
         else
            call Parallel_Brdcst_values(MASTER,4*ne(mb)*ne(mb),C)
         end if

      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_4mmm_Multiply3          *
c     *                                      *
c     ****************************************

      subroutine Dneall_4mmm_Multiply3(mb,A,B,alpha,C,beta)
      implicit none
      integer mb
      real*8 A(*),B(*),C(*)
      real*8 alpha,beta

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer ms,ms1,ms2,n,shift2,ishift2

      if (mparallelized) then
        if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = m2cq(1)*n2cq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n = 2*ne(ms)
            if (n.le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm3(n,n,n,64,
     >             alpha,
     >             A(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             B(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             beta,
     >             C(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = 2*ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('N','T',n,n,n,alpha,
     >                A(shift2), n,
     >                B(shift2), n,
     >                beta,
     >                C(shift2), n)
   30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   4*(ne(1)*ne(1)+ne(2)*ne(2)),C)
         else
            call Parallel_Brdcst_values(MASTER,4*ne(mb)*ne(mb),C)
         end if

      end if 

      return
      end





c     ****************************************
c     *                                      *
c     *        Dneall_4mmm_Multiply          *
c     *                                      *
c     ****************************************

      subroutine Dneall_4mmm_Multiply(mb,A,B,alpha,C,beta)
      implicit none
      integer mb
      real*8 A(*),B(*),C(*)
      real*8 alpha,beta
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer ms,ms1,ms2,n,shift2,ishift2
  
      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = m2cq(1)*n2cq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n = 2*ne(ms)
            if (n.le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm1(n,n,n,64,
     >             alpha,
     >             A(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             B(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             beta,
     >             C(shift2),m2cq(ms),
     >                       int_mb(m2c(1,ms)),
     >                       int_mb(n2c(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = 2*ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('N','N',n,n,n,
     >                alpha,
     >                A(shift2), n,
     >                B(shift2), n,
     >                beta,
     >                C(shift2), n)
   30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   4*(ne(1)*ne(1)+ne(2)*ne(2)),C)
         else
            call Parallel_Brdcst_values(MASTER,4*ne(mb)*ne(mb),C)
         end if

      end if

      return
      end






c     ****************************************
c     *                                      *
c     *           Dneall_4m_trace            *
c     *                                      *
c     ****************************************

      double precision function Dneall_4m_trace(mb,M)
      implicit none
      integer mb
      real*8  M(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,indx,i
      real*8  sum

*     ***** external functions ****
      real*8   DMatrix_trace
      external DMatrix_trace

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = m2cq(1)*n2cq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         sum = 0.0d0
         do ms=ms1,ms2
            shift2 = 1 + (ms-1)*ishift2
            sum =  sum + DMatrix_trace(2*ne(ms),
     >                                 M(shift2),m2cq(ms),
     >                                           int_mb(m2c(1,ms)),
     >                                           int_mb(n2c(1,ms)),
     >                                 taskid_i,taskid_j)
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         sum = 0.0d0
         do ms=ms1,ms2

           if (ne(ms).le.0) goto 30
           shift2 = (ms-1)*ishift2

           do i=1,ne(ms)
              indx = i + (i-1)*2*ne(ms) + shift2
              sum = sum + M(indx)
           end do

 30        continue
         end do
      end if

      Dneall_4m_trace = sum
      return
      end


c     ****************************************
c     *                                      *
c     *           Dneall_4m_scal             *
c     *                                      *
c     ****************************************

      subroutine Dneall_4m_scal(mb,alpha,M)
      implicit none
      integer mb
      real*8  alpha
      real*8  M(*)

#include "Dne.fh"

*     **** local variables ****
      integer nn

      if (mparallelized) then
         if (mb.eq.0) then
            nn = m2cq(1)*n2cq(1)+m2cq(2)*n2cq(2)
         else
            nn = m2cq(mb)*n2cq(mb)
         end if
      else
         if (mb.eq.0) then
            nn = 4*(ne(1)*ne(1) + ne(2)*ne(2))
         else
            nn = 4*ne(mb)*ne(mb)
         end if
      end if

      call dscal(nn,alpha,M,1)
      return
      end



c     ****************************************
c     *                                      *
c     *           Dneall_4m_diag_scal        *
c     *                                      *
c     ****************************************

      subroutine Dneall_4m_diag_scal(mb,diag,M)
      implicit none
      integer mb
      real*8  diag(*)
      real*8  M(*)

#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,indx,i

      if (mparallelized) then
         call errquit('Dneall_4m_diag_scal not finished',0,0)
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = 2*ne(1)
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2

            if (ne(ms).le.0) goto 30
            shift1 = (ms-1)*ishift1
            shift2 = (ms-1)*ishift2

            do i=1,2*ne(ms)
               indx = i + (i-1)*2*ne(ms) + shift2
               M(indx) = M(indx)*diag(i+shift1)
            end do

 30        continue
         end do
      end if

      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_4m_diag_scal_inv       *
c     *                                      *
c     ****************************************

      subroutine Dneall_4m_diag_scal_inv(mb,diag,M)
      implicit none
      integer mb
      real*8  diag(*)
      real*8  M(*)

#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,indx,i

      if (mparallelized) then
         call errquit('Dneall_4m_diag_scal_inv not finished',0,0)
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = 2*ne(1)
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
         end if

         do ms=ms1,ms2

            if (ne(ms).le.0) goto 30
            shift1 = (ms-1)*ishift1
            shift2 = (ms-1)*ishift2

            do i=1,2*ne(ms)
               indx = i + (i-1)*2*ne(ms) + shift2
               M(indx) = M(indx)/diag(i+shift1)
            end do

 30        continue
         end do
      end if
      return
      end


      real*8 function  Dneall_4m_value(mb,ms,i,j,A)
      implicit none
      integer mb,ms,i,j
      real*8  A(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ishift2,shift2
      real*8 w

*     **** external functions ****
      real*8   DMatrix_m_get_value
      external DMatrix_m_get_value
      
      w = 0.0d0
      if (ne(ms).gt.0)  then
         if (mparallelized) then

            if (mb.eq.0) then
               ishift2 = m2cq(1)*n2cq(1)
            else
               ishift2 = 0
            end if
            shift2 = 1 + (ms-1)*ishift2
            w = DMatrix_m_get_value(i,j,A(shift2),
     >                 m2cq(ms),int_mb(m2c(1,ms)),int_mb(n2c(1,ms)))
         else
            shift2 = (ms-1)*ne(1)*2
            w = A(i+(j-1)*2*ne(ms)+shift2)
         end if
      end if

      Dneall_4m_value = w
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_4m_eye                  *
c     *                                      *
c     ****************************************

      subroutine Dneall_4m_eye(mb,A,alpha)
      implicit none
      integer mb
      real*8 A(*)
      real*8 alpha

#include "mafdecls.fh"
#include "Dne.fh"


*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,k
      integer indx2

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = m2cq(1)*n2cq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
             shift2 = 1 + (ms-1)*ishift2
             call DMatrix_eye(2*ne(ms),2*ne(ms),
     >                A(shift2),
     >                m2cq(ms),int_mb(m2c(1,ms)),int_mb(n2c(1,ms)),
     >                taskid_i,taskid_j)
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = 4*ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
           if (ne(ms).le.0) go to 30
           shift2 = 1 + (ms-1)*ishift2
           call dcopy(4*ne(ms)*ne(ms),0.0d0,0,A(shift2),1)
           indx2 = shift2
           do k=1,2*ne(ms)
              A(indx2) = alpha
              indx2    = indx2 + (1+2*ne(ms))
           end do

 30        continue
         end do
      end if

      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_mmm_Multiply2ab        *
c     *                                      *
c     ****************************************

      subroutine Dneall_mmm_Multiply2ab(mb,A,B,alpha,C,beta)
      implicit none
      integer mb
      real*8 A(*),B(*),C(*)
      real*8 alpha,beta
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer ms,ms1,ms2,n,shift2,ishift2
  
      if (mparallelized) then
        if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),ne(ms),64,
     >             alpha,
     >             A(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             B(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             beta,
     >             C(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do


      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call DGEMM('T','N',n,n,n,alpha,
     >                A(shift2), n,
     >                B(shift2), n,
     >                beta,
     >                C(shift2), n)
   30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   ne(1)*ne(1)+ne(2)*ne(2),C)
         else
            call Parallel_Brdcst_values(MASTER,ne(mb)*ne(mb),C)
         end if

      end if

      return
      end

c     ****************************************
c     *                                      *
c     *        Dneall_wtom_Real              *
c     *                                      *
c     ****************************************
      subroutine Dneall_wtom_Real(mb,A,B)
      implicit none
      integer mb
      complex*16 A(*)
      real*8     B(*)
      integer i,nsize
      call Dneall_m_size(mb,nsize)
      do i=1,nsize
         B(i) = dble(A(i))
      end do
      return
      end


c     ****************************************
c     *                                      *
c     *        Dneall_mmtow_Cmplx            *
c     *                                      *
c     ****************************************
      subroutine Dneall_mmtow_Cmplx(mb,Ar,Br,C)
      implicit none
      integer mb
      real*8 Ar(*),Br(*)
      complex*16 C(*)
      integer i,nsize
      call Dneall_m_size(mb,nsize)
      do i=1,nsize
         C(i) = dcmplx(Ar(i),Br(i))
      end do
      return
      end



c     ****************************************
c     *                                      *
c     *        Dne_ffm_combo_sym_Multiply    *
c     *                                      *
c     ****************************************
c
c   warning - ms==0 not allowed

      subroutine Dne_ffm_combo_sym_Multiply(ms,A1,A2,npack1,hml3)
      implicit none
      complex*16 A1(*),A2(*)
      integer    ms,npack1
      real*8     hml3(*)
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer n,shift

      call nwpw_timing_start(15)
      if (parallelized) then

         if (mparallelized) then
            if (ne(ms).le.0) go to 20
            shift  = 1 + (ms-1)*neq(1)*npack1
            
            call DMatrix_combo_dgemm2(ne(ms),ne(ms),npack1_all,128,
     >             2.0d0,
     >             A1(shift),A2(shift),
     >                       int_mb(ma(1,ms)+taskid_i), 
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             hml3,        int_mb(mc(1,ms)+taskid_i), 
     >                         int_mb(nc(1,ms)+taskid_j),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_combo_dgemm2(ne(ms),ne(ms),nida1_all,128,
     >             -1.0d0,
     >             A1(shift),A2(shift),
     >                       int_mb(ma(1,ms)+taskid_i), 
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             1.0d0,
     >             hml3,        int_mb(mc(1,ms)+taskid_i), 
     >                         int_mb(nc(1,ms)+taskid_j),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  20        continue

         else

            if (ne(ms).le.0) go to 21
            shift  = 1 + (ms-1)*neq(1)*npack1
            
            call DMatrix_combo_dgemm2(ne(ms),ne(ms),npack1_all,128,
     >             2.0d0,
     >             A1(shift),A2(shift),
     >                       int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             dbl_mb(mat_tmp(1)),
     >                         int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(nc(1,ms)+taskid_j),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

            call DMatrix_combo_dgemm2(ne(ms),ne(ms),nida1_all,128,
     >             -1.0d0,
     >             A1(shift),A2(shift),
     >                       int_mb(ma(1,ms)+taskid_i),
     >                       int_mb(ma1(1,ms)),
     >                       int_mb(na(1,ms)),
     >             1.0d0,
     >             dbl_mb(mat_tmp(1)),
     >                         int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(nc(1,ms)+taskid_j),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  21        continue
            call Dne_m_combo_gather(mall(ms),
     >                        mpack(ms),int_mb(mindx(1,ms)),
     >                        dbl_mb(mat_tmp(1)),hml3)

         end if
      else

         if (ne(ms).le.0) go to 30
         shift  = 1 + (ms-1)*ne(1)*npack1
         call Pack_ccm_combo_sym_dot(1,ne(ms),
     >                     A1(shift),
     >                     A2(shift),
     >                     hml3)

  30     continue
      end if
      call nwpw_timing_end(15)
      return
      end

      subroutine Dne_m_combo_gather(nall,npack,indx,A,B)
      implicit none
      integer nall,npack,indx(*)
      real*8 A(npack,*),B(nall,*)
      integer i
      call dcopy(3*nall,0.0d0,0,B,1)
      do i=1,npack
         B(indx(i),1) = A(i,1)
         B(indx(i),2) = A(i,2)
         B(indx(i),3) = A(i,3)
      end do  
      call Parallel_Vector_SumAll(3*nall,B)
      return
      end




c     ****************************************
c     *                                      *
c     *        Dneall_f_GramSchmidt          *
c     *                                      *
c     ****************************************

c   performs a modified gramSchmidt on Q
c
      subroutine Dneall_f_GramSchmidt(mb,Q,npack1)
      implicit none
      integer mb
      complex*16 Q(*)
      integer    npack1      

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

c     **** local variables ****
      integer ms,ms1,ms2,shift,j,k,indxk,indxj
      integer jj,kk,jcur,kcur
      integer tmp(2)
      real*8 w

      if (parallelized) then

c        **** allocate temporary memory ****
         if (.not.MA_push_get(mt_dcpl,npack1,'tmp',tmp(2),tmp(1)))
     >   call errquit('Dneall_f_Gramschmidt:out of stack',0,MA_ERR)

         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
         else
            ms1 = mb
            ms2 = mb
         end if
         shift = neq(1)*npack1

         do ms=ms1,ms2

            kcur = np_j-1
            kk   = int_mb(na(1,ms)+kcur) - 1 

            do k=ne(ms),1,-1

               if (kcur.eq.taskid_j) then
                  indxk = 1 + kk*npack1    + (ms-1)*shift
                  call Pack_cc_dot(1,Q(indxk),Q(indxk),w)
                  w        = 1.0d0/dsqrt(w)
                  call Pack_c_SMul1(1,w,Q(indxk))
                  call dcopy(2*npack1,Q(indxk),1,dcpl_mb(tmp(1)),1)
               end if

*              *** Brdcst Q(indxk) ***
               if (kcur.gt.0) 
     >            call D1dB_Brdcst_values(kcur,2*npack1,dcpl_mb(tmp(1)))

c              *** set j = k+1 ***
               jj   = kk
               jcur = kcur

               jj = jj - 1
               if (jj.lt.0) then
                  jcur = jcur - 1
                  jj = int_mb(na(1,ms) + jcur) - 1
               end if

               do j=k-1,1,-1
                  if (jcur.eq.taskid_j) then
                     indxj = 1 + jj*npack1    + (ms-1)*shift
                     call Pack_cc_dot(1,dcpl_mb(tmp(1)),Q(indxj),w)
                     w = -w
                     call Pack_cc_daxpy(1,w,dcpl_mb(tmp(1)),Q(indxj))
                  end if

                  jj = jj - 1
                  if (jj.lt.0) then
                     jcur = jcur - 1
                     jj = int_mb(na(1,ms) + jcur) - 1
                  end if

               end do

               kk = kk - 1
               if (kk.lt.0) then
                  kcur = kcur - 1
                  kk = int_mb(na(1,ms) + kcur) - 1
               end if

            end do
         end do

c        **** deallocate local memory ****
         if (.not.MA_pop_stack(tmp(2)))
     >   call errquit('Dneall_f_GramSchmidt:popping stack',0,MA_ERR)



c     **** not parallized ****
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
         else
            ms1 = mb
            ms2 = mb
         end if
         shift = ne(1)*npack1

c         **** modified Gram-Schmidt ****
         do ms=ms1,ms2
         do k=ne(ms),1,-1
            indxk = 1 + (k-1)*npack1 + (ms-1)*shift
            call Pack_cc_dot(1,Q(indxk),Q(indxk),w)
            w        = 1.0d0/dsqrt(w)
            call Pack_c_SMul1(1,w,Q(indxk))

            do j=k-1,1,-1
               indxj = 1 + (j-1)*npack1 + (ms-1)*shift
               call Pack_cc_dot(1,Q(indxk),Q(indxj),w)
               w = -w
               call Pack_cc_daxpy(1,w,Q(indxk),Q(indxj))
            end do
         end do
         end do
      end if

      return
      end 




c     ****************************************
c     *                                      *
c     *        Dneall_mne_diagonalize        *
c     *                                      *
c     ****************************************

      subroutine Dneall_mne_diagonalize(mb,nein,hml,eig,assending)
      implicit none
      integer    mb,nein(2)
      real*8     hml(*),eig(*)
      logical    assending

#include "mafdecls.fh"           
#include "errquit.fh"
#include "Dne.fh"

*     ***** local variables ****
      integer MASTER
      parameter (MASTER=0)
      logical value
      integer ms,ms1,ms2,shift1,shift2,ishift1,ishift2,ierr
      integer tmp1(2),V(2),VV(2),Q(2),tu(2),ework(2)

      integer mcqin(NBLOCKS),ncqin(NBLOCKS)
      integer mcin(2,NBLOCKS),ncin(2,NBLOCKS)
      integer work1in(2),work2in(2)
      integer i,j,k,nework


      call nwpw_timing_start(17)
      if (mparallelized) then

*        ****************************************************
*        **** define mcin,ncin,mcqin,ncqin based on nein ****
*        ****************************************************
         value = .true.
         mcqin(1) = 0
         mcqin(2) = 0
         ncqin(1) = 0
         ncqin(2) = 0
         do ms=1,ispin
             value = value.and.
     >           MA_push_get(mt_int,np_i,'mcin',mcin(2,ms),mcin(1,ms))
             value = value.and.
     >           MA_push_get(mt_int,np_j,'ncin',ncin(2,ms),ncin(1,ms))
             if (.not.value) then
               call errquit(': out of heap memory',0,MA_ERR)
             end if
             call icopy(np_i,0,0,int_mb(mcin(1,ms)),1)
             call icopy(np_j,0,0,int_mb(ncin(1,ms)),1)
             i = 0
             j = 0
             do k=1,nein(ms)
                int_mb(mcin(1,ms)+i) = int_mb(mcin(1,ms)+i) + 1
                int_mb(ncin(1,ms)+j) = int_mb(ncin(1,ms)+j) + 1
                i = mod(i+1,np_i)
                j = mod(j+1,np_j)
             end do
             mcqin(ms) = int_mb(mcin(1,ms)+taskid_i)
             ncqin(ms) = int_mb(ncin(1,ms)+taskid_j)
         end do
*        ****************************************************
*        **** define mcin,ncin,mcqin,ncqin based on nein ****
*        ****************************************************
*        ***************************************************************
*        ****** allocate work1in and work2in ***************************
*        ***************************************************************
         value = value.and.MA_push_get(mt_dbl,
     >                                2*2*64*int_mb(mcin(1,1)+taskid_i),
     >                                  'work1in',work1in(2),work1in(1))
         nework = 2*64*int_mb(ncin(1,1)+taskid_j)
         if (nework.lt.mcqin(1)*ncqin(1)) nework = mcqin(1)*ncqin(1)
         value = value.and.MA_push_get(mt_dbl,
     >                                  3*nework,
     >                                  'work2in',work2in(2),work2in(1))
         if (.not.value) 
     >      call errquit(': out of heap memory',1,MA_ERR)
*        ***************************************************************
*        ****** allocate work1in and work2in ***************************
*        ***************************************************************


         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = nein(1)
            ishift2 = mcqin(1)*ncqin(1)
            call dcopy((nein(1)+nein(2)),0.0d0,0,eig,1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            call dcopy(nein(mb),0.0d0,0,eig,1)
         end if
         value = MA_push_get(mt_dbl,mcqin(1)*ncqin(1),'V',V(2),V(1))
         value = value.and.
     >           MA_push_get(mt_dbl,mcqin(1)*ncqin(1),'VV',VV(2),VV(1))
         value = value.and.
     >           MA_push_get(mt_dbl,mcqin(1)*ncqin(1),'Q',Q(2),Q(1))
         value = value.and.
     >           MA_push_get(mt_dbl,nein(1),'tu',tu(2),tu(1))
         value = value.and.
     >           MA_push_get(mt_dbl,nein(1),'ework',ework(2),ework(1))
         if (.not. value) 
     >      call errquit('Dneall_m_diagonalize:out of stack',
     >                    0,MA_ERR)
         do ms=ms1,ms2
            shift1 = 1+(ms-1)*ishift1
            shift2 = 1+(ms-1)*ishift2

      
            call nwpw_timing_start(22)
            call DMatrix_tredq(nein(ms),
     >                hml(shift2),dbl_mb(Q(1)),
     >                mcqin(ms),int_mb(mcin(1,ms)),int_mb(ncin(1,ms)),
     >                taskid_i,taskid_j,
     >                np_i,np_j,
     >                comm_i,comm_j,
     >                dbl_mb(work1in(1)),dbl_mb(work2in(1)),
     >                dbl_mb(V(1)),dbl_mb(VV(1)))
            call nwpw_timing_end(22)

            call nwpw_timing_start(23)
            call DMatrix_getdiags(nein(ms),
     >                eig(shift1),dbl_mb(tu(1)),
     >                hml(shift2),
     >                mcqin(ms),int_mb(mcin(1,ms)),int_mb(ncin(1,ms)),
     >                taskid_i,taskid_j,
     >                np_i,np_j,
     >                comm_i,comm_j,
     >                dbl_mb(ework(1)))
            call dcopy(mcqin(ms)*ncqin(ms),dbl_mb(Q(1)),1,hml(shift2),1)
            call nwpw_timing_end(23)

            call nwpw_timing_start(24)
            call DMatrix_tqliq(nein(ms),
     >                eig(shift1),dbl_mb(tu(1)),
     >                hml(shift2),
     >                mcqin(ms),int_mb(mcin(1,ms)),int_mb(ncin(1,ms)),
     >                taskid_i,taskid_j,
     >                np_i,np_j,
     >                comm_i,comm_j,
     >                dbl_mb(work1in(1)),dbl_mb(work2in(1)))
            call nwpw_timing_end(24)

            call nwpw_timing_start(25)
            if (.not.assending)
     >      call DMatrix_eigsrtq(nein(ms),
     >              eig(shift1),
     >              hml(shift2),
     >              mcqin(ms),int_mb(mcin(1,ms)),int_mb(ncin(1,ms)),
     >              taskid_i,taskid_j,
     >              np_i,np_j,
     >              comm_i,comm_j,
     >              dbl_mb(work1in(1)),dbl_mb(work2in(1)))
            call nwpw_timing_end(25)

         end do

         value =           MA_pop_stack(ework(2))
         value = value.and.MA_pop_stack(tu(2))
         value = value.and.MA_pop_stack(Q(2))
         value = value.and.MA_pop_stack(VV(2))
         value = value.and.MA_pop_stack(V(2))
         if (.not. value) 
     >    call errquit('error popping stack in Dneall_mne_diagonalize',
     >                 0,MA_ERR)

*        ****************************************************
*        **** deallocate mcin,ncin,work1in,work2in       ****
*        ****************************************************
         value = .true.
         value = value.and.MA_pop_stack(work2in(2))
         value = value.and.MA_pop_stack(work1in(2))
         do ms=ispin,1,-1
            value = value.and.MA_pop_stack(ncin(2,ms))
            value = value.and.MA_pop_stack(mcin(2,ms))
         end do
        if (.not.value) 
     >     call errquit('Dne_end: error deallocating stack',
     >                  0,MA_ERR)
*        ****************************************************
*        **** deallocate mcin,ncin,work1in,work2in       ****
*        ****************************************************

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift1 = nein(1)
            ishift2 = nein(1)*ne(1)
            call dcopy((nein(1)+nein(2)),0.0d0,0,eig,1)
         else
            ms1 = mb
            ms2 = mb
            ishift1 = 0
            ishift2 = 0
            call dcopy(nein(mb),0.0d0,0,eig,1)
         end if

         value = MA_push_get(mt_dbl,(2*nein(1)*nein(1)),
     >                       'tmp1',tmp1(2),tmp1(1))
         if (.not. value) 
     >      call errquit('Dneall_mne_diagonalize:out of stack',
     >                    1,MA_ERR)

*        ***** diagonalize the matrix *****
         do ms=ms1,ms2
            shift1 = 1+(ms-1)*ishift1
            shift2 = 1+(ms-1)*ishift2
            if (nein(ms).le.0) go to 30

            call DSYEV('V','U',nein(ms),
     >                 hml(shift2),nein(ms), 
     >                 eig(shift1),
     >                 dbl_mb(tmp1(1)),2*nein(1)*nein(1),
     >                 ierr)

            if (.not.assending)
     >       call eigsrt(eig(shift1),
     >                   hml(shift2),
     >                   nein(ms),nein(ms))

  30       continue
         end do
         if (mb.eq.0) then
            call Parallel_Brdcst_values(MASTER,
     >                   nein(1)*nein(1)+nein(2)*nein(2),hml)
         else
            call Parallel_Brdcst_values(MASTER,nein(mb)*nein(mb),hml)
         end if

         value = MA_pop_stack(tmp1(2))
         if (.not. value) 
     >    call errquit('error popping stack in Dneall_mne_diagonalize',
     >                 0,MA_ERR)

      end if

      call nwpw_timing_end(17)
      return
      end


      real*8 function  Dneall_mne_value(mb,nein,ms,i,j,A)
      implicit none
      integer mb,ms,i,j,nein(2)
      real*8  A(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ishift2,shift2
      real*8 w

      logical value
      integer mcqin(2),ncqin(2)
      integer mcin(2,NBLOCKS),ncin(2,NBLOCKS)
      integer ii,jj,k

*     **** external functions ****
      real*8   DMatrix_m_get_value
      external DMatrix_m_get_value
      
      w = 0.0d0
      if (nein(ms).gt.0)  then
         if (mparallelized) then


         value = .true.
         mcqin(1) = 0
         mcqin(2) = 0
         ncqin(1) = 0
         ncqin(2) = 0
         do ms=1,ispin
             value = value.and.
     >           MA_push_get(mt_int,np_i,'mcin',mcin(2,ms),mcin(1,ms))
             value = value.and.
     >           MA_push_get(mt_int,np_j,'ncin',ncin(2,ms),ncin(1,ms))
             if (.not.value) then
               call errquit(': out of heap memory',0,MA_ERR)
             end if
             call icopy(np_i,0,0,int_mb(mcin(1,ms)),1)
             call icopy(np_j,0,0,int_mb(ncin(1,ms)),1)
             ii = 0
             jj = 0
             do k=1,nein(ms)
                int_mb(mcin(1,ms)+ii) = int_mb(mcin(1,ms)+ii) + 1
                int_mb(ncin(1,ms)+jj) = int_mb(ncin(1,ms)+jj) + 1
                ii = mod(jj+1,np_i)
                jj = mod(jj+1,np_j)
             end do
             mcqin(ms) = int_mb(mcin(1,ms)+taskid_i)
             ncqin(ms) = int_mb(ncin(1,ms)+taskid_j)
         end do


            if (mb.eq.0) then
               ishift2 = mcqin(1)*ncqin(1)
            else
               ishift2 = 0
            end if
            shift2 = 1 + (ms-1)*ishift2
            w = DMatrix_m_get_value(i,j,A(shift2),
     >                 mcqin(ms),int_mb(mcin(1,ms)),int_mb(ncin(1,ms)))


         do ms=ispin,1,-1
            value = value.and.MA_pop_stack(ncin(2,ms))
            value = value.and.MA_pop_stack(mcin(2,ms))
         end do
        if (.not.value) 
     >     call errquit('Dne_end: error deallocating stack',
     >                  0,MA_ERR)



         else
            if (mb.eq.0) then
               ishift2 = nein(1)*nein(1)
            else
               ishift2 = 0
            end if
            shift2 = (ms-1)*ishift2
            w = A(i+(j-1)*nein(ms)+shift2)
         end if
      end if

      Dneall_mne_value = w
      return
      end



      subroutine Dneall_mne_set_value(w,mb,nein,ms,i,j,A)
      implicit none
      real*8 w
      integer mb,ms,i,j,nein(2)
      real*8  A(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ishift2,shift2

      logical value
      integer mcqin(2),ncqin(2)
      integer mcin(2,NBLOCKS),ncin(2,NBLOCKS)
      integer ii,jj,k

      if (nein(ms).gt.0)  then
         if (mparallelized) then



         value = .true.
         mcqin(1) = 0
         mcqin(2) = 0
         ncqin(1) = 0
         ncqin(2) = 0
         do ms=1,ispin
             value = value.and.
     >           MA_push_get(mt_int,np_i,'mcin',mcin(2,ms),mcin(1,ms))
             value = value.and.
     >           MA_push_get(mt_int,np_j,'ncin',ncin(2,ms),ncin(1,ms))
             if (.not.value) then
               call errquit(': out of heap memory',0,MA_ERR)
             end if
             call icopy(np_i,0,0,int_mb(mcin(1,ms)),1)
             call icopy(np_j,0,0,int_mb(ncin(1,ms)),1)
             ii = 0
             jj = 0
             do k=1,nein(ms)
                int_mb(mcin(1,ms)+ii) = int_mb(mcin(1,ms)+ii) + 1
                int_mb(ncin(1,ms)+jj) = int_mb(ncin(1,ms)+jj) + 1
                ii = mod(ii+1,np_i)
                jj = mod(jj+1,np_j)
             end do
             mcqin(ms) = int_mb(mcin(1,ms)+taskid_i)
             ncqin(ms) = int_mb(ncin(1,ms)+taskid_j)
         end do




            if (mb.eq.0) then
               ishift2 = mcqin(1)*ncqin(1)
            else
               ishift2 = 0
            end if
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_m_set_value(w,i,j,A(shift2),
     >                 mcqin(ms),int_mb(mcin(1,ms)),int_mb(ncin(1,ms)))



         do ms=ispin,1,-1
            value = value.and.MA_pop_stack(ncin(2,ms))
            value = value.and.MA_pop_stack(mcin(2,ms))
         end do
        if (.not.value)
     >     call errquit('Dne_end: error deallocating stack',
     >                  0,MA_ERR)



         else
            if (mb.eq.0) then
               ishift2 = nein(1)*nein(1)
            else
               ishift2 = 0
            end if
            shift2 = (ms-1)*ishift2
             A(i+(j-1)*nein(ms)+shift2) = w
         end if
      end if

      return
      end



c
c
c     ****************************************
c     *                                      *
c     *        Dneall_mne_allocate_block     *
c     *                                      *
c     ****************************************
      logical function Dneall_mne_allocate_block(mb,nb,nein,hml)
      implicit none
      integer mb,nb,nein(2)
      integer hml(2)

#include "Dne.fh"
#include "errquit.fh"
#include "mafdecls.fh"

      integer size

      logical value
      integer mcqin(2),ncqin(2)
      integer mcin(2,NBLOCKS),ncin(2,NBLOCKS)
      integer ii,jj,k,ms

     
      if (mparallelized) then

         value = .true.
         mcqin(1) = 0
         mcqin(2) = 0
         ncqin(1) = 0
         ncqin(2) = 0
         do ms=1,ispin
             value = value.and.
     >           MA_push_get(mt_int,np_i,'mcin',mcin(2,ms),mcin(1,ms))
             value = value.and.
     >           MA_push_get(mt_int,np_j,'ncin',ncin(2,ms),ncin(1,ms))
             if (.not.value) 
     >         call errquit(': out of stackmemory',0,MA_ERR)
     
             call icopy(np_i,0,0,int_mb(mcin(1,ms)),1)
             call icopy(np_j,0,0,int_mb(ncin(1,ms)),1)
             ii = 0
             jj = 0
             do k=1,nein(ms)
                int_mb(mcin(1,ms)+ii) = int_mb(mcin(1,ms)+ii) + 1
                int_mb(ncin(1,ms)+jj) = int_mb(ncin(1,ms)+jj) + 1
                ii = mod(ii+1,np_i)
                jj = mod(jj+1,np_j)
             end do
             mcqin(ms) = int_mb(mcin(1,ms)+taskid_i)
             ncqin(ms) = int_mb(ncin(1,ms)+taskid_j)
         end do



         if (mb.eq.0) then
            size = mcqin(1)*ncqin(1) + mcqin(2)*ncqin(2)
         else
            size = mcqin(mb)*ncqin(mb)
         end if


         do ms=ispin,1,-1
            value = value.and.MA_pop_stack(ncin(2,ms))
            value = value.and.MA_pop_stack(mcin(2,ms))
         end do
        if (.not.value)
     >     call errquit('Dne_end: error deallocating stack',
     >                  0,MA_ERR)


      else
         if (mb.eq.0) then 
            size = nein(1)*nein(1) + nein(2)*nein(2)
         else
            size = nein(mb)*nein(mb)
         end if
      end if
     
      Dneall_mne_allocate_block 
     > = MA_alloc_get(mt_dbl,nb*size,'hmlab',hml(2),hml(1))
      return
      end




c
c
c     ****************************************
c     *                                      *
c     *        Dneall_mne_size                *
c     *                                      *
c     ****************************************
      integer function Dneall_mne_size(mb,nein)
      implicit none
      integer mb,nein(2)

#include "Dne.fh"
#include "errquit.fh"
#include "mafdecls.fh"

      integer size

      logical value
      integer mcqin(2),ncqin(2)
      integer mcin(2,NBLOCKS),ncin(2,NBLOCKS)
      integer ii,jj,k,ms

     
      if (mparallelized) then

         value = .true.
         mcqin(1) = 0
         mcqin(2) = 0
         ncqin(1) = 0
         ncqin(2) = 0
         do ms=1,ispin
             value = value.and.
     >           MA_push_get(mt_int,np_i,'mcin',mcin(2,ms),mcin(1,ms))
             value = value.and.
     >           MA_push_get(mt_int,np_j,'ncin',ncin(2,ms),ncin(1,ms))
             if (.not.value) 
     >         call errquit(': out of stackmemory',0,MA_ERR)
     
             call icopy(np_i,0,0,int_mb(mcin(1,ms)),1)
             call icopy(np_j,0,0,int_mb(ncin(1,ms)),1)
             ii = 0
             jj = 0
             do k=1,nein(ms)
                int_mb(mcin(1,ms)+ii) = int_mb(mcin(1,ms)+ii) + 1
                int_mb(ncin(1,ms)+jj) = int_mb(ncin(1,ms)+jj) + 1
                ii = mod(ii+1,np_i)
                jj = mod(jj+1,np_j)
             end do
             mcqin(ms) = int_mb(mcin(1,ms)+taskid_i)
             ncqin(ms) = int_mb(ncin(1,ms)+taskid_j)
         end do



         if (mb.eq.0) then
            size = mcqin(1)*ncqin(1) + mcqin(2)*ncqin(2)
         else
            size = mcqin(mb)*ncqin(mb)
         end if


         do ms=ispin,1,-1
            value = value.and.MA_pop_stack(ncin(2,ms))
            value = value.and.MA_pop_stack(mcin(2,ms))
         end do
        if (.not.value)
     >     call errquit('Dne_end: error deallocating stack',
     >                  0,MA_ERR)


      else
         if (mb.eq.0) then 
            size = nein(1)*nein(1) + nein(2)*nein(2)
         else
            size = nein(mb)*nein(mb)
         end if
      end if
     
      Dneall_mne_size = size
      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_ggm_sym_Multiply      *
c     *                                      *
c     ****************************************

      subroutine Dneall_ggm_sym_Multiply(mb,A1,A2,n2ft3d,hml)
      implicit none
      integer    mb
      real*8     A1(*),A2(*)
      integer    n2ft3d
      real*8     hml(*)
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift,shift2,ishift2

      call nwpw_timing_start(15)
      if (parallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         if (mparallelized) then
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift  = 1 + (ms-1)*neq(1)*n2ft3d
            shift2 = 1 + (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),n2ft3d_all,128,
     >             1.0d0,
     >             A1(shift),int_mb(ma2(1,ms)+taskid_i), 
     >                       int_mb(ma2(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma2(1,ms)+taskid_i), 
     >                       int_mb(ma2(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             hml(shift2),int_mb(mc(1,ms)+taskid_i), 
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  20        continue
         end do
         else
         do ms=ms1,ms2
            if (ne(ms).le.0) go to 21
            shift  = 1 + (ms-1)*neq(1)*n2ft3d
            shift2 =     (ms-1)*ishift2
            call DMatrix_dgemm2(ne(ms),ne(ms),n2ft3d_all,128,
     >             1.0d0,
     >             A1(shift),int_mb(ma2(1,ms)+taskid_i),
     >                       int_mb(ma2(1,ms)),
     >                       int_mb(na(1,ms)),
     >             A2(shift),int_mb(ma2(1,ms)+taskid_i),
     >                       int_mb(ma2(1,ms)),
     >                       int_mb(na(1,ms)),
     >             0.0d0,
     >             dbl_mb(mat_tmp(1)+shift2),int_mb(mc(1,ms)+taskid_i),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

  21        continue
         end do
         call Dneall_m_gather(mall(mb),mpack(mb),int_mb(mindx(1,mb)),
     >                        dbl_mb(mat_tmp(1)),hml)

         end if
      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            shift  = 1 + (ms-1)*ne(1)*n2ft3d
            shift2 = 1 + (ms-1)*ishift2
            n     = ne(ms)
            if (n.le.0) go to 30

            call D3dB_rrm_sym_dot(1,n,
     >                        A1(shift),
     >                        A2(shift),
     >                        hml(shift2))
  30        continue
         end do
      end if

      call nwpw_timing_end(15)
      return
      end



c     ****************************************
c     *                                      *
c     *        Dneall_www_Multiply          *
c     *                                      *
c     ****************************************

      subroutine Dneall_www_Multiply(mb,A,B,alpha,C,beta)
      implicit none
      integer mb
      complex*16 A(*),B(*),C(*)
      complex*16 alpha,beta
           
#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,n,shift2,ishift2
  
      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            if (ne(ms).le.0) go to 20
            shift2 = 1 + (ms-1)*ishift2
            call CMatrix_zgemm1(ne(ms),ne(ms),ne(ms),64,
     >             alpha,
     >             A(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             B(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             beta,
     >             C(shift2),mcq(ms),
     >                       int_mb(mc(1,ms)),
     >                       int_mb(nc(1,ms)),
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             dbl_mb(work1(1)),dbl_mb(work2(1)))

   20       continue
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2
            n     = ne(ms)
            if (n.le.0) go to 30
            shift2 = 1 + (ms-1)*ishift2
            call ZGEMM('N','N',n,n,n,
     >                alpha,
     >                A(shift2), n,
     >                B(shift2), n,
     >                beta,
     >                C(shift2), n)
   30       continue
         end do
      end if

      return
      end

c     ****************************************
c     *                                      *
c     *           Dneall_ww_copy             *
c     *                                      *
c     ****************************************

      subroutine Dneall_ww_copy(mb,M1,M2)
      implicit none
      integer mb
      complex*16 M1(*),M2(*)

#include "Dne.fh" 

*     **** local variables ****
      integer nn

      if (mparallelized) then
         if (mb.eq.0) then
            nn = mcq(1)*ncq(1)+mcq(2)*ncq(2)
         else
            nn = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then
            nn = ne(1)*ne(1) + ne(2)*ne(2)
         else
            nn = ne(mb)*ne(mb)
         end if 
      end if

      call dcopy(2*nn,M1,1,M2,1)
      return
      end


c     ****************************************
c     *                                      *
c     *           Dneall_mm_copy             *
c     *                                      *
c     ****************************************

      subroutine Dneall_mm_copy(mb,M1,M2)
      implicit none
      integer mb
      real*8 M1(*),M2(*)

#include "Dne.fh"

*     **** local variables ****
      integer nn

      if (mparallelized) then
         if (mb.eq.0) then
            nn = mcq(1)*ncq(1)+mcq(2)*ncq(2)
         else
            nn = mcq(mb)*ncq(mb)
         end if
      else
         if (mb.eq.0) then
            nn = ne(1)*ne(1) + ne(2)*ne(2)
         else
            nn = ne(mb)*ne(mb)
         end if
      end if

      call dcopy(nn,M1,1,M2,1)
      return
      end



c     ****************************************
c     *                                      *
c     *            Dneall_w_tracesqr         *
c     *                                      *
c     ****************************************

      double precision function Dneall_w_tracesqr(mb,M)
      implicit none
      integer mb
      complex*16  M(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,indx,i
      real*8  sum

*     ***** external functions ****
      real*8   CMatrix_tracesqr
      external CMatrix_tracesqr

      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         sum = 0.0d0
         do ms=ms1,ms2
            shift2 = 1 + (ms-1)*ishift2
            sum =  sum + CMatrix_tracesqr(ne(ms),
     >                                 M(shift2),mcq(ms),
     >                                           int_mb(mc(1,ms)),
     >                                           int_mb(nc(1,ms)),
     >                                 taskid_i,taskid_j)
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         sum = 0.0d0
         do ms=ms1,ms2

           if (ne(ms).le.0) goto 30
           shift2 = (ms-1)*ishift2

           do i=1,ne(ms)
              indx = i + (i-1)*ne(ms) + shift2
              sum = sum + dble(M(indx))**2 + dimag(M(indx))**2
           end do

 30        continue
         end do
      end if

      Dneall_w_tracesqr = sum
      return
      end



c     ****************************************
c     *                                      *
c     *            Dneall_w_Max              *
c     *                                      *
c     ****************************************

      double precision function Dneall_w_max(mb,M)
      implicit none
      integer mb
      complex*16  M(*)

#include "mafdecls.fh"
#include "Dne.fh"

*     **** local variables ****
      integer ms,ms1,ms2,shift2,ishift2,indx,i,j
      real*8  sum,maxgrad

*     ***** external functions ****
      real*8   CMatrix_max
      external CMatrix_max

      maxgrad = 0.0d0
      if (mparallelized) then
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = mcq(1)*ncq(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if
         sum = 0.0d0
         do ms=ms1,ms2
            shift2 = 1 + (ms-1)*ishift2
            sum =  CMatrix_max(ne(ms),
     >                         M(shift2),mcq(ms),
     >                         int_mb(mc(1,ms)),
     >                         int_mb(nc(1,ms)),
     >                         taskid_i,taskid_j)
            if (sum.gt.maxgrad) maxgrad = sum 
         end do

      else
         if (mb.eq.0) then
            ms1 = 1
            ms2 = ispin
            ishift2 = ne(1)*ne(1)
         else
            ms1 = mb
            ms2 = mb
            ishift2 = 0
         end if

         do ms=ms1,ms2

           if (ne(ms).le.0) goto 30
           shift2 = (ms-1)*ishift2

           do j=1,ne(ms)
           do i=1,ne(ms)
              indx = i + (j-1)*ne(ms) + shift2
              sum =  dsqrt(dble(M(indx))**2 + dimag(M(indx))**2)
              if (sum.gt.maxgrad) maxgrad = sum 
           end do
           end do

 30        continue
         end do
      end if

      Dneall_w_max = maxgrad
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      subroutine mdinit
#include "common.fh"
c
      double precision six,twelve,ac
      integer i,j
c
c  turn of all cluster related functions
c
      nocluster = .false.
c
c    This subroutine sets up the potentials, assigns atomic masses
c    and finishes initializing the calculation
c
      six = 6.0d00
      twelve = 12.0d00
c
c      initialize timing and energy statistics arrays
c
      do i = 1, MAXNRG
        nrg(i) = 0.0d00
        anrg(i) = 0.0d00
        anrg2(i) = 0.0d00
      end do
      nrgcnt = 0
      nrg2ct = 0
      do i = 1, MAXTIM
        tmstat(i) = 0.0d00
      end do
      failcount = 0
c
c     assign atom masses
c
      do i = 1, antot
        mass(i) = amass(at(i))
      end do
c
c   Initialize cutoffs for  potential arrays.
c
      rcmax = 0.0d00
      do i = 1, atnum
        do j = 1, atnum
          ac = acut(i,j)
          if (ac.gt.rcmax) rcmax = ac
          rcorr(i,j) = e12(i,j) / ac**12
          dcorr(i,j) = -e6(i,j) / ac**6
          if (icut.eq.1) then
            frcorr(i,j) = - twelve * e12(i,j) / ac**13
            fdcorr(i,j) = six * e6(i,j) / ac**7
          else
            frcorr(i,j) = 0.0d00
            fdcorr(i,j) = 0.0d00
          endif
        end do
      end do
      rcmax = rcmax + 1.0d00
c
c   calculate total number of degrees of freedom
c
      nrg(1) = dble(3*atot-3)
      nrg(2) = nrg(1) / 2.0
c
c   Convert algorithm parameters into system units
c
      istep = 0
      tavg = 0.0d00
      itavg = 0
      tmstrt = 0
      t_done = 0.0d00
      t_rmndr = tau
c
c   Initialize parameters for mass and temperature degrees of freedom
c
      vol1 = xbox * ybox * zbox
      alen1(1) = xbox
      alen1(2) = ybox
      alen1(3) = zbox
      vol2 = 0.0d00
      vol3 = 0.0d00
      do j = 1, 3
        alen2(j) = 0.0d00
        alen3(j) = 0.0d00
      end do
      scal1 = 1.0d00
      scal2 = 0.0d00
      scal3 = 0.0d00
c
c   Initialize bins accumulating r_cluster values
c
      do j = 1, 10
        do i = 1, mcbins
          r_distr(i,j) = 0
        end do
      end do
c
c   Initialize absolute coordinates
c
      call cluster_center
      call update
      call force
      mbflg = .true.
      call cluster_com
c
      tavg = 0.0d00
      do j = 1, 3
        do i = 1, antot
          ra(i,j,7) = ra(i,j,8)
          ra(i,j,3) = ra(i,j,4)/mass(i)
        end do
      end do
c
      return
      end

*
* $Id: stress_fd.F 24496 2013-08-09 21:36:41Z bylaska $
*
      logical function stress_fd(rtdb)
      implicit none
      integer rtdb
      logical value

#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "geom.fh"

      logical oprint,lstress_numerical
      integer taskid,MASTER
      parameter (MASTER=0)

      integer l,i,j
      integer r1(2),geom,nion


      double precision alpha,E
      double precision unita(3,3)
      double precision unita2(3,3)
      double precision unita3(3,3)

      double precision stress(3,3)
      double precision ke_stress(3,3)
      double precision xc_stress(3,3)
      double precision ewald_stress(3,3)
      double precision hartree_stress(3,3)
      double precision local_stress(3,3)
      double precision nonlocal_stress(3,3)
      double precision alpha_stress(3,3)
      double precision RIJ_stress(3,3)
      double precision ewaldG_stress(3,3)
      double precision ehsic_stress(3,3)
      double precision excsic_stress(3,3)
      double precision hfx_stress(3,3)
      double precision LJ_stress(3,3)
      double precision Q_stress(3,3)
      double precision spring_stress(3,3)
      double precision dftu_stress(3,3)
      double precision disp_stress(3,3)

      double precision lattice(6)
      double precision lattice2(6)
      double precision lattice3(6)

      double precision lstress(6)
      double precision ke_lstress(6)
      double precision xc_lstress(6)
      double precision ewald_lstress(6)
      double precision hartree_lstress(6)
      double precision local_lstress(6)
      double precision nonlocal_lstress(6)
      double precision alpha_lstress(6)
      double precision RIJ_lstress(6)
      double precision ewaldG_lstress(6)
      double precision ehsic_lstress(6)
      double precision excsic_lstress(6)
      double precision hfx_lstress(6)
      double precision LJ_lstress(6)
      double precision Q_lstress(6)
      double precision spring_lstress(6)
      double precision dftu_lstress(6)
      double precision disp_lstress(6)

      integer date_len
      character*40 date_string

*     *** external functions ****
      logical  pspw_noit_energy
      external pspw_noit_energy

      call Parallel_taskid(taskid)
      oprint = (taskid.eq.MASTER)

*     **** initialize and read in geometry object ****
      value=.true.
      value     = value.and.geom_create(geom,'geometry')
      value     = value.and.geom_rtdb_load(rtdb,geom,'geometry')
      value     = value.and.geom_ncent(geom,nion)
      value     = value.and.
     >            MA_alloc_get(mt_dbl,(3*nion),'r1',r1(2),r1(1))
      if(.not.value) call errquit
     E   (' stressfd: geom malloc failure ',0,0)
      call load_cellgeometry(geom,dbl_mb(r1(1)),unita)

      if (.not.
     >    rtdb_get(rtdb,'nwpw:lstress_numerical',
     >             mt_log,1,lstress_numerical))
     >  lstress_numerical = .false.


*     **** get finite difference step and initialize ****
      if (.not.
     >    rtdb_get(rtdb,'pspw:stress_alpha',mt_dbl,1,alpha))
     >  alpha = 0.00100d0

      if (.not.lstress_numerical) then
      call dcopy(9,0.0d0,0,ke_stress,      1)
      call dcopy(9,0.0d0,0,xc_stress,      1)
      call dcopy(9,0.0d0,0,hartree_stress, 1)
      call dcopy(9,0.0d0,0,ewald_stress,   1)
      call dcopy(9,0.0d0,0,local_stress,   1)
      call dcopy(9,0.0d0,0,nonlocal_stress,1)
      call dcopy(9,0.0d0,0,ehsic_stress,1)
      call dcopy(9,0.0d0,0,excsic_stress,1)
      call dcopy(9,0.0d0,0,hfx_stress,1)
      call dcopy(9,0.0d0,0,LJ_stress,1)
      call dcopy(9,0.0d0,0,Q_stress,1)
      call dcopy(9,0.0d0,0,spring_stress,1)
      call dcopy(9,0.0d0,0,dftu_stress,1)
      call dcopy(9,0.0d0,0,disp_stress,1)

      do j=1,3
      do i=1,3


*     *****************************
*     **** + finite difference ****
*     *****************************
      call dcopy(9,unita,1,unita2,1)
      unita2(i,j) = unita2(i,j) + alpha

*     **** update geometry object ****
      call util_date(date_string)
      date_len = inp_strlen(date_string)
      if (oprint) write(6,*)
      if (oprint) write(6,
     &   '(1x,a12,i2,i2,1x,f8.3,1x,a4,1x,a10,f10.1,6x,a5,a27)')
     &   'amatrix i,j:',i,j,unita2(i,j),'(+)',
     &   'wall time:',util_wallsec(),
     &   'date:',date_string(1:date_len)
      if (oprint) call util_flush(6)
      call store_cellgeometry(geom,dbl_mb(r1(1)),unita2)
      value = value.and.geom_rtdb_store(rtdb,geom,'geometry')
      value = value.and.pspw_noit_energy(rtdb)


      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_ke',mt_dbl,1,E)
      ke_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_xc',mt_dbl,1,E)
      xc_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_hartree',mt_dbl,1,E)
      hartree_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_ewald',mt_dbl,1,E)
      ewald_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_local',mt_dbl,1,E)
      local_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_nonlocal',mt_dbl,1,E)
      nonlocal_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_hsic',mt_dbl,1,E)
      ehsic_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_xcsic',mt_dbl,1,E)
      excsic_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_hfx',mt_dbl,1,E)
      hfx_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_LJ',mt_dbl,1,E)
      LJ_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_Q',mt_dbl,1,E)
      Q_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_spring',mt_dbl,1,E)
      spring_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_dftu',mt_dbl,1,E)
      dftu_stress(i,j) = E

      value = value.and.
     >        rtdb_get(rtdb,'pspw:E_disp',mt_dbl,1,E)
      disp_stress(i,j) = E

*     *****************************
*     **** - finite difference ****
*     *****************************
      call dcopy(9,unita,1,unita3,1)
      unita3(i,j) = unita3(i,j) - alpha

*     **** update geometry object ****
      call util_date(date_string)
      date_len = inp_strlen(date_string)
      if (oprint) write(6,*)
      if (oprint) write(6,
     &   '(1x,a12,i2,i2,1x,f8.3,1x,a4,1x,a10,f10.1,6x,a5,a27)')
     &   'amatrix i,j:',i,j,unita3(i,j),'(-)',
     &   'wall time:',util_wallsec(),
     &   'date:',date_string(1:date_len)
      if (oprint) call util_flush(6)
      call store_cellgeometry(geom,dbl_mb(r1(1)),unita3)
      value = value.and.geom_rtdb_store(rtdb,geom,'geometry')
      value = value.and.pspw_noit_energy(rtdb)


      value = value.and.rtdb_get(rtdb,'pspw:E_ke',mt_dbl,1,E)
      ke_stress(i,j) = ke_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_xc',mt_dbl,1,E)
      xc_stress(i,j) = xc_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_hartree',mt_dbl,1,E)
      hartree_stress(i,j) = hartree_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_ewald',mt_dbl,1,E)
      ewald_stress(i,j) = ewald_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_local',mt_dbl,1,E)
      local_stress(i,j) = local_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_nonlocal',mt_dbl,1,E)
      nonlocal_stress(i,j) = nonlocal_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_hsic',mt_dbl,1,E)
      ehsic_stress(i,j) = ehsic_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_xcsic',mt_dbl,1,E)
      excsic_stress(i,j) = excsic_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_hfx',mt_dbl,1,E)
      hfx_stress(i,j) = hfx_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_LJ',mt_dbl,1,E)
      LJ_stress(i,j) = LJ_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_Q',mt_dbl,1,E)
      Q_stress(i,j) = Q_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_spring',mt_dbl,1,E)
      spring_stress(i,j) = spring_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_dftu',mt_dbl,1,E)
      dftu_stress(i,j) = dftu_stress(i,j) - E

      value = value.and.rtdb_get(rtdb,'pspw:E_disp',mt_dbl,1,E)
      disp_stress(i,j) = disp_stress(i,j) - E

      end do
      end do
      call dscal(9,(0.5d0/alpha),ke_stress,1)
      call dscal(9,(0.5d0/alpha),xc_stress,1)
      call dscal(9,(0.5d0/alpha),hartree_stress,1)
      call dscal(9,(0.5d0/alpha),ewald_stress,1)
      call dscal(9,(0.5d0/alpha),local_stress,1)
      call dscal(9,(0.5d0/alpha),nonlocal_stress,1)
      call dscal(9,(0.5d0/alpha),ehsic_stress,1)
      call dscal(9,(0.5d0/alpha),excsic_stress,1)
      call dscal(9,(0.5d0/alpha),hfx_stress,1)
      call dscal(9,(0.5d0/alpha),LJ_stress,1)
      call dscal(9,(0.5d0/alpha),Q_stress,1)
      call dscal(9,(0.5d0/alpha),spring_stress,1)
      call dscal(9,(0.5d0/alpha),dftu_stress,1)
      call dscal(9,(0.5d0/alpha),disp_stress,1)

      call write_stress(ke_stress,"ke FD")
      call write_stress(hartree_stress,"coulomb FD")
      call write_stress(local_stress,"local FD")
      call write_stress(nonlocal_stress,"nonlocal FD")
      call write_stress(xc_stress,"xc FD")
      call write_stress(ewald_stress,"ewald FD")
      call write_stress(ehsic_stress,"Eh SIC FD")
      call write_stress(excsic_stress,"Exc SIC FD")
      call write_stress(hfx_stress,"HFX FD")
      call write_stress(LJ_stress,"LJ FD")
      call write_stress(Q_stress,"Q FD")
      call write_stress(spring_stress,"spring FD")
      call write_stress(dftu_stress,"DFTU FD")
      call write_stress(disp_stress,"Dispersion FD")

      call dcopy(9,ke_stress,1,stress,1)
      call daxpy(9,1.0d0,xc_stress,1,stress,1)
      call daxpy(9,1.0d0,hartree_stress,1,stress,1)
      call daxpy(9,1.0d0,ewald_stress,1,stress,1)
      call daxpy(9,1.0d0,local_stress,1,stress,1)
      call daxpy(9,1.0d0,nonlocal_stress,1,stress,1)
      call daxpy(9,1.0d0,ehsic_stress,1,stress,1)
      call daxpy(9,1.0d0,excsic_stress,1,stress,1)
      call daxpy(9,1.0d0,hfx_stress,1,stress,1)
      call daxpy(9,1.0d0,LJ_stress,1,stress,1)
      call daxpy(9,1.0d0,Q_stress,1,stress,1)
      call daxpy(9,1.0d0,spring_stress,1,stress,1)
      call daxpy(9,1.0d0,dftu_stress,1,stress,1)
      call daxpy(9,1.0d0,disp_stress,1,stress,1)
      call write_stress(stress,"TOTAL FD")

*     **************************************
*     **** output stress for use driver ****
*     **************************************
      value = value.and.rtdb_put(rtdb,'pspw:stress',mt_dbl,9,stress)
      
      else
         call cell_unita_abc_abg(unita,lattice)

         do i=1,6
*           *****************************
*           **** + finite difference ****
*           *****************************
            call dcopy(6,lattice,1,lattice2,1)
            lattice2(i) = lattice2(i) + alpha
            call cell_abc_abg_unita(lattice2,unita2)

*           **** update geometry object ****
            call util_date(date_string)
            date_len = inp_strlen(date_string)
            if (oprint) write(6,*)
            if (oprint) write(6,
     &      '(1x,a12,i2,1x,f8.3,1x,a4,1x,a10,f10.1,6x,a5,a27)')
     &      'lattice i:',i,lattice2(i),'(+)',
     &      'wall time:',util_wallsec(),
     &      'date:',date_string(1:date_len)
            if (oprint) call util_flush(6)
            call store_cellgeometry(geom,dbl_mb(r1(1)),unita2)
            value = value.and.geom_rtdb_store(rtdb,geom,'geometry')
            value = value.and.pspw_noit_energy(rtdb)

            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_ke',mt_dbl,1,E)
            ke_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_xc',mt_dbl,1,E)
            xc_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_hartree',mt_dbl,1,E)
            hartree_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_ewald',mt_dbl,1,E)
            ewald_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_local',mt_dbl,1,E)
            local_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_nonlocal',mt_dbl,1,E)
            nonlocal_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_hsic',mt_dbl,1,E)
            ehsic_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_xcsic',mt_dbl,1,E)
            excsic_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_hfx',mt_dbl,1,E)
            hfx_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_LJ',mt_dbl,1,E)
            LJ_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_Q',mt_dbl,1,E)
            Q_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_spring',mt_dbl,1,E)
            spring_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_dftu',mt_dbl,1,E)
            dftu_lstress(i) = E
            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_disp',mt_dbl,1,E)
            disp_lstress(i) = E

*           *****************************
*           **** - finite difference ****
*           *****************************
            call dcopy(6,lattice,1,lattice3,1)
            lattice3(i) = lattice3(i) - alpha
            call cell_abc_abg_unita(lattice3,unita3)

*           **** update geometry object ****
            call util_date(date_string)
            date_len = inp_strlen(date_string)
            if (oprint) write(6,*)
            if (oprint) write(6,
     &         '(1x,a12,i2,1x,f8.3,1x,a4,1x,a10,f10.1,6x,a5,a27)')
     &         'lattice i:',i,lattice3(i),'(-)',
     &         'wall time:',util_wallsec(),
     &         'date:',date_string(1:date_len)
            if (oprint) call util_flush(6)
            call store_cellgeometry(geom,dbl_mb(r1(1)),unita3)
            value = value.and.geom_rtdb_store(rtdb,geom,'geometry')
            value = value.and.pspw_noit_energy(rtdb)

            value = value.and.rtdb_get(rtdb,'pspw:E_ke',mt_dbl,1,E)
            ke_lstress(i) = ke_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_xc',mt_dbl,1,E)
            xc_lstress(i) = xc_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_hartree',mt_dbl,1,E)
            hartree_lstress(i) = hartree_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_ewald',mt_dbl,1,E)
            ewald_lstress(i) = ewald_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_local',mt_dbl,1,E)
            local_lstress(i) = local_lstress(i) - E

            value = value.and.
     >              rtdb_get(rtdb,'pspw:E_nonlocal',mt_dbl,1,E)
            nonlocal_lstress(i) = nonlocal_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_hsic',mt_dbl,1,E)
            ehsic_lstress(i) = ehsic_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_xcsic',mt_dbl,1,E)
            excsic_lstress(i) = excsic_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_hfx',mt_dbl,1,E)
            hfx_lstress(i) = hfx_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_LJ',mt_dbl,1,E)
            LJ_lstress(i) = LJ_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_Q',mt_dbl,1,E)
            Q_lstress(i) = Q_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_spring',mt_dbl,1,E)
            spring_lstress(i) = spring_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_dftu',mt_dbl,1,E)
            dftu_lstress(i) = dftu_lstress(i) - E

            value = value.and.rtdb_get(rtdb,'pspw:E_disp',mt_dbl,1,E)
            disp_lstress(i) = disp_lstress(i) - E
         end do

         call dscal(6,(0.5d0/alpha),ke_lstress,1)
         call dscal(6,(0.5d0/alpha),xc_lstress,1)
         call dscal(6,(0.5d0/alpha),hartree_lstress,1)
         call dscal(6,(0.5d0/alpha),ewald_lstress,1)
         call dscal(6,(0.5d0/alpha),local_lstress,1)
         call dscal(6,(0.5d0/alpha),nonlocal_lstress,1)
         call dscal(6,(0.5d0/alpha),ehsic_lstress,1)
         call dscal(6,(0.5d0/alpha),excsic_lstress,1)
         call dscal(6,(0.5d0/alpha),hfx_lstress,1)
         call dscal(6,(0.5d0/alpha),LJ_lstress,1)
         call dscal(6,(0.5d0/alpha),Q_lstress,1)
         call dscal(6,(0.5d0/alpha),spring_lstress,1)
         call dscal(6,(0.5d0/alpha),dftu_lstress,1)
         call dscal(6,(0.5d0/alpha),disp_lstress,1)

         call write_lstress(ke_lstress,"ke FD")
         call write_lstress(hartree_lstress,"coulomb FD")
         call write_lstress(local_lstress,"local FD")
         call write_lstress(nonlocal_lstress,"nonlocal FD")
         call write_lstress(xc_lstress,"xc FD")
         call write_lstress(ewald_lstress,"ewald FD")
         call write_lstress(ehsic_lstress,"Eh SIC FD")
         call write_lstress(excsic_lstress,"Exc SIC FD")
         call write_lstress(hfx_lstress,"HFX FD")
         call write_lstress(LJ_lstress,"LJ FD")
         call write_lstress(Q_lstress,"Q FD")
         call write_lstress(spring_lstress,"spring FD")
         call write_lstress(dftu_lstress,"dftu FD")
         call write_lstress(disp_lstress,"Dispersion FD")

         call dcopy(6,ke_lstress,1,lstress,1)
         call daxpy(6,1.0d0,xc_lstress,1,lstress,1)
         call daxpy(6,1.0d0,hartree_lstress,1,lstress,1)
         call daxpy(6,1.0d0,ewald_lstress,1,lstress,1)
         call daxpy(6,1.0d0,local_lstress,1,lstress,1)
         call daxpy(6,1.0d0,nonlocal_lstress,1,lstress,1)
         call daxpy(6,1.0d0,ehsic_lstress,1,lstress,1)
         call daxpy(6,1.0d0,excsic_lstress,1,lstress,1)
         call daxpy(6,1.0d0,hfx_lstress,1,lstress,1)
         call daxpy(6,1.0d0,LJ_lstress,1,lstress,1)
         call daxpy(6,1.0d0,Q_lstress,1,lstress,1)
         call daxpy(6,1.0d0,spring_lstress,1,lstress,1)
         call daxpy(6,1.0d0,dftu_lstress,1,lstress,1)
         call daxpy(6,1.0d0,disp_lstress,1,lstress,1)
         call write_lstress(lstress,"TOTAL FD")

*        **************************************
*        **** output lstress for use driver ****
*        **************************************
         value = value.and.
     >           rtdb_put(rtdb,'pspw:lstress',mt_dbl,6,lstress)
      end if

      call store_cellgeometry(geom,dbl_mb(r1(1)),unita)
      !value = value.and.geom_rtdb_delete(rtdb,'geometry')
      value = value.and.geom_rtdb_store(rtdb,geom,'geometry')
      value = value.and.geom_destroy(geom)
      value = value.and.MA_free_heap(r1(2))
 
      stress_fd = value
      return 
      end

      SUBROUTINE vib_PRDATA(rtdb,ARRAY,VECT,NR,NC,NRP,NCP,PVEC,NPRI
     &    ,first_pass)
* $Id: vib_prdata.F 19708 2010-10-29 18:04:21Z d3y133 $
C*MODULE VIB  *DECK PRDATA
c
      IMPLICIT NONE
#include "errquit.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "eaf.fh"
c
      integer rtdb, nr, nc, nrp, ncp, npri
      double precision ARRAY(NR,NC), VECT(NC)
      CHARACTER*11 FREQ
      character*255 filename
      LOGICAL PVEC
      logical first_pass
      logical projected
c
      integer i, j, l
      integer ncl, ncu, nloops
      integer fd
      double precision offset, nrd(2)
c
      FREQ = 'Frequency'
      projected = .not.first_pass
      if (projected) FREQ = 'P.Frequency'
C
      NCL=1
      NCU=6
      NLOOPS=NCP/6+1
      DO 20 L=1,NLOOPS
        IF (NCU.GT.NCP)NCU=NCP
C
        WRITE(luout,9110)(J,J=NCL,NCU)        
        write(luout,9300)
        IF(PVEC) THEN
          WRITE(luout,9210)FREQ,(VECT(J),J=NCL,NCU)
        ENDIF
        write(luout,9300)
        DO 12 I=1,NRP
          WRITE(luout,9402)I,(ARRAY(I,J),J=NCL,NCU)
 12     CONTINUE
        IF(NCU.GE.NCP) goto 00001
        NCL=NCU+1
        NCU=NCU+6
   20 CONTINUE
C
00001 continue
*
* print ecce information
*      
      if (first_pass) then
        call ecce_print1('frequencies',mt_dbl,vect,nc)
        if(.not. rtdb_put(rtdb,'vib:frequencies',MT_DBL,nc,
     &      vect))
     &      call errquit('vib_prdata:rtdb_put of frequencies failed',
     &      555, RTDB_ERR)
        call ecce_print2('normal modes',mt_dbl,
     &      array,nr,nr,nc)
      else
        call ecce_print1('projected frequencies',mt_dbl,vect,nc)
        if(.not. rtdb_put(rtdb,'vib:projected frequencies',
     &      MT_DBL,nc,vect))
     &      call errquit(
     &      'vib_prdata:rtdb_put of projected frequencies failed',
     &      555, RTDB_ERR)
        call ecce_print2('projected normal modes',mt_dbl,
     &      array,nr,nr,nc)
      endif
c
c print frequencies and normal modes to file in case it is needed for vscf
c
      if ((.not.first_pass).and.(ga_nodeid().eq.0)) then
        call util_file_name('nmode',.false.,.false.,filename)
        if (eaf_open(filename,eaf_rw,fd).ne.0)
     &    call errquit('vib_prdata:eaf_open failed',555, DISK_ERR)
c
c     Format is (with all data as reals)
c
c     nr = no. of rows or variables
c     nc = no. of columns or modes
c     freq(nc) = frequencies
c     evecs(nr,nc) = eigenvectors
c     
c     To avoid having to worry about integer sizes between languages
c     just write the integer dimensions as doubles
c
        nrd(1) = nr
        nrd(2) = nc
c
        offset = 0
        if (eaf_write(fd,offset,nrd,16).ne.0)
     &    call errquit('vib_prdata:error writing nmodes',555, DISK_ERR)
        offset = 16
        if (eaf_write(fd,offset,vect,nr*8).ne.0)
     &    call errquit('vib_prdata:error writing frequencies',555,
     &       DISK_ERR)
        offset = offset + nr*8
        if (eaf_write(fd,offset,array,nr*nc*8).ne.0)
     &    call errquit('vib_prdata:error writing modes',555, DISK_ERR)
        if (eaf_close(fd).ne.0)
     &    call errquit('vib_prdata:file close problem',555, DISK_ERR)
      endif
c
      RETURN
C
 9110 FORMAT(/18X,6(I3,9X))
 9111 format(1x,'Projected')
 9210 FORMAT(1X,A11,6F12.2)
 9300 FORMAT(' ')
 9402 FORMAT(9X,I3,6F12.5)
C
      END

      SUBROUTINE e2_offset_2_offset(l_a_offset,k_a_offset,
     &                              l_b_offset,k_b_offset,
     &                              l_c_offset,k_c_offset,length)
C     $Id: e2_offset_2_offset.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     v ( g3 g4 g1 g2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset,l_b_offset,l_c_offset
      INTEGER k_a_offset,k_b_offset,k_c_offset
      INTEGER length
      INTEGER addr
      INTEGER g3b
      INTEGER g4b 
      INTEGER g1b
      INTEGER g2b
      INTEGER i,j,k,l
      INTEGER i1,j1,k1,l1
      INTEGER irow,icol,ires
      INTEGER INDEX_PAIR

c
c--      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
c--     &set)) CALL ERRQUIT('tce_offset_2_offset',0,MA_ERR)
c alternative approach to store l_b_offset: coding(g3b,g4b,g1b,g2b) as a 
c                                           single integer 
c declaring l_b_offset as a global array 
c--      IF (.not.MA_PUSH_GET(mt_int,4*length+1,'noname',l_b_offset,k_b_off
c--     &set)) CALL ERRQUIT('tce_offset_2_offset',0,MA_ERR)
c  here l_v2spin_offset
      IF (.not.MA_PUSH_GET(mt_int,length+1,'noname',l_c_offset,
     &k_c_offset)) CALL ERRQUIT('tce_offset_2_offset',0,MA_ERR)


c--      int_mb(k_a_offset) = length
c--      int_mb(k_b_offset) = length
      int_mb(k_c_offset) = length 
c initial  zeroing
      do i=1,length
c--        int_mb(k_a_offset+i)         = 0
c--        int_mb(k_a_offset+i+length)  = 0
c--        int_mb(k_b_offset+i)         = 0
c--        int_mb(k_b_offset+i+length)  = 0 
c--        int_mb(k_b_offset+i+2*length)= 0
c--        int_mb(k_b_offset+i+3*length)= 0
        int_mb(k_c_offset+i)         = 0
      end do
c
c
      RETURN
      END

c
c FNAME - filename for test program
c
c$Id: util_dra_test.F 21315 2011-10-27 22:58:38Z d3p852 $
c
#define BASE_NAME 'dra.file'
#ifdef  HPIODIR
#  define FNAME   HPIODIR//BASE_NAME
#else
#  define FNAME   BASE_NAME
#endif

      subroutine util_dra_test
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
      integer status, me
      integer max_arrays
      integer stack, heap
      double precision max_sz, max_disk, max_mem 
      data max_arrays, max_sz, max_disk, max_mem /10,1d8,1d10, 1d6/
      data stack, heap /80000, 80000/
c
c     call pbeginf 
c     if(ma_init(MT_F_DBL, stack, heap) ) then
c       call ga_initialize()
        me    = ga_nodeid()
        if(dra_init(max_arrays, max_sz, max_disk, max_mem).ne.0)then
                call ga_error('dra_init failed: ',0)
        endif
        if(me.eq.0) then
          write(6,'(A)') ' Checking integers'
          write(6,*)
          write(6,'(A)') ' dra_init ......................... OK'
          call ffflush(6)
        endif
        call test_io_int()
        if(me.eq.0) then
          write(6,*)
          write(6,'(A)') ' Checking doubles'
          write(6,*)
        endif
        call test_io_dbl()
        status = dra_terminate()
        if (status.ne.0) call ga_error('dra_terminate failed: ',0)
        if(me.eq.0) then
          write(6,'(A)') ' dra_terminate .................... OK'
          call ffflush(6)
        endif
c       call ga_terminate()
c     else
c       print *,'ma_init failed'
c     endif
c     if(me.eq.0)print *, 'all done ...'
c     call pend()
      end


      subroutine test_io_int
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
      integer n,m
      parameter (n = 100)
      parameter (m = 2*n)
      integer a(n,n)
c      integer ga_idot
      integer g_a, g_b, d_a
      integer i,j, req, err, dim1, dim2, type
      integer me, nproc
      logical status
      character*200 filename
      character*100 name
c      external ga_idot
c    
      nproc = ga_nnodes()
      me    = ga_nodeid()
      call init_char(name,100, ' ')
      call init_char(filename,200, ' ')
c    
c     a() is a local copy of what the l array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = i-1 + (j-1)*n
         enddo
      enddo
c
c     if (me.eq.0) print *, 'Creating global arrays'
      call ga_sync()
      if(.not. ga_create(MT_INT, n, n, 'a', 1, 1, g_a))
     &         call ga_error('ga_create failed: a', 0)
      if(.not. ga_create(MT_INT, n, n, 'b', 1, 1, g_b))
     &         call ga_error('ga_create failed: b', 0)
c
*     call ga_zero(g_a)
*     call ga_zero(g_b)
c
      do j = 1+me, n, nproc
         call ga_put(g_a, 1, n, j, j, a(1, j), n)
      enddo
c
c     if(me.eq.0) print *, 'Creating Disk Array ',n,' x',n
      if(dra_create(MT_INT, n, n, 'array A', 
     &   FNAME, 
     &   DRA_RW,    n, 1, d_a).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
      if (me.eq.0) then
        write(6,'(A)') ' dra_create ....................... OK'
        call ffflush(6)
      endif
c
c     if(me.eq.0) print *, 'Writing Global Array to Disk Array'
      if(dra_write(g_a, d_a,req).ne.0)
     $   CALL ga_error('dra_write failed:',0)
      if(dra_wait(req).ne.0)call ga_error('dra_wait failed: ' ,req)
      if (me.eq.0) then
        write(6,'(A)') ' dra_write ........................ OK'
        call ffflush(6)
      endif
c     if (me.eq.0) print *,'OK'
c     if (me.eq.0) print*,' '
c     if(me.eq.0) print *, 'Closing Disk Array'
      if(dra_close(d_a).ne.0)call ga_error('dra_close failed: ',d_a)
      if (me.eq.0) then
        write(6,'(A)') ' dra_close ........................ OK'
        call ffflush(6)
      endif
c     if (me.eq.0) print *,'OK'
c     if (me.eq.0) print*,' '
c
c     if(me.eq.0) print *, 'Opening Existing Disk Array'
      if(dra_open(FNAME ,DRA_R, d_a).ne.0)
     &            call ga_error('dra_open failed',0)
c     
      if(dra_inquire(d_a, type, dim1, dim2, name, filename).ne.0)
     &            call ga_error('dra_inquire failed',0)
      if(dim1.ne.n) call ga_error('dim1 error',dim1)
      if(dim2.ne.n) call ga_error('dim2 error',dim2)
      if(type.ne.MT_INT) call ga_error('type error',type)
c     if(me.eq.0) print *, 'array name read from disk is:',name
      call ga_sync()
c     if (me.eq.0) print *,'OK'
c     if (me.eq.0) print*,' '
      if (me.eq.0) then
        write(6,'(A)') ' dra_open ......................... OK'
        write(6,'(A)') ' dra_inquire ...................... OK'
        call ffflush(6)
      endif
c
c     if(me.eq.0) print *, 'Checking dra_read'
c     call dra_set_mode(1)
      if(dra_read(g_b, d_a, req).ne.0)
     $   CALL ga_error('dra_read failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
c
c     error checking: (g_a - g_b)^2
c
c     call ga_print(g_a)
c     call ga_print(g_b)
      call ga_add(1, g_a, -1, g_b, g_b) 
      err = ga_idot(g_b, g_b) 
c
      if(err.ne.0 )then
          if( me.eq.0) call ga_error('failed', err) 
      else
c         if (me.eq.0) print *,'OK'
      if (me.eq.0) then
        write(6,'(A)') ' dra_read ......................... OK'
        call ffflush(6)
      endif
      endif 
c     if (me.eq.0) print*,' '
c
c     if(me.eq.0) print *, 'Checking dra_delete'
      if(dra_delete(d_a).ne.0)
     &            call ga_error('dra_delete failed',0)
      if (me.eq.0) then
        write(6,'(A)') ' dra_delete ....................... OK'
        call ffflush(6)
      endif
c     if (me.eq.0) print *,'OK'
c     if (me.eq.0) print*,' '
      status = ga_destroy(g_a)
      status = ga_destroy(g_b)
      end




      subroutine test_io_dbl
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
      integer n,m
      parameter (n = 100)
      parameter (m = 2*n)
      double precision a(n,n),  err
      integer g_a, g_b,  d_a
      double precision drand
      integer i,j, req, loop
      integer dilo,dihi,djlo,djhi
      integer gilo,gihi,gjlo,gjhi
      integer ielem, jelem
      integer me, nproc
      integer iran
      logical status
      external  drand
      intrinsic int, dble
      iran(i) = int(drand(0)*dble(i-1)) + 1
c    
      loop  = 30
      nproc = ga_nnodes()
      me    = ga_nodeid()
c    
c     a() is a local copy of what the l array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = dble(i-1 + (j-1)*n)
         enddo
      enddo
c
      call ga_sync()
      if(.not. ga_create(MT_DBL, n, n, 'a', 1, 1, g_a))
     &         call ga_error('ga_create failed: a', 0)
      if(.not. ga_create(MT_DBL, n, n, 'b', 1, 1, g_b))
     &         call ga_error('ga_create failed: b', 0)
c
      call ga_zero(g_a)
      call ga_zero(g_b)
c
      do j = 1+me, n, nproc
         call ga_put(g_a, 1, n, j, j, a(1, j), n)
      enddo
c
c     if (me.eq.0) print*, 'Creating Disk Array ',n,' x',n
      if(dra_create(MT_DBL, n, n, 'A', 
     &      FNAME, 
     &      DRA_RW, n, 3, d_a).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
c
      if (me.eq.0) then
        write(6,'(A)') ' dra_create ....................... OK'
        call ffflush(6)
      endif
c     if(me.eq.0) print *, 'Writing Global Array to Disk Array'
      if(dra_write(g_a, d_a,req).ne.0)
     $   CALL ga_error('dra_write failed:',0)
c     if (me.eq.0) print*,' '
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
c
      if(dra_close(d_a).ne.0)call ga_error('dra_close failed: ',d_a)
c
      if (me.eq.0) then
        write(6,'(A)') ' dra_write ........................ OK'
        call ffflush(6)
      endif
c     if(me.eq.0) print *, 'Checking dra_read'
      if(dra_open(FNAME,DRA_R, d_a).ne.0)
     &            call ga_error('dra_open failed',0)
      if(dra_read(g_b, d_a, req).ne.0)
     $   CALL ga_error('dra_read failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
c
c     error checking: (g_a - g_b)^2
c
c     call ga_print(g_a)
c     call ga_print(g_b)
      call ga_add(1d0, g_a, -1d0, g_b, g_b) 
      err = ga_ddot(g_b, g_b) 
      if(err.ne.0) then
          if (me.eq.0) print *,'error =', err 
      else
c         if (me.eq.0) print *,'OK'
      if (me.eq.0) then
        write(6,'(A)') ' dra_read ......................... OK'
        call ffflush(6)
      endif
      endif 
c     if (me.eq.0) print*,' '
c
c     if(me.eq.0) print *, 'Checking dra_read_section'
c
      call ga_zero(g_b)
      do j = 1, loop
         dilo = iran(n)
         dihi = iran(n) 
         djlo = iran(n)
         djhi = iran(n) 
c
         if(dilo.gt.dihi) call swap(dilo,dihi)
         if(djlo.gt.djhi) call swap(djlo,djhi)
         ielem = dihi - dilo +1
         jelem = djhi - djlo +1
c
         gilo = iran(n-ielem)+1 
         gjlo = iran(n-jelem)+1 
         gihi = gilo+ielem-1
         gjhi = gjlo+jelem-1
c
c         if(me.eq.0) then
c            write(6,100) gilo,gihi,gjlo,gjhi,dilo,dihi,djlo,djhi 
c100         format(1x,'reading  global[',2(i4,':',i4),
c     &                ']  from  disk[',2(i4,':',i4),']')
c            call ffflush(6)
c         endif
c
*        call ga_print(g_b,1)
         if(dra_read_section(.false.,   g_b, gilo, gihi, gjlo, gjhi,
     &                      d_a, dilo, dihi, djlo, djhi, req).ne.0)
     &      call ga_error('dra_read failed:',0)
         if(dra_wait(req).ne.0) call ga_error('dra_wait failed:',req)
*        call ga_print(g_b,1)
*        call ga_print_patch(g_a, dilo, dihi, djlo, djhi,1)
*        call ga_print_patch(g_b, gilo, gihi, gjlo, gjhi,1)
c
         call ga_add_patch(1d0, g_a, dilo, dihi, djlo, djhi,
     &                     -1d0, g_b, gilo, gihi, gjlo, gjhi,
     &                           g_b, gilo, gihi, gjlo, gjhi) 
         err = ga_ddot_patch(g_b,'n', gilo, gihi, gjlo, gjhi,
     &                       g_b,'n', gilo, gihi, gjlo, gjhi) 
         if(err.ne.0 .and. me.eq.0)then
            print *,'error =', err
            call ga_error('failed',0)
         endif
      enddo
c     if (me.eq.0) print*,' OK'
c     if (me.eq.0) print*,' '
      if (me.eq.0) then
        write(6,'(A)') ' dra_read_section ................. OK'
        call ffflush(6)
      endif
      if(dra_delete(d_a).ne.0)
     &            call ga_error('dra_delete failed',0)
      if (me.eq.0) then
        write(6,'(A)') ' dra_delete ....................... OK'
        call ffflush(6)
      endif
c
c***  now d_a is 4 times larger than g_a
c
c     if (me.eq.0) print*, 'Creating New Disk Array ',m,' x',m
      if(dra_create(MT_DBL, m, m, 'A', 
     &      FNAME, 
     &      DRA_RW, n, 2, d_a).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
c     if (me.eq.0) print*,' OK'
c     if (me.eq.0) print*,' '
      if (me.eq.0) then
        write(6,'(A)') ' dra_create (large) ............... OK'
        call ffflush(6)
      endif
c
c   
c     call ga_print(g_a)
c     call ga_zero(g_b)
c     if (me.eq.0) print*,'Testing dra_write_section'
      do j = 1, loop
         gilo = iran(n)
         gihi = iran(n)
         gjlo = iran(n)
         gjhi = iran(n)
c
         if(gilo.gt.gihi) call swap(gilo,gihi)
         if(gjlo.gt.gjhi) call swap(gjlo,gjhi)
         ielem = gihi - gilo +1
         jelem = gjhi - gjlo +1
c
         dilo = iran(m-ielem)+1
         djlo = iran(m-jelem)+1
         dihi = dilo+ielem-1
         djhi = djlo+jelem-1
c
c         if(me.eq.0) then
c            write(6,200) gilo,gihi,gjlo,gjhi,dilo,dihi,djlo,djhi
c200         format(1x,'writing  global[',2(i4,':',i4),
c     &                ']  to  disk[',2(i4,':',i4),']') 
c            call ffflush(6)
c         endif
c
c        call dra_set_mode(0)
         if(dra_write_section(.false.,  g_a, gilo, gihi, gjlo, gjhi,
     &                      d_a, dilo, dihi, djlo, djhi, req).ne.0)
     &      call ga_error('dra_write failed:',0)
         if(dra_wait(req).ne.0) call ga_error('dra_wait failed:',req)
c
c***     dra_read was tested already and we use it for testing dra_write_section
c
c        call dra_set_mode(1)
         if(dra_read_section(.false.,   g_b, gilo, gihi, gjlo, gjhi,
     &                      d_a, dilo, dihi, djlo, djhi, req).ne.0)
     &      call ga_error('dra_read failed:',0)
         if(dra_wait(req).ne.0) call ga_error('dra_wait failed:',req)
c
         call ga_add_patch(1d0, g_a, gilo, gihi, gjlo, gjhi,
     &                     -1d0, g_b, gilo, gihi, gjlo, gjhi,
     &                           g_b, gilo, gihi, gjlo, gjhi)
         err = ga_ddot_patch(g_b,'n', gilo, gihi, gjlo, gjhi,
     &                       g_b,'n', gilo, gihi, gjlo, gjhi)
         if(err.ne.0d0 )then
            call ga_print_patch(g_a, gilo, gihi,gjlo,gjhi,1)
            call ga_print_patch(g_b, gilo, gihi,gjlo,gjhi,1)
         endif
         if(err.ne.0d0 .and. me.eq.0)then
            print *,'error =', err
            call ga_error('error in dra_write_section',0)
         endif
      enddo
c     if (me.eq.0) print*,' OK'
      if (me.eq.0) then
        write(6,'(A)') ' dra_write_section (large) ........ OK'
        call ffflush(6)
      endif
c
      if(dra_delete(d_a).ne.0)
     &            call ga_error('dra_delete failed',0)
      if (me.eq.0) then
        write(6,'(A)') ' dra_delete (large) ............... OK'
        call ffflush(6)
      endif
      status = ga_destroy(g_a)
      status = ga_destroy(g_b)
      end



      subroutine swap(a,b)
      integer a, b, temp
         temp = a
         a = b
         b = temp
      end


      subroutine init_char(str, len, char)
      integer len, i
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      character*1 str(len)
#else
      character*(*) str
#endif
      character*1 char
      do i = 1, len -1 
         str(i:i+1) = char
      enddo
      end
          
      

c        1         2         3         4         5         6
C23456789012345678901234567890123456789012345678901234567890123456789
      SUBROUTINE dc_setgeom(rtdb)

      implicit none

#include "errquit.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "dc_common.fh"
#include "util.fh"

C     General variables

C      DOUBLE PRECISION R ![output] coodinates of atoms
      INTEGER rtdb  ![input] rtdb handle
C      INTEGER nmols  ![input] number of molecules
      INTEGER natom ![output] number of atoms
      INTEGER geom  !geometry handle
      DOUBLE PRECISION scale ![output] bohr->angstrom factor

      integer l_c, k_c, l_q, k_q, l_m, k_m, l_t, k_t

C     Variables specific to Mpoint calculation

      DOUBLE PRECISION directionM !vector from Oxygen to M
      DOUBLE PRECISION midptH !vector gets to the bisector
      DOUBLE PRECISION directionMMagnitude !magn of directionM

      INTEGER I    !indicates a particular water molecule
      INTEGER iii  !indicates component
C      INTEGER MXMOLS
C      INTEGER MXATOMS

C      DIMENSION R(MXMOLS,MXATOM,3)
      DIMENSION midptH(MXMOLS,3)
      DIMENSION directionM(MXMOLS,3)
      DIMENSION directionMMagnitude(MXMOLS)

C     MAKE THE GEOM. OBJECT

      if (.not. geom_create(geom, 'geometry'))
     & call errquit('dangchang_getgeom: failed creating geometry',
     & 0,GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, 'geometry'))
     & call errquit('dangchang_getgeom: no geometry',
     & 0,RTDB_ERR)
      if (.not. geom_ncent(geom,natom))
     & call errquit('dangchang_getgeom: ncent error',
     & 0,GEOM_ERR)

C     CHECKS THAT NATOM IS MULTIPLE OF 3

      if ( MOD (natom,3) .NE. 0 )
     & call errquit('dangchang_getgeom: natom not div by 3',
     & 0,GEOM_ERR)

C     DEFINES NMOLS

      NMOLS = natom / 3

C     ALLOCATE LOCAL MEMORY

      if (.not. ma_push_get(mt_dbl, 3*natom, 'coordinate' ,
     & l_c,k_c))
     & call errquit('dangchang_getgeom: coordinate not allocated',
     & 3*natom,MA_ERR)
      if (.not. ma_push_get(mt_dbl, natom, 'charge', l_q,k_q))
     & call errquit('dangchang_getgeom: charge not allocated',
     & natom,MA_ERR)
      if (.not.ma_push_get(mt_dbl, natom, 'mass', l_m,k_m))
     & call errquit('dangchang_getgeom: mass not allocated',
     & natom,MA_ERR)
      if (.not.ma_push_get(mt_byte, 16*natom, 'tags', l_t,k_t))
     & call errquit('dangchang_getgeom: tags not allocated',
     & natom,MA_ERR)

      if (.not. geom_cart_get(geom, natom, byte_mb(k_t),
     & dbl_mb(k_c), dbl_mb(k_q)))
     & call errquit('dangchang_getgeom: coord error',0,GEOM_ERR)
      if (.not. geom_masses_get(geom, natom, dbl_mb(k_m)))
     & call errquit('dangchang_getgeom:  mass error',0,GEOM_ERR)

 
C     CHECKS THAT ONLY ATOMS O and H PRESENT BY TAG
C     w/ THE PATTERN OHHOHHOHH.....
      if (util_print('geometry',print_medium)) then
      if (.not.geom_print(geom))
     & call errquit('dangcheng_getgeom: print error',0,GEOM_ERR)
      endif

      CALL DANGCHANG_TAGCHECK(natom, byte_mb(k_t))

C      WRITE(6,*)'geom after geom_print before geom_get', geom

      if (.not. geom_get_user_scale(geom,scale))
     & call errquit('dangchang_geom_get_user_scale:
     & scale factor unknown',0,GEOM_ERR)
 

C     PUT INFO INTO DANGCHANG VARIABLES

      CALL DANGCHANG_FILLCOORD(scale,natom,dbl_mb(k_c))

C     In DANGCHANG VARIABLES, Computes the Mpoints for the H2O's

      DO I = 1,NMOLS

        DO iii = 1,3
          midptH(I,iii) = R(I,2,iii) + .5D+00*
     $                  ( R(I,3,iii) - R(I,2,iii) )
          directionM(I,iii) =  midptH(I,iii) - R(I,1,iii)
        END DO

        directionMMagnitude(I) = DSQRT(
     $                           directionM(I,1)**2
     $                         + directionM(I,2)**2
     $                         + directionM(I,3)**2 )

        DO iii = 1,3
          R(I,4,iii) = R(I,1,iii) + 0.215D+00*
     $               directionM(I,iii)/directionMMagnitude(I)

C          WRITE(6,*) 'i,4,iii',i,iii,R(I,4,iii)

        END DO

      END DO ! 1st I loop


C     GET RID OF MEMORY WITH MA_CHOP
C     DEALLOCATE THE FIRST/LOWEST PART OF THE STACK
C     THIS ACTION DEALLOCATES ALL ADDITIONAL
C     MEMORY ADDED TO THE STACK AFTER LOWEST PART

      if (.not. ma_chop_stack(l_c))
     & call errquit('dangchang_getgeom: chop of l_c did not work',
     & 0,MA_ERR)

C     DESTROY GEOM. OBJECT

C      WRITE(6,*) 'GEOM before destory', geom

      if (.not. geom_destroy(geom))
     & call errquit('dangchang_getgeom:  geom_destroy failed',
     & 911,GEOM_ERR)

      END !SUBROUTINE DANGCHANG_SETGEOM

C********************************************************************
      SUBROUTINE DANGCHANG_FILLCOORD(scale,natom,Rinit)
C********************************************************************
      implicit none

#include "dc_common.fh"

      INTEGER i, j, k

      INTEGER natom
      DOUBLE PRECISION Rinit
      DOUBLE PRECISION scale

      DIMENSION Rinit(3,natom) 


      DO i = 1, natom, 3
        DO j = 1, 3
          R(INT((i-1)/3)+1,1,j) = Rinit(j,i)/scale
        END DO
      END DO


      DO i = 2, natom, 3
        DO j = 1, 3
          R(INT((i-1)/3)+1,2,j) = Rinit(j,i)/scale
        END DO
      END DO

      DO i = 3, natom, 3
        DO j = 1, 3
          R(i/3,3,j) = Rinit(j,i)/scale
        END DO
      END DO


c      DO i = 1, natom
c        DO j = 1, 3

c          WRITE(6,*) 'i,j=',i,j
c          WRITE(6,*) 'INT((i-1)/3)+1 =', INT((i-1)/3)+1

c          WRITE(6,*) 'Rinit=', Rinit(j,i)/scale

c        END DO
c      END DO

      END !SUBROUTINE FILLCOORD
C**********************************************************************
      SUBROUTINE DANGCHANG_TAGCHECK(natom, tag)
C**********************************************************************
      implicit none

#include "geom.fh"
#include "errquit.fh"

      INTEGER i
      INTEGER atn
      INTEGER natom
      CHARACTER*16 tag
      CHARACTER*16 element
      CHARACTER*2 symbol

      DIMENSION tag(natom) 

      DO i = 1, natom, 3
C        write(6,*) 'i in the first loop is ',i
        if (.not. geom_tag_to_element(tag(i), symbol, element, atn))
     &   call errquit('DANGCHANG_TAGCHECK:  failed to interpret tags',
     &   0,GEOM_ERR)

C        write(6,*) 'atn is ',atn
        if (atn .NE. 8)
     &  call errquit('DANGCHANG_TAGCHECK:  Os not correct',
     &  0,GEOM_ERR)
      END DO

      DO i = 2, natom, 3
C        write(6,*) 'i in the second loop is ',i
        if (.not. geom_tag_to_element(tag(i), symbol, element, atn))
     &   call errquit('DANGCHANG_TAGCHECK:  failed to interpret tags',
     &   0,GEOM_ERR)

C        write(6,*) 'atn is ',atn
        if (atn .NE. 1)
     &  call errquit('DANGCHANG_TAGCHECK:  Hs not correct',
     &  0,GEOM_ERR)
      END DO

      DO i = 3, natom, 3
C        write(6,*) 'i in the third loop is ',i
        if (.not. geom_tag_to_element(tag(i), symbol, element, atn))
     &   call errquit('DANGCHANG_TAGCHECK:  failed to interpret tags',
     &   0,GEOM_ERR)

C        write(6,*) 'atn is ',atn
        if (atn .NE. 1)
     &  call errquit('DANGCHANG_TAGCHECK:  Hs not correct',
     &  0,GEOM_ERR)
      END DO

      END !SUBROUTINE TAGCHECK
c $Id: dc_setgeom.F 21176 2011-10-10 06:35:49Z d3y133 $

C $Id: ecp_bessel.f 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_bessel (n,m,x,bessel,temp,ind,tol)
*                                                                      *
*   Calculate modified spherical bessel function exp(-x) i_m(x)        *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   n (inp) - number of bessel functions to be evaluated for given     *
*             order                                                    *
*   m (inp) - order of bessel function                                 *
*   x (inp) - array of arguments for bessel function                   *
*   bessel (out) - bessel functions                                    *
*   temp (scr) - scratch array                                         *
*   ind (scr) - index array                                            *
*   tol (inp) - maximum relative error in bessel functions             *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
      integer n,m,i,na,np,ind(n)
      double precision x(n),bessel(n),temp(n,5),tol,two,cut0,cutoff
      parameter (two = 2.0d00, cut0 = 0.106d0)
*
*   Determine cutoff for division between power and asymptotic series
*
      if (m .eq. 0) then
        cutoff = cut0
      else
        cutoff = m*(m+1)/2
      end if
      cutoff = cutoff/two
*
*   Gather arguments for power and asymptotic series
*
      na = 0
      np = n+1
      do i = 1,n
        if (x(i) .gt. cutoff) then
          na = na+1
          temp(na,1) = x(i)
          ind(na) = i
        else
          np = np-1
          temp(np,1) = x(i)
          ind(np) = i
        end if
      end do
      i = np
      np = n-na
*
*   Evaluate functions and scatter into output array
*
      if (np .gt. 0) call ecp_bess_pow (np,m,temp(i,1),temp(i,2),
     &    temp(i,3),temp(i,4),temp(i,5),tol)
      if (na .gt. 0) call ecp_bess_asy (na,m,temp(1,1),temp(1,2),
     &    temp(1,3),temp(1,4))
      do i = 1,n
        bessel(ind(i)) = temp(i,2)
      end do
*
      return
      end

*
* $Id: lcao_generate_vhxcmatrix.F 23737 2013-03-12 01:30:42Z d3y133 $
*
      subroutine lcao_generate_vhxcmatrix(ispin,n2ft3d,dn,
     >                                    vhxcmatrix,phi1,phi2,
     >                                    ehartr,exc,pxc)
      implicit none
#include "errquit.fh"
      integer ispin,n2ft3d
      real*8  dn(n2ft3d,2)
      integer vhxcmatrix(2)
      complex*16 phi1(*)
      complex*16 phi2(*)
      real*8     ehartr,exc,pxc

#include "mafdecls.fh"
#include "global.fh"
#include "nwxc.fh"

*     **** local variables ****
      logical value
      integer ms,i,j,nbasis,npack1,nfft3d,gga
      integer nx,ny,nz
      real*8  sum,scal1,scal2,dv,exc2,pxc2
      integer xcp(2),tmp1(2),tmp2(2),dnall(2),vpsi,vall,xvc,rho

*     ***** external functions ****
      logical  psp_semicore
      integer  aorbs_nbasis,control_version,control_gga
      real*8   lattice_omega,coulomb_e
      external psp_semicore
      external aorbs_nbasis,control_version,control_gga
      external lattice_omega,coulomb_e

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()
      dv    = lattice_omega()*scal1

      call Pack_npack(1,npack1)
      call D3dB_nfft3d(1,nfft3d)
      value = MA_push_get(mt_dbl,(2*n2ft3d),'xcp',xcp(2),xcp(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(2*n2ft3d),'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(2*n2ft3d),'tmp2',tmp2(2),tmp2(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(2*n2ft3d),'dnall',dnall(2),dnall(1))
      call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(xcp(1)),1)
      call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(tmp1(1)),1)
      call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(tmp2(1)),1)
      call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(dnall(1)),1)
      xvc  = tmp1(1)
      rho  = tmp1(1)+n2ft3d
      vpsi = tmp2(1)
      vall = tmp2(1)+n2ft3d
      if (.not. value) 
     > call errquit('lcao_geneate_vhxcmatrix: out of stack memory',0,
     &       MA_ERR)


*     *************************************************
*     **** generate exchange-correlation potential ****
*     *************************************************
      if (psp_semicore(0)) then
           call semicore_density(dbl_mb(tmp1(1)))
c           call D3dB_r_SMul(1,0.5d0,dbl_mb(tmp1(1)),dbl_mb(tmp1(1)))
           call D3dB_r_SMul1(1,0.5d0,dbl_mb(tmp1(1)))
      else
           call dcopy(n2ft3d,0.0d0,0,dbl_mb(tmp1(1)),1)
      end if
      do ms=1,ispin
          call D3dB_rr_Sum(1,dn(1,ms),
     >                     dbl_mb(tmp1(1)),
     >                     dbl_mb(dnall(1) +(ms-1)*n2ft3d))
      end do


      gga = control_gga()
      if ((.not.nwxc_is_on().and.gga.eq.0).or.
     &    (nwxc_is_on().and.nwxc_is_lda())) then
        call vxc(n2ft3d,ispin,dbl_mb(dnall(1)),
     >                    dbl_mb(xcp(1)),
     >                    dbl_mb(tmp1(1)),
     >                    dbl_mb(tmp2(1)))
      else 
        call v_bwexc(gga,n2ft3d,ispin,dbl_mb(dnall(1)),
     >                    1.0d0,1.0d0,
     >                    dbl_mb(xcp(1)),
     >                    dbl_mb(tmp1(1)))
      end if

*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,dbl_mb(dnall(1)),dbl_mb(tmp1(1)),exc)
      call D3dB_rr_dot(1,dn(1,1),dbl_mb(xcp(1)),pxc)

      if (ispin.eq.1) then
         exc= exc + exc
         pxc= pxc + pxc
      else
         call D3dB_rr_dot(1,dbl_mb(dnall(1)+n2ft3d),
     >                      dbl_mb(tmp1(1)),exc2)
         call D3dB_rr_dot(1,dn(1,2),dbl_mb(xcp(1)+n2ft3d),pxc2)
         exc= exc + exc2
         pxc= pxc + pxc2
      end if
      exc = exc*dv
      pxc = pxc*dv

      value = MA_pop_stack(dnall(2))
      if (.not. value) 
     > call errquit('lcao_geneate_vhxcmatrix: popping stack memory',1,
     &       MA_ERR)

*     ************************************
*     **** generate coulomb potential ****
*     ************************************
      call D3dB_rr_Sum(1,dn(1,1),dn(1,ispin),dbl_mb(rho))

      if (control_version().eq.3) then
c         call D3dB_r_SMul(1,scal1,dbl_mb(rho),dbl_mb(rho))
         call D3dB_r_SMul1(1,scal1,dbl_mb(rho))
         call D3dB_rc_pfft3f(1,0,dbl_mb(rho))
         call Pack_c_pack(0,dbl_mb(rho))
         ehartr = coulomb_e(dbl_mb(rho))
         call coulomb_v(dbl_mb(rho),dbl_mb(xvc))
         call Pack_c_unpack(0,dbl_mb(xvc))
         call D3dB_cr_pfft3b(1,0,dbl_mb(xvc))
      else
         call coulomb2_v(dbl_mb(rho),dbl_mb(xvc))
         call D3dB_rr_dot(1,dbl_mb(rho),dbl_mb(xvc),ehartr)
         ehartr = 0.5d0*ehartr*dv
      end if


*     **********************************************
*     **** fourier transform k-space potentials ****
*     **********************************************

      nbasis = aorbs_nbasis()
      do j=1,nbasis

*        **** get phi2 ****
         call aorbs_aorb(j,phi2)
   
*       **** get psi_r ****
         call Pack_c_Copy(1,phi2,dbl_mb(vpsi))
         call Pack_c_unpack(1,dbl_mb(vpsi))
         call D3dB_cr_pfft3b(1,1,dbl_mb(vpsi))
         call D3dB_r_Zero_Ends(1,dbl_mb(vpsi))

         do ms=1,ispin
            call D3dB_rr_Sum(1,dbl_mb(xvc),
     >                         dbl_mb(xcp(1)+(ms-1)*n2ft3d),
     >                         dbl_mb(vall))

c            call D3dB_rr_Mul(1,dbl_mb(vall),
c     >                         dbl_mb(vpsi),
c     >                         dbl_mb(vall))
            call D3dB_rr_Mul2(1,dbl_mb(vpsi),dbl_mb(vall))

*           *******************************
*           **** get vpsi_r in k-space ****
*           *******************************
            call D3dB_rc_pfft3f(1,1,dbl_mb(vall))
            call Pack_c_pack(1,dbl_mb(vall))
            call Pack_c_Copy(1,dbl_mb(vall),phi2)

            do i=1,j

*             **** get phi1 ****
              call aorbs_aorb(i,phi1)
              call Pack_cc_dot(1,phi1,phi2,sum)
              sum = sum*scal1
c              write(*,*) "vhxc:",i,j,sum

              call ga_fill_patch(vhxcmatrix(ms),i,i,j,j,sum)
              call ga_fill_patch(vhxcmatrix(ms),j,j,i,i,sum)
            end do
         end do
      end do

      value =           MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2))
      value = value.and.MA_pop_stack(xcp(2))
      if (.not. value) 
     > call errquit('lcao_geneate_vhxcmatrix: popping stack memory',2,
     &       MA_ERR)
     
      return
      end

      SUBROUTINE ccsdt_lr_alpha_offdiag_1_6(d_a,k_a_offset,d_b,k_b_offse
     &t,d_c,k_c_offset)
C     $Id: ccsdt_lr_alpha_offdiag_1_6.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p10 h11 )_ytb + = 1/2 * Sum ( h1 h3 p2 ) * b ( p2 p10 h1 h3 )_b * i2 ( h1 h3 h11 p2 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p10b
      INTEGER h11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p2b
      INTEGER h1b
      INTEGER h3b
      INTEGER p10b_1
      INTEGER p2b_1
      INTEGER h1b_1
      INTEGER h3b_1
      INTEGER h1b_2
      INTEGER h3b_2
      INTEGER h11b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p10b = noab+1,noab+nvab
      DO h11b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p10b-1)+int_mb(k_spin+h11b
     &-1).ne.4)) THEN
      IF (int_mb(k_spin+p10b-1) .eq. int_mb(k_spin+h11b-1)) THEN
      IF (ieor(int_mb(k_sym+p10b-1),int_mb(k_sym+h11b-1)) .eq. ieor(irre
     &p_y,ieor(irrep_t,irrep_b))) THEN
      dimc = int_mb(k_range+p10b-1) * int_mb(k_range+h11b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_1_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h3b = h1b,noab
      IF (int_mb(k_spin+p10b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p10b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_b) THEN
      CALL TCE_RESTRICTED_4(p10b,p2b,h1b,h3b,p10b_1,p2b_1,h1b_1,h3b_1)
      CALL TCE_RESTRICTED_4(h1b,h3b,h11b,p2b,h1b_2,h3b_2,h11b_2,p2b_2)
      dim_common = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h3b-1)
      dima_sort = int_mb(k_range+p10b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_1_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_1_6',2,MA_ERR)
      IF ((p2b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p2b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+h1b-1),int_mb(k_range+h3b-1
     &),2,4,3,1,1.0d0)
      END IF
      IF ((p10b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p10b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p2b-1),int_mb(k_range+h1b-1),int_mb(k_range+h3b-1
     &),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &_6',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_1_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_1_6',5,MA_ERR)
      IF ((h11b .le. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (h11b_2 - 1 + noab * (h3b_2 - 1 + noab * (h1b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h11b-1),int_mb(k_range+p2b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &_6',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h1b .eq. h3b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_1_6',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_1_6',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_1_6',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h11b-1
     &),int_mb(k_range+p10b-1),2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h11b 
     &- 1 + noab * (p10b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &_6',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_1_6',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

c
c $Id: tool_rebox.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE tool_rebox(n,mxarray,latt,rlatt,aaa)

      implicit none

      include 'p_array.inc'

      integer i,n,mxarray

      real*8 rlatt(3,3),latt(3,3)
      real*8 aaa(mxarray,3)
      real*8 ssx,ssy,ssz,xss,yss,zss

      do i=1,n

       ssx=(rlatt(1,1)*aaa(i,1)+rlatt(1,2)*aaa(i,2)+rlatt(1,3)*aaa(i,3))
       ssy=(rlatt(2,1)*aaa(i,1)+rlatt(2,2)*aaa(i,2)+rlatt(2,3)*aaa(i,3))
       ssz=(rlatt(3,1)*aaa(i,1)+rlatt(3,2)*aaa(i,2)+rlatt(3,3)*aaa(i,3))

       xss=ssx-nint(ssx)
       yss=ssy-nint(ssy)
       zss=ssz-nint(ssz)

       aaa(i,1)=(latt(1,1)*xss+latt(1,2)*yss+latt(1,3)*zss)
       aaa(i,2)=(latt(2,1)*xss+latt(2,2)*yss+latt(2,3)*zss)
       aaa(i,3)=(latt(3,1)*xss+latt(3,2)*yss+latt(3,3)*zss)

      enddo

      return

      END

      subroutine hnd_giaoh01(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     & expj,coefj,j_nprim,j_ngen,Lj,nint,h01,xyzpt,nat,scr,lscr)
c
c $Id: hnd_giaoh01.F 21348 2011-10-31 22:51:25Z d3p852 $
c
c     ----- Wrapper routine that sets the sizes of scratch blocks -----
c
      implicit double precision (a-h,o-z)
#include "hnd_pointers.fh"
      dimension scr(lscr)
      dimension xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension h01(nint,3,nat), xyzpt(3,nat)
c
c Use scratch for temps in integral calculation
c Scratch needs are
c 9*(Li+1)*(Lj+2)*((Li+Lj+2)/2+1)
c
c The pointers are defined in hdn_pointers.fh
c
      call hnd_giaoh011(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,expj,
     1 coefj,j_nprim,j_ngen,Lj,nint,h01,xyzpt,nat,
     2 scr(gh01(1)),scr(gh01(2)),scr(gh01(3)),scr(gh01(4)),scr(gh01(5)),
     3 scr(gh01(6)),scr(gh01(7)),scr(gh01(8)),scr(gh01(9)))
c
      return
      end
c
      subroutine hnd_giaoh011(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     1 expj,coefj,j_nprim,j_ngen,Lj,nint,h01,xyzpt,nat,
     2 xv,yv,zv,dxv,dyv,dzv,xvx,yvy,zvz)
c
      implicit double precision (a-h,o-z)
#include "nwc_const.fh"
#include "hnd_rys.fh"
#include "hnd_tol.fh"
#include "stdio.fh"
      common/hnd_xyzder/xint,yint,zint,t,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     1                  ni,nj,cx,cy,cz
      dimension Nxyz(3),xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension h01(nint,3,nat), xyzpt(3,nat)
      dimension   xv(Li+1,Lj+2,*),  yv(Li+1,Lj+2,*),  zv(Li+1,Lj+2,*)
      dimension  dxv(Li+1,Lj+2,*), dyv(Li+1,Lj+2,*), dzv(Li+1,Lj+2,*)
      dimension  xvx(Li+1,Lj+2,*), yvy(Li+1,Lj+2,*), zvz(Li+1,Lj+2,*)
      data rln10  /2.30258d+00/
      data pi212  /1.1283791670955d+00/
c
      tol=rln10*itol
c
c     Zero integral array
c
      call dcopy(nint*3*nat,0.0d0,0,h01,1)
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi = lit*(lit+1)/2
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj = ljt*(ljt+1)/2
      ljtmod=ljt+1
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
      nroots=(lit+ljt)/2+1
      if(nroots.gt.maxrys) then
         write(luout,9999) maxrys,lit,ljt,nroots
         call errquit('hnd_giah01: need higher Rys root',nroots,INT_ERR)
      endif
c
c     ----- i primitive -----
c
      do ig=1, i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=1.0d0/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) goto 1000  
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      cij=csi*csj*fac*aa1*pi212
c
c     ----- -h01- term -----
c
      aax=aa*ax
      aay=aa*ay
      aaz=aa*az
c
      do ipt=1,nat
         znuc=1.0d0
         cx=xyzpt(1,ipt)
         cy=xyzpt(2,ipt)
         cz=xyzpt(3,ipt)
         yy=aa*((ax-cx)**2+(ay-cy)**2+(az-cz)**2)
         call hnd_droot
         do iroot=1,nroots
            uu=u9(iroot)*aa
            ww=w9(iroot)*znuc
            ww=ww*(uu+uu)
            tt=1.0d0/(aa+uu)
            t = sqrt(tt)
            x0=(aax+uu*cx)*tt
            y0=(aay+uu*cy)*tt
            z0=(aaz+uu*cz)*tt
            do j=1,ljtmod
               nj=j
               do i=1,lit
                  ni=i
                  call hnd_sxyz
                  xv(i,j,iroot)=xint
                  yv(i,j,iroot)=yint
                  zv(i,j,iroot)=zint*ww
                  call hnd_dervxyz(1)
                  dxv(i,j,iroot)=xint
                  dyv(i,j,iroot)=yint
                  dzv(i,j,iroot)=zint*ww
               enddo
            enddo
            do i=1,lit
               xvx(i,1,iroot)=(-(aj+aj)*xv(i,2,iroot))
               yvy(i,1,iroot)=(-(aj+aj)*yv(i,2,iroot))
               zvz(i,1,iroot)=(-(aj+aj)*zv(i,2,iroot))
               do j=2,ljt
                  xvx(i,j,iroot)= (dble(j-1)*xv(i,j-1,iroot)-
     &                             (aj+aj)*xv(i,j+1,iroot))
                  yvy(i,j,iroot)= (dble(j-1)*yv(i,j-1,iroot)-
     &                             (aj+aj)*yv(i,j+1,iroot))
                  zvz(i,j,iroot)= (dble(j-1)*zv(i,j-1,iroot)-
     &                             (aj+aj)*zv(i,j+1,iroot))
               enddo
            enddo
         enddo
c
         ij=0
         do j=1,maxj
            call getNxyz(Lj,j,Nxyz)
            jx = Nxyz(1) + 1
            jy = Nxyz(2) + 1
            jz = Nxyz(3) + 1
            do i=1,maxi
               call getNxyz(Li,i,Nxyz)
               ix = Nxyz(1) + 1
               iy = Nxyz(2) + 1
               iz = Nxyz(3) + 1
               dumx=0.0d0
               dumy=0.0d0
               dumz=0.0d0
               do ir=1,nroots
                  dumx=dumx+xv(ix,jx,ir)*dyv(iy,jy,ir)*zvz(iz,jz,ir)
     1                     -xv(ix,jx,ir)*yvy(iy,jy,ir)*dzv(iz,jz,ir)
                  dumy=dumy+xvx(ix,jx,ir)* yv(iy,jy,ir)*dzv(iz,jz,ir)
     1                     -dxv(ix,jx,ir)* yv(iy,jy,ir)*zvz(iz,jz,ir)
                  dumz=dumz+dxv(ix,jx,ir)*yvy(iy,jy,ir)* zv(iz,jz,ir)
     1                     -xvx(ix,jx,ir)*dyv(iy,jy,ir)* zv(iz,jz,ir)
               enddo     
               ij=ij+1
               h01(ij,1,ipt)=h01(ij,1,ipt)+dumx*cij
               h01(ij,2,ipt)=h01(ij,2,ipt)+dumy*cij
               h01(ij,3,ipt)=h01(ij,3,ipt)+dumz*cij
            enddo     
         enddo     
      enddo      
c
 1000 continue
c
      enddo
      enddo
c
      return
 9999 format(' in -giah01- , the rys quadrature is not implemented',
     1       ' beyond -nroots- = ',i3,/,' lit,ljt,nroots= ',3i3)
      end

      subroutine tce_mrcc_mul_1(alpha,d_a,beta,d_b,k_c_offset,d_c,iref)
        implicit none
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_mrcc.fh"
#include "tce_main.fh"

      double precision alpha,beta
      integer d_a,d_b,d_c
      integer k_c_offset
      integer nprocs
      integer count
      integer next
      INTEGER NXTASK
      EXTERNAL NXTASK
      INTEGER NXTASKsub
      EXTERNAL NXTASKsub
      logical nodezero
      integer iref
      integer p1b,h2b,p1,h2
      integer inoab,invab
      integer size
      integer k_a,k_b,k_c
      integer l_a,l_b,l_c
      integer i
      logical noloadbalance

      nodezero = (ga_nodeid().eq.0)
      count = 0
      if(lusesub) then
      nprocs = ga_pgroup_nnodes(mypgid)
      call ga_pgroup_sync(mypgid)
      next = NXTASKsub(nprocs, 1,mypgid)
      else
      nprocs = ga_nnodes()
      call ga_sync()
      next = NXTASK(nprocs, 1)
      endif
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_c))))

      inoab = nblcks(1,iref)+nblcks(2,iref)
      invab = nblcks(3,iref)+nblcks(4,iref)

      do p1b = inoab+1,inoab+invab
        do h2b = 1,inoab

          if (noloadbalance.or.(next.eq.count)) then

            if (int_mb(k_spinm(iref)+p1b-1) .eq.
     1  int_mb(k_spinm(iref)+h2b-1)) then
            if ((.not.restricted).or.(int_mb(k_spinm(iref)+p1b-1)
     1        +int_mb(k_spinm(iref)+h2b-1).ne.4)) then
            if (ieor(int_mb(k_symm(iref)+p1b-1),
     1 int_mb(k_symm(iref)+h2b-1)).eq.0) then

              size = int_mb(k_rangem(iref)+p1b-1) *
     1  int_mb(k_rangem(iref)+h2b-1)

              if (.not.ma_push_get(mt_dbl,size,'a',l_a,k_a))
     1          call errquit('tce_jacobi_t1: MA problem',0,MA_ERR)
              if (.not.ma_push_get(mt_dbl,size,'b',l_b,k_b))
     1          call errquit('tce_jacobi_t1: MA problem',0,MA_ERR)
              if (.not.ma_push_get(mt_dbl,size,'c',l_c,k_c))
     1          call errquit('tce_jacobi_t1: MA problem',0,MA_ERR)

              call get_hash_block(d_a,dbl_mb(k_a),size,
     1          int_mb(k_c_offset),((p1b-inoab-1)*inoab+h2b-1))

              call get_hash_block(d_b,dbl_mb(k_b),size,
     1          int_mb(k_c_offset),((p1b-inoab-1)*inoab+h2b-1))

              i = 0

              do p1 = 1,int_mb(k_rangem(iref)+p1b-1)
                do h2 = 1,int_mb(k_rangem(iref)+h2b-1)
                  i = i + 1
                  dbl_mb(k_c+i-1) = alpha*dbl_mb(k_a+i-1)+
     1                               beta*dbl_mb(k_b+i-1)
c        write(6,"('alpha/beta',2F16.12,2F16.12)")alpha,beta
c        write(6,"(I2,':',I4,I4,I4,I4,2F16.12,2F16.12,2F16.12)")
c     1ga_nodeid(),p1b,h2b,i,iref,
c     1 dbl_mb(k_a+i-1),dbl_mb(k_b+i-1),dbl_mb(k_c+i-1)
                enddo
              enddo

              call put_hash_block(d_c,dbl_mb(k_c),size,
     1          int_mb(k_c_offset),((p1b-inoab-1)*inoab+h2b-1))

              if (.not.ma_pop_stack(l_c))
     1          call errquit('tce_mrcc_mul: MA problem',1,MA_ERR)
              if (.not.ma_pop_stack(l_b))
     1          call errquit('tce_mrcc_mul: MA problem',1,MA_ERR)
              if (.not.ma_pop_stack(l_a))
     1          call errquit('tce_mrcc_mul: MA problem',1,MA_ERR)
            endif
            endif
            endif
cc            next = nxtval(nprocs)
      if(lusesub) then
       next = NXTASKsub(nprocs,1,mypgid)
      else
       next = NXTASK(nprocs, 1)
      endif
          endif
          count = count + 1
        enddo
      enddo
cc    next = nxtval(-nprocs)
      if(lusesub) then
       next = NXTASKsub(-nprocs,1,mypgid)
       call ga_pgroup_sync(mypgid)
      else
       next = NXTASK(-nprocs, 1)
       call ga_sync()
      endif

      return
      end

c $Id: tce_mrcc_mul_1.F 24345 2013-06-22 06:19:30Z d3y133 $

      subroutine put_block(d_file,array,size,offset)
c
c $Id: put_block.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sf.fh"
#include "eaf.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_file
      integer d_f
      integer size
      integer offset
      double precision array(size)
      integer request
      integer i,j
      logical used
      character*255 filename
      logical parallel
c
      cpusecs(3) = cpusecs(3) - util_cpusec()
      cpusecs(53) = cpusecs(53) - util_wallsec()
      parallel = (ga_nnodes().gt.1)
      if (util_print('put_block',print_debug)) then
         write(LuOut,9000) ga_nodeid(),d_file,size,offset
      endif
      if (offset .eq. -1)
     1  call errquit('put_block: illegal offset',0,UNKNOWN_ERR)
      if (ioalg.eq.0) then
        used = .false.
        do i = 1,nfiles
          if (filehandles(i) .eq. d_file) then
            j = i
            used = .true.
          endif
        enddo
        if (.not.used) call errquit('put_block: invalid handle',d_file,
     1  UNKNOWN_ERR)
        if (parallel) then
          call ga_lock(0)
          open(d_file,file=filenames(j),access='direct',recl=bytes)
        endif
        do i = 1,size
          write(d_file,rec=offset+i) array(i)
        enddo
        if (parallel) then
          close(d_file)
          call ga_unlock(0)
        endif
      else if (ioalg.eq.1) then
        if (parallel) then
          used = .false.
          do i = 1,nfiles
            if (filehandles(i) .eq. d_file) then
              j = i
              used = .true.
            endif
          enddo
          filename = filenames(j)
          if (.not.used)
     1      call errquit('put_block: invalid handle',d_file,UNKNOWN_ERR)
          call ga_lock(0)
          if (eaf_open(filename, EAF_RW, d_f).ne.0)
     1      call errquit('put_block: eaf problem',1,DISK_ERR)
          if (eaf_write(d_f,dfloat(bytes)*dfloat(offset),
     1      array,bytes*size).ne.0)
     2      call errquit('put_block: eaf problem',2,DISK_ERR)
          if (eaf_close(d_f).ne.0)
     1      call errquit('put_block: eaf problem',4,DISK_ERR)
          call ga_unlock(0)
        else
          if (eaf_write(d_file,dfloat(bytes)*dfloat(offset),
     1      array,bytes*size).ne.0)
     2      call errquit('put_block: eaf problem',5,DISK_ERR)
        endif
      else if (ioalg.eq.2) then
        call ga_put(d_file,offset+1,offset+size,1,1,
     1    array,1)
      else if (ioalg.eq.3) then
        if (parallel) then
          call ga_lock(0)
          if (sf_open(d_file).ne.0)
     1      call errquit('put_block: sf problem',0,DISK_ERR)
        endif
        if (sf_write(d_file,dfloat(bytes)*dfloat(offset),
     1    dfloat(bytes)*dfloat(size),array,request).ne.0)
     2    call errquit('put_block: sf problem',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('put_block: sf problem',2,DISK_ERR)
        if (parallel) then
          if (sf_close(d_file).ne.0)
     1      call errquit('put_block: sf problem',3,DISK_ERR)
          call ga_unlock(0)
        endif
      else if (ioalg.eq.4) then
        if (eaf_write(d_file,dfloat(bytes)*dfloat(offset),
     1    array,bytes*size).ne.0)
     2    call errquit('put_block: eaf problem',2,DISK_ERR)
      else if (ioalg.eq.5) then
        if (fileisga(d_file)) then
          call ga_put(filehandles(d_file),offset+1,offset+size,1,1,
     1      array,1)
        else
          call errquit('put_block: a write request to DRA',1,
     1      UNKNOWN_ERR)
        endif
      else if (ioalg.eq.6) then
        if (fileisga(d_file)) then
          call ga_put(filehandles(d_file),offset+1,offset+size,1,1,
     1      array,1)
        else
          if (eaf_write(filehandles(d_file),
     1      dfloat(bytes)*dfloat(offset),array,bytes*size).ne.0)
     2      call errquit('put_block: eaf problem',2,DISK_ERR)
        endif
      endif
 9000 format(1x,'node',i3,' put_block request to file:',i10,
     1  ' size:',i10,' offset:',i10)
      cpusecs(3) = cpusecs(3) + util_cpusec()
      cpusecs(53) = cpusecs(53) + util_wallsec()
      return
      end




















      subroutine put_block_sf(d_file,array,size,offset)
c
c $Id: put_block.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sf.fh"
#include "eaf.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_file
      integer d_f
      integer size
      integer offset
      double precision array(size)
      integer request
      integer i,j
      logical used
      character*255 filename
      logical parallel
c
      cpusecs(3) = cpusecs(3) - util_cpusec()
      cpusecs(53) = cpusecs(53) - util_wallsec()
      parallel = (ga_nnodes().gt.1)
      if (util_print('put_block',print_debug)) then
         write(LuOut,9000) ga_nodeid(),d_file,size,offset
      endif
      if (offset .eq. -1)
     1  call errquit('put_block: illegal offset',0,UNKNOWN_ERR)
c
c      else if (ioalg.eq.3) then
c
        if (parallel) then
          call ga_lock(0)
          if (sf_open(d_file).ne.0)
     1      call errquit('put_block: sf problem',0,DISK_ERR)
        endif
        if (sf_write(d_file,dfloat(bytes)*dfloat(offset),
     1    dfloat(bytes)*dfloat(size),array,request).ne.0)
     2    call errquit('put_block: sf problem',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('put_block: sf problem',2,DISK_ERR)
        if (parallel) then
          if (sf_close(d_file).ne.0)
     1      call errquit('put_block: sf problem',3,DISK_ERR)
          call ga_unlock(0)
        endif
c
c      endif
c
 9000 format(1x,'node',i3,' put_block request to file:',i10,
     1  ' size:',i10,' offset:',i10)
      cpusecs(3) = cpusecs(3) + util_cpusec()
      cpusecs(53) = cpusecs(53) + util_wallsec()
      return
      end

      subroutine rel_input(rtdb)
*
* $Id: rel_input.F 21948 2012-02-03 19:27:57Z niri $
*
      implicit none
#include "rtdb.fh"
#include "context.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
#include "rel_consts.fh"
#include "errquit.fh"
#include "zora.fh"
c     
c     Read input for the relativistic block
c     
      integer rtdb ! [input] handle to database
      integer slc_spinpolAO ! for selecting spin-density matrix contrib
c     
      character*255 test
      double precision clight
      logical dk_run             ! Douglas-Kroll
      logical dmd_run            ! Dyall modified Dirac
      logical zora_run           ! ZORA

      logical status
      integer irelKey            ! Relativistic method keys
      logical do_prntNMRCS
      logical skip_csAOev,skip_gshiftAOev,
     &        skip_hypAOev,skip_efgz4AOev,
     &        Knucl
      logical skip_cphf_ev_shield,
     &        skip_cphf_ev_gshift,
     &        skip_cphf_ev_hyp

      irelKey = 0
c
c     Set the available relativistic approaches to .false.
c
c     Douglas-Kroll 
      dk_run = .false.
      if (.not. rtdb_put(rtdb, 'doug_kroll', mt_log, 1, dk_run))
     $   call errquit('rel_input: rtdb_put failed', 0, RTDB_ERR)
c
c     Dyall Modified Dirac
      dmd_run = .false.
      if (.not. rtdb_put(rtdb, 'dyall_mod_dir', mt_log, 1, dmd_run))
     $   call errquit('rel_input: rtdb_put failed', 0, RTDB_ERR)
c
c     ZORA
      zora_run = .false.
      if (.not. rtdb_put(rtdb, 'zora', mt_log, 1, zora_run))
     &  call errquit('rel_input: rtdb_put failed', 0, RTDB_ERR)
c
c     Set some relativistic variables we could need later on
c
   1  if (.not. inp_read()) call errquit('rel_input: inp_read failed',0,
     &       INPUT_ERR)
      if (.not. inp_a(test))
     $     call errquit('rel_input: failed to read keyword', 0,
     &       INPUT_ERR)
c
      if (inp_compare(.false.,'clight', test)) then
c
         if (.not. inp_f(clight)) then
            call errquit('rel_input: failed reading clight', 0,
     &       UNKNOWN_ERR)
         else 
           if(.not.rtdb_put(rtdb,'relativistic:clight',mt_dbl,1,clight))
     $        call errquit('rel_input: rtdb_put failed', 0, RTDB_ERR)
         endif
         write(luout,10) clight
  10        format(/,'The speed of light used in the relativistic ',
     $               'calculations is ',F16.10, 'au.'/)
c
      elseif (inp_compare(.false.,'douglas-kroll', test)) then
         dk_run = .true.
         if (.not. rtdb_put(rtdb, 'doug_kroll', mt_log, 1, dk_run))
     $     call errquit('rel_input: rtdb_put failed', 0, RTDB_ERR)
         call dk_input(rtdb)
c
      elseif (inp_compare(.false.,'dyall-mod-dirac', test)) then
         dmd_run = .true.
         if (.not. rtdb_put(rtdb, 'dyall_mod_dir', mt_log, 1, dmd_run))
     $     call errquit('rel_input: rtdb_put failed', 0, RTDB_ERR)
         call dmd_input(rtdb)
c
      elseif (inp_compare(.false.,'zora', test)) then
        zora_run = .true.
        if (.not. rtdb_put(rtdb, 'zora', mt_log, 1, zora_run))
     &     call errquit('rel_input: rtdb_put failed', 0, RTDB_ERR)
         call zora_input(rtdb)
c
      elseif(inp_compare(.false.,'zora:cutoff',test)) then
         if(.not. inp_f(zoracutoff)) zoracutoff = 1.0d-15  ! set a default cutoff
         if (.not. rtdb_put(rtdb,'zora:cutoff',mt_dbl,1,zoracutoff))
     &    call errquit('rel_input: rtdb put failed',0, RTDB_ERR)
c
c     zoracutoff_EFG, used in get_rhoS() from dft_zora_utils.F
      elseif(inp_compare(.false.,'zora:cutoff_EFG',test)) then
         if(.not. inp_f(zoracutoff_EFG)) zoracutoff_EFG = 1.0d-04 ! set dflt cutoff
         if (.not. rtdb_put(rtdb,'zora:cutoff_EFG', 
     &                      mt_dbl,1,zoracutoff_EFG))
     &    call errquit('rel_input: rtdb put failed',0, RTDB_ERR)
c
c     zoracutoff_NMR, used in get_NMR() from dft_zora_utils.F
      elseif(inp_compare(.false.,'zora:cutoff_NMR',test)) then
         if(.not. inp_f(zoracutoff_NMR)) zoracutoff_NMR = 1.0d-08 ! set dflt cutoff
         if (.not. rtdb_put(rtdb,'zora:cutoff_NMR',
     &                      mt_dbl,1,zoracutoff_NMR))
     &    call errquit('rel_input: rtdb put failed',0, RTDB_ERR)
c
      elseif(inp_compare(.false.,'zora:do_NonRel',test)) then
         do_NonRel = .true.                                  ! set do_NonRel
         if (.not. rtdb_put(rtdb,'zora:do_NonRel', mt_log,1,do_NonRel))
     &    call errquit('rel_input: rtdb put failed',0, RTDB_ERR)
c
      elseif(inp_compare(.false.,'zora:do_prntNMRCS',test)) then
         do_prntNMRCS = .true.                            ! set do_prntNMRCS
         if (.not. rtdb_put(rtdb,'zora:do_prntNMRCS',
     &                      mt_log,1,do_prntNMRCS))
     &    call errquit('rel_input: rtdb put failed',0, RTDB_ERR)
c
      elseif(inp_compare(.false.,'zora:not_zora_scale',test)) then 
         not_zora_scale = .true.                               ! set not_zora_scale
         if (.not. rtdb_put(rtdb,'zora:not_zora_scale',
     &                     mt_log,1,not_zora_scale))
     &    call errquit('rel_input: rtdb put failed',0, RTDB_ERR)
c
c ------- SKIP ev. AO matrices for NMRCS or gshifts or hyperfine
c Note.- It will read instead data from a file, if the file does not
c        exist it will stop calc. with a warning message.
      elseif(inp_compare(.false.,'zora:skip_csAOev',test)) then 
         skip_csAOev = .true.      
         if (.not. rtdb_put(rtdb,'zora:skip_csAOev',           
     &                     mt_log,1,skip_csAOev))             
     &    call errquit('rel_input: rtdb put failed skip csAOev',
     &                  0, RTDB_ERR) 
      elseif(inp_compare(.false.,'zora:skip_gshiftAOev',test)) then
         skip_gshiftAOev = .true.                               
         if (.not. rtdb_put(rtdb,'zora:skip_gshiftAOev',
     &                     mt_log,1,skip_gshiftAOev))
     &    call errquit('rel_input: rtdb put failed skip gshiftAOev',
     &                  0, RTDB_ERR)
      elseif(inp_compare(.false.,'zora:skip_hypAOev',test)) then  
         skip_hypAOev = .true.
         if (.not. rtdb_put(rtdb,'zora:skip_hypAOev',
     &                     mt_log,1,skip_hypAOev))
     &    call errquit('rel_input: rtdb put failed skip hypAOev',
     &                  0, RTDB_ERR)
      elseif(inp_compare(.false.,'zora:skip_efgz4AOev',test)) then   
         skip_efgz4AOev = .true.
         if (.not. rtdb_put(rtdb,'zora:skip_efgz4AOev',
     &                     mt_log,1,skip_efgz4AOev))
     &    call errquit('rel_input: rtdb put failed skip efgz4AOev',
     &                  0, RTDB_ERR)
c
c     definitions for skip-cphf flags
      elseif(inp_compare(.false.,'zora:skip_cphf_ev_shield',test)) then
         skip_cphf_ev_shield = .true.
         if (.not. rtdb_put(rtdb,'zora:skip_cphf_ev_shield',
     &                     mt_log,1,skip_cphf_ev_shield))
     &    call errquit('rel_input-1: rtdb put failed skip cphf shield ',
     &                  0, RTDB_ERR)
      elseif(inp_compare(.false.,'zora:skip_cphf_ev_gshift',test)) then
         skip_cphf_ev_gshift = .true.
         if (.not. rtdb_put(rtdb,'zora:skip_cphf_ev_gshift',
     &                     mt_log,1,skip_cphf_ev_gshift))
     &    call errquit('rel_input-2: rtdb put failed skip cphf gshift',
     &                  0, RTDB_ERR)
      elseif(inp_compare(.false.,'zora:skip_cphf_ev_hyp',test)) then
         skip_cphf_ev_hyp = .true.
         if (.not. rtdb_put(rtdb,'zora:skip_cphf_ev_hyp',
     &                     mt_log,1,skip_cphf_ev_hyp))
     &    call errquit('rel_input-3: rtdb put failed skip cphf hyp',
     &                  0, RTDB_ERR)
c
      elseif(inp_compare(.false.,'zora:Knucl',test)) then
c      Knucle purpose: For including ONLY nuclear part in evaluation of K ZORA
         Knucl = .true. 
         if (.not. rtdb_put(rtdb,'zora:Knucl',
     &                     mt_log,1,Knucl))
     &    call errquit('rel_input: rtdb put failed Knucl',
     &                  0, RTDB_ERR)
      elseif(inp_compare(.false.,'zora:slc_spinpolAO',test)) then
c   For selecting spin-density matrix (A-B means total spin density matrix)
c   0=A-B,1=A,2=-B selecting spin-density matrix  
         if (.not. inp_i(slc_spinpolAO)) slc_spinpolAO= 0  ! set a default 
         if (.not. rtdb_put(rtdb,'zora:slc_spinpolAO',
     &                      mt_int,1,slc_spinpolAO))
     &    call errquit('rel_input: rtdb put failed',0, RTDB_ERR)
      else if (inp_compare(.false.,'end', test)) then
c
c        end will be catched in while loop structure
c
      else
         call errquit('rel_input: unrecognized directive', 0, INPUT_ERR)
      endif
c
c     End of while loop over the input
c
      if (.not. inp_compare(.false.,'end', test)) goto 1
c
c     User could have set multiple relativistic approaches in the input file by accident. 
c     Check if this is the case, stop if multiple methods are set to true.
c
      irelKey = 0
      status = rtdb_get(rtdb, 'doug_kroll', mt_log, 1, dk_run)
      if (dk_run) irelKey = irelKey + 1
c
      status = rtdb_get(rtdb, 'dyall_mod_dir', mt_log, 1, dmd_run)
      if (dmd_run) irelKey = irelKey + 1
c
      status = rtdb_get(rtdb, 'zora', mt_log, 1, zora_run)
      if (zora_run) irelKey = irelKey + 1
c
c     Check if multiple approaches have been set 
      if (irelKey .gt. 1) then
         if (ga_nodeid() .eq. 0) then
           write(luout,20)
  20       format(/'Input error relativistic:'/,
     & 'Multiple relativistic methods have been specified 
     & in the input!')
         endif
         call errquit('rel_input: input error',0, INPUT_ERR)
      endif

      return
      end

C $Id: ecp_t1_Q1pow.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_t1_Q1pow (n,m,x,xt,gamma,term,test,Q,tol)
*                                                                      *
*   Calculate Q^{m+p}_m for p = 1 using the series expansion.          *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   n (inp) - number of Q functions to be evaluated for given order    *
*   m (inp) - order of Q function                                      *
*   x (inp) - array of values beta/2sqrt(alpha)                        *
*   xt (scr) - array to store x^2                                      *
*   gamma (scr) - array of values of 1/sqrt(alpha)                     *
*   term (scr) - array of terms in series                              *
*   test (scr) - array of ratios of terms to sums                      *
*   Q (out) - Q^m+1_m functions                                        *
*   tol (inp) - maximum relative error in Q functions                  *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
#include "ecp_consts.fh"
#include "errquit.fh"
      integer i,idamax,m,n
      double precision x(n),xt(n),gamma(n),term(n),test(n),Q(n),
     &    tol,fac0,fac1,fac2,fac3
*
      if (m .lt. 0) call errquit ('Negative m in ecp_t1_Q1pow',99,
     &       BASIS_ERR)
      fac3 = half
      fac1 = zero
      fac2 = one
      do i = 1,m
        fac1 = fac1+two
        fac2 = fac2+two
        fac3 = fac3*fac1/fac2
      end do
      fac1 = fac1+two
      fac2 = fac2+two
      fac0 = fac1/fac2
      if (m .eq. 0) then
        do i = 1,n
          Q(i) = fac3*(gamma(i)**2)
        end do
      else
        do i = 1,n
          Q(i) = fac3*(gamma(i)**2)*(x(i)*gamma(i))**m
        end do
      end if
      do i = 1,n
        xt(i) = x(i)*x(i)
        test(i) = fac0*xt(i)
        term(i) = Q(i)*test(i)
      end do
      fac3 = 1
    1 i = idamax(n,test,1)
      if (test(i) .ge. tol) then
        fac1 = fac1+two
        fac2 = fac2+two
        fac3 = fac3+one
        fac0 = fac1/(fac2*fac3)
        do i = 1,n
          if (test(i) .ge. tol) then
            Q(i) = Q(i)+term(i)
            term(i) = term(i)*xt(i)*fac0
            test(i) = term(i)/Q(i)
          end if
        end do
        go to 1
      end if
*
      do i = 1,n
        Q(i) = Q(i)*exp(-xt(i))
      end do
*
      return
      end

c
c     $Id: pair_distab.F 25375 2014-03-23 22:36:59Z bylaska $
c
*     *********************************
*     *                               *
*     *          pair_distab          *
*     *                               *
*     *********************************
      subroutine pair_distab(mfilename)
      implicit none
      character*(*) mfilename

#include "errquit.fh"
#include "mafdecls.fh"
#include "stdio.fh"

c     *** parameters ***
      integer MASTER,taskid,np
      parameter (MASTER=0)

      real*8 DELR
      parameter (DELR=0.01d0)
 

*     **** local variables ****
      logical value,found
      integer MAXBIN
      integer i,j,bin,natoms,natoms0,t,nframes,iii,icount
      integer nindxA,nindxB,nkatm,iA,iB
      integer rx(2),ry(2),rz(2),hst(2),symb(2),indxA(2),indxB(2)
      real*8  time1,time2,volume,volume1
      real*8  x,y,z,r,gr,v1,v2,v3
      real*8 RLOWER,RUPPER,NIDEAL,CONST    
      real*8 grs,grm2,grm1,grp1,grp2,sum1,sum2
      integer k1,k2,n1,n2,n3
      real*8 unita(3,3)
      character*2 tag2
      character*2 tag4
      character*2 tagA,tagB
      character*255 full_filename,gfilename

*     ***************************************
*     ****** PAIR DISTRIBUTION routine ******
*     ***************************************

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      if (taskid.eq.MASTER) then
         write(luout,*)
         write(luout,*) 
     =   '===== Calculating radial distribution functions ===='
         write(luout,*)

*        *** get the number of frames from MOTION ***
         call MOTION_nframes(mfilename,nframes,natoms,volume,unita)
      end if
      call Parallel_Brdcst_ivalues(MASTER,1,nframes)
      call Parallel_Brdcst_ivalues(MASTER,1,natoms)
      call Parallel_Brdcst_values(MASTER,1,volume)
      call Parallel_Brdcst_values(MASTER,9,unita)
      

      MAXBIN = INT(0.5d0*(volume**(0.33333333d0))/DELR)

      value = MA_push_get(mt_int,MAXBIN,'hst89',hst(2),hst(1))
      value = value.and.
     >        MA_push_get(mt_int,natoms,'indxA',indxA(2),indxA(1))
      value = value.and.
     >        MA_push_get(mt_int,natoms,'indxB',indxB(2),indxB(1))
      value = value.and.
     >        MA_push_get(mt_dbl,natoms,'rx',rx(2),rx(1))
      value = value.and.
     >        MA_push_get(mt_dbl,natoms,'ry',ry(2),ry(1))
      value = value.and.
     >        MA_push_get(mt_dbl,natoms,'rz',rz(2),rz(1))
      value = value.and.
     >        MA_push_get(mt_byte,2*natoms,'symb',symb(2),symb(1))
      if (.not. value) 
     >   call errquit('pair_distab: out of stack memory',0,MA_ERR)
      
      if (taskid.eq.MASTER) then
         iA = 1
         iB = 3
         gfilename
     >   ='                                                    '
         nkatm = 0
         open(unit=19,file=mfilename,form='formatted')
         read(19,*) time1,natoms0,volume1,unita
         do i=1,natoms0
            read(19,*) iii,tag2,tag4,x,y,z,v1,v2,v3

            found = .false.
            j = 0
            do while ((j.lt.nkatm).and.(.not.found))
               tagA(1:1) = byte_mb(symb(1)+2*j)
               tagA(2:2) = byte_mb(symb(1)+2*j+1)
               if (tag2.eq.tagA) found = .true.
               j = j + 1
            end do

            if (.not.found) then
               byte_mb(symb(1)+2*nkatm)   = tag2(1:1)
               byte_mb(symb(1)+2*nkatm+1) = tag2(2:2)
               nkatm = nkatm+1
               gfilename(iA:iB) = tag2//' '
               iA = iA + 3
               iB = iB + 3
            end if

         end do
         close(19)

         write(luout,*) 
         write(luout,*) 'frames used: ',nframes
         write(luout,*) 'natoms:      ',natoms
         write(luout,*) 'nkatoms:     ',nkatm
         write(luout,*) 'atoms:       ',gfilename
         write(luout,*) 'delr:        ',DELR
         write(luout,*) 'volume:      ',volume
         write(luout,1100) '    a1:      ',
     >                     unita(1,1),unita(2,1),unita(3,1)
         write(luout,1100) '    a2:      ',
     >                     unita(1,2),unita(2,2),unita(3,2)
         write(luout,1100) '    a3:      ',
     >                     unita(1,3),unita(2,3),unita(3,3)
         write(luout,*) 'maxbin:      ',MAXBIN
         iii = index(mfilename,' ')
         write(luout,*) 'MOTION filename:    ',mfilename(1:iii)
         write(luout,*) 
         call util_flush(luout)
      end if
 1100 FORMAT(A,3F8.3)

      call Parallel_Brdcst_ivalues(MASTER,1,nkatm)
      do iA = 1,nkatm
      do iB = 1,nkatm
         do bin=0,MAXBIN-1
            int_mb(hst(1)+bin) = 0
         end do

         if (taskid.eq.MASTER) then
            tagA(1:1) = byte_mb(symb(1)+2*iA-2)
            tagA(2:2) = byte_mb(symb(1)+2*iA-1)
            tagB(1:1) = byte_mb(symb(1)+2*iB-2)
            tagB(2:2) = byte_mb(symb(1)+2*iB-1)
            open(unit=19,file=mfilename,form='formatted')
         end if
     
*        **** calculate the pair distribution function ****
         time1 = 0.0d0
         do t=1,nframes
        
            if (taskid.eq.MASTER) then
               time2    = time1
               read(19,*) time1,natoms0,volume1,unita
               nindxA = 0
               nindxB = 0
               do i=1,natoms0
                  read(19,*) iii,tag2,tag4,x,y,z,v1,v2,v3
                  dbl_mb(rx(1)+(i-1)) = x
                  dbl_mb(ry(1)+(i-1)) = y
                  dbl_mb(rz(1)+(i-1)) = z          
                  if (tag2.eq.tagA) then
                     int_mb(indxA(1)+nindxA) = i
                     nindxA = nindxA + 1
                  end if
                  if (tag2.eq.tagB) then
                     int_mb(indxB(1)+nindxB) = i
                     nindxB = nindxB + 1
                  end if
               end do
            end if
            call Parallel_Brdcst_ivalues(MASTER,1,natoms0)
            call Parallel_Brdcst_ivalues(MASTER,1,nindxA)
            call Parallel_Brdcst_ivalues(MASTER,1,nindxB)
            call Parallel_Brdcst_ivalues(MASTER,nindxA,int_mb(indxA(1)))
            call Parallel_Brdcst_ivalues(MASTER,nindxB,int_mb(indxB(1)))
            call Parallel_Brdcst_values(MASTER,natoms0,dbl_mb(rx(1)))
            call Parallel_Brdcst_values(MASTER,natoms0,dbl_mb(ry(1)))
            call Parallel_Brdcst_values(MASTER,natoms0,dbl_mb(rz(1)))

            icount = 0
            do k1=1,nindxA
              i = int_mb(indxA(1)+k1-1)
              do k2=1,nindxB
                j = int_mb(indxB(1)+k2-1)
                if (icount.eq.taskid) then
                   do n1=-1,1
                   do n2=-1,1
                   do n3=-1,1
                     x = dbl_mb(rx(1)+(i-1)) - dbl_mb(rx(1)+(j-1))
     >                 + n1*unita(1,1) + n2*unita(1,2) + n3*unita(1,3)
                     y = dbl_mb(ry(1)+(i-1)) - dbl_mb(ry(1)+(j-1))
     >                 + n1*unita(2,1) + n2*unita(2,2) + n3*unita(2,3)
                     z = dbl_mb(rz(1)+(i-1)) - dbl_mb(rz(1)+(j-1))
     >                 + n1*unita(3,1) + n2*unita(3,2) + n3*unita(3,3)
                     r = dsqrt(x*x+y*y+z*z)
                     if (r.gt.DELR) then
                       bin = INT(r/DELR) 
                       if (bin.le.(MAXBIN-1)) 
     >                  int_mb(hst(1)+bin) = int_mb(hst(1)+bin) + 1
                     end if
                   end do
                   end do
                   end do
                end if
                icount = mod(icount+1,np)
              end do
            end do

         end do
         if (taskid.eq.MASTER) close(unit=19)

         call Parallel_Vector_ISumAll(MAXBIN,int_mb(hst(1)))

         if (taskid.eq.MASTER) then
*        ***** write out g(r) in PAIR_DISTRIBUTION ****
         i = 2
         j = 2
         if (tagA(2:2).eq.' ') i = 1
         if (tagB(2:2).eq.' ') j = 1
         gfilename = tagA(1:i)//tagB(1:j)//'.gr'
         call util_file_name_noprefix(gfilename,.false.,
     >                             .false.,
     >                             full_filename)
         open(unit=19,file=full_filename,form='formatted')
         iii = index(full_filename,' ')
         write(luout,*) 'creating gr filename:',full_filename(1:iii)

         gfilename = tagA(1:i)//tagB(1:j)//'.hist'
         call util_file_name_noprefix(gfilename,.false.,
     >                             .false.,
     >                             full_filename)
         open(unit=21,file=full_filename,form='formatted')
         iii = index(full_filename,' ')
         write(luout,*) 'creating hist filename:',full_filename(1:iii)
         write(luout,*) 
         call util_flush(luout)

***      **** normalize hist(bin) to give g(r) ****
         sum1=0.0d0
         sum2=0.0d0
         CONST =       (16.0d0*datan(1.0d0)/3.0d0)*(nindxB/volume)
         do bin=2,MAXBIN-3
           RLOWER = dble(bin)*DELR
           RUPPER = RLOWER + DELR
           NIDEAL = CONST*(RUPPER**3 - RLOWER**3)
           !NIDEAL = NIDEAL*nindxA*nindxB
           NIDEAL = NIDEAL*nindxA
           r  = 0.5d0*(RLOWER+RUPPER)
           gr = dble(int_mb(hst(1)+bin))/dble(nframes)

           RLOWER = dble(bin-2)*DELR
           RUPPER = RLOWER + DELR
           !NIDEAL = CONST*(RUPPER**3 - RLOWER**3)
           grm2 = dble(int_mb(hst(1)+bin-2))/dble(nframes)

           RLOWER = dble(bin-1)*DELR
           RUPPER = RLOWER + DELR
           !NIDEAL = CONST*(RUPPER**3 - RLOWER**3)
           grm1 = dble(int_mb(hst(1)+bin-1))/dble(nframes)

           RLOWER = dble(bin+1)*DELR
           RUPPER = RLOWER + DELR
           !NIDEAL = CONST*(RUPPER**3 - RLOWER**3)
           grp1 = dble(int_mb(hst(1)+bin+1))/dble(nframes)

           RLOWER = dble(bin+2)*DELR
           RUPPER = RLOWER + DELR
           !NIDEAL = CONST*(RUPPER**3 - RLOWER**3)
           grp2 = dble(int_mb(hst(1)+bin+2))/dble(nframes)

           grs = ( -3.0d0*grm2
     >           + 12.0d0*grm1
     >           + 17.0d0*gr
     >           + 12.0d0*grp1
     >           -  3.0d0*grp2)/35.0d0

           sum1 = sum1 + grs
           sum2 = sum2 + gr
           write(19,1200) 0.529177d0*r,grs/NIDEAL,sum1,gr/NIDEAL,sum2
           write(21,1201) 0.529177d0*r,grs,gr
        end do
        close(unit=19)
        close(unit=21)
      end if

      end do
      end do
 1200 FORMAT(5E14.5)
 1201 FORMAT(3E14.5)

      value =           MA_pop_stack(symb(2))
      value = value.and.MA_pop_stack(rz(2))
      value = value.and.MA_pop_stack(ry(2))
      value = value.and.MA_pop_stack(rx(2))
      value = value.and.MA_pop_stack(indxB(2))
      value = value.and.MA_pop_stack(indxA(2))
      value = value.and.MA_pop_stack(hst(2))
      if (.not. value) 
     >  call errquit('pair_distab:cannot release stack memory',0,
     &       MA_ERR)


*     *** synchronization ***
      call ga_sync()

      return
      end

C> \ingroup selci
C> @{
      subroutine selci_mkdele(numf, nroot, deltae, vc, roots,
     $     diag, nfmax, dnorm)
*
* $Id: mkdele.F 24790 2013-11-11 18:56:49Z d3y133 $
*
#include "implicit.fh"
c
c     deltae(root) =  - <root|H|*><*|H|root> / (<*|H|*> - Eroot)
c     dnorm = ( <*|H|root>/(<*|H|*>-E) ) **2
c
      dimension deltae(nroot), vc(nfmax, nroot), roots(nroot),
     $     diag(numf, numf), dnorm(nroot)
c
      call dfill(nroot, 0.0d0, deltae, 1)
      call dfill(nroot, 0.0d0, dnorm, 1)
c
      do 10 ir = 1,nroot
         do 20 i = 1,numf
            coeff = vc(i,ir)/(diag(i,i) - roots(ir))
            deltae(ir) = deltae(ir) - vc(i,ir)*coeff
            dnorm(ir) = dnorm(ir) + coeff*coeff
 20      continue
 10   continue
c
      end
C> @}

*
* $Id: cgsdv5.F 25931 2014-07-23 16:47:53Z bylaska $
*

***********************************************************************
*                      cgsdv5-mpi  (MPI code)                         *
*                                                                     *
*     This is a developing cgsdv5 parallel code for NWCHEM            *
*       + tcgmsg message passing library used                         *
*       + my own slap-decomposed parallel 3d-FFT(real->complex) used  *
*                                                                     *
*                                                                     *
***********************************************************************

      logical function cgsdv5(rtdb,flag)
      implicit none
      integer rtdb
      integer flag

#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"

#include "nwpw_timing.fh"
      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d
      real*8  a,b,c,alpha,beta,gamma
    

*     ***** energy variables ****
      integer ispin,ne(2),ms
      real*8  E(10),en(2)
      real*8  dipole(3)
      real*8  stress(3,3),lstress(6)

*     **** gradient variables ****
      integer fion(2)

*     **** error variables ****
      logical value,newpsi
      integer ierr

*     **** local variables ****
      logical oprint,lprint,hprint,qmmm
      real*8  gx,gy,gz,cx,cy,cz
      real*8  EV,EVQ,pi,rs
      real*8  icharge
      integer i,k,ia,nion,minimizer,mapping,mapping1d


*     **** external functions ****
      real*8      psp_zv,psp_rc,ewald_rcut
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg,ion_amass
      integer     ewald_ncut,ewald_nshl3d
      integer     psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      integer     psp_nprj,psp_psp_type
      character*4 ion_atom,ion_aname
      external    psp_zv,psp_rc,ewald_rcut
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg,ion_amass
      external    ewald_ncut,ewald_nshl3d
      external    psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      external    psp_nprj,psp_psp_type
      external    ion_atom,ion_aname
    
      external      psp_comment
      character*255 psp_comment,comment

      real*8   control_tole,control_tolc,control_tolr,ion_rion
      external control_tole,control_tolc,control_tolr,ion_rion
      real*8   control_time_step,control_fake_mass
      external control_time_step,control_fake_mass
      logical  control_read,control_move,ion_init
      external control_read,control_move,ion_init

      integer  pack_nwave_all
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      integer  pspw_charge_nion
      external pack_nwave_all
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external pspw_charge_nion

      character*12 control_boundry
      external     control_boundry
      character*50 control_cell_name
      external     control_cell_name

      logical      psp_semicore
      real*8       psp_rcore,psp_ncore,psp_rlocal
      external     psp_semicore
      external     psp_rcore,psp_ncore,psp_rlocal

      logical  psi_initialize, psi_finalize
      integer  psi_ispin,psi_ne,psi_neq,electron_count,linesearch_count
      external psi_initialize, psi_finalize
      external psi_ispin,psi_ne,psi_neq,electron_count,linesearch_count
      real*8   cgsd_energy,cgsd_noit_energy
      external cgsd_energy,cgsd_noit_energy
      logical  control_Mulliken,control_DOS
      external control_Mulliken,control_DOS
      real*8   ion_TotalCharge,psi_occupation
      external ion_TotalCharge,psi_occupation
      logical   control_check_charge_multiplicity
      external  control_check_charge_multiplicity
      logical   pspw_charge_found,ion_q_FixIon
      external  pspw_charge_found,ion_q_FixIon
      integer  control_minimizer,control_scf_algorithm
      external control_minimizer,control_scf_algorithm
      integer  control_ks_algorithm
      external control_ks_algorithm
      real*8   control_ks_alpha,control_kerker_g0
      external control_ks_alpha,control_kerker_g0
      logical  control_print,control_balance
      external control_print,control_balance
      integer  control_mapping,control_mapping1d,control_np_orbital
      external control_mapping,control_mapping1d,control_np_orbital
      integer  control_ks_maxit_orb,control_ks_maxit_orbs
      external control_ks_maxit_orb,control_ks_maxit_orbs
      logical  control_fractional,control_parallel_io
      external control_fractional,control_parallel_io
      integer  control_fractional_smeartype,control_excited_ne
      external control_fractional_smeartype,control_excited_ne
      real*8   control_fractional_kT,control_fractional_temperature
      external control_fractional_kT,control_fractional_temperature
      logical  psp_pawexist
      external psp_pawexist

#ifdef USE_OPENMP
      integer  omp_get_max_threads
      external omp_get_max_threads
#endif


      logical pspw_bqext,control_fast_erf
      external pspw_bqext,control_fast_erf
      integer  ion_nconstraints,ion_ndof
      external ion_nconstraints,ion_ndof
      logical  control_smooth_cutoff
      external control_smooth_cutoff
      real*8   control_smooth_cutoff_values
      external control_smooth_cutoff_values


*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      call ecce_print_module_entry('pspw')

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(10,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      value = control_read(3,rtdb)
      if (.not. value) 
     > call errquit('error reading control',0, INPUT_ERR)

      call Parallel2d_Init(control_np_orbital())
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)



      oprint= ((taskid.eq.MASTER).and.control_print(print_medium))
      lprint= ((taskid.eq.MASTER).and.control_print(print_low))
      hprint= ((taskid.eq.MASTER).and.control_print(print_high))


      if (taskid.eq.MASTER) call current_second(cpu1)

*     ***** print out header ****
      if (oprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1042)
         write(luout,1043)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
         call flush(luout)
      end if
      
      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      minimizer = control_minimizer()
      mapping   = control_mapping()


*     **** initialize psi_data ****
      call psi_data_init(100)

*     **** initialize D3dB data structure ****
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d

*     ***** Initialize double D3dB data structure ****
      if (control_version().eq.4)
     >   call D3dB_Init(2,2*ngrid(1),2*ngrid(2),2*ngrid(3),mapping)


 
*     **** initialize lattice data structure ****
      call lattice_init()
      call G_init()
      call mask_init()
      call Pack_Init()
      call D3dB_pfft_init()
      call ga_sync()


*     **** read ions ****
      value = ion_init(rtdb)
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call psp_init()
      call psp_readall()
      if (psp_semicore(0)) call semicore_check()

*     **** initialize G,mask,ke,coulomb,and ewald data structures ****
      call ke_init()
      if (control_version().eq.3) call coulomb_init()
      if (control_version().eq.4) call coulomb2_init()
      call strfac_init()
      call phafac()
      if (control_version().eq.3) then
         call ewald_init()
         call ewald_phafac()
      end if


*     **** read in wavefunctions and initialize psi ****
      if (.not.control_check_charge_multiplicity()) then
        call psi_new()
        newpsi = .true.
      else
        newpsi = .false.
      end if

*     **** Initialize 1d mappings for ne spaces ****
      call psi_get_ne(ispin,ne)
      mapping1d   = control_mapping1d()
      call Dne_init(ispin,ne,mapping1d)


*     **** read in wavefunctions and initialize psi ****
      value = psi_initialize()

      !call D3dB_n_fft_init(1,psi_ne(1)+psi_ne(2))

*     **** electron and geodesic data structures ****
      call electron_init()
      if ((minimizer.eq.4).or.(minimizer.eq.7)) then  !debug
        call geodesic2_init()
      else
         call geodesic_init()
      end if

*     **** initialize two-electron Gaussian integrals ****
      if (psp_pawexist()) then
         call nwpw_gintegrals_init()
         call nwpw_gintegrals_set((flag.gt.0))
      end if


*     **** initialize QM/MM ****
      call pspw_init_APC(rtdb)
      call pspw_qmmm_init(rtdb)
      call pspw_charge_init(rtdb)

*     **** initialize SIC and HFX ****
      ne(1) = psi_ne(1)
      ne(2) = psi_ne(2)
      call pspw_init_SIC(rtdb,ne)
      call pspw_init_HFX(rtdb,psi_ispin(),ne)

*     **** initialize DFT+U ****
      call psp_U_init()

*     **** initialize  META GGA ****
      call nwpw_meta_gga_init()

*     **** initialize metadynamics ****
      call meta_initialize(rtdb)

*     **** initialize  META GGA ****

*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)

*     **** initialize linesearching ****
      call linesearch_init()





*                |**************************|
******************   summary of input data  **********************
*                |**************************|

      if (oprint) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j
         if (mapping.eq.1) write(luout,1112) 
         if (mapping.eq.2) write(luout,1113) 
         if (mapping.eq.3) write(luout,1118) 
         if (control_balance()) then
           write(luout,1114)
         else
           write(luout,1116)
         end if
#ifdef USE_OPENMP
         write(luout,1119)  omp_get_max_threads()
#endif
         if (control_parallel_io()) then
           write(luout,1123)
         else
           write(luout,1124)
         end if
         if (control_fast_erf()) write(luout,1125)

         write(luout,1115)
         write(luout,1121) control_boundry(),control_version()
         if (psi_ispin().eq.1) write(luout,1130) "restricted"
         if (psi_ispin().eq.2) write(luout,1130) "unrestricted"
         !if (qmmm) write(luout,1122)

         call v_bwexc_print(luout,control_gga())

         if (control_fractional()) write(luout,1132)
         call pspw_print_SIC(luout)
         call pspw_print_HFX(luout)
         write(luout,1140)
         do ia = 1,ion_nkatm()
           call psp_print(ia)
c           call psp_check_print(ia)
         end do

         icharge = -(psi_ne(1)+psi_ne(psi_ispin()))
         en(1)     = psi_ne(1)
         en(psi_ispin()) = psi_ne(psi_ispin())
         if (control_fractional()) then
            icharge = 0
            do ms=1,psi_ispin()
            en(ms) =0.0d0
            do i=1,ne(ms)
              !!!!k = fweight(1)+(i-1)+(ms-1)*ne(1)
              icharge = icharge - (3-psi_ispin())*psi_occupation(ms,i)
              en(ms) = en(ms) + psi_occupation(ms,i)
            end do
            end do
         end if
         icharge = icharge + ion_TotalCharge()
         write(luout,1159) icharge

         if (control_version().eq.3) then
            rs  = (3.0d0*lattice_omega()/(4.0d0*pi))**(1.0d0/3.0d0)
            EVQ = 0.5d0*ewald_mandelung()*(icharge**2)/rs
         else
            EVQ = 0.0d0
         end if

         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         if (hprint) then
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz
         write(luout,1211) ion_nconstraints(),ion_ndof()

         call pspw_charge_Print(luout)
         end if

         !write(luout,1220) psi_ne(1),psi_ne(psi_ispin()),' (Fourier space)'
         if (control_fractional()) then
          write(luout,1219) en(1),en(psi_ispin()),' (   fractional)'
          write(luout,1221) psi_ne(1),psi_neq(1),
     >                  psi_ne(psi_ispin()),psi_neq(psi_ispin()),
     >                  ' (Fourier space)'
         else
          write(luout,1220) psi_ne(1),psi_neq(1),
     >                  psi_ne(psi_ispin()),psi_neq(psi_ispin()),
     >                 ' (Fourier space)'
          write(luout,1221) psi_ne(1),psi_neq(1),
     >                  psi_ne(psi_ispin()),psi_neq(psi_ispin()),
     >                  ' (Fourier space)'
         end if
         write(luout,1230)
         write(luout,1233) control_cell_name()
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1231) lattice_omega()
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(0),pack_nwave(0)
         write(luout,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(1),pack_nwave(1)
         if (control_smooth_cutoff()) 
     >      write(luout,1252) 
     >      control_smooth_cutoff_values(1)*lattice_wcut(),
     >      control_smooth_cutoff_values(2) 

         if (control_version().eq.3) then
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung(),
     >                     ewald_mandelung()
     >                    *(4.0d0*pi/3.0)**(1.0d0/3.0d0),rs
         end if
         write(luout,1270)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_tole(),control_tolc()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()
         if ((minimizer.eq.5).or.(minimizer.eq.8)) then
           write(luout,1291)
           if (control_ks_algorithm().eq.0) 
     >       write(luout,1292) "conjugate gradient"
           if (control_ks_algorithm().eq.1) 
     >       write(luout,1292) "rmm-diis"
           write(luout,1295) control_ks_maxit_orb(),
     >                       control_ks_maxit_orbs()
           if (control_scf_algorithm().eq.0) 
     >       write(luout,1293) "simple mixing"
           if (control_scf_algorithm().eq.1) 
     >       write(luout,1293) "Anderson potential mixing"
           if (control_scf_algorithm().eq.2) 
     >       write(luout,1293) "Johnson-Pulay mixing"
           if (control_scf_algorithm().eq.3) 
     >       write(luout,1293) "Anderson density mixing"
           if (minimizer.eq.5) write(luout,1296) "potential"
           if (minimizer.eq.8) write(luout,1296) "density"
           write(luout,1294) control_ks_alpha()
           write(luout,1301) control_kerker_g0()
         end if
        if (control_fractional()) then
           write(6,1297)
           if (control_fractional_smeartype().eq.0)
     >       write(6,1298) "step function"
           if (control_fractional_smeartype().eq.1)
     >       write(6,1298) "Fermi-Dirac"
           if (control_fractional_smeartype().eq.2)
     >       write(6,1298) "Gaussian"
           write(6,1299) control_fractional_kT(),
     >                   control_fractional_temperature()
         end if
         write(luout,1300)
c         call ion_Print_neighborlist()
         call util_flush(luout)
      end if

*                |***************************|
******************     call CG minimizer     **********************
*                |***************************|
      if (taskid.eq.MASTER) call current_second(cpu2)

c     if (flag.eq.1) then
c       call control_gradient_iterations()
c     end if

*     **** calculate energy ****
      if (flag.eq.-1) then
        EV= cgsd_noit_energy()
      else
        EV= cgsd_energy(newpsi)
      end if

*     **** calculate excited state orbitals ****
      call ga_sync()
      call cgsd_excited()

*     **** calculate oep eigenvalues ****
      call cgsd_oep_eigenvalues()

*     **** extra energy output for QA test ****
      if (lprint) write(LuOut,1600) EV
      if (lprint) then
         if (EVQ.gt.0.0d0) write(LuOut,1601) EV+EVQ
      end if

*     **** calculate the spin contamination ****
      if (flag.gt.-1) call psi_spin2(dipole(1))

      
*     **** calculate the dipole ***
      dipole(1) = 0.0d0
      dipole(2) = 0.0d0
      dipole(3) = 0.0d0
      if (flag.gt.-1) call rho_dipole(dipole)

*     ****  calculate gradient ***
      if (flag.gt.0) then
      nion = ion_nion()
      if (pspw_charge_found().and.
     >    (.not.pspw_bqext())) nion = nion + pspw_charge_nion()

      value = MA_push_get(mt_dbl,(3*nion),
     >                       'fion',fion(2),fion(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
     
      call cgsd_energy_gradient(dbl_mb(fion(1)))
      call dscal(3*nion,(-1.0d0),dbl_mb(fion(1)),1)
      end if

*     **** calculate the stress tensor ****
      call dcopy(9,0.0d0,0,stress,1)
      call dcopy(6,0.0d0,0,lstress,1)
      if (flag.eq.3) then
         call psp_stress_init()
         call psp_stress_readall()
         call cgsd_energy_stress(stress,lstress)
         call psp_stress_end()
      end if


*     *************************************************************
*     **** output energy, dipole, and gradient to rtdb for use ****
*     **** by task_energy and task_gradient                    ****
*     *************************************************************
      value = .true.
      if (flag.gt.-1) then
      value = rtdb_put(rtdb,'pspw:energy',mt_dbl,1,EV)
      value = value.and.
     >        rtdb_put(rtdb,'pspw:dipole',mt_dbl,
     >                 3,dipole)
      end if
      if (flag.gt.0) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:gradient',mt_dbl,
     >                 3*nion,dbl_mb(fion(1)))
        value = value.and.MA_pop_stack(fion(2))
      end if
      if (flag.eq.3) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:stress',mt_dbl,
     >                 9,stress)
        value = value.and.
     >        rtdb_put(rtdb,'pspw:lstress',mt_dbl,
     >                 6,lstress)
      end if
      if (.not. value) call errquit('cgsdv5: error writing rtdb',0,
     &       RTDB_ERR)

      if (taskid.eq.MASTER) call current_second(cpu3)

*                |***************************|
******************         Epilogue          **********************
*                |***************************|

*     **** calculate Mulliken Populations ***
      if (control_Mulliken()) then
         call psi_Mulliken(rtdb)
         i = control_excited_ne(1)+control_excited_ne(2)
         if (i.eq.0) call kp_structure(rtdb)
      end if


*     **** write wavefunctions to file and finalize psi ****
      if (flag.eq.-1) then
        value = psi_finalize(.false.)
      else
        value = psi_finalize(.true.)
      end if


*     **** write geometry to rtdb ****
      call pspw_charge_write(rtdb)
      call ion_write(rtdb)


*     **** deallocate heap memory ****
      call electron_finalize()
      if ((minimizer.eq.4).or.(minimizer.eq.7)) then
        call geodesic2_finalize()
      else
        call geodesic_finalize()
      end if
      if (control_version().eq.3) call ewald_end()
      call strfac_end()
      if (control_version().eq.3) call coulomb_end()
      if (control_version().eq.4) call coulomb2_end()
      call ke_end()
      call mask_end()
      call Pack_end()
      call G_end()
      call psp_U_end()
      call nwpw_meta_gga_end()
      call pspw_end_SIC()
      call pspw_end_HFX()
      call pspw_end_APC()
      call pspw_charge_end()
      call pspw_qmmm_end()
c      call frac_occ_end()
      call meta_finalize(rtdb)
      if (psp_pawexist()) call nwpw_gintegrals_end()

      call ion_end()
      call psp_end()
      call ion_end_FixIon()
      !call D3dB_n_fft_end(1)
      call D3dB_pfft_end()
      call D3dB_end(1)
      if (control_version().eq.4) call D3dB_end(2)
      call Dne_end()
      call psi_data_end()

*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (lprint) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(electron_count())
         write(luout,1801)
         write(luout,1802)
         write(luout,1803) T1
         write(luout,1804) T2
         write(luout,1805) T3
         write(luout,1806) T4
         write(luout,1807) AV,electron_count(),linesearch_count()

         call nwpw_timing_print_final(oprint,electron_count())
         write(luout,*)
         CALL nwpw_MESSAGE(4)
      end if 



      call Parallel2d_Finalize()
      call Parallel_Finalize()
      call ecce_print_module_exit('pspw', 'ok')
      cgsdv5 = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*               NWPW PSPW Calculation              *')
 1030 FORMAT(10X,'* [ (Grassmann/Stiefel manifold implementation)  ] *')
 1035 FORMAT(10x,'*      [ NorthWest Chemistry implementation ]      *')
 1040 FORMAT(10X,'*            version #5.10   06/12/02              *')
 1041 FORMAT(10X,'*    This code was developed by Eric J. Bylaska,   *')
 1042 FORMAT(10X,'*    and was based upon algorithms and code        *')
 1043 FORMAT(10X,'*    developed by the group of Prof. John H. Weare *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I10)
 1112 FORMAT( ' parallel mapping         :   1d slab')
 1113 FORMAT( ' parallel mapping         :2d hilbert')
 1114 FORMAT( ' parallel mapping         :  balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1117 FORMAT( ' processor grid           :',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         : 2d hcurve')
 1119 FORMAT( ' number of threads        :',I10)
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1122 FORMAT(5X,' qmmm simulation')
 1123 FORMAT( ' parallel io              :        on')
 1124 FORMAT( ' parallel io              :       off')
 1125 FORMAT( ' fast erf                 :        on')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F8.4,'  lmax=',I3)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)

 1159 FORMAT(/' total charge:',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I5))
 1180 FORMAT(/' position of ions (au):')
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - fixed')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1211 FORMAT(5X,'   number of constraints = ', I6,' ( DOF = ',I6,' )' )
 1219 FORMAT(/' number of electrons: spin up=',F6.2,16x,
     >        '  down=',F6.2,A)
 1220 FORMAT(/' number of electrons: spin up=',I6,
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1221 FORMAT( ' number of orbitals : spin up=',I6,  
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,'             omega=',F12.1)
 1232 FORMAT(5x,' lattice:    a=    ',f8.3,' b=   ',f8.3,' c=    ',f8.3,
     >      /5x,'             alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1233 FORMAT(5x,' cell_name:  ',A)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1250 FORMAT(/5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1252 FORMAT(5X,' smooth wavefnc cutoff:  A=',F7.3,' sigma = ',F7.3)
 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   Madelung Wigner-Seitz=',f11.8,
     >                              ' (alpha=',f11.8,' rs=',f11.8,')')
 1270 FORMAT(/' technical parameters:')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (density)')
 1291 FORMAT(/' Kohn-Sham scf parameters:')
 1292 FORMAT(5X, ' Kohn-Sham algorithm  = ',A)
 1293 FORMAT(5X, ' SCF algorithm        = ',A)
 1294 FORMAT(5X, ' SCF mixing parameter =',F7.4)
 1295 FORMAT(5X, ' Kohn-Sham iterations = ',I3,
     >           ' (',I3,' outer)')
 1296 FORMAT(5X, ' SCF mixing type      = ',A)
 1297 FORMAT(/' fractional smearing parameters:')
 1298 FORMAT(5X, ' smearing algorithm   = ',A)
 1299 FORMAT(5X, ' smearing parameter   = ',E9.3,' (',F7.1,' K)')
 1300 FORMAT(//)
 1301 FORMAT(5X, ' Kerker damping       =',F7.4)
 1305 FORMAT(10X,'================ iteration =========================')
 1310 FORMAT(I8,E20.10,3E15.5)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1500 FORMAT(/' orbital energies:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1600 FORMAT(/' Total PSPW energy     :',E19.10)
 1601 FORMAT(/' Total PSPW energy ',
     >        '(charge correction - E + 0.5*q**2*mandelung/rs) :',
     >        E19.10)
 1801 FORMAT(//'== Timing ==')
 1802 FORMAT(/'cputime in seconds')
 1803 FORMAT( '  prologue    : ',E14.6)
 1804 FORMAT( '  main loop   : ',E14.6)
 1805 FORMAT( '  epilogue    : ',E14.6)
 1806 FORMAT( '  total       : ',E14.6)
 1807 FORMAT( '  cputime/step: ',E14.6,
     >        '       (',I8,' evalulations,', I8,' linesearches)')
 1808 FORMAT(A,E14.6,E14.6)
 1809 FORMAT(//A,2A14)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(luout,9010) ierr
      call Parallel_Finalize()
      call ecce_print_module_exit('pspw', 'failed')

      cgsdv5 = value
      return
      END

      subroutine argos_space_wrttrj(lfntrj,lxw,lvw,lfw,lxs,lvs,lfs,
     + stime,pres,temp,tempw,temps,iwl,xw,vw,fw,xwcr,isl,xs,vs,fs)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      integer lfntrj
      logical lxw,lvw,lfw,lxs,lvs,lfs
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 stime,pres,temp,tempw,temps
      real*8 xw(mwm,3,mwa),vw(mwm,3,mwa),fw(mwm,3,mwa),xwcr(mwm,3)
      real*8 xs(msa,3),vs(msa,3),fs(msa,3)
c
      integer lenscr
c
      lenscr=ma_inquire_avail(mt_byte)/
     + ((9*mwa+3)*ma_sizeof(mt_dbl,1,mt_byte)+
     + (mis2+4)*ma_sizeof(mt_int,1,mt_byte))-1
      if(.not.ma_push_get(mt_dbl,lenscr*3*mwa,'bx',l_bx,i_bx))
     + call md_abort('Failed to allocate bx',0)
      if(.not.ma_push_get(mt_dbl,lenscr*3*mwa,'bv',l_bv,i_bv))
     + call md_abort('Failed to allocate bv',0)
      if(.not.ma_push_get(mt_dbl,lenscr*3*mwa,'bf',l_bf,i_bf))
     + call md_abort('Failed to allocate bf',0)
      if(.not.ma_push_get(mt_dbl,lenscr*3,'br',l_br,i_br))
     + call md_abort('Failed to allocate br',0)
      if(.not.ma_push_get(mt_int,lenscr*max(mis2,2),'bi',l_bi,i_bi))
     + call md_abort('Failed to allocate bi',0)
      if(.not.ma_push_get(mt_int,lenscr,'n',l_n,i_n))
     + call md_abort('Failed to allocate n',0)
c
      call argos_space_wttrj(lfntrj,lxw,lvw,lfw,lxs,lvs,lfs,
     + stime,pres,temp,tempw,temps,
     + iwl,int_mb(i_packw),xw,vw,fw,xwcr,isl,int_mb(i_pack),xs,vs,fs,
     + int_mb(i_ipl),lenscr,int_mb(i_bi),dbl_mb(i_bx),dbl_mb(i_bv),
     + dbl_mb(i_bf),dbl_mb(i_br),int_mb(i_bi),dbl_mb(i_bx),dbl_mb(i_bv),
     + dbl_mb(i_bf))
c
      if(.not.ma_pop_stack(l_n))
     + call md_abort('Failed to deallocate n',0)
      if(.not.ma_pop_stack(l_bi))
     + call md_abort('Failed to deallocate bi',0)
      if(.not.ma_pop_stack(l_br))
     + call md_abort('Failed to deallocate br',0)
      if(.not.ma_pop_stack(l_bf))
     + call md_abort('Failed to deallocate bf',0)
      if(.not.ma_pop_stack(l_bv))
     + call md_abort('Failed to deallocate bv',0)
      if(.not.ma_pop_stack(l_bx))
     + call md_abort('Failed to deallocate bx',0)
c
      return
      end
c $Id: argos_space_wrttrj.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function cpmd_qmmm_step(verlet,
     >                                rion,nion,
     >                                rcharge,qcharge,ncharge,
     >                                E,fion,fcharge)
      implicit none
      integer rtdb
      logical verlet
      real*8  rion(3,*)
      integer nion
      real*8  rcharge(3,*),qcharge(*)
      integer ncharge
      real*8  E(*)
      real*8  fion(3,*)
      real*8  fcharge(3,*)

#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
      

*     **** cpmd_qmmm_block ****
      integer nfft3d
      integer npack1
      integer ispin
      integer ne(2),nemax
      integer psi0(2),psi1(2),psi2(2)
      integer dn(2)
      integer Hpsi(2),psir(2)
      integer hml(2),lmd(2)
      integer icount,icount_shift
      real*8  emotion_time_shift,dt,eave,evar,eke
      logical mulliken
      common /cpmd_qmmm_block/ psi0,psi1,psi2,dn,hml,lmd,Hpsi,psir,
     >                         ispin,ne,npack1,nfft3d,nemax,
     >                         icount,icount_shift,
     >                         emotion_time_shift,dt,eave,evar,eke,
     >                         mulliken

      integer ms,ii,jj
      integer taskid,MASTER
      parameter (MASTER=0)

      logical  control_Nose
      external control_Nose

      call Parallel_taskid(taskid)


*     ***** first step using velocity ****
      call inner_loop_qmmm_step(verlet,ispin,ne,
     >             npack1,nfft3d,nemax,
     >             dcpl_mb(psi0(1)),
     >             dcpl_mb(psi1(1)),
     >             dcpl_mb(psi2(1)),
     >             dbl_mb(dn(1)),
     >             1,0,E,
     >             dbl_mb(hml(1)),dbl_mb(lmd(1)),
     >             dcpl_mb(Hpsi(1)),dcpl_mb(psir(1)),
     >             rion,nion,rcharge,qcharge,ncharge,fion,fcharge)

      if (verlet) then 


         eke = eke + E(3)
         icount = icount + 1

         if (taskid.eq.MASTER) then 

           write(6,1310) icount,E(1),E(2),E(3),E(4)
           call util_flush(6)

*          **** write out EMOTION data ****
           eave = E(25)/dble(icount+icount_shift)
           evar = E(26)/dble(icount+icount_shift)
           evar = evar - eave*eave
           if (control_Nose()) then
             write(31,1311) icount*dt + emotion_time_shift,
     >                    e(1),e(2),e(3),e(4),e(5),e(6),
     >                    e(7),e(8),e(9),e(10),
     >                    eave,evar
           else
             write(31,1311) icount*dt + emotion_time_shift,
     >                    e(1),e(2),e(3),e(4),e(5),e(6),
     >                    e(7),e(8),
     >                    eave,evar
           end if
           call util_flush(31)

*          **** write out EIGMOTION data -diagonal hml matrix ****
           if (mulliken) then
           write(32,1311) icount*dt,
     >       (( dbl_mb(hml(1)+ii-1+(ii-1)*ne(1)+(ms-1)*ne(1)*ne(1)), 
     >         ii=1,ne(ms)),ms=1,ispin)
           call util_flush(32)
           end if

*          **** write out HMOTION data - hml matrix ****
           if (mulliken) then
           write(34,1312) icount*dt,ispin
           do ms=1,ispin
             write(34,1313) ms,ne(ms),ne(ms)
             do ii=1,ne(ms)
               write(34,1311) 
     >         (dbl_mb(hml(1)+ii-1+(jj-1)*ne(1)+(ms-1)*ne(1)*ne(1)), 
     >          jj=1,ne(ms))
             end do
           end do
           call util_flush(34)
           end if

         end if


*        **** write xyz data ****
         call xyz_write()
         call MOTION_write((icount*dt))

*        **** write OMOTION data ****
         if (mulliken) call Orb_Write(dcpl_mb(psi1(1)))


      end if

      cpmd_qmmm_step = .true.
      return
 1309 FORMAT(I8,2E19.10,2E14.5,2F9.1)
 1310 FORMAT(I8,2E19.10,2E14.5,F14.2)
 1311 format(100e19.10)
 1312 format(e14.6,i3)
 1313 format(3i4)
      end



c $Id: cpmd_qmmm_step.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_stepcor(A,INEED,G,C,ETOT,NATD,
     &    CONVGE,CONVGG,CONVGGM,
     &    cnvgrd, rtdb, step_number)
c $Id: stpr_stepcor.F 25540 2014-05-01 22:33:27Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
#include "util.fh"
#include "cstprfiles.fh"
      integer rtdb
      integer step_number
      logical dbug
      LOGICAL TRACK,RPATH,BCKSTP,CNVGRD
      LOGICAL SECO, SWSEC, SWFIR
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / OLDES / ELAST,E2PRED
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      COMMON / THRESH / RCONVG,RSTD
      COMMON / SWITCH / SECO, SWSEC, SWFIR
      COMMON / MASS / TOTM, NUMAS
      DIMENSION G(NATD*3)
      DIMENSION C(3,NATD)
      DIMENSION A(INEED)
      DIMENSION IPT(25)
C
      dbug=.false.
C
C     Open input/output files.
C
C     Tape 41 is used to store step parameters PSTEPP.
C
      OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE=FILE41,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP41)
C
C     Tape 44 is used to store previous tracked mode in order to
C     find current hessian eigenvector with maximum overlap.
C
      OPEN (UNIT=ITAP44, FORM='UNFORMATTED', FILE=FILE44,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP44)
C
C     Tape 45 is a temp file used to store HESS, GRAD, COORD
C     and ENERGY during step determination.
C
      OPEN (UNIT=ITAP45, FORM='UNFORMATTED', FILE=FILE45,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP45)
#if defined(OPENCLOSE)
      CLOSE (UNIT=ITAP41, STATUS='KEEP')
      CLOSE (UNIT=ITAP44, STATUS='KEEP')
      CLOSE (UNIT=ITAP45, STATUS='KEEP')
#endif
C
C     Calculate memory offsets.
C
      IPT( 1) = 1
      IPT( 2) = IPT( 1) + NAT3SQ
      IPT( 3) = IPT( 2) + NAT3
      IPT( 4) = IPT( 3) + NAT3
      IPT( 5) = IPT( 4) + NAT3SQ
      IPT( 6) = IPT( 5) + NAT3
      IPT( 7) = IPT( 6) + NAT3
      IPT( 8) = IPT( 7) + NAT3
      IPT( 9) = IPT( 8) + NAT3
      IPT(10) = IPT( 9) + NATOM
      IPT(11) = IPT(10) + NAT3
      IPT(12) = IPT(11) + NAT3TR
      IPT(13) = IPT(12) + NAT3SQ
      IPT(14) = IPT(13) + NAT3SQ
      IPT(15) = IPT(14) + NATOM
      IPT(16) = IPT(15) + NUMAS
      IPT(17) = IPT(16) + NAT3TR
      IPT(18) = IPT(17) + NAT3TR
      IPT(19) = IPT(18) + 3
      IPT(20) = IPT(19) + 9
C
C     Set up atomic masses.
C
      CALL stpr_setmass(A(IPT(16)))
C
C     Get user input: TRUST,NMODE,TRACK,
C     SELECT, RPATH, STD, etc, and equivalence data coming
C     in from NWCHEM to data locations required by STEPPER.
C
      if(dbug) then
         grad_max = dabsmax(natd*3,g)
         write(6,*)' grad max in stepcor ',grad_max
      endif
      CALL stpr_face
     &       ( A(IPT( 1)), A(IPT( 2)), A(IPT( 5)), A(IPT( 9)),
     &       A(IPT(11)), A(IPT(15)), A(IPT(16)),
     &       G, C, ETOT, TRUST, ENERGY, CONVGE, CONVGG, CONVGGM,
     &       NATD, NMODE, TRACK, BCKSTP, RPATH , rtdb, step_number)
      if(dbug) then
         grad_max = dabsmax(natd*3,g)
         write(6,*)' grad max in stepcor ',grad_max
      endif
C
C     If analytical hessian is unavailable form update hessian.
C
      IF(ICALC.EQ.1.AND..NOT.BCKSTP)THEN
        CALL stpr_FORMUP (
     &         A(IPT(1)),  A(IPT(2)),  A(IPT(8)),  A(IPT(5)),
     &         A(IPT(3)), A(IPT(13)) , rtdb)
      ENDIF
C
C     Obtain step.
C
      CALL stpr_driver (
     &       A(IPT( 1)), A(IPT( 2)), A(IPT( 3)), A(IPT( 4)),
     &       A(IPT( 5)), A(IPT( 6)), A(IPT( 7)), A(IPT( 8)),
     &       A(IPT( 9)), A(IPT(10)), A(IPT(11)), A(IPT(12)),
     &       A(IPT(13)), A(IPT(14)), A(IPT(16)), A(IPT(17)),
     &       A(IPT(18)), A(IPT(19)), ENERGY, E2NEW, TRUST,
     &       CONVGE, CONVGG, CONVGGM,
     &       NMODE, TRACK, RPATH, BCKSTP, CNVGRD, rtdb )
C
C     Switch between first and second derivatives.
C
c      IF (SECO.OR.SWFIR.OR.SWSEC) THEN
c        CALL FIRSEC
c      ENDIF
C
C     Put back coordinates into SUPERMOLECULE array:
C
      CALL stpr_putbck  ( A(IPT(5)), C )
C
C     Write out new interatom distances and angles.
C
c      CALL DISTAN
c      CALL ANGLE
C
C
#if defined(OPENCLOSE)
C     Open input/output files.
C
C     Tape 41 is used to store step parameters PSTEPP.
C
      OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE=FILE41,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP41)
C
C     Tape 44 is used to store previous tracked mode in order to
C     find current hessian eigenvector with maximum overlap.
C
      OPEN (UNIT=ITAP44, FORM='UNFORMATTED', FILE=FILE44,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP44)
C
C     Tape 45 is a temp file used to store HESS, GRAD, COORD
C     and ENERGY during step determination.
C
      OPEN (UNIT=ITAP45, FORM='UNFORMATTED', FILE=FILE45,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP45)
#endif
C
C     Close open files and return.
C
      CLOSE (UNIT=ITAP41, STATUS='KEEP')
      CLOSE (UNIT=ITAP44, STATUS='KEEP') 
      CLOSE (UNIT=ITAP45, STATUS='DELETE')
      ELAST = ENERGY
      E2PRED = E2NEW
      RETURN
      END
C> @}

c
c $Id: smd_message.F 19707 2010-10-29 17:59:36Z d3y133 $
c

      block data initial_smd_message_data
      implicit none
#include "smd_message_data.fh"
c     
      data smd_message_n /0/
      data smd_message_string /smd_message_nmax*" "/

      end

      subroutine smd_message_flush(un)

      implicit none
#include "smd_message_data.fh"
#include "stdio.fh"
#include "global.fh"
      integer un
c
      integer i
      do i=1,smd_message_n
         if(ga_nodeid().eq.0)
     >   write(un,*) smd_message_string(i)
         smd_message_string(i) = " "
      end do
      if(smd_message_n.eq.smd_message_nmax) then
        if(ga_nodeid().eq.0) then
        write(luout,*) "end of buffer reached"
        write(luout,*) "messages could be lost"
        end if
      end if
      smd_message_n = 0
      return

      end

      subroutine smd_message_post(buffer)

      implicit none
#include "smd_message_data.fh"
#include "global.fh"
      character*(*) buffer
c
      integer i
      if(smd_message_n.eq.smd_message_nmax) return
      smd_message_n = smd_message_n + 1
      i = smd_message_n
      smd_message_string(i) = buffer 
      return
      end

      subroutine sym_ops_get(geom,numops,symops)
C$Id: sym_ops_get.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
c
      integer i,j,geom,numops
c
      double precision symops(numops*3,4)
c
      do i=1,numops*3
        do j=1,4
          symops(i,j)=sym_ops(i,j,geom)
        enddo
      enddo
c
      return
      end

*> \brief \b DLARRA computes the splitting points with the specified threshold.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLARRA + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlarra.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlarra.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlarra.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLARRA( N, D, E, E2, SPLTOL, TNRM,
*                           NSPLIT, ISPLIT, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, N, NSPLIT
*       DOUBLE PRECISION    SPLTOL, TNRM
*       ..
*       .. Array Arguments ..
*       INTEGER            ISPLIT( * )
*       DOUBLE PRECISION   D( * ), E( * ), E2( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> Compute the splitting points with threshold SPLTOL.
*> DLARRA sets any "small" off-diagonal elements to zero.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix. N > 0.
*> \endverbatim
*>
*> \param[in] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          On entry, the N diagonal elements of the tridiagonal
*>          matrix T.
*> \endverbatim
*>
*> \param[in,out] E
*> \verbatim
*>          E is DOUBLE PRECISION array, dimension (N)
*>          On entry, the first (N-1) entries contain the subdiagonal
*>          elements of the tridiagonal matrix T; E(N) need not be set.
*>          On exit, the entries E( ISPLIT( I ) ), 1 <= I <= NSPLIT,
*>          are set to zero, the other entries of E are untouched.
*> \endverbatim
*>
*> \param[in,out] E2
*> \verbatim
*>          E2 is DOUBLE PRECISION array, dimension (N)
*>          On entry, the first (N-1) entries contain the SQUARES of the
*>          subdiagonal elements of the tridiagonal matrix T;
*>          E2(N) need not be set.
*>          On exit, the entries E2( ISPLIT( I ) ),
*>          1 <= I <= NSPLIT, have been set to zero
*> \endverbatim
*>
*> \param[in] SPLTOL
*> \verbatim
*>          SPLTOL is DOUBLE PRECISION
*>          The threshold for splitting. Two criteria can be used:
*>          SPLTOL<0 : criterion based on absolute off-diagonal value
*>          SPLTOL>0 : criterion that preserves relative accuracy
*> \endverbatim
*>
*> \param[in] TNRM
*> \verbatim
*>          TNRM is DOUBLE PRECISION
*>          The norm of the matrix.
*> \endverbatim
*>
*> \param[out] NSPLIT
*> \verbatim
*>          NSPLIT is INTEGER
*>          The number of blocks T splits into. 1 <= NSPLIT <= N.
*> \endverbatim
*>
*> \param[out] ISPLIT
*> \verbatim
*>          ISPLIT is INTEGER array, dimension (N)
*>          The splitting points, at which T breaks up into blocks.
*>          The first block consists of rows/columns 1 to ISPLIT(1),
*>          the second of rows/columns ISPLIT(1)+1 through ISPLIT(2),
*>          etc., and the NSPLIT-th consists of rows/columns
*>          ISPLIT(NSPLIT-1)+1 through ISPLIT(NSPLIT)=N.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERauxiliary
*
*> \par Contributors:
*  ==================
*>
*> Beresford Parlett, University of California, Berkeley, USA \n
*> Jim Demmel, University of California, Berkeley, USA \n
*> Inderjit Dhillon, University of Texas, Austin, USA \n
*> Osni Marques, LBNL/NERSC, USA \n
*> Christof Voemel, University of California, Berkeley, USA
*
*  =====================================================================
      SUBROUTINE DLARRA( N, D, E, E2, SPLTOL, TNRM,
     $                    NSPLIT, ISPLIT, INFO )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N, NSPLIT
      DOUBLE PRECISION    SPLTOL, TNRM
*     ..
*     .. Array Arguments ..
      INTEGER            ISPLIT( * )
      DOUBLE PRECISION   D( * ), E( * ), E2( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   EABS, TMP1

*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
      INFO = 0

*     Compute splitting points
      NSPLIT = 1
      IF(SPLTOL.LT.ZERO) THEN
*        Criterion based on absolute off-diagonal value
         TMP1 = ABS(SPLTOL)* TNRM
         DO 9 I = 1, N-1
            EABS = ABS( E(I) )
            IF( EABS .LE. TMP1) THEN
               E(I) = ZERO
               E2(I) = ZERO
               ISPLIT( NSPLIT ) = I
               NSPLIT = NSPLIT + 1
            END IF
 9       CONTINUE
      ELSE
*        Criterion that guarantees relative accuracy
         DO 10 I = 1, N-1
            EABS = ABS( E(I) )
            IF( EABS .LE. SPLTOL * SQRT(ABS(D(I)))*SQRT(ABS(D(I+1))) )
     $      THEN
               E(I) = ZERO
               E2(I) = ZERO
               ISPLIT( NSPLIT ) = I
               NSPLIT = NSPLIT + 1
            END IF
 10      CONTINUE
      ENDIF
      ISPLIT( NSPLIT ) = N

      RETURN
*
*     End of DLARRA
*
      END
c $Id: dlarra.f 24343 2013-06-22 05:35:15Z d3y133 $

C $Id: rel_2e4cd_sf.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
c:tex-\subsection{rel\_2e4cd\_sf}
c:tex-Wrapper routine for evaluation of the two-electron four-center
c:tex-spin-free relativistically-corrected derivative integrals. This
c:tex-only includes contributions from the Coulomb operator. Contributions 
c:tex-from the Gaunt operator could be added at a later stage.
c:tex-
c:tex-\noindent Author: K. G. Dyall
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine rel_2e4cd_sf (
     &    Axyz,zeta_A,coefL_A,coefS_A,n_prim_A,n_cont_A,l_A,i_cent_A,
     &    Bxyz,zeta_B,coefL_B,coefS_B,n_prim_B,n_cont_B,l_B,i_cent_B,
     &    Cxyz,zeta_C,coefL_C,coefS_C,n_prim_C,n_cont_C,l_C,i_cent_C,
     &    Dxyz,zeta_D,coefL_D,coefS_D,n_prim_D,n_cont_D,l_D,i_cent_D,
     &    eri,leri,canAB,canCD,canPQ,DryRun,scr,lscr,
     &    AB_rel,CD_rel,SS_one_cent,do_SSSS,ibug)
c:tex-\end{verbatim}
      implicit none
#include "stdio.fh"
#include "rel_consts.fh"
#include "errquit.fh"
*
c:tex-{\it Argument list:}
c:tex-\begin{verbatim}
      integer n_prim_A ! [input] num. prims in shell A
      integer n_cont_A ! [input] num general conts in shell A
      integer l_A      ! [input] angular momentum of shell A
      integer i_cent_A ! [input] lexical atom index for shell A
      integer n_prim_B ! [input] num. prims in shell B
      integer n_cont_B ! [input] num general conts in shell B
      integer l_B      ! [input] angular momentum of shell B 
      integer i_cent_B ! [input] lexical atom index for shell B
      integer n_prim_C ! [input] num. prims in shell C
      integer n_cont_C ! [input] num general conts in shell C
      integer l_C      ! [input] angular momentum of shell C 
      integer i_cent_C ! [input] lexical atom index for shell C
      integer n_prim_D ! [input] num. prims in shell D
      integer n_cont_D ! [input] num general conts in shell D
      integer l_D      ! [input] angular momentum of shell D 
      integer i_cent_D ! [input] lexical atom index for shell D
      integer leri     ! length of integral buffer
      integer lscr     ! length of scratch array
      integer ibug     ! [input] debug variable
      double precision Axyz(3)          ! [input] position of center A
      double precision zeta_A(n_prim_A) ! [input] exponents of shell A
      double precision coefL_A(n_prim_A,n_cont_A) ! [input] A large coeffs
      double precision coefS_A(n_prim_A,n_cont_A) ! [input] A small coeffs
      double precision Bxyz(3)          ! [input] position of center B
      double precision zeta_B(n_prim_B) ! [input] exponents of shell B 
      double precision coefL_B(n_prim_B,n_cont_B)  ! [input] B large coeffs
      double precision coefS_B(n_prim_B,n_cont_B)  ! [input] B small coeffs
      double precision Cxyz(3)          ! [input] position of center C
      double precision zeta_C(n_prim_C) ! [input] exponents of shell C 
      double precision coefL_C(n_prim_C,n_cont_C)  ! [input] C large coeffs
      double precision coefS_C(n_prim_C,n_cont_C)  ! [input] C small coeffs
      double precision Dxyz(3)          ! [input] position of center D
      double precision zeta_D(n_prim_D) ! [input] exponents of shell D 
      double precision coefL_D(n_prim_D,n_cont_D)  ! [input] D large coeffs
      double precision coefS_D(n_prim_D,n_cont_D)  ! [input] D small coeffs
      double precision scr(lscr)    ! [scratch] scratch buffer
      double precision eri(leri,12)  ! [output] relativistic integrals
      logical canAB   ! [input] compute only canonical ints (false only)
      logical canCD   ! [input] compute only canonical ints (false only)
      logical canPQ   ! [input] compute only canonical ints (false only)
      logical DryRun  ! [input] true means only compute required memory
      logical AB_rel  ! [input] relativistic correction for A and B shells
      logical CD_rel  ! [input] relativistic correction for C and D shells
      logical SS_one_cent  ! [input] do relativistic correction only if
                           ! SS density is one-centre.
      logical do_SSSS ! [input] logical to do SSSS contributions
c:tex-\end{verbatim}
c:tex-
c:tex-{\it Subroutines called:} hf2, rel_LLSS, rel_SSLL, rel_SSSS
*
      integer iscr      ! address of free space in scr
      integer nscr      ! length of free space in scr
      integer neri      ! number of integrals per derivative
      integer neri12    ! number of derivative integrals
      integer max_mem   ! maximum memory used
      integer i         ! do loop index
      integer ibuf      ! integral buffer pointer
      logical do_CD     ! do relativistic CD corrections
      logical do_AB     ! do relativistic AB corrections
*
      max_mem = 0
      neri = n_cont_A*(l_A+1)*(l_A+2)/2
      neri = neri*n_cont_B*(l_B+1)*(l_B+2)/2
      neri = neri*n_cont_C*(l_C+1)*(l_C+2)/2
      neri = neri*n_cont_D*(l_D+1)*(l_D+2)/2
      if ((neri .gt. leri) .and. (.not.DryRun)) call errquit 
     &    ('rel_2e4cd_sf: eri buffer too small ',99, MEM_ERR)
      neri12 = neri*12
*
*   Do the LLLL integrals
*
      nscr = lscr
      call hf2d(
     &    Axyz,zeta_A,coefL_A,n_prim_A,n_cont_A,l_A,i_cent_A,
     &    Bxyz,zeta_B,coefL_B,n_prim_B,n_cont_B,l_B,i_cent_B,
     &    Cxyz,zeta_C,coefL_C,n_prim_C,n_cont_C,l_C,i_cent_C,
     &    Dxyz,zeta_D,coefL_D,n_prim_D,n_cont_D,l_D,i_cent_D,
     &    eri,leri,canAB,canCD,canPQ,DryRun,scr,nscr)
      if (DryRun) max_mem = max(max_mem, nscr)
*
*  .. then the LLSS integrals
*
      iscr = neri12+1
      do_CD = CD_rel
      if (SS_one_cent) do_CD = do_CD .and. (i_cent_C .eq. i_cent_D)
      if (do_CD) then
        nscr = lscr-neri12
        call rel_LLSSd (
     &      Axyz,zeta_A,coefL_A,n_prim_A,n_cont_A,l_A,i_cent_A,
     &      Bxyz,zeta_B,coefL_B,n_prim_B,n_cont_B,l_B,i_cent_B,
     &      Cxyz,zeta_C,coefS_C,n_prim_C,n_cont_C,l_C,i_cent_C,
     &      Dxyz,zeta_D,coefS_D,n_prim_D,n_cont_D,l_D,i_cent_D,
     &      scr,neri,canAB,canCD,canPQ,
     &      DryRun,scr(iscr),nscr,ibug,1)
        if (DryRun) then
          max_mem = max(max_mem, nscr)
        else
          ibuf = 1
          do i = 1,12
            call daxpy (neri,qalsq,scr(ibuf),1,eri(1,i),1)
            ibuf = ibuf+neri
          end do
        end if
      end if
*
*  .. and the SSLL integrals
*
      do_AB = AB_rel
      if (SS_one_cent) do_AB = do_AB .and. (i_cent_A .eq. i_cent_B)
      if (do_AB) then
        nscr = lscr-neri12
        call rel_SSLLd (
     &      Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A,i_cent_A,
     &      Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B,i_cent_B,
     &      Cxyz,zeta_C,coefL_C,n_prim_C,n_cont_C,l_C,i_cent_C,
     &      Dxyz,zeta_D,coefL_D,n_prim_D,n_cont_D,l_D,i_cent_D,
     &      scr,neri,canAB,canCD,canPQ,
     &      DryRun,scr(iscr),nscr,ibug,1)
        if (DryRun) then
          max_mem = max(max_mem, nscr)
        else
          ibuf = 1
          do i = 1,12
            call daxpy (neri,qalsq,scr(ibuf),1,eri(1,i),1)
            ibuf = ibuf+neri
          end do
        end if
      end if
*
*  .. and finally the SSSS integrals
*
      if (do_AB .and. do_CD .and. do_SSSS) then
        nscr = lscr-neri12
        call rel_SSSSd (
     &      Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A,i_cent_A,
     &      Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B,i_cent_B,
     &      Cxyz,zeta_C,coefS_C,n_prim_C,n_cont_C,l_C,i_cent_C,
     &      Dxyz,zeta_D,coefS_D,n_prim_D,n_cont_D,l_D,i_cent_D,
     &      scr,neri,canAB,canCD,canPQ,
     &      DryRun,scr(iscr),nscr,ibug,1,1)
        if (DryRun) then
          max_mem = max(max_mem, nscr)
        else
          ibuf = 1
          do i = 1,12
            call daxpy (neri,salf,scr(ibuf),1,eri(1,i),1)
            ibuf = ibuf+neri
          end do
        end if
      end if
*
      if (DryRun) lscr = max_mem+neri
*
      return
      end

      SUBROUTINE cr_eomccsd_t_N2_3(d_a,k_a_offset,d_b,k_b_offset,a_c,t_p
     &4b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b)
C     $Id: cr_eomccsd_t_n2_3.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vxt + = -1 * P( 9 ) * Sum ( p7 ) * t ( p4 p7 h1 h2 )_t * i1 ( p5 p6 h3 p7 )_vx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p4b_1
      INTEGER p7b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER h3b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO p4b = noab+1,noab+nvab
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = 1,noab
      skipped = .true.
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) skipped = .false.
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,ieor(irrep_x,irrep_t))) TH
     &EN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+p6b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cr_eomccsd_t_N2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p4b,p7b,h1b,h2b,p4b_1,p7b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(p5b,p6b,h3b,p7b,p5b_2,p6b_2,h3b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1)
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cr_eomccsd_t_N2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cr_eomccsd_t_N2_3',2,MA_ERR)
      IF ((p7b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p7b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p4b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p7b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cr_eomccsd_t_N2_3',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cr_eomccsd_t_N2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cr_eomccsd_t_N2_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (h3b_2 - 1 + noab * (p6b_2 - noab - 1 + nvab 
     &* (p5b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h3b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cr_eomccsd_t_N2_3',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cr_eomccsd_t_N2_3',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cr_eomccsd_t_N2_3',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,3,2,5,4,1,-1.0d0)
      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,3,2,1,5,4,-1.0d0)
      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,3,2,5,1,4,1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,6,2,5,4,1,1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,6,2,1,5,4,1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,6,2,5,1,4,-1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,2,6,5,4,1,-1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,2,6,1,5,4,-1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
     &mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_mb(k_range+h2b-1),int_
     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),3,2,6,5,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cr_eomccsd_t_N2_3',
     &9,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

#ifndef __LINE__
#define __LINE__ 0
#endif
      subroutine tce_input(rtdb)
c
c $Id: tce_input.F 25605 2014-05-13 18:06:39Z bhas990 $
c
c Input parser for TCE module for various many-electron theories.
c Also sets default values for input parameters.
c Modified from tddft/tddft_input.F by So Hirata Oct, 2002.
c
c     TCE
c        [(DFT||HF||SCF) default HF]
c        [FREEZE [[core] (atomic || <integer nfzc default 0>)] \
c                 [virtual <integer nfzv default 0>]]
c        [(LCCD||CCD||CCSD||LCCSD||CCSDT||CCSDTQ|| \ 
c          CCSD(T)||CCSD[T]||QCISD||CISD||CISDT||CISDTQ|| \
c          MBPT2||MBPT3||MBPT4||MP2||MP3||MP4|| \
c          CR-CCSD(T)||CR-CCSD[T]||LR-CCSD(T)||LR-CCSD(TQ)||CCSD(2)_T||CCSD(2)||
c          CCSDT(2)_Q) default CCSD]
c        [THRESH <double thresh default 1e-6>]
c        [MAXITER <integer maxiter default 100>]
c        [PRINT (none||low||medium||high||debug)]
c        [IO (fortran||eaf||ga||sf||replicated||dra||ga_eaf) default ga]
c        [DIIS <integer diis default 5>]
c        [EOMSOL <integer default 1 >]
c        [DIIS2 <integer diis default 5>]
c        [DIIS3 <integer diis default 5>]
c        [NROOTS <integer nroots default 0>]
c        [TARGET <integer target default 1>]
c        [TARGETSYM <character targetsym default 'none'>]
c        [SYMMETRY]
c        [DIPOLE]
c        [TILESIZE <no default (automatically adjusted)>]
c        [FRAGMENT <default -1 (off)>]
c        [(NO)FOCK <logical recompf default .true.>]
c        [ACTIVE_OA <default 0>]
c        [ACTIVE_OB <default 0>]
c        [ACTIVE_VA <default 0>]
c        [ACTIVE_VB <default 0>]
c        [T3A_LVL   <default 0>]
c     END
c
c     TASK TCE ENERGY
c
c     ... or ...
c
c     UCCSDT or UCC or UCCSD(T) etc.
c        [(DFT||HF||SCF) default HF]
c        [FREEZE [[core] (atomic || <integer nfzc default 0>)] \
c                 [virtual <integer nfzv default 0>]]
c        [THRESH <double thresh default 1e-6>]
c        [MAXITER <integer maxiter default 100>]
c        [PRINT (none||low||medium||high||debug)]
c        [IO (fortran||c||ga||sf||replicated) default ga]
c        [DIIS <integer diis default 5>]
c        [NROOTS <integer nroots default 0>]
c        [TARGET <integer target default 1>]
c        [TARGETSYM <character targetsym default 'none'>]
c        [SYMMETRY]
c        [DIPOLE]
c        [TILESIZE <no default (automatically adjusted)>]
c        [FRAGMENT <default -1 (off)>]
c        [(NO)FOCK <logical recompf default .true.>]
c        [ACTIVE_OA <default 0>]
c        [ACTIVE_OB <default 0>]
c        [ACTIVE_VA <default 0>]
c        [ACTIVE_VB <default 0>]
c     END
c
c     TASK UCCSDT ENERGY
c
c     ... etc.
c     
      implicit none
#include "inp.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "stdio.fh"
      integer rtdb
      character*20 test
      integer maxiter
      character*10 model
      character*10 model2e
      character*10 module
      double precision thresh
      double precision maxdiff ! new
      character*10 ioalgchar
      integer ioalg
      integer reference
      integer diis,diis2,diis3
      integer eomsol
c --- level shift --
      double precision zlshift,zlshiftl,zlshift2(2),zlshift3(2)
c ------------------
      integer nroots
      integer target
      integer tilesize
      integer fragment
      character*4 targetsym
      logical symmetry
      logical left
c --- density matrix    
      logical idens
      character*256 file_densmat
c<-d3p975
      integer multipole
      logical recompf
      character*10 perturbative
      character*10 ccsd_var 
      integer oactive(2)
      integer vactive(2)
      integer numact
c --- ccsd_act/eomccsd_act ---
      integer uact,oact
      double precision emin_act,emax_act
c --- 4 index transform. ---
      integer maxs,ichopx,i4im,idiskx
c --- EOM solver
      integer hbard

c --- TCE_CUDA
      integer icuda
ckbn --- EA/IPCCSD
#ifdef EACCSD
      logical eaccsd
#endif
#ifdef IPCCSD
      logical ipccsd
#endif

c
c -------------------------------------
c What input block are we dealing with?
c -------------------------------------
c
      if (.not.rtdb_cget(rtdb,'tce:module',1,module))
     1  call errquit('tce_input: failed reading from rtdb',0,
     2  RTDB_ERR)
c
c ------------------
c Set default values
c ------------------
c
c     DFT, HF, or SCF (reference wavefunction)
c
      reference=1
      if (.not.rtdb_put(rtdb,'tce:reference',mt_int,1,reference))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     FREEZE (frozen cores/virtuals)
c
c     no action is taken
c
c     MODEL (the name of CC model requested)
c
c     no action is taken
c
c     THRESH (convergence threshold for Davidson iteration)
c
      thresh=1.0d-7
      if (.not.rtdb_put(rtdb,'tce:thresh',mt_dbl,1,thresh))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     LEVEL SHIFT (for singles and doubles)
c
      zlshift=0.0d0
      if (.not.rtdb_put(rtdb,'tce:zlshift',mt_dbl,1,zlshift))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      zlshiftl=0.0d0
      if (.not.rtdb_put(rtdb,'tce:zlshiftl',mt_dbl,1,zlshiftl))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      zlshift2(1)=0.0d0
      zlshift2(2)=0.0d0
      if (.not.rtdb_put(rtdb,'tce:zlshift2',mt_dbl,2,zlshift2))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      zlshift3(1)=0.0d0
      zlshift3(2)=0.0d0
      if (.not.rtdb_put(rtdb,'tce:zlshift3',mt_dbl,2,zlshift3))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     MAXITER (the maximum number of Davidson iterations)
c
      maxiter=100
      if (.not.rtdb_put(rtdb,'tce:maxiter',mt_int,1,maxiter))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     IO (I/O method, 0 = Fortran Direct Access, 
c                     1 = C Low-Level I/O,
c                     2 = GA Library,
c                     3 = SF library,
c                     4 = Replicated C Low-Level I/O)
c
      ioalg=2
      if (.not.rtdb_put(rtdb,'tce:ioalg',mt_int,1,ioalg))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     DIIS (the vector space size in DIIS)
c
      diis=5
      if (.not.rtdb_put(rtdb,'tce:diis',mt_int,1,diis))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      diis2=5
      if (.not.rtdb_put(rtdb,'tce:diis2',mt_int,1,diis2))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      diis3=5
      if (.not.rtdb_put(rtdb,'tce:diis3',mt_int,1,diis3))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     EOMCC SOLVER
c
      eomsol=1
      if (.not.rtdb_put(rtdb,'tce:eoms',mt_int,1,eomsol))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     DIMENSION OF THE EOM ITERATIVE SPACE
c
      hbard=500
      if (.not.rtdb_put(rtdb,'tce:hbard',mt_int,1,hbard))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     NROOTS (the number of excited state roots)
c
      nroots=0
      if (.not.rtdb_put(rtdb,'tce:nroots',mt_int,1,nroots))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     2e STORAGE
c
        model2e='2espin'
      if (.not.rtdb_cput(rtdb,'tce:model2e',1,model2e))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c 4ind. transfromation
c
       maxs=30
      if (.not.rtdb_put(rtdb,'tce:maxs',mt_int,1,maxs))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR) 
c
       ichopx=1
      if (.not.rtdb_put(rtdb,'tce:ichopx',mt_int,1,ichopx))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
       i4im=1
      if (.not.rtdb_put(rtdb,'tce:i4im',mt_int,1,i4im))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
      idiskx=0
      if (.not.rtdb_put(rtdb,'tce:idiskx',mt_int,1,idiskx))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     TARGET (the target excited state for, e.g., geometry optimization)
c
      target=1
      if (.not.rtdb_put(rtdb,'tce:target',mt_int,1,target))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     TARGETSYM (the irrep of the target excited state)
c
      targetsym='none'
      if (.not.rtdb_cput(rtdb,'tce:targetsym',1,targetsym))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     SYMMETRY (restricts the roots to have the TARGETSYM irrep)
c
      symmetry=.false.
      if (.not.rtdb_put(rtdb,'tce:symmetry',mt_log,1,symmetry))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     IDENS (one particle reduced density matrix)
c
      idens=.false.
      if (.not.rtdb_put(rtdb,'tce:densmat',mt_log,1,idens))
     1   call errquit('tce_input: failed writing to rtdb',0,
     1   rtdb_err)
c
c     DIPOLE (dipole moments & dipole transition moments)
c
      left=.false.
      if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     MULTIPOLE LMAX (multipole moments highest angular momentum)
c
      multipole=0
      if (.not.rtdb_put(rtdb,'tce:multipole',mt_int,1,multipole))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     FRAGMENT (fragment MO calculations)
c
      fragment=-1
      if (.not.rtdb_put(rtdb,'tce:fragment',mt_int,1,fragment))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     (NO)FOCK (recompute fock for, e.g., DFT, ROHF refs)
c
      recompf=.true.
      if (.not.rtdb_put(rtdb,'tce:recompf',mt_log,1,recompf))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     ACTIVE_OA,OB (Number of active occupied orbitals)
c
      oactive(1)=0
      if (.not.rtdb_put(rtdb,'tce:active_oa',mt_int,1,oactive(1)))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      oactive(2)=0
      if (.not.rtdb_put(rtdb,'tce:active_ob',mt_int,1,oactive(2)))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c     ccsd_act/eomccsd_act
c
      oact=0
      if (.not.rtdb_put(rtdb,'tce:oact',mt_int,1,oact))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      uact=0
      if (.not.rtdb_put(rtdb,'tce:uact',mt_int,1,uact))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
      emin_act=0.0d0
      if (.not.rtdb_put(rtdb,'tce:eactmin',mt_dbl,1,emin_act))
     1  call errquit('tce_input: rtdb eactmin problem',0,
     2  RTDB_ERR)
      emax_act=0.0d0
      if (.not.rtdb_put(rtdb,'tce:eactmax',mt_dbl,1,emax_act))
     1  call errquit('tce_input: rtdb eactmax problem',0,
     2  RTDB_ERR)
c
c     ACTIVE_VA,VB (Number of active virtual orbitals)
c
      vactive(1)=0
      if (.not.rtdb_put(rtdb,'tce:active_va',mt_int,1,vactive(1)))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
      vactive(2)=0
      if (.not.rtdb_put(rtdb,'tce:active_vb',mt_int,1,vactive(2)))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c    ACTIVE EXCITATION LEVEL (number of active orbitals in T3)
c
      numact=0
      if (.not.rtdb_put(rtdb,'tce:act_excit_lvl',mt_int,1,numact))
     1  call errquit('tce_input: failed writing to rtdb',0,
     2  RTDB_ERR)
c
c ----------
c Read input
c ----------
c
 10   if (.not. inp_read()) 
     1  call errquit('tce_input: failed reading input',0,
     2  RTDB_ERR)
      if (.not. inp_a(test)) 
     1  call errquit('tce_input: failed reading keyword',0,
     2  RTDB_ERR)
c
c     DFT, HF, or SCF (reference wavefunction)
c
      if (inp_compare(.false.,test,'dft')) then
        reference=0
        if (.not.rtdb_put(rtdb,'tce:reference',mt_int,1,reference))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'hf')) then
        reference=1
        if (.not.rtdb_put(rtdb,'tce:reference',mt_int,1,reference))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'scf')) then
        reference=1
        if (.not.rtdb_put(rtdb,'tce:reference',mt_int,1,reference))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     FREEZE (frozen cores/virtuals)
c
      else if (inp_compare(.false.,test,'freeze')) then
        call freeze_input(rtdb,'tce')
c
c     STORAGE OF 2-e INTEGRALS
c
      else if (inp_compare(.false.,test,'2eorb')) then
        if (module.eq.'tce') then
        model2e='2eorb'
        if (.not.rtdb_cput(rtdb,'tce:model2e',1,model2e))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
c
c     MODEL (the name of theory requested)
c
      else if (inp_compare(.false.,test,'multi')) then
        if (module.eq.'tce') then
        model='multi'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
          call errquit('tce_input: multiple theory inputs',0,
     2    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'eionly')) then
        if (module.eq.'tce') then
        model='eionly'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
          call errquit('tce_input: multiple theory inputs',0,
     2    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccd')) then
        if (module.eq.'tce') then
        model='ccd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     2  INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'lccd')) then
        if (module.eq.'tce') then
        model='lccd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsd')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
c ccsd_act/eomccsd_act
      else if (inp_compare(.false.,test,'ccsd_act')) then
        if (module.eq.'tce') then
        model='ccsd_act'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'lccsd')) then
        if (module.eq.'tce') then
        model='lccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'lccsd(t)')) then
        if (module.eq.'tce') then
        model='lccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'cr-lccsd(t)')) then
        if (module.eq.'tce') then
        model='lccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='cr_(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
c ccsd_act/eomccsd_act
      else if (inp_compare(.false.,test,'crsd(t)ac')) then
        if (module.eq.'tce') then
        model='ccsd_act'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='cr_(t)a'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsdta')) then
        if (module.eq.'tce') then
        model='ccsdta'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsdt')) then
        if (module.eq.'tce') then
        model='ccsdt'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsdtq')) then
        if (module.eq.'tce') then
        model='ccsdtq'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'cc2')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        ccsd_var='cc2'
        if (.not.rtdb_cput(rtdb,'tce:ccsdvar',1,ccsd_var))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'lr-ccsd')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        ccsd_var='lr-ccsd'
        if (.not.rtdb_cput(rtdb,'tce:ccsdvar',1,ccsd_var))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsd(t)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsd[t]')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='[t]'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'qcisd(t)')) then
        if (module.eq.'tce') then
        model='qcisd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'cr-qcisd(t)')) then
        if (module.eq.'tce') then
        model='qcisd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='cr_(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
c
c
c
      else if (inp_compare(.false.,test,'lambda-ccsd(t)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='lambda(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
c      else if (inp_compare(.false.,test,'lambda-ccsd[t]')) then
c        if (module.eq.'tce') then
c        model='ccsd'
c        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
c     1    call errquit('tce_input: failed writing to rtdb',0,
c     2    RTDB_ERR)
c        perturbative='lambda[t]'
c        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
c     1    call errquit('tce_input: failed writing to rtdb',0,
c     2    RTDB_ERR)
c        left=.true.
c        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
c     1    call errquit('tce_input: failed writing to rtdb',0,
c     2    RTDB_ERR)
c        else
c        call errquit('tce_input: multiple theory inputs',0,
c     1    INPUT_ERR)
c        endif
c
c
c
      else if (inp_compare(.false.,test,'cr-ccsd(t)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='cr_(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'lr-ccsd(t)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='lr_(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'creomsd(t)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='creom_(t)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
c ccsd_act/eomccsd-act
      else if (inp_compare(.false.,test,'creom(t)ac')) then
        if (module.eq.'tce') then
        model='ccsd_act'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='creom(t)a'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'r-creom1(t)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='emb1'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'r-creom2(t)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='emb2'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'lr-ccsd(tq)-1')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='lr_(tq1)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'lr-ccsd(tq)-1p')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='lr_(tq1p)'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'cr-ccsd[t]')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='cr_[t]'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsd(2)_t')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='2_t'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsd(2)')) then
        if (module.eq.'tce') then
        model='ccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='2_tq'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'ccsdt(2)_q')) then
        if (module.eq.'tce') then
        model='ccsdt'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        perturbative='2_q'
        if (.not.rtdb_cput(rtdb,'tce:perturbative',1,perturbative))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'qcisd')) then
        if (module.eq.'tce') then
        model='qcisd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'cis')) then
        if (module.eq.'tce') then
           model='cis'
           if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1     call errquit('tce_input: failed writing to rtdb',0,
     1     rtdb_err)
        else
           call errquit('tce_input: multiple theory inputs',0,
     1     input_err)
        end if
      else if (inp_compare(.false.,test,'cisd')) then
        if (module.eq.'tce') then
        model='cisd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'cisdt')) then
        if (module.eq.'tce') then
        model='cisdt'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'cisdtq')) then
        if (module.eq.'tce') then
        model='cisdtq'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mbpt2')) then
        if (module.eq.'tce') then
        model='mbpt2'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mbpt3')) then
        if (module.eq.'tce') then
        model='mbpt3'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mbpt4')) then
        if (module.eq.'tce') then
        model='mbpt4'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mbpt4(sdq)')) then
        if (module.eq.'tce') then
        model='mbpt4sdq'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mbpt4sdq(t)')) then
        if (module.eq.'tce') then
        model='mbpt4sdq_t'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mp2')) then
        if (module.eq.'tce') then
        model='mbpt2'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mp3')) then
        if (module.eq.'tce') then
        model='mbpt3'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mp4sdq')) then
        if (module.eq.'tce') then
        model='mbpt4sdq'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1       INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mp4sdq(t)')) then
        if (module.eq.'tce') then
        model='mbpt4sdq_t'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1       INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mp4')) then
        if (module.eq.'tce') then
        model='mbpt4'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif

#ifdef MRCC_METHODS
ckbn mrcc-r-1 -3
c     BWCCSD
      else if (inp_compare(.false.,test,'bwccsd')) then
        if (module.eq.'tce') then
        model='bwccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        if (.not.rtdb_put(rtdb,'tce:mrcc',mt_int,1,1))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
      else if (inp_compare(.false.,test,'mkccsd')) then
c     MkCCSD
        if (module.eq.'tce') then
        model='mkccsd'
        if (.not.rtdb_cput(rtdb,'tce:model',1,model))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        if (.not.rtdb_put(rtdb,'tce:mrcc',mt_int,1,1))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        else
        call errquit('tce_input: multiple theory inputs',0,
     1    INPUT_ERR)
        endif
#endif

c
c     THRESH (convergence threshold for Davidson iteration)
c
      else if (inp_compare(.false.,test,'thresh')) then
        if (.not.inp_f(thresh)) then
          write(LuOut,*) 'tce_input: thresh value not found; ',
     1      'default value of 1e-6 will be used'
          thresh=1.0d-6
        endif
        if (.not.rtdb_put(rtdb,'tce:thresh',mt_dbl,1,thresh))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     LEVEL SHIFT
c
      else if (inp_compare(.false.,test,'lshift')) then
        if (.not.inp_f(zlshift)) then
          write(LuOut,*) 'tce_input: lshift value not found; ',
     1      'default value of 0.0d0 will be used'
          zlshift=0.0d0
        endif
        if (.not.rtdb_put(rtdb,'tce:zlshift',mt_dbl,1,zlshift))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'lshiftl')) then
        if (.not.inp_f(zlshiftl)) then
          write(LuOut,*) 'tce_input: lshiftl value not found; ',
     1      'default value of 0.0d0 will be used'
          zlshiftl=0.0d0
        endif
        if (.not.rtdb_put(rtdb,'tce:zlshiftl',mt_dbl,1,zlshiftl))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'lshift2')) then
        if (.not.inp_f(zlshift2(1))) then
          write(LuOut,*) 'tce_input: lshift2(1) value not found; ',
     1      'default value of 0.0d0 will be used'
          zlshift2(1)=0.0d0
        endif
        if (.not.inp_f(zlshift2(2))) then
          write(LuOut,*) 'tce_input: lshift2(2) value not found; ',
     1      'default value of 0.0d0 will be used'
          zlshift2(2)=0.0d0
        endif
        if (.not.rtdb_put(rtdb,'tce:zlshift2',mt_dbl,2,zlshift2))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'lshift3')) then
        if (.not.inp_f(zlshift3(1))) then
          write(LuOut,*) 'tce_input: lshift3(1) value not found; ',
     1      'default value of 0.0d0 will be used'
          zlshift3(1)=0.0d0
        endif
        if (.not.inp_f(zlshift3(2))) then
          write(LuOut,*) 'tce_input: lshift3(2) value not found; ',
     1      'default value of 0.0d0 will be used'
          zlshift3(2)=0.0d0
        endif
        if (.not.rtdb_put(rtdb,'tce:zlshift3',mt_dbl,2,zlshift3))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)

c
c      TCE_CUDA Number of CUDA devices per node
c
      else if (inp_compare(.false.,test,'cuda')) then
        if (.not.inp_i(icuda))
     1    call errquit('tce_input: no icuda',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:cuda',mt_int,1,icuda))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)

c
c     MAXITER (the maximum number of Davidson iterations)
c
      else if (inp_compare(.false.,test,'maxiter')) then
        if (.not.inp_i(maxiter)) then
          write(LuOut,*) 'tce_input: maxiter value not found; ',
     1      'default value of 100 will be used'
          maxiter=100
        endif
        if (.not.rtdb_put(rtdb,'tce:maxiter',mt_int,1,maxiter))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     IOALGORITHM (I/O method)
c
      else if (inp_compare(.false.,test,'io')) then
        if (.not.inp_a(ioalgchar)) then
          write(LuOut,*) 'tce_input: ioalgorithm value not found; ',
     1      'default GA fully incore algorithm will be used'
          ioalg=2
        else
          if (ioalgchar.eq.'fortran') then
            ioalg=0
          else if (ioalgchar.eq.'eaf') then
            ioalg=1
          else if (ioalgchar.eq.'ga') then
            ioalg=2
          else if (ioalgchar.eq.'sf') then
            ioalg=3
          else if (ioalgchar.eq.'replicated') then
            ioalg=4
          else if (ioalgchar.eq.'dra') then
            ioalg=5
          else if (ioalgchar.eq.'ga_eaf') then
            ioalg=6
          endif
        endif
        if (.not.rtdb_put(rtdb,'tce:ioalg',mt_int,1,ioalg))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c EOMCC SOLVER
c
      else if (inp_compare(.false.,test,'eomsol')) then
        if (.not.inp_i(eomsol)) then
          write(LuOut,*) 'tce_input: eomsol value not found; ',
     1      'default value of 1 will be used'
          eomsol=1
        endif
        if (.not.rtdb_put(rtdb,'tce:eoms',mt_int,1,eomsol))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     DIIS (the vector space size in DIIS)
c
      else if (inp_compare(.false.,test,'diis')) then
        if (.not.inp_i(diis)) then
          write(LuOut,*) 'tce_input: diis value not found; ',
     1      'default value of 5 will be used'
          diis=5
        endif
        if (.not.rtdb_put(rtdb,'tce:diis',mt_int,1,diis))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'diis2')) then
        if (.not.inp_i(diis2)) then
          write(LuOut,*) 'tce_input: diis2 value not found; ',
     1      'default value of 5 will be used'
          diis2=5
        endif
        if (.not.rtdb_put(rtdb,'tce:diis2',mt_int,1,diis2))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'diis3')) then
        if (.not.inp_i(diis3)) then
          write(LuOut,*) 'tce_input: diis3 value not found; ',
     1      'default value of 5 will be used'
          diis3=5
        endif
        if (.not.rtdb_put(rtdb,'tce:diis3',mt_int,1,diis3))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c DIMENSION OF EOMCC ITERATIVE SPACE
c
      else if (inp_compare(.false.,test,'hbard')) then
        if (.not.inp_i(hbard)) then
          write(LuOut,*) 'tce_input: hbard value not found; ',
     1      'default value of 500 will be used'
          hbard=500
        endif
        if (.not.rtdb_put(rtdb,'tce:hbard',mt_int,1,hbard))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     NROOTS (the number of excited state root)
c
      else if (inp_compare(.false.,test,'nroots')) then
        if (.not.inp_i(nroots)) then
          write(LuOut,*) 'tce_input: nroots value not found; ',
     1      'default value of 0 will be used'
          nroots=0
        endif
        if (.not.rtdb_put(rtdb,'tce:nroots',mt_int,1,nroots))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
ckbn EACCSD
#ifdef EACCSD
      else if (inp_compare(.false.,test,'eaccsd')) then
        eaccsd=.true.
        if (.not.rtdb_put(rtdb,'tce:eaccsd',mt_log,1,eaccsd))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
#endif
c
ckbn IPCCSD
#ifdef IPCCSD
      else if (inp_compare(.false.,test,'ipccsd')) then
        ipccsd=.true.
        if (.not.rtdb_put(rtdb,'tce:ipccsd',mt_log,1,ipccsd))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
#endif
c
c     MAXDIFF (for EOM codes)
c
      else if (inp_compare(.false.,test,'maxdiff')) then
        if (.not.inp_f(maxdiff)) then
c          write(LuOut,*) 'tce_input: maxdiff value not found; ',
c     1      'default value of 1e-6 will be used'
          maxdiff=0.5d0
        endif
        if (.not.rtdb_put(rtdb,'tce:maxdiff',mt_dbl,1,maxdiff))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     2e STORAGE
c
      else if (inp_compare(.false.,test,'attilesize')) then
        if (.not.inp_i(maxs)) then
          write(LuOut,*) 'tce_input: attilesize value not found; ',
     1      'default value of 30 will be used'
          maxs=30
        endif
        if (.not.rtdb_put(rtdb,'tce:maxs',mt_int,1,maxs))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
      else if (inp_compare(.false.,test,'split')) then
        if (.not.inp_i(ichopx)) then
          write(LuOut,*) 'tce_input: split value not found; ',
     1      'default value of 1 will be used'
          ichopx=1
        endif
        if (.not.rtdb_put(rtdb,'tce:ichopx',mt_int,1,ichopx))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
      else if (inp_compare(.false.,test,'2emet')) then
        if (.not.inp_i(i4im)) then
          write(LuOut,*) 'tce_input: 2emet value not found; ',
     1      'default value of 1 will be used'
          i4im=1
        endif
        if (.not.rtdb_put(rtdb,'tce:i4im',mt_int,1,i4im))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
      else if (inp_compare(.false.,test,'idiskx')) then
        if (.not.inp_i(idiskx)) then
          write(LuOut,*) 'tce_input: idiskx value not found; ',
     1      'default value of 0 will be used'
          idiskx=0
        endif
        if (.not.rtdb_put(rtdb,'tce:idiskx',mt_int,1,idiskx))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     TARGET (the target excited state for, e.g., geometry optimization)
c
      else if (inp_compare(.false.,test,'target')) then
        if (.not.inp_i(target)) then
          write(LuOut,*) 'tce_input: target value not found; ',
     1      'default value of 1 will be used'
          target=1
        endif
        if (target.gt.nroots) call errquit
     1    ('tce_input: an illegal value for target',target,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:target',mt_int,1,target))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     TARGETSYM (the symmetry of the target excited state)
c
      else if (inp_compare(.false.,test,'targetsym')) then
        if (.not.inp_a(targetsym)) then
          write(LuOut,*) 'tce_input: targetsym value not found; ',
     1      'no symmetry information will be used in specifying target'
          targetsym='none'
        endif
        if (.not.rtdb_cput(rtdb,'tce:targetsym',1,targetsym))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     SYMMETRY (restricts the roots to have the TARGETSYM irrep)
c
      else if (inp_compare(.false.,test,'symmetry')) then
        symmetry=.true.
        if (.not.rtdb_put(rtdb,'tce:symmetry',mt_log,1,symmetry))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     IDENS (one particle reduced density matrix)
c
      else if (inp_compare(.false.,test,'densmat')) then
         idens=.true.
         left =.true.
         if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1      call errquit('tce_input: failed writing to rtdb',0,
     2      RTDB_ERR)
         if (.not.rtdb_put(rtdb,'tce:densmat',mt_log,1,idens))
     1      call errquit('tce_input: failed writing to rtdb',0,
     2      RTDB_ERR)
         if (.not.inp_a(file_densmat)) then
            call util_file_name('densmat', .false.,.false.,file_densmat)
         endif
         if (.not.rtdb_cput(rtdb,'tce:file_densmat',1,file_densmat))
     1      call errquit('tce_input: rtdb_cput failed - file_densmat',0,
     1      RTDB_ERR)
c
c     MULTIPOLE (multipole moments)
c
      else if (inp_compare(.false.,test,'multipole')) then
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        if (.not.inp_i(multipole)) then
          write(LuOut,*) 'tce_input: multipole value not found; ',
     1      'all available multipoles (L=1,2,3) will be calculated'
          multipole=3
        endif
        if (.not.rtdb_put(rtdb,'tce:multipole',mt_int,1,multipole))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     DIPOLE (dipole moments & dipole transition moments)
c     QUADRUPOLE (quadrupole moments & quadrupole transition moments)
c     OCTUPOLE (octupole moments & octupole transition moments)
c
      else if (inp_compare(.false.,test,'dipole')) then
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        multipole=max(multipole,1)
        if (.not.rtdb_put(rtdb,'tce:multipole',mt_int,1,multipole))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'quadrupole')) then
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        multipole=max(multipole,2)
        if (.not.rtdb_put(rtdb,'tce:multipole',mt_int,1,multipole))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'octupole')) then
        left=.true.
        if (.not.rtdb_put(rtdb,'tce:left',mt_log,1,left))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
        multipole=max(multipole,3)
        if (.not.rtdb_put(rtdb,'tce:multipole',mt_int,1,multipole))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     PROPERTY INPUT SUB-BLOCK
c
      else if (inp_compare(.false.,test,'tceprop')) then
        call tce_prop_input(rtdb)
c
c     TILESIZE (the maximum tile size)
c
      else if (inp_compare(.false.,test,'tilesize')) then
        if (.not.inp_i(tilesize))
     1    call errquit('tce_input: no tilesize given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:tilesize',mt_int,1,tilesize))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     FRAGMENT (if excited state calc, give an atom in an excited fragment)
c
      else if (inp_compare(.false.,test,'fragment')) then
        if (.not.inp_i(fragment)) then
          write(LuOut,*) 'tce_input: fragment value not found; ',
     1      'default value of 0 will be used'
          fragment=0
        endif
        if (.not.rtdb_put(rtdb,'tce:fragment',mt_int,1,fragment))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     (NO)FOCK (recompute fock for, e.g., DFT, ROHF refs)
c
      else if (inp_compare(.false.,test,'fock')) then
        recompf=.true.
        if (.not.rtdb_put(rtdb,'tce:recompf',mt_log,1,recompf))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'nofock')) then
        recompf=.false.
        if (.not.rtdb_put(rtdb,'tce:recompf',mt_log,1,recompf))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c    ccsd_act/eomccsd_act
c
      else if (inp_compare(.false.,test,'oact')) then
        if (.not.inp_i(oact))
     1    call errquit('tce_input: no oact given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:oact',mt_int,1,oact))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'uact')) then
        if (.not.inp_i(uact))
     1    call errquit('tce_input: no uact given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:uact',mt_int,1,uact))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
      else if (inp_compare(.false.,test,'emin_act')) then
        if (.not.inp_f(emin_act))
     1    call errquit('tce_input: no emin_act given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:eactmin',mt_dbl,1,emin_act))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
      else if (inp_compare(.false.,test,'emax_act')) then
        if (.not.inp_f(emax_act))
     1    call errquit('tce_input: no emax_act given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:eactmax',mt_dbl,1,emax_act))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     ACTIVE_OA (Number of active occupied orbitals)
c
      else if (inp_compare(.false.,test,'active_oa')) then
        if (.not.inp_i(oactive(1)))
     1    call errquit('tce_input: no active_oa given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:active_oa',mt_int,1,oactive(1)))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     ACTIVE_OB (Number of active occupied orbitals)
c
      else if (inp_compare(.false.,test,'active_ob')) then
        if (.not.inp_i(oactive(2)))
     1    call errquit('tce_input: no active_ob given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:active_ob',mt_int,1,oactive(2)))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     ACTIVE_VA (Number of active virtual orbitals)
c
      else if (inp_compare(.false.,test,'active_va')) then
        if (.not.inp_i(vactive(1)))
     1    call errquit('tce_input: no active_va given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:active_va',mt_int,1,vactive(1)))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     ACTIVE_VB (Number of active virtual orbitals)
c
      else if (inp_compare(.false.,test,'active_vb')) then
        if (.not.inp_i(vactive(2)))
     1    call errquit('tce_input: no active_vb given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:active_vb',mt_int,1,vactive(2)))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)
c
c     ACTIVE_EXCIT_LVL (T3 active excitation level)
c
      else if (inp_compare(.false.,test,'t3a_lvl')) then
        if (.not.inp_i(numact))
     1    call errquit('tce_input: no t3a_lvl given',0,INPUT_ERR)
        if (.not.rtdb_put(rtdb,'tce:act_excit_lvl',mt_int,1,numact))
     1    call errquit('tce_input: failed writing to rtdb',0,
     2    RTDB_ERR)

c
c     PRINT
c
      else if (inp_compare(.false.,test,'print')) then
        call util_print_input(rtdb,'tce')
c
c     END
c
      else if (inp_compare(.false.,test,'end')) then
        goto 20
      else
        call errquit('tce_input: unknown directive',0,INPUT_ERR)
      endif
      goto 10
c
c ------
c Return
c ------
c
 20   return
      end
c
c     This is the TCE property input block ("tceprop")
c
      subroutine tce_prop_input(rtdb)
c
      implicit none
#include "inp.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "stdio.fh"
      integer rtdb
      integer n_a,k_a,l_a
      integer n_b,k_b,l_b
      integer n_c,k_c,l_c
      integer n_i,k_i,l_i
      integer i,icount
      character*10 module
      character*20 test
      character*20 beta_opt
      character*20 gamm_opt
      character*20 disp_opt
      character*20 beta_type
      character*20 gamm_type
      character*20 disp_type
      logical lineresp ! T(1) response equations - real frequency
      logical leftresp ! L(1) response equations 
      logical quadresp ! T(2) response equations
      logical imagresp ! T(1) response equatiosn - imaginary frequency
      logical status
c
      lineresp = .false.
      leftresp = .false.
      quadresp = .false.
      imagresp = .false.
c
c -------------------------------------
c What input block are we dealing with?
c -------------------------------------
c
      if (.not.rtdb_cget(rtdb,'tce:module',1,module)) then
        call errquit('tce_prop_input: line ',__LINE__,RTDB_ERR)
      endif
c
c ----------
c Read input
c ----------
c
 100  if (.not. inp_read()) then
        call errquit('tce_prop_input: line ',__LINE__,RTDB_ERR)
      endif
      if (.not. inp_a(test)) then
        call errquit('tce_prop_input: line ',__LINE__,RTDB_ERR)
      endif
c
c     POLARIZABILITY
c
      if (inp_compare(.false.,test,'polarizability').or.
     1    inp_compare(.false.,test,'polar').or.
     2    inp_compare(.false.,test,'alpha')) then
        lineresp = .true.
c
c     HYPERPOLARIZABILITY
c
      elseif (inp_compare(.false.,test,'hyperpolarizability').or.
     1    inp_compare(.false.,test,'hyperpolar').or.
     2    inp_compare(.false.,test,'beta')) then
        lineresp = .true.
        leftresp = .true.
        if (.not.inp_a(beta_opt)) then
          beta_type = 'static'
        else
          if (inp_compare(.false.,beta_opt,'shg')) then
            beta_type = 'SHG'
          elseif (inp_compare(.false.,beta_opt,'or')) then
            beta_type = 'OR'
          elseif (inp_compare(.false.,beta_opt,'eope')) then
            beta_type = 'EOPE'
          else
            call errquit('tce_prop_input: invalid option for beta',
     1                   __LINE__,RTDB_ERR)
          endif
        endif
c
c     SECOND HYPERPOLARIZABILITY
c
      elseif (inp_compare(.false.,test,'cubicpolarizability').or.
     1        inp_compare(.false.,test,'cubicpolar').or.
     2        inp_compare(.false.,test,'gamma')) then
        lineresp = .true.
        leftresp = .true.
        quadresp = .true.
        if (.not.inp_a(gamm_opt)) then
          gamm_type = 'static'
        else
          if (inp_compare(.false.,gamm_opt,'thg')) then
            gamm_type = 'THG'
          elseif (inp_compare(.false.,gamm_opt,'efish')) then
            gamm_type = 'EFISH'
          elseif (inp_compare(.false.,gamm_opt,'dfwm')) then
            gamm_type = 'DFWM'
          elseif (inp_compare(.false.,gamm_opt,'oke')) then
            gamm_type = 'OKE'
          elseif (inp_compare(.false.,gamm_opt,'cars')) then
            gamm_type = 'CARS'
          else
            call errquit('tce_prop_input: invalid option for gamma',
     1                   __LINE__,RTDB_ERR)
          endif
        endif
c
c     DISPERSION
c
      elseif (inp_compare(.false.,test,'dispersion').or.
     1        inp_compare(.false.,test,'disp').or.
     2        inp_compare(.false.,test,'c6')) then
        imagresp = .true.
        if (.not.inp_a(disp_opt)) then
          disp_type = 'derevianko'
        else
          if (inp_compare(.false.,disp_opt,'custom')) then
            disp_type = 'custom'
          elseif (inp_compare(.false.,disp_opt,'gauss-legendre')) then
            disp_type = 'gauss-leg'
          elseif (inp_compare(.false.,disp_opt,'gauss-chebyshev')) then
            disp_type = 'gauss-cheb'
          else
            call errquit('tce_prop_input: invalid option for disp',
     1                   __LINE__,RTDB_ERR)
          endif
        endif
c
c     AFREQ (omega for polarizability)
c
      elseif (inp_compare(.false.,test,'afreq')) then
        lineresp = .true.
        if (inp_i(n_a)) then
          if (.not.ma_push_get(mt_dbl,n_a,'afreq',l_a,
     1                         k_a)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          icount = 0
          do i = 0, n_a-1
            status = inp_f(dbl_mb(k_a+i))
            if (status) then
              icount = icount+1
            else
              write(6,'(a,a,i4,a)')
     1           'Response property input found ',
     2           'fewer frequencies than expected, only ',icount,
     3           'will be used'
              n_a = icount
              if (icount.eq.0) then
                if (.not.ma_pop_stack(l_a)) then
                  call errquit('tce_prop_input: ma_pop_stack',__LINE__,
     1                         MA_ERR)
                endif
              endif
              goto 300
            endif
          enddo
        else
          n_a = 1
          if (.not.ma_push_get(mt_dbl,n_a,'afreq',l_a,k_a)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          dbl_mb(k_a) = 0.0d0
        endif
 300    continue
c
c     BFREQ (omega for first hyperpolarizability)
c
      elseif (inp_compare(.false.,test,'bfreq')) then
        lineresp = .true.
        leftresp = .true.
        if (inp_i(n_b)) then
          if (.not.ma_push_get(mt_dbl,n_b,'bfreq',l_b,
     1                         k_b)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          icount = 0
          do i = 0, n_b-1
            status = inp_f(dbl_mb(k_b+i))
            if (status) then
              icount = icount+1
            else
              write(6,'(a,a,i4,a)')
     1           'Response property input found ',
     2           'fewer frequencies than expected, only ',icount,
     3           'will be used'
              n_b = icount
              if (icount.eq.0) then
                if (.not.ma_pop_stack(l_b)) then
                  call errquit('tce_prop_input: ma_pop_stack',__LINE__,
     1                         MA_ERR)
                endif
              endif
              goto 400
            endif
          enddo
        else
          n_b = 1
          if (.not.ma_push_get(mt_dbl,n_b,'bfreq',l_b,k_b)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          dbl_mb(k_b) = 0.0d0
        endif
 400    continue
c
c     CFREQ (omega for second hyperpolarizability)
c
      elseif (inp_compare(.false.,test,'cfreq')) then
        lineresp = .true.
        leftresp = .true.
        quadresp = .true.
        if (inp_i(n_c)) then
          if (.not.ma_push_get(mt_dbl,n_c,'cfreq',l_c,
     1                         k_c)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          icount = 0
          do i = 0, n_b-1
            status = inp_f(dbl_mb(k_c+i))
            if (status) then
              icount = icount+1
            else
              write(6,'(a,a,i4,a)')
     1           'Response property input found ',
     2           'fewer frequencies than expected, only ',icount,
     3           'will be used'
              n_c = icount
              if (icount.eq.0) then
                if (.not.ma_pop_stack(l_c)) then
                  call errquit('tce_prop_input: ma_pop_stack',__LINE__,
     1                         MA_ERR)
                endif
              endif
              goto 500
            endif
          enddo
        else
          n_c = 1
          if (.not.ma_push_get(mt_dbl,n_c,'cfreq',l_c,k_c)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          dbl_mb(k_c) = 0.0d0
        endif
 500    continue
c
c     IFREQ (omega for imaginary polarizability)
c
      elseif (inp_compare(.false.,test,'ifreq')) then
        imagresp = .true.
        if (inp_i(n_i)) then
          if (.not.ma_push_get(mt_dbl,n_i,'ifreq',l_i,
     1                         k_i)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          icount = 0
          do i = 0, n_i-1
            status = inp_f(dbl_mb(k_i+i))
            if (status) then
              icount = icount+1
            else
              write(6,'(a,a,i4,a)')
     1           'Response property input found ',
     2           'fewer frequencies than expected, only ',icount,
     3           'will be used'
              n_i = icount
              if (icount.eq.0) then
                if (.not.ma_pop_stack(l_c)) then
                  call errquit('tce_prop_input: ma_pop_stack',__LINE__,
     1                         MA_ERR)
                endif
              endif
              goto 600
            endif
          enddo
        else
          n_i = 1
          if (.not.ma_push_get(mt_dbl,n_i,'ifreq',l_i,k_i)) then
             call errquit('tce_prop_input: ma_push_get',__LINE__,MA_ERR)
          endif
          dbl_mb(k_i) = 0.0d0
        endif
 600    continue
c
c     END
c
      else if (inp_compare(.false.,test,'end')) then
        goto 200
      else
        call errquit('tce_prop_input: unknown directive',0,INPUT_ERR)
      endif
      goto 100
 200  return
c
c -------------------
c Push values to RTDB
c -------------------
c
      if (.not.rtdb_put(rtdb,'tce:lineresp',mt_log,1,lineresp)) then
        call errquit('tce_prop_input: rtdb_put',__LINE__,RTDB_ERR)
      endif
      if (.not.rtdb_put(rtdb,'tce:leftresp',mt_log,1,leftresp)) then
        call errquit('tce_prop_input: rtdb_put',__LINE__,RTDB_ERR)
      endif
c
c ------
c Return
c ------
c
      end

c
c     qmd_nucl_dt2: half step
c
      subroutine qmd_nucl_dt2(nat,dt,m,r,v,g)
c
      implicit none
c
      integer nat                ! number of atoms
      double precision dt        ! step size
      double precision m(nat)    ! mass
      double precision r(3,nat)  ! coordinates
      double precision v(3,nat)  ! velocities
      double precision g(3,nat)  ! gradients
c
      integer i
      double precision a(3,nat)  ! acceleration
      double precision dtsq2,dt2
c
      character*30 pname
c
c     preliminaries
      pname='qmd_nucl_dt2: '
      dtsq2 = 0.5d0*dt*dt
      dt2 = 0.5d0*dt
c
c     calculate acceleration, update positions (r) and velocities (v) at dt/2
      do i = 1,nat
        a(1,i) = -g(1,i)/m(i)
        r(1,i) = r(1,i) + v(1,i)*dt + a(1,i)*dtsq2
        v(1,i) = v(1,i) + a(1,i)*dt2
c
        a(2,i) = -g(2,i)/m(i)
        r(2,i) = r(2,i) + v(2,i)*dt + a(2,i)*dtsq2
        v(2,i) = v(2,i) + a(2,i)*dt2
c
        a(3,i) = -g(3,i)/m(i)
        r(3,i) = r(3,i) + v(3,i)*dt + a(3,i)*dtsq2
        v(3,i) = v(3,i) + a(3,i)*dt2
      end do
c
      return
      end
c $Id: qmd_nucl_dt2.F 24348 2013-06-23 04:29:20Z d3y133 $

C $Id: ecp_gradient.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_gradient (
     &    xyz_A,zeta_A,coef_A,n_prim_A,n_cont_A,l_A,i_c_A,
     &    xyz_B,zeta_B,coef_B,n_prim_B,n_cont_B,l_B,i_c_B,
     &    xyz_C,zeta_C,coef_C,n_prim_C,n_colc_C,
     &    ind_z,ind_c,n_zeta_C,n_coef_C,
     &    l_C,i_cent_C,n_C,l_ecp_max,
     &    sphcart,csco,lcsco,
     &    ecp_grads,n_int,n_blk,n_cent,
     &    DryRun,scr,lscr,ibug)
*                                                                      *
*   Calculate ecp gradient integrals.                                  *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   xyz_A (inp) - coordinates of centre A                              *
*   zeta_A (inp) - exponents of primitive gaussians on centre A        *
*   coef_A (inp) - contraction coefficients on centre A                *
*   n_prim_A (inp) - number of primitive gaussians on centre A         *
*   n_cont_A (inp) - number of contracted functions on centre A        *
*   l_A (inp) - angular momentum of functions on centre A              *
*   i_c_A (inp) - index of centre A                                    *
*   xyz_B (inp) - coordinates of centre B                              *
*   zeta_B (inp) - exponents of primitive gaussians on centre B        *
*   coef_B (inp) - contraction coefficients on centre B                *
*   n_prim_B (inp) - number of primitive gaussians on centre B         *
*   n_cont_B (inp) - number of contracted functions on centre B        *
*   l_B (inp) - angular momentum of functions on centre B              *
*   i_c_B (inp) - index of centre B                                    *
*   xyz_C (inp) - coordinates of ECP centres C                         *
*   zeta_C (inp) - array of exponents of primitive gaussians on all    *
*                  centres C. These are stored in an array of single   *
*                  dimension, i.e. packed.                             *
*   coef_C (inp) - array of contraction coefficients on all centres C  *
*   n_prim_C (inp) - array of number of primitive gaussians for each   *
*                    power of r, l value and ECP centre. The highest   *
*                    l value is for the local part, thus the second    *
*                    dimension is l_ecp_max+2 (or 0:l_ecp_max+1)       *
*   n_colc_C (inp) - array of number of coefficients for each l value  *
*                    and ECP centre. This is n_prim_C summed over the  *
*                    first dimension.                                  *
*   ind_z (inp) - array of addresses of first exponent for each l      *
*                 value and ECP centre.                                *
*   ind_c (inp) - array of addresses of first coefficient for each l   *
*                 value and ECP centre.                                *
*   n_zeta_C (inp) - total number of ECP exponents.                    *
*   n_coef_C (inp) - total number of ECP coefficients.                 *
*   l_C (inp) - maximum angular momentum of projectors on centres C    *
*   i_cent_C (inp) - indices of ECP centres C                          *
*   n_C (inp) - number of ECP centres C                                *
*   l_ecp_max (inp) - maximum angular momentum of any projector on any *
*                 ECP centre                                           *
*   sphcart (inp) - 0 for cartesian, 1 for spherical integrals         *
*   ecp_grads (out) - gradient integrals over ECPs                     *
*   n_int (inp) - number of ECP gradient integrals for a given centre  *
*                 and cartesian derivative. Should be equal to         *
*                 NCA*NCB*[(La+1)*(La+2)/2]*[(Lb+1)*(Lb+2)/2]          *
*   n_blk (inp) - 1 for scalar only, 3 for s-o only, 4 for both        *
*   n_cent (inp) - total number of centres in the molecule             *
*   DryRun (inp) - logical for dry run. If true, routine only returns  *
*                  maximum scratch space needed, if false, integrals   *
*                  are returned.                                       *
*   scr (scr) - scratch array for work space                           *
*   lscr (i/o) - length of scratch array. Value returned if DryRun is  *
*                true, used as dimension if false.                     *
*   ibug - debug flag. 0 for no debug, 1 for address printing, 2 for   *
*          array printing, 3 for both.                                 *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"
      integer i,j,k,l,
     &    n_prim_A,n_cont_A,l_A,i_c_A,
     &    n_prim_B,n_cont_B,l_B,i_c_B,
     &    n_zeta_C,n_coef_C,n_C,i_c_C,l_ecp_max,
     &    n_int,n_blk,n_cent,sphcart,lscr,ibug
      integer n_prim_C(0:4,-1:l_ecp_max,n_C*2),
     &    n_colc_C(-1:l_ecp_max,n_C*2),
     &    ind_z(-1:l_ecp_max,n_C*2),ind_c(-1:l_ecp_max,n_C*2),
     &    l_C(n_C),i_cent_C(n_C)
      integer i_scr,i_s,i_zeta,i_coef,i_xca,i_xcb,i_lm,i_lp,
     &    mem,max_type1,max_type2,memscr,
     &    n_cart_a,n_cart_b,n_cart_ab,n_cont_ab,
     &    n_all_a,n_all_b,n_ab,n_ab3,
     &    n_cartm_a,n_cartm_b,n_cartp_a,n_cartp_b,
     &    n_intpa,n_intpb,n_intma,n_intmb
      integer lcsco
      logical DryRun,debug_gen,debug_addresses,debug_arrays
      double precision 
     &    xyz_A(3),zeta_A(n_prim_A),coef_A(n_prim_A,n_cont_A),
     &    xyz_B(3),zeta_B(n_prim_B),coef_B(n_prim_B,n_cont_B),
     &    xyz_C(3,n_C),zeta_C(n_zeta_C),coef_C(n_zeta_C),
     &    scr(lscr),ecp_grads(n_int*n_blk,3,n_cent)
      double precision 
     &    X_AC,Y_AC,Z_AC,R_AC,X_BC,Y_BC,Z_BC,R_BC,
     &    tol,zero,one
      double precision csco(lcsco)
      character*4 dbyd(3)
      character*12 printhead
      parameter (zero = 0.0d00, one = 1.0d00)
!      data tol/1.0d-14/
      data tol/1.0d-16/
      data dbyd/'d/dx','d/dy','d/dz'/
      data printhead/'      U_ab  '/
*
      debug_gen = ibug .gt. 0
      debug_addresses = mod(ibug,2) .eq. 1
      debug_arrays = (mod(ibug,10)/2 .eq. 1) .and. .not.DryRun
      if (debug_gen) write (LuOut,*) 'ibug = ',ibug
*
      if (debug_gen) write (LuOut,'(//A,/)') 'Entering ecp_gradient ...'
      if (debug_addresses) then
        write(LuOut,*)' lscr in ecp_gradient:',lscr
        write (LuOut,*) 'n_prim_A,n_cont_A,l_A',n_prim_A,n_cont_A,l_A
        write (LuOut,*) 'n_prim_B,n_cont_B,l_B',n_prim_B,n_cont_B,l_B
        write (LuOut,*) 'l_ecp_max,n_c',l_ecp_max,n_c
      end if
      n_cart_a = (l_a+1)*(l_a+2)/2
      n_cart_b = (l_b+1)*(l_b+2)/2
      n_cart_ab = n_cart_a*n_cart_b
      n_cont_ab = n_cont_a*n_cont_b
      n_all_b = n_cart_b*n_cont_b
      n_all_a = n_cart_a*n_cont_a
      n_ab = n_cart_ab*n_cont_ab
      n_ab3 = n_ab*3
      if (debug_addresses) write (LuOut,*) 
     &    'n_cart_a,n_cart_b,n_cart_ab,n_cont_ab',
     &    n_cart_a,n_cart_b,n_cart_ab,n_cont_ab
      if (n_int .lt. n_ab) call errquit (
     &    'Mismatch of integral count in ecp_gradient',99, BASIS_ERR)
      if (sphcart .ne. 0) call errquit(
     &    'Do your own spherical transformation, lazy bum!',99,
     &       BASIS_ERR)

      max_type1 = 0     ! take care of compiler warnings
      max_type2 = 0

      if (.not.DryRun)
     &  call dfill (n_int*n_blk*3*n_cent,zero,ecp_grads,1)
*
*   Set up pointers to scratch space for coefficients multiplied by 
*   exponents and for integrals with shifted l values
*
      n_cartp_a = n_cart_a+l_A+2
      n_cartp_b = n_cart_b+l_B+2
      n_cartm_a = n_cart_a-l_A-1
      n_cartm_b = n_cart_b-l_B-1
      n_intpa = n_cartp_a*n_cart_b*n_cont_ab
      n_intma = n_cartm_a*n_cart_b*n_cont_ab
      n_intpb = n_cart_a*n_cartp_b*n_cont_ab
      n_intmb = n_cart_a*n_cartm_b*n_cont_ab
      i_xca = 1
      i_xcb = i_xca+n_prim_A*n_cont_A
      i_lp = i_xcb+n_prim_B*n_cont_B
      i_lm = i_lp+max(n_intpa,n_intpb)*n_blk
      i_scr = i_lm+max(n_intma,n_intmb)*n_blk
      if (debug_addresses) then
        write (LuOut,*) 'i_xca,i_xcb',i_xca,i_xcb
        write (LuOut,*) 'i_lp,i_lm',i_lp,i_lm
        write (LuOut,*) 'i_scr',i_scr
      end if
*
*   Set up coefficients multiplied by exponents
*
      if (.not.DryRun) then
        memscr = lscr-i_scr+1
        if (memscr .lt. 0) call errquit (
     &      'Insufficient scratch memory in ecp_gradient',99, MEM_ERR)
        k = i_xca-1
        do j = 1,n_cont_a
          do i = 1,n_prim_A
            scr(k+i) = zeta_A(i)*coef_A(i,j)
          end do
          k = k+n_prim_A
        end do
        k = i_xcb-1
        do j = 1,n_cont_B
          do i = 1,n_prim_B
            scr(k+i) = zeta_B(i)*coef_B(i,j)
          end do
          k = k+n_prim_B
        end do
      end if
*
*   Loop over ECP centres
*
      if (debug_arrays) call ecp_matpr (xyz_C,1,3,1,n_C,1,3,1,n_C,
     &    'coordinate array','E',78,4)
      if (debug_gen) write (LuOut,*) 'Number of ECP centers =',n_C
      do i = 1,n_C
        l = l_C(i)
        i_c_C = i_cent_C(i)
        if (debug_gen) write (LuOut,*) 'ECP center',i
        if (debug_gen) write (LuOut,*) '   Maximum angular momentum',l
*
*     Set up relative cartesian coordinates
*
        X_AC = xyz_C(1,i)-xyz_A(1)
        Y_AC = xyz_C(2,i)-xyz_A(2)
        Z_AC = xyz_C(3,i)-xyz_A(3)
        R_AC = sqrt(X_AC**2+Y_AC**2+Z_AC**2)
        X_BC = xyz_C(1,i)-xyz_B(1)
        Y_BC = xyz_C(2,i)-xyz_B(2)
        Z_BC = xyz_C(3,i)-xyz_B(3)
        R_BC = sqrt(X_BC**2+Y_BC**2+Z_BC**2)
        if (debug_arrays) then
          write (LuOut,'(3x,A,3F10.6)') 'Relative coords of center A:',
     &        X_AC,Y_AC,Z_AC
          write (LuOut,'(3x,A,3F10.6)') 'Relative coords of center B:',
     &        X_BC,Y_BC,Z_BC
          write (LuOut,'(3x,A,3F10.6)') 'Distance to center A and B:',
     &        R_AC,R_BC
        end if
*
*     Pointers for local part
*
        i_zeta = ind_z(-1,i)
        i_coef = ind_c(-1,i)
*
*
*       Derivatives wrt centre B
*       ========================
*
        if (i_c_B .ne. i_c_C) then
*
*         Increment angular momentum on centre B
*
          if (.not.DryRun) then
            call dfill (n_intpb*n_blk,zero,scr(i_lp),1)
            call dfill (n_intmb*n_blk,zero,scr(i_lm),1)
          end if
          if (i_c_A .eq. i_c_C) then
          if ((n_colc_C(-1,i) .gt. 0)) then
            if (n_blk .ne. 3) call ecp_local1 (mem,DryRun,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B+1,
     &          n_prim_B,n_cont_B,scr(i_xcb),zeta_B,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A,
     &          n_prim_A,n_cont_A,coef_A,zeta_A,
     &          n_prim_C(0,-1,i),n_colc_C(-1,i),
     &          zeta_c(i_zeta),coef_c(i_coef),0,4,
     &          tol,0,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpb,.false.,ibug/10)
            if (DryRun) max_type1 = max(mem,max_type1)
            endif
            call ecp_int1 (mem,DryRun,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B+1,
     &          n_prim_B,n_cont_B,scr(i_xcb),zeta_B,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A,
     &          n_prim_A,n_cont_A,coef_A,zeta_A,
     &          l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &          ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &          zeta_C,coef_C,0,4,tol,0,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpb,n_blk,.false.,ibug/10)
            if (DryRun) max_type1 = max(mem,max_type1)
          else
          if ((n_colc_C(-1,i) .gt. 0)) then
            if (n_blk .ne. 3) call ecp_local2 (mem,DryRun,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B+1,
     &          n_prim_B,n_cont_B,scr(i_xcb),zeta_B,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A,
     &          n_prim_A,n_cont_A,coef_A,zeta_A,
     &          n_prim_C(0,-1,i),n_colc_C(-1,i),
     &          zeta_C(i_zeta),coef_C(i_coef),0,4,
     &          tol,0,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpb,ibug/10)
            if (DryRun) max_type2 = max(mem,max_type2)
            endif
            call ecp_int2 (mem,DryRun,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B+1,
     &          n_prim_B,n_cont_B,scr(i_xcb),zeta_B,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A,
     &          n_prim_A,n_cont_A,coef_A,zeta_A,
     &          l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &          ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &          zeta_C,coef_C,0,4,tol,sphcart,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpb,n_blk,ibug/10)
            if (DryRun) max_type2 = max(mem,max_type2)
          end if
*
*         Decrement angular momentum on centre B
*
          if (l_B .gt. 0) then
            if (i_c_A .eq. i_c_C) then
          if ((n_colc_C(-1,i) .gt. 0)) then
              if (n_blk .ne. 3) call ecp_local1 (mem,DryRun,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B-1,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            n_prim_C(0,-1,i),n_colc_C(-1,i),
     &            zeta_c(i_zeta),coef_c(i_coef),0,4,
     &            tol,0,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intmb,.false.,ibug/10)
              if (DryRun) max_type1 = max(mem,max_type1)
              endif
              call ecp_int1 (mem,DryRun,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B-1,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &            ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &            zeta_C,coef_C,0,4,tol,0,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intmb,n_blk,.false.,ibug/10)
              if (DryRun) max_type1 = max(mem,max_type1)
            else
          if ((n_colc_C(-1,i) .gt. 0)) then
              if (n_blk .ne. 3) call ecp_local2 (mem,DryRun,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B-1,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            n_prim_C(0,-1,i),n_colc_C(-1,i),
     &            zeta_C(i_zeta),coef_C(i_coef),0,4,
     &            tol,0,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intmb,ibug/10)
              if (DryRun) max_type2 = max(mem,max_type2)
              endif
              call ecp_int2 (mem,DryRun,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B-1,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &            ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &            zeta_C,coef_C,0,4,tol,sphcart,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intmb,n_blk,ibug/10)
              if (DryRun) max_type2 = max(mem,max_type2)
            end if
          end if
*
*         Add gradient terms to output array
*
          if (.not.DryRun) then
            call dfill (n_ab3*n_blk,zero,scr(i_scr),1)
            call ecp_grad_b (l_B,n_cartp_b,n_cart_b,n_cartm_b,n_cont_B,
     &          scr(i_lp),scr(i_lm),scr(i_scr),n_all_a*n_blk,ibug/10)
            i_s = i_scr
            do j = 1,3
              call daxpy (n_ab*n_blk,one,scr(i_s),1,
     &            ecp_grads(1,j,i_c_B),1)
              call daxpy (n_ab*n_blk,-one,scr(i_s),1,
     &            ecp_grads(1,j,i_c_C),1)
              i_s = i_s+n_ab*n_blk
            end do
          end if
        end if
*
*       Derivatives wrt centre A
*       ========================
*
        if (i_c_A .ne. i_c_C) then
*
*         Increment angular momentum on centre A
*
          if (.not.DryRun) then
            call dfill (n_intpa*n_blk,zero,scr(i_lp),1)
            call dfill (n_intma*n_blk,zero,scr(i_lm),1)
          end if
          if (i_c_B .eq. i_c_C) then
          if ((n_colc_C(-1,i) .gt. 0)) then
            if (n_blk .ne. 3) call ecp_local1 (mem,DryRun,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A+1,
     &          n_prim_A,n_cont_A,scr(i_xca),zeta_A,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B,
     &          n_prim_B,n_cont_B,coef_B,zeta_B,
     &          n_prim_C(0,-1,i),n_colc_C(-1,i),
     &          zeta_c(i_zeta),coef_c(i_coef),0,4,
     &          tol,0,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpa,.true.,ibug/10)
            if (DryRun) max_type1 = max(mem,max_type1)
            endif
            call ecp_int1 (mem,DryRun,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A+1,
     &          n_prim_A,n_cont_A,scr(i_xca),zeta_A,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B,n_prim_B,n_cont_B,
     &          coef_B,zeta_B,
     &          l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &          ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &          zeta_C,coef_C,0,4,tol,0,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpa,n_blk,.true.,ibug/10)
            if (DryRun) max_type1 = max(mem,max_type1)
          else
          if ((n_colc_C(-1,i) .gt. 0)) then
            if (n_blk .ne. 3) call ecp_local2 (mem,DryRun,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B,
     &          n_prim_B,n_cont_B,coef_B,zeta_B,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A+1,
     &          n_prim_A,n_cont_A,scr(i_xca),zeta_A,
     &          n_prim_C(0,-1,i),n_colc_C(-1,i),
     &          zeta_C(i_zeta),coef_C(i_coef),0,4,
     &          tol,0,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpa,ibug/10)
            if (DryRun) max_type2 = max(mem,max_type2)
            endif
            call ecp_int2 (mem,DryRun,
     &          R_BC,X_BC,Y_BC,Z_BC,l_B,
     &          n_prim_B,n_cont_B,coef_B,zeta_B,
     &          R_AC,X_AC,Y_AC,Z_AC,l_A+1,
     &          n_prim_A,n_cont_A,scr(i_xca),zeta_A,
     &          l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &          ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &          zeta_C,coef_C,0,4,tol,sphcart,scr(i_scr),memscr,
     &          csco,lcsco,
     &          scr(i_lp),n_intpa,n_blk,ibug/10)
            if (DryRun) max_type2 = max(mem,max_type2)
          end if
*
*         Decrement angular momentum on centre A
*
          if (l_A .gt. 0) then
            if (i_c_B .eq. i_c_C) then
          if ((n_colc_C(-1,i) .gt. 0)) then
              if (n_blk .ne. 3) call ecp_local1 (mem,DryRun,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A-1,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            n_prim_C(0,-1,i),n_colc_C(-1,i),
     &            zeta_c(i_zeta),coef_c(i_coef),0,4,
     &            tol,0,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intma,.true.,ibug/10)
              if (DryRun) max_type1 = max(mem,max_type1)
              endif
              call ecp_int1 (mem,DryRun,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A-1,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &            ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &            zeta_C,coef_C,0,4,tol,0,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intma,n_blk,.true.,ibug/10)
              if (DryRun) max_type1 = max(mem,max_type1)
            else
          if ((n_colc_C(-1,i) .gt. 0)) then
              if (n_blk .ne. 3) call ecp_local2 (mem,DryRun,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A-1,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            n_prim_C(0,-1,i),n_colc_C(-1,i),
     &            zeta_C(i_zeta),coef_C(i_coef),0,4,
     &            tol,0,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intma,ibug/10)
              if (DryRun) max_type2 = max(mem,max_type2)
           endif
              call ecp_int2 (mem,DryRun,
     &            R_BC,X_BC,Y_BC,Z_BC,l_B,
     &            n_prim_B,n_cont_B,coef_B,zeta_B,
     &            R_AC,X_AC,Y_AC,Z_AC,l_A-1,
     &            n_prim_A,n_cont_A,coef_A,zeta_A,
     &            l_c(i),n_prim_C(0,-1,i),n_colc_C(-1,i),ind_z(-1,i),
     &            ind_c(-1,i),n_zeta_C,n_coef_C,l_ecp_max,n_C,
     &            zeta_C,coef_C,0,4,tol,sphcart,scr(i_scr),memscr,
     &            csco,lcsco,
     &            scr(i_lm),n_intma,n_blk,ibug/10)
              if (DryRun) max_type2 = max(mem,max_type2)
            end if
          end if
*
*         Add gradient terms to output array
*
          if (.not.DryRun) then
            call dfill (n_ab3*n_blk,zero,scr(i_scr),1)
            call ecp_grad_a (l_A,n_cartp_a,n_cart_a,n_cartm_a,
     &          n_cont_A*n_blk,scr(i_lp),scr(i_lm),scr(i_scr),n_all_b,
     &          ibug/10)
            i_s = i_scr
            do j = 1,3
              call daxpy (n_ab*n_blk,one,scr(i_s),1,
     &            ecp_grads(1,j,i_c_A),1)
              call daxpy (n_ab*n_blk,-one,scr(i_s),1,
     &            ecp_grads(1,j,i_c_C),1)
              i_s = i_s+n_ab*n_blk
            end do
          end if
        end if
      end do
      if (debug_arrays) then
        do i = 1,n_cent
          write (LuOut,*) ' Centre',i
          do j = 1,3
            printhead(1:4) = dbyd(j)
            call ecp_matpr (ecp_grads(1,j,i),1,n_all_b,1,n_all_a,
     &          1,n_all_b,1,n_all_a,printhead,'E',78,4)
          end do
        end do
      end if
      if (DryRun) lscr = i_scr-1
     &    +max(n_ab3*n_blk,max_type1,max_type2)
      if (debug_gen) write (LuOut,*) 'Exiting ecp_gradient'
*
      return
      end

C $Id: ecp_up_k.f 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_up_k (m_min,m_max,k,j,l,n,ldQ,alpha,beta,
     &    gamma,Q_lo,Q_mid,Q_hi)
*                                                                      *
*   Perform upward recursion in k for k even, using 6.38:              *
*   2c Q^{k+2}_{m,m+j} = (k-j) Q^k_{m,m+j} + a Q^{k+1}_{m+1,m+j}       *
*                    + b Q^{k+1}_{m,m-1+j}                             *
*   = gamma [(gamma (k-j)/2 Q^k_{m,m+j} + alpha Q^{k+1}_{m+1,m+j}      *
*                    + beta Q^{k+1}_{m,m-1+j} ]                        *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   m_min (inp) - minimum value of m                                   *
*   m_max (inp) - maximum value of m                                   *
*   k (inp) - value of k                                               *
*   j (inp) - value of j                                               *
*   l (inp) - switches alpha and beta for different forms of recursion *
*             formula.                                                 *
*   n (inp) - number of functions                                      *
*   alpha (inp) -  a/2*sqrt(c)                                         *
*   beta (inp) -  b/2*sqrt(c)                                          *
*   gamma (inp) - 1/sqrt(c)                                            *
*   Q_mid (inp) - Q^{k+1}_{m+1,m}                                      *
*   Q_lo (inp) - Q^{k}_{m,m}                                           *
*   Q_hi (out) - Q^{k+2}_{m,m}                                         *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
      integer i,j,k,l,ldQ,m,m_min,m_max,n
      double precision two,fac,alpha(n),beta(n),gamma(n),
     &    Q_lo(ldQ,m_min:m_max),Q_mid(ldQ,m_min:m_max+1),
     &    Q_hi(ldQ,m_min:m_max)
*
      parameter (two = 2.0d00)
*
      fac = k-j
      fac = fac/two
C      write (6,'(/A,/)') 'upward_k_recursion'
C      write (6,*) 'k,j,m_min,m_max',k,j,m_min,m_max
      do m = m_min,m_max-j
C        write (6,*) 'm =',m
        do i = 1,n
          Q_hi(i,m) = gamma(i)*( gamma(i)*fac*Q_lo(i,m)
     &        + alpha(i)*Q_mid(i,m+l)+ beta(i)*Q_mid(i,m+1-l) )
C          write (6,'(1p4e20.10)') gamma(i),alpha(i),beta(i)
C          write (6,'(1p4e20.10)') Q_lo(i,m),Q_mid(i,m+l),Q_mid(i,m+1-l),
C     &        Q_hi(i,m)
        end do
      end do
*
      return
      end

      subroutine tce_mrcc_ao2e(rtdb,d_ao2e,iref)
c
c $Id: tce_mrcc_ao2e.F 24345 2013-06-22 06:19:30Z d3y133 $
c
c     Returns a SF handle for the AO 2-e integral matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_mrcc.fh"
      integer rtdb                 ! Run-time database
      logical nodezero             ! True if node zero
      integer d_ao2e               ! AO integrals
      integer joff(max_size)       ! j offset
      integer loff(max_size)       ! l offset
      integer work1,work2          ! Work array sizes
      integer l_work1,k_work1      ! Work array 1
      integer l_work2,k_work2      ! Work array 2
      integer l_ijkl,k_ijkl        ! AO integrals
      integer l_ij,k_ij            ! AO integrals
      integer l_pj,k_pj            ! Quarter transformed
      integer l_pq,k_pq            ! Half transformed
      integer l_pq_packed,k_pq_packed! Packed
      integer g1b,g2b
      integer sf_size_pq
      integer sf_size_kl
      integer ish,jsh,ksh,lsh
      integer i,j,k,l,kl
      integer ikjl,ijkl
      integer ilo,ihi,jlo,jhi
      integer klo,khi,llo,lhi
      integer irange,jrange
      integer krange,lrange
      integer kloff
      integer pgd
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      integer nxtasksub
      external nxtasksub
      integer next,count,nprocs
      integer N
      character*255 filename
      double precision dbl_size
      integer iref,innodes
c
c     ===========
c     Set offsets
c     ===========
c
      if (ipol.eq.1) then
        N = (nmo(1) - nfc(1) - nfv(1)) * 2
      else
        N = nmo(1) + nmo(2) - nfc(1) - nfc(2) - nfv(1) - nfv(2)
      endif
      nodezero = (ga_nodeid().eq.0)
      do j = 1, nbf
        joff(j) = (j-1)*nbf
      enddo
      do l = 1, nbf
        loff(l) = (l-1)*nbf
      enddo
c
c     ===========
c     Allocate SF
c     ===========
c
      sf_size_pq = 0
      dbl_size = 0.0d0
ckbn     if(nodezero) write(*,'(A,I5)') "noa+nob+nva+nvb",noa+nob+nva+nvb
      do g1b = 1,noa+nob+nva+nvb
        do g2b = g1b,noa+nob+nva+nvb
          sf_size_pq = sf_size_pq + int_mb(k_range+g1b-1)
     1                            * int_mb(k_range+g2b-1)

ckbn      if(nodezero) write(*,'(A,I5,I5,I5,I5)') "sf_size_pq ",sf_size_pq,
ckbn     + int_mb(k_range+g1b-1),int_mb(k_range+g2b-1),
ckbn     + int_mb(k_range+g1b-1)*int_mb(k_range+g2b-1)

          dbl_size   = dbl_size   + dfloat(int_mb(k_range+g1b-1))
     1                            * dfloat(int_mb(k_range+g2b-1))
        enddo
      enddo
#if !defined(EXT_INT)
      if ((dbl_size .gt. 16.0d0*1024.0d0**3).and.(ioalg.eq.0)) then
        write(LuOut,*) '--------------------------------------------'
        write(LuOut,*) 'Abort: 2 GB file size limit will be exceeded'
        write(LuOut,*) 'Use GA/SF scheme or OS large file support'
        write(LuOut,*) '--------------------------------------------'
        call errquit('tce_ao2e: abort',0,UNKNOWN_ERR)
      endif
      if (dbl_size .gt. 2.0d0*1024.0d0**3) then
        write(LuOut,*) '---------------------------------------------'
        write(LuOut,*) 'Abort: 32 bit integer overflow is anticipated'
        write(LuOut,*) 'Use a machine with a 64 bit operating system'
        write(LuOut,*) '---------------------------------------------'
        call errquit('tce_ao2e: abort',0,UNKNOWN_ERR)
      endif
#endif
      sf_size_kl = nbf**2
ckbn      if (nodezero.and.util_print('ao2e',print_default)) then
ckbn      if (nodezero) then
ckbn        write(LuOut,*)
ckbn        write(LuOut,9000) sf_size_pq*sf_size_kl
ckbn      endif
ckbn 9000 format(1x,'2-e (intermediate) file size = ',i15)
      call tce_filename('v2i',filename)
ckbn      if (nodezero.and.util_print('mo1e',print_default))
ckbn     1  write(LuOut,9010) filename(1:20)
ckbn 9010 format(1x,'2-e (intermediate) file name = ',A)
ckbn write size
        if(lusesub) then
         if(ga_pgroup_nodeid(mypgid).eq.0) then
          write(LuOut,'(A,A,A,I18)')
     +    "2-e(intermediate) ",filename(1:20)," in bytes= ",
     +    sf_size_pq*sf_size_kl*8
          call util_flush(LuOut)
         endif 
        else
         if(nodezero) then
          write(LuOut,'(A,A,A,I18)')
     +    "2-e(intermediate) ",filename(1:20)," in bytes= ",
     +    sf_size_pq*sf_size_kl*8
          call util_flush(LuOut)
         endif
        endif


        if(lusesub) then
        innodes = ga_nnodes()
        pgd = int_mb(k_innodes+innodes+ga_nodeid())
      call pgcreatefile(filename,d_ao2e,sf_size_pq*sf_size_kl,
     1 int_mb(k_innodes+innodes+ga_nodeid()))
        else
      call createfile(filename,d_ao2e,sf_size_pq*sf_size_kl)
        endif

c      call util_flush(LuOut)
c
c     =======================
c     Initialize integral API
c     =======================
c
      call int_mem_2e4c(work1,work2)
      if (.not.ma_push_get(mt_dbl,work1,'work1',l_work1,k_work1))
     1  call errquit('tce_ao2e: MA problem work1',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,work2,'work2',l_work2,k_work2))
     1  call errquit('tce_ao2e: MA problem work2',1,MA_ERR)
      if (.not.ma_push_get(mt_dbl,nbf*nbf,'ij',l_ij,k_ij))
     1  call errquit('tce_ao2e: MA problem k_ij',4,MA_ERR)
      if (.not.ma_push_get(mt_dbl,N*nbf,'pj',l_pj,k_pj))
     1  call errquit('tce_ao2e: MA problem p_ij',5,MA_ERR)
      if (.not.ma_push_get(mt_dbl,N*N,'pq',l_pq,k_pq))
     1  call errquit('tce_ao2e: MA problem k_pq',6,MA_ERR)
      if (.not.ma_push_get(mt_dbl,sf_size_pq,'pq_packed',
     1  l_pq_packed,k_pq_packed)) 
     2  call errquit('tce_ao2e: MA problem pq_packed',7,
     3  MA_ERR)
c
c     ================
c     Loop over shells
c     ================
c
      if(lusesub) then
      nprocs = ga_pgroup_nnodes(pgd)
      count = 0
      next = NXTASKsub(nprocs,1,pgd)
      else
      nprocs = ga_nnodes()
      count = 0
      next = NXTASK(nprocs, 1)
      endif

      do lsh=1,nshells
        do ksh=1,nshells
          if (next.eq.count) then
ckbn            if((iref.eq.1).and.lusesub.and.(lsh.eq.ksh))
ckbn     1 write(LuOut,"('Start I.part, shells: ',I4,I4,' nshells',I6)")
ckbn     1 lsh,ksh,nshells
            if (util_print('ao2e',print_debug))
     1        write(LuOut,9190) lsh,ksh,ga_nodeid()
            if (.not.bas_cn2bfr(ao_bas_han,ksh,klo,khi))
     1        call errquit('tce_ao2e: basis fn range problem 1',0,
     2        BASIS_ERR)
            krange = khi - klo + 1
            if (.not.bas_cn2bfr(ao_bas_han,lsh,llo,lhi))
     1        call errquit('tce_ao2e: basis fn range problem 2',1,
     2        BASIS_ERR)
            lrange = lhi - llo + 1
            if (.not.ma_push_get(mt_dbl,sf_size_kl*krange*lrange,
     1        'ao2e',l_ijkl,k_ijkl))
     2        call errquit('tce_ao2e: MA problem k_ijkl',18,MA_ERR)
            do ijkl = 1,sf_size_kl*krange*lrange
              dbl_mb(k_ijkl+ijkl-1) = 0.0d0
            enddo
            do jsh=1,nshells
              do ish=1,nshells
                if (schwarz_shell(ish,ksh)*schwarz_shell(jsh,lsh) 
     1            .ge. tol2e) then
                  if (.not.bas_cn2bfr(ao_bas_han,ish,ilo,ihi))
     1              call errquit('tce_ao2e: basis fn range problem',2,
     2              BASIS_ERR)
                  irange = ihi - ilo + 1
                  if (.not.bas_cn2bfr(ao_bas_han,jsh,jlo,jhi))
     1              call errquit('tce_ao2e: basis fn range problem',3,
     2              BASIS_ERR)
                  jrange = jhi - jlo + 1
                  call int_2e4c(ao_bas_han,ish,ksh,ao_bas_han,jsh,lsh,
     1              work2,dbl_mb(k_work2),work1,dbl_mb(k_work1))
c--------------------------------------------------------------------
                  kl = 0
                  do l = llo,lhi
                    do k = klo,khi
                      kl = kl + 1
                      kloff = (kl-1)*sf_size_kl
                      do j = jlo,jhi
                        do i = ilo,ihi
                          ikjl = (((i-ilo)*krange+(k-klo))*jrange
     1                           +(j-jlo))*lrange+(l-llo)
                          dbl_mb(k_ijkl+kloff+joff(j)+i-1) = 
     1                      dbl_mb(k_work1+ikjl)
                        enddo
                      enddo
                    enddo
                  enddo
c--------------------------------------------------------------------
                endif
              enddo
            enddo
c
c     Write to SF
c
            kl = 0
            do l = llo,lhi
              do k = klo,khi
                kl = kl + 1
                kloff = (kl-1)*sf_size_kl
c
c     Half transformation
c
                call dcopy(sf_size_kl,dbl_mb(k_ijkl+kloff),1,
     1            dbl_mb(k_ij),1)
                call dgemm('T','N',N,nbf,nbf,
     1            1.0d0,dbl_mb(k_movecs_sorted),nbf,
     2            dbl_mb(k_ij),nbf,
     3            0.0d0,dbl_mb(k_pj),N)
                call dgemm('N','N',N,N,nbf,
     1            1.0d0,dbl_mb(k_pj),N,
     2            dbl_mb(k_movecs_sorted),nbf,
     3            0.0d0,dbl_mb(k_pq),N)
                call ma_pack(dbl_mb(k_pq),dbl_mb(k_pq_packed),N)
                if (util_print('ao2e',print_debug)) then
                  write(LuOut,9200) l,k
                  call ma_print_compact(dbl_mb(k_pq_packed),
     1              sf_size_pq,1,'Half transformed MO 2e')
                endif
                call put_block(d_ao2e,dbl_mb(k_pq_packed),
     1            sf_size_pq,(loff(l)+k-1)*sf_size_pq)
              enddo
            enddo
            if (.not.ma_pop_stack(l_ijkl)) 
     1        call errquit('tce_ao2e: MA problem x1',16,MA_ERR)
cc            next = nxtval(nprocs)
      if(lusesub) then
      next = NXTASKsub(nprocs,1,pgd)
      else
      next = NXTASK(nprocs,1)
      endif

ckbn            if((iref.eq.1).and.lusesub.and.(lsh.eq.ksh))
ckbn     1 write(LuOut,"('***** I.part, shells: ',I4,I4,' nshells',I6)")
ckbn     1 lsh,ksh,nshells

          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      if(lusesub) then
      next = NXTASKsub(-nprocs,1,pgd)
      else
      next = NXTASK(-nprocs,1)
      endif

      if(lusesub) then
        call ga_pgroup_sync(pgd)
      else
        call reconcilefile(d_ao2e,sf_size_pq*sf_size_kl)
      endif
c
c     ==========
c     Deallocate
c     ==========
c
      if (.not.ma_pop_stack(l_pq_packed)) 
     1  call errquit('tce_ao2e: MA problem',8,MA_ERR)
      if (.not.ma_pop_stack(l_pq)) 
     1  call errquit('tce_ao2e: MA problem',9,MA_ERR)
      if (.not.ma_pop_stack(l_pj)) 
     1  call errquit('tce_ao2e: MA problem',10,MA_ERR)
      if (.not.ma_pop_stack(l_ij)) 
     1  call errquit('tce_ao2e: MA problem',11,MA_ERR)
      if (.not.ma_pop_stack(l_work2)) 
     1  call errquit('tce_ao2e: MA problem',14,MA_ERR)
      if (.not.ma_pop_stack(l_work1)) 
     1  call errquit('tce_ao2e: MA problem',15,MA_ERR)
      if (nodezero.and.util_print('time',print_debug)) then
        write(LuOut,8000) 'createfile   ', cpusecs(1), cpusecs(51)
        write(LuOut,8000) 'deletefile   ', cpusecs(2), cpusecs(52)
        write(LuOut,8000) 'put_block    ', cpusecs(3), cpusecs(53)
        write(LuOut,8000) 'add_block    ', cpusecs(4), cpusecs(54)
        write(LuOut,8000) 'get_block    ', cpusecs(5), cpusecs(55)
        write(LuOut,8000) 'reconcilefile', cpusecs(6), cpusecs(56)
      endif
c
c     ======
c     Return
c     ======
c
 8000 format(1x,'cpu & wall time in seconds for ',A,2f20.1)
 9190 format(/,'k- and l-shells',2i3,' has been assigned to node ',i3)
 9200 format(/,'k and l',2i3)
      return
      end

c
c     $Id: cgsd_energy.F 25003 2013-12-18 02:39:04Z bylaska $                       
c

*     ***************************
*     *				*
*     *		cgsd_energy	*
*     *				*
*     ***************************

      real*8 function cgsd_energy(newpsi)
      implicit none

#include "stdio.fh"
#include "util.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c#include "global.fh"
c#include "rtdb.fh"

      logical newpsi
      integer MASTER
      parameter (MASTER=0)

      logical stalled,value,oprint,psitmp,failed
      integer taskid
      integer minimizer
      integer i,j,ms,neall,NN
      integer it_in,it_out,icount,bfgscount
      real*8  EV,virial
      real*8  tole,tolc,deltae,deltac,deltae_old
      real*8  cx,cy,cz
      real*8  gx,gy,gz
      real*8  en(2),en1(2),en2(2)
      real*8  E(40)
      integer rtdb

*     **** external functions ****
      logical     psp_semicore,pspw_charge_found,pspw_qmmm_found
      logical     psp_pawexist,psp_U_psputerm,meta_found
      logical     control_out_of_time,pspw_SIC,control_DOS,pspw_HFX
      logical     control_print,control_psi_tmp,control_fractional
      character*4 ion_aname
      integer     control_it_in, control_it_out,control_minimizer
      integer     ion_nion,ion_katm,psi_ne,psi_ispin,control_rtdb
      integer     psi_iptr_hml
      real*8      control_tole,control_tolc,psi_occupation
      real*8      ion_rion,psi_eigenvalue,psi_hml,ion_amass
      real*8      psi_smearfermi
      external psp_semicore,pspw_charge_found,pspw_qmmm_found
      external psp_pawexist,psp_U_psputerm,meta_found
      external control_out_of_time,pspw_SIC,control_DOS,pspw_HFX
      external ion_aname
      external control_it_in, control_it_out,control_minimizer
      external ion_nion,ion_katm,psi_ne,psi_ispin,control_rtdb
      external psi_iptr_hml
      external control_print,control_psi_tmp,control_fractional
      external control_tole,control_tolc,psi_occupation
      external ion_rion,psi_eigenvalue,psi_hml,ion_amass
      external psi_smearfermi
      character*4 psi_ab_irrep_name
      external    psi_ab_irrep_name
      integer     control_symmetry,control_version
      external    control_symmetry,control_version
      logical  ion_disp_on
      external ion_disp_on


      call Parallel_taskid(taskid)
      oprint = ((taskid.eq.MASTER).and.control_print(print_medium))

      psitmp = control_psi_tmp()


*     **** set the minimizer ****
      call dcopy(40,0.0d0,0,E,1)
      minimizer = control_minimizer()

*     **** generate phaze factors and local psp and core density ****
      call phafac()
      if (control_version().eq.3) call ewald_phafac()
      call electron_gen_vl_potential()
      if (psp_semicore(0)) call semicore_density_update()


*     :::::::::::  begin electron iteration  :::::::::::::::::::::::
      if (oprint) then
         !write(luout,1300)
         write(luout,1301)
         !write(luout,1302)
         write(luout,1304)
         if (minimizer.eq.1) write(luout,1305)
         if (minimizer.eq.2) write(luout,1306)
         if (minimizer.eq.3) write(luout,1307)
         if (minimizer.eq.4) write(luout,1308)
         if (minimizer.eq.5) write(luout,1309)
         if (minimizer.eq.6) write(luout,1311)
         if (minimizer.eq.7) write(luout,1312)
         if (minimizer.eq.8) write(luout,1313)
         call util_flush(luout)
      end if

      stalled = .false.
      deltae  = -1.0d-03
      icount=0
      bfgscount=0
      it_in  = control_it_in()
      it_out = control_it_out()
      tole   = control_tole()
      tolc   = control_tolc()
      E(1)=0.0d0
      if (oprint) then
        if ((minimizer.eq.5).or.(minimizer.eq.8)) then
          call nwpw_message(7)
        else
          call nwpw_message(2)
        end if
      end if

      if (oprint) call util_flush(luout)
      if (minimizer.gt.1) call pspw_Grsm_list_start()
      if (minimizer.eq.5) it_out = 1
      if (minimizer.eq.8) it_out = 1
      if (newpsi) then
        call sdminimize(15)
        !call bybminimize(E,deltae,deltac,1,.true.,2)
      end if
   2  continue
         icount = icount + 1
         if (stalled) then
           call sdminimize(0)
           bfgscount = 0 
         end if

         deltae_old = deltae
         if (minimizer.eq.1) then
           bfgscount = bfgscount + 1
           call cgminimize(E,deltae,deltac,bfgscount,it_in)
         else if (minimizer.eq.2) then
           bfgscount = bfgscount + 1
           call bfgsminimize(E,deltae,deltac,bfgscount,minimizer)
         else if (minimizer.eq.3) then
           bfgscount = bfgscount + 1
           call bfgsminimize(E,deltae,deltac,bfgscount,minimizer)
         else if (minimizer.eq.4) then
           bfgscount = bfgscount + 1
           call cgminimize2(E,deltae,deltac,bfgscount)

         else if (minimizer.eq.5) then
           bfgscount = bfgscount + 1
           call bybminimize(E,deltae,deltac,bfgscount,.false.,1,failed)

c          **** reset minimizer if failed ****
           if (failed) then
              minimizer = 1
              it_out    = control_it_out()
              call pspw_Grsm_list_end()
              if (oprint) then
                 write(luout,1314)
                 write(luout,*)
                 write(luout,1305)
                 call nwpw_message(2)
              end if
           end if

         else if (minimizer.eq.6) then
           bfgscount = bfgscount + 1
           call bfgsminimize3(E,deltae,deltac,bfgscount,minimizer)
         else if (minimizer.eq.7) then
           bfgscount = bfgscount + 1
           call bfgsminimize2(E,deltae,deltac,bfgscount,minimizer)

         else if (minimizer.eq.8) then
           bfgscount = bfgscount + 1
           call bybminimize2(E,deltae,deltac,bfgscount,.false.,1,failed)

c          **** reset minimizer if failed ****
           if (failed) then
              minimizer = 1
              it_out    = control_it_out()
              call pspw_Grsm_list_end()
              if (oprint) then
                 write(luout,1314)
                 write(luout,*)
                 write(luout,1305)
                 call nwpw_message(2)
              end if
           end if
         end if

         if ((dabs(deltae).gt.dabs(deltae_old)).or.
     >       (dabs(deltae).gt.1.0d-2)          .or.
     >       (deltae.gt.0.0d0)) then
            stalled = .true.
         else
            stalled = .false.
         end if
         !stalled = .false. !debug
        
         if (psitmp) then
            call psi_tmp_write()
         end if

         if ((oprint).and.(minimizer.ne.5).and.(minimizer.ne.8)) then 
           write(luout,1310) icount*it_in,E(1),deltae,deltac
           call util_flush(luout)

           call ecce_print1('iteration counter', mt_int,icount*it_in,1)
           call ecce_print1('iterative total energy difference',
     >                      mt_dbl, deltae, 1)
           call ecce_print1('iterative total density difference',
     >                      mt_dbl,deltac, 1)
         end if
         if (deltae.gt.0.0d0) then
            if (oprint) 
     >       write(luout,*) 
     >       ' *** energy going up. iteration not terminated'
             stalled = .true.
            !go to 3
         end if
         deltae = dabs(deltae)
         if ((deltae.lt.tole).and.
     >       (deltac.lt.tolc)) then
            if (oprint) 
     >       write(luout,*) ' *** tolerance ok. iteration terminated'
            go to 3
         end if
         if (control_out_of_time()) then
            if (oprint) 
     >       write(luout,*) ' *** out of time. iteration terminated'
           go to 3
         end if

      if (icount.lt.it_out) go to 2
      if (oprint) 
     > write(luout,*) '*** arived at the Maximum iteration.  terminated'

*     :::::::::::  end of electron iteration loop  :::::::::::::::::::::

   3  continue
      if (minimizer.gt.1) call pspw_Grsm_list_end()
      if (oprint) CALL NWPW_MESSAGE(3)


*     **** diagonalize hamiltonian and rotate psi  ****
*     **** but skip if doing an SIC calculations   ****
      call psi_spin_density(en1)
      if (psp_pawexist()) then
         en2(1) = 0.0d0
         en2(2) = 0.0d0
      else
         en2(1) = 0.0d0
         en2(2) = 0.0d0
      end if
      en(1) = en1(1) + en2(1)
      en(2) = en1(2) + en2(2)
      call psi_1gen_hml()

      call psi_diagonalize_hml()

*     *** reverse the order of occ ***
      if (control_fractional())  then
         call psi_1reverse_occupation()
      end if

      if (pspw_SIC()) then
         call psi_1gen_hml_g()
c      else if (.not.control_fractional()) then
      else 
         call psi_1rotate2()
         call psi_2to1()
      end if


*     **** geometrical center and center of mass of the cluster ****
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

*:::::::::::::::::   report summary of results  :::::::::::::::::::::::
      if (control_symmetry().gt.0) call psi_ab_gen_irrep_names(.false.)
      if (oprint) then
         neall = (psi_ne(1)+psi_ne(2))
         write(luout,1304)
         write(luout,1410)

         write(luout,*)
         write(luout,1320) en(1),en(psi_ispin()),' (real space)'
         if (psp_pawexist()) then
            write(luout,1322) en1(1),en1(psi_ispin()),' (real space)'
            write(luout,1323) en2(1),en2(psi_ispin()),' (real space)'
         end if
         write(luout,1430) E(1),E(1)/ion_nion()

         if (pspw_qmmm_found()) then
            write(luout,1431)
            write(luout,1432)
            write(luout,1433)  E(1)-E(11),
     >                        (E(1)-E(11))/ion_nion()
         end if

         if (pspw_charge_found()) then
            write(luout,1431)
            write(luout,1432)
            write(luout,1433) (E(1)-E(19)-E(20)-E(21)),
     >         (E(1)-E(19)-E(20)-E(21))/ion_nion()
         end if

         write(luout,1440) E(2),E(2)/neall
         write(luout,1450) E(3),E(3)/neall
         write(luout,1460) E(4),E(4)/neall
         if (pspw_SIC()) then
           write(luout,1455) E(22),E(22)/neall
           write(luout,1456) E(23),E(23)/neall
         end if
         if (pspw_HFX()) then
           write(luout,1457) E(26),E(26)/neall
         end if
         if (psp_U_psputerm()) then
           write(luout,1458) E(29),E(29)/neall
         end if
         if (meta_found()) then
           write(luout,1459) E(31),E(31)/ion_nion()
         end if
         write(luout,1470) E(5),E(5)/ion_nion()
         if (control_fractional()) write(luout,1471) E(28),E(28)/neall



         write(luout,1480) E(6),E(6)/neall

c        if (pspw_qmmm_found()) then
c           write(luout,1491) E(7),E(7)/neall
c        else
c           write(luout,1490) E(7),E(7)/neall
c        end if
         write(luout,1490) E(7),E(7)/neall

         write(luout,1495) E(8),E(8)/neall
         write(luout,1496) E(9),E(9)/neall
         write(luout,1497) E(10),E(10)/neall
         if (pspw_SIC())  then
           write(luout,1499) E(24),E(24)/neall
           write(luout,1501) E(25),E(25)/neall
         end if
         if (pspw_HFX())  then
           write(luout,1502) E(27),E(27)/neall
         end if
         if (psp_U_psputerm()) then
           write(luout,1503) E(30),E(30)/neall
         end if
         if (meta_found()) then
           write(luout,1504) E(32),E(32)/neall
         end if

         virial = (E(10)+E(9)+E(8)+E(7))/E(6)
         write(luout,1498) virial

        if (pspw_qmmm_found()) then
            write(luout,1700)
            write(luout,1701)
            write(luout,1702) E(11)
            write(luout,1703) E(12)
            write(luout,1704) E(13)
c
c            write(luout,1703) E(14)+E(15)
c            write(luout,1710) E(14)
c            write (luout,1711) E(15)
c
c            write(luout,1704) E(16)
c            write(luout,1705) E(17)
c            write(luout,1706) E(18)
        end if
        if (ion_disp_on()) then
            write(luout,1720) E(33)
        end if

        if (pspw_charge_found()) then
            write(luout,1800)
            write(luout,1801)
            write(luout,1805) E(19)+E(20)+E(21)
            write(luout,1802) E(19)
            write(luout,1803) E(20)
            write(luout,1804) E(21)
        end if

*        **** write out <psi|H|psi> matrix ****
         if (pspw_SIC()) then
           do ms=1,psi_ispin()
             if (ms.eq.1) write(luout,1331)
             if (ms.eq.2) write(luout,1332)
             !*** call Gainsville matrix output ***
             call output(dbl_mb(psi_iptr_hml(ms,1,1)),
     >                    1,psi_ne(ms),1,psi_ne(ms),
     >                    psi_ne(ms),psi_ne(ms),1)

c            do j=1,psi_ne(ms)
c            do i=1,psi_ne(ms)
c              write(luout,1341) ms,i,j,psi_hml(ms,i,j)
c            end do
c            end do

           end do

         end if

*        **** write out KS eigenvalues ****
           NN=psi_ne(1)-psi_ne(2)
           EV=27.2116d0
           if (control_fractional()) then
             if (psi_ispin().eq.1) then
               write(luout,1507) psi_smearfermi(1),psi_smearfermi(1)*EV
             else
             write(luout,1507) psi_smearfermi(1),psi_smearfermi(1)*EV,
     >                         psi_smearfermi(2),psi_smearfermi(2)*EV
             end if
           end if
           write(luout,1500)
           if (control_symmetry().gt.0) then
             if (control_fractional()) then
             do I=1,NN
               write(luout,1513) psi_eigenvalue(1,I),
     >                           psi_eigenvalue(1,I)*EV,
     >                           psi_ab_irrep_name(I),
     >                           psi_occupation(1,I)
             end do
             do I=1,psi_ne(2)
               write(luout,1513)  psi_eigenvalue(1,I+NN),
     >                            psi_eigenvalue(1,I+NN)*EV,
     >                            psi_ab_irrep_name(I),
     >                            psi_occupation(1,I+NN),
     >                            psi_eigenvalue(2,I),
     >                            psi_eigenvalue(2,I)*EV,
     >                            psi_ab_irrep_name(I+psi_ne(1)),
     >                            psi_occupation(2,I)
             end do
             else
             do I=1,NN
                 write(luout,1512) psi_eigenvalue(1,I),
     >                           psi_eigenvalue(1,I)*EV,
     >                           psi_ab_irrep_name(I)
             end do
             do I=1,psi_ne(2)
               write(luout,1512)  psi_eigenvalue(1,I+NN),
     >                            psi_eigenvalue(1,I+NN)*EV,
     >                            psi_ab_irrep_name(I),
     >                            psi_eigenvalue(2,I),
     >                            psi_eigenvalue(2,I)*EV,
     >                            psi_ab_irrep_name(I+psi_ne(1))
             end do
             end if

           else
             if (control_fractional()) then
             do I=1,NN
               write(luout,1511) psi_eigenvalue(1,I),
     >                           psi_eigenvalue(1,I)*EV,
     >                           psi_occupation(1,I)
             end do
             do I=1,psi_ne(2)
               write(luout,1511)  psi_eigenvalue(1,I+NN),
     >                            psi_eigenvalue(1,I+NN)*EV,
     >                            psi_occupation(1,I+NN),
     >                            psi_eigenvalue(2,I),
     >                            psi_eigenvalue(2,I)*EV,
     >                            psi_occupation(2,I)
             end do
             else
             do I=1,NN
               write(luout,1510) psi_eigenvalue(1,I),
     >                           psi_eigenvalue(1,I)*EV
             end do
             do I=1,psi_ne(2)
               write(luout,1510)  psi_eigenvalue(1,I+NN),
     >                            psi_eigenvalue(1,I+NN)*EV,
     >                            psi_eigenvalue(2,I),
     >                            psi_eigenvalue(2,I)*EV
             end do
             end if


           end if
        

      end if
      if (control_symmetry().gt.0) call psi_ab_kill_irrep_names()

      rtdb = control_rtdb()
      if (control_DOS()) call psi_DOS(rtdb)

c*     **** debug - energies written to rtdb for numerical stress ****
c      rtdb = control_rtdb()
c      value =           rtdb_put(rtdb,'pspw:E_ke',      mt_dbl,1,E(6))
c      value = value.and.rtdb_put(rtdb,'pspw:E_hartree', mt_dbl,1,E(3))
c      value = value.and.rtdb_put(rtdb,'pspw:E_xc',      mt_dbl,1,E(4))
c      value = value.and.rtdb_put(rtdb,'pspw:E_ewald',   mt_dbl,1,E(5))
c      value = value.and.rtdb_put(rtdb,'pspw:E_local',   mt_dbl,1,E(7))
c      value = value.and.rtdb_put(rtdb,'pspw:E_nonlocal',mt_dbl,1,E(8))
c      if (.not. value) call errquit(
c     >   'cgsd_noit_energy: numerical stress - error writing rtdb',0)
      call ecce_print1 ('total energy', mt_dbl, E(1), 1)
      call ecce_print1 ('nuclear repulsion energy', mt_dbl, E(5), 1)
      call ecce_print1 ('coulomb energy', mt_dbl, E(3), 1)
      call ecce_print1 ('exchange energy', mt_dbl, E(4), 1)
      call ecce_print1 ('correlation energy', mt_dbl, E(4), 1)


      cgsd_energy = E(1)
      return



 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F6.3,' ')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1300 FORMAT(//'======================')
 1301 FORMAT(//'== Energy Calculation ==')
 1302 FORMAT(  '======================')
 1304 FORMAT(/)
 1305 FORMAT(10X,'====== Grassmann conjugate gradient iteration ======')
 1306 FORMAT(10X,'============ Grassmann lmbfgs iteration ============')
 1307 FORMAT(10X,'============ Grassmann diis iteration ==============')
 1308 FORMAT(10X,'======= Stiefel conjugate gradient iteration =======')
 1309 FORMAT(10X,'======= Kohn-Sham scf iteration (potential) ========')
 1310 FORMAT(I8,E20.10,3E15.5)
 1311 FORMAT(10X,'======= Projected Grassmann lmbfgs iteration =======')
 1312 FORMAT(10X,'============= Stiefel lmbfgs iteration =============')
 1313 FORMAT(10X,'======== Kohn-Sham scf iteration (density) =========')
 1314 FORMAT(10X,'======== Kohn-Sham scf iteration failed    =========')
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1321 FORMAT(' total charge of system:',F11.5,A)
 1322 FORMAT('     plane-wave part:         ',F11.5,'       ',F11.5,A)
 1323 FORMAT('      augmented part:         ',F11.5,'       ',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1331 FORMAT(/' Elements of Hamiltonian matrix (up/restricted)')
 1332 FORMAT(/' Elements of Hamiltonian matrix (down)')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1341 FORMAT(I3,2I3,' H=',E16.6)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
c1410 FORMAT(10X,'=============  summary of results  =================')
 1410 FORMAT('==  Summary Of Results  ==')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1431 FORMAT(/' QM Energies')
 1432 FORMAT( '------------')
 1433 FORMAT( ' total  QM energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1455 FORMAT( ' SIC-hartree energy  :',E19.10,' (',E15.5,'/electron)')
 1456 FORMAT( ' SIC-exc-corr energy :',E19.10,' (',E15.5,'/electron)')
 1457 FORMAT( ' HF exchange energy  :',E19.10,' (',E15.5,'/electron)')
 1458 FORMAT( ' DFT+U     energy    :',E19.10,' (',E15.5,'/electron)')
 1459 FORMAT( ' Metadynamics energy :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1471 FORMAT( ' smearing  energy    :',E19.10,' (',E15.5,'/electron)')
 1480 FORMAT(/' kinetic (planewave) :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' V_local (planewave) :',E19.10,' (',E15.5,'/electron)')
 1491 FORMAT( ' Vl+Vqm/mm           :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' V_nl    (planewave) :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' V_Coul  (planewave) :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' V_xc.   (planewave) :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1499 FORMAT( ' K.S. SIC-hartree energy  :',E19.10,
     >        ' (',E15.5,'/electron)')
 1500 FORMAT(/' orbital energies:')
 1501 FORMAT( ' K.S. SIC-exc-corr energy :',E19.10,
     >        ' (',E15.5,'/electron)')
 1502 FORMAT( ' K.S. HFX energy     :',E19.10,
     >        ' (',E15.5,'/electron)')
 1503 FORMAT( ' K.S. DFT+U energy   :',E19.10,
     >        ' (',E15.5,'/electron)')
 1504 FORMAT( ' K.S. Metadynamics energy   :',E19.10,
     >        ' (',E15.5,'/ion)')
 1507 FORMAT(/' Fermi energy =',2(E18.7,' (',F8.3,'eV)'))
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 1511 FORMAT(2(E18.7,' (',F8.3,'eV)  occ=',F5.3))
 1512 FORMAT(2(E18.7,' (',F8.3,'eV)',A4))
 1513 FORMAT(2(E18.7,' (',F8.3,'eV)',A4,' occ=',F5.3))

 1680 FORMAT(/' kinetic (loc. basis):',E19.10,' (',E15.5,'/electron)')
 1690 FORMAT( ' V_local (loc. basis):',E19.10,' (',E15.5,'/electron)')
 1696 FORMAT( ' coulomb (loc. basis):',E19.10,' (',E15.5,'/electron)')
 1697 FORMAT( ' exc-cor (loc. basis):',E19.10,' (',E15.5,'/electron)')

 1700 FORMAT(/' QM/MM-pol-vib/CAV Energies')
 1701 FORMAT( ' --------------------------')
 1702 FORMAT( ' LJ energy                        :',E19.10)
 1703 FORMAT( ' Residual Coulomb energy          :',E19.10)
 1704 FORMAT( ' MM Vibrational energy            :',E19.10)
 1705 FORMAT( ' MM Vibration energy              :',E19.10)
 1706 FORMAT( ' (QM+MM)/Cavity energy            :',E19.10)
 1707 FORMAT( ' - MM Charge Field/QM Electron    :',E19.10)
 1708 FORMAT( ' - MM Charge Field/QM Ion         :',E19.10)
 1709 FORMAT( ' - MM LJ/QM LJ                    :',E19.10)
 1710 FORMAT( ' - MM Charge Field/MM Charge Field:',E19.10)
 1711 FORMAT( ' - MM LJ/MM LJ                    :',E19.10)

 1720 FORMAT(/' Dispersion energy   :',E19.10)

 1800 FORMAT(/' Charge Field Energies')
 1801 FORMAT( ' ---------------------')
 1802 FORMAT( ' - Charge Field/Electron    :',E19.10)
 1803 FORMAT( ' - Charge Field/Ion         :',E19.10)
 1804 FORMAT( ' - Charge Field/Charge Field:',E19.10)
 1805 FORMAT( ' Charge Field Energy        :',E19.10)
   
      end

*     *******************************
*     *				    *
*     *	    cgsd_energy_gradient    *
*     *				    *
*     *******************************

      subroutine cgsd_energy_gradient(G1)
      implicit none
      real*8 G1(3,*)

#include "stdio.fh"
#include "util.fh"

      logical allow_translation,lprint,mprint,dprint,debug
      integer MASTER
      parameter (MASTER=0)
      integer i,k,taskid,nion,nion1
      integer i1
      real*8  GG,fmax,fatom
      real*8  fmx,fmy,fmz
      real*8  fmx2,fmy2,fmz2

*     **** external functions ****
      logical     psp_semicore,pspw_charge_found,pspw_qmmm_found
      logical     control_allow_translation,ion_q_FixIon,control_print
      character*4 ion_aname,pspw_charge_aname
      integer     ion_katm,ion_nion,control_version
      integer     pspw_charge_nion
      real*8      ion_rion,pspw_charge_rion
      real*8      pspw_charge_charge
      external psp_semicore,pspw_charge_found,pspw_qmmm_found
      external control_allow_translation,ion_q_FixIon,control_print
      external ion_aname,pspw_charge_aname
      external ion_katm,ion_nion,control_version
      external pspw_charge_nion
      external ion_rion,pspw_charge_rion
      external pspw_charge_charge
      logical  pspw_bqext,ion_disp_on
      external pspw_bqext,ion_disp_on


      allow_translation = control_allow_translation()
      nion = ion_nion()
      if (pspw_charge_found().and.
     >    (.not.pspw_bqext())) nion = nion + pspw_charge_nion()

      call Parallel_taskid(taskid)
      debug  = control_print(print_debug)
      dprint = ((taskid.eq.MASTER).and.control_print(print_debug))
      mprint = ((taskid.eq.MASTER).and.control_print(print_high))
      lprint = ((taskid.eq.MASTER).and.control_print(print_medium))

cc*     **** debug ****
c       if (debug) then
c          call dcopy(3*nion,0.0d0,0,G1,1)
c          call psi_1force_local(G1)
c          if (dprint) call write_force(nion,G1,"local")
c          call dcopy(3*nion,0.0d0,0,G1,1)
c          call psi_1force_nonlocal(G1)
c          if (dprint) call write_force(nion,G1,"nonlocal")
c          call dcopy(3*nion,0.0d0,0,G1,1)
c          if (psp_semicore(0)) call electron_semicoreforce(G1)
c          if (dprint) call write_force(nion,G1,"xc")
c          call dcopy(3*nion,0.0d0,0,G1,1)
c          if (control_version().eq.3) call ewald_f(G1)
c          if (control_version().eq.4) call ion_ion_f(G1)
c          if (dprint) call write_force(nion,G1,"ewald ")
c          call dcopy(3*nion,0.0d0,0,G1,1)
c          if (pspw_qmmm_found()) call pspw_qmmm_LJ_fion(G1)
c          if (dprint) call write_force(nion,G1,"LJ ")
c          call dcopy(3*nion,0.0d0,0,G1,1)
c          if (pspw_qmmm_found()) call pspw_qmmm_Q_fion(G1)
c          if (dprint) call write_force(nion,G1,"Q ")
c          call dcopy(3*nion,0.0d0,0,G1,1)
c          call psi_1force_psp_U_v_nonlocal(G1)
c          if (dprint) call write_force(nion,G1,"psp_U_v_nonlocal")
c       end if
cc*     **** debug ****
      
      call dcopy(3*nion,0.0d0,0,G1,1)

      call psi_1force(G1)
      if (psp_semicore(0)) call electron_semicoreforce(G1)

      if (control_version().eq.3) call ewald_f(G1)
      if (control_version().eq.4) call ion_ion_f(G1)
      if (pspw_qmmm_found()) call pspw_qmmm_fion(G1)
      if (ion_disp_on()) call ion_disp_force(G1)


      if (pspw_charge_found()) then
        if(pspw_bqext()) then
           call pspw_charge_charge_Fion(G1)
         else
           nion1 = ion_nion()
           call pspw_charge_Fion_Fcharge(G1,G1(1,nion1+1))
           call pspw_charge_Fcharge(G1(1,nion1+1))
           call rho_1Fcharge(G1(1,nion1+1))
         end if
      end if


*     **** remove ion forces using ion_FixIon ****
      call ion_FixIon(G1)

      if (.not.allow_translation) then
        call center_F_mass(G1,fmx,fmy,fmz)
        do i=1,nion
         G1(1,i) = G1(1,i) - fmx
         G1(2,i) = G1(2,i) - fmy
         G1(3,i) = G1(3,i) - fmz
        end do
      end if
      call center_F_mass(G1,fmx2,fmy2,fmz2)

      GG = 0.0d0
      fmax = 0.0d0
      do i=1,nion
         GG = GG + G1(1,i)**2 + G1(2,i)**2 + G1(3,i)**2
         fatom = dsqrt(G1(1,i)**2+G1(2,i)**2 +G1(3,i)**2)
         if (fatom.gt.fmax)  fmax = fatom
      end do


      if (taskid.eq.MASTER) then
        if (mprint) then
        !write(luout,1300)
        write(luout,1301)
        !write(luout,1302)
        end if

        if (lprint) then
        write(luout,1304)
        if (.not.allow_translation) write(luout,1400) fmx,fmy,fmz
        write(luout,1304)
        write(luout,1410)
        end if

        if (mprint) then
        write(luout,1420)
        do I=1,ion_nion()
          if (ion_q_FixIon(I)) then
           write(6,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3)
          else
           write(6,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3)
          end if
        end do
    

*       **** print out charge positions ***
        if (pspw_charge_found().and.(.not.pspw_bqext())) then
          do i=1,pspw_charge_nion()
            i1 = ion_nion() + i
            if (ion_q_FixIon(i1)) then
            write(luout,1193) i1,pspw_charge_aname(i),
     >                    (pspw_charge_rion(K,i),K=1,3),
     >                    pspw_charge_charge(i)
            else
            write(luout,1192) i1,pspw_charge_aname(i),
     >                    (pspw_charge_rion(K,i),K=1,3),
     >                    pspw_charge_charge(i)
            end if
          end do
        end if
        end if


        if (lprint) then
        write(luout,1421)
        write(luout,1190)(i,ion_aname(I),
     >                  (G1(K,I),K=1,3),I=1,ion_nion())

*       **** print out charge forces ***
        if (pspw_charge_found().and.(.not.pspw_bqext())) then
          do i=1,pspw_charge_nion()
            i1 = ion_nion() + i
            write(luout,1190) i1,pspw_charge_aname(i),
     >                    (G1(K,i1),K=1,3)
          end do
        end if

        write(luout,1210) fmx2,fmy2,fmz2  
        write(luout,1425)
        write(luout,1426) dsqrt(GG),
     >                    dsqrt(GG)/dble(nion),
     >                    fmax,fmax*(27.2116d0/0.529177d0)
        end if
      end if

c     call dscal(3*nion,(-1.0d0),G1,1)

      return
 1190 FORMAT(5X, I4, A5,  ' (',3F12.6,' )')
 1191 FORMAT(5X, I4, A5,  ' (',3F12.6,' ) - fixed')
 1192 FORMAT(5X, I4, A5,  ' (',3F12.6,' ) q=',F8.3)
 1193 FORMAT(5X, I4, A5,  ' (',3F12.6,' ) q=',F8.3,' - fixed')
 1210 FORMAT(5X,'   C.O.M.',' (',3F12.6,' )')
 1300 FORMAT(//'========================')
 1301 FORMAT(//'== Gradient Calculation ==')
 1302 FORMAT(  '========================')
 1304 FORMAT(/)
 1400 FORMAT('Translation force removed: (',3F11.5,')')
 1410 FORMAT(10X,'=============  Ion Gradients =================')
 1425 FORMAT(10X,'===============================================')
 1426 FORMAT(10X,'|F|       =',E15.6,
     >      /10x,'|F|/nion  =',E15.6,
     >      /10x,'max|Fatom|=',E15.6,1x,'(',F8.3,'eV/Angstrom)'//)
 1420 FORMAT( ' Ion Positions:')
 1421 FORMAT( ' Ion Forces:')
      end


*     ***************************
*     *				*
*     *	    cgsd_energy_stress	*
*     *				*
*     ***************************

      subroutine cgsd_energy_stress(stress,lstress)
      implicit none
      real*8 stress(3,3)
      real*8 lstress(6)

#include "stdio.fh"
#include "util.fh"

      integer taskid,MASTER
      parameter (MASTER=0)

*     **** local variables ****
      logical oprint,hprint
      integer u,v,s
      real*8  tstress(3,3),ht(3,3),scal
      real*8  sigma(3,3),xcstress(3,3)

*     **** external functions ****
      logical  psp_semicore,pspw_SIC,pspw_HFX,control_print,ion_disp_on
      integer  control_optimize_cell_strategy
      integer  control_optimize_lattice_vectors
      integer  control_optimize_lattice
      real*8   lattice_omega,lattice_unita
      external psp_semicore,pspw_SIC,pspw_HFX,control_print,ion_disp_on
      external control_optimize_cell_strategy
      external control_optimize_lattice_vectors
      external control_optimize_lattice
      external lattice_omega,lattice_unita


      call Parallel_taskid(taskid)
      oprint = ((taskid.eq.MASTER).and.control_print(print_medium))
      hprint = ((taskid.eq.MASTER).and.control_print(print_high))

      call dcopy(9,0.0d0,0,stress,1)

*     **** Kinetic energy component : dE_kin/dhuv ****
      call psi_1ke_stress(tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
      if (hprint) call write_stress(tstress,"ke")

*     **** Coulomb energy component : dE_Coul/dhuv ****
      call psi_1coulomb_stress(tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
      if (hprint) call write_stress(tstress,"coulomb")

*     **** Local pseudo energy component : dE_local/dhuv ****
      call dng_1vlocal_stress(tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
      if (hprint) call write_stress(tstress,"local")

*     **** Nonlocal pseudo energy component : dE_nolocal/dhuv ****
      call dcopy(9,0.0d0,0,tstress,1)
      call psi_1vnonlocal_stress(tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
      if (hprint) call write_stress(tstress,"nonlocal")

*     **** xc energy component : dE_xc/dhuv ****
      call dcopy(9,0.0d0,0,tstress,1)
      call rho_1exc_stress(tstress)
      call dcopy(9,tstress,1,xcstress,1)
      if (hprint) call write_stress(tstress,"xc1")

*     **** Core-correction Coulomb energy component : dE_core/dhuv ****
      if (psp_semicore(0)) then
        call rho_1semicore_stress(tstress)
        if (hprint) call write_stress(tstress,"xc2")
        call daxpy(9,1.0d0,tstress,1,xcstress,1)
      end if

      call daxpy(9,1.0d0,xcstress,1,stress,1)
      if (hprint) call write_stress(xcstress,"xc")

*     **** Ewald energy component : dE_ewald/dhuv ****
      call ewald_stress(tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
      if (hprint) call write_stress(tstress,"ewald")

*     **** SIC energy component : dE_SIC/dhuv ****
      if (pspw_SIC())  then
        call electron_SIC_stress(tstress)
        call daxpy(9,1.0d0,tstress,1,stress,1)
        if (hprint) call write_stress(tstress,"SIC")
      end if

*     **** HFX energy component : dE_HFX/dhuv ****
      if (pspw_hfx())  then
        call electron_HFX_stress(tstress)
        call daxpy(9,1.0d0,tstress,1,stress,1)
        if (hprint) call write_stress(tstress,"HFX")
      end if

*     **** Dispersion energy component : dE_disp/dhuv ****
      if (ion_disp_on()) then
        call ion_disp_stress(tstress)
        call daxpy(9,1.0d0,tstress,1,stress,1)
        if (hprint) call write_stress(tstress,"Dispersion")
      end if


**     **** define ht ****
       do v=1,3
       do u=1,3
          ht(u,v)=lattice_unita(v,u)
       end do
       end do

      call cell_lattice_gradient(stress,lstress)

*      **** apply lattice_vector constraints ****
       call zero_cell_constraint(stress,lstress)
 
**     **** define stress tensor ****
       call dcopy(9,0.0d0,0,sigma,1)
       scal = -1.0d0/lattice_omega()
       do v=1,3
       do u=1,3
          do s=1,3
             sigma(u,v) = sigma(u,v) + scal*stress(u,s)*ht(s,v)
          end do
       end do
       end do

c     *** call dscal(9,-1.0d0,stress,1)
      if (oprint) call write_stress(stress,"total gradient")

      if (oprint) then
        write(luout,*)
        write(luout,1811) "dE/da     = ",lstress(1)
        write(luout,1811) "dE/db     = ",lstress(2)
        write(luout,1811) "dE/dc     = ",lstress(3)
        write(luout,1811) "dE/dalpha = ",lstress(4)
        write(luout,1811) "dE/dbeta  = ",lstress(5)
        write(luout,1811) "dE/dgamma = ",lstress(6)
        write(luout,*)
      end if

      if (hprint) call write_stress(sigma,"Internal Stress Tensor")

      return
 1800 FORMAT('Lattice Constraint: gradient(',i1,',',i1,')-->0')
 1801 FORMAT('Lattice Constraint: gradient(',i1,')-->0')
 1811 FORMAT(5X,A14,F11.5)
      end

      subroutine write_stress(stress,name)
      implicit none
      real*8 stress(3,3)
      character*(*) name

#include "stdio.fh"

      integer MASTER,taskid
      parameter (MASTER=0)
      real*8 pressure,autoMbar,autoGPa,autoatm
      parameter (autoMbar=294.214239071d0)
      parameter (autoGPa=autoMbar*100.0d0)
      parameter (autoatm =290.360032539d6)

      call Parallel_taskid(taskid)
      if (taskid.eq.MASTER) then
         write(luout,1900)
         write(luout,1901)
         write(luout,1902)
         write(luout,1904)
         write(luout,1910) name
         write(luout,1911) stress(1,1),stress(1,2),stress(1,3)
         write(luout,1912) stress(2,1),stress(2,2),stress(2,3)
         write(luout,1912) stress(3,1),stress(3,2),stress(3,3)
         write(luout,1915)
         write(luout,1916) dsqrt(
     >                  stress(1,1)**2+stress(1,2)**2+stress(1,3)**2
     >                 +stress(2,1)**2+stress(2,2)**2+stress(2,3)**2
     >                 +stress(3,1)**2+stress(3,2)**2+stress(3,3)**2)
         pressure = (stress(1,1) + stress(2,2) + stress(3,3))/3.0d0
         write(luout,1917) pressure,
     >                 pressure*autoMbar,
     >                 pressure*autoGPa,
     >                 pressure*autoatm

 1900 FORMAT(//'======================')
 1901 FORMAT(  '= Stress calculation =')
 1902 FORMAT(  '======================')
 1904 FORMAT(/)
 1910 FORMAT(10X,'============= ',A,' ==============')
 1911 FORMAT(5X,' S = ',' (',3F11.5,' )')
 1912 FORMAT(5X,'     ',' (',3F11.5,' )')
 1915 FORMAT(10X,'===================================================')
 1916 FORMAT(10X,'|S|      = ',E11.5)
 1917 FORMAT(10X,'pressure = ',E9.3,' au',
     >      /10X,'         = ',E9.3,' Mbar'
     >      /10X,'         = ',E9.3,' GPa',
     >      /10X,'         = ',E9.3,' atm'/)
      end if

      return
      end



      subroutine write_lstress(lstress,name)
      implicit none
      real*8 lstress(6)
      character*(*) name

#include "stdio.fh"

      integer MASTER,taskid
      parameter (MASTER=0)
      real*8 pressure,autoMbar,autoGPa,autoatm
      parameter (autoMbar=294.214239071d0)
      parameter (autoGPa=autoMbar*100.0d0)
      parameter (autoatm =290.360032539d6)

      call Parallel_taskid(taskid)
      if (taskid.eq.MASTER) then
         write(luout,1900)
         write(luout,1901)
         write(luout,1902)
         write(luout,1904)
         write(luout,1910) name
         write(luout,1811) "dE/da     = ",lstress(1)
         write(luout,1811) "dE/db     = ",lstress(2)
         write(luout,1811) "dE/dc     = ",lstress(3)
         write(luout,1811) "dE/dalpha = ",lstress(4)
         write(luout,1811) "dE/dbeta  = ",lstress(5)
         write(luout,1811) "dE/dgamma = ",lstress(6)
         write(luout,1915)
         write(luout,*)

 1811 FORMAT(5X,A14,F11.5)
 1900 FORMAT(//'=======================')
 1901 FORMAT(  '= LStress calculation =')
 1902 FORMAT(  '=======================')
 1904 FORMAT(/)
 1910 FORMAT(10X,'============= ',A,' ==============')
 1911 FORMAT(5X,' S = ',' (',3F11.5,' )')
 1912 FORMAT(5X,'     ',' (',3F11.5,' )')
 1915 FORMAT(10X,'===================================================')
 1916 FORMAT(10X,'|S|      = ',E11.5)
 1917 FORMAT(10X,'pressure = ',E9.3,' au',
     >      /10X,'         = ',E9.3,' Mbar'
     >      /10X,'         = ',E9.3,' GPa',
     >      /10X,'         = ',E9.3,' atm'/)
      end if

      return
      end




*     ***********************************************
*     *                                             *
*     *            cgsd_pressure_stress             *
*     *                                             *
*     ***********************************************

      subroutine cgsd_pressure_stress(ispin,ne,psi,rhoall,dng,xcp,
     >                                evnl,exc,pxc,
     >                                pressure,p1,p2,stress)
      implicit none
      integer    ispin,ne(2)
      complex*16 psi(*),rhoall(*),dng(*)
      real*8     xcp(*)
      real*8     evnl,exc,pxc
      real*8     pressure,p1,p2 
      real*8     stress(3,3)

      integer taskid,MASTER
      parameter (MASTER=0)

*     **** local variables ****
      integer u,v,s,ii,gga,nfft3d
      real*8  tstress(3,3),ht(3,3),scal,scal2
      real*8  sigma(3,3),xcstress(3,3),hm(3,3),pi

*     **** external functions ****
      logical  psp_semicore,pspw_SIC,pspw_HFX,ion_disp_on
      integer  ion_nion,control_gga
      real*8   lattice_omega,lattice_unita,ion_vion,ion_amass
      real*8   lattice_unitg
      external psp_semicore,pspw_SIC,pspw_HFX
      external ion_nion,control_gga,ion_disp_on
      external lattice_omega,lattice_unita,ion_vion,ion_amass
      external lattice_unitg


      call dcopy(9,0.0d0,0,stress,1)

*     **** Kinetic energy component : dE_kin/dhuv ****
      call ke_euv(ispin,ne,psi,tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
c      p1 = (tstress(1,1)+tstress(2,2)+tstress(3,3))/3.0d0
c      write(*,*) "ke p=",p1

*     **** Coulomb energy component : dE_Coul/dhuv ****
      call coulomb_euv(dng,tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
c      p1 = (tstress(1,1)+tstress(2,2)+tstress(3,3))/3.0d0
c      write(*,*) "coulomb p=",p1

*     **** Local pseudo energy component : dE_local/dhuv ****
      call v_local_euv(dng,tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
c      p1 = (tstress(1,1)+tstress(2,2)+tstress(3,3))/3.0d0
c      write(*,*) "local p=",p1

*     **** Nonlocal pseudo energy component : dE_nolocal/dhuv ****
      call dcopy(9,0.0d0,0,tstress,1)
      call v_nonlocal_euv_2(ispin,ne,psi,tstress) 

*     *** define hm ****
      pi   = 4.0d0*datan(1.0d0)
      scal = 1.0d0/(2.0d0*pi)
      do v=1,3
      do u=1,3
         hm(u,v) = scal*lattice_unitg(u,v)
      end do
      end do
      do v=1,3
      do u=1,3
         tstress(u,v) = tstress(u,v) - evnl*hm(u,v)
      end do
      end do
      call daxpy(9,1.0d0,tstress,1,stress,1)
c      p1 = (tstress(1,1)+tstress(2,2)+tstress(3,3))/3.0d0
c      write(*,*) "nolocal p=",p1


*     **** xc energy component : dE_xc/dhuv ****
      call dcopy(9,0.0d0,0,tstress,1)

*     **** LDA part ****
      do v=1,3
      do u=1,3
         tstress(u,v) = (exc-pxc)*hm(u,v)
      end do
      end do

*     **** PBE96 GGA part ****
      gga = control_gga()
      call D3dB_nfft3d(1,nfft3d)
      if ((gga.ge.10).and.(gga.lt.100)) then
       call v_bwexc_euv(gga,2*nfft3d,ispin,rhoall,
     >                  1.0d0,1.0d0,xcstress)
       do v=1,3
       do u=1,3
          tstress(u,v) = tstress(u,v) + xcstress(u,v)
       end do
       end do
      end if

      if (gga.eq.110) then
       call v_bwexc_euv(10,2*nfft3d,ispin,rhoall,
     >                  0.75d0,1.0d0,xcstress)
       do v=1,3
       do u=1,3
          tstress(u,v) = tstress(u,v) + xcstress(u,v)
       end do
       end do
      end if

      if (gga.eq.112) then
       call v_bwexc_euv(12,2*nfft3d,ispin,rhoall,
     >                  0.75d0,1.0d0,xcstress)
       do v=1,3
       do u=1,3
          tstress(u,v) = tstress(u,v) + xcstress(u,v)
       end do
       end do
      end if

      if (gga.eq.114) then
       call v_bwexc_euv(14,2*nfft3d,ispin,rhoall,
     >                  1.00d0,1.0d0,xcstress)
       do v=1,3
       do u=1,3
          tstress(u,v) = tstress(u,v) + xcstress(u,v)
       end do
       end do
      end if


      if (gga.eq.115) then
       call v_bwexc_euv(15,2*nfft3d,ispin,rhoall,
     >                  0.80d0,1.0d0,xcstress)
       do v=1,3
       do u=1,3
          tstress(u,v) = tstress(u,v) + xcstress(u,v)
       end do
       end do
      end if


      call dcopy(9,tstress,1,xcstress,1)
c      p1 = (tstress(1,1)+tstress(2,2)+tstress(3,3))/3.0d0
c      write(*,*) "not finished, xc p=",p1

*     **** Core-correction Coulomb energy component : dE_core/dhuv ****
      if (psp_semicore(0)) then
        call semicore_euv_vxc(ispin,xcp,tstress)
        call daxpy(9,1.0d0,tstress,1,xcstress,1)
      end if

      call daxpy(9,1.0d0,xcstress,1,stress,1)

*     **** Ewald energy component : dE_ewald/dhuv ****
      call ewald_stress(tstress)
      call daxpy(9,1.0d0,tstress,1,stress,1)
c      p1 = (tstress(1,1)+tstress(2,2)+tstress(3,3))/3.0d0
c      write(*,*) "ewald p=",p1

*     **** SIC energy component : dE_SIC/dhuv ****
      if (pspw_SIC())  then
        call electron_SIC_stress(tstress)
        call daxpy(9,1.0d0,tstress,1,stress,1)
      end if

*     **** HFX energy component : dE_HFX/dhuv ****
      if (pspw_hfx())  then
        call electron_HFX_stress(tstress)
        call daxpy(9,1.0d0,tstress,1,stress,1)
      end if

*     **** Dispersion energy component : dE_disp/dhuv ****
      if (ion_disp_on()) then
         call ion_disp_stress(tstress)
        call daxpy(9,1.0d0,tstress,1,stress,1)
      end if


**     **** define ht ****
       do v=1,3
       do u=1,3
          ht(u,v)=lattice_unita(v,u)
       end do
       end do

 
**     **** define stress tensor ****
       call dcopy(9,0.0d0,0,sigma,1)
       scal = -1.0d0/lattice_omega()
       do v=1,3
       do u=1,3
          do s=1,3
             sigma(u,v) = sigma(u,v) + scal*stress(u,s)*ht(s,v)
          end do
       end do
       end do
       p1 = (sigma(1,1)+sigma(2,2)+sigma(3,3))/3.0d0


       scal = 1.0d0/lattice_omega()
       do ii=1,ion_nion()
         scal2 = ion_amass(ii)*scal
         do v=1,3
         do u=1,3
           sigma(u,v) = sigma(u,v) 
     >                + scal2*(ion_vion(u,ii)*ion_vion(v,ii))
         end do
         end do
       end do
       pressure = (sigma(1,1)+sigma(2,2)+sigma(3,3))/3.0d0
       p2 = pressure - p1

      return
      end


*     *******************************
*     *				    *
*     *	  cgsd_energy_gradient_md   *
*     *				    *
*     *******************************
      subroutine cgsd_energy_gradient_md(G1)
      implicit none
      real*8 G1(3,*)

      integer i,k,nion,nion1
      integer i1
      real*8  GG

*     **** external functions ****
      logical     psp_semicore,pspw_charge_found,pspw_qmmm_found
      character*4 ion_aname,pspw_charge_aname
      integer     ion_katm,ion_nion,control_version
      integer     pspw_charge_nion
      real*8      ion_rion,pspw_charge_rion
      real*8      pspw_charge_charge
      external psp_semicore,pspw_charge_found,pspw_qmmm_found
      external ion_aname,pspw_charge_aname
      external ion_katm,ion_nion,control_version
      external pspw_charge_nion
      external ion_rion,pspw_charge_rion
      external pspw_charge_charge
      logical  pspw_bqext,ion_disp_on
      external pspw_bqext,ion_disp_on

      nion = ion_nion()
      if (pspw_charge_found().and.
     >    (.not.pspw_bqext())) nion = nion + pspw_charge_nion()

      call dcopy(3*nion,0.0d0,0,G1,1)

      call psi_1force(G1)
      if (psp_semicore(0)) call electron_semicoreforce(G1)

      if (control_version().eq.3) call ewald_f(G1)
      if (control_version().eq.4) call ion_ion_f(G1)
      if (pspw_qmmm_found()) call pspw_qmmm_fion(G1)
      if (ion_disp_on()) call ion_disp_force(G1)

      if (pspw_charge_found()) then
        if(pspw_bqext()) then
           call pspw_charge_charge_Fion(G1)
         else
           nion1 = ion_nion()
           call pspw_charge_Fion_Fcharge(G1,G1(1,nion1+1))
           call pspw_charge_Fcharge(G1(1,nion1+1))
           call rho_1Fcharge(G1(1,nion1+1))
         end if
      end if

*     **** remove ion forces using ion_FixIon ****
      call ion_FixIon(G1)

      return
      end

      Subroutine Stupid_XF(G_C, G_V, AOBas, FitBas)
C$Id: stupid_xf.F 19697 2010-10-29 16:57:34Z d3y133 $
      Implicit NONE
C
      Integer G_C, G_V, AOBas, FitBas
C
      Integer NBF, NOcc, NVir, NFit
C     -------------------- biphenyl ------------------------------
      Parameter (NBF = 204, NOcc = 73, NVir = NBF-NOcc, NFit = 204)
c$$$C     -------------------------- He16 ----------------------------
c$$$      Parameter (NBF = 32, NOcc = 16, NVir = NBF-NOcc, NFit = 272)
C
      Double precision AOInts(NBF, NFit, NBF), First(NVir, NFit, NBF),
     $   Sec(NVir, NFit, NOcc), Third(NVir, NFit, NOcc), C(NBF, NBF),
     $   V(NFit, NFit)
C
      Logical Status
      Integer NAOSh, NFitSh, PSh, QSh, SSh, PLo, PHi, QLo, QHi,
     $   SLo, SHi, P, Q, S, Offset, LInt, LScr, H_Int, Int_Idx,
     $   H_Scr, Scr_Idx, I
C
#include "numerical_constants.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "global.fh"
C
C     Step 0: Generate AO integrals
C
      Write (6, *) '%%%%% Starting integral generation'
      Call Util_Flush(6)
C
      Call Int_Mem_2e3c(LInt, LScr)
      Status = .TRUE.
      Status = Status .AND. MA_Push_Get( MT_Dbl, LInt,
     $   'Integral eval', H_Int, Int_Idx)
      Status = Status .AND. MA_Push_Get( MT_Dbl, LScr,
     $   'Integral scr', H_Scr, Scr_Idx)
C
      Status = Status .AND. Bas_NumCont(AOBas, NAOSh)
      Status = Status .AND. Bas_NumCont(FitBas, NFitSh)
C
C
C
      Do Psh = 1, NAOSh
         Status = Bas_Cn2BFR( AOBas, PSh, Plo, Phi)
C
         Do Qsh = 1, NAOSh
            Status = Bas_Cn2BFR( AOBas, QSh, Qlo, Qhi)
C
            Do SSh = 1, NFitSh
               Status = Bas_Cn2BFR( FitBas, SSh, Slo, Shi)
C
C              Note that these guys come out (pq|s), despite the order
c              of the arguments.
C
               Call Int_2e3c( FitBas, SSh, AOBas, PSh, QSh,
     $            LScr, Dbl_MB(Scr_Idx), LInt, Dbl_MB(Int_Idx) )
C
               Offset = 0
               Do S = SLo, SHi
                  Do Q = QLo, QHi
                     Do P = PLo, PHi
                        AOInts(P, S, Q) = Dbl_MB(Int_Idx + Offset)
                        Offset = Offset + 1
                     EndDo
                  EndDo
               EndDo
C
            EndDo
         EndDo
      EndDo
C
      Status = MA_Pop_Stack(H_Scr)
      Status = MA_Pop_Stack(H_Int)
C
C     Step 1: Transform first index
C
      Write (6, *) '%%%%% Starting first transformation'
      Call Util_Flush(6)
C
      Call GA_Get(G_C, 1, NBF, 1, NBF, C, NBF)
      Call SGEMM('T', 'N', NVir, NFit*NBF, NBF,
     $  FP_One, C(1, NOcc+1), NBF, AOInts, NBF,
     $   FP_Zero, First, NVir)
C
C     Step 2: Transform second index
C
      Write (6, *) '%%%%% Starting second transformation'
      Call Util_Flush(6)
C
      Call SGEMM('N', 'N', NVir*NFit, NOcc, NBF,
     $   FP_One, First, NVir*NFit, C(1, 1), NBF, 
     $   FP_Zero, Sec, NVir*NFit)
C
C     Step 2a: write out partially transformed integrals
C
      Write (6, *) '%%%%% Starting first output'
      Call Util_Flush(6)
C
      Call OpenRec(50, NVir*NFit)
      Do I = 1, NOcc
         Call PutRec(50, I, NVir*NFit, Sec(1, 1, I) )
      EndDo
C
C     Step 3: Transform fitting index
C
      Write (6, *) '%%%%% Starting third transformation'
      Call Util_Flush(6)
C
      Call GA_Get(G_V, 1, NFit, 1, NFit, V, NFit)
      Do I = 1, NOcc
         Call SGEMM('N', 'N', NVir, NFit, NFit,
     $      FP_One, Sec(1, 1, I), NVir, V, NFit,
     $      FP_Zero, Third(1, 1, I), NVir)
      EndDo
C
C     Step 3a: write out fully transformed integrals
C
      Write (6, *) '%%%%% Starting second output'
      Call Util_Flush(6)
C
      Call OpenRec(51, NVir*NFit)
      Do I = 1, NOcc
         Call PutRec(51, I, NVir*NFit, Third(1, 1, I) )
      EndDo
C
C
C
      Return
      End
C
C
C
      Subroutine OpenRec(LU, NElem)
      Implicit NONE
      Integer LU, NElem
C
      Open (UNIT=LU, ACCESS='DIRECT', RECL=NElem*8)
      Return
      End
C
C
C
      Subroutine PutRec(LU, RecNr, NElem, A)
      Implicit NONE
      Integer LU, RecNr, NElem
      Double Precision A(NElem)
C
      Integer Junk
      Double precision ChkSum
C
      External SASUM, ISAMAX
      Double precision SASUM
      Integer IASMAX
C
      Write (LU, REC=RecNr) A
C
      ChkSum = SASUM(NElem, A, 1)
      Junk = ISAMAX(NElem, A, 1)
      Write (6, 9000) RecNr, ChkSum, A(Junk)
 9000 Format(1X, 'Record ', I5, ' checksum = ', F30.15,
     $   ' max = ', F30.15)
      Return
      End

*
* $Id: sum.F 19708 2010-10-29 18:04:21Z d3y133 $
*
*======================================================================
*
* DISCLAIMER
*
* This material was prepared as an account of work sponsored by an
* agency of the United States Government.  Neither the United States
* Government nor the United States Department of Energy, nor Battelle,
* nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
* ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
* COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
* SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
* INFRINGE PRIVATELY OWNED RIGHTS.
*
* ACKNOWLEDGMENT
*
* This software and its documentation were produced with Government
* support under Contract Number DE-AC06-76RLO-1830 awarded by the United
* States Department of Energy.  The Government retains a paid-up
* non-exclusive, irrevocable worldwide license to reproduce, prepare
* derivative works, perform publicly and display publicly by or for the
* Government, including the right to distribute to other Government
* contractors.
*
*======================================================================
*
*  -- PEIGS  routine (version 2.1) --
*     Pacific Northwest Laboratory
*     July 28, 1995
*
*======================================================================
C	These are special purpose integer functions used in an mxcomb call
C	The routines must be integer functions, they must return 0, and
C	the result of a hopefully commutative and associative operation goes 
C	into the 1st parameter.  The 1st 2 input parameters can be any data 
C	type, and the # of bytes these parameters occupy is denoted in the 
C	3rd input parameter.  Usually the 3rd parameter is not used.
********************************************************************
      integer function sumi(a,b,size)
      integer a,b,size
      a = a + b
      sumi = 0
      return
      end
********************************************************************
      integer function sumd(a,b,size)
      double precision a,b
      integer size
      a = a + b
      sumd = 0
      return
      end
********************************************************************
      integer function sumdv(a,b,size,nelm)
c
      double precision a(nelm),b(nelm)
      integer size
      do 10 i = 1,nelm
         a(i) = a(i) + b(i)
 10   continue
      sumdv = 0
      return
      end
c     
      integer function sumiv(a,b,size,nelm)
      integer nelm
      integer a(nelm),b(nelm)
      integer size
c
      do 10 i = 1,nelm
         a(i) = a(i) + b(i)
 10   continue
      sumiv = 0
      return
      end
c      
C     Do this silliness to keep the transputers happy
********************************************************************
C	This function is defined to keep mxcomb consistent with mxcomb
C	by using a double precision complex function
c
      integer function sumdc(a,b,size)
      complex*16 a, b
      integer size
      a = a + b
      sumdc = 0
      return
      end
c

      subroutine argos_prep_wrtnoe(lfntop,filtop,mdrs,ndrs,idrs,rdrs)
c
      implicit none
c
      integer lfntop
      character*(*) filtop
      integer mdrs,ndrs
      integer idrs(2,mdrs)
      real*8 rdrs(5,mdrs)
c
      integer i,j
      character*3 string
c
c     write solute NOE restraints
c
      if(ndrs.gt.0) then
      open(unit=lfntop,file=filtop(1:index(filtop,' ')-1),
     + form='formatted',status='unknown',err=9999)
    9 continue
      read(lfntop,100,end=10,err=9999) string
  100 format(a3)
      if(string.ne.'noe') goto 9
      goto 11
   10 continue
      write(lfntop,101)
  101 format('noe')
   11 continue
      write(lfntop,1000) ndrs
 1000 format(i5)
      do 1 j=1,ndrs
      write(lfntop,1001)
     + (idrs(i,j),i=1,2),(rdrs(i,j),i=1,5)
 1001 format(2i10,3f12.6,/,20x,2e12.5)
    1 continue
      close(unit=lfntop)
      endif
c
      return
c
 9999 continue
      call md_abort('Could not open filtop to write noe',0)
      return
      end
c $Id: argos_prep_wrtnoe.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_space_gaputf(node,fw,numwm,fs,numsa)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      real*8 fw(mwm,3,mwa),fs(msa,3)
      integer il,ih,jl,jh
c
      if(numwm.gt.0) then
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_put(ga_w,il,ih,jl+6*mwa+3,jl+9*mwa+2,fw,mwm)
      endif
      if(numsa.gt.0) then
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_put(ga_s,il,ih,jl+6,jl+8,fs,msa)
      endif
c
      return
      end
c $Id: argos_space_gaputf.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine cf_pbc(iopt,xd,ndd,xc,ndc,noff,n0,n1)
c
c $Id: cf_pbc.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "cf_common.fh"
c
      integer iopt,ndd,ndc,noff,n0,n1
      real*8 xd(ndd,3),xc(ndc,3),xt(3),xts
      integer i,ix,jx,ndim
      real*8 rin(3),pbcor,boxi(3)
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 cf_anint
      external cf_anint
#endif
c
      if(npbtyp.eq.0) return
c
      boxi(1)=one/box(1)
      boxi(2)=one/box(2)
      boxi(3)=one/box(3)
c
c     correction vector returned in xc
c     --------------------------------
c
      if(iopt.eq.0) then
c
      do 1 i=n0,n1
      xc(i,1)=zero
      xc(i,2)=zero
      xc(i,3)=zero
    1 continue
c
      ndim=3
      if(npbtyp.eq.2) ndim=2
c
c     rectangular box
c
      if(nbxtyp.eq.0.or.nbxtyp.eq.2) then
      do 2 ix=1,ndim
      do 3 i=n0,n1
      if(abs(xd(noff+i,ix)).gt.boxh(ix)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xc(i,ix)=cf_anint(xd(noff+i,ix)*boxi(ix))*box(ix)
#else
      xc(i,ix)=anint(xd(noff+i,ix)*boxi(ix))*box(ix)
#endif
      endif
    3 continue
    2 continue
      endif
c
      if(nbxtyp.eq.1) then
      do 4 i=n0,n1
      do 5 ix=1,3
      xts=zero
      do 6 jx=1,3
      xts=xts+vlati(ix,jx)*xd(noff+i,jx)
    6 continue
      xt(ix)=int(two*xts)
    5 continue
      do 7 ix=1,3
      xc(i,ix)=zero
      do 8 jx=1,3
      xc(i,ix)=xc(i,ix)+vlat(ix,jx)*xt(jx)
    8 continue
    7 continue
    4 continue
      endif
c
      if(nbxtyp.eq.2) then
      do 9 i=n0,n1
      pbcor=boxh(1)*aint(four*(abs((xd(noff+i,1)-xc(i,1))/box(1))
     + +abs((xd(noff+i,2)-xc(i,2))/box(2))
     + +abs((xd(noff+i,3)-xc(i,3))/box(3)))/three)
      do 10 ix=1,3
      xc(i,ix)=xc(i,ix)+sign(pbcor,(xd(noff+i,ix)-xc(i,ix)))
   10 continue
    9 continue
      endif
c
      endif
c
c     correction applied to xd
c     ------------------------
c
      if(iopt.eq.1) then 
c
      ndim=3
      if(npbtyp.eq.2) ndim=2
c
c     rectangular box
c
      if(nbxtyp.eq.0.or.nbxtyp.eq.2) then
      do 12 ix=1,ndim
      do 13 i=n0,n1
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      if(abs(xd(noff+i,ix)).gt.boxh(ix))
     + xd(noff+i,ix)=xd(noff+i,ix)-
     + cf_anint(xd(noff+i,ix)*boxi(ix))*box(ix)
#else
      if(abs(xd(noff+i,ix)).gt.boxh(ix))
     + xd(noff+i,ix)=xd(noff+i,ix)-anint(xd(noff+i,ix)*boxi(ix))*box(ix)
#endif
   13 continue
   12 continue
      endif
c
      if(nbxtyp.eq.1) then
      do 14 i=n0,n1
      do 15 ix=1,3
      rin(ix)=xd(noff+i,ix)
      xts=zero
      do 16 jx=1,3
      xts=xts+vlati(ix,jx)*xd(noff+i,jx)
   16 continue
      xt(ix)=int(two*xts)
   15 continue
      do 17 ix=1,3
      do 18 jx=1,3
      xd(noff+i,ix)=xd(noff+i,ix)-vlat(ix,jx)*xt(jx)
   18 continue
   17 continue
   14 continue
      endif
c
      if(nbxtyp.eq.2) then
      do 19 i=n0,n1
      pbcor=boxh(1)*aint(four*(abs(xd(noff+i,1)/box(1))
     + +abs(xd(noff+i,2)/box(2))+abs(xd(noff+i,3)/box(3)))/three)
      do 20 ix=1,3
      xd(noff+i,ix)=xd(noff+i,ix)-sign(pbcor,xd(noff+i,ix))
   20 continue
   19 continue
      endif
c
      endif
c
      return
      end

      subroutine qhop_alloc
c
c $Id: qhop_final.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "qhop_common.fh"
#include "mafdecls.fh"
c
c     original dimensions
c
      maxseq=5000
      mxseq=30
      maxpar=10000
      mxar=mxseq*30
      maxhv=4
c
c     allocate memory for parameter arrays
c
      if(.not.ma_push_get(mt_int,2*maxseq,'iptseq',l_ptseq,i_ptseq))
     + call md_abort('Failed to allocate iptseq',0)
      if(.not.ma_push_get(mt_int,mxseq,'iptarat',l_ptarat,i_ptarat))
     + call md_abort('Failed to allocate iptarat',0)
      if(.not.ma_push_get(mt_int,4*mxar,'iarat',l_iarat,i_iarat))
     + call md_abort('Failed to allocate iarat',0)
      if(.not.ma_push_get(mt_dbl,2*mxar,'racs',l_racs,i_racs))
     + call md_abort('Failed to allocate racs',0)
      if(.not.ma_push_get(mt_int,maxpar,'iptpar',l_ptpar,i_ptpar))
     + call md_abort('Failed to allocate iptpar',0)
      if(.not.ma_push_get(mt_dbl,31*maxpar,'par',l_par,i_par))
     + call md_abort('Failed to allocate par',0)
c
      return
      end
      subroutine qhop_finish
c
      implicit none
c
#include "qhop_common.fh"
#include "mafdecls.fh"
c
      if(.not.ma_pop_stack(l_par))
     + call md_abort('qhop_final: Failed to deallocate par',0)
      if(.not.ma_pop_stack(l_ptpar))
     + call md_abort('qhop_final: Failed to deallocate ptpar',0)
      if(.not.ma_pop_stack(l_racs))
     + call md_abort('qhop_final: Failed to deallocate racs',0)
      if(.not.ma_pop_stack(l_iarat))
     + call md_abort('qhop_final: Failed to deallocate arat',0)
      if(.not.ma_pop_stack(l_ptarat))
     + call md_abort('qhop_final: Failed to deallocate ptarat',0)
      if(.not.ma_pop_stack(l_ptseq))
     + call md_abort('qhop_final: Failed to deallocate ptseq',0)
c
      return
      end

      subroutine rohf_dens(g_vecs, nbf, nclosed, nopen,
     $     g_cdens, g_odens)
*
* $Id: rohf_dens.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "global.fh"
      integer g_vecs
      integer nbf
      integer nclosed
      integer nopen
      integer g_cdens
      integer g_odens
c
      call ga_matmul_patch('n', 't', 2.0d0, 0.0d0,
     $     g_vecs, 1, nbf, 1, nclosed,
     $     g_vecs, 1, nclosed, 1, nbf,
     $     g_cdens, 1, nbf, 1, nbf)
      call ga_symmetrize(g_cdens)
c
      if (nopen .gt. 0) then
         call ga_matmul_patch('n', 't', 1.0d0, 0.0d0,
     $        g_vecs, 1, nbf, nclosed+1, nclosed+nopen,
     $        g_vecs, nclosed+1, nclosed+nopen, 1, nbf,
     $        g_odens, 1, nbf, 1, nbf)
         call ga_symmetrize(g_odens)
      endif
c
      end

      SUBROUTINE ccsdtq_lr_alpha_15_48_4(d_a,k_a_offset,d_b,k_b_offset,d
     &_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_48_4.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h18 p13 h15 h16 )_ytrat + = 2/9 * Sum ( h9 h10 h11 p5 p6 p7 ) * t ( p5 p6 p7 p13 h9 h10 h11 h15 )_t * i3 ( h9 h10 h11 h18 h16 p5 p6 p7 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER h18b
      INTEGER h15b
      INTEGER h16b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h9b
      INTEGER h10b
      INTEGER h11b
      INTEGER p13b_1
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER p7b_1
      INTEGER h15b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER h11b_1
      INTEGER h18b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER h11b_2
      INTEGER h16b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(3)
      INTEGER isuperp
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p13b = noab+1,noab+nvab
      DO h18b = 1,noab
      DO h15b = 1,noab
      DO h16b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h18b-1)+int_mb(k_spin+p13b
     &-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+h16b-1).ne.8)) THEN
      IF (int_mb(k_spin+h18b-1)+int_mb(k_spin+p13b-1) .eq. int_mb(k_spin
     &+h15b-1)+int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+h18b-1),ieor(int_mb(k_sym+p13b-1),ieor(int_m
     &b(k_sym+h15b-1),int_mb(k_sym+h16b-1)))) .eq. ieor(irrep_y,ieor(irr
     &ep_tra,irrep_t))) THEN
      dimc = int_mb(k_range+h18b-1) * int_mb(k_range+p13b-1) * int_mb(k_
     &range+h15b-1) * int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_48_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      DO h11b = h10b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+h9
     &b-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+p6b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb(k_sym+h15b-1),i
     &eor(int_mb(k_sym+h9b-1),ieor(int_mb(k_sym+h10b-1),int_mb(k_sym+h11
     &b-1)))))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_8(p13b,p5b,p6b,p7b,h15b,h9b,h10b,h11b,p13b_1,p
     &5b_1,p6b_1,p7b_1,h15b_1,h9b_1,h10b_1,h11b_1)
      CALL TCE_RESTRICTED_8(h18b,h9b,h10b,h11b,h16b,p5b,p6b,p7b,h18b_2,h
     &9b_2,h10b_2,h11b_2,h16b_2,p5b_2,p6b_2,p7b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+p7b-1) * int_mb(k_range+h9b-1) * int_mb(k_range+h10b-1) 
     &* int_mb(k_range+h11b-1)
      dima_sort = int_mb(k_range+p13b-1) * int_mb(k_range+h15b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h18b-1) * int_mb(k_range+h16b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_48_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_48_4',2,MA_ERR)
      IF ((p7b .le. p13b) .and. (h11b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p13b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p13b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h15b-1),8,4,7,6,5,3,2,1,1.0d0)
      END IF
      IF ((p7b .le. p13b) .and. (h10b .le. h15b) .and. (h15b .lt. h11b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h15b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p13b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p13b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b
     &-1),int_mb(k_range+h11b-1),7,4,8,6,5,3,2,1,-1.0d0)
      END IF
      IF ((p7b .le. p13b) .and. (h9b .le. h15b) .and. (h15b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h15b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p13b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p13b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h15b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),6,4,8,7,5,3,2,1,1.0d0)
      END IF
      IF ((p7b .le. p13b) .and. (h15b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (h15b_1 - 
     &1 + noab * (p13b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+p13b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),5,4,8,7,6,3,2,1,-1.0d0)
      END IF
      IF ((p6b .le. p13b) .and. (p13b .lt. p7b) .and. (h11b .le. h15b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h15b-1),8,3,7,6,5,4,2,1,-1.0d0)
      END IF
      IF ((p6b .le. p13b) .and. (p13b .lt. p7b) .and. (h10b .le. h15b) .
     &and. (h15b .lt. h11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h15b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b
     &-1),int_mb(k_range+h11b-1),7,3,8,6,5,4,2,1,1.0d0)
      END IF
      IF ((p6b .le. p13b) .and. (p13b .lt. p7b) .and. (h9b .le. h15b) .a
     &nd. (h15b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h15b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h15b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),6,3,8,7,5,4,2,1,-1.0d0)
      END IF
      IF ((p6b .le. p13b) .and. (p13b .lt. p7b) .and. (h15b .lt. h9b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (h15b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * 
     &(p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),5,3,8,7,6,4,2,1,1.0d0)
      END IF
      IF ((p5b .le. p13b) .and. (p13b .lt. p6b) .and. (h11b .le. h15b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p13b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h15b-1),8,2,7,6,5,4,3,1,1.0d0)
      END IF
      IF ((p5b .le. p13b) .and. (p13b .lt. p6b) .and. (h10b .le. h15b) .
     &and. (h15b .lt. h11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h15b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p13b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b
     &-1),int_mb(k_range+h11b-1),7,2,8,6,5,4,3,1,-1.0d0)
      END IF
      IF ((p5b .le. p13b) .and. (p13b .lt. p6b) .and. (h9b .le. h15b) .a
     &nd. (h15b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h15b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p13b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h15b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),6,2,8,7,5,4,3,1,1.0d0)
      END IF
      IF ((p5b .le. p13b) .and. (p13b .lt. p6b) .and. (h15b .lt. h9b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (h15b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p13b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),5,2,8,7,6,4,3,1,-1.0d0)
      END IF
      IF ((p13b .lt. p5b) .and. (h11b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p5b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h15b-1),8,1,7,6,5,4,3,2,-1.0d0)
      END IF
      IF ((p13b .lt. p5b) .and. (h10b .le. h15b) .and. (h15b .lt. h11b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h15b_1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p5b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h15b
     &-1),int_mb(k_range+h11b-1),7,1,8,6,5,4,3,2,1.0d0)
      END IF
      IF ((p13b .lt. p5b) .and. (h9b .le. h15b) .and. (h15b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h15b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p5b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h15b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),6,1,8,7,5,4,3,2,-1.0d0)
      END IF
      IF ((p13b .lt. p5b) .and. (h15b .lt. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h9b_1 - 1 + noab * (h15b_1 - 
     &1 + noab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (
     &p5b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b
     &-1),int_mb(k_range+h11b-1),5,1,8,7,6,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_48_4'
     &,3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_48_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_48_4',5,MA_ERR)
      IF ((h11b .le. h18b) .and. (h16b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h16b_2 - 1 + noab * (h18b_2 - 1 + noab * (h11b_2 - 1 + n
     &oab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h11b-1),int_mb(k_range+h18b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6
     &b-1),int_mb(k_range+p7b-1),5,4,3,2,1,8,7,6,1.0d0)
      END IF
      IF ((h10b .le. h18b) .and. (h18b .lt. h11b) .and. (h16b .le. p5b))
     & THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h16b_2 - 1 + noab * (h11b_2 - 1 + noab * (h18b_2 - 1 + n
     &oab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h18b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6
     &b-1),int_mb(k_range+p7b-1),5,3,4,2,1,8,7,6,-1.0d0)
      END IF
      IF ((h9b .le. h18b) .and. (h18b .lt. h10b) .and. (h16b .le. p5b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h16b_2 - 1 + noab * (h11b_2 - 1 + noab * (h10b_2 - 1 + n
     &oab * (h18b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h18b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6
     &b-1),int_mb(k_range+p7b-1),5,2,4,3,1,8,7,6,1.0d0)
      END IF
      IF ((h18b .lt. h9b) .and. (h16b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h16b_2 - 1 + noab * (h11b_2 - 1 + noab * (h10b_2 - 1 + n
     &oab * (h9b_2 - 1 + noab * (h18b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h18b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h11b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6
     &b-1),int_mb(k_range+p7b-1),5,1,4,3,2,8,7,6,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_48_4'
     &,6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      nsuperp(3) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      IF (p6b .eq. p7b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h9b .eq. h10b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h10b .eq. h11b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,36.0d0/FACTORIAL
     &(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsuperp(3))/FACTORIAL
     &(nsubh(1))/FACTORIAL(nsubh(2))/FACTORIAL(nsubh(3)),dbl_mb(k_a_sort
     &),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),di
     &ma_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &48_4',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &48_4',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_48_4',9,MA_ERR)
      IF ((h15b .le. h16b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h18b-1),int_mb(k_range+h15b-1),int_mb(k_range+p13
     &b-1),2,4,3,1,1.0d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h15b - 1 + noab * (p13b - noab - 1 + nvab * (h18b - 
     &1)))))
      END IF
      IF ((h16b .le. h15b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h18b-1),int_mb(k_range+h15b-1),int_mb(k_range+p13
     &b-1),2,4,1,3,-1.0d0/9.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h16b - 1 + noab * (p13b - noab - 1 + nvab * (h18b - 
     &1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_48_4'
     &,10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &48_4',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine gradients_input(rtdb)
C$Id: grad_inp.F 25572 2014-05-06 18:29:36Z niri $
c
      implicit none
c
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      integer ind,              ! Index of matched directive
     $     checkpoint           ! minutes between checkpoints
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 6)
      character*8 dirs(num_dirs)
      character*255 test
      data dirs /'chkpt','restart','print','noprint','point','end'/
c
 10   if (.not. inp_read()) call errquit
     $     ('gradients_input: inp_read failed', 0, INPUT_ERR)
c
      if (.not. inp_a(test))
     $     call errquit('gradients_input: failed to read keyword', 0,
     &       INPUT_ERR)
      call util_flush(6)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     $     call errquit('gradients_input: unknown directive', 0,
     &       INPUT_ERR)

      goto (100, 200, 300, 400, 500, 9999) ind
      call errquit('gradients_input: unimplemented directive', ind,
     &       INPUT_ERR)

 100  if (.not. inp_i(checkpoint)) call errquit
     $     ('scf_input: time between checkpoints missing', 0,
     &       INPUT_ERR)
      if (.not. rtdb_put(rtdb, 'gradients:checkpoint', mt_int, 1, 
     $                   checkpoint))
     $     call errquit('gradients_input: rtdb_put of chkpt failed', 0,
     &       RTDB_ERR)
      goto 10
c     
 200  if (.not. rtdb_put(rtdb,'gradients:restart', MT_LOG, 1, .true.))
     $     call errquit('gradients_input:rtdb_put of restart failed', 0,
     &       RTDB_ERR)
      goto 10
c
c     treatment of point charges now in geometry
c     
 500  call errquit('gradients_input: see geometry bqbq directive',0,
     &       INPUT_ERR)
c
c	print and noprint
c
 300  continue
 400  continue
      call util_print_input(rtdb, 'gradients')
      goto 10
c
c     end
c     
 9999 continue
c     
      end

c===============================================================c
c                                                               c
c       Socrates - an NWChem module for teaching                c
c       Copyright © 2009 Jeff Hammond                           c
c                                                               c
c       Developed by:                                           c
c                                                               c
c               Jeff R. Hammond                                 c
c               Leadership Computing Facility                   c
c               Argonne National Laboratory                     c
c               jhammond@mcs.anl.gov                            c
c                                                               c
c===============================================================c
      logical function socrates_driver(rtdb)
c
c $Id: socrates_driver.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "schwarz.fh"
c
c     object handles
c
      integer rtdb             ! RTDB handle
      integer geom             ! GEOM handle
c
c     variables
c
      integer scf_alg
      integer nuclear_charge
      integer total_charge
      integer nopen
      integer num_elec
      integer num_alfa
      integer num_beta
c
      double precision dtemp
c
      logical debug
      logical nodezero
      logical stat
      logical use_symm
c
      character*8 group
c
c     function declarations
c
      logical socrates_scf_serial
      external socrates_scf_serial
      logical socrates_scf_ga
      external socrates_scf_ga
c
#ifdef DEBUG_PRINT
      debug = (GA_NodeId().eq.0) ! debug print on nodezero only
c      debug = .true. ! debug print everywhere
#else
      parameter debug = .false.
#endif
c
c===============================================================c
c                                                               c
c                        INITIALIZATION                         c
c                                                               c
c===============================================================c
c
      nodezero=(ga_nodeid().eq.0)
c
      if (debug) write(LuOut,*) 'top of socrates_driver'
c
      socrates_driver = .false.
c
      if (.not.rtdb_get(rtdb,'socrates:scf_alg',mt_int,1,scf_alg)) then
        scf_alg = 2
      endif
c
c===============================================================c
c                                                               c
c     Setup molecular parameters                                c
c                                                               c
c===============================================================c
c
c     ---------------------
c     Geometry and symmetry
c     ---------------------
c
      if (.not.geom_create(geom,'geometry')) then
        call errquit(__FILE__,__LINE__,GEOM_ERR)
      endif
      if (.not.geom_rtdb_load(rtdb,geom,'geometry')) then
        call errquit(__FILE__,__LINE__,GEOM_ERR)
      endif
c
      call sym_group_name(geom,group)
      use_symm = (group(1:2) .ne. 'C1')
c
      if (use_symm) then
#ifndef SYMMETRY_ENABLED
        write(LuOut,*) 'Please implement symmetry'
        call errquit(__FILE__,__LINE__,GEOM_ERR)
#else
        if(nodezero) then
          write(LuOut,*) ' BE CAREFUL!  Using symmetry: ',group
        endif
#endif
        call util_flush(LuOut)
      endif
c
c     ------
c     Charge
c     ------
c
c     total charge
c
      if (.not.rtdb_get(rtdb, 'charge',mt_dbl,1,dtemp)) then
        dtemp = 0.0d0
      endif
      total_charge = int(dtemp)
      if ((dble(total_charge)-dtemp).gt.1e-7) then
        call errquit(__FILE__,__LINE__,INPUT_ERR)
      endif
c
c     nuclear charge
c
      if (.not. geom_nuc_charge(geom, dtemp)) then
        call errquit(__FILE__,__LINE__,GEOM_ERR)
      endif
      nuclear_charge = int(dtemp)
      if ((dble(nuclear_charge)-dtemp).gt.1e-7) then
        call errquit(__FILE__,__LINE__,INPUT_ERR)
      endif
c
c     electron count
c
      num_elec = nuclear_charge - total_charge
      if (num_elec.le.0) then
        if (nodezero) then
          write(LuOut,*) 'Electrons required!'
        endif
        call util_flush(LuOut)
        call errquit(__FILE__,__LINE__,INPUT_ERR)
      endif
c
c     open-shell
c
      if (.not.rtdb_get(rtdb,'socrates:nopen',mt_int,1,nopen)) then
        nopen = 0
      endif
      if (mod(num_elec-nopen,2).eq.0) then
        num_beta = (num_elec-nopen)/2
        num_alfa = num_elec-num_beta
      else
        if (nodezero) write(LuOut,*) 'nopen is wrong'
        call util_flush(LuOut)
        call errquit(__FILE__,__LINE__,INPUT_ERR)
        num_beta = 0 ! I hate compiler warnings 
        num_alfa = 0 ! I hate compiler warnings
      endif
      if (.not.rtdb_put(rtdb,'socrates:num_alfa',mt_int,1,
     1                  num_alfa)) then
           call errquit(__FILE__,__LINE__,RTDB_ERR)
      endif
      if (.not.rtdb_put(rtdb,'socrates:num_beta',mt_int,1,
     1                  num_beta)) then
           call errquit(__FILE__,__LINE__,RTDB_ERR)
      endif
c
c===============================================================c
c                                                               c
c                           RUN SCF                             c
c                                                               c
c===============================================================c
c
      if (scf_alg.eq.1) then
        if (nodezero) write(LuOut,102)
  102   format(/,'SCF with GA algorithm',/)
        stat = socrates_scf_ga(rtdb,geom,num_alfa,num_beta)
        if (.not.stat) then
          write(LuOut,*) 'socrates_scf_ga failed'
          call util_flush(LuOut)
          call errquit(__FILE__,__LINE__,GEOM_ERR)
        endif
      else
        write(LuOut,*) 'invalid scf_alg'
        call util_flush(LuOut)
        call errquit(__FILE__,__LINE__,GEOM_ERR)
      endif
c
c===============================================================c
c                                                               c
c                         TERMINATION                           c
c                                                               c
c===============================================================c
c
      if (.not.geom_destroy(geom)) then
        call errquit(__FILE__,__LINE__,GEOM_ERR)
      endif
c
      socrates_driver = .true.
c
      if (debug) then
        write(LuOut,*) 'end of socrates_driver'
        call util_flush(LuOut)
      endif
c
      return
c
      end

      subroutine argos_cafe_pr_imprs(lfnout,nso,mso,msp,
     + ioop,oop,roop,snam)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      integer lfnout,nso,mso,msp
      integer ioop(mso,5)
      real*8 oop(mso,msp,mset),roop(mso,2)
      character*16 snam(nsatot)
c
      integer i,j
c
      if(np.gt.1) call ga_dgop(mcf_54,roop,2*mso,'+')
      if(me.ne.0) return
c
      write(lfnout,1000)
 1000 format(/,' Solute out of plane torsions',/,
     + '      i      j      k      l     atom_i           ',
     + 'atom_j           atom_k           atom_l           ',
     + ' c  mul    theta_0     C         theta         U',/)
c
      do 1 i=1,nso
      write(lfnout,1001) (ioop(i,j),j=1,4),
     + (snam(ioop(i,j))(12:16)//':'//snam(ioop(i,j))(1:11),j=1,4),
     + ioop(i,5),(oop(i,j,iset),j=1,3),(roop(i,j),j=1,2)
 1001 format(4i7,4a17,i7,f5.1,f10.5,e12.5,f10.5,f12.6)
    1 continue
c
      return
      end
c $Id: argos_cafe_pr_imprs.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup selci
C> @{
      subroutine selci_prtri(d,n)
*
* $Id: prtri.F 24790 2013-11-11 18:56:49Z d3y133 $
*
c
c     ----- print out a real triangular matrix -----
c
#include "implicit.fh"
      dimension d(*),dd(6)
      iw = 6
c
      max = 6
      imax = 0
  100 imin = imax+1
      imax = imax+max
      if (imax .gt. n) imax = n
      write (iw,9008)
      write (iw,8028) (i,i = imin,imax)
      do 160 j = 1,n
         k = 0
         do 140 i = imin,imax
            k = k+1
            m = max0(i,j)*(max0(i,j)-1)/2 + min0(i,j)
            dd(k) = d(m)
 140     continue
         write (iw,8048) j,(dd(i),i = 1,k)
  160 continue
      if (imax .lt. n) go to 100
      return
 9008 format(/)
 8028 format(6x,6(4x,i4,4x))
 8048 format(i5,1x,6f12.6)
      end
C> @}

c $Id: exactd_mem.F 19696 2010-10-29 16:53:42Z d3y133 $
*
***********************************************************************
c:tex-% part of the API Internal Routines
c:tex-\subsection{exactd\_mem}
c:tex-This routine computes the memory required by the 
c:tex-McMurchie-Davidson integral derivative code developed at PNNL.
c:tex-This calls specific routines listed below for each integral
c:tex-derivative type.  The data is stored in a common block (apiP.fh)
c:tex-for fast retrieval from the int\_mem routines.
c:tex-
***********************************************************************
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine exactd_mem(rtdb,bases,nbas)
c:tex-\end{verbatim}
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "bas.fh"
#include "apiP.fh"
#include "stdio.fh"
#include "bgj.fh"
#include "util.fh"
c
c:: functions
      logical api_is_atomic_basis
      external api_is_atomic_basis
c:: passed
c:tex-\begin{verbatim}
      integer rtdb        ! [input] the RTDB handle
      integer nbas        ! [input] number of basis sets
      integer bases(nbas) ! [input} array of basis set handles
c:tex-\end{verbatim}
c:: local
      integer lmem_2e4c, lmem_1e
      integer lsz_2e4c, lsz_1e
      integer ibas,jbas
      integer nbfmax, nbf
      logical o_do_full
c
c check to see if a full memory check is needed
c
c:tex-
c:tex-{\bf Debugging Note:} using a set directive to set the 
c:tex-variable ``int:full\_mem'' to true will force the more 
c:tex-expensive $O(N^4)$ algorithm to be used to compute the 
c:tex-memory requirements for the 2-electron integral derivatives.
c:tex-
      if (.not.(rtdb_get(rtdb,'int:full_mem',Mt_Log,1,o_do_full)))
     &    o_do_full = .false.
c
      call int_mem_zero()
c
      nbfmax = 0
      do 00100 ibas = 1,nbas
        if (api_is_atomic_basis(bases(ibas))) then
          call int_nbf_max(bases(ibas),nbf)
          nbfmax = max(nbfmax,nbf)
          do 00200 jbas = 1,ibas
            if (api_is_atomic_basis(bases(jbas))) then
c.... nbfmax for 2e3c and 2e4c
              if (bases(jbas).ne.bases(ibas)) then
                call int_nbf_max(bases(ibas),nbf)
                nbfmax = max(nbfmax,nbf)
              endif
              if (o_do_full) then
c.... 2e 4 center full computation
                call emem_d2e4c_full
     &              (bases(ibas),bases(jbas),lsz_2e4c,lmem_2e4c)
              else
c.... 2e 4 center
                call emem_d2e4c
     &              (bases(ibas),bases(jbas),lsz_2e4c,lmem_2e4c)
              endif
              mem_2e4c = max(mem_2e4c, lmem_2e4c)
              isz_2e4c = max(isz_2e4c, lsz_2e4c)
c.... 1e
              call emem_d1e(bases(ibas), bases(jbas), lsz_1e, lmem_1e)
              mem_1e = max(mem_1e, lmem_1e)
              isz_1e = max(isz_1e, lsz_1e)
*debug:          write(luout,*)' ibas|jbas ', ibas, '|', jbas
*debug:          write(luout,*)' mem_2e4c: ',mem_2e4c
*debug:          write(luout,*)' mem_1e  : ',mem_1e
            endif
00200     continue
        endif
00100 continue
c
c.. memory for relativistic one-electron integrals
c
      if (dyall_mod_dir) then
        call emem_d1e_rel(sc_bsh, sc_bsh, lsz_1e, lmem_1e)
        mem_1e = max(mem_1e, lmem_1e)
        isz_1e = max(isz_1e, lsz_1e)
      end if
c
c tmp for ecp derivatives
c
      mem_1e = mem_1e * 3
c
c.. need extra memory for H1 call externalized by int_mem_h1 (Ta)
c
      mem_1e_h1 = mem_1e + nbfmax*nbfmax*3*2
      mem_3ov   = 2*mem_1e_h1  ! WAG
c
c... 2e3c and 2e2c use same scratch space so the maxg is the only thing that changes      
c
      isz_2e3c = 3*3*nbfmax**3
      isz_2e2c = 2*3*nbfmax**2
      mem_2e3c = mem_2e4c
      mem_2e2c = mem_2e4c
c
c for NWChem blocking interface
c
      iszb_2e4c = isz_2e4c  ! one quartet minimum
      memb_2e4c = mem_2e4c + mem_2e4c/5 ! + 20 % 
c
      if (numd_red.gt.numd_tot/33) then
        if (ga_nodeid().eq.0) then
          write(luout,*)
     &        ' integral derivatives have > 33% split blocks'
          write(luout,*)
     &        ' insert the following into your input deck'
          write(luout,*)
     &        ' set "intd:approxmem" integer 9000000'
        endif
      endif
c
      end
c:tex-% part of API Internal Routines
c:tex-\subsection{emem\_d1e}
c:tex-This routine determines the maximum buffer and scratch size for the 
c:tex-one electron derivative integrals.
c:tex-This routine should not be called by application code.
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine emem_d1e(brain, ketin, max1e, memsize)
c:tex-\end{verbatim}
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "stdio.fh"
#include "util.fh"
c::functions
      integer int_unint 
      external int_unint
c::external bq functions (mv)
      logical geom_extbq_on
      external geom_extbq_on
      integer  geom_extbq_ncenter
      external  geom_extbq_ncenter

c::passed
c:tex-\begin{verbatim}
      integer brain   ! [input] bra basis set handle
      integer ketin   ! [input] ket basis set handle
      integer max1e   ! [output] max size of 1e integrals buffer
      integer memsize ! [output] max size of scratch space for 1e integral evaluation
c:tex-\end{verbatim}
c::local
      integer bra, ket, bra_ucont, ket_ucont, ibc, ikc, nint
      integer bra_type, ket_type, memdum, bra_geom, ket_geom
      integer bra_prim, ket_prim, ket_lim
      integer bra_gen, ket_gen
      integer max_nbf_bra,max_nbf_ket, nat
      integer bra_fact, ket_fact
      double precision factor
c
#include "bas_exndcf_sfn.fh"
c
      memsize = 0
      max1e = 0
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
c
      bra_ucont = infbs_head(HEAD_NCONT,bra)
      ket_ucont = infbs_head(HEAD_NCONT,ket)
c
      bra_geom  = ibs_geom(bra)
      ket_geom  = ibs_geom(ket)
      if (bra_geom.ne.ket_geom) then
        write(luout,*)'emem_d1e: two different geometries for',
     &         ' derivatives?'
        call errquit('emem_d1e: geom error ',911, GEOM_ERR)
      endif
c
      nat = ncenter(bra_geom)
c
c     add number of external bq's if any (MV)
c     --------------------------------------
      if(geom_extbq_on()) then
        nat = nat + geom_extbq_ncenter() 
      end if
c
c
      do 00100 ibc = 1, bra_ucont
        bra_fact = 1
        ket_fact = 1
c
        bra_type = infbs_cont(CONT_TYPE,ibc,bra)
        bra_prim = infbs_cont(CONT_NPRIM,ibc,bra)
        bra_gen  = infbs_cont(CONT_NGEN,ibc,bra)
        if (bra_gen.gt.1) then
          bra_gen = 1
          bra_fact = 1
        endif
        if (bra_type.lt.0) then
          bra_type = abs(bra_type)
          bra_gen  = 1
        endif
c
        if (bra.eq.ket) then
          ket_lim = ibc
        else
          ket_lim = ket_ucont
        endif
c
        do 00200 ikc = 1, ket_lim
          ket_type = infbs_cont(CONT_TYPE,ikc,ket)
          ket_prim = infbs_cont(CONT_NPRIM,ikc,ket)
          ket_gen  = infbs_cont(CONT_NGEN,ikc,ket)
          if (ket_gen.gt.1) then
            ket_gen = 1
            ket_fact = 1
          endif
          if (ket_type.lt.0) then
            ket_type = abs(ket_type)
            ket_gen  = 1
          endif
c
          memdum = 20 000 000
          nint = int_unint(brain,ibc,ketin,ikc,0,0,0,0)
          call hf1d(
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), bra_prim, bra_gen,
     &          bra_type, 1, dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          ket_prim, ket_gen, ket_type, 2,
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), nat, dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          nint, .true., .true., .true., .false., .true.,
     &          dbl_mb(mb_exndcf(1,1)), memdum)
          memsize = max(memsize,(bra_fact*ket_fact*memdum))
00200   continue
00100 continue
c
      call int_nbf_max(brain,max_nbf_bra)
      if (ketin.eq.brain) then
        max_nbf_ket = max_nbf_bra
      else
        call int_nbf_max(ketin,max_nbf_ket)
      endif
c
      max1e = max_nbf_bra*max_nbf_ket*nat*3
      memsize = max(max1e,memsize)
c
      factor = 1.20d00
      memsize = int(dble(memsize)*factor)
      max1e   = int(dble(max1e)*factor)
*debug:      write(luout,'(a,i10)')'emem_d1e: memsize =',memsize
*debug:      write(luout,'(a,i10)')'emem_d1e: max1e   =',max1e
*debug:      write(luout,*)' factor =',factor
c
      end
c:tex-% part of API Internal Routines
c:tex-\subsection{emem\_d1e\_rel}
c:tex-This routine determines the maximum buffer and scratch size for the 
c:tex-one electron derivative relativistic integrals.
c:tex-This routine should not be called by application code.
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine emem_d1e_rel(brain, ketin, max1e, memsize)
c:tex-\end{verbatim}
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "stdio.fh"
#include "util.fh"
c::functions
      integer int_unint 
      external int_unint
c::passed
c:tex-\begin{verbatim}
      integer brain   ! [input] bra basis set handle
      integer ketin   ! [input] ket basis set handle
      integer max1e   ! [output] max size of 1e integrals buffer
      integer memsize ! [output] max size of scratch space for 1e integral evaluation
c:tex-\end{verbatim}
c::local
      integer bra, ket, bra_ucont, ket_ucont, ibc, ikc, nint
      integer bra_type, ket_type, memdum, bra_geom, ket_geom
      integer bra_prim, ket_prim, ket_lim
      integer bra_gen, ket_gen
      integer max_nbf_bra,max_nbf_ket, nat
      integer bra_fact, ket_fact
      integer rel_dbg, rel_typ
      double precision factor
c
#include "bas_exndcf_sfn.fh"
c
      memsize = 0
      max1e = 0
c
c     relativistic integral options. rel_typ selects scalar (1),
c     spin-orbit (3) or both (4). Should be passed when spin-orbit 
c     integrals are needed, or included in a common block.
c
      rel_dbg = 0
      rel_typ = 1
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
c
      bra_ucont = infbs_head(HEAD_NCONT,bra)
      ket_ucont = infbs_head(HEAD_NCONT,ket)
c
      bra_geom  = ibs_geom(bra)
      ket_geom  = ibs_geom(ket)
      if (bra_geom.ne.ket_geom) then
        write(luout,*)'emem_d1e_rel: two different geometries for',
     &         ' derivatives?'
        call errquit('emem_d1e_rel: geom error ',911, GEOM_ERR)
      endif
c
      nat = ncenter(bra_geom)
c
      do 00100 ibc = 1, bra_ucont
        bra_fact = 1
        ket_fact = 1
c
        bra_type = infbs_cont(CONT_TYPE,ibc,bra)
        bra_prim = infbs_cont(CONT_NPRIM,ibc,bra)
        bra_gen  = infbs_cont(CONT_NGEN,ibc,bra)
        if (bra_gen.gt.1) then
          bra_gen = 1
          bra_fact = 1
        endif
        if (bra_type.lt.0) then
          bra_type = abs(bra_type)
          bra_gen  = 1
        endif
c
        if (bra.eq.ket) then
          ket_lim = ibc
        else
          ket_lim = ket_ucont
        endif
c
        do 00200 ikc = 1, ket_lim
          ket_type = infbs_cont(CONT_TYPE,ikc,ket)
          ket_prim = infbs_cont(CONT_NPRIM,ikc,ket)
          ket_gen  = infbs_cont(CONT_NGEN,ikc,ket)
          if (ket_gen.gt.1) then
            ket_gen = 1
            ket_fact = 1
          endif
          if (ket_type.lt.0) then
            ket_type = abs(ket_type)
            ket_gen  = 1
          endif
c
          memdum = 20 000 000
          nint = int_unint(brain,ibc,ketin,ikc,0,0,0,0)
          call rel_oneld(
     &        dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &        dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &        bra_prim, bra_gen, bra_type, 1, 
     &        dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &        dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &        ket_prim, ket_gen, ket_type, 2,
     &        dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &        dbl_mb(mb_exndcf(1,1)), nat, dbl_mb(mb_exndcf(1,1)),
     &        dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
C .........           doS     doT     doV     canAB
     &        nint, .true., .true., .true., .false.,
C ........     do_nw   do_hnd   nonrel   dryrun
     &        .true., .false., .false., .true.,
     &        dbl_mb(mb_exndcf(1,1)), memdum,rel_dbg,rel_typ)
          memsize = max(memsize,(bra_fact*ket_fact*memdum))
00200   continue
00100 continue
c
      call int_nbf_max(brain,max_nbf_bra)
      if (ketin.eq.brain) then
        max_nbf_ket = max_nbf_bra
      else
        call int_nbf_max(ketin,max_nbf_ket)
      endif
c
      max1e = max_nbf_bra*max_nbf_ket*nat*3
      memsize = max(max1e,memsize)
c
      factor = 1.20d00
      memsize = int(dble(memsize)*factor)
      max1e   = int(dble(max1e)*factor)
*debug:      write(luout,'(a,i10)')'emem_d1e_rel: memsize =',memsize
*debug:      write(luout,'(a,i10)')'emem_d1e_rel: max1e   =',max1e
*debug:      write(luout,*)' factor =',factor
c
      end
c:tex-% part of the API Internal Routines
c:tex-\subsection{emem\_d2e4c}
c:tex-This routine determines the maximum buffer and scratch size for 
c:tex-the given basis sets to compute 2 electron derivative integrals.  
c:tex-The logic used is similar to that of the integral routine.  
c:tex-This routine should not be called by application code.
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine emem_d2e4c(brain, ketin, maxg, memsize)
c:tex-\end{verbatim}
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "stdio.fh"
#include "apiP.fh"
#include "util.fh"
c::functions
      integer int_unint
      external int_unint
c::passed
c:tex-\begin{verbatim}
      integer brain   ! [input] bra basis set handle
      integer ketin   ! [input] ket basis set handle
      integer maxg    ! [output] max size of 2e integrals buffer
      integer memsize ! [output] max size of scratch space for 2e integral evaluation
c:tex-\end{verbatim}
c::local
      integer bra, ket, bra_ucont, ket_ucont, ibc, ikc, nint
      integer bra_type, ket_type, memdum
      integer bra_prim, ket_prim, ket_lim
      integer bra_gen, ket_gen
      integer max_nbf_bra,max_nbf_ket
      integer bra_geom, ket_geom
      integer bra_cent, ket_cent
      integer bra_fact, ket_fact
      logical bra_rel, ket_rel, status_rel
      double precision factor
*debug:-start-debug
*debug:      integer fbra, fket, find
*debug:-start-end
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      memsize = 0
      maxg = 0
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
c
      bra_ucont = infbs_head(HEAD_NCONT,bra)
      ket_ucont = infbs_head(HEAD_NCONT,ket)
c
      bra_geom  = ibs_geom(bra)
      ket_geom  = ibs_geom(ket)
      if (bra_geom.ne.ket_geom) then
        write(luout,*)'emem_d2e4c: two different geometries for',
     &         ' derivatives?'
        call errquit('emem_d2e4c: geom error ',911, GEOM_ERR)
      endif
c 
c relativistic?
c
      status_rel = dyall_mod_dir .and. (.not.nesc_1e_approx)
     &    .and. (brain .eq. ketin) .and. (brain .eq. ao_bsh)
c
      do 00100 ibc = 1, bra_ucont
        bra_fact = 1
        ket_fact = 1
c
        bra_type = infbs_cont(CONT_TYPE,ibc,bra)
        bra_prim = infbs_cont(CONT_NPRIM,ibc,bra)
        bra_gen  = infbs_cont(CONT_NGEN,ibc,bra)
        bra_rel = infbs_cont(CONT_RELLS,ibc,bra) .ne. 0
        bra_cent  = (sf_ibs_cn2ce(ibc,bra))
        if (bra_gen.gt.1) then
          bra_gen = 1
          bra_fact = 1
        endif
        if (bra_type.lt.0) then
          bra_type = abs(bra_type)
          bra_gen  = 1
        endif
c
        if (bra.eq.ket) then
          ket_lim = ibc
        else
          ket_lim = ket_ucont
        endif
c
        do 00200 ikc = 1, ket_lim
          ket_type = infbs_cont(CONT_TYPE,ikc,ket)
          ket_prim = infbs_cont(CONT_NPRIM,ikc,ket)
          ket_gen  = infbs_cont(CONT_NGEN,ikc,ket)
          ket_rel = infbs_cont(CONT_RELLS ,ikc,ket) .ne. 0
          ket_cent  = (sf_ibs_cn2ce(ikc,ket))
          if (ket_gen.gt.1) then
            ket_gen = 1
            ket_fact = 1
          endif
          if (ket_type.lt.0) then
            ket_type = abs(ket_type)
            ket_gen  = 1
          endif
c
          memdum = 20 000 000
c. . . . . . . . . . . . . . . . . . . . . . . . . . . . coulomb
          nint = int_unint(brain,ibc,brain,ibc,ketin,ikc,ketin,ikc)
          if (status_rel .and. (bra_rel .or. ket_rel)) then
            if (ss_one_cent) then
              call rel_2e4cd_sf (
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,bra_cent,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,bra_cent,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,ket_cent,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,ket_cent,
c ...........                             canAB   canCD   canPQ
     &            dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........     DryRun
     &            .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &            bra_rel,ket_rel,ss_one_cent,do_ssss,0)
            else
              call rel_2e4cd_sf (
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,1,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,2,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,3,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,4,
c ...........                             canAB   canCD   canPQ
     &            dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........     DryRun
     &            .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &            bra_rel,ket_rel,ss_one_cent,do_ssss,0)
            end if
          else
            call hf2d(
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), bra_prim, bra_gen,
     &          bra_type, 1, dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          bra_prim, bra_gen, bra_type, 2,
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), ket_prim, ket_gen,
     &          ket_type, 3, dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          ket_prim, ket_gen, ket_type, 4,
     &          dbl_mb(mb_exndcf(1,1)), nint, .false., .false.,
     &          .false.,.true.,dbl_mb(mb_exndcf(1,1)), memdum)
          end if
*debug:-start-debug
*debug:          write(luout,*)
*debug:          write(luout,*)'===============================================',
*debug:     &        '================================='
*debug:          fbra = bra_prim*((bra_type+1)*(bra_type+2)/2)
*debug:          fket = ket_prim*((ket_type+1)*(ket_type+2)/2)
*debug:          find = fbra*fbra*fket*fket
*debug:          write(luout,10000)ibc,ibc,ikc,ikc,
*debug:     &        bra_prim,bra_prim,ket_prim,ket_prim,
*debug:     &        nint,memdum,find,(dble(memdum)/dble(find))
*debug:10000     format(1x,'<',4(i4),'>(',4(i3),') nint=',i10,
*debug:     &        ' memory =',i10,' find =',i10,' ratio = ',f10.3)
*debug:-end-debug
          memsize = max(memsize,memdum)
c
          memdum = 20 000 000
c. . . . . . . . . . . . . . . . . . . . . . . . . . . . exchange
          nint = int_unint(brain,ibc,brain,ibc,ketin,ikc,ketin,ikc)
          if (status_rel .and. bra_rel .and. ket_rel) then
            if (ss_one_cent) then
              call rel_2e4cd_sf (
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,bra_cent,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,ket_cent,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,bra_cent,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,ket_cent,
c ...........                             canAB   canCD   canPQ
     &            dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........     DryRun
     &            .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &            bra_rel,ket_rel,ss_one_cent,do_ssss,0)
            else
              call rel_2e4cd_sf (
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,1,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,2,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            bra_prim,bra_gen,bra_type,3,
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &            ket_prim,ket_gen,ket_type,4,
c ...........                             canAB   canCD   canPQ
     &            dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........     DryRun
     &            .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &            bra_rel,ket_rel,ss_one_cent,do_ssss,0)
            end if
          else
            call hf2d(dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), bra_prim, bra_gen, bra_type,
     &          1, dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), ket_prim, ket_gen, ket_type,
     &          2, dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), bra_prim, bra_gen, bra_type,
     &          3, dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &          dbl_mb(mb_exndcf(1,1)), ket_prim, ket_gen, ket_type,
     &          4, dbl_mb(mb_exndcf(1,1)), nint,.false.,.false.,
     &          .false., .true., dbl_mb(mb_exndcf(1,1)), memdum)
          end if
*debug:-start-debug
*debug:          find = fbra*fbra*fket*fket
*debug:          write(luout,10000)ibc,ikc,ibc,ikc,
*debug:     &        bra_prim,ket_prim,bra_prim,ket_prim,
*debug:     &        nint,memdum,find,(dble(memdum)/dble(find))
*debug:-end-debug
          memsize = max(memsize,memdum)
c
          if (bra.eq.ket) then
            memdum = 20 000 000
c. . . . . . . . . . . . . . . . . . . . . . . . . . . . triple (bb|bk)
            nint = int_unint(brain,ibc,brain,ibc,brain,ibc,ketin,ikc)
            if (status_rel .and. bra_rel .and. ket_rel) then
              if (ss_one_cent) then
                call rel_2e4cd_sf (
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,bra_cent,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,bra_cent,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,bra_cent,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,ket_cent,
c ...........                             canAB   canCD   canPQ
     &              dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........     DryRun
     &              .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &              bra_rel,ket_rel,ss_one_cent,do_ssss,0)
              else
                call rel_2e4cd_sf (
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,1,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,2,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,3,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,4,
c ...........                             canAB   canCD   canPQ
     &              dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........     DryRun
     &              .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &              bra_rel,ket_rel,ss_one_cent,do_ssss,0)
              end if
            else
              call hf2d(
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)), bra_prim, bra_gen,
     &            bra_type, 1,  dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            bra_prim, bra_gen, bra_type, 2,
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)), bra_prim, bra_gen,
     &            bra_type, 3, dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            ket_prim, ket_gen, ket_type, 4,
     &            dbl_mb(mb_exndcf(1,1)), nint, .false., .false.,
     &            .false., .true., dbl_mb(mb_exndcf(1,1)), memdum)
            end if
*debug:-start-debug
*debug:          find = fbra*fbra*fbra*fket
*debug:          write(luout,10000)ibc,ibc,ibc,ikc,
*debug:     &        bra_prim,bra_prim,bra_prim,ket_prim,
*debug:     &        nint,memdum,find,(dble(memdum)/dble(find))
*debug:-end-debug
            memsize = max(memsize,memdum)
c
            memdum = 20 000 000
c. . . . . . . . . . . . . . . . . . . . . . . . . . . . triple (bk|kk)
            nint = int_unint(brain,ibc,ketin,ikc,ketin,ikc,ketin,ikc)
            if (status_rel .and. bra_rel .and. ket_rel) then
              if (ss_one_cent) then
                call rel_2e4cd_sf (
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,bra_cent,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,ket_cent,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,ket_cent,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,ket_cent,
c ...........                                 canAB   canCD   canPQ
     &              dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........        DryRun
     &              .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &              bra_rel,ket_rel,ss_one_cent,do_ssss,0)
              else
                call rel_2e4cd_sf (
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              bra_prim,bra_gen,bra_type,1,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,2,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,3,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              ket_prim,ket_gen,ket_type,4,
c ...........                                 canAB   canCD   canPQ
     &              dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........        DryRun
     &              .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &              bra_rel,ket_rel,ss_one_cent,do_ssss,0)
              end if
            else
              call hf2d(
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)), bra_prim, bra_gen,
     &            bra_type, 1, dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            ket_prim, ket_gen, ket_type, 2,
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1))
     &            ,dbl_mb(mb_exndcf(1,1)),ket_prim,ket_gen,ket_type
     &            ,3,dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1))
     &            ,dbl_mb(mb_exndcf(1,1)),ket_prim,ket_gen,ket_type
     &            ,4,dbl_mb(mb_exndcf(1,1)),nint,.false.,.false.,
     &            .false.,.true.,dbl_mb(mb_exndcf(1,1)),memdum)
            end if
*debug:-start-debug
*debug:          find = fbra*fket*fket*fket
*debug:          write(luout,10000)ibc,ikc,ikc,ikc,
*debug:     &        bra_prim,ket_prim,ket_prim,ket_prim,
*debug:     &        nint,memdum,find,(dble(memdum)/dble(find))
*debug:          write(luout,*)'===============================================',
*debug:     &        '================================='
*debug:-end-debug
            memsize = max(memsize,(bra_fact*ket_fact*memdum))
          endif
00200   continue
00100 continue
c
      call int_nbf_max(brain,max_nbf_bra)
      if (ketin.eq.brain) then
        max_nbf_ket = max_nbf_bra
      else
        call int_nbf_max(ketin,max_nbf_ket)
      endif
      maxg = max_nbf_bra*max_nbf_bra
      maxg = maxg*max_nbf_ket*max_nbf_ket
      maxg = maxg*12
      memsize = max(memsize,maxg)
      factor = 1.50d00
      memsize = int(dble(memsize)*factor)
      maxg    = int(dble(maxg)*factor)
c
*debug:      write(luout,'(a,i10)')'emem_d2e4c: memsize =',memsize
*debug:      write(luout,'(a,i10)')'emem_d2e4c: maxg    =',maxg
*debug:      write(luout,*)' factor =',factor
c
      end
c:tex-% part of the API Internal Routines
c:tex-\subsection{emem\_d2e4c\_full}
c:tex-This routine determines the maximum buffer and scratch size for 
c:tex-the given basis sets to compute 2 electron derivative integrals.  
c:tex-The logic used is similar to that of the integral routine.  
c:tex-This routine should not be called by application code. 
c:tex-this routine computes the complete memory requirements using
c:tex-an $O(N^4$) algorithm
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine emem_d2e4c_full(brain, ketin, maxg, memsize)
c:tex-\end{verbatim}
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "stdio.fh"
#include "apiP.fh"
#include "util.fh"
c::functions
      integer int_unint
      external int_unint
c::passed
c:tex-\begin{verbatim}
      integer brain   ! [input] bra basis set handle
      integer ketin   ! [input] ket basis set handle
      integer maxg    ! [output] max size of 2e integrals buffer
      integer memsize ! [output] max size of scratch space for 2e integral evaluation
c:tex-\end{verbatim}
c::local
      integer approx_maxg
      integer approx_memsize
c
      integer bra, bra_ucont, bra_geom, max_nbf_bra
      integer ket, ket_ucont, ket_geom, max_nbf_ket, ket_lim
      integer ibc, i_type, i_prim, i_gen, i_atom
      integer jbc, j_type, j_prim, j_gen, j_atom
      integer kkc, k_type, k_prim, k_gen, k_atom
      integer lkc, l_type, l_prim, l_gen, l_atom
      integer memdum, nint
      logical bra_rel, ket_rel, status_rel
      double precision factor
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      call emem_d2e4c(brain,ketin,approx_maxg,approx_memsize)
      memsize = 0
      maxg = 0
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
c
      write(luout,*)' bra basis ',bs_name(bra)(1:len_bs_name(bra))
      write(luout,*)' ket basis ',bs_name(ket)(1:len_bs_name(ket))
c
      bra_ucont = infbs_head(HEAD_NCONT,bra)
      ket_ucont = infbs_head(HEAD_NCONT,ket)
c
      bra_geom  = ibs_geom(bra)
      ket_geom  = ibs_geom(ket)
      if (bra_geom.ne.ket_geom) then
        write(luout,*)'emem_d2e4c: two different geometries for',
     &         ' derivatives?'
        call errquit('emem_d2e4c: geom error ',911, GEOM_ERR)
      endif
c 
c relativistic?
c
      status_rel = dyall_mod_dir .and. (.not.nesc_1e_approx)
     &    .and. (brain .eq. ketin) .and. (brain .eq. ao_bsh)
c
      do ibc = 1, bra_ucont
c
        i_type = infbs_cont(CONT_TYPE ,ibc,bra)
        i_prim = infbs_cont(CONT_NPRIM,ibc,bra)
        i_gen  = infbs_cont(CONT_NGEN ,ibc,bra)
        i_atom = (sf_ibs_cn2ce(ibc,bra))
        if (i_gen.gt.1) then
          i_gen = 1
        endif
        if (i_type.lt.0) then
          i_type = abs(i_type)
          i_gen  = 1
        endif
        do jbc = 1, bra_ucont
          j_type = infbs_cont(CONT_TYPE ,jbc,bra)
          j_prim = infbs_cont(CONT_NPRIM,jbc,bra)
          j_gen  = infbs_cont(CONT_NGEN ,jbc,bra)
          j_atom = (sf_ibs_cn2ce(jbc,bra))
          if (j_gen.gt.1) then
            j_gen = 1
          endif
          if (j_type.lt.0) then
            j_type = abs(j_type)
            j_gen  = 1
          endif
          bra_rel = infbs_cont(CONT_RELLS,ibc,bra) .ne. 0
     &        .and. infbs_cont(CONT_RELLS,jbc,bra) .ne. 0
c
          if (bra.eq.ket) then
            ket_lim = bra_ucont
          else
            ket_lim = ket_ucont
          endif
c
          do kkc = 1, ket_lim
            k_type = infbs_cont(CONT_TYPE ,kkc,ket)
            k_prim = infbs_cont(CONT_NPRIM,kkc,ket)
            k_gen  = infbs_cont(CONT_NGEN ,kkc,ket)
            k_atom = (sf_ibs_cn2ce(kkc,ket))
            if (k_gen.gt.1) then
              k_gen = 1
            endif
            if (k_type.lt.0) then
              k_type = abs(k_type)
              k_gen  = 1
            endif
            do lkc = 1, ket_lim
              l_type = infbs_cont(CONT_TYPE ,lkc,ket)
              l_prim = infbs_cont(CONT_NPRIM,lkc,ket)
              l_gen  = infbs_cont(CONT_NGEN ,lkc,ket)
              l_atom = (sf_ibs_cn2ce(lkc,ket))
              if (l_gen.gt.1) then
                l_gen = 1
              endif
              if (l_type.lt.0) then
                l_type = abs(l_type)
                l_gen  = 1
              endif
              ket_rel = infbs_cont(CONT_RELLS,kkc,ket) .ne. 0
     &            .and. infbs_cont(CONT_RELLS,lkc,ket) .ne. 0
c
              memdum = 20 000 000
              nint = int_unint(brain,ibc,brain,jbc,ketin,kkc,ketin,lkc)
              if (status_rel .and. (bra_rel .or. ket_rel)) then
                call rel_2e4cd_sf (
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              i_prim, i_gen, i_type, i_atom,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              j_prim, j_gen, j_type, j_atom,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              k_prim, k_gen, k_type, k_atom,
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              dbl_mb(mb_exndcf(1,1)),dbl_mb(mb_exndcf(1,1)),
     &              l_prim, l_gen, l_type, l_atom,
c ...........                                 canAB   canCD   canPQ
     &              dbl_mb(mb_exndcf(1,1)),1,.false.,.false.,.false.,
c ...........       DryRun
     &              .true.,dbl_mb(mb_exndcf(1,1)),memdum,
     &              bra_rel,ket_rel,ss_one_cent,do_ssss,0)
              else
                call hf2d(
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),
     &            i_prim, i_gen, i_type, i_atom,
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),
     &            j_prim, j_gen, j_type, j_atom,
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),
     &            k_prim, k_gen, k_type, k_atom,
     &            dbl_mb(mb_exndcf(1,1)), dbl_mb(mb_exndcf(1,1)),
     &            dbl_mb(mb_exndcf(1,1)),
     &            l_prim, l_gen, l_type, l_atom,
     &            dbl_mb(mb_exndcf(1,1)), nint, .false., .false.,
     &            .false.,.true.,dbl_mb(mb_exndcf(1,1)), memdum)
              end if
              memsize = max(memsize,memdum)
            enddo
          enddo
        enddo
      enddo
c
      call int_nbf_max(brain,max_nbf_bra)
      if (ketin.eq.brain) then
        max_nbf_ket = max_nbf_bra
      else
        call int_nbf_max(ketin,max_nbf_ket)
      endif
      maxg = max_nbf_bra*max_nbf_bra
      maxg = maxg*max_nbf_ket*max_nbf_ket
      maxg = maxg*12
      memsize = max(memsize,maxg)
      factor = dble(maxg)/dble(approx_maxg)
      write(luout,'(a,i10)')  'emem_d2e4c     : maxg    =',approx_maxg
      write(luout,'(a,i10)')  'emem_d2e4c_full: maxg    =',maxg
      write(luout,'(a,f10.3)')'             maxg factor =',factor
      factor = dble(memsize)/dble(approx_memsize)
      write(luout,'(a,i10)')  'emem_d2e4c     : memsize =',
     &    approx_memsize
      write(luout,'(a,i10)')  'emem_d2e4c_full: memsize =',memsize
      write(luout,'(a,f10.3)')'          memsize factor =',factor
      call util_flush(6)
c
      end

*
* $Id: integrate_kbpp_e_band_local.F 22503 2012-05-20 06:58:57Z d3y133 $
*

      subroutine integrate_kbpp_e_band_local(version,
     >                            nrho,drho,lmax,locp,nmax,
     >                            n_extra,n_expansion,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nfft1,nfft2,nfft3,nprj,
     >                            G,vl,
     >                            n_prj,l_prj,m_prj,vnlnrm,
     >                            semicore,rho_sc_r,rho_sc_k,
     >                            ierr)
      implicit none
      integer          version
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      integer          nmax
      integer          n_extra,n_expansion(0:lmax)
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:(lmax+n_extra))
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nfft1,nfft2,nfft3,nprj
      double precision G(nfft1,nfft2,nfft3,3)
      double precision vl(nfft1,nfft2,nfft3)
      integer          n_prj(nprj),l_prj(nprj),m_prj(nprj)
      double precision vnlnrm(nmax,nmax,0:lmax)


      logical semicore
      double precision rho_sc_r(nrho,2)
      double precision rho_sc_k(nfft1,nfft2,nfft3,4)

      integer ierr

#include "mafdecls.fh"

      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      logical value
      integer lcount,task_count,nfft3d
      integer k1,k2,k3,i,l,n,nb,n1,n2
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3,p
      double precision gx,gy,gz,a,q,d
      integer indx(5,0:3)

*     **** external functions ****
      double precision dsum,simp
      external         dsum,simp


*     **** set up indx(n,l) --> to wp ****
      nb = lmax+1
      do l=0,lmax
         indx(1,l) = l
         do n=2,n_expansion(l)
            indx(n,l) = nb
            nb = nb+1
         end do
      end do

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      nfft3d = (nfft1)*nfft2*nfft3
      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      if ((nrho/2)*2.eq.nrho) then
        write(*,*)"local pseudopotential not computed: nrho is not odd"
        ierr=2
        return
      end if

      P0=DSQRT(FORPI)
      P1=DSQRT(3.0d0*FORPI)
      P2=DSQRT(15.0d0*FORPI)
      P3=DSQRT(105.0d0*FORPI)

*::::::::::::::::::  Define non-local pseudopotential  ::::::::::::::::
      do l=0,lmax
        if (l.ne.locp) then
          do i=1,nrho
            vp(i,l)=vp(i,l)-vp(i,locp)
          end do
        end if
      end do

*:::::::::::::::::::::  Normarization constants  ::::::::::::::::::::::
      lcount = 0
      do l=0,lmax
        if (l.eq.locp) then
           do n2 = 1, n_expansion(l)
           do n1 = n2,n_expansion(l)
              vnlnrm(n1,n2,l) = 0.0d0
              vnlnrm(n2,n1,l) = 0.0d0
           end do
           end do
        else
           do n2 = 1, n_expansion(l)
              do i=1,nrho
                 f(i)=vp(i,l)*wp(i,indx(n2,l))**2
              end do
              a=simp(nrho,f,drho)
              vnlnrm(n2,n2,l) = a
              do n1 = n2+1,n_expansion(l)
                 do i=1,nrho
                    f(i)=vp(i,l)*wp(i,indx(n1,l))*wp(i,indx(n2,l))
                 end do
                 a=simp(nrho,f,drho)
                 vnlnrm(n1,n2,l) = a
                 vnlnrm(n2,n1,l) = a
              end do
           end do
           if (n_expansion(l).eq.1) then
              vnlnrm(1,1,l) = 1/a
           else if (n_expansion(l).eq.2) then
              d = vnlnrm(1,1,l)*vnlnrm(2,2,l)
     >          - vnlnrm(1,2,l)*vnlnrm(2,1,l)
              q = vnlnrm(1,1,l)
              vnlnrm(1,1,l) = vnlnrm(2,2,l)/d
              vnlnrm(2,2,l) = q/d
              vnlnrm(1,2,l) = -vnlnrm(1,2,l)/d
              vnlnrm(2,1,l) = -vnlnrm(2,1,l)/d
           else
              call nwpw_matrix_invert(n_expansion(l),vnlnrm(1,1,l),nmax)
           end if
        end if
      end do

*======================  Fourier transformation  ======================
      call dcopy(nfft3d,0.0d0,0,VL,1)
      call dcopy(4*nfft3d,0.0d0,0,rho_sc_k,1)
      task_count = -1
      DO 700 k3=1,nfft3
      DO 700 k2=1,nfft2
      DO 700 k1=1,nfft1
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        Q=DSQRT(G(k1,k2,k3,1)**2
     >         +G(k1,k2,k3,2)**2
     >         +G(k1,k2,k3,3)**2)

        if ((k1.eq.1).and.(k2.eq.1).and.(k3.eq.1)) go to 700

        
        GX=G(k1,k2,k3,1)/Q
        GY=G(k1,k2,k3,2)/Q
        GZ=G(k1,k2,k3,3)/Q
        DO I=1,NRHO
          CS(I)=DCOS(Q*RHO(I))
          SN(I)=DSIN(Q*RHO(I))
        END DO

*::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
  600   CONTINUE

        DO  I=1,NRHO
          F(I)=RHO(I)*VP(I,locp)*SN(I)
        END DO
        vl(k1,k2,k3)=SIMP(nrho,f,drho)*forpi/Q-ZV*forpi*cs(nrho)/(Q*Q)
 

*::::::::::::::::::::: semicore density :::::::::::::::::::::::::::::::
        if (semicore) then
           do i=1,nrho
              f(i) = rho(i)*dsqrt(rho_sc_r(i,1))*sn(i)
           end do
           rho_sc_k(k1,k2,k3,1) = SIMP(nrho,f,drho)*forpi/Q

           do i=1,nrho
             f(i)=(sn(i)/(Q*rho(i))-cs(i))*rho_sc_r(i,2)*rho(i)
           end do
           P = SIMP(nrho,f,drho)*forpi/Q
           rho_sc_k(k1,k2,k3,2)=P*GX
           rho_sc_k(k1,k2,k3,3)=P*GY
           rho_sc_k(k1,k2,k3,4)=P*GZ

        end if
    
  700 CONTINUE

      call Parallel_Vector_SumAll(4*nfft3d,rho_sc_k)
      call Parallel_Vector_SumAll(nfft3d,VL)

*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      

      DO I=1,NRHO
        F(I)=VP(I,locp)*RHO(I)**2
      END DO
      VL(1,1,1)=FORPI*SIMP(NRHO,F,DRHO)+TWOPI*ZV*RHO(NRHO)**2

*     **** semicore density ****
      if (semicore) then
         do i=1,nrho
            f(i) = dsqrt(rho_sc_r(i,1))*rho(i)**2
         end do
         rho_sc_k(1,1,1,1) = forpi*SIMP(nrho,f,drho)
         rho_sc_k(1,1,1,2) = 0.0d0
         rho_sc_k(1,1,1,3) = 0.0d0
         rho_sc_k(1,1,1,4) = 0.0d0
      end if


*     ********************************
*     **** define n_prj and l_prj ****
*     ********************************
      lcount = nprj+1
      GO TO (950,940,930,920), lmax+1

        !::::::  f-wave  :::::::
  920   CONTINUE
        if (locp.ne.3) then
          do n=1,n_expansion(3)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = -3

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = -2

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = -1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 0

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 2

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 3
          end do
        end if

        !::::  d-wave  ::::
  930   CONTINUE
        if (locp.ne.2) then
          do n=1,n_expansion(2)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = -2

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = -1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = 0

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = 1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = 2
          end do
        end if

        !::::  p-wave  ::::
  940   CONTINUE
        if (locp.ne.1) then
          do n=1,n_expansion(1)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 1
             m_prj(lcount) = -1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 1
             m_prj(lcount) = 0

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 1
             m_prj(lcount) = 1
          end do
        end if

        !::::  s-wave  ::::
  950   CONTINUE
        if (locp.ne.0) then
          do n=1,n_expansion(0)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 0
             m_prj(lcount) = 0
          end do
        end if

      ierr=0
      return
      end

*
* $Id: task_pspw.F 25971 2014-08-03 16:43:06Z bylaska $
*
C> \ingroup task
C> @{
      logical function task_pspw(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
      integer rtdb
      logical value,dummy,md_only
      integer MASTER
      parameter (MASTER=0)
c
      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 24)
      character*30 dirs(num_dirs)
      character*255 test
      data dirs / 'psp_generator',
     >            'psp_formatter',
     >            'wavefunction_initializer',
     >            'wavefunction_converter',
     >            'steepest_descent',
     >            'conjugate_gradient',
     >            'Car-Parrinello',
     >            'v_wavefunction_initializer',
     >            'wavefunction_expander',
     >            'cell_optimize',
     >            'pspw_dplot',
     >            'stress',
     >            'noit_energy',
     >            'wannier',
     >            'expand_cell',
     >            'ionize',
     >            'convert_restricted',
     >            'Born-Oppenheimer',
     >            'rdf',
     >            'lcao',
     >            'pspw_et',
     >            'Metropolis',
     >            'nwpw-optimize',
     >            'aimd_properties'/

c     *** define external functions ****
      logical  psp_formatter,wvfnc_init,cpsdv5,cpmdv5,cgsdv5,cgmdv5
      logical  v_wvfnc_init,wvfnc_expander,cell_optimize,mmsdv1,mmmdv1
      logical  pspw_dplot,pspw_stress,pspw_noit_energy,cpmdv6
      logical  pspw_wannier,pspw_wannier_old,expand_cell,wvfnc_ionize
      logical  wvfnc_convert_restricted,nwpw_rdf,lcaov1,pspw_et
      logical  cgmontecarlov1,cgoptimize1
      logical  task_aimd_properties
      external psp_formatter,wvfnc_init,cpsdv5,cpmdv5,cgsdv5,cgmdv5
      external v_wvfnc_init,wvfnc_expander,cell_optimize,mmsdv1,mmmdv1
      external pspw_dplot,pspw_stress,pspw_noit_energy,cpmdv6
      external pspw_wannier,pspw_wannier_old,expand_cell,wvfnc_ionize
      external wvfnc_convert_restricted,nwpw_rdf,lcaov1,pspw_et
      external cgmontecarlov1,cgoptimize1
      external task_aimd_properties
c
c
      value = .false.
      task_pspw = .false. 
 10   value = rtdb_cget(rtdb,'task:operation',1,test)

      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit('task pspw: unknown directive', 0, INPUT_ERR)
c
c
c
      goto ( 100,  200, 300, 400, 500, 600, 700, 800, 900,
     >       1000, 1100, 1200, 1300, 1400, 1500, 1600, 1700, 1800,
     >       1900, 2000, 2100, 2200, 2300, 2400 ) ind
      call errquit('task pspw: unimplemented directive', ind, INPUT_ERR)


c     
c  psp_generator
c     
 100  value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then 
        write(*,*)  ">>>> PSPW Serial Module - psp_generator <<<<"
c       value = psp_generator(rtdb)
      endif
      call ga_sync()
      goto 9999


c
c  psp_formatter - This is outdated code, but kept for legacy purposes.
c
 200  value = .true.
      
      if (ga_nodeid().eq.MASTER) then 
        write(*,*)  ">>>> PSPW parallel Module - psp_formatter <<<<"  
      end if
      value = rtdb_parallel(.true.)
      call Parallel_Init()        !** Parallel calls need since psp_formatter is also called directly from codes
      value = psp_formatter(rtdb)
      call Parallel_Finalize()    !** Parallel calls need since psp_formatter is also called directly from codes
      call ga_sync()
      goto 9999


c
c  wavefunction_initializer
c 
 300  value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then 
         write(*,*) 
     >      ">>>> PSPW Serial Module - wavefunction_initializer <<<<"
         value = wvfnc_init(rtdb)
      end if
      call ga_sync()
      goto 9999


c
c  wavefunction_converter
c
 400  value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then
        write(*,*)  
     >     ">>>> PSPW Serial Module - wavefunction_converter <<<<"
        write(*,*) "not finished"
c       value = wavefunction_converter(rtdb)
      endif
      call ga_sync()
      goto 9999


c
c  steepest_descent
c
 500  if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - steepest_descent <<<<"
      end if

      value = .true.
      value = rtdb_parallel(.true.)

      if (.not.rtdb_get(rtdb,'nwpw:md_only',mt_log,1,md_only))
     >   md_only = .false.

      if (md_only) then
         value = mmsdv1(rtdb)
      else
         value = cpsdv5(rtdb)
      end if

      call ga_sync()
      goto 9999


c
c  conjugate gradient
c
 600  if (ga_nodeid().eq.MASTER) then
        write(*,*) ">>>> PSPW Parallel Module - conjugate_gradient <<<<"
      end if
      value =  cgsdv5(rtdb,0)
      call ga_sync()
      goto 9999


c
c  Car-Parrinello
c
 700  if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - Car-Parrinello <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = cpmdv5(rtdb)
      call ga_sync()
      goto 9999

c
c  v_wavefunction_initializer
c 
 800  value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then 
         write(*,*) 
     >      ">>>> PSPW Serial Module - v_wavefunction_initializer <<<<"
         value = v_wvfnc_init(rtdb)
      end if
      call ga_sync()
      goto 9999

c
c  wavefunction_expander
c
 900  value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then
        write(*,*)  
     >     ">>>> PSPW Serial Module - wavefunction_expander <<<<"
        write(*,*) "not finished"
        value = wvfnc_expander(rtdb)
      endif
      call ga_sync()
      goto 9999

c
c  cell_optimize
c
 1000 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - cell_optimize <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = cell_optimize(rtdb)
      call ga_sync()
      goto 9999

c
c  pspw_dplot
c
 1100 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - pspw_dplot <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = pspw_dplot(rtdb)
      call ga_sync()
      goto 9999

c
c  stress - debug
c
 1200 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - stress <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = pspw_stress(rtdb)
      call ga_sync()
      goto 9999

c
c  noit_energy - debug
c
 1300 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - noit_energy <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = pspw_noit_energy(rtdb)
      call ga_sync()
      goto 9999

c
c  wannier
c
 1400 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - Wannier <<<<"
      end if
      if (.not.rtdb_get(rtdb,'nwpw:wannier_old',mt_log,1,dummy))
     >  dummy = .false.
      value = .true.
      value = rtdb_parallel(.true.)
      if (dummy) then
         value = pspw_wannier_old(rtdb)
      else
         value = pspw_wannier(rtdb)
      end if
      call ga_sync()
      goto 9999

c
c  expand_cell
c
 1500 value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then
        write(*,*)
     >     ">>>> PSPW Serial Module - expand_cell <<<<"
        write(*,*) "not finished"
        value = expand_cell(rtdb)
      endif
      call ga_sync()
      goto 9999

c
c  ionize
c
 1600 value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then
        write(*,*)
     >     ">>>> PSPW Serial Module - ionize <<<<"
        write(*,*) "not finished"
        value = wvfnc_ionize(rtdb)
      endif
      call ga_sync()
      goto 9999


c
c  convert_restricted
c
 1700 value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then
        write(*,*)
     >     ">>>> PSPW Serial Module - convert_restricted <<<<"
        write(*,*) "not finished"
        value = wvfnc_convert_restricted(rtdb)
      endif
      call ga_sync()
      goto 9999

c
c  Born-Oppenheimer
c
 1800 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - Born-Oppenheimer <<<<"
      end if

      value = .true.
      value = rtdb_parallel(.true.)
      if (.not.rtdb_get(rtdb,'nwpw:md_only',mt_log,1,md_only))
     >   md_only = .false.

      if (md_only) then
         value = mmmdv1(rtdb,0)
      else
         value = cgmdv5(rtdb,0)
      end if

      call ga_sync()
      goto 9999

c
c  rdf
c
 1900 value = .true.
      value = rtdb_parallel(.false.)
      if (ga_nodeid().eq.MASTER) then
        write(*,*)
     >     ">>>> PSPW Serial Module - rdf <<<<"
        write(*,*) "not finished"
        value = nwpw_rdf(rtdb)
      endif
      call ga_sync()
      goto 9999

c
c  lcao
c
 2000 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - LCAO <<<<"
      end if
      value = lcaov1(rtdb)
      call ga_sync()
      goto 9999
c
c  et
c
 2100 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - ET <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = pspw_et(rtdb)
      call ga_sync()
      goto 9999

c
c  Metropolis
c
 2200 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - Metropolis <<<<"
      end if

      value = .true.
      value = rtdb_parallel(.true.)
      if (.not.rtdb_get(rtdb,'nwpw:md_only',mt_log,1,md_only))
     >   md_only = .false.

      if (md_only) then
         !value = mmmdv1(rtdb,0)
         value = .false.
      else
         value = cgmontecarlov1(rtdb,0)
      end if

      call ga_sync()
      goto 9999


c
c  nwpw-optimize
c
 2300 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - nwpw-optimize <<<<"
      end if

      value = .true.
      value = rtdb_parallel(.true.)
      value = cgoptimize1(rtdb,0)

      call ga_sync()
      goto 9999

c
c  aimd_properties
c
 2400 if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PSPW Parallel Module - aimd_properties <<<<"
      end if

      value = .true.
      value = rtdb_parallel(.true.)

      value = task_aimd_properties(rtdb)

      call ga_sync()
      goto 9999





 9999 continue
      dummy = rtdb_parallel(.true.)
      task_pspw = value

      return
      end
C> @}

*
* $Id: cellgeometry.F 19707 2010-10-29 17:59:36Z d3y133 $
*

      subroutine load_cellgeometry(geom,coords,amatrix)
      implicit none
      integer geom
      double precision coords(*)
      double precision amatrix(*)

#include "errquit.fh"
#include "geom.fh"

      if (.not. geom_cart_coords_get(geom, coords))
     >   call errquit('load_cellgeometry: geom cart?',
     >                0,GEOM_ERR)
      if (.not. geom_cart_to_frac(geom, coords))
     >    call errquit('load_cell_geometry: cart_to_frac?',
     >                 0,GEOM_ERR)
      if (.not. geom_amatrix_get(geom, amatrix))
     >   call errquit('load_cellgeometry: failed to get amatrix',
     >                 0,GEOM_ERR)
      return
      end

      subroutine store_cellgeometry(geom,coords,amatrix)
      implicit none
      integer geom
      double precision coords(*)
      double precision amatrix(3,3)

#include "errquit.fh"
#include "geom.fh"

*     **** external functions ****
      logical  geom_amatrix_set
      external geom_amatrix_set

      if (.not. geom_amatrix_set(geom,amatrix))
     >   call errquit('store_cellgeometry: failed to set amatrix',
     >                0,GEOM_ERR)
      if (.not. geom_frac_to_cart(geom,coords))
     >   call errquit('store_cell_geometry: frac_to_cart?',
     >                0,GEOM_ERR)
      if (.not. geom_cart_coords_set(geom,coords))
     >   call errquit('store_cellgeometry: geom cart?',
     >                0,GEOM_ERR)
      if (.not. geom_cart_to_frac(geom, coords))
     >    call errquit('store_cell_geometry: cart_to_frac?',
     >                 0,GEOM_ERR)

      !**** testing ****
      if (.not. geom_amatrix_get(geom, amatrix))
     >   call errquit('load_cellgeometry: failed to get amatrix',
     >                 0,GEOM_ERR)

      return
      end


 
      subroutine adjust_cellgeometry(rtdb,unita,unita2)
      implicit none
      integer rtdb
      real*8 unita(3,3),unita2(3,3)

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"

      logical value
      integer i,nion,r1(2),geom
      real*8 rxyz(3),q
      character*16     t

      
      value = geom_create(geom,'geometry')
      value = geom_rtdb_load(rtdb,geom,'geometry')

*     **** get the number ions ****
      value = geom_ncent(geom,nion)

*     ***** allocate ion data structure *****
      value = MA_alloc_get(mt_dbl,(3*nion),'r1',r1(2),r1(1))

      do i=1,nion
         value = geom_cent_get(geom,i,t,dbl_mb(r1(1)+(i-1)*3),q)
      end do

      call adjust_ions(nion,dbl_mb(r1(1)),unita,unita2)

      do i=1,nion
         value = geom_cent_get(geom,i,t,rxyz,q)
         value = geom_cent_set(geom,i,t,dbl_mb(r1(1)+(i-1)*3),q)
      end do
      value = geom_rtdb_delete(rtdb,'geometry')
      value = geom_rtdb_store(rtdb,geom,'geometry')
      value = geom_destroy(geom)

      value = MA_free_heap(r1(2))
      return
      end


      subroutine adjust_ions(nion,rion,unita,unita2)
      implicit none
      integer nion
      real*8  rion(3,*)
      real*8  unita(3,3)
      real*8  unita2(3,3)

      integer i,j
      real*8 a(3,3),b(3,3),tion(3),volume

*     **** Convert from real coordinates to fractional coordinates. *****
      do j=1,3
      do i=1,3
        a(i,j) = unita(i,j)
      end do
      end do

      b(1,1) = a(2,2)*a(3,3) - a(3,2)*a(2,3)
      b(2,1) = a(3,2)*a(1,3) - a(1,2)*a(3,3)
      b(3,1) = a(1,2)*a(2,3) - a(2,2)*a(1,3)

      b(1,2) = a(2,3)*a(3,1) - a(3,3)*a(2,1)
      b(2,2) = a(3,3)*a(1,1) - a(1,3)*a(3,1)
      b(3,2) = a(1,3)*a(2,1) - a(2,3)*a(1,1)

      b(1,3) = a(2,1)*a(3,2) - a(3,1)*a(2,2)
      b(2,3) = a(3,1)*a(1,2) - a(1,1)*a(3,2)
      b(3,3) = a(1,1)*a(2,2) - a(2,1)*a(1,2)
      volume = a(1,1)*b(1,1)
     >       + a(2,1)*b(2,1)
     >       + a(3,1)*b(3,1)

      volume = 1.0d0/volume
      call dscal(9,volume,b,1)

      do i=1,nion
         tion(1) = rion(1,i)
         tion(2) = rion(2,i)
         tion(3) = rion(3,i)
         rion(1,i) = b(1,1)*tion(1)
     >             + b(2,1)*tion(2)
     >             + b(3,1)*tion(3)
         rion(2,i) = b(1,2)*tion(1)
     >             + b(2,2)*tion(2)
     >             + b(3,2)*tion(3)
         rion(3,i) = b(1,3)*tion(1)
     >             + b(2,3)*tion(2)
     >             + b(3,3)*tion(3)

      end do

*     **** Convert from fractional coordinates to real coordinates. *****
      do j=1,3
      do i=1,3
        a(i,j) = unita2(i,j)
      end do
      end do


      do i=1,nion
         tion(1) = rion(1,i)
         tion(2) = rion(2,i)
         tion(3) = rion(3,i)

         rion(1,i) = a(1,1)*tion(1)
     >             + a(1,2)*tion(2)
     >             + a(1,3)*tion(3)
         rion(2,i) = a(2,1)*tion(1)
     >             + a(2,2)*tion(2)
     >             + a(2,3)*tion(3)
         rion(3,i) = a(3,1)*tion(1)
     >             + a(3,2)*tion(2)
     >             + a(3,3)*tion(3)
      end do

      return
      end

      logical function pre_rtdbsq(irtdb,igeom,lfnout,sysnam,
     + lseq,cseq,mseq,nseq,latm,catm,xatm,matm,natm)
c
c $Id: pre_rtdbsq.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     function to read sequence from the rtdb
c
c     in  : irtdb
c           igeom
c           lfnout      = output file logical file number
c           mseq        = dimension of the sequence list
c           nseq        = expected length of the sequence list
c
c     out : lseq(1,*)   = segment numbers
c           cseq(1,*)   = segment names
c           nseq        = actual length of the sequence list
c           latm(1,*)   = index to sequence list
c           catm(1,*)   = atom name
c           xatm(1:3,*) = atomic coordinates
c
      implicit none
c
#include "geom.fh"
c
      real*8 cau2nm
      parameter(cau2nm=5.29177249d-02)
c
      integer irtdb,igeom
      integer lfnout,mseq,nseq,matm,natm
      integer lseq(6,mseq),latm(5,matm)
      character*6 catm(3,matm)
      character*5 cseq(2,mseq)
      character*80 sysnam
      real*8 xatm(3,matm)
      real*8 c(3),q
      character*16 tag
      integer i,num,numh
      character*10 symbol,element
      integer iatn
c
      do 1 i=1,natm
      if(.not.geom_cent_get(igeom,i,tag,c,q))
     + call md_abort('pre_rtdbsq: geom_cent_get failed',i)
      latm(1,i)=1
      latm(2,i)=0
      latm(3,i)=0
      latm(4,i)=0
      latm(5,i)=0
      xatm(1,i)=cau2nm*c(1)
      xatm(2,i)=cau2nm*c(2)
      xatm(3,i)=cau2nm*c(3)
      if(.not.geom_tag_to_element(tag,symbol,element,iatn))
     + call md_abort('geom_tag_to_element failed',9999)
      latm(2,1)=iatn
      catm(1,i)='      '
      if(symbol(2:2).eq.' ') then
      catm(1,i)(2:2)=symbol(1:1)
      else
      catm(1,i)(1:2)=symbol(1:2)
      endif
      catm(2,i)='      '
      catm(3,i)='      '
    1 continue
      cseq(1,1)=sysnam(1:5)
      cseq(2,1)='     '
      lseq(1,1)=1
      lseq(2,1)=0
      lseq(3,1)=1
      lseq(3,2)=natm+1
c
      num=0
      numh=0
      do 2 i=1,natm
      if(catm(1,i)(1:2).ne.' H') then
      num=num+1
      if(num.lt.10) then
      write(catm(1,i)(3:3),'(i1.1)') num
      else
      if(num.lt.100) then
      write(catm(1,i)(3:4),'(i2.2)') num
      else
      write(catm(1,i)(3:5),'(i3.3)') num
      endif
      endif
      else
      numh=numh+1
      if(numh.lt.10) then
      write(catm(1,i)(3:3),'(i1.1)') numh
      else
      if(numh.lt.100) then
      write(catm(1,i)(3:4),'(i2.2)') numh
      else
      write(catm(1,i)(3:5),'(i3.3)') numh
      endif
      endif

      endif
    2 continue
c
      pre_rtdbsq=.true.
      return
c
 9999 continue
c
      pre_rtdbsq=.false.
      return
      end

*
* $Id: v_wvfnc_init_input.F 21380 2011-11-02 22:54:04Z bert $
*

      subroutine v_wvfnc_init_input(rtdb)
      implicit none
#include "errquit.fh"
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
c
      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 7)
      integer NMAX              ! maximum wavfunctions
      parameter (NMAX = 100)
 
      character*30 dirs(num_dirs)
      character*255 test

      character*25 cell_name
      character*50 v_wavefunction_filename
      integer nup
      integer ndown
      logical restricted
      data dirs / 'cell_name:',
     >            'v_wavefunction_filename:',
     >            'restricted',
     >            'unrestricted',
     >            'up_filling:',
     >            'down_filling:',
     >            'end'/



*     ***** initializations ****
      cell_name             = 'cell_default'
      call util_file_prefix('vmovecs',v_wavefunction_filename)
c     v_wavefunction_filename = ' '

      restricted            = .true.
      nup                   = 0
      ndown                 = 0

 10   if (.not. inp_read()) 
     >     call errquit(
     >           'v_wvfnc_init_input: inp_read failed', 0, INPUT_ERR)
      if (.not. inp_a(test))
     >     call errquit(
     >           'wvfnc_init_input: failed to read keyword', 0,
     &       INPUT_ERR)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit(
     >           'v_wvfnc_init_input: unknown directive', 0, INPUT_ERR)


      goto ( 100,  200, 300, 400, 500, 600,
     >      9999) ind
      call errquit(
     >      'v_wvfnc_init_input: unimplemented directive', ind,
     &       INPUT_ERR)


c     
c  cell_name
c     
 100  if (.not. inp_a(cell_name))
     >     call errquit(
     >          'v_wvfnc_init_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c wavefunction_filename
c
 200  if (.not. inp_a(v_wavefunction_filename))
     >     call errquit(
     >          'v_wvfnc_init_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c  restricted
c 
 300  restricted = .true.
      goto 10

c
c  unrestricted
c 
 400  restricted = .false.
      goto 10

c
c  up_filling
c 
 500  if (.not. inp_i(nup))
     >     call errquit(
     >          'v_wvfnc_init_input: failed to read nup', 0, INPUT_ERR)

      goto 10
 
c
c  down_filling
c 
 600  if (.not. inp_i(ndown))
     >     call errquit(
     >          'v_wvfnc_init_input: failed to read ndown', 0,
     &       INPUT_ERR)

      goto 10
 
 

*     ***** add wavefunction to rtdb ****
 9999 continue
      if (cell_name.eq.' ') 
     >  call errquit('v_wvfnc_init_input: nead a cell_name', 0,
     &       INPUT_ERR)
      if (v_wavefunction_filename.eq.' ') 
     >  call errquit(
     >       'v_wvfnc_init_input: nead a wavefunction_filename', 0,
     &       INPUT_ERR)


      ind = index(cell_name,' ') - 1
      if (.not. rtdb_cput(rtdb,'v_wvfnc:cell_name',1,cell_name(1:ind)))
     >     call errquit(
     >     'v_wvfnc_init_input: rtdb_cput failed', 0, RTDB_ERR)

      ind = index(v_wavefunction_filename,' ') - 1
      if (.not. rtdb_cput(rtdb,'v_wvfnc:v_wavefunction_filename',
     >                    1,v_wavefunction_filename(1:ind)))
     >     call errquit(
     >     'v_wvfnc_init_input: rtdb_cput failed', 0, RTDB_ERR)


      if (.not. rtdb_put(rtdb,'v_wvfnc:nup',
     >                    mt_int,1,nup))
     >     call errquit(
     >     'v_wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      if (.not. rtdb_put(rtdb,'v_wvfnc:ndown',
     >                    mt_int,1,ndown))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      if (.not. rtdb_put(rtdb,'v_wvfnc:restricted',
     >                    mt_log,1,restricted))
     >     call errquit(
     >     'v_wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      return
      end

*> \brief \b SLAEXC swaps adjacent diagonal blocks of a real upper quasi-triangular matrix in Schur canonical form, by an orthogonal similarity transformation.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SLAEXC + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/slaexc.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/slaexc.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/slaexc.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SLAEXC( WANTQ, N, T, LDT, Q, LDQ, J1, N1, N2, WORK,
*                          INFO )
* 
*       .. Scalar Arguments ..
*       LOGICAL            WANTQ
*       INTEGER            INFO, J1, LDQ, LDT, N, N1, N2
*       ..
*       .. Array Arguments ..
*       REAL               Q( LDQ, * ), T( LDT, * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SLAEXC swaps adjacent diagonal blocks T11 and T22 of order 1 or 2 in
*> an upper quasi-triangular matrix T by an orthogonal similarity
*> transformation.
*>
*> T must be in Schur canonical form, that is, block upper triangular
*> with 1-by-1 and 2-by-2 diagonal blocks; each 2-by-2 diagonal block
*> has its diagonal elemnts equal and its off-diagonal elements of
*> opposite sign.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] WANTQ
*> \verbatim
*>          WANTQ is LOGICAL
*>          = .TRUE. : accumulate the transformation in the matrix Q;
*>          = .FALSE.: do not accumulate the transformation.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix T. N >= 0.
*> \endverbatim
*>
*> \param[in,out] T
*> \verbatim
*>          T is REAL array, dimension (LDT,N)
*>          On entry, the upper quasi-triangular matrix T, in Schur
*>          canonical form.
*>          On exit, the updated matrix T, again in Schur canonical form.
*> \endverbatim
*>
*> \param[in] LDT
*> \verbatim
*>          LDT is INTEGER
*>          The leading dimension of the array T. LDT >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] Q
*> \verbatim
*>          Q is REAL array, dimension (LDQ,N)
*>          On entry, if WANTQ is .TRUE., the orthogonal matrix Q.
*>          On exit, if WANTQ is .TRUE., the updated matrix Q.
*>          If WANTQ is .FALSE., Q is not referenced.
*> \endverbatim
*>
*> \param[in] LDQ
*> \verbatim
*>          LDQ is INTEGER
*>          The leading dimension of the array Q.
*>          LDQ >= 1; and if WANTQ is .TRUE., LDQ >= N.
*> \endverbatim
*>
*> \param[in] J1
*> \verbatim
*>          J1 is INTEGER
*>          The index of the first row of the first block T11.
*> \endverbatim
*>
*> \param[in] N1
*> \verbatim
*>          N1 is INTEGER
*>          The order of the first block T11. N1 = 0, 1 or 2.
*> \endverbatim
*>
*> \param[in] N2
*> \verbatim
*>          N2 is INTEGER
*>          The order of the second block T22. N2 = 0, 1 or 2.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          = 1: the transformed matrix T would be too far from Schur
*>               form; the blocks are not swapped and T and Q are
*>               unchanged.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup realOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE SLAEXC( WANTQ, N, T, LDT, Q, LDQ, J1, N1, N2, WORK,
     $                   INFO )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      LOGICAL            WANTQ
      INTEGER            INFO, J1, LDQ, LDT, N, N1, N2
*     ..
*     .. Array Arguments ..
      REAL               Q( LDQ, * ), T( LDT, * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0E+0, ONE = 1.0E+0 )
      REAL               TEN
      PARAMETER          ( TEN = 1.0E+1 )
      INTEGER            LDD, LDX
      PARAMETER          ( LDD = 4, LDX = 2 )
*     ..
*     .. Local Scalars ..
      INTEGER            IERR, J2, J3, J4, K, ND
      REAL               CS, DNORM, EPS, SCALE, SMLNUM, SN, T11, T22,
     $                   T33, TAU, TAU1, TAU2, TEMP, THRESH, WI1, WI2,
     $                   WR1, WR2, XNORM
*     ..
*     .. Local Arrays ..
      REAL               D( LDD, 4 ), U( 3 ), U1( 3 ), U2( 3 ),
     $                   X( LDX, 2 )
*     ..
*     .. External Functions ..
      REAL               SLAMCH, SLANGE
      EXTERNAL           SLAMCH, SLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLACPY, SLANV2, SLARFG, SLARFX, SLARTG, SLASY2,
     $                   SROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. N1.EQ.0 .OR. N2.EQ.0 )
     $   RETURN
      IF( J1+N1.GT.N )
     $   RETURN
*
      J2 = J1 + 1
      J3 = J1 + 2
      J4 = J1 + 3
*
      IF( N1.EQ.1 .AND. N2.EQ.1 ) THEN
*
*        Swap two 1-by-1 blocks.
*
         T11 = T( J1, J1 )
         T22 = T( J2, J2 )
*
*        Determine the transformation to perform the interchange.
*
         CALL SLARTG( T( J1, J2 ), T22-T11, CS, SN, TEMP )
*
*        Apply transformation to the matrix T.
*
         IF( J3.LE.N )
     $      CALL SROT( N-J1-1, T( J1, J3 ), LDT, T( J2, J3 ), LDT, CS,
     $                 SN )
         CALL SROT( J1-1, T( 1, J1 ), 1, T( 1, J2 ), 1, CS, SN )
*
         T( J1, J1 ) = T22
         T( J2, J2 ) = T11
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SROT( N, Q( 1, J1 ), 1, Q( 1, J2 ), 1, CS, SN )
         END IF
*
      ELSE
*
*        Swapping involves at least one 2-by-2 block.
*
*        Copy the diagonal block of order N1+N2 to the local array D
*        and compute its norm.
*
         ND = N1 + N2
         CALL SLACPY( 'Full', ND, ND, T( J1, J1 ), LDT, D, LDD )
         DNORM = SLANGE( 'Max', ND, ND, D, LDD, WORK )
*
*        Compute machine-dependent threshold for test for accepting
*        swap.
*
         EPS = SLAMCH( 'P' )
         SMLNUM = SLAMCH( 'S' ) / EPS
         THRESH = MAX( TEN*EPS*DNORM, SMLNUM )
*
*        Solve T11*X - X*T22 = scale*T12 for X.
*
         CALL SLASY2( .FALSE., .FALSE., -1, N1, N2, D, LDD,
     $                D( N1+1, N1+1 ), LDD, D( 1, N1+1 ), LDD, SCALE, X,
     $                LDX, XNORM, IERR )
*
*        Swap the adjacent diagonal blocks.
*
         K = N1 + N1 + N2 - 3
         GO TO ( 10, 20, 30 )K
*
   10    CONTINUE
*
*        N1 = 1, N2 = 2: generate elementary reflector H so that:
*
*        ( scale, X11, X12 ) H = ( 0, 0, * )
*
         U( 1 ) = SCALE
         U( 2 ) = X( 1, 1 )
         U( 3 ) = X( 1, 2 )
         CALL SLARFG( 3, U( 3 ), U, 1, TAU )
         U( 3 ) = ONE
         T11 = T( J1, J1 )
*
*        Perform swap provisionally on diagonal block in D.
*
         CALL SLARFX( 'L', 3, 3, U, TAU, D, LDD, WORK )
         CALL SLARFX( 'R', 3, 3, U, TAU, D, LDD, WORK )
*
*        Test whether to reject swap.
*
         IF( MAX( ABS( D( 3, 1 ) ), ABS( D( 3, 2 ) ), ABS( D( 3,
     $       3 )-T11 ) ).GT.THRESH )GO TO 50
*
*        Accept swap: apply transformation to the entire matrix T.
*
         CALL SLARFX( 'L', 3, N-J1+1, U, TAU, T( J1, J1 ), LDT, WORK )
         CALL SLARFX( 'R', J2, 3, U, TAU, T( 1, J1 ), LDT, WORK )
*
         T( J3, J1 ) = ZERO
         T( J3, J2 ) = ZERO
         T( J3, J3 ) = T11
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SLARFX( 'R', N, 3, U, TAU, Q( 1, J1 ), LDQ, WORK )
         END IF
         GO TO 40
*
   20    CONTINUE
*
*        N1 = 2, N2 = 1: generate elementary reflector H so that:
*
*        H (  -X11 ) = ( * )
*          (  -X21 ) = ( 0 )
*          ( scale ) = ( 0 )
*
         U( 1 ) = -X( 1, 1 )
         U( 2 ) = -X( 2, 1 )
         U( 3 ) = SCALE
         CALL SLARFG( 3, U( 1 ), U( 2 ), 1, TAU )
         U( 1 ) = ONE
         T33 = T( J3, J3 )
*
*        Perform swap provisionally on diagonal block in D.
*
         CALL SLARFX( 'L', 3, 3, U, TAU, D, LDD, WORK )
         CALL SLARFX( 'R', 3, 3, U, TAU, D, LDD, WORK )
*
*        Test whether to reject swap.
*
         IF( MAX( ABS( D( 2, 1 ) ), ABS( D( 3, 1 ) ), ABS( D( 1,
     $       1 )-T33 ) ).GT.THRESH )GO TO 50
*
*        Accept swap: apply transformation to the entire matrix T.
*
         CALL SLARFX( 'R', J3, 3, U, TAU, T( 1, J1 ), LDT, WORK )
         CALL SLARFX( 'L', 3, N-J1, U, TAU, T( J1, J2 ), LDT, WORK )
*
         T( J1, J1 ) = T33
         T( J2, J1 ) = ZERO
         T( J3, J1 ) = ZERO
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SLARFX( 'R', N, 3, U, TAU, Q( 1, J1 ), LDQ, WORK )
         END IF
         GO TO 40
*
   30    CONTINUE
*
*        N1 = 2, N2 = 2: generate elementary reflectors H(1) and H(2) so
*        that:
*
*        H(2) H(1) (  -X11  -X12 ) = (  *  * )
*                  (  -X21  -X22 )   (  0  * )
*                  ( scale    0  )   (  0  0 )
*                  (    0  scale )   (  0  0 )
*
         U1( 1 ) = -X( 1, 1 )
         U1( 2 ) = -X( 2, 1 )
         U1( 3 ) = SCALE
         CALL SLARFG( 3, U1( 1 ), U1( 2 ), 1, TAU1 )
         U1( 1 ) = ONE
*
         TEMP = -TAU1*( X( 1, 2 )+U1( 2 )*X( 2, 2 ) )
         U2( 1 ) = -TEMP*U1( 2 ) - X( 2, 2 )
         U2( 2 ) = -TEMP*U1( 3 )
         U2( 3 ) = SCALE
         CALL SLARFG( 3, U2( 1 ), U2( 2 ), 1, TAU2 )
         U2( 1 ) = ONE
*
*        Perform swap provisionally on diagonal block in D.
*
         CALL SLARFX( 'L', 3, 4, U1, TAU1, D, LDD, WORK )
         CALL SLARFX( 'R', 4, 3, U1, TAU1, D, LDD, WORK )
         CALL SLARFX( 'L', 3, 4, U2, TAU2, D( 2, 1 ), LDD, WORK )
         CALL SLARFX( 'R', 4, 3, U2, TAU2, D( 1, 2 ), LDD, WORK )
*
*        Test whether to reject swap.
*
         IF( MAX( ABS( D( 3, 1 ) ), ABS( D( 3, 2 ) ), ABS( D( 4, 1 ) ),
     $       ABS( D( 4, 2 ) ) ).GT.THRESH )GO TO 50
*
*        Accept swap: apply transformation to the entire matrix T.
*
         CALL SLARFX( 'L', 3, N-J1+1, U1, TAU1, T( J1, J1 ), LDT, WORK )
         CALL SLARFX( 'R', J4, 3, U1, TAU1, T( 1, J1 ), LDT, WORK )
         CALL SLARFX( 'L', 3, N-J1+1, U2, TAU2, T( J2, J1 ), LDT, WORK )
         CALL SLARFX( 'R', J4, 3, U2, TAU2, T( 1, J2 ), LDT, WORK )
*
         T( J3, J1 ) = ZERO
         T( J3, J2 ) = ZERO
         T( J4, J1 ) = ZERO
         T( J4, J2 ) = ZERO
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL SLARFX( 'R', N, 3, U1, TAU1, Q( 1, J1 ), LDQ, WORK )
            CALL SLARFX( 'R', N, 3, U2, TAU2, Q( 1, J2 ), LDQ, WORK )
         END IF
*
   40    CONTINUE
*
         IF( N2.EQ.2 ) THEN
*
*           Standardize new 2-by-2 block T11
*
            CALL SLANV2( T( J1, J1 ), T( J1, J2 ), T( J2, J1 ),
     $                   T( J2, J2 ), WR1, WI1, WR2, WI2, CS, SN )
            CALL SROT( N-J1-1, T( J1, J1+2 ), LDT, T( J2, J1+2 ), LDT,
     $                 CS, SN )
            CALL SROT( J1-1, T( 1, J1 ), 1, T( 1, J2 ), 1, CS, SN )
            IF( WANTQ )
     $         CALL SROT( N, Q( 1, J1 ), 1, Q( 1, J2 ), 1, CS, SN )
         END IF
*
         IF( N1.EQ.2 ) THEN
*
*           Standardize new 2-by-2 block T22
*
            J3 = J1 + N2
            J4 = J3 + 1
            CALL SLANV2( T( J3, J3 ), T( J3, J4 ), T( J4, J3 ),
     $                   T( J4, J4 ), WR1, WI1, WR2, WI2, CS, SN )
            IF( J3+2.LE.N )
     $         CALL SROT( N-J3-1, T( J3, J3+2 ), LDT, T( J4, J3+2 ),
     $                    LDT, CS, SN )
            CALL SROT( J3-1, T( 1, J3 ), 1, T( 1, J4 ), 1, CS, SN )
            IF( WANTQ )
     $         CALL SROT( N, Q( 1, J3 ), 1, Q( 1, J4 ), 1, CS, SN )
         END IF
*
      END IF
      RETURN
*
*     Exit with INFO = 1 if swap was rejected.
*
   50 INFO = 1
      RETURN
*
*     End of SLAEXC
*
      END
c $Id: slaexc.f 24343 2013-06-22 05:35:15Z d3y133 $

c
c     qmd_write_trj: write trajectory: xyz file in angstroms
c
      subroutine qmd_write_trj(xyzfilename,xyzfileunit,
     &           mode_append,nat,iframe,etotal,geom)
c
      implicit none
c
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "geom.fh"
#include "stdio.fh"
c
#include "qmd_common.fh"
c
      character*(*) xyzfilename
      integer xyzfileunit
      logical mode_append
      integer nat
      integer iframe
      double precision etotal
      integer geom
c
      character*32 pname
c
      pname = "qmd_write_traj: "
c
c     open file
      if (mode_append) then
         open(unit=xyzfileunit,file=xyzfilename,form='formatted',
     &        position='append',status='unknown')
      else
         open(unit=xyzfileunit,file=xyzfilename,form='formatted',
     &        position='rewind',status='unknown')
      end if
c
c     write number of atoms, frame number and energy
      write(xyzfileunit,110) nat
      write(xyzfileunit,111) iframe,etotal
c
      if (.not.geom_print_xyzq(geom, xyzfileunit)) 
     &  call errquit(pname//'geom write failed',0,GEOM_ERR)
c
      if (xyzfileunit.ne.0) close(unit=xyzfileunit)
c
  110 format(I5)
  111 format(I5,f22.12)
c
      return
      end
c $Id: qmd_write_trj.F 24348 2013-06-23 04:29:20Z d3y133 $

      subroutine int_init_pso(maxbuf,maxscr,basis,npt)
c
c $Id: hnd_init_pso.F 19696 2010-10-29 16:53:42Z d3y133 $
c
      implicit none
c
#include "hnd_pointers.fh"
#include "bas.fh"
#include "errquit.fh"
#include "hnd_tol.fh"
c
      integer maxbuf    ! [output] buffer space for integrals
      integer maxscr    ! [output] scratch space needed
      integer basis     ! [input] basis set info
      integer npt       ! [input] number of grid points to be calculated
c
      integer lmax, iblk, i, mroots
c
c     set default tolerance
c
      itol = 15
c
c     Define Hermite polynomial values
c
      call hnd_whermt
c
c     set up memory requirements: get max L first
c
      lmax = -1
      if (.not.bas_high_angular(basis,lmax))
     &   call errquit('int_init_pso: lmax error',lmax, INT_ERR)
      lmax = lmax + 1
c
c     Calculate maximum buffer needed
c
      maxbuf = lmax*(lmax+1)*lmax*(lmax+1)/4*npt*3
c
c     Calculate maximum scratch space needed
c
      mroots = (2*lmax+2-2)/2+1
      iblk = lmax*(lmax+1)*3*mroots
      maxscr = 3*iblk
      maxscr = max(maxbuf,maxscr)
c
c     Set pointers for scratch space
c
      dsot(1) = 1
      do i = 2, 3
         dsot(i) = 1 + (i-1)*iblk
      enddo
c
c     If spherical basis, allocate scratch space for transformation
c     A little smaller than maxbuf: we will use maxbuf size
c
      maxscr = max(maxscr,maxbuf)
c
      return
      end

*> \brief \b ZSPCON
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZSPCON + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zspcon.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zspcon.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zspcon.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZSPCON( UPLO, N, AP, IPIV, ANORM, RCOND, WORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, N
*       DOUBLE PRECISION   ANORM, RCOND
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       COMPLEX*16         AP( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZSPCON estimates the reciprocal of the condition number (in the
*> 1-norm) of a complex symmetric packed matrix A using the
*> factorization A = U*D*U**T or A = L*D*L**T computed by ZSPTRF.
*>
*> An estimate is obtained for norm(inv(A)), and the reciprocal of the
*> condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          Specifies whether the details of the factorization are stored
*>          as an upper or lower triangular matrix.
*>          = 'U':  Upper triangular, form is A = U*D*U**T;
*>          = 'L':  Lower triangular, form is A = L*D*L**T.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] AP
*> \verbatim
*>          AP is COMPLEX*16 array, dimension (N*(N+1)/2)
*>          The block diagonal matrix D and the multipliers used to
*>          obtain the factor U or L as computed by ZSPTRF, stored as a
*>          packed triangular matrix.
*> \endverbatim
*>
*> \param[in] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (N)
*>          Details of the interchanges and the block structure of D
*>          as determined by ZSPTRF.
*> \endverbatim
*>
*> \param[in] ANORM
*> \verbatim
*>          ANORM is DOUBLE PRECISION
*>          The 1-norm of the original matrix A.
*> \endverbatim
*>
*> \param[out] RCOND
*> \verbatim
*>          RCOND is DOUBLE PRECISION
*>          The reciprocal of the condition number of the matrix A,
*>          computed as RCOND = 1/(ANORM * AINVNM), where AINVNM is an
*>          estimate of the 1-norm of inv(A) computed in this routine.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX*16 array, dimension (2*N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex16OTHERcomputational
*
*  =====================================================================
      SUBROUTINE ZSPCON( UPLO, N, AP, IPIV, ANORM, RCOND, WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, N
      DOUBLE PRECISION   ANORM, RCOND
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      COMPLEX*16         AP( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I, IP, KASE
      DOUBLE PRECISION   AINVNM
*     ..
*     .. Local Arrays ..
      INTEGER            ISAVE( 3 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLACN2, ZSPTRS
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( ANORM.LT.ZERO ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSPCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      RCOND = ZERO
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      ELSE IF( ANORM.LE.ZERO ) THEN
         RETURN
      END IF
*
*     Check that the diagonal matrix D is nonsingular.
*
      IF( UPPER ) THEN
*
*        Upper triangular storage: examine D from bottom to top
*
         IP = N*( N+1 ) / 2
         DO 10 I = N, 1, -1
            IF( IPIV( I ).GT.0 .AND. AP( IP ).EQ.ZERO )
     $         RETURN
            IP = IP - I
   10    CONTINUE
      ELSE
*
*        Lower triangular storage: examine D from top to bottom.
*
         IP = 1
         DO 20 I = 1, N
            IF( IPIV( I ).GT.0 .AND. AP( IP ).EQ.ZERO )
     $         RETURN
            IP = IP + N - I + 1
   20    CONTINUE
      END IF
*
*     Estimate the 1-norm of the inverse.
*
      KASE = 0
   30 CONTINUE
      CALL ZLACN2( N, WORK( N+1 ), WORK, AINVNM, KASE, ISAVE )
      IF( KASE.NE.0 ) THEN
*
*        Multiply by inv(L*D*L**T) or inv(U*D*U**T).
*
         CALL ZSPTRS( UPLO, N, 1, AP, IPIV, WORK, N, INFO )
         GO TO 30
      END IF
*
*     Compute the estimate of the reciprocal condition number.
*
      IF( AINVNM.NE.ZERO )
     $   RCOND = ( ONE / AINVNM ) / ANORM
*
      RETURN
*
*     End of ZSPCON
*
      END
c $Id: zspcon.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine smd_atom_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_atom
      character*32 tag,pname
      logical result

      pname = "smd_atom_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_atom_init(sp_atom)

      return
      end

      subroutine smd_atom_init(namespace)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_const_data.fh"
#include "geom.fh"
c     
      character*(*) namespace
c
      character*32 pname
      character*80 tag
      integer nt,ns
      integer i_t,i_tr,i_ir,i_qf
      integer i_iconst
      logical result
c
      logical geom_tag_to_charge_gen
      external geom_tag_to_charge_gen
c
      pname = "smd_atom_init"
c
      call util_message("iin "//pname)
      write(*,*) "in "//pname
c
c     get total number of atoms from pdb file
c     ---------------------------------------
      call smd_coordfile_natoms(nt)
      if(nt.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)
c
c
c     create atom namespace
c     ---------------------
      call smd_namespace_create(namespace)
c
c     create atom data structures
c     ---------------------------
      tag = "atom:iconst"
      call smd_data_create_get(namespace,tag,1,MT_INT,i_iconst)
      tag = "atom:name"
      call smd_data_create_get(namespace,tag,nt,MT_STR,i_t)
      tag  = "atom:resname"
      call smd_data_create_get(namespace,tag,nt,MT_STR,i_tr)
      tag = "atom:resid"
      call smd_data_create_get(namespace,tag,nt,MT_INT,i_ir)
      tag = "atom:formal_charge"
      call smd_data_create_get(namespace,tag,nt,MT_DBL,i_qf)

c
c    don't ask
c    --------
      int_mb(i_iconst) = nt
c
c     fill in names from pdb file
c     ---------------------------
      call smd_coordfile_read_atomres(nt,
     +                         byte_mb(i_t),
     +                         byte_mb(i_tr),
     +                         int_mb(i_ir))

      tag = "atom:name"
      call smd_get_size(tag,ns,result)
      if(.not.result) call errquit(
     >       pname//'error getting size',0, RTDB_ERR)

      ns=ns/nt
c
      if(.not.geom_tag_to_charge_gen(nt,ns,
     >                        byte_mb(i_t),dbl_mb(i_qf)))
     >  call errquit(
     >       pname//'error setting formal charge',0, RTDB_ERR)

      call util_message("out "//pname)

      return
      end

      subroutine smd_atom_ntot(ntot)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer ntot
c
      character*72 tag
      character*30 pname
      integer i_iconst
      logical result

      pname = "smd_atom_ntot"
      tag = "atom:iconst"
      call smd_get_ind(tag,i_iconst,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting ntot '//tag,0, RTDB_ERR)
      ntot = int_mb(i_iconst)

      return
      end

      subroutine smd_atom_nres(namespace,nr)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      integer nr
c
      character*72 tag
      character*30 pname
      integer i_ir
      logical result
      integer nt
      integer ir,ir0,i

      pname = "smd_atom_nres"
      tag = "atom:resid"
      call smd_data_get_index(namespace,tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting '//tag,0, RTDB_ERR)
      call smd_data_get_dim(namespace,tag,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size '//tag,0, RTDB_ERR)

      nr = 0
      ir0 = 0
      do i=1,nt
       ir = int_mb(i_ir+i-1)
       if(ir0.ne.ir) then
          ir0=ir
          nr = nr + 1
       end if
      end do
       
      return
      end

      subroutine smd_atom_ntot1(namespace,ntot)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      integer ntot
c
      character*72 tag
      character*30 pname
      logical result

      pname = "smd_atom_ntot"
      tag = "atom:xyz"
      call smd_data_get_dim(namespace,tag,ntot,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for '//tag,0, RTDB_ERR)
      ntot = ntot/3

      return
      end

c $Id: smd_atom.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine dia_finish(sgmnam,ltask)
c
c $Id: dia_finish.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "dia_common.fh"
#include "mafdecls.fh"
c
      character*16 sgmnam(nsa)
      logical ltask
c
c      call dia_report(sgmnam,dbl_mb(i_xrms),int_mb(i_isel))
c
c
      if(me.eq.0) then
      if(lcop.gt.0) then
      if(fmtcop.eq.'eci') write(lfncop,'(a)') 'End'
      close(unit=lfncop)
      write(*,'(a)') ' Closing copy file '
      endif
      if(lsup.gt.0)  then
      if(fmtsup.eq.'eci') write(lfnsup,'(a)') 'End'
      close(unit=lfnsup)
      write(*,'(a)') ' Closing super file '
      endif
      endif
c
c     deallocate memory
c
c      call ma_summarize_allocated_blocks()
      if(ltask) then
      if(.not.ma_pop_stack(l_atmn))
     + call md_abort('Failed to deallocate atmn',0)
      if(.not.ma_pop_stack(l_ndxw))
     + call md_abort('Failed to deallocate ndxw',0)
      if(.not.ma_pop_stack(l_wsel))
     + call md_abort('Failed to deallocate wsel',0)
      if(.not.ma_pop_stack(l_qwdat))
     + call md_abort('Failed to deallocate qwdat',0)
      if(.not.ma_pop_stack(l_wdat))
     + call md_abort('Failed to deallocate wdat',0)
      if(.not.ma_pop_stack(l_idat))
     + call md_abort('Failed to deallocate idat',0)
      if(.not.ma_pop_stack(l_xp))
     + call md_abort('Failed to deallocate xp',0)
      if(.not.ma_pop_stack(l_xadat))
     + call md_abort('Failed to deallocate xadat',0)
      if(.not.ma_pop_stack(l_qdat))
     + call md_abort('Failed to deallocate qdat',0)
      if(.not.ma_pop_stack(l_xdat))
     + call md_abort('Failed to deallocate xdat',0)
      if(.not.ma_pop_stack(l_snam))
     + call md_abort('Failed to deallocate sgmnam',0)
      endif
c
      if(.not.ma_verify_allocator_stuff()) print*,'Oops'
c
      if(.not.ma_pop_stack(l_owt))
     + call md_abort('Failed to deallocate owt',0)
      if(.not.ma_pop_stack(l_swt))
     + call md_abort('Failed to deallocate swt',0)
      if(.not.ma_pop_stack(l_wt))
     + call md_abort('Failed to deallocate wt',0)
      if(.not.ma_pop_stack(l_xrms))
     + call md_abort('Failed to deallocate xrms',0)
      if(.not.ma_pop_stack(l_xref))
     + call md_abort('Failed to deallocate xref',0)
c
      if(.not.ma_pop_stack(l_val))
     + call md_abort('Failed to deallocate val',0)
      if(.not.ma_pop_stack(l_tag))
     + call md_abort('Failed to deallocate tag',0)
      if(.not.ma_pop_stack(l_osel))
     + call md_abort('Failed to deallocate osel',0)
      if(.not.ma_pop_stack(l_ssel))
     + call md_abort('Failed to deallocate ssel',0)
      if(.not.ma_pop_stack(l_isel))
     + call md_abort('Failed to deallocate isel',0)
      if(.not.ma_pop_stack(l_hbnd))
     + call md_abort('Failed to deallocate hbnd',0)
c
      return
      end
      subroutine dia_report(sgmnam,xrms,isel)
c
      implicit none
c
#include "dia_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      integer isel(nsa)
      real*8 xrms(nsa)
c
      integer i,n
      real*8 arms,bfact
c
c     report results
c
      bfact=128.0d0*atan(1.0d0)*atan(1.0d0)/3.0d0
c
      if(me.eq.0) then
      write(lfnrms,1000)
 1000 format('analysis')
      endif
      if(np.gt.1) then
      call ga_dgop(mag_d12,xrms,nsa,'+')
      endif
      if(me.eq.0) then
      write(lfnrms,1001) (sgmnam(i),i,isel(i),
     + sqrt(xrms(i)/dble(ndata)),bfact*xrms(i)/dble(ndata),i=1,nsa) 
 1001 format(a16,i10,i5,2f12.6)
      arms=0.0d0
      n=0
      if(me.eq.0) write(lfnrms,1000)
      do 1 i=1,nsa
      if(isel(i).ne.0) then
      arms=arms+xrms(i)
      n=n+1
      endif
      if(i.eq.nsa) goto 2
      if(sgmnam(i)(11:16).ne.sgmnam(i+1)(11:16)) goto 2
      goto 1
    2 continue
      if(ndata*n.gt.0) then
      write(lfnrms,1002) sgmnam(i)(1:5),sgmnam(i)(11:16),
     + sqrt(arms/dble(ndata*n)),bfact*arms/dble(ndata*n)
 1002 format(a5,a6,2f12.6)
      endif
      arms=0.0d0
      n=0
    1 continue
      close(unit=lfnrms)
      endif
      return
      end

      subroutine pspw_qmmm_input(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "util.fh"
#include "nwc_const.fh"
#include "errquit.fh"
c
c

      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 19)
      character*30 dirs(num_dirs)
      data dirs / 'lj_ion_parameters:',
     >            'lj_ion_parameters',
     >            'lj_mm_parameters:',
     >            'polarization_mm_parameter:',
     >            'sr_basis:',
     >            'lr_cutoff:',
     >            'fragment',
     >            'nonfragment',
     >            'mm_psp',
     >            'mm_tags',
     >            'qmmm_lambda',
     >            'enable',
     >            'disable',
     >            'lj_ion_ion_parameters',
     >            'pair_ion_ion_parameters',
     >            'buckingham_ion_ion_parameters',
     >            'bmh_ion_ion_parameters',
     >            'dbmh_ion_ion_parameters',
     >            'end'/

      integer num_fdirs          ! No. of known directives
      parameter (num_fdirs = 15)
      character*30 fdirs(num_fdirs)
      data fdirs / 'size',
     >             'index_start',
     >             'shake',
     >             'switching',
     >             'bond_spring',
     >             'angle_spring',
     >             'self_interaction',
     >             'incell',
     >             'cross_bond_spring',
     >             'bond_morse',
     >             'dihedral_spring',
     >             'dihedral',
     >             'coord_number',
     >             'bond_pair',
     >             'end'/

      integer num_dirs2          ! No. of known directives
      parameter (num_dirs2 = 8)
      character*10 dirs2(num_dirs2)
      data dirs2 / 'index1',
     >             'index2',
     >             'n',
     >             'm',
     >             'r0',
     >             'K',
     >             'cn0',
     >             'sprik'/
c
      logical       value
      character*4   element,element2
      character*16  tag
      character*80  rtdb_name
      integer       element_length,element2_length,npair
      integer       basis_length,tmp(2),geom
      integer       ni,nkf,nfrag,frag_size,index_start(2)
      integer       nknf,nnonfrag,l
      real*8        se(20),alpha,Rin,Rout,scal
      integer       nsigma
      real*8        charge,rcut
      real*8        rxyz(3),q
      character*255 test,dir_name,sdir_name
      integer ind               ! Index of matched directive

      integer h,i,j,k,ka,jstart,jlast,jstride
      character*16 psp_in,psp_out

      logical self,indx_notset
      integer sindx(50),na,nb,nshk
      real*8  sdist(50)
      integer nbs,nas,ncbs,nbm,nds,ndds
      integer n1,n2,nkc,ind2
      integer index_start1(2),index_start2(2)

*     **** external functions ****
      character*7 c_index_name
      external    c_index_name

      nkf   = 0
      nfrag = 0
      nknf     = 0
      nnonfrag = 0


 10   if (.not. inp_read()) 
     >  call errquit(
     >  'pspw_qmmm_input: inp_read failed', 0, INPUT_ERR)
      if (.not. inp_a(test))
     >  call errquit(
     >  'pspw_qmmm_input: failed to read keyword', 0, INPUT_ERR)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >  call errquit(
     >  'pspw_qmmm_input: unknown directive', 0, INPUT_ERR)


      goto ( 100,100,200,300,400,500,600,700,800,900,1000,1100,1200,
     >       150,160,170,180,190,
     >      9999) ind
      call errquit(
     >      'pspw_qmmm_input: unimplemented directive', ind, INPUT_ERR)

c
c  LJ Ion parameters - used by model potential and model charge
c
 100  element = '    '
      value = inp_a(element)
      value = value.and.inp_f(se(1))
      value = value.and.inp_f(se(2))
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading lj_ion_parameters:',0, INPUT_ERR)

      element_length = index(element,' ') - 1
      rtdb_name = 'pspw_LJ_param_ion:'//element(1:element_length)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,2,se)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading LJ ion parameters:',0, INPUT_ERR)
      
      goto 10

c
c  LJ Ion-Ion parameters -
c
 150  element  = '    '
      element2 = '    '
      value =           inp_a(element)
      value = value.and.inp_a(element2)
      value = value.and.inp_f(se(1))
      value = value.and.inp_f(se(2))
      se(3) = 0.0d0
      se(4) = 0.0d0
      se(5) = 0.0d0
      se(6) = 0.0d0
      ni = 1
      if (.not. value)
     >  call errquit(
     >   'pspw_qmmm_input:failed reading lj_ion_ion_parameters:',
     >    0, INPUT_ERR)

      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element
     >             //element2
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)

      if (element.ne.element2) then
      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element2
     >             //element
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element2
     >             //element 
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element2
     >             //element
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)
      end if

      if (.not. value)
     >  call errquit(
     >    'pspw_qmmm_input:failed reading LJ ion-ion parameters:',
     >     0,INPUT_ERR)

      goto 10

c
c  Pair Ion-Ion parameters - 1 - 4*Aij*((Bij/rij)**12-(Bij/rij)**6), 
c                            2 - Aij*exp(-rij/Bij) - Cij/rij**6, 
c                            3 - Aij*exp(-rij/Bij) - Cij/rij**6 - Dij/rij**8
c                            4 - Aij*(rij-Bij)^Cij, 
c                            5 - Aij*exp(-rij/Bij)
c                            6 - Aij*(1-exp(-Bij*(rij-Cij)))**2
c                            7 - ???
c                            8 - Aij*exp(-(rij/Bij)**2)
c
 160  element  = '    '
      element2 = '    '
      value =           inp_a(element)
      value = value.and.inp_a(element2)
      value = value.and.inp_i(ni)   !* pair type 1-Power, 2-Born-Mayer
      value = value.and.inp_f(se(1))   !* Aij
      value = value.and.inp_f(se(2))   !* Bij
      value = value.and.inp_f(se(3))   !* Cij
      value = value.and.inp_f(se(4))   !* Dij
      se(5) = 0.0d0
      se(6) = 0.0d0
      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading pair_ion_ion_parameters:',
     >    0, INPUT_ERR)


      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element
     >             //element2
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)


      if (element.ne.element2) then
         rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element2
     >             //element
         if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
         npair = npair + 1
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

         rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element2
     >             //element 
         value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

         rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element2
     >             //element
         value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)
      end if

      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading Pair ion-ion parameters:',
     >     0,INPUT_ERR)
      goto 10

c
c  Buckingham Ion-Ion parameters -
c
 170  element  = '    '
      element2 = '    '
      value =           inp_a(element)
      value = value.and.inp_a(element2)
      value = value.and.inp_f(se(1))
      value = value.and.inp_f(se(2))
      value = value.and.inp_f(se(3))
      se(4) = 0.0d0
      se(5) = 0.0d0
      se(6) = 0.0d0
      ni = 2
      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading buckingham_ion_ion_parameters:',
     >  0,INPUT_ERR)

      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element
     >             //element2
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)

      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element2
     >             //element
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element2
     >             //element
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element2
     >             //element
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)

      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading Buckingham ion-ion parameters:',
     >  0,INPUT_ERR)

      goto 10


c
c  BMH Ion-Ion parameters -
c
 180  element  = '    '
      element2 = '    '
      value =           inp_a(element)
      value = value.and.inp_a(element2)
      value = value.and.inp_f(se(1))
      value = value.and.inp_f(se(2))
      value = value.and.inp_f(se(3))
      value = value.and.inp_f(se(4))
      se(5) = 0.0d0
      se(6) = 0.0d0
      ni = 3
      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading bmh_ion_ion_parameters:',
     >  0,INPUT_ERR)

      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element
     >             //element2
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)

 
      if (element.ne.element2) then
      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element2
     >             //element
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element2
     >             //element
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element2
     >             //element
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)
      end if

      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading BMH ion-ion parameters:',
     >  0,INPUT_ERR)

      goto 10
c
c  BMH Ion-Ion parameters -
c
 190  element  = '    '
      element2 = '    '
      value =           inp_a(element)
      value = value.and.inp_a(element2)
      value = value.and.inp_f(se(1))
      value = value.and.inp_f(se(2))
      value = value.and.inp_f(se(3))
      value = value.and.inp_f(se(4))
      value = value.and.inp_f(se(5))
      value = value.and.inp_f(se(6))
      ni = 7
      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading dbmh_ion_ion_parameters:',
     >  0,INPUT_ERR)

      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element
     >             //element2
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element
     >             //element2
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)


      if (element.ne.element2) then
      rtdb_name = 'pspw_Pair_ion_ion_npair:'
     >             //element2
     >             //element
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,npair)) npair = 0
      npair = npair + 1
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,npair)

      rtdb_name = 'pspw_Pair_ion_ion_type:'//c_index_name(npair)
     >             //element2
     >             //element
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,ni)

      rtdb_name = 'pspw_Pair_ion_ion_param:'//c_index_name(npair)
     >             //element2
     >             //element
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,6,se)
      end if

      if (.not. value)
     >  call errquit(
     >  'pspw_qmmm_input:failed reading BMH ion-ion parameters:',
     >  0,INPUT_ERR)

      goto 10



c
c  LJ MM parameters - used by model potential and model charge
c
 200  element = '    '
      value = inp_a(element)
      value = value.and.inp_f(se(1))
      value = value.and.inp_f(se(2))
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading lj_mm_parameters:',0, INPUT_ERR)

      element_length = index(element,' ') - 1
      rtdb_name = 'pspw_LJ_param_mm:'//element(1:element_length)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,2,se)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading LJ MM parameters:',0, RTDB_ERR)
      
      goto 10

c
c  Polarization parameter - used by model potential and model charge
c
 300  element = '    '
      value = inp_a(element)
      value = value.and.inp_f(alpha)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading polarization_parameter:',0,
     &       INPUT_ERR)

      element_length = index(element,' ') - 1
      rtdb_name = 'pspw_polarization_mm:'//element(1:element_length)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,1,alpha)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading polarization_parameter:',0,
     &       RTDB_ERR)
      
      goto 10

c
c  SR Basis - used by model potential
c
 400  element = '    '
      value = inp_a(element)
      value = value.and.inp_f(se(1))
      value = value.and.inp_f(se(2))

      element_length = index(element,' ') - 1
      rtdb_name = 'pspw_SR_basis_length:'//element(1:element_length)
      if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,basis_length)) then
         basis_length = 0
      end if
      basis_length = basis_length+1
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,1,basis_length)


      value = value.and.
     >         MA_push_get(mt_dbl,(2*basis_length),'tmp',tmp(2),tmp(1))

      rtdb_name = 'pspw_SR_basis:'//element(1:element_length)
      if (basis_length.gt.1) then
        value = value.and.
     >          rtdb_get(rtdb,rtdb_name,
     >                 mt_dbl,(2*basis_length-2),dbl_mb(tmp(1)))
      end if
      dbl_mb(tmp(1)+2*basis_length-2) = se(1)
      dbl_mb(tmp(1)+2*basis_length-1) = se(2)
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,
     >                 mt_dbl,(2*basis_length),dbl_mb(tmp(1)))
      value = value.and.MA_pop_stack(tmp(2))
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading SR_Basis:',0, MA_ERR)
      
      goto 10

c
c  lr_cutoff - used by model potential
c
 500  element = '    '
      value = inp_a(element)
      value = value.and.inp_f(alpha)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading lr_cutoff:',0, INPUT_ERR)

      element_length = index(element,' ') - 1
      rtdb_name = 'pspw_lr_cutoff:'//element(1:element_length)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,1,alpha)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed reading lr_cutoff:',0, RTDB_ERR)
      
      goto 10

c
c  fragment
c
 600  nkf = nkf + 1
      nshk = 0
      nas  = 0
      nbs  = 0
      ncbs = 0
      nbm  = 0
      nds  = 0
      ndds = 0
      nkc  = 0
      rtdb_name = 'pspw_qmmm_nkfrag'
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,nkf)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed writing nkfrag',0, RTDB_ERR)

 601  if (.not. inp_read()) 
     >  call errquit('pspw_qmmm_input: inp_read failed',0,INPUT_ERR)
      if (.not. inp_a(test))
     >call errquit('pspw_qmmm_input:failed reading keyword',0,INPUT_ERR)
      if (.not. inp_match(num_fdirs, .false.,test,fdirs,ind))
     >  call errquit('pspw_qmmm_input: unknown directive', 0, INPUT_ERR)


      goto ( 602,603,604,605,606,608,611,612,613,607,609,610,620,614,
     >       699) ind
      call errquit('pspw_qmmm_input:directive not found',ind,INPUT_ERR)

c
c  size
c
 602  if (.not.inp_i(frag_size)) frag_size = 1
      rtdb_name = 'pspw_qmmm_frag_size:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,frag_size)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed writing frag_size',0, RTDB_ERR)

      goto 601
c
c index_start
c
 603  value = MA_push_get(mt_int,nw_max_atom,'indx_start',
     >                    index_start(2),index_start(1))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed allocating index_start',0,MA_ERR)

      ni = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start(1)+ni) = j
          ni = ni+1
         end do
      end do
c      do while (inp_i(index_start(ni+1)))
c        ni = ni + 1
c      end do
      rtdb_name = 'pspw_qmmm_frag_index_start:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,ni,int_mb(index_start(1)))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed writing index_start',0,RTDB_ERR)

      value = MA_pop_stack(index_start(2))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed deallocating index_start',0,MA_ERR)

      rtdb_name = 'pspw_qmmm_frag_nindex_start:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,ni)
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed writing nindex_start',0, RTDB_ERR)

      nfrag = nfrag + ni
      rtdb_name = 'pspw_qmmm_nfrag'
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,nfrag)
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed writing nfrag',0, RTDB_ERR)

      goto 601

c
c shake
c
 604  na = 0
      if (inp_i(k)) then
         scal = 1.0d0
         sindx(na+1) = k
         na = na + 1
      else
         call get_scalefrominput(scal)
      end if
      do while (inp_i(k))
         sindx(na+1) = k
         na = na + 1
      end do
      if (inp_a(test)) then
         if (inp_contains(.false.,'c',test,k)) then
           nb = na
         else
           nb = na - 1 
         end if

         ni = 0
         do while (inp_f(alpha))
           sdist(ni+1) = (scal*alpha)**2
           ni = ni + 1
         end do
         if (ni.ge.nb) then
            nshk = nshk + 1
            rtdb_name = 'pspw_qmmm_frag_nshk:'//c_index_name(nkf)
            value = rtdb_put(rtdb,rtdb_name,mt_int,1,nshk)
            if (.not. value)
     >        call errquit(
     >       'pspw_qmmm_input:failed writing nshk',0,RTDB_ERR)

            rtdb_name = 'pspw_qmmm_frag_na:'
     >                  //c_index_name(nkf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_int,1,na)
            if (.not. value)
     >      call errquit(
     >      'pspw_qmmm_input:failed writing na',0,RTDB_ERR)

            rtdb_name = 'pspw_qmmm_frag_nb:'
     >                  //c_index_name(nkf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_int,1,nb)
            if (.not. value)
     >      call errquit(
     >      'pspw_qmmm_input:failed writing nb',0,RTDB_ERR)

            rtdb_name = 'pspw_qmmm_frag_indx_shake:'
     >                  //c_index_name(nkf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_int,na,sindx)
            if (.not. value)
     >      call errquit(
     >      'pspw_qmmm_input:failed writing indx_shake',0,RTDB_ERR)

            rtdb_name = 'pspw_qmmm_frag_dsq_shake:'
     >                  //c_index_name(nkf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_dbl,nb,sdist)
            if (.not. value)
     >      call errquit(
     >      'pspw_qmmm_input:failed writing dsq_shake',0,RTDB_ERR)

         end if


      end if

      goto 601
c
c switching
c
 605  if (.not.inp_f(Rin))  Rin = 0.0d0
      if (.not.inp_f(Rout)) Rout = 0.0d0

      rtdb_name = 'pspw_qmmm_frag_switch_Rin:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_dbl,1,Rin)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed writing switch_Rin',0, RTDB_ERR)

      rtdb_name = 'pspw_qmmm_frag_switch_Rout:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_dbl,1,Rout)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed writing switch_Rout',0, RTDB_ERR)

      goto 601

c
c bond spring
c
 606  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
         nbs = nbs+1
         rtdb_name = 'pspw_qmmm_frag_nbond:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nbs)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing nbs',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_indx_bond:'
     >               //c_index_name(nkf)
     >               //c_index_name(nbs)
         value = rtdb_put(rtdb,rtdb_name,mt_int,2,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing bond spring ij',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_Kr0_bond:'
     >               //c_index_name(nkf)
     >               //c_index_name(nbs)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,2,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing bond spring K,ro',0,RTDB_ERR)

      end if
      end if
      end if
      end if

      goto 601

c
c bond morse
c
 607  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
      if (inp_f(sdist(3))) then
         sindx(3) = 6     ! morse = 6
         sdist(4) = 0.0d0
         sdist(5) = 0.0d0
         sdist(6) = 0.0d0
         nbm = nbm+1
         rtdb_name = 'pspw_qmmm_frag_nmbond:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nbm)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing nbm',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_indx_mbond:'
     >               //c_index_name(nkf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_int,3,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing bond spring ij',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_Kr0_mbond:'
     >               //c_index_name(nkf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,6,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing bond spring D,rho,ro',
     >    0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if


      goto 601



c
c angle spring
c
 608  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
         nas = nas+1
         rtdb_name = 'pspw_qmmm_frag_nangle:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nas)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing nas',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_indx_angle:'
     >               //c_index_name(nkf)
     >               //c_index_name(nas)
         value = rtdb_put(rtdb,rtdb_name,mt_int,3,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing bond spring ijk',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_Kr0_angle:'
     >               //c_index_name(nkf)
     >               //c_index_name(nas)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,2,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing angle spring K,q0',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if

      goto 601

c
c dihedral spring
c
 609  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
         nds = nds+1
         rtdb_name='pspw_qmmm_frag_ndihedral_spring:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nds)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing nds',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_indx_dihedral_spring:'
     >               //c_index_name(nkf)
     >               //c_index_name(nds)
         value = rtdb_put(rtdb,rtdb_name,mt_int,4,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed dihedral spring ijkl',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_Kr0_dihedral_spring:'
     >               //c_index_name(nkf)
     >               //c_index_name(nds)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,2,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed dihedral spring K,q0',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if
      end if
      goto 601

c
c dihedral
c
 610  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
      if (inp_f(sdist(3))) then
         ndds = ndds+1
         rtdb_name='pspw_qmmm_frag_ndihedral:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,ndds)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing ndds',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_indx_dihedral:'
     >               //c_index_name(nkf)
     >               //c_index_name(ndds)
         value = rtdb_put(rtdb,rtdb_name,mt_int,4,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed dihedral ijkl',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_Kr0_dihedral:'
     >               //c_index_name(nkf)
     >               //c_index_name(ndds)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,3,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed dihedral K,n0,q0',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if
      end if
      end if
      goto 601


c
c  self_interaction
c
 611  self = .true.
      if (inp_a(test)) then
        if (inp_compare(.false.,test,'on'))      self = .true.
        if (inp_compare(.false.,test,'yes'))     self = .true.
        if (inp_compare(.false.,test,'.true.'))  self = .true.
        if (inp_compare(.false.,test,'T'))       self = .true.
        if (inp_compare(.false.,test,'off'))     self = .false.
        if (inp_compare(.false.,test,'no'))      self = .false.
        if (inp_compare(.false.,test,'.false.')) self = .false.
        if (inp_compare(.false.,test,'F'))       self = .false.
      end if
      rtdb_name = 'pspw_qmmm_frag_self_interaction:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_log,1,self)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed writing frag_self',0, RTDB_ERR)

      goto 601


c
c  incell
c
 612  self = .true.
      if (inp_a(test)) then
        if (inp_compare(.false.,test,'on'))      self = .true.
        if (inp_compare(.false.,test,'yes'))     self = .true.
        if (inp_compare(.false.,test,'.true.'))  self = .true.
        if (inp_compare(.false.,test,'T'))       self = .true.
        if (inp_compare(.false.,test,'off'))     self = .false.
        if (inp_compare(.false.,test,'no'))      self = .false.
        if (inp_compare(.false.,test,'.false.')) self = .false.
        if (inp_compare(.false.,test,'F'))       self = .false.
      end if
      rtdb_name = 'pspw_qmmm_frag_incell:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_log,1,self)
      if (.not. value)
     >  call errquit(
     > 'pspw_qmmm_input:failed writing frag_incell',0, RTDB_ERR)

      goto 601


c
c cross bond spring i1 i2 d12  i3 i4 d34 K
c
 613  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_f(sdist(1))) then

      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then
      if (inp_f(sdist(2))) then

      if (inp_f(sdist(3))) then
         ncbs = ncbs+1
         rtdb_name = 'pspw_qmmm_frag_ncbond:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,ncbs)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing ncbs',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_indx_cbond:'
     >               //c_index_name(nkf)
     >               //c_index_name(ncbs)
         value = rtdb_put(rtdb,rtdb_name,mt_int,4,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing cbond spring ijkl',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_Kr0_cbond:'
     >               //c_index_name(nkf)
     >               //c_index_name(ncbs)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,3,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing cbond spring K,ro',0,RTDB_ERR)


      end if
      end if
      end if
      end if
      end if
      end if
      end if

      goto 601


c
c bond pair i1 i2 type A B C D E F
c
c Pair Ion-Ion parameters - 1 - 4*Aij*((Bij/rij)**12-(Bij/rij)**6),
c                           2 - Aij*exp(-rij/Bij) - Cij/rij**6,
c                           3 - Aij*exp(-rij/Bij) - Cij/rij**6 - Dij/rij**8
c                           4 - Aij*(rij-Bij)^Cij,
c                           5 - Aij*exp(-rij/Bij)
c                           6 - Aij*(1-exp(-Bij*(rij-Cij)))**2
c                           7 - ???
c                           8 - Aij*exp(-(rij/Bij)**2)

 614  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
      if (inp_f(sdist(3))) then
      if (inp_f(sdist(4))) then
      if (inp_f(sdist(5))) then
      if (inp_f(sdist(6))) then
         nbm = nbm+1
         rtdb_name = 'pspw_qmmm_frag_nmbond:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nbm)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing nbm',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_indx_mbond:'
     >               //c_index_name(nkf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_int,3,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing bond spring ij',0,RTDB_ERR)

         rtdb_name = 'pspw_qmmm_frag_Kr0_mbond:'
     >               //c_index_name(nkf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,6,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_qmmm_input:failed writing bond spring D,rho,ro',
     >    0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if
      end if
      end if
      end if
      end if

      goto 601


c
c  coord_number
c
 620  nkc = nkc + 1
      rtdb_name = 'pspw_qmmm_frag_ncoord:'//c_index_name(nkf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,nkc)
      sdist(1) = -1.0d0
      sdist(2) = -1.0d0
      sdist(3) = -1.0d0
      sdist(4) = -1.0d0
      sdist(5) = -1.0d0
      sdist(6) = -1.0d0
      n1 = 0 
      n2 = 0
 621  if (.not. inp_a(test)) goto 630
      if (.not. inp_match(num_dirs2,.false.,test,dirs2,ind2))
     >  call errquit(
     >  'pspw_qmmm_input: unknown directive',0,INPUT_ERR)

      goto ( 622,623,624,625,626,627,628,629 ) ind2
      call errquit(
     >     'pspw_qmmm_input: unimplemented directive',ind2,INPUT_ERR)

c
c index1
c
 622   if (.not.MA_push_get(mt_int,nw_max_atom,'indx_start1',
     >                    index_start1(2),index_start1(1)))
     >    call errquit(
     > 'pspw_qmmm_input:failed allocating index_start1',0,MA_ERR)
      n1 = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start1(1)+n1) = j
          n1 = n1+1
         end do
      end do
      rtdb_name='pspw_qmmm_frag_coord_indxsize1:'//c_index_name(nkf)
     >                                         //c_index_name(nkc)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,n1)
      rtdb_name ='pspw_qmmm_frag_coord_indx1:'//c_index_name(nkf)
     >                                      //c_index_name(nkc)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,n1,
     >                              int_mb(index_start1(1)))
      value = value.and.MA_pop_stack(index_start1(2))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed deallocating index_start1',0,MA_ERR)

      goto 621
c
c index2 
c
 623   if (.not.MA_push_get(mt_int,nw_max_atom,'indx_start2',
     >                    index_start2(2),index_start2(1)))
     >    call errquit(
     > 'pspw_qmmm_input:failed allocating index_start2',0,MA_ERR)
      n2 = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start2(1)+n2) = j
          n2 = n2+1
         end do
      end do
      rtdb_name='pspw_qmmm_frag_coord_indxsize2:'//c_index_name(nkf)
     >                                         //c_index_name(nkc)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,n2)
      rtdb_name ='pspw_qmmm_frag_coord_indx2:'//c_index_name(nkf)
     >                                      //c_index_name(nkc)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,n2,
     >                              int_mb(index_start2(1)))
      value = value.and.MA_pop_stack(index_start2(2))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed deallocating index_start2',0,MA_ERR)

      goto 621
c
c n
c
 624  if (.not.inp_f(sdist(1))) sdist(1)=-1.0d0
      goto 621
c
c m
c
 625  if (.not.inp_f(sdist(2))) sdist(2)=-1.0d0
      goto 621
c
c r0
c
 626  if (.not.inp_f(sdist(3))) sdist(3)=-1.0d0
      goto 621
c
c K
c
 627  if (.not.inp_f(sdist(4))) sdist(4)=-1.0d0
      goto 621
c
c cn0
c
 628  if (.not.inp_f(sdist(5))) sdist(5)=-1.0d0
      goto 621
c
c sprik
c
 629  sdist(6)=1.0d0
      goto 621


 630  if ((n1.le.0).or.(n2.le.0)) then
         nkc = nkc - 1
         rtdb_name = 'pspw_qmmm_frag_ncoord:'//c_index_name(nkf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nkc)
      else
         rtdb_name ='pspw_qmmm_frag_coord_Kr0:'//c_index_name(nkf)
     >                                          //c_index_name(nkc)
         if (.not.rtdb_put(rtdb,rtdb_name,mt_dbl,6,sdist))
     >    call errquit('pspw_qmmm_input:failed writing coord_number',
     >                 0,RTDB_ERR)
      end if

      goto 601


 699  continue
      goto 10

c
c  nonfragment
c
 700  nknf = nknf + 1
      nshk = 0
      nas  = 0
      nbs  = 0
      ncbs  = 0
      nbm   = 0
      nds  = 0
      ndds  = 0
      nkc   = 0
      indx_notset = .true.
      rtdb_name = 'pspw_2qmmm_nkfrag'
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,nknf)
      if (.not. value)
     >  call errquit(
     > 'pspw_2qmmm_input:failed writing nkfrag',0, RTDB_ERR)

 701  if (.not. inp_read())
     >  call errquit('pspw_2qmmm_input: inp_read failed',0,INPUT_ERR)
      if (.not. inp_a(test)) call errquit(
     > 'pspw_2qmmm_input:failed reading keyword',0,INPUT_ERR)
      if (.not. inp_match(num_fdirs, .false.,test,fdirs,ind))
     >  call errquit('pspw_2qmmm_input: unknown directive',0,INPUT_ERR)


      goto ( 702,703,704,705,706,708,711,712,713,707,709,710,720,714,
     >       799) ind
      call errquit('pspw_2qmmm_input:directive not found',ind,INPUT_ERR)

c
c  size
c
 702  if (.not.inp_i(frag_size)) frag_size = 1
      rtdb_name = 'pspw_2qmmm_frag_size:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,frag_size)
      if (.not. value)
     >  call errquit(
     > 'pspw_2qmmm_input:failed writing frag_size',0, RTDB_ERR)

      goto 701
c
c index_start
c
 703  value = MA_push_get(mt_int,nw_max_atom,'indx_start',
     >                    index_start(2),index_start(1))
      if (.not. value) call errquit(
     > 'pspw_2qmmm_input:failed allocating index_start',0,MA_ERR)

      ni = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start(1)+ni) = j
          ni = ni+1
         end do
      end do

      rtdb_name = 'pspw_2qmmm_frag_index_start:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,ni,int_mb(index_start(1)))
      if (.not. value) call errquit(
     > 'pspw_2qmmm_input:failed writing index_start',0,RTDB_ERR)

      value = MA_pop_stack(index_start(2))
      if (.not. value) call errquit(
     > 'pspw_2qmmm_input:failed deallocating index_start',0,MA_ERR)

      rtdb_name = 'pspw_2qmmm_frag_nindex_start:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,ni)
      if (.not. value) call errquit(
     > 'pspw_2qmmm_input:failed writing nindex_start',0, RTDB_ERR)

      nnonfrag = nnonfrag + ni
      rtdb_name = 'pspw_2qmmm_nfrag'
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,nnonfrag)
      if (.not. value) call errquit(
     > 'pspw_2qmmm_input:failed writing nnonfrag',0, RTDB_ERR)

      indx_notset = .false.
      goto 701

c
c shake
c
 704  na = 0
      if (inp_i(k)) then
         scal = 1.0d0
         sindx(na+1) = k
         na = na + 1
      else
         call get_scalefrominput(scal)
      end if
      do while (inp_i(k))
         sindx(na+1) = k
         na = na + 1
      end do
      if (inp_a(test)) then
         if (inp_contains(.false.,'c',test,k)) then
           nb = na
         else
           nb = na - 1
         end if

         ni = 0
         do while (inp_f(alpha))
           sdist(ni+1) = (scal*alpha)**2
           ni = ni + 1
         end do
         if (ni.ge.nb) then
            nshk = nshk + 1
            rtdb_name = 'pspw_2qmmm_frag_nshk:'//c_index_name(nknf)
            value = rtdb_put(rtdb,rtdb_name,mt_int,1,nshk)
            if (.not. value)
     >        call errquit(
     >       'pspw_2qmmm_input:failed writing nshk',0,RTDB_ERR)

            rtdb_name = 'pspw_2qmmm_frag_na:'
     >                  //c_index_name(nknf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_int,1,na)
            if (.not. value)
     >      call errquit(
     >      'pspw_2qmmm_input:failed writing na',0,RTDB_ERR)

            rtdb_name = 'pspw_2qmmm_frag_nb:'
     >                  //c_index_name(nknf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_int,1,nb)
            if (.not. value)
     >      call errquit(
     >      'pspw_2qmmm_input:failed writing nb',0,RTDB_ERR)

            rtdb_name = 'pspw_2qmmm_frag_indx_shake:'
     >                  //c_index_name(nknf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_int,na,sindx)
            if (.not. value)
     >      call errquit(
     >      'pspw_2qmmm_input:failed writing indx_shake',0,RTDB_ERR)

            rtdb_name = 'pspw_2qmmm_frag_dsq_shake:'
     >                  //c_index_name(nknf)
     >                  //c_index_name(nshk)
            value = rtdb_put(rtdb,rtdb_name,mt_dbl,nb,sdist)
            if (.not. value)
     >      call errquit(
     >      'pspw_2qmmm_input:failed writing dsq_shake',0,RTDB_ERR)

         end if

      end if

      goto 701 

c
c switching
c 
 705  if (.not.inp_f(Rin))  Rin = 0.0d0
      if (.not.inp_f(Rout)) Rout = 0.0d0

      rtdb_name = 'pspw_2qmmm_frag_switch_Rin:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_dbl,1,Rin)
      if (.not. value)
     >  call errquit(
     > 'pspw_2qmmm_input:failed writing switch_Rin',0, RTDB_ERR)

      rtdb_name = 'pspw_2qmmm_frag_switch_Rout:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_dbl,1,Rout)
      if (.not. value)
     >  call errquit(
     > 'pspw_2qmmm_input:failed writing switch_Rout',0, RTDB_ERR)
     
      goto 701

c
c bond spring
c
 706  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
         nbs = nbs+1
         rtdb_name = 'pspw_2qmmm_frag_nbond:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nbs)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing nbs',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_indx_bond:'
     >               //c_index_name(nknf)
     >               //c_index_name(nbs)
         value = rtdb_put(rtdb,rtdb_name,mt_int,2,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing bond spring ij',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_Kr0_bond:'
     >               //c_index_name(nknf)
     >               //c_index_name(nbs)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,2,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing bond spring K,ro',0,RTDB_ERR)

      end if
      end if
      end if
      end if

      goto 701

c
c bond morse
c 
 707  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
      if (inp_f(sdist(3))) then
         sindx(3) = 6     ! morse = 6
         sdist(4) = 0.0d0
         sdist(5) = 0.0d0
         sdist(6) = 0.0d0
         nbm = nbm+1
         rtdb_name = 'pspw_2qmmm_frag_nmbond:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nbm)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing nbm',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_indx_mbond:'
     >               //c_index_name(nknf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_int,3,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing bond spring ij',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_Kr0_mbond:'
     >               //c_index_name(nknf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,6,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing bond spring D,rho,ro',
     >    0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if

      goto 701

c
c angle spring
c
 708  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
         nas = nas+1
         rtdb_name = 'pspw_2qmmm_frag_nangle:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nas)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing nas',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_indx_angle:'
     >               //c_index_name(nknf)
     >               //c_index_name(nas)
         value = rtdb_put(rtdb,rtdb_name,mt_int,3,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing bond spring ijk',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_Kr0_angle:'
     >               //c_index_name(nknf)
     >               //c_index_name(nas)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,2,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing angle spring K,q0',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if

      goto 701

c
c dihedral spring
c
 709  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
        nds = nds+1
       rtdb_name='pspw_2qmmm_frag_ndihedral_spring:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nds)
        if (.not. value)
     >  call errquit(
     >   'pspw_2qmmm_input:failed writing nds',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_indx_dihedral_spring:'
     >               //c_index_name(nknf)
     >               //c_index_name(nds)
         value = rtdb_put(rtdb,rtdb_name,mt_int,4,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed dihedral spring ijkl',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_Kr0_dihedral_spring:'
     >               //c_index_name(nknf)
     >               //c_index_name(nds)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,2,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed dihedral spring K,q0',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if
      end if
      goto 701

c
c dihedral
c
 710  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
      if (inp_f(sdist(3))) then
         ndds = ndds+1
         rtdb_name='pspw_2qmmm_frag_ndihedral:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,ndds) 
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing ndds',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_indx_dihedral:'
     >               //c_index_name(nknf)
     >               //c_index_name(ndds)
         value = rtdb_put(rtdb,rtdb_name,mt_int,4,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed dihedral ijkl',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_Kr0_dihedral:'
     >               //c_index_name(nknf)
     >               //c_index_name(ndds)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,3,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed dihedral K,n0,q0',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if
      end if
      end if
      goto 701

c
c  self_interaction
c
 711  self = .true.
      if (inp_a(test)) then
        if (inp_compare(.false.,test,'on'))      self = .true.
        if (inp_compare(.false.,test,'yes'))     self = .true.
        if (inp_compare(.false.,test,'.true.'))  self = .true.
        if (inp_compare(.false.,test,'T'))       self = .true.
        if (inp_compare(.false.,test,'off'))     self = .false.
        if (inp_compare(.false.,test,'no'))      self = .false.
        if (inp_compare(.false.,test,'.false.')) self = .false.
        if (inp_compare(.false.,test,'F'))       self = .false.
      end if
      rtdb_name = 
     > 'pspw_2qmmm_frag_self_interaction:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_log,1,self)
      if (.not. value)
     >  call errquit(
     > 'pspw_2qmmm_input:failed writing frag_self',0, RTDB_ERR)

      goto 701
c
c  incell
c
 712  self = .true.
      if (inp_a(test)) then
        if (inp_compare(.false.,test,'on'))      self = .true.
        if (inp_compare(.false.,test,'yes'))     self = .true.
        if (inp_compare(.false.,test,'.true.'))  self = .true.
        if (inp_compare(.false.,test,'T'))       self = .true.
        if (inp_compare(.false.,test,'off'))     self = .false.
        if (inp_compare(.false.,test,'no'))      self = .false.
        if (inp_compare(.false.,test,'.false.')) self = .false.
        if (inp_compare(.false.,test,'F'))       self = .false.
      end if
      rtdb_name = 'pspw_2qmmm_frag_incell:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_log,1,self)
      if (.not. value)
     >  call errquit(
     > 'pspw_2qmmm_input:failed writing frag_incell',0, RTDB_ERR)

      goto 701

c
c cross bond spring i1 i2 d12  i3 i4 d34 K
c
 713  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_f(sdist(1))) then
 
      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then
      if (inp_f(sdist(2))) then

      if (inp_f(sdist(3))) then
         ncbs = ncbs+1
         rtdb_name = 'pspw_2qmmm_frag_ncbond:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,ncbs)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing ncbs',0,RTDB_ERR)
 
         rtdb_name = 'pspw_2qmmm_frag_indx_cbond:'
     >               //c_index_name(nknf)
     >               //c_index_name(ncbs)
         value = rtdb_put(rtdb,rtdb_name,mt_int,4,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing cbond spring ijkl',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_Kr0_cbond:'
     >               //c_index_name(nknf)
     >               //c_index_name(ncbs)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,3,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing cbond spring K,ro',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if
      end if
      end if

      goto 701


c
c bond_pair i1 i2 type A B C D E F
c
 714  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_f(sdist(1))) then
      if (inp_f(sdist(2))) then
      if (inp_f(sdist(3))) then
      if (inp_f(sdist(4))) then
      if (inp_f(sdist(5))) then
      if (inp_f(sdist(6))) then
         nbm = nbm+1
         rtdb_name = 'pspw_2qmmm_frag_nmbond:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nbm)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing nbm',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_indx_mbond:'
     >               //c_index_name(nknf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_int,3,sindx)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing bond spring ij',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_Kr0_mbond:'
     >               //c_index_name(nknf)
     >               //c_index_name(nbm)
         value = rtdb_put(rtdb,rtdb_name,mt_dbl,6,sdist)
         if (.not. value)
     >   call errquit(
     >   'pspw_2qmmm_input:failed writing bond spring D,rho,ro',
     >    0,RTDB_ERR)


      end if
      end if
      end if
      end if
      end if
      end if
      end if
      end if
      end if

      goto 701

 
c
c  coord_number
c
 720  nkc = nkc + 1
      rtdb_name = 'pspw_2qmmm_frag_ncoord:'//c_index_name(nknf)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,nkc)
      sdist(1) = -1.0d0
      sdist(2) = -1.0d0
      sdist(3) = -1.0d0
      sdist(4) = -1.0d0
      sdist(5) = -1.0d0
      sdist(6) = -1.0d0
      n1 = 0  
      n2 = 0
 721  if (.not. inp_a(test)) goto 730
      if (.not. inp_match(num_dirs2,.false.,test,dirs2,ind2))
     >  call errquit(
     >  'pspw_2qmmm_input: unknown directive',0,INPUT_ERR)

      goto ( 722,723,724,725,726,727,728,729 ) ind2
      call errquit(
     >     'pspw_2qmmm_input: unimplemented directive',ind2,INPUT_ERR)

c
c index1
c
 722   if (.not.MA_push_get(mt_int,nw_max_atom,'indx_start1',
     >                    index_start1(2),index_start1(1)))
     >    call errquit(
     > 'pspw_2qmmm_input:failed allocating index_start1',0,MA_ERR)
      n1 = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start1(1)+n1) = j
          n1 = n1+1
         end do
      end do

      rtdb_name='pspw_2qmmm_frag_coord_indxsize1:'//c_index_name(nknf)
     >                                            //c_index_name(nkc)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,n1)
      rtdb_name ='pspw_2qmmm_frag_coord_indx1:'//c_index_name(nknf)
     >                                         //c_index_name(nkc)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,n1,
     >                              int_mb(index_start1(1)))
      value = value.and.MA_pop_stack(index_start1(2))
      if (.not. value) call errquit(
     > 'pspw_2qmmm_input:failed deallocating index_start1',0,MA_ERR)

      goto 721
c
c index2 
c
 723   if (.not.MA_push_get(mt_int,nw_max_atom,'indx_start2',
     >                    index_start2(2),index_start2(1)))
     >    call errquit(
     > 'pspw_2qmmm_input:failed allocating index_start2',0,MA_ERR)
      n2 = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start2(1)+n2) = j
          n2 = n2+1
         end do
      end do
      rtdb_name='pspw_2qmmm_frag_coord_indxsize2:'//c_index_name(nknf)
     >                                         //c_index_name(nkc)
      value = rtdb_put(rtdb,rtdb_name,mt_int,1,n2)
      rtdb_name ='pspw_2qmmm_frag_coord_indx2:'//c_index_name(nknf)
     >                                      //c_index_name(nkc)
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,n2,
     >                              int_mb(index_start2(1)))
      value = value.and.MA_pop_stack(index_start2(2))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed deallocating index_start2',0,MA_ERR)

      goto 721
c
c n
c
 724  if (.not.inp_f(sdist(1))) sdist(1)=-1.0d0
      goto 721
c
c m
c
 725  if (.not.inp_f(sdist(2))) sdist(2)=-1.0d0
      goto 721
c
c r0
c
 726  if (.not.inp_f(sdist(3))) sdist(3)=-1.0d0
      goto 721
c
c K
c
 727  if (.not.inp_f(sdist(4))) sdist(4)=-1.0d0
      goto 721
c
c cn0
c
 728  if (.not.inp_f(sdist(5))) sdist(5)=-1.0d0
      goto 721
c
c sprik
c
 729  sdist(6)=1.0d0
      goto 721

 730  if ((n1.le.0).or.(n2.le.0)) then
         nkc = nkc - 1
         rtdb_name = 'pspw_2qmmm_frag_ncoord:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nkc)
      else
         rtdb_name ='pspw_2qmmm_frag_coord_Kr0:'//c_index_name(nknf)
     >                                          //c_index_name(nkc)
         if (.not.rtdb_put(rtdb,rtdb_name,mt_dbl,6,sdist))
     >    call errquit('pspw_2qmmm_input:failed writing coord_number',
     >                 0,RTDB_ERR)
      end if

      goto 701


 799  continue

      if (indx_notset) then
         rtdb_name = 'pspw_2qmmm_frag_index_start:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,1)
         if (.not. value) call errquit(
     >    'pspw_2qmmm_input:failed writing index_start',0,RTDB_ERR)

         rtdb_name = 'pspw_2qmmm_frag_nindex_start:'//c_index_name(nknf)
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,1)
         if (.not. value) call errquit(
     >    'pspw_2qmmm_input:failed writing nindex_start',0, RTDB_ERR)

         nnonfrag = nnonfrag + 1
         rtdb_name = 'pspw_2qmmm_nfrag'
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,nnonfrag)
         if (.not. value) call errquit(
     >    'pspw_2qmmm_input:failed writing nnonfrag',0, RTDB_ERR)
      end if

      goto 10


c
c  mm_psp
c
 800  if (inp_a(element) .and.inp_f(charge)) then
         if (.not.inp_i(nsigma)) nsigma = 4
         if (.not.inp_f(rcut))   rcut = 0.8d0

         call util_directory_name(sdir_name,.true.,0)
         call util_directory_name(dir_name,.false.,0)
         h = index(sdir_name,' ') - 1
         i = index(dir_name,' ') - 1

         open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='unknown')
         close(unit=99,status='delete')

         ka = index(element,'^') - 1
         if (ka.lt.0) ka = 4
         open(unit=99,file=sdir_name(1:h)//'/junk.inp')
         write(99,*) '<QMMM>'
         write(99,'(A2,E14.6,I4,E14.6)') 
     >        element(1:ka),charge,nsigma,rcut
         write(99,*) '<end>'
         close(99)

         k = index(element,' ') - 1
         if (k.lt.0) k = 4
         psp_in  = 'junk.inp'
         psp_out = element(1:k)//".psp "
         j = index(psp_in,' ')  - 1
         k = index(psp_out,' ') - 1

         call qmmm_parse(.false.,
     >        -1,-1,1.0d0,
     >        sdir_name(1:h),h,
     >        dir_name(1:i),i,
     >        psp_in,j,
     >        psp_out(1:k),k,
     >        element(1:ka),ka)

         open(unit=99,file=sdir_name(1:h)//'/junk.inp',status='old')
         close(unit=99,status='delete')
      end if 

      goto 10
c
c  mm_tags
c
 900  value = MA_push_get(mt_int,nw_max_atom,'indx_start',
     >                    index_start(2),index_start(1))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed allocating mm_tags',0,MA_ERR)

      ni = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start(1)+ni) = j
          ni = ni+1
         end do
      end do
      element = '    '
      if (.not.inp_a(element)) element = '    '

      if (geom_create(geom,'geometry')) then
      if (geom_rtdb_load(rtdb,geom,'geometry')) then

c     *** remove ^ from tags ****
      if (inp_compare(.false.,element,'off')) then
         do j=1,ni
            i = int_mb(index_start(1)+j-1)
            value = geom_cent_get(geom,i,tag,rxyz,q)
            k = index(tag,'^') 
            if (k.gt.0) then
               do ka=k,16
                  tag(ka:ka) = ' '
               end do
               value = geom_cent_set(geom,i,tag,rxyz,q)
            end if
         end do

c     *** add ^ to tags ****
      else
         element = '^'//element(1:1)
         do j=1,ni
            i = int_mb(index_start(1)+j-1)
            value = geom_cent_get(geom,i,tag,rxyz,q)
            k = index(tag,' ') - 1
            if (k.gt.0) then
               tag = tag(1:k)//element
               value = geom_cent_set(geom,i,tag,rxyz,q)
            end if
         end do
      end if

      value = geom_rtdb_delete(rtdb,'geometry')
      value = geom_rtdb_store(rtdb,geom,'geometry')
      value = geom_destroy(geom)

      end if
      end if



      value = MA_pop_stack(index_start(2))
      if (.not. value) call errquit(
     > 'pspw_qmmm_input:failed deallocating mm_tags',0,MA_ERR)

      goto 10
c
c  qmmm_lambda
c
 1000 if (inp_f(alpha)) then
         rtdb_name = 'pspw_qmmm_lmbda'
         if (.not.rtdb_put(rtdb,rtdb_name,mt_dbl,1,alpha))
     >     call errquit(
     >     'pspw_qmmm_lmbda:failed reading qmmm_lmbda parameter:',0,
     >      RTDB_ERR)
      end if
      goto 10

c
c  enable 
c
 1100 rtdb_name = 'pspw_qmmm_auxon'
      if (.not.rtdb_put(rtdb,rtdb_name,mt_log,1,.true.))
     >   call errquit(
     >   'pspw_qmmm_auxon:failed writing auxon:',0,
     >    RTDB_ERR)
      goto 10
c
c  disable
c
 1200 rtdb_name = 'pspw_qmmm_auxon'
      if (.not.rtdb_put(rtdb,rtdb_name,mt_log,1,.false.))
     >   call errquit(
     >   'pspw_qmmm_auxon:failed writing auxoff:',0,
     >    RTDB_ERR)
      goto 10



 9999 continue

      return
      end
c $Id: pspw_qmmm_input.F 24559 2013-09-04 19:16:40Z bylaska $

      logical function oniom_energy(rtdb)
*
* $Id: oniom.F 25316 2014-03-11 07:20:39Z d3y133 $
*
      implicit none
      integer rtdb
      logical oniom
      external oniom
      oniom_energy = oniom(rtdb,'energy')
      end
      logical function oniom_gradient(rtdb)
      implicit none
      integer rtdb
      logical oniom
      external oniom
      oniom_gradient = oniom(rtdb,'gradient')
      end
      logical function oniom(rtdb, task)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
#include "geom.fh"
#include "inp.fh"
#include "nwc_const.fh"
      integer rtdb
      character*(*) task
c     
c     Implements a two- and three-layer ONIOM model
c     
c     E(High,Real) = E(High,Model) + E(Low,Real) - E(Low,Model)
c     
c     task can currently be energy or gradient
c     
      logical oprint, ignore, status, oprint_head
      character*256 title
      character*32 high_theory, low_theory, medium_theory, 
     $     gname, bname, ename
      character*32 high_basis, low_basis, medium_basis
      character*32 high_ecp, low_ecp, medium_ecp
c
      character*256 v_low_real, v_low_model, v_high_model,
     $     v_medium_model, v_medium_inter, v_low_inter
c
      integer real_nat, model_nat, nat, nattest, inter_nat
      integer geom
      integer i, j, k, bond, nlayer, dummy(2)
      integer maxbonds
      parameter (maxbonds = 50)
      integer model_bonds(2,maxbonds), model_nbonds
      double precision model_p(maxbonds), model_charge
      character*32 model_tags(maxbonds)
      integer inter_bonds(2,maxbonds), inter_nbonds
      double precision inter_p(maxbonds), inter_charge
      character*32 inter_tags(maxbonds)
      double precision p, real_charge
      character*1024 high_input, medium_input, low_input
c     
c     For manipulating the geometry
c     
      double precision coords(3,nw_max_atom), charge(nw_max_atom)
      character*16 tags(nw_max_atom)
c     
      double precision g(3,nw_max_atom), g_low_model(3,nw_max_atom),
     $     g_high_model(3,nw_max_atom), g_low_real(3,nw_max_atom),
     $     g_medium_model(3,nw_max_atom), g_medium_inter(3,nw_max_atom),
     $     g_low_inter(3,nw_max_atom)
c     
      double precision energy, e_low_real, e_low_model, e_high_model,
     $     e_medium_model, e_medium_inter, e_low_inter, e2, e3
      double precision gdummy
c
      character*2 symbol
      character*8 element
      integer atn
c
      integer k_actlist, l_actlist, ma_type, nactive
c     
      logical task_energy_doit, task_gradient_doit, geom_zmtmak
      logical usesymmol
      integer nops
      external task_energy_doit, task_gradient_doit, geom_zmtmak
c     
      status = rtdb_parallel(.true.)
         if(.not.rtdb_get(rtdb,'geom:symmol',mt_log,1,
     $        usesymmol)) usesymmol=.false.
      call util_print_push
      call util_print_rtdb_load(rtdb, 'oniom')
      call ecce_print_module_entry('oniom')
      oprint = util_print('information', print_low) .and. 
     $     ga_nodeid().eq.0
      oprint_head = util_print('headers', print_low) .and. 
     $     ga_nodeid().eq.0
      if (.not. rtdb_cget(rtdb, 'title', 1, title))
     $     title = ' '
      if (.not. geom_create(geom,'geometry')) 
     $     call errquit('oniom: failed creating geometry?',0, GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, 'geometry'))
     $     call errquit('oniom: no geometry ', 0, RTDB_ERR)
      if (.not. geom_rtdb_store(rtdb, geom, 'oniom_geometry'))
     $     call errquit('oniom: failed storing geometry',0, RTDB_ERR)
      if (.not. geom_ncent(geom,real_nat))
     $     call errquit('oniom: number of atoms from geometry?',0,
     &       GEOM_ERR)
      if (.not. geom_destroy(geom))
     $     call errquit('oniom: destroying geometry',0, GEOM_ERR)
c
c     Save the list active list of atoms for gradient calculations
c
      if (task .eq. 'gradient') then
         nactive = real_nat
         if (rtdb_ma_get(rtdb, 'geometry:actlist', ma_type, 
     $        nactive, l_actlist)) then
            if (.not. ma_get_index(l_actlist, k_actlist))
     $           call errquit('oniom: ma_get_index failed',l_actlist,
     &       MA_ERR)
            if (.not. rtdb_put(rtdb, 'oniom:actlist', mt_int, nactive, 
     $           int_mb(k_actlist))) call errquit
     $           ('oniom: saving actlist failed',0, RTDB_ERR)
            if (.not. ma_free_heap(l_actlist)) call errquit
     $           ('oniom: free of actlist?',0, MA_ERR)
         end if
      else
         ignore = rtdb_delete(rtdb,'oniom:actlist')
      end if
c     
c     Get ONIOM parameters from the database
c
      if (.not. rtdb_cget(rtdb, 'oniom:high:theory', 1, high_theory))
     $     call errquit('oniom: high_theory?', 0, RTDB_ERR)
      if (.not. rtdb_cget(rtdb, 'oniom:medium:theory', 1,medium_theory))
     $     medium_theory = ' '
      if (.not. rtdb_cget(rtdb, 'oniom:low:theory', 1, low_theory))
     $     call errquit('oniom: low_theory?', 0, RTDB_ERR)
c     
      if (.not. rtdb_cget(rtdb, 'oniom:high:basis', 1, high_basis))
     $     high_basis = 'ao basis'
      if (.not. rtdb_cget(rtdb, 'oniom:medium:basis', 1, medium_basis))
     $     medium_basis = high_basis
      if (.not. rtdb_cget(rtdb, 'oniom:low:basis', 1, low_basis))
     $     low_basis = medium_basis
c
      if (.not. rtdb_cget(rtdb, 'oniom:high:ecp', 1, high_ecp))
     $     high_ecp = ' '
      if (.not. rtdb_cget(rtdb, 'oniom:medium:ecp', 1, medium_ecp))
     $     medium_ecp = ' ' 
      if (.not. rtdb_cget(rtdb, 'oniom:low:ecp', 1, low_ecp))
     $     low_ecp = ' '
c
      if (.not. rtdb_cget(rtdb, 'oniom:high:input', 1, high_input))
     $     high_input = ' '
      if (.not. rtdb_cget(rtdb, 'oniom:medium:input', 1, medium_input))
     $     medium_input = ' ' 
      if (.not. rtdb_cget(rtdb, 'oniom:low:input', 1, low_input))
     $     low_input = ' '
c
      if (.not. rtdb_cget(rtdb, 'oniom:v_low_real', 1, 
     $     v_low_real)) 
     $     call util_file_name('lrmos', .false.,.false., v_low_real)
      if (.not. rtdb_cget(rtdb, 'oniom:v_low_model', 1, 
     $     v_low_model)) 
     $     call util_file_name('lmmos', .false.,.false., v_low_model)
      if (.not. rtdb_cget(rtdb, 'oniom:v_high_model', 1, 
     $     v_high_model)) 
     $     call util_file_name('hmmos', .false.,.false., v_high_model)
      if (.not. rtdb_cget(rtdb, 'oniom:v_medium_model', 1, 
     $     v_medium_model)) 
     $     call util_file_name('mmmos', .false.,.false., v_medium_model)
      if (.not. rtdb_cget(rtdb, 'oniom:v_medium_inter', 1, 
     $     v_medium_inter)) 
     $     call util_file_name('mimos', .false.,.false., v_medium_inter)
      if (.not. rtdb_cget(rtdb, 'oniom:v_low_inter', 1, 
     $     v_low_inter)) 
     $     call util_file_name('limos', .false.,.false., v_low_inter)
c
      call util_file_name_resolve(v_low_real, .false.)
      call util_file_name_resolve(v_low_model, .false.)
      call util_file_name_resolve(v_high_model, .false.)
      call util_file_name_resolve(v_medium_model, .false.)
      call util_file_name_resolve(v_medium_inter, .false.)
      call util_file_name_resolve(v_low_inter, .false.)
c     
      if (.not. rtdb_get(rtdb, 'oniom:model:nat', mt_int, 1,
     $     model_nat)) call errquit('oniom: model_nat?',0, RTDB_ERR)
      if (.not. rtdb_get(rtdb, 'oniom:inter:nat', mt_int, 1,
     $     inter_nat)) inter_nat = 0
      if (.not. rtdb_get(rtdb, 'oniom:model:charge', mt_dbl, 1, 
     $        model_charge)) call errquit('oniom:model charge',0,
     &       RTDB_ERR)
      if (.not. rtdb_get(rtdb, 'oniom:inter:charge', mt_dbl, 1, 
     $        inter_charge)) inter_charge = 0.0d0
c     
      model_nbonds = 0
      if (rtdb_get(rtdb,'oniom:model:nbonds',mt_int,1,model_nbonds))then
         if (.not. rtdb_get(rtdb, 'oniom:model:bonds', mt_int,
     $        2*model_nbonds, model_bonds)) call errquit
     $        ('oniom: failed to read model-real bonds?',0,
     &       RTDB_ERR)
         if (.not. rtdb_get(rtdb, 'oniom:model:p', mt_dbl,
     $        model_nbonds, model_p)) call errquit
     $        ('oniom: failed to read model-real bonds factors?',0,
     &       RTDB_ERR)
         if (.not. rtdb_cget(rtdb,'oniom:model:tags', 
     $           model_nbonds, model_tags)) call errquit
     $        ('oniom: failed to read model-real bonds tags?',0,
     &       RTDB_ERR)
      end if
c     
      inter_nbonds = 0
      if (rtdb_get(rtdb,'oniom:inter:nbonds',mt_int,1,inter_nbonds))then
         if (.not. rtdb_get(rtdb, 'oniom:inter:bonds', mt_int,
     $        2*inter_nbonds, inter_bonds)) call errquit
     $        ('oniom: failed to read inter-real bonds?',0,
     &       RTDB_ERR)
         if (.not. rtdb_get(rtdb, 'oniom:inter:p', mt_dbl,
     $        inter_nbonds, inter_p)) call errquit
     $        ('oniom: failed to read inter-real bonds factors?',0,
     &       RTDB_ERR)
         if (.not. rtdb_cget(rtdb,'oniom:inter:tags', 
     $           inter_nbonds, inter_tags)) call errquit
     $        ('oniom: failed to read model-real bonds tags?',0,
     &       RTDB_ERR)
      end if
c     
c     Save user indirections for the basis set and geometry
c     
      if (.not. rtdb_cget(rtdb,'geometry',1,gname)) gname = ' '
      if (.not. rtdb_cget(rtdb,'ao basis',1,bname)) bname = ' '
      if (.not. rtdb_cget(rtdb,'ecp basis',1,ename)) ename = ' '
      if (.not. rtdb_get(rtdb, 'charge', mt_dbl, 1, real_charge))
     $     real_charge = 0.0d0
c
      if (model_charge .eq. -999.0) model_charge = real_charge
      if (inter_charge .eq. -999.0) inter_charge = real_charge
c
      nlayer = 2
      if (inter_nat .gt. 0) nlayer = 3
c     
c     Summarize parameters
c
      if (oprint) then
         call util_print_centered(6, 'NWChem ONIOM Module', 40, .true.)
         write(6,*)
         write(6,*)
         if (title .ne. ' ') then
            call util_print_centered(6, title, 40, .false.)
            write(6,*)
            write(6,*)
         end if
c     
         write(6,10)
 10      format(7x,'Theory',/,7x,'------')
         if (high_ecp .eq. ' ') then
            write(6,1) '   high', 
     $           high_theory(1:inp_strlen(high_theory)), 
     $           high_basis(1:inp_strlen(high_basis))
         else
            write(6,1) '   high', 
     $           high_theory(1:inp_strlen(high_theory)), 
     $           high_basis(1:inp_strlen(high_basis)),
     $           high_ecp(1:inp_strlen(high_ecp))
         end if
         if (high_input .ne. ' ') 
     $        write(6,101) high_input(1:inp_strlen(high_input))
         if (medium_theory .ne. ' ') then
            if (medium_ecp .eq. ' ') then
               write(6,1) ' medium', 
     $              medium_theory(1:inp_strlen(medium_theory)), 
     $              medium_basis(1:inp_strlen(medium_basis))
            else
               write(6,1) ' medium', 
     $              medium_theory(1:inp_strlen(medium_theory)), 
     $              medium_basis(1:inp_strlen(medium_basis)),
     $              medium_ecp(1:inp_strlen(medium_ecp))
            end if
            if (medium_input .ne. ' ') 
     $           write(6,101) medium_input(1:inp_strlen(medium_input))
         end if
         if (low_ecp .eq. ' ') then
            write(6,1) '    low', low_theory(1:inp_strlen(low_theory)), 
     $           low_basis(1:inp_strlen(low_basis))
         else
            write(6,1) '    low', low_theory(1:inp_strlen(low_theory)), 
     $           low_basis(1:inp_strlen(low_basis)),
     $           low_ecp(1:inp_strlen(low_ecp))
         end if
         if (low_input .ne. ' ') 
     $        write(6,101) low_input(1:inp_strlen(low_input))
 1       format(6x,a7,2x,'theory=',a,2x,'basis="',a,'"',:,2x,
     $        'ecp="',a,'"')
 101     format(15x,'input string="',a,'"')
c
         write(6,*)
         write(6,15)
 15      format(6x,'Vectors',/,6x,'-------')
         if (nlayer .eq. 2) then
            write(6,21) 'High-model', 
     $           v_high_model(1:inp_strlen(v_high_model))
            write(6,21) 'Low-real', 
     $           v_low_real(1:inp_strlen(v_low_real))
            write(6,21) 'Low-model', 
     $           v_low_model(1:inp_strlen(v_low_model))
         else
            write(6,21) 'High-model', 
     $           v_high_model(1:inp_strlen(v_high_model))
            write(6,21) 'Medium-model', 
     $           v_medium_model(1:inp_strlen(v_medium_model))
            write(6,21) 'Medium-inter', 
     $           v_medium_inter(1:inp_strlen(v_medium_inter))
            write(6,21) 'Low-real', 
     $           v_low_real(1:inp_strlen(v_low_real))
            write(6,21) 'Low-inter', 
     $           v_low_inter(1:inp_strlen(v_low_inter))
         end if
 21      format(8x,a12,2x,a)
c     
         write(6,*)
         write(6,20)
 20      format(5x,'Geometry',/,5x,'--------')
         write(6,2) '   real', real_nat, real_charge
         if (inter_nat .gt. 0) write(6,2) '  inter', inter_nat, 
     $        inter_charge
         if (inter_nbonds .gt. 0) then
            write(6,*) '                 ',
     $           'Bonds between intermediate and real'
            write(6,3) (inter_bonds(1,i),inter_bonds(2,i),inter_p(i),
     $           inter_tags(i)(1:inp_strlen(inter_tags(i))),
     $           i=1,inter_nbonds)
         end if
         write(6,2) '  model', model_nat, model_charge
         if (model_nbonds .gt. 0) then
            write(6,*) '            Bonds between model and',
     $           ' real/intermediate'
            write(6,3) (model_bonds(1,i),model_bonds(2,i),model_p(i),
     $           model_tags(i)(1:inp_strlen(model_tags(i))), 
     $           i=1,model_nbonds)
         end if
 2       format(6x,a7,2x,i4,' atoms with charge',f8.4)
 3       format(20x,2i4,f6.2,2x,'"',a,'"')
         call util_flush(6)
      end if
c     
c     Make the model geometry resetting the symmetry & autoz info
c     
      if (oprint) then
         write(6,*)
         write(6,*) ' Making model geometry '
         write(6,*)
      end if
c     
      if (.not. geom_create(geom,'geometry')) 
     $     call errquit('oniom: failed creating geometry?',0,
     &       GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, 'oniom_geometry'))
     $     call errquit('oniom: no geometry ', 0,
     &       RTDB_ERR)
      if (.not. geom_cart_get(geom,real_nat,tags,g,charge))
     $     call errquit('oniom: geom_cart_get failed', 0, GEOM_ERR)
      call dcopy(3*real_nat, g, 1, coords, 1)
c     
      nat = model_nat
      do bond = 1, model_nbonds
         i = model_bonds(1,bond)
         j = model_bonds(2,bond)
         p = model_p(bond)
         nat = nat + 1
         tags(nat) = model_tags(bond) !!!!!!!!
         ignore = geom_tag_to_element(tags(nat), symbol, element, atn)
         charge(nat) = atn
         do k = 1, 3
            coords(k,nat) = g(k,i)*(1.0d0-p) + g(k,j)*p
         end do
      end do
c     
      if (.not. geom_cart_set(geom,nat,tags,coords,charge))
     $     call errquit('oniom: geom_cart_get failed', 0, GEOM_ERR)
c     
      nattest = nat             ! sym_nwc corrupts the input #atoms
      call sym_nwc(geom, rtdb, nattest, .false., 1.0d0, 1d-4,
     ,     nops, usesymmol)
      if (.not. geom_ncent(geom,nattest)) call errquit
     $     ('oniom: getting ncent',0, GEOM_ERR)
      if (nat .ne. nattest) call errquit
     $     ('oniom: model does not have correct symmetry', 0, GEOM_ERR)
      ignore = geom_zmtmak(rtdb, geom, .false.)
      if (.not. geom_rtdb_store(rtdb, geom, 'oniom model'))
     $     call errquit('oniom: failed storing geometry',0, RTDB_ERR)
      if (ga_nodeid().eq.0 .and.
     $     util_print('geometry',print_default)) then
         if (.not. geom_print(geom)) 
     $        call errquit('oniom: geom print?',0, GEOM_ERR)
      end if
      if (.not. geom_destroy(geom))
     $     call errquit('oniom: destroying geometry',0, GEOM_ERR)
c     
c     Make the intermediate geometry resetting the symmetry & autoz info
c     
      if (inter_nat .gt. 0) then
         if (oprint) then
            write(6,*)
            write(6,*) ' Making intermediate geometry '
            write(6,*)
         end if
         if (.not. geom_create(geom,'geometry')) 
     $        call errquit('oniom: failed creating geometry?',0,
     &       GEOM_ERR)
         if (.not. geom_rtdb_load(rtdb, geom, 'oniom_geometry'))
     $        call errquit('oniom: no geometry ', 0, RTDB_ERR)
         if (.not. geom_cart_get(geom,real_nat,tags,g,charge))
     $        call errquit('oniom: geom_cart_get failed', 0, GEOM_ERR)
         call dcopy(3*real_nat, g, 1, coords, 1)
         nat = inter_nat
         do bond = 1, inter_nbonds
            i = inter_bonds(1,bond)
            j = inter_bonds(2,bond)
            p = inter_p(bond)
            nat = nat + 1
            tags(nat) = inter_tags(bond) !!!! 'H oniom'
            charge(nat) = 1.0d0
            do k = 1, 3
               coords(k,nat) = g(k,i)*(1.0d0-p) + g(k,j)*p
            end do
         end do
         if (.not. geom_cart_set(geom,nat,tags,coords,charge))
     $        call errquit('oniom: geom_cart_get failed', 0, GEOM_ERR)
         nattest = nat          ! sym_nwc corrupts the input #atoms
         call sym_nwc(geom, rtdb, nattest, .false., 1.0d0, 1d-4,
     ,        nops, usesymmol)
         if (.not. geom_ncent(geom,nattest)) call errquit
     $        ('oniom: getting ncent',0, GEOM_ERR)
         if (nat .ne. nattest) call errquit
     $        ('oniom: inter does not have correct symmetry', 0,
     &       GEOM_ERR)
         ignore = geom_zmtmak(rtdb, geom, .false.)
         if (.not. geom_rtdb_store(rtdb, geom, 'oniom inter'))
     $        call errquit('oniom: failed storing geometry',0, RTDB_ERR)
         if (ga_nodeid().eq.0 .and.
     $        util_print('geometry',print_default)) then
            if (.not. geom_print(geom)) 
     $           call errquit('oniom: geom print?',0, GEOM_ERR)
         end if
         if (.not. geom_destroy(geom))
     $        call errquit('oniom: destroying geometry',0,
     &       GEOM_ERR)
      end if
c     
c     Two-layer model
c     E(High,Real) = E(High,Model) + E(Low,Real) - E(Low,Model)
c     
c     Three-layer model
c     E(High,Real) = E(High,Model) - E(Medium,Model)
c     .            + E(Medium,Inter) + E(Real,Low) - E(Low,Inter) 
c     
c     To avoid recursive calls thru Fortran, call the task*doit layer.
c     
      oniom = .false.
      call dfill(3*nw_max_atom, 0.0d0, g, 1)
      call dfill(3*nw_max_atom, 0.0d0, g_low_model, 1)
      call dfill(3*nw_max_atom, 0.0d0, g_high_model, 1)
      call dfill(3*nw_max_atom, 0.0d0, g_low_real, 1)
      call dfill(3*nw_max_atom, 0.0d0, g_medium_model, 1)
      call dfill(3*nw_max_atom, 0.0d0, g_medium_inter, 1)
      energy = 0.0d0
      e_low_model = 0.0d0
      e_high_model = 0.0d0
      e_low_real = 0.0d0
      e_medium_model = 0.0d0
      e_medium_inter = 0.0d0
c     
c     Low + Real
c     
      if (oprint_head)
     $     call util_print_centered(6, 'ONIOM LOW+REAL', 20, .true.)
      call oniom_param(rtdb, ' ', low_basis, low_ecp, real_charge,
     $     low_input)
      call oniom_manage_mos(rtdb,low_theory,v_low_real)
      if (task .eq. 'energy') then
         status = task_energy_doit(rtdb, low_theory, e_low_real)
      else
         call oniom_munge_actlist(rtdb,real_nat,0,dummy)
         status = task_gradient_doit(rtdb, low_theory, e_low_real, 
     $        g_low_real)
      end if
      if (.not. status) 
     $     call errquit('oniom: low theory + real geometry failed',0,
     &       GEOM_ERR)
c     
c     Low + Model
c     
      if (oprint_head)
     $     call util_print_centered(6, 'ONIOM LOW+MODEL', 20, .true.)
      call oniom_param(rtdb, 'oniom model',low_basis, low_ecp,
     $     model_charge, low_input)
      call oniom_manage_mos(rtdb,low_theory,v_low_model)
      if (task .eq. 'energy') then
         status = task_energy_doit(rtdb, low_theory, e_low_model)
      else
         call oniom_munge_actlist(rtdb,model_nat,
     $        model_nbonds,model_bonds)
         status = task_gradient_doit(rtdb, low_theory, e_low_model, 
     $        g_low_model)
      end if
      if (.not. status) 
     $     call errquit('oniom:low theory + model geometry failed',0,
     &       GEOM_ERR)
c     
c     High + Model
c     
      if (oprint_head)
     $     call util_print_centered(6, 'ONIOM HIGH+MODEL', 20, .true.)
      call oniom_param(rtdb, 'oniom model', 
     $     high_basis, high_ecp, model_charge, high_input)
      call oniom_manage_mos(rtdb,high_theory, v_high_model)
      if (task .eq. 'energy') then
         status = task_energy_doit(rtdb, high_theory, e_high_model)
      else
         call oniom_munge_actlist(rtdb,model_nat,
     $        model_nbonds,model_bonds)
         status = task_gradient_doit(rtdb, high_theory, e_high_model, 
     $        g_high_model)
      end if
      if (.not. status) 
     $     call errquit('oniom: high theory + model geometry failed',0,
     &       GEOM_ERR)
c
      if (nlayer .eq. 3) then
c     
c     Low + Inter
c     
         if (oprint_head)
     $        call util_print_centered(6, 'ONIOM LOW+INTER', 20, .true.)
         call oniom_param(rtdb, 'oniom inter', 
     $        low_basis, low_ecp, inter_charge, low_input)
         call oniom_manage_mos(rtdb, low_theory, v_low_inter)
         if (task .eq. 'energy') then
            status = task_energy_doit(rtdb, low_theory, e_low_inter)
         else
            call oniom_munge_actlist(rtdb,inter_nat,
     $           inter_nbonds,inter_bonds)
            status = task_gradient_doit(rtdb, low_theory, e_low_inter, 
     $           g_low_inter)
         end if
         if (.not. status) 
     $        call errquit('oniom:low theory + model geometry failed',0,
     &       GEOM_ERR)
c     
c     Medium + Inter
c     
         if (oprint_head) call util_print_centered
     $        (6, 'ONIOM MEDIUM+INTER', 20, .true.)
         call oniom_param(rtdb, 'oniom inter', 
     $        medium_basis, medium_ecp, inter_charge, medium_input)
         call oniom_manage_mos(rtdb,medium_theory,v_medium_inter)
         if (task .eq. 'energy') then
            status = task_energy_doit(rtdb,medium_theory,e_medium_inter)
         else
            call oniom_munge_actlist(rtdb,inter_nat,
     $           inter_nbonds,inter_bonds)
            status = task_gradient_doit(rtdb, medium_theory, 
     $           e_medium_inter, g_medium_inter)
         end if
         if (.not. status) 
     $        call errquit('oniom: medium theory + '//
     $        'inter geometry failed',0, GEOM_ERR)
c     
c     Medium + Model
c     
         if (oprint_head) call util_print_centered
     $        (6, 'ONIOM MEDIUM+MODEL', 20, .true.)
         call oniom_param(rtdb, 'oniom model',
     $        medium_basis, medium_ecp, model_charge, medium_input)
         call oniom_manage_mos(rtdb,medium_theory,v_medium_model)
         if (task .eq. 'energy') then
            status = task_energy_doit(rtdb,medium_theory,e_medium_model)
         else
            call oniom_munge_actlist(rtdb,model_nat,
     $           model_nbonds,model_bonds)
            status = task_gradient_doit(rtdb, medium_theory, 
     $           e_medium_model, g_medium_model)
         end if
         if (.not. status) 
     $        call errquit('oniom: medium theory + '//
     $        'model geometry failed',0, GEOM_ERR)
      end if
c     
c     Assemble the ONIOM energy and gradient
c     
      e2 = e_high_model + e_low_real - e_low_model
      energy = e2
      if (nlayer .eq. 3) then
         e3 = e_high_model - e_medium_model
     $        + e_medium_inter + e_low_real - e_low_inter 
         energy = e3
      end if
c     
      if (.not. rtdb_put(rtdb,'oniom:energy',mt_dbl,1,energy))
     $     call errquit('oniom: failed storing energy', 0, RTDB_ERR)
c     
      if (task .eq. 'gradient') then
         if (nlayer .eq. 2) then
            call dcopy(3*real_nat, g_low_real, 1, g, 1)
            do i = 1, model_nat
               do k = 1, 3
                  g(k,i) = g(k,i) + g_high_model(k,i) - g_low_model(k,i)
               end do
            end do
            nat = model_nat
            do bond = 1, model_nbonds
               i = model_bonds(1,bond)
               j = model_bonds(2,bond)
               p = model_p(bond)
               nat = nat + 1
               do k = 1, 3
                  gdummy = g_high_model(k,nat) - g_low_model(k,nat)
                  g(k,i) = g(k,i) + gdummy*(1.0d0-p)
                  g(k,j) = g(k,j) + gdummy*p
               end do
            end do
         else
            call dcopy(3*real_nat, g_low_real, 1, g, 1)
            do i = 1, model_nat
               do k = 1, 3
                  g(k,i) = g(k,i) + 
     $                 g_high_model(k,i) - g_medium_model(k,i)
               end do
            end do
            nat = model_nat
            do bond = 1, model_nbonds
               i = model_bonds(1,bond)
               j = model_bonds(2,bond)
               p = model_p(bond)
               nat = nat + 1
               do k = 1, 3
                  gdummy = g_high_model(k,nat) - g_medium_model(k,nat)
                  g(k,i) = g(k,i) + gdummy*(1.0d0-p)
                  g(k,j) = g(k,j) + gdummy*p
               end do
            end do
            do i = 1, inter_nat
               do k = 1, 3
                  g(k,i) = g(k,i) + 
     $                 g_medium_inter(k,i) - g_low_inter(k,i)
               end do
            end do
            nat = inter_nat
            do bond = 1, inter_nbonds
               i = inter_bonds(1,bond)
               j = inter_bonds(2,bond)
               p = inter_p(bond)
               nat = nat + 1
               do k = 1, 3
                  gdummy = g_medium_inter(k,nat) - g_low_inter(k,nat)
                  g(k,i) = g(k,i) + gdummy*(1.0d0-p)
                  g(k,j) = g(k,j) + gdummy*p
               end do
            end do
         end if
c
c     Enforce active atom constraints on the gradient and also restore
c     the full list of active atoms from the copy made earlier.
c
         if (rtdb_ma_get(rtdb, 'oniom:actlist', ma_type, 
     $        nactive, l_actlist)) then
            if (.not. ma_get_index(l_actlist, k_actlist))
     $           call errquit('oniom: ma_get_index failed',l_actlist,
     &       MA_ERR)
            do i = 1, real_nat
               do j = 1, nactive
                  if (int_mb(k_actlist+j-1) .eq. i) goto 444
               end do
               do k = 1, 3
                  g(k,i) = 0.0d0
               end do
 444           continue
            end do
            if (.not. rtdb_put(rtdb, 'geometry:actlist', mt_int, 
     $           nactive, int_mb(k_actlist))) call errquit
     $           ('oniom: saving actlist failed',0,
     &       RTDB_ERR)
            if (.not. ma_free_heap(l_actlist)) call errquit
     $           ('oniom: free of actlist?',0, RTDB_ERR)
         end if
c         
         if (.not. rtdb_put(rtdb,'oniom:gradient',mt_dbl,3*real_nat,g))
     $        call errquit('oniom: failed storing gradient', 0,
     &       RTDB_ERR)
      end if
c     
c     Reset the geometry and restore any user indirection of basis
c     or geometry. 
c     
      ignore = rtdb_delete(rtdb, 'geometry')
      ignore = rtdb_delete(rtdb, 'ao basis')
      ignore = rtdb_delete(rtdb, 'ecp basis')
      ignore = rtdb_delete(rtdb, 'charge')
      if (gname .ne. ' ') then 
         if (.not. rtdb_cput(rtdb,'geometry',1,gname)) 
     $        call errquit('oniom:failed resetting user geom name',0,
     &       RTDB_ERR)
      end if
      if (bname .ne. ' ') then 
         if (.not. rtdb_cput(rtdb,'ao basis',1,bname)) call errquit
     $        ('oniom:failed resetting user basis name',0, RTDB_ERR)
      end if
      if (ename .ne. ' ') then 
         if (.not. rtdb_cput(rtdb,'ecp basis',1,ename)) call errquit
     $        ('oniom:failed resetting user ecp name',0,
     &       RTDB_ERR)
      end if
      if (real_charge .ne. -999.0d0) then
         if (.not. rtdb_put(rtdb, 'charge', mt_dbl, 1, real_charge))
     $        call errquit('oniom: resetting real charge?', 0,
     &       RTDB_ERR)
      end if
c
c     Don't leave MO vectors info lying around in the database.
c
      call oniom_unmanage_mos(rtdb)
c     
c     Get the geometry in preparation for printing
c     
      if (.not. geom_create(geom,'geometry')) 
     $     call errquit('oniom: failed creating geometry?',0, GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, 'oniom_geometry'))
     $     call errquit('oniom: no geometry ', 0, RTDB_ERR)
      if (.not. geom_cart_get(geom,real_nat,tags,coords,charge))
     $     call errquit('oniom: geom_cart_get failed', 0, GEOM_ERR)
      if (.not. geom_destroy(geom))
     $     call errquit('oniom: geom destroy?',0, GEOM_ERR)
c     
      if (oprint) then
         call util_print_centered(6, 'ONIOM summary', 20, .true.)
         write(6,*)
         write(6,5) e_low_real, e_high_model, e_low_model, e2
 5       format(
     $        8x, '+   LOW + REAL  ', f20.12,/,
     $        8x, '+  HIGH + MODEL ', f20.12,/,
     $        8x, '-   LOW + MODEL ', f20.12,/,
     $        8x, '   ------------ ',/,
     $        8x, '=        ONIOM2 ', f20.12,/)
         if (nlayer .eq. 3) then
            write(6,55) e_low_real, e_high_model, e_medium_model, 
     $           e_medium_inter, e_low_inter, e3
 55         format(
     $           8x, '+   LOW + REAL  ', f20.12,/,
     $           8x, '+  HIGH + MODEL ', f20.12,/,
     $           8x, '-   MED + MODEL ', f20.12,/,
     $           8x, '+   MED + INTER ', f20.12,/,
     $           8x, '-   LOW + INTER ', f20.12,/,
     $           8x, '   ------------ ',/,
     $           8x, '=        ONIOM3 ', f20.12,/)
         end if
         if (task .eq. 'gradient') then
            write(6,1000) 'ONIOM',
     $           'x','y','z','x','y','z'
            do 30, i=1, real_nat
               write(6,2000) i, tags(i),(coords(j,i),j=1,3),
     $              (g(j,i),j=1,3)
 30         continue
            write(6,*)
 1000       format(/,/,25X,A,' ENERGY GRADIENTS',/,/,4X,'atom',15X,
     $           'coordinates',
     $           24X,'gradient',/,6X,2(1X,(3(10X,A1))))
 2000       format(1X,I3,1X,A4,2(1X,3(1X,F10.6)))
         end if
         call util_flush(6)
      end if
c     
      if (.not. rtdb_cput(rtdb, 'task:theory', 1, 'oniom'))
     $     call errquit('oniom: re-setting theory?',0,
     &       RTDB_ERR)
c     
      oniom = .true.
      call util_print_pop
      call ecce_print_module_exit('oniom', 'ok')
c
      end
      subroutine oniom_input(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
c     
      integer rtdb
c     
      logical status
      character*32 test
      integer maxbonds
      parameter (maxbonds = 50)
c
      integer model_bonds(2,maxbonds), model_nbonds, model_nat
      double precision model_p(maxbonds), model_charge
      character*32 model_tags(maxbonds)
c
      integer inter_bonds(2,maxbonds), inter_nbonds, inter_nat
      double precision inter_p(50), inter_charge
      character*32 inter_tags(maxbonds)
c
      character*32 high_theory, high_basis, high_ecp
      character*32 medium_theory, medium_basis, medium_ecp
      character*32 low_theory, low_basis, low_ecp
      character*1024 high_input, medium_input, low_input
c
      character*256 v_low_real, v_low_model, v_high_model,
     $     v_medium_model, v_medium_inter, v_low_inter
c
      integer bond, junk, i, j
      character*2 symbol
      character*8 element
      integer atn
c
      high_theory = ' '
      high_basis = ' '
      high_ecp = ' '
      high_input = ' '
      medium_theory = ' '
      medium_basis = ' '
      medium_ecp = ' ' 
      medium_input = ' '
      low_theory = ' '
      low_basis = ' '
      low_ecp = ' '
      low_input = ' '
      model_nat = 0
      model_nbonds = 0
      model_charge = -999.0     ! Used to indicate no charge
      inter_nat = 0
      inter_nbonds = 0
      inter_charge = -999.0
c
      v_low_real = ' '
      v_low_model = ' '
      v_high_model = ' '
      v_medium_model = ' '
      v_medium_inter = ' '
      v_low_inter = ' '
c
c     While input is available
c
 10   if (.not. inp_read()) 
     $     call errquit('oniom_input: premature EOF',0, INPUT_ERR)
      if (.not. inp_a(test))
     $     call errquit('oniom_input: failed to read keyword',0,
     &       INPUT_ERR)
c
      if (inp_compare(.false.,'high',test)) then
c
         call oniom_theory_input(high_theory,high_basis,high_ecp,
     $        high_input)
c     
      else if (inp_compare(.false.,'medium',test)) then
c
         call oniom_theory_input(medium_theory,medium_basis,medium_ecp,
     $        medium_input)
c     
      else if (inp_compare(.false.,'low',test)) then
c
         call oniom_theory_input(low_theory,low_basis,low_ecp,
     $        low_input)
c     
      else if (inp_compare(.false.,'print', test) .or.
     $        inp_compare(.false.,'noprint', test)) then
         call util_print_input(rtdb, 'oniom')
c     
      else if (inp_compare(.false.,'model',test)) then
c
c     model natom [charge q] [i1 j1 p1 [tag1] ...] 
c
         if (.not. inp_i(model_nat))
     $        call errquit('oniom_input:model natoms [i1 j1 p1 ...]',0,
     &       INPUT_ERR)
         if (inp_a(test)) then
            if (inp_compare(.false.,'charge',test)) then
               if (.not. inp_f(model_charge)) call errquit
     $              ('oniom_input: reading charge', 0, INPUT_ERR)
            else
               call inp_prev_field()
            end if
         end if
         model_nbonds = 0
         do bond = 1, maxbonds
            if (.not. inp_i(model_bonds(1,bond))) goto 501
            if (.not. inp_i(model_bonds(2,bond))) call errquit
     $           ('oniom_input: reading second atom for bond',bond,
     &       INPUT_ERR)
            if (.not. inp_f(model_p(bond))) call errquit
     $           ('oniom_input: reading scale factor for bond',bond,
     &       INPUT_ERR)
            model_tags(bond) = 'H oniom'
            if (inp_cur_field() .lt. inp_n_field()) then
               if (inp_i(junk)) then
                  call inp_prev_field()
               else if (.not. inp_a(model_tags(bond))) then
                  call errquit('oniom_input: reading tag for bond',bond,
     &       INPUT_ERR)
               end if
            end if
            if (.not. geom_tag_to_element(model_tags(bond), symbol, 
     $           element, atn)) then
               if (symbol.ne.'bq') call errquit
     $              ('oniom_input: tag must be bq* or element*',0,
     &       INPUT_ERR)
            end if
            model_nbonds = model_nbonds + 1
         end do
 501     continue
      else if (inp_compare(.false.,'inter',test)) then
c
c     inter natom [i1 j1 p1 [tag1] ...]
c
         if (.not. inp_i(inter_nat))
     $        call errquit('oniom_input:inter natoms [i1 j1 p1 ...]',0,
     &       INPUT_ERR)
         if (inp_a(test)) then
            if (inp_compare(.false.,'charge',test)) then
               if (.not. inp_f(inter_charge)) call errquit
     $              ('oniom_input: reading charge', 0, INPUT_ERR)
            else
               call inp_prev_field()
            end if
         end if
         inter_nbonds = 0
         do bond = 1, maxbonds
            if (.not. inp_i(inter_bonds(1,bond))) goto 503
            if (.not. inp_i(inter_bonds(2,bond))) call errquit
     $           ('oniom_input: reading second atom for bond',bond,
     &       INPUT_ERR)
            if (.not. inp_f(inter_p(bond))) call errquit
     $           ('oniom_input: reading scale factor for bond',bond,
     &       INPUT_ERR)
            inter_tags(bond) = 'H oniom'
            if (inp_cur_field() .lt. inp_n_field()) then
               if (inp_i(junk)) then
                  call inp_prev_field()
               else if (.not. inp_a(inter_tags(bond))) then
                  call errquit('oniom_input: reading tag for bond',bond,
     &       INPUT_ERR)
               end if
            end if
            if (.not. geom_tag_to_element(inter_tags(bond), symbol, 
     $           element, atn)) then
               if (symbol.ne.'bq') call errquit
     $              ('oniom_input: tag must be bq* or element*',0,
     &       INPUT_ERR)
            end if
            inter_nbonds = inter_nbonds + 1
         end do
 503     continue
c
      else if (inp_compare(.false.,'vectors',test)) then
 111     if (inp_a(test)) then
            if (inp_compare(.false.,'low-real',test)) then
               if (.not. inp_a(v_low_real)) call errquit
     $              ('oniom_input: error reading low_real vectors', 0,
     &       INPUT_ERR)
            else if (inp_compare(.false.,'low-model',test)) then
               if (.not. inp_a(v_low_model)) call errquit
     $              ('oniom_input: error reading low_model vectors', 0,
     &       INPUT_ERR)
            else if (inp_compare(.false.,'high-model',test)) then
               if (.not. inp_a(v_high_model)) call errquit
     $              ('oniom_input: error reading high_model vectors', 0,
     &       INPUT_ERR)
            else if (inp_compare(.false.,'medium-model',test)) then
               if (.not. inp_a(v_medium_model)) call errquit
     $              ('oniom_input:error reading medium_model vectors',0,
     &       INPUT_ERR)
            else if (inp_compare(.false.,'medium-inter',test)) then
               if (.not. inp_a(v_medium_inter)) call errquit
     $              ('oniom_input:error reading medium_inter vectors',0,
     &       INPUT_ERR)
            else if (inp_compare(.false.,'low-inter',test)) then
               if (.not. inp_a(v_low_inter)) call errquit
     $              ('oniom_input: error reading low_inter vectors', 0,
     &       INPUT_ERR)
            else
               call errquit('oniom_input:unknown keyword for vectors',0,
     &       INPUT_ERR)
            end if
            goto 111
         end if
      else if (.not. inp_compare(.false.,'end',test)) then
         call errquit('oniom_input: unknown directive', 0, INPUT_ERR)
      end if
      if (.not. inp_compare(.false.,'end',test)) goto 10
c
c     Sanity tests
c
      if (high_theory.eq.' ' .or. low_theory.eq.' ') call errquit
     $     ('oniom_input: must specify both high and low theory',0,
     &       INPUT_ERR)
      if (model_nat .le. 0) call errquit
     $     ('oniom_input: must specify no. of model atoms',0, INPUT_ERR)
      if ( (medium_theory.ne.' ' .and. inter_nat.eq.0) .or.
     $     (medium_theory.eq.' ' .and. inter_nat.gt.0) ) call errquit
     $     ('oniom_input: 3-layer model requires both medium theory'//
     $     ' and intermediate layer',0, INPUT_ERR)
c
c     Put the bond info into the right order 1=model, 2=real and
c     also do a little checking.
c
      do bond = 1, model_nbonds
         i = min(model_bonds(1,bond),model_bonds(2,bond))
         j = max(model_bonds(1,bond),model_bonds(2,bond))
         if (i.le.0 .or. i.gt.model_nat .or. j.le.model_nat) 
     $        call errquit
     $        ('oniom_input: bad atom info for model bond number', bond,
     &       INPUT_ERR)
         model_bonds(1,bond) = i
         model_bonds(2,bond) = j
      end do
      do bond = 1, inter_nbonds
         i = min(inter_bonds(1,bond),inter_bonds(2,bond))
         j = max(inter_bonds(1,bond),inter_bonds(2,bond))
         if (i.le.0 .or. i.gt.inter_nat .or. j.le.inter_nat) 
     $        call errquit
     $        ('oniom_input: bad atom info for inter bond number', bond,
     &       INPUT_ERR)
         inter_bonds(1,bond) = i
         inter_bonds(2,bond) = j
      end do
c
c     Store info to the database
c
      status = rtdb_cput(rtdb, 'oniom:high:theory', 1, high_theory)
      status = rtdb_cput(rtdb, 'oniom:low:theory', 1, low_theory)
     $     .and. status
      if (medium_theory .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:medium:theory', 1, 
     $     medium_theory) .and. status
c
      if (high_basis .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:high:basis', 1, high_basis)
     $     .and. status
      if (medium_basis .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:medium:basis', 1, 
     $     medium_basis).and. status
      if (low_basis .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:low:basis', 1, low_basis)
     $     .and. status
c
      if (high_ecp .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:high:ecp', 1, high_ecp)
     $     .and. status
      if (medium_ecp .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:medium:ecp', 1, 
     $     medium_ecp).and. status
      if (low_ecp .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:low:ecp', 1, low_ecp)
     $     .and. status
c
      if (high_input .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:high:input', 1, high_input)
     $     .and. status
      if (medium_input .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:medium:input', 1, 
     $     medium_input).and. status
      if (low_input .ne. ' ') 
     $     status = rtdb_cput(rtdb, 'oniom:low:input', 1, low_input)
     $     .and. status
c
      if (v_low_real .ne. ' ') status = status .and. 
     $     rtdb_cput(rtdb, 'oniom:v_low_real', 1, v_low_real)
      if (v_low_model .ne. ' ')  status = status .and. 
     $     rtdb_cput(rtdb, 'oniom:v_low_model', 1, v_low_model)
      if (v_high_model .ne. ' ')  status = status .and. 
     $     rtdb_cput(rtdb, 'oniom:v_high_model', 1, v_high_model)
      if (v_medium_model .ne. ' ')  status = status .and. 
     $     rtdb_cput(rtdb, 'oniom:v_medium_model', 1, v_medium_model)
      if (v_medium_inter .ne. ' ')  status = status .and. 
     $     rtdb_cput(rtdb, 'oniom:v_medium_inter', 1, v_medium_inter)
      if (v_low_inter .ne. ' ')  status = status .and. 
     $     rtdb_cput(rtdb, 'oniom:v_low_inter', 1, v_low_inter)
c
      status = rtdb_put(rtdb, 'oniom:model:nat', mt_int, 1, model_nat)
     $     .and. status
      status = rtdb_put(rtdb, 'oniom:model:charge', mt_dbl, 1, 
     $     model_charge) .and. status
      if (model_nbonds .gt. 0) then
         status = rtdb_put(rtdb, 'oniom:model:nbonds', mt_int, 1, 
     $        model_nbonds) .and. status
         status = rtdb_put(rtdb, 'oniom:model:bonds', mt_int, 
     $        2*model_nbonds, model_bonds) .and. status
         status = rtdb_put(rtdb, 'oniom:model:p', mt_dbl, 
     $        model_nbonds, model_p) .and. status
         status = rtdb_cput(rtdb,'oniom:model:tags', 
     $        model_nbonds, model_tags) .and. status
      end if
c
      if (inter_nat .gt. 0) then
         status = rtdb_put(rtdb, 'oniom:inter:nat', mt_int, 1, 
     $        inter_nat) .and. status
         status = rtdb_put(rtdb, 'oniom:inter:charge', mt_dbl, 1, 
     $        inter_charge) .and. status
         if (inter_nbonds .gt. 0) then
            status = rtdb_put(rtdb, 'oniom:inter:nbonds', mt_int, 1, 
     $           inter_nbonds) .and. status
            status = rtdb_put(rtdb, 'oniom:inter:bonds', mt_int, 
     $           2*inter_nbonds, inter_bonds) .and. status
            status = rtdb_put(rtdb, 'oniom:inter:p', mt_dbl, 
     $           inter_nbonds, inter_p) .and. status
            status = rtdb_cput(rtdb,'oniom:inter:tags', 
     $           inter_nbonds, inter_tags) .and. status
         end if
      end if
c
      if (.not. status) call errquit
     $     ('oniom_input: error putting data into RTDB',0, RTDB_ERR)
c
      end
      subroutine oniom_unmanage_mos(rtdb)
#include "rtdb.fh"
      integer rtdb
c
c     Delete the vectors input/output keywords from the
c     popular (scf,dft,mcscf) places so that there is
c     no confusion or overwriting down the road
c
      logical ignore
c
      ignore = rtdb_delete(rtdb, 'scf:input vectors')
      ignore = rtdb_delete(rtdb, 'dft:input vectors')
      ignore = rtdb_delete(rtdb, 'pspw:input vectors')
      ignore = rtdb_delete(rtdb, 'band:input vectors')
      ignore = rtdb_delete(rtdb, 'mcscf:input vectors')
      ignore = rtdb_delete(rtdb, 'scf:output vectors')
      ignore = rtdb_delete(rtdb, 'dft:output vectors')
      ignore = rtdb_delete(rtdb, 'pspw:output vectors')
      ignore = rtdb_delete(rtdb, 'band:output vectors')
      ignore = rtdb_delete(rtdb, 'mcscf:output vectors')
c
      end
      subroutine oniom_manage_mos(rtdb,theory,movecs)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "global.fh"
#include "inp.fh"
      integer rtdb
      character*(*) theory
      character*(*) movecs
c
c     Defeat the convergence tests on the MO methods which
c     are confused by some ONIOM calculations and tell the
c     MO codes to use the correct MO vectors.
c
      logical ignore
      logical oexists
      logical do_mcscf
      character*32 keyin, keyout
c
      do_mcscf = .false.
      if (ga_nodeid() .eq. 0) then
         keyin  = 'scf:input vectors'
         keyout = 'scf:output vectors'
         if (inp_compare(.false.,'dft',theory)) then
            keyin  = 'dft:input vectors'
            keyout = 'dft:output vectors'
         else if (inp_compare(.false.,'pspw',theory)) then
            keyin  = 'pspw:input vectors'
            keyout = 'pspw:output vectors'
         else if (inp_compare(.false.,'band',theory)) then
            keyin  = 'band:input vectors'
            keyout = 'band:output vectors'
         else if (inp_compare(.false.,'mcscf',theory)) then
            keyin  = 'mcscf:input vectors'
            keyout = 'mcscf:output vectors'
            do_mcscf = .true.
         else if (inp_compare(.false.,'selci',theory)) then
            keyin  = 'mcscf:input vectors'
            keyout = 'mcscf:output vectors'
            do_mcscf = .true.
         end if
         inquire(file=movecs,exist=oexists)
c
         ignore = rtdb_parallel(.false.)
         ignore = rtdb_delete(rtdb, 'dft:converged')  ! DO WE REALLY NEED TO DO THIS?
         ignore = rtdb_delete(rtdb, 'scf:converged')
         ignore = rtdb_delete(rtdb, 'mcscf:converged')
         ignore = rtdb_delete(rtdb, keyin)
         ignore = rtdb_delete(rtdb, keyout)
         if (oexists) then
            if (.not. rtdb_cput(rtdb,keyin,1,movecs)) call errquit
     $           ('oniom_manage_mos: failed settting input vectors',0,
     &       RTDB_ERR)
         else if (do_mcscf) then
c           we need to prevent the MCSCF code picking up random SCF vectors
            if (.not. rtdb_cput(rtdb,keyin,1,'atomic')) call errquit
     $           ('oniom_manage_mos: failed settting input vectors',0,
     &       RTDB_ERR)
         end if
         if (.not. rtdb_cput(rtdb,keyout,1,movecs)) call errquit
     $        ('oniom_manage_mos: failed settting output vectors',0,
     &       RTDB_ERR)
         ignore = rtdb_parallel(.true.)
      end if
c
      call ga_sync()
c
      end
      subroutine oniom_munge_actlist(rtdb,nat,nbonds,bonds)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "nwc_const.fh"
      integer rtdb
      integer nat, nbonds, bonds(2,*)
c
c     For constrained geometry optimizations and numerical frequencies 
c     the list of active atoms for computing the gradient may be set.
c     For ONIOM subcalculations we need to prune the list of atoms
c     to those actually active in the calculation (otherwise some of
c     the other modules rightfully complain) and if either of the
c     atoms in a bond are active we need to ensure that the link
c     atom is also marked active.
c
      integer l_actlist, k_actlist, nactive, i, j, bond, ma_type
      integer active(nw_max_atom)
c
      if (.not. rtdb_ma_get(rtdb, 'oniom:actlist', ma_type, 
     $     nactive, l_actlist)) return
c
      if (.not. ma_get_index(l_actlist, k_actlist))
     $     call errquit('grad_act_at: ma_get_inded failed',l_actlist,
     &       MA_ERR)
c
c     Prune out atoms not in the subset
c
      do i = 1, nat + nbonds
         active(i) = 0
      end do
      do i = 1, nactive
         j = int_mb(k_actlist+i-1)
         if (j.le.nat) active(j) = 1
      end do
c
c     Ensure link atoms are active if necessary
c
      do bond = 1, nbonds
         i = bonds(1,bond)
         j = bonds(2,bond)
         if (active(i).gt.0 .or. active(j).gt.0) active(nat+bond) = 1
      end do
c
c     Compress the active flags down into a list of atoms
c
      nactive = 0
      do i = 1, nat + nbonds
         if (active(i).gt.0) then
            nactive = nactive + 1
            active(nactive) = i
         end if
      end do
c
      if (nactive .eq. 0) call errquit('oniom: nactive=0?',0,
     &       INPUT_ERR)
c
      if (.not. rtdb_put(rtdb, 'geometry:actlist', mt_int, nactive, 
     $     active)) call errquit('oniom: failed storing actlist',0,
     &       RTDB_ERR)
      if (.not. ma_free_heap(l_actlist)) call errquit
     $     ('oniom: free of actlist?',0, MA_ERR)
c
      end
      subroutine oniom_theory_input(theory,basname,ecpname,input)
      implicit none
#include "errquit.fh"
      character*(*) theory, basname, ecpname, input ! [output]
#include "inp.fh"
c
c     (high||medium||low) theory [basis basname] [ecp ecpname] [input inpstr]
c
c     Read oniom theory input ... defaults assumed set outside
c
c     The theory string should always be converted to lower case as the
c     task layer uses lower case strings only.
c
      character*128 test
c
      if (.not. inp_a(theory)) call errquit
     $     ('oniom_input: failed reading theory',0, INPUT_ERR)
      call inp_lcase(theory)
c
 10   if (.not. inp_a(test)) return
      if (inp_compare(.false.,'basis',test)) then
         if (.not. inp_a(basname)) call errquit
     $        ('oniom_input: failed reading basname',0, INPUT_ERR)
      else if (inp_compare(.false.,'ecp',test)) then
         if (.not. inp_a(ecpname)) call errquit
     $        ('oniom_input: failed reading ecpname',0, INPUT_ERR)
      else if (inp_compare(.false.,'input',test)) then
         if (.not. inp_a(input)) call errquit
     $        ('oniom_input: failed reading input [input]',0, INPUT_ERR)
      else
         call errquit('oniom: unknown keyword for high||medium||low',0,
     &       INPUT_ERR)
      end if
      goto 10
c
      end
      subroutine oniom_param(rtdb, geom, basis, ecp, charge, input)
      implicit none
#include "errquit.fh"
      integer rtdb
      character*(*) geom, basis, ecp, input
      double precision charge
#include "rtdb.fh"
#include "mafdecls.fh"
c
      logical ignore
      logical nw_inp_from_character
      external nw_inp_from_character
c
      if (charge .ne. -999.0d0) then
         if (.not. rtdb_put(rtdb,'charge',mt_dbl,1,charge))
     $        call errquit('oniom:setting charge?',0, RTDB_ERR)
      end if
      if (geom .ne. ' ') then
         if (.not. rtdb_cput(rtdb,'geometry',1,geom))
     $        call errquit('oniom: setting geometry?',0, RTDB_ERR)
      end if
c
      if (basis .ne. ' ') then
         if (.not. rtdb_cput(rtdb, 'ao basis', 1, basis)) 
     $        call errquit('oniom: setting basis?',0, RTDB_ERR)
      end if
c
      if (ecp .ne. ' ') then
         if (.not. rtdb_cput(rtdb, 'ecp basis', 1, ecp)) 
     $        call errquit('oniom: setting ecp?',0, RTDB_ERR)
      else
         ignore = rtdb_delete(rtdb,'ecp basis')
      end if
c
      if (input .ne. ' ') then
         if (.not. nw_inp_from_character(rtdb,input))
     $        call errquit('oniom: error processing input string',0,
     &       INPUT_ERR)
      endif
c     
      end

C> \ingroup task
C> @{
      logical function task_hondo_deriv_check(rtdb)
      implicit none
#include "errquit.fh"
* $Id: rak27.F 22841 2012-09-12 06:55:13Z d3y133 $
c
c For testing hondo gradient integrals.  It is currently set up to test
c the potential derivative integrals.  Comments are sprinkled through the
c code to handle the S and T cases.
c
#include "stdio.fh"
#include "mafdecls.fh"
#include "geom.fh"
#include "bas.fh"
c
      logical int_normalize, raktask27_a
      external int_normalize, raktask27_a
c
      integer rtdb
c
      logical status
      integer basis, geom
      integer nbf, nat, nshell
      integer maxg1, maxs1
      integer hbuf, hbufp, hbufm, hscr, hg, hfd, hxyz
      integer kbuf, kbufp, kbufm, kscr, kg, kfd, kxyz
      integer hbufpp, hbufmm, hbuf3
      integer kbufpp, kbufmm, kbuf3
c
      task_hondo_deriv_check = .false.
c
c
      if (.not.geom_create(geom,'geometry')) call errquit
     &    ('geom create failed',911, GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'geometry')) call errquit
     &    ('geom_rtdb_load failed',911, RTDB_ERR)
c
      if (.not.bas_create(basis,'ao basis')) call errquit
     &    ('bas_create failed',911, BASIS_ERR)
      if (.not.bas_rtdb_load(rtdb,geom,basis,'ao basis')) call errquit
     &    ('bas_rtdb_load failed',911, RTDB_ERR)
c
      write(6,*)' geom/basis loaded'
c
      if (.not.int_normalize(rtdb,basis)) stop ' norm error 1'
c
      if (.not. bas_print(basis))
     $    call errquit(' basis print failed', 0, BASIS_ERR)
c
      if (.not.bas_numbf(basis,nbf)) call errquit
     &    ('numbf failed',911, BASIS_ERR)
      if (.not.bas_numcont(basis,nshell)) call errquit
     &    ('numcont failed',911, BASIS_ERR)
c
      if (.not.geom_ncent(geom,nat)) stop 'geom_ncent fe'
      write(6,*) 'number of atoms ', nat
c
      call intd_init(rtdb, 1, basis)
      call int_mem_1e(maxg1, maxs1)
      maxs1 = max(maxs1,(nbf*nbf*3*nat))
      write(luout,*)' maxs1 = ',maxs1, ' after max for copy '
      status = .true.
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg1,'int buffer' ,hbuf,kbuf)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg1,'int buffer' ,hbuf3,kbuf3)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg1,'int buffer(+)' ,hbufp,kbufp)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg1,'int buffer(2+)' ,hbufpp,kbufpp)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg1,'int buffer(-)' ,hbufm,kbufm)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg1,'int buffer(2-)' ,hbufmm,kbufmm)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxs1,'scr buffer' ,hscr,kscr)
      status = status .and.
     &    ma_alloc_get(mt_dbl,(nbf*nbf*3*nat),'grad' ,hg,kg)
      status = status .and.
     &    ma_alloc_get(mt_dbl,(nbf*nbf*3*nat),
     &    'finite difference grad' ,hfd,kfd)
      status = status .and.
     &    ma_alloc_get(mt_dbl,3*nat,'my coords',hxyz,kxyz)
      if (.not.status) stop ' memory failed rak27 '
      call intd_terminate()
      task_hondo_deriv_check = raktask27_a(rtdb,
     &    geom, basis, nbf, nat, nshell, maxg1, maxs1,
     &    dbl_mb(kg), dbl_mb(kfd), 
     &    dbl_mb(kbuf),
     &    dbl_mb(kbuf3),
     &    dbl_mb(kscr),
     &    dbl_mb(kbufp),
     &    dbl_mb(kbufm),
     &    dbl_mb(kbufpp),
     &    dbl_mb(kbufmm),
     &    dbl_mb(kxyz))
      status = .true.
      status = status.and.ma_free_heap(hg)
      status = status.and.ma_free_heap(hfd)
      status = status.and.ma_free_heap(hbuf)
      status = status.and.ma_free_heap(hbuf3)
      status = status.and.ma_free_heap(hscr)
      status = status.and.ma_free_heap(hbufp)
      status = status.and.ma_free_heap(hbufm)
      status = status.and.ma_free_heap(hbufpp)
      status = status.and.ma_free_heap(hbufmm)
      status = status.and.ma_free_heap(hxyz)
      status = status.and.bas_destroy(basis)
      status = status.and.geom_destroy(geom)
      task_hondo_deriv_check = task_hondo_deriv_check.and.status
      end
C> @}
      logical function raktask27_a(rtdb,
     &    geom, basis, nbf, nat, nshell,
     &    sizeg, sizescr,
     &    grad, fdgrad, buf, buf3, scr, bufp, bufm,
     &    bufpp, bufmm, xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geom.fh"
#include "geomP.fh"
#include "basdeclsP.fh"
#include "basP.fh"
#include "bas.fh"
#include "stdio.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
c
      double precision ddot
      external ddot
c
      logical ignore
      integer rtdb, geom, basis, nbf, nat, nshell
      integer sizeg, sizescr, soid
      double precision xyz(3,nat)
      double precision grad(nbf,nbf,3,nat)
      double precision fdgrad(nbf,nbf,3,nat)
      double precision buf(sizeg), buf3(sizeg)
      double precision bufp(sizeg), bufm(sizeg)
      double precision bufpp(sizeg), bufmm(sizeg)
      double precision scr(sizescr)
c
      double precision thresh, delta, factor, norm
      double precision asum, fdsum
      integer xbas, xsize
      integer ii_np, ii_gen, ii_exp, ii_cf, ii_type, ii_atom
      integer jj_np, jj_gen, jj_exp, jj_cf, jj_type, jj_atom
      integer ishell, ilo, ihi, nbfshi
      integer jshell, jlo, jhi, nbfshj
      integer nbfsh, ucont
      integer atom, ixyz, cnt, i, j
      integer nat3, nshell_use
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      call intd_init(rtdb,1,basis)
c
      nat3 = 3*nat
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*3*nat),0.0d00,grad,1)
      call dfill((nbf*nbf*3*nat),0.0d00,fdgrad,1)
      call dfill(sizeg,0.0d00,buf,1)
      call dfill(sizeg,0.0d00,bufp,1)
      call dfill(sizeg,0.0d00,bufm,1)
      call dfill(sizeg,0.0d00,bufpp,1)
      call dfill(sizeg,0.0d00,bufmm,1)
      call dfill(sizescr,0.0d00,scr,1)
* store original coordintates
*      write(6,*)' original coordinates '
*      if (.not.geom_print(geom)) stop ' gp error'
      call dcopy(nat3,coords(1,1,geom),1,xyz,1)
c
      soid = 0
      thresh = 1.0d-09
      delta = 0.0025d00
      write(6,*)' delta =',delta
      xbas = basis + BASIS_HANDLE_OFFSET
c
      nshell_use = nshell
*      nshell_use = 1
      do ishell = 1, nshell_use
        write(6,*)' fd: ishell = ',ishell,' of ',nshell_use
        call util_flush(6)
        if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &      stop 'cn2bfr error i'
        nbfshi = ihi - ilo + 1
        ucont = (sf_ibs_cn2ucn(ishell,xbas))
        ii_np   = infbs_cont(CONT_NPRIM,ucont,xbas)
        ii_gen  = infbs_cont(CONT_NGEN,ucont,xbas)
        ii_exp  = infbs_cont(CONT_IEXP,ucont,xbas)
        ii_cf   = infbs_cont(CONT_ICFP,ucont,xbas)
        ii_type = infbs_cont(CONT_TYPE,ucont,xbas)
        ii_atom = (sf_ibs_cn2ce(ishell,xbas))
        do jshell = 1, ishell
          if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &        stop 'cn2bfr error j'
          nbfshj = jhi - jlo + 1
          nbfsh = nbfshi*nbfshj
*          write(6,*)' fd:     jshell = ',jshell,' size =',nbfsh
          ucont = (sf_ibs_cn2ucn(jshell,xbas))
          jj_np   = infbs_cont(CONT_NPRIM,ucont,xbas)
          jj_gen  = infbs_cont(CONT_NGEN,ucont,xbas)
          jj_exp  = infbs_cont(CONT_IEXP,ucont,xbas)
          jj_cf   = infbs_cont(CONT_ICFP,ucont,xbas)
          jj_type = infbs_cont(CONT_TYPE,ucont,xbas)
          jj_atom = (sf_ibs_cn2ce(jshell,xbas))
          do atom = 1,nat
            do ixyz = 1,3
              call dcopy(nat3,xyz,1,coords(1,1,geom),1)
              coords(ixyz,atom,geom) =
     &              coords(ixyz,atom,geom) + delta + delta
              call dfill(sizescr,0.0d00,scr,1)
              call dfill(sizeg,0.0d00,buf,1)
              call dfill(sizeg,0.0d00,bufpp,1)
c
*             write(6,*)' plus ', atom, ixyz
*              if (.not.geom_print(geom)) stop ' gp error'
               call hnd_stvint(
     &            coords(1,ii_atom,geom),
     &            dbl_mb(mb_exndcf(ii_exp,xbas)),
     &            dbl_mb(mb_exndcf(ii_cf,xbas)),
     &            ii_np, ii_gen, ii_type,

     &            coords(1,jj_atom,geom),
     &            dbl_mb(mb_exndcf(jj_exp,xbas)),
     &            dbl_mb(mb_exndcf(jj_cf,xbas)),
     &            jj_np, jj_gen, jj_type,
 
     &            coords(1,1,geom),charge(1,geom),nat,
c
c for S, the following line should be used instead of the next active one
c     &            bufpp,scr,scr,nbfsh,.true.,.false.,.false.,
c for T, the following line should be used instead of the next active one
c     &            scr,bufpp,scr,nbfsh,.false.,.true.,.false.,
c
     &            scr,scr,bufpp,nbfsh,.false.,.false.,.true.,
     &            scr,sizescr)
*              if (nbfsh.eq.1) write(6,*)
*     &            ' ',atom,' X=',ixyz,' +', bufp(1)
*
              call dcopy(nat3,xyz,1,coords(1,1,geom),1)
              coords(ixyz,atom,geom) = coords(ixyz,atom,geom) + delta
              call dfill(sizescr,0.0d00,scr,1)
              call dfill(sizeg,0.0d00,bufp,1)
c
*             write(6,*)' plus ', atom, ixyz
*              if (.not.geom_print(geom)) stop ' gp error'
               call hnd_stvint(
     &            coords(1,ii_atom,geom),
     &            dbl_mb(mb_exndcf(ii_exp,xbas)),
     &            dbl_mb(mb_exndcf(ii_cf,xbas)),
     &            ii_np, ii_gen, ii_type,

     &            coords(1,jj_atom,geom),
     &            dbl_mb(mb_exndcf(jj_exp,xbas)),
     &            dbl_mb(mb_exndcf(jj_cf,xbas)),
     &            jj_np, jj_gen, jj_type,
 
     &            coords(1,1,geom),charge(1,geom),nat,
c
c for S, the following line should be used instead of the next active one
c     &            bufp,scr,scr,nbfsh,.true.,.false.,.false.,
c for T, the following line should be used instead of the next active one
c     &            scr,bufp,scr,nbfsh,.false.,.true.,.false.,
c
     &            scr,scr,bufp,nbfsh,.false.,.false.,.true.,
     &            scr,sizescr)
*              if (nbfsh.eq.1) write(6,*)
*     &            ' ',atom,' X=',ixyz,' +', bufp(1)
*
              call dcopy(nat3,xyz,1,coords(1,1,geom),1)
              coords(ixyz,atom,geom) = coords(ixyz,atom,geom) - delta
              call dfill(sizescr,0.0d00,scr,1)
              call dfill(sizeg,0.0d00,bufm,1)
c
*              write(6,*)' minus ', atom, ixyz
*              if (.not.geom_print(geom)) stop ' gp error'
               call hnd_stvint(
     &            coords(1,ii_atom,geom),
     &            dbl_mb(mb_exndcf(ii_exp,xbas)),
     &            dbl_mb(mb_exndcf(ii_cf,xbas)),
     &            ii_np, ii_gen, ii_type,

     &            coords(1,jj_atom,geom),
     &            dbl_mb(mb_exndcf(jj_exp,xbas)),
     &            dbl_mb(mb_exndcf(jj_cf,xbas)),
     &            jj_np, jj_gen, jj_type,
 
     &            coords(1,1,geom),charge(1,geom),nat,
c
c for S, the following line should be used instead of the next active one
c     &            bufm,scr,scr,nbfsh,.true.,.false.,.false.,
c for T, the following line should be used instead of the next active one
c     &            scr,bufm,scr,nbfsh,.false.,.true.,.false.,
c
     &            scr,scr,bufm,nbfsh,.false.,.false.,.true.,
     &            scr,sizescr)
*
              call dcopy(nat3,xyz,1,coords(1,1,geom),1)
              coords(ixyz,atom,geom) =
     &              coords(ixyz,atom,geom) - delta - delta 
              call dfill(sizescr,0.0d00,scr,1)
              call dfill(sizeg,0.0d00,bufmm,1)
c
*              write(6,*)' minus ', atom, ixyz
*              if (.not.geom_print(geom)) stop ' gp error'
               call hnd_stvint(
     &            coords(1,ii_atom,geom),
     &            dbl_mb(mb_exndcf(ii_exp,xbas)),
     &            dbl_mb(mb_exndcf(ii_cf,xbas)),
     &            ii_np, ii_gen, ii_type,

     &            coords(1,jj_atom,geom),
     &            dbl_mb(mb_exndcf(jj_exp,xbas)),
     &            dbl_mb(mb_exndcf(jj_cf,xbas)),
     &            jj_np, jj_gen, jj_type,
 
     &            coords(1,1,geom),charge(1,geom),nat,
c
c for S, the following line should be used instead of the next active one
c     &            bufmm,scr,scr,nbfsh,.true.,.false.,.false.,
c for T, the following line should be used instead of the next active one
c     &            scr,bufmm,scr,nbfsh,.false.,.true.,.false.,
c
     &            scr,scr,bufmm,nbfsh,.false.,.false.,.true.,
     &            scr,sizescr)
*              if (nbfsh.eq.1) write(6,*)
*     &            ' ',atom,' X=',ixyz,' -', bufm(1)
*
*.............. 3 point
              factor = 1.0d00/(2.0d00*delta)
              call dcopy(nbfsh,bufp,1,buf3,1)
              call daxpy(nbfsh,-1.0d00,bufm,1,buf3,1)
              call dscal(nbfsh,factor,buf3,1)
*.............. 5 point
              factor = 2.0d0/(3.0d0*delta)
              call dscal(nbfsh,factor,bufp,1)
              call dscal(nbfsh,factor,bufm,1)
              factor = 1.0d00/(12.0d00*delta)
              call dscal(nbfsh,factor,bufpp,1)
              call dscal(nbfsh,factor,bufmm,1)
              call dcopy(nbfsh,          bufp, 1,buf,1)
              call daxpy(nbfsh,-1.0d00,  bufm, 1,buf,1)
              call daxpy(nbfsh,-1.0d00, bufpp, 1,buf,1)
              call daxpy(nbfsh, 1.0d00, bufmm, 1,buf,1)
              
*              if (nbfsh.eq.1) write(6,*)
*     &            ' ',atom,' X=',ixyz,' g', buf(1)
              cnt = 1
              do i = ilo,ihi
                do j = jlo, jhi
                  fdgrad(i,j,ixyz,atom) = buf(cnt)
                  fdgrad(j,i,ixyz,atom) = buf(cnt)
                    grad(i,j,ixyz,atom) = buf3(cnt)   ! grad has 3 point
                    grad(j,i,ixyz,atom) = buf3(cnt)
                  cnt = cnt + 1
                enddo
              enddo
              if (.not.ma_verify_allocator_stuff())
     &            stop ' ma broke 3'
            enddo
          enddo
        enddo
      enddo
      write(6,*)' differences between 3 point and 5 point '
      call rak27_diff(fdgrad,grad,nbf,nat)
c
*      call prt27(fdgrad,nbf,nat,'fd gradient')
c
      call dcopy(nat3,xyz,1,coords(1,1,geom),1)
      call dfill((nbf*nbf*3*nat),0.0d00,grad,1)
*
      nshell_use = nshell
*      nshell_use = 1
      do ishell = 1, nshell_use
        write(6,*)'  a: ishell = ',ishell,' of ',nshell_use
        call util_flush(6)
        if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &      stop 'cn2bfr error i'
        nbfshi = ihi - ilo + 1
        ucont = (sf_ibs_cn2ucn(ishell,xbas))
        ii_np   = infbs_cont(CONT_NPRIM,ucont,xbas)
        ii_gen  = infbs_cont(CONT_NGEN,ucont,xbas)
        ii_exp  = infbs_cont(CONT_IEXP,ucont,xbas)
        ii_cf   = infbs_cont(CONT_ICFP,ucont,xbas)
        ii_type = infbs_cont(CONT_TYPE,ucont,xbas)
        ii_atom = (sf_ibs_cn2ce(ishell,xbas))
        do jshell = 1, ishell
          if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &        stop 'cn2bfr error j'
          nbfshj = jhi - jlo + 1
          nbfsh = nbfshi*nbfshj
*          write(6,*)'  a:     jshell = ',jshell,' size =',nbfsh
          ucont = (sf_ibs_cn2ucn(jshell,xbas))
          jj_np   = infbs_cont(CONT_NPRIM,ucont,xbas)
          jj_gen  = infbs_cont(CONT_NGEN,ucont,xbas)
          jj_exp  = infbs_cont(CONT_IEXP,ucont,xbas)
          jj_cf   = infbs_cont(CONT_ICFP,ucont,xbas)
          jj_type = infbs_cont(CONT_TYPE,ucont,xbas)
          jj_atom = (sf_ibs_cn2ce(jshell,xbas))
c
          call dfill(sizescr,0.0d00,scr,1)
          call dfill(sizeg,0.0d00,buf,1)
c
c   The next line is not needed for V, but is for S and T
c
c         if (ii_atom.eq.jj_atom) goto 220
          call hnd_stvintd(
     &        coords(1,ii_atom,geom),
     &        dbl_mb(mb_exndcf(ii_exp,xbas)),
     &        dbl_mb(mb_exndcf(ii_cf,xbas)),
     &        ii_np, ii_gen, ii_type, ii_atom,
          
     &        coords(1,jj_atom,geom),
     &        dbl_mb(mb_exndcf(jj_exp,xbas)),
     &        dbl_mb(mb_exndcf(jj_cf,xbas)),
     &        jj_np, jj_gen, jj_type, jj_atom,
          
     &        coords(1,1,geom),charge(1,geom),nat,
c
c for S, the following 2 lines should be used instead of the next 2 active ones
c     &        buf,scr,scr,nbfsh,
c     &        .true.,.false.,.false.,
c for T, the following 2 lines should be used instead of the next 2 active ones
c     &        scr,buf,scr,nbfsh,
c     &        .false.,.true.,.false.,
c
     &        scr,scr,buf,nbfsh,
     &        .false.,.false.,.true.,
     &        scr,sizescr)
c
c Here is the call to the nw integrals for comparison.  This call is
c set up to only do the V call.
c
c         call hf1d(
c    &        coords(1,ii_atom,geom),
c    &        dbl_mb(mb_exndcf(ii_exp,xbas)),
c    &        dbl_mb(mb_exndcf(ii_cf,xbas)),
c    &        ii_np, ii_gen, ii_type, ii_atom,
c         
c    &        coords(1,jj_atom,geom),
c    &        dbl_mb(mb_exndcf(jj_exp,xbas)),
c    &        dbl_mb(mb_exndcf(jj_cf,xbas)),
c    &        jj_np, jj_gen, jj_type, jj_atom,
c         
c    &        coords(1,1,geom),charge(1,geom),nat,
c    &        scr,scr,buf,nbfsh,
c    &        .false.,.false.,.true.,.false.,.false.,
c    &        scr,sizescr)
          xsize = nbfsh*3*nat
c          if (nbfsh.eq.9) then
c            do i = 1, 3*nat
c              write(6,*)' grad buff ',i,' ',buf(i)
c            enddo
c          endif
          cnt = 1
          do atom=1,nat
            do ixyz = 1,3
              do i = ilo, ihi
                do j = jlo, jhi
                  grad(i,j,ixyz,atom) = buf(cnt)
                  grad(j,i,ixyz,atom) = buf(cnt)
                  cnt = cnt + 1
                enddo
              enddo
            enddo
          enddo
c
c220    continue
        enddo
      enddo

c
*      call prt27(grad,nbf,nat,'   gradient')
c
      xsize = nbf*nbf*3*nat
      do i = 1,nbf
        do j = 1,i
          asum = 0.0d00
          fdsum = 0.0d00
          do atom = 1,nat
            do ixyz = 1,3
              asum = asum + grad(i,j,ixyz,atom)
              fdsum = fdsum + fdgrad(i,j,ixyz,atom)
            enddo
          enddo
          if ((abs(asum).gt.1.0d-06).or.(abs(fdsum).gt.1.0d-06))
     &        write(6,*)i,j,asum,fdsum
        enddo
      enddo
c
      xsize = nbf*nbf*3*nat
      call dcopy(xsize,grad,1,scr,1)
c
c The signs seem to be opposite for the derivative integrals and the finite
c difference integrals.  The integrals themselves seem to be O.K. according to
c the nw integrals and several test cases. Changed -1.0 to 1.0
c The sign should be 1.0 for the S and T integrals.
c
      call daxpy(xsize,-1.0d00,fdgrad,1,scr,1)
      norm = ddot(xsize,scr,1,scr,1)
      write(luout,*)' difference norm for hondo derivs: ',norm
      call util_flush(luout)
c
      call intd_terminate()
      raktask27_a = norm .lt. thresh
      if (raktask27_a) return
c
      call rak27_diff(fdgrad,grad,nbf,nat)
c
      end
      subroutine prt27(g,nbf,nat,msg)
      implicit none
#include "stdio.fh"
      integer nbf
      integer nat
      double precision g(nbf,nbf,3,nat)
      character*(*) msg
c
      double precision thresh, val
      integer i,j,x,a
c
      thresh = 1.0d-06
      write(luout,*)'........................................   ',msg
      do i = 1,nbf
        do j = 1,i
          do x = 1,3
            do a = 1,nat
              val = g(i,j,x,a)
              if (abs(val).gt.thresh) then
                write(luout,10000)i,j,x,a,val
              endif
            enddo
          enddo
        enddo
      enddo
      write(luout,*)
      write(luout,*)
10000 format(1x,'g(',4i5,') =',1pd20.10)
      end
      subroutine rak27_diff(fd,g,nbf,nat)
      implicit none
#include "stdio.fh"
      integer nbf, nat
      double precision fd(nbf,nbf,3,nat)
      double precision  g(nbf,nbf,3,nat)
c
      double precision aval, val, thresh
      integer i, j, x, a, t
      integer hgram(10)
      double precision tt(9)
      logical pheader
c
      call ifill(10,0,hgram,1)
      do i = 1,9
        tt(i) = 10.0d00**(-(12-i))
      enddo
*      write(6,*)' tt is ', tt
      write(luout,*)
      write(luout,*)
      write(luout,*)
      pheader = .false.
      thresh = 1.0d-05
      do i = 1,nbf
        do j = 1,nbf
          do x = 1,3
            do a = 1,nat
              val = g(i,j,x,a) - fd(i,j,x,a) 
              aval = abs(val)
              if (aval.lt.tt(1)) then
                hgram(1) = hgram(1) + 1
              else if (aval.gt.tt(9)) then
                hgram(10) = hgram(10) + 1
              else
                do t = 2,9
                  if (aval.le.tt(t).and.aval.gt.tt((t-1)))
     &                hgram(t) = hgram(t) + 1
                enddo
              endif
              if (aval.gt.thresh)then
                if (.not.pheader) then
                  write(luout,10000)
                  pheader = .true.
                endif
                write(luout,10001)
     &              i,j,x,a,g(i,j,x,a),fd(i,j,x,a),val
              endif
            enddo
          enddo
        enddo
      enddo
c
10010 format(1x,'Difference count <',1x,1pd8.2,18x,i10,' values')
10011 format(1x,'Difference count <',1x,
     &    1pd8.2,' and >',1x,1pd8.2,3x,i10,' values')
10012 format(1x,'Difference count ',15x,'>',1x,1pd8.2,3x,i10,' values')
      write(luout,10010)tt(1),hgram(1) 
      do i = 2,9
        write(luout,10011) tt(i),tt(i-1),hgram(i) 
      enddo
      write(luout,10012)tt(9),hgram(10)
*                12345
10000 format(1x,'   i ','   j ','   x ','   a ',3x,
*          12345678901234567890123
     &    '   ---- analytic ------',3x,
     &    '   - FiniteDifference -',3x,
     &    '   --- difference -----')
10001 format(1x,4i5,3(3x,1pd20.10))
      end

      SUBROUTINE ccsdtq_lambda2_12_3_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdtq_lambda2_12_3_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h7 h8 h12 p1 )_v + = 1 * v ( h7 h8 h12 p1 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER h8b
      INTEGER p1b
      INTEGER h12b
      INTEGER dimc
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER p1b_1
      INTEGER h12b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h7b = 1,noab
      DO h8b = h7b,noab
      DO p1b = noab+1,noab+nvab
      DO h12b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+h12b-1).ne.8)) THEN
      IF (int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),ieor(int_mb(k_sym+h8b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+h8b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+h12b-1)
      CALL TCE_RESTRICTED_4(h7b,h8b,p1b,h12b,h7b_1,h8b_1,p1b_1,h12b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h7b-1) * int_mb(k_range+h8b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+h12b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_12_3_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_12_3_1',1,MA_ERR)
      IF ((h12b .le. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - 1 + (noab+nvab) * (h12b_1 - 1 + (noab+nvab) * (h8b_1 - 1 + (noa
     &b+nvab) * (h7b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h12b-1),int_mb(k_range+p1b-1
     &),3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_12_3_1',2
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_12_3_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+h8b-1),int_mb(k_range+h7b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h12b 
     &- 1 + noab * (p1b - noab - 1 + nvab * (h8b - 1 + noab * (h7b - 1))
     &)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_12_3_1',4
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_12_3
     &_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE ccsdt_y_tr3_4_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsdt_y_tr3_4_4.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h11 )_vtrt + = 1 * Sum ( p7 ) * t ( p7 h11 )_t * i2 ( h4 p7 )_vtr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p7b_1
      INTEGER h11b_1
      INTEGER h4b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h4b = 1,noab
      DO h11b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h11b-
     &1).ne.4)) THEN
      IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h11b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+h11b-1)) .eq. ieor(irrep
     &_v,ieor(irrep_tr,irrep_t))) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h11b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr3_4_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      IF (int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h11b-1)) THEN
      IF (ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+h11b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p7b,h11b,p7b_1,h11b_1)
      CALL TCE_RESTRICTED_2(h4b,p7b,h4b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1)
      dima_sort = int_mb(k_range+h11b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr3_4_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr3_4_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h11b_
     &1 - 1 + noab * (p7b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h11b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr3_4_4',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr3_4_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr3_4_4',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (h4b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p7b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr3_4_4',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr3_4_4',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr3_4_4',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr3_4_4',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h11b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h11b 
     &- 1 + noab * (h4b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr3_4_4',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr3_4_4',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine tce_mbpt2(d_mo2e,k_2e_offset,
     1                     d_t2,k_t2_offset,mbpt2)
c
c $Id: tce_mbpt2.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
      integer d_mo2e
      integer d_t2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer k_2e_offset
      integer k_t2_offset
      integer size
      integer l_t2,k_t2
      integer l_v2,k_v2
      integer g_mbpt2
      double precision factor
      double precision mbpt2
      integer nprocs
      integer count
      integer next
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      double precision cpu
      double precision wall
      logical nodezero
c
      nodezero=(ga_nodeid().eq.0)
      cpu=-util_cpusec()
      wall=-util_wallsec()
c
c     =====================
c     Zero scratch residual
c     =====================
c
      if (.not.ga_create(mt_dbl,1,1,'mbpt2',1,1,g_mbpt2))
     1  call errquit('tce_mbpt2: GA problem',0,GA_ERR)
      mbpt2 = 0.0d0
      call ga_put(g_mbpt2,1,1,1,1,mbpt2,1)
      call ga_sync()
c
c     ================
c     Loop over blocks
c     ================
c
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do h3b = 1,noab
            do h4b = h3b,noab
              if (next.eq.count) then
                if ((.not.restricted).or.
     1             (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)
     2             +int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8))
     3             then
                if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1            .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
                if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1            ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2            .eq. 0) then
                  factor = 0.25d0
                  if (p2b .gt. p1b) factor = factor * 2.0d0
                  if (h4b .gt. h3b) factor = factor * 2.0d0
                if ((restricted).and.
     1             (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)
     2             +int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).eq.4))
     3             factor = factor * 2.0d0
                  size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1                 * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                  if (.not.ma_push_get(mt_dbl,size,'v2',l_v2,k_v2))
     1              call errquit('tce_mbpt2: MA problem',0,MA_ERR)
                  call get_hash_block(d_mo2e,dbl_mb(k_v2),size,
     1              int_mb(k_2e_offset),((((p1b-1)*(noab+nvab)+p2b-1)
     2              *(noab+nvab)+h3b-1)*(noab+nvab)+h4b-1))
                  if (.not.ma_push_get(mt_dbl,size,'t2',l_t2,k_t2))
     1              call errquit('tce_mbpt2: MA problem',1,MA_ERR)
                  call get_hash_block(d_t2,dbl_mb(k_t2),size,
     1              int_mb(k_t2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2              *noab+h3b-1)*noab+h4b-1))
                  mbpt2 = ddot(size,dbl_mb(k_t2),1,dbl_mb(k_v2),1)
                  if (util_print('mbpt2',print_debug))
     1              write(LuOut,9200) ga_nodeid(),p1b,p2b,h3b,h4b,
     2              mbpt2 * factor
                  call ga_acc(g_mbpt2,1,1,1,1,mbpt2,1,factor)
                  if (.not.ma_pop_stack(l_t2))
     1              call errquit('tce_mbpt2: MA problem',2,MA_ERR)
                  if (.not.ma_pop_stack(l_v2))
     1              call errquit('tce_mbpt2: MA problem',3,MA_ERR)
                endif
                endif
                endif
cc                next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
              endif
              count = count + 1
            enddo
          enddo
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      call ga_get(g_mbpt2,1,1,1,1,mbpt2,1)
      if (.not.ga_destroy(g_mbpt2))
     1  call errquit('tce_mbpt2: GA problem',1,GA_ERR)
      cpu=cpu+util_cpusec()
      wall=wall+util_wallsec()
      if (nodezero) write(LuOut,9020) cpu, wall
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9200 format(/,1x,'node',i3,' blocks:',4i3,' MBPT(2) contribution',
     1       f20.10)
      return
      end

C> \ingroup selci
C> @{
      subroutine selci_rdhead(title,type)
*
* $Id: rdhead.F 24790 2013-11-11 18:56:49Z d3y133 $
*
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
#include "cselcifiles.fh"
      character*(*) type
      character*80 title, dtitle(10)
c
c     open these here for tidiness
c
      if (type .eq. 'ci') then
c     closed in makeh
         open(iflham,form='unformatted',status='unknown',file=hamil)
         open(iflhdg,form='unformatted',status='unknown',file=hamdg)
      endif
c
c     open and read info from the CICONF file header
c
      open(iflcon, form='unformatted',status='old',file=ciconf)
      call selci_rdhcon(iflcon, title, multi, nelec, issss, norbs,
     $     nnsmax, 
     &     nci, noconf, nintpo, nbitpi, nbpsy, isym, nsym, inttyp,
     &     nsneed)
c
c     open and read info from the MOINTS file header
c
      call selci_rdhint(iflint,ntitle,dtitle,repnuc,nnorbs,inttyp,
     $     moints)
c
c     make, open and read info from the WMATRX file header
c 
      nsmax = nsneed(2)
      if (type.eq.'select') nsmax=nsneed(3)
      call selci_couple(multi,nsmax,0,wmatrx)
      open(iflwmt, form='formatted',status='old',file=wmatrx)
      call selci_rdhwmt(iflwmt,mmulti, nsmax, nf, nfmax, nfmax2)
c
c     check the files for consistency
c
      if (norbs.gt.nnorbs) then
         write(ifllog,*) ' norbs = ',norbs,' nnorbs=',nnorbs
         call errquit(' info from files does not tally ',0, INPUT_ERR)
      endif
c
c     if actually do PT selection need to open civecs file
c
      if (type.eq.'select') then
         open(iflciv,file=civecs,form='unformatted',status='old')
         read (iflciv) nroot,nnci
         if (nnci.ne.nci)
     $        call errquit('nci ciconf, civecs mismatch',nnci,
     &       INPUT_ERR)
      endif
c
      end
C> @}

c
c $Id: nwpw_set_library.F 19707 2010-10-29 17:59:36Z d3y133 $
c

      subroutine nwpw_set_library(rtdb)
      implicit none
      integer rtdb


#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"

      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 5)
      character*30 dirs(num_dirs)
      data dirs / 'pspw_library',
     >            'library',
     >            'paw_library',
     >            'cpi',
     >            'teter' /

      character*4  atom
      character*255 rtdb_name,library_type,library_name
      integer idum


 10   if (.not. inp_read())
     >     call errquit(
     >     'nwpw_set_library: inp_read failed', 0, INPUT_ERR)

      if (.not. inp_a(atom))
     >     call errquit(
     >     'nwpw_set_library: inp_a failed', 0, INPUT_ERR)

      if (inp_compare(.false.,atom,'end')) goto 100
      
      if (.not. inp_a(library_type))
     >     call errquit(
     >     'nwpw_set_library: inp_a failed', 0, INPUT_ERR)

      if (.not. inp_a(library_name))
     >     call errquit(
     >     'nwpw_set_library: inp_a failed', 0, INPUT_ERR)


      if(.not.inp_match(num_dirs,.false.,library_type,dirs,ind))
     > call errquit('nwpw_set_library: unknown library type', 
     >              0,INPUT_ERR)
c
c
      goto ( 20, 20, 30, 40, 50) ind
      call errquit('nwpw_set_library: unimplemented directive', ind,
     &       INPUT_ERR)


c
c pspw_library
c
  20  ind = index(atom,' ') - 1
      rtdb_name = atom(1:ind)//':pspw_library'
      ind = index(library_name,' ') - 1
      if (.not. rtdb_cput(rtdb,rtdb_name,
     >                  1,library_name(1:ind)))
     > call errquit('nwpw_set_library: rtdb write error', 
     >              0,INPUT_ERR)

      rtdb_name = atom(1:ind)//':pspw_library_type'
      if (.not. rtdb_put(rtdb,rtdb_name,mt_int,1,0))
     > call errquit('nwpw_set_library: rtdb write error', 
     >              0,INPUT_ERR)
      goto 10

c
c  paw_library
c
  30  ind = index(atom,' ') - 1
      rtdb_name = atom(1:ind)//':paw_library'
      ind = index(library_name,' ') - 1
      if (.not. rtdb_cput(rtdb,rtdb_name,
     >                  1,library_name(1:ind)))
     > call errquit('nwpw_set_library: rtdb write error', 
     >              0,INPUT_ERR)
      goto 10

c
c CPI filename
c
  40  ind = index(atom,' ') - 1
      rtdb_name = atom(1:ind)//':pspw_library'
      ind = index(library_name,' ') - 1
      if (.not. rtdb_cput(rtdb,rtdb_name,
     >                  1,library_name(1:ind)))
     > call errquit('nwpw_set_library: rtdb write error', 
     >              0,INPUT_ERR)

      idum = 2
      ind = index(atom,' ') - 1
      rtdb_name = atom(1:ind)//':pspw_library_type'
      if (.not. rtdb_put(rtdb,rtdb_name,mt_int,1,idum))
     > call errquit('nwpw_set_library: rtdb write error', 
     >              0,INPUT_ERR)
      goto 10

c
c TETER filename
c
  50  ind = index(atom,' ') - 1
      rtdb_name = atom(1:ind)//':pspw_library'
      ind = index(library_name,' ') - 1
      if (.not. rtdb_cput(rtdb,rtdb_name,
     >                  1,library_name(1:ind)))
     > call errquit('nwpw_set_library: rtdb write error', 
     >              0,INPUT_ERR)

      idum = 3
      ind = index(atom,' ') - 1
      rtdb_name = atom(1:ind)//':pspw_library_type'
      if (.not. rtdb_put(rtdb,rtdb_name,mt_int,1,idum))
     > call errquit('nwpw_set_library: rtdb write error', 
     >              0,INPUT_ERR)
      goto 10



 100  continue

      return
      end

      subroutine smd_bond_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_bond,sp_param
      character*32 tag,pname
      logical result

      pname = "smd_bond_init_system"
c
      tag = "bond"
      call smd_system_get_component(sp_bond,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_bond_init(sp_bond,sp_param,result)

      if(.not.result) then
       tag = "bond"
       call smd_system_unset_component(tag)
      end if
c
      return
      end

      subroutine smd_bond_init(sp_bond,sp_param,result)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_bond
      character*(*) sp_param
      logical result
c
      character*32 pname
      character*80 tag
      character*255 filename
      integer i,nb,nt
      integer i_i1,i_i2,i_d,i_k,i_it
      integer i_ta,i_tr
c
      pname = "smd_bond_init"
c
c      write(*,*) "in "//pname
c
c     get total number of shake parameters
c     ------------------------------------
      call smd_paramfile_nbond(nb)
      write(*,*) "number of shake parameters",nb
      if(nb.eq.0) then
        result = .false.
        goto 100
      end if
c
c     create parameter data structures
c     ---------------------------
      call smd_namespace_create(sp_bond)
      call smd_data_create(sp_bond,"bond:i1",nb,MT_INT)
      call smd_data_create(sp_bond,"bond:i2",nb,MT_INT)
      call smd_data_create(sp_bond,"bond:type",nb,MT_INT)
      call smd_data_create(sp_bond,"bond:distance",nb,MT_DBL)
      call smd_data_create(sp_bond,"bond:strength",nb,MT_DBL)
c
c     get array of type names
c     -----------------------
      tag = "param:atomname"
      call smd_data_get_index(sp_param,tag,i_ta,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      call smd_data_get_size(sp_param,tag,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for'//tag,0, RTDB_ERR)
      nt = nt/16
      tag = "param:resname"
      call smd_data_get_index(sp_param,tag,i_tr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
 
c
c     get bond arrays
c     ----------------
      tag = "bond:i1"
      call smd_data_get_index(sp_bond,tag,i_i1,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:i2"
      call smd_data_get_index(sp_bond,tag,i_i2,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:distance"
      call smd_data_get_index(sp_bond,tag,i_d,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:strength"
      call smd_data_get_index(sp_bond,tag,i_k,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "bond:type"
      call smd_data_get_index(sp_bond,tag,i_it,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)


      call smd_paramfile_read_bond(nb,nt,
     +                         int_mb(i_i1),
     +                         int_mb(i_i2),
     +                         int_mb(i_it),
     +                         dbl_mb(i_d),
     +                         dbl_mb(i_k),
     +                         byte_mb(i_ta),
     +                         byte_mb(i_tr))


      do i=1,nb
       write(*,*) "BOND",
     >            int_mb(i_i1+i-1),
     >            int_mb(i_i2+i-1),
     >            int_mb(i_it+i-1),
     >            dbl_mb(i_d+i-1),
     >            dbl_mb(i_k+i-1)
      end do
100   continue
      return
      end

      subroutine smd_bond_nshake(sp_bond,ns)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
c     
      integer ns
      character*(*) sp_bond
c
      character*30 tag
      character*32 pname
      integer i,nb,nt
      integer i_it
      logical result
c
      pname = "smd_bond_nshake"
c
      write(*,*) "in "//pname
c
c     get bond arrays
c     ----------------
      tag = "bond:type"
      call smd_data_get_index(sp_bond,tag,i_it,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)
      call smd_data_get_size(sp_bond,tag,nb,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)



      ns = 0 
      do i=1,nb
       if(int_mb(i_it+i-1).eq.1)
     >    ns = ns + 1
 
      end do
100   continue
      return
      end
c $Id: smd_bond.F 22502 2012-05-20 06:11:57Z d3y133 $

*
* $Id: aorbs.F 24375 2013-07-06 18:53:39Z bylaska $
*

#define TCGMSG

*     ***********************************
*     *					*
*     *	 	     aorbs_init		*
*     *					*
*     ***********************************
      logical function aorbs_init()      
      implicit none

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

*     **** local variables ****
      integer npack1,nion
      logical value

*     **** external functions *****
      integer  ion_nkatm_qm,ion_nion_qm
      external ion_nkatm_qm,ion_nion_qm
 

      call Pack_npack(1,npack1)
      nion   = ion_nion_qm()
      nkatmx = ion_nkatm_qm()

      value = MA_alloc_get(mt_dbl,(norbs_max*nkatmx*npack1),
     >                    'aorbs',aorbs(2),aorbs(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(nkatmx),'lmmax',lmmax(2),lmmax(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(nkatmx),'lmax',lmax(2),lmax(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(nkatmx),'locp',locp(2),locp(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(nkatmx),'rcut',rcut(2),rcut(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(nkatmx),'lmbda',lmbda(2),lmbda(1))

      value = value.and.
     >        MA_alloc_get(mt_int,(nion*norbs_max),
     >                    'lmaorb',lmaorb(2),lmaorb(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(nion*norbs_max),
     >                    'iaaorb',iaaorb(2),iaaorb(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(nion*norbs_max),
     >                    'iiaorb',iiaorb(2),iiaorb(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(nion*norbs_max),
     >                    'basisaorb',basisaorb(2),basisaorb(1))

      if (value) 
     >  call dcopy(norbs_max*nkatmx*npack1,0.0d0,0,dbl_mb(aorbs(1)),1)
      aorbs_init = value
      return
      end


*     ***********************************
*     *					*
*     *	 	     aorbs_end		*
*     *					*
*     ***********************************
      subroutine aorbs_end()      
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "aorbs.fh"

*     **** local variables ****
      logical value

      value = MA_free_heap(aorbs(2))
      value = value.and.MA_free_heap(lmmax(2))
      value = value.and.MA_free_heap(lmax(2))
      value = value.and.MA_free_heap(locp(2))
      value = value.and.MA_free_heap(rcut(2))
      value = value.and.MA_free_heap(lmbda(2))
      value = value.and.MA_free_heap(lmaorb(2))
      value = value.and.MA_free_heap(iaaorb(2))
      value = value.and.MA_free_heap(iiaorb(2))
      value = value.and.MA_free_heap(basisaorb(2))
      if (.not. value) call errquit('aorbs_end:freeing heap memory',0,
     &       MA_ERR)

      return
      end


*     ***********************************
*     *					*
*     *	 	     aorbs_norbs	*
*     *					*
*     ***********************************

      integer function aorbs_norbs(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

      aorbs_norbs = int_mb(lmmax(1)+ia-1)
      return
      end


*     ***********************************
*     *					*
*     *	 	   aorbs_nbasis		*
*     *					*
*     ***********************************
      integer function aorbs_nbasis()
      implicit none

***** AORBS common block ****
#include "aorbs.fh"

      aorbs_nbasis = ibasis
      return
      end

*     ***********************************
*     *                                 *
*     *              aorbs_lmax         *
*     *                                 *
*     ***********************************

      integer function aorbs_lmax(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

      aorbs_lmax = int_mb(lmax(1)+ia-1)-1
      return
      end


*     ***********************************
*     *                                 *
*     *              aorbs_rcut         *
*     *                                 *
*     ***********************************
      real*8 function aorbs_rcut(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"
#include "aorbs.fh"

      aorbs_rcut = dbl_mb(rcut(1)+ia-1)
      return
      end

*     ***********************************
*     *                                 *
*     *           aorbs_lmbda           *
*     *                                 *
*     ***********************************
      real*8 function aorbs_lmbda(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"
#include "aorbs.fh"

      aorbs_lmbda = dbl_mb(lmbda(1)+ia-1)
      return
      end


*     ***********************************
*     *                                 *
*     *              aorbs_l            *
*     *                                 *
*     ***********************************

      integer function aorbs_l(ia,n)
      implicit none
      integer  ia
      integer n          ! basis number

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

*     *** local variables ***
      integer l,m,lm
      
      lm = int_mb(lmaorb(1)+n-1)
      l = 0
      if (lm.eq.1) l = 0 

      if (lm.eq.2) l = 1
      if (lm.eq.3) l = 1
      if (lm.eq.4) l = 1

      if (lm.eq.5) l = 2
      if (lm.eq.6) l = 2
      if (lm.eq.7) l = 2
      if (lm.eq.8) l = 2
      if (lm.eq.9) l = 2

      if (lm.eq.10) l = 3
      if (lm.eq.11) l = 3
      if (lm.eq.12) l = 3
      if (lm.eq.13) l = 3
      if (lm.eq.14) l = 3
      if (lm.eq.15) l = 3
      if (lm.eq.16) l = 3

      aorbs_l = l
      return
      end


*     ***********************************
*     *                                 *
*     *              aorbs_m            *
*     *                                 *
*     ***********************************

      integer function aorbs_m(ia,n)
      implicit none
      integer  ia
      integer n          ! basis number

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

*     *** local variables ***
      integer l,m,lm

      lm = int_mb(lmaorb(1)+n-1)
      m = 0
      if (lm.eq.1) m = 0

      if (lm.eq.2) m = -1
      if (lm.eq.3) m =  0
      if (lm.eq.4) m =  1

      if (lm.eq.5) m = -2
      if (lm.eq.6) m = -1
      if (lm.eq.7) m =  0
      if (lm.eq.8) m =  1
      if (lm.eq.9) m =  2

      if (lm.eq.10) m = -3
      if (lm.eq.11) m = -2
      if (lm.eq.12) m = -1
      if (lm.eq.13) m =  0
      if (lm.eq.14) m =  1
      if (lm.eq.15) m =  2
      if (lm.eq.16) m =  3

      aorbs_m = m
      return
      end




*     ***********************************
*     *                                 *
*     *           aorbs_katm            *
*     *                                 *
*     ***********************************
      integer function aorbs_katm(n)
      implicit none
      integer n

#include "mafdecls.fh"
#include "aorbs.fh"

      aorbs_katm = int_mb(iaaorb(1)+n-1)
      return
      end


*     ***********************************
*     *                                 *
*     *           aorbs_ii              *
*     *                                 *
*     ***********************************
      integer function aorbs_ii(n)
      implicit none
      integer n

#include "mafdecls.fh"
#include "aorbs.fh"

      aorbs_ii = int_mb(iiaorb(1)+n-1)
      return
      end



*     ***********************************
*     *                                 *
*     *     aorbs_get_basis_number      *
*     *                                 *
*     ***********************************

      integer function aorbs_get_basis_number(ii,lm)
      implicit none
      integer ii,lm

#include "mafdecls.fh"
#include "aorbs.fh"

      aorbs_get_basis_number=int_mb(basisaorb(1)+lm-1+(ii-1)*norbs_max)

      return
      end



*     ***********************************
*     *					*
*     *	 	   aorbs_normalize  	*
*     *					*
*     ***********************************
      subroutine aorbs_normalize()
      implicit none

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

*     **** local variables ****
      integer n,lm,ia,npack1
      real*8  sum

      call Pack_npack(1,npack1)

*     **** Normalize atomic orbitals in k space *****
      do n=1,ibasis
         lm = int_mb(lmaorb(1)+n-1)
         ia = int_mb(iaaorb(1)+n-1)
         call Pack_tt_dot(1,
     >                    dbl_mb(aorbs(1) 
     >                          + (lm-1)*npack1
     >                          + (ia-1)*npack1*norbs_max),
     >                    dbl_mb(aorbs(1) 
     >                          + (lm-1)*npack1
     >                          + (ia-1)*npack1*norbs_max),
     >                    sum)
         sum = 1.0d0/dsqrt(sum)
c         call Pack_t_SMul(1,sum,
c     >                    dbl_mb(aorbs(1) 
c     >                          + (lm-1)*npack1
c     >                          + (ia-1)*npack1*norbs_max),
c     >                    dbl_mb(aorbs(1) 
c     >                          + (lm-1)*npack1
c     >                          + (ia-1)*npack1*norbs_max))
         call Pack_t_SMul1(1,sum,
     >                    dbl_mb(aorbs(1) 
     >                          + (lm-1)*npack1
     >                          + (ia-1)*npack1*norbs_max))
      end do

      return
      end

*     ***********************************
*     *					*
*     *	 	   aorbs_weight		*
*     *					*
*     ***********************************
      real*8 function aorbs_weight(n)
      implicit none
      integer n          ! basis number

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

*     **** local variables ****
      integer ia
      real*8 zv,zcount

*     **** external functions ****
      real*8   psp_zv
      external psp_zv

      ia     = int_mb(iaaorb(1)+n-1)
      zcount = int_mb(lmmax(1)+ia-1)
      zv     = psp_zv(ia)

      aorbs_weight = (zv/zcount)
      return
      end

*     ***********************************
*     *					*
*     *	 	   aorbs_aorb  		*
*     *					*
*     ***********************************

      subroutine aorbs_aorb(n,aorb)
      implicit none
#include "errquit.fh"
      integer n          ! basis number
      complex*16 aorb(*) ! return orbital

#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

*     **** local variables ****
      logical value
      integer lm,ia,ii
      integer nfft3d,npack1
      integer exi(2)

*     **** external functions ****
      logical  is_sORd
      external is_sORd


      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)

      value = MA_push_get(mt_dcpl,nfft3d,'exi', exi(2), exi(1))
      if (.not. value) call errquit('aorbs_aorb:out of heap memory',0,
     &       MA_ERR)

*     **** structure factor ****
      lm = int_mb(lmaorb(1)+n-1)
      ia = int_mb(iaaorb(1)+n-1)
      ii = int_mb(iiaorb(1)+n-1)
      call strfac(ii,dcpl_mb(exi(1)))
      call Pack_c_pack(1,dcpl_mb(exi(1)))

*     **** phase factor does not matter therefore ****
*     **** (-i)^l is the same as (i)^l in the     ****
*     **** Rayleigh scattering formula            ****

*     *** current function is s or d ****
      if (is_sORd(lm,int_mb(lmax(1)+ia-1),
     >                   int_mb(locp(1)+ia-1))
     >        ) then
         call Pack_tc_Mul(1,dbl_mb(aorbs(1) 
     >                          + (lm-1)*npack1
     >                          + (ia-1)*npack1*norbs_max),
     >                   dcpl_mb(exi(1)),
     >                   aorb)

*     *** current function is p or f ****
      else
         call Pack_itc_Mul(1,dbl_mb(aorbs(1)
     >                           +(lm-1)*npack1
     >                           +(ia-1)*npack1*norbs_max),
     >                   dcpl_mb(exi(1)),
     >                   aorb)
      end if


      value = MA_pop_stack(exi(2))
      if (.not. value) call errquit('aorbs_aorb:freeing heap memory',0,
     &       MA_ERR)

      return 
      end


*     ***********************************
*     *					*
*     *	 	   aorbs_read 		*
*     *					*
*     ***********************************
      subroutine aorbs_read(fname,
     >                      version,
     >                       nfft,unita,
     >						 atom,
     >                       lmmax,lmax,locp,rcut,lmbda,
     >                       npack1,aorbs,
     >                       tmp,tmp2,
     >                       ierr)
      implicit none 
      character*50 fname
      integer version
      integer nfft(3)
      real*8  unita(3,3)
      character*2 atom
      integer lmmax,lmax,locp
      real*8 rcut,lmbda
      integer npack1
      real*8 aorbs(npack1,*)
      complex*16 tmp(*)
      real*8     tmp2(*)
      integer ierr

#ifdef TCGMSG
#include "tcgmsg.fh"
#include "msgtypesf.h"
#endif

*    *** local variables ***
      logical pio
      integer MASTER,taskid,taskid_i,taskid_p,com_p
      parameter(MASTER=0)
      integer n,l
      integer msglen
      integer iatom(2)
      character*255 full_filename

      logical  control_parallel_io
      external control_parallel_io


      call Parallel_taskid(taskid)
      call Parallel2d_taskid_i(taskid_i)

      pio = control_parallel_io()
      if (pio) then
         taskid_p = taskid_i
         com_p = 1
      else
         taskid_p = taskid
         com_p = 0
      end if

*     **** open fname binary file ****
      if (taskid_p.eq.MASTER) then
         call util_file_name_noprefix(fname,.false.,
     >                             .false.,
     >                       full_filename)
         l = index(full_filename,' ') - 1
         call openfile(5,full_filename,l,'r',l)
         call iread(5,version,1)
         call iread(5,nfft,3)
         call dread(5,unita,9)
         call cread(5,atom,2)
         call iread(5,lmax,1)
         call iread(5,locp,1)
         call dread(5,rcut,1)
         call dread(5,lmbda,1)
         lmmax=(lmax+1)**2 - (2*locp+1)
      end if

*     **** send header data to all processors ****
      msglen = 1
      call Parallela_Brdcst_ivalues(com_p,MASTER,msglen,version)
      msglen = 3
      call Parallela_Brdcst_ivalues(com_p,MASTER,msglen,nfft)
      msglen = 9
      call Parallela_Brdcst_values(com_p,MASTER,msglen,unita)

      iatom(1) = ichar(atom(1:1))
      iatom(2) = ichar(atom(2:2))
      msglen = 2
      call Parallela_Brdcst_ivalues(com_p,MASTER,msglen,iatom)
      atom(1:1) = char(iatom(1))
      atom(2:2) = char(iatom(2))

      msglen = 1
      call Parallela_Brdcst_ivalues(com_p,MASTER,msglen,lmax)
      call Parallela_Brdcst_ivalues(com_p,MASTER,msglen,locp)
      call Parallela_Brdcst_values(com_p,MASTER,msglen,rcut)
      call Parallela_Brdcst_values(com_p,MASTER,msglen,lmbda)
      lmmax=(lmax+1)**2 - (2*locp+1)


*     **** read in aorb 3d blocks ****
      do n=1,lmmax
         if (pio) then
            call D3dB_t_read_pio(1,5,tmp2,tmp,-1)
         else
            call D3dB_t_read(1,5,tmp2,tmp,-1)
         end if
         call Pack_t_pack(1,tmp2)
         call Pack_t_Copy(1,tmp2,aorbs(1,n))
      end do


*     *** close fname binary file ***
      if (taskid_p.eq.MASTER) then
c       close(11)
         call closefile(5)
      end if

      ierr = 0
      return
      end

*     ***********************************
*     *					*
*     *	 	  aorbs_readall		*
*     *					*
*     ***********************************

      logical function aorbs_readall()
      implicit none
      
#include "mafdecls.fh"

***** AORBS common block ****
#include "aorbs.fh"

*     **** local variables ****
      integer ngp(3),version,nfft3d,npack1
      integer ia,l,lm,ii,icount
      real*8 unita(3,3)
      integer tmp(2),tmp2(2),ierr
      logical value,found,correct_box,value2
      character*2  atom
      character*4  element
      character*50 fname

*     **** parallel i/o variable ****
      integer MASTER,taskid
      parameter(MASTER=0)

*     **** external functions ****
      logical      nwpw_filefind
      integer      control_ngrid
      real*8       control_unita
      character*12 control_boundry
      character*4  ion_atom_qm
      external     nwpw_filefind
      external     control_ngrid
      external     control_unita
      external     control_boundry
      external     ion_atom_qm
      integer      ion_nion_qm,ion_katm_qm
      external     ion_nion_qm,ion_katm_qm
      

      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)
      call Parallel_taskid(taskid)

      value = MA_push_get(mt_dbl,(2*nfft3d),'tmp',tmp(2),tmp(1))
      if (.not. value) go to 9000

      value = MA_push_get(mt_dbl,(nfft3d),'tmp2',tmp2(2),tmp2(1))
      if (.not. value) go to 9000

*     **** read pseudopotentials ****
      do ia=1,nkatmx

*      **** define formatted aorb name ****
       element = '    '
       element = ion_atom_qm(ia)
       l = index(element,' ') - 1
       fname = element(1:l)//'.aorb'
        

       found = .false.
       do while (.not.found)

         if (nwpw_filefind(fname)) then
            call aorbs_read(fname,
     >                  version,
     >                  ngp,unita,
     >                  atom,
     >                  int_mb(lmmax(1)+ia-1),
     >                  int_mb(lmax(1)+ia-1),
     >                  int_mb(locp(1)+ia-1),
     >                  dbl_mb(rcut(1)+ia-1),
     >                  dbl_mb(lmbda(1)+ia-1),
     >                  npack1,
     >                  dbl_mb(aorbs(1)+ (ia-1)*npack1*norbs_max),
     >                  dbl_mb(tmp(1)),dbl_mb(tmp2(1)),
     >                  ierr)

           if (ierr.gt.0) then
              value = .false.
              go to 9000
           end if

*          **************************************************************
*          ***** logic for finding out if psp is correctly formatted ****
*          **************************************************************
           correct_box = .true.
           if ( (ngp(1).ne.control_ngrid(1)) .or.
     >       (ngp(2).ne.control_ngrid(2)) .or.
     >       (ngp(3).ne.control_ngrid(3)) .or. 
     >       (unita(1,1).ne.control_unita(1,1)) .or.
     >       (unita(2,1).ne.control_unita(2,1)) .or.
     >       (unita(3,1).ne.control_unita(3,1)) .or.
     >       (unita(1,2).ne.control_unita(1,2)) .or.
     >       (unita(2,2).ne.control_unita(2,2)) .or.
     >       (unita(3,2).ne.control_unita(3,2)) .or.
     >       (unita(1,3).ne.control_unita(1,3)) .or.
     >       (unita(2,3).ne.control_unita(2,3)) .or.
     >       (unita(3,3).ne.control_unita(3,3))) then
              correct_box = .false.
              if (taskid.eq.MASTER) then
              write(6,*) "atomic orbitals are not correctly formatted:",
     >                    fname
              end if
           end if
           if (correct_box) found = .true.

         end if

*        **** generate formatted pseudopotential atom.aorb *****
         if (.not.found) then
             call aorbs_formatter_auto(ion_atom_qm(ia),0.0d0,0.0d0)
         end if

       end do !***do while ****


      end do

*     ***********************************************
*     **** set up the index for the atomic basis ****
*     ***********************************************
      icount = 0
      do ii=1,ion_nion_qm()
         ia = ion_katm_qm(ii)

         do lm=1,int_mb(lmmax(1)+ia-1)
            icount = icount + 1

            int_mb(lmaorb(1)+icount-1)  = lm
            int_mb(iaaorb(1)+icount-1)  = ia
            int_mb(iiaorb(1)+icount-1)  = ii
            int_mb(basisaorb(1)+lm-1+(ii-1)*norbs_max) = icount
         end do
      end do
      ibasis = icount
      call aorbs_normalize()

 9000 value2 = MA_pop_stack(tmp2(2))
      value2 = MA_pop_stack(tmp(2))
      

      aorbs_readall = value
      return
      end

      subroutine ubesplg(rtdb,npd,lmax,nper,nint,alpha,
     &     xr,wwl,derl,csc,csl)
c
c     bessel fuction spline code with new prescription for
c     the outgoing wave continuum function.
c
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
      integer rtdb
      integer nbig, lbig, nsmall,nsmall2,nchmx,nemx,np,npd
      parameter (nbig=15000,lbig=6,nsmall=4015)
      parameter (nchmx=20,nemx=100)
      parameter (nsmall2=2*nsmall)
      integer ipow(0:lbig)
      double precision echan(nchmx),energy(nemx)
      double precision xstart,ystart,ypstart,al,mu,h,xmax,
     &     e,eta,ak,rd,r,w,cs,rd26
      integer l
      common /integ/ xstart,ystart,ypstart,al,mu,h,xmax
      common /energy/ e,eta,ak
      common/spl/rd,r(nsmall),w(nsmall,0:lbig),cs(nsmall),rd26,l
      complex*16 csc(nsmall,0:lbig),scc(nsmall)
      double precision aj(0:(lbig+1)),ay(0:(lbig+1))
      double precision aj1(0:(lbig+1)),ay1(0:(lbig+1))
      double precision csl(nsmall,0:lbig),derl(nsmall,0:lbig)
      complex*16 x1,x2,f1,f2,f,fp,gp,sig(0:lbig),tv
      complex*16 yc1,yc2,zl
c      double precision css(nsmall)
      complex*16 c1,c2,ai,ww(nsmall),wwl(nsmall,0:lbig)
      double precision xr(*)
      double precision zero
      integer gg
      external zero,gg
      double precision der(nsmall),xx(nbig),yy(nbig),zz(nbig),
     &     scr(nsmall),wwlr(nsmall2,0:lbig),cscr(nsmall2,0:lbig)
c      equivalence (wwl(1,0),wwlr(1,0)),(csc(1,0),cscr(1,0))
c
      integer i,lmax,nper,nint,nl,ncomp,j,index,i1,i2,np2,k
      double precision znuc,alpha,aint,x,yp1,yp2,det,c2r
c
      ai=cmplx(0.,1.)
c
c..unicos
c      call link ("unit5=infreeg,unit6=(outfree,hc,create)
c..unicos     1,unit8=bessplr//")
c
c      open(5,file='infree')
c      open(6,file='outfree')
c      open(8,file='bessplr',form='unformatted')
c
      ipow(0)=0
      do 66 i=1,lbig
         ipow(i)=1
 66   continue
c     call keep80(4hwave)
c     call frid(10hxerox+film,1,4,1)
c     call dders(-1)
      eta=0.
      znuc=0.
      mu=1.
c
c lmax=max. l value desired
c nper=no. of points per unit a.u. for splined functions
c xstart = first r-point (.00001 is o.k.)
c xmax = last r-point(r=k*x!)
c nint = multiple of nper for integration(3 or 4 is reasonable)
c alpha = exponential parameter in test function
c
c      read(5,*)lmax,nper,xstart,xmax,nint,alpha
      if(.not.rtdb_get(rtdb,'cckohn:lmax',mt_int,1,lmax))
     &     call errquit("can not get lmax from rtdb", 100, RTDB_ERR)
      if(.not.rtdb_get(rtdb,'cckohn:nper',mt_int,1,nper))
     &     call errquit("can not get nper from rtdb", 100, RTDB_ERR)
      if(.not.rtdb_get(rtdb,'cckohn:xstart',mt_dbl,1,xstart))
     &     call errquit("can not get xstart from rtdb", 100, RTDB_ERR)
      if(.not.rtdb_get(rtdb,'cckohn:xmax',mt_dbl,1,xmax))
     &     call errquit("can not get xmax from rtdb", 100, RTDB_ERR)
      if(.not.rtdb_get(rtdb,'cckohn:nint',mt_int,1,nint))
     &     call errquit("can not get nint from rtdb", 100, RTDB_ERR)
      if(.not.rtdb_get(rtdb,'cckohn:alpha',mt_dbl,1,alpha))
     &     call errquit("can not get alpha from rtdb", 100, RTDB_ERR)
      write(6,*)' Greens Function Code '
      write(6,101)lmax,nper,xstart,xmax,nint,alpha
 101  format(/,' L-Max  = ',i5,/,
     2     ' Nper   = ',i5,/,
     3     ' XStart = ',f20.12,/,
     4     ' XMax   = ',f20.12,/,
     5     ' Nint   = ',i5,/,
     6     ' Alpha  = ',f20.12)
      np=nper*xmax+1
      if(np.gt.nsmall.or.npd.ne.nsmall)then
         write(6,100)
 100     format(" np.gt.nsmall")
         stop
      endif
      rd=(xmax-xstart)/(np-1)
      rd26=rd*rd/6.
      do i=1,np
         r(i)=rd*(i-1.)+xstart
      enddo
      aint=nint
      h=rd/aint
      nl=lmax+1
      do 667 i=1,np
         x=r(i)
         call sjymec(x,aj,ay,ncomp,lmax)
         do 668 j=0,lmax
            w(i,j)=exp(-x*alpha)*aj(j)*x
 668     continue
 667  continue
      do 33 l=0,lmax
         al=l
         ystart=xstart**(l+1)
         ypstart=(al+1.)*xstart**l
         yp1=(w(2,l)-w(1,l))/rd
         yp2=(w(np,l)-w(np-1,l))/rd
         call cckohn_spline(r,w(1,l),np,yp1,yp2,scr,cs)
         call outward(xx,yy,index,zero)
         call outward(xx,zz,index,gg)
         i1=index
         i2=index-1./h
         x1=xx(i1)
         x2=xx(i2)
         det=yy(i1)*zz(i2)-yy(i2)*zz(i1)
c         write(*,*)"l,x1,x2,xx(i1),xx(i2),yy(i1),yy(i2),zz(i1),
c     &        zz(i2),det",
c     &        l,x1,x2,xx(i1),xx(i2),yy(i1),yy(i2),zz(i1),zz(i2),det   
c      write(*,*)"l,i1,i2,x1,x2,det",l,i1,i2,x1,x2,det
         call sjymec(x1,aj,ay,ncomp,l)
         call sjymec(x2,aj1,ay1,ncomp,l)
         f1=x1*(-ay(l)+ai*aj(l))
         f2=x2*(-ay1(l)+ai*aj1(l))
c      write(*,*)"l,x1,x2,ay(l),ai,aj(l),ay1(l),aj1(l)",f1,f2,
c     &     l,x1,x2,ay(l),ai,aj(l),ay1(l),aj1(l),f1,f2
         c1=f1*zz(i2)-f2*zz(i1)
         c1=c1/det
         c2=f2*yy(i1)-f1*yy(i2)
         c2=c2/det
         j=0
         do 3 i=1,index,nint
            j=j+1
            ww(j)=c1*yy(i)+c2*zz(i)
c            if(l.eq.1.and.j.eq.2)then
c               write(*,*)ww(j),c1,c2,xx(i),yy(i),zz(i)
c            endif
            ww(j)=ww(j)/xx(i)
c            if(l.eq.1.and.j.eq.2)then
c               write(*,*)ww(j),c1,c2,xx(i),yy(i),zz(i)
c            endif
            wwl(j,l)=ww(j)
c            if(l.eq.1.and.j.eq.2)then
c               write(*,*)ww(j),c1,c2,xx(i),yy(i),zz(i)
c            endif
 3       continue
         yc1=(ww(2)-ww(1))/rd
         yc2=(ww(np)-ww(np-1))/rd
         call splinec(r,ww,np,yc1,yc2,scc,csc(1,l))
         c2r=c2
         do 5 i=1,np
            der(i)=w(i,l)*c2r
            der(i)=der(i)/r(i)**ipow(l)
            derl(i,l)=der(i)
 5       continue
         yp1=(der(2)-der(1))/rd
         yp2=(der(np)-der(np-1))/rd
         call cckohn_spline(r,der,np,yp1,yp2,scr,csl(1,l))
 33   continue
      call dcopy(np,r,1,xr,1)
c      write(*,*)"r"
c      write(*,"(6f12.5)")(r(i),i=1,np)
c      write(*,*)"xr"
c      write(*,"(6f12.5)")(xr(i),i=1,np)
c      write(*,*)"wwl"
c      write(*,"(6f12.5)")((wwl(i,k),i=1,np),k=0,lmax)
c      write(*,*)"derl"
c      write(*,"(6f12.5)")((derl(i,k),i=1,np),k=0,lmax)
c      write(*,*)"csc"
c      write(*,"(6f12.5)")((csc(i,k),i=1,np),k=0,lmax)
c      write(*,*)"csl"
c      write(*,"(6f12.5)")((csl(i,k),i=1,np),k=0,lmax)
c      write(8)lmax,np,xstart,rd,alpha
c      write(8)(r(i),i=1,np)
c      np2=2*np
c      write(8)((wwlr(i,k),i=1,np2),k=0,lmax)
c      write(8)((derl(i,k),i=1,np),k=0,lmax)
c      write(8)((cscr(i,k),i=1,np2),k=0,lmax)
c      write(8)((csl(i,k),i=1,np),k=0,lmax)
      write(6,*)' BessplG Finished '
      return
      end
c $Id: ubesplg.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE stpr_matout(A,NR,NC,M)
c $Id: stpr_matout.f 19708 2010-10-29 18:04:21Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
C
C     Rectangular array output.
C     input:
C       A    Array to be written to for006.
C       NR   The row order of A.
C       NC   The column order of A.
C       M    The row dimension of A in the calling routine.
C
      DIMENSION A(M,NC)
      CHARACTER*15 LINE(5)
      DATA LINE /5*' _____________ '/
      MAXCOL=0
      NSETS=(NC-1)/5+1
      DO 100 NS=1,NSETS
        MINCOL=MAXCOL
        IF (NS.EQ.NSETS) THEN
          NUMCOL=NC-MINCOL
        ELSE
          NUMCOL=5
        END IF
        MAXCOL=MINCOL+NUMCOL
        MINCOL=MINCOL+1
        WRITE (6,1000) (I,I=MINCOL,MAXCOL)
        WRITE (6,1010) (LINE(I),I=1,NUMCOL)
        DO 90 I=1,NR
          WRITE (6,1020) I,(A(I,J),J=MINCOL,MAXCOL)
   90   CONTINUE
  100 CONTINUE
      WRITE (6,1030)
 1000 FORMAT (/,5X,5(6X,I3,6X))
 1010 FORMAT (5X,5A15)
 1020 FORMAT (1X,I3,1X,5(E14.7,1X))
 1030 FORMAT (/)
      RETURN
      END

      subroutine sym_group_name(geom, name)
C$Id: sym_grp_name.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "geomP.fh"
      integer geom              ! [input]
      character*(*) name        ! [output]
c
c     return the name of the group
c
      integer i
      logical geom_check_handle
      external geom_check_handle
c
      if (.not. geom_check_handle(geom,'sym_group_name'))
     $     call errquit('sym_group_name: bad geom handle',geom,
     &       GEOM_ERR)
c
c     strip annonying leading blanks
c
      do i = 1, len(group_name(geom))
         if (group_name(geom)(i:i).ne.' ') goto 10
      enddo
      call errquit('sym_group_name: all blank?', 0, INPUT_ERR)
c
 10   name = group_name(geom)(i:)
c
      end

      subroutine uccsdt_triples_amplitudes(d_amp, spina, spinc)
      implicit none
#include "errquit.fh"
#include "cuccsdtP.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "amplitudes.fh"
      integer ind, list,
     &     max_lenia, symkc, lenkc, l_t2, k_t2, symia, 
     &     a, alo, ahi, syma, asub, asublo, asubhi, asubdim, spina,
     &     b, blo, bhi, symb, bsub, bsublo, bsubhi, bsubdim, spinb,
     &     c, clo, chi, symc, csub, csublo, csubhi, csubdim, spinc, 
     &     e, elo, ehi, syme, esub, esublo, esubhi, esubdim, spine, 
     &     i, ilo, ihi, symi, isub, isublo, isubhi, isubdim, spini, 
     &     j, jlo, jhi, symj, jsub, jsublo, jsubhi, jsubdim, spinj, 
     &     k, klo, khi, symk, ksub, ksublo, ksubhi, ksubdim, spink, 
     &     m, mlo, mhi, symm, msub, msublo, msubhi, msubdim, spinm, 
     $     nproc, me, ei, cik, ma, kbc, mb, ia, ek, aki, l, lenia,
     $     symib, symie, symke, symmc, lenke, kc, max_lenke, 
     $     ptr, d_amp, g_t2, kac, offset, actual_lenkc, actual_lenia,
     $     mc, ica, actual_lenib, ib, bki, icb,
     $     max_lenje, symje, lenje, symmb, aji, ej, iab, bji

      double precision buf(1000)
c     
c     Offset maps a 4-d array into a 1-d array.  It is used to look up
c     ptr(ind,i,j,k,l) where ptr is dimensioned ptr(2,dim1,dim2,dim3,dim4) 
c     with dim1-4 = listinfo(6-9,list)
c     
      offset(ind,i,j,k,l,list) = 
     $     ind-1 + 
     $     2*(i-1 + 
     $     listinfo(6,list)*(j-1 + 
     $     listinfo(7,list)*(k-1 + 
     $     listinfo(8,list)*(l-1))))
c     
c     t(ia,kc)
c     
      spink = spinc
      spini = spina
      spinb = spina
      spine = spina
c     
c     get local memory of size max "lenkc"
c     
      max_lenia = 0
      do symia = 0,7
        lenia = ov_len(symia,spini,spina)
        if (lenia.gt.max_lenia)max_lenia = lenia
      enddo
      if(.not.ma_push_get(mt_dbl,max_lenia,'t2',l_t2,k_t2))
     $     call errquit('t2s: t2?',max_lenia, MA_ERR)
c     
      me = ga_nodeid()
      nproc = ga_nnodes()
c     
c     loop over symkc
c     
      alo = asuper(1)
      ahi = asuper(2)
      blo = bsuper(1)
      bhi = bsuper(2)
      clo = csuper(1)
      chi = csuper(2)
      ilo = nc(spini) + 1
      ihi = nc(spini) + no(spini)
      do symkc = 0,7
        symia = symkc
        symib = symkc
        symie = symkc
        lenia = ov_len(symia,spini,spina)
        actual_lenkc = ov_off(chi+1,symkc,spink,spinc) - 
     $       ov_off(clo,symkc,spink,spinc)
        if(actual_lenkc.gt.0.and.lenia.gt.0) then
          if (.not.uccsdt_ampfile_read_t2(d_amp, 
     $         spini, spina, spink, spinc, symkc, clo, chi, 
     $         g_t2, .true., 'column'))
     $         call errquit('amp_read_t2: reading t2 failed', d_amp,
     &       DISK_ERR)
          kc = 1
          do c = clo, chi
            csub = cblock_inv(c)
            csublo = cblock(1,csub)
            csubdim = cblock(2,csub) - cblock(1,csub) + 1
            symc = cblock(3,csub)
            symk = ieor(symkc,symc)
            do k = o_sym(1,symk,spink), o_sym(2,symk,spink)
              IF (MOD(KC,NPROC).eq.ME) THEN
                ksub = oblock_inv(k,spink)
                ksublo = oblock(1,ksub,spink)
                ksubdim = oblock(2,ksub,spink) - 
     $               oblock(1,ksub,spink) + 1
                call ga_get(g_t2,1,lenia,kc,kc,dbl_mb(k_t2),1)
c               if (.not.ma_verify_allocator_stuff())
c               $               call errquit(' after ga ',0)
c               
c               14.  t(e,c,i,k) spin(e)=spin(a) mixed = t(a,c,i,k)
c               
                do i = ilo, ihi
                  isub = oblock_inv(i,spini)
                  isublo = oblock(1,isub,spini)
                  isubdim = oblock(2,isub,spini) - 
     $                 oblock(1,isub,spini) + 1
                  symi = oblock(3,isub,spini)
                  syme = ieor(symie,symi)
                  esublo = v_sym(1,syme,spine)
                  esubhi = v_sym(2,syme,spine)
                  esubdim = esubhi - esublo + 1
                  if (esubdim.gt.0)then
                    cik = (c-csublo + csubdim*(i-isublo + 
     $                   isubdim*(k-ksublo)))
                    list = 14
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,csub,isub,ksub,list))
                    ptr = ptr + esubdim*cik
                    ei = k_t2 + ov_off(esublo,symie,spini,spine) + 
     $                   i - o_sym(1,symi,spini)
                    call dfill(1000, 0.0d0, buf, 1)
                    do e = 1, esubdim
                      buf(e) = dbl_mb(ei+(e-1)*no_sym(symi,spini))
                    enddo
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+esubdim-1,1,1,buf,1)
                  endif
                enddo
c               
c               20.  t(m,k,a,c) spin(m)=spin(a) mixed = t(i,a,k,c)  m=i
c               
                do a = alo, ahi
                  asub = ablock_inv(a)
                  asublo = ablock(1,asub)
                  asubdim = ablock(2,asub) - ablock(1,asub) + 1
                  syma = ablock(3,asub)
                  symm = ieor(symia,syma)
                  spinm = spini
                  msublo = o_sym(1,symm,spinm)
                  msubhi = o_sym(2,symm,spinm)
                  msubdim = msubhi - msublo + 1
                  if (msubdim.gt.0)then
                    kac = (k-ksublo + ksubdim*(a-asublo + 
     $                   asubdim*(c-csublo)))
                    list = 20
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,ksub,asub,csub,list))
                    ptr = ptr + msubdim*kac
                    ma = k_t2 + ov_off(a,symia,spini,spina)
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+msubdim-1,1,1,dbl_mb(ma),1)
                  endif
                enddo
c               
c               21.  t(m,k,b,c) spin(m)=spin(b) mixed = t(i,a,k,c)  m=i
c               
                do b = blo, bhi
                  bsub = bblock_inv(b)
                  bsublo = bblock(1,bsub)
                  bsubdim = bblock(2,bsub) - bblock(1,bsub) + 1
                  symb = bblock(3,bsub)
                  symm = ieor(symib,symb)
                  spinm = spini
                  msublo = o_sym(1,symm,spinm)
                  msubhi = o_sym(2,symm,spinm)
                  msubdim = msubhi - msublo + 1
                  if (msubdim.gt.0)then
                    kbc = (k-ksublo + ksubdim*(b-bsublo + 
     $                   bsubdim*(c-csublo)))
                    list = 21
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,ksub,bsub,csub,list))
                    ptr = ptr + msubdim*kbc
                    mb = k_t2 + ov_off(b,symib,spini,spinb)
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+msubdim-1,1,1,dbl_mb(mb),1)
                  endif
                enddo
              ENDIF             ! end parallel work
              kc = kc + 1
            enddo
          enddo
          if (.not. ga_destroy(g_t2))
     $         call errquit('t2s: ga_destroy?',1, GA_ERR)
        endif
      enddo
      if (.not. ma_pop_stack(l_t2))
     $     call errquit('t2s: ma_pop_stack?',1, MA_ERR)
c     
c     get local memory of size max "lenkc"
c     
      spine = spink
      max_lenke = 0
      do symke = 0,7
        lenke = ov_len(symke,spink,spine)
        if (lenke.gt.max_lenke)max_lenke = lenke
      enddo
      if(.not.ma_push_get(mt_dbl,max_lenke,'t2',l_t2,k_t2))
     $     call errquit('t2s: t2?',max_lenke, MA_ERR)
c     
      klo = nc(spink) + 1
      khi = nc(spink) + no(spink)
      do symia = 0,7
        symke = symia
        symmc = symia
        lenke = ov_len(symke,spink,spine)
        actual_lenia = ov_off(ahi+1,symia,spini,spina) - 
     $       ov_off(alo,symia,spini,spina)
        if(actual_lenia.gt.0.and.lenke.gt.0) then
          if (.not.uccsdt_ampfile_read_t2(d_amp, 
     $         spink, spine, spini, spina, symia, alo, ahi, 
     $         g_t2, .true., 'column'))
     $         call errquit('amp_read_t2: reading t2 failed', d_amp,
     &       DISK_ERR)
          ia = 1
          do a = alo, ahi
            asub = ablock_inv(a)
            asublo = ablock(1,asub)
            asubdim = ablock(2,asub) - ablock(1,asub) + 1
            syma = ablock(3,asub)
            symi = ieor(symia,syma)
            do i = o_sym(1,symi,spini), o_sym(2,symi,spini)
              IF (MOD(IA,NPROC).eq.ME) THEN
                isub = oblock_inv(i,spini)
                isublo = oblock(1,isub,spini)
                isubdim = oblock(2,isub,spini) - 
     $               oblock(1,isub,spini) + 1
                call ga_get(g_t2,1,lenke,ia,ia,dbl_mb(k_t2),1)
c               if (.not.ma_verify_allocator_stuff())
c               $               call errquit(' after ga ',0)
c               
c               17.  t(e,a,k,i) spin(e)=spin(k) mixed = t(k,e,i,a)
c               
                do k = klo, khi
                  ksub = oblock_inv(k,spink)
                  ksublo = oblock(1,ksub,spink)
                  ksubdim = oblock(2,ksub,spink) - 
     $                 oblock(1,ksub,spink) + 1
                  symk = oblock(3,ksub,spink)
                  syme = ieor(symke,symk)
                  esublo = v_sym(1,syme,spine)
                  esubhi = v_sym(2,syme,spine)
                  esubdim = esubhi - esublo + 1
                  if (esubdim.gt.0)then
                    aki = (a-asublo + asubdim*(k-ksublo + 
     $                   ksubdim*(i-isublo)))
                    list = 17
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,asub,ksub,isub,list))
                    ptr = ptr + esubdim*aki
                    ek = k_t2 + ov_off(esublo,symke,spink,spine) + 
     $                   k - o_sym(1,symk,spink)
                    call dfill(1000, 0.0d0, buf, 1)
                    do e = 1, esubdim
                      buf(e) = dbl_mb(ek+(e-1)*no_sym(symk,spink))
                    enddo
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+esubdim-1,1,1,buf,1)
                  endif
                enddo
c               
c               22.  t(m,i,c,a) spin(m)=spin(c) mixed = t(m,c,i,a)
c               
                do c = clo, chi
                  csub = cblock_inv(c)
                  csublo = cblock(1,csub)
                  csubdim = cblock(2,csub) - cblock(1,csub) + 1
                  symc = cblock(3,csub)
                  symm = ieor(symmc,symc)
                  spinm = spinc
                  msublo = o_sym(1,symm,spinm)
                  msubhi = o_sym(2,symm,spinm)
                  msubdim = msubhi - msublo + 1
                  if (msubdim.gt.0)then
                    ica = (i-isublo + isubdim*(c-csublo + 
     $                   csubdim*(a-asublo)))
                    list = 22
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,isub,csub,asub,list))
                    ptr = ptr + msubdim*ica
                    mc = k_t2 + ov_off(c,symmc,spinm,spinc)
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+msubdim-1,1,1,dbl_mb(mc),1)
                  endif
                enddo
              ENDIF             ! end parallel work
              ia = ia + 1
            enddo
          enddo
          if (.not. ga_destroy(g_t2))
     $         call errquit('t2s: ga_destroy?',1, GA_ERR)
        endif
      enddo
c
      do symib = 0,7
        symke = symib
        symmc = symib
        lenke = ov_len(symke,spink,spine)
        actual_lenib = ov_off(bhi+1,symib,spini,spinb) - 
     $       ov_off(blo,symib,spini,spinb)
        if(actual_lenib.gt.0.and.lenke.gt.0) then
          if (.not.uccsdt_ampfile_read_t2(d_amp, 
     $         spink, spine, spini, spinb, symib, blo, bhi, 
     $         g_t2, .true., 'column'))
     $         call errquit('amp_read_t2: reading t2 failed', d_amp,
     &       DISK_ERR)
          ib = 1
          do b = blo, bhi
            bsub = bblock_inv(b)
            bsublo = bblock(1,bsub)
            bsubdim = bblock(2,bsub) - bblock(1,bsub) + 1
            symb = bblock(3,bsub)
            symi = ieor(symib,symb)
            do i = o_sym(1,symi,spini), o_sym(2,symi,spini)
              IF (MOD(IB,NPROC).eq.ME) THEN
                isub = oblock_inv(i,spini)
                isublo = oblock(1,isub,spini)
                isubdim = oblock(2,isub,spini) - 
     $               oblock(1,isub,spini) + 1
                call ga_get(g_t2,1,lenke,ib,ib,dbl_mb(k_t2),1)
c               if (.not.ma_verify_allocator_stuff())
c               $               call errquit(' after ga ',0)
c               
c               18.  t(e,b,k,i) spin(e)=spin(k) mixed = t(k,e,i,b)
c               
                do k = klo, khi
                  ksub = oblock_inv(k,spink)
                  ksublo = oblock(1,ksub,spink)
                  ksubdim = oblock(2,ksub,spink) - 
     $                 oblock(1,ksub,spink) + 1
                  symk = oblock(3,ksub,spink)
                  syme = ieor(symke,symk)
                  esublo = v_sym(1,syme,spine)
                  esubhi = v_sym(2,syme,spine)
                  esubdim = esubhi - esublo + 1
                  if (esubdim.gt.0)then
                    bki = (b-bsublo + bsubdim*(k-ksublo + 
     $                   ksubdim*(i-isublo)))
                    list = 18
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,bsub,ksub,isub,list))
                    ptr = ptr + esubdim*bki
                    ek = k_t2 + ov_off(esublo,symke,spink,spine) + 
     $                   k - o_sym(1,symk,spink)
                    call dfill(1000, 0.0d0, buf, 1)
                    do e = 1, esubdim
                      buf(e) = dbl_mb(ek+(e-1)*no_sym(symk,spink))
                    enddo
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+esubdim-1,1,1,buf,1)
                  endif
                enddo
c               
c               23.  t(m,i,c,b) spin(m)=spin(c) mixed = t(m,c,i,b)
c               
                do c = clo, chi
                  csub = cblock_inv(c)
                  csublo = cblock(1,csub)
                  csubdim = cblock(2,csub) - cblock(1,csub) + 1
                  symc = cblock(3,csub)
                  symm = ieor(symmc,symc)
                  spinm = spinc
                  msublo = o_sym(1,symm,spinm)
                  msubhi = o_sym(2,symm,spinm)
                  msubdim = msubhi - msublo + 1
                  if (msubdim.gt.0)then
                    icb = (i-isublo + isubdim*(c-csublo + 
     $                   csubdim*(b-bsublo)))
                    list = 23
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,isub,csub,bsub,list))
                    ptr = ptr + msubdim*icb
                    mc = k_t2 + ov_off(c,symmc,spinm,spinc)
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+msubdim-1,1,1,dbl_mb(mc),1)
                  endif
                enddo
              ENDIF             ! end parallel work
              ib = ib + 1
            enddo
          enddo
          if (.not. ga_destroy(g_t2))
     $         call errquit('t2s: ga_destroy?',1, GA_ERR)
        endif
      enddo

      if (.not. ma_pop_stack(l_t2))
     $     call errquit('t2s: ma_pop_stack?',1, MA_ERR)

c     
c     get local memory of size max "lenkc"
c     
      spinj = spini
      spine = spinj
      max_lenje = 0
      do symje = 0,7
        lenje = ov_len(symje,spinj,spine)
        if (lenje.gt.max_lenje)max_lenje = lenje
      enddo
      if(.not.ma_push_get(mt_dbl,max_lenje,'t2',l_t2,k_t2))
     $     call errquit('t2s: t2?',max_lenje, MA_ERR)
c     
      jlo = nc(spinj) + 1
      jhi = nc(spinj) + no(spinj)
      do symia = 0,7
        symje = symia
        symmb = symia
        lenje = ov_len(symje,spinj,spine)
        actual_lenia = ov_off(ahi+1,symia,spini,spina) - 
     $       ov_off(alo,symia,spini,spina)
        if(actual_lenia.gt.0.and.lenje.gt.0) then
          if (.not.uccsdt_ampfile_read_t2(d_amp, 
     $         spinj, spine, spini, spina, symia, alo, ahi, 
     $         g_t2, .true., 'column'))
     $         call errquit('amp_read_t2: reading t2 failed', d_amp,
     &       DISK_ERR)
          ia = 1
          do a = alo, ahi
            asub = ablock_inv(a)
            asublo = ablock(1,asub)
            asubdim = ablock(2,asub) - ablock(1,asub) + 1
            syma = ablock(3,asub)
            symi = ieor(symia,syma)
            do i = o_sym(1,symi,spini), o_sym(2,symi,spini)
              IF (MOD(IA,NPROC).eq.ME) THEN
                isub = oblock_inv(i,spini)
                isublo = oblock(1,isub,spini)
                isubdim = oblock(2,isub,spini) - 
     $               oblock(1,isub,spini) + 1
                call ga_get(g_t2,1,lenje,ia,ia,dbl_mb(k_t2),1)
c               if (.not.ma_verify_allocator_stuff())
c               $               call errquit(' after ga ',0)
c               
c               15.  t(e,a,j,i) spin(e)=spin(j) pure = t(j,e,i,a)
c               
                do j = jlo, jhi
                  jsub = oblock_inv(j,spinj)
                  jsublo = oblock(1,jsub,spinj)
                  jsubdim = oblock(2,jsub,spinj) - 
     $                 oblock(1,jsub,spinj) + 1
                  symj = oblock(3,jsub,spinj)
                  syme = ieor(symje,symj)
                  esublo = v_sym(1,syme,spine)
                  esubhi = v_sym(2,syme,spine)
                  esubdim = esubhi - esublo + 1
                  if (esubdim.gt.0)then
                    aji = (a-asublo + asubdim*(j-jsublo + 
     $                   jsubdim*(i-isublo)))
                    list = 15
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,asub,jsub,isub,list))
                    ptr = ptr + esubdim*aji
                    ej = k_t2 + ov_off(esublo,symje,spinj,spine) + 
     $                   j - o_sym(1,symj,spinj)
                    call dfill(1000, 0.0d0, buf, 1)
                    do e = 1, esubdim
                      buf(e) = dbl_mb(ej+(e-1)*no_sym(symj,spinj))
                    enddo
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+esubdim-1,1,1,buf,1)
                  endif
                enddo
c               
c               19.  t(m,i,a,b) pure spin = -t(m,b,i,a)
c               
                do b = blo, bhi
                  bsub = bblock_inv(b)
                  bsublo = bblock(1,bsub)
                  bsubdim = bblock(2,bsub) - bblock(1,bsub) + 1
                  symb = bblock(3,bsub)
                  symm = ieor(symmb,symb)
                  spinm = spinb
                  msublo = o_sym(1,symm,spinm)
                  msubhi = o_sym(2,symm,spinm)
                  msubdim = msubhi - msublo + 1
                  if (msubdim.gt.0)then
                    iab = (i-isublo + isubdim*(a-asublo + 
     $                   asubdim*(b-bsublo)))
                    list = 19
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,isub,asub,bsub,list))
                    ptr = ptr + msubdim*iab
                    mb = k_t2 + ov_off(b,symmb,spinm,spinb)
                    call dscal(msubdim,-1.0d0,dbl_mb(mb),1)
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+msubdim-1,1,1,dbl_mb(mb),1)
                    call dscal(msubdim,-1.0d0,dbl_mb(mb),1)
                  endif
                enddo
              ENDIF             ! end parallel work
              ia = ia + 1
            enddo
          enddo
          if (.not. ga_destroy(g_t2))
     $         call errquit('t2s: ga_destroy?',1, GA_ERR)
        endif
      enddo
      do symib = 0,7
        symje = symib
        symmb = symib
        lenje = ov_len(symje,spinj,spine)
        actual_lenib = ov_off(bhi+1,symib,spini,spinb) - 
     $       ov_off(blo,symib,spini,spinb)
        if(actual_lenib.gt.0.and.lenje.gt.0) then
          if (.not.uccsdt_ampfile_read_t2(d_amp, 
     $         spinj, spine, spini, spinb, symib, blo, bhi, 
     $         g_t2, .true., 'column'))
     $         call errquit('amp_read_t2: reading t2 failed', d_amp,
     &       DISK_ERR)
          ib = 1
          do b = blo, bhi
            bsub = bblock_inv(b)
            bsublo = bblock(1,bsub)
            bsubdim = bblock(2,bsub) - bblock(1,bsub) + 1
            symb = bblock(3,bsub)
            symi = ieor(symib,symb)
            do i = o_sym(1,symi,spini), o_sym(2,symi,spini)
              IF (MOD(IB,NPROC).eq.ME) THEN
                isub = oblock_inv(i,spini)
                isublo = oblock(1,isub,spini)
                isubdim = oblock(2,isub,spini) - 
     $               oblock(1,isub,spini) + 1
                call ga_get(g_t2,1,lenje,ib,ib,dbl_mb(k_t2),1)
c               if (.not.ma_verify_allocator_stuff())
c               $               call errquit(' after ga ',0)
c               
c               16.  t(e,b,j,i) spin(e)=spin(j) pure = t(j,e,i,b)
c               
                do j = jlo, jhi
                  jsub = oblock_inv(j,spinj)
                  jsublo = oblock(1,jsub,spinj)
                  jsubdim = oblock(2,jsub,spinj) - 
     $                 oblock(1,jsub,spinj) + 1
                  symj = oblock(3,jsub,spinj)
                  syme = ieor(symje,symj)
                  esublo = v_sym(1,syme,spine)
                  esubhi = v_sym(2,syme,spine)
                  esubdim = esubhi - esublo + 1
                  if (esubdim.gt.0)then
                    bji = (b-bsublo + bsubdim*(j-jsublo + 
     $                   jsubdim*(i-isublo)))
                    list = 16
                    ptr = int_mb(listinfo(2,list) +
     $                   offset(1,1,bsub,jsub,isub,list))
                    ptr = ptr + esubdim*bji
                    ej = k_t2 + ov_off(esublo,symje,spinj,spine) + 
     $                   j - o_sym(1,symj,spinj)
                    call dfill(1000, 0.0d0, buf, 1)
                    do e = 1, esubdim
                      buf(e) = dbl_mb(ej+(e-1)*no_sym(symj,spinj))
                    enddo
                    call ga_put(listinfo(5,list),ptr,
     $                   ptr+esubdim-1,1,1,buf,1)
                  endif
                enddo
              ENDIF             ! end parallel work
              ib = ib + 1
            enddo
          enddo
          if (.not. ga_destroy(g_t2))
     $         call errquit('t2s: ga_destroy?',1, GA_ERR)
        endif
      enddo
      if (.not. ma_pop_stack(l_t2))
     $     call errquit('t2s: ma_pop_stack?',1, MA_ERR)
c
      end

c $Id: draftt2s.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine hnd_spdgia(ng,nr,g,xyz)
c
c $Id: hnd_spdgia.F 19696 2010-10-29 16:53:42Z d3y133 $
c
      implicit none
#include "nwc_const.fh"
#include "hnd_tol.fh"
#include "hnd_giao.fh"
#include "hnd_pointers.fh"
c
c     Input parameters
c
      integer ng,nr
      double precision g(ngint,6),xyz(ng*nr,3,3,*)
c
c     Local variables
c
      integer nn,nx,ny,nz,igr,Nxyz(3)
      double precision dum1,dum2,dum3,dum4,dum5,dum6,dum7,fij,fkl
      integer llkjt,llkt,ni,nj,nk,nl,i,j,k,l,m
      integer ix,iy,iz,jx,jy,jz,kx,ky,kz,lx,ly,lz
c
c     ----- sum up ( ix * iy * iz ) -----
c
      llkt   = lmt*(lkt+1)
      llkjt  = llkt*ljt
      nk=numl             
      nj=nk*numk
      ni=nj*numj
      ijkl=0
      do 240 i=1,numi
        call getNxyz(lit-1,i,Nxyz)
        ix = Nxyz(1)
        iy = Nxyz(2)
        iz = Nxyz(3)
        do 230 j=1,numj
          call getNxyz(ljt-1,j,Nxyz)
          jx = Nxyz(1)
          jy = Nxyz(2)
          jz = Nxyz(3)
          do 220 k=1,numk
            call getNxyz(lkt-1,k,Nxyz)
            kx = Nxyz(1)
            ky = Nxyz(2)
            kz = Nxyz(3)
            do 210 l=1,numl
              call getNxyz(lmt-1,l,Nxyz)
              lx = Nxyz(1)
              ly = Nxyz(2)
              lz = Nxyz(3)
              ijkl=ijkl+1
              nn=1 + ni*(i-1) + nj*(j-1) + nk*(k-1) + (l-1)
              nx=1 + ix*llkjt + jx*llkt  + kx*lmt   + lx
              ny=1 + iy*llkjt + jy*llkt  + ky*lmt   + ly
              nz=1 + iz*llkjt + jz*llkt  + kz*lmt   + lz
              dum1=0.0d0
              dum2=0.0d0
              dum3=0.0d0
              dum4=0.0d0
              dum5=0.0d0
              dum6=0.0d0
              dum7=0.0d0
              do igr=1,ng*nr
               dum1=dum1+xyz(igr,1,1,nx)*xyz(igr,2,1,ny)*xyz(igr,3,1,nz)
               dum2=dum2+xyz(igr,1,2,nx)*xyz(igr,2,1,ny)*xyz(igr,3,1,nz)
               dum3=dum3+xyz(igr,1,1,nx)*xyz(igr,2,2,ny)*xyz(igr,3,1,nz)
               dum4=dum4+xyz(igr,1,1,nx)*xyz(igr,2,1,ny)*xyz(igr,3,2,nz)
               dum5=dum5+xyz(igr,1,3,nx)*xyz(igr,2,1,ny)*xyz(igr,3,1,nz)
               dum6=dum6+xyz(igr,1,1,nx)*xyz(igr,2,3,ny)*xyz(igr,3,1,nz)
               dum7=dum7+xyz(igr,1,1,nx)*xyz(igr,2,1,ny)*xyz(igr,3,3,nz)
              enddo     
              g(nn,1)=g(nn,1)+(qijx*dum1+tijy*dum4-tijz*dum3)
              g(nn,2)=g(nn,2)+(qijy*dum1+tijz*dum2-tijx*dum4)
              g(nn,3)=g(nn,3)+(qijz*dum1+tijx*dum3-tijy*dum2)
              g(nn,4)=g(nn,4)+(qklx*dum1+tkly*dum7-tklz*dum6)
              g(nn,5)=g(nn,5)+(qkly*dum1+tklz*dum5-tklx*dum7)
              g(nn,6)=g(nn,6)+(qklz*dum1+tklx*dum6-tkly*dum5)
  210       continue
  220     continue
  230   continue
  240 continue
      return
      end

      subroutine util_transpose(a,lda,b,ldb,m,n)
*
* $Id: util_transpose.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
c
      integer lda, ldb, m, n
      double precision a(lda,n), b(ldb,m)
c
c     Transpose a(m,n) to b(n,m)
c
c     The arrays CANNOT be the same.  Use util_inplace_transpose
c     instead.
c
      integer i, j
c$$$      integer b, ilo, jlo, ihi, jhi
c$$$      parameter (b=16)
c
      do j = 1, n
         do i = 1, m
            b(j,i) = a(i,j)
         enddo
      enddo
c$$$c
c$$$c     Untested blocking code
c$$$c
c$$$      do jlo = 1, n, b
c$$$         jhi = min(jlo+b-1,n)
c$$$         do ilo = 1, m, b
c$$$            ihi = min(ihi+b-1,m)
c$$$            do j = jlo, jhi
c$$$               do i = ilo, ihi
c$$$                  b(j,i) = a(i,j)
c$$$               enddo
c$$$            enddo
c$$$         enddo
c$$$      enddo
c
      end
      subroutine util_inplace_transpose(n, a)
      implicit none
c
      integer n
      double precision a(n,n)
c
      double precision aij, aji
c
      integer i, j
      do i = 1, n
         do j = 1, i-1
            aij = a(i,j)
            aji = a(j,i)
            a(i,j) = aji
            a(j,i) = aij
         enddo
      enddo
c
      end
      subroutine util_2_transpose(rows,cols,mat,ldmat,tmat,ldtmat)
      implicit none
#include "errquit.fh"
*
*
*  This routine forms the matrix transpose of mat.  The input 
*  matrix (mat) is a rows by cols matrix (stored in a ldmat 
*  by cols matrix in the calling routine).  The resultant matrix
*  (tmat) is a cols by rows matrix (stored in a ldtmat by rows 
*  matrix in the calling routine).  Matrices mat and tmat can
*  be the same storage but the routine must be called appropriately
*  (i.e., ldmat = ldtmat). 
*
*::passed:pointers
      integer rows   ! [input] number of rows in mat (columns in tmat)
      integer cols   ! [input] number of columns in mat (rows in tmat)
      integer ldmat  ! [input] leading dimension of mat
      integer ldtmat ! [input] leading dimension of tmat
      double precision   mat (ldmat ,cols) ! [input] matrix to be transposed
      double precision   tmat(ldtmat,rows) ! [output] transposed matrix
*::local:variables
* 
      integer r        ! loop index
      integer c        ! loop index
      integer square   ! square block size of non-square matrix
      double precision local_temp ! temporary variable for transpose
*
*:: do the square part of the matrix
      square = min(rows,cols)
      do r = 1,square
        do c = 1,r
          local_temp     = mat(c,r)
          tmat(c,r) = mat(r,c)
          tmat(r,c) = local_temp
        enddo
      enddo
      if      (rows.eq.cols) return ! square matrix return
*
      if      (rows.lt.cols) then   ! simple copy of non-square block
*
* e.g., 
*--------------------------------------
*   ***x    ***
*   ***y -> ***
*   ***z    ***
*           xyz
*--------------------------------------
*
        do r = (rows+1),cols
          do c = 1,rows
            tmat(r,c) = mat(c,r)
          enddo
        enddo
      else if (rows.gt.cols) then   ! simple copy of non-square block
*
* e.g., 
*--------------------------------------
*   ***    ***x
*   *** -> ***y
*   ***    ***z
*   xyz        
*--------------------------------------
*
        do r = 1,cols
          do c = (cols+1),rows
            tmat(r,c) = mat(c,r)
          enddo
        enddo
      else
        call errquit('util_transpose: square block did not return',911,
     &       UNKNOWN_ERR)
      endif
      end

      logical function argos_prepare_wrtpov(lfnout,lfnpov,filpov,iopt,
     + box,
     + num,amass,mat,
     + csa,isat,isgm,xs,vs,msa,nsa,cwa,iwat,xw,vw,mwm,mwa,nwm,nwa,
     + xwc,vwc,mwmc,nwmc,slvnam,nxrep,nyrep,nzrep,drep,msb,nsb,idsb,
     + rdist,scale,cpk)
c
c $Id: argos_prepare_wrtpov.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
#include "mafdecls.fh"
c
      character*2 argos_prepare_atnam
      real*8 atom_radius
      integer argos_prepare_atnum
      character*255 atom_color
      external argos_prepare_atnam,atom_radius,argos_prepare_atnum,
     + atom_color
c
      integer lfnout,lfnpov,iopt,msa,nsa,mwm,nwm,mwa,nwa,mat,mwmc,nwmc
      character*255 filpov
      integer num(mat),isat(msa),isgm(msa),iwat(mwa)
      character*16 cwa(mwa),csa(msa)
      character*3 slvnam
      real*8 amass(mat),xs(3,msa),vs(3,msa),xw(3,mwa,mwm),vw(3,mwa,mwm)
      real*8 xwc(3,mwa,mwmc),vwc(3,mwa,mwmc),box(3)
      integer nxrep,nyrep,nzrep
      real*8 rdist,drep(3),xh(3)
      integer msb,nsb
      integer idsb(2,msb)
      real*8 scale,cpk
c
      integer length,ib,jb
      character*255 color
c
      integer i,j,k
c
      real*8 xbmax,xbmin,ybmax,ybmin,zbmax,zbmin
c
      xbmax=xs(1,1)+0.2d0
      xbmin=xs(1,1)-0.2d0
      ybmax=xs(2,1)+0.2d0
      ybmin=xs(2,1)-0.2d0
      zbmax=xs(3,1)+0.2d0
      zbmin=xs(3,1)-0.2d0
      do 1 i=2,nsa
      xbmax=max(xbmax,xs(1,i))
      xbmin=min(xbmin,xs(1,i))
      ybmax=max(ybmax,xs(2,i))
      ybmin=min(ybmin,xs(2,i))
      zbmax=max(zbmax,xs(3,i))
      zbmin=min(zbmin,xs(3,i))
    1 continue
      if(scale.le.0.0d0) then
      scale=2.0d0/max(xbmax-xbmin,ybmax-ybmin,zbmax-zbmin)
      xbmax=scale*xbmax
      xbmin=scale*xbmin
      ybmax=scale*ybmax
      ybmin=scale*ybmin
      zbmax=scale*zbmax
      zbmin=scale*zbmin
      endif
      call povinc(lfnpov,xbmin,xbmax,ybmin,ybmax,zbmin,zbmax)
c
c     open POV file
c
      length=index(filpov,' ')-1
      open(unit=lfnpov,file=filpov(1:length),form='formatted',
     + status='unknown',err=9999)
      write(lfnpov,8000)
 8000 format('#include "camera.inc"',/,'#include "colors.inc"',/,
     + '#include "plane.inc"')
c
      do 2 i=1,nsa
      k=argos_prepare_atnum(csa(i)(11:12))
      color=atom_color(k)
      if(k.gt.0) then
      write(lfnpov,8003) isgm(i),csa(i)
 8003 format('// ',i5,':',a16)
      if(cpk.gt.0.0d0) then
      write(lfnpov,8001) (scale*xs(j,i),j=1,3),scale*cpk*atom_radius(k),
     + color(1:index(color,' ')-1)
      else
      write(lfnpov,8001) (scale*xs(j,i),j=1,3),
     + scale*abs(cpk)*atom_radius(1),
     + color(1:index(color,' ')-1)
      endif
 8001 format('sphere {',/,'  <',f12.6,',',f12.6,',',f12.6,'>,',/,
     + 3x,f12.6,/,
     + '  texture { pigment { ',a,' }',/,
     + '            finish  { ambient 0.16 ',/,
     + '                      diffuse 0.48 ',/,
     + '                      phong 1.25 ',/,
     + '                      phong_size 200 } }',/,'}')
      endif
    2 continue
      if(cpk.le.0.0d0) then
      do 3 i=1,nsb
      ib=idsb(1,i)
      jb=idsb(2,i)
      xh(1)=0.5d0*(xs(1,ib)+xs(1,jb))
      xh(2)=0.5d0*(xs(2,ib)+xs(2,jb))
      xh(3)=0.5d0*(xs(3,ib)+xs(3,jb))
      k=argos_prepare_atnum(csa(ib)(11:12))
      color=atom_color(k)
      write(lfnpov,8002) (scale*xs(j,ib),j=1,3),
     + (scale*xh(j),j=1,3),scale*abs(cpk)*atom_radius(1),
     + color(1:index(color,' ')-1)
 8002 format('cylinder {',/,'  <',f12.6,',',f12.6,',',f12.6,'>,',/,
     + '  <',f12.6,',',f12.6,',',f12.6,'>,',/,
     + 3x,f12.6,/,'  open',/,'  texture { pigment { ',a,' } }',/,'}')
      k=argos_prepare_atnum(csa(jb)(11:12))
      color=atom_color(k)
      write(lfnpov,8002) (scale*xs(j,jb),j=1,3),
     + (scale*xh(j),j=1,3),scale*abs(cpk)*atom_radius(1),
     + color(1:index(color,' ')-1)
    3 continue
      endif
      close(unit=lfnpov)
c
      if(util_print('files',print_default)) then
      write(lfnout,2000) filpov(1:length)
 2000 format(' Created pov',t40,a,/)
      endif
c
      argos_prepare_wrtpov=.true.
      return
c
 9999 continue
      argos_prepare_wrtpov=.false.
      return
      end

      program testnat
* $Id: testnat.f 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
      integer iat, jat, kat, lat, nat
      integer ibk, jbk, kbk, lbk
      integer iathi, iatlo
      integer jathi, jatlo
      integer kathi, katlo
      integer lathi, latlo
      integer ijunk, icount
c
      integer i,j,k,l
      integer isym2,isym4
      ISYM2(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      ISYM4(I,J,K,L)=MAX(ISYM2(I,J),ISYM2(K,L))*
     &    (MAX(ISYM2(I,J),ISYM2(K,L))-1)/2+
     &    MIN(ISYM2(I,J),ISYM2(K,L))
c
      nat = 4
      iat = 0
      jat = 0
      kat = 0
      lat = 0
c
      icount = 0
      do kat = nat, 1, -1
        do iat = nat, kat, -1
          do jat = iat, 1, -1
            lathi = kat
            if (iat.eq.kat) lathi = jat
            do lat = 1,lathi
              icount = icount + 1
              ijunk = isym4(iat,jat,kat,lat)
              write(81,10000)ijunk,iat,jat,kat,lat
*              write(6,10000)ijunk,iat,jat,kat,lat
*              write(81,10000)kat,iat
            enddo
          enddo
        enddo
      enddo
      write(6,*)' original', icount
      write(6,*)' '
c
      ibk = 2
      jbk = 2
      kbk = 2
      lbk = 5
      iat = 0
      jat = 0
      kat = 0
      lat = 0
c
      icount = 0
      do kathi = nat, 1, -kbk
        katlo = max(1,kathi-kbk+1)
        do iathi = nat, 1, -ibk
          iatlo = max(1,iathi-ibk+1)
          do jathi = nat, 1, -jbk
            jatlo = max(1,jathi-jbk+1)
            do iat = iathi, iatlo, -1
              do jat = jathi,jatlo,-1
                do kat = kathi,katlo,-1
                  if (iat.ge.jat) then
                    if (iat.ge.kat) then
                      lathi = kat
                      if (iat.eq.kat) lathi = jat
                      do lat = 1,lathi
                        ijunk = isym4(iat,jat,kat,lat)
                        write(91,10000)ijunk,iat,jat,kat,lat
*                    write(91,10000)kat,iat
*                        write(6,10000)ijunk,iat,jat,kat,lat
                        icount = icount + 1
                      enddo
                    endif
                  endif
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      write(6,*)' blocked ', icount
c
      call exit
10000 format(i7, i5, i5, i5, i5)
      end

      
      

      subroutine smd_tasklist_init()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_tasklist_data.fh"
      character*30 pname, theory
      integer i
      integer istart,iend
      integer t(1000)
      logical result
      character*72 tag
c
      pname = "smd_tasklist_init"      
c
      tag = "smd:theory"
      call smd_rtdb_get_string(tag,1,theory,result)
      if(.not.result)
     > call errquit(
     >       pname//'no '//tag,0, RTDB_ERR)
c
      tag = "smd:fragment_istart"
      call smd_rtdb_get_int(tag,1,istart,result)
      if(.not.result)
     > call errquit(
     >       pname//'no '//tag,0, RTDB_ERR)
c
      tag = "smd:fragment_iend"
      call smd_rtdb_get_int(tag,1,iend,result)
      if(.not.result)
     > call errquit(
     >       pname//'no '//tag,0, RTDB_ERR)
c
c
      smd_ntask = iend-istart+1
c
      call smd_rtdb_get_log("smd:steal",1,osteal,result)
      if(.not.result) osteal = .false.

      if(.not.nga_create(MT_INT, 1, smd_ntask, 
     >    'smd_ga_task_params',0, smd_ga_task_params)) 
     >  call errquit(
     >       pname//'nga_create error ',0, RTDB_ERR)
c
      if(.not.nga_create(MT_INT, 1, smd_ntask, 
     >    'smd_ga_task_status',0, smd_ga_task_status)) 
     >  call errquit(
     >       pname//'nga_create error ',0, RTDB_ERR)
c
c      if(.not.nga_create(MT_INT, 1, smd_ntask, 
c     >    'smd_ga_group_pool',0, smd_ga_group_pool)) 
c     >  call errquit(
c     >       pname//'nga_create error ',0, RTDB_ERR)


      do i=1,smd_ntask 
        t(i) = istart+i-1
      end do

      call nga_put(smd_ga_task_params,1,smd_ntask,t,1)
      call ga_print(smd_ga_task_params)

      do i=1,smd_ntask
       t(i) = t_avail
      end do

      call nga_put(smd_ga_task_status,1,smd_ntask,t,1)
      do i=1,smd_ntask
       t(i) = t_busy
      end do

c      call nga_put(smd_ga_group_pool,1,smd_ntask,t,1)
c      call ga_print(smd_ga_task_status)
c      call ga_print(smd_ga_task_status)
 
      return
      end

      function smd_tasklist_get1(i)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_tasklist_data.fh"
#include "smd_group_data.fh"
#include "msgids.fh"
      character*30 pname 
      integer t
      integer i,ig,j,ng,it
      integer t_p(1000)
      integer t_s(1000)
      logical smd_tasklist_get1
      logical result
c
      pname = "smd_tasklist_get1"      
c
      ig = smd_group_id
      ng = smd_ngroup
      if(ga_nodeid().ne.0) goto 20
c      write(70+ig,*) "getting task"
c      write(*,*) "ig,ng,ntask",ig,ng,smd_ntask
      call nga_get(smd_ga_task_status,1, smd_ntask,t_s,1)

c      write(70+ig,*) "task array"
      do i=1,smd_ntask 
      write(70+ig,*) i,t_s(i).eq.t_avail
      end do
 
      smd_tasklist_get1 =.false.
c      write(70+ig,*) "looking for unfinished task"
c     honestly look for unfinished task
      do i=ig,smd_ntask,ng
        if(t_s(i).eq.t_avail) then
          result = .true.
          goto 10
        end if
      end do
c
10    continue
      if(result) then
        call nga_put(smd_ga_task_status,i,i,t_busy,1)
c        write(70+ig,*) "found task",i
c        call util_flush(70+ig)
      end if

20    continue
      call ga_brdcst(msg_smd,result,
     >     ma_sizeof(mt_log,1,mt_byte),0)
      call ga_brdcst(msg_smd,i,
     >     ma_sizeof(mt_int,1,mt_byte),0)

      smd_tasklist_get1 =result
      return
      end


      function smd_tasklist_get(i)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_tasklist_data.fh"
#include "smd_group_data.fh"
      character*30 pname 
      integer t
      integer i,ig,j,ng,it
      integer t_p(1000)
      integer t_s(1000)
      logical smd_tasklist_get
c
      pname = "smd_tasklist_get"      
c
      ig = smd_group_id
      ng = smd_ngroup
      write(70+ig,*) "getting task"
      write(*,*) "ig,ng,ntask",ig,ng,smd_ntask
c      call nga_put(smd_ga_group_pool,ig,ig,t_avail,1)
      call nga_get(smd_ga_task_status,1, smd_ntask,t_s,1)
      call ga_sync()

      write(70+ig,*) "task array"
      do i=1,smd_ntask 
      write(70+ig,*) i,t_s(i).eq.t_avail
      end do
 
      smd_tasklist_get =.false.
      write(70+ig,*) "looking for unfinished task"
c     honestly look for unfinished task
      do i=ig,smd_ntask,ng
        if(t_s(i).eq.t_avail) goto 100
      end do
c
      return
c      if(.not.osteal) return
c     start stealing work from left cpus
c      call nga_get(smd_ga_task_status,1, smd_ntask,t_s,1)
      call ga_sync()
      do j=1,ig-1
       it = 0
       do i=j,smd_ntask,ng
        if(t_s(i).eq.t_avail) then
         it = it + 1
         if(it.eq.2) goto 100
        end if
       end do
      end do
c     start stealing work from right cpus
c      call nga_get(smd_ga_task_status,1, smd_ntask,t_s,1)
      call ga_sync()
      do j=ig+1,ng
       it = 0
       do i=j,smd_ntask,ng
        if(t_s(i).eq.t_avail) then
         it = it + 1
         if(it.eq.2) goto 100
        end if
       end do
      end do
      return
100   continue
      write(70+ig,*) "found task",i
c      call nga_put(smd_ga_group_pool,ig,ig,t_busy,1)
      call nga_put(smd_ga_task_status,i,i,t_busy,1)
      call ga_sync()
      smd_tasklist_get =.true.
      call util_flush(70+ig)
      return
      end

      subroutine smd_tasklist_set()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_tasklist_data.fh"
#include "smd_group_data.fh"
      character*30 pname 
      integer t
      integer i,ig,j,ng,it
      integer t_p(1000)
      integer t_s(1000)
      integer p_world,p_default
c
      pname = "smd_tasklist_set"      
c
      p_world   = ga_pgroup_get_world()
      p_default = ga_pgroup_get_default()
      call ga_pgroup_sync(p_world)
c
      call ga_pgroup_set_default(p_world)
c
      if(ga_nodeid().eq.0) then
      do i=1,smd_ntask
        t_s(i)=t_avail
      end do
      call nga_put(smd_ga_task_status,1, smd_ntask,t_s,1)
      end if

      call ga_sync()
      call ga_pgroup_set_default(p_default)

      return
      end
c $Id: smd_tasklist.F 21176 2011-10-10 06:35:49Z d3y133 $

c     $Id: cgsd_oep_eigenvalues.F 22944 2012-09-30 20:27:13Z bylaska $                       

*     ********************************
*     *		  	  	     *
*     *	     cgsd_oep_eigenvalues    *
*     *				     *
*     ********************************

      subroutine cgsd_oep_eigenvalues()
      implicit none

#include "stdio.fh"


c#include "global.fh"
c#include "mafdecls.fh"
c#include "rtdb.fh"

      logical newpsi
      integer MASTER
      parameter (MASTER=0)

      logical stalled,value
      integer taskid
      integer minimizer
      integer i,j,ms,neall,NN
      integer nexcited(2)
      integer it_in,it_out,icount,bfgscount
      real*8  EV,virial
      real*8  tole,tolc,deltae,deltac,deltae_old
      real*8  cx,cy,cz
      real*8  gx,gy,gz
      real*8  en(2)
      real*8  E(30)
      integer rtdb

*     **** external functions ****
      logical     epsi_initialize,epsi_finalize,epsi_filefind
      logical     control_oep
      integer     psi_ne_excited,control_excited_ne,psi_ne
      real*8      psi_virtual,psi_eigenvalue
      external    epsi_initialize,epsi_finalize,epsi_filefind
      external    control_oep
      external    psi_ne_excited,control_excited_ne,psi_ne
      external    psi_virtual,psi_eigenvalue
      


      call Parallel_taskid(taskid)

      if (control_oep()) then

      if (taskid.eq.MASTER) write(*,1301)

      value = epsi_initialize() !*** load in virtual orbitals ***

      call psi_gen_density_potentials(1) !**** generate oep ****
      call psi_1add_oep_to_vall()

      call psi_1to2() !** store psi1 orbitals temporarilly in psi2 ***
      call psi_2gen_hml()
      call psi_diagonalize_hml_assending()
      call psi_2rotate1()


      !*** minimize orbitals ****
      call psi_minimize_f_orb()
      call psi_minimize_virtual()


      if (taskid.eq.MASTER) then

        !**** write out KS virtual eigenvalues ****
        write(*,1500)
        NN=psi_ne_excited(1)-psi_ne_excited(2)
        EV=27.2116d0
        do I=psi_ne_excited(1),(psi_ne_excited(2)+1),-1
          write(*,1510) psi_virtual(1,I),
     >                  psi_virtual(1,I)*EV
        end do

        do I=psi_ne_excited(2),1,-1
          write(*,1510)  psi_virtual(1,I),
     >                   psi_virtual(1,I)*EV,
     >                   psi_virtual(2,I),
     >                   psi_virtual(2,I)*EV
        end do

        !**** write out KS filled eigenvalues ****
        write(*,1501)
        NN=psi_ne(1)-psi_ne(2)
        EV=27.2116
        do I=psi_ne(1),(psi_ne(2)+1),-1
          write(*,1510) psi_eigenvalue(1,I),
     >                  psi_eigenvalue(1,I)*EV
        end do

        do I=psi_ne(2),1,-1
          write(*,1510)  psi_eigenvalue(1,I),
     >                   psi_eigenvalue(1,I)*EV,
     >                   psi_eigenvalue(2,I),
     >                   psi_eigenvalue(2,I)*EV
        end do


        write(*,*)
        write(*,*)


      end if

*     **** do not write out excited wavefunctions ***
      value = epsi_finalize(.false.)

      call psi_2to1() !**** store put psi2 back to psi1 ****

      end if

      return
 1301 FORMAT(//'== Perturbative OEP Orbital Calculation =='/)
 1500 FORMAT(/' virtual orbital energies:')
 1501 FORMAT(/' orbital energies:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
      end

      subroutine smd_exlist_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_exlist,sp_atom
      character*32 tag,pname
      logical result

      pname = "smd_exlist_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "excl_list"
      call smd_system_get_component(sp_exlist,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_exlist_init(sp_exlist,result)
c
      if(.not.result) then
       tag = "excl_list"
       call smd_system_unset_component(tag)
      end if

      return
      end

      subroutine smd_exlist_init(sp_exlist,result)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_exlist
      logical result
c
      character*32 pname
      character*80 tag
      integer np,nl
      integer i_p,i_l,i_ir
      integer h_l
      integer i_list
      integer i
c
      pname = "smd_exlist_init"
c
c      write(*,*) "in "//pname
c
c     get total number of atoms
c     -------------------------
      call smd_atom_ntot(np)
c
c     gestimate the size of pair list
c     ------------------------------
      nl =  min( np*200, ma_inquire_avail(MT_INT))
c
c     create pointer memory
c     ---------------------
      call smd_namespace_create(sp_exlist)
      tag = "exlist:pointer"
      call smd_data_create_get(sp_exlist,tag,np,MT_INT,i_p)

c
c    create temporary scratch array for list since
c    we do not know the size yet
c    ---------------------------------------------
      if(.not.ma_push_get(mt_int,nl,'tmp l',h_l,i_l))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nl, MA_ERR)

c
c     get atom residue index for exclusion criteria
c     ---------------------------------------------
      tag = "atom:resid"
      call smd_get_ind(tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)


      call smd_exlist_set(nl,
     +                    int_mb(i_l),
     +                    np,
     +                    int_mb(i_p),
     +                    int_mb(i_ir))

c
c     create list memory
c     nl now contains the actual size
c     -------------------------------

      if(nl.eq.0) then
        result = .false.
        call smd_namespace_destroy(sp_exlist)
        goto 200
      end if
c
      tag = "exlist:list"
      call smd_data_create_get(sp_exlist,tag,nl,MT_INT,i_list)


      do i=1,nl
       int_mb(i_list+i-1) = int_mb(i_l+i-1)
      end do 

      if(.not.ma_pop_stack(h_l))
     & call errquit(pname//'Failed to deallocate stack h_l',nl,
     &       MA_ERR)

200   continue
      return
      end
c
c
      subroutine smd_exlist_set(nl,list,natms,point,resid)
c
c     constructs excluded pairt list
c     point(i) is an index to list() array
c     that contains all the pairs of atom i
c     In other words all the atoms paired with atom i
c     are contained in list(point(i)),...,list(point(i+1)-1)
c     
      implicit none
#include "errquit.fh"
      integer nl,natms
      integer list(nl)
      integer point(natms)
      integer resid(natms)
c
      integer i,j
      integer nlist

      character*30 pname
 
      pname = "smd_exlist_set"

      nlist = 0
      do i=1,natms-1

       point(i)=nlist+1

       do j=i+1,natms

         if(resid(i).eq.resid(j))then

          nlist=nlist+1

          if(nlist.gt.nl)  
     +     call errquit(pname//'exceeded list dimensions',
     +     nl, 0)

          list(nlist)=j

         endif

       enddo
      enddo
c
c     we need to set this to mark
c     the end of pair list index for natms-1
c     it would be used as point(natms)-1
c     -------------------------------------
      point(natms)=nlist+1

      nl = nlist

      return

      END
c $Id: smd_exlist.F 22502 2012-05-20 06:11:57Z d3y133 $

c $Id: util_perf_test.F 21309 2011-10-27 16:46:04Z d3p852 $
c------------------------------------------------------------------------
c Program perf.x is used to test performance of GA put, get, accumulate  |
c It has to be executed on four processors.                              |
c remote operations access data on processes 1,2,3 in the round-robin way|
c------------------------------------------------------------------------
c
      subroutine util_perf_test
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      integer heap
c
c***  Intitialize a message passing library
c
#ifdef MPI
c     integer ierr
c     call mpi_init(ierr)
#else
c     call pbeginf
#endif
c
c***  Intitialize the GA package
c     call ga_initialize()
      if(ga_nnodes().ne.4) then
         if (ga_nodeid().eq.0) then
         write(6,*) '[This test requires 4 processors]'
         write(6,*) '[This test will be skipped]'
         call util_flush(6)
         endif
         return
      endif
c
c***  Initialize the MA package
      heap = 900000
c     if (.not. ma_init(MT_DBL, heap,heap)) 
c    $     call ga_error('ma init failed',2*heap) 
c
      call test2D()
      call test1D()
c     call ga_terminate()
c
#ifdef MPI
c     call mpi_finalize(ierr)
#else
c     call pend()
#endif
      end


      subroutine test1D()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
c     
c
      integer n, nn, num_chunks
      parameter (n = 1024*1024, nn = n/4, num_chunks=16)
      double precision buf(nn)
c
      integer g_a
      integer ilo, ihi, jlo, jhi
      integer nproc, me, loop
      integer chunk(num_chunks)
      data    chunk /1,9,16,81,256,576,900,2304,4096,8281,
     $               16384,29241,65536,124609,193600,262144/
c     
      nproc = ga_nnodes()
      me = ga_nodeid()
c
c***  Create global array
      if (.not. ga_create(MT_DBL, n, 1, 'a', 0, 0, g_a))
     $     call ga_error(' ga_create failed ',1)
c     
      do loop=1,nn
         buf(loop) = .01d0
      enddo
      call ga_zero(g_a) 
c
c      if (me .eq. 0) then
c        write(*,*)' '
c        write(*,*)' '
c        write(*,*)' '
c        write(*,55)n
c55      format(' Performance of GA get, put & acc',
c     $           ' for 1-dimensional sections of array[',i7,']')
c        print *,' '
c      endif
c
c     do loop=1,2
c
c***  local ops
c
      call ga_distribution(g_a, me, ilo, ihi, jlo, jhi)
      call TestPutGetAcc1
     &     (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo, jhi, .true.)
c
c***  remote ops
c
      call TestPutGetAcc1
     &     (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo, jhi,.false.)

c     enddo
      if (.not. ga_destroy(g_a))
     $     call ga_error(' ga_destroy failed ',1)
      end


      subroutine TestPutGetAcc1
     &      (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo,jhi, local)
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer num_chunks, chunk(num_chunks)
      integer n, ilo, ihi, jlo,jhi,g_a
      double precision buf(*), tg, tp, ta
      double precision time_acc1, time_get1, time_put1
      logical local
c
      integer me
      integer loop, jump, count, bytes
c
      me = ga_nodeid()
      if (me .eq. 0) then
        write(6,*)' '
        if(local) then
          write(6,'(26X, 25HLocal 1-D Array Section    )') 
        else
          write(6,'(26X, 25HRemote 1-D Array Section   )') 
        endif

        write(6,*)'    section           get               put',
     &           '           accumulate'
        write(6,*)' bytes    dim     sec      MB/s     sec      MB/s',
     &           '     sec      MB/s'
        call util_flush(6)
      endif
      call ga_sync()
c
      do loop = 1, num_chunks
        bytes = util_mdtob(1)*chunk(loop) ! how much data is accessed
        jump  =  n/(6000*loop) ! jump distance between consecutive patches
        if(loop.eq.num_chunks)jump=0
c
c       everybody touches own data 
        call ga_fill_patch(g_a, 1, n, 1, 1 , 1d0*me*loop)
        if (me .eq. 0) then
        tg=time_get1(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count,
     $               local)
        else
          call util_sleep(1)
        endif
c
c       everybody touches own data
        call ga_fill_patch(g_a, 1, n, 1, 1 , 1d0*me*loop)
        if (me .eq. 0) then
        tp=time_put1(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count, 
     $               local)
        else
          call util_sleep(1)
        endif
c
c       everybody touches own data
        call ga_fill_patch(g_a, 1, n, 1, 1 , 1d0*me*loop)
        if (me .eq. 0) then
        ta=time_acc1(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count,
     $               local)
        else
          call util_sleep(1)
        endif
c
        if (me .eq. 0) then
          write(6,77)bytes, chunk(loop), tg, 
     &          1d-6*bytes/tg,tp, 1d-6*bytes/tp, ta, 1d-6*bytes/ta
          call util_flush(6)
        endif
      enddo
c
77    format(i7, i7,1x, 3(1x,d8.3,1x,d8.3))
      end



      double precision function
     &   time_acc1(g_a, is, ie, js, je, buf, chunk, jump, count, local)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
      logical local 
      integer rows, indx, shifti(3)
c
      integer ilo, ihi, jlo, jhi
      double precision seconds, buf(*)
c
      count = 0
      rows = ie - is + 1
      shifti(1) = rows
      shifti(2) = 2*rows 
      shifti(3) = 3*rows
      jlo = js
      jhi = je

      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
           ihi = ilo + chunk -1
           count = count + 1
           if (local) then
                 call ga_acc(g_a, ilo, ihi, jlo, jhi, buf, chunk, 1d0)
           else
                 indx = Mod(count,3) + 1 
                 call ga_acc(g_a, ilo+shifti(indx), ihi+shifti(indx),
     $                       jlo, jhi,  buf, chunk, 1d0)
           endif
        enddo
      seconds = util_timer() - seconds
c
      time_acc1 = seconds/count
      end


      double precision function
     &    time_get1(g_a, is, ie, js, je, buf, chunk, jump, count, local)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
      integer rows, indx, shifti(3)
      logical local
c
      integer ilo, ihi, jlo, jhi
      double precision seconds, buf(*)
c
      count = 0
      rows = ie - is + 1
      shifti(1) = 3*rows
      shifti(2) = 2*rows
      shifti(3) = rows
      jlo = js
      jhi = je

      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
              ihi = ilo + chunk -1
              count = count + 1
              if (local) then
                 call ga_get(g_a, ilo, ihi, jlo, jhi, buf, chunk)
              else
                 indx = Mod(count,3) + 1
                 call ga_get(g_a, ilo+shifti(indx), ihi+shifti(indx),
     $                       jlo, jhi,  buf, chunk)
              endif
        enddo
      seconds = util_timer() - seconds
c
      time_get1 = seconds/count
      end



      double precision function
     &   time_put1(g_a, is, ie, js, je, buf, chunk, jump, count, local)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
      integer rows, indx, shifti(3), shiftj(3)
      logical local
c
      integer ilo, ihi, jlo, jhi
      double precision  seconds, buf(*)
c
      count = 0
      rows = ie - is + 1
      shifti(1) = rows
      shifti(2) = 2*rows
      shifti(3) = 3*rows
      jlo = js
      jhi = je

      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
              ihi = ilo + chunk -1
              count = count + 1
              if (local) then
                 call ga_put(g_a, ilo, ihi, jlo, jhi, buf, chunk)
              else
                 indx = Mod(count,3) + 1
                 call ga_put(g_a, ilo+shifti(indx), ihi+shifti(indx),
     $                       jlo, jhi,  buf, chunk)
              endif
        enddo
      seconds = util_timer() - seconds
c
      time_put1 = seconds/count
      end



c
c     test for square patches
c
      subroutine test2D()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
c
      integer n, nn, num_chunks
      parameter (n = 1024, nn = n*n/4, num_chunks=16)
      double precision buf(nn)
c
      integer g_a
      integer ilo, ihi, jlo, jhi
      integer nproc, me, loop
      integer chunk(num_chunks)
      data    chunk /1,3,4,9,16,24,30,48,64,91,128,171,256,353,440,512/
c     
      nproc = ga_nnodes()
      me = ga_nodeid()
c
c***  Create global array
      if (.not. ga_create(MT_DBL, n, n, 'a', 0, 0, g_a))
     $     call ga_error(' ga_create failed ',1)
c     
      do loop=1,nn
         buf(loop) = .01d0
      enddo
      call ga_zero(g_a) 
c
c      if (me .eq. 0) then
c        write(*,*)' '
c        write(*,55)n,n
c55      format(' Performance of GA get, put & acc',
c     $           ' for square sections of array[',i4,',',i4,']')
c        print *,' '
c      endif
c
c     do loop=1,2
c
c***  local ops
c
      call ga_distribution(g_a, me, ilo, ihi, jlo, jhi)
      call TestPutGetAcc
     &     (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo, jhi, .true.)
c
c***  remote ops
c
      call TestPutGetAcc
     &     (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo, jhi,.false.)

c     enddo
      if (.not. ga_destroy(g_a))
     $     call ga_error(' ga_destroy failed ',1)
      end


      subroutine TestPutGetAcc
     &      (g_a, n, chunk, num_chunks, buf, ilo, ihi, jlo,jhi, local)
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer num_chunks, chunk(num_chunks)
      integer n, ilo, ihi, jlo,jhi,g_a
      double precision buf(*), tg, tp, ta
      double precision time_acc, time_get, time_put
      logical local
c
      integer me
      integer loop, jump, count, bytes
c
      me = ga_nodeid()
      if (me .eq. 0) then
        if(local) then
          write(6,'(26X, 25HLocal 2-D Array Section    )') 
        else
          write(6,'(26X, 25HRemote 2-D Array Section   )') 
        endif

        write(6,*)'    section           get               put',
     &           '           accumulate'
        write(6,*)' bytes    dim     sec      MB/s     sec      MB/s',
     &           '     sec      MB/s'
        call util_flush(6)
      endif
      call ga_sync()
c
      do loop = 1, num_chunks
        bytes = util_mdtob(1)*chunk(loop)*chunk(loop) !how much data is accessed
        jump  =  n/(60*loop) ! jump distance between consecutive patches
        if(loop.eq.num_chunks)jump=0
c
c       everybody touches own data 
        call ga_fill_patch(g_a, 1, n, 1, n , 1d0*me*loop)
        if (me .eq. 0) then
        tg=time_get(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count,
     $               local)
        else
          call util_sleep(1)
        endif
c
c       everybody touches own data
        call ga_fill_patch(g_a, 1, n, 1, n , 1d0*me*loop)
        if (me .eq. 0) then
        tp=time_put(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count, 
     $               local)
        else
          call util_sleep(1)
        endif
c
c       everybody touches own data
        call ga_fill_patch(g_a, 1, n, 1, n , 1d0*me*loop)
        if (me .eq. 0) then
        ta=time_acc(g_a,ilo,ihi,jlo,jhi,buf,chunk(loop),jump,count,
     $               local)
        else
          call util_sleep(1)
        endif
c
        if (me .eq. 0) then
          write(6,77)bytes, chunk(loop), tg, 
     &          1d-6*bytes/tg,tp, 1d-6*bytes/tp, ta, 1d-6*bytes/ta
          call util_flush(6)
        endif
      enddo
c
77    format(i7, i7,1x, 3(1x,d8.3,1x,d8.3))
      end



      double precision function
     &   time_acc(g_a, is, ie, js, je, buf, chunk, jump, count, local)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
      logical local 
      integer rows, cols, indx, shifti(3), shiftj(3)
c
      integer ilo, ihi, jlo, jhi
      double precision  seconds, buf(*) 
c
      count = 0
      rows = ie - is + 1
      cols = je - js + 1
      shifti(1) = rows
      shifti(2) = 0
      shifti(3) = rows
      shiftj(1) = 0
      shiftj(2) = cols
      shiftj(3) = cols

      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
           ihi = ilo + chunk -1
           do jlo = js, je -chunk-jump +1, chunk+jump
              jhi = jlo + chunk -1
              count = count + 1
              if (local) then
                 call ga_acc(g_a, ilo, ihi, jlo, jhi, buf, chunk, 1d0)
              else
                 indx = Mod(count,3) + 1 
                 call ga_acc(g_a, ilo+shifti(indx), ihi+shifti(indx),
     $                       jlo+shiftj(indx), jhi+shiftj(indx), 
     $                       buf, chunk, 1d0)
              endif
           enddo
        enddo
      seconds = util_timer() - seconds
c
      time_acc = seconds/count
      end


      double precision function
     &    time_get(g_a, is, ie, js, je, buf, chunk, jump, count, local)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
      integer rows, cols, indx, shifti(3), shiftj(3)
      logical local
c
      integer ilo, ihi, jlo, jhi
      double precision  seconds, buf(*)
c
      count = 0
      rows = ie - is + 1
      cols = je - js + 1
      shifti(1) = rows
      shifti(2) = 0
      shifti(3) = rows
      shiftj(1) = 0
      shiftj(2) = cols
      shiftj(3) = cols

      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
           ihi = ilo + chunk -1
           do jlo = js, je -chunk-jump +1, chunk+jump
              jhi = jlo + chunk -1
              count = count + 1
              if (local) then
                 call ga_get(g_a, ilo, ihi, jlo, jhi, buf, chunk)
              else
                 indx = Mod(count,3) + 1
                 call ga_get(g_a, ilo+shifti(indx), ihi+shifti(indx),
     $                       jlo+shiftj(indx), jhi+shiftj(indx),
     $                       buf, chunk)
              endif
           enddo
        enddo
      seconds = util_timer() - seconds
c
      time_get = seconds/count
      end



      double precision function
     &   time_put(g_a, is, ie, js, je, buf, chunk, jump, count, local)
c
      implicit none
#include "global.fh"
#include "testutil.fh"
c
      integer g_a, chunk, jump, count, is, js, ie, je
      integer rows, cols, indx, shifti(3), shiftj(3)
      logical local
c
      integer ilo, ihi, jlo, jhi
      double precision  seconds, buf(*)
c
      count = 0
      rows = ie - is + 1
      cols = je - js + 1
      shifti(1) = rows
      shifti(2) = 0
      shifti(3) = rows
      shiftj(1) = 0
      shiftj(2) = cols
      shiftj(3) = cols

      seconds = util_timer()
c
c       distance between consecutive patches increased by jump
c       to destroy locality of reference
        do ilo = is, ie -chunk-jump +1, chunk+jump
           ihi = ilo + chunk -1
           do jlo = js, je -chunk-jump +1, chunk+jump
              jhi = jlo + chunk -1
              count = count + 1
              if (local) then
                 call ga_put(g_a, ilo, ihi, jlo, jhi, buf, chunk)
              else
                 indx = Mod(count,3) + 1
                 call ga_put(g_a, ilo+shifti(indx), ihi+shifti(indx),
     $                       jlo+shiftj(indx), jhi+shiftj(indx),
     $                       buf, chunk)
              endif
           enddo
        enddo
      seconds = util_timer() - seconds
c
      time_put = seconds/count
      end

      real*8 function dia_torsion(x,nx,w,nw,na,i,i2,j,j2,k,k2,l,l2)
c
c $Id: dia_torsion.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
#include "global.fh"
c
      integer nx,nw,na,i,i2,j,j2,k,k2,l,l2
      real*8 x(nx,3),w(nw,na,3)
c
      real*8 xijx,xkjx,xklx,xikx,xjlx
      real*8 xijy,xkjy,xkly,xiky,xjly
      real*8 xijz,xkjz,xklz,xikz,xjlz
      real*8 xmx,xmy,xmz,xnx,xny,xnz,rm2i,rn2i,rmni,cphi,s,phi
c
      real*8 xa(3),xb(3),xc(3),xd(3)
c
      if(i2.le.0) then
      xa(1)=x(i,1)
      xa(2)=x(i,2)
      xa(3)=x(i,3)
      else
      xa(1)=w(i,i2,1)
      xa(2)=w(i,i2,2)
      xa(3)=w(i,i2,3)
      endif
      if(j2.le.0) then
      xb(1)=x(j,1)
      xb(2)=x(j,2)
      xb(3)=x(j,3)
      else
      xb(1)=w(j,j2,1)
      xb(2)=w(j,j2,2)
      xb(3)=w(j,j2,3)
      endif
      if(k2.le.0) then
      xc(1)=x(k,1)
      xc(2)=x(k,2)
      xc(3)=x(k,3)
      else
      xc(1)=w(k,k2,1)
      xc(2)=w(k,k2,2)
      xc(3)=w(k,k2,3)
      endif
      if(l2.le.0) then
      xd(1)=x(l,1)
      xd(2)=x(l,2)
      xd(3)=x(l,3)
      else
      xd(1)=w(l,l2,1)
      xd(2)=w(l,l2,2)
      xd(3)=w(l,l2,3)
      endif
c
c     determine the dihedral angle
c     ----------------------------
c
      xijx=xa(1)-xb(1)
      xkjx=xc(1)-xb(1)
      xklx=xc(1)-xd(1)
      xikx=xijx-xkjx
      xjlx=xklx-xkjx
      xijy=xa(2)-xb(2)
      xkjy=xc(2)-xb(2)
      xkly=xc(2)-xd(2)
      xiky=xijy-xkjy
      xjly=xkly-xkjy
      xijz=xa(3)-xb(3)
      xkjz=xc(3)-xb(3)
      xklz=xc(3)-xd(3)
      xikz=xijz-xkjz
      xjlz=xklz-xkjz
      xmx=xijy*xkjz-xkjy*xijz
      xmy=xijz*xkjx-xkjz*xijx
      xmz=xijx*xkjy-xkjx*xijy
      xnx=xkjy*xklz-xkly*xkjz
      xny=xkjz*xklx-xklz*xkjx
      xnz=xkjx*xkly-xklx*xkjy
      rm2i=1.0d0/(xmx*xmx+xmy*xmy+xmz*xmz)
      rn2i=1.0d0/(xnx*xnx+xny*xny+xnz*xnz)
      rmni=sqrt(rm2i*rn2i)
      cphi=(xmx*xnx+xmy*xny+xmz*xnz)*rmni
      if(cphi.lt.-1.0d0) cphi=-1.0d0
      if(cphi.gt. 1.0d0) cphi= 1.0d0
      phi=acos(cphi)
      s=xkjx*(xmy*xnz-xmz*xny) +xkjy*(xmz*xnx-xmx*xnz)
     + +xkjz*(xmx*xny-xmy*xnx)
      if(s.lt.0.0d0) phi=-phi
c
      dia_torsion=phi
c
      return
      end

C> \file axbt.f
C> Matrix multiply
C>
C> \ingroup selci
C> @{
C>
C> \brief Matrix multiply
C>
C> Performs the matrix-matrix multiplication
C> \f{eqnarray*}{
C>   C &=& A * B^T
C> \f}
C>
      subroutine selci_axbt(a,mrowa,b,mrowb,c,mrowc,ncol,nlink,nrow)
*
* $Id: axbt.f 24784 2013-11-08 03:38:46Z d3y133 $
*
      implicit real*8 (a-h,o-z)
      integer mrowa !< [Input] The number of rows in A
      integer mrowb !< [Input] The number of rows in B
      integer mrowc !< [Input] The number of rows in C
      integer ncol  !< [Input] The length of a column in C
      integer nrow  !< [Input] The length of a row in C
      integer nlink !< [Input] The length of the contraction
      parameter (zero=0.0d0)
      double precision a(mrowa,nlink) !< [Input] Matrix A
      double precision b(mrowb,nlink) !< [Input] Matrix B
      double precision c(mrowc,nrow)  !< [Output] Matrix C
c     
c     matrix multiply c = a*bt
c     
*     mdc*if alliant
*     c(1:ncol,1:nrow) = matmul(a(1:ncol,1:nlink),
*     $     transpose(b(1:nrow,1:nlink)))
*     mdc*else
c     
c     Assumed that this is being used on small sparse matrices
c     
c     Optimize with loop unrolling
c     
      integer ind(3)
      real*8  bjk(3)
c
c     small cases
c
      if (nlink .eq. 1) then
         do j = 1, nrow
            do i = 1, ncol
               c(i,j) = a(i,1)*b(j,1)
            enddo
         enddo
         return
      else if (nlink.eq.2) then
         do j = 1, nrow
            do i = 1, ncol
               c(i,j) = a(i,1)*b(j,1) + a(i,2)*b(j,2)
            enddo
         enddo
         return
      else if (nlink .eq. 3) then
         do j = 1, nrow
            do i = 1, ncol
               c(i,j) = a(i,1)*b(j,1) + a(i,2)*b(j,2) + a(i,3)*b(j,3)
            enddo
         enddo
         return
      endif
c
c     general case
c
      do j = 1,nrow
         do i = 1,ncol
            c(i,j) = zero
         enddo
c
         ndo = 0
         do k = 1,nlink
            test = b(j,k)
            if (test .ne. 0.0d0) then
               ndo = ndo + 1
               ind(ndo) = k
               bjk(ndo) = test
            endif
            if (ndo.eq.3) then
               k1 = ind(1)
               k2 = ind(2)
               k3 = ind(3)
               bjk1 = bjk(1)
               bjk2 = bjk(2)
               bjk3 = bjk(3)
               do i = 1,ncol
                  c(i,j)=c(i,j)+a(i,k1)*bjk1+a(i,k2)*bjk2+a(i,k3)*bjk3
               enddo
               ndo = 0
            endif
         enddo
         if (ndo.eq.2) then
            k1 = ind(1)
            k2 = ind(2)
            bjk1 = bjk(1)
            bjk2 = bjk(2)
            do i = 1,ncol
               c(i,j) = c(i,j) + a(i,k1)*bjk1 + a(i,k2)*bjk2
            enddo
         else if (ndo.eq.1) then
            k1 = ind(1)
            bjk1 = bjk(1)
            do i = 1,ncol
               c(i,j) = c(i,j) + a(i,k1)*bjk1
            enddo
         endif
c     
      enddo
*     *mdc*endif
*     c
*     call selci_mxma(a,1,mrowa,b,mrowb,1,c,1,mrowc,ncol,nlink,nrow)
*     
*     call dgemm( 'n', 't', ncol, nrow, nlink, 1.0d0, a, mrowa,
*     *     b, mrowb, 0.0d0, c, mrowc )
c     
      end
C>
C> @}

C> \ingroup task
C> @{
      logical function task_drdy(rtdb)
      implicit none
*
      logical drdy_nwchem
      external drdy_nwchem
*
      integer rtdb
*
      task_drdy = drdy_nwchem(rtdb)
      end
C> @}
      logical function drdy_nwchem(rtdb)
*
* $Id: drdy.F 22841 2012-09-12 06:55:13Z d3y133 $
*
C
C DRDYNWChem - DiRect DYnamics with the NWChem electronic structure code
C   This code prepares the file30 input for POLYRATE from electronic 
C   structure calculations of gradients
C   and hessians at the reactant, product, and saddle point geometries, 
C   and along the minimum energy path.
C   Cartesian geometries for the reactants, products, and saddle points 
C   need to be input to this code;
C   optimization for these geometries is not performed in the code. 
C   Points along the minimum energy path
C   are calculated here.
C
C Read coordinate X, gradient DX (negative of the force), and the
C   Force constant matrix F from the runtime database and hessian file of 
C   NWChem predict the next step along the IRC, generate input file 
C   (via the RTDB) for NWChem initiate NWChem ab initio run
C
C  File useage
C     6  - standard output 
C    30  - RPH data
C
      Implicit none             ! Double Precision (A-H,O-Z)
#include "errquit.fh"
C
#include "stdio.fh"
#include "drdyP.fh"
#include "nwc_drdyP.fh"
#include "global.fh"
#include "rtdb.fh"
C
*::passed:
      Integer rtdb ! [input] RTDB handle
*::local:
      Logical status_rtdb
      Logical lhead,lsad,lskip
      integer jop
      integer ns
      integer jopmx
      integer i, ii, j
      integer i_dummy
*
      me_drdy = ga_nodeid()
      my_rtdb = rtdb
      fu6 = luout
      fu30 = 30
*      call setdbg(1)
      
      status_rtdb = rtdb_parallel(.false.)
      if (me_drdy.ne.0) then
        i_dummy = 0
        call drdy_synch(i_dummy,'drdy')
        goto 99999
      endif
C
C  Read in input data
      Call Input_for_drdy(rtdb)
C
C  Set up for constructing nwchem info on rtdb
      call potset_nwchem(rtdb)
C
      jop = 0
      lsad = .false.
      ns = 0
c
      if (lgs(8).eq.0) then
C
         call util_file_unlink('fort.30')
C  Initiate file 30
         Call drdy_rphwrt(0)
      else
C
C  Read restart data from file 30
         Call drdy_sort(lhead,jop,lsad,ns,0)
         if (.not.lhead) then
            write (fu6,*) ' trouble with restart, file unreadable'
            call errquit('drdy: fatal error',911, UNKNOWN_ERR)
         endif
      endif
      jopmx = 3
      if (lgs(6).eq.1.or.lgs(6).eq.3) jopmx = 4
C
C  Reactant and product calculations
      if (jop.lt.jopmx) Call drdy_react(jop)
C
      if (lgs(1).ne.0) then
C  Saddle point calculations
         if (lsad) then
C  Saddle point information successful read in from fort.30
            do i = 1,n3
               xspsv(i) = xr(i,5)
            enddo
         else
C  Calculate potential and hessian at saddle point geometry
            Call drdy_saddle
            Call drdy_rphwrt(5)
            Call drdy_rphwrt(6)
         endif
      else
         if (ns.le.0) then
C  No saddle point, if ns<=0 compute v, dx, h at starting geometry
            call drdy_saddle
C  lsad is set true in sort if the two lines beginning the MEP data
C   are already written
            if(.not.lsad) call drdy_rphwrt(6)
            call drdy_rphwrt(7)
            ns = 1
         else
            ii = 0
            vspsv = vgrid(1) + vzero
            vspspsv = vgrdsp(1) + vzerosp
            do i = 1,n3
               xspsv(i) = xgrid(i,1)
               dxspsv(i) = dxgrid(i,1)
               do j = 1,i
                  ii = ii + 1
                  fspsv(j,i) = hgrid(ii,1)
                  fspsv(i,j) = hgrid(ii,1)
               enddo
            enddo
         endif
      endif
      if (slp.ne.0.0d0.or.slm.ne.0.0d0) then
C
C  Check whether to skip the saddle point set up
C
        if (lgs(1).eq.0) then
C
C    no saddle point so skip
C
           lskip = .true.
        else if (ns.gt.0) then
C
C restart calculation; last s values on reactant and product sides should be in 
C sgrid(1) and sgrid(ns) - 
C skip if either the reactant or product side has not be done
C
           lskip = sgrid(1).lt.0.0d00 .and. sgrid(ns).gt.0.0d00
        else
C for saddle point with no previous calculation, don't skip
C
           lskip = .false.
        endif
C
C  Set up to take first step off saddle point
C
        if(.not.lskip) Call drdy_setpth
C
C  Calculate steepest descent path
C
        Call drdy_path(ns)
C
C  Sort data along reaction path and rewrite file30
C
        Call drdy_sort(lhead,jop,lsad,ns,1)
      endif
      write (fu6,*) 'drdy_NWChem has finished correctly, bye !'
      call drdy_synch(DRDY_CODE_DONE,'drdy 2')
99999 continue
*      call setdbg(0)
      call ga_sync()
      status_rtdb = rtdb_parallel(status_rtdb)
      drdy_nwchem = .true.
      End
      

*
* $Id: check_real.f 19707 2010-10-29 17:59:36Z d3y133 $
*


      subroutine Check_Real(nx,ny,nz,nfft3d,A)
      implicit none
      integer nx,ny,nz,nfft3d
      complex*16 A(nfft3d)


*     **** local variables ****
      integer i,j,k,kr
      integer k1,k2,k3
      integer nxh,nyh,nzh
      integer indx,indx_r

      nxh = nx/2
      nyh = ny/2
      nzh = nz/2

*     **** k1=0,k2=0, k3=-(nzh-1),nzh-1 ****
      k1 = 0
      k2 = 0
      do k3=1,(nzh-1)
        indx   = k3     *(nxh+1)*ny + 1
        indx_r = (nz-k3)*(nxh+1)*ny + 1
        if (A(indx).ne.dconjg(A(indx_r))) then
            write(*,*) "NR:",k1,k2,k3,A(indx),A(indx_r),
     >                  (A(indx)-A(indx_r))
        end if  
      end do
      
*     **** k1=0, k2=-(nyh-1),nyh-1, k3=-(nzh-1),nzh-1 ****
      k1 = 0
      do k3=(-nzh+1),(nzh-1)
      do k2=1,(nyh-1)
         k  =  k3
         kr = -k3
         if (k.lt.0)  k  = k  + nz
         if (kr.lt.0) kr = kr + nz
         indx   = k *(nxh+1)*ny +  k2    *(nxh+1) + 1
         indx_r = kr*(nxh+1)*ny + (ny-k2)*(nxh+1) + 1
         if (A(indx).ne.dconjg(A(indx_r))) then
            write(*,*) "NR:",k1,k2,k3,A(indx),A(indx_r),
     >                  (A(indx)-dconjg(A(indx_r)))
        end if  
      end do
      end do

      return
      end

C> \brief Implementation for use with GA-4-3
C>
C> An implementation of ga_zgop to be used only in the case of compiling
C> NWChem with GA-4-3 (i.e. the environment variable OLD_GA is set). In
C> GA-5-1 and later the routine ga_zgop is part of the global array
C> distribution. In GA-4-3 this routine did not exist causing
C> linking problems. However, this routine is used in only one place
C> to sum complex numbers across processors. We can easily reproduce
C> this particular behavior using real numbers instead of complex
C> numbers. So as a fallback we will use that approach.
C>
      subroutine ga_zgop(itype,x,n,op)
      implicit none
#include "errquit.fh"
      integer itype       !< [Input] MA data type of x 
      integer n           !< [Input] length of array x
      double complex x(n) !< [In/Output] the data array
      character*(*) op    !< [Input] the operation to perform
c
      if (op.eq."+") then
        call ga_dgop(itype,x,2*n,op)
      else
        call errquit("ga_zgop: invalid operation",0,UERR)
      endif
c
      end
c $Id: ga_zgop.F 24349 2013-06-23 04:30:58Z d3y133 $

      SUBROUTINE OFFSET_ccsdtq_lr_alpha_13_13_1(l_a_offset,k_a_offset,si
     &ze)
C     $Id: offset_ccsdtq_lr_alpha_13_13_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h5 h6 h7 h13 h15 p1 p2 p3 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h5b
      INTEGER h6b
      INTEGER h7b
      INTEGER h13b
      INTEGER h15b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      length = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h7b = h6b,noab
      DO h13b = h7b,noab
      DO h15b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1)
     &+int_mb(k_spin+h13b-1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+p1
     &b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h7b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h15b-1),i
     &eor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+p3b-
     &1)))))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h7b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h15b-1)
     &+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1).ne
     &.16)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lr_alpha_13_13_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h7b = h6b,noab
      DO h13b = h7b,noab
      DO h15b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1)
     &+int_mb(k_spin+h13b-1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+p1
     &b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h7b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h15b-1),i
     &eor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+p3b-
     &1)))))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h7b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h15b-1)
     &+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1).ne
     &.16)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p3b - noab - 1 + nvab * (p2b - noab - 1 
     &+ nvab * (p1b - noab - 1 + nvab * (h15b - 1 + noab * (h13b - 1 + n
     &oab * (h7b - 1 + noab * (h6b - 1 + noab * (h5b - 1)))))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_
     &mb(k_range+h7b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+h15b-1
     &) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_range
     &+p3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      SUBROUTINE ccsdtq_lambda2_23_8(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lambda2_23_8.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 p13 p18 h15 h16 h17 )_vttt + = -2 * Sum ( p10 ) * t ( p10 p13 h16 h17 )_t * i2 ( h3 p18 h15 p10 )_vtt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER p13b
      INTEGER p18b
      INTEGER h16b
      INTEGER h17b
      INTEGER h15b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p10b
      INTEGER p13b_1
      INTEGER p10b_1
      INTEGER h16b_1
      INTEGER h17b_1
      INTEGER h3b_2
      INTEGER p18b_2
      INTEGER h15b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO p13b = noab+1,noab+nvab
      DO p18b = noab+1,noab+nvab
      DO h16b = 1,noab
      DO h17b = h16b,noab
      DO h15b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+p13b-
     &1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+h16b-
     &1)+int_mb(k_spin+h17b-1).ne.12)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+p13b-1)+int_mb(k_spin+p18b-
     &1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+
     &h17b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+p13b-1),ieor(int_mb
     &(k_sym+p18b-1),ieor(int_mb(k_sym+h15b-1),ieor(int_mb(k_sym+h16b-1)
     &,int_mb(k_sym+h17b-1)))))) .eq. ieor(irrep_v,ieor(irrep_t,ieor(irr
     &ep_t,irrep_t)))) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+p13b-1) * int_mb(k_r
     &ange+p18b-1) * int_mb(k_range+h15b-1) * int_mb(k_range+h16b-1) * i
     &nt_mb(k_range+h17b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_23_8',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p10b = noab+1,noab+nvab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p10b-1) .eq. int_mb(k_spin
     &+h16b-1)+int_mb(k_spin+h17b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p10b-1),ieor(int_m
     &b(k_sym+h16b-1),int_mb(k_sym+h17b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p13b,p10b,h16b,h17b,p13b_1,p10b_1,h16b_1,h17
     &b_1)
      CALL TCE_RESTRICTED_4(h3b,p18b,h15b,p10b,h3b_2,p18b_2,h15b_2,p10b_
     &2)
      dim_common = int_mb(k_range+p10b-1)
      dima_sort = int_mb(k_range+p13b-1) * int_mb(k_range+h16b-1) * int_
     &mb(k_range+h17b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+p18b-1) * int_m
     &b(k_range+h15b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_23_8',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_23_8',2,MA_ERR)
      IF ((p10b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (p13b_1 - noab - 1 + nvab * (p
     &10b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p13b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17
     &b-1),4,3,2,1,1.0d0)
      END IF
      IF ((p13b .lt. p10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p
     &13b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p10b-1),int_mb(k_range+h16b-1),int_mb(k_range+h17
     &b-1),4,3,1,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_23_8',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_23_8',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_23_8',5,MA_ERR)
      IF ((h15b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - noab - 1 + nvab * (h15b_2 - 1 + noab * (p18b_2 - noab - 1 + nv
     &ab * (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p18b-1),int_mb(k_range+h15b-1),int_mb(k_range+p10b
     &-1),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_23_8',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_23_8
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_23_8
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_23_8',9,MA_ERR)
      IF ((p13b .le. p18b) .and. (h15b .le. h16b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p13b-1),3,6,2,1,5,4,-1.0
     &d0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h17b 
     &- 1 + noab * (h16b - 1 + noab * (h15b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p13b - noab - 1 + nvab * (h3b - 1)))))))
      END IF
      IF ((p13b .le. p18b) .and. (h16b .le. h15b) .and. (h15b .le. h17b)
     &) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p13b-1),3,6,2,5,1,4,1.0d
     &0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h17b 
     &- 1 + noab * (h15b - 1 + noab * (h16b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p13b - noab - 1 + nvab * (h3b - 1)))))))
      END IF
      IF ((p13b .le. p18b) .and. (h17b .le. h15b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p13b-1),3,6,2,5,4,1,-1.0
     &d0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h17b - 1 + noab * (h16b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p13b - noab - 1 + nvab * (h3b - 1)))))))
      END IF
      IF ((p18b .le. p13b) .and. (h15b .le. h16b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p13b-1),3,2,6,1,5,4,1.0d
     &0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h17b 
     &- 1 + noab * (h16b - 1 + noab * (h15b - 1 + noab * (p13b - noab - 
     &1 + nvab * (p18b - noab - 1 + nvab * (h3b - 1)))))))
      END IF
      IF ((p18b .le. p13b) .and. (h16b .le. h15b) .and. (h15b .le. h17b)
     &) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p13b-1),3,2,6,5,1,4,-1.0
     &d0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h17b 
     &- 1 + noab * (h15b - 1 + noab * (h16b - 1 + noab * (p13b - noab - 
     &1 + nvab * (p18b - noab - 1 + nvab * (h3b - 1)))))))
      END IF
      IF ((p18b .le. p13b) .and. (h17b .le. h15b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h3b-1),int_mb(k_range+h17b
     &-1),int_mb(k_range+h16b-1),int_mb(k_range+p13b-1),3,2,6,5,4,1,1.0d
     &0/3.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h17b - 1 + noab * (h16b - 1 + noab * (p13b - noab - 
     &1 + nvab * (p18b - noab - 1 + nvab * (h3b - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_23_8',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_23_8
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_diana_selection(atomname,natoms,target,list)
c
      implicit none
c
      integer natoms
      character*16 atomname(natoms)
      character*80 target
      character*10 string,aname
      integer list(natoms)
c
      integer i,j,ip,ndxcol,length,isgmfr,isgmto,isegment
      logical lsgm,latm
c
      do 1 i=1,natoms
      list(i)=0
 1    continue
c
      length=index(target,' ')-1
      ndxcol=index(target,':')
      lsgm=ndxcol.gt.0
      latm=ndxcol.gt.0
      if(ndxcol.eq.0) then
      latm=.false.
      do 2 i=1,length
      lsgm=.false.
      if(target(i:i).eq.'1') lsgm=.true.
      if(target(i:i).eq.'2') lsgm=.true.
      if(target(i:i).eq.'3') lsgm=.true.
      if(target(i:i).eq.'4') lsgm=.true.
      if(target(i:i).eq.'5') lsgm=.true.
      if(target(i:i).eq.'6') lsgm=.true.
      if(target(i:i).eq.'7') lsgm=.true.
      if(target(i:i).eq.'8') lsgm=.true.
      if(target(i:i).eq.'9') lsgm=.true.
      if(target(i:i).eq.'0') lsgm=.true.
      if(target(i:i).eq.',') lsgm=.true.
      if(target(i:i).eq.'-') lsgm=.true.
      if(.not.lsgm) latm=.true.
      if(latm) goto 3
 2    continue
 3    continue
      if(lsgm) then
      ndxcol=length+1
      else
      ndxcol=0
      endif
      endif
c
      if(lsgm) then
      string='          '
      isgmto=0
      isgmfr=0
      ip=1
      do 4 i=1,ndxcol
      if(target(i:i).eq.','.or.i.eq.ndxcol) then
      string(10+ip-i:10)=target(ip:i-1)
      read(string,'(i10)') isgmto
      string='          '
      ip=i+1
      if(isgmfr.eq.0) isgmfr=isgmto
      elseif(target(i:i).eq.'-') then
      string(10+ip-i:10)=target(ip:i-1)
      read(string,'(i10)') isgmfr
      string='          '
      ip=i+1
      endif
      if(isgmto.gt.0) then
      do 5 j=1,natoms
      read(atomname(j)(12:16),'(i5)') isegment
      if(isegment.ge.isgmfr.and.isegment.le.isgmto) list(j)=-1
 5    continue
      isgmto=0
      isgmfr=0
      endif
 4    continue
      else
      if(latm) then
      do 6 j=1,natoms
      list(j)=-1
 6    continue
      else
      do 7 j=1,natoms
      list(j)=1
 7    continue
      endif
      endif
c
      if(latm) then
      string='          '
      ip=1
      do 8 i=ndxcol+1,length+1
      if(target(i:i).eq.','.or.i.eq.length+1) then
      do 9 j=1,natoms
      if(list(j).eq.-1) then
      aname(1:6)=atomname(j)(6:11)
      if(string(1:1).eq.'_') aname(1:1)='_'
      if(string(1:1).eq.'?') aname(1:1)='?'
      if(string(2:2).eq.'?') aname(2:2)='?'
      if(string(3:3).eq.'?') aname(3:3)='?'
      if(string(4:4).eq.'?') aname(4:4)='?'
      if(string(5:5).eq.'?') aname(5:5)='?'
      if(string(6:6).eq.'?') aname(6:6)='?'
      if(string(1:6).eq.aname(1:6)) list(j)=1
      endif
 9    continue
      string='          '
      ip=1
      else
      string(ip:ip)=target(i:i)
      ip=ip+1
      endif
 8    continue
      else
      do 10 i=1,natoms
      if(list(i).lt.0) list(i)=1
   10 continue
      endif
c
      do 11 i=1,natoms
      if(list(i).lt.0) list(i)=0
   11 continue
c
      return
      end
c $Id: argos_diana_selection.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE print_output(istep,nprnt,ekin,ecoul,eshrt,ebond,eshel)

      implicit none

      include 'p_const.inc'
      include 'p_input.inc'
      include 'cm_temp.inc'

      integer  istep,nprnt

      real*8  ekin,ecoul,eshrt,ebond,eshel
      real*8  stptmp,stpke,stppe,stpte

      logical lnew

      data lnew/.true./

      save lnew

      stptmp=2.0*ekin/boltzmann/degfree
      stpke=ekin/convfct2
      stppe=ecoul+eshrt+ebond+eshel
      stpte=stppe+stpke
 
      if(lnew)write(output,'(/,a12,8a12)')'    STEP    ',
     $  '  TOTAL E.  ',' KINETIC E. ','POTENTIAL E.','  COUL. E.  ',
     $  '   VDW E.   ','  BOND E.   ','  SHELL E.  ',' TEMPERATURE'
      if(lnew)lnew=.false.

      if(mod(istep,nprnt).eq.0)write(output,'(i12,8f12.4)')
     $  istep,stpte,stpke,stppe,ecoul,eshrt,ebond,eshel,stptmp

      return

      END
c $Id: print_output.f 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine tce_jacobi2_ir4(d_r4,d_t4,k_t4_offset,omega,
     1                          shift,damping)
c
c $Id: tce_jacobi2_ir4.F 24184 2013-05-04 00:43:17Z edo $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
      integer d_r4
      integer d_t4
      integer p1b
      integer p2b
      integer p3b
      integer p4b
      integer h5b
      integer h6b
      integer h7b
      integer h8b
      integer p1
      integer p2
      integer p3
      integer p4
      integer h5
      integer h6
      integer h7
      integer h8
      integer k_t4_offset
      integer size
      integer l_r4,k_r4
      integer i
      integer nprocs
      integer count
      integer next
      integer nxtask
      external nxtask
      logical noloadbalance
      logical nodezero         ! True if node 0
      double precision shift,omega,damping
      double precision denom
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_r4))))
      nprocs = ga_nnodes()
      count = 0
      next = nxtask(nprocs,1)
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do p3b = p2b,noab+nvab
            do p4b = p3b,noab+nvab
              do h5b = 1,noab
                do h6b = h5b,noab
                  do h7b = h6b,noab
                    do h8b = h7b,noab
                      if (noloadbalance.or.(next.eq.count)) then
                      if (int_mb(k_spin+p1b-1)
     1                   +int_mb(k_spin+p2b-1)
     2                   +int_mb(k_spin+p3b-1)
     3                   +int_mb(k_spin+p4b-1)
     4                .eq.int_mb(k_spin+h5b-1)
     5                   +int_mb(k_spin+h6b-1)
     6                   +int_mb(k_spin+h7b-1)
     7                   +int_mb(k_spin+h8b-1)) then
                      if ((.not.restricted).or.
     1                   (int_mb(k_spin+p1b-1)
     2                   +int_mb(k_spin+p2b-1)
     3                   +int_mb(k_spin+p3b-1)
     4                   +int_mb(k_spin+p4b-1)
     5                   +int_mb(k_spin+h5b-1)
     6                   +int_mb(k_spin+h6b-1)
     7                   +int_mb(k_spin+h7b-1)
     8                   +int_mb(k_spin+h8b-1).ne.16)) then
                      if (ieor(int_mb(k_sym+p1b-1),
     1                    ieor(int_mb(k_sym+p2b-1),
     2                    ieor(int_mb(k_sym+p3b-1),
     3                    ieor(int_mb(k_sym+p4b-1),
     4                    ieor(int_mb(k_sym+h5b-1),
     5                    ieor(int_mb(k_sym+h6b-1),
     6                    ieor(int_mb(k_sym+h7b-1),
     7                    int_mb(k_sym+h8b-1)))))))) .eq. irrep_x) then
                        size = int_mb(k_range+p1b-1)
     1                       * int_mb(k_range+p2b-1)
     2                       * int_mb(k_range+p3b-1)
     3                       * int_mb(k_range+p4b-1)
     4                       * int_mb(k_range+h5b-1)
     5                       * int_mb(k_range+h6b-1)
     6                       * int_mb(k_range+h7b-1)
     7                       * int_mb(k_range+h8b-1)
                        if (.not.ma_push_get(mt_dbl,size,'rr4',
     1                    l_r4,k_r4))
     2                    call errquit('tce_jacobi2_ir4: MA problem',0,
     3                    MA_ERR)
                        call get_hash_block(d_r4,dbl_mb(k_r4),size,
     1                    int_mb(k_t4_offset),((((((((p1b-noab-1)*nvab
     2                    +p2b-noab-1)*nvab+p3b-noab-1)*nvab
     3                    +p4b-noab-1)*noab+h5b-1)*noab
     4                    +h6b-1)*noab+h7b-1)*noab+h8b-1))
                        i = 0
                        do p1 = 1,int_mb(k_range+p1b-1)
                          do p2 = 1,int_mb(k_range+p2b-1)
                            do p3 = 1,int_mb(k_range+p3b-1)
                              do p4 = 1,int_mb(k_range+p4b-1)
                                do h5 = 1,int_mb(k_range+h5b-1)
                                  do h6 = 1,int_mb(k_range+h6b-1)
                                    do h7 = 1,int_mb(k_range+h7b-1)
                                      do h8 = 1,int_mb(k_range+h8b-1)
                                    i = i + 1
                denom = ( 
     1             -dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2             -dbl_mb(k_evl_sorted+int_mb(k_offset+p2b-1)+p2-1)
     3             -dbl_mb(k_evl_sorted+int_mb(k_offset+p3b-1)+p3-1)
     4             -dbl_mb(k_evl_sorted+int_mb(k_offset+p4b-1)+p4-1)
     5             +dbl_mb(k_evl_sorted+int_mb(k_offset+h5b-1)+h5-1) 
     6             +dbl_mb(k_evl_sorted+int_mb(k_offset+h6b-1)+h6-1) 
     7             +dbl_mb(k_evl_sorted+int_mb(k_offset+h7b-1)+h7-1) 
     8             +dbl_mb(k_evl_sorted+int_mb(k_offset+h8b-1)+h8-1) 
     9                   )
                dbl_mb(k_r4+i-1) = damping*dbl_mb(k_r4+i-1)
     1                           / ( shift - denom*denom - omega*omega )
                                      enddo
                                    enddo
                                  enddo
                                enddo
                              enddo
                            enddo
                          enddo
                        enddo
                        call add_hash_block(d_t4,dbl_mb(k_r4),size,
     1                    int_mb(k_t4_offset),((((((((p1b-noab-1)*nvab
     2                    +p2b-noab-1)*nvab+p3b-noab-1)*nvab
     3                    +p4b-noab-1)*noab+h5b-1)*noab
     4                    +h6b-1)*noab+h7b-1)*noab+h8b-1))
                        if (nodezero.and.util_print('tr4',print_debug))
     1                    then
                          call get_hash_block(d_t4,dbl_mb(k_r4),size,
     1                    int_mb(k_t4_offset),((((((((p1b-noab-1)*nvab
     2                    +p2b-noab-1)*nvab+p3b-noab-1)*nvab
     3                    +p4b-noab-1)*noab+h5b-1)*noab
     4                    +h6b-1)*noab+h7b-1)*noab+h8b-1))
                          call ma_print_compact
     1                    (dbl_mb(k_r4),size,1,'tr4')
                        endif
                        if (.not.ma_pop_stack(l_r4))
     1                    call errquit('tce_jacobi2_ir4: MA problem',1,
     2                    MA_ERR)
                      endif
                      endif
                      endif
                      next = nxtask(nprocs,1)
                      endif
                      count = count + 1
                    enddo
                  enddo
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
      next = nxtask(-nprocs,1)
      call ga_sync()
      return
      end

      function task_smd_fragment(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
      logical task_smd_fragment
      logical result,ofragment
c
      logical task_smd_fragment_energy
      external task_smd_fragment_energy
      logical task_smd_energy_sp
      external task_smd_energy_sp
      character*30 operation,pname
      character*69 buffer
c
      double precision energy
c
      energy = 0.0d0
      pname = "task_smd_fragment"
c
      write(*,*) "initializing fragment"
      call smd_init("fragment",rtdb)
      call ga_sync()
c
      if (.not. rtdb_cget(rtdb,'task:operation', 1,operation))
     $      call errquit(pname,0, RTDB_ERR)

      if(operation.eq."energy") then
        call util_message("task_smd_fragment_energy")
        result = task_smd_fragment_energy(rtdb)   
      else
        call errquit(pname//"unknown operation"//operation,
     +               0, RTDB_ERR)
      end if
      if (.not. rtdb_put(rtdb,'smd:energy',mt_dbl,1,energy))
     $     call errquit(pname//'failed put energy', 0, RTDB_ERR)
      task_smd_fragment = .true.

      return
      END

      function task_smd_fragment_energy(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
      logical task_smd_fragment_energy
      character*72 namespace
      character*32 pname,rtdb_fname
      double precision etime1,etime2,etime3,etime4,etime5,etime6
      double precision energy,ewald1,ewald2,evdw
      logical operiodic
      integer i
      integer group_id,group_nproc,ngroup
      double precision eps
      integer world_me
c
      logical smd_tasklist_get1
      external smd_tasklist_get1
      logical smd_tasklist_get
      external smd_tasklist_get
c

      pname = "task_smd_fragment_energy"
c
c     closing world rtdb now
c     its name is saved in smd data structure
c     ---------------------------------------
      call smd_rtdb_close('keep')
c      if(.not.rtdb_close(rtdb, 'keep'))
c     + call errquit('Failed to close world rtdb',0, RTDB_ERR)
      call ga_sync() 
      call smd_data_print(60+ga_nodeid())
      call ga_sync() 
c
c     server-client loop
c     ------------------
      world_me = ga_nodeid()
      
      if(world_me.eq.0) then
         call util_message("executing server code")
         call sched_grp_server_code()
      else
         call util_message("executing client code")
         call sched_grp_client_code()
      endif

      call ga_sync()
c      call cpu_time(etime4)
      call smd_rtdb_get_name(rtdb_fname)
      if (.not. rtdb_open(rtdb_fname,'old',rtdb)) call errquit
     *     (' rtdb_open old failed ',0,0)
c


      write(*,*) "ending smd"
      call smd_data_print(30+ga_nodeid())
      call ga_sync()
      call smd_end(rtdb)
      task_smd_fragment_energy = .true.
      return
      END

c     ------------------------------
c     simple subgroup implementation
c     ------------------------------
      function task_smd_fragment_energy0(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
      logical task_smd_fragment_energy0
      character*72 namespace
      character*32 pname
      double precision etime1,etime2,etime3,etime4,etime5,etime6
      double precision energy,ewald1,ewald2,evdw
      logical operiodic
      integer i
      integer group_id,group_nproc,ngroup
      double precision eps
c
      logical smd_tasklist_get1
      external smd_tasklist_get1
      logical smd_tasklist_get
      external smd_tasklist_get
c

      pname = "task_smd_fragment_energy"
c
      eps = 1.0
c
      call smd_tasklist_init()
c     
      call ga_sync()
c
      call smd_group_init(rtdb)
c
      call smd_group_ngroup_get(ngroup)
      call smd_group_id_get(group_id)
      call smd_group_nproc_get(group_nproc)

99    continue
      if(.not.smd_tasklist_get1(i))
     >  goto 100 

      if(ga_nodeid().eq.0)
     > write(*,*) "got task",i,group_id
      call smd_monomer_energy(i)
c
      goto 99

      call cpu_time(etime6)
      write(luout,'(/,a,f20.3)')'Total CPU time : ',(etime6-etime1)
      write(luout,'(/,a,f20.3)')'Initialization : ',(etime2-etime1)
      write(luout,'(/,a,f20.3)')'Verlet         : ',(etime3-etime2)
      write(luout,'(/,a,f20.3)')'Force          : ',(etime4-etime3)

      write(*,*) "Goodbye from task_smd"
100   continue
      call ga_pgroup_sync(ga_pgroup_get_world())
      call smd_fragment_charge_diff(eps)
      if(eps.gt.0.0001) then
        call smd_tasklist_set()
        eps = 0.0d0
        goto 99
      end if

      call ga_pgroup_sync(ga_pgroup_get_world())
       call smd_group_end(rtdb)
       energy = 0.0d0
       if (.not. rtdb_put(rtdb,'smd:energy',mt_dbl,1,energy))
     $     call errquit(pname//'failed put energy', 0, RTDB_ERR)
      if(ga_nodeid().eq.0) then
       write(*,*) "smd_charge_write_default()"
       call smd_charge_write_default()
      end if
      call smd_end(rtdb)
      task_smd_fragment_energy0 = .true.
      return
      END


c $Id: task_smd_fragment.F 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE ccsdt_lr_alpha_offdiag_16_12_2(d_a,k_a_offset,d_b,k_b_o
     &ffset,d_c,k_c_offset)
C     $Id: ccsdt_lr_alpha_offdiag_16_12_2.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 p11 h10 p9 )_ybc + = 2 * Sum ( h7 h8 p5 ) * c ( p5 p11 h7 h8 )_c * i3 ( h2 h7 h8 h10 p5 p9 )_yb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p11b
      INTEGER h2b
      INTEGER h10b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h7b
      INTEGER h8b
      INTEGER p11b_1
      INTEGER p5b_1
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER h2b_2
      INTEGER h7b_2
      INTEGER h8b_2
      INTEGER h10b_2
      INTEGER p9b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p11b = noab+1,noab+nvab
      DO h2b = 1,noab
      DO h10b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p11b-
     &1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+
     &h10b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p11b-1),ieor(int_mb
     &(k_sym+h10b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_y,ieor(irrep
     &_b,irrep_c))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p11b-1) * int_mb(k_r
     &ange+h10b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_16_12_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h7b = 1,noab
      DO h8b = h7b,noab
      IF (int_mb(k_spin+p11b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+
     &h7b-1)+int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb
     &(k_sym+h7b-1),int_mb(k_sym+h8b-1)))) .eq. irrep_c) THEN
      CALL TCE_RESTRICTED_4(p11b,p5b,h7b,h8b,p11b_1,p5b_1,h7b_1,h8b_1)
      CALL TCE_RESTRICTED_6(h2b,h7b,h8b,h10b,p9b,p5b,h2b_2,h7b_2,h8b_2,h
     &10b_2,p9b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h7b-1) * int_m
     &b(k_range+h8b-1)
      dima_sort = int_mb(k_range+p11b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_16_12_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_16_12_2',2,MA_ERR)
      IF ((p5b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p11b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1
     &),2,4,3,1,1.0d0)
      END IF
      IF ((p11b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p11b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1
     &),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &6_12_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha_offdiag_16_12_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_16_12_2',5,MA_ERR)
      IF ((h8b .lt. h2b) .and. (h10b .le. p5b) .and. (p5b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h2b_2 - 1 + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h2b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p9b-1),6,4,3,2,1,5,1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h2b_2 - 1 + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h2b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+p5b-1),5,4,3,2,1,6,-1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (h10b .le. p5b) .and
     &. (p5b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h8b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p9b-1),6,4,2,3,1,5,-1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h8b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+p5b-1),5,4,2,3,1,6,1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (h10b .le. p5b) .and. (p5b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p9b-1),6,4,1,3,2,5,1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab
     & * (h8b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+p5b-1),5,4,1,3,2,6,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &6_12_2',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h7b .eq. h8b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_16_12_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_16_12_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha_offdiag_16_12_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+p11b-
     &1),3,4,2,1,2.0d0/1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h10b - 1 + noab * (p11b - noab - 1 + nvab * (h
     &2b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha_offdiag_1
     &6_12_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha_offd
     &iag_16_12_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      integer function util_time_remaining(rtdb)
* $Id: util_job.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
      integer rtdb
c
c     Return the minimum of the time remaining w.r.t. limits
c     .   set in the input (if any), and
c     .   set in the the batch job (if any)
c
c     If no limit information is available then return -1
c
c     NB: THIS IS A COLLECTIVE FUNCTION in order to ensure that
c     all processes get the same information and also to avoid 
c     creation of many subprocesses on machines for which it is
c     necessary to analyse the output of shell commands using perl.
c
      integer user_left, batch_left, left
      integer util_batch_job_time_remaining
      double precision util_wallsec
      external util_batch_job_time_remaining, util_wallsec
      logical rtdb_mode
c
      if (ga_nodeid() .eq. 0) then
c
         rtdb_mode = rtdb_parallel(.false.)
         if (rtdb_get(rtdb,'timelimit', mt_int, 1, user_left)) then
*            write(6,*) ' USER LIMIT ', user_left
            user_left = user_left - util_wallsec()
            if (user_left .lt. 0) user_left = 0
         else
            user_left = -1
         endif
*         write(6,*) '  USER LEFT ', user_left
         rtdb_mode = rtdb_parallel(rtdb_mode)
         batch_left = util_batch_job_time_remaining()
*         write(6,*) ' BATCH LEFT ', batch_left
c
         if (user_left .eq. -1) then ! User limit not defined
            left = batch_left
*            write(6,*) ' LEFT1 ', left
         else if (batch_left .eq. -1) then ! Batch limit not defined
            left = user_left
*            write(6,*) ' LEFT2 ', left
         else                   ! Both defined
*            left = min(batch_left,user_left)
            left = user_left    ! Seems better to allow override from input
*            write(6,*) ' LEFT3 ', left
         endif
      endif
c
      call ga_brdcst(161,left,mitob(1),0)
c
      util_time_remaining = left
c
      end
      logical function util_test_time_remaining(rtdb, required)
      implicit none
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
      integer rtdb ! [input]
      integer required ! [input] required time in seconds
c
c     Return TRUE if the required no. of seconds remain in the
c     job (minimum of user or batch job limits) or if no limits 
c     have been set.  If insufficient time remains, return FALSE.
c
c     NB: THIS IS A COLLECTIVE FUNCTION
c
      integer left, req
      integer util_time_remaining
      external util_time_remaining
c
      left = util_time_remaining(rtdb)
c
      util_test_time_remaining = .true.
c
      if (left .eq. -1) return
c
      req = required
      call ga_igop(353, req, 1, 'max')
c
      if (left.eq.0 .or. req.gt.left) then
         util_test_time_remaining = .false.
         if (ga_nodeid().eq.0) then
            write(6,1) left, required
 1          format(/' !! Terminating execution since time remaining =',
     $           i7,'s',/,' !!             is less than the ',
     $           'required time =',i7,'s'/)
            call util_flush(6)
         endif
      endif
c
      end

*
* $Id: brillioun.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************
*     *					*
*     *	       brillioun_init		*
*     *					*
*     ***********************************
      subroutine brillioun_init()
      implicit none
      integer map_in

#include "mafdecls.fh"
#include "errquit.fh"
#include "brillioun_common.fh"

*     **** local variables ****
      logical value
      integer nb,nbq,count,taskid_k,p
      real*8  kvec(3),ksvec(4)
      real*8 total_weight 

*     **** external functions ****
      integer  control_num_kvectors
      external control_num_kvectors

      call Parallel3d_taskid_k(taskid_k)

      nbrillioun = control_num_kvectors()
      printbrill = (nbrillioun.le.pbrillmax)

      map_in = 1
      call K1dB_init(nbrillioun,map_in)
      call K1dB_nq(nbrillq)

*     **** allocate from MA heap ****
      value =MA_alloc_get(mt_dbl,(nbrillq),'weight',weight(2),weight(1))
      value =value.and.
     >       MA_alloc_get(mt_dbl,(3*nbrillq),'ks',ks(2),ks(1))
      value =value.and.
     >       MA_alloc_get(mt_dbl,(3*nbrillq),'kv',kv(2),kv(1))
      value =value.and.
     >       MA_alloc_get(mt_dbl,(3*nbrillioun),'kv_all',
     >                    kv_all(2),kv_all(1))
      if (.not. value)
     > call errquit('brillioun_init:out of heap memory',0, MA_ERR)

      do nb=1,nbrillioun
         call control_ksvector(nb,ksvec)
         call control_kvector(nb,kvec)

         dbl_mb(kv_all(1)+3*(nb-1))    = kvec(1)
         dbl_mb(kv_all(1)+3*(nb-1)+1)  = kvec(2)
         dbl_mb(kv_all(1)+3*(nb-1)+2)  = kvec(3)

         call K1dB_ktoqp(nb,nbq,p)

         if (p.eq.taskid_k) then
            dbl_mb(kv(1)+3*(nbq-1))    = kvec(1)
            dbl_mb(kv(1)+3*(nbq-1)+1)  = kvec(2)
            dbl_mb(kv(1)+3*(nbq-1)+2)  = kvec(3)

            dbl_mb(ks(1)+3*(nbq-1))    = ksvec(1)
            dbl_mb(ks(1)+3*(nbq-1)+1)  = ksvec(2)
            dbl_mb(ks(1)+3*(nbq-1)+2)  = ksvec(3)
            dbl_mb(weight(1)+nbq-1)    = ksvec(4)
         end if
      end do

*     *** set the default weights *****
      count = 0
      total_weight = 0.0d0
      do nbq=1,nbrillq
         if (dbl_mb(weight(1)+nbq-1).gt.0.0d0) then
           total_weight = total_weight - dbl_mb(weight(1)+nbq-1)
         else
           count = count + 1
         end if
      end do
      call K1dB_ISumAll(count)
      call K1dB_SumAll(total_weight)
      total_weight = 1.0d0 - total_weight
     
      if (count.gt.0) then
         total_weight = total_weight/dble(count)
         do nbq=1,nbrillq
            if (dbl_mb(weight(1)+nbq-1).le.0.0d0) then
               dbl_mb(weight(1)+nbq-1) = total_weight
            end if
         end do
      end if

      return
      end


*     ***********************************
*     *					*
*     *	   brillioun_structure_init	*
*     *					*
*     ***********************************
      subroutine brillioun_structure_init(nbstart,nbk)
      implicit none
      integer nbstart,nbk

#include "mafdecls.fh"
#include "errquit.fh"
#include "brillioun_common.fh"

*     **** local variables ****
      logical value
      real*8  kvec(3),ksvec(4)
      integer map_in,nb,nbq,taskid_k,p

      call Parallel3d_taskid_k(taskid_k)
      nbrillioun = nbk
      
      map_in = 1
      call K1dB_init(nbrillioun,map_in)
      call K1dB_nq(nbrillq)

*     **** allocate from MA heap ****
      value = MA_alloc_get(mt_dbl,(nbrillq),
     >                     'weight',weight(2),weight(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(3*nbrillq),'ks',ks(2),ks(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(3*nbrillq),'kv',kv(2),kv(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(3*nbrillioun),
     >                     'kv_all',kv_all(2),kv_all(1))
      if (.not. value)
     > call errquit('brillioun_structure_init:out of heap memory',
     >              0,MA_ERR)

      do nb=1,nbrillioun
        call control_ksvector_structure((nb-1)+nbstart,ksvec)
        call control_kvector_structure((nb-1) +nbstart,kvec)

        dbl_mb(kv_all(1)+3*(nb-1))    = kvec(1)
        dbl_mb(kv_all(1)+3*(nb-1)+1)  = kvec(2)
        dbl_mb(kv_all(1)+3*(nb-1)+2)  = kvec(3)

        call K1dB_ktoqp(nb,nbq,p)
        if (p.eq.taskid_k) then
          dbl_mb(kv(1)+3*(nbq-1))    = kvec(1)
          dbl_mb(kv(1)+3*(nbq-1)+1)  = kvec(2)
          dbl_mb(kv(1)+3*(nbq-1)+2)  = kvec(3)

          dbl_mb(ks(1)+3*(nbq-1))    = ksvec(1)
          dbl_mb(ks(1)+3*(nbq-1)+1)  = ksvec(2)
          dbl_mb(ks(1)+3*(nbq-1)+2)  = ksvec(3)
          dbl_mb(weight(1)+(nbq-1))  = 1.0d0
        end if
      end do

      return
      end


*     ***********************************
*     *					*
*     *		brillioun_end		*
*     *					*
*     ***********************************
      subroutine brillioun_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "brillioun_common.fh"

*     **** local variables ****
      logical value

      call K1dB_end()

      value =           MA_free_heap(weight(2))
      value = value.and.MA_free_heap(ks(2))
      value = value.and.MA_free_heap(kv(2))
      value = value.and.MA_free_heap(kv_all(2))
      if (.not. value)
     > call errquit('brillioun_end:freeing heap memory',0, MA_ERR)

      return
      end 

*     ***********************************
*     *					*
*     *		brillioun_nbrillioun 	*
*     *					*
*     ***********************************
      integer function brillioun_nbrillioun()
      implicit none
!      integer nb

#include "mafdecls.fh"
#include "brillioun_common.fh"

      brillioun_nbrillioun = nbrillioun
      return
      end

*     ***********************************
*     *					*
*     *		brillioun_nbrillq   	*
*     *					*
*     ***********************************
      integer function brillioun_nbrillq()
      implicit none
!      integer nb

#include "mafdecls.fh"
#include "brillioun_common.fh"

      brillioun_nbrillq = nbrillq
      return
      end

*     ***********************************
*     *					*
*     *		brillioun_weight	*
*     *					*
*     ***********************************
      real*8 function brillioun_weight(nbq)
      implicit none
      integer nbq

#include "mafdecls.fh"
#include "brillioun_common.fh"

      brillioun_weight = dbl_mb(weight(1)+nbq-1)
      return
      end

*     ***********************************
*     *					*
*     *		 brillioun_ks		*
*     *					*
*     ***********************************
      real*8 function brillioun_ks(i,nbq)
      implicit none
      integer i,nbq

#include "mafdecls.fh"
#include "brillioun_common.fh"

      brillioun_ks = dbl_mb(ks(1)+3*(nbq-1)+i-1)
      return
      end

*     ***********************************
*     *					*
*     *		  brillioun_k	        *
*     *					*
*     ***********************************
      real*8 function brillioun_k(i,nbq)
      implicit none
      integer i,nbq

#include "mafdecls.fh"
#include "brillioun_common.fh"

      brillioun_k = dbl_mb(kv(1)+3*(nbq-1)+i-1)
      return
      end



*     ***********************************
*     *                                 *
*     *           brillioun_all_k       *
*     *                                 *
*     ***********************************
      real*8 function brillioun_all_k(i,nb)
      implicit none
      integer i,nb

#include "mafdecls.fh"
#include "brillioun_common.fh"

      brillioun_all_k = dbl_mb(kv_all(1)+3*(nb-1)+i-1)
      return
      end



*     ***********************************
*     *					*
*     *		brillioun_weight_brdcst	*
*     *					*
*     ***********************************
      real*8 function brillioun_weight_brdcst(nb)
      implicit none
      integer nb

#include "mafdecls.fh"
#include "brillioun_common.fh"

      integer nbq,taskid_k,p
      real*8 w 

      call Parallel3d_taskid_k(taskid_k)
      call K1dB_ktoqp(nb,nbq,p)

      w = 0.0d0
      if (p.eq.taskid_k) w = dbl_mb(weight(1)+nbq-1)
      call K1dB_SumAll(w)

      brillioun_weight_brdcst = w
      return
      end

*     ***********************************
*     *					*
*     *		 brillioun_ks_brdcst	*
*     *					*
*     ***********************************
      real*8 function brillioun_ks_brdcst(i,nb)
      implicit none
      integer i,nb

#include "mafdecls.fh"
#include "brillioun_common.fh"

      integer nbq,taskid_k,p
      real*8 w 

      call Parallel3d_taskid_k(taskid_k)
      call K1dB_ktoqp(nb,nbq,p)

      w = 0.0d0
      if (p.eq.taskid_k) w = dbl_mb(ks(1)+3*(nbq-1)+i-1)
      call K1dB_SumAll(w)

      brillioun_ks_brdcst = w
      return
      end

*     ***********************************
*     *					*
*     *		  brillioun_k_brdcst    *
*     *					*
*     ***********************************
      real*8 function brillioun_k_brdcst(i,nb)
      implicit none
      integer i,nb

#include "mafdecls.fh"
#include "brillioun_common.fh"

      integer nbq,taskid_k,p
      real*8 w 

      call Parallel3d_taskid_k(taskid_k)
      call K1dB_ktoqp(nb,nbq,p)

      w = 0.0d0
      if (p.eq.taskid_k) w = dbl_mb(kv(1)+3*(nbq-1)+i-1)
      call K1dB_SumAll(w)

      brillioun_k_brdcst = w
      return
      end

*     ***********************************
*     *                                 *
*     *           brillioun_print      *
*     *                                 *
*     ***********************************
      logical function brillioun_print()
      implicit none
      integer i,nb

#include "mafdecls.fh"
#include "brillioun_common.fh"

      brillioun_print = printbrill
      return
      end

      program test
C$Id: test.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "rtdb.fh"
#include "mafdecls.fh"
c
      integer rtdb, ma_handle, ma_index
      integer itest(3), ibuf(3)
      real ftest(4), fbuf(4)
      double precision dtest(5), dbuf(5)
      character *20 cbuf(4), ccbuf(4)
      character *20 name,rtdb_fname
      character *26 date
      logical status
      integer type, nelem, i
c
      data itest/1, 2, 3/
      data ftest/1.0e0, 2.0e0, 3.0e0, 4.0e0/
      data dtest/1.0d0, 2.0d0, 3.0d0, 4.0d0, 5.0d0/
c
      cbuf(1) = 'Have'
      cbuf(2) = 'a'
      cbuf(3) = 'nice'
      cbuf(4) = 'day, Robert!'
c
      call pbeginf()
      if (.not. ma_init(MT_DBL, -1, -1)) stop 99
      call ga_initialize()
      if (.not. rtdb_open('fortran.db', 'empty', rtdb)) stop 1
c
      if (.not. rtdb_put(rtdb, 'Integer array', MT_INT, 3, itest))
     $     stop 2
      if (.not. rtdb_put(rtdb, 'Real array', MT_REAL, 4, ftest))
     $     stop 3
      if (.not. rtdb_put(rtdb, 'Double array', MT_DBL, 5, dtest))
     $     stop 4
      if (.not. rtdb_cput(rtdb, 'Character variable', 4, cbuf))
     $     stop 44
c
      if (.not. rtdb_print(rtdb, .true.)) stop 55
c
      if (.not. rtdb_get(rtdb, 'Integer array', MT_INT, 3, ibuf))
     $     stop 5
      write(6,*) ' Ibuf ', ibuf
      if (.not. rtdb_get(rtdb, 'Real array', MT_REAL, 4, fbuf))
     $     stop 6
      write(6,*) ' Fbuf ', fbuf
      if (.not. rtdb_get(rtdb, 'Double array', MT_DBL, 5, dbuf))
     $     stop 7
      write(6,*) ' Dbuf ', dbuf
      if (.not. rtdb_cget(rtdb, 'Character variable', 4, ccbuf))
     $     stop 8
      write(6,*) ' Cbuf 1 ', ccbuf(1)
      write(6,*) ' Cbuf 2 ', ccbuf(2)
      write(6,*) ' Cbuf 3 ', ccbuf(3)
      write(6,*) ' Cbuf 4 ', ccbuf(4)
c
      status = rtdb_first(rtdb, name)
 10   if (status) then
         if (.not. rtdb_get_info(rtdb, name, type, nelem, date)) stop 9
         write(6,*) name, type, nelem, date
         if (type.eq.mt_int .or. type.eq.mt_dbl) then
            type = -1
            nelem = -1
            if (.not. rtdb_ma_get(rtdb, name, type, nelem, ma_handle))
     $           stop 88
            write(6,*) name, type, nelem, date
            if (.not. ma_get_index(ma_handle, ma_index)) stop 89
            if (type .eq. mt_int) then
               write(6,1) (int_mb(ma_index+i),i=0,nelem-1)
 1             format(1x,10i5)
            else if (type .eq. mt_dbl) then
               write(6,2) (dbl_mb(ma_index+i),i=0,nelem-1)
 2             format(1x,5d16.8)
            else
               stop 91
            endif
            status = ma_free_heap(ma_handle)
         endif
         status = rtdb_next(rtdb, name)
         goto 10
      endif
c
      if (.not. rtdb_getfname(rtdb, rtdb_fname)) stop 9
      if (.not. rtdb_close(rtdb, 'keep')) stop 10
      call testclone(rtdb,rtdb_fname)
c
      call pend()
c
      end
      subroutine testclone(rtdb,rtdbname)
      implicit none
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
      integer rtdb
c
      character*(*) rtdbname           
      character*256 grtdbname
      logical ortdbstate
      double precision dtest(5)
c
      integer ii,ngroups
c
      ngroups=12

      if(ga_nodeid().eq.0) write(0,*) '**Testing rtdb_clone'
      ortdbstate=rtdb_parallel(.true.)

      do ii=1,ngroups
         call util_pname0(rtdbname,grtdbname,ii,ngroups)
c     
c     creates rtdb file grtdbname=rtdbname.ii
c     
         if(.not.rtdb_clone(rtdb,grtdbname))
     .        call errquit('oo ',0,0)
      enddo
c
c     try  to open rtdbname.2
c
      call util_pname0(rtdbname,grtdbname,2,ngroups)
      if (.not. rtdb_open(grtdbname, 'old', rtdb)) stop 123
c
c     get the dtest() doubles
c
      if (.not. rtdb_get(rtdb, 'Double array', MT_DBL, 5, dtest))
     $     stop 4
      write(0,*) 'me=',ga_nodeid(),' got dtest(2) =',dtest(2)
c
c     modify dtest(2)
c
      dtest(2)=dtest(2)-.33d0
c
c     rtdb_put for dtest
c
      if (.not. rtdb_put(rtdb, 'Double array', MT_DBL, 5, dtest))
     $     stop 5
      if (.not. rtdb_get(rtdb, 'Double array', MT_DBL, 5, dtest))
     $     stop 6
      write(0,*) 'me=',ga_nodeid(),' got dtest(2) =',dtest(2)
      if (.not. rtdb_close(rtdb, 'keep')) stop 103
c
c     delete all the rtdb we cloned earlier
c
      do ii=1,ngroups
         call util_pname0(rtdbname,grtdbname,ii,ngroups)
         if (.not. rtdb_open(grtdbname, 'old', rtdb)) stop 123
         if (.not. rtdb_close(rtdb, 'delete')) stop 103
      enddo
      return
      end

c
c FNAME - filename for test program
c
#define BASE_NAME 'shared.file'
#ifdef  HPIODIR
#  define FNAME   HPIODIR//BASE_NAME
#else
#  define FNAME   BASE_NAME
#endif
#define SYNCH ga_sync

      subroutine util_sf_test
c
      implicit none
#include "sf.fh"
c
      integer size
      integer dimnsn
      integer maxid
      parameter(maxid=5)           ! max number of outstanding I/O requests
      parameter(dimnsn=8192)
      real*8 buffer(dimnsn,maxid)  ! need buffering for all maxid requests
      double precision tt0,ttw, ttr, tcgtime
c     integer stack, heap
      integer idlist(maxid), curid
      character*80 errmsg
      logical status
c
      integer nodeid, nnodes
      integer me,nproc,handle,i,start,end,j, rc, chunk
c
c     call pbeginf()
c     call ga_initialize()
c
      curid = 0
      me = nodeid()
      nproc = nnodes()
      size  = maxid*dimnsn*nproc
c
      status = .true.
      rc = sf_create(FNAME,
     $     dble(16*size),dble(8*size),dble(8*dimnsn),handle)
      if (rc.ne.0) status = .false.
      if (me.eq.0) then
         if (status) then
         write(6,'(A)') ' sf_create ........................ OK'
         else
         write(6,'(A)') ' sf_create ........................ Failed'
         endif
         call ffflush(6)
      endif
c
      call SYNCH
      chunk = (size+nproc-1)/nproc
      start = me*chunk+1
      end = min((start+chunk-1),size)
      tt0 = tcgtime()
      status = .true.
c
c     print *,'me=',me,'writing:', start, end
c     everybody writes chunk of data
      if(start.le.end) then
         do i = start, end,dimnsn
            do j = 1, min(dimnsn,(end-i+1))
               buffer(j,curid+1) = dble(i+j-1)
            enddo

            if(curid .eq. maxid)then
               rc=sf_waitall(idlist,maxid)
               curid = 0
            endif
            curid = curid+1
            rc = sf_write(handle,  8*dble(i-1), 
     &           8*dble(min(dimnsn,(end-i+1))), buffer(1,curid), 
     &           idlist(curid))
            if (rc.ne.0) status = .false.

         enddo
      endif
c
      rc=sf_waitall(idlist,curid)
      if(rc.ne.0) status = .false.
      curid = 0
      if (me.eq.0) then
         if (status) then
         write(6,'(A)') ' sf_write/sf_waitall .............. OK'
         else
         write(6,'(A)') ' sf_write/sf_waitall .............. Failed'
         endif
         call ffflush(6)
      endif

      ttw = tcgtime() -tt0
c
      call ga_dgop(88,ttw,1,'max')
      call SYNCH
c
c
c     everybody reads different chunk of data
      start = (nproc-me-1)*chunk+1
      end = min((start+chunk-1),size)
c     print *,'me=',me,'reading:', start, end
      tt0 = tcgtime()
      status = .true.
      do i = start,end,dimnsn

c           read and test data chunk by chunk
            rc = sf_read(handle, 8*dble(i-1),
     .           8*dble(min(dimnsn,(end-i+1))), buffer, idlist(1))
            if (rc.ne.0)then
               status = .false.
            endif
            rc=sf_wait(idlist(1))
            if (rc.ne.0) status = .false.
c
            do j = 1,min(dimnsn,(end-i+1))
               if(buffer(j,1).ne.dble(i+j-1)) then
                  status = .false.
               endif
            enddo
      enddo
      ttr = tcgtime() -tt0
c
      call ga_dgop(88,ttr,1,'max')
      call SYNCH
      if (me.eq.0) then
         if (status) then
         write(6,'(A)') ' sf_read/sf_wait .................. OK'
         else
         write(6,'(A)') ' sf_read/sf_wait .................. Failed'
         endif
         call ffflush(6)
      endif
c
      status = .true.
      rc = sf_destroy(handle)
      if(rc.ne.0) status = .false.
      if (me.eq.0) then
         if (status) then
         write(6,'(A)') ' sf_destroy ....................... OK'
         else
         write(6,'(A)') ' sf_destroy ....................... Failed'
         endif
         call ffflush(6)
      endif
      if(me.eq.0)then
c       write(*,*)' '
c       write(*,*)'test passed ', 8*maxid*dimnsn,' bytes'
c       write(*,*) 8.0e-6*maxid*dimnsn/ttw,' MB/s write rate'
c       write(*,*) 8.0e-6*maxid*dimnsn/ttr,' MB/s read rate'
c       write(*,*)' '
        write(6,'(A,F7.1,A)') ' sf_write rate .................... ',
     1  8.0e-6*maxid*dimnsn/ttw,' MB/s'
        write(6,'(A,F7.1,A)') ' sf_read rate ..................... ',
     1  8.0e-6*maxid*dimnsn/ttr,' MB/s'
        call ffflush(6)
      endif
c
      call SYNCH
c     call ga_terminate
c     call pend()
      end
c $Id: util_sf_test.F 21345 2011-10-31 21:26:52Z d3p852 $

      subroutine oeigd(fc, s, u, t, h)
C$Id: oeigd.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
      real *8 fc(*), s(*), u(*), t(*), h(*)
c.......................................................................
c     one-electron integrals. general.
c.......................................................................
c
#include "cguess.fh"
c
      integer l, i, j
      integer nbas1, k, nstep
      real *8 ufacl, expfac, zp, zq, zpq, term1, ppq, rpq
c
      ufacl = sqrt(8.0d0/3.1415926536d0)
      nstep = 0
      k = 0
      do l = 1 , nsym
         nbas1 = nbas(l)
         expfac = l + 0.5d0
         do i = 1 , nbas1
            do j = 1 , i
               k = k + 1
               zp = zeta(nstep+i)
               zq = zeta(nstep+j)
               zpq = 0.5d0*(zp+zq)
               term1 = sqrt(zpq)
               ppq = zp*zq/zpq
               rpq = sqrt(ppq/zpq)
               s(k) = rpq**expfac
               fc(k) = s(k)
               u(k) = ufacl*s(k)*term1
               t(k) = expfac*s(k)*ppq
               h(k) = t(k) - zn*u(k)
            enddo
         enddo
         nstep = nstep + nbas1
         ufacl = ufacl*2.0d0*l/(2.0d0*l+1.0d0)
      enddo
      return
      end

      subroutine fock_2e_c( nfock, tol2e, q4_shell, eri,
     $     islo, ishi, jslo, jshi,
     $     kslo, kshi, lslo, lshi,
     $     ialo, iahi, jalo, jahi,
     $     kalo, kahi, lalo, lahi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_c.F 19707 2010-10-29 17:59:36Z d3y133 $

      implicit none
c     
c     Add integrals without labels into atomic fock matrix blocks ... 
c     symmetrization will be needed later
c
c     !! THIS ROUTINE IS OBSOLETED BY ROUTINES THAT USE LABELS
c     
      integer nfock
      double precision tol2e
      double precision q4_shell
      integer islo, ishi, jslo, jshi, kslo, kshi, lslo, lshi
      integer ialo, iahi, jalo, jahi, kalo, kahi, lalo, lahi
      double precision eri(lslo:lshi,kslo:kshi,jslo:jshi,islo:ishi)
      double precision dij(nfock,ialo:iahi,jalo:jahi)
      double precision dik(nfock,ialo:iahi,kalo:kahi)
      double precision dli(nfock,lalo:lahi,ialo:iahi)
      double precision djk(nfock,jalo:jahi,kalo:kahi)
      double precision dlj(nfock,lalo:lahi,jalo:jahi)
      double precision dlk(nfock,lalo:lahi,kalo:kahi)
      double precision fij(nfock,ialo:iahi,jalo:jahi)
      double precision fik(nfock,ialo:iahi,kalo:kahi)
      double precision fli(nfock,lalo:lahi,ialo:iahi)
      double precision fjk(nfock,jalo:jahi,kalo:kahi)
      double precision flj(nfock,lalo:lahi,jalo:jahi)
      double precision flk(nfock,lalo:lahi,kalo:kahi)
c     
      integer i, j, k, l, jtop, ktop, ltop, v
      logical oij, okl, oikjl
      double precision g
c     
c     Assume identical index ranges ==> identical shells
c     
      oij = islo.eq.jslo
      okl = kslo.eq.lslo
      oikjl = (islo.eq.kslo).and.(jslo.eq.lslo)
c     
c     Add into the fock matrix
c     
      do i = islo, ishi
        jtop = jshi
        if (oij) jtop = i
        do j = jslo, jtop
          ktop = kshi
          if (oikjl) ktop = i
          do k = kslo, ktop
            ltop = lshi
            if (okl) ltop = k
            if (oikjl .and. k.eq.i) ltop = j
            do l = lslo, ltop
              if (abs(eri(l,k,j,i)) .ge. tol2e) then
                g = eri(l,k,j,i)*q4_shell
                do v=1,nfock
                  fij(v,i,j) = fij(v,i,j) + g*dlk(v,l,k)
                  flk(v,l,k) = flk(v,l,k) + g*dij(v,i,j)
                  fik(v,i,k) = fik(v,i,k) + g*dlj(v,l,j)
                  fli(v,l,i) = fli(v,l,i) + g*djk(v,j,k)
                  flj(v,l,j) = flj(v,l,j) + g*dik(v,i,k)
                  fjk(v,j,k) = fjk(v,j,k) + g*dli(v,l,i)
                enddo
              end if
            enddo
          enddo
        enddo
      enddo
      
      end



c
c  Special code for nfock=1
c
      subroutine fock_2e_c1( tol2e, q4_shell, eri,
     $                       islo, ishi, jslo, jshi,
     $                       kslo, kshi, lslo, lshi,
     $                       ialo, iahi, jalo, jahi,
     $                       kalo, kahi, lalo, lahi,
     $                       dij, dik, dli, djk, dlj, dlk, 
     $                       fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_c.F 19707 2010-10-29 17:59:36Z d3y133 $

      implicit none
c     
c     Add integrals without labels into atomic fock matrix blocks ... 
c     symmetrization will be needed later
c
c     !! THIS ROUTINE IS OBSOLETED BY ROUTINES THAT USE LABELS
c     
      double precision tol2e
      double precision q4_shell
      integer islo, ishi, jslo, jshi, kslo, kshi, lslo, lshi
      integer ialo, iahi, jalo, jahi, kalo, kahi, lalo, lahi
      double precision eri(lslo:lshi,kslo:kshi,jslo:jshi,islo:ishi)
      double precision dij(ialo:iahi,jalo:jahi)
      double precision dik(ialo:iahi,kalo:kahi)
      double precision dli(lalo:lahi,ialo:iahi)
      double precision djk(jalo:jahi,kalo:kahi)
      double precision dlj(lalo:lahi,jalo:jahi)
      double precision dlk(lalo:lahi,kalo:kahi)
      double precision fij(ialo:iahi,jalo:jahi)
      double precision fik(ialo:iahi,kalo:kahi)
      double precision fli(lalo:lahi,ialo:iahi)
      double precision fjk(jalo:jahi,kalo:kahi)
      double precision flj(lalo:lahi,jalo:jahi)
      double precision flk(lalo:lahi,kalo:kahi)
c     
      integer i, j, k, l, jtop, ktop, ltop
      logical oij, okl, oikjl
      double precision d_ij, d_jk, d_ik
      double precision f_ij, f_jk, f_ik
      double precision g
c     
c     Assume identical index ranges ==> identical shells
c     
      oij = islo.eq.jslo
      okl = kslo.eq.lslo
      oikjl = (islo.eq.kslo).and.(jslo.eq.lslo)
c     
c     Add into the fock matrix
c     
      do i = islo, ishi
        jtop = jshi
        if (oij) jtop = i
        do j = jslo, jtop
          d_ij = dij(i,j)
          f_ij = 0.d0
          ktop = kshi
          if (oikjl) ktop = i
          do k = kslo, ktop
            d_jk = djk(j,k)
            d_ik = dik(i,k)
            f_jk = 0.d0
            f_ik = 0.d0
            ltop = lshi
            if (okl) ltop = k
            if (oikjl .and. k.eq.i) ltop = j
            do l = lslo, ltop
              if (abs(eri(l,k,j,i)) .ge. tol2e) then
                g = eri(l,k,j,i)*q4_shell
                flk(l,k)   = flk(l,k)   + g * d_ij
                fli(l,i)   = fli(l,i)   + g * d_jk
                flj(l,j)   = flj(l,j)   + g * d_ik
                f_ij       = f_ij       + g * dlk(l,k)
                f_ik       = f_ik       + g * dlj(l,j)
                f_jk       = f_jk       + g * dli(l,i)
              end if
            enddo
            fjk(j,k) = fjk(j,k) + f_jk
            fik(i,k) = fik(i,k) + f_ik
          enddo
          fij(i,j) = fij(i,j) + f_ij
        enddo
      enddo
      
      end

      subroutine sym_print_all(geom, oinfo, ouniq, omap, oops, ochar)
C$Id: sym_pr_all.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "nwc_const.fh"
#include "geomP.fh"
#include "util.fh"
#include "mafdecls.fh"
#include "inp.fh"
c
c     Print out all symmetry related information inside the
c     geometry object 
c
      integer geom              ! [input]
      logical oinfo             ! If true print info
      logical ouniq             ! If true print list of unique atoms
      logical omap              ! If true print mapping of atoms under ops
      logical oops              ! If true print operator matrices
      logical ochar             ! If true print character table
c
      integer cent, j, op, addr, centhi
c
      call util_print_centered(6,'Symmetry information', 15, .true.)
      write(6,*)
c
      if (oinfo) then
         write(6,1) group_name(geom), group_number(geom),
     $        sym_num_ops(geom)+1, ncenter_unique(geom)
         if (isystype(geom) .ne. 0) write(6,11) 
     $        setting_number(geom)
         write(6,*)
 1       format(
     $        ' Group name             ', a10/
     $        ' Group number           ', i4/
     $        ' Group order            ', i4/
     $        ' No. of unique centers  ', i4)
 11      format(
     $        ' Setting number         ', i4)
      endif
c      
      if (ochar) call sym_print_char_table(geom)
c
      if (ouniq) then
         call util_print_centered(6,'Symmetry unique atoms', 15,.false.)
         write(6,*)
         do j = 1, ncenter_unique(geom), 15
            centhi = min(j + 14,ncenter_unique(geom))
            write(6,2) (unique_cent(cent,geom),cent=j,centhi)
 2          format(1x,15i5)
         enddo
         write(6,*)
      endif
c
      if (omap) then
         call util_print_centered(6,'Mapping of centers', 14, .false.)
         write(6,*)
         do op = 1, sym_num_ops(geom)
            write(6,15) op
 15         format('     op ', i3)
            if (omap) then
               addr = sym_center_map_index(geom) + op - 1
               write(6,5) (
     $              cent,
     $              int_mb(addr + (cent-1)*sym_num_ops(geom)),
     $              cent=1,ncenter(geom))
 5             format(100(10x,5('(',i4,'->',i4,')':,2x)/))
            endif
         enddo
         write(6,*)
      endif
c
      if (oops) then
         call util_print_centered(6,'Group operations', 13, .false.)
         write(6,*)
         call sym_print_ops(geom)
         write(6,*)
      endif
c
      call util_flush(6)
c
      end

*> \brief \b CSCAL
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CSCAL(N,CA,CX,INCX)
* 
*       .. Scalar Arguments ..
*       COMPLEX CA
*       INTEGER INCX,N
*       ..
*       .. Array Arguments ..
*       COMPLEX CX(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    CSCAL scales a vector by a constant.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex_blas_level1
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>     jack dongarra, linpack,  3/11/78.
*>     modified 3/93 to return if incx .le. 0.
*>     modified 12/3/93, array(1) declarations changed to array(*)
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE CSCAL(N,CA,CX,INCX)
*
*  -- Reference BLAS level1 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      COMPLEX CA
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      COMPLEX CX(*)
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER I,NINCX
*     ..
      IF (N.LE.0 .OR. INCX.LE.0) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
         DO I = 1,N
            CX(I) = CA*CX(I)
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         NINCX = N*INCX
         DO I = 1,NINCX,INCX
            CX(I) = CA*CX(I)
         END DO
      END IF
      RETURN
      END
c $Id: cscal.f 24342 2013-06-22 05:32:15Z d3y133 $

      subroutine argos_cafe_mcti_w(isat,isga,vs,nums,wgt,dera)
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      integer nums
      integer isat(msa),isga(msa)
      real*8 vs(msa,3),wgt(mat,mset)
      real*8 dera(6,nsatot)
c
      integer i
      real*8 vsq
c
      do 1 i=1,nums
      vsq=half*(vs(i,1)*vs(i,1)+vs(i,2)*vs(i,2)+vs(i,3)*vs(i,3))
      deriv(13,1)=deriv(13,1)-wgt(isat(i),4)*vsq
      if(npgdec.gt.1) dera(6,isga(i))=dera(6,isga(i))-wgt(isat(i),4)*vsq
      if(ipert2.and.ip2(13)) ep2(3)=ep2(3)+
     + vsq*wgt(isat(i),1)*(wgt(isat(i),1)/wgt(isat(i),2)-one)
      if(ipert3.and.ip3(13)) ep3(3)=ep3(3)+
     + vsq*wgt(isat(i),1)*(wgt(isat(i),1)/wgt(isat(i),3)-one)
    1 continue
c
      return
      end
c $Id: argos_cafe_mcti_w.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_place(HESS,GRAD,COORD,ENERGY,IERR)
c $Id: stpr_place.F 25540 2014-05-01 22:33:27Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
#include "cstprfiles.fh"
      DIMENSION HESS(NAT3TR),
     &          GRAD(NAT3),
     &          COORD(3,NATOM)
      IERR = 0

#if defined(OPENCLOSE)
      OPEN (UNIT=ITAP45, FORM='UNFORMATTED', FILE=FILE45,
     &   ACCESS='SEQUENTIAL', STATUS='UNKNOWN',err=10)
      REWIND (UNIT=ITAP45)
#else
      REWIND ITAP45
#endif
C
C     Write HESS.
C
*debug:      write(6,*)'hess stpr_place',nat3tr
*debug:      do i=1,nat3tr
*debug:        if (abs(hess(i)).gt.1.0d-5)
*debug:     &      write(6,*)' hess (',i,') =',hess(i)
*debug:      enddo
      CALL stpr_wrtsq (ITAP45,HESS,NAT3TR,IERR)
      IF(IERR.NE.0)GOTO 10
C
C     Write GRAD.
C
      CALL stpr_wrtsq (ITAP45,GRAD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 10
C
C     Write COORD.
C
      CALL stpr_wrtsq (ITAP45,COORD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 10
C
C     Write ENERGY.
C
      WRITE(ITAP45, ERR=10)ENERGY
#if defined(OPENCLOSE)
      close(unit=itap45,status='keep')
#endif
      RETURN
   10 CONTINUE
      IERR = 1
      RETURN
      end
      subroutine stpr_recall(HESS,GRAD,COORD,ENERGY,IERR)
*      ENTRY stpr_recall(HESS,GRAD,COORD,ENERGY,IERR)
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
#include "cstprfiles.fh"
      DIMENSION HESS(NAT3TR),
     &          GRAD(NAT3),
     &          COORD(3,NATOM)
      IERR = 0
#if defined(OPENCLOSE)
      OPEN (UNIT=ITAP45, FORM='UNFORMATTED', FILE=FILE45,
     &   ACCESS='SEQUENTIAL', STATUS='UNKNOWN',err=20)
      REWIND (UNIT=ITAP45)
#else
      REWIND ITAP45
#endif
C
C     Read HESS.
C
      CALL stpr_readsq (ITAP45,HESS,NAT3TR,IERR)
      IF(IERR.NE.0)GOTO 20
*debug:      write(6,*)'hess stpr_recall', nat3tr
*debug:      do i=1,nat3tr
*debug:        if (abs(hess(i)).gt.1.0d-5)
*debug:     &      write(6,*)' hess (',i,') =',hess(i)
*debug:      enddo
C
C     Read GRAD.
C
      CALL stpr_readsq (ITAP45,GRAD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 20
C
C     Read COORD.
C
      CALL stpr_readsq (ITAP45,COORD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 20
C
C     Read ENERGY.
C
      READ(ITAP45, END=20, ERR=20)ENERGY
#if defined(OPENCLOSE)
      close(unit=itap45,status='keep')
#endif
      RETURN
   20 CONTINUE
      IERR = 1
      RETURN
      END
C> @}

*
* $Id: fci_owalk_info.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_owalk_info(owalk, iocc, ns, ioff, numdet, sym)
      implicit none
#include "fciinfo.fh"
c     
c     Given the index of an orbital walk return the occupation, the 
c     offset in the CI determinant vector, the number of open shells
c     and the corresponding number of determinants, and the 
c     symmetry of the occupation.  
c     
c     The CI coefficients for this orbital occupation are addressed
c     as C(ioff+i) i=1,...,numdet.
c     
c     This routine bundles the function of several other routines
c     as a convenience.
c     
      integer owalk             ! [input]  Index of orbital occupation
      integer iocc(*)           ! [output] The orbital occupation pattern
      integer ns                ! [output] No. of open shells
      integer ioff              ! [output] Offset into CI vector
      integer numdet            ! [output] No. of determinants for this ns
      integer sym               ! [output] Symmetry 0...7
c     
      integer i
#include "bitops.fh"
c     
      if (owalk.lt.1 .or. owalk.gt.nwalko) call fci_err
     $     ('fci_owalk_info: bad owalk ', owalk)
c     
      call fci_ofind_occ(owalk, iocc)
      ns = 0
      sym = 0
      do i = 1, nactiv
         if (iocc(i) .eq. 2) then 
            ns = ns + 1
            sym = ieor(sym,orbsym(i))
         endif
      enddo
      numdet = mnsdet(ns)
      if (sym .eq. statesym) then
         ioff = indexo(owalk)
      else
         ioff = -999999999
      endif
c     
      end

C> \ingroup stpr_priv
C> @{
      subroutine stpr_select_grtdb(nat,rtdb,selbuf)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c::passed
      integer rtdb, nat
      integer selbuf(3,nat)
      external stpr_data ! For T3D linker
c
      if (.not.rtdb_get(rtdb,'stepper:select',MT_INT,(3*nat),selbuf))
     &    call errquit
     &    ('stpr_select_grtdb: rtdb_get failed',911, RTDB_ERR)
      end
      SUBROUTINE stpr_face (
     &     HESS, GRAD, COORD, CHARGE, SELECT, ATMASS,
     &     AMS, G, C, ETOT, TRUST, 
     &     ENERGY, CONVGE, CONVGG, CONVGGM, 
     &     NATD, NMODE,
     &     TRACK, BCKSTP, RPATH , rtdb, step_number)
c     
c     $Id: stpr_face.F 25540 2014-05-01 22:33:27Z d3y133 $
c     
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
#include "errquit.fh"
#include "util.fh"
      integer rtdb, him, kim, step_number, maxiter
      LOGICAL BCKSTP, TRACK, RPATH
      LOGICAL SECO, SWSEC, SWFIR
      LOGICAL SETM
      logical oselect, osetmass
c     CHARACTER LINE*7
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &     ITAP44, ITAP45
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      COMMON / SWITCH / SECO, SWSEC, SWFIR
      COMMON / THRESH / RCONVG,RSTD
      COMMON / MASS / TOTM, NUMAS
#include "mafdecls.fh"
#include "chow.fh"
      integer select
      logical oprint_info
      DIMENSION HESS(NAT3,NAT3), GRAD(NAT3), COORD(3,NATOM),
     &     CHARGE(NATOM), SELECT(NAT3), C(3,NATOM),
     &     ATMASS(NATOM), AMS(NUMAS), G(NATD*3)
C     
C     OMIN - minimization walk
C     TS - transition state walk
C     
C     STD - steepest descent walk
C     The step length (norm of the x vector) can not overpass RSTD
C     TROT and TRTR can enlarge the step length to the acceptable
C     RSTD limit
C     If they are false the STD step will be scaled down to RSTD
C     (if the step is too long) but it can not be scaled up
C     (if the step is shorter than RSTD)
C     TROT will allow scaling up in the region of a negative
C     NMODE eigenvalue
C     TRTR will allow scaling up along the whole walk
C     Using TRTR is dangerous since you can miss the minimum
C     
C     SECO - analytic second derivatives in the first step only
C     SWSEC - switch to second derivatives; then bomb
C     SWFIR - switch to first derivatives; then bomb
C     
C     Set default values.
C     
*     write(6,*)' nat3 = ',nat3
      oprint_info = util_print('information',print_low)
      oselect = .false.
      osetmass = .false.
      call stpr_set_defaults(OMIN,TS,STD,TROT,TRTR,MWC,SECO,SWFIR,
     &     SWSEC,RSTD,TRUSTC,TRUSTM,TRUST,NMODE,TRACK,RPATH,RCONVG,
     &     SETM,convggm,convgg,convge,maxiter)
      call stpr_load_rtdb(rtdb,omin,ts,std,trot,trtr,mwc,seco, swfir,
     &     swsec,track,rpath,setm,oselect,osetmass,nmode,rconvg,rstd,
     &     trustc, trustm, trust, convggm, convgg, convge, maxiter)
c     
      if (oselect) then
         call stpr_select_grtdb(natom,rtdb,select)
      endif
c     
      if(convggm.eq.0.0d0) CONVGGM=8.0D-4
      if(convgg .eq.0.0d0) CONVGG =1.0D-2
      if(convge .eq.0.0d0) CONVGE =1.0D-4
      AMUAU = (1.6605656D0/9.109534D0)*1.0D+04
      if (osetmass) then
         write(6,*)'  atomic number and masses read '
         call stpr_setmass_grtdb(natom,rtdb,him,kim,atmass)
         do 00003 i=1,natom
            if (atmass(i).eq.0.0d00) then
               if(int_mb((kim-1+i)).gt.numas) then
                  WRITE(6,*)'  Atomic number out of range. '
                  WRITE(6,*)'  Masses for atomic numbers .LE. ',
     &                 NUMAS,' only. '
                  WRITE(6,*)'  You must input the mass. '
                  call errquit('stepper:face fatal error',911,
     &       INPUT_ERR)
               endif
               atmass(i) = ams(int_mb((kim-1+i)))
            else
               atmass(i) = atmass(i)*amuau
            endif
00003    continue
         setm = .false.
         write(6,*)'  Atomic masses: '
         write(6,*) (atmass(i),i=1,natom)
         if(.not.MA_free_heap(him))
     &        call errquit
     &        ('stpr_face: failed to free dummy read array',911, MA_ERR)
         
      endif
      if (TS)  omin = .false.
      if (std) omin = .false.
c     
c     OMIN = .TRUE.
c     TS = .FALSE.
c     STD = .FALSE.
c     TROT = .FALSE.
c     TRTR = .FALSE.
c     MWC = .FALSE.
c     SECO = .FALSE.
c     SWFIR = .FALSE.
c     SWSEC = .FALSE.
c     RSTD = 5.D-02
c     TRUSTC = 0.1D0
c     TRUSTM = 5.D0
c     TRUST = 0.D0
c     NMODE = 0
c     TRACK = .FALSE.
c     RPATH = .FALSE.
c     RCONVG = 1.D-02
c     SETM = .TRUE.
c     
c     C
c     C     Read input.
c     C
c     CALL stpr_locate (ITAP05, '&STEPPER  ', IERROR)
c     IF (IERROR .EQ. 0) THEN
c     1   READ (ITAP05,'(A)',ERR=2,END=2) LINE
c     IF (LINE(1:4) .EQ. '&END') THEN
c     GO TO 2
c     ELSE IF (LINE(1:3) .EQ. 'MIN') THEN
c     OMIN = .TRUE.
c     WRITE(ITAP06,*)'  Keyword MIN found. '
c     WRITE(ITAP06,*)'  MIN = ',OMIN
c     ELSE IF (LINE(1:2) .EQ. 'TS') THEN
c     TS = .TRUE.
c     OMIN = .FALSE.
c     WRITE(ITAP06,*)'  Keyword TS found. '
c     WRITE(ITAP06,*)'  TS = ',TS
c     ELSE IF (LINE(1:3) .EQ. 'STD') THEN
c     STD = .TRUE.
c     OMIN = .FALSE.
c     WRITE(ITAP06,*)'  Keyword STD found. '
c     WRITE(ITAP06,*)'  STD = ',STD
c     ELSE IF (LINE(1:4) .EQ. 'RSTD') THEN
c     READ (ITAP05,*,END=2,ERR=2) RSTD
c     WRITE(ITAP06,*)'  Keyword RSTD found. '
c     WRITE(ITAP06,*)'  RSTD = ',RSTD
c     ELSE IF (LINE(1:4) .EQ. 'TROT') THEN
c     TROT = .TRUE.
c     WRITE(ITAP06,*)'  Keyword TROT found. '
c     WRITE(ITAP06,*)'  TROT = ',TROT
c     ELSE IF (LINE(1:4) .EQ. 'TRTR') THEN
c     TRTR = .TRUE.
c     WRITE(ITAP06,*)'  Keyword TRTR found. '
c     WRITE(ITAP06,*)'  TRTR = ',TRTR
c     ELSE IF (LINE(1:3) .EQ. 'MWC') THEN
c     MWC = .TRUE.
c     WRITE(ITAP06,*)'  Keyword MWC found. '
c     WRITE(ITAP06,*)'  MWC = ',MWC
c     ELSE IF (LINE(1:4) .EQ. 'SECO') THEN
c     SECO = .TRUE.
c     WRITE(ITAP06,*)'  Keyword SECO found. '
c     WRITE(ITAP06,*)'  SECO = ',SECO
c     ELSE IF (LINE(1:5) .EQ. 'SWSEC') THEN
c     SWSEC = .TRUE.
c     WRITE(ITAP06,*)'  Keyword SWSEC found. '
c     WRITE(ITAP06,*)'  SWSEC = ',SWSEC
c     ELSE IF (LINE(1:5) .EQ. 'SWFIR') THEN
c     SWFIR = .TRUE.
c     WRITE(ITAP06,*)'  Keyword SWFIR found. '
c     WRITE(ITAP06,*)'  SWFIR = ',SWFIR
c     ELSE IF (LINE(1:5) .EQ. 'TRUST') THEN
c     READ (ITAP05,*,END=2,ERR=2) TRUST
c     WRITE(ITAP06,*)'  Keyword TRUST found. '
c     WRITE(ITAP06,*)'  TRUST = ',TRUST
c     ELSE IF (LINE(1:5) .EQ. 'NMODE') THEN
c     READ (ITAP05,*,END=2,ERR=2) NMODE
c     WRITE(ITAP06,*)'  Keyword NMODE found. '
c     WRITE(ITAP06,*)'  NMODE = ',NMODE
c     ELSE IF (LINE(1:5) .EQ. 'TRACK') THEN
c     TRACK = .TRUE.
c     WRITE(ITAP06,*)'  Keyword TRACK found. '
c     WRITE(ITAP06,*)'  TRACK = ',TRACK
c     ELSE IF (LINE(1:6) .EQ. 'SELECT') THEN
c     READ (ITAP05,*,END=2,ERR=2) SELECT
c     WRITE(ITAP06,*)'  Keyword SELECT found. '
c     NMODE = 1
c     WRITE(ITAP06,*)'  SELECT: '
c     WRITE(6,1001)
c     DO 30 I = 1,NATOM
c     JSTART = 3*(I-1) + 1
c     JEND = JSTART + 2
c     WRITE(6,1002)I,(SELECT(J),J=JSTART,JEND)
c     30     CONTINUE
c     1001     FORMAT('  ATOM:',12x,'X',14x,'Y',14x,'Z')
c     1002     FORMAT('  ',I3,6X,3(1X,F14.10))
c     c          CALL stpr_matout(SELECT,3,NATOM,3)
c     ELSE IF (LINE(1:5) .EQ. 'RPATH') THEN
c     RPATH = .TRUE.
c     WRITE(ITAP06,*)'  Keyword RPATH found. '
c     ELSE IF (LINE(1:6) .EQ. 'RCONVG') THEN
c     READ (ITAP05,*,END=2,ERR=2) RCONVG
c     WRITE(ITAP06,*)'  Keyword RCONVG found. '
c     WRITE(ITAP06,*)'  RCONVG = ',RCONVG
c     ELSE IF (LINE(1:7) .EQ. 'SETMASS') THEN
c     WRITE(6,*)'  atomic number and masses read from',
c     &              ' standard in. '
c     DO 3 I = 1,NATOM
c     READ(ITAP05,*,ERR=2,END=2) IREAD,ATMASS(I)
c     write(6,*)'  atom ',i,' mass ',atmass(i)
c     IF(ATMASS(I).EQ.0.0D00) THEN
c     IF(IREAD.GT.NUMAS)THEN
c     WRITE(6,*)'  Atomic number out of range. '
c     WRITE(6,*)'  Masses for atomic numbers .LE. ',
c     &                            NUMAS,' only. '
c     WRITE(6,*)'  You must input the mass. '
c     call errquit('stepper:face fatal error',911)
c     ENDIF
c     ATMASS(I) = AMS(IREAD)
c     ELSE
c     ATMASS(I)=ATMASS(I)*AMUAU
c     ENDIF
c     3     CONTINUE
c     SETM = .FALSE.
c     write(6,*)'  Atomic masses: '
c     write(6,*) (atmass(i),i=1,natom)
c     END IF
c     GO TO 1
c     ELSE
c     c       WRITE (ITAP06,*)'  Label &STEPPER not found. '
c     c       WRITE (ITAP06,*)'  Default input used. '
c     ICNVG = -99
c     END IF
c     2 CONTINUE
      IF (MWC.AND.SETM) THEN
C     
C     Get charges
C     
c     DO 4 I = 1, NATOM
c     
c     no current need for mass weighted hess ... temp fix - jan.
c     
c     CHARGE(I) = ZAN(I)
c     4     CONTINUE
         WRITE(6,'(/A/)')
     +        ' Default masses from atomic number (charge) used. '
         DO 5 I = 1,NATOM
            IDUM = INT(CHARGE(I))
            ATMASS(I) = AMS(IDUM)
            WRITE(6,*)'  Atom ',I,' Mass ',ATMASS(I)
 5       CONTINUE
      ENDIF
      IF (MWC) THEN
C     
C     Calculate total mass.
C     
         TOTM = 0.D0
         DO 6 I = 1,NATOM
            TOTM = TOTM + ATMASS(I)
 6       CONTINUE
         WRITE(6,*)'  Total mass is ',TOTM,' a.u.'
      ENDIF
      IF (TRUST.EQ.0.D0) THEN
         IF (MWC) THEN
            TRUST=TRUSTM
         ELSE
            TRUST=TRUSTC
         ENDIF
      ENDIF
      if (oprint_info) then
         IF(TS)THEN
            WRITE(ITAP06,*)'  Step sought for transition state. '
         ELSE IF (OMIN) THEN
            WRITE(ITAP06,*)'  Step sought for minimum. '
         ELSE IF (STD) THEN
            WRITE(ITAP06,*)'  Finding steepest descent step. '
         ENDIF
      endif
      IF ((NMODE.NE.0).AND..NOT.(TS.OR.STD)) THEN
         WRITE(ITAP06,*)'  keyword TS or STD required. '
         call errquit('stepper:face fatal error',911, INPUT_ERR)
      ENDIF
      IF ((TS.OR.STD).AND.(NMODE.EQ.0)) THEN
         NMODE = 1
      ENDIF
      IF (STD) THEN
         TRACK = .TRUE.
      ENDIF
      IF (RPATH.AND.OMIN) THEN
         RPATH = .FALSE.
         WRITE(ITAP06,*)'  Keyword RPATH ignored. '
      ENDIF
C     
C     Get constants from SUPERMOLECULE or set here.
C     
C     
C     IWCTR = step counter.
C     
      IWCTR = IWCTR + 1
      step_number = iwctr
      if (step_number.ge.maxiter) step_number = -step_number
C     
C     ICALC = order of derivatives.
C     
      ICALC = 1
      IF(RPATH.AND.(ICALC.NE.2)) THEN
         RPATH = .FALSE.
         WRITE(ITAP06,*)'  Keyword RPATH ignored. '
      ENDIF
      IF (SECO.AND.(IWCTR.GT.1)) THEN
         SECO = .FALSE.
         WRITE(6,*)'  KEYWORD SECO IGNORED'
         IF ((ICALC.EQ.1).AND.SECO) THEN
            SECO = .FALSE.
            WRITE(6,*)'  KEYWORD SECO IGNORED'
         ENDIF
      ENDIF
      IF ((ICALC.EQ.1).AND.SWFIR) THEN
         SWFIR = .FALSE.
         WRITE(6,*)'  KEYWORD SWFIR IGNORED'
      ENDIF
      IF ((ICALC.EQ.2).AND.SWSEC) THEN
         SWSEC = .FALSE.
         WRITE(6,*)'  KEYWORD SWSEC IGNORED'
      ENDIF
      IF((SECO.AND.SWSEC).OR.(SECO.AND.SWFIR).OR.
     &     (SWSEC.AND.SWFIR)) THEN
         WRITE(6,*)'  TOO MANY SWITCHING KEYWORDS'
         call errquit('stepper:face fatal error',911, INPUT_ERR)
      ENDIF
C     
C     Get energy.
C     
      ENERGY = ETOT
      CALL stpr_wlkchk(ETOT,CONVGE,BCKSTP,NMODE)
      IF(BCKSTP)RETURN
C     
C     Get coordinates.
C     
      DO 8 I = 1, 3
         DO 7 N = 1, NATOM
            COORD(I,N) = C(I,N)
 7       CONTINUE
    8 CONTINUE
C     
C     Get gradients and if calculated, the analytic hessian.
C     
      DO 9 I = 1, NAT3
         GRAD(I) = G(I)
    9 CONTINUE
*      grad_max = dabsmax(nat3,grad)
*      write(6,*)' grad max in stpr_face ',grad_max
*      write(6,*)' grad ',(grad(i), i=1,nat3)
      IF (ICALC .EQ. 2) THEN
         WRITE(6,*)'  Second derivatives NOT available. '
         call errquit('stepper:face fatal error',911, INPUT_ERR)
C     
C     Check to make sure it is symmetric
C     
         CALL stpr_chkhess(HESS)
C     
C     Construct triangular hessian.
C     
         CALL stpr_mktri (HESS, HESS)
      ELSEIF (ICALC .EQ. 1) THEN
         if (oprint_info) then
            WRITE(6,*)'  Update Hessian used. '
         endif
      ELSE
         WRITE(6,*)'  Unknown calculation type. Program aborts. '
         call errquit('stepper:face fatal error',911, INPUT_ERR)
      END IF
      RETURN
      END
      subroutine stpr_set_defaults(OMIN,TS,STD,TROT,TRTR,MWC,SECO,
     &    SWFIR,SWSEC,RSTD,TRUSTC,TRUSTM,TRUST,NMODE,TRACK,RPATH,
     &    RCONVG,SETM,CONVGGM,CONVGG,CONVGE,maxiter)
c
      implicit none
      logical omin, ts, std, trot, trtr, mwc, seco, swfir, swsec
      logical track, rpath, setm
      integer nmode, maxiter
      double precision rconvg, rstd, trustc, trustm, trust
      double precision convggm, convgg, convge
c
      OMIN = .TRUE.
      TS = .FALSE.
      STD = .FALSE.
      TROT = .FALSE.
      TRTR = .FALSE.
      MWC = .FALSE.
      SECO = .FALSE.
      SWFIR = .FALSE.
      SWSEC = .FALSE.
      TRACK = .FALSE.
      RPATH = .FALSE.
      SETM = .TRUE.
c
      NMODE = 0
      maxiter = 20
c
      RCONVG = 1.0D-02
      RSTD   = 5.0D-02
      TRUSTC = 0.1D+00
      TRUSTM = 5.0D+00
      TRUST  = 0.0D+00
      convggm= 0.0d+00
      convgg = 0.0d+00
      convge = 0.0d+00
c
      end
      subroutine stpr_select_srtdb(nat,rtdb,selbuf)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c::passed
      integer rtdb, nat
      integer selbuf(3,nat)
c
      if (.not.rtdb_put(rtdb,'stepper:select',MT_INT,(3*nat),selbuf))
     &    call errquit
     &    ('stpr_select_srtdb: rtdb_put failed',911, RTDB_ERR)
      end
      subroutine stpr_setmass_srtdb(nat,rtdb,imass,xmass)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c::passed
      integer rtdb, nat
      integer imass(nat)
      double precision xmass(nat)
c
      if (.not.rtdb_put(rtdb,'stepper:setmass:int',MT_INT,nat,imass))
     &    call errquit
     &    ('stpr_setmass_srtdb: rtdb_put failed',911, RTDB_ERR)
      if (.not.rtdb_put(rtdb,'stepper:setmass:dbl',MT_DBL,nat,xmass))
     &    call errquit
     &    ('stpr_setmass_srtdb: rtdb_put failed',911, RTDB_ERR)
      end
      subroutine stpr_setmass_grtdb(nat,rtdb,himass,kimass,xmass)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c::passed
      integer rtdb, nat
      integer himass, kimass
      double precision xmass(nat)
c::local
      integer my_ma_type
      integer my_nat
c
      if (.not.rtdb_ma_get
     &    (rtdb,'stepper:setmass:int',my_ma_type,my_nat,himass))
     &    call errquit
     &    ('stpr_setmass_grtdb: rtdb_ma_get failed',911, RTDB_ERR)
      if(.not.((my_ma_type.eq.MT_INT).and.(my_nat.eq.nat))) then
        write(6,*)' my_ma_type .ne. MT_INT',my_ma_type,MT_INT
        write(6,*)' my_nat .ne. nat       ',my_nat, nat
        call errquit('stpr_setmass_grtdb: rtdb_ma_get failure',911,
     &       RTDB_ERR)
      endif
      if (.not.MA_get_index(himass,kimass))
     &    call errquit('stpr_setmass_grtdb: MA_get_index error',911,
     &       MA_ERR)
      if (.not.rtdb_get(rtdb,'stepper:setmass:dbl',MT_DBL,nat,xmass))
     &    call errquit
     &    ('stpr_setmass_grtdb: rtdb_get failed',911, RTDB_ERR)
      end
      subroutine stpr_store_rtdb(rtdb,omin,ts,std,trot,trtr,mwc,seco,
     &    swfir,
     &    swsec,track,rpath,setm,oselect,osetmass,nmode,rconvg, rstd,
     &    trustc, trustm, trust, convggm, convgg, convge, maxiter)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stpr_inP.fh"
c::passed
      integer rtdb
      logical omin,  ts,   std,     trot,  trtr
      logical mwc,   seco, swfir,   swsec, track
      logical rpath, setm, oselect, osetmass
      integer nmode, maxiter
      double precision rconvg, rstd, trustc, trustm, trust
      double precision convggm, convgg, convge
c::local
      integer hlog,klog,    hdbl,kdbl,  hint, kint
c
c allocate memory
c.. logs array 
      if(.not.MA_Push_Get(MT_LOG,ns_log,'stepper logs',hlog,klog))
     &    call errquit
     &    ('stpr_store_rtdb: push for logs failed?',911, MA_ERR)
c.. one one int no allocate now
      if(.not.MA_Push_get(MT_INT,ns_int,'stepper ints',hint,kint))
     &    call errquit
     &    ('stpr_store_rtdb: push for ints failed?',911, MA_ERR)
      if(.not.MA_Push_get(MT_DBL,ns_dbl,'stepper dbls',hdbl,kdbl))
     &    call errquit
     &    ('stpr_store_rtdb: push for dbls failed?',911, MA_ERR)
c
      log_mb( klog)       = omin ! OVERRIDDEN BELOW (see stpr_load_rtdb)
      log_mb((klog +  1)) = ts   ! OVERRIDDEN BELOW (see stpr_load_rtdb)
      log_mb((klog +  2)) = std
      log_mb((klog +  3)) = trot
      log_mb((klog +  4)) = trtr
      log_mb((klog +  5)) = mwc
      log_mb((klog +  6)) = seco
      log_mb((klog +  7)) = swfir
      log_mb((klog +  8)) = swsec
      log_mb((klog +  9)) = track
      log_mb((klog + 10)) = rpath
      log_mb((klog + 11)) = setm
      log_mb((klog + 12)) = oselect
      log_mb((klog + 13)) = osetmass
c
      int_mb(kint)    = nmode
      int_mb(kint+1)   = maxiter
c
      dbl_mb( kdbl) = rconvg
      dbl_mb((kdbl +  1)) = rstd
      dbl_mb((kdbl +  2)) = trustc
      dbl_mb((kdbl +  3)) = trustm
      dbl_mb((kdbl +  4)) = trust
      dbl_mb((kdbl +  5)) = convgg
      dbl_mb((kdbl +  6)) = convge
      dbl_mb((kdbl +  7)) = convggm
c
c     The values of stepper:ts and stepper:omin are also overriden by
c     task_optimize and task_saddle.
c
      if (.not.rtdb_put(rtdb,'stepper:ts',MT_LOG,1,ts))
     &    call errquit('stpr_store_rtdb: rtdb_put failed',911, RTDB_ERR)
c
      if (.not.rtdb_put(rtdb,'stepper:omin',MT_LOG,1,omin))
     &    call errquit('stpr_store_rtdb: rtdb_put failed',911, RTDB_ERR)
c
      if (.not.rtdb_put
     &    (rtdb,'stepper:logicalvals',MT_LOG,ns_log,log_mb(klog)))
     &    call errquit
     &    ('stpr_store_rtdb: rtdb_put failed',911, RTDB_ERR)
c
      if (.not.rtdb_put
     &    (rtdb,'stepper:integervals',MT_INT,ns_int,int_mb(kint)))
     &    call errquit
     &    ('stpr_store_rtdb: rtdb_put failed',911, RTDB_ERR)
c
      if (.not.rtdb_put
     &    (rtdb,'stepper:doublevals',MT_DBL,ns_dbl,dbl_mb(kdbl)))
     &    call errquit
     &    ('stpr_store_rtdb: rtdb_put failed',911, RTDB_ERR)
c
      if(.not.MA_Pop_Stack(hdbl))
     &    call errquit
     &    ('stpr_store_rtdb: error freeing hdbl',911, RTDB_ERR)
c
      if(.not.MA_Pop_Stack(hint))
     &    call errquit
     &    ('stpr_store_rtdb: error freeing hint',911, MA_ERR)
c
      if(.not.MA_Pop_Stack(hlog))
     &    call errquit
     &    ('stpr_store_rtdb: error freeing hlog',911, MA_ERR)
c
*      if(rtdb_print(rtdb,.true.))write(6,*)'store'
c
      end
      subroutine stpr_load_rtdb(rtdb,omin,ts,std,trot,trtr,mwc,seco,
     &    swfir,
     &    swsec,track,rpath,setm,oselect,osetmass,nmode,rconvg, rstd,
     &    trustc, trustm, trust, convggm, convgg, convge, maxiter)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stpr_inP.fh"
c::passed
      integer rtdb
      logical omin,  ts,   std,     trot,  trtr
      logical mwc,   seco, swfir,   swsec, track
      logical rpath, setm, oselect, osetmass
      integer nmode, maxiter
      double precision rconvg, rstd, trustc, trustm, trust
      double precision convggm, convgg, convge
c::local
      logical status
      integer hlog,klog,    hdbl,kdbl
      integer hint, kint
      integer my_ma_type, my_len
c
*      if(rtdb_print(rtdb,.true.))write(6,*)'load 1'
      status = rtdb_ma_get
     &    (rtdb,'stepper:logicalvals',my_ma_type,my_len,hlog)
c
c.. status=.false. ==> either no input or rtdb is corrupt
      if(.not.status) goto 00001
c
      if(.not.((my_ma_type.eq.MT_LOG).and.(my_len.eq.ns_log))) then
        write(6,*)' read type .ne. expected type ',my_ma_type,MT_LOG
        write(6,*)' read length .ne. expected    ',my_len,ns_log
        call errquit('stpr_load_rtdb: rtdb_ma_get fail',911,
     &       RTDB_ERR)
      endif
      if(.not.MA_get_index(hlog,klog))
     &    call errquit('stpr_load_rtdb: ma_get_index fail',911, MA_ERR)
*      if(rtdb_print(rtdb,.true.))write(6,*)'load 2'
c
c... currently only two integer input nmode/maxiter
      if(.not.rtdb_ma_get
     &    (rtdb,'stepper:integervals',my_ma_type,my_len,hint))
     &    call errquit
     &    ('stpr_load_rtdb:rtdb_ma_get failed',911, RTDB_ERR)
      if (.not.MA_get_index(hint,kint))
     &    call errquit('stpr_load_rtdb: ma_get_index fail',911, MA_ERR)
c
      if(.not.((my_ma_type.eq.MT_INT).and.(my_len.eq.ns_int)))then
        write(6,*)' read type .ne. expected type ',my_ma_type,MT_INT
        write(6,*)' read length .ne. expected    ',my_len,ns_int
        call errquit('stpr_load_rtdb: rtdb_ma_get fail',911, RTDB_ERR)
      endif
c
*      if(rtdb_print(rtdb,.true.))write(6,*)'load 3'
      if (.not.rtdb_ma_get
     &    (rtdb,'stepper:doublevals',my_ma_type,my_len,hdbl))
     &    call errquit
     &    ('stpr_load_rtdb: rtdb_ma_get failed',911, RTDB_ERR)
c
      if(.not.((my_ma_type.eq.MT_DBL).and.(my_len.eq.ns_dbl)))then
        write(6,*)' read type .ne. expected type ',my_ma_type,MT_DBL
        write(6,*)' read length .ne. expected    ',my_len,ns_dbl
        call errquit('stpr_load_rtdb: rtdb_ma_get fail',911, RTDB_ERR)
      endif
      if(.not.MA_get_index(hdbl,kdbl))
     &    call errquit('stpr_load_rtdb: ma_get_index fail',911,
     &       RTDB_ERR)
c
c
      if (.not.rtdb_get(rtdb,'stepper:ts',MT_LOG,1,ts))
     &    call errquit('stpr_load_rtdb: rtdb_put failed',911,
     &       RTDB_ERR)
c
      if (.not.rtdb_get(rtdb,'stepper:omin',MT_LOG,1,omin))
     &    call errquit('stpr_load_rtdb: rtdb_put failed',911,
     &       RTDB_ERR)
c
***   omin     = log_mb( klog)          ! NOW DONE INDIVIDUALLY
***   ts       = log_mb((klog +  1))    ! NOW DONE INDIVIDUALLY
      std      = log_mb((klog +  2)) 
      trot     = log_mb((klog +  3)) 
      trtr     = log_mb((klog +  4)) 
      mwc      = log_mb((klog +  5)) 
      seco     = log_mb((klog +  6)) 
      swfir    = log_mb((klog +  7)) 
      swsec    = log_mb((klog +  8)) 
      track    = log_mb((klog +  9)) 
      rpath    = log_mb((klog + 10)) 
      setm     = log_mb((klog + 11)) 
      oselect  = log_mb((klog + 12)) 
      osetmass = log_mb((klog + 13)) 
c
      nmode   = int_mb(kint)
      maxiter = int_mb(kint+1)
c
      rconvg = dbl_mb( kdbl) 
      rstd   = dbl_mb((kdbl +  1)) 
      trustc = dbl_mb((kdbl +  2)) 
      trustm = dbl_mb((kdbl +  3)) 
      trust  = dbl_mb((kdbl +  4)) 
      convgg = dbl_mb((kdbl +  5)) 
      convge = dbl_mb((kdbl +  6)) 
      convggm= dbl_mb((kdbl +  7)) 
c
c.... free heap memory
        if(.not.MA_free_heap(hdbl))
     &      call errquit
     &      ('stpr_load_rtdb: error freeing hdbl',911, MA_ERR)
c
        if(.not.MA_free_heap(hint))
     &      call errquit
     &      ('stpr_load_rtdb: error freeing hint',911, MA_ERR)
c
        if(.not.MA_free_heap(hlog))
     &      call errquit
     &      ('stpr_load_rtdb: error freeing hlog',911, MA_ERR)
c
00001 continue
c
      call util_flush(6)
c
      end
      block data stpr_data
      implicit none
      COMMON / CFACE / IWCTR,NATOM,ICALC
      integer iwctr, natom, icalc
c
      data iwctr /0/
      data natom /0/
      data icalc /0/
c
      end
C> @}

      subroutine scatter(n,a,indx,b)
*
* $Id: scatter.f 19707 2010-10-29 17:59:36Z d3y133 $
*
      integer n, indx(n)
      double precision a(*), b(n)
      integer i
      
      do i=1,n
        a(indx(i)) = b(i)
      enddo
      return
      end

      subroutine tce_eom_tidy
c
c $Id: tce_eom_tidy.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Delete files for trial and product vectors
c
      implicit none
#include "tce_diis.fh"
      integer i
c
      do i = 1,maxtrials
        if (xc1_exist(i))  call deletefile(xc1(i))
        if (xc2_exist(i))  call deletefile(xc2(i))
        if (xc3_exist(i))  call deletefile(xc3(i))
        if (xc4_exist(i))  call deletefile(xc4(i))
        if (yc1_exist(i))  call deletefile(yc1(i))
        if (yc2_exist(i))  call deletefile(yc2(i))
        if (yc3_exist(i))  call deletefile(yc3(i))
        if (yc4_exist(i))  call deletefile(yc4(i))
      enddo
      return
      end



      subroutine tce_eom_xtidy
c
c $Id: tce_eom_tidy.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Delete files for trial and product vectors
c
      implicit none
#include "tce_diis.fh"
      integer i
c
      do i = 1,maxtrials
        if (x1_exist(i))  call deletefile(x1(i))
        if (x2_exist(i))  call deletefile(x2(i))
        if (x3_exist(i))  call deletefile(x3(i))
        if (x4_exist(i))  call deletefile(x4(i))
        if (xp1_exist(i)) call deletefile(xp1(i))
        if (xp2_exist(i)) call deletefile(xp2(i))
        if (xp3_exist(i)) call deletefile(xp3(i))
        if (xp4_exist(i)) call deletefile(xp4(i))
      enddo
      return
      end



      subroutine tce_eom_ytidy
c
c $Id: tce_eom_tidy.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Delete files for trial and product vectors
c
      implicit none
#include "tce_diis.fh"
      integer i
c
      do i = 1,maxtrials
        if (y1_exist(i))  call deletefile(y1(i))
        if (y2_exist(i))  call deletefile(y2(i))
        if (y3_exist(i))  call deletefile(y3(i))
        if (y4_exist(i))  call deletefile(y4(i))
        if (yp1_exist(i)) call deletefile(yp1(i))
        if (yp2_exist(i)) call deletefile(yp2(i))
        if (yp3_exist(i)) call deletefile(yp3(i))
        if (yp4_exist(i)) call deletefile(yp4(i))
      enddo
      return
      end

*> \brief \b SORMHR
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SORMHR + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sormhr.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sormhr.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sormhr.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SORMHR( SIDE, TRANS, M, N, ILO, IHI, A, LDA, TAU, C,
*                          LDC, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          SIDE, TRANS
*       INTEGER            IHI, ILO, INFO, LDA, LDC, LWORK, M, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * ), C( LDC, * ), TAU( * ),
*      $                   WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SORMHR overwrites the general real M-by-N matrix C with
*>
*>                 SIDE = 'L'     SIDE = 'R'
*> TRANS = 'N':      Q * C          C * Q
*> TRANS = 'T':      Q**T * C       C * Q**T
*>
*> where Q is a real orthogonal matrix of order nq, with nq = m if
*> SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*> IHI-ILO elementary reflectors, as returned by SGEHRD:
*>
*> Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'L': apply Q or Q**T from the Left;
*>          = 'R': apply Q or Q**T from the Right.
*> \endverbatim
*>
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>          = 'N':  No transpose, apply Q;
*>          = 'T':  Transpose, apply Q**T.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix C. M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix C. N >= 0.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>
*>          ILO and IHI must have the same values as in the previous call
*>          of SGEHRD. Q is equal to the unit matrix except in the
*>          submatrix Q(ilo+1:ihi,ilo+1:ihi).
*>          If SIDE = 'L', then 1 <= ILO <= IHI <= M, if M > 0, and
*>          ILO = 1 and IHI = 0, if M = 0;
*>          if SIDE = 'R', then 1 <= ILO <= IHI <= N, if N > 0, and
*>          ILO = 1 and IHI = 0, if N = 0.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is REAL array, dimension
*>                               (LDA,M) if SIDE = 'L'
*>                               (LDA,N) if SIDE = 'R'
*>          The vectors which define the elementary reflectors, as
*>          returned by SGEHRD.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.
*>          LDA >= max(1,M) if SIDE = 'L'; LDA >= max(1,N) if SIDE = 'R'.
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is REAL array, dimension
*>                               (M-1) if SIDE = 'L'
*>                               (N-1) if SIDE = 'R'
*>          TAU(i) must contain the scalar factor of the elementary
*>          reflector H(i), as returned by SGEHRD.
*> \endverbatim
*>
*> \param[in,out] C
*> \verbatim
*>          C is REAL array, dimension (LDC,N)
*>          On entry, the M-by-N matrix C.
*>          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
*> \endverbatim
*>
*> \param[in] LDC
*> \verbatim
*>          LDC is INTEGER
*>          The leading dimension of the array C. LDC >= max(1,M).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The dimension of the array WORK.
*>          If SIDE = 'L', LWORK >= max(1,N);
*>          if SIDE = 'R', LWORK >= max(1,M).
*>          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*>          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
*>          blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realOTHERcomputational
*
*  =====================================================================
      SUBROUTINE SORMHR( SIDE, TRANS, M, N, ILO, IHI, A, LDA, TAU, C,
     $                   LDC, WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS
      INTEGER            IHI, ILO, INFO, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * ), C( LDC, * ), TAU( * ),
     $                   WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LEFT, LQUERY
      INTEGER            I1, I2, IINFO, LWKOPT, MI, NB, NH, NI, NQ, NW
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           ILAENV, LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SORMQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NH = IHI - ILO
      LEFT = LSAME( SIDE, 'L' )
      LQUERY = ( LWORK.EQ.-1 )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.LSAME( TRANS, 'T' ) )
     $          THEN
         INFO = -2
      ELSE IF( M.LT.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, NQ ) ) THEN
         INFO = -5
      ELSE IF( IHI.LT.MIN( ILO, NQ ) .OR. IHI.GT.NQ ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -8
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, NW ) .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF( LEFT ) THEN
            NB = ILAENV( 1, 'SORMQR', SIDE // TRANS, NH, N, NH, -1 )
         ELSE
            NB = ILAENV( 1, 'SORMQR', SIDE // TRANS, M, NH, NH, -1 ) 
         END IF
         LWKOPT = MAX( 1, NW )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SORMHR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. NH.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( LEFT ) THEN
         MI = NH
         NI = N
         I1 = ILO + 1
         I2 = 1
      ELSE
         MI = M
         NI = NH
         I1 = 1
         I2 = ILO + 1
      END IF
*
      CALL SORMQR( SIDE, TRANS, MI, NI, NH, A( ILO+1, ILO ), LDA,
     $             TAU( ILO ), C( I1, I2 ), LDC, WORK, LWORK, IINFO )
*
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of SORMHR
*
      END
c $Id: sormhr.f 24343 2013-06-22 05:35:15Z d3y133 $

*> \brief \b DLARFG generates an elementary reflector (Householder matrix).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLARFG + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlarfg.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlarfg.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlarfg.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLARFG( N, ALPHA, X, INCX, TAU )
* 
*       .. Scalar Arguments ..
*       INTEGER            INCX, N
*       DOUBLE PRECISION   ALPHA, TAU
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   X( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLARFG generates a real elementary reflector H of order n, such
*> that
*>
*>       H * ( alpha ) = ( beta ),   H**T * H = I.
*>           (   x   )   (   0  )
*>
*> where alpha and beta are scalars, and x is an (n-1)-element real
*> vector. H is represented in the form
*>
*>       H = I - tau * ( 1 ) * ( 1 v**T ) ,
*>                     ( v )
*>
*> where tau is a real scalar and v is a real (n-1)-element
*> vector.
*>
*> If the elements of x are all zero, then tau = 0 and H is taken to be
*> the unit matrix.
*>
*> Otherwise  1 <= tau <= 2.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the elementary reflector.
*> \endverbatim
*>
*> \param[in,out] ALPHA
*> \verbatim
*>          ALPHA is DOUBLE PRECISION
*>          On entry, the value alpha.
*>          On exit, it is overwritten with the value beta.
*> \endverbatim
*>
*> \param[in,out] X
*> \verbatim
*>          X is DOUBLE PRECISION array, dimension
*>                         (1+(N-2)*abs(INCX))
*>          On entry, the vector x.
*>          On exit, it is overwritten with the vector v.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>          The increment between elements of X. INCX > 0.
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is DOUBLE PRECISION
*>          The value tau.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup doubleOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE DLARFG( N, ALPHA, X, INCX, TAU )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      DOUBLE PRECISION   ALPHA, TAU
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            J, KNT
      DOUBLE PRECISION   BETA, RSAFMN, SAFMIN, XNORM
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH, DLAPY2, DNRM2
      EXTERNAL           DLAMCH, DLAPY2, DNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, SIGN
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSCAL
*     ..
*     .. Executable Statements ..
*
      IF( N.LE.1 ) THEN
         TAU = ZERO
         RETURN
      END IF
*
      XNORM = DNRM2( N-1, X, INCX )
*
      IF( XNORM.EQ.ZERO ) THEN
*
*        H  =  I
*
         TAU = ZERO
      ELSE
*
*        general case
*
         BETA = -SIGN( DLAPY2( ALPHA, XNORM ), ALPHA )
         SAFMIN = DLAMCH( 'S' ) / DLAMCH( 'E' )
         KNT = 0
         IF( ABS( BETA ).LT.SAFMIN ) THEN
*
*           XNORM, BETA may be inaccurate; scale X and recompute them
*
            RSAFMN = ONE / SAFMIN
   10       CONTINUE
            KNT = KNT + 1
            CALL DSCAL( N-1, RSAFMN, X, INCX )
            BETA = BETA*RSAFMN
            ALPHA = ALPHA*RSAFMN
            IF( ABS( BETA ).LT.SAFMIN )
     $         GO TO 10
*
*           New BETA is at most 1, at least SAFMIN
*
            XNORM = DNRM2( N-1, X, INCX )
            BETA = -SIGN( DLAPY2( ALPHA, XNORM ), ALPHA )
         END IF
         TAU = ( BETA-ALPHA ) / BETA
         CALL DSCAL( N-1, ONE / ( ALPHA-BETA ), X, INCX )
*
*        If ALPHA is subnormal, it may lose relative accuracy
*
         DO 20 J = 1, KNT
            BETA = BETA*SAFMIN
 20      CONTINUE
         ALPHA = BETA
      END IF
*
      RETURN
*
*     End of DLARFG
*
      END
c $Id: dlarfg.f 24343 2013-06-22 05:35:15Z d3y133 $

      logical function argos(irtdb0)
c
c $Id: argos.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "rtdb.fh"
#include "util.fh"
#include "mafdecls.fh"
#include "argos.fh"
c
      integer irtdb0
c
      irtdb=irtdb0
c
      call util_print_push
      call util_print_rtdb_load(irtdb,'argos')
c
      call timer_init()
c
      call argos_rdinp()
c
      call argos_start()
      call argos_main()
      call argos_finish()
c
      call util_print_pop
c
      argos=.true.
c
      return
      end

c
c     task quantum molecular dynamics
c
      logical function task_qmd(rtdb)
c
      implicit none
c
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
#include "stdio.fh"
c
      integer rtdb
c
      logical status
      double precision cpu,wall
c
      character*32 theory
      character*84 tag
      character*30 pname
c
      logical qmd_driver
      external qmd_driver
c
      pname = "task_qmd: "
c
c     start clock
      cpu  = util_cpusec()
      wall = util_wallsec()
c
c     invoke the qmd driver
      if (ga_nodeid().eq.0) write(luout,*) "calling qmd_driver"
      status = qmd_driver(rtdb)
c
c     stop clock
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - wall
c
      if (status) then
         if (.not. rtdb_put(rtdb, 'task:cputime', mt_dbl, 1, cpu))
     $     call errquit(pname//'failed storing cputime',0,RTDB_ERR)
         if (.not. rtdb_put(rtdb, 'task:walltime', mt_dbl, 1, wall))
     $     call errquit(pname//'failed storing walltime',0,RTDB_ERR)
      endif
c         
      task_qmd = status
c
      end
c $Id: task_qmd.F 24348 2013-06-23 04:29:20Z d3y133 $

      subroutine util_rtdb_speak(rtdb)
*
* $Id: util_rtdb_speak.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "inp.fh"
#include "util.fh"
      integer rtdb
c
      character*255 hostname
      integer port
c
      if (.not. rtdb_cget(rtdb,'speech:hostname',1,hostname))
     $     return
      if (.not. rtdb_get(rtdb,'speech:port',mt_int,1,port))
     $     return
c
      if (ga_nodeid() .gt. 0) return
c
      if (util_print('speech',print_low)) then
         write(6,1) hostname(1:inp_strlen(hostname)), port
 1       format(/'  Speech output at ',a,' port number',i6/)
         call util_flush(6)
      endif
c
      call util_speak_init(hostname, port)
c
      end

*
* $Id: cpsi_H.F 21578 2011-11-28 23:33:26Z bylaska $
*

*     **********************************************
*     *                                            *
*     *              cpsi_H                        *
*     *                                            *
*     **********************************************

      subroutine cpsi_H(ispin,ne,
     >                 psi_k_tag,psi_r_tag,vl,vc,xcp,Hpsi_k_tag,
     >                 move,fion)
      implicit none
      integer    ispin,ne(2)
      integer    psi_k_tag
      integer    psi_r_tag
      complex*16 vl(*)
      complex*16 vc(*)
      real*8     xcp(*)
      integer    Hpsi_k_tag
      logical    move
      real*8     fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      logical done,dohfx
      integer ms,n,n1(2),n2(2)
      integer nx,ny,nz
      integer ki,kj,nbi,nbj
      integer psi_shift,Hpsi_shift,Hpsir_shift,nshift1,nshift2
      real*8  scal1,scal2

*     **** tempory space ****
      integer nfft3d,npack0,nb,nbq,neall,nbrillq
      integer vall(2),vpsi(2),Hpsi_r_tag
      logical value


*     **** external functions ****
      logical  C3dB_rc_pfft3_queue_filled,band_HFX,band_HFX_relaxed
      integer  Pneb_nbrillq,Pneb_convert_nb
      integer  cpsi_data_get_chnk,cpsi_data_nsize,cpsi_data_alloc
      real*8   lattice_omega
      external C3dB_rc_pfft3_queue_filled,band_HFX,band_HFX_relaxed
      external Pneb_nbrillq,Pneb_convert_nb
      external cpsi_data_get_chnk,cpsi_data_nsize,cpsi_data_alloc
      external lattice_omega

      dohfx = (band_HFX().and.band_HFX_relaxed())

      call C3dB_nx(1,nx)
      call C3dB_ny(1,ny)
      call C3dB_nz(1,nz)
      call C3dB_nfft3d(1,nfft3d)
      call Cram_npack(0,npack0)

      scal2 = 1.0d0/lattice_omega()
      scal1 = 1.0d0/dble(nx*ny*nz)
      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)
      neall = ne(1) + ne(2)
      nbrillq = Pneb_nbrillq()
      nshift1 = cpsi_data_nsize(psi_r_tag)
      nshift2 = cpsi_data_nsize(Hpsi_k_tag)

      value = MA_push_get(mt_dcpl,nfft3d,'vall',vall(2),vall(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'vpsi',vpsi(2),vpsi(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      if (dohfx) then
         Hpsi_r_tag = cpsi_data_alloc(nbrillq,ne(1)+ne(2),2*nfft3d)
      end if
       

*     ****************************
*     **** add kinetic energy ****
*     ****************************
      call cke(ispin,ne,psi_k_tag,Hpsi_k_tag)

*     **************************
*     **** add non-local psp ***
*     **************************
      call cpsp_v_nonlocal(ispin,ne,psi_k_tag,Hpsi_k_tag,move,fion)
      call cpsp_v_spin_orbit(ispin,ne,psi_k_tag,Hpsi_k_tag,
     >  move,fion)

*     *******************************************************
*     **** HF exchange corrections- Hpsi_r = Vhfx*psi_r ****
*     *******************************************************
      if (dohfx) then
         call band_potential_HFX(ispin,psi_r_tag,Hpsi_r_tag)
      end if



*     **********************************************************
*     **** add up k-space potentials, vall = scal2*vl + vc  ****
*     **********************************************************
c      call Cram_c_SMul(0,scal2,vl,dcpl_mb(vall(1)))
c      call Cram_cc_Sum(0,dcpl_mb(vall(1)),vc,dcpl_mb(vall(1)))
      call dcopy(2*npack0,vc,1,dcpl_mb(vall(1)),1)
      call daxpy(2*npack0,scal2,vl,1,dcpl_mb(vall(1)),1)
      call Cram_c_unpack(0,dcpl_mb(vall(1)))

*     **********************************************
*     **** fourier transform k-space potentials ****
*     **********************************************
      call C3dB_cr_pfft3b(1,0,dcpl_mb(vall(1)))

      ki  = 1
      nbi = 1 
      psi_shift   = cpsi_data_get_chnk(psi_r_tag,nbi)
      if (dohfx) Hpsir_shift = cpsi_data_get_chnk(Hpsi_r_tag,nbi)

      kj  = 1
      nbj = 1 
      Hpsi_shift  = cpsi_data_get_chnk(Hpsi_k_tag,nbj)
      done = .false.
      do while (.not.done)
         if (nbi.le.nbrillq) then
            ms=1
            if (ki.gt.n2(1)) ms = 2

*           **** vpsi_r = (vall_r+xcp)*psi_r ****
            call C3dB_rc_Sum(1,
     >                       xcp(1+(ms-1)*nfft3d),
     >                       dcpl_mb(vall(1)),
     >                       dcpl_mb(vpsi(1)))
c            call C3dB_cc_Mul(1,dcpl_mb(vpsi(1)),
c     >                       dbl_mb(psi_shift),
c     >                       dcpl_mb(vpsi(1)))
            call C3dB_bb_Mul2c(1,dbl_mb(psi_shift),
     >                           dcpl_mb(vpsi(1)))

            if (dohfx)
     >         call C3dB_bb_Sum2(1,dbl_mb(Hpsir_shift),dcpl_mb(vpsi(1)))

*           **** get vpsi_r in k-space ****
            call C3dB_rc_pfft3f_queuein(nbi,dcpl_mb(vpsi(1)))

            psi_shift   = psi_shift   + nshift1
            if (dohfx) Hpsir_shift = Hpsir_shift + nshift1
            ki         = ki + 1
            if (ki.gt.neall) then
               nbi = nbi + 1
               ki  = 1
               if (nbi.le.nbrillq) then
                  psi_shift   = cpsi_data_get_chnk(psi_r_tag, nbi)
                  if (dohfx) 
     >               Hpsir_shift = cpsi_data_get_chnk(Hpsi_r_tag,nbi)
               endif
            end if
         end if

         if ((C3dB_rc_pfft3_queue_filled()).or.(nbi.gt.nbrillq)) then
            call C3dB_rc_pfft3f_queueout(nbj,dcpl_mb(vpsi(1)))

*           **** add to Hpsi_k ****
            call Cram_cc_daxpy(nbj,(-scal1),
     >                         dcpl_mb(vpsi(1)),
     >                         dbl_mb(Hpsi_shift))

            Hpsi_shift = Hpsi_shift + nshift2
            kj         = kj + 1
            if (kj.gt.neall) then
               nbj = nbj + 1
               kj  = 1
               if (nbj.le.nbrillq) then
                  Hpsi_shift   = cpsi_data_get_chnk(Hpsi_k_tag,nbj)
               endif
            end if

         end if

         done = ((nbi.gt.nbrillq).and.(nbj.gt.nbrillq))
      end do


      value = .true.
      if (dohfx) call cpsi_data_dealloc(Hpsi_r_tag)

      value = value.and.MA_pop_stack(vpsi(2))
      value = value.and.MA_pop_stack(vall(2))
      if (.not.value)
     >  call errquit('cpsi_H: error popping stack',0,MA_ERR)

      return
      end


*     *************************************
*     *                                   *
*     *             cpsi_Horb             *
*     *                                   *
*     *************************************
*
*  This routine calculates
*
*       Horb_k = KE*orb_k + Vnl*orb_k + + FFT[(vall+xcp)*orb_r]
*
*  where vall = iFFT[Vl+Vc]
*
*   Entry - ispin,ne            - spin and number of electrons in each spin
*           ms,n                - spin and electron number
*           orb_k,orb_r         - orbitals in k-space and r-space
*           vall                  - local +external fields+coulomb in r-space
*           xcp                 - xc potential in r-space
*   Exit - Horb_k - gradient in k-space
*
      subroutine cpsi_Horb(hfxon,nb,ispin,ms,
     >                     psi_r_tag,
     >                     vall,
     >                     orb_k,orb_r,
     >                     Horb_k)
      implicit none
      logical    hfxon
      integer    nb,ispin,ms
      integer    psi_r_tag
      complex*16 vall(*)
      complex*16 orb_k(*)
      complex*16 orb_r(*)
      complex*16 Horb_k(*)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      logical dohfx
      integer nx,ny,nz,npack1
      real*8  scal1

*     **** tempory space ****
      integer nfft3d,ne1,shiftk
      integer vpsi(2),Horb_r(2)
      logical value


*     **** external functions ****
      logical  band_HFX,band_HFX_relaxed
      integer  cpsi_ne
      real*8   lattice_omega
      logical  control_spin_orbit
      complex*16 zdotc
      external band_HFX,band_HFX_relaxed
      external lattice_omega
      external control_spin_orbit
      external zdotc,cpsi_ne


      dohfx = band_HFX().and.band_HFX_relaxed().and.hfxon

      if (control_spin_orbit()) then
        call cpsi_Horb2com(nb,ispin,ms,
     >                 vall,
     >                 orb_k,orb_r,
     >                 Horb_k)
        return
      end if

      ne1=cpsi_ne(1)
      call Cram_max_npack(npack1)
      call C3dB_nx(1,nx)
      call C3dB_ny(1,ny)
      call C3dB_nz(1,nz)
      call C3dB_nfft3d(1,nfft3d)

      value = MA_push_get(mt_dcpl,nfft3d,'vpsi',vpsi(2),vpsi(1))
      if (dohfx) then
         value = value.and.
     >          MA_push_get(mt_dcpl,nfft3d,'Horb_r',Horb_r(2),Horb_r(1))
         call dcopy(2*nfft3d,0.0d0,0,dbl_mb(Horb_r(1)),1)
      end if
      if (.not. value)
     >  call errquit('cpsi_Horb:out of stack memory',0, MA_ERR)


      shiftk=npack1*ne1
      scal1 = 1.0d0/dble(nx*ny*nz)
      
*     ************************************************
*     **** add kinetic energy - Horb_k = Ke*orb_k ****
*     ************************************************
      call cke_orb(nb,orb_k,Horb_k)


*     *********************************************************
*     **** add non-local psp - Horb_k = Horb_k + Vnl*orb_k ****
*     *********************************************************
      call cpsp_v_nonlocal_orb(nb,orb_k,Horb_k)


*     **********************
*     **** HFX energy   ****
*     **********************
      if (dohfx) then
         call band_potential_HFX_orb(nb,ms,
     >                               psi_r_tag,
     >                               orb_r,
     >                               dcpl_mb(Horb_r(1)))
      end if



*     **************************************************
*     **** Hpsi_k = Hpsi_k + FFT[vall_r+xcp)*orb_r] ****
*     **************************************************

*     **** vpsi_r = (vall_r)*orb_r ****
      call C3dB_bb_Mul(1,vall(1+(ms-1)*nfft3d),
     >                   orb_r,
     >                   dcpl_mb(vpsi(1)))

      if (dohfx)
     >   call C3dB_bb_Sum2(1,dcpl_mb(Horb_r(1)),
     >                      dcpl_mb(vpsi(1)))


*     **** put vpsi_r in k-space ****
      call C3dB_rc_pfft3f(1,nb,dcpl_mb(vpsi(1)))
      call Cram_c_pack(nb,dcpl_mb(vpsi(1)))

*     **** add to Horb_k ****
      call Cram_cc_daxpy(nb,(-scal1),
     >                   dcpl_mb(vpsi(1)),
     >                   Horb_k)

      value = .true.
      if (dohfx) value = value.and.MA_pop_stack(Horb_r(2))
      value = value.and.MA_pop_stack(vpsi(2))
      if (.not.value)
     >  call errquit('cpsi_Horb: popping stack',0,MA_ERR)

      return
      end

*     *************************************
*     *                                   *
*     *             cpsi_Horb2com         *
*     *                                   *
*     *************************************
*
*  This routine calculates
*
*       Horb_k = KE*orb_k + Vnl*orb_k + + FFT[(vall+xcp)*orb_r]
*
*  where vall = iFFT[Vl+Vc]
*
*   Entry - ispin,ne            - spin and number of electrons in each spin
*           ms,n                - spin and electron number
*           orb_k,orb_r         - orbitals in k-space and r-space
*           vall                  - local +external fields+coulomb in r-space
*           xcp                 - xc potential in r-space
*   Exit - Horb_k - gradient in k-space
*
      subroutine cpsi_Horb2com(nb,ispin,ms,
     >                 vall,
     >                 orb_k,orb_r,
     >                 Horb_k)
      implicit none
      integer    nb,ispin,ms
      complex*16 vall(*)
      complex*16 orb_k(*)
      complex*16 orb_r(*)
      complex*16 Horb_k(*)

#include "mafdecls.fh"
#include "errquit.fh"


*     **** local variables ****
      integer nx,ny,nz
      real*8  scal1

*     **** tempory space ****
      integer nfft3d,npack1,ne1,shiftr,shiftk
      integer vpsi(2)
      logical value


*     **** external functions ****
      real*8   lattice_omega
      integer  cpsi_ne
      external lattice_omega
      external cpsi_ne

      ne1=cpsi_ne(1)
      call Cram_max_npack(npack1)
      call C3dB_nx(1,nx)
      call C3dB_ny(1,ny)
      call C3dB_nz(1,nz)
      call C3dB_nfft3d(1,nfft3d)
      shiftr=ne1*nfft3d + 1
      shiftk=ne1*npack1 + 1

      value = MA_push_get(mt_dcpl,2*nfft3d,'vpsi',vpsi(2),vpsi(1))
      if (.not. value)
     >  call errquit('cpsi_Horb2com:out of stack memory',0, MA_ERR)


      scal1 = 1.0d0/dble(nx*ny*nz)
      
*     ************************************************
*     **** add kinetic energy - Horb_k = Ke*orb_k ****
*     ************************************************
      call cke_orb(nb,orb_k,Horb_k)


*     *********************************************************
*     **** add non-local psp - Horb_k = Horb_k + Vnl*orb_k ****
*     *********************************************************
      call cpsp_v_nonlocal_orb(nb,orb_k,Horb_k)

 
*     *********************************************************
*     **** add spin_orbit psp - Horb_k = Horb_k + Vso*orb_k ***
*     *********************************************************
      call cpsp_v_spin_orbit_orb(nb,orb_k,Horb_k)


*     **************************************************
*     **** Hpsi_k = Hpsi_k + FFT[vall_r+xcp)*orb_r] ****
*     **************************************************
*     **** vpsi_r = (vall_r)*orb_r ****
      call C3dB_bb_Mul(1,vall(1),
     >                   orb_r,
     >                   dcpl_mb(vpsi(1)))
      call C3dB_bb_Mul(1,vall(1+nfft3d),
     >                   orb_r(shiftr),
     >                   dcpl_mb(vpsi(1)+nfft3d))


*     **** put vpsi_r in k-space ****
      call C3dB_rc_pfft3f(1,nb,dcpl_mb(vpsi(1)))
      call Cram_c_pack(nb,dcpl_mb(vpsi(1)))

      call C3dB_rc_pfft3f(1,nb,dcpl_mb(vpsi(1)+nfft3d))
      call Cram_c_pack(nb,dcpl_mb(vpsi(1)+nfft3d))

*     **** add to Horb_k ****
      call Cram_cc_daxpy(nb,(-scal1),
     >                   dcpl_mb(vpsi(1)),
     >                   Horb_k)
      call Cram_cc_daxpy(nb,(-scal1),
     >                   dcpl_mb(vpsi(1)+nfft3d),
     >                   Horb_k(shiftk))


      value = MA_pop_stack(vpsi(2))
      if (.not.value)
     >  call errquit('psi_Horb2com: popping stack',1, MA_ERR)

      return
      end



*     ***************************************************
*     *                                                 *
*     *                 cpsi_H_vall                     *
*     *                                                 *
*     ***************************************************
      subroutine cpsi_H_vall(ispin,ne,psi_k_tag,psi_r_tag,vall,
     >                       Hpsi_k_tag)
      implicit none
      integer    ispin,ne(2)
      integer    psi_k_tag
      integer    psi_r_tag
      complex*16 vall(*)
      integer    Hpsi_k_tag

#include "errquit.fh"
#include "mafdecls.fh"

*     **** local variables ****
      integer ms,n,n1(2),n2(2)
      integer nx,ny,nz
      integer psi_shift,Hpsi_shift,nshift1,nshift2
      real*8  scal1,scal2,fion(3)

*     **** tempory space ****
      integer nfft3d,nb,nbq,nbrillq
      integer vpsi(2)
      logical value

*     **** external functions ****
      integer  Pneb_nbrillq,Pneb_convert_nb
      integer  cpsi_data_get_chnk,cpsi_data_nsize
      real*8   lattice_omega
      external Pneb_nbrillq,Pneb_convert_nb
      external cpsi_data_get_chnk,cpsi_data_nsize
      external lattice_omega
      

      call C3dB_nx(1,nx)
      call C3dB_ny(1,ny)
      call C3dB_nz(1,nz)
      call C3dB_nfft3d(1,nfft3d)
c      call Cram_max_npack(npack1)

      value = MA_push_get(mt_dcpl,nfft3d,'vpsi',vpsi(2),vpsi(1))
      if (.not.value) call errquit('cpsi_H_vall:out of stack',0,MA_ERR)
      

      scal2 = 1.0d0/lattice_omega()
      scal1 = 1.0d0/dble(nx*ny*nz)
      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)
      nbrillq = Pneb_nbrillq()
      nshift1 = cpsi_data_nsize(psi_r_tag)
      nshift2 = cpsi_data_nsize(Hpsi_k_tag)
       

*     ****************************
*     **** add kinetic energy ****
*     ****************************
      call cke(ispin,ne,psi_k_tag,Hpsi_k_tag)

*     **************************
*     **** add non-local psp ***
*     **************************
      call cpsp_v_nonlocal(  ispin,ne,psi_k_tag,Hpsi_k_tag,.false.,fion)
      call cpsp_v_spin_orbit(ispin,ne,psi_k_tag,Hpsi_k_tag,.false.,fion)

*     **************************************************
*     **** Hpsi_k = Hpsi_k + FFT[vall_r+)*psi_r]    ****
*     **************************************************
      do nbq=1,nbrillq
cccc         nb = Pneb_convert_nb(nbq)
         psi_shift  = cpsi_data_get_chnk( psi_r_tag,nbq)
         Hpsi_shift = cpsi_data_get_chnk(Hpsi_k_tag,nbq)
    
         do ms=1,ispin
         do n=n1(ms),n2(ms)

*           *************************************
*           **** vpsi_r = (vall_r)*psi_r ****
*           *************************************
            call C3dB_bb_Mul(1,vall(1+(ms-1)*nfft3d),
     >                         dbl_mb(psi_shift),
     >                         dcpl_mb(vpsi(1)))

*           *******************************
*           **** get vpsi_r in k-space ****
*           *******************************
            !call C3dB_rc_fft3f(1,dcpl_mb(vpsi(1)))
            call C3dB_rc_pfft3f(1,nbq,dcpl_mb(vpsi(1)))
            call Cram_c_pack(nbq,dcpl_mb(vpsi(1)))

*           ***********************
*           **** add to Hpsi_k ****
*           ***********************
            call Cram_cc_daxpy(nbq,(-scal1),
     >                         dcpl_mb(vpsi(1)),
     >                         dbl_mb(Hpsi_shift))

            psi_shift  = psi_shift  + nshift1
            Hpsi_shift = Hpsi_shift + nshift2
         end do
         end do
      end do

      value = MA_pop_stack(vpsi(2))
      if(.not.value) call errquit('cpsi_H_vall:popping stack',0,MA_ERR)

      return
      end

      Subroutine hf1mkr(Axyz,Bxyz,Cxyz,zan,exinv,ncenters,
     &                  alpha,Pxyz,RS,PC,ff,R,
     &                  R0,R0C,IJK,NPP,Lp,Lp3,CENTER)
c $Id: hf1mkr.f 19696 2010-10-29 16:53:42Z d3y133 $

      Implicit none
c::passed
      Integer ncenters                  ! number of nuclei
      Integer NPP                       ! number of primitive products
      Integer Lp                        ! angular momentum sum La+Lb+MXD
      Integer Lp3                       ! number of angular momentum functions
      Double precision Axyz(3),Bxyz(3)  ! Cartesian coordinates of centers 
      Double precision Cxyz(3,ncenters) ! Nuclear cartesian coordinates
      Double precision zan(ncenters)    ! Nuclear charges
      Double precision exinv(ncenters)  ! Nuclear inverse exponents
      Double precision alpha(2,NPP)     ! basis function exponents copy
      Double precision Pxyz(3,NPP)      ! coordinates of product center
      Double precision RS(NPP)          ! scale factor
      Double precision PC(NPP,3)        ! distance from product center to nucleus
      Double precision ff(2,NPP)        ! recursion factors
      Double precision R(NPP,0:Lp,Lp3)  ! R/R000j/RIKJj functions
      Double precision R0(NPP,Lp3)      ! R integrals
      Double precision R0C(ncenters,NPP,Lp3) ! R integrals per center
      integer IJK(0:Lp,0:Lp,0:Lp)       ! index array 
      Logical CENTER
c::local
      integer ic,j,m,n
      Double precision a,b,f1,f2,alpha_t,beta,PCx,PCy,PCz
      Double precision PI, PI4          ! pi, 4/pi
      Parameter (PI=3.1415926535898D0,PI4=4.D0/PI)
c
c Define the auxiliary function integrals necessary to compute the nuclear
c attraction integrals (NAIs). These integrals are scaled by an appropriate
c factor, RS, defined as
c
c         / a + b \ 1/2
c   RS = | ------- |
c         \  PI/4 /
c
c The scale factor for the Hermite expansion coefficients is assumed to be
c
c         /   PI  \ 3/2     /   a b   __2 \
c   ES = | ------- |    EXP| - -----  AB   |
c         \ a + b /         \  a + b      /
c
c Therefore,
c
c            2 PI        /   a b   __2 \
c   ES RS = -------  EXP| - -----  AB   |
c            a + b       \  a + b      /
c
c******************************************************************************

      do 101 m = 1,NPP
       do 100 j = 1,Lp3
        R0(m,j) = 0.D0
  100  continue
  101 continue

      do 110 m = 1,NPP

c Define the center "P".

       a = alpha(1,m)
       b = alpha(2,m)

       f1 = a/(a+b)
       f2 = b/(a+b)

       Pxyz(1,m) = f1*Axyz(1) + f2*Bxyz(1)
       Pxyz(2,m) = f1*Axyz(2) + f2*Bxyz(2)
       Pxyz(3,m) = f1*Axyz(3) + f2*Bxyz(3)

c Define the scaling factor.

       RS(m) = sqrt((a+b)*PI4)

  110 continue

c Sum over all centers.

      do 150 ic = 1,ncenters

       beta = exinv(ic)

c Define factors necessary to compute incomplete gamma function and the
c auxiliary functions.

       do 120 m = 1,NPP

        alpha_t = alpha(1,m) + alpha(2,m)
        alpha_t = alpha_t/(1.0d0+alpha_t*beta)

        ff(1,m) = RS(m)
        ff(2,m) = -2.D0*alpha_t

        PCx = Pxyz(1,m) - Cxyz(1,ic)
        PCy = Pxyz(2,m) - Cxyz(2,ic)
        PCz = Pxyz(3,m) - Cxyz(3,ic)

        R(m,0,1) = alpha_t*(PCx**2 + PCy**2 + PCz**2)

        PC(m,1) = PCx
        PC(m,2) = PCy
        PC(m,3) = PCz

  120  continue

c Evaluate the incomplete gamma function.

       call igamma(R,NPP,Lp)

c Scale for finite nuclear size if necessary

       if (beta .ne. 0.0D0) then
        do 125 m = 1,NPP
         alpha_t = sqrt(1.0d0+(alpha(1,m)+alpha(2,m))*beta)
         do 126 j=0,Lp
          R(m,j,1) = R(m,j,1)/alpha_t
  126    continue
  125   continue
       end if

c Define the initial auxiliary functions (i.e., R000j, j=1,Lr).

       do 135 j = 0,Lp
        do 130 m = 1,NPP
         R(m,j,1) = ff(1,m)*R(m,j,1)
         ff(1,m) = ff(1,m)*ff(2,m)
  130   continue
  135  continue

c Recursively build the remaining auxiliary functions (i.e., RIJKj, j=0).

       call hfmkr(R,IJK,PC,NPP,Lp,Lp3)

c Transfer to R0 array.

       if( CENTER )then
        do 141 n = 1,Lp3
         do 140 m = 1,NPP
          R0C(ic,m,n) = -zan(ic)*R(m,0,n)
          R0(m,n) = R0(m,n) + R0C(ic,m,n)
  140    continue
  141   continue
       else
        do 146 n = 1,Lp3
         do 145 m = 1,NPP
          R0(m,n) = R0(m,n) - zan(ic)*R(m,0,n)
  145    continue
  146   continue
       end if

  150 continue

      end

      subroutine argos_wrtime
c
      implicit none
c
#include "argos.fh"
#include "global.fh"
#include "msgids.fh"
c
      external timer_wall,timer_wall_total
      real*8 timer_wall,timer_wall_total
c
      integer i,j
      real*8 tim(56,1024)
c
      do 1 i=1,np
      do 2 j=1,56
      tim(j,i)=zero
    2 continue
    1 continue
c
      do 3 i=1,55
      tim(i,me+1)=timer_wall_total(i)
      tim(56,me+1)=tim(56,me+1)+tim(i,me+1)
    3 continue
c
      call ga_dgop(mrg_d04,tim,56*np,'+')
c
      if(me.eq.0) then
      write(lfntim,1000) stime
 1000 format('timings',/,f12.6)
      do 1002 j=1,np
      write(lfntim,1001) (tim(i,j),i=1,56)
 1001 format(10f7.3)
 1002 continue
      endif
c
      return
      end
c $Id: argos_wrtime.F 21176 2011-10-10 06:35:49Z d3y133 $

#define NBLOCKS 4


*
* $Id: D1dB.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************************************
*     *								*
*     *   		   D1dB library				*
*     *			(MPI implemenation)			*
*     *								*
*     *   Author - Eric Bylaska					*
*     *   date   - 3/23/96					*
*     *								*
*     ***********************************************************

*	The D1dB (distributed one-dimensional block) library is to 
* be used for handling three kinds of data structures.  The first 
* data structure, denoted by "r", is a double precision array of
* length (nx(nb)+2)*ny(nb)*nz.  The second data structure, denoted by "c", is
* a double complex array of length of (nx(nb)/2+1)*ny(nb)*nz.  The third data

* (nx(nb)/2+1)*ny(nb)*nz.
*
*	The data structures is distributed across threads, p, in
* the k (i.e. nz(nb)) dimension using a cyclic decomposition.  So that
* a "r" array A is defined as double precision A(nx(nb)+2,ny(nb),nq(nb)) on
* each thread.  
*
*	Where 
*		np = number of threads
*		nq(nb) = ceil(nz(nb)/np).
*		0 <= p < np
*		1 <= q <= nq(nb)
*		1 <= k <= nz(nb)
* 
* 	The mapping of k -> q is defined as:
*	
*		k = ((q-1)*np + p) + 1
*		q = ((k-1) - p)/np + 1
*		p = (k-1) mod np
*
*  Libraries used: mpi, blas, fftpack, and compressed_io
*
*  common blocks used in this library:
*
*       integer nq,nz(NBLOCKS)
*	common	/ D3dB / nq,nz

*     **** local variables ****

*     ***********************************
*     *					*
*     *	       Mapping1d_init		*	
*     *					*
*     ***********************************

      subroutine Mapping1d_init(nb)
      implicit none
      integer nb
     
#include "mafdecls.fh"
#include "errquit.fh"
#include "D1dB.fh"


      integer k,q,p
*     integer kn
      integer taskid
      logical value
      
c      call Parallel2d_np_j(np_j)
      call Parallel2d_taskid_j(taskid)


*     **** allocate q_map,p_map,k_map
      value = MA_alloc_get(mt_int,nz(nb),'q_map',q_map(2,nb),
     >                                       q_map(1,nb))
      value = value.and.MA_alloc_get(mt_int,nz(nb),'p_map',p_map(2,nb),
     >                                       p_map(1,nb))
      value = value.and.MA_alloc_get(mt_int,nz(nb),'k_map',k_map(2,nb),
     >                                       k_map(1,nb))
      value = value.and.MA_alloc_get(mt_int,np_j,'nqarray',
     >                               nqarray(2,nb),nqarray(1,nb))
      if (.not. value)
     > call errquit('Mapping_init:out of heap memory',0, MA_ERR)


*     ****************************
*     ****** Cyclic Mapping ******
*     ****************************
      if (mapping.eq.0) then
         p = 0
         q = 1
         do k=1,nz(nb)
            int_mb(q_map(1,nb)+k-1) = q
            int_mb(p_map(1,nb)+k-1) = p
            if (p .eq. taskid) nq(nb) = q

            p = p+1
            if (p .ge. np_j) then
               p = 0
               q = q + 1
            end if
         end do

*     ***********************
*     **** block mapping ****
*     ***********************
      else

         do p=0,np_j-1
           int_mb(nqarray(1,nb)+p) = 0
         end do

         p = 0
         do k=1,nz(nb)
           int_mb(nqarray(1,nb)+p) = int_mb(nqarray(1,nb)+p) + 1
           p = mod(p+1,np_j)
         end do

         k = 1
         do p=0,np_j-1
           do q=1,int_mb(nqarray(1,nb)+p)
              int_mb(q_map(1,nb)+k-1) = q
              int_mb(p_map(1,nb)+k-1) = p
              k = k + 1
           end do
         end do

         nq(nb) = int_mb(nqarray(1,nb)+taskid)

      end if
      !*** probably not needed!! ****
      do k=1,nz(nb)
         if (int_mb(p_map(1,nb)+k-1) .eq. taskid) then
            int_mb(k_map(1,nb)+int_mb(q_map(1,nb)+k-1)-1) = k
         end if
      end do

      return
      end

*     ***********************************
*     *					*
*     *	          D1dB_end   		*	
*     *					*
*     ***********************************
      subroutine D1dB_end(nb)
      implicit none
      integer nb

#include "mafdecls.fh"
#include "errquit.fh"
#include "D1dB.fh"


      logical value

      value =.true.
      value = value.and.MA_free_heap(q_map(2,nb))
      value = value.and.MA_free_heap(p_map(2,nb))
      value = value.and.MA_free_heap(k_map(2,nb))
      value = value.and.MA_free_heap(nqarray(2,nb))
      
      if (.not. value)
     > call errquit('D1dB_end:freeing heap memory',0, MA_ERR)

      return
      end
         
*     ***********************************
*     *					*
*     *	          D1dB_qtok   		*	
*     *					*
*     ***********************************

      subroutine D1dB_qtok(nb,q,k)      
      implicit none
      integer nb
      integer q,k

#include "mafdecls.fh"
#include "D1dB.fh"

      k = int_mb(k_map(1,nb)+q-1)
      return
      end

*     ***********************************
*     *					*
*     *	          D1dB_ktoqp  		*	
*     *					*
*     ***********************************

      subroutine D1dB_ktoqp(nb,k,q,p)      
      implicit none
      integer nb
      integer k,q,p

#include "mafdecls.fh"
#include "D1dB.fh"

      q = int_mb(q_map(1,nb)+k-1)
      p = int_mb(p_map(1,nb)+k-1)
      return
      end



*     ***********************************
*     *					*
*     *	        D1dB_nq			*	
*     *					*
*     ***********************************

      subroutine D1dB_nq(nb,nqtmp)
      implicit none
      integer nb
      integer nqtmp

#include "D1dB.fh"


      nqtmp = nq(nb)
      return 
      end


*     ***********************************
*     *					*
*     *	        D1dB_nz			*	
*     *					*
*     ***********************************

      subroutine D1dB_nz(nb,nztmp)
      implicit none
      integer nb
      integer nztmp

#include "D1dB.fh"
    
      nztmp = nz(nb)
      return
      end



*     ***********************************
*     *					*
*     *	        D1dB_init		*	
*     *					*
*     ***********************************

      subroutine D1dB_init(nb,nz_in,map_in)
      implicit none
      integer nb
      integer nz_in
      integer map_in

#include "D1dB.fh"

      !**** local variables ****
      integer MASTER
      parameter (MASTER=0)
      integer taskid

      call Parallel2d_np_j(np_j)
      call Parallel_taskid(taskid)


      !**** Make sure ngrid is consistent with mapping ***
      if (np_j.gt.nz_in) then
          if (taskid.eq.MASTER) then
            write(6,*) 'Error: for 1d decomposition the',
     >                 ' number of columns (np_j processors) must ',
     >                 ' be in the range ( 1 ...nz=',
     >                   nz_in,')'
          end if
          call errquit('D1dB_init: mapping error',0,0)
      end if

*     ***** initialize D1dB common block *****
      nz(nb)     = nz_in
      mapping    = map_in

*     **** do other initializations ****
      call Mapping1d_init(nb)
      
      return
      end

      double precision function tce_ccsd_asym_polar(
     &  irrep_a1,d_a1,k_a1_offset,irrep_b1,
     &  d_t1,k_t1_offset,d_t2,k_t2_offset,
     &  d_y1,k_y1_offset,d_y2,k_y2_offset,
     &  d_tr1,k_tr1_offset,d_tr2,k_tr2_offset,
     &  d_yr1,k_yr1_offset,d_yr2,k_yr2_offset)
c
c $Id: tce_ccsd_asym_polar.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "sf.fh"
#include "inp.fh"
#include "errquit.fh"
#include "tce.fh"
c#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
c#include "tce_amps.fh"
c#include "tce_diis.fh"
c
c     CI, CC, & MBPT
c
      integer iter,maxiter
      integer irrep_g
      integer d_a1,k_a1_offset,irrep_a1,irrep_b1
      integer d_a0                ! Dipole polarizability component handle
      integer l_a0_offset         ! Offset for a0 file
      integer k_a0_offset         ! Offset for a0 file
      integer size_a0             ! File size in doubles
      integer d_yr1             ! SF handle for yr1 amplitudes
      integer k_yr1_offset      ! Offset for yr1 file
      integer size_yr1          ! File size in doubles
      integer d_yr2             ! SF handle for yr2 amplitudes
      integer k_yr2_offset      ! Offset for yr2 file
      integer size_yr2          ! File size in doubles
      integer d_yrr1            ! SF handle for yrr1 amplitudes
      integer d_yrr2            ! SF handle for yrr2 amplitudes
      integer d_tr1             ! SF handle for tr1 amplitudes
      integer k_tr1_offset      ! Offset for tr1 file
      integer size_tr1          ! File size in doubles
      integer d_tr2             ! SF handle for tr2 amplitudes
      integer k_tr2_offset      ! Offset for tr2 file
      integer size_tr2          ! File size in doubles
      integer d_rr1             ! SF handle for rr1 amplitudes
      integer d_rr2             ! SF handle for rr2 amplitudes
      integer d_o1
      integer k_o1_offset
      integer size_o1
      integer d_f1             ! SF handle for MO 1e integrals
      integer k_f1_offset      ! Offset for 1e integral file
      integer size_1e          ! File size in doubles
      integer d_v2             ! SF handle for MO 2e integrals
      integer k_v2_offset      ! Offset for 2e integral file
      integer size_2e          ! File size in doubles
      integer d_t1             ! SF handle for t1 amplitudes
      integer k_t1_offset      ! Offset for t1 file
      integer size_t1          ! File size in doubles
      integer d_t2             ! SF handle for t2 amplitudes
      integer k_t2_offset      ! Offset for t2 file
      integer size_t2          ! File size in doubles
      integer d_y1             ! Lambda 1 file
      integer d_y2             ! Lambda 2 file
      integer k_y1_offset      ! Offset for Lambda 1 file
      integer size_y1          ! File size in doubles
      integer k_y2_offset      ! Offset for Lambda 2 file
      integer size_y2          ! File size in doubles
      logical nodezero
      double precision cpu
      double precision wall
      double precision omega
      double precision alpha0,alpha1,alpha2!,alpha3,alpha4,alpha5,alpha6
      external ddotfile
      character*255 filename
      character*20 title
      character*4 irrepname
      nodezero=(ga_nodeid().eq.0)
      cpu=-util_cpusec()
      wall=-util_wallsec()
      alpha1=0.0d0
      alpha2=0.0d0
c      alpha3=0.0d0
c      alpha4=0.0d0
c      alpha5=0.0d0
c      alpha6=0.0d0
      irrep_g=0
c
      call tce_e_offset(l_a0_offset,k_a0_offset,size_a0)
#if defined(DEBUG_PRINT)
        if(nodezero) write(LuOut,*) 'l_a0_offset = ',l_a0_offset
#endif
      call tce_filename('a0',filename)
      call createfile(filename,d_a0,size_a0)
c
      irrep_d=irrep_a1
      irrep_tr=irrep_b1
      irrep_y=irrep_g
c
      call alpha_1(d_a1,d_a0,d_t1,d_t2,d_tr1,d_tr2,
     2     d_y1,d_y2,k_a1_offset,k_a0_offset,
     4     k_t1_offset,k_t2_offset,k_tr1_offset,
     5     k_tr2_offset,k_y1_offset,k_y2_offset)
      call reconcilefile(d_a0,size_a0)
      call get_block(d_a0,alpha1,1,0)
      call tce_zero(d_a0,size_a0)
c
      irrep_o=irrep_a1
      irrep_y=irrep_b1
c
      call alpha_2_yr(d_a0,d_a1,d_t1,d_t2,d_yr1,d_yr2,
     2     k_a0_offset,k_a1_offset,k_t1_offset,
     3     k_t2_offset,k_yr1_offset,k_yr2_offset)
      call reconcilefile(d_a0,size_a0)
      call get_block(d_a0,alpha2,1,0)
      call tce_zero(d_a0,size_a0)
c
      alpha0=(-0.5d0)*(alpha1+alpha2)
      call deletefile(d_a0)
c
      cpu=cpu+util_cpusec()
      wall=wall+util_wallsec()
#if defined(DEBUG_PRINT)
      if (nodezero) write(LuOut,9020) cpu, wall
#endif
      if (.not.ma_pop_stack(l_a0_offset))
     1     call errquit("tce_ccsd_asym_polar: MA problem",
     2                  l_a0_offset,MA_ERR)
      tce_ccsd_asym_polar=alpha0
      return
c
c     ======
c     Format
c     ======
c
 9000 format(1x,A,' file size   = ',i16)
 9010 format(1x,A,' file name   = ',A)
 9090 format(1x,A,' file handle = ',i10)
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9480 format(1x,'Cpu & wall time / sec for ',A,2f15.1)
      end

      SUBROUTINE YGEBAL( JOB, N, A, LDA, ILO, IHI, SCALE, INFO )
c $Id: ygebal.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      implicit none
#include "y64.fh"
      CHARACTER          JOB
      INTEGER            IHI, ILO, INFO, LDA, N
      DOUBLE PRECISION   A( LDA, * ), SCALE( * )
c
      INTGR4            IHI4, ILO4, INFO4, LDA4, N4      
c
      LDA4=lda
      N4=n
c
      call DGEBAL( JOB, N4, A, LDA4, ILO4, IHI4, SCALE,INFO4)
      IHI=ihi4
      ILO=ilo4
c
      info4=info
      return
      end

c
c $Id: chg_case.f 19707 2010-10-29 17:59:36Z d3y133 $
c
      SUBROUTINE chg_case(char)

      implicit none

      integer upper_to_lower

      character*1 char

      upper_to_lower=iachar("a")-iachar("A")

      if("a"<=char.and.char<="z")then
        char=ACHAR(IACHAR(char)-upper_to_lower)
      endif

      return

      END

      logical function pre_mktop(lfnout,title,nparms,mparms,
     + lfnseq,filseq,lfntop,filtop,lfnsgm,lfnpar,
     + lfnmod,filmod,lfnmat,lfnhdb,lfnhop,filhop,
     + lfnbsg,filbsg,ignore,slvnam,itopol,icomb)
c
c $Id: pre_mktop.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     in : integer lfnout    = logical file number output file
c          char*80 ffield    = force field from [amber]
c          integer lfnseq    = logical file number for seq file
c          char*80 filseq    = file name of seq file
c          integer lfntop    = logical file number for top file
c          char*80 filtop    = file name of top file
c          integer lfnsgm    = logical file number for sgm file
c
      implicit none
c
#include "mafdecls.fh"
#include "util.fh"
#include "pre_common.fh"
c
      logical pre_seqsiz,pre_rdseq,pre_term,pre_dimens,pre_mklist
      external pre_seqsiz,pre_rdseq,pre_term,pre_dimens,pre_mklist
      logical pre_params,pre_natyps,pre_wrttop,pre_third,pre_excl
      external pre_params,pre_natyps,pre_wrttop,pre_third,pre_excl
      logical pre_nonbon,pre_modify
      external pre_nonbon,pre_modify
c
      integer lfnout,lfnseq,lfntop,lfnsgm,lfnpar,lfnmod,ignore,lfnmat
      integer lfnhdb,lfnhop,lfnbsg
      integer nparms,mparms,itopol,icomb
      character*80 title(2,3)
      character*255 filseq,filtop,filmod,filhop,filbsg
      character*3 slvnam
c
      integer mseq,nseq
      integer l_lseq,i_lseq,l_cseq,i_cseq
c
      integer mlnk,nlnk
      integer l_llnk,i_llnk,l_clnk,i_clnk
c
      integer matm,natm
      integer l_latm,i_latm,l_catm,i_catm,l_qatm,i_qatm
c
      integer mbnd,nbnd
      integer l_lbnd,i_lbnd,l_rbnd,i_rbnd
c
      integer mang,nang
      integer l_lang,i_lang,l_rang,i_rang
c
      integer mdih,ndih
      integer l_ldih,i_ldih,l_kdih,i_kdih,l_rdih,i_rdih,l_ndih,i_ndih
c
      integer mimp,nimp
      integer l_limp,i_limp,l_rimp,i_rimp,l_kimp,i_kimp
c
      integer matt,natt,mats,nats
      integer l_latt,i_latt,l_catt,i_catt,l_patt,i_patt,l_ratt,i_ratt
      integer l_lats,i_lats
c
      integer nval
      integer l_ival,i_ival,l_rval,i_rval,l_ndx,i_ndx
c
      integer m3rd,n3rd
      integer i_l3rd,l_l3rd
c
      integer mexc,nexc
      integer i_lexc,l_lexc
c
      integer mnon,nnon
      integer i_lnon,l_lnon
c
      integer natmt,nbndt,nangt,ndiht,nimpt,n3rdt,mqu
c
      real*8 releps,q14fac,wcorr(10)
c
      logical lupdat
c
      real*8 timer_wall_total
      external timer_wall_total
c
      lupdat=.false.
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1000)
 1000 format('TOPOLOGY GENERATION')
      endif
c
      call timer_init()
      if(.not.pre_seqsiz(lfnout,lfnseq,filseq,nseq,nlnk))
     + call md_abort('pre_seqsize failed',9999)
c
      mseq=nseq+2
      mlnk=nlnk+1
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1001) nseq
 1001 format('sequence length is',i10)
      endif
c
c     allocate memory for sequence
c     ----------------------------
c
c     integer lseq(1,mseq) : number of sequence entry
c                  2       : link type
c                  3       : index of first atom of sequence entry
c                  4       : molecule number
c
      if(.not.ma_push_get(mt_int,6*mseq,'lseq',l_lseq,i_lseq))
     + call md_abort('Memory allocation failed for lseq',9999)
c
c     char*5  cseq(1,mseq) : name of sequence entry on pdb
c                  2       : name of sequence entry on top
c
      if(.not.ma_push_get(mt_byte,10*mseq,'cseq',l_cseq,i_cseq))
     + call md_abort('Memory allocation failed for cseq',9999)
c
c     allocate memory for link list
c     -----------------------------
c
c     integer llnk(1,mlnk) : link segment 1
c                  2       : link segment 2
c                  3       : link type : 0: normal
c                                        1: forced
c     char*4  clnk(1,mlnk) : link segment 1 atom name
c                  2       : link segment 2 atom name
c
      if(.not.ma_push_get(mt_int,3*mlnk,'llnk',l_llnk,i_llnk))
     + call md_abort('Memory allocation failed for llnk',9999)
      if(.not.ma_push_get(mt_byte,8*mlnk,'clnk',l_clnk,i_clnk))
     + call md_abort('Memory allocation failed for clnk',9999)
c
c     read the sequence file
c     ----------------------
c
      if(.not.pre_rdseq(lfnout,lfnseq,filseq,
     + int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,
     + int_mb(i_llnk),byte_mb(i_clnk),mlnk,nlnk))
     + call md_abort('pre_rdseq failed',9999)
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1002)
 1002 format('sequence is read')
      endif
c
c     determine termini
c     -----------------
c
      if(.not.pre_term(lfnout,lfnsgm,
     + int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,
     + int_mb(i_llnk),byte_mb(i_clnk),mlnk,nlnk))
     + call md_abort('pre_term failed',9999)
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1003)
 1003 format('termini are determined')
      endif
c
c     determine array dimensions
c     --------------------------
c
      if(.not.pre_dimens(lfnout,lfnsgm,
     + int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,
     + natm,nbnd,nang,ndih,nimp,nparms))
     + call md_abort('pre_dimens failed',9999)
      mparms=nparms+1
c
c     adjust dimension to account for links
c     -------------------------------------
c
      matm=natm+1
      mbnd=nbnd+3*nseq+1
      mang=nang+27*nseq+1
      mdih=ndih+45*nseq+1
      mimp=nimp+6*nseq+1
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1004) mseq,matm,mbnd,mang,mdih,mimp
 1004 format('list dimensions are determined:',/,
     + ' number of segments  ',i10,/,
     + ' number of atoms     ',i10,/,
     + ' number of bonds     ',i10,/,
     + ' number of angles    ',i10,/,
     + ' number of dihedrals ',i10,/,
     + ' number of impropers ',i10)
      endif
c
c     allocate memory for atomic lists
c     --------------------------------
c
c     integer latm(1,matm)   : charge group
c                  2         : polarization group
c                  3         : link number
c                  4         : center type
c                  5         : segment number
c                  6         : molecule number
c                  7         : atomic number
c                  8         : fraction
c                  9         : ???
c
c
c     char*6  catm(  1,matm) : atom name 
c                  i+1       : atom type set i, i=1,nparms
c
      if(.not.ma_push_get(mt_int,11*matm,'latm',l_latm,i_latm))
     + call md_abort('Memory allocation failed for latm',9999)
      if(.not.ma_push_get(mt_byte,6*mparms*matm,'catm',l_catm,i_catm))
     + call md_abort('Memory allocation failed for catm',9999)
c
c     real*8 qatm(nparms,1,matm) : partial atomic charges sets 1,..,nparms
c                        2       : polarizabilities sets 1,..,nparms
c
      mqu=3*matm
      if(.not.ma_push_get(mt_dbl,2*nparms*mqu,'qatm',l_qatm,i_qatm))
     + call md_abort('Memory allocation failed for qatm',9999)
c
c     allocate memory for bonded lists
c     --------------------------------
c
c     integer lbnd(1:2,mbnd)        : bond indices
c                  3                : parameter source
c                  4                : constraint type
c     real*8  rbnd(nparms,1,mbnd)   : bond length set 1
c                         2         : force constant set 1
c
      if(.not.ma_push_get(mt_int,4*mbnd,'lbnd',l_lbnd,i_lbnd))
     + call md_abort('Memory allocation failed for lbnd',9999)
      if(.not.ma_push_get(mt_dbl,2*nparms*mbnd,'rbnd',l_rbnd,i_rbnd))
     + call md_abort('Memory allocation failed for rbnd',9999)
c
c     integer lang(1:3,mang)        : angle indices
c                  4                : parameter source
c                  5                : constraint type
c     real*8  rang(nparms,1,mang)   : angle set 1
c                         2         : force constant set 1
c
      if(.not.ma_push_get(mt_int,5*mang,'lang',l_lang,i_lang))
     + call md_abort('Memory allocation failed for lang',9999)
      if(.not.ma_push_get(mt_dbl,4*nparms*mang,'rang',l_rang,i_rang))
     + call md_abort('Memory allocation failed for rang',9999)
c
c     integer ldih(1:4,mdih) : torsion indices
c                  5         : parameter source
c                  6         : constraint type
c
c     integer nfdih(nparms,mdih) : number of functions
c
c     integer kdih(6,nparms,mdih) : multiplicity set 1
c
c     real*8  rdih(6,nparms,1,mdih) : phase angle set 1
c                           2       : force constant set 1
c
      if(.not.ma_push_get(mt_int,6*mdih,'ldih',l_ldih,i_ldih))
     + call md_abort('Memory allocation failed for ldih',9999)
      if(.not.ma_push_get(mt_int,nparms*mdih,'nfdih',l_ndih,i_ndih))
     + call md_abort('Memory allocation failed for ldih',9999)
      if(.not.ma_push_get(mt_int,6*nparms*mdih,'kdih',l_kdih,i_kdih))
     + call md_abort('Memory allocation failed for ldih',9999)
      if(.not.ma_push_get(mt_dbl,12*nparms*mdih,'rdih',l_rdih,i_rdih))
     + call md_abort('Memory allocation failed for rdih',9999)
c
c     integer limp(1:4,mimp) : improper torsion indices
c                  5         : parameter source
c                  6         : constraint type
c
c     integer kimp(nparms,mimp) : multiplicity
c
c     real*8  rimp(nparms,1,mimp)   : phase angle set 1
c                         2         : force constant set 1
c
      if(.not.ma_push_get(mt_int,6*mimp,'limp',l_limp,i_limp))
     + call md_abort('Memory allocation failed for limp',9999)
      if(.not.ma_push_get(mt_int,nparms*mimp,'kimp',l_kimp,i_kimp))
     + call md_abort('Memory allocation failed for limp',9999)
      if(.not.ma_push_get(mt_dbl,2*nparms*mimp,'rimp',l_rimp,i_rimp))
     + call md_abort('Memory allocation failed for rimp',9999)
c
c     generate the atomic and bonded lists
c     ------------------------------------
c
      natm=0
      nbnd=0
      nang=0
      ndih=0
      nimp=0
c
      nval=max(mbnd,mang,mdih,mimp,1)
      if(.not.ma_push_get(mt_int,nval,'ival',l_ival,i_ival))
     + call md_abort('Memory allocation failed for ival',9999)
      if(.not.ma_push_get(mt_int,nval,'ndx',l_ndx,i_ndx))
     + call md_abort('Memory allocation failed for ndx',9999)
      if(.not.ma_push_get(mt_dbl,nval,'rval',l_rval,i_rval))
     + call md_abort('Memory allocation failed for rval',9999)
      if(.not.pre_mklist(lfnout,lfnsgm,lfnmat,nparms,mparms,
     + int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,
     + int_mb(i_llnk),byte_mb(i_clnk),mlnk,nlnk,
     + int_mb(i_latm),byte_mb(i_catm),dbl_mb(i_qatm),matm,natm,
     + int_mb(i_lbnd),dbl_mb(i_rbnd),mbnd,nbnd,
     + int_mb(i_lang),dbl_mb(i_rang),mang,nang,
     + int_mb(i_ldih),int_mb(i_ndih),int_mb(i_kdih),
     + dbl_mb(i_rdih),mdih,ndih,
     + int_mb(i_limp),int_mb(i_kimp),dbl_mb(i_rimp),mimp,nimp,
     + natmt,nbndt,nangt,ndiht,nimpt,wcorr,
     + nval,int_mb(i_ival),dbl_mb(i_rval),int_mb(i_ndx),itopol))
     + call md_abort('pre_mklist failed',9999)
      if(.not.ma_pop_stack(l_rval))
     + call md_abort('Memory deallocation failed for rval',9999)
      if(.not.ma_pop_stack(l_ndx))
     + call md_abort('Memory deallocation failed for ndx',9999)
      if(.not.ma_pop_stack(l_ival))
     + call md_abort('Memory deallocation failed for ival',9999)
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1005)
 1005 format('lists are generated')
      endif
c
c     apply topology modifications to atom types
c     ------------------------------------------
      if(.not.pre_modify(1,lfnout,lfnmod,filmod,nparms,mparms,
     + int_mb(i_latm),byte_mb(i_catm),dbl_mb(i_qatm),matm,natm,
     + int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,
     + int_mb(i_lbnd),dbl_mb(i_rbnd),mbnd,nbnd,nbndt,
     + int_mb(i_lang),dbl_mb(i_rang),mang,nang,nangt,
     + int_mb(i_ldih),int_mb(i_ndih),int_mb(i_kdih),
     + dbl_mb(i_rdih),mdih,ndih,ndiht,
     + int_mb(i_limp),int_mb(i_kimp),dbl_mb(i_rimp),mimp,nimp,nimpt,
     + lupdat))
     + call md_abort('pre_modify failed',9999)
c
c     get number of atom types
c     ------------------------
c
      if(.not.pre_natyps(lfnout,nparms,mparms,
     + byte_mb(i_catm),matm,natmt,natt,nats))
     + call md_abort('pre_natyps failed',9999)
      matt=natt
      mats=nats
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1006) natt
 1006 format(' Number of atom types is ',i10)
      endif
c
c     allocate memory for atom type lists
c     -----------------------------------
c
      if(.not.ma_push_get(mt_int,3*matt,'latt',l_latt,i_latt))
     + call md_abort('Memory allocation failed for latt',9999)
      if(.not.ma_push_get(mt_int,nparms*mats,'lats',l_lats,i_lats))
     + call md_abort('Memory allocation failed for lats',9999)
      if(.not.ma_push_get(mt_byte,36*matt,'catt',l_catt,i_catt))
     + call md_abort('Memory allocation failed for catt',9999)
      if(.not.ma_push_get(mt_dbl,12*matt*matt,'patt',l_patt,i_patt))
     + call md_abort('Memory allocation failed for patt',9999)
      if(.not.ma_push_get(mt_dbl,3*matt,'ratt',l_ratt,i_ratt))
     + call md_abort('Memory allocation failed for ratt',9999)
c
c     substitute force field parameters
c     ---------------------------------
c
      if(.not.pre_params(lfnpar,lfnout,nparms,mparms,
     + releps,q14fac,ignore,
     + int_mb(i_latm),byte_mb(i_catm),matm,natmt,
     + int_mb(i_lbnd),dbl_mb(i_rbnd),mbnd,nbndt,
     + int_mb(i_lang),dbl_mb(i_rang),mang,nangt,
     + int_mb(i_ldih),int_mb(i_ndih),int_mb(i_kdih),
     + dbl_mb(i_rdih),mdih,ndiht,
     + int_mb(i_limp),int_mb(i_kimp),dbl_mb(i_rimp),mimp,nimpt,
     + int_mb(i_latt),int_mb(i_lats),byte_mb(i_catt),dbl_mb(i_patt),
     + dbl_mb(i_ratt),matt,natt,mats,nats,
     + int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,icomb))
     + call md_abort('pre_params failed',9999)
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1007)
 1007 format('force field parameters are substituted')
      endif
c
c     allocate memory for third neighbor list
c     ---------------------------------------
c
      m3rd=6*mang
      n3rd=0
      if(.not.ma_push_get(mt_int,2*m3rd,'l3rd',l_l3rd,i_l3rd))
     + call md_abort('Memory allocation failed for l3rd',9999)
      nval=max(m3rd,matm,1)
      if(.not.ma_push_get(mt_int,nval,'ival',l_ival,i_ival))
     + call md_abort('Memory allocation failed for ival',9999)
      if(.not.ma_push_get(mt_int,nval,'ndx',l_ndx,i_ndx))
     + call md_abort('Memory allocation failed for ndx',9999)
c
c     construct third neighbor list
c     -----------------------------
c
      if(.not.pre_third(int_mb(i_lbnd),mbnd,nbnd,int_mb(i_lang),
     + mang,nang,int_mb(i_l3rd),m3rd,n3rd,1,1,1,
     + nval,int_mb(i_ival),int_mb(i_ndx),matm))
     + call md_abort('pre_third failed',9999)
c
      n3rdt=n3rd
      if(nbndt.gt.nbnd.and.nangt.gt.nang) then
      if(.not.pre_third(int_mb(i_lbnd),mbnd,nbndt,int_mb(i_lang),
     + mang,nangt,int_mb(i_l3rd),m3rd,n3rdt,nbnd+1,nang+1,n3rd+1,
     + nval,int_mb(i_ival),int_mb(i_ndx),matm))
     + call md_abort('pre_third failed',9999)
      endif
      if(.not.ma_pop_stack(l_ndx))
     + call md_abort('Memory deallocation failed for ndx',9999)
      if(.not.ma_pop_stack(l_ival))
     + call md_abort('Memory deallocation failed for ival',9999)
c
      if(util_print('topology',print_high)) then
      write(lfnout,1008) n3rd
 1008 format(' Solute third neighbor list length is',i10)
      endif
c
c     allocate memory for excluded pair list
c     --------------------------------------
c
      mexc=n3rd+nbnd+nang+300
      nexc=0
      if(.not.ma_push_get(mt_int,2*mexc,'lexc',l_lexc,i_lexc))
     + call md_abort('Memory allocation failed for lexc',9999)
c
c     construct excluded pair list
c     ----------------------------
c
      nval=max(mexc,1)
      if(.not.ma_push_get(mt_int,nval,'ival',l_ival,i_ival))
     + call md_abort('Memory allocation failed for ival',9999)
      if(.not.ma_push_get(mt_int,nval,'ndx',l_ndx,i_ndx))
     + call md_abort('Memory allocation failed for ndx',9999)
      if(.not.pre_excl(int_mb(i_l3rd),m3rd,n3rd,int_mb(i_lbnd),
     + mbnd,nbnd,int_mb(i_lang),mang,nang,int_mb(i_lexc),mexc,nexc,
     + nval,int_mb(i_ival),int_mb(i_ndx),byte_mb(i_catt),matt,
     + int_mb(i_lats),nparms,mats,int_mb(i_latm),matm,natm,lupdat))
     + call md_abort('pre_excl failed',9999)
      if(.not.ma_pop_stack(l_ndx))
     + call md_abort('Memory deallocation failed for ndx',9999)
      if(.not.ma_pop_stack(l_ival))
     + call md_abort('Memory deallocation failed for ival',9999)
c
      if(util_print('topology',print_high)) then
      write(lfnout,1009) nexc
 1009 format(' Solute excluded pair list length is',i10)
      endif
c
c     allocate memory for solvent non-bonded list
c     -------------------------------------------
c
      mnon=max(1,(natmt-natm)*(natmt-natm))
      nnon=0
      if(.not.ma_push_get(mt_int,2*mnon,'lnon',l_lnon,i_lnon))
     + call md_abort('Memory allocation failed for lnon',9999)
c
c     construct solvent non-bonded list
c     ---------------------------------
c
      if(.not.pre_nonbon(natm+1,natmt,int_mb(i_lbnd),mbnd,nbnd+1,nbndt,
     + int_mb(i_lang),mang,nang+1,nangt,
     + int_mb(i_l3rd),m3rd,n3rd+1,n3rdt,
     + int_mb(i_lnon),mnon,nnon))
     + call md_abort('pre_nonbon failed',9999)
c
      if(util_print('topology',print_high)) then
      write(lfnout,1010) nnon
 1010 format(' Solvent non-bonded list length is',i10)
      endif
c
c     apply topology modifications to bonded parameters
c     -------------------------------------------------
c
      if(.not.pre_modify(2,lfnout,lfnmod,filmod,nparms,mparms,
     + int_mb(i_latm),byte_mb(i_catm),dbl_mb(i_qatm),matm,natm,
     + int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,
     + int_mb(i_lbnd),dbl_mb(i_rbnd),mbnd,nbnd,nbndt,
     + int_mb(i_lang),dbl_mb(i_rang),mang,nang,nangt,
     + int_mb(i_ldih),int_mb(i_ndih),int_mb(i_kdih),
     + dbl_mb(i_rdih),mdih,ndih,ndiht,
     + int_mb(i_limp),int_mb(i_kimp),dbl_mb(i_rimp),mimp,nimp,nimpt,
     + lupdat))
     + call md_abort('pre_modify failed',9999)
c
c     write the topology file
c     -----------------------
c
      if(.not.pre_wrttop(lfnout,title,lfntop,filtop,lfnhdb,
     + lfnhop,filhop,lfnbsg,filbsg,releps,q14fac,
     + nparms,mparms,int_mb(i_lseq),byte_mb(i_cseq),mseq,nseq,mqu,
     + int_mb(i_latt),int_mb(i_lats),byte_mb(i_catt),dbl_mb(i_patt),
     + dbl_mb(i_ratt),matt,natt,mats,nats,int_mb(i_latm),
     + byte_mb(i_catm),
     + dbl_mb(i_qatm),matm,natm,int_mb(i_lbnd),dbl_mb(i_rbnd),mbnd,
     + nbnd,int_mb(i_lang),
     + dbl_mb(i_rang),mang,nang,int_mb(i_ldih),int_mb(i_ndih),
     + int_mb(i_kdih),dbl_mb(i_rdih),mdih,ndih,
     + int_mb(i_limp),int_mb(i_kimp),dbl_mb(i_rimp),mimp,nimp,
     + int_mb(i_l3rd),
     + m3rd,n3rd,int_mb(i_lexc),mexc,nexc,int_mb(i_lnon),mnon,nnon,
     + natmt,nbndt,nangt,ndiht,nimpt,n3rdt,wcorr,slvnam,itopol))
     + call md_abort('pre_wrttop failed',9999)
c
      if(util_print('topology',print_debug)) then
      write(lfnout,1011)
 1011 format(' Topology file is written')
      endif
c
c     deallocate memory
c     -----------------
c
      if(.not.ma_pop_stack(l_lnon))
     + call md_abort('Memory deallocation failed for lnon',9999)
      if(.not.ma_pop_stack(l_lexc))
     + call md_abort('Memory deallocation failed for lexc',9999)
      if(.not.ma_pop_stack(l_l3rd))
     + call md_abort('Memory deallocation failed for l3rd',9999)
      if(.not.ma_pop_stack(l_ratt))
     + call md_abort('Memory deallocation failed for ratt',9999)
      if(.not.ma_pop_stack(l_patt))
     + call md_abort('Memory deallocation failed for patt',9999)
      if(.not.ma_pop_stack(l_catt))
     + call md_abort('Memory deallocation failed for catt',9999)
      if(.not.ma_pop_stack(l_lats))
     + call md_abort('Memory deallocation failed for lats',9999)
      if(.not.ma_pop_stack(l_latt))
     + call md_abort('Memory deallocation failed for latt',9999)
      if(.not.ma_pop_stack(l_rimp))
     + call md_abort('Memory deallocation failed for rimp',9999)
      if(.not.ma_pop_stack(l_kimp))
     + call md_abort('Memory deallocation failed for limp',9999)
      if(.not.ma_pop_stack(l_limp))
     + call md_abort('Memory deallocation failed for limp',9999)
      if(.not.ma_pop_stack(l_rdih))
     + call md_abort('Memory deallocation failed for rdih',9999)
      if(.not.ma_pop_stack(l_kdih))
     + call md_abort('Memory deallocation failed for kdih',9999)
      if(.not.ma_pop_stack(l_ndih))
     + call md_abort('Memory deallocation failed for ldih',9999)
      if(.not.ma_pop_stack(l_ldih))
     + call md_abort('Memory deallocation failed for ldih',9999)
      if(.not.ma_pop_stack(l_rang))
     + call md_abort('Memory deallocation failed for rang',9999)
      if(.not.ma_pop_stack(l_lang))
     + call md_abort('Memory deallocation failed for lang',9999)
      if(.not.ma_pop_stack(l_rbnd))
     + call md_abort('Memory deallocation failed for rbnd',9999)
      if(.not.ma_pop_stack(l_lbnd))
     + call md_abort('Memory deallocation failed for lbnd',9999)
      if(.not.ma_pop_stack(l_qatm))
     + call md_abort('Memory deallocation failed for qatm',9999)
      if(.not.ma_pop_stack(l_catm))
     + call md_abort('Memory deallocation failed for catm',9999)
      if(.not.ma_pop_stack(l_latm))
     + call md_abort('Memory deallocation failed for latm',9999)
      if(.not.ma_pop_stack(l_clnk))
     + call md_abort('Memory deallocation failed for clnk',9999)
      if(.not.ma_pop_stack(l_llnk))
     + call md_abort('Memory deallocation failed for llnk',9999)
      if(.not.ma_pop_stack(l_cseq))
     + call md_abort('Memory deallocation failed for cseq',9999)
      if(.not.ma_pop_stack(l_lseq))
     + call md_abort('Memory deallocation failed for lseq',9999)
c
      pre_mktop=.true.
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
       subroutine output (z,rowlow,rowhi,collow,colhi,rowdim,coldim,
     $     nctl)
c.......................................................................
c output prints a real*8 matrix in formatted form with numbered rows
c and columns.  the input is as follows;
c        matrix(*,*).........matrix to be output
c        rowlow..............row number at which output is to begin
c        rowhi...............row number at which output is to end
c        collow..............column number at which output is to begin
c        colhi...............column number at which output is to end
c        rowdim..............row dimension of matrix(*,*)
c        coldim..............column dimension of matrix(*,*)
c        nctl................carriage control flag; 1 for single space
c                                                   2 for double space
c                                                   3 for triple space
c the parameters that follow matrix are all of type integer*4.  the
c program is set up to handle 5 columns/page with a 1p5d24.15 format for
c the columns.  if a different number of columns is required, change
c formats 1000 and 2000, and initialize kcol with the new number of
c columns.
c author;  nelson h.f. beebe, quantum theory project, university of
c          florida, gainesville
c.......................................................................
C$Id: output.F,v 1.1 2005/03/08 23:58:03 d3g293 Exp $
      implicit double precision (a-h,o-z)
#include "mafdecls.fh"
#include "global.fh"
      integer rowlow,rowhi,collow,colhi,rowdim,coldim,begin,kcol
      dimension z(rowdim,coldim)
      dimension asa(3)
      data column/8hcolumn   /,asa/8h          ,8h00000000  ,
     1     8h--------  /,blank/8h          /
      data kcol/8/
      data zero/0.d00/
      if (ga_nodeid().ne.0) return
      do 11 i=rowlow,rowhi
         do 10 j=collow,colhi
            if (z(i,j).ne.zero) go to 15
 10      continue
 11   continue
      write (6,3000)
 3000 format (/' zero matrix'/)
      go to 3
 15   continue
      if (rowhi.lt.rowlow) go to 3
      if (colhi.lt.collow) go to 3
      last = min0(colhi,collow+kcol-1)
      do 2 begin = collow,colhi,kcol
         write (6,1000) (column,i,i = begin,last)
         do 1 k = rowlow,rowhi
            do 4 i=begin,last
               if (z(k,i).ne.zero) go to 5
 4          continue
            go to 1
c
5       write (6,2000) k,(z(k,i), i = begin,last)               

 1       continue
         last = min0(last+kcol,colhi)
 2    continue
 3    return
 1000 format (/11x,7(a3,i3,3x),(a3,i3)) 
 2000 format ('row',i4,1x,8f9.4) 
      end

      subroutine argos_cafe_rgib(lfngib,dera,dec,dlambd)
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      integer lfngib
      real*8 dera(6,nsatot),dec(6,nsatot),dlambd
c
      integer i,j
c
      if(me.eq.0) then
      read(lfngib,1000) ((dera(i,j),i=1,6),j=1,nsatot)
 1000 format(4e20.10)
      do 1 i=1,nsatot
      do 2 j=1,6
      dec(j,i)=dec(j,i)+dlambd*dera(j,i)
    2 continue
    1 continue
      else
      do 3 i=1,nsatot
      do 4 j=1,6
      dera(j,i)=zero
    4 continue
    3 continue
      endif
c
      return
      end
c $Id: argos_cafe_rgib.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b DORGHR
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DORGHR + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dorghr.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dorghr.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dorghr.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DORGHR( N, ILO, IHI, A, LDA, TAU, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            IHI, ILO, INFO, LDA, LWORK, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DORGHR generates a real orthogonal matrix Q which is defined as the
*> product of IHI-ILO elementary reflectors of order N, as returned by
*> DGEHRD:
*>
*> Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix Q. N >= 0.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>
*>          ILO and IHI must have the same values as in the previous call
*>          of DGEHRD. Q is equal to the unit matrix except in the
*>          submatrix Q(ilo+1:ihi,ilo+1:ihi).
*>          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the vectors which define the elementary reflectors,
*>          as returned by DGEHRD.
*>          On exit, the N-by-N orthogonal matrix Q.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A. LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is DOUBLE PRECISION array, dimension (N-1)
*>          TAU(i) must contain the scalar factor of the elementary
*>          reflector H(i), as returned by DGEHRD.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The dimension of the array WORK. LWORK >= IHI-ILO.
*>          For optimum performance LWORK >= (IHI-ILO)*NB, where NB is
*>          the optimal blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup doubleOTHERcomputational
*
*  =====================================================================
      SUBROUTINE DORGHR( N, ILO, IHI, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            I, IINFO, J, LWKOPT, NB, NH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DORGQR, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      NH = IHI - ILO
      LQUERY = ( LWORK.EQ.-1 )
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -2
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LWORK.LT.MAX( 1, NH ) .AND. .NOT.LQUERY ) THEN
         INFO = -8
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DORGQR', ' ', NH, NH, NH, -1 )
         LWKOPT = MAX( 1, NH )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DORGHR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
*     Shift the vectors which define the elementary reflectors one
*     column to the right, and set the first ilo and the last n-ihi
*     rows and columns to those of the unit matrix
*
      DO 40 J = IHI, ILO + 1, -1
         DO 10 I = 1, J - 1
            A( I, J ) = ZERO
   10    CONTINUE
         DO 20 I = J + 1, IHI
            A( I, J ) = A( I, J-1 )
   20    CONTINUE
         DO 30 I = IHI + 1, N
            A( I, J ) = ZERO
   30    CONTINUE
   40 CONTINUE
      DO 60 J = 1, ILO
         DO 50 I = 1, N
            A( I, J ) = ZERO
   50    CONTINUE
         A( J, J ) = ONE
   60 CONTINUE
      DO 80 J = IHI + 1, N
         DO 70 I = 1, N
            A( I, J ) = ZERO
   70    CONTINUE
         A( J, J ) = ONE
   80 CONTINUE
*
      IF( NH.GT.0 ) THEN
*
*        Generate Q(ilo+1:ihi,ilo+1:ihi)
*
         CALL DORGQR( NH, NH, NH, A( ILO+1, ILO+1 ), LDA, TAU( ILO ),
     $                WORK, LWORK, IINFO )
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of DORGHR
*
      END
c $Id: dorghr.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine tce_aod1(rtdb,g_aod1,dipole)
c
c $Id: tce_aod1.F 21468 2011-11-08 20:41:25Z jhammond $
c
c     Returns a GA handle for AO dipole matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer rtdb               ! Run-time database
      integer g_aod1(3)          ! GA handle for AO dipole matrices
      integer g_dens(2)          ! GA handle for density matrices
      double precision dipole(3) ! SCF dipole moments
      integer i
c
c     ===============
c     Allocate g_dens
c     ===============
c
      do i=1,ipol
        if (.not.ga_create(mt_dbl,nbf,nbf,'AO density',
     1    -1,-1,g_dens(i))) call errquit('tce_aod1: GA problem',2,
     2    GA_ERR)
      enddo
c
c     =====================
c     Make density matrices
c     =====================
c
      do i=1,ipol
        call ga_dgemm('N','T',nbf,nbf,nocc(i),1.0d0,
     1    g_movecs(i),g_movecs(i),0.0d0,g_dens(i))
        if (ipol.eq.1) call ga_dscal(g_dens(i),2.0d0)
        if (util_print('aod1',
     1    print_debug)) call ga_print(g_dens(i))
      enddo
c
c     ===============
c     Allocate g_aod1
c     ===============
c
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole X',
     1  -1,-1,g_aod1(1))) call errquit('tce_aod1: GA problem',0,
     2  GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole Y',
     1  -1,-1,g_aod1(2))) call errquit('tce_aod1: GA problem',1,
     2  GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole Z',
     1  -1,-1,g_aod1(3))) call errquit('tce_aod1: GA problem',2,
     2  GA_ERR)
c
c     ====================
c     Make dipole matrices
c     ====================
c
      call int_dip_ga(ao_bas_han,ao_bas_han,
     1  g_aod1(1),g_aod1(2),g_aod1(3))
      if (util_print('aod1',print_debug)) call ga_print(g_aod1(1))
      if (util_print('aod1',print_debug)) call ga_print(g_aod1(2))
      if (util_print('aod1',print_debug)) call ga_print(g_aod1(3))
c
c     ===================
c     Make dipole moments
c     ===================
c
c     Note: do not attempt to compute these in MO basis;
c     frozen core approximation can give you wrong results.
c
      do i=1,ipol
        dipole(1) = dipole(1) + ga_ddot(g_dens(i),g_aod1(1))
        dipole(2) = dipole(2) + ga_ddot(g_dens(i),g_aod1(2))
        dipole(3) = dipole(3) + ga_ddot(g_dens(i),g_aod1(3))
      enddo
      do i=1,ipol
        if (.not.ga_destroy(g_dens(i)))
     1  call errquit('tce_aod1: failed to destroy g_dens',0,GA_ERR)
      enddo
      return
      end



      subroutine tce_aoq1(rtdb,g_aoq1,quadrupole)
c
c $Id: tce_aod1.F 21468 2011-11-08 20:41:25Z jhammond $
c
c     Returns a GA handle for AO quadrupole matrix.
c
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer rtdb                   ! Run-time database
      integer g_aoq1(6)              ! GA handle for AO quadrupole matrices
      integer g_dens(2)              ! GA handle for density matrices
      double precision quadrupole(6) ! SCF quadrupole moments
      integer i
c
c     ===============
c     Allocate g_dens
c     ===============
c
      do i=1,ipol
        if (.not.ga_create(mt_dbl,nbf,nbf,'AO density',
     1    -1,-1,g_dens(i))) call errquit('tce_aoq1: GA problem',2,
     2    GA_ERR)
      enddo
c
c     =====================
c     Make density matrices
c     =====================
c
      do i=1,ipol
        call ga_dgemm('N','T',nbf,nbf,nocc(i),1.0d0,
     1    g_movecs(i),g_movecs(i),0.0d0,g_dens(i))
        if (ipol.eq.1) call ga_dscal(g_dens(i),2.0d0)
        if (util_print('aoq1',
     1    print_debug)) call ga_print(g_dens(i))
      enddo
c
c     ===============
c     Allocate g_aod1
c     ===============
c
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole XX',
     1  -1,-1,g_aoq1(1))) call errquit('tce_aoq1: GA problem',0,
     2  GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole XY',
     1  -1,-1,g_aoq1(2))) call errquit('tce_aoq1: GA problem',1,
     2  GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole XZ',
     1  -1,-1,g_aoq1(3))) call errquit('tce_aoq1: GA problem',2,
     2  GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole YY',
     1  -1,-1,g_aoq1(4))) call errquit('tce_aoq1: GA problem',3,
     2  GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole YZ',
     1  -1,-1,g_aoq1(5))) call errquit('tce_aoq1: GA problem',4,
     2  GA_ERR)
      if (.not.ga_create(mt_dbl,nbf,nbf,'AO dipole ZZ',
     1  -1,-1,g_aoq1(6))) call errquit('tce_aoq1: GA problem',5,
     2  GA_ERR)
c
c     ====================
c     Make dipole matrices
c     ====================
c
      call int_qdr_ga(ao_bas_han,ao_bas_han,
     1  g_aoq1(1),g_aoq1(2),g_aoq1(3),g_aoq1(4),g_aoq1(5),g_aoq1(6))
      if (util_print('aoq1',print_debug)) then
        do i=1,6
            call ga_print(g_aoq1(i))
        enddo
      endif
c
c     =======================
c     Make quadrupole moments
c     =======================
c
c     Note: do not attempt to compute these in MO basis;
c     frozen core approximation can give you wrong results.
c
      do i=1,ipol
        quadrupole(1) = quadrupole(1) + ga_ddot(g_dens(i),g_aoq1(1))
        quadrupole(2) = quadrupole(2) + ga_ddot(g_dens(i),g_aoq1(2))
        quadrupole(3) = quadrupole(3) + ga_ddot(g_dens(i),g_aoq1(3))
        quadrupole(1) = quadrupole(1) + ga_ddot(g_dens(i),g_aoq1(4))
        quadrupole(2) = quadrupole(2) + ga_ddot(g_dens(i),g_aoq1(5))
        quadrupole(3) = quadrupole(3) + ga_ddot(g_dens(i),g_aoq1(6))
      enddo
      do i=1,ipol
        if (.not.ga_destroy(g_dens(i)))
     1  call errquit('tce_aod1: failed to destroy g_dens',0,GA_ERR)
      enddo
      return
      end

      SUBROUTINE ccsdtq_lambda2_13_13_3(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdtq_lambda2_13_13_3.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h5 h15 )_vt + = -1/2 * Sum ( h12 p9 p10 ) * t ( p9 p10 h12 h15 )_t * v ( h5 h12 p9 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h15b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p9b
      INTEGER p10b
      INTEGER h12b
      INTEGER p9b_1
      INTEGER p10b_1
      INTEGER h15b_1
      INTEGER h12b_1
      INTEGER h5b_2
      INTEGER h12b_2
      INTEGER p9b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h5b = 1,noab
      DO h15b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h15b-
     &1).ne.4)) THEN
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h15b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+h15b-1)) .eq. ieor(irrep
     &_v,irrep_t)) THEN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h15b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_13_13_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p9b = noab+1,noab+nvab
      DO p10b = p9b,noab+nvab
      DO h12b = 1,noab
      IF (int_mb(k_spin+p9b-1)+int_mb(k_spin+p10b-1) .eq. int_mb(k_spin+
     &h15b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p9b-1),ieor(int_mb(k_sym+p10b-1),ieor(int_mb
     &(k_sym+h15b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p9b,p10b,h15b,h12b,p9b_1,p10b_1,h15b_1,h12b_
     &1)
      CALL TCE_RESTRICTED_4(h5b,h12b,p9b,p10b,h5b_2,h12b_2,p9b_2,p10b_2)
      dim_common = int_mb(k_range+p9b-1) * int_mb(k_range+p10b-1) * int_
     &mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+h15b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_13_13_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_13_13_3',2,MA_ERR)
      IF ((h12b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p
     &9b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+h12b-1),int_mb(k_range+h15b
     &-1),4,3,2,1,1.0d0)
      END IF
      IF ((h15b .lt. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h15b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p
     &9b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+h15b-1),int_mb(k_range+h12b
     &-1),3,4,2,1,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_13_13_3',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_13_13_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_13_13_3',5,MA_ERR)
      IF ((h12b .lt. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noa
     &b+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b-
     &1),2,1,4,3,-1.0d0)
      END IF
      IF ((h5b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p9b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+p9b-1),int_mb(k_range+p10b-
     &1),1,2,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_13_13_3',
     &6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p9b .eq. p10b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_13_1
     &3_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_13_1
     &3_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_13_13_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h15b-1),1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h5b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_13_13_3',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_13_1
     &3_3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE ccsdt_lr_alpha2_4_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdt_lr_alpha2_4_2.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h6 h7 h11 h12 )_ytratrb + = -1 * Sum ( p5 ) * trb ( p5 h12 )_trb * i2 ( h6 h7 h11 p5 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h6b
      INTEGER h7b
      INTEGER h12b
      INTEGER h11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p5b_1
      INTEGER h12b_1
      INTEGER h6b_2
      INTEGER h7b_2
      INTEGER h11b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h6b = 1,noab
      DO h7b = h6b,noab
      DO h12b = 1,noab
      DO h11b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1
     &)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h12b-1).ne.8)) THEN
      IF (int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h
     &11b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),ieor(int_mb(k_sym+h7b-1),ieor(int_mb(
     &k_sym+h11b-1),int_mb(k_sym+h12b-1)))) .eq. ieor(irrep_y,ieor(irrep
     &_tra,irrep_trb))) THEN
      dimc = int_mb(k_range+h6b-1) * int_mb(k_range+h7b-1) * int_mb(k_ra
     &nge+h11b-1) * int_mb(k_range+h12b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_4_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h12b-1)) .eq. irrep_trb)
     & THEN
      CALL TCE_RESTRICTED_2(p5b,h12b,p5b_1,h12b_1)
      CALL TCE_RESTRICTED_4(h6b,h7b,h11b,p5b,h6b_2,h7b_2,h11b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+h12b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+h7b-1) * int_mb
     &(k_range+h11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_4_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_4_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h12b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha2_4_2',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_4_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_4_2',5,MA_ERR)
      IF ((h11b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h11b_2 - 1 + noab * (h7b_2 - 1 + noab * (h6b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h11b-1),int_mb(k_range+p5b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha2_4_2',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_4_2
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_4_2
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_4_2',9,MA_ERR)
      IF ((h11b .le. h12b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h11b-1
     &),int_mb(k_range+h7b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),3,2,1,4,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h12b 
     &- 1 + noab * (h11b - 1 + noab * (h7b - 1 + noab * (h6b - 1)))))
      END IF
      IF ((h12b .le. h11b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h11b-1
     &),int_mb(k_range+h7b-1),int_mb(k_range+h6b-1),int_mb(k_range+h12b-
     &1),3,2,4,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h11b 
     &- 1 + noab * (h12b - 1 + noab * (h7b - 1 + noab * (h6b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha2_4_2',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_4_2
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE ccsdtq_lambda1_19_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lambda1_19_2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 p10 p9 p11 )_yt + = 1/6 * Sum ( h8 h7 h6 p4 p3 ) * t ( p3 p4 p10 h6 h7 h8 )_t * y ( h2 h6 h7 h8 p3 p4 p9 p11 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p10b
      INTEGER p9b
      INTEGER p11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER h6b
      INTEGER h7b
      INTEGER h8b
      INTEGER p10b_1
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h6b_1
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER h2b_2
      INTEGER h6b_2
      INTEGER h7b_2
      INTEGER h8b_2
      INTEGER p9b_2
      INTEGER p11b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h2b = 1,noab
      DO p10b = noab+1,noab+nvab
      DO p9b = noab+1,noab+nvab
      DO p11b = p9b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p10b-
     &1)+int_mb(k_spin+p9b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p10b-1) .eq. int_mb(k_spin+
     &p9b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p10b-1),ieor(int_mb
     &(k_sym+p9b-1),int_mb(k_sym+p11b-1)))) .eq. ieor(irrep_y,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p10b-1) * int_mb(k_r
     &ange+p9b-1) * int_mb(k_range+p11b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_19_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h6b = 1,noab
      DO h7b = h6b,noab
      DO h8b = h7b,noab
      IF (int_mb(k_spin+p10b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &) .eq. int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p10b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb
     &(k_sym+p4b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(k_sym+h7b-1),in
     &t_mb(k_sym+h8b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p10b,p3b,p4b,h6b,h7b,h8b,p10b_1,p3b_1,p4b_1,
     &h6b_1,h7b_1,h8b_1)
      CALL TCE_RESTRICTED_8(h2b,h6b,h7b,h8b,p9b,p11b,p3b,p4b,h2b_2,h6b_2
     &,h7b_2,h8b_2,p9b_2,p11b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+h6b-1) * int_mb(k_range+h7b-1) * int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+p10b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+p9b-1) * int_mb
     &(k_range+p11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_19_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_19_2',2,MA_ERR)
      IF ((p4b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (h6b_1 - 1 + noab * (p10b_1 - no
     &ab - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p10b-1),int_mb(k_range+h6b-1
     &),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),3,6,5,4,2,1,1.0d0)
      END IF
      IF ((p3b .le. p10b) .and. (p10b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (h6b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p10b_1 - noab - 1 + nvab * (p3b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+p4b-1),int_mb(k_range+h6b-1
     &),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),2,6,5,4,3,1,-1.0d0)
      END IF
      IF ((p10b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h7b_1 - 1 + noab * (h6b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p10b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h6b-1
     &),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),1,6,5,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_19_2',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_19_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_19_2',5,MA_ERR)
      IF ((h8b .lt. h2b) .and. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h8b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p11b-1),8,7,4,3,2,1,6,5,-1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (p3b .le. p9b) .and. (p9b .lt. p4b) .and.
     & (p4b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h8b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,6,4,3,2,1,7,5,1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (p3b .le. p9b) .and. (p11b .lt. p4b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h8b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,6,4,3,2,1,8,5,-1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (p9b .lt. p3b) .and. (p4b .le. p11b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h8b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,5,4,3,2,1,7,6,-1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (p9b .lt. p3b) .and. (p3b .le. p11b) .and
     &. (p11b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h8b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,5,4,3,2,1,8,6,1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (p11b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h8b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p11b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),6,5,4,3,2,1,8,7,-1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p11b-1),8,7,3,4,2,1,6,5,1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (p3b .le. p9b) .and.
     & (p9b .lt. p4b) .and. (p4b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,6,3,4,2,1,7,5,-1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (p3b .le. p9b) .and.
     & (p11b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,6,3,4,2,1,8,5,1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (p9b .lt. p3b) .and.
     & (p4b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,5,3,4,2,1,7,6,1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (p9b .lt. p3b) .and.
     & (p3b .le. p11b) .and. (p11b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,5,3,4,2,1,8,6,-1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b) .and. (p11b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h2b_2 - 
     &1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p11b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),6,5,3,4,2,1,8,7,1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h7b) .and. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p11b-1),8,7,2,4,3,1,6,5,-1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h7b) .and. (p3b .le. p9b) .and.
     & (p9b .lt. p4b) .and. (p4b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,6,2,4,3,1,7,5,1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h7b) .and. (p3b .le. p9b) .and.
     & (p11b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,6,2,4,3,1,8,5,-1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h7b) .and. (p9b .lt. p3b) .and.
     & (p4b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,5,2,4,3,1,7,6,-1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h7b) .and. (p9b .lt. p3b) .and.
     & (p3b .le. p11b) .and. (p11b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,5,2,4,3,1,8,6,1.0d0)
      END IF
      IF ((h6b .lt. h2b) .and. (h2b .le. h7b) .and. (p11b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h2b_2 - 1 + noab * (h6b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p11b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),6,5,2,4,3,1,8,7,-1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p4b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p11b-1),8,7,1,4,3,2,6,5,1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (p3b .le. p9b) .and. (p9b .lt. p4b) .and.
     & (p4b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,6,1,4,3,2,7,5,-1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (p3b .le. p9b) .and. (p11b .lt. p4b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p9b_2 - noab - 1
     & + nvab * (p3b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p9b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,6,1,4,3,2,8,5,1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (p9b .lt. p3b) .and. (p4b .le. p11b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p11b-1),8,5,1,4,3,2,7,6,1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (p9b .lt. p3b) .and. (p3b .le. p11b) .and
     &. (p11b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p3b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p3b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p4b-1),7,5,1,4,3,2,8,6,-1.0d0)
      END IF
      IF ((h2b .le. h6b) .and. (p11b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (p9b_2 - noab - 1 + nvab * (h8b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p11b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),6,5,1,4,3,2,8,7,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_19_2',6,M
     &A_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h6b .eq. h7b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h7b .eq. h8b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,12.0d0/FACTORIAL
     &(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(n
     &subh(2))/FACTORIAL(nsubh(3)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_
     &b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_19_2
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_19_2
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_19_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p11b-1
     &),int_mb(k_range+p9b-1),int_mb(k_range+h2b-1),int_mb(k_range+p10b-
     &1),3,4,2,1,1.0d0/6.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p11b 
     &- noab - 1 + nvab * (p9b - noab - 1 + nvab * (p10b - noab - 1 + nv
     &ab * (h2b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_19_2',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_19_2
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine smd_ewald_recip_generic(
     >                          na,
     >                          nk,
     >                          eikr,
     >                          eikx,
     >                          eiky,
     >                          eikz,
     >                          ralphsq,
     >                          rksqmax,
     >                          vol,
     >                          rlatt,
     >                          kmax,
     >                          ccc,
     >                          q,
     >                          fff,
     >                          ewald2)

      implicit none
#include "smd_const_data.fh"

      integer na
      integer nk
      double precision ralphsq
      double precision rksqmax
      double precision vol
      double complex eikr(na)
      double complex eikx(1:na,0:nk)
      double complex eiky(1:na,-nk:nk)
      double complex eikz(1:na,-nk:nk)
      double precision rlatt(3,3)
      double precision ccc(na,3)
      double precision fff(na,3)
      double precision q(na)
      integer kmax(3)



      integer i,k,kx,ky,kz,kminx,kminy,kminz

      real*8 rksq,rx,ry,rz,rkx,rky,rkz
      real*8 kcoeff,factor,force,ewald2

      double complex rhosum

      ewald2 = 0.0d0
      do i=1,na

       eikx(i,0)=(1.0,0.0)
       eiky(i,0)=(1.0,0.0)
       eikz(i,0)=(1.0,0.0)
       rx=rlatt(1,1)*ccc(i,1)+rlatt(1,2)*ccc(i,2)+rlatt(1,3)*ccc(i,3)
       ry=rlatt(2,1)*ccc(i,1)+rlatt(2,2)*ccc(i,2)+rlatt(2,3)*ccc(i,3)
       rz=rlatt(3,1)*ccc(i,1)+rlatt(3,2)*ccc(i,2)+rlatt(3,3)*ccc(i,3)
       eikx(i,1)=dcmplx(dcos(twopi*rx),dsin(twopi*rx))
       eiky(i,1)=dcmplx(dcos(twopi*ry),dsin(twopi*ry))
       eikz(i,1)=dcmplx(dcos(twopi*rz),dsin(twopi*rz))
       eiky(i,-1)=conjg(eiky(i,1))
       eikz(i,-1)=conjg(eikz(i,1))

      enddo

      do i=1,na

       do k=2,kmax(1)
        eikx(i,k)=eikx(i,k-1)*eikx(i,1)
       enddo
       do k=2,kmax(2)
        eiky(i,k)=eiky(i,k-1)*eiky(i,1)
        eiky(i,-k)=conjg(eiky(i,k))
       enddo
       do k=2,kmax(3)
        eikz(i,k)=eikz(i,k-1)*eikz(i,1)
        eikz(i,-k)=conjg(eikz(i,k))
       enddo

      enddo

      kminx=0
      kminy=-kmax(2)
      kminz=-kmax(3)

      do kx=kminx,kmax(1)

       if(kx.eq.0)then
        factor=1.0
       else
        factor=2.0
       endif

       do ky=kminy,kmax(2)

        do kz=kminz,kmax(3)

         rkx=real(kx)*rlatt(1,1)+real(ky)*rlatt(1,2)+real(kz)*rlatt(1,3)
         rky=real(kx)*rlatt(2,1)+real(ky)*rlatt(2,2)+real(kz)*rlatt(2,3)
         rkz=real(kx)*rlatt(3,1)+real(ky)*rlatt(3,2)+real(kz)*rlatt(3,3)
         rkx=twopi*rkx
         rky=twopi*rky
         rkz=twopi*rkz
         rksq=rkx*rkx+rky*rky+rkz*rkz

          if(rksq.lt.rksqmax.and.rksq.ne.0.0)then

           rhosum=(0.0,0.0)

           do i=1,na

            eikr(i)=eikx(i,kx)*eiky(i,ky)*eikz(i,kz)
            rhosum=rhosum+q(i)*eikr(i)

           enddo

           kcoeff=exp(rksq*ralphsq)/rksq
           ewald2=ewald2+factor*kcoeff*conjg(rhosum)*rhosum
           do i=1,na

            force=-factor*2.0*twopi*convfct1/vol*kcoeff*
     $            dimag(rhosum*dconjg(eikr(i)))*q(i)
            fff(i,1)=fff(i,1)+convfct2*rkx*force
            fff(i,2)=fff(i,2)+convfct2*rky*force
            fff(i,3)=fff(i,3)+convfct2*rkz*force

           enddo

          endif

         enddo

        enddo 

       enddo 

       ewald2=twopi*ewald2*convfct1/vol

       return

       END


      subroutine smd_ewald_excl_generic(na,
     >                                  nl,
     >                                  alpha,
     >                                  rcutsq,
     >                                  latt,
     >                                  rlatt,
     >                                  q,
     >                                  ccc,
     >                                  fff,
     >                                  epoint,
     >                                  elist,
     >                                  e)

      implicit none

#include "smd_const_data.fh"


      integer na
      integer nl
      double precision alpha
      double precision rcutsq
      double precision rlatt(3,3),latt(3,3)
      integer epoint(na)
      double precision q(na)
      integer elist(nl)
      double precision ccc(na,3),fff(na,3)
      double precision e
c
      integer i,j,k,jnab
      integer jbeg,jend

      double precision  dr,ar,rsq
      double precision  erfxc,force

      double precision x,y,z

      double precision  ssx,ssy,ssz,xss,yss,zss

      e=0

      do i=1,na-1

       jbeg=epoint(i)
       jend=epoint(i+1)-1

c       write(*,*) "i,jbeg,jend",i,jbeg,jend

      do jnab=jbeg,jend

       j=elist(jnab)

       x=ccc(i,1)-ccc(j,1)
       y=ccc(i,2)-ccc(j,2)
       z=ccc(i,3)-ccc(j,3)
c
c      reboxing here
c      ------------
       ssx=(rlatt(1,1)*x+rlatt(1,2)*y+rlatt(1,3)*z)
       ssy=(rlatt(2,1)*x+rlatt(2,2)*y+rlatt(2,3)*z)
       ssz=(rlatt(3,1)*x+rlatt(3,2)*y+rlatt(3,3)*z)

       xss=ssx-nint(ssx)
       yss=ssy-nint(ssy)
       zss=ssz-nint(ssz)

       x=(latt(1,1)*xss+latt(1,2)*yss+latt(1,3)*zss)
       y=(latt(2,1)*xss+latt(2,2)*yss+latt(2,3)*zss)
       z=(latt(3,1)*xss+latt(3,2)*yss+latt(3,3)*zss)
c      done reboxing

       rsq=x*x+y*y+z*z
       if(rsq.lt.rcutsq)then

        dr=sqrt(rsq)
        ar=alpha*dr

        e=e-convfct1*q(i)*q(j)
     $       *(1-erfxc(ar))/dr

        force=-convfct1*q(i)*q(j)*
     $       ((1-erfxc(ar))-2*ar/sqrpi*exp(-ar*ar))
     $       /(dr*rsq)

        fff(i,1)=fff(i,1)+convfct2*force*x
        fff(i,2)=fff(i,2)+convfct2*force*y
        fff(i,3)=fff(i,3)+convfct2*force*z

        fff(j,1)=fff(j,1)-convfct2*force*x
        fff(j,2)=fff(j,2)-convfct2*force*y
        fff(j,3)=fff(j,3)-convfct2*force*z

       endif

      end do
      end do

      return

      END

      subroutine smd_ewald_real_generic(na,
     >                                  nl,
     >                                  alpha,
     >                                  rcutsq,
     >                                  q,
     >                                  ccc,
     >                                  fff,
     >                                  point,
     >                                  list,
     >                                  e)

      implicit none

#include "smd_const_data.fh"


      integer na
      integer nl
      double precision alpha
      double precision rcutsq
      integer point(na)
      double precision q(na)
      integer list(nl)
      double precision ccc(nl,3)
      double precision fff(na,3)
      double precision e
c
      integer i,j,k,jnab
      integer jbeg,jend
      integer nlist

      double precision  dr,ar,rsq
      double precision  erfxc,force

      double precision x,y,z

      e=0

      nlist = 0
      do i=1,na-1

       jbeg=point(i)
       jend=point(i+1)-1


      do jnab=jbeg,jend

       j=list(jnab)

       nlist = nlist + 1
       x=ccc(nlist,1)
       y=ccc(nlist,2)
       z=ccc(nlist,3)

       rsq=x*x+y*y+z*z

       if(rsq.lt.rcutsq)then

        dr=sqrt(rsq)
        ar=alpha*dr

        e=e+convfct1*q(i)*q(j)
     $       *erfxc(ar)/dr
c        write(*,*) q(i),q(j),ar,dr

        force=convfct1*q(i)*q(j)
     $       *(erfxc(ar)+2*ar/sqrpi*exp(-ar*ar))/(dr*rsq)

        fff(i,1)=fff(i,1)+convfct2*force*x
        fff(i,2)=fff(i,2)+convfct2*force*y
        fff(i,3)=fff(i,3)+convfct2*force*z

        fff(j,1)=fff(j,1)-convfct2*force*x
        fff(j,2)=fff(j,2)-convfct2*force*y
        fff(j,3)=fff(j,3)-convfct2*force*z

       endif

      end do
      end do

      return

      END

c $Id: smd_ewald_generic.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine dia_gettrj
c
c $Id: dia_gettrj.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     read the trajectory
c     -------------------
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      external dia_rdfram
      logical dia_rdfram
c
      integer nread,nframe,itmp(4),ifil,nfram
      integer meio,meframf,meframl,mefilf,mefill,meskip,melast
      integer ifram,iffram,ilfram,lq,ifr
      real*8 t(6)
      character*255 fname
c
c     deallocate any existing global arrays
c
      if(nfrtot.gt.0) then
      if(.not.ga_destroy(ga_trj))
     + call md_abort('Failed to destroy ga_trj',0)
      if(lslvnt) then
      if(.not.ga_destroy(ga_trw))
     + call md_abort('Failed to destroy ga_trw',0)
      endif
      if(.not.ga_destroy(ga_trt))
     + call md_abort('Failed to destroy ga_trt',0)
      endif
c
      read(card(8:38),'(3i10,l1)') ifrfr,ifrto,ifrsk,lslvnt
c
      if(me.eq.0) then
      write(*,'(/,3(a,i10))') ' Selected frames ',ifrfr,' to ',ifrto,
     + ' by',ifrsk
      endif
      timoff=0.0d0
      time=0.0d0
      timr=0.0d0
c
c     allocate global array
c
c     nfrtot : total number of frames
c     nfrdim : maximum number of frames per processor
c     nfrme  : actual number of frames on processor
c     nfrndx : global index of first element local list
c     ntrj   : number of solute atoms per frame in memory resident frames
c
      nfrtot=int((ifrto-ifrfr+1)/ifrsk)
      nfrdim=nfrtot/np
      if(mod(nfrtot,np).ne.0) nfrdim=nfrdim+1
      nfrme=min(nfrdim,nfrtot-me*nfrdim)
      if(nfrme.lt.0) nfrme=0
      nfrndx=me*nfrdim+1
      ntrj=nsa
c
      if(me.eq.0) then
      write(*,6001) np,nfrtot,nfrdim,nsel
 6001 format(/,' Number of processors',t45,i5,/,
     + ' Total number of selected frames',t45,i5,/,
     + ' Number of frames per processor',t45,i5,//,
     + ' Number of selected atoms',t45,i5,//)
      endif
c
      if(.not.ga_create(mt_dbl,ntrj*3,nfrtot,'trj',ntrj*3,nfrdim,
     + ga_trj)) call md_abort('Failed to create ga_trj',0)
      if(lslvnt) then
      if(.not.ga_create(mt_dbl,nwm*nwa*3,nfrtot,'trw',nwm*nwa*3,nfrdim,
     + ga_trw)) call md_abort('Failed to create ga_trw',0)
      endif
      if(.not.ga_create(mt_dbl,6,nfrtot,'trt',6,nfrdim,
     + ga_trt)) call md_abort('Failed to create ga_trt',0)
c
c      write(*,'(i5,a,2i5)') me,' allocated ga for frames ',
c     + me*nfrdim+1,min((me+1)*nfrdim,nfrtot)
c
      if(iomode.eq.0) then
c
c     read trajectory files sequentially
c     ----------------------------------
c
c     read file header
c
      call dia_rdhdr(byte_mb(i_snam))
      nread=0
      nwrit=0
      nframe=0
 1010 continue
      if(dia_rdfram(dbl_mb(i_xdat),dbl_mb(i_wdat),t)) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 1010
      if(nframe.eq.(nframe/ifrsk)*ifrsk) then
      ndata=ndata+1
      if(me.eq.0) then
      call ga_put(ga_trj,1,3*nsa,ndata,ndata,dbl_mb(i_xdat),nsa)
      if(lslvnt) call ga_put(ga_trw,1,3*nwm*nwa,ndata,ndata,
     + dbl_mb(i_wdat),nwm*nwa)
      call ga_put(ga_trt,1,6,ndata,ndata,t,6)
      endif
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 1010
      endif
c
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      endif
c
      else
c
c     read trajectory files in parallel
c     ---------------------------------
c
c     read file header
c
      call dia_rdhdr(byte_mb(i_snam))
      call dia_getofffr()
      iofffr=iofffr-ioffhd
c
      itmp(1)=nfilf
      itmp(2)=ioffhd
      itmp(3)=iofffr
      itmp(4)=0
      call ga_brdcst(mag_d01,itmp,4*ma_sizeof(mt_int,1,mt_byte),0)
      nfilf=itmp(1)
      ioffhd=itmp(2)
      iofffr=itmp(3)
c
c      write(*,'(i5,a,i10)') me,' number of frames per file is ',nfilf
c      write(*,'(i5,a,i10)') me,' trajectory header offset  is ',ioffhd
c      write(*,'(i5,a,i10)') me,' trajectory frame size     is ',iofffr
c
c     meio   : processor carrying out i/o for current processor
c     meframf: first frame to be read from trajectory for this processor
c     meframl: last frame to be read from trajectory for this processor
c     mefilf : file that has first frame for this processor
c     mefill : file that has last frame for this processor
c     meskip : number of frames to be skipped on first file for this processor
c     melast : last frame to be read from the last file for this processor
c
      meio=(me/iomode)*iomode
      meframf=ifrfr+me*nfrme*ifrsk 
      meframl=ifrfr+(me+1)*nfrme*ifrsk-1
      mefilf=((meframf-1)/nfilf)+1
      mefill=((meframl-1)/nfilf)+1
      meskip=meframf-(mefilf-1)*nfilf-1
      melast=meframl-(mefill-1)*nfilf
c
cc      write(*,'(i5,a,i5,a,2i5,a,2i5,a,2i5)') 
cc     + me,' p :',meio,':',meframf,meframl,':',mefilf,mefill,':',
cc     + meskip,melast
c
c     since a single processor reads the trajectory for iomode processors
c
      if(me.eq.meio) then
c
c     meframl: last frame to be read from trajectory by the i/o processor
c     mefill : file that has last frame for the i/o processor
c     melast : last frame to be read from the last file for the i/o processor
c
      meframl=min(ifrfr+(me+iomode)*nfrme*ifrsk-1,ifrto)
      mefill=((meframl-1)/nfilf)+1
      melast=meframl-(mefill-1)*nfilf
c
c      write(*,'(i5,a,i5,a,2i5,a,2i5,a,2i5)') 
c     + me,' n :',meio,':',meframf,meframl,':',mefilf,mefill,':',
c     + meskip,melast
c
c     loop ov er the number of frames to be stored by this processor
c
c
      nfram=me*nfrme
      lq=index(filtrj,'?')
c
c     loop over all files for this processor
c
      do 101 ifil=mefilf,mefill
c
c     construct file name for file ifil
c
      if(lq.gt.0) then
      write(cnum,'(i3.3)') ifil
      fname=filtrj(1:lq-1)//cnum//filtrj(lq+1:index(filtrj,' ')-1)
      else
      fname=filtrj(1:index(filtrj,' ')-1)
      endif
c
c     determine first frame to read from this file
c
      iffram=1
      ilfram=nfilf
      if(ifil.eq.mefilf) iffram=meskip+1
      if(ifil.eq.mefill) ilfram=melast
c
      open(unit=lfntrj,file=fname(1:index(fname,' ')-1),
     + status='old',form='formatted')
      do 102 ifr=iffram,ilfram
      if(mod(ifr-iffram+1,ifrsk).eq.0) then
      nfram=nfram+1
      call fseek(lfntrj,ioffhd+(ifr-1)*iofffr,0)
c      call fseek(lfntrj,ioffhd+(ifr-1)*iofffr,0,9999)
      call dia_preadframe(dbl_mb(i_xdat),dbl_mb(i_wdat),t)
      call ga_put(ga_trj,1,3*nsa,nfram,nfram,dbl_mb(i_xdat),nsa)
      if(lslvnt) call ga_put(ga_trw,1,3*nwm*nwa,ndata,ndata,
     + dbl_mb(i_wdat),nwm*nwa)
      call ga_put(ga_trt,1,6,nfram,nfram,t,6)
c      write(*,'(i5,6f12.6)') nfram,t
      endif
  102 continue
  103 continue
c
      close(unit=lfntrj)
c
  101 continue
      endif
c
      endif
c
      return
 9999 continue
      call md_abort('Error in fseek',0)
      return
      end
      subroutine dia_puttrj()
c
c     read the trajectory
c     -------------------
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      return
      end
      subroutine dia_wrttrj(ga_t,fname,fmt,nbatch,logw)
c
c     read the trajectory
c     -------------------
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer ga_t,nbatch
      character*255 fname
      real*8 x(msa,3)
      logical logw
c
      integer ifil,ibatch
      character*3 fmt
      integer i,ipd,ifr
c
      if(nbatch.le.0) return
      if(me.ne.0) return
c
      ibatch=0
      ifil=0
      ipd=index(fname,'.')
      if(ipd.eq.0) ipd=index(fname,' ')
      lsonly=.true.
c
      do 1 ifr=1,nfrtot
c
      if(ibatch.eq.0) then
      ifil=ifil+1
      write(filcop,'(a,i5.5,a,a)') fname(1:ipd-1),ifil,'.',fmt
      call dia_wthdr(fmt,byte_mb(i_snam),byte_mb(i_tag),int_mb(i_isel),
     + logw)
      endif
      ibatch=ibatch+1
c
c     write frame
c
      call ga_get(ga_t,1,3*nsa,ifr,ifr,dbl_mb(i_xdat),nsa)
      call dia_wtfram(fmt,byte_mb(i_snam),dbl_mb(i_xdat),dbl_mb(i_wdat),
     + int_mb(i_isel),byte_mb(i_tag),dbl_mb(i_val),int_mb(i_wsel),
     + int_mb(i_ndxw),ifr)
c
      if(ibatch.eq.nbatch.or.ifr.eq.nfrtot) then
      ibatch=0
      close(unit=lfncop)
      endif
c
c
    1 continue
c
      return
      end
      subroutine dia_setiomode()
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
c
      read(card(8:12),1000) iomode
 1000 format(i5)
c
      call ga_brdcst(mag_d01,iomode,ma_sizeof(mt_int,1,mt_byte),0)
c
      return
      end
      subroutine dia_copy()
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
c
      character*255 fil,fname
      character*3 fmt
      integer i,nbatch
c
      read(card(8:14),1000) nbatch
 1000 format(i7)
      fil=card(15:80)
      i=index(fil,'.')
      if(i.eq.0) then
      fmt='trj'
      fname=fil(1:index(fil,' ')-1)//'.trj'
      i=index(fname,'.')
      else
      fname=fil
      fmt=fname(i+1:i+3)
      endif
c
      call dia_wrttrj(ga_trj,fname(1:i-1),fmt,nbatch,.false.)
c
      return
      end

      SUBROUTINE ccsdtq_lambda1_8_7_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdtq_lambda1_8_7_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h6 p15 h13 p4 )_v + = 1 * v ( h6 p15 h13 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h6b
      INTEGER p15b
      INTEGER h13b
      INTEGER p4b
      INTEGER dimc
      INTEGER h6b_1
      INTEGER p15b_1
      INTEGER h13b_1
      INTEGER p4b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h6b = 1,noab
      DO p15b = noab+1,noab+nvab
      DO h13b = 1,noab
      DO p4b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p15b-
     &1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      IF (int_mb(k_spin+h6b-1)+int_mb(k_spin+p15b-1) .eq. int_mb(k_spin+
     &h13b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),ieor(int_mb(k_sym+p15b-1),ieor(int_mb
     &(k_sym+h13b-1),int_mb(k_sym+p4b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h6b-1) * int_mb(k_range+p15b-1) * int_mb(k_r
     &ange+h13b-1) * int_mb(k_range+p4b-1)
      CALL TCE_RESTRICTED_4(h6b,p15b,h13b,p4b,h6b_1,p15b_1,h13b_1,p4b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p15b-1) * int_m
     &b(k_range+h13b-1) * int_mb(k_range+p4b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_8_7_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_8_7_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p4b_1
     & - 1 + (noab+nvab) * (h13b_1 - 1 + (noab+nvab) * (p15b_1 - 1 + (no
     &ab+nvab) * (h6b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p15b-1),int_mb(k_range+h13b-1),int_mb(k_range+p4b-
     &1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_8_7_1',2,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_8_7_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h13b-1),int_mb(k_range+p15b-1),int_mb(k_range+h6b-
     &1),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (h13b - 1 + noab * (p15b - noab - 1 + nvab * (h
     &6b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_8_7_1',4,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_8_7_
     &1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE ccsdtq_lr_alpha_1_11_2(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_1_11_2.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h5 h6 h7 h13 p3 p4 )_ytra + = -1/2 * Sum ( h10 p8 p9 ) * tra ( p8 p9 h10 h13 )_tra * y ( h5 h6 h7 h10 p3 p4 p8 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h6b
      INTEGER h7b
      INTEGER h13b
      INTEGER p3b
      INTEGER p4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p8b
      INTEGER p9b
      INTEGER h10b
      INTEGER p8b_1
      INTEGER p9b_1
      INTEGER h13b_1
      INTEGER h10b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h7b_2
      INTEGER h10b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER p8b_2
      INTEGER p9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h7b = h6b,noab
      DO h13b = 1,noab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h7b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+p3b-1)+
     &int_mb(k_spin+p4b-1).ne.12)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1)
     & .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h7b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+p3b-1),in
     &t_mb(k_sym+p4b-1)))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+h7b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+p3b-1) * int_
     &mb(k_range+p4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_1_11_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p8b = noab+1,noab+nvab
      DO p9b = p8b,noab+nvab
      DO h10b = 1,noab
      IF (int_mb(k_spin+p8b-1)+int_mb(k_spin+p9b-1) .eq. int_mb(k_spin+h
     &13b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+p9b-1),ieor(int_mb(
     &k_sym+h13b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_tra) THEN
      CALL TCE_RESTRICTED_4(p8b,p9b,h13b,h10b,p8b_1,p9b_1,h13b_1,h10b_1)
      CALL TCE_RESTRICTED_8(h5b,h6b,h7b,h10b,p3b,p4b,p8b,p9b,h5b_2,h6b_2
     &,h7b_2,h10b_2,p3b_2,p4b_2,p8b_2,p9b_2)
      dim_common = int_mb(k_range+p8b-1) * int_mb(k_range+p9b-1) * int_m
     &b(k_range+h10b-1)
      dima_sort = int_mb(k_range+h13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+h7b-1) * int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_1_11_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_1_11_2',2,MA_ERR)
      IF ((h10b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (p9b_1 - noab - 1 + nvab * (p8
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h13b-
     &1),4,3,2,1,1.0d0)
      END IF
      IF ((h13b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (p9b_1 - noab - 1 + nvab * (p8
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+h13b-1),int_mb(k_range+h10b-
     &1),3,4,2,1,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_1_11_2',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_1_11_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_1_11_2',5,MA_ERR)
      IF ((h10b .lt. h5b) .and. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h5b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),8,7,4,3,2,1,6,5,-1.0d0)
      END IF
      IF ((h10b .lt. h5b) .and. (p8b .lt. p3b) .and. (p3b .le. p9b) .and
     &. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h5b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,6,4,3,2,1,7,5,1.0d0)
      END IF
      IF ((h10b .lt. h5b) .and. (p8b .lt. p3b) .and. (p4b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h5b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,6,4,3,2,1,8,5,-1.0d0)
      END IF
      IF ((h10b .lt. h5b) .and. (p3b .le. p8b) .and. (p9b .lt. p4b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h5b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,5,4,3,2,1,7,6,-1.0d0)
      END IF
      IF ((h10b .lt. h5b) .and. (p3b .le. p8b) .and. (p8b .lt. p4b) .and
     &. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h5b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,5,4,3,2,1,8,6,1.0d0)
      END IF
      IF ((h10b .lt. h5b) .and. (p4b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h5b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1
     &),int_mb(k_range+p9b-1),6,5,4,3,2,1,8,7,-1.0d0)
      END IF
      IF ((h5b .le. h10b) .and. (h10b .lt. h6b) .and. (p9b .lt. p3b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h10b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),8,7,4,3,1,2,6,5,1.0d0)
      END IF
      IF ((h5b .le. h10b) .and. (h10b .lt. h6b) .and. (p8b .lt. p3b) .an
     &d. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h10b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,6,4,3,1,2,7,5,-1.0d0)
      END IF
      IF ((h5b .le. h10b) .and. (h10b .lt. h6b) .and. (p8b .lt. p3b) .an
     &d. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h10b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,6,4,3,1,2,8,5,1.0d0)
      END IF
      IF ((h5b .le. h10b) .and. (h10b .lt. h6b) .and. (p3b .le. p8b) .an
     &d. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h10b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,5,4,3,1,2,7,6,1.0d0)
      END IF
      IF ((h5b .le. h10b) .and. (h10b .lt. h6b) .and. (p3b .le. p8b) .an
     &d. (p8b .lt. p4b) .and. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h10b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,5,4,3,1,2,8,6,-1.0d0)
      END IF
      IF ((h5b .le. h10b) .and. (h10b .lt. h6b) .and. (p4b .le. p8b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h6b_2 - 1
     & + noab * (h10b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1
     &),int_mb(k_range+p9b-1),6,5,4,3,1,2,8,7,1.0d0)
      END IF
      IF ((h6b .le. h10b) .and. (h10b .lt. h7b) .and. (p9b .lt. p3b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h10b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),8,7,4,2,1,3,6,5,-1.0d0)
      END IF
      IF ((h6b .le. h10b) .and. (h10b .lt. h7b) .and. (p8b .lt. p3b) .an
     &d. (p3b .le. p9b) .and. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h10b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,6,4,2,1,3,7,5,1.0d0)
      END IF
      IF ((h6b .le. h10b) .and. (h10b .lt. h7b) .and. (p8b .lt. p3b) .an
     &d. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h10b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,6,4,2,1,3,8,5,-1.0d0)
      END IF
      IF ((h6b .le. h10b) .and. (h10b .lt. h7b) .and. (p3b .le. p8b) .an
     &d. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h10b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,5,4,2,1,3,7,6,-1.0d0)
      END IF
      IF ((h6b .le. h10b) .and. (h10b .lt. h7b) .and. (p3b .le. p8b) .an
     &d. (p8b .lt. p4b) .and. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h10b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,5,4,2,1,3,8,6,1.0d0)
      END IF
      IF ((h6b .le. h10b) .and. (h10b .lt. h7b) .and. (p4b .le. p8b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h10b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h10b-1),int_mb(k_range+h7b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1
     &),int_mb(k_range+p9b-1),6,5,4,2,1,3,8,7,-1.0d0)
      END IF
      IF ((h7b .le. h10b) .and. (p9b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1),int_mb(k_range+p3b-1
     &),int_mb(k_range+p4b-1),8,7,3,2,1,4,6,5,1.0d0)
      END IF
      IF ((h7b .le. h10b) .and. (p8b .lt. p3b) .and. (p3b .le. p9b) .and
     &. (p9b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,6,3,2,1,4,7,5,-1.0d0)
      END IF
      IF ((h7b .le. h10b) .and. (p8b .lt. p3b) .and. (p4b .le. p9b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (p8b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p8b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,6,3,2,1,4,8,5,1.0d0)
      END IF
      IF ((h7b .le. h10b) .and. (p3b .le. p8b) .and. (p9b .lt. p4b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p9b-1
     &),int_mb(k_range+p4b-1),8,5,3,2,1,4,7,6,1.0d0)
      END IF
      IF ((h7b .le. h10b) .and. (p3b .le. p8b) .and. (p8b .lt. p4b) .and
     &. (p4b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p8b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p4b-1
     &),int_mb(k_range+p9b-1),7,5,3,2,1,4,8,6,-1.0d0)
      END IF
      IF ((h7b .le. h10b) .and. (p4b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p8b-1
     &),int_mb(k_range+p9b-1),6,5,3,2,1,4,8,7,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_1_11_2',
     &6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p8b .eq. p9b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_1_1
     &1_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_1_1
     &1_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_1_11_2',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h7b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h13b-1),5,4,3,6,2,1,-1.0d0/2
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (h13b - 1 + noab * (h7
     &b - 1 + noab * (h6b - 1 + noab * (h5b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_1_11_2',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_1_1
     &1_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_space_gagetixvf(node,iwl,iwlp,xw,xwcr,vw,fw,
     + numwm,isl,islp,xs,vs,fs,numsa,ipl)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3)
      real*8 fw(mwm,3,mwa),fs(msa,3)
      integer ipl(mbox,mip2)
      integer il,ih,jl,jh
c
      call ga_distribution(ga_ip,node,il,ih,jl,jh)
      call ga_get(ga_ip,il,ih,jl,jh,ipl,mbox)
      numwm=ipl(1,2)
      numsa=ipl(2,2)
c
      if(numwm.gt.0) then
      call ga_distribution(ga_iw,node,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_get(ga_iw,il,il+numwm-1,jl,jh,iwl,mwm)
      else
      call ga_get(ga_iw,il,il+numwm-1,jl,jl+npackw-1,iwlp,mwm)
      call argos_space_unpackw(numwm,iwl,iwlp)
      endif
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_get(ga_w,il,ih,jl,jl+3*mwa-1,xw,mwm)
      call ga_get(ga_w,il,ih,jl+3*mwa,jl+6*mwa-1,vw,mwm)
      call ga_get(ga_w,il,ih,jl+6*mwa,jl+6*mwa+2,xwcr,mwm)
      call ga_get(ga_w,il,ih,jl+6*mwa+3,jl+9*mwa+2,fw,mwm)
      endif
c
      if(numsa.gt.0) then
      call ga_distribution(ga_is,node,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_get(ga_is,il,il+numsa-1,jl,jh,isl,msa)
      else
      call ga_get(ga_is,il,il+numsa-1,jl,jl+npack-1,islp,msa)
      call argos_space_unpack(numsa,isl,islp)
      endif
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_get(ga_s,il,ih,jl,jl+2,xs,msa)
      call ga_get(ga_s,il,ih,jl+3,jl+5,vs,msa)
      call ga_get(ga_s,il,ih,jl+9,jl+11,fs,msa)
      endif
c
      return
      end
c $Id: argos_space_gagetixvf.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_prop_stat(mdstep,stime,eww,esw,ess,esk,epme)
c
      implicit none
c
#include "argos_prop.fh"
#include "msgids.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      logical frequency
      external frequency
c
      integer mdstep
      real*8 eww(mpe,2),esw(msf,mpe,2),ess(msf,msf,mpe,2),epme
      real*8 stime,esk(msf)
c
      integer i,j
      character*10 pdate,ptime
      real*8 facs,fact,tfacs,tfact,rt
c
      nsum=nsum+1
      nsumt=nsumt+1
      nsump=nsump+1
      do 8 i=1,maxpro
      if(abs(p(i)).lt.tiny) p(i)=zero
      psum(i)=psum(i)+p(i)
      p2sum(i)=p2sum(i)+p(i)*p(i)
      pslop(i)=pslop(i)+stime*p(i)
      psumt(i)=psumt(i)+p(i)
      p2sumt(i)=p2sumt(i)+p(i)*p(i)
      pslopt(i)=pslopt(i)+stime*p(i)
      psump(i)=psump(i)+p(i)
    8 continue
      tsum=tsum+stime
      t2sum=t2sum+stime*stime
      tsumt=tsumt+stime
      t2sumt=t2sumt+stime*stime
c
      if(frequency(mdstep,nfoutp)) then
      if(.not.lhdr) then
      call swatch(pdate,ptime)
      write(lfnout,1000) pdate,ptime
 1000 format(/,' MOLECULAR DYNAMICS TIME STEP INFORMATION',T110,2A10,//,
     + '    Time      Temp    Pres      Volume Tscalw Tscals  Pscal ',
     + '   U(ele)    U(vdW)      U(pot)     U(kin)     U(tot) ',/,
     + '     ps         K      Pa        nm**3                      ',
     + '   kJ/mol    kJ/mol      kJ/mol     kJ/mol     kJ/mol ',/)
      if(lpstep) write(lfnout,1010)
 1010 format(14X,
     + '   U(bnd)     U(ang)     U(dih)     U(imp)  ',
     + '   Ui(ele)    Ui(vdW) ',
     + '   Uw(ele)    Uw(vdW)    U(kin)     U(pot)     U(tot)',/,14X,
     + '   kJ/mol     kJ/mol     kJ/mol     kJ/mol  ',
     + '   kJ/mol     kJ/mol  ',
     + '   kJ/mol     kJ/mol     kJ/mol     kJ/mol     kJ/mol  ',/)
      lhdr=.true.
      endif
      write(lfnout,1001) stime,temp,pres,volume,p(21),p(22),p(15),
     + p(24),p(25),p(26),p(27),p(32)
 1001 format(1x,f10.5,0pf8.2,1pe9.2,0pf10.3,3f7.4,5(1pe11.4),i5,i7)
      if(lpstep) then
      if(nwm.gt.0) then
      rt=one/nwm
      write(lfnout,1011) rt*p(56),rt*p(57),rt*p(58),rt*p(59),rt*p(52),
     + rt*p(53),rt*p(54),rt*p(55),rt*p(64),rt*p(66),rt*p(67)
 1011 format('   solvent  ',11f11.2)
      endif
      do 1 i=1,nsf
      j=isprop+(i-1)*27
      rt=p(j+7)+p(j+8)+p(j+9)+p(j+10)+p(j+2)+p(j+3)+p(j+5)+p(j+6)
      write(lfnout,1012) i,p(j+7),p(j+8),p(j+9),p(j+10),
     + p(j+2),p(j+3),p(j+5),p(j+6),p(j+16),rt,rt+p(j+16)
 1012 format('   solute',i3,11f11.2)
    1 continue
      endif
      endif
c
      if(frequency(mdstep,nfstat)) then
      call swatch(pdate,ptime)
      write(lfnout,2000) pdate,ptime,nsum,nsumt
 2000 format(/,' MOLECULAR DYNAMICS STATISTICAL INFORMATION',t110,2a10,
     + //,t41,2(3X,'Statistics over last ',I8,' steps',2X),/,
     + t41,2(3X,'Average',5X,'RMS fluct',5X,'Drift/ps',3X),/)
      facs=one/dble(nsum)
      fact=one/dble(nsumt)
      tfacs=one/(t2sum-facs*tsum*tsum)
      tfact=one/(t2sumt-fact*tsumt*tsumt)
      do 15 i=1,nprop
      j=ixp(i)
      if(lp(j)) write(lfnout,2001) pronam(j)(1:39),
     + psum(j)*facs,sqrt(abs((p2sum(j)-psum(j)*psum(j)*facs)*facs)),
     + (pslop(j)-facs*psum(j)*tsum)*tfacs,
     + psumt(j)*fact,sqrt(abs((p2sumt(j)-psumt(j)*psumt(j)*fact)*fact)),
     + (pslopt(j)-fact*psumt(j)*tsumt)*tfact,
     + pronam(j)(40:50)
 2001 format(1x,a39,t41,2(3(1pe12.5,1x),1x),a11)
      psum(j)=zero
      p2sum(j)=zero
      pslop(j)=zero
   15 continue
      tsum=zero
      t2sum=zero
      nsum=0
      lhdr=.false.
      endif
c
      return
      end
c $Id: argos_prop_stat.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: Grassman.F 19707 2010-10-29 17:59:36Z d3y133 $
*

* $Log: not supported by cvs2svn $
* Revision 1.19  2009/02/07 03:50:56  bylaska
* Bassi Vectorization Fix...EJB
*
* Revision 1.18  2007/03/29 00:51:45  bylaska
* queue FFT added to HFX and more rigid msgtyping added to queueFFT
* ....EJB
*
* Revision 1.17  2006/10/07 00:10:07  bylaska
* Initial implementation of 2d processor grid parallelization in pspw.  Currently works with:
*
* task pspw steepest_descent
* task pspw energy            (only minimizer 1, minimizer 2?, other minimizers not yet implemented)
*
* Currently only works with USE_MPIF option, straight tcgmsg only partially implemented.  Car-Parrinello, HFX, SIC, and various analysis codes are also not yet ported.
*
*
* The number of processors along the orbital dimension, np_orbital, is entered as follows, e.g.:
*
* nwpw
*    np_orbital  2
* end
*
* The number of processors along the grid dimension, np_grid, is currently defined using np_orbital as
*
* np_grid = np/np_orbital
*
* where np is the total number of processors.
*
* ...EJB
*
* Revision 1.16  2005/07/12 21:26:33  bylaska
* Intitial implementation of pipelined parallel FFT implemented.
*
* ....EJB
*
* Revision 1.15  2005/06/24 19:24:18  bylaska
* various FFT updates, and symmetry point paths added to band_structure...EJB
*
* Revision 1.14  2004/02/22 18:56:38  bylaska
* Input and io changes for simulation_cell
* Grsm_ggm2_sym_dot routine used in paw_overlap_matrix_gen
* ...EBJ
*
* Revision 1.13  2003/10/31 22:16:38  bylaska
* bug fixes ... EJB
*
* Revision 1.12  2003/10/26 22:24:04  bylaska
* performance updates??...EJB
*
* Revision 1.11  2003/10/23 01:37:55  bylaska
* Added Grsm_ggm2_dot subroutine ....EJB
*
* Revision 1.10  2003/10/20 16:46:18  bylaska
* ..EJB
*
* Revision 1.9  2003/05/07 21:52:26  bylaska
* ...EJB
*
* Revision 1.8  2003/03/09 00:09:12  bylaska
* Added Grsm_ggm_sym_dot subroutine for more efficient calculation of
* product that result in symmetry matrices...EJB
*

*     ***********************************************************
*     *								*
*     *   		 Grsm (Grassman) Library		*	
*     *	   	      (Pack and D3dB implemenation)		*
*     *								*
*     *   Author - Eric Bylaska					*
*     *   date   - 3/23/96					*
*     *								*
*     ***********************************************************

*    The Grsm (Grassman) library is to be used for handling
* four kinds of data structures.  The first data structure,
* denoted by "g", is a set of n D3dB "c" complex vectors.
* The second data structure, denoted by "h", is a set of n
* D3dB "r" real vectors.  The third data structure, denoted by
* "m", is a (n X n) real matrix.  The fourth data structure denoted
* by "q" is a (n X n) complex matrix.
*
*  Uses: D3dB(1,..) data structure, blas3
*  Assumes: that D3dB(1,...) data structure is initialized
*
*  Future: This data structure will replace D3dB
* 

*     ****************************
*     *                		 *
*     *    	Grsm_gg_Copy  	 *
*     *                		 *
*     ****************************
*
*     C = A 
*     uses - Pack_c_Copy

      subroutine Grsm_gg_Copy(nfft3d,n,A,C)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer i

c     do i=1,n
c        call Pack_c_Copy(1,A(1,i),C(1,i))
c     end do
      call dcopy(2*n*nfft3d,A,1,C,1)
 
      return
      end


*     ****************************
*     *                		 *
*     *    	Grsm_hh_Copy  	 *
*     *                		 *
*     ****************************
*
*     C = A 
*     uses - D3dB_r_Copy

      subroutine Grsm_hh_Copy(nfft3d,n,A,C)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer i

c     do i=1,n
c        call D3dB_r_Copy(1,A(1,i),C(1,i))
c     end do
      call dcopy(2*n*nfft3d,A,1,C,1)
 
      return
      end

*     ****************************
*     *                	    	 *
*     *    	Grsm_gg_daxpy  	     *
*     *                	     	 *
*     ****************************
*
*     C = C + alpha*A
*     uses - Pack_cc_Sum

      subroutine Grsm_gg_daxpy(nfft3d,n,alpha,A,C)
      implicit none
      integer    nfft3d,n
      real*8     alpha
      complex*16 A(nfft3d,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****

      call daxpy(2*n*nfft3d,alpha,A,1,C,1)
c     do i=1,n
c         call Pack_cc_daxpy(1,alpha,A(1,i),C(1,i))
c     end do
 
      return
      end

       
       

*     ****************************
*     *                		 *
*     *    	Grsm_ggg_Sum   	 *
*     *                		 *
*     ****************************
*
*     C = A + B
*     uses - Pack_cc_Sum

      subroutine Grsm_ggg_Sum(nfft3d,n,A,B,C)
      implicit none
      integer    nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer i

      do i=1,n
c         call D3dB_cc_Sum(1,A(1,i),B(1,i),C(1,i))
          call Pack_cc_Sum(1,A(1,i),B(1,i),C(1,i))
      end do
 
      return
      end



*     ****************************
*     *                          *
*     *         Grsm_ggg_Sum2    *
*     *                          *
*     ****************************
*
*     B = A + B
*     uses - Pack_cc_Sum2

      subroutine Grsm_ggg_Sum2(nfft3d,n,A,B)
      implicit none
      integer    nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)

*     **** local variables ****
      integer i

      do i=1,n
c         call D3dB_cc_Sum(1,A(1,i),B(1,i),C(1,i))
          call Pack_cc_Sum2(1,A(1,i),B(1,i))
      end do

      return
      end

       

*     ****************************
*     *                		 *
*     *    	Grsm_ggg_Sub   	 *
*     *                		 *
*     ****************************
*
*     C = A - B
*     uses - Pack_cc_Sub

      subroutine Grsm_ggg_Sub(nfft3d,n,A,B,C)
      implicit none
      integer    nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer i

      do i=1,n
c         call D3dB_cc_Sub(1,A(1,i),B(1,i),C(1,i))
         call Pack_cc_Sub(1,A(1,i),B(1,i),C(1,i))
      end do
 
      return
      end
       
       
*     ****************************
*     *                		 *
*     *    	Grsm_hhh_Sum   	 *
*     *                		 *
*     ****************************
*
*     C = A + B
*     uses - D3dB_rr_Sum

      subroutine Grsm_hhh_Sum(nfft3d,n,A,B,C)
      implicit none
      integer nfft3d,n
      real*8 A(nfft3d,n)
      real*8 B(nfft3d,n)
      real*8 C(nfft3d,n)

*     **** local variables ****
      integer i

      do i=1,n
         call D3dB_rr_Sum(1,A(1,i),B(1,i),C(1,i))
      end do
 
      return
      end
       

*     ****************************
*     *                		 *
*     *    	Grsm_gmg_Mul   	 *
*     *                		 *
*     ****************************
*
*     C = A*MM
*     uses - Pack_c_SMul, Pack_cc_daxpy

      subroutine Grsm_gmg_Mul(nfft3d,n,A,MM,C)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      real*8     MM(n,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer j,k

      do k=1,n
c         call D3dB_c_SMul(1,MM(1,k),A(1,1),C(1,k))
c         do j=2,n
c           call D3dB_cc_daxpy(1,MM(j,k),A(1,j),C(1,k))
c         end do
         call Pack_c_SMul(1,MM(1,k),A(1,1),C(1,k))
         do j=2,n
           call Pack_cc_daxpy(1,MM(j,k),A(1,j),C(1,k))
         end do

      end do

      return
      end

*     ****************************
*     *                		 *
*     *    	Grsm_gmg_daxpy   	 *
*     *                		 *
*     ****************************
*
*     C = C + A*MM
*     uses - Pack_c_SMul, Pack_cc_daxpy

      subroutine Grsm_gmg_daxpy(nfft3d,n,A,MM,C)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      real*8     MM(n,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer j,k

      do k=1,n
         do j=1,n
           call Pack_cc_daxpy(1,MM(j,k),A(1,j),C(1,k))
         end do
      end do

      return
      end



*     ****************************
*     *                		 *
*     *    	Grsm_gqg_Mul   	 *
*     *                		 *
*     ****************************
*
*     C = A*Q
*     uses - Pack_c_SMul, Pack_cc_zaxpy

      subroutine Grsm_gqg_Mul(nfft3d,n,A,Q,C)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 Q(n,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer j,k


      do k=1,n
c         call D3dB_c_ZMul(1,Q(1,k),A(1,1),C(1,k))
c         do j=2,n
c           call D3dB_cc_zaxpy(1,Q(j,k),A(1,j),C(1,k))
c         end do
         call Pack_c_ZMul(1,Q(1,k),A(1,1),C(1,k))
         do j=2,n
           call Pack_cc_zaxpy(1,Q(j,k),A(1,j),C(1,k))
         end do
      end do

      return
      end

*     ****************************
*     *                		 *
*     *    	Grsm_hmh_Mul   	 *
*     *                		 *
*     ****************************
*
*     C = A*M
*     uses - D3dB_r_SMul, D3dB_rr_daxpy

      subroutine Grsm_hmh_Mul(nfft3d,n,A,MM,C)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      real*8     MM(n,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer j,k


      do k=1,n
         call D3dB_r_SMul(1,MM(1,k),A(1,1),C(1,k))
         do j=2,n
           call D3dB_rr_daxpy(1,MM(j,k),A(1,j),C(1,k))
         end do
      end do

      return
      end


*     ****************************
*     *                		 *
*     *    	Grsm_gg_dScale 	 *
*     *                		 *
*     ****************************
*
*     C = scale*A
*     uses - Pack_c_SMul

      subroutine Grsm_gg_dScale(nfft3d,n,scale,A,C)
      implicit none
      integer nfft3d,n
      real*8     scale
      complex*16 A(nfft3d,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer k

      do k=1,n
c        call D3dB_c_SMul(1,scale,A(1,k),C(1,k))
        call Pack_c_SMul(1,scale,A(1,k),C(1,k))

      end do

      return
      end



*     ****************************
*     *                          *
*     *         Grsm_gg_dScale1  *
*     *                          *
*     ****************************
*
*     C = scale*A
*     uses - Pack_c_SMul1

      subroutine Grsm_gg_dScale1(nfft3d,n,scale,A)
      implicit none
      integer nfft3d,n
      real*8     scale
      complex*16 A(nfft3d,n)

*     **** local variables ****
      integer k

      do k=1,n
        call Pack_c_SMul1(1,scale,A(1,k))
      end do

      return
      end




*     ****************************
*     *                		 *
*     *    	Grsm_hh_dScale 	 *
*     *                		 *
*     ****************************
*
*     C = scale*A
*     uses - D3dB_r_SMul

      subroutine Grsm_hh_dScale(nfft3d,n,scale,A,C)
      implicit none
      integer nfft3d,n
      real*8 scale
      complex*16 A(nfft3d,n)
      complex*16 C(nfft3d,n)

*     **** local variables ****
      integer k


      do k=1,n
        call D3dB_r_SMul(1,scale,A(1,k),C(1,k))
      end do

      return
      end



*     ****************************
*     *                		 *
*     *    	Grsm_gh_fftb 	 *
*     *                		 *
*     ****************************
*
*     A = FFT(-1)[A]
*     uses - D3dB_cr_fft3b,Pack_c_unpack

      subroutine Grsm_gh_fftb(nfft3d,n,A)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)

*     **** local variables ****
      logical done
      integer k,indx1,indx2


*     **** external functions ****
      logical  D3dB_cr_pfft3_queue_filled
      external D3dB_cr_pfft3_queue_filled

c      do k=1,n
c        call Pack_c_unpack(1,A(1,k))
c        !call D3dB_cr_fft3b(1,A(1,k))
c        !call D3dB_cr_pfft3b(1,1,A(1,k))
c      end do
c      call D3dB_cr_mpfft3b(1,1,n,A)

      indx1=1
      indx2=1
      done = .false.
      do while (.not.done)
        if (indx1.le.n) then
           call D3dB_cr_pfft3b_queuein(1,A(1,indx1))
           indx1 = indx1 + 1
        end if

        if ((D3dB_cr_pfft3_queue_filled()).or.(indx1.gt.n)) then
           call D3dB_cr_pfft3b_queueout(1,A(1,indx2))
           indx2 = indx2 + 1
        end if
        done = ((indx1.gt.n).and.(indx2.gt.n))
      end do

      return
      end



*     ****************************
*     *                		 *
*     *    	Grsm_hg_fftf 	 *
*     *                		 *
*     ****************************
*
*     A = FFT[A]
*     uses - D3dB_rc_fft3f,Pack_c_mpack

      subroutine Grsm_hg_fftf(nfft3d,n,A)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)

*     **** local variables ****
      integer k


      !call D3dB_nrc_fft3f(1,n,A)
      do k=1,n
        call D3dB_rc_fft3f(1,A(1,k))
      end do
      call Pack_c_mpack(1,n,A)

      return
      end


*     ****************************
*     *                		 *
*     *    	Grsm_g_mask 	 *
*     *                		 *
*     ****************************
*
*     uses - mask_C

      subroutine Grsm_g_mask(nfft3d,n,nb,A)
      implicit none
      integer nfft3d,n,nb
      complex*16 A(nfft3d,n)

*     **** local variables ****
      integer k


      do k=1,n
        call mask_C(nb,A(1,k))
      end do

      return
      end

*     ****************************
*     *                		 *
*     *    	Grsm_ggm_dot 	 *
*     *                		 *
*     ****************************
*
*     uses - 

      subroutine Grsm_ggm_dot(nfft3d,n,A,B,MM)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)
      real*8     MM(n,n)

*     **** local variables ****
      integer j,k,np
      real*8 sum

      call Parallel_np(np)
      call dcopy(n*n,0.0d0,0,MM,1)
      do k=1,n
      do j=1,n
       call Pack_cc_idot(1,A(1,j),B(1,k),sum) 
       MM(j,k) = sum
      end do
      end do
      if (np.gt.1) call D3dB_Vector_Sumall(n*n,MM)

      return
      end



*     ****************************
*     *                          *
*     *        Grsm_ggm2_dot     *
*     *                          *
*     ****************************
*
*     uses -

      subroutine Grsm_ggm2_dot(nfft3d,n,A,B,MM,m)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)

      integer m
      real*8     MM(m,m)

*     **** local variables ****
      integer j,k,np
      real*8 sum

      call Parallel_np(np)
      call dcopy(m*m,0.0d0,0,MM,1)
      do k=1,n
      do j=1,n
       call Pack_cc_idot(1,A(1,j),B(1,k),sum)
       MM(j,k) = sum
      end do
      end do
      if (np.gt.1) call D3dB_Vector_Sumall(m*m,MM)

      return
      end

*     ********************************
*     *                              *
*     *        Grsm_ggm2_sym_dot     *
*     *                              *
*     ********************************
*
*     uses -

      subroutine Grsm_ggm2_sym_dot(nfft3d,n,A,B,MM,m)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)

      integer m
      real*8     MM(m,m)

*     **** local variables ****
      integer j,k,np
      real*8 sum

      call Parallel_np(np)
      call dcopy(m*m,0.0d0,0,MM,1)
      do k=1,n
         call Pack_cc_idot(1,A(1,k),B(1,k),sum)
         MM(k,k) = sum
        do j=k+1,n
         call Pack_cc_idot(1,A(1,j),B(1,k),sum)
         MM(j,k) = sum
         MM(k,j) = sum
        end do
      end do
      if (np.gt.1) call D3dB_Vector_Sumall(m*m,MM)


      return
      end


*     ****************************
*     *                          *
*     *     Grsm_ggm_sym_dot     *
*     *                          *
*     ****************************
*
      subroutine Grsm_ggm_sym_dot(nfft3d,n,A,B,MM)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)
      real*8     MM(n,n)

*     **** local variables ****
      integer j,k,np
      real*8 sum

      call Parallel_np(np)
      call dcopy(n*n,0.0d0,0,MM,1)
      do k=1,n
         call Pack_cc_idot(1,A(1,k),B(1,k),sum)
         MM(k,k) = sum
        do j=k+1,n
         call Pack_cc_idot(1,A(1,j),B(1,k),sum)
         MM(j,k) = sum
         MM(k,j) = sum
        end do
      end do
      if (np.gt.1) call D3dB_Vector_Sumall(n*n,MM)

      return
      end


*     ****************************
*     *                		 *
*     *    	Grsm_ggm_dot2 	 *
*     *                		 *
*     ****************************
*
*     uses - 

      subroutine Grsm_ggm_dot2(nfft3d,m,n,A,B,MM)
      implicit none
      integer nfft3d,m,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)
      real*8     MM(m,m)

*     **** local variables ****
      integer j,k,np
      real*8 sum

      call Parallel_np(np)
      call dcopy(m*m,0.0d0,0,MM,1)
      do k=1,n
      do j=1,n
c       call D3dB_cc_idot(1,A(1,j),B(1,k),sum)
       call Pack_cc_idot(1,A(1,j),B(1,k),sum) 
       MM(j,k) = sum
      end do
      end do
      if (np.gt.1) call D3dB_Vector_Sumall(m*m,MM)

      return
      end


*     ****************************
*     *                		 *
*     *    	Grsm_gg_trace 	 *
*     *                		 *
*     ****************************
*
*     uses - 

      subroutine Grsm_gg_trace(nfft3d,n,A,B,MM)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)
      real*8     MM

*     **** local variables ****
      integer j,np
      real*8 sum

*     **** common block for pack ****
      integer nida(0:1),nidb(0:1)
      integer pack(2,0:1)
      common / pack_blk / pack,nida,nidb


*     **** external functions ****
      real*8   ddot
      external ddot


      call Parallel2d_np_i(np)
      MM = 0.0d0
      do j=1,n
c        call Pack_cc_idot(1,A(1,j),B(1,j),sum)
c        MM = MM + sum
        MM = MM 
     >     + ddot(2*nida(1),A(1,j),1,B(1,j),1)
     >     + 2*ddot(2*nidb(1),A(nida(1)+1,j),1,B(nida(1)+1,j),1)
      end do
      if (np.gt.1) call D3dB_SumAll(MM)

      return
      end


*     ****************************
*     *                          *
*     *         Grsm_gg_itrace    *
*     *                          *
*     ****************************
* 
*     uses - 

      subroutine Grsm_gg_itrace(nfft3d,n,A,B,MM)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)
      complex*16 B(nfft3d,n)
      real*8     MM

*     **** local variables ****
      integer j,np
      real*8 sum

*     **** common block for pack ****
      integer nida(0:1),nidb(0:1)
      integer pack(2,0:1)
      common / pack_blk / pack,nida,nidb


*     **** external functions ****
      real*8   ddot
      external ddot


c      call Parallel2d_np_i(np)
      MM = 0.0d0
      do j=1,n
c        call Pack_cc_idot(1,A(1,j),B(1,j),sum)
c        MM = MM + sum
        MM = MM
     >     + ddot(2*nida(1),A(1,j),1,B(1,j),1)
     >     + 2*ddot(2*nidb(1),A(nida(1)+1,j),1,B(nida(1)+1,j),1)
      end do
c      if (np.gt.1) call D3dB_SumAll(MM)

      return
      end




*     ****************************
*     *                		 *
*     *    Grsm_h_Zero_Ends	 *
*     *                		 *
*     ****************************
*
*     uses - 

      subroutine Grsm_h_Zero_Ends(nfft3d,n,A)
      implicit none
      integer nfft3d,n
      complex*16 A(nfft3d,n)

*     **** local variables ****
      integer k

      do k=1,n
        call D3dB_r_Zero_Ends(1,A(1,k))
      end do

      return
      end


*     ****************************
*     *                		 *
*     *    Grsm_g_project	 *
*     *                		 *
*     ****************************
*

      subroutine Grsm_g_project(nfft3d,n,Z,Y,YtZ)
      implicit none
      integer	 nfft3d,n
      complex*16 Z(nfft3d,n)
      complex*16 Y(nfft3d,n)
      real*8     YtZ(n,n)

*     ***** local variables *****
      integer i,j,np
      real*8  sum

      call Parallel2d_np_i(np)
      do j=1,n
         do i=1,n
c            call D3dB_cc_idot(1,Y(1,i),Z(1,j),sum)
            call Pack_cc_idot(1,Y(1,i),Z(1,j),sum)
            YtZ(i,j) = sum
         end do
      end do
      if (np.gt.1) call D3dB_Vector_Sumall(n*n,YtZ)


      return
      end


*     **************************************
*     *                                    *
*     *              Grsm_g_QR             *
*     *                                    *
*     **************************************

*     This routine calculates the QR decomposition
* 
*       A-->QR
*
*     Entry - npack,ne,Q
*     Exit  - Q,R

      subroutine Grsm_g_QR(npack,ne,Q,R)
      implicit none
      integer npack,ne
      complex*16 Q(npack,ne)
      real*8     R(ne,ne)

*     **** local variables ****
      integer j,k
      real*8  w

      call dcopy(ne*ne,0.0d0,0,R,1)
      do k=1,ne
         call Pack_cc_dot(1,Q(1,k),Q(1,k),w)
         R(k,k) = dsqrt(w)
         w = 1.0d0/R(k,k)
         call Pack_c_SMul(1,w,Q(1,k),Q(1,k))

         do j=k+1,ne
            call Pack_cc_dot(1,Q(1,k),Q(1,j),w)
            R(k,j) = w
            w = -w
            call Pack_cc_daxpy(1,w,Q(1,k),Q(1,j))
         end do
      end do

      return
      end 

c $Id: kgdtest.F 19708 2010-10-29 18:04:21Z d3y133 $
      logical function kgdtest (rtdb)
      implicit none
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "global.fh"
#include "stdio.fh"
c::passed
      integer rtdb          ! rtdb handle
c::local
      integer me
      integer kgdtask, kgd_tmp
c
      call ga_sync()
      call ga_sync()
      kgdtask = 0
      if (rtdb_get(rtdb,'kgdtask',MT_INT,1,kgd_tmp))
     &    kgdtask = kgd_tmp
c
      call ga_sync()
      call ga_sync()
      me = ga_nodeid()
      write (luout,*) 'in kgdtest'
      call util_flush(luout)
c
      if (kgdtask.eq.0) then    !...................................   0
        if (me.eq.0) then
          write(luout,*)' default kgdtest task '
          write(luout,*)' test use of kgdtest! '
        endif
        kgdtest = .true.
      else if (kgdtask.eq.1) then !.................................   1
        if (me.eq.0) write(luout,*)
     &      ' kgdtest task 1: relativistic integral test'
        call kgdtest_rel1e(rtdb)
        kgdtest = .true.
      else if (kgdtask.eq.2) then !.................................   2
        if (me.eq.0) write(luout,*)
     &      ' kgdtest task 2: general contraction test'
        call kgdtest_gencon(rtdb)
        kgdtest = .true.
      else if (kgdtask.eq.3) then !.................................   3
        if (me.eq.0) write(luout,*)
     &      ' kgdtest task 3: so-ecp integral test'
        call kgdtest_soecp(rtdb)
        kgdtest = .true.
      else if (kgdtask.eq.4) then !.................................   4
        if (me.eq.0) write(luout,*)
     &      ' kgdtest task 4: rel2e integral test'
        call kgdtest_rel2e(rtdb)
        kgdtest = .true.
      else if (kgdtask.eq.5) then !.................................   5
        if (me.eq.0) write(luout,*)
     &      ' kgdtest task 5: ecp memory test'
        call kgdtest_ecpmem(rtdb)
        kgdtest = .true.
      else if (kgdtask.eq.6) then !.................................   6
        if (me.eq.0) write(luout,*)
     &      ' kgdtest task 6: rel general contraction integral test'
        call kgdtest_relgen(rtdb)
        kgdtest = .true.
      end if
      end
************************************************************************
      subroutine kgdtest_rel1e(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "geom.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
c
      logical int_normalize
      external int_normalize
c
c test relativistic one-electron integrals
c
      integer rtdb
      integer geom,basis, basis_id
      integer nshell, memscr, membuf
      integer h_scr, k_scr, h_buf, k_buf
      integer ish, jsh, ucont
      integer li, i_prim, i_gen, i_iexp, i_icfp, i_cent, i_geom
      integer lj, j_prim, j_gen, j_iexp, j_icfp, j_cent, j_geom
C      integer nint_out
      integer ihi,jhi
      logical status
      character*255 mo_basis, geom_name
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      mo_basis = 'ao basis'
      geom_name = 'geometry'
c
      if(.not.geom_create(geom,geom_name))call errquit
     &    ('kgdtest_rel1e: geom create error',911, GEOM_ERR)
      if(.not.bas_create(basis,mo_basis))call errquit
     &    ('kgdtest_rel1e: basis create error',911, BASIS_ERR)
c
      if(.not.geom_rtdb_load(rtdb,geom,geom_name)) call errquit
     &    ('kgdtest_rel1e: geom load ',911, RTDB_ERR)
      if(.not.bas_rtdb_load(rtdb,geom,basis,mo_basis)) call errquit
     &    ('kgdtest_rel1e: basis load ',911, RTDB_ERR)
c
      basis_id = basis + BASIS_HANDLE_OFFSET
      nshell = ncont_tot_gb(basis_id)
      if (.not.int_normalize(rtdb,basis)) call errquit
     &    ('kgdtest_rel1e: error normalizing ',911, INT_ERR)
c
      call int_init(rtdb,1,basis)
      memscr = 100 000
      membuf = 1000
      if (.not.ma_push_get(mt_dbl,memscr,' scratch ',
     &    h_scr, k_scr)) call errquit
     &    (' ma error 1',911, MA_ERR)
      if (.not.ma_push_get(mt_dbl,membuf*3,' buf ',
     &    h_buf, k_buf)) call errquit
     &    (' ma error 2',911, MA_ERR)
c
      do ish = 1,nshell
        do jsh = 1,ish
          write(6,*)' ============= shells <',ish,'|',jsh,'>',
     &        '==================== start =========='
          write(6,*)' '
          
          ucont = (sf_ibs_cn2ucn(ish,basis_id))
          Li      = infbs_cont(CONT_TYPE ,ucont,basis_id)
          i_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
          i_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
          i_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
          i_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
          i_cent  = (sf_ibs_cn2ce(ish,basis_id))
          i_geom  = ibs_geom(basis_id)
          ihi = i_gen*(Li+1)*(Li+2)/2
c
          ucont = (sf_ibs_cn2ucn(jsh,basis_id))
          Lj      = infbs_cont(CONT_TYPE ,ucont,basis_id)
          j_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
          j_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
          j_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
          j_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
          j_cent  = (sf_ibs_cn2ce(jsh,basis_id))
          j_geom  = ibs_geom(basis_id)
          jhi = j_gen*(Lj+1)*(Lj+2)/2
*
*   Calculate overlap and kinetic energy integrals
*
      call int_hf1sp(
     &        coords(1,i_cent,i_geom),
     &        dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),i_prim,i_gen,Li,i_cent,
     &        coords(1,j_cent,j_geom),
     &        dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),j_prim,j_gen,Lj,j_cent,
     &        coords(1,1,i_geom),charge(1,i_geom),ncenter(i_geom),
     &        dbl_mb(k_buf),dbl_mb(k_buf+1000),dbl_mb(k_buf+2000),
     &        .true.,.true.,.false.,.false.,
     &        .false.,dbl_mb(k_scr),memscr,'kgdtest_rel1e')
          call ecp_matpr (dbl_mb(k_buf),1,jhi,1,ihi,1,jhi,1,ihi,
     &        'overlap integrals','E',120,8)
          call ecp_matpr (dbl_mb(k_buf+1000),1,jhi,1,ihi,1,jhi,1,ihi,
     &        'kinetic integrals','E',120,8)
C     modified metric
          call rel_onel (
     &        coords(1,i_cent,i_geom),
     &        dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),i_prim,i_gen,Li,
     &        coords(1,j_cent,j_geom),
     &        dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),j_prim,j_gen,Lj,
     &        coords(1,1,i_geom),charge(1,i_geom),
     &        geom_invnucexp(1,i_geom),ncenter(i_geom),
     &        dbl_mb(k_buf),dbl_mb(k_buf+1000),dbl_mb(k_buf+2000),
     &        membuf,.true.,.false.,.false.,.false.,.true.,.false.,
     &        .false.,.false.,dbl_mb(k_scr),memscr,0,1)
          call ecp_matpr (dbl_mb(k_buf),1,jhi,1,ihi,1,jhi,1,ihi,
     &        'modified overlap integrals','E',120,8)
C     modified kinetic energy
          call rel_onel (
     &        coords(1,i_cent,i_geom),
     &        dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),i_prim,i_gen,Li,
     &        coords(1,j_cent,j_geom),
     &        dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),j_prim,j_gen,Lj,
     &        coords(1,1,i_geom),charge(1,i_geom),
     &        geom_invnucexp(1,i_geom),ncenter(i_geom),
     &        dbl_mb(k_buf),dbl_mb(k_buf+1000),dbl_mb(k_buf+2000),
     &        membuf,.false.,.true.,.false.,.false.,.true.,.false.,
     &        .false.,.false.,dbl_mb(k_scr),memscr,0,1)
          call ecp_matpr (dbl_mb(k_buf+1000),1,jhi,1,ihi,1,jhi,1,ihi,
     &        'modified kinetic integrals','E',120,8)
C     modified potential energy
          call rel_onel (
     &        coords(1,i_cent,i_geom),
     &        dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),i_prim,i_gen,Li,
     &        coords(1,j_cent,j_geom),
     &        dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),j_prim,j_gen,Lj,
     &        coords(1,1,i_geom),charge(1,i_geom),
     &        geom_invnucexp(1,i_geom),ncenter(i_geom),
     &        dbl_mb(k_buf),dbl_mb(k_buf+1000),dbl_mb(k_buf+2000),
     &        membuf,.false.,.false.,.true.,.false.,.true.,.false.,
     &        .false.,.false.,dbl_mb(k_scr),memscr,0,1)
          call ecp_matpr (dbl_mb(k_buf+2000),1,jhi,1,ihi,1,jhi,1,ihi,
     &        'modified potential integrals','E',120,8)
          write(6,*)' ============= shells <',ish,'|',jsh,'>',
     &          '====================  end  =========='
          write(6,*)' '
        enddo
      enddo
c      
      call int_terminate()
      status = ma_pop_stack(h_buf)
      status = status.and.ma_pop_stack(h_scr)
      if (.not.status) call errquit('pop failed',911, MA_ERR)
      status = bas_destroy(basis)
      status = status.and.geom_destroy(geom)
      if (.not.status) call errquit('b/g destroy failed',911, GEOM_ERR)
      return
      end
************************************************************************
      subroutine kgdtest_gencon(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "geom.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "stdio.fh"
c
      logical int_normalize
      external int_normalize
      integer idamax
      external idamax
c
c test general contraction in McMD 2e integrals.
c
      integer rtdb
      integer geom,basis, basis_id
      integer nshell, memscr, membuf
      integer h_scr, k_scr, h_buf, k_buf
      integer ish, jsh, ksh,lsh, ucont
      integer li, i_prim, i_gen, i_iexp, i_icfp, i_cent, i_geom
      integer lj, j_prim, j_gen, j_iexp, j_icfp, j_cent, j_geom
      integer lk, k_prim, k_gen, k_iexp, k_icfp, k_cent, k_geom
      integer ll, l_prim, l_gen, l_iexp, l_icfp, l_cent, l_geom
      integer Nints
      integer i_eri,i_c,j_c,k_c,l_c,ic,jc,kc,lc,i_seg
      integer ihi,jhi,khi,lhi,i2,j2,k2,l2,n_cart,n_cont
      character*255 mo_basis, geom_name
      double precision difmax
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      mo_basis = 'ao basis'
      geom_name = 'geometry'
c
      if(.not.geom_create(geom,geom_name))call errquit
     &    ('kgdtest_gencon: geom create error',911, GEOM_ERR)
      if(.not.bas_create(basis,mo_basis))call errquit
     &    ('kgdtest_gencon: basis create error',911, BASIS_ERR)
c
      if(.not.geom_rtdb_load(rtdb,geom,geom_name)) call errquit
     &    ('kgdtest_gencon: geom load ',911, RTDB_ERR)
      if(.not.bas_rtdb_load(rtdb,geom,basis,mo_basis)) call errquit
     &    ('kgdtest_gencon: basis load ',911, RTDB_ERR)
c
      basis_id = basis + BASIS_HANDLE_OFFSET
      nshell = ncont_tot_gb(basis_id)
      if (.not.int_normalize(rtdb,basis)) call errquit
     &    ('kgdtest_gencon: error normalizing ',911, INT_ERR)
c
      call int_init(rtdb,1,basis)
      memscr = 1 000 000
      membuf = 10 000
      if (.not.ma_push_get(mt_dbl,memscr,' scratch ',
     &    h_scr, k_scr)) call errquit
     &    (' ma error 1',911, MA_ERR)
      if (.not.ma_push_get(mt_dbl,membuf,' buf ',
     &    h_buf, k_buf)) call errquit
     &    (' ma error 2',911, MA_ERR)
c
      difmax = 0.0d0
      do ish = 1,nshell
        ucont = (sf_ibs_cn2ucn(ish,basis_id))
        Li      = infbs_cont(CONT_TYPE ,ucont,basis_id)
        i_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
        i_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
        i_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
        i_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
        i_cent  = (sf_ibs_cn2ce(ish,basis_id))
        i_geom  = ibs_geom(basis_id)
        i2 = (Li+1)*(Li+2)/2
        ihi = i_gen*i2
c
        do jsh = 1,ish
          ucont = (sf_ibs_cn2ucn(jsh,basis_id))
          Lj      = infbs_cont(CONT_TYPE ,ucont,basis_id)
          j_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
          j_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
          j_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
          j_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
          j_cent  = (sf_ibs_cn2ce(jsh,basis_id))
          j_geom  = ibs_geom(basis_id)
          j2 = (Lj+1)*(Lj+2)/2
          jhi = j_gen*j2
c
          do ksh = 1,ish
            ucont = (sf_ibs_cn2ucn(ksh,basis_id))
            Lk      = infbs_cont(CONT_TYPE ,ucont,basis_id)
            k_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
            k_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
            k_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
            k_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
            k_cent  = (sf_ibs_cn2ce(ish,basis_id))
            k_geom  = ibs_geom(basis_id)
            k2 = (Lk+1)*(Lk+2)/2
            khi = k_gen*k2
c
            do lsh = 1,ksh
              ucont = (sf_ibs_cn2ucn(lsh,basis_id))
              Ll      = infbs_cont(CONT_TYPE ,ucont,basis_id)
              l_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
              l_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
              l_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
              l_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
              l_cent  = (sf_ibs_cn2ce(lsh,basis_id))
              l_geom  = ibs_geom(basis_id)
              l2 = (Ll+1)*(Ll+2)/2
              lhi = l_gen*l2
              
              n_cart = i2*j2*k2*l2
              n_cont = i_gen*j_gen*k_gen*l_gen
              Nints = ihi*jhi*khi*lhi
              write (LuOut,*) ish,Li,i_prim,i_gen,i_cent
              write (LuOut,*) jsh,Lj,j_prim,j_gen,j_cent
              write (LuOut,*) ksh,Lk,k_prim,k_gen,k_cent
              write (LuOut,*) lsh,Ll,l_prim,l_gen,l_cent
C              if (n_cont .gt. 1 .and. Li.ne.Lj .and. Lk.ne.Ll) then
C                write(luout,*)' '
C                write(luout,*)' ============= (',
C     &              ish,':',Li,',',
C     &              jsh,':',Lj,'|',
C     &              ksh,':',Lk,',',
C     &              lsh,':',Ll,')',
C     &              '===================='
C                write(luout,*)' '
                write (luout,*) 'Nints',Nints

                call hf2(
     &            coords(1,i_cent,i_geom),
     &              dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &              dbl_mb(mb_exndcf(i_icfp,basis_id)),i_prim,i_gen,Li,
     &              coords(1,j_cent,j_geom),
     &              dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &              dbl_mb(mb_exndcf(j_icfp,basis_id)),j_prim,j_gen,Lj,
     &              coords(1,k_cent,k_geom),
     &              dbl_mb(mb_exndcf(k_iexp,basis_id)),
     &              dbl_mb(mb_exndcf(k_icfp,basis_id)),k_prim,k_gen,Lk,
     &              coords(1,l_cent,l_geom),
     &              dbl_mb(mb_exndcf(l_iexp,basis_id)),
     &              dbl_mb(mb_exndcf(l_icfp,basis_id)),l_prim,l_gen,Ll,
     &              dbl_mb(k_buf),Nints,.false.,.false.,.false.,
     &              .false.,dbl_mb(k_scr),memscr)
              
                i_eri = k_buf+Nints
                i_seg = i_eri
                i_c = i_icfp
                do ic = 1,i_gen
                  j_c = j_icfp
                  do jc = 1,j_gen
                    k_c = k_icfp
                    do kc = 1,k_gen
                      l_c = l_icfp
                      do lc = 1,l_gen
C                        write (luout,*) 'ic,jc,kc,lc',ic,jc,kc,lc
                        call hf2(
     &                      coords(1,i_cent,i_geom),
     &                      dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &                      dbl_mb(mb_exndcf(i_c,basis_id)),
     &                      i_prim,1,Li,
     &                      coords(1,j_cent,j_geom),
     &                      dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &                      dbl_mb(mb_exndcf(j_c,basis_id)),
     &                      j_prim,1,Lj,
     &                      coords(1,k_cent,k_geom),
     &                      dbl_mb(mb_exndcf(k_iexp,basis_id)),
     &                      dbl_mb(mb_exndcf(k_c,basis_id)),
     &                      k_prim,1,Lk,
     &                      coords(1,l_cent,l_geom),
     &                      dbl_mb(mb_exndcf(l_iexp,basis_id)),
     &                      dbl_mb(mb_exndcf(l_c,basis_id)),
     &                      l_prim,1,Ll,
     &                      dbl_mb(i_eri),Nints,.false.,.false.,.false.,
     &                      .false.,dbl_mb(k_scr),memscr)

                        i_eri = i_eri+i2*j2*k2*l2
                        l_c = l_c+l_prim
                      end do
                      k_c = k_c+k_prim
                    end do
                    j_c = j_c+j_prim
                  end do
                  i_c = i_c+i_prim
                end do

                call reorder_2eints(dbl_mb(i_eri),dbl_mb(i_seg),
     &              l2,l_gen,k2,k_gen,j2,j_gen,i2,i_gen)
                call dcopy (Nints,dbl_mb(i_eri),1,dbl_mb(i_seg),1)
                call daxpy(Nints,-1.0d0,dbl_mb(k_buf),1,dbl_mb(i_eri),1)
                ic = idamax(Nints,dbl_mb(i_eri),1)-1
                write (luout,*) 'Maximum difference',dbl_mb(i_eri+ic)
                difmax = max(difmax,abs(dbl_mb(i_eri+ic)))
                if (abs(dbl_mb(i_eri+ic)) .gt. 1.0d-12) then
                  call ecp_matpr (dbl_mb(k_buf),1,khi*lhi,1,ihi*jhi,
     &                1,khi*lhi,1,ihi*jhi,'General contraction',
     &                'E',120,6)
                  call ecp_matpr (dbl_mb(i_seg),1,khi*lhi,1,ihi*jhi,
     &                1,khi*lhi,1,ihi*jhi,'Segmented contraction',
     &                'E',120,6)
                end if
C              end if
            end do
          end do
        end do
      end do
      write (luout,*) 'Maximum difference of all blocks',difmax

      end
************************************************************************
      subroutine reorder_2eints(bnew,bold,lc,lg,kc,kg,jc,jg,ic,ig)
      double precision bnew(lc,lg,kc,kg,jc,jg,ic*ig)
      double precision bold(lc,kc,jc,ic,lg,kg,jg*ig)
      integer lc,lg,kc,kg,jc,jg,ic,ig
      integer i,j,k,l,ii,jj,kk,ll,inew,iold
      iold = 0
      inew = 0
      do i = 1,ig
        do j = 1,jg
          iold = iold+1
          do k = 1,kg
            do l = 1,lg
              do ii = 1,ic
                do jj = 1,jc
                  do kk = 1,kc
                    do ll = 1,lc
                      bnew(ll,l,kk,k,jj,j,inew+ii) =
     &                    bold(ll,kk,jj,ii,l,k,iold)
                    end do
                  end do
                end do
              end do
            end do
          end do
        end do
        inew = inew+ic
      end do
      end

************************************************************************
      subroutine kgdtest_soecp(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "geom.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "ecp_nwc.fh"
#include "stdio.fh"
c
      logical int_normalize
      external int_normalize
      integer idamax
      external idamax
c
c test spin-orbit integrals
c
      integer rtdb
      integer geom,basis, basis_id
      integer nshell, memscr, membuf
      integer h_scr, k_scr, h_buf, k_buf
      integer ish, jsh, ucont
      integer li, i_prim, i_gen, i_iexp, i_icfp, i_cent, i_geom
      integer lj, j_prim, j_gen, j_iexp, j_icfp, j_cent, j_geom
      integer ihi,jhi,i2,j2
      integer ibug,n_blk
      character*255 mo_basis, geom_name
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      mo_basis = 'ao basis'
      geom_name = 'geometry'
c
      if(.not.geom_create(geom,geom_name))call errquit
     &    ('kgdtest_gencon: geom create error',911, GEOM_ERR)
      if(.not.bas_create(basis,mo_basis))call errquit
     &    ('kgdtest_gencon: basis create error',911, BASIS_ERR)
c
      if(.not.geom_rtdb_load(rtdb,geom,geom_name)) call errquit
     &    ('kgdtest_gencon: geom load ',911, RTDB_ERR)
      if(.not.bas_rtdb_load(rtdb,geom,basis,mo_basis)) call errquit
     &    ('kgdtest_gencon: basis load ',911, RTDB_ERR)
c
      basis_id = basis + BASIS_HANDLE_OFFSET
      nshell = ncont_tot_gb(basis_id)
      if (.not.int_normalize(rtdb,basis)) call errquit
     &    ('kgdtest_gencon: error normalizing ',911, INT_ERR)
c
      call int_init(rtdb,1,basis)
      memscr = 1 000 000
      membuf = 10 000
      if (.not.ma_push_get(mt_dbl,memscr,' scratch ',
     &    h_scr, k_scr)) call errquit
     &    (' ma error 1',911, MA_ERR)
      if (.not.ma_push_get(mt_dbl,membuf,' buf ',
     &    h_buf, k_buf)) call errquit
     &    (' ma error 2',911, MA_ERR)
c
      if (.not. rtdb_get(rtdb,'ecp:ibug',mt_int,1,ibug))
     &    ibug = 3
      if (.not. rtdb_get(rtdb,'ecp:n_blk',mt_int,1,n_blk))
     &    n_blk = 3
c
      do ish = 1,nshell
        ucont = (sf_ibs_cn2ucn(ish,basis_id))
        Li      = infbs_cont(CONT_TYPE ,ucont,basis_id)
        i_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
        i_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
        i_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
        i_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
        i_cent  = (sf_ibs_cn2ce(ish,basis_id))
        i_geom  = ibs_geom(basis_id)
        i2 = (Li+1)*(Li+2)/2
        ihi = i_gen*i2
c
        do jsh = 1,ish
          ucont = (sf_ibs_cn2ucn(jsh,basis_id))
          Lj      = infbs_cont(CONT_TYPE ,ucont,basis_id)
          j_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
          j_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
          j_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
          j_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
          j_cent  = (sf_ibs_cn2ce(jsh,basis_id))
          j_geom  = ibs_geom(basis_id)
          j2 = (Lj+1)*(Lj+2)/2
          jhi = j_gen*j2

          write(luout,*)' '
          write(luout,*)' ============= ',ish,jsh,
     &        '===================='
          write(luout,*)' '

          call ecp_integral (
     &        coords(1,i_cent,i_geom),
     &        dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),i_prim,i_gen,Li,i_cent,
     &        coords(1,j_cent,j_geom),
     &        dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),j_prim,j_gen,Lj,j_cent,
     &        dbl_mb(k_xyzecp),
     &        dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &        int_mb(k_ecp_nprim_c),
     &        int_mb(k_ecp_ncoef_c), ! new name is n_colc_C
     &        int_mb(k_ecp_ind_z),
     &        int_mb(k_ecp_ind_c),
     &        n_zeta_c,
     &        n_zeta_c,
     &        int_mb(k_ecp_l_c),
     &        int_mb(k_ecp_lip), 
     &        n_ecp,l_ecp,
     &        0,
     &        dbl_mb(k_ecp_c2s),mem_c2s,
     &        dbl_mb(k_buf),ihi*jhi,n_blk, 
     &        .false.,dbl_mb(k_scr),memscr,
     &        ibug)               

        end do
      end do
      call int_terminate()
      end
************************************************************************
      subroutine kgdtest_rel2e(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "geom.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "apiP.fh"
#include "rel_nwc.fh"
#include "stdio.fh"
c
      logical int_normalize
      external int_normalize
      integer idamax
      external idamax
c
c test relativistic 2e integrals for correct magnitude
c
      integer rtdb
      integer geom, basis, basis_id
      integer nshell, memscr, membuf
      integer h_scr, k_scr, h_buf, k_buf
      integer ish, jsh, ksh,lsh, ucont
      integer li, ipr, igc, iex, icf, icfs, ice, igm
      integer lj, jpr, jgc, jex, jcf, jcfs, jce, jgm
      integer lk, kpr, kgc, kex, kcf, kcfs, kce, kgm
      integer ll, lpr, lgc, lex, lcf, lcfs, lce, lgm
      integer Nints
      integer i_eri,i,abas,sbas
      integer ihi,jhi,khi,lhi,i2,j2,k2,l2,n_cart,n_cont
      character*255 mo_basis, geom_name
      double precision difmax,errmax,dif,erimax
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      mo_basis = 'ao basis'
      geom_name = 'geometry'
c
      if(.not.geom_create(geom,geom_name))call errquit
     &    ('kgdtest_rel2e: geom create error',911, GEOM_ERR)
      if(.not.bas_create(basis,mo_basis))call errquit
     &    ('kgdtest_rel2e: basis create error',911, BASIS_ERR)
c
      if(.not.geom_rtdb_load(rtdb,geom,geom_name)) call errquit
     &    ('kgdtest_rel2e: geom load ',911, GEOM_ERR)
      if(.not.bas_rtdb_load(rtdb,geom,basis,mo_basis)) call errquit
     &    ('kgdtest_rel2e: basis load ',911, BASIS_ERR)
c
      basis_id = basis + BASIS_HANDLE_OFFSET
      nshell = ncont_tot_gb(basis_id)
      if (.not.int_normalize(rtdb,basis)) call errquit
     &    ('kgdtest_rel2e: error normalizing ',911, INT_ERR)
c
      call int_init(rtdb,1,basis)
      memscr = 5 000 000
      membuf = 100 000
      if (.not.ma_push_get(mt_dbl,memscr,' scratch ',
     &    h_scr, k_scr)) call errquit
     &    (' ma error 1',911, MA_ERR)
      if (.not.ma_push_get(mt_dbl,membuf,' buf ',
     &    h_buf, k_buf)) call errquit
     &    (' ma error 2',911, MA_ERR)
c
      sbas = sc_bsh + BASIS_HANDLE_OFFSET
      abas = ao_bsh + BASIS_HANDLE_OFFSET
c
      difmax = 0.0d0
      errmax = 0.0d0
      rel_dbg = 3
C      do ish = 1,nshell
C      do ish = 2,12,10
      ish = 12
        ucont = (sf_ibs_cn2ucn(ish,abas))
        Li   = infbs_cont(CONT_TYPE ,ucont,abas)
        ipr  = infbs_cont(CONT_NPRIM,ucont,abas)
        igc  = infbs_cont(CONT_NGEN ,ucont,abas)
        iex  = infbs_cont(CONT_IEXP ,ucont,abas)
        icf  = infbs_cont(CONT_ICFP ,ucont,abas)
        ice  = (sf_ibs_cn2ce(ish,abas))
        igm  = ibs_geom(abas)
        i2 = (Li+1)*(Li+2)/2
        ihi = igc*i2
        ucont = ao_to_ls(ucont)
        icfs = infbs_cont(CONT_ICFP ,ucont,sbas)
c
C        do jsh = 1,ish
        jsh = 11
C        jsh = ish-1
          ucont = (sf_ibs_cn2ucn(jsh,abas))
          Lj   = infbs_cont(CONT_TYPE ,ucont,abas)
          jpr  = infbs_cont(CONT_NPRIM,ucont,abas)
          jgc  = infbs_cont(CONT_NGEN ,ucont,abas)
          jex  = infbs_cont(CONT_IEXP ,ucont,abas)
          jcf  = infbs_cont(CONT_ICFP ,ucont,abas)
          jce  = (sf_ibs_cn2ce(jsh,abas))
          jgm  = ibs_geom(abas)
          j2 = (Lj+1)*(Lj+2)/2
          jhi = jgc*j2
          ucont = ao_to_ls(ucont)
          jcfs = infbs_cont(CONT_ICFP ,ucont,sbas)
c
C          do ksh = 1,ish
          ksh = 1
            ucont = (sf_ibs_cn2ucn(ksh,abas))
            Lk   = infbs_cont(CONT_TYPE ,ucont,abas)
            kpr  = infbs_cont(CONT_NPRIM,ucont,abas)
            kgc  = infbs_cont(CONT_NGEN ,ucont,abas)
            kex  = infbs_cont(CONT_IEXP ,ucont,abas)
            kcf  = infbs_cont(CONT_ICFP ,ucont,abas)
            kce  = (sf_ibs_cn2ce(ksh,abas))
            kgm  = ibs_geom(abas)
            k2 = (Lk+1)*(Lk+2)/2
            khi = kgc*k2
            ucont = ao_to_ls(ucont)
            kcfs = infbs_cont(CONT_ICFP ,ucont,sbas)
c
C            do lsh = 1,ksh
            lsh = 1
              ucont = (sf_ibs_cn2ucn(lsh,abas))
              Ll   = infbs_cont(CONT_TYPE ,ucont,abas)
              lpr  = infbs_cont(CONT_NPRIM,ucont,abas)
              lgc  = infbs_cont(CONT_NGEN ,ucont,abas)
              lex  = infbs_cont(CONT_IEXP ,ucont,abas)
              lcf  = infbs_cont(CONT_ICFP ,ucont,abas)
              lce  = (sf_ibs_cn2ce(lsh,abas))
              lgm  = ibs_geom(abas)
              l2 = (Ll+1)*(Ll+2)/2
              lhi = lgc*l2
              ucont = ao_to_ls(ucont)
              lcfs = infbs_cont(CONT_ICFP ,ucont,sbas)
              
              n_cart = i2*j2*k2*l2
              n_cont = igc*jgc*kgc*lgc
              Nints = ihi*jhi*khi*lhi
              i_eri = k_buf+Nints
C              if (n_cont .gt. 1 .and. Li.ne.Lj .and. Lk.ne.Ll) then
                write(luout,*)' '
                write(luout,*)' ============= (',
     &              ish,':',Li,',',
     &              jsh,':',Lj,'|',
     &              ksh,':',Lk,',',
     &              lsh,':',Ll,')',
     &              '===================='
                write(luout,*)' '
C                write (luout,*) 'Nints',Nints

              call hf2(
     &            coords(1,ice,igm),
     &            dbl_mb(mb_exndcf(iex,abas)),
     &            dbl_mb(mb_exndcf(icf,abas)),ipr,igc,Li,
     &            coords(1,jce,jgm),
     &            dbl_mb(mb_exndcf(jex,abas)),
     &            dbl_mb(mb_exndcf(jcf,abas)),jpr,jgc,Lj,
     &            coords(1,kce,kgm),
     &            dbl_mb(mb_exndcf(kex,abas)),
     &            dbl_mb(mb_exndcf(kcf,abas)),kpr,kgc,Lk,
     &            coords(1,lce,lgm),
     &            dbl_mb(mb_exndcf(lex,abas)),
     &            dbl_mb(mb_exndcf(lcf,abas)),lpr,lgc,Ll,
     &            dbl_mb(k_buf),Nints,.false.,.false.,.false.,
     &            .false.,dbl_mb(k_scr),memscr)
                  call ecp_matpr (dbl_mb(k_buf),1,khi*lhi,1,ihi*jhi,
     &                1,khi*lhi,1,ihi*jhi,'Large component only',
     &                'E',120,6)
C              write (luout,*) 'hf2 completed'
C              call util_flush(6)
              call rel_2e4c_sf (
     &            coords(1,ice,igm),dbl_mb(mb_exndcf(iex,abas)),
     &            dbl_mb(mb_exndcf(icf,abas)),
     &            dbl_mb(mb_exndcf(icfs,sbas)),ipr,igc,Li,ice,
     &            coords(1,jce,jgm),dbl_mb(mb_exndcf(jex,abas)),
     &            dbl_mb(mb_exndcf(jcf,abas)),
     &            dbl_mb(mb_exndcf(jcfs,sbas)),jpr,jgc,Lj,jce,
     &            coords(1,kce,kgm),dbl_mb(mb_exndcf(kex,abas)),
     &            dbl_mb(mb_exndcf(kcf,abas)),
     &            dbl_mb(mb_exndcf(kcfs,sbas)),kpr,kgc,Lk,kce,
     &            coords(1,lce,lgm),dbl_mb(mb_exndcf(lex,abas)),
     &            dbl_mb(mb_exndcf(lcf,abas)),
     &            dbl_mb(mb_exndcf(lcfs,sbas)),lpr,lgc,Ll,lce,
c...................... canAB   canCD   canPQ   DryRun
     &            dbl_mb(i_eri),Nints,.false.,.false.,.false.,.false.,
     &            dbl_mb(k_scr),memscr,
     &            .true.,.true.,ss_one_cent,do_ssss,rel_dbg)

                  call ecp_matpr (dbl_mb(i_eri),1,khi*lhi,1,ihi*jhi,
     &                1,khi*lhi,1,ihi*jhi,'Relativistic integrals',
     &                'E',120,6)
C              write (luout,*) 'rel_2e4c_sf completed'
C              call util_flush(6)
              call daxpy(Nints,-1.0d0,dbl_mb(k_buf),1,dbl_mb(i_eri),1)
              dif = 0.0d0
              erimax = 0.0d0
              do i = 0,Nints-1
                erimax = max(erimax,abs(dbl_mb(k_buf+i)))
                if (abs(dbl_mb(k_buf+i)) .gt. 1.0d-12) then
                  dif = max(dif,abs(dbl_mb(i_eri+i)/dbl_mb(k_buf+i)))
                else if (abs(dbl_mb(i_eri+i)) .gt. 1.0d-12) then
                  if (abs(dbl_mb(k_buf+i)) .ne. 0.0d0) then
                    dif = max(dif,abs(dbl_mb(i_eri+i)/dbl_mb(k_buf+i)))
                  else
                    errmax = max(errmax,abs(dbl_mb(i_eri+i)))
                  end if
                end if
              end do
              difmax = max(difmax,dif)
              if (dif .gt. 0.1d0) then
                write (LuOut,*) ish,Li,ipr,igc,ice
                write (LuOut,*) jsh,Lj,jpr,jgc,jce
                write (LuOut,*) ksh,Lk,kpr,kgc,kce
                write (LuOut,*) lsh,Ll,lpr,lgc,lce
                write (LuOut,*) dif,erimax
                call util_flush(LuOut)
              end if
C            end do
C          end do
C        end do
C      end do
      write (luout,*) 'Maximum difference of all blocks',difmax
      write (luout,*) 'Maximum difference from zero integrals',errmax
      call int_terminate()

      end
************************************************************************
      subroutine kgdtest_ecpmem(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "geom.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "ecp_nwc.fh"
#include "stdio.fh"
c
      logical int_normalize
      external int_normalize
      integer idamax
      external idamax
c
c test spin-orbit integrals
c
      integer rtdb
      integer geom,basis, basis_id
      integer nshell, memscr, membuf, maxscr
      integer h_scr, k_scr, h_buf, k_buf
      integer ish, jsh, ucont
      integer li, i_prim, i_gen, i_iexp, i_icfp, i_cent, i_geom
      integer lj, j_prim, j_gen, j_iexp, j_icfp, j_cent, j_geom
      integer ihi,jhi,i2,j2
      integer ibug,n_blk
      character*255 mo_basis, geom_name
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      mo_basis = 'ao basis'
      geom_name = 'geometry'
c
      if(.not.geom_create(geom,geom_name))call errquit
     &    ('kgdtest_gencon: geom create error',911, GEOM_ERR)
      if(.not.bas_create(basis,mo_basis))call errquit
     &    ('kgdtest_gencon: basis create error',911, BASIS_ERR)
c
      if(.not.geom_rtdb_load(rtdb,geom,geom_name)) call errquit
     &    ('kgdtest_gencon: geom load ',911, RTDB_ERR)
      if(.not.bas_rtdb_load(rtdb,geom,basis,mo_basis)) call errquit
     &    ('kgdtest_gencon: basis load ',911, RTDB_ERR)
c
      basis_id = basis + BASIS_HANDLE_OFFSET
      nshell = ncont_tot_gb(basis_id)
      if (.not.int_normalize(rtdb,basis)) call errquit
     &    ('kgdtest_gencon: error normalizing ',911, INT_ERR)
c
      call int_init(rtdb,1,basis)
      memscr = 1 000 000
      membuf = 10 000
      if (.not.ma_push_get(mt_dbl,memscr,' scratch ',
     &    h_scr, k_scr)) call errquit
     &    (' ma error 1',911, MA_ERR)
      if (.not.ma_push_get(mt_dbl,membuf,' buf ',
     &    h_buf, k_buf)) call errquit
     &    (' ma error 2',911, MA_ERR)
c
      if (.not. rtdb_get(rtdb,'ecp:ibug',mt_int,1,ibug))
     &    ibug = 1
      if (.not. rtdb_get(rtdb,'ecp:n_blk',mt_int,1,n_blk))
     &    n_blk = 1
c
      maxscr = 0
      do ish = 1,nshell
        ucont = (sf_ibs_cn2ucn(ish,basis_id))
        Li      = infbs_cont(CONT_TYPE ,ucont,basis_id)
        i_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
        i_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
        i_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
        i_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
        i_cent  = (sf_ibs_cn2ce(ish,basis_id))
        i_geom  = ibs_geom(basis_id)
        i2 = (Li+1)*(Li+2)/2
        ihi = i_gen*i2
c
        do jsh = 1,ish
          ucont = (sf_ibs_cn2ucn(jsh,basis_id))
          Lj      = infbs_cont(CONT_TYPE ,ucont,basis_id)
          j_prim  = infbs_cont(CONT_NPRIM,ucont,basis_id)
          j_gen   = infbs_cont(CONT_NGEN ,ucont,basis_id)
          j_iexp  = infbs_cont(CONT_IEXP ,ucont,basis_id)
          j_icfp  = infbs_cont(CONT_ICFP ,ucont,basis_id)
          j_cent  = (sf_ibs_cn2ce(jsh,basis_id))
          j_geom  = ibs_geom(basis_id)
          j2 = (Lj+1)*(Lj+2)/2
          jhi = j_gen*j2

          write(luout,*)' '
          write(luout,*)' ============= ',ish,jsh,
     &        '===================='
          write(luout,*)' '

          call ecp_integral (
     &        coords(1,i_cent,i_geom),
     &        dbl_mb(mb_exndcf(i_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(i_icfp,basis_id)),i_prim,i_gen,Li,i_cent,
     &        coords(1,j_cent,j_geom),
     &        dbl_mb(mb_exndcf(j_iexp,basis_id)),
     &        dbl_mb(mb_exndcf(j_icfp,basis_id)),j_prim,j_gen,Lj,j_cent,
     &        dbl_mb(k_xyzecp),
     &        dbl_mb(k_ecp_e),dbl_mb(k_ecp_c),
     &        int_mb(k_ecp_nprim_c),
     &        int_mb(k_ecp_ncoef_c), ! new name is n_colc_C
     &        int_mb(k_ecp_ind_z),
     &        int_mb(k_ecp_ind_c),
     &        n_zeta_c,
     &        n_zeta_c,
     &        int_mb(k_ecp_l_c),
     &        int_mb(k_ecp_lip), 
     &        n_ecp,l_ecp,
     &        0,
     &        dbl_mb(k_ecp_c2s),mem_c2s,
     &        dbl_mb(k_buf),ihi*jhi,n_blk, 
     &        .true.,dbl_mb(k_scr),memscr,
     &        ibug)               
          maxscr = max(memscr,maxscr)

        end do
      end do
      write (luout,*) 'Maximum scratch needed:',maxscr
      call int_terminate()
      end
************************************************************************
      subroutine kgdtest_relgen(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "geom.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "apiP.fh"
#include "rel_nwc.fh"
#include "stdio.fh"
c
      logical int_normalize
      external int_normalize
      integer idamax
      external idamax
c
c test general contraction in relativistic 2e integrals.
c
      integer rtdb
      integer geom, basis, basid
      integer nshell, memscr, membuf
      integer h_scr, k_scr, h_buf, k_buf
      integer ish, jsh, ksh,lsh, ucont
      integer li, ipr, igc, iex, icf, icfs, ice, ige
      integer lj, jpr, jgc, jex, jcf, jcfs, jce, jge
      integer lk, kpr, kgc, kex, kcf, kcfs, kce, kge
      integer ll, lpr, lgc, lex, lcf, lcfs, lce, lge
      integer Nints
      integer i_eri,i_c,j_c,k_c,l_c,ic,jc,kc,lc,i_seg
      integer ihi,jhi,khi,lhi,i2,j2,k2,l2,n_cart,n_cont
      integer abas,sbas,i_cs,j_cs,k_cs,l_cs
      character*255 basis_name, geom_name
      double precision difmax
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      write (luout,*) 'in kgdtest_relgen'
      basis_name = 'ao basis'
      geom_name = 'geometry'
c
      if(.not.geom_create(geom,geom_name))call errquit
     &    ('kgdtest_relgen: geom create error',911, GEOM_ERR)
      if(.not.bas_create(basis,basis_name))call errquit
     &    ('kgdtest_relgen: basis create error',911, BASIS_ERR)
c
      if(.not.geom_rtdb_load(rtdb,geom,geom_name)) call errquit
     &    ('kgdtest_relgen: geom load ',911, GEOM_ERR)
      if(.not.bas_rtdb_load(rtdb,geom,basis,basis_name)) call errquit
     &    ('kgdtest_relgen: basis load ',911, BASIS_ERR)
c
      basid = basis + BASIS_HANDLE_OFFSET
      nshell = ncont_tot_gb(basid)
      if (.not.int_normalize(rtdb,basis)) call errquit
     &    ('kgdtest_relgen: error normalizing ',911, INT_ERR)
c
      call int_init(rtdb,1,basis)
      memscr = 5 000 000
      membuf = 100 000
      if (.not.ma_push_get(mt_dbl,memscr,' scratch ',
     &    h_scr, k_scr)) call errquit
     &    (' ma error 1',911, MA_ERR)
      if (.not.ma_push_get(mt_dbl,membuf,' buf ',
     &    h_buf, k_buf)) call errquit
     &    (' ma error 2',911, MA_ERR)
c
      sbas = sc_bsh + BASIS_HANDLE_OFFSET
      abas = ao_bsh + BASIS_HANDLE_OFFSET
      write (luout,*) ' starting shell loops ...'
c
      difmax = 0.0d0
      do ish = 1,nshell
        ucont = (sf_ibs_cn2ucn(ish,abas))
        Li      = infbs_cont(CONT_TYPE ,ucont,abas)
        ipr  = infbs_cont(CONT_NPRIM,ucont,abas)
        igc   = infbs_cont(CONT_NGEN ,ucont,abas)
        iex  = infbs_cont(CONT_IEXP ,ucont,abas)
        icf  = infbs_cont(CONT_ICFP ,ucont,abas)
        ice  = (sf_ibs_cn2ce(ish,abas))
        ige  = ibs_geom(abas)
        i2 = (Li+1)*(Li+2)/2
        ihi = igc*i2
        ucont = ao_to_ls(ucont)
        icfs = infbs_cont(CONT_ICFP ,ucont,sbas)
c
        do jsh = 1,ish
          ucont = (sf_ibs_cn2ucn(jsh,abas))
          Lj      = infbs_cont(CONT_TYPE ,ucont,abas)
          jpr  = infbs_cont(CONT_NPRIM,ucont,abas)
          jgc   = infbs_cont(CONT_NGEN ,ucont,abas)
          jex  = infbs_cont(CONT_IEXP ,ucont,abas)
          jcf  = infbs_cont(CONT_ICFP ,ucont,abas)
          jce  = (sf_ibs_cn2ce(jsh,abas))
          jge  = ibs_geom(abas)
          j2 = (Lj+1)*(Lj+2)/2
          jhi = jgc*j2
          ucont = ao_to_ls(ucont)
          jcfs = infbs_cont(CONT_ICFP ,ucont,sbas)
c
          do ksh = 1,ish
            ucont = (sf_ibs_cn2ucn(ksh,abas))
            Lk      = infbs_cont(CONT_TYPE ,ucont,abas)
            kpr  = infbs_cont(CONT_NPRIM,ucont,abas)
            kgc   = infbs_cont(CONT_NGEN ,ucont,abas)
            kex  = infbs_cont(CONT_IEXP ,ucont,abas)
            kcf  = infbs_cont(CONT_ICFP ,ucont,abas)
            kce  = (sf_ibs_cn2ce(ish,abas))
            kge  = ibs_geom(abas)
            k2 = (Lk+1)*(Lk+2)/2
            khi = kgc*k2
            ucont = ao_to_ls(ucont)
            kcfs = infbs_cont(CONT_ICFP ,ucont,sbas)
c
            do lsh = 1,ksh
              ucont = (sf_ibs_cn2ucn(lsh,abas))
              Ll      = infbs_cont(CONT_TYPE ,ucont,abas)
              lpr  = infbs_cont(CONT_NPRIM,ucont,abas)
              lgc   = infbs_cont(CONT_NGEN ,ucont,abas)
              lex  = infbs_cont(CONT_IEXP ,ucont,abas)
              lcf  = infbs_cont(CONT_ICFP ,ucont,abas)
              lce  = (sf_ibs_cn2ce(lsh,abas))
              lge  = ibs_geom(abas)
              l2 = (Ll+1)*(Ll+2)/2
              lhi = lgc*l2
              ucont = ao_to_ls(ucont)
              lcfs = infbs_cont(CONT_ICFP ,ucont,sbas)
              
              n_cart = i2*j2*k2*l2
              n_cont = igc*jgc*kgc*lgc
              Nints = ihi*jhi*khi*lhi
C              write (LuOut,*) ish,Li,ipr,igc,ice,ihi
C              write (LuOut,*) jsh,Lj,jpr,jgc,jce,jhi
C              write (LuOut,*) ksh,Lk,kpr,kgc,kce,khi
C              write (LuOut,*) lsh,Ll,lpr,lgc,lce,lhi
C              if (n_cont .gt. 1 .and. Li.ne.Lj .and. Lk.ne.Ll) then
C                write(luout,*)' '
C                write(luout,*)' ============= (',
C     &              ish,':',Li,',',
C     &              jsh,':',Lj,'|',
C     &              ksh,':',Lk,',',
C     &              lsh,':',Ll,')',
C     &              '===================='
C                write(luout,*)' '
C                write (luout,*) 'Nints',Nints
C                write (luout,*) 'calling rel_2e4c_sf gen'
C                call util_flush(6)

                call rel_2e4c_sf (
     &              coords(1,ice,ige),dbl_mb(mb_exndcf(iex,abas)),
     &              dbl_mb(mb_exndcf(icf,abas)),
     &              dbl_mb(mb_exndcf(icfs,sbas)),ipr,igc,Li,ice,
     &              coords(1,jce,jge),dbl_mb(mb_exndcf(jex,abas)),
     &              dbl_mb(mb_exndcf(jcf,abas)),
     &              dbl_mb(mb_exndcf(jcfs,sbas)),jpr,jgc,Lj,jce,
     &              coords(1,kce,kge),dbl_mb(mb_exndcf(kex,abas)),
     &              dbl_mb(mb_exndcf(kcf,abas)),
     &              dbl_mb(mb_exndcf(kcfs,sbas)),kpr,kgc,Lk,kce,
     &              coords(1,lce,lge),dbl_mb(mb_exndcf(lex,abas)),
     &              dbl_mb(mb_exndcf(lcf,abas)),
     &              dbl_mb(mb_exndcf(lcfs,sbas)),lpr,lgc,Ll,lce,
     &              dbl_mb(k_buf),Nints,.false.,.false.,.false.,
     &              .false.,dbl_mb(k_scr),memscr,
     &              .true.,.true.,.false.,.true.,0)
C                  call ecp_matpr (dbl_mb(k_buf),1,khi*lhi,1,ihi*jhi,
C     &                1,khi*lhi,1,ihi*jhi,'General contraction',
C     &                'E',120,6)
C                write (luout,*) 'calling rel_2e4c_sf seg'
C                call util_flush(6)

                i_eri = k_buf+Nints
                i_seg = i_eri
                i_c = icf
                i_cs = icfs
                do ic = 1,igc
                  j_c = jcf
                  j_cs = jcfs
                  do jc = 1,jgc
                    k_c = kcf
                    k_cs = kcfs
                    do kc = 1,kgc
                      l_c = lcf
                      l_cs = lcfs
                      do lc = 1,lgc
C                        write (luout,*) 'ic,jc,kc,lc',ic,jc,kc,lc

                call rel_2e4c_sf (
     &              coords(1,ice,ige),dbl_mb(mb_exndcf(iex,abas)),
     &              dbl_mb(mb_exndcf(i_c,abas)),
     &              dbl_mb(mb_exndcf(i_cs,sbas)),ipr,1,Li,ice,
     &              coords(1,jce,jge),dbl_mb(mb_exndcf(jex,abas)),
     &              dbl_mb(mb_exndcf(j_c,abas)),
     &              dbl_mb(mb_exndcf(j_cs,sbas)),jpr,1,Lj,jce,
     &              coords(1,kce,kge),dbl_mb(mb_exndcf(kex,abas)),
     &              dbl_mb(mb_exndcf(k_c,abas)),
     &              dbl_mb(mb_exndcf(k_cs,sbas)),kpr,1,Lk,kce,
     &              coords(1,lce,lge),dbl_mb(mb_exndcf(lex,abas)),
     &              dbl_mb(mb_exndcf(l_c,abas)),
     &              dbl_mb(mb_exndcf(l_cs,sbas)),lpr,1,Ll,lce,
     &              dbl_mb(i_eri),Nints,.false.,.false.,.false.,
     &              .false.,dbl_mb(k_scr),memscr,
     &              .true.,.true.,.false.,.true.,0)
C                  call ecp_matpr (dbl_mb(k_buf),1,k2*l2,1,i2*j2,
C     &                1,k2*l2,1,i2*j2,'Segmented contraction',
C     &                'E',120,6)

                        i_eri = i_eri+i2*j2*k2*l2
                        l_c = l_c+lpr
                        l_cs = l_cs+lpr
                      end do
                      k_c = k_c+kpr
                      k_cs = k_cs+kpr
                    end do
                    j_c = j_c+jpr
                    j_cs = j_cs+jpr
                  end do
                  i_c = i_c+ipr
                  i_cs = i_cs+ipr
                end do

                call reorder_2eints(dbl_mb(i_eri),dbl_mb(i_seg),
     &              l2,lgc,k2,kgc,j2,jgc,i2,igc)
                call dcopy (Nints,dbl_mb(i_eri),1,dbl_mb(i_seg),1)
C                call ecp_matpr (dbl_mb(i_seg),1,khi*lhi,1,ihi*jhi,
C     &              1,khi*lhi,1,ihi*jhi,'Segmented contraction',
C     &              'E',120,6)
                call daxpy(Nints,-1.0d0,dbl_mb(k_buf),1,dbl_mb(i_eri),1)
C                call ecp_matpr (dbl_mb(i_eri),1,khi*lhi,1,ihi*jhi,
C     &              1,khi*lhi,1,ihi*jhi,'Differences',
C     &              'E',120,6)
                ic = idamax(Nints,dbl_mb(i_eri),1)-1
C                write (luout,*) 'Maximum difference',dbl_mb(i_eri+ic)
                difmax = max(difmax,abs(dbl_mb(i_eri+ic)))
                if (abs(dbl_mb(i_eri+ic)) .gt. 1.0d-12) then
                  write (luout,*) ish,jsh,ksh,lsh
                  call ecp_matpr (dbl_mb(k_buf),1,khi*lhi,1,ihi*jhi,
     &                1,khi*lhi,1,ihi*jhi,'General contraction',
     &                'E',120,6)
                  call ecp_matpr (dbl_mb(i_seg),1,khi*lhi,1,ihi*jhi,
     &                1,khi*lhi,1,ihi*jhi,'Segmented contraction',
     &                'E',120,6)
                end if
C              end if
            end do
          end do
        end do
      end do
      write (luout,*) 'Maximum difference of all blocks',difmax

      end
************************************************************************
      subroutine kgdtest_gen1d(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "geom.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "apiP.fh"
#include "rel_nwc.fh"
#include "stdio.fh"
c
      logical int_normalize
      external int_normalize
      integer idamax
      external idamax
c
c test general contraction in derivative 1e integrals
c
      integer rtdb
      integer geom, basis, basid
      integer nshell, memscr, membuf
      integer h_scr, k_scr, h_buf, k_buf
      integer ish, jsh, ucont
      integer li, ipr, igc, iex, icf, ice, ige
      integer lj, jpr, jgc, jex, jcf, jce, jge
      integer Nints
      integer i_o2i,i_kei,i_nai
      integer ihi,jhi,i2,j2,n_cart,n_cont
      character*255 basis_name, geom_name
      double precision difmax
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      write (luout,*) 'in kgdtest_relgen'
      basis_name = 'ao basis'
      geom_name = 'geometry'
c
      if(.not.geom_create(geom,geom_name))call errquit
     &    ('kgdtest_relgen: geom create error',911, GEOM_ERR)
      if(.not.bas_create(basis,basis_name))call errquit
     &    ('kgdtest_relgen: basis create error',911, BASIS_ERR)
c
      if(.not.geom_rtdb_load(rtdb,geom,geom_name)) call errquit
     &    ('kgdtest_relgen: geom load ',911, RTDB_ERR)
      if(.not.bas_rtdb_load(rtdb,geom,basis,basis_name)) call errquit
     &    ('kgdtest_relgen: basis load ',911, RTDB_ERR)
c
      basid = basis + BASIS_HANDLE_OFFSET
      nshell = ncont_tot_gb(basid)
      if (.not.int_normalize(rtdb,basis)) call errquit
     &    ('kgdtest_relgen: error normalizing ',911, INT_ERR)
c
      call int_init(rtdb,1,basis)
      memscr = 5 000 000
      membuf = 100 000
      if (.not.ma_push_get(mt_dbl,memscr,' scratch ',
     &    h_scr, k_scr)) call errquit
     &    (' ma error 1',911, MA_ERR)
      if (.not.ma_push_get(mt_dbl,membuf,' buf ',
     &    h_buf, k_buf)) call errquit
     &    (' ma error 2',911, MA_ERR)
c
      difmax = 0.0d0
      do ish = 1,nshell
        ucont = (sf_ibs_cn2ucn(ish,basid))
        Li      = infbs_cont(CONT_TYPE ,ucont,basid)
        ipr  = infbs_cont(CONT_NPRIM,ucont,basid)
        igc   = infbs_cont(CONT_NGEN ,ucont,basid)
        iex  = infbs_cont(CONT_IEXP ,ucont,basid)
        icf  = infbs_cont(CONT_ICFP ,ucont,basid)
        ice  = (sf_ibs_cn2ce(ish,basid))
        ige  = ibs_geom(basid)
        i2 = (Li+1)*(Li+2)/2
        ihi = igc*i2
c
        do jsh = 1,ish
          ucont = (sf_ibs_cn2ucn(jsh,basid))
          Lj      = infbs_cont(CONT_TYPE ,ucont,basid)
          jpr  = infbs_cont(CONT_NPRIM,ucont,basid)
          jgc   = infbs_cont(CONT_NGEN ,ucont,basid)
          jex  = infbs_cont(CONT_IEXP ,ucont,basid)
          jcf  = infbs_cont(CONT_ICFP ,ucont,basid)
          jce  = (sf_ibs_cn2ce(jsh,basid))
          jge  = ibs_geom(basid)
          j2 = (Lj+1)*(Lj+2)/2
          jhi = jgc*j2
              
          n_cart = i2*j2
          n_cont = igc*jgc
          Nints = ihi*jhi
          write (LuOut,*) ish,Li,ipr,igc,ice,ihi
          write (LuOut,*) jsh,Lj,jpr,jgc,jce,jhi
          write (luout,*) 'Nints',Nints
          i_o2i = k_scr
          i_kei = i_o2i+Nints*6
          i_nai = i_kei+Nints*6
          call util_flush(6)
c
          call hf1d(
     &        coords(1,ice,ige),dbl_mb(mb_exndcf(iex,basid)),
     &        dbl_mb(mb_exndcf(icf,basid)),ipr,igc,Li,ice,
     &        coords(1,jce,jge),dbl_mb(mb_exndcf(jex,basid)),
     &        dbl_mb(mb_exndcf(jcf,basid)),jpr,jgc,Lj,jce,
     &        coords(1,1,ige),charge(1,ige),
     &        geom_invnucexp(1,ige),ncenter(ige),
     &        dbl_mb(i_o2i),dbl_mb(i_kei),dbl_mb(i_nai),Nints,
     &        .true.,.true.,.true.,.false.,.false.,
     &        dbl_mb(k_scr),memscr)
c
C          call hf1d_new(
C     &        coords(1,ice,ige),dbl_mb(mb_exndcf(iex,basid)),
C     &        dbl_mb(mb_exndcf(icf,basid)),ipr,igc,Li,ice,
C     &        coords(1,jce,jge),dbl_mb(mb_exndcf(jex,basid)),
C     &        dbl_mb(mb_exndcf(jcf,basid)),jpr,jgc,Lj,jce,
C     &        coords(1,1,ige),charge(1,ige),
C     &        geom_invnucexp(1,ige),ncenter(ige),
C     &        dbl_mb(i_o2i),dbl_mb(i_kei),dbl_mb(i_nai),Nints,
C     &        .true.,.true.,.true.,.false.,.false.,
C     &        dbl_mb(k_scr),memscr)
C
C                write (6,*) k_buf,i_seg,i_eri
C                call reorder_2eints(dbl_mb(i_eri),dbl_mb(i_seg),
C     &              l2,lgc,k2,kgc,j2,jgc,i2,igc)
C                call dcopy (Nints,dbl_mb(i_eri),1,dbl_mb(i_seg),1)
C                call ecp_matpr (dbl_mb(i_seg),1,khi*lhi,1,ihi*jhi,
C     &              1,khi*lhi,1,ihi*jhi,'Segmented contraction',
C     &              'E',120,6)
C                call daxpy(Nints,-1.0d0,dbl_mb(k_buf),1,dbl_mb(i_eri),1)
C                call ecp_matpr (dbl_mb(i_eri),1,khi*lhi,1,ihi*jhi,
C     &              1,khi*lhi,1,ihi*jhi,'Differences',
C     &              'E',120,6)
C                ic = idamax(Nints,dbl_mb(i_eri),1)-1
C                write (luout,*) 'Maximum difference',dbl_mb(i_eri+ic)
C                difmax = max(difmax,abs(dbl_mb(i_eri+ic)))
C                if (abs(dbl_mb(i_eri+ic)) .gt. 1.0d-12) then
C                  call ecp_matpr (dbl_mb(k_buf),1,khi*lhi,1,ihi*jhi,
C     &                1,khi*lhi,1,ihi*jhi,'General contraction',
C     &                'E',120,6)
C                  call ecp_matpr (dbl_mb(i_seg),1,khi*lhi,1,ihi*jhi,
C     &                1,khi*lhi,1,ihi*jhi,'Segmented contraction',
C     &                'E',120,6)
C                end if
C            end do
C          end do
        end do
      end do
      write (luout,*) 'Maximum difference of all blocks',difmax

      end

      SUBROUTINE ccsdt_lambda1_8(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsdt_lambda1_8.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h2 p1 )_yv + = 1/4 * Sum ( h13 h12 p15 p14 ) * y ( h2 h12 h13 p1 p14 p15 )_y * i1 ( p14 p15 h12 h13 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h12b
      INTEGER h13b
      INTEGER p14b
      INTEGER p15b
      INTEGER h2b_1
      INTEGER h12b_1
      INTEGER h13b_1
      INTEGER p1b_1
      INTEGER p14b_1
      INTEGER p15b_1
      INTEGER p14b_2
      INTEGER p15b_2
      INTEGER h12b_2
      INTEGER h13b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperh(2)
      INTEGER isuperh
      INTEGER nsubp(2)
      INTEGER isubp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h2b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h2b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &y,irrep_v)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lambda1_8',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h12b = 1,noab
      DO h13b = h12b,noab
      DO p14b = noab+1,noab+nvab
      DO p15b = p14b,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h13b-
     &1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p14b-1)+int_mb(k_spin+p
     &15b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h12b-1),ieor(int_mb
     &(k_sym+h13b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p14b-1),
     &int_mb(k_sym+p15b-1)))))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_6(h2b,h12b,h13b,p1b,p14b,p15b,h2b_1,h12b_1,h13
     &b_1,p1b_1,p14b_1,p15b_1)
      CALL TCE_RESTRICTED_4(p14b,p15b,h12b,h13b,p14b_2,p15b_2,h12b_2,h13
     &b_2)
      dim_common = int_mb(k_range+h12b-1) * int_mb(k_range+h13b-1) * int
     &_mb(k_range+p14b-1) * int_mb(k_range+p15b-1)
      dima_sort = int_mb(k_range+h2b-1) * int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lambda1_8',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lambda1_8',2,MA_ERR)
      IF ((h13b .lt. h2b) .and. (p15b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p15b_1 - noab - 1 + nvab * (p14b_1 - noab - 
     &1 + nvab * (h2b_1 - 1 + noab * (h13b_1 - 1 + noab * (h12b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+h2b-1),int_mb(k_range+p14b
     &-1),int_mb(k_range+p15b-1),int_mb(k_range+p1b-1),6,3,5,4,2,1,1.0d0
     &)
      END IF
      IF ((h13b .lt. h2b) .and. (p14b .lt. p1b) .and. (p1b .le. p15b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p14b_1 - noab - 
     &1 + nvab * (h2b_1 - 1 + noab * (h13b_1 - 1 + noab * (h12b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+h2b-1),int_mb(k_range+p14b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p15b-1),5,3,6,4,2,1,-1.0d
     &0)
      END IF
      IF ((h13b .lt. h2b) .and. (p1b .le. p14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p14b_1 - noab - 1 + nvab * (p1b_1 - noab - 
     &1 + nvab * (h2b_1 - 1 + noab * (h13b_1 - 1 + noab * (h12b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+h2b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p14b-1),int_mb(k_range+p15b-1),4,3,6,5,2,1,1.0d0
     &)
      END IF
      IF ((h12b .lt. h2b) .and. (h2b .le. h13b) .and. (p15b .lt. p1b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p15b_1 - noab - 1 + nvab * (p14b_1 - noab - 
     &1 + nvab * (h13b_1 - 1 + noab * (h2b_1 - 1 + noab * (h12b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h13b-1),int_mb(k_range+p14b
     &-1),int_mb(k_range+p15b-1),int_mb(k_range+p1b-1),6,2,5,4,3,1,-1.0d
     &0)
      END IF
      IF ((h12b .lt. h2b) .and. (h2b .le. h13b) .and. (p14b .lt. p1b) .a
     &nd. (p1b .le. p15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p14b_1 - noab - 
     &1 + nvab * (h13b_1 - 1 + noab * (h2b_1 - 1 + noab * (h12b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h13b-1),int_mb(k_range+p14b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p15b-1),5,2,6,4,3,1,1.0d0
     &)
      END IF
      IF ((h12b .lt. h2b) .and. (h2b .le. h13b) .and. (p1b .le. p14b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p14b_1 - noab - 1 + nvab * (p1b_1 - noab - 
     &1 + nvab * (h13b_1 - 1 + noab * (h2b_1 - 1 + noab * (h12b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h13b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p14b-1),int_mb(k_range+p15b-1),4,2,6,5,3,1,-1.0d
     &0)
      END IF
      IF ((h2b .le. h12b) .and. (p15b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p15b_1 - noab - 1 + nvab * (p14b_1 - noab - 
     &1 + nvab * (h13b_1 - 1 + noab * (h12b_1 - 1 + noab * (h2b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h13b-1),int_mb(k_range+p14b
     &-1),int_mb(k_range+p15b-1),int_mb(k_range+p1b-1),6,1,5,4,3,2,1.0d0
     &)
      END IF
      IF ((h2b .le. h12b) .and. (p14b .lt. p1b) .and. (p1b .le. p15b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p14b_1 - noab - 
     &1 + nvab * (h13b_1 - 1 + noab * (h12b_1 - 1 + noab * (h2b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h13b-1),int_mb(k_range+p14b
     &-1),int_mb(k_range+p1b-1),int_mb(k_range+p15b-1),5,1,6,4,3,2,-1.0d
     &0)
      END IF
      IF ((h2b .le. h12b) .and. (p1b .le. p14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p15b_
     &1 - noab - 1 + nvab * (p14b_1 - noab - 1 + nvab * (p1b_1 - noab - 
     &1 + nvab * (h13b_1 - 1 + noab * (h12b_1 - 1 + noab * (h2b_1 - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h13b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p14b-1),int_mb(k_range+p15b-1),4,1,6,5,3,2,1.0d0
     &)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lambda1_8',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lambda1_8',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lambda1_8',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h13b_
     &2 - 1 + noab * (h12b_2 - 1 + noab * (p15b_2 - noab - 1 + nvab * (p
     &14b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p14b-1
     &),int_mb(k_range+p15b-1),int_mb(k_range+h12b-1),int_mb(k_range+h13
     &b-1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lambda1_8',6,MA_ER
     &R)
      nsuperh(1) = 1
      nsuperh(2) = 1
      isuperh = 1
      IF (h12b .eq. h13b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      nsubp(1) = 1
      nsubp(2) = 1
      isubp = 1
      IF (p14b .eq. p15b) THEN
      nsubp(isubp) = nsubp(isubp) + 1
      ELSE
      isubp = isubp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperh(1))/FACTORIAL(nsuperh(2))/FACTORIAL(nsubp(1))/FACTORIAL(ns
     &ubp(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lambda1_8',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lambda1_8',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lambda1_8',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h2b-1),2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h2b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lambda1_8',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lambda1_8',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine esp_getx(t,x,q,n)
c
c $Id: esp_getx.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "esp_params.fh"
#include "esp_common.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "mafdecls.fh"
c
      character*16 t(natoms)
      integer n(natoms)
      real*8 x(3,natoms),q(natoms)
      integer i,j
c
      if(.not.geom_cart_get(igeom,natoms,t,x,q))
     + call md_abort('esp: geom_cart_get failed',me)
c
c     convert coordinates to nm and find extrema
c
      do 1 j=1,3
      xmin(j)=x(j,1)
      xmax(j)=x(j,1)
      do 2 i=1,natoms
      if(x(j,i).lt.xmin(j)) xmin(j)=x(j,i)
      if(x(j,i).gt.xmax(j)) xmax(j)=x(j,i)
    2 continue
    1 continue
      do 3 i=1,natoms
      n(i)=int(q(i))
    3 continue
c
c     calculate grid size
c
      do 4 i=1,3
      mgrid(i)=(xmax(i)-xmin(i)+2.0d0*rcut)/spac+3
    4 continue
      mxgrid=mgrid(1)*mgrid(2)*mgrid(3)
c
      return
      end

      subroutine argos_space_initip(ibownr,ipl)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
c
      integer ibownr(maxbox,3),ipl(mbox,mip2)
      integer i,j,ibx,iby,ibz,nrbox,nrnod,nbiown
      integer il,ih,jl,jh
c
      do 1 j=1,mip2
      do 2 i=1,30
      ipl(i,j)=0
    2 continue
    1 continue
c
      if(iand(idebug,1).eq.1) then
      write(lfndbg,8003) nbx,nby,nbz,maxbox
 8003 format('ibownr in argos_space_initip',4i5)
      write(lfndbg,8004) (ibownr(ibx,1),ibx=1,nbx)
 8004 format('ibownr x',/,(20i5))
      write(lfndbg,8005) (ibownr(iby,2),iby=1,nby)
 8005 format('ibownr y',/,(20i5))
      write(lfndbg,8006) (ibownr(ibz,3),ibz=1,nbz)
 8006 format('ibownr z',/,(20i5))
      call util_flush(lfndbg)
      if(iand(idebug,2).eq.2) write(lfndbg,8002)
 8002 format('boxlist')
      endif
      nbiown=0
      do 3 ibx=1,nbx
      do 4 iby=1,nby
      do 5 ibz=1,nbz
      nrbox=((ibz-1)*nby+iby-1)*nbx+ibx-1
      nrnod=(ibownr(ibz,3)*npy+ibownr(iby,2))*npx+ibownr(ibx,1)
      if(iand(idebug,2).eq.2) then
      write(lfndbg,8001) ibx,iby,ibz,nrbox,nrnod
 8001 format(5i5)
      call util_flush(lfndbg)
      endif
      if(me.eq.nrnod) then
      nbiown=nbiown+1
      ipl(30+nbiown,1)=nrbox
      ipl(30+nbiown,2)=0
      ipl(30+nbiown,3)=0
      ipl(30+nbiown,4)=0
      ipl(30+nbiown,5)=0
      endif
    5 continue
    4 continue
    3 continue
      ipl(1,1)=nbiown
c
      call ga_distribution(ga_ip,me,il,ih,jl,jh)
      call ga_put(ga_ip,il,ih,jl,jh,ipl,mbox)
c
      if(iand(idebug,2).eq.2) then
      write(lfndbg,8000) (i,ipl(30+i,1),i=1,ipl(1,1))
 8000 format('ipl',/,(2i5))
      call util_flush(lfndbg)
      endif
c
      return
      end
c $Id: argos_space_initip.F 21176 2011-10-10 06:35:49Z d3y133 $

c      SUBROUTINE tce_mrcc_c2(size_t2m,k_t1_offsetm,d_t1m,nref,iref,
c     1 K_T2_OFFSETM,d_t2m,d_r2m,k_r2_offsetm,size_t1m)
      SUBROUTINE tce_mrcc_c2(size_t2m,k_t1_offsetm,d_t1m,iref,
     1 K_T2_OFFSETM,d_t2m,d_r2m,k_r2_offsetm,size_t1m)
c C2 + t2(mu/nu) - t2(mu)
c          call tce_mrcc_c2(size_t2m,k_t1_offsetm,d_t1m,nref,iref,
c     1 k_t2_offsetm,d_t2m,d_r2m)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "util.fh"
#include "msgids.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_mrcc.fh"
#include "stdio.fh"

      integer inoab,invab
      integer size_t2m(maxref),size_t1m(maxref)
      integer k_t1_offsetm(maxref)
      integer d_t1m(maxref)
      integer iref
      integer size
      integer dima,dimb
      integer p1b,p2b,h3b,h4b
      integer l_t2,k_t2
      integer l_t1a1,k_t1a1
      integer l_t1b1,k_t1b1
      integer l_t1a2,k_t1a2
      integer l_t1b2,k_t1b2
      integer l_tmp,k_tmp
      integer k_t2_offsetm(maxref),d_t2m(maxref)
      integer d_r2m(maxref)
      integer k_t2_2,l_t2_2
      integer l_r2,k_r2
      integer l_c,k_c
      integer irefnew
      integer p1,p2,h3,h4
      integer i
      character*255 filename
      integer d_c2tmp,d_t1c
      integer k_r2_offsetm(maxref)
      double precision coef
      integer d_rc2
      double precision sign
      integer ijblock(nref,noab+nvab)
      integer aux1,aux2
      logical nodezero
      double precision itcpu,itwall

      nodezero=(ga_nodeid().eq.0)

      if(lusesub) then

          call tce_filename('c2_tmp',filename)
          call pgcreatefile(filename,d_c2tmp,size_t2m(iref),mypgid)

          call tce_filename('rc2',filename)
          call pgcreatefile(filename,d_rc2,size_t2m(iref),mypgid)

          call tce_filename('t1c',filename)
          call pgcreatefile(filename,d_t1c,size_t1m(iref),mypgid)

      else

          call tce_filename('c2_tmp',filename)
          call createfile(filename,d_c2tmp,size_t2m(iref))

          call tce_filename('rc2',filename)
          call createfile(filename,d_rc2,size_t2m(iref))

          call tce_filename('t1c',filename)
          call createfile(filename,d_t1c,size_t1m(iref))

      endif

      do irefnew=1,nref
       do i=1,noab+nvab

           aux1 = (1 - (int_mb(k_spinm(iref)+i-1)-1)+
     1 int_mb(k_mo_indexm(iref)+int_mb(k_offsetm(iref)+i-1)))/2

        aux1 = moindexes(aux1,int_mb(k_spinm(iref)+i-1),iref)
        aux1 = moindexes(aux1,int_mb(k_spinm(iref)+i-1),irefnew)

         ijblock(irefnew,i) = orbinblck(aux1,int_mb(k_spinm(iref)+i-1),
     1 irefnew)

       enddo
      enddo

      do irefnew=1,nref
      if(irefnew.ne.iref) then

      coef = dbl_mb(k_heff+iref-1+(irefnew-1)*nref)*
     1 dbl_mb(k_sqc+(irefnew-1)*nref+mkroot-1)
      if(dbl_mb(k_sqc+(iref-1)*nref+mkroot-1).lt.0.0d0)
     1 coef=-1.0d0*coef

c     2dbl_mb(k_sqc+(mkroot-1)*nref+iref-1)
c      write(6,*)'USING',coef,
c     1dbl_mb(k_heff+iref-1+(irefnew-1)*nref),
c     2abs(dbl_mb(k_sqc+(irefnew-1)*nref+mkroot-1)),
c     3abs(dbl_mb(k_sqc+(iref-1)*nref+mkroot-1))


      call ga_zero(d_c2tmp)
      call ga_zero(d_t1c)

        itcpu = - util_cpusec()
        itwall = - util_wallsec()

      call tce_mrcc_c1_offset(k_t1_offsetm,d_t1m,iref,irefnew,d_t1c)
      if(lusesub) then
        call ga_pgroup_sync(mypgid)
      else
        call reconcilefile(d_t1c,size_t1m(iref))
      endif

          itcpu = itcpu + util_cpusec()
          itwall = itwall + util_wallsec()

c          if(nodezero) then
c            write(LuOut,9222) itcpu, itwall
c            call util_flush(LuOut)
c          endif

        itcpu = - util_cpusec()
        itwall = - util_wallsec()

      call tce_mrcc_c2_offset(k_t2_offsetm,d_t2m,iref,irefnew,d_c2tmp,
     1 ijblock,nref)
      if(lusesub) then
        call ga_pgroup_sync(mypgid)
      else
        call reconcilefile(d_c2tmp,size_t2m(iref))
      endif

          itcpu = itcpu + util_cpusec()
          itwall = itwall + util_wallsec()

          if(nodezero) then
c            write(LuOut,9223) itcpu, itwall
            call util_flush(LuOut)
          endif

c      write(6,*)'T2T2T2T2T2T2T2',iref,irefnew
c      call tce_mrcc_print_t2type(d_t2m(iref),k_t2_offsetm(iref),
c     1iref,irefnew)
      
c       write(6,*)'SELECTED',iref,irefnew
c      call tce_mrcc_print_t2type(d_c2tmp,k_t2_offsetm(iref),
c     1iref,irefnew)

c      write(6,*)'0'
c      call tce_mrcc_c1_t1t1(d_t1m(iref),k_t1_offsetm(iref),d_t1c,
c     1 k_t1_offsetm(iref),d_c2tmp,k_r2_offsetm(iref))
c      call reconcilefile(d_c2tmp,size_t2m(iref))

c      write(6,*)'1'
c      call tce_mrcc_c1_t1t1_2(d_t1c,k_t1_offsetm(iref),d_t1c,
c     1 k_t1_offsetm(iref),d_c2tmp,k_r2_offsetm(iref))
c      call reconcilefile(d_c2tmp,size_t2m(iref))
      if(lusesub) then
      call T2_C2_1x(d_rc2,d_t1c,k_t2_offsetm(iref),
     1 k_t1_offsetm(iref),coef)
      else
      call T2_C2_1a(d_rc2,d_t1c,k_t2_offsetm(iref),
     1 k_t1_offsetm(iref),coef)
      endif

      if(lusesub) then
        call ga_pgroup_sync(mypgid)
      else
        call reconcilefile(d_rc2,size_t2m(iref))
      endif

      if(lusesub) then
      call T2_pg_C2(d_rc2,d_t1m(iref),d_t2m(iref),d_t1c,d_c2tmp,
     1 k_t2_offsetm(iref),k_t1_offsetm(iref),k_t2_offsetm(iref),
     2 k_t1_offsetm(iref),k_t2_offsetm(iref),coef)
      else
      call T2_C2(d_rc2,d_t1m(iref),d_t2m(iref),d_t1c,d_c2tmp,
     1 k_t2_offsetm(iref),k_t1_offsetm(iref),k_t2_offsetm(iref),
     2 k_t1_offsetm(iref),k_t2_offsetm(iref),coef)
      endif

      if(lusesub) then
        call ga_pgroup_sync(mypgid)
      else
        call reconcilefile(d_rc2,size_t2m(iref))
      endif

c      write(6,*)'2'
c      call tce_mrcc_c1_t1t1_2(d_t1m(iref),k_t1_offsetm(iref),
c     1 d_t1m(iref),k_t1_offsetm(iref),d_c2tmp,k_r2_offsetm(iref))
c      call reconcilefile(d_c2tmp,size_t2m(iref))

c      write(6,*)'3'
c      call tce_mrcc_c2_offset(k_t2_offsetm,d_t2m,iref,irefnew,d_c2tmp)

c      call tce_mrcc_print_t2type(d_t2m(iref),k_t2_offsetm(iref),
c     1iref,irefnew)
c      call tce_mrcc_print_t2type(d_t2m(iref),k_t2_offsetm(iref),
c     1iref,irefnew)

c      call ga_add(1.0d0,d_c2tmp,-1.0d0,d_t2m(iref),d_c2tmp)
c      call tce_mrcc_mul_2(1.0d0,d_c2tmp,-1.0d0,d_t2m(iref),
c     1 k_t2_offsetm(iref),d_c2tmp,iref)
c      call reconcilefile(d_c2tmp,size_t2m(iref))

c      write(6,*)'COUPLING',iref
c      call tce_mrcc_print_t2type(d_c2tmp,k_t2_offsetm(iref),
c     1iref,irefnew)

c      call ga_add(1.0d0,d_rc2,coef,d_c2tmp,d_rc2)
c      call tce_mrcc_mul_2(1.0d0,d_rc2,coef,d_c2tmp,
c     1 k_t2_offsetm(iref),d_rc2,iref)
c      call reconcilefile(d_rc2,size_t2m(iref))

      endif 
      enddo

c       write(6,*)'M2M2M2M2M2M2M2',iref,irefnew
c      call tce_mrcc_print_t2type(d_rc2,k_t2_offsetm(iref),
c     1iref,irefnew)

c      call ga_print(d_t2m(iref))
      call util_flush(LuOut)

c      write(6,*)'INITIAL R2',iref
c      call tce_mrcc_print_t2type(d_r2m(iref),k_t2_offsetm(iref),
c     1iref,irefnew)

c      write(6,*)'USING R2mu',dbl_mb(k_sqc+(iref-1)*nref+mkroot-1)

c abs(dbl_mbik_sqc+(mkroot-1)*nref+iref-1))
c      call ga_add(abs(dbl_mb(k_sqc+(iref-1)*nref+mkroot-1)),d_r2m(iref),
c     1 1.0d0,d_rc2,d_r2m(iref))
      call tce_mrcc_mul_2(abs(dbl_mb(k_sqc+(iref-1)*nref+mkroot-1)),
     1 d_r2m(iref),1.0d0,d_rc2,k_t2_offsetm(iref),d_r2m(iref),iref)
      if(lusesub) then
        call ga_pgroup_sync(mypgid)
      else
        call reconcilefile(d_r2m(iref),size_t2m(iref))
      endif

c       write(6,*)'FINAL R2',iref,irefnew
c      call tce_mrcc_print_t2type(d_r2m(iref),k_t2_offsetm(iref),
c     1iref,irefnew)

      call deletefile(d_rc2)
      call deletefile(d_c2tmp)
      call deletefile(d_t1c) 

 9222 format(1x,'Corresponding T1 / sec',2f15.1)
 9223 format(1x,'Corresponding T2 / sec',2f15.1)

      return
      end
c $Id: tce_mrcc_c2.F 24345 2013-06-22 06:19:30Z d3y133 $

      subroutine tce_print_x2(d_r2,k_r2_offset,r2_thresh,irrep)
c
c $Id: tce_print_x2.F 21233 2011-10-20 17:22:46Z kowalski $
c
c Prints the X2 tensor
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_r2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer irrep
      logical nodezero
      double precision r2_thresh
      character*4 irrep_p1,irrep_p2,irrep_h3,irrep_h4
      character*5 spinnames(2),spin_p1,spin_p2,spin_h3,spin_h4
      data spinnames/'alpha','beta '/
c
      nodezero = (ga_nodeid().eq.0)
      if (nodezero) write(LuOut,9000) 'Doubles contributions'
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do h3b = 1,noab
            do h4b = h3b,noab
              if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1          .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
              if ((.not.restricted).or.
     1          (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2          int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
              if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1          ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2          .eq. irrep) then
                size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1               * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1            call errquit('tce_print_x2: MA problem',0,MA_ERR)
                call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1            int_mb(k_r2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2            *noab+h3b-1)*noab+h4b-1))
                i = 0
                do p1 = 1,int_mb(k_range+p1b-1)
                  do p2 = 1,int_mb(k_range+p2b-1)
                    do h3 = 1,int_mb(k_range+h3b-1)
                      do h4 = 1,int_mb(k_range+h4b-1)
                        i = i + 1
              if (dabs(dbl_mb(k_r2+i-1)).gt.r2_thresh) then
                call sym_irrepname(geom,int_mb(k_sym+p1b-1)+1,irrep_p1)
                call sym_irrepname(geom,int_mb(k_sym+p2b-1)+1,irrep_p2)
                call sym_irrepname(geom,int_mb(k_sym+h3b-1)+1,irrep_h3)
                call sym_irrepname(geom,int_mb(k_sym+h4b-1)+1,irrep_h4)
                spin_p1 = spinnames(int_mb(k_spin+p1b-1))
                spin_p2 = spinnames(int_mb(k_spin+p2b-1))
                spin_h3 = spinnames(int_mb(k_spin+h3b-1))
                spin_h4 = spinnames(int_mb(k_spin+h4b-1))
                if (nodezero) write(LuOut,9010)
c     1            int_mb(k_offset+p1b-1)+p1,irrep_p1,spin_p1,
c     2            int_mb(k_offset+p2b-1)+p2,irrep_p2,spin_p2,
c     3            int_mb(k_offset+h3b-1)+h3,irrep_h3,spin_h3,
c     4            int_mb(k_offset+h4b-1)+h4,irrep_h4,spin_h4,
c     5            dbl_mb(k_r2+i-1)
     1            (int_mb(k_mo_index+int_mb(k_offset+p1b-1)+p1-1)+
     1             2-int_mb(k_spin+p1b-1))/2,
     1            irrep_p1,spin_p1,
     2            (int_mb(k_mo_index+int_mb(k_offset+p2b-1)+p2-1)+
     2             2-int_mb(k_spin+p2b-1))/2,
     2            irrep_p2,spin_p2,
     3            (int_mb(k_mo_index+int_mb(k_offset+h3b-1)+h3-1)+
     3             2-int_mb(k_spin+h3b-1))/2,
     3            irrep_h3,spin_h3,
     4            (int_mb(k_mo_index+int_mb(k_offset+h4b-1)+h4-1)+
     4             2-int_mb(k_spin+h4b-1))/2,
     4            irrep_h4,spin_h4,
     5            dbl_mb(k_r2+i-1)
              endif
                      enddo
                    enddo
                  enddo
                enddo
                if (.not.ma_pop_stack(l_r2))
     1            call errquit('tce_print_x2: MA problem',1,MA_ERR)
              endif
              endif
              endif
            enddo
          enddo
        enddo
      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9010 format(1x,i5,a4,'(',a5,') ',i5,a4,'(',a5,') --- ',
     1          i5,a4,'(',a5,') ',i5,a4,'(',a5,')',f20.10)
      return
      end
c
c
      subroutine tce_print_x2a(d_r2,k_r2_offset,r2_thresh,irrep)
c
c $Id: tce_print_x2.F 21233 2011-10-20 17:22:46Z kowalski $
c
c Prints the X2 tensor
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_r2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer irrep
      logical nodezero
      double precision r2_thresh
      LOGICAL is_active_1,is_active_2,is_active_3,is_active_4
      character*4 irrep_p1,irrep_p2,irrep_h3,irrep_h4
      character*5 spinnames(2),spin_p1,spin_p2,spin_h3,spin_h4
      data spinnames/'alpha','beta '/
c
      nodezero = (ga_nodeid().eq.0)
      if (nodezero) write(LuOut,9000) 'Doubles contributions'
      do p1b = noab+1,noab+nvab
        do p2b = p1b,noab+nvab
          do h3b = 1,noab
            do h4b = h3b,noab
              IF(is_active_4(p1b,p2b,h3b,h4b)) THEN
              if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1          .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
              if ((.not.restricted).or.
     1          (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2          int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
              if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1          ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2          .eq. irrep) then
                size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1               * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1            call errquit('tce_print_x2: MA problem',0,MA_ERR)
                call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1            int_mb(k_r2_offset),((((p1b-noab-1)*nvab+p2b-noab-1)
     2            *noab+h3b-1)*noab+h4b-1))
                i = 0
                do p1 = 1,int_mb(k_range+p1b-1)
                  do p2 = 1,int_mb(k_range+p2b-1)
                    do h3 = 1,int_mb(k_range+h3b-1)
                      do h4 = 1,int_mb(k_range+h4b-1)
                        i = i + 1
              if (dabs(dbl_mb(k_r2+i-1)).gt.r2_thresh) then
                call sym_irrepname(geom,int_mb(k_sym+p1b-1)+1,irrep_p1)
                call sym_irrepname(geom,int_mb(k_sym+p2b-1)+1,irrep_p2)
                call sym_irrepname(geom,int_mb(k_sym+h3b-1)+1,irrep_h3)
                call sym_irrepname(geom,int_mb(k_sym+h4b-1)+1,irrep_h4)
                spin_p1 = spinnames(int_mb(k_spin+p1b-1))
                spin_p2 = spinnames(int_mb(k_spin+p2b-1))
                spin_h3 = spinnames(int_mb(k_spin+h3b-1))
                spin_h4 = spinnames(int_mb(k_spin+h4b-1))
                if (nodezero) write(LuOut,9010)
c     1            int_mb(k_offset+p1b-1)+p1,irrep_p1,spin_p1,
c     2            int_mb(k_offset+p2b-1)+p2,irrep_p2,spin_p2,
c     3            int_mb(k_offset+h3b-1)+h3,irrep_h3,spin_h3,
c     4            int_mb(k_offset+h4b-1)+h4,irrep_h4,spin_h4,
c     5            dbl_mb(k_r2+i-1)
     1            (int_mb(k_mo_index+int_mb(k_offset+p1b-1)+p1-1)+
     1             2-int_mb(k_spin+p1b-1))/2,
     1            irrep_p1,spin_p1,
     2            (int_mb(k_mo_index+int_mb(k_offset+p2b-1)+p2-1)+
     2             2-int_mb(k_spin+p2b-1))/2,
     2            irrep_p2,spin_p2,
     3            (int_mb(k_mo_index+int_mb(k_offset+h3b-1)+h3-1)+
     3             2-int_mb(k_spin+h3b-1))/2,
     3            irrep_h3,spin_h3,
     4            (int_mb(k_mo_index+int_mb(k_offset+h4b-1)+h4-1)+
     4             2-int_mb(k_spin+h4b-1))/2,
     4            irrep_h4,spin_h4,
     5            dbl_mb(k_r2+i-1)
              endif
                      enddo
                    enddo
                  enddo
                enddo
                if (.not.ma_pop_stack(l_r2))
     1            call errquit('tce_print_x2: MA problem',1,MA_ERR)
              endif
              endif
              endif
              endif
            enddo
          enddo
        enddo
      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9010 format(1x,i5,a4,'(',a5,') ',i5,a4,'(',a5,') --- ',
     1          i5,a4,'(',a5,') ',i5,a4,'(',a5,')',f20.10)
      return
      end
c
c
      subroutine tce_print_y2(d_r2,k_r2_offset,r2_thresh,irrep)
c
c Prints the Y2 tensor
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r2
      integer p1b
      integer p2b
      integer h3b
      integer h4b
      integer p1
      integer p2
      integer h3
      integer h4
      integer k_r2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer irrep
      logical nodezero
      double precision r2_thresh
      character*4 irrep_p1,irrep_p2,irrep_h3,irrep_h4
      character*5 spinnames(2),spin_p1,spin_p2,spin_h3,spin_h4
      data spinnames/'alpha','beta '/
c
      nodezero = (ga_nodeid().eq.0)
      if (nodezero) write(LuOut,9000) 'Doubles contributions'
      do h3b = 1,noab
        do h4b = h3b,noab
          do p1b = noab+1,noab+nvab
            do p2b = p1b,noab+nvab
              if (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) 
     1          .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) then
              if ((.not.restricted).or.
     1          (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     2          int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.8)) then
              if (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),
     1          ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1))))
     2          .eq. irrep) then
                size = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     1               * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
                if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1            call errquit('tce_print_y2: MA problem',0,MA_ERR)
                call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1            int_mb(k_r2_offset),((((h3b-1)*noab+h4b-1)
     2            *nvab+p1b-noab-1)*nvab+p2b-noab-1))
                i = 0
                do h3 = 1,int_mb(k_range+h3b-1)
                  do h4 = 1,int_mb(k_range+h4b-1)
                    do p1 = 1,int_mb(k_range+p1b-1)
                      do p2 = 1,int_mb(k_range+p2b-1)
                        i = i + 1
              if (dabs(dbl_mb(k_r2+i-1)).gt.r2_thresh) then
                call sym_irrepname(geom,int_mb(k_sym+p1b-1)+1,irrep_p1)
                call sym_irrepname(geom,int_mb(k_sym+p2b-1)+1,irrep_p2)
                call sym_irrepname(geom,int_mb(k_sym+h3b-1)+1,irrep_h3)
                call sym_irrepname(geom,int_mb(k_sym+h4b-1)+1,irrep_h4)
                spin_p1 = spinnames(int_mb(k_spin+p1b-1))
                spin_p2 = spinnames(int_mb(k_spin+p2b-1))
                spin_h3 = spinnames(int_mb(k_spin+h3b-1))
                spin_h4 = spinnames(int_mb(k_spin+h4b-1))
                if (nodezero) write(LuOut,9010)
     1            int_mb(k_offset+p1b-1)+p1,irrep_p1,spin_p1,
     2            int_mb(k_offset+p2b-1)+p2,irrep_p2,spin_p2,
     3            int_mb(k_offset+h3b-1)+h3,irrep_h3,spin_h3,
     4            int_mb(k_offset+h4b-1)+h4,irrep_h4,spin_h4,
     5            dbl_mb(k_r2+i-1)
              endif
                      enddo
                    enddo
                  enddo
                enddo
                if (.not.ma_pop_stack(l_r2))
     1            call errquit('tce_print_y2: MA problem',1,MA_ERR)
              endif
              endif
              endif
            enddo
          enddo
        enddo
      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9010 format(1x,i5,a4,'(',a5,') ',i5,a4,'(',a5,') --- ',
     1          i5,a4,'(',a5,') ',i5,a4,'(',a5,')',f20.10)
      return
      end
c
c
c
c
c
      subroutine tce_print_g2(rtdb,d_r2,k_r2_offset,r2_thresh,irrep_r2)
c
c Prints the G2 tensor
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "rtdb.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer rtdb
      integer d_r2
      integer g1b,g2b,g3b,g4b
      integer g1,g2,g3,g4
      integer k_r2_offset
      integer size
      integer l_r2,k_r2
      integer i
      integer irrep_r2
      integer eiformat
      logical nodezero
      double precision r2_thresh
      character*4 irrep_g1,irrep_g2,irrep_g3,irrep_g4
      character*5 spinnames(2),spin_g1,spin_g2,spin_g3,spin_g4
      data spinnames/'alpha','beta '/
c
      if (.not.rtdb_get(rtdb,'tce:eiformat',mt_int,1,eiformat)) then
        eiformat = 1
        if (.not.rtdb_put(rtdb,'tce:eiformat',mt_int,1,eiformat))
     1  call errquit('tce_init: failed to write eiformat',0,RTDB_ERR)
      endif
c
      nodezero = (ga_nodeid().eq.0)
c      if (nodezero) write(LuOut,9000) 'Doubles contributions'
      do g3b = 1,noab+nvab
        do g4b = g3b,noab+nvab
          do g1b = 1,noab+nvab
            do g2b = g1b,noab+nvab
              if (int_mb(k_spin+g1b-1)+int_mb(k_spin+g2b-1)
     1          .eq. int_mb(k_spin+g3b-1)+int_mb(k_spin+g4b-1)) then
              if ((.not.restricted).or.
     1          (int_mb(k_spin+g1b-1)+int_mb(k_spin+g2b-1)+
     2           int_mb(k_spin+g3b-1)+int_mb(k_spin+g4b-1).ne.8)) then
              if (ieor(int_mb(k_sym+g1b-1),ieor(int_mb(k_sym+g2b-1),
     1            ieor(int_mb(k_sym+g3b-1),int_mb(k_sym+g4b-1))))
     2          .eq. irrep_r2) then
                size = int_mb(k_range+g1b-1) * int_mb(k_range+g2b-1)
     1               * int_mb(k_range+g3b-1) * int_mb(k_range+g4b-1)
                if (.not.ma_push_get(mt_dbl,size,'r2',l_r2,k_r2))
     1            call errquit('tce_print_x2: MA problem',0,MA_ERR)
                call get_hash_block(d_r2,dbl_mb(k_r2),size,
     1            int_mb(k_r2_offset),g2b-1+(noab+nvab)
     2              *(g1b-1+(noab+nvab)*(g4b-1+(noab+nvab)*(g3b-1))))
                i = 0
                do g3 = 1,int_mb(k_range+g3b-1)
                  do g4 = 1,int_mb(k_range+g4b-1)
                    do g1 = 1,int_mb(k_range+g1b-1)
                      do g2 = 1,int_mb(k_range+g2b-1)
                        i = i + 1
              if (dabs(dbl_mb(k_r2+i-1)).gt.r2_thresh) then
                call sym_irrepname(geom,int_mb(k_sym+g3b-1)+1,irrep_g3)
                call sym_irrepname(geom,int_mb(k_sym+g4b-1)+1,irrep_g4)
                call sym_irrepname(geom,int_mb(k_sym+g1b-1)+1,irrep_g1)
                call sym_irrepname(geom,int_mb(k_sym+g2b-1)+1,irrep_g2)
                spin_g3 = spinnames(int_mb(k_spin+g3b-1))
                spin_g4 = spinnames(int_mb(k_spin+g4b-1))
                spin_g1 = spinnames(int_mb(k_spin+g1b-1))
                spin_g2 = spinnames(int_mb(k_spin+g2b-1))
                if ((nodezero).and.(eiformat.eq.1)) then
                  write(LuOut,9011)
     3            int_mb(k_offset+g3b-1)+g3,irrep_g3,spin_g3,
     4            int_mb(k_offset+g4b-1)+g4,irrep_g4,spin_g4,
     1            int_mb(k_offset+g1b-1)+g1,irrep_g1,spin_g1,
     2            int_mb(k_offset+g2b-1)+g2,irrep_g2,spin_g2,
     5            dbl_mb(k_r2+i-1)
                elseif ((nodezero).and.(eiformat.eq.2)) then
                  write(LuOut,9012)
     3            int_mb(k_offset+g3b-1)+g3,irrep_g3,spin_g3,
     4            int_mb(k_offset+g4b-1)+g4,irrep_g4,spin_g4,
     1            int_mb(k_offset+g1b-1)+g1,irrep_g1,spin_g1,
     2            int_mb(k_offset+g2b-1)+g2,irrep_g2,spin_g2,
     5            dbl_mb(k_r2+i-1)
                elseif ((nodezero).and.(eiformat.eq.3)) then
                  write(LuOut,9013)
     1             int_mb(k_offset+g3b-1)+g3,int_mb(k_sym+g3b-1)+1,
     2             int_mb(k_spin+g3b-1),
     3             int_mb(k_offset+g4b-1)+g4,int_mb(k_sym+g4b-1)+1,
     4             int_mb(k_spin+g4b-1),
     1             int_mb(k_offset+g1b-1)+g1,int_mb(k_sym+g1b-1)+1,
     2             int_mb(k_spin+g1b-1),
     3             int_mb(k_offset+g2b-1)+g2,int_mb(k_sym+g2b-1)+1,
     4             int_mb(k_spin+g2b-1),
     5            dbl_mb(k_r2+i-1)
                elseif ((nodezero).and.(eiformat.eq.4)) then
                  write(LuOut,9014)
     3            int_mb(k_offset+g3b-1)+g3,
     4            int_mb(k_offset+g4b-1)+g4,
     1            int_mb(k_offset+g1b-1)+g1,
     2            int_mb(k_offset+g2b-1)+g2,
     5            dbl_mb(k_r2+i-1)
                endif
              endif
                      enddo
                    enddo
                  enddo
                enddo
                if (.not.ma_pop_stack(l_r2))
     1            call errquit('tce_print_x2: MA problem',1,MA_ERR)
              endif
              endif
              endif
            enddo
          enddo
        enddo
      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9011 format(1x,i3,a4,'(',a5,') ',i3,a4,'(',a5,') --- ',
     1          i3,a4,'(',a5,') ',i3,a4,'(',a5,')',f20.14)
 9012 format(1x,i3,',  ',a4,',',a5,',',i3,',  ',a4,',',a5,',',
     1          i3,',  ',a4,',',a5,',',i3,',  ',a4,',',a5,',',f20.14)
 9013 format(1x,i3,',',i3,',',i3,',',i3,',',i3,',',i3,',',
     1          i3,',',i3,',',i3,',',i3,',',i3,',',i3,',',f20.14)
 9014 format(1x,i3,', ',i3,', ',i3,', ',i3,', ',f20.14)
      return
      end

C> \ingroup selci
C> @{
C>
      subroutine selci_brdeig
*
* $Id: e0mp2.F 24780 2013-11-07 21:23:59Z d3y133 $
*
#include "implicit.fh"
#include "ciinfo.fh"
#include "cmp2.fh"
      call ga_brdcst(20,eps,mdtob(norbs),0)
      return
      end
      subroutine selci_geteig(eigins)
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
#include "cmp2.fh"
      character*80 eigins
c$$$      logical isitthere
c
c subroutine to get orbital eigenvalues to be used in MP pt.
c currently reads ascii eigenvalues from a file called 'eigins'
c
      call errquit('select: MP denominators not functional',0,
     &       INPUT_ERR)
c$$$      if (norbs.gt.norbsmx) then
c$$$         call errquit('norbs > norbsmx = ',norbsmx)
c$$$      endif
c$$$      isitthere = .false.
c$$$      inquire(file=eigins,exist=isitthere)
c$$$      if (.not.isitthere) then
c$$$         call errquit(' file eigins missing ',911)
c$$$      endif
c$$$      open(unit=ifleig,form='formatted',access='sequential',
c$$$     &     status='old',file=eigins)
c$$$      read(ifleig,*)(eps(i),i=1,norbs)
c$$$      call dscal(norbs,0.5d00,eps,1)
c$$$c
c$$$c:debug 2
c$$$      write(6,*) ' Orbital eigenvalues '
c$$$      write(ifllog,10000) (eps(i),i=1,norbs)
c$$$10000 format(1x,6f12.6)
c$$$c
c$$$      return
      end
      double precision function selci_e0mp2(iocc)
#include "implicit.fh"
#include "ciinfo.fh"
#include "cmp2.fh"
c
      integer iocc(norbs)
c
c     return the zeroth order energy of this orbital occupation
c     using the mp2 partioning
c
      e = 0.0d0
      selci_e0mp2 = e
      do 10 i = 1, norbs
         if (iocc(i).ne.0) then
            e = e + eps(i)
            if (iocc(i).eq.3) e = e + eps(i)
         endif
 10   continue
c
      selci_e0mp2 = e
c:debug      write(6,*)' e,e0mp2,iocc = ',e,e0mp2,iocc
      end
      subroutine selci_mke0mp(ioconf, indxci, ci, erefmp, nconf)
#include "implicit.fh"
#include "ciinfo.fh"
c
      dimension ioconf(nintpo, nconf), indxci(nconf+1),
     $     ci(nci, nroot), erefmp(nroot)
      dimension iocc(255)
c
c     return in erefmp(*) the zeroth order energy of each reference
c     function with the mp2 partitioning
c
      call dfill(nroot, 0.0d0, erefmp, 1)
c
c     loop thru orbital configurations in reference space
c
c      write(6,*)' nconf = ',nconf
      do 10 iconf = 1, nconf
         call selci_upkcon(norbs, iocc, ioconf(1,iconf), nintpo, nbitpi)
         e = selci_e0mp2(iocc)
c
c     loop thru roots
c
         do 20 iroot = 1, nroot
c
c     compute norm of this orbital config for this root and
c     add in energy contribution
c
            csq = 0.0d0
c            write(6,*)' icsf(start) = ',indxci(iconf)+1
c            write(6,*)' icsf(end  ) = ',indxci(iconf+1)
            do 30 icsf = indxci(iconf)+1, indxci(iconf+1)
               csq = csq + ci(icsf, iroot)**2
 30         continue
c            write(6,*)' e = ',e,' c**2 = ',csq
            erefmp(iroot) = erefmp(iroot) + csq*e
 20      continue
 10   continue
c
      write(6,1)
 1    format(/' moller-plesset reference energies '/)
      call selci_output(erefmp, 1, nroot, 1, 1, nroot, 1, 1)
c
      end
C>
C> @}

      logical function pre_ffield(idir,lfnpar,filep,lfnout,
     + q14fac,releps,
     + icomb,latt,catt,patt,ratt,matt,natt,latm,catm,matm,natm,
     + lbnd,rbnd,mbnd,nbnd,lang,rang,mang,nang,
     + ldih,nfdih,kdih,rdih,mdih,ndih,
     + limp,kimp,rimp,mimp,nimp,nparms,mparms)
c
c $Id: pre_ffield.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "util.fh"
#include "pre_common.fh"
c
c
      integer idir,lfnpar,lfnout,nparms,mparms
      character*255 filep
      real*8 q14fac,releps
      integer matt,natt,icomb
      integer latt(3,matt)
      character*6 catt(2,matt)
      real*8 patt(4,2,matt,matt),ratt(matt)
      integer matm,natm
      integer latm(11,matm)
      character*6 catm(mparms,matm)
      integer mbnd,nbnd
      integer lbnd(4,mbnd)
      real*8 rbnd(nparms,2,mbnd)
      integer mang,nang
      integer lang(5,mang)
      real*8 rang(nparms,4,mang)
      integer mdih,ndih
      integer ldih(6,mdih),nfdih(nparms,mdih),kdih(6,nparms,mdih)
      real*8 rdih(6,nparms,2,mdih)
      integer mimp,nimp
      integer limp(6,mimp),kimp(nparms,mdih)
      real*8 rimp(nparms,2,mimp)
c
      integer i,j,length,nt,ng,latnum,mult,ifnd,nd,jcomb
      character*80 card
      character*6 atyp1,atyp2,atyp3,atyp4,btyp1,btyp2,btyp3,btyp4
      character*1 qtm
      real*8 rmass,p1,p2,p3,p4,pt1,pt2,pt3,pt4
c
      integer mask(3)
c
      mask(1)=4
      mask(2)=2
      mask(3)=1
c
      length=index(filep,' ')-1
      open(unit=lfnpar,file=filep(1:length),form='formatted',
     + status='old',err=9999)
c
      if(util_print('files',print_default)) then
      write(lfnout,1111) filep(1:length)
 1111 format(' Parameter file',t40,a)
      endif
c
      if(icomb.eq.0) icomb=3
c
    1 continue
      read(lfnpar,1000,err=9999,end=999) card
 1000 format(a)
      if(card(1:1).eq.'#') goto 1
      if(card(1:3).eq.'End') goto 999
    2 continue
c
c     1-4 electrostatic scaling
c     -------------------------
c
      if(card(1:32).eq.'Electrostatic 1-4 scaling factor') then
      read(card(34:45),'(f12.6)') q14fac
      goto 1
      endif
c
c     relative dielectric constant
c     ----------------------------
c
      if(card(1:28).eq.'Relative dielectric constant') then
      read(card(30:41),'(f12.6)') releps
      goto 1
      endif
c
c     non-bonded parameter format
c     ---------------------------
c
      if(card(1:17).eq.'Parameters C6 C12') then
c      if(icomb.ne.0.and.icomb.ne.1)
c     + call md_abort('Combination rules should not be mixed',9999)
      jcomb=1
      if(util_print('files',print_default).and.icomb.ne.jcomb) then
      if(icomb.eq.2) write(lfnout,1102)
      if(icomb.eq.3) write(lfnout,1103)
 1101 format(/,' Parameters converted to C6 and C12')
 1102 format(/,' Parameters converted to epsilon and sigma')
 1103 format(/,' Parameters converted to epsilon and R*')
      endif
      goto 1
      endif
      if(card(1:24).eq.'Parameters epsilon sigma') then
c      if(icomb.ne.0.and.icomb.ne.2)
c     + call md_abort('Combination rules should not be mixed',9999)
      jcomb=2
      if(util_print('files',print_default).and.icomb.ne.jcomb) then
      if(icomb.eq.1) write(lfnout,1101)
      if(icomb.eq.3) write(lfnout,1103)
      endif
      goto 1
      endif
      if(card(1:21).eq.'Parameters epsilon R*') then
c      if(icomb.ne.0.and.icomb.ne.3)
c     + call md_abort('Combination rules should not be mixed',9999)
      jcomb=3
      if(util_print('files',print_default).and.icomb.ne.jcomb) then
      if(icomb.eq.1) write(lfnout,1101)
      if(icomb.eq.2) write(lfnout,1102)
      endif
      goto 1
      endif
c
c     atom types
c     ----------
c
      if(card(1:5).eq.'Atoms') then
      atyp1(6:6)=' '
      atyp2(6:6)=' '
    3 continue
      read(lfnpar,1000,end=999) card
      if(card(1:1).eq.'#') goto 3
      if(card(1:5).eq.'Cross') goto 2
      if(card(1:5).eq.'Bonds') goto 2
      if(card(1:6).eq.'Angles') goto 2
      if(card(1:16).eq.'Proper dihedrals') goto 2
      if(card(1:18).eq.'Improper dihedrals') goto 2
      if(card(1:10).eq.'Atom types') goto 2
      if(card(1:3).eq.'End') goto 999
      read(card,1001,err=2) atyp1(1:5),rmass,p1,p2,p3,p4,nt,ng
 1001 format(a5,f10.5,4e12.5,i5,1x,i10)
      if(atyp1.eq.'      ') goto 1
      read(lfnpar,1002,err=9999) atyp2(1:5),qtm,latnum,pt1,pt2,pt3,pt4
 1002 format(a5,1x,a1,3x,i5,4e12.5)
      if(atyp2.eq.'      ') atyp2=atyp1
      do 4 i=1,natt
      if(catt(1,i)(1:5).eq.atyp1(1:5).and.
     + (qtm.eq.' '.or.qtm.eq.catt(1,i)(6:6))) then
      catt(2,i)=atyp2
      ratt(i)=rmass
      latt(1,i)=latnum
      latt(2,i)=nt
      latt(3,i)=ng
c
      if(icomb.ne.jcomb) then
      if(icomb.eq.1) then
      if(jcomb.eq.2) then
      call md_abort('Parameter conversion not implemented',12)
      elseif(jcomb.eq.3) then
      call md_abort('Parameter conversion not implemented',13)
      elseif(jcomb.eq.4) then
      call md_abort('Parameter conversion not implemented',14)
      endif
      elseif(icomb.eq.2) then
      if(jcomb.eq.1) then
      call md_abort('Parameter conversion not implemented',21)
      elseif(jcomb.eq.3) then
      call md_abort('Parameter conversion not implemented',23)
      elseif(jcomb.eq.4) then
      call md_abort('Parameter conversion not implemented',24)
      endif
      elseif(icomb.eq.3) then
      if(jcomb.eq.1) then
      patt(1,1,i,i)=0.25d0*(p1*p1/p2)
      patt(2,1,i,i)=0.5d0*((2.0d0*p2/p1)**(1.0d0/6.0d0))
      patt(3,1,i,i)=p3
      patt(4,1,i,i)=p4
      patt(1,2,i,i)=0.25d0*(pt1*pt1/pt2)
      patt(2,2,i,i)=0.5d0*((2.0d0*pt2/pt1)**(1.0d0/6.0d0))
      patt(3,2,i,i)=pt3
      patt(4,2,i,i)=pt4
      elseif(jcomb.eq.2) then
      call md_abort('Parameter conversion not implemented',32)
      elseif(jcomb.eq.4) then
      call md_abort('Parameter conversion not implemented',34)
      endif
      elseif(icomb.eq.4) then
      if(jcomb.eq.1) then
      call md_abort('Parameter conversion not implemented',41)
      elseif(jcomb.eq.2) then
      call md_abort('Parameter conversion not implemented',42)
      elseif(jcomb.eq.3) then
      call md_abort('Parameter conversion not implemented',43)
      endif
      endif
      else
      patt(1,1,i,i)=p1
      patt(2,1,i,i)=p2
      patt(3,1,i,i)=p3
      patt(4,1,i,i)=p4
      patt(1,2,i,i)=pt1
      patt(2,2,i,i)=pt2
      patt(3,2,i,i)=pt3
      patt(4,2,i,i)=pt4
      endif
c
      do 5 j=1,natt
      if(i.ne.j) then
      if(icomb.eq.1) then
      endif
      if(icomb.eq.2) then
      patt(1,1,i,j)=sqrt(patt(1,1,i,i)*patt(1,1,j,j))
      patt(1,1,j,i)=patt(1,1,i,j)
      patt(2,1,i,j)=patt(2,1,i,i)+patt(2,1,j,j)
      patt(2,1,j,i)=patt(2,1,i,j)
      patt(1,2,i,j)=sqrt(patt(1,2,i,i)*patt(1,2,j,j))
      patt(1,2,j,i)=patt(1,2,i,j)
      patt(2,2,i,j)=patt(2,2,i,i)+patt(2,2,j,j)
      patt(2,2,j,i)=patt(2,2,i,j)
      endif
      if(icomb.eq.3) then
      patt(1,1,i,j)=sqrt(patt(1,1,i,i)*patt(1,1,j,j))
      patt(1,1,j,i)=patt(1,1,i,j)
      patt(2,1,i,j)=patt(2,1,i,i)+patt(2,1,j,j)
      patt(2,1,j,i)=patt(2,1,i,j)
      patt(1,2,i,j)=sqrt(patt(1,2,i,i)*patt(1,2,j,j))
      patt(1,2,j,i)=patt(1,2,i,j)
      patt(2,2,i,j)=patt(2,2,i,i)+patt(2,2,j,j)
      patt(2,2,j,i)=patt(2,2,i,j)
      endif
      endif
    5 continue
      endif
    4 continue
      goto 3
      endif
c
c     cross terms
c     -----------
c
      if(card(1:5).eq.'Cross') then
      atyp1(6:6)=' '
      atyp2(6:6)=' '
    6 continue
      read(lfnpar,1000,end=999) card
      if(card(1:1).eq.'#') goto 6
      if(card(1:5).eq.'Atoms') goto 2
      if(card(1:5).eq.'Bonds') goto 2
      if(card(1:6).eq.'Angles') goto 2
      if(card(1:16).eq.'Proper dihedrals') goto 2
      if(card(1:18).eq.'Improper dihedrals') goto 2
      if(card(1:10).eq.'Atom types') goto 2
      if(card(1:3).eq.'End') goto 999
      read(card,1003,err=2) atyp1(1:5),atyp2(1:5),p1,p2
 1003 format(a5,1x,a5,2x,2e12.5)
      if(atyp1.eq.'      ') goto 1
      if(atyp2.eq.'      ') goto 1
      read(lfnpar,1004,err=9999) pt1,pt2
 1004 format(13x,2e12.5)
c
      do 7 i=1,natt
      if(catt(1,i)(1:5).eq.atyp1) then
      do 8 j=1,natt
      if(catt(1,i)(1:5).eq.atyp2) then
c
      if(icomb.ne.jcomb) then
      if(icomb.eq.1) then
      if(jcomb.eq.2) then
      call md_abort('Parameter conversion not implemented',12)
      elseif(jcomb.eq.3) then
      call md_abort('Parameter conversion not implemented',13)
      elseif(jcomb.eq.4) then
      call md_abort('Parameter conversion not implemented',14)
      endif
      elseif(icomb.eq.2) then
      if(jcomb.eq.1) then
      call md_abort('Parameter conversion not implemented',21)
      elseif(jcomb.eq.3) then
      call md_abort('Parameter conversion not implemented',23)
      elseif(jcomb.eq.4) then
      call md_abort('Parameter conversion not implemented',24)
      endif
      elseif(icomb.eq.3) then
      if(jcomb.eq.1) then
      patt(1,1,i,j)=0.25d0*(p1*p1/p2)
      patt(2,1,i,j)=0.5d0*((2.0d0*p2/p1)**(1.0d0/6.0d0))
      patt(3,1,i,j)=p3
      patt(4,1,i,j)=p4
      patt(1,2,i,j)=0.25d0*(pt1*pt1/pt2)
      patt(2,2,i,j)=0.5d0*((2.0d0*pt2/pt1)**(1.0d0/6.0d0))
      patt(3,2,i,j)=pt3
      patt(4,2,i,j)=pt4
      elseif(jcomb.eq.2) then
      call md_abort('Parameter conversion not implemented',32)
      elseif(jcomb.eq.4) then
      call md_abort('Parameter conversion not implemented',34)
      endif
      elseif(icomb.eq.4) then
      if(jcomb.eq.1) then
      call md_abort('Parameter conversion not implemented',41)
      elseif(jcomb.eq.2) then
      call md_abort('Parameter conversion not implemented',42)
      elseif(jcomb.eq.3) then
      call md_abort('Parameter conversion not implemented',43)
      endif
      endif
      else
      if(icomb.eq.1) then
      patt(1,1,i,j)=p1
      patt(2,1,i,j)=p2
      patt(3,1,i,j)=p3
      patt(4,1,i,j)=p4
      patt(1,2,i,j)=pt1
      patt(2,2,i,j)=pt2
      patt(3,2,i,j)=pt3
      patt(4,2,i,j)=pt4
      elseif(icomb.eq.2) then
      patt(1,1,i,j)=p1
      patt(2,1,i,j)=p2+p2
      patt(3,1,i,j)=p3
      patt(4,1,i,j)=p4
      patt(1,2,i,j)=pt1
      patt(2,2,i,j)=pt2+pt2
      patt(3,2,i,j)=pt3
      patt(4,2,i,j)=pt4
      elseif(icomb.eq.3) then
      patt(1,1,i,j)=p1
      patt(2,1,i,j)=p2+p2
      patt(3,1,i,j)=p3
      patt(4,1,i,j)=p4
      patt(1,2,i,j)=pt1
      patt(2,2,i,j)=pt2+pt2
      patt(3,2,i,j)=pt3
      patt(4,2,i,j)=pt4
      elseif(icomb.eq.4) then
      patt(1,1,i,j)=p1
      patt(2,1,i,j)=p2
      patt(3,1,i,j)=p3
      patt(4,1,i,j)=p4
      patt(1,2,i,j)=pt1
      patt(2,2,i,j)=pt2
      patt(3,2,i,j)=pt3
      patt(4,2,i,j)=pt4
      endif
      endif
c
c      if(icomb.eq.1) then
c      patt(1,1,i,j)=p1
c      patt(2,1,i,j)=p2
c      patt(1,2,i,j)=pt1
c      patt(2,2,i,j)=pt2
c      endif
c      if(icomb.eq.2) then
c      endif
c      if(icomb.eq.3) then
c      patt(1,1,i,j)=sqrt(p1*p1)
c      patt(2,1,i,j)=p2+p2
c      patt(1,2,i,j)=sqrt(pt1*pt1)
c      patt(2,2,i,j)=pt2+pt2
c      endif
c
      patt(1,1,j,i)=patt(1,1,i,j)
      patt(2,1,j,i)=patt(2,1,i,j)
      patt(1,2,j,i)=patt(1,2,i,j)
      patt(2,2,j,i)=patt(2,2,i,j)
      endif
    8 continue
      endif
    7 continue
      goto 6
      endif
c
c     bonds
c     -----
c
      if(card(1:5).eq.'Bonds') then
      atyp1(6:6)=' '
      atyp2(6:6)=' '
      btyp1(6:6)=' '
      btyp2(6:6)=' '
    9 continue
      read(lfnpar,1000,end=999) card
      if(card(1:1).eq.'#') goto 9
      if(card(1:5).eq.'Atoms') goto 2
      if(card(1:5).eq.'Cross') goto 2
      if(card(1:6).eq.'Angles') goto 2
      if(card(1:16).eq.'Proper dihedrals') goto 2
      if(card(1:18).eq.'Improper dihedrals') goto 2
      if(card(1:10).eq.'Atom types') goto 2
      if(card(1:3).eq.'End') goto 999
      read(card,1005,err=2) atyp1(1:5),atyp2(1:5),p1,p2
 1005 format(a5,1x,a5,f10.5,e12.5)
      if(atyp1.eq.'      ') goto 1
      if(atyp2.eq.'      ') goto 1
      do 10 i=1,nbnd
c      if(lbnd(3,i).le.0.and.lbnd(4,i).eq.0) then
      if(lbnd(3,i).le.0) then
      do 11 j=1,nparms
      if(iand(mask(j),lbnd(4,i)).eq.0) then
      btyp1(1:5)=catm(1+j,lbnd(1,i))(1:5)
      btyp2(1:5)=catm(1+j,lbnd(2,i))(1:5)
      if((atyp1.eq.btyp1.and.atyp2.eq.btyp2).or.
     + (atyp2.eq.btyp1.and.atyp1.eq.btyp2)) then
      rbnd(j,1,i)=p1
      rbnd(j,2,i)=p2
      lbnd(3,i)=-(ior(iabs(lbnd(3,i)),2**(j-1)))
      endif
      endif
   11 continue
      endif
   10 continue
      goto 9
      endif
c
c     angles
c     ------
c
      if(card(1:6).eq.'Angles') then
      atyp1(6:6)=' '
      atyp2(6:6)=' '
      atyp3(6:6)=' '
      btyp1(6:6)=' '
      btyp2(6:6)=' '
      btyp3(6:6)=' '
   12 continue
      read(lfnpar,1000,end=999) card
      if(card(1:1).eq.'#') goto 12
      if(card(1:5).eq.'Atoms') goto 2
      if(card(1:5).eq.'Cross') goto 2
      if(card(1:5).eq.'Bonds') goto 2
      if(card(1:16).eq.'Proper dihedrals') goto 2
      if(card(1:18).eq.'Improper dihedrals') goto 2
      if(card(1:10).eq.'Atom types') goto 2
      if(card(1:3).eq.'End') goto 999
      if(ffield(1:6).ne.'charmm') then
      read(card,1006,err=2) atyp1(1:5),atyp2(1:5),atyp3(1:5),p1,p2
      else
      read(card,1006,err=2) atyp1(1:5),atyp2(1:5),atyp3(1:5),p1,p2,p3,p4
      endif
 1006 format(a5,1x,a5,1x,a5,2(f10.5,e12.5))
      if(atyp1.eq.'      ') goto 1
      if(atyp2.eq.'      ') goto 1
      if(atyp3.eq.'      ') goto 1
      do 13 i=1,nang
c      if(lang(4,i).le.0.and.lang(5,i).eq.0) then
      if(lang(4,i).le.0) then
      do 14 j=1,nparms
      if(iand(mask(j),lang(5,i)).eq.0) then
      btyp1(1:5)=catm(1+j,lang(1,i))(1:5)
      btyp2(1:5)=catm(1+j,lang(2,i))(1:5)
      btyp3(1:5)=catm(1+j,lang(3,i))(1:5)
      if(atyp2.eq.btyp2.and.((atyp1.eq.btyp1.and.atyp3.eq.btyp3).or.
     + (atyp3.eq.btyp1.and.atyp1.eq.btyp3))) then
      rang(j,1,i)=p1
      rang(j,2,i)=p2
      if(ffield(1:6).eq.'charmm') then
      rang(j,3,i)=p3
      rang(j,4,i)=p4
      endif
      lang(4,i)=-(ior(iabs(lang(4,i)),2**(j-1)))
c      write(*,'(6i5,6a6)') lang(1,i),lang(2,i),lang(3,i),lang(4,i),
c     + lang(5,i),j,atyp1,atyp2,atyp3,btyp1,btyp2,btyp3
c      write(*,'(4i5,3a6)') (lang(j,i),j=1,4),atyp1,atyp2,atyp3
      endif
      endif
   14 continue
      endif
   13 continue
      goto 12
      endif
c
c     torsions
c     --------
c
      if(card(1:16).eq.'Proper dihedrals') then
      atyp1(6:6)=' '
      atyp2(6:6)=' '
      atyp3(6:6)=' '
      atyp4(6:6)=' '
      btyp1(6:6)=' '
      btyp2(6:6)=' '
      btyp3(6:6)=' '
      btyp4(6:6)=' '
      nd=0
   15 continue
      read(lfnpar,1000,end=999) card
      if(card(1:1).eq.'#') goto 15
      if(card(1:5).eq.'Atoms') goto 2
      if(card(1:5).eq.'Cross') goto 2
      if(card(1:5).eq.'Bonds') goto 2
      if(card(1:6).eq.'Angles') goto 2
      if(card(1:18).eq.'Improper dihedrals') goto 2
      if(card(1:10).eq.'Atom types') goto 2
      if(card(1:3).eq.'End') goto 999
      read(card,1007,err=2) atyp1(1:5),atyp2(1:5),atyp3(1:5),atyp4(1:5),
     + p1,p2,mult
 1007 format(a5,1x,a5,1x,a5,1x,a5,f10.5,e12.5,i5)
      nd=nd+1
      if(atyp2.eq.'      ') goto 1
      if(atyp3.eq.'      ') goto 1
      do 16 i=1,ndih
c      if(ldih(5,i).le.0.and.ldih(6,i).eq.0) then
      if(ldih(5,i).le.0) then
      do 17 j=1,nparms
      if(iand(mask(j),ldih(6,i)).eq.0) then
      btyp1(1:5)=catm(1+j,ldih(1,i))(1:5)
      btyp2(1:5)=catm(1+j,ldih(2,i))(1:5)
      btyp3(1:5)=catm(1+j,ldih(3,i))(1:5)
      btyp4(1:5)=catm(1+j,ldih(4,i))(1:5)
c
      if(((atyp1.eq.'      '.or.atyp1.eq.btyp1).and.
     + atyp2.eq.btyp2.and.atyp3.eq.btyp3.and.
     + (atyp4.eq.'      '.or.atyp4.eq.btyp4)).or.
     + ((atyp1.eq.'      '.or.atyp1.eq.btyp4).and.
     + atyp2.eq.btyp3.and.atyp3.eq.btyp2.and.
     + (atyp4.eq.'      '.or.atyp4.eq.btyp1))) then
      nfdih(j,i)=nd
      kdih(nfdih(j,i),j,i)=mult
      rdih(nfdih(j,i),j,1,i)=p1 
      rdih(nfdih(j,i),j,2,i)=p2 
      ldih(5,i)=-(ior(iabs(ldih(5,i)),2**(j-1)))
      endif
      endif
   17 continue
      endif
   16 continue
      if(mult.gt.0) nd=0
      goto 15
      endif
c
c     impropers
c     ---------
c
      if(card(1:18).eq.'Improper dihedrals') then
      atyp1(6:6)=' '
      atyp2(6:6)=' '
      atyp3(6:6)=' '
      atyp4(6:6)=' '
      btyp1(6:6)=' '
      btyp2(6:6)=' '
      btyp3(6:6)=' '
      btyp4(6:6)=' '
   18 continue
      read(lfnpar,1000,end=999) card
      if(card(1:1).eq.'#') goto 18
      if(card(1:5).eq.'Atoms') goto 2
      if(card(1:5).eq.'Cross') goto 2
      if(card(1:5).eq.'Bonds') goto 2
      if(card(1:6).eq.'Angles') goto 2
      if(card(1:16).eq.'Proper dihedrals') goto 2
      if(card(1:10).eq.'Atom types') goto 2
      if(card(1:3).eq.'End') goto 999
      if(ffield(1:5).eq.'amber') then
      read(card,1008,err=2) atyp2(1:5),atyp3(1:5),atyp1(1:5),atyp4(1:5),
     + p1,p2,mult
 1008 format(a5,1x,a5,1x,a5,1x,a5,f10.5,e12.5,i5)
      else
      read(card,1008,err=2) atyp1(1:5),atyp2(1:5),atyp3(1:5),atyp4(1:5),
     + p1,p2,mult
      endif
      if(atyp1.eq.'      ') goto 1
      if(atyp4.eq.'      ') goto 1
      do 19 i=1,nimp
c      if(limp(5,i).le.0.and.limp(6,i).eq.0) then
      if(limp(5,i).le.0) then
      do 20 j=1,nparms
      if(iand(mask(j),limp(6,i)).eq.0) then
      btyp1(1:5)=catm(1+j,limp(1,i))(1:5)
      btyp2(1:5)=catm(1+j,limp(2,i))(1:5)
      btyp3(1:5)=catm(1+j,limp(3,i))(1:5)
      btyp4(1:5)=catm(1+j,limp(4,i))(1:5)
c
      ifnd=0
      if(atyp1.eq.btyp1) then
      if(atyp2.eq.'      ') then
      if(atyp3.eq.'      ') then
      if(atyp4.eq.btyp4) ifnd=1
      if(atyp4.eq.btyp3) ifnd=1
      if(atyp4.eq.btyp2) ifnd=1
      else
      if(atyp3.eq.btyp3.and.atyp4.eq.btyp4) ifnd=1
      if(atyp3.eq.btyp4.and.atyp4.eq.btyp3) ifnd=1
      if(atyp3.eq.btyp2.and.atyp4.eq.btyp4) ifnd=1
      if(atyp3.eq.btyp4.and.atyp4.eq.btyp2) ifnd=1
      if(atyp3.eq.btyp2.and.atyp4.eq.btyp3) ifnd=1
      if(atyp3.eq.btyp3.and.atyp4.eq.btyp2) ifnd=1
      endif
      else
      if(atyp3.eq.'      ') then
      if(atyp2.eq.btyp3.and.atyp4.eq.btyp4) ifnd=1
      if(atyp2.eq.btyp4.and.atyp4.eq.btyp3) ifnd=1
      if(atyp2.eq.btyp2.and.atyp4.eq.btyp4) ifnd=1
      if(atyp2.eq.btyp4.and.atyp4.eq.btyp2) ifnd=1
      if(atyp2.eq.btyp2.and.atyp4.eq.btyp3) ifnd=1
      if(atyp2.eq.btyp3.and.atyp4.eq.btyp2) ifnd=1
      else
      if(atyp2.eq.btyp2.and.atyp3.eq.btyp3.and.atyp4.eq.btyp4) ifnd=1
      if(atyp2.eq.btyp3.and.atyp3.eq.btyp4.and.atyp4.eq.btyp2) ifnd=1
      if(atyp2.eq.btyp4.and.atyp3.eq.btyp2.and.atyp4.eq.btyp3) ifnd=1
      if(atyp2.eq.btyp3.and.atyp3.eq.btyp2.and.atyp4.eq.btyp4) ifnd=-1
      if(atyp2.eq.btyp2.and.atyp3.eq.btyp4.and.atyp4.eq.btyp3) ifnd=-1
      if(atyp2.eq.btyp4.and.atyp3.eq.btyp3.and.atyp4.eq.btyp2) ifnd=-1
      endif
      endif
      endif
c
      if(ffield(1:5).eq.'charm'.and.ifnd.eq.0) then
      if(atyp4.eq.btyp1) then
      if(atyp3.eq.'      ') then
      if(atyp2.eq.'      ') then
      if(atyp1.eq.btyp4) ifnd=1
      if(atyp1.eq.btyp3) ifnd=1
      if(atyp1.eq.btyp2) ifnd=1
      else
      if(atyp2.eq.btyp3.and.atyp1.eq.btyp4) ifnd=1
      if(atyp2.eq.btyp4.and.atyp1.eq.btyp3) ifnd=1
      if(atyp2.eq.btyp2.and.atyp1.eq.btyp4) ifnd=1
      if(atyp2.eq.btyp4.and.atyp1.eq.btyp2) ifnd=1
      if(atyp2.eq.btyp2.and.atyp1.eq.btyp3) ifnd=1
      if(atyp2.eq.btyp3.and.atyp1.eq.btyp2) ifnd=1
      endif
      else
      if(atyp2.eq.'      ') then
      if(atyp3.eq.btyp3.and.atyp1.eq.btyp4) ifnd=1
      if(atyp3.eq.btyp4.and.atyp1.eq.btyp3) ifnd=1
      if(atyp3.eq.btyp2.and.atyp1.eq.btyp4) ifnd=1
      if(atyp3.eq.btyp4.and.atyp1.eq.btyp2) ifnd=1
      if(atyp3.eq.btyp2.and.atyp1.eq.btyp3) ifnd=1
      if(atyp3.eq.btyp3.and.atyp1.eq.btyp2) ifnd=1
      else
      if(atyp3.eq.btyp2.and.atyp2.eq.btyp3.and.atyp1.eq.btyp4) ifnd=1
      if(atyp3.eq.btyp3.and.atyp2.eq.btyp4.and.atyp1.eq.btyp2) ifnd=1
      if(atyp3.eq.btyp4.and.atyp2.eq.btyp2.and.atyp1.eq.btyp3) ifnd=1
      if(atyp3.eq.btyp3.and.atyp2.eq.btyp2.and.atyp1.eq.btyp4) ifnd=-1
      if(atyp3.eq.btyp2.and.atyp2.eq.btyp4.and.atyp1.eq.btyp3) ifnd=-1
      if(atyp3.eq.btyp4.and.atyp2.eq.btyp3.and.atyp1.eq.btyp2) ifnd=-1
      endif
      endif
      endif
      endif
c
      if(ifnd.ne.0) then
      kimp(j,i)=mult
      rimp(j,1,i)=ifnd*p1 
      rimp(j,2,i)=p2 
      limp(5,i)=-(ior(iabs(limp(5,i)),2**(j-1)))
      endif
      endif
c
   20 continue
      endif
   19 continue
      goto 18
      endif
c
      goto 1
  999 continue
      close(unit=lfnpar)
c
      pre_ffield=.true.
      if(util_print('where',print_debug)) then
      write(lfnout,2006)
 2006 format(/,'pre_ffield done')
      endif
      return
 9999 continue
      pre_ffield=.false.
      return
      end

      subroutine dplot_defgrid(volume,angle,
     ,     spread,step,const_m,const_p,
     ,     cooto,coofrom,ngridxyz)
      implicit none
#include "errquit.fh"
#include "util_params.fh"
      double precision volume
      double precision angle(3),spread(3),step(3)
      integer const_m(3),const_p(3)
      double precision cooto(3),coofrom(3) ! [in]
      integer ngridxyz(3) ! [in]
c
      integer i
      double precision scale,frac_p
c
      Volume = 1.0d0
      Scale  = 1d0/cau2ang
c
      Do i = 1, 3
         Angle(i)  = 90.0d0
         If (nGridXYZ(i).gt.0) Then
            Spread(i) = CooTo(i)-CooFrom(i)
            Step(i)   = Spread(i)/dble( nGridXYZ(i) )
            Volume    = Volume * Step(i)
            If (CooFrom(i).ge.0.0d0) Then
               Const_M(i) = 0
               Const_P(i) = nGridXYZ(i)
            Else If (CooTo(i).le.0.0d0) Then
               Const_M(i) =-nGridXYZ(i)
               Const_P(i) = 0
            Else
               Frac_P     = (CooTo(i)-0.5d0*Step(i))/Spread(i)
               Const_P(i) = Int(Frac_P*nGridXYZ(i)) + 1
               Const_M(i) = Const_P(i) - nGridXYZ(i)
            End If
            Spread(i) = Spread(i)/Scale
         Else If (nGridXYZ(i).eq.0) Then
            Volume     =0.d0
            CooFrom(i) = (CooFrom(i)+CooTo(i))/2.d0
            CooTo(i)   = CooFrom(i)
            Spread(i)  = 0.d0
            Const_M(i) = 0
            Const_P(i) = 0
         Else
            Call ErrQuit('Get_Grid: Negative no_of_spacings', 0,
     &       INPUT_ERR)
         End If
      End Do
      return
      end
c $Id: dplot_defgrid.F 24668 2013-10-18 00:35:34Z edo $

      subroutine mp2_zero_forces(force,oactive,nat)
*
* $Id: mp2_grad_utils.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      implicit none
      integer nat,i
      double precision force(3,nat)
      logical oactive
      dimension oactive(nat)
      do i=1,nat
         if (.not.oactive(i)) then
            force(1,i)=0.0d0
            force(2,i)=0.0d0
            force(3,i)=0.0d0
         endif
      enddo
      return
      end
c      
c$$$      subroutine div_eigen_aaaa(noa,nva,nob,
c$$$     $     nvb,nbf,orbe_a,t1_aaaa)
c$$$      implicit none
c$$$      integer noa,nva,nob,nvb,nbf
c$$$      double precision orbe_a(nbf)
c$$$      double precision t1_aaaa(*)
c$$$      integer a,a_count,b,b_count,count
c$$$c...  
c$$$c...  routine to return amplitude of the
c$$$c...  first order correction to the wavefunction for the
c$$$c...  alpha/alpha and beta/beta case.
c$$$c...  
c$$$      count=0
c$$$      a_count=0
c$$$      b_count=0
c$$$      do a=noa+1,nbf
c$$$         a_count=a_count+1
c$$$         do b=nob+1,nbf
c$$$            b_count=b_count+1
c$$$            count=count+1
c$$$            t1_aaaa(count)=t1_aaaa(count)/
c$$$     $           (orbe_a(i)+orbe_a(j)
c$$$     $           -orbe_a(a_count)-orbe_a(b_count))
c$$$         enddo
c$$$      enddo
c$$$      return
c$$$      end
c     
c     
      subroutine div_eigen_aabb(i,a_count,jlo_1,jhi_1,blo_1,bhi_1,
     $     noa,nva,nob,nvb,nbf,orbe_a,orbe_b,g_t1_aabb,t1_aabb)
      implicit none
#include "global.fh"
      integer noa,nva,nob,nvb,nbf
      double precision orbe_a(nbf),orbe_b(nbf)
      double precision t1_aabb(*)
      integer i,a_count
      integer j,j_count,b,b_count,count
      integer g_t1_aabb
      integer myid,jlo,jhi,blo,bhi
      integer blo_1,bhi_1,jlo_1,jhi_1
c...  
c...  routine to return amplitude of the
c...  first order correction to the wavefunction for the
c...  alpha/beta and beta/alpha case.
c...  
      myid=ga_nodeid()
      write(6,*) 'myid is ', myid
      write(6,*) 'INSIDE THE DIV_EIGEN_AABB CRAP'
      write(6,*) 'i,a_count,jlo_1,jhi_1,blo_1,bhi_1',
     $     i,a_count,jlo_1,jhi_1,blo_1,bhi_1
      call ga_print(g_t1_aabb)
c      call ga_distribution(g_t1_bb,myid,jlo,jhi,blo,bhi)
      count=0
      do j=jlo_1,jhi_1
         do b=blo_1,bhi_1
            count=count+1
            t1_aabb(count)=t1_aabb(count)/
     $           (orbe_a(i)+orbe_b(j)
     $           -orbe_a(a_count)-orbe_b(b))
         enddo
      enddo
      return
      end

*> \brief \b IPARMQ
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download IPARMQ + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/iparmq.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/iparmq.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/iparmq.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       INTEGER FUNCTION IPARMQ( ISPEC, NAME, OPTS, N, ILO, IHI, LWORK )
* 
*       .. Scalar Arguments ..
*       INTEGER            IHI, ILO, ISPEC, LWORK, N
*       CHARACTER          NAME*( * ), OPTS*( * )
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>      This program sets problem and machine dependent parameters
*>      useful for xHSEQR and its subroutines. It is called whenever 
*>      ILAENV is called with 12 <= ISPEC <= 16
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ISPEC
*> \verbatim
*>          ISPEC is integer scalar
*>              ISPEC specifies which tunable parameter IPARMQ should
*>              return.
*>
*>              ISPEC=12: (INMIN)  Matrices of order nmin or less
*>                        are sent directly to xLAHQR, the implicit
*>                        double shift QR algorithm.  NMIN must be
*>                        at least 11.
*>
*>              ISPEC=13: (INWIN)  Size of the deflation window.
*>                        This is best set greater than or equal to
*>                        the number of simultaneous shifts NS.
*>                        Larger matrices benefit from larger deflation
*>                        windows.
*>
*>              ISPEC=14: (INIBL) Determines when to stop nibbling and
*>                        invest in an (expensive) multi-shift QR sweep.
*>                        If the aggressive early deflation subroutine
*>                        finds LD converged eigenvalues from an order
*>                        NW deflation window and LD.GT.(NW*NIBBLE)/100,
*>                        then the next QR sweep is skipped and early
*>                        deflation is applied immediately to the
*>                        remaining active diagonal block.  Setting
*>                        IPARMQ(ISPEC=14) = 0 causes TTQRE to skip a
*>                        multi-shift QR sweep whenever early deflation
*>                        finds a converged eigenvalue.  Setting
*>                        IPARMQ(ISPEC=14) greater than or equal to 100
*>                        prevents TTQRE from skipping a multi-shift
*>                        QR sweep.
*>
*>              ISPEC=15: (NSHFTS) The number of simultaneous shifts in
*>                        a multi-shift QR iteration.
*>
*>              ISPEC=16: (IACC22) IPARMQ is set to 0, 1 or 2 with the
*>                        following meanings.
*>                        0:  During the multi-shift QR sweep,
*>                            xLAQR5 does not accumulate reflections and
*>                            does not use matrix-matrix multiply to
*>                            update the far-from-diagonal matrix
*>                            entries.
*>                        1:  During the multi-shift QR sweep,
*>                            xLAQR5 and/or xLAQRaccumulates reflections and uses
*>                            matrix-matrix multiply to update the
*>                            far-from-diagonal matrix entries.
*>                        2:  During the multi-shift QR sweep.
*>                            xLAQR5 accumulates reflections and takes
*>                            advantage of 2-by-2 block structure during
*>                            matrix-matrix multiplies.
*>                        (If xTRMM is slower than xGEMM, then
*>                        IPARMQ(ISPEC=16)=1 may be more efficient than
*>                        IPARMQ(ISPEC=16)=2 despite the greater level of
*>                        arithmetic work implied by the latter choice.)
*> \endverbatim
*>
*> \param[in] NAME
*> \verbatim
*>          NAME is character string
*>               Name of the calling subroutine
*> \endverbatim
*>
*> \param[in] OPTS
*> \verbatim
*>          OPTS is character string
*>               This is a concatenation of the string arguments to
*>               TTQRE.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is integer scalar
*>               N is the order of the Hessenberg matrix H.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>               It is assumed that H is already upper triangular
*>               in rows and columns 1:ILO-1 and IHI+1:N.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is integer scalar
*>               The amount of workspace available.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup auxOTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>       Little is known about how best to choose these parameters.
*>       It is possible to use different values of the parameters
*>       for each of CHSEQR, DHSEQR, SHSEQR and ZHSEQR.
*>
*>       It is probably best to choose different parameters for
*>       different matrices and different parameters at different
*>       times during the iteration, but this has not been
*>       implemented --- yet.
*>
*>
*>       The best choices of most of the parameters depend
*>       in an ill-understood way on the relative execution
*>       rate of xLAQR3 and xLAQR5 and on the nature of each
*>       particular eigenvalue problem.  Experiment may be the
*>       only practical way to determine which choices are most
*>       effective.
*>
*>       Following is a list of default values supplied by IPARMQ.
*>       These defaults may be adjusted in order to attain better
*>       performance in any particular computational environment.
*>
*>       IPARMQ(ISPEC=12) The xLAHQR vs xLAQR0 crossover point.
*>                        Default: 75. (Must be at least 11.)
*>
*>       IPARMQ(ISPEC=13) Recommended deflation window size.
*>                        This depends on ILO, IHI and NS, the
*>                        number of simultaneous shifts returned
*>                        by IPARMQ(ISPEC=15).  The default for
*>                        (IHI-ILO+1).LE.500 is NS.  The default
*>                        for (IHI-ILO+1).GT.500 is 3*NS/2.
*>
*>       IPARMQ(ISPEC=14) Nibble crossover point.  Default: 14.
*>
*>       IPARMQ(ISPEC=15) Number of simultaneous shifts, NS.
*>                        a multi-shift QR iteration.
*>
*>                        If IHI-ILO+1 is ...
*>
*>                        greater than      ...but less    ... the
*>                        or equal to ...      than        default is
*>
*>                                0               30       NS =   2+
*>                               30               60       NS =   4+
*>                               60              150       NS =  10
*>                              150              590       NS =  **
*>                              590             3000       NS =  64
*>                             3000             6000       NS = 128
*>                             6000             infinity   NS = 256
*>
*>                    (+)  By default matrices of this order are
*>                         passed to the implicit double shift routine
*>                         xLAHQR.  See IPARMQ(ISPEC=12) above.   These
*>                         values of NS are used only in case of a rare
*>                         xLAHQR failure.
*>
*>                    (**) The asterisks (**) indicate an ad-hoc
*>                         function increasing from 10 to 64.
*>
*>       IPARMQ(ISPEC=16) Select structured matrix multiply.
*>                        (See ISPEC=16 above for details.)
*>                        Default: 3.
*> \endverbatim
*>
*  =====================================================================
      INTEGER FUNCTION IPARMQ( ISPEC, NAME, OPTS, N, ILO, IHI, LWORK )
*
*  -- LAPACK auxiliary routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, ISPEC, LWORK, N
      CHARACTER          NAME*( * ), OPTS*( * )
*
*  ================================================================
*     .. Parameters ..
      INTEGER            INMIN, INWIN, INIBL, ISHFTS, IACC22
      PARAMETER          ( INMIN = 12, INWIN = 13, INIBL = 14,
     $                   ISHFTS = 15, IACC22 = 16 )
      INTEGER            NMIN, K22MIN, KACMIN, NIBBLE, KNWSWP
      PARAMETER          ( NMIN = 75, K22MIN = 14, KACMIN = 14,
     $                   NIBBLE = 14, KNWSWP = 500 )
      REAL               TWO
      PARAMETER          ( TWO = 2.0 )
*     ..
*     .. Local Scalars ..
      INTEGER            NH, NS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          LOG, MAX, MOD, NINT, REAL
*     ..
*     .. Executable Statements ..
      IF( ( ISPEC.EQ.ISHFTS ) .OR. ( ISPEC.EQ.INWIN ) .OR.
     $    ( ISPEC.EQ.IACC22 ) ) THEN
*
*        ==== Set the number simultaneous shifts ====
*
         NH = IHI - ILO + 1
         NS = 2
         IF( NH.GE.30 )
     $      NS = 4
         IF( NH.GE.60 )
     $      NS = 10
         IF( NH.GE.150 )
     $      NS = MAX( 10, NH / NINT( LOG( REAL( NH ) ) / LOG( TWO ) ) )
         IF( NH.GE.590 )
     $      NS = 64
         IF( NH.GE.3000 )
     $      NS = 128
         IF( NH.GE.6000 )
     $      NS = 256
         NS = MAX( 2, NS-MOD( NS, 2 ) )
      END IF
*
      IF( ISPEC.EQ.INMIN ) THEN
*
*
*        ===== Matrices of order smaller than NMIN get sent
*        .     to xLAHQR, the classic double shift algorithm.
*        .     This must be at least 11. ====
*
         IPARMQ = NMIN
*
      ELSE IF( ISPEC.EQ.INIBL ) THEN
*
*        ==== INIBL: skip a multi-shift qr iteration and
*        .    whenever aggressive early deflation finds
*        .    at least (NIBBLE*(window size)/100) deflations. ====
*
         IPARMQ = NIBBLE
*
      ELSE IF( ISPEC.EQ.ISHFTS ) THEN
*
*        ==== NSHFTS: The number of simultaneous shifts =====
*
         IPARMQ = NS
*
      ELSE IF( ISPEC.EQ.INWIN ) THEN
*
*        ==== NW: deflation window size.  ====
*
         IF( NH.LE.KNWSWP ) THEN
            IPARMQ = NS
         ELSE
            IPARMQ = 3*NS / 2
         END IF
*
      ELSE IF( ISPEC.EQ.IACC22 ) THEN
*
*        ==== IACC22: Whether to accumulate reflections
*        .     before updating the far-from-diagonal elements
*        .     and whether to use 2-by-2 block structure while
*        .     doing it.  A small amount of work could be saved
*        .     by making this choice dependent also upon the
*        .     NH=IHI-ILO+1.
*
         IPARMQ = 0
         IF( NS.GE.KACMIN )
     $      IPARMQ = 1
         IF( NS.GE.K22MIN )
     $      IPARMQ = 2
*
      ELSE
*        ===== invalid value of ispec =====
         IPARMQ = -1
*
      END IF
*
*     ==== End of IPARMQ ====
*
      END
c $Id: iparmq.f 24343 2013-06-22 05:35:15Z d3y133 $

      SUBROUTINE YGEEV( JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR,
     $                  LDVR, WORK, LWORK, INFO )
*
* $Id: ygeev.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      implicit none
#include "y64.fh"
      CHARACTER          JOBVL, JOBVR
      INTEGER            INFO, LDA, LDVL, LDVR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WI( * ), WORK( * ), WR( * )
c
      INTGR4            N4, LDA4, LDVL4, LDVR4, LWORK4, INFO4
c
      N4=N
      LDA4=LDA
      LDVL4=LDVL
      LDVR4=LDVR
      LWORK4=LWORK
c
      CALL DGEEV( JOBVL, JOBVR, N4, A, LDA4, WR, WI, VL, LDVL4, VR,
     $                  LDVR4, WORK, LWORK4, INFO4 )
      INFO=INFO4

      RETURN
      END

      subroutine smd_type_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_type,sp_param,sp_atom
      character*32 tag,pname
      logical result

      pname = "smd_type_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_type_init(sp_type)
c
      return
      end

      subroutine smd_type_init(sp_type)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_type
c
      character*32 pname
      character*80 tag
      integer nt,na
      integer i_ta,i_tr,i_it
      integer i_tta,i_ttr
      logical result
c
      pname = "smd_type_init"
c
c      write(*,*) "in "//pname
c
      tag = "atom:name"
      call smd_get_ind_size(tag,i_ta,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      if(na.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)

      tag = "atom:resname"
      call smd_get_ind(tag,i_tr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

      tag = "param:atomname"
      call smd_get_ind_size(tag,i_tta,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      if(nt.le.0)
     >  call errquit(
     >       pname//'no types ',nt, RTDB_ERR)

      tag = "param:resname"
      call smd_get_ind(tag,i_ttr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)

c
c     create type structure
c     ---------------------
c
      call smd_namespace_create(sp_type)
      tag = "type:id"
      call smd_data_create_get(sp_type,tag,na,MT_INT,i_it)

      call smd_type_set(nt,
     +                  byte_mb(i_tta),
     +                  byte_mb(i_ttr),
     +                  na,
     +                  byte_mb(i_ta),
     +                  byte_mb(i_tr),
     +                  int_mb(i_it))


      return
      end

      subroutine smd_type_set(nt,tta,ttr,na,ta,tr,it)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer na,nt
      character*(smd_string_size) ta(na)
      character*(smd_string_size) tr(na)
      character*(smd_string_size) tta(nt)
      character*(smd_string_size) ttr(nt)
      integer it(na)
c
      integer i,j
      character*(smd_string_size) atag,rtag
      character*30 pname
      logical lr,la,match
 
      pname = "smd_type_set"

      do i=1,na
       match = .false.
       atag = ta(i)
       rtag = tr(i)
       do j=1,nt
        lr=rtag.eq.ttr(j)
        la=atag.eq.tta(j)
c        write(*,*) "check",atag,tta(j),rtag,ttr(j)
c        write(*,*) "check",la,lr
        if(la.and.lr) then
          match = .true.
          it(i)=j
c          write(*,*) "found match"
          goto 110
        end if
       end do
110    continue
       if(.not.match) then
        call util_warning
     >         ("no type defined for "//atag//"in "//rtag,0,0)
       end if
      end do

      return
      end

c $Id: smd_type.F 22502 2012-05-20 06:11:57Z d3y133 $

C $Id: ecp_t1_Q3asy.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_t1_Q3asy (n,m,x,xt,gamma,Q,tol)
*                                                                      *
*   Calculate Q^{m+p}_m function for p = 3 by use of the asymptotic    * 
*   expansion                                                          *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   n (inp) - number of Q functions to be evaluated for given order    *
*   m (inp) - order of Q function                                      *
*   x (inp) - array of values beta/(2*sqrt(alpha))                     *
*   xt (scr) - array to store x^2                                      *
*   gamma (scr) - array of values of 1/sqrt(alpha)                     *
*   Q (out) - Q^m_m functions                                          *
*   tol (inp) - maximum relative error in Q3 functions                 *
*                                                                      *
*   Written by W. A. de Jong                                           *
*                                                                      *
************************************************************************
      implicit none
#include "ecp_consts.fh"
      integer i,k,m,n
      double precision x(n),xt(n),gamma(n),Q(n),tol,fac0,fac1,fac2,fac3
*
      do i = 1,n
        xt(i) = one/(x(i)*x(i))
        Q(i) = one
      end do
*
      fac1 = half*(2*m-1)
      fac2 = -m
      fac3 = m+1
      do k = 0,m-1
        fac0 = fac1*fac2/fac3
        do i = 1,n
          Q(i) = one+Q(i)*fac0*xt(i)
        end do
        fac1 = fac1 - one
        fac2 = fac2 - one
        fac3 = fac3 - one
      end do
      do i = 1,n
        Q(i) = Q(i)*qpirt*(x(i)*gamma(i))**(m+1)*gamma(i)**3
      end do
*
      return
      end

      subroutine argos_diana_listord(sgmnam,last,ndordr)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
c
      integer last,ndordr
      character*16 sgmnam(msa)
      integer i,j
c
      if(me.eq.0) then
      do 5 i=last,nord
      write(cord(i),1000) (sgmnam(iord(i,j,1))(11:16),':',
     + sgmnam(iord(i,j,1))(1:10),j=1,ndordr+1)
 1000 format(4(a6,a1,a10))
    5 continue
      endif
c
      return
      end
 
c $Id: argos_diana_listord.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine cf_lww(lself,lpbc,xwm,idt,iwfr,iwto,jwfr,jwto,
     + nlocw,mpairs,npairs,lwwjpt,lwwin,lwwj,list,rwx,rw)
c $Id: cf_list.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "cf_common.fh"
#include "bitops.fh"
#include "mafdecls.fh"
c
      integer nlocw
      real*8 rwx(mscr,3),rw(mscr)
      real*8 xwm(mwm,3)
      integer lwwj(*),lwwjpt(nlocw,2)
      integer lwwin(nlocw,2)
      integer list(mwm,2),idt(mwm)
      logical lself,lpbc
c
      integer iwm,jwm,iwmfr,iwfr,iwmto,iwto,jwmfr,jwfr,jwmto,jwto
      integer ilist,nlist,mpairs,npairs
c
      iwmfr=iwfr
      if(lself) then
      lwwin(nlocw,1)=0
      lwwin(nlocw,2)=0
      lwwjpt(nlocw,1)=0
      lwwjpt(nlocw,2)=0
      iwmto=iwto-1
      jwmfr=0
      jwmto=iwto
      else
      iwmto=iwto
      jwmfr=jwfr
      jwmto=jwto
      endif
c
      npairs=0
      do 1 iwm=iwmfr,iwmto
      if(lself) jwmfr=iwm+1
c
      do 3 jwm=jwmfr,jwmto
      rwx(jwm,1)=xwm(iwm,1)-xwm(jwm,1)
      rwx(jwm,2)=xwm(iwm,2)-xwm(jwm,2)
      rwx(jwm,3)=xwm(iwm,3)-xwm(jwm,3)
    3 continue
      if(lpbc) call cf_pbc(1,rwx,mscr,rwx,mscr,0,jwmfr,jwmto)
      do 8 jwm=jwmfr,jwmto
      rw(jwm)=rwx(jwm,1)**2+rwx(jwm,2)**2+rwx(jwm,3)**2
    8 continue
      do 4 jwm=jwmfr,jwmto
      list(jwm,1)=0
      list(jwm,2)=0
      if(rw(jwm).lt.rshrt2.and.
     + (iand(idt(iwm),mdynam).eq.ldynam.or.
     + iand(idt(jwm),mdynam).eq.ldynam)) list(jwm,1)=1
      if(rw(jwm).lt.rrest2 .and.
     + (iand(idt(iwm),mrestr).eq.lrestr.or.
     + iand(idt(jwm),mrestr).eq.lrestr)) list(jwm,1)=1
    4 continue
      if(npww.eq.2) then
      do 2 jwm=jwmfr,jwmto
      if(rw(jwm).lt.rlong2.and.
     + (iand(idt(iwm),mdynam).eq.ldynam.or.
     + iand(idt(jwm),mdynam).eq.ldynam)) list(jwm,2)=1
      if(list(jwm,1).eq.1) list(jwm,2)=0
    2 continue
      endif
c
c     short range pairlist
c
      nlist=0
      do 9 jwm=jwmfr,jwmto
      if(list(jwm,1).eq.1) then
      nlist=nlist+1
      list(nlist,1)=jwm
      endif
    9 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 5 ilist=1,nlist
      lwwj(npairs+ilist)=list(ilist,1)
    5 continue
      lwwjpt(iwm-iwmfr+1,1)=npairs+1
      npairs=npairs+nlist
      lsww=lsww+nlist
      lwwin(iwm-iwmfr+1,1)=nlist
c
c     long range pairs
c
      nlist=0
      if(npww.eq.2) then
      do 12 jwm=jwmfr,jwmto
      if(list(jwm,2).eq.1) then
      nlist=nlist+1
      list(nlist,2)=jwm
      endif
   12 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 13 ilist=1,nlist
      lwwj(npairs+ilist)=list(ilist,2)
   13 continue
      lwwjpt(iwm-iwmfr+1,2)=npairs+1
      npairs=npairs+nlist
      llww=llww+nlist
      lwwin(iwm-iwmfr+1,2)=nlist
      endif
    1 continue
c
      return
      end
      subroutine cf_lsw(lpbc,lpbcs,xs,isdt,isgr,isfr,isto,xwm,iwdt,iwz,
     + iwfr,iwto,ndim,mpairs,npairs,lswjpt,lswin,lswj,list,rwx,rw)
c
      implicit none
c
#include "cf_common.fh"
#include "bitops.fh"
c
      real*8 rwx(mscr,3),rw(mscr)
      real*8 xwm(mwm,3),xs(msa,3)
      integer ndim
      integer lswj(*),lswjpt(ndim,2),lswin(ndim,2)
      integer list(mwm,2),iwdt(mwm),isdt(msa),isgr(msa)
      integer iwz(mwm)
c
      integer iwmfr,iwfr,iwmto,iwto,isafr,isfr,isato,isto
      integer mpairs,npairs,isa,iwm,nlist,ilist,isa0,iisa
c
      integer nswi1,nswi2
      logical lpbc,lpbcs
c
c     this subroutine evaluates the solute-solvent pairlist
c
      iwmfr=iwfr
      iwmto=iwto
      isafr=isfr
      isato=isto
c
c      maxlst=2*mavail
c
      npairs=0
c
c     for lstype=0 the pairlist is atom based
c
      if(lstype.eq.0) then
      do 1 isa=isafr,isato
      do 3 iwm=iwmfr,iwmto
      rwx(iwm,1)=xs(isa,1)-xwm(iwm,1)
      rwx(iwm,2)=xs(isa,2)-xwm(iwm,2)
      rwx(iwm,3)=xs(isa,3)-xwm(iwm,3)
    3 continue
      if(lpbc.or.lpbcs) call cf_pbc(1,rwx,mscr,rwx,mscr,0,iwmfr,iwmto)
      do 8 iwm=iwmfr,iwmto
      rw(iwm)=rwx(iwm,1)**2+rwx(iwm,2)**2+rwx(iwm,3)**2
    8 continue
      do 4 iwm=iwmfr,iwmto
      list(iwm,1)=0
      list(iwm,2)=0
      if(rw(iwm).lt.rshrt2.and.
     + (iand(iwdt(iwm),mdynam).eq.ldynam.or.
     + iand(isdt(isa),mdynam).eq.ldynam)) list(iwm,1)=1
      if(rw(iwm).lt.rrest2.and.
     + (iand(iwdt(iwm),mrestr).eq.lrestr.or.
     + iand(isdt(isa),mrestr).eq.lrestr) ) list(iwm,1)=1
    4 continue
      if(npsw.eq.2) then
      do 401 iwm=iwmfr,iwmto
      if(rw(iwm).lt.rlong2.and.
     + (iand(iwdt(iwm),mdynam).eq.ldynam.or.
     + iand(isdt(isa),mdynam).eq.ldynam)) list(iwm,2)=1
      if(list(iwm,1).eq.1) list(iwm,2)=0
  401 continue
      endif
c
c     short range pairlist
c
      nlist=0
      do 402 iwm=iwmfr,iwmto
      if(list(iwm,1).eq.1) then
      nlist=nlist+1
      list(nlist,1)=iwm
      endif
  402 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 5 ilist=1,nlist
      lswj(npairs+ilist)=list(ilist,1)
    5 continue
      lswjpt(isa-isafr+1,1)=npairs+1
      npairs=npairs+nlist
      lssw=lssw+nlist
      lswin(isa-isafr+1,1)=nlist
c
c     long range pairlist
c
      if(npsw.eq.2) then
      nlist=0
      do 8402 iwm=iwmfr,iwmto
      if(list(iwm,2).eq.1) then
      nlist=nlist+1
      list(nlist,2)=iwm
      endif
 8402 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 8005 ilist=1,nlist
      lswj(npairs+ilist)=list(ilist,2)
 8005 continue
      lswjpt(isa-isafr+1,2)=npairs+1
      npairs=npairs+nlist
      llsw=llsw+nlist
      lswin(isa-isafr+1,2)=nlist
      endif
    1 continue
      endif
c
c     for lstype=1 the pairlist is charge group based
c         lstype=1 the pairlist is segment based
c
      if(lstype.eq.1.or.lstype.eq.2) then
      isa=isafr
      isa0=isafr
   21 continue
      nlist=0
      do 15 iwm=iwmfr,iwmto
      list(iwm,1)=0
      list(iwm,2)=0
   15 continue
   10 continue
      do 11 iwm=iwmfr,iwmto
      rwx(iwm,1)=xs(isa,1)-xwm(iwm,1)
      rwx(iwm,2)=xs(isa,2)-xwm(iwm,2)
      rwx(iwm,3)=xs(isa,3)-xwm(iwm,3)
   11 continue
      if(lpbc.or.lpbcs) call cf_pbc(1,rwx,mscr,rwx,mscr,0,iwmfr,iwmto)
      do 13 iwm=iwmfr,iwmto
      rw(iwm)=rwx(iwm,1)**2+rwx(iwm,2)**2+rwx(iwm,3)**2
   13 continue
      do 9012 iwm=iwmfr,iwmto
      if(iand(iwdt(iwm),mdynam).eq.ldynam.and.
     + rw(iwm).lt.rshrt2) list(iwm,1)=1
      if(iand(iwdt(iwm),mrestr).eq.lrestr.and.
     + rw(iwm).lt.rrest2) list(iwm,1)=1
 9012 continue
      if(iand(isdt(isa),mdynam).eq.ldynam) then
      do 9013 iwm=iwmfr,iwmto
      if(rw(iwm).lt.rshrt2) list(iwm,1)=1
 9013 continue
      endif
      if(iand(isdt(isa),mrestr).eq.lrestr) then
      do 9014 iwm=iwmfr,iwmto
      if(rw(iwm).lt.rrest2) list(iwm,1)=1
 9014 continue
      endif
      if(iqmmm.ne.0) then
      if(iand(isdt(isa),lquant).eq.lquant) then
      do 9015 iwm=iwmfr,iwmto
      if(rw(iwm).lt.rqmmm2) iwz(iwm)=1
 9015 continue
      endif
      endif
      if(npsw.eq.2) then
      do 9812 iwm=iwmfr,iwmto
      if(iand(iwdt(iwm),mdynam).eq.ldynam.and.
     + rw(iwm).lt.rlong2) list(iwm,2)=1
 9812 continue
      if(iand(isdt(isa),mdynam).eq.ldynam) then
      do 9813 iwm=iwmfr,iwmto
      if(rw(iwm).lt.rlong2) list(iwm,2)=1
 9813 continue
      endif
      endif
      do 9815 iwm=iwmfr,iwmto
      if(list(iwm,1).eq.1) list(iwm,2)=0
 9815 continue
      if(isa.eq.isato) goto 16
      if(lstype.eq.1) then
      if(isgr(isa+1).eq.isgr(isa)) then
      isa=isa+1
      goto 10
      endif
      endif
c      if(lstype.eq.2) then
c      if(isl(isa+1,lssgm).eq.isl(isa,lssgm)) then
c      isa=isa+1
c      goto 10
c      endif
c      endif
   16 continue
c
c     at this point the partial list for a solute charge group or
c     segment with all solvent has been evaluated
c
c     short range pairlist
c
      nlist=0
      do 17 iwm=iwmfr,iwmto
      if(list(iwm,1).eq.1) then
      nlist=nlist+1
      list(nlist,1)=iwm
      endif
   17 continue
      do 18 iisa=isa0,isa
      lswjpt(iisa-isafr+1,1)=npairs+1
      lswin(iisa-isafr+1,1)=nlist
   18 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 19 ilist=1,nlist
      lswj(npairs+ilist)=list(ilist,1)
   19 continue
      npairs=npairs+nlist
      lssw=lssw+nlist
c
c     long range pairlist
c
      if(npsw.eq.2) then
      nlist=0
      do 8017 iwm=iwmfr,iwmto
      if(list(iwm,2).eq.1) then
      nlist=nlist+1
      list(nlist,2)=iwm
      endif
 8017 continue
      do 8018 iisa=isa0,isa
      lswjpt(iisa-isafr+1,2)=npairs+1
      lswin(iisa-isafr+1,2)=nlist
 8018 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 8019 ilist=1,nlist
      lswj(npairs+ilist)=list(ilist,2)
 8019 continue
      npairs=npairs+nlist
      llsw=llsw+nlist
      endif
c
      isa=isa+1
      isa0=isa
      if(isa.le.isato) goto 21
      endif
      nswi1=0
      nswi2=0
      do 9191 isa=isafr,isato
      nswi1=nswi1+lswin(isa-isafr+1,1)
      if(npsw.eq.2) nswi2=nswi2+lswin(isa-isafr+1,2)
 9191 continue
c
      return
      end
      subroutine cf_lss(lself,lpbc,lpbcs,xs,iga,idt,igr,isgm,iss,ish,
     + isz,
     + isfr,isto,jsfr,jsto,nlocs,mpairs,npairs,lssjpt,lssin,lssj,list,
     + rwx,rw,ndxt,nt,ndxx,nx,lda,rda,lseq,lsthop,mprot)
c
      implicit none
c
#include "cf_common.fh"
#include "bitops.fh"
#include "util.fh"
#include "mafdecls.fh"
c
      real*8 rwx(mscr,3),rw(mscr)
      real*8 xs(msa,3)
      integer nlocs,nt,nx
      integer ndxt(0:nt,2),ndxx(0:nx,2)
c
      integer lssj(*),lssjpt(nlocs,2),lssin(nlocs,2)
      integer list(msa,3),iga(msa),igr(msa),idt(msa),iss(msa),isz(msa)
      integer ish(msa),isgm(msa)
      integer lseq(mseq),lsthop(2,*),mprot(mseq)
      logical lself,lpbc,lpbcs,lsame
c
      integer isafr,isfr,isato,isto,jsafr,jsfr,jsato,jsto
      integer mpairs,npairs,isa,jsa,nlist1,nlist2,idoff,iaoff
      integer ifrsx,itosx,ifrst,itost,jfrsx,jtosx,jfrst,jtost
      integer iskip1,iskip2,istsum,ist,jst,isxsum,isx,jsx,ilist
      integer nlist0,isa0,iisa,isglob,ipss,jsglob,nlist,leq,nssl0
      integer lda(16,*)
      real*8 rda(11,*)
c
      real*8 xacc(11)
      integer idon,iacc,i,idown,idfr,idto,iaown,iafr,iato
c
c
c     this subroutine evaluates the solute-solute pairlist
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
      if(lself) isato=isato-1
c
c      write(*,'(i5,a,i5)') me,' cf_lss nseq=',nseq
c      write(*,'(20i5)') (lseq(i),i=1,nseq)
c
      npairs=0
c
c     for lstype=0 the pairlist is atom based
c     ---------------------------------------
c
      if(lstype.eq.0) then
      do 1 isa=isafr,isato
      if(lself) then
      jsafr=isa+1
      jsato=isato+1
      endif
      do 2 jsa=jsafr,jsato
      rwx(jsa,1)=xs(isa,1)-xs(jsa,1)
      rwx(jsa,2)=xs(isa,2)-xs(jsa,2)
      rwx(jsa,3)=xs(isa,3)-xs(jsa,3)
    2 continue
      if(lpbc.or.lpbcs) call cf_pbc(1,rwx,mscr,rwx,mscr,0,jsafr,jsato)
      do 3 jsa=jsafr,jsato
      rw(jsa)=rwx(jsa,1)**2+rwx(jsa,2)**2+rwx(jsa,3)**2
    3 continue
      nlist1=0
      nlist2=0
      isglob=iga(isa)
      ifrsx=ndxx(isglob-1,1)+1
      itosx=ndxx(isglob,1)
      ifrst=ndxt(isglob-1,1)+1
      itost=ndxt(isglob,1)
      do 4 jsa=jsafr,jsato
      iskip1=1
      iskip2=1
      if(rw(jsa).lt.rshrt2.and.
     + (iand(idt(isa),mdynam).eq.ldynam.or.includ.eq.1.or.
     + iand(idt(jsa),mdynam).eq.ldynam)) iskip1=0
      if(rw(jsa).lt.rlong2.and.
     + (iand(idt(isa),mdynam).eq.ldynam.or.includ.eq.1.or.
     + iand(idt(jsa),mdynam).eq.ldynam)) iskip2=0
      if(rw(jsa).lt.rrest2.and.
     + (iand(idt(isa),mrestr).eq.lrestr.or.
     + iand(idt(jsa),mrestr).eq.lrestr) ) iskip1=0
      istsum=0
      isxsum=0
      if(iskip1.eq.0.or.iskip2.eq.0) then
      jsglob=iga(jsa)
      jfrsx=ndxx(jsglob-1,1)+1
      jtosx=ndxx(jsglob,1)
      jfrst=ndxt(jsglob-1,1)+1
      jtost=ndxt(jsglob,1)
      istsum=1
      do 5 ist=ifrst,itost
      if(jsglob.eq.ndxt(ist,2)) goto 7
    5 continue
      do 6 jst=jfrst,jtost
      if(isglob.eq.ndxt(jst,2)) goto 7
    6 continue
      istsum=0
    7 continue
      isxsum=0
      if(istsum.eq.0) then
      isxsum=1
      do 8 isx=ifrsx,itosx
      if(jsglob.eq.ndxx(isx,2)) goto 10
    8 continue
      do 9 jsx=jfrsx,jtosx
      if(isglob.eq.ndxx(jsx,2)) goto 10
    9 continue
      isxsum=0
   10 continue
      endif
      endif
      if(istsum.eq.0.and.isxsum.eq.0) then
      if(iskip1.eq.0) then
      nlist1=nlist1+1
      list(nlist1,1)=jsa
      else
      if(iskip2.eq.0) then
      nlist2=nlist2+1
      list(nlist2,2)=jsa
      endif
      endif
      endif
    4 continue
      if(npairs+nlist1+nlist2.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 11 ilist=1,nlist1
      lssj(npairs+ilist)=list(ilist,1)
   11 continue
      lssjpt(isa-isafr+1,1)=npairs+1
      npairs=npairs+nlist1
      lsss=lsss+nlist1
      lssin(isa-isafr+1,1)=nlist1
      if(npss.eq.2) then
      do 12 ilist=1,nlist2
      lssj(npairs+ilist)=list(ilist,2)
   12 continue
      lssjpt(isa-isafr+1,2)=npairs+1
      npairs=npairs+nlist2
      llss=llss+nlist2
      lssin(isa-isafr+1,2)=nlist2
      endif
    1 continue
      endif
c
c     for lstype=1 the pairlist is charge group based
c         lstype=2 the pairlist is segment based
c
      if(lstype.eq.1.or.lstype.eq.2) then
      isa=isafr
      isa0=isafr
   13 continue
      if(lself) then
      jsafr=isa+1
      jsato=isato+1
      endif
      do 14 jsa=jsafr,jsato
      list(jsa,1)=0
      list(jsa,2)=0
   14 continue
   15 continue
      do 16 jsa=jsafr,jsato
      rwx(jsa,1)=xs(isa,1)-xs(jsa,1)
      rwx(jsa,2)=xs(isa,2)-xs(jsa,2)
      rwx(jsa,3)=xs(isa,3)-xs(jsa,3)
   16 continue
      if(lpbc.or.lpbcs) call cf_pbc(1,rwx,mscr,rwx,mscr,0,jsafr,jsato)
      do 17 jsa=jsafr,jsato
      rw(jsa)=rwx(jsa,1)**2+rwx(jsa,2)**2+rwx(jsa,3)**2
   17 continue
      if(iand(idt(isa),mdynam).eq.ldynam.or.includ.eq.1) then
      do 18 jsa=jsafr,jsato
      if(rw(jsa).lt.rshrt2) list(jsa,1)=1
   18 continue
      endif
      if(iand(idt(isa),mrestr).eq.lrestr) then
      do 20 jsa=jsafr,jsato
      if(iand(idt(jsa),mdynam).eq.ldynam.and.rw(jsa).lt.rshrt2)
     + list(jsa,1)=1
      if(iand(idt(jsa),mdynam).ne.ldynam.and.rw(jsa).lt.rrest2)
     + list(jsa,1)=1
   20 continue
      endif
      if(iand(idt(isa),mfixed).eq.lfixed) then
      do 22 jsa=jsafr,jsato
      if(iand(idt(jsa),mdynam).eq.ldynam.and.rw(jsa).lt.rshrt2)
     + list(jsa,1)=1
      if(iand(idt(jsa),mrestr).eq.lrestr.and.rw(jsa).lt.rrest2)
     + list(jsa,1)=1
   22 continue
      endif
      if(iqmmm.ne.0) then
      if(iand(idt(isa),lquant).eq.0) then
      do 24 jsa=jsafr,jsato
      if(iand(idt(jsa),lquant).ne.0.and.rw(jsa).lt.rqmmm2)
     + isz(isa)=1
   24 continue
      else
      do 25 jsa=jsafr,jsato
      if(iand(idt(jsa),lquant).eq.0.and.rw(jsa).lt.rqmmm2)
     + isz(jsa)=1
   25 continue
      endif
      endif
cx      if(nhop.gt.0) then
c      if(ish(isa).gt.0.and.iand(ish(isa),1).ne.0) then
c      do 326 jsa=jsafr,jsato
c      list(jsa,1)=0
c  326 continue
c      endif
c      do 327 jsa=jsafr,jsato
c      if(ish(jsa).gt.0.and.iand(ish(jsa),1).ne.0)
c     + list(jsa,1)=0
c  327 continue
cx      endif
c
c     donor acceptor pair list
c
      if(nhop.gt.0) then
      idon=0
      iacc=0
      idown=0
      iaown=0
      if(ish(isa).gt.0) then
      if(iand(ish(isa),1).eq.0) then
      idon=isa
      idown=me
      else
      iacc=isa
      iaown=me
      endif
      endif
      if(idon.gt.0.or.iacc.gt.0) then
      do 225 jsa=jsafr,jsato
      if(isgm(isa).ne.isgm(jsa)) then
      if(idon.eq.isa) iacc=0
      if(iacc.eq.isa) idon=0
      if(ish(jsa).gt.0) then
      if(iacc.gt.0.and.iand(ish(jsa),1).eq.0) then
      idon=jsa
      if(lself) idown=me
      elseif(idon.gt.0.and.iand(ish(jsa),1).eq.1) then
      iacc=jsa
      if(lself) iaown=me
      endif
      endif
      if(idon.gt.0.and.iacc.gt.0.and.rw(jsa).lt.rhop2) then
c
      if(lseq(isgm(idon))+ish(idon)/2.le.mprot(idon)
     + .or.lseq(isgm(iacc))-ish(iacc)/2.ge.1) then
c
      do 226 i=1,nhops
      if(lsthop(1,i).eq.isgm(iacc).and.lsthop(2,i).eq.isgm(idon)) then
      goto 227
      endif
  226 continue
c
c
c
      call qhop_asite(msa,xs,idon,iga(idon),isgm(idon),lseq(isgm(idon)),
     + iacc,iga(iacc),isgm(iacc),lseq(isgm(iacc)),xacc,idoff,iaoff,
     + lsame)
c
c     do not allow hops to the same protonation state if the type of
c     residue/molecule is identical (e.q. water dissociating into OH and H3O)
c
      if(.not.lsame.or.lseq(isgm(idon)).ne.lseq(isgm(iacc))) then
c
      nlda=nlda+1
c      write(*,2222) me,nlda,idon,iga(idon),isgm(idon),lseq(isgm(idon)),
c     + ish(idon),iacc,iga(iacc),isgm(iacc),lseq(isgm(iacc)),ish(iacc),
c     + sqrt(rw(jsa))
c 2222 format(12i5,f12.6)
      if(nlda.gt.3*nhop) call md_abort('Increase nhop',nhop)
      lda(1,nlda)=iga(idon)
      lda(2,nlda)=idon
      lda(3,nlda)=isgm(idon)
      lda(4,nlda)=lseq(isgm(idon))+ish(idon)/2
      lda(5,nlda)=idoff
      lda(6,nlda)=iga(iacc)
      lda(7,nlda)=iacc
      lda(8,nlda)=isgm(iacc)
      lda(9,nlda)=lseq(isgm(iacc))-ish(iacc)/2
      lda(10,nlda)=iaoff
      lda(11,nlda)=idown
      lda(12,nlda)=0
      lda(13,nlda)=0
      lda(14,nlda)=iaown
      lda(15,nlda)=0
      lda(16,nlda)=0
      rda(1,nlda)=xacc(1)
      rda(2,nlda)=xacc(2)
      rda(3,nlda)=xacc(3)
      rda(4,nlda)=xacc(4)
      rda(5,nlda)=xacc(5)
      rda(6,nlda)=xacc(6)
      rda(7,nlda)=xacc(7)
      rda(8,nlda)=xacc(8)
      rda(9,nlda)=xacc(9)
      rda(10,nlda)=xacc(10)
      rda(11,nlda)=xacc(11)
c
      endif
c
  227 continue
c
      endif
      endif
      endif
c
  225 continue
      endif
      endif
c
      if(npss.eq.2) then
      if(iand(idt(isa),mdynam).eq.ldynam.or.includ.eq.1) then
      do 26 jsa=jsafr,jsato
      if(rw(jsa).lt.rlong2) list(jsa,2)=1
   26 continue
      endif
      if(iand(idt(isa),mrestr).eq.lrestr) then
      do 28 jsa=jsafr,jsato
      if(iand(idt(jsa),mdynam).eq.ldynam.and.rw(jsa).lt.rlong2)
     + list(jsa,2)=1
   28 continue
      endif
      if(iand(idt(isa),mfixed).eq.lfixed) then
      do 30 jsa=jsafr,jsato
      if(iand(idt(jsa),mdynam).eq.ldynam.and.rw(jsa).lt.rlong2)
     + list(jsa,2)=1
   30 continue
cx      endif
c      if(nhop.gt.0) then
c      if(ish(isa).gt.0.and.iand(ish(isa),1).ne.0) then
c      do 426 jsa=jsafr,jsato
c      list(jsa,1)=0
c  426 continue
c      endif
c      do 427 jsa=jsafr,jsato
c      if(ish(jsa).gt.0.and.iand(ish(jsa),1).ne.0)
c     + list(jsa,1)=0
cx  427 continue
      endif
      endif
      if(isa.lt.isato) then
      if(lstype.eq.1.and.igr(isa+1).eq.igr(isa)) then
      isa=isa+1
      goto 15
      endif
c      if(lstype.eq.2.and.isl(isa+1,lssgm).eq.isl(isa,lssgm)) then
c      isa=isa+1
c      goto 15
c      endif
      endif
c
      do 32 jsa=isa0,isa
      if(iand(idt(jsa),mrestr).ne.lrestr) goto 33
   32 continue
      goto 34
   33 continue
c
c     solute atoms in the same charge group (lstype=1) or
c     segment (lstype=2) always all interact in short range list
c     this can only happen when lself is true
c
      if(lself) then
      do 35 jsa=isa0+1,isa
      if(iand(idt(isa),mdynam).eq.ldynam.or.includ.eq.1.or.
     + iand(idt(jsa),mdynam).eq.ldynam) list(jsa,1)=1
   35 continue
      endif
   34 continue
c
      if(lstype.eq.1) then
c
c     following two loops make sure that all atoms in a charge group
c     are counted if at least one atom is within short range cutoff
c
      do 36 jsa=jsafr+1,jsato
      if(igr(jsa).eq.igr(jsa-1).and.list(jsa-1,1).eq.1)
     + list(jsa,1)=1
   36 continue
      do 37 jsa=jsato-1,jsafr,-1
      if(igr(jsa).eq.igr(jsa+1).and.list(jsa+1,1).eq.1)
     + list(jsa,1)=1
   37 continue
c
      if(iqmmm.ne.0) then
      do 38 jsa=isafr+1,isato
      if(igr(jsa).eq.igr(jsa-1)) then
      if(iand(idt(jsa),lquant).ne.lquant.and.isz(jsa-1).ne.0)
     + isz(jsa)=1
      if(isz(jsa).ne.0.and.iand(idt(jsa-1),lquant).ne.lquant)
     + isz(jsa-1)=1
      endif
   38 continue
      do 39 jsa=isato-1,isafr,-1
      if(igr(jsa).eq.igr(jsa+1)) then
      if(iand(idt(jsa),lquant).ne.lquant.and.isz(jsa+1).ne.0)
     + isz(jsa)=1
      if(isz(jsa).ne.0.and.iand(idt(jsa+1),lquant).ne.lquant)
     + isz(jsa+1)=1
      endif
   39 continue
      do 40 jsa=jsafr+1,jsato
      if(igr(jsa).eq.igr(jsa-1)) then
      if(iand(idt(jsa),lquant).ne.lquant.and.isz(jsa-1).ne.0)
     + isz(jsa)=1
      if(isz(jsa).ne.0.and.iand(idt(jsa-1),lquant).ne.lquant)
     + isz(jsa-1)=1
      endif
   40 continue
      do 41 jsa=jsato-1,jsafr,-1
      if(igr(jsa).eq.igr(jsa+1)) then
      if(iand(idt(jsa),lquant).ne.lquant.and.isz(jsa+1).ne.0)
     + isz(jsa)=1
      if(isz(jsa).ne.0.and.iand(idt(jsa+1),lquant).ne.lquant)
     + isz(jsa+1)=1
      endif
   41 continue
      endif
c
      if(npss.eq.2) then
c
c     remove all short range interaction from long range list
c
      do 42 jsa=jsafr,jsato
      if(list(jsa,1).eq.1) list(jsa,2)=0
   42 continue
c
c     following two loops make sure that all atoms in a charge group
c     are counted if at least one atom is within long range cutoff
c
      do 43 jsa=jsafr+1,jsato
      if(igr(jsa).eq.igr(jsa-1).and.list(jsa-1,2).eq.1)
     + list(jsa,2)=1
   43 continue
      do 44 jsa=jsato-1,jsafr,-1
      if(igr(jsa).eq.igr(jsa+1).and.list(jsa+1,2).eq.1)
     + list(jsa,2)=1
   44 continue
c
      endif
      endif
c      if(lstype.eq.2) then
cc
cc     following two loops make sure that all atoms in a segment
cc     are counted if at least one atom is within short range cutoff
cc
c      do 43 jsa=jsafr+1,jsato
c      if(isl(jsa,lssgm).eq.isl(jsa-1,lssgm).and.list(jsa-1,1).eq.1)
c     + list(jsa,1)=1
c   43 continue
c      do 44 jsa=jsato-1,jsafr,-1
c      if(isl(jsa,lssgm).eq.isl(jsa+1,lssgm).and.list(jsa+1,1).eq.1)
c     + list(jsa,1)=1
c   44 continue
cc
c      if(npss.eq.2) then
cc
cc     following two loops make sure that all atoms in a charge group
cc     are counted if at least one atom is within long range cutoff
cc
c      do 45 jsa=jsafr+1,jsato
c      if(isl(jsa,lssgm).eq.isl(jsa-1,lssgm).and.list(jsa-1,2).eq.1)
c     + list(jsa,2)=1
c   45 continue
c      do 46 jsa=jsato-1,jsafr,-1
c      if(isl(jsa,lssgm).eq.isl(jsa+1,lssgm).and.list(jsa+1,2).eq.1)
c     + list(jsa,2)=1
c   46 continue
cc
c      endif
c      endif
      nlist0=0
      do 47 iisa=isa0,isa
c
c     remove third neighbor pairs and excluded pairs from the lists
c
      isglob=iga(iisa)
c
      do 48 ipss=1,npss
c
      do 49 jsa=jsafr,jsato
      list(jsa,3)=list(jsa,ipss)
   49 continue
c
      do 50 jsa=jsafr,jsato
      if(iga(iisa).eq.iga(jsa)) list(jsa,3)=0
      if(lself.and.jsa.lt.iisa) list(jsa,3)=0
   50 continue
      ifrst=ndxt(isglob-1,1)+1
      itost=ndxt(isglob,1)
      do 51 ist=ifrst,itost
      jsglob=ndxt(ist,2)
      do 52 jsa=jsafr,jsato
      if(iga(jsa).eq.jsglob) list(jsa,3)=0
   52 continue
   51 continue
      do 53 jsa=jsafr,jsato
      if(list(jsa,3).eq.1) then
      jsglob=iga(jsa)
      jfrst=ndxt(jsglob-1,1)+1
      jtost=ndxt(jsglob,1)
      do 54 jst=jfrst,jtost
      if(isglob.eq.ndxt(jst,2)) list(jsa,3)=0
   54 continue
      endif
   53 continue
      ifrsx=ndxx(isglob-1,1)+1
      itosx=ndxx(isglob,1)
      do 55 isx=ifrsx,itosx
      jsglob=ndxx(isx,2)
      do 56 jsa=jsafr,jsato
      if(iga(jsa).eq.jsglob) list(jsa,3)=0
   56 continue
   55 continue
      do 57 jsa=jsafr,jsato
      if(list(jsa,3).eq.1) then
      jsglob=iga(jsa)
      jfrsx=ndxx(jsglob-1,1)+1
      jtosx=ndxx(jsglob,1)
      do 58 jsx=jfrsx,jtosx
      if(isglob.eq.ndxx(jsx,2)) list(jsa,3)=0
   58 continue
      endif
   57 continue
c
c     remove interactions between dummy atoms
c
c     bits set in iss : 0 set 1 s-w is dummy               (1)
c                       1 set 2 s-w is dummy               (2)
c                       2 set 3 s-w is dummy               (4)
c                       3 set 1 s-s non-self is dummy      (8)
c                       4 set 2 s-s non-self is dummy     (16)
c                       5 set 3 s-s non-self is dummy     (32)
c                       6 set 1 s-s self is dummy         (64)
c                       7 set 2 s-s self is dummy        (128)
c                       8 set 3 s-s self is dummy        (256)
c
cz      if(.not.ithint) then
cz      do 150 jsa=jsafr,jsato
cz      if(iand(iss(iisa),72).eq.72) list(jsa,3)=0
cz      if(iand(iss(jsa),72).eq.72) list(jsa,3)=0
cz  150 continue
cz      else
cz      do 151 jsa=jsafr,jsato
cz      if(iand(iss(iisa),144).eq.144.and.iand(iss(iisa),288).eq.288)
cz     + list(jsa,3)=0
cz      if(iand(iss(jsa),144).eq.144.and.iand(iss(jsa),288).eq.288)
cz     + list(jsa,3)=0
cz      if(iand(iss(iisa),144).eq.144.and.iand(iss(jsa),288).eq.288)
cz     + list(jsa,3)=0
cz      if(iand(iss(jsa),144).eq.144.and.iand(iss(iisa),288).eq.288)
cz     + list(jsa,3)=0
cz  151 continue
cz      endif
c
c     make the actual pairlist
c
      nlist=0
      do 59 jsa=jsafr,jsato
      if(list(jsa,3).ne.0) then
c      write(*,'(a,8i5,2(1x,9l1))') 'LSS ',iisa,jsa,iga(iisa),iga(jsa),
c     + idt(iisa),idt(jsa),iss(iisa),iss(jsa),
c     + iand(iss(iisa),1).ne.0,iand(iss(iisa),2).ne.0,
c     + iand(iss(iisa),4).ne.0,iand(iss(iisa),8).ne.0,
c     + iand(iss(iisa),16).ne.0,iand(iss(iisa),32).ne.0,
c     + iand(iss(iisa),64).ne.0,iand(iss(iisa),128).ne.0,
c     + iand(iss(iisa),256).ne.0,
c     + iand(iss(jsa),1).ne.0,iand(iss(jsa),2).ne.0,
c     + iand(iss(jsa),4).ne.0,iand(iss(jsa),8).ne.0,
c     + iand(iss(jsa),16).ne.0,iand(iss(jsa),32).ne.0,
c     + iand(iss(jsa),64).ne.0,iand(iss(jsa),128).ne.0,
c     + iand(iss(jsa),256).ne.0
      nlist=nlist+1
      list(nlist,3)=jsa
      endif
   59 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      leq=0
c
c     check if this pairlist section was generated before
c
      if(ipss.eq.2.and.nlist.eq.nlist0) then
      nssl0=lssjpt(iisa-1,ipss)-1
      do 60 ilist=1,nlist
      if(lssj(nssl0+ilist).ne.list(ilist,3)) leq=1
   60 continue
      endif
c
      if(leq.eq.0) then
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 61 ilist=1,nlist
      lssj(npairs+ilist)=list(ilist,3)
   61 continue
      lssjpt(iisa-isfr+1,ipss)=npairs+1
      npairs=npairs+nlist
      if(ipss.eq.1) then
      lsss=lsss+nlist
      else
      llss=llss+nlist
      endif
      else
      lssjpt(iisa-isfr+1,ipss)=lssjpt(iisa-isfr,ipss)
      endif
c
      lssin(iisa-isfr+1,ipss)=nlist
   48 continue
   47 continue
      isa=isa+1
      isa0=isa
      if(isa.le.isato) goto 13
      endif
c
      if(lself) then
      lssin(isto-isfr+1,1)=0
      lssin(isto-isfr+1,2)=0
      endif
c
      return
      end
      subroutine cf_lsb(lself,iga,idt,istemp,isfr,isto,jsfr,jsto,
     + idb,nsb,nbonds,mbonds,nconst,lbonds,itemp)
c
      implicit none
c
#include "cf_common.fh"
c
      integer iga(msa),idt(msa)
      integer nsb,mbonds
      integer idb(nsb,4)
      integer lbonds(*)
      integer itemp(nsatot),istemp(msa)
      integer isa,jsa,isfr,isto,jsfr,jsto,isafr,isato,jsafr,jsato
      integer isb,nbi,nbj,nbonds,nconst,ibloc,jbloc,isbloc,iq,jq
      logical lself
c
#include "bitops.fh"
c
      if(numb(2).eq.0) return
c
c     This subroutine evaluates the solute bonds list
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
c
      nbonds=0
      nconst=0
c
      do 1 isa=1,nsatot
      itemp(isa)=0
    1 continue
      do 2 jsa=jsafr,jsato
      itemp(iga(jsa))=3
c      if(iand(idt(jsa),mdynam).ne.ldynam) itemp(iga(jsa))=-3
    2 continue
      do 3 isa=isafr,isato
      itemp(iga(isa))=1
c      if(iand(idt(isa),mdynam).ne.ldynam) itemp(iga(isa))=-1
    3 continue
c
      do 4 isb=1,numb(2)
      if(idb(isb,3).ge.0) then
      nbi=itemp(idb(isb,1))
c      lbi=nbi.ge.0
c      nbi=iabs(nbi)
      if(nbi.gt.0) then
      nbj=itemp(idb(isb,2))
c      lbj=nbj.ge.0
      nbi=nbi+iabs(nbj)
      if(nbi.gt.1) then
      if((lself.and.nbi.eq.2).or.(.not.lself.and.nbi.eq.4)) then
c      if(lbi.or.lbj) then
      nbonds=nbonds+1
      if(idb(isb,3).eq.1) nconst=nconst+1
      if(nbonds.gt.mbonds)
     + call md_abort('Insufficient memory for bond list',0)
      lbonds(nbonds)=isb
c      endif
      endif
      endif
      endif
      endif
    4 continue
c
      if(iqmmm.ne.0) then
      do 5 isa=1,nsatot
      itemp(isa)=0
    5 continue
      do 6 jsa=jsafr,jsato
      itemp(iga(jsa))=jsa
    6 continue
      do 7 isa=isafr,isato
      itemp(iga(isa))=isa
    7 continue
      do 8 isbloc=1,nbonds
      isb=lbonds(isbloc)
      ibloc=itemp(idb(isb,1))
      jbloc=itemp(idb(isb,2))
      iq=iand(idt(ibloc),lquant)
      jq=iand(idt(jbloc),lquant)
      if(iq.ne.lquant.and.jq.eq.lquant) istemp(ibloc)=1
      if(iq.eq.lquant.and.jq.ne.lquant) istemp(jbloc)=1
    8 continue
      endif
c
      return
      end
      subroutine cf_lsh(lself,iga,idt,istemp,isfr,isto,jsfr,jsto,
     + idh,nsh,nangls,mangls,nconst,langls,itemp)
c
      implicit none
c
#include "cf_common.fh"
c
      integer nsh,mangls
      integer idh(nsh,5)
      integer iga(msa),idt(msa)
      integer langls(1)
      integer itemp(nsatot),istemp(msa)
      integer isa,jsa,isfr,isto,jsfr,jsto,isafr,isato,jsafr,jsato
      integer ish,nhi,nangls,nconst
      integer ishloc,ihloc,jhloc,khloc,iq,jq,kq
      logical lself
c
#include "bitops.fh"
c
      if(numh(2).eq.0) return
c
c     This subroutine evaluates the solute angles list
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
c
      nangls=0
      nconst=0
c
      do 1 isa=1,nsatot
      itemp(isa)=0
    1 continue
      do 2 jsa=jsafr,jsato
      itemp(iga(jsa))=4
    2 continue
      do 3 isa=isafr,isato
      itemp(iga(isa))=1
    3 continue
c
      do 4 ish=1,numh(2)
c
c     skip angles with negative ishs
c
      if(idh(ish,4).ge.0) then
c
      nhi=itemp(idh(ish,1))
      if(nhi.gt.0) then
      nhi=nhi+itemp(idh(ish,2))
      if(nhi.gt.1) then
      nhi=nhi+itemp(idh(ish,3))
      if(nhi.gt.2) then
      if((lself.and.nhi.eq.3).or.
     + (.not.lself.and.(nhi.eq.6.or.nhi.eq.9))) then
      nangls=nangls+1
      if(idh(ish,4).eq.1) nconst=nconst+1
      if(nangls.gt.mangls)
     + call md_abort('Insufficient memory for angle list',0)
      langls(nangls)=ish
      endif
      endif
      endif
      endif
      endif
    4 continue
c
      if(iqmmm.ne.0) then
      do 5 isa=1,nsatot
      itemp(isa)=0
    5 continue
      do 6 jsa=jsafr,jsato
      itemp(iga(jsa))=jsa
    6 continue
      do 7 isa=isafr,isato
      itemp(iga(isa))=isa
    7 continue
      do 8 ishloc=1,nangls
      ish=langls(ishloc)
      ihloc=itemp(idh(ish,1))
      jhloc=itemp(idh(ish,2))
      khloc=itemp(idh(ish,3))
      iq=iand(idt(ihloc),lquant)
      jq=iand(idt(jhloc),lquant)
      kq=iand(idt(khloc),lquant)
      if(iq.eq.lquant.or.jq.eq.lquant.or.kq.eq.lquant) then
      if(iq.ne.lquant) istemp(ihloc)=1
      if(jq.ne.lquant) istemp(jhloc)=1
      if(kq.ne.lquant) istemp(khloc)=1
      endif
    8 continue
      endif
c
      return
      end
      subroutine cf_lsd(lself,iga,idt,istemp,isfr,isto,jsfr,jsto,
     + idd,nsd,ndihes,mdihes,nconst,ldihes,itemp)
c
      implicit none
c
#include "cf_common.fh"
c
      integer nsd,mdihes
      integer idd(nsd,6)
      integer iga(msa),idt(msa)
      integer ldihes(1)
      integer itemp(nsatot),istemp(msa)
      integer isa,jsa,isfr,isto,jsfr,jsto,isafr,isato,jsafr,jsato
      integer isd,ndi,ndihes,nconst
      integer isdloc,idloc,jdloc,kdloc,ldloc,iq,jq,kq,lq
      logical lself
c
#include "bitops.fh"
c
      if(numd(2).eq.0) return
c
c     This subroutine evaluates the solute dihedrals list
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
c
      ndihes=0
      nconst=0
c
      do 1 isa=1,nsatot
      itemp(isa)=0
    1 continue
      do 2 jsa=jsafr,jsato
      itemp(iga(jsa))=5
    2 continue
      do 3 isa=isafr,isato
      itemp(iga(isa))=1
    3 continue
c
      do 4 isd=1,numd(2)
c
c     skip dihedrals with negative isds
c
      if(idd(isd,5).ge.0) then
c
      ndi=itemp(idd(isd,1))
      if(ndi.gt.0) then
      ndi=ndi+itemp(idd(isd,2))
      if(ndi.gt.1) then
      ndi=ndi+itemp(idd(isd,3))
      if(ndi.gt.2) then
      ndi=ndi+itemp(idd(isd,4))
      if(ndi.gt.3) then
      if((lself.and.ndi.eq.4).or.
     + (.not.lself.and.(ndi.eq.8.or.ndi.eq.12.or.ndi.eq.16))) then
      ndihes=ndihes+1
      if(idd(isd,5).eq.1) nconst=nconst+1
      if(ndihes.gt.mdihes)
     + call md_abort('Insufficient memory for torsion list',0)
      ldihes(ndihes)=isd
      endif
      endif
      endif
      endif
      endif
      endif
    4 continue
c
      if(iqmmm.ne.0) then
      do 5 isa=1,nsatot
      itemp(isa)=0
    5 continue
      do 6 jsa=jsafr,jsato
      itemp(iga(jsa))=jsa
    6 continue
      do 7 isa=isafr,isato
      itemp(iga(isa))=isa
    7 continue
      do 8 isdloc=1,ndihes
      isd=ldihes(isdloc)
      idloc=itemp(idd(isd,1))
      jdloc=itemp(idd(isd,2))
      kdloc=itemp(idd(isd,3))
      ldloc=itemp(idd(isd,4))
      iq=iand(idt(idloc),lquant)
      jq=iand(idt(jdloc),lquant)
      kq=iand(idt(kdloc),lquant)
      lq=iand(idt(ldloc),lquant)
      if(iq.eq.lquant.or.jq.eq.lquant.or.
     + kq.eq.lquant.or.lq.eq.lquant) then
      if(iq.ne.lquant) istemp(idloc)=1
      if(jq.ne.lquant) istemp(jdloc)=1
      if(kq.ne.lquant) istemp(kdloc)=1
      if(lq.ne.lquant) istemp(ldloc)=1
      endif
    8 continue
      endif
c
      return
      end
      subroutine cf_lso(lself,iga,idt,istemp,isfr,isto,jsfr,jsto,
     + ido,nso,nimprs,mimprs,nconst,limprs,itemp)
c
      implicit none
c
#include "cf_common.fh"
c
      integer nso,mimprs
      integer ido(nso,6)
      integer iga(msa),idt(msa)
      integer limprs(1)
      integer itemp(nsatot),istemp(msa)
      integer isa,jsa,isfr,isto,jsfr,jsto,isafr,isato,jsafr,jsato
      integer iso,noi,nimprs,nconst
      integer isoloc,ioloc,joloc,koloc,loloc,iq,jq,kq,lq
      logical lself
c
#include "bitops.fh"
c
      if(numi(2).eq.0) return
c
c     This subroutine evaluates the solute impropers list
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
c
      nimprs=0
      nconst=0
c
      do 1 isa=1,nsatot
      itemp(isa)=0
    1 continue
      do 2 jsa=jsafr,jsato
      itemp(iga(jsa))=5
    2 continue
      do 3 isa=isafr,isato
      itemp(iga(isa))=1
    3 continue
c
      do 4 iso=1,numi(2)
c
c     skip dihedrals with negative isos
c
      if(ido(iso,5).ge.0) then
c
      noi=itemp(ido(iso,1))
      if(noi.gt.0) then
      noi=noi+itemp(ido(iso,2))
      if(noi.gt.1) then
      noi=noi+itemp(ido(iso,3))
      if(noi.gt.2) then
      noi=noi+itemp(ido(iso,4))
      if(noi.gt.3) then
      if((lself.and.noi.eq.4).or.
     + (.not.lself.and.(noi.eq.8.or.noi.eq.12.or.noi.eq.16))) then
      nimprs=nimprs+1
      if(ido(iso,5).eq.1) nconst=nconst+1
      if(nimprs.gt.mimprs)
     + call md_abort('Insufficient memory for improper list',0)
      limprs(nimprs)=iso
      endif
      endif
      endif
      endif
      endif
      endif
    4 continue
c
      if(iqmmm.ne.0) then
      do 5 isa=1,nsatot
      itemp(isa)=0
    5 continue
      do 6 jsa=jsafr,jsato
      itemp(iga(jsa))=jsa
    6 continue
      do 7 isa=isafr,isato
      itemp(iga(isa))=isa
    7 continue
      do 8 isoloc=1,nimprs
      iso=limprs(isoloc)
      ioloc=itemp(ido(iso,1))
      joloc=itemp(ido(iso,2))
      koloc=itemp(ido(iso,3))
      loloc=itemp(ido(iso,4))
      iq=iand(idt(ioloc),lquant)
      jq=iand(idt(joloc),lquant)
      kq=iand(idt(koloc),lquant)
      lq=iand(idt(loloc),lquant)
      if(iq.eq.lquant.or.jq.eq.lquant.or.
     + kq.eq.lquant.or.lq.eq.lquant) then
      if(iq.ne.lquant) istemp(ioloc)=1
      if(jq.ne.lquant) istemp(joloc)=1
      if(kq.ne.lquant) istemp(koloc)=1
      if(lq.ne.lquant) istemp(loloc)=1
      endif
    8 continue
      endif
c
      return
      end
      subroutine cf_lst(lself,iga,idt,istemp,isfr,isto,jsfr,jsto,
     + idtn,nst,nthird,mthird,lthird,itemp)
c
      implicit none
c
#include "cf_common.fh"
c
      integer nst,mthird
      integer idtn(0:nst,2)
      integer iga(msa),idt(msa)
c      integer idst(mst),jdst(mst)
      integer lthird(1)
c      integer isl(msa,mis2)
      integer isa,jsa,isfr,isto,jsfr,jsto,isafr,isato,jsafr,jsato
      integer ist,nti,nthird,itloc,jtloc,istloc,iq,jq
      integer itemp(nsatot),istemp(msa)
      logical lself
c
      nthird=0
c
      if(numt(2).eq.0) return
c
c     This subroutine evaluates the solute third neighbor list
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
c
      do 1 isa=1,nsatot
      itemp(isa)=0
    1 continue
      do 2 jsa=jsafr,jsato
      itemp(iga(jsa))=3
    2 continue
      do 3 isa=isafr,isato
      itemp(iga(isa))=1
    3 continue
c
      do 4 isa=1,nsatot
      if(idtn(isa,1).gt.idtn(isa-1,1)) then
      do 5 ist=idtn(isa-1,1)+1,idtn(isa,1)
      nti=itemp(isa)
      if(nti.gt.0) then
      nti=nti+itemp(idtn(ist,2))
      if(nti.gt.1) then
      if((lself.and.nti.eq.2).or.(.not.lself.and.nti.eq.4)) then
      nthird=nthird+1
      if(nthird.gt.mthird)
     + call md_abort('Insufficient memory for third neighbor list',0)
      lthird(nthird)=ist
      endif
      endif
      endif
    5 continue
      endif
    4 continue
c
      if(iqmmm.ne.0) then
      do 6 isa=1,nsatot
      itemp(isa)=0
    6 continue
      do 7 jsa=jsafr,jsato
      itemp(iga(jsa))=jsa
    7 continue
      do 8 isa=isafr,isato
      itemp(iga(isa))=isa
    8 continue
      do 9 istloc=1,nthird
      ist=lthird(istloc)
      itloc=-1
      do 10 isa=1,nsatot
      itloc=itemp(isa)
      if(idtn(isa-1,1).lt.ist.and.idtn(isa,1).ge.ist) goto 11
   10 continue
   11 continue
      if(itloc.lt.0) call md_abort('Error in cf_lst',me)
      jtloc=itemp(idtn(ist,2))
      iq=iand(idt(itloc),lquant)
      jq=iand(idt(jtloc),lquant)
      if(iq.ne.lquant.and.jq.eq.lquant) istemp(itloc)=1
      if(iq.eq.lquant.and.jq.ne.lquant) istemp(jtloc)=1
    9 continue
      endif
c
      return
      end

      subroutine sf_print(sf_handle,size)
c
c $Id: sf_print.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "sf.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer sf_handle
      integer size
      integer l_sf,k_sf
      integer i
      logical wasdra
      double precision checksum
c
      if (.not.ma_push_get(mt_dbl,size,'sf',l_sf,k_sf))
     1  call errquit('sf_print: MA problem',0,DISK_ERR)
      if (.not.fileisga(sf_handle)) then
        call dratoga(sf_handle)
        wasdra = .true.
      else
        wasdra = .false.
      endif
      call get_block(sf_handle,dbl_mb(k_sf),size,0)
      if (wasdra) call gatodra(sf_handle)
      write(LuOut,9000) ga_nodeid()
c     call ma_print(dbl_mb(k_sf),size,1,'Global file')
      write(LuOut,9020)
      do i = 1,size
        if (dabs(dbl_mb(k_sf+i-1)).gt.1.0d-10)
     1  write(LuOut,9030) dbl_mb(k_sf+i-1)
      enddo
      write(LuOut,9020)
      checksum = 0.0d0
      do i = 1,size
        checksum = checksum + dbl_mb(k_sf+i-1)**2
      enddo
      write(LuOut,9010) checksum
      if (.not.ma_pop_stack(l_sf))
     1  call errquit('sf_print: MA problem',0,MA_ERR)
 9000 format(/,1x,'Node = ',i3)
 9010 format(1x,'Checksum = ',f15.10)
 9020 format(1x,'---------------')
 9030 format(1x,f15.10)
      return
      end

      subroutine argos_cafe_dsw(xs,xsm,ps,psp,isdt,ismf,isml,
     + isq1,isfrom,nums,
     + xw,xwm,pw,pwp,iwq,lpbc,chg,lswndx,lswjpt,lswin,lswj,
     + rwc,xi,xj,rwx,pl,pj,fi,fj,isal)
c
c $Id: argos_cafe_dsw.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      real*8 xs(msa,3),xsm(msm,3),ps(msa,3,2),psp(msa,3,2,2)
      integer isdt(msa),ismf(msa),isml(msa),isq1(msa)
      integer isfrom,nums
      real*8 xw(mwm,3,mwa),xwm(mwm,3),pw(mwm,3,mwa,2),pwp(mwm,3,mwa,2,2)
      integer iwq(mwa)
      logical lpbc
      real*8 chg(mqt,mqp,mset)
      integer lswndx(0:msa,2),lswjpt(nums,2),lswin(nums,2),lswj(*)
      real*8 rwc(mscr,3),xi(mscr,3),xj(mscr,3,mwa),rwx(mscr,3)
      real*8 pl(mscr,3),pj(mscr,3,mwa),fi(mscr,3),fj(mscr,3,mwa)
      integer isal(mscr)
c
      integer ispj,ism,lswptr,ipset,nswlen(2)
      integer isfr,ipsw,number,isa,jwa,ismn,ispm,iax,nax,nax2
      real*8 qai,qaj,pai,paj,rx,ry,rz,pix,piy,piz,pjx,pjy,pjz
      real*8 ri2,ri3,rmi,rmj
#include "bitops.fh"
c
      real*8 qfaci
c
      qfaci=one/qfac
c
c     this subroutine evaluates the solute-solvent forces for nums
c     solute atoms starting from isfrom. the interacting solvent
c     molecules are determined from the pairlist.
c
      isfr=isfrom-1
c
c     loop over short and long range pairs
c
      do 1 ipsw=1,npsw
c
c     evaluate outer index array
c
      nswlen(ipsw)=0
      lswndx(0,ipsw)=0
      number=0
      do 2 isa=1,nums
      if(number+lswin(isa,ipsw).gt.mscr .or.
     + (ismf(isfr+isa).ne.ismf(isfr+isa-1).and.number.gt.0)) then
      nswlen(ipsw)=nswlen(ipsw)+1
      lswndx(nswlen(ipsw),ipsw)=isa-1
      number=0
      endif
      number=number+lswin(isa,ipsw)
    2 continue
      if(number.gt.0) then
      nswlen(ipsw)=nswlen(ipsw)+1
      lswndx(nswlen(ipsw),ipsw)=nums
      endif
c
c     loop over number of cycles to complete pairlist
c
      do 3 ispm=1,nswlen(ipsw)
      nax=0
c
c     vacuo conditions
c
c      if(npbtyp.eq.0) then
c      if(.not.lpbc) then
      do 4 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      ism=isml(isfr+isa)
c
c     collect center of mass distance vectors
c
      if(lpbc.or.ism.eq.0) then
      do 6 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      rwc(nax+ismn,1)=xs(isfr+isa,1)-xwm(lswptr,1)
      rwc(nax+ismn,2)=xs(isfr+isa,2)-xwm(lswptr,2)
      rwc(nax+ismn,3)=xs(isfr+isa,3)-xwm(lswptr,3)
    6 continue
      if(lpbc)
     + call argos_cafe_pbc(0,rwc,mscr,rwx,mscr,nax,1,lswin(isa,ipsw))
      else
      do 5 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      rwc(nax+ismn,1)=xsm(ism,1)-xwm(lswptr,1)
      rwc(nax+ismn,2)=xsm(ism,2)-xwm(lswptr,2)
      rwc(nax+ismn,3)=xsm(ism,3)-xwm(lswptr,3)
    5 continue
      endif
c
c     collect solute coordinates and atomic polarization fields
c
c      if(iand(isdt(isfr+isa),mdynam).eq.ldynam) then
      do 7 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      xi(nax+ismn,1)=xs(isfr+isa,1)
      xi(nax+ismn,2)=xs(isfr+isa,2)
      xi(nax+ismn,3)=xs(isfr+isa,3)
      pl(nax+ismn,1)=ps(isfr+isa,1,2)
      pl(nax+ismn,2)=ps(isfr+isa,2,2)
      pl(nax+ismn,3)=ps(isfr+isa,3,2)
      isal(nax+ismn)=isfr+isa
    7 continue
c      else
c      do 8 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      xi(nax+ismn,1)=xs(isfr+isa,1)
c      xi(nax+ismn,2)=xs(isfr+isa,2)
c      xi(nax+ismn,3)=xs(isfr+isa,3)
c      pl(nax+ismn,1)=ps(isfr+isa,1,2)
c      pl(nax+ismn,2)=ps(isfr+isa,2,2)
c      pl(nax+ismn,3)=ps(isfr+isa,3,2)
c      isal(nax+ismn)=isfr+isa
c    8 continue
c      endif
c
c     collect solvent coordinates and atomic polarization fields
c
      do 8 jwa=1,mwa
      if(lpbc) then
      do 9 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      xj(nax+ismn,1,jwa)=xw(lswptr,1,jwa)+rwx(ismn,1)
      xj(nax+ismn,2,jwa)=xw(lswptr,2,jwa)+rwx(ismn,2)
      xj(nax+ismn,3,jwa)=xw(lswptr,3,jwa)+rwx(ismn,3)
      pj(nax+ismn,1,jwa)=pw(lswptr,1,jwa,2)
      pj(nax+ismn,2,jwa)=pw(lswptr,2,jwa,2)
      pj(nax+ismn,3,jwa)=pw(lswptr,3,jwa,2)
    9 continue
      else
      do 10 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      xj(nax+ismn,1,jwa)=xw(lswptr,1,jwa)
      xj(nax+ismn,2,jwa)=xw(lswptr,2,jwa)
      xj(nax+ismn,3,jwa)=xw(lswptr,3,jwa)
      pj(nax+ismn,1,jwa)=pw(lswptr,1,jwa,2)
      pj(nax+ismn,2,jwa)=pw(lswptr,2,jwa,2)
      pj(nax+ismn,3,jwa)=pw(lswptr,3,jwa,2)
   10 continue
      endif
    8 continue
      nax=nax+lswin(isa,ipsw)
    4 continue
c      else
cc
cc     periodic boundary conditions
cc
c      do 11 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
c      ispj=lswjpt(isa,ipsw)-1
c      ism=isml(isfr+isa)
cc
cc     collect center of mass distance vectors
cc
c      do 12 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      rwc(nax+ismn,1)=xs(isfr+isa,1)-xwm(lswptr,1)
c      rwc(nax+ismn,2)=xs(isfr+isa,2)-xwm(lswptr,2)
c      rwc(nax+ismn,3)=xs(isfr+isa,3)-xwm(lswptr,3)
c      rwx(ismn,1)=zero
c      rwx(ismn,2)=zero
c      rwx(ismn,3)=zero
c      if(abs(rwc(nax+ismn,1)).gt.boxh(1)) then
c      rwx(ismn,1)=sign(box(1),xs(isfr+isa,1))
c      endif
c      if(abs(rwc(nax+ismn,2)).gt.boxh(2)) then
c      rwx(ismn,2)=sign(box(2),xs(isfr+isa,2))
c      endif
c      if(npbtyp.eq.1) then
c      if(abs(rwc(nax+ismn,3)).gt.boxh(3)) then
c      rwx(ismn,3)=sign(box(3),xs(isfr+isa,3))
c      endif
c      endif
c      if(ism.gt.0) then
c      rwc(nax+ismn,1)=xsm(ism,1)-xwm(lswptr,1)-rwx(ismn,1)
c      rwc(nax+ismn,2)=xsm(ism,2)-xwm(lswptr,2)-rwx(ismn,2)
c      rwc(nax+ismn,3)=xsm(ism,3)-xwm(lswptr,3)-rwx(ismn,3)
c      else
c      rwc(nax+ismn,1)=xs(isfr+isa,1)-xwm(lswptr,1)-rwx(ismn,1)
c      rwc(nax+ismn,2)=xs(isfr+isa,2)-xwm(lswptr,2)-rwx(ismn,2)
c      rwc(nax+ismn,3)=xs(isfr+isa,3)-xwm(lswptr,3)-rwx(ismn,3)
c      endif
c   12 continue
cc
cc     collect solute coordinates and atomic polarization fields
cc
c      do 13 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      xi(nax+ismn,1)=xs(isfr+isa,1)
c      xi(nax+ismn,2)=xs(isfr+isa,2)
c      xi(nax+ismn,3)=xs(isfr+isa,3)
c      pl(nax+ismn,1)=ps(isfr+isa,1,2)
c      pl(nax+ismn,2)=ps(isfr+isa,2,2)
c      pl(nax+ismn,3)=ps(isfr+isa,3,2)
c      isal(nax+ismn)=isfr+isa
c   13 continue
cc
cc     collect solvent coordinates and atomic polarization fields
cc
c      do 14 jwa=1,mwa
c      do 15 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      xj(nax+ismn,1,jwa)=xw(lswptr,1,jwa)+rwx(ismn,1)
c      xj(nax+ismn,2,jwa)=xw(lswptr,2,jwa)+rwx(ismn,2)
c      xj(nax+ismn,3,jwa)=xw(lswptr,3,jwa)+rwx(ismn,3)
c      pj(nax+ismn,1,jwa)=pw(lswptr,1,jwa,2)
c      pj(nax+ismn,2,jwa)=pw(lswptr,2,jwa,2)
c      pj(nax+ismn,3,jwa)=pw(lswptr,3,jwa,2)
c   15 continue
c   14 continue
c      nax=nax+lswin(isa,ipsw)
c   11 continue
c      endif
c
c     zero temparary arays fi and fj
c
      do 16 iax=1,nax
      fi(iax,1)=zero
      fi(iax,2)=zero
      fi(iax,3)=zero
   16 continue
      do 17 jwa=1,mwa
      do 18 iax=1,nax
      fj(iax,1,jwa)=zero
      fj(iax,2,jwa)=zero
      fj(iax,3,jwa)=zero
   18 continue
   17 continue
c
c     loop over the number of atoms in a solvent molecule
c
c     calculated here is 4*pi*epsilon*field and not just the field
c     since the polarization is given in alpha/(4*pi*epsilon) in
c     stead of just alpha, the induced dipole is obtained by the
c     product of pwa and pw
c
      do 19 jwa=1,mwa
      qaj=qfaci*chg(iwq(jwa),1,iset)
      paj=chg(iwq(jwa),2,iset)
      do 20 iax=1,nax
      isa=isal(iax)
      qai=qfaci*chg(isq1(isa),1,iset)
      pai=chg(isq1(isa),2,iset)
      rx=xj(iax,1,jwa)-xi(iax,1)
      ry=xj(iax,2,jwa)-xi(iax,2)
      rz=xj(iax,3,jwa)-xi(iax,3)
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1,jwa)
      pjy=paj*pj(iax,2,jwa)
      pjz=paj*pj(iax,3,jwa)
      ri2=one/(rx**2+ry**2+rz**2)
      ri3=sqrt(ri2)*ri2
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=fi(iax,1)+((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=fi(iax,2)+((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=fi(iax,3)+((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1,jwa)=fj(iax,1,jwa)+((rmi+qai)*rx-pix)*ri3
      fj(iax,2,jwa)=fj(iax,2,jwa)+((rmi+qai)*ry-piy)*ri3
      fj(iax,3,jwa)=fj(iax,3,jwa)+((rmi+qai)*rz-piz)*ri3
   20 continue
   19 continue
c
c     update the electric field arrays
c
      iax=0
      do 21 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      do 22 ismn=1,lswin(isa,ipsw)
      ps(isfr+isa,1,1)=ps(isfr+isa,1,1)+fi(iax+ismn,1)
      ps(isfr+isa,2,1)=ps(isfr+isa,2,1)+fi(iax+ismn,2)
      ps(isfr+isa,3,1)=ps(isfr+isa,3,1)+fi(iax+ismn,3)
   22 continue
      do 23 jwa=1,mwa
      do 24 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pw(lswptr,1,jwa,1)=pw(lswptr,1,jwa,1)+fj(iax+ismn,1,jwa)
      pw(lswptr,2,jwa,1)=pw(lswptr,2,jwa,1)+fj(iax+ismn,2,jwa)
      pw(lswptr,3,jwa,1)=pw(lswptr,3,jwa,1)+fj(iax+ismn,3,jwa)
   24 continue
   23 continue
      iax=iax+lswin(isa,ipsw)
   21 continue
c
c     thermodynamic integration and perturbation
c
      do 30 ipset=2,3
      if((ipset.eq.2.and.ipert2).or.
     + (ipset.eq.3.and.ipert3)) then
c
      nax2=0
      do 31 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      do 32 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pl(nax2+ismn,1)=psp(isfr+isa,1,2,ipset-1)
      pl(nax2+ismn,2)=psp(isfr+isa,2,2,ipset-1)
      pl(nax2+ismn,3)=psp(isfr+isa,3,2,ipset-1)
   32 continue
      do 33 jwa=1,mwa
      do 34 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pj(nax2+ismn,1,jwa)=pwp(lswptr,1,jwa,2,ipset-1)
      pj(nax2+ismn,2,jwa)=pwp(lswptr,2,jwa,2,ipset-1)
      pj(nax2+ismn,3,jwa)=pwp(lswptr,3,jwa,2,ipset-1)
   34 continue
   33 continue
      nax2=nax2+lswin(isa,ipsw)
   31 continue
c
      if(nax.ne.nax2) call md_abort('Error in dipsw',me)
c
      do 41 iax=1,nax
      fi(iax,1)=zero
      fi(iax,2)=zero
      fi(iax,3)=zero
   41 continue
      do 42 jwa=1,mwa
      do 43 iax=1,nax
      fj(iax,1,jwa)=zero
      fj(iax,2,jwa)=zero
      fj(iax,3,jwa)=zero
   43 continue
   42 continue
c
      do 35 jwa=1,mwa
      qaj=qfaci*chg(iwq(jwa),1,ipset)
      paj=chg(iwq(jwa),2,ipset)
      do 36 iax=1,nax
      isa=isal(iax)
      qai=qfaci*chg(isq1(isa),1,ipset)
      pai=chg(isq1(isa),2,ipset)
      rx=xj(iax,1,jwa)-xi(iax,1)
      ry=xj(iax,2,jwa)-xi(iax,2)
      rz=xj(iax,3,jwa)-xi(iax,3)
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1,jwa)
      pjy=paj*pj(iax,2,jwa)
      pjz=paj*pj(iax,3,jwa)
      ri2=one/(rx**2+ry**2+rz**2)
      ri3=sqrt(ri2)*ri2
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=fi(iax,1)+((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=fi(iax,2)+((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=fi(iax,3)+((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1,jwa)=fj(iax,1,jwa)+((rmi+qai)*rx-pix)*ri3
      fj(iax,2,jwa)=fj(iax,2,jwa)+((rmi+qai)*ry-piy)*ri3
      fj(iax,3,jwa)=fj(iax,3,jwa)+((rmi+qai)*rz-piz)*ri3
   36 continue
   35 continue
c
c     update the electric field arrays
c
      iax=0
      do 37 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      do 38 ismn=1,lswin(isa,ipsw)
      psp(isfr+isa,1,ipset-1,1)=psp(isfr+isa,1,ipset-1,1)+fi(iax+ismn,1)
      psp(isfr+isa,2,ipset-1,1)=psp(isfr+isa,2,ipset-1,1)+fi(iax+ismn,2)
      psp(isfr+isa,3,ipset-1,1)=psp(isfr+isa,3,ipset-1,1)+fi(iax+ismn,3)
   38 continue
      do 39 jwa=1,mwa
      do 40 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pwp(lswptr,1,jwa,ipset-1,1)=pwp(lswptr,1,jwa,ipset-1,1)+
     + fj(iax+ismn,1,jwa)
      pwp(lswptr,2,jwa,ipset-1,1)=pwp(lswptr,2,jwa,ipset-1,1)+
     + fj(iax+ismn,2,jwa)
      pwp(lswptr,3,jwa,ipset-1,1)=pwp(lswptr,3,jwa,ipset-1,1)+
     + fj(iax+ismn,3,jwa)
   40 continue
   39 continue
      iax=iax+lswin(isa,ipsw)
   37 continue
      endif
   30 continue
c
    3 continue
    1 continue
c
      return
      end

      subroutine argos_space_wtrest(lfn)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
c
      integer lfn
c
      integer i_ltmp,l_ltmp
c
      if(.not.ma_push_get(mt_int,(mbbl+1)*mbb2,'ltmp',l_ltmp,i_ltmp))
     + call md_abort('Failed to allocate memory for ltmp',0)
      call argos_space_wrest(lfn,int_mb(i_bb),int_mb(i_ltmp),mbbl+1,
     + dbl_mb(i_boxs))
      if(.not.ma_pop_stack(l_ltmp))
     + call md_abort('Failed to deallocate ltmp',0)
c
      return
      end
c $Id: argos_space_wtrest.F 21176 2011-10-10 06:35:49Z d3y133 $

      double precision function ddotfile(d_1,d_2,size)
c
c $Id: ddotfile.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Vector inner product of two files of the same size
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "msgids.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_1
      integer d_2
      integer size
      integer nblocks,blocksize
      integer l_temp1,k_temp1
      integer l_temp2,k_temp2
      integer i,j,k
      logical nodezero
      logical d_1isga, d_2isga
cc      integer nxtval 
      integer next, nprocs, count
      INTEGER NXTASK
      EXTERNAL NXTASK
cc      external nxtval
      logical noloadbalance
c
c     new
c
      if ((fileisga(d_1).and.fileisga(d_2))) then
        ddotfile = ga_ddot(d_1,d_2)
        return
      endif
c
      if ((ioalg.eq.6).and.(fileisga(d_1).neqv.fileisga(d_2)))
     1  call errquit('unable to ddot GA and EAF',0,UNKNOWN_ERR)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_1))))
      d_1isga = fileisga(d_1)
      d_2isga = fileisga(d_2)
      if (.not.d_1isga) call dratoga(d_1)
      if ((.not.d_2isga).and.(d_1.ne.d_2)) call dratoga(d_2)
c     if ((ioalg.eq.2).or.((ioalg.eq.5).and.fileisga(d_1))
c    1                .or.((ioalg.eq.6).and.fileisga(d_1))) then
c       ddotfile = ga_ddot(d_1,d_2)
c       if (.not.d_1isga) call gatodra(d_1)
c       if ((.not.d_2isga).and.(d_1.ne.d_2)) call gatodra(d_2)
c       return
c     endif
      nodezero = (ga_nodeid().eq.0)
      ddotfile = 0.0d0
      nblocks = size/buffer_size
      if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
      blocksize = size/nblocks
      if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
      if (nodezero.and.util_print('ddotfile',print_debug)) then
        write(LuOut,9190) d_1,size
        write(LuOut,9190) d_2,size
        write(LuOut,9200) nblocks,blocksize
      endif
      if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1  l_temp1,k_temp1))
     2  call errquit('ddotfile: MA problem',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1  l_temp2,k_temp2))
     2  call errquit('ddotfile: MA problem',1,MA_ERR)
      nprocs = GA_NNODES()
      count = 0
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      do i = 1,nblocks
        if (noloadbalance.or.(next.eq.count)) then
          if (util_print('ddotfile',print_debug))
     1      write(LuOut,9210) ga_nodeid(),(i-1)*blocksize,
     2                        min(size,i*blocksize)-(i-1)*blocksize
          call get_block(d_1,dbl_mb(k_temp1),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
          call get_block(d_2,dbl_mb(k_temp2),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
          k = 0
          do j = (i-1)*blocksize+1,min(size,i*blocksize)
            k = k + 1
            ddotfile = ddotfile + dbl_mb(k_temp1+k-1)
     1                          * dbl_mb(k_temp2+k-1)
          enddo
cc          next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
        endif
        count = count + 1
      enddo
cc      next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      if (.not.noloadbalance) call ga_dgop(mt_dbl,ddotfile,1,'+')
      if (.not.d_1isga) call gatodra(d_1)
      if ((.not.d_2isga).and.(d_1.ne.d_2)) call gatodra(d_2)
      if (.not.ma_pop_stack(l_temp2))
     1  call errquit('createfile: MA problem',2,MA_ERR)
      if (.not.ma_pop_stack(l_temp1))
     1  call errquit('createfile: MA problem',3,MA_ERR)
 9190 format(/,1x,'        file handle:',i10,' size:',i10)
 9200 format(  1x,'            nblocks:',i10,' size:',i10)
 9210 format(  1x,i3,'          offset:',i10,' size:',i10)
      return
      end
c
c
c
      double precision function ddotfile_1(d_1,d_2,size)
c
c $Id: ddotfile.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Vector inner product of two files of the same size
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "msgids.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_1
      integer d_2
      integer size
      integer nblocks,blocksize
      integer l_temp1,k_temp1
      integer l_temp2,k_temp2
      integer i,j,k
      logical nodezero
      logical d_1isga, d_2isga
cc      integer nxtval 
      integer next, nprocs, count
      integer buffer_size_t1,size_t1
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical noloadbalance
c
c     new
c
      if ((fileisga(d_1).and.fileisga(d_2))) then
        ddotfile_1 = ga_ddot(d_1,d_2)
        return
      endif
c
      buffer_size_t1=tile_dim**2
c
      if ((ioalg.eq.6).and.(fileisga(d_1).neqv.fileisga(d_2)))
     1  call errquit('unable to ddot GA and EAF',0,UNKNOWN_ERR)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_1))))
      d_1isga = fileisga(d_1)
      d_2isga = fileisga(d_2)
      if (.not.d_1isga) call dratoga(d_1)
      if ((.not.d_2isga).and.(d_1.ne.d_2)) call dratoga(d_2)
c     if ((ioalg.eq.2).or.((ioalg.eq.5).and.fileisga(d_1))
c    1                .or.((ioalg.eq.6).and.fileisga(d_1))) then
c       ddotfile = ga_ddot(d_1,d_2)
c       if (.not.d_1isga) call gatodra(d_1)
c       if ((.not.d_2isga).and.(d_1.ne.d_2)) call gatodra(d_2)
c       return
c     endif
      nodezero = (ga_nodeid().eq.0)
      ddotfile_1 = 0.0d0
      nblocks = size/buffer_size_t1
      if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
      blocksize = size/nblocks
      if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
      if (nodezero.and.util_print('ddotfile',print_debug)) then
        write(LuOut,9190) d_1,size
        write(LuOut,9190) d_2,size
        write(LuOut,9200) nblocks,blocksize
      endif
      if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1  l_temp1,k_temp1))
     2  call errquit('ddotfile: MA problem',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1  l_temp2,k_temp2))
     2  call errquit('ddotfile: MA problem',1,MA_ERR)
      nprocs = GA_NNODES()
      count = 0
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      do i = 1,nblocks
        if (noloadbalance.or.(next.eq.count)) then
          if (util_print('ddotfile',print_debug))
     1      write(LuOut,9210) ga_nodeid(),(i-1)*blocksize,
     2                        min(size,i*blocksize)-(i-1)*blocksize
          call get_block(d_1,dbl_mb(k_temp1),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
          call get_block(d_2,dbl_mb(k_temp2),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
ccx          k = 0
ccx          do j = (i-1)*blocksize+1,min(size,i*blocksize)
ccx            k = k + 1
ccx            ddotfile_1 = ddotfile_1 + dbl_mb(k_temp1+k-1)
ccx     1                          * dbl_mb(k_temp2+k-1)
ccx          enddo
c
          size_t1=min(size,i*blocksize)-(i-1)*blocksize
          ddotfile_1=ddotfile_1
     1       +ddot(size_t1,dbl_mb(k_temp1),1,dbl_mb(k_temp2),1)
c
cc          next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
        endif
        count = count + 1
      enddo
cc      next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      if (.not.noloadbalance) call ga_dgop(mt_dbl,ddotfile_1,1,'+')
      if (.not.d_1isga) call gatodra(d_1)
      if ((.not.d_2isga).and.(d_1.ne.d_2)) call gatodra(d_2)
      if (.not.ma_pop_stack(l_temp2))
     1  call errquit('createfile: MA problem',2,MA_ERR)
      if (.not.ma_pop_stack(l_temp1))
     1  call errquit('createfile: MA problem',3,MA_ERR)
 9190 format(/,1x,'        file handle:',i10,' size:',i10)
 9200 format(  1x,'            nblocks:',i10,' size:',i10)
 9210 format(  1x,i3,'          offset:',i10,' size:',i10)
      return
      end
c
c
c
c
c
c
      double precision function ddotfile_2(d_1,d_2,size)
c
c $Id: ddotfile.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Vector inner product of two files of the same size
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "msgids.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_1
      integer d_2
      integer size
      integer nblocks,blocksize
      integer l_temp1,k_temp1
      integer l_temp2,k_temp2
      integer i,j,k
      logical nodezero
      logical d_1isga, d_2isga
cc      integer nxtval
      integer  next, nprocs, count
      integer buffer_size_t2,size_t2
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical noloadbalance
c
c     new
c
      if ((fileisga(d_1).and.fileisga(d_2))) then
        ddotfile_2 = ga_ddot(d_1,d_2)
        return
      endif
c
      buffer_size_t2=tile_dim**4
c
      if ((ioalg.eq.6).and.(fileisga(d_1).neqv.fileisga(d_2)))
     1  call errquit('unable to ddot GA and EAF',0,UNKNOWN_ERR)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_1))))
      d_1isga = fileisga(d_1)
      d_2isga = fileisga(d_2)
      if (.not.d_1isga) call dratoga(d_1)
      if ((.not.d_2isga).and.(d_1.ne.d_2)) call dratoga(d_2)
c     if ((ioalg.eq.2).or.((ioalg.eq.5).and.fileisga(d_1))
c    1                .or.((ioalg.eq.6).and.fileisga(d_1))) then
c       ddotfile = ga_ddot(d_1,d_2)
c       if (.not.d_1isga) call gatodra(d_1)
c       if ((.not.d_2isga).and.(d_1.ne.d_2)) call gatodra(d_2)
c       return
c     endif
      nodezero = (ga_nodeid().eq.0)
      ddotfile_2 = 0.0d0
      nblocks = size/buffer_size_t2
      if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
      blocksize = size/nblocks
      if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
      if (nodezero.and.util_print('ddotfile',print_debug)) then
        write(LuOut,9190) d_1,size
        write(LuOut,9190) d_2,size
        write(LuOut,9200) nblocks,blocksize
      endif
      if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1  l_temp1,k_temp1))
     2  call errquit('ddotfile: MA problem',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1  l_temp2,k_temp2))
     2  call errquit('ddotfile: MA problem',1,MA_ERR)
      nprocs = GA_NNODES()
      count = 0
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      do i = 1,nblocks
        if (noloadbalance.or.(next.eq.count)) then
          if (util_print('ddotfile',print_debug))
     1      write(LuOut,9210) ga_nodeid(),(i-1)*blocksize,
     2                        min(size,i*blocksize)-(i-1)*blocksize
          call get_block(d_1,dbl_mb(k_temp1),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
          call get_block(d_2,dbl_mb(k_temp2),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
ccx          k = 0
ccx          do j = (i-1)*blocksize+1,min(size,i*blocksize)
ccx            k = k + 1
ccx            ddotfile_1 = ddotfile_1 + dbl_mb(k_temp1+k-1)
ccx     1                          * dbl_mb(k_temp2+k-1)
ccx          enddo
c
          size_t2=min(size,i*blocksize)-(i-1)*blocksize
          ddotfile_2=ddotfile_2
     1       +ddot(size_t2,dbl_mb(k_temp1),1,dbl_mb(k_temp2),1)
c
cc          next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
        endif
        count = count + 1
      enddo
cc      next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      if (.not.noloadbalance) call ga_dgop(mt_dbl,ddotfile_2,1,'+')
      if (.not.d_1isga) call gatodra(d_1)
      if ((.not.d_2isga).and.(d_1.ne.d_2)) call gatodra(d_2)
      if (.not.ma_pop_stack(l_temp2))
     1  call errquit('createfile: MA problem',2,MA_ERR)
      if (.not.ma_pop_stack(l_temp1))
     1  call errquit('createfile: MA problem',3,MA_ERR)
 9190 format(/,1x,'        file handle:',i10,' size:',i10)
 9200 format(  1x,'            nblocks:',i10,' size:',i10)
 9210 format(  1x,i3,'          offset:',i10,' size:',i10)
      return
      end

      logical function argos_prepare_wrtsgm(lfnout,lfnsgm,filsgm,nparms,
     + nparmsp,
     + latm,catm,qatm,matm,natm,lbnd,mbnd,nbnd,lang,mang,nang,
     + ldih,mdih,ndih,limp,mimp,nimp,izmat,zmat,mzmat,nzmat,ipardef)
c
c $Id: argos_prepare_wrtsgm.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
#include "argos_prepare_common.fh"
c
      integer lfnout,lfnsgm,nparms,nparmsp,ipardef
      integer matm,natm,mbnd,nbnd,mang,nang,mdih,ndih,mimp,nimp
      integer latm(6,matm),lbnd(2,mbnd),lang(3,mang),ldih(4,mdih)
      integer limp(4,mimp)
      character*6 catm(nparmsp,matm)
      real*8 qatm(nparms,2,matm)
      integer mzmat,nzmat
      integer izmat(mzmat,4)
      real*8 zmat(mzmat,3)
      character*255 filsgm
      character*10 date,time
c
      integer i,j,length
c
      length=index(filsgm,' ')-1
      open(unit=lfnsgm,file=filsgm(1:length),form='formatted',
     + status='new',err=9999)
c
      call swatch(date,time)
c
      write(lfnsgm,2000) date,time
 2000 format('# This is an automatically generated segment file',/,
     + '# ',2a10)
c
      write(lfnsgm,2001) 4.6
 2001 format(f12.6)
c
      write(lfnsgm,2002) natm,nbnd,nang,ndih,nimp,nzmat,nparms,ipardef
 2002 format(8i5)
c
      write(lfnsgm,2003) (0.0,j=1,nparms)
 2003 format(f12.6)
c
      do 1 i=1,natm
      write(lfnsgm,2004) i,catm(1,i),(latm(j,i),j=1,5)
 2004 format(i5,a6,5i5)
      do 201 j=1,nparms
      write(lfnsgm,2005) catm(1+j,i),qatm(j,1,i),qatm(j,2,i)
 2005 format(5x,a6,2f12.6)
  201 continue
    1 continue
c
      do 2 i=1,nbnd
      write(lfnsgm,2006) i,(lbnd(j,i),j=1,2),0,0
 2006 format(5i5)
      do 202 j=1,nparms
      write(lfnsgm,2007) 0.0d0,0.0d0
 2007 format(f12.6,e12.5)
  202 continue
    2 continue
c
      do 3 i=1,nang
      write(lfnsgm,2008) i,(lang(j,i),j=1,3),0,0
 2008 format(6i5)
      do 203 j=1,nparms
      write(lfnsgm,2009) 0.0d0,0.0d0
 2009 format(f10.6,e12.5)
  203 continue
    3 continue
c
      do 4 i=1,ndih
      write(lfnsgm,2010) i,(ldih(j,i),j=1,4),0,0
 2010 format(7i5)
      do 204 j=1,nparms
      write(lfnsgm,2011) 0,0.0d0,0.0d0
 2011 format(i3,f10.6,e12.5)
  204 continue
    4 continue
c
      do 5 i=1,nimp
      if(ffield(1:5).eq.'amber') then
      write(lfnsgm,2012) i,limp(2,i),limp(3,i),limp(1,i),limp(4,i),
     + 0,0
 2012 format(7i5)
      do 205 j=1,nparms
      write(lfnsgm,2013) 0,0.0d0,0.0d0
 2013 format(i3,f10.6,e12.5)
  205 continue
      else
      write(lfnsgm,2012) i,(limp(j,i),j=1,4),0,0
      do 305 j=1,nparms
      write(lfnsgm,2013) 0,0.0d0,0.0d0
  305 continue
      endif
    5 continue
c
      do 6 i=1,nzmat
      write(lfnsgm,2014) i,(izmat(i,j),j=1,4),(zmat(i,j),j=1,3)
 2014 format(5i5,3f12.6)
    6 continue
c
      close(unit=lfnsgm)
c
      if(util_print('sequence',print_medium)) then
      write(lfnout,1000) filsgm(1:length)
 1000 format(' Created segment',t40,a)
      endif
c
      argos_prepare_wrtsgm=.true.
      return
c
 9999 continue
      argos_prepare_wrtsgm=.false.
      return
      end

*> \brief \b LSAMEN
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download LSAMEN + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/lsamen.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/lsamen.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/lsamen.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       LOGICAL          FUNCTION LSAMEN( N, CA, CB )
* 
*       .. Scalar Arguments ..
*       CHARACTER*( * )    CA, CB
*       INTEGER            N
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> LSAMEN  tests if the first N letters of CA are the same as the
*> first N letters of CB, regardless of case.
*> LSAMEN returns .TRUE. if CA and CB are equivalent except for case
*> and .FALSE. otherwise.  LSAMEN also returns .FALSE. if LEN( CA )
*> or LEN( CB ) is less than N.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of characters in CA and CB to be compared.
*> \endverbatim
*>
*> \param[in] CA
*> \verbatim
*>          CA is CHARACTER*(*)
*> \endverbatim
*>
*> \param[in] CB
*> \verbatim
*>          CB is CHARACTER*(*)
*>          CA and CB specify two character strings of length at least N.
*>          Only the first N characters of each string will be accessed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup auxOTHERauxiliary
*
*  =====================================================================
      LOGICAL          FUNCTION LSAMEN( N, CA, CB )
*
*  -- LAPACK auxiliary routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER*( * )    CA, CB
      INTEGER            N
*     ..
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          LEN
*     ..
*     .. Executable Statements ..
*
      LSAMEN = .FALSE.
      IF( LEN( CA ).LT.N .OR. LEN( CB ).LT.N )
     $   GO TO 20
*
*     Do for each character in the two strings.
*
      DO 10 I = 1, N
*
*        Test if the characters are equal using LSAME.
*
         IF( .NOT.LSAME( CA( I: I ), CB( I: I ) ) )
     $      GO TO 20
*
   10 CONTINUE
      LSAMEN = .TRUE.
*
   20 CONTINUE
      RETURN
*
*     End of LSAMEN
*
      END
c $Id: lsamen.f 24343 2013-06-22 05:35:15Z d3y133 $

      SubRoutine Get_Dens(Geom,Basis,nSet,nBF,g_Vec,g_Dns,
     &                    Spin,File_Vec,nOrb,k_Orb,iProc)
*
* $Id: get_dens.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      Implicit None
#include "errquit.fh"
*     
************************************************************************
#include "mafdecls.fh"
#include "global.fh"
#include "stdio.fh"
#include "bas.fh"
#include "context.fh"
************************************************************************
*
*---- Arguments of a Get_Dens call
      Integer Geom,Basis,nSet,nBF,g_Vec(2),g_Dns(2)
      Integer nOrb,k_Orb,iProc
      Character*8 Spin
      Character*80 File_Vec
*---- Local variables
      Integer iSet,nOcc(2),k_Occ(2),k_Ene(2),l_Occ(2),l_Ene(2)
      Integer iBF
      Logical DeBug,LResult
      Logical  movecs_read
      External movecs_read
*
************************************************************************
*
      DeBug = .False.
*
*---- Allocate memory for orbital energies and occupation numbers
      LResult = MA_Push_Get(MT_Dbl,nBF,'Ene1',l_Ene(1),k_Ene(1))
      Call ErrMem(LResult,'Get_Dens: Failed to allocate orb. en.',0)
      LResult = MA_Push_Get(MT_Dbl,nBF,'Occ1',l_Occ(1),k_Occ(1))
      Call ErrMem(LResult,'Get_Dens: Failed to allocate occ. num.',0)
      If (nSet.eq.2) Then
         LResult = MA_Push_Get(MT_Dbl,nBF,'Ene2',l_Ene(2),k_Ene(2))
         Call ErrMem(LResult,'Get_Dens: Failed to allocate orb. en.',0)
         LResult = MA_Push_Get(MT_Dbl,nBF,'Occ2',l_Occ(2),k_Occ(2))
         Call ErrMem(LResult,'Get_Dens: Failed to allocate occ. num.',0)
      End If
*
*---- Generate the density matrix
      Do iSet = 1, nSet
*------- Read the orbital file
         If (.not.movecs_read(File_Vec,iSet,Dbl_mb(k_Occ(iSet)),
     &      Dbl_mb(k_Ene(iSet)),g_Vec(iSet)))
     &      Call ErrQuit('Get_Dens: movecs_read failed',0, DISK_ERR)
*------- Get the number of occ. orbitals (for DFT_DensM, no longer used)
         nOcc(iSet) = 0
         Do iBF = 0, nBF-1
            If (Dbl_mb(k_Occ(iSet)+iBF).gt.1.d-8)
     &         nOcc(iSet)=nOcc(iSet)+1
         End Do
         If (Debug . and . iProc.eq.0) 
     &      Write(LuOut,*)' nOcc       = ',nOcc(iSet)
*------- Change the orbital occupancies in the restricted case
         If (nSet.eq.1 . and . Spin.ne.'TOTAL')
     &      Call ChangeOcc(Dbl_mb(k_Occ(iSet)),nBF,Spin)
*------- Eliminate orbitals from the calculation of the density
         If (nOrb.ne.999999) Call Eliminate(Int_mb(k_Orb),nOrb,
     &                       Dbl_mb(k_Occ(iSet)),nBF,iProc)
*------- Finally, get the density in AO basis: D(AO) = C x D(MO) x C(T)
         Call DMat(Geom,Basis,
     &             g_Vec(iSet),g_Dns(iSet),Dbl_mb(k_Occ(iSet)),nBF)
      End Do
      Call GA_Sync
*
*---- Form the relevant density matrix
      If (nSet.eq.2) Then
         If (Spin.eq.'TOTAL') Then
            Call GA_dAdd(1.d0,g_Dns(1),1.d0,g_Dns(2),g_Dns(1))
         Else If (Spin.eq.'SPINDENS') Then
            Call GA_dAdd(1.d0,g_Dns(1),-1.d0,g_Dns(2),g_Dns(1))
         Else If (Spin.eq.'ALPHA') Then
         Else If (Spin.eq.'BETA') Then
            Call GA_Copy(g_Dns(2),g_Dns(1))
         End If
      End If
*
*---- Deallocate memory
      If (nSet.eq.2) Then
         LResult = MA_Pop_Stack(l_Occ(2))
         Call ErrMem(LResult,
     &        'Get_Dens: Failed to deallocate occ. num.',0)
         LResult = MA_Pop_Stack(l_Ene(2))
         Call ErrMem(LResult,
     &        'Get_Dens: Failed to deallocate orb. en.',0)
      End If
      LResult = MA_Pop_Stack(l_Occ(1))
      Call ErrMem(LResult,'Get_Dens: Failed to deallocate occ. num.',0)
      LResult = MA_Pop_Stack(l_Ene(1))
      Call ErrMem(LResult,'Get_Dens: Failed to deallocate orb. en.',0)
*
      Call GA_Sync
*
*---- Normal termination
      Return
      End
*
*-----------------------------------------------------------------------
*
      SubRoutine Eliminate(OrbNo,nOrb,OccNo,nBF,iProc)
      Implicit None
#include "errquit.fh"
*---- Arguments of a Eliminate call
      Integer nOrb,nBF,iProc
      Integer OrbNo(nOrb)
      Double Precision OccNo(nBF)
*---- Local Variables
      Integer i,iCount
      Logical DeBug
*
      DeBug = .False.
      If (DeBug . and . iProc.eq.0)
     &   Write(*,'(30(1x,f3.1))') (OccNo(i),i=1,nBF)
*
      iCount = 1
      Do i = 1, nBF
         If (i.eq.OrbNo(iCount)) Then
            iCount = iCount + 1
         Else
            OccNo(i) = 0.d0
         End If
      End Do
      If (iCount-1.ne.nOrb) Call ErrQuit('Eliminate: failed',0,
     &       UNKNOWN_ERR)
*
      If (DeBug . and . iProc.eq.0)
     &   Write(*,'(30(1x,f3.1))') (OccNo(i),i=1,nBF)
*
      Return
      End
*
*-----------------------------------------------------------------------
*
      SubRoutine ChangeOcc(OccNo,nBF,Spin)
      Implicit None
#include "errquit.fh"
*
************************************************************************
*
*---- Arguments of a ChangeOcc call
      Integer nBF
      Double Precision OccNo(nBF)
      Character*8 Spin
*---- Local variables
      Integer iBF
*
************************************************************************
*
      Do iBF = 1, nBF
         If ( Abs(OccNo(iBF)-2.d0) . lt . 1.d-8 ) Then
            If (Spin.eq.'SPINDENS') Then
               OccNo(iBF) = 0.d0
            Else If (Spin.eq.'ALPHA') Then
               OccNo(iBF) = 1.d0
            Else If (Spin.eq.'BETA') Then
               OccNo(iBF) = 1.d0
            End If
         Else If ( Abs(OccNo(iBF)-1.d0) . lt . 1.d-8 ) Then
            If (Spin.eq.'BETA') Then
               OccNo(iBF) = 0.d0
            End If
         Else If ( Abs(OccNo(iBF) ) . lt . 1.d-8 ) Then
         Else
            Call ErrQuit('Cannot handle non-integer occupations yet',0,
     &       CAPMIS_ERR)
         End If
      End Do
*
      Return
      End

C $Id: rphwrt.F 25349 2014-03-15 21:09:00Z jhammond $
#if defined(LINUX) && !defined(XLFLINUX) && !defined(CRAYFORTRAN)
#define APPEND_OK
#endif
      Subroutine drdy_rphwrt (iop)
C
C Write out RPH interpolation information.
C
C    IOP = 0, first call to RPHSET
C    IOP = 1,2, write out reactant information
C    IOP = 3,4, write out product information
C    IOP = 5, write out saddle point information
C    IOP = 6, set up to write out RPH information for points along
C             the MEP
C    IOP = 7, write out RPH information for points along the MEP
C
      Implicit None
#include "errquit.fh"
C
#include "drdyP.fh"
#include "stdio.fh"
C
*::local:
*::passed:
      Integer iop
      Character*255 filename ! we want to give the file 30 a name
*::local:
#if !(defined(APPEND_OK) || defined(F90_IO))
      character*80 dummy_card
#endif
      Logical isopen
      Integer i,j,llopt(40),lifreq,nfreq,nend
      Double Precision swrt
C
      nfreq  = 0
      nend   = 0
      lifreq = 0
c
c get a unique file name for fu30
c
      call util_file_name('file30',.false.,.false.,filename)
C
      if (iop.eq.0) then
c
C First call; write comment card and options
C
         isopen = .false.
         inquire(unit=fu30,opened=isopen)
         if (isopen) then
            write(fu6,*)' deleting old unit fu30 data'
            close (unit=fu30, status='delete')
         endif
         open (unit=fu30,status='new',form='formatted',file=filename)
         write (fu30,3000) ctitle
C
C Options:
C    LLOPT(1)  = 2, print out titles, options, summary information, 
C                   and echo input as it is read
C    LLOPT(2)  = maximum number of points used in Lagrange interpolation
C    LLOPT(3)  = 1, write coordinates and gradients in mass-weighted
C    LLOPT(4)  =-2, packed F matrix written in mass-weighted coordinates
C    LLOPT(5)  = 0, no anharmonicity data
C    LLOPT(6)  = 2, use gradient on save grid and fit to quadratic
C
         do i = 1,40
            llopt(i) = 0
         enddo
         llopt(1) = 2
         llopt(2) = 3
         llopt(3) = 1
         llopt(4) = -2
         llopt(5) = 0
         llopt(6) = 2
         llopt(7) = 0
         llopt(8) = 0
         write (fu30,3005) llopt
      elseif (iop.lt.5) then
c
c reactants or products
c
         isopen = .false.
         inquire(unit=fu30,opened=isopen)
         if (isopen) then
            write(fu6,*)' deleting old unit fu30 data'
            close (unit=fu30, status='keep')
         endif
#if defined(APPEND_OK)
         open (unit=fu30,access='append',form='formatted',
     &         file=filename)
#endif
#if defined(F90_IO)
         open (unit=fu30,position='append',form='formatted',
     $         file=filename)
#endif
#if !(defined(APPEND_OK) || defined(F90_IO))
         open (unit=fu30,form='formatted',file=filename)
         rewind fu30
00001    continue
         read (fu30,'(a)',end=00002) dummy_card
         goto 00001
00002    backspace fu30
#endif
         write (fu30,3010) iop
         swrt = 0.0d00
         if (iop.eq.1) then
            vzero = v
            v = v - vzero
            if (lgs(39).eq.0) then
               write (fu30,3020) swrt,v,vzero
            else
               vzerosp = vspc
               vspc = vspc - vzerosp
               write (fu30,3021) swrt,v,vzero,vspc,vzerosp
            endif
         else if (iop.eq.3) then
            v = v - vzero
            if (lgs(39).eq.0) then
               write (fu30,3020) swrt,v
            else
               vspc = vspc - vzerosp
               write (fu30,3020) swrt,v,vspc
            endif
         else
            write (fu30,3020) swrt,0.0d00,0.0d00
         endif
         lifreq = 0
         if (iop.eq.2 .or. iop.eq.4) lifreq = nf(iop-1)
         if (icode(iop).eq.1) then
            write (fu30,*) ' '
         elseif (icode(iop).eq.2) then
            write (fu6,6000) iop
            call errquit('drdy_rphwrt: fatal error ',911, INPUT_ERR)
         else
            nfreq = nf(iop)
            nend = 3*nratom(iop)
            write (fu30,3005) (lifreq+i,i=1,nfreq)
C  write out packed hessian in mass-weighted coordinates
            write (fu30,3040)
            do i = 1, nend
               write (fu30,3020) (fsv(i,j),j=1,i)
            enddo
         endif
      elseif (iop.eq.5) then
c
c saddle point
c
        isopen = .false.
        inquire(unit=fu30,opened=isopen)
        if (isopen) then
          write(fu6,*)' deleting old unit fu30 data'
          close (unit=fu30, status='keep')
        endif
#if defined(APPEND_OK)
        open (unit=fu30,access='append',form='formatted',
     &        file=filename)
#endif
#if defined(F90_IO)
        open (unit=fu30,position='append',form='formatted',
     &        file=filename)
#endif
#if !(defined(APPEND_OK) || defined(F90_IO))
        open (unit=fu30,form='formatted',file=filename)
        rewind fu30
00003   continue
        read (fu30,'(a)',end=00004) dummy_card
        goto 00003
00004   backspace fu30
#endif
        write (fu30,3050)
         nfreq = nf(5)
         if(lgs(39).eq.0) then
            write (fu30,3020) s,v-vzero
         else
            write (fu30,3020) s,v-vzero,vspc-vzerosp
         endif
c  write out mass-weighted x
C         write (fu30,3030) (x(i),i=1,n3)
         write (fu30,3005) (i,i=1,nfreq)
C  write out packed hessian in mass-weighted coordinates
         write (fu30,3040)
         do i = 1, n3
            write (fu30,3020) (f(i,j),j=1,i)
         enddo
      elseif (iop.eq.6) then
*
         isopen = .false.
         inquire(unit=fu30,opened=isopen)
         if (isopen) then
            write(fu6,*)' deleting old unit fu30 data'
            close (unit=fu30, status='keep')
         endif
#if defined(APPEND_OK)
         open (unit=fu30,access='append',form='formatted',
     &         file=filename)
#endif
#if defined(F90_IO)
         open (unit=fu30,position='append',form='formatted',
     &         file=filename)
#endif
#if !(defined(APPEND_OK) || defined(F90_IO))
         open (unit=fu30,form='formatted',file=filename)
         rewind fu30
00005    continue
         read (fu30,'(a)',end=00006) dummy_card
         goto 00005
00006    backspace fu30
#endif
C
         write (fu30,3060)
      else
c
c points along mep
c
         isopen = .false.
         inquire(unit=fu30,opened=isopen)
         if (isopen) then
            write(fu6,*)' deleting old unit fu30 data'
            close (unit=fu30, status='keep')
         endif
#if defined(APPEND_OK)
         open (unit=fu30,access='append',form='formatted',
     &         file=filename)
#endif
#if defined(F90_IO)
         open (unit=fu30,position='append',form='formatted',
     &         file=filename)
#endif
#if !(defined(APPEND_OK) || defined(F90_IO))
         open (unit=fu30,form='formatted',file=filename)
         rewind fu30
00007    continue
         read (fu30,'(a)',end=00008) dummy_card
         goto 00007
00008    backspace fu30
#endif
         if (icode(5).eq.3) then
            nfreq = n3 - 6
         else
            nfreq = n3 - 7
         endif
         if(lgs(39).eq.0) then
            write (fu30,3070) s,v-vzero
         else
            write (fu30,3070) s,v-vzero,vspc-vzerosp
         endif
c  write out mass-weighted x
         write (fu30,3030) (x(i),i=1,n3)
c  write out mass-weighted dx
         write (fu30,3080) (dx(i),i=1,n3)
         write (fu30,3005) (i,i=1,nfreq)
c  write out packed hessian in mass-weighted coordinates
         write (fu30,3040)
         do i = 1, n3
            write (fu30,3020) (f(i,j),j=1,i)
         enddo
      endif
      close (fu30)
      return
C
3000  Format (a80)
3005  Format (1x,i2,39i3)
3010  Format (' iop =', i5, ', s,v=')
3020  Format (1x, 1pe23.15, 3e24.15)
3021  Format (1x, 1pe23.15, 4e24.15)
3030  Format (' x='/ (1x, 1pe23.15, 3e24.15))
3040  Format (' f matrix (packed)=')
3050  Format (' saddle point,  s,v=')
3060  Format (' begin points along reaction coordinate'/ ' number of',
     *   ' points goes here')
3070  Format (' s,v='/ (1x, 1pe23.15, 3e24.15))
3080  Format (' dx='/ (1x, 1pe23.15, 3e24.15))
6000  Format (' icode=2 was chosen for iop=',i5,', but it is not',
     *   ' supported')
      END

      subroutine tce_sort_4(unsorted,sorted,a,b,c,d,
     1                      i,j,k,l,factor)
      implicit none
#include "util.fh"
#include "tce_main.fh"
      integer version
      integer a,b,c,d
      integer i,j,k,l
      integer id(4),jd(4),ia,ib,j1,j2,j3,j4
      double precision sorted(a*b*c*d)
      double precision unsorted(a*b*c*d)
      double precision factor
c
      version = 1000*i+100*j+10*k+l
c
c transpose_1234.log:        The best loop order is:        2134
c transpose_1243.log:        The best loop order is:        1243
c transpose_1324.log:        The best loop order is:        1234
c transpose_1342.log:        The best loop order is:        1342
c transpose_1423.log:        The best loop order is:        1423
c transpose_1432.log:        The best loop order is:        1342
c
      if (version.eq.1234) then
        call transpose_1234_loop_2134(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.1243) then
        call transpose_1243_loop_1243(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.1324) then
        call transpose_1324_loop_1234(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.1342) then
        call transpose_1342_loop_1342(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.1423) then
        call transpose_1423_loop_1423(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.1432) then
        call transpose_1432_loop_1342(unsorted,sorted,a,b,c,d,factor)
c
c transpose_2134.log:        The best loop order is:        2134
c transpose_2143.log:        The best loop order is:        2143
c transpose_2314.log:        The best loop order is:        2134
c transpose_2341.log:        The best loop order is:        2341
c transpose_2413.log:        The best loop order is:        2413
c transpose_2431.log:        The best loop order is:        2341
c
      elseif (version.eq.2134) then
        call transpose_2134_loop_2134(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.2143) then
        call transpose_2143_loop_2143(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.2314) then
        call transpose_2314_loop_2134(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.2341) then
        call transpose_2341_loop_2341(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.2413) then
        call transpose_2413_loop_2413(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.2431) then
        call transpose_2431_loop_2341(unsorted,sorted,a,b,c,d,factor)
c
c transpose_3124.log:        The best loop order is:        1234
c transpose_3142.log:        The best loop order is:        1342
c transpose_3214.log:        The best loop order is:        2134
c transpose_3241.log:        The best loop order is:        2341
c transpose_3412.log:        The best loop order is:        1342
c transpose_3421.log:        The best loop order is:        2341
c
      elseif (version.eq.3124) then
        call transpose_3124_loop_1234(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.3142) then
        call transpose_3142_loop_1342(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.3214) then
        call transpose_3214_loop_2134(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.3241) then
        call transpose_3241_loop_2341(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.3412) then
        call transpose_3412_loop_1342(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.3421) then
        call transpose_3421_loop_2341(unsorted,sorted,a,b,c,d,factor)
c
c transpose_4123.log:        The best loop order is:        1423
c transpose_4132.log:        The best loop order is:        1342
c transpose_4213.log:        The best loop order is:        2413
c transpose_4231.log:        The best loop order is:        2341
c transpose_4312.log:        The best loop order is:        1342
c transpose_4321.log:        The best loop order is:        2341
c
      elseif (version.eq.4123) then
        call transpose_4123_loop_1423(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.4132) then
        call transpose_4132_loop_1342(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.4213) then
        call transpose_4213_loop_2413(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.4231) then
        call transpose_4231_loop_2341(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.4312) then
        call transpose_4312_loop_1342(unsorted,sorted,a,b,c,d,factor)
      elseif (version.eq.4321) then
        call transpose_4321_loop_2341(unsorted,sorted,a,b,c,d,factor)
c
      else
        print*,'something is wrong...'
      endif

      return
      end
        subroutine transpose_4321_loop_3241(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer xdim1,xdim4,rdim1,rdim4
        integer old offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
        rdim1=mod(dim1,4)
        rdim4=mod(dim4,4)
        xdim1=dim1-rdim1
        xdim4=dim4-rdim4
!DEC$ ivdep
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ vector always
!DEC$ loop count min(24), max(40), avg(32)
        do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
         do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ vector always
          do j4 = 1,xdim4,4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ vector always
           do j1 = 1,xdim1,4
            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(1+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(1+j1-1))))
            sorted(2+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(2+j1-1))))
            sorted(3+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(3+j1-1))))

            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(1+j4-1)))) = factor*
     &    unsorted(1+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(1+j1+dim1*(j2-1+dim2*(j3-1+dim3*(1+j4-1)))) = factor*
     &    unsorted(1+j4+dim4*(j3-1+dim3*(j2-1+dim2*(1+j1-1))))
            sorted(2+j1+dim1*(j2-1+dim2*(j3-1+dim3*(1+j4-1)))) = factor*
     &    unsorted(1+j4+dim4*(j3-1+dim3*(j2-1+dim2*(2+j1-1))))
            sorted(3+j1+dim1*(j2-1+dim2*(j3-1+dim3*(1+j4-1)))) = factor*
     &    unsorted(1+j4+dim4*(j3-1+dim3*(j2-1+dim2*(3+j1-1))))

            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(2+j4-1)))) = factor*
     &    unsorted(2+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(1+j1+dim1*(j2-1+dim2*(j3-1+dim3*(2+j4-1)))) = factor*
     &    unsorted(2+j4+dim4*(j3-1+dim3*(j2-1+dim2*(1+j1-1))))
            sorted(2+j1+dim1*(j2-1+dim2*(j3-1+dim3*(2+j4-1)))) = factor*
     &    unsorted(2+j4+dim4*(j3-1+dim3*(j2-1+dim2*(2+j1-1))))
            sorted(3+j1+dim1*(j2-1+dim2*(j3-1+dim3*(2+j4-1)))) = factor*
     &    unsorted(2+j4+dim4*(j3-1+dim3*(j2-1+dim2*(3+j1-1))))

            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(3+j4-1)))) = factor*
     &    unsorted(3+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(1+j1+dim1*(j2-1+dim2*(j3-1+dim3*(3+j4-1)))) = factor*
     &    unsorted(3+j4+dim4*(j3-1+dim3*(j2-1+dim2*(1+j1-1))))
            sorted(2+j1+dim1*(j2-1+dim2*(j3-1+dim3*(3+j4-1)))) = factor*
     &    unsorted(3+j4+dim4*(j3-1+dim3*(j2-1+dim2*(2+j1-1))))
            sorted(3+j1+dim1*(j2-1+dim2*(j3-1+dim3*(3+j4-1)))) = factor*
     &    unsorted(3+j4+dim4*(j3-1+dim3*(j2-1+dim2*(3+j1-1))))
           enddo
!DEC$ loop count min(0), max(4), avg(2)
!DEC$ vector always
           do j1 = xdim1+1,dim1,1
            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(1+j4-1)))) = factor*
     &    unsorted(1+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(2+j4-1)))) = factor*
     &    unsorted(2+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(3+j4-1)))) = factor*
     &    unsorted(3+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
           enddo
          enddo
!DEC$ loop count min(0), max(4), avg(2)
!DEC$ vector always
          do j4 = xdim4+1,dim4,1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ vector always
           do j1 = 1,xdim1,4
            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
            sorted(1+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(1+j1-1))))
            sorted(2+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(2+j1-1))))
            sorted(3+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(3+j1-1))))
           enddo
          enddo
!DEC$ loop count min(0), max(4), avg(2)
!DEC$ vector always
          do j4 = xdim4+1,dim4,1
!DEC$ loop count min(0), max(4), avg(2)
!DEC$ vector always
           do j1 = xdim1+1,dim1,1
            sorted(0+j1+dim1*(j2-1+dim2*(j3-1+dim3*(0+j4-1)))) = factor*
     &    unsorted(0+j4+dim4*(j3-1+dim3*(j2-1+dim2*(0+j1-1))))
           enddo
          enddo
         enddo
        enddo
        return
        end
c
c
c  ADD AUTO-GENERATED CODE HERE
c
c
        subroutine transpose_1234_loop_2134(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j4 = 1,dim4
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_1243_loop_1243(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j3 = 1,dim3
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j3+dim3*(j4-1+dim4*(j2-1+dim2*(j1-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_1324_loop_1234(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j4 = 1,dim4
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j4+dim4*(j2-1+dim2*(j3-1+dim3*(j1-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_1342_loop_1342(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j2 = 1,dim2
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j2+dim2*(j4-1+dim4*(j3-1+dim3*(j1-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_1423_loop_1423(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j3 = 1,dim3
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j3+dim3*(j2-1+dim2*(j4-1+dim4*(j1-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_1432_loop_1342(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j2 = 1,dim2
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j2+dim2*(j3-1+dim3*(j4-1+dim4*(j1-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_2134_loop_2134(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j4 = 1,dim4
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j4+dim4*(j3-1+dim3*(j1-1+dim1*(j2-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_2143_loop_2143(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j3 = 1,dim3
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j3+dim3*(j4-1+dim4*(j1-1+dim1*(j2-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_2314_loop_2134(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j4 = 1,dim4
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j4+dim4*(j1-1+dim1*(j3-1+dim3*(j2-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_2341_loop_2341(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j1 = 1,dim1
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j1+dim1*(j4-1+dim4*(j3-1+dim3*(j2-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_2413_loop_2413(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j3 = 1,dim3
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j3+dim3*(j1-1+dim1*(j4-1+dim4*(j2-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_2431_loop_2341(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j1 = 1,dim1
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j1+dim1*(j3-1+dim3*(j4-1+dim4*(j2-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_3124_loop_1234(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j4 = 1,dim4
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j4+dim4*(j2-1+dim2*(j1-1+dim1*(j3-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_3142_loop_1342(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j2 = 1,dim2
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j2+dim2*(j4-1+dim4*(j1-1+dim1*(j3-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_3214_loop_2134(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j4 = 1,dim4
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j4+dim4*(j1-1+dim1*(j2-1+dim2*(j3-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_3241_loop_2341(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j1 = 1,dim1
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j1+dim1*(j4-1+dim4*(j2-1+dim2*(j3-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_3412_loop_1342(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j2 = 1,dim2
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j2+dim2*(j1-1+dim1*(j4-1+dim4*(j3-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_3421_loop_2341(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j1 = 1,dim1
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j1+dim1*(j2-1+dim2*(j4-1+dim4*(j3-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_4123_loop_1423(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j3 = 1,dim3
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j3+dim3*(j2-1+dim2*(j1-1+dim1*(j4-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_4132_loop_1342(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j2 = 1,dim2
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j2+dim2*(j3-1+dim3*(j1-1+dim1*(j4-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_4213_loop_2413(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j3 = 1,dim3
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j3+dim3*(j1-1+dim1*(j2-1+dim2*(j4-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_4231_loop_2341(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j1 = 1,dim1
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j1+dim1*(j3-1+dim3*(j2-1+dim2*(j4-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_4312_loop_1342(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j1 = 1,dim1
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j2 = 1,dim2
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j2+dim2*(j1-1+dim1*(j3-1+dim3*(j4-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
        subroutine transpose_4321_loop_2341(unsorted,sorted,
     &                           dim1,dim2,dim3,dim4,factor)
        implicit none
        integer dim1,dim2,dim3,dim4
        integer old_offset,new_offset
        integer j1,j2,j3,j4
        double precision sorted(dim1*dim2*dim3*dim4)
        double precision unsorted(dim1*dim2*dim3*dim4)
        double precision factor
!DEC$ prefetch sorted
!DEC$ prefetch unsorted
!DEC$ ivdep
!DEC$ loop count min(24), max(40), avg(32)
        do j2 = 1,dim2
!DEC$ loop count min(24), max(40), avg(32)
         do j3 = 1,dim3
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
          do j4 = 1,dim4
!DEC$ loop count min(24), max(40), avg(32)
!DEC$ unroll(8)
!DEC$ vector always
           do j1 = 1,dim1
            old_offset = j4+dim4*(j3-1+dim3*(j2-1+dim2*(j1-1)))
            new_offset = j1+dim1*(j2-1+dim2*(j3-1+dim3*(j4-1)))
            sorted(new_offset) = unsorted(old_offset) * factor
           enddo
          enddo
         enddo
        enddo
        return
        end
c $Id: tce_sort4_jeff_torun.F 21176 2011-10-10 06:35:49Z d3y133 $

c
c$Id: rstat.F 19708 2010-10-29 18:04:21Z d3y133 $
      subroutine drdy_rstat(string,iend,istrt,jtype)
c     Generic subroutine to read in the input for all the stationary points.
c     Jtype = 1  first reactant 
c     Jtype = 2  second reactant 
c     Jtype = 3  first product 
c     Jtype = 4  second product
c     Jtype = 5  saddle point or starting stationary point
c
      Implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "drdyP.fh"
      Integer iend,istrt,jtype
      character * 80 string
C
      Integer ierr,isect
      character * 8  idmn 
c
c     read in first keyword in this section
c
      call drdy_rline(string,istrt,isect,iend)
c
      do while (isect.eq.0.and.iend.eq.0)
c GEOM
         if (string(istrt:istrt+3).eq.'geom') then
            if (jtype.le.4) call drdy_rgeom(string,istrt,jtype)
            if (jtype.eq.5) call drdy_rgsad(string,istrt,jtype)
c SPECIES
         else if (string(istrt:istrt+6).eq.'species') then              !0603PF97
            call drdy_rword(string,istrt,ierr)
            if (ierr.ne.1) then 
               idmn = string(istrt:istrt+7)
               if (idmn.eq.'atomic  ') icode(jtype)=1
               if (idmn.eq.'lints   '.or.idmn.eq.'linrp   ')
     >                icode(jtype)=3
               if (idmn.eq.'nonlints'.or.idmn.eq.'nonlinrp')
     >                icode(jtype) = 4
            else
               write(fu6,*) 'ERROR: variable SPECIES must have an',
     *                       ' argument!'
               call errquit('drdy_rstat: fatal error ',911, INPUT_ERR)
            end if
         else
            write(fu6,1000) string(istrt:80)
            call errquit('drdy_rstat: fatal error ',911, INPUT_ERR)
         endif
         call drdy_rline(string,istrt,isect,iend)
      end do
c
1000  format(3x,'Error:  the following is not a valid keyword in the',
     *       ' stationary points section',/A80)
c
      return
      end

C> \ingroup selci
C> @{
      subroutine selci_rdconf(iflcon,ioconf,indxci,nintpo,noconf)
*
* $Id: rdconf.f 24790 2013-11-11 18:56:49Z d3y133 $
*
      integer ioconf(nintpo*noconf),indxci(noconf+1)
c
c     read occupations and index vector from ciconf file
c
      read (iflcon) ioconf
      read (iflcon) indxci
c
      end
C> @}

C $Id: euler.F 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine drdy_euler (n3tm,n3,x,dx,dels)
      Implicit None
      Integer n3tm,n3
      Double Precision x(n3tm),dx(n3tm),dels
C
      Integer i
      Double Precision dxmag
C
      dxmag = 0.0d00
      do i = 1,n3
         dxmag = dxmag + dx(i)*dx(i)
      enddo
      dxmag = sqrt(dxmag)
      do i = 1,n3
         x(i) = x(i) - dels*dx(i)/dxmag
      enddo
      return
      end

c
c $Id: ewald_self.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE ewald_self(ewald1)

      implicit none

      include 'p_array.inc'
      include 'p_const.inc'
      include 'cm_atom.inc'
      include 'cm_ewld.inc'

      integer i,iatm

      real*8 ewald1

      ewald1=0.0

      do i=1,natms

       iatm=atmtype(i)
       ewald1=ewald1+typchge(iatm)*typchge(iatm)

      enddo

      ewald1=-convfct1*alpha*ewald1/sqrpi

      return

      END

C> \ingroup selci
C> @{
C>
      subroutine selci_makef(f,h,g,int12,int34,iocc,listd,lists,ns,nd,
     $     odonly)
*
* $Id: makef.F 24780 2013-11-07 21:23:59Z d3y133 $
*
#include "implicit.fh"
#include "ciinfo.fh"
      dimension f(*),h(*),g(*),int12(*),int34(*),listd(*),lists(*),
     $     iocc(255)
      logical odonly
c
      dimension ind(255),rocc(255),indir(255),indrr(255)
c     
c     f(ij) = hij + sum(r) (nr*(ij|rr)-(ir|rj))
c     where nr is the occupancy (1 or 2) of orbital r
c     and ij is a triangular index
c     
c     listd(*) is the list of doubly occupied orbitals (nd of them)
c     lists(*) is the list of singly occupied orbitals (ns of them)
c     
c     12/13/89 ... only make for at least one index occupied
c              ... lots of other optimisations
c
c     2/3/96   ... only compute diag. if that is all that is needed
c     
#include "stfunc.fh"
c     
c     call dfill(nnorbs,0.0d0,f,1)
c
      do 5 i = 1,ns
         ind(i) = lists(i)
         rocc(i) = 1.0d0
 5    continue
      do 6 i = 1,nd
         ind(i+ns) = listd(i)
         rocc(i+ns) = 2.0d0
 6    continue
      nocc = ns+nd
      do 7 i = 1,nocc
         indrr(i) = iky(ind(i)) + ind(i)
 7    continue
c
      do 10 i = 1,norbs
         if (iocc(i).gt.0) then
            do 15 kr = 1,nocc
               indir(kr) = itrian(i,ind(kr))
 15         continue
c
            if (odonly) then
               ii = itrian(i,i)
               s = h(ii)
               do kr = 1,nocc
                  ir = ind(kr)
                  iirr = intadr(ii,indrr(kr))
                  irri = intadr(indir(kr),itrian(ir,i))
                  s = s + rocc(kr)*g(iirr) - g(irri)
               enddo
               f(ii) = s
            else
               do 20 j = 1,norbs
                  if (isym(i).eq.isym(j)) then 
                     ij = itrian(i,j)
                     s = h(ij)
                     do 30 kr = 1,nocc
                        ir = ind(kr)
                        ijrr = intadr(ij,indrr(kr))
                        irrj = intadr(indir(kr),itrian(ir,j))
                        s = s + rocc(kr)*g(ijrr) - g(irrj)
 30                  continue
                     f(ij) = s
                  endif
 20            continue
            endif
c
         endif
 10   continue
c     
      end
C>
C> @}

      subroutine argos_space_trvl(xw,vw,xwcr,gw,iwl,iwlp,
     + xs,vs,gs,isl,islp,
     + boxsiz,ibownr,ipl,ndx,itmp,rtmp,lenx)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      real*8 xw(mwm,3,mwa),vw(mwm,3,mwa),xwcr(mwm,3)
      real*8 xs(msa,3),vs(msa,3)
      real*8 gw(mwm,3,mwa),gs(msa,3)
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      integer lenx
      real*8 boxsiz(maxbox,3)
      integer ipl(mbox,mip2),ibownr(maxbox,3)
      integer ndx(lenx),itmp(lenx)
      real*8 rtmp(lenx)
      logical lrec(27)
c
      integer i,indexw,indexs,j,k,ibx,iby,ibz,ipx,ipy,ipz
      integer isbox,isnod,nrbox
      integer ilp,ihp,jlp,jhp
      integer il,ih,jl,jh,ilw,ihw,jlw,jhw,ils,ihs,jls,jhs
      integer iliw,ihiw,jliw,jhiw
      integer ilis,ihis,jlis,jhis
      integer iwm,iwstay,jwstay,lwstay,nwgo,nwgosm
      integer nwgtsm
      integer nwnew,nwstay,iwmloc,jwmloc,lwmloc,irw
      integer isa,jsa,isstay,jsstay,icsgm,ifsgm,ilsgm
      integer nsnew,nsstay,lsstay,isaloc,jsaloc,lsaloc,irs
      integer nsgo,jnode,iwfr,iwto,isfr,isto
      real*8 factor,xscx,xscy,xscz,boxi(3)
      integer itemps,nfold
      logical lend
      character*255 string
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 util_nint
      external util_nint
#endif
c
      boxi(1)=one/box(1)
      boxi(2)=one/box(2)
      boxi(3)=one/box(3)
      nfold=0
      lpbc9=.false.
c
      nwstay=0
c
c     order the solvent molecules
c
      if(nwmloc.gt.0) then
      do 1 i=1,nwmloc
      ndx(i)=i
    1 continue
      endif
      if(nwmloc.gt.1) then
      lwmloc=nwmloc/2+1
      irw=nwmloc
    2 continue
      if(lwmloc.gt.1) then
      lwmloc=lwmloc-1
      itemps=ndx(lwmloc)
      else
      itemps=ndx(irw)
      ndx(irw)=ndx(1)
      irw=irw-1
      if(irw.eq.1) then
      ndx(1)=itemps
      goto 3
      endif
      endif
      iwmloc=lwmloc
      jwmloc=lwmloc+lwmloc
    4 continue
      if(jwmloc.le.irw) then
      if(jwmloc.lt.irw) then
      if((iwl(ndx(jwmloc),lwnod).eq.iwl(ndx(jwmloc+1),lwnod).and.
     + iwl(ndx(jwmloc),lwbox).le.iwl(ndx(jwmloc+1),lwbox)).or.
     + ((iwl(ndx(jwmloc),lwnod).eq.me.or.
     + (iwl(ndx(jwmloc),lwnod).ne.me.and.
     + iwl(ndx(jwmloc),lwnod).le.iwl(ndx(jwmloc+1),lwnod))).and.
     + iwl(ndx(jwmloc+1),lwnod).ne.me)) jwmloc=jwmloc+1
      endif
      if((iwl(itemps,lwnod).eq.iwl(ndx(jwmloc),lwnod).and.
     + iwl(itemps,lwbox).le.iwl(ndx(jwmloc),lwbox)).or.
     + ((iwl(itemps,lwnod).eq.me.or. (iwl(itemps,lwnod).ne.me.and.
     + iwl(itemps,lwnod).le.iwl(ndx(jwmloc),lwnod))).and.
     + iwl(ndx(jwmloc),lwnod).ne.me)) then
      ndx(iwmloc)=ndx(jwmloc)
      iwmloc=jwmloc
      jwmloc=jwmloc+jwmloc
      else
      jwmloc=irw+1
      endif
      goto 4
      endif
      ndx(iwmloc)=itemps
      goto 2
    3 continue
c
      do 5 k=1,3
      do 8 i=1,nwmloc
      rtmp(i)=xwcr(i,k)
    8 continue
      do 9 i=1,nwmloc
      xwcr(i,k)=rtmp(ndx(i))
    9 continue
      do 10 j=1,nwa
      do 11 i=1,nwmloc
      rtmp(i)=xw(i,k,j)
   11 continue
      do 12 i=1,nwmloc
      xw(i,k,j)=rtmp(ndx(i))
   12 continue
      do 13 i=1,nwmloc
      rtmp(i)=vw(i,k,j)
   13 continue
      do 14 i=1,nwmloc
      vw(i,k,j)=rtmp(ndx(i))
   14 continue
      if(iguide.gt.0) then
      do 113 i=1,nwmloc
      rtmp(i)=gw(i,k,j)
  113 continue
      do 114 i=1,nwmloc
      gw(i,k,j)=rtmp(ndx(i))
  114 continue
      endif
   10 continue
    5 continue
      do 18 k=1,miw2
      do 19 i=1,nwmloc
      itmp(i)=iwl(i,k)
   19 continue
      do 20 i=1,nwmloc
      iwl(i,k)=itmp(ndx(i))
   20 continue
   18 continue
      endif
c
      if(nwmloc.gt.0) then
      do 21 iwm=1,nwmloc
      if(iwl(iwm,lwnod).eq.me) then
      nwstay=iwm
      else
c
c     check if moving atoms go to neighboring processor
c
      do 222 k=1,27
      if(iwl(iwm,lwnod).eq.neighb(k,1)) goto 223
  222 continue
      write(string,'(a,i4,a,i4,a,i4,9f6.2)')
     +  'argos_space_travel: solvent molecule ',
     + iwl(iwm,lwgmn),' moving to non-neighbor ',iwl(iwm,lwnod),
     + ' from ',me,((xw(iwm,i,j),i=1,3),j=1,3)
      call md_abort(string,me)
  223 continue
c
      endif
c
c     testcode
c
      if(iand(idebug,8).eq.8) then
      if(iwl(iwm,lwnod).ne.me) write(lfndbg,'(a,3i5)')
     +  'Travel w fnd ',me,iwl(iwm,lwnod),iwl(iwm,lwgmn)
      endif
c
c     end test code
c
   21 continue
      endif
c
c     order the solute atoms
c
c     isl(isa,lsbox) : box
c     isl(isa,lsnod) : node
c     isl(isa,lssgm) : segment
c
      nsstay=0
      if(nsaloc.gt.0) then
      do 22 i=1,nsaloc
      ndx(i)=i
   22 continue
      endif
c
      if(nsaloc.gt.1) then
      lsaloc=nsaloc/2+1
      irs=nsaloc
   23 continue
      if(lsaloc.gt.1) then
      lsaloc=lsaloc-1
      itemps=ndx(lsaloc)
      else
      itemps=ndx(irs)
      ndx(irs)=ndx(1)
      irs=irs-1
      if(irs.eq.1) then
      ndx(1)=itemps
      goto 24
      endif
      endif
      isaloc=lsaloc
      jsaloc=lsaloc+lsaloc
   25 continue
      if(jsaloc.le.irs) then
      if(jsaloc.lt.irs) then
      if((isl(ndx(jsaloc),lsnod).eq.isl(ndx(jsaloc+1),lsnod).and.
     + (isl(ndx(jsaloc),lsbox).lt.isl(ndx(jsaloc+1),lsbox).or.
     + (isl(ndx(jsaloc),lsbox).eq.isl(ndx(jsaloc+1),lsbox).and.
     + isl(ndx(jsaloc),lssgm).le.isl(ndx(jsaloc+1),lssgm)))).or.
     + ((isl(ndx(jsaloc),lsnod).eq.me.or.
     + (isl(ndx(jsaloc),lsnod).ne.me.and.
     + isl(ndx(jsaloc),lsnod).le.isl(ndx(jsaloc+1),lsnod))).and.
     + isl(ndx(jsaloc+1),lsnod).ne.me)) jsaloc=jsaloc+1
      endif
      if((isl(itemps,lsnod).eq.isl(ndx(jsaloc),lsnod).and.
     + (isl(itemps,lsbox).lt.isl(ndx(jsaloc),lsbox).or.
     + (isl(itemps,lsbox).eq.isl(ndx(jsaloc),lsbox).and.
     + isl(itemps,lssgm).le.isl(ndx(jsaloc),lssgm)))).or.
     + ((isl(itemps,lsnod).eq.me.or. (isl(itemps,lsnod).ne.me.and.
     + isl(itemps,lsnod).le.isl(ndx(jsaloc),lsnod))).and.
     + isl(ndx(jsaloc),lsnod).ne.me)) then
      ndx(isaloc)=ndx(jsaloc)
      isaloc=jsaloc
      jsaloc=jsaloc+jsaloc
      else
      jsaloc=irs+1
      endif
      goto 25
      endif
      ndx(isaloc)=itemps
      goto 23
   24 continue
c
      do 26 k=1,3
      do 27 i=1,nsaloc
      rtmp(i)=xs(i,k)
   27 continue
      do 28 i=1,nsaloc
      xs(i,k)=rtmp(ndx(i))
   28 continue
      do 29 i=1,nsaloc
      rtmp(i)=vs(i,k)
   29 continue
      do 30 i=1,nsaloc
      vs(i,k)=rtmp(ndx(i))
   30 continue
      if(iguide.gt.0) then
      do 2129 i=1,nsaloc
      rtmp(i)=gs(i,k)
 2129 continue
      do 2130 i=1,nsaloc
      gs(i,k)=rtmp(ndx(i))
 2130 continue
      endif
   26 continue
      do 40 k=1,mis2
      do 41 i=1,nsaloc
      itmp(i)=isl(i,k)
   41 continue
      do 42 i=1,nsaloc
      isl(i,k)=itmp(ndx(i))
   42 continue
   40 continue
      endif
c
      if(nsa.gt.0) then
      do 43 isa=1,nsaloc
      if(isl(isa,lsnod).eq.me) then
      nsstay=isa
      else
c
c     check if moving atoms go to neighboring processor
c
      do 444 k=1,27
      if(isl(isa,lsnod).eq.neighb(k,1)) goto 445
  444 continue
      write(string,'(a,i4,a,i4,a,i4,3f6.2)')
     +  'argos_space_travel: solute segment ',
     + isl(isa,lssgm),' moving to non-neighbor ',isl(isa,lsnod),
     + ' from ',me,(xs(isa,i),i=1,3)
      call md_abort(string,me)
  445 continue
c
      endif
   43 continue
      endif
c
c     make packages ready for shipment
c
c     loop over all neighboring nodes
c
      call ga_distribution(ga_iw,me,iliw,ihiw,jliw,jhiw)
      call ga_distribution(ga_w,me,ilw,ihw,jlw,jhw)
      call ga_distribution(ga_is,me,ilis,ihis,jlis,jhis)
      call ga_distribution(ga_s,me,ils,ihs,jls,jhs)
c
      indexw=0
      indexs=0
      nwgosm=0
c
      do 70 i=1,27
      jnode=neighb(i,1)
      if(jnode.ge.0.and.jnode.ne.me) then
c
c     for the solvent
c
      iwfr=0
      iwto=0
      do 71 iwm=nwstay+1,nwmloc
      if(iwl(iwm,lwnod).eq.jnode) then
      if(iwfr.eq.0) iwfr=iwm
      iwto=iwm
c
c     testcode
c
      if(iand(idebug,8).eq.8) then
      if(iwl(iwm,lwnod).ne.me) write(lfndbg,'(a,3i5)')
     +  'Travel w snd ',me,iwl(iwm,lwnod),iwl(iwm,lwgmn)
      endif
c
c     end test code
c
      endif
   71 continue
c
c     if molecules need to travel copy coordinates etc into global array
c
      nwgo=iwto-iwfr+1
      if(iwfr.eq.0) nwgo=0
      ipl(1,1)=0
      ipl(1,2)=0
c
      if(nwgo.gt.0) then
      nwgosm=nwgosm+nwgo
      il=iliw+indexw
      ih=il+nwgo-1
      if(npackw.eq.0) then
      call ga_put(ga_iw,il,ih,jliw,jhiw,iwl(iwfr,1),mwm)
      else
      call argos_space_packw(ih-il+1,iwl(iwfr,1),iwlp(iwfr,1))
      call ga_put(ga_iw,il,ih,jliw,jliw+npackw-1,iwlp(iwfr,1),mwm)
      endif
      il=ilw+indexw
      ih=il+nwgo-1
      call ga_put(ga_w,il,ih,jlw,jlw+3*mwa-1,xw(iwfr,1,1),mwm)
      call ga_put(ga_w,il,ih,jlw+3*mwa,jlw+6*mwa-1,vw(iwfr,1,1),mwm)
      call ga_put(ga_w,il,ih,jlw+6*mwa,jlw+6*mwa+2,xwcr(iwfr,1),mwm)
      if(iguide.gt.0) then
      call ga_put(ga_w,il,ih,jlw+6*mwa+3,jlw+9*mwa+2,gw(iwfr,1,1),mwm)
      endif
      ipl(1,1)=indexw+1
      ipl(1,2)=indexw+nwgo
      indexw=indexw+nwgo
      endif
c
c     for the solute
c
      isfr=0
      isto=0
      do 72 isa=nsstay+1,nsaloc
      if(isl(isa,lsnod).eq.jnode) then
      if(isfr.eq.0) isfr=isa
      isto=isa
      endif
   72 continue
      nsgo=isto-isfr+1
      if(isfr.eq.0) nsgo=0
      ipl(1,3)=0
      ipl(1,4)=0
      if(nsgo.gt.0) then
      il=ilis+indexs
      ih=il+nsgo-1
      if(npack.eq.0) then
      call ga_put(ga_is,il,ih,jlis,jhis,isl(isfr,1),msa)
      else
      call argos_space_pack(ih-il+1,isl(isfr,1),islp(isfr,1))
      call ga_put(ga_is,il,ih,jlis,jlis+npack-1,islp(isfr,1),msa)
      endif
      call ga_put(ga_s,il,ih,jls,jls+2,xs(isfr,1),msa)
      call ga_put(ga_s,il,ih,jls+3,jls+5,vs(isfr,1),msa)
      if(iguide.gt.0) then
      call ga_put(ga_s,il,ih,jls+6,jls+8,gs(isfr,1),msa)
      endif
      ipl(1,3)=indexs+1
      ipl(1,4)=indexs+nsgo
      indexs=indexs+nsgo
      endif
c
c     inform other node of number of molecules to get
c
      if(ipl(1,1).gt.0.or.ipl(1,3).gt.0) then
      call ga_distribution(ga_ip,jnode,ilp,ihp,jlp,jhp)
      ilp=ilp+2+i
      call ga_put(ga_ip,ilp,ilp,jlp,jhp,ipl,mbox)
      endif
      endif
      lrec(i)=.false.
   70 continue
c
      call ga_sync()
c
c     receive molecules from other nodes
c
      nwgtsm=0
c
      call ga_distribution(ga_ip,me,ilp,ihp,jlp,jhp)
      call ga_get(ga_ip,ilp,ilp+30,jlp,jhp,ipl,mbox)
c
      do 74 i=1,27
      jnode=neighb(i,2)
      if(jnode.ge.0.and.jnode.ne.me.and..not.lrec(i)) then
c
      iwfr=ipl(3+i,1)
      iwto=ipl(3+i,2)
      isfr=ipl(3+i,3)
      isto=ipl(3+i,4)
c
      nwnew=iwto-iwfr+1
      nsnew=isto-isfr+1
c
      if(iwfr.eq.0) nwnew=0
      if(isfr.eq.0) nsnew=0
c
      if(nwstay+nwnew.gt.mwm) then
      write(string,'(a,i7,a,i7)')
     + 'Travel: mwm needs increase with ',nwnew,' to ',nwstay+nwnew
      call md_abort(string,me)
      endif
      if(nsstay+nsnew.gt.msa) then
      write(string,'(a,i7,a,i7)')
     + 'Travel: msa needs increase with ',nsnew,' to ',nsstay+nsnew
      call md_abort(string,me)
      endif
c
      lrec(i)=.true.
c
      if(iwfr.gt.0) then
      nwgtsm=nwgtsm+nwnew
      iwto=ipl(3+i,2)
      call ga_distribution(ga_iw,jnode,iliw,ihiw,jliw,jhiw)
      call ga_distribution(ga_w,jnode,ilw,ihw,jlw,jhw)
c
c     get data for additional molecules
c
      il=iliw+iwfr-1
      ih=iliw+iwto-1
      if(npackw.eq.0) then
      call ga_get(ga_iw,il,ih,jliw,jhiw,iwl(nwstay+1,1),mwm)
      else
      call ga_get(ga_iw,il,ih,jliw,jliw+npackw-1,iwlp(nwstay+1,1),mwm)
      call argos_space_unpackw(ih-il+1,iwl(nwstay+1,1),iwlp(nwstay+1,1))
      endif
      call ga_get(ga_w,il,ih,jlw,jlw+3*mwa-1,xw(nwstay+1,1,1),mwm)
      call ga_get(ga_w,il,ih,jlw+3*mwa,jlw+6*mwa-1,vw(nwstay+1,1,1),mwm)
      call ga_get(ga_w,il,ih,jlw+6*mwa,jlw+6*mwa+2,xwcr(nwstay+1,1),mwm)
      if(iguide.gt.0) then
      call ga_get(ga_w,il,ih,jlw+6*mwa+3,jlw+9*mwa+2,
     + gw(nwstay+1,1,1),mwm)
      endif
c
c     testcode
c
      if(iand(idebug,8).eq.8) then
      write(lfndbg,'(a,3i5)')
     +  ('Travel w rcv ',me,jnode,iwl(nwstay+k,lwgmn),k=1,nwnew)
      endif
c
c     end test code
c
c
c     update number of local solvent molecules
c
      nwstay=nwstay+nwnew
c
      endif
c
c     for the solute
c
      if(isfr.gt.0) then
      call ga_distribution(ga_is,jnode,ilis,ihis,jlis,jhis)
      call ga_distribution(ga_s,jnode,ils,ihs,jls,jhs)
      il=ilis+isfr-1
      ih=ilis+isto-1
      jl=jlis
      jh=jhis
      if(npack.eq.0) then
      call ga_get(ga_is,il,ih,jlis,jhis,isl(nsstay+1,1),msa)
      else
      call ga_get(ga_is,il,ih,jlis,jlis+npack-1,islp(nsstay+1,1),msa)
      call argos_space_unpack(ih-il+1,isl(nsstay+1,1),islp(nsstay+1,1))
      endif
      call ga_get(ga_s,il,ih,jls,jls+2,xs(nsstay+1,1),msa)
      call ga_get(ga_s,il,ih,jls+3,jls+5,vs(nsstay+1,1),msa)
      if(iguide.gt.0) then
      call ga_get(ga_s,il,ih,jls+6,jls+8,gs(nsstay+1,1),msa)
      endif
c
      nsstay=nsstay+nsnew
      endif
c
      endif
c
c     reset the pointers to zero
c
      ipl(3+i,1)=0
      ipl(3+i,2)=0
      ipl(3+i,3)=0
      ipl(3+i,4)=0
c
   74 continue
c
c     reset ipl in global array
c
      call ga_put(ga_ip,ilp,ilp+30,jlp,jhp,ipl,mbox)
c
c     order the solvent molecules according to subbox and
c     store indices into ip
c
c     ip(1,1)    : number of boxes on this node
c     ip(1,2)    : number of solvent molecules on this node
c     ip(2,2)    : number of solute atoms on this node
c
c     ip(3+i,1)  : index for solvents to be moved to the i-th neighbor
c
c     ip(30+i,1) : number of i-th box on this node
c     ip(30+i,2) : index to first solvent in i-th box
c     ip(30+i,3) : index to lasst solvent in i-th box
c
      if(nwstay.gt.0.and.(nwgosm.gt.0.or.nwgtsm.gt.0)) then
      do 81 i=1,nwstay
      ndx(i)=i
   81 continue
      if(nwstay.gt.1) then
      lwstay=nwstay/2+1
      irw=nwstay
   82 continue
      if(lwstay.gt.1) then
      lwstay=lwstay-1
      itemps=ndx(lwstay)
      else
      itemps=ndx(irw)
      ndx(irw)=ndx(1)
      irw=irw-1
      if(irw.eq.1) then
      ndx(1)=itemps
      goto 83
      endif
      endif
      iwstay=lwstay
      jwstay=lwstay+lwstay
   84 continue
      if(jwstay.le.irw) then
      if(jwstay.lt.irw) then
      if(iwl(ndx(jwstay),lwbox).le.iwl(ndx(jwstay+1),lwbox))
     + jwstay=jwstay+1
      endif
      if(iwl(itemps,lwbox).le.iwl(ndx(jwstay),lwbox)) then
      ndx(iwstay)=ndx(jwstay)
      iwstay=jwstay
      jwstay=jwstay+jwstay
      else
      jwstay=irw+1
      endif
      goto 84
      endif
      ndx(iwstay)=itemps
      goto 82
   83 continue
c
      do 85 k=1,3
      do 88 i=1,nwstay
      rtmp(i)=xwcr(i,k)
   88 continue
      do 89 i=1,nwstay
      xwcr(i,k)=rtmp(ndx(i))
   89 continue
      do 90 j=1,nwa
      do 91 i=1,nwstay
      rtmp(i)=xw(i,k,j)
   91 continue
      do 92 i=1,nwstay
      xw(i,k,j)=rtmp(ndx(i))
   92 continue
      do 93 i=1,nwstay
      rtmp(i)=vw(i,k,j)
   93 continue
      do 94 i=1,nwstay
      vw(i,k,j)=rtmp(ndx(i))
   94 continue
      if(iguide.gt.0) then
      do 193 i=1,nwstay
      rtmp(i)=gw(i,k,j)
  193 continue
      do 194 i=1,nwstay
      gw(i,k,j)=rtmp(ndx(i))
  194 continue
      endif
   90 continue
   85 continue
      do 98 k=1,miw2
      do 99 i=1,nwstay
      itmp(i)=iwl(i,k)
   99 continue
      do 100 i=1,nwstay
      iwl(i,k)=itmp(ndx(i))
  100 continue
   98 continue
c
      endif
      endif
c
c     order the solute according to segment
c
      if(nsstay.gt.0) then
      do 122 i=1,nsstay
      ndx(i)=i
  122 continue
      if(nsstay.gt.1) then
      lsstay=nsstay/2+1
      irs=nsstay
  123 continue
      if(lsstay.gt.1) then
      lsstay=lsstay-1
      itemps=ndx(lsstay)
      else
      itemps=ndx(irs)
      ndx(irs)=ndx(1)
      irs=irs-1
      if(irs.eq.1) then
      ndx(1)=itemps
      goto 124
      endif
      endif
      isstay=lsstay
      jsstay=lsstay+lsstay
  125 continue
      if(jsstay.le.irs) then
      if(jsstay.lt.irs) then
      if(isl(ndx(jsstay),lssgm).le.isl(ndx(jsstay+1),lssgm))
     + jsstay=jsstay+1
      endif
      if(isl(itemps,lssgm).le.isl(ndx(jsstay),lssgm)) then
      ndx(isstay)=ndx(jsstay)
      isstay=jsstay
      jsstay=jsstay+jsstay
      else
      jsstay=irs+1
      endif
      goto 125
      endif
      ndx(isstay)=itemps
      goto 123
  124 continue
      endif
c
c     for each segment : 1. determine box number
c                        2. assign box number to each atom
c                        3. when box not owned by node:
c                           a. assign box number
c                           b. assign correct node number
c
      goto 666
      icsgm=isl(ndx(1),lssgm)
      ifsgm=1
      ilsgm=1
      do 126 isa=2,nsstay+1
c
c     if isa is first atom of a new segment or very last atom
c
 
      if(isa.le.nsstay) then
      lend=isl(ndx(isa),lssgm).ne.icsgm
      else
      lend=.true.
      endif
      if(lend) then
      if(isa.gt.nsstay) ilsgm=nsstay
      if(ifsgm.gt.0.and.ilsgm.ge.ifsgm) then
      xscx=zero
      xscy=zero
      xscz=zero
      do 127 jsa=ifsgm,ilsgm
      xscx=xscx+xs(ndx(jsa),1)
      xscy=xscy+xs(ndx(jsa),2)
      xscz=xscz+xs(ndx(jsa),3)
  127 continue
      factor=one/dble(ilsgm-ifsgm+1)
      xscx=factor*xscx
      xscy=factor*xscy
      xscz=factor*xscz
      if(npbtyp.ne.0) then
      if(abs(xscx).gt.boxh(1)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xscx=xscx-util_nint(xscx*boxi(1))*box(1)
#else
      xscx=xscx-nint(xscx*boxi(1))*box(1)
#endif
      nfold=1
      endif
      if(abs(xscy).gt.boxh(2)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xscy=xscy-util_nint(xscy*boxi(2))*box(2)
#else
      xscy=xscy-nint(xscy*boxi(2))*box(2)
#endif
      nfold=1
      endif
      if(abs(xscz).gt.boxh(3)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xscz=xscz-util_nint(xscz*boxi(3))*box(3)
#else
      xscz=xscz-nint(xscz*boxi(3))*box(3)
#endif
      nfold=1
      endif
      endif
c
c     determine the box number
c
      ibx=0
      iby=0
      ibz=0
      do 128 i=1,nbx-1
      if(xscx+boxh(1).gt.boxsiz(i,1)) ibx=i
  128 continue
      do 129 i=1,nby-1
      if(xscy+boxh(2).gt.boxsiz(i,2)) iby=i
  129 continue
      do 1130 i=1,nbz-1
      if(xscz+boxh(3).gt.boxsiz(i,3)) ibz=i
 1130 continue
      if(npbtyp.gt.0) then
      if(ibx.ge.nbx) ibx=ibx-nbx
      if(iby.ge.nby) iby=iby-nby
      if(ibx.lt.0) ibx=ibx+nbx
      if(iby.lt.0) iby=iby+nby
      if(npbtyp.eq.1) then
      if(ibz.ge.nbz) ibz=ibz-nbz
      if(ibz.lt.0) ibz=ibz+nbz
      else
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibz.lt.0) ibz=0
      endif
      else
      if(ibx.ge.nbx) ibx=nbx-1
      if(iby.ge.nby) iby=nby-1
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibx.lt.0) ibx=0
      if(iby.lt.0) iby=0
      if(ibz.lt.0) ibz=0
      endif
      ipx=ibownr(ibx+1,1)
      ipy=ibownr(iby+1,2)
      ipz=ibownr(ibz+1,3)
      isbox=(ibz*nby+iby)*nbx+ibx
      isnod=(ipz*npy+ipy)*npx+ipx
c
c     assign box and node numbers
c
      do 1131 jsa=ifsgm,ilsgm
      isl(ndx(jsa),lsbox)=isbox
      isl(ndx(jsa),lsnod)=isnod
 1131 continue
c
      endif
      if(isa.le.nsstay) icsgm=isl(ndx(isa),lssgm)
      ifsgm=isa
      else
      ilsgm=isa
      endif
  126 continue
  666 continue
c
c     order solute according to box, segment, charge group, atom number
c
      if(nsstay.gt.1) then
      lsstay=nsstay/2+1
      irs=nsstay
  132 continue
      if(lsstay.gt.1) then
      lsstay=lsstay-1
      itemps=ndx(lsstay)
      else
      itemps=ndx(irs)
      ndx(irs)=ndx(1)
      irs=irs-1
      if(irs.eq.1) then
      ndx(1)=itemps
      goto 133
      endif
      endif
      isstay=lsstay
      jsstay=lsstay+lsstay
  134 continue
      if(jsstay.le.irs) then
      if(jsstay.lt.irs) then
      if(isl(ndx(jsstay),lsbox).lt.isl(ndx(jsstay+1),lsbox).or.
     + (isl(ndx(jsstay),lsbox).eq.isl(ndx(jsstay+1),lsbox).and.
     + (isl(ndx(jsstay),lssgm).lt.isl(ndx(jsstay+1),lssgm).or.
     + (isl(ndx(jsstay),lssgm).eq.isl(ndx(jsstay+1),lssgm).and.
     + (isl(ndx(jsstay),lsgrp).lt.isl(ndx(jsstay+1),lsgrp).or.
     + (isl(ndx(jsstay),lsgrp).eq.isl(ndx(jsstay+1),lsgrp).and.
     + isl(ndx(jsstay),lsgan).le.isl(ndx(jsstay+1),lsgan)))))))
     + jsstay=jsstay+1
      endif
      if(isl(itemps,lsbox).lt.isl(ndx(jsstay),lsbox).or.
     + (isl(itemps,lsbox).eq.isl(ndx(jsstay),lsbox).and.
     + (isl(itemps,lssgm).lt.isl(ndx(jsstay),lssgm).or.
     + (isl(itemps,lssgm).eq.isl(ndx(jsstay),lssgm).and.
     + (isl(itemps,lsgrp).lt.isl(ndx(jsstay),lsgrp).or.
     + (isl(itemps,lsgrp).eq.isl(ndx(jsstay),lsgrp).and.
     + isl(itemps,lsgan).le.isl(ndx(jsstay),lsgan))))))) then
      ndx(isstay)=ndx(jsstay)
      isstay=jsstay
      jsstay=jsstay+jsstay
      else
      jsstay=irs+1
      endif
      goto 134
      endif
      ndx(isstay)=itemps
      goto 132
  133 continue
      endif
c
      do 135 k=1,3
      do 136 i=1,nsstay
      rtmp(i)=xs(i,k)
  136 continue
      do 137 i=1,nsstay
      xs(i,k)=rtmp(ndx(i))
  137 continue
      do 138 i=1,nsstay
      rtmp(i)=vs(i,k)
  138 continue
      do 139 i=1,nsstay
      vs(i,k)=rtmp(ndx(i))
  139 continue
      if(iguide.gt.0) then
      do 1138 i=1,nsstay
      rtmp(i)=gs(i,k)
 1138 continue
      do 1139 i=1,nsstay
      gs(i,k)=rtmp(ndx(i))
 1139 continue
      endif
  135 continue
      do 149 k=1,mis2
      do 150 i=1,nsstay
      itmp(i)=isl(i,k)
  150 continue
      do 151 i=1,nsstay
      isl(i,k)=itmp(ndx(i))
  151 continue
  149 continue
c
      endif
c
      do 200 i=1,ipl(1,1)
      ipl(30+i,2)=0
      ipl(30+i,3)=0
      ipl(30+i,4)=0
      ipl(30+i,5)=0
  200 continue
c
      do 201 i=1,ipl(1,1)
      nrbox=ipl(30+i,1)
      if(nwstay.gt.0) then
      do 202 iwm=1,nwstay
      if(iwl(iwm,lwbox).eq.nrbox) then
      if(ipl(30+i,2).eq.0) ipl(30+i,2)=iwm
      ipl(30+i,3)=iwm
      endif
  202 continue
      endif
      if(nsstay.gt.0) then
      do 203 isa=1,nsstay
      if(isl(isa,lsbox).eq.nrbox) then
      if(ipl(30+i,4).eq.0) ipl(30+i,4)=isa
      ipl(30+i,5)=isa
      endif
  203 continue
      endif
  201 continue
c
      nwmloc=nwstay
      ipl(1,2)=nwmloc
      nsaloc=nsstay
      ipl(2,2)=nsaloc
c
      call ga_igop(msp_23,nfold,1,'+')
      lpbc9=nfold.gt.0
c
      return
      end
c $Id: argos_space_trvl.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdtq_lr_alpha_15_18_4_1(d_a,k_a_offset,d_b,k_b_offset
     &,d_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_18_4_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h4 h12 p17 p1 p2 p3 )_yt + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p17 h9 h10 )_t * y ( h4 h9 h10 h12 p1 p2 p3 p7 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p17b
      INTEGER h4b
      INTEGER h12b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h9b
      INTEGER h10b
      INTEGER p17b_1
      INTEGER p7b_1
      INTEGER h9b_1
      INTEGER h10b_1
      INTEGER h4b_2
      INTEGER h12b_2
      INTEGER h9b_2
      INTEGER h10b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p17b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h12b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h12b-
     &1)+int_mb(k_spin+p17b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)
     &+int_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+p17b-
     &1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h12b-1),ieor(int_mb
     &(k_sym+p17b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),i
     &nt_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_t)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h12b-1) * int_mb(k_r
     &ange+p17b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int
     &_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_18_4_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h10b = h9b,noab
      IF (int_mb(k_spin+p17b-1)+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+
     &h9b-1)+int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p17b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb
     &(k_sym+h9b-1),int_mb(k_sym+h10b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p17b,p7b,h9b,h10b,p17b_1,p7b_1,h9b_1,h10b_1)
      CALL TCE_RESTRICTED_8(h4b,h12b,h9b,h10b,p1b,p2b,p3b,p7b,h4b_2,h12b
     &_2,h9b_2,h10b_2,p1b_2,p2b_2,p3b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+h9b-1) * int_m
     &b(k_range+h10b-1)
      dima_sort = int_mb(k_range+p17b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h12b-1) * int_m
     &b(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_18_4_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_18_4_1',2,MA_ERR)
      IF ((p7b .le. p17b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p17b_1 - noab - 1 + nvab * (p7
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p17b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),2,4,3,1,1.0d0)
      END IF
      IF ((p17b .lt. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h9b_1 - 1 + noab * (p7b_1 - noab - 1 + nvab * (p17
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p17b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),1,4,3,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_18_4_
     &1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_18_4_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_18_4_1',5,MA_ERR)
      IF ((h10b .lt. h4b) .and. (p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p7b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h4b_2 - 
     &1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h4b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((h10b .lt. h4b) .and. (p1b .le. p7b) .and. (p7b .lt. p2b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h4b_2 - 
     &1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h4b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,4,3,2,1,6,1.0d0)
      END IF
      IF ((h10b .lt. h4b) .and. (p2b .le. p7b) .and. (p7b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h4b_2 - 
     &1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h4b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p7b-
     &1),int_mb(k_range+p3b-1),8,6,5,4,3,2,1,7,-1.0d0)
      END IF
      IF ((h10b .lt. h4b) .and. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h4b_2 - 
     &1 + noab * (h10b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h4b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p7b-1),7,6,5,4,3,2,1,8,1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h4b .le. h10b) .and. (h10b .le. h12b) .a
     &nd. (p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p7b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,4,2,3,1,5,1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h4b .le. h10b) .and. (h10b .le. h12b) .a
     &nd. (p1b .le. p7b) .and. (p7b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,4,2,3,1,6,-1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h4b .le. h10b) .and. (h10b .le. h12b) .a
     &nd. (p2b .le. p7b) .and. (p7b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p7b-
     &1),int_mb(k_range+p3b-1),8,6,5,4,2,3,1,7,1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h4b .le. h10b) .and. (h10b .le. h12b) .a
     &nd. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p7b-1),7,6,5,4,2,3,1,8,-1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h12b .lt. h10b) .and. (p7b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p7b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,3,2,4,1,5,-1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h12b .lt. h10b) .and. (p1b .le. p7b) .an
     &d. (p7b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,3,2,4,1,6,1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h12b .lt. h10b) .and. (p2b .le. p7b) .an
     &d. (p7b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p7b-
     &1),int_mb(k_range+p3b-1),8,6,5,3,2,4,1,7,-1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (h12b .lt. h10b) .and. (p3b .le. p7b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p7b-1),7,6,5,3,2,4,1,8,1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h10b .le. h12b) .and. (p7b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p7b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,4,1,3,2,5,-1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h10b .le. h12b) .and. (p1b .le. p7b) .an
     &d. (p7b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,4,1,3,2,6,1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h10b .le. h12b) .and. (p2b .le. p7b) .an
     &d. (p7b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p7b-
     &1),int_mb(k_range+p3b-1),8,6,5,4,1,3,2,7,-1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h10b .le. h12b) .and. (p3b .le. p7b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h12b_2 - 1 + noab * (h10b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h10b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p7b-1),7,6,5,4,1,3,2,8,1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h9b .le. h12b) .and. (h12b .lt. h10b) .a
     &nd. (p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p7b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,3,1,4,2,5,1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h9b .le. h12b) .and. (h12b .lt. h10b) .a
     &nd. (p1b .le. p7b) .and. (p7b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,3,1,4,2,6,-1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h9b .le. h12b) .and. (h12b .lt. h10b) .a
     &nd. (p2b .le. p7b) .and. (p7b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p7b-
     &1),int_mb(k_range+p3b-1),8,6,5,3,1,4,2,7,1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h9b .le. h12b) .and. (h12b .lt. h10b) .a
     &nd. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h12b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p7b-1),7,6,5,3,1,4,2,8,-1.0d0)
      END IF
      IF ((h12b .lt. h9b) .and. (p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p7b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,6,2,1,4,3,5,-1.0d0)
      END IF
      IF ((h12b .lt. h9b) .and. (p1b .le. p7b) .and. (p7b .lt. p2b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p3b-1),8,7,5,2,1,4,3,6,1.0d0)
      END IF
      IF ((h12b .lt. h9b) .and. (p2b .le. p7b) .and. (p7b .lt. p3b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p7b-
     &1),int_mb(k_range+p3b-1),8,6,5,2,1,4,3,7,-1.0d0)
      END IF
      IF ((h12b .lt. h9b) .and. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h10b_2 - 1 + noab * (h9b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h9b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),int_mb(k_range+p7b-1),7,6,5,2,1,4,3,8,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_18_4_
     &1',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h9b .eq. h10b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &18_4_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &18_4_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_18_4_1',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h12b-1
     &),int_mb(k_range+h4b-1),int_mb(k_range+p17b-1),5,4,6,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (p1b - noab - 1 + nvab
     & * (p17b - noab - 1 + nvab * (h12b - 1 + noab * (h4b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_18_4_
     &1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &18_4_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine smd_leapf(natms,tstep,ekin,mass,fff,vvv,ccc)

      implicit none

      integer natms
      double precision tstep
      double precision ekin
      double precision mass(natms)
      double precision fff(3,natms)
      double precision vvv(3,natms)
      double precision ccc(3,natms)
c
      integer i,iatm

      double precision  tmpvx,tmpvy,tmpvz

      ekin=0.0

      do i=1,natms
       tmpvx=vvv(1,i)
       tmpvy=vvv(2,i)
       tmpvz=vvv(3,i)

       vvv(1,i)=vvv(1,i)+fff(1,i)*tstep/mass(i)
       vvv(2,i)=vvv(2,i)+fff(2,i)*tstep/mass(i)
       vvv(3,i)=vvv(3,i)+fff(3,i)*tstep/mass(i)

       tmpvx=0.5*(tmpvx+vvv(1,i))
       tmpvy=0.5*(tmpvy+vvv(2,i))
       tmpvz=0.5*(tmpvz+vvv(3,i))

       ekin=ekin+mass(i)*(tmpvx**2+tmpvy**2+tmpvz**2)

       ccc(1,i)=ccc(1,i)+tstep*vvv(1,i)
       ccc(2,i)=ccc(2,i)+tstep*vvv(2,i)
       ccc(3,i)=ccc(3,i)+tstep*vvv(3,i)
       
      enddo 

      ekin=0.5*ekin

      return

      end

c $Id: smd_leapf.F 21176 2011-10-10 06:35:49Z d3y133 $

c
c $Id: model_potential.F 21286 2011-10-25 01:09:01Z bylaska $
c

*     **********************************
*     *	                               *
*     *    Model_Potential_init        *
*     *                                *
*     **********************************

*   This reads in Gaussian Basis and initializes
*  variables for the SR contribution 
*
      subroutine Model_Potential_init(rtdb)
      implicit none
      integer rtdb

#include "errquit.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "mafdecls.fh"

***** Mode Potential common block *****
#include "model_potential.fh"

*     **** local variables ***
      logical value
      integer taskid
      integer MASTER
      parameter(MASTER=0)

      integer i,ia,element_length,basis_length
      real*8 sqrtpi
      character*4 element
      character*30 rtdb_name
      integer count,tmp(2)

*     **** external functions ****
      character*2 pspw_qmmm_atom
      integer     pspw_qmmm_nkatm
      real*8      pspw_Q_zv_MM
      external    pspw_qmmm_atom
      external    pspw_qmmm_nkatm
      external    pspw_Q_zv_MM




      call Parallel_taskid(taskid)
      value = rtdb_parallel(.true.)


*     ***************************
*     **** read in lr_cutoff ****
*     ***************************

*     **** Allocate Memory from heap ****
      count = pspw_qmmm_nkatm()
      value = MA_alloc_get(mt_dbl,count,'lr_cutoff',
     >                       lr_cutoff(2),lr_cutoff(1))

*     **** read lr_cutoff from rtdb ****
      do ia=1,pspw_qmmm_nkatm()
        element = '    '
        element = pspw_qmmm_atom(ia)

        element_length = index(element,' ') - 1
        rtdb_name = 'pspw_lr_cutoff:'//element(1:element_length)
        if (.not.rtdb_get(rtdb,rtdb_name,
     >                   mt_dbl,1,
     >                   dbl_mb(lr_cutoff(1)+ia-1))) then
           dbl_mb(lr_cutoff(1)+ia-1) = 1.0d0
        end if
      end do

      if (taskid.eq.MASTER) then
        write(luout,*)
        write(luout,*) "Model Potential - Long-Range Potential   "
        write(luout,*) "-----------------------------------------"
        write(luout,*)
        write(luout,'  (A15,2x,A15,2x,A4)') "q","rcut","atom"
        do ia=1,pspw_qmmm_nkatm()
           write(luout,'  (E15.6,2x,E15.6,2x,A4)') 
     >         pspw_Q_zv_MM(ia),
     >         dbl_mb(lr_cutoff(1)+ia-1),
     >         pspw_qmmm_atom(ia)
        end do
        write(luout,*)
      end if


*     **************************
*     **** read in SR Basis ****
*     **************************

*     **** determine Nbasis = number of total basis functions ****
      Nbasis = 0
      do ia=1,pspw_qmmm_nkatm()
        element = '    '
        element = pspw_qmmm_atom(ia)

        element_length = index(element,' ') - 1
        rtdb_name = 'pspw_SR_basis_length:'//element(1:element_length)
        if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,basis_length)) then
          basis_length = 0
        end if
        Nbasis = Nbasis + basis_length
      end do

      if (Nbasis.gt.0) then

*       **** Allocate Memory from heap ****
        value = MA_alloc_get(mt_int,Nbasis,'iatom',
     >                       iatom(2),iatom(1))
        value = value.and.
     >          MA_alloc_get(mt_dbl,Nbasis,'c',c(2),c(1))
        value = value.and.
     >          MA_alloc_get(mt_dbl,Nbasis,'g',g(2),g(1))
        value = value.and.
     >          MA_alloc_get(mt_dbl,Nbasis,'coeff',coeff(2),coeff(1))
        if (.not. value) 
     >   call errquit('Model_Potentail_init:out of heap memory',0,
     &       MA_ERR)


*       **** Read basis from rtdb ****
        count = 0
        do ia=1,pspw_qmmm_nkatm()
          element = '    '
          element = pspw_qmmm_atom(ia)

          element_length = index(element,' ') - 1
          rtdb_name = 'pspw_SR_basis_length:'//element(1:element_length)
          if (.not.rtdb_get(rtdb,rtdb_name,mt_int,1,basis_length)) then
            basis_length = 0
          end if

          if (basis_length.gt.1) then
            value = value.and.
     >         MA_push_get(mt_dbl,(2*basis_length),'tmp',tmp(2),tmp(1))
              if (.not. value)
     >         call errquit(
     >        'Model_Potential_init:failed pushing stack:',0, MA_ERR)

            rtdb_name = 'pspw_SR_basis:'//element(1:element_length)
            value = rtdb_get(rtdb,rtdb_name,
     >                 mt_dbl,(2*basis_length),dbl_mb(tmp(1)))


            do i=1,basis_length
              int_mb(iatom(1)+count+i-1) = ia
              dbl_mb(c(1)    +count+i-1) = dbl_mb(tmp(1)+2*(i-1)  )
              dbl_mb(g(1)    +count+i-1) = dbl_mb(tmp(1)+2*(i-1)+1) 
            end do
            value = MA_pop_stack(tmp(2))
            if (.not. value)
     >       call errquit(
     >      'Model_Potential_init:failed popping stack:',0, MA_ERR)
          end if

          count = count + basis_length
        end do

        if (taskid.eq.MASTER) then
           write(luout,*)
           write(luout,*) "Model Potential - Gaussian Basis   "
           write(luout,*) "-----------------------------------"
           write(luout,*)
           write(luout,'  (A15,2x,A15,2x,A4)') "coeff","exponent","atom"
           do i=1,Nbasis
              write(luout,'  (E15.6,2x,E15.6,2x,A4)') 
     >            dbl_mb(c(1)+i-1),
     >            dbl_mb(g(1)+i-1),
     >            pspw_qmmm_atom(int_mb(iatom(1)+i-1))
           end do
           write(luout,*)
        end if

         sqrtpi = dsqrt(4.0d0*datan(1.0d0))
         do i=1,Nbasis
            dbl_mb(coeff(1)+i-1) = dbl_mb(c(1)+i-1)
     >                           * (1.0d0/(sqrtpi*dbl_mb(g(1)+i-1)))**3
            dbl_mb(g(1)+i-1) = 1.0d0/dbl_mb(g(1)+i-1)**2
         end do

      end if


      return
      end

*     **********************************
*     *	                               *
*     *     Model_Potential_end	       *
*     *                                *
*     **********************************

      subroutine Model_Potential_end()

#include "mafdecls.fh"

***** Mode Potential common block *****
#include "model_potential.fh"

*     **** local variables ***
      logical value

      value = MA_free_heap(lr_cutoff(2))
      if (Nbasis.gt.0) then
         value = value.and.MA_free_heap(iatom(2))
         value = value.and.MA_free_heap(c(2))
         value = value.and.MA_free_heap(g(2))
         value = value.and.MA_free_heap(coeff(2))
      end if
      if (.not.value) call errquit('error MA_free_heap',0, MA_ERR)

      return
      end




*     **********************************
*     *	                               *
*     *   Model_Potential_Generate_V   *
*     *                                *
*     **********************************

*   This routine calculate the Model Potential
*
      subroutine Model_Potential_Generate_V(n2ft3d,rgrid,Vqm)
      implicit none
      integer n2ft3d
      real*8 rgrid(3,n2ft3d)
      real*8 Vqm(n2ft3d)

#include "mafdecls.fh"

***** Mode Potential common block *****
#include "model_potential.fh"


*     **** local variables ****
      integer ii,i,k,ia
      real*8 r1(3)
      real*8 q,d,d2,rcut
      real*8 sqrtpi

*     **** external functions ****
      integer  pspw_qmmm_katm,pspw_qmmm_nion
      real*8   pspw_qmmm_rion,pspw_Q_zv_MM,util_erf
      external pspw_qmmm_katm,pspw_qmmm_nion
      external pspw_qmmm_rion,pspw_Q_zv_MM,util_erf


      sqrtpi = dsqrt(4.0d0*datan(1.0d0))

      do ii=1,pspw_qmmm_nion()
         r1(1) = pspw_qmmm_rion(1,ii)
         r1(2) = pspw_qmmm_rion(2,ii)
         r1(3) = pspw_qmmm_rion(3,ii)
         ia =pspw_qmmm_katm(ii)

*        **** Add the SR contribution to the model potential ****
         do i=1,Nbasis
           if (int_mb(iatom(1)+i-1).eq.ia) then
             do k=1,n2ft3d
                d2 = (rgrid(1,k)-r1(1))**2 
     >             + (rgrid(2,k)-r1(2))**2
     >             + (rgrid(3,k)-r1(3))**2 

                Vqm(k) = Vqm(k) 
     >                 + dbl_mb(coeff(1)+i-1)*dexp(-d2*dbl_mb(g(1)+i-1))
             end do
           end if
         end do


*        **** Add the LR contribution to the Model Potential ****
*        **** get charges from pspw_Q data structure         ****
         q    = pspw_Q_zv_MM(ia)
         rcut = dbl_mb(lr_cutoff(1)+ia-1)
         if (abs(q).gt.0.0d0) then
           do k=1,n2ft3d
             d = dsqrt( (rgrid(1,k)-r1(1))**2
     >                + (rgrid(2,k)-r1(2))**2
     >                + (rgrid(3,k)-r1(3))**2)

             if (d.gt.small) then
               Vqm(k) = Vqm(k) - q*util_erf(d/rcut)/d
             else
               Vqm(k) = Vqm(k) - 2.0d0*q/(sqrtpi*rcut)
             end if
           end do
        end if


      end do

      return 
      end


*     **********************************
*     *	                               *
*     *      Model_Potential_Fmm       *
*     *                                *
*     **********************************

*     This routine calculates the force on the MM ions from the
*   Model potential interaction with the QM density and adds it
*   to the MM ion force, f_mm.
*
*     Exit - f_mm: force on the MM ions
*
*     Uses - pspw_qmmm_nion,pspw_qmmm_rion
*
*     Author - Eric Bylaska
*
      subroutine Model_Potential_Fmm(n2ft3d,rgrid,rho,dv,f_mm)
      implicit none
      integer n2ft3d
      real*8  rgrid(3,*),rho(*)
      real*8  dv

      real*8 f_mm(3,*)

#include "mafdecls.fh"

***** Mode Potential common block *****
#include "model_potential.fh"

*     **** local variables ****
      integer ii,i,k,ia
      real*8  r1(3),ftmp(3),desr
      real*8  x,y,z,d2,d
      real*8  q,rcut,sqrtpi

*     **** external functions ****
      integer  pspw_qmmm_katm,pspw_qmmm_nion
      real*8   pspw_qmmm_rion,pspw_Q_zv_MM,util_erf
      external pspw_qmmm_katm,pspw_qmmm_nion
      external pspw_qmmm_rion,pspw_Q_zv_MM,util_erf


      sqrtpi = dsqrt(4.0d0*datan(1.0d0))
      do ii=1,pspw_qmmm_nion()
         r1(1) = pspw_qmmm_rion(1,ii)
         r1(2) = pspw_qmmm_rion(2,ii)
         r1(3) = pspw_qmmm_rion(3,ii)
         ia =pspw_qmmm_katm(ii)

         call dcopy(3,0.0d0,0,ftmp,1)

*        **** Add the SR contribution ****
         do i=1,Nbasis
           if (int_mb(iatom(1)+i-1).eq.ia) then
             do k=1,n2ft3d
                x = (rgrid(1,k)-r1(1))
                y = (rgrid(2,k)-r1(2))
                z = (rgrid(3,k)-r1(3))
                d2 = (x*x+y*y+z*z)

                desr = dv*rho(k)
     >                 * dbl_mb(coeff(1)+i-1)
     >                 * dexp(-d2*dbl_mb(g(1)+i-1))
     >                 * (-2.0d0*dbl_mb(g(1)+i-1))
                ftmp(1) = ftmp(1) + x*desr
                ftmp(2) = ftmp(2) + y*desr
                ftmp(3) = ftmp(3) + z*desr
             end do
           end if
         end do

*        **** Add the LR contribution ****
         q    = pspw_Q_zv_MM(ia)
         rcut = dbl_mb(lr_cutoff(1)+ia-1)
         if (abs(q).gt.0.0d0) then
           do k=1,n2ft3d
             x = (rgrid(1,k)-r1(1))
             y = (rgrid(2,k)-r1(2))
             z = (rgrid(3,k)-r1(3))
             d = dsqrt(x*x+y*y+z*z)
             if (d.gt.small) then
                desr = dv*rho(k)*q
     >                 * ((-2.0d0/sqrtpi)
     >                     *(d/rcut)
     >                     *dexp(-(d/rcut)**2)
     >                   + util_erf((d/rcut)))
     >                 /(d**3)
                ftmp(1) = ftmp(1) + x*desr
                ftmp(2) = ftmp(2) + y*desr
                ftmp(3) = ftmp(3) + z*desr
             end if
           end do
        end if


*        **** add all force contributions and add to f_mm ****
         call D3dB_Vector_SumAll(3,ftmp)
         f_mm(1,ii) = f_mm(1,ii) + ftmp(1)
         f_mm(2,ii) = f_mm(2,ii) + ftmp(2)
         f_mm(3,ii) = f_mm(3,ii) + ftmp(3)


      end do

      return
      end

      SUBROUTINE mp4_1pdm_pp_mo_III_b(d_i0,d_t2,d_y2,k_i0_offset,k_t2_of
     &fset,k_y2_offset)
C     $Id: mp4_1pdm_pp_mo_III_b.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 )_ty + = 1/2 * Sum ( p5 h3 h4 ) * t ( p1 p5 h3 h4 )_t * y ( h3 h4 p2 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      CALL mp4_1pdm_pp_mo_III_b_1(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i0
     &,k_i0_offset)
      RETURN
      END
      SUBROUTINE mp4_1pdm_pp_mo_III_b_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: mp4_1pdm_pp_mo_III_b.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 )_ty + = 1/2 * Sum ( p5 h3 h4 ) * t ( p1 p5 h3 h4 )_t * y ( h3 h4 p2 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b_1
      INTEGER p5b_1
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p2b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &t,irrep_y)) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mp4_1pdm_pp_mo_III_b_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h3b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p1b,p5b,h3b,h4b,p1b_1,p5b_1,h3b_1,h4b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,p2b,p5b,h3b_2,h4b_2,p2b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h3b-1) * int_m
     &b(k_range+h4b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mp4_1pdm_pp_mo_III_b_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mp4_1pdm_pp_mo_III_b_1',2,MA_ERR)
      IF ((p5b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p1b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mp4_1pdm_pp_mo_III_b_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mp4_1pdm_pp_mo_III_b_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mp4_1pdm_pp_mo_III_b_1',5,MA_ERR)
      IF ((p5b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mp4_1pdm_pp_mo_III_b_1',
     &6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h3b .eq. h4b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mp4_1pdm_pp_mo_III_
     &b_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mp4_1pdm_pp_mo_III_
     &b_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mp4_1pdm_pp_mo_III_b_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mp4_1pdm_pp_mo_III_b_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mp4_1pdm_pp_mo_III_
     &b_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      logical function pre_rtdbin(irtdb,title,
     + source,sysnam,calc,slvnam,slvmdl,
     + newtop,newseq,newrst,mcount,ncount,icount,
     + mgrid,nrgrid,iogrid,rogrid,gdist,mnoe,mpmf,
     + maxscf,qscale,
     + altloc,chain,icyren,iconst,model,nxlnk,mdold,ignore,scount,
     + fcount,mfract,nfract,ifract,scale,cpk,his,itopol,icomb)
c
c $Id: pre_rtdbin.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     function to read input for prepare module from rtdb
c
      implicit none
c
      logical util_nwchemrc_get,pre_paths,pre_paths2
      external util_nwchemrc_get,pre_paths,pre_paths2
c
#include "rtdb.fh"
#include "mafdecls.fh"
#include "pre_common.fh"
c
      integer irtdb,mcount,ncount
      character*3 slvnam
      character*80 source
      character*80 sysnam,calc,title(2,3)
      character*10 slvmdl
      integer newtop,newseq,newrst,icount(mcount),icyren,ignore
      integer len,ndx,mgrid,mnoe,mpmf,maxscf,model,nxlnk,mdold
      integer mfract,nfract,iconst,itopol,icomb
      integer ifract(mfract)
      real*8 gdist,qscale
      character*1 altloc,chain,his
      character*4 scount(mcount)
      real*8 fcount
      real*8 scale,cpk
      integer i,j,nrgrid,iogrid(5),rogrid(2,5)
c
      character*255 key,value
c
      ffield=' '
c
      key='ffield '
      if(util_nwchemrc_get(key,value)) then
      ffield=value(1:index(value,' ')-1)
      if(.not.pre_paths())
     + call md_abort('Error reading path info from .nwchemrc',0)
      endif
c
      source=' '
c
      do 1 i=1,2
      do 2 j=1,3
      title(i,j)=' '
    2 continue
    1 continue
c
c     read from rtdb
c     --------------
c
      if(.not.rtdb_cget(irtdb,'prep:title',6,title)) continue

      if(rtdb_cget(irtdb,'prep:ffield',1,ffield)) then
      if(.not.pre_paths())
     + call md_abort('Error reading path info from .nwchemrc',0)
      endif
c
      if(.not.pre_paths2(irtdb)) call md_abort('prepaths2 ',0)
c
      if(.not.rtdb_cget(irtdb,'prep:sysnam',1,sysnam)) then
      if(.not.rtdb_cget(irtdb,'arg:project',1,sysnam)) then
      if(.not.rtdb_cget(irtdb,'file_prefix',1,sysnam))
     + call md_abort('rtdb_get failed on sysnam',9999)
      endif
      endif
c
      if(.not.rtdb_cget(irtdb,'prep:source',1,source)) source=' '
c
      if(.not.rtdb_cget(irtdb,'prep:slvnam',1,slvnam)) slvnam='HOH'
      if(.not.rtdb_cget(irtdb,'prep:slvmdl',1,slvmdl)) slvmdl=' '
c
      mdold=0
      if(.not.rtdb_get(irtdb,'md:mdold',mt_int,1,mdold)) mdold=0
c
      if(.not.rtdb_get(irtdb,'prep:newtop',mt_int,1,newtop)) newtop=0
      if(.not.rtdb_get(irtdb,'prep:newseq',mt_int,1,newseq)) newseq=0
      if(.not.rtdb_get(irtdb,'prep:newrst',mt_int,1,newrst)) newrst=0
c
      if(.not.rtdb_get(irtdb,'prep:nfract',mt_int,1,nfract)) nfract=0
      if(nfract.gt.0) then
      if(.not.rtdb_get(irtdb,'prep:ifract',mt_int,nfract,ifract))
     + call md_abort('Fraction input problem',0)
      endif
c
      if(.not.rtdb_get(irtdb,'prep:ncount',mt_int,1,ncount)) ncount=0
      if(ncount.gt.0) then
      if(.not.rtdb_get(irtdb,'prep:icount',mt_int,ncount,icount))
     + call md_abort('Counter ion input problem',0)
      if(.not.rtdb_cget(irtdb,'prep:scount',ncount,scount))
     + call md_abort('Counter ion input problem',0)
      endif
      if(.not.rtdb_get(irtdb,'prep:fcount',mt_dbl,1,fcount))
     + call md_abort('Counter ion input problem',0)
      if(.not.rtdb_get(irtdb,'prep:mgrid',mt_int,1,mgrid)) mgrid=24
      if(.not.rtdb_get(irtdb,'prep:nrgrid',mt_int,1,nrgrid)) nrgrid=0
      if(nrgrid.gt.0) then
      if(.not.rtdb_get(irtdb,'prep:iogrid',mt_int,nrgrid,iogrid))
     + call md_abort('pre_rtdb: rtdb_get failed',0)
      if(.not.rtdb_get(irtdb,'prep:rogrid',mt_int,2*nrgrid,rogrid))
     + call md_abort('pre_rtdbin: rtdb_get failed',0)
      endif
      if(.not.rtdb_get(irtdb,'prep:rgrid',mt_dbl,1,gdist)) gdist=0.2d0
c
      if(.not.rtdb_get(irtdb,'prep:mnoe',mt_int,1,mnoe)) mnoe=0
c
      if(.not.rtdb_get(irtdb,'prep:mpmf',mt_int,1,mpmf)) mpmf=0
c
      if(.not.rtdb_get(irtdb,'prep:itopol',mt_int,1,itopol)) itopol=0
c
      if(.not.rtdb_get(irtdb,'prep:icomb',mt_int,1,icomb)) icomb=0
c
      if(.not.rtdb_get(irtdb,'prep:ignore',mt_int,1,ignore)) ignore=0
c
      if(.not.rtdb_get(irtdb,'prep:maxscf',mt_int,1,maxscf)) maxscf=20
      if(.not.rtdb_get(irtdb,'prep:qscale',mt_dbl,1,qscale))
     + qscale=1.0d0
c
      if(.not.rtdb_get(irtdb,'prep:nxlnk',mt_int,1,nxlnk)) nxlnk=1
c
      if(.not.rtdb_cget(irtdb,'prep:altloc',1,altloc)) altloc='A'
      if(.not.rtdb_cget(irtdb,'prep:chain',1,chain)) chain='A'
      if(.not.rtdb_cget(irtdb,'prep:his',1,his)) his=' '
c
      if(.not.rtdb_get(irtdb,'prep:model',mt_int,1,model)) model=0
c
      if(.not.rtdb_get(irtdb,'prep:icyren',mt_int,1,icyren)) icyren=0
      if(.not.rtdb_get(irtdb,'prep:iconst',mt_int,1,iconst)) iconst=0
c
      if(.not.rtdb_get(irtdb,'prep:scale',mt_dbl,1,scale)) scale=1.0d0
      if(.not.rtdb_get(irtdb,'prep:cpk',mt_dbl,1,cpk)) cpk=0.0d0
c
      if(slvnam.eq.'HOH'.and.slvmdl(1:1).eq.' ') slvmdl='spce      '
c
      ndx=index(sysnam,'_')
      len=index(sysnam,' ')
      if(ndx.gt.1.and.ndx.lt.len-1) then
      calc=sysnam(ndx+1:len)
      sysnam=sysnam(1:ndx-1)//' '
      else
      calc='md '
      endif
c
      if(newseq.eq.1) newtop=1
c
c     get defaults for unspecified variables from $HOME/.nwchemrc
c     -----------------------------------------------------------
c
      key='histidine'
      if(his.eq.' ') then
      if(util_nwchemrc_get(key,value)) then
      if(value(1:3).eq.'HID') his='D'
      if(value(1:3).eq.'HIE') his='E'
      if(value(1:3).eq.'HIP') his='P'
      else
      his='E'
      endif
      endif
c
      lqhopmem=.false.
c
      call qhop_alloc()
      pre_rtdbin=.true.
      return
      end

      SUBROUTINE inte_leapf(tstep,ekin)

      implicit none

      include 'p_array.inc'
      include 'cm_atom.inc'
      include 'cm_latt.inc'

      integer i,iatm

      real*8  ekin,tmpvx,tmpvy,tmpvz,tstep

      ekin=0.0

      do i=1,natms

       iatm=atmtype(i)

       tmpvx=vvv(i,1)
       tmpvy=vvv(i,2)
       tmpvz=vvv(i,3)

       vvv(i,1)=vvv(i,1)+fff(i,1)*tstep/typmass(iatm)
       vvv(i,2)=vvv(i,2)+fff(i,2)*tstep/typmass(iatm)
       vvv(i,3)=vvv(i,3)+fff(i,3)*tstep/typmass(iatm)

       tmpvx=0.5*(tmpvx+vvv(i,1))
       tmpvy=0.5*(tmpvy+vvv(i,2))
       tmpvz=0.5*(tmpvz+vvv(i,3))

       ekin=ekin+typmass(iatm)*(tmpvx**2+tmpvy**2+tmpvz**2)

       ccc(i,1)=ccc(i,1)+tstep*vvv(i,1)
       ccc(i,2)=ccc(i,2)+tstep*vvv(i,2)
       ccc(i,3)=ccc(i,3)+tstep*vvv(i,3)

      enddo 

      call tool_rebox(natms,mxatms,latt,rlatt,ccc) 

      ekin=0.5*ekin

      return

      END
c $Id: inte_leapf.f 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine hnd_giaotv10(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     & expj,coefj,j_nprim,j_ngen,Lj,coord,zan,nat,nint,tv10,scr,lscr)
c
c $Id: hnd_giaotv10.F 21348 2011-10-31 22:51:25Z d3p852 $
c
c     ----- Wrapper routine that sets the sizes of scratch blocks -----
c
      implicit double precision (a-h,o-z)
#include "hnd_pointers.fh"
      dimension scr(lscr)
      dimension xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension tv10(nint,3),coord(3,nat),zan(nat)
c
c Use scratch for temps in integral calculation
c Scratch needs are
c 6*(Li+2)*(Lj+3) + 6*(Li+2)*(Lj+1)*((Li+Lj+1)/2+1)
c
c The pointers are defined in hdn_pointers.fh
c
      call hnd_giaotv101(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,expj,
     1 coefj,j_nprim,j_ngen,Lj,coord,zan,nat,nint,tv10,scr(gh01(1)),
     2 scr(gh01(12)),scr(gh01(2)),scr(gh01(3)),scr(gh01(4)),
     3 scr(gh01(5)),scr(gh01(6)),scr(gh01(7)),scr(gh01(8)),scr(gh01(9)),
     4 scr(gh01(10)),scr(gh01(11)))
c
      return
      end
c
      subroutine hnd_giaotv101(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     1                 expj,coefj,j_nprim,j_ngen,Lj,coord,zan,nat,nint,
     2                 tv10,xs,ys,zs,xxs,yys,zzs,xv,yv,zv,xxv,yyv,zzv)
      implicit double precision (a-h,o-z)
#include "nwc_const.fh"
#include "hnd_rys.fh"
#include "hnd_tol.fh"
#include "stdio.fh"
      integer NoKinetic             ! FA-11-08-10
      common /skipKinetic/NoKinetic ! FA-11-08-10

      common/hnd_xyzder/xint,yint,zint,t,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     1                  ni,nj,ccx,ccy,ccz
      dimension Nxyz(3),xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension tv10(nint,3),coord(3,nat),zan(nat)
      dimension  xs(Li+2,Lj+3),ys(Li+2,Lj+3),zs(Li+2,Lj+3)
      dimension  xv(Li+2,Lj+1,*),yv(Li+2,Lj+1,*),zv(Li+2,Lj+1,*)
      dimension xxs(Li+2,Lj+3),yys(Li+2,Lj+3),zzs(Li+2,Lj+3)
      dimension xxv(Li+2,Lj+1,*),yyv(Li+2,Lj+1,*),zzv(Li+2,Lj+1,*)
      data rln10  /2.30258d+00/
      data pi212  /1.1283791670955d+00/
c
      tol=rln10*itol
c
c     Zero integral array
c
      call dcopy(nint*3,0.0d0,0,tv10,1)
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi = lit*(lit+1)/2
      litmod=lit+1
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj = ljt*(ljt+1)/2
      ljtmod=ljt+2
c
      qijx=yi*zj-zi*yj
      qijy=zi*xj-xi*zj
      qijz=xi*yj-yi*xj
      tijx=xi-xj
      tijy=yi-yj
      tijz=zi-zj
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
c
      nroots=(1+lit+ljt-2)/2+1
      if(nroots.gt.maxrys) then
         write(luout,9997) maxrys,lit,ljt,nroots
         call errquit('hnd_giaotv10: need higher Rys rt',nroots,INT_ERR)
      endif
c
c     ----- i primitive -----
c
      do ig=1, i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=1.0d0/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) goto 1000
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      cij=csi*csj*fac
c
c     ----- kinetic energy -----
c
      if (NoKinetic .eq. 1) goto 20 ! SKIP KINETIC ENERGY-FA-11-08-10
      t = sqrt(aa1)
      x0=ax
      y0=ay
      z0=az
      do j=1,ljtmod
         nj=j
         do i=1,litmod
            ni=i
            call hnd_sxyz
            xs(i,j)=xint*t
            ys(i,j)=yint*t
            zs(i,j)=zint*t
         enddo
         do i=1,lit
            xxs(i,j)=xs(i+1,j)
            yys(i,j)=ys(i+1,j)
            zzs(i,j)=zs(i+1,j)
         enddo
      enddo
c
      do i=1,lit
         xv(i,1,1)=(xs(i,1)-xs(i,3)*(aj+aj))*aj
         yv(i,1,1)=(ys(i,1)-ys(i,3)*(aj+aj))*aj
         zv(i,1,1)=(zs(i,1)-zs(i,3)*(aj+aj))*aj
         xxv(i,1,1)=(xxs(i,1)-xxs(i,3)*(aj+aj))*aj
         yyv(i,1,1)=(yys(i,1)-yys(i,3)*(aj+aj))*aj
         zzv(i,1,1)=(zzs(i,1)-zzs(i,3)*(aj+aj))*aj
         if (ljt.gt.1) then
            xv(i,2,1)=(xs(i,2)*dble(2+2-1)-xs(i,4)*(aj+aj))*aj
            yv(i,2,1)=(ys(i,2)*dble(2+2-1)-ys(i,4)*(aj+aj))*aj
            zv(i,2,1)=(zs(i,2)*dble(2+2-1)-zs(i,4)*(aj+aj))*aj
            xxv(i,2,1)=(xxs(i,2)*dble(2+2-1)-xxs(i,4)*(aj+aj))*aj
            yyv(i,2,1)=(yys(i,2)*dble(2+2-1)-yys(i,4)*(aj+aj))*aj
            zzv(i,2,1)=(zzs(i,2)*dble(2+2-1)-zzs(i,4)*(aj+aj))*aj
         endif
         do j=3,ljt
            xv(i,j,1)=(xs(i,j)*dble(j+j-1)-xs(i,j+2)*(aj+aj))*aj
     1                 -xs(i,j-2)*dble(((j-1)*(j-2))/2)
            yv(i,j,1)=(ys(i,j)*dble(j+j-1)-ys(i,j+2)*(aj+aj))*aj
     1                 -ys(i,j-2)*dble(((j-1)*(j-2))/2)
            zv(i,j,1)=(zs(i,j)*dble(j+j-1)-zs(i,j+2)*(aj+aj))*aj
     1                 -zs(i,j-2)*dble(((j-1)*(j-2))/2)
            xxv(i,j,1)=(xxs(i,j)*dble(j+j-1)-xxs(i,j+2)*(aj+aj))*aj
     1                 -xxs(i,j-2)*dble(((j-1)*(j-2))/2)
            yyv(i,j,1)=(yys(i,j)*dble(j+j-1)-yys(i,j+2)*(aj+aj))*aj
     1                 -yys(i,j-2)*dble(((j-1)*(j-2))/2)
            zzv(i,j,1)=(zzs(i,j)*dble(j+j-1)-zzs(i,j+2)*(aj+aj))*aj
     1                 -zzs(i,j-2)*dble(((j-1)*(j-2))/2)
         enddo
      enddo
c
      ij=0
      do j=1,maxj
         call getNxyz(Lj,j,Nxyz)
         jx = Nxyz(1) + 1
         jy = Nxyz(2) + 1
         jz = Nxyz(3) + 1
         do i=1,maxi
            call getNxyz(Li,i,Nxyz)
            ix = Nxyz(1) + 1
            iy = Nxyz(2) + 1
            iz = Nxyz(3) + 1
            dum = xv(ix,jx,1)* ys(iy,jy)  * zs(iz,jz)
     1          + xs(ix,jx)  * yv(iy,jy,1)* zs(iz,jz)
     2          + xs(ix,jx)  * ys(iy,jy)  * zv(iz,jz,1)
            dumx=xxv(ix,jx,1)* ys(iy,jy)  * zs(iz,jz)
     1          +xxs(ix,jx)  * yv(iy,jy,1)* zs(iz,jz)
     2          +xxs(ix,jx)  * ys(iy,jy)  * zv(iz,jz,1)
            dumy= xv(ix,jx,1)*yys(iy,jy)  * zs(iz,jz)
     1          + xs(ix,jx)  *yyv(iy,jy,1)* zs(iz,jz)
     2          + xs(ix,jx)  *yys(iy,jy)  * zv(iz,jz,1)
            dumz= xv(ix,jx,1)* ys(iy,jy)  *zzs(iz,jz)
     1          + xs(ix,jx)  * yv(iy,jy,1)*zzs(iz,jz)
     2          + xs(ix,jx)  * ys(iy,jy)  *zzv(iz,jz,1)
            ij=ij+1
            tv10(ij,1)=tv10(ij,1)+cij*(qijx*dum+tijy*dumz-tijz*dumy)
            tv10(ij,2)=tv10(ij,2)+cij*(qijy*dum+tijz*dumx-tijx*dumz)
            tv10(ij,3)=tv10(ij,3)+cij*(qijz*dum+tijx*dumy-tijy*dumx)
         enddo
      enddo
 20   continue ! SKIP KINETIC ENERGY-FA-11-08-10
c
c     ----- nuclear attraction -----
c
      aax=aa*ax
      aay=aa*ay
      aaz=aa*az
      do ic=1,nat
      znuc=-zan(ic)
      cx=coord(1,ic)
      cy=coord(2,ic)
      cz=coord(3,ic)
      yy=aa*((ax-cx)**2+(ay-cy)**2+(az-cz)**2)
      call hnd_droot
      do iroot=1,nroots
         uu=u9(iroot)*aa
         ww=w9(iroot)*znuc
         tt=1.0d0/(aa+uu)
         t = sqrt(tt)
         x0=(aax+uu*cx)*tt
         y0=(aay+uu*cy)*tt
         z0=(aaz+uu*cz)*tt
         do j=1,ljt
            nj=j
            do i=1,litmod
               ni=i
               call hnd_sxyz
               xv(i,j,iroot)=xint
               yv(i,j,iroot)=yint
               zv(i,j,iroot)=zint*ww
            enddo
            do i=1,lit
               xxv(i,j,iroot)=xv(i+1,j,iroot)
               yyv(i,j,iroot)=yv(i+1,j,iroot)
               zzv(i,j,iroot)=zv(i+1,j,iroot)
            enddo
         enddo
      enddo
c
      ij=0
      do j=1,maxj
         call getNxyz(Lj,j,Nxyz)
         jx = Nxyz(1) + 1
         jy = Nxyz(2) + 1
         jz = Nxyz(3) + 1
         do i=1,maxi
            call getNxyz(Li,i,Nxyz)
            ix = Nxyz(1) + 1
            iy = Nxyz(2) + 1
            iz = Nxyz(3) + 1
            dum =0.0d0
            dumx=0.0d0
            dumy=0.0d0
            dumz=0.0d0
            do iroot=1,nroots
            dum =dum + xv(ix,jx,iroot)* yv(iy,jy,iroot)* zv(iz,jz,iroot)
            dumx=dumx+xxv(ix,jx,iroot)* yv(iy,jy,iroot)* zv(iz,jz,iroot)
            dumy=dumy+ xv(ix,jx,iroot)*yyv(iy,jy,iroot)* zv(iz,jz,iroot)
            dumz=dumz+ xv(ix,jx,iroot)* yv(iy,jy,iroot)*zzv(iz,jz,iroot)
            enddo
            dum =dum *(aa1*pi212)
            dumx=dumx*(aa1*pi212)
            dumy=dumy*(aa1*pi212)
            dumz=dumz*(aa1*pi212)
            ij=ij+1
            tv10(ij,1)=tv10(ij,1)+cij*(qijx*dum+tijy*dumz-tijz*dumy)
            tv10(ij,2)=tv10(ij,2)+cij*(qijy*dum+tijz*dumx-tijx*dumz)
            tv10(ij,3)=tv10(ij,3)+cij*(qijz*dum+tijx*dumy-tijy*dumx)
         enddo
      enddo
c
c     ----- end loop over atoms -----
c
      enddo
c
c     ----- end loop over primitives -----
c
 1000 continue
      enddo
      enddo
c
      return
 9997 format(' in -gitv10- the rys quadrature is not implemented',
     1       ' beyond -nroots- = ',i2,/,' lit,ljt,nroots= ',3i3)
      end

      double precision function util_cpusec()
      implicit none
c $Id: util_cpusec.F 26140 2014-09-03 00:19:44Z edo $
*
* routine to give cpu seconds since start of execution
*  delta times are handled by all applications
*
#if defined(BGL) || defined(BGP) || defined(BGQ)
      EXTERNAL MPI_WTIME
      REAL*8 MPI_WTIME
      util_cpusec = MPI_WTIME()
#elif defined(IBM) || defined(SP1) ||defined(HPUX)
      double precision ibm_cputime
      external ibm_cputime
      util_cpusec = ibm_cputime()
#elif defined(KSR)
*--KSR-start
      real ksr_cputime
      external ksr_cputime
      util_cpusec = ksr_cputime()
*--KSR-end
#elif defined(SUN) || defined(__PARAGON__) || defined(DECOSF) || defined(SOLARIS) || defined(FUJITSU_VPP)|| defined(LINUXALPHA) || defined(MACX) 
      real*4 tarray(2)
      real*4 etime
#ifndef GCC4
      external etime
#endif
      util_cpusec = etime(tarray)
#elif defined(SGI)
#if defined(SGITFP)
      real*4 tarray(2)        ! nb: real == real*8 on TFP
      real*4 etime
      external etime
#else
      real tarray(2)
      real etime
      external etime
#endif
      util_cpusec = etime(tarray)
#elif defined(DELTA)
      double precision dclock
      external dclock
      double precision first
      logical ofirst
      data ofirst /.true./
      if (ofirst) then
        first = dclock()
        ofirst = .false.
      endif
      util_cpusec = dclock() - first
#elif (defined(LINUX) || defined(CYGNUS)) && !defined(LINUXIA64) && !defined(CATAMOUNT)
      double precision linux_cputime
      external linux_cputime
      util_cpusec = linux_cputime()
#elif defined(WIN32) &&!defined(__MINGW32__)
      double precision win32_cputime
      external win32_cputime
      util_cpusec = win32_cputime()
#elif defined(CRAY)
      double precision secondr
      external secondr
      double precision first
      logical ofirst
      save first, ofirst
      data ofirst /.true./
      if (ofirst) then
        first = secondr()
        ofirst = .false.
      endif
      util_cpusec = secondr() - first ! Actually wall time
#elif defined(FUJITSU_SOLARIS) || defined(CATAMOUNT)
#ifdef FUJITSU_SOLARIS
      intrinsic cpu_time
#endif
      call cpu_time (util_cpusec)
#else
#include "tcgmsg.fh"
      util_cpusec = TCGTIME()
#endif
      end

C> \ingroup selci
C> @{
      subroutine selci_mxmb(a,mcola,mrowa,b,mcolb,mrowb,
     1     r,mcolr,mrowr, ncol,nlink,nrow)
*
* $Id: mxmb.f 24790 2013-11-11 18:56:49Z d3y133 $
*
      implicit double precision (a-h,o-z)
      dimension a(1),b(1),r(1)
c
      ir=1
      ib=1
      do 50 j=1,nrow
         ibb=ib
         ia=1
         do 40 k=1,nlink
            fac=b(ibb)
            if(fac)10,30,10
 10         irr=ir
            iaa=ia
            do 20 i=1,ncol
               r(irr)=r(irr)+fac*a(iaa)
               irr=irr+mcolr
               iaa=iaa+mcola
 20         continue
 30         ibb=ibb+mcolb
            ia=ia+mrowa
 40      continue
         ir=ir+mrowr
         ib=ib+mrowb
 50   continue
c
      end
C> @}

      SUBROUTINE ccsdtq_lambda1_20_17(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdtq_lambda1_20_17.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p15 p17 p18 h13 h14 h16 )_vtt + = -1/12 * Sum ( h11 h12 ) * t ( p15 p18 h11 h12 )_t * i2 ( h11 h12 p17 h13 h14 h16 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p15b
      INTEGER p18b
      INTEGER p17b
      INTEGER h13b
      INTEGER h14b
      INTEGER h16b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h11b
      INTEGER h12b
      INTEGER p15b_1
      INTEGER p18b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER p17b_2
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER h13b_2
      INTEGER h14b_2
      INTEGER h16b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p15b = noab+1,noab+nvab
      DO p18b = p15b,noab+nvab
      DO p17b = noab+1,noab+nvab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      DO h16b = h14b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b
     &-1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b
     &-1)+int_mb(k_spin+h16b-1).ne.12)) THEN
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p17b-1)+int_mb(k_spin+p18b
     &-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin
     &+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+p18b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h14b-1
     &),int_mb(k_sym+h16b-1)))))) .eq. ieor(irrep_v,ieor(irrep_t,irrep_t
     &))) THEN
      dimc = int_mb(k_range+p15b-1) * int_mb(k_range+p17b-1) * int_mb(k_
     &range+p18b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+h14b-1) * 
     &int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_17',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h11b = 1,noab
      DO h12b = h11b,noab
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p18b-1) .eq. int_mb(k_spin
     &+h11b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p18b-1),ieor(int_m
     &b(k_sym+h11b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p15b,p18b,h11b,h12b,p15b_1,p18b_1,h11b_1,h12
     &b_1)
      CALL TCE_RESTRICTED_6(p17b,h11b,h12b,h13b,h14b,h16b,p17b_2,h11b_2,
     &h12b_2,h13b_2,h14b_2,h16b_2)
      dim_common = int_mb(k_range+h11b-1) * int_mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p15b-1) * int_mb(k_range+p18b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p17b-1) * int_mb(k_range+h13b-1) * int_
     &mb(k_range+h14b-1) * int_mb(k_range+h16b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_17',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_17',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (p18b_1 - noab - 1 + nvab * (p
     &15b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12
     &b-1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_20_17',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_17',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_17',5,MA_ERR)
      IF ((h12b .le. p17b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h16b_
     &2 - 1 + noab * (h14b_2 - 1 + noab * (h13b_2 - 1 + noab * (p17b_2 -
     & noab - 1 + nvab * (h12b_2 - 1 + noab * (h11b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p17b-1),int_mb(k_range+h13
     &b-1),int_mb(k_range+h14b-1),int_mb(k_range+h16b-1),6,5,4,3,2,1,1.0
     &d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_20_17',6,
     &MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h11b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_1
     &7',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_1
     &7',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_17',9,MA_ERR)
      IF ((p15b .le. p17b) .and. (p17b .le. p18b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h13b-1),int_mb(k_range+p17
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,4,5,3,2,1,-1.
     &0d0/36.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p17b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF ((p17b .le. p15b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h13b-1),int_mb(k_range+p17
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),4,6,5,3,2,1,1.0
     &d0/36.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (p18b - noab - 
     &1 + nvab * (p15b - noab - 1 + nvab * (p17b - noab - 1)))))))
      END IF
      IF ((p18b .le. p17b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h13b-1),int_mb(k_range+p17
     &b-1),int_mb(k_range+p18b-1),int_mb(k_range+p15b-1),6,5,4,3,2,1,1.0
     &d0/36.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (p17b - noab - 
     &1 + nvab * (p18b - noab - 1 + nvab * (p15b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_20_17',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_1
     &7',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

#if HAVE_CONFIG_H
#   include "config.fh"
#endif

# define THRESH 1d-13
# define THRESHF 1e-5
#define MISMATCH(x,y) abs(x-y)/max(1d0,abs(x)).gt.THRESH
#define MISMATCHF(x,y) abs(x-y)/max(1.0,abs(x)).gt.THRESHF


      program main
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      integer DIM, MAXPROC, NITER
      parameter (DIM = 2, MAXPROC = 1000000, NITER=10)
      integer MAXSIZE
      parameter (MAXSIZE = 2**NITER)
      integer heap, stack, fudge, ma_heap
      integer me, nproc, nshift
      integer iter, lsize, ndim, dims(2), lo(2), hi(2), chunk(2), ld
      integer g_a
      integer i, j, ioff
      double precision tbeg, t_init, t_term, t_ma_init, t_msg_init
      double precision t_create, t_destroy, t_put, t_get, t_sync, bw
      double precision a(MAXSIZE,MAXSIZE)
      logical status
c     
c***  Intitialize a message passing library
c
#ifdef MPI
      integer ierr
c     tbeg = ga_wtime()
      call mpi_init(ierr)
#else
c     tbeg = ga_wtime()
      call pbeginf
#endif
c     t_msg_init = ga_wtime() - tbeg
c
c***  Initialize GA
c
c     There are 2 choices: ga_initialize or ga_initialize_ltd.
c     In the first case, there is no explicit limit on memory usage.
c     In the second, user can set limit (per processor) in bytes.
c
      tbeg = ga_wtime()
      call ga_initialize()
      t_init = ga_wtime() - tbeg

      nproc = ga_nnodes()
      me = ga_nodeid()
      nshift = nproc/2
c
c     call ga_dgop(1,t_msg_init,1,'+')
c     t_msg_init = t_msg_init/dble(nproc)
c     if (me.eq.0) then
c       write(6,'(a,f16.6)') 'Time spent in runtime initialization: ',
c    +                       t_msg_init
c     endif
      call ga_dgop(2,t_init,1,'+')
      t_init = t_init/dble(nproc)
      if (me.eq.0) then
        write(6,'(a,f16.6)') 'Time spent in GA initialization:      ',
     +                       t_init
      endif
c     we can also use GA_set_memory_limit BEFORE first ga_create call
c
      heap = 2000*2000*4
      fudge = 100
      stack = 2000*2000
      ma_heap = heap + fudge 
      call GA_set_memory_limit(8*ma_heap)
c
      if(ga_nodeid().eq.0)then
         write(6,'(a)') ' '
         write(6,'(a)') ' GA initialized '
         write(6,'(a)') ' '
         call ffflush(6)
      endif
c
c***  Initialize the MA package
c     MA must be initialized before any global array is allocated
c
      tbeg = ga_wtime()
      status = ma_init(MT_DCPL, stack, ma_heap)
      t_ma_init = ga_wtime() - tbeg
      if (.not. status) call ga_error('ma_init failed',-1) 
      call ga_dgop(3,t_ma_init,1,'+')
      t_ma_init = t_ma_init/dble(nproc)
      if (me.eq.0) then
        write(6,'(a,f16.6)') 'Time spent in MA initialization:      ',
     +                       t_ma_init
      endif
c
      if(me.eq.0)then
        write(6,'(a,i8,a)') 'Using ', nproc, ' process(es)'
        call ffflush(6)
      endif
c
c*** begin looping over tests
c
      lsize = 1
      do iter = 1, NITER
        lsize = 2*lsize
c
c*** create GA that is lsize X lsize*nproc in dimension
c
        if (me.eq.0) then
          write(6,'(a)') ' '
          write(6,'(a,i8)') ' Testing block size of ',lsize*lsize
          write(6,'(a)') ' '
        endif
        ndim = 2
        dims(1) = lsize
        dims(2) = nproc*lsize
        chunk(1) = lsize
        chunk(2) = -1
        call ga_sync
        tbeg = ga_wtime()
        g_a = ga_create_handle()
        call ga_set_data(g_a,ndim,dims,MT_DBL)
        call ga_set_chunk(g_a,chunk)
        status = ga_allocate(g_a)
        if (.not.status) then
          call ga_error('ga_allocate failed for size: ',lsize)
        endif
        t_create = ga_wtime() - tbeg
        call ga_dgop(iter,t_create,1,'+')
        t_create = t_create/dble(nproc)
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Time spent creating GA:               ',
     +                       t_create
        endif
c
c*** Fill local buffer with values
c
        ioff = mod(me+nshift,nproc)
        ioff = ioff*lsize**2
        do j = 1, lsize
          do i = 1, lsize
            a(i,j) = dble((j-1)*lsize+i+ioff)
          end do
        end do
        ld = MAXSIZE
        lo(1) = 1
        hi(1) = lsize
        lo(2) = mod(me+nshift,nproc)
        lo(2) = lo(2)*lsize + 1
        hi(2) = lo(2) - 1 + lsize
        call ga_zero(g_a)
        tbeg = ga_wtime()
        call nga_put(g_a,lo,hi,a,ld)
        t_put = ga_wtime() - tbeg
        call ga_dgop(iter+1,t_put,1,'+')
        t_put = t_put/dble(nproc)
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Time spent in put:                    ',
     +                       t_put
        endif
        bw = dble(8*lsize*lsize)/t_put
        bw = bw/1000000.0d00
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Bandwidth for put (MB/s):             ',
     +                       bw
        endif
        tbeg = ga_wtime()
        call ga_sync
        t_sync = ga_wtime() - tbeg
        call ga_dgop(iter+2,t_sync,1,'+')
        t_sync = t_sync/dble(nproc)
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Time spent in sync:                   ',
     +                       t_sync
        endif
        bw = dble(8*lsize*lsize)/(t_put+t_sync)
        bw = bw/1000000.0d00
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Bandwidth for put with sync (MB/s):   ',
     +                       bw
        endif
        do j = 1, lsize
          do i = 1, lsize
            a(i,j) = 0.0d00
          end do
        end do
        call ga_sync
        tbeg = ga_wtime()
        call nga_get(g_a,lo,hi,a,ld)
        t_get = ga_wtime() - tbeg
        ioff = mod(me+nshift,nproc)
        ioff = ioff*lsize**2
        do j = 1, lsize
          do i = 1, lsize
            if (a(i,j).ne.dble((j-1)*lsize+i+ioff)) then
              write(6,'(i4,a,i8,a,i8,a)') me,' mismatch for element (',
     +                                    i,',',j,')' 
            endif
          end do
        end do
        call ga_dgop(iter+3,t_get,1,'+')
        t_get = t_get/dble(nproc)
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Time spent in get:                    ',
     +                       t_get
        endif
        bw = dble(8*lsize*lsize)/t_get
        bw = bw/1000000.0d00
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Bandwidth for get (MB/s):             ',
     +                       bw
        endif
        call ga_sync
        tbeg = ga_wtime()
        status = ga_destroy(g_a)
        t_destroy = ga_wtime() - tbeg
        call ga_dgop(iter+4,t_destroy,1,'+')
        t_destroy = t_destroy/dble(nproc)
        if (me.eq.0) then
          write(6,'(a,f16.6)') 'Time spent destroying GA:             ',
     +                       t_destroy
        endif
      end do
c
c***  Tidy up the GA package
c
      call ga_terminate()
c
c***  Tidy up after message-passing library
c
#ifdef MPI
      call mpi_finalize(ierr)
#else
      call pend()
#endif
c
      stop
      end

*
* $Id: psi_marat_write.F 20364 2011-05-20 20:38:23Z d3p852 $
*

*     ***********************************
*     *                                 *
*     *         psi_marat_write         *
*     *                                 *
*     ***********************************

      subroutine psi_marat_write(filename,ispin,ne,psi2)
      implicit none 
      integer ispin,ne(2)
      double complex psi2(*)
      character*(*) filename

#include "mafdecls.fh"


*    *** local variables ***
      integer version,l
      integer nfft3d,npack1
      integer nfft(3)
      real*8  unita(3,3),scale,occupation
      character*255 full_filename

      integer MASTER,taskid
      parameter(MASTER=0)
      integer n

c     complex*16 tmp(*)
      integer tmp(2),tmp2(2),psi_spin(2),psi_occup(2)
      logical value

*     ***** local functions ****
      character*50 control_output_psi
      external     control_output_psi
      double precision control_unita,lattice_omega
      external         control_unita,lattice_omega
      integer  control_ngrid,control_version
      external control_ngrid,control_version

      call Parallel_taskid(taskid)
      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)

      value = MA_push_get(mt_dcpl,nfft3d,'tmp',tmp(2),tmp(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'tmp2',tmp2(2),tmp2(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(ne(1)+ne(2)),
     >                    'psi_occup',psi_occup(2),psi_occup(1))
      value = value.and.
     >        MA_push_get(mt_int,(ne(1)+ne(2)),
     >                    'psi_spin',psi_spin(2),psi_spin(1))
      if (.not. value) call errquit('psi_marat_write: push stack',0,0)

      version = control_version()
      nfft(1) = control_ngrid(1)
      nfft(2) = control_ngrid(2)
      nfft(3) = control_ngrid(3)

      unita(1,1) = control_unita(1,1)
      unita(2,1) = control_unita(2,1)
      unita(3,1) = control_unita(3,1)
      unita(1,2) = control_unita(1,2)
      unita(2,2) = control_unita(2,2)
      unita(3,2) = control_unita(3,2)
      unita(1,3) = control_unita(1,3)
      unita(2,3) = control_unita(2,3)
      unita(3,3) = control_unita(3,3)
      scale = 1.0d0/dsqrt(lattice_omega())

      occupation = 1.0d0
      if (ispin.eq.1) occupation = 2.0d0
      do n=1,ne(2)
        dbl_mb(psi_occup(1)+n-1) = occupation
        int_mb(psi_spin(1)+n-1)  = -1
      end do
      do n=ne(2)+1,ne(1)+ne(2)
        dbl_mb(psi_occup(1)+n-1) = occupation
        int_mb(psi_spin(1)+n-1)  = 1
      end do

*     **** open ELCIN binary file ****
      if (taskid.eq.MASTER) then
c         filename = "marat.psi"
         call util_file_name_noprefix(filename,.false.,
     >                                .false.,
     >                       full_filename)
         l = index(full_filename,' ') -1
         OPEN(87,file=full_filename,form="FORMATTED")
         write(87,*) nfft
         write(87,*) (dbl_mb(psi_occup(1)+n-1),n=1,(ne(1)+ne(2)))
         write(87,*) (int_mb(psi_spin(1)+n-1), n=1,(ne(1)+ne(2)))
      end if

*     *** write out 3d blocks ***
      !*** down spin ***
      if (ispin.eq.2) then
        do n=ne(1)+1,(ne(1)+ne(2))
         call Pack_c_Copy(1,psi2(1+(n-1)*npack1),dcpl_mb(tmp2(1)))
         call Pack_c_unpack(1,dcpl_mb(tmp2(1)))         
         call D3dB_cr_fft3b(1,dcpl_mb(tmp2(1))) 
c         call D3dB_r_SMul(1,scale,
c     >                      dcpl_mb(tmp2(1)),
c     >                      dcpl_mb(tmp2(1)))
         call D3dB_r_SMul1(1,scale,dcpl_mb(tmp2(1)))
         call D3dB_r_FormatWrite_paw(1,87,
     >                           dcpl_mb(tmp2(1)),
     >                           dcpl_mb(tmp(1)))
  
        end do
      end if
      !*** up spin ***
      do n=1,ne(1)
         call Pack_c_Copy(1,psi2(1+(n-1)*npack1),dcpl_mb(tmp2(1)))
         call Pack_c_unpack(1,dcpl_mb(tmp2(1)))         
         call D3dB_cr_fft3b(1,dcpl_mb(tmp2(1))) 
c         call D3dB_r_SMul(1,scale,
c     >                      dcpl_mb(tmp2(1)),
c     >                      dcpl_mb(tmp2(1)))
         call D3dB_r_SMul1(1,scale,dcpl_mb(tmp2(1)))
         call D3dB_r_FormatWrite_paw(1,87,
     >                           dcpl_mb(tmp2(1)),
     >                           dcpl_mb(tmp(1)))
      end do

*     *** close ELCIN binary file ***
      if (taskid.eq.MASTER) then
        close(87)
      end if

      value =           MA_pop_stack(psi_spin(2))
      value = value.and.MA_pop_stack(psi_occup(2))
      value = value.and.MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp(2))
      return
      end

      logical function argos_prep_wrtpdb(lfnout,lfnpdb,lrgpdb,
     + filpdb,iopt,box,num,amass,mat,
     + csa,isat,isgm,imol,ifra,xs,vs,msa,nsa,
     + cwa,iwat,xw,vw,mwm,mwa,nwm,nwa,
     + xwc,vwc,mwmc,nwmc,slvnam,iropt,irrand,nxrep,nyrep,nzrep,drep,
     + msb,nsb,idsb,rdist,nskip,iskip,lang,lfnmrg,nmerge,xmerge,filmrg,
     + irenum,invert,ihop,ips)
c
c $Id: argos_prep_wrtpdb.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
#include "mafdecls.fh"
c
      character*2 argos_prep_atnam
      real*8 argos_prep_atsiz
      integer argos_prep_merge
      external argos_prep_atnam,argos_prep_atsiz,argos_prep_merge
c
      integer lfnout,lfnpdb,iopt,msa,nsa,mwm,nwm,mwa,nwa,mat,mwmc,nwmc
      integer lfnmrg,lrgpdb
      character*255 filpdb,filmrg(100)
      integer num(mat),isat(msa),isgm(msa),imol(msa),ifra(msa),iwat(mwa)
      integer ihop(msa),ips(msa)
      character*16 cwa(mwa),csa(msa)
      character*3 slvnam
      real*8 amass(mat),xs(3,msa),vs(3,msa),xw(3,mwa,mwm),vw(3,mwa,mwm)
      real*8 xwc(3,mwa,mwmc),vwc(3,mwa,mwmc),box(3)
      integer iropt,irrand,nxrep,nyrep,nzrep,nskip
      real*8 rdist,drep(3),xmerge(3,100)
      integer msb,nsb,nmols,irenum,invert,nmerge
      integer idsb(2,msb),iskip(3,nskip),lang(*)
c
      integer length,ioff
c
      integer i,j,k,l,nats,nums,numslv,isoff,iaoff,natom,isegm,nsegm
      integer ixrep,iyrep,izrep
      real*8 temp,dbx,dby,dbz,dist,dbz0,angle
      real*8 o(3),px(3),py(3),pz(3),x(3),y(3),v(3)
      character*3 sname
      character*1 charr
      integer icharr,ilang,inum
c
      real*8 dumdst
c
      dumdst=0.025d0
c
      isoff=0
      iaoff=0
      inum=-1
      if(irenum.ne.0) inum=0
      charr=' '
      icharr=ichar(charr)
      dbz0=0.0d0
c
      o(1)=0.0d0
      o(2)=0.0d0
      o(3)=0.0d0
      px(1)=1.0d0
      px(2)=0.0d0
      px(3)=0.0d0
      py(1)=0.0d0
      py(2)=1.0d0
      py(3)=0.0d0
      pz(1)=0.0d0
      pz(2)=0.0d0
      pz(3)=1.0d0
c
c     open PDB file
c
      length=index(filpdb,' ')-1
      open(unit=lfnpdb,file=filpdb(1:length),form='formatted',
     + status='unknown',err=9999)
c
      if(nxrep.lt.1) nxrep=1
      if(nyrep.lt.1) nyrep=1
      if(nzrep.lt.-2) nzrep=1
      nums=0
c
      if(nxrep.le.1.and.nyrep.le.1.and.iabs(nzrep).le.1) then
c
      if(lrgpdb.eq.0) then
      write(lfnpdb,1000) (1.0d1*box(i),i=1,3),90.0,90.0,90.0
 1000 format(
     + 'HEADER',/,
     + 'TITLE     ',/,
     + 'TITLE    2',/,
     + 'TITLE    3',/,
     + 'REMARK   4 XXXX COMPLIES WITH FORMAT V. 2.1, 25-OCT-1996',/,
     + 'CRYST1',3f9.3,3f7.2)
      else
      write(lfnpdb,2000) (1.0d1*box(i),i=1,3),90.0,90.0,90.0
 2000 format(
     + 'HEADER',/,
     + 'TITLE     ',/,
     + 'TITLE    2',/,
     + 'TITLE    3',/,
     + 'REMARK   4 YYYY DOES NOT COMPLY WITH FORMAT V. 2.1,',
     + ' 25-OCT-1996',/,
     + 'CRYST1',3f9.3,3f7.2,/,
     + 'LRGPDB')
      endif
c
      ioff=0
c      if(filmrg(1:1).ne.' ') then
      if(nmerge.gt.0) then
      do 6060 k=1,nmerge
      ioff=ioff+argos_prep_merge(lfnmrg,xmerge(1,k),filmrg(k),
     + lfnout,lfnpdb,slvnam,inum,lrgpdb)
 6060 continue
      ioff=inum
c      ioff=argos_prep_merge(lfnmrg,filmrg,lfnout,lfnpdb,slvnam,inum)
      if(ioff.lt.0) call md_abort('Error in argos_prep_merge',ioff)
      if(inum.ge.0) ioff=ioff+1-isgm(1)
      else
      if(irenum.ne.0) ioff=-isgm(1)+1
      endif
c
      nums=0
      do 11 k=1,nsb
      i=idsb(1,k)
      j=idsb(2,k)
c      write(*,'(5i5)') i,j,k,isgm(i),isgm(j)
      if(isgm(i).ne.isgm(j)) then
      dist=sqrt((xs(1,j)-xs(1,i))*(xs(1,j)-xs(1,i))+
     + (xs(2,j)-xs(2,i))*(xs(2,j)-xs(2,i))+
     + (xs(3,j)-xs(3,i))*(xs(3,j)-xs(3,i)))
      if(dist.gt.argos_prep_atsiz(num(isat(j)))+
     + argos_prep_atsiz(num(isat(i)))) then
      write(lfnpdb,1101) csa(i)(11:14),csa(i)(1:3),' ',isgm(i)+ioff,
     + csa(j)(11:14),csa(j)(1:3),isgm(j)+ioff
 1101 format('LINK',t13,a4,1x,a3,1x,a1,i4,16x,a4,1x,a3,2x,i4)
      endif
      endif
   11 continue
      do 1 i=1,nsa
      if(ips(i).ge.0.or.ihop(i).eq.0) then
      x(1)=xs(1,i)
      x(2)=xs(2,i)
      x(3)=xs(3,i)
      else
      x(1)=xs(1,i)-xs(1,i+ihop(i))
      x(2)=xs(2,i)-xs(2,i+ihop(i))
      x(3)=xs(3,i)-xs(3,i+ihop(i))
      dist=sqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
      dist=dumdst/dist
      x(1)=xs(1,i+ihop(i))+dist*x(1)
      x(2)=xs(2,i+ihop(i))+dist*x(2)
      x(3)=xs(3,i+ihop(i))+dist*x(3)
      endif
      temp=4.009103873d1*amass(isat(i))*
     + (vs(1,i)*vs(1,i)+vs(2,i)*vs(2,i)+vs(3,i)*vs(3,i))
      if(temp.gt.999.0) temp=999.989
      sname=csa(i)(1:3)
      if(sname(1:1).eq.'_') sname(1:1)=' '
      if(sname(2:2).eq.'_') sname(2:2)=' '
      if(sname(3:3).eq.'_') sname(3:3)=' '
      if(lrgpdb.eq.0) then
      write(lfnpdb,1001) i,csa(i)(11:14),sname,' ',
     + isgm(i)+ioff,(1.0d1*x(k),k=1,3),temp,
     + argos_prep_atnam(num(isat(i)))
      else
      write(lfnpdb,2001) i,csa(i)(11:14),sname,
     + isgm(i)+ioff,(1.0d1*x(k),k=1,3),temp,
     + argos_prep_atnam(num(isat(i)))
      endif
 1001 format('ATOM',i7,1x,a4,1x,a3,1x,a1,i4,4x,3f8.3,6x,f6.2,4x,a2)
 2001 format('ATOM',i7,1x,a4,1x,a3,i6,4x,3f8.3,6x,f6.2,4x,a2)
      if(isgm(i).gt.nums) nums=isgm(i)
    1 continue
      else
      dbz0=0.0d0
      charr='A'
      icharr=ichar(charr)
      if(nzrep.lt.0) then
      if(nsa.gt.0.and.nwm.eq.0) dbz0=xs(3,1)
      if(nsa.eq.0.and.nwm.gt.0) dbz0=xw(3,1,1)
      if(nsa.gt.0.and.nwm.gt.0) dbz=min(xs(3,1),xw(3,1,1))
      if(invert.eq.0) then
      do 31 i=1,nsa
      dbz0=min(dbz0,xs(3,i))
   31 continue
      do 32 i=1,nwm
      do 33 j=1,nwa
      dbz0=min(dbz0,xw(3,j,i))
   33 continue
   32 continue
      dbz0=dbz0-0.5d0*rdist
      else
      do 41 i=1,nsa
      dbz0=max(dbz0,xs(3,i))
   41 continue
      do 42 i=1,nwm
      do 43 j=1,nwa
      dbz0=max(dbz0,xw(3,j,i))
   43 continue
   42 continue
      dbz0=dbz0+0.5d0*rdist
      endif
      endif
c
      nmols=0
      do 34 i=1,nsa
      if(iropt.eq.3) then
      nmols=max(nmols,ifra(i))
      else
      nmols=max(nmols,imol(i))
      endif
   34 continue
c
      if(lrgpdb.eq.0) then
      write(lfnpdb,1000) 1.0d1*dble(nxrep)*drep(1),
     + 1.0d1*dble(nyrep)*drep(2),1.0d1*dble(nzrep)*drep(3),
     + 90.0,90.0,90.0
      else
      write(lfnpdb,2000) 1.0d1*dble(nxrep)*drep(1),
     + 1.0d1*dble(nyrep)*drep(2),1.0d1*dble(nzrep)*drep(3),
     + 90.0,90.0,90.0
      endif
c
      ioff=0
      inum=0
      if(nmerge.gt.0) then
      do 6061 k=1,nmerge
      ioff=ioff+argos_prep_merge(lfnmrg,xmerge(1,k),filmrg(k),
     + lfnout,lfnpdb,slvnam,inum,lrgpdb)
 6061 continue
      ioff=inum
c      if(filmrg(1:1).ne.' ') then
c      ioff=argos_prep_merge(lfnmrg,filmrg,lfnout,lfnpdb,slvnam,inum)
      if(ioff.lt.0) call md_abort('Error 2 in argos_prep_merge',0)
      endif
c
      if(iropt.le.1) then
      ilang=0
      do 4 izrep=1,iabs(nzrep)
      if(nzrep.gt.0) then
      dbz=(dble(izrep)-0.5d0*dble(nzrep+1))*drep(3)
      else
      dbz=dbz0
      endif
      do 5 iyrep=1,nyrep
      dby=(dble(iyrep)-0.5d0*dble(nyrep+1))*drep(2)
      do 6 ixrep=1,nxrep
      dbx=(dble(ixrep)-0.5d0*dble(nxrep+1))*drep(1)
c
      do 66 k=1,nskip
      if(ixrep.eq.iskip(1,k).and.iyrep.eq.iskip(2,k).and.
     + izrep.eq.iskip(3,k)) goto 6
   66 continue
c
      angle=8.0d0*atan(1.0d0)*util_random(0)
      ilang=ilang+1
      lang(ilang)=angle
c
      if(iropt.eq.0) then
      icharr=ichar(' ')
      else
      isoff=0
      endif
c
      do 111 k=1,nsb
      i=idsb(1,k)
      j=idsb(2,k)
      if(isgm(i).ne.isgm(j)) then
      dist=sqrt((xs(1,j)-xs(1,i))*(xs(1,j)-xs(1,i))+
     + (xs(2,j)-xs(2,i))*(xs(2,j)-xs(2,i))+
     + (xs(3,j)-xs(3,i))*(xs(3,j)-xs(3,i)))
      if(dist.gt.argos_prep_atsiz(num(isat(j)))+
     + argos_prep_atsiz(num(isat(i)))) then
      write(lfnpdb,1101) csa(i)(11:14),csa(i)(1:3),char(icharr),
     + isgm(i)+ioff+isoff,csa(j)(11:14),csa(j)(1:3),isgm(j)+ioff+isoff
      endif
      endif
  111 continue
c
      nums=0
c
      do 7 i=1,nsa
c
      x(1)=xs(1,i)
      x(2)=xs(2,i)
      x(3)=xs(3,i)
      if(ips(i).ge.0.or.ihop(i).eq.0) then
      x(1)=xs(1,i)
      x(2)=xs(2,i)
      x(3)=xs(3,i)
      else
      x(1)=xs(1,i)-xs(1,i+ihop(i))
      x(2)=xs(2,i)-xs(2,i+ihop(i))
      x(3)=xs(3,i)-xs(3,i+ihop(i))
      dist=sqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
      dist=dumdst/dist
      x(1)=xs(1,i+ihop(i))+dist*x(1)
      x(2)=xs(2,i+ihop(i))+dist*x(2)
      x(3)=xs(3,i+ihop(i))+dist*x(3)
      endif
      y(1)=x(1)
      y(2)=x(2)
      y(3)=x(3)
      if(irrand.eq.1.or.irrand.eq.4) call rotate(o,px,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
      if(irrand.eq.2.or.irrand.eq.4) call rotate(o,py,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
      if(irrand.eq.3.or.irrand.eq.4) call rotate(o,pz,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
c
      temp=4.009103873d1*amass(isat(i))*
     + (vs(1,i)*vs(1,i)+vs(2,i)*vs(2,i)+vs(3,i)*vs(3,i))
      if(temp.gt.999.0) temp=999.989
      if(lrgpdb.eq.0) then
      if(nzrep.gt.0) then
      write(lfnpdb,1001) i+iaoff,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)+dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      if(izrep.eq.1) then
      write(lfnpdb,1001) i+iaoff,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      write(lfnpdb,1001) i+iaoff,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,-1.0d1*(y(1)+dbx),
     + -1.0d1*(y(2)+dby),-1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      endif
      endif
      else
      if(char(icharr).ne.' ') call md_abort('Error in LRGPDB ',icharr)
      if(nzrep.gt.0) then
      write(lfnpdb,2001) i+iaoff,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)+dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      if(izrep.eq.1) then
      write(lfnpdb,2001) i+iaoff,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      write(lfnpdb,2001) i+iaoff,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,-1.0d1*(y(1)+dbx),
     + -1.0d1*(y(2)+dby),-1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      endif
      endif
      endif
      if(isgm(i).gt.nums) nums=isgm(i)
    7 continue
      isoff=isoff+nums
      iaoff=iaoff+nsa
      icharr=icharr+1
    6 continue
    5 continue
    4 continue
c
      else
      natom=0
      nsegm=0
      isegm=0
      isoff=0
      do 20 l=1,nmols
      ilang=0
      do 14 izrep=1,iabs(nzrep)
      if(nzrep.gt.0) then
      dbz=(dble(izrep)-0.5d0*dble(nzrep+1))*drep(3)
      else
      dbz=dbz0
      endif
      do 15 iyrep=1,nyrep
      dby=(dble(iyrep)-0.5d0*dble(nyrep+1))*drep(2)
      do 16 ixrep=1,nxrep
      dbx=(dble(ixrep)-0.5d0*dble(nxrep+1))*drep(1)
c
      do 67 k=1,nskip
      if(ixrep.eq.iskip(1,k).and.iyrep.eq.iskip(2,k).and.
     + izrep.eq.iskip(3,k)) goto 16
   67 continue
c
      ilang=ilang+1
c
      if(l.eq.1) then
      angle=8.0d0*atan(1.0d0)*util_random(0)
      lang(ilang)=angle
      else
      angle=lang(ilang)
      endif
c
      icharr=ichar(' ')
c
      do 212 i=1,nsa
      if(iropt.eq.3) then
      if(ifra(i).eq.l) then
      isoff=nsegm-isgm(i)+1
      goto 213
      endif
      else
      if(imol(i).eq.l) then
      isoff=nsegm-isgm(i)+1
      goto 213
      endif
      endif
  212 continue
  213 continue
c
      do 211 k=1,nsb
      i=idsb(1,k)
      j=idsb(2,k)
      if(iropt.eq.3) then
      if(ifra(i).eq.l.and.ifra(j).eq.l.and.isgm(i).ne.isgm(j)) then
      dist=sqrt((xs(1,j)-xs(1,i))*(xs(1,j)-xs(1,i))+
     + (xs(2,j)-xs(2,i))*(xs(2,j)-xs(2,i))+
     + (xs(3,j)-xs(3,i))*(xs(3,j)-xs(3,i)))
      if(dist.gt.argos_prep_atsiz(num(isat(j)))+
     + argos_prep_atsiz(num(isat(i)))) then
      write(lfnpdb,1101) csa(i)(11:14),csa(i)(1:3),char(icharr),
     + isgm(i)+ioff+isoff,csa(j)(11:14),csa(j)(1:3),isgm(j)+ioff+isoff
      endif
      endif
      else
      if(imol(i).eq.l.and.imol(j).eq.l.and.isgm(i).ne.isgm(j)) then
      dist=sqrt((xs(1,j)-xs(1,i))*(xs(1,j)-xs(1,i))+
     + (xs(2,j)-xs(2,i))*(xs(2,j)-xs(2,i))+
     + (xs(3,j)-xs(3,i))*(xs(3,j)-xs(3,i)))
      if(dist.gt.argos_prep_atsiz(num(isat(j)))+
     + argos_prep_atsiz(num(isat(i)))) then
      write(lfnpdb,1101) csa(i)(11:14),csa(i)(1:3),char(icharr),
     + isgm(i)+ioff+isoff,csa(j)(11:14),csa(j)(1:3),isgm(j)+ioff+isoff
      endif
      endif
      endif
  211 continue
c
      nums=0
c
      do 17 i=1,nsa
c
      x(1)=xs(1,i)
      x(2)=xs(2,i)
      x(3)=xs(3,i)
      if(ips(i).ge.0.or.ihop(i).eq.0) then
      x(1)=xs(1,i)
      x(2)=xs(2,i)
      x(3)=xs(3,i)
      else
      x(1)=xs(1,i)-xs(1,i+ihop(i))
      x(2)=xs(2,i)-xs(2,i+ihop(i))
      x(3)=xs(3,i)-xs(3,i+ihop(i))
      dist=sqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
      dist=dumdst/dist
      x(1)=xs(1,i+ihop(i))+dist*x(1)
      x(2)=xs(2,i+ihop(i))+dist*x(2)
      x(3)=xs(3,i+ihop(i))+dist*x(3)
      endif
      y(1)=x(1)
      y(2)=x(2)
      y(3)=x(3)
      if(irrand.eq.1.or.irrand.eq.4) call rotate(o,px,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
      if(irrand.eq.2.or.irrand.eq.4) call rotate(o,py,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
      if(irrand.eq.3.or.irrand.eq.4) call rotate(o,pz,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
c
      if(iropt.eq.3) then
      if(ifra(i).eq.l) then
      temp=4.009103873d1*amass(isat(i))*
     + (vs(1,i)*vs(1,i)+vs(2,i)*vs(2,i)+vs(3,i)*vs(3,i))
      if(temp.gt.999.0) temp=999.989
      natom=natom+1
      if(lrgpdb.eq.0) then
      if(nzrep.gt.0) then
      write(lfnpdb,1001) natom,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)+dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      if(izrep.eq.1) then
      write(lfnpdb,1001) natom,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      write(lfnpdb,1001) natom,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,-1.0d1*(y(1)+dbx),
     + -1.0d1*(y(2)+dby),-1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      endif
      endif
      else
      if(char(icharr).ne.' ') call md_abort('Error in LRGPDB ',icharr)
      if(nzrep.gt.0) then
      write(lfnpdb,2001) natom,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)+dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      if(izrep.eq.1) then
      write(lfnpdb,2001) natom,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      write(lfnpdb,2001) natom,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,-1.0d1*(y(1)+dbx),
     + -1.0d1*(y(2)+dby),-1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      endif
      endif
      endif
      nsegm=isgm(i)+isoff
      endif
      else
      if(imol(i).eq.l) then
      temp=4.009103873d1*amass(isat(i))*
     + (vs(1,i)*vs(1,i)+vs(2,i)*vs(2,i)+vs(3,i)*vs(3,i))
      if(temp.gt.999.0) temp=999.989
      natom=natom+1
      if(lrgpdb.eq.0) then
      if(nzrep.gt.0) then
      write(lfnpdb,1001) natom,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)+dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      if(izrep.eq.1) then
      write(lfnpdb,1001) natom,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      write(lfnpdb,1001) natom,csa(i)(11:14),csa(i)(1:3),
     + char(icharr),isgm(i)+ioff+isoff,-1.0d1*(y(1)+dbx),
     + -1.0d1*(y(2)+dby),-1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      endif
      endif
      else
      if(char(icharr).ne.' ') call md_abort('Error in LRGPDB ',icharr)
      if(nzrep.gt.0) then
      write(lfnpdb,2001) natom,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)+dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      if(izrep.eq.1) then
      write(lfnpdb,2001) natom,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,1.0d1*(y(1)+dbx),
     + 1.0d1*(y(2)+dby),1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      else
      write(lfnpdb,2001) natom,csa(i)(11:14),csa(i)(1:3),
     + isgm(i)+ioff+isoff,-1.0d1*(y(1)+dbx),
     + -1.0d1*(y(2)+dby),-1.0d1*(y(3)-dbz),
     + temp,argos_prep_atnam(num(isat(i)))
      endif
      endif
      endif
      nsegm=isgm(i)+isoff
      endif
      endif
   17 continue
   16 continue
   15 continue
   14 continue
   20 continue
      endif
c
      endif
c
      write(lfnpdb,1002)
 1002 format('TER')
c
      numslv=iopt
      if(iopt.lt.0) numslv=nwmc
      if(iopt.gt.nwm+nwmc) numslv=nwm+nwmc
c
      if(numslv.gt.0) then
c
      if(nxrep.le.1.and.nyrep.le.1.and.iabs(nzrep).le.1) then
c
      nats=nsa
      do 2 i=1,numslv
      do 3 j=1,nwa
      nats=nats+1
      if(i.le.nwmc) then
      temp=4.009103873d1*amass(iwat(j))*(vwc(1,j,i)*vwc(1,j,i)+
     + vwc(2,j,i)*vwc(2,j,i)+vwc(3,j,i)*vwc(3,j,i))
      if(temp.gt.999.0) temp=999.989
      write(lfnpdb,1003) nats,cwa(j)(11:14),slvnam,
     + i+nums,(1.0d1*xwc(k,j,i),k=1,3),temp,
     + argos_prep_atnam(num(iwat(j)))
      else
      temp=4.009103873d1*amass(iwat(j))*(vw(1,j,i-nwmc)*vw(1,j,i-nwmc)+
     + vw(2,j,i-nwmc)*vw(2,j,i-nwmc)+vw(3,j,i-nwmc)*vw(3,j,i-nwmc))
      if(temp.gt.999.0) temp=999.989
      write(lfnpdb,1003) nats,cwa(j)(11:14),slvnam,
     + i+nums,(1.0d1*xw(k,j,i-nwmc),k=1,3),temp,
     + argos_prep_atnam(num(iwat(j)))
      endif
 1003 format('ATOM',i7,1x,a4,1x,a3,i6,4x,3f8.3,6x,f6.2,4x,a2)
    3 continue
    2 continue
c
      else
c
      nats=nxrep*nyrep*iabs(nzrep)*nsa
      ilang=0
      do 44 izrep=1,iabs(nzrep)
      if(nzrep.gt.0) then
      dbz=(dble(izrep)-0.5d0*dble(nzrep+1))*drep(3)
      else
      dbz=dbz0
      endif
      do 45 iyrep=1,nyrep
      dby=(dble(iyrep)-0.5d0*dble(nyrep+1))*drep(2)
      do 46 ixrep=1,nxrep
      dbx=(dble(ixrep)-0.5d0*dble(nxrep+1))*drep(1)
c
      ilang=ilang+1
      angle=lang(ilang)
c
      nums=isoff
      do 47 i=1,numslv
      do 48 j=1,nwa
      nats=nats+1
c
      if(i.le.nwmc) then
      x(1)=xwc(1,j,i)
      x(2)=xwc(2,j,i)
      x(3)=xwc(3,j,i)
      y(1)=xwc(1,j,i)
      y(2)=xwc(2,j,i)
      y(3)=xwc(3,j,i)
      v(1)=vwc(1,j,i)
      v(2)=vwc(2,j,i)
      v(3)=vwc(3,j,i)
      else
      x(1)=xw(1,j,i-nwmc)
      x(2)=xw(2,j,i-nwmc)
      x(3)=xw(3,j,i-nwmc)
      y(1)=xw(1,j,i-nwmc)
      y(2)=xw(2,j,i-nwmc)
      y(3)=xw(3,j,i-nwmc)
      v(1)=vw(1,j,i-nwmc)
      v(2)=vw(2,j,i-nwmc)
      v(3)=vw(3,j,i-nwmc)
      endif
      if(irrand.eq.1.or.irrand.eq.4) call rotate(o,px,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
      if(irrand.eq.2.or.irrand.eq.4) call rotate(o,py,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
      if(irrand.eq.3.or.irrand.eq.4) call rotate(o,pz,angle,x,y)
      x(1)=y(1)
      x(2)=y(2)
      x(3)=y(3)
c
      if(nzrep.gt.0) then
      temp=4.009103873d1*amass(iwat(j))*(v(1)*v(1)+
     + v(2)*v(2)+v(3)*v(3))
      if(temp.gt.999.0) temp=999.989
      write(lfnpdb,1003) nats,cwa(j)(11:14),slvnam,
     + i+nums,1.0d1*(y(1)+dbx),1.0d1*(y(2)+dby),
     + 1.0d1*(y(3)+dbz),temp,argos_prep_atnam(num(iwat(j)))
      else
      if(izrep.eq.1) then
      temp=4.009103873d1*amass(iwat(j))*(v(1)*v(1)+
     + v(2)*v(2)+v(3)*v(3))
      if(temp.gt.999.0) temp=999.989
      write(lfnpdb,1003) nats,cwa(j)(11:14),slvnam,
     + i+nums,1.0d1*(y(1)+dbx),1.0d1*(y(2)+dby),
     + 1.0d1*(y(3)-dbz),temp,argos_prep_atnam(num(iwat(j)))
      else
      temp=4.009103873d1*amass(iwat(j))*(v(1)*v(1)+
     + v(2)*v(2)+v(3)*v(3))
      if(temp.gt.999.0) temp=999.989
      write(lfnpdb,1003) nats,cwa(j)(11:14),slvnam,
     + i+nums,1.0d1*(y(1)+dbx),1.0d1*(y(2)+dby),
     + 1.0d1*(y(3)-dbz),temp,argos_prep_atnam(num(iwat(j)))
      endif
      endif
   48 continue
   47 continue
      nums=nums+numslv
   46 continue
   45 continue
   44 continue
c
      endif
c
      endif
c
      write(lfnpdb,1004)
 1004 format('END')
c
c
      close(unit=lfnpdb)
c
      if(util_print('files',print_default)) then
      write(lfnout,3000) filpdb(1:length)
 3000 format(' Created pdb',t40,a,/)
      endif
c
      argos_prep_wrtpdb=.true.
      return
c
 9999 continue
      argos_prep_wrtpdb=.false.
      return
      end

      SUBROUTINE ccsdt_lr_alpha2_9_28_6_1(d_a,k_a_offset,d_b,k_b_offset,
     &d_c,k_c_offset)
C     $Id: ccsdt_lr_alpha2_9_28_6_1.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h2 h8 h9 h14 p5 p6 )_ytra + = 1 * Sum ( p3 ) * tra ( p3 h14 )_tra * y ( h2 h8 h9 p3 p5 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h8b
      INTEGER h9b
      INTEGER h14b
      INTEGER p5b
      INTEGER p6b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p3b_1
      INTEGER h14b_1
      INTEGER h2b_2
      INTEGER h8b_2
      INTEGER h9b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO h8b = h2b,noab
      DO h9b = h8b,noab
      DO h14b = 1,noab
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h8b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1)+
     &int_mb(k_spin+p6b-1).ne.12)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)
     & .eq. int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h8b-1),ieor(int_mb(
     &k_sym+h9b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p5b-1),in
     &t_mb(k_sym+p6b-1)))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h8b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h14b-1) * int_mb(k_range+p5b-1) * int_
     &mb(k_range+p6b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_28_6_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h14b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h14b-1)) .eq. irrep_tra)
     & THEN
      CALL TCE_RESTRICTED_2(p3b,h14b,p3b_1,h14b_1)
      CALL TCE_RESTRICTED_6(h2b,h8b,h9b,p5b,p6b,p3b,h2b_2,h8b_2,h9b_2,p5
     &b_2,p6b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+h14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h8b-1) * int_mb
     &(k_range+h9b-1) * int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_28_6_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_28_6_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h14b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha2_9_28_6_1
     &',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_28_6_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_28_6_1',5,MA_ERR)
      IF ((p3b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (h9b_2 - 1 + noab * (h8b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),6,5,3,2,1,4,1.0d0)
      END IF
      IF ((p5b .lt. p3b) .and. (p3b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h9b_2 - 1 + noab * (h8b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p6b-1),6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((p6b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h9b_2 - 1 + noab * (h8b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p3b-1),5,4,3,2,1,6,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha2_9_28_6_1
     &',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_2
     &8_6_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_2
     &8_6_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_28_6_1',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h9b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h14b-1),5,4,3,6,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p6b -
     & noab - 1 + nvab * (p5b - noab - 1 + nvab * (h14b - 1 + noab * (h9
     &b - 1 + noab * (h8b - 1 + noab * (h2b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha2_9_28_6_1
     &',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_2
     &8_6_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      program test
*
* $Id: testfmm.F 21484 2011-11-09 21:22:15Z d3p852 $
*
      implicit none
c
      double precision total_flops
      common / totalf / total_flops
c
      integer lmax, depth, lwork
      parameter (lmax=32, depth=3)
      parameter (lwork=(lmax+1)**2*2*(8**(depth+1)-1)/7)
      double precision poles((lmax+1)**2,
     $     0:2**depth-1,0:2**depth-1,0:2**depth-1)
      double precision work(lwork), poles0(-lmax:lmax,0:lmax)
      double precision fmm_potential, direct_sum, drand
      double precision fmm_direct_potential
      external fmm_potential, fmm_direct_potential, direct_sum, 
     $     drand
      double precision x, y, z, dimx, dimy, dimz, time
      real*4 etime, stuff(2)
c
      integer ncharge, i, ntest, j
      parameter (ncharge = 10, ntest=100)
      double precision charges(ncharge), coords(3,ncharge)
      double precision chargesr(ncharge), coordsr(3,ncharge)
      double precision pot1(ncharge), pot2(ncharge), pot3(ncharge)
      integer list_next(ncharge), map(ncharge),
     $     list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
c
      double precision far, near, err, relerr, l2err, l2norm, sum
c
      call xlm_init
      total_flops = 0.0d0
      write(6,*) ' lwork = ', lwork
      write(6,*) ' poles = ', (lmax+1)**2 * 8**depth
c
      dimx = 1.0d0
      dimy = 1.0d0
      dimz = 1.0d0
      do i = 1, ncharge
         charges(i) = drand(0)-0.5d0
         coords(1,i)= drand(0)
         coords(2,i)= drand(0)
         coords(3,i)= drand(0)
*         write(6,77) charges(i), (coords(j,i),j=1,3)
* 77      format(f12.6,2x,3f12.6)
      enddo
c
      write(6,*) ' Depth ', depth-1, ' lmax ', lmax
      time = etime(stuff)
      call fmm_charges_to_poles(lmax, depth-1, dimx, dimy, dimz,
     $     poles, coords, charges, ncharge, list_info, list_next,
     $     map)
      time = etime(stuff) - time
      write(6,61) ' Time to form multipoles ', time
 61   format(1x,a,f12.6)
      time = etime(stuff)
      call fmm(lmax, depth-1, dimx, dimy, dimz, poles, .false., poles0, 
     $     work, lwork)
      time = etime(stuff) - time
      write(6,61) ' Time to perform far field summation ', time
c
      write(6,*)
      write(6,*)
      write(6,*) ' Depth ', depth, ' lmax ', lmax
c
      time = etime(stuff)
      call fmm_charges_to_poles(lmax, depth, dimx, dimy, dimz,
     $     poles, coords, charges, ncharge, list_info, list_next,
     $     map)
c
      time = etime(stuff) - time
      write(6,61) ' Time to form multipoles ', time
c     
      time = etime(stuff)
      call fmm(lmax, depth, dimx, dimy, dimz, poles, .false., poles0, 
     $     work, lwork)
      time = etime(stuff) - time
      write(6,61) ' Time to perform far field summation ', time
c
      l2err = 0.0d0
      l2norm = 0.0d0
      err = 0.0d0
      relerr = 0.0d0
      do i = 1, ntest
         x = drand(0)
         y = drand(0)
         z = drand(0)
         far = fmm_potential(lmax,depth,dimx,dimy,dimz,poles,x,y,z)
         near = fmm_direct_potential(
     $        lmax, depth, dimx, dimy, dimz, x, y, z,
     $        coords, charges, ncharge, list_info, map)
         sum = direct_sum(coords, charges, ncharge, x, y, z)
         err = max(err,abs(sum-far-near))
         relerr = max(relerr, abs(sum-far-near)/sum)
         l2err = l2err + (sum-far-near)**2
         l2norm = l2norm + sum**2
      enddo
      write(6,62) ' MAX abs err = ', err
 62   format(1x,a,1p,d9.2)
      write(6,62) ' MAX rel err = ', relerr
      write(6,62) ' L2 err norm = ', sqrt(l2err/l2norm)
c
**      write(6,*) ' total flops ', total_flops
c
      time = etime(stuff)
      do j = 1, 1000
         far = fmm_potential(lmax,depth,dimx,dimy,dimz,poles,x,y,z)
         near = fmm_direct_potential(lmax, depth,
     $        dimx, dimy, dimz, x, y, z,
     $        coords, charges, ncharge, list_info, map)
      enddo
      time = etime(stuff)-time
      write(6,61) ' time per FMM potential eval ', time/1000
      time = etime(stuff)
      do j = 1, 1000
         sum = direct_sum(coords, charges, ncharge, x, y, z)
      enddo
      time = etime(stuff)-time
      write(6,61) ' time per direct potential eval ', time/1000
c
      time = etime(stuff)
      do j = 1, ncharge
         chargesr(j) = charges(map(j))
         coordsr(1,j) = coords(1,map(j))
         coordsr(2,j) = coords(2,map(j))
         coordsr(3,j) = coords(3,map(j))
      enddo
      call fmm_potential_at_charges2(lmax, depth,dimx,dimy,dimz,
     $     poles, coordsr, chargesr, ncharge, list_info, pot3)
      do j = 1, ncharge
         pot1(map(j)) = pot3(j)
      enddo
      time = etime(stuff)-time
      write(6,61) ' Time to evaluate all FMM potentials ', time
c
      time = etime(stuff)
      call direct_sum_at_charges(coords, charges, ncharge, pot2)
      time = etime(stuff)-time
      write(6,61) ' Time to evaluate all direct potentials ', time
c
      l2err = 0.0d0
      l2norm = 0.0d0
      err = 0.0d0
      do i = 1, ncharge
         err = max(err,abs(pot1(i)-pot2(i)))
         l2err = l2err + (pot1(i)-pot2(i))**2
         l2norm = l2norm + pot1(i)**2
      enddo
      write(6,62) ' MAX abs err at charges = ', err
      write(6,62) ' L2 err norm at charges = ', sqrt(l2err/l2norm)
c 
*      write(6,*) ' TOP LEVEL MULTIPOLES '
*      call xlm_print(lmax,poles0,lmax)
c
      end
      double precision function fmm_potential(lmax, depth,
     $     dimx, dimy, dimz, potential, x, y, z)
      implicit none
#include "errquit.fh"
      integer lmax, depth
      double precision dimx, dimy, dimz, x, y, z
      double precision potential((lmax+1)**2,
     $     0:2**depth-1,0:2**depth-1,0:2**depth-1)
c
c     Given a potential previously evaluated by the routine fmm
c     and augmented appropriatly for the near field terms,
c     evaluate the potential at the point (x,y,z).  The volume
c     is assumed to be defined on (0:dimx,0:dimy,0:dimz)
c
      integer kx, ky, kz
      double precision hx, hy, hz, xo, yo, zo
      integer lq
      parameter (lq = FMM_LMAX)
      double precision q(-lq:lq,0:lq)
      double precision xlm_local_potential
      external xlm_local_potential
c
      hx = dimx/dble(2**depth)  ! Size of boxes
      hy = dimy/dble(2**depth)
      hz = dimz/dble(2**depth)
      kx = int(x/hx) ! Index of box containing point
      ky = int(y/hy) ! Index of box containing point
      kz = int(z/hz) ! Index of box containing point
      xo = (dble(kx)+0.5d0)*hx   ! Coords of box center
      yo = (dble(ky)+0.5d0)*hy
      zo = (dble(kz)+0.5d0)*hz
c
      if (kx.lt.0 .or. kx.ge.2**depth) call errquit('x?',0, FMM_ERR)
      if (ky.lt.0 .or. ky.ge.2**depth) call errquit('y?',0, FMM_ERR)
      if (kz.lt.0 .or. kz.ge.2**depth) call errquit('z?',0, FMM_ERR)

*      if (kx.lt.2 .or. kx.ge.2**depth-2) call errquit('x2?',0)
*      if (ky.lt.2 .or. ky.ge.2**depth-2) call errquit('y2?',0)
*      if (kz.lt.2 .or. kz.ge.2**depth-2) call errquit('z2?',0)

c
      call xlm_unpack(lmax, potential(1,kx,ky,kz), q, lq)
      fmm_potential = xlm_local_potential(x-xo,y-yo,z-zo,
     $     q,lq,lmax)
c
      end
      double precision function direct_sum(coords, charges, ncharge,
     $     x, y, z)
      implicit none
      integer ncharge
      double precision coords(3,*), charges(*), x, y, z
c
c     Return the Coulomb potential at the specified point due to the
c     given charges
c
      integer i
      double precision sum
      sum = 0.0d0
      do i = 1, ncharge
         sum = sum + charges(i)/sqrt(
     $        (coords(1,i)-x)**2 +
     $        (coords(2,i)-y)**2 + 
     $        (coords(3,i)-z)**2)
      end do
c
      direct_sum = sum
c
      end
      subroutine direct_sum_at_charges(coords, charges, ncharge, pot)
      implicit none
      integer ncharge
      double precision coords(3,*), charges(*), x, y, z, pot(ncharge)
c
c     Evaluate the potential at each charge due to the other charges
c
      integer i, j
      double precision sum, rdist, xx, yy, zz
c
      do j = 1, ncharge
         pot(j) = 0.0d0
      enddo
c
      do j = 1, ncharge
         sum = 0.0d0
         x = coords(1,j)
         y = coords(2,j)
         z = coords(3,j)
         do i = 1, j-1
            xx = coords(1,i)-x
            yy = coords(2,i)-y
            zz = coords(3,i)-z
            rdist = 1.0d0/sqrt(xx*xx+yy*yy+zz*zz)
            sum = sum + charges(i)*rdist
            pot(i) = pot(i) + charges(j)*rdist
         enddo
         pot(j) = pot(j) + sum
      end do
c
      end
      subroutine fmm_charges_to_poles(lmax, depth, dimx, dimy, dimz, 
     $     poles, coords, charges, ncharge, list_info, list_next,
     $     map)
      implicit none
#include "errquit.fh"
      integer lmax, depth, ncharge
      double precision dimx, dimy, dimz
      double precision poles((lmax+1)**2,
     $     0:2**depth-1,0:2**depth-1,0:2**depth-1)
      double precision charges(ncharge), coords(3,ncharge)
      integer list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1),
     $     list_next(ncharge), map(ncharge)
c
c     Given a set of charges at the specified coordinates, 
c     build the input for FMM by migrating the sources
c     to the nearest center on the grid.  The coordinates are
c     assumed to be relative to the frame of the box which 
c     is defined on (0:dimx,0:dimy,0:dimz)
c
c     Initially build a linked list associating charges with each box.
c
c     list_info(1,box)  = first charge in box (or 0 if none)
c     list_next(charge) = next charge in box (or 0 if none)
c
c     Then construct a map that reorders the charges so that
c
c     list_info(1,box) = first reordered charge in box
c     list_info(2,box) = last reordered charge in box
c     map(reordered charge) = actual charge
c
      integer total
      integer kx, ky, kz, i, l, m
      double precision hx, hy, hz, xo, yo, zo, x, y, z
      integer lq
      parameter (lq = FMM_LMAX)
      double precision q(-lq:lq,0:lq)
      integer max_per_box, min_per_box, ind, n, twod
      double precision avgsq_per_box
c
      if (lmax .gt. lq) call errquit('fmm_ctop: lmax>lq', lmax, FMM_ERR)
      twod = 2**depth
      call xlm_init
c
      hx = dimx/dble(twod)  ! Size of boxes
      hy = dimy/dble(twod)
      hz = dimz/dble(twod)
      call dfill((lmax+1)**2*8**depth,0.0d0,poles,1)
      call ifill(8**depth * 2, 0, list_info, 1)
c
      do i = 1, ncharge
         x = coords(1,i)
         y = coords(2,i)
         z = coords(3,i)
         kx = int(x/hx)         ! Index of box containing point
         ky = int(y/hy)
         kz = int(z/hz)
         xo = (dble(kx)+0.5d0)*hx ! Coords of box center
         yo = (dble(ky)+0.5d0)*hy
         zo = (dble(kz)+0.5d0)*hz
         write(6,*) x, y, z, kx, ky, kz, depth, twod
         if (kx.lt.0 .or. kx.ge.twod) call errquit('x!',0, FMM_ERR)
         if (ky.lt.0 .or. ky.ge.twod) call errquit('y!',0, FMM_ERR)
         if (kz.lt.0 .or. kz.ge.twod) call errquit('z!',0, FMM_ERR)
c
         call xlm(lmax, x-xo, y-yo, z-zo, q, lq)
         do l = 0, lmax
            do m = -l, l
               q(m,l) = q(m,l)*charges(i)
            end do
         end do
*         call xlm_translate(lmax, xo-x, yo-y, zo-z, q, lq)
         call xlm_accumulate_to_packed
     $        (lmax,poles(1,kx,ky,kz),q,lq)
c
         list_next(i) = list_info(1,kx,ky,kz)
         list_info(1,kx,ky,kz) = i
      end do
c
      max_per_box = 0
      min_per_box = ncharge
      avgsq_per_box = 0
      total = 0
c      
      do kz = 0, twod-1
         do ky = 0, twod-1
            do kx = 0, twod-1
               ind = list_info(1,kx,ky,kz)
               list_info(1,kx,ky,kz) = total+1
               n = 0
 10            if (ind .gt. 0) then
                  n = n + 1
                  total = total + 1
                  map(total) = ind
                  ind = list_next(ind)
                  goto 10
               endif
               list_info(2,kx,ky,kz) = total
               if (list_info(2,kx,ky,kz) .lt. list_info(1,kx,ky,kz))then
                  list_info(1,kx,ky,kz) = 0
                  list_info(2,kx,ky,kz) = -1
               endif
               max_per_box = max(n,max_per_box)
               min_per_box = min(n,min_per_box)
               avgsq_per_box = avgsq_per_box + n*n
            enddo
         enddo
      enddo
c
      if (total .ne. ncharge) then
         write(6,*) ' total, ncharge ', total, ncharge
         stop 23
      endif
      write(6,1) max_per_box, min_per_box, ncharge/8**depth, 
     $     sqrt(avgsq_per_box/8.0d0**depth - (ncharge/8.0d0**depth)**2)
 1    format(' Particles/box:',
     $     ' max =', i4, '; min =', i4, '; mean =', i4,
     $     '; rms =', f6.1)
c
      end
      subroutine fmm_points_to_boxes(depth, n, coords,
     $     xlo, xhi, ylo, yhi, zlo, zhi,
     $     list_next, list_info, coords_r, map)
      implicit none
#include "errquit.fh"
c
      integer depth, n
      double precision coords(3,n), coords_r(3,n)
      double precision xlo, xhi, ylo, yhi, zlo, zhi
      integer list_next(n)      ! [scratch]
      integer list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
      integer map(n)
c
c     Given a list of points in the given solution volume assign
c     the points to the FMM octree of given depth. 
c
c     Initially build a linked list associating points with each box.
c
c     list_info(1,box)  = first point in box (or 0 if none)
c     list_next(point) = next point in box (or 0 if none)
c
c     Then construct a map that reorders the points so that we return
c
c     list_info(1,box) = first reordered point in box, or 0 if none
c     list_info(2,box) = last reordered point in box, or -1 if none
c     map(reordered point) = index of actual point in coords()
c     coords_r(3,n)    = reordered point
c
c     Values computed at the reordered points can be put
c     back into the original order using
c
c     do j = 1, n
c     .    value(map(j)) = value_r(j)
c     enddo
c
      integer total
      integer kx, ky, kz, i
      double precision hx, hy, hz, xo, yo, zo, x, y, z
      integer max_per_box, min_per_box, ind, twod, ninbox
      double precision avgsq_per_box
c
      twod = 2**depth
c
      hx = (xhi-xlo)/dble(twod)  ! Size of boxes
      hy = (yhi-ylo)/dble(twod)
      hz = (yhi-ylo)/dble(twod)
      call ifill(8**depth * 2, 0, list_info, 1)
c
      do i = 1, n
         x = coords(1,i)
         y = coords(2,i)
         z = coords(3,i)
         kx = int((x-xlo)/hx)         ! Index of box containing point
         ky = int((y-ylo)/hy)
         kz = int((z-zlo)/hz)
         xo = xlo + (dble(kx)+0.5d0)*hx ! Coords of box center
         yo = ylo + (dble(ky)+0.5d0)*hy
         zo = zlo + (dble(kz)+0.5d0)*hz
         if (kx.lt.0 .or. kx.ge.twod) call errquit('fmm:p2b: x!',0,
     &       FMM_ERR)
         if (ky.lt.0 .or. ky.ge.twod) call errquit('fmm:p2b: y!',0,
     &       FMM_ERR)
         if (kz.lt.0 .or. kz.ge.twod) call errquit('fmm:p2b: z!',0,
     &       FMM_ERR)
c
         list_next(i) = list_info(1,kx,ky,kz)
         list_info(1,kx,ky,kz) = i
      end do
c
      max_per_box = 0
      min_per_box = n
      avgsq_per_box = 0
      total = 0
c      
      do kz = 0, twod-1
         do ky = 0, twod-1
            do kx = 0, twod-1
               ind = list_info(1,kx,ky,kz)
               list_info(1,kx,ky,kz) = total+1
               ninbox = 0
 10            if (ind .gt. 0) then
                  ninbox = ninbox + 1
                  total = total + 1
                  map(total) = ind
                  ind = list_next(ind)
                  goto 10
               endif
               list_info(2,kx,ky,kz) = total
               if (list_info(2,kx,ky,kz) .lt. list_info(1,kx,ky,kz))then
                  list_info(1,kx,ky,kz) = 0
                  list_info(2,kx,ky,kz) = -1
               endif
               max_per_box = max(ninbox,max_per_box)
               min_per_box = min(ninbox,min_per_box)
               avgsq_per_box = avgsq_per_box + dble(ninbox)**2
            enddo
         enddo
      enddo
c
      do i = 1, n
         coords_r(1,i) = coords(1,map(i))
         coords_r(2,i) = coords(2,map(i))
         coords_r(3,i) = coords(3,map(i))
      enddo
c
      write(6,1) depth, max_per_box, min_per_box, n/8**depth, 
     $     sqrt(abs(avgsq_per_box/8.0d0**depth - (n/8.0d0**depth)**2))
 1    format(' Level ', i2,' particles/box:',
     $     ' max =', i6, '; min =', i6, '; mean =', i6,
     $     '; rms =', 1p,d9.1)
c
      end
      subroutine fmm_add_values_from_near_points(
     $     depth, kx, ky, kz,
     $     n, v_r, list_info,
     $     v_near, oldnumr)
      implicit none
#include "errquit.fh"
#include "fmmP.fh"
      integer kx, ky, kz, depth, n, numr, oldnumr
      double precision v_r(n), v_near(*)
      integer list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
c
c     Take values computed at the points formed by calling
c     fmm_make_list_of_near_points() and add them into the
c     values at coords_r(), the reordered points from 
c     fmm_points_to_boxes().
c
      integer kxn, kyn, kzn, dkx, dky, dkz, twod, ninbox, i, ii
c
      twod = 2**depth
      if (kx.lt.0 .or. kx.ge.twod) call errquit('x?',0, FMM_ERR)
      if (ky.lt.0 .or. ky.ge.twod) call errquit('y?',0, FMM_ERR)
      if (kz.lt.0 .or. kz.ge.twod) call errquit('z?',0, FMM_ERR)
c
      numr = 1
      do dkz = -well_separated, well_separated
         kzn = kz + dkz
         if (kzn.ge.0 .and. kzn.lt.twod) then
            do dky = -well_separated, well_separated
               kyn = ky + dky
               if (kyn.ge.0 .and. kyn.lt.twod) then
                  do dkx = -well_separated, well_separated
                     kxn = kx + dkx
                     if (kxn.ge.0 .and. kxn.lt.twod) then
                        ninbox = list_info(2,kxn,kyn,kzn) - 
     $                       list_info(1,kxn,kyn,kzn) + 1
                        if (ninbox .gt. 0) then
                           ii = list_info(1,kxn,kyn,kzn) 
                           do i = 0, ninbox-1
                              v_r(ii+i) = v_r(ii+i) + v_near(i+numr)
                           enddo
                           numr = numr + ninbox
                        endif
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      numr = numr - 1
      if (numr .ne. oldnumr) call errquit('fmm:avfnp confused',numr,
     &       FMM_ERR)
c
      end
      subroutine fmm_make_list_of_near_points(depth, kx, ky, kz, 
     $     n, coords_r, list_info, r, numr)
      implicit none
#include "errquit.fh"
#include "fmmP.fh"
      integer kx, ky, kz, depth, n, numr
      double precision coords_r(3,n), r(3,*)
      integer list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
c
c     From the points that have been ordered by fmm_points_to_boxes
c     return a list of points at which the box (kx, ky, kz) must
c     compute its near field potential.
c
c     r(3,1:numr) and numr are returned.  r() should probably be
c     the same dimension as coords to be safe.
c
      integer kxn, kyn, kzn, dkx, dky, dkz, twod, ninbox
c
      twod = 2**depth
      if (kx.lt.0 .or. kx.ge.twod) call errquit('x?',0, FMM_ERR)
      if (ky.lt.0 .or. ky.ge.twod) call errquit('y?',0, FMM_ERR)
      if (kz.lt.0 .or. kz.ge.twod) call errquit('z?',0,
     &       FMM_ERR)
c
      numr = 1
      do dkz = -well_separated, well_separated
         kzn = kz + dkz
         if (kzn.ge.0 .and. kzn.lt.twod) then
            do dky = -well_separated, well_separated
               kyn = ky + dky
               if (kyn.ge.0 .and. kyn.lt.twod) then
                  do dkx = -well_separated, well_separated
                     kxn = kx + dkx
                     if (kxn.ge.0 .and. kxn.lt.twod) then
                        ninbox = list_info(2,kxn,kyn,kzn) - 
     $                       list_info(1,kxn,kyn,kzn) + 1
                        if (ninbox .gt. 0) then
                           call dcopy(3*ninbox,
     $                          coords_r(1,list_info(1,kxn,kyn,kzn)), 1,
     $                          r(1,numr), 1)
                           numr = numr + ninbox
                        endif
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
      numr = numr - 1
c
      end
      double precision function fmm_direct_potential(
     $     lmax, depth,
     $     dimx, dimy, dimz, x, y, z,
     $     coords, charges, ncharge, list_info, map)
      implicit none
#include "errquit.fh"
#include "fmmP.fh"
      integer lmax, depth
      double precision dimx, dimy, dimz, x, y, z
      integer ncharge
      double precision charges(ncharge), coords(3,ncharge)
      integer list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
      integer map(ncharge)
c
c     Evaluate the direct local potential at the given point
c     ... i.e., directly sum interactions within the box
c     containing the point and immediate neighbours
c
      integer kx, ky, kz, kxn, kyn, kzn, dkx, dky, dkz, twod
      integer i, ii
      double precision hx, hy, hz, xx, yy, zz, potential
c
      twod = 2**depth
      hx = dimx/dble(twod)  ! Size of boxes
      hy = dimy/dble(twod)
      hz = dimz/dble(twod)
      kx = int(x/hx) ! Index of box containing point
      ky = int(y/hy) ! Index of box containing point
      kz = int(z/hz) ! Index of box containing point
c
      if (kx.lt.0 .or. kx.ge.twod) call errquit('x?',0, FMM_ERR)
      if (ky.lt.0 .or. ky.ge.twod) call errquit('y?',0,
     &       FMM_ERR)
      if (kz.lt.0 .or. kz.ge.twod) call errquit('z?',0, FMM_ERR)
c
      potential = 0.0d0
c
      do dkz = -well_separated, well_separated
         kzn = kz + dkz
         if (kzn.ge.0 .and. kzn.lt.twod) then
            do dky = -well_separated, well_separated
               kyn = ky + dky
               if (kyn.ge.0 .and. kyn.lt.twod) then
                  do dkx = -well_separated, well_separated
                     kxn = kx + dkx
                     if (kxn.ge.0 .and. kxn.lt.twod) then
                        do ii = list_info(1,kxn,kyn,kzn), 
     $                       list_info(2,kxn,kyn,kzn)
                           i = map(ii)
                           xx = coords(1,i) - x
                           yy = coords(2,i) - y
                           zz = coords(3,i) - z
                           potential = potential + charges(i)/
     $                          sqrt(xx*xx + yy*yy + zz*zz)
                        enddo
                     endif
                  enddo
               endif
            enddo
         endif
      enddo
c
      fmm_direct_potential = potential
c
      end
      subroutine fmm_potential_at_charges2(lmax, depth,dimx,dimy,dimz,
     $     potential, coords, charges, ncharge, list_info, pot)
      implicit none
#include "errquit.fh"
#include "fmmP.fh"
      integer lmax, depth
      double precision dimx, dimy, dimz
      double precision potential((lmax+1)**2,
     $     0:2**depth-1,0:2**depth-1,0:2**depth-1)
      integer ncharge
      double precision charges(ncharge), coords(3,ncharge), pot(ncharge)
      integer list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
c     
c     Evaluate the near and far field potentials at all charges
c     returning the result in pot
c     
      integer kx, ky, kz, i, l, m, kxn, kyn, kzn, ind
      integer twod, j, dkyhi, dkxhi
      integer kxnlo, kynlo, kznlo
      double precision hx, hy, hz, xo, yo, zo, sum, 
     $     x, y, z, xx, yy, zz, rdist

      integer lq
      parameter (lq = FMM_LMAX)
      double precision w(-lq:lq,0:lq)
      double precision xlm_local_potential
      external xlm_local_potential
c     
      if (lmax .gt. lq) call errquit('fmm_pac2: lmax>lq', lmax, FMM_ERR)
      twod = 2**depth
      hx = dimx/dble(twod)  ! Size of boxes
      hy = dimy/dble(twod)
      hz = dimz/dble(twod)
c
      do i = 1, ncharge
         pot(i) = 0.0d0
      enddo
c
      do kz = 0, twod-1
         do ky = 0, twod-1
            do kx = 0, twod-1
               xo = (dble(kx)+0.5d0)*hx ! Coords of box center
               yo = (dble(ky)+0.5d0)*hy
               zo = (dble(kz)+0.5d0)*hz
c     
c     Compute the far field term
c     
               do i = list_info(1,kx,ky,kz),list_info(2,kx,ky,kz)
                  x = coords(1,i)
                  y = coords(2,i)
                  z = coords(3,i)
                  sum = 0.0d0
                  call xlm(lmax, x-xo, y-yo, z-zo, w, lq)
                  ind = 1
                  do l = 0, lmax
                     do m = -l,l
                        sum = sum + w(m,l)*potential(ind,kx,ky,kz)
                        ind = ind + 1
                     end do
                  end do
                  pot(i) = pot(i) + sum
               enddo
c     
c     Near field terms
c
               do i = list_info(1,kx,ky,kz),list_info(2,kx,ky,kz)
                  x = coords(1,i)
                  y = coords(2,i)
                  z = coords(3,i)
                  sum = 0.0d0
                  do j = list_info(1,kx,ky,kz), i-1
                     xx = coords(1,j) - x
                     yy = coords(2,j) - y
                     zz = coords(3,j) - z
                     rdist = 1.0d0/sqrt(xx*xx+yy*yy+zz*zz)
                     sum = sum + charges(j)*rdist
                     pot(j) = pot(j) + charges(i)*rdist
                  enddo
                  pot(i) = pot(i) + sum
               enddo
c
               kxnlo = max(0,kx-well_separated)
               kynlo = max(0,ky-well_separated)
               kznlo = max(0,kz-well_separated)
               do kzn = kznlo, kz
                  dkyhi = well_separated
                  if (kz .eq. kzn) dkyhi = 0
                  do kyn = kynlo, min(twod-1,ky+dkyhi)
                     dkxhi = well_separated
                     if (kz.eq.kzn .and. ky.eq.kyn) dkxhi = -1
                     do kxn = kxnlo, min(twod-1,kx+dkxhi)
                        do j = list_info(1,kxn,kyn,kzn),
     $                       list_info(2,kxn,kyn,kzn)
                           x = coords(1,j)
                           y = coords(2,j)
                           z = coords(3,j)
                           sum = 0.0d0
                           do i = list_info(1,kx,ky,kz), 
     $                          list_info(2,kx,ky,kz)
                              xx = coords(1,i) - x
                              yy = coords(2,i) - y
                              zz = coords(3,i) - z
                              rdist = 1.0d0/sqrt(xx*xx+yy*yy+zz*zz)
                              sum = sum + charges(i)*rdist
                              pot(i) = pot(i) + charges(j)*rdist
                           enddo
                           pot(j) = pot(j) + sum
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      end
      subroutine fmm_potential_at_charges(lmax, depth,dimx,dimy,dimz,
     $     potential, coords, charges, ncharge, list_info, pot)
      implicit none
#include "errquit.fh"
#include "fmmP.fh"
      integer lmax, depth
      double precision dimx, dimy, dimz
      double precision potential((lmax+1)**2,
     $     0:2**depth-1,0:2**depth-1,0:2**depth-1)
      integer ncharge
      double precision charges(ncharge), coords(3,ncharge), pot(ncharge)
      integer list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
c     
c     Evaluate the near and far field potentials at all charges
c     returning the result in pot
c     
      integer kx, ky, kz, i, l, m, kxn, kyn, kzn, ind
      integer twod, j, dkyhi, dkxhi
      integer kxnlo, kynlo, kznlo
      double precision hx, hy, hz, xo, yo, zo, sum, 
     $     x, y, z, xx, yy, zz, rdist

      integer lq
      parameter (lq = FMM_LMAX)
      double precision w(-lq:lq,0:lq)
      double precision xlm_local_potential
      external xlm_local_potential
c     
      if (lmax .gt. lq) call errquit('fmm_pac: lmax>lq', lmax, FMM_ERR)
      twod = 2**depth
      hx = dimx/dble(twod)  ! Size of boxes
      hy = dimy/dble(twod)
      hz = dimz/dble(twod)
c
      do i = 1, ncharge
         pot(i) = 0.0d0
      enddo
c
      do i = 1, ncharge
         x = coords(1,i)
         y = coords(2,i)
         z = coords(3,i)
         kx = int(x/hx)         ! Index of box containing point
         ky = int(y/hy)         ! Index of box containing point
         kz = int(z/hz)         ! Index of box containing point
         xo = (dble(kx)+0.5d0)*hx ! Coords of box center
         yo = (dble(ky)+0.5d0)*hy
         zo = (dble(kz)+0.5d0)*hz
c
         sum = 0.0d0
c
c     Compute the far field term
c
         call xlm(lmax, x-xo, y-yo, z-zo, w, lq)
         ind = 1
         do l = 0, lmax
            do m = -l,l
               sum = sum + w(m,l)*potential(ind,kx,ky,kz)
               ind = ind + 1
            end do
         end do
c     
c     Near field terms ... avoiding current charge
c
         do j = list_info(1,kx,ky,kz), list_info(2,kx,ky,kz)
            if (j .gt. i) then
               xx = coords(1,j) - x
               yy = coords(2,j) - y
               zz = coords(3,j) - z
               rdist = 1.0d0/sqrt(xx*xx+yy*yy+zz*zz)
               sum = sum + charges(j)*rdist
               pot(j) = pot(j) + charges(i)*rdist
            endif
         enddo
c
         kxnlo = max(0,kx-well_separated)
         kynlo = max(0,ky-well_separated)
         kznlo = max(0,kz-well_separated)
         do kzn = kznlo, kz
            dkyhi = well_separated
            if (kz .eq. kzn) dkyhi = 0
            do kyn = kynlo, min(twod-1,ky+dkyhi)
               dkxhi = well_separated
               if (kz.eq.kzn .and. ky.eq.kyn) dkxhi = -1
               do kxn = kxnlo, min(twod-1,kx+dkxhi)
                  do j = list_info(1,kxn,kyn,kzn), 
     $                 list_info(2,kxn,kyn,kzn)
                     xx = coords(1,j) - x
                     yy = coords(2,j) - y
                     zz = coords(3,j) - z
                     rdist = 1.0d0/sqrt(xx*xx+yy*yy+zz*zz)
                     sum = sum + charges(j)*rdist
                     pot(j) = pot(j) + charges(i)*rdist
                  enddo
               enddo
            enddo
         enddo
c
         pot(i) = pot(i) + sum
c
      enddo
      end
      subroutine fmm(lmax, depth, dimx, dimy, dimz, 
     $     mpoles, otree, mpoles0, work, lwork)
      implicit none
#include "errquit.fh"
      double precision flops, flopsv, flopst, calls
      common /xlmflops/flops, flopsv, flopst, calls
c
c     Given a regular power-of-two grid of unnormalized, real
c     multipoles, sum the far-field interactions using FMM.
c     Optionally allow multipoles to be defined on coarser grids
c     going up the octree (otree=.true.).
c
c     The FMM results in a local spherical Taylor series associated
c     with each cell at the finest level from which the far-field 
c     potential may be computed by calling xlm_local_potenial.
c     
c     The direct interaction of each cell with its eight immediate 
c     neighbours and the interactions within a cell are NOT computed 
c     here and must be formed by other means.
c
c     Arguments
c
c     lmax  = Maximum order of multipole to use.  The error is
c     .       proportional to 2**(-lmax).
c
c     depth = level of the tree at which multipoles are provided
c     .       There will be 8**depth boxes.  Depth can be anything
c     .       greater than zero, but for efficiency should be at
c     .       least 3 and probably no more than 7.
c     .       (depth=0 means one box covers the whole domain)
c
c     dimx/y/z= The volume of the summation.  Boxes at
c     .       a given level are labelled k=0,...,2**level-1 for
c     .       each of x,y,z.  The width of each box is 
c     .       hx=dimx/2**level.  The center of each box, at which
c     .       both multipoles and local taylor series are centered,
c     .       is given by xlo+(k+0.5)*hx where xlo is the coordinate
c     .       of the bottom-left-front corner of the box in user
c     .       space.
c     
c     mpoles(lenxlm,2**depth,2**depth,2**depth)
c     .       Inputs the multipoles within each box about the box center.
c     .       The definition of the multipoles corresponds to the unnormalized
c     .       real solid spherical harmonics as computed by xlm().  The
c     .       routine xlm_coeff() can also be use to transform from simple
c     .       cartesian moments to this basis.  See xlm_pack/unpack
c     .       for the compressed storage format.
c     .       lenxlm = sum(l=0,lmax)(2*l+1) = (lmax+1)**2
c     .
c     .       Returns the spherical Taylor series expansions.  The potential
c     .       at a point within a box may be computed from the corresponding
c     .       series by
c     .           double precision q(-lq:lq,0:lmax) ! lq>= lmax
c     .           call xlm_unpack(lmax, mpoles(1,kx,ky,kz), q, lq)
c     .           u = xlm_local_potential(x,y,z,q,lq,lmax)
c     .       where x,y,z are the coordinates relative to the center of
c     .       the box, and kx,ky,kz label the box as described above.
c
c     otree = If false, then mpoles is as described above, which specifies
c     .       the multipole moments associated with just the finest level.
c     .
c     .       If true, then multipoles may be specified at all levels of
c     .       the octree and mpoles() consists of the concatenated grids
c     .       starting with the finest and will be of dimension 
c     .       lenxlm**8^(depth+1)-1)/7.  The effect of otree=false may
c     .       be emulated with otree=true by just specifying mpoles
c     .       at the finest level and providing zeroes at the other levels.
c
c     mpoles0(-lmax:lmax,0:lmax)
c     .       Returns the multipole moments at level=0 (the whole domain).
c
c     work(lwork)
c     .       Scratch workspace.  
c     .       lwork >= lenxlm*2*[sum(k=0,depth)8^k]
c     .             >= lenxlm*2*(8^(depth+1)-1)/7
c
      integer lmax, depth, lwork, mptr
      double precision dimx, dimy, dimz
      double precision mpoles((lmax+1)**2,*)
      double precision work((lmax+1)**2,*)
      double precision mpoles0(-lmax:lmax,0:lmax)
      logical otree
c
      integer lenxlm, poles, parent_poles, level,
     $     potential, parent_potential
      
      integer luse(32768)

      flops = 0
      flopsv= 0
      flopst= 0
      calls = 0

      call xlm_init

      lenxlm = (lmax+1)**2

      if (lwork/lenxlm .lt. 2*((8**(depth+1)-1)/7)) 
     $     call errquit('fmm: lwork must be ',0, 2*((8**(depth+1)-1)/7),
     &       FMM_ERR)

c     In the initial debug implementation copy all data into
c     workspace and copy results back.  Will do a memory
c     saving version later.  So for now, work is organized
c     as follows
c     level=depth   potential+mpoles
c     level=depth-1 potential+mpoles
c     ...
c     level=0       potential+mpoles
c
*****      call dfill(lwork, 0.0d0, work, 1)
      call dcopy(lenxlm*(8**depth), mpoles, 1, work, 1)
c
c     Upward pass
c
c
      parent_poles = 1
      do level = depth, 1, -1

         poles        = parent_poles
         potential    = poles + (8**level)
         parent_poles = poles + (8**level)*2
c
         if ((parent_poles+2*8**(level-1)-1)*lenxlm .gt. lwork) 
     $        call errquit('xxxxxxx?',0, FMM_ERR)
c
c     Pass multipoles up to the parent and pass short-range potential
c     to neighbours at the current level.  If we have source terms
c     on the parent level (otree=true) then copy them, otherwise
c     zero the parent poles.
c
         if (otree) then
            mptr = (parent_poles-1)/2 + 1
            call dcopy(lenxlm*(8**(level-1)), mpoles(1,mptr), 1,
     $           work(1,parent_poles), 1)
         else
            call dfill(lenxlm*(8**(level-1)), 0.0d0,
     $           work(1,parent_poles), 1)
         endif
         call dfill(lenxlm*(8**level), 0.0d0, work(1,potential), 1)
c
         call fmm_pass1(lmax, level, dimx, dimy, dimz,
     $        work(1,poles), work(1,potential), work(1,parent_poles),
     $        luse)
c
         if (level .eq. 1) then
            call xlm_unpack(lmax, work(1,parent_poles),
     $           mpoles0, lmax)
         end if
c
      end do
c
c     Downward pass ... note value of pointer potential is used from above
c     (the last level at which a local potential was computed was 1
c     ... this is actually zero since no suitable neighbours exist
c     until level 2).
c
      do level = 2, depth
         parent_potential = potential
         potential = parent_potential - 8**(level-1) - 8**level

         call fmm_pass2(lmax, level, 
     $        dimx, dimy, dimz, 
     $        work(1,parent_potential), work(1,potential))
      end do
c
      call dcopy(lenxlm*(8**depth), work(1,potential), 1, mpoles, 1)
c
*      write(6,*) ' flops calls ', flops,flopsv,flopst,calls
c
      end
      subroutine fmm_pass1(lmax, level, dimx, dimy, dimz,
     $     poles, potential, parent_poles, luse)
      implicit none
#include "errquit.fh"
#include "fmmP.fh"
      integer lmax, level
      double precision dimx, dimy, dimz
      double precision poles((lmax+1)**2,
     $     0:2**level-1,0:2**level-1,0:2**level-1)
      double precision potential((lmax+1)**2,
     $     0:2**level-1,0:2**level-1,0:2**level-1)
      double precision parent_poles((lmax+1)**2,
     $     0:2**(level-1)-1,0:2**(level-1)-1,0:2**(level-1)-1)
      integer luse(0:2**level-1,0:2**level-1,0:2**level-1)
c     
      double precision hx, hy, hz, x, y, z, xn, yn, zn, xp, yp, zp
      double precision xx, yy, zz
      integer dkx, dky, dkz, l, ln, m
      integer kx, ky, kz, kxn, kyn, kzn, kxp, kyp, kzp
      integer lq
      parameter (lq = FMM_LMAX)
      double precision q(-lq:lq,0:lq), qn(-lq:lq,0:lq)
      double precision p(-lq:lq,0:lq), pn(-lq:lq,0:lq)
      double precision scale, scale0
      integer lmaxeff, lmaxeffn, hi, lo, twol, ind, indn
      integer lusemin
      parameter (lusemin = 6)
c
c     If in_all_boxes is true, then the potential is transferred even
c     to boxes that do not contain charges.  If you only want to compute
c     the potential at the location of charges, set in_all_boxes false.
c
      logical in_all_boxes
      parameter (in_all_boxes = .true.)
c
c     Note that to localize memory references even though
c     q(), etc., are dimensioned lq>=lmax, we are telling the
c     subroutines below they are dimensioned lmax, thus the
c     arrays are NOT easily used in this routine.
c
      if (lq .lt. lmax) call errquit('fmm_p_m_u: lq ', lmax, FMM_ERR)
c
      twol = 2**level
c     
      hx = dimx/dble(twol)
      hy = dimy/dble(twol)
      hz = dimz/dble(twol)
c     
      scale0 = (well_separated+1d0)/0.87d0 - 1.0d0

      do kz = 0, twol-1
         do ky = 0, twol-1
            do kx = 0, twol-1
               call xlm_unpack(lmax,poles(1,kx,ky,kz),q,lq)
               do l = lmax, 0, -1
                  do m = -l,l
                     if (abs(q(m,l)).ne.0.0d0) goto 33
                  enddo
               enddo
 33            luse(kx,ky,kz) = l
            enddo
         enddo
      enddo
c     
      do kz = 0, twol-1
         do ky = 0, twol-1
            do kx = 0, twol-1
               x = (dble(kx)+0.5d0)*hx ! Coords of current box center
               y = (dble(ky)+0.5d0)*hy
               z = (dble(kz)+0.5d0)*hz
c     
               l = luse(kx,ky,kz)
               if (l .ge. 0) then
                  call xlm_unpack(lmax,poles(1,kx,ky,kz),q,lmax)
                  kxp = kx/2    ! Parent box indices
                  kyp = ky/2
                  kzp = kz/2
                  xp = (dble(kxp)+0.5d0)*hx*2.0d0 ! Coords of parent box
                  yp = (dble(kyp)+0.5d0)*hy*2.0d0
                  zp = (dble(kzp)+0.5d0)*hz*2.0d0
c     
c     Pass multipoles up to parent (note that this destroys q so
c     must unpack again afterwards)
c     
                  call xlm_translate(lmax, xp-x, yp-y, zp-z, q, lmax)
                  call xlm_accumulate_to_packed
     $                 (lmax,parent_poles(1,kxp,kyp,kzp),q,lmax)
               endif
c     
c     Propagate local taylor series expansion
c     
               ind = kx+twol*(ky+twol*kz)
               lo = 2*well_separated
               hi = 2*well_separated + 1
               if (l .ge. 0) call xlm_unpack
     $              (lmax,poles(1,kx,ky,kz),q,lmax)
               do kzn = max(0,int(kz/2)*2-lo),
     $              min(twol-1,int(kz/2)*2+hi)
                  dkz = abs(kzn - kz)
                  do kyn = max(0,int(ky/2)*2-lo),
     $                 min(twol-1,int(ky/2)*2+hi)
                     dky = abs(kyn - ky)
                     do kxn = max(0,int(kx/2)*2-lo),
     $                    min(twol-1,int(kx/2)*2+hi)
                        dkx = abs(kxn - kx)
                        indn = kxn+twol*(kyn+twol*kzn)
                        if ((dkx.gt.well_separated .or.
     $                       dky.gt.well_separated .or.
     $                       dkz.gt.well_separated) .and.
     $                       indn.gt.ind) then
c     
c     Limit precision if possible for distant boxes.  h*sqrt(3)/2 is the
c     distance of the corner of a cube from its center.
c     
                           ln = luse(kxn,kyn,kzn)
                           lmaxeff  = l
                           lmaxeffn = ln
                           if (ln.ge.0 .or. l.ge.0) then
                              xn = (dble(kxn)+0.5d0)*hx
                              yn = (dble(kyn)+0.5d0)*hy
                              zn = (dble(kzn)+0.5d0)*hz
                              xx = xn - x
                              yy = yn - y
                              zz = zn - z
                              scale = sqrt(xx*xx+yy*yy+zz*zz)
                              scale = scale / (0.87d0*hx) - 1.0d0
                              scale = log(scale0)/log(scale)
*                              scale = 1.0d0
                           endif
                           if (ln .ge. 0) then 
                              call xlm_unpack(lmax,
     $                             poles(1,kxn,kyn,kzn), qn, lmax)
                              lmaxeffn = min(ln,max(6,nint(lmax*scale)))
                           endif
                           if (l .ge. 0) then 
                              lmaxeff = min(l,max(6,nint(lmax*scale)))
                           endif
c
                           if (lmaxeff.ge.0 .and. lmaxeffn.ge.0) then
                              call xlm_new_multipole_to_local(lmaxeff, 
     $                             xn, yn, zn, pn, lmax,x,y,z,q,lmax)
                              call xlm_accumulate_to_packed(lmaxeff,
     $                             potential(1,kxn,kyn,kzn),pn,lmax)
                              call xlm_new_multipole_to_local(lmaxeffn, 
     $                             x, y, z, p, lmax, xn, yn, zn,qn,lmax)
                              call xlm_accumulate_to_packed(lmaxeffn,
     $                             potential(1,kx,ky,kz),p,lmax)
                           else if (lmaxeff.ge.0.and.in_all_boxes) then
                              call xlm_new_multipole_to_local(lmaxeff, 
     $                             xn, yn, zn, pn, lmax, x,y,z,q,lmax)
                              call xlm_accumulate_to_packed(lmaxeff,
     $                             potential(1,kxn,kyn,kzn),pn,lmax)
                           else if (lmaxeffn.ge.0.and.in_all_boxes) then
                              call xlm_new_multipole_to_local(lmaxeffn, 
     $                             x, y, z, p, lmax, xn, yn,zn,qn,lmax)
                              call xlm_accumulate_to_packed(lmaxeffn,
     $                             potential(1,kx,ky,kz),p,lmax)
                           endif
                        end if
                     end do
                  end do
               end do
            end do
         end do
      end do
c
      end
      subroutine fmm_pass2(lmax, level, 
     $     dimx, dimy, dimz, parent_potential, potential)
      implicit none
#include "errquit.fh"
      integer lmax, level
      double precision dimx, dimy, dimz
      double precision potential((lmax+1)**2,
     $     0:2**level-1,0:2**level-1,0:2**level-1)
      double precision parent_potential((lmax+1)**2,
     $     0:2**(level-1)-1,0:2**(level-1)-1,0:2**(level-1)-1)
c
      double precision hx, hy, hz, x, y, z, xp, yp, zp
      integer kx, ky, kz, kxp, kyp, kzp
      integer lq
      parameter (lq = FMM_LMAX)
      double precision q((2*lq+1)*(lq+1))
c
      if (lq .lt. lmax) call errquit('fmm_p_f_a: lq ', lmax, FMM_ERR)
c
      hx = dimx/dble(2**level)
      hy = dimy/dble(2**level)
      hz = dimz/dble(2**level)
c
      do kz = 0, 2**level-1
         do ky = 0, 2**level-1
            do kx = 0, 2**level-1
               x = (dble(kx)+0.5d0)*hx ! Coords of current box center
               y = (dble(ky)+0.5d0)*hy
               z = (dble(kz)+0.5d0)*hz
               kxp = kx/2       ! Parent box indices
               kyp = ky/2
               kzp = kz/2
               xp = (dble(kxp)+0.5d0)*hx*2.0d0 ! Coords of parent box
               yp = (dble(kyp)+0.5d0)*hy*2.0d0
               zp = (dble(kzp)+0.5d0)*hz*2.0d0
               call xlm_unpack(lmax, parent_potential(1,kxp,kyp,kzp), 
     $              q, lmax)
               call xlm_local_translate(lmax,x-xp,y-yp,z-zp,q,lmax)
               call xlm_accumulate_to_packed(lmax,
     $              potential(1,kx,ky,kz),q,lmax)
            end do
         end do
      end do
c
      end
c$$$      subroutine fmm_multipole_to_local_rot(lmax, 
c$$$     $     xn, yn, zn, pn, lp, x, y, z, q, lq)
c$$$      implicit none
c$$$#include "xlm.fh"
c$$$c     
c$$$      integer lmax, lq, lp
c$$$      double precision xn, yn, zn, x, y, z
c$$$      double precision q(-lq:lq,0:lmax), pn(-lp:lp,0:lp)
c$$$c
c$$$      double precision theta, phi, r, pi
c$$$      double precision qq(-maxl:maxl,0:maxl)
c$$$      integer l, m
c$$$c
c$$$c     Determine the rotation angle
c$$$c
c$$$      pi = 4.0d0*atan(1.0d0)
c$$$      call fmm_xyz_to_phi_theta(xn-x,yn-y,zn-z,phi,theta)
c$$$*      write(6,*) ' doing it ', xn, yn, zn, x, y, z, 
c$$$*     $     theta*180.0d0/pi, phi*180.0d0/pi
c$$$c      
c$$$c     Rotate the source multipoles
c$$$c
c$$$      do l = 0, lmax
c$$$         do m = -l, l
c$$$            qq(m,l) = 2.0d0*q(m,l) * (b(m,l)*c(m,l))
c$$$         enddo
c$$$         qq(0,l) = qq(0,l) * 0.5d0
c$$$      enddo
c$$$c
c$$$*      write(6,*) ' before phi ', phi
c$$$*      call xlm_print(lmax,q,lq)
c$$$      call xlm_apply_z_rotation(lmax,phi,qq,maxl)
c$$$*      write(6,*) ' after phi ', phi
c$$$*      call xlm_print(lmax,q,lq)
c$$$      call xlm_apply_y_rotation(lmax,theta,qq,maxl)
c$$$c
c$$$      do l = 0, lmax
c$$$         do m = -l, l
c$$$            qq(m,l) = 0.5d0*qq(m,l) / (b(m,l)*c(m,l))
c$$$         enddo
c$$$         qq(0,l) = qq(0,l) * 2.0d0
c$$$      enddo
c$$$c
c$$$c     Translate 0,0,r
c$$$c
c$$$      r = sqrt((xn-x)**2 + (yn-y)**2 + (zn-z)**2)
c$$$      call xlm_multipole_to_local_z(lmax, 
c$$$     $     r, pn, lp, qq, maxl)
c$$$*      call xlm_multipole_to_local(lmax, 
c$$$*     $     0.0d0, 0.0d0, r, pn, lp, 0.0d0, 0.0d0, 0.0d0, qq, maxl)
c$$$c
c$$$c     Rotate the potentials back
c$$$c     
c$$$*      write(6,*) ' before -phi ', -phi
c$$$*      call xlm_print(lmax,pn,lp)
c$$$      call xlm_apply_y_rotation(lmax,-theta,pn,lp)
c$$$*      write(6,*) ' after -phi ', -phi
c$$$*      call xlm_print(lmax,pn,lp)
c$$$      call xlm_apply_z_rotation(lmax,-phi,pn,lp)
c$$$c
c$$$      end



      subroutine fmm_xyz_to_phi_theta(xx, yy, zz,
     $     phi, theta)
      implicit none
      double precision xx, yy, zz
      double precision theta, phi
c
c     dx, dy, dz are integer coordinates of a box relative to
c     origin ... determine the spherical coords
c     
      double precision r, x, y, z
c
      x = xx
      y = yy
      z = zz
c
      if (x.eq.0.0d0 .and. y.eq.0.0d0) then
         phi = 0.0d0
         theta = 0.0d0
      else 
         r = sqrt(x*x + y*y + z*z)
         z = z/r
         if (abs(z) .gt. 1.0d0) z = sign(1.0d0,z)
         theta = acos(z)
         phi = atan2(y,x)
      endif
c
      end

c
c $Id: hnd_hlf_ij.F 19696 2010-10-29 16:53:42Z d3y133 $
c
c Modified from HONDO
c
      subroutine hnd_hlf_ij2(xyzi,expi,coefi,i_nprim,i_ngen, Li,
     1  xyzj,expj,coefj, j_nprim, j_ngen, Lj, kat, dvij, ddvij,
     2  zan, xyz, nder, nint, scr,lscr)
c
c This is a wrapper routine, setting up scratch blocks used in actual
c integral routine
c
      implicit none
      integer i_nprim  ! [input] num. prims on function i
      integer i_ngen   ! [input] num general conts on func. i
      integer Li       ! [input] angular momentum of func. i
      integer j_nprim  ! [input] num. prims on function j
      integer j_ngen   ! [input] num general conts on func. j
      integer Lj       ! [input] angular momentum of func. j
      integer nder     ! [input] 1=1rst der; 2=2nd der
      integer nint     ! [input] number of base integrals
      integer kat      ! [input] lexical number of an atom
      integer lscr     ! [input] length of scratch space
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim)  ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen)  ! [input] j coeffs
      double precision xyz(3,*)  ! [input] all atom positions
      double precision dvij(nint,3) ! [output] 1rst. der integrals
      double precision ddvij(nint,3,3) ! [output] 2nd der integrals
      double precision zan(*)   ! [input] nuclear charges
      double precision scr(lscr) ! [input] scratch buffer
c
# include "hnd_pointers.fh"
c
c Use scratch for temps in integral calculation
c Scratch needs are dependent on nder:
c nder=1 (6 * (Li+1)*(Lj+1)*((Li+Lj+2)/2+1) + 3 0.0d0 length blocks
c nder=2 (9 * (Li+1)*(Lj+1)*((Li+Lj+2)/2+1)
c
c The pointers are defined in hnd_pointers.fh
c
      call hnd_hlf_ij21(xyzi,expi,coefi,i_nprim,i_ngen, Li,
     2     xyzj,expj,coefj, j_nprim, j_ngen, Lj, kat, dvij, ddvij,
     3     zan, xyz, nder, nint,
     4     scr(tvp(22)),scr(tvp(23)),scr(tvp(24)),
     5     scr(tvp(25)),scr(tvp(26)),scr(tvp(27)),
     6     scr(tvp(46)),scr(tvp(47)),scr(tvp(48)))
c
      return
      end
c
      subroutine hnd_hlf_ij21(xyzi,expi,coefi,i_nprim,i_ngen, Li,
     1  xyzj,expj,coefj, j_nprim, j_ngen, Lj, kat, dvij, ddvij,
     2  zan, xyz, nder, nint,xv,yv,zv,dxv,dyv,dzv,ddxv,ddyv,ddzv)
c
c  This is the routine that actually computes the 1rst and 2nd
c  derivatives for the Helman-Feynman term.  It is assumed that the buffers
c  for the integrals have been 0.0d0ed before entering this routine.
c
      implicit none
#include "stdio.fh"
#include "hnd_rys.fh"
#include "hnd_tol.fh"
#include "errquit.fh"
      integer i_nprim  ! [input] num. prims on function i
      integer i_ngen   ! [input] num general conts on func. i
      integer Li       ! [input] angular momentum of func. i
      integer j_nprim  ! [input] num. prims on function j
      integer j_ngen   ! [input] num general conts on func. j
      integer Lj       ! [input] angular momentum of func. j
      integer nder     ! [input] 1=1rst der; 2=2nd der
      integer nint     ! [input] number of base integrals
      integer kat      ! [input] lexical number of an atom
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim)  ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen)  ! [input] j coeffs
      double precision xyz(3,*)  ! [input] all atom positions
      double precision dvij(nint,3) ! [output] 1rst. der integrals
      double precision ddvij(nint,3,3) ! [output] 2nd der integrals
      double precision zan(*)   ! [input] nuclear charges
c
      character*8 errmsg
      common/hnd_xyzder/xint,yint,zint,tx,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     1                             ni,nj,cx,cy,cz
      double precision xint, yint, zint, tx, x0, y0, z0, xi, yi, zi
      double precision xj, yj, zj, cx, cy, cz
      double precision ijx, ijy, ijz
      double precision rln10, tol, rr, ai, aj, arri
      double precision axi, ayi, azi, csi, cpi, cdi, cfi, cgi
      double precision aa, aa1, dum, fac, csj, cpj, cdj, cfj, cgj
      double precision ax, ay, az, dum1, dum2, pij
      double precision dumx, dumy, dumz, dumxx, dumyy, dumzz
      double precision dumxy, dumxz, dumyz
      double precision pi212, aax, aay, aaz, znuc
      double precision uu, u2, u4, ww, w2, w4, tt, xv, yv, zv
      double precision dxv, dyv, dzv, ddxv, ddyv, ddzv
      integer ni, nj, iroot, Nxyz
      integer lit,maxi, ljt, maxj
      integer ig, jg, ij, i, j, ix, iy, iz, jx, jy, jz
      dimension   xv(Li+1,Lj+1,*),  yv(Li+1,Lj+1,*),  zv(Li+1,Lj+1,*)
      dimension  dxv(Li+1,Lj+1,*), dyv(Li+1,Lj+1,*), dzv(Li+1,Lj+1,*)
      dimension ddxv(Li+1,Lj+1,*),ddyv(Li+1,Lj+1,*),ddzv(Li+1,Lj+1,*)
      dimension Nxyz(3)
      dimension w2(maxrys),w4(maxrys)
      dimension errmsg(3)
      data errmsg /'program ','stop in ','-hlfspd-'/
      data rln10  /2.30258d+00/
      data pi212  /1.1283791670955d+00/
c
      tol =rln10*itol
c
c     ----- calculate -helfey- term -----
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi=lit*(lit+1)/2
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj=ljt*(ljt+1)/2
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
      nroots=(lit+ljt+nder-2)/2+1
      if(nroots.gt.maxrys) then
         write(luout,9997) maxrys,lit,ljt,nroots
         call hnd_hnderr(3,errmsg)
      endif
c
c     ----- i primitive -----
c
      do 7000 ig=1,i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do 6000 jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=1.0d0/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) go to 6000
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      pij=fac*csi*csj*pi212*aa1
c
c     ----- hellmann-feynman term -----
c
      aax=aa*ax
      aay=aa*ay
      aaz=aa*az
c
c     ----- kat -----
c
      znuc=-zan(kat)
      cx=xyz(1,kat)
      cy=xyz(2,kat)
      cz=xyz(3,kat)
      yy=aa*((ax-cx)**2+(ay-cy)**2+(az-cz)**2)
      call hnd_droot
      do 420 iroot=1,nroots
      uu=u9(iroot)*aa
      u2=uu
      u4=uu*uu
      ww=w9(iroot)*znuc
      w2(iroot)=ww*u2*2.0d0
      w4(iroot)=ww*u4*4.0d0
      tt=1.0d0/(aa+uu)
      tx= sqrt(tt)
      x0=(aax+uu*cx)*tt
      y0=(aay+uu*cy)*tt
      z0=(aaz+uu*cz)*tt
      do 410 j=1,ljt
      nj=j
      do 410 i=1,lit
      ni=i

      call hnd_sxyz

      xv(i,j,iroot)=xint
      yv(i,j,iroot)=yint
      zv(i,j,iroot)=zint

      call hnd_dervxyz(1)

      dxv(i,j,iroot)=xint
      dyv(i,j,iroot)=yint
      dzv(i,j,iroot)=zint

      if (nder .gt. 1) then 
         call hnd_dervxyz(2)

         ddxv(i,j,iroot)=xint
         ddyv(i,j,iroot)=yint
         ddzv(i,j,iroot)=zint
      endif
  410 continue
  420 continue
c
      ij=0
      do 450 i=1,maxi
      call getNxyz(Li,i,Nxyz)
      ix = Nxyz(1) + 1
      iy = Nxyz(2) + 1
      iz = Nxyz(3) + 1
      do 440 j=1,maxj
      call getNxyz(Lj,j,Nxyz)
      jx = Nxyz(1) + 1
      jy = Nxyz(2) + 1
      jz = Nxyz(3) + 1
      ij=ij+1
      if (nder.eq.1) then
        dumx=0.0d0
        dumy=0.0d0
        dumz=0.0d0
        do 430 iroot=1,nroots
           dumx = dumx + dxv(ix,jx,iroot)*  yv(iy,jy,iroot)*  
     1             zv(iz,jz,iroot)*w2(iroot)
           dumy = dumy + xv(ix,jx,iroot)*  dyv(iy,jy,iroot)*  
     1             zv(iz,jz,iroot)*w2(iroot)
           dumz = dumz + xv(ix,jx,iroot)*   yv(iy,jy,iroot)* 
     1            dzv(iz,jz,iroot)*w2(iroot)
  430   continue
        dumx =dumx *pij
        dumy =dumy *pij
        dumz =dumz *pij
        dvij(ij,1)=dvij(ij,1)+dumx
        dvij(ij,2)=dvij(ij,2)+dumy
        dvij(ij,3)=dvij(ij,3)+dumz
      elseif (nder.eq.2) then
        dumxx=0.0d0
        dumyy=0.0d0
        dumzz=0.0d0
        dumxy=0.0d0
        dumxz=0.0d0
        dumyz=0.0d0
        do 431 iroot=1,nroots
           dum=xv(ix,jx,iroot)*yv(iy,jy,iroot)*zv(iz,jz,iroot)*w2(iroot)
           dumxx=dumxx-dum+ ddxv(ix,jx,iroot)*  yv(iy,jy,iroot)*  
     1             zv(iz,jz,iroot)*w4(iroot)
           dumyy=dumyy-dum+   xv(ix,jx,iroot)*ddyv(iy,jy,iroot)*  
     1             zv(iz,jz,iroot)*w4(iroot)
           dumzz=dumzz-dum+   xv(ix,jx,iroot)*  yv(iy,jy,iroot)*
     1           ddzv(iz,jz,iroot)*w4(iroot)
           dumxy=dumxy+ dxv(ix,jx,iroot)* dyv(iy,jy,iroot)*  
     1             zv(iz,jz,iroot)*w4(iroot)
           dumxz=dumxz+ dxv(ix,jx,iroot)*  yv(iy,jy,iroot)* 
     1            dzv(iz,jz,iroot)*w4(iroot)
           dumyz=dumyz+  xv(ix,jx,iroot)* dyv(iy,jy,iroot)*
     1            dzv(iz,jz,iroot)*w4(iroot)
  431   continue
        dumxx=dumxx*pij
        dumyy=dumyy*pij
        dumzz=dumzz*pij
        dumxy=dumxy*pij
        dumxz=dumxz*pij
        dumyz=dumyz*pij
        ddvij(ij,1,1)=ddvij(ij,1,1)+dumxx    
        ddvij(ij,1,2)=ddvij(ij,1,2)+dumxy
        ddvij(ij,1,3)=ddvij(ij,1,3)+dumxz
        ddvij(ij,2,1)=ddvij(ij,2,1)+dumxy
        ddvij(ij,2,2)=ddvij(ij,2,2)+dumyy
        ddvij(ij,2,3)=ddvij(ij,2,3)+dumyz
        ddvij(ij,3,1)=ddvij(ij,3,1)+dumxz
        ddvij(ij,3,2)=ddvij(ij,3,2)+dumyz
        ddvij(ij,3,3)=ddvij(ij,3,3)+dumzz
      endif
c
  440 continue
  450 continue
c
 6000 continue
 7000 continue
c
      return
 9997 format(' in -hlf- , the rys quadrature is not implemented',
     1       ' beyond -nroots- = ',i3,/,
     2       ' lit,ljt,nroots = ',3i3)
      end

*> \brief \b STRTRI
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download STRTRI + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/strtri.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/strtri.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/strtri.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE STRTRI( UPLO, DIAG, N, A, LDA, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          DIAG, UPLO
*       INTEGER            INFO, LDA, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> STRTRI computes the inverse of a real upper or lower triangular
*> matrix A.
*>
*> This is the Level 3 BLAS version of the algorithm.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  A is upper triangular;
*>          = 'L':  A is lower triangular.
*> \endverbatim
*>
*> \param[in] DIAG
*> \verbatim
*>          DIAG is CHARACTER*1
*>          = 'N':  A is non-unit triangular;
*>          = 'U':  A is unit triangular.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the triangular matrix A.  If UPLO = 'U', the
*>          leading N-by-N upper triangular part of the array A contains
*>          the upper triangular matrix, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading N-by-N lower triangular part of the array A contains
*>          the lower triangular matrix, and the strictly upper
*>          triangular part of A is not referenced.  If DIAG = 'U', the
*>          diagonal elements of A are also not referenced and are
*>          assumed to be 1.
*>          On exit, the (triangular) inverse of the original matrix, in
*>          the same storage format.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -i, the i-th argument had an illegal value
*>          > 0: if INFO = i, A(i,i) is exactly zero.  The triangular
*>               matrix is singular and its inverse can not be computed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realOTHERcomputational
*
*  =====================================================================
      SUBROUTINE STRTRI( UPLO, DIAG, N, A, LDA, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JB, NB, NN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           STRMM, STRSM, STRTI2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STRTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity if non-unit.
*
      IF( NOUNIT ) THEN
         DO 10 INFO = 1, N
            IF( A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
         INFO = 0
      END IF
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'STRTRI', UPLO // DIAG, N, -1, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code
*
         CALL STRTI2( UPLO, DIAG, N, A, LDA, INFO )
      ELSE
*
*        Use blocked code
*
         IF( UPPER ) THEN
*
*           Compute inverse of upper triangular matrix
*
            DO 20 J = 1, N, NB
               JB = MIN( NB, N-J+1 )
*
*              Compute rows 1:j-1 of current block column
*
               CALL STRMM( 'Left', 'Upper', 'No transpose', DIAG, J-1,
     $                     JB, ONE, A, LDA, A( 1, J ), LDA )
               CALL STRSM( 'Right', 'Upper', 'No transpose', DIAG, J-1,
     $                     JB, -ONE, A( J, J ), LDA, A( 1, J ), LDA )
*
*              Compute inverse of current diagonal block
*
               CALL STRTI2( 'Upper', DIAG, JB, A( J, J ), LDA, INFO )
   20       CONTINUE
         ELSE
*
*           Compute inverse of lower triangular matrix
*
            NN = ( ( N-1 ) / NB )*NB + 1
            DO 30 J = NN, 1, -NB
               JB = MIN( NB, N-J+1 )
               IF( J+JB.LE.N ) THEN
*
*                 Compute rows j+jb:n of current block column
*
                  CALL STRMM( 'Left', 'Lower', 'No transpose', DIAG,
     $                        N-J-JB+1, JB, ONE, A( J+JB, J+JB ), LDA,
     $                        A( J+JB, J ), LDA )
                  CALL STRSM( 'Right', 'Lower', 'No transpose', DIAG,
     $                        N-J-JB+1, JB, -ONE, A( J, J ), LDA,
     $                        A( J+JB, J ), LDA )
               END IF
*
*              Compute inverse of current diagonal block
*
               CALL STRTI2( 'Lower', DIAG, JB, A( J, J ), LDA, INFO )
   30       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of STRTRI
*
      END
c $Id: strtri.f 24343 2013-06-22 05:35:15Z d3y133 $

*> \brief \b DHSEQR
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DHSEQR + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dhseqr.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dhseqr.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dhseqr.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DHSEQR( JOB, COMPZ, N, ILO, IHI, H, LDH, WR, WI, Z,
*                          LDZ, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            IHI, ILO, INFO, LDH, LDZ, LWORK, N
*       CHARACTER          COMPZ, JOB
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   H( LDH, * ), WI( * ), WORK( * ), WR( * ),
*      $                   Z( LDZ, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    DHSEQR computes the eigenvalues of a Hessenberg matrix H
*>    and, optionally, the matrices T and Z from the Schur decomposition
*>    H = Z T Z**T, where T is an upper quasi-triangular matrix (the
*>    Schur form), and Z is the orthogonal matrix of Schur vectors.
*>
*>    Optionally Z may be postmultiplied into an input orthogonal
*>    matrix Q so that this routine can give the Schur factorization
*>    of a matrix A which has been reduced to the Hessenberg form H
*>    by the orthogonal matrix Q:  A = Q*H*Q**T = (QZ)*T*(QZ)**T.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] JOB
*> \verbatim
*>          JOB is CHARACTER*1
*>           = 'E':  compute eigenvalues only;
*>           = 'S':  compute eigenvalues and the Schur form T.
*> \endverbatim
*>
*> \param[in] COMPZ
*> \verbatim
*>          COMPZ is CHARACTER*1
*>           = 'N':  no Schur vectors are computed;
*>           = 'I':  Z is initialized to the unit matrix and the matrix Z
*>                   of Schur vectors of H is returned;
*>           = 'V':  Z must contain an orthogonal matrix Q on entry, and
*>                   the product Q*Z is returned.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           The order of the matrix H.  N .GE. 0.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>
*>           It is assumed that H is already upper triangular in rows
*>           and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*>           set by a previous call to DGEBAL, and then passed to ZGEHRD
*>           when the matrix output by DGEBAL is reduced to Hessenberg
*>           form. Otherwise ILO and IHI should be set to 1 and N
*>           respectively.  If N.GT.0, then 1.LE.ILO.LE.IHI.LE.N.
*>           If N = 0, then ILO = 1 and IHI = 0.
*> \endverbatim
*>
*> \param[in,out] H
*> \verbatim
*>          H is DOUBLE PRECISION array, dimension (LDH,N)
*>           On entry, the upper Hessenberg matrix H.
*>           On exit, if INFO = 0 and JOB = 'S', then H contains the
*>           upper quasi-triangular matrix T from the Schur decomposition
*>           (the Schur form); 2-by-2 diagonal blocks (corresponding to
*>           complex conjugate pairs of eigenvalues) are returned in
*>           standard form, with H(i,i) = H(i+1,i+1) and
*>           H(i+1,i)*H(i,i+1).LT.0. If INFO = 0 and JOB = 'E', the
*>           contents of H are unspecified on exit.  (The output value of
*>           H when INFO.GT.0 is given under the description of INFO
*>           below.)
*>
*>           Unlike earlier versions of DHSEQR, this subroutine may
*>           explicitly H(i,j) = 0 for i.GT.j and j = 1, 2, ... ILO-1
*>           or j = IHI+1, IHI+2, ... N.
*> \endverbatim
*>
*> \param[in] LDH
*> \verbatim
*>          LDH is INTEGER
*>           The leading dimension of the array H. LDH .GE. max(1,N).
*> \endverbatim
*>
*> \param[out] WR
*> \verbatim
*>          WR is DOUBLE PRECISION array, dimension (N)
*> \endverbatim
*>
*> \param[out] WI
*> \verbatim
*>          WI is DOUBLE PRECISION array, dimension (N)
*>
*>           The real and imaginary parts, respectively, of the computed
*>           eigenvalues. If two eigenvalues are computed as a complex
*>           conjugate pair, they are stored in consecutive elements of
*>           WR and WI, say the i-th and (i+1)th, with WI(i) .GT. 0 and
*>           WI(i+1) .LT. 0. If JOB = 'S', the eigenvalues are stored in
*>           the same order as on the diagonal of the Schur form returned
*>           in H, with WR(i) = H(i,i) and, if H(i:i+1,i:i+1) is a 2-by-2
*>           diagonal block, WI(i) = sqrt(-H(i+1,i)*H(i,i+1)) and
*>           WI(i+1) = -WI(i).
*> \endverbatim
*>
*> \param[in,out] Z
*> \verbatim
*>          Z is DOUBLE PRECISION array, dimension (LDZ,N)
*>           If COMPZ = 'N', Z is not referenced.
*>           If COMPZ = 'I', on entry Z need not be set and on exit,
*>           if INFO = 0, Z contains the orthogonal matrix Z of the Schur
*>           vectors of H.  If COMPZ = 'V', on entry Z must contain an
*>           N-by-N matrix Q, which is assumed to be equal to the unit
*>           matrix except for the submatrix Z(ILO:IHI,ILO:IHI). On exit,
*>           if INFO = 0, Z contains Q*Z.
*>           Normally Q is the orthogonal matrix generated by DORGHR
*>           after the call to DGEHRD which formed the Hessenberg matrix
*>           H. (The output value of Z when INFO.GT.0 is given under
*>           the description of INFO below.)
*> \endverbatim
*>
*> \param[in] LDZ
*> \verbatim
*>          LDZ is INTEGER
*>           The leading dimension of the array Z.  if COMPZ = 'I' or
*>           COMPZ = 'V', then LDZ.GE.MAX(1,N).  Otherwize, LDZ.GE.1.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (LWORK)
*>           On exit, if INFO = 0, WORK(1) returns an estimate of
*>           the optimal value for LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>           The dimension of the array WORK.  LWORK .GE. max(1,N)
*>           is sufficient and delivers very good and sometimes
*>           optimal performance.  However, LWORK as large as 11*N
*>           may be required for optimal performance.  A workspace
*>           query is recommended to determine the optimal workspace
*>           size.
*>
*>           If LWORK = -1, then DHSEQR does a workspace query.
*>           In this case, DHSEQR checks the input parameters and
*>           estimates the optimal workspace size for the given
*>           values of N, ILO and IHI.  The estimate is returned
*>           in WORK(1).  No error message related to LWORK is
*>           issued by XERBLA.  Neither H nor Z are accessed.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>             =  0:  successful exit
*>           .LT. 0:  if INFO = -i, the i-th argument had an illegal
*>                    value
*>           .GT. 0:  if INFO = i, DHSEQR failed to compute all of
*>                the eigenvalues.  Elements 1:ilo-1 and i+1:n of WR
*>                and WI contain those eigenvalues which have been
*>                successfully computed.  (Failures are rare.)
*>
*>                If INFO .GT. 0 and JOB = 'E', then on exit, the
*>                remaining unconverged eigenvalues are the eigen-
*>                values of the upper Hessenberg matrix rows and
*>                columns ILO through INFO of the final, output
*>                value of H.
*>
*>                If INFO .GT. 0 and JOB   = 'S', then on exit
*>
*>           (*)  (initial value of H)*U  = U*(final value of H)
*>
*>                where U is an orthogonal matrix.  The final
*>                value of H is upper Hessenberg and quasi-triangular
*>                in rows and columns INFO+1 through IHI.
*>
*>                If INFO .GT. 0 and COMPZ = 'V', then on exit
*>
*>                  (final value of Z)  =  (initial value of Z)*U
*>
*>                where U is the orthogonal matrix in (*) (regard-
*>                less of the value of JOB.)
*>
*>                If INFO .GT. 0 and COMPZ = 'I', then on exit
*>                      (final value of Z)  = U
*>                where U is the orthogonal matrix in (*) (regard-
*>                less of the value of JOB.)
*>
*>                If INFO .GT. 0 and COMPZ = 'N', then Z is not
*>                accessed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup doubleOTHERcomputational
*
*> \par Contributors:
*  ==================
*>
*>       Karen Braman and Ralph Byers, Department of Mathematics,
*>       University of Kansas, USA
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>             Default values supplied by
*>             ILAENV(ISPEC,'DHSEQR',JOB(:1)//COMPZ(:1),N,ILO,IHI,LWORK).
*>             It is suggested that these defaults be adjusted in order
*>             to attain best performance in each particular
*>             computational environment.
*>
*>            ISPEC=12: The DLAHQR vs DLAQR0 crossover point.
*>                      Default: 75. (Must be at least 11.)
*>
*>            ISPEC=13: Recommended deflation window size.
*>                      This depends on ILO, IHI and NS.  NS is the
*>                      number of simultaneous shifts returned
*>                      by ILAENV(ISPEC=15).  (See ISPEC=15 below.)
*>                      The default for (IHI-ILO+1).LE.500 is NS.
*>                      The default for (IHI-ILO+1).GT.500 is 3*NS/2.
*>
*>            ISPEC=14: Nibble crossover point. (See IPARMQ for
*>                      details.)  Default: 14% of deflation window
*>                      size.
*>
*>            ISPEC=15: Number of simultaneous shifts in a multishift
*>                      QR iteration.
*>
*>                      If IHI-ILO+1 is ...
*>
*>                      greater than      ...but less    ... the
*>                      or equal to ...      than        default is
*>
*>                           1               30          NS =   2(+)
*>                          30               60          NS =   4(+)
*>                          60              150          NS =  10(+)
*>                         150              590          NS =  **
*>                         590             3000          NS =  64
*>                        3000             6000          NS = 128
*>                        6000             infinity      NS = 256
*>
*>                  (+)  By default some or all matrices of this order
*>                       are passed to the implicit double shift routine
*>                       DLAHQR and this parameter is ignored.  See
*>                       ISPEC=12 above and comments in IPARMQ for
*>                       details.
*>
*>                 (**)  The asterisks (**) indicate an ad-hoc
*>                       function of N increasing from 10 to 64.
*>
*>            ISPEC=16: Select structured matrix multiply.
*>                      If the number of simultaneous shifts (specified
*>                      by ISPEC=15) is less than 14, then the default
*>                      for ISPEC=16 is 0.  Otherwise the default for
*>                      ISPEC=16 is 2.
*> \endverbatim
*
*> \par References:
*  ================
*>
*>       K. Braman, R. Byers and R. Mathias, The Multi-Shift QR
*>       Algorithm Part I: Maintaining Well Focused Shifts, and Level 3
*>       Performance, SIAM Journal of Matrix Analysis, volume 23, pages
*>       929--947, 2002.
*> \n
*>       K. Braman, R. Byers and R. Mathias, The Multi-Shift QR
*>       Algorithm Part II: Aggressive Early Deflation, SIAM Journal
*>       of Matrix Analysis, volume 23, pages 948--973, 2002.
*
*  =====================================================================
      SUBROUTINE DHSEQR( JOB, COMPZ, N, ILO, IHI, H, LDH, WR, WI, Z,
     $                   LDZ, WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, INFO, LDH, LDZ, LWORK, N
      CHARACTER          COMPZ, JOB
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   H( LDH, * ), WI( * ), WORK( * ), WR( * ),
     $                   Z( LDZ, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
*
*     ==== Matrices of order NTINY or smaller must be processed by
*     .    DLAHQR because of insufficient subdiagonal scratch space.
*     .    (This is a hard limit.) ====
      INTEGER            NTINY
      PARAMETER          ( NTINY = 11 )
*
*     ==== NL allocates some local workspace to help small matrices
*     .    through a rare DLAHQR failure.  NL .GT. NTINY = 11 is
*     .    required and NL .LE. NMIN = ILAENV(ISPEC=12,...) is recom-
*     .    mended.  (The default value of NMIN is 75.)  Using NL = 49
*     .    allows up to six simultaneous shifts and a 16-by-16
*     .    deflation window.  ====
      INTEGER            NL
      PARAMETER          ( NL = 49 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0d0, ONE = 1.0d0 )
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   HL( NL, NL ), WORKL( NL )
*     ..
*     .. Local Scalars ..
      INTEGER            I, KBOT, NMIN
      LOGICAL            INITZ, LQUERY, WANTT, WANTZ
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      LOGICAL            LSAME
      EXTERNAL           ILAENV, LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLACPY, DLAHQR, DLAQR0, DLASET, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     ==== Decode and check the input parameters. ====
*
      WANTT = LSAME( JOB, 'S' )
      INITZ = LSAME( COMPZ, 'I' )
      WANTZ = INITZ .OR. LSAME( COMPZ, 'V' )
      WORK( 1 ) = DBLE( MAX( 1, N ) )
      LQUERY = LWORK.EQ.-1
*
      INFO = 0
      IF( .NOT.LSAME( JOB, 'E' ) .AND. .NOT.WANTT ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( COMPZ, 'N' ) .AND. .NOT.WANTZ ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -5
      ELSE IF( LDH.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDZ.LT.1 .OR. ( WANTZ .AND. LDZ.LT.MAX( 1, N ) ) ) THEN
         INFO = -11
      ELSE IF( LWORK.LT.MAX( 1, N ) .AND. .NOT.LQUERY ) THEN
         INFO = -13
      END IF
*
      IF( INFO.NE.0 ) THEN
*
*        ==== Quick return in case of invalid argument. ====
*
         CALL XERBLA( 'DHSEQR', -INFO )
         RETURN
*
      ELSE IF( N.EQ.0 ) THEN
*
*        ==== Quick return in case N = 0; nothing to do. ====
*
         RETURN
*
      ELSE IF( LQUERY ) THEN
*
*        ==== Quick return in case of a workspace query ====
*
         CALL DLAQR0( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI, ILO,
     $                IHI, Z, LDZ, WORK, LWORK, INFO )
*        ==== Ensure reported workspace size is backward-compatible with
*        .    previous LAPACK versions. ====
         WORK( 1 ) = MAX( DBLE( MAX( 1, N ) ), WORK( 1 ) )
         RETURN
*
      ELSE
*
*        ==== copy eigenvalues isolated by DGEBAL ====
*
         DO 10 I = 1, ILO - 1
            WR( I ) = H( I, I )
            WI( I ) = ZERO
   10    CONTINUE
         DO 20 I = IHI + 1, N
            WR( I ) = H( I, I )
            WI( I ) = ZERO
   20    CONTINUE
*
*        ==== Initialize Z, if requested ====
*
         IF( INITZ )
     $      CALL DLASET( 'A', N, N, ZERO, ONE, Z, LDZ )
*
*        ==== Quick return if possible ====
*
         IF( ILO.EQ.IHI ) THEN
            WR( ILO ) = H( ILO, ILO )
            WI( ILO ) = ZERO
            RETURN
         END IF
*
*        ==== DLAHQR/DLAQR0 crossover point ====
*
         NMIN = ILAENV( 12, 'DHSEQR', JOB( : 1 ) // COMPZ( : 1 ), N,
     $          ILO, IHI, LWORK )
         NMIN = MAX( NTINY, NMIN )
*
*        ==== DLAQR0 for big matrices; DLAHQR for small ones ====
*
         IF( N.GT.NMIN ) THEN
            CALL DLAQR0( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI, ILO,
     $                   IHI, Z, LDZ, WORK, LWORK, INFO )
         ELSE
*
*           ==== Small matrix ====
*
            CALL DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI, ILO,
     $                   IHI, Z, LDZ, INFO )
*
            IF( INFO.GT.0 ) THEN
*
*              ==== A rare DLAHQR failure!  DLAQR0 sometimes succeeds
*              .    when DLAHQR fails. ====
*
               KBOT = INFO
*
               IF( N.GE.NL ) THEN
*
*                 ==== Larger matrices have enough subdiagonal scratch
*                 .    space to call DLAQR0 directly. ====
*
                  CALL DLAQR0( WANTT, WANTZ, N, ILO, KBOT, H, LDH, WR,
     $                         WI, ILO, IHI, Z, LDZ, WORK, LWORK, INFO )
*
               ELSE
*
*                 ==== Tiny matrices don't have enough subdiagonal
*                 .    scratch space to benefit from DLAQR0.  Hence,
*                 .    tiny matrices must be copied into a larger
*                 .    array before calling DLAQR0. ====
*
                  CALL DLACPY( 'A', N, N, H, LDH, HL, NL )
                  HL( N+1, N ) = ZERO
                  CALL DLASET( 'A', NL, NL-N, ZERO, ZERO, HL( 1, N+1 ),
     $                         NL )
                  CALL DLAQR0( WANTT, WANTZ, NL, ILO, KBOT, HL, NL, WR,
     $                         WI, ILO, IHI, Z, LDZ, WORKL, NL, INFO )
                  IF( WANTT .OR. INFO.NE.0 )
     $               CALL DLACPY( 'A', N, N, HL, NL, H, LDH )
               END IF
            END IF
         END IF
*
*        ==== Clear out the trash, if necessary. ====
*
         IF( ( WANTT .OR. INFO.NE.0 ) .AND. N.GT.2 )
     $      CALL DLASET( 'L', N-2, N-2, ZERO, ZERO, H( 3, 1 ), LDH )
*
*        ==== Ensure reported workspace size is backward-compatible with
*        .    previous LAPACK versions. ====
*
         WORK( 1 ) = MAX( DBLE( MAX( 1, N ) ), WORK( 1 ) )
      END IF
*
*     ==== End of DHSEQR ====
*
      END
c $Id: dhseqr.f 24343 2013-06-22 05:35:15Z d3y133 $

	subroutine printbasis
	implicit none
#include "cguess.fh"
        integer isym, ibas, lobas, iprim
c
*       write(6,*)
*       write(6,*) ' zn=', zn, 'nbct=', nbct, ' nsym=', nsym, ' nsht=', nsht
C$Id: printbasis.F 19708 2010-10-29 18:04:21Z d3y133 $
        lobas =  1
	do isym = 1, nsym
           write(6,*) ' isym ', isym
           write(6,*) '       nbas  ', nbas(isym)
           write(6,*) '       ncsh  ', ncsh(isym)
           write(6,*) '       nosh  ', nosh(isym)
           write(6,*) '       nccup ', nccup(isym)
           write(6,*) '       n1    ', n1(isym)
           write(6,*) '       nbc   ', nbc(isym)
           do ibas = lobas, lobas+nbc(isym)-1
              write(6,*) '       function ', ibas
              do iprim = nstrt(ibas), nstrt(ibas+1)-1
                 write(6,1) iprim-nstrt(ibas)+1,zeta(iprim), cont(iprim)
 1               format('            ', i5,2f20.6)
              enddo
           enddo
           lobas = lobas + nbc(isym)
        enddo
        write(6,2) ajmn
 2      format(1x,4d16.8)
        write(6,*)
        write(6,*)
        end

      subroutine pre_rotate(o,p,angle,xw,mwm,mwa,nwm,nwa,xwc,mwmc,nwmc,
     + xs,msa,nsa)
c
c $Id: pre_rotate.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer mwm,mwa,nwm,nwa,mwmc,nwmc,msa,nsa
      real*8 xw(3,mwa,mwm),xwc(3,mwa,mwmc),xs(3,msa)
      real*8 angle,o(3),p(3),x(3),y(3)
c
      integer i,j
c
c     rotate
c
      do 1 i=1,nsa
      x(1)=xs(1,i)
      x(2)=xs(2,i)
      x(3)=xs(3,i)
      call rotate(o,p,angle,x,y)
      xs(1,i)=y(1)
      xs(2,i)=y(2)
      xs(3,i)=y(3)
    1 continue
      do 2 i=1,nwmc
      do 3 j=1,nwa
      x(1)=xwc(1,j,i)
      x(2)=xwc(2,j,i)
      x(3)=xwc(3,j,i)
      call rotate(o,p,angle,x,y)
      xwc(1,j,i)=y(1)
      xwc(2,j,i)=y(2)
      xwc(3,j,i)=y(3)
    3 continue
    2 continue
      do 4 i=1,nwm
      do 5 j=1,nwa
      x(1)=xw(1,j,i)
      x(2)=xw(2,j,i)
      x(3)=xw(3,j,i)
      call rotate(o,p,angle,x,y)
      xw(1,j,i)=y(1)
      xw(2,j,i)=y(2)
      xw(3,j,i)=y(3)
    5 continue
    4 continue
      return
      end

c
c $Id: list_verlt.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE list_verlt()

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'cm_atom.inc'
      include 'cm_cuto.inc'
      include 'cm_latt.inc'
      include 'cm_vlst.inc'
      include 'cm_elst.inc'

      integer i,j,k
      integer eatm,nlist

      real*8 rij,rijsq

      dimension rij(mxatms,3)

      nlist=0

      do i=1,natms-1

       k=0
       point(i)=nlist+1
       if(epoint(i).ne.epoint(i+1))eatm=epoint(i)

       do j=i+1,natms

        k=k+1
        rij(k,1)=ccc(i,1)-ccc(j,1)
        rij(k,2)=ccc(i,2)-ccc(j,2)
        rij(k,3)=ccc(i,3)-ccc(j,3)

       enddo

       call tool_rebox(k,mxatms,latt,rlatt,rij)

       k=0

       do j=i+1,natms

        k=k+1

        if((epoint(i).ne.epoint(i+1)).and.(elist(eatm).eq.j))then

         eatm=min(eatm+1,(epoint(i+1)-1))

        else

         rijsq=rij(k,1)*rij(k,1)+rij(k,2)*rij(k,2)+rij(k,3)*rij(k,3)

         if(rijsq.lt.vcutsq)then

          nlist=nlist+1

          if(nlist.gt.(mxatms*mxvlist))then
           write(output,"(/,1x,'mxatms*mxvlist exceeded')")
           stop
          endif
          if((nlist-point(i)+1).gt.mxnlist)then
           write(output,"(/,1x,'mxnlist exceeded')")
           stop
          endif

          list(nlist)=j

         endif

        endif

       enddo

      enddo

      point(natms)=nlist+1

      return

      END

      subroutine argos_cafe_lso(lself,iga,idt,istemp,
     + isfr,isto,jsfr,jsto,
     + ido,nso,nimprs,mimprs,nconst,limprs,itemp)
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      integer nso,mimprs
      integer ido(nso,6)
      integer iga(msa),idt(msa)
      integer limprs(1)
      integer itemp(nsatot),istemp(msa)
      integer isa,jsa,isfr,isto,jsfr,jsto,isafr,isato,jsafr,jsato
      integer iso,noi,nimprs,nconst
      integer isoloc,ioloc,joloc,koloc,loloc,iq,jq,kq,lq
      logical lself
c
#include "bitops.fh"
c
      if(numi(2).eq.0) return
c
c     This subroutine evaluates the solute impropers list
c
      isafr=isfr
      isato=isto
      jsafr=jsfr
      jsato=jsto
c
      nimprs=0
      nconst=0
c
      do 1 isa=1,nsatot
      itemp(isa)=0
    1 continue
      do 2 jsa=jsafr,jsato
      itemp(iga(jsa))=5
    2 continue
      do 3 isa=isafr,isato
      itemp(iga(isa))=1
    3 continue
c
      do 4 iso=1,numi(2)
c
c     skip dihedrals with negative isos
c
      if(ido(iso,5).ge.0) then
c
      noi=itemp(ido(iso,1))
      if(noi.gt.0) then
      noi=noi+itemp(ido(iso,2))
      if(noi.gt.1) then
      noi=noi+itemp(ido(iso,3))
      if(noi.gt.2) then
      noi=noi+itemp(ido(iso,4))
      if(noi.gt.3) then
      if((lself.and.noi.eq.4).or.
     + (.not.lself.and.(noi.eq.8.or.noi.eq.12.or.noi.eq.16))) then
      nimprs=nimprs+1
      if(ido(iso,5).eq.1) nconst=nconst+1
      if(nimprs.gt.mimprs)
     + call md_abort('Insufficient memory for improper list',0)
      limprs(nimprs)=iso
      endif
      endif
      endif
      endif
      endif
      endif
    4 continue
c
      return
      end
c $Id: argos_cafe_lso.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdt_y_tr2_11_6(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: ccsdt_y_tr2_11_6.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 p11 h13 h14 )_vtr + = -1/2 * Sum ( h10 p6 p7 ) * tr ( p6 p7 p11 h10 h13 h14 )_tr * v ( h3 h10 p6 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER p11b
      INTEGER h13b
      INTEGER h14b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p7b
      INTEGER h10b
      INTEGER p11b_1
      INTEGER p6b_1
      INTEGER p7b_1
      INTEGER h13b_1
      INTEGER h14b_1
      INTEGER h10b_1
      INTEGER h3b_2
      INTEGER h10b_2
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO p11b = noab+1,noab+nvab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+p11b-
     &1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+
     &h13b-1)+int_mb(k_spin+h14b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+p11b-1),ieor(int_mb
     &(k_sym+h13b-1),int_mb(k_sym+h14b-1)))) .eq. ieor(irrep_v,irrep_tr)
     &) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+p11b-1) * int_mb(k_r
     &ange+h13b-1) * int_mb(k_range+h14b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr2_11_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h10b = 1,noab
      IF (int_mb(k_spin+p11b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1
     &) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h
     &10b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb
     &(k_sym+p7b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h14b-1),
     &int_mb(k_sym+h10b-1)))))) .eq. irrep_tr) THEN
      CALL TCE_RESTRICTED_6(p11b,p6b,p7b,h13b,h14b,h10b,p11b_1,p6b_1,p7b
     &_1,h13b_1,h14b_1,h10b_1)
      CALL TCE_RESTRICTED_4(h3b,h10b,p6b,p7b,h3b_2,h10b_2,p6b_2,p7b_2)
      dim_common = int_mb(k_range+p6b-1) * int_mb(k_range+p7b-1) * int_m
     &b(k_range+h10b-1)
      dima_sort = int_mb(k_range+p11b-1) * int_mb(k_range+h13b-1) * int_
     &mb(k_range+h14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr2_11_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr2_11_6',2,MA_ERR)
      IF ((p7b .le. p11b) .and. (h10b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h10b_1 - 1 + noab * (p11b_1 -
     & noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p11b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),6,5,3,4,2,1,1.0d0
     &)
      END IF
      IF ((p7b .le. p11b) .and. (h13b .lt. h10b) .and. (h10b .le. h14b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h13b_1 - 1 + noab * (p11b_1 -
     & noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p11b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h10b-1),int_mb(k_range+h14b-1),6,4,3,5,2,1,-1.0d
     &0)
      END IF
      IF ((p7b .le. p11b) .and. (h14b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (p11b_1 -
     & noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p11b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h14b-1),int_mb(k_range+h10b-1),5,4,3,6,2,1,1.0d0
     &)
      END IF
      IF ((p6b .le. p11b) .and. (p11b .lt. p7b) .and. (h10b .le. h13b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h10b_1 - 1 + noab * (p7b_1 - 
     &noab - 1 + nvab * (p11b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p7b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),6,5,2,4,3,1,-1.0d
     &0)
      END IF
      IF ((p6b .le. p11b) .and. (p11b .lt. p7b) .and. (h13b .lt. h10b) .
     &and. (h10b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h13b_1 - 1 + noab * (p7b_1 - 
     &noab - 1 + nvab * (p11b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p7b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h10b-1),int_mb(k_range+h14b-1),6,4,2,5,3,1,1.0d0
     &)
      END IF
      IF ((p6b .le. p11b) .and. (p11b .lt. p7b) .and. (h14b .lt. h10b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (p7b_1 - 
     &noab - 1 + nvab * (p11b_1 - noab - 1 + nvab * (p6b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p7b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h14b-1),int_mb(k_range+h10b-1),5,4,2,6,3,1,-1.0d
     &0)
      END IF
      IF ((p11b .lt. p6b) .and. (h10b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h10b_1 - 1 + noab * (p7b_1 - 
     &noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p11b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),6,5,1,4,3,2,1.0d0
     &)
      END IF
      IF ((p11b .lt. p6b) .and. (h13b .lt. h10b) .and. (h10b .le. h14b))
     & THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h10b_1 - 1 + noab * (h13b_1 - 1 + noab * (p7b_1 - 
     &noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p11b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h10b-1),int_mb(k_range+h14b-1),6,4,1,5,3,2,-1.0d
     &0)
      END IF
      IF ((p11b .lt. p6b) .and. (h14b .lt. h10b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (p7b_1 - 
     &noab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p11b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1),int_mb(k_range+h13b-
     &1),int_mb(k_range+h14b-1),int_mb(k_range+h10b-1),5,4,1,6,3,2,1.0d0
     &)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr2_11_6',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr2_11_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr2_11_6',5,MA_ERR)
      IF ((h10b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (h3b_2 - 1 + (noab
     &+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),2,1,4,3,-1.0d0)
      END IF
      IF ((h3b .le. h10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (h10b_2 - 1 + (noa
     &b+nvab) * (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p6b-1),int_mb(k_range+p7b-1
     &),1,2,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr2_11_6',6,MA_E
     &RR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p6b .eq. p7b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr2_11_6',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr2_11_6',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr2_11_6',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+h13b-1),int_mb(k_range+p11b
     &-1),1,4,3,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h14b 
     &- 1 + noab * (h13b - 1 + noab * (p11b - noab - 1 + nvab * (h3b - 1
     &)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr2_11_6',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr2_11_6',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

c $Id: int_hf1sp.F 23339 2013-01-03 17:50:16Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Private wrapper routine that calls McMurchie-Davidson
C> 1-electron integral routines
C>
C> Call the McMurchie-Davidson 1-electron integral routines and
C> handle any permutations to compute the SP integrals.
C>
c:tex-% part of the internal API routines.
c:tex-\subsection{int\_hf1sp}
c:tex-This is a layer routine that calls the 
c:tex-McMurchie-Davidson one electron routine.  This layer
c:tex-routine handles all permutations to compute sp integrals.
c:tex-This routine should never be called by an application module.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_hf1sp(
     &       xyzi,expi,coefi, i_nprim, i_ngen, Li, ictri,
     &       xyzj,expj,coefj, j_nprim, j_ngen, Lj, ictrj,
     &       xyz,zan,exinv,nat,S,T,V,lstv,doS,doT,doV,canAB,
     &       dryrun,scr,lscr,msg)
c:tex-\end{verbatim}
      implicit none
#include "apiP.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "util.fh"
c::passed
c:tex-For an integral $<i|Operator|j>$
c:tex-\begin{verbatim}
      integer i_nprim  !< [Input] num. prims on function i
      integer i_ngen   !< [Input] num general conts on func. i
      integer Li       !< [Input] angular momentum of func. i  
      integer ictri    !< [Input] lexical atom index for function i 
      integer j_nprim  !< [Input] num. prims on function j     
      integer j_ngen   !< [Input] num general conts on func. j 
      integer Lj       !< [Input] angular momentum of func. j  
      integer ictrj    !< [Input] lexical atom index for function j 
      integer nat      !< [Input] number of atoms
      integer lscr     !< [Input] size of scratch array
      integer lstv     !< [Input] size of any integral buffer
      double precision xyzi(3)  !< [Input] position of center i
      double precision expi(i_nprim) !< [Input] exponents on i
      double precision coefi(i_nprim,i_ngen) !< [Input] i coeffs
      double precision xyzj(3)  !< [Input] position of center j
      double precision expj(j_nprim)  !< [Input] exponents on j
      double precision coefj(j_nprim,j_ngen)  !< [Input] j coeffs
      double precision xyz(3,nat)  !< [Input] all atom positions
      double precision zan(nat)  !< [Input] charges on all atoms
      double precision exinv(nat)   !< [Input] inverse nuclear exponents
      double precision scr(lscr)  !< [Scratch] scratch buffers
      double precision S(lstv)  !< [Output] overlap integrals
      double precision T(lstv)  !< [Output] kinetic energy integrals
      double precision V(lstv)  !< [Output] potential integrals
      logical doS     !< [Input] compute overlap (True/False)
      logical doT     !< [Input] compute kinetic (True/False)
      logical doV     !< [Input] compute potential (True/False)
      logical canAB   !< [Input] compute only canonical ints (false only)
      logical dryrun  !< [Input] true means only compute required memory
      character*(*) msg !< [Input] calling function identification message
c:tex-\end{verbatim}
c::local
      integer offset
      integer nintx, nint_xsp
c
*debug_print      integer iii
c
      if (Li.gt.-1.and.Lj.gt.-1) then
        call int_hf1sp_ecp(
     &         xyzi,expi,coefi,i_nprim,i_ngen,Li,ictri,
     &         xyzj,expj,coefj,j_nprim,j_ngen,Lj,ictrj,
     &         xyz,zan,exinv,nat,S,T,V,lstv,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
c
      elseif (Li.eq.-1.and.Lj.eq.-1) then
c.............................................................. (SP|SP)
c________________________________ (S|S)
        call int_hf1sp_ecp(
     &         xyzi,expi,coefi,i_nprim,1,0,ictri,
     &         xyzj,expj,coefj,j_nprim,1,0,ictrj,
     &         xyz,zan,exinv,nat,S,T,V,lstv,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
c________________________________ (S|P)
        offset = 1
        call int_hf1sp_ecp(
     &         xyzi,
     &         expi,coefi(1,1),
     &         i_nprim,1,0,ictri,
     &         xyzj,
     &         expj,coefj(1,2),
     &         j_nprim,1,1,ictrj,
     &         xyz,zan,exinv,nat,
     &         S(offset+1),T(offset+1),V(offset+1),
     &         (lstv-offset)
     &         ,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
c________________________________ (P|S)
        offset = 1 + 3 
        call int_hf1sp_ecp(
     &         xyzi,
     &         expi,coefi(1,2),
     &         i_nprim,1,1,ictri,
     &         xyzj,
     &         expj,coefj(1,1),
     &         j_nprim,1,0,ictrj,
     &         xyz,zan,exinv,nat,
     &         S(offset+1),T(offset+1),V(offset+1),
     &         (lstv-offset)
     &         ,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
c________________________________ (P|P)
        offset = 1 + 3 + 3
        call int_hf1sp_ecp(
     &         xyzi,
     &         expi,coefi(1,2),
     &         i_nprim,1,1,ictri,
     &         xyzj,
     &         expj,coefj(1,2),
     &         j_nprim,1,1,ictrj,
     &         xyz,zan,exinv,nat,
     &         S(offset+1),T(offset+1),V(offset+1),
     &         (lstv-offset)
     &         ,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
*
        if (doS) call int_1spsp(S,1)
        if (doT) call int_1spsp(T,1)
        if (dov) call int_1spsp(V,1)
      elseif (Li.eq.-1) then
c.............................................................. (SP|X)
c________________________________ (S|X)
        call int_hf1sp_ecp(
     &         xyzi,expi,coefi,i_nprim,1,0,ictri,
     &         xyzj,expj,coefj,j_nprim,j_ngen,Lj,ictrj,
     &         xyz,zan,exinv,nat,S,T,V,lstv,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
c________________________________ (P|X)
        offset = 1*(Lj+1)*(Lj+2)/2*j_ngen
        call int_hf1sp_ecp(
     &         xyzi,
     &         expi,coefi(1,2),
     &         i_nprim,1,1,ictri,
     &         xyzj,
     &         expj,coefj,j_nprim,j_ngen,Lj,ictrj,
     &         xyz,zan,exinv,nat,
     &         S(offset+1),T(offset+1),V(offset+1),
     &         (lstv-offset)
     &         ,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
      elseif (Lj.eq.-1) then
c.............................................................. (X|SP)
c________________________________ (X|S)
        call int_hf1sp_ecp(
     &         xyzi,expi,coefi,i_nprim,i_ngen,Li,ictri,
     &         xyzj,expj,coefj,j_nprim,1,0,ictrj,
     &         xyz,zan,exinv,nat,S,T,V,lstv,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
c________________________________ (X|P)
        offset = 1*(Li+1)*(Li+2)/2*i_ngen
        call int_hf1sp_ecp(
     &         xyzi,
     &         expi,coefi,i_nprim,i_ngen,Li,ictri,
     &         xyzj,
     &         expj,coefj(1,2),
     &         j_nprim,1,1,ictrj,
     &         xyz,zan,exinv,nat,
     &         S(offset+1),T(offset+1),V(offset+1),
     &         (lstv-offset)
     &         ,doS,doT,doV,canAB,
     &         dryrun,scr,lscr,msg)
c
        if (li.eq.0.and.i_ngen.eq.1) then
c * for i_ngen = 1
c * nothing needed since (s|s), (s|p) is same order as (s|sp)
c * (s|s), (s|x), (s|y), (s|z)
          continue
        else if (li.eq.1.and.i_ngen.eq.1) then
          if (doS) call int_1psp(S,1)
          if (doT) call int_1psp(T,1)
          if (doV) call int_1psp(V,1)
        else if (li.eq.2.and.i_ngen.eq.1) then
          if (doS) call int_1dsp(S,1)
          if (doT) call int_1dsp(T,1)
          if (doV) call int_1dsp(V,1)
        else
          nintx   = (Li+1)*(Li+2)/2*i_ngen  ! size of X
          nint_xsp = nintx * 4              ! size of X * size of sp
          if (doS) then
            call dcopy(nint_xsp,S,1,scr,1)
            call int_sp1b(S,scr,scr(nintx+1),nintx,1)
          endif
          if (doT) then
            call dcopy(nint_xsp,T,1,scr,1)
            call int_sp1b(T,scr,scr(nintx+1),nintx,1)
          endif
          if (doV) then
            call dcopy(nint_xsp,V,1,scr,1)
            call int_sp1b(V,scr,scr(nintx+1),nintx,1)
          endif
        endif
      else
        write(luout,*)'int_hf1sp called by ',msg
        call errquit('int_hf1sp: unknown case finished',911, INT_ERR)
      endif
c
c
      end
C>
C> \brief Call the McMurchie-Davidson 1-electron integral routines
C> while handling all ECP integral options.
C>
c:tex-% part of the internal API routines.
c:tex-\subsection{int\_hf1sp\_ecp}
c:tex-This is a layer routine that calls the 
c:tex-McMurchie-Davidson one electron routine.  This layer
c:tex-routine handles all options for computing ecp integrals.
c:tex-This routine should never be called by an application module.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_hf1sp_ecp(
     &       xyzi,expi,coefi, i_nprim, i_ngen, Li, ictri,
     &       xyzj,expj,coefj, j_nprim, j_ngen, Lj, ictrj,
     &       xyz,zan,exinv,nat,S,T,V,lstv,doS,doT,doV,canAB,
     &       dryrun,scr,lscr,msg)
c:tex-\end{verbatim}
      implicit none
#include "apiP.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "nwc_const.fh"
#include "int_nbf.fh"
#include "util.fh"
c::passed
c:tex-For an integral $<i|Operator|j>$
c:tex-\begin{verbatim}
      integer i_nprim  !< [Input] num. prims on function i
      integer i_ngen   !< [Input] num general conts on func. i
      integer Li       !< [Input] angular momentum of func. i  
      integer ictri    !< [Input] lexical atom index for function i 
      integer j_nprim  !< [Input] num. prims on function j     
      integer j_ngen   !< [Input] num general conts on func. j 
      integer Lj       !< [Input] angular momentum of func. j  
      integer ictrj    !< [Input] lexical atom index for function j 
      integer nat      !< [Input] number of atoms
      integer lscr     !< [Input] size of scratch array
      integer lstv     !< [Input] size of any integral buffer
      double precision xyzi(3)  !< [Input] position of center i
      double precision expi(i_nprim) !< [Input] exponents on i
      double precision coefi(i_nprim,i_ngen) !< [Input] i coeffs
      double precision xyzj(3)  !< [Input] position of center j
      double precision expj(j_nprim)  !< [Input] exponents on j
      double precision coefj(j_nprim,j_ngen)  !< [Input] j coeffs
      double precision xyz(3,nat)  !< [Input] all atom positions
      double precision zan(nat)  !< [Input] charges on all atoms
      double precision exinv(nat)   !< [Input] inverse nuclear exponents
      double precision scr(lscr)  !< [Scratch] scratch buffers
      double precision S(lstv)  !< [Output] overlap integrals
      double precision T(lstv)  !< [Output] kinetic energy integrals
      double precision V(lstv)  !< [Output] potential integrals
      logical doS     !< [Input] compute overlap (True/False)
      logical doT     !< [Input] compute kinetic (True/False)
      logical doV     !< [Input] compute potential (True/False)
      logical canAB   !< [Input] compute only canonical ints (false only)
      logical dryrun  !< [Input] true means only compute required memory
      character*(*) msg !< [Input] calling func. identification message
c:tex-\end{verbatim}
c::local
      integer nintV
      integer offset
*
      call hf1(
     &      xyzi,expi,coefi,i_nprim,i_ngen,Li,
     &      xyzj,expj,coefj,j_nprim,j_ngen,Lj,
     &      xyz,zan,exinv,nat,S,T,V,lstv,doS,doT,doV,canAB,
     &      dryrun,scr,lscr)
*
      if (any_ecp.and.doV.and.msg.ne.'int_1eefc') then
        nintV = int_nbf_x(Li)*i_ngen
        nintV = nintV*int_nbf_x(Lj)*j_ngen
        offset = nintV + 1
*       write(luout,*)' lscr to ecp_hf1:',(lscr-nintV)
        if (ictri.lt.0.or.ictrj.lt.0) then
          write(luout,*)' int_hf1sp_ecp: ictri = ',ictri
          write(luout,*)' int_hf1sp_ecp: ictrj = ',ictrj
          write(luout,*)'int_hf1sp_ecp called by ',msg
          call errquit(
     &        'int_hf1sp: unknown center for ECPs',
     &        911, INT_ERR)
        endif
        call int_ecp_hf1(
     &      xyzi,expi,coefi,i_nprim,i_ngen,Li,ictri,
     &      xyzj,expj,coefj,j_nprim,j_ngen,Lj,ictrj,
     &      scr,nintV,scr(offset),(lscr-nintV),
     &      dryrun)
*... sum ecp into V block
        call daxpy(nintV, 1.0d00, scr,1,V,1)
      endif
*
      end
C>
C> \brief Transform the S and P integrals to SP integrals
C>
C> This routine transforms integrals from the way they were
C> computed \f$ (p|s) \f$ and \f$ (p|p) \f$ to \f$ (p|sp) \f$.
C> The transformation is performed in place as follows:
C>
C> <table>
C> <tr><th> no.</th><th>computed order</th><th>transformed order</th><th>permutation      </th></tr>
C> <tr><td>  1 </td><td> \f$(x|s)\f$ </td><td> \f$(x|s)\f$ </td><td>                        </td></tr>
C> <tr><td>  2 </td><td> \f$(y|s)\f$ </td><td> \f$(x|x)\f$ </td><td> \f$2 \rightarrow 5\f$  </td></tr>
C> <tr><td>  3 </td><td> \f$(z|s)\f$ </td><td> \f$(x|y)\f$ </td><td> \f$3 \rightarrow 9\f$  </td></tr>
C> <tr><td>  4 </td><td> \f$(x|x)\f$ </td><td> \f$(x|z)\f$ </td><td> \f$4 \rightarrow 2\f$  </td></tr>
C> <tr><td>  5 </td><td> \f$(x|y)\f$ </td><td> \f$(y|s)\f$ </td><td> \f$5 \rightarrow 3\f$  </td></tr>
C> <tr><td>  6 </td><td> \f$(x|z)\f$ </td><td> \f$(y|x)\f$ </td><td> \f$6 \rightarrow 4\f$  </td></tr>
C> <tr><td>  7 </td><td> \f$(y|x)\f$ </td><td> \f$(y|y)\f$ </td><td> \f$7 \rightarrow 6\f$  </td></tr>
C> <tr><td>  8 </td><td> \f$(y|y)\f$ </td><td> \f$(y|z)\f$ </td><td> \f$8 \rightarrow 7\f$  </td></tr>
C> <tr><td>  9 </td><td> \f$(y|z)\f$ </td><td> \f$(z|s)\f$ </td><td> \f$9 \rightarrow 8\f$  </td></tr>
C> <tr><td> 10 </td><td> \f$(z|x)\f$ </td><td> \f$(z|x)\f$ </td><td>                        </td></tr>
C> <tr><td> 11 </td><td> \f$(z|y)\f$ </td><td> \f$(z|y)\f$ </td><td>                        </td></tr>
C> <tr><td> 12 </td><td> \f$(z|z)\f$ </td><td> \f$(z|z)\f$ </td><td>                        </td></tr>
C> </table>
C>
C>
c:tex-% part of the internal API routines
c:tex-\subsection{int\_1psp}
c:tex-This routine transforms integrals from the way they
c:tex-were computed $(p|s)$, $(p|p)$ to $(p|sp)$.
c:tex-The transformation is done in place as follows:
c:tex-\begin{tabular}{rccc}
c:tex- & computed & transformed & \\
c:tex- &  order   &   order     & \\
c:tex-~1 & (x$|$s)  &  (x$|$s)  & \\
c:tex-~2 & (y$|$s)  &  (x$|$x)  & 2 $\rightarrow$ 5\\
c:tex-~3 & (z$|$s)  &  (x$|$y)  & 3 $\rightarrow$ 9\\
c:tex-~4 & (x$|$x)  &  (x$|$z)  & 4 $\rightarrow$ 2\\
c:tex-~5 & (x$|$y)  &  (y$|$s)  & 5 $\rightarrow$ 3\\
c:tex-~6 & (x$|$z)  &  (y$|$x)  & 6 $\rightarrow$ 4\\
c:tex-~7 & (y$|$x)  &  (y$|$y)  & 7 $\rightarrow$ 6\\
c:tex-~8 & (y$|$y)  &  (y$|$z)  & 8 $\rightarrow$ 7\\
c:tex-~9 & (y$|$z)  &  (z$|$s)  & 9 $\rightarrow$ 8\\
c:tex-10 & (z$|$x)  &  (z$|$x)  &  \\
c:tex-11 & (z$|$y)  &  (z$|$y)  &  \\
c:tex-12 & (z$|$z)  &  (z$|$z)  &  \\
c:tex-\end{tabular}
c:tex- 
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_1psp(block,num_blocks)
c:tex-\end{verbatim}
c
c transforms a (p|sp) block to correct order in place
c integrals in block were calculated (p|s),(p|p).
c      computed transformed 
c       order     order
c  1.  (x|s)     (x|s)     
c  2.  (y|s)     (x|x)     2 -> 5
c  3.  (z|s)     (x|y)     3 -> 9
c  4.  (x|x)     (x|z)     4 -> 2
c  5.  (x|y)     (y|s)     5 -> 3
c  6.  (x|z)     (y|x)     6 -> 4
c  7.  (y|x)     (y|y)     7 -> 6
c  8.  (y|y)     (y|z)     8 -> 7
c  9.  (y|z)     (z|s)     9 -> 8
c 10.  (z|x)     (z|x)     
c 11.  (z|y)     (z|y)     
c 12.  (z|z)     (z|z)     
c
      implicit none
c:tex-\begin{verbatim}
      integer num_blocks  !< [Input] num. blocks to transform
      double precision block(12,num_blocks) !< [Input/output] integral block
c:tex-\end{verbatim}
c
      integer ib
      double precision temp1, temp2
      do 00100 ib = 1,num_blocks
        temp1       = block(2,ib)  ! 2 -> temp1
        temp2       = block(3,ib)  ! 3 -> temp2
        block(2,ib) = block(4,ib)  ! 4 -> 2
        block(3,ib) = block(5,ib)  ! 5 -> 3
        block(4,ib) = block(6,ib)  ! 6 -> 4
        block(6,ib) = block(7,ib)  ! 7 -> 6
        block(7,ib) = block(8,ib)  ! 8 -> 7
        block(8,ib) = block(9,ib)  ! 9 -> 8
        block(9,ib) = temp2        ! temp2 -> 9 or 3 -> 9
        block(5,ib) = temp1        ! temp1 -> 5 or 2 -> 5
00100 continue
      end
C>
C> \brief Transform integrals involving D functions to
C> SP integrals
C>
C> Transform integrals from the way they were computed
C> \f$(d|s)\f$ and \f$(d|p)\f$ to \f$(d|sp)\f$. The transformation
C> proceeds in place.
C>
C> <table>
C> <tr><th> no.</th><th>computed order</th><th>transformed order</th><th>permutation      </th></tr>
C> <tr><td>  1 </td><td> \f$(xx|s)\f$  </td><td> \f$(xx|s)\f$     </td><td>                       </td></tr>
C> <tr><td>  2 </td><td> \f$(xy|s)\f$  </td><td> \f$(xx|x)\f$     </td><td> \f$2 \rightarrow 5\f$ </td></tr>
C> <tr><td>  3 </td><td> \f$(xz|s)\f$  </td><td> \f$(xx|y)\f$     </td><td> \f$3 \rightarrow 9\f$ </td></tr>
C> <tr><td>  4 </td><td> \f$(yy|s)\f$  </td><td> \f$(xx|z)\f$     </td><td> \f$4 \rightarrow 13\f$ </td></tr>
C> <tr><td>  5 </td><td> \f$(yz|s)\f$  </td><td> \f$(xy|s)\f$     </td><td> \f$5 \rightarrow 17\f$ </td></tr>
C> <tr><td>  6 </td><td> \f$(zz|s)\f$  </td><td> \f$(xy|x)\f$     </td><td> \f$6 \rightarrow 21\f$ </td></tr>
C> <tr><td>  7 </td><td> \f$(xx|x)\f$  </td><td> \f$(xy|y)\f$     </td><td> \f$7 \rightarrow 2\f$ </td></tr>
C> <tr><td>  8 </td><td> \f$(xx|y)\f$  </td><td> \f$(xy|z)\f$     </td><td> \f$8 \rightarrow 3\f$ </td></tr>
C> <tr><td>  9 </td><td> \f$(xx|z)\f$  </td><td> \f$(xz|s)\f$     </td><td> \f$9 \rightarrow 4\f$ </td></tr>
C> <tr><td> 10 </td><td> \f$(xy|x)\f$  </td><td> \f$(xz|x)\f$     </td><td> \f$10\rightarrow 6\f$ </td></tr>
C> <tr><td> 11 </td><td> \f$(xy|y)\f$  </td><td> \f$(xz|y)\f$     </td><td> \f$11\rightarrow 7\f$ </td></tr>
C> <tr><td> 12 </td><td> \f$(xy|z)\f$  </td><td> \f$(xz|z)\f$     </td><td> \f$12\rightarrow 8\f$ </td></tr>
C> <tr><td> 13 </td><td> \f$(xz|x)\f$  </td><td> \f$(yy|s)\f$     </td><td> \f$13\rightarrow 10\f$ </td></tr>
C> <tr><td> 14 </td><td> \f$(xz|y)\f$  </td><td> \f$(yy|x)\f$     </td><td> \f$14\rightarrow 11\f$ </td></tr>
C> <tr><td> 15 </td><td> \f$(xz|z)\f$  </td><td> \f$(yy|y)\f$     </td><td> \f$15\rightarrow 12\f$ </td></tr>
C> <tr><td> 16 </td><td> \f$(yy|x)\f$  </td><td> \f$(yy|z)\f$     </td><td> \f$16\rightarrow 14\f$ </td></tr>
C> <tr><td> 17 </td><td> \f$(yy|y)\f$  </td><td> \f$(yz|s)\f$     </td><td> \f$17\rightarrow 15\f$ </td></tr>
C> <tr><td> 18 </td><td> \f$(yy|z)\f$  </td><td> \f$(yz|x)\f$     </td><td> \f$18\rightarrow 16\f$ </td></tr>
C> <tr><td> 19 </td><td> \f$(yz|x)\f$  </td><td> \f$(yz|y)\f$     </td><td> \f$19\rightarrow 18\f$ </td></tr>
C> <tr><td> 20 </td><td> \f$(yz|y)\f$  </td><td> \f$(yz|z)\f$     </td><td> \f$20\rightarrow 19\f$ </td></tr>
C> <tr><td> 21 </td><td> \f$(yz|z)\f$  </td><td> \f$(zz|s)\f$     </td><td> \f$21\rightarrow 20\f$ </td></tr>
C> <tr><td> 22 </td><td> \f$(zz|x)\f$  </td><td> \f$(zz|x)\f$     </td><td>                        </td></tr>
C> <tr><td> 23 </td><td> \f$(zz|y)\f$  </td><td> \f$(zz|y)\f$     </td><td>                        </td></tr>
C> <tr><td> 24 </td><td> \f$(zz|z)\f$  </td><td> \f$(zz|z)\f$     </td><td>                        </td></tr>
C> </table>
C>
c:tex-% part of the internal API routines
c:tex-\subsection{int\_1dsp}
c:tex-This routine transforms integrals from the way they
c:tex-were computed $(d|s)$, $(d|p)$ to $(d|sp)$.
c:tex-The transformation is done in place as follows:
c:tex-\begin{tabular}{rccc}      
c:tex-  &  computed  & transformed & \\
c:tex-  &  ~order    &  order & \\
c:tex-~1 & (xx$|$s)  &  (xx$|$s)  & \\
c:tex-~2 & (xy$|$s)  &  (xx$|$x)  &  ~2 $\rightarrow$ 5~~ \\
c:tex-~3 & (xz$|$s)  &  (xx$|$y)  &  ~3 $\rightarrow$ 9~~ \\
c:tex-~4 & (yy$|$s)  &  (xx$|$z)  &  ~4 $\rightarrow$ 13~ \\
c:tex-~5 & (yz$|$s)  &  (xy$|$s)  &  ~5 $\rightarrow$ 17~ \\
c:tex-~6 & (zz$|$s)  &  (xy$|$x)  &  ~6 $\rightarrow$ 21~ \\
c:tex-~7 & (xx$|$x)  &  (xy$|$y)  &  ~7 $\rightarrow$ 2~~ \\
c:tex-~8 & (xx$|$y)  &  (xy$|$z)  &  ~8 $\rightarrow$ 3~~ \\
c:tex-~9 & (xx$|$z)  &  (xz$|$s)  &  ~9 $\rightarrow$ 4~~ \\
c:tex-10 & (xy$|$x)  &  (xz$|$x)  &  10 $\rightarrow$ 6~~ \\
c:tex-11 & (xy$|$y)  &  (xz$|$y)  &  11 $\rightarrow$ 7~~ \\
c:tex-12 & (xy$|$z)  &  (xz$|$z)  &  12 $\rightarrow$ 8~~ \\
c:tex-13 & (xz$|$x)  &  (yy$|$s)  &  13 $\rightarrow$ 10~ \\
c:tex-14 & (xz$|$y)  &  (yy$|$x)  &  14 $\rightarrow$ 11~ \\
c:tex-15 & (xz$|$z)  &  (yy$|$y)  &  15 $\rightarrow$ 12~ \\
c:tex-16 & (yy$|$x)  &  (yy$|$z)  &  16 $\rightarrow$ 14~ \\
c:tex-17 & (yy$|$y)  &  (yz$|$s)  &  17 $\rightarrow$ 15~ \\
c:tex-18 & (yy$|$z)  &  (yz$|$x)  &  18 $\rightarrow$ 16~ \\
c:tex-19 & (yz$|$x)  &  (yz$|$y)  &  19 $\rightarrow$ 18~ \\
c:tex-20 & (yz$|$y)  &  (yz$|$z)  &  20 $\rightarrow$ 19~ \\
c:tex-21 & (yz$|$z)  &  (zz$|$s)  &  21 $\rightarrow$ 20~ \\
c:tex-22 & (zz$|$x)  &  (zz$|$x)  & \\
c:tex-23 & (zz$|$y)  &  (zz$|$y)  & \\
c:tex-24 & (zz$|$z)  &  (zz$|$z)  & \\
c:tex-\end{tabular}
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_1dsp(block,num_blocks)
c:tex-\end{verbatim}
c
c transforms a (d|sp) block to correct order in place
c integrals in block were calculated (d|s),(d|p).
c      computed transformed 
c       order     order
c  1.  (xx|s)     (xx|s)
c  2.  (xy|s)     (xx|x)  2 -> 5   *
c  3.  (xz|s)     (xx|y)  3 -> 9   *
c  4.  (yy|s)     (xx|z)  4 -> 13  *
c  5.  (yz|s)     (xy|s)  5 -> 17  *
c  6.  (zz|s)     (xy|x)  6 -> 21  *
c  7.  (xx|x)     (xy|y)  7 -> 2   *
c  8.  (xx|y)     (xy|z)  8 -> 3   *
c  9.  (xx|z)     (xz|s)  9 -> 4   *
c 10.  (xy|x)     (xz|x) 10 -> 6   *
c 11.  (xy|y)     (xz|y) 11 -> 7   *
c 12.  (xy|z)     (xz|z) 12 -> 8   *
c 13.  (xz|x)     (yy|s) 13 -> 10  *
c 14.  (xz|y)     (yy|x) 14 -> 11  *
c 15.  (xz|z)     (yy|y) 15 -> 12  *
c 16.  (yy|x)     (yy|z) 16 -> 14  *
c 17.  (yy|y)     (yz|s) 17 -> 15  *
c 18.  (yy|z)     (yz|x) 18 -> 16  *
c 19.  (yz|x)     (yz|y) 19 -> 18  *
c 20.  (yz|y)     (yz|z) 20 -> 19  *
c 21.  (yz|z)     (zz|s) 21 -> 20  *
c 22.  (zz|x)     (zz|x)
c 23.  (zz|y)     (zz|y)
c 24.  (zz|z)     (zz|z)
c
      implicit none
c:tex-\begin{verbatim}
      integer num_blocks  !< [Input] num. blocks to transform
      double precision block(24,num_blocks) !< [Input/Output] integral block
c:tex-\end{verbatim}
c
      double precision temp1, temp2, temp3
      integer ib
c
      do 00100 ib = 1, num_blocks
        temp1        = block(2,ib)    ! 2 -> temp1
        block(2,ib)  = block(7,ib)    ! 7 -> 2
        temp2        = block(3,ib)    ! 3 -> temp2
        block(3,ib)  = block(8,ib)    ! 8 -> 3
        temp3        = block(4,ib)    ! 4 -> temp3
        block(4,ib)  = block(9,ib)    ! 9 -> 4
        block(9,ib)  = temp2          ! temp2 -> 9 or 3 -> 9
        temp2        = block(6,ib)    ! 6 -> temp2
        block(6,ib)  = block(10,ib)   ! 10 -> 6
        block(7,ib)  = block(11,ib)   ! 11 -> 7
        block(8,ib)  = block(12,ib)   ! 12 -> 8
        block(10,ib) = block(13,ib)   ! 13 -> 10
        block(11,ib) = block(14,ib)   ! 14 -> 11
        block(12,ib) = block(15,ib)   ! 15 -> 12
        block(14,ib) = block(16,ib)   ! 16 -> 14
        block(15,ib) = block(17,ib)   ! 17 -> 15
        block(17,ib) = block(5,ib)    ! 5 -> 17
        block(5,ib)  = temp1          ! temp1 -> 5 or 2 -> 5
        block(16,ib) = block(18,ib)   ! 18 -> 16
        block(18,ib) = block(19,ib)   ! 19 -> 18
        block(19,ib) = block(20,ib)   ! 20 -> 19
        block(20,ib) = block(21,ib)   ! 21 -> 20
        block(13,ib) = temp3          ! temp3 -> 13 or 4 -> 13
        block(21,ib) = temp2          ! temp2 -> 21 or 6 -> 21
00100 continue
      end
C>
C> \brief Transform the integrals from the way they were computed
C> as \f$(s|s)\f$, \f$(s|p)\f$, \f$(p|s)\f$ and \f$(p|p)\f$ to
C> \f$(sp|sp)\f$
C>
C> This routine transforms the integrals from the way they were computed
C> as \f$(s|s)\f$, \f$(s|p)\f$, \f$(p|s)\f$ and \f$(p|p)\f$ to
C> \f$(sp|sp)\f$. The transformation completes as follows:
C>
C> <table>
C> <tr><th> no.</th><th>computed order</th><th>transformed order</th><th>permutation      </th></tr>
C> <tr><td>  1 </td><td> \f$(s|s)\f$ </td><td> \f$(s|s)\f$ </td><td>                        </td></tr>
C> <tr><td>  2 </td><td> \f$(s|x)\f$ </td><td> \f$(s|x)\f$ </td><td>                        </td></tr>
C> <tr><td>  3 </td><td> \f$(s|y)\f$ </td><td> \f$(s|y)\f$ </td><td>                        </td></tr>
C> <tr><td>  4 </td><td> \f$(s|z)\f$ </td><td> \f$(s|z)\f$ </td><td>                        </td></tr>
C> <tr><td>  5 </td><td> \f$(x|s)\f$ </td><td> \f$(x|s)\f$ </td><td>                        </td></tr>
C> <tr><td>  6 </td><td> \f$(y|s)\f$ </td><td> \f$(x|x)\f$ </td><td> \f$6 \rightarrow 9 \f$ </td></tr>
C> <tr><td>  7 </td><td> \f$(z|s)\f$ </td><td> \f$(x|y)\f$ </td><td> \f$7 \rightarrow 13\f$ </td></tr>
C> <tr><td>  8 </td><td> \f$(x|x)\f$ </td><td> \f$(x|z)\f$ </td><td> \f$8 \rightarrow 6 \f$ </td></tr>
C> <tr><td>  9 </td><td> \f$(x|y)\f$ </td><td> \f$(y|s)\f$ </td><td> \f$9 \rightarrow 7 \f$ </td></tr>
C> <tr><td> 10 </td><td> \f$(x|z)\f$ </td><td> \f$(y|x)\f$ </td><td> \f$10\rightarrow 8 \f$ </td></tr>
C> <tr><td> 11 </td><td> \f$(y|x)\f$ </td><td> \f$(y|y)\f$ </td><td> \f$11\rightarrow 10\f$ </td></tr>
C> <tr><td> 12 </td><td> \f$(y|y)\f$ </td><td> \f$(y|z)\f$ </td><td> \f$12\rightarrow 11\f$ </td></tr>
C> <tr><td> 13 </td><td> \f$(y|z)\f$ </td><td> \f$(z|s)\f$ </td><td> \f$13\rightarrow 12\f$ </td></tr>
C> <tr><td> 14 </td><td> \f$(z|x)\f$ </td><td> \f$(z|x)\f$ </td><td>                        </td></tr>
C> <tr><td> 15 </td><td> \f$(z|y)\f$ </td><td> \f$(z|y)\f$ </td><td>                        </td></tr>
C> <tr><td> 16 </td><td> \f$(z|z)\f$ </td><td> \f$(z|z)\f$ </td><td>                        </td></tr>
C> </table>
C>
c:tex-% part of the internal API routines
c:tex-\subsection{int\_1spsp}
c:tex-This routine transforms integrals from the way they
c:tex-were computed $(s|s)$, $(s|p)$, $(p|s)$, $(p|p)$  
c:tex-to $(sp|sp)$.
c:tex-The transformation is done in place as follows:
c:tex-\begin{tabular}{rccc}      
c:tex-  &  computed & transformed   &   \\
c:tex-  &   order   &  order  &   \\
c:tex-~1 & (s$|$s)  &  (s$|$s)  &   \\
c:tex-~2 & (s$|$x)  &  (s$|$x)  &   \\
c:tex-~3 & (s$|$y)  &  (s$|$y)  &   \\
c:tex-~4 & (s$|$z)  &  (s$|$z)  &   \\
c:tex-~5 & (x$|$s)  &  (x$|$s)  &   \\
c:tex-~6 & (y$|$s)  &  (x$|$x)  &  ~6 $\rightarrow$ 9\\
c:tex-~7 & (z$|$s)  &  (x$|$y)  &  ~7 $\rightarrow$ 13\\
c:tex-~8 & (x$|$x)  &  (x$|$z)  &  ~8 $\rightarrow$ 6\\
c:tex-~9 & (x$|$y)  &  (y$|$s)  &  ~9 $\rightarrow$ 7\\
c:tex-10 & (x$|$z)  &  (y$|$x)  &  10 $\rightarrow$ 8 \\ 
c:tex-11 & (y$|$x)  &  (y$|$y)  &  11 $\rightarrow$ 10\\
c:tex-12 & (y$|$y)  &  (y$|$z)  &  12 $\rightarrow$ 11\\
c:tex-13 & (y$|$z)  &  (z$|$s)  &  13 $\rightarrow$ 12\\
c:tex-14 & (z$|$x)  &  (z$|$x)  &   \\
c:tex-15 & (z$|$y)  &  (z$|$y)  &   \\
c:tex-16 & (z$|$z)  &  (z$|$z)  &   \\
c:tex-\end{tabular}
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_1spsp(block,num_blocks)
c:tex-\end{verbatim}
c
c transforms a 1 electron integral block holding the 16
c (sp|sp) integrals calculated from 4 calls:
c           (s|s),(s|p),(p|s),(p|p) to the (sp|sp) order
c
c      computed transformed 
c       order      order
c  1.   (s|s)      (s|s)
c  2.   (s|x)      (s|x)  
c  3.   (s|y)      (s|y)
c  4.   (s|z)      (s|z)
c  5.   (x|s)      (x|s)
c  6.   (y|s)      (x|x)   6 -> 9
c  7.   (z|s)      (x|y)   7 -> 13
c  8.   (x|x)      (x|z)   8 -> 6
c  9.   (x|y)      (y|s)   9 -> 7
c 10.   (x|z)      (y|x)  10 -> 8 
c 11.   (y|x)      (y|y)  11 -> 10
c 12.   (y|y)      (y|z)  12 -> 11
c 13.   (y|z)      (z|s)  13 -> 12
c 14.   (z|x)      (z|x)
c 15.   (z|y)      (z|y)
c 16.   (z|z)      (z|z)
      implicit none
c:tex-\begin{verbatim}
      integer num_blocks        !< [Input] num. blocks to transform
      double precision block(16,num_blocks) !< [Input/Output] integral block
c:tex-\end{verbatim}
c
      double precision temp
      integer ib
c
      do 00100 ib = 1,num_blocks
        temp         = block(6, ib)
        block(6, ib) = block(8, ib)
        block(8, ib) = block(10,ib)
        block(10,ib) = block(11,ib)
        block(11,ib) = block(12,ib)
        block(12,ib) = block(13,ib)
        block(13,ib) = block(7, ib)
        block(7, ib) = block(9, ib)
        block(9, ib) = temp
00100 continue
      end
C> 
C> \brief Transform the integrals from the way they were computed as
C> \f$(s|X)\f$ and \f$(p|X)\f$ to \f$(sp|X)\f$
C>
c:tex-% part of the internal API routines
c:tex-\subsection{int\_1spa}
c:tex-This routine transforms integrals from the way they
c:tex-were computed $(s|X)$, $(p|X)$, to $(sp|X)$.
c:tex-The transformation is {\bf NOT} done in place:
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_sp1a(sp_block,s_block,p_block,sizeb,num_blocks)
c:tex-\end{verbatim}
c
*..  sp 1 electron transformation routine 
*.. (ash|bsh) block of integrals where a is an sp shell
c
      implicit none
c::passed
c:tex-\begin{verbatim}
      integer sizeb  !< [Input] size of non sp block
      integer num_blocks !< [Input] num of blocks to transform
*
      double precision sp_block(sizeb,1:4,num_blocks) !< [Output] (sp|X) transformed integral block
*
      double precision s_block(sizeb,num_blocks)      !< [Input] computed (s|X) block
*
      double precision p_block(sizeb,2:4,num_blocks)  !< [Input] computed (p|X) block
c:tex-\end{verbatim}
c::local
      integer block
      integer ib
c
      do 00100 block=1,num_blocks
        do 00200 ib = 1,sizeb
          sp_block(ib,1,block) = s_block(ib,block)
          sp_block(ib,2,block) = p_block(ib,2,block)
          sp_block(ib,3,block) = p_block(ib,3,block)
          sp_block(ib,4,block) = p_block(ib,4,block)
00200   continue
00100 continue
      end
C> 
C> \brief Transform the integrals from the way they were computed as
C> \f$(X|s)\f$ and \f$(X|p)\f$ to \f$(X|sp)\f$
C>
c:tex-% part of the internal API routines
c:tex-\subsection{int\_sp1b}
c:tex-This routine transforms integrals from the way they
c:tex-were computed $(X|s)$, $(X|p)$, to $(X|sp)$.
c:tex-The transformation is {\bf NOT} done in place:
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_sp1b(sp_block,s_block,p_block,sizea,num_blocks)
c:tex-\end{verbatim}
c
*..  sp 1 electron transformation routine 
*.. (ash|bsh) block of integrals where b is an sp shell
c
      implicit none
c::passed
c:tex-\begin{verbatim}
      integer sizea !< [Input] size of non sp block
      integer num_blocks !< [Input] num of blocks to transform
*
      double precision sp_block(1:4,sizea,num_blocks) !< [Output] (X|sp) transformed integral block
*
      double precision s_block(sizea,num_blocks)      !< [Input] computed (X|s) block
*
      double precision p_block(2:4,sizea,num_blocks)  !< [Input] computed (X|p) block
c:tex-\end{verbatim}
c::local
      integer block
      integer ia
c
      do 00100 block = 1,num_blocks
        do 00200 ia = 1,sizea
          
          sp_block(1,ia,block) = s_block(ia,block)
          sp_block(2,ia,block) = p_block(2,ia,block)
          sp_block(3,ia,block) = p_block(3,ia,block)
          sp_block(4,ia,block) = p_block(4,ia,block)
00200   continue
00100 continue
      end
C> @}

c****f* ddscf_fock_2e/fock_builders_note
c
c     NOTES
c
c     Originally the Fock builders in this file were written to deal 
c     with straightforward Hartree-Fock cases. Recently the
c     functionality of the code has been extended to include NMR and
c     spin-orbit coupling. In these cases the operators become complex
c     which has consequences for the assumptions that may be exploited
c     in the Fock builders.
c
c     The main consequence of having complex operators is that the 
c     Fock and density matrices involved become complex valued as well.
c     A common approach to deal with this is to separate the real and
c     imaginary parts of the matrices and deal with them separately. 
c     The advantage is that existing code can be used that way.
c     There is a catch, however...
c
c     The argument below applies equally to Fock and density matrices
c     even though we refer to density matrices here as they are simpler.
c     The density matrix is defined as:
c
c                        *                   *     *
c        D(r,r') = sum  f (r) f (r') = sum  x (r) c   c   x (r')       '
c                     i  i     i          i  r     ri  si  s
c
c     It is clear from this equation that the following relationship
c     holds:
c
c               *
c        D   = D
c         rs    sr
c
c     which implies
c
c        Re(D  ) = Re(D  ),  Im(D  ) = -Im(D  )
c            rs        sr        rs         sr
c
c     i.e. the real part of the density matrix is symmetric, whereas
c     the imaginary part is anti-symmetric.
c
c     In the traditional Hartree-Fock case the imaginary part is zero,
c     and the symmetry property can be used at will. For the general
c     case, however, the code has to correctly handle both symmetric and
c     anti-symmetric cases. Extreme care is required when permuting
c     matrix indeces to ensure the correctness of the result. Also
c     test cases have to be selected carefully as traditional Fock
c     based algorithms will not be affected by mistakes.
c
c     Huub van Dam, August 2010.
c
c******
      subroutine fock_init_cmul(idim,jdim,ldim)
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
      integer idim, jdim, ldim
c
c     Initialize array to eliminate integer multiplication in
c     Fock-build kernels
c
      integer i
c
      do i = 0,maxim1
         lm(i) = ldim*i
         jm(i) = jdim*i
         im(i) = idim*i
      enddo
c
      end
      subroutine fock_init_rep_cmul(nbf)
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
#include "util.fh"
      integer nbf
c
c     Initialize array to eliminate integer multiplication in
c     Fock-build kernels ... replicated version
c
      integer i
c
      do i = 1,nbf
         im1(i) = (i-1)*nbf
      enddo
c
      end
c
c****f* ddscf_fock_2e/fock_2e_label
c
c     NAME
c
c       fock_2e_label -- Distributed data Fock-matrix builder
c
c     SYNOPSIS
c
c       subroutine fock_2e_label(nfock, tol2e, neri, ilab, jlab,
c                  klab, llab, eri, ilo, ihi, jlo, jhi, klo, khi,
c                  llo, lhi, dij, dik, dli, djk, dlj, dlk,
c                  fij, fik, fli, fjk, flj, flk)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to nfock Fock
c       matrices given the corresponding density matrices, and a set of
c       Electron Repulsion Integrals (ERI). It uses a distributed data
c       approach, i.e. only the given blocks of the Fock and density
c       matrices are accessible. The ERI are presented along with their
c       labels, where the labels run as
c
c         * ilo <= ilab(n) <= ihi
c         * jlo <= jlab(n) <= jhi
c         * klo <= klab(n) <= khi
c         * llo <= llab(n) <= lhi
c
c       To compute the indeces in the various blocks the routine uses
c       the arrays im, jm and lm from the common block cfockmul. 
c       This common block is initialized in subroutine fock_init_cmul
c       for every distinct set of Fock and density matrix blocks.
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F). The latter condition
c       follows from the fact that the data communication is spread
c       much more evenly across the machine if the indices on one of
c       matrices are interchanged. I.e. if to calculate Fij one uses
c       Dji rather than Dij. Due to the properties of the density
c       and Fock matrices this leads to the introduction of a sign
c       for the imaginary Fock matrices.
c
c     INPUTS
c
c       nfock - the number of Fock matrices
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       ilab(neri) - the i-labels for each integral
c
c       jlab(neri) - the j-labels for each integral
c
c       klab(neri) - the k-labels for each integral
c
c       llab(neri) - the l-labels for each integral
c
c       eri(neri)  - the ERI themselves
c
c       ilo, ihi   - the lower and upper limit on the i-basis functions
c
c       jlo, jhi   - the lower and upper limit on the j-basis functions
c
c       klo, khi   - the lower and upper limit on the k-basis functions
c
c       llo, lhi   - the lower and upper limit on the l-basis functions
c
c       dij - density matrix block representing D(nfock,ilo:ihi,jlo:jhi)
c
c       dik - density matrix block representing D(nfock,ilo:ihi,klo:khi)
c
c       dli - density matrix block representing D(nfock,llo:lhi,ilo:ihi)
c
c       djk - density matrix block representing D(nfock,jlo:jhi,klo:khi)
c
c       dlj - density matrix block representing D(nfock,llo:lhi,jlo:jhi)
c
c       dlk - density matrix block representing D(nfock,llo:lhi,klo:khi)
c
c     OUTPUT
c
c       fij - Fock matrix block representing F(nfock,ilo:ihi,jlo:jhi)
c
c       fik - Fock matrix block representing F(nfock,ilo:ihi,klo:khi)
c
c       fli - Fock matrix block representing F(nfock,llo:lhi,ilo:ihi)
c
c       fjk - Fock matrix block representing F(nfock,jlo:jhi,klo:khi)
c
c       flj - Fock matrix block representing F(nfock,llo:lhi,jlo:jhi)
c
c       flk - Fock matrix block representing F(nfock,llo:lhi,klo:khi)
c
c     SOURCE
c
      subroutine fock_2e_label(nfock, tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      integer nfock
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      double precision eri(neri)
      double precision dij(nfock,0:*)
      double precision dik(nfock,0:*)
      double precision dli(nfock,0:*)
      double precision djk(nfock,0:*)
      double precision dlj(nfock,0:*)
      double precision dlk(nfock,0:*)
      double precision fij(nfock,0:*)
      double precision fik(nfock,0:*)
      double precision fli(nfock,0:*)
      double precision fjk(nfock,0:*)
      double precision flj(nfock,0:*)
      double precision flk(nfock,0:*)
c     
      integer i, j, k, l, ind, v
      integer idim, jdim, ldim
      integer ij, lk, ik, li, lj, jk
      double precision g
c
      if (nfock .eq. 1) then
         call fock_2e_1_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else if (nfock .eq. 2) then
         call fock_2e_2_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else if (nfock .eq. 3) then
         call fock_2e_3_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else if (nfock .eq. 4) then
         call fock_2e_4_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else
         idim = ihi - ilo + 1
         jdim = jhi - jlo + 1
         ldim = lhi - llo + 1
         do ind = 1, neri
            g = eri(ind)
            if (abs(g) .gt. tol2e) then
               i = ilab(ind) - ilo
               j = jlab(ind) - jlo
               k = klab(ind) - klo
               l = llab(ind) - llo
c     
*     ij = i + j*idim
*     lk = l + k*ldim
*     ik = i + k*idim
*     li = l + i*ldim
*     lj = l + j*ldim
*     jk = j + k*jdim
               ij = i + im(j)
               lk = l + lm(k)
               ik = i + im(k)
               li = l + lm(i)
               lj = l + lm(j)
               jk = j + jm(k)
               do v = 1, nfock
                  fij(v,ij) = fij(v,ij) + g*dlk(v,lk)
                  flk(v,lk) = flk(v,lk) + g*dij(v,ij)
                  fik(v,ik) = fik(v,ik) + g*dlj(v,lj)
                  fli(v,li) = fli(v,li) + g*djk(v,jk)
                  flj(v,lj) = flj(v,lj) + g*dik(v,ik)
                  fjk(v,jk) = fjk(v,jk) + g*dli(v,li)
               end do
            end if
         end do
      endif
c
      end
c
c******
c
c****f* ddscf_fock_2e/fock_2e_1_label
c
c     NAME
c
c       fock_2e_1_label -- Distributed data Fock-matrix builder for
c                          1 matrix
c
c     SYNOPSIS
c
c       subroutine fock_2e_1_label(tol2e, neri, ilab, jlab,
c                  klab, llab, eri, ilo, ihi, jlo, jhi, klo, khi,
c                  llo, lhi, dij, dik, dli, djk, dlj, dlk,
c                  fij, fik, fli, fjk, flj, flk)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to 1 Fock
c       matrix given the corresponding density matrix, and a set of
c       Electron Repulsion Integrals (ERI). It uses a distributed data
c       approach, i.e. only the given blocks of the Fock and density
c       matrices are accessible. The ERI are presented along with their
c       labels, where the labels run as
c
c         * ilo <= ilab(n) <= ihi
c         * jlo <= jlab(n) <= jhi
c         * klo <= klab(n) <= khi
c         * llo <= llab(n) <= lhi
c
c       To compute the indeces in the various blocks the routine uses
c       the arrays im, jm and lm from the common block cfockmul. 
c       This common block is initialized in subroutine fock_init_cmul
c       for every distinct set of Fock and density matrix blocks.
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F). The latter condition
c       follows from the fact that the data communication is spread
c       much more evenly across the machine if the indices on one of
c       matrices are interchanged. I.e. if to calculate Fij one uses
c       Dji rather than Dij. Due to the properties of the density
c       and Fock matrices this leads to the introduction of a sign
c       for the imaginary Fock matrices.
c
c     INPUTS
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       ilab(neri) - the i-labels for each integral
c
c       jlab(neri) - the j-labels for each integral
c
c       klab(neri) - the k-labels for each integral
c
c       llab(neri) - the l-labels for each integral
c
c       eri(neri)  - the ERI themselves
c
c       ilo, ihi   - the lower and upper limit on the i-basis functions
c
c       jlo, jhi   - the lower and upper limit on the j-basis functions
c
c       klo, khi   - the lower and upper limit on the k-basis functions
c
c       llo, lhi   - the lower and upper limit on the l-basis functions
c
c       dij - density matrix block representing D(ilo:ihi,jlo:jhi)
c
c       dik - density matrix block representing D(ilo:ihi,klo:khi)
c
c       dli - density matrix block representing D(llo:lhi,ilo:ihi)
c
c       djk - density matrix block representing D(jlo:jhi,klo:khi)
c
c       dlj - density matrix block representing D(llo:lhi,jlo:jhi)
c
c       dlk - density matrix block representing D(llo:lhi,klo:khi)
c
c     OUTPUT
c
c       fij - Fock matrix block representing F(ilo:ihi,jlo:jhi)
c
c       fik - Fock matrix block representing F(ilo:ihi,klo:khi)
c
c       fli - Fock matrix block representing F(llo:lhi,ilo:ihi)
c
c       fjk - Fock matrix block representing F(jlo:jhi,klo:khi)
c
c       flj - Fock matrix block representing F(llo:lhi,jlo:jhi)
c
c       flk - Fock matrix block representing F(llo:lhi,klo:khi)
c
c     SOURCE
c
      subroutine fock_2e_1_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      double precision eri(neri)
      double precision dij(0:*)
      double precision dik(0:*)
      double precision dli(0:*)
      double precision djk(0:*)
      double precision dlj(0:*)
      double precision dlk(0:*)
      double precision fij(0:*)
      double precision fik(0:*)
      double precision fli(0:*)
      double precision fjk(0:*)
      double precision flj(0:*)
      double precision flk(0:*)
c     
      integer i, j, k, l, ind
      double precision g
      integer idim, jdim, ldim
      integer ij, lk, ik, li, lj, jk
c
      idim = ihi - ilo + 1
      jdim = jhi - jlo + 1
      ldim = lhi - llo + 1
c     
      do ind = 1, neri
         g = eri(ind)
         i = ilab(ind) - ilo
         j = jlab(ind) - jlo
         k = klab(ind) - klo
         l = llab(ind) - llo
c     
*      ij = i + j*idim
*      lk = l + k*ldim
*      ik = i + k*idim
*      li = l + i*ldim
*      lj = l + j*ldim
*      jk = j + k*jdim
         ij = i + im(j)
         lk = l + lm(k)
         ik = i + im(k)
         li = l + lm(i)
         lj = l + lm(j)
         jk = j + jm(k)
         fij(ij) = fij(ij) + g*dlk(lk)
         flk(lk) = flk(lk) + g*dij(ij)
         fik(ik) = fik(ik) + g*dlj(lj)
         fli(li) = fli(li) + g*djk(jk)
         flj(lj) = flj(lj) + g*dik(ik)
         fjk(jk) = fjk(jk) + g*dli(li)
      end do
c     
      end
c
c******
c
c****f* ddscf_fock_2e/fock_2e_2_label
c
c     NAME
c
c       fock_2e_2_label -- Distributed data Fock-matrix builder for
c                          2 matrices
c
c     SYNOPSIS
c
c       subroutine fock_2e_2_label(tol2e, neri, ilab, jlab,
c                  klab, llab, eri, ilo, ihi, jlo, jhi, klo, khi,
c                  llo, lhi, dij, dik, dli, djk, dlj, dlk,
c                  fij, fik, fli, fjk, flj, flk)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to 2 Fock
c       matrices given the corresponding density matrices, and a set of
c       Electron Repulsion Integrals (ERI). It uses a distributed data
c       approach, i.e. only the given blocks of the Fock and density
c       matrices are accessible. The ERI are presented along with their
c       labels, where the labels run as
c
c         * ilo <= ilab(n) <= ihi
c         * jlo <= jlab(n) <= jhi
c         * klo <= klab(n) <= khi
c         * llo <= llab(n) <= lhi
c
c       To compute the indeces in the various blocks the routine uses
c       the arrays im, jm and lm from the common block cfockmul. 
c       This common block is initialized in subroutine fock_init_cmul
c       for every distinct set of Fock and density matrix blocks.
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F). The latter condition
c       follows from the fact that the data communication is spread
c       much more evenly across the machine if the indices on one of
c       matrices are interchanged. I.e. if to calculate Fij one uses
c       Dji rather than Dij. Due to the properties of the density
c       and Fock matrices this leads to the introduction of a sign
c       for the imaginary Fock matrices.
c
c     INPUTS
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       ilab(neri) - the i-labels for each integral
c
c       jlab(neri) - the j-labels for each integral
c
c       klab(neri) - the k-labels for each integral
c
c       llab(neri) - the l-labels for each integral
c
c       eri(neri)  - the ERI themselves
c
c       ilo, ihi   - the lower and upper limit on the i-basis functions
c
c       jlo, jhi   - the lower and upper limit on the j-basis functions
c
c       klo, khi   - the lower and upper limit on the k-basis functions
c
c       llo, lhi   - the lower and upper limit on the l-basis functions
c
c       dij - density matrix block representing D(2,ilo:ihi,jlo:jhi)
c
c       dik - density matrix block representing D(2,ilo:ihi,klo:khi)
c
c       dli - density matrix block representing D(2,llo:lhi,ilo:ihi)
c
c       djk - density matrix block representing D(2,jlo:jhi,klo:khi)
c
c       dlj - density matrix block representing D(2,llo:lhi,jlo:jhi)
c
c       dlk - density matrix block representing D(2,llo:lhi,klo:khi)
c
c     OUTPUT
c
c       fij - Fock matrix block representing F(2,ilo:ihi,jlo:jhi)
c
c       fik - Fock matrix block representing F(2,ilo:ihi,klo:khi)
c
c       fli - Fock matrix block representing F(2,llo:lhi,ilo:ihi)
c
c       fjk - Fock matrix block representing F(2,jlo:jhi,klo:khi)
c
c       flj - Fock matrix block representing F(2,llo:lhi,jlo:jhi)
c
c       flk - Fock matrix block representing F(2,llo:lhi,klo:khi)
c
c     SOURCE
c
      subroutine fock_2e_2_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      double precision eri(neri)
      double precision dij(2,0:*)
      double precision dik(2,0:*)
      double precision dli(2,0:*)
      double precision djk(2,0:*)
      double precision dlj(2,0:*)
      double precision dlk(2,0:*)
      double precision fij(2,0:*)
      double precision fik(2,0:*)
      double precision fli(2,0:*)
      double precision fjk(2,0:*)
      double precision flj(2,0:*)
      double precision flk(2,0:*)
c     
      integer i, j, k, l, ind
      double precision g
      integer idim, jdim, ldim
      integer ij, lk, ik, li, lj, jk
c
      idim = ihi - ilo + 1
      jdim = jhi - jlo + 1
      ldim = lhi - llo + 1
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = ilab(ind) - ilo
            j = jlab(ind) - jlo
            k = klab(ind) - klo
            l = llab(ind) - llo
c
*            ij = i + j*idim
*            lk = l + k*ldim
*            ik = i + k*idim
*            li = l + i*ldim
*            lj = l + j*ldim
*            jk = j + k*jdim
            ij = i + im(j)
            lk = l + lm(k)
            ik = i + im(k)
            li = l + lm(i)
            lj = l + lm(j)
            jk = j + jm(k)
            fij(1,ij) = fij(1,ij) + g*dlk(1,lk)
            flk(1,lk) = flk(1,lk) + g*dij(1,ij)
            fik(1,ik) = fik(1,ik) + g*dlj(1,lj)
            fli(1,li) = fli(1,li) + g*djk(1,jk)
            flj(1,lj) = flj(1,lj) + g*dik(1,ik)
            fjk(1,jk) = fjk(1,jk) + g*dli(1,li)
            fij(2,ij) = fij(2,ij) + g*dlk(2,lk)
            flk(2,lk) = flk(2,lk) + g*dij(2,ij)
            fik(2,ik) = fik(2,ik) + g*dlj(2,lj)
            fli(2,li) = fli(2,li) + g*djk(2,jk)
            flj(2,lj) = flj(2,lj) + g*dik(2,ik)
            fjk(2,jk) = fjk(2,jk) + g*dli(2,li)
         end if
      end do
c
      end
c
c******
c
c****f* ddscf_fock_2e/fock_2e_3_label
c
c     NAME
c
c       fock_2e_3_label -- Distributed data Fock-matrix builder for
c                          3 matrices
c
c     SYNOPSIS
c
c       subroutine fock_2e_3_label(tol2e, neri, ilab, jlab,
c                  klab, llab, eri, ilo, ihi, jlo, jhi, klo, khi,
c                  llo, lhi, dij, dik, dli, djk, dlj, dlk,
c                  fij, fik, fli, fjk, flj, flk)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to 3 Fock
c       matrices given the corresponding density matrices, and a set of
c       Electron Repulsion Integrals (ERI). It uses a distributed data
c       approach, i.e. only the given blocks of the Fock and density
c       matrices are accessible. The ERI are presented along with their
c       labels, where the labels run as
c
c         * ilo <= ilab(n) <= ihi
c         * jlo <= jlab(n) <= jhi
c         * klo <= klab(n) <= khi
c         * llo <= llab(n) <= lhi
c
c       To compute the indeces in the various blocks the routine uses
c       the arrays im, jm and lm from the common block cfockmul. 
c       This common block is initialized in subroutine fock_init_cmul
c       for every distinct set of Fock and density matrix blocks.
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F). The latter condition
c       follows from the fact that the data communication is spread
c       much more evenly across the machine if the indices on one of
c       matrices are interchanged. I.e. if to calculate Fij one uses
c       Dji rather than Dij. Due to the properties of the density
c       and Fock matrices this leads to the introduction of a sign
c       for the imaginary Fock matrices.
c
c     INPUTS
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       ilab(neri) - the i-labels for each integral
c
c       jlab(neri) - the j-labels for each integral
c
c       klab(neri) - the k-labels for each integral
c
c       llab(neri) - the l-labels for each integral
c
c       eri(neri)  - the ERI themselves
c
c       ilo, ihi   - the lower and upper limit on the i-basis functions
c
c       jlo, jhi   - the lower and upper limit on the j-basis functions
c
c       klo, khi   - the lower and upper limit on the k-basis functions
c
c       llo, lhi   - the lower and upper limit on the l-basis functions
c
c       dij - density matrix block representing D(3,ilo:ihi,jlo:jhi)
c
c       dik - density matrix block representing D(3,ilo:ihi,klo:khi)
c
c       dli - density matrix block representing D(3,llo:lhi,ilo:ihi)
c
c       djk - density matrix block representing D(3,jlo:jhi,klo:khi)
c
c       dlj - density matrix block representing D(3,llo:lhi,jlo:jhi)
c
c       dlk - density matrix block representing D(3,llo:lhi,klo:khi)
c
c     OUTPUT
c
c       fij - Fock matrix block representing F(3,ilo:ihi,jlo:jhi)
c
c       fik - Fock matrix block representing F(3,ilo:ihi,klo:khi)
c
c       fli - Fock matrix block representing F(3,llo:lhi,ilo:ihi)
c
c       fjk - Fock matrix block representing F(3,jlo:jhi,klo:khi)
c
c       flj - Fock matrix block representing F(3,llo:lhi,jlo:jhi)
c
c       flk - Fock matrix block representing F(3,llo:lhi,klo:khi)
c
c     SOURCE
c
      subroutine fock_2e_3_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      double precision eri(neri)
      double precision dij(3,0:*)
      double precision dik(3,0:*)
      double precision dli(3,0:*)
      double precision djk(3,0:*)
      double precision dlj(3,0:*)
      double precision dlk(3,0:*)
      double precision fij(3,0:*)
      double precision fik(3,0:*)
      double precision fli(3,0:*)
      double precision fjk(3,0:*)
      double precision flj(3,0:*)
      double precision flk(3,0:*)
c     
      integer i, j, k, l, ind
      double precision g
      integer idim, jdim, ldim
      integer ij, lk, ik, li, lj, jk
c
      idim = ihi - ilo + 1
      jdim = jhi - jlo + 1
      ldim = lhi - llo + 1
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = ilab(ind) - ilo
            j = jlab(ind) - jlo
            k = klab(ind) - klo
            l = llab(ind) - llo
c
*            ij = i + j*idim
*            lk = l + k*ldim
*            ik = i + k*idim
*            li = l + i*ldim
*            lj = l + j*ldim
*            jk = j + k*jdim
            ij = i + im(j)
            lk = l + lm(k)
            ik = i + im(k)
            li = l + lm(i)
            lj = l + lm(j)
            jk = j + jm(k)
            fij(1,ij) = fij(1,ij) + g*dlk(1,lk)
            flk(1,lk) = flk(1,lk) + g*dij(1,ij)
            fik(1,ik) = fik(1,ik) + g*dlj(1,lj)
            fli(1,li) = fli(1,li) + g*djk(1,jk)
            flj(1,lj) = flj(1,lj) + g*dik(1,ik)
            fjk(1,jk) = fjk(1,jk) + g*dli(1,li)
            fij(2,ij) = fij(2,ij) + g*dlk(2,lk)
            flk(2,lk) = flk(2,lk) + g*dij(2,ij)
            fik(2,ik) = fik(2,ik) + g*dlj(2,lj)
            fli(2,li) = fli(2,li) + g*djk(2,jk)
            flj(2,lj) = flj(2,lj) + g*dik(2,ik)
            fjk(2,jk) = fjk(2,jk) + g*dli(2,li)
            fij(3,ij) = fij(3,ij) + g*dlk(3,lk)
            flk(3,lk) = flk(3,lk) + g*dij(3,ij)
            fik(3,ik) = fik(3,ik) + g*dlj(3,lj)
            fli(3,li) = fli(3,li) + g*djk(3,jk)
            flj(3,lj) = flj(3,lj) + g*dik(3,ik)
            fjk(3,jk) = fjk(3,jk) + g*dli(3,li)
         end if
      end do
c
      end
c
c******
c
c****f* ddscf_fock_2e/fock_2e_4_label
c
c     NAME
c
c       fock_2e_4_label -- Distributed data Fock-matrix builder for
c                          4 matrices
c
c     SYNOPSIS
c
c       subroutine fock_2e_4_label(tol2e, neri, ilab, jlab,
c                  klab, llab, eri, ilo, ihi, jlo, jhi, klo, khi,
c                  llo, lhi, dij, dik, dli, djk, dlj, dlk,
c                  fij, fik, fli, fjk, flj, flk)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to 4 Fock
c       matrices given the corresponding density matrices, and a set of
c       Electron Repulsion Integrals (ERI). It uses a distributed data
c       approach, i.e. only the given blocks of the Fock and density
c       matrices are accessible. The ERI are presented along with their
c       labels, where the labels run as
c
c         * ilo <= ilab(n) <= ihi
c         * jlo <= jlab(n) <= jhi
c         * klo <= klab(n) <= khi
c         * llo <= llab(n) <= lhi
c
c       To compute the indeces in the various blocks the routine uses
c       the arrays im, jm and lm from the common block cfockmul. 
c       This common block is initialized in subroutine fock_init_cmul
c       for every distinct set of Fock and density matrix blocks.
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F). The latter condition
c       follows from the fact that the data communication is spread
c       much more evenly across the machine if the indices on one of
c       matrices are interchanged. I.e. if to calculate Fij one uses
c       Dji rather than Dij. Due to the properties of the density
c       and Fock matrices this leads to the introduction of a sign
c       for the imaginary Fock matrices.
c
c     INPUTS
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       ilab(neri) - the i-labels for each integral
c
c       jlab(neri) - the j-labels for each integral
c
c       klab(neri) - the k-labels for each integral
c
c       llab(neri) - the l-labels for each integral
c
c       eri(neri)  - the ERI themselves
c
c       ilo, ihi   - the lower and upper limit on the i-basis functions
c
c       jlo, jhi   - the lower and upper limit on the j-basis functions
c
c       klo, khi   - the lower and upper limit on the k-basis functions
c
c       llo, lhi   - the lower and upper limit on the l-basis functions
c
c       dij - density matrix block representing D(4,ilo:ihi,jlo:jhi)
c
c       dik - density matrix block representing D(4,ilo:ihi,klo:khi)
c
c       dli - density matrix block representing D(4,llo:lhi,ilo:ihi)
c
c       djk - density matrix block representing D(4,jlo:jhi,klo:khi)
c
c       dlj - density matrix block representing D(4,llo:lhi,jlo:jhi)
c
c       dlk - density matrix block representing D(4,llo:lhi,klo:khi)
c
c     OUTPUT
c
c       fij - Fock matrix block representing F(4,ilo:ihi,jlo:jhi)
c
c       fik - Fock matrix block representing F(4,ilo:ihi,klo:khi)
c
c       fli - Fock matrix block representing F(4,llo:lhi,ilo:ihi)
c
c       fjk - Fock matrix block representing F(4,jlo:jhi,klo:khi)
c
c       flj - Fock matrix block representing F(4,llo:lhi,jlo:jhi)
c
c       flk - Fock matrix block representing F(4,llo:lhi,klo:khi)
c
c     SOURCE
c
      subroutine fock_2e_4_label(tol2e, neri, 
     $     ilab, jlab, klab, llab, eri,
     $     ilo, ihi, jlo, jhi,
     $     klo, khi, llo, lhi,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      integer ilo, ihi, jlo, jhi, klo, khi, llo, lhi
      double precision eri(neri)
      double precision dij(4,0:*)
      double precision dik(4,0:*)
      double precision dli(4,0:*)
      double precision djk(4,0:*)
      double precision dlj(4,0:*)
      double precision dlk(4,0:*)
      double precision fij(4,0:*)
      double precision fik(4,0:*)
      double precision fli(4,0:*)
      double precision fjk(4,0:*)
      double precision flj(4,0:*)
      double precision flk(4,0:*)
c     
      integer i, j, k, l, ind
      double precision g
      integer idim, jdim, ldim
      integer ij, lk, ik, li, lj, jk
c
      idim = ihi - ilo + 1
      jdim = jhi - jlo + 1
      ldim = lhi - llo + 1
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = ilab(ind) - ilo
            j = jlab(ind) - jlo
            k = klab(ind) - klo
            l = llab(ind) - llo
c
*            ij = i + j*idim
*            lk = l + k*ldim
*            ik = i + k*idim
*            li = l + i*ldim
*            lj = l + j*ldim
*            jk = j + k*jdim
            ij = i + im(j)
            lk = l + lm(k)
            ik = i + im(k)
            li = l + lm(i)
            lj = l + lm(j)
            jk = j + jm(k)
            fij(1,ij) = fij(1,ij) + g*dlk(1,lk)
            flk(1,lk) = flk(1,lk) + g*dij(1,ij)
            fik(1,ik) = fik(1,ik) + g*dlj(1,lj)
            fli(1,li) = fli(1,li) + g*djk(1,jk)
            flj(1,lj) = flj(1,lj) + g*dik(1,ik)
            fjk(1,jk) = fjk(1,jk) + g*dli(1,li)
            fij(2,ij) = fij(2,ij) + g*dlk(2,lk)
            flk(2,lk) = flk(2,lk) + g*dij(2,ij)
            fik(2,ik) = fik(2,ik) + g*dlj(2,lj)
            fli(2,li) = fli(2,li) + g*djk(2,jk)
            flj(2,lj) = flj(2,lj) + g*dik(2,ik)
            fjk(2,jk) = fjk(2,jk) + g*dli(2,li)
            fij(3,ij) = fij(3,ij) + g*dlk(3,lk)
            flk(3,lk) = flk(3,lk) + g*dij(3,ij)
            fik(3,ik) = fik(3,ik) + g*dlj(3,lj)
            fli(3,li) = fli(3,li) + g*djk(3,jk)
            flj(3,lj) = flj(3,lj) + g*dik(3,ik)
            fjk(3,jk) = fjk(3,jk) + g*dli(3,li)
            fij(4,ij) = fij(4,ij) + g*dlk(4,lk)
            flk(4,lk) = flk(4,lk) + g*dij(4,ij)
            fik(4,ik) = fik(4,ik) + g*dlj(4,lj)
            fli(4,li) = fli(4,li) + g*djk(4,jk)
            flj(4,lj) = flj(4,lj) + g*dik(4,ik)
            fjk(4,jk) = fjk(4,jk) + g*dli(4,li)
         end if
      end do
c
      end
c
c******
c!!
c!!   READ THIS !!!!!!!!!!!!
c!!
c!!     Mod routines differ from above routines in that
c!!
c!!     1) have labels(4,neri) rather than i(neri), j(neri), ...
c!!     2) labels are offsets within the range, rather than
c!!        full labels (i.e., there is no need to subtract ilo)
c!!     3) No need to pass ranges since im/jm/lm are used
c!!
c
c****f* ddscf_fock_2e/fock_2e_mod_label
c
c     NAME
c
c       fock_2e_mod_label -- Modified distributed data Fock-matrix
c                            builder
c
c     SYNOPSIS
c
c       subroutine fock_2e_mod_label(nfock, tol2e, neri, labels, eri,
c                  dij, dik, dli, djk, dlj, dlk,
c                  fij, fik, fli, fjk, flj, flk)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to nfock Fock
c       matrices given the corresponding density matrices, and a set of
c       Electron Repulsion Integrals (ERI). It uses a distributed data
c       approach, i.e. only the given blocks of the Fock and density
c       matrices are accessible. 
c
c       The routine has been modified relative to its counter part
c       subroutine fock_2e_label so that the labels given enumerate 
c       basis functions within the current sub-ranges rather than the
c       full basis set. As a result the current sub-ranges need not
c       be explicitly specified. I.e. the labels satisfy the conditions
c
c         * 0 <= labels(1,n) <= ihi-ilo
c         * 0 <= labels(2,n) <= jhi-jlo
c         * 0 <= labels(3,n) <= khi-klo
c         * 0 <= labels(4,n) <= lhi-llo
c
c       where ilo through to llo and ihi through to lhi are defined
c       as in subroutine fock_2e_label.
c
c       To compute the indeces in the various blocks the routine uses
c       the arrays im, jm and lm from the common block cfockmul. 
c       This common block is initialized in subroutine fock_init_cmul
c       for every distinct set of Fock and density matrix blocks.
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F). The latter condition
c       follows from the fact that the data communication is spread
c       much more evenly across the machine if the indices on one of
c       matrices are interchanged. I.e. if to calculate Fij one uses
c       Dji rather than Dij. Due to the properties of the density
c       and Fock matrices this leads to the introduction of a sign
c       for the imaginary Fock matrices.
c
c     INPUTS
c
c       nfock - the number of Fock matrices
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       labels(4,neri) - the (i,j,k,l)-labels for each integral
c
c       eri(neri)  - the ERI themselves
c
c       dij - density matrix block representing D(nfock,ilo:ihi,jlo:jhi)
c
c       dik - density matrix block representing D(nfock,ilo:ihi,klo:khi)
c
c       dli - density matrix block representing D(nfock,llo:lhi,ilo:ihi)
c
c       djk - density matrix block representing D(nfock,jlo:jhi,klo:khi)
c
c       dlj - density matrix block representing D(nfock,llo:lhi,jlo:jhi)
c
c       dlk - density matrix block representing D(nfock,llo:lhi,klo:khi)
c
c     OUTPUT
c
c       fij - Fock matrix block representing F(nfock,ilo:ihi,jlo:jhi)
c
c       fik - Fock matrix block representing F(nfock,ilo:ihi,klo:khi)
c
c       fli - Fock matrix block representing F(nfock,llo:lhi,ilo:ihi)
c
c       fjk - Fock matrix block representing F(nfock,jlo:jhi,klo:khi)
c
c       flj - Fock matrix block representing F(nfock,llo:lhi,jlo:jhi)
c
c       flk - Fock matrix block representing F(nfock,llo:lhi,klo:khi)
c
c     SOURCE
c
      subroutine fock_2e_mod_label(nfock, tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      integer nfock
      double precision tol2e
      integer neri
      integer labels(*)
      double precision eri(neri)
      double precision dij(nfock,0:*)
      double precision dik(nfock,0:*)
      double precision dli(nfock,0:*)
      double precision djk(nfock,0:*)
      double precision dlj(nfock,0:*)
      double precision dlk(nfock,0:*)
      double precision fij(nfock,0:*)
      double precision fik(nfock,0:*)
      double precision fli(nfock,0:*)
      double precision fjk(nfock,0:*)
      double precision flj(nfock,0:*)
      double precision flk(nfock,0:*)
c     
      integer i, j, k, l, ind, v, ind4
      integer ij, lk, ik, li, lj, jk
      double precision g
c
      if (nfock .eq. 1) then
         call fock_2e_mod_1_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else if (nfock .eq. 2) then
         call fock_2e_mod_2_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else if (nfock .eq. 3) then
         call fock_2e_mod_3_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else if (nfock .eq. 4) then
         call fock_2e_mod_4_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
      else
         ind4 = 1
         do ind = 1, neri
            g = eri(ind)
            if (abs(g) .gt. tol2e) then
               i = labels(  ind4)
               j = labels(1+ind4)
               k = labels(2+ind4)
               l = labels(3+ind4)
c     
               ij = i + im(j)
               lk = l + lm(k)
               ik = i + im(k)
               li = l + lm(i)
               lj = l + lm(j)
               jk = j + jm(k)
               do v = 1, nfock
                  fij(v,ij) = fij(v,ij) + g*dlk(v,lk)
                  flk(v,lk) = flk(v,lk) + g*dij(v,ij)
                  fik(v,ik) = fik(v,ik) + g*dlj(v,lj)
                  fli(v,li) = fli(v,li) + g*djk(v,jk)
                  flj(v,lj) = flj(v,lj) + g*dik(v,ik)
                  fjk(v,jk) = fjk(v,jk) + g*dli(v,li)
               end do
            end if
            ind4 = ind4 + 4
         end do
      endif
c
      end
      subroutine fock_2e_mod_1_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer labels(*)
      double precision eri(neri)
      double precision dij(0:*)
      double precision dik(0:*)
      double precision dli(0:*)
      double precision djk(0:*)
      double precision dlj(0:*)
      double precision dlk(0:*)
      double precision fij(0:*)
      double precision fik(0:*)
      double precision fli(0:*)
      double precision fjk(0:*)
      double precision flj(0:*)
      double precision flk(0:*)
c     
      integer i, j, k, l, ind, ind4
      double precision g
      integer ij, lk, ik, li, lj, jk
c
      ind4 = 1
      do ind = 1, neri
         g = eri(ind)
         i = labels(  ind4)
         j = labels(1+ind4)
         k = labels(2+ind4)
         l = labels(3+ind4)
         ind4 = ind4 + 4
c     
         ij = i + im(j)
         lk = l + lm(k)
         ik = i + im(k)
         li = l + lm(i)
         lj = l + lm(j)
         jk = j + jm(k)
         fij(ij) = fij(ij) + g*dlk(lk)
         flk(lk) = flk(lk) + g*dij(ij)
         fik(ik) = fik(ik) + g*dlj(lj)
         fli(li) = fli(li) + g*djk(jk)
         flj(lj) = flj(lj) + g*dik(ik)
         fjk(jk) = fjk(jk) + g*dli(li)
      end do
c     
      end
      subroutine fock_2e_mod_2_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer labels(*)
      double precision eri(neri)
      double precision dij(2,0:*)
      double precision dik(2,0:*)
      double precision dli(2,0:*)
      double precision djk(2,0:*)
      double precision dlj(2,0:*)
      double precision dlk(2,0:*)
      double precision fij(2,0:*)
      double precision fik(2,0:*)
      double precision fli(2,0:*)
      double precision fjk(2,0:*)
      double precision flj(2,0:*)
      double precision flk(2,0:*)
c     
      integer i, j, k, l, ind, ind4
      double precision g
      integer ij, lk, ik, li, lj, jk
c
      ind4 = 1
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(  ind4)
            j = labels(1+ind4)
            k = labels(2+ind4)
            l = labels(3+ind4)
c
            ij = i + im(j)
            lk = l + lm(k)
            ik = i + im(k)
            li = l + lm(i)
            lj = l + lm(j)
            jk = j + jm(k)
            fij(1,ij) = fij(1,ij) + g*dlk(1,lk)
            flk(1,lk) = flk(1,lk) + g*dij(1,ij)
            fik(1,ik) = fik(1,ik) + g*dlj(1,lj)
            fli(1,li) = fli(1,li) + g*djk(1,jk)
            flj(1,lj) = flj(1,lj) + g*dik(1,ik)
            fjk(1,jk) = fjk(1,jk) + g*dli(1,li)
            fij(2,ij) = fij(2,ij) + g*dlk(2,lk)
            flk(2,lk) = flk(2,lk) + g*dij(2,ij)
            fik(2,ik) = fik(2,ik) + g*dlj(2,lj)
            fli(2,li) = fli(2,li) + g*djk(2,jk)
            flj(2,lj) = flj(2,lj) + g*dik(2,ik)
            fjk(2,jk) = fjk(2,jk) + g*dli(2,li)
         end if
         ind4 = ind4 + 4
      end do
c
      end
      subroutine fock_2e_mod_3_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer labels(*)
      double precision eri(neri)
      double precision dij(3,0:*)
      double precision dik(3,0:*)
      double precision dli(3,0:*)
      double precision djk(3,0:*)
      double precision dlj(3,0:*)
      double precision dlk(3,0:*)
      double precision fij(3,0:*)
      double precision fik(3,0:*)
      double precision fli(3,0:*)
      double precision fjk(3,0:*)
      double precision flj(3,0:*)
      double precision flk(3,0:*)
c     
      integer i, j, k, l, ind, ind4
      double precision g
      integer ij, lk, ik, li, lj, jk
c
      ind4 = 1
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(  ind4)
            j = labels(1+ind4)
            k = labels(2+ind4)
            l = labels(3+ind4)
c
            ij = i + im(j)
            lk = l + lm(k)
            ik = i + im(k)
            li = l + lm(i)
            lj = l + lm(j)
            jk = j + jm(k)
            fij(1,ij) = fij(1,ij) + g*dlk(1,lk)
            flk(1,lk) = flk(1,lk) + g*dij(1,ij)
            fik(1,ik) = fik(1,ik) + g*dlj(1,lj)
            fli(1,li) = fli(1,li) + g*djk(1,jk)
            flj(1,lj) = flj(1,lj) + g*dik(1,ik)
            fjk(1,jk) = fjk(1,jk) + g*dli(1,li)
            fij(2,ij) = fij(2,ij) + g*dlk(2,lk)
            flk(2,lk) = flk(2,lk) + g*dij(2,ij)
            fik(2,ik) = fik(2,ik) + g*dlj(2,lj)
            fli(2,li) = fli(2,li) + g*djk(2,jk)
            flj(2,lj) = flj(2,lj) + g*dik(2,ik)
            fjk(2,jk) = fjk(2,jk) + g*dli(2,li)
            fij(3,ij) = fij(3,ij) + g*dlk(3,lk)
            flk(3,lk) = flk(3,lk) + g*dij(3,ij)
            fik(3,ik) = fik(3,ik) + g*dlj(3,lj)
            fli(3,li) = fli(3,li) + g*djk(3,jk)
            flj(3,lj) = flj(3,lj) + g*dik(3,ik)
            fjk(3,jk) = fjk(3,jk) + g*dli(3,li)
         end if
         ind4 = ind4 + 4
      end do
c
      end
      subroutine fock_2e_mod_4_label(tol2e, neri, 
     $     labels, eri,
     $     dij, dik, dli, djk, dlj, dlk, 
     $     fij, fik, fli, fjk, flj, flk )
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.  It is ASSUMED that
c     all integrals in the input record will contribute only to the
c     six blocks of the given fock matrix
c     
      double precision tol2e
      integer neri
      integer labels(*)
      double precision eri(neri)
      double precision dij(4,0:*)
      double precision dik(4,0:*)
      double precision dli(4,0:*)
      double precision djk(4,0:*)
      double precision dlj(4,0:*)
      double precision dlk(4,0:*)
      double precision fij(4,0:*)
      double precision fik(4,0:*)
      double precision fli(4,0:*)
      double precision fjk(4,0:*)
      double precision flj(4,0:*)
      double precision flk(4,0:*)
c     
      integer i, j, k, l, ind, ind4
      double precision g
      integer ij, lk, ik, li, lj, jk
c
      ind4 = 1
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(  ind4)
            j = labels(1+ind4)
            k = labels(2+ind4)
            l = labels(3+ind4)
c
            ij = i + im(j)
            lk = l + lm(k)
            ik = i + im(k)
            li = l + lm(i)
            lj = l + lm(j)
            jk = j + jm(k)
            fij(1,ij) = fij(1,ij) + g*dlk(1,lk)
            flk(1,lk) = flk(1,lk) + g*dij(1,ij)
            fik(1,ik) = fik(1,ik) + g*dlj(1,lj)
            fli(1,li) = fli(1,li) + g*djk(1,jk)
            flj(1,lj) = flj(1,lj) + g*dik(1,ik)
            fjk(1,jk) = fjk(1,jk) + g*dli(1,li)
            fij(2,ij) = fij(2,ij) + g*dlk(2,lk)
            flk(2,lk) = flk(2,lk) + g*dij(2,ij)
            fik(2,ik) = fik(2,ik) + g*dlj(2,lj)
            fli(2,li) = fli(2,li) + g*djk(2,jk)
            flj(2,lj) = flj(2,lj) + g*dik(2,ik)
            fjk(2,jk) = fjk(2,jk) + g*dli(2,li)
            fij(3,ij) = fij(3,ij) + g*dlk(3,lk)
            flk(3,lk) = flk(3,lk) + g*dij(3,ij)
            fik(3,ik) = fik(3,ik) + g*dlj(3,lj)
            fli(3,li) = fli(3,li) + g*djk(3,jk)
            flj(3,lj) = flj(3,lj) + g*dik(3,ik)
            fjk(3,jk) = fjk(3,jk) + g*dli(3,li)
            fij(4,ij) = fij(4,ij) + g*dlk(4,lk)
            flk(4,lk) = flk(4,lk) + g*dij(4,ij)
            fik(4,ik) = fik(4,ik) + g*dlj(4,lj)
            fli(4,li) = fli(4,li) + g*djk(4,jk)
            flj(4,lj) = flj(4,lj) + g*dik(4,ik)
            fjk(4,jk) = fjk(4,jk) + g*dli(4,li)
         end if
         ind4 = ind4 + 4
      end do
c
      end
c
c******
c
c****f* ddscf_fock_2e/fock_2e_rep_label
c
c     NAME
c
c       fock_2e_rep_label -- Replicated data Fock-matrix builder
c
c     SYNOPSIS
c
c       subroutine fock_2e_rep_label(nfock, nbf, jfac, kfac,
c                  tol2e, neri, ilab, jlab, klab, llab, eri,
c                  dens, fock)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to nfock Fock
c       matrices given nfock density matrices, and a set of Electron
c       Repulsion Integrals (ERI). It assumes that a replicated data
c       approach is being used, i.e. the complete Fock and density
c       matrices are accessible. The ERI are presented along with their
c       labels, where the labels run from 1 to NBF, where NBF is the
c       total number of basis functions. Finally the Coulomb and
c       exchange contributions can be scaled to support Coulomb-fitting
c       and DFT calculations. 
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F), so that the results
c       are consistent with the distributed data case (see also
c       subroutine fock_2e_label).
c
c     INPUTS
c
c       nfock - the number of Fock matrices
c
c       nbf   - the number of basis functions
c
c       jfac(nfock) - the Coulomb contribution scale factors
c
c       kfac(nfock) - the exchange contribution scale factors
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       ilab(neri) - the i-labels for each integral
c
c       jlab(neri) - the j-labels for each integral
c
c       klab(neri) - the k-labels for each integral
c
c       llab(neri) - the l-labels for each integral
c
c       eri(neri) - the ERI themselves
c
c       dens(1:nfock*nbf*nbf) - the density matrices
c
c     OUTPUT
c
c       fock(1:nfock*nbf*nbf) - the Fock matrices
c
c     SOURCE
c
      subroutine fock_2e_rep_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, ilab, jlab, klab, llab, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.
c     
c     The _rep_ routines assume that each process has the entire 
c     fock matrix and that we are not adding into distinct patches
c     of the matrix.  We also must add in the j/k scaling factors.
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      double precision eri(neri)
      double precision fock(nfock,nbf*nbf), dens(nfock,nbf*nbf)
      double precision jfac(nfock), kfac(nfock)
c     
      integer i, j, k, l, ind, v
      integer ij, lk, ik, li, lj, jk
      double precision g, gk, gj
c
*      write(6,*) ' f2el ', neri, nfock
*      write(6,1) (eri(i),ilab(i),jlab(i),klab(i),llab(i),
*     $     i=1,min(neri,9))
*1     format(d16.8,4i5)
c
      if (nfock .eq. 1) then
         call fock_2e_rep_1_label(nfock, nbf, jfac, kfac, tol2e,
     $        neri, ilab, jlab, klab, llab, eri, dens, fock)
         return
      else if (nfock .eq. 2) then
         call fock_2e_rep_2_label(nfock, nbf, jfac, kfac, tol2e,
     $        neri, ilab, jlab, klab, llab, eri, dens, fock)
         return
      else if (nfock .eq. 3) then
         call fock_2e_rep_3_label(nfock, nbf, jfac, kfac, tol2e,
     $        neri, ilab, jlab, klab, llab, eri, dens, fock)
         return
      else if (nfock .eq. 4) then
         call fock_2e_rep_4_label(nfock, nbf, jfac, kfac, tol2e,
     $        neri, ilab, jlab, klab, llab, eri, dens, fock)
         return
      endif
c     
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = ilab(ind)
            j = jlab(ind)
            k = klab(ind)
            l = llab(ind)
*debug
*            if (i.le.0 .or. i.gt.nbf) call errquit(' i bad', i)
*            if (j.le.0 .or. j.gt.nbf) call errquit(' j bad', j)
*            if (l.le.0 .or. l.gt.nbf) call errquit(' l bad', l)
*            if (k.le.0 .or. k.gt.nbf) call errquit(' k bad', k)
*
            ij = i + im1(j)
            lj = l + im1(j)
            lk = l + im1(k)
            ik = i + im1(k)
            jk = j + im1(k)
            li = l + im1(i)
c
            do v = 1, nfock
               gj = g*jfac(v)
               gk = g*kfac(v)
               fock(v,ij) = fock(v,ij) + gj*dens(v,lk)
               fock(v,lk) = fock(v,lk) + gj*dens(v,ij)
               fock(v,ik) = fock(v,ik) + gk*dens(v,lj)
               fock(v,li) = fock(v,li) + gk*dens(v,jk)
               fock(v,lj) = fock(v,lj) + gk*dens(v,ik)
               fock(v,jk) = fock(v,jk) + gk*dens(v,li)
            end do
         end if
      end do
c     
      end
      subroutine fock_2e_rep_1_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, ilab, jlab, klab, llab, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.
c     
c     The _rep_ routines assume that each process has the entire 
c     fock matrix and that we are not adding into distinct patches
c     of the matrix.  We also must add in the j/k scaling factors.
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      double precision eri(neri)
      double precision fock(*), dens(*)
      double precision jfac, kfac
c     
      integer i, j, k, l, ind
      integer ij, lk, ik, li, lj, jk
      double precision g, gk, gj, fij, fkl, fik, fil, fjl, fjk
c     
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            gj = g*jfac
            gk = g*kfac
c
            i = ilab(ind)
            j = jlab(ind)
            k = klab(ind)
            l = llab(ind)
c
c           At some point (up to r18591) there was a replacement logic
c           based code here. This approach optimized for pipelining
c           instructions. However, to manage the needed scaling of the
c           integrals the code calculated Im(F) instead of -Im(F)
c           which caused conflicts with the other Fock builders,
c           in particular the distributed data ones.
c
            ij = i + im1(j)
            lk = l + im1(k)
c
            fock(ij) = fock(ij) + gj*dens(lk)
            fock(lk) = fock(lk) + gj*dens(ij)
c
            ik = i + im1(k)
            li = l + im1(i)
            lj = l + im1(j)
            jk = j + im1(k)
c
            fock(ik) = fock(ik) + gk*dens(lj)
            fock(li) = fock(li) + gk*dens(jk)
            fock(jk) = fock(jk) + gk*dens(li)
            fock(lj) = fock(lj) + gk*dens(ik)
         end if
      end do
c     
      end
      subroutine fock_2e_rep_2_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, ilab, jlab, klab, llab, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.
c     
c     The _rep_ routines assume that each process has the entire 
c     fock matrix and that we are not adding into distinct patches
c     of the matrix.  We also must add in the j/k scaling factors.
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      double precision eri(neri)
      double precision fock(nfock,nbf*nbf), dens(nfock,nbf*nbf)
      double precision jfac(nfock), kfac(nfock)
c     
      integer i, j, k, l, ind
      integer ij, lk, ik, li, lj, jk
      double precision g, gk1, gj1, gk2, gj2
c     
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = ilab(ind)
            j = jlab(ind)
            k = klab(ind)
            l = llab(ind)
c
            ij = i + im1(j)
            lj = l + im1(j)
            lk = l + im1(k)
            ik = i + im1(k)
            jk = j + im1(k)
            li = l + im1(i)
c
            gj1 = g*jfac(1)
            gk1 = g*kfac(1)
            fock(1,ij) = fock(1,ij) + gj1*dens(1,lk)
            fock(1,lk) = fock(1,lk) + gj1*dens(1,ij)
            fock(1,ik) = fock(1,ik) + gk1*dens(1,lj)
            fock(1,li) = fock(1,li) + gk1*dens(1,jk)
            fock(1,lj) = fock(1,lj) + gk1*dens(1,ik)
            fock(1,jk) = fock(1,jk) + gk1*dens(1,li)
c
            gj2 = g*jfac(2)
            gk2 = g*kfac(2)
            fock(2,ij) = fock(2,ij) + gj2*dens(2,lk)
            fock(2,lk) = fock(2,lk) + gj2*dens(2,ij)
            fock(2,ik) = fock(2,ik) + gk2*dens(2,lj)
            fock(2,li) = fock(2,li) + gk2*dens(2,jk)
            fock(2,lj) = fock(2,lj) + gk2*dens(2,ik)
            fock(2,jk) = fock(2,jk) + gk2*dens(2,li)
         end if
      end do
c     
      end
      subroutine fock_2e_rep_3_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, ilab, jlab, klab, llab, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.
c     
c     The _rep_ routines assume that each process has the entire 
c     fock matrix and that we are not adding into distinct patches
c     of the matrix.  We also must add in the j/k scaling factors.
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      double precision eri(neri)
      double precision fock(nfock,nbf*nbf), dens(nfock,nbf*nbf)
      double precision jfac(nfock), kfac(nfock)
c     
      integer i, j, k, l, ind
      integer ij, lk, ik, li, lj, jk
      double precision g, gk1, gj1, gk2, gj2, gk3, gj3
c     
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = ilab(ind)
            j = jlab(ind)
            k = klab(ind)
            l = llab(ind)
c
            ij = i + im1(j)
            lj = l + im1(j)
            lk = l + im1(k)
            ik = i + im1(k)
            jk = j + im1(k)
            li = l + im1(i)
c
            gj1 = g*jfac(1)
            gk1 = g*kfac(1)
            fock(1,ij) = fock(1,ij) + gj1*dens(1,lk)
            fock(1,lk) = fock(1,lk) + gj1*dens(1,ij)
            fock(1,ik) = fock(1,ik) + gk1*dens(1,lj)
            fock(1,li) = fock(1,li) + gk1*dens(1,jk)
            fock(1,lj) = fock(1,lj) + gk1*dens(1,ik)
            fock(1,jk) = fock(1,jk) + gk1*dens(1,li)
c
            gj2 = g*jfac(2)
            gk2 = g*kfac(2)
            fock(2,ij) = fock(2,ij) + gj2*dens(2,lk)
            fock(2,lk) = fock(2,lk) + gj2*dens(2,ij)
            fock(2,ik) = fock(2,ik) + gk2*dens(2,lj)
            fock(2,li) = fock(2,li) + gk2*dens(2,jk)
            fock(2,lj) = fock(2,lj) + gk2*dens(2,ik)
            fock(2,jk) = fock(2,jk) + gk2*dens(2,li)
c
            gj3 = g*jfac(3)
            gk3 = g*kfac(3)
            fock(3,ij) = fock(3,ij) + gj3*dens(3,lk)
            fock(3,lk) = fock(3,lk) + gj3*dens(3,ij)
            fock(3,ik) = fock(3,ik) + gk3*dens(3,lj)
            fock(3,li) = fock(3,li) + gk3*dens(3,jk)
            fock(3,lj) = fock(3,lj) + gk3*dens(3,ik)
            fock(3,jk) = fock(3,jk) + gk3*dens(3,li)
         end if
      end do
c     
      end
      subroutine fock_2e_rep_4_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, ilab, jlab, klab, llab, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.
c     
c     The _rep_ routines assume that each process has the entire 
c     fock matrix and that we are not adding into distinct patches
c     of the matrix.  We also must add in the j/k scaling factors.
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer ilab(neri),jlab(neri),klab(neri),llab(neri)
      double precision eri(neri)
      double precision fock(nfock,nbf*nbf), dens(nfock,nbf*nbf)
      double precision jfac(nfock), kfac(nfock)
c     
      integer i, j, k, l, ind
      integer ij, lk, ik, li, lj, jk
      double precision g, gk1, gj1, gk2, gj2, gk3, gj3, gk4, gj4
c     
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = ilab(ind)
            j = jlab(ind)
            k = klab(ind)
            l = llab(ind)
c
            ij = i + im1(j)
            lj = l + im1(j)
            lk = l + im1(k)
            ik = i + im1(k)
            jk = j + im1(k)
            li = l + im1(i)
c
            gj1 = g*jfac(1)
            gk1 = g*kfac(1)
            fock(1,ij) = fock(1,ij) + gj1*dens(1,lk)
            fock(1,lk) = fock(1,lk) + gj1*dens(1,ij)
            fock(1,ik) = fock(1,ik) + gk1*dens(1,lj)
            fock(1,li) = fock(1,li) + gk1*dens(1,jk)
            fock(1,lj) = fock(1,lj) + gk1*dens(1,ik)
            fock(1,jk) = fock(1,jk) + gk1*dens(1,li)
c
            gj2 = g*jfac(2)
            gk2 = g*kfac(2)
            fock(2,ij) = fock(2,ij) + gj2*dens(2,lk)
            fock(2,lk) = fock(2,lk) + gj2*dens(2,ij)
            fock(2,ik) = fock(2,ik) + gk2*dens(2,lj)
            fock(2,li) = fock(2,li) + gk2*dens(2,jk)
            fock(2,lj) = fock(2,lj) + gk2*dens(2,ik)
            fock(2,jk) = fock(2,jk) + gk2*dens(2,li)
c
            gj3 = g*jfac(3)
            gk3 = g*kfac(3)
            fock(3,ij) = fock(3,ij) + gj3*dens(3,lk)
            fock(3,lk) = fock(3,lk) + gj3*dens(3,ij)
            fock(3,ik) = fock(3,ik) + gk3*dens(3,lj)
            fock(3,li) = fock(3,li) + gk3*dens(3,jk)
            fock(3,lj) = fock(3,lj) + gk3*dens(3,ik)
            fock(3,jk) = fock(3,jk) + gk3*dens(3,li)
c
            gj4 = g*jfac(4)
            gk4 = g*kfac(4)
            fock(4,ij) = fock(4,ij) + gj4*dens(4,lk)
            fock(4,lk) = fock(4,lk) + gj4*dens(4,ij)
            fock(4,ik) = fock(4,ik) + gk4*dens(4,lj)
            fock(4,li) = fock(4,li) + gk4*dens(4,jk)
            fock(4,lj) = fock(4,lj) + gk4*dens(4,ik)
            fock(4,jk) = fock(4,jk) + gk4*dens(4,li)
         end if
      end do
c     
      end
c
c******
c
c****f* ddscf_fock_2e/fock_2e_rep_mod_label
c
c     NAME
c
c       fock_2e_rep_mod_label -- Modified replicated data Fock-matrix
c                                builder
c
c     SYNOPSIS
c
c       subroutine fock_2e_rep_mod_label(nfock, nbf, jfac, kfac,
c                  tol2e, neri, labels, eri, dens, fock)
c
c     FUNCTION
c
c       This routine adds Fock matrix contributions to nfock Fock
c       matrices given nfock density matrices, and a set of Electron
c       Repulsion Integrals (ERI). It assumes that a replicated data
c       approach is being used, i.e. the complete Fock and density
c       matrices are accessible. The ERI are presented along with their
c       labels, where the labels run from 0 to NBF-1, where NBF is the
c       total number of basis functions. Finally the Coulomb and
c       exchange contributions can be scaled to support Coulomb-fitting
c       and DFT calculations. 
c
c       This routine is implemented to be consistent with the 
c       requirements noted in ddscf_fock_2e/fock_builders_note .
c       This means that given Re(D) this routine calculate Re(F),
c       and given Im(D) it calculates -Im(F), so that the results
c       are consistent with the distributed data case (see also
c       subroutine fock_2e_label).
c
c     INPUTS
c
c       nfock - the number of Fock matrices
c
c       nbf   - the number of basis functions
c
c       jfac(nfock) - the Coulomb contribution scale factors
c
c       kfac(nfock) - the exchange contribution scale factors
c
c       tol2e - the ERI tolerance (integrals smaller than this value
c               will be ignored)
c
c       neri  - the number of ERI
c
c       labels(4,neri) - the labels associated with each integral
c                        labels(1:4,iq) = (i,j,k,l)
c
c       eri(neri) - the ERI themselves
c
c       dens(0:nfock*nbf*nbf-1) - the density matrices
c
c     OUTPUT
c
c       fock(0:nfock*nbf*nbf-1) - the Fock matrices
c
c     SOURCE
c
      subroutine fock_2e_rep_mod_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
c     Add scaled labelled integrals into fock matrix blocks ... 
c     symmetrization will be needed later.
c
c     MOD routines again use label(4,*) and indices are
c     offset from zero.
c     
c     The _rep_ routines assume that each process has the entire 
c     fock matrix and that we are not adding into distinct patches
c     of the matrix.  We also must add in the j/k scaling factors.
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer labels(4,neri)
      double precision eri(neri)
      double precision fock(nfock,0:nbf*nbf-1), dens(nfock,0:nbf*nbf-1)
      double precision jfac(nfock), kfac(nfock)
c     
      integer i, j, k, l, ind, v
      integer ij, lk, ik, li, lj, jk
      double precision g, gk, gj
c
      if (nfock .eq. 1) then
         call fock_2e_rep_mod_1_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
         return
      else if (nfock .eq. 2) then
         call fock_2e_rep_mod_2_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
         return
      else if (nfock .eq. 3) then
         call fock_2e_rep_mod_3_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
         return
      else if (nfock .eq. 4) then
         call fock_2e_rep_mod_4_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
         return
      endif
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(1,ind)
            j = labels(2,ind)
            k = labels(3,ind)
            l = labels(4,ind)
*     debug
*            if (i.lt.0 .or. i.ge.nbf) call errquit(' i bad', i)
*            if (j.lt.0 .or. j.ge.nbf) call errquit(' j bad', j)
*            if (l.lt.0 .or. l.ge.nbf) call errquit(' l bad', l)
*            if (k.lt.0 .or. k.ge.nbf) call errquit(' k bad', k)

            ij = i + im(j)      ! im NOT im1 since go from 0
            lj = l + im(j)
            lk = l + im(k)
            ik = i + im(k)
            jk = j + im(k)
            li = l + im(i)
c
            do v = 1, nfock
               gj = g*jfac(v)
               gk = g*kfac(v)
               fock(v,ij) = fock(v,ij) + gj*dens(v,lk)
               fock(v,lk) = fock(v,lk) + gj*dens(v,ij)
               fock(v,ik) = fock(v,ik) + gk*dens(v,lj)
               fock(v,li) = fock(v,li) + gk*dens(v,jk)
               fock(v,lj) = fock(v,lj) + gk*dens(v,ik)
               fock(v,jk) = fock(v,jk) + gk*dens(v,li)
            end do
         end if
      end do
c     
      end
      subroutine fock_2e_rep_mod_1_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer labels(4,neri)
      double precision eri(neri)
      double precision fock(0:*), dens(0:*)
      double precision jfac, kfac
c     
      integer i, j, k, l, ind
      integer ij, ik, jk, lk, li, lj
      double precision g, gk, gj, fij, fkl, fik, fil, fjl, fjk
c
c#ifdef SOLARIS
*     Overwrite logic seems slower on UltraSparc
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            gj = g*jfac
            gk = g*kfac
            i = labels(1,ind)
            j = labels(2,ind)
            k = labels(3,ind)
            l = labels(4,ind)
            ij = i + im(j)
            lk = l + im(k)
            ik = i + im(k)
            li = l + im(i)
            lj = l + im(j)
            jk = j + im(k)
            fock(ij) = fock(ij) + gj*dens(lk)
            fock(lk) = fock(lk) + gj*dens(ij)
            fock(ik) = fock(ik) + gk*dens(lj)
            fock(li) = fock(li) + gk*dens(jk)
            fock(lj) = fock(lj) + gk*dens(ik)
            fock(jk) = fock(jk) + gk*dens(li)
         end if
      end do
c#else
c      do ind = 1, neri
c         g = eri(ind)
c         if (abs(g) .gt. tol2e) then
c            gj = g*jfac
c            gk = g*kfac
c            i = labels(1,ind)
c            j = labels(2,ind)
c            k = labels(3,ind)
c            l = labels(4,ind)
cc
cc     Logic behind this choice is that indices vary mostly with
cc     i>=j and k>=l with kl varying fastest ... improved cache hits?
cc     If change this mapping must change overwrite logic below
cc
c            ij = im(i) + j      ! NOT im1 since go from 0
c            kl = im(k) + l
c            if (ij .eq. kl) gj = gj + gj
cc
cc     Using overwrite logic ... separates stores/loads, and enables
cc     partial pipelining of */+ pairs ... at least in principle
cc
c            fij = fock(ij) + gj*dens(kl)
c            fkl = fock(kl) + gj*dens(ij)
c            if (i .eq. j) gk = gk + gk
c            fock(ij) = fij
c            fock(kl) = fkl
c            if (k .eq. l) gk = gk + gk
c            ik = im(i) + k
c            il = im(i) + l
c            jl = im(j) + l
c            jk = im(j) + k
c            fik = fock(ik) + gk*dens(jl)
c            fil = fock(il) + gk*dens(jk)
c            fjk = fock(jk) + gk*dens(il)
c            fjl = fock(jl) + gk*dens(ik)
c            fock(ik) = fik
c            fock(il) = fil
c            fock(jl) = fjl
c            fock(jk) = fjk
c         end if
c      end do
c#endif
c     
      end
c$$$      subroutine fock_2e_rep_mod_1_label(nfock, nbf, jfac, kfac, tol2e,
c$$$     $     neri, labels, eri, dens, fock)
c$$$c     
c$$$c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c$$$c     
c$$$      implicit none
c$$$#include "errquit.fh"
c$$$#include "nwc_const.fh"
c$$$#include "cfockmul.fh"
c$$$c     
c$$$      integer nfock, nbf
c$$$      double precision tol2e
c$$$      integer neri
c$$$      integer labels(4,neri)
c$$$      double precision eri(neri)
c$$$      double precision fock(0:*), dens(0:*)
c$$$      double precision jfac, kfac
c$$$c     
c$$$      integer i, j, k, l, ind
c$$$      integer ij, ik, jk, kl, il, jl
c$$$      double precision g, gk, gj, fij, fkl, fik, fil, fjl, fjk
c$$$c
c$$$      do ind = 1, neri
c$$$         g = eri(ind)
c$$$         if (abs(g) .gt. tol2e) then
c$$$            gj = g*jfac
c$$$            gk = g*kfac
c$$$            i = labels(1,ind)
c$$$            j = labels(2,ind)
c$$$            k = labels(3,ind)
c$$$            l = labels(4,ind)
c$$$*     debug
c$$$*            if (i.lt.0 .or. i.ge.nbf) call errquit(' i bad', i)
c$$$*            if (j.lt.0 .or. j.ge.nbf) call errquit(' j bad', j)
c$$$*            if (l.lt.0 .or. l.ge.nbf) call errquit(' l bad', l)
c$$$*            if (k.lt.0 .or. k.ge.nbf) call errquit(' k bad', k)
c$$$c
c$$$c     Logic behind this choice is that indices vary mostly with
c$$$c     i>=j and k>=l with kl varying fastest ... improved cache hits?
c$$$c     If change this mapping must change overwrite logic below
c$$$c
c$$$            ij = im(i) + j      ! NOT im1 since go from 0
c$$$            kl = im(k) + l
c$$$            if (ij .eq. kl) gj = gj + gj
c$$$c
c$$$c     Using overwrite logic ... separates stores/loads, and enables
c$$$c     partial pipelining of */+ pairs ... at least in principle
c$$$c
c$$$            fij = fock(ij) + gj*dens(kl)
c$$$            fkl = fock(kl) + gj*dens(ij)
c$$$            if (i .eq. j) gk = gk + gk
c$$$            fock(ij) = fij
c$$$            fock(kl) = fkl
c$$$c
c$$$            if (k .eq. l) gk = gk + gk
c$$$c
c$$$            ik = im(i) + k
c$$$            il = im(i) + l
c$$$            jl = im(j) + l
c$$$            jk = im(j) + k
c$$$
c$$$            fik = fock(ik) + gk*dens(jl)
c$$$            fil = fock(il) + gk*dens(jk)
c$$$            fjk = fock(jk) + gk*dens(il)
c$$$            fjl = fock(jl) + gk*dens(ik)
c$$$            fock(ik) = fik
c$$$            fock(il) = fil
c$$$            fock(jl) = fjl
c$$$            fock(jk) = fjk
c$$$c
c$$$c     Code without overwrite logic
c$$$c
c$$$c$$$            fock(ij) = fock(ij) + gj*dens(kl)
c$$$c$$$            fock(kl) = fock(kl) + gj*dens(ij)
c$$$c$$$            fock(ik) = fock(ik) + gk*dens(jl)
c$$$c$$$            fock(il) = fock(il) + gk*dens(jk)
c$$$c$$$            fock(jl) = fock(jl) + gk*dens(ik)
c$$$c$$$            fock(jk) = fock(jk) + gk*dens(il)
c$$$         end if
c$$$      end do
c$$$c     
c$$$      end
      subroutine fock_2e_rep_mod_2_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer labels(4,neri)
      double precision eri(neri)
      double precision fock(2,0:*), dens(2,0:*)
      double precision jfac(*), kfac(*)
c     
      integer i, j, k, l, ind
      integer ij, ik, jk, lk, li, lj
      double precision g, gk1, gj1, gj2, gk2
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(1,ind)
            j = labels(2,ind)
            k = labels(3,ind)
            l = labels(4,ind)
c
            ij = i + im(j)      ! NOT im1 since go from 0
            ik = i + im(k)
            li = l + im(i)
            lj = l + im(j)
            jk = j + im(k)
            lk = l + im(k)
c
            gj1 = g*jfac(1)
            gk1 = g*kfac(1)
            fock(1,ij) = fock(1,ij) + gj1*dens(1,lk)
            fock(1,lk) = fock(1,lk) + gj1*dens(1,ij)
            fock(1,ik) = fock(1,ik) + gk1*dens(1,lj)
            fock(1,li) = fock(1,li) + gk1*dens(1,jk)
            fock(1,lj) = fock(1,lj) + gk1*dens(1,ik)
            fock(1,jk) = fock(1,jk) + gk1*dens(1,li)
c
            gj2 = g*jfac(2)
            gk2 = g*kfac(2)
            fock(2,ij) = fock(2,ij) + gj2*dens(2,lk)
            fock(2,lk) = fock(2,lk) + gj2*dens(2,ij)
            fock(2,ik) = fock(2,ik) + gk2*dens(2,lj)
            fock(2,li) = fock(2,li) + gk2*dens(2,jk)
            fock(2,lj) = fock(2,lj) + gk2*dens(2,ik)
            fock(2,jk) = fock(2,jk) + gk2*dens(2,li)
         end if
      end do
c     
      end
      subroutine fock_2e_rep_mod_3_label(nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer labels(4,neri)
      double precision eri(neri)
      double precision fock(3,0:*), dens(3,0:*)
      double precision jfac(*), kfac(*)
c     
      integer i, j, k, l, ind
      integer ij, ik, jk, lk, li, lj
      double precision g, gk1, gj1, gj2, gk2, gj3, gk3
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(1,ind)
            j = labels(2,ind)
            k = labels(3,ind)
            l = labels(4,ind)
c
            ij = i + im(j)     ! NOT im1 since go from 0
            lk = l + im(k)
            ik = i + im(k)
            jk = j + im(k)
            li = l + im(i)
            lj = l + im(j)
c
            gj1 = g*jfac(1)
            gk1 = g*kfac(1)
            fock(1,ij) = fock(1,ij) + gj1*dens(1,lk)
            fock(1,lk) = fock(1,lk) + gj1*dens(1,ij)
            fock(1,ik) = fock(1,ik) + gk1*dens(1,lj)
            fock(1,li) = fock(1,li) + gk1*dens(1,jk)
            fock(1,lj) = fock(1,lj) + gk1*dens(1,ik)
            fock(1,jk) = fock(1,jk) + gk1*dens(1,li)
c
            gj2 = g*jfac(2)
            gk2 = g*kfac(2)
            fock(2,ij) = fock(2,ij) + gj2*dens(2,lk)
            fock(2,lk) = fock(2,lk) + gj2*dens(2,ij)
            fock(2,ik) = fock(2,ik) + gk2*dens(2,lj)
            fock(2,li) = fock(2,li) + gk2*dens(2,jk)
            fock(2,lj) = fock(2,lj) + gk2*dens(2,ik)
            fock(2,jk) = fock(2,jk) + gk2*dens(2,li)
c
            gj3 = g*jfac(3)
            gk3 = g*kfac(3)
            fock(3,ij) = fock(3,ij) + gj3*dens(3,lk)
            fock(3,lk) = fock(3,lk) + gj3*dens(3,ij)
            fock(3,ik) = fock(3,ik) + gk3*dens(3,lj)
            fock(3,li) = fock(3,li) + gk3*dens(3,jk)
            fock(3,lj) = fock(3,lj) + gk3*dens(3,ik)
            fock(3,jk) = fock(3,jk) + gk3*dens(3,li)
         end if
      end do
c     
      end
      subroutine fock_2e_rep_mod_4_label
     $     (nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer labels(4,neri)
      double precision eri(neri)
      double precision fock(0:*), dens(0:*)
      double precision jfac(nfock), kfac(nfock)
c     
      integer i, j, k, l, ind
      integer ij, ik, jk, lk, li, lj, kj
      double precision g, gj, gk, gk1, gj1, gj2, gk2, gj3, gk3, gj4, gk4
c     
c
c     At some point (up to r18591) there was a replacement logic
c     based code here. This approach optimized for pipelining
c     instructions. However, to manage the needed scaling of the
c     integrals the code calculated Im(F) instead of -Im(F)
c     which caused conflicts with the other Fock builders,
c     in particular the distributed data ones.
c
      if (
     $     jfac(1).eq.1.0d0 .and. jfac(2).eq.0.0d0 .and. 
     $     jfac(3).eq.1.0d0 .and. jfac(4).eq.0.0d0 .and. 
     $     kfac(1).eq.0.0d0 .and. kfac(2).eq.0.5d0 .and. 
     $     kfac(3).eq.0.0d0 .and. kfac(4).eq.0.5d0 ) then ! UHF special
         do ind = 1, neri
            g = eri(ind)
            if (abs(g) .gt. tol2e) then
               i = labels(1,ind)
               j = labels(2,ind)
               k = labels(3,ind)
               l = labels(4,ind)
c     
               ij = (i + im(j))*4
               lk = (l + im(k))*4
c     
               gj = g
c     
               fock(  ij) = fock(  ij) + gj*dens(  lk)
               fock(2+ij) = fock(2+ij) + gj*dens(2+lk)
               fock(  lk) = fock(  lk) + gj*dens(  ij)
               fock(2+lk) = fock(2+lk) + gj*dens(2+ij)
c     
               gk = g * 0.5d0
c
               ik = (i + im(k))*4 + 1
               lj = (l + im(j))*4 + 1
c
               jk = (j + im(k))*4 + 1
               li = (l + im(i))*4 + 1
c     
               fock(  ik) = fock(  ik) + gk*dens(  lj)
               fock(2+ik) = fock(2+ik) + gk*dens(2+lj)
               fock(  li) = fock(  li) + gk*dens(  jk)
               fock(2+li) = fock(2+li) + gk*dens(2+jk)
               fock(  lj) = fock(  lj) + gk*dens(  ik)
               fock(2+lj) = fock(2+lj) + gk*dens(2+ik)
               fock(  jk) = fock(  jk) + gk*dens(  li)
               fock(2+jk) = fock(2+jk) + gk*dens(2+li)
c     
            end if
         end do

      else

         do ind = 1, neri
            g = eri(ind)
            if (abs(g) .gt. tol2e) then
               i = labels(1,ind)
               j = labels(2,ind)
               k = labels(3,ind)
               l = labels(4,ind)
c     
               ij = (i + im(j))*4 
               lk = (l + im(k))*4
c
               ik = (i + im(k))*4
               jk = (j + im(k))*4
               li = (l + im(i))*4
               lj = (l + im(j))*4
c     
               gj = g
               gj1 = gj*jfac(1)
               gj2 = gj*jfac(2)
               gj3 = gj*jfac(3)
               gj4 = gj*jfac(4)
c     
               fock(  ij) = fock(  ij) + gj1*dens(  lk)
               fock(1+ij) = fock(1+ij) + gj2*dens(1+lk)
               fock(2+ij) = fock(2+ij) + gj3*dens(2+lk)
               fock(3+ij) = fock(3+ij) + gj4*dens(3+lk)
               fock(  lk) = fock(  lk) + gj1*dens(  ij)
               fock(1+lk) = fock(1+lk) + gj2*dens(1+ij)
               fock(2+lk) = fock(2+lk) + gj3*dens(2+ij)
               fock(3+lk) = fock(3+lk) + gj4*dens(3+ij)
c     
               gk = g
               gk1 = gk*kfac(1)
               gk2 = gk*kfac(2)
               gk3 = gk*kfac(3)
               gk4 = gk*kfac(4)
c     
               fock(  ik) = fock(  ik) + gk1*dens(  lj)
               fock(1+ik) = fock(1+ik) + gk2*dens(1+lj)
               fock(2+ik) = fock(2+ik) + gk3*dens(2+lj)
               fock(3+ik) = fock(3+ik) + gk4*dens(3+lj)
               fock(  li) = fock(  li) + gk1*dens(  jk)
               fock(1+li) = fock(1+li) + gk2*dens(1+jk)
               fock(2+li) = fock(2+li) + gk3*dens(2+jk)
               fock(3+li) = fock(3+li) + gk4*dens(3+jk)
               fock(  lj) = fock(  lj) + gk1*dens(  ik)
               fock(1+lj) = fock(1+lj) + gk2*dens(1+ik)
               fock(2+lj) = fock(2+lj) + gk3*dens(2+ik)
               fock(3+lj) = fock(3+lj) + gk4*dens(3+ik)
               fock(  jk) = fock(  jk) + gk1*dens(  li)
               fock(1+jk) = fock(1+jk) + gk2*dens(1+li)
               fock(2+jk) = fock(2+jk) + gk3*dens(2+li)
               fock(3+jk) = fock(3+jk) + gk4*dens(3+li)
c     
            end if
         end do
      endif
c     
      end
c
c******
c
      subroutine fock_2e_rep_mod_4_label_new_ok
     $     (nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer labels(4,neri)
      double precision eri(neri)
      double precision fock(4,0:*), dens(4,0:*)
      double precision jfac(*), kfac(*)
c     
      integer i, j, k, l, ind
      integer ij, ik, jk, kl, il, jl
      double precision g, g2, gk1, gj1, gj2, gk2, gj3, gk3, gj4, gk4
      double precision 
     $     fock1ij, fock1kl, fock2ij, fock2kl, fock3ij, fock3kl, 
     $     fock4ij, fock4kl, fock1ik, fock1il, fock1jl, fock1jk,
     $     fock2ik, fock2il, fock2jl, fock2jk, fock3ik, fock3il,
     $     fock3jl, fock3jk, fock4ik, fock4il, fock4jl, fock4jk
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(1,ind)
            j = labels(2,ind)
            k = labels(3,ind)
            l = labels(4,ind)
c
c
            ij = im(i) + j      ! NOT im1 since go from 0
            kl = im(k) + l
c
            if (ij .eq. kl) then
               g2 = g + g
               gj1 = g2*jfac(1)
               gj2 = g2*jfac(2)
               gj3 = g2*jfac(3)
               gj4 = g2*jfac(4)
            else
               gj1 = g*jfac(1)
               gj2 = g*jfac(2)
               gj3 = g*jfac(3)
               gj4 = g*jfac(4)
            endif
c
            fock1ij = fock(1,ij) + gj1*dens(1,kl)
            fock2ij = fock(2,ij) + gj2*dens(2,kl)
            fock3ij = fock(3,ij) + gj3*dens(3,kl)
            fock4ij = fock(4,ij) + gj4*dens(4,kl)
            fock1kl = fock(1,kl) + gj1*dens(1,ij)
            fock2kl = fock(2,kl) + gj2*dens(2,ij)
            fock3kl = fock(3,kl) + gj3*dens(3,ij)
            fock4kl = fock(4,kl) + gj4*dens(4,ij)
c
            fock(1,ij) = fock1ij
            fock(2,ij) = fock2ij
            fock(3,ij) = fock3ij
            fock(4,ij) = fock4ij
            fock(1,kl) = fock1kl
            fock(2,kl) = fock2kl
            fock(3,kl) = fock3kl
            fock(4,kl) = fock4kl
c
c     Working non-overwrite code for exchange
c
c$$$            ik = im(i) + k
c$$$            il = im(i) + l
c$$$            jl = im(j) + l
c$$$            jk = im(j) + k
c$$$c
c$$$            gk1 = g*kfac(1)
c$$$            fock(1,ik) = fock(1,ik) + gk1*dens(1,jl)
c$$$            fock(1,il) = fock(1,il) + gk1*dens(1,jk)
c$$$            fock(1,jl) = fock(1,jl) + gk1*dens(1,ik)
c$$$            fock(1,jk) = fock(1,jk) + gk1*dens(1,il)
c$$$c
c$$$            gk2 = g*kfac(2)
c$$$            fock(2,ik) = fock(2,ik) + gk2*dens(2,jl)
c$$$            fock(2,il) = fock(2,il) + gk2*dens(2,jk)
c$$$            fock(2,jl) = fock(2,jl) + gk2*dens(2,ik)
c$$$            fock(2,jk) = fock(2,jk) + gk2*dens(2,il)
c$$$c
c$$$            gk3 = g*kfac(3)
c$$$            fock(3,ik) = fock(3,ik) + gk3*dens(3,jl)
c$$$            fock(3,il) = fock(3,il) + gk3*dens(3,jk)
c$$$            fock(3,jl) = fock(3,jl) + gk3*dens(3,ik)
c$$$            fock(3,jk) = fock(3,jk) + gk3*dens(3,il)
c$$$c
c$$$            gk4 = g*kfac(4)
c$$$            fock(4,ik) = fock(4,ik) + gk4*dens(4,jl)
c$$$            fock(4,il) = fock(4,il) + gk4*dens(4,jk)
c$$$            fock(4,jl) = fock(4,jl) + gk4*dens(4,ik)
c$$$            fock(4,jk) = fock(4,jk) + gk4*dens(4,il)
c
c
c
            if (i .eq. j) g = g + g
            if (k .eq. l) then
               g2 = g + g
               gk1 = g2*kfac(1)
               gk2 = g2*kfac(2)
               gk3 = g2*kfac(3)
               gk4 = g2*kfac(4)
            else
               gk1 = g*kfac(1)
               gk2 = g*kfac(2)
               gk3 = g*kfac(3)
               gk4 = g*kfac(4)
            endif
c
            ik = im(i) + k
            il = im(i) + l
            jl = im(j) + l
            jk = im(j) + k
c
            fock1ik = fock(1,ik) + gk1*dens(1,jl)
            fock2ik = fock(2,ik) + gk2*dens(2,jl)
            fock3ik = fock(3,ik) + gk3*dens(3,jl)
            fock4ik = fock(4,ik) + gk4*dens(4,jl)
            fock1il = fock(1,il) + gk1*dens(1,jk)
            fock2il = fock(2,il) + gk2*dens(2,jk)
            fock3il = fock(3,il) + gk3*dens(3,jk)
            fock4il = fock(4,il) + gk4*dens(4,jk)
            fock1jl = fock(1,jl) + gk1*dens(1,ik)
            fock2jl = fock(2,jl) + gk2*dens(2,ik)
            fock3jl = fock(3,jl) + gk3*dens(3,ik)
            fock4jl = fock(4,jl) + gk4*dens(4,ik)
            fock1jk = fock(1,jk) + gk1*dens(1,il)
            fock2jk = fock(2,jk) + gk2*dens(2,il)
            fock3jk = fock(3,jk) + gk3*dens(3,il)
            fock4jk = fock(4,jk) + gk4*dens(4,il)
c
            fock(1,ik) = fock1ik
            fock(2,ik) = fock2ik
            fock(3,ik) = fock3ik
            fock(4,ik) = fock4ik
            fock(1,il) = fock1il
            fock(2,il) = fock2il
            fock(3,il) = fock3il
            fock(4,il) = fock4il
            fock(1,jl) = fock1jl
            fock(2,jl) = fock2jl
            fock(3,jl) = fock3jl
            fock(4,jl) = fock4jl
            fock(1,jk) = fock1jk
            fock(2,jk) = fock2jk
            fock(3,jk) = fock3jk
            fock(4,jk) = fock4jk
c
         end if
      end do
c     
      end
      subroutine fock_2e_rep_mod_4_label_old
     $     (nfock, nbf, jfac, kfac, tol2e,
     $     neri, labels, eri, dens, fock)
c     
c     $Id: fock_2e_lab.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "nwc_const.fh"
#include "cfockmul.fh"
c     
      integer nfock, nbf
      double precision tol2e
      integer neri
      integer labels(4,neri)
      double precision eri(neri)
      double precision fock(4,0:*), dens(4,0:*)
      double precision jfac(*), kfac(*)
c     
      integer i, j, k, l, ind
      integer ij, ik, jk, kl, il, jl
      double precision g, gk1, gj1, gj2, gk2, gj3, gk3, gj4, gk4
c
      do ind = 1, neri
         g = eri(ind)
         if (abs(g) .gt. tol2e) then
            i = labels(1,ind)
            j = labels(2,ind)
            k = labels(3,ind)
            l = labels(4,ind)
c
            ij = im(i) + j      ! NOT im1 since go from 0
            ik = im(i) + k
            il = im(i) + l
            jl = im(j) + l
            jk = im(j) + k
            kl = im(k) + l
c
            gj1 = g*jfac(1)
            gk1 = g*kfac(1)
            fock(1,ij) = fock(1,ij) + gj1*dens(1,kl)
            fock(1,kl) = fock(1,kl) + gj1*dens(1,ij)
            fock(1,ik) = fock(1,ik) + gk1*dens(1,jl)
            fock(1,il) = fock(1,il) + gk1*dens(1,jk)
            fock(1,jl) = fock(1,jl) + gk1*dens(1,ik)
            fock(1,jk) = fock(1,jk) + gk1*dens(1,il)
c
            gj2 = g*jfac(2)
            gk2 = g*kfac(2)
            fock(2,ij) = fock(2,ij) + gj2*dens(2,kl)
            fock(2,kl) = fock(2,kl) + gj2*dens(2,ij)
            fock(2,ik) = fock(2,ik) + gk2*dens(2,jl)
            fock(2,il) = fock(2,il) + gk2*dens(2,jk)
            fock(2,jl) = fock(2,jl) + gk2*dens(2,ik)
            fock(2,jk) = fock(2,jk) + gk2*dens(2,il)
c
            gj3 = g*jfac(3)
            gk3 = g*kfac(3)
            fock(3,ij) = fock(3,ij) + gj3*dens(3,kl)
            fock(3,kl) = fock(3,kl) + gj3*dens(3,ij)
            fock(3,ik) = fock(3,ik) + gk3*dens(3,jl)
            fock(3,il) = fock(3,il) + gk3*dens(3,jk)
            fock(3,jl) = fock(3,jl) + gk3*dens(3,ik)
            fock(3,jk) = fock(3,jk) + gk3*dens(3,il)
c
            gj4 = g*jfac(4)
            gk4 = g*kfac(4)
            fock(4,ij) = fock(4,ij) + gj4*dens(4,kl)
            fock(4,kl) = fock(4,kl) + gj4*dens(4,ij)
            fock(4,ik) = fock(4,ik) + gk4*dens(4,jl)
            fock(4,il) = fock(4,il) + gk4*dens(4,jk)
            fock(4,jl) = fock(4,jl) + gk4*dens(4,ik)
            fock(4,jk) = fock(4,jk) + gk4*dens(4,il)
         end if
      end do
c     
      end

*
* $Id: task_paw.F 22842 2012-09-12 07:37:03Z d3y133 $
*
C> \ingroup task
C> @{
      logical function task_paw(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
      integer rtdb
      logical value,dummy
      integer MASTER
      parameter (MASTER=0)
c
      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 4)
      character*30 dirs(num_dirs)
      character*255 test
      data dirs / 
     >            'steepest_descent',
     >            'Car-Parrinello',
     >            'noit_energy',
     >            'stress' /

c     *** define external functions ****
      logical  paw_sd,paw_cpmd,paw_noit_energy,paw_stress
      external paw_sd,paw_cpmd,paw_noit_energy,paw_stress
c
c
      value = .false.
      task_paw = .false. 
 10   value = rtdb_cget(rtdb,'task:operation',1,test)

      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit('task paw: unknown directive', 0, INPUT_ERR)
c
c
c
      goto ( 100,  200, 300, 400) ind
      call errquit('task paw: unimplemented directive', ind, INPUT_ERR)


c
c  steepest_descent
c
 100  if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PAW Parallel Module - steepest_descent <<<<"
      end if

      value = .true.
      value = rtdb_parallel(.true.)
      value = paw_sd(rtdb)
      call ga_sync()
      goto 9999

c
c  Car-Parrinello
c
 200  if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PAW Parallel Module - Car-Parrinello <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = paw_cpmd(rtdb)
      call ga_sync()
      goto 9999

c
c  noit_energy
c
 300  if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PAW Parallel Module - noit_energy <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = paw_noit_energy(rtdb)
      call ga_sync()
      goto 9999

c
c  stress
c
 400  if (ga_nodeid().eq.MASTER) then
        write(*,*)  ">>>> PAW Parallel Module - stress <<<<"
      end if
      value = .true.
      value = rtdb_parallel(.true.)
      value = paw_stress(rtdb)
      call ga_sync()
      goto 9999




 9999 continue
      dummy = rtdb_parallel(.true.)
      task_paw = value
      

      return
      end
C> @}

      subroutine dia_getref
c
c $Id: dia_getref.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     read the reference coordinates
c     ------------------------------
c
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      filref=card(8:80)
c
c     get the size from the reference file
c
      call dia_sizref(nsai,msai,nwmi,mwmi,nwai,mwai)
c
c     allocate memory and initialize
c
      call dia_alloc(.true.)
c
c     read the reference coordinates
c
      call dia_rdref(dbl_mb(i_xref))
c
      call dia_all(int_mb(i_ssel),1,dbl_mb(i_swt),nsel)
      lsel=.false.
      call dia_all(int_mb(i_isel),1,dbl_mb(i_wt),nsel)
      call dia_wall(int_mb(i_wsel),1,int_mb(i_ndxw))
c
      if(me.eq.0) then
      write(*,'(a,a)') ' Reference coordinates read from ',
     + filref(1:index(filref,' ')-1)
      write(*,'(/,a,i5,/)') ' Number of atoms is ',nsai
      endif
      if(.not.ma_verify_allocator_stuff()) print*,'Oopsi 2'
c
      return
      end

      SUBROUTINE cisdt_2pdm_pphh_mo(d_i0,d_t2,d_t3,d_y0,d_y1,k_i0_offset
     &,k_t2_offset,k_t3_offset,k_y0_offset,k_y1_offset)
C     $Id: cisdt_2pdm_pphh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_yt + = 1 * t ( p3 p4 h1 h2 )_t * y ( )_y
C     i0 ( p3 p4 h1 h2 )_yt + = 1 * Sum ( h6 p5 ) * t ( p3 p4 p5 h1 h2 h6 )_t * y ( h6 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_y0
      INTEGER k_y0_offset
      INTEGER d_t3
      INTEGER k_t3_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      CALL cisdt_2pdm_pphh_mo_1(d_t2,k_t2_offset,d_y0,k_y0_offset,d_i0,k
     &_i0_offset)
      CALL cisdt_2pdm_pphh_mo_2(d_t3,k_t3_offset,d_y1,k_y1_offset,d_i0,k
     &_i0_offset)
      RETURN
      END
      SUBROUTINE cisdt_2pdm_pphh_mo_1(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: cisdt_2pdm_pphh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_yt + = 1 * t ( p3 p4 h1 h2 )_t * y ( )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdt_2pdm_pphh_mo_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h2b,p3b_1,p4b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdt_2pdm_pphh_mo_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdt_2pdm_pphh_mo_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_1',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdt_2pdm_pphh_mo_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdt_2pdm_pphh_mo_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_b),dbl_mb(k_b_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_1',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_
     &1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_
     &1',8,MA_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdt_2pdm_pphh_mo_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_1',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_
     &1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdt_2pdm_pphh_mo_2(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: cisdt_2pdm_pphh_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_yt + = 1 * Sum ( h6 p5 ) * t ( p3 p4 p5 h1 h2 h6 )_t * y ( h6 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h6b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h6b_1
      INTEGER h6b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdt_2pdm_pphh_mo_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h6b = 1,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h6b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+p5b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h6b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p3b,p4b,p5b,h1b,h2b,h6b,p3b_1,p4b_1,p5b_1,h1
     &b_1,h2b_1,h6b_1)
      CALL TCE_RESTRICTED_2(h6b,p5b,h6b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdt_2pdm_pphh_mo_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdt_2pdm_pphh_mo_2',2,MA_ERR)
      IF ((p5b .lt. p3b) .and. (h6b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h6b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,3,2,4,1,1.0d0)
      END IF
      IF ((p5b .lt. p3b) .and. (h1b .le. h6b) .and. (h6b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h2b-1),6,4,3,2,5,1,-1.0d0)
      END IF
      IF ((p5b .lt. p3b) .and. (h2b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h6b-1),5,4,3,2,6,1,1.0d0)
      END IF
      IF ((p3b .le. p5b) .and. (p5b .lt. p4b) .and. (h6b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h6b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,3,1,4,2,-1.0d0)
      END IF
      IF ((p3b .le. p5b) .and. (p5b .lt. p4b) .and. (h1b .le. h6b) .and.
     & (h6b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h2b-1),6,4,3,1,5,2,1.0d0)
      END IF
      IF ((p3b .le. p5b) .and. (p5b .lt. p4b) .and. (h2b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h6b-1),5,4,3,1,6,2,-1.0d0)
      END IF
      IF ((p4b .le. p5b) .and. (h6b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h6b_1 - 1 + noab * (p5b_1 - noa
     &b - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,2,1,4,3,1.0d0)
      END IF
      IF ((p4b .le. p5b) .and. (h1b .le. h6b) .and. (h6b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noa
     &b - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h2b-1),6,4,2,1,5,3,-1.0d0)
      END IF
      IF ((p4b .le. p5b) .and. (h2b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noa
     &b - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h6b-1),5,4,2,1,6,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_2',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdt_2pdm_pphh_mo_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdt_2pdm_pphh_mo_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h6b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p5b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_2',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_
     &2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_
     &2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdt_2pdm_pphh_mo_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_2',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdt_2pdm_pphh_mo_
     &2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE shll_qnch(ntshel)

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'p_const.inc'
      include 'cm_atom.inc'
      include 'cm_temp.inc'
      include 'cm_shel.inc'

      integer i,iatm1,iatm2,iatma,iatmb
      integer ntshel

      real*8 cske,rmu,vij,xscale
      real*8 tmx,tmy,tmz

      dimension vij(mxshel2,3)

      cske=boltzmann*temp*1.d-4

      do i=1,ntshel

       iatm1=shllist(i,1)
       iatm2=shllist(i,2)
       iatma=atmtype(iatm1)
       iatmb=atmtype(iatm2)
       rmu=(typmass(iatma)*typmass(iatmb))/
     $     (typmass(iatma)+typmass(iatmb))

       vij(i,1)=vvv(iatm2,1)-vvv(iatm1,1)
       vij(i,2)=vvv(iatm2,2)-vvv(iatm1,2)
       vij(i,3)=vvv(iatm2,3)-vvv(iatm1,3)

       xscale=sqrt(cske/(rmu*(vij(i,1)**2+vij(i,2)**2+vij(i,3)**2)))

       tmx=typmass(iatma)*vvv(iatm1,1)+typmass(iatmb)*vvv(iatm2,1)
       tmy=typmass(iatma)*vvv(iatm1,2)+typmass(iatmb)*vvv(iatm2,2)
       tmz=typmass(iatma)*vvv(iatm1,3)+typmass(iatmb)*vvv(iatm2,3)

       vvv(iatm1,1)=tmx/(typmass(iatma)+typmass(iatmb))
     $             -xscale*rmu*vij(i,1)/typmass(iatma)
       vvv(iatm2,1)=tmx/(typmass(iatma)+typmass(iatmb))
     $             +xscale*rmu*vij(i,1)/typmass(iatmb)
       vvv(iatm1,2)=tmy/(typmass(iatma)+typmass(iatmb))
     $             -xscale*rmu*vij(i,2)/typmass(iatma)
       vvv(iatm2,2)=tmy/(typmass(iatma)+typmass(iatmb))
     $             +xscale*rmu*vij(i,2)/typmass(iatmb)
       vvv(iatm1,3)=tmz/(typmass(iatma)+typmass(iatmb))
     $             -xscale*rmu*vij(i,3)/typmass(iatma)
       vvv(iatm2,3)=tmz/(typmass(iatma)+typmass(iatmb))
     $             +xscale*rmu*vij(i,3)/typmass(iatmb)

      enddo
 
      return

      END
c $Id: shll_qnch.f 22502 2012-05-20 06:11:57Z d3y133 $

      logical function argos_prep_wrtrst(lfnout,lfnrst,filrst,title,
     + npbtyp,nbxtyp,box,
     + iwmr,xw,vw,mwm,mwa,nwm,nwa,iwmrc,xwc,vwc,mwmc,nwmc,
     + isar,isgm,xs,vs,msa,nsa,msm,nsm,irrep,nxrep,nyrep,nzrep,
     + mseq,nseq,lseq,ips,istat,lfnmod,filmod,itopol)
c
c $Id: argos_prep_wrtrst.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
      logical argos_prep_ssize,argos_prep_rstmod
      external argos_prep_ssize,argos_prep_rstmod
c
      integer lfnout,lfnrst
      integer mwm,mwa,nwm,nwa,msa,nsa,msm,nsm,mwmc,nwmc,mseq,nseq
      integer npbtyp,nbxtyp,irrep,nxrep,nyrep,nzrep
      character*255 filrst,filmod
      character*80 title(2,3)
      real*8 xw(3,mwa,mwm),xs(3,msa),vw(3,mwa,mwm),vs(3,msa),box(3)
      real*8 xwc(3,mwa,mwmc),vwc(3,mwa,mwmc)
      integer iwmrc(mwmc),iwmr(mwm),isar(msa),isgm(msa),lseq(mseq)
      integer ips(msa),istat(msa),lfnmod,itopol
c
      integer i,j,k,length,ixrep,iyrep,izrep,nrep,idhop
      real*8 orep(3),rsgm
      character*10 rstdat,rsttim
c
c     process modifications
c
      if(.not.argos_prep_rstmod(lseq,mseq,nseq,lfnmod,filmod,lfnout))
     + call md_abort('argos_prep_rstmod failed',9999)
c
      if(itopol.eq.3) then
      do 111 i=1,nsa
      idhop=2**(lseq(isgm(i))-1)
      if(iand(istat(i),idhop).eq.0) ips(i)=-ips(i)
c      write(*,'(a,5i5)') 'wrtrst ',i,isgm(i),lseq(isgm(i)),istat(i),
c     + ips(i)
  111 continue
      else
      do 112 i=1,nsa
      ips(i)=0
  112 continue
      endif
c
      if(.not.argos_prep_ssize(isgm,xs,msa,nsa,rsgm))
     + call md_abort('argos_prep_ssize failed',9999)
c
c     open the restart file
c     ---------------------
c
      length=index(filrst,' ')-1
      open(unit=lfnrst,file=filrst(1:length),form='formatted',
     + status='unknown',err=9999)
c
      call swatch(rstdat,rsttim)
c
      if(npbtyp.eq.0) then
      if(box(1).lt.1.0e-6) box(1)=max(box(1),box(2),box(3))
      if(box(2).lt.1.0e-6) box(2)=max(box(1),box(2),box(3))
      if(box(3).lt.1.0e-6) box(3)=max(box(1),box(2),box(3))
      endif
c
      if(irrep.eq.0) then
      orep(1)=0.0d0
      orep(2)=0.0d0
      orep(3)=0.0d0
      nxrep=1
      nyrep=1
      nzrep=1
      nrep=1
      else
      nrep=nxrep*nyrep*nzrep
      endif
c
      write(lfnrst,1001) (title(2,i),i=1,3),4.6,rstdat,rsttim,0,.false.
 1001 format(a,/,a,/,a,/,f12.6,2a10,i5,4x,l1)
      write(lfnrst,1002) npbtyp,nbxtyp,rsgm,
     + dble(nxrep)*box(1),0.0d0,0.0d0,
     + 0.0d0,dble(nyrep)*box(2),0.0d0,
     + 0.0d0,0.0d0,dble(nzrep)*box(3)
 1002 format(2i5,f12.6,/,(3f12.6))
      write(lfnrst,1003) 0.0d0
 1003 format(e12.5)
      write(lfnrst,1004) 0.0d0,0.0d0,0.0d0
 1004 format(3f12.6)
c
c     dimensions on the restart file
c
c     1 i10 nwm   number of solvent molecules
c     2 i10 nwa   number of atoms per solvent molecule
c     3 i10 nsm   number of solute molecules
c     4 i10 nsa   number of solute atoms
c     5 i10 nwmc  number of crystal solvent molecules
c     6 i10 nsf   number of solute fractions
c     7 i10 nss   number of solute segments
c     8 i5  nprev number of processors used in previous job
c     9 i5  noe   number of noe constraints
c
c
      write(lfnrst,1005) nrep*(nwmc+nwm),nwa,
     + nrep*nsm,nrep*nsa,nrep*nwmc,0,nrep*nseq,0,0
 1005 format(7i10,2i5)
c
c     check wich version
c
      if(nwm+nwmc.gt.0) then
      if(nwmc.gt.0) then
      do 101 izrep=1,nzrep
      do 102 iyrep=1,nyrep
      do 103 ixrep=1,nxrep
      if(irrep.gt.0) then
      orep(1)=0.5d0*dble(2*ixrep-nxrep-1)*box(1)
      orep(2)=0.5d0*dble(2*iyrep-nyrep-1)*box(2)
      orep(3)=0.5d0*dble(2*izrep-nzrep-1)*box(3)
      endif
      do 1 i=1,nwmc
      write(lfnrst,1006) ((xwc(k,j,i)+orep(k),k=1,3),
     + (vwc(k,j,i),k=1,3),j=1,nwa)
 1006 format(2x,6f13.8)
      write(lfnrst,1007) iwmrc(i),(0.0d0,k=1,3)
 1007 format(i1,1x,3f13.8)
    1 continue
  103 continue
  102 continue
  101 continue
      endif
      do 201 izrep=1,nzrep
      do 202 iyrep=1,nyrep
      do 203 ixrep=1,nxrep
      if(irrep.gt.0) then
      orep(1)=0.5d0*dble(2*ixrep-nxrep-1)*box(1)
      orep(2)=0.5d0*dble(2*iyrep-nyrep-1)*box(2)
      orep(3)=0.5d0*dble(2*izrep-nzrep-1)*box(3)
      endif
      do 2 i=1,nwm
      write(lfnrst,1006) ((xw(k,j,i)+orep(k),k=1,3),
     + (vw(k,j,i),k=1,3),j=1,nwa)
      write(lfnrst,1007) iwmr(i),(0.0d0,k=1,3)
    2 continue
  203 continue
  202 continue
  201 continue
      endif
      if(nsa.gt.0) then
      do 301 izrep=1,nzrep
      do 302 iyrep=1,nyrep
      do 303 ixrep=1,nxrep
      if(irrep.gt.0) then
      orep(1)=0.5d0*dble(2*ixrep-nxrep-1)*box(1)
      orep(2)=0.5d0*dble(2*iyrep-nyrep-1)*box(2)
      orep(3)=0.5d0*dble(2*izrep-nzrep-1)*box(3)
      endif
      write(lfnrst,1008)
     + (isar(i),(xs(k,i)+orep(k),k=1,3),(vs(k,i),k=1,3),ips(i),i=1,nsa)
 1008 format(i1,1x,6f13.8,i5)
  303 continue
  302 continue
  301 continue
      endif
c
      if(nsm.gt.0) then
      write(lfnrst,1011) ((0.0d0,k=1,3),i=1,nrep*nsm)
 1011 format(2x,3f13.8)
      endif
c
      if(nseq.gt.0) then
      write(lfnrst,1012) ((lseq(i),i=1,nseq),j=1,nrep)
 1012 format(20i3)
      endif
c
      close(unit=lfnrst)
c
      if(util_print('files',print_default)) then
      write(lfnout,2000) filrst(1:length)
 2000 format(/,' Created restart',t40,a,/)
      endif
c
      argos_prep_wrtrst=.true.
      return
c
 9999 continue
      argos_prep_wrtrst=.false.
      return
      end

      subroutine argos_cafe_wtmro(lfnmro,dera)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "msgids.fh"
c
      integer lfnmro
      real*8 dera(6,nsatot)
c
      integer i,j
c
      call ga_dgop(mcf_68,dera,5*nsatot,'+')
c
      if(me.eq.0) then
      write(lfnmro) ((dera(i,j),i=1,6),j=1,nsatot)
      else
      do 1 i=1,nsatot
      do 2 j=1,6
      dera(j,i)=zero
    2 continue
    1 continue
      endif
c
      return
      end
c $Id: argos_cafe_wtmro.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine ana_report_file(opt,fil,lfn)
c
c $Id: ana_report.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_common.fh"
#include "ana_params.fh"
#include "mafdecls.fh"
c
      character*8 opt
      character*255 fil
      integer lfn
c
      integer i,j,num,numi,numj
      integer i_ii,l_ii,i_ic,l_ic
      integer i_ji,l_ji,i_jc,l_jc,i_jr,l_jr
c
      if(me.ne.0) return
c
      if(opt.eq.'local   '.and.index(fil,'.loc').gt.0) then
      open(unit=lfn,file=fil(1:index(fil,' ')-1))
      rewind(lfn)
      read(lfn,1000) num
 1000 format(i7)
      read(lfn,1000) numi
      do 1 i=1,numi
      read(lfn,1000) j
    1 continue
      read(lfn,1000) numj
      if(.not.ma_push_get(mt_int,3*numi,'ii',l_ii,i_ii))
     + call md_abort('Could not allocate ii',0)
      if(.not.ma_push_get(mt_byte,12*numi,'ic',l_ic,i_ic))
     + call md_abort('Could not allocate ic',0)
      if(.not.ma_push_get(mt_int,4*numj,'ji',l_ji,i_ji))
     + call md_abort('Could not allocate ji',0)
      if(.not.ma_push_get(mt_byte,12*numj,'jc',l_jc,i_jc))
     + call md_abort('Could not allocate jc',0)
      if(.not.ma_push_get(mt_dbl,numj,'jr',l_jr,i_jr))
     + call md_abort('Could not allocate jr',0)
      call ana_report_loc(lfn,numi,numj,int_mb(i_ii),int_mb(i_ji),
     + byte_mb(i_ic),byte_mb(i_jc),dbl_mb(i_jr))
      if(.not.ma_pop_stack(l_jr))
     + call md_abort('Failed to deallocate jr',0)
      if(.not.ma_pop_stack(l_jc))
     + call md_abort('Failed to deallocate jc',0)
      if(.not.ma_pop_stack(l_ji))
     + call md_abort('Failed to deallocate ji',0)
      if(.not.ma_pop_stack(l_ic))
     + call md_abort('Failed to deallocate ic',0)
      if(.not.ma_pop_stack(l_ii))
     + call md_abort('Failed to deallocate ii',0)
      close(unit=lfn)
      endif
c
      return
      end
      subroutine ana_report_loc(lfn,numi,numj,ndxi,ndxj,itxt,jtxt,tim)
c
      implicit none
c
#include "ana_common.fh"
#include "ana_params.fh"
c
      integer lfn,numi,numj
      integer ndxi(numi,3),ndxj(numj,4)
      character*12 itxt(numi),jtxt(numj)
      real*8 tim(numj)
c
      integer i,j,k,nskip,it,jt(10)
      real*8 ctime,ptime,dtime,timi,timf
c
      rewind(lfn)
      read(lfn,1000) j
      read(lfn,1000) j
 1000 format(i7)
      do 1 i=1,numi
      read(lfn,1001) (ndxi(i,j),j=1,3),itxt(i)
 1001 format(i7,i5,i6,1x,a12)
    1 continue
      read(lfn,1000) j
      do 2 i=1,numj
      read(lfn,1001) (ndxj(i,j),j=1,3),jtxt(i)
    2 continue
      nskip=numi+numj+3
c
      do 3 i=1,numi
      rewind(lfn)
      do 4 j=1,nskip
      read(lfn,1000,end=3) k
    4 continue
      do 6 j=1,numj
      ndxj(j,4)=0
      tim(j)=0.0d0
    6 continue
      ptime=-1.0d0
      timi=0.0d0
    5 continue
      read(lfn,1002,end=11) ctime,it,(jt(k),k=1,10)
 1002 format(f12.6,i6,10i6)
      if(ptime.le.0.0d0) timi=ctime
      if(timf.lt.ctime) timf=ctime
      if(it.ne.ndxi(i,1)) goto 5
c
      if(ptime.ge.0.0d0) then
      dtime=ctime-ptime
      do 7 j=1,numj
      if(ndxj(j,4).ne.0) tim(j)=tim(j)+dtime
    7 continue
      endif
c
      do 8 j=1,numj
      ndxj(j,4)=0
    8 continue
      ptime=ctime
c
      do 9 k=1,10
      if(jt(k).eq.0) goto 9
      do 10 j=1,numj
      if(ndxj(j,1).eq.jt(k)) ndxj(j,4)=1
   10 continue
    9 continue
c
      goto 5
   11 continue
c
      dtime=ctime-ptime
      do 12 j=1,numj
      if(ndxj(j,4).ne.0) tim(j)=tim(j)+dtime
   12 continue
c
      do 13 j=1,numj
      if(tim(j).gt.0.0d0) then
      write(6,1003) ndxi(i,3),itxt(i),
     + ndxj(j,3),jtxt(j),tim(j),100.0d0*tim(j)/(timf-timi)
 1003 format(i7,1x,a,i7,1x,a,f12.6,' ps = ',f6.2,' %')
      endif
   13 continue
      write(6,1004)
 1004 format(' ')
c
    3 continue
c
      return
      end

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_driver(
     &       HESS, GRAD, STEP, VC,
     &       COORD, COOROLD, HIEIGS, GISR,
     &       CHARGE, SELECT, SCRSYM, SCRSQ,
     &       VECSQ, ATMASS, P, HMP,
     &       CMASS, TENIN, ENERGY, E2NEW, TRUST,
     &       CONVGE, CONVGG, CONVGGM,
     &       NMODE, TRACK, RPATH, BCKSTP, CNVGRD, rtdb )
c $Id: stpr_driver.F 25540 2014-05-01 22:33:27Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      LOGICAL TRACK,BCKSTP,CNVGRD,RPATH
#include "chow.fh"
      integer rtdb
      LOGICAL SECO, SWSEC, SWFIR
      integer idamax
      external idamax
      PARAMETER( ZERO=0.D0, ONE=1.D0 )
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      COMMON / SWITCH / SECO, SWSEC, SWFIR
      DIMENSION HESS(NAT3TR),GRAD(NAT3),STEP(NAT3),VC(NAT3,NAT3),
     &          COORD(3,NATOM),COOROLD(3,NATOM),HIEIGS(NAT3),
     &          GISR(NAT3),CHARGE(NATOM),
     &          SELECT(NAT3),SCRSYM(NAT3TR),SCRSQ(NAT3,NAT3),
     &          VECSQ(NAT3,NAT3),ATMASS(NATOM),P(NAT3TR),
     &          HMP(NAT3TR),CMASS(3),TENIN(3,3)
      IF(BCKSTP)THEN
        WRITE(6,*)'  Retrieving old hessian, gradient '
        WRITE(6,*)'  coordinates, and energy. '
        IERR = 0
        CALL stpr_retrve(HESS,GRAD,COORD,ENERGY,IERR)
        IF(IERR.NE.0)THEN
          WRITE(6,*)'  Unsuccessful "RETRVE" attempt. '
          STOP
        ENDIF
      ENDIF

*      grad_max = dabsmax(nat3,grad)
      grad_max = abs(grad(idamax(nat3,grad,1)))

      NINTER = NAT3
C
C     Zero all arrays with the exception of the
C     incoming hessian; HESS, and gradient; GRAD.
C
      call dfill(NAT3,0.0d00,STEP,1)
      call dfill(NAT3,0.0d00,GISR,1)
      call dfill(NAT3,0.0d00,HIEIGS,1)
      call dfill(NAT3TR,0.0d00,SCRSYM,1)
      call dfill(NAT3SQ,0.0d00,SCRSQ,1)
C
C     Place necessary current iteration information: HESS, GRAD,
C     COORD, and ENERGY in cold storage (scratch disk) to recall
C     when needed.
C
      IERR = 0
      CALL stpr_place(HESS,GRAD,COORD,ENERGY,IERR)
      IF(IERR.NE.0)THEN
        WRITE(6,*)'  Unsuccessful "PLACE" attempt. '
        STOP
      ENDIF
C
C     Partition hessian.
C
      CALL stpr_partit(rtdb,
     $     HESS, GRAD, COORD, HIEIGS, GISR, VC, SCRSYM,
     &            SCRSQ, VECSQ, STEP, SELECT, P, HMP,
     &            ATMASS, CMASS, TENIN, ENERGY,
     &            CONVGE, CONVGG, CONVGGM,
     &            NINTER, NMODE, RPATH, TRACK, BCKSTP)
*      write(6,*)' step after partit '
*      do jjjj = 1,nat3
*      write(6,'(1x,i5,1x,f20.10)')jjjj,step(jjjj)
*      enddo
      IF(NINTER.NE.0)THEN
        CALL stpr_mkstep(HIEIGS,GISR,VC,STEP,SELECT,SCRSQ,ATMASS,ENERGY,
     &              CONVGE, CONVGG, CONVGGM, GRAD_MAX,
     &              E2NEW,NINTER,NAT3,NMODE,TRUST,BCKSTP,CNVGRD,
     &              rtdb)
*      write(6,*)' step after mkstep '
*      do jjjj = 1,nat3
*      write(6,'(1x,i5,1x,f20.10)')jjjj,step(jjjj)
*      enddo
      ELSE
       CNVGRD = .TRUE.
       WRITE(6,*)'  ENERGY = ',ENERGY
      ENDIF
      IF (.NOT.CNVGRD) THEN
        CALL stpr_output(STEP,COORD,BCKSTP, grad_max,
     &                   CONVGGM, CONVGG, CONVGE )
      ELSE
c
c     Write out useful hessian info:
c

      ENDIF
C
C     Restore currently used information and write to backstep disk.
C
      IERR = 0
      CALL stpr_recall(HESS,GRAD,COORD,ENERGY,IERR)
      IF(IERR.NE.0)THEN
        WRITE(6,*)'  Unsuccessful "RECALL" attempt. '
        STOP
      ENDIF
      IERR = 0
      CALL stpr_save(HESS,GRAD,COORD,ENERGY,IERR)
      IF(IERR.NE.0)THEN
        WRITE(6,*)'  Unsuccessful "SAVE" attempt. '
        STOP
      ENDIF
      CALL stpr_sumstc(STEP,COORD,ATMASS,CMASS,TENIN,CNVGRD)
      RETURN
      END
C> @}

C> \ingroup task
C> @{
C>
C> \brief The main driver for gradient evaluations
C>
C> This routine controls both analytical and numerical gradient
C> evaluations. Before starting any gradient evaluation it will check
C> whether the calculation was preceeded by a successfull energy
C> evaluation. If not the energy will be calculated first.
C>
C> Dependent on the theory setting a variety of gradient drivers
C> may be called. If no analytical gradients are available for a theory
C> the gradient will be evaluated using numerical differentiation.
C>
C> \return Return .true. if the gradient was calculated successfully,
C> and .false. otherwise.
C>
      logical function task_gradient(rtdb)
*
* $Id: task_gradient.F 25320 2014-03-11 18:56:32Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
#include "global.fh"
#include "nwc_const.fh"
c
      integer rtdb !< [Input] The RTDB handle
c
      logical status, ignore, numerical
      logical ocons
      logical task_qmmm
      character*32 theory
      double precision cpu, wall, energy, dipole(3), 
     $     gradient(3,nw_max_atom), gmax, gnorm
      integer i, k, ncent, nelem
      logical task_gradient_doit, oniom_gradient, geom_rtdb_ncent
      external task_gradient_doit, oniom_gradient, geom_rtdb_ncent
      logical  task_qmmm_gradient
      external task_qmmm_gradient
      logical cons_active
      external cons_active
c
      logical task_bsse
      logical bsse_gradient
      external bsse_gradient
c
c      logical task_embed
c      logical embed_gradient
c      external embed_gradient
c
      cpu  = util_cpusec()
      wall = util_wallsec()
c
c     Set output parameters as if failed
c
      ignore = rtdb_delete(rtdb, 'task:energy')
      ignore = rtdb_delete(rtdb, 'task:gradient')
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, .false.))
     $     call errquit('task_gradient: failed to invalidate status',0,
     &       RTDB_ERR)
      if (.not. rtdb_cget(rtdb, 'task:theory', 1, theory))
     $     call errquit('task:gradient: theory not specified',0,
     &       RTDB_ERR)
c
      if (.not. geom_rtdb_ncent(rtdb, 'geometry', ncent))
     $     call errquit('task_gradient: failed getting #atoms',0,
     &       RTDB_ERR)
      nelem = ncent*3
c
      if (.not. rtdb_get(rtdb, 'task:numerical', mt_log, 1, 
     $     numerical)) numerical = .false.
c
      if( .not. rtdb_get(rtdb,'task:QMMM',mt_log,1,task_qmmm))
     &    task_qmmm = .false.
c
c      if( .not. rtdb_get(rtdb,'task:embed',mt_log,1,task_embed))
c     &    task_embed = .false.
c
      if (.not. rtdb_get(rtdb,'bsse',mt_log,1,task_bsse))
     $     task_bsse = .false.
c
      if(task_qmmm) then
          status = task_qmmm_gradient(rtdb)
            if (.not. rtdb_get(rtdb, 'qmmm:energy', mt_dbl, 1, energy))
     $           call errquit('task_energy: no energy in rtdb?',0,
     &       RTDB_ERR)
            if (.not. rtdb_get(rtdb, 'qmmm:gradient', mt_dbl, nelem, 
     $           gradient))
     $           call errquit('task_gradient: no gradient in rtdb?',0,
     &       RTDB_ERR)
c
c      else if(task_embed) then
c          status = embed_gradient(rtdb)
c            if (.not. rtdb_get(rtdb, 'embed:energy', mt_dbl, 1, energy))
c     $           call errquit('task_gradient: no energy in rtdb?',0,
c     &       RTDB_ERR)
c            if (.not. rtdb_get(rtdb, 'embed:gradient', mt_dbl, nelem,
c     $           gradient))
c     $           call errquit('task_gradient: no gradient in rtdb?',0,
c     &       RTDB_ERR)
c
      else if(theory .ne. 'oniom' .or. numerical) then
c
        if(.not.task_bsse) then
          status = task_gradient_doit(rtdb,theory,energy, gradient)
        else
          status = bsse_gradient(rtdb,theory,energy,gradient)
          if(.not.status)
     $      call errquit('task_gradient: error call bsse gradient',911,
     &                   CALC_ERR)
        endif
c
      else
         status = oniom_gradient(rtdb)
         if (status) then
            if (.not. rtdb_get(rtdb, 'oniom:energy', mt_dbl, 1, energy))
     $           call errquit('task_energy: no energy in rtdb?',0,
     &       RTDB_ERR)
            if (.not. rtdb_get(rtdb, 'oniom:gradient', mt_dbl, nelem, 
     $           gradient))
     $           call errquit('task_gradient: no gradient in rtdb?',0,
     &       RTDB_ERR)
            if (rtdb_get(rtdb, 'oniom:dipole', mt_dbl, 3, dipole)) then
               if (.not. rtdb_put(rtdb,'task:dipole',mt_dbl,3,dipole))
     $              call errquit('task_energy: failed storing dipole',0,
     &       RTDB_ERR)
            else
               ignore = rtdb_delete(rtdb, 'task:dipole')
            endif
         endif
      endif
c
       ocons = cons_active(rtdb)
c      if(.not.rtdb_get(rtdb, 'cons:active',mt_log, 1, ocons)) then
c        ocons = .false.
c      end if
      if(ocons)  call cons_add_egrad(rtdb,energy,nelem,gradient)
c
      call bq_force(rtdb)
c
      if (status) then
         call geom_print_rtdb_ecce(rtdb)
         call ecce_print1('total energy', mt_dbl, energy, 1)
         call ecce_print2('total gradient', mt_dbl, gradient,
     $        3,3,nelem/3)
         gmax = 0.0d0
         gnorm = 0.0d0
         do i = 1, nelem/3
            do k = 1, 3
               gnorm = gnorm + gradient(k,i)**2
               gmax  = max(abs(gradient(k,i)),gmax)
            end do
         enddo
         gnorm = sqrt(gnorm)
         call ecce_print1('gradient norm', mt_dbl, gnorm, 1)
         call ecce_print1('gradient max', mt_dbl, gmax, 1)
      endif
c
      if (.not. rtdb_put(rtdb, 'task:energy', mt_dbl, 1, energy))
     $     call errquit('task_gradient: failed storing energy',0,
     &       RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:gradient', mt_dbl, nelem,
     $     gradient))
     $     call errquit('task_gradient: failed storing energy',0,
     &       RTDB_ERR)
c
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - wall
c
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, .true.))
     $     call errquit('task_gradient: failed to set status',0,
     &       RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:cputime', mt_dbl, 1, cpu))
     $     call errquit('task_gradient: failed storing cputime',0,
     &       RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:walltime', mt_dbl, 1, wall))
     $     call errquit('task_gradient: failed storing walltime',0,
     &       RTDB_ERR)
c
      call ecce_print1('cpu time', mt_dbl, cpu, 1)
      call ecce_print1('wall time', mt_dbl, wall, 1)
      if (status) then
         call ecce_print_module_exit('task gradient', 'ok')
      else
         call ecce_print_module_exit('task gradient', 'failed')
      endif
c
      task_gradient = status
c
      end
C> @}
c
      logical function task_gradient_doit(rtdb,theory,energy,gradient)
*
* $Id: task_gradient.F 25320 2014-03-11 18:56:32Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
#include "global.fh"
      integer rtdb
      character*32 theory
      double precision energy, gradient(3,*)
c
c     Generic NWChem interface to compute the energy and gradient.  
c     Currently only the QM components are supported.
c
c     Since this routine is directly invoked by application modules
c     no input is processed in this routine.
c
c     RTDB input parameters
c     ---------------------
c     task:theory (string) - name of (QM) level of theory to use
c     task:numerical (logical) - optional - if true use numerical 
c         differentiation. If absent or false use default selection.
c     
c     RTDB output parameters
c     ----------------------
c     task:status (logical)- T/F for success/failure
c     if (status) then
c     .  task:energy (real)   - total energy
c     .  task:gradient (real array) - derivative w.r.t. geometry cart. coords.
c     .  task:dipole (real(3)) - total dipole if available
c     .  task:cputime (real)  - cpu time to execute the task
c     .  task:walltime (real) - wall time to execute the task
c
c     Also returns status through the function value
c
c     If the method does not have analytic derivatives automatically call
c     the numerical derivative routine.
c
      logical  scf, rimp2, oimp2, direct_mp2, ccsd, mcscf, selci
      external scf, rimp2, oimp2, direct_mp2, ccsd, mcscf, selci
      logical semi_dir_mp2, rimp2g, pspw_gradient,band_gradient
      external semi_dir_mp2, rimp2g, pspw_gradient,band_gradient
      logical dft_energy_gradient, sodft_energy_gradient
      external dft_energy_gradient, sodft_energy_gradient
      logical  tddft_energy, tddft_gradient
      external tddft_energy, tddft_gradient
      logical tce_energy_fragment
      external tce_energy_fragment
      logical  paw_gradient
      external paw_gradient
c
      logical mcscf_gradient, scf_gradient, grad_dft, task_num_grad
      external mcscf_gradient, scf_gradient, grad_dft, task_num_grad
      logical geom_rtdb_ncent
      logical leps_gradient 
      external leps_gradient
c
c      logical tce_gradient
c      external tce_gradient
c
      integer nelem, ncent
      logical status, numerical, ocosmo, xc_chktau
      external xc_chktau
      double precision dipole(3)
      character*80 key, prefix
c
      logical dftmp2
      logical rodft
c
      if (.not. geom_rtdb_ncent(rtdb, 'geometry', ncent))
     $     call errquit('task_gradient: failed getting #atoms',0,
     &       RTDB_ERR)
      nelem = ncent*3
c
      call ecce_print_module_entry('task gradient')
c
      task_gradient_doit = .false.
c
c     Set the theory in the database so that all is consistent for
c     the lower level modules.  Should not really have to do this,
c     but this value is used (appropriately and inappropriately) and
c     things are not yet disentangled.
c
      if (.not. rtdb_cput(rtdb, 'task:theory', 1, theory))
     $     call errquit('task_gradient: setting theory?',0,
     &       RTDB_ERR)
c
c     Right now only have a QM component
c
      if (.not. rtdb_get(rtdb, 'task:numerical', mt_log, 1, 
     $     numerical)) numerical = .false.
c
c     Check if analytic gradients are supported within the theory
c
c     == double hybrid DFT ==
      dftmp2 = .false.
      if(theory.eq.'dft') then
        if (.not. rtdb_get(rtdb,'dft:dftmp2',mt_log,1,dftmp2))
     1   dftmp2 = .false.
        if (dftmp2) then
         numerical = .true.  ! do numerical gradients for fifth-rung (w/MP2) functionals
         if (ga_nodeid().eq.0) write(LuOut,*) 
     1    'DFT+MP2 based functional - numerical derivatives only'
        end if
      end if
c
c     == restricted open-shell DFT ==
      rodft = .false.
      if(theory.eq.'dft') then
        if (.not. rtdb_get(rtdb,'dft:rodft',mt_log,1,rodft))
     1   rodft = .false.
      end if
c
c     Currently cosmo does not work with analytic gradients
c
      if (.not. rtdb_get(rtdb,'slv:cosmo',mt_log,1,ocosmo))
     $     ocosmo = .false.
c
c     Actually do the deed
c
      prefix = theory           ! Most common
c
      if (theory .eq. 'scf') then
         if (numerical) then
           status = task_num_grad(rtdb)
         else
           status = scf_gradient(rtdb)
         endif
      else if (theory .eq. 'dft') then
         if (numerical) then
           status=task_num_grad(rtdb)
         else
           status = dft_energy_gradient(rtdb)
         endif
      else if (theory .eq. 'sodft') then
         if (numerical) then
           status=task_num_grad(rtdb)
         else
           status = sodft_energy_gradient(rtdb)
         endif
      else if (theory .eq. 'mp2' .or. theory .eq. 'semi_dir_mp2') then
         if (numerical) then
           status=task_num_grad(rtdb)
         else
           prefix = 'mp2'
           if(.not. rtdb_cput(rtdb,'sdmp2:task',1,'gradient'))
     $        call errquit('task_gradient: rtdb_put failed',0, RTDB_ERR)
           status = semi_dir_mp2(rtdb)
         endif
      else if (theory .eq. 'mcscf') then
         if (numerical) then
           status=task_num_grad(rtdb)
         else
           status = mcscf_gradient(rtdb)
         endif
      else if (theory .eq. 'rimp2') then
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'rimp2_grad') then
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'direct_mp2') then
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'selci') then
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'oimp2') then
         status = .false.       ! No derivatives yet
      else if (theory .eq. 'ccsd') then
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ccsd(t)') then
         prefix = 'ccsd'
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ccsd+t(ccsd)') then
         prefix = 'ccsd'
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'tddft') then
         if (numerical) then
            status = task_num_grad(rtdb) ! Only numerical
         else
            status = tddft_gradient(rtdb)
         endif
      else if (theory .eq. 'tce') then
         status = task_num_grad(rtdb) ! Only numerical
c         if (numerical) then 
c            status = task_num_grad(rtdb) ! Only numerical
c         else
c            status = tce_gradient(rtdb)
c         endif
      else if (theory .eq. 'uccd') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'ccd'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ulccd') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'lccd'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'uccsd') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'ccsd'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ulccsd') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'lccsd'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'uqcisd') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'qcisd'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'uccsdt') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'ccsdt'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'uccsdtq') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'ccsdtq'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ucisd') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'cisd'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ucisdt') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'cisdt'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ucisdtq') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'cisdtq'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ump2') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'mbpt2'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ump3') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'mbpt3'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'ump4') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'mbpt4'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'umbpt2') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'mbpt2'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'umbpt3') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'mbpt3'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory .eq. 'umbpt4') then
         prefix = 'tce'
         if (.not.rtdb_cput(rtdb,'tce:model',1,'mbpt4'))
     1   call errquit('task_gradient: failed writing to rtdb',0,
     &       RTDB_ERR)
         status = task_num_grad(rtdb) ! Only numerical
      else if (theory.eq.'pspw') then
         status = pspw_gradient(rtdb)
      else if (theory .eq. 'band') then
         status = band_gradient(rtdb)
      else if (theory .eq. 'paw') then
         status = paw_gradient(rtdb)
      else if (theory .eq. 'qmmm') then
         if (ga_nodeid().eq.0) then
           write(6,*)'task_gradient: qmmm should never be the theory '
           write(6,*)'task_gradient: you probably reversed the order ',
     &         'of the task input '
           write(6,*)'task [qmmm] <string theory> [<string operation ',
     &         '= energy>] [numerical] [ignore]'
         endif
         status = .false.
c      else if (theory .eq. 'embed') then
c         if (ga_nodeid().eq.0) then
c           write(6,*)'task [embed] <string theory> [<string operation ',
c     &         '= energy>] [numerical] [ignore]'
c         endif
c         status = .false.
      else if (theory .eq. 'oniom') then
         status = task_num_grad(rtdb) ! Doing Oniom in a numerical fashion
      else if (theory .eq. 'dangchang') then
         status = task_num_grad(rtdb) ! Dang Chang only supports numerical gradients
      else if (theory .eq. 'leps') then
         if (numerical) then
           status = task_num_grad(rtdb)
         else
           status = leps_gradient(rtdb)
         endif
      else
         call util_flush(luout)
         write(luout,*)'task_gradient: theory = ',
     &                 theory(1:inp_strlen(theory))
         call util_flush(luout)
         call errquit('task_gradient: unknown theory',0, INPUT_ERR)
      endif
c
      if (status) then
         key = ' '
         write(key,'(a,'':energy'')') prefix(1:inp_strlen(prefix))
         if (.not. rtdb_get(rtdb, key, mt_dbl, 1, energy))
     $        call errquit('task_gradient: no energy in rtdb?',0,
     &       RTDB_ERR)
c
         key = ' '
         write(key,'(a,'':dipole'')') prefix(1:inp_strlen(prefix))
         if (rtdb_get(rtdb, key, mt_dbl, 3, dipole)) then
           if (.not. rtdb_put(rtdb, 'task:dipole', mt_dbl, 3, dipole))
     $        call errquit('task_gradient: failed storing dipole',0,
     &       RTDB_ERR)
	 endif
c
         write(key,'(a,'':gradient'')') prefix(1:inp_strlen(prefix))
         if (.not. rtdb_get(rtdb, key, mt_dbl, nelem, gradient))
     $        call errquit('task_gradient: no gradient in rtdb?',0,
     &       RTDB_ERR)
      end if
c
      task_gradient_doit = status
c
      end

      subroutine argos_em()
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
c
      integer i_pcgw,l_pcgw,i_pcgs,l_pcgs
c
      llong=ltwin
c
c     center of mass coordinates
c
      call argos_cafe_cenmas(nwmloc,dbl_mb(i_xw),dbl_mb(i_xwm),nsaloc,
     + int_mb(i_is+(lsatt-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_gsm))
c
c     periodic boundary conditions
c
      call argos_fold(int_mb(i_iw),int_mb(i_is),
     + dbl_mb(i_xw),dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_xsm))
c
c     atom redistribution
c
      call argos_space_travel(box,dbl_mb(i_xw),dbl_mb(i_vw),
     + dbl_mb(i_xwcr),
     + dbl_mb(i_gw),int_mb(i_iw),nwmloc,dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_gs),int_mb(i_is),nsaloc)
c
c     center of mass coordinates
c
      call argos_cafe_cenmas(nwmloc,dbl_mb(i_xw),dbl_mb(i_xwm),nsaloc,
     + int_mb(i_is+(lsatt-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_gsm))
c
      call argos_cafe_mass(dbl_mb(i_wws),dbl_mb(i_wws+mwa),
     + int_mb(i_is+(lsatt-1)*msa),nsaloc)
c
      call argos_eminit(dbl_mb(i_xw),dbl_mb(i_yw),
     + dbl_mb(i_xs),dbl_mb(i_ys))
c
      if(msdit.gt.0) call argos_stdesc(int_mb(i_iw+(lwdyn-1)*mwm),
     + dbl_mb(i_xw),dbl_mb(i_yw),dbl_mb(i_vw),dbl_mb(i_fw),
     + int_mb(i_is+(lsdyn-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_ys),dbl_mb(i_vs),dbl_mb(i_fs),
     + dbl_mb(i_wws),dbl_mb(i_wws+mwa),int_mb(i_mm),dbl_mb(i_fm),
     + dbl_mb(i_xsm))
c
      if(mcgit.gt.0) then
      if(.not.ma_push_get(mt_dbl,3*mwa*mwm,'pcgw',l_pcgw,i_pcgw))
     + call md_abort('Failed to allocate memory for pcgw',me)
      if(.not.ma_push_get(mt_dbl,3*msa,'pcgs',l_pcgs,i_pcgs))
     + call md_abort('Failed to allocate memory for pcgs',me)
      call argos_congra(int_mb(i_iw+(lwdyn-1)*mwm),dbl_mb(i_xw),
     + dbl_mb(i_yw),dbl_mb(i_vw),dbl_mb(i_fw),dbl_mb(i_pcgw),
     + int_mb(i_is+(lsdyn-1)*msa),dbl_mb(i_xs),dbl_mb(i_ys),
     + dbl_mb(i_vs),dbl_mb(i_fs),dbl_mb(i_pcgs),dbl_mb(i_wws),
     + dbl_mb(i_wws+mwa))
      if(.not.ma_pop_stack(l_pcgs))
     + call md_abort('Failed to deallocate memory for pcgs',me)
      if(.not.ma_pop_stack(l_pcgw))
     + call md_abort('Failed to deallocate memory for pcgw',me)
      endif
c
      call argos_cafe_print_energy(lfnout)
c
      call argos_space_printf(filtop,lfntop,
     + int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_fs),npener,dbl_mb(i_esa))
c
      return
      end
c $Id: argos_em.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: lcaov1.F 24323 2013-06-18 19:27:05Z bylaska $
*

      logical function lcaov1(rtdb)
      implicit none
      integer rtdb

#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "rtdb.fh"
#include "errquit.fh"

      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d

*     **** electronic variables ****
      real*8 icharge,tcharge
      integer ispin
      integer ne(2)


*     **** error variables ****
      integer ierr

*     **** local variables ****
      integer ms,mapping,mapping1d
      real*8  deltae,deltac,deltar
      real*8  gx,gy,gz,cx,cy,cz,sum1,sum2
      integer i,j,k,ia,n,nn,nextra_orbs
      integer ii,jj,indx,indx1
      integer icount,it_in,it_out
      character*255 full_filename

      logical value,lcao_print,success
      integer version
      real*8 unita(3,3),t
      integer ind,lcao_iterations,x,xx,mult
      character*50 filename


*     **** external functions ****
      character*50 control_input_psi
      external     control_input_psi
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg

      logical  control_read,ion_init
      external control_read,ion_init
 
      logical      psp_semicore
      external     psp_semicore

      integer      control_np_orbital,control_mapping,control_mapping1d
      external     control_np_orbital,control_mapping,control_mapping1d

      double precision control_unita
      external         control_unita
      integer  control_ngrid,control_ispin
      external control_ngrid,control_ispin
      integer  control_multiplicity
      external control_multiplicity
      real*8   control_totalcharge
      external control_totalcharge
      real*8   ion_TotalCharge_qm
      external ion_TotalCharge_qm
      logical  lcao_wvfnc,control_print,psi_filefind
      external lcao_wvfnc,control_print,psi_filefind
      integer  control_rtdb,control_version
      external control_rtdb,control_version
      integer  control_frac_occ_extra_orbitals
      external control_frac_occ_extra_orbitals


*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.

      call nwpw_timing_init()

*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)
      

      if (taskid.eq.MASTER) call current_second(cpu1)

      value = control_read(1,rtdb)
      call Parallel2d_Init(control_np_orbital())
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      mapping = control_mapping()

*     **** initialize psi_data ****
      call psi_data_init(20)

*     **** initialize D3dB data structure ****
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d

*     ***** Initialize double D3dB data structure ****
      if (control_version().eq.4) 
     >   call D3dB_Init(2,2*ngrid(1),2*ngrid(2),2*ngrid(3),mapping)


*     **** initialize lattice and packing data structure ****
      call lattice_init()
      call G_init()
      call mask_init()
      call Pack_Init()

      call D3dB_pfft_init()
      call ga_sync()

*     **** read ions ****
      value = ion_init(rtdb)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call psp_init()
      call psp_readall()
      if (psp_semicore(0)) call semicore_check()

*     **** initialize G,mask,ke,and coulomb data structures ****
      call ke_init()
      if (control_version().eq.3) call coulomb_init()
      if (control_version().eq.4) call coulomb2_init()
      call strfac_init()
      call phafac()
      if (control_version().eq.3) then
         call ewald_init()
         call ewald_phafac()
      end if

*     **** call the lcao code ****
      filename = control_input_psi()
      version = control_version()
      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      unita(1,1) = control_unita(1,1)
      unita(2,1) = control_unita(2,1)
      unita(3,1) = control_unita(3,1)
      unita(1,2) = control_unita(1,2)
      unita(2,2) = control_unita(2,2)
      unita(3,2) = control_unita(3,2)
      unita(1,3) = control_unita(1,3)
      unita(2,3) = control_unita(2,3)
      unita(3,3) = control_unita(3,3)

      ispin   = control_ispin()
      mult    = control_multiplicity()
      tcharge = control_TotalCharge()
      icharge = ion_TotalCharge_qm()
      t = icharge - tcharge       !** total number of electrons **
      x = NINT(t)
      xx = x

*     **** reassign spin to agree with total number of electrons ****
      if ((mod(x,2).ne.0).and.(ispin.eq.1)) then !** odd number of electrons **
         ispin = 2
         call control_ispin_set(ispin)
      end if

*     **** reassign mult to agree with total number of electrons ****
      if ((mod(x,2).ne.0) .and.(mod(mult,2).ne.0)) then !** odd number of electrons and mult odd **
         mult = mult - 1
         do while (mult.gt.(x+1))
            mult = mult - 2
         end do
         if (mult.lt.1) mult = 2
         call control_multiplicity_set(mult)
      end if
      if ((mod(x,2).eq.0) .and.(mod(mult,2).eq.0)) then !** even number of electrons and mult even **
         mult = mult - 1
         do while (mult.gt.(x+1))
            mult = mult - 2
         end do
         if (mult.lt.1) mult = 1
         call control_multiplicity_set(mult)
      end if

*     **** assign number of up and down electrons ****
      if (ispin.eq.1) then
         ne(1) = xx/2
         ne(2) = 0
      else
         x = mult-1
         ne(1) = (xx+x)/2
         ne(2) = (xx-x)/2
      end if

      nextra_orbs = control_frac_occ_extra_orbitals()
      if (ispin.eq.1) then
         ne(1) = ne(1) + nextra_orbs
      else
         ne(1) = ne(1) + nextra_orbs
         ne(2) = ne(2) + nextra_orbs
      end if

      rtdb = control_rtdb()
      if (.not.rtdb_get(rtdb,
     >         'nwpw:lcao_iterations',mt_int,1,lcao_iterations))
     >   lcao_iterations = 10

      lcao_print = .true.


      success =  lcao_wvfnc(lcao_print,lcao_iterations,
     >                        filename,
     >                        version,
     >                        ngrid,
     >                        unita,
     >                        ispin,
     >                        ne)



*     **** deallocate heap memory ****
      if (control_version().eq.3) call ewald_end()
      call strfac_end()
      if (control_version().eq.3) call coulomb_end()
      if (control_version().eq.4) call coulomb2_end()
      call ke_end()
      call mask_end()
      call Pack_end()
      call G_end()
      call ion_end()
      call psp_end()


      call D3dB_pfft_end()
      call D3dB_end(1)
      if (control_version().eq.4) call D3dB_end(2)
      call psi_data_end()


      call Parallel2d_Finalize()
      call Parallel_Finalize()
      lcaov1 = value
      return
      end

C> \ingroup selci
C> @{
      subroutine selci_getij(i,j,ioconf,joconf,nintpo,nbitpi,iocc)
*
* $Id: getij.F 24790 2013-11-11 18:56:49Z d3y133 $
*
      dimension ioconf(nintpo),joconf(nintpo),ind(2),ijocc(2),
     $     iocc(*)
      integer selci_leadz32
#include "bitops.fh"
#include "errquit.fh"
c
c     (i->j)|I> = |J>. Determine i and j from the
c     bit packed occupations
c
      nelpi = nbitpi/2
      nbit2 = 2 - nbitpi
      ngot = 0
      ibase = 0
      do 10 iword = 1,nintpo
         itemp = ieor(ioconf(iword),joconf(iword))
         jbase = 0
 20      lz = selci_leadz32(itemp)
         lz = lz - mod(lz,2)
         if (lz.ne.nbitpi) then
            jbase = jbase  + lz/2 + 1
            ngot = ngot + 1
            itemp = ishft(itemp,lz)
            k = ibase + jbase
            ind(ngot) = k
            ijocc(ngot) = iocc(k) - ieor(ishft(itemp,nbit2),iocc(k))
            itemp =ishft(itemp,2)
            if (ngot.eq.2) goto 30
            goto 20
         endif
         ibase = ibase + nelpi
 10   continue
      call errquit('getij: fell out of do 10',ngot, UNKNOWN_ERR)
c
 30   continue
c
c     now have indices and delta occupations ... which is which ?
c
      if (ijocc(1).gt.ijocc(2)) then
         i = ind(1)
         j = ind(2)
      else
         i = ind(2)
         j = ind(1)
      endif
c
      end
C> @}

*> \brief \b ZLARFX applies an elementary reflector to a general rectangular matrix, with loop unrolling when the reflector has order ≤ 10.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZLARFX + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zlarfx.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zlarfx.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zlarfx.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZLARFX( SIDE, M, N, V, TAU, C, LDC, WORK )
* 
*       .. Scalar Arguments ..
*       CHARACTER          SIDE
*       INTEGER            LDC, M, N
*       COMPLEX*16         TAU
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         C( LDC, * ), V( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZLARFX applies a complex elementary reflector H to a complex m by n
*> matrix C, from either the left or the right. H is represented in the
*> form
*>
*>       H = I - tau * v * v**H
*>
*> where tau is a complex scalar and v is a complex vector.
*>
*> If tau = 0, then H is taken to be the unit matrix
*>
*> This version uses inline code if H has order < 11.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'L': form  H * C
*>          = 'R': form  C * H
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix C.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix C.
*> \endverbatim
*>
*> \param[in] V
*> \verbatim
*>          V is COMPLEX*16 array, dimension (M) if SIDE = 'L'
*>                                        or (N) if SIDE = 'R'
*>          The vector v in the representation of H.
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is COMPLEX*16
*>          The value tau in the representation of H.
*> \endverbatim
*>
*> \param[in,out] C
*> \verbatim
*>          C is COMPLEX*16 array, dimension (LDC,N)
*>          On entry, the m by n matrix C.
*>          On exit, C is overwritten by the matrix H * C if SIDE = 'L',
*>          or C * H if SIDE = 'R'.
*> \endverbatim
*>
*> \param[in] LDC
*> \verbatim
*>          LDC is INTEGER
*>          The leading dimension of the array C. LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX*16 array, dimension (N) if SIDE = 'L'
*>                                            or (M) if SIDE = 'R'
*>          WORK is not referenced if H has order < 11.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complex16OTHERauxiliary
*
*  =====================================================================
      SUBROUTINE ZLARFX( SIDE, M, N, V, TAU, C, LDC, WORK )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE
      INTEGER            LDC, M, N
      COMPLEX*16         TAU
*     ..
*     .. Array Arguments ..
      COMPLEX*16         C( LDC, * ), V( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ),
     $                   ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            J
      COMPLEX*16         SUM, T1, T10, T2, T3, T4, T5, T6, T7, T8, T9,
     $                   V1, V10, V2, V3, V4, V5, V6, V7, V8, V9
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           ZLARF
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG
*     ..
*     .. Executable Statements ..
*
      IF( TAU.EQ.ZERO )
     $   RETURN
      IF( LSAME( SIDE, 'L' ) ) THEN
*
*        Form  H * C, where H has order m.
*
         GO TO ( 10, 30, 50, 70, 90, 110, 130, 150,
     $           170, 190 )M
*
*        Code for general M
*
         CALL ZLARF( SIDE, M, N, V, 1, TAU, C, LDC, WORK )
         GO TO 410
   10    CONTINUE
*
*        Special code for 1 x 1 Householder
*
         T1 = ONE - TAU*V( 1 )*DCONJG( V( 1 ) )
         DO 20 J = 1, N
            C( 1, J ) = T1*C( 1, J )
   20    CONTINUE
         GO TO 410
   30    CONTINUE
*
*        Special code for 2 x 2 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         DO 40 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
   40    CONTINUE
         GO TO 410
   50    CONTINUE
*
*        Special code for 3 x 3 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         DO 60 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
   60    CONTINUE
         GO TO 410
   70    CONTINUE
*
*        Special code for 4 x 4 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         V4 = DCONJG( V( 4 ) )
         T4 = TAU*DCONJG( V4 )
         DO 80 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J ) +
     $            V4*C( 4, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
            C( 4, J ) = C( 4, J ) - SUM*T4
   80    CONTINUE
         GO TO 410
   90    CONTINUE
*
*        Special code for 5 x 5 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         V4 = DCONJG( V( 4 ) )
         T4 = TAU*DCONJG( V4 )
         V5 = DCONJG( V( 5 ) )
         T5 = TAU*DCONJG( V5 )
         DO 100 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J ) +
     $            V4*C( 4, J ) + V5*C( 5, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
            C( 4, J ) = C( 4, J ) - SUM*T4
            C( 5, J ) = C( 5, J ) - SUM*T5
  100    CONTINUE
         GO TO 410
  110    CONTINUE
*
*        Special code for 6 x 6 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         V4 = DCONJG( V( 4 ) )
         T4 = TAU*DCONJG( V4 )
         V5 = DCONJG( V( 5 ) )
         T5 = TAU*DCONJG( V5 )
         V6 = DCONJG( V( 6 ) )
         T6 = TAU*DCONJG( V6 )
         DO 120 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J ) +
     $            V4*C( 4, J ) + V5*C( 5, J ) + V6*C( 6, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
            C( 4, J ) = C( 4, J ) - SUM*T4
            C( 5, J ) = C( 5, J ) - SUM*T5
            C( 6, J ) = C( 6, J ) - SUM*T6
  120    CONTINUE
         GO TO 410
  130    CONTINUE
*
*        Special code for 7 x 7 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         V4 = DCONJG( V( 4 ) )
         T4 = TAU*DCONJG( V4 )
         V5 = DCONJG( V( 5 ) )
         T5 = TAU*DCONJG( V5 )
         V6 = DCONJG( V( 6 ) )
         T6 = TAU*DCONJG( V6 )
         V7 = DCONJG( V( 7 ) )
         T7 = TAU*DCONJG( V7 )
         DO 140 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J ) +
     $            V4*C( 4, J ) + V5*C( 5, J ) + V6*C( 6, J ) +
     $            V7*C( 7, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
            C( 4, J ) = C( 4, J ) - SUM*T4
            C( 5, J ) = C( 5, J ) - SUM*T5
            C( 6, J ) = C( 6, J ) - SUM*T6
            C( 7, J ) = C( 7, J ) - SUM*T7
  140    CONTINUE
         GO TO 410
  150    CONTINUE
*
*        Special code for 8 x 8 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         V4 = DCONJG( V( 4 ) )
         T4 = TAU*DCONJG( V4 )
         V5 = DCONJG( V( 5 ) )
         T5 = TAU*DCONJG( V5 )
         V6 = DCONJG( V( 6 ) )
         T6 = TAU*DCONJG( V6 )
         V7 = DCONJG( V( 7 ) )
         T7 = TAU*DCONJG( V7 )
         V8 = DCONJG( V( 8 ) )
         T8 = TAU*DCONJG( V8 )
         DO 160 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J ) +
     $            V4*C( 4, J ) + V5*C( 5, J ) + V6*C( 6, J ) +
     $            V7*C( 7, J ) + V8*C( 8, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
            C( 4, J ) = C( 4, J ) - SUM*T4
            C( 5, J ) = C( 5, J ) - SUM*T5
            C( 6, J ) = C( 6, J ) - SUM*T6
            C( 7, J ) = C( 7, J ) - SUM*T7
            C( 8, J ) = C( 8, J ) - SUM*T8
  160    CONTINUE
         GO TO 410
  170    CONTINUE
*
*        Special code for 9 x 9 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         V4 = DCONJG( V( 4 ) )
         T4 = TAU*DCONJG( V4 )
         V5 = DCONJG( V( 5 ) )
         T5 = TAU*DCONJG( V5 )
         V6 = DCONJG( V( 6 ) )
         T6 = TAU*DCONJG( V6 )
         V7 = DCONJG( V( 7 ) )
         T7 = TAU*DCONJG( V7 )
         V8 = DCONJG( V( 8 ) )
         T8 = TAU*DCONJG( V8 )
         V9 = DCONJG( V( 9 ) )
         T9 = TAU*DCONJG( V9 )
         DO 180 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J ) +
     $            V4*C( 4, J ) + V5*C( 5, J ) + V6*C( 6, J ) +
     $            V7*C( 7, J ) + V8*C( 8, J ) + V9*C( 9, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
            C( 4, J ) = C( 4, J ) - SUM*T4
            C( 5, J ) = C( 5, J ) - SUM*T5
            C( 6, J ) = C( 6, J ) - SUM*T6
            C( 7, J ) = C( 7, J ) - SUM*T7
            C( 8, J ) = C( 8, J ) - SUM*T8
            C( 9, J ) = C( 9, J ) - SUM*T9
  180    CONTINUE
         GO TO 410
  190    CONTINUE
*
*        Special code for 10 x 10 Householder
*
         V1 = DCONJG( V( 1 ) )
         T1 = TAU*DCONJG( V1 )
         V2 = DCONJG( V( 2 ) )
         T2 = TAU*DCONJG( V2 )
         V3 = DCONJG( V( 3 ) )
         T3 = TAU*DCONJG( V3 )
         V4 = DCONJG( V( 4 ) )
         T4 = TAU*DCONJG( V4 )
         V5 = DCONJG( V( 5 ) )
         T5 = TAU*DCONJG( V5 )
         V6 = DCONJG( V( 6 ) )
         T6 = TAU*DCONJG( V6 )
         V7 = DCONJG( V( 7 ) )
         T7 = TAU*DCONJG( V7 )
         V8 = DCONJG( V( 8 ) )
         T8 = TAU*DCONJG( V8 )
         V9 = DCONJG( V( 9 ) )
         T9 = TAU*DCONJG( V9 )
         V10 = DCONJG( V( 10 ) )
         T10 = TAU*DCONJG( V10 )
         DO 200 J = 1, N
            SUM = V1*C( 1, J ) + V2*C( 2, J ) + V3*C( 3, J ) +
     $            V4*C( 4, J ) + V5*C( 5, J ) + V6*C( 6, J ) +
     $            V7*C( 7, J ) + V8*C( 8, J ) + V9*C( 9, J ) +
     $            V10*C( 10, J )
            C( 1, J ) = C( 1, J ) - SUM*T1
            C( 2, J ) = C( 2, J ) - SUM*T2
            C( 3, J ) = C( 3, J ) - SUM*T3
            C( 4, J ) = C( 4, J ) - SUM*T4
            C( 5, J ) = C( 5, J ) - SUM*T5
            C( 6, J ) = C( 6, J ) - SUM*T6
            C( 7, J ) = C( 7, J ) - SUM*T7
            C( 8, J ) = C( 8, J ) - SUM*T8
            C( 9, J ) = C( 9, J ) - SUM*T9
            C( 10, J ) = C( 10, J ) - SUM*T10
  200    CONTINUE
         GO TO 410
      ELSE
*
*        Form  C * H, where H has order n.
*
         GO TO ( 210, 230, 250, 270, 290, 310, 330, 350,
     $           370, 390 )N
*
*        Code for general N
*
         CALL ZLARF( SIDE, M, N, V, 1, TAU, C, LDC, WORK )
         GO TO 410
  210    CONTINUE
*
*        Special code for 1 x 1 Householder
*
         T1 = ONE - TAU*V( 1 )*DCONJG( V( 1 ) )
         DO 220 J = 1, M
            C( J, 1 ) = T1*C( J, 1 )
  220    CONTINUE
         GO TO 410
  230    CONTINUE
*
*        Special code for 2 x 2 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         DO 240 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
  240    CONTINUE
         GO TO 410
  250    CONTINUE
*
*        Special code for 3 x 3 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         DO 260 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
  260    CONTINUE
         GO TO 410
  270    CONTINUE
*
*        Special code for 4 x 4 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         V4 = V( 4 )
         T4 = TAU*DCONJG( V4 )
         DO 280 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 ) +
     $            V4*C( J, 4 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
            C( J, 4 ) = C( J, 4 ) - SUM*T4
  280    CONTINUE
         GO TO 410
  290    CONTINUE
*
*        Special code for 5 x 5 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         V4 = V( 4 )
         T4 = TAU*DCONJG( V4 )
         V5 = V( 5 )
         T5 = TAU*DCONJG( V5 )
         DO 300 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 ) +
     $            V4*C( J, 4 ) + V5*C( J, 5 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
            C( J, 4 ) = C( J, 4 ) - SUM*T4
            C( J, 5 ) = C( J, 5 ) - SUM*T5
  300    CONTINUE
         GO TO 410
  310    CONTINUE
*
*        Special code for 6 x 6 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         V4 = V( 4 )
         T4 = TAU*DCONJG( V4 )
         V5 = V( 5 )
         T5 = TAU*DCONJG( V5 )
         V6 = V( 6 )
         T6 = TAU*DCONJG( V6 )
         DO 320 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 ) +
     $            V4*C( J, 4 ) + V5*C( J, 5 ) + V6*C( J, 6 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
            C( J, 4 ) = C( J, 4 ) - SUM*T4
            C( J, 5 ) = C( J, 5 ) - SUM*T5
            C( J, 6 ) = C( J, 6 ) - SUM*T6
  320    CONTINUE
         GO TO 410
  330    CONTINUE
*
*        Special code for 7 x 7 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         V4 = V( 4 )
         T4 = TAU*DCONJG( V4 )
         V5 = V( 5 )
         T5 = TAU*DCONJG( V5 )
         V6 = V( 6 )
         T6 = TAU*DCONJG( V6 )
         V7 = V( 7 )
         T7 = TAU*DCONJG( V7 )
         DO 340 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 ) +
     $            V4*C( J, 4 ) + V5*C( J, 5 ) + V6*C( J, 6 ) +
     $            V7*C( J, 7 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
            C( J, 4 ) = C( J, 4 ) - SUM*T4
            C( J, 5 ) = C( J, 5 ) - SUM*T5
            C( J, 6 ) = C( J, 6 ) - SUM*T6
            C( J, 7 ) = C( J, 7 ) - SUM*T7
  340    CONTINUE
         GO TO 410
  350    CONTINUE
*
*        Special code for 8 x 8 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         V4 = V( 4 )
         T4 = TAU*DCONJG( V4 )
         V5 = V( 5 )
         T5 = TAU*DCONJG( V5 )
         V6 = V( 6 )
         T6 = TAU*DCONJG( V6 )
         V7 = V( 7 )
         T7 = TAU*DCONJG( V7 )
         V8 = V( 8 )
         T8 = TAU*DCONJG( V8 )
         DO 360 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 ) +
     $            V4*C( J, 4 ) + V5*C( J, 5 ) + V6*C( J, 6 ) +
     $            V7*C( J, 7 ) + V8*C( J, 8 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
            C( J, 4 ) = C( J, 4 ) - SUM*T4
            C( J, 5 ) = C( J, 5 ) - SUM*T5
            C( J, 6 ) = C( J, 6 ) - SUM*T6
            C( J, 7 ) = C( J, 7 ) - SUM*T7
            C( J, 8 ) = C( J, 8 ) - SUM*T8
  360    CONTINUE
         GO TO 410
  370    CONTINUE
*
*        Special code for 9 x 9 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         V4 = V( 4 )
         T4 = TAU*DCONJG( V4 )
         V5 = V( 5 )
         T5 = TAU*DCONJG( V5 )
         V6 = V( 6 )
         T6 = TAU*DCONJG( V6 )
         V7 = V( 7 )
         T7 = TAU*DCONJG( V7 )
         V8 = V( 8 )
         T8 = TAU*DCONJG( V8 )
         V9 = V( 9 )
         T9 = TAU*DCONJG( V9 )
         DO 380 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 ) +
     $            V4*C( J, 4 ) + V5*C( J, 5 ) + V6*C( J, 6 ) +
     $            V7*C( J, 7 ) + V8*C( J, 8 ) + V9*C( J, 9 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
            C( J, 4 ) = C( J, 4 ) - SUM*T4
            C( J, 5 ) = C( J, 5 ) - SUM*T5
            C( J, 6 ) = C( J, 6 ) - SUM*T6
            C( J, 7 ) = C( J, 7 ) - SUM*T7
            C( J, 8 ) = C( J, 8 ) - SUM*T8
            C( J, 9 ) = C( J, 9 ) - SUM*T9
  380    CONTINUE
         GO TO 410
  390    CONTINUE
*
*        Special code for 10 x 10 Householder
*
         V1 = V( 1 )
         T1 = TAU*DCONJG( V1 )
         V2 = V( 2 )
         T2 = TAU*DCONJG( V2 )
         V3 = V( 3 )
         T3 = TAU*DCONJG( V3 )
         V4 = V( 4 )
         T4 = TAU*DCONJG( V4 )
         V5 = V( 5 )
         T5 = TAU*DCONJG( V5 )
         V6 = V( 6 )
         T6 = TAU*DCONJG( V6 )
         V7 = V( 7 )
         T7 = TAU*DCONJG( V7 )
         V8 = V( 8 )
         T8 = TAU*DCONJG( V8 )
         V9 = V( 9 )
         T9 = TAU*DCONJG( V9 )
         V10 = V( 10 )
         T10 = TAU*DCONJG( V10 )
         DO 400 J = 1, M
            SUM = V1*C( J, 1 ) + V2*C( J, 2 ) + V3*C( J, 3 ) +
     $            V4*C( J, 4 ) + V5*C( J, 5 ) + V6*C( J, 6 ) +
     $            V7*C( J, 7 ) + V8*C( J, 8 ) + V9*C( J, 9 ) +
     $            V10*C( J, 10 )
            C( J, 1 ) = C( J, 1 ) - SUM*T1
            C( J, 2 ) = C( J, 2 ) - SUM*T2
            C( J, 3 ) = C( J, 3 ) - SUM*T3
            C( J, 4 ) = C( J, 4 ) - SUM*T4
            C( J, 5 ) = C( J, 5 ) - SUM*T5
            C( J, 6 ) = C( J, 6 ) - SUM*T6
            C( J, 7 ) = C( J, 7 ) - SUM*T7
            C( J, 8 ) = C( J, 8 ) - SUM*T8
            C( J, 9 ) = C( J, 9 ) - SUM*T9
            C( J, 10 ) = C( J, 10 ) - SUM*T10
  400    CONTINUE
         GO TO 410
      END IF
  410 CONTINUE
      RETURN
*
*     End of ZLARFX
*
      END
c $Id: zlarfx.f 24343 2013-06-22 05:35:15Z d3y133 $

*
* $Id: DMatrix-mpi.F 22504 2012-05-20 20:46:47Z bylaska $
*

*     ***********************************************************
*     *								*
*     *   		   DMatrix library			*
*     *								*
*     *   Author - Eric Bylaska					*
*     *   date   - 5/19/06					*
*     *								*
*     ***********************************************************
c
c
c
c

*     ***********************************
*     *                                 *
*     *         DMatrix_dgemm1_rot2     *
*     *                                 *
*     ***********************************

      subroutine DMatrix_dgemm1_rot2(m,n,k,
     >                  alpha,
     >                  A,lda,ma,na,
     >                  B,ldb,mb,nb,
     >                  beta,
     >                  C,ldc,mc,nc,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  Bcol,Bwork,work1,work2)
      implicit none
      integer m,n,k
      real*8  alpha

      integer lda,ma(*),na(*)
      real*8  A(lda,*)

      integer ldb,mb(*),nb(*)
c      real*8  B(ldb,*)
      real*8  B(*)

      real*8  beta

      integer ldc,mc(*),nc(*)
      real*8  C(ldc,*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  Bcol(*),Bwork(*)
      real*8  work1(*),work2(*)

#include "mpif.h"
#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** local variables ****
      logical jeven
      integer i,j,j1,ii,jj,ne0
      integer iwrk,jcur,ierr,bshift,iwrk2
      integer request1(4),request2(4)
      integer bshift2(0:np_j)

      bshift     = 1
      bshift2(0) = 1
      do jj=1,np_j
         bshift      = bshift + na(jj)*nb(taskid_j+1)
         bshift2(jj) = bshift
      end do

*     *** collect B into columns ***
      ne0 = 0
      do i=1,np_i
         ne0 = ne0+mb(i)
      end do
      j1 = 0
      do jj=1,taskid_j
         j1 = j1 + nb(jj)
      end do
   
      bshift = 0
      iwrk2 = nb(taskid_j+1)
      ii    = 0
      do jcur=0,np_j-1
         iwrk  = na(jcur+1)
         do j=1,iwrk2
         do i=1,iwrk
            Bwork(bshift+i+(j-1)*iwrk) = B(ii+i+(j+j1-1)*ne0)
         end do
         end do
         bshift = bshift + iwrk*iwrk2
         ii     = ii     + iwrk
      end do


*     *** C = beta*C ***
c      call dscal(ldc*nc(taskid_j+1),beta,C,1)
      do j=1,nc(taskid_j+1)
         do i=1,mc(taskid_i+1)
            C(i,j) = beta*C(i,j)
         end do
      end do

      call Dmatrix_start_rot(1,
     >                       taskid_j,np_j,comm_j,
     >                       A,work1,lda,na,
     >                       request1)
      jcur = taskid_j
      iwrk = na(jcur+1)

      if ((mc(taskid_i+1).gt.0).and.
     >    (nc(taskid_j+1).gt.0).and.
     >    (iwrk.gt.0))
     >     call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >                alpha,
     >                A, ma(taskid_i+1),
     >                Bwork(bshift2(jcur)), iwrk,
     >                1.0d0,
     >                C, ldc)

      jeven = .true.
      do j=2,np_j-1
         if (jeven) then
            jeven = .false.
            jcur = mod(jcur-1+np_j,np_j)
            iwrk = na(jcur+1)
            call Dmatrix_end_rot(request1)
            call Dmatrix_start_rot(j,
     >                             taskid_j,np_j,comm_j,
     >                             A,work2,lda,na,
     >                             request2)
         if ((mc(taskid_i+1).gt.0).and.
     >       (nc(taskid_j+1).gt.0).and.
     >       (iwrk.gt.0))
     >       call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >                alpha,
     >                work1, ma(taskid_i+1),
     >                Bwork(bshift2(jcur)), iwrk,
     >                1.0d0,
     >                C, ldc)

         else
            jeven = .true.
            jcur = mod(jcur-1+np_j,np_j)
            iwrk = na(jcur+1)
            call Dmatrix_end_rot(request2)
            call Dmatrix_start_rot(j,
     >                             taskid_j,np_j,comm_j,
     >                             A,work1,lda,na,
     >                             request1)
            if ((mc(taskid_i+1).gt.0).and.
     >          (nc(taskid_j+1).gt.0).and.
     >          (iwrk.gt.0))
     >          call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >                alpha,
     >                work2, ma(taskid_i+1),
     >                Bwork(bshift2(jcur)), iwrk,
     >                1.0d0,
     >                C, ldc)

         end if 
      end do
      if (jeven) then
         jcur = mod(jcur-1+np_j,np_j)
         iwrk = na(jcur+1)
         call Dmatrix_end_rot(request1)
         if ((mc(taskid_i+1).gt.0).and.
     >       (nc(taskid_j+1).gt.0).and.
     >       (iwrk.gt.0))
     >       call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >             alpha,
     >             work1, ma(taskid_i+1),
     >             Bwork(bshift2(jcur)), iwrk,
     >             1.0d0,
     >             C, ldc)

      else
         jcur = mod(jcur-1+np_j,np_j)
         iwrk = na(jcur+1)
         call Dmatrix_end_rot(request2)
         if ((mc(taskid_i+1).gt.0).and.
     >       (nc(taskid_j+1).gt.0).and.
     >       (iwrk.gt.0))
     >       call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >             alpha,
     >             work2, ma(taskid_i+1),
     >             Bwork(bshift2(jcur)), iwrk,
     >             1.0d0,
     >             C, ldc)
      end if 
      return
      end





*     ***********************************
*     *                                 *
*     *         DMatrix_dgemm1_rot      *
*     *                                 *
*     ***********************************

      subroutine DMatrix_dgemm1_rot(m,n,k,
     >                  alpha,
     >                  A,lda,ma,na,
     >                  B,ldb,mb,nb,
     >                  beta,
     >                  C,ldc,mc,nc,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  Bcol,Bwork,work1,work2)
      implicit none
      integer m,n,k
      real*8  alpha

      integer lda,ma(*),na(*)
      real*8  A(lda,*)

      integer ldb,mb(*),nb(*)
c      real*8  B(ldb,*)
      real*8  B(*)

      real*8  beta

      integer ldc,mc(*),nc(*)
      real*8  C(ldc,*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  Bcol(*),Bwork(*)
      real*8  work1(*),work2(*)

#include "mpif.h"
#ifdef MPI4
#include "stupid_mpi4.fh"
#endif


*     **** local variables ****
      logical jeven
      integer i,j,ii,jj,mbmax,nbmax,ne0
      integer iwrk,jcur,ierr,bshift,iwrk2
      integer request1(4),request2(4)
      integer bshift2(0:np_j)

      bshift     = 1
      bshift2(0) = 1
      do jj=1,np_j
         bshift      = bshift + na(jj)*nb(taskid_j+1)
         bshift2(jj) = bshift
      end do

*     *** collect B into columns ***
      ne0 = 0
      mbmax = 0
      do i=1,np_i
         if (mb(i).gt.mbmax) mbmax = mb(i)
         ne0 = ne0+mb(i)
      end do
      nbmax = 0
      do j=1,np_j
         if (nb(j).gt.nbmax) nbmax = nb(j)
      end do
      if (np_i.gt.1) then


         do j=1,nb(taskid_j+1)


          !*** Allgather is flaky on my mac laptop ***
          call dcopy(ne0,0.0,0,Bcol(1+(j-1)*ne0),1)
          bshift = 0
          do ii=1,taskid_i
             bshift = bshift + mb(ii)
          end do
          do i=1,mb(taskid_i+1)
            Bcol(bshift+i+(j-1)*ne0) = B(i+(j-1)*mb(taskid_i+1))
          end do
          call D3dB_Vector_SumAll(ne0,Bcol(1+(j-1)*ne0))
         end do

         bshift = 0
         iwrk2 = nb(taskid_j+1)
         ii    = 0
         do jcur=0,np_j-1
            iwrk  = na(jcur+1)
            do j=1,iwrk2
            do i=1,iwrk
               Bwork(bshift+i+(j-1)*iwrk) = Bcol(ii+i+(j-1)*ne0)

            end do
            end do
            bshift = bshift + iwrk*iwrk2
            ii     = ii     + iwrk
         end do
      else
         bshift = 0
         iwrk2 = nb(taskid_j+1)
         ii    = 0
         do jcur=0,np_j-1
            iwrk  = na(jcur+1)
            do j=1,iwrk2
            do i=1,iwrk
               Bwork(bshift+i+(j-1)*iwrk) = B(ii+i+(j-1)*ne0)
            end do
            end do
            bshift = bshift + iwrk*iwrk2
            ii     = ii     + iwrk
         end do
      end if



*     *** C = beta*C ***
c      call dscal(ldc*nc(taskid_j+1),beta,C,1)
      do j=1,nc(taskid_j+1)
         do i=1,mc(taskid_i+1)
            C(i,j) = beta*C(i,j)
         end do
      end do

      call Dmatrix_start_rot(1,
     >                       taskid_j,np_j,comm_j,
     >                       A,work1,lda,na,
     >                       request1)
      jcur = taskid_j
      iwrk = na(jcur+1)

      if ((mc(taskid_i+1).gt.0).and.
     >    (nc(taskid_j+1).gt.0).and.
     >    (iwrk.gt.0))
     >     call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >                alpha,
     >                A, ma(taskid_i+1),
     >                Bwork(bshift2(jcur)), iwrk,
     >                1.0d0,
     >                C, ldc)

      jeven = .true.
      do j=2,np_j-1
         if (jeven) then
            jeven = .false.
            jcur = mod(jcur-1+np_j,np_j)
            iwrk = na(jcur+1)
            call Dmatrix_end_rot(request1)
            call Dmatrix_start_rot(j,
     >                             taskid_j,np_j,comm_j,
     >                             A,work2,lda,na,
     >                             request2)
         if ((mc(taskid_i+1).gt.0).and.
     >       (nc(taskid_j+1).gt.0).and.
     >       (iwrk.gt.0))
     >       call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >                alpha,
     >                work1, ma(taskid_i+1),
     >                Bwork(bshift2(jcur)), iwrk,
     >                1.0d0,
     >                C, ldc)

         else
            jeven = .true.
            jcur = mod(jcur-1+np_j,np_j)
            iwrk = na(jcur+1)
            call Dmatrix_end_rot(request2)
            call Dmatrix_start_rot(j,
     >                             taskid_j,np_j,comm_j,
     >                             A,work1,lda,na,
     >                             request1)
            if ((mc(taskid_i+1).gt.0).and.
     >          (nc(taskid_j+1).gt.0).and.
     >          (iwrk.gt.0))
     >          call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >                alpha,
     >                work2, ma(taskid_i+1),
     >                Bwork(bshift2(jcur)), iwrk,
     >                1.0d0,
     >                C, ldc)

         end if 
      end do
      if (jeven) then
         jcur = mod(jcur-1+np_j,np_j)
         iwrk = na(jcur+1)
         call Dmatrix_end_rot(request1)
         if ((mc(taskid_i+1).gt.0).and.
     >       (nc(taskid_j+1).gt.0).and.
     >       (iwrk.gt.0))
     >       call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >             alpha,
     >             work1, ma(taskid_i+1),
     >             Bwork(bshift2(jcur)), iwrk,
     >             1.0d0,
     >             C, ldc)

      else
         jcur = mod(jcur-1+np_j,np_j)
         iwrk = na(jcur+1)
         call Dmatrix_end_rot(request2)
         if ((mc(taskid_i+1).gt.0).and.
     >       (nc(taskid_j+1).gt.0).and.
     >       (iwrk.gt.0))
     >       call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >             alpha,
     >             work2, ma(taskid_i+1),
     >             Bwork(bshift2(jcur)), iwrk,
     >             1.0d0,
     >             C, ldc)
      end if 
      return
      end


      subroutine DMatrix_Bwork_copy(m,n,A,lda,ii,B,ldb)
      implicit none
      integer n,m
      integer lda,ii,ldb
      real*8 A(LDA,*)
      real*8 B(LDB,*)

*     *** local variables ***
      integer i,j

      do j=1,n
         do i=1,m
            B(i,j) = A(ii+i,j)
         end do
      end do
      return
      end

*     ***********************************
*     *                                 *
*     *         DMatrix_start_rot       *
*     *                                 *
*     ***********************************

      subroutine DMatrix_start_rot(j,
     >                             taskid_j,np_j,comm_j,
     >                             A,W,lda,na,
     >                             request)
      implicit none
      integer j
      integer taskid_j,np_j,comm_j
      real*8 A(*),W(*)
      integer lda,na(*)
      integer request(*)

#include "mpif.h"
#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

*     **** local variables ****
      integer proc_to,proc_from,msgtype,amsglen,wmsglen,mpierr

      proc_to   = mod(taskid_j+j,np_j)
      proc_from = mod(taskid_j-j+np_j,np_j)
      msgtype   = j
      amsglen = lda*na(taskid_j+1)
      wmsglen = lda*na(proc_from+1)

#ifdef MPI4
            if (wmsglen.gt.0) then
               stupid_msglen = wmsglen
               stupid_type   = msgtype
               stupid_taskid = proc_from
               call MPI_IRECV(W,
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_comm_j,
     >                    stupid_request,stupid_ierr)
               request(1) = stupid_request
               request(3) = 1
            else
               request(3) = 0
            end if

            if (amsglen.gt.0) then
               stupid_msglen = amsglen
               stupid_type   = msgtype
               stupid_taskid = proc_to
               call MPI_ISEND(A,
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_comm_j,
     >                     stupid_request,stupid_ierr)
               request(2) = stupid_request
               request(4) = 1
            else
               request(4) = 0
            end if
#else
            if (wmsglen.gt.0) then
               call MPI_IRECV(W,wmsglen,MPI_DOUBLE_PRECISION,
     >                    proc_from,
     >                    msgtype,comm_j,
     >                    request(1),mpierr)
               request(3) = 1
            else
               request(3) = 0
            end if
            if (amsglen.gt.0) then
               call MPI_ISEND(A,amsglen,MPI_DOUBLE_PRECISION,
     >                     proc_to,
     >                     msgtype,comm_j,
     >                     request(2),mpierr)
               request(4) = 1
            else
               request(4) = 0
            end if
#endif

      if ((request(3).eq.1).and.(request(4).eq.1)) then
         request(3) = 1
      else if (request(3).eq.1) then
         request(3) = 2
      else if (request(4).eq.1) then
         request(3) = 3
      else 
         request(3) = 4
      end if

      return
      end

*     ***********************************
*     *                                 *
*     *         DMatrix_end_rot         *
*     *                                 *
*     ***********************************

      subroutine DMatrix_end_rot(request)
      implicit none
      integer request(*)

*     **** wait for completion of mp_send, also do a sync ****
      if (request(3).eq.1) then
         call Parallel_mpiWaitAll(2,request)
      else if (request(3).eq.2) then
         call Parallel_mpiWaitAll(1,request)
      else if (request(3).eq.3) then
         call Parallel_mpiWaitAll(1,request(2))
      endif

      return
      end





*     ***********************************
*     *                                 *
*     *         DMatrix_dgemm1          *
*     *                                 *
*     ***********************************

      subroutine DMatrix_dgemm1(m,n,k,nblock,
     >                  alpha,
     >                  A,lda,ma,na,
     >                  B,ldb,mb,nb,
     >                  beta,
     >                  C,ldc,mc,nc,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer m,n,k,nblock
      real*8  alpha

      integer lda,ma(*),na(*)
      real*8  A(lda,*)

      integer ldb,mb(*),nb(*)
      real*8  B(ldb,*)

      real*8  beta

      integer ldc,mc(*),nc(*)
      real*8  C(ldc,*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  work1(*),work2(*)


#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


*     **** local variables ****
      logical docalc1,docalc2
      integer i,j,ii,jj
      integer kk,iwrk,icur,jcur,ierr,shift


      do j=1,nc(taskid_j+1)
         do i=1,mc(taskid_i+1)
            C(i,j) = beta*C(i,j)
         end do
      end do

      ii = 0
      jj = 0
      kk = 0
      icur = 0
      jcur = 0
c     **** loop over all row pannels of C ***
      do while (kk.lt.k)
         iwrk = min(nblock, mb(icur+1)-ii)
         iwrk = min(iwrk,   na(jcur+1)-jj)


*        **** pack current iwrk columns of A into work1 ***
         if (taskid_j.eq.jcur) then
            call dlacpy("G", ma(taskid_i+1),iwrk,
     >                   A(1,jj+1), lda,
     >                   work1,     ma(taskid_i+1))
         end if

*        **** pack current iwrk rows of B into work2 ***
         if (taskid_i.eq.icur) then
            call dlacpy("G", iwrk,nb(taskid_j+1),
     >                   B(ii+1,1), ldb,
     >                   work2,  iwrk)
         end if

#ifdef MPI4
c        **** broadcast work1  within my row ***
         stupid_msglen = iwrk*ma(taskid_i+1)
         stupid_taskid = jcur
         call MPI_Bcast(work1,stupid_msglen,stupid_double,
     >                  stupid_taskid,stupid_comm_j,stupid_ierr)

c        **** broadcast work2  within my column ***
         stupid_msglen = iwrk*nb(taskid_j+1)
         stupid_taskid = icur
         call MPI_Bcast(work2,stupid_msglen,stupid_double,
     >                  stupid_taskid,stupid_comm_i,stupid_ierr)
#else
c        **** broadcast work1  within my row ***
         call MPI_Bcast(work1,iwrk*ma(taskid_i+1),MPI_DOUBLE_PRECISION,
     >                  jcur,comm_j,ierr)

c        **** broadcast work2  within my column ***
         call MPI_Bcast(work2,iwrk*nb(taskid_j+1),MPI_DOUBLE_PRECISION,
     >                  icur,comm_i,ierr)
#endif


         if ((iwrk.gt.0)          .and.
     >       (mc(taskid_i+1).gt.0).and.
     >       (nc(taskid_j+1).gt.0))
     >     call dgemm('N','N',mc(taskid_i+1),nc(taskid_j+1),iwrk,
     >                alpha,
     >                work1, ma(taskid_i+1),
     >                work2, iwrk,
     >                1.0d0,
     >                C, ldc)


         ii = ii + iwrk
         jj = jj + iwrk
         kk = kk + iwrk

         if (jj.ge.na(jcur+1)) then
           jcur = jcur + 1
           jj   = 0
         end if
         if (ii.ge.mb(icur+1)) then
           icur = icur + 1
           ii   = 0
         end if

      end do

      return
      end


*     ***********************************
*     *                                 *
*     *         DMatrix_dgemm2          *
*     *                                 *
*     ***********************************
      subroutine DMatrix_dgemm2(m,n,k,nblock,
     >                  alpha,
     >                  A,lda,ma,na,
     >                  B,ldb,mb,nb,
     >                  beta,
     >                  C,ldc,mc,nc,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer m,n,k,nblock
      real*8  alpha

      integer lda,ma(*),na(*)
      real*8  A(lda,*)

      integer ldb,mb(*),nb(*)
      real*8  B(ldb,*)

      real*8  beta

      integer ldc,mc(*),nc(*)
      real*8  C(ldc,*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  work1(*),work2(*)


#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


*     **** local variables ****
      logical docalc1,docalc2
      integer i,j,ii,jj
      integer kk,iwrk,icur,jcur,ierr,shift

      do j=1,nc(taskid_j+1)
         do i=1,mc(taskid_i+1)
            C(i,j) = beta*C(i,j)
         end do
      end do

      ii = 0
      jj = 0
      kk = 0
      icur = 0
      jcur = 0
c     **** loop over all row pannels of C ***
      do while (kk.lt.m)
         iwrk = min(nblock, mc(icur+1)-ii)
         iwrk = min(iwrk,   na(jcur+1)-jj)


*        **** iwrk*nc(taskid_j+1) submatrix !=0 ****
         if (ma(taskid_i+1).gt.0) then

*           **** pack current iwrk columns of A into work1 ***
            if (taskid_j.eq.jcur) then
               call dlacpy("G", ma(taskid_i+1),iwrk,
     >                   A(1,jj+1), lda,
     >                   work1,     ma(taskid_i+1))
            end if

c           **** broadcast work1  within my row ***
#ifdef MPI4
            stupid_msglen = iwrk*ma(taskid_i+1)
            stupid_taskid = jcur
            call MPI_Bcast(work1,stupid_msglen,
     >                     stupid_double,stupid_taskid,
     >                     stupid_comm_j,stupid_ierr)
#else
            call MPI_Bcast(work1,iwrk*ma(taskid_i+1),
     >                     MPI_DOUBLE_PRECISION,jcur,comm_j,ierr)
#endif


c            if ((iwrk.gt.0)          .and.
c     >          (nb(taskid_j+1).gt.0).and.
c     >          (ma(taskid_i+1).gt.0))
            if ((iwrk.gt.0)          .and.
     >          (nb(taskid_j+1).gt.0))
     >        call dgemm('T','N',iwrk,nb(taskid_j+1),ma(taskid_i+1),
     >                   alpha,
     >                   work1, ma(taskid_i+1),
     >                   B, ldb,
     >                   0.0d0,
     >                   work2, iwrk)

*        **** iwrk*nc(taskid_j+1) submatrix ==0 ****
         else
            call dcopy(nc(taskid_j+1)*iwrk,0.0d0,0,work2,1)
         end if


c        **** summ to node that holds current rows of C ****
#ifdef MPI4
         stupid_msglen = nc(taskid_j+1)*iwrk
         stupid_taskid = icur
         call MPI_Reduce(work2,work1,stupid_msglen,
     >                   stupid_double,stupid_sum,
     >                   stupid_taskid,stupid_comm_i,stupid_ierr)
#else
         call MPI_Reduce(work2,work1,nc(taskid_j+1)*iwrk,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,icur,comm_i,ierr)
#endif


c        **** add to current rows of C ****
         if (taskid_i.eq.icur) then
            shift = 1
            do i=ii,(ii+iwrk-1)
               call daxpy(nc(taskid_j+1),1.0d0,work1(shift),iwrk,
     >                                    C(i+1,1),mc(taskid_i+1))
               shift = shift + 1
            end do
         end if

         ii = ii + iwrk
         jj = jj + iwrk
         kk = kk + iwrk

         if (jj.ge.na(jcur+1)) then
           jcur = jcur + 1
           jj   = 0
         end if
         if (ii.ge.mc(icur+1)) then
           icur = icur + 1
           ii   = 0
         end if

      end do


      return
      end


*     ***********************************
*     *                                 *
*     *         DMatrix_dgemm3          *
*     *                                 *
*     ***********************************

      subroutine DMatrix_dgemm3(m,n,k,nblock,
     >                  alpha,
     >                  A,lda,ma,na,
     >                  B,ldb,mb,nb,
     >                  beta,
     >                  C,ldc,mc,nc,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer m,n,k,nblock
      real*8  alpha

      integer lda,ma(*),na(*)
      real*8  A(lda,*)

      integer ldb,mb(*),nb(*)
      real*8  B(ldb,*)

      real*8  beta

      integer ldc,mc(*),nc(*)
      real*8  C(ldc,*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  work1(*),work2(*)

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


*     **** local variables ****
      logical docalc1,docalc2
      integer i,j,ii,jj
      integer kk,iwrk,icur,jcur,ierr,shift
      real*8  dum


      do j=1,nc(taskid_j+1)
         do i=1,mc(taskid_i+1)
            C(i,j) = beta*C(i,j)
         end do
      end do

      ii = 0
      jj = 0
      kk = 0
      icur = 0
      jcur = 0
      do while (kk.lt.n)
         iwrk = min(nblock, mb(icur+1)-ii)
         iwrk = min(iwrk,   nc(jcur+1)-jj)


         if (taskid_i.eq.icur) then
            call dlacpy("G", iwrk,nb(taskid_j+1),
     >                   B(ii+1,1), ldb,
     >                   work2,     iwrk)
         end if

#ifdef MPI4
        stupid_msglen = iwrk*nb(taskid_j+1)
        stupid_taskid = icur
        call MPI_Bcast(work2,stupid_msglen,stupid_double,
     >                  stupid_taskid,stupid_comm_i,stupid_ierr)
#else
        call MPI_Bcast(work2,iwrk*nb(taskid_j+1),MPI_DOUBLE_PRECISION,
     >                  icur,comm_i,ierr)
#endif

         if ((iwrk.gt.0)          .and.
     >       (na(taskid_j+1).gt.0).and.
     >       (mc(taskid_i+1).gt.0))
     >      call dgemm('N','T',mc(taskid_i+1),iwrk,na(taskid_j+1),
     >              alpha,
     >              A, lda,
     >              work2, iwrk,
     >              0.0d0,
     >              work1, mc(taskid_i+1))

#ifdef MPI4
        stupid_msglen = mc(taskid_i+1)*iwrk
        stupid_taskid = jcur
        call MPI_Reduce(work1,work2,stupid_msglen,stupid_double,
     >                  stupid_sum,stupid_taskid,
     >                  stupid_comm_j,stupid_ierr)
#else
        call MPI_Reduce(work1,work2,mc(taskid_i+1)*iwrk,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,jcur,comm_j,ierr)
#endif


         if (taskid_j.eq.jcur) then
            shift = 1
            do j=jj,(jj+iwrk-1)
               call daxpy(mc(taskid_i+1),
     >                    1.0d0,
     >                    work2(shift),1,
     >                    C(1,j+1),1)
               shift = shift + mc(taskid_i+1)
            end do
         end if

         ii = ii + iwrk
         jj = jj + iwrk
         kk = kk + iwrk

         if (jj.ge.nc(jcur+1)) then
           jcur = jcur + 1
           jj   = 0
         end if
         if (ii.ge.mb(icur+1)) then
           icur = icur + 1
           ii   = 0
         end if

      end do


      return
      end





*     ***********************************
*     *                                 *
*     *         DMatrix_tqliq           *
*     *                                 *
*     ***********************************

      subroutine DMatrix_tqliq(n,eig,tu,
     >                  Q,ldq,mq,nq,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer n

      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*),eig(*),tu(*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j
      real*8  work1(*),work2(*)

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variables ****
      integer MAXITER
      parameter (MAXITER = 100)
      real*8  tole
      parameter (tole=1.0d-15)

      logical notdone
      integer i,j,l,m,iter
      integer ii,jj0,jj1,jcur0,jcur1,ierr,istat
      real*8  b,c,f,g,p,r,s


      do l=1,n-1
         iter = 0

         do m=l,n-1
         if (dabs(tu(m)).lt.tole) go to 2
         end do
         m = n
  2      continue
         if (m.eq.l) then
            notdone = .false.
         else
            notdone = .true.
         end if
         do while ((iter.lt.MAXITER).and.(notdone))
            g = (eig(l+1)-eig(l))/(2.0d0*tu(l))
            r = dsqrt(g**2+1.0d0)
            g = eig(m)-eig(l)+tu(l)/(g+dsign(r,g))
            s = 1.0d0
            c = 1.0d0
            p = 0.0d0
            do i = m-1,l,-1
               f = s*tu(i)
               b = c*tu(i)
               if (dabs(f).ge.dabs(g)) then
                  c = g/f
                  r = dsqrt(c**2+1.0d0)
                  tu(i+1) = f*r
                  s = 1/r
                  c = c*s
               else
                  s = f/g
                  r = dsqrt(s**2+1.0d0)
                  tu(i+1) = g*r
                  c = 1/r
                  s = s*c
               end if
               g = eig(i+1)-p
               r = (eig(i)-g)*s + 2.0d0*c*b
               p = s*r
               eig(i+1) = g+p
               g = c*r-b


*              **** update eigenvectors ****
               jcur0 = 0
               jj0   = 1
               do j=1,i-1
                 jj0 = jj0 + 1
                 if (jj0.gt.nq(jcur0+1)) then
                    jcur0 = jcur0 + 1
                    jj0   = 1
                 end if
               end do
               jcur1 = jcur0
               jj1   = jj0 + 1
               if (jj1.gt.nq(jcur1+1)) then
                  jcur1 = jcur1 + 1
                  jj1   = 1
               end if

               if (jcur0.eq.taskid_j)
     >             call dcopy(mq(taskid_i+1),Q(1,jj0),1,work1,1)
               if (jcur1.eq.taskid_j)
     >             call dcopy(mq(taskid_i+1),Q(1,jj1),1,work2,1)

#ifdef MPI4
               stupid_msglen = mq(taskid_i+1)
               stupid_taskid = jcur0
               stupid_type   = jcur1
               call MPI_Bcast(work1,stupid_msglen,stupid_double,
     >                  stupid_taskid,stupid_comm_j,stupid_ierr)
               call MPI_Bcast(work2,stupid_msglen,stupid_double,
     >                  stupid_type,stupid_comm_j,stupid_ierr)
#else
               call MPI_Bcast(work1,mq(taskid_i+1),MPI_DOUBLE_PRECISION,
     >                  jcur0,comm_j,ierr)
               call MPI_Bcast(work2,mq(taskid_i+1),MPI_DOUBLE_PRECISION,
     >                  jcur1,comm_j,ierr)
#endif

               if (jcur0.eq.taskid_j) then
                  do ii=1,mq(taskid_i+1)
                    Q(ii,jj0) = c*Q(ii,jj0) - s*work2(ii)
                  end do
               end if

               if (jcur1.eq.taskid_j) then
                  do ii=1,mq(taskid_i+1)
                    Q(ii,jj1) = c*Q(ii,jj1) + s*work1(ii)
                  end do
               end if

            end do
            eig(l) = eig(l) - p
            tu(l)  = g
            tu(m)  = 0.0d0


            do m=l,n-1
            if (dabs(tu(m)).lt.tole) go to 3
            end do
            m = n
  3         continue
            if (m.eq.l) then
               notdone = .false.
            else
               notdone = .true.
            end if

            iter = iter + 1
         end do

      end do

      return
      end



*     ***********************************
*     *                                 *
*     *         DMatrix_houseq          *
*     *                                 *
*     ***********************************
      subroutine DMatrix_houseq(jcol,
     >                  n,
     >                  A,V,Q,lda,ma,na,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer jcol,n

      integer lda,ma(*),na(*)
      real*8  A(lda,*),V(lda,*),Q(lda,*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  work1(*),work2(*)
      real*8 VV(7,7),VV2(7,7)

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variables ****
      integer i,j,ii,jj
      integer kk,iwrk,icur,jcur,ierr,shift
      integer ii0,icur0,ii1,icur1,ii2,icur2
      integer jj0,jcur0,jj1,jcur1
      real*8  beta,mu0,mu,v20,v2

      call dcopy(ma(taskid_i+1)*na(taskid_j+1),0.0d0,0,V,1)

      jcur0 = 0
      jj0   = 1
      do j=1,jcol-1
        jj0 = jj0 + 1
        if (jj0.gt.na(jcur0+1)) then
           jcur0 = jcur0 + 1
           jj0 = 1
        end if
      end do
      jcur1 = jcur0
      jj1   = jj0 + 1
      if (jj1.gt.na(jcur1+1)) then
           jcur1 = jcur1 + 1
           jj1 = 1
      end if

      icur0 = 0
      ii0   = 1
      do i=1,jcol-1
        ii0 = ii0 + 1
        if (ii0.gt.ma(icur0+1)) then
           icur0 = icur0 + 1
           ii0 = 1
        end if
      end do
      icur1 = icur0
      ii1   = ii0 + 1
      if (ii1.gt.ma(icur1+1)) then
           icur1 = icur1 + 1
           ii1 = 1
      end if
      icur2 = icur1
      ii2   = ii1 + 1
      if (ii2.gt.ma(icur2+1)) then
           icur2 = icur2 + 1
           ii2 = 1
      end if

      if (jcur0.eq.taskid_j) then

         icur = icur1
         ii   = ii1
         do i=jcol+1,n
            if (icur.eq.taskid_i) V(ii,jj0) = A(ii,jj0)
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do


         mu0 = 0.0d0
         icur = icur1
         ii   = ii1
         do i=jcol+1,n
            if (icur.eq.taskid_i) mu0 = mu0 + V(ii,jj0)**2
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
#ifdef MPI4
         stupid_msglen = 1
         stupid_taskid = icur1
         call MPI_AllReduce(mu0,mu,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_comm_i,stupid_ierr)
#else
         call MPI_AllReduce(mu0,mu,1,
     >                      MPI_DOUBLE_PRECISION,MPI_SUM,comm_i,ierr)
#endif
         mu = dsqrt(mu)


         if (mu.ne.0.0d0) then
           if (icur1.eq.taskid_i)
     >        beta = V(ii1,jj0) + dsign(mu,V(ii1,jj0))
#ifdef MPI4
           stupid_msglen = 1
           stupid_taskid = icur1
           call MPI_Bcast(beta,stupid_msglen,stupid_double,
     >                    stupid_taskid,stupid_comm_i,stupid_ierr)
#else
           call MPI_Bcast(beta,1,MPI_DOUBLE_PRECISION,
     >                  icur1,comm_i,ierr)
#endif

           icur = icur2
           ii   = ii2
           do i=jcol+2,n
              if (icur.eq.taskid_i) V(ii,jj0) = V(ii,jj0)/beta
              ii = ii + 1
              if (ii.gt.ma(icur+1)) then
                 icur = icur + 1
                 ii = 1
              end if
           end do
         end if
         if (icur1.eq.taskid_i)  V(ii1,jj0) = 1.0d0
         if (icur0.eq.taskid_i)  V(ii0,jj0) = 0.0d0

         v20 = 0.0d0
         icur = icur0
         ii   = ii0
         do i=jcol,n
            if (icur.eq.taskid_i) v20 = v20 + V(ii,jj0)**2
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
#ifdef MPI4
         stupid_msglen = 1
         call MPI_AllReduce(v20,v2,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_comm_i,stupid_ierr)
#else
         call MPI_AllReduce(v20,v2,1,
     >                      MPI_DOUBLE_PRECISION,MPI_SUM,comm_i,ierr)
#endif
         v2 = 2.0d0/v2
      end if
#ifdef MPI4
      stupid_msglen = 1
      stupid_taskid = jcur0
      call MPI_Bcast(v2,stupid_msglen,stupid_double,
     >               stupid_taskid,stupid_comm_j,stupid_ierr)
#else
      call MPI_Bcast(v2,1,MPI_DOUBLE_PRECISION,
     >               jcur0,comm_j,ierr)
#endif

      call DMatrix_eye(n,n,1.0d0,Q,lda,ma,na,taskid_i,taskid_j)
      call nwpw_timing_start(28)
      call DMatrix_dgemm3(n,n,n,64,
     >             (-v2),
     >             V,ma(taskid_i+1), ma,na,
     >             V,ma(taskid_i+1), ma,na,
     >             1.0d0,
     >             Q,ma(taskid_i+1), ma,na,
     >             taskid_i,taskid_j,
     >             np_i,np_j,
     >             comm_i, comm_j,
     >             work1,work2)
      call nwpw_timing_end(28)

      do j=1,7
         do i=1,7
            VV(i,j) = 0.0d0
         end do
      end do

      jcur = 0
      jj   = 1
      do j=1,7
         icur = 0
         ii   = 1
         do i=1,7
            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               VV(i,j) = V(ii,jj)
            end if
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
         jj = jj + 1
         if (jj.gt.na(jcur+1)) then
            jcur = jcur + 1
            jj = 1
         end if
      end do
#ifdef MPI4
      stupid_msglen = 7*7
      call MPI_AllReduce(VV,VV2,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_world,stupid_ierr)
#else
      call MPI_AllReduce(VV,VV2,7*7,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,
     >                   MPI_COMM_WORLD,ierr)
#endif
      
      if ((taskid_i.eq.0).and.(taskid_j.eq.0)) then
         write(*,*) "jcol=",jcol,"  V="
         do i=1,7
            write(*,'(10F12.3)') (VV2(i,j),j=1,7)
         end do
      end if

      do j=1,7
         do i=1,7
            VV(i,j) = 0.0d0
         end do
      end do

      jcur = 0
      jj   = 1
      do j=1,7
         icur = 0
         ii   = 1
         do i=1,7
            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               VV(i,j) = Q(ii,jj)
            end if
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
         jj = jj + 1
         if (jj.gt.na(jcur+1)) then
            jcur = jcur + 1
            jj = 1
         end if
      end do
#ifdef MPI4
      stupid_msglen = 7*7
      call MPI_AllReduce(VV,VV2,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_world,stupid_ierr)
#else
      call MPI_AllReduce(VV,VV2,7*7,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,
     >                   MPI_COMM_WORLD,ierr)
#endif
      


      if ((taskid_i.eq.0).and.(taskid_j.eq.0)) then
         write(*,*) "Q="
         do i=1,7
            write(*,'(10F12.3)') (VV2(i,j),j=1,7)
         end do
      end if


      return
      end


*     ***********************************
*     *                                 *
*     *         DMatrix_eigsrtq         *
*     *                                 *
*     ***********************************
      subroutine DMatrix_eigsrtq(n,eig,
     >                  Q,ldq,mq,nq,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer n

      integer ldq,mq(*),nq(*)
      real*8  Q(ldq,*),eig(*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j
      real*8  work1(*),work2(*)

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


*     **** local variables ****
      logical notdone
      integer i,j,k,l,m,iter
      integer ii,jj0,jj1,jcur0,jcur1,ierr,istat
      real*8  b,c,f,g,p,r,s


      do i=1,n-1
         k = i
         p = eig(i)
         do j=i+1,n
            if (eig(j).ge.p) then
               k = j
               p = eig(j)
            end if
         end do
         if (k.ne.i) then
            eig(k) = eig(i)
            eig(i) = p

            jcur0 = 0
            jj0   = 1
            do j=1,i-1
               jj0 = jj0 + 1
               if (jj0.gt.nq(jcur0+1)) then
                  jcur0 = jcur0 + 1
                  jj0 = 1
               end if
            end do
            jcur1 = 0
            jj1   = 1
            do j=1,k-1
               jj1 = jj1 + 1
               if (jj1.gt.nq(jcur1+1)) then
                  jcur1 = jcur1 + 1
                  jj1 = 1
               end if
            end do


            if (jcur0.eq.taskid_j)
     >         call dcopy(mq(taskid_i+1),Q(1,jj0),1,work1,1)
            if (jcur1.eq.taskid_j)
     >         call dcopy(mq(taskid_i+1),Q(1,jj1),1,work2,1)

#ifdef MPI4
            stupid_msglen = mq(taskid_i+1)
            stupid_taskid = jcur0
            stupid_type   = jcur1
            call MPI_Bcast(work1,stupid_msglen,stupid_double,
     >                     stupid_taskid,stupid_comm_j,stupid_ierr)
            call MPI_Bcast(work2,stupid_msglen,stupid_double,
     >                     stupid_type,stupid_comm_j,stupid_ierr)
#else
            call MPI_Bcast(work1,mq(taskid_i+1),MPI_DOUBLE_PRECISION,
     >                     jcur0,comm_j,ierr)
            call MPI_Bcast(work2,mq(taskid_i+1),MPI_DOUBLE_PRECISION,
     >                     jcur1,comm_j,ierr)
#endif

            if (jcur0.eq.taskid_j)
     >         call dcopy(mq(taskid_i+1),work2,1,Q(1,jj0),1)
            if (jcur1.eq.taskid_j)
     >         call dcopy(mq(taskid_i+1),work1,1,Q(1,jj1),1)

         end if

      end do

      return
      end


*     ***********************************
*     *                                 *
*     *         DMatrix_getdiags        *
*     *                                 *
*     ***********************************
      subroutine DMatrix_getdiags(n,eig,tu,
     >                  A,lda,ma,na,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i,comm_j,
     >                  work1)
      implicit none
      integer n

      integer lda,ma(*),na(*)
      real*8  A(lda,*),eig(*),tu(*)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j
      real*8  work1(*)

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif



*     **** local variables ****
      integer i,j,ii,jj,is,ie,js,je
      integer icur,jcur,ierr

*     **************************
*     **** gather diagonals ****
*     **************************
      call dcopy(n,0.0d0,0,work1,1)
      call dcopy(n,0.0d0,0,eig,1)
      js = 1
      do jcur = 0,taskid_j-1
        js = js + na(jcur+1)
      end do
      jcur = taskid_j
      je   = js-1 + na(jcur+1)
      jj   = 1
      do j=js,je

         icur=0
         ii = 1
         do i=1,j-1
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
         work1(j) = A(ii,jj)

#ifdef MPI4
         stupid_msglen = 1
         stupid_taskid = icur
         call MPI_Bcast(work1(j),stupid_msglen,stupid_double,
     >                  stupid_taskid,stupid_comm_i,stupid_ierr)
#else
         call MPI_Bcast(work1(j),1,MPI_DOUBLE_PRECISION,
     >                  icur,comm_i,ierr)
#endif
         jj = jj + 1
         if (jj.gt.na(jcur+1)) then
            jcur = jcur + 1
            jj = 1
         end if
      end do

#ifdef MPI4
      stupid_msglen = n
      call MPI_AllReduce(work1,eig,stupid_msglen,
     >                   stupid_double,stupid_sum,
     >                   stupid_comm_j,stupid_ierr)
#else
      call MPI_AllReduce(work1,eig,n,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,comm_j,ierr)
#endif


*     ******************************
*     **** gather off-diagonals ****
*     ******************************
      call dcopy(n,0.0d0,0,work1,1)
      call dcopy(n,0.0d0,0,tu,1)
      is = 1
      do icur = 0,taskid_i-1
        is = is + ma(icur+1)
      end do
      icur = taskid_i
      ie   = is-1 + ma(icur+1)
      if (ie.ge.n) ie=ie-1
      ii   = 1
      do i=is,ie

         jcur=0
         jj = 1
         do j=1,i
            jj = jj + 1
            if (jj.gt.na(jcur+1)) then
               jcur = jcur + 1
               jj = 1
            end if
         end do
         work1(i) = A(ii,jj)
#ifdef MPI4
         stupid_msglen = 1
         stupid_taskid = jcur
         call MPI_Bcast(work1(i),stupid_msglen,stupid_double,
     >                  stupid_taskid,stupid_comm_j,stupid_ierr)
#else
         call MPI_Bcast(work1(i),1,MPI_DOUBLE_PRECISION,
     >                  jcur,comm_j,ierr)
#endif
         ii = ii + 1
         if (ii.gt.ma(icur+1)) then
            icur = icur + 1
            ii = 1
         end if
      end do
#ifdef MPI4
      stupid_msglen = n-1
      call MPI_AllReduce(work1,tu,stupid_msglen,
     >                   stupid_double,stupid_sum,
     >                   stupid_comm_i,stupid_ierr)
#else
      call MPI_AllReduce(work1,tu,n-1,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,comm_i,ierr)
#endif
      return
      end




*     ***********************************
*     *                                 *
*     *         DMatrix_MaxAll          *
*     *                                 *
*     ***********************************
      subroutine DMatrix_MaxAll(sum)
c     implicit none
      real*8  sum

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


      integer msglen,mpierr,np
      real*8  sumall

*     **** external functions ****

      call Parallel_np(np)
      if (np.gt.1) then
        msglen = 1
#ifdef MPI4
        stupid_msglen = 1
        call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                      stupid_max,stupid_world,stupid_ierr)
#else
        call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                      MPI_MAX,MPI_COMM_WORLD,mpierr)
#endif
        sum = sumall
      end if

      return
      end




*     ***********************************
*     *                                 *
*     *         DMatrix_SumAll          *
*     *                                 *
*     ***********************************
      subroutine DMatrix_SumAll(sum)
c     implicit none
      real*8  sum

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


      integer msglen,mpierr,np
      real*8  sumall

*     **** external functions ****

      call Parallel_np(np)
      if (np.gt.1) then
        msglen = 1
#ifdef MPI4
        stupid_msglen = msglen
        call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                      stupid_sum,stupid_world,stupid_ierr)
#else
        call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                      MPI_SUM,MPI_COMM_WORLD,mpierr)
#endif
        sum = sumall
      end if

      return
      end





*     ***********************************
*     *                                 *
*     *         DMatrix_mm_transpose     *
*     *                                 *
*     ***********************************

      subroutine DMatrix_mm_transpose(n,A,B,ldq,mq,nq)
      implicit none
      integer n
      integer ldq,mq(*),nq(*)
      real*8  A(ldq,*)
      real*8  B(ldq,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "mpif.h"

#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

*     **** local variables ****
      logical value
      integer taskid
      integer i,j
      integer ii,jj,rr,ss
      integer icur,jcur,rcur,scur
      integer psend,precv,msglen,msgtype,mpierr,status(2)

*     **** external functions ****
      integer  Parallel2d_convert_taskid_ij
      external Parallel2d_convert_taskid_ij


      call Parallel_taskid(taskid)
      msglen  = 1
      msgtype = 1

*    **** allocate memory ****
      value = MA_push_get(mt_int,MPI_STATUS_SIZE,
     >                     'status',status(2),status(1))
      if (.not. value)
     > call errquit(' DMatrix_m_transpose:out of stack',0,MA_ERR)


      jj   = 1
      jcur = 0
      rr   = 1
      rcur = 0
      do j=1,n
         ii   = 1
         icur = 0
         ss   = 1
         scur = 0
         do i=1,n

          
            psend = Parallel2d_convert_taskid_ij(icur,jcur)
            precv = Parallel2d_convert_taskid_ij(rcur,scur)

            if (psend.eq.precv) then
               if (psend.eq.taskid) B(rr,ss) = A(ii,jj)
            else
#ifdef MPI4
               !**** send ****
               if (psend.eq.taskid) then
                  stupid_msglen = 1
                  stupid_type   = msgtype
                  stupid_taskid = precv
                  call MPI_SEND(A(ii,jj),
     >                          stupid_msglen,stupid_double,
     >                          stupid_taskid,
     >                          stupid_type,stupid_world,stupid_ierr)
               end if

               !**** recv ****
               if (precv.eq.taskid) then
                  stupid_msglen = msglen
                  stupid_type   = msgtype
                  stupid_taskid = psend
                  call MPI_RECV(B(rr,ss),
     >                       stupid_msglen,stupid_double,
     >                       stupid_taskid,
     >                       stupid_type,stupid_world,
     >                       int_mb(status(1)),stupid_ierr)
               end if

#else
               if (psend.eq.taskid)
     >         call MPI_SEND(A(ii,jj),1,
     >                       MPI_DOUBLE_PRECISION,precv,
     >                       msgtype,MPI_COMM_WORLD,mpierr)

               !**** recv ****
               if (precv.eq.taskid)
     >         call MPI_RECV(B(rr,ss),msglen,
     >                       MPI_DOUBLE_PRECISION,psend,
     >                       msgtype,MPI_COMM_WORLD,
     >                       int_mb(status(1)),mpierr)
#endif
            end if
           

            ii = ii + 1
            if (ii.gt.mq(icur+1)) then
              icur = icur + 1
              ii   = 1
            end if

            ss = ss + 1
            if (ss.gt.nq(scur+1)) then
              scur = scur + 1
              ss   = 1
            end if

         end do

         jj = jj + 1
         if (jj.gt.nq(jcur+1)) then
           jcur = jcur + 1
           jj   = 1
         end if

         rr = rr + 1
         if (rr.gt.mq(rcur+1)) then
           rcur = rcur + 1
           rr   = 1
         end if

      end do

      !*** deallocate memory ***
      value = MA_pop_stack(status(2))
      if (.not. value)
     > call errquit(' DMatrix_m_transpose:popping stack',0,MA_ERR)

      return
      end






*     ***********************************
*     *                                 *
*     *       DMatrix_combo_dgemm2      *
*     *                                 *
*     ***********************************
      subroutine DMatrix_combo_dgemm2(m,n,k,nblock,
     >                  alpha,
     >                  A,B,lda,ma,na,
     >                  beta,
     >                  C,ldc,ldc2,mc,nc,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer m,n,k,nblock
      real*8  alpha

      integer lda,ma(*),na(*)
      real*8  A(lda,*)
      real*8  B(lda,*)

      real*8  beta

      integer ldc,ldc2,mc(*),nc(*)
      real*8  C(ldc,ldc2,3)

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8  work1(*),work2(*)


#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


*     **** local variables ****
      logical docalc1,docalc2
      integer i,j,ii,jj
      integer kk,iwrk,icur,jcur,ierr,shift,shft,shft2,shft3

      do kk=1,3
      do j=1,nc(taskid_j+1)
         do i=1,mc(taskid_i+1)
            C(i,j,kk) = beta*C(i,j,kk)
         end do
      end do
      end do

      ii = 0
      jj = 0
      kk = 0
      icur = 0
      jcur = 0
c     **** loop over all row pannels of C ***
      do while (kk.lt.m)
         iwrk = min(nblock, mc(icur+1)-ii)
         iwrk = min(iwrk,   na(jcur+1)-jj)


*        **** iwrk*nc(taskid_j+1) submatrix !=0 ****
         if (ma(taskid_i+1).gt.0) then

            shft  = iwrk*ma(taskid_i+1)
            shft2 = iwrk*nc(taskid_j+1)
            shft3 = shft2+shft2

*           **** pack current iwrk columns of A into work1 ***
            if (taskid_j.eq.jcur) then
               call dlacpy("G", ma(taskid_i+1),iwrk,
     >                   A(1,jj+1), lda,
     >                   work1,     ma(taskid_i+1))

               call dlacpy("G", ma(taskid_i+1),iwrk,
     >                   B(1,jj+1), lda,
     >                   work1(1+shft),  ma(taskid_i+1))
            end if

c           **** broadcast work1  within my row ***
#ifdef MPI4
            stupid_msglen = 2*iwrk*ma(taskid_i+1)
            stupid_taskid = jcur
            call MPI_Bcast(work1,stupid_msglen,
     >                     stupid_double,stupid_taskid,
     >                     stupid_comm_j,stupid_ierr)
#else
            call MPI_Bcast(work1,2*iwrk*ma(taskid_i+1),
     >                     MPI_DOUBLE_PRECISION,jcur,comm_j,ierr)
#endif


            if ((iwrk.gt.0)          .and.
     >          (na(taskid_j+1).gt.0)) then

              call dgemm('T','N',iwrk,na(taskid_j+1),ma(taskid_i+1),
     >                   alpha,
     >                   work1, ma(taskid_i+1),
     >                   A, lda,
     >                   0.0d0,
     >                   work2, iwrk)
              call dgemm('T','N',iwrk,na(taskid_j+1),ma(taskid_i+1),
     >                   alpha,
     >                   work1, ma(taskid_i+1),
     >                   B, lda,
     >                   0.0d0,
     >                   work2(1+shft2), iwrk)
              call dgemm('T','N',iwrk,na(taskid_j+1),ma(taskid_i+1),
     >                   alpha,
     >                   work1(1+shft), ma(taskid_i+1),
     >                   B, lda,
     >                   0.0d0,
     >                   work2(1+shft3), iwrk)
            end if

*        **** iwrk*nc(taskid_j+1) submatrix ==0 ****
         else
            call dcopy(3*nc(taskid_j+1)*iwrk,0.0d0,0,work2,1)
         end if


c        **** summ to node that holds current rows of C ****
#ifdef MPI4
         stupid_msglen = 3*nc(taskid_j+1)*iwrk
         stupid_taskid = icur
         call MPI_Reduce(work2,work1,stupid_msglen,
     >                   stupid_double,stupid_sum,
     >                   stupid_taskid,stupid_comm_i,stupid_ierr)
#else
         call MPI_Reduce(work2,work1,3*nc(taskid_j+1)*iwrk,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,icur,comm_i,ierr)
#endif


c        **** add to current rows of C ****
         if (taskid_i.eq.icur) then
            shift = 1
            do i=ii,(ii+iwrk-1)
               call daxpy(nc(taskid_j+1),1.0d0,work1(shift),iwrk,
     >                                    C(i+1,1,1),mc(taskid_i+1))
               call daxpy(nc(taskid_j+1),1.0d0,work1(shift+shft2),iwrk,
     >                                    C(i+1,1,2),mc(taskid_i+1))
               call daxpy(nc(taskid_j+1),1.0d0,work1(shift+shft3),iwrk,
     >                                    C(i+1,1,3),mc(taskid_i+1))
               shift = shift + 1
            end do
         end if

         ii = ii + iwrk
         jj = jj + iwrk
         kk = kk + iwrk

         if (jj.ge.na(jcur+1)) then
           jcur = jcur + 1
           jj   = 0
         end if
         if (ii.ge.mc(icur+1)) then
           icur = icur + 1
           ii   = 0
         end if

      end do

      return
      end



*     ***********************************
*     *                                 *
*     *         DMatrix_houseq_V        *
*     *                                 *
*     ***********************************
      subroutine DMatrix_houseq_V(jcol,
     >                  n,
     >                  A,V1,V1t,lda,ma,na,
     >                  r2,
     >                  taskid_i,taskid_j,
     >                  np_i,np_j,
     >                  comm_i, comm_j,
     >                  work1,work2)
      implicit none
      integer jcol,n

      integer lda,ma(*),na(*)
      real*8  A(lda,*),V1(lda,*),V1t(lda,*)
      real*8  r2

      integer taskid_i,taskid_j
      integer np_i,np_j
      integer comm_i,comm_j

      real*8 work1(*),work2(*)

      real*8 VV(7,7),VV2(7,7)

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variables ****
      logical crossing
      integer i,j,ii,jj,ll
      integer kk,iwrk,icur,jcur,ierr,shift
      integer ii0,icur0,ii1,icur1,ii2,icur2
      integer jj0,jcur0,jj1,jcur1
      real*8  beta,mu0,mu,r20

      call dcopy(ma(taskid_i+1)*na(taskid_j+1),0.0d0,0,V1,1)
      call dcopy(ma(taskid_i+1)*na(taskid_j+1),0.0d0,0,V1t,1)

      jcur0 = 0
      jj0   = 1
      do j=1,jcol-1
        jj0 = jj0 + 1
        if (jj0.gt.na(jcur0+1)) then
           jcur0 = jcur0 + 1
           jj0 = 1
        end if
      end do
      jcur1 = jcur0
      jj1   = jj0 + 1
      if (jj1.gt.na(jcur1+1)) then
           jcur1 = jcur1 + 1
           jj1 = 1
      end if
      icur0 = 0
      ii0   = 1
      do i=1,jcol-1
        ii0 = ii0 + 1
        if (ii0.gt.ma(icur0+1)) then
           icur0 = icur0 + 1
           ii0 = 1
        end if
      end do
      icur1 = icur0
      ii1   = ii0 + 1
      if (ii1.gt.ma(icur1+1)) then
           icur1 = icur1 + 1
           ii1 = 1
      end if
      icur2 = icur1
      ii2   = ii1 + 1
      if (ii2.gt.ma(icur2+1)) then
           icur2 = icur2 + 1
           ii2 = 1
      end if

      if (jcur0.eq.taskid_j) then
         icur = icur1
         ii   = ii1
         do i=jcol+1,n
            if (icur.eq.taskid_i) V1(ii,jj0) = A(ii,jj0)
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
         mu0 = 0.0d0
         icur = icur1
         ii   = ii1
         do i=jcol+1,n
            if (icur.eq.taskid_i) mu0 = mu0 + V1(ii,jj0)**2
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
#ifdef MPI4
         stupid_msglen = 1
         stupid_taskid = icur1
         call MPI_AllReduce(mu0,mu,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_comm_i,stupid_ierr)
#else
         call MPI_AllReduce(mu0,mu,1,
     >                      MPI_DOUBLE_PRECISION,MPI_SUM,comm_i,ierr)
#endif
         mu = dsqrt(mu)
         if (mu.ne.0.0d0) then
           if (icur1.eq.taskid_i)
     >        beta = V1(ii1,jj0) + dsign(mu,V1(ii1,jj0))
#ifdef MPI4
           stupid_msglen = 1
           stupid_taskid = icur1
           call MPI_Bcast(beta,stupid_msglen,stupid_double,
     >                    stupid_taskid,stupid_comm_i,stupid_ierr)
#else
           call MPI_Bcast(beta,1,MPI_DOUBLE_PRECISION,
     >                  icur1,comm_i,ierr)
#endif
           icur = icur2
           ii   = ii2
           do i=jcol+2,n
              if (icur.eq.taskid_i) V1(ii,jj0) = V1(ii,jj0)/beta
              ii = ii + 1
              if (ii.gt.ma(icur+1)) then
                 icur = icur + 1
                 ii = 1
              end if
           end do
         end if
         if (icur1.eq.taskid_i)  V1(ii1,jj0) = 1.0d0
         if (icur0.eq.taskid_i)  V1(ii0,jj0) = 0.0d0

         r20 = 0.0d0
         icur = icur0
         ii   = ii0
         do i=jcol,n
            if (icur.eq.taskid_i) r20 = r20 + V1(ii,jj0)**2
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
#ifdef MPI4
         stupid_msglen = 1
         call MPI_AllReduce(r20,r2,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_comm_i,stupid_ierr)
#else
         call MPI_AllReduce(r20,r2,1,
     >                      MPI_DOUBLE_PRECISION,MPI_SUM,comm_i,ierr)
#endif
         r2 = 2.0d0/r2
      end if
#ifdef MPI4
      stupid_msglen = 1
      stupid_taskid = jcur0
      call MPI_Bcast(r2,stupid_msglen,stupid_double,
     >               stupid_taskid,stupid_comm_j,stupid_ierr)
#else
      call MPI_Bcast(r2,1,MPI_DOUBLE_PRECISION,
     >               jcur0,comm_j,ierr)
#endif

*     **** generate V1*Ones(N) matrix ****
      if (jcur0.eq.taskid_j) then
         do ii=1,ma(taskid_i+1)
            V1(ii,1) = V1(ii,jj0)
         end do
      end if
#ifdef MPI4
      stupid_msglen = ma(taskid_i+1)
      stupid_taskid = jcur0
      call MPI_Bcast(V1,stupid_msglen,stupid_double,
     >               stupid_taskid,stupid_comm_j,stupid_ierr)
#else
      call MPI_Bcast(V1,ma(taskid_i+1),MPI_DOUBLE_PRECISION,
     >               jcur0,comm_j,ierr)
#endif
      do jj=2,na(taskid_j+1)
         do ii=1,ma(taskid_i+1)
            V1(ii,jj) = V1(ii,1)
         end do
      end do


      crossing = .false.
      kk   = 1
      ii   = 1
      jj   = 1
      icur = 0
      jcur = 0
      do i=1,n
         if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
            work1(kk) = V1(ii,jj)
         end if

         kk = kk + 1
         if ((ii.ge.ma(icur+1)).or.(jj.ge.na(jcur+1))) crossing=.true.
         if (crossing) then
            if ((taskid_i.eq.0).and.(taskid_j.eq.0))
     >      write(*,'(A,6I4)') 
     >      "crossing:",ii,jj,icur,jcur,ma(icur+1),na(jcur+1)

            if (jcur.eq.taskid_j) then
#ifdef MPI4
               stupid_msglen = kk-1
               stupid_taskid = icur
               call MPI_Bcast(work1,stupid_msglen,stupid_double,
     >               stupid_taskid,stupid_comm_i,stupid_ierr)
#else
               call MPI_Bcast(work1,kk-1,MPI_DOUBLE_PRECISION,
     >               icur,comm_i,ierr)
#endif

               do ll=1,kk-1
                  do iwrk=1,ma(taskid_i+1)
                     V1t(iwrk,jj+1-ll) = work1(kk-ll)
                  end do
               end do
            end if
            kk = 1
            crossing = .false.
         end if
         ii = ii + 1
         if (ii.gt.ma(icur+1)) then
            icur = icur + 1
            ii = 1
         end if
         jj = jj + 1
         if (jj.gt.na(jcur+1)) then
            jcur = jcur + 1
            jj = 1
         end if
      end do


      do j=1,7
         do i=1,7
            VV(i,j) = 0.0d0
         end do
      end do

      jcur = 0
      jj   = 1
      do j=1,7
         icur = 0
         ii   = 1
         do i=1,7
            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               VV(i,j) = V1(ii,jj)
            end if
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
         jj = jj + 1
         if (jj.gt.na(jcur+1)) then
            jcur = jcur + 1
            jj = 1
         end if
      end do
#ifdef MPI4
      stupid_msglen = 7*7
      call MPI_AllReduce(VV,VV2,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_world,stupid_ierr)
#else
      call MPI_AllReduce(VV,VV2,7*7,
     >                      MPI_DOUBLE_PRECISION,MPI_SUM,
     >                      MPI_COMM_WORLD,ierr)
#endif
      
      if ((taskid_i.eq.0).and.(taskid_j.eq.0)) then
         write(*,*) "jcol=",jcol,"  V*ones(7)="
         do i=1,7
            write(*,'(10F12.3)') (VV2(i,j),j=1,7)
         end do
      end if

      do j=1,7
         do i=1,7
            VV(i,j) = 0.0d0
         end do
      end do

      jcur = 0
      jj   = 1
      do j=1,7
         icur = 0
         ii   = 1
         do i=1,7
            if ((icur.eq.taskid_i).and.(jcur.eq.taskid_j)) then
               VV(i,j) = V1t(ii,jj)
            end if
            ii = ii + 1
            if (ii.gt.ma(icur+1)) then
               icur = icur + 1
               ii = 1
            end if
         end do
         jj = jj + 1
         if (jj.gt.na(jcur+1)) then
            jcur = jcur + 1
            jj = 1
         end if
      end do
#ifdef MPI4
      stupid_msglen = 7*7
      call MPI_AllReduce(VV,VV2,stupid_msglen,
     >                      stupid_double,stupid_sum,
     >                      stupid_world,stupid_ierr)
#else
      call MPI_AllReduce(VV,VV2,7*7,
     >                   MPI_DOUBLE_PRECISION,MPI_SUM,
     >                   MPI_COMM_WORLD,ierr)
#endif
      


      if ((taskid_i.eq.0).and.(taskid_j.eq.0)) then
         write(*,*) "V1t*ones(7)="
         do i=1,7
            write(*,'(10F12.3)') (VV2(i,j),j=1,7)
         end do
      end if


      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
      double precision function timer_dontuse()
c
c     return the time since the last call to timer.
c
c     must be initialized by calling once and throwing away the
c     value 
c     ... use cpu time on multi-user machines
c     ... use elapsed time on dedicated or single user machines.
c
*mdc*if unix
*      real*4 dtime, tt(2)
*      timer = dble(dtime(tt))
*mdc*elseif tcgmsg
C$Id: timer.F,v 1.1 2005-03-08 23:58:03 d3g293 Exp $
#if 0
#include "mpif.h"
      save mlast
      data mlast/0/
      m = MPI_WTIME()
      timer = dble(m - mlast) * 0.01d0
      mlast = m
*mdc*endif
c
#endif
      timer_dontuse = 0.0d0
      end

c$Id: util_ndim_test.F 19707 2010-10-29 17:59:36Z d3y133 $
#define  MAXLOOP 100

      subroutine util_ndim_test
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer nproc
      logical status
c
c***  Intitialize a message passing library
c
#ifdef MPI
c     integer ierr
c     call mpi_init(ierr)
#else
c     call pbeginf
#endif
c     Intitialize the GA package
c
c     call ga_initialize()
      nproc = ga_nnodes()
c     if(ga_nodeid().eq.0)print *,nproc,' nodes'
c
c     Initialize the MA package
c
c     status = ma_init(MT_DBL, 500000/nproc, 50000)
c     if(.not. status) call ga_error("ma_init failed",0) 
c
c
      if(ga_nodeid().eq.0) then
       write(6,'(A)') ' Checking 3-Dimensional Arrays'
       write(6,*)
      endif
      call testit()
      if(ga_nodeid().eq.0) then
       write(6,*)
       write(6,'(A)') ' Checking 4-Dimensional Arrays'
       write(6,*)
      endif
      call testit4()
c     call ga_terminate()
c
c***  Tidy up after message-passing library
c
#ifdef MPI
c     call mpi_finalize(ierr)
#else
c     call pend()
#endif
      end


c-----------------



      subroutine testit()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c     
      integer n
      integer ndim
      parameter (n = 38)
      parameter (ndim = 3)
      double precision a(n,n,n),b(n,n,n)
      integer g_a
      integer  i,  lo(ndim),hi(ndim), lop(ndim),hip(ndim),elems
      integer nproc, me, proc, loop, maxloop
      integer chunk(ndim), dims(ndim), adims(ndim), ld(ndim)
      logical status, compare_patches
      integer count_elems
      double precision crap,alpha
c     
      nproc = ga_nnodes()
      me    = ga_nodeid()
c     
      
      call ifill_array(chunk,ndim,0)
      call ifill_array(adims,ndim,n-1)
      call ifill_array(dims,ndim,n)
      call ifill_array(ld,ndim,n)
      call dfill_array(a,n*n*n,dble(me))
      call dfill_array(b,n*n*n,-1d0)
c
c***  Create global arrays
      if (.not. nga_create(MT_DBL, ndim, adims, 'a', chunk, g_a))
     $     call ga_error(' ga_create failed ',1)
c     
      call ga_sync()
c     if(me.eq.0)then
c        write(6,'(i2,21H-dimensional Array A:  ,10i6)')
c    $   ndim,(adims(i),i=1,ndim)
c        print *,'distribution information for all processors'
c        print *,'-------------------------------------------'
c        call ffflush(6)
c     endif
      call ga_sync()
      call nga_distribution(g_a, me, lo,hi)
      elems = count_elems(lo,hi,ndim)
c
      do i = 0, nproc-1
c       if (me .eq. i) then
c100      format(i4,' has',i8,' elements of A, range:',10(i3,':',i3,','))
c        write(*,100)me,elems,(lo(j),hi(j),j=1,ndim)
c         call print_range(me, lo, hi, ndim)
c         call ffflush(6)
c       endif
       call ga_sync()
      enddo
c
c------------------------------- GA_FILL ----------------------------
      call ga_fill(g_a,dble(me))
c     if(me.eq.0)then 
c       print *, ' '
c       print *, 'Filling array A'
c       call ffflush(6)
c     endif
c     call ga_print(g_a)
      call ga_sync()
c
      if(elems.gt.0) then
        call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3)),ld)

        if(compare_patches(me,0d0,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)
      endif

      call ga_sync()
      if(me.eq.0)then 
        write(6,'(A)') ' ga_fill .......................... OK'
c       print *, 'OK'
c       print *, ' '
c       print *, 'Testing random PUT'
c       print *,'(only process 0 prints range for its every 10-th put)'
        call ffflush(6)
      endif
      call ga_fill(g_a,-1d0)
c
c------------------------------- NGA_PUT ----------------------------
c     if(nproc.gt.0)return
      proc =  nproc-1 -me ! access other process memory 
      call nga_distribution(g_a, proc, lo,hi)
      elems = count_elems(lo,hi,ndim)
      call init_array(a,ndim,dims)
c
      call ga_sync()
      if(elems.gt.0) then
         call nga_put(g_a,lo,hi,a(lo(1),lo(2),lo(3)),ld)
         do loop = 1, MAXLOOP 
            call random_range(lo,hi,lop,hip,ndim)
c           if(me.eq.0 .and. Mod(loop,10).eq.0)then
c              call print_range(loop,lop,hip,ndim)
c           endif
            call nga_put(g_a,lop,hip,a(lop(1),lop(2),lop(3)),ld)
         enddo

         call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3)),ld)

         if(compare_patches(me,0d0,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)

      endif
c
      call ga_sync()
      if(me.eq.0)then
        write(6,'(A)') ' nga_put .......................... OK'
c       print *, 'OK'
c       print *, ' '
c       print *, 'Testing random GET'
c       print *,'(only process 0 prints range for its every 10-th get)'
        call ffflush(6)
      endif
c------------------------------- NGA_GET ----------------------------
      call ga_sync()
      call ifill_array(lop,ndim,1)
      call ifill_array(hip,ndim,n-1)
      do loop = 1, MAXLOOP 
         call random_range(lop,hip,lo,hi,ndim)
c        if(me.eq.0 .and. Mod(loop,10).eq.1)then
c           call print_range(loop,lo,hi,ndim)
c        endif
         call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3)),ld)
         if(compare_patches(me,0d0,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)
      enddo
c------------------------------- NGA_ACC ----------------------------
      call ga_sync()
      if(me.eq.0)then
        write(6,'(A)') ' nga_get .......................... OK'
c       print *, 'OK'
c       print *, ' '
c       print *, 'Testing Accumulate'
        call ffflush(6)
      endif
c     
      call ga_sync()
      call ifill_array(lop,ndim,1)
      call ifill_array(hip,ndim,n-1)
      call random_range(lop,hip,lo,hi,ndim)
      crap = util_drand(1)
      maxloop = 10
      alpha = .1d0 ! alpha must be 1/maxloop
      call ga_sync()
c
      do loop=1, maxloop
       call nga_acc(g_a,lop,hip,a(lop(1),lop(2),lop(3)),ld,alpha)
      enddo
      call ga_sync()
      if(me.eq.0)then
c       print *, 'multiple accumulate target same array section'
c       call print_range(maxloop,lo,hi,ndim) 
        call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3)),ld)
        call scale_patch(dble(nproc+1),ndim, a(lo(1),lo(2),lo(3)),
     $                    lo, hi, dims)
        if(compare_patches(me,1d-2,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)
        write(6,'(A)') ' nga_acc .......................... OK'
c       print *, 'OK'
        call ffflush(6)
      endif
c     
      status= ga_destroy(g_a)
      end


      subroutine testit4()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c     
      integer n
      integer ndim
      parameter (n = 25)
      parameter (ndim = 4)
      double precision a(n,n,n,n),b(n,n,n,n)
      integer g_a
      integer  i, lo(ndim),hi(ndim), lop(ndim),hip(ndim),elems
      integer nproc, me, proc, loop, maxloop
      integer chunk(ndim), dims(ndim), ld(ndim)
      logical status, compare_patches
      integer count_elems
      double precision crap,alpha
c     
      nproc = ga_nnodes()
      me    = ga_nodeid()
c     
      
      call ifill_array(chunk,ndim,0)
      call ifill_array(dims,ndim,n)
      call ifill_array(ld,ndim,n)
      elems=1
      do i = 1,ndim
         elems = elems * dims(i)
      enddo
      call dfill_array(a,elems,dble(me))
      call dfill_array(b,elems,-1d0)
c
c***  Create global arrays
      if (.not. nga_create(MT_DBL, ndim, dims, 'a', chunk, g_a))
     $     call ga_error(' ga_create failed ',1)
c     
      call ga_sync()
c     if(me.eq.0)then
c        write(6,'(i2,21H-dimensional Array A:  ,10i6)')
c    $   ndim,(dims(i),i=1,ndim)
c        print *,'distribution information for all processors'
c        print *,'-------------------------------------------'
c        call ffflush(6)
c     endif
      call ga_sync()
      call nga_distribution(g_a, me, lo,hi)
      elems = count_elems(lo,hi,ndim)
c
      do i = 0, nproc-1
c       if (me .eq. i) then
c100      format(i4,' has',i8,' elements of A, range:',10(i3,':',i3,','))
cc        write(*,100)me,elems,(lo(j),hi(j),j=1,ndim)
c         call print_range(me, lo, hi, ndim)
c         call ffflush(6)
c       endif
       call ga_sync()
      enddo
c
c------------------------------- GA_FILL ----------------------------
      call ga_fill(g_a,dble(me))
c     if(me.eq.0)then 
c       print *, ' '
c       print *, 'Filling array A'
c       call ffflush(6)
c     endif
c     call ga_print(g_a)
      call ga_sync()
c
      if(elems.gt.0) then
        call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3),lo(4)),ld)

        if(compare_patches(me,0d0,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)
      endif

      call ga_sync()
      if(me.eq.0)then 
        write(6,'(A)') ' ga_fill .......................... OK'
c       print *, 'OK'
c       print *, ' '
c       print *, 'Testing random PUT'
c       print *,'(only process 0 prints range for its every 10-th put)'
        call ffflush(6)
      endif
      call ga_fill(g_a,-1d0)
c
c------------------------------- NGA_PUT ----------------------------
c     if(nproc.gt.0)return
      proc =  nproc-1 -me ! access other process memory 
      call nga_distribution(g_a, proc, lo,hi)
      elems = count_elems(lo,hi,ndim)
      call init_array(a,ndim,dims)
c
      call ga_sync()
      if(elems.gt.0) then
         call nga_put(g_a,lo,hi,a(lo(1),lo(2),lo(3),lo(4)),ld)
         do loop = 1, MAXLOOP 
            call random_range(lo,hi,lop,hip,ndim)
c           if(me.eq.0 .and. Mod(loop,10).eq.0)then
c              call print_range(loop,lop,hip,ndim)
c           endif
            call nga_put(g_a,lop,hip,a(lop(1),lop(2),lop(3),lop(4)),ld)
         enddo

         call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3),lo(4)),ld)

         if(compare_patches(me,0d0,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)

      endif
c
      call ga_sync()
      if(me.eq.0)then
        write(6,'(A)') ' nga_put .......................... OK'
c       print *, 'OK'
c       print *, ' '
c       print *, 'Testing random GET'
c       print *,'(only process 0 prints range for its every 10-th get)'
        call ffflush(6)
      endif
c------------------------------- NGA_GET ----------------------------
      call ga_sync()
      call ifill_array(lop,ndim,1)
      call ifill_array(hip,ndim,n)
      do loop = 1, MAXLOOP 
         call random_range(lop,hip,lo,hi,ndim)
c        if(me.eq.0 .and. Mod(loop,10).eq.0)then
c           call print_range(loop,lo,hi,ndim)
c        endif
         call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3),lo(4)),ld)
         if(compare_patches(me,0d0,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)
      enddo
c------------------------------- NGA_ACC ----------------------------
      call ga_sync()
      if(me.eq.0)then
        write(6,'(A)') ' nga_get .......................... OK'
c       print *, 'OK'
c       print *, ' '
c       print *, 'Testing Accumulate'
        call ffflush(6)
      endif
c     
      call ga_sync()
      call ifill_array(lop,ndim,1)
      call ifill_array(hip,ndim,n)
      call random_range(lop,hip,lo,hi,ndim)
      crap = util_drand(1)
      maxloop = 10
      alpha = .1d0 ! alpha must be 1/maxloop
      call ga_sync()
c
      do loop=1, maxloop
       call nga_acc(g_a,lop,hip,a(lop(1),lop(2),lop(3),lop(4)),ld,alpha)
      enddo
      call ga_sync()
      if(me.eq.0)then
c       print *, 'multiple accumulate target same array section'
c       call print_range(maxloop,lo,hi,ndim) 
        call nga_get(g_a,lo,hi,b(lo(1),lo(2),lo(3),lo(4)),ld)
        call scale_patch(dble(nproc+1),ndim, a(lo(1),lo(2),lo(3),lo(4)),
     $                    lo, hi, dims)
        if(compare_patches(me,1d-2,ndim,a,lo,hi,dims,b,lo,hi,dims))
     $             call ga_error('bye',0)
        write(6,'(A)') ' nga_acc .......................... OK'
c       print *, 'OK'
        call ffflush(6)
      endif
c     
      status= ga_destroy(g_a)
      end







      subroutine random_range(lo,hi,lop,hip,ndim)
      implicit none
#include "testutil.fh"
      integer lo(1),hi(1),lop(1),hip(1),ndim
      integer i, range, swap, val
      integer iran
      external iran

      do i = 1, ndim
         range = hi(i)-lo(i)+1
         val = iran(range)
         lop(i) = lo(i) + val 
         val = iran(range)
         hip(i) = hi(i) - val
         if(hip(i) .lt. lop(i))then
            swap =hip(i)
            hip(i)=lop(i)
            lop(i)=swap
         endif
         hip(i)=MIN(hip(i),hi(i))
         lop(i)=MAX(lop(i),lo(i))
      enddo
      end


      subroutine compare(a,b,n)
      double precision a(1), b(1)
      integer n
      integer i
      do i =1, n
         if(a(i).ne.b(i))then
           print *, 'error',a(i),b(i)
           call ga_error("comparison failed",0)
         endif
      enddo
      end
         

      integer function count_elems(lo,hi,ndim)
      implicit none
      integer lo(1),hi(1),ndim,elems,i
      elems=1
      do i=1,ndim
         elems = elems*(hi(i)-lo(i)+1)
      enddo
      count_elems = elems
      end


      subroutine testit2()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c     
      integer n
      parameter (n = 5)
*     double precision a(n,n), b(n,n), c(n,n)
      integer g_a,g_b
      integer  i, ilo,ihi,jlo,jhi
      integer nproc, me
c     
      nproc = ga_nnodes()
      me    = ga_nodeid()
c     
c***  Create global arrays
      if (.not. ga_create(MT_DCPL, n, n, 'a', 0, 0, g_a))
     $     call ga_error(' ga_create failed ',2)
      if (.not. ga_create(MT_DCPL, 1, n, 'b', 1, n, g_b))
     $     call ga_error(' ga_create failed ',2)
c     
c     
      call ga_sync()
      if(me.eq.0)print *,'Array A ',n,'x',n
      do i = 0, nproc-1
         if (me .eq. i) then
            call ga_distribution(g_a, me, ilo,ihi,jlo,jhi)
            print *,  ' my portion of A  ',ilo,ihi,jlo,jhi
            call ffflush(6)
         endif
         call ga_sync()
      enddo
      call ga_sync()
      if(me.eq.0)print *,'Array B ',n/3,'x',n
      call ga_sync()
      do i = 0, nproc-1
         if (me .eq. i) then
            call ga_distribution(g_b, me, ilo,ihi,jlo,jhi)
            print *,  ' my portion of B  ',ilo,ihi,jlo,jhi
            call ffflush(6)
         endif
         call ga_sync()
      enddo

      end

      subroutine dfill_array(a,n,val)
      implicit none
      integer n
      double precision a(n),val
      integer k
      do k= 1, n
         a(k) = val
      enddo
      end                                              

      subroutine ifill_array(a,n,val)
      implicit none
      integer n
      integer a(n),val
      integer k
      do k= 1, n
         a(k) = val
      enddo                                                
      end    

      subroutine argos_pme_finish
c
      implicit none
c
#include "argos_pme_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      if(.not.ga_destroy(ga_flg))
     + call md_abort('Failed to deallocate flg',0)
c
      call ga_destroy_list(mgz,lslab)
c
      if(.not.ma_pop_stack(l_slab))
     + call md_abort('Failed to deallocate slab',0)
      if(.not.ma_pop_stack(l_map2))
     + call md_abort('Failed to deallocate map2',0)
      if(.not.ma_pop_stack(l_map1))
     + call md_abort('Failed to deallocate map1',0)
      if(.not.ma_pop_stack(l_slmax))
     + call md_abort('Failed to deallocate slmax',0)
      if(.not.ma_pop_stack(l_lsld))
     + call md_abort('Failed to deallocate lsldo',0)
      if(.not.ma_pop_stack(l_knod))
     + call md_abort('Failed to deallocate knode',0)
      if(.not.ma_pop_stack(l_nodp))
     + call md_abort('Failed to deallocate nodep',0)
      if(.not.ma_pop_stack(l_kto))
     + call md_abort('Failed to deallocate kto',0)
      if(.not.ma_pop_stack(l_kfr))
     + call md_abort('Failed to deallocate kfrom',0)
      if(.not.ma_pop_stack(l_lnod))
     + call md_abort('Failed to deallocate lnode',0)
      if(.not.ma_pop_stack(l_grdh))
     + call md_abort('Failed to deallocate gridh',0)
      if(.not.ma_pop_stack(l_grdt))
     + call md_abort('Failed to deallocate gridt',0)
      if(.not.ma_pop_stack(l_grd))
     + call md_abort('Failed to deallocate grid',0)
      if(.not.ma_pop_stack(l_grd2))
     + call md_abort('Failed to deallocate grid2',0)
      if(.not.ma_pop_stack(l_grd1))
     + call md_abort('Failed to deallocate grid1',0)
c
      if(.not.ma_pop_stack(l_barr))
     + call md_abort('Failed to deallocate barr',0)
      if(.not.ma_pop_stack(l_bmod))
     + call md_abort('Failed to deallocate bmod',0)
c
      return
      end
c $Id: argos_pme_finish.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdtq_lambda1_22_2_1_2(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdtq_lambda1_22_2_1_2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h5 h6 h9 h14 p1 p3 p7 p8 )_y + = 4/5 * y ( h5 h6 h9 h14 p1 p3 p7 p8 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h6b
      INTEGER h9b
      INTEGER h14b
      INTEGER p1b
      INTEGER p3b
      INTEGER p7b
      INTEGER p8b
      INTEGER dimc
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h9b_1
      INTEGER h14b_1
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h9b = h6b,noab
      DO h14b = h9b,noab
      DO p1b = noab+1,noab+nvab
      DO p3b = noab+1,noab+nvab
      DO p7b = p3b,noab+nvab
      DO p8b = p7b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+p1b-1)+
     &int_mb(k_spin+p3b-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1).ne.
     &16)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h9b-1)
     &+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b
     &-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h9b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p1b-1),ie
     &or(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+p8b-1
     &)))))))) .eq. irrep_y) THEN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+h9b-1) * int_mb(k_range+h14b-1) * int_mb(k_range+p1b-1) * int_
     &mb(k_range+p3b-1) * int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1)
      CALL TCE_RESTRICTED_8(h5b,h6b,h9b,h14b,p1b,p3b,p7b,p8b,h5b_1,h6b_1
     &,h9b_1,h14b_1,p1b_1,p3b_1,p7b_1,p8b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+h9b-1) * int_mb(k_range+h14b-1) * int_mb(k_range+p1b-1) *
     & int_mb(k_range+p3b-1) * int_mb(k_range+p7b-1) * int_mb(k_range+p8
     &b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_22_2_1_2',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_22_2_1_2',1,MA_ERR)
      IF ((p8b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 
     &+ nvab * (p3b_1 - noab - 1 + nvab * (h14b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h9b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1
     &),int_mb(k_range+p1b-1),7,6,5,8,4,3,2,1,-1.0d0)
      END IF
      IF ((p7b .lt. p1b) .and. (p1b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p8b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p7b_1 - noab - 1 
     &+ nvab * (p3b_1 - noab - 1 + nvab * (h14b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h9b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1
     &),int_mb(k_range+p8b-1),8,6,5,7,4,3,2,1,1.0d0)
      END IF
      IF ((p3b .lt. p1b) .and. (p1b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p8b_1
     & - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p1b_1 - noab - 1 
     &+ nvab * (p3b_1 - noab - 1 + nvab * (h14b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h9b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),8,7,5,6,4,3,2,1,-1.0d0)
      END IF
      IF ((p1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p8b_1
     & - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p3b_1 - noab - 1 
     &+ nvab * (p1b_1 - noab - 1 + nvab * (h14b_1 - 1 + noab * (h9b_1 - 
     &1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h9b-1),int_mb(k_range+h14b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p3b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p8b-1),8,7,6,5,4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_22_2_1_2'
     &,2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_22_2_1_2',3,MA_ERR)
      CALL TCE_SORT_8(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p3b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h14b-1),int_mb(k_range+h9b-1),int_mb(k_range+h6b-1
     &),int_mb(k_range+h5b-1),8,7,6,5,4,3,2,1,4.0d0/5.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p8b -
     & noab - 1 + nvab * (p7b - noab - 1 + nvab * (p3b - noab - 1 + nvab
     & * (p1b - noab - 1 + nvab * (h14b - 1 + noab * (h9b - 1 + noab * (
     &h6b - 1 + noab * (h5b - 1)))))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_22_2_1_2'
     &,4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_22_2
     &_1_2',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

C> \ingroup stpr_api
C> @{
C>
      integer function stpr_walk(rtdb)
c     $Id: stpr_walk.F 25540 2014-05-01 22:33:27Z d3y133 $
      implicit none
#include "errquit.fh"
c     
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "global.fh"
#include "geom.fh"
#include "nwc_const.fh"
********************************************************************#include "geomP.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "pstat.fh"
#include "util.fh"
#include "stdio.fh"
c
c     
      integer rtdb              ! [input] run-time-data-base handle
c     
c     parameters read from rtdb
c     prefix:energy (later) rohf and uhf
c     
      integer geom              ! geometry handle
      integer needed            ! core needed
      integer nat               ! number of atoms 
      character*255 title       ! title buffer
      double precision energy   ! energy
c     
      integer h_grad, k_grad    ! MA handle/index of gradient
      integer h_coord, k_coord  ! MA handle/index of coords
      integer h_core, k_core    ! MA handle/index of scratch array for stepper
      integer h_chg, k_chg      ! MA handle/index of charge array
      integer int_val           ! value to propigate status (stpr_walk value)
      character*40 new_geom_name ! new geometry name for next step
      character*16 stpr_tags(nw_max_atom) ! local tags array
      integer i_timewalk
      logical o_timewalk, okeepgeom
      logical status
      logical lstpr_walk
      double precision convggm, convgg, convge
#include "cstprfiles.fh"
      integer first_call, step_number, astep_number
      data first_call /0/
c     
      call util_print_push
      call util_print_rtdb_load(rtdb,'stepper')
c     
      call stpr_filenames()
c     
      call ecce_print_module_entry ('stepper')
c
      if (first_call.eq.0) then
         first_call = 1
      endif
c     
#if defined(KSR)||defined(SUN)||defined(__PARAGON__)
      o_timewalk = util_print('time',print_default)
#else 
      o_timewalk = .false.
#endif
c     
      if (o_timewalk) then
         if (.not.(pstat_allocate
     &        ('stepper time',Pstat_Qstat,0,0,i_timewalk)))
     &        call errquit('stpr_walk: pstat allocate failed',911,
     &       MEM_ERR)
         call pstat_on(i_timewalk)
      endif
c     
      lstpr_walk = .false.
c....................................set broadcast off
      status = rtdb_parallel(.false.) 
c     
*     rak:      status = rtdb_print(rtdb,.true.)
      if (ga_nodeid().eq.0)  then
         if (.not. rtdb_cget(rtdb, 'title', 1, title))
     $        title = ' '
         if (util_print('information',print_low)) then
            call util_print_centered(6, 'NWChem STEPPER Module', 
     $           40, .true.)
            write(6,*)
            write(6,*)
            if (title .ne. ' ') then
               call util_print_centered(6, title, 40, .false.)
               write(6,*)
               write(6,*)
            endif
         endif
c     
         if (.not. rtdb_get(rtdb, 'task:energy', MT_DBL, 1, energy))
     &        call errquit
     &        ('stpr_walk: failed to read energy from rtdb', 911,
     &       RTDB_ERR)
c     
         if (.not. geom_create(geom, 'geometry'))
     &        call errquit('stpr_walk: geom_create?', 911, GEOM_ERR)
         if (.not. geom_rtdb_load(rtdb, geom, 'geometry'))
     &        call errquit('stpr_walk: no geometry ', 911, RTDB_ERR)
c     
*     rak:        write(6,*)' after load in stpr_walk'
*     rak:        if (.not.geom_print(geom)) stop 'tmp error'
c     
         if (.not. geom_ncent(geom,nat))
     &        call errquit('stpr_walk: geom_ncent?',911, GEOM_ERR)
c     
         call stpr_cneed(needed,nat) ! determine core needed
         needed = (needed + 1023)*1024/1024 ! nearest 1024 block
c     
c.....space for core array
         if (.not.MA_Push_Get(MT_DBL,needed,'stpr core',h_core,k_core))
     &        call errquit('stpr_walk: allocation for core failed?',911,
     &       MA_ERR)
c.....space for coords
         if (.not.
     &        MA_Push_Get(MT_DBL,(3*nat),'stpr coords',h_coord,k_coord))
     &        call errquit
     &        ('stpr_walk: allocation for coords failed?',911, MA_ERR)
c.....space for gradient
         if (.not.
     &        MA_Push_Get(MT_DBL,(3*nat),'stpr gradient',h_grad,k_grad))
     &        call errquit
     &        ('stpr_walk: allocation for gradient failed?',911, MA_ERR)
c.....space for charge
         if (.not.
     &        MA_Push_Get(MT_DBL,nat,'stpr geom charge',h_chg,k_chg))
     &        call errquit
     &        ('stpr_walk: allocation for geom charge failed?',911,
     &       MA_ERR)
c     
c.....read gradients
         if (.not. rtdb_get(rtdb, 'task:gradient', MT_DBL, 
     &        (3*nat),dbl_mb(k_grad)))
     &        call errquit
     &        ('stpr_walk: reading gradients failed',911, RTDB_ERR)
c     
c.....get coordinates
         if (.not. geom_cart_get(geom,nat,
     &        stpr_tags,
     &        dbl_mb(k_coord),
     &        dbl_mb(k_chg)))
     &        call errquit
     &        ('stpr_walk: geom_cart_get failed ?',911, GEOM_ERR)
c     
c...  take a step
c     
         convggm= 8.0d-04
         convgg = 1.0d-02
         convge = 1.0d-04
         call stpr_stepper(
     &        dbl_mb(k_core),
     &        needed,
     &        dbl_mb(k_grad),
     &        dbl_mb(k_coord),
     &        energy,nat,convge,convgg,convggm,lstpr_walk,
     &        rtdb,step_number)
c.....set coordinates
         if (.not. geom_cart_set(geom,nat,
     &        stpr_tags,
     &        dbl_mb(k_coord),
     &        dbl_mb(k_chg)))
     &        call errquit
     &        ('stpr_walk: geom_cart_set failed ?',911, GEOM_ERR)
C        output to ECCE
         astep_number = abs(step_number)
         call ecce_print1 ('iteration', mt_int, astep_number, 1)
         call ecce_print2 ('geometry', mt_dbl, dbl_mb(k_coord), 3,3,nat)
c
c     optionally delete the old geometry (done by default)
c     
         if (.not. rtdb_get(rtdb,'stepper:keepgeom', mt_log, 1, 
     $        okeepgeom)) okeepgeom = .false.
         if (step_number.gt.1 .and. (.not. okeepgeom)) then
            call stpr_new_geom_name(new_geom_name, step_number-1)
            if (.not. geom_rtdb_delete(rtdb,new_geom_name))
     $           call errquit('stpr_walk: rtdb corrupt? geom delete',
     $           step_number-1, RTDB_ERR)
         endif
c
c     copy the new geometry to the database with a new name
c
         call stpr_new_geom_name(new_geom_name, step_number)
c     
         call sym_geom_project(geom, 1d-4)
c     
         if (.not.geom_rtdb_store(rtdb,geom,new_geom_name))
     &        call errquit
     &        ('stpr_walk: geom_rtdb_store (of copy) failed',911,
     &       RTDB_ERR)
         if (util_print('new coordinates',print_low)) then
           if (lstpr_walk) then
             write(luout,11001)
           else
             write(luout,11002)
           endif
           if (.not.geom_print(geom)) call errquit(
     &         'stpr_walk: geom_print failed',911, GEOM_ERR)
         endif
         if (util_print('distances',print_default)) then
           if (.not.geom_print_distances(geom)) call errquit(
     &         'stpr_walk: geom_print_distances failed',911, GEOM_ERR)
         endif
         if (util_print('angles',print_default)) then
           if (.not.geom_print_angles(geom)) call errquit(
     &       'stpr_walk: geom_print_angles failed',911, GEOM_ERR)
         endif
         if (util_print('dihedrals',print_default)) then
           if (.not.geom_print_dihedrals(geom)) call errquit(
     &         'stpr_walk: geom_print_angles failed',911, GEOM_ERR)
         endif
c     
C**** #define ECCE
#if defined(ECCE)
         write(luout,*)'<stepper updated geometry> start '
         if(.not. geom_print(geom)) call errquit
     &        ('stpr_walk:geom print failed ',911, GEOM_ERR)
         write(luout,*)'<stepper updated geometry> end'
#endif
c     
         if(.not.rtdb_cput(rtdb,'geometry',1,new_geom_name))
     &        call errquit
     &        ('stpr_walk: rtdb_cput failed ?',911, RTDB_ERR)
c     
*     if(.not.rtdb_print(rtdb,.true.)) stop 'tmp error'
c     
*     rak---- old copy over geometry - start
*     rak:c
*     rak:c..... update rtdb with new coordinates        
*     rak:c
*     rak:*        if (.not. geom_print(geom))
*     rak:*     &      call errquit('stpr_walk: geom_print ?',911)
*     rak:        if (.not.geom_rtdb_store(rtdb,geom,'geometry'))
*     rak:     &      call errquit
*     rak:     &      ('stpr_walk: geom_rtdb_store failed ?',911)
*     rak:c
*     rak---- old copy over geometry - end
c...  clean up
         if (.not.geom_destroy(geom))
     &        call errquit('stpr_walk: geom_destroy failed?',911,
     &       GEOM_ERR)
*     if (.not.geom_destroy(new_geom))
*     &      call errquit('stpr_walk: geom_destroy failed?',911)
         if (.not.MA_Pop_Stack(h_chg))
     &        call errquit('stpr_walk: ma_pop_stack h_chg failed',911,
     &       MA_ERR)
         if (.not.MA_Pop_Stack(h_grad))
     &        call errquit('stpr_walk: ma_pop_stack h_grad failed',911,
     &       MA_ERR)
         if (.not.MA_Pop_Stack(h_coord))
     &        call errquit('stpr_walk: ma_pop_stack h_coord failed',911,
     &       MA_ERR)
         if (.not.MA_Pop_Stack(h_core))
     &        call errquit('stpr_walk: ma_pop_stack h_core failed',911,
     &       MA_ERR)
c     
         int_val = 0 
         if (lstpr_walk) int_val = 1
         if(step_number.le.0) then
            write(6,*)' maximum number of geometry optimization ',
     &           'iterations exceeded:  restartable shutdown will occur'
            int_val = -1
         endif
      endif
c     
      call ga_brdcst(Msg_Stpr_Walk+MSGINT, int_val, mitob(1), 0) ! Propagate walker status
c     
      lstpr_walk = .false.
      if (int_val.gt.0) lstpr_walk = .true.
      stpr_walk = int_val
c     
c.... restore parallel access to rtdb
      status = rtdb_parallel(.true.) 
c     
      if (o_timewalk) then
         call pstat_off(i_timewalk)
         call pstat_print_handles(i_timewalk,1)
         write(6,*)' '
         o_timewalk = .false.
         if (.not.pstat_free(i_timewalk))
     &        call errquit('stpr_walk: pstat_free failed?',911, MEM_ERR)
      endif
c     
      
      if (stpr_walk.lt.0) then
        call ecce_print_module_exit
     &      ('stepper','failed : maxiter reached')
      else
        call ecce_print_module_exit ('stepper','ok')
      endif
      call util_print_pop
      call ga_sync()
c     
11001 format(/,/,/,'  ',16('-'),' Converged geometry ',16('-'))
11002 format(/,/,/,'  ',19('-'),' New geometry ',19('-'))
      end
      subroutine stpr_walk_reset
      implicit none
c
      integer iwctr, natom, icalc
      COMMON / CFACE / IWCTR,NATOM,ICALC
c
      iwctr = 0
      natom = 0
      icalc = 0
c
      end
C>
C> @}
C> \ingroup stpr_priv
C> @{
C>
      subroutine stpr_new_geom_name(new_geom_name, step_number)
      implicit none
c
      character*(*) new_geom_name
      integer step_number
c
c     Construct a name for the geometry at this step
c
      new_geom_name = ' '
      if (abs(step_number) .lt. 10) then
         write(new_geom_name,'(''g-'',i1,''-step'')') 
     $        abs(step_number)
      else if (abs(step_number) .lt. 100) then
         write(new_geom_name,'(''g-'',i2,''-step'')') 
     $        abs(step_number)
      else if (abs(step_number) .lt. 1000) then
         write(new_geom_name,'(''g-'',i3,''-step'')') 
     $        abs(step_number)
      else
         write(new_geom_name,'(''g-'',i4,''-step'')') 
     $        abs(step_number)
      endif
c
      end
      logical function stpr_walk_task(rtdb)
      implicit none
#include "util.fh"
#include "stdio.fh"
#include "global.fh"
      integer rtdb
*
      double precision gradw_time
      integer grad_time
      logical grad_status
      logical me_write
      integer value_stpr_walk
      integer stpr_walk
      external stpr_walk
      logical task_gradient
      external task_gradient
*
      stpr_walk_task = .false.
      call stpr_walk_reset()
*
      me_write = ga_nodeid().eq.0
00010 continue
      gradw_time = (-1.0d00) * util_wallsec()
      grad_status = task_gradient(rtdb)
      gradw_time = (gradw_time + util_wallsec())*1.2d00 ! add 20 percent
      grad_time = int(gradw_time)
      if (.not. grad_status) then
        if (me_write) then
          write(luout,*)' stpr_walk_task: energy+gradient failed',
     &              ' ... optimization incomplete'
          call util_flush(luout)
        endif
      endif
      value_stpr_walk = stpr_walk(rtdb)
c
c     Disable printing of movecs to ecce after the first step
c     ... reenable at the end
c
      call movecs_ecce_print_off()
c
      if (value_stpr_walk .eq. 0) then
        if (util_test_time_remaining(rtdb,grad_time)) then
          goto 00010
        else
          stpr_walk_task = .false.
          if (me_write) then
            write(luout,*)
     &          ' remaining time is not long enough for next step'
            call util_flush(luout)
          endif
        endif
      else if (value_stpr_walk.eq.1) then
        stpr_walk_task = .true.
      endif
c
      call movecs_ecce_print_on()
c
      end
C>
C> @}

      logical function argos_prep_disres(card,card2,isegm,csa,msa,nsa,
     + inoe,dnoe,mnoe,nnoe)
c
c $Id: argos_prep_disres.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "inp.fh"
c
      logical argos_prep_str_replace
      external argos_prep_str_replace
c
      integer mnoe,nnoe,msa,nsa
      integer isegm(msa),inoe(2,mnoe)
      real*8 dnoe(5,mnoe)
      character*16 csa(msa)
      character*80 card,card2
      integer i,ifr,ito
      character*255 target,atomi,atomj
      integer ndx,iatom,jatom,isgm,jsgm
c
      card=card(8:80)
c
      ifr=0
      if(.not.inp_strtok(card,' ',ifr,ito))
     + call md_abort('Unable to find atom',9999)
      target=card(ifr:ito)//' '
      ndx=index(target,':')
      read(target(1:ndx-1),*) isgm
      atomi=target(ndx+1:index(target,' ')-1)//'      '
      if(.not.argos_prep_str_replace(atomi,'_',' '))
     + call md_abort('argos_prep_str_replace',9999)
      if(.not.inp_strtok(card,' ',ifr,ito))
     + call md_abort('Unable to find atom',9999)
      target=card(ifr:ito)//' '
      ndx=index(target,':')
      read(target(1:ndx-1),*) jsgm
      atomj=target(ndx+1:index(target,' ')-1)//'      '
      if(.not.argos_prep_str_replace(atomj,'_',' '))
     + call md_abort('argos_prep_str_replace',9999)
      iatom=0
      jatom=0
      do 1 i=1,nsa
      if(isgm.eq.isegm(i).and.atomi(1:4).eq.csa(i)(11:14)) iatom=i
      if(jsgm.eq.isegm(i).and.atomj(1:4).eq.csa(i)(11:14)) jatom=i
    1 continue
      if(iatom.eq.0.or.jatom.eq.0)
     + call md_abort('argos_prep_disres error',9999)
      nnoe=nnoe+1
      if(nnoe.gt.mnoe) call md_abort('Increase mnoe',9999)
      inoe(1,nnoe)=iatom
      inoe(2,nnoe)=jatom
      read(card2,1000) (dnoe(i,nnoe),i=1,5)
 1000 format(3f12.6,2e12.5)
c
      argos_prep_disres=.true.
      return
c
 9999 continue
      argos_prep_disres=.false.
      return
      end

      subroutine smd_geom_monomer_create(im)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
#include "bq.fh"
c
      integer im
c     
      character*32 sp_coords,sp_atom,sp_charge,sp_mass
      character*32 tag,pname
      logical result
      integer i_ir,i_ta,i_q,i_c,i_m,i_qf
      integer i_ct,h_ct
      integer i_cd,h_cd
      integer i,j
      integer nt,nm,i0
      integer rtdb
      integer igeom
      integer bq_handle
      integer nbq,i_qbq,i_cbq
      double precision scale
      double precision cm(3)
c
      logical geom_cart_set1
      external geom_cart_set1
      pname = "smd_geom_monomer_create"
c
      call smd_rtdb_get_handle(rtdb)
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "coordinates"
      call smd_system_get_component(sp_coords,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "charge"
      call smd_system_get_component(sp_charge,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "mass"
      call smd_system_get_component(sp_mass,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

c     
      tag = "coords"
      call smd_data_get_index(sp_coords,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "charge"
      call smd_data_get_index(sp_charge,tag,i_q,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      tag = "atom:name"
      call smd_data_get_index(sp_atom,tag,i_ta,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      tag = "atom:formal_charge"
      call smd_data_get_index(sp_atom,tag,i_qf,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:resid"
      call smd_data_get_index(sp_atom,tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      call smd_data_get_size(sp_atom,tag,nt,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

c
      tag = "mass"
      call smd_data_get_index(sp_mass,tag,i_m,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

c    
      call smd_geom_monomer_index_size(im,nt,int_mb(i_ir),nm,i0)
c
c      write(*,*) "monomer size",i0,nm
c
      if(.not.ma_push_get(mt_dbl,3*nm,'tmp',h_cd,i_cd))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nm, MA_ERR)
 
c
      if(.not.ma_push_get(mt_dbl,3*nt,'tmp',h_ct,i_ct))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nm, MA_ERR)
 
c
c     shift box so that monomer is in the center
c     -----------------------------------------
      do i=1,3*nt
        dbl_mb(i_ct+i-1) = dbl_mb(i_c+i-1)
      end do

      call smd_geom_recenter(nt,nm,i0,dbl_mb(i_cd),
     >                       dbl_mb(i_ct))

      if(.not.geom_create(igeom,"geometry"))
     + call errquit('qmmm: Failed to create geometry',0, GEOM_ERR)

     
      if(.not.geom_cart_set1(igeom,i0,nm,nt,byte_mb(i_ta),
     + dbl_mb(i_ct),dbl_mb(i_qf)))
     + call errquit('qmmm: Failed to initialize geometry',0, GEOM_ERR)

      if(.not.geom_masses_set(igeom,nm,dbl_mb(i_m+i0-1)))
     + call errquit('qmmm: Failed to initialize masses',0, GEOM_ERR)
      call geom_compute_values(igeom)
c
c      if (.not. geom_print(igeom))
c     + call errquit('qmmm: Failed to initialize masses',0, GEOM_ERR)
c
      if(.not.geom_rtdb_store(rtdb,igeom,"geometry"))
     + call errquit('qmmm: Failed to store geom to rtdb',0, RTDB_ERR)

       if(.not.geom_destroy(igeom))
     + call errquit('qmmm: Failed to destroy geometry',0, GEOM_ERR)

c      call smd_coords_print(55)
c
c     now do the charges
c
      nbq = nt - nm
      if(.not.bq_create("monomer charges",bq_handle))
     + call errquit(pname//'Failed bq_create',0,CALC_ERR)

      if(.not.bq_alloc(bq_handle,nbq))
     + call errquit(pname//'Failed bq_create',0,CALC_ERR)


      if(.not.bq_index_coord(bq_handle,i_cbq))
     + call errquit(pname//'Failed bq_index',0,CALC_ERR)

      if(.not.bq_index_charge(bq_handle,i_qbq))
     + call errquit(pname//'Failed bq_index',0,CALC_ERR)

      scale = 1.88972598858d0

      do i=1,i0-1
         do j=1,3
            dbl_mb(i_cbq+3*(i-1)+j-1)=dbl_mb(i_ct+nt*(j-1)+i-1)*scale
         end do
         dbl_mb(i_qbq+i-1)=dbl_mb(i_q+i-1)
      end do

      do i=i0,nbq
         do j=1,3
            dbl_mb(i_cbq+3*(i-1)+j-1)=dbl_mb(i_ct+nt*(j-1)+i-1+nm)
     >                                *scale
         end do
         dbl_mb(i_qbq+i-1)=dbl_mb(i_q+nm+i-1)
      end do

c      call bq_print_info(bq_handle)

      if(.not.bq_activate(bq_handle))
     + call errquit(pname//'Failed bq_activate',0,CALC_ERR)
c


      if(.not.ma_pop_stack(h_ct))
     & call errquit(pname//'Failed to deallocate stack h_l',nm,
     &       MA_ERR)
      if(.not.ma_pop_stack(h_cd))
     & call errquit(pname//'Failed to deallocate stack h_l',nm,
     &       MA_ERR)
c


      return
      end
c
      subroutine smd_geom_monomer_end()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
#include "bq.fh"
c
      integer bq_handle

      character*32 pname

      pname = "smd_geom_end"
      if(.not.bq_get_active(bq_handle))
     + call errquit(pname//'Failed bq_get_active',0,CALC_ERR)

      if(.not.bq_destroy(bq_handle))
     + call errquit(pname//'Failed bq_destroy',0,CALC_ERR)


      return
      end
c
      subroutine smd_geom_recenter(nt,nm,i0,cm,c)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer nt
      integer nm
      integer i0
      double precision cm(nm,3)
      double precision c(nt,3)
c
      integer i,j
      double precision cshift(3)
      double precision com(3)
c
c     assemble a complete residue
c     ---------------------------
      do j=1,3
         cshift(j)=c(i0,j)
      end do

      do i=1,nm
      do j=1,3
         cm(i,j)=c(i0+i-1,j)-cshift(j)
      end do
      end do
 
      call smd_lat_rebox(nm,cm) 

      do i=1,nm
      do j=1,3
         cm(i,j)=cm(i,j)+cshift(j)
      end do
      end do
c
c     shift the entire box so that
c     monomer geom. center is at the 
c     center
c     ------------------------------ 
      com(1) = 0.0d0
      com(2) = 0.0d0
      com(3) = 0.0d0
      
      do i=1,nm
      do j=1,3
         com(j)=com(j)+cm(i,j)
      end do
      end do

      com(1) = com(1)/3.0d0 
      com(2) = com(2)/3.0d0 
      com(3) = com(3)/3.0d0 

      do i=1,nt
      do j=1,3
         c(i,j)=c(i,j)-com(j)
      end do
      end do
 
      call smd_lat_rebox(nt,c) 

c
      return
c
  
      end
c
      subroutine smd_geom_push_charges(im)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "geom.fh"
c
      integer im
c     
      character*32 sp_coords,sp_atom,sp_charge,sp_mass
      character*32 tag,pname
      logical result
      integer i_ir,i_ta,i_q,i_c,i_m,i_qf
      integer i_ct,h_ct
      integer i,j
      integer nt,nm,i0,nqm
      integer rtdb
      integer igeom
c
      logical geom_cart_set1
      external geom_cart_set1
      logical geom_rtdb_ncent
      external geom_rtdb_ncent
c
      pname = "smd_geom_push_charges"
c
      call smd_rtdb_get_handle(rtdb)
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "coordinates"
      call smd_system_get_component(sp_coords,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "charge"
      call smd_system_get_component(sp_charge,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)
c
      tag = "mass"
      call smd_system_get_component(sp_mass,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

c     
      tag = "coords"
      call smd_data_get_index(sp_coords,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      tag = "charge"
      call smd_data_get_index(sp_charge,tag,i_q,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      tag = "atom:name"
      call smd_data_get_index(sp_atom,tag,i_ta,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
      tag = "atom:formal_charge"
      call smd_data_get_index(sp_atom,tag,i_qf,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
      tag = "atom:resid"
      call smd_data_get_index(sp_atom,tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      call smd_data_get_size(sp_atom,tag,nt,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

c
      tag = "mass"
      call smd_data_get_index(sp_mass,tag,i_m,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

c    
      call smd_geom_monomer_index_size(im,nt,int_mb(i_ir),nm,i0)
c
      if(.not.ma_push_get(mt_dbl,3*nm,'tmp',h_ct,i_ct))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nm, MA_ERR)

      if(.not.geom_create(igeom,"geometry"))
     + call errquit('qmmm: Failed to create geometry',0, GEOM_ERR)

c
c     pick the best available charge geometry
c     ---------------------------------------
      tag = "cresp:geometry"
      result = geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      if(.not.result) then
        tag = "resp:geometry"
        result =  geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      end if
      if(.not.result) then
        tag = "cesp:geometry"
        result =  geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      end if
      if(.not.result) then
        tag = "esp:geometry"
        result =  geom_rtdb_ncent(rtdb,tag(1:inp_strlen(tag)),nqm)
      end if

      if(.not.result) then
         call errquit(pname//'cannot find charges')
      end if

      if(nqm.ne.nm)
     + call errquit(pname//'mismatch in sizes'//tag,0, GEOM_ERR)

      if(.not.geom_rtdb_load(rtdb,igeom,tag(1:inp_strlen(tag))))
     + call errquit(pname//'Failed to load geometry'//tag,0, GEOM_ERR)

      if(.not.geom_cart_get_charges(igeom,nm,dbl_mb(i_q+i0-1)))
     + call errquit(pname//'Failed to get charges',0, GEOM_ERR)

       if(.not.geom_destroy(igeom))
     + call errquit(pname//'Failed to destroy geometry',0, GEOM_ERR)

c
      if(.not.ma_pop_stack(h_ct))
     & call errquit(pname//'Failed to deallocate stack h_l',nm,
     &       MA_ERR)
c
      return
      end
c
      subroutine smd_geom_monomer_index_size(im,nt,ir,nm,i0)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer im
      integer rtdb
      integer nt
      integer ir(nt)
      integer nm
      integer i0
c
      integer i,j
c
c     count number of atoms in residue im
c     contigious storage is presumed
c     -----------------------------------
      nm = 0
      do i=1,nt
       j = i
       if(im.eq.ir(i)) then
100     continue
        nm = nm + 1
        j = j + 1
        if(im.eq.ir(j)) then
         goto 100
        else
         goto 101 
        end if
       end if
      end do
101   continue
      i0=i
      return
c
  
      end

c $Id: smd_geom.F 22502 2012-05-20 06:11:57Z d3y133 $

#ifdef SNGLPR
      Subroutine SGeCop (TRANSA, M, N, A, LDA, B, LDB)
#else
      Subroutine DGeCop (TRANSA, M, N, A, LDA, B, LDB)
#endif
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: dgecop.F 19697 2010-10-29 16:57:34Z d3y133 $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     dgecop, sgecop -- copies one matrix into another
C
C SYNOPSIS
      Implicit NONE
      Character*1 TRANSA
      Integer M, N, LDA, LDB
#ifdef SNGLPR
      Real A(LDA,*), B(LDB,*)
#else
      Double precision A(LDA,*), B(LDB,*)
#endif
C
C ARGUMENTS
C     TRANSA  Consider the source to be A or A' (input)
C     M       Rows of B (input)
C     N       Columns of B (input)
C     A       Source matrix (input)
C     LDA     Leading dimension of A (input)
C     B       Destination matrix (output)
C     LDB     Leading dimension of B (input)
C
C DESCRIPTION
C     Copies one general matrix into another
C
C ROUTINES REQUIRED
C     From BLAS -- Support routines
      Logical LSame
      External LSame, XErBLA
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Integer i, j, Info
      Logical NotA
C
C     Test input parameters
C
      NotA = LSame( TransA, 'N')
C
      Info = 0
      If ( .not. (NotA .OR. LSame(TransA, 'T')
     $   .OR. LSame(TransA, 'C')) ) then
         Info = 1
      ElseIf (M .lt. 0) then
         Info = 2
      ElseIf (N .lt. 0) then
         Info = 3
      ElseIf ((LDA .lt. Max(1, M) .AND. NotA)
     $      .OR. ( LDA .lt. Max(1, N) .AND. .NOT. NotA)) then
         Info = 5
      ElseIf (LDB .lt. Max(1, M)) then
         Info = 7
      EndIf
      If (Info .ne. 0) then
#ifdef SNGLPR
         Call XErBLA('SGECOP', Info)
#else
         Call XErBLA('DGECOP', Info)
#endif
         Return
      EndIf
C
C     See if we can get away easily
C
      If (M .eq. 0 .OR. N .eq. 0) Return
C
C     Gotta do the work...
C
      If (NotA) then
c==========================================
c JUST COPY
c==========================================
#if defined(BLAS_COPY)
c------------------------------------------
c BLAS VERSION
c------------------------------------------
#ifdef SNGLPR
         call scopy(M*N,A,1,B,1)
#else
         call dcopy(M*N,A,1,B,1)
#endif

c------------------------------------------
#else
c------------------------------------------
c SLOW VERSION
c------------------------------------------
         Do 100 j = 1, N
            Do 110 i = 1, M
               B(i,j) = A(i,j)
 110        Continue
 100     Continue
c------------------------------------------
#endif
      Else
c==========================================
c TRANSPOSE
c==========================================
#if defined(ESSL_TRANSPOSE)
c------------------------------------------
c ESSL VERSION
c------------------------------------------
#ifdef SNGLPR
      call sgetmo(A,M,LDA,N,B,LDB)
#else
      call dgetmo(A,M,LDA,N,B,LDB)
#endif
#elif defined(OSU_TRANSPOSE)
c------------------------------------------
c OSU VERSION
c------------------------------------------
      call osu_transpose(A,B,M,N)
#else
c------------------------------------------
c SLOW VERSION
c------------------------------------------
         Do 200 j = 1, N
            Do 210 i = 1, M
               B(i,j) = A(j,i)
 210        Continue
 200     Continue
#endif
      EndIf
c==========================================
C
      Return
      End

*> \brief \b SLAQR5 performs a single small-bulge multi-shift QR sweep.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SLAQR5 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/slaqr5.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/slaqr5.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/slaqr5.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SLAQR5( WANTT, WANTZ, KACC22, N, KTOP, KBOT, NSHFTS,
*                          SR, SI, H, LDH, ILOZ, IHIZ, Z, LDZ, V, LDV, U,
*                          LDU, NV, WV, LDWV, NH, WH, LDWH )
* 
*       .. Scalar Arguments ..
*       INTEGER            IHIZ, ILOZ, KACC22, KBOT, KTOP, LDH, LDU, LDV,
*      $                   LDWH, LDWV, LDZ, N, NH, NSHFTS, NV
*       LOGICAL            WANTT, WANTZ
*       ..
*       .. Array Arguments ..
*       REAL               H( LDH, * ), SI( * ), SR( * ), U( LDU, * ),
*      $                   V( LDV, * ), WH( LDWH, * ), WV( LDWV, * ),
*      $                   Z( LDZ, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    SLAQR5, called by SLAQR0, performs a
*>    single small-bulge multi-shift QR sweep.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] WANTT
*> \verbatim
*>          WANTT is logical scalar
*>             WANTT = .true. if the quasi-triangular Schur factor
*>             is being computed.  WANTT is set to .false. otherwise.
*> \endverbatim
*>
*> \param[in] WANTZ
*> \verbatim
*>          WANTZ is logical scalar
*>             WANTZ = .true. if the orthogonal Schur factor is being
*>             computed.  WANTZ is set to .false. otherwise.
*> \endverbatim
*>
*> \param[in] KACC22
*> \verbatim
*>          KACC22 is integer with value 0, 1, or 2.
*>             Specifies the computation mode of far-from-diagonal
*>             orthogonal updates.
*>        = 0: SLAQR5 does not accumulate reflections and does not
*>             use matrix-matrix multiply to update far-from-diagonal
*>             matrix entries.
*>        = 1: SLAQR5 accumulates reflections and uses matrix-matrix
*>             multiply to update the far-from-diagonal matrix entries.
*>        = 2: SLAQR5 accumulates reflections, uses matrix-matrix
*>             multiply to update the far-from-diagonal matrix entries,
*>             and takes advantage of 2-by-2 block structure during
*>             matrix multiplies.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is integer scalar
*>             N is the order of the Hessenberg matrix H upon which this
*>             subroutine operates.
*> \endverbatim
*>
*> \param[in] KTOP
*> \verbatim
*>          KTOP is integer scalar
*> \endverbatim
*>
*> \param[in] KBOT
*> \verbatim
*>          KBOT is integer scalar
*>             These are the first and last rows and columns of an
*>             isolated diagonal block upon which the QR sweep is to be
*>             applied. It is assumed without a check that
*>                       either KTOP = 1  or   H(KTOP,KTOP-1) = 0
*>             and
*>                       either KBOT = N  or   H(KBOT+1,KBOT) = 0.
*> \endverbatim
*>
*> \param[in] NSHFTS
*> \verbatim
*>          NSHFTS is integer scalar
*>             NSHFTS gives the number of simultaneous shifts.  NSHFTS
*>             must be positive and even.
*> \endverbatim
*>
*> \param[in,out] SR
*> \verbatim
*>          SR is REAL array of size (NSHFTS)
*> \endverbatim
*>
*> \param[in,out] SI
*> \verbatim
*>          SI is REAL array of size (NSHFTS)
*>             SR contains the real parts and SI contains the imaginary
*>             parts of the NSHFTS shifts of origin that define the
*>             multi-shift QR sweep.  On output SR and SI may be
*>             reordered.
*> \endverbatim
*>
*> \param[in,out] H
*> \verbatim
*>          H is REAL array of size (LDH,N)
*>             On input H contains a Hessenberg matrix.  On output a
*>             multi-shift QR sweep with shifts SR(J)+i*SI(J) is applied
*>             to the isolated diagonal block in rows and columns KTOP
*>             through KBOT.
*> \endverbatim
*>
*> \param[in] LDH
*> \verbatim
*>          LDH is integer scalar
*>             LDH is the leading dimension of H just as declared in the
*>             calling procedure.  LDH.GE.MAX(1,N).
*> \endverbatim
*>
*> \param[in] ILOZ
*> \verbatim
*>          ILOZ is INTEGER
*> \endverbatim
*>
*> \param[in] IHIZ
*> \verbatim
*>          IHIZ is INTEGER
*>             Specify the rows of Z to which transformations must be
*>             applied if WANTZ is .TRUE.. 1 .LE. ILOZ .LE. IHIZ .LE. N
*> \endverbatim
*>
*> \param[in,out] Z
*> \verbatim
*>          Z is REAL array of size (LDZ,IHI)
*>             If WANTZ = .TRUE., then the QR Sweep orthogonal
*>             similarity transformation is accumulated into
*>             Z(ILOZ:IHIZ,ILO:IHI) from the right.
*>             If WANTZ = .FALSE., then Z is unreferenced.
*> \endverbatim
*>
*> \param[in] LDZ
*> \verbatim
*>          LDZ is integer scalar
*>             LDA is the leading dimension of Z just as declared in
*>             the calling procedure. LDZ.GE.N.
*> \endverbatim
*>
*> \param[out] V
*> \verbatim
*>          V is REAL array of size (LDV,NSHFTS/2)
*> \endverbatim
*>
*> \param[in] LDV
*> \verbatim
*>          LDV is integer scalar
*>             LDV is the leading dimension of V as declared in the
*>             calling procedure.  LDV.GE.3.
*> \endverbatim
*>
*> \param[out] U
*> \verbatim
*>          U is REAL array of size
*>             (LDU,3*NSHFTS-3)
*> \endverbatim
*>
*> \param[in] LDU
*> \verbatim
*>          LDU is integer scalar
*>             LDU is the leading dimension of U just as declared in the
*>             in the calling subroutine.  LDU.GE.3*NSHFTS-3.
*> \endverbatim
*>
*> \param[in] NH
*> \verbatim
*>          NH is integer scalar
*>             NH is the number of columns in array WH available for
*>             workspace. NH.GE.1.
*> \endverbatim
*>
*> \param[out] WH
*> \verbatim
*>          WH is REAL array of size (LDWH,NH)
*> \endverbatim
*>
*> \param[in] LDWH
*> \verbatim
*>          LDWH is integer scalar
*>             Leading dimension of WH just as declared in the
*>             calling procedure.  LDWH.GE.3*NSHFTS-3.
*> \endverbatim
*>
*> \param[in] NV
*> \verbatim
*>          NV is integer scalar
*>             NV is the number of rows in WV agailable for workspace.
*>             NV.GE.1.
*> \endverbatim
*>
*> \param[out] WV
*> \verbatim
*>          WV is REAL array of size
*>             (LDWV,3*NSHFTS-3)
*> \endverbatim
*>
*> \param[in] LDWV
*> \verbatim
*>          LDWV is integer scalar
*>             LDWV is the leading dimension of WV as declared in the
*>             in the calling subroutine.  LDWV.GE.NV.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup realOTHERauxiliary
*
*> \par Contributors:
*  ==================
*>
*>       Karen Braman and Ralph Byers, Department of Mathematics,
*>       University of Kansas, USA
*
*> \par References:
*  ================
*>
*>       K. Braman, R. Byers and R. Mathias, The Multi-Shift QR
*>       Algorithm Part I: Maintaining Well Focused Shifts, and Level 3
*>       Performance, SIAM Journal of Matrix Analysis, volume 23, pages
*>       929--947, 2002.
*>
*  =====================================================================
      SUBROUTINE SLAQR5( WANTT, WANTZ, KACC22, N, KTOP, KBOT, NSHFTS,
     $                   SR, SI, H, LDH, ILOZ, IHIZ, Z, LDZ, V, LDV, U,
     $                   LDU, NV, WV, LDWV, NH, WH, LDWH )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            IHIZ, ILOZ, KACC22, KBOT, KTOP, LDH, LDU, LDV,
     $                   LDWH, LDWV, LDZ, N, NH, NSHFTS, NV
      LOGICAL            WANTT, WANTZ
*     ..
*     .. Array Arguments ..
      REAL               H( LDH, * ), SI( * ), SR( * ), U( LDU, * ),
     $                   V( LDV, * ), WH( LDWH, * ), WV( LDWV, * ),
     $                   Z( LDZ, * )
*     ..
*
*  ================================================================
*     .. Parameters ..
      REAL               ZERO, ONE
      PARAMETER          ( ZERO = 0.0e0, ONE = 1.0e0 )
*     ..
*     .. Local Scalars ..
      REAL               ALPHA, BETA, H11, H12, H21, H22, REFSUM,
     $                   SAFMAX, SAFMIN, SCL, SMLNUM, SWAP, TST1, TST2,
     $                   ULP
      INTEGER            I, I2, I4, INCOL, J, J2, J4, JBOT, JCOL, JLEN,
     $                   JROW, JTOP, K, K1, KDU, KMS, KNZ, KRCOL, KZS,
     $                   M, M22, MBOT, MEND, MSTART, MTOP, NBMPS, NDCOL,
     $                   NS, NU
      LOGICAL            ACCUM, BLK22, BMP22
*     ..
*     .. External Functions ..
      REAL               SLAMCH
      EXTERNAL           SLAMCH
*     ..
*     .. Intrinsic Functions ..
*
      INTRINSIC          ABS, MAX, MIN, MOD, REAL
*     ..
*     .. Local Arrays ..
      REAL               VT( 3 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM, SLABAD, SLACPY, SLAQR1, SLARFG, SLASET,
     $                   STRMM
*     ..
*     .. Executable Statements ..
*
*     ==== If there are no shifts, then there is nothing to do. ====
*
      IF( NSHFTS.LT.2 )
     $   RETURN
*
*     ==== If the active block is empty or 1-by-1, then there
*     .    is nothing to do. ====
*
      IF( KTOP.GE.KBOT )
     $   RETURN
*
*     ==== Shuffle shifts into pairs of real shifts and pairs
*     .    of complex conjugate shifts assuming complex
*     .    conjugate shifts are already adjacent to one
*     .    another. ====
*
      DO 10 I = 1, NSHFTS - 2, 2
         IF( SI( I ).NE.-SI( I+1 ) ) THEN
*
            SWAP = SR( I )
            SR( I ) = SR( I+1 )
            SR( I+1 ) = SR( I+2 )
            SR( I+2 ) = SWAP
*
            SWAP = SI( I )
            SI( I ) = SI( I+1 )
            SI( I+1 ) = SI( I+2 )
            SI( I+2 ) = SWAP
         END IF
   10 CONTINUE
*
*     ==== NSHFTS is supposed to be even, but if it is odd,
*     .    then simply reduce it by one.  The shuffle above
*     .    ensures that the dropped shift is real and that
*     .    the remaining shifts are paired. ====
*
      NS = NSHFTS - MOD( NSHFTS, 2 )
*
*     ==== Machine constants for deflation ====
*
      SAFMIN = SLAMCH( 'SAFE MINIMUM' )
      SAFMAX = ONE / SAFMIN
      CALL SLABAD( SAFMIN, SAFMAX )
      ULP = SLAMCH( 'PRECISION' )
      SMLNUM = SAFMIN*( REAL( N ) / ULP )
*
*     ==== Use accumulated reflections to update far-from-diagonal
*     .    entries ? ====
*
      ACCUM = ( KACC22.EQ.1 ) .OR. ( KACC22.EQ.2 )
*
*     ==== If so, exploit the 2-by-2 block structure? ====
*
      BLK22 = ( NS.GT.2 ) .AND. ( KACC22.EQ.2 )
*
*     ==== clear trash ====
*
      IF( KTOP+2.LE.KBOT )
     $   H( KTOP+2, KTOP ) = ZERO
*
*     ==== NBMPS = number of 2-shift bulges in the chain ====
*
      NBMPS = NS / 2
*
*     ==== KDU = width of slab ====
*
      KDU = 6*NBMPS - 3
*
*     ==== Create and chase chains of NBMPS bulges ====
*
      DO 220 INCOL = 3*( 1-NBMPS ) + KTOP - 1, KBOT - 2, 3*NBMPS - 2
         NDCOL = INCOL + KDU
         IF( ACCUM )
     $      CALL SLASET( 'ALL', KDU, KDU, ZERO, ONE, U, LDU )
*
*        ==== Near-the-diagonal bulge chase.  The following loop
*        .    performs the near-the-diagonal part of a small bulge
*        .    multi-shift QR sweep.  Each 6*NBMPS-2 column diagonal
*        .    chunk extends from column INCOL to column NDCOL
*        .    (including both column INCOL and column NDCOL). The
*        .    following loop chases a 3*NBMPS column long chain of
*        .    NBMPS bulges 3*NBMPS-2 columns to the right.  (INCOL
*        .    may be less than KTOP and and NDCOL may be greater than
*        .    KBOT indicating phantom columns from which to chase
*        .    bulges before they are actually introduced or to which
*        .    to chase bulges beyond column KBOT.)  ====
*
         DO 150 KRCOL = INCOL, MIN( INCOL+3*NBMPS-3, KBOT-2 )
*
*           ==== Bulges number MTOP to MBOT are active double implicit
*           .    shift bulges.  There may or may not also be small
*           .    2-by-2 bulge, if there is room.  The inactive bulges
*           .    (if any) must wait until the active bulges have moved
*           .    down the diagonal to make room.  The phantom matrix
*           .    paradigm described above helps keep track.  ====
*
            MTOP = MAX( 1, ( ( KTOP-1 )-KRCOL+2 ) / 3+1 )
            MBOT = MIN( NBMPS, ( KBOT-KRCOL ) / 3 )
            M22 = MBOT + 1
            BMP22 = ( MBOT.LT.NBMPS ) .AND. ( KRCOL+3*( M22-1 ) ).EQ.
     $              ( KBOT-2 )
*
*           ==== Generate reflections to chase the chain right
*           .    one column.  (The minimum value of K is KTOP-1.) ====
*
            DO 20 M = MTOP, MBOT
               K = KRCOL + 3*( M-1 )
               IF( K.EQ.KTOP-1 ) THEN
                  CALL SLAQR1( 3, H( KTOP, KTOP ), LDH, SR( 2*M-1 ),
     $                         SI( 2*M-1 ), SR( 2*M ), SI( 2*M ),
     $                         V( 1, M ) )
                  ALPHA = V( 1, M )
                  CALL SLARFG( 3, ALPHA, V( 2, M ), 1, V( 1, M ) )
               ELSE
                  BETA = H( K+1, K )
                  V( 2, M ) = H( K+2, K )
                  V( 3, M ) = H( K+3, K )
                  CALL SLARFG( 3, BETA, V( 2, M ), 1, V( 1, M ) )
*
*                 ==== A Bulge may collapse because of vigilant
*                 .    deflation or destructive underflow.  In the
*                 .    underflow case, try the two-small-subdiagonals
*                 .    trick to try to reinflate the bulge.  ====
*
                  IF( H( K+3, K ).NE.ZERO .OR. H( K+3, K+1 ).NE.
     $                ZERO .OR. H( K+3, K+2 ).EQ.ZERO ) THEN
*
*                    ==== Typical case: not collapsed (yet). ====
*
                     H( K+1, K ) = BETA
                     H( K+2, K ) = ZERO
                     H( K+3, K ) = ZERO
                  ELSE
*
*                    ==== Atypical case: collapsed.  Attempt to
*                    .    reintroduce ignoring H(K+1,K) and H(K+2,K).
*                    .    If the fill resulting from the new
*                    .    reflector is too large, then abandon it.
*                    .    Otherwise, use the new one. ====
*
                     CALL SLAQR1( 3, H( K+1, K+1 ), LDH, SR( 2*M-1 ),
     $                            SI( 2*M-1 ), SR( 2*M ), SI( 2*M ),
     $                            VT )
                     ALPHA = VT( 1 )
                     CALL SLARFG( 3, ALPHA, VT( 2 ), 1, VT( 1 ) )
                     REFSUM = VT( 1 )*( H( K+1, K )+VT( 2 )*
     $                        H( K+2, K ) )
*
                     IF( ABS( H( K+2, K )-REFSUM*VT( 2 ) )+
     $                   ABS( REFSUM*VT( 3 ) ).GT.ULP*
     $                   ( ABS( H( K, K ) )+ABS( H( K+1,
     $                   K+1 ) )+ABS( H( K+2, K+2 ) ) ) ) THEN
*
*                       ==== Starting a new bulge here would
*                       .    create non-negligible fill.  Use
*                       .    the old one with trepidation. ====
*
                        H( K+1, K ) = BETA
                        H( K+2, K ) = ZERO
                        H( K+3, K ) = ZERO
                     ELSE
*
*                       ==== Stating a new bulge here would
*                       .    create only negligible fill.
*                       .    Replace the old reflector with
*                       .    the new one. ====
*
                        H( K+1, K ) = H( K+1, K ) - REFSUM
                        H( K+2, K ) = ZERO
                        H( K+3, K ) = ZERO
                        V( 1, M ) = VT( 1 )
                        V( 2, M ) = VT( 2 )
                        V( 3, M ) = VT( 3 )
                     END IF
                  END IF
               END IF
   20       CONTINUE
*
*           ==== Generate a 2-by-2 reflection, if needed. ====
*
            K = KRCOL + 3*( M22-1 )
            IF( BMP22 ) THEN
               IF( K.EQ.KTOP-1 ) THEN
                  CALL SLAQR1( 2, H( K+1, K+1 ), LDH, SR( 2*M22-1 ),
     $                         SI( 2*M22-1 ), SR( 2*M22 ), SI( 2*M22 ),
     $                         V( 1, M22 ) )
                  BETA = V( 1, M22 )
                  CALL SLARFG( 2, BETA, V( 2, M22 ), 1, V( 1, M22 ) )
               ELSE
                  BETA = H( K+1, K )
                  V( 2, M22 ) = H( K+2, K )
                  CALL SLARFG( 2, BETA, V( 2, M22 ), 1, V( 1, M22 ) )
                  H( K+1, K ) = BETA
                  H( K+2, K ) = ZERO
               END IF
            END IF
*
*           ==== Multiply H by reflections from the left ====
*
            IF( ACCUM ) THEN
               JBOT = MIN( NDCOL, KBOT )
            ELSE IF( WANTT ) THEN
               JBOT = N
            ELSE
               JBOT = KBOT
            END IF
            DO 40 J = MAX( KTOP, KRCOL ), JBOT
               MEND = MIN( MBOT, ( J-KRCOL+2 ) / 3 )
               DO 30 M = MTOP, MEND
                  K = KRCOL + 3*( M-1 )
                  REFSUM = V( 1, M )*( H( K+1, J )+V( 2, M )*
     $                     H( K+2, J )+V( 3, M )*H( K+3, J ) )
                  H( K+1, J ) = H( K+1, J ) - REFSUM
                  H( K+2, J ) = H( K+2, J ) - REFSUM*V( 2, M )
                  H( K+3, J ) = H( K+3, J ) - REFSUM*V( 3, M )
   30          CONTINUE
   40       CONTINUE
            IF( BMP22 ) THEN
               K = KRCOL + 3*( M22-1 )
               DO 50 J = MAX( K+1, KTOP ), JBOT
                  REFSUM = V( 1, M22 )*( H( K+1, J )+V( 2, M22 )*
     $                     H( K+2, J ) )
                  H( K+1, J ) = H( K+1, J ) - REFSUM
                  H( K+2, J ) = H( K+2, J ) - REFSUM*V( 2, M22 )
   50          CONTINUE
            END IF
*
*           ==== Multiply H by reflections from the right.
*           .    Delay filling in the last row until the
*           .    vigilant deflation check is complete. ====
*
            IF( ACCUM ) THEN
               JTOP = MAX( KTOP, INCOL )
            ELSE IF( WANTT ) THEN
               JTOP = 1
            ELSE
               JTOP = KTOP
            END IF
            DO 90 M = MTOP, MBOT
               IF( V( 1, M ).NE.ZERO ) THEN
                  K = KRCOL + 3*( M-1 )
                  DO 60 J = JTOP, MIN( KBOT, K+3 )
                     REFSUM = V( 1, M )*( H( J, K+1 )+V( 2, M )*
     $                        H( J, K+2 )+V( 3, M )*H( J, K+3 ) )
                     H( J, K+1 ) = H( J, K+1 ) - REFSUM
                     H( J, K+2 ) = H( J, K+2 ) - REFSUM*V( 2, M )
                     H( J, K+3 ) = H( J, K+3 ) - REFSUM*V( 3, M )
   60             CONTINUE
*
                  IF( ACCUM ) THEN
*
*                    ==== Accumulate U. (If necessary, update Z later
*                    .    with with an efficient matrix-matrix
*                    .    multiply.) ====
*
                     KMS = K - INCOL
                     DO 70 J = MAX( 1, KTOP-INCOL ), KDU
                        REFSUM = V( 1, M )*( U( J, KMS+1 )+V( 2, M )*
     $                           U( J, KMS+2 )+V( 3, M )*U( J, KMS+3 ) )
                        U( J, KMS+1 ) = U( J, KMS+1 ) - REFSUM
                        U( J, KMS+2 ) = U( J, KMS+2 ) - REFSUM*V( 2, M )
                        U( J, KMS+3 ) = U( J, KMS+3 ) - REFSUM*V( 3, M )
   70                CONTINUE
                  ELSE IF( WANTZ ) THEN
*
*                    ==== U is not accumulated, so update Z
*                    .    now by multiplying by reflections
*                    .    from the right. ====
*
                     DO 80 J = ILOZ, IHIZ
                        REFSUM = V( 1, M )*( Z( J, K+1 )+V( 2, M )*
     $                           Z( J, K+2 )+V( 3, M )*Z( J, K+3 ) )
                        Z( J, K+1 ) = Z( J, K+1 ) - REFSUM
                        Z( J, K+2 ) = Z( J, K+2 ) - REFSUM*V( 2, M )
                        Z( J, K+3 ) = Z( J, K+3 ) - REFSUM*V( 3, M )
   80                CONTINUE
                  END IF
               END IF
   90       CONTINUE
*
*           ==== Special case: 2-by-2 reflection (if needed) ====
*
            K = KRCOL + 3*( M22-1 )
            IF( BMP22 ) THEN
               IF ( V( 1, M22 ).NE.ZERO ) THEN
                  DO 100 J = JTOP, MIN( KBOT, K+3 )
                     REFSUM = V( 1, M22 )*( H( J, K+1 )+V( 2, M22 )*
     $                        H( J, K+2 ) )
                     H( J, K+1 ) = H( J, K+1 ) - REFSUM
                     H( J, K+2 ) = H( J, K+2 ) - REFSUM*V( 2, M22 )
  100             CONTINUE
*
                  IF( ACCUM ) THEN
                     KMS = K - INCOL
                     DO 110 J = MAX( 1, KTOP-INCOL ), KDU
                        REFSUM = V( 1, M22 )*( U( J, KMS+1 )+
     $                           V( 2, M22 )*U( J, KMS+2 ) )
                        U( J, KMS+1 ) = U( J, KMS+1 ) - REFSUM
                        U( J, KMS+2 ) = U( J, KMS+2 ) - REFSUM*
     $                                  V( 2, M22 )
  110                CONTINUE
                  ELSE IF( WANTZ ) THEN
                     DO 120 J = ILOZ, IHIZ
                        REFSUM = V( 1, M22 )*( Z( J, K+1 )+V( 2, M22 )*
     $                           Z( J, K+2 ) )
                        Z( J, K+1 ) = Z( J, K+1 ) - REFSUM
                        Z( J, K+2 ) = Z( J, K+2 ) - REFSUM*V( 2, M22 )
  120                CONTINUE
                  END IF
               END IF
            END IF
*
*           ==== Vigilant deflation check ====
*
            MSTART = MTOP
            IF( KRCOL+3*( MSTART-1 ).LT.KTOP )
     $         MSTART = MSTART + 1
            MEND = MBOT
            IF( BMP22 )
     $         MEND = MEND + 1
            IF( KRCOL.EQ.KBOT-2 )
     $         MEND = MEND + 1
            DO 130 M = MSTART, MEND
               K = MIN( KBOT-1, KRCOL+3*( M-1 ) )
*
*              ==== The following convergence test requires that
*              .    the tradition small-compared-to-nearby-diagonals
*              .    criterion and the Ahues & Tisseur (LAWN 122, 1997)
*              .    criteria both be satisfied.  The latter improves
*              .    accuracy in some examples. Falling back on an
*              .    alternate convergence criterion when TST1 or TST2
*              .    is zero (as done here) is traditional but probably
*              .    unnecessary. ====
*
               IF( H( K+1, K ).NE.ZERO ) THEN
                  TST1 = ABS( H( K, K ) ) + ABS( H( K+1, K+1 ) )
                  IF( TST1.EQ.ZERO ) THEN
                     IF( K.GE.KTOP+1 )
     $                  TST1 = TST1 + ABS( H( K, K-1 ) )
                     IF( K.GE.KTOP+2 )
     $                  TST1 = TST1 + ABS( H( K, K-2 ) )
                     IF( K.GE.KTOP+3 )
     $                  TST1 = TST1 + ABS( H( K, K-3 ) )
                     IF( K.LE.KBOT-2 )
     $                  TST1 = TST1 + ABS( H( K+2, K+1 ) )
                     IF( K.LE.KBOT-3 )
     $                  TST1 = TST1 + ABS( H( K+3, K+1 ) )
                     IF( K.LE.KBOT-4 )
     $                  TST1 = TST1 + ABS( H( K+4, K+1 ) )
                  END IF
                  IF( ABS( H( K+1, K ) ).LE.MAX( SMLNUM, ULP*TST1 ) )
     $                 THEN
                     H12 = MAX( ABS( H( K+1, K ) ), ABS( H( K, K+1 ) ) )
                     H21 = MIN( ABS( H( K+1, K ) ), ABS( H( K, K+1 ) ) )
                     H11 = MAX( ABS( H( K+1, K+1 ) ),
     $                     ABS( H( K, K )-H( K+1, K+1 ) ) )
                     H22 = MIN( ABS( H( K+1, K+1 ) ),
     $                     ABS( H( K, K )-H( K+1, K+1 ) ) )
                     SCL = H11 + H12
                     TST2 = H22*( H11 / SCL )
*
                     IF( TST2.EQ.ZERO .OR. H21*( H12 / SCL ).LE.
     $                   MAX( SMLNUM, ULP*TST2 ) )H( K+1, K ) = ZERO
                  END IF
               END IF
  130       CONTINUE
*
*           ==== Fill in the last row of each bulge. ====
*
            MEND = MIN( NBMPS, ( KBOT-KRCOL-1 ) / 3 )
            DO 140 M = MTOP, MEND
               K = KRCOL + 3*( M-1 )
               REFSUM = V( 1, M )*V( 3, M )*H( K+4, K+3 )
               H( K+4, K+1 ) = -REFSUM
               H( K+4, K+2 ) = -REFSUM*V( 2, M )
               H( K+4, K+3 ) = H( K+4, K+3 ) - REFSUM*V( 3, M )
  140       CONTINUE
*
*           ==== End of near-the-diagonal bulge chase. ====
*
  150    CONTINUE
*
*        ==== Use U (if accumulated) to update far-from-diagonal
*        .    entries in H.  If required, use U to update Z as
*        .    well. ====
*
         IF( ACCUM ) THEN
            IF( WANTT ) THEN
               JTOP = 1
               JBOT = N
            ELSE
               JTOP = KTOP
               JBOT = KBOT
            END IF
            IF( ( .NOT.BLK22 ) .OR. ( INCOL.LT.KTOP ) .OR.
     $          ( NDCOL.GT.KBOT ) .OR. ( NS.LE.2 ) ) THEN
*
*              ==== Updates not exploiting the 2-by-2 block
*              .    structure of U.  K1 and NU keep track of
*              .    the location and size of U in the special
*              .    cases of introducing bulges and chasing
*              .    bulges off the bottom.  In these special
*              .    cases and in case the number of shifts
*              .    is NS = 2, there is no 2-by-2 block
*              .    structure to exploit.  ====
*
               K1 = MAX( 1, KTOP-INCOL )
               NU = ( KDU-MAX( 0, NDCOL-KBOT ) ) - K1 + 1
*
*              ==== Horizontal Multiply ====
*
               DO 160 JCOL = MIN( NDCOL, KBOT ) + 1, JBOT, NH
                  JLEN = MIN( NH, JBOT-JCOL+1 )
                  CALL SGEMM( 'C', 'N', NU, JLEN, NU, ONE, U( K1, K1 ),
     $                        LDU, H( INCOL+K1, JCOL ), LDH, ZERO, WH,
     $                        LDWH )
                  CALL SLACPY( 'ALL', NU, JLEN, WH, LDWH,
     $                         H( INCOL+K1, JCOL ), LDH )
  160          CONTINUE
*
*              ==== Vertical multiply ====
*
               DO 170 JROW = JTOP, MAX( KTOP, INCOL ) - 1, NV
                  JLEN = MIN( NV, MAX( KTOP, INCOL )-JROW )
                  CALL SGEMM( 'N', 'N', JLEN, NU, NU, ONE,
     $                        H( JROW, INCOL+K1 ), LDH, U( K1, K1 ),
     $                        LDU, ZERO, WV, LDWV )
                  CALL SLACPY( 'ALL', JLEN, NU, WV, LDWV,
     $                         H( JROW, INCOL+K1 ), LDH )
  170          CONTINUE
*
*              ==== Z multiply (also vertical) ====
*
               IF( WANTZ ) THEN
                  DO 180 JROW = ILOZ, IHIZ, NV
                     JLEN = MIN( NV, IHIZ-JROW+1 )
                     CALL SGEMM( 'N', 'N', JLEN, NU, NU, ONE,
     $                           Z( JROW, INCOL+K1 ), LDZ, U( K1, K1 ),
     $                           LDU, ZERO, WV, LDWV )
                     CALL SLACPY( 'ALL', JLEN, NU, WV, LDWV,
     $                            Z( JROW, INCOL+K1 ), LDZ )
  180             CONTINUE
               END IF
            ELSE
*
*              ==== Updates exploiting U's 2-by-2 block structure.
*              .    (I2, I4, J2, J4 are the last rows and columns
*              .    of the blocks.) ====
*
               I2 = ( KDU+1 ) / 2
               I4 = KDU
               J2 = I4 - I2
               J4 = KDU
*
*              ==== KZS and KNZ deal with the band of zeros
*              .    along the diagonal of one of the triangular
*              .    blocks. ====
*
               KZS = ( J4-J2 ) - ( NS+1 )
               KNZ = NS + 1
*
*              ==== Horizontal multiply ====
*
               DO 190 JCOL = MIN( NDCOL, KBOT ) + 1, JBOT, NH
                  JLEN = MIN( NH, JBOT-JCOL+1 )
*
*                 ==== Copy bottom of H to top+KZS of scratch ====
*                  (The first KZS rows get multiplied by zero.) ====
*
                  CALL SLACPY( 'ALL', KNZ, JLEN, H( INCOL+1+J2, JCOL ),
     $                         LDH, WH( KZS+1, 1 ), LDWH )
*
*                 ==== Multiply by U21**T ====
*
                  CALL SLASET( 'ALL', KZS, JLEN, ZERO, ZERO, WH, LDWH )
                  CALL STRMM( 'L', 'U', 'C', 'N', KNZ, JLEN, ONE,
     $                        U( J2+1, 1+KZS ), LDU, WH( KZS+1, 1 ),
     $                        LDWH )
*
*                 ==== Multiply top of H by U11**T ====
*
                  CALL SGEMM( 'C', 'N', I2, JLEN, J2, ONE, U, LDU,
     $                        H( INCOL+1, JCOL ), LDH, ONE, WH, LDWH )
*
*                 ==== Copy top of H to bottom of WH ====
*
                  CALL SLACPY( 'ALL', J2, JLEN, H( INCOL+1, JCOL ), LDH,
     $                         WH( I2+1, 1 ), LDWH )
*
*                 ==== Multiply by U21**T ====
*
                  CALL STRMM( 'L', 'L', 'C', 'N', J2, JLEN, ONE,
     $                        U( 1, I2+1 ), LDU, WH( I2+1, 1 ), LDWH )
*
*                 ==== Multiply by U22 ====
*
                  CALL SGEMM( 'C', 'N', I4-I2, JLEN, J4-J2, ONE,
     $                        U( J2+1, I2+1 ), LDU,
     $                        H( INCOL+1+J2, JCOL ), LDH, ONE,
     $                        WH( I2+1, 1 ), LDWH )
*
*                 ==== Copy it back ====
*
                  CALL SLACPY( 'ALL', KDU, JLEN, WH, LDWH,
     $                         H( INCOL+1, JCOL ), LDH )
  190          CONTINUE
*
*              ==== Vertical multiply ====
*
               DO 200 JROW = JTOP, MAX( INCOL, KTOP ) - 1, NV
                  JLEN = MIN( NV, MAX( INCOL, KTOP )-JROW )
*
*                 ==== Copy right of H to scratch (the first KZS
*                 .    columns get multiplied by zero) ====
*
                  CALL SLACPY( 'ALL', JLEN, KNZ, H( JROW, INCOL+1+J2 ),
     $                         LDH, WV( 1, 1+KZS ), LDWV )
*
*                 ==== Multiply by U21 ====
*
                  CALL SLASET( 'ALL', JLEN, KZS, ZERO, ZERO, WV, LDWV )
                  CALL STRMM( 'R', 'U', 'N', 'N', JLEN, KNZ, ONE,
     $                        U( J2+1, 1+KZS ), LDU, WV( 1, 1+KZS ),
     $                        LDWV )
*
*                 ==== Multiply by U11 ====
*
                  CALL SGEMM( 'N', 'N', JLEN, I2, J2, ONE,
     $                        H( JROW, INCOL+1 ), LDH, U, LDU, ONE, WV,
     $                        LDWV )
*
*                 ==== Copy left of H to right of scratch ====
*
                  CALL SLACPY( 'ALL', JLEN, J2, H( JROW, INCOL+1 ), LDH,
     $                         WV( 1, 1+I2 ), LDWV )
*
*                 ==== Multiply by U21 ====
*
                  CALL STRMM( 'R', 'L', 'N', 'N', JLEN, I4-I2, ONE,
     $                        U( 1, I2+1 ), LDU, WV( 1, 1+I2 ), LDWV )
*
*                 ==== Multiply by U22 ====
*
                  CALL SGEMM( 'N', 'N', JLEN, I4-I2, J4-J2, ONE,
     $                        H( JROW, INCOL+1+J2 ), LDH,
     $                        U( J2+1, I2+1 ), LDU, ONE, WV( 1, 1+I2 ),
     $                        LDWV )
*
*                 ==== Copy it back ====
*
                  CALL SLACPY( 'ALL', JLEN, KDU, WV, LDWV,
     $                         H( JROW, INCOL+1 ), LDH )
  200          CONTINUE
*
*              ==== Multiply Z (also vertical) ====
*
               IF( WANTZ ) THEN
                  DO 210 JROW = ILOZ, IHIZ, NV
                     JLEN = MIN( NV, IHIZ-JROW+1 )
*
*                    ==== Copy right of Z to left of scratch (first
*                    .     KZS columns get multiplied by zero) ====
*
                     CALL SLACPY( 'ALL', JLEN, KNZ,
     $                            Z( JROW, INCOL+1+J2 ), LDZ,
     $                            WV( 1, 1+KZS ), LDWV )
*
*                    ==== Multiply by U12 ====
*
                     CALL SLASET( 'ALL', JLEN, KZS, ZERO, ZERO, WV,
     $                            LDWV )
                     CALL STRMM( 'R', 'U', 'N', 'N', JLEN, KNZ, ONE,
     $                           U( J2+1, 1+KZS ), LDU, WV( 1, 1+KZS ),
     $                           LDWV )
*
*                    ==== Multiply by U11 ====
*
                     CALL SGEMM( 'N', 'N', JLEN, I2, J2, ONE,
     $                           Z( JROW, INCOL+1 ), LDZ, U, LDU, ONE,
     $                           WV, LDWV )
*
*                    ==== Copy left of Z to right of scratch ====
*
                     CALL SLACPY( 'ALL', JLEN, J2, Z( JROW, INCOL+1 ),
     $                            LDZ, WV( 1, 1+I2 ), LDWV )
*
*                    ==== Multiply by U21 ====
*
                     CALL STRMM( 'R', 'L', 'N', 'N', JLEN, I4-I2, ONE,
     $                           U( 1, I2+1 ), LDU, WV( 1, 1+I2 ),
     $                           LDWV )
*
*                    ==== Multiply by U22 ====
*
                     CALL SGEMM( 'N', 'N', JLEN, I4-I2, J4-J2, ONE,
     $                           Z( JROW, INCOL+1+J2 ), LDZ,
     $                           U( J2+1, I2+1 ), LDU, ONE,
     $                           WV( 1, 1+I2 ), LDWV )
*
*                    ==== Copy the result back to Z ====
*
                     CALL SLACPY( 'ALL', JLEN, KDU, WV, LDWV,
     $                            Z( JROW, INCOL+1 ), LDZ )
  210             CONTINUE
               END IF
            END IF
         END IF
  220 CONTINUE
*
*     ==== End of SLAQR5 ====
*
      END
c $Id: slaqr5.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine comp4_bins(m, n, nb_per_i)
C$Id: comp4_bins.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
c
      integer m(*)              ! Array holding info compressed to 4 bits
      integer n                 ! Bin the first n entries
      integer nb_per_i          ! No. of bytes per integer
c
#if defined(CRAY)
      integer vv,vvv            ! Temporaries for CRAY
#endif
      integer v                 ! Value after compression
      integer index, nbits, i
      integer bins(0:15)
      double precision fast(0:15)
#include "bitops_decls.fh"
      data fast/0.0d0, 1.0d-13, 1.0d-12, 1.0d-11, 1.0d-10, 1.0d-9,
     $     1.0d-8, 1.0d-7, 1.0d-6, 1.0d-5, 1.0d-4, 1.0d-3, 1.0d-2,
     $     1.0d-1, 1.0d0, 1.0d1/
#include "bitops_funcs.fh"
c
      do i = 0, 15
         bins(i) = 0
      enddo
c
      do i = 1, n
         v = 15
         index = (i - 1)/(2*nb_per_i) + 1
         nbits = 4*(i - (index-1)*(2*nb_per_i) - 1)
#if defined(CRAY)
         vvv =  shiftl(v, nbits)
         vv = shiftr(iand(m(index), vvv), nbits)
         v = iand(vv,15)
#else
         v = iand(rshift(iand(m(index), lshift(v, nbits)), nbits),15)
#endif
         bins(v) = bins(v) + 1
      enddo
c
      write(6,1) 
 1    format(1x,4('  value      no.   '))
      write(6,2) 
 2    format(1x,4(' -------- ------   '))
      write(6,3) (fast(i), bins(i), i=0,15)
 3    format(4(1x,4(1pd9.2,i7,3x)/))
c
      end

c
c $Id: frce_bond.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE frce_bond(ntbond,ebond)

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'p_const.inc'
      include 'cm_atom.inc'
      include 'cm_bond.inc'
      include 'cm_latt.inc'

      integer i,iatm1,iatm2,ibond
      integer ntbond

      real*8 ebond,rij,dij0,rdij,dijt,force,kcst

      dimension rij(mxbond2,3)

      ebond=0.0

      do i=1,ntbond

       iatm1=bonlist(i,1)
       iatm2=bonlist(i,2)

       rij(i,1)=ccc(iatm1,1)-ccc(iatm2,1)
       rij(i,2)=ccc(iatm1,2)-ccc(iatm2,2)
       rij(i,3)=ccc(iatm1,3)-ccc(iatm2,3)

      enddo

      call tool_rebox(ntbond,mxbond2,latt,rlatt,rij)

      do i=1,ntbond

       iatm1=bonlist(i,1)
       iatm2=bonlist(i,2)
       ibond=bonlist(i,3)

       dij0=bonddist(ibond)
       kcst=bondfrce(ibond)

       dijt=sqrt(rij(i,1)**2+rij(i,2)**2+rij(i,3)**2)
       rdij=1.0/dijt

       ebond=ebond+0.5*kcst*(dijt-dij0)**2

       force=-kcst*(dijt-dij0)*rdij

       fff(iatm1,1)=fff(iatm1,1)+convfct2*force*rij(i,1)
       fff(iatm1,2)=fff(iatm1,2)+convfct2*force*rij(i,2)
       fff(iatm1,3)=fff(iatm1,3)+convfct2*force*rij(i,3)

       fff(iatm2,1)=fff(iatm2,1)-convfct2*force*rij(i,1)
       fff(iatm2,2)=fff(iatm2,2)-convfct2*force*rij(i,2)
       fff(iatm2,3)=fff(iatm2,3)-convfct2*force*rij(i,3)

      enddo

      return

      END

      subroutine argos_prepare_collaps(xs,id,ndx,vec,msa,nsa,touch,mode,
     + nmoves,
     + ncolgr,icolgr,lfnout,lfnpdb,lrgpdb,sysnam,filpdb,iopt,box,
     + num,amass,mat,
     + csa,isat,isgm,imol,ifra,vs,
     + cwa,iwat,xw,vw,mwm,mwa,nwm,nwa,
     + xwc,vwc,mwmc,nwmc,slvnam,iropt,irrand,nxrep,nyrep,nzrep,drep,
     + msb,nsb,idsb,rdist,nskip,iskip,lang,lfnmrg,nmerge,xmerge,filmrg,
     + irenum,invert,ihop,ips)
c
      implicit none
c
#include "mafdecls.fh"
      logical argos_prepare_wrtpdb
      external argos_prepare_wrtpdb
c
      integer msa,nsa,mode,nmoves
      integer id(msa),ndx(msa,3)
      real*8 xs(3,msa),vec(6,msa)
      real*8 touch
      integer ncolgr
      integer icolgr(2,ncolgr)
c
      integer lfnout,lfnpdb,iopt,mwm,nwm,mwa,nwa,mat,mwmc,nwmc
      integer lfnmrg,lrgpdb
      character*255 filpdb,filmrg(100)
      integer num(mat),isat(msa),isgm(msa),imol(msa),ifra(msa),iwat(mwa)
      integer ihop(msa),ips(msa)
      character*16 cwa(mwa),csa(msa)
      character*3 slvnam
      real*8 amass(mat),vs(3,msa),xw(3,mwa,mwm),vw(3,mwa,mwm)
      real*8 xwc(3,mwa,mwmc),vwc(3,mwa,mwmc),box(3)
      integer iropt,irrand,nxrep,nyrep,nzrep,nskip
      real*8 rdist,drep(3),xmerge(3,100)
      integer msb,nsb,nmols,irenum,invert,nmerge
      integer idsb(2,msb),iskip(3,nskip),lang(*)
      character*80 sysnam
c
      character*255 filnam
c
      logical first,found
      integer i,j,k,m
      integer nmol,large,nummov
      real*8 rt,rk,dist
      real*8 a,b,c,d,e,r,r1,r2,root,dt,dtran
      real*8 tr(3),tran(3),xmax(3),xmin(3)
      real*8 a2,b2,c2,d2,p(3),factor
c
      write(*,'(/,a,i4,f12.6,/)') ' Collapsing using mode ',mode,touch
c
c     find total number of molecules
c
c     on entry, id(i) contains the molecule number of atom i
c
      do 13 i=1,nsa
      ndx(i,1)=0
      ndx(i,2)=0
      ndx(i,3)=0
   13 continue
c
c     store in ndx(i,1) the number of atoms in molecule i
c
      nmol=0
      do 1 i=1,nsa
      nmol=max(nmol,id(i))
      ndx(id(i),1)=ndx(id(i),1)+1
    1 continue
c
      do 14 i=1,nsa
      ndx(i,2)=id(i)
   14 continue
c
c     group single atom molecules with nearest multi-atom molecules
c
      do 15 i=1,nsa
      if(ndx(id(i),1).eq.1) then
      k=0
      rk=1.0d10
      do 16 j=1,nsa
      if(ndx(id(j),1).gt.1) then
      dist=(xs(1,i)-xs(1,j))**2+(xs(2,i)-xs(2,j))**2+
     + (xs(3,i)-xs(3,j))**2
      if(dist.lt.rk) then
      k=j
      rk=dist
      endif
      endif
   16 continue
      if(k.gt.0) then
      ndx(id(i),1)=0
      ndx(id(k),1)=ndx(id(k),1)+1
      ndx(i,2)=id(k)
      write(*,'(a,i8,a,i4,a,f12.6)')
     + ' Single ion ',i,' grouped with molecule ',
     + id(k),', distance is ',sqrt(rk)
      endif
      endif
   15 continue
c
      if(ncolgr.gt.0) then
      do 26 j=1,ncolgr
      do 27 i=1,nsa
      if(ndx(i,2).eq.icolgr(2,j)) ndx(i,2)=icolgr(1,j)
   27 continue
      write(*,'(a,i8,a,i4)')
     + ' Molecule   ',icolgr(2,j),
     + ' grouped with molecule ',icolgr(1,j)
   26 continue
      endif
c
      nummov=0
c
    2 continue
c
c     find molecule with largest possible tranlation
c
      large=0
      dtran=0.0d0
      root=0.0d0
c
c     determine centers of geometry
c
      do 31 m=1,nmol
      vec(1,m)=0.0d0
      vec(2,m)=0.0d0
      vec(3,m)=0.0d0
      vec(4,m)=0.0d0
      vec(5,m)=0.0d0
      vec(6,m)=0.0d0
   31 continue
      do 32 i=1,nsa
      m=ndx(i,2)
      vec(1,m)=xs(1,i)
      vec(2,m)=xs(2,i)
      vec(3,m)=xs(3,i)
      vec(4,m)=xs(1,i)
      vec(5,m)=xs(2,i)
      vec(6,m)=xs(3,i)
   32 continue
      do 33 i=1,nsa
      m=ndx(i,2)
      vec(1,m)=min(vec(1,m),xs(1,i))
      vec(2,m)=min(vec(2,m),xs(2,i))
      vec(3,m)=min(vec(3,m),xs(3,i))
      vec(4,m)=max(vec(4,m),xs(1,i))
      vec(5,m)=max(vec(5,m),xs(2,i))
      vec(6,m)=max(vec(6,m),xs(3,i))
   33 continue
      do 34 m=1,nmol
      if(ndx(m,1).gt.0) then
      vec(1,m)=0.5d0*(vec(1,m)+vec(4,m))
      vec(2,m)=0.5d0*(vec(2,m)+vec(5,m))
      vec(3,m)=0.5d0*(vec(3,m)+vec(6,m))
      vec(4,m)=vec(4,m)-vec(1,m)
      vec(5,m)=vec(5,m)-vec(2,m)
      vec(6,m)=vec(6,m)-vec(3,m)
      endif
   34 continue
c
      do 3 m=1,nmol
      if(ndx(m,1).gt.0) then
c
      tr(1)=-vec(1,m)
      tr(2)=-vec(2,m)
      tr(3)=-vec(3,m)
      if(mode.eq.3) tr(3)=0.0d0
c
      do 41 i=1,nmol
      ndx(i,3)=1
   41 continue
      ndx(m,3)=0
      b2=vec(1,m)*vec(1,m)+vec(2,m)*vec(2,m)+vec(3,m)*vec(3,m)
      d=sqrt(vec(4,m)*vec(4,m)+vec(5,m)*vec(5,m)+vec(6,m)*vec(6,m))
      e=sqrt(vec(4,m)*vec(4,m)+vec(5,m)*vec(5,m))
      do 42 i=1,nmol
      k=1
      if(ndx(i,1).eq.0.or.i.eq.m) then
      k=0
      else
      if(abs(vec(1,i)-(vec(1,m)+0.5d0*tr(1))).gt.
     +   abs(vec(1,m)+0.5d0*tr(1))+vec(4,i)+vec(4,m)) k=0
      if(abs(vec(2,i)-(vec(2,m)+0.5d0*tr(2))).gt.
     +   abs(vec(2,m)+0.5d0*tr(2))+vec(5,i)+vec(5,m)) k=0
      if(abs(vec(3,i)-(vec(3,m)+0.5d0*tr(3))).gt.
     +   abs(vec(3,m)+0.5d0*tr(3))+vec(6,i)+vec(6,m)) k=0
      if(k.eq.1) then
      a2=vec(1,i)*vec(1,i)+vec(2,i)*vec(2,i)+vec(3,i)*vec(3,i)
      c2=(vec(1,m)-vec(1,i))**2+(vec(2,m)-vec(2,i))**2+
     + (vec(3,m)-vec(3,i))**2
      factor=(1.0d0-0.5d0*(b2+c2-a2)/b2)
      p(1)=factor*vec(1,m)
      p(2)=factor*vec(2,m)
      p(3)=factor*vec(3,m)
      a=sqrt((p(1)-vec(1,i))**2+(p(2)-vec(2,i))**2+(p(3)-vec(3,i))**2)
      c=sqrt(vec(4,i)**2+vec(5,i)**2+vec(6,i)**2)
      if(a.gt.c+d) k=0
      if(mode.eq.3.and. k.eq.1) then
      if(abs(p(3)-vec(3,i)).gt.abs(vec(6,i))+abs(vec(6,m))) k=0
      endif
      endif
      endif
      if(k.eq.0) ndx(i,3)=0
   42 continue
c
c     determine translation vector
c
      rt=-1.0d0
c
      dt=sqrt(tr(1)*tr(1)+tr(2)*tr(2)+tr(3)*tr(3))
c
      do 8 i=1,nsa
      if(ndx(i,2).eq.m) then
      do 9 j=1,nsa
      if(ndx(ndx(j,2),3).eq.1) then
      a=0.0d0
      b=0.0d0
      c=0.0d0
      do 10 k=1,3
      a=a+tr(k)*tr(k)
      b=b+(xs(k,i)-xs(k,j))*tr(k)
      c=c+xs(k,i)*xs(k,i)+xs(k,j)*xs(k,j)-2.0*xs(k,i)*xs(k,j)
   10 continue
      b=2.0d0*b
      c=c-touch*touch
      if(abs(a).gt.1.0d-5) then
c
c     find smallest positive root
c
      d=(b*b-4.0d0*a*c)/(4.0d0*a*a)
      if(d.gt.0.0d0) then
      r1=-b/(2.0d0*a)
      if(r1.ge.0) then
      r1=r1+sqrt(d)
      else
      r1=r1-sqrt(d)
      endif
      r2=c/(r1*a)
      r=-1.0d0
      if(r1.gt.0.0d0) r=r1
      if(r2.gt.0.0d0.and.r2.lt.r1) r=r2
      if(r.gt.1.0d0) r=-1.0d0
c
      if(r.gt.0.0d0) then
      d=r*sqrt(tr(1)*tr(1)+tr(2)*tr(2)+tr(3)*tr(3))
      if(d.lt.dt) then
      dt=d
      rt=r
      endif
      endif
c
      endif
      endif
      endif
    9 continue
      endif
    8 continue
c
      if(rt.gt.0.and.dt.gt.dtran) then
      large=m
      root=rt
      tran(1)=tr(1)
      tran(2)=tr(2)
      tran(3)=tr(3)
      dtran=dt
      endif
      endif
c
    3 continue
c
      write(*,'(a,i4,a,f12.6,a,f12.6)')
     + ' Translating molecule ',large,' by ',dtran,' nm',root
c
c     process largest possible translation
c
      if(large.gt.0) then
      do 11 i=1,nsa
      if(ndx(i,2).eq.large) then
      do 12 k=1,3
      xs(k,i)=xs(k,i)+root*tran(k)
   12 continue
      endif
   11 continue
      nummov=nummov+1
      write(filnam,'(a,i5.5,a)')
     + sysnam(1:index(sysnam,' ')-1)//'-c',nummov,'.pdb'
c
      if(.not.argos_prepare_wrtpdb(lfnout,lfnpdb,lrgpdb,filnam,iopt,box,
     + num,amass,
     + mat,csa,isat,isgm,imol,ifra,xs,vs,msa,nsa,cwa,iwat,xw,vw,mwm,mwa,
     + nwm,nwa,xwc,vwc,mwmc,nwmc,slvnam,iropt,irrand,nxrep,nyrep,nzrep,
     + drep,msb,nsb,idsb,rdist,nskip,iskip,lang,lfnmrg,nmerge,xmerge,
     + filmrg,irenum,invert,ihop,ips))
     +  call md_abort('argos_prepare_wrtpdb failed',9999)
c
      if(dtran.gt.touch.and.(nummov.lt.nmoves.or.nmoves.lt.0)) goto 2
      endif
c
      return
      end
 
c $Id: argos_prepare_collaps.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b SPOTRF
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SPOTRF + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/spotrf.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/spotrf.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/spotrf.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SPOTRF( UPLO, N, A, LDA, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, N
*       ..
*       .. Array Arguments ..
*       REAL               A( LDA, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SPOTRF computes the Cholesky factorization of a real symmetric
*> positive definite matrix A.
*>
*> The factorization has the form
*>    A = U**T * U,  if UPLO = 'U', or
*>    A = L  * L**T,  if UPLO = 'L',
*> where U is an upper triangular matrix and L is lower triangular.
*>
*> This is the block version of the algorithm, calling Level 3 BLAS.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangle of A is stored;
*>          = 'L':  Lower triangle of A is stored.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is REAL array, dimension (LDA,N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*>          N-by-N upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading N-by-N lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>
*>          On exit, if INFO = 0, the factor U or L from the Cholesky
*>          factorization A = U**T*U or A = L*L**T.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          > 0:  if INFO = i, the leading minor of order i is not
*>                positive definite, and the factorization could not be
*>                completed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realPOcomputational
*
*  =====================================================================
      SUBROUTINE SPOTRF( UPLO, N, A, LDA, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      REAL               A( LDA, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE
      PARAMETER          ( ONE = 1.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J, JB, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           SGEMM, SPOTF2, SSYRK, STRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SPOTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'SPOTRF', UPLO, N, -1, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code.
*
         CALL SPOTF2( UPLO, N, A, LDA, INFO )
      ELSE
*
*        Use blocked code.
*
         IF( UPPER ) THEN
*
*           Compute the Cholesky factorization A = U**T*U.
*
            DO 10 J = 1, N, NB
*
*              Update and factorize the current diagonal block and test
*              for non-positive-definiteness.
*
               JB = MIN( NB, N-J+1 )
               CALL SSYRK( 'Upper', 'Transpose', JB, J-1, -ONE,
     $                     A( 1, J ), LDA, ONE, A( J, J ), LDA )
               CALL SPOTF2( 'Upper', JB, A( J, J ), LDA, INFO )
               IF( INFO.NE.0 )
     $            GO TO 30
               IF( J+JB.LE.N ) THEN
*
*                 Compute the current block row.
*
                  CALL SGEMM( 'Transpose', 'No transpose', JB, N-J-JB+1,
     $                        J-1, -ONE, A( 1, J ), LDA, A( 1, J+JB ),
     $                        LDA, ONE, A( J, J+JB ), LDA )
                  CALL STRSM( 'Left', 'Upper', 'Transpose', 'Non-unit',
     $                        JB, N-J-JB+1, ONE, A( J, J ), LDA,
     $                        A( J, J+JB ), LDA )
               END IF
   10       CONTINUE
*
         ELSE
*
*           Compute the Cholesky factorization A = L*L**T.
*
            DO 20 J = 1, N, NB
*
*              Update and factorize the current diagonal block and test
*              for non-positive-definiteness.
*
               JB = MIN( NB, N-J+1 )
               CALL SSYRK( 'Lower', 'No transpose', JB, J-1, -ONE,
     $                     A( J, 1 ), LDA, ONE, A( J, J ), LDA )
               CALL SPOTF2( 'Lower', JB, A( J, J ), LDA, INFO )
               IF( INFO.NE.0 )
     $            GO TO 30
               IF( J+JB.LE.N ) THEN
*
*                 Compute the current block column.
*
                  CALL SGEMM( 'No transpose', 'Transpose', N-J-JB+1, JB,
     $                        J-1, -ONE, A( J+JB, 1 ), LDA, A( J, 1 ),
     $                        LDA, ONE, A( J+JB, J ), LDA )
                  CALL STRSM( 'Right', 'Lower', 'Transpose', 'Non-unit',
     $                        N-J-JB+1, JB, ONE, A( J, J ), LDA,
     $                        A( J+JB, J ), LDA )
               END IF
   20       CONTINUE
         END IF
      END IF
      GO TO 40
*
   30 CONTINUE
      INFO = INFO + J - 1
*
   40 CONTINUE
      RETURN
*
*     End of SPOTRF
*
      END
c $Id: spotrf.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine ga_reorder(g_a, orow, rmap, ocol, cmap)
*
* $Id: ga_reorder.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
      integer g_a               ! [input] Handle to array to be reordered
      logical orow              ! [input] If true reorder the rows
      integer rmap(*)         ! [input] if (orow) a(i,j) -> a(rmap(i),j)
      logical ocol              ! [input] If true reorder the columns
      integer cmap(*)         ! [input] if (ocol) a(i,j) -> a(i,cmap(j))
c
      integer g_d, i, j, l_v, k_v, l_vv, k_vv, ma_type, dim1, dim2, jj
c
      call ga_inquire(g_a, ma_type, dim1, dim2)
c     
      if (.not. ma_alloc_get(mt_dbl, dim1, 'gareo', l_v, k_v))
     $     call errquit('ga_reorder: could not allocate column', dim1,
     &       MA_ERR)
      if (.not. ma_alloc_get(mt_dbl, dim1, 'gareo', l_vv, k_vv))
     $     call errquit('ga_reorder: could not allocate column2', dim1,
     &       MA_ERR)
c
*      write(6,*) ' BEFORE '
*      call util_flush(6)
*      call ga_print(g_a)
c
      call ga_sync
      if (.not. ga_duplicate(g_a, g_d, 'ga_reorder')) call errquit
     $     ('ga_reorder: duplicate failed', 0, GA_ERR)
      call ga_copy(g_a, g_d)
c
      do j = 1+ga_nodeid(), dim2, ga_nnodes()
         if (orow) then
            call ga_get(g_d, 1, dim1, j, j, dbl_mb(k_v), 1)
            do i = 1, dim1
               dbl_mb(k_vv+rmap(i)-1) = dbl_mb(k_v+i-1)
            enddo
         else
            call ga_get(g_d, 1, dim1, j, j, dbl_mb(k_vv), 1)
         endif
         jj = j
         if (ocol) jj = cmap(j)
         call ga_put(g_a, 1, dim1, jj, jj, dbl_mb(k_vv), 1)
      enddo
      if (.not. ma_free_heap(l_vv)) call errquit('ga_reo: ma?',0,
     &       MA_ERR)
      if (.not. ma_free_heap(l_v))  call errquit('ga_reo: ma2?',0,
     &       MA_ERR)
      call ga_sync
      if (.not. ga_destroy(g_d)) call errquit('ga_reo: ga_destroy?',0,
     &       GA_ERR)
c
*      write(6,*) ' AFTER '
*      call util_flush(6)
*      call ga_print(g_a)
c
      end
      subroutine nga_reorder(g_a, orow, rmap, ocol, cmap)
      implicit none
#include "errquit.fh"
c
c This is basically just an extension of ga_reorder and is not very
c generic at this point.  As a matter of fact, it assumes (and tests)
c that the dimension is 3 and that you only want to reorder the last
c two indices.  This can be made more general after I test this version.
c Also, I am wasting a lot of memory by duplicating the whole ga.  This
c will need to be optimized in the future.
c
#include "global.fh"
#include "mafdecls.fh"
      integer g_a               ! [input] Handle to array to be reordered
      logical orow              ! [input] If true reorder the rows
      integer rmap(*)         ! [input] if (orow) a(i,j) -> a(rmap(i),j)
      logical ocol              ! [input] If true reorder the columns
      integer cmap(*)         ! [input] if (ocol) a(i,j) -> a(i,cmap(j))
c
      integer g_d, i, j, l_v, k_v, l_vv, k_vv, ma_type 
      integer dim0, dim1, dim2, jj
      integer ndim, dims(3), lo(3), hi(3), ld(2)
c
      ndim = ga_ndim(g_a)
      if (ndim.ne.3)
     $     call errquit('nga_reorder: must have 3 dimensions',ndim,
     &       GA_ERR)
      call nga_inquire(g_a, ma_type, ndim, dims)
      dim1 = dims(2)
      dim2 = dims(3)
c     
      if (.not. ma_alloc_get(mt_dbl, dim1, 'gareo', l_v, k_v))
     $     call errquit('ga_reorder: could not allocate column', dim1,
     &       GA_ERR)
      if (.not. ma_alloc_get(mt_dbl, dim1, 'gareo', l_vv, k_vv))
     $     call errquit('ga_reorder: could not allocate column2', dim1,
     &       GA_ERR)
c
*      write(6,*) ' BEFORE '
*      call util_flush(6)
*      call ga_print(g_a)
c
      call ga_sync
      if (.not. ga_duplicate(g_a, g_d, 'ga_reorder')) call errquit
     $     ('ga_reorder: duplicate failed', 0, GA_ERR)
      call ga_copy(g_a, g_d)
c
      ld(1) = 1
      ld(2) = 1
      lo(2) = 1
      hi(2) = dim1
      do dim0 = 1, dims(1)
      lo(1) = dim0
      hi(1) = dim0
      do j = 1+ga_nodeid(), dim2, ga_nnodes()
         lo(3) = j
         hi(3) = j
         if (orow) then
            call nga_get(g_d, lo, hi, dbl_mb(k_v), ld)
            do i = 1, dim1
               dbl_mb(k_vv+rmap(i)-1) = dbl_mb(k_v+i-1)
            enddo
         else
            call nga_get(g_d, lo, hi, dbl_mb(k_vv), ld)
         endif
         jj = j
         if (ocol) jj = cmap(j)
         lo(3) = jj
         hi(3) = jj
         call nga_put(g_a, lo, hi, dbl_mb(k_vv), ld)
      enddo
      enddo
      if (.not. ma_free_heap(l_vv)) call errquit('ga_reo: ma?',0,
     &       MA_ERR)
      if (.not. ma_free_heap(l_v))  call errquit('ga_reo: ma2?',0,
     &       MA_ERR)
      call ga_sync
      if (.not. ga_destroy(g_d)) call errquit('ga_reo: ga_destroy?',0,
     &       GA_ERR)
c
*      write(6,*) ' AFTER '
*      call util_flush(6)
*      call ga_print(g_a)
c
      end
      subroutine matrix_reorder(dim1, dim2, a, orow, rmap, ocol, cmap)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
      integer dim1, dim2
      double precision a(dim1,dim2) ! [input/output] Array to be reordered
      logical orow              ! [input] If true reorder the rows
      integer rmap(*)           ! [input] if (orow) a(i,j) -> a(rmap(i),j)
      logical ocol              ! [input] If true reorder the columns
      integer cmap(*)           ! [input] if (ocol) a(i,j) -> a(i,cmap(j))
c
      integer i, j, l_v, k_v, l_vv, k_vv,jj
      integer l_d, k_d
c
      if (.not. ma_alloc_get(mt_dbl, dim1*dim2, 'mareo', l_d, k_d))
     $     call errquit('ga_reorder: could not allocate dup', dim1*dim2,
     &       MA_ERR)
      if (.not. ma_alloc_get(mt_dbl, dim1, 'mareo', l_v, k_v))
     $     call errquit('ga_reorder: could not allocate column', dim1,
     &       MA_ERR)
      if (.not. ma_alloc_get(mt_dbl, dim1, 'mareo', l_vv, k_vv))
     $     call errquit('ga_reorder: could not allocate column2', dim1,
     &       MA_ERR)
c
      call dcopy(dim1*dim2, a, 1, dbl_mb(k_d), 1)
c
*      write(6,*) ' BEFORE '
*      call output(a, 1, dim1, 1, dim2, dim1, dim2, 1)
c
      do j = 1, dim2
         if (orow) then
            call dcopy(dim1, dbl_mb(k_d+(j-1)*dim1), 1, dbl_mb(k_v), 1)
            do i = 1, dim1
               dbl_mb(k_vv+rmap(i)-1) = dbl_mb(k_v+i-1)
            enddo
         else
            call dcopy(dim1, dbl_mb(k_d+(j-1)*dim1), 1, dbl_mb(k_vv), 1)
         endif
         jj = j
         if (ocol) jj = cmap(j)
         call dcopy(dim1, dbl_mb(k_vv), 1, a(1,jj), 1)
      enddo
c
*      write(6,*) ' AFTER '
*      call output(a, 1, dim1, 1, dim2, dim1, dim2, 1)
c
      if (.not. ma_free_heap(l_vv)) call errquit('ma_reo: ma?',0,
     &       MA_ERR)
      if (.not. ma_free_heap(l_v))  call errquit('ma_reo: ma2?',0,
     &       MA_ERR)
      if (.not. ma_free_heap(l_d)) call errquit('ma_reo: ma?',0,
     &       MA_ERR)
c
      end

      subroutine hf3PEabc(Pabc, E, R0, IJK,
     &    Nabc, La, Lb, Lc, Lg, Lg3, nint, lim_nint)
c $Id: hf3PEabc.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
#include "errquit.fh"
c
      integer La, Lb, Lc, Lg, Lg3, Nabc, nint, lim_nint
      integer IJK(0:Lg,0:Lg,0:Lg)
      double precision E(Nabc,3,0:Lg,0:La,0:Lb,0:Lc)
      double precision R0(Nabc,Lg3)
      double precision Pabc(*)
      double precision pabc_int
c
      integer Nxyz(3)
      integer La2, Lb2, Lc2, ica, icb, icc
      integer Ia, Ja, Ka
      integer Ib, Jb, Kb
      integer Ic, Jc, Kc
      integer Ip, Jp, Kp
      integer np, mp
c
c Define the number of shell components on each center.

      La2 = ((La+1)*(La+2))/2
      Lb2 = ((Lb+1)*(Lb+2))/2
      Lc2 = ((Lc+1)*(Lc+2))/2
      nint = la2*lb2*lc2
      if (nint.gt.lim_nint) then
        write(6,*)' la = ',la
        write(6,*)' lb = ',lb
        write(6,*)' lc = ',lc
        write(6,*)' nint     = ',nint
        write(6,*)' lim_nint = ',lim_nint
        call errquit('hf3PEabc: something hosed',911, INT_ERR)
      endif

c Loop over shell components.
c
      nint = 0   
c
      do 00100 ica = 1,La2

        call getNxyz(La,ica,Nxyz)
        Ia = Nxyz(1)
        Ja = Nxyz(2)
        Ka = Nxyz(3)
        
        do 00200 icb = 1,Lb2
          
          call getNxyz(Lb,icb,Nxyz)
          Ib = Nxyz(1)
          Jb = Nxyz(2)
          Kb = Nxyz(3)
          
          do 00300 icc = 1, Lc2

            call getNxyz(Lc,icc,Nxyz)
            Ic = Nxyz(1)
            Jc = Nxyz(2)
            Kc = Nxyz(3)

            if (nint.eq.lim_nint) then
              write(6,*)' nint =   ',nint
              write(6,*)' lim_nint ',lim_nint
              call errquit
     &            ('hf3PEabc: buffer too small ',911, MEM_ERR)
            endif

            nint = nint + 1


            pabc_int = 0.0d00
            do 00400 Ip = 0, (Ia + Ib + Ic)
              do 00500 Jp = 0, (Ja + Jb +Jc)
                do 00600 Kp = 0, (Ka + Kb +Kc)

                  np = IJK(Ip, Jp, Kp)
                  
                  do 00700 mp = 1, Nabc
                    pabc_int = pabc_int + 
     &                  E(mp,1,Ip,Ia,Ib,Ic) *
     &                  E(mp,2,Jp,Ja,Jb,Jc) *
     &                  E(mp,3,Kp,Ka,Kb,Kc) * R0(mp,np)
                      
00700             continue
00600           continue
00500         continue
00400       continue
            Pabc(nint) = pabc_int
00300     continue
00200   continue
00100 continue
c
      end

*> \brief \b CLAHRD reduces the first nb columns of a general rectangular matrix A so that elements below the k-th subdiagonal are zero, and returns auxiliary matrices which are needed to apply the transformation to the unreduced part of A.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download CLAHRD + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/clahrd.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/clahrd.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/clahrd.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CLAHRD( N, K, NB, A, LDA, TAU, T, LDT, Y, LDY )
* 
*       .. Scalar Arguments ..
*       INTEGER            K, LDA, LDT, LDY, N, NB
*       ..
*       .. Array Arguments ..
*       COMPLEX            A( LDA, * ), T( LDT, NB ), TAU( NB ),
*      $                   Y( LDY, NB )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CLAHRD reduces the first NB columns of a complex general n-by-(n-k+1)
*> matrix A so that elements below the k-th subdiagonal are zero. The
*> reduction is performed by a unitary similarity transformation
*> Q**H * A * Q. The routine returns the matrices V and T which determine
*> Q as a block reflector I - V*T*V**H, and also the matrix Y = A * V * T.
*>
*> This is an OBSOLETE auxiliary routine. 
*> This routine will be 'deprecated' in a  future release.
*> Please use the new routine CLAHR2 instead.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.
*> \endverbatim
*>
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>          The offset for the reduction. Elements below the k-th
*>          subdiagonal in the first NB columns are reduced to zero.
*> \endverbatim
*>
*> \param[in] NB
*> \verbatim
*>          NB is INTEGER
*>          The number of columns to be reduced.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX array, dimension (LDA,N-K+1)
*>          On entry, the n-by-(n-k+1) general matrix A.
*>          On exit, the elements on and above the k-th subdiagonal in
*>          the first NB columns are overwritten with the corresponding
*>          elements of the reduced matrix; the elements below the k-th
*>          subdiagonal, with the array TAU, represent the matrix Q as a
*>          product of elementary reflectors. The other columns of A are
*>          unchanged. See Further Details.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is COMPLEX array, dimension (NB)
*>          The scalar factors of the elementary reflectors. See Further
*>          Details.
*> \endverbatim
*>
*> \param[out] T
*> \verbatim
*>          T is COMPLEX array, dimension (LDT,NB)
*>          The upper triangular matrix T.
*> \endverbatim
*>
*> \param[in] LDT
*> \verbatim
*>          LDT is INTEGER
*>          The leading dimension of the array T.  LDT >= NB.
*> \endverbatim
*>
*> \param[out] Y
*> \verbatim
*>          Y is COMPLEX array, dimension (LDY,NB)
*>          The n-by-nb matrix Y.
*> \endverbatim
*>
*> \param[in] LDY
*> \verbatim
*>          LDY is INTEGER
*>          The leading dimension of the array Y. LDY >= max(1,N).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complexOTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The matrix Q is represented as a product of nb elementary reflectors
*>
*>     Q = H(1) H(2) . . . H(nb).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**H
*>
*>  where tau is a complex scalar, and v is a complex vector with
*>  v(1:i+k-1) = 0, v(i+k) = 1; v(i+k+1:n) is stored on exit in
*>  A(i+k+1:n,i), and tau in TAU(i).
*>
*>  The elements of the vectors v together form the (n-k+1)-by-nb matrix
*>  V which is needed, with T and Y, to apply the transformation to the
*>  unreduced part of the matrix, using an update of the form:
*>  A := (I - V*T*V**H) * (A - Y*V**H).
*>
*>  The contents of A on exit are illustrated by the following example
*>  with n = 7, k = 3 and nb = 2:
*>
*>     ( a   h   a   a   a )
*>     ( a   h   a   a   a )
*>     ( a   h   a   a   a )
*>     ( h   h   a   a   a )
*>     ( v1  h   a   a   a )
*>     ( v1  v2  a   a   a )
*>     ( v1  v2  a   a   a )
*>
*>  where a denotes an element of the original matrix A, h denotes a
*>  modified element of the upper Hessenberg matrix H, and vi denotes an
*>  element of the vector defining H(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE CLAHRD( N, K, NB, A, LDA, TAU, T, LDT, Y, LDY )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            K, LDA, LDT, LDY, N, NB
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), T( LDT, NB ), TAU( NB ),
     $                   Y( LDY, NB )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ),
     $                   ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX            EI
*     ..
*     .. External Subroutines ..
      EXTERNAL           CAXPY, CCOPY, CGEMV, CLACGV, CLARFG, CSCAL,
     $                   CTRMV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
      DO 10 I = 1, NB
         IF( I.GT.1 ) THEN
*
*           Update A(1:n,i)
*
*           Compute i-th column of A - Y * V**H
*
            CALL CLACGV( I-1, A( K+I-1, 1 ), LDA )
            CALL CGEMV( 'No transpose', N, I-1, -ONE, Y, LDY,
     $                  A( K+I-1, 1 ), LDA, ONE, A( 1, I ), 1 )
            CALL CLACGV( I-1, A( K+I-1, 1 ), LDA )
*
*           Apply I - V * T**H * V**H to this column (call it b) from the
*           left, using the last column of T as workspace
*
*           Let  V = ( V1 )   and   b = ( b1 )   (first I-1 rows)
*                    ( V2 )             ( b2 )
*
*           where V1 is unit lower triangular
*
*           w := V1**H * b1
*
            CALL CCOPY( I-1, A( K+1, I ), 1, T( 1, NB ), 1 )
            CALL CTRMV( 'Lower', 'Conjugate transpose', 'Unit', I-1,
     $                  A( K+1, 1 ), LDA, T( 1, NB ), 1 )
*
*           w := w + V2**H *b2
*
            CALL CGEMV( 'Conjugate transpose', N-K-I+1, I-1, ONE,
     $                  A( K+I, 1 ), LDA, A( K+I, I ), 1, ONE,
     $                  T( 1, NB ), 1 )
*
*           w := T**H *w
*
            CALL CTRMV( 'Upper', 'Conjugate transpose', 'Non-unit', I-1,
     $                  T, LDT, T( 1, NB ), 1 )
*
*           b2 := b2 - V2*w
*
            CALL CGEMV( 'No transpose', N-K-I+1, I-1, -ONE, A( K+I, 1 ),
     $                  LDA, T( 1, NB ), 1, ONE, A( K+I, I ), 1 )
*
*           b1 := b1 - V1*w
*
            CALL CTRMV( 'Lower', 'No transpose', 'Unit', I-1,
     $                  A( K+1, 1 ), LDA, T( 1, NB ), 1 )
            CALL CAXPY( I-1, -ONE, T( 1, NB ), 1, A( K+1, I ), 1 )
*
            A( K+I-1, I-1 ) = EI
         END IF
*
*        Generate the elementary reflector H(i) to annihilate
*        A(k+i+1:n,i)
*
         EI = A( K+I, I )
         CALL CLARFG( N-K-I+1, EI, A( MIN( K+I+1, N ), I ), 1,
     $                TAU( I ) )
         A( K+I, I ) = ONE
*
*        Compute  Y(1:n,i)
*
         CALL CGEMV( 'No transpose', N, N-K-I+1, ONE, A( 1, I+1 ), LDA,
     $               A( K+I, I ), 1, ZERO, Y( 1, I ), 1 )
         CALL CGEMV( 'Conjugate transpose', N-K-I+1, I-1, ONE,
     $               A( K+I, 1 ), LDA, A( K+I, I ), 1, ZERO, T( 1, I ),
     $               1 )
         CALL CGEMV( 'No transpose', N, I-1, -ONE, Y, LDY, T( 1, I ), 1,
     $               ONE, Y( 1, I ), 1 )
         CALL CSCAL( N, TAU( I ), Y( 1, I ), 1 )
*
*        Compute T(1:i,i)
*
         CALL CSCAL( I-1, -TAU( I ), T( 1, I ), 1 )
         CALL CTRMV( 'Upper', 'No transpose', 'Non-unit', I-1, T, LDT,
     $               T( 1, I ), 1 )
         T( I, I ) = TAU( I )
*
   10 CONTINUE
      A( K+NB, NB ) = EI
*
      RETURN
*
*     End of CLAHRD
*
      END
c $Id: clahrd.f 24343 2013-06-22 05:35:15Z d3y133 $

      logical function paw_cell_optimize(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "global.fh"
#include "msgtypesf.h"
#include "rtdb.fh"
#include "errquit.fh"

*     **** local variables ***
      integer taskid,MASTER
      parameter (MASTER=0)
      logical value,value2

      character*50     cell_name
      integer          optimize_strategy,cycles
      integer          optimize_lattice(6)
      double precision lattice_tolerances(6)

      integer i

*     **** external functions ****
      logical  paw_stress,paw_update_unitcell
      external paw_stress,paw_update_unitcell

      taskid = ga_nodeid()

*     **** read in initial data ***
      value = rtdb_cget(rtdb,'cell_optimize:cell_name',1,cell_name)

      value = value.and.
     >        rtdb_get(rtdb,'cell_optimize:optimize_strategy',
     >                 mt_int,1,optimize_strategy)

      value = value.and.
     >        rtdb_get(rtdb,'cell_optimize:cycles',
     >                 mt_int,1,cycles)

      value = value.and.
     >        rtdb_get(rtdb,'cell_optimize:optimize_lattice',
     >                 mt_int,6,optimize_lattice)

      value = value.and.
     >        rtdb_get(rtdb,'cell_optimize:lattice_tolerances',
     >                 mt_dbl,6,lattice_tolerances)


*     *** exit if error found ***
      if(.not. value) 
     >    call errquit('cell_optimize: error reading rtdb',0, RTDB_ERR)


      if (taskid.eq.MASTER) then
        write(*,*) '  ******************************************** '
        write(*,*) '  *                                          * '
        write(*,*) '  *     PAW Cell Optimize - version 0.1      * '
        write(*,*) '  *                                          * '
        write(*,*) '  *      version last updated 5/23/01        * '
        write(*,*) '  *                                          * '
        write(*,*) '  ******************************************** '
        call nwpw_message(1)

        write(*,*) 
        write(*,*) ' Optimizing cell_name       :',cell_name
        write(*,*) ' Optimizing strategy        :',optimize_strategy
        write(*,*) ' optimize_lattice           :',optimize_lattice
        write(*,*) ' Tolerances                 :',lattice_tolerances
        write(*,*) ' Number optimization cycles :',cycles
        write(*,*) 
      endif

*     **** read in initial data ***
      value = .true.
      value2 = rtdb_parallel(.true.)


      call ga_sync()


*     **** start optimization loop ***
      do i=1,cycles

*         **** calculate stress tensor ***
          value = paw_stress(rtdb)
          if(.not. value) 
     >      call errquit('paw_stress did not converge: error',0,
     &       CALC_ERR)


*         **** reformat/adjust unit cell ****
          value2 = rtdb_parallel(.false.)
          if (taskid.eq.MASTER) value = paw_update_unitcell(rtdb)
          value2 = rtdb_parallel(.true.)
          if(.not.value) call errquit(
     >       'cell_optimize: error reformatting unit cell',0,
     &       CALC_ERR)

          call ga_sync()
      end do
      value = .false.
      goto 999

  998 value = .true.

*     **** set to true for debugging ****
  999 value = .true.
      paw_cell_optimize = value
      return
      end
 

c $Id: paw_cell_optimize.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine tce_clone_y2(d_y2,size_y2,irrep,title)
c
c $Id: tce_clone_y2.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "errquit.fh"
c#include "tce.fh"
#include "tce_main.fh"
c#include "tce_prop.fh"
c#include "tce_ints.fh"
#include "tce_amps.fh"
c#include "tce_diis.fh"
      integer rtdb
      logical nodezero         ! True if node 0
      double precision cpu     ! CPU sec counter
      double precision wall    ! WALL sec counter
      integer irrep
      character*8 title
      character*255 filename
c
      nodezero=(ga_nodeid().eq.0)
c
c      call tce_y2_offset(l_y2_offset,k_y2_offset,size_y2,irrep)
      call tce_filename(title,filename)
      call createfile(filename,d_y2,size_y2)
      call gatoeaf(d_y2)
      if (nodezero.and.util_print(title,print_default)) then
c        write(LuOut,*)
        write(LuOut,9000) title,size_y2
        write(LuOut,9010) title,filename(1:120)
#if defined(DEBUG_PRINT)
        write(LuOut,9090) title,d_y2
#endif
c       write(LuOut,9020) cpu
        call util_flush(LuOut)
      endif
c
      return
 9000 format(1x,A,' file size   = ',i16)
 9010 format(1x,A,' file name   = ',A)
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9090 format(1x,A,' file handle = ',i10)

      end

c
c     Interface and computation routines for screened exchange project
c
c     BGJ - 2/01
c
c     $Id: screened_op.F 19696 2010-10-29 16:53:42Z d3y133 $
c
      function screened_exchange()
      implicit none
      logical screened_exchange, screened_x
      double precision Ks
#include "bgj.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
      double precision scrk_Ks
      logical scrk_op_enabled
      common /screened_k/ scrk_Ks, scrk_op_enabled
      logical initd
      save initd
      data initd / .false. /
c
      if (.not. initd) then
         scrk_op_enabled = .false.
         initd = .true.
      endif
c
      screened_x = rtdb_get(bgj_get_rtdb_handle(),
     &     'screened_exchange:Ks',MT_DBL,1,Ks)
      scrk_Ks = Ks
      screened_exchange = screened_x
c
      return
      end
c
      function screened_operator_Ks()
      implicit none
      double precision screened_operator_Ks
#include "bgj.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
      double precision scrk_Ks
      logical scrk_op_enabled
      common /screened_k/ scrk_Ks, scrk_op_enabled
c
      screened_operator_Ks = scrk_Ks
c
      return
      end
c
      subroutine enable_screened_operator()
      implicit none
      double precision Ks
#include "bgj.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
      double precision scrk_Ks
      logical scrk_op_enabled
      common /screened_k/ scrk_Ks, scrk_op_enabled
c
      if (.not.rtdb_put(bgj_get_rtdb_handle(),
     &     'screeend_operator_enabled',MT_LOG,1,.true.))
     &     call errquit('Error enabling screened operator',0, INT_ERR)
c
      scrk_op_enabled = .true.
      if (.not.rtdb_get(bgj_get_rtdb_handle(),
     &     'screened_exchange:Ks',MT_DBL,1,Ks))
     &     call errquit('Could not get screening constant',0, INT_ERR)
      scrk_Ks = Ks
c
      return
      end
c
      subroutine disable_screened_operator()
      implicit none
#include "bgj.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
      double precision scrk_Ks
      logical scrk_op_enabled
      common /screened_k/ scrk_Ks, scrk_op_enabled
c
      if (.not.rtdb_put(bgj_get_rtdb_handle(),
     &     'screened_operator_enabled',MT_LOG,1,.false.))
     &     call errquit('Error disabling screened operator',0, INT_ERR)
c
      scrk_op_enabled = .false.
c
      return
      end
c
      function screened_operator_enabled()
      implicit none
      logical screened_operator_enabled
#include "bgj.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
      double precision scrk_Ks
      logical scrk_op_enabled
      common /screened_k/ scrk_Ks, scrk_op_enabled
c
      screened_operator_enabled = scrk_op_enabled
c
      return
      end
c
      subroutine density_average(rho, qwgt, nq, ipol, ifunc)
      implicit none
      integer nq, ipol, ifunc, i
      double precision t(100), rho(nq,*), qwgt(nq), p, rho_avg,
     &     pi, CF, CTF
      save t
#include "screened_op.fh"
      if (ifunc .eq. 0) then
c        initialize
         call dfill(100,0.D0,t,1)
         return
      endif
      if (ifunc .lt. 0) then
c        print
         pi = acos(-1d0)
         CF = (3.d0*pi*pi)**(1d0/3d0)
         CTF = sqrt(4d0*CF/pi)
         p = t(1)
         rho_avg = t(2)/p
#if 0
         write(*,*)'=== Density average begin ==='
         write(*,*)'int rho:         ',t(1)
         write(*,*)'avg rho:         ',rho_avg, rho_avg/p
         write(*,*)'avg kTF:         ',CTF*t(3)/p
         write(*,*)'kTF from avg rho:',CTF*rho_avg**(1d0/6d0)
         write(*,*)'avg kF:          ',CF*t(4)/p
         write(*,*)'kF from avg rho: ',CF*rho_avg**(1d0/3d0)
         write(*,*)'=== Density average end ==='
#endif
         return
      endif
c
c     Update integrated quantities
c
c     1 - rho
c     2 - rho**2 (average of rho)
c     3 - rho**(7/6) (average of rho**(1/6))
c     4 - rho**(4/3) (average of rho**(1/3))     
c
      do i = 1, nq
         p = rho(i,1)
         t(1) = t(1) + qwgt(i) * p
         t(2) = t(2) + qwgt(i) * p*p
         t(3) = t(3) + qwgt(i) * p*p**(1d0/6d0)
         t(4) = t(4) + qwgt(i) * p*p**(1d0/3d0)
      enddo
      return
      end

      SUBROUTINE ccsdtq_lr_alpha_15_43(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_43.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p13 p17 h15 h16 )_ytrbtrat + = -1/3 * t ( p13 h16 )_t * i2 ( p17 h15 )_ytrbtra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER p17b
      INTEGER h16b
      INTEGER h15b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p13b_1
      INTEGER h16b_1
      INTEGER p17b_2
      INTEGER h15b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p13b = noab+1,noab+nvab
      DO p17b = noab+1,noab+nvab
      DO h16b = 1,noab
      DO h15b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b
     &-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+h16b-1).ne.8)) THEN
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b-1) .eq. int_mb(k_spin
     &+h15b-1)+int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+h15b-1),int_mb(k_sym+h16b-1)))) .eq. ieor(irrep_y,ieor(irr
     &ep_trb,ieor(irrep_tra,irrep_t)))) THEN
      dimc = int_mb(k_range+p13b-1) * int_mb(k_range+p17b-1) * int_mb(k_
     &range+h15b-1) * int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_43',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p13b-1) .eq. int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),int_mb(k_sym+h16b-1)) .eq. irrep_t) 
     &THEN
      CALL TCE_RESTRICTED_2(p13b,h16b,p13b_1,h16b_1)
      CALL TCE_RESTRICTED_2(p17b,h15b,p17b_2,h15b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p13b-1) * int_mb(k_range+h16b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p17b-1) * int_mb(k_range+h15b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_43',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_43',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (p13b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+h16b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_43',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_43',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_43',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h15b_
     &2 - 1 + noab * (p17b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p17b-1
     &),int_mb(k_range+h15b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_43',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &43',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &43',8,MA_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_43',9,MA_ERR)
      IF ((p13b .le. p17b) .and. (h15b .le. h16b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p17b-1),int_mb(k_range+h16b-1),int_mb(k_range+p13
     &b-1),4,2,1,3,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h15b - 1 + noab * (p17b - noab - 1 + nvab * (p13b - 
     &noab - 1)))))
      END IF
      IF ((p13b .le. p17b) .and. (h16b .le. h15b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p17b-1),int_mb(k_range+h16b-1),int_mb(k_range+p13
     &b-1),4,2,3,1,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h16b - 1 + noab * (p17b - noab - 1 + nvab * (p13b - 
     &noab - 1)))))
      END IF
      IF ((p17b .le. p13b) .and. (h15b .le. h16b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p17b-1),int_mb(k_range+h16b-1),int_mb(k_range+p13
     &b-1),2,4,1,3,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h15b - 1 + noab * (p13b - noab - 1 + nvab * (p17b - 
     &noab - 1)))))
      END IF
      IF ((p17b .le. p13b) .and. (h16b .le. h15b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+p17b-1),int_mb(k_range+h16b-1),int_mb(k_range+p13
     &b-1),2,4,3,1,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h16b - 1 + noab * (p13b - noab - 1 + nvab * (p17b - 
     &noab - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_43',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &43',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*     *************************
*     *                       *
*     *     LJparam_init	  *
*     *                       *
*     *************************
      subroutine LJparam_init(rtdb)
      implicit none
#include "errquit.fh"
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"


*     **** LJparam common block ****
      integer ljcount
      integer ion_number(2)
      integer ei(2),si(2)
      real*8 ew,sw
      common / LJparam_Block / ew,sw,ei,si,ion_number,ljcount

*     **** local variables
      logical value
      integer taskid
      integer MASTER
      parameter(MASTER=0)
      integer i,j

      value = rtdb_parallel(.true.)
      value = value.and.
     >        rtdb_get(rtdb,'water_pseudopotential:lj_count',
     >                 mt_int,1,ljcount)
      if (.not. value) call errquit('error reading rtdb',0, RTDB_ERR)


      if (ljcount.gt.0) then

        value = MA_alloc_get(mt_int,(ljcount),'ion_number',
     >                       ion_number(2),ion_number(1))
        value = value.and.
     >          MA_alloc_get(mt_dbl,(ljcount),'ei',ei(2),ei(1))
        value = value.and.
     >          MA_alloc_get(mt_dbl,(ljcount),'si',si(2),si(1))
        if (.not. value) call errquit('out of heap memory',0, MA_ERR)

        value = rtdb_get(rtdb,'water_pseudopotential:lj_ion_number',
     >                   mt_int,ljcount,int_mb(ion_number(1)))
        value = value.and.
     >          rtdb_get(rtdb,'water_pseudopotential:lj_ei',
     >                   mt_dbl,ljcount,dbl_mb(ei(1)))
        value = value.and.
     >          rtdb_get(rtdb,'water_pseudopotential:lj_si',
     >                   mt_dbl,ljcount,dbl_mb(si(1)))
        value = value.and.
     >          rtdb_get(rtdb,'water_pseudopotential:lj_ew',
     >                   mt_dbl,1,ew)
        value = value.and.
     >          rtdb_get(rtdb,'water_pseudopotential:lj_sw',
     >                   mt_dbl,1,sw)
        if (.not. value) call errquit('error reading rtdb',0, RTDB_ERR)
      
         call Parallel_taskid(taskid)
         if (taskid.eq.MASTER) then
          write(*,*)
          write(*,*) "LJ Parameters:"
          do i=1,ljcount
            j = int_mb(ion_number(1)+i-1)
            write(*,'(A11,I4,A12,E10.3,A12,E10.3)') 
     >                  "ion #",j,
     >                  "epsilon:",dbl_mb(ei(1)+j-1), 
     >                  "sigma:",  dbl_mb(si(1)+j-1)
          end do
          write(*,'(A11,A16,E10.3,A12,E10.3)') "water", "epsilon:",ew,
     >                                               "sigma:",sw
          write(*,*)

         end if
      end if

      return
      end

*     *************************
*     *                       *
*     *     LJparam_end		  *
*     *                       *
*     *************************
      subroutine LJparam_end()
      implicit none
#include "errquit.fh"

#include "mafdecls.fh"

*     **** LJparam common block ****
      integer ljcount
      integer ion_number(2)
      integer ei(2),si(2)
      real*8 ew,sw
      common / LJparam_Block / ew,sw,ei,si,ion_number,ljcount

      logical value

      if (ljcount.gt.0) then
         value = MA_free_heap(ion_number(2))
         value = value.and.MA_free_heap(ei(2))
         value = value.and.MA_free_heap(si(2))
         if (.not.value) call errquit('error MA_free_heap',0, MA_ERR)
      end if

      return
      end


*     ***************************
*     *							*
*     *         LJparam_Ion		*
*     *							*
*     ***************************

      subroutine LJparam_Ion(i,e,s)
      implicit none
      integer i
      real*8  e,s

#include "mafdecls.fh"

*     **** LJparam common block ****
      integer ljcount
      integer ion_number(2)
      integer ei(2),si(2)
      real*8 ew,sw
      common / LJparam_Block / ew,sw,ei,si,ion_number,ljcount

*     **** local variables ****
      logical found
      integer ii,j

      found = .false.
      do ii=1,ljcount
         if (int_mb(ion_number(1)+ii-1) .eq. i) then
             j = ii
             found = .true.
         end if
      end do

      if (found) then
         e = dbl_mb(ei(1)+j-1)
         s = dbl_mb(si(i)+j-1)
      else
         e = 0.0d0
         s = 0.0d0
      end if

      return
      end
      
*     ***************************
*     *							*
*     *         LJparam_water	*
*     *							*
*     ***************************

      subroutine LJparam_water(e,s)
      implicit none
      real*8  e,s

*     **** LJparam common block ****
      integer ljcount
      integer ion_number(2)
      integer ei(2),si(2)
      real*8 ew,sw
      common / LJparam_Block / ew,sw,ei,si,ion_number,ljcount

      e = ew
      s = sw
      return
      end
c $Id: LJparam_Ion.F 21176 2011-10-10 06:35:49Z d3y133 $

C $Id: rel_init_con.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine rel_init_con (rtdb)
*                                                                      *
*   Routine to initialize constants required by relativistic integrals *
*                                                                      *
*   Written by Kenneth G. Dyall                                        *
*                                                                      *
************************************************************************
      implicit none
c     
      integer rtdb ! [input] handle to database
c
#include "rtdb.fh"
#include "mafdecls.fh"
#include "rel_consts.fh"
c
      double precision clight
c
      cau = 137.0359895d00
      if (rtdb_get(rtdb,'relativistic:clight',mt_dbl,1,clight))
     &    cau = clight
      csq = cau*cau
      alpha = 1.0d00/cau
      halp = 0.5d00*alpha
      halsq = halp*alpha
      qalsq = halp*halp
      salf = qalsq*qalsq
c
      return
      end

      subroutine tce_sortacc_0(unsorted,sorted,factor)
c
c $Id: tce_sortacc.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce_main.fh"
      double precision sorted
      double precision unsorted
      double precision factor
c
c     Plain original algorithm
c
      sorted = sorted + unsorted * factor
      return
      end
      subroutine tce_sortacc_2(unsorted,sorted,a,b,
     1                         i,j,factor)
c
c $Id: tce_sortacc.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce_main.fh"
      integer a,b
      integer i,j
      integer id(2),jd(2),ia,ib,j1,j2
      double precision sorted(a*b)
      double precision unsorted(a*b)
      double precision factor
c
c     Plain original algorithm
c
      cpusecs(7) = cpusecs(7) - util_cpusec()
      cpusecs(57) = cpusecs(57) - util_wallsec()
      ia = 0
      jd(1) = a
      jd(2) = b
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        ia = ia + 1
        ib = id(j)+jd(j)*(id(i)-1)
        sorted(ib) = sorted(ib) + unsorted(ia) * factor
       enddo
      enddo
      cpusecs(7) = cpusecs(7) + util_cpusec()
      cpusecs(57) = cpusecs(57) + util_wallsec()
      return
      end
      subroutine tce_sortacc_4(unsorted,sorted,a,b,c,d,
     1                         i,j,k,l,factor)
c
c $Id: tce_sortacc.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce_main.fh"
      integer a,b,c,d
      integer i,j,k,l
      integer id(4),jd(4),ia,ib,j1,j2,j3,j4
      double precision sorted(a*b*c*d)
      double precision unsorted(a*b*c*d)
      double precision factor
c
c     Plain original algorithm
c
      cpusecs(7) = cpusecs(7) - util_cpusec()
      cpusecs(57) = cpusecs(57) - util_wallsec()
      jd(1) = a
      jd(2) = b
      jd(3) = c
      jd(4) = d
      if ((l.eq.4).or.(l.eq.3)) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j3 = 1,c
         id(3) = j3
         do j4 = 1,d
          id(4) = j4
          ia = id(4)+jd(4)*(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))
          ib = id(l)+jd(l)*(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))
          sorted(ib) = sorted(ib) + unsorted(ia) * factor
         enddo
        enddo
       enddo
      enddo
      else if (l.eq.2) then
      do j1 = 1,a
       id(1) = j1
       do j3 = 1,c
        id(3) = j3
        do j2 = 1,b
         id(2) = j2
         do j4 = 1,d
          id(4) = j4
          ia = id(4)+jd(4)*(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))
          ib = id(l)+jd(l)*(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))
          sorted(ib) = sorted(ib) + unsorted(ia) * factor
         enddo
        enddo
       enddo
      enddo
      else
      do j2 = 1,b
       id(2) = j2
       do j3 = 1,c
        id(3) = j3
        do j1 = 1,a
         id(1) = j1
         do j4 = 1,d
          id(4) = j4
          ia = id(4)+jd(4)*(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))
          ib = id(l)+jd(l)*(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))
          sorted(ib) = sorted(ib) + unsorted(ia) * factor
         enddo
        enddo
       enddo
      enddo
      endif
      cpusecs(7) = cpusecs(7) + util_cpusec()
      cpusecs(57) = cpusecs(57) + util_wallsec()
      return
      end
      subroutine tce_sortacc_6(unsorted,sorted,a,b,c,d,e,f,
     1                         i,j,k,l,m,n,factor)
c
c $Id: tce_sortacc.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce_main.fh"
      integer a,b,c,d,e,f
      integer i,j,k,l,m,n
      integer id(6),jd(6),ia,ib,j1,j2,j3,j4,j5,j6
      double precision sorted(a*b*c*d*e*f)
      double precision unsorted(a*b*c*d*e*f)
      double precision factor
      double precision cpu
c
c     Plain original algorithm
c
      cpusecs(7) = cpusecs(7) - util_cpusec()
      cpusecs(57) = cpusecs(57) - util_wallsec()
      cpu = -util_cpusec()
      ia = 0
      jd(1) = a
      jd(2) = b
      jd(3) = c
      jd(4) = d
      jd(5) = e
      jd(6) = f
      if ((n.eq.6).or.(n.eq.5)) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j3 = 1,c
         id(3) = j3
         do j4 = 1,d
          id(4) = j4
          do j5 = 1,e
           id(5) = j5
           do j6 = 1,f
            id(6) = j6
            ia = id(6)+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     1         *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))
            ib = id(n)+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     1         *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))
            sorted(ib) = sorted(ib) + unsorted(ia) * factor
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (n.eq.4) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j3 = 1,c
         id(3) = j3
         do j5 = 1,e
          id(5) = j5
          do j4 = 1,d
           id(4) = j4
           do j6 = 1,f
            id(6) = j6
            ia = id(6)+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     1         *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))
            ib = id(n)+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     1         *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))
            sorted(ib) = sorted(ib) + unsorted(ia) * factor
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (n.eq.3) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j4 = 1,d
         id(4) = j4
         do j5 = 1,e
          id(5) = j5
          do j3 = 1,c
           id(3) = j3
           do j6 = 1,f
            id(6) = j6
            ia = id(6)+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     1         *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))
            ib = id(n)+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     1         *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))
            sorted(ib) = sorted(ib) + unsorted(ia) * factor
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (n.eq.2) then
      do j1 = 1,a
       id(1) = j1
       do j3 = 1,c
        id(3) = j3
        do j4 = 1,d
         id(4) = j4
         do j5 = 1,e
          id(5) = j5
          do j2 = 1,b
           id(2) = j2
           do j6 = 1,f
            id(6) = j6
            ia = id(6)+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     1         *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))
            ib = id(n)+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     1         *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))
            sorted(ib) = sorted(ib) + unsorted(ia) * factor
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else
      do j2 = 1,b
       id(2) = j2
       do j3 = 1,c
        id(3) = j3
        do j4 = 1,d
         id(4) = j4
         do j5 = 1,e
          id(5) = j5
          do j1 = 1,a
           id(1) = j1
           do j6 = 1,f
            id(6) = j6
            ia = id(6)+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     1         *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))
            ib = id(n)+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     1         *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))
            sorted(ib) = sorted(ib) + unsorted(ia) * factor
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      endif
      cpusecs(7) = cpusecs(7) + util_cpusec()
      cpusecs(57) = cpusecs(57) + util_wallsec()
      cpu = cpu + util_cpusec()
c     write(*,*) cpu
      return
      end
      subroutine tce_sortacc_8(unsorted,sorted,a,b,c,d,e,f,g,h,
     1                         i,j,k,l,m,n,o,p,factor)
c
c $Id: tce_sortacc.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce_main.fh"
      integer a,b,c,d,e,f,g,h
      integer i,j,k,l,m,n,o,p
      integer id(8),jd(8),ia,ib,j1,j2,j3,j4,j5,j6,j7,j8
      double precision sorted(a*b*c*d*e*f*g*h)
      double precision unsorted(a*b*c*d*e*f*g*h)
      double precision factor
c
c     Plain original algorithm
c
      jd(1) = a
      jd(2) = b
      jd(3) = c
      jd(4) = d
      jd(5) = e
      jd(6) = f
      jd(7) = g
      jd(8) = h
      if ((p.eq.8).or.(p.eq.7)) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j3 = 1,c
         id(3) = j3
         do j4 = 1,d
          id(4) = j4
          do j5 = 1,e
           id(5) = j5
           do j6 = 1,f
            id(6) = j6
            do j7 = 1,g
             id(7) = j7
             do j8 = 1,h
              id(8) = j8
              ia = id(8)+jd(8)*(id(7)-1+jd(7)
     1           *(id(6)-1+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     2           *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))))
              ib = id(p)+jd(p)*(id(o)-1+jd(o)
     1           *(id(n)-1+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     2           *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))))
              sorted(ib) = sorted(ib) + unsorted(ia) * factor
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (p.eq.6) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j3 = 1,c
         id(3) = j3
         do j4 = 1,d
          id(4) = j4
          do j5 = 1,e
           id(5) = j5
           do j7 = 1,g
            id(7) = j7
            do j6 = 1,f
             id(6) = j6
             do j8 = 1,h
              id(8) = j8
              ia = id(8)+jd(8)*(id(7)-1+jd(7)
     1           *(id(6)-1+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     2           *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))))
              ib = id(p)+jd(p)*(id(o)-1+jd(o)
     1           *(id(n)-1+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     2           *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))))
              sorted(ib) = sorted(ib) + unsorted(ia) * factor
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (p.eq.5) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j3 = 1,c
         id(3) = j3
         do j4 = 1,d
          id(4) = j4
          do j6 = 1,f
           id(6) = j6
           do j7 = 1,g
            id(7) = j7
            do j5 = 1,e
             id(5) = j5
             do j8 = 1,h
              id(8) = j8
              ia = id(8)+jd(8)*(id(7)-1+jd(7)
     1           *(id(6)-1+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     2           *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))))
              ib = id(p)+jd(p)*(id(o)-1+jd(o)
     1           *(id(n)-1+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     2           *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))))
              sorted(ib) = sorted(ib) + unsorted(ia) * factor
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (p.eq.4) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j3 = 1,c
         id(3) = j3
         do j5 = 1,e
          id(5) = j5
          do j6 = 1,f
           id(6) = j6
           do j7 = 1,g
            id(7) = j7
            do j4 = 1,d
             id(4) = j4
             do j8 = 1,h
              id(8) = j8
              ia = id(8)+jd(8)*(id(7)-1+jd(7)
     1           *(id(6)-1+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     2           *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))))
              ib = id(p)+jd(p)*(id(o)-1+jd(o)
     1           *(id(n)-1+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     2           *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))))
              sorted(ib) = sorted(ib) + unsorted(ia) * factor
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (p.eq.3) then
      do j1 = 1,a
       id(1) = j1
       do j2 = 1,b
        id(2) = j2
        do j4 = 1,d
         id(4) = j4
         do j5 = 1,e
          id(5) = j5
          do j6 = 1,f
           id(6) = j6
           do j7 = 1,g
            id(7) = j7
            do j3 = 1,c
             id(3) = j3
             do j8 = 1,h
              id(8) = j8
              ia = id(8)+jd(8)*(id(7)-1+jd(7)
     1           *(id(6)-1+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     2           *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))))
              ib = id(p)+jd(p)*(id(o)-1+jd(o)
     1           *(id(n)-1+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     2           *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))))
              sorted(ib) = sorted(ib) + unsorted(ia) * factor
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else if (p.eq.2) then
      do j1 = 1,a
       id(1) = j1
       do j3 = 1,c
        id(3) = j3
        do j4 = 1,d
         id(4) = j4
         do j5 = 1,e
          id(5) = j5
          do j6 = 1,f
           id(6) = j6
           do j7 = 1,g
            id(7) = j7
            do j2 = 1,b
             id(2) = j2
             do j8 = 1,h
              id(8) = j8
              ia = id(8)+jd(8)*(id(7)-1+jd(7)
     1           *(id(6)-1+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     2           *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))))
              ib = id(p)+jd(p)*(id(o)-1+jd(o)
     1           *(id(n)-1+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     2           *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))))
              sorted(ib) = sorted(ib) + unsorted(ia) * factor
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      else
      do j2 = 1,b
       id(2) = j2
       do j3 = 1,c
        id(3) = j3
        do j4 = 1,d
         id(4) = j4
         do j5 = 1,e
          id(5) = j5
          do j6 = 1,f
           id(6) = j6
           do j7 = 1,g
            id(7) = j7
            do j1 = 1,a
             id(1) = j1
             do j8 = 1,h
              id(8) = j8
              ia = id(8)+jd(8)*(id(7)-1+jd(7)
     1           *(id(6)-1+jd(6)*(id(5)-1+jd(5)*(id(4)-1+jd(4)
     2           *(id(3)-1+jd(3)*(id(2)-1+jd(2)*(id(1)-1)))))))
              ib = id(p)+jd(p)*(id(o)-1+jd(o)
     1           *(id(n)-1+jd(n)*(id(m)-1+jd(m)*(id(l)-1+jd(l)
     2           *(id(k)-1+jd(k)*(id(j)-1+jd(j)*(id(i)-1)))))))
              sorted(ib) = sorted(ib) + unsorted(ia) * factor
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      endif
      return
      end

      SUBROUTINE cc2_t2(d_f1,d_i0,d_t1,d_t2,d_v2,k_f1_offset,k_i0_offset
     &,k_t1_offset,k_t2_offset,k_v2_offset,size_t2)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_v + = 1 * v ( p3 p4 h1 h2 )_v
C     i0 ( p3 p4 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( h10 ) * t ( p3 h10 )_t * i1 ( h10 p4 h1 h2 )_v
C         i1 ( h10 p3 h1 h2 )_v + = 1 * v ( h10 p3 h1 h2 )_v
C         i1 ( h10 p3 h1 h2 )_vt + = 1/2 * Sum ( h8 ) * t ( p3 h8 )_t * i2 ( h8 h10 h1 h2 )_v
C             i2 ( h8 h10 h1 h2 )_v + = 1 * v ( h8 h10 h1 h2 )_v
C             i2 ( h8 h10 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p5 ) * t ( p5 h1 )_t * i3 ( h8 h10 h2 p5 )_v
C                 i3 ( h8 h10 h1 p5 )_v + = 1 * v ( h8 h10 h1 p5 )_v
C                 i3 ( h8 h10 h1 p5 )_vt + = -1/2 * Sum ( p6 ) * t ( p6 h1 )_t * v ( h8 h10 p5 p6 )_v
C         i1 ( h10 p3 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p5 ) * t ( p5 h1 )_t * i2 ( h10 p3 h2 p5 )_v
C             i2 ( h10 p3 h1 p5 )_v + = 1 * v ( h10 p3 h1 p5 )_v
C             i2 ( h10 p3 h1 p5 )_vt + = -1/2 * Sum ( p6 ) * t ( p6 h1 )_t * v ( h10 p3 p5 p6 )_v
C     i0 ( p3 p4 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p5 ) * t ( p5 h1 )_t * i1 ( p3 p4 h2 p5 )_v
C         i1 ( p3 p4 h1 p5 )_v + = 1 * v ( p3 p4 h1 p5 )_v
C         i1 ( p3 p4 h1 p5 )_vt + = -1/2 * Sum ( p6 ) * t ( p6 h1 )_t * v ( p3 p4 p5 p6 )_v
C     i0 ( p3 p4 h1 h2 )_tf + = -1 * P( 2 ) * Sum ( h5 ) * t ( p3 p4 h1 h5 )_t * f ( h5 h2 )_f
C     i0 ( p3 p4 h1 h2 )_tf + = 1 * P( 2 ) * Sum ( p5 ) * t ( p3 p5 h1 h2 )_t * f ( p4 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER size_t2
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER l_i2_offset
      INTEGER size_i2
      INTEGER d_i3
      INTEGER k_i3_offset
      INTEGER l_i3_offset
      INTEGER size_i3
c --- fusion of 4-p diagrams ---
      INTEGER d_d2,l_d2_offset,k_d2_offset
c ------------------------------
      CHARACTER*255 filename
      CALL cc2_t2_1(d_v2,k_v2_offset,d_i0,k_i0_offset)
      CALL OFFSET_cc2_t2_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('cc2_t2_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL cc2_t2_2_1(d_v2,k_v2_offset,d_i1,k_i1_offset)
      CALL OFFSET_cc2_t2_2_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('cc2_t2_2_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL cc2_t2_2_2_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL OFFSET_cc2_t2_2_2_2_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('cc2_t2_2_2_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL cc2_t2_2_2_2_1(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL cc2_t2_2_2_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i3,k_i3_of
     &fset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL cc2_t2_2_2_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_i2_offs
     &et)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('cc2_t2',-1,MA_ER
     &R)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL cc2_t2_2_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_offset
     &)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('cc2_t2',-1,MA_ER
     &R)
      CALL OFFSET_cc2_t2_2_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('cc2_t2_2_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL cc2_t2_2_3_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL cc2_t2_2_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i2_offs
     &et)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL cc2_t2_2_3(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_offset
     &)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('cc2_t2',-1,MA_ER
     &R)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL cc2_t2_2(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('cc2_t2',-1,MA_ER
     &R)
c
c
      CALL lccsd_t2_3x(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i0,
     &k_i0_offset)
      call tce_filename('d2',filename)
      call createfile(filename,d_d2,size_t2)
      call tce_zero(d_d2,size_t2)
      CALL RECONCILEFILE(d_d2,size_t2)
      CALL c2f_t2_t12(d_t1,k_t1_offset,d_d2,k_t2_offset)
      CALL ccsd_t2_8(d_d2,k_t2_offset,d_v2,k_v2_offset,d_i0,k_i0_offset)
      call deletefile(d_d2)
c
c
c      CALL OFFSET_cc2_t2_3_1(l_i1_offset,k_i1_offset,size_i1)
c      CALL TCE_FILENAME('cc2_t2_3_1_i1',filename)
c      CALL CREATEFILE(filename,d_i1,size_i1)
c      CALL cc2_t2_3_1(d_v2,k_v2_offset,d_i1,k_i1_offset)
c      CALL cc2_t2_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,k_i1_offset
c     &)
c      CALL RECONCILEFILE(d_i1,size_i1)
c      CALL cc2_t2_3(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
c      CALL DELETEFILE(d_i1)
c      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('cc2_t2',-1,MA_ER
c     &R)
c
      CALL cc2_t2_4(d_t2,k_t2_offset,d_f1,k_f1_offset,d_i0,k_i0_offset)
      CALL cc2_t2_5(d_t2,k_t2_offset,d_f1,k_f1_offset,d_i0,k_i0_offset)
      RETURN
      END
      SUBROUTINE cc2_t2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_v + = 1 * v ( p3 p4 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h2b,p3b_1,p4b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_1',1,MA_ERR)
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p4b_1 - 1 + (noab
     &+nvab) * (p3b_1 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),
     &(h2b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p4b_1 - 1 + (noab
     &+nvab) * (p3b_1 - 1)))),h2b_1,h1b_1,p4b_1,p3b_1)
      end if
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( h10 ) * t ( p3 h10 )_t * i1 ( h10 p4 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h10b
      INTEGER p3b_1
      INTEGER h10b_1
      INTEGER p4b_2
      INTEGER h10b_2
      INTEGER h1b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_v,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h10b = 1,noab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h10b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h10b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p3b,h10b,p3b_1,h10b_1)
      CALL TCE_RESTRICTED_4(p4b,h10b,h1b,h2b,p4b_2,h10b_2,h1b_2,h2b_2)
      dim_common = int_mb(k_range+h10b-1)
      dima_sort = int_mb(k_range+p3b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h10b_
     &1 - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h10b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (h10b_2 - 1 + noab * (p4b_2 - no
     &ab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2',9,MA_ERR)
      IF ((p3b .le. p4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((p4b .le. p3b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p3b - noab - 1 + nvab * (p4b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_2',11,MA_ERR
     &)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h10 p3 h1 h2 )_v + = 1 * v ( h10 p3 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER h10b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+h2b-1)
      CALL TCE_RESTRICTED_4(p3b,h10b,h1b,h2b,p3b_1,h10b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_1',1,MA_ERR)
      IF ((h10b .le. p3b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p3b_1 - 1 + (noab
     &+nvab) * (h10b_1 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),
     &(h2b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p3b_1 - 1 + (noab
     &+nvab) * (h10b_1 - 1)))),h2b_1,h1b_1,p3b_1,h10b_1)
      end if
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h10b - 1 + noab * (p3b - noab - 1))
     &)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_1',5,MA_ER
     &R)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_cc2_t2_2_1(l_a_offset,k_a_offset,size)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h10 p3 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p3b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      length = 0
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('cc2_t2_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h2b - 1 + noab * (h1b - 1 + noab * (h10b
     & - 1 + noab * (p3b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int
     &_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE cc2_t2_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h10 p3 h1 h2 )_vt + = 1/2 * Sum ( h8 ) * t ( p3 h8 )_t * i2 ( h8 h10 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h8b
      INTEGER p3b_1
      INTEGER h8b_1
      INTEGER h10b_2
      INTEGER h8b_2
      INTEGER h1b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h8b = 1,noab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h8b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h8b,p3b_1,h8b_1)
      CALL TCE_RESTRICTED_4(h10b,h8b,h1b,h2b,h10b_2,h8b_2,h1b_2,h2b_2)
      dim_common = int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+p3b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h10b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h8b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_2_2',5,MA_ERR)
      IF ((h8b .le. h10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (h10b_2 - 1 + noab * (h8b_2 - 1)
     &))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,2,1,1.0d0)
      END IF
      IF ((h10b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (h8b_2 - 1 + noab * (h10b_2 - 1)
     &))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,1,2,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_2_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_2_2',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_2',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h10b - 1 + noab * (p3b - noab - 1))
     &)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_2_2',11,MA_E
     &RR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_2_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h8 h10 h1 h2 )_v + = 1 * v ( h8 h10 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h8b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER h8b_1
      INTEGER h10b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+h2b-1)
      CALL TCE_RESTRICTED_4(h8b,h10b,h1b,h2b,h8b_1,h10b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_2_1',1,MA_ERR)
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (h10b_1 - 1 + (noa
     &b+nvab) * (h8b_1 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),
     &(h2b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (h10b_1 - 1 + (noa
     &b+nvab) * (h8b_1 - 1)))),h2b_1,h1b_1,h10b_1,h8b_1)
      end if
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_2_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h10b-1),int_mb(k_range+h8b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h10b - 1 + noab * (h8b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_2_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_2_1',5,MA_
     &ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_cc2_t2_2_2_1(l_a_offset,k_a_offset,size)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h8 h10 h1 h2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h8b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      length = 0
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('cc2_t2_2_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h2b - 1 + noab * (h1b - 1 + noab * (h10b
     & - 1 + noab * (h8b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int
     &_mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE cc2_t2_2_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h8 h10 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p5 ) * t ( p5 h1 )_t * i3 ( h8 h10 h2 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h8b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER h8b_2
      INTEGER h10b_2
      INTEGER h2b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h1b,p5b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h8b,h10b,h2b,p5b,h8b_2,h10b_2,h2b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_2_2_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h2b_2 - 1 + noab * (h10b_2 - 1 + noab * (h8b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+p5b-1
     &),3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_2_2_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_2_2_2',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_2_2',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_2_2',9,MA_ERR)
      IF ((h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h8b-1),int_mb(k_range+h1b-1
     &),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h10b - 1 + noab * (h8b - 1)))))
      END IF
      IF ((h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h8b-1),int_mb(k_range+h1b-1
     &),3,2,1,4,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (h10b - 1 + noab * (h8b - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_2_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_2_2_2',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_2_2_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h8 h10 h1 p5 )_v + = 1 * v ( h8 h10 h1 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h8b
      INTEGER h10b
      INTEGER h1b
      INTEGER p5b
      INTEGER dimc
      INTEGER h8b_1
      INTEGER h10b_1
      INTEGER h1b_1
      INTEGER p5b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p5b-1)
      CALL TCE_RESTRICTED_4(h8b,h10b,h1b,p5b,h8b_1,h10b_1,h1b_1,p5b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+h1b-1) * int_mb(k_range+p5b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_2_2_1',1,MA_ERR)
      IF ((h1b .le. p5b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (h10b_1 - 1 + (noa
     &b+nvab) * (h8b_1 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),
     &(p5b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (h10b_1 - 1 + (noa
     &b+nvab) * (h8b_1 - 1)))),p5b_1,h1b_1,h10b_1,h8b_1)
      end if
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1
     &),4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_2_2_1',2,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_2_2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h10b-1),int_mb(k_range+h8b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h10b - 1 + noab * (h8b - 1))
     &)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_2_2_1',4,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_2_2_1',5,M
     &A_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_cc2_t2_2_2_2_1(l_a_offset,k_a_offset,size)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h8 h10 h1 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h8b
      INTEGER h10b
      INTEGER h1b
      INTEGER p5b
      length = 0
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('cc2_t2_2_2_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p5b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (h10b - 1 + noab * (h8b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int
     &_mb(k_range+h1b-1) * int_mb(k_range+p5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE cc2_t2_2_2_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h8 h10 h1 p5 )_vt + = -1/2 * Sum ( p6 ) * t ( p6 h1 )_t * v ( h8 h10 p5 p6 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h8b
      INTEGER h10b
      INTEGER h1b
      INTEGER p5b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h8b_2
      INTEGER h10b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h8b = 1,noab
      DO h10b = h8b,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p5b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p6b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p6b,h1b,p6b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h8b,h10b,p5b,p6b,h8b_2,h10b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h8b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+p5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_2_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p6b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_2_2_2',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_2_2_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_2_2_2_2',5,MA_ERR)
      IF ((p6b .lt. p5b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (h10b_2 - 1 + (noa
     &b+nvab) * (h8b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p5b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (h10b_2 - 1 + (noa
     &b+nvab) * (h8b_2 - 1)))),p5b_2,p6b_2,h10b_2,h8b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1
     &),4,2,1,3,-1.0d0)
      END IF
      IF ((p5b .le. p6b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h10b_2 - 1 + (noa
     &b+nvab) * (h8b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h10b_2 - 1 + (noa
     &b+nvab) * (h8b_2 - 1)))),p6b_2,p5b_2,h10b_2,h8b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_2_2_2_2',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_2_2_2_2',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_2_2_2',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_2_2_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h8b-1),int_mb(k_range+h1b-1
     &),3,2,4,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h10b - 1 + noab * (h8b - 1))
     &)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_2_2_2',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_2_2_2_2',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_2_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h10 p3 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p5 ) * t ( p5 h1 )_t * i2 ( h10 p3 h2 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h10b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER p3b_2
      INTEGER h10b_2
      INTEGER h2b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h1b,p5b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p3b,h10b,h2b,p5b,p3b_2,h10b_2,h2b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_3',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_2_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h2b_2 - 1 + noab * (h10b_2 - 1 + noab * (p3b
     &_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+h2b-1),int_mb(k_range+p5b-1
     &),3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_2_3',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_2_3',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_3',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_3',9,MA_ERR)
      IF ((h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1
     &),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h10b - 1 + noab * (p3b - noab - 1))
     &)))
      END IF
      IF ((h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1
     &),3,2,1,4,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (h10b - 1 + noab * (p3b - noab - 1))
     &)))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_3',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_2_3',11,MA_E
     &RR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_2_3_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h10 p3 h1 p5 )_v + = 1 * v ( h10 p3 h1 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h10b
      INTEGER h1b
      INTEGER p5b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER h10b_1
      INTEGER h1b_1
      INTEGER p5b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p5b-1)
      CALL TCE_RESTRICTED_4(p3b,h10b,h1b,p5b,p3b_1,h10b_1,h1b_1,p5b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+h1b-1) * int_mb(k_range+p5b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_3_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_3_1',1,MA_ERR)
      IF ((h10b .le. p3b) .and. (h1b .le. p5b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p3b_1 - 1 + (noab
     &+nvab) * (h10b_1 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),
     &(p5b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p3b_1 - 1 + (noab
     &+nvab) * (h10b_1 - 1)))),p5b_1,h1b_1,p3b_1,h10b_1)
      end if
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_3_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_3_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h10b-1),int_mb(k_range+p3b-1
     &),4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h10b - 1 + noab * (p3b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_3_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_3_1',5,MA_
     &ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_cc2_t2_2_3_1(l_a_offset,k_a_offset,size)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h10 p3 h1 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p3b
      INTEGER h10b
      INTEGER h1b
      INTEGER p5b
      length = 0
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('cc2_t2_2_3_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+p3b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p5b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (h10b - 1 + noab * (p3b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int
     &_mb(k_range+h1b-1) * int_mb(k_range+p5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE cc2_t2_2_3_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h10 p3 h1 p5 )_vt + = -1/2 * Sum ( p6 ) * t ( p6 h1 )_t * v ( h10 p3 p5 p6 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h10b
      INTEGER h1b
      INTEGER p5b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER p3b_2
      INTEGER h10b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO h10b = 1,noab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-
     &1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+h10b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_mb(k_r
     &ange+h1b-1) * int_mb(k_range+p5b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_2_3_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p6b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p6b,h1b,p6b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p3b,h10b,p5b,p6b,p3b_2,h10b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h10b-1) * int_m
     &b(k_range+p5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_2_3_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_2_3_2',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p6b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_2_3_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_2_3_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_2_3_2',5,MA_ERR)
      IF ((h10b .le. p3b) .and. (p6b .lt. p5b)) THEN
      if(.not.intorb) then 
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + (noab
     &+nvab) * (h10b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p5b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + (noab
     &+nvab) * (h10b_2 - 1)))),p5b_2,p6b_2,p3b_2,h10b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1
     &),4,1,2,3,-1.0d0)
      END IF
      IF ((h10b .le. p3b) .and. (p5b .le. p6b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + (noab
     &+nvab) * (h10b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (p3b_2 - 1 + (noab
     &+nvab) * (h10b_2 - 1)))),p6b_2,p5b_2,p3b_2,h10b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+p3b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_2_3_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_2_3_2',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_2_3_2',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_2_3_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h10b-1),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1
     &),3,2,4,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h10b - 1 + noab * (p3b - noa
     &b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_2_3_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_2_3_2',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_vt + = -1 * P( 2 ) * Sum ( p5 ) * t ( p5 h1 )_t * i1 ( p3 p4 h2 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER h2b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_v,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h1b,p5b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p3b,p4b,h2b,p5b,p3b_2,p4b_2,h2b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_3',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h2b_2 - 1 + noab * (p4b_2 - noab - 1 + nvab 
     &* (p3b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h2b-1),int_mb(k_range+p5b-1)
     &,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_3',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_3',9,MA_ERR)
      IF ((h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1)
     &,3,2,1,4,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_3',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_3',11,MA_ERR
     &)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_3_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p3 p4 h1 p5 )_v + = 1 * v ( p3 p4 h1 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER p5b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER p5b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p5b-1)
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,p5b,p3b_1,p4b_1,h1b_1,p5b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+p5b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_3_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_3_1',1,MA_ERR)
      IF ((h1b .le. p5b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p4b_1 - 1 + (noab
     &+nvab) * (p3b_1 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),
     &(p5b_1
     & - 1 + (noab+nvab) * (h1b_1 - 1 + (noab+nvab) * (p4b_1 - 1 + (noab
     &+nvab) * (p3b_1 - 1)))),p5b_1,h1b_1,p4b_1,p3b_1)
      end if
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_3_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_3_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b
     & - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_3_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_3_1',5,MA_ER
     &R)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_cc2_t2_3_1(l_a_offset,k_a_offset,size)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p3 p4 h1 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER p5b
      length = 0
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('cc2_t2_3_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p5b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (p4b - noab - 1 + nvab * (p3b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+p5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE cc2_t2_3_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p3 p4 h1 p5 )_vt + = -1/2 * Sum ( p6 ) * t ( p6 h1 )_t * v ( p3 p4 p5 p6 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER p5b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p5b-1)))) .eq. ieor(irrep_v,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p5b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_3_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p6b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p6b,h1b,p6b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p3b,p4b,p5b,p6b,p3b_2,p4b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+p5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_3_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_3_2',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     &int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p6b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_3_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_3_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_3_2',5,MA_ERR)
      IF ((p6b .lt. p5b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (p4b_2 - 1 + (noab
     &+nvab) * (p3b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p5b_2
     & - 1 + (noab+nvab) * (p6b_2 - 1 + (noab+nvab) * (p4b_2 - 1 + (noab
     &+nvab) * (p3b_2 - 1)))),p5b_2,p6b_2,p4b_2,p3b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p5b .le. p6b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (p4b_2 - 1 + (noab
     &+nvab) * (p3b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (p4b_2 - 1 + (noab
     &+nvab) * (p3b_2 - 1)))),p6b_2,p5b_2,p4b_2,p3b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_3_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_3_2',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_3_2',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_3_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p3b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b
     & - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_3_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_3_2',11,MA_E
     &RR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_tf + = -1 * P( 2 ) * Sum ( h5 ) * t ( p3 p4 h1 h5 )_t * f ( h5 h2 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h5b_1
      INTEGER h5b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_f)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h5b,p3b_1,p4b_1,h1b_1,h5b_1)
      CALL TCE_RESTRICTED_2(h5b,h2b,h5b_2,h2b_2)
      dim_common = int_mb(k_range+h5b-1)
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_4',2,MA_ERR)
      IF ((h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h5b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_4',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + (noab+nvab) * (h5b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_4',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_4',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_4',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_4',9,MA_ERR)
      IF ((h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_4',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_4',11,MA_ERR
     &)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cc2_t2_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: cc2_t2.F 21580 2011-11-29 19:12:06Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_tf + = 1 * P( 2 ) * Sum ( p5 ) * t ( p3 p5 h1 h2 )_t * f ( p4 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p3b_1
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p3b = noab+1,noab+nvab
      DO p4b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_f)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cc2_t2_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p5b,h1b,h2b,p3b_1,p5b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_2(p4b,p5b,p4b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cc2_t2_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cc2_t2_5',2,MA_ERR)
      IF ((p5b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p3b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cc2_t2_5',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cc2_t2_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cc2_t2_5',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p4b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cc2_t2_5',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cc2_t2_5',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cc2_t2_5',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cc2_t2_5',9,MA_ERR)
      IF ((p3b .le. p4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,4,1,3,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((p4b .le. p3b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,1,4,3,2,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p3b - noab - 1 + nvab * (p4b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cc2_t2_5',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cc2_t2_5',11,MA_ERR
     &)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

c $Id: int_term.F 23383 2013-01-07 02:07:18Z d3y133 $
C> \ingroup nwint
C> @{
C>
C> \brief The main integral termination routine
C>
c:tex-
c:tex-%API Initialization and Termination Routines
c:tex-\subsection{int\_terminate}
c:tex-This is the main termination routine for integrals.
c:tex-After this call the INT-API is ready for re-initialization.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_terminate()
c:tex-\end{verbatim}
c:tex-No formal arguments
c:tex-
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "apiP.fh"
#include "candoP.fh"
#include "stdio.fh"
c::functions
      logical spcart_terminate 
      external spcart_terminate 
      logical hnd_terminate 
      external hnd_terminate 
c
      if (init_int .eq. 0) then
        write(luout,*)' warning: int_init has not been called '
      endif
      call int_mem_zero()
c      
* def u=f d=f -> f.and.!f -> f -> e = t
* no txs u=t d=f -> t.and.!f -> t -> e = f
      if (.not.(user_cando_txs.and.(.not.def_cando_txs))) then
        call texas_terminate()
      endif
      if (.not.spcart_terminate()) then
        call errquit('int_terminate: spcart_terminate failed',0, 
     &             INT_ERR)
      endif
      if (.not.hnd_terminate()) then
        call errquit('int_terminate: hnd_terminate failed', 555,
     &            INT_ERR)
      endif
      if (any_ecp) then
        call int_ecp_terminate()
        ecp_bsh = 0
      endif
c
c   Terminate relativistic integrals. This is an unconditional call
c   because the call to int_rel_init is also unconditional, and the
c   flag init_rel_int must be set to .false.
c
      if (dyall_mod_dir) call int_rel_term
c
c   Terminate Douglas-Kroll integrals. The fitting basis set will
c   be destroyed and the handle put to -1.
c
      if (doug_kroll) then
       if (.not. bas_destroy(dk_fitbas)) call errquit(
     &   'int_terminate: failed to destroy Douglas-Kroll fitting basis'
     &   ,0, INT_ERR)
       dk_fitbas = -1
      endif
c
      end
C>
C> \brief The derivative integral termination routine
C>
c:tex-
c:tex-%API Initialization and Termination Routines
c:tex-\subsection{intd\_terminate}
c:tex-This is the main termination routine for integral
c:tex-derivatives.
c:tex-After this call the INT-API is ready for re-initialization.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine intd_terminate()
c:tex-\end{verbatim}
c:tex-No formal arguments
c:tex-
      implicit none
#include "bas.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "apiP.fh"
#include "candoP.fh"
c::functions
      logical spcart_terminate 
      external spcart_terminate 
      logical hnd_terminate 
      external hnd_terminate 
c
      if (init_intd.eq.0) then
        write(luout,*)' warning: intd_init has not been called '
      endif
      call int_mem_zero()
c.. parameters for int derivative (hf2d)
      intd_memthresh = 0
      numd_tot       = 0
      numd_okay      = 0
      numd_red       = 0
c
      if (.not.spcart_terminate()) then
        call errquit('intd_terminate: spcart_terminate failed',0,
     &         INT_ERR)
      endif
c
      if (.not.hnd_terminate()) then
        call errquit('intd_terminate: hnd_terminate failed', 555,
     &         INT_ERR)
      endif
c
      if (.not.(user_cando_txs.and.(.not.def_cando_txs))) then
        call texas_terminate()
      endif
*:rak:this should not be here      call int_app_unset_no_texas(rtdbIused)
c
      if (any_ecp) then
        call int_ecp_terminate()
        ecp_bsh = 0
      endif
c
      if (dyall_mod_dir) call int_rel_term
c
c   Terminate Douglas-Kroll integrals. The fitting basis set will
c   be destroyed and the handle put to -1.
c
      if (doug_kroll) then
       if (.not. bas_destroy(dk_fitbas)) call errquit(
     &   'int_terminate: failed to destroy Douglas-Kroll fitting basis'
     &   ,0, INT_ERR)
       dk_fitbas = -1
      endif
c
      end
C>
C> \brief The 2nd derivative integral termination routine
C>
c:tex-
c:tex-%API Initialization and Termination Routines
c:tex-\subsection{intdd\_terminate}
c:tex-This is the main termination routine for integral
c:tex-second derivatives.
c:tex-After this call the INT-API is ready for re-initialization.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine intdd_terminate()
c:tex-\end{verbatim}
c:tex-No formal arguments
c:tex-
      implicit none
#include "apiP.fh"
#include "errquit.fh"
#include "candoP.fh"
#include "stdio.fh"
c::functions
      logical spcart_terminate 
      external spcart_terminate 
      logical hnd_terminate 
      external hnd_terminate 
c
      if (init_intdd.eq.0) then
        write(luout,*)' warning: intdd_init has not been called '
      endif
      call int_mem_zero()
      intd_memthresh = 0
c
      if (.not.spcart_terminate()) then
        call errquit('intdd_terminate: spcart_terminate failed',0,
     &             INT_ERR)
      endif
c
      if (.not.hnd_terminate()) then
        call errquit('intd_terminate: hnd_terminate failed', 555,
     &          INT_ERR)
      endif
c
      if (.not.(user_cando_txs.and.(.not.def_cando_txs))) then
        call texas_terminate()
      endif
c
      if (any_ecp) then
        call int_ecp_terminate()
        ecp_bsh = 0
      endif
c
      end
C> @}

*> \brief \b SLAED3 used by sstedc. Finds the roots of the secular equation and updates the eigenvectors. Used when the original matrix is tridiagonal.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SLAED3 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/slaed3.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/slaed3.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/slaed3.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SLAED3( K, N, N1, D, Q, LDQ, RHO, DLAMDA, Q2, INDX,
*                          CTOT, W, S, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, K, LDQ, N, N1
*       REAL               RHO
*       ..
*       .. Array Arguments ..
*       INTEGER            CTOT( * ), INDX( * )
*       REAL               D( * ), DLAMDA( * ), Q( LDQ, * ), Q2( * ),
*      $                   S( * ), W( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SLAED3 finds the roots of the secular equation, as defined by the
*> values in D, W, and RHO, between 1 and K.  It makes the
*> appropriate calls to SLAED4 and then updates the eigenvectors by
*> multiplying the matrix of eigenvectors of the pair of eigensystems
*> being combined by the matrix of eigenvectors of the K-by-K system
*> which is solved here.
*>
*> This code makes very mild assumptions about floating point
*> arithmetic. It will work on machines with a guard digit in
*> add/subtract, or on those binary machines without guard digits
*> which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*> It could conceivably fail on hexadecimal or decimal machines
*> without guard digits, but we know of none.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>          The number of terms in the rational function to be solved by
*>          SLAED4.  K >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of rows and columns in the Q matrix.
*>          N >= K (deflation may result in N>K).
*> \endverbatim
*>
*> \param[in] N1
*> \verbatim
*>          N1 is INTEGER
*>          The location of the last eigenvalue in the leading submatrix.
*>          min(1,N) <= N1 <= N/2.
*> \endverbatim
*>
*> \param[out] D
*> \verbatim
*>          D is REAL array, dimension (N)
*>          D(I) contains the updated eigenvalues for
*>          1 <= I <= K.
*> \endverbatim
*>
*> \param[out] Q
*> \verbatim
*>          Q is REAL array, dimension (LDQ,N)
*>          Initially the first K columns are used as workspace.
*>          On output the columns 1 to K contain
*>          the updated eigenvectors.
*> \endverbatim
*>
*> \param[in] LDQ
*> \verbatim
*>          LDQ is INTEGER
*>          The leading dimension of the array Q.  LDQ >= max(1,N).
*> \endverbatim
*>
*> \param[in] RHO
*> \verbatim
*>          RHO is REAL
*>          The value of the parameter in the rank one update equation.
*>          RHO >= 0 required.
*> \endverbatim
*>
*> \param[in,out] DLAMDA
*> \verbatim
*>          DLAMDA is REAL array, dimension (K)
*>          The first K elements of this array contain the old roots
*>          of the deflated updating problem.  These are the poles
*>          of the secular equation. May be changed on output by
*>          having lowest order bit set to zero on Cray X-MP, Cray Y-MP,
*>          Cray-2, or Cray C-90, as described above.
*> \endverbatim
*>
*> \param[in] Q2
*> \verbatim
*>          Q2 is REAL array, dimension (LDQ2, N)
*>          The first K columns of this matrix contain the non-deflated
*>          eigenvectors for the split problem.
*> \endverbatim
*>
*> \param[in] INDX
*> \verbatim
*>          INDX is INTEGER array, dimension (N)
*>          The permutation used to arrange the columns of the deflated
*>          Q matrix into three groups (see SLAED2).
*>          The rows of the eigenvectors found by SLAED4 must be likewise
*>          permuted before the matrix multiply can take place.
*> \endverbatim
*>
*> \param[in] CTOT
*> \verbatim
*>          CTOT is INTEGER array, dimension (4)
*>          A count of the total number of the various types of columns
*>          in Q, as described in INDX.  The fourth column type is any
*>          column which has been deflated.
*> \endverbatim
*>
*> \param[in,out] W
*> \verbatim
*>          W is REAL array, dimension (K)
*>          The first K elements of this array contain the components
*>          of the deflation-adjusted updating vector. Destroyed on
*>          output.
*> \endverbatim
*>
*> \param[out] S
*> \verbatim
*>          S is REAL array, dimension (N1 + 1)*K
*>          Will contain the eigenvectors of the repaired matrix which
*>          will be multiplied by the previously accumulated eigenvectors
*>          to update the system.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit.
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*>          > 0:  if INFO = 1, an eigenvalue did not converge
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERcomputational
*
*> \par Contributors:
*  ==================
*>
*> Jeff Rutter, Computer Science Division, University of California
*> at Berkeley, USA \n
*>  Modified by Francoise Tisseur, University of Tennessee
*>
*  =====================================================================
      SUBROUTINE SLAED3( K, N, N1, D, Q, LDQ, RHO, DLAMDA, Q2, INDX,
     $                   CTOT, W, S, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDQ, N, N1
      REAL               RHO
*     ..
*     .. Array Arguments ..
      INTEGER            CTOT( * ), INDX( * )
      REAL               D( * ), DLAMDA( * ), Q( LDQ, * ), Q2( * ),
     $                   S( * ), W( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ONE, ZERO
      PARAMETER          ( ONE = 1.0E0, ZERO = 0.0E0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, II, IQ2, J, N12, N2, N23
      REAL               TEMP
*     ..
*     .. External Functions ..
      REAL               SLAMC3, SNRM2
      EXTERNAL           SLAMC3, SNRM2
*     ..
*     .. External Subroutines ..
      EXTERNAL           SCOPY, SGEMM, SLACPY, SLAED4, SLASET, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( K.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.K ) THEN
         INFO = -2
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SLAED3', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( K.EQ.0 )
     $   RETURN
*
*     Modify values DLAMDA(i) to make sure all DLAMDA(i)-DLAMDA(j) can
*     be computed with high relative accuracy (barring over/underflow).
*     This is a problem on machines without a guard digit in
*     add/subtract (Cray XMP, Cray YMP, Cray C 90 and Cray 2).
*     The following code replaces DLAMDA(I) by 2*DLAMDA(I)-DLAMDA(I),
*     which on any of these machines zeros out the bottommost
*     bit of DLAMDA(I) if it is 1; this makes the subsequent
*     subtractions DLAMDA(I)-DLAMDA(J) unproblematic when cancellation
*     occurs. On binary machines with a guard digit (almost all
*     machines) it does not change DLAMDA(I) at all. On hexadecimal
*     and decimal machines with a guard digit, it slightly
*     changes the bottommost bits of DLAMDA(I). It does not account
*     for hexadecimal or decimal machines without guard digits
*     (we know of none). We use a subroutine call to compute
*     2*DLAMBDA(I) to prevent optimizing compilers from eliminating
*     this code.
*
      DO 10 I = 1, K
         DLAMDA( I ) = SLAMC3( DLAMDA( I ), DLAMDA( I ) ) - DLAMDA( I )
   10 CONTINUE
*
      DO 20 J = 1, K
         CALL SLAED4( K, J, DLAMDA, W, Q( 1, J ), RHO, D( J ), INFO )
*
*        If the zero finder fails, the computation is terminated.
*
         IF( INFO.NE.0 )
     $      GO TO 120
   20 CONTINUE
*
      IF( K.EQ.1 )
     $   GO TO 110
      IF( K.EQ.2 ) THEN
         DO 30 J = 1, K
            W( 1 ) = Q( 1, J )
            W( 2 ) = Q( 2, J )
            II = INDX( 1 )
            Q( 1, J ) = W( II )
            II = INDX( 2 )
            Q( 2, J ) = W( II )
   30    CONTINUE
         GO TO 110
      END IF
*
*     Compute updated W.
*
      CALL SCOPY( K, W, 1, S, 1 )
*
*     Initialize W(I) = Q(I,I)
*
      CALL SCOPY( K, Q, LDQ+1, W, 1 )
      DO 60 J = 1, K
         DO 40 I = 1, J - 1
            W( I ) = W( I )*( Q( I, J ) / ( DLAMDA( I )-DLAMDA( J ) ) )
   40    CONTINUE
         DO 50 I = J + 1, K
            W( I ) = W( I )*( Q( I, J ) / ( DLAMDA( I )-DLAMDA( J ) ) )
   50    CONTINUE
   60 CONTINUE
      DO 70 I = 1, K
         W( I ) = SIGN( SQRT( -W( I ) ), S( I ) )
   70 CONTINUE
*
*     Compute eigenvectors of the modified rank-1 modification.
*
      DO 100 J = 1, K
         DO 80 I = 1, K
            S( I ) = W( I ) / Q( I, J )
   80    CONTINUE
         TEMP = SNRM2( K, S, 1 )
         DO 90 I = 1, K
            II = INDX( I )
            Q( I, J ) = S( II ) / TEMP
   90    CONTINUE
  100 CONTINUE
*
*     Compute the updated eigenvectors.
*
  110 CONTINUE
*
      N2 = N - N1
      N12 = CTOT( 1 ) + CTOT( 2 )
      N23 = CTOT( 2 ) + CTOT( 3 )
*
      CALL SLACPY( 'A', N23, K, Q( CTOT( 1 )+1, 1 ), LDQ, S, N23 )
      IQ2 = N1*N12 + 1
      IF( N23.NE.0 ) THEN
         CALL SGEMM( 'N', 'N', N2, K, N23, ONE, Q2( IQ2 ), N2, S, N23,
     $               ZERO, Q( N1+1, 1 ), LDQ )
      ELSE
         CALL SLASET( 'A', N2, K, ZERO, ZERO, Q( N1+1, 1 ), LDQ )
      END IF
*
      CALL SLACPY( 'A', N12, K, Q, LDQ, S, N12 )
      IF( N12.NE.0 ) THEN
         CALL SGEMM( 'N', 'N', N1, K, N12, ONE, Q2, N1, S, N12, ZERO, Q,
     $               LDQ )
      ELSE
         CALL SLASET( 'A', N1, K, ZERO, ZERO, Q( 1, 1 ), LDQ )
      END IF
*
*
  120 CONTINUE
      RETURN
*
*     End of SLAED3
*
      END
c $Id: slaed3.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine movecs_ecce_print_on()
      implicit none
#include "ceccemoprint.fh"
      flag = .true.
      end
      subroutine movecs_ecce_print_off()
      implicit none
#include "ceccemoprint.fh"
      flag = .false.
      end
      subroutine movecs_ecce(nbf, nmo, lo, hi, eval, occ, sym,
     $     g_movecs, scftype, key)
*
* $Id: movecs_ecce.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "ceccemoprint.fh"
      integer nbf               ! [input] no. of basis functions
      integer nmo               ! [input] no. of MOs
      integer lo, hi            ! [input] range of MOs to print
      double precision eval(*)  ! [input] MO energies
      double precision occ(*)   ! [input] MO occupation numbers
      integer sym(*)            ! [input] MO symmetries
      integer g_movecs          ! [input] GA with vectors
      character*(*) scftype     ! [input] Type of SCF
      character*(*) key         ! [input] Part of keyword for ECCE
c
c     Output all of the evals, occupation numbers and symmetries and a
c     subset of the molecular orbitals to the ECCE print file.
c
c     The ECCE keywords are constructed as 
c
c     <scftype> <key> <molecular orbitals>
c     <scftype> <key> <molecular orbital energies>
c     ...
c
c     scftype is presently either RHF, ROHF, UHF, DFT, or MCSCF.
c
c     Key should be blank for restricted spin methods or alpha
c     or beta for unrestricted methods as appropriate.
c
c     This routine is temporarily being used to print ALL of the
c     MOs to the ECCE file.  This is not suitable for large 
c     calculations which should just print frontier orbitals
c
      integer l_v, k_v, stat1, stat2, range(2), slen, klen
      character*80 ceval, cocc, cvec, cran, csym
c
c     If ECCE is not printing then go home.  Note that only process
c     zero will really know but only it is printing.
c
      stat1 = 0
      call ecce_print_control(stat1, stat2) ! stat2 set to print status
      stat1 = stat2
      call ecce_print_control(stat1, stat2) ! restore previous setting
      if (stat1 .ne. 1) return
c
      if (.not. flag) return    ! Control for geometry optimization
c
c     Get the MOs
c
      if (.not. ma_push_get(mt_dbl, (hi-lo+1)*nbf, 'moecce', l_v, k_v))
     $     call errquit('movecs_ecce: insufficient memory',0, MA_ERR)
      call ga_get(g_movecs, 1, nbf, lo, hi, dbl_mb(k_v), nbf)
c
c     Construct the names
c
      ceval = ' '
      cocc  = ' '
      cvec  = ' '
      cran  = ' '
      csym  = ' '
      slen = inp_strlen(scftype)
      klen = inp_strlen(key)
      if (key .eq. ' ') then
         write(ceval,'(a,1x,a)')
     $      'molecular orbital energies',
     &      scftype(1:slen)
         write(cocc,'(a,1x,a)')
     $       'molecular orbital occupations',
     &       scftype(1:slen) 
         write(cvec,'(a,1x,a)')
     $        'molecular orbital vectors',
     &       scftype(1:slen)
         write(cran,'(a,1x,a)')
     $       'molecular orbital range',
     &       scftype(1:slen)
         write(csym,'(a,1x,a)')
     $       'molecular orbital symmetries',
     &       scftype(1:slen)
      else
         write(ceval,'(a,1x,a,1x,a)')
     &      'molecular orbital energies',
     &      scftype(1:slen), 
     $      key(1:klen)
         write(cocc,'(a,1x,a,1x,a)')
     &       'molecular orbital occupations',
     &       scftype(1:slen), 
     $       key(1:klen)
         write(cvec,'(a,1x,a,1x,a)')
     &       'molecular orbital vectors',
     &       scftype(1:slen),
     $       key(1:klen)
         write(cran,'(a,1x,a,1x,a)')
     &       'molecular orbital range',
     &       scftype(1:slen),
     $       key(1:klen)
         write(csym,'(a,1x,a,1x,a)')
     &       'molecular orbital symmetries',
     &       scftype(1:slen),
     $       key(1:klen)
      endif
      range(1) = lo
      range(2) = hi
c
      call ecce_print1(ceval, mt_dbl, eval, nmo)
      call ecce_print1(cocc,  mt_dbl, occ,  nmo)
      call ecce_print1(csym,  mt_int, sym,  nmo)
      call ecce_print1(cran,  mt_int, range, 2)
      call ecce_print2_dbl_tol(cvec,  dbl_mb(k_v), nbf, nbf, (hi-lo)+1,
     $     1d-3)
c
      if (.not. ma_pop_stack(l_v)) call errquit
     $     ('movecs_ecce: ma stack is corrupt', 0, MA_ERR)
c
      end

*
* $Id: cpsp.F 24629 2013-10-05 00:00:54Z bylaska $
*

#define TCGMSG

*     ****************************************************
*     *                                                  *
*     *                cpsp_init                         *
*     *                                                  *
*     ****************************************************
      subroutine cpsp_init()      
      implicit none

#include "mafdecls.fh"
#include "cpsp_common.fh"
#include "errquit.fh"

*     ***** local variables ****
      logical value
      integer axsize
      integer npack0,npack1,nbrillq,nion

*     **** external functions *****
      logical  two_component_pseudopotential,control_pspspin
      external two_component_pseudopotential,control_pspspin
      integer  ion_nkatm, brillioun_nbrillq,ion_nion
      external ion_nkatm, brillioun_nbrillq,ion_nion
 
      npsp = ion_nkatm()
      nbrillq = brillioun_nbrillq()

      call Cram_npack(0,npack0)
      call Cram_max_npack(npack1)

*     **** allocate projector datastructure ****
      call cpsp_projector_init(5*npsp)

*     ***** allocate local potentitals *****
      value = MA_alloc_get(mt_dbl,(npsp*npack0),'vl',vl(2),vl(1))


*     ***** allocate projector tag lists *****
      value = value.and.
     >        MA_alloc_get(mt_int,npsp,'vnl',vnl(2),vnl(1))
      value = value.and.
     >        MA_alloc_get(mt_int,npsp,'vnlso',vnlso(2),vnlso(1))

*     **** nonlocal coeffiencients *****
      axsize=npsp*gij_stride
      value = value.and.
     >      MA_alloc_get(mt_dbl,axsize,'Gijl',Gijl(2),Gijl(1))
      axsize=npsp*kij_stride
      value = value.and.
     >      MA_alloc_get(mt_dbl,axsize,'Kijl',Kijl(2),Kijl(1))

      value = value.and.
     >        MA_alloc_get(mt_int,(npsp),'nprj',nprj(2),nprj(1))

      axsize=npsp*jmmax_max
      value = value.and.
     >        MA_alloc_get(mt_int,axsize,
     >                     'n_projector',n_projector(2),n_projector(1))
      value = value.and.
     >        MA_alloc_get(mt_int,axsize,
     >                     'l_projector',l_projector(2),l_projector(1))
      value = value.and.
     >        MA_alloc_get(mt_int,axsize,
     >                     'm_projector',m_projector(2),m_projector(1))


      value = value.and.
     >        MA_alloc_get(mt_dbl,(npsp),'zv',zv(2),zv(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(npsp),'amass',amass(2),amass(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(npsp*(lmax_max+1)),'rc',rc(2),rc(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(npsp),'lmmax',lmmax(2),lmmax(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(npsp),'lmax',lmax(2),lmax(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(npsp),'locp',locp(2),locp(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(npsp),'nmax',nmax(2),nmax(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(npsp),
     >                     'psp_type',psp_type(2),psp_type(1))

*     **** setup pspspin structure - used for generating antiferromagnetic structures ****
      pspspin = control_pspspin()
      if (pspspin) then
         nion  = ion_nion()
         value = value.and.
     >   MA_alloc_get(mt_log,nion,'pspspin_upions',
     >                pspspin_upions(2),pspspin_upions(1))
         value = value.and.
     >   MA_alloc_get(mt_log,nion,'pspspin_downions',
     >                pspspin_downions(2),pspspin_downions(1))
         if (.not. value)
     >   call errquit('psp_init:out of heap memory',0, MA_ERR)

         call control_set_pspspin(pspspin_upscale,pspspin_downscale,
     >                            pspspin_upl,pspspin_downl,
     >                            nion,
     >                            log_mb(pspspin_upions(1)),
     >                            log_mb(pspspin_downions(1)))
      end if

      if (.not. value) 
     >   call errquit('cpsp_init:out of heap memory',0, MA_ERR)

      call dcopy(npsp*npack0,0.0d0,0,dbl_mb(vl(1)),1)
      call dcopy(npsp,       0.0d0,0,dbl_mb(zv(1)),1)
      call dcopy(npsp,       0.0d0,0,dbl_mb(amass(1)),1)
      call dcopy(npsp*(lmax_max+1),    0.0d0,0,dbl_mb(rc(1)),1)

*     **** allocate semicore data ****
      call c_semicore_init()
      return
      end

*     ****************************************************
*     *                                                  *
*     *                cpsp_proj_init                    *
*     *                                                  *
*     ****************************************************
      subroutine cpsp_proj_init()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "cpsp_common.fh"

*     ***** local variables ****
      logical value
      integer axsize,npack1

*     ***** external functions *****
      integer  cpsp_nprj_max
      external cpsp_nprj_max

      nprj_max = cpsp_nprj_max()
      call Cram_max_npack(npack1)

      axsize=npack1*nprj_max*2
      value = MA_alloc_get(mt_dcpl,axsize,'prjtmp',prjtmp(2),prjtmp(1))
      if (.not. value) 
     >   call errquit('cpsp_proj_init:out of heap memory',0,MA_ERR)

      return
      end

*     ******************************************
*     *                                        *
*     *             cpsp_end                   *
*     *                                        *
*     ******************************************
      subroutine cpsp_end()      
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "cpsp_common.fh"

      logical value

*     **** external functions ****


*     **** deallocate projector data ****
      call cpsp_projector_end()

*     **** deallocate semicore data ****
      call c_semicore_end()

      value = MA_free_heap(prjtmp(2))
      value = value.and.MA_free_heap(vl(2))
      value = value.and.MA_free_heap(vnlso(2))
      value = value.and.MA_free_heap(vnl(2))
      value = value.and.MA_free_heap(Kijl(2))
      value = value.and.MA_free_heap(Gijl(2))
      value = value.and.MA_free_heap(nprj(2))
      value = value.and.MA_free_heap(n_projector(2))
      value = value.and.MA_free_heap(l_projector(2))
      value = value.and.MA_free_heap(m_projector(2))
      value = value.and.MA_free_heap(zv(2))
      value = value.and.MA_free_heap(amass(2))
      value = value.and.MA_free_heap(rc(2))
      value = value.and.MA_free_heap(lmmax(2))
      value = value.and.MA_free_heap(lmax(2))
      value = value.and.MA_free_heap(locp(2))
      value = value.and.MA_free_heap(nmax(2))
      value = value.and.MA_free_heap(psp_type(2))
      if (pspspin) then
         value = value.and.MA_free_heap(pspspin_upions(2))
         value = value.and.MA_free_heap(pspspin_downions(2))
      end if
      if (.not. value)
     >  call errquit('cpsp_end:error freeing heap memory',0,MA_ERR)

      return
      end


*     ***********************************
*     *					*
*     *	 	   cpsp_zv		*
*     *					*
*     ***********************************
      real*8 function cpsp_zv(ia)
      implicit none
      integer ia

#include "mafdecls.fh"
#include "cpsp_common.fh"


      cpsp_zv = dbl_mb(zv(1)+ia-1)
      return
      end


*     ***********************************
*     *					*
*     *	 	   cpsp_amass		*
*     *					*
*     ***********************************
      real*8 function cpsp_amass(ia)
      implicit none
      integer ia

#include "mafdecls.fh"
#include "cpsp_common.fh"

      cpsp_amass = dbl_mb(amass(1)+ia-1)
      return
      end


*     ***********************************
*     *					*
*     *	 	   cpsp_rc		*
*     *					*
*     ***********************************
      real*8 function cpsp_rc(i,ia)
      implicit none
      integer i,ia

#include "mafdecls.fh"
#include "cpsp_common.fh"

      cpsp_rc = dbl_mb(rc(1) + i + (lmax_max+1)*(ia-1))
      return
      end

*     ***********************************
*     *					*
*     *	 	   cpsp_atom		*
*     *					*
*     ***********************************
      character*2 function cpsp_atom(ia)
      implicit none
      integer  ia

#include "cpsp_common.fh"

      cpsp_atom = atom(ia)
      return
      end


*     ***********************************
*     *                                 *
*     *            psp_comment          *
*     *                                 *
*     ***********************************
      character*(*) function cpsp_comment(ia)
      implicit none
      integer  ia

#include "cpsp_common.fh"


      cpsp_comment = comment(ia)
      return
      end




*     ***********************************
*     *					*
*     *	 	   cpsp_lmmax		*
*     *					*
*     ***********************************
      integer function cpsp_lmmax(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"
#include "cpsp_common.fh"


      cpsp_lmmax = int_mb(lmmax(1)+ia-1)
      return
      end

*     ***********************************
*     *                                 *
*     *            cpsp_nprj             *
*     *                                 *
*     ***********************************
      integer function cpsp_nprj(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"
#include "cpsp_common.fh"

      cpsp_nprj  = int_mb(nprj(1)+ia-1)
      return
      end

*     ***********************************
*     *                                 *
*     *            cpsp_nprj_max        *
*     *                                 *
*     ***********************************
      integer function cpsp_nprj_max()
      implicit none

#include "mafdecls.fh"
#include "cpsp_common.fh"

      integer ia,nprjmax,nprjtmp

      nprjmax = 0
      do ia=1,npsp
         nprjtmp = (int_mb(nprj(1)+ia-1))
         if (nprjtmp.gt.nprjmax) nprjmax = nprjtmp
      end do

      cpsp_nprj_max  = nprjmax
      return
      end

*     ***********************************
*     *                                 *
*     *            cpsp_psp_type        *
*     *                                 *
*     ***********************************
      integer function cpsp_psp_type(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"
#include "cpsp_common.fh"

      cpsp_psp_type  = int_mb(psp_type(1)+ia-1)
      return
      end


*     ***********************************
*     *					*
*     *	 	   cpsp_lmax		*
*     *					*
*     ***********************************
      integer function cpsp_lmax(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"
#include "cpsp_common.fh"


      cpsp_lmax = int_mb(lmax(1)+ia-1)
      return
      end

*     ***********************************
*     *					*
*     *	 	   cpsp_locp		*
*     *					*
*     ***********************************
      integer function cpsp_locp(ia)
      implicit none
      integer  ia

#include "mafdecls.fh"
#include "cpsp_common.fh"


      cpsp_locp = int_mb(locp(1)+ia-1)
      return
      end

*     ***********************************
*     *					*
*     *	 	   cpsp_npsp		*
*     *					*
*     ***********************************
      integer function cpsp_npsp()
      implicit none

#include "cpsp_common.fh"


      cpsp_npsp = npsp
      return
      end


*     ***********************************
*     *					*
*     *	 	   cpsp_v_local         *
*     *					*
*     ***********************************
      subroutine cpsp_v_local(vl_out,move,dng,fion)
      implicit none
      complex*16 vl_out(*)
      logical    move
      complex*16 dng(*)
      real*8     fion(3,*)

#include "mafdecls.fh"
#include "cpsp_common.fh"
#include "errquit.fh"

*     *** local variables ***
      integer nfft3d,npack0
      integer i,ii,ia
      integer exi(2),vtmp(2),xtmp(2),G(3)
      integer Gx(2),Gy(2),Gz(2)
      logical value

*     **** external functions ****
      integer  c_G_indx,ion_nion,ion_katm
      external c_G_indx,ion_nion,ion_katm

      call nwpw_timing_start(5)
      call C3dB_nfft3d(1,nfft3d)
      call Cram_npack(0,npack0)

      value = MA_push_get(mt_dcpl,npack0,'exi', exi(2), exi(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'vtmp',vtmp(2),vtmp(1))
      if (.not. value) call errquit('cpsp_v_local: pushing stack',0,
     &       MA_ERR)
      
      if (move) then
        value = MA_push_get(mt_dbl, nfft3d,'xtmp',xtmp(2),xtmp(1))
        value = value.and.
     >          MA_push_get(mt_dbl, nfft3d,'Gx',Gx(2),Gx(1))
        value = value.and.
     >          MA_push_get(mt_dbl, nfft3d,'Gy',Gy(2),Gy(1))
        value = value.and.
     >          MA_push_get(mt_dbl, nfft3d,'Gz',Gz(2),Gz(1))
        if (.not. value) call errquit('cpsp_v_local: pushing stack',1,
     &       MA_ERR)
        G(1)  = c_G_indx(1)
        G(2)  = c_G_indx(2)
        G(3)  = c_G_indx(3)

*       **** define Gx,Gy and Gz in packed space ****
        call C3dB_t_Copy(1,dbl_mb(G(1)),dbl_mb(Gx(1)))
        call C3dB_t_Copy(1,dbl_mb(G(2)),dbl_mb(Gy(1)))
        call C3dB_t_Copy(1,dbl_mb(G(3)),dbl_mb(Gz(1)))
        call Cram_r_pack(0,dbl_mb(Gx(1)))
        call Cram_r_pack(0,dbl_mb(Gy(1)))
        call Cram_r_pack(0,dbl_mb(Gz(1)))
      end if

      call dcopy((2*npack0),0.0d0,0,vl_out,1)
      do ii=1,ion_nion()
        ia=ion_katm(ii)

*       **** structure factor and local pseudopotential ****
        call cstrfac_pack(0,ii,dcpl_mb(exi(1)))
       
*       **** add to local psp ****
        call Cram_rc_Mul(0,dbl_mb(vl(1)+npack0*(ia-1)),
     >                   dcpl_mb(exi(1)),
     >                   dcpl_mb(vtmp(1)))
c        call Cram_cc_Sum(0,vl_out,dcpl_mb(vtmp(1)),vl_out)
        call Cram_cc_Sum2(0,dcpl_mb(vtmp(1)),vl_out)

        if (move) then
       
          do i=1,npack0
             dbl_mb(xtmp(1)+i-1) 
     >          = dimag(dng(i))* dble(dcpl_mb(vtmp(1)+i-1))
     >           - dble(dng(i))*dimag(dcpl_mb(vtmp(1)+i-1))
          end do
         call Cram_rr_dot(0,dbl_mb(Gx(1)),dbl_mb(xtmp(1)),fion(1,ii))
         call Cram_rr_dot(0,dbl_mb(Gy(1)),dbl_mb(xtmp(1)),fion(2,ii))
         call Cram_rr_dot(0,dbl_mb(Gz(1)),dbl_mb(xtmp(1)),fion(3,ii))
   
       end if
        

      end do

      if (move) then
        value = MA_pop_stack(Gz(2))
        value = value.and.MA_pop_stack(Gy(2))
        value = value.and.MA_pop_stack(Gx(2))
        value = value.and.MA_pop_stack(xtmp(2))
        if (.not. value) call errquit('cpsp_v_local: popping stack',0,
     &       MA_ERR)
      end if
      value = MA_pop_stack(vtmp(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not. value) call errquit('cpsp_v_local: popping stack',1,
     &       MA_ERR)

      call nwpw_timing_end(5)
      return 
      end


*     ***********************************
*     *					*
*     *	 	   cpsp_f_vlocal  	*
*     *					*
*     ***********************************

      subroutine cpsp_f_vlocal(dng,fion)
      implicit none
      complex*16 dng(*)
      real*8     fion(3,*)

#include "mafdecls.fh"
#include "cpsp_common.fh"
#include "errquit.fh"


*     *** local variables ***
      integer nfft3d,npack0
      integer i,ii,ia
      integer exi(2),vtmp(2),xtmp(2),G(3)
      integer Gx(2),Gy(2),Gz(2)
      logical value

*     **** external functions ****
      integer  c_G_indx,ion_nion,ion_katm
      external c_G_indx,ion_nion,ion_katm

      call nwpw_timing_start(5)
      
      call C3dB_nfft3d(1,nfft3d)
      call Cram_npack(0,npack0)
      value = MA_push_get(mt_dcpl,npack0,'exi', exi(2), exi(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'vtmp',vtmp(2),vtmp(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'xtmp',xtmp(2),xtmp(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gx',Gx(2),Gx(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gy',Gy(2),Gy(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gz',Gz(2),Gz(1))
      if (.not. value) call errquit('cpsp_f_vlocal:pushing stack',0,
     &       MA_ERR)
      G(1)  = c_G_indx(1)
      G(2)  = c_G_indx(2)
      G(3)  = c_G_indx(3)

*     **** define Gx,Gy and Gz in packed space ****
      call C3dB_t_Copy(1,dbl_mb(G(1)),dbl_mb(Gx(1)))
      call C3dB_t_Copy(1,dbl_mb(G(2)),dbl_mb(Gy(1)))
      call C3dB_t_Copy(1,dbl_mb(G(3)),dbl_mb(Gz(1)))
      call Cram_r_pack(0,dbl_mb(Gx(1)))
      call Cram_r_pack(0,dbl_mb(Gy(1)))
      call Cram_r_pack(0,dbl_mb(Gz(1)))

      do ii=1,ion_nion()
        ia=ion_katm(ii)

*       **** structure factor and local pseudopotential ****
c        call cstrfac(ii,dcpl_mb(exi(1)))
c        call Cram_c_pack(0,dcpl_mb(exi(1)))
        call cstrfac_pack(0,ii,dcpl_mb(exi(1)))
        
*       **** add to local psp ****
        call Cram_rc_Mul(0,dbl_mb(vl(1)+npack0*(ia-1)),
     >                   dcpl_mb(exi(1)),
     >                   dcpl_mb(vtmp(1)))

        do i=1,npack0
           dbl_mb(xtmp(1)+i-1) 
     >        = dimag(dng(i))* dble(dcpl_mb(vtmp(1)+i-1))
     >         - dble(dng(i))*dimag(dcpl_mb(vtmp(1)+i-1))
        end do

        call Cram_rr_dot(0,dbl_mb(Gx(1)),dbl_mb(xtmp(1)),fion(1,ii))
        call Cram_rr_dot(0,dbl_mb(Gy(1)),dbl_mb(xtmp(1)),fion(2,ii))
        call Cram_rr_dot(0,dbl_mb(Gz(1)),dbl_mb(xtmp(1)),fion(3,ii))
 
      end do
      value = MA_pop_stack(Gz(2))
      value = value.and.MA_pop_stack(Gy(2))
      value = value.and.MA_pop_stack(Gx(2))
      value = value.and.MA_pop_stack(xtmp(2))
      value = value.and.MA_pop_stack(vtmp(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not. value) call errquit('cpsp_f_vlocal:popping stack',1,
     &       MA_ERR)

      call nwpw_timing_end(5)
      return 
      end



*     ***********************************
*     *					*
*     *	 	 cpsp_v_nonlocal  	*
*     *					*
*     ***********************************

      subroutine cpsp_v_nonlocal(ispin,ne,psi1_tag,psi2_tag,move,fion)
      implicit none
      integer    ispin,ne(2)
      integer    psi1_tag
      integer    psi2_tag
      logical move
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "cpsp_common.fh"
#include "errquit.fh"

*     *** local variables ***
      complex*16 one,mone,ione
      integer nfft3d,G(3),npack1,npack
      integer ii,ia,l,n,nn,nb,nbq,neall,nbrillq,nion
      integer shift,l_prj,nproj
      integer psi1_shift,psi2_shift,psi_shift,nshift
      integer occ_tag,occ_shift,occ1_shift
      real*8  omega,weight,scal,wfrac
      complex*16 cxr
      integer exi(2),xtmp(2),zsw1(2),zsw2(2),sum(2),ftmp(2)
      integer Gx(2),Gy(2),Gz(2),shfts,shftd
      logical value,sd_function

*     **** external functions ****
      logical  is_sORd,cpsi_spin_orbit
      integer  ion_nion,ion_katm,c_G_indx,Pneb_nbrillq
      integer  cpsp_projector_get_ptr,cpsi_data_get_chnk
      integer  cpsi_data_get_next
      real*8   lattice_omega,brillioun_weight
      external is_sORd,cpsi_spin_orbit
      external ion_nion,ion_katm,c_G_indx,Pneb_nbrillq
      external cpsp_projector_get_ptr,cpsi_data_get_chnk
      external cpsi_data_get_next
      external lattice_omega,brillioun_weight

      one  = dcmplx( 1.0d0,0.0d0)
      mone = dcmplx(-1.0d0,0.0d0)
      ione = dcmplx( 0.0d0,1.0d0)
      call nwpw_timing_start(6)
      
*     **** allocate local memory ****
      nn = ne(1)+ne(2)
      neall = ne(1)+ne(2)
      nion  = ion_nion()
      nbrillq = Pneb_nbrillq()
      call C3dB_nfft3d(1,nfft3d)
      call Cram_max_npack(npack1)
      nshift = 2*npack1

      value = MA_push_get(mt_dcpl,npack1,'exi',exi(2),exi(1))
      value = value.and.MA_push_get(mt_dcpl,nn*nprj_max,
     >                              'zsw1',zsw1(2),zsw1(1))
      value = value.and.MA_push_get(mt_dcpl,nn*nprj_max,
     >                              'zsw2',zsw2(2),zsw2(1))
      if (.not.value) call errquit('cpsp_v_nonlocal:pushing stack',0,
     >       MA_ERR)

ccccccccccccccc if move we do this ccccccccccccccccccccccccc
      if (move) then
        occ_tag = cpsi_data_get_next(psi1_tag)
        value = MA_push_get(mt_dbl, nfft3d,'xtmp',xtmp(2),xtmp(1))
        value = value.and.
     >          MA_push_get(mt_dbl, nfft3d,'Gx',Gx(2),Gx(1))
        value = value.and.
     >          MA_push_get(mt_dbl, nfft3d,'Gy',Gy(2),Gy(1))
        value = value.and.
     >          MA_push_get(mt_dbl, nfft3d,'Gz',Gz(2),Gz(1))
        value = value.and.
     >        MA_push_get(mt_dbl,3*nn,'sum',sum(2),sum(1))
        value = value.and.
     >        MA_push_get(mt_dbl,3*nion,'ftmp',ftmp(2),ftmp(1))
        if (.not.value) call errquit('cpsp_v_nonlocal:pushing stack',1,
     &       MA_ERR)
        G(1)  = c_G_indx(1)
        G(2)  = c_G_indx(2)
        G(3)  = c_G_indx(3)
        call dcopy(3*nion,0.0d0,0,dbl_mb(ftmp(1)),1)
      end if
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      omega = lattice_omega()
      scal  = 1.0d0/omega

      do nbq=1,nbrillq
        psi1_shift = cpsi_data_get_chnk(psi1_tag,nbq)
        psi2_shift = cpsi_data_get_chnk(psi2_tag,nbq)
        call Cram_npack(nbq,npack)

      do 500 ii=1,nion
        ia=ion_katm(ii)

        nproj = int_mb(nprj(1)+ia-1)
        if (nproj.gt.0) then 

          if (int_mb(psp_type(1)+ia-1).eq.7) then

            call cpsp_v_nonlocal_rel(nbq,ii,ia,nproj,npack1,nbrillq,
     >      nn,ne,
     >      dcpl_mb(exi(1)),dcpl_mb(prjtmp(1)),
     >      dcpl_mb(zsw1(1)),
     >      dbl_mb(psi1_shift),dbl_mb(psi2_shift),
     >      dbl_mb(Kijl(1)+(ia-1)*kij_stride),scal)
            if (move) then

*              **** define Gx,Gy and Gz in packed space ****
               call C3dB_t_Copy(1,dbl_mb(G(1)),dbl_mb(Gx(1)))
               call C3dB_t_Copy(1,dbl_mb(G(2)),dbl_mb(Gy(1)))
               call C3dB_t_Copy(1,dbl_mb(G(3)),dbl_mb(Gz(1)))
               call Cram_r_pack(nbq,dbl_mb(Gx(1)))
               call Cram_r_pack(nbq,dbl_mb(Gy(1)))
               call Cram_r_pack(nbq,dbl_mb(Gz(1)))

              shftd=nproj*npack1
              shfts=ne(1)*npack1*2
              weight = brillioun_weight(nbq)
              if (occ_tag.gt.0) 
     >           occ1_shift = cpsi_data_get_chnk(occ_tag,nbq)
              do l=1,nproj          
                 psi_shift = psi1_shift
                 do n=1,ne(1)

*                   **** routine should be vectorized!!!****
                    call Cram_zccr_Multiply2(nbq,
     >                     dcpl_mb(zsw1(1)+(l-1)*ne(1)+n-1),
     >                     dbl_mb(psi_shift),
     >                     dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                     dbl_mb(xtmp(1)))
                    call Cram_zccr_Multiply2Add(nbq,
     >                     dcpl_mb(zsw1(1)+(l-1)*ne(1)+n-1),
     >                     dbl_mb(psi_shift+shfts),
     >                     dcpl_mb(prjtmp(1)+(l-1)*npack1+shftd),
     >                     dbl_mb(xtmp(1)))
                    psi_shift = psi_shift + nshift

                    call Cram_rr_idot(nbq,dbl_mb(Gx(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+3*(n-1)))
                    call Cram_rr_idot(nbq,dbl_mb(Gy(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+1+3*(n-1)))
                    call Cram_rr_idot(nbq,dbl_mb(Gz(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+2+3*(n-1)))
                 end do !**n**

                 call C3dB_Vector_Sumall((3*ne(1)),dbl_mb(sum(1)))

                 wfrac = 1.0d0
                 if (occ_tag.gt.0) occ_shift = occ1_shift
                 do n=1,ne(1)
                    if (occ_tag.gt.0) then
                       wfrac = dbl_mb(occ_shift)
                       occ_shift = occ_shift+1
                    end if
                    dbl_mb(ftmp(1)+3*(ii-1)) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1))
     >                         + 2.0d0*weight*wfrac
     >                                *dbl_mb(sum(1)+3*(n-1))
                    dbl_mb(ftmp(1)+3*(ii-1)+1) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1)+1)
     >                         + 2.0d0*weight*wfrac
     >                                *dbl_mb(sum(1)+1+3*(n-1))
                    dbl_mb(ftmp(1)+3*(ii-1)+2) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1)+2)
     >                         + 2.0d0*weight*wfrac
     >                                *dbl_mb(sum(1)+2+3*(n-1))
                 end do !** ne(1) **

              end do !** l **
            end if !** move **
            goto 500

          end if

*       **** structure factor pseudopotential ****
            call cstrfac_pack(nbq,ii,dcpl_mb(exi(1)))
            call cstrfac_k(ii,nbq,cxr)
c             call Cram_c_ZMul(nbq,cxr,dcpl_mb(exi(1)),dcpl_mb(exi(1)))
            call zscal(npack,cxr,dcpl_mb(exi(1)),1)


*          **** generate zsw1's and projectors ****
            do l=1,nproj

              shift = cpsp_projector_get_ptr(
     >                     int_mb(vnl(1)+ia-1),nbq,l)
              l_prj = int_mb(l_projector(1)+(l-1)
     >                      +(ia-1)*jmmax_max)

              sd_function=.true.
              if (mod(l_prj,2).ne.0) then
                sd_function=.false.
              end if

*             **** phase factor does not matter therefore ****
*             **** (-i)^l is the same as (i)^l in the     ****
*             **** Rayleigh scattering formula            ****

c             *** current function is s or d ****
              if (sd_function) then
                 call Cram_rc_Mul(nbq,dbl_mb(shift),
     >                               dcpl_mb(exi(1)),
     >                               dcpl_mb(prjtmp(1)+(l-1)*npack1))
*             *** current function is p or f ****
              else
                 call Cram_irc_Mul(nbq,dbl_mb(shift),
     >                                dcpl_mb(exi(1)),
     >                                dcpl_mb(prjtmp(1)+(l-1)*npack1))
              end if

*             **** compute nnXnproj matrix zsw1 = <psi1|prj> ****
              call Cram_cc_inzdot(nbq,nn,
     >                      dbl_mb(psi1_shift),
     >                      dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                      dcpl_mb(zsw1(1)+(l-1)*nn))

*           ***** scale psp by factor - used for generating antiferromagnetic structures ****
*           **** nwchem input: pspspin up/down scale l ion_numbers                       ****
            if (pspspin) then
               if (log_mb(pspspin_upions(1)+ii-1).and.
     >            (l_prj.eq.pspspin_upl))
     >            call dscal(2*ne(1),pspspin_upscale,
     >                       dcpl_mb(zsw1(1)+(l-1)*nn),1)
               if (log_mb(pspspin_downions(1)+ii-1).and.
     >            (l_prj.eq.pspspin_downl))
     >            call dscal(2*ne(2),pspspin_downscale,
     >                       dcpl_mb(zsw1(1)+(l-1)*nn+ne(1)),1)
            end if

           end do !**l**

           call C3dB_Vector_SumAll((2*nn*nproj),dcpl_mb(zsw1(1)))


*          **** zsw2 = Gijl*zsw1 ******
           call Multiply_Gijl_zsw1(nn,
     >                         nproj,
     >                         int_mb(nmax(1)+ia-1),
     >                         int_mb(lmax(1)+ia-1),
     >                         int_mb(n_projector(1)
     >                                + (ia-1)*jmmax_max),
     >                         int_mb(l_projector(1)
     >                                + (ia-1)*jmmax_max),
     >                         int_mb(m_projector(1)
     >                                + (ia-1)*jmmax_max),
     >                         dbl_mb(Gijl(1)
     >                         + (ia-1)*gij_stride),
     >                         dcpl_mb(zsw1(1)),
     >                         dcpl_mb(zsw2(1)))


*          **** do Kleinman-Bylander Multiplication ****
           call dscal(2*nn*nproj,scal,dcpl_mb(zsw2(1)),1)
           call ZGEMM('N','C',npack,nn,nproj,
     >                mone,
     >                dcpl_mb(prjtmp(1)), npack1,
     >                dcpl_mb(zsw2(1)),   nn,
     >                one,
     >                dbl_mb(psi2_shift), npack1)


           if (move) then
              weight = brillioun_weight(nbq)
              if (occ_tag.gt.0) 
     >           occ1_shift = cpsi_data_get_chnk(occ_tag,nbq)
              if (ispin.eq.1) 
     >           call dscal(2*nn*nproj,2.0d0,dcpl_mb(zsw2(1)),1)
          
              do l=1,nproj
          
                 psi_shift = psi1_shift
                 do n=1,nn

*                   **** routine should be vectorized!!!****
                    call Cram_zccr_Multiply2(nbq,
     >                                 dcpl_mb(zsw2(1)+(l-1)*nn+n-1),
     >                                 dbl_mb(psi_shift),
     >                                 dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                                 dbl_mb(xtmp(1)))
                    psi_shift = psi_shift + nshift
c                    do i=1,npack
c                       ctmp = psi1(i+(n-1)*npack1
c     >                              +(nb-1)*neall*npack1)
c     >                      *dconjg(dcpl_mb(prjtmp(1)+(l-1)*npack1+i-1))
c     >                      *dconjg(dcpl_mb(zsw2(1)+(l-1)*nn+n-1))
c                       dbl_mb(xtmp(1)+i-1) = dimag(ctmp)
c                    end do


*                   **** define Gx,Gy and Gz in packed space ****
                    call C3dB_t_Copy(1,dbl_mb(G(1)),dbl_mb(Gx(1)))
                    call C3dB_t_Copy(1,dbl_mb(G(2)),dbl_mb(Gy(1)))
                    call C3dB_t_Copy(1,dbl_mb(G(3)),dbl_mb(Gz(1)))
                    call Cram_r_pack(nbq,dbl_mb(Gx(1)))
                    call Cram_r_pack(nbq,dbl_mb(Gy(1)))
                    call Cram_r_pack(nbq,dbl_mb(Gz(1)))

                    call Cram_rr_idot(nbq,dbl_mb(Gx(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+3*(n-1)))
                    call Cram_rr_idot(nbq,dbl_mb(Gy(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+1+3*(n-1)))
                    call Cram_rr_idot(nbq,dbl_mb(Gz(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+2+3*(n-1)))
                 end do !**n**

                 call C3dB_Vector_Sumall(3*(nn),dbl_mb(sum(1)))

                 wfrac = 1.0d0
                 if (occ_tag.gt.0) occ_shift = occ1_shift
                 do n=1,nn
                    if (occ_tag.gt.0) then
                       wfrac = dbl_mb(occ_shift)
                       occ_shift = occ_shift+1
                    end if
                    dbl_mb(ftmp(1)+3*(ii-1)) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1))
     >                         + 2.0d0*weight*wfrac
     >                                *dbl_mb(sum(1)+3*(n-1))
                    dbl_mb(ftmp(1)+3*(ii-1)+1) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1)+1)
     >                         + 2.0d0*weight*wfrac
     >                                *dbl_mb(sum(1)+1+3*(n-1))
                    dbl_mb(ftmp(1)+3*(ii-1)+2) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1)+2)
     >                         + 2.0d0*weight*wfrac
     >                                *dbl_mb(sum(1)+2+3*(n-1))
                 end do !** nn **

              end do !** l **
           end if !** move **
       
        end if !** nproj>0**

 500  continue
      end do !** nbq **

      if (move) then
        call K1dB_Vector_SumAll(3*nion,dbl_mb(ftmp(1)))
        call daxpy(3*nion,1.0d0,dbl_mb(ftmp(1)),1,fion,1)
        value = MA_pop_stack(ftmp(2))
        value = value.and.MA_pop_stack(sum(2))
        value = value.and.MA_pop_stack(Gz(2))
        value = value.and.MA_pop_stack(Gy(2))
        value = value.and.MA_pop_stack(Gx(2))
        value = value.and.MA_pop_stack(xtmp(2))
        if (.not.value) call errquit('cpsp_v_nonlocal:popping stack',2,
     &       MA_ERR)
      end if

      value =           MA_pop_stack(zsw2(2))
      value = value.and.MA_pop_stack(zsw1(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not.value) call errquit('cpsp_v_nonlocal:popping stack',3,
     &       MA_ERR)

      call nwpw_timing_end(6)

      return 
      end

*     ************************************************
*     *                                              *
*     *              Multiply_Gijl_zsw1              *
*     *                                              *
*     ************************************************
cccccccccccccccccccc
c
cccccccccccccccccccc
      subroutine Multiply_Gijl_zsw1(nn,nprj,nmax,lmax,
     >                             n_prj,l_prj,m_prj,
     >                             G,
     >                             zsw1,zsw2)
      implicit none
      integer nn
      integer nprj,nmax,lmax
      integer n_prj(nprj)
      integer l_prj(nprj)
      integer m_prj(nprj)
      real*8  G(nmax,nmax,0:lmax)
      complex*16 zsw1(nn,nprj)
      complex*16 zsw2(nn,nprj)

      !**** local variables ****
      integer a,b,na,nb,la,lb,ma,mb


      call dcopy(2*nn*nprj,0.0d0,0,zsw2,1)
      do b=1,nprj
         lb = l_prj(b)
         mb = m_prj(b)

         do a=1,nprj
            la = l_prj(a)
            ma = m_prj(a)

            if ((la.eq.lb).and.(ma.eq.mb)) then
              na = n_prj(a)
              nb = n_prj(b)
              call daxpy(2*nn,G(nb,na,la),zsw1(1,a),1,zsw2(1,b),1)
            end if

         end do
      end do
      return
      end


*     ***********************************
*     *					*
*     *	 	 cpsp_v_nonlocal_orb  	*
*     *					*
*     ***********************************

      subroutine cpsp_v_nonlocal_orb(nb,orb1,orb2)
      implicit none
      integer    nb
      complex*16 orb1(*)
      complex*16 orb2(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "cpsp_common.fh"


*     *** local variables ***
      complex*16 one,mone,ione
c      parameter  (one=(1.0d0,0.0d0), mone=(-1.0d0,0.0d0))
c      parameter  (ione=(0.0d0,1.0d0))
      integer nfft3d,npack1,npack
      integer ii,ia,l,ne1
      integer shift,l_prj,nproj
      real*8  omega,scal
      complex*16 cxr
      integer exi(2),zsw1(2),zsw2(2)
      logical value,sd_function

*     **** external functions ****
      logical  is_sORd,cpsi_spin_orbit
      integer  ion_nion,ion_katm
      integer  cpsp_projector_get_ptr
      integer  cpsi_neq
      real*8   lattice_omega
      external is_sORd,cpsi_spin_orbit
      external ion_nion,ion_katm
      external cpsp_projector_get_ptr
      external lattice_omega
      external cpsi_neq
      one=dcmplx(1.0d0,0.0d0)
      mone=dcmplx(-1.0d0,0.d0)
      ione=dcmplx(0.0d0,1.d0)

      if (cpsi_spin_orbit()) then
        call cpsp_v_nonlocal_orb_2com(nb,orb1,orb2)
        return
      end if

      call nwpw_timing_start(6)
      
*     **** allocate local memory ****
      call C3dB_nfft3d(1,nfft3d)
      call Cram_max_npack(npack1)
c      nbrill = brillioun_nbrillioun()
      ne1=cpsi_neq(1)
      value = MA_push_get(mt_dcpl,npack1,'exi', exi(2), exi(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nprj_max,
     >                    'zsw1',zsw1(2),zsw1(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nprj_max,
     >                    'zsw2',zsw2(2),zsw2(1))
      if (.not.value) 
     > call errquit('cpsp_v_nonlocal_orb:pushing stack',0,MA_ERR)


      omega = lattice_omega()
      scal  = 1.0d0/omega

      do 500 ii=1,ion_nion()
         ia=ion_katm(ii)
         nproj = int_mb(nprj(1)+ia-1)

         if (nproj.gt.0) then

            if ( int_mb(psp_type(1)+ia-1) .eq. 7) then
              call cpsp_v_nonlocal_rel_orb(nb,orb1,orb2,
     >             dcpl_mb(zsw1(1)),
     >             dbl_mb(Kijl(1)+(ia-1)*kij_stride),
     >             dcpl_mb(exi(1)),
     >             nfft3d,ia,ii,ne1,
     >             npack1,nproj)
              goto 500
            end if


*           **** structure factor ****
            call Cram_npack(nb,npack)
            call cstrfac_pack(nb,ii,dcpl_mb(exi(1)))
            call cstrfac_k(ii,nb,cxr)
cc            call Cram_c_ZMul(nb,cxr,dcpl_mb(exi(1)),dcpl_mb(exi(1)))
            call zscal(npack,cxr,dcpl_mb(exi(1)),1)

            do l=1,nproj

c              shift = vnl(1)+(l-1) *npack1
c     >                      +(nb-1)*npack1*vnl_stride
c     >                      +(ia-1)*npack1*vnl_stride*nbrill
              shift = cpsp_projector_get_ptr(
     >                     int_mb(vnl(1)+ia-1),nb,l)
              l_prj = int_mb(l_projector(1)+(l-1)
     >                                     +(ia-1)*jmmax_max)

              sd_function=.true.
              if (mod(l_prj,2).ne.0) then
                sd_function=.false.
              end if

*             **** phase factor does not matter therefore ****
*             **** (-i)^l is the same as (i)^l in the     ****
*             **** Rayleigh scattering formula            ****
*             *** current function is s or d ****
              if (sd_function) then
                 call Cram_rc_Mul(nb,dbl_mb(shift),
     >                               dcpl_mb(exi(1)),
     >                               dcpl_mb(prjtmp(1)+(l-1)*npack1))
*             *** current function is p or f ****
              else
                 call Cram_irc_Mul(nb,dbl_mb(shift),
     >                                dcpl_mb(exi(1)),
     >                                dcpl_mb(prjtmp(1)+(l-1)*npack1))
              end if

*             **** compute 1Xnproj matrix zsw1 = <psi1|prj> ****
              call Cram_cc_izdot(nb,
     >                      orb1,
     >                      dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                      dcpl_mb(zsw1(1)+(l-1)))
            end do !**l**
            call C3dB_Vector_SumAll((2*nproj),dcpl_mb(zsw1(1)))

*           **** zsw2 = Gijl*zsw1 ******
            call Multiply_Gijl_zsw1(1,
     >                         nproj,
     >                         int_mb(nmax(1)+ia-1),
     >                         int_mb(lmax(1)+ia-1),
     >                         int_mb(n_projector(1)
     >                                + (ia-1)*jmmax_max),
     >                         int_mb(l_projector(1)
     >                                + (ia-1)*jmmax_max),
     >                         int_mb(m_projector(1)
     >                                + (ia-1)*jmmax_max),
     >                         dbl_mb(Gijl(1)
     >                         + (ia-1)*gij_stride),
     >                         dcpl_mb(zsw1(1)),
     >                         dcpl_mb(zsw2(1)))

*           **** do Kleinman-Bylander Multiplication ****
            call dscal(2*nproj,scal,dcpl_mb(zsw2(1)),1)
            call ZGEMM('N','C',npack,1,nproj,
     >                 mone,
     >                 dcpl_mb(prjtmp(1)), npack1,
     >                 dcpl_mb(zsw2(1)),   1,
     >                 one,
     >                 orb2, npack1)

         end if !** nproj>0 **
500   continue !** ii ****

      value =           MA_pop_stack(zsw2(2))
      value = value.and.MA_pop_stack(zsw1(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not.value) 
     > call errquit('cpsp_v_nonlocal_orb:popping stack',3,MA_ERR)

      call nwpw_timing_end(6)

      return 
      end



*     ***********************************
*     *					*
*     *	       cpsp_f_vnonlocal		*
*     *					*
*     ***********************************

      subroutine cpsp_f_vnonlocal(ispin,ne,psi1_tag,fion)
      implicit none
      integer    ispin,ne(2)
      integer    psi1_tag
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "cpsp_common.fh"
#include "errquit.fh"


*     *** local variables ***
      integer nfft3d,G(3),npack1,npack,nbrillq,neall,nion
      integer ii,ia,l,n,nn,nbq,l_prj,nproj,shift
      integer psi1_shift,psi_shift,nshift
      real*8  omega,weight,scal,wfrac
      complex*16 cxr
      integer exi(2),xtmp(2),zsw1(2),zsw2(2),sum(2),ftmp(2)
      integer Gx(2),Gy(2),Gz(2),it
      integer occ1_tag,occ1_shift,occ_shift
      logical value,sd_function

*     **** external functions ****
      logical  is_sORd
      integer  ion_nion,ion_katm,c_G_indx,Pneb_nbrillq
      integer  cpsp_projector_get_ptr,cpsi_data_get_chnk
      integer  cpsi_data_get_next
      real*8   lattice_omega,brillioun_weight
      external is_sORd
      external ion_nion,ion_katm,c_G_indx,Pneb_nbrillq
      external cpsp_projector_get_ptr,cpsi_data_get_chnk
      external cpsi_data_get_next
      external lattice_omega,brillioun_weight

      call nwpw_timing_start(6)
      
*     **** allocate local memory ****
      nn = ne(1)+ne(2)
      neall   = ne(1)+ne(2)
      nion    = ion_nion()
      nbrillq = Pneb_nbrillq()
      call C3dB_nfft3d(1,nfft3d)
      call Cram_max_npack(npack1)
      nshift = 2*npack1
      occ1_tag = cpsi_data_get_next(psi1_tag)

      value = MA_push_get(mt_dcpl,npack1,'exi', exi(2), exi(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nn*nprj_max,
     >                    'zsw1',zsw1(2),zsw1(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nn*nprj_max,
     >                    'zsw2',zsw2(2),zsw2(1))
      if (.not.value) call errquit('cpsp_v_nonlocal:pushing stack',0,
     &       MA_ERR)

      value = MA_push_get(mt_dbl, nfft3d,'xtmp',xtmp(2),xtmp(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gx',Gx(2),Gx(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gy',Gy(2),Gy(1))
      value = value.and.
     >        MA_push_get(mt_dbl, nfft3d,'Gz',Gz(2),Gz(1))

      value = value.and.
     >      MA_push_get(mt_dbl,3*nn,'sum',sum(2),sum(1))
      value = value.and.
     >      MA_push_get(mt_dbl,3*nion,'ftmp',ftmp(2),ftmp(1))
      if (.not.value) call errquit('cpsp_v_nonlocal:pushing stack',1,
     &       MA_ERR)
      call dcopy(3*nion,0.0d0,0,dbl_mb(ftmp(1)),1)
      G(1)  = c_G_indx(1)
      G(2)  = c_G_indx(2)
      G(3)  = c_G_indx(3)

      omega = lattice_omega()
      scal  = 1.0d0/omega

      do nbq = 1,nbrillq
        call Cram_npack(nbq,npack)
        weight = brillioun_weight(nbq)
        psi1_shift = cpsi_data_get_chnk(psi1_tag,nbq)
        if (occ1_tag.gt.0) 
     >     occ1_shift = cpsi_data_get_chnk(occ1_tag,nbq)


*       **** define Gx,Gy and Gz in packed space ****
        call C3dB_t_Copy(1,dbl_mb(G(1)),dbl_mb(Gx(1)))
        call C3dB_t_Copy(1,dbl_mb(G(2)),dbl_mb(Gy(1)))
        call C3dB_t_Copy(1,dbl_mb(G(3)),dbl_mb(Gz(1)))
        call Cram_r_pack(nbq,dbl_mb(Gx(1)))
        call Cram_r_pack(nbq,dbl_mb(Gy(1)))
        call Cram_r_pack(nbq,dbl_mb(Gz(1)))

        do 100 ii=1,nion
           ia=ion_katm(ii)
           it=int_mb(psp_type(1)+ia-1)
           nproj = int_mb(nprj(1)+ia-1)
           if (nproj.gt.0) then
              if (it.eq.7) then 
                call cpsp_f_nonlocal_rel(nbq,ii,ia,nproj,npack1,ne(1),
     >          dcpl_mb(exi(1)),dcpl_mb(zsw1(1)),
     >          dbl_mb(psi1_shift),dcpl_mb(prjtmp(1)),
     >          dbl_mb(xtmp(1)),dbl_mb(sum(1)),
     >          dbl_mb(Kijl(1)+(ia-1)*kij_stride),
     >          dbl_mb(Gx(1)),dbl_mb(Gy(1)),dbl_mb(Gz(1)),
     >          dbl_mb(ftmp(1)+3*(ii-1)),
     >          dbl_mb(ftmp(1)+3*(ii-1)+1),
     >          dbl_mb(ftmp(1)+3*(ii-1)+2),
     >          weight,scal)
                goto 100 
              end if

*             **** structure factor ****
              call cstrfac_pack(nbq,ii,dcpl_mb(exi(1)))
              call cstrfac_k(ii,nbq,cxr)
c              call Cram_c_ZMul(nbq,cxr,dcpl_mb(exi(1)),dcpl_mb(exi(1)))
              call zscal(npack,cxr,dcpl_mb(exi(1)),1)

              do l=1,nproj
c                 shift = vnl(1)
c     >                      +(l-1) *npack1
c     >                      +(nb-1)*npack1*vnl_stride
c     >                      +(ia-1)*npack1*vnl_stride*nbrill
                 shift = cpsp_projector_get_ptr(
     >                     int_mb(vnl(1)+ia-1),nbq,l)
                 l_prj = int_mb(l_projector(1)+(l-1)
     >                          +(ia-1)*jmmax_max)
              
                sd_function=.true.
                if (mod(l_prj,2).ne.0) then
                  sd_function=.false.
                end if

*                **** phase factor does not matter therefore ****
*                **** (-i)^l is the same as (i)^l in the     ****
*                **** Rayleigh scattering formula            ****
*                *** current function is s or d ****
                 if (sd_function) then
                    call Cram_rc_Mul(nbq,dbl_mb(shift),
     >                                  dcpl_mb(exi(1)),
     >                                  dcpl_mb(prjtmp(1)+(l-1)*npack1))
*                *** current function is p or f ****
                 else
                    call Cram_irc_Mul(nbq,dbl_mb(shift),
     >                                   dcpl_mb(exi(1)),
     >                                  dcpl_mb(prjtmp(1)+(l-1)*npack1))
                 end if

*                **** compute nnXnproj matrix zsw1 = <psi1|prj> ****
                 call Cram_cc_inzdot(nbq,nn,
     >                         dbl_mb(psi1_shift),
     >                         dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                         dcpl_mb(zsw1(1)+(l-1)*nn))

*                ***** scale psp by factor - used for generating antiferromagnetic structures ****
*                **** nwchem input: pspspin up/down scale l ion_numbers                       ****
                 if (pspspin) then
                    if (log_mb(pspspin_upions(1)+ii-1).and.
     >                 (l_prj.eq.pspspin_upl))
     >                 call dscal(2*ne(1),pspspin_upscale,
     >                            dcpl_mb(zsw1(1)+(l-1)*nn),1)
                    if (log_mb(pspspin_downions(1)+ii-1).and.
     >                 (l_prj.eq.pspspin_downl))
     >                 call dscal(2*ne(2),pspspin_downscale,
     >                            dcpl_mb(zsw1(1)+(l-1)*nn+ne(1)),1)
                 end if
              end do
              call C3dB_Vector_SumAll((2*nn*nproj),dcpl_mb(zsw1(1)))


*             **** do kleinman-bylander multiplication ****
*             **** sw2 = Gijl*sw1 ******
              call Multiply_Gijl_zsw1(nn,
     >                          nproj,
     >                          int_mb(nmax(1)+ia-1),
     >                          int_mb(lmax(1)+ia-1),
     >                          int_mb(n_projector(1)
     >                                 + (ia-1)*jmmax_max),
     >                          int_mb(l_projector(1)
     >                                 + (ia-1)*jmmax_max),
     >                          int_mb(m_projector(1)
     >                                 + (ia-1)*jmmax_max),
     >                          dbl_mb(Gijl(1)
     >                         + (ia-1)*gij_stride),
     >                          dcpl_mb(zsw1(1)),
     >                          dcpl_mb(zsw2(1)))

              call dscal(2*nn*nproj,scal,dcpl_mb(zsw2(1)),1)
              if (ispin.eq.1) 
     >           call dscal(2*nn*nproj,2.0d0,dcpl_mb(zsw2(1)),1)

              do l=1,nproj

                 psi_shift = psi1_shift
                 do n=1,nn
                    call Cram_zccr_Multiply2(nbq,
     >                                 dcpl_mb(zsw2(1)+(l-1)*nn+n-1),
     >                                 dbl_mb(psi_shift),
     >                                 dcpl_mb(prjtmp(1)+(l-1)*npack1),
     >                                 dbl_mb(xtmp(1)))
                    psi_shift = psi_shift + nshift
c                    do i=1,npack
c                       ctmp = psi1(i+(n-1)*npack1
c     >                              +(nb-1)*neall*npack1)
c     >                      *dconjg(dcpl_mb(prjtmp(1)+(l-1)*npack1+i-1))
c     >                      *dconjg(dcpl_mb(zsw2(1)+(l-1)*nn+n-1))
c                       dbl_mb(xtmp(1)+i-1) = dimag(ctmp)
c                    end do
 
                    call Cram_rr_idot(nbq,dbl_mb(Gx(1)),dbl_mb(xtmp(1)),
     >                                   dbl_mb(sum(1)+3*(n-1)))
                    call Cram_rr_idot(nbq,dbl_mb(Gy(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+1+3*(n-1)))
                    call Cram_rr_idot(nbq,dbl_mb(Gz(1)),dbl_mb(xtmp(1)),
     >                                dbl_mb(sum(1)+2+3*(n-1)))
                 end do
                 call C3dB_Vector_Sumall(3*(nn),dbl_mb(sum(1)))
  
                 wfrac = 1.0d0
                 if (occ1_tag.gt.0) occ_shift = occ1_shift
                 do n=1,nn
                    if (occ1_tag.gt.0) then
                       wfrac = dbl_mb(occ_shift)
                       occ_shift = occ_shift+1
                    end if
                    dbl_mb(ftmp(1)+3*(ii-1)) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1))
     >                         + 2.0d0*wfrac*weight
     >                           *dbl_mb(sum(1)+3*(n-1))
                    dbl_mb(ftmp(1)+3*(ii-1)+1) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1)+1)
     >                         + 2.0d0*wfrac*weight
     >                           *dbl_mb(sum(1)+1+3*(n-1))
                    dbl_mb(ftmp(1)+3*(ii-1)+2) = 
     >                         dbl_mb(ftmp(1)+3*(ii-1)+2)
     >                         + 2.0d0*wfrac*weight
     >                          *dbl_mb(sum(1)+2+3*(n-1))
                 end do
        
              end do !** l **

           end if !** nproj>0) ***
100      continue !** ii **

      end do !** nbq ***

      call K1dB_Vector_SumAll(3*nion,dbl_mb(ftmp(1)))
      call daxpy(3*nion,1.0d0,dbl_mb(ftmp(1)),1,fion,1)
      value =           MA_pop_stack(ftmp(2))
      value = value.and.MA_pop_stack(sum(2))
      value = value.and.MA_pop_stack(Gz(2))
      value = value.and.MA_pop_stack(Gy(2))
      value = value.and.MA_pop_stack(Gx(2))
      value = value.and.MA_pop_stack(xtmp(2))
      if (.not.value) call errquit('cpsp_f_vnonlocal:popping stack',2,
     &       MA_ERR)

      value =           MA_pop_stack(zsw2(2))
      value = value.and.MA_pop_stack(zsw1(2))
      value = value.and.MA_pop_stack(exi(2))
      if (.not.value) call errquit('cpsp_f_vnonlocal:popping stack',3,
     &       MA_ERR)

      call nwpw_timing_end(6)
      

      return 
      end

*     *************************************************************
*     *                                                           *
*     *                   cpsp_read                               *
*     *                                                           *
*     *************************************************************
cccccccccccccccccccccccccccccccccccccccccccccccccc
c Read data from psp file *.cpp
cccccccccccccccccccccccccccccccccccccccccccccccccc 
      subroutine cpsp_read(fname,comment,
     >                       psp_type,
     >                       version,
     >                       nfft,unita,
     >                       atom,amass,zv,lmmax,lmax,locp,nmax,
     >                       rc,
     >                       nprj,n_projector,l_projector,m_projector,
     >                       Gijl,
     >                       Kijl,
     >                       nfft3d,npack0,npack1,lmmax_max,nmax_max,
     >                       vl,vnl_tag,vnl2_tag,
     >                       semicore,rcore,ncore,
     >                       tmp,tmp2,
     >                       ierr)
      implicit none 
      character*(*) comment
      character*50 fname
      integer psp_type
      integer version
      integer nfft(3)
      real*8  unita(3,3)
      character*2 atom
      real*8 amass,zv
      integer lmmax
      integer lmax
      integer locp
      integer nmax
      real*8 rc(*)
      integer nprj,n_projector(*),l_projector(*),m_projector(*)
      real*8 Gijl(*),Kijl(*)
      integer nfft3d,npack0,npack1,lmmax_max,nmax_max
      real*8 vl(*)
      integer vnl_tag
      integer vnl2_tag
      logical semicore
      real*8  rcore
      real*8  ncore(*)
      real*8     tmp(*)
      real*8     tmp2(*)
      integer ierr

#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"

#ifdef TCGMSG
#include "tcgmsg.fh"
#include "msgtypesf.h"
#endif

*    *** local variables ***
      integer MASTER,taskid,taskid_k
      parameter(MASTER=0)
      integer n,l,nb,nbq,pk
      integer msglen,rsize
      integer iatom(2)
      character*255 full_filename
      real*8 kv(3)
      integer nbrillioun
      logical mprint,value

*     ***** external functions ****
      integer  brillioun_nbrillioun,cpsp_projector_alloc
      integer  brillioun_nbrillq
      real*8   brillioun_all_k
      logical  control_print
      external brillioun_nbrillioun,cpsp_projector_alloc
      external brillioun_nbrillq
      external brillioun_all_k
      external control_print

      call Parallel_taskid(taskid)
      call Parallel3d_taskid_k(taskid_k)
      mprint = (taskid.eq.MASTER).and.control_print(print_medium)

*     **** open fname binary file ****
      
      if (taskid.eq.MASTER) then
         call util_file_name_noprefix(fname,.false.,
     >                             .false.,
     >                       full_filename)
         l = index(full_filename,' ') - 1
         call openfile(5,full_filename,l,'r',l)
         call cread(5,comment,80)
         call iread(5,psp_type,1)
         call iread(5,version,1)
         call iread(5,nfft,3)
         call dread(5,unita,9)
         call cread(5,atom,2)
         call dread(5,amass,1)
         call dread(5,zv,1)
         call iread(5,lmax,1)
         call iread(5,locp,1)
         call iread(5,nmax,1)
         lmmax=(lmax+1)**2 - (2*locp+1)
         amass = amass*1822.89d0
         call dread(5,rc,(lmax+1))
         call iread(5,nprj,1)
         if (nprj.gt.0) then
           call iread(5,n_projector,nprj)
           call iread(5,l_projector,nprj)
           call iread(5,m_projector,nprj)
           if (psp_type.eq.7) then
              call dread(5,Kijl,nprj)
           else
ccc!** number of matrix elements = nmax*nmax*(lmax+1) **
             rsize=nmax*nmax*(lmax+1)
             call dread(5,Gijl,rsize)
             if (psp_type.eq.1) then
               call dread(5,Kijl,rsize)
             end if
ccc!** number of matrix elements = nmax*nmax*(lmax+1) **
           end if
         end if  
         call dread(5,rcore,1)
         call iread(5,nbrillioun,1)
         ierr = 0
         if (nbrillioun.eq.brillioun_nbrillioun()) then
           do nb=1,nbrillioun
               call dread(5,kv,3)
               if ((brillioun_all_k(1,nb).ne.kv(1)).or.  
     >             (brillioun_all_k(2,nb).ne.kv(2)).or.
     >             (brillioun_all_k(3,nb).ne.kv(3))) 
     >          ierr = 1
           end do
           if (ierr.eq.1) then
              if (mprint) then
                 write(*,*)"Brillioun Zone Vectors do not match!"
                 call flush(6)
              end if
           end if
         else
           if (mprint) then
           write(*,*)"Brillioun Zone Points do not match!"
           write(*,*)"NB = ",nbrillioun," not equal ",
     >       brillioun_nbrillioun()
           call flush(6)
           end if
           ierr = 1
         end if
      end if

      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,ierr)
      if (ierr.ne.0) then
         if (taskid.eq.MASTER) call closefile(5)
         return
      end if

*     **** send header data to all processors ****
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,version)
      call Parallel_Brdcst_ivalues(MASTER,msglen,psp_type)
      msglen = 3
      call Parallel_Brdcst_ivalues(MASTER,msglen,nfft)
      msglen = 9
      call Parallel_Brdcst_values(MASTER,msglen,unita)

      iatom(1) = ichar(atom(1:1))
      iatom(2) = ichar(atom(2:2))
      msglen = 2
      call BRDCST(9+MSGCHR,iatom,mitob(msglen),MASTER)
      atom(1:1) = char(iatom(1))
      atom(2:2) = char(iatom(2))

      msglen = 1
      call Parallel_Brdcst_values(MASTER,msglen,amass)
      msglen = 1
      call Parallel_Brdcst_values(MASTER,msglen,zv)
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,lmax)
      call Parallel_Brdcst_ivalues(MASTER,msglen,locp)
      call Parallel_Brdcst_ivalues(MASTER,msglen,nmax)
      call Parallel_Brdcst_ivalues(MASTER,msglen,nprj)
      lmmax=(lmax+1)**2 - (2*locp+1)

      msglen=lmax+1
      call Parallel_Brdcst_values(MASTER,msglen,rc)

      msglen=nprj
      call Parallel_Brdcst_ivalues(MASTER,msglen,n_projector)
      call Parallel_Brdcst_ivalues(MASTER,msglen,l_projector)
      call Parallel_Brdcst_ivalues(MASTER,msglen,m_projector)

      if (psp_type.eq.7) then
       msglen=nprj
       call Parallel_Brdcst_values(MASTER,msglen,Kijl)
      else
       msglen=nmax*nmax*(lmax+1)
       call Parallel_Brdcst_values(MASTER,msglen,Gijl)
       if(psp_type.eq.1) call Parallel_Brdcst_values(MASTER,msglen,Kijl)
      end if
      msglen=1
      call Parallel_Brdcst_values(MASTER,msglen,rcore)


*     **** determine semicore value ****
      if (rcore.gt.0.0d0) then
         semicore = .true.
      else
         semicore = .false.
      end if

*     *** read in vl 3d block ***
      call C3dB_r_read(1,5,tmp2,tmp,-1,-1)
      call Cram_r_pack(0,tmp2)
      call Cram_r_Copy(0,tmp2,vl)


*     **** read in vnl 3d blocks ****

ccccccccccccccccccc
      if (psp_type.eq.7) then
cccccccccccccccccccc
c Relativistic Non-Local PPot.
c spin-orbit included...
cccccccccccccccccccc
        vnl_tag  = cpsp_projector_alloc(brillioun_nbrillq(),
     >                                  nprj,2*npack1)
        vnl2_tag = cpsp_projector_alloc(brillioun_nbrillq(),
     >                                  nprj,2*npack1)
!*** XXXX double check this INPUT ****
        do nb=1,brillioun_nbrillioun() 
          call K1dB_ktoqp(nb,nbq,pk)
          do n=1,nprj
            call C3dB_c_Read(1,5,tmp2,tmp,-1,pk)
            if (pk.eq.taskid_k) then
               call Cram_c_pack(nbq,tmp2)
               call cpsp_projector_add(vnl_tag,nbq,n,tmp2)
            end if
          end do
          do n=1,nprj
            call C3dB_c_read(1,5,tmp2,tmp,-1,pk)
            if (pk.eq.taskid_k) then
               call Cram_c_pack(nbq,tmp2)
               call cpsp_projector_add(vnl2_tag,nbq,n,tmp2)
            end if
          end do
        end do

      else
        vnl_tag = cpsp_projector_alloc(brillioun_nbrillq(),
     >                                 nprj,npack1)
        do nb=1,brillioun_nbrillioun() 
          call K1dB_ktoqp(nb,nbq,pk)
          do n=1,nprj

            call C3dB_r_read(1,5,tmp2,tmp,-1,pk)

            if (pk.eq.taskid_k) then
               call Cram_r_pack(nbq,tmp2)
               call cpsp_projector_add(vnl_tag,nbq,n,tmp2)
            endif
          end do
        end do
*     **** read in v_spin_orbit 3d blocks ****
        if (psp_type.eq.1) then
          vnl2_tag = cpsp_projector_alloc(brillioun_nbrillq(),
     >                                    nprj,2*npack1)
          do nb=1,brillioun_nbrillioun()
            call K1dB_ktoqp(nb,nbq,pk)
            do n=1,nprj
              call C3dB_c_read(1,5,tmp2,tmp,-1,pk)
              if (pk.eq.taskid_k) then
                 call Cram_c_pack(nbq,tmp2)
                 call cpsp_projector_add(vnl2_tag,nbq,n,tmp2)
              endif
            end do
          end do
        end if
      end if
*     **** read in semicore density block ****
      if (semicore) then
         call C3dB_r_read(1,5,tmp2,tmp,-1,-1)
         call Cram_r_pack(0,tmp2)
         call Cram_r_Copy(0,tmp2,ncore(1))

         call C3dB_r_read(1,5,tmp2,tmp,-1,-1)
         call Cram_r_pack(0,tmp2)
         call Cram_r_Copy(0,tmp2,ncore(1+2*npack0))

         call C3dB_r_read(1,5,tmp2,tmp,-1,-1)
         call Cram_r_pack(0,tmp2)
         call Cram_r_Copy(0,tmp2,ncore(1+3*npack0))

         call C3dB_r_read(1,5,tmp2,tmp,-1,-1)
         call Cram_r_pack(0,tmp2)
         call Cram_r_Copy(0,tmp2,ncore(1+4*npack0))
      end if

*     *** close fname binary file ***
      if (taskid.eq.MASTER) then
         call closefile(5)
      end if

      ierr = 0
      return
      end


*     ***********************************
*     *					*
*     *	 	  cpsp_readall  	*
*     *					*
*     ***********************************

      subroutine cpsp_readall()
      implicit none
      
#include "mafdecls.fh"
#include "cpsp_common.fh"
#include "c_semicore_common.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"

*     **** local variables ****
      integer ngp(3),version,nfft3d,npack0,npack1
      integer ia,l
      real*8 unita(3,3)
      character*12 boundry
      integer tmp(2),tmp2(2),ierr
      logical value,found,correct_box,mprint
      character*5  element
      character*50 fname

*     **** parallel i/o variable ****
      integer MASTER,taskid
      parameter(MASTER=0)

*     **** external functions ****
      logical      nwpw_filefind,control_spin_orbit,control_print
      integer      control_ngrid
      real*8       control_unita
      character*12 control_boundry
      character*4  ion_atom
      external     nwpw_filefind,control_spin_orbit,control_print
      external     control_ngrid
      external     control_unita
      external     control_boundry
      external     ion_atom
      

      call C3dB_nfft3d(1,nfft3d)
      call Cram_npack(0,npack0)
      call Cram_max_npack(npack1)
      call Parallel_taskid(taskid)
      !nbrill = brillioun_nbrillioun()

      mprint = (taskid.eq.MASTER).and.control_print(print_medium)

*     *** set semicore(0) *****
      log_mb(semicore(1)) = .false.

      value = MA_push_get(mt_dbl,(4*nfft3d),'tmp',tmp(2),tmp(1))
      if (.not. value) 
     > call errquit('cpsp_readall:out of stack memory',0,MA_ERR)

      value = MA_push_get(mt_dbl,(2*nfft3d),'tmp2',tmp2(2),tmp2(1))
      if (.not. value) 
     > call errquit('cpsp_readall:out of stack memory',0,MA_ERR)

      do_spin_orbit=.false.

*     **** read pseudopotentials ****
      do ia=1,npsp

*      **** define formatted psp name ****
       element = '     '
       element = ion_atom(ia)
       l = index(element,' ') - 1
       fname = element(1:l)//'.cpp'

       found = .false.
       do while (.not.found)

         if (nwpw_filefind(fname)) then
            call cpsp_read(fname,comment(ia),
     >                  int_mb(psp_type(1)+ia-1),
     >                  version,
     >                  ngp,unita,
     >                  atom(ia),
     >                  dbl_mb(amass(1)+ia-1),
     >                  dbl_mb(zv(1)+ia-1),
     >                  int_mb(lmmax(1)+ia-1),
     >                  int_mb(lmax(1)+ia-1),
     >                  int_mb(locp(1)+ia-1),
     >                  int_mb(nmax(1)+ia-1),
     >                  dbl_mb(rc(1) + (ia-1)*(lmax_max+1)),
     >                  int_mb(nprj(1)+ia-1),
     >                  int_mb(n_projector(1)
     >                     + (ia-1)*jmmax_max),
     >                  int_mb(l_projector(1)
     >                     + (ia-1)*jmmax_max),
     >                  int_mb(m_projector(1)
     >                     + (ia-1)*jmmax_max),
     >                  dbl_mb(Gijl(1)
     >                     + (ia-1)*gij_stride),
     >                  dbl_mb(Kijl(1)
     >                     + (ia-1)*kij_stride),
     >                  nfft3d,npack0,npack1,lmmax_max,nmax_max,
     >                  dbl_mb(vl(1) + (ia-1)*npack0),
     >                  int_mb(vnl(1)   + ia-1),
     >                  int_mb(vnlso(1) + ia-1),
     >                  log_mb(semicore(1)+ia),
     >                  dbl_mb(rcore(1)+ia-1),
     >                  dbl_mb(ncore(1)+ (ia-1)*npack0*5),
     >                  dbl_mb(tmp(1)),dbl_mb(tmp2(1)),
     >                  ierr)

           if ((int_mb(psp_type(1)+(ia-1)).eq.1).and.
     >           control_spin_orbit()) then
              do_spin_orbit=.true.
              if (mprint) then
                write(*,*)"HGH spin orbit pseudopotential activated"
                call flush(6)
              end if
           end if
           if ((int_mb(psp_type(1)+(ia-1)).eq.7)) then
             if (mprint) then
               write(*,*)"RTC spin orbit pseudopotential activated"
               call flush(6)
             end if
           end if

*          **** set semicore(0) ****
           if (log_mb(semicore(1)+ia)) log_mb(semicore(1)) = .true.
           if (ierr.gt.1) go to 9000
*          **************************************************************
*          ***** logic for finding out if psp is correctly formatted ****
*          **************************************************************
           correct_box = .true.
           boundry = control_boundry()
           l =index(boundry,' ') - 1
           if ( (ngp(1).ne.control_ngrid(1)) .or.
     >       (ngp(2).ne.control_ngrid(2)) .or.
     >       (ngp(3).ne.control_ngrid(3)) .or. 
     >       (unita(1,1).ne.control_unita(1,1)) .or.
     >       (unita(2,1).ne.control_unita(2,1)) .or.
     >       (unita(3,1).ne.control_unita(3,1)) .or.
     >       (unita(1,2).ne.control_unita(1,2)) .or.
     >       (unita(2,2).ne.control_unita(2,2)) .or.
     >       (unita(3,2).ne.control_unita(3,2)) .or.
     >       (unita(1,3).ne.control_unita(1,3)) .or.
     >       (unita(2,3).ne.control_unita(2,3)) .or.
     >       (unita(3,3).ne.control_unita(3,3)) .or.
     >       ((boundry(1:l).eq.'periodic').and.(version.ne.3)).or.
     >       ((boundry(1:l).eq.'aperiodic').and.(version.ne.4))) then
              correct_box = .false.
              if (mprint) then
              write(luout,*)
              write(luout,*) 
     >        "pseudopotential is not correctly formatted:",fname
              end if
              if ((ierr.eq.0).and.(int_mb(nprj(1)+ia-1).gt.0)) then
                 call cpsp_projector_dealloc(int_mb(vnl(1)+ia-1))
                 if ((int_mb(psp_type(1)+ia-1).eq.7)
     >               .or.(do_spin_orbit)) then
                    call cpsp_projector_dealloc(int_mb(vnlso(1)+ia-1))
                 end if
              end if
           end if
           if (correct_box) found = .true.
           if (ierr.eq.1)   then
              found = .false.
              if (mprint) then
              write(luout,*)
              write(luout,*) 
     >        "pseudopotential is not correctly formatted---",
     >         "bad brillioun zone:",fname
              end if
           end if

         end if

*        **** generate formatted pseudopotential atom.cpp *****
         if (.not.found) then
             call cpsp_formatter_auto(ion_atom(ia))
         end if

       end do !***do while ****


      end do

 9000 value =           MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp(2))
      if (.not. value) 
     > call errquit('cpsp_readall:error popping stack',0,MA_ERR)

*     **** done reading set nprj_max and prjtmp for nonlocal psp operator ****
      call cpsp_proj_init()

      return
      end

*> \brief <b> DPOSV computes the solution to system of linear equations A * X = B for PO matrices</b>
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DPOSV + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dposv.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dposv.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dposv.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DPOSV( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, LDB, N, NRHS
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DPOSV computes the solution to a real system of linear equations
*>    A * X = B,
*> where A is an N-by-N symmetric positive definite matrix and X and B
*> are N-by-NRHS matrices.
*>
*> The Cholesky decomposition is used to factor A as
*>    A = U**T* U,  if UPLO = 'U', or
*>    A = L * L**T,  if UPLO = 'L',
*> where U is an upper triangular matrix and L is a lower triangular
*> matrix.  The factored form of A is then used to solve the system of
*> equations A * X = B.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangle of A is stored;
*>          = 'L':  Lower triangle of A is stored.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of linear equations, i.e., the order of the
*>          matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] NRHS
*> \verbatim
*>          NRHS is INTEGER
*>          The number of right hand sides, i.e., the number of columns
*>          of the matrix B.  NRHS >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*>          N-by-N upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading N-by-N lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>
*>          On exit, if INFO = 0, the factor U or L from the Cholesky
*>          factorization A = U**T*U or A = L*L**T.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB,NRHS)
*>          On entry, the N-by-NRHS right hand side matrix B.
*>          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          > 0:  if INFO = i, the leading minor of order i of A is not
*>                positive definite, so the factorization could not be
*>                completed, and the solution has not been computed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup doublePOsolve
*
*  =====================================================================
      SUBROUTINE DPOSV( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
*  -- LAPACK driver routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*     ..
*
*  =====================================================================
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DPOTRF, DPOTRS, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPOSV ', -INFO )
         RETURN
      END IF
*
*     Compute the Cholesky factorization A = U**T*U or A = L*L**T.
*
      CALL DPOTRF( UPLO, N, A, LDA, INFO )
      IF( INFO.EQ.0 ) THEN
*
*        Solve the system A*X = B, overwriting B with X.
*
         CALL DPOTRS( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
      END IF
      RETURN
*
*     End of DPOSV
*
      END
c $Id: dposv.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine tce_create_movecs(rtdb)
c
c $Id: tce_create_movecs.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Initialize for many-electron calculations.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "errquit.fh"
c#include "tce.fh"
c#include "tce_main.fh"
c#include "tce_diis.fh"
c#include "tce_prop.fh"
#include "dra.fh"
c
      integer rtdb             ! RTDB handle
      integer nbf_verify       ! nbf read from movecs_read_header
      integer ipol_verify      ! ipol read from movecs_read_header
      character*255 movecs_out ! MO vector file name
      character*255 title      ! Title
      character*255 basisname  ! Basis set name
      character*255 scftype    ! Type of SCF
      character*4 hftype
      character*3 onoff1,onoff2
      integer i,j,n
      integer nclosed, nopen
      double precision a
      character*60 ctype
      character*60 cperturbative
      integer itol2e
      logical nodezero
      logical dummy
      logical rohf
      logical int_normalize
      external int_normalize
      logical movecs_read,movecs_read_header
      external movecs_read,movecs_read_header
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
      logical xc_gotxc
      external xc_gotxc
      character*10 module
      character*8 multchar(8)
       character*26 date
       integer ma_type
c
c
      nodezero=(ga_nodeid().eq.0)
c
c     ----------
c     MO vectors
c     ----------
c
      if (reference.eq.0) then
        if (.not.rtdb_cget(rtdb,'dft:output vectors',1,movecs_out))
     1   call errquit('tce_create_movecs: no final MO found',0,RTDB_ERR)
      else if (reference.eq.1) then
        if (.not.rtdb_cget(rtdb,'scf:output vectors',1,movecs_out))
     1   call errquit('tce_create_movecs: no final MO found',0,RTDB_ERR)
      endif
c
c     -------------------------------------
c     Allocate global arrays for MO vectors
c     -------------------------------------
c
      do i=1,ipol
        if (.not.ma_push_get(mt_dbl,nbf,'eigenvalues',
     1    l_evl(i),k_evl(i))) call errquit
     2    ('tce_create_movecs: failed to allocate evl',0,MA_ERR)
        if (.not.ma_push_get(mt_dbl,nbf,'occupancy',
     1    l_occ(i),k_occ(i))) call errquit
     2    ('tce_create_movecs: failed to allocate occ',0,MA_ERR)
        if (.not.ma_push_get(mt_int,nbf,'irreps',
     1    l_irs(i),k_irs(i))) call errquit
     2    ('tce_create_movecs: failed to allocate irs',0,MA_ERR)
      enddo
      if (.not.movecs_read_header(movecs_out,title,basisname,
     1  scftype,nbf_verify,ipol_verify,nmo,2)) call errquit
     2  ('tce_create_movecs: failed to read MO file header',0,RTDB_ERR)
      if (nbf.ne.nbf_verify) call errquit
     1  ('tce_create_movecs: corrupted MO vectors',0,RTDB_ERR)
      if (rohf) nmo(2) = nmo(1)
      do i=1,ipol
        g_movecs(i)=ga_create_atom_blocked
     1    (geom,ao_bas_han,'MO eigenvectors')
        if (rohf.and.(i.eq.2)) then
          call ga_copy(g_movecs(1),g_movecs(2))
          do j = 1,nbf
            dbl_mb(k_evl(2)+j-1) = dbl_mb(k_evl(1)+j-1)
            dbl_mb(k_occ(2)+j-1) = dbl_mb(k_occ(1)+j-1)
          enddo
        else
          if (.not.movecs_read(movecs_out,i,
     1      dbl_mb(k_occ(i)),dbl_mb(k_evl(i)),g_movecs(i)))
     2      call errquit('tce_create_movecs: failed to read MO vectors',
     3      0,RTDB_ERR)
        endif
        if (util_print('MO vectors',print_debug)) then
          if (nodezero) call ma_print(dbl_mb(k_evl(i)),
     1      nbf,1,'Eigenvalues')
          if (nodezero) call ma_print(dbl_mb(k_occ(i)),
     1      nbf,1,'Occupancies')
          call ga_print(g_movecs(i))
        endif
      enddo
      if (reference.eq.0) then
        if (.not.rtdb_get(rtdb,'dft:alpha irreps',mt_int,
     1    nbf,int_mb(k_irs(1))))
     2    call errquit('tce_create_movecs: no alpha irreps found',0,
     3    RTDB_ERR)
      else if (reference.eq.1) then
        if (.not.rtdb_get(rtdb,'scf:alpha irreps',mt_int,
     1    nbf,int_mb(k_irs(1))))
     2    call errquit('tce_create_movecs: no alpha irreps found',1,
     3    RTDB_ERR)
      endif
      do i=1,nbf
        if (oadapt) then
          int_mb(k_irs(1)+i-1) = int_mb(k_irs(1)+i-1) - 1
        else
          int_mb(k_irs(1)+i-1) = 0
        endif
      enddo
      if (ipol.eq.2) then
        if (reference.eq.0) then
          if (.not.rtdb_get(rtdb,'dft:beta irreps',mt_int,
     1      nbf,int_mb(k_irs(2))))
     2      call errquit('tce_create_movecs: no beta irreps found',0,
     3      RTDB_ERR)
        else if (reference.eq.1) then
          if (rohf) then
            do j = 1,nbf
              int_mb(k_irs(2)+j-1) = int_mb(k_irs(1)+j-1) + 1
            enddo
          else
            if (.not.rtdb_get(rtdb,'scf:beta irreps',mt_int,
     1        nbf,int_mb(k_irs(2))))
     2        call errquit('tce_create_movecs: no beta irreps found',1,
     3        RTDB_ERR)
          endif
        endif
        do i=1,nbf
          if (oadapt) then
            int_mb(k_irs(2)+i-1) = int_mb(k_irs(2)+i-1) - 1
          else
            int_mb(k_irs(2)+i-1) = 0
          endif
        enddo
      endif
      if (nodezero) call util_flush(LuOut)
c
c     ------
c     Return
c     ------
c
      return
      end

      integer function argos_pme_synop(idat,jdat,iteml,nitems)
c
      integer idat,jdat,iteml,nitems
c
      idat=0
      jdat=0
      argos_pme_synop=0
c
      return
      end
c $Id: argos_pme_synop.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup selci
C> @{
      subroutine selci_mkindx(ioconf,indxci,ncinew,nnsmax)
*
* $Id: mkindx.F 24790 2013-11-11 18:56:49Z d3y133 $
*
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
c
      dimension ioconf(nintpo,noconf), indxci(noconf+1)
c
      dimension iocc(255)
#include "bitops.fh"
c
      ncinew = 0
      nnsmax = 0
      do 10 iconf = 1,noconf
         call selci_upkcon(norbs, iocc, ioconf(1,iconf), nintpo, nbitpi)
         is = 0
         ns = 0
c$doit asis
         do 20 j = 1,norbs
            if (iocc(j).eq.1) then
               is = ieor(is,isym(j))
               ns = ns + 1
            endif
 20      continue
         if (is.ne.issss) then
            call selci_wrtcon(ifllog, iocc, norbs)
            call errquit(' mkindx: bad symmetry ',is, INPUT_ERR)
         endif
         if (mod(ns,2).ne.mod(multi-1,2) .or. ns.lt.multi-1) then
            call selci_wrtcon(ifllog, iocc, norbs)
            call errquit(' mkindx: a reference has invalid ns',i,
     &       INPUT_ERR)
         endif
         nnsmax = max(ns,nnsmax)
         if (nnsmax.gt.nsmax) then
            call selci_wrtcon(ifllog, iocc, norbs)
            call errquit('mkindx: wmatrx nsmax small, need:',nnsmax,
     &       INPUT_ERR)
         endif
         indxci(iconf) = ncinew
         ncinew = ncinew + nf(ns)
 10   continue
      indxci(noconf+1) = ncinew
c
      end
C> @}

      subroutine super(x,ix,nx,mx,y,w,sdev,ny,my,mod,rms0,rms1)
c
c $Id: super.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     superimpose x(1:n,1:3) onto y(1:n,1:3)
c
      implicit none
c
#include "msgids.fh"
#include "global.fh"
c
      real*8 zero
      parameter(zero=0.0d0)
c
      integer nx,mx,ny,my
      integer ix(mx)
      real*8 x(mx,3),y(my,3),w(my),sdev(my),rms0,rms1
      logical mod
c
      integer i,j,k,nr
      real*8 u(3,3),c(4,4),q(4),b(4),v(4,4),wnorm
      real*8 xt(3),yt(3),sd
c
      wnorm=zero
      do 1 j=1,3
      xt(j)=zero
      yt(j)=zero
    1 continue
      do 2 k=1,nx
      do 3 j=1,3
      xt(j)=xt(j)+w(ix(k))*x(k,j)
    3 continue
    2 continue
      call ga_dgop(mag_d08,xt,3,'+')
      do 4 k=1,ny
      wnorm=wnorm+w(k)
      do 5 j=1,3
      yt(j)=yt(j)+w(k)*y(k,j)
    5 continue
    4 continue
c
      rms0=zero
      do 6 j=1,3
      xt(j)=xt(j)/wnorm
      yt(j)=yt(j)/wnorm
      do 7 k=1,nx
      rms0=rms0+w(ix(k))*(x(k,j)-xt(j)-y(ix(k),j)+yt(j))**2
    7 continue
    6 continue
      call ga_dgop(mag_d09,rms0,1,'+')
      rms0=sqrt(rms0/wnorm)
c
      do 8 i=1,3
      do 9 j=1,3
      u(i,j)=zero
      do 10 k=1,nx
      u(i,j)=u(i,j)+w(ix(k))*(x(k,i)-xt(i))*(y(ix(k),j)-yt(j))
   10 continue
    9 continue
    8 continue
      call ga_dgop(mag_d10,u,9,'+')
c
      c(1,1)=u(1,1)+u(2,2)+u(3,3)
      c(1,2)=u(3,2)-u(2,3)
      c(1,3)=u(1,3)-u(3,1)
      c(1,4)=u(2,1)-u(1,2)
      c(2,2)=u(1,1)-u(2,2)-u(3,3)
      c(2,3)=u(1,2)+u(2,1)
      c(2,4)=u(3,1)+u(1,3)
      c(3,3)=u(2,2)-u(3,3)-u(1,1)
      c(3,4)=u(2,3)+u(3,2)
      c(4,4)=u(3,3)-u(1,1)-u(2,2)
c
      do 11 j=1,3
      do 12 i=j+1,4
      c(i,j)=c(j,i)
   12 continue
   11 continue
c
      call jacobi(c,4,4,b,v,nr)
c
      do 13 i=1,4
      q(i)=v(i,4)
   13 continue
c
      u(1,1)=q(1)*q(1)+q(2)*q(2)-q(3)*q(3)-q(4)*q(4)
      u(1,2)=2.0d0*(q(3)*q(2)+q(1)*q(4))
      u(1,3)=2.0d0*(q(4)*q(2)-q(1)*q(3))
      u(2,1)=2.0d0*(q(2)*q(3)-q(1)*q(4))
      u(2,2)=q(1)*q(1)-q(2)*q(2)+q(3)*q(3)-q(4)*q(4)
      u(2,3)=2.0d0*(q(4)*q(3)+q(1)*q(2))
      u(3,1)=2.0d0*(q(2)*q(4)+q(1)*q(3))
      u(3,2)=2.0d0*(q(3)*q(4)-q(1)*q(2))
      u(3,3)=q(1)*q(1)-q(2)*q(2)-q(3)*q(3)+q(4)*q(4)
c
      rms1=zero
      do 14 k=1,nx
      do 15 i=1,3
      q(i)=0.0d0
      do 16 j=1,3
      q(i)=q(i)+u(i,j)*(x(k,j)-xt(j))
   16 continue
   15 continue
      if(mod) then
      do 17 i=1,3
      x(k,i)=q(i)+yt(i)
   17 continue
      endif
      sd=0.0d0
      do 18 j=1,3
      sd=sd+(q(j)-y(ix(k),j)+yt(j))**2
   18 continue
      sd=w(ix(k))*sd
      sdev(ix(k))=sdev(ix(k))+sd
      rms1=rms1+sd
   14 continue
      call ga_dgop(mag_d11,rms1,1,'+')
      rms1=sqrt(rms1/wnorm)
c
      return
      end
c
      subroutine jacobi(a,n,na,d,v,nrot)
c
c     compute eigenvectors and eigenvalues for real symmetric 
c     matrix using the Jacobi diagonalization
c
      implicit none
c
      integer nmax,nrmax
      parameter(nmax=100)
      parameter(nrmax=100)
c
      real*8 zero,half,one,two
      parameter(zero=0.0d0)
      parameter(half=0.5d0)
      parameter(one=1.0d0)
      parameter(two=2.0d0)
c
      integer n,na,nrot
      real*8 a(na,na),d(na),v(na,na)
      real*8 at,b,dma,q
c
      integer i,j,k,l
      real*8 c,s,t,sum,temp
c
      do 1 i=1,n
      do 2 j=1,n
      v(i,j)=zero
    2 continue
      v(i,i)=one
      d(i)=a(i,i)
    1 continue
c
      nrot=0
      do 3 l=1,nrmax
      sum=zero
      do 4 i=1,n-1
      do 5 j=i+1,n
      sum=sum+abs(a(i,j))
    5 continue
    4 continue
      if(sum.eq.zero) then
      do 6 i=1,n-1
      do 7 j=i+1,n
      if(d(i).gt.d(j)) then
      temp=d(i)
      d(i)=d(j)
      d(j)=temp
      do 8 k=1,n
      temp=v(k,i)
      v(k,i)=v(k,j)
      v(k,j)=temp
    8 continue
      endif
    7 continue
    6 continue
      return
      endif
      do 9 j=2,n
      do 10 i=1,j-1
      b=a(i,j)
      if(abs(b).gt.zero) then
      dma=d(j)-d(i)
      if(abs(dma)+abs(b).le.abs(dma)) then
      t=b/dma
      else
      q=half*dma/b
      t=sign(one/(abs(q)+sqrt(one+q*q)),q)
      endif
      c=one/sqrt(t*t+one)
      s=t*c
      a(i,j)=zero
      do 11 k=1,i-1
      at=c*a(k,i)-s*a(k,j)
      a(k,j)=s*a(k,i)+c*a(k,j)
      a(k,i)=at
   11 continue
      do 12 k=i+1,j-1
      at=c*a(i,k)-s*a(k,j)
      a(k,j)=s*a(i,k)+c*a(k,j)
      a(i,k)=at
   12 continue
      do 13 k=j+1,n
      at=c*a(i,k)-s*a(j,k)
      a(j,k)=s*a(i,k)+c*a(j,k)
      a(i,k)=at
   13 continue
      do 14 k=1,n
      at=c*v(k,i)-s*v(k,j)
      v(k,j)=s*v(k,i)+c*v(k,j)
      v(k,i)=at
   14 continue
      at=c*c*d(i)+s*s*d(j)-two*c*s*b
      d(j)=s*s*d(i)+c*c*d(j)+two*c*s*b
      d(i)=at
      endif
   10 continue
    9 continue
    3 continue
c
      stop 'jacobi: maximum iterations reached'
c
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c   subroutine dosymops applies symops to the assymetric unit atoms
c      input to it, outputs a list of unique atoms defining the 
c      molecule, surface or crystal. it also sorts them by name
c
c                                       3/1/94 A.C. Hess
c
c
c   some variables:
c       coords = input coordinates of atoms in assymetric unit
c        nata = number of atoms in assymtric unit
c       coord = full coordinate list of all atoms
c         nat = total number of atoms
c      ipcord = pointer before the first empty spot in coord
c        xnew = array holds atoms generated for a given assym atoms 
c               for the list of entire list of symops, 4th colum is
c               used in an in place comparison of atoms to determine
c               uniqueness
c iasym_order = keeps track of where the original assymetric unit
c               atoms are in the final (full) coordinate list.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine dosymops(symops,nops,coords,tags,nata,itype,
     &     tags_new,coords_new,nareal,nat,cdist,cang,iasym_order,
     $     charge, charge_new, mass, mass_new, 
     $     invnucexp, invnucexp_new, threquiv)
C$Id: dosymops.F 19708 2010-10-29 18:04:21Z d3y133 $
*rak typed everyting
      implicit none
#include "util.fh"
c
c has to be a .F file since print_debug is in the include definition and
c with the implicit real*8 it was of type real not integer
#include "errquit.fh"
c
      double precision tol, threquiv
      integer maxops, iodat
      parameter (maxops=192,iodat=11)
c
      integer nata, nat
      integer nops, itype, nareal
      character*16 tags(nata),tags_new(nat)
      double precision symops(maxops*3,4),coords_new(3,nat),
     &    xnew(maxops,4),
     &    coords(3,nata),cdist(3),cang(3)
      integer iasym_order(nata)
      logical oprint
      double precision charge(*), charge_new(*), mass(*),
     $     mass_new(*), invnucexp(*), invnucexp_new(*)
c
      integer i, j, k, l, ii, ll, nata_old,
     &    ipcord, ipt, nauniq, iopnum, im, iop
      double precision sum, dx, dy, dz, x, y, z 
c
c     set tolerance
c
      tol = threquiv
      nata_old = nata
c
c     Modified below (RJH) so that can send in a list with symmetry
c     equivalent atoms and not generate redundant ones and also
c     identify the unique ones correctly
c
c--> application of symops to atoms in assym. unit
c-->
c--> outer loops go: 1)over all atoms, 2) over the number of symops
c--> 3) mult. current symop times current atom coordinates. Done for
c--> all symops for a given atom, 4) the list is then sorted, and the
c--> unique atoms added to the master list.
c
c--> if its a fractional system move all atoms into cell before application
c--> of symops. still no 1-d systems
c
c bulk
      oprint = util_print('dosymops',print_debug)
c
      if(itype.eq.3) then
        do 900 i=1,nata
          do 910 j=1,3
 2000       if(coords(j,i).lt.(0.0d+00)) then
              coords(j,i)=coords(j,i)+1.0d+00
              goto 2000
            elseif (coords(j,i).ge.1.0d+00) then
              coords(j,i)=coords(j,i)-1.0d+00
              goto 2000
            endif
            if(dabs(coords(j,i)) .lt. 1.0d-10) then
              coords(j,i) = 0.0d+00
            endif
            if(dabs(dabs(coords(j,i))-1.0d+00) .lt. 1.0d-10) then
              coords(j,i) = 0.0d+00
            endif
  910     continue
  900   continue
c surfaces
      elseif(itype.eq.2) then
         do 902 i=1,nata
            do 912 j=1,2
 2002          if(coords(j,i).lt.0.0d+00) then
                  coords(j,i)=coords(j,i)+1.0d+00
                  goto 2002
               elseif (coords(j,i).ge.1.0d+00) then
                  coords(j,i)=coords(j,i)-1.0d+00
                  goto 2002
               endif
               if(dabs(coords(j,i)) .lt. 1.0d-10) then
                 coords(j,i) = 0.0d+00
               endif
               if(dabs(dabs(coords(j,i))-1.0d+00) .lt. 1.0d-10) then
                 coords(j,i) = 0.0d+00
               endif
 912        continue
 902     continue
c         
      elseif(itype.eq.1) then
         do 904 i=1,nata
            j = 3
 2004          if(coords(j,i).lt.0.0d+00) then
                  coords(j,i)=coords(j,i)+1.0d+00
                  goto 2004
               elseif (coords(j,i).ge.1.0d+00) then
                  coords(j,i)=coords(j,i)-1.0d+00
                  goto 2004
               endif
               if(dabs(coords(j,i)) .lt. 1.0d-10) then
                 coords(j,i) = 0.0d+00
               endif
               if(dabs(dabs(coords(j,i))-1.0d+00) .lt. 1.0d-10) then
                 coords(j,i) = 0.0d+00
               endif
 904     continue
c         
      endif
c
c symops*coordinates
c
      ipcord=0
      nareal=0
      sum=0.0d+00
      ipt=nops+1
      nauniq = 0
c
      do 300 i=1,nata
c
c     Check to see if the atom is already present
c
         do l=1,ipcord
            dx=dabs(coords(1,i)-coords_new(1,l))
            dy=dabs(coords(2,i)-coords_new(2,l))
            dz=dabs(coords(3,i)-coords_new(3,l))
            if(dx+dy+dz.le.3*tol) then
c              If the tags don't match, we are probably in trouble
               if(tags(i) .eq. tags_new(l)) then
                 if (oprint)write(6,*) ' ATOM ',i,' is already present '
                 goto 300
               endif
            endif
         enddo
         if (oprint) write(6,544) 
     $        ' doing atom ',i,coords(1,i),coords(2,i),coords(3,i)
 543     format(a,2i4,3f12.6)
 544     format(a,i4,3f12.6)
         iopnum=0
c
c--> reset flag for atom uniqueness
c
         do 570 im=1,nops
            xnew(im,4)=0.0
570      continue
         do 305 iop=1,nops
            do 310 j=1,3
               iopnum=iopnum+1
               do 320 k=1,3
                  sum=sum+symops(iopnum,k)*coords(k,i)
320            continue
               xnew(iop,j)=sum+symops(iopnum,4)
               sum=0.0d+00
310         continue
            if (oprint) write(6,544) 
     $           ' op ', iop,xnew(iop,1),xnew(iop,2),xnew(iop,3)
c
c--> shift it into the home cell. This operation depends on sysytem type
c--> in place for 3-d,2-d and molecules now.
c
            if(itype.eq.3) then ! bulk
 3000         do 380 ii=1,3
                if(dabs(xnew(iop,ii)).lt.1.0d-10) then
                  xnew(iop,ii)=0.0d0
                endif
                if(dabs((dabs(xnew(iop,ii))-1.0d0)).lt.1.0d-10) then
                   xnew(iop,ii)=0.0d0
                endif
                if(xnew(iop,ii).lt.(0.0d0)) then
                  xnew(iop,ii)=xnew(iop,ii)+1.0d0
                  goto 3000
                elseif (xnew(iop,ii).ge.1.0d0) then
                  xnew(iop,ii)=xnew(iop,ii)-1.0d0
                  goto 3000
                endif
  380         continue
            elseif(itype.eq.2) then ! surfaces
 3020         do 382 ii=1,2
                if(dabs(xnew(iop,ii)).lt.1.0d-10) then
                  xnew(iop,ii)=0.0d0
                endif
                if(dabs((dabs(xnew(iop,ii))-1.0d0)).lt.1.0d-10) then
                   xnew(iop,ii)=0.0d0
                endif
                if(xnew(iop,ii).lt.0.0d0) then
                  xnew(iop,ii)=xnew(iop,ii)+1.0d0
                  goto 3020
                elseif (xnew(iop,ii).ge.1.0d0) then
                  xnew(iop,ii)=xnew(iop,ii)-1.0d0
                  goto 3020
                endif
 382         continue
            endif
  305     continue
c
c--> place this assym. atom into final coord list
c
         ipcord=ipcord + 1
         nauniq = nauniq + 1
         nareal = nareal + 1
         do 330 ll=1,3
            coords_new(ll,ipcord)=coords(ll,i)
330      continue
         tags_new(ipcord)=tags(i)
         charge_new(ipcord)=charge(i)
         invnucexp_new(ipcord)=invnucexp(i)
         mass_new(ipcord)=mass(i)
         iasym_order(nauniq)=ipcord
*
*rak: changed K -> i  was that right?
*
         if (oprint) write(6,543) ' keepingX ', ipcord,nareal,
     $        xnew(i,1),xnew(i,2),xnew(i,3)
c
c--> remove copies of the assymetric atom from the xnew list
c
         x=coords(1,i)
         y=coords(2,i)
         z=coords(3,i)
         if (oprint) write(6,544) ' comparing ', i, x,y,x
         do 390 l=1,nops
               dx=dabs(x-xnew(l,1))
               dy=dabs(y-xnew(l,2))
               dz=dabs(z-xnew(l,3))
               if (oprint) write(6,544)
     $              '    with ',l,xnew(l,1),xnew(l,2),xnew(l,3)
               if (oprint) write(6,544)
     $              '    diff ',l,dx,dy,dz
               if(dx.le.tol.and.dy.le.tol.and.dz.le.tol) then
                  xnew(l,4)=1.0d0
               endif
390      continue
c
c--> sift the xnew list for unique atoms
c
         do 400 k=1,nops
            if(xnew(k,4).ne.1.0d0) then
               x=xnew(k,1)
               y=xnew(k,2)
               z=xnew(k,3)
               do 410 l=k+1,nops
                  dx=dabs(x-xnew(l,1))
                  dy=dabs(y-xnew(l,2))
                  dz=dabs(z-xnew(l,3))
                  if(dx.le.tol.and.dy.le.tol.and.dz.le.tol) then
                     if (oprint) write(6,*) ' KEEP IT',l
                     xnew(l,4)=1.0d0
                  endif
410            continue
            endif
400      continue
c
c--> put the new unique atoms into the final list, keeping track of 
c--> what kind they are.
c
         do 420 k=1,nops
            if(xnew(k,4).ne.1.0d0) then
               ipcord=ipcord+1
               nareal=nareal+1
               do 430 ll=1,3
                  coords_new(ll,ipcord)=xnew(k,ll)
430            continue
               if (oprint) write(6,543) ' keeping ', ipcord,nareal,
     $              xnew(k,1),xnew(k,2),xnew(k,3)
               tags_new(ipcord)=tags(i)
               charge_new(ipcord)=charge(i)
               invnucexp_new(ipcord)=invnucexp(i)
               mass_new(ipcord)=mass(i)
            endif
420      continue
300   continue
c
      nata = nauniq
      if (oprint) then 
         write(*,25) nareal
         do 510 i=1,nareal
            write(*,2122) i,tags_new(i),(coords_new(j,i),j=1,3),
     $           charge_new(i)
 510     continue
 2122    format(i5,2x,a16,2x,3f12.6,2x,f10.2)
      endif
*
*     RJH.  If the user input all of the atoms don't want
*     to reorder them since it may break zmatrix/autoz
*
      if (itype.eq.0 .and. nareal.eq.nata_old) then
c
c     Map unique atoms back into old ordering
c
         do ii = 1, nauniq
            i = iasym_order(ii)
            do j = 1, nareal
               dx = abs(coords_new(1,i) - coords(1,j))
               dy = abs(coords_new(2,i) - coords(2,j))
               dz = abs(coords_new(3,i) - coords(3,j))
               if(dx.le.tol.and.dy.le.tol.and.dz.le.tol) then
                  iasym_order(ii) = j
                  goto 9876
               endif
            enddo
            call errquit('dosymops: failed matching uniq',i, INPUT_ERR)
 9876       continue
         enddo
         do i = 1, nareal
            tags_new(i) = tags(i)
         enddo
         call dcopy(nareal, charge, 1, charge_new, 1)
         call dcopy(nareal, invnucexp, 1, invnucexp_new, 1)
         call dcopy(nareal, mass, 1, mass_new, 1)
         call dcopy(nareal*3, coords, 1, coords_new, 1)
      endif
c     
c
c--> write stuff out
c
c--> coordinate output stuff
c
c     if(itype.ne.0) then
c        write(*,13)
c        if(itype.eq.3) then
c           write(*,28) 
c           write(*,29)
c        elseif(itype.eq.2) then
c           write(*,32)
c           write(*,31)
c        elseif(itype.eq.1) then
c           write(*,33)
c           write(*,34)
c        endif
c        write(*,14)
c        call wrcell(cdist,cang,itype)
c     
c--   > list of atoms in assymetric unit
c     
c        write(*,10) nata
c        do 500 i=1,nata
c           write(*,20) i,tags(i),(coords(j,i),j=1,3)
c500     continue
c
c--> list of total number of atoms unit cell of the solid
c
c        write(*,25) nareal
c        do 510 i=1,nareal
c           write(*,20) i,tags_new(i),(coord(j,i),j=1,3)
c510     continue
c     endif
c
10    format(/,22x,i5,6x,'SYMMETRY DISTINCT ATOMS',/)
13    format(///,'--------------------- PERIODIC SYSTEM GEOMETRY INFORMA
     $TION',' -------------------',/)
 14   format(/,'------------------------------------------------------',
     &'-----------------------',/)
 20   format(10x,i5,2x,a16,3f14.8)
 25   format(//,22x,i5,6x,'ATOMS IN UNIT CELL',/)
 28   format(28X,'SYSTEM TYPE = BULK CRYSTAL',/)
 29   format(25x,' FRACTIONAL ATOMIC COORDINATES ')
 30   format(/,15x,'-------------- ATOMIC COORDINATES --------------',/)
 31   format(6x,'FRACTIONAL & CARTESIAN COORDINATES: Z-COMPONENT UNITS =
     $ANGSTROMS')
 32   format(29x,'SYSTEM TYPE = SURFACE',/)
 33   format(29x,'SYSTEM TYPE = POLYMER',/)
 34   format(5x,'FRACTIONAL & CARTESIAN COORDINATES: XY-COMPONENTS IN UN
     $ITS = ANGSTROMS')
c
      if (oprint) call util_flush(6)
      end

*
* $Id: stpr_gen_aux.F 25564 2014-05-03 07:06:49Z d3y133 $
* 
* this file contains auxilary routines to stpr_gen functions
*
* current routines: 
* stpr_fd_upd_dipole           ! computes finite difference dipole moment
* stpr_fd_upd_hess             ! computes finite difference either central or forward
* stpr_wrt_fd_from_sq          ! writes hessian to file
* stpr_check_genat_restart     ! check for restart "is info available?"
* stpr_get_genat_restart       ! get restart info
* stpr_put_genat_restart       ! put restart info out to restart file
* stpr_gen_hess_foldave        ! averages off diaginal contributions
* stpr_gen_hess_fold           ! sums off diaginal contributions (partial computations)
* stpr_gen_set_diag            ! sets inactive atom diagonal contribs to large value
*
c
C> \ingroup stpr_priv
C> @{
C>
      subroutine stpr_fd_upd_dipole(ddipole,mdipole,pdipole,
     &    s_delta,delta,nat,iatom,ixyz,q1)
      implicit none
c
c::passed
      integer nat
      integer iatom
      integer ixyz
      double precision s_delta
      double precision delta
      double precision mdipole(3)
      double precision pdipole(3)
      double precision ddipole(3,3,nat)
      double precision q1
c:local
      integer moment
      double precision rdelta
      double precision value
c
      rdelta = 1.0d00/(s_delta*delta)
      do moment = 1,3
        value = rdelta*(pdipole(moment)-mdipole(moment)) * q1
        ddipole(moment,ixyz,iatom) = value
      enddo
c
      end
C>
C> \brief Update the Hessian from new gradient data
C>
C> Apply the finite difference formula to the gradient data provided
C> to calculate a contribution to and update the Hessian.
C>
C> Depending on the values of the parameters `gradm`, `gradp` and
C> `s_delta` the subroutine will evaluate either the forward difference
C> equation
C> \f{eqnarray*}{
C>    f'(x) &=& \frac{f(x+h)-f(x)}{h}
C> \f}
C> or the central difference formula
C> \f{eqnarray*}{
C>    f'(x) &=& \frac{f(x+h)-f(x-h)}{2h}
C> \f}
C>
      subroutine stpr_fd_upd_hess(rtdb,
     &    hess,gradm,gradp,s_delta,delta,nat,
     &    iatom_t,ixyz_t)
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "geom.fh"
#include "sym.fh"
c::passed
      integer rtdb                       !< [Input] The RTDB handle
      integer nat                        !< [Input] The number of atoms
      integer iatom_t                    !< [Input] The displaced atom
      integer ixyz_t                     !< [Input] The displaced coordinate
      double precision hess(3,nat,3,nat) !< [In/Output] The Hessian
      double precision gradm(3,nat)      !< [Input] The gradient at 
                                         !< negative (or no) displacement
      double precision gradp(3,nat)      !< [Input] The gradient at 
                                         !< positive displacement
      double precision delta             !< [Input] The step size
      double precision s_delta           !< [Input] The scale factor
                                         !< for total displacement
                                         !< * 1 - for forward difference
                                         !< * 2 - for central difference
c::local
      integer geom
      integer iatom,ixyz
      double precision rdelta, value
      double precision q2
c
      if (.not.geom_create(geom,'reference')) call errquit
     $    ('stpr_fd_upd_hess:geom_create failed?',1, GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'reference')) call errquit
     $        ('stpr_fd_upd_hess:geom_rtdb_load failed?',2, RTDB_ERR)
c 
c finite difference  [g(x+delta) - g(x-delta)]/(s_delta*delta) (s_delta = 2.0)
c central difference [g(x+delta) - g(x)]/(s_delta*delta) (s_delta = 1.0)
c 
c
      rdelta = 1.0d00/(s_delta*delta)
      do 00100 iatom = 1,iatom_t
        if (sym_atom_pair(geom,iatom_t,iatom,q2)) then
**           write(6,*) ' iatom_t iatom q2 ', iatom_t, iatom, q2
           if (iatom.ne.iatom_t) q2 = q2 + q2
          do 00200 ixyz = 1,3
            value = rdelta*(gradp(ixyz,iatom)-gradm(ixyz,iatom))
            value = q2*value
            hess(ixyz_t,iatom_t,ixyz,iatom) = value
**            hess(ixyz,iatom,ixyz_t,iatom_t) = value
00200     continue
        endif
00100 continue
c
      if (.not.geom_destroy(geom))
     $    call errquit
     $    ('stpr_fd_upd_hess: geom_destroy failed?',33, GEOM_ERR)
      end
      subroutine stpr_wrt_fd_dipole(ddipole,nat,filename)
      implicit none
#include "stdio.fh"
#include "inp.fh"
#include "util.fh"
      integer nat
      double precision ddipole(3,3,nat)
      character*(*) filename
c
      integer lu
      integer print_level
      integer atom, xyz, moment
      logical does_it_exist
c
      call util_print_get_level(print_level)
      lu = 67 
      does_it_exist = .false.
      inquire(file=filename,exist=does_it_exist)
      if ((does_it_exist).and.(print_level.gt.print_none))
     &    write(luout,*)
     &    'stpr_wrt_fd_dipole: overwrite of existing file',
     &    filename(1:inp_strlen(filename))
      open(unit=lu,file=filename,
     &    form='formatted',
     &    access='sequential',
     &    status='unknown')
c
      do atom = 1,nat
        do  xyz = 1,3
          do moment = 1,3
            write(lu,10000)ddipole(moment,xyz,atom)
          enddo
        enddo
      enddo
c
10000 format(1x,1pd20.10)
c
      close(unit=lu,status='keep')
c
      end
      subroutine stpr_wrt_fd_from_sq(hess,rank_hess,filename)
      implicit none
c
#include "stdio.fh"
#include "inp.fh"
#include "util.fh"
c
      integer rank_hess
      double precision hess(rank_hess,rank_hess)
      character*(*) filename
c
      logical does_it_exist
c
      integer i, j, lu
      integer print_level
c
      call util_print_get_level(print_level)
      lu = 66
      does_it_exist = .false.
      inquire(file=filename,exist=does_it_exist)
      if ((does_it_exist).and.(print_level.gt.print_none))
     &    write(luout,*)
     &    ' stpr_wrt_fd_from_sq: overwrite of existing file:',
     &    filename(1:inp_strlen(filename))
      open(unit=lu,file=filename,
     &    form='formatted',
     &    access='sequential',
     &    status='unknown')
c
      do 00100 i = 1,rank_hess
        do 00200 j = 1,i
          write(lu,10000)hess(i,j)
00200   continue
00100 continue
c
10000 format(1x,1pd20.10)
c
      close(unit=lu,status='keep')
c
      end
C>
C> \brief Check and retrieve restart data
C>
C> Check the runtime database for the state of the calculation
C> and report back whether this calculation needs to be restarted
C> or not. The function also provides the rank of the initial
C> atom and atomic coordinate to start from.
C>
C> The initial atom and atomic coordinate are read from the
C> restart file. For this purpose the function may open the restart
C> file if available. But the restart file must be closed before
C> the function returns.
C>
C> \return Returns .TRUE. if the calculation needs to be restarted,
C> and .FALSE. otherwise.
C>
      logical function stpr_check_genat_restart(
     &    rtdb, iatom_start,ixyz_start)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "msgids.fh"
#include "stdio.fh"
#include "cstprfiles.fh"
      integer rtdb        !< [Input] The RTDB handle
      integer iatom_start !< [Output] The atom to start from
      integer ixyz_start  !< [Output] The atomic coordinate to start
                          !< from
c
      integer int_restart
      integer rank, ijunk1, ijunk2
      logical does_it_exist
c
      logical ostart, orestart, ocontinue
c
c assume not a restart
      iatom_start = 1
      ixyz_start  = 1
      int_restart = 0
      call util_get_rtdb_state(rtdb,ostart,ocontinue,orestart)
      if (ostart) then
        if (ga_nodeid().eq.0)
     &    call util_file_unlink(FILEATR)
      else if (ocontinue.or.orestart) then
        if (ga_nodeid().eq.0) then
          does_it_exist = .false.
          inquire(file=FILEATR,exist=does_it_exist)
          if (does_it_exist) then
            open(unit=69,file=FILEATR,
     &          form='unformatted',
     &          access='sequential',
     &          status='old')
            read(69)iatom_start,ixyz_start,rank, ijunk1, ijunk2
            close(unit=69,status='keep')
            int_restart = 1
          else
            write(luout,*)'*** Warning continue called for but no  ***'
            write(luout,*)'*** fd restart file for nuclear hessian ***'
            write(luout,*)'*** starting from scratch so to speak   ***'
          endif
        endif
      else
        call errquit
     &      ('stpr_check_genat_restart: error with rtdb state',911,
     &       RTDB_ERR)
      endif
c
      call ga_brdcst(Msg_gen_at_iatom  +MSGINT,iatom_start,mitob(1),0)
      call ga_brdcst(Msg_gen_at_ixyz   +MSGINT,ixyz_start, mitob(1),0)
      call ga_brdcst(Msg_gen_at_restart+MSGINT,int_restart,mitob(1),0)
c
      if (int_restart.eq.1) then
        stpr_check_genat_restart = .true.
      else if (int_restart.eq.0) then
        stpr_check_genat_restart = .false.
      else
        write(luout,*)' invalid int_restart value ', ga_nodeid()
        call errquit(' stpr_check_genat_restart: fatal error ',
     &      int_restart, INPUT_ERR)
      endif
      end
C>
C> \brief Load the restart information
C>
C> Load the data needed for restarting a Hessian calculation. 
C>
C> Obviously the restart data is read from the restart file. Hence,
C> this subroutine must open the restart file, but the restart file
C> must be closed before the routine returns.
C>
      subroutine stpr_get_genat_restart(rank_in,hess,grad0,get_grad0,
     &    dipole_okay,ddipole)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "cstprfiles.fh"
      integer rank_in    !< [Input] The dimension of the Hessian
      double precision hess(rank_in,rank_in) !< [Output] The Hessian
      double precision grad0(rank_in)        !< [Output] The gradient
      double precision ddipole(3*rank_in)    !< [Output] The dipole
                                             !< derivative
      logical get_grad0    !< [Input] Should the gradient be loaded
                           !< * `.TRUE.` - load the gradient
                           !< * `.FALSE.` - do not load the gradient
      logical dipole_okay  !< [Output] Is the dipole derivative returned
                           !< * `.TRUE.` - The dipole derivative is 
                           !< returned
                           !< * `.FALSE.` - The dipole derivative is 
                           !< not returned
c
      logical does_it_exist
      integer ijunk1, ijunk2, rank, iflag_grad0
      integer dipole_there
c
      if (ga_nodeid().ne.0) then
        write(luout,*)' non-master node called me ',ga_nodeid()
        call errquit('stpr_get_genat_restart: error ',911, INPUT_ERR)
      endif
c
      inquire(file=FILEATR,exist=does_it_exist)
      if (does_it_exist) then
        open(unit=69,file=FILEATR,
     &      form='unformatted',
     &      access='sequential',
     &      status='old')
        read(69)ijunk1,ijunk2,rank,iflag_grad0,dipole_there
        if (dipole_there.eq.1) then
          dipole_okay = .true.
        else
          dipole_okay = .false.
        endif
        if (rank.ne.rank_in) then
          write(luout,*)'rank not the same as rank_in '
          write(luout,*)' rank    :',rank
          write(luout,*)' rank_in :',rank_in
          close(unit=69,status='keep')
          call errquit('stpr_get_genat_restart: error ',911, INPUT_ERR)
        endif
        if (get_grad0.and.iflag_grad0.ne.1) then
          write(luout,*)' grad 0 not written but requested '
          call errquit(' stpr_get_genat_restart: error',911, INPUT_ERR)
        endif
        if ((.not.get_grad0).and.iflag_grad0.eq.1) then
          write(luout,*)' grad 0 written but not requested '
          call errquit(' stpr_get_genat_restart: error',911, INPUT_ERR)
        endif
        if (get_grad0) read(69) grad0
        read(69) hess
        if (dipole_okay) read(69) ddipole
        if (util_print('debug_stepper_restart',print_debug)
     &      .or.
     &      util_print('debug_stepper',print_debug)) then
          write(6,*)'hessian read from restart file '
          call output(hess,1,rank,1,rank,rank,rank,1)
          call stpr_print_ddipole(ddipole,
     &        'dipole derivative read from restart file',
     &        (rank/3),
     &        1.0d-07)
        endif
        close(unit=69,status='keep')
      else
        write(6,*)' no finite difference hessian restart ',
     &      'information read '
      endif
      end
C>
C> \brief Store the restart data
C>
C> Write the restart data to a file. The restart file is opened and
C> overwritten with new restart data. The restart file must be closed
C> before the subroutine returns.
C>
      subroutine stpr_put_genat_restart(rank,hess,grad0,
     &    iatom_in,ixyz_in,nat,put_grad0,
     &    dipole_okay,ddipole)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "cstprfiles.fh"
      integer rank  !< [Input] The dimension of the Hessian
      integer iatom_in !< [Input] The current atom
      integer ixyz_in  !< [Input] The current atomic coordinate
      integer nat      !< [Input] The number of atoms
      double precision hess(rank,rank) !< [Input] The Hessian
      double precision grad0(rank)     !< [Input] The gradient
      double precision ddipole(3*rank) !< [Input] The dipole derivative
      logical put_grad0    !< [Input] Should the gradient be stored?
      logical dipole_okay  !< [Input] Should the dipole derivative be
                           !< stored?
      logical lopen        !< Is the file open?
c
      integer iatom_start, ixyz_start
      integer iflag_grad0
      integer dipole_there
c
      if (ga_nodeid().ne.0) then
        write(luout,*)' non-master node called me ',ga_nodeid()
        call errquit('stpr_put_genat_restart: error ',911, INPUT_ERR)
      endif
c
      if(iatom_in.eq.nat.and.ixyz_in.eq.3) then
        call util_file_unlink(FILEATR)
        return
      endif
      iatom_start = iatom_in
      ixyz_start  = ixyz_in + 1
      if(ixyz_in.eq.3) then
        iatom_start = iatom_start + 1
        ixyz_start  = 1
      endif
c
      dipole_there = 0
      if (dipole_okay) dipole_there = 1
c
      if (put_grad0) then
        iflag_grad0 = 1
      else
        iflag_grad0 = 0
      endif
c     If unit 69 is not closed then the OPEN statement will be ignored
c     in which case the restart data is appended to the existing file
c     rather than overwriting it.
c     Therefore we force the file to be closed. If it is not then there
c     is a bug somewhere else.
      inquire(unit=69,opened=lopen)
      if (lopen) call errquit("stpr_put_genat_restart: unit 69 should "
     &                      //"be closed at this point",0,UERR)
      open(unit=69,file=FILEATR,
     &    form='unformatted',
     &    access='sequential',
     &    status='unknown')
      write(69)iatom_start,ixyz_start,rank,iflag_grad0,dipole_there
      if (put_grad0) write(69)grad0
      write(69)hess
      if (dipole_okay)write(69) ddipole
      close(unit=69,status='keep')
      if (util_print('debug_stepper_restart',print_debug)
     &    .or.
     &    util_print('debug_stepper',print_debug)) then
        write(6,*)'hessian put to restart file '
        call output(hess,1,rank,1,rank,rank,rank,1)
        call stpr_print_ddipole(ddipole,
     &      'dipole derivative put to restart file',
     &      (rank/3),
     &      1.0d-07)
      endif
      end
      subroutine stpr_gen_hess_foldave(hess,rank_hess)
*! averages off diaginal contributions
      implicit none
      integer rank_hess
      double precision hess(rank_hess,rank_hess)
*
      integer i,j
      double precision dbl_tmp 
*
      do i = 1,rank_hess
        do j = 1,(i-1)
          dbl_tmp   = hess(i,j) + hess(j,i)
          dbl_tmp   = dbl_tmp/2.0d00
          hess(i,j) = dbl_tmp
          hess(j,i) = dbl_tmp
        enddo
      enddo
      end
      subroutine stpr_gen_hess_fold(hess,rank_hess)
*! sums off diaginal contributions assuming a partial computation
      implicit none
#include "util.fh"
      integer rank_hess
      double precision hess(rank_hess,rank_hess)
*
      integer i,j
      double precision dbl_tmp 
      integer icount
      double precision dbl_diff, max_dbl_diff
      logical o_debug
c
      o_debug = util_print('debug_stepper_restart',print_debug)
      o_debug = o_debug .or.
     &    util_print('debug_stepper',print_debug)
      if (o_debug) then
        write(6,*)' hessian before fold operaton'
        call output(hess,1,rank_hess,1,rank_hess,
     &      rank_hess,rank_hess,1)
        icount = 0
        max_dbl_diff = -1.0d00
      endif
*
      do i = 1,rank_hess
        do j = 1,(i-1)
          if (o_debug) then
            dbl_diff = abs(hess(i,j)) - abs(hess(j,i))
            max_dbl_diff = max(max_dbl_diff,dbl_diff)
            icount = icount + 1
            write(6,12345)icount,dbl_diff,max_dbl_diff
          endif
          dbl_tmp   = hess(i,j) + hess(j,i)
          hess(i,j) = dbl_tmp
          hess(j,i) = dbl_tmp
        enddo
      enddo
      if (o_debug) then
        write(6,*)' hessian after fold operaton'
        call output(hess,1,rank_hess,1,rank_hess,
     &      rank_hess,rank_hess,1)
      endif
12345 format('<',i2,'> <diff=',f14.8,'> <diff_max=',f14.8)
      end
      subroutine stpr_gen_set_diag(hess,rank_hess)
*! sets diag to default value for stiff frequency analysis
*! e.g., active atom computation
      implicit none
#include "util.fh"
      integer rank_hess
      double precision hess(rank_hess,rank_hess)
*
      integer i
      double precision dbl_tmp 
      logical o_debug
      o_debug = util_print('debug_stepper_restart',print_debug)
      o_debug = o_debug .or.
     &    util_print('debug_stepper',print_debug)
      if (o_debug) then
        write(6,*)' hessian before diag set operaton'
        call output(hess,1,rank_hess,1,rank_hess,
     &      rank_hess,rank_hess,1)
      endif
*
      dbl_tmp = 1.0d00
      do i = 1,rank_hess
        if (hess(i,i).eq.0.0d00) hess(i,i) = dbl_tmp
      enddo
      if (o_debug) then
        write(6,*)' hessian after diag set operaton'
        call output(hess,1,rank_hess,1,rank_hess,
     &      rank_hess,rank_hess,1)
      endif
      end
      subroutine stpr_print_ddipole(ddipole,msg,nat,thresh)
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "inp.fh"
      integer nat
      double precision ddipole(3,3,nat)
      double precision thresh
      character*(*) msg
      character*1 cname(3)
      character*1 kapname
c
      double precision val
      integer moment
      integer xyz, atom
c
      cname(1) = 'x'
      cname(2) = 'y'
      cname(3) = 'z'
c
      write(luout,'(/a/)') msg(1:inp_strlen(msg))
      write(luout,*)' '
      do moment = 1,3 
        kapname = cname(moment)
        call inp_ucase(kapname)
        write(luout,*)' '
        write(luout,10001) kapname
        do atom = 1,nat
          do xyz = 1,3
            if (moment.ge.1.and.moment.le.3) then
              val = ddipole(moment,xyz,atom)
*
* from A Physicists Desk Reference, The Second Edition of Physics Vade Mecum
*      Herbert L. Anderson, Editor in Chief
*      Copyright (C) 1989 American Institute of Physics
*      335 East 45th Street, New York, NY 10017
*
*1 debye = 10**(-18) esu cm * [1 e/4.8032068 x 10**(-10) esu]*[1 m /100cm]*[a0/5.29177249 x 10**(-11) m]
*1 debye = (1.0/4.8032068/5.29177249) * 10**(-18 + 10 - 2 + 11) e a0
*1 debye = (1.0/4.8032068/5.29177249) * 10**(1) e a0
*1 e a0  = (4.8032068*5.29177249) * 10**(-1) debye
*1 e a0  = 25.417477608 * 10**(-1) debye
*1 e a0  = 2.5417477608 debye
*
*use 1 e a0 = 2.541 7478 debye
*
              val = val*2.5417478d00
              val = val/0.529177249d00  ! bohr->angstrom matches current geom data
              if (abs(val).gt.thresh) then
                write(luout,10002)
     &              cname(moment),atom,cname(xyz),
     &              ddipole(moment,xyz,atom),val
              endif
            else
              write(luout,10000)moment
              call errquit('stpr_print_ddipole: fatal error',911,
     &       UNKNOWN_ERR)
            endif
          enddo
        enddo
      enddo
      write(luout,*)' '
      write(luout,*)' '
10000 format('invalid moment value',i10)
10001 format(1x,a1,1x,
     &    'vector of derivative dipole (au) [debye/angstrom]')
10002 format(1x,'d_dipole_',a1,'/<atom=',i4,',',a1,'> = ',
     &    f10.4,5x,'[',f10.4,']')
      end
C>
C> @}

      SUBROUTINE ccsdt_lr_alpha2_9_13(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdt_lr_alpha2_9_13.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p11 p12 h14 h15 )_ytratrb + = 1/12 * Sum ( h2 h13 h4 p6 ) * trb ( p6 p11 p12 h2 h4 h13 )_trb * i2 ( h2 h4 h13 h14 h15 p6 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p11b
      INTEGER p12b
      INTEGER h14b
      INTEGER h15b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER h2b
      INTEGER h4b
      INTEGER h13b
      INTEGER p11b_1
      INTEGER p12b_1
      INTEGER p6b_1
      INTEGER h2b_1
      INTEGER h4b_1
      INTEGER h13b_1
      INTEGER h2b_2
      INTEGER h4b_2
      INTEGER h13b_2
      INTEGER h14b_2
      INTEGER h15b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p11b = noab+1,noab+nvab
      DO p12b = p11b,noab+nvab
      DO h14b = 1,noab
      DO h15b = h14b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p11b-1)+int_mb(k_spin+p12b
     &-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h15b-1).ne.8)) THEN
      IF (int_mb(k_spin+p11b-1)+int_mb(k_spin+p12b-1) .eq. int_mb(k_spin
     &+h14b-1)+int_mb(k_spin+h15b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_m
     &b(k_sym+h14b-1),int_mb(k_sym+h15b-1)))) .eq. ieor(irrep_y,ieor(irr
     &ep_tra,irrep_trb))) THEN
      dimc = int_mb(k_range+p11b-1) * int_mb(k_range+p12b-1) * int_mb(k_
     &range+h14b-1) * int_mb(k_range+h15b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_13',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      DO h2b = 1,noab
      DO h4b = h2b,noab
      DO h13b = h4b,noab
      IF (int_mb(k_spin+p11b-1)+int_mb(k_spin+p12b-1)+int_mb(k_spin+p6b-
     &1) .eq. int_mb(k_spin+h2b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+h1
     &3b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_m
     &b(k_sym+p6b-1),ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h4b-1),i
     &nt_mb(k_sym+h13b-1)))))) .eq. irrep_trb) THEN
      CALL TCE_RESTRICTED_6(p11b,p12b,p6b,h2b,h4b,h13b,p11b_1,p12b_1,p6b
     &_1,h2b_1,h4b_1,h13b_1)
      CALL TCE_RESTRICTED_6(h2b,h4b,h13b,h14b,h15b,p6b,h2b_2,h4b_2,h13b_
     &2,h14b_2,h15b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h4b-1) * int_mb(k_range+h13b-1)
      dima_sort = int_mb(k_range+p11b-1) * int_mb(k_range+p12b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h14b-1) * int_mb(k_range+h15b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_13',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_13',2,MA_ERR)
      IF ((p6b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h4b_1 - 1 + noab * (h2b_1 - 1 + noab * (p12b_1 - n
     &oab - 1 + nvab * (p11b_1 - noab - 1 + nvab * (p6b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+h4b-1),int_mb(k_range+h13b-1),3,2,6,5,4,1,1.0d0)
      END IF
      IF ((p11b .lt. p6b) .and. (p6b .le. p12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h4b_1 - 1 + noab * (h2b_1 - 1 + noab * (p12b_1 - n
     &oab - 1 + nvab * (p6b_1 - noab - 1 + nvab * (p11b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+p12b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+h4b-1),int_mb(k_range+h13b-1),3,1,6,5,4,2,-1.0d0
     &)
      END IF
      IF ((p12b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h4b_1 - 1 + noab * (h2b_1 - 1 + noab * (p6b_1 - no
     &ab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p11b_1 - noab - 1))))
     &)))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p12b-1),int_mb(k_range+p6b-1),int_mb(k_range+h2b-
     &1),int_mb(k_range+h4b-1),int_mb(k_range+h13b-1),2,1,6,5,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha2_9_13',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_9_13',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_13',5,MA_ERR)
      IF ((h15b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h1
     &3b_2 - 1 + noab * (h4b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+h15b-1),int_mb(k_range+p6b-1),5,4,3,2,1,6,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha2_9_13',6,
     &MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h2b .eq. h4b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h4b .eq. h13b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,6.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2))/FACTORIAL(nsubh(3)),dbl_mb(k_a_sort)
     &,dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dim
     &a_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_1
     &3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_1
     &3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_9_13',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h15b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+p12b-1),int_mb(k_range+p11
     &b-1),4,3,2,1,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h15b 
     &- 1 + noab * (h14b - 1 + noab * (p12b - noab - 1 + nvab * (p11b - 
     &noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha2_9_13',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_9_1
     &3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* $Id: fci_sigma.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_sigma(c,s,ecore,h,g,ionel,i1dim,nonemx,
     $     dkl,bij,kblmax)
      implicit none
#include "fciinfo.fh"
c     
c     s = hamiltonian * c (MUST PRESENTLY BE IN DETERMINANTS)
c     
      double precision c(ndets) ! [input] CI vector
      double precision s(ndets) ! [output] H*c
      double precision ecore    ! [input] Nuclear repulsion+frozen core
      double precision h(nacttr)! [input] Modified 1-e integrals
      double precision g(nacttr,nacttr) ! [input] 2-e integrals
      double precision dkl(*), bij(*) ! [scratch] Workspace
      integer i1dim             ! [input] last dimension of ionel
      integer nonemx            ! [input] Max # coupling coeff from onelcc
      integer ionel(5,i1dim)    ! [scratch] workspace to hold coupling coeff
      integer kblmax            ! [input] max size of any intermdediate state
c      
      integer kblock, koff, num1cc, kwalk, kdim, kel,
     $     k, l, kl, kaddr, jdet, idet, nonel
      integer kocc(nactmx), kbase, ksym, kns
      double precision ddot
      integer idamax
      external ddot, idamax
c
      call fci_tstart(8,.false.)
      call dfill(0.0d0,s,1,ndets)
      call dscal(nacttr,2.0d0,h,1)
c     loop thru intermediate states ... process when have all can hold
      kblock = 0
      num1cc = 0
      kwalk  = 1
c
 10   if (kwalk.gt.nwalko) goto 20
      call fci_owalk_info(kwalk,kocc,kns,kbase,kdim,ksym)
      if (kblock+kdim.le.kblmax .and. num1cc+nonemx.le.i1dim) then
         koff = kblock
         call fci_onelcc(kocc,koff,kdim,ksym,
     $        ionel(1,num1cc+1),nonel,nonemx)
c
c     Do the 1-e bit while we know the symmetry of K and real kbase
c
         if (ksym .eq. statesym) then
            do kel = num1cc+1,num1cc+nonel
               k = max(ionel(1,kel),ionel(2,kel))
               l = min(ionel(1,kel),ionel(2,kel))
               kl = iky(k) + l
               idet = ionel(3,kel) + kbase - koff
               jdet = ionel(4,kel)
               s(idet) = s(idet) + h(kl)*c(jdet)*ionel(5,kel)
            enddo
         endif
c
         num1cc = num1cc + nonel
         kwalk = kwalk + 1
         kblock = kblock + kdim
         goto 10
      endif
c
 20   continue
c
      if (kblock .gt. 0) then
c     vector compute required addresses
         do 30 kel = 1,num1cc
            k = max(ionel(1,kel),ionel(2,kel))
            l = min(ionel(1,kel),ionel(2,kel))
            kl = iky(k) + l
            ionel(1,kel) = ionel(3,kel) + (kl - 1)*kblock
 30      continue
c     make dkl
         call dfill(0.0d0,dkl,1,nacttr*kblock)
         do 40 kel = 1,num1cc
            kaddr = ionel(1,kel)
            jdet = ionel(4,kel)
            dkl(kaddr) = dkl(kaddr) + ionel(5,kel) * c(jdet)
 40      continue
c     make bij
         call dgemm('n','n',kblock,nacttr,nacttr,1.0d0,dkl,kblock,
     $        g,nacttr,0.0d0,bij,kblock)
*         call fci_axb(kblock,nacttr,nacttr,dkl,g,bij)
c     add in 2-e sigma component 
         do 50 kel = 1,num1cc
            kaddr = ionel(1,kel)
            idet = ionel(4,kel)
            s(idet) = s(idet) + ionel(5,kel) * bij(kaddr) 
 50      continue
      else if (kwalk.le.nwalko) then
         write(6,*) ' kblock, kdim, kblmax, num1cc, nonemx, i1dim ',
     $        kblock, kdim, kblmax, num1cc, nonemx, i1dim 
         call fci_err('fci_sigma: kblock is zero ', kblock)
      endif
c     goto next kwalk if any left
      kblock = 0
      num1cc = 0
      if (kwalk.le.nwalko) goto 10
c     
      call dscal(ndets,0.5d0,s,1)
      call dscal(nacttr,0.5d0,h,1)
      call daxpy(ndets, ecore, c, 1, s, 1)
c
      call fci_tfinish(8,.false.)
c
      end

      logical function argos_prep_rstsz(lfnrst,filrst,nwm,nwa,nsa,nwmc)
c
c $Id: argos_prep_rstsz.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer lfnrst,nwm,nwa,nwmc
      character*255 filrst
c
      character*1 cdummy
      integer i,nsa,npbtyp,kinsep
c
      open(unit=lfnrst,file=filrst(1:index(filrst,' ')-1),
     + status='old',err=9999)
      rewind(lfnrst)
c
      do 1 i=1,4
      read(lfnrst,1000) cdummy
 1000 format(a1)
    1 continue
      read(lfnrst,1001) npbtyp
 1001 format(i5)
      read(lfnrst,1002) kinsep
 1002 format(40x,i5)
      read(lfnrst,1000) cdummy
      if(kinsep.eq.1) then
      do 2 i=1,3
      read(lfnrst,1000) cdummy
    2 continue
      endif
c
      read(lfnrst,1003) nwm,nwa,nsa,nwmc
 1003 format(2i10,10x,2i10)
c
      close(unit=lfnrst)
c
c      nwm=nwm-nwmc
c
      argos_prep_rstsz=.true.
      return
c
 9999 continue
      argos_prep_rstsz=.false.
      return
      end

      subroutine tce_tidy(rtdb)
c
c $Id: tce_tidy.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Terminate TCE modulem.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "errquit.fh"
#include "dra.fh"
c
      integer rtdb             ! RTDB handle
      integer i
      logical nodezero
c
      nodezero = (ga_nodeid().eq.0)
      if (nodezero.and.util_print('time',print_debug)) then
        write(LuOut,9000) 'createfile   ', cpusecs(1), cpusecs(51)
        write(LuOut,9000) 'deletefile   ', cpusecs(2), cpusecs(52)
        write(LuOut,9000) 'put_block    ', cpusecs(3), cpusecs(53)
        write(LuOut,9000) 'add_block    ', cpusecs(4), cpusecs(54)
        write(LuOut,9000) 'get_block    ', cpusecs(5), cpusecs(55)
        write(LuOut,9000) 'reconcilefile', cpusecs(6), cpusecs(56)
        write(LuOut,9000) 'tce_sort     ', cpusecs(7), cpusecs(57)
      endif
      do i=ipol,1,-1
        if (.not.ma_pop_stack(l_irs(i))) call errquit
     1    ('tce_tidy: MA problem',1,MA_ERR)
        if (.not.ma_pop_stack(l_occ(i))) call errquit
     1    ('tce_tidy: MA problem',2,MA_ERR)
        if (.not.ma_pop_stack(l_evl(i))) call errquit
     1    ('tce_tidy: MA problem',3,MA_ERR)
      enddo
      if (.not.geom_destroy(geom))
     1  call errquit('tce_tidy: geom_destroy failed',0,GEOM_ERR)
      if (.not.bas_destroy(ao_bas_han))
     1  call errquit('tce_tidy: bas_destroy failed',0,BASIS_ERR)
      if (ioalg.eq.5) then
        if (dra_terminate().ne.0)
     1  call errquit('tce_tidy: dra termination failed',0,DISK_ERR)
      endif
      call fock_2e_tidy(rtdb)
      call int_terminate()
      call schwarz_tidy()
 9000 format(1x,'cpu & wall time in seconds for ',A,2f20.1)
      return
      end

      subroutine argos_diana_setiomode()
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
c
      read(card(8:12),1000) iomode
 1000 format(i5)
c
      call ga_brdcst(mag_d01,iomode,ma_sizeof(mt_int,1,mt_byte),0)
c
      return
      end
c $Id: argos_diana_setiomode.F 21176 2011-10-10 06:35:49Z d3y133 $

c $Id: hnd_dderij.F 19696 2010-10-29 16:53:42Z d3y133 $
c
c taken from hondo.
c
      subroutine hnd_dderij2(ddxdii,ddydii,ddzdii,ddxdij,ddydij,ddzdij,
     1                  ddxdjj,ddydjj,ddzdjj,
     2                  dxdi,dydi,dzdi,dxdj,dydj,dzdj,
     3                  x,y,z,lit,ljt,ai,aj,nder)
      implicit none
      double precision x, y, z, dxdi, dydi, dzdi, dxdj, dydj, dzdj
      double precision ddxdii, ddydii, ddzdii 
      double precision ddxdjj, ddydjj, ddzdjj 
      double precision ddxdij, ddydij, ddzdij
      double precision ai, aj
      integer lit, ljt, j, i, nder
      dimension      x(lit+nder,ljt+nder)
      dimension      y(lit+nder,ljt+nder)
      dimension      z(lit+nder,ljt+nder)
      dimension   dxdi(lit,ljt),  dydi(lit,ljt),  dzdi(lit,ljt)
      dimension   dxdj(lit,ljt),  dydj(lit,ljt),  dzdj(lit,ljt)
      dimension ddxdii(lit,ljt),ddydii(lit,ljt),ddzdii(lit,ljt)
      dimension ddxdjj(lit,ljt),ddydjj(lit,ljt),ddzdjj(lit,ljt)
      dimension ddxdij(lit,ljt),ddydij(lit,ljt),ddzdij(lit,ljt)
c
c     ----- dxdi ... -----
c
      do 110 j=1,ljt
      dxdi(1,j)=x(2,j)*(ai+ai)
      dydi(1,j)=y(2,j)*(ai+ai)
      dzdi(1,j)=z(2,j)*(ai+ai)
  110 continue
c
      if(lit.eq.1) go to 130
c
      do 120 i=2,lit
      do 120 j=1,ljt
      dxdi(i,j)=x(i+1,j)*(ai+ai)-x(i-1,j)*dble(i-1)
      dydi(i,j)=y(i+1,j)*(ai+ai)-y(i-1,j)*dble(i-1)
      dzdi(i,j)=z(i+1,j)*(ai+ai)-z(i-1,j)*dble(i-1)
  120 continue
c
  130 continue
c
c     ----- dxdj ... -----
c
      do 140 i=1,lit
      dxdj(i,1)=x(i,2)*(aj+aj)
      dydj(i,1)=y(i,2)*(aj+aj)
      dzdj(i,1)=z(i,2)*(aj+aj)
  140 continue
c
      if(ljt.eq.1) go to 200
c
      do 150 j=2,ljt
      do 150 i=1,lit
      dxdj(i,j)=x(i,j+1)*(aj+aj)-x(i,j-1)*dble(j-1)
      dydj(i,j)=y(i,j+1)*(aj+aj)-y(i,j-1)*dble(j-1)
      dzdj(i,j)=z(i,j+1)*(aj+aj)-z(i,j-1)*dble(j-1)
  150 continue
c
  200 continue
      if (nder.lt.2) return
c
c     ----- ddxdii ... -----
c
      do 210 j=1,ljt
      ddxdii(1,j)=(x(3,j)*(ai+ai)-x(1,j))*(ai+ai)
      ddydii(1,j)=(y(3,j)*(ai+ai)-y(1,j))*(ai+ai)
      ddzdii(1,j)=(z(3,j)*(ai+ai)-z(1,j))*(ai+ai)
  210 continue
c
      if(lit.eq.1) go to 300
c
      do 220 j=1,ljt
      ddxdii(2,j)=(x(4,j)*(ai+ai)-x(2,j)*dble(2+2-1))*(ai+ai)
      ddydii(2,j)=(y(4,j)*(ai+ai)-y(2,j)*dble(2+2-1))*(ai+ai)
      ddzdii(2,j)=(z(4,j)*(ai+ai)-z(2,j)*dble(2+2-1))*(ai+ai)
  220 continue
c
      if(lit.eq.2) go to 300
c
      do 230 i=3,lit
      do 230 j=1,ljt
      ddxdii(i,j)=(x(i+2,j)*(ai+ai)-x(i,j)*dble(i+i-1))*(ai+ai)
     1            +x(i-2,j)*dble((i-1)*(i-2))
      ddydii(i,j)=(y(i+2,j)*(ai+ai)-y(i,j)*dble(i+i-1))*(ai+ai)
     1            +y(i-2,j)*dble((i-1)*(i-2))
      ddzdii(i,j)=(z(i+2,j)*(ai+ai)-z(i,j)*dble(i+i-1))*(ai+ai)
     1            +z(i-2,j)*dble((i-1)*(i-2))
  230 continue
c
  300 continue
c
c     ----- ddxdij ... -----
c
      ddxdij(1,1)= x(2,2)*((aj+aj)*(ai+ai))
      ddydij(1,1)= y(2,2)*((aj+aj)*(ai+ai))
      ddzdij(1,1)= z(2,2)*((aj+aj)*(ai+ai))
c
      if(ljt.eq.1) go to 330
      do 320 j=2,ljt
      ddxdij(1,j)=(x(2,j+1)*(aj+aj)-x(2,j-1)*dble(j-1))*(ai+ai)
      ddydij(1,j)=(y(2,j+1)*(aj+aj)-y(2,j-1)*dble(j-1))*(ai+ai)
      ddzdij(1,j)=(z(2,j+1)*(aj+aj)-z(2,j-1)*dble(j-1))*(ai+ai)
  320 continue
  330 if(lit.eq.1) go to 400
      do 340 i=2,lit
      ddxdij(i,1)=(x(i+1,2)*(ai+ai)-x(i-1,2)*dble(i-1))*(aj+aj)
      ddydij(i,1)=(y(i+1,2)*(ai+ai)-y(i-1,2)*dble(i-1))*(aj+aj)
      ddzdij(i,1)=(z(i+1,2)*(ai+ai)-z(i-1,2)*dble(i-1))*(aj+aj)
  340 continue
      if(ljt.eq.1) go to 400
      do 350 i=2,lit
      do 350 j=2,ljt
      ddxdij(i,j)=
     1      (x(i+1,j+1)*(aj+aj)-x(i+1,j-1)*dble(j-1))*(ai+ai)
     2     -(x(i-1,j+1)*(aj+aj)-x(i-1,j-1)*dble(j-1))*dble(i-1)
      ddydij(i,j)=
     1      (y(i+1,j+1)*(aj+aj)-y(i+1,j-1)*dble(j-1))*(ai+ai)
     2     -(y(i-1,j+1)*(aj+aj)-y(i-1,j-1)*dble(j-1))*dble(i-1)
      ddzdij(i,j)=
     1      (z(i+1,j+1)*(aj+aj)-z(i+1,j-1)*dble(j-1))*(ai+ai)
     2     -(z(i-1,j+1)*(aj+aj)-z(i-1,j-1)*dble(j-1))*dble(i-1)
  350 continue
c
  400 continue
c
c     ----- ddxdjj ... -----
c
      do 410 i=1,lit
      ddxdjj(i,1)=(x(i,3)*(aj+aj)-x(i,1))*(aj+aj)
      ddydjj(i,1)=(y(i,3)*(aj+aj)-y(i,1))*(aj+aj)
      ddzdjj(i,1)=(z(i,3)*(aj+aj)-z(i,1))*(aj+aj)
  410 continue
c
      if(ljt.eq.1) return
c
      do 420 i=1,lit
      ddxdjj(i,2)=(x(i,4)*(aj+aj)-x(i,2)*dble(2+2-1))*(aj+aj)
      ddydjj(i,2)=(y(i,4)*(aj+aj)-y(i,2)*dble(2+2-1))*(aj+aj)
      ddzdjj(i,2)=(z(i,4)*(aj+aj)-z(i,2)*dble(2+2-1))*(aj+aj)
  420 continue
c
      if(ljt.eq.2) return
c
      do 430 i=1,lit
      do 430 j=3,ljt
      ddxdjj(i,j)=(x(i,j+2)*(aj+aj)-x(i,j)*dble(j+j-1))*(aj+aj)
     1            +x(i,j-2)*dble((j-1)*(j-2))
      ddydjj(i,j)=(y(i,j+2)*(aj+aj)-y(i,j)*dble(j+j-1))*(aj+aj)
     1            +y(i,j-2)*dble((j-1)*(j-2))
      ddzdjj(i,j)=(z(i,j+2)*(aj+aj)-z(i,j)*dble(j+j-1))*(aj+aj)
     1            +z(i,j-2)*dble((j-1)*(j-2))
  430 continue
      return
      end

      SUBROUTINE ccsdt_lr_beta_2_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsdt_lr_beta_2_3.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_ytrbtrav + = -1/4 * Sum ( h6 h7 h11 h12 ) * i1 ( h6 h7 h11 h12 )_ytrbtra * v ( h11 h12 h6 h7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h6b
      INTEGER h7b
      INTEGER h11b
      INTEGER h12b
      INTEGER h6b_1
      INTEGER h7b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER h6b_2
      INTEGER h7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperh(2)
      INTEGER isuperh
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      IF (next.eq.count) THEN
      IF (0 .eq. ieor(irrep_y,ieor(irrep_trb,ieor(irrep_tra,irrep_v)))) 
     &THEN
      dimc = 1
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h6b = 1,noab
      DO h7b = h6b,noab
      DO h11b = 1,noab
      DO h12b = h11b,noab
      IF (int_mb(k_spin+h6b-1)+int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h
     &11b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),ieor(int_mb(k_sym+h7b-1),ieor(int_mb(
     &k_sym+h11b-1),int_mb(k_sym+h12b-1)))) .eq. ieor(irrep_y,ieor(irrep
     &_trb,irrep_tra))) THEN
      CALL TCE_RESTRICTED_4(h6b,h7b,h11b,h12b,h6b_1,h7b_1,h11b_1,h12b_1)
      CALL TCE_RESTRICTED_4(h11b,h12b,h6b,h7b,h11b_2,h12b_2,h6b_2,h7b_2)
      dim_common = int_mb(k_range+h6b-1) * int_mb(k_range+h7b-1) * int_m
     &b(k_range+h11b-1) * int_mb(k_range+h12b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h7b_1 - 1 + noab * (h6b_1 - 1
     &)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_beta_2_3',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h7b_2
     & - 1 + (noab+nvab) * (h6b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (noa
     &b+nvab) * (h11b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-
     &1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_beta_2_3',6,MA_
     &ERR)
      nsuperh(1) = 1
      nsuperh(2) = 1
      isuperh = 1
      IF (h6b .eq. h7b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h11b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperh(1))/FACTORIAL(nsuperh(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_3',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_3',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_3',9,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_c_sort),dbl_mb(k_c),-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_beta_2_3',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_3',
     &11,MA_ERR)
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine smd_srtdb_init()
      implicit none
#include "rtdb.fh"
#include "srtdb.fh"
#include "smd_srtdb_data.fh"
#include "mafdecls.fh"
c

      if (.not. srtdb_open('smd.main', 'empty', smd_srtdb)) 
     *     call errquit('srtdb_open',0,0)

      end 

      subroutine smd_srtdb_get_paramfile(filename,result)
      implicit none
#include "srtdb.fh"
#include "smd_srtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) filename
      logical result
c
      
      result = .true.
      if(.not.srtdb_cget(smd_srtdb,'smd:paramfile',1,filename))
     >   result = .false.
      end 

      subroutine smd_srtdb_get_coordfile(filename,result)
      implicit none
#include "srtdb.fh"
#include "smd_srtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_srtdb_get_coordfile"
      
      result = .true.
      if(.not.srtdb_cget(smd_srtdb,'smd:coordfile',1,filename))
     >   result = .false.

      end 

      subroutine smd_srtdb_get_handle(srtdb)
      implicit none
#include "rtdb.fh"
#include "smd_srtdb_data.fh"
#include "mafdecls.fh"
c
      integer srtdb
c
      srtdb = smd_srtdb

      end 
c $Id: smd_srtdb.F 22502 2012-05-20 06:11:57Z d3y133 $

C $Id: drdy_sort.F 25289 2014-02-25 20:49:10Z d3y133 $
      Subroutine drdy_sort(lhead,jop,lsad,ns,iflg)
C
C Sort RPH interpolation information to give points along MEP in 
C  increasing value of s (iflg#0, final sort and print out summary)
C
      Implicit None
C
#include "drdyP.fh"
#include "stdio.fh"
C
*::passed::
      Integer jop,iflg
      Logical lhead,lsad
*::local:
      Integer i,ii,ierr,iop,is,j,jopmx,js,ks,llopt(40),nbar,nend,
     * nfreq,ns,indx
      Character*80 line
      Character*255 filename
      Double Precision t
      Logical isopen
C
      nend  = 0
      jopmx = 0
      nfreq = 0
      nbar  = 0
C
c Get the filename for fu30, make sure it is the same as the one in rphwrt.F
c
      call util_file_name('file30',.false.,.false.,filename)
      ierr = 0
      write (fu6,600)
      isopen = .false.
      inquire(unit=fu30,opened=isopen)
      if (isopen) then
        close (unit=fu30, status='keep')
      endif
      open (unit=fu30,status='old',err=1000,form='formatted',
     &      file=filename)
C Position fu30 file at beginning of MEP data
      call drdy_restor(lhead,jop,lsad,llopt)
      jopmx = 3
      if (lgs(6).eq.1.or.lgs(6).eq.3) jopmx = 4
      ns = 0
      if (.not.lhead .or. .not.lsad .or. jop.lt.jopmx) then
         write (fu6,*) ' trouble reading fu30 file, can not sort'
         return
      endif
      is = 0
      if (lgs(1).eq.0) lsad = .false.
      read (fu30,3000,end=100) line
C      write (fu6,3000) line
      read (fu30,3000) line
C      write (fu6,3000) line
      if (lgs(1).eq.0) lsad = .true.
      nfreq = nf(5)
      nbar = (n3*(n3+1))/2
C Read and sort MEP data
      do while (is.le.nsmax+1)
         is = is + 1
         read (fu30,3000,end=100) line
C         write(fu6,*) line
         if (lgs(39).eq.0) then
            read (fu30,*,end=100,err=100) s,v
         else
            read (fu30,*,end=100,err=100) s,v,vspc
         endif
C         write(fu6,*) s,v
         read (fu30,3000,end=100) line
C         write(fu6,*) line
         read (fu30,*,end=100,err=100) (x(i),i=1,n3)
C         write(fu6,*) (x(i),i=1,n3)
C Find insertion point, js, for newly read s value
         js = 1
         do while (js.lt.is .and. s.gt.sgrid(js))
            js = js + 1
         enddo
         ks = is
C Insertion point, js, is less than the total number of points, is
C   Shift grid from js and above up one
         do while (ks.gt.js)
            sgrid(ks) = sgrid(ks-1)
            vgrid(ks) = vgrid(ks-1)
            vgrdsp(ks) = vgrdsp(ks-1)
            do i = 1,n3
               xgrid(i,ks) = xgrid(i,ks-1)
               dxgrid(i,ks) = dxgrid(i,ks-1)
               ifrgrd(i,ks) = ifrgrd(i,ks-1)
               freqg(i,ks) = freqg(i,ks-1)
            enddo
            do i = 1,nbar
               hgrid(i,ks) = hgrid(i,ks-1)
            enddo
            ks = ks - 1
         enddo
C Read new point in at insertion point
         sgrid(js) = s
         vgrid(js) = v
         vgrdsp(js) = vspc
         do i = 1,n3
            xgrid(i,js) = x(i)
         enddo
         read (fu30,3000,end=100) line
C         write(fu6,*) line
         read (fu30,*,end=100,err=100) (dxgrid(i,js),i=1,n3)
C         write(fu6,*) (dxgrid(i,js),i=1,n3)
         read (fu30,*) (ifrgrd(i,js),i=1,nfreq)
C         write(fu6,*) (ifrgrd(i,js),i=1,nfreq)
         read (fu30,3000) line
C         write(fu6,*) line
         read (fu30,*) (hgrid(i,js),i=1,nbar)
C         write(fu6,*) (hgrid(i,js),i=1,nbar)
C Project and diagonalize hessian
         indx = 0
         do i = 1,n3
            dx(i) = dxgrid(i,js)
            do j = 1,i
               f(i,j) = hgrid(indx+j,js)
            enddo
            indx = indx + i
         enddo
         do i = 2,n3
            do j = 1,i-1
               f(j,i) = f(i,j)
            enddo
         enddo
         call drdy_projct(ierr)
         if(ierr.eq.0) call drdy_fdiag(n3,nf(5),ierr,0)
         if (ierr.eq.0) then
C Store frequencies in freqg array
            do i = 1,nf(5)
               freqg(i,js) = scr2(i)
            enddo
         endif
C
      enddo
      if (is.gt.nsmax) then
         write (fu6,*) ' maximum number of grid points is', nsmax
         write (fu6,*) ' unable to complete sort of data'
         close (fu30)
         call errquit('drdy_sort: fatal error:1',911,0)
      endif
100   continue
      close (fu30)
      ns = is - 1
C
      Write(fu6,601)
      if (ns.le.0) then
         if (jop.ge.1) write (fu6,602) sr,vr
         if (jop.ge.3) write (fu6,603) sp,vp
         if (lgs(1).ne.0.and.lsad) write (fu6,604) 0.0,vspsv,
     *    (xr(i,5),i=1,n3)
      else
C Calculate s at reactants and products
         sr = 0.0d00
         sp = 0.0d00
         do i = 1,n3
            t = xgrid(i,1)-xr(i,1)
            sr = sr + t*t
            t = xgrid(i,ns)-xr(i,3)
            sp = sp + t*t
         enddo
         sr = sgrid(1) - sqrt(sr)
         sp = sgrid(ns) + sqrt(sp)
         write (fu6,602) sr,vr,(xr(i,1),i=1,n3)
         write (fu6,603) sp,vp,(xr(i,3),i=1,n3)
C
C Rewrite MEP data
         open (unit=fu30,form='formatted',file=filename)
         write (fu30,3000) ctitle
         write (fu30,3005) llopt
         iop = 1
         do while (iop.le.4)
C Reactants and products
            write (fu30,3010) iop
            if (iop.eq.1) then
               if (lgs(39).eq.0) then
                  write (fu30,3020) sr,vr,vzero
               else
                  write (fu30,3021) sr,vr,vzero,vrsp,vzerosp
               endif
            else if (iop.eq.2) then
               if (lgs(39).eq.0) then
                  write (fu30,3020) sr,0.0
               else
                  write (fu30,3020) sr,0.0,0.0
               endif
            else if (iop.eq.3) then
               if (lgs(39).eq.0) then
                  write (fu30,3020) sp,vp
               else
                  write (fu30,3020) sp,vp,vpsp
               endif
            else
               if (lgs(39).eq.0) then
                  write (fu30,3020) sp,0.0
               else
                  write (fu30,3020) sp,0.0,0.0
               endif
            endif
            if (icode(iop).eq.1) then
               write (fu30,*) ' '
            elseif (icode(iop).eq.2) then
               write (fu6,6000) iop
               call errquit('drdy_sort: fatal error:2',911,0)
            else
               nfreq = nf(iop)
               nend = 3*nratom(iop)
               write (fu30,3005) (ifrgrp(i,iop),i=1,nfreq)
               write (fu30,3040)
               nbar = (nend*(nend+1))/2
               ii = 0
               do i = 1,nend
                  write (fu30,3020) (hgrp(ii+j,iop),j=1,i)
                  ii = ii + i
               enddo
            endif
            if ((iop.eq.1 .and. lgs(6).le.2) .or. 
     *       iop.eq.2. or.
     *       (iop.eq.3 .and. (lgs(6).eq.1.or.lgs(6).eq.3)) .or.
     *       iop.eq.4) then
               iop = iop + 1
            else
               iop = iop + 2
            endif
         enddo
         nfreq = nf(5)
         if(lgs(1).ne.0) then
            write (fu30,3050)
            s = 0.0
            write (fu6,604) s,vspsv,(xr(i,5),i=1,n3)
            if(lgs(39).eq.0) then
               write (fu30,3020) s,vspsv
            else
               write (fu30,3020) s,vspsv,vspspsv
            endif
            write (fu30,3005) (ifrsp(i),i=1,nfreq)
C  write out packed hessian in mass-weighted coordinates
            write (fu30,3040)
            do i = 1, n3
               write (fu30,3020) (fspsv(i,j),j=1,i)
            enddo
         endif
         write (fu30, 3060) ns
         nbar = (n3*(n3+1))/2
         write (fu6,*) ' '
         do is = 1,ns
            write (fu6,605) sgrid(is),vgrid(is),(xgrid(i,is),i=1,n3)
            if (lgs(39).eq.0) then
               write (fu30,3070) sgrid(is),vgrid(is)
            else
               write (fu30,3070) sgrid(is),vgrid(is),vgrdsp(is)
            endif
c  write out mass-weighted x
            write (fu30,3030) (xgrid(i,is),i=1,n3)
c  write out mass-weighted dx
            write (fu30,3080) (dxgrid(i,is),i=1,n3)
            write (fu30,3005) (ifrgrd(i,is),i=1,nfreq)
c  write out packed hessian in mass-weighted coordinates
            write (fu30,3040)
            ii = 0
            do i = 1,n3
               write (fu30,3020) (hgrid(ii+j,is),j=1,i)
               ii = ii + i
            enddo
         enddo
         if (iflg.ne.0) then
            write (fu30,3085)
            write (fu30,3090) 0,sr,vr
            write (fu30,3095)
            write (fu30,3090) 0,sp,vp
            call drdy_sumout(ns)
         endif
      endif
      close (fu30)
      return
1000  continue
      write (fu6,*) ' error opening fu30 file'
      call errquit('drdy_sort: fatal error:3',911,0)
600   Format (//,' Sort data in file 30 so points along MEP',
     *  ' have the reaction coordinate in ascending order.',/,
     *  ' Also calculate the values of the reaction coordinate',
     *  ' at the reactant and product geometries',/,
     *  '  and shift energies so reactant v is zero.')
601   Format (/,' Summary of sorted data (all units are atomic)',/,5x,
     * 'R = reactants, P = products, * = saddle point or starting',
     * ' geometry',//,t10,'s',11x,'V',T38,'x (mass weighted)')
602   Format (' R',t4,0pf12.5,1pe13.5,(T35,0p9f9.4))
603   Format (' P',t4,0pf12.5,1pe13.5,(T35,0p9f9.4))
604   Format (' *',t4,0pf12.5,1pe13.5,(T35,0p9f9.4))
605   Format (t4,0pf12.5,1pe13.5,(T35,0p9f9.4))
3000  Format (a80)
3005  Format (1x,i2,39i3)
3010  Format (' iop =', i5, ', s,v=')
3020  Format (1x, 1pe19.10, 3e20.10)
3021  Format (1x, 1pe19.10, 4e20.10)
3030  Format (' x='/ (1x, 1pe19.10, 3e20.10))
3040  Format (' f matrix (packed)=')
3050  Format (' saddle point,  s,v=')
3060  Format (' begin points along reaction coordinate, ns=',/,1x,i5)
3070  Format (' s,v='/ (1x, 1pe19.10, 3e20.10))
3080  Format (' dx='/ (1x, 1pe19.10, 3e20.10))
3085  Format (' option for fitting potential in reactant valley,',
     *  ' ifitvr,s,v=')
3090  Format (1x,i5,1p2e13.5)
3095  Format (' option for fitting potential in product valley,',
     *  ' ifitvp,s,v=')
6000  Format (' icode=2 was chosen for iop=',i5,', but it is not',
     *   ' supported')
      END

      integer function argos_cafe_atotyp(ityp,ia)
c
      implicit none
c
#include "argos_cafe_common.fh"
c
      integer ia
      integer ityp(mat,3)
c
      argos_cafe_atotyp=ityp(ia,iset)
c
      return
      end
c $Id: argos_cafe_atotyp.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_newton()
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
c
      logical frequency
      external frequency
c
      external timer_wall,timer_wall_average,timer_wall_minimum
      real*8 timer_wall,timer_wall_average,timer_wall_minimum
      external timer_wall_total
      real*8 timer_wall_total
c
      real*8 dxmax,wallt,syntim
c
c     start timer
c
      call timer_start(1)
c
c     debug code
c
      if(idebug.gt.0) then
      write(lfndbg,'(a,i5,f12.6)') 'Timestep ',mdstep,stime
      endif
c
c     end debug code
c
      if(tann2.gt.0.and.tmpext1.ne.tmpext2.and.tann1.lt.tann2)then
      if(stime.gt.tann1.and.stime.lt.tann2) then
      tmpext=((tann2-stime)*tmpext1+(stime-tann1)*tmpext2)/(tann2-tann1)
      else
      tmpext=tmpext1
      if(stime.ge.tann2) tmpext=tmpext2
      endif
      endif
c
      wallt=timer_wall(203)
c
c     dynamic load balancing data
c
      if(itload.eq.0) then
      wallt=timer_wall(203)
      syntim=timer_wall(204)
      elseif(itload.eq.1) then
      wallt=timer_wall_minimum(203)
      syntim=timer_wall_minimum(204)
      elseif(itload.eq.2) then
      wallt=timer_wall_average(203)
      syntim=timer_wall_average(204)
      else
      wallt=timer_wall_average(203)
      syntim=timer_wall_average(204)
      if(me.eq.0) then
      wallt=timer_wall_minimum(203)
      syntim=timer_wall_minimum(204)
      endif
      endif
c
      if(me.eq.0.and.ioload.eq.1) then
      if(corrio.ge.syntim) then
      syntim=zero
      else
      syntim=syntim-corrio
      endif
      endif
c
      if(lpair) call timer_reset(203)
      call timer_start(203)
c
c     reassign velocities
c
      if(frequency(mdstep,nfgaus)) then
      call argos_cafe_gauss(tgauss,frgaus,nwmloc,nsaloc,
     + dbl_mb(i_vw),dbl_mb(i_vs),int_mb(i_iw+(lwdyn-1)*mwm),
     + int_mb(i_is+(lsdyn-1)*msa),int_mb(i_is+(lsatt-1)*msa))
      endif
c
      lpair=lfirst.or.frequency(mdstep,nfpair)
      lload=lfirst.or.frequency(mdstep,nfload)
      lhop=frequency(mdstep,nfhop)
      llong=(lfirst.or.frequency(mdstep,nflong).or.lpair).and.ltwin
c
      call timer_stop(1)
c
      if(lpair) then
c
      call timer_start(2)
c
c     center of mass coordinates
c
      call argos_cafe_cenmas(nwmloc,dbl_mb(i_xw),dbl_mb(i_xwm),nsaloc,
     + int_mb(i_is+(lsatt-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_gsm))
c
c     periodic boundary conditions
c
      call argos_fold(int_mb(i_iw),int_mb(i_is),
     + dbl_mb(i_xw),dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_xsm))
c
      call timer_stop(2)
c
      if(lload) then
c
      call timer_start(3)
c
      if(me.eq.0.and.ioload.eq.2) then
      if(corrio.ge.syntim.and.
     + ((nfcoor.gt.nfpair.and.nfcoor.gt.np).or.
     +  (nfcoor.eq.0.and.nfscoo.gt.nfpair.and.nfscoo.gt.np))) then
      syntim=zero
      else
      syntim=syntim-corrio
      endif
      endif
c
      call argos_space_balanc(stime,syntim,wallt,frequency(mdstep,
     + nfsync))
      call timer_reset(204)
c
      call timer_stop(3)
      call timer_start(4)
c
c     atom redistribution
c
      call argos_space_travel(box,dbl_mb(i_xw),dbl_mb(i_vw),
     + dbl_mb(i_xwcr),
     + dbl_mb(i_gw),int_mb(i_iw),nwmloc,dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_gs),int_mb(i_is),nsaloc)
c
      call timer_stop(4)
c
      endif
c
      endif
c
      call timer_start(5)
c
c     center of mass coordinates
c
      call argos_cafe_cenmas(nwmloc,dbl_mb(i_xw),dbl_mb(i_xwm),nsaloc,
     + int_mb(i_is+(lsatt-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_gsm))
c
c     subtract center of mass coordinates from reference coordinates
c
      if(idifco.gt.0)
     + call argos_addref(.false.,dbl_mb(i_xwm),dbl_mb(i_xwcr),
     + dbl_mb(i_xsm),dbl_mb(i_xscr),dbl_mb(i_dsr))
c
      call timer_stop(5)
      call timer_start(6)
c
      if(lfw.or.lfs) then
      call argos_space_gaputf(me,dbl_mb(i_fw),nwmloc,dbl_mb(i_fs),
     + nsaloc)
      call argos_space_wrttrj(lfntrj,lxw,lvw,lfw,lxs,lvs,lfs,
     + stime,pres,temp,tempw,temps,
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_fw),
     + dbl_mb(i_xwcr),int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_fs))
      endif
c
      call timer_stop(6)
c
      call argos_finit(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs),
     + dbl_mb(i_xsm),dbl_mb(i_xsmp))
c
      corrio=costio
      if(me.eq.0.and..not.lequi.and.(lxw.or.lvw.or.lxs.or.lvs)) then
c
      call timer_start(6)
c
      if(.not.lfw.and..not.lfs) then
      call argos_space_wrttrj(lfntrj,lxw,lvw,lfw,lxs,lvs,lfs,
     + stime,pres,temp,tempw,temps,
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_vw),dbl_mb(i_fw),
     + dbl_mb(i_xwcr),int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),
     + dbl_mb(i_fs))
      endif
      call timer_stop(6)
c
      costio=max(costio,timer_wall(6))
      corrio=costio-timer_wall(6)
c
      endif
c
c     atomic forces and potential energies
c
      call argos_forces(int_mb(i_iw),int_mb(i_is),dbl_mb(i_xw),
     + dbl_mb(i_xwm),dbl_mb(i_xs),dbl_mb(i_fw),dbl_mb(i_fs))
c
c     self-guided forces
c
      if(iguide.gt.0) then
      call timer_start(48)
      call argos_guided(dbl_mb(i_fw),dbl_mb(i_fs),
     + dbl_mb(i_gw),dbl_mb(i_gs))
      call timer_stop(48)
      endif
c
c     center of mass options
c
      if(icmopt.gt.0) then
      call timer_start(48)
      call argos_cmopt(dbl_mb(i_vs),dbl_mb(i_fs),dbl_mb(i_fcm),
     + int_mb(i_is+(lsmol-1)*msa),int_mb(i_is+(lsatt-1)*msa))
      call timer_stop(48)
      endif
c
      if(imembr.ne.0) call argos_membrane_forces(int_mb(i_mm),
     + dbl_mb(i_fm),dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_fs),
     + dbl_mb(i_wws))
c
c     time step
c
      call timer_start(49)
      call argos_cafe_mdstep(int_mb(i_iw+(lwdyn-1)*mwm),dbl_mb(i_xw),
     + dbl_mb(i_yw),dbl_mb(i_vw),dbl_mb(i_vwt),dbl_mb(i_fw),nwmloc,
     + int_mb(i_is+(lsdyn-1)*msa),int_mb(i_is+(lsatt-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_ys),dbl_mb(i_vs),dbl_mb(i_vst),
     + dbl_mb(i_fs),nsaloc,int_mb(i_iw+(lwgmn-1)*mwm),
     + int_mb(i_is+(lsgan-1)*msa),int_mb(i_is+(lssgm-1)*msa),tmpext,
     + int_mb(i_is+(lshop-1)*msa))
      call timer_stop(49)
c
c     shake
c
      call timer_start(50)
      call argos_shake(dbl_mb(i_xw),dbl_mb(i_yw),int_mb(i_iw),
     + dbl_mb(i_xs),dbl_mb(i_ys),int_mb(i_is),dxmax)
      call timer_stop(50)
c
c     recalculate velocities
c
      call argos_cafe_veloc(nwmloc,dbl_mb(i_xw),dbl_mb(i_yw),
     + dbl_mb(i_vw),
     + nsaloc,dbl_mb(i_xs),dbl_mb(i_ys),dbl_mb(i_vs))
c
c     velocity scaling to preset temperature
c
      if(frequency(mdstep,nfgaus)) then
      call argos_cafe_vscale(tgauss,nwmloc,nsaloc,
     + dbl_mb(i_vw),dbl_mb(i_vwt),dbl_mb(i_vs),dbl_mb(i_vst),
     + int_mb(i_iw+(lwdyn-1)*mwm),
     + int_mb(i_is+(lsdyn-1)*msa),int_mb(i_is+(lsatt-1)*msa))
      if(iand(ivopt,1).eq.1) nfgaus=0
      endif
c
c     coordinate scaling
c
      call timer_start(51)
      call argos_cafe_final(dbl_mb(i_xw),dbl_mb(i_xwm),dbl_mb(i_yw),
     + dbl_mb(i_vw),dbl_mb(i_vwt),nwmloc,
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_ys),dbl_mb(i_vs),
     + dbl_mb(i_vst),int_mb(i_is+(lsatt-1)*msa),
     + int_mb(i_is+(lsmol-1)*msa),int_mb(i_is+(lsdyn-1)*msa),
     + int_mb(i_is+(lsfrc-1)*msa),int_mb(i_is+(lshop-1)*msa),
     + dbl_mb(i_zs),
     + dbl_mb(i_esk),nsaloc,box,vlat,pres,temp,tempw,temps)
      call timer_stop(51)
c
c     center of mass coordinates
c
      call timer_start(52)
c
      if(idifco.gt.0.or.
     + frequency(mdstep,nfcntr).or.frequency(mdstep,nfslow)) then
c
      call argos_cafe_cenmas(nwmloc,dbl_mb(i_xw),dbl_mb(i_xwm),nsaloc,
     + int_mb(i_is+(lsatt-1)*msa),int_mb(i_is+(lsmol-1)*msa),
     + dbl_mb(i_xs),dbl_mb(i_xsm),dbl_mb(i_gsm))
c
c     add center of mass coordinates from reference coordinates
c
      if(idifco.gt.0)
     + call argos_addref(.true.,dbl_mb(i_xwm),dbl_mb(i_xwcr),
     + dbl_mb(i_xsm),dbl_mb(i_xscr),dbl_mb(i_dsr))
c
c     center solute in box
c
      if(frequency(mdstep,nfcntr)) then
      call argos_cafe_center(dbl_mb(i_xw),nwmloc,
     + int_mb(i_is+(lsfrc-1)*msa),
     + dbl_mb(i_xs),nsaloc,idscb,nscb,icentr)
      endif
c
c     remove overall translational motion
c
      if(frequency(mdstep,nfslow)) then
      call argos_cafe_slow(dbl_mb(i_xw),dbl_mb(i_vw),nwmloc,
     + dbl_mb(i_xs),
     + dbl_mb(i_vs),int_mb(i_is+(lsatt-1)*msa),nsaloc)
      endif
c
      endif
      call timer_stop(52)
      call timer_start(53)
c
c     update decomposition module
c
      call argos_space_update(me,vlat,
     + int_mb(i_iw),dbl_mb(i_xw),dbl_mb(i_xwcr),dbl_mb(i_vw),nwmloc,
     + int_mb(i_is),dbl_mb(i_xs),dbl_mb(i_vs),nsaloc)
c
      if(itest.gt.0) call argos_test()
c
      lfirst=.false.
c
      call timer_stop(53)
      call timer_stop(203)
c
      return
      end
c $Id: argos_newton.F 21176 2011-10-10 06:35:49Z d3y133 $

c $Id: hf2.F 21673 2012-01-06 01:22:09Z edo $
      Subroutine hf2(Axyz,Aprims,Acoefs,NPA,NCA,La,
     &               Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,
     &               Cxyz,Cprims,Ccoefs,NPC,NCC,Lc,
     &               Dxyz,Dprims,Dcoefs,NPD,NCD,Ld,
     &               bERI,Nints,canAB,canCD,canPQ,
     &               DryRun,W0,maxW0)

      Implicit none
#include "stdio.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "case.fh"

      Integer NPA,NCA,La
      Integer NPB,NCB,Lb
      Integer NPC,NCC,Lc
      Integer NPD,NCD,Ld
      Integer Nints,maxW0

      Logical canAB,canCD,canPQ

      Logical GenCon,DryRun

c--> Cartesian Coordinates, Primitives & Contraction Coefficients

      Double Precision Axyz(3),Aprims(NPA),Acoefs(NPA,NCA)
      Double Precision Bxyz(3),Bprims(NPB),Bcoefs(NPB,NCB)
      Double Precision Cxyz(3),Cprims(NPC),Ccoefs(NPC,NCC)
      Double Precision Dxyz(3),Dprims(NPD),Dcoefs(NPD,NCD)
c
c--> Block of Electron Repulsion Integrals

      Double Precision bERI(Nints)

c--> Scratch Space

      Double Precision W0(maxW0)

c--> Local variables
      
      Integer NCP,NCQ,MXD,nd
      Integer La2,Lb2,Lc2,Ld2
      Integer lp,lq,lr,lp3,lq3,lr3,lpq3
      Integer i_ALPHAp,i_IPAIRp,i_ESp,i_Ep
      Integer i_ALPHAq,i_IPAIRq,i_ESq,i_Eq
      Integer i_left,i_right,i_pf
      Integer MaxMem,MaxAvail,MemPerPair,MaxPairs,NPass
      Integer maxpp,maxpq,ipp,ipq
      Integer MPP,MPQ,MPR,NPP,NPQ,NPR
      Integer lszp,lszq,ninti
      Integer i_R0,i_IJK,i_P,i_Q,i_PQ,i_ff,i_Rj
      Integer i_E3,i_t1,i_t2,i_t3,i_t4,i_eri,i_top
      Integer i,j,istep
      integer i_ffscr,l_ffscr,i_rscr,l_rscr,nvals

      Logical doit_PQ

c
c Compute 4-ctr electron repulsion integrals (ERI) for four shells of 
c contracted Gaussian functions.
c
c******************************************************************************

      MXD = 0
      istep = MA_sizeof(MT_DBL,1,MT_INT)
      if (istep .gt. 2) call errquit(
     &    'hf2:Too many integers per real for Ipair addressing',911,
     &       INT_ERR)
      istep = 2/istep

c Determine whether general or segmented contraction is used.

      NCP = NCA*NCB
      NCQ = NCC*NCD

      GenCon = (NCP.ne.1) .or. (NCQ.ne.1)

c Define the angular momentum of the overlap distributions.

      Lp = La + Lb
      Lq = Lc + Ld
      Lr = Lp + Lq

c Increment "Lr" to account for the order of differentiation.

      Lr = Lr + MXD

c Define the accumulated number of angular momentum functions <= Lr.

      Lp3 = ((Lp+1)*(Lp+2)*(Lp+3))/6
      Lq3 = ((Lq+1)*(Lq+2)*(Lq+3))/6
      Lpq3 = max(Lp3,Lq3)
      Lr3 = ((Lr+1)*(Lr+2)*(Lr+3))/6

c Define the prefactor of the overlap distribution "P".
 
c Assign pointers to scratch space.

      i_ALPHAp = 1
      i_IPAIRp = i_ALPHAp + 2*(NPA*NPB)
      i_left   = i_IPAIRp + 2*(NPA*NPB) - 1
      i_ESp   = (maxW0+1) - 3*(NPA*NPB)
      i_right = i_ESp

      MaxMem = 1   ! take care of compiler warnings
      if (DryRun) then
        MaxMem = i_left + (maxW0 - (i_right-1))
        NPP = NPA*NPB
      else
        if (i_left.ge.i_right) then
          write(LuOut,*) 'HF2:  Insufficient scratch space.'
          write(LuOut,*) '      needed    ',i_left + (maxW0-(i_right-1))
          write(LuOut,*) '      allocated ',maxW0
          write(LuOut,*) 'From the left '
          write(LuOut,*) 'ALPHAp:  ',i_ALPHAp 
          write(LuOut,*) 'IPAIRp:  ',i_IPAIRp 
          write(LuOut,*) 'From the right '
          write(LuOut,*) 'ESp   :  ',i_ESp 
          call errquit('hf2: Not enough scratch space for hfset AB',911,
     &       MEM_ERR)
        end if
        call hfset(Axyz,Aprims,Acoefs,NPA,NCA,
     &      Bxyz,Bprims,Bcoefs,NPB,NCB,
     &      GenCon,W0(i_ALPHAp),W0(i_IPAIRp),W0(i_ESp),NPP)
      end if
 
c Define the prefactor of the overlap distribution "Q".

c Assign pointers to scratch space.

      i_ALPHAq = i_IPAIRp + 2*(NPA*NPB)
      i_IPAIRq = i_ALPHAq + 2*(NPC*NPD)
      i_left   = i_IPAIRq + 2*(NPC*NPD) - 1
      i_ESq   = i_right - 3*(NPC*NPD)
      i_right = i_ESq

      if( DryRun )then
        MaxMem = max( MaxMem, i_left + (maxW0 - (i_right-1)) )
        NPQ = NPC*NPD
      else
        if (i_left.ge.i_right) then
          write(LuOut,*) 'HF2:  Insufficient scratch space.'
          write(LuOut,*) '      needed    ',i_left + (maxW0-(i_right-1))
          write(LuOut,*) '      allocated ',maxW0
          write(LuOut,*) 'From the left '
          write(LuOut,*) 'ALPHAp:  ',i_ALPHAp 
          write(LuOut,*) 'IPAIRp:  ',i_IPAIRp 
          write(LuOut,*) 'ALPHAq:  ',i_ALPHAq 
          write(LuOut,*) 'IPAIRq:  ',i_IPAIRq 
          write(LuOut,*) 'From the right '
          write(LuOut,*) 'ESp   :  ',i_ESp 
          write(LuOut,*) 'ESq   :  ',i_ESq 
          call errquit('hf2: Not enough scratch space for hfset CD',911,
     &       MEM_ERR)
        end if
        call hfset(Cxyz,Cprims,Ccoefs,NPC,NCC,
     &      Dxyz,Dprims,Dcoefs,NPD,NCD,
     &      GenCon,W0(i_ALPHAq),W0(i_IPAIRq),W0(i_ESq),NPQ)
      end if

c Zero out integral block. Return if NPR = 0, i.e. no integrals

      NPR = NPP*NPQ
      if (NPR .eq. 0) then 
!     if (.not.DryRun) call dfill(Nints,0.0d00,beri,1)
      if (.not.DryRun) call dcopy(Nints,0d0,0,beri,1) 
         go to 99
      endif

c Define cartesian components for shells, bra and ket length and 
c number of integrals.

      La2 = (la+1)*(la+2)/2
      Lb2 = (lb+1)*(lb+2)/2
      lszp = La2*Lb2*NCP

      Lc2 = (lc+1)*(lc+2)/2
      Ld2 = (ld+1)*(ld+2)/2
      lszq = Lc2*Ld2*NCQ

      ninti = lszp*lszq
      if (.not.DryRun) call dfill(Ninti,0.0d00,beri,1)

c Define the Hermite linear expansion coefficients.

c Assign pointers to scratch space.

      i_Ep   = i_IPAIRq + 2*(NPC*NPD)
      i_Eq   = i_Ep     + 3*NPP*(MXD+1)*((Lp+1)*(La+1)*(Lb+1))
      i_pf   = i_Eq     + 3*NPQ*(MXD+1)*((Lq+1)*(Lc+1)*(Ld+1))
      i_left = i_pf     + 2*max(NPP,NPQ) - 1

      if( DryRun )then
        MaxMem = max( MaxMem, i_left + (maxW0 - (i_right-1)) )
      else
        if (i_left.ge.i_right) then
          write(LuOut,*) 'HF2:  Insufficient scratch space.'
          write(LuOut,*) '      needed    ',i_left + (maxW0-(i_right-1))
          write(LuOut,*) '      allocated ',maxW0
          write(LuOut,*) 'From the left '
          write(LuOut,*) 'ALPHAp:  ',i_ALPHAp 
          write(LuOut,*) 'IPAIRp:  ',i_IPAIRp 
          write(LuOut,*) 'ALPHAq:  ',i_ALPHAq 
          write(LuOut,*) 'IPAIRq:  ',i_IPAIRq 
          write(LuOut,*) 'Ep    :  ',i_Ep
          write(LuOut,*) 'Eq    :  ',i_Eq
          write(LuOut,*) 'pf    :  ',i_pf
          write(LuOut,*) 'From the right '
          write(LuOut,*) 'ESp   :  ',i_ESp 
          write(LuOut,*) 'ESq   :  ',i_ESq 
          call errquit('hf2: Not enough scratch space for hfmke',911,
     &       MEM_ERR)
        end if

        do nd = 0,MXD
          call hfmke(Axyz,Bxyz,W0(i_ALPHAp),W0(i_ESp),W0(i_Ep),W0(i_pf),
     &        nd,NPP,MXD,La,Lb)
          call hfmke(Cxyz,Dxyz,W0(i_ALPHAq),W0(i_ESq),W0(i_Eq),W0(i_pf),
     &        nd,NPQ,MXD,Lc,Ld)
        end do

      end if

c Evaluate the auxiliary function integrals.

c   Determine memory requirements and assign pointers to scratch space.
c   If insufficient memory, do multipassing.

      i_IJK = i_Eq  + 3*NPQ*(MXD+1)*((Lq+1)*(Lc+1)*(Ld+1))
      i_R0  = i_IJK + (Lr+1)**3

      MaxAvail = maxW0-i_R0-3*(NPP+NPQ)+1
      MemPerPair = (Lr+2)*Lr3 + 5
      if (MaxAvail-MemPerPair .le. 0) then
        write(LuOut,*) 'HF2:  Insufficient scratch space.'
        write(LuOut,*) '      needed    ',i_R0+3*(NPP+NPQ)
     &      +MemPerPair*NPR
        write(LuOut,*) '      allocated ',maxW0
        write(LuOut,*) 'ALPHAp:  ',i_ALPHAp 
        write(LuOut,*) 'IPAIRp:  ',i_IPAIRp 
        write(LuOut,*) 'ALPHAq:  ',i_ALPHAq 
        write(LuOut,*) 'IPAIRq:  ',i_IPAIRq 
        write(LuOut,*) 'Ep    :  ',i_Ep
        write(LuOut,*) 'Eq    :  ',i_Eq
        write(LuOut,*) 'R0    :  ',i_R0
        write(LuOut,*) 'IJK   :  ',i_IJK
        call errquit('hf2: Not enough scratch space for hf2mkr',911,
     &       MEM_ERR)
      end if

      MaxPairs = Maxavail/MemPerPair
      
      if (MaxPairs .ge. NPR) then
        maxpp = NPP
        maxpq = NPQ
      else if (NPP .ge. NPQ) then
        if (MaxPairs .ge. NPP) then
          maxpp = NPP
          maxpq = MaxPairs/NPP
        else if (MaxPairs .ge. NPQ) then
          maxpq = NPQ
          maxpp = MaxPairs/NPQ
        else
          NPass = (NPP-1)/MaxPairs+1
          maxpp = min((NPP-1)/NPass+1,MaxPairs)
          maxpq = 1
        end if
      else
        if (MaxPairs .ge. NPQ) then
          maxpq = NPQ
          maxpp = MaxPairs/NPQ
        else if (MaxPairs .ge. NPP) then
          maxpp = NPP
          maxpq = MaxPairs/NPP
        else
          NPass = (NPP-1)/MaxPairs+1
          maxpp = min((NPP-1)/NPass+1,MaxPairs)
          maxpq = 1
        end if
      end if

      do ipp = 0,NPP-1,maxpp
        MPP = min(maxpp,NPP-ipp)
        do ipq = 0,NPQ-1,maxpq
          MPQ = min(maxpq,NPQ-ipq)
          MPR = MPP*MPQ
          i_P   = i_R0  + MPR*Lr3
          i_Q   = i_P   + 3*MPP
          i_PQ  = i_Q   + 3*MPQ
          i_ff  = i_PQ  + MPR*3
          i_Rj  = i_ff  + 2*MPR
          i_top = i_Rj  + MPR*(Lr+1)*Lr3 - 1

          if (Lp.eq.Lq) then
            doit_PQ = MPP.ge.MPQ
          else if (abs((MPP-MPQ)).ge.4) then
            doit_PQ = MPP.ge.MPQ
          else if (Lp.lt.Lq) then
            doit_PQ = .true.
          else
            doit_PQ = .false.
          endif

          if( DryRun )then
            MaxMem = max( MaxMem, i_top )
          else
             nvals=1
             if(doscreen) nvals=2*MPP*MPQ
             if (.not.MA_Push_get(mt_dbl,nvals,'ffscr',
     C            l_ffscr,i_ffscr)) call errquit(
     E            'hf2: ran out of MA memory',0,MEM_ERR)
             nvals=1
             if(doscreen) nvals=2*MPP*MPQ*lr3*(lr+1)
             if (.not.MA_Push_get(mt_dbl,nvals,'rscr',
     C            l_rscr,i_rscr)) call errquit(
     E            'hf2: ran out of MA memory',1,MEM_ERR)
            if (doit_PQ) then
              call hf2mkr(Axyz,Bxyz,Cxyz,Dxyz,
     &            W0(i_ALPHAp+2*ipp),W0(i_ALPHAq+2*ipq),
     &            W0(i_R0),W0(i_IJK),W0(i_P),W0(i_Q),W0(i_PQ),
     &            W0(i_ff),W0(i_Rj),
     &            dbl_mb(i_ffscr),dbl_mb(i_rscr),
     &            MPP,MPQ,Lr,Lr3)
            else
              call hf2mkr(Cxyz,Dxyz,Axyz,Bxyz,
     &            W0(i_ALPHAq+2*ipq),W0(i_ALPHAp+2*ipp),
     &            W0(i_R0),W0(i_IJK),W0(i_Q),W0(i_P),W0(i_PQ),
     &            W0(i_ff),W0(i_Rj),
     &            dbl_mb(i_ffscr),dbl_mb(i_rscr),
     &            MPQ,MPP,Lr,Lr3)
            end if
             if (.not.ma_chop_stack(l_ffscr)) call errquit(
     E            'hf2: machopstack failed',0,MEM_ERR)
          end if

c Compute the ERI.

c Assign pointers to scratch space.

          i_eri = i_P
          i_t2 = i_eri + ninti
          if (gencon) then
            if (doit_PQ) then
              i_E3 = i_t2 + MPQ*Lq3*max(MPP,NCP)
              i_t1 = i_E3
              i_t3 = i_E3 + MPQ*Lq3
              i_t4 = i_t3 + MPQ
              i_top = max(i_t1+MPQ*Lq3*NPB*NCA,i_E3+MPP,i_t4+NPD)-1
            else
              i_E3 = i_t2 + MPP*Lp3*max(MPQ,NCQ)
              i_t1 = i_E3
              i_t3 = i_E3 + MPP*Lp3
              i_t4 = i_t3 + MPP
              i_top = max(i_t1+MPP*Lp3*NPD*NCC,i_E3+MPQ,i_t4+NPB)-1
            end if
          else
            i_E3 = i_t2 + MPR*Lpq3
            i_top  = i_E3 + max(MPP,MPQ)-1
          end if
          if( DryRun )then
            MaxMem = max( MaxMem, i_top )
          else if (i_top.gt.maxW0) then
            write(LuOut,*) 'HF2:  Insufficient scratch space.'
            write(LuOut,*) '      needed    ',i_top
            write(LuOut,*) '      allocated ',maxW0
            write(LuOut,*) 'ALPHAp:  ',i_ALPHAp 
            write(LuOut,*) 'IPAIRp:  ',i_IPAIRp 
            write(LuOut,*) 'ALPHAq:  ',i_ALPHAq 
            write(LuOut,*) 'IPAIRq:  ',i_IPAIRq 
            write(LuOut,*) 'Ep    :  ',i_Ep
            write(LuOut,*) 'Eq    :  ',i_Eq
            write(LuOut,*) 'IJK   :  ',i_IJK
            write(LuOut,*) 'R0    :  ',i_R0
            write(LuOut,*) 'eri   :  ',i_eri
            write(LuOut,*) 't2    :  ',i_t2
            write(LuOut,*) 'E3    :  ',i_E3
            if (gencon) then
              write(LuOut,*) 't1  :  ',i_t1
              write(LuOut,*) 't3  :  ',i_t3
              write(LuOut,*) 't4  :  ',i_t4
            end if
            call errquit('hf2: Not enough scratch space for hferi',911,
     &       MEM_ERR)
          else if (doit_PQ) then
            if (GenCon) then
              call hferi_gen(W0(i_Ep+3*ipp),W0(i_Eq+3*ipq),
     &            W0(i_IPAIRp+istep*ipp),W0(i_IPAIRq+istep*ipq),
     &            W0(i_R0),W0(i_IJK),W0(i_eri),W0(i_E3),
     &            W0(i_t1),W0(i_t2),W0(i_t3),W0(i_t4),
     &            MPP,MPQ,NPP,NPQ,La,Lb,Lc,Ld,La2,Lb2,Lc2,Ld2,
     &            Lq,Lq3,Lr,Acoefs,Bcoefs,Ccoefs,Dcoefs,
     &            NPA,NPB,NPC,NPD,NCA,NCB,NCC,NCD,
     &            MXD,canAB,canCD,canPQ)
            else
              call hferi(W0(i_Ep+3*ipp),W0(i_Eq+3*ipq),
     &            W0(i_R0),W0(i_IJK),W0(i_eri),W0(i_E3),W0(i_t2),
     &            MPP,MPQ,NPP,NPQ,Nints,La,Lb,Lc,Ld,Lr,MXD,
     &            canAB,canCD,canPQ)
            end if
            call daxpy(ninti,1.0D0,W0(i_eri),1,beri,1)
          else
            if (GenCon) then
              call hferi_gen(W0(i_Eq+3*ipq),W0(i_Ep+3*ipp),
     &            W0(i_IPAIRq+istep*ipq),W0(i_IPAIRp+istep*ipp),
     &            W0(i_R0),W0(i_IJK),W0(i_eri),W0(i_E3),
     &            W0(i_t1),W0(i_t2),W0(i_t3),W0(i_t4),
     &            MPQ,MPP,NPQ,NPP,Lc,Ld,La,Lb,Lc2,Ld2,La2,Lb2,
     &            Lp,Lp3,Lr,Ccoefs,Dcoefs,Acoefs,Bcoefs,
     &            NPC,NPD,NPA,NPB,NCC,NCD,NCA,NCB,
     &            MXD,canCD,canAB,canPQ)
            else
              call hferi(W0(i_Eq+3*ipq),W0(i_Ep+3*ipp),
     &            W0(i_R0),W0(i_IJK),W0(i_eri),W0(i_E3),W0(i_t2),
     &            MPQ,MPP,NPQ,NPP,Ninti,Lc,Ld,La,Lb,Lr,MXD,
     &            canCD,canAB,canPQ)
            end if
            j = 1
            do i = 0,lszp-1
              call daxpy(lszq,1.0d0,W0(i_eri+i),lszp,beri(j),1)
              j = j+lszq
            end do
          end if

        end do
      end do

c Return the maximum amount of scratch space required by a "dry run".

   99 if( DryRun ) maxW0 = MaxMem
c
      end

      SUBROUTINE tce_mo2e_offset_intorb(l_a_offset,k_a_offset,size)
C     $Id: tce_mo2e_offset_intorb.F 21239 2011-10-20 18:01:54Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     v ( g3 g4 g1 g2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
c new offset
      INTEGER length1
      INTEGER ipiece_l,i_counter,ipos,i
      INTEGER g3a,g4a,g1a,g2a
      INTEGER size_last
c
      INTEGER addr
      INTEGER g3b
      INTEGER g4b
      INTEGER g1b
      INTEGER g2b
      INTEGER IROW,ICOL,IRES
      INTEGER INDEX_PAIR
c 
      INTEGER key_test,offset_test,index_point
c 
c
      length = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &    ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1))))
     &    .eq. irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN       
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
c 
c new offset
c idividex from tce.fh
c
      length1=0
      ipiece_l=length/idiv2e
      if(ipiece_l*idiv2e.eq.length) then
       length1=idiv2e
      else if(ipiece_l*idiv2e.lt.length) then
       length1=idiv2e+1
      end if
      if(length1.eq.0) CALL ERRQUIT('tce_mo2e_offset length1',0,MA_ERR)
      IF(.not.MA_PUSH_GET(mt_int,6*(length1+1)+1,'noname',
     &l_a_offset,k_a_offset)) CALL ERRQUIT('tce_t2_offset',0,MA_ERR)
      int_mb(k_a_offset) = length1
      addr = 0
      size = 0
      i_counter=0
      ipos=1
c
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq. 
     &irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      IRES=INDEX_PAIR(IROW,ICOL)
      i_counter=i_counter+1
      if(addr.eq.0) then
       int_mb(k_a_offset+ipos)=g2b - 1 + (noa+nva) * 
     &(g1b - 1 + (noa+nva) * (g4b-
     & 1 + (noa+nva) * (g3b - 1)))
cc       int_mb(k_a_offset+ipos) = IRES
       int_mb(k_a_offset+(length1+1)+ipos)=size
       int_mb(k_a_offset+2*(length1+1)+ipos)=g3b !first do loop
       int_mb(k_a_offset+3*(length1+1)+ipos)=g4b
       int_mb(k_a_offset+4*(length1+1)+ipos)=g1b
       int_mb(k_a_offset+5*(length1+1)+ipos)=g2b !last  do loop
       ipos=ipos+1
      end if
      if(i_counter.eq.ipiece_l) then
       int_mb(k_a_offset+ipos)=g2b - 1 + 
     &(noa+nva) * (g1b - 1 + (noa+nva) * (g4b-
     & 1 + (noa+nva) * (g3b - 1)))
cc       int_mb(k_a_offset+ipos) = IRES
       int_mb(k_a_offset+(length1+1)+ipos)=size
       int_mb(k_a_offset+2*(length1+1)+ipos)=g3b !first do loop
       int_mb(k_a_offset+3*(length1+1)+ipos)=g4b
       int_mb(k_a_offset+4*(length1+1)+ipos)=g1b
       int_mb(k_a_offset+5*(length1+1)+ipos)=g2b !last  do loop
       ipos=ipos+1
       i_counter=0
      end if
      addr = addr + 1
      size_last=size
      g3a=g3b !first do loop
      g4a=g4b
      g1a=g1b
      g2a=g2b !last  do loop
      addr = addr + 1
      size = size + int_mb(k_range_alpha+g3b-1) * 
     &int_mb(k_range_alpha+g4b-1) * int_mb(k_range_alpha+g1b-1) * 
     &int_mb(k_range_alpha+g2b-1)
      END IF
c      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
c new offset
      if(i_counter.ne.0) then
       int_mb(k_a_offset+ipos)=g2a - 1 + (noa+nva) * 
     & (g1a - 1 + (noa+nva) * (g4a-
     & 1 + (noa+nva) * (g3a - 1)))
cc       int_mb(k_a_offset+ipos) = IRES
       int_mb(k_a_offset+(length1+1)+ipos)=size_last
       int_mb(k_a_offset+2*(length1+1)+ipos)=g3a !first do loop
       int_mb(k_a_offset+3*(length1+1)+ipos)=g4a
       int_mb(k_a_offset+4*(length1+1)+ipos)=g1a
       int_mb(k_a_offset+5*(length1+1)+ipos)=g2a !last  do loop
      end if
c
      RETURN
      END
c
c
c
      SUBROUTINE tce_mo2e_offset_intorb_old(l_a_offset,k_a_offset,size)
C     $Id: tce_mo2e_offset_intorb.F 21239 2011-10-20 18:01:54Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     v ( g3 g4 g1 g2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER g3b
      INTEGER g4b
      INTEGER g1b
      INTEGER g2b
      INTEGER IROW,ICOL,IRES
      INTEGER INDEX_PAIR
c
      length = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &    ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1))))
     &    .eq. irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN       
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
c 
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_mo2e_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq. 
     &irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      addr = addr + 1
      IRES=INDEX_PAIR(IROW,ICOL)
      int_mb(k_a_offset+addr) = IRES
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range_alpha+g3b-1) * 
     &int_mb(k_range_alpha+g4b-1) * int_mb(k_range_alpha+g1b-1) * 
     &int_mb(k_range_alpha+g2b-1)
      END IF
c      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
c
c
c
      SUBROUTINE tce_mo2e_pairs(l_a_offset,k_a_offset,size)
C     $Id: tce_mo2e_offset_intorb.F 21239 2011-10-20 18:01:54Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     v ( g3 g4 g1 g2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER g3b
      INTEGER g4b
      INTEGER g1b
      INTEGER g2b
      INTEGER IROW,ICOL,IRES
      INTEGER INDEX_PAIR
      INTEGER I
      INTEGER ISPAIR
      INTEGER XOFFSET
      INTEGER IBEFORE
c
      length = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      ISPAIR = 0 
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &    ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1))))
     &    .eq. irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      ISPAIR=1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF(ISPAIR.EQ.1) length=length+1
      END DO
      END DO
c
c length test
      if(length.ne.((noa+nva)*(noa+nva+1))/2) 
     &  CALL ERRQUIT('tce_mo2e_pairs',0,MA_ERR)
c
      IF (.not.MA_PUSH_GET(mt_int,3*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_mo2e_offset',0,MA_ERR)
      do i=1,3*length+1
       int_mb(k_a_offset+i-1)=0
      enddo  
      int_mb(k_a_offset) = length
      addr = 0
      xoffset = 0
      ibefore = 0
cc      size = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
        int_mb(k_a_offset+2*length+addr+1) = ibefore     
       size = 0
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq.
     &irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      size = size + int_mb(k_range_alpha+g3b-1) *
     &int_mb(k_range_alpha+g4b-1) * int_mb(k_range_alpha+g1b-1) *
     &int_mb(k_range_alpha+g2b-1)
      ibefore=ibefore+1 
      END IF
c      END IF
      END IF
      END IF
      END DO
      END DO
       if(size.ne.0) then
        addr = addr + 1
        int_mb(k_a_offset+addr)=size
        int_mb(k_a_offset+length+addr)=xoffset
        xoffset = xoffset + size
       else
        addr = addr + 1 
        int_mb(k_a_offset+addr)=0
        int_mb(k_a_offset+length+addr)=0
       end if
      END DO
      END DO
      RETURN
      END
c
c
c
      SUBROUTINE tce_mo2e_pairs_act(l_a_offset,k_a_offset,size)
C     $Id: tce_mo2e_offset_intorb.F 21239 2011-10-20 18:01:54Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     v ( g3 g4 g1 g2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER g3b
      INTEGER g4b
      INTEGER g1b
      INTEGER g2b
      INTEGER IROW,ICOL,IRES
      INTEGER INDEX_PAIR
      INTEGER I
      INTEGER ISPAIR
      INTEGER XOFFSET
      INTEGER IBEFORE
      LOGICAL is_active_4_o
c
      length = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      ISPAIR = 0 
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &    ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1))))
     &    .eq. irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      ISPAIR=1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF(ISPAIR.EQ.1) length=length+1
      END DO
      END DO
c
c  length test
      if(length.ne.((noa+nva)*(noa+nva+1))/2) 
     &  CALL ERRQUIT('tce_mo2e_pairs',0,MA_ERR)
c
      IF (.not.MA_PUSH_GET(mt_int,3*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('tce_mo2e_offset',0,MA_ERR)
      do i=1,3*length+1
       int_mb(k_a_offset+i-1)=0
      enddo  
      int_mb(k_a_offset) = length
      addr = 0
      xoffset = 0
      ibefore = 0
cc      size = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
        int_mb(k_a_offset+2*length+addr+1) = ibefore     
       size = 0
      IROW=INDEX_PAIR(g4b,g3b)
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF(.not.((g3b.gt.noa).and.(g4b.gt.noa).and.(g1b.gt.noa).and.
     &   (g2b.gt.noa).and.(.not.is_active_4_o(g3b,g4b,g1b,g2b)))) THEN
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq.
     &irrep_v) THEN
cc      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      size = size + int_mb(k_range_alpha+g3b-1) *
     &int_mb(k_range_alpha+g4b-1) * int_mb(k_range_alpha+g1b-1) *
     &int_mb(k_range_alpha+g2b-1)
      ibefore=ibefore+1 
      END IF
c      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
       if(size.ne.0) then
        addr = addr + 1
        int_mb(k_a_offset+addr)=size
        int_mb(k_a_offset+length+addr)=xoffset
        xoffset = xoffset + size
       else
        addr = addr + 1 
        int_mb(k_a_offset+addr)=0
        int_mb(k_a_offset+length+addr)=0
       end if
      END DO
      END DO
      RETURN
      END
c
c
      SUBROUTINE tce_mo2e_offset_intorb_act(l_a_offset,k_a_offset,size)
C     $Id: tce_mo2e_offset_intorb.F 21239 2011-10-20 18:01:54Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     v ( g3 g4 g1 g2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
c new offset
      INTEGER length1
      INTEGER ipiece_l,i_counter,ipos,i
      INTEGER g3a,g4a,g1a,g2a
      INTEGER size_last
c
      INTEGER addr
      INTEGER g3b
      INTEGER g4b
      INTEGER g1b
      INTEGER g2b
      INTEGER IROW,ICOL,IRES
      INTEGER INDEX_PAIR
c 
      INTEGER key_test,offset_test,index_point
c 
      LOGICAL is_active_4_o
c
      length = 0
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF(.not.((g3b.gt.noa).and.(g4b.gt.noa).and.(g1b.gt.noa).and.
     &   (g2b.gt.noa).and.(.not.is_active_4_o(g3b,g4b,g1b,g2b)))) THEN
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &    ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1))))
     &    .eq. irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN       
      length = length + 1
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
c 
c new offset
c idividex from tce.fh
c
      length1=0
      ipiece_l=length/idiv2e
      if(ipiece_l*idiv2e.eq.length) then
       length1=idiv2e
      else if(ipiece_l*idiv2e.lt.length) then
       length1=idiv2e+1
      end if
      if(length1.eq.0) CALL ERRQUIT('tce_mo2e_offset length1',0,MA_ERR)
      IF(.not.MA_PUSH_GET(mt_int,6*(length1+1)+1,'noname',
     &l_a_offset,k_a_offset)) CALL ERRQUIT('tce_t2_offset',0,MA_ERR)
      int_mb(k_a_offset) = length1
      addr = 0
      size = 0
      i_counter=0
      ipos=1
c
      DO g3b = 1,noa+nva   !j
      DO g4b = g3b,noa+nva !i
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
      IF(.not.((g3b.gt.noa).and.(g4b.gt.noa).and.(g1b.gt.noa).and.
     &   (g2b.gt.noa).and.(.not.is_active_4_o(g3b,g4b,g1b,g2b)))) THEN
      IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     &int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
      IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1),
     &ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq. 
     &irrep_v) THEN
      IROW=INDEX_PAIR(g4b,g3b)
      ICOL=INDEX_PAIR(g2b,g1b)
      IF(IROW.GE.ICOL) THEN
      IRES=INDEX_PAIR(IROW,ICOL)
      i_counter=i_counter+1
      if(addr.eq.0) then
       int_mb(k_a_offset+ipos)=g2b - 1 + (noa+nva) * 
     &(g1b - 1 + (noa+nva) * (g4b-
     & 1 + (noa+nva) * (g3b - 1)))
cc       int_mb(k_a_offset+ipos) = IRES
       int_mb(k_a_offset+(length1+1)+ipos)=size
       int_mb(k_a_offset+2*(length1+1)+ipos)=g3b !first do loop
       int_mb(k_a_offset+3*(length1+1)+ipos)=g4b
       int_mb(k_a_offset+4*(length1+1)+ipos)=g1b
       int_mb(k_a_offset+5*(length1+1)+ipos)=g2b !last  do loop
       ipos=ipos+1
      end if
      if(i_counter.eq.ipiece_l) then
       int_mb(k_a_offset+ipos)=g2b - 1 + 
     &(noa+nva) * (g1b - 1 + (noa+nva) * (g4b-
     & 1 + (noa+nva) * (g3b - 1)))
cc       int_mb(k_a_offset+ipos) = IRES
       int_mb(k_a_offset+(length1+1)+ipos)=size
       int_mb(k_a_offset+2*(length1+1)+ipos)=g3b !first do loop
       int_mb(k_a_offset+3*(length1+1)+ipos)=g4b
       int_mb(k_a_offset+4*(length1+1)+ipos)=g1b
       int_mb(k_a_offset+5*(length1+1)+ipos)=g2b !last  do loop
       ipos=ipos+1
       i_counter=0
      end if
      addr = addr + 1
      size_last=size
      g3a=g3b !first do loop
      g4a=g4b
      g1a=g1b
      g2a=g2b !last  do loop
      addr = addr + 1
      size = size + int_mb(k_range_alpha+g3b-1) * 
     &int_mb(k_range_alpha+g4b-1) * int_mb(k_range_alpha+g1b-1) * 
     &int_mb(k_range_alpha+g2b-1)
      END IF
c      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
c new offset
      if(i_counter.ne.0) then
       int_mb(k_a_offset+ipos)=g2a - 1 + (noa+nva) * 
     & (g1a - 1 + (noa+nva) * (g4a-
     & 1 + (noa+nva) * (g3a - 1)))
       int_mb(k_a_offset+(length1+1)+ipos)=size_last
       int_mb(k_a_offset+2*(length1+1)+ipos)=g3a !first do loop
       int_mb(k_a_offset+3*(length1+1)+ipos)=g4a
       int_mb(k_a_offset+4*(length1+1)+ipos)=g1a
       int_mb(k_a_offset+5*(length1+1)+ipos)=g2a !last  do loop
      end if
c

c
      RETURN
      END
c
c
c
      INTEGER FUNCTION INDEX_SINGLE(I)
      IMPLICIT NONE
      INTEGER I 
      INDEX_SINGLE=(I*(I-1))/2
      RETURN 
      END
c
      INTEGER FUNCTION INDEX_PAIR(I,J)
      IMPLICIT NONE
      INTEGER I,J
      INDEX_PAIR=(I*(I-1))/2+J
      RETURN
      END       
c
      INTEGER FUNCTION INDEX_POINT(I,J,N)
      IMPLICIT NONE
      INTEGER I,J,N
c I <= J
      INDEX_POINT=(N*(N+1))/2-((N-I)*(N-I+1))/2-(N-J)
      RETURN
      END

      subroutine argos_input(irtdb)
c
c $Id: argos_input.F 19828 2011-01-04 20:25:43Z d3j191 $
c
      implicit none
c
      real*8 one
      parameter(one=1.0d0)
c
#include "rtdb.fh"
#include "inp.fh"
#include "global.fh"
#include "mafdecls.fh"
c
      integer irtdb
      character*255 item
      character*80 project,server
c
      integer mdalgo,iset,iforw,msdit,mcgit,ncgcy,mrun,ibinar,ipme
      integer maxlam,npgdec,issscl,mequi,mdacq,ldacq,ipscal,itscal
      integer ipolt,mshitw,mshits,npstep,npener,npdist,nptmng,nfpair
      integer nfrdf,nfcntr,nfoutp,nfstat,nfrest,keepr,nfcoor,nfscoo
      integer nfvelo,nfsvel,nfprop,nffree,nfsync,iformt,madbox,loadb
      integer nfforc,nfwfor,nfsfor,npstat,nfesp,impfr,impto,nftri
      integer nflong,nfgaus,mropt,nfauto,nfconv,nffet,idebug,mpolit
      integer npatom,nptopw,nptops,npx,npy,npz,npg,nbx,nby,nbz,itrack
      integer ngx,ngy,ngz,numfix,ifix,noshak,nfslow,nfefld,nfsfld
      integer ngl,isetp1,isetp2,ifield,iapprx,nacfl,npxpct,imfft
      integer ireact,itemp,nscb,idscb(10),memlim,morder,isolvo,lfout6
      integer mwmreq,msareq,itest,nodpme,lbpair,ireset,npmf,nopack
      integer ndistr,ndaver,idevel,itime(500),nftime,idtime,nfdrss
      integer itload,ihess,latom,icomm,nfanal,iport,iguide,icentr
      integer mbbreq,nfwcoo,nfwvel,ioload,iprof,isload,icntrl,istart
      integer ifidi,ncoll,ipopt,ivopt,ilambd,mlambd,includ,npforc
      integer iprop,iprpmf,nfhop,ipbtyp,iradgy,idifco,nfnewf,ncolt
      integer icmopt,imembr,icrit,nbget,nprec,nfload,ncp
      real*8 dx0sd,dxsdmx,dxmsd,dx0cg,dxcgmx,dxmcg,edacq,fdacq,ddacq
      real*8 delta,stime,tstep,prsext,prsrlx,compr,tmpext,tmprlx
      real*8 tmsrlx,tgauss,rshort,rlong,ptol,tlwsha,tlssha,factld
      real*8 rrdf,xfield,xfvect(3),xffreq,weight,dielec,ealpha
      real*8 frgaus,rbox,disrlx,drsscl,eqm,tguide,fguide,rfix,fcoll
      real*8 tmpext2,tann1,tann2,scaleq,rsgm,facpmf,rhop,thop
      character*12 afix
c
      integer i,mtimes,len
      character*255 filcmd
      integer lfncmd,numcmd,ifirst,ilast
      logical expert
c
#include "bitops.fh"
c
      lfncmd=69
      numcmd=0
c
      mtimes=250
c
c     set the defaults
c
      ncp=1
      nbx=0
      nby=0
      nbz=0
      npx=0
      npy=0
      npz=0
      npg=1
      includ=0
      itrack=0
      mdalgo=1
      iset=1
      isetp1=0
      isetp2=0
      iforw=1
      ilambd=0
      mlambd=0
      msdit=100
      mcgit=0
      ncgcy=10
      mrun=0
      maxlam=21
      npgdec=0
      issscl=0
      mequi=0
      mdacq=1000
      ldacq=500
      ipscal=0
      ipopt=0
      ivopt=0
      itscal=0
      nfgaus=0
      ipolt=0
      ifidi=0
      mpolit=10
      mshitw=100
      mshits=100
      npstep=0
      npstat=0
      npatom=0
      nptopw=0
      nptops=0
      npener=0
      npforc=0
      npdist=0
      nptmng=0
      nfpair=1
      nfesp=0
      nfrdf=0
      impfr=0
      impto=0
      nftri=0
      ngl=1000
      nflong=1
      nfcntr=0
      nfanal=0
      nfoutp=10
      nfstat=100
      nfrest=0
      keepr=0
      nfslow=0
      nfcoor=-1
      nfwcoo=-1
      nfscoo=-1
      nfvelo=-1
      nfwvel=-1
      nfsvel=-1
      nfforc=-1
      nfwfor=-1
      nfsfor=-1
      nfprop=0
      nffree=1
      nfsync=0
      nfauto=0
      nfconv=0
      nffet=0
      nfefld=0
      nfsfld=0
      nfnewf=0
      ibinar=0
      iformt=1
      madbox=6
      loadb=3
      nfload=0
      ireset=0
      mropt=1
      idebug=0
      icntrl=0
      ifield=0
      iapprx=0
      nacfl=1000
      npxpct=0
      ipme=0
      morder=4
      ngx=nbx
      ngy=nby
      ngz=nbz
      len=0
      nbget=0
      nprec=0
      iprop=0
      nfhop=0
      rhop=0.35d0
      thop=0.020d0
c      ifix=0
c      iunfix=0
      numfix=0
      noshak=0
      nscb=1
      idscb(1)=1
      ireact=0
      memlim=0
      isolvo=0
      lfout6=0
      iprpmf=0
      imfft=1
      mwmreq=0
      msareq=0
      mbbreq=0
      itest=0
      nodpme=0
      lbpair=10
      ndistr=0
      npmf=0
      ndaver=0
      idevel=0
      nftime=0
      nfdrss=0
      itload=0
      ioload=0
      isload=0
      iprof=0
      ihess=0
      latom=0
      icomm=0
      iport=0
      iguide=0
      icmopt=0
      imembr=0
      nopack=0
      istart=0
      ncoll=0
      ncolt=0
      ipbtyp=1
      iradgy=0
      idifco=0
      icrit=0
      fcoll=1.0d0
      rsgm=-1.0d0
c
      server=' '
c
      dx0sd=0.01d0
      dxsdmx=0.00001d0
      dxmsd=0.05d0
      dx0cg=0.001d0
      dxcgmx=0.00001d0
      dxmcg=0.05d0
      edacq=5.0d0
      ddacq=5.0d0
      fdacq=0.75d0
      delta=0.075d0
      stime=0.0d0
      tstep=0.001d0
      prsext=1.025e5
      prsrlx=0.5d0
      compr=4.53e-10
      tmpext=298.15d0
      tmpext2=298.15d0
      tmprlx=0.1d0
      tmsrlx=0.1d0
      tann1=0.0d0
      tann2=0.0d0
      tgauss=298.15d0
      rlong=0.9d0
      rshort=0.9d0
      ptol=0.001d0
      tlwsha=0.001d0
      tlssha=0.001d0
      factld=0.75d0
      rrdf=0.0d0
      xfvect(1)=0.0d0
      xfvect(2)=0.0d0
      xfvect(3)=1.0d0
      xffreq=0.0d0
      weight=0.0d0
      ealpha=0.0d0
      dielec=80.0d0
      frgaus=1.0d0
      rbox=0.0d0
      disrlx=0.1d0
      drsscl=one
      eqm=0.0d0
      tguide=0.0d0
      fguide=0.0d0
      scaleq=-1.0d0
c      do 4 i=1,msf
c      lsffix(i)=1
c    4 continue
      do 7 i=1,mtimes
      itime(i)=0
    7 continue
      idtime=0
      project=' '
      expert=.false.
c
c     read the nwchem input file
c
    1 continue
c
      if(.not.inp_read()) call md_abort('argos: inp_read failed',0)
c
    2 continue
c
      if(.not.inp_a(item)) goto 1
c
    3 continue
c
      if(inp_compare(.false.,'system',item)) then
      if(len.gt.0) call md_abort('argos: duplicate system',0)
      if(.not.inp_a(project)) call md_abort('argos: error system',0)
      len=index(project,' ')-1
      filcmd=project(1:len)//'.cmd '
      open(unit=lfncmd,file=filcmd(1:index(filcmd,' ')-1),
     + form='formatted',status='unknown',err=1999)
      rewind(unit=lfncmd)
      numcmd=0
      goto 2
      endif
c
      if(inp_compare(.false.,'expert',item)) then
      expert=.true.
      goto 2
      endif
c
      if(inp_compare(.false.,'finish',item)) then
      istart=1
      goto 2
      endif
c
      if(inp_compare(.false.,'resume',item)) then
      istart=2
      goto 2
      endif
c
      if(inp_compare(.false.,'prefetch',item)) then
      if(.not.inp_i(nbget)) nbget=-1
      goto 2
      endif
c
      if(inp_compare(.false.,'server',item)) then
      if(.not.inp_a(server)) call md_abort('argos: error server',0)
      if(.not.inp_i(iport)) call md_abort('argos: error port',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'boxmin',item)) then
      if(.not.inp_f(rbox)) call md_abort('argos: error minbox',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'segmentsize',item)) then
      if(.not.inp_f(rsgm))
     + call md_abort('argos: error segmentsize',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'boxes',item)) then
      if(.not.inp_i(nbx)) call md_abort('argos: error nbx',0)
      if(.not.inp_i(nby)) call md_abort('argos: error nby',0)
      if(.not.inp_i(nbz)) call md_abort('argos: error nbz',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'cells',item)) then
      if(.not.inp_i(nbx)) call md_abort('argos: error nbx',0)
      if(.not.inp_i(nby)) call md_abort('argos: error nby',0)
      if(.not.inp_i(nbz)) call md_abort('argos: error nbz',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'nodes',item)) then
      if(.not.inp_i(npx)) call md_abort('argos: error npx',0)
      if(.not.inp_i(npy)) call md_abort('argos: error npy',0)
      if(.not.inp_i(npz)) call md_abort('argos: error npz',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'procs',item)) then
      if(.not.inp_i(npx)) call md_abort('argos: error npx',0)
      if(.not.inp_i(npy)) call md_abort('argos: error npy',0)
      if(.not.inp_i(npz)) call md_abort('argos: error npz',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'groups',item)) then
      if(.not.inp_i(npg)) call md_abort('argos: error npg',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'cores',item)) then
      if(.not.inp_i(ncp)) call md_abort('argos: error ncp',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'set',item)) then
      if(.not.inp_i(iset)) call md_abort('argos: error set',2)
      if(iset.le.0) call md_abort('argos: illegal iset',2)
      if(iset.gt.3) call md_abort('argos: illegal iset',2)
      goto 2
      endif
c
      if(inp_compare(.false.,'pset',item)) then
      if(.not.inp_i(isetp1)) call md_abort('argos: error pset',2)
      if(isetp1.le.1) call md_abort('argos: illegal ipset1',2)
      if(isetp1.gt.3) call md_abort('argos: illegal ipset1',2)
      if(.not.inp_i(isetp2)) goto 2
      if(isetp1.eq.3) call md_abort('argos: illegal ipset1',2)
      if(isetp2.ne.3) call md_abort('argos: illegal ipset2',2)
      goto 2
      endif
c
      if(inp_compare(.false.,'lambda',item)) then
      if(.not.inp_i(ilambd)) call md_abort('argos: error lambda',0)
      if(.not.inp_i(mlambd)) call md_abort('argos: error lambda',0)
      goto 2
      endif
c
      if(inp_compare(.false.,'numerical',item)) then
      ifidi=1
      goto 2
      endif
c
      if(inp_compare(.false.,'pbc',item)) then
      if(.not.inp_a(item)) call md_abort('argos: error pbc',1)
      if(inp_compare(.false.,'atom',item)) then
      ipbtyp=1
      elseif(inp_compare(.false.,'residue',item)) then
      ipbtyp=2
      elseif(inp_compare(.false.,'molecule',item)) then
      ipbtyp=3
      else
      call md_abort('argos: error pbc',2)
      endif
      goto 2
      endif
c
c     energy minimization
c
c     em [[sd] [<i>] [init <r>] [max <i>] [min <i>]]
c     [cg [<i>] [cy <i>] [init <r>] [max <r>] [min <i>]]
c
      if(inp_compare(.false.,'sd',item)) then
      if(.not.inp_i(msdit)) call  md_abort('argos: error em sd',2)
  101 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'init',item)) then
      if(.not.inp_f(dx0sd)) call md_abort('argos: error sd init',2)
      goto 101
      endif
      if(inp_compare(.false.,'min',item)) then
      if(.not.inp_f(dxsdmx)) call md_abort('argos: error sd min',2)
      goto 101
      endif
      if(inp_compare(.false.,'max',item)) then
      if(.not.inp_f(dxmsd)) call md_abort('argos: error sd max',2)
      goto 101
      endif
      if(inp_compare(.false.,'criterion',item)) then
      if(.not.inp_i(icrit)) call md_abort('argos: error sd crit',2)
      goto 101
      endif
      endif
c
c     conjugate gradient
c
      if(inp_compare(.false.,'cg',item)) then
      if(.not.inp_i(mcgit)) call  md_abort('argos: error em cg',2)
  103 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'init',item)) then
      if(.not.inp_f(dx0cg)) call md_abort('argos: error cg init',2)
      goto 103
      endif
      if(inp_compare(.false.,'min',item)) then
      if(.not.inp_f(dxcgmx)) call md_abort('argos: error cg min',2)
      goto 103
      endif
      if(inp_compare(.false.,'max',item)) then
      if(.not.inp_f(dxmcg)) call md_abort('argos: error cg max',2)
      goto 103
      endif
      if(inp_compare(.false.,'cy',item)) then
      if(.not.inp_i(ncgcy)) call md_abort('argos: error cg cy',2)
      goto 103
      endif
      if(inp_compare(.false.,'criterion',item)) then
      if(.not.inp_i(icrit)) call md_abort('argos: error cg crit',2)
      goto 103
      endif
      endif
c
c     forward mcti
c
      if(inp_compare(.false.,'forward',item)) then
      iforw=1
      if(inp_i(mrun)) then
      maxlam=mrun
      if(.not.inp_a(item)) goto 1
      if(.not.inp_compare(.false.,'of',item)) goto 3
      if(.not.inp_i(maxlam)) call md_abort('argos: error mcti',7)
      endif
      goto 2
      endif
c
c
c     reverse mcti
c
      if(inp_compare(.false.,'reverse',item)) then
      iforw=-1
      if(inp_i(mrun)) then
      maxlam=mrun
      if(.not.inp_a(item)) goto 1
      if(.not.inp_compare(.false.,'of',item)) goto 3
      if(.not.inp_i(maxlam)) call md_abort('argos: error mcti',7)
      endif
      goto 2
      endif
c
c     error
c
      if(inp_compare(.false.,'error',item)) then
      if(.not.inp_f(edacq)) call md_abort('argos: error error',8)
      goto 2
      endif
c
c     drift
c
      if(inp_compare(.false.,'drift',item)) then
      if(.not.inp_f(ddacq)) call md_abort('argos: error drift',9)
      goto 2
      endif
c
c     factor
c
      if(inp_compare(.false.,'factor',item)) then
      if(.not.inp_f(fdacq)) call md_abort('argos: error factor',10)
      goto 2
      endif
c
c     decomposition
c
      if(inp_compare(.false.,'decomp',item)) then
      if(.not.inp_i(npgdec)) npgdec=1
      goto 2
      endif
c
c     separation shifted scaling
c
      if(inp_compare(.false.,'sss',item)) then
      issscl=1
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'delta',item)) then
      if(.not.inp_f(delta)) call md_abort('argos: error delta',11)
      goto 2
      endif
      endif
c
c     new mcti
c
      if(inp_compare(.false.,'new',item)) then
      mropt=1
      goto 2
      endif
c
c     renew mcti
c
      if(inp_compare(.false.,'renew',item)) then
      mropt=2
      goto 2
      endif
c
c     extend mcti
c
      if(inp_compare(.false.,'extend',item)) then
      mropt=3
      goto 2
      endif
c
c     input for autocorrelation function error analysis
c
      if(inp_compare(.false.,'auto',item)) then
      if(.not.inp_i(nacfl)) call md_abort('argos: error auto',3)
  202 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'fit',item)) then
      if(.not.inp_i(iapprx)) call md_abort('argos: error fit',3)
      if(iapprx.lt.0) iapprx=0
      if(iapprx.gt.15) iapprx=15
      goto 202
      endif
      if(inp_compare(.false.,'weight',item)) then
      if(.not.inp_f(weight)) call md_abort('argos: error weight',3)
      if(weight.lt.0.0) weight=0.0
      goto 202
      endif
      goto 3
      endif
c
c     input for md and mcti
c
      if(inp_compare(.false.,'time',item)) then
      if(.not.inp_f(stime)) call md_abort('argos: error start',3)
      goto 2
      endif
c
      if(inp_compare(.false.,'step',item)) then
      if(.not.inp_f(tstep)) call md_abort('argos: error step',3)
      goto 2
      endif
c
      if(inp_compare(.false.,'leapfrog',item)) then
      mdalgo=1
      goto 2
      endif
c
      if(inp_compare(.false.,'leapfrog_bc',item)) then
      mdalgo=2
      goto 2
      endif
c
      if(inp_compare(.false.,'equil',item)) then
      if(.not.inp_i(mequi)) call md_abort('argos: error equil',3)
      goto 2
      endif
c
      if(inp_compare(.false.,'data',item)) then
      if(.not.inp_i(mdacq)) call md_abort('argos: error data',4)
      ldacq=mdacq
      if(.not.inp_a(item)) goto 1
      if(.not.inp_compare(.false.,'over',item)) goto 3
      if(.not.inp_i(ldacq)) call md_abort('argos: error over',5)
      goto 2
      endif
c
c     constant pressure
c
c     isobar [<pres_ext>] [trelax <prsrlx>] [compress <compr>]
c
      if(inp_compare(.false.,'isobar',item)) then
      ipscal=1
      if(inp_f(prsext)) ipscal=1
  250 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'trelax',item)) then
      if(.not.inp_f(prsrlx))
     + call md_abort('argos: error p_trelax',12)
      goto 250
      endif
      if(inp_compare(.false.,'compress',item)) then
      if(.not.inp_f(compr)) call md_abort('argos: error compress',13)
      goto 250
      endif
      if(inp_compare(.false.,'anisotropic',item)) then
      ipscal=2
      goto 250
      endif
      if(inp_compare(.false.,'xy',item)) then
      ipopt=12
      goto 250
      endif
      if(inp_compare(.false.,'z',item)) then
      ipopt=3
      goto 250
      endif
      if(inp_compare(.false.,'xy-z',item)) then
      ipopt=123
      goto 250
      endif
      goto 3
      endif
c
c     constant temperature
c
c     isotherm [<tmpext> [tmpext2>]] [trelax <tmprlx> [<tmsrlx>]] \
c              [anneal <tanneal1> [<tanneal2>]]
c
      if(inp_compare(.false.,'isotherm',item)) then
      itscal=1
      if(inp_f(tmpext)) itscal=1
      if(.not.inp_f(tmpext2)) tmpext2=tmpext
  252 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'trelax',item)) then
      if(.not.inp_f(tmprlx))
     + call md_abort('argos: error t_trelax',14)
      if(inp_f(tmsrlx)) itscal=2
      goto 252
      endif
      if(inp_compare(.false.,'anneal',item)) then
      if(.not.inp_f(tann1))
     + call md_abort('argos: error t_tanneal',14)
      if(.not.inp_f(tann2)) then
      tann2=tann1
      tann1=0.0d0
      endif
      goto 252
      endif
      goto 3
      endif
c
c     qhop proton hopping
c
      if(inp_compare(.false.,'qhop',item)) then
      if(.not.inp_i(nfhop)) nfhop=10
      if(.not.inp_f(rhop)) rhop=0.35d0
      if(.not.inp_f(thop)) thop=0.02d0
      goto 2
      endif
c
c     guided dynamics
c
      if(inp_compare(.false.,'guided',item)) then
      iguide=1
      if(.not.inp_f(fguide)) fguide=0.2d0
      if(.not.inp_f(tguide)) tguide=0.2d0
      goto 2
      endif
c
c     membrane setup options
c
      if(inp_compare(.false.,'membrane',item)) then
      imembr=1
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'rotations',item)) then
      imembr=2
      goto 2
      endif
      goto 3
      endif
c
c     solute center of mass options
c
      if(inp_compare(.false.,'scmxy',item)) then
      if(.not.inp_i(icmopt)) icmopt=1
      goto 2
      endif
c
c     reaction field
c
      if(inp_compare(.false.,'react',item)) then
      ireact=1
      if(inp_f(dielec)) ireact=1
      goto 2
      endif
c
c     external field
c
      if(inp_compare(.false.,'field',item)) then
      if(.not.inp_f(xfield)) call md_abort('argos: error xfield',13)
      ifield=1
  260 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'freq',item)) then
      if(.not.inp_f(xffreq)) call md_abort('argos: error xffreq',13)
      goto 260
      endif
      if(inp_compare(.false.,'vector',item)) then
      if(.not.inp_f(xfvect(1)))
     + call md_abort('argos: error xfvector x',13)
      if(.not.inp_f(xfvect(2)))
     + call md_abort('argos: error xfvector y',13)
      if(.not.inp_f(xfvect(3)))
     + call md_abort('argos: error xfvector z',13)
      goto 260
      endif
      goto 3
      endif
c
c     pmf
c
      if(inp_compare(.false.,'pmf',item)) then
      npmf=1
      facpmf=1.0d0
  288 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'equilharm',item)) then
      if(.not.inp_i(npmf)) call md_abort('argos: error equilharm',0)
      if(npmf.le.1) call md_abort('argos: error equilharm',npmf)
      if(.not.inp_a(item)) goto 1
      elseif(inp_compare(.false.,'scale',item).or.
     + inp_compare(.false.,'scale_factor',item)) then
      if(.not.inp_f(facpmf))
     + call md_abort('argos: error pmf scale',0)
      endif
      goto 2
      endif
c
c     collapse
c
      if(inp_compare(.false.,'collapse',item)) then
      ncolt=0
      ncoll=3
      fcoll=1.0d+01
  278 continue
      if(.not.inp_f(fcoll)) then
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'segment',item)) then
      ncolt=3
      ncoll=6
      goto 278
      endif
      if(inp_compare(.false.,'z',item)) then
      ncoll=ncolt+1
      goto 278
      endif
      if(inp_compare(.false.,'xy',item)) then
      ncoll=ncolt+2
      goto 278
      endif
      endif
      goto 2
      endif
c
c     include
c
      if(inp_compare(.false.,'include',item)) then
      if(.not.inp_a(item)) call md_abort('argos: error include',0)
      if(inp_compare(.false.,'fixed',item)) then
      includ=1
      else
      call md_abort('argos: error include option',0)
      endif
      goto 2
      endif
c
c     distance restraints
c
      if(inp_compare(.false.,'distar',item)) then
      ndistr=1
  241 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'draver',item)) then
      ndaver=1
      if(inp_f(disrlx)) ndaver=1
      goto 241
      elseif(inp_compare(.false.,'scale',item)) then
      if(.not.inp_f(drsscl))
     + call md_abort('argos: error distar scale',13)
      goto 241
      elseif(inp_compare(.false.,'after',item)) then
      if(.not.inp_i(nfdrss))
     + call md_abort('argos: error distar scale',13)
      goto 241
      endif
      endif
c
c     development flag
c
      if(inp_compare(.false.,'develop',item)) then
      if(.not.inp_i(idevel)) call md_abort('argos: error develop',3)
      goto 2
      endif
c
c     particle-mesh Ewald
c
c     ewald [ grid <i ngx> [ <i ngy> [ <i ngz> ] ] ]
c
      if(inp_compare(.false.,'ewald',item).or.
     + inp_compare(.false.,'pme',item)) then
      ipme=1
  251 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'grid',item)) then
      if(.not.inp_i(ngx)) call md_abort('argos: error grid',13)
      ngy=ngx
      ngz=ngx
      if(inp_i(ngy)) then
      if(.not.inp_i(ngz)) ngz=ngy
      endif
      goto 251
      endif
      if(inp_compare(.false.,'alpha',item)) then
      if(.not.inp_f(ealpha)) call md_abort('argos: error alpha',13)
      goto 251
      endif
      if(inp_compare(.false.,'order',item)) then
      if(.not.inp_i(morder)) call md_abort('argos: error order',13)
      goto 251
      endif
      if(inp_compare(.false.,'fft',item)) then
      if(.not.inp_i(imfft)) call md_abort('argos: error fft',13)
      goto 251
      endif
      if(inp_compare(.false.,'procs',item)) then
      if(.not.inp_i(nodpme)) call md_abort('argos: error procs',13)
      goto 251
      endif
      if(inp_compare(.false.,'nodes',item)) then
      if(.not.inp_i(nodpme)) call md_abort('argos: error nodes',13)
      goto 251
      endif
      if(inp_compare(.false.,'solvent',item)) then
      isolvo=1
      goto 251
      endif
      goto 3
      endif
c
c     fix [solvent] [solute]
c
      if(inp_compare(.false.,'fix',item).or.
     + inp_compare(.false.,'free',item)) then
c
      ifix=1
      afix=' '
      rfix=0.0d0
      if(inp_compare(.false.,'free',item)) ifix=0
c
      if(.not.inp_a(item)) call md_abort('argos: error fix',1)
c
      if(inp_compare(.false.,'solvent',item)) then
      if(.not.inp_i(ifirst)) then
      if(.not.inp_a(item)) then
      ifirst=0
      ilast=0
      else
      ifirst=-1
      if(inp_compare(.false.,'within',item)) then
      if(.not.inp_f(rfix)) call md_abort('argos: error fix',2)
      if(.not.inp_a(afix)) call md_abort('argos: error fix',3)
      ilast=-1
      elseif(inp_compare(.false.,'beyond',item)) then
      if(.not.inp_f(rfix)) call md_abort('argos: error fix',4)
      if(.not.inp_a(afix)) call md_abort('argos: error fix',5)
      ilast=-2
      else
      call md_abort('argos: error fix',6)
      endif
      endif
      else
      if(.not.inp_i(ilast)) ilast=ifirst
      endif
      write(lfncmd,1001) ifix,ifirst,ilast,rfix,afix
 1001 format('fix w ',i2,2i10,f12.6,a)
      numfix=numfix+1
      goto 2
      endif
c
      if(inp_compare(.false.,'solute',item)) then
      if(.not.inp_i(ifirst)) then
      if(.not.inp_a(item)) then
      ifirst=0
      ilast=0
      else
      ifirst=-1
      if(inp_compare(.false.,'within',item)) then
      if(.not.inp_f(rfix)) call md_abort('argos: error fix',7)
      if(.not.inp_a(afix)) call md_abort('argos: error fix',8)
      ilast=-1
      elseif(inp_compare(.false.,'beyond',item)) then
      if(.not.inp_f(rfix)) call md_abort('argos: error fix',9)
      if(.not.inp_a(afix)) call md_abort('argos: error fix',10)
      ilast=-2
      else
      call md_abort('argos: error fix',11)
      endif
      endif
      else
      if(.not.inp_i(ilast)) ilast=ifirst
      endif
      if(.not.inp_a(item)) then
      write(lfncmd,1002) ifix,ifirst,ilast,rfix,afix
 1002 format('fix s ',i2,2i10,f12.6,a)
      numfix=numfix+1
      goto 2
      else
      if(inp_compare(.false.,'heavy',item)) then
      write(lfncmd,1003) ifix,ifirst,ilast
 1003 format('fix x ',i2,2i10)
      numfix=numfix+1
      goto 2
      else
 1113 continue
      write(lfncmd,1004) ifix,ifirst,ilast,item(1:index(item,' ')-1)
 1004 format('fix s ',i2,2i10,12x,a)
      numfix=numfix+1
      if(inp_a(item)) goto 1113
      goto 2
      endif
      endif
      endif
c
      if(inp_compare(.false.,'permanent',item)) then
      write(lfncmd,1005)
 1005 format('fix p ')
      numfix=numfix+1
      goto 2
      endif
c
      if(inp_compare(.false.,'select',item)) then
      if(.not.inp_a(item)) call md_abort('argos_input fix select',14)
      write(lfncmd,1006) ifix,0.0d0,item
 1006 format('fix S ',i2,20x,f12.6,a)
      numfix=numfix+1
      goto 2
      endif
c
      call md_abort('argos: unrecognized fix/free command',13)
      endif
c
c      if(inp_compare(.false.,'fix',item)) then
c  261 continue
c      if(.not.inp_a(item)) goto 1
c  361 continue
c      if(inp_compare(.false.,'all',item)) then
c      ifix=ior(ifix,1)
c      goto 261
c      endif
c      if(inp_compare(.false.,'solvent',item)) then
c      ifix=ior(ifix,2)
c      goto 261
c      endif
c      if(inp_compare(.false.,'solute',item)) then
c      ifix=ior(ifix,4)
c      if(.not.inp_a(item)) goto 1
c      if(inp_compare(.false.,'fraction',item)) then
cc      do 5 i=1,msf
cc      lsffix(i)=0
cc    5 continue
cc      do 6 i=1,msf
cc      if(.not.inp_i(n)) goto 261
cc      if(n.gt.0.and.n.le.msf) lsffix(n)=1
cc    6 continue
c      goto 261
c      endif
c      goto 361
c      endif
c      if(inp_compare(.false.,'non-H',item)) then
c      ifix=ior(ifix,8)
c      goto 261
c      endif
c      goto 3
c      endif
c
c     fix [solvent] [solute]
c
c      if(inp_compare(.false.,'unfix',item)) then
c  262 continue
c      if(.not.inp_a(item)) goto 1
c      if(inp_compare(.false.,'all',item)) then
c      iunfix=ior(iunfix,1)
c      goto 262
c      endif
c      if(inp_compare(.false.,'solvent',item)) then
c      iunfix=ior(iunfix,2)
c      goto 262
c      endif
c      if(inp_compare(.false.,'solute',item)) then
c      iunfix=ior(iunfix,4)
c      goto 262
c      endif
c      if(inp_compare(.false.,'non-H',item)) then
c      iunfix=ior(iunfix,8)
c      goto 262
c      endif
c      goto 3
c      endif
c
c     noshake [solvent] [solute]
c
      if(inp_compare(.false.,'noshake',item)) then
c      noshak=3
  263 continue
      if(.not.inp_a(item)) then
        if(noshak.eq.0) noshak=3
        goto 1
      end if
      if(inp_compare(.false.,'solvent',item)) then
      if(noshak.eq.0) noshak=1
      if(noshak.eq.2) noshak=3
      goto 263
      endif
      if(inp_compare(.false.,'solute',item)) then
      if(noshak.eq.0) noshak=2
      if(noshak.eq.1) noshak=3
      goto 263
      endif
      goto 3
      endif
c
c     hessian
c
      if(inp_compare(.false.,'profile',item)) then
      if(.not.inp_i(iprof)) iprof=1
      goto 2
      endif
c
c     hessian
c
      if(inp_compare(.false.,'hessian',item)) then
      ihess=1
      goto 2
      endif
c
c     radius of gyration
c
      if(inp_compare(.false.,'radius_gyration',item)) then
      iradgy=1
      goto 2
      endif
c
c     diffusion coefficients
c
      if(inp_compare(.false.,'diffusion',item)) then
      idifco=1
      goto 2
      endif
c
c     velocity reassignment
c
      if(inp_compare(.false.,'vreass',item).or.
     + inp_compare(.false.,'reassign',item)) then
      if(.not.inp_i(nfgaus)) call md_abort('argos: error vreass',13)
      if(nfgaus.lt.0) nfgaus=-1
      if(.not.inp_f(tgauss)) call md_abort('argos: error vreass',13)
  900 continue
      if(.not.inp_a(item)) goto 1
c
      if(inp_compare(.false.,'fraction',item)) then
      if(.not.inp_f(frgaus)) then
      frgaus=0.5
      goto 900
      endif
      if(frgaus.lt.0.0) frgaus=0.0
      if(frgaus.gt.1.0) frgaus=1.0
      goto 900
      endif
c
      if(inp_compare(.false.,'once',item)) then
      ivopt=ior(ivopt,1)
      goto 900
      endif
c
      if(inp_compare(.false.,'first',item).or.
     + inp_compare(.false.,'initial',item)) then
      ivopt=ior(ivopt,2)
      goto 900
      endif
c
      if(inp_compare(.false.,'last',item).or.
     + inp_compare(.false.,'final',item)) then
      ivopt=ior(ivopt,4)
      goto 900
      endif
c
      goto 2
      endif
c
c     QM zero energy
c
      if(inp_compare(.false.,'eqm',item)) then
      if(.not.inp_f(eqm)) call md_abort('argos: error eqm',0)
      goto 2
      endif
c
c     input for all calculations
c
      if(inp_compare(.false.,'cutoff',item)) then
  300 continue
      if(inp_f(rshort)) then
      rlong=rshort
      goto 300
      endif
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'short',item)) then
      if(.not.inp_f(rshort)) call md_abort('argos: error short',14)
      goto 300
      endif
      if(inp_compare(.false.,'long',item)) then
      if(.not.inp_f(rlong)) call md_abort('argos: error long',14)
      goto 300
      endif
      goto 3
      endif
c
      if(inp_compare(.false.,'atomlist',item)) then
      latom=1
      goto 2
      endif
c
      if(inp_compare(.false.,'polar',item)) then
      ipolt=1
  400 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'first',item)) then
      ipolt=1
      goto 400
      endif
      if(inp_compare(.false.,'scf',item)) then
      ipolt=3
      if(.not.inp_i(mpolit)) mpolit=10
      if(inp_f(ptol)) goto 400
      goto 400
      endif
      goto 3
      endif
c
      if(inp_compare(.false.,'shake',item)) then
      if(inp_i(mshitw)) then
      mshits=mshitw
      if(inp_i(mshits)) then
      endif
      endif
      if(inp_f(tlwsha)) then
      tlssha=tlwsha
      if(inp_f(tlssha)) then
      endif
      endif
      goto 2
      endif
c
c     communication option
c
      if(inp_compare(.false.,'comlim',item)) then
      if(.not.inp_a(item)) call md_abort('argos: error comlim',0)
      if(inp_compare(.false.,'on',item)) then
      icomm=1
      goto 2
      elseif(inp_compare(.false.,'off',item)) then
      icomm=0
      goto 2
      else
      call md_abort('argos: error comlim',0)
      endif
      endif
c
      if(inp_compare(.false.,'detail',item)) then
      if(.not.inp_i(npstat)) npstat=1
      goto 2
      endif
c
c     print flags
c
      if(inp_compare(.false.,'print',item)) then
  500 continue
      if(.not.inp_a(item)) goto 1
  501 continue
      if(inp_compare(.false.,'step',item)) then
      if(.not.inp_i(nfoutp)) call md_abort('argos: error step',20)
      goto 500
      endif
      if(inp_compare(.false.,'stat',item)) then
      if(.not.inp_i(nfstat)) call md_abort('argos: error stat',20)
      goto 500
      endif
      if(inp_compare(.false.,'dayout',item)) then
      itrack=1
      goto 500
      endif
      if(inp_compare(.false.,'out6',item)) then
      lfout6=1
      goto 500
      endif
      if(inp_compare(.false.,'pmf',item)) then
      if(.not.inp_i(iprpmf)) iprpmf=-1
      goto 500
      endif
      if(inp_compare(.false.,'extra',item)) then
      npstep=1
      goto 500
      endif
      if(inp_compare(.false.,'energy',item)) then
      if(.not.inp_i(npener)) npener=1
      goto 500
      endif
      if(inp_compare(.false.,'energies',item)) then
      if(.not.inp_i(npener)) npener=1
      goto 500
      endif
      if(inp_compare(.false.,'forces',item)) then
      if(.not.inp_i(npforc)) npforc=1
      goto 500
      endif
      if(inp_compare(.false.,'matrix',item)) then
      npdist=1
      goto 500
      endif
      if(inp_compare(.false.,'expect',item)) then
      if(.not.inp_i(npxpct)) call md_abort('argos: error expect',20)
      goto 500
      endif
      if(inp_compare(.false.,'timing',item)) then
      nptmng=ga_nnodes()-1
      goto 500
      endif
      if(inp_compare(.false.,'topol',item)) then
  502 continue
      if(.not.inp_a(item)) then
      nptopw=1
      nptops=1
      npatom=1
      goto 1
      endif
  503 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'solvent',item)) then
      nptopw=1
      goto 503
      endif
      if(inp_compare(.false.,'solute',item)) then
      nptops=1
      goto 503
      endif
      if(inp_compare(.false.,'nonbond',item)) then
      npatom=1
      goto 503
      endif
      goto 501
      endif
      goto 3
      endif
c
c     update
c
      if(inp_compare(.false.,'update',item)) then
  800 continue
      if(.not.inp_a(item)) goto 1
  801 continue
      if(inp_compare(.false.,'pairs',item)) then
      if(.not.inp_i(nfpair)) call md_abort('argos: error pair',20)
      goto 800
      endif
      if(inp_compare(.false.,'esp',item)) then
      if(.not.inp_i(nfesp)) call md_abort('argos: error esp',20)
      goto 800
      endif
      if(inp_compare(.false.,'long',item)) then
      if(.not.inp_i(nflong)) call md_abort('argos: error long',20)
      goto 800
      endif
      if(inp_compare(.false.,'analysis',item).or.
     + inp_compare(.false.,'analyze',item)) then
      if(.not.inp_i(nfanal)) call md_abort('argos: error anal',20)
      goto 800
      endif
      if(inp_compare(.false.,'center',item)) then
      if(.not.inp_i(nfcntr)) call md_abort('argos: error center',20)
      icentr=3
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'zonly',item)) then
      icentr=1
      if(.not.inp_a(item)) goto 1
      endif
      if(inp_compare(.false.,'xyonly',item)) then
      icentr=2
      if(.not.inp_a(item)) goto 1
      endif
      if(inp_compare(.false.,'fraction',item)) then
      nscb=0
  802 continue
      if(inp_i(itemp)) then
      nscb=nscb+1
      idscb(nscb)=itemp
      if(nscb.lt.10) goto 802
      goto 800
      endif
      goto 800
      else
      nscb=1
      idscb(1)=1
      goto 801
      endif
      goto 800
      endif
      if(inp_compare(.false.,'motion',item)) then
      if(.not.inp_i(nfslow)) call md_abort('argos: error motion',20)
      goto 800
      endif
      if(inp_compare(.false.,'rdf',item)) then
      if(.not.inp_i(nfrdf)) call md_abort('argos: error rdf',20)
  803 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'range',item)) then
      if(.not.inp_f(rrdf)) call md_abort('argos: error range',20)
      goto 803
      endif
      if(inp_compare(.false.,'bins',item)) then
      if(.not.inp_i(ngl)) call md_abort('argos: error bins',20)
      goto 803
      endif
      goto 801
      endif
      goto 2
      endif
c
c     recording
c
      if(inp_compare(.false.,'record',item)) then
  600 continue
      if(.not.inp_a(item)) goto 1
  601 continue
      if(inp_compare(.false.,'rest',item)) then
      if(.not.inp_i(nfrest)) call md_abort('argos: error restart',20)
      if(.not.inp_a(item)) goto 1
      if(.not.inp_compare(.false.,'keep',item)) goto 601
      keepr=1
      goto 600
      endif
      if(inp_compare(.false.,'acf',item)) then
      nfauto=1
      goto 600
      endif
      if(inp_compare(.false.,'cnv',item)) then
      nfconv=1
      goto 600
      endif
      if(inp_compare(.false.,'fet',item)) then
      nffet=1
      goto 600
      endif
      if(inp_compare(.false.,'precision',item)) then
      if(.not.inp_i(nprec)) call md_abort('argos: error coord',20)
      goto 600
      endif
      if(inp_compare(.false.,'coord',item)) then
      if(.not.inp_i(nfcoor)) call md_abort('argos: error coord',20)
      goto 600
      endif
      if(inp_compare(.false.,'wcoor',item)) then
      if(.not.inp_i(nfwcoo)) call md_abort('argos: error scoor',20)
      goto 600
      endif
      if(inp_compare(.false.,'scoor',item)) then
      if(.not.inp_i(nfscoo)) call md_abort('argos: error scoor',20)
      goto 600
      endif
      if(inp_compare(.false.,'veloc',item)) then
      if(.not.inp_i(nfvelo)) call md_abort('argos: error veloc',20)
      goto 600
      endif
      if(inp_compare(.false.,'wvelo',item)) then
      if(.not.inp_i(nfwvel)) call md_abort('argos: error svelo',20)
      goto 600
      endif
      if(inp_compare(.false.,'svelo',item)) then
      if(.not.inp_i(nfsvel)) call md_abort('argos: error svelo',20)
      goto 600
      endif
      if(inp_compare(.false.,'force',item)) then
      if(.not.inp_i(nfforc)) call md_abort('argos: error force',20)
      goto 600
      endif
      if(inp_compare(.false.,'wforc',item)) then
      if(.not.inp_i(nfwfor)) call md_abort('argos: error sforc',20)
      goto 600
      endif
      if(inp_compare(.false.,'sforc',item)) then
      if(.not.inp_i(nfsfor)) call md_abort('argos: error sforc',20)
      goto 600
      endif
      if(inp_compare(.false.,'prop',item)) then
      if(.not.inp_i(nfprop)) call md_abort('argos: error prop',20)
      iprop=0
      if(nfprop.lt.0) then
      iprop=1
      nfprop=-nfprop
      endif
      goto 600
      endif
      if(inp_compare(.false.,'prop_average',item)) then
      if(.not.inp_i(nfprop)) call md_abort('argos: error prop',20)
      iprop=1
      goto 600
      endif
      if(inp_compare(.false.,'free',item)) then
      if(.not.inp_i(nffree)) call md_abort('argos: error free',20)
      goto 600
      endif
      if(inp_compare(.false.,'sync',item)) then
      if(.not.inp_i(nfsync)) call md_abort('argos: error sync',20)
      goto 600
      endif
      if(inp_compare(.false.,'binary',item)) then
      ibinar=1
      goto 600
      endif
      if(inp_compare(.false.,'ascii',item)) then
      ibinar=0
      goto 600
      endif
      if(inp_compare(.false.,'ecce',item)) then
      iformt=1
      goto 600
      endif
      if(inp_compare(.false.,'argos',item)) then
      iformt=0
      goto 600
      endif
      if(inp_compare(.false.,'times',item)) then
      if(inp_i(nftime)) then
  602 continue
      if(inp_i(i)) then
      if(i.gt.0) then
      idtime=idtime+1
      else
      i=-i
      endif
      itime(i)=idtime
      goto 602
      endif
      goto 600
      endif
      endif
      goto 2
      endif
c
c     batch
c
      if(inp_compare(.false.,'batch',item)) then
      if(.not.inp_i(nfnewf)) call md_abort('argos: error batch',15)
      goto 2
      endif
c
c     importing
c
      if(inp_compare(.false.,'import',item)) then
      if(.not.inp_i(impfr)) then
      impfr=1
      impto=1
      nftri=1
      goto 2
      endif
      if(.not.inp_i(impto)) then
      impto=impfr
      impfr=1
      nftri=1
      goto 2
      endif
      if(.not.inp_i(nftri)) nftri=1
      goto 2
      endif
c
c     other stuff
c
      if(inp_compare(.false.,'memory',item)) then
      if(.not.inp_i(memlim)) call md_abort('argos: error memory',15)
      goto 2
      endif
      if(inp_compare(.false.,'extra',item)) then
      if(.not.inp_i(madbox)) call md_abort('argos: error extra',15)
      goto 2
      endif
      if(inp_compare(.false.,'mwm',item)) then
      if(.not.inp_i(mwmreq)) call md_abort('argos: error mwm',15)
      goto 2
      endif
      if(inp_compare(.false.,'msa',item)) then
      if(.not.inp_i(msareq)) call md_abort('argos: error msa',15)
      goto 2
      endif
      if(inp_compare(.false.,'mbb',item)) then
      if(.not.inp_i(mbbreq)) call md_abort('argos: error mbb',15)
      goto 2
      endif
      if(inp_compare(.false.,'mcells',item)) then
      if(.not.inp_i(mbbreq)) call md_abort('argos: error mcells',15)
      goto 2
      endif
      if(inp_compare(.false.,'load',item)) then
      loadb=0
      if(.not.inp_i(nfload)) nfload=1
  700 continue
      if(.not.inp_a(item)) goto 1
      if(inp_compare(.false.,'none',item)) then
      loadb=0
      goto 700
      endif
      if(inp_compare(.false.,'reset',item)) then
      ireset=1
      goto 700
      endif
      if(inp_compare(.false.,'last',item)) then
      itload=0
      goto 700
      endif
      if(inp_compare(.false.,'minimum',item)) then
      itload=1
      goto 700
      endif
      if(inp_compare(.false.,'average',item)) then
      itload=2
      goto 700
      endif
      if(inp_compare(.false.,'combination',item)) then
      itload=3
      goto 700
      endif
      if(inp_compare(.false.,'iotime',item)) then
      ioload=1
      goto 700
      endif
      if(inp_compare(.false.,'experimental',item)) then
      ioload=2
      goto 700
      endif
      if(inp_compare(.false.,'sizez',item)) then
      isload=1
      if(loadb.eq.0) loadb=1
      if(loadb.eq.2) loadb=3
      if(inp_f(factld)) goto 700
      goto 700
      endif
      if(inp_compare(.false.,'size',item)) then
      if(loadb.eq.0) loadb=1
      if(loadb.eq.2) loadb=3
      if(inp_f(factld)) goto 700
      goto 700
      endif
      if(inp_compare(.false.,'pairs',item)) then
      if(loadb.eq.0) loadb=2
      if(loadb.eq.1) loadb=3
      if(.not.inp_i(lbpair)) goto 700
      lbpair=min(lbpair,50)
      goto 700
      endif
      goto 2
      endif
      if(inp_compare(.false.,'debug',item)) then
      if(.not.inp_i(i)) call md_abort('argos: error debug',15)
  555 continue
      if(i.le.0) then
      idebug=0
      else
      idebug=ior(idebug,2**(i-1))
      endif
      if(inp_i(i)) goto 555
      goto 2
      endif
      if(inp_compare(.false.,'test',item)) then
      if(.not.inp_i(itest)) call md_abort('argos: error test',15)
      goto 2
      endif
      if(inp_compare(.false.,'nopack',item)) then
      nopack=1
      goto 2
      endif
      if(inp_compare(.false.,'pack',item)) then
      nopack=0
      goto 2
      endif
      if(inp_compare(.false.,'control',item)) then
      if(.not.inp_i(icntrl)) call md_abort('argos: error control',15)
      goto 2
      endif
      if(inp_compare(.false.,'scale',item)) then
      if(.not.inp_f(scaleq)) call md_abort('argos: error scale',15)
      goto 2
      endif
c
      if(.not.inp_compare(.false.,'end',item)) then
      write(6,9999) item
 9999 format('argos: unknown field ',a)
      call md_abort('argos: error reading input file',0)
      endif
c
      if(.not.expert) then
      if(nflong.gt.1.and.ipme.gt.0)
     + call md_abort('argos: PME nflong>1 only in expert mode',0)
      endif
c
      if(nfscoo.lt.0) nfscoo=nfcoor
      if(nfsvel.lt.0) nfsvel=nfvelo
      if(nfsfor.lt.0) nfsfor=nfforc
      if(nfwcoo.lt.0) nfwcoo=nfcoor
      if(nfwvel.lt.0) nfwvel=nfvelo
      if(nfwfor.lt.0) nfwfor=nfforc
      if(nfscoo.lt.0) nfscoo=0
      if(nfsvel.lt.0) nfsvel=0
      if(nfsfor.lt.0) nfsfor=0
      if(nfwcoo.lt.0) nfwcoo=0
      if(nfwvel.lt.0) nfwvel=0
      if(nfwfor.lt.0) nfwfor=0
c
      numcmd=numfix
c
c     put input in rtdb
c
      if(project(1:1).ne.' ') then
      if(.not.rtdb_cput(irtdb,'md:project',1,project))
     + call md_abort('argos: rtdb_put failed',0)
      endif
      if(.not.rtdb_put(irtdb,'md:port',mt_int,1,iport))
     + call md_abort('argos: rtdb_put failed',0)
      if(iport.gt.0) then
      if(.not.rtdb_cput(irtdb,'md:server',1,server))
     + call md_abort('argos: rtdb_put failed',0)
      endif
c
      if(.not.rtdb_put(irtdb,'md:istart',mt_int,1,istart))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nbx',mt_int,1,nbx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nby',mt_int,1,nby))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nbz',mt_int,1,nbz))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npx',mt_int,1,npx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npy',mt_int,1,npy))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npz',mt_int,1,npz))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npg',mt_int,1,npg))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ncp',mt_int,1,ncp))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mdalgo',mt_int,1,mdalgo))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iset',mt_int,1,iset))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:isetp1',mt_int,1,isetp1))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:isetp2',mt_int,1,isetp2))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iforw',mt_int,1,iforw))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:msdit',mt_int,1,msdit))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mcgit',mt_int,1,mcgit))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:icrit',mt_int,1,icrit))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ncgcy',mt_int,1,ncgcy))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mrun',mt_int,1,mrun))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:maxlam',mt_int,1,maxlam))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npgdec',mt_int,1,npgdec))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:issscl',mt_int,1,issscl))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mequi',mt_int,1,mequi))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mdacq',mt_int,1,mdacq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ldacq',mt_int,1,ldacq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nacfl',mt_int,1,nacfl))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iapprx',mt_int,1,iapprx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ipscal',mt_int,1,ipscal))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ipopt',mt_int,1,ipopt))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:itscal',mt_int,1,itscal))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfgaus',mt_int,1,nfgaus))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ivopt',mt_int,1,ivopt))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ipolt',mt_int,1,ipolt))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mpolit',mt_int,1,mpolit))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mshitw',mt_int,1,mshitw))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mshits',mt_int,1,mshits))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:itrack',mt_int,1,itrack))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npstep',mt_int,1,npstep))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npstat',mt_int,1,npstat))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npener',mt_int,1,npener))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npforc',mt_int,1,npforc))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npdist',mt_int,1,npdist))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nptmng',mt_int,1,nptmng))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npatom',mt_int,1,npatom))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nptopw',mt_int,1,nptopw))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nptops',mt_int,1,nptops))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npxpct',mt_int,1,npxpct))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfpair',mt_int,1,nfpair))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfesp',mt_int,1,nfesp))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfrdf',mt_int,1,nfrdf))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nflong',mt_int,1,nflong))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfcntr',mt_int,1,nfcntr))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:icentr',mt_int,1,icentr))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfanal',mt_int,1,nfanal))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfslow',mt_int,1,nfslow))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfoutp',mt_int,1,nfoutp))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfstat',mt_int,1,nfstat))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfrest',mt_int,1,nfrest))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:keepr',mt_int,1,keepr))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfcoor',mt_int,1,nfwcoo))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfscoo',mt_int,1,nfscoo))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfvelo',mt_int,1,nfwvel))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfsvel',mt_int,1,nfsvel))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfforc',mt_int,1,nfwfor))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfsfor',mt_int,1,nfsfor))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfprop',mt_int,1,nfprop))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iprop',mt_int,1,iprop))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nffree',mt_int,1,nffree))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfsync',mt_int,1,nfsync))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfauto',mt_int,1,nfauto))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfconv',mt_int,1,nfconv))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nffet',mt_int,1,nffet))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:impfr',mt_int,1,impfr))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:impto',mt_int,1,impto))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nftri',mt_int,1,nftri))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iformt',mt_int,1,iformt))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:madbox',mt_int,1,madbox))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ireset',mt_int,1,ireset))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:loadb',mt_int,1,loadb))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mropt',mt_int,1,mropt))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:idebug',mt_int,1,idebug))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:icntrl',mt_int,1,icntrl))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ifidi',mt_int,1,ifidi))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ipbtyp',mt_int,1,ipbtyp))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ngl',mt_int,1,ngl))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ifield',mt_int,1,ifield))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ipme',mt_int,1,ipme))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ngx',mt_int,1,ngx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ngy',mt_int,1,ngy))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ngz',mt_int,1,ngz))
     + call md_abort('argos: rtdb_put failed',0)
c      if(.not.rtdb_put(irtdb,'md:ifix',mt_int,1,ifix))
c     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:numfix',mt_int,1,numfix))
     + call md_abort('argos: rtdb_put failed',0)
c      if(.not.rtdb_put(irtdb,'md:lsffix',mt_int,msf,lsffix))
c     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:noshak',mt_int,1,noshak))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfefld',mt_int,1,nfefld))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfsfld',mt_int,1,nfsfld))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nscb',mt_int,1,nscb))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:idscb',mt_int,nscb,idscb))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ireact',mt_int,1,ireact))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:memlim',mt_int,1,memlim))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:morder',mt_int,1,morder))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:isolvo',mt_int,1,isolvo))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:lfout6',mt_int,1,lfout6))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iprpmf',mt_int,1,iprpmf))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:imfft',mt_int,1,imfft))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mwmreq',mt_int,1,mwmreq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:msareq',mt_int,1,msareq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mbbreq',mt_int,1,mbbreq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:itest',mt_int,1,itest))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nodpme',mt_int,1,nodpme))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:lbpair',mt_int,1,lbpair))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ndistr',mt_int,1,ndistr))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:npmf',mt_int,1,npmf))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:facpmf',mt_dbl,1,facpmf))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfdrss',mt_int,1,nfdrss))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ndaver',mt_int,1,ndaver))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:idevel',mt_int,1,idevel))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:itime',mt_int,mtimes,itime))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nftime',mt_int,1,nftime))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfload',mt_int,1,nfload))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:itload',mt_int,1,itload))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ioload',mt_int,1,ioload))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:isload',mt_int,1,isload))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ihess',mt_int,1,ihess))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:latom',mt_int,1,latom))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:icomm',mt_int,1,icomm))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfhop',mt_int,1,nfhop))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:rhop',mt_dbl,1,rhop))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:thop',mt_dbl,1,thop))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iguide',mt_int,1,iguide))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:icmopt',mt_int,1,icmopt))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:imembr',mt_int,1,imembr))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nopack',mt_int,1,nopack))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iprof',mt_int,1,iprof))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:numcmd',mt_int,1,numcmd))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ncoll',mt_int,1,ncoll))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ilambd',mt_int,1,ilambd))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:mlambd',mt_int,1,mlambd))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:includ',mt_int,1,includ))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:iradgy',mt_int,1,iradgy))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:idifco',mt_int,1,idifco))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nfnewf',mt_int,1,nfnewf))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nbget',mt_int,1,nbget))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:nprec',mt_int,1,nprec))
     + call md_abort('argos: rtdb_put failed',0)
c
      if(.not.rtdb_put(irtdb,'md:fguide',mt_dbl,1,fguide))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tguide',mt_dbl,1,tguide))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:dx0sd',mt_dbl,1,dx0sd))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:dxsdmx',mt_dbl,1,dxsdmx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:dxmsd',mt_dbl,1,dxmsd))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:dx0cg',mt_dbl,1,dx0cg))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:dxcgmx',mt_dbl,1,dxcgmx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:dxmcg',mt_dbl,1,dxmcg))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:edacq',mt_dbl,1,edacq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ddacq',mt_dbl,1,ddacq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:fdacq',mt_dbl,1,fdacq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:delta',mt_dbl,1,delta))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:stime',mt_dbl,1,stime))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tstep',mt_dbl,1,tstep))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:prsext',mt_dbl,1,prsext))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:prsrlx',mt_dbl,1,prsrlx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:compr',mt_dbl,1,compr))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tmpext',mt_dbl,1,tmpext))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tmpext2',mt_dbl,1,tmpext2))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tmprlx',mt_dbl,1,tmprlx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tmsrlx',mt_dbl,1,tmsrlx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tann1',mt_dbl,1,tann1))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tann2',mt_dbl,1,tann2))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tgauss',mt_dbl,1,tgauss))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:frgaus',mt_dbl,1,frgaus))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:rlong',mt_dbl,1,rlong))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:rshort',mt_dbl,1,rshort))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ptol',mt_dbl,1,ptol))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tlwsha',mt_dbl,1,tlwsha))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:tlssha',mt_dbl,1,tlssha))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:factld',mt_dbl,1,factld))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:rrdf',mt_dbl,1,rrdf))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:xfield',mt_dbl,1,xfield))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:xffreq',mt_dbl,1,xffreq))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:xfvect',mt_dbl,3,xfvect))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:weight',mt_dbl,1,weight))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:dielec',mt_dbl,1,dielec))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:ealpha',mt_dbl,1,ealpha))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:rbox',mt_dbl,1,rbox))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:rsgm',mt_dbl,1,rsgm))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:disrlx',mt_dbl,1,disrlx))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:drsscl',mt_dbl,1,drsscl))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:uqmatm',mt_dbl,1,eqm))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:fcoll',mt_dbl,1,fcoll))
     + call md_abort('argos: rtdb_put failed',0)
      if(.not.rtdb_put(irtdb,'md:scaleq',mt_dbl,1,scaleq))
     + call md_abort('argos: rtdb_put failed',0)
c
      close(unit=lfncmd)
c
      return
c
 1999 continue
      call md_abort('argos: unable to open cmd file',13)
c
      return
      end

      subroutine dia_sizref()
c
c $Id: dia_sizref.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "dia_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*1 cdum
      integer i,nsm
c
      integer ibroad(10),nhist
      logical lforces
c
      if(me.eq.0) then
      open(unit=lfnref,file=filref(1:index(filref,' ')-1),
     + status='old',err=9999)
c
      read(lfnref,1000) cdum
      read(lfnref,1000) cdum
      read(lfnref,1000) cdum
 1000 format(a)
      read(lfnref,1001) nhist,lforces
 1001 format(32x,i5,4x,l1)
      if(nhist.gt.0) then
      do 1 i=1,nhist
      read(lfnref,1000) cdum
    1 continue
      endif
c
      read(lfnref,1000) cdum
c
      read(lfnref,1000) cdum
      read(lfnref,1000) cdum
      read(lfnref,1000) cdum
c
      read(lfnref,1000) cdum
      read(lfnref,1000) cdum
c
      read(lfnref,1002) nwm,nwa,nsm,nsai
 1002 format(4i10)
c
      close(unit=lfnref)
      endif
c
      msai=nsai
      nwmi=nwm
      mwmi=nwm
      nwai=nwa
      mwai=nwa
c
c     broadcast options to all nodes
c
      if(np.gt.1) then
      ibroad(1)=nsai
      ibroad(2)=msai
      ibroad(3)=nwmi
      ibroad(4)=mwmi
      ibroad(5)=nwai
      ibroad(6)=mwai
      call ga_brdcst(mag_d01,ibroad,6*ma_sizeof(mt_int,1,mt_byte),0)
      nsai=ibroad(1)
      msai=ibroad(2)
      nwmi=ibroad(3)
      mwmi=ibroad(4)
      nwai=ibroad(5)
      mwai=ibroad(6)
      endif
c
      return
c
 9999 continue
      call md_abort('Unable to open reference file',0)
      return
      end

CFrom lyang@tazdevil.llnl.gov Mon Sep 23 17:44:01 1991
CReturn-Path: <lyang@tazdevil.llnl.gov>
CReceived: from tazdevil.llnl.gov by  icose  (NeXT-1.0 (From Sendmail 5.52)/NeXT-2.0)
C	id AA06758; Mon, 23 Sep 91 17:43:58 CDT
CReceived: by tazdevil.llnl.gov (4.1/1.15)
C	id AA06980; Mon, 23 Sep 91 15:42:04 PDT
CDate: Mon, 23 Sep 91 15:42:04 PDT
CFrom: lyang@tazdevil.llnl.gov (Lin H. Yang)
CMessage-Id: <9109232242.AA06980@tazdevil.llnl.gov>
CTo: asmith@icose.msd.anl.gov
CSubject: library routines
CStatus: R
C
C
CI am including some library routines you will need for non-Cray machines.
C
CMakesure you also need to modify your Makefile to include the library routines.
C
C
C ********* SSCAL
C
      SUBROUTINE SSCAL(N,SCALE,ARRAY,INC)
      INTEGER*4 I,N,INC
      REAL*8 SCALE,ARRAY(*)
      DO 101 I = 1, N, INC
      ARRAY(I) = ARRAY(I) * SCALE
101   CONTINUE
      RETURN
      END
C
C ********* CSSCAL
C
      SUBROUTINE CSSCAL(N,SCALE,CARRAY,INC)
      INTEGER*4 I,N,INC
      REAL*8 SCALE
      DOUBLE COMPLEX CARRAY(*)
      DO 101 I = 1, N, INC
      CARRAY(I) = CARRAY(I) * SCALE
101   CONTINUE
      RETURN
      END
C
C *********** SSUM
C
      FUNCTION SSUM(N,ARRAY,INC)
      INTEGER*4 I,N,INC
      REAL*8 SSUM,ARRAY(*)
      SSUM = 0.0E0
      DO 101 I = 1, N, INC
      SSUM = SSUM + ARRAY(I)
101   CONTINUE
      RETURN
      END
C
C *********** CSUM
C
      FUNCTION CSUM(N,CARRAY,INC)
      INTEGER*4 I,N,INC
      DOUBLE COMPLEX CSUM,CARRAY(*)
      CSUM = CMPLX(0.0E0, 0.0E0)
      DO 101 I = 1, N, INC
      CSUM = CSUM + CARRAY(I)
101   CONTINUE
      RETURN
      END
C
C ********** SDOT
C
      FUNCTION SDOT(N,ARRAY,INC1,BRRAY,INC2)
      INTEGER*4 I,N,INC1,INC2,I1,I2
      REAL*8 SDOT,ARRAY(*),BRRAY(*)
      SDOT = 0.0E0
      DO 101 I = 1, N
      I1 = 1 + (I-1)*INC1
      I2 = 1 + (I-1)*INC2
      SDOT = SDOT + ARRAY(I1) * BRRAY(I2)
101   CONTINUE
      RETURN
      END
C
C ********** CDOTC
C
      FUNCTION CDOTC(N,CARRAY,INC1,CBRRAY,INC2)
      INTEGER*4 I,N,INC1,INC2,I1,I2
      DOUBLE COMPLEX CDOTC,CARRAY(*),CBRRAY(*)
      CDOTC = CMPLX(0.0E0, 0.0E0)
      DO 101 I = 1, N
      I1 = 1 + (I-1)*INC1
      I2 = 1 + (I-1)*INC2
      CDOTC = CDOTC + CONJG(CARRAY(I1)) * CBRRAY(I2)
101   CONTINUE
      RETURN
      END
C
C ********** SCNRM2
C
      FUNCTION SCNRM2(N,CARRAY,INC)
      INTEGER*4 I,N,INC
      REAL*8 SCNRM2
      DOUBLE COMPLEX CARRAY(*)
      SCNRM2 = 0.0E0
      DO 101 I = 1, N, INC
      SCNRM2 = SCNRM2 + ABS(CARRAY(I))**2
101   CONTINUE
      SCNRM2 = DSQRT(SCNRM2)
      RETURN
      END
C
C ********** CAXPY
C
      SUBROUTINE CAXPY(N,CNST,CARRAY,INC1,CBRRAY,INC2)
      INTEGER*4 I,N,INC1,INC2,I1,I2
      DOUBLE COMPLEX CNST,CARRAY(*),CBRRAY(*)
      DO 101 I = 1, N
      I1 = 1 + (I-1)*INC1
      I2 = 1 + (I-1)*INC2
      CBRRAY(I2) = CBRRAY(I2) + CNST * CARRAY(I1)
101   CONTINUE
      RETURN
      END
C
C ********** SCOPY
C
      SUBROUTINE SCOPY(N,ARRAY,INC1,BRRAY,INC2)
      INTEGER*4 I,N,INC1,INC2,I1,I2
      REAL*8 ARRAY(*),BRRAY(*)
      DO 101 I = 1, N
      I1 = 1 + (I-1)*INC1
      I2 = 1 + (I-1)*INC2
      BRRAY(I2) = ARRAY(I1)
101   CONTINUE
      RETURN
      END
C
C ********** CCOPY
C
      SUBROUTINE CCOPY(N,CARRAY,INC1,CBRRAY,INC2)
      INTEGER*4 I,N,INC1,INC2,I1,I2
      DOUBLE COMPLEX CARRAY(*),CBRRAY(*)
      DO 101 I = 1, N
      I1 = 1 + (I-1)*INC1
      I2 = 1 + (I-1)*INC2
      CBRRAY(I2) = CARRAY(I1)
101   CONTINUE
      RETURN
      END
C
C ********** ICOPY
C
      SUBROUTINE ICOPY(N,ARRAY,INC1,BRRAY,INC2)
      INTEGER I,N,INC1,INC2,I1,I2
      INTEGER ARRAY(*),BRRAY(*)
      DO 101 I = 1, N
      I1 = 1 + (I-1)*INC1
      I2 = 1 + (I-1)*INC2
      BRRAY(I2) = ARRAY(I1)
101   CONTINUE
      RETURN
      END
C
      SUBROUTINE GATHER(NSIZE,A_AR,B_AR,INDEX)
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION A_AR(*),B_AR(*),INDEX(*)
C
      DO 101 IA = 1, NSIZE
      A_AR(IA) = B_AR(INDEX(IA))
101   CONTINUE
      RETURN
      END
C
C ********* SECOND
C
      SUBROUTINE SECOND(ELAPSE)
C
C --- Returns the CPU time (seconds) since beginning of program.
C     Resolution of 0.01 second.
C
      REAL*8 ELAPSE
      REAL TARRAY(2),TIME_T
C
      TIME_T = ETIME(TARRAY)
      TIME_T = TARRAY(1)
      ELAPSE = TIME_T
C
      RETURN
      END
C
C ********* CLOCK
C
      SUBROUTINE CLOCK(TCLOCK)
C
C --- Returns the CLOCK time 
C
      CHARACTER*24 TJOB
      CHARACTER*1 TCLOCK(10),TJOB_T(24)
      EQUIVALENCE (TJOB,TJOB_T)
      INTEGER I, II
C
      CALL FDATE(TJOB)
      DO 101 I = 11, 20
      II = I - 10
      TCLOCK(II) = TJOB_T(I)
101   CONTINUE
C
      RETURN
      END
C
C ********* DATE
C
      SUBROUTINE DATE(TDATE)
C
C --- Returns the CLOCK time 
C
      CHARACTER*24 TJOB
      CHARACTER*1 TDATE(10),TJOB_T(24)
      EQUIVALENCE (TJOB,TJOB_T)
C
      CALL FDATE(TJOB)
      DO 101 I = 5, 10
      II = I - 4
      TDATE(II) = TJOB_T(I)
101   CONTINUE
      TDATE(7) = ' '
      TDATE(8) = ' '
      TDATE(9) = TJOB_T(23)
      TDATE(10) = TJOB_T(24)
C
      RETURN
      END
C
C ********* AIMAG
C
      DOUBLE PRECISION FUNCTION AIMAG(CX)
      DOUBLE COMPLEX CX
      AIMAG = IMAG(CX)
      RETURN
      END

C $Id: ecp_t1_Q3int.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_t1_Q3int (n,m,x,a_sqrt,Q3,temp,ind,tol)
*                                                                      *
*   Driver for calculation of type 1 Q^{m+p}_{m} integrals for p = 3   *
*                                                                      *
* Q^{m+p}_{m} = \int_0^\infty dr r^{m+p} e^{-\alpha r^2} i_m(\beta r)  *
*                                                                      *
*   where $i_m(\beta r)$ is the modified spherical Bessel function.    *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   n (inp) - number of Q integrals to be evaluated for given order    *
*   m (inp) - order of Q integral                                      *
*   x (inp) - array of values beta/2sqrt(alpha)                        *
*   a_sqrt (scr) - array of values of one/sqrt(alpha)                  *
*   Q3 (out) - Q^{m}_{m} integrals                                     *
*   temp (scr) - scratch array                                         *
*   ind (scr) - index array                                            *
*   tol (inp) - maximum relative error in bessel functions             *
*                                                                      *
*   Written by W. A. de Jong                                           *
*                                                                      *
************************************************************************
      implicit none
#include "ecp_consts.fh"
      integer i,m,n,na,np,n1,ind(n)
      double precision x(n),a_sqrt(n),Q3(n),temp(n,6),tol,
     &    m_plus_half,m_plus_2,log_accy
*
*   Initialize ind array
*
      do i = 1,n
        ind(i) = -1
      enddo
*
*   Gather arguments
*
      m_plus_2 = m+2
      m_plus_half = m_plus_2-half
      log_accy = log(tol)-log(two)-m_plus_half*log(m_plus_2)+m_plus_2
      na = 0
      np = 0
      n1 = n+1
      do i = 1,n
        if (x(i) .eq. zero) then
          if (m .eq. 0) then
            Q3(i) = a_sqrt(i)**4/two
          else
            Q3(i) = zero
          end if
        else if (log_accy+x(i)**2+two*m_plus_half*log(x(i)) .gt. zero) 
     &        then
          na = na+1
          temp(na,1) = x(i)
          temp(na,3) = a_sqrt(i)
          ind(na) = i
        else
          np = np+1
          temp(n1-np,1) = x(i)
          temp(n1-np,3) = a_sqrt(i)
          ind(n1-np) = i
        end if
      end do
      i = n1-np
*
      if (na.gt.0.or.np.gt.0) then
        if (na .gt. 0) call ecp_t1_Q3asy (na,m,temp(1,1),temp(1,2),
     &      temp(1,3),temp(1,6),tol)
        if (np .gt. 0) call ecp_t1_Q3pow (np,m,temp(i,1),temp(i,2),
     &      temp(i,3),temp(i,4),temp(i,5),temp(i,6),tol)
        do i = 1,n
          if (ind(i).gt.0)
     &        Q3(ind(i)) = temp(i,6)
        end do
      endif
*
      return
      end

      subroutine argos_cafe_sclq(iqfr,iqto,chg)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer iqfr,iqto
      real*8 chg(mqt,mqp,mset)
c
      integer i,j
c
      do 1 i=iqfr,iqto
      do 2 j=1,nparms
      chg(i,1,j)=scaleq*chg(i,1,j)
    2 continue
    1 continue
c
      return
      end
c $Id: argos_cafe_sclq.F 21176 2011-10-10 06:35:49Z d3y133 $

      function util_xyz_nframes(in_xyz,nf)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "inp.fh"
      character*(*) in_xyz
      integer nf
      logical util_xyz_nframes
c     local variables
      character*32 pname
      integer i,ns
      character*16 buf
      character*255 filename
      character*255 xyzfile
      character*255 message

      integer fn_xyz

      logical util_get_io_unit
      external util_get_io_unit

      message = "empty message for initialization"

      pname = "util_xyz_nframes"
      util_xyz_nframes = .false.
c
      xyzfile = in_xyz(1:inp_strlen(in_xyz))
      call util_file_name_resolve(xyzfile, .false.)
c
      filename = in_xyz(1:inp_strlen(xyzfile))
c
c     prepare files for reading/writing
c     ---------------------------------
      if(.not.util_get_io_unit(fn_xyz)) 
     >       call errquit("cannot get file number",0,0)
      filename = xyzfile
      open(fn_xyz,file=filename,form='formatted',status='old',
     $          err=133)
c
      nf = 0
c
c     get number of atoms
c     ------------------
  9   continue
      message = " number of atoms "
      read(fn_xyz,*,err=10,end=10) ns
c
c     seek frame
c     ----------
      message = " seek frame"
      do i=1,ns+1
        read(fn_xyz,*,err=10,end=10) buf 
c        for strict/hard processing use
c        read(fn_xyz,*,err=134,end=135) buf 
      end do
      nf = nf + 1
      goto 9
 10   continue 
      close(fn_xyz)
      util_xyz_nframes = .true.
      return
 133  call errquit(pname//'error opening/closing '//filename,0, 0)
 134  call errquit(pname//'error reading xyz file'//message,0, 0)
 135  call errquit(pname//'error end of file at'//message,0, 0)

      end

      function util_xyz_seek(fn_xyz,nf)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "inp.fh"
      integer fn_xyz
      integer nf
      logical util_xyz_seek
c     local variables
      integer sf
      character*32 pname
      integer i,ns
      character*16 buf
      character*255 message

      pname = "util_xyz_seek"
      util_xyz_seek = .false.
c
c     prepare files for reading/writing
c     ---------------------------------
      rewind(fn_xyz)
      sf = 0
c
c     get number of atoms
c     ------------------
  9   continue
      message = " number of atoms "
      read(fn_xyz,*,err=10,end=10) ns
c
c     seek frame
c     ----------
      message = " seek frame"
      do i=1,ns+1
        read(fn_xyz,*,err=10,end=10) buf 
      end do
      sf = sf + 1
      if(sf.eq.(nf-1)) then
        util_xyz_seek = .true.
        return
      end if 
      goto 9
 10   continue 
      return

      end
c $Id: util_xyz.F 25356 2014-03-17 14:14:20Z jhammond $

      subroutine smd_mass_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_mass,sp_param,sp_type
      character*32 tag,pname
      logical result

      pname = "smd_mass_init_system"
c
      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "mass"
      call smd_system_get_component(sp_mass,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_mass_init(sp_mass)
c
      return
      end

      subroutine smd_mass_init(sp_mass)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_mass
c
      character*32 pname
      character*80 tag
      integer na
      integer i_it
      integer i_mp,i_m,nmp
      logical result
c
      pname = "smd_mass_init"
c
c      write(*,*) "in "//pname
c
c     get type array
c     --------------
      tag = "type:id"
      call smd_get_ind_size(tag,i_it,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
c
c     get mass parameter array
c     ------------------------
      tag = "param:mass"
      call smd_get_ind_size(tag,i_mp,nmp,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
c
c     create mass structure
c     ---------------------
      call smd_namespace_create(sp_mass)
      tag = "mass"
      call smd_data_create_get(sp_mass,tag,na,MT_DBL,i_m)

      call smd_mass_set(na,
     +                  int_mb(i_it),
     +                  dbl_mb(i_mp),
     +                  dbl_mb(i_m))


      return
      end
c
      subroutine smd_mass_set(na,it,mp,m)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
      integer na
      integer it(na)
      double precision  mp(*)
      double precision m(na)
c
      integer i,j
 
      do i=1,na
       j=it(i)
       m(i) = mp(j)
      end do

      return
      end

c $Id: smd_mass.F 22502 2012-05-20 06:11:57Z d3y133 $

c
c $Id: nwpw_WGaussian.F 25915 2014-07-16 20:53:10Z bylaska $
c

*     ******************************************************
*     *                                                    *
*     *             nwpw_WGaussian                         *
*     *                                                    *
*     ******************************************************
*
*     Calculates the two electron two center Gaussian integral
*
*                                            //
*    WGaussian(la,ma,sa,lb,Ra,mb,sb,Rb)   =  || g(la,ma,sa;r-Ra) * g(lb,mb,sb;r'-Rb)  
*                                            || ------------------------------------  dr dr'
*                                            //                |r-r'|
*
*     where g(l,m,s; r) = C_l * |r|**l * exp(-(r/s)**2) * Tlm(rhat) 
*
*          and C_l = 2**(l+2) / (sqrt(pi) (2*l+1)!! s**(2*l+3) )
*           
*     The normalization constant C_l is defined such at
*            /
*            | g(l,m,s;r) * |r|**l *Tlm(rhat) dr = 1
*            /
*
      real*8 function nwpw_WGaussian(la,ma,sa,lb,mb,sb,Rab)
      implicit none
      integer la,ma,lb,mb
      real*8  sa,sb,Rab(3)
 
*     *** local variables ***
      integer l,m,fac,fac2
      real*8 c,x,y,pi,tmp,mtmp,alpha
      real*8 cos_theta,phi,R

*     **** external functions ****
      integer  nwpw_doublefactorial
      external nwpw_doublefactorial
      real*8   nwpw_gaunt,nwpw_GaussBessel,Tesseral_lm
      external nwpw_gaunt,nwpw_GaussBessel,Tesseral_lm

      pi = 4.0d0*datan(1.0d0)
      x = dble(nwpw_doublefactorial(2*la+1))
      y = dble(nwpw_doublefactorial(2*lb+1))
      alpha = dsqrt(0.25d0*(sa*sa + sb*sb))
      R = dsqrt(Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3))
      cos_theta = Rab(3)/R

      if ((dabs(Rab(2)).lt.1.0d-9).and.(dabs(Rab(1)).lt.1.0d-9)) then
         phi = 0.0d0
      else
         phi = datan2(Rab(2),Rab(1))
      end if

      if (mod(2*la+lb,2).eq.1) then 
         c = -32.0d0*pi/(x*y)
      else
         c = 32.0d0*pi/(x*y)
      end if

      if (mod((abs(la-lb)+la+lb)/2,2).eq.1) then 
         fac = -1
      else
         fac = 1
      end if
      
      tmp = 0.0d0
      do l = abs(la-lb), (la+lb), 2
         mtmp = 0.0d0
         do m=-l,l
            mtmp = mtmp + nwpw_gaunt(.false.,l,m,la,ma,lb,mb)
     <                   *Tesseral_lm(l,m,cos_theta,phi)
         end do
         tmp = tmp + fac * mtmp * nwpw_GaussBessel(la+lb,l,alpha,R)
         fac = -fac
      end do

      nwpw_WGaussian = c * tmp
      return
      end 


*     ******************************************************
*     *                                                    *
*     *             nwpw_dWGaussian                        *
*     *                                                    *
*     ******************************************************
*
*     Calculates the two electron two center Gaussian integral
*
*                                            //
*    WGaussian(la,ma,sa,lb,Ra,mb,sb,Rb)   =  || g(la,ma,sa;r-Ra) * g(lb,mb,sb;r'-Rb)  
*                                            || ------------------------------------  dr dr'
*                                            //                |r-r'|
*
*     where g(l,m,s; r) = C_l * |r|**l * exp(-(r/s)**2) * Tlm(rhat) 
*
*          and C_l = 2**(l+2) / (sqrt(pi) (2*l+1)!! s**(2*l+3) )
*           
*     The normalization constant C_l is defined such at
*            /
*            | g(l,m,s;r) * |r|**l *Tlm(rhat) dr = 1
*            /
*
      subroutine nwpw_dWGaussian(la,ma,sa,lb,mb,sb,Rab,W,dW)
      implicit none
      integer la,ma,lb,mb
      real*8  sa,sb,Rab(3)
      real*8  W,dW(3)
 
*     *** local variables ***
      integer l,m,fac
      real*8 c,x,y,pi,tmp,mtmp,mtmpx,mtmpy,mtmpz,alpha
      real*8 cos_theta,phi,R,gg1,gg2,gg3,Tx,Ty,Tz

*     **** external functions ****
      integer  nwpw_doublefactorial
      external nwpw_doublefactorial
      real*8   nwpw_gaunt,nwpw_GaussBessel,nwpw_dGaussBessel,Tesseral_lm
      external nwpw_gaunt,nwpw_GaussBessel,nwpw_dGaussBessel,Tesseral_lm

      pi = 4.0d0*datan(1.0d0)
      x = dble(nwpw_doublefactorial(2*la+1))
      y = dble(nwpw_doublefactorial(2*lb+1))
      alpha = dsqrt(0.25d0*(sa*sa + sb*sb))

      R = dsqrt(Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3))
      cos_theta = Rab(3)/R
      phi       = datan2(Rab(2),Rab(1))

      if (mod(2*la+lb,2).eq.1) then 
         c = -32.0d0*pi/(x*y)
      else
         c = 32.0d0*pi/(x*y)
      end if

      if (mod((abs(la-lb)+la+lb)/2,2).eq.1) then 
         fac = -1
      else
         fac = 1
      end if
      
      W = 0.0d0
      dW(1) = 0.0d0
      dW(2) = 0.0d0
      dW(3) = 0.0d0
      do l = abs(la-lb), (la+lb), 2
         mtmp  = 0.0d0
         mtmpx = 0.0d0
         mtmpy = 0.0d0
         mtmpz = 0.0d0
         do m=-l,l
            gg1 = nwpw_gaunt(.false.,l,m,la,ma,lb,mb)
            call dTesseral_lm(l,m,cos_theta,phi,Tx,Ty,Tz)
            mtmp = mtmp   + gg1*Tesseral_lm(l,m,cos_theta,phi)
            mtmpx = mtmpx + gg1*Tx
            mtmpy = mtmpy + gg1*Ty
            mtmpz = mtmpz + gg1*Tz
         end do
         gg2 = nwpw_GaussBessel(la+lb,l,alpha,R)
         gg3 = nwpw_dGaussBessel(la+lb,l,alpha,R)
         W     = W     + fac*(mtmp*gg2)
         dW(1) = dW(1) + fac*(mtmpx*gg2 + mtmp*(Rab(1)/R)*gg3)
         dW(2) = dW(2) + fac*(mtmpy*gg2 + mtmp*(Rab(2)/R)*gg3)
         dW(3) = dW(3) + fac*(mtmpz*gg2 + mtmp*(Rab(3)/R)*gg3)
         fac = -fac
      end do
      W = W*c
      dW(1) = dW(1)*c
      dW(2) = dW(2)*c
      dW(3) = dW(3)*c

      return
      end 

*     ******************************************************
*     *                                                    *
*     *             nwpw_UGaussian                         *
*     *                                                    *
*     ******************************************************
*
*     Calculates the two electron one center Gaussian integral
*
*                                            //
*    WGaussian(la,ma,sa,lb,Ra,mb,sb,Rb)   =  || g(la,ma,sa;r) * g(lb,mb,sb;r')  
*                                            || ------------------------------------  dr dr'
*                                            //                |r-r'|
*
*     where g(l,m,s; r) = C_l * |r|**l * exp(-(r/s)**2) * Tlm(rhat) 
*
*          and C_l = 2**(l+2) / (sqrt(pi) (2*l+1)!! s**(2*l+3) )
*           
*     The normalization constant C_l is defined such at
*            /
*            | g(l,m,s;r) * |r|**l *Tlm(rhat) dr = 1
*            /
*
      real*8 function nwpw_UGaussian(la,ma,sa,lb,mb,sb)
      implicit none
      integer la,ma,lb,mb
      real*8  sa,sb
 
*     *** local variables ***
      real*8 x,y,twopi,s,U

*     **** external functions ****
      integer  nwpw_doublefactorial
      external nwpw_doublefactorial

      U = 0.0d0
      if ((la.eq.lb).and.(ma.eq.mb)) then
         twopi = 8.0d0*datan(1.0d0)
         x = dble((2*la+1)*nwpw_doublefactorial(2*la+1))
         y = (dsqrt(0.5d0*(sa*sa+sb*sb)))**(2*la+1)
         U = 4.0d0*dsqrt(twopi)/(x*y) 
      end if

      nwpw_UGaussian = U
      return
      end 

*
* $Id: ke.F 25293 2014-02-25 22:35:26Z bylaska $
*

*     **************************************
*     *                                    *
*     *             ke_init                *
*     *                                    *
*     **************************************
      subroutine ke_init()
      implicit none 

#include "mafdecls.fh"
#include "errquit.fh"

*     **** parameters - filter ****
c      real*8 eps,ncut
c      parameter (eps=1.0d-6,ncut=151.0d0)
      real*8 ncut

*     **** local variables ****
      integer npack1,nfft3d,G(3)
      integer i
      real*8  gg,g1,ggcut,A,E0,sigma,bb,x
      logical value
 
      integer tmp1(2),tmp2(2)

*     **** external functions ****
      logical  control_smooth_cutoff
      external control_smooth_cutoff
      integer  G_indx
      external G_indx
      real*8   lattice_wcut,control_smooth_cutoff_values,util_erf
      external lattice_wcut,control_smooth_cutoff_values,util_erf
      

*     **** common block used for ke.F ****
c     real*8 tg(nfft3d)
      integer tg_indx,tg_hndl
      common / tg_block / tg_indx,tg_hndl

      logical filter
      integer df(2)
      common / tg2_block / df,filter


      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)
      G(1)= G_indx(1)
      G(2)= G_indx(2)
      G(3)= G_indx(3)

      value = MA_alloc_get(mt_dbl,npack1,
     >                     'tg',tg_hndl,tg_indx)
      if (.not. value) 
     > call errquit('ke_init:out of heap memory',0, MA_ERR)

      value = MA_push_get(mt_dbl,nfft3d,'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dbl,nfft3d,'tmp2',tmp2(2),tmp2(1))
      if (.not. value) 
     > call errquit('ke_init:out of stack memory',0, MA_ERR)


      do i=1,nfft3d
         gg  = ( dbl_mb(G(1)+i-1)*dbl_mb(G(1)+i-1)
     >         + dbl_mb(G(2)+i-1)*dbl_mb(G(2)+i-1)
     >         + dbl_mb(G(3)+i-1)*dbl_mb(G(3)+i-1))
         dbl_mb(tmp1(1)+i-1) = -0.5d0*gg 
      end do
      call Pack_t_pack(1,dbl_mb(tmp1(1)))
      call Pack_t_Copy(1,dbl_mb(tmp1(1)),dbl_mb(tg_indx))


*     **** Funny decay added to stabalize unitcell optimization and pressures ****
      filter = control_smooth_cutoff()
      if (filter) then
         value = MA_alloc_get(mt_dbl,npack1,'df',df(2),df(1))
         if (.not. value) 
     >      call errquit('ke_init:out of heap memory',3,MA_ERR)

         E0    = lattice_wcut()
         A     = control_smooth_cutoff_values(1)*E0
         sigma = control_smooth_cutoff_values(2)
         bb    = 2.0d0*A/(sigma*dsqrt(4.0d0*datan(1.0d0)))

         do i=1,nfft3d
            gg  = ( dbl_mb(G(1)+i-1)*dbl_mb(G(1)+i-1)
     >            + dbl_mb(G(2)+i-1)*dbl_mb(G(2)+i-1)
     >            + dbl_mb(G(3)+i-1)*dbl_mb(G(3)+i-1))

            if (gg.gt.(E0-6.0d0*sigma)) then
               x = (0.5d0*gg-E0)/sigma
               dbl_mb(tmp1(1)+i-1) = -A*(1.0d0+util_erf(x))
               dbl_mb(tmp2(1)+i-1) = 1.0d0 + bb*dexp(-x*x)
            else
               dbl_mb(tmp1(1)+i-1) = 0.0d0
               dbl_mb(tmp2(1)+i-1) = 1.0d0
            end if
         end do
         call Pack_t_pack(1,dbl_mb(tmp1(1)))
         call Pack_t_pack(1,dbl_mb(tmp2(1)))
         call Pack_t_Copy(1,dbl_mb(tmp2(1)),dbl_mb(df(1)))
         call Pack_tt_Sum2(1,dbl_mb(tmp1(1)),dbl_mb(tg_indx))
      end if
      
      value =           MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2))
      if (.not. value) 
     > call errquit('ke_init:popping stack memory',0, MA_ERR)
      return
      end


*     ****************************************
*     *                                      *
*     *               ke_end                 *
*     *                                      *
*     ****************************************
      subroutine ke_end()
      implicit none 

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block used for ke.F ****
c     real*8 tg(nfft3d)
      integer tg_indx,tg_hndl
      common / tg_block / tg_indx,tg_hndl

      logical filter
      integer df(2)
      common / tg2_block / df,filter

      logical value

      value = MA_free_heap(tg_hndl)
      if (filter) value = value.and.MA_free_heap(df(2))
      if (.not. value) 
     >   call errquit('ke_end:error freeing heap',0, MA_ERR)
      return
      end


*     ****************************************
*     *                                      *
*     *               ke                     *
*     *                                      *
*     ****************************************
      subroutine ke(ispin,ne,psi1,psi2)
      implicit none
      integer    ispin,ne(2)
      complex*16 psi1(*)
      complex*16 psi2(*)

#include "mafdecls.fh"

*     **** common block used for ke.F ****
c     real*8 tg(nfft3d)
      integer tg_indx,tg_hndl
      common / tg_block / tg_indx,tg_hndl

*     **** local variables ****
      integer npack1
      integer n
      
      call Pack_npack(1,npack1)

      do n=1,(ne(1)+ne(2))
         call Pack_tc_Mul(1,dbl_mb(tg_indx),psi1(1+(n-1)*npack1),
     >                                      psi2(1+(n-1)*npack1))
      end do
      
      return 
      end

*     ****************************************
*     *                                      *
*     *               ke_add                 *
*     *                                      *
*     ****************************************
      subroutine ke_add(ispin,ne,psi1,psi2)
      implicit none
      integer    ispin,ne(2)
      complex*16 psi1(*)
      complex*16 psi2(*)

#include "mafdecls.fh"
cccccccc#include "frac_occ.fh"

*     **** common block used for ke.F ****
c     real*8 tg(nfft3d)
      integer tg_indx,tg_hndl
      common / tg_block / tg_indx,tg_hndl

*     **** local variables ****
      integer npack1
      integer n
      
      call Pack_npack(1,npack1)

      do n=1,(ne(1)+ne(2))
         call Pack_tc_MulAdd(1,dbl_mb(tg_indx),psi1(1+(n-1)*npack1),
     >                                         psi2(1+(n-1)*npack1))
      end do
      
      return 
      end


*     ****************************************
*     *                                      *
*     *               ke_ave                 *
*     *                                      *
*     ****************************************
      subroutine ke_ave(ispin,ne,psi1,ave,fractional,occ)
      implicit none
      integer ispin,ne(2)
      complex*16 psi1(*)
      real*8     ave
      logical fractional
      real*8  occ(*)

#include "mafdecls.fh"
#include "errquit.fh"
cccccccc#include "frac_occ.fh"

*     **** common block used for ke.F ****
c     real*8 tg(nfft3d)
      integer tg_indx,tg_hndl
      common / tg_block / tg_indx,tg_hndl


*     **** local variables ****
      integer npack1,np
      integer ms,n,n1(2),n2(2)
      real*8  sum

c     complex*16 tmp1(nfft3d)
      integer tmp1(2)
      logical value
     
      call Parallel_np(np)

      call Pack_npack(1,npack1)
      value = MA_push_get(mt_dcpl,npack1,'tmp1',tmp1(2),tmp1(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)

      ave = 0.0d0
      do ms=1,ispin
         do n=n1(ms),n2(ms)
            if (fractional) then
            call Pack_tc_aMul(1,occ(n),
     >                          dbl_mb(tg_indx),
     >                          psi1(1+(n-1)*npack1),
     >                          dcpl_mb(tmp1(1)))
            else
            call Pack_tc_Mul(1,dbl_mb(tg_indx),
     >                       psi1(1+(n-1)*npack1),
     >                       dcpl_mb(tmp1(1)))
            end if
            call Pack_cc_idot(1,psi1(1+(n-1)*npack1),
     >                       dcpl_mb(tmp1(1)),
     >                       sum)

            ave = ave + sum
         end do
      end do
      if (np.gt.1) call Parallel_SumAll(ave)
      if (ispin.eq.1) ave = 2.0d0*ave
      ave = -ave

      value = MA_pop_stack(tmp1(2))
      return 
      end 



*     ****************************************
*     *                                      *
*     *               ke_euv                 *
*     *                                      *
*     ****************************************
      subroutine ke_euv(ispin,ne,psi,euv)
*
* $Id: ke.F 25293 2014-02-25 22:35:26Z bylaska $
*
      implicit none 
      integer ispin,ne(2)
      complex*16 psi(*)
      real*8 euv(3,3)

#include "mafdecls.fh"
#include "errquit.fh"

      logical filter
      integer df(2)
      common / tg2_block / df,filter

*     **** local variables ****
      integer npack1,nfft3d,G(2,3)
      integer i,j,ms,n,n1(2),n2(2),np_i,np_j
      integer u,v,s
      logical value

      real*8 pi,scal,sum,ave
      real*8 hm(3,3),Aus(3,3)
      integer tmp1(2),tmp2(2)

*     **** external functions ****
c     real*8 G(nfft3d,3)
      integer  G_indx
      external G_indx

      real*8   lattice_unitg,lattice_omega,lattice_unita
      external lattice_unitg,lattice_omega,lattice_unita


      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)

      pi   = 4.0d0*datan(1.0d0)
      scal = 1.0d0/(2.0d0*pi)

*     *** define hm ****
      do j=1,3
      do i=1,3
         hm(i,j) = scal*lattice_unitg(i,j)
      end do
      end do      



      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)

      value = MA_push_get(mt_dbl,nfft3d,
     >                     'G1',G(2,1),G(1,1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
      value = MA_push_get(mt_dbl,nfft3d,
     >                     'G2',G(2,2),G(1,2))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
      value = MA_push_get(mt_dbl,nfft3d,
     >                     'G3',G(2,3),G(1,3))
      if (.not. value) call errquit('out of stack  memory',0, MA_ERR)


      value = MA_push_get(mt_dbl,npack1,'tmp1',tmp1(2),tmp1(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      value = MA_push_get(mt_dcpl,npack1,'tmp2',tmp2(2),tmp2(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


      call dcopy(nfft3d,dbl_mb(G_indx(1)),1,dbl_mb(G(1,1)),1)
      call dcopy(nfft3d,dbl_mb(G_indx(2)),1,dbl_mb(G(1,2)),1)
      call dcopy(nfft3d,dbl_mb(G_indx(3)),1,dbl_mb(G(1,3)),1)
      call Pack_t_pack(1,dbl_mb(G(1,1)))
      call Pack_t_pack(1,dbl_mb(G(1,2)))
      call Pack_t_pack(1,dbl_mb(G(1,3)))

*     **** calculate Aus = Sum(n)Sum(G) psi(G,n)**2 G(u)G(s) ****
      call dcopy(9,0.0d0,0,Aus,1)    
      do u=1,3
      do s=u,3
        call Pack_tt_Mul(1,dbl_mb(G(1,u)),
     >                     dbl_mb(G(1,s)),
     >                     dbl_mb(tmp1(1)))

        if (filter) call Pack_tt_Mul2(1,dbl_mb(df(1)),dbl_mb(tmp1(1)))
     
        ave = 0.0d0
        do ms=1,ispin
        do n=n1(ms),n2(ms)    
            call Pack_tc_Mul(1,dbl_mb(tmp1(1)),
     >                       psi(1+(n-1)*npack1),
     >                       dcpl_mb(tmp2(1)))
            call Pack_cc_idot(1,psi(1+(n-1)*npack1),
     >                        dcpl_mb(tmp2(1)),
     >                       sum)
             ave = ave + sum
             !Aus(u,s) = Aus(u,s) + sum
        end do
        end do
        if (np_i.gt.1) call D3dB_SumAll(ave)
        if (np_j.gt.1) call D1dB_SumAll(ave)
        Aus(u,s) = Aus(u,s) + ave

      end do
      end do
      do u=1,3
      do s=u+1,3
         Aus(s,u) = Aus(u,s)
      end do
      end do
      if (ispin.eq.1) call dscal(9,2.0d0,Aus,1)

*     *** calculate euv = -Sum(s) hm(s,v)*Aus(u,s)
      call dcopy(9,0.0d0,0,euv,1)
      do v=1,3
      do u=1,3
         do s=1,3
            euv(u,v) = euv(u,v) - Aus(u,s)*hm(s,v) 
         end do
      end do
      end do

      value = MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2))
      value = value.and.MA_pop_stack(G(2,3)) 
      value = value.and.MA_pop_stack(G(2,2)) 
      value = value.and.MA_pop_stack(G(2,1))
      if (.not. value) call errquit('error poping stack memory',0,
     &       MA_ERR)
      return
      end


*     ****************************************
*     *                                      *
*     *               ke_Precondition        *
*     *                                      *
*     ****************************************
      subroutine ke_Precondition(npack,neall,psi,gradk)
      implicit none
      integer npack,neall
      complex*16   psi(npack,neall)
      complex*16 gradk(npack,neall)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block used for ke.F ****
c     real*8 tg(nfft3d)
      integer tg_indx,tg_hndl
      common / tg_block / tg_indx,tg_hndl

*     **** local variables ****
      logical value
      integer k,n
      real*8  sum
      real*8  x,cm,dm,Ep,cm2(1)
      integer tmp1(2)

      real*8   lattice_wggcut,control_Ep
      external lattice_wggcut,control_Ep

      integer ispin,ne(2)
c      integer  psi_ispin,psi_ne
c      external psi_ispin,psi_ne

c      value = MA_push_get(mt_dcpl,npack,'tmp1',tmp1(2),tmp1(1))
c      if (.not. value) call errquit('out of stack memory',0)

c      sum = lattice_wggcut()
c      do n=1,neall
c         call Pack_tc_Mul(1,dbl_mb(tg_indx),psi(1,n),dcpl_mb(tmp1(1)))
c         call Pack_cc_dot(1,psi(1,n),dcpl_mb(tmp1(1)),sum)
c         do k=1,npack
c           x = dbl_mb(tg_indx+k-1)
c           x = x*dconjg(psi(k,n))*psi(k,n)
c           x = x/sum
c
c           cm = 27.0d0+(18.0d0+(12.0d0+8.0d0*x)*x)*x
c           dm = (cm + 16.0d0* x**4)
c           cm = cm/dm
c
cc          x = 2.0d0*dabs(dbl_mb(tg_indx+k-1)/sum)
cc          cm = dexp(-0.15d0*x*x) 
cc          cm = dexp(-0.5d0*(x-0.5)**2) 
c
c           gradk(k,n) = gradk(k,n)*(cm)
c         end do
c      end do


c*     **** Preconditioner of Tassone, Mauri, and Car ****
c      ispin = psi_ispin()
c      ne(1) = psi_ne(1)
c      ne(2) = psi_ne(2)
c      call ke_ave(ispin,ne,gradk,Ep)
c      write(*,*) "E(R):",Ep
c      Ep = control_Ep()-Ep
c      cm = 1.0d0/(Ep)
c      do k=1,npack       
c         x = -dbl_mb(tg_indx+k-1)
c        dm = (x*cm)
c         if (x.gt.Ep) then
c           do n=1,neall
c              gradk(k,n) = gradk(k,n)/dm
c           end do
c         end if
c      end do

 
*     **** My preconditioner ****
      ispin = 2
      ne(1) = 1
      ne(2) = 0
      do n=1,neall
c        call ke_ave(ispin,ne,gradk(1,n),Ep)
c        write(*,*) "n,E(R)=",n,Ep,control_Ep()-50*Ep
c        Ep =  control_Ep() - 15*Ep
        Ep =  control_Ep()
        cm = 1.0d0/Ep
CDIR$ NOVECTOR
        do k=1,npack
          x = -dbl_mb(tg_indx+k-1)
          dm = x*cm
          if (x.gt.Ep) then
          gradk(k,n) = gradk(k,n)/dm
          end if
        end do
      end do

*     **** preconditioner #5 ****
c      ispin = 2
c      ne(1) = 1
c      ne(2) = 0
c      do n=1,neall
c        call ke_ave(ispin,ne,gradk(1,n),Ep,.false.,cm2)
c        Ep = 1.5d0*Ep
c        do k=1,npack
c           x = -2.0d0*dbl_mb(tg_indx+k-1)/Ep
c           cm = 27.0d0+(18.0d0+(12.0d0+8.0d0*x)*x)*x
c           dm = (cm + 16.0d0* x**4)
c           cm = (cm/dm)*(2.0d0/Ep)
c           gradk(k,n) = gradk(k,n)*cm
c        end do
c      end do

c      value = MA_pop_stack(tmp1(2))
c      if (.not. value) call errquit('error popping stack memory',0)

      return
      end



*     ****************************************
*     *                                      *
*     *               ke_Precondition2       *
*     *                                      *
*     ****************************************
      subroutine ke_Precondition2(npack,neall,residual,Kresidual)
      implicit none
      integer npack,neall
      complex*16 residual(npack,neall)
      complex*16 Kresidual(npack,neall)

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block used for ke.F ****
c     real*8 tg(nfft3d)
      integer tg_indx,tg_hndl
      common / tg_block / tg_indx,tg_hndl

*     **** local variables ****
      logical value
      integer k,n
      real*8  sum
      real*8  x,cm,dm,Ep,cm2(1)
      integer ispin,ne(2)


*     **** preconditioner #5 ****
      ispin = 2
      ne(1) = 1
      ne(2) = 0
      do n=1,neall
        call ke_ave(ispin,ne,residual(1,n),Ep,.false.,cm2)
        Ep = 1.5d0*Ep
        do k=1,npack
           x = -2.0d0*dbl_mb(tg_indx+k-1)/Ep
           cm = 27.0d0+(18.0d0+(12.0d0+8.0d0*x)*x)*x
           dm = (cm + 16.0d0* x**4)
           cm = (cm/dm)*(2.0d0/Ep)
           Kresidual(k,n) = residual(k,n)*cm
        end do
      end do

      return
      end

C $Id: rel_LLSSd.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
c:tex-\subsection{rel\_LLSSd}
c:tex-This routine generates the LLSS-type two-electron derivative integrals
c:tex-for a relativistic basis set, within the modified Dirac formalism.
c:tex-The integrals returned are the derivatives of 
c:tex-$\nabla_C\cdot\nabla_D (ab|c^Sd^S)$,
c:tex-$\nabla_C\times\nabla_D (ab|c^Sd^S)$, or the 9 derivatives.
c:tex-
c:tex-\noindent Author: K. G. Dyall
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine rel_LLSSd (
     &    Axyz,zeta_A,coef_A,NPA,NCA,l_A,ictra,
     &    Bxyz,zeta_B,coef_B,NPB,NCB,l_B,ictrb,
     &    Cxyz,zeta_C,coef_C,NPC,NCC,l_C,ictrc,
     &    Dxyz,zeta_D,coef_D,NPD,NCD,l_D,ictrd,
     &    rel_ints,n_ints,canAB,canCD,canPQ,
     &    DryRun,scr,lscr,ibug,ntyp)
c:tex-\end{verbatim}
      implicit none
#include "stdio.fh"
#include "rel_consts.fh"
#include "errquit.fh"
*
c:tex-{\it Argument list:}
c:tex-\begin{verbatim}
      integer NPA     ! [input] num. prims in shell A
      integer NCA     ! [input] num general conts in shell A
      integer l_A     ! [input] angular momentum of shell A
      integer ictra   ! [input] lexical atom index of shell A
      integer NPB     ! [input] num. prims in shell B
      integer NCB     ! [input] num general conts in shell B
      integer l_B     ! [input] angular momentum of shell B 
      integer ictrb   ! [input] lexical atom index of shell B
      integer NPC     ! [input] num. prims in shell C
      integer NCC     ! [input] num general conts in shell C
      integer l_C     ! [input] angular momentum of shell C
      integer ictrc   ! [input] lexical atom index of shell C
      integer NPD     ! [input] num. prims in shell D
      integer NCD     ! [input] num general conts in shell D
      integer l_D     ! [input] angular momentum of shell D 
      integer ictrd   ! [input] lexical atom index of shell D
      integer lscr    ! [input] size of scratch array
      integer n_ints  ! [input] size of any integral buffer
      integer ibug    ! [input] debug variable
      integer ntyp    ! [input] potential energy integral type
      double precision Axyz(3)         ! [input] position of center A
      double precision zeta_A(NPA)     ! [input] exponents of shell A
      double precision coef_A(NPA,NCA) ! [input] A large coeffs
      double precision Bxyz(3)         ! [input] position of center B
      double precision zeta_B(NPB)     ! [input] exponents of shell B 
      double precision coef_B(NPB,NCB) ! [input] B large coeffs
      double precision Cxyz(3)         ! [input] position of center C
      double precision zeta_C(NPC)     ! [input] exponents of shell C
      double precision coef_C(NPC,NCC) ! [input] C small coeffs
      double precision Dxyz(3)         ! [input] position of center D
      double precision zeta_D(NPD)     ! [input] exponents of shell D 
      double precision coef_D(NPD,NCD) ! [input] D small coeffs
      double precision scr(lscr)       ! [scratch] scratch buffers
      double precision rel_ints(n_ints,12,ntyp)  ! [output] LLSS integrals
      logical canAB   ! [input] compute only canonical ints (false only)
      logical canCD   ! [input] compute only canonical ints (false only)
      logical canPQ   ! [input] compute only canonical ints (false only)
      logical DryRun  ! [input] true means only compute required memory
c:tex-\end{verbatim}
c:tex-See rel_pot for a description of the allowed values of ibug and ntyp
c:tex-Note that in the current version of this routine, the call to rel_pot 
c:tex-uses a dummy ntyp=1. It is kept in the input so that in future, the 
c:tex-spin-orbit integrals can also be obtained with a call to this routine.
c:tex-
c:tex-{\it Subroutines called:} hf2d, rel\_pot, daxpy 
*
      integer n_cart_a   ! cartesian components of shell A
      integer n_cart_b   ! cartesian components of shell B
      integer n_cart_c   ! cartesian components of shell C
      integer n_cart_d   ! cartesian components of shell D
      integer n_cart_cd  ! n_cart_c*n_cart_d
      integer n_cont_cd  ! NCC*NCD
      integer n_all_a    ! n_cart_a*NCA
      integer n_all_b    ! n_cart_b*NCB
      integer n_all_c    ! n_cart_c*NCC
      integer n_all_d    ! n_cart_d*NCD
      integer n_ab       ! number of ab densities
      integer n_cd       ! number of cd densities
      integer n_abcd     ! number of integrals
      integer n_cartp_c  ! cartesian components for l_C+1
      integer n_cartp_d  ! cartesian components for l_D+1
      integer n_cartm_c  ! cartesian components for l_C-1
      integer n_cartm_d  ! cartesian components for l_D-1
      integer n_intpp    ! number of integrals for l_C+1,l_D+1
      integer n_intpm    ! number of integrals for l_C-1,l_D+1
      integer n_intmp    ! number of integrals for l_C+1,l_D-1
      integer n_intmm    ! number of integrals for l_C-1,l_D-1
      integer i_xcc      ! address in scr of exp*coef for shell C
      integer i_xcd      ! address in scr of exp*coef for shell D
      integer i_pp       ! address in scr of integrals for l_A+1,l_B+1
      integer i_pm       ! address in scr of integrals for l_A-1,l_B+1
      integer i_mp       ! address in scr of integrals for l_A+1,l_B-1
      integer i_mm       ! address in scr of integrals for l_A-1,l_B-1
      integer i_scr      ! address of free space in scr
      integer memscr     ! free space in scr
      integer max_mem    ! maximum memory used
      integer i,j,k      ! loop indices etc.
      double precision one ! Obvious!
      parameter (one = 1.0D0)
*
      logical debug_gen       ! do general debug printing
      logical debug_addresses ! do address debug printing
      logical debug_arrays    ! do array debug printing
*
      debug_gen = ibug .gt. 0
      debug_addresses = mod(ibug,2) .eq. 1
      debug_arrays = mod(ibug,10)/2 .eq. 1
      max_mem = 0
      if (debug_gen) write (LuOut,*) 'Entering rel_LLSSd'
*
      if ((ntyp .ne. 1) .and. (ntyp .ne. 3) .and. (ntyp .ne. 4) .and.
     &    (ntyp .ne. 9))
     &    call errquit('Invalid value of ntyp in rel_LLSSd',99,
     &       UNKNOWN_ERR)
*
      n_cart_a = (l_a+1)*(l_a+2)/2
      n_cart_b = (l_b+1)*(l_b+2)/2
      n_cart_c = (l_c+1)*(l_c+2)/2
      n_cart_d = (l_d+1)*(l_d+2)/2
      n_cart_cd = n_cart_c*n_cart_d
      n_cont_cd = NCC*NCD
      n_all_a = n_cart_a*NCA
      n_all_b = n_cart_b*NCB
      n_all_c = n_cart_c*NCC
      n_all_d = n_cart_d*NCD
      n_ab = n_all_a*n_all_b
      n_cd = n_all_c*n_all_d
      n_abcd = n_ab*n_cd
      if ((n_ints .lt. n_abcd) .and. (.not.DryRun)) call errquit (
     &    'Integral buffer n_ints too small in rel_LLSSd',99,
     &       MEM_ERR)
      if (debug_addresses) then
        write (LuOut,*) 'n_cart_a',n_cart_a
        write (LuOut,*) 'n_cart_b',n_cart_b
        write (LuOut,*) 'n_cart_c',n_cart_c
        write (LuOut,*) 'n_cart_d',n_cart_d
        write (LuOut,*) 'n_cart_cd',n_cart_cd
        write (LuOut,*) 'n_cont_cd',n_cont_cd
        write (LuOut,*) 'n_all_a',n_all_a
        write (LuOut,*) 'n_all_b',n_all_b
        write (LuOut,*) 'n_all_c',n_all_c
        write (LuOut,*) 'n_all_d',n_all_d
        write (LuOut,*) 'n_ab',n_ab
        write (LuOut,*) 'n_cd',n_cd
      end if
*
*   Set up pointers to scratch space for coefficients multiplied by 
*   exponents and for integrals with shifted l values
*
      n_cartp_c = n_cart_c+l_C+2
      n_cartp_d = n_cart_d+l_D+2
      n_cartm_c = n_cart_c-l_C-1
      n_cartm_d = n_cart_d-l_D-1
      n_intpp = n_cartp_c*n_cartp_d*n_cont_cd*n_ab
      n_intpm = n_cartm_c*n_cartp_d*n_cont_cd*n_ab
      n_intmp = n_cartp_c*n_cartm_d*n_cont_cd*n_ab
      n_intmm = n_cartm_c*n_cartm_d*n_cont_cd*n_ab
      i_xcc = 1
      i_xcd = i_xcc+NPC*NCC
      i_pp = i_xcd+NPD*NCD
      i_pm = i_pp+n_intpp*12
      i_mp = i_pm+n_intpm*12
      i_mm = i_mp+n_intmp*12
      i_scr = i_mm+n_intmm*12
      memscr = lscr-i_scr+1

      if (debug_addresses) then
        write (LuOut,*) 'n_cartp_c',n_cartp_c
        write (LuOut,*) 'n_cartp_d',n_cartp_d
        write (LuOut,*) 'n_cartm_c',n_cartm_c
        write (LuOut,*) 'n_cartm_d',n_cartm_d
        write (LuOut,*) 'n_intpp',n_intpp
        write (LuOut,*) 'n_intpm',n_intpm
        write (LuOut,*) 'n_intmp',n_intmp
        write (LuOut,*) 'n_intmm',n_intmm
        write (LuOut,*) 'i_xcc,i_xcd',i_xcc,i_xcd
        write (LuOut,*) 'i_pp,i_pm,i_mp,i_mm',i_pp,i_pm,i_mp,i_mm
        write (LuOut,*) 'i_scr',i_scr
        write (LuOut,*) 'memscr,lscr',memscr,lscr
      end if
*
*   Set up coefficients multiplied by exponents
*
      if (.not.DryRun) then
        if (memscr .lt. 0) call errquit (
     &      'Insufficient scratch memory in rel_LLSSd',99, MEM_ERR)
        k = i_xcc-1
        do j = 1,NCC
          do i = 1,NPC
            scr(k+i) = zeta_C(i)*coef_C(i,j)
          end do
          k = k+NPC
        end do
        k = i_xcd-1
        do j = 1,NCD
          do i = 1,NPD
            scr(k+i) = zeta_D(i)*coef_D(i,j)
          end do
          k = k+NPD
        end do
      end if
*
*         Calculate integrals for l_C+1, l_D+1
*
      if (debug_gen) write (LuOut,*) 'calling hf2d ++'
      call hf2d(
     &    Axyz,zeta_A,coef_A,NPA,NCA,l_A,ictra,
     &    Bxyz,zeta_B,coef_B,NPB,NCB,l_B,ictrb,
     &    Cxyz,zeta_C,scr(i_xcc),NPC,NCC,l_C+1,ictrc,
     &    Dxyz,zeta_D,scr(i_xcd),NPD,NCD,l_D+1,ictrd,
     &    scr(i_pp),n_intpp,canAB,canCD,canPQ,
     &    DryRun,scr(i_scr),memscr)
      if (DryRun) max_mem = max(max_mem,i_scr+memscr-1)
*
*         Calculate integrals for l_C-1, l_D+1
*
      if (l_C .gt. 0) then
        memscr = lscr-i_scr+1
        if (debug_gen) write (LuOut,*) 'calling hf2d -+'
        call hf2d(
     &      Axyz,zeta_A,coef_A,NPA,NCA,l_A,ictra,
     &      Bxyz,zeta_B,coef_B,NPB,NCB,l_B,ictrb,
     &      Cxyz,zeta_C,coef_C,NPC,NCC,l_C-1,ictrc,
     &      Dxyz,zeta_D,scr(i_xcd),NPD,NCD,l_D+1,ictrd,
     &      scr(i_pm),n_intpm,canAB,canCD,canPQ,
     &      DryRun,scr(i_scr),memscr)
        if (DryRun) max_mem = max(max_mem,i_scr+memscr-1)
      end if
*
*         Calculate integrals for l_C+1, l_D-1
*
      if (l_D .gt. 0) then
        memscr = lscr-i_scr+1
        if (debug_gen) write (LuOut,*) 'calling hf2d +-'
        call hf2d(
     &      Axyz,zeta_A,coef_A,NPA,NCA,l_A,ictra,
     &      Bxyz,zeta_B,coef_B,NPB,NCB,l_B,ictrb,
     &      Cxyz,zeta_C,scr(i_xcc),NPC,NCC,l_C+1,ictrc,
     &      Dxyz,zeta_D,coef_D,NPD,NCD,l_D-1,ictrd,
     &      scr(i_mp),n_intmp,canAB,canCD,canPQ,
     &      DryRun,scr(i_scr),memscr)
        if (DryRun) max_mem = max(max_mem,i_scr+memscr-1)
*
*         Calculate integrals for l_C-1, l_D-1
*
        if (l_C .gt. 0) then
          memscr = lscr-i_scr+1
          if (debug_gen) write (LuOut,*) 'calling hf2d --'
          call hf2d(
     &        Axyz,zeta_A,coef_A,NPA,NCA,l_A,ictra,
     &        Bxyz,zeta_B,coef_B,NPB,NCB,l_B,ictrb,
     &        Cxyz,zeta_C,coef_C,NPC,NCC,l_C-1,ictrc,
     &        Dxyz,zeta_D,coef_D,NPD,NCD,l_D-1,ictrd,
     &        scr(i_mm),n_intmm,canAB,canCD,canPQ,
     &        DryRun,scr(i_scr),memscr)
          if (DryRun) max_mem = max(max_mem,i_scr+memscr-1)
        end if
      end if
*
*     Compute the relativistic integrals
*
      memscr = lscr-i_scr+1
      if (debug_gen) write (LuOut,*) 'calling rel_pot'
      call rel_pot (
     &    scr(i_pp),scr(i_pm),scr(i_mp),scr(i_mm),
     &    rel_ints,n_ints*12,ntyp,
     &    l_C,n_cartp_c,n_cart_c,n_cartm_c,NCC*n_ab*12,
     &    l_D,n_cartp_d,n_cart_d,n_cartm_d,NCD,
     &    DryRun,scr(i_scr),memscr,ibug)
      if (DryRun) then
        max_mem = max(max_mem,i_scr+memscr-1)
        lscr = max_mem
      end if
      if (debug_gen) write (LuOut,*) 'Exiting rel_LLSSd'
*
      return
      end

      SUBROUTINE ccsdt_t3_8_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: ccsdt_t3_8_5.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h12 p4 p5 h1 h2 h3 )_vtt + = 1/24 * P( 2 ) * Sum ( h8 ) * t ( p4 h8 )_t * i2 ( h8 h12 p5 h1 h2 h3 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p4b
      INTEGER p5b
      INTEGER h12b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h8b
      INTEGER p4b_1
      INTEGER h8b_1
      INTEGER p5b_2
      INTEGER h12b_2
      INTEGER h8b_2
      INTEGER h1b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p4b = noab+1,noab+nvab
      DO p5b = noab+1,noab+nvab
      DO h12b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+h12b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h12b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,ieor(irrep_t,irrep_t))) T
     &HEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+h12b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_
     &mb(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_t3_8_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h8b = 1,noab
      IF (int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+h8b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p4b,h8b,p4b_1,h8b_1)
      CALL TCE_RESTRICTED_6(p5b,h12b,h8b,h1b,h2b,h3b,p5b_2,h12b_2,h8b_2,
     &h1b_2,h2b_2,h3b_2)
      dim_common = int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+p4b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h12b-1) * int_m
     &b(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_t3_8_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_t3_8_5',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (p4b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h8b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_t3_8_5',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_t3_8_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_t3_8_5',5,MA_ERR)
      IF ((h8b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h3b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (h1b_2 - 1 + noab * (h12b_2 - 1 
     &+ noab * (h8b_2 - 1 + noab * (p5b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h12b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),6,5,4,3,1,2,1.0d0)
      END IF
      IF ((h12b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h3b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (h1b_2 - 1 + noab * (h8b_2 - 1 +
     & noab * (h12b_2 - 1 + noab * (p5b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h8b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),6,5,4,2,1,3,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_t3_8_5',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_t3_8_5',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_t3_8_5',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_t3_8_5',9,MA_ERR)
      IF ((p4b .le. p5b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),6,5,4,3,2,1,1.0d0/24
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h12b - 1 + noab *
     & (p5b - noab - 1 + nvab * (p4b - noab - 1)))))))
      END IF
      IF ((p5b .le. p4b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),5,6,4,3,2,1,-1.0d0/2
     &4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h12b - 1 + noab *
     & (p4b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_t3_8_5',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_t3_8_5',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      logical function pre_nucleic(sgmnam)
c
c $Id: pre_nucleic.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "pre_common.fh"
c
      character*5 sgmnam
c
      pre_nucleic=.true.
c
      if(sgmnam(1:3).eq.'A  '.or.sgmnam(1:3).eq.'+A '.or.
     + sgmnam(1:3).eq.'C  '.or.sgmnam(1:3).eq.'+C '.or.
     + sgmnam(1:3).eq.'G  '.or.sgmnam(1:3).eq.'+G '.or.
     + sgmnam(1:3).eq.'I  '.or.sgmnam(1:3).eq.'+I '.or.
     + sgmnam(1:3).eq.'T  '.or.sgmnam(1:3).eq.'+T '.or.
     + sgmnam(1:3).eq.'U  '.or.sgmnam(1:3).eq.'+U ') return
      if(ffield(1:5).eq.'amber') then
      if(sgmnam(1:3).eq.'DA '.or.sgmnam(1:3).eq.'RA '.or.
     + sgmnam(1:3).eq.'DC '.or.sgmnam(1:3).eq.'RC '.or.
     + sgmnam(1:3).eq.'DG '.or.sgmnam(1:3).eq.'RG '.or.
     + sgmnam(1:3).eq.'DT '.or.sgmnam(1:3).eq.'RU ') return
      endif
      if(ffield(1:6).eq.'charmm') then
      endif
c
      pre_nucleic=.false.
      return
      end

*
* $Id: inner_loop.F 25926 2014-07-21 03:13:15Z bylaska $
*

*  ************************************************************
*  *                MPI cpsd routine                          *
*  *                                                          *
*  *  This is a developing cpsdv3 parallel code wrtten in     *
*  *  Fortran and MPI.                                        *
*  *                                                          *
*  *    + mpl message passing library used                    *
*  *                                                          *
*  *    + ngp is used instead of nfft in this proceudure      *
*  *                                                          *
*  *    + error checking is based on aimd.h parameters        *
*  *      then control file                                   *
*  ************************************************************
  
      subroutine inner_loop(ispin,ne,
     >                      npack1,nfft3d,nemax,
     >                      psi1,psi2,dn,
     >                      it_in,E,deltae,deltac,deltar,
     >                      hml,lmd,
     >                      psi_r,Hpsi,
     >                      fractional,occ1,occ2)
      implicit none
      integer    ispin,ne(2)
      integer    npack1,nfft3d,nemax
      complex*16 psi1(npack1,nemax)
      complex*16 psi2(npack1,nemax)
      real*8     dn(2*nfft3d,2)
      integer    it_in
      real*8     E(*)
      real*8     deltae,deltac,deltar
      real*8     hml(*),lmd(*)

*     **** very big workspace variables ****
      real*8     psi_r(2*nfft3d,nemax)
      complex*16 Hpsi(npack1,nemax)

      logical fractional
      real*8 occ1(*),occ2(*)


#include "mafdecls.fh"
#include "errquit.fh"
cccccccc#include "frac_occ.fh"

*     **** local variables ****
      logical move,sic,hfx
      integer n2ft3d,np_i,np_j,np
      integer i,n,n1(2),n2(2),it,ms,ierr
      integer nx,ny,nz
      integer gga
      real*8  sum,Eold,eorbit,eion,ehartr,eke,elocal,enlocal
      real*8  exc,exc2,pxc,pxc2,dte,scal1,scal2,dv,dt
      real*8  ehsic,phsic,exsic,pxsic,ehfx,phfx
      real*8  deltamm
      real*8  e_lj, e_q, e_spring
      real*8  ehartree_atom,ecmp_cmp,ecmp_pw,exc_atom,pxc_atom
      !real*8 e_ionmm,e_qmmm,e_mmmm,e_pol,e_vib,e_cav



*     **** MA local variables ****
      logical value,field_exist
*     real*8     tmp_L(8*nemax*nemax)
*     complex*16 tmp1(nfft3d)
*     complex*16 tmp2(nfft3d)
c     complex*16  vl(nfft3d)
c     complex*16  vc(nfft3d)
c     complex*16 dng(nfft3d)
c     real*8     xcp(2*nfft3d,2)
c     real*8     xce(2*nfft3d,2)
c     real*8     fion(3,natmx)
      integer tmp_L(2)
      integer tmp1(2),tmp2(2)
      integer vl(2),vc(2),dng(2)
      integer vlr_l(2),rho(2),r_grid(2)
      integer v_field(2)
      integer xcp(2),xce(2),dnall(2)
      integer natmx,fion(2),ftest(2)
      integer sumi(2)
      integer npack0

*     ***** external functions ****
      logical  control_move,psp_semicore,psp_pawexist
      logical  pspw_SIC,pspw_SIC_relaxed
      logical  pspw_HFX,pspw_HFX_relaxed
      integer  ion_nion,control_gga
      real*8   control_time_step,control_fake_mass,ion_dti
      real*8   lattice_omega,coulomb_e,ewald_e
      external control_move,psp_semicore,psp_pawexist
      external pspw_SIC,pspw_SIC_relaxed
      external pspw_HFX,pspw_HFX_relaxed
      external ion_nion,control_gga
      external control_time_step,control_fake_mass,ion_dti
      external lattice_omega,coulomb_e,ewald_e
      integer  control_version
      external control_version
      real*8   ion_ion_e,E_vnonlocal
      external ion_ion_e,E_vnonlocal

      double precision Dneall_m_trace
      external         Dneall_m_trace
      logical  Dneall_m_push_get_block,Dneall_m_pop_stack
      external Dneall_m_push_get_block,Dneall_m_pop_stack

*     ***** QM/MM external functions ****
      logical  pspw_charge_found,pspw_qmmm_found
      real*8   pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E
      external pspw_charge_found,pspw_qmmm_found
      external pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E

      logical  psp_U_psputerm,meta_found
      external psp_U_psputerm,meta_found
      logical  nwpw_meta_gga_on,ion_disp_on
      external nwpw_meta_gga_on,ion_disp_on
      real*8   nwpw_meta_gga_pxc,ion_disp_energy
      external nwpw_meta_gga_pxc,ion_disp_energy

*     **** paw external functions ****
      real*8   psp_kinetic_atom,psp_kinetic_core,psp_valence_core_atom
      real*8   psp_ncmp_vloc,psp_vloc_atom,psp_ion_core
      real*8   psp_hartree_atom,psp_hartree_cmp_cmp,psp_hartree_cmp_pw
      external psp_kinetic_atom,psp_kinetic_core,psp_valence_core_atom
      external psp_ncmp_vloc,psp_vloc_atom,psp_ion_core
      external psp_hartree_atom,psp_hartree_cmp_cmp,psp_hartree_cmp_pw




      call Pack_npack(0,npack0)
      n2ft3d = 2*nfft3d
      deltamm = 0.0d0

      field_exist = pspw_charge_found()
      sic        = pspw_SIC()
      hfx        = pspw_HFX()
      gga = control_gga()

      call nwpw_timing_start(12)
*     **** allocate MA local variables ****
      value = Dneall_m_push_get_block(1,8,tmp_L)
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d),'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d),'tmp2',tmp2(2),tmp2(1))

      if (control_version().eq.3) then
       value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'vc',  vc(2),  vc(1))
      end if

      if (control_version().eq.4) then
       value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'vc',vc(2),vc(1))
       value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'vlr_l',vlr_l(2),vlr_l(1))
      end if

      if ((field_exist).or.(control_version().eq.4)) then
       value = value.and.
     >    MA_push_get(mt_dbl,(3*n2ft3d),'r_grid',r_grid(2),r_grid(1))
      end if

       value = value.and.
     >  MA_push_get(mt_dbl,(n2ft3d),'v_field',v_field(2),v_field(1))

      value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'vloc', vl(2), vl(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'rho',rho(2),rho(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'dng',dng(2), dng(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'xcp',xcp(2), xcp(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'xce',xce(2), xce(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'dnall',dnall(2),dnall(1))
      natmx = ion_nion()
      value = value.and.
     >        MA_push_get(mt_dbl,(3*natmx),'fion',fion(2),fion(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(3*natmx),'ftest',ftest(2),ftest(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(nemax),'sumi',sumi(2),sumi(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
      call dcopy(4*nfft3d,0.0d0,0,dbl_mb(dnall(1)),1)
      call dcopy(4*nfft3d,0.0d0,0,dbl_mb(xcp(1)),1)
      call dcopy(4*nfft3d,0.0d0,0,dbl_mb(xce(1)),1)

      call nwpw_timing_end(12)
     
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      move = control_move()
      

      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1) + 1
      n2(2) = ne(1) + ne(2)

      dt = control_time_step()
      dte = dt/dsqrt(control_fake_mass())
      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()
      dv    = scal1*lattice_omega()

      if ((control_version().eq.4).or.(field_exist))
     >   call lattice_r_grid(dbl_mb(r_grid(1)))

*     ******************************************
*     ****                                  ****
*     ****   Start of steepest descent loop ****
*     ****                                  ****
*     ******************************************
      do it=1,it_in
        call dcopy(2*npack1*nemax,psi2,1,psi1,1)
        if (move) call ion_shift()

*       ********************************
*       **** generate phaze factors ****
*       ********************************
        call phafac()
        if (control_version().eq.3) call ewald_phafac()
        call nwpw_timing_start(11)

*       *******************;
*       **** get psi_r ****
*       *******************
c        do n=n1(1),n2(ispin)
c           call Pack_c_Copy(1,psi1(1,n),psi_r(1,n))
c           call Pack_c_unpack(1,psi_r(1,n))
c           call D3dB_cr_fft3b(1,psi_r(1,n))
c           call D3dB_r_Zero_Ends(1,psi_r(1,n))
c        end do
        do n=n1(1),n2(ispin)
           call Pack_c_Copy(1,psi1(1,n),psi_r(1,n))
        end do
        call Grsm_gh_fftb(nfft3d,n2(ispin),psi_r)
        do n=n1(1),n2(ispin)
           call D3dB_r_Zero_Ends(1,psi_r(1,n))
        end do

        call nwpw_meta_gga_gen_tau(ispin,ne,psi1)


*       *********************
*       **** generate dn ****
*       *********************
        call dcopy(ispin*n2ft3d,0.0d0,0,dn,1)
        if (fractional) then
          do ms=1,ispin
             do n=n1(ms),n2(ms)
                do i=1,n2ft3d
                   dn(i,ms) = dn(i,ms) 
     >                      + scal2*(psi_r(i,n)**2)
     >                       *occ1(n)
                end do
             end do
             call D3dB_r_Zero_Ends(1,dn(1,ms))
             call D1dB_Vector_SumAll(n2ft3d,dn(1,ms))
          end do
        else
          do ms=1,ispin
             do n=n1(ms),n2(ms)
                do i=1,n2ft3d
                   dn(i,ms) = dn(i,ms) + scal2*(psi_r(i,n)**2)
                end do
             end do
             call D3dB_r_Zero_Ends(1,dn(1,ms))
             call D1dB_Vector_SumAll(n2ft3d,dn(1,ms))
          end do
        end if

*       **********************
*       **** generate dng ****
*       **********************
        call D3dB_rr_Sum(1,dn(1,1),dn(1,ispin),dbl_mb(rho(1)))
        call D3dB_r_SMul(1,scal1,dbl_mb(rho(1)),dcpl_mb(tmp1(1)))
        call D3dB_rc_fft3f(1,dcpl_mb(tmp1(1)))
c        call mask_C(0,dcpl_mb(dng(1)))
        call Pack_c_pack(0,dcpl_mb(tmp1(1)))
        call Pack_c_Copy(0,dcpl_mb(tmp1(1)),dcpl_mb(dng(1)))



*       ********************************************************
*       **** generate dnall - used for semicore corrections ****
*       ********************************************************
        if (psp_semicore(0)) then
           if (move .or. (it.eq.1)) call semicore_density_update()
           call semicore_density(dcpl_mb(tmp1(1)))
           call D3dB_r_SMul1(1,0.5d0,dcpl_mb(tmp1(1)))
        else
           call dcopy(n2ft3d,0.0d0,0,dcpl_mb(tmp1(1)),1)
        end if
        do ms=1,ispin
          call D3dB_rr_Sum(1,dn(1,ms),
     >                     dcpl_mb(tmp1(1)),
     >                     dbl_mb(dnall(1) +(ms-1)*n2ft3d))
        end do
        
        call nwpw_timing_end(11)

*       **************************
*       **** update ncmp*Vloc ****
*       **************************
        if (psp_pawexist().and.(move .or. (it.eq.1)))
     >     call psp_dE_ncmp_vloc_Qlm(ispin)


*       *****************************************
*       **** generate local pseudopotential  ****
*       **** and also get force if move true ****
*       *****************************************
 
        call v_local(dcpl_mb(vl(1)),
     >               move,
     >               dcpl_mb(dng(1)),
     >               dbl_mb(fion(1)))


*       *** long-range psp for charge systems ***
        if (control_version().eq.4) then
          call v_lr_local(dbl_mb(r_grid(1)),
     >                    dbl_mb(vlr_l(1)))
          if (move) then
             call grad_v_lr_local(dbl_mb(r_grid(1)),
     >                            dbl_mb(rho(1)),
     >                            dbl_mb(fion(1)))
          end if
        end if


*       ************************************
*       **** generate coulomb potential ****
*       ************************************
        if (control_version().eq.3) 
     >     call coulomb_v(dcpl_mb(dng(1)),dcpl_mb(vc(1)))

        if (control_version().eq.4) 
     >     call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))

*       *************************************************
*       **** generate exchange-correlation potential ****
*       *************************************************
        call v_bwexc_all_tmp1(gga,n2ft3d,ispin,
     >                        dbl_mb(dnall(1)),
     >                        dbl_mb(xcp(1)),
     >                        dbl_mb(xce(1)),
     >                        dcpl_mb(tmp1(1)))

     
*       *******************************************
*       ***** generate other real-space fields ****
*       *******************************************
        if (field_exist) then

           call dcopy(n2ft3d,0.0d0,0,dbl_mb(v_field(1)),1)


*          **** generate charge potential ****
           if (pspw_charge_found()) then
              call pspw_charge_Generate_V(n2ft3d,
     >                                    dbl_mb(r_grid(1)),
     >                                    dbl_mb(v_field(1)))
           end if
        end if

        call nwpw_timing_start(13)



*       ******************
*       **** get Hpsi ****
*       ******************
        if (control_version().eq.3) 
     >     call psi_H(ispin,ne,psi1,psi_r,
     >             dcpl_mb(vl(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dcpl_mb(vc(1)),dbl_mb(xcp(1)),Hpsi,
     >             move,dbl_mb(fion(1)),fractional,occ1)

        if (control_version().eq.4) 
     >     call psi_Hv4(ispin,ne,psi1,psi_r,
     >             dcpl_mb(vl(1)),dbl_mb(vlr_l(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dbl_mb(vc(1)),dbl_mb(xcp(1)),Hpsi,
     >             move,dbl_mb(fion(1)),fractional,occ1)

        
*       ************************************
*       **** do a steepest descent step ****
*       ************************************
        do n=1,n2(ispin)
          call Pack_c_SMul(1,dte,Hpsi(1,n),psi2(1,n))
c          call Pack_cc_Sum(1,psi2(1,n),psi1(1,n),psi2(1,n))
          call Pack_cc_Sum2(1,psi1(1,n),psi2(1,n))
        end do
        call nwpw_timing_end(13)

*       *******************************************
*       **** get ewald and semicore forces     ****
*       ****   and do steepest descent on ions ****
*       *******************************************
        if (move) then

*          **** get the ewald force ****
           if (control_version().eq.3) call ewald_f(dbl_mb(fion(1)))

*          **** get the free-space ion force ****
           if (control_version().eq.4) call ion_ion_f(dbl_mb(fion(1)))

*          **** get the semicore force ****
           if (psp_semicore(0)) then
              call semicore_xc_F(ispin,dbl_mb(xcp(1)),dbl_mb(fion(1)))
           end if

*          **** get the qmmm force ****
           if (pspw_qmmm_found()) call pspw_qmmm_fion(dbl_mb(fion(1)))

*          **** get dispersion force ****
           if (ion_disp_on()) call ion_disp_force(dbl_mb(fion(1)))

*          **** remove ion forces using ion_FixIon ****
           call ion_FixIon(dbl_mb(fion(1)))

           call ion_optimize_step(dbl_mb(fion(1)))
        end if


*       *****************************************        
*       **** lagrange multiplier corrections ****
*       *****************************************        

        if (psp_pawexist()) then
        call psp_overlap_S(ispin,ne,psi1,psi_r)
        call psi_lmbda_paw(ispin,ne,nemax,npack1,psi_r,psi2,
     >                  dte,
     >                  lmd,dbl_mb(tmp_L(1)),ierr)
        else if (fractional) then
        call psi_lmbda2(ispin,ne,nemax,npack1,psi1,psi2,
     >                  dte,occ1,
     >                  lmd,dbl_mb(tmp_L(1)),ierr)
        else if (sic.or.hfx) then
        call psi_lmbda_sic(ispin,ne,nemax,npack1,psi1,psi2,dte,
     >                 lmd,dbl_mb(tmp_L(1)),ierr)
        else
        call psi_lmbda(ispin,ne,nemax,npack1,psi1,psi2,dte,
     >                 lmd,dbl_mb(tmp_L(1)),ierr)
        end if


      end do

*     *************************************
*     ***** total energy calculation ******
*     *************************************
      call nwpw_timing_start(10)
      call Parallel_np(np)
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

*     *** get orbital energies ****
      call Dneall_ffm_sym_Multiply(0,psi1,Hpsi,npack1,hml)
      call Dneall_m_scal(0,(-1.0d0),hml)
      if (fractional) then
         !call Dneall_m_diag_scal(0,dbl_mb(fweight(1)),hml)
         eorbit = Dneall_m_trace(0,hml)
         !call Dneall_m_diag_scal_inv(0,dbl_mb(fweight(1)),hml)
      else
         eorbit = Dneall_m_trace(0,hml)
      end if
      if (ispin.eq.1) eorbit = eorbit+eorbit
       

*     **** get ewald energy ****
      eion = 0.0d0
      if (control_version().eq.3) eion = ewald_e()
    
*     **** get free-space ion-ion energy ****
      if (control_version().eq.4) eion = ion_ion_e()

           
*     **** get coulomb energy ****
      if (control_version().eq.3) ehartr = coulomb_e(dcpl_mb(dng(1)))
      if (control_version().eq.4) then
         call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
         ehartr = 0.5d0*ehartr*dv
      end if
        

*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,dbl_mb(dnall(1)),dbl_mb(xce(1)),exc)
      call D3dB_rr_dot(1,dn(1,1),dbl_mb(xcp(1)),pxc)
      if (ispin.eq.1) then
         exc= exc + exc 
         pxc= pxc + pxc 
      else
         call D3dB_rr_dot(1,dbl_mb(dnall(1)+n2ft3d),
     >                      dbl_mb(xce(1)),exc2)
         call D3dB_rr_dot(1,dn(1,2),dbl_mb(xcp(1)+n2ft3d),pxc2)
         exc= exc + exc2
         pxc= pxc + pxc2
      end if
      exc = exc*dv
      pxc = pxc*dv

      if (nwpw_meta_gga_on()) then
         pxc = pxc + nwpw_meta_gga_pxc(ispin,ne,psi1)
      end if

        
  
*     ***** average Kohn-Sham kinetic energy ****
      call ke_ave(ispin,ne,psi1,eke,fractional,occ1)


*     **** average Kohn-Sham v_local energy ****
      call Pack_cc_dot(0,dcpl_mb(dng(1)),dcpl_mb(vl(1)),elocal)


*     *** add in long range part ****
      if (control_version().eq.4) then
      call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vlr_l(1)),sum)
      elocal = elocal + sum*dv
      end if

*     *** add in other real-space fields ****
      if (field_exist) then
      call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(v_field(1)),sum)
      elocal = elocal + sum*dv
      end if

 
*     ***** average Kohn-Sham v_nonlocal energy ****
c      call dcopy(2*npack1*nemax,0.0d0,0,Hpsi,1)
c      call v_nonlocal(ispin,ne,psi1,Hpsi,
c     >                .false.,dbl_mb(ftest(1)),fractional,occ1)
c      enlocal = 0.0d0
c      do ms=1,ispin
c      do n=n1(ms),n2(ms)
c         call Pack_cc_idot(1,psi1(1,n),Hpsi(1,n),sum)
c         if (fractional) sum=sum*occ1(n)
c         enlocal = enlocal - sum
c      end do
c      end do
c      if (np.gt.1) call Parallel_SumAll(enlocal)
c      if (ispin.eq.1) enlocal = 2.0d0*enlocal
      enlocal = E_vnonlocal(ispin,ne,fractional,occ1)



*     **** total energy ****
      Eold=E(1)
      E(1) = eorbit + eion + exc - ehartr - pxc
      E(2) = eorbit
      E(3) = ehartr
      E(4) = exc
      E(5) = eion
      E(6) = eke
      E(7) = elocal
      E(8) = enlocal
      E(9) = 2.0d0*ehartr
      E(10) = pxc

      if (pspw_qmmm_found()) then
         e_lj     = pspw_qmmm_LJ_E()
         e_q      = pspw_qmmm_Q_E()
         e_spring = pspw_qmmm_spring_E()
         E(1)  = E(1) + e_lj + e_q + e_spring

         E(11) = e_lj
         E(12) = e_q
         E(13) = e_spring
      end if

*     **** PAW ee terms ****
      if (psp_pawexist()) then
         E(35) = psp_kinetic_atom(ispin,ne,psi1)      !*** kinetic atom ***
         E(36) = psp_kinetic_core()                   !*** kinetic core  - independent of psi ***
         E(37) = psp_valence_core_atom(ispin,ne,psi1) !*** valence core energy ***

         E(38) = psp_ncmp_vloc(ispin)         !*** (ncmp)*Vlocal
         E(39) = psp_vloc_atom(ispin,ne,psi1) !*** Vlocal (local basis) -  nv*Vsrloc + nloc*Vloc - ncmp*Vloc ***

         ehartree_atom = psp_hartree_atom(ispin,ne,psi1)
         ecmp_cmp      = psp_hartree_cmp_cmp(ispin)
         ecmp_pw       = psp_hartree_cmp_pw(ispin,dcpl_mb(dng(1)),dn)
         E(40) = ehartree_atom             !*** vcoulomb atom  ***
         E(41) = ecmp_cmp                  !*** ncmp-ncmp coulomb energy ***
         E(42) = ecmp_pw                   !*** ncmp-pw coulomb energy ***

         call psp_xc_atom(ispin,ne,psi1,exc_atom,pxc_atom)
         E(43) = exc_atom                  !*** exc atom  ***
         E(44) = pxc_atom                  !*** pxc atom  ***

         E(45) = psp_ion_core()            !*** ion core energy - independent of psi ***


         E(1) = E(1) + E(36) + E(45) 
     >        + exc_atom - pxc_atom
     >        - ehartree_atom - ecmp_cmp - ecmp_pw
      end if


*     **** SIC corrections ****
      if (pspw_SIC()) then
         call pspw_energy_SIC(ispin,psi_r,ehsic,phsic,exsic,pxsic)
         E(1) = E(1) + ehsic + exsic
         E(16) = ehsic
         E(17) = exsic
         if (pspw_SIC_relaxed()) then
            E(1)  = E(1) - phsic - pxsic
            E(18) = phsic
            E(19) = pxsic
         end if
      end if

*     **** HFX corrections ****
      if (pspw_HFX()) then
         call pspw_energy_HFX(ispin,psi_r,ehfx,phfx)
         E(1) = E(1) + ehfx
         E(20) = ehfx
         if (pspw_HFX_relaxed()) then
            E(1)  = E(1) - phfx 
            E(21) = phfx
         end if
      end if

*     **** DFT+U terms ****
      if (psp_U_psputerm()) then
         call psp_U_psputerm_energy(ehfx,phfx)
         E(29) =  ehfx
         E(30) =  phfx
         E(1)  = E(1) + E(29) - E(30)
      end if

*     **** metadynamics energy ****
      if (meta_found()) then
         call meta_energypotential(ispin,ne,psi1,E(31),E(32))
         E(1)  = E(1) + E(31) - E(32)
      end if

*     **** Dispersion energy ****
      if (ion_disp_on()) then
         E(33) = ion_disp_energy()
         E(1)  = E(1) + E(33)
      end if


*     **** set convergence variables ****
      deltae = (E(1)-Eold)/(dt*dble(it_in))

*     *** deltac ***
      do n=n1(1),n2(ispin)
         do i=1,npack1
            Hpsi(i,n) = psi2(i,n) - psi1(i,n)
         end do
      end do

      do n=n1(1),n2(ispin)
         call Pack_cc_idot(1,Hpsi(1,n),Hpsi(1,n),dbl_mb(sumi(1)+n-1))
      end do
     
      if (np_i.gt.1) 
     >     call D3dB_Vector_SumAll((n2(ispin)-n1(1)+1),
     >                             dbl_mb(sumi(1)))

      deltac = 0.0d0
      do n=n1(1),n2(ispin)
         if (dbl_mb(sumi(1)+n-1).gt.deltac) deltac=dbl_mb(sumi(1)+n-1)
      end do
      if (np_j.gt.1) call D1dB_MaxAll(deltac)
      deltac = deltac/dte

c     do i=1,ion_nion()
c         fion(1,i) = (r2(1,i) - r1(1,i))/ion_dti(i)
c         fion(2,i) = (r2(2,i) - r1(2,i))/ion_dti(i)
c         fion(3,i) = (r2(3,i) - r1(3,i))/ion_dti(i)
c     end do

*     *** deltar ***
      deltar = deltamm
      if (move) then
        do i=1,ion_nion()
           sum = dsqrt( dbl_mb(fion(1)+(i-1)*3  )**2 
     >                + dbl_mb(fion(1)+(i-1)*3+1)**2 
     >                + dbl_mb(fion(1)+(i-1)*3+2)**2)
           if (sum.gt.deltar) deltar = sum
        end do
      end if
       
      call nwpw_timing_end(10)

*     **** dealocate MA local variables ****
      call nwpw_timing_start(12)
      value = MA_pop_stack(sumi(2))
      value = MA_pop_stack(ftest(2))
      value = MA_pop_stack(fion(2))
      value = MA_pop_stack(dnall(2))
      value = MA_pop_stack(xce(2))
      value = MA_pop_stack(xcp(2))
      value = MA_pop_stack(dng(2))
      value = MA_pop_stack(rho(2))
      value = MA_pop_stack(vl(2))
      value = MA_pop_stack(v_field(2))

      if ((control_version().eq.4).or.(field_exist))
     >   value = MA_pop_stack(r_grid(2))

      if (control_version().eq.4) 
     >   value = MA_pop_stack(vlr_l(2))

      value = MA_pop_stack(vc(2))
      value = MA_pop_stack(tmp2(2))
      value = MA_pop_stack(tmp1(2))
      value = Dneall_m_pop_stack(tmp_L)

      call nwpw_timing_end(12)


      return
      end
 

      SUBROUTINE ex_1real(n,ist,irecord,buf,ierr)

      implicit none

      integer i,j,n,ifact2,ifact,ist,nstart
      integer ierr,limit,iexft,irec_len

      real*8 expo,buf,fact

      character*1 irecord,cchar,itemp

      parameter(irec_len=100)

      dimension irecord(irec_len),cchar(19)

      data cchar/'0','1','2','3','4','5','6','7','8','9','+','&','/',
     $           '-','.','D','E','d','e'/

      buf=0.0d+0
      expo=0.0d+0
      iexft=0
      limit=19
      ifact2=0
      fact=1.0d0
      nstart=ist+n-1
      do i=1,n
       do j=1,limit
        if(cchar(j).eq.irecord(nstart))goto 180
       enddo
 170   ierr=2
       return
 180   if(j.lt.11)goto 200
       if(j.le.14)goto 190
       if(j.gt.15)then
        expo=buf
        iexft=i
        ifact2=i
        buf=0.0d+0
        fact=1.0d0
        goto 210
       endif
       ifact2=i-1
       limit=14
       goto 210
 190   continue
       if(j.eq.14)buf=-buf
       goto 210
 200   buf=buf+(dfloat(j-1)*fact)
       fact=fact*10.0d+0
 210   nstart=nstart-1
      enddo
 220  buf=(0.1d0**(ifact2-iexft))*buf
      buf=buf*10**expo
 230  continue

      return

      END
c $Id: extrct_real.f 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE ccsd_lr_d1_hp(d_i0,d_t1,d_t2,d_tr1,d_tr2,d_y1,d_y2,d_yr
     &1,d_yr2,k_i0_offset,k_t1_offset,k_t2_offset,k_tr1_offset,k_tr2_off
     &set,k_y1_offset,k_y2_offset,k_yr1_offset,k_yr2_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_tr + = 1 * tr ( p2 h1 )_tr
C     i0 ( p2 h1 )_ytr + = 1 * Sum ( h4 p3 ) * tr ( p2 p3 h1 h4 )_tr * y ( h4 p3 )_y
C     i0 ( p2 h1 )_ytrt + = -1 * Sum ( h7 ) * t ( p2 h7 )_t * i1 ( h7 h1 )_ytr
C         i1 ( h7 h1 )_ytr + = 1 * Sum ( p4 ) * tr ( p4 h1 )_tr * y ( h7 p4 )_y
C         i1 ( h7 h1 )_ytr + = -1/2 * Sum ( h6 p4 p5 ) * tr ( p4 p5 h1 h6 )_tr * y ( h6 h7 p4 p5 )_y
C         i1 ( h7 h1 )_yrt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * yr ( h5 h7 p3 p4 )_yr
C     i0 ( p2 h1 )_yttr + = -1 * Sum ( h7 ) * tr ( p2 h7 )_tr * i1 ( h7 h1 )_yt
C         i1 ( h7 h1 )_yt + = 1 * Sum ( p3 ) * t ( p3 h1 )_t * y ( h7 p3 )_y
C         i1 ( h7 h1 )_yt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * y ( h5 h7 p3 p4 )_y
C     i0 ( p2 h1 )_yttr + = 1/2 * Sum ( h5 h6 p4 ) * tr ( p2 p4 h5 h6 )_tr * i1 ( h5 h6 h1 p4 )_yt
C         i1 ( h5 h6 h1 p4 )_yt + = -1 * Sum ( p3 ) * t ( p3 h1 )_t * y ( h5 h6 p3 p4 )_y
C     i0 ( p2 h1 )_ytrt + = -1/2 * Sum ( h4 h5 p3 ) * t ( p2 p3 h4 h5 )_t * i1 ( h4 h5 h1 p3 )_ytr
C         i1 ( h4 h5 h1 p3 )_ytr + = -1 * Sum ( p6 ) * tr ( p6 h1 )_tr * y ( h4 h5 p3 p6 )_y
C         i1 ( h4 h5 h1 p3 )_yrt + = -1 * Sum ( p6 ) * t ( p6 h1 )_t * yr ( h4 h5 p3 p6 )_yr
C     i0 ( p2 h1 )_yrt + = 1 * Sum ( h4 p3 ) * t ( p2 p3 h1 h4 )_t * yr ( h4 p3 )_yr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_tr1
      INTEGER k_tr1_offset
      INTEGER d_tr2
      INTEGER k_tr2_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_yr1
      INTEGER k_yr1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_yr2
      INTEGER k_yr2_offset
      CHARACTER*255 filename
      CALL ccsd_lr_d1_hp_1(d_tr1,k_tr1_offset,d_i0,k_i0_offset)
      CALL ccsd_lr_d1_hp_2(d_tr2,k_tr2_offset,d_y1,k_y1_offset,d_i0,k_i0
     &_offset)
      CALL OFFSET_ccsd_lr_d1_hp_3_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsd_lr_d1_hp_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsd_lr_d1_hp_3_1(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i1,k_
     &i1_offset)
      CALL ccsd_lr_d1_hp_3_2(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_
     &i1_offset)
      CALL ccsd_lr_d1_hp_3_3(d_t2,k_t2_offset,d_yr2,k_yr2_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsd_lr_d1_hp_3(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_o
     &ffset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsd_lr_d1_hp',-
     &1,MA_ERR)
      CALL OFFSET_ccsd_lr_d1_hp_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsd_lr_d1_hp_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsd_lr_d1_hp_4_1(d_t1,k_t1_offset,d_y1,k_y1_offset,d_i1,k_i1
     &_offset)
      CALL ccsd_lr_d1_hp_4_2(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i1,k_i1
     &_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsd_lr_d1_hp_4(d_tr1,k_tr1_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsd_lr_d1_hp',-
     &1,MA_ERR)
      CALL OFFSET_ccsd_lr_d1_hp_5_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsd_lr_d1_hp_5_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsd_lr_d1_hp_5_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i1,k_i1
     &_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsd_lr_d1_hp_5(d_tr2,k_tr2_offset,d_i1,k_i1_offset,d_i0,k_i0
     &_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsd_lr_d1_hp',-
     &1,MA_ERR)
      CALL OFFSET_ccsd_lr_d1_hp_6_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsd_lr_d1_hp_6_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsd_lr_d1_hp_6_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i1,k_
     &i1_offset)
      CALL ccsd_lr_d1_hp_6_2(d_t1,k_t1_offset,d_yr2,k_yr2_offset,d_i1,k_
     &i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsd_lr_d1_hp_6(d_t2,k_t2_offset,d_i1,k_i1_offset,d_i0,k_i0_o
     &ffset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsd_lr_d1_hp',-
     &1,MA_ERR)
      CALL ccsd_lr_d1_hp_7(d_t2,k_t2_offset,d_yr1,k_yr1_offset,d_i0,k_i0
     &_offset)
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_tr + = 1 * tr ( p2 h1 )_tr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER p2b_1
      INTEGER h1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. irrep_tr) T
     &HEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      CALL TCE_RESTRICTED_2(p2b,h1b,p2b_1,h1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p2b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_1',2,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_1',4,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_1',5,
     &MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_ytr + = 1 * Sum ( h4 p3 ) * tr ( p2 p3 h1 h4 )_tr * y ( h4 p3 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER p2b_1
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER h4b_1
      INTEGER h4b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_tr)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_tr) THEN
      CALL TCE_RESTRICTED_4(p2b,p3b,h1b,h4b,p2b_1,p3b_1,h1b_1,h4b_1)
      CALL TCE_RESTRICTED_2(h4b,p3b,h4b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1)
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_2',2,MA_ERR)
      IF ((p3b .lt. p2b) .and. (h4b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h4b-1),int_mb(k_range+h1b-1)
     &,4,2,3,1,1.0d0)
      END IF
      IF ((p3b .lt. p2b) .and. (h1b .le. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h1b-1),int_mb(k_range+h4b-1)
     &,3,2,4,1,-1.0d0)
      END IF
      IF ((p2b .le. p3b) .and. (h4b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h1b-1)
     &,4,1,3,2,-1.0d0)
      END IF
      IF ((p2b .le. p3b) .and. (h1b .le. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h1b-1),int_mb(k_range+h4b-1)
     &,3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_2',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (h4b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_2',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_2',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_2',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_2',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_2',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_ytrt + = -1 * Sum ( h7 ) * t ( p2 h7 )_t * i1 ( h7 h1 )_ytr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h7b
      INTEGER p2b_1
      INTEGER h7b_1
      INTEGER h7b_2
      INTEGER h1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,ieor(irrep_tr,irrep_t))) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h7b = 1,noab
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h7b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p2b,h7b,p2b_1,h7b_1)
      CALL TCE_RESTRICTED_2(h7b,h1b,h7b_2,h1b_2)
      dim_common = int_mb(k_range+h7b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + noab * (p2b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h7b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_3',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h1b_2
     & - 1 + noab * (h7b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_3',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_3',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_3_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h7 h1 )_ytr + = 1 * Sum ( p4 ) * tr ( p4 h1 )_tr * y ( h7 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h7b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_tr)) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      IF (int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+h1b-1)) .eq. irrep_tr) T
     &HEN
      CALL TCE_RESTRICTED_2(p4b,h1b,p4b_1,h1b_1)
      CALL TCE_RESTRICTED_2(h7b,p4b,h7b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p4b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_3_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (h7b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+p4b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_3_1',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h1b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h7b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_3_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd_lr_d1_hp_3_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h7 h1 )_ytr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h7b
      INTEGER h1b
      length = 0
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_tr)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd_lr_d1_hp_3_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_tr)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h1b - 1 + noab * (h7b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h7b-1) * int_mb(k_range+h1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_3_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h7 h1 )_ytr + = -1/2 * Sum ( h6 p4 p5 ) * tr ( p4 p5 h1 h6 )_tr * y ( h6 h7 p4 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p5b
      INTEGER h6b
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER h6b_1
      INTEGER h7b_2
      INTEGER h6b_2
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_tr)) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO p5b = p4b,noab+nvab
      DO h6b = 1,noab
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_tr) THEN
      CALL TCE_RESTRICTED_4(p4b,p5b,h1b,h6b,p4b_1,p5b_1,h1b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h7b,h6b,p4b,p5b,h7b_2,h6b_2,p4b_2,p5b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_m
     &b(k_range+h6b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_2',2,MA_ERR)
      IF ((h6b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h1b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h1b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h6b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_3_2',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_2',5,MA_ERR)
      IF ((h6b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab 
     &* (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,2,1,4,3,1.0d0)
      END IF
      IF ((h7b .lt. h6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,1,2,4,3,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_3_2',6,MA_
     &ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p4b .eq. p5b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_2',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_2',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h1b-1),1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h7b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_3_2',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_2',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_3_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h7 h1 )_yrt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * yr ( h5 h7 p3 p4 )_yr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER h5b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h5b_1
      INTEGER h7b_2
      INTEGER h5b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &yr,irrep_t)) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h5b = 1,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h5b,p3b_1,p4b_1,h1b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h7b,h5b,p3b,p4b,h7b_2,h5b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_3',2,MA_ERR)
      IF ((h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h1b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h5b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_3_3',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_3_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_3',5,MA_ERR)
      IF ((h5b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,2,1,4,3,1.0d0)
      END IF
      IF ((h7b .lt. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,1,2,4,3,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_3_3',6,MA_
     &ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_3',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_3',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_3_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h1b-1),1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h7b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_3_3',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_3_3',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_yttr + = -1 * Sum ( h7 ) * tr ( p2 h7 )_tr * i1 ( h7 h1 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h7b
      INTEGER p2b_1
      INTEGER h7b_1
      INTEGER h7b_2
      INTEGER h1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,ieor(irrep_t,irrep_tr))) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h7b = 1,noab
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h7b-1)) .eq. irrep_tr) T
     &HEN
      CALL TCE_RESTRICTED_2(p2b,h7b,p2b_1,h7b_1)
      CALL TCE_RESTRICTED_2(h7b,h1b,h7b_2,h1b_2)
      dim_common = int_mb(k_range+h7b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + noab * (p2b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h7b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_4',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h1b_2
     & - 1 + noab * (h7b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_4',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_4',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_4_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h7 h1 )_yt + = 1 * Sum ( p3 ) * t ( p3 h1 )_t * y ( h7 p3 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER h7b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h1b,p3b_1,h1b_1)
      CALL TCE_RESTRICTED_2(h7b,p3b,h7b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_4_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (h7b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+p3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_4_1',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h1b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h7b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_4_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd_lr_d1_hp_4_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h7 h1 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h7b
      INTEGER h1b
      length = 0
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd_lr_d1_hp_4_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h1b - 1 + noab * (h7b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h7b-1) * int_mb(k_range+h1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_4_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h7 h1 )_yt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * y ( h5 h7 p3 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER h5b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h5b_1
      INTEGER h7b_2
      INTEGER h5b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h7b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h5b = 1,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h5b,p3b_1,p4b_1,h1b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h7b,h5b,p3b,p4b,h7b_2,h5b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4_2',2,MA_ERR)
      IF ((h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h1b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h5b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_4_2',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_4_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4_2',5,MA_ERR)
      IF ((h5b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,2,1,4,3,1.0d0)
      END IF
      IF ((h7b .lt. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,1,2,4,3,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_4_2',6,MA_
     &ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4_2',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4_2',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_4_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h1b-1),1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h7b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_4_2',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_4_2',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_yttr + = 1/2 * Sum ( h5 h6 p4 ) * tr ( p2 p4 h5 h6 )_tr * i1 ( h5 h6 h1 p4 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p2b_1
      INTEGER p4b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h1b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,ieor(irrep_t,irrep_tr))) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_tr) THEN
      CALL TCE_RESTRICTED_4(p2b,p4b,h5b,h6b,p2b_1,p4b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,h1b,p4b,h5b_2,h6b_2,h1b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+h5b-1) * int_m
     &b(k_range+h6b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_5',2,MA_ERR)
      IF ((p4b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p2b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_5',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_5',5,MA_ERR)
      IF ((h1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (h1b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_
     &2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p4b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_5',6,MA_ER
     &R)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_5',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_5',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_5',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_5',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_5',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_5_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 h6 h1 p4 )_yt + = -1 * Sum ( p3 ) * t ( p3 h1 )_t * y ( h5 h6 p3 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h6b
      INTEGER h1b
      INTEGER p4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p4b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h1b = 1,noab
      DO p4b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_5_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h1b,p3b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p4b,p3b,h5b_2,h6b_2,p4b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_5_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_5_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_5_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_5_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_5_1',5,MA_ERR)
      IF ((p3b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((p4b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_5_1',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_5_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_5_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_5_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h6b - 1 + noab * (h5b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_5_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_5_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd_lr_d1_hp_5_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 h6 h1 p4 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h5b
      INTEGER h6b
      INTEGER h1b
      INTEGER p4b
      length = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h1b = 1,noab
      DO p4b = noab+1,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd_lr_d1_hp_5_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO h1b = 1,noab
      DO p4b = noab+1,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p4b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (h6b - 1 + noab * (h5b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+p4b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_6(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_ytrt + = -1/2 * Sum ( h4 h5 p3 ) * t ( p2 p3 h4 h5 )_t * i1 ( h4 h5 h1 p3 )_ytr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER p2b_1
      INTEGER p3b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER h1b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,ieor(irrep_tr,irrep_t))) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &4b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h4b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p2b,p3b,h4b,h5b,p2b_1,p3b_1,h4b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,h1b,p3b,h4b_2,h5b_2,h1b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6',2,MA_ERR)
      IF ((p3b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p2b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_6',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6',5,MA_ERR)
      IF ((h1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (h1b_2 - 1 + noab * (h5b_2 - 1 + noab * (h4b_
     &2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_6',6,MA_ER
     &R)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_6',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_6_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h1 p3 )_ytr + = -1 * Sum ( p6 ) * tr ( p6 h1 )_tr * y ( h4 h5 p3 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER h1b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p3b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h1b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,irrep_tr)) T
     &HEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p6b-1),int_mb(k_sym+h1b-1)) .eq. irrep_tr) T
     &HEN
      CALL TCE_RESTRICTED_2(p6b,h1b,p6b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p3b,p6b,h4b_2,h5b_2,p3b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p6b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_6_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6_1',5,MA_ERR)
      IF ((p6b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p3b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p3b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p3b-1),int_mb(k_range+p6b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_6_1',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h4b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h5b - 1 + noab * (h4b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_6_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd_lr_d1_hp_6_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h1 p3 )_ytr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h4b
      INTEGER h5b
      INTEGER h1b
      INTEGER p3b
      length = 0
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h1b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,irrep_tr)) T
     &HEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd_lr_d1_hp_6_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h1b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,irrep_tr)) T
     &HEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p3b - noab - 1 + nvab * (h1b - 1 + noab 
     &* (h5b - 1 + noab * (h4b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+p3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_6_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h1 p3 )_yrt + = -1 * Sum ( p6 ) * t ( p6 h1 )_t * yr ( h4 h5 p3 p6 )_yr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER h1b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p3b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h1b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_yr,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p6b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p6b,h1b,p6b_1,h1b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p3b,p6b,h4b_2,h5b_2,p3b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p6b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_6_2',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_6_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6_2',5,MA_ERR)
      IF ((p6b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p3b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p3b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p3b-1),int_mb(k_range+p6b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_6_2',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6_2',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6_2',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_6_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h4b-1),int_mb(k_range+h1b-1)
     &,3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (h1b - 1 + noab * (h5b - 1 + noab * (h4b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_6_2',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_6_2',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd_lr_d1_hp_7(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: ccsd_lr_d1_hp.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_yrt + = 1 * Sum ( h4 p3 ) * t ( p2 p3 h1 h4 )_t * yr ( h4 p3 )_yr
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER p2b_1
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER h4b_1
      INTEGER h4b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &yr,irrep_t)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_7',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p2b,p3b,h1b,h4b,p2b_1,p3b_1,h1b_1,h4b_1)
      CALL TCE_RESTRICTED_2(h4b,p3b,h4b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1)
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_7',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_7',2,MA_ERR)
      IF ((p3b .lt. p2b) .and. (h4b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h4b-1),int_mb(k_range+h1b-1)
     &,4,2,3,1,1.0d0)
      END IF
      IF ((p3b .lt. p2b) .and. (h1b .le. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h1b-1),int_mb(k_range+h4b-1)
     &,3,2,4,1,-1.0d0)
      END IF
      IF ((p2b .le. p3b) .and. (h4b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h1b-1)
     &,4,1,3,2,-1.0d0)
      END IF
      IF ((p2b .le. p3b) .and. (h1b .le. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h1b-1),int_mb(k_range+h4b-1)
     &,3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_lr_d1_hp_7',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_lr_d1_hp_7',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_7',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (h4b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_lr_d1_hp_7',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_7',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_7',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd_lr_d1_hp_7',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd_lr_d1_hp_7',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_lr_d1_hp_7',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE lr_ccsd_tq_1(d_t1,k_t1_offset,d_t2,k_t2_offset,
     1                   d_v2,k_v2_offset,
     2                   d_e,k_e_offset,energy)
C
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_t1
      integer k_t1_offset
      integer d_t2
      integer k_t2_offset
      integer d_v2
      integer k_v2_offset
      integer d_e
      integer k_e_offset
      integer t_h1b, t_h1
      integer t_h2b, t_h2
      integer t_h3b, t_h3
      integer t_h4b, t_h4
      integer t_p5b, t_p5
      integer t_p6b, t_p6
      integer t_p7b, t_p7
      integer t_p8b, t_p8
      integer k_right,l_right
      integer k_left,l_left
c
      integer l_hole,k_hole
      integer l_2hole,k_2hole
      integer hole_p_1
      integer hole_p_2
      double precision diffeorb,xlocden
c
      integer size,i
      integer g_energy
      integer nxtask
      integer next
      integer nprocs
      integer count
      integer d_i1_1,d_i1_2
      integer k_i1_offset_1,l_i1_offset_1
      integer k_i1_offset_2,l_i1_offset_2
      double precision energy
      double precision factor
      external nxtask
c
      k_right = 0
      k_left = 0
c
c forming the nu(i) and mu(i,j) arrays (i,j refer to occupied indices)
c no offset for nu(i) and mu(i,j) is needed
      hole_p_1=nocc(1)-nfc(1)+nocc(ipol)-nfc(ipol)
      if (.not.ma_push_get(mt_dbl,hole_p_1,
     1  "one hole",l_hole,k_hole)) call errquit('lr_ccsd_t',1,MA_ERR)
      hole_p_2=hole_p_1*hole_p_1
      if (.not.ma_push_get(mt_dbl,hole_p_2,"two holes",
     2    l_2hole,k_2hole)) call errquit('lr_ccsd_t',2,MA_ERR)
c
c here goes the procedure to calculate the nu(i) and mu(i,j)
        do i=1,hole_p_1
         dbl_mb(k_hole+i-1)=0.0d0
        enddo
        do i=1,hole_p_2
         dbl_mb(k_2hole+i-1)=0.0d0
        enddo
        call tce_nu1(k_hole,d_t1,k_t1_offset)
        call tce_mu2(k_2hole,hole_p_1,d_t2,k_t2_offset)
c
c
c     Caution! k_right & k_left are not even allocated yet
c     but they won't be used.
c
c
c
c
      call ccsd2_q_right(dbl_mb(k_right),d_i1_1,d_i1_2,
     1  d_t1,d_t2,d_v2,k_i1_offset_1,k_i1_offset_2,
     2  k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3  l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_h4b,
     4  t_p5b,t_p6b,t_p7b,t_p8b,1)
      call lr_t2_t2(dbl_mb(k_left),d_t2,k_t2_offset,
     &  t_h1b,t_h2b,t_h3b,t_h4b,
     &  t_p5b,t_p6b,t_p7b,t_p8b,1)
c
c     Accumulate
c
      if (.not.ga_create(mt_dbl,1,1,'perturbative',1,1,g_energy))
     1  call errquit('ccsd_q: GA problem',0,GA_ERR)
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      energy=0.0d0
      do t_p5b = noab+1,noab+nvab
       do t_p6b = t_p5b,noab+nvab
        do t_p7b = t_p6b,noab+nvab
         do t_p8b = t_p7b,noab+nvab
          do t_h1b = 1,noab
           do t_h2b = t_h1b,noab
            do t_h3b = t_h2b,noab
             do t_h4b = t_h3b,noab
              if (next.eq.count) then
              if (int_mb(k_spin+t_p5b-1)
     1           +int_mb(k_spin+t_p6b-1)
     2           +int_mb(k_spin+t_p7b-1)
     3           +int_mb(k_spin+t_p8b-1)
     4        .eq.int_mb(k_spin+t_h1b-1)
     5           +int_mb(k_spin+t_h2b-1)
     6           +int_mb(k_spin+t_h3b-1)
     7           +int_mb(k_spin+t_h4b-1)) then
              if ((.not.restricted).or.
     1           (int_mb(k_spin+t_p5b-1)
     2           +int_mb(k_spin+t_p6b-1)
     3           +int_mb(k_spin+t_p7b-1)
     4           +int_mb(k_spin+t_p8b-1)
     5           +int_mb(k_spin+t_h1b-1)
     6           +int_mb(k_spin+t_h2b-1)
     7           +int_mb(k_spin+t_h3b-1)
     8           +int_mb(k_spin+t_h4b-1).le.12)) then
              if (ieor(int_mb(k_sym+t_p5b-1),
     1            ieor(int_mb(k_sym+t_p6b-1),
     2            ieor(int_mb(k_sym+t_p7b-1),
     3            ieor(int_mb(k_sym+t_p8b-1),
     4            ieor(int_mb(k_sym+t_h1b-1),
     5            ieor(int_mb(k_sym+t_h2b-1),
     6            ieor(int_mb(k_sym+t_h3b-1),
     7                 int_mb(k_sym+t_h4b-1)))))))).eq.0) then
              size = int_mb(k_range+t_p5b-1)
     1             * int_mb(k_range+t_p6b-1)
     2             * int_mb(k_range+t_p7b-1)
     3             * int_mb(k_range+t_p8b-1)
     4             * int_mb(k_range+t_h1b-1)
     5             * int_mb(k_range+t_h2b-1)
     6             * int_mb(k_range+t_h3b-1)
     7             * int_mb(k_range+t_h4b-1)
              if (.not.MA_PUSH_GET(mt_dbl,size,'right moment 2,3',
     1          l_right,k_right)) call errquit('lr_ccsd_tq',3,MA_ERR)
              if (.not.MA_PUSH_GET(mt_dbl,size,'T2 T2',
     1          l_left,k_left)) call errquit('lr-ccsd_tq',3,MA_ERR)
              do i = 1, size
               dbl_mb(k_right+i-1) = 0.0d0
               dbl_mb(k_left+i-1) = 0.0d0
              enddo
              call ccsd2_q_right(dbl_mb(k_right),d_i1_1,d_i1_2,
     1          d_t1,d_t2,d_v2,k_i1_offset_1,k_i1_offset_2,
     2          k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3          l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_h4b,
     4          t_p5b,t_p6b,t_p7b,t_p8b,2)
              call lr_t2_t2(dbl_mb(k_left),d_t2,k_t2_offset,
     &          t_h1b,t_h2b,t_h3b,t_h4b,
     &          t_p5b,t_p6b,t_p7b,t_p8b,2)
              if ((restricted).and.
     1           (int_mb(k_spin+t_p5b-1)
     2           +int_mb(k_spin+t_p6b-1)
     3           +int_mb(k_spin+t_p7b-1)
     4           +int_mb(k_spin+t_p8b-1)
     5           +int_mb(k_spin+t_h1b-1)
     6           +int_mb(k_spin+t_h2b-1)
     7           +int_mb(k_spin+t_h3b-1)
     8           +int_mb(k_spin+t_h4b-1).ne.12)) then
                factor = 2.0d0
              else
                factor = 1.0d0
              endif
              if ((t_p5b.eq.t_p6b).and.(t_p6b.eq.t_p7b)
     1                            .and.(t_p7b.eq.t_p8b)) then
                factor = factor / 24.0d0
              else if ((t_p5b.eq.t_p6b).and.(t_p6b.eq.t_p7b)) then
                factor = factor / 6.0d0
              else if ((t_p6b.eq.t_p7b).and.(t_p7b.eq.t_p8b)) then
                factor = factor / 6.0d0
              else if ((t_p5b.eq.t_p6b).and.(t_p7b.eq.t_p8b)) then
                factor = factor / 4.0d0
              else if (t_p5b.eq.t_p6b) then
                factor = factor / 2.0d0
              else if (t_p6b.eq.t_p7b) then
                factor = factor / 2.0d0
              else if (t_p7b.eq.t_p8b) then
                factor = factor / 2.0d0
              endif
              if ((t_h1b.eq.t_h2b).and.(t_h2b.eq.t_h3b)
     1                            .and.(t_h3b.eq.t_h4b)) then
                factor = factor / 24.0d0
              else if ((t_h1b.eq.t_h2b).and.(t_h2b.eq.t_h3b)) then
                factor = factor / 6.0d0
              else if ((t_h2b.eq.t_h3b).and.(t_h3b.eq.t_h4b)) then
                factor = factor / 6.0d0
              else if ((t_h1b.eq.t_h2b).and.(t_h3b.eq.t_h4b)) then
                factor = factor / 4.0d0
              else if (t_h1b.eq.t_h2b) then
                factor = factor / 2.0d0
              else if (t_h2b.eq.t_h3b) then
                factor = factor / 2.0d0
              else if (t_h3b.eq.t_h4b) then
                factor = factor / 2.0d0
              endif
              i = 0
              do t_p5 = 1, int_mb(k_range+t_p5b-1)
               do t_p6 = 1, int_mb(k_range+t_p6b-1)
                do t_p7 = 1, int_mb(k_range+t_p7b-1)
                 do t_p8 = 1, int_mb(k_range+t_p8b-1)
                  do t_h1 = 1, int_mb(k_range+t_h1b-1)
                   do t_h2 = 1, int_mb(k_range+t_h2b-1)
                    do t_h3 = 1, int_mb(k_range+t_h3b-1)
                     do t_h4 = 1, int_mb(k_range+t_h4b-1)
                    i = i + 1
c
        diffeorb=-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     3           -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     4           -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p7b-1)+t_p7-1)
     5           -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p8b-1)+t_p8-1)
     6           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     7           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     8           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1)
     9           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h4b-1)+t_h4-1)
c
        xlocden=1.0d0+dbl_mb(k_hole+int_mb(k_offset+t_h1b-1)+t_h1-1)
     &               +dbl_mb(k_hole+int_mb(k_offset+t_h2b-1)+t_h2-1)
     &               +dbl_mb(k_hole+int_mb(k_offset+t_h3b-1)+t_h3-1)
     &               +dbl_mb(k_hole+int_mb(k_offset+t_h4b-1)+t_h4-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h1b-1)+t_h1-1)
     &            +int_mb(k_offset+t_h2b-1)+t_h2-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h1b-1)+t_h1-1)
     &            +int_mb(k_offset+t_h3b-1)+t_h3-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h2b-1)+t_h2-1)
     &            +int_mb(k_offset+t_h3b-1)+t_h3-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h1b-1)+t_h1-1)
     &            +int_mb(k_offset+t_h4b-1)+t_h4-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h2b-1)+t_h2-1)
     &            +int_mb(k_offset+t_h4b-1)+t_h4-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h3b-1)+t_h3-1)
     &            +int_mb(k_offset+t_h4b-1)+t_h4-1)
c
                    energy = energy + factor * dbl_mb(k_right+i-1)
     1                                       * dbl_mb(k_left+i-1)/
     2                                         (xlocden)
c
                    energy = energy + factor * dbl_mb(k_right+i-1)
     1                                       * dbl_mb(k_right+i-1)/
     2                                         (diffeorb*xlocden)
c
                     enddo
                    enddo
                   enddo
                  enddo
                 enddo
                enddo
               enddo
              enddo
              if (.not.MA_POP_STACK(l_left)) 
     1          call errquit('ccsd_q',6,MA_ERR)
              if (.not.MA_POP_STACK(l_right)) 
     1          call errquit('ccsd_q',6,MA_ERR)
              endif
              endif
              endif
              next = nxtask(nprocs,1)
              endif
              count = count + 1
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      next = nxtask(-nprocs,1)
      call lr_t2_t2(dbl_mb(k_left),d_t2,k_t2_offset,
     &  t_h1b,t_h2b,t_h3b,t_h4b,
     &  t_p5b,t_p6b,t_p7b,t_p8b,3)
      call ccsd2_q_right(dbl_mb(k_right),d_i1_1,d_i1_2,
     1  d_t1,d_t2,d_v2,k_i1_offset_1,k_i1_offset_2,
     2  k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3  l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_h4b,
     4  t_p5b,t_p6b,t_p7b,t_p8b,3)
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,energy,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,energy,1)
      if (.not.ga_destroy(g_energy))
     1  call errquit('ccsd_q: GA problem',1,GA_ERR)
c
      if (.not.ma_pop_stack(l_2hole))
     1  call errquit("tce_energy: MA problem",19,MA_ERR)
      if (.not.ma_pop_stack(l_hole))
     1  call errquit("tce_energy: MA problem",19,MA_ERR)
c
      return
      end
c
c
c
c FULL VERSION 
c
c
c
      SUBROUTINE lr_ccsd_tq1p(d_t1,k_t1_offset,d_t2,k_t2_offset,
     1                   d_v2,k_v2_offset,
     2                   d_e,k_e_offset,energy)
C
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_t1
      integer k_t1_offset
      integer d_t2
      integer k_t2_offset
      integer d_v2
      integer k_v2_offset
      integer d_e
      integer k_e_offset
      integer t_h1b, t_h1
      integer t_h2b, t_h2
      integer t_h3b, t_h3
      integer t_h4b, t_h4
      integer t_p5b, t_p5
      integer t_p6b, t_p6
      integer t_p7b, t_p7
      integer t_p8b, t_p8
      integer k_right,l_right
      integer k_left,l_left
c local denominators
      integer l_hole,k_hole
      integer l_2hole,k_2hole
      integer hole_p_1
      integer hole_p_2
      double precision diffeorb,xlocden
c needed in lr_12prod_q call
      integer d_ii1_1,d_ii1_3
      integer k_ii1_offset_1,k_ii1_offset_3
      integer l_ii1_offset_1,l_ii1_offset_3
c
      integer size,i
      integer g_energy
      integer nxtask
      integer next
      integer nprocs
      integer count
      integer d_i1_1,d_i1_2
      integer k_i1_offset_1,l_i1_offset_1
      integer k_i1_offset_2,l_i1_offset_2
      double precision energy
      double precision factor
      external nxtask
c
c
c forming the nu(i) and mu(i,j) arrays (i,j refer to occupied indices)
c no offset for nu(i) and mu(i,j) is needed
      hole_p_1=nocc(1)-nfc(1)+nocc(ipol)-nfc(ipol)
      if (.not.ma_push_get(mt_dbl,hole_p_1,
     1  "one hole",l_hole,k_hole)) call errquit('lr_ccsd_t',1,MA_ERR)
      hole_p_2=hole_p_1*hole_p_1
      if (.not.ma_push_get(mt_dbl,hole_p_2,"two holes",
     2    l_2hole,k_2hole)) call errquit('lr_ccsd_t',2,MA_ERR)
c
c here goes the procedure to calculate the nu(i) and mu(i,j)
        do i=1,hole_p_1
         dbl_mb(k_hole+i-1)=0.0d0
        enddo
        do i=1,hole_p_2
         dbl_mb(k_2hole+i-1)=0.0d0
        enddo
        call tce_nu1(k_hole,d_t1,k_t1_offset)
        call tce_mu2(k_2hole,hole_p_1,d_t2,k_t2_offset)
c
c
c
c
c     Caution! k_right & k_left are not even allocated yet
c     but they won't be used.
c
c
c
c
      call ccsd2_q_right(dbl_mb(k_right),d_i1_1,d_i1_2,
     1  d_t1,d_t2,d_v2,k_i1_offset_1,k_i1_offset_2,
     2  k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3  l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_h4b,
     4  t_p5b,t_p6b,t_p7b,t_p8b,1)
      call lr_12prod_q(dbl_mb(k_left),d_ii1_1,d_ii1_3,d_t1,
     &d_t2,k_ii1_offset_1,k_ii1_offset_3,k_t1_offset,
     &k_t2_offset,l_ii1_offset_1,l_ii1_offset_3,
     &t_h1b,t_h2b,t_h3b,t_h4b,t_p5b,t_p6b,t_p7b,t_p8b
     &,1)
ccc      call lr_t1t3_q(dbl_mb(k_right2),d_t1,d_m3loc,
ccc     &k_t1_offset,k_m3loc_offset,t_h1b,
ccc     &t_h2b,t_h3b,t_h4b,t_p5b,t_p6b,t_p7b,t_p8b,1)
c
c     Accumulate
c
      if (.not.ga_create(mt_dbl,1,1,'perturbative',1,1,g_energy))
     1  call errquit('ccsd_q: GA problem',0,GA_ERR)
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      energy=0.0d0
      do t_p5b = noab+1,noab+nvab
       do t_p6b = t_p5b,noab+nvab
        do t_p7b = t_p6b,noab+nvab
         do t_p8b = t_p7b,noab+nvab
          do t_h1b = 1,noab
           do t_h2b = t_h1b,noab
            do t_h3b = t_h2b,noab
             do t_h4b = t_h3b,noab
              if (next.eq.count) then
              if (int_mb(k_spin+t_p5b-1)
     1           +int_mb(k_spin+t_p6b-1)
     2           +int_mb(k_spin+t_p7b-1)
     3           +int_mb(k_spin+t_p8b-1)
     4        .eq.int_mb(k_spin+t_h1b-1)
     5           +int_mb(k_spin+t_h2b-1)
     6           +int_mb(k_spin+t_h3b-1)
     7           +int_mb(k_spin+t_h4b-1)) then
              if ((.not.restricted).or.
     1           (int_mb(k_spin+t_p5b-1)
     2           +int_mb(k_spin+t_p6b-1)
     3           +int_mb(k_spin+t_p7b-1)
     4           +int_mb(k_spin+t_p8b-1)
     5           +int_mb(k_spin+t_h1b-1)
     6           +int_mb(k_spin+t_h2b-1)
     7           +int_mb(k_spin+t_h3b-1)
     8           +int_mb(k_spin+t_h4b-1).le.12)) then
              if (ieor(int_mb(k_sym+t_p5b-1),
     1            ieor(int_mb(k_sym+t_p6b-1),
     2            ieor(int_mb(k_sym+t_p7b-1),
     3            ieor(int_mb(k_sym+t_p8b-1),
     4            ieor(int_mb(k_sym+t_h1b-1),
     5            ieor(int_mb(k_sym+t_h2b-1),
     6            ieor(int_mb(k_sym+t_h3b-1),
     7                 int_mb(k_sym+t_h4b-1)))))))).eq.0) then
              size = int_mb(k_range+t_p5b-1)
     1             * int_mb(k_range+t_p6b-1)
     2             * int_mb(k_range+t_p7b-1)
     3             * int_mb(k_range+t_p8b-1)
     4             * int_mb(k_range+t_h1b-1)
     5             * int_mb(k_range+t_h2b-1)
     6             * int_mb(k_range+t_h3b-1)
     7             * int_mb(k_range+t_h4b-1)
              if (.not.MA_PUSH_GET(mt_dbl,size,'right moment 2,3',
     1          l_right,k_right)) call errquit('lr_ccsd_tq',3,MA_ERR)
              if (.not.MA_PUSH_GET(mt_dbl,size,'T2 T2',
     1          l_left,k_left)) call errquit('lr-ccsd_tq',3,MA_ERR)
              do i = 1, size
               dbl_mb(k_right+i-1) = 0.0d0
               dbl_mb(k_left+i-1) = 0.0d0
              enddo
              call ccsd2_q_right(dbl_mb(k_right),d_i1_1,d_i1_2,
     1          d_t1,d_t2,d_v2,k_i1_offset_1,k_i1_offset_2,
     2          k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3          l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_h4b,
     4          t_p5b,t_p6b,t_p7b,t_p8b,2)
              call lr_12prod_q(dbl_mb(k_left),d_ii1_1,d_ii1_3,d_t1,
     &           d_t2,k_ii1_offset_1,k_ii1_offset_3,k_t1_offset,
     &           k_t2_offset,l_ii1_offset_1,l_ii1_offset_3,
     &           t_h1b,t_h2b,t_h3b,t_h4b,t_p5b,t_p6b,t_p7b,t_p8b
     &           ,2)
c              call lr_t1t3_q(dbl_mb(k_right2),d_t1,d_m3loc,
c     &           k_t1_offset,k_m3loc_offset,t_h1b,
c     &           t_h2b,t_h3b,t_h4b,t_p5b,t_p6b,t_p7b,t_p8b,2)
              if ((restricted).and.
     1           (int_mb(k_spin+t_p5b-1)
     2           +int_mb(k_spin+t_p6b-1)
     3           +int_mb(k_spin+t_p7b-1)
     4           +int_mb(k_spin+t_p8b-1)
     5           +int_mb(k_spin+t_h1b-1)
     6           +int_mb(k_spin+t_h2b-1)
     7           +int_mb(k_spin+t_h3b-1)
     8           +int_mb(k_spin+t_h4b-1).ne.12)) then
                factor = 2.0d0
              else
                factor = 1.0d0
              endif
              if ((t_p5b.eq.t_p6b).and.(t_p6b.eq.t_p7b)
     1                            .and.(t_p7b.eq.t_p8b)) then
                factor = factor / 24.0d0
              else if ((t_p5b.eq.t_p6b).and.(t_p6b.eq.t_p7b)) then
                factor = factor / 6.0d0
              else if ((t_p6b.eq.t_p7b).and.(t_p7b.eq.t_p8b)) then
                factor = factor / 6.0d0
              else if ((t_p5b.eq.t_p6b).and.(t_p7b.eq.t_p8b)) then
                factor = factor / 4.0d0
              else if (t_p5b.eq.t_p6b) then
                factor = factor / 2.0d0
              else if (t_p6b.eq.t_p7b) then
                factor = factor / 2.0d0
              else if (t_p7b.eq.t_p8b) then
                factor = factor / 2.0d0
              endif
              if ((t_h1b.eq.t_h2b).and.(t_h2b.eq.t_h3b)
     1                            .and.(t_h3b.eq.t_h4b)) then
                factor = factor / 24.0d0
              else if ((t_h1b.eq.t_h2b).and.(t_h2b.eq.t_h3b)) then
                factor = factor / 6.0d0
              else if ((t_h2b.eq.t_h3b).and.(t_h3b.eq.t_h4b)) then
                factor = factor / 6.0d0
              else if ((t_h1b.eq.t_h2b).and.(t_h3b.eq.t_h4b)) then
                factor = factor / 4.0d0
              else if (t_h1b.eq.t_h2b) then
                factor = factor / 2.0d0
              else if (t_h2b.eq.t_h3b) then
                factor = factor / 2.0d0
              else if (t_h3b.eq.t_h4b) then
                factor = factor / 2.0d0
              endif
              i = 0
              do t_p5 = 1, int_mb(k_range+t_p5b-1)
               do t_p6 = 1, int_mb(k_range+t_p6b-1)
                do t_p7 = 1, int_mb(k_range+t_p7b-1)
                 do t_p8 = 1, int_mb(k_range+t_p8b-1)
                  do t_h1 = 1, int_mb(k_range+t_h1b-1)
                   do t_h2 = 1, int_mb(k_range+t_h2b-1)
                    do t_h3 = 1, int_mb(k_range+t_h3b-1)
                     do t_h4 = 1, int_mb(k_range+t_h4b-1)
                    i = i + 1
c
        diffeorb=-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     3           -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     4           -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p7b-1)+t_p7-1)
     5           -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p8b-1)+t_p8-1)
     6           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     7           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     8           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1)
     9           +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h4b-1)+t_h4-1)
c
        xlocden=1.0d0+dbl_mb(k_hole+int_mb(k_offset+t_h1b-1)+t_h1-1)
     &               +dbl_mb(k_hole+int_mb(k_offset+t_h2b-1)+t_h2-1)
     &               +dbl_mb(k_hole+int_mb(k_offset+t_h3b-1)+t_h3-1)
     &               +dbl_mb(k_hole+int_mb(k_offset+t_h4b-1)+t_h4-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h1b-1)+t_h1-1)
     &            +int_mb(k_offset+t_h2b-1)+t_h2-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h1b-1)+t_h1-1)
     &            +int_mb(k_offset+t_h3b-1)+t_h3-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h2b-1)+t_h2-1)
     &            +int_mb(k_offset+t_h3b-1)+t_h3-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h1b-1)+t_h1-1)
     &            +int_mb(k_offset+t_h4b-1)+t_h4-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h2b-1)+t_h2-1)
     &            +int_mb(k_offset+t_h4b-1)+t_h4-1)
     &     +dbl_mb(k_2hole+hole_p_1*(int_mb(k_offset+t_h3b-1)+t_h3-1)
     &            +int_mb(k_offset+t_h4b-1)+t_h4-1)
c <(all_12products)+*M4/local_den>
                    energy = energy + factor * dbl_mb(k_right+i-1)
     1                                       * dbl_mb(k_left+i-1)/
     2                                         (xlocden)
c <T4+*(M4/local_den)>
                    energy = energy + factor * dbl_mb(k_right+i-1)
     1                                       * dbl_mb(k_right+i-1)/
     2                                         (diffeorb*xlocden)
c
                     enddo
                    enddo
                   enddo
                  enddo
                 enddo
                enddo
               enddo
              enddo
              if (.not.MA_POP_STACK(l_left)) 
     1          call errquit('ccsd_q',6,MA_ERR)
              if (.not.MA_POP_STACK(l_right)) 
     1          call errquit('ccsd_q',6,MA_ERR)
              endif
              endif
              endif
              next = nxtask(nprocs,1)
              endif
              count = count + 1
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      next = nxtask(-nprocs,1)
      call lr_12prod_q(dbl_mb(k_left),d_ii1_1,d_ii1_3,d_t1,
     &   d_t2,k_ii1_offset_1,k_ii1_offset_3,k_t1_offset,
     &   k_t2_offset,l_ii1_offset_1,l_ii1_offset_3,
     &   t_h1b,t_h2b,t_h3b,t_h4b,t_p5b,t_p6b,t_p7b,t_p8b
     &   ,3)
      call ccsd2_q_right(dbl_mb(k_right),d_i1_1,d_i1_2,
     1  d_t1,d_t2,d_v2,k_i1_offset_1,k_i1_offset_2,
     2  k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3  l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_h4b,
     4  t_p5b,t_p6b,t_p7b,t_p8b,3)
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,energy,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,energy,1)
      if (.not.ga_destroy(g_energy))
     1  call errquit('ccsd_q: GA problem',1,GA_ERR)
c
      if (.not.ma_pop_stack(l_2hole))
     1  call errquit("tce_energy: MA problem",19,MA_ERR)
      if (.not.ma_pop_stack(l_hole))
     1  call errquit("tce_energy: MA problem",19,MA_ERR)
c
      return
      end
c
c
c
c
c  PRODUCT 1/2T2*T2
c
c
c
      SUBROUTINE lr_t2_t2(a_i0,d_t2,k_t2_offset,t_h1b,t_h2b,t_h3b,t_h4b,
     &t_p5b,t_p6b,t_p7b,t_p8b,toggle)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_tt + = 1/2 * P( 36 ) * t ( p5 p6 h1 h2 )_t * t ( p7 p8 h3 h4 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER toggle
      INTEGER d_t2
      INTEGER k_t2_offset
      DOUBLE PRECISION a_i0(*)
      IF (toggle .eq. 2) CALL lr_t2_t2_1(d_t2,k_t2_offset,d_t2,k_t2_offs
     &et,a_i0,t_p5b,t_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
      RETURN
      END
      SUBROUTINE lr_t2_t2_1(d_a,k_a_offset,d_b,k_b_offset,a_c,t_p5b,t_p6
     &b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_tt + = 1/2 * P( 36 ) * t ( p5 p6 h1 h2 )_t * t ( p7 p8 h3 h4 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER p8b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = noab+1,noab+nvab
      DO p8b = p7b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      skipped = .true.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+h1b-1)+i
     &nt_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.1
     &6)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-
     &1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1)
     &))))))) .eq. ieor(irrep_t,irrep_t)) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lr_t2_t2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h1b,h2b,p5b_1,p6b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(p7b,p8b,h3b,h4b,p7b_2,p8b_2,h3b_2,h4b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1) * int_mb
     &(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lr_t2_t2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lr_t2_t2_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lr_t2_t2_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lr_t2_t2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lr_t2_t2_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h4b_2
     & - 1 + noab * (h3b_2 - 1 + noab * (p8b_2 - noab - 1 + nvab * (p7b_
     &2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lr_t2_t2_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lr_t2_t2_1',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lr_t2_t2_1',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,6,5,2,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,2,6,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,2,6,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,6,2,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,6,2,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,2,1,6,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,6,5,2,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,2,6,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,2,6,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,6,2,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,6,2,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,2,1,6,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lr_t2_t2_1',9,MA_ER
     &R)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
c
c
c
c
c ALL PRODUCTS 1/2T2*T2+1/2T1*T1*T2+1/24T1*T1*T1*T1
c
c
c
      SUBROUTINE lr_12prod_q(a_i0,d_i1_1,d_i1_2,d_t1,d_t2,k_i1_offset_1,
     &k_i1_offset_2,k_t1_offset,k_t2_offset,l_i1_offset_1,l_i1_offset_2,
     &t_h1b,t_h2b,t_h3b,t_h4b,t_p5b,t_p6b,t_p7b,t_p8b,toggle)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_tt + = 1/2 * P( 36 ) * t ( p5 p6 h1 h2 )_t * i1 ( p7 p8 h3 h4 )_t
C         i1 ( p5 p6 h1 h2 )_t + = 1 * t ( p5 p6 h1 h2 )_t
C         i1 ( p5 p6 h1 h2 )_tt + = 1 * P( 4 ) * t ( p5 h1 )_t * t ( p6 h2 )_t
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_tttt + = -3/2 * P( 16 ) * t ( p5 h1 )_t * i1 ( p6 p7 p8 h2 h3 h4 )_ttt
C         i1 ( p5 p6 p7 h1 h2 h3 )_ttt + = 1/9 * P( 9 ) * t ( p5 h1 )_t * i2 ( p6 p7 h2 h3 )_tt
C             i2 ( p5 p6 h1 h2 )_tt + = -1/4 * P( 4 ) * t ( p5 h1 )_t * t ( p6 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER toggle
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_i1_1
      INTEGER k_i1_offset_1
      INTEGER l_i1_offset_1
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1_2
      INTEGER k_i1_offset_2
      INTEGER l_i1_offset_2
      INTEGER size_i1_1
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER size_i1_2
      INTEGER l_i2_offset
      INTEGER size_i2
      DOUBLE PRECISION a_i0(*)
      CHARACTER*255 filename
      IF (toggle .eq. 3) THEN
      CALL DELETEFILE(d_i1_2)
      IF (.not.MA_POP_STACK(l_i1_offset_2)) CALL ERRQUIT('lr_12prod_q',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 3) THEN
      CALL DELETEFILE(d_i1_1)
      IF (.not.MA_POP_STACK(l_i1_offset_1)) CALL ERRQUIT('lr_12prod_q',-
     &1,MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL OFFSET_lr_12prod_q_1_1(l_i1_offset_1,k_i1_
     &offset_1,size_i1_1)
      IF (toggle .eq. 1) CALL TCE_FILENAME('lr_12prod_q_1_1_i1',filename
     &)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i1_1,size_i1_1)
      IF (toggle .eq. 1) CALL lr_12prod_q_1_1(d_t2,k_t2_offset,d_i1_1,k_
     &i1_offset_1)
      IF (toggle .eq. 1) CALL lr_12prod_q_1_2(d_t1,k_t1_offset,d_t1,k_t1
     &_offset,d_i1_1,k_i1_offset_1)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i1_1,size_i1_1)
      IF (toggle .eq. 2) CALL lr_12prod_q_1(d_t2,k_t2_offset,d_i1_1,k_i1
     &_offset_1,a_i0,t_p5b,t_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
      IF (toggle .eq. 1) CALL OFFSET_lr_12prod_q_2_1(l_i1_offset_2,k_i1_
     &offset_2,size_i1_2)
      IF (toggle .eq. 1) CALL TCE_FILENAME('lr_12prod_q_2_1_i1',filename
     &)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i1_2,size_i1_2)
      IF (toggle .eq. 1) CALL OFFSET_lr_12prod_q_2_1_1(l_i2_offset,k_i2_
     &offset,size_i2)
      IF (toggle .eq. 1) CALL TCE_FILENAME('lr_12prod_q_2_1_1_i2',filena
     &me)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i2,size_i2)
      IF (toggle .eq. 1) CALL lr_12prod_q_2_1_1(d_t1,k_t1_offset,d_t1,k_
     &t1_offset,d_i2,k_i2_offset)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i2,size_i2)
      IF (toggle .eq. 1) CALL lr_12prod_q_2_1(d_t1,k_t1_offset,d_i2,k_i2
     &_offset,d_i1_2,k_i1_offset_2)
      IF (toggle .eq. 1) THEN
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('lr_12prod_q',-1,
     &MA_ERR)
      END IF
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i1_2,size_i1_2)
      IF (toggle .eq. 2) CALL lr_12prod_q_2(d_t1,k_t1_offset,d_i1_2,k_i1
     &_offset_2,a_i0,t_p5b,t_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
      RETURN
      END
      SUBROUTINE lr_12prod_q_1(d_a,k_a_offset,d_b,k_b_offset,a_c,t_p5b,t
     &_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_tt + = 1/2 * P( 36 ) * t ( p5 p6 h1 h2 )_t * i1 ( p7 p8 h3 h4 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER p8b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = noab+1,noab+nvab
      DO p8b = p7b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      skipped = .true.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) skipped = .fals
     &e.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+h1b-1)+i
     &nt_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.1
     &6)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-
     &1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1)
     &))))))) .eq. ieor(irrep_t,irrep_t)) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lr_12prod_q_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h1b,h2b,p5b_1,p6b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_4(p7b,p8b,h3b,h4b,p7b_2,p8b_2,h3b_2,h4b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1) * int_mb
     &(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lr_12prod_q_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lr_12prod_q_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lr_12prod_q_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lr_12prod_q_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lr_12prod_q_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h4b_2
     & - 1 + noab * (h3b_2 - 1 + noab * (p8b_2 - noab - 1 + nvab * (p7b_
     &2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lr_12prod_q_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lr_12prod_q_1',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lr_12prod_q_1',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,7,4,3,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,7,3,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,6,5,2,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,2,6,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,2,6,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,6,2,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,6,2,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,8,3,7,2,1,6,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,6,5,2,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,2,6,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,2,6,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,6,2,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,6,2,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p6b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,7,3,2,1,6,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),8,4,3,7,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,6,5,2,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,2,6,5,1,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,2,6,1,5,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h2b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,6,2,5,1,-1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,6,2,1,5,1.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p7b) .and. (t_p6b .eq. p8b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p6b) .and. (t_h1b .eq. h3b) .and. (t_h2b .eq. h
     &4b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h2b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+p8b-1),int_mb(k_range+p7b-1),int_
     &mb(k_range+h2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_
     &mb(k_range+p5b-1),4,3,8,7,2,1,6,5,1.0d0/2.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lr_12prod_q_1',9,MA
     &_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE lr_12prod_q_1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 h1 h2 )_t + = 1 * t ( p5 p6 h1 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      CALL TCE_RESTRICTED_4(p5b,p6b,h1b,h2b,p5b_1,p6b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lr_12prod_q_1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lr_12prod_q_1_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lr_12prod_q_1_1',2,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &lr_12prod_q_1_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p6b - noab - 1 + nvab * (p5b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('lr_12prod_q_1_1',4,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lr_12prod_q_1_1',5,
     &MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_lr_12prod_q_1_1(l_a_offset,k_a_offset,size)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 h1 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('lr_12prod_q_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h2b - 1 + noab * (h1b - 1 + noab * (p6b 
     &- noab - 1 + nvab * (p5b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE lr_12prod_q_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 h1 h2 )_tt + = 1 * P( 4 ) * t ( p5 h1 )_t * t ( p6 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER p6b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lr_12prod_q_1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h1b,p5b_1,h1b_1)
      CALL TCE_RESTRICTED_2(p6b,h2b,p6b_2,h2b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lr_12prod_q_1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lr_12prod_q_1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lr_12prod_q_1_2',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lr_12prod_q_1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lr_12prod_q_1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (p6b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lr_12prod_q_1_2',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lr_12prod_q_1_2',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lr_12prod_q_1_2',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &lr_12prod_q_1_2',9,MA_ERR)
      IF ((p5b .le. p6b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,4,2,3,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p6b - noab - 1 + nvab * (p5b - noab
     & - 1)))))
      END IF
      IF ((p5b .le. p6b) .and. (h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,4,2,1,3,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p6b - noab - 1 + nvab * (p5b - noab
     & - 1)))))
      END IF
      IF ((p6b .le. p5b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p5b - noab - 1 + nvab * (p6b - noab
     & - 1)))))
      END IF
      IF ((p6b .le. p5b) .and. (h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,2,4,1,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p5b - noab - 1 + nvab * (p6b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('lr_12prod_q_1_2',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lr_12prod_q_1_2',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE lr_12prod_q_2(d_a,k_a_offset,d_b,k_b_offset,a_c,t_p5b,t
     &_p6b,t_p7b,t_p8b,t_h1b,t_h2b,t_h3b,t_h4b)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p5 p6 p7 p8 h1 h2 h3 h4 )_tttt + = -3/2 * P( 16 ) * t ( p5 h1 )_t * i1 ( p6 p7 p8 h2 h3 h4 )_ttt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_p7b
      INTEGER t_p8b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER t_h4b
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER p8b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO p7b = p6b,noab+nvab
      DO p8b = p7b,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      DO h3b = h2b,noab
      DO h4b = h3b,noab
      skipped = .true.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) skipped = .fals
     &e.
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) skipped = .fals
     &e.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+h1b-1)+i
     &nt_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.1
     &6)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-
     &1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1)
     &))))))) .eq. ieor(irrep_t,ieor(irrep_t,ieor(irrep_t,irrep_t)))) TH
     &EN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+p8b-1) * int_mb(k_range+h1b-1) * int_m
     &b(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lr_12prod_q_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h1b,p5b_1,h1b_1)
      CALL TCE_RESTRICTED_6(p6b,p7b,p8b,h2b,h3b,h4b,p6b_2,p7b_2,p8b_2,h2
     &b_2,h3b_2,h4b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+p7b-1) * int_mb
     &(k_range+p8b-1) * int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * 
     &int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lr_12prod_q_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lr_12prod_q_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lr_12prod_q_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lr_12prod_q_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lr_12prod_q_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h4b_2
     & - 1 + noab * (h3b_2 - 1 + noab * (h2b_2 - 1 + noab * (p8b_2 - noa
     &b - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p8b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h4b-1),6,5,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lr_12prod_q_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lr_12prod_q_2',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lr_12prod_q_2',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,6,5,4,7,3,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,6,5,4,3,7,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,6,5,4,3,2,7,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p5b) .and. (t_p6b .eq. p6b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),8,6,5,4,3,2,1,7,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,8,5,4,7,3,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,8,5,4,3,7,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,8,5,4,3,2,7,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p5b) .and. (t_p7b .eq. p7b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,8,5,4,3,2,1,7,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,8,4,7,3,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,8,4,3,7,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,8,4,3,2,7,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p5b)
     & .and. (t_p8b .eq. p8b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,8,4,3,2,1,7,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h
     &2b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,4,8,7,3,2,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &1b) .and. (t_h3b .eq. h3b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,4,8,3,7,2,1,-3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h1b) .and. (t_h4b .eq. h4b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,4,8,3,2,7,1,3.0d0/2.0d0)
      END IF
      IF ((t_p5b .eq. p6b) .and. (t_p6b .eq. p7b) .and. (t_p7b .eq. p8b)
     & .and. (t_p8b .eq. p5b) .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h
     &3b) .and. (t_h3b .eq. h4b) .and. (t_h4b .eq. h1b)) THEN
      CALL TCE_SORTACC_8(dbl_mb(k_c_sort),a_c,int_mb(k_range+h4b-1),int_
     &mb(k_range+h3b-1),int_mb(k_range+h2b-1),int_mb(k_range+p8b-1),int_
     &mb(k_range+p7b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_
     &mb(k_range+p5b-1),6,5,4,8,3,2,1,7,-3.0d0/2.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lr_12prod_q_2',9,MA
     &_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE lr_12prod_q_2_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_o
     &ffset)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 p7 h1 h2 h3 )_ttt + = 1/9 * P( 9 ) * t ( p5 h1 )_t * i2 ( p6 p7 h2 h3 )_tt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      DO h3b = h2b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_t,ieor(irrep_t,irrep_t))) TH
     &EN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lr_12prod_q_2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h1b,p5b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p6b,p7b,h2b,h3b,p6b_2,p7b_2,h2b_2,h3b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+p7b-1) * int_mb
     &(k_range+h2b-1) * int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lr_12prod_q_2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lr_12prod_q_2_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lr_12prod_q_2_1',3,MA_ER
     &R)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lr_12prod_q_2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lr_12prod_q_2_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h3b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (p7b_2 - noab - 1 + nvab * (p6b_
     &2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lr_12prod_q_2_1',6,MA_ER
     &R)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lr_12prod_q_2_1',7,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lr_12prod_q_2_1',8,
     &MA_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &lr_12prod_q_2_1',9,MA_ERR)
      IF ((p5b .le. p6b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),6,4,3,5,2,1,1.0d0/9.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (p7b - noab - 1 + 
     &nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p5b .le. p6b) .and. (h2b .le. h1b) .and. (h1b .le. h3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),6,4,3,2,5,1,-1.0d0/9.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * (p7b - noab - 1 + 
     &nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p5b .le. p6b) .and. (h3b .le. h1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),6,4,3,2,1,5,1.0d0/9.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (p7b - noab - 1 + 
     &nvab * (p6b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),4,6,3,5,2,1,-1.0d0/9.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (p7b - noab - 1 + 
     &nvab * (p5b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h2b .le. h1b) .and.
     & (h1b .le. h3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),4,6,3,2,5,1,1.0d0/9.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * (p7b - noab - 1 + 
     &nvab * (p5b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h3b .le. h1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),4,6,3,2,1,5,-1.0d0/9.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (p7b - noab - 1 + 
     &nvab * (p5b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p7b .le. p5b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),4,3,6,5,2,1,1.0d0/9.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (p5b - noab - 1 + 
     &nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p7b .le. p5b) .and. (h2b .le. h1b) .and. (h1b .le. h3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),4,3,6,2,5,1,-1.0d0/9.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h1b - 1 + noab * (h2b - 1 + noab * (p5b - noab - 1 + 
     &nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF ((p7b .le. p5b) .and. (h3b .le. h1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p7b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p5b-1),4,3,6,2,1,5,1.0d0/9.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (p5b - noab - 1 + 
     &nvab * (p7b - noab - 1 + nvab * (p6b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('lr_12prod_q_2_1',10,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lr_12prod_q_2_1',11
     &,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_lr_12prod_q_2_1(l_a_offset,k_a_offset,size)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p5 p6 p7 h1 h2 h3 )_ttt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_t,ieor(irrep_t,irrep_t))) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('lr_12prod_q_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_t,ieor(irrep_t,irrep_t))) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h3b - 1 + noab * (h2b - 1 + noab * (h1b 
     &- 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p5
     &b - noab - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_
     &mb(k_range+p7b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) 
     &* int_mb(k_range+h3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE lr_12prod_q_2_1_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p5 p6 h1 h2 )_tt + = -1/4 * P( 4 ) * t ( p5 h1 )_t * t ( p6 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b_1
      INTEGER h1b_1
      INTEGER p6b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lr_12prod_q_2_1_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h1b,p5b_1,h1b_1)
      CALL TCE_RESTRICTED_2(p6b,h2b,p6b_2,h2b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lr_12prod_q_2_1_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lr_12prod_q_2_1_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lr_12prod_q_2_1_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lr_12prod_q_2_1_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lr_12prod_q_2_1_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (p6b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lr_12prod_q_2_1_1',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lr_12prod_q_2_1_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lr_12prod_q_2_1_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &lr_12prod_q_2_1_1',9,MA_ERR)
      IF ((p5b .le. p6b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,4,2,3,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p6b - noab - 1 + nvab * (p5b - noab
     & - 1)))))
      END IF
      IF ((p5b .le. p6b) .and. (h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,4,2,1,3,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p6b - noab - 1 + nvab * (p5b - noab
     & - 1)))))
      END IF
      IF ((p6b .le. p5b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,2,4,3,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p5b - noab - 1 + nvab * (p6b - noab
     & - 1)))))
      END IF
      IF ((p6b .le. p5b) .and. (h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+p5b-1)
     &,2,4,1,3,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p5b - noab - 1 + nvab * (p6b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('lr_12prod_q_2_1_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lr_12prod_q_2_1_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_lr_12prod_q_2_1_1(l_a_offset,k_a_offset,size)
C     $Id: lr_ccsd_tq.F 19821 2010-12-14 07:46:49Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p5 p6 h1 h2 )_tt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('lr_12prod_q_2_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h2b - 1 + noab * (h1b - 1 + noab * (p6b 
     &- noab - 1 + nvab * (p5b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

c
c $Id: hnd_dipxyz.F 19696 2010-10-29 16:53:42Z d3y133 $
c
      subroutine hnd_dipxyz
      implicit none
c
c     ----- gauss-hermite quadrature using minimum point formula -----
c
#include "hnd_whermt.fh"
c
      common/hnd_xyzdip/xint,yint,zint,xxint,yyint,zzint,t,x0,y0,z0,
     1                  xi,yi,zi,xj,yj,zj,ni,nj,cx,cy,cz
      double precision xint, yint, zint, t, x0, y0, z0, xi, yi, zi
      double precision xxint, yyint, zzint
      double precision xj, yj, zj, zero, dum, px, py, pz
      double precision cx, cy, cz
      double precision ptx, pty, ptz, ax, ay, az, bx, by, bz
      integer ni, nj, npts, imin, imax, i, ii, jj
      data zero /0.0d+00/
c
      xint=zero
      yint=zero
      zint=zero
      npts=(ni+nj-2+1)/2+1
      imin=hermin(npts)
      imax=hermax(npts)
      do 16 i=imin,imax
         dum=w(i)
         px=dum
         py=dum
         pz=dum
         dum=h(i)/t
         ptx=dum+x0
         pty=dum+y0
         ptz=dum+z0
         ax=ptx-xi
         ay=pty-yi
         az=ptz-zi
         bx=ptx-xj
         by=pty-yj
         bz=ptz-zj
         do ii = 1, ni-1
            px=px*ax
            py=py*ay
            pz=pz*az
         enddo
         do jj = 1, nj-1
            px=px*bx
            py=py*by
            pz=pz*bz
         enddo
         xint=xint+px
         yint=yint+py
         zint=zint+pz
   16 continue
      return
      end

      subroutine argos_space_nbaccfbl(ibbl,lhandl,fw,fs,lpair,iwz,isz)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
c
      integer ibbl,lhandl
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      logical lpair
      integer iwz(mwm),isz(msa)
c
      call argos_space_nbacfbl(ibbl,lhandl,fw,fs,int_mb(i_bb),
     + int_mb(i_jpl),lpair,iwz,isz)
c
      return
      end
c $Id: argos_space_nbaccfbl.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine sym_irrepname(geom,irrep,name)
c
c $Id: sym_irrepname.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c Returns the name of irrep.  If irrep is zero, returns
c '?' as the name.
c
      implicit none
#include "geom.fh"
#include "sym.fh"
      integer geom       ! [input] Geometry handle
      integer irrep      ! [input] Irrep number
      character*(*) name ! [output] name of the irrep
      character*8 zname  ! name of symmetry group
      integer maxop
      integer maxireps
      parameter (maxop=120)
      parameter (maxireps=20)
      integer nop
      integer nir
      integer class_dim(maxireps)
      character*8 zir(maxireps)
      character*8 zclass(maxireps)
      double precision chars(maxireps*maxireps)
c
      call sym_group_name(geom,zname)
      if (.not.sym_char_table(zname,nop,nir,class_dim,
     1  zir,zclass,chars)) call errquit
     2  ('sym_irrepname: failed to get character table',0,0)
      if (irrep.eq.0) then
        name='?'
      else
        name=zir(irrep)
      endif
      return
      end

C$Id: ecp_3j_prod.f 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_3j_prod (l1,l2,l3,m1,m2,result)
*                                                                      *
*   Calculate product of 3j symbols which appears in the angular       * 
*   integral over three spherical tensors. Product is                  *
*   (l1 l2 l3 / m1 m2 m3) (l1 l2 l3 / 0 0 0).                          *
*                                                                      *
*   l1,l2,l3 - l values                                                *
*   m1,m2 - m values; m3 = -(m1+m2)                                    *
*   result - value of product of 3j symbols                            *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
      integer l1,l2,l3,m1,m2,m3
      integer l_min,l_mid,l_max,m_min,m_mid,m_max,
     &    ll,ll_min,ll_mid,ll_max,l_sum
      integer i,j,k,l,m,n,phase
      double precision result,wa,wb
*
      result = 0.0d00
      m3 = -(m1+m2)
      if (abs(m1) .gt. l1) return
      if (abs(m2) .gt. l2) return
      if (abs(m3) .gt. l3) return
*
*   Order angular momenta by size.
*
      if (l2 .gt. l1) then
        l_max = l2
        m_max = m2
        l_min = l1
        m_min = m1
      else
        l_max = l1
        m_max = m1
        l_min = l2
        m_min = m2
      end if
      if (l3 .gt. l_max) then
        l_mid = l_max
        m_mid = m_max
        l_max = l3
        m_max = m3
      else if (l3. lt. l_min) then
        l_mid = l_min
        m_mid = m_min
        l_min = l3
        m_min = m3
      else
        l_mid = l3
        m_mid = m3
      end if
      phase = (abs(m1)+abs(m2)+abs(m3))/2
      if (m_min .lt. 0) then
        m_min = -m_min
        m_mid = -m_mid
        m_max = -m_max
      end if
*
*   Special code for l_min = 0
*
      if (l_min .eq. 0) then
        wb = 1
        wa = 2*l_max+1
        result = wb/wa
*
*   Special code for l_min = 1
*
      else if (l_min .eq. 1) then
        wa = (2*l_max+1)*(2*l_max-1)
        if (m_min .eq. 0) then
          wb = (l_max+m_mid)*(l_max-m_mid)
        else
          wb = (l_max+m_mid)*(l_max+m_mid+1)/2
        end if
        result = sqrt(wb)/wa
*
*   General code for l_min > 1
*
      else
*
*     (a+b-c-1)!!(b+c-a-1)!!(c+a-b-1)!!/(a+b+c+1)!!
*
        l_sum = l1+l2+l3
        ll_max = 2*l_max
        ll_min = 2*l_min
        ll_mid = 2*l_mid
        m = 1
        do l = l_sum-ll_min+1,l_sum+1,2
          m = m*l
        end do
        wa = m
        m = 1
        do l = 3,l_sum-ll_mid-1,2
          m = m*l
        end do
        do l = 3,l_sum-ll_max-1,2
          m = m*l
        end do
        wb = m
        result = wb/wa
*
*     [(c+gamma)!(c-gamma)!/(a+alpha)!(a-alpha)!(b+beta)!(b-beta)!]^1/2
*
        m = 1
        n = 1
        ll_max = l_max+abs(m_max)
        ll_mid = l_mid+abs(m_mid)
        if (ll_max .ge. ll_mid) then
          do i = ll_mid+1,ll_max
            m = m*i
          end do
        else
          do i = ll_max+1,ll_mid
            n = n*i
          end do
        end if
        ll_max = l_max-abs(m_max)
        ll_mid = l_mid-abs(m_mid)
        if (ll_max .ge. ll_mid) then
          do i = ll_mid+1,ll_max
            m = m*i
          end do
        else
          do i = ll_max+1,ll_mid
            n = n*i
          end do
        end if
        do i = 1,l_min-m_min
          n = n*i
        end do
        do i = 1,l_min+m_min
          n = n*i
        end do
        wa = m
        wb = n
        result = result*sqrt(wa/wb)
*
*     Remaining factor
*
        ll = l_min+l_mid-l_max
        if (ll .gt. 0) then
          i = l_min+m_min
          j = l_min-m_min
          m = l_mid+m_mid
          n = l_mid-m_mid
          ll_min = max(0,ll-i,ll-n)
          ll_max = min(ll,j,m)
          k = 1
          do l = 1,ll_min
            k = -k*j*m/l
            j = j-1
            m = m-1
          end do
          do l = 1,ll-ll_min
            k = k*i*n/l
            i = i-1
            n = n-1
          end do
          l_sum = k
          do l = ll_min+1,ll_max
            i = i+1
            n = n+1
            k = -k*j*m*(ll-l+1)/(i*n*l)
            j = j-1
            m = m-1
            l_sum = l_sum+k
          end do
          wa = l_sum
          result = result*wa
        end if
	phase = phase+ll/2
      end if
*
      if (mod(abs(phase+m_max),2) .eq. 1) result = -result
*
      return
      end

c $Id: intd_1eso.F 23273 2012-12-12 19:11:17Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Calculate derivative 1-electron spin-orbit potential integrals
C>
c:tex-% this is part of the API Standard Integral routines.
c:tex-\subsection{intd\_1eso}
c:tex-This routine computes the derivative 1 electron spin orbit 
c:tex-potential integrals,
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine intd_1eso(i_basis,ish,j_basis,jsh,lscr,scr,lso,SO)
c:tex-\end{verbatim}
      implicit none
#include "stdio.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
c::external subroutines used
c errquit
c::functions
      logical cando_nw_1e
      logical cando_nw
      logical int_chk_init
      logical int_chk_sh
      integer int_nint_cart
      external int_nint_cart
      external int_chk_init
      external int_chk_sh
      external cando_nw_1e
      external cando_nw
c::passed
c:tex-\begin{verbatim}
      integer i_basis !< [Input] basis set handle for ish
      integer ish     !< [Input] i shell/contraction
      integer j_basis !< [Input] basis set handle for jsh
      integer jsh     !< [Input] j shell/contraction
      integer lscr    !< [Input] length of scratch array
      double precision scr(lscr) !< [Scratch] scratch array
      integer lso                !< [Input] length of SO buffer
      double precision SO(lso)   !< [Output] spin orbit potential 
                                 !< integral buffer
c:tex-\end{verbatim}
c::local
      logical shells_ok
      integer nint, nat
      integer i_geom, j_geom, ibas, jbas, ucont
      integer Li, i_prim, i_gen, i_iexp, i_icfp, i_cent
      integer Lj, j_prim, j_gen, j_iexp, j_icfp, j_cent
c
      logical any_spherical
c
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c check initialization, shells, and buffer length
c
      if (.not.int_chk_init('intd_1eso'))
     &       call errquit('intd_1eso: int_init was not called' ,0,
     &          INT_ERR)
c
      shells_ok = int_chk_sh(i_basis,ish)
      shells_ok = shells_ok .and. int_chk_sh(j_basis,jsh)
      if (.not.shells_ok)
     &       call errquit('intd_1eso: invalid contraction/shell',0,
     &          INT_ERR)
c
      nat = ncenter(ibs_geom((i_basis + Basis_Handle_Offset)))
      nint = int_nint_cart(i_basis,ish,j_basis,jsh,0,0,0,0)
      if (nint*3*2.gt.lso) then
        write(luout,*) 'nint*3*2 = ',nint*3*2
        write(luout,*) 'lso      = ',lso
        call errquit('intd_1eso: nint>lso error',911, INT_ERR)
      endif
c
      call int_nospshell_check(i_basis,'intd_1eso:i_basis')
      call int_nospshell_check(j_basis,'intd_1eso:j_basis')
*
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
c
      ucont   = (sf_ibs_cn2ucn(ish,ibas))
      Li      = infbs_cont(CONT_TYPE ,ucont,ibas)
      i_prim  = infbs_cont(CONT_NPRIM,ucont,ibas)
      i_gen   = infbs_cont(CONT_NGEN ,ucont,ibas)
      i_iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      i_icfp  = infbs_cont(CONT_ICFP ,ucont,ibas)
      i_cent  = (sf_ibs_cn2ce(ish,ibas))
      i_geom  = ibs_geom(ibas)
c
      ucont   = (sf_ibs_cn2ucn(jsh,jbas))
      Lj      = infbs_cont(CONT_TYPE ,ucont,jbas)
      j_prim  = infbs_cont(CONT_NPRIM,ucont,jbas)
      j_gen   = infbs_cont(CONT_NGEN ,ucont,jbas)
      j_iexp  = infbs_cont(CONT_IEXP ,ucont,jbas)
      j_icfp  = infbs_cont(CONT_ICFP ,ucont,jbas)
      j_cent  = (sf_ibs_cn2ce(jsh,jbas))
      j_geom  = ibs_geom(jbas)
c
      if (i_geom.ne.j_geom.and.WarnP.eq.0) then
        write(luout,*)
     &      'intd_1eso: WARNING: possible geometry inconsistency'
        write(luout,*)'i_basis geometry handle:',i_geom
        write(luout,*)'j_basis geometry handle:',j_geom
        WarnP = 1
      endif
c
      if (cando_nw_1e(i_basis,ish,0).and.cando_nw_1e(j_basis,jsh,0))
     &    then
        call intd_so_hf1(
     &         coords(1,i_cent,i_geom),dbl_mb(mb_exndcf(i_iexp,ibas)),
     &         dbl_mb(mb_exndcf(i_icfp,ibas)),
     &         i_prim, i_gen, Li, i_cent,
     &         coords(1,j_cent,j_geom),dbl_mb(mb_exndcf(j_iexp,jbas)),
     &         dbl_mb(mb_exndcf(j_icfp,jbas)),
     &         j_prim, j_gen, Lj, j_cent,
     &         SO, nint, nat,scr,lscr,.false.) ! false>dryrun
      else
        call errquit('intd_1eso: could not do nw integrals',0,
     &              INT_ERR)
      endif
c
*     SO now has the cartesian integral block  (jlo:jhi,ilo:ihi,3,3,nat)
*      
      any_spherical = bas_spherical(ibas).or.bas_spherical(jbas)
      if (.not.any_spherical) return
c
c ... reset general contractions for sp shells to 1 since they are handled
c     as a block of 4.
c
      if (li.eq.-1) i_gen = 1
      if (lj.eq.-1) j_gen = 1
      call spcart_2cBtran(SO,scr,lscr,
     &    int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &    int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &    3*3*nat,.false.)
c
      end
C> @}

*
* $Id: wvfnc_expander_input.F 19707 2010-10-29 17:59:36Z d3y133 $
*

      subroutine wvfnc_expander_input(rtdb)
      implicit none
#include "errquit.fh"
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
c
c
      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 7)
      integer NMAX              ! maximum wavfunctions
      parameter (NMAX = 100)
 
      character*30 dirs(num_dirs)
      character*255 test

      character*50 new_wavefunction_filename
      character*50 old_wavefunction_filename
      integer ngrid(3)
      data dirs / 'old_wavefunction_filename:',
     >            'new_wavefunction_filename:',
     >            'new_ngrid:',
     >            'old_wavefunction_filename',
     >            'new_wavefunction_filename',
     >            'new_ngrid',
     >            'end'/



*     ***** initializations ****
      old_wavefunction_filename = ' '
      new_wavefunction_filename = ' '
      call util_file_prefix('movecs',old_wavefunction_filename)
      call util_file_prefix('movecs',new_wavefunction_filename)
      ngrid(1) = 0
      ngrid(2) = 0
      ngrid(3) = 0

 10   if (.not. inp_read()) 
     >     call errquit(
     >           'wvfnc_expander_input: inp_read failed', 0, INPUT_ERR)
      if (.not. inp_a(test))
     >     call errquit(
     >      'wvfnc_expander_input: failed to read keyword', 0,
     &       INPUT_ERR)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit(
     >           'wvfnc_expander_input: unknown directive', 0,
     &       INPUT_ERR)


      goto ( 100,  200, 300, 100, 200, 300,
     >      9999) ind
      call errquit(
     >   'wvfnc_expander_input: unimplemented directive', ind,
     &       INPUT_ERR)



c
c old_wavefunction_filename
c
 100  if (.not. inp_a(old_wavefunction_filename))
     >     call errquit(
     >      'wvfnc_expander_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c new_wavefunction_filename
c
 200  if (.not. inp_a(new_wavefunction_filename))
     >     call errquit(
     >      'wvfnc_expander_input: failed to read ', 0, INPUT_ERR)
      goto 10

 300  if (.not. inp_i(ngrid(1)))
     >     call errquit(
     >      'wvfnc_expander_input: failed to read ', 0, INPUT_ERR)
      if (.not. inp_i(ngrid(2)))
     >     call errquit(
     >      'wvfnc_expander_input: failed to read ', 0, INPUT_ERR)
      if (.not. inp_i(ngrid(3)))
     >     call errquit(
     >      'wvfnc_expander_input: failed to read ', 0, INPUT_ERR)
      goto 10
 

*     ***** add wavefunction to rtdb ****
 9999 continue
      if (old_wavefunction_filename.eq.' ') 
     >  call errquit(
     >    'wvfnc_expander_input: nead a old_wavefunction_filename', 0,
     &       INPUT_ERR)
      if (new_wavefunction_filename.eq.' ') 
     >  call errquit(
     >  'wvfnc_expander_input: nead a new_wavefunction_filename', 0,
     &       INPUT_ERR)



      ind = index(old_wavefunction_filename,' ') - 1
      if (.not. rtdb_cput(rtdb,'xpndr:old_wavefunction_filename',
     >                    1,old_wavefunction_filename(1:ind)))
     >     call errquit(
     >     'wvfnc_expander_input: rtdb_cput failed', 0, RTDB_ERR)


      ind = index(new_wavefunction_filename,' ') - 1
      if (.not. rtdb_cput(rtdb,'xpndr:new_wavefunction_filename',
     >                    1,new_wavefunction_filename(1:ind)))
     >     call errquit(
     >     'wvfnc_expander_input: rtdb_cput failed', 0, RTDB_ERR)

      if (.not. rtdb_put(rtdb,'xpndr:ngrid',mt_int,3,ngrid))
     >     call errquit(
     >     'wvfnc_expander_input: rtdb_put failed', 0, RTDB_ERR)
     

      return
      end

*
* $Id: wvfnc_init_input.F 20399 2011-06-01 23:01:10Z bylaska $
*


      subroutine wvfnc_init_input(rtdb)
      implicit none
#include "errquit.fh"
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
c
c
      integer ind               ! Index of matched directive
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 17)
      integer NMAX              ! maximum wavfunctions
      parameter (NMAX = 501)
 
      character*22 dirs(num_dirs)
      character*255 test

      character*50 cell_name,wavefunction_filename
      integer   up_filling(4,NMAX),nup
      integer down_filling(4,NMAX),ndown
      logical restricted
      integer i
      data dirs / 'cell_name:',
     >            'wavefunction_filename:',
     >            'restricted',
     >            'unrestricted',
     >            'up_filling:',
     >            'down_filling:',
     >            'up_electrons:',
     >            'down_electrons:',
     >            'restricted_electrons:',
     >            'cell_name',
     >            'wavefunction_filename',
     >            'up_filling',
     >            'down_filling',
     >            'up_electrons',
     >            'down_electrons',
     >            'restricted_electrons',
     >            'end'/



*     ***** initializations ****
      cell_name             = 'cell_default'

      call util_file_prefix('movecs',wavefunction_filename)
c     wavefunction_filename = ' '

      restricted            = .true.
      nup                   = 0
      ndown                 = 0

 10   if (.not. inp_read()) 
     >     call errquit(
     >           'wvfnc_init_input: inp_read failed', 0, INPUT_ERR)
      if (.not. inp_a(test))
     >     call errquit(
     >           'wvfnc_init_input: failed to read keyword', 0,
     &       INPUT_ERR)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit(
     >           'wvfnc_init_input: unknown directive', 0, INPUT_ERR)


      goto ( 100,  200, 300, 400, 500,600,700,800,900,
     >       100,  200,           500,600,700,800,900,
     >      9999) ind
      call errquit(
     >      'psp_formatter_input: unimplemented directive', ind,
     &       INPUT_ERR)


c     
c  cell_name
c     
 100  if (.not. inp_a(cell_name))
     >     call errquit(
     >          'wvfnc_init_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c wavefunction_filename
c
 200  if (.not. inp_a(wavefunction_filename))
     >     call errquit(
     >          'wvfnc_init_input: failed to read keyword', 0,
     &       INPUT_ERR)
      goto 10


c
c  restricted
c 
 300  restricted = .true.
      goto 10

c
c  unrestricted
c 
 400  restricted = .false.
      goto 10

c
c  up_filling
c 
 500  if (.not. inp_i(nup))
     >     call errquit(
     >          'wvfnc_init_input: failed to read nup', 0, INPUT_ERR)

      do i=1,nup
         if (.not. inp_read()) 
     >        call errquit(
     >           'wvfnc_init_input: inp_read failed', 0, INPUT_ERR)

           if (.not. inp_i(up_filling(1,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(up_filling) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(up_filling(2,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(up_filling) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(up_filling(3,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(up_filling) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(up_filling(4,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(up_filling) failed', 0,
     &       INPUT_ERR)
      end do
      goto 10
 
c
c  down_filling
c 
 600  if (.not. inp_i(ndown))
     >     call errquit(
     >          'wvfnc_init_input: failed to read ndown', 0, INPUT_ERR)

      do i=1,ndown
         if (.not. inp_read()) 
     >        call errquit(
     >           'wvfnc_init_input: inp_read failed', 0, INPUT_ERR)

           if (.not. inp_i(down_filling(1,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(down_filling) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(down_filling(2,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(down_filling) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(down_filling(3,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(down_filling) failed', 0,
     &       INPUT_ERR)

           if (.not. inp_i(down_filling(4,i)))
     >     call errquit(
     >          'wvfnc_init_input: inp_i(down_filling) failed', 0,
     &       INPUT_ERR)
      end do
      goto 10
 
c
c  up_electrons
c 
 700  if (.not. inp_i(nup))
     >     call errquit(
     >          'wvfnc_init_input: failed to read nup', 0, INPUT_ERR)
      call getfilling(.true.,nup,up_filling)
      goto 10
 
 
c
c  down_electrons
c 
 800  if (.not. inp_i(ndown))
     >     call errquit(
     >          'wvfnc_init_input: failed to read ndown', 0, INPUT_ERR)
      call getfilling(.true.,ndown,down_filling)
      goto 10
 
c
c  restricted_electrons
c 
 900  if (.not. inp_i(nup))
     >     call errquit(
     >          'wvfnc_init_input: failed to read nup', 0, INPUT_ERR)
      nup=nup/2
      call getfilling(.true.,nup,up_filling)
      goto 10


*     ***** add wavefunction to rtdb ****
 9999 continue
      if (cell_name.eq.' ') 
     >  call errquit('wvfnc_init_input: nead a cell_name', 0, INPUT_ERR)
      if (wavefunction_filename.eq.' ') 
     >  call errquit(
     >       'wvfnc_init_input: nead a wavefunction_filename', 0,
     &       INPUT_ERR)


      ind = index(cell_name,' ') - 1
      if (.not. rtdb_cput(rtdb,'wvfnc:cell_name',1,cell_name(1:ind)))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_cput failed', 0, RTDB_ERR)

      ind = index(wavefunction_filename,' ') - 1
      if (.not. rtdb_cput(rtdb,'wvfnc:wavefunction_filename',
     >                    1,wavefunction_filename(1:ind)))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_cput failed', 0, RTDB_ERR)


      if (.not. rtdb_put(rtdb,'wvfnc:nup',
     >                    mt_int,1,nup))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      if (.not. rtdb_put(rtdb,'wvfnc:ndown',
     >                    mt_int,1,ndown))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      if (.not. rtdb_put(rtdb,'wvfnc:up_filling',
     >                    mt_int,(4*nup+1),up_filling))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      if (.not. rtdb_put(rtdb,'wvfnc:down_filling',
     >                    mt_int,(4*ndown+1),down_filling))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      if (.not. rtdb_put(rtdb,'wvfnc:restricted',
     >                    mt_log,1,restricted))
     >     call errquit(
     >     'wvfnc_init_input: rtdb_put failed', 0, RTDB_ERR)

      return
      end

*
* $Id: ewald.F 24733 2013-10-29 19:00:37Z bylaska $
*
      integer function ewald_ncut()
      implicit none 
#include "ewald.fh"
      ewald_ncut = ncut
      return
      end 
ccccccccccccccccccccccccccccccccccccc
      integer function ewald_nida()
      implicit none 
#include "ewald.fh"
      ewald_nida = nida
      return
      end
ccccccccccccccccccccccccccccccccccccc
      integer function ewald_npack()
      implicit none 
#include "ewald.fh"
      ewald_npack = enpack
      return
      end 
ccccccccccccccccccccccccccccccccccccc
      real*8 function ewald_zv(i)
      implicit none
#include "mafdecls.fh"
#include "ewald.fh"
      integer i,ix
      ix=zv(1)+i-1
      ewald_zv=dbl_mb(ix)      
      return
      end
cccccccccccccccccccccccccccccccccccc
      real*8 function ewald_rcut()
      implicit none 
#include "ewald.fh"
      ewald_rcut = rcut
      return
      end 
ccccccccccccccccccccccccccccccccccccccccc
      integer function ewald_nshl3d()
      implicit none 
#include "ewald.fh"
      ewald_nshl3d = nshl3d
      return
      end 
ccccccccccccccccccccccccccccccccccccc
      integer function ewald_rcell_ptr()
      implicit none
#include "ewald.fh"
      ewald_rcell_ptr = rcell(1)
      return
      end
ccccccccccccccccccccccccccccccccccccc
      real*8 function ewald_mandelung()
      implicit none 
#include "ewald.fh"
      ewald_mandelung = alpha
      return
      end 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer function ewald_grid_nx()
      implicit none
#include "ewald.fh"
      ewald_grid_nx=enx
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer function ewald_grid_ny()
      implicit none
#include "ewald.fh"
      ewald_grid_ny=eny
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer function ewald_grid_nz()
      implicit none
#include "ewald.fh"
      ewald_grid_nz=enz
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      intialization routines
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine mandelung_set(alpha)
      implicit none
      real*8 alpha
      
      integer N
      parameter (N=40)

*     **** local variables ****
      integer n1,n2,n3,nterm
      real*8  rc,rs,epsilon,pi
      real*8  a1,a2,a3,g1,g2,g3,gg
      real*8  unita(3,3),unitg(3,3)
      real*8  alpha1,alpha2,sum,ea,omega

*     **** external functions ****
      real*8   util_erfc
      external util_erfc
      real*8   lattice_unita,lattice_unitg,lattice_omega
      external lattice_unita,lattice_unitg,lattice_omega
      
      pi = 4.0d0*datan(1.0d0)

*     ***** set lattice parameters *****
      omega = lattice_omega()
      do n1=1,3
      do n2=1,3
         unita(n1,n2) = lattice_unita(n1,n2)
         unitg(n1,n2) = lattice_unitg(n1,n2)
      end do
      end do

*     ***** set cutoff radii ****
      rs      = (3.0d0*omega/(4.0d0*pi))**(1.0d0/3.0d0)
      rc      = rs
      epsilon = 1.0d0/rc

*     **** calculate alpha1 *****
      sum = 0.0d0
      do n1=(-N+1),(N-1) 
      do n2=(-N+1),(N-1) 
      do n3=(-N+1),(N-1) 
         nterm=iabs(n1)+iabs(n2)+iabs(n3)
         if (nterm.ne.0) then
            a1 = n1*unita(1,1)
     >         + n2*unita(1,2)
     >         + n3*unita(1,3)

            a2 = n1*unita(2,1)
     >         + n2*unita(2,2)
     >         + n3*unita(2,3)

            a3 = n1*unita(3,1)
     >         + n2*unita(3,2)
     >         + n3*unita(3,3)

            ea = dsqrt(a1*a1 + a2*a2 + a3*a3)

            sum = sum + util_erfc(epsilon*ea)/ea

         end if
      end do
      end do
      end do
      alpha1 = sum

		
*     **** calculate alpha2 *****
      sum = 0.0d0
      do n1=(-N+1),(N-1) 
      do n2=(-N+1),(N-1) 
CDIR$ NOVECTOR
      do n3=(-N+1),(N-1) 
         nterm=iabs(n1)+iabs(n2)+iabs(n3)
         if (nterm.ne.0) then
            g1 = n1*unitg(1,1)
     >         + n2*unitg(1,2)
     >         + n3*unitg(1,3)

            g2 = n1*unitg(2,1)
     >         + n2*unitg(2,2)
     >         + n3*unitg(2,3)

            g3 = n1*unitg(3,1)
     >         + n2*unitg(3,2)
     >         + n3*unitg(3,3)

            gg  = g1*g1 + g2*g2 + g3*g3
            sum = sum +  (4.0d0*pi/gg)* exp(-gg*rc*rc/4.0d0)
	    
         end if
      end do
      end do
      end do
      alpha2 = sum/omega

      sum = alpha1 + alpha2 
     >    - pi*rc*rc/omega - 2.0d0*epsilon/dsqrt(pi)

      alpha = -sum*rs
      return 
      end
cccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccc
      subroutine ewald_init()
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"
*     **** arguments **********
*     **** local variables ****
      real*8 eps
      parameter(eps=1.0d-12)
      integer i,j,k,l
      integer k1,k2,k3,itmp,i_indx,j_indx,k_indx
      integer enxh,enyh,enzh,enpack0
      integer dutask,indx,xtra
      integer ntyp,ccode
      real*8  pi,pi4,gg,w,ggcut
      real*8  rs,qi
      real*8  zz,z,term
      logical value
      real*8 g1,g2,g3,gg1,gg2,gg3
      real*8 gf1,gf2,gf3,ggf1,ggf2,ggf3
      real*8 unitg(3,3),unita(3,3)
      real*8 unitf(3,3)

*     **** external functions ****
      integer  ewald_strfact_i_indx
      integer  ewald_strfact_j_indx
      integer  ewald_strfact_k_indx
      integer  control_code,ion_nkatm
      integer  control_ncut
      real*8   control_rcut,control_ecut
      integer  ion_nion,ion_katm,ion_nion_qm
      real*8   lattice_omega,lattice_unita
      real*8   lattice_unitg,lattice_unitg_frozen
      real*8 psp_zv,cpsp_zv,paw_basis_ion_charge,mmq_zv
      real*8 paw_basis_core_charge,dsum
      integer control_ewald_ngrid
  
      external ewald_strfact_i_indx
      external ewald_strfact_j_indx
      external ewald_strfact_k_indx
      external control_code,ion_nkatm
      external control_ncut
      external control_rcut,control_ecut
      external ion_nion,ion_katm,ion_nion_qm
      external lattice_omega,lattice_unita                                
      external lattice_unitg,lattice_unitg_frozen
      external psp_zv,cpsp_zv,paw_basis_ion_charge,mmq_zv
      external paw_basis_core_charge,dsum
      external control_ewald_ngrid

      do j=1,3
      do i=1,3
          unita(i,j) = lattice_unita(i,j)
          unitg(i,j) = lattice_unitg(i,j)
          unitf(i,j) = lattice_unitg_frozen(i,j)
      end do
      end do
      call Parallel_np(tnp)
      call Parallel_taskid(tid)
      enx=control_ewald_ngrid(1)
      eny=control_ewald_ngrid(2)
      enz=control_ewald_ngrid(3)
      enxh=enx/2
      enyh=eny/2
      enzh=enz/2

*     **** determine ggcut ****
      g1 = unitf(1,1)*(enxh)
      g2 = unitf(2,1)*(enxh)
      g3 = unitf(3,1)*(enxh)
      gg1 = g1*g1 + g2*g2 + g3*g3

      g1 = unitf(1,2)*(enyh)
      g2 = unitf(2,2)*(enyh)
      g3 = unitf(3,2)*(enyh)
      gg2 = g1*g1 + g2*g2 + g3*g3

      g1 = unitf(1,3)*(enzh)
      g2 = unitf(2,3)*(enzh)
      g3 = unitf(3,3)*(enzh)
      gg3 = g1*g1 + g2*g2 + g3*g3

      ggcut = gg1
      if (gg2.lt.ggcut) ggcut = gg2
      if (gg3.lt.ggcut) ggcut = gg3
      if ((2.0d0*control_ecut()).lt.ggcut) ggcut=2.0d0*control_ecut()

c     **** determine enpack and nida ****
      dutask=0
      enpack = 0
      nida   = 0
      k1 = 0
      k2 = 0
      k3 = 0
      g1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
      g2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
      g3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
      gg=g1*g1+g2*g2+g3*g3
      if ((gg-ggcut).lt.-eps) then
         if (dutask.eq.tid) then
            enpack = enpack + 1
            nida   = nida + 1
         end if 
         dutask = mod(dutask+1,tnp)
      end if
      do k=1,(enzh-1)
         k1 = 0
         k2 = 0
         k3 = k
         g1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
         g2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
         g3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
         gg=g1*g1+g2*g2+g3*g3
         if ((gg-ggcut).lt.-eps) then
            if (dutask.eq.tid) enpack = enpack + 1
            dutask = mod(dutask+1,tnp)
         end if
      end do
      do k=(-enzh+1),(enzh-1)
      do j=1,(enyh-1)
         k1 = 0
         k2 = j
         k3 = k
         g1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
         g2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
         g3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
         gg=g1*g1+g2*g2+g3*g3
         if ((gg-ggcut).lt.-eps) then
            if (dutask.eq.tid) enpack = enpack + 1
            dutask = mod(dutask+1,tnp)
         end if
      end do 
      end do 
      do k=(-enzh+1),(enzh-1)
      do j=(-enyh+1),(enyh-1)
      do i=1,(enxh-1)
         k1=i
         k2=j
         k3=k
         g1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
         g2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
         g3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
         gg=g1*g1+g2*g2+g3*g3
         if ((gg-ggcut).lt.-eps) then
            if (dutask.eq.tid) enpack = enpack + 1
            dutask = mod(dutask+1,tnp)
         end if
      end do
      end do
      end do

c     **** allocate memory for common block ****
      notzero_enpack = (enpack.gt.0)  !** needed for very large numbers cpu
      value = .true.
      if (notzero_enpack) then 
         value=MA_alloc_get(mt_dbl,3*enpack,'eG',eg_hndl,eG(1))
         eG(2)=eG(1)+enpack
         eG(3)=eG(2)+enpack
         value=value.and.MA_alloc_get(mt_dbl,enpack,'vg',vg(2),vg(1))
         value=value.and.MA_alloc_get(mt_dbl,enpack,'vcx',vcx(2),vcx(1))
      end if
      ntyp=ion_nkatm()      
      value=value.and.MA_alloc_get(mt_dbl,ntyp,'zv',zv(2),zv(1))
      if (.not.value) call errquit('ewald_init:out of heap memory',0,0)

      call ewald_strfact_init()


*     **** determine eG ****
      if (notzero_enpack) then
      i_indx = ewald_strfact_i_indx()
      j_indx = ewald_strfact_j_indx()
      k_indx = ewald_strfact_k_indx()
      call dcopy(3*enpack,0.0d0,0,dbl_mb(eG(1)),1)
      dutask=0
      enpack0 = 0
      k1 = 0
      k2 = 0
      k3 = 0
      g1=k1*unitg(1,1)+k2*unitg(1,2)+k3*unitg(1,3)
      g2=k1*unitg(2,1)+k2*unitg(2,2)+k3*unitg(2,3)
      g3=k1*unitg(3,1)+k2*unitg(3,2)+k3*unitg(3,3)

      gf1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
      gf2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
      gf3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
      gg=gf1*gf1+gf2*gf2+gf3*gf3
      if ((gg-ggcut).lt.-eps) then
         if (dutask.eq.tid) then
            dbl_mb(eG(1)+enpack0) = g1
            dbl_mb(eG(2)+enpack0) = g2
            dbl_mb(eG(3)+enpack0) = g3
            i=k1
            j=k2
            k=k3
            if (i .lt. 0) i = i + enx
            if (j .lt. 0) j = j + eny
            if (k .lt. 0) k = k + enz
            int_mb(i_indx+enpack0) = i+1
            int_mb(j_indx+enpack0) = j+1
            int_mb(k_indx+enpack0) = k+1
            enpack0 = enpack0 + 1
         endif
         dutask = mod(dutask+1,tnp)
      end if

      k1 = 0
      k2 = 0
      do k3=1,(enzh-1)
         g1=k1*unitg(1,1)+k2*unitg(1,2)+k3*unitg(1,3)
         g2=k1*unitg(2,1)+k2*unitg(2,2)+k3*unitg(2,3)
         g3=k1*unitg(3,1)+k2*unitg(3,2)+k3*unitg(3,3)

         gf1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
         gf2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
         gf3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
         gg=gf1*gf1+gf2*gf2+gf3*gf3
         if ((gg-ggcut).lt.-eps) then
            if (dutask.eq.tid) then
               dbl_mb(eG(1)+enpack0) = g1
               dbl_mb(eG(2)+enpack0) = g2
               dbl_mb(eG(3)+enpack0) = g3
               i=k1
               j=k2
               k=k3
               if (i .lt. 0) i = i + enx
               if (j .lt. 0) j = j + eny
               if (k .lt. 0) k = k + enz
               int_mb(i_indx+enpack0) = i+1
               int_mb(j_indx+enpack0) = j+1
               int_mb(k_indx+enpack0) = k+1
               enpack0 = enpack0 + 1
            end if
            dutask = mod(dutask+1,tnp)
         end if
      end do
      k1 = 0
      do k3=(-enzh+1),(enzh-1)
      do k2=1,(enyh-1)
         g1=k1*unitg(1,1)+k2*unitg(1,2)+k3*unitg(1,3)
         g2=k1*unitg(2,1)+k2*unitg(2,2)+k3*unitg(2,3)
         g3=k1*unitg(3,1)+k2*unitg(3,2)+k3*unitg(3,3)

         gf1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
         gf2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
         gf3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
         gg=gf1*gf1+gf2*gf2+gf3*gf3
         if ((gg-ggcut).lt.-eps) then
            if (dutask.eq.tid) then
               dbl_mb(eG(1)+enpack0) = g1
               dbl_mb(eG(2)+enpack0) = g2
               dbl_mb(eG(3)+enpack0) = g3
               i=k1
               j=k2
               k=k3
               if (i .lt. 0) i = i + enx
               if (j .lt. 0) j = j + eny
               if (k .lt. 0) k = k + enz
               int_mb(i_indx+enpack0) = i+1
               int_mb(j_indx+enpack0) = j+1
               int_mb(k_indx+enpack0) = k+1
               enpack0 = enpack0 + 1
            end if
            dutask = mod(dutask+1,tnp)
         end if
      end do 
      end do 
      do k3=(-enzh+1),(enzh-1)
      do k2=(-enyh+1),(enyh-1)
      do k1=1,(enxh-1)
         g1=k1*unitg(1,1)+k2*unitg(1,2)+k3*unitg(1,3)
         g2=k1*unitg(2,1)+k2*unitg(2,2)+k3*unitg(2,3)
         g3=k1*unitg(3,1)+k2*unitg(3,2)+k3*unitg(3,3)

         gf1=k1*unitf(1,1)+k2*unitf(1,2)+k3*unitf(1,3)
         gf2=k1*unitf(2,1)+k2*unitf(2,2)+k3*unitf(2,3)
         gf3=k1*unitf(3,1)+k2*unitf(3,2)+k3*unitf(3,3)
         gg=gf1*gf1+gf2*gf2+gf3*gf3
         if ((gg-ggcut).lt.-eps) then
            if (dutask.eq.tid) then
               dbl_mb(eG(1)+enpack0) = g1
               dbl_mb(eG(2)+enpack0) = g2
               dbl_mb(eG(3)+enpack0) = g3
               i=k1
               j=k2
               k=k3
               if (i .lt. 0) i = i + enx
               if (j .lt. 0) j = j + eny
               if (k .lt. 0) k = k + enz
               int_mb(i_indx+enpack0) = i+1
               int_mb(j_indx+enpack0) = j+1
               int_mb(k_indx+enpack0) = k+1
               enpack0 = enpack0 + 1
            end if
            dutask = mod(dutask+1,tnp)
         end if
      end do
      end do
      end do

      call dcopy(enpack,0.0d0,0,dbl_mb(vg(1)),1)
      call dcopy(enpack,0.0d0,0,dbl_mb(vcx(1)),1)
      end if

*     ***** find w *****
      pi  = 4.0d0*datan(1.0d0)
      pi4 = 4.0d0*pi
      ncut = control_ncut()
      rcut = control_rcut()
      if (ncut.le.0)     ncut=1
      if (rcut.le.0.0d0) then
         rs = unita(1,1)**2 + unita(2,1)**2 + unita(3,1)**2
         rs = dsqrt(rs)
         rcut=rs/pi

         rs = unita(1,2)**2 + unita(2,2)**2 + unita(3,2)**2
         rs = dsqrt(rs)
         w=rs/pi
         if (w.lt.rcut) rcut = w

         rs = unita(1,3)**2 + unita(2,3)**2 + unita(3,3)**2
         rs = dsqrt(rs)
         w=rs/pi
         if (w.lt.rcut) rcut = w
      end if
      w = 0.25d0*rcut*rcut

      if (notzero_enpack) then
         dbl_mb(vcx(1)) = 0.0d0
         dbl_mb(vg(1))  = 0.0d0
         do k=1+nida,enpack
           g1 = dbl_mb(eG(1)+k-1)
           g2 = dbl_mb(eG(2)+k-1)
           g3 = dbl_mb(eG(3)+k-1)
           gg=g1*g1+g2*g2+g3*g3
           term=pi4/gg
           dbl_mb(vcx(1)+k-1)=term
           dbl_mb(vg(1)+k-1) =term*dexp(-w*gg)
         end do
      end if

ccccccccccc set Mandelung constant       

      call Mandelung_set(alpha)

ccccccccccc set ion charges
      ccode=control_code()
      if (ccode.eq.12) then
         do i=1,ntyp
            dbl_mb(zv(1)+i-1)=mmq_zv(i)
         end do
      else if ((ccode.eq.5).or.(ccode.eq.13).or.(ccode.eq.14)) then
          do i=1,ntyp
             dbl_mb(zv(1)+i-1)=cpsp_zv(i)
          end do
      else
        if ((ccode.eq.6).or.(ccode.eq.7).or.(ccode.eq.8)) then
          do i=1,ntyp
              dbl_mb(zv(1)+i-1)=paw_basis_ion_charge(i)-
     >                 paw_basis_core_charge(i)
          end do
        else
          do i=1,ntyp
             dbl_mb(zv(1)+i-1)=psp_zv(i)
          end do
        end if
      end if

cccccccccc  ewald summation
      rs = (3.0d0*lattice_omega()/pi4)**(1.0d0/3.0d0)

      zz = 0.0d0
      z  = 0.0d0
      do i=1,ion_nion()
         qi=dbl_mb(zv(1)+ion_katm(i)-1)
         zz = zz + qi**2
         z  = z  + qi
      end do

*     ***** t_dsum of vg *****
      if (notzero_enpack) then
         cewald = 2.0d0*dsum(enpack,dbl_mb(vg(1)),1)   
      else
         cewald=0.0d0
      end if
      !if (nida.eq.1) cewald = cewald - dbl_mb(vg(1))  !*** zero because vg(g=0) = 0
      if (tnp.gt.1) call Parallel_SumAll(cewald)

      cewald = -0.5d0*zz*(alpha/rs + cewald/lattice_omega())
     >         -0.5d0*(z*z-zz)*rcut*rcut*pi/lattice_omega()


      zz = 0.0d0
      z  = 0.0d0
      do i=1,ion_nion_qm()
         qi=dbl_mb(zv(1)+ion_katm(i)-1)
         zz = zz + qi**2
         z  = z  + qi
      end do

*     ***** t_dsum of vg *****
      if (notzero_enpack) then
         cewald_qm = 2.0d0*dsum(enpack,dbl_mb(vg(1)),1)   
      else
         cewald_qm = 0.0d0
      end if
      !if (nida.eq.1) cewald_qm = cewald_qm - dbl_mb(vg(1))  !*** zero because vg(g=0) = 0
      if (tnp.gt.1) call Parallel_SumAll(cewald_qm)

      cewald_qm = -0.5d0*zz*(alpha/rs + cewald_qm/lattice_omega())
     >         -0.5d0*(z*z-zz)*rcut*rcut*pi/lattice_omega()

      zz = 0.0d0
      z  = 0.0d0
      do i=ion_nion_qm(1)+1,ion_nion()
         qi=dbl_mb(zv(1)+ion_katm(i)-1)
         zz = zz + qi**2
         z  = z  + qi
      end do

*     ***** t_dsum of vg *****
      if (notzero_enpack) then
         cewald_mm = 2.0d0*dsum(enpack,dbl_mb(vg(1)),1)   
      else
         cewald_mm = 0.0d0
      end if
      !if (nida.eq.1) cewald_mm = cewald_mm - dbl_mb(vg(1))  !*** zero because vg(g=0) = 0
      if (tnp.gt.1) call Parallel_SumAll(cewald_mm)

      cewald_mm = -0.5d0*zz*(alpha/rs + cewald_mm/lattice_omega())
     >         -0.5d0*(z*z-zz)*rcut*rcut*pi/lattice_omega()


cccccccccc allocate and fill rcell
      nshl3d=(2*ncut+1)**3
      value=MA_alloc_get(mt_dbl,(3*nshl3d),'rcell',rcell(2),rcell(1))
      if (.not. value)
     > call errquit('ewald_init:out of heap memory',0,MA_ERR)


*     **** get lattice vectors in real space - define rcell(1) = origin****
      l=1
      dbl_mb(rcell(1)+(l-1))          = 0.0d0
      dbl_mb(rcell(1)+(l-1)+nshl3d)   = 0.0d0
      dbl_mb(rcell(1)+(l-1)+2*nshl3d) = 0.0d0
      do k=-ncut,ncut
      do j=-ncut,ncut
      do i=-ncut,ncut
      if (.not.((i.eq.0).and.(j.eq.0).and.(k.eq.0))) then
        l = l+1
        dbl_mb(rcell(1)+(l-1) )
     >    =i*unita(1,1)+j*unita(1,2)+k*unita(1,3)
        dbl_mb(rcell(1)+(l-1)+nshl3d)
     >    =i*unita(2,1)+j*unita(2,2)+k*unita(2,3)
        dbl_mb(rcell(1)+(l-1)+2*nshl3d)
     >    =i*unita(3,1)+j*unita(3,2)+k*unita(3,3)
      end if
      end do
      end do
      end do

      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ewald_end()
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"
      logical value
      call ewald_strfact_end()
      value = .true.
      if (notzero_enpack) then
         value=value.and.MA_free_heap(eg_hndl)
         value=value.and.MA_free_heap(vcx(2))
         value=value.and.MA_free_heap(vg(2))
      end if
      value=value.and.MA_free_heap(rcell(2))
      value=value.and.MA_free_heap(zv(2))
      if (.not.value) then
        call errquit("ewald end can free heap",0,MA_ERR)
      end if
      return 
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
*     ***********************************
*     *                                 *
*     *          ewald_ct_Sqr           *
*     *                                 *
*     ***********************************
      subroutine ewald_ct_Sqr(ng,A,C)
      implicit none
      integer    ng
      complex*16 A(*)
      real*8     C(*)

*     **** local variables ****
      integer i

      do i=1,ng
        C(i) = dble(A(i))**2 + dimag(A(i))**2
      end do
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
*     ***********************************
*     *			  		*
*     *		ewald_e			*
*     *				       	*
*     ***********************************
      real*8 function ewald_e()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     **** local variables ****
      integer dutask
      integer i,j,ii,l,nion
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  energy,etmp,energyG,ttcr,ttci,zii
      complex*16 ttcz
*     **** temporary workspace variables ****
      integer exi(2),s(2),tmp3(2)
      logical value

*     **** external functions ****
      integer  ion_nion,ion_katm
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc
      real*8   ddot
      external ion_nion,ion_katm
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc
      external ddot

      call nwpw_timing_start(21)

*     **** allocate temp workspace ****
      nion = ion_nion()
      
      if (notzero_enpack) then
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.
     >           MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
         if (.not. value) 
     >     call errquit('ewald_e:out of stack memory',0,MA_ERR)
     
*        **** get the structure factor ****
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            call daxpy(2*enpack,dbl_mb(zv(1)+ion_katm(ii)-1),
     >             dcpl_mb(exi(1)),1,
     >             dcpl_mb(s(1)),1)
         end do

*        **** calculate the ewald energy ****
         call ewald_ct_Sqr(enpack,dcpl_mb(s(1)),dbl_mb(tmp3(1)))
         energy=2.0d0*ddot(enpack,dbl_mb(tmp3(1)),1,dbl_mb(vg(1)),1)
      else
         energy=0.0d0
      end if
      if (tnp.gt.1) call Parallel_SumAll(energy)
      energy  = 0.5d0*energy/lattice_omega() + cewald


*     *** made parallel  ****
      dutask = 0
      etmp = 0.0d0
      do i=1,nion-1
      do j=i+1,nion
      if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = dbl_mb(zv(1)+ion_katm(i)-1)*dbl_mb(zv(1)+ion_katm(j)-1)
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+nshl3d)   + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           if (r.gt.1.0d-6) then
              w = (r/rcut)
              yerfc = util_erfc(w)  !*** needs to be faster
              etmp=etmp+(zz*yerfc/r)
           end if
        end do
      end if
      dutask=mod(dutask+1,tnp)
      end do
      end do
      if (tnp.gt.1) call Parallel_SumAll(etmp)
      energy = energy + etmp
      

*     **** deallocate temp workspace ****
      if (notzero_enpack) then
         value =           MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >     call errquit('ewald_e:popping stack memory',0,MA_ERR)
      end if

      call nwpw_timing_end(21)
      ewald_e = energy
      return
      end


*     ***********************************
*     *	        			*
*     *		ewald_f			*
*     *		       			*
*     ***********************************

      subroutine ewald_f(fion)
      implicit none
      real*8  fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)


*     **** local variables ****
      integer dutask
      integer i,j,l,ii
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  sum,scal2,f
      real*8  sw1,sw2,sw3,zii

*     **** temporary workspace variables ****
      integer nion
      integer exi(2),s(2),tmp3(2)
      integer fx(2),fy(2),fz(2)
      logical value

*     **** external functions ****
      integer  ion_nion,ion_katm,ewald_nshl3d
      external ion_nion,ion_katm,ewald_nshl3d
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot

      call nwpw_timing_start(21)
      nion = ion_nion()

*     **** allocate temp workspace ****
      value = .true.
      if (notzero_enpack) then
         value = value.and.
     >           MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
      end if
      value = value.and.MA_push_get(mt_dbl,nion,'fx',fx(2),fx(1)) 
      value = value.and.MA_push_get(mt_dbl,nion,'fy',fy(2),fy(1)) 
      value = value.and.MA_push_get(mt_dbl,nion,'fz',fz(2),fz(1)) 
      if(.not.value) call errquit('ewald_f:out of stack',0,MA_ERR)


      scal2 = 1.0d0/lattice_omega()
      call dcopy(nion,0.0d0,0,dbl_mb(fx(1)),1)
      call dcopy(nion,0.0d0,0,dbl_mb(fy(1)),1)
      call dcopy(nion,0.0d0,0,dbl_mb(fz(1)),1)
     
*     **** get the structure factor ****
      if (notzero_enpack) then
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            call daxpy(2*enpack,zii,dcpl_mb(exi(1)),1,dcpl_mb(s(1)),1)
         end do
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))

c         do i=1,enpack
c            dbl_mb(tmp3(1)+i-1) 
c     >              = ( dble(dcpl_mb(exi(1)+i-1))
c     >                *dimag(dcpl_mb(s(1)+i-1))
c     >              -  dimag(dcpl_mb(exi(1)+i-1))
c     >                 *dble(dcpl_mb(s(1)+i-1))
c     >                )*dbl_mb(vg(1)+i-1)
c         end do
            call ewald_f_tmp3(enpack,
     >                        dcpl_mb(exi(1)),dcpl_mb(s(1)),
     >                        dbl_mb(vg(1)),dbl_mb(tmp3(1)))

            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            sum=2.0d0*ddot(enpack,dbl_mb(eG(1)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fx(1)+ii-1) = dbl_mb(fx(1)+ii-1) 
     >                         +  sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(2)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fy(1)+ii-1) = dbl_mb(fy(1)+ii-1) 
     >                         +  sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(3)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fz(1)+ii-1) = dbl_mb(fz(1)+ii-1) 
     >                         +  sum*zii*scal2
         end do
      end if
    
      dutask=0
      do i=1,nion-1
      do j=i+1,nion
       if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = ewald_zv(ion_katm(i)) * ewald_zv(ion_katm(j))
        sw1=0.0d0
        sw2=0.0d0
        sw3=0.0d0  
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+  nshl3d) + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           if (r.gt.1.0d-6) then
              w = r/rcut
              yerfc = util_erfc(w)
              f = zz*(yerfc+cerfc*w*dexp(-w*w))/r**3
              sw1=sw1+(x*f)
              sw2=sw2+(y*f)
              sw3=sw3+(z*f)
           end if
        end do

        dbl_mb(fx(1)+i-1) = dbl_mb(fx(1)+i-1) + sw1
        dbl_mb(fy(1)+i-1) = dbl_mb(fy(1)+i-1) + sw2
        dbl_mb(fz(1)+i-1) = dbl_mb(fz(1)+i-1) + sw3

        dbl_mb(fx(1)+j-1) = dbl_mb(fx(1)+j-1) - sw1
        dbl_mb(fy(1)+j-1) = dbl_mb(fy(1)+j-1) - sw2
        dbl_mb(fz(1)+j-1) = dbl_mb(fz(1)+j-1) - sw3

       end if
       dutask = mod((dutask+1),tnp)
      end do
      end do
      if (tnp.gt.1) then
          call Parallel_Vector_SumAll(nion,dbl_mb(fx(1)))
          call Parallel_Vector_SumAll(nion,dbl_mb(fy(1)))
          call Parallel_Vector_SumAll(nion,dbl_mb(fz(1)))
      end if

      do i=1,nion
         fion(1,i) = fion(1,i) + dbl_mb(fx(1)+i-1)
         fion(2,i) = fion(2,i) + dbl_mb(fy(1)+i-1)
         fion(3,i) = fion(3,i) + dbl_mb(fz(1)+i-1)
      end do
      
*     **** deallocate temp workspace ****
      value =           MA_pop_stack(fz(2))
      value = value.and.MA_pop_stack(fy(2))
      value = value.and.MA_pop_stack(fx(2))
      if (notzero_enpack) then
         value = value.and.MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
      end if
      if (.not. value) 
     >  call errquit('ewald_f:popping stack memory',0,MA_ERR)

      call nwpw_timing_end(21)
      return
      end

      subroutine ewald_f_tmp3(n,e,s,v,t)
      implicit none
      integer n
      complex*16 e(n),s(n)
      real*8 v(n),t(n)

      integer i

      do i=1,n
        t(i) = v(i)*(dble(e(i))*dimag(s(i)) - dimag(e(i))*dble(s(i)))
      end do

      return
      end

*     ***********************************
*     *					*
*     *		ewald_stress		*
*     *	        			*
*     ***********************************

      subroutine ewald_stress(stress)
      implicit none
      real*8  stress(3,3)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

      integer N
      parameter (N=40)

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)

*     **** local variables ****
      logical value
      integer i,ii,j,l,nion
      integer n1,n2,n3
      integer u,v,s,dutask
      real*8 pi,fourpi,scal
      real*8 zz,z
      real*8 Cus(3,3),hm(3,3),energy,sum,ss,rs
      real*8 ea,ax,ay,az,epsilon
      real*8 dx,dy,dz,w,ar,ai
      real*8 unita(3,3),unitg(3,3)
      complex*16 cz
      integer H(2),F(2),tmp1(2),tmp2(2),exi(2),strf(2)

*     **** external functions ****
      integer  ion_katm,ion_nion
      real*8   ewald_zv,lattice_unitg,lattice_unita,lattice_omega
      real*8   util_erfc,ion_rion,ddot
      external ion_katm,ion_nion
      external ewald_zv,lattice_unitg,lattice_unita,lattice_omega
      external util_erfc,ion_rion,ddot

      call nwpw_timing_start(21)
      pi     = 4.0d0*datan(1.0d0)
      fourpi = 4.0d0*pi
      scal   = 1.0d0/(2.0d0*pi)
      nion    = ion_nion()
*     *** define hm,unita,unitg ****
      do v=1,3
      do u=1,3
         hm(u,v) = scal*lattice_unitg(u,v)
         unitg(u,v) = lattice_unitg(u,v)
         unita(u,v) = lattice_unita(u,v)
      end do
      end do
 
      zz = 0.0d0
      z  = 0.0d0
      do i=1,nion
         zz = zz + dbl_mb(zv(1)+ion_katm(i)-1)**2
         z  = z  + dbl_mb(zv(1)+ion_katm(i)-1)
      end do

*     **** Miscellaneous contributions - stress from cewald term ****
      do v=1,3
      do u=1,3
         stress(u,v) = 0.5d0*z*z*pi*rcut*rcut/lattice_omega()
     >               *hm(u,v)
      end do
      end do


*     **** G-space contributions ****

*     **** get the structure factor ****
      if (notzero_enpack) then
         value=            MA_push_get(mt_dbl,enpack,'H',H(2),H(1))
         value=value.and.MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1))
         value=value.and.
     >         MA_push_get(mt_dcpl,enpack,'strf',strf(2),strf(1))
         if (.not. value) 
     >     call errquit('ewald_stress:out of stack memory',0,MA_ERR)


         call dcopy((2*enpack),0.0d0,0,dcpl_mb(strf(1)),1)
         do ii=1,ion_nion()
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            call daxpy(2*enpack,ewald_zv(ion_katm(ii)),
     >                 dcpl_mb(exi(1)),1,dcpl_mb(strf(1)),1)
         end do
         do i=1,enpack
             cz=dcpl_mb(strf(1)+i-1)
             ar=dble(cz)
             ai=dimag(cz)
             dbl_mb(H(1)+i-1)=ar*ar+ai*ai
         end do
         value =           MA_pop_stack(strf(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >    call errquit('ewald_stress:error popping stack',0,MA_ERR)

*        **** calculate the ewald energy ****
c         call dcopy(enpack,dbl_mb(vg(1)),1,dbl_mb(F(1)),1)
         F(1) = vg(1)
         energy=2.0d0*ddot(enpack,dbl_mb(F(1)),1,dbl_mb(H(1)),1)
      else
         energy=0.0d0
      end if
      if (tnp.gt.1) call Parallel_SumAll(energy)
      energy = -0.5d0*energy/lattice_omega()


      do v=1,3
      do u=1,3
         stress(u,v) = stress(u,v) + energy*hm(u,v)
      end do
      end do
     
*     **** tmp2(G) = F(G)*H(G)/G**2 + F(G)*H(G)*rcut*rcut/4 ****
      if (notzero_enpack) then
         value=MA_push_get(mt_dbl,enpack,'tmp1',tmp1(2),tmp1(1))
         value=value.and.
     >         MA_push_get(mt_dbl,enpack,'tmp2',tmp2(2),tmp2(1))
         if (.not.value) 
     >     call errquit('ewald_stress:out of stack memory',0,MA_ERR)

         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(F(1)+i-1)*dbl_mb(H(1)+i-1)
         end do
         ss = 0.25d0*rcut*rcut
         do i=1,enpack
            dbl_mb(tmp2(1)+i-1)=dbl_mb(tmp1(1)+i-1)*ss
         end do       
         ss = 1.0d0/fourpi
         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(tmp1(1)+i-1)*ss
         end do       
         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(tmp1(1)+i-1)*dbl_mb(vcx(1)+i-1)
         end do       
         do i=1,enpack
            dbl_mb(tmp2(1)+i-1)=dbl_mb(tmp2(1)+i-1)+dbl_mb(tmp1(1)+i-1)
         end do       
      end if

*     **** calculate Cus ****

      call dcopy(9,0.0d0,0,Cus,1)
      ss =  1.0d0/lattice_omega()
      if (notzero_enpack) then
         do u=1,3
         do s=u,3
            do i=1,enpack
               dbl_mb(tmp1(1)+i-1)=dbl_mb(eG(u)+i-1)*dbl_mb(eG(s)+i-1)
            end do
            sum=2.0d0*ddot(enpack,dbl_mb(tmp1(1)),1,dbl_mb(tmp2(1)),1)
            !if (tnp.gt.1) call Parallel_SumAll(sum)
            Cus(u,s) = ss*sum
         end do
         end do
c      do u=1,3
c      do s=u+1,3
c         Cus(s,u) = Cus(u,s)
c      end do
c      end do
c      do v=1,3
c      do u=1,3
c        do s=1,3
c           stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
c        end do
c      end do
c      end do

         value =           MA_pop_stack(tmp2(2))
         value = value.and.MA_pop_stack(tmp1(2))
         value = value.and.MA_Pop_stack(H(2))
         if (.not.value) 
     >    call errquit(
     >         'ewald_stress:error popping stack memory',0,MA_ERR)
      end if

*     **** R-space contributions ****

*     **** calculate alpha1 - stress from cewald term*****
c        call dcopy(9,0.0d0,0,Cus,1)
        rs      = (3.0d0*lattice_omega()/(4.0d0*pi))**(1.0d0/3.0d0)
        epsilon = 1.0d0/rcut
        sum = 0.0d0
        dutask = 0
        do n1=(-N+1),(N-1) 
        do n2=(-N+1),(N-1) 
        do n3=(-N+1),(N-1) 
           if (dutask.eq.tid) then
           if (.not.((n1.eq.0).and.(n2.eq.0).and.(n3.eq.0))) then
              ax = n1*unita(1,1)
     >           + n2*unita(1,2)
     >           + n3*unita(1,3)

              ay = n1*unita(2,1)
     >           + n2*unita(2,2)
     >           + n3*unita(2,3)

              az = n1*unita(3,1)
     >           + n2*unita(3,2)
     >           + n3*unita(3,3)

              ea = dsqrt(ax*ax + ay*ay + az*az)
              w = ea*epsilon

              ss = util_erfc(w)/ea 
     >           + 2.0d0*epsilon/dsqrt(pi)*dexp(-w*w)
              ss = -(0.5d0*zz)*ss/(ea*ea)
              Cus(1,1) = Cus(1,1) + ss * ax*ax 
              Cus(1,2) = Cus(1,2) + ss * ax*ay 
              Cus(1,3) = Cus(1,3) + ss * ax*az 

              !Cus(2,1) = Cus(2,1) + ss * ay*ax 
              Cus(2,2) = Cus(2,2) + ss * ay*ay 
              Cus(2,3) = Cus(2,3) + ss * ay*az 

              !Cus(3,1) = Cus(3,1) + ss * az*ax 
              !Cus(3,2) = Cus(3,2) + ss * az*ay 
              Cus(3,3) = Cus(3,3) + ss * az*az 

           end if
           end if
           dutask=mod(dutask+1,tnp)
        end do
        end do
        end do


c        do v=1,3
c        do u=1,3
c          do s=1,3
c             stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
c          end do
c        end do
c        end do


*     **** calculate erfc contribution *****
c      call dcopy(9,0.0d0,0,Cus,1)
      epsilon = 1.0d0/rcut
      dutask=0
      do i=1,nion-1
      do j=i+1,nion
        if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = ewald_zv(ion_katm(i)) * ewald_zv(ion_katm(j))
        do l=1,nshl3d
           ax = dbl_mb(rcell(1)+(l-1))          + dx
           ay = dbl_mb(rcell(1)+(l-1)+nshl3d)   + dy
           az = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           ea = dsqrt(ax*ax+ay*ay+az*az)
           if (ea.gt.1.0d-6) then
              w = ea*epsilon

              ss = -util_erfc(w)/ea
     >           - 2.0d0*epsilon/dsqrt(pi)*exp(-w*w)
              ss = ss/(ea*ea)
              Cus(1,1) = Cus(1,1) + ss * ax*ax * zz
              Cus(1,2) = Cus(1,2) + ss * ax*ay * zz
              Cus(1,3) = Cus(1,3) + ss * ax*az * zz
              Cus(2,2) = Cus(2,2) + ss * ay*ay * zz
              Cus(2,3) = Cus(2,3) + ss * ay*az * zz
              Cus(3,3) = Cus(3,3) + ss * az*az * zz
           end if
        end do
        end if
        dutask=mod(dutask+1,tnp)
      end do
      end do

      if (tnp.gt.1) then
        call Parallel_Vector_SumAll(9,Cus(1,1))
      end if

      do u=1,3
        do s=u+1,3
           Cus(s,u) = Cus(u,s)
        end do
      end do

      do v=1,3
        do u=1,3
          do s=1,3
             stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
          end do
        end do
      end do

      call nwpw_timing_end(21)
      return
      end


*     ***********************************
*     *			  		*
*     *		ewald_e_qm		*
*     *				       	*
*     ***********************************
      real*8 function ewald_e_qm()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     **** local variables ****
      integer dutask
      integer i,j,ii,l,nion
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  energy,etmp,energyG,ttcr,ttci,zii
      complex*16 ttcz
*     **** temporary workspace variables ****
      integer exi(2),s(2),tmp3(2)
      logical value

*     **** external functions ****
      integer  ion_nion_qm,ion_katm
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc
      real*8   ddot
      external ion_nion_qm,ion_katm
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc
      external ddot

      call nwpw_timing_start(21)

*     **** allocate temp workspace ****
      nion = ion_nion_qm()

      if (notzero_enpack) then      
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.
     >           MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
         if (.not. value) 
     >     call errquit('ewald_e:out of stack memory',0,MA_ERR)
     
*        **** get the structure factor ****
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            call daxpy(2*enpack,dbl_mb(zv(1)+ion_katm(ii)-1),
     >             dcpl_mb(exi(1)),1,
     >             dcpl_mb(s(1)),1)
         end do

*        **** calculate the ewald energy ****
         call ewald_ct_Sqr(enpack,dcpl_mb(s(1)),dbl_mb(tmp3(1)))
         energy=2.0d0*ddot(enpack,dbl_mb(tmp3(1)),1,dbl_mb(vg(1)),1)
      else
         energy=0.0d0
      end if
      if (tnp.gt.1) call Parallel_SumAll(energy)
      energy  = 0.5d0*energy/lattice_omega() + cewald_qm

      
*     *** made parallel  ****
      dutask = 0
      etmp = 0.0d0
      do i=1,nion-1
      do j=i+1,nion
      if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = dbl_mb(zv(1)+ion_katm(i)-1)*dbl_mb(zv(1)+ion_katm(j)-1)
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+nshl3d)   + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           w = (r/rcut)
           yerfc = util_erfc(w)  !*** needs to be faster
           etmp=etmp+(zz*yerfc/r)
        end do
      end if
      dutask=mod(dutask+1,tnp)
      end do
      end do
      if (tnp.gt.1) call Parallel_SumAll(etmp)
      energy = energy + etmp
      

*     **** deallocate temp workspace ****
      if (notzero_enpack) then
         value =           MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >     call errquit('ewald_e:popping stack memory',0,MA_ERR)
      end if

      call nwpw_timing_end(21)
      ewald_e_qm = energy
      return
      end


*     ***********************************
*     *	        			*
*     *		ewald_f_qm		*
*     *		       			*
*     ***********************************

      subroutine ewald_f_qm(fion)
      implicit none
      real*8  fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)


*     **** local variables ****
      integer dutask
      integer i,j,l,ii
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  sum,scal2,f
      real*8  sw1,sw2,sw3,zii

*     **** temporary workspace variables ****
      integer nion
      integer exi(2),s(2),tmp3(2)
      integer fx(2),fy(2),fz(2)
      logical value

*     **** external functions ****
      integer  ion_nion_qm,ion_katm,ewald_nshl3d
      external ion_nion_qm,ion_katm,ewald_nshl3d
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot

      call nwpw_timing_start(21)
      nion = ion_nion_qm()

*     **** allocate temp workspace ****
      value = .true.
      if (notzero_enpack) then
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
      end if
      value = value.and.MA_push_get(mt_dbl,nion,'fx',fx(2),fx(1)) 
      value = value.and.MA_push_get(mt_dbl,nion,'fy',fy(2),fy(1)) 
      value = value.and.MA_push_get(mt_dbl,nion,'fz',fz(2),fz(1)) 
      if(.not.value) call errquit('ewald_f:out of stack',0,MA_ERR)


      scal2 = 1.0d0/lattice_omega()
      call dcopy(nion,0.0d0,0,dbl_mb(fx(1)),1)
      call dcopy(nion,0.0d0,0,dbl_mb(fy(1)),1)
      call dcopy(nion,0.0d0,0,dbl_mb(fz(1)),1)
     
*     **** get the structure factor ****
      if (notzero_enpack) then
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            call daxpy(2*enpack,zii,dcpl_mb(exi(1)),1,dcpl_mb(s(1)),1)
         end do
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))

c         do i=1,enpack
c            dbl_mb(tmp3(1)+i-1) 
c     >              = ( dble(dcpl_mb(exi(1)+i-1))
c     >                *dimag(dcpl_mb(s(1)+i-1))
c     >              -  dimag(dcpl_mb(exi(1)+i-1))
c     >                 *dble(dcpl_mb(s(1)+i-1))
c     >                )*dbl_mb(vg(1)+i-1)
c         end do
            call ewald_f_tmp3(enpack,
     >                        dcpl_mb(exi(1)),dcpl_mb(s(1)),
     >                        dbl_mb(vg(1)),dbl_mb(tmp3(1)))

            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            sum=2.0d0*ddot(enpack,dbl_mb(eG(1)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fx(1)+ii-1) = dbl_mb(fx(1)+ii-1) 
     >                         +  sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(2)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fy(1)+ii-1) = dbl_mb(fy(1)+ii-1) 
     >                         +  sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(3)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fz(1)+ii-1) = dbl_mb(fz(1)+ii-1) 
     >                         +  sum*zii*scal2
         end do
      end if
    
      dutask=0
      do i=1,nion-1
      do j=i+1,nion
       if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = ewald_zv(ion_katm(i)) * ewald_zv(ion_katm(j))
        sw1=0.0d0
        sw2=0.0d0
        sw3=0.0d0  
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+  nshl3d) + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           w = r/rcut
           yerfc = util_erfc(w)
           f = zz*(yerfc+cerfc*w*dexp(-w*w))/r**3
           sw1=sw1+(x*f)
           sw2=sw2+(y*f)
           sw3=sw3+(z*f)
        end do

        dbl_mb(fx(1)+i-1) = dbl_mb(fx(1)+i-1) + sw1
        dbl_mb(fy(1)+i-1) = dbl_mb(fy(1)+i-1) + sw2
        dbl_mb(fz(1)+i-1) = dbl_mb(fz(1)+i-1) + sw3

        dbl_mb(fx(1)+j-1) = dbl_mb(fx(1)+j-1) - sw1
        dbl_mb(fy(1)+j-1) = dbl_mb(fy(1)+j-1) - sw2
        dbl_mb(fz(1)+j-1) = dbl_mb(fz(1)+j-1) - sw3

       end if
       dutask = mod((dutask+1),tnp)
      end do
      end do
      if (tnp.gt.1) then
          call Parallel_Vector_SumAll(nion,dbl_mb(fx(1)))
          call Parallel_Vector_SumAll(nion,dbl_mb(fy(1)))
          call Parallel_Vector_SumAll(nion,dbl_mb(fz(1)))
      end if

      do i=1,nion
         fion(1,i) = fion(1,i) + dbl_mb(fx(1)+i-1)
         fion(2,i) = fion(2,i) + dbl_mb(fy(1)+i-1)
         fion(3,i) = fion(3,i) + dbl_mb(fz(1)+i-1)
      end do
      
*     **** deallocate temp workspace ****
      value =           MA_pop_stack(fz(2))
      value = value.and.MA_pop_stack(fy(2))
      value = value.and.MA_pop_stack(fx(2))
      if (notzero_enpack) then
         value = value.and.MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
      end if
      if (.not. value) 
     >  call errquit('ewald_f:popping stack memory',0,MA_ERR)

      call nwpw_timing_end(21)
      return
      end

*     ***********************************
*     *					*
*     *		ewald_stress_qm		*
*     *	        			*
*     ***********************************

      subroutine ewald_stress_qm(stress)
      implicit none
      real*8  stress(3,3)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

      integer N
      parameter (N=40)

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)

*     **** local variables ****
      logical value
      integer i,ii,j,l,nion
      integer n1,n2,n3
      integer u,v,s,dutask
      real*8 pi,fourpi,scal
      real*8 zz,z
      real*8 Cus(3,3),hm(3,3),energy,sum,ss,rs
      real*8 ea,ax,ay,az,epsilon
      real*8 dx,dy,dz,w,ar,ai
      real*8 unita(3,3),unitg(3,3)
      complex*16 cz
      integer H(2),F(2),tmp1(2),tmp2(2),exi(2),strf(2)

*     **** external functions ****
      integer  ion_katm,ion_nion_qm
      real*8   ewald_zv,lattice_unitg,lattice_unita,lattice_omega
      real*8   util_erfc,ion_rion,ddot
      external ion_katm,ion_nion_qm
      external ewald_zv,lattice_unitg,lattice_unita,lattice_omega
      external util_erfc,ion_rion,ddot

      call nwpw_timing_start(21)
      pi     = 4.0d0*datan(1.0d0)
      fourpi = 4.0d0*pi
      scal   = 1.0d0/(2.0d0*pi)
      nion    = ion_nion_qm()
*     *** define hm,unita,unitg ****
      do v=1,3
      do u=1,3
         hm(u,v) = scal*lattice_unitg(u,v)
         unitg(u,v) = lattice_unitg(u,v)
         unita(u,v) = lattice_unita(u,v)
      end do
      end do
 
      zz = 0.0d0
      z  = 0.0d0
      do i=1,nion
         zz = zz + dbl_mb(zv(1)+ion_katm(i)-1)**2
         z  = z  + dbl_mb(zv(1)+ion_katm(i)-1)
      end do

*     **** Miscellaneous contributions - stress from cewald_qm term ****
      do v=1,3
      do u=1,3
         stress(u,v) = 0.5d0*z*z*pi*rcut*rcut/lattice_omega()
     >               *hm(u,v)
      end do
      end do


*     **** G-space contributions ****
      if (notzero_enpack) then

*        **** get the structure factor ****
         value=          MA_push_get(mt_dbl,enpack,'H',H(2),H(1))
         value=value.and.MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1))
         value=value.and.
     >         MA_push_get(mt_dcpl,enpack,'strf',strf(2),strf(1))
         if (.not. value) 
     >     call errquit('ewald_stress:out of stack memory',0,MA_ERR)


         call dcopy((2*enpack),0.0d0,0,dcpl_mb(strf(1)),1)
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            call daxpy(2*enpack,ewald_zv(ion_katm(ii)),
     >                dcpl_mb(exi(1)),1,dcpl_mb(strf(1)),1)
         end do
         do i=1,enpack
             cz=dcpl_mb(strf(1)+i-1)
             ar=dble(cz)
             ai=dimag(cz)
             dbl_mb(H(1)+i-1)=ar*ar+ai*ai
         end do
         value =           MA_pop_stack(strf(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >    call errquit('ewald_stress:error popping stack',0,MA_ERR)

*        **** calculate the ewald energy ****
c         call dcopy(enpack,dbl_mb(vg(1)),1,dbl_mb(F(1)),1)
         F(1) = vg(1)
         energy=2.0d0*ddot(enpack,dbl_mb(F(1)),1,dbl_mb(H(1)),1)
      else
         energy=0.0d0
      end if
      if (tnp.gt.1) call Parallel_SumAll(energy)
      energy = -0.5d0*energy/lattice_omega()


      do v=1,3
      do u=1,3
         stress(u,v) = stress(u,v) + energy*hm(u,v)
      end do
      end do
     
*     **** tmp2(G) = F(G)*H(G)/G**2 + F(G)*H(G)*rcut*rcut/4 ****
      if (notzero_enpack) then
         value=MA_push_get(mt_dbl,enpack,'tmp1',tmp1(2),tmp1(1))
         value=value.and.
     >         MA_push_get(mt_dbl,enpack,'tmp2',tmp2(2),tmp2(1))
         if (.not.value) 
     >     call errquit('ewald_stress:out of stack memory',0,MA_ERR)

         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(F(1)+i-1)*dbl_mb(H(1)+i-1)
         end do
         ss = 0.25d0*rcut*rcut
         do i=1,enpack
            dbl_mb(tmp2(1)+i-1)=dbl_mb(tmp1(1)+i-1)*ss
         end do       
         ss = 1.0d0/fourpi
         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(tmp1(1)+i-1)*ss
         end do       
         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(tmp1(1)+i-1)*dbl_mb(vcx(1)+i-1)
         end do       
         do i=1,enpack
            dbl_mb(tmp2(1)+i-1)=dbl_mb(tmp2(1)+i-1)+dbl_mb(tmp1(1)+i-1)
         end do       
      end if

*     **** calculate Cus ****

      call dcopy(9,0.0d0,0,Cus,1)
      ss =  1.0d0/lattice_omega()
      if (notzero_enpack) then
         do u=1,3
         do s=u,3
            do i=1,enpack
               dbl_mb(tmp1(1)+i-1)=dbl_mb(eG(u)+i-1)*dbl_mb(eG(s)+i-1)
            end do
            sum=2.0d0*ddot(enpack,dbl_mb(tmp1(1)),1,dbl_mb(tmp2(1)),1)
            !if (tnp.gt.1) call Parallel_SumAll(sum)
            Cus(u,s) = ss*sum
         end do
         end do
c      do u=1,3
c      do s=u+1,3
c         Cus(s,u) = Cus(u,s)
c      end do
c      end do
c      do v=1,3
c      do u=1,3
c        do s=1,3
c           stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
c        end do
c      end do
c      end do

         value =           MA_pop_stack(tmp2(2))
         value = value.and.MA_pop_stack(tmp1(2))
         value = value.and.MA_Pop_stack(H(2))
         if (.not.value) 
     >    call errquit(
     >         'ewald_stress:error popping stack memory',0,MA_ERR)
      end if

*     **** R-space contributions ****

*     **** calculate alpha1 - stress from cewald_qm term*****
c        call dcopy(9,0.0d0,0,Cus,1)
        rs      = (3.0d0*lattice_omega()/(4.0d0*pi))**(1.0d0/3.0d0)
        epsilon = 1.0d0/rcut
        sum = 0.0d0
        dutask = 0
        do n1=(-N+1),(N-1) 
        do n2=(-N+1),(N-1) 
        do n3=(-N+1),(N-1) 
           if (dutask.eq.tid) then
           if (.not.((n1.eq.0).and.(n2.eq.0).and.(n3.eq.0))) then
              ax = n1*unita(1,1)
     >           + n2*unita(1,2)
     >           + n3*unita(1,3)

              ay = n1*unita(2,1)
     >           + n2*unita(2,2)
     >           + n3*unita(2,3)

              az = n1*unita(3,1)
     >           + n2*unita(3,2)
     >           + n3*unita(3,3)

              ea = dsqrt(ax*ax + ay*ay + az*az)
              w = ea*epsilon

              ss = util_erfc(w)/ea 
     >           + 2.0d0*epsilon/dsqrt(pi)*dexp(-w*w)
              ss = -(0.5d0*zz)*ss/(ea*ea)
              Cus(1,1) = Cus(1,1) + ss * ax*ax 
              Cus(1,2) = Cus(1,2) + ss * ax*ay 
              Cus(1,3) = Cus(1,3) + ss * ax*az 

              !Cus(2,1) = Cus(2,1) + ss * ay*ax 
              Cus(2,2) = Cus(2,2) + ss * ay*ay 
              Cus(2,3) = Cus(2,3) + ss * ay*az 

              !Cus(3,1) = Cus(3,1) + ss * az*ax 
              !Cus(3,2) = Cus(3,2) + ss * az*ay 
              Cus(3,3) = Cus(3,3) + ss * az*az 

           end if
           end if
           dutask=mod(dutask+1,tnp)
        end do
        end do
        end do


c        do v=1,3
c        do u=1,3
c          do s=1,3
c             stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
c          end do
c        end do
c        end do


*     **** calculate erfc contribution *****
c      call dcopy(9,0.0d0,0,Cus,1)
      epsilon = 1.0d0/rcut
      dutask=0
      do i=1,nion-1
      do j=i+1,nion
        if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = ewald_zv(ion_katm(i)) * ewald_zv(ion_katm(j))
        do l=1,nshl3d
           ax = dbl_mb(rcell(1)+(l-1))          + dx
           ay = dbl_mb(rcell(1)+(l-1)+nshl3d)   + dy
           az = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           ea = dsqrt(ax*ax+ay*ay+az*az)
           w = ea*epsilon

           ss = -util_erfc(w)/ea
     >        - 2.0d0*epsilon/dsqrt(pi)*exp(-w*w)
           ss = ss/(ea*ea)
           Cus(1,1) = Cus(1,1) + ss * ax*ax * zz
           Cus(1,2) = Cus(1,2) + ss * ax*ay * zz
           Cus(1,3) = Cus(1,3) + ss * ax*az * zz
           Cus(2,2) = Cus(2,2) + ss * ay*ay * zz
           Cus(2,3) = Cus(2,3) + ss * ay*az * zz
           Cus(3,3) = Cus(3,3) + ss * az*az * zz
        end do
        end if
        dutask=mod(dutask+1,tnp)
      end do
      end do

      if (tnp.gt.1) then
        call Parallel_Vector_SumAll(9,Cus(1,1))
      end if

      do u=1,3
        do s=u+1,3
           Cus(s,u) = Cus(u,s)
        end do
      end do

      do v=1,3
        do u=1,3
          do s=1,3
             stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
          end do
        end do
      end do

      call nwpw_timing_end(21)
      return
      end

*     ***********************************
*     *			  		*
*     *		ewald_e_mm		*
*     *				       	*
*     ***********************************
      real*8 function ewald_e_mm()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     **** local variables ****
      integer dutask
      integer i,j,ii,l,nion,nion_qm,nion_mm
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  energy,etmp,energyG,ttcr,ttci,zii
      complex*16 ttcz
*     **** temporary workspace variables ****
      integer exi(2),s(2),tmp3(2)
      logical value

*     **** external functions ****
      integer  ion_nion,ion_nion_qm,ion_nion_mm,ion_katm
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc
      real*8   ddot
      external ion_nion,ion_nion_qm,ion_nion_mm,ion_katm
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc
      external ddot

      call nwpw_timing_start(21)

*     **** allocate temp workspace ****
      nion    = ion_nion()
      nion_qm = ion_nion_qm()
      nion_mm = ion_nion_mm()
      
      if (notzero_enpack) then
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.
     >           MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
         if (.not. value) 
     >     call errquit('ewald_e:out of stack memory',0,MA_ERR)
     
*        **** get the structure factor ****
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion_mm
            call ewald_strfac(nion_qm+ii,dcpl_mb(exi(1)))
            call daxpy(2*enpack,dbl_mb(zv(1)+ion_katm(nion_qm+ii)-1),
     >             dcpl_mb(exi(1)),1,
     >             dcpl_mb(s(1)),1)
         end do

*        **** calculate the ewald energy ****
         call ewald_ct_Sqr(enpack,dcpl_mb(s(1)),dbl_mb(tmp3(1)))
         energy=2.0d0*ddot(enpack,dbl_mb(tmp3(1)),1,dbl_mb(vg(1)),1)
      else
         energy=0.0d0
      end if
      if (tnp.gt.1) call Parallel_SumAll(energy)
      energy  = 0.5d0*energy/lattice_omega() + cewald_qm

      
*     *** made parallel  ****
      dutask = 0
      etmp = 0.0d0
      do i=1,nion_mm-1
      do j=i+1,nion_mm
      if (dutask.eq.tid) then
        dx = ion_rion(1,nion_qm+i) - ion_rion(1,nion_qm+j)
        dy = ion_rion(2,nion_qm+i) - ion_rion(2,nion_qm+j)
        dz = ion_rion(3,nion_qm+i) - ion_rion(3,nion_qm+j)
        zz = dbl_mb(zv(1)+ion_katm(nion_qm+i)-1)
     >      *dbl_mb(zv(1)+ion_katm(nion_qm+j)-1)
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+nshl3d)   + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           w = (r/rcut)
           yerfc = util_erfc(w)  !*** needs to be faster
           etmp=etmp+(zz*yerfc/r)
        end do
      end if
      dutask=mod(dutask+1,tnp)
      end do
      end do
      if (tnp.gt.1) call Parallel_SumAll(etmp)
      energy = energy + etmp
      

*     **** deallocate temp workspace ****
      if (notzero_enpack) then
         value =           MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >     call errquit('ewald_e:popping stack memory',0,MA_ERR)
      end if

      call nwpw_timing_end(21)
      ewald_e_mm = energy
      return
      end


*     ***********************************
*     *	        			*
*     *		ewald_f_mm		*
*     *		       			*
*     ***********************************

      subroutine ewald_f_mm(fion)
      implicit none
      real*8  fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)


*     **** local variables ****
      integer dutask
      integer i,j,l,ii
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  sum,scal2,f
      real*8  sw1,sw2,sw3,zii

*     **** temporary workspace variables ****
      integer nion,nion_qm,nion_mm
      integer exi(2),s(2),tmp3(2)
      integer fx(2),fy(2),fz(2)
      logical value

*     **** external functions ****
      integer  ion_nion,ion_nion_qm,ion_nion_mm,ion_katm,ewald_nshl3d
      external ion_nion,ion_nion_qm,ion_nion_mm,ion_katm,ewald_nshl3d
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot

      call nwpw_timing_start(21)
      nion    = ion_nion()
      nion_qm = ion_nion_qm()
      nion_mm = ion_nion_mm()

*     **** allocate temp workspace ****
      value = .true.
      if (notzero_enpack) then
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
      end if
      value = value.and.MA_push_get(mt_dbl,nion_mm,'fx',fx(2),fx(1)) 
      value = value.and.MA_push_get(mt_dbl,nion_mm,'fy',fy(2),fy(1)) 
      value = value.and.MA_push_get(mt_dbl,nion_mm,'fz',fz(2),fz(1)) 
      if(.not.value) call errquit('ewald_f:out of stack',0,MA_ERR)


      scal2 = 1.0d0/lattice_omega()
      call dcopy(nion_mm,0.0d0,0,dbl_mb(fx(1)),1)
      call dcopy(nion_mm,0.0d0,0,dbl_mb(fy(1)),1)
      call dcopy(nion_mm,0.0d0,0,dbl_mb(fz(1)),1)
     
*     **** get the structure factor ****
      if (notzero_enpack) then
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion_mm
            call ewald_strfac(nion_qm+ii,dcpl_mb(exi(1)))
            zii=dbl_mb(zv(1)+ion_katm(nion_qm+ii)-1)
            call daxpy(2*enpack,zii,dcpl_mb(exi(1)),1,dcpl_mb(s(1)),1)
         end do
         do ii=1,nion_mm
            call ewald_strfac(nion_qm+ii,dcpl_mb(exi(1)))
   
            call ewald_f_tmp3(enpack,
     >                        dcpl_mb(exi(1)),dcpl_mb(s(1)),
     >                        dbl_mb(vg(1)),dbl_mb(tmp3(1)))

            zii=dbl_mb(zv(1)+ion_katm(nion_qm+ii)-1)
            sum=2.0d0*ddot(enpack,dbl_mb(eG(1)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fx(1)+ii-1) = dbl_mb(fx(1)+ii-1) 
     >                         +  sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(2)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fy(1)+ii-1) = dbl_mb(fy(1)+ii-1) 
     >                         +  sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(3)),1,dbl_mb(tmp3(1)),1)
            dbl_mb(fz(1)+ii-1) = dbl_mb(fz(1)+ii-1) 
     >                         +  sum*zii*scal2
         end do
      end if
    
      dutask=0
      do i=1,nion_mm-1
      do j=i+1,nion_mm
       if (dutask.eq.tid) then
        dx = ion_rion(1,nion_qm+i) - ion_rion(1,nion_qm+j)
        dy = ion_rion(2,nion_qm+i) - ion_rion(2,nion_qm+j)
        dz = ion_rion(3,nion_qm+i) - ion_rion(3,nion_qm+j)
        zz = ewald_zv(ion_katm(nion_qm+i))*ewald_zv(ion_katm(nion_qm+j))
        sw1=0.0d0
        sw2=0.0d0
        sw3=0.0d0  
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+  nshl3d) + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           w = r/rcut
           yerfc = util_erfc(w)
           f = zz*(yerfc+cerfc*w*dexp(-w*w))/r**3
           sw1=sw1+(x*f)
           sw2=sw2+(y*f)
           sw3=sw3+(z*f)
        end do

        dbl_mb(fx(1)+i-1) = dbl_mb(fx(1)+i-1) + sw1
        dbl_mb(fy(1)+i-1) = dbl_mb(fy(1)+i-1) + sw2
        dbl_mb(fz(1)+i-1) = dbl_mb(fz(1)+i-1) + sw3

        dbl_mb(fx(1)+j-1) = dbl_mb(fx(1)+j-1) - sw1
        dbl_mb(fy(1)+j-1) = dbl_mb(fy(1)+j-1) - sw2
        dbl_mb(fz(1)+j-1) = dbl_mb(fz(1)+j-1) - sw3

       end if
       dutask = mod((dutask+1),tnp)
      end do
      end do
      if (tnp.gt.1) then
          call Parallel_Vector_SumAll(nion_mm,dbl_mb(fx(1)))
          call Parallel_Vector_SumAll(nion_mm,dbl_mb(fy(1)))
          call Parallel_Vector_SumAll(nion_mm,dbl_mb(fz(1)))
      end if

      do i=1,nion_mm
         fion(1,nion_qm+i) = fion(1,nion_qm+i) + dbl_mb(fx(1)+i-1)
         fion(2,nion_qm+i) = fion(2,nion_qm+i) + dbl_mb(fy(1)+i-1)
         fion(3,nion_qm+i) = fion(3,nion_qm+i) + dbl_mb(fz(1)+i-1)
      end do
      
*     **** deallocate temp workspace ****
      value =           MA_pop_stack(fz(2))
      value = value.and.MA_pop_stack(fy(2))
      value = value.and.MA_pop_stack(fx(2))
      if (notzero_enpack) then
         value = value.and.MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
      end if
      if (.not. value) 
     >  call errquit('ewald_f:popping stack memory',0,MA_ERR)

      call nwpw_timing_end(21)
      return
      end

*     ***********************************
*     *					*
*     *		ewald_stress_mm		*
*     *	        			*
*     ***********************************

      subroutine ewald_stress_mm(stress)
      implicit none
      real*8  stress(3,3)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

      integer N
      parameter (N=40)

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)

*     **** local variables ****
      logical value
      integer i,ii,j,l,nion,nion_qm,nion_mm
      integer n1,n2,n3
      integer u,v,s,dutask
      real*8 pi,fourpi,scal
      real*8 zz,z
      real*8 Cus(3,3),hm(3,3),energy,sum,ss,rs
      real*8 ea,ax,ay,az,epsilon
      real*8 dx,dy,dz,w,ar,ai
      real*8 unita(3,3),unitg(3,3)
      complex*16 cz
      integer H(2),F(2),tmp1(2),tmp2(2),exi(2),strf(2)

*     **** external functions ****
      integer  ion_katm,ion_nion,ion_nion_qm,ion_nion_mm
      real*8   ewald_zv,lattice_unitg,lattice_unita,lattice_omega
      real*8   util_erfc,ion_rion,ddot
      external ion_katm,ion_nion,ion_nion_qm,ion_nion_mm
      external ewald_zv,lattice_unitg,lattice_unita,lattice_omega
      external util_erfc,ion_rion,ddot

      call nwpw_timing_start(21)
      pi     = 4.0d0*datan(1.0d0)
      fourpi = 4.0d0*pi
      scal   = 1.0d0/(2.0d0*pi)
      nion    = ion_nion()
      nion_qm = ion_nion_qm()
      nion_mm = ion_nion_mm()
*     *** define hm,unita,unitg ****
      do v=1,3
      do u=1,3
         hm(u,v) = scal*lattice_unitg(u,v)
         unitg(u,v) = lattice_unitg(u,v)
         unita(u,v) = lattice_unita(u,v)
      end do
      end do
 
      zz = 0.0d0
      z  = 0.0d0
      do i=1,nion_mm
         zz = zz + dbl_mb(zv(1)+ion_katm(nion_qm+i)-1)**2
         z  = z  + dbl_mb(zv(1)+ion_katm(nion_qm+i)-1)
      end do

*     **** Miscellaneous contributions - stress from cewald_qm term ****
      do v=1,3
      do u=1,3
         stress(u,v) = 0.5d0*z*z*pi*rcut*rcut/lattice_omega()
     >               *hm(u,v)
      end do
      end do


*     **** G-space contributions ****

*     **** get the structure factor ****
      if (notzero_enpack) then
         value=MA_push_get(mt_dbl,enpack,'H',H(2),H(1))
         value=value.and.MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1))
         value=value.and.
     >         MA_push_get(mt_dcpl,enpack,'strf',strf(2),strf(1))
         if (.not. value) 
     >     call errquit('ewald_stress:out of stack memory',0,MA_ERR)


         call dcopy((2*enpack),0.0d0,0,dcpl_mb(strf(1)),1)
         do ii=1,nion_mm
            call ewald_strfac(nion_qm+ii,dcpl_mb(exi(1)))
            call daxpy(2*enpack,ewald_zv(ion_katm(nion_qm+ii)),
     >                dcpl_mb(exi(1)),1,
     >                dcpl_mb(strf(1)),1)
         end do
         do i=1,enpack
             cz=dcpl_mb(strf(1)+i-1)
             ar=dble(cz)
             ai=dimag(cz)
             dbl_mb(H(1)+i-1)=ar*ar+ai*ai
         end do
         value =           MA_pop_stack(strf(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >    call errquit('ewald_stress:error popping stack',0,MA_ERR)

*        **** calculate the ewald energy ****
c         call dcopy(enpack,dbl_mb(vg(1)),1,dbl_mb(F(1)),1)
         F(1) = vg(1)
         energy=2.0d0*ddot(enpack,dbl_mb(F(1)),1,dbl_mb(H(1)),1)
      else
         energy=0.0d0
      end if
      if (tnp.gt.1) call Parallel_SumAll(energy)
      energy = -0.5d0*energy/lattice_omega()


      do v=1,3
      do u=1,3
         stress(u,v) = stress(u,v) + energy*hm(u,v)
      end do
      end do
     
*     **** tmp2(G) = F(G)*H(G)/G**2 + F(G)*H(G)*rcut*rcut/4 ****
      if (notzero_enpack) then
         value=MA_push_get(mt_dbl,enpack,'tmp1',tmp1(2),tmp1(1))
         value=value.and.
     >         MA_push_get(mt_dbl,enpack,'tmp2',tmp2(2),tmp2(1))
         if (.not.value) 
     >     call errquit('ewald_stress:out of stack memory',0,MA_ERR)

         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(F(1)+i-1)*dbl_mb(H(1)+i-1)
         end do
         ss = 0.25d0*rcut*rcut
         do i=1,enpack
            dbl_mb(tmp2(1)+i-1)=dbl_mb(tmp1(1)+i-1)*ss
         end do       
         ss = 1.0d0/fourpi
         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(tmp1(1)+i-1)*ss
         end do       
         do i=1,enpack
            dbl_mb(tmp1(1)+i-1)=dbl_mb(tmp1(1)+i-1)*dbl_mb(vcx(1)+i-1)
         end do       
         do i=1,enpack
            dbl_mb(tmp2(1)+i-1)=dbl_mb(tmp2(1)+i-1)+dbl_mb(tmp1(1)+i-1)
         end do       
      end if

*     **** calculate Cus ****

      call dcopy(9,0.0d0,0,Cus,1)
      ss =  1.0d0/lattice_omega()
      if (notzero_enpack) then
         do u=1,3
         do s=u,3
            do i=1,enpack
               dbl_mb(tmp1(1)+i-1)=dbl_mb(eG(u)+i-1)*dbl_mb(eG(s)+i-1)
            end do
            sum=2.0d0*ddot(enpack,dbl_mb(tmp1(1)),1,dbl_mb(tmp2(1)),1)
            !if (tnp.gt.1) call Parallel_SumAll(sum)
            Cus(u,s) = ss*sum
         end do
         end do
c      do u=1,3
c      do s=u+1,3
c         Cus(s,u) = Cus(u,s)
c      end do
c      end do
c      do v=1,3
c      do u=1,3
c        do s=1,3
c           stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
c        end do
c      end do
c      end do

         value =           MA_pop_stack(tmp2(2))
         value = value.and.MA_pop_stack(tmp1(2))
         value = value.and.MA_Pop_stack(H(2))
         if (.not.value) 
     >    call errquit(
     >         'ewald_stress:error popping stack memory',0,MA_ERR)
      end if

*     **** R-space contributions ****

*     **** calculate alpha1 - stress from cewald_qm term*****
c        call dcopy(9,0.0d0,0,Cus,1)
        rs      = (3.0d0*lattice_omega()/(4.0d0*pi))**(1.0d0/3.0d0)
        epsilon = 1.0d0/rcut
        sum = 0.0d0
        dutask = 0
        do n1=(-N+1),(N-1) 
        do n2=(-N+1),(N-1) 
        do n3=(-N+1),(N-1) 
           if (dutask.eq.tid) then
           if (.not.((n1.eq.0).and.(n2.eq.0).and.(n3.eq.0))) then
              ax = n1*unita(1,1)
     >           + n2*unita(1,2)
     >           + n3*unita(1,3)

              ay = n1*unita(2,1)
     >           + n2*unita(2,2)
     >           + n3*unita(2,3)

              az = n1*unita(3,1)
     >           + n2*unita(3,2)
     >           + n3*unita(3,3)

              ea = dsqrt(ax*ax + ay*ay + az*az)
              w = ea*epsilon

              ss = util_erfc(w)/ea 
     >           + 2.0d0*epsilon/dsqrt(pi)*dexp(-w*w)
              ss = -(0.5d0*zz)*ss/(ea*ea)
              Cus(1,1) = Cus(1,1) + ss * ax*ax 
              Cus(1,2) = Cus(1,2) + ss * ax*ay 
              Cus(1,3) = Cus(1,3) + ss * ax*az 

              !Cus(2,1) = Cus(2,1) + ss * ay*ax 
              Cus(2,2) = Cus(2,2) + ss * ay*ay 
              Cus(2,3) = Cus(2,3) + ss * ay*az 

              !Cus(3,1) = Cus(3,1) + ss * az*ax 
              !Cus(3,2) = Cus(3,2) + ss * az*ay 
              Cus(3,3) = Cus(3,3) + ss * az*az 

           end if
           end if
           dutask=mod(dutask+1,tnp)
        end do
        end do
        end do


c        do v=1,3
c        do u=1,3
c          do s=1,3
c             stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
c          end do
c        end do
c        end do


*     **** calculate erfc contribution *****
c      call dcopy(9,0.0d0,0,Cus,1)
      epsilon = 1.0d0/rcut
      dutask=0
      do i=1,nion_mm-1
      do j=i+1,nion_mm
        if (dutask.eq.tid) then
        dx = ion_rion(1,nion_qm+i) - ion_rion(1,nion_qm+j)
        dy = ion_rion(2,nion_qm+i) - ion_rion(2,nion_qm+j)
        dz = ion_rion(3,nion_qm+i) - ion_rion(3,nion_qm+j)
        zz = ewald_zv(ion_katm(nion_qm+i))*ewald_zv(ion_katm(nion_qm+j))
        do l=1,nshl3d
           ax = dbl_mb(rcell(1)+(l-1))          + dx
           ay = dbl_mb(rcell(1)+(l-1)+nshl3d)   + dy
           az = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           ea = dsqrt(ax*ax+ay*ay+az*az)
           w = ea*epsilon

           ss = -util_erfc(w)/ea
     >        - 2.0d0*epsilon/dsqrt(pi)*exp(-w*w)
           ss = ss/(ea*ea)
           Cus(1,1) = Cus(1,1) + ss * ax*ax * zz
           Cus(1,2) = Cus(1,2) + ss * ax*ay * zz
           Cus(1,3) = Cus(1,3) + ss * ax*az * zz
           Cus(2,2) = Cus(2,2) + ss * ay*ay * zz
           Cus(2,3) = Cus(2,3) + ss * ay*az * zz
           Cus(3,3) = Cus(3,3) + ss * az*az * zz
        end do
        end if
        dutask=mod(dutask+1,tnp)
      end do
      end do

      if (tnp.gt.1) then
        call Parallel_Vector_SumAll(9,Cus(1,1))
      end if

      do u=1,3
        do s=u+1,3
           Cus(s,u) = Cus(u,s)
        end do
      end do

      do v=1,3
        do u=1,3
          do s=1,3
             stress(u,v) = stress(u,v) + Cus(u,s)*hm(s,v)
          end do
        end do
      end do

      call nwpw_timing_end(21)
      return
      end


*     ***********************************
*     *	        			*
*     *		ewald_f_async		*
*     *		       			*
*     ***********************************

      subroutine ewald_f_async(fion)
      implicit none
      real*8  fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)


*     **** local variables ****
      integer dutask
      integer i,j,l,ii
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  sum,scal2,f
      real*8  sw1,sw2,sw3,zii

*     **** temporary workspace variables ****
      integer nion
      integer exi(2),s(2),tmp3(2)
      logical value

*     **** external functions ****
      integer  ion_nion,ion_katm,ewald_nshl3d
      external ion_nion,ion_katm,ewald_nshl3d
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot

      call nwpw_timing_start(21)
      nion = ion_nion()
      scal2 = 1.0d0/lattice_omega()

*     **** allocate temp workspace ****
      if (notzero_enpack) then
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
         if(.not.value) call errquit('ewald_f:out of stack',0,MA_ERR)

*        **** get the structure factor ****
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            call daxpy(2*enpack,zii,dcpl_mb(exi(1)),1,dcpl_mb(s(1)),1)
         end do
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))

c         do i=1,enpack
c            dbl_mb(tmp3(1)+i-1) 
c     >              = ( dble(dcpl_mb(exi(1)+i-1))
c     >                *dimag(dcpl_mb(s(1)+i-1))
c     >              -  dimag(dcpl_mb(exi(1)+i-1))
c     >                 *dble(dcpl_mb(s(1)+i-1))
c     >                )*dbl_mb(vg(1)+i-1)
c         end do
            call ewald_f_tmp3(enpack,
     >                        dcpl_mb(exi(1)),dcpl_mb(s(1)),
     >                        dbl_mb(vg(1)),dbl_mb(tmp3(1)))

            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            sum=2.0d0*ddot(enpack,dbl_mb(eG(1)),1,dbl_mb(tmp3(1)),1)
            fion(1,ii) = fion(1,ii) + sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(2)),1,dbl_mb(tmp3(1)),1)
            fion(2,ii) = fion(2,ii) + sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(3)),1,dbl_mb(tmp3(1)),1)
            fion(3,ii) = fion(3,ii) + sum*zii*scal2
         end do
      end if
    
      dutask=0
      do i=1,nion-1
      do j=i+1,nion
       if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = ewald_zv(ion_katm(i)) * ewald_zv(ion_katm(j))
        sw1=0.0d0
        sw2=0.0d0
        sw3=0.0d0  
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+  nshl3d) + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           if (r.gt.1.0d-6) then
              w = r/rcut
              yerfc = util_erfc(w)
              f = zz*(yerfc+cerfc*w*dexp(-w*w))/r**3
              sw1=sw1+(x*f)
              sw2=sw2+(y*f)
              sw3=sw3+(z*f)
           end if
        end do

        fion(1,i) = fion(1,i) + sw1
        fion(2,i) = fion(2,i) + sw2
        fion(3,i) = fion(3,i) + sw3

        fion(1,j) = fion(1,j) - sw1
        fion(2,j) = fion(2,j) - sw2
        fion(3,j) = fion(3,j) - sw3

       end if
       dutask = mod((dutask+1),tnp)
      end do
      end do

      
*     **** deallocate temp workspace ****
      if (notzero_enpack) then
         value =           MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >     call errquit('ewald_f_async:popping stack memory',0,MA_ERR)
      end if

      call nwpw_timing_end(21)
      return
      end


*     ***********************************
*     *	        			*
*     *		ewald_f_qm_async	*
*     *		       			*
*     ***********************************

      subroutine ewald_f_qm_async(fion)
      implicit none
      real*8  fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)


*     **** local variables ****
      integer dutask
      integer i,j,l,ii
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  sum,scal2,f
      real*8  sw1,sw2,sw3,zii

*     **** temporary workspace variables ****
      integer nion
      integer exi(2),s(2),tmp3(2)
      logical value

*     **** external functions ****
      integer  ion_nion_qm,ion_katm,ewald_nshl3d
      external ion_nion_qm,ion_katm,ewald_nshl3d
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot

      call nwpw_timing_start(21)
      nion = ion_nion_qm()
      scal2 = 1.0d0/lattice_omega()

*     **** allocate temp workspace ****
      if (notzero_enpack) then
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
         if(.not.value) call errquit('ewald_f:out of stack',0,MA_ERR)

*        **** get the structure factor ****
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))
            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            call daxpy(2*enpack,zii,dcpl_mb(exi(1)),1,dcpl_mb(s(1)),1)
         end do
         do ii=1,nion
            call ewald_strfac(ii,dcpl_mb(exi(1)))

c         do i=1,enpack
c            dbl_mb(tmp3(1)+i-1) 
c     >              = ( dble(dcpl_mb(exi(1)+i-1))
c     >                *dimag(dcpl_mb(s(1)+i-1))
c     >              -  dimag(dcpl_mb(exi(1)+i-1))
c     >                 *dble(dcpl_mb(s(1)+i-1))
c     >                )*dbl_mb(vg(1)+i-1)
c         end do
            call ewald_f_tmp3(enpack,
     >                        dcpl_mb(exi(1)),dcpl_mb(s(1)),
     >                        dbl_mb(vg(1)),dbl_mb(tmp3(1)))

            zii=dbl_mb(zv(1)+ion_katm(ii)-1)
            sum=2.0d0*ddot(enpack,dbl_mb(eG(1)),1,dbl_mb(tmp3(1)),1)
            fion(1,ii) = fion(1,ii) + sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(2)),1,dbl_mb(tmp3(1)),1)
            fion(2,ii) = fion(2,ii) + sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(3)),1,dbl_mb(tmp3(1)),1)
            fion(3,ii) = fion(3,ii) + sum*zii*scal2
         end do
      end if
    
      dutask=0
      do i=1,nion-1
      do j=i+1,nion
       if (dutask.eq.tid) then
        dx = ion_rion(1,i) - ion_rion(1,j)
        dy = ion_rion(2,i) - ion_rion(2,j)
        dz = ion_rion(3,i) - ion_rion(3,j)
        zz = ewald_zv(ion_katm(i)) * ewald_zv(ion_katm(j))
        sw1=0.0d0
        sw2=0.0d0
        sw3=0.0d0  
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+  nshl3d) + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           w = r/rcut
           yerfc = util_erfc(w)
           f = zz*(yerfc+cerfc*w*dexp(-w*w))/r**3
           sw1=sw1+(x*f)
           sw2=sw2+(y*f)
           sw3=sw3+(z*f)
        end do

        fion(1,i) = fion(1,i) + sw1
        fion(2,i) = fion(2,i) + sw2
        fion(3,i) = fion(3,i) + sw3

        fion(1,j) = fion(1,j) - sw1
        fion(2,j) = fion(2,j) - sw2
        fion(3,j) = fion(3,j) - sw3

       end if
       dutask = mod((dutask+1),tnp)
      end do
      end do

      
*     **** deallocate temp workspace ****
      if (notzero_enpack) then
         value =           MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >     call errquit('ewald_f:popping stack memory',0,MA_ERR)
      end if

      call nwpw_timing_end(21)
      return
      end


*     ***********************************
*     *	        			*
*     *		ewald_f_mm_async	*
*     *		       			*
*     ***********************************

      subroutine ewald_f_mm_async(fion)
      implicit none
      real*8  fion(3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     ****  expansion coefficient of the error function ****
      real*8 cerfc
      parameter (cerfc=1.128379167d0)


*     **** local variables ****
      integer dutask
      integer i,j,l,ii
      real*8  w,dx,dy,dz,x,y,z,r,zz
      real*8  yerfc
      real*8  sum,scal2,f
      real*8  sw1,sw2,sw3,zii

*     **** temporary workspace variables ****
      integer nion,nion_qm,nion_mm
      integer exi(2),s(2),tmp3(2)
      logical value

*     **** external functions ****
      integer  ion_nion,ion_nion_qm,ion_nion_mm,ion_katm,ewald_nshl3d
      external ion_nion,ion_nion_qm,ion_nion_mm,ion_katm,ewald_nshl3d
      real*8   lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot
      external lattice_omega,ewald_zv,dsum,ion_rion,util_erfc,ddot

      call nwpw_timing_start(21)
      nion    = ion_nion()
      nion_qm = ion_nion_qm()
      nion_mm = ion_nion_mm()
      scal2 = 1.0d0/lattice_omega()

*     **** allocate temp workspace ****
      if (notzero_enpack) then
         value = MA_push_get(mt_dcpl,enpack,'exi',exi(2),exi(1)) 
         value = value.and.MA_push_get(mt_dcpl,enpack,'s',s(2),s(1)) 
         value = value.and.
     >           MA_push_get(mt_dbl, enpack,'tmp3',tmp3(2),tmp3(1)) 
         if(.not.value) call errquit('ewald_f:out of stack',0,MA_ERR)
     
*        **** get the structure factor ****
         call dcopy((2*enpack),0.0d0,0,dcpl_mb(s(1)),1)
         do ii=1,nion_mm
            call ewald_strfac(nion_qm+ii,dcpl_mb(exi(1)))
            zii=dbl_mb(zv(1)+ion_katm(nion_qm+ii)-1)
            call daxpy(2*enpack,zii,dcpl_mb(exi(1)),1,dcpl_mb(s(1)),1)
         end do
         do ii=1,nion_mm
            call ewald_strfac(nion_qm+ii,dcpl_mb(exi(1)))
   
            call ewald_f_tmp3(enpack,
     >                        dcpl_mb(exi(1)),dcpl_mb(s(1)),
     >                        dbl_mb(vg(1)),dbl_mb(tmp3(1)))

            zii=dbl_mb(zv(1)+ion_katm(nion_qm+ii)-1)
            sum=2.0d0*ddot(enpack,dbl_mb(eG(1)),1,dbl_mb(tmp3(1)),1)
            fion(1,nion_qm+ii) = fion(1,nion_qm+ii) + sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(2)),1,dbl_mb(tmp3(1)),1)
            fion(2,nion_qm+ii) = fion(2,nion_qm+ii) + sum*zii*scal2
            sum=2.0d0*ddot(enpack,dbl_mb(eG(3)),1,dbl_mb(tmp3(1)),1)
            fion(3,nion_qm+ii) = fion(3,nion_qm+ii) + sum*zii*scal2
         end do
      end if
    
      dutask=0
      do i=1,nion_mm-1
      do j=i+1,nion_mm
       if (dutask.eq.tid) then
        dx = ion_rion(1,nion_qm+i) - ion_rion(1,nion_qm+j)
        dy = ion_rion(2,nion_qm+i) - ion_rion(2,nion_qm+j)
        dz = ion_rion(3,nion_qm+i) - ion_rion(3,nion_qm+j)
        zz = ewald_zv(ion_katm(nion_qm+i))*ewald_zv(ion_katm(nion_qm+j))
        sw1=0.0d0
        sw2=0.0d0
        sw3=0.0d0  
        do l=1,nshl3d
           x = dbl_mb(rcell(1)+(l-1))          + dx
           y = dbl_mb(rcell(1)+(l-1)+  nshl3d) + dy
           z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
           r = dsqrt(x*x+y*y+z*z)
           w = r/rcut
           yerfc = util_erfc(w)
           f = zz*(yerfc+cerfc*w*dexp(-w*w))/r**3
           sw1=sw1+(x*f)
           sw2=sw2+(y*f)
           sw3=sw3+(z*f)
        end do

        fion(1,nion_qm+i) = fion(1,nion_qm+i) + sw1
        fion(2,nion_qm+i) = fion(2,nion_qm+i) + sw2
        fion(3,nion_qm+i) = fion(3,nion_qm+i) + sw3

        fion(1,nion_qm+j) = fion(1,nion_qm+j) - sw1
        fion(2,nion_qm+j) = fion(2,nion_qm+j) - sw2
        fion(3,nion_qm+j) = fion(3,nion_qm+j) - sw3

       end if
       dutask = mod((dutask+1),tnp)
      end do
      end do

*     **** deallocate temp workspace ****
      if (notzero_enpack) then
         value =           MA_pop_stack(tmp3(2))
         value = value.and.MA_pop_stack(s(2))
         value = value.and.MA_pop_stack(exi(2))
         if (.not. value) 
     >     call errquit('ewald_f:popping stack memory',0,MA_ERR)
      end if

      call nwpw_timing_end(21)
      return
      end




*     ***********************************
*     *	        			*
*     *		ewald_efg		*
*     *		       			*
*     ***********************************

      subroutine ewald_efg(efg_ion)
      implicit none
      real*8  efg_ion(3,3,*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "ewald.fh"

*     **** local variables ****
      integer dutask
      integer ii,jj,kk,l,k,u,v,nion
      real*8  w,dx,dy,dz,x,y,z,r,qj
      real*8  yerfc,kfac
      real*8  aconst,bconst,scal2,sqrt_pi
      integer mu,nu
      real*8  gvec(3),gg,phase,cosphase
      real*8  rji(3),termgg,pi,expfac

*     **** external functions ****
      integer  ion_nion,ion_katm,ewald_nshl3d
      external ion_nion,ion_katm,ewald_nshl3d
      real*8   lattice_omega,ewald_zv,ion_rion,util_erfc
      external lattice_omega,ewald_zv,ion_rion,util_erfc

*     **** preliminaries ****
      call nwpw_timing_start(21)
      nion = ion_nion()
      sqrt_pi = dsqrt(4.0d0*datan(1.0d0))
      pi = sqrt_pi*sqrt_pi

*     **** initialize efg_ion ****
      call dcopy(9*nion,0.0d0,0,efg_ion,1)

*     **** reciprocal space part of efg_ion ****
*     **** Honma eq. 4.8 ****
      aconst = 4.d0*pi/3.d0/lattice_omega()
      if (notzero_enpack) then  ! eliminate g=0 term
         do k=1+nida,enpack
           gvec(1) = dbl_mb(eG(1)+k-1)
           gvec(2) = dbl_mb(eG(2)+k-1)
           gvec(3) = dbl_mb(eG(3)+k-1)
           gg=gvec(1)*gvec(1)+gvec(2)*gvec(2)+gvec(3)*gvec(3)
           expfac = aconst*dbl_mb(vg(1)+k-1)/dbl_mb(vcx(1)+k-1)  ! see ewald_init for exp factors
           do ii=1,nion
            do jj=1,nion
             qj = ewald_zv(ion_katm(jj))
             rji(1) = ion_rion(1,jj) - ion_rion(1,ii)
             rji(2) = ion_rion(2,jj) - ion_rion(2,ii)
             rji(3) = ion_rion(3,jj) - ion_rion(3,ii)
             phase = gvec(1)*rji(1)+gvec(2)*rji(2)+gvec(3)*rji(3)
             cosphase = dcos(phase)
             do mu= 1,3
              do nu= 1,3
               termgg = -3.d0*gvec(mu)*gvec(nu)/gg
               if (mu == nu) termgg = 1.d0 + termgg

               !**** extra factor of 2 needed because its an integral ****
               efg_ion(mu,nu,ii) = efg_ion(mu,nu,ii) 
     &                           + 2.0d0*qj*cosphase*termgg*expfac
              end do
             end do
            end do ! jj
           end do ! ii
         end do  ! k
      end if   ! notzero_enpack
!
*     **** real-space part of efg_ion ****
*     **** Honma eq. 2.10 ****
      bconst = 4.0d0/(3.0d0*sqrt_pi*rcut**3)
      dutask=0
      do ii=1,nion
      do jj=1,nion
       if (dutask.eq.tid) then
        dx = ion_rion(1,ii) - ion_rion(1,jj)
        dy = ion_rion(2,ii) - ion_rion(2,jj)
        dz = ion_rion(3,ii) - ion_rion(3,jj)
        qj = ewald_zv(ion_katm(jj))
        do l=1,nshl3d
         x = dbl_mb(rcell(1)+(l-1))          + dx
         y = dbl_mb(rcell(1)+(l-1)+  nshl3d) + dy
         z = dbl_mb(rcell(1)+(l-1)+2*nshl3d) + dz
         r = dsqrt(x*x+y*y+z*z)
         if (r.gt.1.0d-6) then
          w = r/rcut
          yerfc = util_erfc(w)
          kfac = -bconst*((1.0d0+3.0d0/(2.0d0*w*w))*exp(-w*w) 
     >            + 3.0d0*sqrt_pi*yerfc/(4.0d0*w**3))
          efg_ion(1,1,ii)=efg_ion(1,1,ii)+qj*kfac*(1.d0-3.d0*(x*x)/r**2)
          efg_ion(2,1,ii)=efg_ion(2,1,ii)+qj*kfac*(    -3.d0*(y*x)/r**2)
          efg_ion(3,1,ii)=efg_ion(3,1,ii)+qj*kfac*(    -3.d0*(z*x)/r**2)
          efg_ion(1,2,ii)=efg_ion(1,2,ii)+qj*kfac*(    -3.d0*(x*y)/r**2)
          efg_ion(2,2,ii)=efg_ion(2,2,ii)+qj*kfac*(1.d0-3.d0*(y*y)/r**2)
          efg_ion(3,2,ii)=efg_ion(3,2,ii)+qj*kfac*(    -3.d0*(z*y)/r**2)
          efg_ion(1,3,ii)=efg_ion(1,3,ii)+qj*kfac*(    -3.d0*(x*z)/r**2)
          efg_ion(2,3,ii)=efg_ion(2,3,ii)+qj*kfac*(    -3.d0*(y*z)/r**2)
          efg_ion(3,3,ii)=efg_ion(3,3,ii)+qj*kfac*(1.d0-3.d0*(z*z)/r**2)
         end if
        end do !** lattice vectors **
       end if ! dutask
       dutask = mod((dutask+1),tnp)
      end do !**jj**
      end do !**ii**
!
      if (tnp.gt.1) then
        call Parallel_Vector_SumAll(9*nion,efg_ion)
      end if
!
      call nwpw_timing_end(21)
!
      return
      end

      subroutine argos_cafe_wbox(numw,nums,iwat,isat,isml,ishop,wsm,wgt)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
c
      integer numw,nums,iwat(mwa),isat(msa),isml(msa),ishop(msa)
      real*8 wsm(msm),wgt(mat,mset)
c
      integer i
c
      wbox=zero
c
      if(numw.gt.0) then
      do 1 i=1,nwa
      wbox=wbox+wgt(iwat(i),iset)
    1 continue
      wbox=dble(numw)*wbox
      endif
c
      do 2 i=1,msm
      wsm(i)=zero
    2 continue
c
      if(nums.gt.0) then
      do 3 i=1,nums
      if(iand(ishop(i),1).ne.1) then
      wbox=wbox+wgt(isat(i),iset)
      wsm(isml(i))=wsm(isml(i))+wgt(isat(i),iset)
      endif
    3 continue
      endif
c
      if(np.gt.1) then
      call ga_dgop(mcf_34,wbox,1,'+')
      if(msm.gt.0) call ga_dgop(mcf_35,wsm,msm,'+')
      endif
c
      return
      end
c $Id: argos_cafe_wbox.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup task
C> @{
      function task_smd_energy(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
      logical task_smd_energy
      character*72 namespace
      character*32 pname
      double precision etime1,etime2,etime3,etime4,etime5,etime6
      double precision energy,ewald1,ewald2,evdw
      logical operiodic

      pname = "task_smd_energy"
      call smd_init_energy(rtdb)
c      write(*,*) "in "//pname
c
c     start the clock
c     ---------------
      etime1=0.0
      etime2=0.0
      etime3=0.0
      etime4=0.0
      etime5=0.0
      etime6=0.0
      call cpu_time(etime1)
c
      call cpu_time(etime1)
      call cpu_time(etime2)
c
      call smd_vlist_update(.true.,.true.)
      call cpu_time(etime3)
c
      call smd_force_compute()
      call cpu_time(etime4)
c
      call smd_energy_compute()
      call cpu_time(etime5)
c
      call smd_energy_print(6)
c
      call smd_end()
c
      if (.not. rtdb_put(rtdb,'smd:energy',mt_dbl,1,energy))
     $     call errquit(pname//'failed put energy', 0, RTDB_ERR)
c

      call cpu_time(etime6)
      write(luout,'(/,a,f20.3)')'Total CPU time : ',(etime6-etime1)
      write(luout,'(/,a,f20.3)')'Initialization : ',(etime2-etime1)
      write(luout,'(/,a,f20.3)')'Verlet         : ',(etime3-etime2)
      write(luout,'(/,a,f20.3)')'Force          : ',(etime4-etime3)

      write(*,*) "Goodbye from task_smd"
      task_smd_energy = .true.

      return
      END
C> @}

c $Id: task_smd_energy.F 22842 2012-09-12 07:37:03Z d3y133 $

      logical function argos_prep_center(lfnout,xw,mwm,mwa,nwm,nwa,
     + xwc,mwmc,nwmc,xs,msa,nsa,iopt)
c
c $Id: argos_prep_center.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
      integer mwa,mwm,nwa,nwm,msa,nsa,mwmc,nwmc,iopt,lfnout
      real*8 xw(3,mwa,mwm),xwc(3,mwa,mwmc),xs(3,msa)
c
      integer i,j,k,imax,imin,kfr,kto
      real*8 s,smin,smax
c
      if(nsa.gt.0) then
c
      kfr=1
      kto=3
      if(iopt.ne.0) then
      kfr=iopt
      kto=iopt
      endif
c
      do 1 k=kfr,kto
      smin=xs(k,1)
      smax=xs(k,1)
      imin=1
      imax=1
      do 2 i=2,nsa
      if(xs(k,i).lt.smin) imin=i
      if(xs(k,i).gt.smax) imax=i
      smin=min(smin,xs(k,i))
      smax=max(smax,xs(k,i))
    2 continue
      s=(smax+smin)/2.0d0
      do 3 i=1,nsa
      xs(k,i)=xs(k,i)-s
    3 continue
      if(nwmc.gt.0) then
      do 4 i=1,nwmc
      do 5 j=1,nwa
      xwc(k,j,i)=xwc(k,j,i)-s
    5 continue
    4 continue
      endif
      if(nwm.gt.0) then
      do 6 i=1,nwm
      do 7 j=1,nwa
      xw(k,j,i)=xw(k,j,i)-s
    7 continue
    6 continue
      endif
      if(util_print('restart',print_high)) then
      write(lfnout,'(i2,2i5,3f12.6)') k,imin,imax,smin,smax,s
      endif
      if(util_print('restart',print_low)) then
      if(k.eq.0) write(lfnout,1000)
 1000 format(' Solute centered')
      if(k.eq.1) write(lfnout,1001)
 1001 format(' Solute centered in x-dimension')
      if(k.eq.2) write(lfnout,1002)
 1002 format(' Solute centered in y-dimension')
      if(k.eq.3) write(lfnout,1003)
 1003 format(' Solute centered in z-dimension')
      endif
    1 continue
c
      endif
c
      argos_prep_center=.true.
      return
      end

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     occ_ranges -- Convert an occupation vector into ranges of occupied
C     and virtual orbitals
C
C REVISION
C     $Id: occ_ranges.F 19697 2010-10-29 16:57:34Z d3y133 $
C
C SYNOPSIS
      Subroutine Occ_Ranges( N, Occ, OLo, OHi, VLo, VHi)
      Implicit NONE
      Integer N, OLo, OHi, VLo, VHi
      Double precision Occ(N)
C
C ARGUMENTS
C     N    Length of occupation vector [IN]
C     Occ  Occupation vector [IN]
C     OLo  Lower limit of occupied range [OUT]
C     OHi  Upper limit of occupied range [OUT]
C     VLo  Lower limit of virtual range [OUT]
C     VHi  Upper limit of virtual range [OUT]
C
C DESCRIPTION
C     Convert a vector of occupation numbers into ranges of occupied
C     and virtual orbitals.  If either range is empty, it will be
C     returned as 1:0, which can be fed to a Fortran DO loop and will 
C     NOT result in an iteration.
C
C     This routine is presently very simplistic, but should suffice 
C     for most purposes.  Occupied and virtual blocks are assumed to be
C     contiguous, with occupied first and virtuals second.
C
C     Any orbital with non-zero occupation is taken as occupied.
C
C INCLUDE FILES
#include "numerical_constants.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
C
      Integer I
C
C     Initialize things in a way that Fortran loops will work if there
C     are no occupied or not virtual orbitals.
C
      OLo = 1
      OHi = 0
      VLo = 1
      VHi = 0
C
C     Assume that all occupied are contiguous at the bottom of the
C     array and all the virtuals are contiguous at the top.  So all
C     we have to do is find the break point.
C
      Do I = 1, N
         If ( Occ( I ) .eq. FP_Zero) then
            OHi = I - 1
            VLo = I
            VHi = N
            Return
         EndIf
      EndDo
C
      Return
      End

*> \brief \b ZGEHD2 reduces a general square matrix to upper Hessenberg form using an unblocked algorithm.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZGEHD2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zgehd2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zgehd2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zgehd2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZGEHD2( N, ILO, IHI, A, LDA, TAU, WORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            IHI, ILO, INFO, LDA, N
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZGEHD2 reduces a complex general matrix A to upper Hessenberg form H
*> by a unitary similarity transformation:  Q**H * A * Q = H .
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>
*>          It is assumed that A is already upper triangular in rows
*>          and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*>          set by a previous call to ZGEBAL; otherwise they should be
*>          set to 1 and N respectively. See Further Details.
*>          1 <= ILO <= IHI <= max(1,N).
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX*16 array, dimension (LDA,N)
*>          On entry, the n by n general matrix to be reduced.
*>          On exit, the upper triangle and the first subdiagonal of A
*>          are overwritten with the upper Hessenberg matrix H, and the
*>          elements below the first subdiagonal, with the array TAU,
*>          represent the unitary matrix Q as a product of elementary
*>          reflectors. See Further Details.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is COMPLEX*16 array, dimension (N-1)
*>          The scalar factors of the elementary reflectors (see Further
*>          Details).
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX*16 array, dimension (N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complex16GEcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The matrix Q is represented as a product of (ihi-ilo) elementary
*>  reflectors
*>
*>     Q = H(ilo) H(ilo+1) . . . H(ihi-1).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**H
*>
*>  where tau is a complex scalar, and v is a complex vector with
*>  v(1:i) = 0, v(i+1) = 1 and v(ihi+1:n) = 0; v(i+2:ihi) is stored on
*>  exit in A(i+2:ihi,i), and tau in TAU(i).
*>
*>  The contents of A are illustrated by the following example, with
*>  n = 7, ilo = 2 and ihi = 6:
*>
*>  on entry,                        on exit,
*>
*>  ( a   a   a   a   a   a   a )    (  a   a   h   h   h   h   a )
*>  (     a   a   a   a   a   a )    (      a   h   h   h   h   a )
*>  (     a   a   a   a   a   a )    (      h   h   h   h   h   h )
*>  (     a   a   a   a   a   a )    (      v2  h   h   h   h   h )
*>  (     a   a   a   a   a   a )    (      v2  v3  h   h   h   h )
*>  (     a   a   a   a   a   a )    (      v2  v3  v4  h   h   h )
*>  (                         a )    (                          a )
*>
*>  where a denotes an element of the original matrix A, h denotes a
*>  modified element of the upper Hessenberg matrix H, and vi denotes an
*>  element of the vector defining H(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE ZGEHD2( N, ILO, IHI, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, INFO, LDA, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      COMPLEX*16         ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLARF, ZLARFG
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -2
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZGEHD2', -INFO )
         RETURN
      END IF
*
      DO 10 I = ILO, IHI - 1
*
*        Compute elementary reflector H(i) to annihilate A(i+2:ihi,i)
*
         ALPHA = A( I+1, I )
         CALL ZLARFG( IHI-I, ALPHA, A( MIN( I+2, N ), I ), 1, TAU( I ) )
         A( I+1, I ) = ONE
*
*        Apply H(i) to A(1:ihi,i+1:ihi) from the right
*
         CALL ZLARF( 'Right', IHI, IHI-I, A( I+1, I ), 1, TAU( I ),
     $               A( 1, I+1 ), LDA, WORK )
*
*        Apply H(i)**H to A(i+1:ihi,i+1:n) from the left
*
         CALL ZLARF( 'Left', IHI-I, N-I, A( I+1, I ), 1,
     $               DCONJG( TAU( I ) ), A( I+1, I+1 ), LDA, WORK )
*
         A( I+1, I ) = ALPHA
   10 CONTINUE
*
      RETURN
*
*     End of ZGEHD2
*
      END
c $Id: zgehd2.f 24343 2013-06-22 05:35:15Z d3y133 $

*> \brief \b SLADIV performs complex division in real arithmetic, avoiding unnecessary overflow.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download SLADIV + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/sladiv.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/sladiv.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/sladiv.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE SLADIV( A, B, C, D, P, Q )
* 
*       .. Scalar Arguments ..
*       REAL               A, B, C, D, P, Q
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> SLADIV performs complex division in  real arithmetic
*>
*>                       a + i*b
*>            p + i*q = ---------
*>                       c + i*d
*>
*> The algorithm is due to Robert L. Smith and can be found
*> in D. Knuth, The art of Computer Programming, Vol.2, p.195
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] A
*> \verbatim
*>          A is REAL
*> \endverbatim
*>
*> \param[in] B
*> \verbatim
*>          B is REAL
*> \endverbatim
*>
*> \param[in] C
*> \verbatim
*>          C is REAL
*> \endverbatim
*>
*> \param[in] D
*> \verbatim
*>          D is REAL
*>          The scalars a, b, c, and d in the above expression.
*> \endverbatim
*>
*> \param[out] P
*> \verbatim
*>          P is REAL
*> \endverbatim
*>
*> \param[out] Q
*> \verbatim
*>          Q is REAL
*>          The scalars p and q in the above expression.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE SLADIV( A, B, C, D, P, Q )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      REAL               A, B, C, D, P, Q
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL               E, F
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
      IF( ABS( D ).LT.ABS( C ) ) THEN
         E = D / C
         F = C + D*E
         P = ( A+B*E ) / F
         Q = ( B-A*E ) / F
      ELSE
         E = C / D
         F = D + C*E
         P = ( B+A*E ) / F
         Q = ( -A+B*E ) / F
      END IF
*
      RETURN
*
*     End of SLADIV
*
      END
c $Id: sladiv.f 24343 2013-06-22 05:35:15Z d3y133 $

      SUBROUTINE OFFSET_ccsdtq_lr_alpha_15_27_1(l_a_offset,k_a_offset,si
     &ze)
C     $Id: offset_ccsdtq_lr_alpha_15_27_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 h5 h6 h14 h15 h16 p4 p8 )_ytra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h2b
      INTEGER h5b
      INTEGER h6b
      INTEGER h14b
      INTEGER h15b
      INTEGER h16b
      INTEGER p4b
      INTEGER p8b
      length = 0
      DO h2b = 1,noab
      DO h5b = h2b,noab
      DO h6b = h5b,noab
      DO h14b = h6b,noab
      DO h15b = 1,noab
      DO h16b = h15b,noab
      DO p4b = noab+1,noab+nvab
      DO p8b = p4b,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     &+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+h1
     &6b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h15b-1),i
     &eor(int_mb(k_sym+h16b-1),ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+p8b
     &-1)))))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h15b-1)
     &+int_mb(k_spin+h16b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b-1).n
     &e.16)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lr_alpha_15_27_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h2b = 1,noab
      DO h5b = h2b,noab
      DO h6b = h5b,noab
      DO h14b = h6b,noab
      DO h15b = 1,noab
      DO h16b = h15b,noab
      DO p4b = noab+1,noab+nvab
      DO p8b = p4b,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     &+int_mb(k_spin+h14b-1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+h1
     &6b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h15b-1),i
     &eor(int_mb(k_sym+h16b-1),ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+p8b
     &-1)))))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h15b-1)
     &+int_mb(k_spin+h16b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b-1).n
     &e.16)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p8b - noab - 1 + nvab * (p4b - noab - 1 
     &+ nvab * (h16b - 1 + noab * (h15b - 1 + noab * (h14b - 1 + noab * 
     &(h6b - 1 + noab * (h5b - 1 + noab * (h2b - 1)))))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h2b-1) * int_mb(k_range+h5b-1) * int_
     &mb(k_range+h6b-1) * int_mb(k_range+h14b-1) * int_mb(k_range+h15b-1
     &) * int_mb(k_range+h16b-1) * int_mb(k_range+p4b-1) * int_mb(k_rang
     &e+p8b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine argos_prop_wtmro(lfnmro,ndec,dfr,dfrm)
c
      implicit none
c
#include "argos_prop.fh"
c
      integer lfnmro,ndec
      real*8 dfr(mda),dfrm(mda)
c
      integer i
c
      if(me.eq.0) then
      write(lfnmro) nderiv,nda,nprop,nsum,nsumt,ndec,maxp
      write(lfnmro) deriv
      write(lfnmro) (dfr(i),i=1,nda)
      write(lfnmro) (dfrm(i),i=1,nda)
      write(lfnmro) tsum,t2sum,tsumt,t2sumt
      write(lfnmro) (psum(i),i=1,maxp)
      write(lfnmro) (p2sum(i),i=1,maxp)
      write(lfnmro) (pslop(i),i=1,maxp)
      write(lfnmro) (psumt(i),i=1,maxp)
      write(lfnmro) (p2sumt(i),i=1,maxp)
      write(lfnmro) (pslopt(i),i=1,maxp)
      endif
      if(ndec.gt.0) call argos_cafe_wrtmro(lfnmro)
c
      return
      end
c $Id: argos_prop_wtmro.F 21176 2011-10-10 06:35:49Z d3y133 $

       program transform_pdb
       implicit none
       character*255 infile
       character*255 outfile
       character*16  tar
       logical ofile
       integer i,l,istatus 
       character*72 buffer
       integer ntot
c
       i=1
       call my_get_command_argument(i,buffer,l,istatus)
       if(istatus.ne.0) goto 18
       read(buffer,*) infile
18     continue
       write(*,*) "input file is",trim(infile)
       call cluster(infile)
c
       end

       subroutine cluster(infile)
       implicit none
       character*(*) infile
c
       integer ntot,nres
       double precision, dimension(:,:), allocatable :: c
       double precision, dimension(:,:), allocatable :: cg
       double precision, dimension(:), allocatable :: cd
       integer, dimension(:), allocatable :: ir
       integer, dimension(:), allocatable :: is
       integer, dimension(:), allocatable :: im
       integer, dimension(:,:), allocatable :: p2
       integer, dimension(:,:), allocatable :: p3
       integer, dimension(:,:), allocatable :: p4
       integer, dimension(:,:), allocatable :: p5
       integer, dimension(:,:), allocatable :: p6
       integer, dimension(:,:), allocatable :: p7
       integer, dimension(:,:), allocatable :: p8
       integer, dimension(:,:), allocatable :: p9
       character*16 , dimension(:), allocatable :: ta,tr
       integer i,il
       integer n2
       integer n3
       integer n4
       integer n5
       integer n6
       integer n7
       integer n8
       integer n9
 
       integer nmax
       nmax = 500
c
       call smd_pdb_natoms(infile,ntot)
       allocate(c(3,ntot))
       allocate(ta(ntot))
       allocate(tr(ntot))
       allocate(ir(ntot))
c
       call smd_pdb_read_coords(infile,ntot,c)
       call smd_pdb_read_atomres(infile,ntot,ta,tr,ir)
       call smd_pdb_sort_byres(ntot,ta,tr,ir,c)
       call smd_pdb_nres0(nres,ntot,ir)
       allocate(cg(3,nres))
       call smd_pdb_cog(ntot,nres,ir,c,cg)
       n2 = nres*(nres-1)/2
       allocate(p2(2,n2))
       call parse_dimers(nres,cg,n2,p2)
       allocate(p3(3,nmax))
       allocate(p4(4,nmax))
       allocate(p5(5,nmax))
       allocate(p6(6,nmax))
       allocate(p7(7,nmax))
       allocate(p8(8,nmax))
       allocate(p9(9,nmax))
       n3 = nmax
       n4 = nmax
       n5 = nmax
       n6 = nmax
       n7 = nmax
       n8 = nmax
       n9 = nmax

       call parse_trimers(n2,p2,n2,2,p2,n3,p3)
c       do i=1,n3
c         write(*,*) (p3(il,i),il=1,3)
c       end do
       call parse_trimers(n2,p2,n3,3,p3,n4,p4)
       do i=1,n4
         write(*,'(100I4)') (p4(il,i),il=1,4)
       end do
       call parse_trimers(n2,p2,n4,4,p4,n5,p5)
       do i=1,n5
         write(*,'(100I4)') (p5(il,i),il=1,5)
       end do
       call parse_trimers(n2,p2,n5,5,p5,n6,p6)
       do i=1,n6
         write(*,'(100I4)') (p6(il,i),il=1,6)
       end do
!!!      == deallocate arrays ==
       deallocate(p2)
       deallocate(cg)
       deallocate(ir)
       deallocate(tr)
       deallocate(ta)
       deallocate(c)
       end

      subroutine parse_dimers(nres,cg,nb,p2)
      implicit none
      integer nres
      double precision cg(3,nres)
      integer nb
      integer p2(2,nb)
c 
      integer i,j
      integer k
      double precision rd
      double precision dist
      double precision r1(3),r2(3)
      external dist


      k = 0
      do i=1,nres
      r1 = cg(:,i)
      do j=i+1,nres
        r2 = cg(:,j)
        rd  = dist(r1,r2)
        if(rd.lt.3.0) then
          k = k + 1
          p2(1,k) = i
          p2(2,k) = j
          write(12,*) i,j,rd
        end if 
      end do
      end do
      nb = k
      end subroutine

      subroutine parse_trimers(nb2,p2,nb,l,p,nx,px)
      implicit none
      integer nb2,nb,l,nx
      integer p2(2,nb2)
      integer p(l,nb)
      integer px(l+1,nx)
c 
      integer ptmp(l+1)
      integer ptmp0(l+1)
      integer i,j
      integer k
      integer tail, head
      logical ohead, otail
      integer ic

      integer i2,i3,j3,ik
      integer fn_out
      logical ofound,omatch

      fn_out = 78
c       open(fn_out,file="trimer.dat",
c     $            form='formatted',status='unknown')

      open(fn_out, form='formatted', status='scratch')
      k = 0
      do i2=1,nb2
      head = p2(1,i2)
      tail = p2(2,i2)
      do i=1,nb
        ic = 0
        do j=1,l
           ptmp(j) = p(j,i)
           if(p(j,i).eq.head) then
             ic = ic + 1
             ptmp(l+1) = tail
           end if
           if(p(j,i).eq.tail) then
             ic = ic + 1
             ptmp(l+1) = head
           end if
        end do
        if(ic.eq.1) then
          call sort(l+1,ptmp)
          if(k.ne.0) rewind(fn_out)
          ofound = .false.
          do ik=1,k
            read(fn_out,*) ptmp0
            if(ALL(ptmp0.eq.ptmp)) ofound = .true.
          end do
          if(.not.ofound) then
             write(fn_out,*) ptmp
             k = k +1
             px(:,k) = ptmp
          end if
        end if
      end do
      end do
      nx = k
      close(fn_out)
      end subroutine

      subroutine parse_fourmers(nb2,p2,nb,l,p,nx,px)
      implicit none
      integer nb2,nb,l,nx
      integer p2(2,nb2)
      integer p(l,nb)
      integer px(l+1,nx)
c 
      integer ptmp(l+1)
      integer ptmp0(l+1)
      integer i,j
      integer k
      integer tail, head
      logical ohead, otail
      integer ic

      integer i2,i3,j3,ik
      integer fn_out
      logical ofound,omatch
      character*73 message

      message = "opening file"
      fn_out = 33
       open(unit=fn_out,file="fourimer.dat",
     $            form='formatted',status='unknown',err=911)

      k = 0
      do i2=1,nb2
      head = p2(1,i2)
      tail = p2(2,i2)
      do i=1,nb
        ic = 0
        do j=1,l
           ptmp(j) = p(j,i)
           if(p(j,i).eq.head) then
             ic = ic + 1
             ptmp(l+1) = tail
           end if
           if(p(j,i).eq.tail) then
             ic = ic + 1
             ptmp(l+1) = head
           end if
        end do
        if(ic.eq.1) then
          call sort(l+1,ptmp)
          if(k.ne.0) rewind(fn_out)
          ofound = .false.
          do ik=1,k
            write(*,*) "ik=",ik
            read(fn_out,*) ptmp0
            write(*,*) "ptmp0=",ptmp0
            if(ALL(ptmp0.eq.ptmp)) ofound = .true.
          end do
          if(.not.ofound) then
             k = k +1
             write(*,*) k,ptmp
             write(fn_out,*) ptmp
             px(:,k) = ptmp
          end if
        end if
      end do
      end do
      close(fn_out)
      nx = k
      return
911    continue       
c      if you reach this you are in trouble
       write(*,*) "Emergency STOP "
       write(*,*) trim(message)
       stop
       end subroutine
      subroutine sort(n,a)
      implicit none
      integer n
      integer a(n)
c
c     local variables:
      integer i
      integer pass
      integer sorted
      integer temp
      character*32 pname

      pass = 1
      sorted = 0
      do while(sorted .eq. 0)
        sorted = 1
        do 2 i = 1,n-pass
          if(a(i) .gt. a(i+1)) then
            temp = a(i)
            a(i) = a(i+1)
            a(i+1) = temp
            sorted = 0
          endif
 2      continue
        pass = pass +1
      end do
      do i=1,n-1
       if(a(i).eq.a(i+1)) a(i)=-1
      end do

      return

      end

      function dist(r1,r2)
      implicit none
      double precision r1(3),r2(3)
      double precision dist
      dist = (r1(1)-r2(1))**2+
     +       (r1(2)-r2(2))**2+
     +       (r1(3)-r2(3))**2

      dist = sqrt(dist)
      return
      end function

      subroutine my_get_command_argument(i,buffer,l,istatus)
      implicit none
      integer i
      integer l
      character*(*) buffer
      integer istatus
c
      istatus = 0
      l = 0
      call getarg(i,buffer)
      if(buffer.eq." ") istatus = 1
c      call get_command_argument(i,buffer,l,istatus)
      end subroutine

      subroutine parse_trimers0(nb2,p2,nb,l,p,px)
      implicit none
      integer nb2,nb,l
      integer p2(2,nb2)
      integer px(l+1,nb)
      integer p(l,nb)
c 
      integer ptmp(l+1)
      integer i,j
      integer k
      integer tail, head
      logical ohead, otail
      integer ic

      integer i2,i3,j3

      k = 0
      do i2=1,nb2
      head = p2(1,i2)
      tail = p2(2,i2)
      do i=1,nb
        ic = 0
        do j=1,l
           ptmp(j) = p(j,i)
           if(p(j,i).eq.head) then
             ic = ic + 1
             ptmp(l+1) = tail
           end if
           if(p(j,i).eq.tail) then
             ic = ic + 1
             ptmp(l+1) = head
           end if
        end do
        if(ic.eq.1) then
           k = k+1
c          px(1:l,k) = p(:,i)
c          px(l+1,k) = tail
c         call sort(l+1,ptmp)
          write(14,*) (p(j,i),j=1,l),head,tail
          write(15,*) (ptmp(j),j=1,l+1)
        end if
        do j=1,l+1
          write(*,*) j,k,nb
          px(j,k) = ptmp(j)
        end do
      end do
      end do
      end subroutine

      subroutine parse_trimers1(nb2,p2,nb,l,p)
      implicit none
      integer nb2,nb,l
      integer p2(2,nb2)
      integer p(l,nb)
c 
      integer ptmp0(l+1)
      integer ptmp(l+1)
      integer i,j
      integer tail, head
      logical ohead, otail
      integer ic

      integer ik,in,il,jn,k,h0,h1,kk
      character*256 buf0,buf1
      logical ofound,omatch
      integer fn_out

      fn_out = 78
       open(fn_out,file="trimer.dat",
     $            form='formatted',status='unknown')
      kk = 0
      buf0 = " "
      ptmp0 = 0
      do in=1,nb
      do il=1,l
         h0 = p(il,in)
         h1 = p(min(il+1,l),in)
         do jn=1,nb2
           omatch = .false.
           if(p2(1,jn).eq.h0) then
             if(p2(2,jn).ne.h1) then
                     omatch = .true.
             end if
           else if(p2(2,jn).eq.h0) then
            omatch = .true.
           end if
           if(omatch) then
                write(14,*) (p(k,in),k=1,l),p2(1,jn),p2(2,jn)
                ptmp(2:l+1)= p(:,in)
                ptmp(1) = p2(2,jn)
                call sort(l+1,ptmp)
                write(buf1,*) (ptmp(k),k=1,l+1)
                ofound = .false.
                if(kk.ne.0) rewind(fn_out)
                do ik=1,kk
                  read(fn_out,*) ptmp0
                  if(ALL(ptmp0.eq.ptmp)) ofound = .true.
                end do
                if(.not.ofound) then
                   write(fn_out,*) ptmp
                   kk = kk +1
                end if
           end if
         end do
      end do
      end do
      rewind(fn_out)
      read(fn_out,'(a)') buf0
      write(*,*) "buf0",buf0
      end subroutine
c $Id: main.f 22505 2012-05-21 23:24:13Z d3y133 $

      subroutine cart_dens_trans_prod_sph(
     $     l1, x1, y1, z1,
     $     l2, x2, y2, z2, 
     $     a, b, c, work, dinv, ld, dens, ndens)
*
* $Id: cart_trans.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
      integer l1, l2            ! The angular momenta
      integer ld                ! Dimension parameter for dinv
      double precision x1, y1, z1, x2, y2, z2, a, b, c
      double precision dinv(((ld+1)*(ld+2)*(ld+3))/6,-ld:ld,0:ld)
      double precision dens(((l1+1)*(l1+2))/2,((l2+1)*(l2+2))/2)
      double precision ndens(*), work(*)
c
c     Combine the function of cart_dens_translate/product/to_sph.
c
c     Given in dens a density multiplying cartesian shells of given
c     angular momentum and centers, 
c
c     d(x,y,z) = sum(i,j,k) sum(p,q,r) dens(i,j,k; p,q,r) * 
c     .               (x-z1)^i(y-y1)^j(z-z1)^k * 
c     .               (x-z2)^p(y-y2)^q(z-z2)^r * 
c
c     (where i+j+k = l1 and p+q+r = l2) return the density in the form
c
c     d(x,y,z) = sum(n=0..l1+l2) sum(l=n,0,-2) sum(m=-l,l) 
c     .               ndens(n,l,m) Xlm(x-a,y-b,z-c) r^(n-l) 
c     
c     (where r is the distance of (x,y,z) from (a,b,c)
c
c     The output order in ndens is as described in cart_dens_to_sph
c
c     Both work and ndens need to be dimensioned
c     (((lmax+1)*(lmax+2)*(lmax+3))/6)**2 where lmax=max(l1,l2).
c     The output data in ndens is of length
c     (((l12+1)*(l12+2)*(l12+3))/6) where l12 = l1 + l2.
c
c     Dinv are the cartesian to spherical transformation coeffs 
c     generated by calling xlm_coeff_inv, and ld>=l1+l2.
c
c     The general case ... code special cases for optimization later.
c
c     This routine ONLY translates the polynomial or angular components
c     ... any rescaling due to the gaussian factors must be done
c     separately.
c
c     The input density in dens is preserved.
c
      call cart_dens_translate(l1, x1, y1, z1, l2, x2, y2, z2,
     $     a, b, c, dens, ndens, work)
      call cart_dens_product(l1,l2,ndens,work)
      call cart_dens_to_sph(l1+l2,work,ndens,dinv,ld)
c
      end
      subroutine cart_dens_translate(
     $     l1, x1, y1, z1, 
     $     l2, x2, y2, z2, 
     $     a, b, c, dens, ndens, work)
      implicit none
      integer l1, l2
      double precision x1, y1, z1, x2, y2, z2, a, b, c
      double precision dens(((l1+1)*(l1+2))/2,((l2+1)*(l2+2))/2)
      double precision ndens(*), work(*)
c
c     Given a block of a density matrix for two cartesian shells
c     of angular momentum l1 and l2, respectively, translate
c     the center of expansion for the polynomials from the separate
c     centers of the shells to the common center (a, b, c).
c
c     Work should be the same size as ndens which is
c     ndens((l1+1)*(l1+2)*(l1+3))/6,((l2+1)*(l2+2)*(l2+3))/6)
c
c     The input density d(ijk,pqr) is defined just for 
c     i+j+k=l1 and p+q+r=l2 in the standard order for a cartesian
c     shell.  The output density of necessity will include all
c     functions with i+j+k<=l1 and p+q+r<=l2.  See cart_poly_translate
c     for the ordering and addressing of these functions.
c
c     The input density is preserved.
c
      integer num1, num2, i1, i2, loff1, loff2
c
      integer itri, ind, loff, i, j, l
c
      itri(i,j)  = ((i*(i-1))/2 + j)
      ind(i,j,l) = itri(l-i+1,l-i-j+1) ! Index of x^i*y^j*z^(l-i-j) in
c     .                                ! cartesian shell of rank l
      loff(l) = ((l*(l+1)*(l+2))/6)
c
c
c     Translate shell 1.  First transpose into work(2,1), then
c     translate 1.
c
      num1 = ((l1+1)*(l1+2))/2
      num2 = ((l2+1)*(l2+2))/2
c
      if (l1 .gt. 0) then
         call dfill(loff(l1+1)*num2,0.0d0,work,1)
         loff1= loff(l1)*num2
         do i1 = 1, num1
            do i2 = 1, num2
               work(i2 + loff1) = dens(i1,i2)
            enddo
            loff1 = loff1 + num2
         enddo
         call cart_poly_translate(l1,num2,work,ndens,a-x1,b-y1,c-z1)
c     
c     Transpose back to work(1,2) and translate shell 2
c     
         num1 = loff(l1+1)
         num2 = ((l2+1)*(l2+2))/2
c     
         call dfill(loff(l1+1)*loff(l2+1),0.0d0,work,1)
         loff2= loff(l2)*num1
         do i2 = 1, num2
            loff1 = 0
            do i1 = 1, num1
               work(i1 + loff2) = ndens(i2 + loff1)
               loff1 = loff1 + num2
            enddo
            loff2 = loff2 + num1
         enddo
      else
         call dfill(loff(l1+1)*loff(l2+1),0.0d0,work,1)
         loff2= loff(l2)*num1
         do i2 = 1, num2
            do i1 = 1, num1
               work(i1 + loff2) = dens(i1, i2)
            enddo
            loff2 = loff2 + num1
         enddo
      endif
c
      if (l2 .gt. 0) then
         call cart_poly_translate(l2,num1,work,ndens,a-x2,b-y2,c-z2)
      else
         call dcopy(loff(l1+1)*loff(l2+1),work,1,ndens,1)
      endif
c
      end
      subroutine cart_poly_translate(lmax,npoly,coeff,ncoeff,a,b,c)
      implicit none
      integer lmax, npoly
      double precision  coeff(npoly,*)
      double precision ncoeff(npoly,*)
      double precision a, b, c
c
c     Given a set of polynomials (m=1,..,npoly) defined as
c
c     Pm = sum(i,j,k) coeff(m,i,j,k) x^i y^j z^k
c
c     recompute the coefficients for the polynomial being
c     expanded about the center (a, b, c)
c
c     Use the standard binomial expansion
c
c     (x-a+a)^i = (x'+a)^i = a^i + i*a^(i-1)*x' + ... + x'^i
c
c     coeff of a^p*x^(i-p) is i!/((i-p)!p!)
c
c     ncoeff returns the result, the input coeffs are DESTROYED
c
c     You should have at all points Pm(x,y,z) = Pmnew(x-a,y-b,z-c)
c
c     Included in coeff are all terms x^i y^j z^k with 0 <= i+j+k <= lmax
c     with all terms for each value of l stored contiguously.  Within 
c     a given l value (i+j+k=l) the offset of x^i y^j z^k is given
c     by ind(i,j,l).  The number of preceeding coefficients for all
c     polynomials up to, but not including, l is loff(l) = l*(l+1)*(l+2)/6.
c
c     So the location of (i,j,k) is loff(l)+ind(i,j,l) where l=i+j+k.
c
c     i j k
c     0 0 0
c     1 0 0, 0 1 0, 0 0 1,
c     2 0 0, 1 1 0, 1 0 1, 0 2 0, 0 1 1, 0 0 2
c     ...
c
      integer i, j, k, l, m, p, nijk, ijk, ijkp
      double precision fac
      integer itri, ind, loff
c
      itri(i,j)  = ((i*(i-1))/2 + j)
      ind(i,j,l) = itri(l-i+1,l-i-j+1) ! Index of x^i*y^j*z^(l-i-j) in
c     .                                ! cartesian shell of rank l
      loff(l) = ((l*(l+1)*(l+2))/6)
c
      nijk = loff(lmax+1)
c
c     First translate x
c
      call dfill(npoly*nijk, 0.0d0, ncoeff, 1)
      do l = 0, lmax
         do i = l, 0, -1
            do j = l-i,0,-1
               k = l-i-j
               ijk = loff(l) + ind(i,j,l)
               fac = 1.0d0
               do p = 0, i
                  if (abs(fac) .gt. 0.0d0) then
                     ijkp = loff(l-p) + ind(i-p,j,l-p)
                     do m = 1, npoly
                        ncoeff(m,ijkp) = ncoeff(m,ijkp) + 
     $                       fac*coeff(m,ijk)
                     enddo
                     fac = fac * a * dble(i-p) / dble(p+1)
                  endif
               enddo
            enddo
         enddo
      enddo
c
c     Then y
c
      call dfill(npoly*nijk, 0.0d0, coeff, 1)
c
      do l = 0, lmax
         do i = l, 0, -1
            do j = l-i,0,-1
               k = l-i-j
               ijk = loff(l) + ind(i,j,l)
               fac = 1.0d0
               do p = 0, j
                  if (abs(fac) .gt. 0.0d0) then
                     ijkp = loff(l-p) + ind(i,j-p,l-p)
                     do m = 1, npoly
                        coeff(m,ijkp) = coeff(m,ijkp) + 
     $                       fac*ncoeff(m,ijk)
                     enddo
                     fac = fac * b * dble(j-p) / dble(p+1)
                  endif
               enddo
            enddo
         enddo
      enddo
c
c     Then z
c
      call dfill(npoly*nijk, 0.0d0, ncoeff, 1)
      do l = 0, lmax
         do i = l, 0, -1
            do j = l-i,0,-1
               k = l-i-j
               ijk = loff(l) + ind(i,j,l)
               fac = 1.0d0
               do p = 0, k
                  if (abs(fac) .gt. 0.0d0) then
                     ijkp = loff(l-p) + ind(i,j,l-p)
                     do m = 1, npoly
                        ncoeff(m,ijkp) = ncoeff(m,ijkp) + 
     $                       fac*coeff(m,ijk)
                     enddo
                     fac = fac * c * dble(k-p) / dble(p+1)
                  endif
               enddo
            enddo
         enddo
      enddo
c
      end
      subroutine cart_dens_product(l1,l2,dens,ndens)
      implicit none
      integer l1, l2
      double precision dens(*), ndens(*)
c
c     Given in dens(ijk,pqr) the coefficients multiplying
c     x^(i+p)y^(j+q)z^(k+r) for i+j+k <= l1 and p+q+r <= l2
c     in the ordering generated by cart_{dens,poly}_translate.
c     Resum everything so that we return in ndens(ijk) the equivalent
c     coefficients for x^i*y^j*z^k for (i+j+k) <= (l1+l2) again
c     in the order described in cart_poly_translate
c
c     The arrays should be dimensioned
c
c     dens(loff(l1+1),loff(l2+1))
c     ndens(loff(l1+l2+1))
c
      integer i, j, l, l1p, l2p, i1, i2, j1, j2, k1, k2, ipt, ipt12
      integer i12, j12, l12, loff12
      integer itri, ind, loff
c
      itri(i,j)  = ((i*(i-1))/2 + j)
      ind(i,j,l) = itri(l-i+1,l-i-j+1) ! Index of x^i*y^j*z^(l-i-j) in
c     .                                ! cartesian shell of rank l
      loff(l) = (((l)*(l+1)*(l+2))/6)
c
      call dfill(loff(l1+l2+1),0.0d0,ndens,1)
c
      ipt = 0
      do l2p = 0, l2
         do i2 = l2p,0,-1
            do j2 = l2p-i2,0,-1
               k2 = l2p-i2-j2
               do l1p = 0, l1
                  l12 = l1p + l2p
                  loff12 = loff(l12)
                  do i1 = l1p,0,-1
                     i12 = i1 + i2
                     do j1 = l1p-i1,0,-1
                        k1 = l1p-i1-j1
                        ipt = ipt + 1
c
                        j12 = j1 + j2
                        ipt12 = loff12 + ind(i12,j12,l12)
                        ndens(ipt12) = ndens(ipt12) + dens(ipt)
c
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
c
      end
      subroutine cart_dens_to_sph(lmax,dens,ndens,dinv,ld)
      implicit none
      integer lmax, ld
      double precision dens(*),ndens(*)
      double precision dinv(((ld+1)*(ld+2)*(ld+3))/6,-ld:ld,0:ld)
#include "errquit.fh"
c
c     Given in dens a set of density matrix coefficients
c     for a cartesian basis of the form resulting from 
c     cart_dens_product, transform these into the real solid
c     spherical harmonic basis returning them in ndens.
c
c     dinv should contain the transformation coeffs resulting
c     from call xlm_coeff_inv(ld, d, dinv) (ld >= lmax)
c
c     The input order of coeffs for x^i y^j z^k in dens is
c
c     do l = 0, lmax
c     .  do i = l,0,-1
c     .     do j = l-i,0,-1
c     .        k = l-i-j
c     .        d(i,j,k)
c
c     the output order of coeffs for r^(n-l)Xlm in ndens is
c
c     do n = 0, lmax
c     .  do l = n,0,-2
c     .     do m = -l,l
c     .        d(n,l,m)
c
c     Both dens and ndens are the same size
c
c     (((lmax+1)*(lmax+2)*(lmax+3))/6)
c
      integer ind, n, nbase, loff, l, m, ijk
      double precision sum
      loff(l) = ((l*(l+1)*(l+2))/6)
c
      if (ld .lt. lmax) call errquit(
     $ 'carttrans: ld lt lmax ',ld+lmax*10000, CALC_ERR)
      ind = 0
      do n = 0, lmax
         nbase = loff(n)
         do l = n,0,-2
            do m = -l, l
               sum = 0.0d0
               do ijk = 1,(n+1)*(n+2)/2
                  sum = sum + dens(ijk+nbase)*dinv(ijk+nbase,m,l)
               enddo
               ind = ind + 1
               ndens(ind) = sum
            enddo
         enddo
         if (ind .ne. loff(n+1)) stop 9997
      enddo
c
      end
      subroutine gaussian_product(
     $     zeta1, x1, y1, z1,
     $     zeta2, x2, y2, z2,
     $      zeta,  a,  b,  c, prefac)
      implicit none
      double precision 
     $     zeta1, x1, y1, z1,
     $     zeta2, x2, y2, z2,
     $      zeta,  a,  b,  c, prefac
c
c     The Gaussian product theorem 
c
c     exp(-zeta1*(r-r1)^2)*exp(-zeta2*(r-r2)^2) = 
c     .   exp(-q*(r1-r2)^2)*exp(-zeta*(r-P)^2)
c
c     where
c
c     q    = (zeta1*zeta2)/(zeta1+zeta2)
c     zeta = (zeta1+zeta2)
c     P    = (zeta1*r1+ zeta2*r2)/(zeta1+zeta2)
c
c     Return zeta, P=(a,b,c), and prefac=exp(-q*(r1-r2)^2)
c
      double precision rzeta, q, dx, dy, dz, r12sq
c
      zeta  = (zeta1+zeta2)
      rzeta = 1.0d0/zeta
      q     = (zeta1*zeta2)*rzeta
      a     = (zeta1*x1 + zeta2*x2)*rzeta
      b     = (zeta1*y1 + zeta2*y2)*rzeta
      c     = (zeta1*z1 + zeta2*z2)*rzeta
      dx    = (x1-x2)
      dy    = (y1-y2)
      dz    = (z1-z2)
      r12sq = dx*dx + dy*dy + dz*dz
      prefac= exp(-q*r12sq)
c
      end

      function smd_monomer(im)
      implicit none

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "global.fh"
#include "process_task.fh"
#include <mpif.h>
      logical smd_monomer
      integer im
c
      character*72 namespace
      character*32 pname
      integer rtdb
      logical result
      double precision qm_energy
      logical task_energy_doit
      external task_energy_doit
      logical esp
      external esp
      integer util_sgroup_mygroup
      external util_sgroup_mygroup
      logical mode
      character*72 tag
      character*256 movecs
      character*16 theory
      double precision e1, e2,e3,e4,e5,e6,e7,e8,e9,e10,e11

      pname = "smd_monomer"
c      write(*,*) "1 im=",im," in "//pname
      e1 = mpi_wtime()
      call smd_rtdb_get_handle(rtdb)
      if (.not.rtdb_cget(rtdb,"smd:theory",1,theory)) then
       write(0,*) "PLEASE SET smd:theory"
       call errquit('failed to get theory',0,0)
      end if
c      call smd_charge_ga_get_all()
c      write(*,*) "1 "//pname
c      call util_flush(6)
      call ga_pgroup_sync(ga_pgroup_get_default())

      call smd_geom_monomer_create(im)
      e2 = mpi_wtime()
      t_gm_crt = t_gm_crt + (e2-e1)
c     write (*,*) "2 im=",im," in "//pname, ga_nodeid()
c     call util_flush(6)

c     write (*,*) "3 im=",im," in "//pname, ga_nodeid()
c     call util_flush(6)
c      call smd_rtdb_get_handle(rtdb)
c      write (*,*) "4 im=",im," in "//pname, ga_nodeid()
c      call util_flush(6)
      e4 = mpi_wtime()
      result = task_energy_doit(rtdb,theory,qm_energy)
      e5 = mpi_wtime()
      t_doit = t_doit + (e5-e4)
      if(ga_nodeid().eq.0) then
        write(*,*) "time energy monomer",im, e5-e4
        write(*,*) "time geom monomer",im,e2-e1
      end if
      call util_message("task_energy_doit done")
      e6 = mpi_wtime()
      if(.not.rtdb_put(rtdb,'esp:newgrd',mt_int,1,1))
     +     call errquit('esp: rtdb_put newgrd failed',0,0)
c      write (*,*) "6 im=",im," in "//pname, ga_nodeid()
c      call util_flush(6)

      if (theory.eq.'dft') then
       tag='dft:output vectors'
      else
       tag='scf:output vectors'
      endif
      if (.not.rtdb_cget(rtdb,tag,1,
     >                   movecs)) then
       write (6,*) 'error in rtdb_cget'
      end if
c
      if (.not.rtdb_cput(rtdb,'esp:input vectors',1,
     >                   movecs)) then
       write (6,*) 'error in rtdb_cput'
      end if
c
      e7 = mpi_wtime()
      t_rtdb = t_rtdb + (e7-e6)
c
c      if(.not.esp(rtdb))
c     &    call errquit(pname//'failed esp call', 100,
c     &                 RTDB_ERR)
      e8 = mpi_wtime()
      t_esp = t_esp + (e8-e7)
c      write (*,*) "7 im=",im," in "//pname, ga_nodeid()
c      call util_flush(6)

c      call smd_geom_push_charges(im)
      e9 = mpi_wtime()
      t_gm_push = t_gm_push + (e9-e8)

      call util_message("before call smd_charge_ga_set1")
c      if(ga_nodeid().eq.0)
c     &     call smd_charge_ga_set1(im)
c     call smd_charge_ga_set(im)
      call util_message("after call smd_charge_ga_set1")
      e10 = mpi_wtime()
      t_chrg_set = t_chrg_set + (e10-e9)
 
      call smd_geom_monomer_end()
      call util_message("after smd_geom_monomer_end")
      e11 = mpi_wtime()
      t_im_end = t_im_end + (e11-e10)

c      write(*,*) "Goodbye from "//pname,util_sgroup_mygroup(),qm_energy
c      call util_flush(6)
      smd_monomer = .true.

      return
      end function

c $Id: smd_monomer.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine argos_cafe_copyv(ia,ja,vdwai,vdw)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer ia,ja
      real*8 vdwai(24,4),vdw(mat,mat,map,mset)
c
      integer i,j
c
      if(.not.lfree) then
      do 1 i=1,4
      do 2 j=1,nparms
      vdw(ia,ja,i,j)=vdwai(j,i)
      if(ia.ne.ja) vdw(ja,ia,i,j)=vdw(ia,ja,i,j)
    2 continue
    1 continue
      else
      do 3 i=1,4
      do 4 j=1,3
      vdw(ia,ja,i,j)=vdwai(j,i)
    4 continue
    3 continue
      do 5 i=1,4
      vdw(ia,ja,i,4)=vdw(ia,ja,i,3)-vdw(ia,ja,i,2)
      vdw(ia,ja,i,5)=vdw(ia,ja,i,2)
      vdw(ia,ja,i,6)=vdw(ia,ja,i,3)
    5 continue
      if(ia.ne.ja) then
      do 6 i=1,4
      do 7 j=1,6
      vdw(ja,ia,i,j)=vdw(ia,ja,i,j)
    7 continue
    6 continue
      endif
      endif
c
c      do 55 i=1,4
c      write(*,9) ia,ja,i,(vdw(ia,ja,i,j),j=1,mset)
c   55 continue
c    9 format(3i5,10e12.5)
      return
      end
c $Id: argos_cafe_copyv.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine smd_shake_init(sp_shake,sp_param,rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_shake
      character*(*) sp_param
      integer rtdb
c
      character*32 pname
      character*80 tag
      character*255 filename
      integer na,nt
      integer i_i1,i_i2,i_d,i_tt
      integer i_i1t,h_i1t
      integer i_i2t,h_i2t
      integer i_dt,h_dt
      logical result
      integer i
c
      pname = "smd_shake_init"
c
      write(*,*) "in "//pname
c
c     get array of type names
c     -----------------------
      tag = "param:typename"
      call smd_data_get_index(sp_param,tag,i_tt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      call smd_data_get_size(sp_param,tag,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for'//tag,0, RTDB_ERR)
      nt = nt/16
c
       na = nt*(nt-1)
       na = na/2
c
c     allocate initial storage for shake params
c     ----------------------------------------
      if(.not.ma_push_get(mt_int,na,'tmp i1',h_i1t,i_i1t))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_int,na,'tmp i2',h_i2t,i_i2t))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      if(.not.ma_push_get(mt_dbl,na,'tmp d',h_dt,i_dt))
     + call errquit(pname//'Failed to allocate memory',
     + 0, MA_ERR)

      call smd_paramfile_read_shake(na,nt,
     +                         int_mb(i_i1t),
     +                         int_mb(i_i2t),
     +                         dbl_mb(i_dt),
     +                         byte_mb(i_tt))

c
c     create parameter data structures
c     ---------------------------
      call smd_data_create(sp_shake,"shake:i1",na,MT_INT)
      call smd_data_create(sp_shake,"shake:i2",na,MT_INT)
      call smd_data_create(sp_shake,"shake:distance",na,MT_DBL)

c
c     get shake arrays
c     ----------------
      tag = "shake:i1"
      call smd_data_get_index(sp_shake,tag,i_i1,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "shake:i2"
      call smd_data_get_index(sp_shake,tag,i_i2,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      tag = "shake:distance"
      call smd_data_get_index(sp_shake,tag,i_d,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      do i=1,na
       int_mb(i_i1+i-1) = int_mb(i_i1t+i-1)
       int_mb(i_i2+i-1) = int_mb(i_i2t+i-1)
       dbl_mb(i_d+i-1)  = dbl_mb(i_dt+i-1)
      end do

      if(.not.ma_pop_stack(h_dt))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_i2t))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_i1t))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      return
      end

      subroutine smd_shake_ntot(sp_shake,na)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_shake
      integer na
c
      logical result
      character*30 tag,pname
c
      pname = "smd_shake_ntot"
c
      tag = "shake:i1"
      call smd_data_get_index(sp_shake,tag,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, 0)

      return
      end

c $Id: smd_shake.F 22502 2012-05-20 06:11:57Z d3y133 $

C> \ingroup selci
C> @{
      subroutine restk
*
* $Id: restk.F 24790 2013-11-11 18:56:49Z d3y133 $
*
      implicit real*8 (a-h,o-z), integer(i-n)
#include "errquit.fh"
      parameter(irest1 = 69,irest2=70, istde=0,istdo=6)
      integer idum(7)
c     
#include "cselcifiles.fh"
c     
      do 00100 i = 1,7
         idum(i) = -i
00100 continue
      open(unit=irest1,
     &     file=names(1),
     &     access='sequential',
     &     form='unformatted',
     &     status='unknown',
     &     err=90911)
      open(unit=irest2,
     &     file=names(2),
     &     access='sequential',
     &     form='unformatted',
     &     status='unknown',
     &     err=90911)
      write(irest1) idum
      write(irest2) idum
      call selci_restkc(irest1,irest2)
      return
90911 call errquit(' error opening restart file ',0, DISK_ERR)
c
      end
      subroutine selci_restkc(irest1,irest2)
      implicit integer(i-z)
c
      close(unit=irest1,status='delete')
      close(unit=irest2,status='delete')
c
      return
      end
C> @}

      SUBROUTINE ccsdtq_lambda1_20_6_4(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsdtq_lambda1_20_6_4.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h8 p18 h14 p5 )_vt + = -1 * Sum ( h12 p10 ) * t ( p10 p18 h12 h14 )_t * v ( h8 h12 p5 p10 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p18b
      INTEGER h8b
      INTEGER h14b
      INTEGER p5b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p10b
      INTEGER h12b
      INTEGER p18b_1
      INTEGER p10b_1
      INTEGER h14b_1
      INTEGER h12b_1
      INTEGER h8b_2
      INTEGER h12b_2
      INTEGER p5b_2
      INTEGER p10b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p18b = noab+1,noab+nvab
      DO h8b = 1,noab
      DO h14b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+p18b-
     &1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+p18b-1) .eq. int_mb(k_spin+
     &h14b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+p18b-1),ieor(int_mb
     &(k_sym+h14b-1),int_mb(k_sym+p5b-1)))) .eq. ieor(irrep_v,irrep_t)) 
     &THEN
      dimc = int_mb(k_range+h8b-1) * int_mb(k_range+p18b-1) * int_mb(k_r
     &ange+h14b-1) * int_mb(k_range+p5b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_6_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p10b = noab+1,noab+nvab
      DO h12b = 1,noab
      IF (int_mb(k_spin+p18b-1)+int_mb(k_spin+p10b-1) .eq. int_mb(k_spin
     &+h14b-1)+int_mb(k_spin+h12b-1)) THEN
      IF (ieor(int_mb(k_sym+p18b-1),ieor(int_mb(k_sym+p10b-1),ieor(int_m
     &b(k_sym+h14b-1),int_mb(k_sym+h12b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p18b,p10b,h14b,h12b,p18b_1,p10b_1,h14b_1,h12
     &b_1)
      CALL TCE_RESTRICTED_4(h8b,h12b,p5b,p10b,h8b_2,h12b_2,p5b_2,p10b_2)
      dim_common = int_mb(k_range+p10b-1) * int_mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+p18b-1) * int_mb(k_range+h14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h8b-1) * int_mb(k_range+p5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_6_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_6_4',2,MA_ERR)
      IF ((p10b .le. p18b) .and. (h12b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (p18b_1 - noab - 1 + nvab * (p
     &10b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14
     &b-1),4,2,3,1,1.0d0)
      END IF
      IF ((p10b .le. p18b) .and. (h14b .lt. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (p18b_1 - noab - 1 + nvab * (p
     &10b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+h14b-1),int_mb(k_range+h12
     &b-1),3,2,4,1,-1.0d0)
      END IF
      IF ((p18b .lt. p10b) .and. (h12b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p
     &18b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p18b-1
     &),int_mb(k_range+p10b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14
     &b-1),4,1,3,2,-1.0d0)
      END IF
      IF ((p18b .lt. p10b) .and. (h14b .lt. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h14b_1 - 1 + noab * (p10b_1 - noab - 1 + nvab * (p
     &18b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p18b-1
     &),int_mb(k_range+p10b-1),int_mb(k_range+h14b-1),int_mb(k_range+h12
     &b-1),3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_20_6_4',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_20_6_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_6_4',5,MA_ERR)
      IF ((h12b .lt. h8b) .and. (p10b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p10b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noa
     &b+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h8b-1),int_mb(k_range+p10b-1),int_mb(k_range+p5b-
     &1),4,2,1,3,1.0d0)
      END IF
      IF ((h12b .lt. h8b) .and. (p5b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noa
     &b+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h8b-1),int_mb(k_range+p5b-1),int_mb(k_range+p10b-
     &1),3,2,1,4,-1.0d0)
      END IF
      IF ((h8b .le. h12b) .and. (p10b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p10b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h8b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+p10b-1),int_mb(k_range+p5b-
     &1),4,1,2,3,-1.0d0)
      END IF
      IF ((h8b .le. h12b) .and. (p5b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (no
     &ab+nvab) * (h8b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+p5b-1),int_mb(k_range+p10b-
     &1),3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_20_6_4',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_6
     &_4',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_6
     &_4',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_20_6_4',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h14b-1),int_mb(k_range+p18b-
     &1),2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h14b - 1 + noab * (p18b - noab - 1 + nvab * (h
     &8b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_20_6_4',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_20_6
     &_4',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

*> \brief \b CDOTU
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       COMPLEX FUNCTION CDOTU(N,CX,INCX,CY,INCY)
* 
*       .. Scalar Arguments ..
*       INTEGER INCX,INCY,N
*       ..
*       .. Array Arguments ..
*       COMPLEX CX(*),CY(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    CDOTU forms the dot product of two vectors.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex_blas_level1
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>     jack dongarra, linpack, 3/11/78.
*>     modified 12/3/93, array(1) declarations changed to array(*)
*> \endverbatim
*>
*  =====================================================================
      COMPLEX FUNCTION CDOTU(N,CX,INCX,CY,INCY)
*
*  -- Reference BLAS level1 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      COMPLEX CX(*),CY(*)
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      COMPLEX CTEMP
      INTEGER I,IX,IY
*     ..
      CTEMP = (0.0,0.0)
      CDOTU = (0.0,0.0)
      IF (N.LE.0) RETURN
      IF (INCX.EQ.1 .AND. INCY.EQ.1) THEN
*
*        code for both increments equal to 1
*
         DO I = 1,N
            CTEMP = CTEMP + CX(I)*CY(I)
         END DO
      ELSE
*
*        code for unequal increments or equal increments
*          not equal to 1
*
         IX = 1
         IY = 1
         IF (INCX.LT.0) IX = (-N+1)*INCX + 1
         IF (INCY.LT.0) IY = (-N+1)*INCY + 1
         DO I = 1,N
            CTEMP = CTEMP + CX(IX)*CY(IY)
            IX = IX + INCX
            IY = IY + INCY
         END DO
      END IF
      CDOTU = CTEMP
      RETURN
      END
c $Id: cdotu.f 24342 2013-06-22 05:32:15Z d3y133 $

      SUBROUTINE GAL_CGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA,
     $                   B, LDB, BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER*1        TRANSA, TRANSB
      INTEGER            M, N, K, LDA, LDB, LDC
      COMPLEX            ALPHA, BETA
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  GAL_CGEMM  performs one of the matrix-matrix operations
*
*     C := alpha*op( A )*op( B ) + beta*C,
*
*  where  op( X ) is one of
*
*     op( X ) = X   or   op( X ) = X'   or   op( X ) = conjg( X' ),
*
*  alpha and beta are scalars, and A, B and C are matrices, with op( A )
*  an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
*
*  Parameters
*  ==========
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n',  op( A ) = A.
*
*              TRANSA = 'T' or 't',  op( A ) = A'.
*
*              TRANSA = 'C' or 'c',  op( A ) = conjg( A' ).
*
*           Unchanged on exit.
*
*  TRANSB - CHARACTER*1.
*           On entry, TRANSB specifies the form of op( B ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSB = 'N' or 'n',  op( B ) = B.
*
*              TRANSB = 'T' or 't',  op( B ) = B'.
*
*              TRANSB = 'C' or 'c',  op( B ) = conjg( B' ).
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry,  M  specifies  the number  of rows  of the  matrix
*           op( A )  and of the  matrix  C.  M  must  be at least  zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N  specifies the number  of columns of the matrix
*           op( B ) and the number of columns of the matrix C. N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry,  K  specifies  the number of columns of the matrix
*           op( A ) and the number of rows of the matrix op( B ). K must
*           be at least  zero.
*           Unchanged on exit.
*
*  ALPHA  - COMPLEX         .
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - COMPLEX          array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
*           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by m  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
*           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*           least  max( 1, k ).
*           Unchanged on exit.
*
*  B      - COMPLEX          array of DIMENSION ( LDB, kb ), where kb is
*           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
*           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
*           part of the array  B  must contain the matrix  B,  otherwise
*           the leading  n by k  part of the array  B  must contain  the
*           matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
*           LDB must be at least  max( 1, k ), otherwise  LDB must be at
*           least  max( 1, n ).
*           Unchanged on exit.
*
*  BETA   - COMPLEX         .
*           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*           supplied as zero then C need not be set on input.
*           Unchanged on exit.
*
*  C      - COMPLEX          array of DIMENSION ( LDC, n ).
*           Before entry, the leading  m by n  part of the array  C must
*           contain the matrix  C,  except when  beta  is zero, in which
*           case C need not be set on entry.
*           On exit, the array  C  is overwritten by the  m by n  matrix
*           ( alpha*op( A )*op( B ) + beta*C ).
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            GAL_LSAME
      EXTERNAL           GAL_LSAME
*     .. External Subroutines ..
      EXTERNAL           GAL_XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          CONJG, MAX
*     .. Local Scalars ..
      LOGICAL            CONJA, CONJB, NOTA, NOTB
      INTEGER            I, INFO, J, L, NCOLA, NROWA, NROWB
      COMPLEX            TEMP
*     .. Parameters ..
      COMPLEX            ONE
      PARAMETER        ( ONE  = ( 1.0E+0, 0.0E+0 ) )
      COMPLEX            ZERO
      PARAMETER        ( ZERO = ( 0.0E+0, 0.0E+0 ) )
*     ..
*     .. Executable Statements ..
*
*     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
*     conjugated or transposed, set  CONJA and CONJB  as true if  A  and
*     B  respectively are to be  transposed but  not conjugated  and set
*     NROWA, NCOLA and  NROWB  as the number of rows and  columns  of  A
*     and the number of rows of  B  respectively.
*
      NOTA  = GAL_LSAME( TRANSA, 'N' )
      NOTB  = GAL_LSAME( TRANSB, 'N' )
      CONJA = GAL_LSAME( TRANSA, 'C' )
      CONJB = GAL_LSAME( TRANSB, 'C' )
      IF( NOTA )THEN
         NROWA = M
         NCOLA = K
      ELSE
         NROWA = K
         NCOLA = M
      END IF
      IF( NOTB )THEN
         NROWB = K
      ELSE
         NROWB = N
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF(      ( .NOT.NOTA                 ).AND.
     $         ( .NOT.CONJA                ).AND.
     $         ( .NOT.GAL_LSAME( TRANSA, 'T' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.NOTB                 ).AND.
     $         ( .NOT.CONJB                ).AND.
     $         ( .NOT.GAL_LSAME( TRANSB, 'T' ) )      )THEN
         INFO = 2
      ELSE IF( M  .LT.0               )THEN
         INFO = 3
      ELSE IF( N  .LT.0               )THEN
         INFO = 4
      ELSE IF( K  .LT.0               )THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 8
      ELSE IF( LDB.LT.MAX( 1, NROWB ) )THEN
         INFO = 10
      ELSE IF( LDC.LT.MAX( 1, M     ) )THEN
         INFO = 13
      END IF
      IF( INFO.NE.0 )THEN
         CALL GAL_XERBLA( 'GAL_CGEMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( BETA.EQ.ZERO )THEN
            DO 20, J = 1, N
               DO 10, I = 1, M
                  C( I, J ) = ZERO
   10          CONTINUE
   20       CONTINUE
         ELSE
            DO 40, J = 1, N
               DO 30, I = 1, M
                  C( I, J ) = BETA*C( I, J )
   30          CONTINUE
   40       CONTINUE
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( NOTB )THEN
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B + beta*C.
*
            DO 90, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 50, I = 1, M
                     C( I, J ) = ZERO
   50             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 60, I = 1, M
                     C( I, J ) = BETA*C( I, J )
   60             CONTINUE
               END IF
               DO 80, L = 1, K
                  IF( B( L, J ).NE.ZERO )THEN
                     TEMP = ALPHA*B( L, J )
                     DO 70, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
   70                CONTINUE
                  END IF
   80          CONTINUE
   90       CONTINUE
         ELSE IF( CONJA )THEN
*
*           Form  C := alpha*conjg( A' )*B + beta*C.
*
            DO 120, J = 1, N
               DO 110, I = 1, M
                  TEMP = ZERO
                  DO 100, L = 1, K
                     TEMP = TEMP + CONJG( A( L, I ) )*B( L, J )
  100             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  110          CONTINUE
  120       CONTINUE
         ELSE
*
*           Form  C := alpha*A'*B + beta*C
*
            DO 150, J = 1, N
               DO 140, I = 1, M
                  TEMP = ZERO
                  DO 130, L = 1, K
                     TEMP = TEMP + A( L, I )*B( L, J )
  130             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  140          CONTINUE
  150       CONTINUE
         END IF
      ELSE IF( NOTA )THEN
         IF( CONJB )THEN
*
*           Form  C := alpha*A*conjg( B' ) + beta*C.
*
            DO 200, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 160, I = 1, M
                     C( I, J ) = ZERO
  160             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 170, I = 1, M
                     C( I, J ) = BETA*C( I, J )
  170             CONTINUE
               END IF
               DO 190, L = 1, K
                  IF( B( J, L ).NE.ZERO )THEN
                     TEMP = ALPHA*CONJG( B( J, L ) )
                     DO 180, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  180                CONTINUE
                  END IF
  190          CONTINUE
  200       CONTINUE
         ELSE
*
*           Form  C := alpha*A*B'          + beta*C
*
            DO 250, J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  DO 210, I = 1, M
                     C( I, J ) = ZERO
  210             CONTINUE
               ELSE IF( BETA.NE.ONE )THEN
                  DO 220, I = 1, M
                     C( I, J ) = BETA*C( I, J )
  220             CONTINUE
               END IF
               DO 240, L = 1, K
                  IF( B( J, L ).NE.ZERO )THEN
                     TEMP = ALPHA*B( J, L )
                     DO 230, I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
  230                CONTINUE
                  END IF
  240          CONTINUE
  250       CONTINUE
         END IF
      ELSE IF( CONJA )THEN
         IF( CONJB )THEN
*
*           Form  C := alpha*conjg( A' )*conjg( B' ) + beta*C.
*
            DO 280, J = 1, N
               DO 270, I = 1, M
                  TEMP = ZERO
                  DO 260, L = 1, K
                     TEMP = TEMP + CONJG( A( L, I ) )*CONJG( B( J, L ) )
  260             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  270          CONTINUE
  280       CONTINUE
         ELSE
*
*           Form  C := alpha*conjg( A' )*B' + beta*C
*
            DO 310, J = 1, N
               DO 300, I = 1, M
                  TEMP = ZERO
                  DO 290, L = 1, K
                     TEMP = TEMP + CONJG( A( L, I ) )*B( J, L )
  290             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  300          CONTINUE
  310       CONTINUE
         END IF
      ELSE
         IF( CONJB )THEN
*
*           Form  C := alpha*A'*conjg( B' ) + beta*C
*
            DO 340, J = 1, N
               DO 330, I = 1, M
                  TEMP = ZERO
                  DO 320, L = 1, K
                     TEMP = TEMP + A( L, I )*CONJG( B( J, L ) )
  320             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  330          CONTINUE
  340       CONTINUE
         ELSE
*
*           Form  C := alpha*A'*B' + beta*C
*
            DO 370, J = 1, N
               DO 360, I = 1, M
                  TEMP = ZERO
                  DO 350, L = 1, K
                     TEMP = TEMP + A( L, I )*B( J, L )
  350             CONTINUE
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
  360          CONTINUE
  370       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of GAL_CGEMM .
*
      END

*
* $Id: bessel_transform.F 19707 2010-10-29 17:59:36Z d3y133 $
*

!*************************************************
!
!   Name    : spher_bessel_transform
!
!
!   Purpose : performs spherical Bessel transformation
!             from r-space to k-space. The end result is
!             the radial part of the transform in k-space
!
!
!   Created : 8/12/98, modified 7-30-2002
!
!*************************************************
      real*8 function spher_bessel_transform(l,ngrid,log_amesh,r,phi_r,
     >                                       G)
      implicit none
      integer l
      integer ngrid
      real*8 log_amesh
      real*8 r(*)
      real*8 phi_r(*)
      real*8 G

#include "mafdecls.fh"

      !*** Local variables ***
      logical value
      integer i
      integer power_r,power_f
      integer my_sin(2),my_cos(2),tmp_r(2),J(2)
      real*8 phi_G

      !*** external functions ***
#include "integrate.fh"


      value =           MA_push_get(mt_dbl,ngrid,
     >                              'my_sin',my_sin(2),my_sin(1))
      value = value.and.MA_push_get(mt_dbl,ngrid,
     >                              'my_cos',my_cos(2),my_cos(1))
      value = value.and.MA_push_get(mt_dbl,ngrid,
     >                              'tmp_r',tmp_r(2),tmp_r(1))
      value = value.and.MA_push_get(mt_dbl,ngrid,'J',J(2),J(1))
      if (.not.value) 
     >   call errquit('spher_bessel_transform: push stack',0,0)

      do i=1,ngrid
        dbl_mb(tmp_r(1)+i-1)  = r(i)*G
        dbl_mb(my_sin(1)+i-1) = sin(r(i)*G)
        dbl_mb(my_cos(1)+i-1) = cos(r(i)*G)
      end do
   
      power_r = 1
      power_f = 2*l+1

      call find_spher_J_v(l,ngrid,
     >                      dbl_mb(tmp_r(1)), 
     >                      dbl_mb(my_cos(1)), 
     >                      dbl_mb(my_sin(1)),
     >                      dbl_mb(J(1)))

      do i=1,ngrid
        dbl_mb(tmp_r(1)+i-1) = phi_r(i)*dbl_mb(J(1)+i-1)
      end do
      phi_G = def_integr(power_f,dbl_mb(tmp_r(1)),
     >                   power_r,r,
     >                   log_amesh,ngrid)
         
      value =           MA_pop_stack(J(2))
      value = value.and.MA_pop_stack(tmp_r(2))
      value = value.and.MA_pop_stack(my_cos(2))
      value = value.and.MA_pop_stack(my_sin(2)) 
      if (.not.value) call errquit('spher_bessel_transform',0,1)

      spher_bessel_transform = phi_G
      return
      end

!*************************************************
!
!   Name    : spher_bessel0_transform
!
!
!   Purpose : performs spherical Bessel transformation
!             from r-space to k-space. The end result is
!             the radial part of the transform in k-space
!
!
!   Created : 8/12/98, modified 7-30-2002
!
!*************************************************
      real*8 function spher_bessel0_transform(l,ngrid,log_amesh,r,phi_r)
      implicit none
      integer l
      integer ngrid
      real*8 log_amesh
      real*8 r(*)
      real*8 phi_r(*)

      !*** Local variables ***
      real*8 phi_G

      !*** external functions ***
#include "integrate.fh"
      if (l.eq.0) then
        phi_G = def_integr(1,phi_r,
     >                     1,r,
     >                     log_amesh,ngrid)
      else 
        phi_G = 0.0d0
      end if

      spher_bessel0_transform = phi_G
      return
      end

!*************************************************
!
!   Name    : find_spher_J_v
!
!
!   Purpose :
!
!
!   Created :
!
!*************************************************
      subroutine find_spher_J_v(order,ngrid,x,my_cos,my_sin,J) 
      implicit none
      integer order,ngrid
      real*8  x(*)
      real*8  my_cos(*)
      real*8  my_sin(*)
      real*8  J(*)

*     **** local variables ****
      integer k

      go to (100,200,300,400,500,600,700), order+1
      call errquit('find_spher_J_v: bad order',0,order)

*     *** l=0, s projectors ***
 100  do k=1,ngrid
        J(k) = my_sin(k)/x(k)
      end do
      go to 999

*     *** l=1, p projectors ***
 200  do k=1,ngrid
         J(k)=my_sin(k)/x(k)**2 - my_cos(k)/x(k) 
      end do
      go to 999

*     *** l=2, d projectors ***
 300  do k=1,ngrid
          J(k)=((-3.0d0*my_cos(k))/x(k) 
     >         - my_sin(k) 
     >         + (3.0d0*my_sin(k))/x(k)**2)/x(k)
      end do
      go to 999

*     *** l=3, f projectors ***
 400  do k=1,ngrid
           J(k)=(my_cos(k) 
     >          - (15.0d0*my_cos(k))/x(k)**2 
     >          + (15.0d0*my_sin(k))/x(k)**3 
     >          - ( 6.0d0*my_sin(k))/x(k))/x(k)
      end do
      go to 999

*      *** l=4, g projectors ***
 500  do k=1,ngrid
          J(k)= ((-105.0d0*my_cos(k))/x(k)**3 
     >           + (10.0d0*my_cos(k))/x(k) 
     >           + my_sin(k) 
     >           + (105.0d0*my_sin(k))/x(k)**4
     >           -(45.0d0*my_sin(k))/x(k)**2)/x(k)
      end do
      go to 999

*      *** l=5, h projectors ***
 600  do k=1,ngrid
          J(k)=(-my_cos(k) 
     >         - (945.0d0*my_cos(k))/x(k)**4 
     >         + (105.0d0*my_cos(k))/x(k)**2 
     >         + (945.0d0*my_sin(k))/x(k)**5 
     >         - (420.0d0*my_sin(k))/x(k)**3 
     >         + ( 15.0d0*my_sin(k))/x(k))/x(k)
      end do
      go to 999

*      *** l=6, i projectors ***
 700  do k=1,ngrid
          J(k)=( (-10395.0d0*my_cos(k))/x(k)**5 
     >         + (  1260.0d0*my_cos(k))/x(k)**3 
     >         - (    21.0d0*my_cos(k))/x(k) 
     >         - my_sin(k) 
     >         + (10395.0d0*my_sin(k))/x(k)**6 
     >         - ( 4725.0d0*my_sin(k))/x(k)**4 
     >         + (  210.0d0*my_sin(k))/x(k)**2)/x(k) 
      end do
      go to 999

 999  continue
 
      return
      end !SUBROUTINE find_spher_J_v

      SUBROUTINE ccsd_t_6dts(d_t1,k_t1_offset,d_t2,k_t2_offset,
     1            d_v2,k_v2_offset,energy1,energy2,size_t1,xmem)
C
C     $Id: ccsd_t_6dts.F 25011 2013-12-19 17:45:25Z d3y133 $
C
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_t1
      integer k_t1_offset
      integer d_t2
      integer k_t2_offset
      integer d_v2
      integer k_v2_offset
      integer t_h1b, t_h1
      integer t_h2b, t_h2
      integer t_h3b, t_h3
      integer t_p4b, t_p4
      integer t_p5b, t_p5
      integer t_p6b, t_p6
      integer k_singles,l_singles
      integer k_doubles,l_doubles
      integer size,i
      integer nxtask
      integer next
      integer nprocs
      integer count
      integer offset_p4,offset_p5,offset_p6
      integer offset_h1,offset_h2,offset_h3
      integer range_p4,range_p5,range_p6
      integer range_h1,range_h2,range_h3
c - T1/X1 LOCALIZATION -------------------
      integer l_t1_local,k_t1_local
      integer size_t1
c ---------------------------------------
      integer xmem
      integer dp4,dp5,ii,jj,istart,istop,jstart,jstop
      integer maxp4,maxp5
      double precision xlocal
c ---------------------------------------
      double precision energy(2)
      double precision energy1,energy2
      double precision factor,denom
      double precision denom_p4,denom_p5,denom_p6
      double precision denom_h1,denom_h2,denom_h3
      external nxtask
C
c
c - T1/X1 LOCALIZATION ----------
c    opening l_t1_local and l_x1_local
        if (.not.MA_PUSH_GET(mt_dbl,size_t1,'t1_local',
     1      l_t1_local,k_t1_local))
     1      call errquit('ccsd_t: t1_local size=',size_t1,MA_ERR)
        call ma_zero(dbl_mb(k_t1_local),size_t1)
c    copy d_t1 ==> l_t1_local
ccx        call ga_get(d_t1,1,size_t1,1,1,dbl_mb(k_t1_local),1)
      call get_block(d_t1,dbl_mb(k_t1_local),size_t1,0)
c -------------------------------
C
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      energy(1)=0.0d0
      energy(2)=0.0d0
      energy1 = 0.0d0
      energy2 = 0.0d0
      do t_p4b = noab+1,noab+nvab
       range_p4 = int_mb(k_range+t_p4b-1)
       offset_p4 = k_evl_sorted+int_mb(k_offset+t_p4b-1)-1
       do t_p5b = t_p4b,noab+nvab
        range_p5 = int_mb(k_range+t_p5b-1)
        offset_p5 = k_evl_sorted+int_mb(k_offset+t_p5b-1)-1
        do t_p6b = t_p5b,noab+nvab
         range_p6 = int_mb(k_range+t_p6b-1)
         offset_p6 = k_evl_sorted+int_mb(k_offset+t_p6b-1)-1
         do t_h1b = 1,noab
          range_h1 = int_mb(k_range+t_h1b-1)
          offset_h1 = k_evl_sorted+int_mb(k_offset+t_h1b-1)-1
          do t_h2b = t_h1b,noab
           range_h2 = int_mb(k_range+t_h2b-1)
           offset_h2 = k_evl_sorted+int_mb(k_offset+t_h2b-1)-1
           do t_h3b = t_h2b,noab
            range_h3 = int_mb(k_range+t_h3b-1)
            offset_h3 = k_evl_sorted+int_mb(k_offset+t_h3b-1)-1
            if (int_mb(k_spin+t_p4b-1)
     1         +int_mb(k_spin+t_p5b-1)
     2         +int_mb(k_spin+t_p6b-1)
     3      .eq.int_mb(k_spin+t_h1b-1)
     4         +int_mb(k_spin+t_h2b-1)
     5         +int_mb(k_spin+t_h3b-1)) then
            if ((.not.restricted).or.
     1         (int_mb(k_spin+t_p4b-1)
     1         +int_mb(k_spin+t_p5b-1)
     2         +int_mb(k_spin+t_p6b-1)
     3         +int_mb(k_spin+t_h1b-1)
     4         +int_mb(k_spin+t_h2b-1)
     5         +int_mb(k_spin+t_h3b-1).le.8)) then
            if (ieor(int_mb(k_sym+t_p4b-1),
     1          ieor(int_mb(k_sym+t_p5b-1),
     2          ieor(int_mb(k_sym+t_p6b-1),
     3          ieor(int_mb(k_sym+t_h1b-1),
     4          ieor(int_mb(k_sym+t_h2b-1),
     5               int_mb(k_sym+t_h3b-1)))))).eq.0) then
c
            if (next.eq.count) then
c
c -- 6DTS --
            dp4=1
            dp5=1
 300        continue
            if(dp4.eq.int_mb(k_range+t_p4b-1).and.
     1         dp5.eq.int_mb(k_range+t_p5b-1))
     2      call errquit('6DTS error',3,MA_ERR)
            xlocal=dble(int_mb(k_range+t_p4b-1)
     1           * int_mb(k_range+t_p5b-1)
     2           * int_mb(k_range+t_p6b-1)
     3           * int_mb(k_range+t_h1b-1)
     4           * int_mb(k_range+t_h2b-1)
     5           * int_mb(k_range+t_h3b-1))/(dble(dp4)*dble(dp5))
            if((xlocal*8.0d0)/(1024.0*1024.0).gt.dble(xmem)) then
             if(dp4.lt.int_mb(k_range+t_p4b-1)) then
              dp4=dp4+1
             else
              dp5=dp5+1
             end if
             go to 300
            end if
c
           size = (int_mb(k_range+t_p4b-1)/dp4+
     6    int_mb(k_range+t_p4b-1)-(int_mb(k_range+t_p4b-1)/dp4)*dp4)
     6           *(int_mb(k_range+t_p5b-1)/dp5+
     6    int_mb(k_range+t_p5b-1)-(int_mb(k_range+t_p5b-1)/dp5)*dp5)
     2           * int_mb(k_range+t_p6b-1)
     3           * int_mb(k_range+t_h1b-1)
     4           * int_mb(k_range+t_h2b-1)
     5           * int_mb(k_range+t_h3b-1)
c
          maxp4=int_mb(k_range+t_p4b-1)/dp4+
     6    int_mb(k_range+t_p4b-1)-(int_mb(k_range+t_p4b-1)/dp4)*dp4
          maxp5=int_mb(k_range+t_p5b-1)/dp5+
     6    int_mb(k_range+t_p5b-1)-(int_mb(k_range+t_p5b-1)/dp5)*dp5
c
c ----------
            if (.not.MA_PUSH_GET(mt_dbl,size,'(T) singles',l_singles,
     1        k_singles)) call errquit('ccsd_t: MA error',1,MA_ERR)
            if (.not.MA_PUSH_GET(mt_dbl,size,'(T) doubles',l_doubles,
     1        k_doubles)) call errquit('ccsd_t: MA error',2,MA_ERR)
c  6DTS ----
           do ii=1,dp4 !do ii ---
           do jj=1,dp5 !do jj ---
            if(ii.ne.dp4) then
             istart=(ii-1)*(int_mb(k_range+t_p4b-1)/dp4)+1
             istop=ii*(int_mb(k_range+t_p4b-1)/dp4)
            else
             istart=(ii-1)*(int_mb(k_range+t_p4b-1)/dp4)+1
             istop=int_mb(k_range+t_p4b-1)
            end if
            if(jj.ne.dp5) then
             jstart=(jj-1)*(int_mb(k_range+t_p5b-1)/dp5)+1
             jstop=jj*(int_mb(k_range+t_p5b-1)/dp5)
            else
             jstart=(jj-1)*(int_mb(k_range+t_p5b-1)/dp5)+1
             jstop=int_mb(k_range+t_p5b-1)
            end if
c zeroing ---
        call dfill(size, 0.0d0, dbl_mb(k_singles), 1)
        call dfill(size, 0.0d0, dbl_mb(k_doubles), 1)
c -----------
            call ccsd_t_singles_l_6dts(dbl_mb(k_singles),
     1        k_t1_local,d_v2,k_t1_offset,
     1        k_v2_offset,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2,
     1        istart,istop,jstart,jstop,maxp4,maxp5)
            call ccsd_t_doubles_l_6dts(dbl_mb(k_doubles),
     1        d_t2,d_v2,k_t2_offset,
     1        k_v2_offset,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2,
     1        istart,istop,jstart,jstop,maxp4,maxp5)
            if (restricted) then
              factor = 2.0d0
            else
              factor = 1.0d0
            endif
            if ((t_p4b.eq.t_p5b).and.(t_p5b.eq.t_p6b)) then
              factor = factor / 6.0d0
            else if ((t_p4b.eq.t_p5b).or.(t_p5b.eq.t_p6b)) then
              factor = factor / 2.0d0
            endif
            if ((t_h1b.eq.t_h2b).and.(t_h2b.eq.t_h3b)) then
              factor = factor / 6.0d0
            else if ((t_h1b.eq.t_h2b).or.(t_h2b.eq.t_h3b)) then
              factor = factor / 2.0d0
            endif
c
c factor = [ 1/36, 1/18, 1/12, 1/6, 1/4, 1/3, 1/2, 1, 2]
c
            i = 0
            do t_p4 = istart,istop
             denom_p4 = dbl_mb(offset_p4+t_p4)
             do t_p5 = jstart,jstop
              denom_p5 = dbl_mb(offset_p5+t_p5)
              do t_p6 = 1, range_p6
               denom_p6 = dbl_mb(offset_p6+t_p6)
               do t_h1 = 1, range_h1
                denom_h1 = dbl_mb(offset_h1+t_h1)
                do t_h2 = 1, range_h2
                 denom_h2 = dbl_mb(offset_h2+t_h2)
                 do t_h3 = 1, range_h3
                  denom_h3 = dbl_mb(offset_h3+t_h3)
                  denom = 1.0d0 / ( ( denom_h1 + denom_h2 + denom_h3 )
     1                            - ( denom_p4 + denom_p5 + denom_p6 ) )
                  energy1 = energy1 + factor*denom
     1                    * dbl_mb(k_doubles+i)*dbl_mb(k_doubles+i)
                  energy2 = energy2 + factor*denom*dbl_mb(k_doubles+i)
     1                    * (dbl_mb(k_doubles+i)+dbl_mb(k_singles+i))
                  i = i + 1
                 enddo
                enddo
               enddo
              enddo
             enddo
            enddo
c
            enddo !do ii ---
            enddo !do jj ---
c
            if (.not.MA_POP_STACK(l_doubles)) 
     1        call errquit('ccsd_t',3,MA_ERR)
            if (.not.MA_POP_STACK(l_singles)) 
     1        call errquit('ccsd_t',4,MA_ERR)
c
            next = nxtask(nprocs,1)
            endif
            count = count + 1
c
            endif
            endif
            endif
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      next = nxtask(-nprocs,1)
      energy(1) = energy1
      energy(2) = energy2
      call ga_dgop(mt_dbl,energy,2,'+')
      energy1 = energy(1)
      energy2 = energy(2)
c - T1/X1 LOCALIZATION ------
         if(.not.MA_POP_STACK(l_t1_local))
     &      call errquit('ccsd_t: l_t1_local',4,MA_ERR)
c ---------------------------
      return
      end

      subroutine argos_cafe_collapse(ncoll,fcoll,nums,numw,ismol,issgm,
     + xs,xsm,mst,tsm,fs,xwm,xw,fw)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer ncoll,numw,nums,mst
      integer ismol(msa),issgm(msa)
      real*8 fcoll
      real*8 xsm(msm,3),xs(msa,3),fs(msa,3),tsm(mst,4)
      real*8 xwm(mwm,3),xw(mwm,3,mwa),fw(mwm,3,mwa)
c
      integer i,j,k,ki,kf
      real*8 d
c
      ki=1
      kf=3
      if(ncoll.eq.1.or.ncoll.eq.4) ki=3
      if(ncoll.eq.2.or.ncoll.eq.5) kf=2
c
      if(ncoll.le.3) then
c
      do 5 i=1,msm
      if(ncoll.eq.1) then
      d=one/sqrt(xsm(i,1)**2+xsm(i,2)**2+xsm(i,3)**2)
      else
      d=one/sqrt(xsm(i,1)**2+xsm(i,2)**2)
      endif
      tsm(i,1)=xsm(i,1)*d
      tsm(i,2)=xsm(i,2)*d
      tsm(i,3)=xsm(i,3)*d
    5 continue
c
      do 1 k=ki,kf
      do 2 i=1,nums
      fs(i,k)=fs(i,k)-fcoll*tsm(ismol(i),k)
    2 continue
    1 continue
      do 4 i=1,numw
      if(ncoll.eq.1) then
      d=one/sqrt(xwm(i,1)**2+xwm(i,2)**2+xwm(i,3)**2)
      else
      d=one/sqrt(xwm(i,1)**2+xwm(i,2)**2)
      endif
      do 3 j=1,nwa
      do 6 k=ki,kf
      fw(i,k,j)=fw(i,k,j)-fcoll*d*xwm(i,k)
    6 continue
    3 continue
    4 continue
c
      else
c
      do 7 i=1,mst
      tsm(i,1)=0.0d0
      tsm(i,2)=0.0d0
      tsm(i,3)=0.0d0
      tsm(i,4)=0.0d0
    7 continue
      do 8 i=1,nums
      tsm(issgm(i),1)=tsm(issgm(i),1)+xs(i,1)
      tsm(issgm(i),2)=tsm(issgm(i),2)+xs(i,2)
      tsm(issgm(i),3)=tsm(issgm(i),3)+xs(i,3)
      tsm(issgm(i),4)=tsm(issgm(i),4)+1.0d0
    8 continue
      do 9 k=ki,kf
      do 10 i=1,nums
      fs(i,k)=fs(i,k)-fcoll*tsm(issgm(i),k)/tsm(issgm(i),4)
   10 continue
    9 continue
c
      endif
c
      return
      end
c $Id: argos_cafe_collapse.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function et_calc_fmo(rtdb,Vba)
      implicit none
c
c     This function calculates the electron transfer matrix elements.
c     So far only frontier couplings are calculated (total 4).
c     Only closed shells are possible at the moment.
*
#include "errquit.fh"
#include "rtdb.fh"
#include "util.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "global.fh"
#include "apiP.fh"
#include "bas.fh"
#include "geom.fh"
#include "cscf.fh"
#include "stdio.fh"
#include "numerical_constants.fh"
c
      integer rtdb, me
      integer i, j, k, ilo, ihi, jlo, jhi
      integer g_s_f1, g_mos_f1, ma_occ_f1(2), ma_evls_f1(2), nhomo_f1
      integer g_s_f2, g_mos_f2, ma_occ_f2(2), ma_evls_f2(2), nhomo_f2
      integer g_s_d,  g_mos_d,  ma_occ_d(2),  ma_evls_d(2),  nhomo_d
      integer g_s_p, g_mos_p
      integer g_evls_d, g_mos_d_o, g_mos_p_o
      integer et_nmo(2),nbf_f1,nbf_f2,nbf_d,nset
      integer g_c, g_fock, g_fock_tmp
c
      double precision Vba, E1, E2, toev, ths
c
      character*255 basis_name
c      character*2 pname(2)

      logical movecs_read_header
      external movecs_read_header

      parameter (toev=27.2114d+00)
      parameter (ths=1000.0d+00)

      et_calc_fmo=.true.

      me=ga_nodeid()

      if (me.eq.0) then
      Call Util_Print_Centered(LuOut,'FMO ET Calculation'
     &     ,40,.true.)
      write(LuOut,*)
      endif
c
c for printing:
c
      call util_print_push
      call util_print_rtdb_load(rtdb,"et")
c
c     FRAGMENT 1
c
      if(.not.movecs_read_header('frag1.movecs',title,basis_name,
     &   scftype,nbf_f1,nset,et_nmo,1))
     &   call errquit('et_calc: movecs_read_header failed for frag1',
     &       me, DISK_ERR)

      if (nset.ne.1)
     &   call errquit('et_calc: only HF/DFT orbitals allowed frag1',
     &   nset,INPUT_ERR)
c
      call et_fmo_getdata(rtdb,'frag1',g_s_f1,g_mos_f1,
     &   ma_evls_f1, ma_occ_f1)
      Call GA_Sync
c
      nhomo_f1=0
      do i = 1,nbf_f1
        nhomo_f1 = nhomo_f1 + dbl_mb(ma_occ_f1(2)+i-1)
      enddo
      nhomo_f1 = nhomo_f1/2
c
c order of pop matters
      if (.not.ma_pop_stack(ma_occ_f1(1))) 
     &   call errquit('could not destroy MA',ma_occ_f1(1),MA_ERR)
c
      if (.not.ma_pop_stack(ma_evls_f1(1))) 
     &   call errquit('could not destroy MA',ma_evls_f1(1),MA_ERR)
c
c     FRAGMENT 2
c
      if(.not.movecs_read_header('frag2.movecs',title,basis_name,
     &   scftype,nbf_f2,nset,et_nmo,1))
     &   call errquit('et_calc: movecs_read_header failed for frag2',
     &       me, DISK_ERR)
c
      if (nset.ne.1)
     &   call errquit('et_calc: only HF/DFT orbitals allowed frag2',
     &   nset,INPUT_ERR)
c
      call et_fmo_getdata(rtdb,'frag2',g_s_f2,g_mos_f2,
     &   ma_evls_f2, ma_occ_f2)
      Call GA_Sync
c
      nhomo_f2=0
      do i = 1,nbf_f2
         nhomo_f2 = nhomo_f2 + dbl_mb(ma_occ_f2(2)+i-1)
      enddo
      nhomo_f2 = nhomo_f2/2
c
      if (.not.ma_pop_stack(ma_occ_f2(1))) 
     &   call errquit('could not destroy MA',ma_occ_f2(1),MA_ERR)
c
      if (.not.ma_pop_stack(ma_evls_f2(1))) 
     &   call errquit('could not destroy MA',ma_evls_f2(1),MA_ERR)
c
c
c     DIMER
c
      if(.not.movecs_read_header('dimer.movecs',title,basis_name,
     &   scftype,nbf_d,nset,et_nmo,1))
     &   call errquit('et_calc: movecs_read_header failed for dimer',
     &       me, DISK_ERR)
c
      if (nset.ne.1)
     &   call errquit('et_calc: only HF/DFT orbitals allowed dimer',
     &   nset,INPUT_ERR)
c
      call et_fmo_getdata(rtdb,'dimer',g_s_d,g_mos_d,ma_evls_d,ma_occ_d)
      Call GA_Sync
c
      nhomo_d=0
      do i = 1,nbf_d
         nhomo_d = nhomo_d + dbl_mb(ma_occ_d(2)+i-1)
      enddo
      nhomo_d = nhomo_d/2
c
      if(.not.ga_duplicate(g_mos_d, g_evls_d, 'd_evls'))
     &   call errquit('et_calc: ga_duplicate failed evls_d', 0, GA_ERR)
      call ga_zero(g_evls_d)
c
c copied from ga_trace_diag
      call ga_distribution(g_evls_d, ga_nodeid(), ilo, ihi, jlo, jhi)
      if (ilo.gt.0 .and. jlo.gt.0) then
         ilo = max(ilo,jlo)
         ihi = min(ihi,jhi)
         do i = ilo,ihi
            call ga_put(g_evls_d, i, i, i, i,
     &         dbl_mb(ma_evls_d(2)+i-1)*toev, 1)
         enddo
      endif
c
      if (.not.ma_pop_stack(ma_occ_d(1))) 
     &   call errquit('could not destroy MA',ma_occ_d(1),MA_ERR)
c
      if (.not.ma_pop_stack(ma_evls_d(1))) 
     &   call errquit('could not destroy MA',ma_evls_d(1),MA_ERR)
c
c     PAIR
c
      if(.not.ga_duplicate(g_mos_d, g_mos_p, 'p_mos'))
     &   call errquit('et_calc: ga_duplicate failed p_mos', 0, GA_ERR)
      call ga_zero(g_mos_p)
c
      if(.not.ga_duplicate(g_mos_d, g_s_p, 'p_s'))
     &   call errquit('et_calc: ga_duplicate failed p_s', 0, GA_ERR)
      call ga_zero(g_s_p)
c
      call ga_copy_patch('n', g_mos_f1, 1, nbf_f1, 1, nbf_f1,
     &   g_mos_p, 1, nbf_f1, 1, nbf_f1)
c
      call ga_copy_patch('n', g_mos_f2, 1, nbf_f2, 1, nbf_f2,
     &   g_mos_p, nbf_f1+1, nbf_d, nbf_f1+1, nbf_d)
c
      call ga_copy_patch('n', g_s_f1, 1, nbf_f1, 1, nbf_f1,
     &   g_s_p, 1, nbf_f1, 1, nbf_f1)
c
      call ga_copy_patch('n', g_s_f2, 1, nbf_f2, 1, nbf_f2,
     &   g_s_p, nbf_f1+1, nbf_d, nbf_f1+1, nbf_d)
c
      call ga_matpow(g_s_d, FP_Half, 1d-12)
      call ga_matpow(g_s_p, FP_Half, 1d-12)
c
      if(.not.ga_duplicate(g_mos_d, g_mos_d_o, 'mos_d_o'))
     &   call errquit('et_calc: ga_duplicate failed mos_d_o', 0, GA_ERR)
c
      call ga_dgemm('n','n',nbf_d,nbf_d,nbf_d,1.0d0,
     &   g_s_d, g_mos_d, 0.0d0, g_mos_d_o)
c
      if(.not.ga_duplicate(g_mos_d, g_mos_p_o, 'mos_p_o'))
     &   call errquit('et_calc: ga_duplicate failed mos_p_o', 0, GA_ERR)
c
      call ga_dgemm('n','n',nbf_d,nbf_d,nbf_d,1.0d0,
     &   g_s_p,g_mos_p, 0.0d0, g_mos_p_o)
c
      if(.not.ga_duplicate(g_mos_d, g_c, 'c'))
     &   call errquit('et_calc: ga_duplicate failed c', 0, GA_ERR)
      call ga_zero(g_c)
c
      call ga_dgemm('t','n',nbf_d,nbf_d,nbf_d,1.0d0,
     &   g_mos_p_o,g_mos_d_o, 0.0d0, g_c)
c
      if(.not.ga_duplicate(g_mos_d, g_fock, 'fock'))
     &   call errquit('et_calc: ga_duplicate failed fock', 0, GA_ERR)
      call ga_zero(g_fock)

      if(.not.ga_duplicate(g_mos_d, g_fock_tmp, 'fock_tmp'))
     &  call errquit('et_calc: ga_duplicate failed fock_tmp', 0, GA_ERR)
      call ga_zero(g_fock_tmp)
c
      call ga_dgemm('n','n',nbf_d,nbf_d,nbf_d,1.0d0,
     &   g_c,g_evls_d, 0.0d0, g_fock_tmp)
c
      call ga_dgemm('n','t',nbf_d,nbf_d,nbf_d,1.0d0,
     &   g_fock_tmp,g_c, 0.0d0, g_fock)

      if (.not.ga_destroy(g_fock_tmp)) 
     &  call errquit('ga_destroy g_fock_tmp failed',g_fock_tmp,
     &       GA_ERR)
c
      if (me.eq.0) then
        write(LuOut,9995) 'Frag1 HOMO: ', nhomo_f1,
     &   ' Frag2 HOMO: ', nhomo_f2, ' Dimer HOMO: ', nhomo_d
        write(LuOut,*)
        write(*,"(5A10)") 'F1 #Mo','F2 #Mo','V, meV','E1, meV','E2, meV'
c
        do i=nhomo_f1, nhomo_f1+1
          do j=nhomo_f2+nbf_f1, nhomo_f2+nbf_f1+1
            Call GA_Get(g_fock, j, j, i, i, Vba, 1)
            Call GA_Get(g_fock, i, i, i, i, E1, 1)
            Call GA_Get(g_fock, j, j, j, j, E2, 1)
            write(LuOut,9996) i, j-nbf_f1, Vba*ths, E1*ths, E2*ths
          enddo
        enddo
      endif
c
 9995 format(A13,I3,A13,I3,A13,I3)
 9996 format(2I10,3F10.3)
c
      call util_print_pop
c
c     destroying
c
      if (.not.ga_destroy(g_s_f1))
     &  call errquit('could not destroy s_f1',g_s_f1, GA_ERR)
c
      if (.not.ga_destroy(g_mos_f1))
     &  call errquit('could not destroy mos_f1',g_mos_f1, GA_ERR)

      if (.not.ga_destroy(g_s_f2))
     &  call errquit('could not destroy s_f2',g_s_f2, GA_ERR)
c
      if (.not.ga_destroy(g_mos_f2))
     &  call errquit('could not destroy mos_f2',g_mos_f2, GA_ERR)

      if (.not.ga_destroy(g_s_d))
     &  call errquit('could not destroy s_d',g_s_d, GA_ERR)
c
      if (.not.ga_destroy(g_mos_d))
     &  call errquit('could not destroy mos_d',g_mos_d, GA_ERR)
c
      if (.not.ga_destroy(g_s_p))
     &  call errquit('could not destroy s_p',g_s_p, GA_ERR)
c
      if (.not.ga_destroy(g_mos_p))
     &  call errquit('could not destroy mos_p',g_mos_p, GA_ERR)
c
      if (.not.ga_destroy(g_mos_d_o))
     &  call errquit('could not destroy mos_d_o',g_mos_d_o, GA_ERR)
c
      if (.not.ga_destroy(g_mos_p_o))
     &  call errquit('could not destroy mos_p_o',g_mos_p_o, GA_ERR)
c
      if (.not.ga_destroy(g_c))
     &  call errquit('could not destroy c',g_c, GA_ERR)
c
      if (.not.ga_destroy(g_fock))
     &  call errquit('could not destroy fock',g_fock, GA_ERR)
c
      if (.not.ga_destroy(g_evls_d))
     &  call errquit('could not destroy evls_d',g_evls_d, GA_ERR)
c
      et_calc_fmo=.true.
      return
      end
c $Id: et_calc_fmo.F 25011 2013-12-19 17:45:25Z d3y133 $

*
* $Id: mm_loop.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*  ************************************************************
*  *                MPI mmsd routine                          *
*  *                                                          *
*  *  This is a developing mmsdv1 parallel code wrtten in     *
*  *  Fortran and MPI.                                        *
*  *                                                          *
*  ************************************************************
  
      subroutine mm_loop(it_in,E,deltae,deltar)
      implicit none
      integer    it_in
      real*8     E(*)
      real*8     deltae,deltar

#include "mafdecls.fh"
#include "errquit.fh"

*     **** local variables ****
      integer i,n,n1(2),n2(2),it,ms,ierr
      real*8  sum,Eold,eion
      real*8  dt
      real*8  e_lj, e_q, e_spring

*     **** MA local variables ****
      logical value
      integer natmx,fion(2),ftest(2)

*     ***** external functions ****
      integer  ion_nion
      real*8   control_time_step
      real*8   ewald_e
      external ion_nion
      external control_time_step
      external ewald_e
      integer  control_version
      external control_version
      real*8   ion_ion_e
      external ion_ion_e

*     ***** QM/MM external functions ****
      logical  pspw_charge_found,pspw_qmmm_found
      real*8   pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E
      external pspw_charge_found,pspw_qmmm_found
      external pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E


      call nwpw_timing_start(12)
*     **** allocate MA local variables ****
      natmx = ion_nion()
      value = MA_push_get(mt_dbl,(3*natmx),'fion',fion(2),fion(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(3*natmx),'ftest',ftest(2),ftest(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      call nwpw_timing_end(12)
     
      dt = control_time_step()

*     ******************************************
*     ****                                  ****
*     ****   Start of steepest descent loop ****
*     ****                                  ****
*     ******************************************
      do it=1,it_in

        call ion_shift()
        call dcopy(3*natmx,0.0d0,0,dbl_mb(fion(1)),1)

        if (control_version().eq.3) then
           call ewald_phafac()
           call ewald_f(dbl_mb(fion(1)))
        end if
        if (control_version().eq.4) call ion_ion_f(dbl_mb(fion(1)))

        call pspw_qmmm_fion(dbl_mb(fion(1)))

*       **** remove ion forces using ion_FixIon ****
        call ion_FixIon(dbl_mb(fion(1)))
        call ion_optimize_step(dbl_mb(fion(1)))

      end do

*     *************************************
*     ***** total energy calculation ******
*     *************************************
      call nwpw_timing_start(10)

*     **** get ewald energy ****
      eion = 0.0d0
      if (control_version().eq.3) eion = ewald_e()
    
*     **** get free-space ion-ion energy ****
      if (control_version().eq.4) eion = ion_ion_e()

*     **** total energy ****
      Eold=E(1)
      E(1) = eion 
      E(2) = 0.0d0
      E(3) = 0.0d0
      E(4) = 0.0d0
      E(5) = eion
      E(6) = 0.0d0
      E(7) = 0.0d0
      E(8) = 0.0d0
      E(9) = 0.0d0
      E(10) = 0.0d0
      e_lj  = pspw_qmmm_LJ_E()
      e_q   = pspw_qmmm_Q_E()
      e_spring = pspw_qmmm_spring_E()
      E(1)  = E(1) + e_lj + e_q + e_spring
      E(11) = e_lj
      E(12) = e_q
      E(13) = e_spring

*     **** set convergence variables ****
      deltae = (E(1)-Eold)/(dt*dble(it_in))

*     *** deltar ***
      deltar = 0.0d0
      do i=1,ion_nion()
         sum = dsqrt( dbl_mb(fion(1)+(i-1)*3  )**2 
     >              + dbl_mb(fion(1)+(i-1)*3+1)**2 
     >              + dbl_mb(fion(1)+(i-1)*3+2)**2)
        if (sum.gt.deltar) deltar = sum
      end do
       
      call nwpw_timing_end(10)

*     **** dealocate MA local variables ****
      call nwpw_timing_start(12)
      value = MA_pop_stack(ftest(2))
      value = MA_pop_stack(fion(2))

      call nwpw_timing_end(12)
      return
      end
 

      SUBROUTINE tce_mo2e_zones_4a_disk_ga_N5(rtdb,d_v2,
     1                                kax_v2_alpha_offset,
     1                                size_2e)
C     $Id: tce_mo2e_zones_4a_disk_ga_N5.F 25705 2014-06-02 18:58:56Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     t ( p1 p2 h3 h4 )_t
      IMPLICIT NONE
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
c written by K. Kowalski
c
c
c     max. number of p2 groups =200
c
c
      integer rtdb                 ! Run-time database
      integer d_v2                 ! MO integrals
      integer kax_v2_alpha_offset  ! MO integrals offset
      integer size_2e              ! 2e file size
c
      INTEGER size_2g2a,l_2g2a,k_2g2a
      INTEGER azone1,azone2,azone3,azone4
      INTEGER g1b,g2b,g3b,g4b
      INTEGER igi1,igi2,igi3,igi4
      INTEGER ii,i,j,k,l,N,ipos1,ipos2,ipos3,ipos4
      INTEGER del1,del2,p1rel,p2rel
      INTEGER size_4a,l_4a,k_4a
c
      integer mu,nu,rho,sigma
      integer mu_lo,mu_hi
      integer nu_lo,nu_hi
      integer rho_lo,rho_hi
      integer sigma_lo,sigma_hi
      integer mu_range
      integer nu_range
      integer rho_range
      integer sigma_range
      integer mu1,nu1,rho1,sigma1
      integer shift_mu,shift_nu
      integer shift_rho,shift_sigma
      integer work1,work2          ! Work array sizes
      integer l_work1,k_work1      ! Work array 1
      integer l_work2,k_work2      ! Work array 2
      integer imu1,inu1,irho1,isigma1
c
      integer l_movecs_orb,k_movecs_orb
      integer l_gpair,k_gpair
      integer len_pair,g12_shift
c ATTENTION,ACHTUNG,UWAGA 2000 - max # of CPU
c
      integer size_2g2z,l_2g2z,k_2g2z
      integer tot_azone1_sh,tot_azone2_sh
      integer tot_azone3_sh,tot_azone4_sh
      integer ixi,jxi,point_pair
      integer size_stripe,l_p34,k_p34
      integer addr,xoffset_34
      integer size_g3g4,xoffset_p34
      integer size_g4321,k_g4321,l_g4321
c
      integer l_integral,l_coeff
      integer k_integral,k_coeff
      integer size_ic,size_icc,size_integral,size_coeff,max_na
      integer l_aux,k_aux,size_aux,iend
c
      integer iha,ihb !number of corr. alpha, beta holes
      integer ipa,ipb !number of corr. alpha, beta particles
      integer INDEX_PAIR,icol,irow
c compression
      integer xoffset_g12(1000),xoffset_size(1000)
      integer xoffset_size_p1p2(1000)
      integer key_start(1000),key_end(1000)
      integer size_temp,size_temp_4g,xoffset_temp_4g,size_p1p2
      integer max_size_temp,xoffset_temp,iclose,iopen,offset_2g2z
      integer imaxp12,istart,ibuba,sumx
      double precision wall,cpu,wall1,cpu1,wall2,cpu2,wall3,cpu3
c *** debug ***
       double precision xtot1,xtot2,xtot3
c *************
      integer tot_zone(1000)
      integer l_g12piece,k_g12piece,size_g12p
c 
      integer l_4af_offset,k_4af_offset,d_4af
      integer sf_chunk,request
      integer key_4af,offset_4af,size_4af
      character*255 filename
c 
      logical parallel
c
      INTEGER length
      INTEGER next
      INTEGER nprocs
      INTEGER count
      integer nxtask
      external nxtask
      logical nodezero
      logical idiskl
c
c
c
c
cccx      parallel = (ga_nnodes().gt.1)
      parallel = .true.
c
      if(idisk.eq.0) then
       idiskl=.false.
      else
       idiskl=.true.
      end if
c
c
cccx      max_size_temp=100000000
      max_size_temp=imaxsize**4
c
c
c
      do ii=1,1000
       tot_zone(ii)=0
      enddo
      if(atpart.gt.1000) 
     &  call errquit('tce_zones: atpart too big',1,MA_ERR)
      sumx=0
      do ii=1,atpart
       tot_zone(ii)=sumx
       sumx=sumx+nalength(ii)
      enddo
c
      nodezero=(ga_nodeid().eq.0)
c
c
c this module is called only if intorb = .true.
c N is the number of correlated orbitals
        N = nmo(1) - nfc(1) - nfv(1)
        iha = nocc(1)-nfc(1)
        ihb = nocc(ipol)-nfc(ipol)
        ipa = nmo(1)-nocc(1)-nfv(1)
        ipb = nmo(ipol)-nocc(ipol)-nfv(ipol)
c
c     Offset for 4a file
c
cc      sf_chunk=(imaxsize+10)**4
      sf_chunk=(imaxsize)**4
      if(.not.idiskl) then
c GA is assumed
       call tce_4a_offset(l_4af_offset,k_4af_offset,size_4af)
      else
cccx  call tce_filename('4aint',filename)
       call tce_4a_offset(l_4af_offset,k_4af_offset,size_4af)
cccx       call util_file_name('4aintx',.true.,.false.,filename)
       call util_file_name('4aintx',.false.,.false.,filename)
      end if 
      if(idiskl) then
       if(.not.parallel) 
     1      call errquit('sf only for parallel runs',1,DISK_ERR)
       if(parallel) call ga_sync()
        if (sf_create(filename,dfloat(bytes)*dfloat(size_4af),
     1    dfloat(bytes)*dfloat(size_4af),sf_chunk,d_4af).ne.0)
     2    call errquit('4-index: sf problem',0,DISK_ERR)
ccx        if (parallel) then
ccx          if (sf_close(d_4af).ne.0)
ccx     1      call errquit('createfile: sf problem',1,DISK_ERR)
ccx          call ga_sync()
ccx        end if      
      else
       call createfile(filename,d_4af,size_4af)
       call reconcilefile(d_4af,size_4af)
       call ga_zero(d_4af)
      end if 
c
c
c
c     Pair's structure of the integral file
      call tce_mo2e_pairs(l_gpair,k_gpair,len_pair)
      len_pair = int_mb(k_gpair)
c
c
c alpha orbitals only
c
      if (.not.ma_push_get(mt_dbl,nbf*(iha+ipa)
     1  ,"sorted MO coeffs",
     2  l_movecs_orb,k_movecs_orb))
     3  call errquit('tce_mo2e_zone: MA problem 1',0,
     2    BASIS_ERR)
      call dfill(nbf*(iha+ipa),0.0d0, dbl_mb(k_movecs_orb), 1)
      do i=1,iha
      do isigma1=1,nbf
       dbl_mb(k_movecs_orb+(i-1)*nbf+isigma1-1)=
     & dbl_mb(k_movecs_sorted+(i-1)*nbf+isigma1-1)
      enddo
      enddo
      do i=iha+1,iha+ipa
      do isigma1=1,nbf
       dbl_mb(k_movecs_orb+(i-1)*nbf+isigma1-1)=
     & dbl_mb(k_movecs_sorted+(i+ihb-1)*nbf+isigma1-1)
      enddo
      enddo
c
c
      call int_mem_2e4c(work1,work2)
      if (.not.ma_push_get(mt_dbl,work1,'work1',l_work1,k_work1))
     1  call errquit('tce_ao2e: MA problem work1',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,work2,'work2',l_work2,k_work2))
     1  call errquit('tce_ao2e: MA problem work2',1,MA_ERR)
c
c
c 
c 4af file formed here
c
c
             cpu1 = - util_cpusec()
             wall1 = - util_wallsec()
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
      DO azone3 = 1,atpart      !sigma
      DO azone4 = azone3,atpart !rho
      IF (next.eq.count) THEN
c ---------------------------
        size_4a = nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
        if(.not.ma_push_get(mt_dbl,size_4a,'4a',l_4a,k_4a))
     1     call errquit('tce_4af_zones1: MA problem',0,MA_ERR)
        call dfill(size_4a, 0.0d0, dbl_mb(k_4a), 1)
         shift_mu = 0
         do mu    = a2length(azone2)+1,a2length(azone2+1)
            if (.not.bas_cn2bfr(ao_bas_han,mu,mu_lo,mu_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            mu_range = mu_hi - mu_lo + 1
         shift_nu = 0
         do nu    = a2length(azone1)+1,a2length(azone1+1)
            if (.not.bas_cn2bfr(ao_bas_han,nu,nu_lo,nu_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            nu_range = nu_hi - nu_lo + 1
         shift_rho = 0
         do rho   = a2length(azone4)+1,a2length(azone4+1)
            if (.not.bas_cn2bfr(ao_bas_han,rho,rho_lo,rho_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            rho_range = rho_hi - rho_lo + 1
         shift_sigma = 0
         do sigma = a2length(azone3)+1,a2length(azone3+1)
            if (.not.bas_cn2bfr(ao_bas_han,sigma,sigma_lo,sigma_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            sigma_range = sigma_hi - sigma_lo + 1
            if (schwarz_shell(rho,sigma)*schwarz_shell(mu,nu)
     1          .ge. tol2e) then
cccx            call dfill(work1, 0.0d0, dbl_mb(k_work1), 1)
cccx            call dfill(work2, 0.0d0, dbl_mb(k_work2), 1)
            call int_2e4c(ao_bas_han,mu,nu,ao_bas_han,rho,sigma,
     1           work2,dbl_mb(k_work2),work1,dbl_mb(k_work1))
c
            i=0
             do mu1     = 1,mu_range
             do nu1     = 1,nu_range
             do rho1    = 1,rho_range
             do sigma1  = 1,sigma_range
            i=i+1
            inu1=nu1+shift_nu
            isigma1=sigma1+shift_sigma
            imu1=mu1+shift_mu
            irho1=rho1+shift_rho
c (isigma1,irho1|inu1, imu1)
            ipos1=(((imu1-1)*nalength(azone1)+inu1-1)*
     1            nalength(azone4)+irho1-1)*nalength(azone3)
     2            +isigma1
            dbl_mb(k_4a+ipos1-1)=dbl_mb(k_work1+i-1)
            enddo
            enddo
            enddo
            enddo
            end if !schwarz  screening
         shift_sigma = shift_sigma + sigma_range
         enddo !sigma
         shift_rho   = shift_rho + rho_range
         enddo !rho
         shift_nu    = shift_nu + nu_range
         enddo !nu
         shift_mu    = shift_mu + mu_range
         enddo !mu
c
c fixing offsets and sf_writing
         key_4af=azone4 - 1 + atpart * (azone3 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
         call tce_hash(int_mb(k_4af_offset),key_4af,offset_4af)
      if(idiskl) then
        if (sf_write(d_4af,dfloat(bytes)*dfloat(offset_4af),
     1    dfloat(bytes)*dfloat(size_4a),dbl_mb(k_4a),request).ne.0)
     2    call errquit('zones put: sf problem2',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('zones put: sf problem3',2,DISK_ERR)
      else
        call ga_put(d_4af,offset_4af+1,offset_4af+size_4a,1,1,
     1    dbl_mb(k_4a),1)
      end if 
c closing l_4a file
        if (.not.ma_pop_stack(l_4a))
     1   call errquit('tcc_mo2e_4af2: l_4a',15,MA_ERR)
c ---------------------------
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO !azone4
      ENDDO !azone3
      ENDDO !azone2
      ENDDO !azone1
c
c
c
       call ga_sync()
c
c
c
         call ga_sync()
c
c
c
c
      next = nxtask(-nprocs,1)
c
c
      if(.not.idiskl) then
      call reconcilefile(d_4af,size_4af)
      end if
c
c
c
      max_na=0
      do ixi=1,atpart
       if(nalength(ixi).gt.max_na) max_na=nalength(ixi)
      enddo
        size_ic=2*((max_na)**4)+1
        size_icc=tile_dim*max_na
c
c
c
       if (.not.ma_push_get(mt_dbl,size_ic,'l_int',
     1  l_integral,k_integral))
     1  call errquit('tce_4s: MA problem l_int',0,MA_ERR)
c
       if (.not.ma_push_get(mt_dbl,size_icc,'l_coeff',
     1  l_coeff,k_coeff))
     1  call errquit('tce_4s: MA problem l_coeff',0,MA_ERR)
c
c
c
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO g3b = 1,noa+nva   !k
      DO g4b = g3b,noa+nva !l
      DO azone1 = 1,atpart !nu
      DO azone2 = azone1,atpart !mu
      IF (next.eq.count) THEN
c
             cpu1 = - util_cpusec()
             wall1 = - util_wallsec()
c
      size_2g2a=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1          *nalength(azone1)*nalength(azone2)
      if (.not.ma_push_get(mt_dbl,size_2g2a,'2g2a',l_2g2a,k_2g2a))
     1    call errquit('tce_r2_divide1: MA problem',0,MA_ERR)
      call dfill(size_2g2a, 0.0d0, dbl_mb(k_2g2a), 1)
c
      DO azone3 = 1,atpart      !sigma
      DO azone4 = azone3,atpart !rho
        size_4a = nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
        if(.not.ma_push_get(mt_dbl,size_4a,'4a',l_4a,k_4a))
     1     call errquit('tce_r2_divide2: MA problem',0,MA_ERR)
cccx        call dfill(size_4a, 0.0d0, dbl_mb(k_4a), 1)
c
c
c
c
         key_4af=azone4 - 1 + atpart * (azone3 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
         call tce_hash(int_mb(k_4af_offset),key_4af,offset_4af)
       if(idiskl) then 
        if (sf_read(d_4af,dfloat(bytes)*dfloat(offset_4af),
     1    dfloat(bytes)*dfloat(size_4a),dbl_mb(k_4a),request).ne.0)
     1     call errquit('zones get2: sf problem',1,DISK_ERR)
        if (sf_wait(request).ne.0)
     1    call errquit('zones get3: sf problem',2,DISK_ERR)
       else
        call ga_get(d_4af,offset_4af+1,offset_4af+size_4a,1,1,
     1    dbl_mb(k_4a),1)
       end if 
c
c
       tot_azone3_sh=tot_zone(azone3)
       tot_azone4_sh=tot_zone(azone4)
c
      if(azone3.ne.azone4) then !!============azone3.ne.azone4
c --- C_[g3][sigma]
       i = 0 
       do isigma1 =  1,nalength(azone3)
       do igi3    =  1,int_mb(k_range_alpha+g3b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g3b-1)+igi3-1)*nbf+tot_azone3_sh
     &       +isigma1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c --- C_[g3][sigma]([sigma]<[rho]|[nu] [mu])
c            zone3   zone3  zone4
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g3b-1),  !m
     1 nalength(azone1)*nalength(azone2)*nalength(azone4), !n
     1 nalength(azone3), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g3b-1), !lda
     1 dbl_mb(k_4a),nalength(azone3),          ! B,ldb
     1 0.0d0,dbl_mb(k_integral),
     1 int_mb(k_range_alpha+g3b-1))
c transposition ([g3][rho]|[nu][mu]) => ([rho][g3]|[nu][mu]) 
c
       size_aux=int_mb(k_range_alpha+g3b-1)*nalength(azone4)*
     1          nalength(azone1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux1: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g3b-1),nalength(azone4),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
      do i=1,size_aux
       dbl_mb(k_integral+i-1)=dbl_mb(k_aux+i-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux1',15,MA_ERR)
c C([g4][azone4=rho])
       i = 0
       do irho1   =  1,nalength(azone4)
       do igi4    =  1,int_mb(k_range_alpha+g4b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g4][azone4=rho])([rho][g3]|[azone1][azone2])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g4b-1),  !m
     1 nalength(azone1)*nalength(azone2)*int_mb(k_range_alpha+g3b-1), !n
     1 nalength(azone4), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g4b-1), !lda
     1 dbl_mb(k_integral),nalength(azone4),          ! B,ldb
     1 1.0d0,dbl_mb(k_2g2a),
     1 int_mb(k_range_alpha+g4b-1))
c  done with first  part of azone3.ne.azone4 case ----------------
c  transposition of atomic integrals
c  ([sigma=azone3][rho=azone4]|[nu][mu]) ==>
c  ([rho][sigma]|[nu][mu])
       size_aux=size_4a
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_4a),dbl_mb(k_aux),
     & nalength(azone3),nalength(azone4),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
ccx      if (.not.ma_pop_stack(l_aux))
ccx     1     call errquit('l_aux2',15,MA_ERR) ! see after dgemm
c C([g3][azone4=rho])
       i = 0
       do irho1   =  1,nalength(azone4)
       do igi3    =  1,int_mb(k_range_alpha+g3b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g3b-1)+igi3-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g3][azone4=rho])([rho=azone4][sigma=azone3]|[nu][mu])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g3b-1),  !m
     1 nalength(azone1)*nalength(azone2)*nalength(azone3), !n
     1 nalength(azone4), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g3b-1), !lda
     1 dbl_mb(k_aux),nalength(azone4),          ! B,ldb
     1 0.0d0,dbl_mb(k_integral),
     1 int_mb(k_range_alpha+g3b-1))
c
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c transposition ([g3][sigma]|[nu][mu]) => ([sigma][g3]|[nu][mu])
c
       size_aux=int_mb(k_range_alpha+g3b-1)*nalength(azone3)*
     1          nalength(azone1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux1: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g3b-1),nalength(azone3),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
      do i=1,size_aux
       dbl_mb(k_integral+i-1)=dbl_mb(k_aux+i-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux1',15,MA_ERR)
c C([g4][azone3=sigma])
       i = 0
       do isigma1   =  1,nalength(azone3)
       do igi4    =  1,int_mb(k_range_alpha+g4b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone3_sh
     &       +isigma1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g4][azone3=sigma])([sigma][g3]|[azone1][azone2])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g4b-1),  !m
     1 nalength(azone1)*nalength(azone2)*int_mb(k_range_alpha+g3b-1), !n
     1 nalength(azone3), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g4b-1), !lda
     1 dbl_mb(k_integral),nalength(azone3),          ! B,ldb
     1 1.0d0,dbl_mb(k_2g2a),
     1 int_mb(k_range_alpha+g4b-1))
      end if !azone3.ne.azone4
c
c
c
      if(azone3.eq.azone4) then
c --- C_[g3][sigma]
       i = 0 
       do isigma1 =  1,nalength(azone3)
       do igi3    =  1,int_mb(k_range_alpha+g3b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g3b-1)+igi3-1)*nbf+tot_azone3_sh
     &       +isigma1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c --- C_[g3][sigma]([sigma]=[rho]|[nu] [mu])
c            zone3   zone3  zone4
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g3b-1),  !m
     1 nalength(azone1)*nalength(azone2)*nalength(azone4), !n
     1 nalength(azone3), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g3b-1), !lda
     1 dbl_mb(k_4a),nalength(azone3),          ! B,ldb
     1 0.0d0,dbl_mb(k_integral),
     1 int_mb(k_range_alpha+g3b-1))
c transposition ([g3][rho]|[nu][mu]) => ([rho][g3]|[nu][mu]) 
c
       size_aux=int_mb(k_range_alpha+g3b-1)*nalength(azone4)*
     1          nalength(azone1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux1: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g3b-1),nalength(azone4),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
      do i=1,size_aux
       dbl_mb(k_integral+i-1)=dbl_mb(k_aux+i-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux1',15,MA_ERR)
c C([g4][azone4=rho])
       i = 0
       do irho1   =  1,nalength(azone4)
       do igi4    =  1,int_mb(k_range_alpha+g4b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g4][azone4=rho])([rho][g3]|[azone1][azone2])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g4b-1),  !m
     1 nalength(azone1)*nalength(azone2)*int_mb(k_range_alpha+g3b-1), !n
     1 nalength(azone4), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g4b-1), !lda
     1 dbl_mb(k_integral),nalength(azone4),          ! B,ldb
     1 1.0d0,dbl_mb(k_2g2a),
     1 int_mb(k_range_alpha+g4b-1))
      end if !azone3.eq.azone4
c
c
c
        if (.not.ma_pop_stack(l_4a))
     1   call errquit('tcc_mo2e_trans_zones: l_4a',15,MA_ERR)
      ENDDO !azone4
c one step ahead
      ENDDO !azone3
c
c
c
c
c
c
c g2 g1 do loops
c open (g4 g3 | all symmetry allowed g2 g1) - equally good we can split it into 
c                                              pieces
c (k,l|i,j) pieces
c
c   calculate point_pair index here
         ixi=noa+nva-g3b+1
         jxi=noa+nva-g4b+1
         point_pair=((noa+nva)*(noa+nva+1))/2-((ixi-1)*ixi)/2-jxi+1
         size_stripe=int_mb(k_gpair+point_pair)
         xoffset_p34 = int_mb(k_gpair+len_pair+point_pair)
         addr=int_mb(k_gpair+2*len_pair+point_pair)
c
c offset for blocking the (nu mu | g2 g1 ) = C*C matrix
c
      do i=1,1000
       key_start(i) = 0
       key_end(i)   = 0
       xoffset_g12(i)  = 0
       xoffset_size(i) = 0
       xoffset_size_p1p2(i) = 0
      enddo 
      imaxp12=0
      size_temp=0
      size_temp_4g=0
      xoffset_temp=0 
      xoffset_temp_4g=0
      size_p1p2=0
      i=1
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
       IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     & int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
       IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1)
     & ,ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq.
     & irrep_v) THEN
       IROW=INDEX_PAIR(g4b,g3b)
       ICOL=INDEX_PAIR(g2b,g1b)
       IF(IROW.GE.ICOL) THEN
         if(size_temp_4g.eq.0) then
          key_start(i)=icol
         end if
         size_temp=size_temp+int_mb(k_range_alpha+g2b-1)
     1          *int_mb(k_range_alpha+g1b-1)
     1          *nalength(azone1)*nalength(azone2)
         size_temp_4g=size_temp_4g+int_mb(k_range_alpha+g2b-1)
     1          *int_mb(k_range_alpha+g1b-1)
     2          *int_mb(k_range_alpha+g3b-1) 
     3          *int_mb(k_range_alpha+g4b-1)
         size_p1p2=size_p1p2+int_mb(k_range_alpha+g2b-1)
     1          *int_mb(k_range_alpha+g1b-1)
         ibuba=icol
c
c         if(size_temp.gt.max_size_temp) then
c has to be fully consistent with later part
c
         if(size_temp_4g.gt.max_size_temp) then
           xoffset_g12(i)=xoffset_temp_4g
           xoffset_size(i)=size_temp
           xoffset_size_p1p2(i)=size_p1p2
           xoffset_temp=xoffset_temp+size_temp
           xoffset_temp_4g=xoffset_temp_4g+size_temp_4g
           key_end(i)=icol
           size_temp=0
           size_temp_4g=0
           size_p1p2=0
           imaxp12=i
           i=i+1
          end if
       END IF
       END IF
       END IF
      ENDDO
      ENDDO
c
      if(size_temp_4g.ne.0) then
           xoffset_g12(i)=xoffset_temp_4g
           xoffset_size(i)=size_temp
           xoffset_size_p1p2(i)=size_p1p2
           key_end(i)=ibuba
           imaxp12=i
      end if
c
      if(i.gt.1000) 
     1  call errquit('tce_zone: xoffset-size-problem',0,MA_ERR)
c
c
      do i =1, imaxp12
        size_g12p=int_mb(k_range_alpha+g4b-1)*
     1                int_mb(k_range_alpha+g3b-1)*
     1                xoffset_size_p1p2(i)
        if (.not.ma_push_get(mt_dbl,size_g12p,'g12piece',
     1      l_g12piece,k_g12piece))
     1      call errquit('tce_zone: MA g12-piece ',0,MA_ERR)
c TRY IF THIS CAN BE BY-PASSED
        call dfill(size_g12p, 0.0d0, dbl_mb(k_g12piece), 1)
c
c
c
c
      offset_2g2z=0 !
c
c
c
      iend=0
      istart=0
      DO g1b = 1,noa+nva     !l
      DO g2b = g1b,noa+nva   !k 
       ICOL=INDEX_PAIR(g2b,g1b)
       IF(iend.eq.1) go to 4444
       if(istart.ne.1) then
        IF(ICOL.eq.key_start(i)) istart=1
       end if
       if(icol.eq.key_end(i)) iend=1
       IF(istart.eq.1) THEN
       IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     & int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
       IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1)
     & ,ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq.
     & irrep_v) THEN
       IROW=INDEX_PAIR(g4b,g3b)
       ICOL=INDEX_PAIR(g2b,g1b)
       IF(IROW.GE.ICOL) THEN
        tot_azone1_sh=tot_zone(azone1)
        tot_azone2_sh=tot_zone(azone2)
       if(azone1.ne.azone2) then !-----------------
c C_([mu-azone2][g2])
        ii=0
        do igi2    =  1,int_mb(k_range_alpha+g2b-1)
        do imu1    =  1,nalength(azone2)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone2_sh
     &           +imu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo 
c ([g4][g3]|[nu-azone1][mu-azone2])*C_([mu-azone2][g2])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   nalength(azone1),                                        !m
     1   int_mb(k_range_alpha+g2b-1),                             !n
     3   nalength(azone2),                                        !k
     4   1.0d0,dbl_mb(k_2g2a),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   nalength(azone1),
     6   dbl_mb(k_coeff),nalength(azone2),
     7   0.0d0,dbl_mb(k_integral),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   nalength(azone1))
c transposition ([g4][g3]|[nu-azone1][g2])=>([g4][g3]|[g2][nu-azone1])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *int_mb(k_range_alpha+g2b-1)*nalength(azone1)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     &int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1), 
     &nalength(azone1),int_mb(k_range_alpha+g2b-1), 
     &1,2,4,3,1.0d0)
      do ii=1,size_aux
       dbl_mb(k_integral+ii-1)=dbl_mb(k_aux+ii-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c C_([nu-azone1][g1])
        ii=0
        do igi1    =  1,int_mb(k_range_alpha+g1b-1)
        do inu1    =  1,nalength(azone1)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g1b-1)+igi1-1)*nbf+tot_azone1_sh
     &           +inu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[g2][nu-azone1])*C_([nu-azone1][g1])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   int_mb(k_range_alpha+g2b-1),                             !m
     1   int_mb(k_range_alpha+g1b-1),                             !n
     3   nalength(azone1),                                        !k
     4   1.0d0,dbl_mb(k_integral),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   int_mb(k_range_alpha+g2b-1),
     6   dbl_mb(k_coeff),nalength(azone1),
     7   1.0d0,dbl_mb(k_g12piece+offset_2g2z),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   int_mb(k_range_alpha+g2b-1))
c done with first  part of azone3.ne.azone4 case ----------------
c  transposition of atomic integrals
c  ([g4][g3]|[azone1-nu][azone2-mu]) ==>
c  ([g4][g3]|[azone2-mu][azone1-nu])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *nalength(azone1)*nalength(azone2) 
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_2g2a),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1),
     & nalength(azone1),nalength(azone2), 
     & 1,2,4,3,1.0d0)
ccx      if (.not.ma_pop_stack(l_aux))
ccx     1     call errquit('l_aux2',15,MA_ERR) ! see after dgemm
c C([azone1-nu][g2])
        ii=0
        do igi2    =  1,int_mb(k_range_alpha+g2b-1)
        do inu1    =  1,nalength(azone1)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone1_sh
     &           +inu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[azone2-mu][azone1-nu])*C([azone1-nu][g2])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   nalength(azone2),                                        !m
     1   int_mb(k_range_alpha+g2b-1),                             !n
     3   nalength(azone1),                                        !k
     4   1.0d0,dbl_mb(k_aux),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   nalength(azone2),
     6   dbl_mb(k_coeff),nalength(azone1),
     7   0.0d0,dbl_mb(k_integral),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   nalength(azone2))
c
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c transposition ([g4][g3]|[azone2-mu][g2])=>([g4][g3]|[g2][azone2-mu])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *int_mb(k_range_alpha+g2b-1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     &int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1),
     &nalength(azone2),int_mb(k_range_alpha+g2b-1),
     &1,2,4,3,1.0d0)
      do ii=1,size_aux
       dbl_mb(k_integral+ii-1)=dbl_mb(k_aux+ii-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c C([azone2-mu][g1])
        ii=0
        do igi1    =  1,int_mb(k_range_alpha+g1b-1)
        do imu1    =  1,nalength(azone2)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g1b-1)+igi1-1)*nbf+tot_azone2_sh
     &           +imu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[g2][azone2-mu])*C([azone2-mu][g1])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   int_mb(k_range_alpha+g2b-1),                             !m
     1   int_mb(k_range_alpha+g1b-1),                             !n
     3   nalength(azone2),                                        !k
     4   1.0d0,dbl_mb(k_integral),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   int_mb(k_range_alpha+g2b-1),
     6   dbl_mb(k_coeff),nalength(azone2),
     7   1.0d0,dbl_mb(k_g12piece+offset_2g2z),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   int_mb(k_range_alpha+g2b-1))
c
        offset_2g2z=offset_2g2z+int_mb(k_range_alpha+g4b-1)*
     1    int_mb(k_range_alpha+g3b-1)*int_mb(k_range_alpha+g2b-1)*
     1    int_mb(k_range_alpha+g1b-1)
       end if ! azone1.ne.azone2 !-----------------
c
c second part 
c
        if(azone1.eq.azone2) then
c C_([mu-azone2][g2])
        ii=0
        do igi2    =  1,int_mb(k_range_alpha+g2b-1)
        do imu1    =  1,nalength(azone2)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone2_sh
     &           +imu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo 
c ([g4][g3]|[nu-azone1][mu-azone2])*C_([mu-azone2][g2])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   nalength(azone1),                                        !m
     1   int_mb(k_range_alpha+g2b-1),                             !n
     3   nalength(azone2),                                        !k
     4   1.0d0,dbl_mb(k_2g2a),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   nalength(azone1),
     6   dbl_mb(k_coeff),nalength(azone2),
     7   0.0d0,dbl_mb(k_integral),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   nalength(azone1))
c transposition ([g4][g3]|[nu-azone1][g2])=>([g4][g3]|[g2][nu-azone1])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *int_mb(k_range_alpha+g2b-1)*nalength(azone1)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     &int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1), 
     &nalength(azone1),int_mb(k_range_alpha+g2b-1), 
     &1,2,4,3,1.0d0)
      do ii=1,size_aux
       dbl_mb(k_integral+ii-1)=dbl_mb(k_aux+ii-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c C_([nu-azone1][g1])
        ii=0
        do igi1    =  1,int_mb(k_range_alpha+g1b-1)
        do inu1    =  1,nalength(azone1)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g1b-1)+igi1-1)*nbf+tot_azone1_sh
     &           +inu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[g2][nu-azone1])*C_([nu-azone1][g1])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   int_mb(k_range_alpha+g2b-1),                             !m
     1   int_mb(k_range_alpha+g1b-1),                             !n
     3   nalength(azone1),                                        !k
     4   1.0d0,dbl_mb(k_integral),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   int_mb(k_range_alpha+g2b-1),
     6   dbl_mb(k_coeff),nalength(azone1),
     7   1.0d0,dbl_mb(k_g12piece+offset_2g2z),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   int_mb(k_range_alpha+g2b-1))
c
        offset_2g2z=offset_2g2z+int_mb(k_range_alpha+g4b-1)*
     1    int_mb(k_range_alpha+g3b-1)*int_mb(k_range_alpha+g2b-1)*
     1    int_mb(k_range_alpha+g1b-1)
c
        end if !azone1.eq.azone2
c !---------------------------------------------------------------------
       END IF ! irow.gt.icol
       END IF ! symmetry
       END IF ! spin
       END IF ! istart
      ENDDO  ! g2b-loop ends up here
      ENDDO  ! g1b-loop ends up here
c 
 4444 continue
c
c now put here add_block
      call add_block(d_v2,dbl_mb(k_g12piece),size_g12p,
     &               xoffset_p34+xoffset_g12(i))
      istart=0
c
c
cccx         if (.not.ma_pop_stack(l_2g2z))
cccx     1   call errquit('tcc_mo2e_trans_zones: l_2g2z',15,MA_ERR)
         if (.not.ma_pop_stack(l_g12piece))
     1   call errquit('tcc_mo2e_trans_zones: l_g12piece',15,MA_ERR)
      ENDDO  ! i = 1,imaxp12 
c
c 
c

      if (.not.ma_pop_stack(l_2g2a))
     1  call errquit('tcc_mo2e_trans_zones: MA problem',15,MA_ERR)
c
c
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO !azone2
      ENDDO !azone1
      ENDDO !g4b
      ENDDO !g3b
c
      next = nxtask(-nprocs,1)
c
       call reconcilefile(d_v2,size_2e)
c
c
      if (.not.ma_pop_stack(l_coeff))
     1  call errquit('tcc_off_4a: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_integral))
     1  call errquit('tcc_off_4a: MA problem',15,MA_ERR)
c
c
c *** debug ***
c
c      if(nodezero) then
c      write(6,*)'DONE --- DONE ---- DONE ---- DONE'
c      end if
c
c *************
      if (.not.ma_pop_stack(l_work2))
     1  call errquit('tcc_ao2e: MA problem',14,MA_ERR)
      if (.not.ma_pop_stack(l_work1))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_movecs_orb))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_gpair))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
c
c
      if(idiskl) then
cccx        if (parallel) then
cccx          call ga_sync()
cccx          if (sf_open(d_4af).ne.0)
cccx     1      call errquit('deletefile: sf problem',0,DISK_ERR)
cccx        endif
ccx      if (.not.sf_destroy(d_4af))
ccx     1  call errquit('tcc_sf_destroy2: sf problem',15,MA_ERR)
        if (parallel) call ga_sync()
      else
       call deletefile(d_4af)
      end if
c
c
c
      if (.not.ma_pop_stack(l_4af_offset))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
      call ga_sync()
c *** debug ***
c 800  format('DGEMM1 MAX',i5,2x,3f15.5)
c 801  format('DGEMM2 ',i5,2x,3f15.5)
 9000 format('PART1',i4,1x,'Cpu  wall ',2(f17.12,1x),3x,'g4b g3b',2i5)
c 9001 format('PART2',i4,1x,'Cpu  wall ',2(f17.12,1x),3x,'g4b g3b',2i5)
c 9003 format('PART1-4a',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9004 format('PART1-2g2z',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9005 format('PART1-dgemm',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9010 format('  P1-mnrs',i3,1x,2i5,1x,2i5,1x,'Cpu  wall ',2(f17.12,1x))
  555  format('atom loop ',2x,i5,3x,2i5,3x,2i5,i12)
  556  format('atom time',2x,i5,3x,2i5,3x,2i5,'Cpu wall ',2(f12.7,1x))
  777  format('main do loop ',2x,i5,3x,2i5,3x,2i5)
  775  format('main loop step1 ',2x,i5,3x,2i5,3x,2i5)
  776  format('main loop step2 ',2x,i5,3x,2i5,3x,2i5)
  778  format('PART1',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',2(f17.12,1x))
  779  format('PART2',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',2(f17.12,1x))
  780  format('ADD BLOCK',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',
     &        2(f17.12,1x))
c *************
c
      RETURN
      END

      SUBROUTINE ccsdtq_lambda1_23_3_1(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsdtq_lambda1_23_3_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h4 p14 h16 p1 )_ytt + = 1 * Sum ( h6 ) * t ( p14 h6 )_t * i3 ( h4 h6 h16 p1 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p14b
      INTEGER h4b
      INTEGER p1b
      INTEGER h16b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h6b
      INTEGER p14b_1
      INTEGER h6b_1
      INTEGER h4b_2
      INTEGER h6b_2
      INTEGER p1b_2
      INTEGER h16b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p14b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO h16b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+p14b-
     &1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+h16b-1).ne.8)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+p14b-1) .eq. int_mb(k_spin+
     &p1b-1)+int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+p14b-1),ieor(int_mb
     &(k_sym+p1b-1),int_mb(k_sym+h16b-1)))) .eq. ieor(irrep_y,ieor(irrep
     &_t,irrep_t))) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+p14b-1) * int_mb(k_r
     &ange+p1b-1) * int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_23_3_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h6b = 1,noab
      IF (int_mb(k_spin+p14b-1) .eq. int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p14b-1),int_mb(k_sym+h6b-1)) .eq. irrep_t) T
     &HEN
      CALL TCE_RESTRICTED_2(p14b,h6b,p14b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h4b,h6b,p1b,h16b,h4b_2,h6b_2,p1b_2,h16b_2)
      dim_common = int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1) * int_mb
     &(k_range+h16b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_23_3_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_23_3_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (p14b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p14b-1
     &),int_mb(k_range+h6b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_23_3_1',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_23_3_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_23_3_1',5,MA_ERR)
      IF ((h6b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h16b_
     &2 - 1 + noab * (p1b_2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h6b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+h16b-1
     &),4,3,2,1,-1.0d0)
      END IF
      IF ((h4b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h16b_
     &2 - 1 + noab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h4b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_mb(k_range+h16b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_23_3_1',6
     &,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_23_3
     &_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_23_3
     &_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_23_3_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h16b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+p14b-
     &1),3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (p1b - noab - 1 + nvab * (p14b - noab - 1 + nvab * (h
     &4b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_23_3_1',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_23_3
     &_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

c
c $Id: qmmm_output.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c
      subroutine qmmm_print_header()
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm_data.fh"
#include "qmmm_params.fh"
#include "rtdb.fh"
#include "qmmm.fh"
#include "global.fh"
#include "stdio.fh"

      character*48 string

      if(ga_nodeid().eq.0) then
      
        string = "     NWChem QM/MM Interface Module"
        call banner(luout, 
     >      string,
     >      "*", .true. , .false., .true.)
        string = " "
        call banner(luout, 
     >      string,
     >      "*", .false., .false., .true.)

        string = "     Developed Marat Valiev 2004"
        call banner(luout, 
     >      string,
     >      "*", .false., .true., .true.)
        
        call util_flush(luout)
      end if
      

      end

      subroutine qmmm_print_params(irtdb)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm_data.fh"
#include "qmmm_params.fh"
#include "rtdb.fh"
#include "qmmm.fh"
#include "stdio.fh"

      integer irtdb
c
      character*32 tag
      character*32 pname
      character*32 optimization
      real*8 eatoms
      integer linkatm,bq_exclude

      
      pname = "qmmm_print_header:"

      tag = "qmmm:uqmatm"
      if (.not.rtdb_get(irtdb,"qmmm:uqmatm",mt_dbl,1,eatoms)) then
           call errquit(pname//'failed to get '//tag,0,
     >       RTDB_ERR)
      end if

      tag ="qmmm:bq_exclude" 
      if (.not.rtdb_get(irtdb,tag,mt_int,1,bq_exclude)) then
           call errquit(pname//'failed to store bq_exclude',0,
     >       RTDB_ERR)
      end if
c
      tag ="qmmm:linkatm" 
      if (.not.rtdb_get(irtdb,tag,mt_int,1,linkatm)) then
           call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
       end if
c
      tag ="qmmm:optimization"
      if (.not.rtdb_cget(irtdb,tag,1,optimization)) then
           call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
      end if

      if(.not.qmmm_master()) return

      call util_print_centered(luout,
     A     "QM/MM Interface Parameters",32,.true.)

      tag = "qmmm:uqmatm"
      write(luout,20) "reference energy",tag,eatoms

      tag ="qmmm:bq_exclude" 
      if(bq_exclude.eq.qmmm_hydrogen) then
        write(luout,22) "excluded bq's",tag,
     V        "hydrogens bonded to link atoms"
      else if(bq_exclude.eq.qmmm_all_atoms) then
        write(luout,22) "excluded bq's",tag,"all"
      else if(bq_exclude.eq.qmmm_no_atoms) then
        write(luout,22) "excluded bq's",tag,"none"
      else
        call errquit(pname//'invalid bq_exclude',0,RTDB_ERR)
      end if
      
      tag ="qmmm:linkatm" 
      if(linkatm.eq.qmmm_hydrogen) then
        write(luout,22) "link atom type",tag,"hydrogens"
      else if(linkatm.eq.qmmm_halogen) then
        write(luout,22) "link atom type",tag,"halogens"
      else
        call errquit(pname//'invalid link atom type',0,RTDB_ERR)
      end if

      tag ="qmmm:optimization"
      write(luout,22) "optimization region",tag,optimization


20    FORMAT(A,T24,A,T46,F12.6)
21    FORMAT(A,T24,A,T46,L3)
22    FORMAT(A,T24,A,T46,A)


      end

      subroutine qmmm_print_energy(irtdb)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm_data.fh"
#include "qmmm_params.fh"
#include "rtdb.fh"
#include "qmmm.fh"

      integer irtdb
c
      character*32 pname
      double precision energy, mm_energy, qm_energy,eatoms
      double precision bq_el_energy,bq_energy,bq_nuc_energy,eqm0

      
      pname = "qmmm_print_energy:"


      if (.not.rtdb_get(irtdb,'qmmm:uqmatm',mt_dbl,1,eatoms))
     $     call errquit('qmmm: failed getting  ref energy',0,RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:qm_energy',mt_dbl,1,qm_energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:mm_energy',mt_dbl,1,mm_energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:energy',mt_dbl,1,energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'dft:bq_energy',mt_dbl,1,bq_el_energy))
     $     bq_el_energy = 0.0d0

      if (.not. rtdb_get(irtdb,'qmmm:bq_nuc_energy',mt_dbl,1,
     >                   bq_nuc_energy))
     $     bq_nuc_energy = 0.0d0

      bq_energy = bq_el_energy + bq_nuc_energy
      eqm0 = qm_energy-bq_energy

      if(.not.qmmm_master()) return

      write(*,19) 
      write(*,21) "QM/MM Energy"
      write(*,19) 
      write(*,21) "quantum energy", qm_energy, qm_energy*cau2kj
      write(*,21) "quantum energy adjusted", qm_energy-eatoms,
     >            (qm_energy-eatoms)*cau2kj
      if(bq_energy.ne.0.0d0) then
        write(*,21) "quantum energy internal", eqm0,
     >               eqm0*cau2kj
        write(*,21) "Bq-nuclear energy", bq_nuc_energy, 
     >               bq_nuc_energy*cau2kj
        write(*,21) "Bq-electron energy", bq_el_energy, 
     >               bq_el_energy*cau2kj
      end if
      write(*,21) "classical energy", mm_energy,
     >            mm_energy*cau2kj
      write(*,21) "total qmmm energy", energy, energy*cau2kj
      write(*,19) 

      write(*,*) 
19    FORMAT(72("-"))
20    FORMAT(1X,A,T34,F18.9)
21    FORMAT(1X,A,T34,F18.9," (",E12.6,2X, "kjoule/mol)")


      end

      subroutine qmmm_print_spring_energy(irtdb)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm_data.fh"
#include "qmmm_params.fh"
#include "rtdb.fh"
#include "qmmm.fh"

      integer irtdb
c
      character*32 pname
      double precision e,deds,s

      if (.not. rtdb_get(irtdb,'qmmm:spring_e',mt_dbl,
     +                    1,e))
     + return 

      if (.not. rtdb_get(irtdb,'qmmm:spring_s',mt_dbl,
     +                    1,s))
     + call errquit(pname//'Failed to get spring_s',
     + 1, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:spring_deds',mt_dbl,
     +                    1,deds))
     + call errquit(pname//'Failed to get spring_deds',
     + 1, RTDB_ERR)

      if(.not.qmmm_master()) return

      write(*,21) "spring energy, derivative,length", e,deds,s

21    FORMAT(1X,A,T34,3E12.6)


      end

      subroutine qmmm_print_energy3(irtdb)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm_data.fh"
#include "qmmm_params.fh"
#include "rtdb.fh"
#include "qmmm.fh"

      integer irtdb
c
      character*32 pname
      double precision energy, mm_energy, qm_energy,eatoms
      double precision bq_energy
      double precision bq_el_energy,bq_nuc_energy,eqm0

      
      pname = "qmmm_print_energy:"


      if (.not.rtdb_get(irtdb,'qmmm:uqmatm',mt_dbl,1,eatoms))
     $     call errquit('qmmm: failed getting  ref energy',0,RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:qm_energy',mt_dbl,1,qm_energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:mm_energy',mt_dbl,1,mm_energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:energy',mt_dbl,1,energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'dft:bq_energy',mt_dbl,1,bq_el_energy))
     $     bq_el_energy = 0.0d0

      if (.not. rtdb_get(irtdb,'qmmm:bq_nuc_energy',mt_dbl,1,
     >                   bq_nuc_energy))
     $     bq_nuc_energy = 0.0d0

      bq_energy = bq_el_energy + bq_nuc_energy
      eqm0 = qm_energy-bq_energy


      if(.not.qmmm_master()) return

      write(*,19) 
      write(*,21) "QM/MM Energy"
      write(*,19) 
      write(*,21) "quantum energy", qm_energy, qm_energy*cau2kj
      write(*,21) "quantum energy adjusted", qm_energy-eatoms,
     >            (qm_energy-eatoms)*cau2kj
      if(bq_energy.ne.0.0d0) then
        write(*,21) "quantum energy internal", eqm0,
     >               eqm0*cau2kj
        write(*,21) "Bq-nuclear energy", bq_nuc_energy, 
     >               bq_nuc_energy*cau2kj
        write(*,21) "Bq-electron energy", bq_el_energy, 
     >               bq_el_energy*cau2kj
      end if
      write(*,21) "classical energy", mm_energy,
     >            mm_energy*cau2kj
      write(*,21) "total qmmm energy", energy, energy*cau2kj
      write(*,19) 

      write(*,*) 
19    FORMAT("@",72("-"))
20    FORMAT("@",1X,A,T34,F18.9)
21    FORMAT("@",1X,A,T34,F18.9," (",E12.6,2X, "kjoule/mol)")


      end

      subroutine qmmm_print_energy2(irtdb)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm_data.fh"
#include "qmmm_params.fh"
#include "rtdb.fh"
#include "qmmm.fh"

      integer irtdb
c
      character*32 pname
      double precision energy, mm_energy, qm_energy,eatoms
      double precision bq_energy

      
      pname = "qmmm_print_energy:"


      if (.not.rtdb_get(irtdb,'qmmm:uqmatm',mt_dbl,1,eatoms))
     $     call errquit('qmmm: failed getting  ref energy',0,RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:qm_energy',mt_dbl,1,qm_energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

c      if (.not. rtdb_get(irtdb,'qmmm:mm_energy',mt_dbl,1,mm_energy))
c     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'qmmm:energy',mt_dbl,1,energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_get(irtdb,'dft:bq_energy',mt_dbl,1,bq_energy))
     $     bq_energy = 0.0d0

      if(.not.qmmm_master()) return

      mm_energy = energy-qm_energy+eatoms

      write(*,19) 
      write(*,21) "QM/MM Energy"
      write(*,19) 
      write(*,21) "quantum energy", qm_energy, qm_energy*cau2kj
      if(bq_energy.ne.0.0d0) 
     >  write(*,21) "Bq-electron energy", bq_energy, bq_energy*cau2kj
      write(*,21) "quantum energy adjusted", qm_energy-eatoms,
     >            (qm_energy-eatoms)*cau2kj
      write(*,21) "classical energy", mm_energy,
     >            mm_energy*cau2kj
      write(*,21) "total qmmm energy", energy, energy*cau2kj
      write(*,19) 

      write(*,*) 
19    FORMAT(72("-"))
20    FORMAT(1X,A,T34,F18.9)
21    FORMAT(1X,A,T34,F18.9," (",E12.6,2X, "kjoule/mol)")


      end

      subroutine qmmm_print_energy1(irtdb,tot_energy,qm_energy)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "qmmm_data.fh"
#include "qmmm_params.fh"
#include "rtdb.fh"
#include "qmmm.fh"

      integer irtdb
      double precision tot_energy
      double precision energy, mm_energy, qm_energy,eatoms
c
      character*32 pname

      
      pname = "qmmm_print_energy1"


      if (.not.rtdb_get(irtdb,'qmmm:uqmatm',mt_dbl,1,eatoms))
     $     call errquit('qmmm: failed getting  ref energy',0,RTDB_ERR)

      energy = tot_energy

      qm_energy = qm_energy/cau2kj
      energy = energy/cau2kj
      mm_energy=energy-qm_energy
      qm_energy = qm_energy+eatoms


      if (.not. rtdb_put(irtdb,'qmmm:qm_energy',mt_dbl,1,qm_energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_put(irtdb,'qmmm:mm_energy',mt_dbl,1,mm_energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      if (.not. rtdb_put(irtdb,'qmmm:energy',mt_dbl,1,energy))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)

      call qmmm_print_energy(irtdb)

      end

*
* $Id: types.f 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine type1(a,b,alpha,beta,q,e,NIN,NDIM,record)
C
C-----------------------------------------------------------------------
C
C     This routine reads Fann's matrices, i.e., alpha's/beta's,
C     and computes the representation a's/b's, and q's/e's. 
C
C-----------------------------------------------------------------------
C
      integer          NDIM,NIN
      double precision a(*),alpha(*),b(*),beta(*),e(*),q(*)
      character        record*48
C
      double precision zero
      parameter        (zero=0.0d0)
      integer          i,j
      double precision shift
      character        matrix*24,string*24
C
      intrinsic        sqrt
C
C.... read the alpha's and beta's ......................................
C
cgif      call parser (record,string)
cgif      read (string,fmt='(a)') matrix
cgif      call parser (record,string)
cgif      read (string,fmt='(e24.0)') shift
C
cgif      open (9,err=1,file=matrix,form='formatted')
cgif      read (9,err=1,fmt=*) NIN 
cgif      if ( NIN.GT.NDIM ) stop 'TYPE1: not enough space in Z'
cgif      read (9,err=1,fmt=*) (j,alpha(i),beta(i),i=1,NIN)
C
cgif      do j = 1,NIN-1
cgif         alpha(j) = alpha(j) + shift
cgif         beta(j) = beta(j+1)
cgif      end do
cgif      alpha(NIN) = alpha(NIN) + shift
C
C.... compute the q's and e's ..........................................
C
      q(1) = alpha(1)
      do j = 1,NIN-1
         e(j) = (beta(j)/q(j)) * beta(j)
         q(j+1) = alpha(j+1) - e(j) 
         if ( q(j+1).lt.zero ) 
     &      STOP 'Matrix is not positive definite, change shift'
      end do 
C
C.... compute the a's and b's ..........................................
C
      a(1) = sqrt(q(1))
      do i=1,NIN-1
         b(i) = sqrt(e(i))
         a(i+1) = sqrt(q(i+1))
      end do
C
      return
    1 stop '* I/O error, check file for Fann''s matrix'
      end
C
C***********************************************************************
C
      subroutine TYPE2 (a,b,alpha,beta,q,e,NIN,NDIM,record)
C
C-----------------------------------------------------------------------
C
C     This routine reads parameters for Gamma glued matrices, i.e.,
C     ncopies and gamma, and computes the representation alpha's/
C     beta's, a's/b's, and q's/e's.      
C
C-----------------------------------------------------------------------
C
      integer          NDIM,NIN
      double precision a(*),alpha(*),b(*),beta(*),e(*),q(*)
      character        record*48
C
      double precision zero
      parameter        (zero=0.0d0)
      integer          j,k,ncopies,N
      double precision gamma
      character        string*24
C
      intrinsic        dble
C
      call parser (record,string)
      read (string,fmt='(i24)') ncopies
      call parser (record,string)
      read (string,fmt='(e24.0)') gamma
C
      N = 11
      NIN = N*ncopies 
      if ( NIN.GT.NDIM ) stop 'TYPE2: not enough space in Z'
C
C.... compute the a's and b's ..........................................
C
      do j = 1,NIN-1
         b(j) = dble(1)
      end do
      do k = 0,ncopies-1
         a( 1+k*11) = dble( 1)
         a( 2+k*11) = dble(11)
         a( 3+k*11) = dble(21)
         a( 4+k*11) = dble(31)
         a( 5+k*11) = dble(41)
         a( 6+k*11) = dble(51)
         a( 7+k*11) = dble(41)
         a( 8+k*11) = dble(31)
         a( 9+k*11) = dble(21)
         a(10+k*11) = dble(11)
         a(11+k*11) = dble( 1)
         b(10+k*11) = gamma
      end do
C
C.... compute the alpha's and beta's ...................................
C
      alpha(1) = a(1)**2
      do j = 1,NIN-1
         beta(j) = a(j)*b(j)
         alpha(j+1) = a(j+1)**2 + b(j)**2
      end do
C
C.... compute the q's and e's ..........................................
C
      do j = 1,NIN-1
         q(j) = a(j)**2
         e(j) = b(j)**2 
      end do
      q(NIN) = a(NIN)**2
      e(NIN) = zero
C
      return
      end
C
C***********************************************************************
C
      subroutine TYPE3 (a,b,alpha,beta,q,e,NIN,NDIM,record)
C
C-----------------------------------------------------------------------
C
C     This routine reads Inder's matrices, i.e., a's and b's, and
C     computes the representation alpha's/beta's and q's/e's. 
C
C-----------------------------------------------------------------------
C
      integer          NDIM,NIN
      double precision a(*),alpha(*),b(*),beta(*),e(*),q(*)
      character        record*48
C
      double precision zero
      parameter        (zero=0.0d0)
      integer          i
      character        matrix*24,string*24
C
C.... read the a's and b's .............................................
C
      call parser (record,string)
      read (string,fmt='(a)') matrix
C
      open (9,err=1,file=matrix,form='formatted')
      read (9,err=1,fmt=*) NIN 
      if ( NIN.GT.NDIM ) stop 'TYPE3: not enough space in Z'
C
      read (9,err=1,fmt=*) (a(i),i=1,NIN  )
      read (9,err=1,fmt=*) (b(i),i=1,NIN-1)
C
C.... compute the alpha's and beta's ...................................
C
      alpha(1) = a(1)**2
      do i = 1,NIN-1
         beta(i) = a(i)*b(i)
         alpha(i+1) = a(i+1)**2 + b(i)**2
      end do
C
C.... compute the q's and e's ..........................................
C
      do i = 1,NIN-1
         q(i) = a(i)**2
         e(i) = b(i)**2 
      end do
      q(NIN) = a(NIN)**2
      e(NIN) = zero
C
      return
    1 stop '* I/O error, check file for Inder''s matrix'
      end
C
C***********************************************************************
C
      subroutine TYPE4 (a,b,alpha,beta,q,e,NIN,NDIM,record)
C
C-----------------------------------------------------------------------
C
C     This routine generates a one_two_one matrix of dimension NIN
C     in the representation alpha's/beta's, a's/b's, and q's/e's.
C
C-----------------------------------------------------------------------
C
      integer          NDIM,NIN
      double precision a(*),alpha(*),b(*),beta(*),e(*),q(*)
      character        record*48
C
      double precision zero
      parameter        (zero=0.0d0)
      integer          i,j
      character        string*24
C
      intrinsic        sqrt
C
C.... read the alpha's and beta's ......................................
C
      call parser (record,string)
      read (string,fmt='(i24)') NIN

      if ( NIN.GT.NDIM ) stop 'TYPE4: not enough space in Z'
C
      do j = 1,NIN-1
         alpha(j) = 2.0d0
         beta(j) = 1.0d0
      end do
      alpha(NIN) = 2.0d0
C
C.... compute the q's and e's ..........................................
C
      q(1) = alpha(1)
      do j = 1,NIN-1
         e(j) = (beta(j)/q(j)) * beta(j)
         q(j+1) = alpha(j+1) - e(j) 
         if ( q(j+1).lt.zero ) 
     &      STOP 'Matrix is not positive definite, change shift'
      end do 
C
C.... compute the a's and b's ..........................................
C
      a(1) = sqrt(q(1))
      do i=1,NIN-1
         b(i) = sqrt(e(i))
         a(i+1) = sqrt(q(i+1))
      end do
C
      return
      end
C
C***********************************************************************
C
      subroutine TYPE5 (a,b,alpha,beta,q,e,NIN,NDIM,record)
C
C-----------------------------------------------------------------------
C
C     This routine reads parameters for generating a random matrix
C     and computes the representation alpha's/beta's, a's/b's, and 
C     q's/e's.      
C
C-----------------------------------------------------------------------
C
      integer          NDIM,NIN
      double precision a(*),alpha(*),b(*),beta(*),e(*),q(*)
      character        record*48
C
      double precision zero
      parameter        (zero=0.0d0)
      integer          iseed(4),j
      character        string*24
C
      double precision dnrm2
      intrinsic        dble
C
      call parser (record,string)
      read (string,fmt='(i24)') NIN
C
      if ( NIN.GT.NDIM ) stop 'TYPE5: not enough space in Z'
C
C.... compute the a's and b's ..........................................
C
      do j = 1,NIN
         iseed(1) = j
         iseed(2) = j + 1
         iseed(3) = j + 2
         iseed(4) = 2*j + 3
         call dlarnv(3,iseed,NIN+1-j,alpha)
         a(j) = dnrm2(NIN+1-j,alpha,1)
         iseed(1) = j
         iseed(2) = j + 1
         iseed(3) = j + 2
         iseed(4) = 2*j + 11
         call dlarnv(3,iseed,NIN-j,alpha)
         b(j) = dnrm2(NIN-j,alpha,1)
      end do
C
C.... compute the alpha's and beta's ...................................
C
      alpha(1) = a(1)**2
      do j = 1,NIN-1
         beta(j) = a(j)*b(j)
         alpha(j+1) = a(j+1)**2 + b(j)**2
      end do
C
C.... compute the q's and e's ..........................................
C
      do j = 1,NIN-1
         q(j) = a(j)**2
         e(j) = b(j)**2 
      end do
      q(NIN) = a(NIN)**2
      e(NIN) = zero
C
      return
      end
C
C***********************************************************************
C
      subroutine parser (record,string)
C
      integer   i,j
      character char*1,record*40,string*24
      logical   advance
C
      i = 0
      j = 0
      string = ' '
      advance = .true.
C
      do while ( advance )
         i = i + 1
         char = record(i:i)
         if ( char.ne.' ' .and. char.ne.',' ) then
            j = j + 1
            string(j:j) = char
         else 
            record(i:i) = ' '
            advance = j.eq.0 
         end if
      end do
C
      record = record(i+1:40)
C
      return
      end

*
*     ***********************************
*     *					*
*     *	        K1dB_SumAll		*	
*     *					*
*     ***********************************

      subroutine K1dB_SumAll(sum)
c     implicit none
      real*8  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "K1dB.fh"


*     **** external functions ****
      integer  Parallel3d_comm_k
      external Parallel3d_comm_k
    
      if (np_k.gt.1) then
         call GA_PGROUP_DGOP(Parallel3d_comm_k(),
     >                       9+MSGDBL,sum,1,'+')
      end if

      return
      end


*     ***********************************
*     *					*
*     *	        K1dB_ISumAll		*	
*     *					*
*     ***********************************

      subroutine K1dB_ISumAll(sum)
c     implicit none
      integer  sum


#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "K1dB.fh"


*     **** external functions ****
      integer  Parallel3d_comm_k
      external Parallel3d_comm_k



      if (np_k.gt.1) then
        call GA_PGROUP_IGOP(Parallel3d_comm_k(),
     >                      9+MSGINT,sum,1,'+')
      end if

      return
      end





*     ***********************************
*     *                                 *
*     *         K1dB_MaxAll             *
*     *                                 *
*     ***********************************
      subroutine K1dB_MaxAll(sum)
c     implicit none
      real*8  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "K1dB.fh"

*     **** external functions ****
      integer  Parallel3d_comm_k
      external Parallel3d_comm_k

      if (np_k.gt.1) then
         call GA_PGROUP_DGOP(Parallel3d_comm_k(),
     >                       9+MSGDBL,sum,1,'max')
      end if
      return
      end

*     ***********************************
*     *                                 *
*     *         K1dB_MinAll             *
*     *                                 *
*     ***********************************
      subroutine K1dB_MinAll(sum)
c     implicit none
      real*8  sum

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "K1dB.fh"


*     **** external functions ****
      integer  Parallel3d_comm_k
      external Parallel3d_comm_k

      if (np_k.gt.1) then
         call GA_PGROUP_DGOP(Parallel3d_comm_k(),
     >                       9+MSGDBL,sum,1,'min')
      end if

      return
      end



*     ***********************************
*     *					*
*     *	        K1dB_Vector_SumAll	*	
*     *					*
*     ***********************************

      subroutine K1dB_Vector_SumAll(n,sum)
c     implicit none
      integer n
      real*8  sum(*)

#include "mafdecls.fh"

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "errquit.fh"
#include "K1dB.fh"



*     **** external functions ****
      integer  Parallel3d_comm_k
      external Parallel3d_comm_k


      if (np_k.gt.1) then
         call GA_PGROUP_DGOP(Parallel3d_comm_k(),
     >                       9+MSGDBL,sum,n,'+')
      end if
      return
      end


*     ***********************************
*     *					*
*     *	        K1dB_Vector_ISumAll	*	
*     *					*
*     ***********************************

      subroutine K1dB_Vector_ISumAll(n,sum)
c     implicit none
      integer n
      integer  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"

#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "K1dB.fh"


*     **** external functions ****
      integer  Parallel3d_comm_k
      external Parallel3d_comm_k


      if (np_k.gt.1) then
        call GA_PGROUP_IGOP(Parallel3d_comm_k(),
     >                      9+MSGINT,sum,n,'+')
      end if

      return
      end


c $Id: K1dB-tcgmsg.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_pme_coeff(bmod,barr)
c
      implicit none
c
#include "argos_pme_common.fh"
c
      real*8 bmod(ngmax,3),barr(ngmax)
c
      real*8 w,arr(25),darr(25)
      integer i
c
      w=zero
c
      call argos_pme_splfil(w,arr,darr)
c
      do 1 i=1,ngmax
      barr(i)=zero
    1 continue
c
      do 2 i=2,morder+1
      barr(i)=arr(i-1)
    2 continue
c
      call argos_pme_dftmod(bmod(1,1),barr,ngx)
      call argos_pme_dftmod(bmod(1,2),barr,ngy)
      call argos_pme_dftmod(bmod(1,3),barr,ngz)
c
      return
      end
c $Id: argos_pme_coeff.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_space_prefetch_p(n,iwl,xw,pw,pwp,isl,xs,ps,psp)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
c
      integer n
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
c
      n=nbbl
c
      call argos_space_lbbl_prefetch(int_mb(i_bb),int_mb(i_ipl),
     + int_mb(i_jpl),
     + iwl,int_mb(i_packw),xw,pw,pwp,isl,int_mb(i_pack),xs,ps,psp,
     + .true.)
c
      return
      end
c $Id: argos_space_prefetch_p.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine tce_mrcc_diis_init
      implicit none
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
      integer i,iref

      do iref=1,maxref

      t1_pointerm(iref) = 0
      t2_pointerm(iref) = 0
      t3_pointerm(iref) = 0
      t4_pointerm(iref) = 0
      r1_pointerm(iref) = 0
      r2_pointerm(iref) = 0
      r3_pointerm(iref) = 0
      r4_pointerm(iref) = 0
      do i = 1,maxdiism
        t1_diis_existm(i,iref) = .false.
        r1_diis_existm(i,iref) = .false.
        t2_diis_existm(i,iref) = .false.
        r2_diis_existm(i,iref) = .false.
        t3_diis_existm(i,iref) = .false.
        r3_diis_existm(i,iref) = .false.
        t4_diis_existm(i,iref) = .false.
        r4_diis_existm(i,iref) = .false.
      enddo
      enddo

      return
      end
c $Id: tce_mrcc_diis_init.F 24345 2013-06-22 06:19:30Z d3y133 $

      SUBROUTINE ccsdtq_lr_alpha_15_54_2(d_a,k_a_offset,d_b,k_b_offset,d
     &_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_54_2.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( p13 p17 h16 p11 )_ytrbt + = -1 * Sum ( h4 h5 h6 p1 ) * t ( p1 p13 p17 h4 h5 h6 )_t * i3 ( h4 h5 h6 h16 p1 p11 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER p17b
      INTEGER h16b
      INTEGER p11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p13b_1
      INTEGER p17b_1
      INTEGER p1b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h16b_2
      INTEGER p11b_2
      INTEGER p1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p13b = noab+1,noab+nvab
      DO p17b = p13b,noab+nvab
      DO h16b = 1,noab
      DO p11b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b
     &-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b-1) .eq. int_mb(k_spin
     &+h16b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+h16b-1),int_mb(k_sym+p11b-1)))) .eq. ieor(irrep_y,ieor(irr
     &ep_trb,irrep_t))) THEN
      dimc = int_mb(k_range+p13b-1) * int_mb(k_range+p17b-1) * int_mb(k_
     &range+h16b-1) * int_mb(k_range+p11b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_54_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p17b-1)+int_mb(k_spin+p1b-
     &1) .eq. int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_m
     &b(k_sym+p1b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),i
     &nt_mb(k_sym+h6b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p13b,p17b,p1b,h4b,h5b,h6b,p13b_1,p17b_1,p1b_
     &1,h4b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_6(h4b,h5b,h6b,h16b,p11b,p1b,h4b_2,h5b_2,h6b_2,
     &h16b_2,p11b_2,p1b_2)
      dim_common = int_mb(k_range+p1b-1) * int_mb(k_range+h4b-1) * int_m
     &b(k_range+h5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p13b-1) * int_mb(k_range+p17b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h16b-1) * int_mb(k_range+p11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_54_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_54_2',2,MA_ERR)
      IF ((p1b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p17b_1 - no
     &ab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p17b-1),int_mb(k_range+h4b-
     &1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),3,2,6,5,4,1,1.0d0)
      END IF
      IF ((p13b .lt. p1b) .and. (p1b .le. p17b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p17b_1 - no
     &ab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p17b-1),int_mb(k_range+h4b-
     &1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),3,1,6,5,4,2,-1.0d0)
      END IF
      IF ((p17b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p1b_1 - noa
     &b - 1 + nvab * (p17b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p17b-1),int_mb(k_range+p1b-1),int_mb(k_range+h4b-
     &1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),2,1,6,5,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_54_2'
     &,3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_54_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_54_2',5,MA_ERR)
      IF ((h16b .le. p1b) .and. (p1b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h16b_2 - 1 + noa
     &b * (h6b_2 - 1 + noab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h16b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p11b-1),6,4,3,2,1,5,1.0d0)
      END IF
      IF ((p11b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (h16b_2 - 1 + noa
     &b * (h6b_2 - 1 + noab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h16b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+p1b-1),5,4,3,2,1,6,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_54_2'
     &,6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,6.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2))/FACTORIAL(nsubh(3)),dbl_mb(k_a_sort)
     &,dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dim
     &a_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &54_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &54_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_54_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p11b-1
     &),int_mb(k_range+h16b-1),int_mb(k_range+p17b-1),int_mb(k_range+p13
     &b-1),4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p11b 
     &- noab - 1 + nvab * (h16b - 1 + noab * (p17b - noab - 1 + nvab * (
     &p13b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_54_2'
     &,10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &54_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE wdm_hp_mo_b_b_b(d_d2,d_i0,d_v2,k_d2_offset,k_i0_offset,
     &k_v2_offset)
C     $Id: wdm_hp_mo_b_b_b.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h1 p2 )_vd + = -1/4 * Sum ( p5 h4 h3 ) * d ( h3 h4 p2 p5 )_d * v ( h1 p5 h3 h4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_d2
      INTEGER k_d2_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      CALL wdm_hp_mo_b_b_b_1(d_d2,k_d2_offset,d_v2,k_v2_offset,d_i0,k_i0
     &_offset)
      RETURN
      END
      SUBROUTINE wdm_hp_mo_b_b_b_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: wdm_hp_mo_b_b_b.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h1 p2 )_vd + = -1/4 * Sum ( p5 h4 h3 ) * d ( h3 h4 p2 p5 )_d * v ( h1 p5 h3 h4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER h4b
      INTEGER p5b
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER p2b_1
      INTEGER p5b_1
      INTEGER h1b_2
      INTEGER p5b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperh(2)
      INTEGER isuperh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      irrep_d=0
      next = NXTVAL(nprocs)
      DO h1b = 1,noab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &v,irrep_d)) THEN
      dimc = int_mb(k_range+h1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('wdm_hp_mo_b_b_b_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &2b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p2b-1),int_mb(k_sym+p5b-1)))) .eq. irrep_d) THEN
      CALL TCE_RESTRICTED_4(h3b,h4b,p2b,p5b,h3b_1,h4b_1,p2b_1,p5b_1)
      CALL TCE_RESTRICTED_4(h1b,p5b,h3b,h4b,h1b_2,p5b_2,h3b_2,h4b_2)
      dim_common = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_m
     &b(k_range+p5b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('wdm_hp_mo_b_b_b_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &wdm_hp_mo_b_b_b_1',2,MA_ERR)
      IF ((p5b .lt. p2b)) THEN
c      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
c     & - 1 + (noab+nvab) * (p5b_1 - 1 + (noab+nvab) * (h4b_1 - 1 + (noab
c     &+nvab) * (h3b_1 - 1)))))
c
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & -noab-1 + (nvab) * (p5b_1 - noab-1 + (nvab) * (h4b_1 - 1 + (noab
     & ) * (h3b_1 - 1)))))
c
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p2b .le. p5b)) THEN
c      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
c     & - 1 + (noab+nvab) * (p2b_1 - 1 + (noab+nvab) * (h4b_1 - 1 + (noab
c     &+nvab) * (h3b_1 - 1)))))
c
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & -noab-1 + (nvab) * (p2b_1-noab-1 + (nvab) * (h4b_1 - 1 + (noab
     & ) * (h3b_1 - 1)))))
c
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('wdm_hp_mo_b_b_b_1',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('wdm_hp_mo_b_b_b_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &wdm_hp_mo_b_b_b_1',5,MA_ERR)
      IF ((h1b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h4b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noab
     &+nvab) * (h1b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,1,2,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('wdm_hp_mo_b_b_b_1',6,MA_
     &ERR)
      nsuperh(1) = 1
      nsuperh(2) = 1
      isuperh = 1
      IF (h3b .eq. h4b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperh(1))/FACTORIAL(nsuperh(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('wdm_hp_mo_b_b_b_1',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('wdm_hp_mo_b_b_b_1',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &wdm_hp_mo_b_b_b_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),1,2,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (h1b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('wdm_hp_mo_b_b_b_1',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('wdm_hp_mo_b_b_b_1',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

C> \ingroup task
C> @{
       function task_qmmm_dynamics(rtdb)
*
* $Id: task_qmmm_dynamics.F 22841 2012-09-12 06:55:13Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb !< [Input] The RTDB handle
      logical  task_qmmm_dynamics
c
      logical status
      double precision cpu,wall
c
      character*84 tag
      character*30 pname
c
      logical opes
c
      logical qmmm_dynamics
      external qmmm_dynamics
      logical  qmmm_pes_dynamics
      external qmmm_pes_dynamics
c
      pname = "task_qmmm_dynamics"
c
      if (.not. rtdb_get(rtdb, 'qmmm:pes', mt_log, 
     $                   1, opes))
     $     opes = .false.
c
      task_qmmm_dynamics = .false.
c
      cpu  = util_cpusec()
      wall = util_wallsec()
c
c     set output parameters as if failed
c     ----------------------------------
      status = rtdb_delete(rtdb, 'task:dynamics')
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, .false.))
     $     call errquit('task_dynamics: failed to invalidate status',0,
     &       RTDB_ERR)
c
      if(opes) then
          status = qmmm_pes_dynamics(rtdb)
      else 
          status = qmmm_dynamics(rtdb)
      end if
c
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - wall
c
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, status))
     $   call errquit('task_dynamics: failed to set status',0, RTDB_ERR)
c
      if (status) then
         if (.not. rtdb_put(rtdb, 'task:cputime', mt_dbl, 1, cpu))
     $        call errquit('task_dynamics: failed storing cputime',0,
     &       RTDB_ERR)
         if (.not. rtdb_put(rtdb, 'task:walltime', mt_dbl, 1, wall))
     $        call errquit('task_dynamics: failed storing walltime',0,
     &       RTDB_ERR)
      endif
c         
      task_qmmm_dynamics = status
      end
C> @}

       function qmmm_dynamics(rtdb)
*
* $Id: task_qmmm_dynamics.F 22841 2012-09-12 06:55:13Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "qmmm.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb
      logical  qmmm_dynamics
c
      character*30 pname
c
      character*32 interface
      character*84 tag
      character*30 region(3)
      integer nregion
      logical oesp
c
      pname = "qmmm_dynamics"
c
c     region definitions
c     ------------------
      tag ="qmmm:region"
      if (.not.rtdb_get(rtdb,tag(1:inp_strlen(tag))//"_n",
     >                 mt_int,1,nregion)) 
     >      call errquit(pname//tag,0,RTDB_ERR)
      if(nregion.gt.3) 
     >      call errquit(pname//"too many regions",0,0)
      if (.not.rtdb_cget(rtdb,tag,nregion,region)) 
     >      call errquit(pname//tag,0,RTDB_ERR)
c
      if (.not. rtdb_get(rtdb, 'qmmm:esp_density', mt_log, 
     $                   1, oesp))
     $     oesp = .false.
c
c     define set of active atoms
c     --------------------------
      call qmmm_cons_free_exclusive(region(1))
c
c      call qmmm_bq_data_update_active()
c
      interface = qmmm_get_interface()
      call qmmm_set_interface("mm")
c
c     Actually do the deed
c
      if(oesp) call qmmm_esp_reset(rtdb)
      call md_md()
      call mm_write_restart_default_dynamics()
c
c     restore interface
      call qmmm_set_interface(interface)
c
      qmmm_dynamics = .true.
c
      end

      function qmmm_pes_dynamics(irtdb)
c     $Id: task_qmmm_dynamics.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
#include "msgids.fh"
#include "tcgmsg.fh"
      integer irtdb
      logical qmmm_pes_dynamics
      double precision cpu, wall
c     
      logical  status
c     
      character*32 pname
c     
      logical   qmmm_dynamics
      external  qmmm_dynamics
      logical ignore
      character*255 filename, dir,xyz,prefix
      character*255 filename0
      character*255 movecs
      character*255 movecs0
      double precision energy
      double precision rb(2)
      integer np
      integer ip
      integer in
      double precision dr
      double precision r
      integer i1,i2,i3
      logical ofile
      logical backward
      logical loadrst
      logical loadmovecs
      integer ncycles
      integer istart
      integer iend

      pname = "qmmm_pes_dynamics"

c
c     get lower/upper  limits for pes scan
c     ------------------------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_bounds',mt_dbl,
     +                    2,rb))
     + call errquit(pname//'Failed to get pes bounds',
     + 1, RTDB_ERR)

c
c     get number of points for pes scan
c     ------------------------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_ncycles',mt_int,
     +                    1,ncycles))
     + ncycles = 1
c
c     get number of points for pes scan
c     ------------------------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_npoints',mt_int,
     +                    1,np))
     + call errquit(pname//'Failed to get pes points',
     + 1, RTDB_ERR)
c
c     get starting point
c     ------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_istart',mt_int,
     +                    1,istart))
     +    istart = 1
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_iend',mt_int,
     +                    1,iend))
     +    iend = np
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_backward',mt_log,
     +                    1,backward))
     +  backward = .false.
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_loadrst',mt_log,
     +                    1,loadrst))
     +  loadrst = .false.
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_loadmovecs',mt_log,
     +                    1,loadmovecs))
     +  loadmovecs = .false.
c
c     directory name to dump restart files
c     ------------------------------------
      dir      = ' '
      call util_directory_name(dir, .false., 0)
c
c     file prefix from mm module
c     --------------------------
      call mm_system_prefix(prefix)
c      write(*,*) "pes, mm_system_prefix", prefix(1:inp_strlen(prefix))
c
c     construct movecs file name  
      movecs0 = ' '
      call util_file_name("movecs",.false.,.false.,movecs0)        
      ignore = rtdb_delete(irtdb,'dft:input vectors')
      ignore = rtdb_delete(irtdb,'scf:input vectors')
c 
c     set increments and initial value
c     --------------------------------
      dr = (rb(2)-rb(1))/(np-1)
      r  = rb(1)

      do in=1,ncycles
      if(backward) then
        i1=iend
        i2=istart
        i3=-1
      else
        i1=istart
        i2=iend
        i3=1
      end if
c
c     actually do the scan
c     --------------------
      do ip=i1,i2,i3
        r  = rb(1)+dr*(ip-1) 
        if(ga_nodeid().eq.0) then
          write(*,15) ip,r
        end if
        if (.not. rtdb_put(irtdb,'qmmm:r_spring',mt_dbl,
     +                     1,r))
     +  call errquit(pname//'Failed to set r_spring',
     +  1, RTDB_ERR)

c       construct restart file name  
c        filename0 = ' '
c        call mm_restart_filename(filename0)
        filename = ' '
        write(filename0,14) 
     $     prefix(1:inp_strlen(prefix)),ip
        write(filename,13) dir(1:inp_strlen(dir)), 
     $     prefix(1:inp_strlen(prefix)),ip

c       start load restart file if it exists and requested     
        if(loadrst) then
          if(ga_nodeid().eq.0) then 
            inquire(file=filename,exist=ofile)
            if(ofile) then 
             write(*,*) "pes: found restart file",
     >                 filename(1:inp_strlen(filename))
            call util_file_copy(filename(1:inp_strlen(filename)),
     >                          filename0(1:inp_strlen(filename0)))
            end if
          end if
          call ga_brdcst(msg_qmmm_misc, ofile, mitob(1), 0)
          call ga_sync()
          if(ofile) 
     >      call mm_reload_rst(irtdb,filename0)
        end if
c       end load restart 
c       start load movecs if it exists and requested     
        movecs = ' '
        write(movecs,17) dir(1:inp_strlen(dir)), 
     $   prefix(1:inp_strlen(prefix)),ip
        if(loadmovecs) then
          if(ga_nodeid().eq.0) then 
            inquire(file=movecs,exist=ofile)
            if(ofile) then 
             write(*,*) "pes: found movecs file",
     >                 movecs(1:inp_strlen(movecs))
            call util_file_copy(movecs(1:inp_strlen(movecs)),
     >                          movecs0(1:inp_strlen(movecs0)))
            end if
          end if
          call ga_sync()
        end if
c       end load restart 
        status = qmmm_dynamics(irtdb)
        if(ga_nodeid().eq.0) then 
           write(*,*) "pes: saving restart file",
     >                 filename
        end if
        call mm_write_restart_named(filename,.true.)
        if(ga_nodeid().eq.0) then 
           write(*,*) "pes: saving movecs file",
     >                 movecs0(1:inp_strlen(movecs0)),
     >                 movecs(1:inp_strlen(movecs))
          call util_file_copy(movecs0(1:inp_strlen(movecs0)),
     >                        movecs(1:inp_strlen(movecs)))
        end if
        call ga_sync()

      end do
      backward = .not.backward
      end do
      qmmm_pes_dynamics = status

 13      format(a,'/',a,'_pes',i3.3,'.rst')
 14      format(a,'_pes',i3.3,'.rst')
 15      format("@pes: point ", I2,3X,"spring length = ",F12.6)
 16      format("@pes: energy =  ", F18.12,3X,"length = ",F12.6)
 17      format(a,'/',a,'_pes',i3.3,'.movecs')

      return
      end

      logical function argos_prepare_mksgm(lfnout,lfnfrg,filfrg,lfnsgm,
     + filsgm)
c
c $Id: argos_prepare_mksgm.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to make segment file
c
c     in  : lfnfrg    = fragment file logical file number
c           lfnsgm    = segment file logical file number
c           lfnout    = output file logical file number
c
      implicit none
c
#include "mafdecls.fh"
#include "util.fh"
#include "argos_prepare_common.fh"
c
      logical argos_prepare_frgsiz,argos_prepare_frgrd,
     + argos_prepare_ang,argos_prepare_dih,argos_prepare_imp
      logical argos_prepare_dihsel,argos_prepare_dihimp,
     + argos_prepare_wrtsgm
      external argos_prepare_frgsiz,argos_prepare_frgrd,
     + argos_prepare_ang,argos_prepare_dih,argos_prepare_imp
      external argos_prepare_dihsel,argos_prepare_dihimp,
     + argos_prepare_wrtsgm
c
      integer lfnout,lfnfrg,lfnsgm
      character*255 filfrg,filsgm
c
      integer length
      integer matm,mbnd,mang,mdih,mimp,mzmat
      integer natm,nbnd,nang,ndih,nimp,nzmat
c
      integer l_latm,i_latm,l_catm,i_catm,l_qatm,i_qatm
      integer l_bnd,i_bnd,l_ang,i_ang,l_dih,i_dih,l_imp,i_imp
      integer i_izmat,l_izmat,i_zmat,l_zmat,l_fil,i_fil
c
      integer nparms,ipardef
c
      length=index(filsgm,' ')-1
c
      if(util_print('where',print_debug)) then
      write(lfnout,2000) filsgm(1:length)
 2000 format(//,'SEGMENT FILE ',a)
      endif
c
      if(.not.argos_prepare_frgsiz(lfnfrg,filfrg,lfnout,natm,nbnd,nzmat,
     + nparms,ipardef))
     + call md_abort('argos_prepare_frgsiz failed',9999)
c
c     allocate memory for bonds, angles, torsions and impropers
c     ---------------------------------------------------------
c
      matm=natm
      mbnd=4*matm
      if(mbnd.lt.nbnd) mbnd=nbnd
      mang=6*matm
      mdih=12*matm
      mimp=matm
      nang=0
      ndih=0
      nimp=0
      mzmat=nzmat+1
c
c     allocate memory for atom list
c     -----------------------------
c
c     integer latm(1,matm) :
c                  2       :
c                  3       :
c                  4       :
c                  5       :
c
      if(.not.ma_push_get(mt_int,6*matm,'latm',l_latm,i_latm))
     + call md_abort('mksgm: Memory allocation failed for latm',9999)
c
c    char*255 fil
c
      if(.not.ma_push_get(mt_byte,255*nparms,'fil',l_fil,i_fil))
     + call md_abort('mksgm: Memory allocation failed for fil',9999)
c
c     char*6  catm(1,matm) : atom name
c                  2       : atom type
c
      if(.not.ma_push_get(mt_byte,6*(nparms+1)*matm,'catm',
     + l_catm,i_catm))
     + call md_abort('mksgm: Memory allocation failed for catm',9999)
c
c     real*8 qatm(1,matm) : partial atomic charges
c                 2       : polarizabilities
c
      if(.not.ma_push_get(mt_dbl,2*nparms*matm,'qatm',l_qatm,i_qatm))
     + call md_abort('mksgm: Memory allocation failed for qatm',9999)
c
c     integer lbnd(1:2,mbnd) : bond indices
c
      if(.not.ma_push_get(mt_int,2*mbnd,'bnd',l_bnd,i_bnd))
     + call md_abort('mksgm: Memory allocation failed for bnd',9999)
c
c     integer lang(1:3,mang) : angle indices
c
      if(.not.ma_push_get(mt_int,3*mang,'ang',l_ang,i_ang))
     + call md_abort('mksgm: Memory allocation failed for ang',9999)
c
c     integer ldih(1:4,mdih) : torsion indices
c
      if(.not.ma_push_get(mt_int,4*mdih,'dih',l_dih,i_dih))
     + call md_abort('mksgm: Memory allocation failed for dih',9999)
c
c     integer limp(1:4,mimp) : improper torsion indices
c
      if(.not.ma_push_get(mt_int,4*mimp,'imp',l_imp,i_imp))
     + call md_abort('mksgm: Memory allocation failed for imp',9999)
c
      if(mzmat.gt.0) then
      if(.not.ma_push_get(mt_int,4*mzmat,'izmat',l_izmat,i_izmat))
     + call md_abort('mksgm: Memory allocation failed for izmat',mzmat)
      if(.not.ma_push_get(mt_dbl,3*mzmat,'zmat',l_zmat,i_zmat))
     + call md_abort('mksgm: Memory allocation failed for zmat',mzmat)
      endif
c
c     read atom list and bond list from fragment file
c     -----------------------------------------------
c
      if(.not.argos_prepare_frgrd(lfnfrg,filfrg,lfnout,nparms,nparms+1,
     + int_mb(i_latm),byte_mb(i_catm),dbl_mb(i_qatm),matm,natm,
     + int_mb(i_bnd),mbnd,nbnd,int_mb(i_izmat),
     + dbl_mb(i_zmat),mzmat,nzmat,byte_mb(i_fil)))
     + call md_abort('mksgm: argos_prepare_frgrd failed',9999)
c
c     make the angle list
c     -------------------
c
      if(.not.argos_prepare_ang(int_mb(i_bnd),mbnd,nbnd,int_mb(i_ang),
     + mang,nang))
     + call md_abort('mksgm: argos_prepare_ang failed',9999)
c
c     make the dihedral list
c     ----------------------
c
      if(.not.argos_prepare_dih(int_mb(i_ang),mang,nang,int_mb(i_dih),
     + mdih,ndih))
     + call md_abort('mksgm: argos_prepare_dih failed',9999)
c
c     make the improper list
c     ----------------------
c
      if(.not.argos_prepare_imp(int_mb(i_latm),matm,natm,
     + int_mb(i_bnd),mbnd,nbnd,int_mb(i_imp),mimp,nimp))
     + call md_abort('mksgm: argos_prepare_imp failed',9999)
c
c     select dihedrals
c     ----------------
c
      if(.not.argos_prepare_dihsel(byte_mb(i_catm),nparms,nparms+1,matm,
     + natm,
     + int_mb(i_dih),mdih,ndih))
     + call md_abort('mksgm: argos_prepare_dihsel failed',9999)
c
c     switch propers to impropers
c     ---------------------------
c
      if(.not.argos_prepare_dihimp(int_mb(i_latm),matm,natm,
     + int_mb(i_ang),mang,nang,
     + int_mb(i_dih),mdih,ndih,int_mb(i_imp),mimp,nimp))
     + call md_abort('mksgm: argos_prepare_dihsel failed',9999)
c
c     write segment file
c     ------------------
c
      if(.not.argos_prepare_wrtsgm(lfnout,lfnsgm,filsgm,nparms,nparms+1,
     + int_mb(i_latm),byte_mb(i_catm),dbl_mb(i_qatm),matm,natm,
     + int_mb(i_bnd),mbnd,nbnd,int_mb(i_ang),mang,nang,
     + int_mb(i_dih),mdih,ndih,int_mb(i_imp),mimp,nimp,
     + int_mb(i_izmat),dbl_mb(i_zmat),mzmat,nzmat,ipardef))
     + call md_abort('mksgm: argos_prepare_wrtsgm failed',9999)
c
c     deallocate memory
c     -----------------
c
      if(mzmat.gt.0) then
      if(.not.ma_pop_stack(l_zmat))
     + call md_abort('mksgm: Memory deallocation failed for zmat',9999)
      if(.not.ma_pop_stack(l_izmat))
     + call md_abort('mksgm: Memory deallocation failed for izmat',9999)
      endif
      if(.not.ma_pop_stack(l_imp))
     + call md_abort('mksgm: Memory deallocation failed for imp',9999)
      if(.not.ma_pop_stack(l_dih))
     + call md_abort('mksgm: Memory deallocation failed for dih',9999)
      if(.not.ma_pop_stack(l_ang))
     + call md_abort('mksgm: Memory deallocation failed for ang',9999)
      if(.not.ma_pop_stack(l_bnd))
     + call md_abort('mksgm: Memory deallocation failed for bnd',9999)
      if(.not.ma_pop_stack(l_qatm))
     + call md_abort('mksgm: Memory deallocation failed for qatm',9999)
      if(.not.ma_pop_stack(l_catm))
     + call md_abort('mksgm: Memory deallocation failed for catm',9999)
      if(.not.ma_pop_stack(l_fil))
     + call md_abort('mksgm: Memory deallocation failed for fil',9999)
      if(.not.ma_pop_stack(l_latm))
     + call md_abort('mksgm: Memory deallocation failed for latm',9999)
c
      argos_prepare_mksgm=.true.
      return
c
 9999 continue
      argos_prepare_mksgm=.false.
      return
      end
 

*     ***********************************
*     *                                 *
*     *          psi_lmbda2          	*
*     *                                 *
*     ***********************************

      subroutine psi_lmbda2(ispin,ne,nemax,npack1,
     >                     psi1,psi2,
     >                     dte,fweight,
     >                     lmbda,tmp,ierr)
      implicit none
      integer ispin,ne(2),nemax,npack1
      complex*16 psi1(npack1,nemax)
      complex*16 psi2(npack1,nemax)
      real*8     dte
      real*8     lmbda(*)
      real*8     fweight(*)
      real*8     tmp(*)
      integer    ierr


      integer MASTER
      parameter (MASTER=0)

*     **** local variables ****
      logical failed
      integer taskid
      integer ms,nn
      integer st1,st2
      integer A,B,C,U,D,Ba,Bs,fnm

      call nwpw_timing_start(3)

      ierr = 0
      call Parallel_taskid(taskid)

      call Dneall_m_size(1,nn)
      A    = 0*nn + 1
      B    = 1*nn + 1
      C    = 2*nn + 1
      Ba   = 3*nn + 1
      Bs   = 4*nn + 1
      fnm  = 5*nn + 1
      st1  = 6*nn + 1
      D    = 7*nn + 1

      U    = Bs
      st2  = B

      call dcopy(8*nn,0.0d0,0,tmp,1)

      do ms=1,ispin
        IF(ne(ms).le.0) go to 640

*       ***** compute the overlap matrices ****
        call Dneall_ffm_sym_Multiply(ms,psi2,psi2,npack1,tmp(A))
        call Dneall_ffm_Multiply(ms,psi1,psi2,npack1,tmp(B))
        call Dneall_ffm_sym_Multiply(ms,psi1,psi1,npack1,tmp(C))

        call psi_gen_Ba_Bs(ms,nn,tmp(B),tmp(Bs),tmp(Ba))

        call psi_gen_UD(ms,tmp(Bs),tmp(D))

        call psi_gen_X(ms,nn,tmp(st1),tmp(st2),
     >                     tmp(A),tmp(Ba),tmp(C),
     >                     tmp(U),tmp(D),tmp(fnm),
     >                     fweight,
     >                     failed)

        if (failed) then
          if (taskid.eq.MASTER) then
            write(*,*)
     >     'Warning: Lagrange Multiplier generation failed.'
            write(*,*) '        +Try using a smaller time step'
            write(*,*) '        +Gram-Schmidt being performed, spin:',ms
          end if
c          call Dneall_f_ortho(ms,psi2,npack1)
          call Dneall_f_GramSchmidt(ms,psi2,npack1)
          ierr = 1
        else
          call Dneall_fmf_Multiply(ms,
     >                          psi1,npack1,
     >                          tmp(st1), 1.0d0,
     >                          psi2,1.0d0)
          call dscal(nn,(1.0d0/dte),tmp(st1),1)
          call Dneall_mm_Expand(ms,tmp(st1),lmbda)
        end if
   
  640   continue
      end do !*ms*

      call nwpw_timing_end(3)

      return
      end


*     ***********************************
*     *                                 *
*     *        psi_gen_Ba_Bs   	     	*
*     *                                 *
*     ***********************************
      subroutine psi_gen_Ba_Bs(ms,nn,B,Bs,Ba)
      implicit none
      integer ms,nn
      real*8 B(*),Bs(*),Ba(*)


      call Dneall_mm_transpose(ms,B,Ba)

      call dcopy(nn,B,1,Bs,1)
      call daxpy(nn,1.0d0,Ba,1,Bs,1)
      call dscal(nn,0.5d0,Bs,1)

      call daxpy(nn,-1.0d0,B,1,Ba,1)
      call dscal(nn,-0.5d0,Ba,1)

      return
      end

*     ***********************************
*     *                                 *
*     *        psi_gen_UD           	*
*     *                                 *
*     ***********************************
      subroutine psi_gen_UD(ms,Bs,D)
      implicit none
      integer ms
      real*8 Bs(*),D(*)

      !call DSYEV('V','U',n,Bs,n_max, D,Work,2*n_max*n_max,ierr)
      call Dneall_m_diagonalize(ms,Bs,D,.true.)

      return
      end




*     ***********************************
*     *                                 *
*     *        psi_gen_X            	*
*     *                                 *
*     ***********************************
      subroutine psi_gen_X(ms,nn,
     >                     X1,tmp,
     >                     A,Ba,C,
     >                     U,D,fnm,
     >                     fweight,
     >                     failed)
     
      implicit none
      integer ms,nn
      real*8 X1(*)
      real*8 tmp(*)
      real*8 A(*)
      real*8 Ba(*)
      real*8 C(*)
      real*8 U(*)
      real*8 D(*)
      real*8 fnm(*)
      real*8 fweight(*)
      logical failed

      !**** local variables ****
      integer itrlmd
      real*8  convg
      parameter (itrlmd=120, convg=1.0d-15)

      integer it
      real*8  adiff

*     **** external functions ****
      real*8   Dneall_m_dmax
      external Dneall_m_dmax

      !**** A = I-A ***
       call dscal(nn,(-1.0d0),A,1)
       call Dneall_m_eye(ms,fnm,1.0d0)
       call daxpy(nn,1.0d0,fnm,1,A,1)

      !*** fnm = I-A ****
      call dcopy(nn,A,1,fnm,1)

      !*** solve U*D*Ut*X + X*U*D*Ut = fnm for X ***
      call psi_fnm_to_X(ms,fnm,U,D,fweight,tmp)
      call dcopy(nn,fnm,1,X1,1)


      it     = 0
      failed = .true.
      do while (failed .and. (it.lt.itrlmd))
        it = it + 1

        !*** fnm = X*C*X ***
        call Dneall_mmm_Multiply(ms,C, X1,  1.0d0,tmp,0.0d0)
        call Dneall_mmm_Multiply(ms,X1,tmp, 1.0d0,fnm,0.0d0)


        !*** fnm = Ba*X - X*C*X ***
        call Dneall_mmm_Multiply(ms,Ba,X1,1.0d0,fnm,-1.0d0)


        !*** fnm = Ba*X - X*Ba - X*C*X ***
        call Dneall_mmm_Multiply(ms,X1,Ba,-1.0d0,fnm,1.0d0)

        !*** fnm = I-A + Ba*X - X*Ba - X*C*X ***
        call daxpy(nn,1.0d0,A,1,fnm,1)


        !*** solve U*D*Ut*X + X*U*D*Ut = fnm for X ***
        call psi_fnm_to_X(ms,fnm,U,D,fweight,tmp)

        !call DMSUB(n_max,n,X1,fnm,tmp)
        !adiff = tmp(idamax(n_max*n,tmp,1))
        !call dcopy(n_max*n,fnm,1,X1,1)
        call dcopy(nn,X1,1,tmp,1)
        call daxpy(nn,-1.0d0,fnm,1,tmp,1)
        adiff = Dneall_m_dmax(ms,tmp)
        call dcopy(nn,fnm,1,X1,1)

        if (adiff.lt.convg) failed = .false.
      end do

      return
      end


*     ***********************************
*     *                                 *
*     *        psi_fnm_to_X         *
*     *                                 *
*     ***********************************
      subroutine psi_fnm_to_X(ms,fnm,U,D,fweight,tmp)
      implicit none
      integer ms
      real*8 fnm(*)
      real*8 U(*)
      real*8 D(*)
      real*8 fweight(*)
      real*8 tmp(*)


      !**** fnm = Ut*fnm*U ***
c      call DGEMM('N','N',n,n,n,1.0d0,
c     >           fnm,n_max,
c     >           U,n_max,
c     >           0.0d0,
c     >           tmp,n_max)
c      call DGEMM('T','N',n,n,n,1.0d0,
c     >           U,n_max,
c     >           tmp,n_max,
c     >           0.0d0,
c     >           fnm,n_max)
      call Dneall_mmm_Multiply(ms,fnm,U,1.0d0,tmp,0.0d0)
      call Dneall_mmm_Multiply2(ms,U,tmp,fnm)

      !**** fnm = (Ut*fnm*U)_nm/(d_n+d_m) ***
c      do j=1,n
c      do i=1,n
c        d2 = D(i,1)+D(j,1)
c        fnm(i,j) = (fnm(i,j)/d2)
c      end do
c      end do
       call Dneall_m_HmldivideDplusD(ms,fnm,D)

      !**** fnm = X = U*{(Ut*fnm*U)_nm/(d_n+d_m)}*Ut ***
c      call DGEMM('N','N',n,n,n,1.0d0,
c     >           U,n_max,
c     >           fnm,n_max,
c     >           0.0d0,
c     >           tmp,n_max)
c      call DGEMM('N','T',n,n,n,1.0d0,
c     >           tmp,n_max,
c     >           U,n_max,
c     >           0.0d0,
c     >           fnm,n_max)
      call Dneall_mmm_Multiply(ms,U,fnm,1.0d0,tmp,0.0d0)
      call Dneall_mmm_Multiply3(ms,tmp,U,fnm)

c      do j=1,n
c      do i=1,n
c        fnm(i,j) = fnm(i,j)*(2.0d0*fweight(i)/(fweight(i)+fweight(j)))
c      end do
c      end do
      call Dneall_m_Hmlfweightscale(ms,fnm,fweight)

      return
      end


c $Id: psi_lmbda2.f 25926 2014-07-21 03:13:15Z bylaska $

      subroutine reconcilefile(d_sf,size)
c
c $Id: reconcilefile.F 20189 2011-04-13 11:59:24Z jhammond $
c
c     Accumulate local distributed files and update all files
c     with the one accumulated file
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "eaf.fh"
#include "dra.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_sf
      integer d_temp
      integer size
      integer nblocks,blocksize
      integer g_temp
      integer l_temp,k_temp
      integer i
      logical nodezero
      logical parallel
c 
      nodezero = (ga_nodeid().eq.0)
      parallel = (ga_nnodes().gt.1)
      cpusecs(6) = cpusecs(6) - util_cpusec()
      cpusecs(56) = cpusecs(56) - util_wallsec()
      if (ioalg.eq.0) then
        if (parallel) call ga_sync()
      else if (ioalg.eq.1) then
        if (parallel) call ga_sync()
      else if (ioalg.eq.2) then
        if (parallel) call ga_sync()
        if (1.eq.ga_is_mirrored(d_sf)) then
          if (util_print('reconcilefile',print_debug)) write(LuOut,*) 
     1        'accumulating mirrored array across all nodes'
          call ga_merge_mirrored(d_sf)
        endif
      else if (ioalg.eq.3) then
        if (parallel) call ga_sync()
      else if ((ioalg.eq.4).or.
     1        ((ioalg.eq.6).and.(.not.fileisga(d_sf)))) then
        if (parallel) then
          if (util_print('reconcilefile',print_debug))
     1      write(LuOut,9190) ga_nodeid(),d_sf,size
          if (nodezero.and.(ioalg.eq.6)) write(LuOut,9230)
          nblocks = size/buffer_size
          if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
          blocksize = size/nblocks
          if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
          if (.not.ga_create(mt_dbl,blocksize,1,'temporary',
     1      -1,1,g_temp))
     2      call errquit('reconcilefile: GA problem',0,GA_ERR)
          if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1      l_temp,k_temp))
     2      call errquit('reconcilefile: MA problem',0,MA_ERR)
          do i = 1,nblocks
            call ga_zero(g_temp)
            call get_block(d_sf,dbl_mb(k_temp),
     1        min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
            call ga_acc(g_temp,1,blocksize,1,1,dbl_mb(k_temp),1,1.0d0)
            call ga_sync()
            call ga_get(g_temp,1,blocksize,1,1,dbl_mb(k_temp),1)
            call put_block(d_sf,dbl_mb(k_temp),
     1        min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
          enddo
          call ga_sync()
          if (.not.ga_destroy(g_temp))
     1      call errquit('reconcilefile: GA problem',0,GA_ERR)
          if (.not.ma_pop_stack(l_temp))
     1      call errquit('reconcilefile: MA problem',1,MA_ERR)
          if (nodezero.and.util_print('reconcilefile',print_debug))
     1      call filesummary
        endif
      else if (ioalg.eq.5) then
        if (parallel) call ga_sync()
      else if ((ioalg.eq.6).and.fileisga(d_sf)) then
        call ga_sync()
        if (eaf_open(filenames(d_sf), EAF_RW, d_temp).ne.0)
     1    call errquit('reconcilefile: eaf problem',0,DISK_ERR)
        if (nodezero.and.util_print('reconcilefile',print_debug))
     1    write(LuOut,9210) d_sf,filehandles(d_sf),d_temp
        nblocks = size/buffer_size
        if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
        blocksize = size/nblocks
        if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
        if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1    l_temp,k_temp))
     2    call errquit('reconcilefile: MA problem',0,MA_ERR)
        do i = 1,nblocks
          call ga_get(filehandles(d_sf),(i-1)*blocksize+1,
     1      min(size,i*blocksize),1,1,dbl_mb(k_temp),1)
          if (eaf_write(d_temp,dfloat(bytes)*dfloat((i-1)*blocksize),
     1      dbl_mb(k_temp),
     2      bytes*(min(size,i*blocksize)-(i-1)*blocksize)).ne.0)
     3      call errquit('reconcilefile: eaf problem',7,DISK_ERR)
        enddo
        if (.not.ma_pop_stack(l_temp))
     1    call errquit('reconcilefile: MA problem',1,MA_ERR)
        if (.not.ga_destroy(filehandles(d_sf)))
     1    call errquit('reconcilefile: GA problem',0,GA_ERR)
        filehandles(d_sf) = d_temp
        fileisga(d_sf) = .false.
        if (nodezero.and.util_print('reconcilefile',print_debug))
     1    call filesummary
        call ga_sync()
      endif
      cpusecs(6) = cpusecs(6) + util_cpusec()
      cpusecs(56) = cpusecs(56) + util_wallsec()
 9190 format(/,1x,'Reconcile file: node',i3,' handle:',i10,
     1            ' size:',i10)
 9200 format(1x,'        offset:',i10,' size:',i10)
 9210 format(/,1x,'Reconcile file: logical handle:',i10,
     1            ' GA handle:',i10,' EAF handle:',i10)
 9220 format(/,1x,i3,' reconcile file: logical handle:',i10,
     1            ' EAF handle:',i10)
 9230 format(/,1x,'Warning: EAF reconciliation in GA/EAF algorithm')
      return
 9240 format(/,1x,'Reconcile file: logical handle:',i10,
     1            ' GA handle:',i10,' DRA handle:',i10)
      end



      subroutine filesummary
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "eaf.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer i
      logical nodezero
      nodezero = (ga_nodeid().eq.0)
      if (nodezero) then
        do i = 1,nfiles
          if (ioalg.eq.5) then
            if (fileisga(i)) write(LuOut,9000) i,filehandles(i),
     1        filenames(i)(1:40)
            if (.not.fileisga(i)) write(LuOut,9010) i,filehandles(i),
     1        filenames(i)(1:40)
          else if (ioalg.eq.6) then
            if (fileisga(i)) write(LuOut,9000) i,filehandles(i),
     1        filenames(i)(1:40)
            if (.not.fileisga(i)) write(LuOut,9020) i,filehandles(i),
     1        filenames(i)(1:40)
          endif
        enddo
      endif
 9000 format(1x,i3,' GA  file handle = ',i9,' file name = ',a)
 9010 format(1x,i3,' DRA file handle = ',i9,' file name = ',a)
 9020 format(1x,i3,' EAF file handle = ',i9,' file name = ',a)
      return
      end

      logical function movecs_read_header(filename, title, basis_name, 
     $     scftype, nbf, nsets, nmo, ldnmo)
C$Id: vectors.F 25498 2014-04-18 02:44:47Z d3y133 $
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "msgids.fh"
#include "cscfps.fh"
#include "inp.fh"
#include "stdio.fh"
#include "mafdecls.fh"
c
c     Temporary routine
c
      character*(*) filename    ! File to read header from
      character*(*) title       ! Returns title of job that created vectors
      character*(*) basis_name  ! Returns name of basis set
      character*(*) scftype     ! Returns the SCF type of the vectors
      integer nbf               ! Returns no. of functions in basis
      integer nsets             ! Returns no. of functions in each set
      integer ldnmo             ! Inputs size of nmo
      integer nmo(ldnmo)        ! Returns no. of vectors in each set
c
      integer unitno            ! Unit no. for reading
      parameter (unitno = 67)   ! These need to be managed !!!

      integer lentit
      integer lenbas
      integer ok, i
      integer ioserr,inntsize
      character*20 scftype20
c
      if (oscfps) call pstat_on(ps_vecio)
      ok = 0
      inntsize=MA_sizeof(MT_INT,1,MT_BYTE)
      if (ga_nodeid() .eq. 0) then
         open(unitno, status='old', form='unformatted', file=filename,
     $        iostat=ioserr,err=1000)
         read(unitno, err=1001, end=2001) ! SKIP convergence info
         read(unitno, err=1001, end=2001) scftype20
         scftype = scftype20
         read(unitno, err=1001, end=2001) lentit
         if (len(title) .lt. lentit) call errquit
     $        ('movecs_read_header: title too short', lentit, INPUT_ERR)
         title = ' '
         read(unitno, err=1001, end=2001) title(1:lentit)
         read(unitno, err=1001, end=2001) lenbas
         if (len(basis_name) .lt. lenbas) call errquit
     $        ('movecs_read_header: basis_name too short', lenbas,
     &       INPUT_ERR)
         basis_name = ' '
         read(unitno, err=1001, end=2001) basis_name(1:lenbas)
         read(unitno, err=1001, end=2001) nsets
         read(unitno, err=1001, end=2001) nbf
         if (nsets .gt. ldnmo) then
            write(6,*) ' movecs_read_header: ldnmo too small ',
     $           nsets, ldnmo
            close(unitno, err=1002)
            goto 10
         endif
         read(unitno, err=1001, end=2001) (nmo(i),i=1,nsets)
         close(unitno, err=1002)
         ok = 1
      endif
c
 10   call ga_brdcst(Msg_Vec_Stat+MSGINT, ok, inntsize, 0) ! Propagate status
      movecs_read_header = ok .eq. 1
      if (.not. movecs_read_header) return
c
      call util_char_ga_brdcst(Msg_Vec_Ttl, title, 0)
      call util_char_ga_brdcst(Msg_Vec_Nam, basis_name, 0)
      call util_char_ga_brdcst(Msg_Vec_Type, scftype, 0)
      call ga_brdcst(Msg_Vec_NBF+MSGINT, nbf, inntsize, 0)
      call ga_brdcst(Msg_Vec_Set+MSGINT, nsets, inntsize, 0)
      call ga_brdcst(Msg_Vec_NMO+MSGINT, nmo, inntsize*nsets, 0)
c
      if (oscfps) call pstat_off(ps_vecio)
c
      return
c
 1000 write(6,*) ' movecs_read_header: failed to open ',
     $     filename(1:inp_strlen(filename)),
     A ' IERR = ', ioserr
      call util_flush(luout)
      ok = 0
      goto 10
c
 1001 write(6,*) ' movecs_read_header: failing reading from ',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      close(unitno, err=1002)
      goto 10
c
 2001 write(6,*) ' movecs_read_header:eof: failing reading from '
     &    , filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      close(unitno, err=1002)
      goto 10
c
 1002 write(6,*) ' movecs_read_header: failed to close',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      goto 10
c
      end
      logical function movecs_read(filename, iset, occ, evals, g_vecs)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "mafdecls.fh"
#include "msgids.fh"
#include "cscfps.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
c
      character*(*) filename
      integer iset              ! No. (1,2) of set of vectors to read
      double precision occ(*)   ! Must be at least nbf long (not nmo)
      double precision evals(*) ! Must be at least nbf long (not nmo)
      integer g_vecs
c
      integer nsets             ! No. of sets of vectors
      integer nbf               ! No. of functions in basis
      integer nmo(2)            ! No. of vectors in each set
      integer ok, jset, i, j
      integer l_vecs, k_vecs
      integer unitno
      parameter (unitno = 67)
      integer inntsize,ddblsize
c     
      l_vecs = -1               ! An invalid MA handle
c
      if (oscfps) call pstat_on(ps_vecio)
      inntsize=MA_sizeof(MT_INT,1,MT_BYTE)
      ddblsize=MA_sizeof(MT_DBL,1,MT_BYTE)
      call ga_sync()
      ok = 0
      if (ga_nodeid() .eq. 0) then
         open(unitno, status='old', form='unformatted', file=filename,
     $        err=1000)
c
c     Skip over uninteresting bits of the header
c
         read(unitno, err=1001, end=1001) ! convergence info
         read(unitno, err=1001, end=1001) ! scftype
         read(unitno, err=1001, end=1001) ! lentit
         read(unitno, err=1001, end=1001) ! title
         read(unitno, err=1001, end=1001) ! lenbas
         read(unitno, err=1001, end=1001) ! basis_name
         read(unitno, err=1001, end=1001) nsets
         read(unitno, err=1001, end=1001) nbf
         read(unitno, err=1001, end=1001) (nmo(i),i=1,nsets)
c
         if (.not. ma_push_get(mt_dbl,nbf,'movecs_read',l_vecs,k_vecs))
     $        call errquit('movecs_read: ma failed', nbf, MA_ERR)
c
c     Skip over unwanted sets
c
         do jset = 1, iset-1
            read(unitno, err=1001, end=1001)
            read(unitno, err=1001, end=1001)
            do i = 1, nmo(jset)
               read(unitno, err=1001, end=1001)
            enddo
         enddo
         read(unitno, err=1001, end=1001) (occ(j),j=1,nbf)
         read(unitno, err=1001, end=1001) (evals(j),j=1,nbf)
         do i = 1, nmo(iset)
*            read(unitno, err=1001, end=1001)
*     $           (dbl_mb(k_vecs+j), j=0,nbf-1)
            call sread(unitno, dbl_mb(k_vecs), nbf)
            call ga_put(g_vecs, 1, nbf, i, i, dbl_mb(k_vecs), 1)
         enddo
 9       close(unitno,err=1002)
         ok = 1
      endif
c
 10   continue
      if (l_vecs .ne. -1) then
	 if (.not. ma_pop_stack(l_vecs)) call errquit
     $      ('movecs_read: pop failed', l_vecs, MA_ERR)
      endif
      call ga_sync()
      call ga_brdcst(Msg_Vec_Stat+MSGINT, ok, inntsize, 0) ! Propagate status
      if (ok .eq. 1) then
	 call ga_brdcst(Msg_Vec_NBF+MSGINT, nbf, inntsize, 0)
	 call ga_brdcst(Msg_Vec_EVal+MSGDBL, evals, ddblsize*nbf, 0)
	 call ga_brdcst(Msg_Vec_Occ+MSGDBL, occ, ddblsize*nbf, 0)
      endif
c
      movecs_read = ok .eq. 1
      if (ga_nodeid() .eq. 0 .and. movecs_read .and.
     $     util_print('vectors i/o', print_high)) then
         write(6,22) filename(1:inp_strlen(filename))
 22      format(/' Read molecular orbitals from ',a/)
         call util_flush(luout)
      endif
      if (oscfps) call pstat_off(ps_vecio)
      return
c
 1000 write(6,*) ' movecs_read: failed to open ',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      goto 10
c
 1001 write(6,*) ' movecs_read: failing reading from ',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      close(unitno,err=1002)
      goto 10
c
 1002 write(6,*) ' movecs_read: failed to close',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      goto 10
c
      end
      logical function movecs_gather(filename, iset, nwant, want,
     $   occ, evals, g_vecs)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
c
      character*(*) filename        ! [in] name of movecs file
      integer iset                  ! [in] no. (1,2) of set of vectors to read
      integer nwant                 ! [in] length of gather vector
      integer want(nwant)           ! [in] list of mos to be gathered
      double precision occ(nwant)   ! [out] occupation numbers
      double precision evals(nwant) ! [out] eigenvalues
      integer g_vecs                ! [in] handle for ga to hold results
c
      integer nsets                 ! no. of sets of vectors
      integer nbf                   ! no. of functions in basis
      integer ldnmo                 ! size of nmo
      parameter (ldnmo = 2)
      integer nmo(ldnmo)            ! no. of vectors in each set
      integer i, l_fullocc, k_fullocc, l_fulleval, k_fulleval, g_tmp
      character*255 title, basis
      integer minchunk              ! for data distirbution in ga
      parameter (minchunk = -1)     ! let ga determine even distrib.
      character*20 scftype
c
      logical movecs_read_header, movecs_read
      external movecs_read_header, movecs_read
c     
      if ( .not. movecs_read_header(filename, title, basis,
     $     scftype, nbf, nsets, nmo, ldnmo) ) call errquit(
     $   'movecs_gather: failed to read movecs file', 1, INPUT_ERR)
c
c     allocate memory to be used while reading info
C     movecs_read expects fullocc and fulleval arrays to be nbf,
C     not nmo(iset)!
c
      if (.not. ma_push_get(mt_dbl,nbf,'movecs_gather',
     $   l_fullocc, k_fullocc)) call errquit(
     $   'movecs_gather: ma failed', nmo(iset), MA_ERR)
c
      if (.not. ma_push_get(mt_dbl,nbf,'movecs_gather',
     $   l_fulleval, k_fulleval)) call errquit(
     $   'movecs_gather: ma failed', nmo(iset), MA_ERR)
c
      if ( .not. ga_create( mt_dbl, nbf, nmo(iset), 'full vectors',
     $   minchunk, minchunk, g_tmp) ) call errquit(
     $   'movecs_gather: ga_create failed', nbf*nmo(iset) , GA_ERR)
c
c     read the full data
c
      if ( .not. movecs_read(filename, iset, dbl_mb(k_fullocc),
     $   dbl_mb(k_fulleval), g_tmp) ) call errquit(
     $   'movecs_gather: failed reading movecs file', 2, DISK_ERR)
c
c     gather the data into the requested subset
c
      do i = 1, nwant
         occ(i)   = dbl_mb( k_fullocc  + want(i) - 1)
         evals(i) = dbl_mb( k_fulleval + want(i) - 1)
         call ga_copy_patch('n', g_tmp, 1, nbf, want(i), want(i),
     $      g_vecs, 1, nbf, i, i)
      enddo
c
c     free temporaries
c
      if ( .not. ga_destroy(g_tmp)) call errquit(
     $   'movecs_gather: ga_destroy failed', g_tmp, GA_ERR)
      if (.not. ma_pop_stack(l_fulleval)) call errquit(
     $   'movecs_gather: pop failed', l_fulleval, MA_ERR)
      if (.not. ma_pop_stack(l_fullocc)) call errquit(
     $   'movecs_gather: pop failed', l_fullocc,
     &       MA_ERR)
c
      movecs_gather = .true.
c
      end
      logical function movecs_write(rtdb, basis, filename, 
     $     scftype, title,
     $     nbf, nsets, nmo, occ, ldocc, evals, ldevals, g_vecs)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "inp.fh"
#include "msgids.fh"
#include "cscfps.fh"
#include "util.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "bq.fh"
c
c     Temporary routine
c
      integer rtdb              ! [input] RTDB handle (-1 if not accessible)
      integer basis             ! [input] Basis handle(-1 if not accessible)
      character*(*) filename    ! [input] File to write to
      character*(*) scftype     ! [input] Type of SCF (dft, scf, mcscf)
      character*(*) title       ! [input] Title of job that created vectors
      integer nbf               ! [input] No. of functions in basis
      integer nsets             ! [input] No. of sets of vectors
      integer nmo(nsets)        ! [input] No. of vectors in each set
      integer ldocc             ! [input]
      integer ldevals           ! [input]
      double precision occ(ldocc, nsets) ! [input] Occupation numbers 
      double precision evals(ldevals, nsets) ! [input] Eigenvalues
      integer g_vecs(nsets)     ! Global array with eigen-vectors
c
      integer unitno            ! Unit no. for writing
      parameter (unitno = 67)   ! These need to be managed !!!
      integer bq_handle         ! Handle of the BQ fragment
      integer lentit
      integer lenbas
      integer l_vecs, k_vecs
      integer ok, iset, i, j
      integer geom, ma_type, nelem
      character*26 date
      character*32 geomsum, basissum, bqsum, key
      character*20 scftype20    ! DECL MUST match movecs_converged routine
      character*128 basis_name, trans_name
      double precision energy, enrep
      integer inntsize
c
      if (oscfps) call pstat_on(ps_vecio)
      inntsize=MA_sizeof(MT_INT,1,MT_BYTE)
      call ga_sync()
c
c     Generate info to go into convergence and restart line
c
      if (basis.ne.-1 .and. rtdb.ne.-1) then
         if (.not. bas_checksum(basis, basissum))
     $        call errquit('movecs_write: bad basis',0, BASIS_ERR)
         if (.not. bas_geom(basis, geom))
     $        call errquit('movecs_write: bad basis',0, BASIS_ERR)
         if (.not. geom_checksum(geom, geomsum))
     $        call errquit('movecs_write: bad geometry',0, GEOM_ERR)
         if (.not. bas_name(basis, basis_name, trans_name))
     $        call errquit('movecs_write: bad basis',0, BASIS_ERR)
         if (trans_name .ne. ' ') basis_name = trans_name
         if (.not. bq_get_active(bq_handle)) then
              bqsum = ' '
         else
           if (.not. bq_checksum(bq_handle,bqsum)) then
              bqsum = ' '
           endif
         endif
c         
         key = ' '
         write(key,'(a,'':converged'')') scftype(1:inp_strlen(scftype))
         if (.not. rtdb_get_info(rtdb, key, ma_type, nelem, date))
     $        date = ' '
      else
         basissum = ' '
         geomsum  = ' '
         bqsum    = ' '
         date     = ' '
      endif
      scftype20 = scftype
c
c
      ok = 0
c
c Write scf energy at the end of the movecs file. If energy
c is not in rtdb, it is given a value of zero.
c
      write(key,'(a,'':energy'')') scftype(1:inp_strlen(scftype))
      if (.not. rtdb_get(rtdb, key, mt_dbl, 1, energy)) then
        energy=0.0d0
      endif
c
c get nuclear repulsion energy
      if (.not. geom_nuc_rep_energy(geom, enrep))
     $  call errquit('unable to get nuclear rep energy',geom, GEOM_ERR)
c
      if (ga_nodeid() .eq. 0) then
         if (nsets .gt. 2) then
            write(6,*) ' movecs_write: nsets > 2 ', nsets
            goto 10
         endif
         open(unitno, status='unknown', form='unformatted',
     $        file=filename, err=1000)
c
c        Information about convergence
c
         write(unitno, err=1001) basissum, geomsum, bqsum, scftype20,
     $                           date
c
c        Check that read routines are both consistent with this
c
         write(unitno, err=1001) scftype20
         lentit = max(1,inp_strlen(title)) ! 0 length record confuses f2c
         write(unitno, err=1001) lentit
         write(unitno, err=1001) title(1:lentit)
         lenbas = max(1,inp_strlen(basis_name))
         write(unitno, err=1001) lenbas
         write(unitno, err=1001) basis_name(1:lenbas)
         write(unitno, err=1001) nsets
         write(unitno, err=1001) nbf
         write(unitno, err=1001) (nmo(i),i=1,nsets)
         if (.not. ma_push_get(mt_dbl,nbf,'movecs_write',l_vecs,k_vecs))
     $        call errquit('movecs_write: ma failed', nbf, MA_ERR)
         do iset = 1, nsets
            write(unitno, err=1001) (occ(j,iset),j=1,nbf)
            write(unitno, err=1001) (evals(j,iset),j=1,nbf)
            do i = 1, nmo(iset)
               call ga_get(g_vecs(iset), 1, nbf, i, i, dbl_mb(k_vecs),1)
               call swrite(unitno, dbl_mb(k_vecs), nbf)
*               write(unitno, err=1001) (dbl_mb(k_vecs+j), j=0,nbf-1)
            enddo
         enddo
         if (.not. ma_pop_stack(l_vecs))
     $        call errquit('movecs_write: ma pop failed', l_vecs,
     &       MA_ERR)
c
c Write scf energy at the end of the movecs file. If energy
c is not in rtdb, it is given a value of zero.
c
         write(unitno, err=1001) energy, enrep
c         
         close(unitno,err=1002)
         ok = 1
      endif
c
 10   call ga_brdcst(Msg_Vec_Stat+MSGINT, ok, inntsize, 0) ! Propagate status
c
      movecs_write = ok .eq. 1
      if (ga_nodeid() .eq. 0 .and.
     $     util_print('vectors i/o', print_high)) then
         write(6,22) filename(1:inp_strlen(filename))
 22      format(/' Wrote molecular orbitals to ',a/)
         call util_flush(luout)
      endif
      call ga_sync()
      if (oscfps) call pstat_off(ps_vecio)
      return
c
 1000 write(6,*) ' movecs_write: failed to open ',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      goto 10
c
 1001 write(6,*) ' movecs_write: failing writing to ',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      close(unitno,err=1002)
      goto 10
c
 1002 write(6,*) ' movecs_write: failed to close',
     $     filename(1:inp_strlen(filename))
      call util_flush(luout)
      ok = 0
      goto 10
c
      end
      subroutine movecs_swap(rtdb, module, scftype,g_vecs,occ,eval)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
#include "inp.fh"
#include "stdio.fh"
c
      character*(*) scftype
      integer rtdb, g_vecs(*)
      double precision occ(*), eval(*)
      character*(*) module
c
c     In the database may be an entry '<module>:swap' (with
c     alpha/beta appended for UHF) which is a list of pairs
c     of vectors to swap.  Apply these to the input vectors, 
c     occupation numbers and eigenvalues.  In the case of
c     UHF g_vecs is assumed to be an array with 2 handles.
c     When finished delete the databse entries so that
c     a restart does not re-swap the vectors.
c
      double precision tmp
      integer type, nelem, handle, index
      integer l_veci, k_veci, l_vecj, k_vecj, dim1, dim2
      integer pair, i, j, ioff, joff, off, set, nset, mlen
      logical oprint,dorot
      double precision mixang,cosa,sina,pi
      integer k_tj,l_tj,k_ti,l_ti
      character*40 name
      character*8 text
c
      oprint = util_print('mo guess', print_default)
      mlen = inp_strlen(module)
c
      if (scftype .eq. 'UHF') then
         nset = 2
      else
         nset = 1
      endif
ccheck if we want the mix rotation
      if (rtdb_get(rtdb, 'mixang', mt_dbl, 1, mixang)) then
         dorot=.true.
         pi=acos(-1d0)
         cosa=cos(mixang*pi/180d0)
         sina=sin(mixang*pi/180d0)
c         write(6,*) ' nseeeet ',nset
      else
         dorot=.false.
      endif
c
      do set = 1, nset
         name = ' '
         if (scftype .eq. 'UHF') then
            if (set.eq.1) then
               write(name,'(a,a)') module(1:mlen),':swap alpha'
               text = 'alpha'
            else
               write(name,'(a,a)') module(1:mlen),':swap beta'
               text = 'beta'
            endif
         else
            write(name,'(a,a)') module(1:mlen),':swap'
            text = scftype
         endif
         if (.not. rtdb_ma_get(rtdb, name, type, nelem, 
     $        handle)) goto 1000
         if (.not. ma_get_index(handle,index)) call errquit
     $        ('movecs_swap: get index failed', handle, MA_ERR)
         if (type.ne.mt_int) call errquit
     $        ('movecs_swap: invalid list of pairs',nelem, MA_ERR)
c
         call ga_sync()
         call ga_inquire(g_vecs, type, dim1, dim2)
         if (ga_nodeid() .eq. 0) then
            if (oprint) write(6,*)
            if (.not. ma_push_get(mt_dbl, dim1, 'swap', l_veci, k_veci))
     $           call errquit('movecs_swap: no scratch space', dim1,
     &       MA_ERR)
            if (.not. ma_push_get(mt_dbl, dim1, 'swap', l_vecj, k_vecj))
     $           call errquit('movecs_swap: no scratch space', dim1,
     &       MA_ERR)
            do pair = 1, nelem, 2
               i = int_mb(index+pair-1)
               j = int_mb(index+pair  )
               if (oprint) write(6,1) text(1:inp_strlen(text)), i, j
 1             format(' Swapping ',a,' orbitals ', 2i5)
               if (i.lt.0 .or. i.gt.dim2) call errquit
     $              ('movecs_swap: invalid vector ', i, INPUT_ERR)
               if (j.lt.0 .or. j.gt.dim2) call errquit
     $              ('movecs_swap: invalid vector ', j, INPUT_ERR)
c     
               call ga_get(g_vecs(set), 1, dim1, i, i, dbl_mb(k_veci),1)
               call ga_get(g_vecs(set), 1, dim1, j, j, dbl_mb(k_vecj),1)
c
               if(dorot) then 
                  if (.not. ma_push_get(mt_dbl, dim1, 'swap', 
     J                 l_ti, k_ti))
     $                 call errquit('moswap: pushget fail', dim1, 0)
                  if (.not. ma_push_get(mt_dbl, dim1, 'swap', 
     J                 l_tj, k_tj))
     $                 call errquit('moswap: pushget fail', dim1, 0)
                  if(set.eq.1) then
c alpha
c psi_1 =  cos*psi_1 + sin*psi_2
                 call dcopy(dim1, 0.d0, 0, dbl_mb(k_ti), 1)
                 call daxpy(dim1,cosa,dbl_mb(k_veci),1,dbl_mb(k_ti),1)
                 call daxpy(dim1,sina,dbl_mb(k_vecj),1,dbl_mb(k_ti),1)
c psi_2 = -sin*psi_1 + cos*psi_2
                 call dcopy(dim1, 0.d0, 0, dbl_mb(k_tj), 1)
                 call daxpy(dim1,-sina,dbl_mb(k_veci),1,dbl_mb(k_tj),1)
                 call daxpy(dim1,cosa,dbl_mb(k_vecj),1,dbl_mb(k_tj),1)
c
               call ga_put(g_vecs(set), 1, dim1, i, i, dbl_mb(k_ti),1)
               call ga_put(g_vecs(set), 1, dim1, j, j, dbl_mb(k_tj),1)
               else
c
c     for beta we swap 1 and 2
c
               call ga_get(g_vecs(2), 1, dim1, i, i, dbl_mb(k_veci),1)
               call ga_get(g_vecs(2), 1, dim1, j, j, dbl_mb(k_vecj),1)
c psi_1 =  -sin*psi_1 + cos*psi_2
                 call dcopy(dim1, 0.d0, 0, dbl_mb(k_ti), 1)
                 call daxpy(dim1,-sina,dbl_mb(k_veci),1,dbl_mb(k_ti),1)
                 call daxpy(dim1,cosa,dbl_mb(k_vecj),1,dbl_mb(k_ti),1)
c psi_2 = cos*psi_1 + sin*psi_2
                 call dcopy(dim1, 0.d0, 0, dbl_mb(k_tj), 1)
                 call daxpy(dim1,cosa,dbl_mb(k_veci),1,dbl_mb(k_tj),1)
                 call daxpy(dim1,sina,dbl_mb(k_vecj),1,dbl_mb(k_tj),1)
c
               call ga_put(g_vecs(2), 1, dim1, i, i, dbl_mb(k_ti),1)
               call ga_put(g_vecs(2), 1, dim1, j, j, dbl_mb(k_tj),1)
                  endif
                  if (.not. ma_chop_stack(l_ti)) call errquit(
     M                 'moswap: chop stack?', 0,MA_ERR)
            else
               call ga_put(g_vecs(set), 1, dim1, i, i, dbl_mb(k_vecj),1)
               call ga_put(g_vecs(set), 1, dim1, j, j, dbl_mb(k_veci),1)
            endif
c
            enddo
            if (oprint) call util_flush(luout)
            if (.not. ma_pop_stack(l_vecj)) call errquit('ms:ma?', 0,
     &       MA_ERR)
            if (.not. ma_pop_stack(l_veci)) call errquit('ms:ma?', 0,
     &       MA_ERR)
         endif
c
         do pair = 1, nelem, 2
           i = int_mb(index+pair-1)
           j = int_mb(index+pair  )
           ioff = i + (set-1)*dim1
           joff = j + (set-1)*dim1
           tmp = occ(ioff)
           occ(ioff) = occ(joff)
           occ(joff) = tmp
           tmp = eval(ioff)
           eval(ioff) = eval(joff)
           eval(joff) = tmp
         enddo
c
         call ga_sync
c
         if (.not. rtdb_delete(rtdb, name)) call errquit
     $        ('movecs_swap: delete of swap entry failed', 0, RTDB_ERR)
c
         if (.not. ma_free_heap(handle)) call errquit('ms:ma?', 0,
     &       MA_ERR)
 1000    continue
      enddo
c
      end


      subroutine movecs_swap_nuclei(rtdb,basis,geom,scftype,g_vecs)
      implicit none
#include "errquit.fh"
c
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
#include "inp.fh"
#include "bas.fh"
#include "geom.fh"
#include "stdio.fh"
c
c     In the database may be an entry 'reorder' which is a list
c     containing the new ordering of the atoms. The MO blocks over each atoms
c     range of basis functions will be reordered according to this list.
c
c     Apply these to the input vectors only (eigenvalues and
c     occupation numbers are unchanged since the MO ordering is
c     not changed). In the case of UHF, g_vecs is assumed to be
c     an array with 2 handles.
c
c     When finished delete the databse entries so that
c     a restart does not re-reorder the vectors.
c
      character*(*) scftype
      integer rtdb, basis,g_vecs(*), nbf, nat, geom
      integer type, nelem, handle, index, g_temp
      integer i, j, k, set, nset
      integer l_atm, k_atm, l_batm, k_batm
      integer jlo, jhi
      integer dim1, dim2, start_from, end_from, start_to, end_to
      logical oprint
c
      oprint = util_print('mo guess',print_default)  
c
      if (scftype .eq. 'UHF') then
        nset = 2
      else
        nset = 1
      endif
c
      if (.not.bas_numbf(basis,nbf))
     $     call errquit('movecs_swap_nuclei: bas_numbf failed',0,0)
c
      if (.not. geom_ncent(geom, nat))
     &     call errquit('movecs_swap_nuclei: geom_ncent failed',0,0)
c
c  set up the list of atoms to reorder
c  -----------------------------------
c
      if (.not.ma_push_get(mt_int,nat,'atom list',l_atm, k_atm))
     &    call errquit('movecs_swap_nuclei: ma_push failed',0,0)
c
      if (.not.ma_push_get(mt_int,nat,'nbf_at list',l_batm, k_batm))
     &    call errquit('movecs_swap_nuclei: ma_push failed',0,0)
c
      if (.not. rtdb_ma_get(rtdb, 'reorder', type, nelem,handle)) 
     $   call errquit('movecs_swap_nuclei: invalid list of pairs',
     $   nelem, 0)
      if (.not. ma_get_index(handle,index)) call errquit
     $    ('movecs_swap_nuclei: get index failed', handle , 0)
      if (type.ne.mt_int) call errquit
     $    ('movecs_swap_nuclei: invalid list of pairs',nelem , 0)
      if (nelem.ne.nat) call errquit
     $    ('movecs_swap_nuclei: reorder list.ne.#atoms',0 , 0)
c
      do i = 1, nelem
         j = int_mb(index+i-1)
           if (i.lt.0.or.i.gt.nat) 
     &       call errquit('movecs_swap_nucei: invalid vector',0,0)
           if (j.lt.0.or.j.gt.nat) 
     &       call errquit('movecs_swap_nucei: invalid vector',0,0)
         int_mb(k_atm+i-1) = j
      enddo
c
c  find nbf for each atom 
c  ----------------------
c
      if (ga_nodeid().eq.0) then
      call util_print_centered(LuOut,'Reordering MO coeffs on atoms',25,
     $        .true.)
      write(LuOut,*) 
      write(LuOut,101) 'old','new','old','new'
      write(LuOut,102) 'atom#','atom#','basis range','basis range'
      write(LuOut,*) '-------------------------------------------------'
      endif
c
      int_mb(k_batm) = 0
      do i = 1,nat
        j = int_mb(k_atm+i-1)
        if (.not.bas_ce2bfr(basis,i,jlo,jhi)) 
     &    call errquit('movecs_swap_nuclei: bas_ce2bfr',0,0)
        int_mb(k_batm+j-1) = jhi-jlo+1
      enddo
c
c  reorder atoms in each set
c  -------------------------
c
      do set = 1,nset
      call ga_inquire(g_vecs(set),type,dim1,dim2)
c 
      if ( .not. ga_create( mt_dbl, dim1, dim2, 'temp vectors',
     $    0,0,g_temp) ) 
     $    call errquit('movecs_swap_nuclei: ga_create failed',0, 0)
      call ga_zero(g_temp)
c
      start_to = 1
c
      do i= 1, nat
      j = int_mb(k_atm+i-1)
c
        start_from = 0
        do k = 1,j-1
          start_from = start_from + int_mb(k_batm+k-1)
        enddo
        start_from = start_from + 1
c
        end_from = start_from + int_mb(k_batm+j-1) - 1
c
        end_to = start_to + int_mb(k_batm+j-1) - 1

        if (ga_nodeid().eq.0.and.set.eq.1) then
        write(LuOut,103) j,i,start_from,end_from,start_to,end_to
        endif
c
        call ga_copy_patch('N',g_vecs(set),start_from,end_from,1,dim2,
     &       g_temp,start_to,end_to,1,dim2)
c
        start_to = start_to + int_mb(k_batm+j-1)
       enddo ! nat
c
      call ga_copy(g_temp, g_vecs(set))
c
      if ( .not. ga_destroy(g_temp))
     $    call errquit('movecs_swap_nuclei: ga_destroy failed',0, 0)
c
      enddo  ! set
c
      call ga_sync()
c
  101 format(2x,a3,4x,a3,11x,a3,16x,a3)
  102 format(1x,a5,2x,a5,7x,a11,8x,a11)
  103 format(i4,2x,i4,5x,i6,2x,i6,5x,i6,2x,i6)
        if (.not. ma_pop_stack(l_batm))
     $    call errquit('movecs_swap_nuclei: ma pop failed',0, 0)
c
        if (.not. ma_pop_stack(l_atm))
     $    call errquit('movecs_swap_nuclei: ma pop failed',0, 0)
c
       if (.not.rtdb_delete(rtdb,'reorder') )
     &   call errquit('movecs_swap_nuclei: rtdb delete failed',0,0)
c
       if (.not. ma_free_heap(handle)) 
     &   call errquit('movecs_swap_nuclei: cant free heap',0,0)
c
      end


      logical function file_write_ga(fname, g_a)
      implicit none
c
c     Generic routine for sequential write of global array to file
c
      character*(*) fname            ! [input] Name of file to write to
      integer g_a                    ! [input] Array to write
c
      integer nrow, ncol, type
      logical file_write_ga_patch
      external file_write_ga_patch
c
      call ga_inquire(g_a, type, nrow, ncol)
c
      file_write_ga = file_write_ga_patch(fname, g_a, 1, nrow, 1, ncol)
c
      end
      logical function file_read_ga(fname, g_a)
      implicit none
c
c     Generic routine for sequential read of global array from file
c
      character*(*) fname            ! [input] Name of file to read from
      integer g_a                    ! [input] Array to read
c
      integer nrow, ncol, type
      logical file_read_ga_patch
      external file_read_ga_patch
c
      call ga_inquire(g_a, type, nrow, ncol)
c
      file_read_ga = file_read_ga_patch(fname, g_a, 1, nrow, 1, ncol)
c
      end
      logical function movecs_converged(rtdb, basis, scftype, filename)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "bas.fh"
#include "geom.fh"
#include "tcgmsg.fh"
#include "bq.fh"
      integer rtdb              ! [input]
      integer basis             ! [input]
      character*(*) scftype     ! [input] Current SCF type
      character*(*) filename    ! [input] MOvecs filename
c
c     Return true/false if the MO vectors in the file correspond
c     to converged vectors of the current SCF type with the
c     current set of options.
c
c     1) The movecs file contains basis checksum, geometry checksum,
c     .  scftype, date on convergence flag in the database at the
c     .  time the vectors were written.
c
c     2) The database contains a convergence flag that is deleted
c     .  whenever any input is changed or options automatically 
c     .  changed.
c
c     The calculation is converged if all of the following are true
c     
c     a) convergence flag is present in the database and the date 
c     .  matches the date in the movecs file
c     b) scftypes match
c     c) basis and geometry checksums match
c
      character*20 filescftype  ! MUST MATCH WRITE ROUTINE DECL
      character*32 filebasissum, filegeomsum, basissum, geomsum
      character*32 filebqsum, bqsum
      logical oconverged
      character*40 key
      character*26 date, filedate
      integer geom, ma_type, nelem
      integer bq_handle         ! Handle of the BQ fragment
      integer unitno            ! Unit no. for reading
      integer inntsize
      parameter (unitno = 67)   ! These need to be managed !!!
      logical status, oldmode
c
      status = .false.
      inntsize=MA_sizeof(MT_INT,1,MT_BYTE)
c
      oldmode =  rtdb_parallel(.false.)
      if (ga_nodeid() .eq. 0) then
         open(unitno, status='old', form='unformatted',
     $        file=filename, err=1000)
         read(unitno, end=1001, err=2001)
     $        filebasissum, filegeomsum, filebqsum, filescftype,
     $        filedate
         goto 3001
c
c        If the previous read statement failed we may have a movecs
c        file from an old version of the code. So try reading the 
c        old format (but this means that the vectors cannot be
c        considered as converged). Non-convergence of the vectors
c        is detected from the filebqsum value which we set to something
c        unusual so it will not match anything obvious.
c
 2001    continue
         filebqsum = " "
         rewind(unitno, err=1001)
         read(unitno, end=1001, err=1001)
     $     filebasissum, filegeomsum, filescftype, filedate
 3001    continue
         close(unitno, err=1002)
c     
c     a)
c     
         key = ' '
         write(key,'(a,'':converged'')') scftype(1:inp_strlen(scftype))
         if (.not. rtdb_get(rtdb, key, mt_log, 1, oconverged)) goto 10
         if (.not. oconverged) goto 10
         if (.not. rtdb_get_info(rtdb, key, ma_type, nelem, date))
     $        call errquit('movecs_converged: rtdb corrupt?',0,
     &       RTDB_ERR)
         if (date .ne. filedate) goto 10
c     
c     b) 
c     
         if (.not. inp_compare(.false., scftype, filescftype)) goto 10
c     
c     c) 
c     
         if (.not. bas_geom(basis, geom)) 
     $        call errquit('movecs_converged: bad basis',0, BASIS_ERR)
         if (.not. bas_checksum(basis, basissum))
     $        call errquit('movecs_converged: bad basis',0, BASIS_ERR)
         if (.not. geom_checksum(geom, geomsum))
     $        call errquit('movecs_converged: bad geometry',0,
     &       BASIS_ERR)
         if (.not. bq_get_active(bq_handle)) then
              bqsum = ' '
         else
           if (.not. bq_checksum(bq_handle,bqsum)) then
              bqsum = ' '
           endif
         endif
         if (basissum.ne.filebasissum .or. geomsum.ne.filegeomsum .or.
     $       bqsum.ne.filebqsum) 
     $        goto 10
c     
c     Cool ... it is converged!
c
         status = .true.
      endif
c
 10   oldmode =  rtdb_parallel(oldmode)
      call ga_brdcst(1311, status, inntsize, 0)
      movecs_converged = status
      return
c
 1000 call errquit('movecs_converged: error opening file',0, DISK_ERR)
 1001 call errquit('movecs_converged: error reading file',0, DISK_ERR)
 1002 call errquit('movecs_converged: error closing file',0, DISK_ERR)
c
      end
      logical function file_read_ga_info(fname,
     $     title, nrow, ncol)
      implicit none
#include "global.fh"
#include "tcgmsg.fh"
#include "inp.fh"
#include "eaf.fh"
#include "stdio.fh"
#include "mafdecls.fh"
c
      character*(*) fname
      character*(*) title
      integer nrow, ncol
c
c     Read the header info from the dumb file_ga file
c
      integer unitno                 ! Unit no. for writing
      integer len1, ok
      integer ierr
      double precision offset
      integer lgth
      character*255 errmsg
      integer inntsize
c
      ok = 1
      inntsize=MA_sizeof(MT_INT,1,MT_BYTE)
      if (ga_nodeid() .eq. 0) then
         offset=0d0
         ierr=eaf_open(fname(1:inp_strlen(fname)),
     ,        eaf_rw, unitno)
        if (ierr .ne. 0) then
           call eaf_errmsg(ierr,errmsg)
           write(LuOut,*) ga_nodeid(),errmsg
           goto 1000
        endif
        lgth=ma_sizeof(MT_INT,1,MT_BYTE)
        ierr = eaf_read(unitno, offset, len1,lgth)
        offset=offset+lgth
        lgth=len1
#ifdef WIN32        
        title=' '
#else
        ierr = eaf_read(unitno, offset, title(1:len1),lgth)
#endif
        offset=offset+lgth
        lgth=ma_sizeof(MT_INT,1,MT_BYTE)
        ierr = eaf_read(unitno, offset, nrow,lgth)
        offset=offset+lgth
        lgth=ma_sizeof(MT_INT,1,MT_BYTE)
        ierr = eaf_read(unitno, offset, ncol,lgth)
        if (ierr .ne. 0) then
           call eaf_errmsg(ierr, errmsg)
           write(LuOut,*) ' IO offset ', offset
           write(LuOut,*) ' IO error message ',
     $          errmsg(1:inp_strlen(errmsg))
           goto 1001
        endif
        ierr=eaf_close(unitno)
        if (ierr .ne. 0) then
           write(luout,*) ga_nodeid(),' closing FD =',unitno,
     ,          fname
            call eaf_errmsg(ierr, errmsg)
            write(LuOut,*) ' IO error message ',
     $           errmsg(1:inp_strlen(errmsg))
            call util_flush(luout)
            goto 1002
         endif
         goto 10
c
 1000    write(6,*) ' file_read_ga_info: failed to open ',
     $        fname(1:inp_strlen(fname))
         call util_flush(luout)
         ok = 0
         goto 10
c     
 1001    write(6,*) ' file_read_ga_info: failing reading from ',
     $        fname(1:inp_strlen(fname))
         call util_flush(luout)
         ok = 0
        ierr=eaf_close(unitno)
        if (ierr .ne. 0) then
           write(luout,*) ga_nodeid(),' closing FD =',unitno,
     ,          fname
            call eaf_errmsg(ierr, errmsg)
            write(LuOut,*) ' IO error message ',
     $           errmsg(1:inp_strlen(errmsg))
            call util_flush(luout)
            goto 1002
         endif
         goto 10
c     
 1002    write(6,*) ' file_read_ga_info: failed to close',
     $        fname(1:inp_strlen(fname))
         call util_flush(luout)
         ok = 0
         goto 10
      end if
c
 10   call ga_sync()
      call ga_brdcst(1, ok, inntsize, 0) ! Propagate status
      call ga_brdcst(2, nrow, inntsize, 0)
      call ga_brdcst(3, ncol, inntsize, 0)
      call util_char_ga_brdcst(4, title, 0)
c
      file_read_ga_info = ok .eq. 1
c
      end
      logical function file_write_ga_patch(fname, g_a, 
     $     ilo, ihi, jlo, jhi)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "mafdecls.fh"
#include "inp.fh"
#include "msgids.fh"
#include "util.fh"
#include "eaf.fh"
#include "stdio.fh"
c
c     Generic routine for sequential write 
c     of global array to file
c
      character*(*) fname            ! [input] Name of file to write to
      integer g_a                    ! [input] Array to write
      integer ilo, ihi, jlo, jhi     ! [input] Patch to write
c
      integer unitno                 ! Unit no. for writing
      character*255 gtitle
      integer l_tmp, k_tmp
      integer len1, nrow, ncol
      integer ok, j
      integer ierr
      double precision offset
      integer lgth
      integer inntsize
      character*255 errmsg
c
      inntsize=MA_sizeof(MT_INT,1,MT_BYTE)
      call ga_sync
c
      ok = 0
      nrow = ihi-ilo+1
      ncol = jhi-jlo+1
      call ga_inquire_name(g_a, gtitle)
      len1 = inp_strlen(gtitle)
      if (ga_nodeid() .eq. 0) then
         offset=0d0
         ierr=eaf_open(fname(1:inp_strlen(fname)),eaf_rw, unitno)
        if (ierr .ne. 0) then
           call eaf_errmsg(ierr,errmsg)
           write(LuOut,*) ga_nodeid(),errmsg
           call errquit('vectors: eaf_open failed',0, ierr)
        endif
        lgth=ma_sizeof(MT_INT,1,MT_BYTE)
        ierr = eaf_write(unitno, offset, len1,lgth)
        offset=offset+lgth
        lgth=len1
#ifdef WIN32        
        gtitle=' '
#else     
        ierr = eaf_write(unitno, offset, gtitle(1:len1),lgth)
#endif
        offset=offset+lgth
        lgth=ma_sizeof(MT_INT,1,MT_BYTE)
        ierr = eaf_write(unitno, offset, nrow,lgth)
        offset=offset+lgth
        lgth=ma_sizeof(MT_INT,1,MT_BYTE)
        ierr = eaf_write(unitno, offset, ncol,lgth)
        if (ierr .ne. 0) then
           call eaf_errmsg(ierr, errmsg)
           write(LuOut,*) ' IO offset ', offset
           write(LuOut,*) ' IO error message ',
     $          errmsg(1:inp_strlen(errmsg))
           goto 1001
        endif
        offset=offset+lgth
         
        if (.not. ma_push_get(mt_dbl,nrow,'movecs_write',l_tmp,k_tmp))
     $    call errquit('matrix_fwrite: ma failed', nrow, MA_ERR)
        lgth=8d0*nrow
        do j=jlo,jhi
          call ga_get(g_a, ilo, ihi, j, j, dbl_mb(k_tmp), 1)
          ierr = eaf_write(unitno, offset, dbl_mb(k_tmp),lgth)
          if (ierr .ne. 0) then
             call eaf_errmsg(ierr, errmsg)
             write(LuOut,*) ' IO offset ', offset
             write(LuOut,*) ' IO error message ',
     $            errmsg(1:inp_strlen(errmsg))
             goto 1001
        endif
        offset=offset+lgth
        enddo
        if (.not. ma_pop_stack(l_tmp))
     $    call errquit('file_write_ga: ma pop failed', l_tmp, MA_ERR)

      ierr=eaf_close(unitno)
      if (ierr .ne. 0) then
         write(luout,*) ga_nodeid(),' closing FD =',unitno,
     ,        fname
         call eaf_errmsg(ierr, errmsg)
         write(LuOut,*) ' IO error message ',
     $        errmsg(1:inp_strlen(errmsg))
         call util_flush(luout)
         goto 1002
      endif
        ok = 1
      endif
c
 10   call ga_sync
      call ga_brdcst(Msg_Vec_Stat+MSGINT, ok, inntsize, 0)        ! Propagate status
c
      file_write_ga_patch = ok .eq. 1
      if (ga_nodeid() .eq. 0 .and.
     $     util_print('vectors i/o', print_high)) then
         write(6,22) gtitle(1:len1), fname(1:inp_strlen(fname))
 22      format(/' Wrote ',a,' to ',a/)
         call util_flush(luout)
      endif
      return
c
 1000 write(6,*) ' file_write_ga: failed to open ',
     $     fname(1:inp_strlen(fname))
      call util_flush(luout)
      ok = 0
      goto 10
c
 1001 write(6,*) ' file_write_ga: failing writing to ',
     $     fname(1:inp_strlen(fname))
      call util_flush(luout)
      ok = 0
      ierr=eaf_close(unitno)
      if (ierr .ne. 0) then
         write(luout,*) ga_nodeid(),' closing FD =',unitno,
     ,        fname
         call eaf_errmsg(ierr, errmsg)
         write(LuOut,*) ' IO error message ',
     $        errmsg(1:inp_strlen(errmsg))
         call util_flush(luout)
         goto 1002
      endif
      goto 10
c
 1002 write(6,*) ' file_write_ga: failed to close',
     $     fname(1:inp_strlen(fname))
      call util_flush(luout)
      ok = 0
      goto 10
c
      end
      logical function file_read_ga_patch
     $     (fname, g_a, ilo, ihi, jlo, jhi)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "mafdecls.fh"
#include "inp.fh"
#include "msgids.fh"
#include "util.fh"
#include "eaf.fh"
#include "stdio.fh"
c
c     Generic routine for sequential read 
c     of file to global array
c
      character*(*) fname            ! [input] Name of file to read from
      integer g_a                    ! [output] Array
      integer ilo, ihi, jlo, jhi     ! [input]
c
      integer unitno                 ! Unit no. for writing
      character*255 gtitle
      integer l_tmp, k_tmp
      integer len1, nrow, ncol
      integer grow, gcol
      integer ok, j
      integer ierr
      double precision offset
      integer lgth
      integer inntsize
      character*255 errmsg
c
      inntsize=ma_sizeof(MT_INT,1,MT_BYTE)
      call ga_sync()
c
      ok = 0
      grow = ihi-ilo+1
      gcol = jhi-jlo+1
      call ga_inquire_name(g_a, gtitle)
      len1 = inp_strlen(gtitle)
      if (ga_nodeid() .eq. 0) then
         offset=0d0
         ierr=eaf_open(fname(1:inp_strlen(fname)),
     ,        eaf_rw, unitno)
         if (ierr .ne. 0) then
           call eaf_errmsg(ierr,errmsg)
           write(LuOut,*) ga_nodeid(),errmsg
           goto 1000
        endif
        lgth=inntsize
        ierr = eaf_read(unitno, offset, len1,lgth)
        offset=offset+lgth
        lgth=len1
#ifdef WIN32        
        gtitle=' '
#else
        ierr = eaf_read(unitno, offset, gtitle(1:len1),lgth)
#endif
        offset=offset+lgth
        lgth=inntsize
        ierr = eaf_read(unitno, offset, nrow,lgth)
        offset=offset+lgth
        lgth=inntsize
        ierr = eaf_read(unitno, offset, ncol,lgth)
        if (ierr .ne. 0) then
           call eaf_errmsg(ierr, errmsg)
           write(LuOut,*) ' IO offset ', offset
           write(LuOut,*) ' IO error message ',
     $          errmsg(1:inp_strlen(errmsg))
           goto 1001
        endif
        offset=offset+lgth
        if ((nrow.ne.grow).and.(ncol.ne.gcol)) goto 2000
        if (.not. ma_push_get(mt_dbl,nrow,'movecs_write',l_tmp,k_tmp))
     $    call errquit('matrix_fwrite: ma failed', nrow, MA_ERR)
        lgth=8d0*nrow
        do j=jlo,jhi
          ierr = eaf_read(unitno, offset, dbl_mb(k_tmp),lgth)
          if (ierr .ne. 0) then
             call eaf_errmsg(ierr, errmsg)
             write(LuOut,*) ' IO offset ', offset
             write(LuOut,*) ' IO error message ',
     $            errmsg(1:inp_strlen(errmsg))
          goto 1001
        endif
        offset=offset+lgth
        call ga_put(g_a, ilo, ihi, j, j, dbl_mb(k_tmp), 1)
        enddo
        if (.not. ma_pop_stack(l_tmp))
     $    call errquit('file_read_ga: ma pop failed', l_tmp, MA_ERR)
        ierr=eaf_close(unitno)
        if (ierr .ne. 0) then
           write(luout,*) ga_nodeid(),' closing FD =',unitno,
     ,          fname
            call eaf_errmsg(ierr, errmsg)
            write(LuOut,*) ' IO error message ',
     $           errmsg(1:inp_strlen(errmsg))
            call util_flush(luout)
            goto 1002
         endif
        ok = 1
      endif
c
 10   call ga_sync()
      call ga_brdcst(Msg_Vec_Stat+MSGINT, ok, inntsize, 0)        ! Propagate status
c
      file_read_ga_patch = ok .eq. 1
      if (ga_nodeid() .eq. 0 .and.
     $     util_print('vectors i/o', print_high)) then
         write(6,22) gtitle(1:len1), fname(1:inp_strlen(fname))
 22      format(/' Read ',a,' from ',a/)
         call util_flush(luout)
      endif
      return
c
 1000 write(6,*) ' file_read_ga: failed to open ',
     $     fname(1:inp_strlen(fname))
      call util_flush(luout)
      ok = 0
      goto 10
c
 1001 write(6,*) ' file_read_ga: failing writing to ',
     $     fname(1:inp_strlen(fname))
      call util_flush(luout)
      ok = 0
      ierr=eaf_close(unitno)
      if (ierr .ne. 0) then
         write(luout,*) ga_nodeid(),' closing FD =',unitno,
     ,        fname
         call eaf_errmsg(ierr, errmsg)
         write(LuOut,*) ' IO error message ',
     $        errmsg(1:inp_strlen(errmsg))
         call util_flush(luout)
         goto 1002
      endif
      goto 10
c
 1002 write(6,*) ' file_read_ga: failed to close',
     $     fname(1:inp_strlen(fname))
      call util_flush(luout)
      ok = 0
      goto 10
c
 2000 write(6,*) ' file_read_ga: GA and file ',
     $           'contents mismatch dimensions',
     $           nrow, ncol, grow, gcol
      call util_flush(luout)
      ok = 0
      goto 10
c
      end

*
* $Id: fci_load.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_load(h,g,ecore)
      implicit none
#include "fciinfo.fh"
c
c     Read the 1e/2e integrals from a simple ASCII list ... this
c     for debug only from testcase integrals.
c
      double precision h(nacttr) ! [output]
      double precision g(nacttr,nacttr) ! [output]
      double precision ecore    ! [output]
c
      integer i, j, k, l, ij, kl, ind
      double precision gg
c      
      ind(i,j) = max(i,j)*(max(i,j)-1)/2 + min(i,j)
c
      call dfill(0.0d0,g,1,nacttr*nacttr)
      call dfill(0.0d0,h,1,nacttr)
c
      ecore = 0.0d0
c
10    read (5,*,end=20) gg,i,j,k,l
      if (i.gt.nactiv .or. j.gt.nactiv .or. k.gt.nactiv .or.
     $     l.gt.nactiv) goto 10
      if (k.gt.0) then
        ij = ind(i,j)
        kl = ind(k,l)
        g(ij,kl) = gg
        g(kl,ij) = gg
      else if (i.gt.0) then
         if (abs(gg) .lt. 1d-6) gg = 0.0d0
        ij = ind(i,j)
        h(ij) = gg
      else
        ecore = gg
      endif
      goto 10
c
20    continue
c
      end

*> \brief \b DLAHQR computes the eigenvalues and Schur factorization of an upper Hessenberg matrix, using the double-shift/single-shift QR algorithm.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLAHQR + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlahqr.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlahqr.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlahqr.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI,
*                          ILOZ, IHIZ, Z, LDZ, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
*       LOGICAL            WANTT, WANTZ
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   H( LDH, * ), WI( * ), WR( * ), Z( LDZ, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    DLAHQR is an auxiliary routine called by DHSEQR to update the
*>    eigenvalues and Schur decomposition already computed by DHSEQR, by
*>    dealing with the Hessenberg submatrix in rows and columns ILO to
*>    IHI.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] WANTT
*> \verbatim
*>          WANTT is LOGICAL
*>          = .TRUE. : the full Schur form T is required;
*>          = .FALSE.: only eigenvalues are required.
*> \endverbatim
*>
*> \param[in] WANTZ
*> \verbatim
*>          WANTZ is LOGICAL
*>          = .TRUE. : the matrix of Schur vectors Z is required;
*>          = .FALSE.: Schur vectors are not required.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix H.  N >= 0.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>          It is assumed that H is already upper quasi-triangular in
*>          rows and columns IHI+1:N, and that H(ILO,ILO-1) = 0 (unless
*>          ILO = 1). DLAHQR works primarily with the Hessenberg
*>          submatrix in rows and columns ILO to IHI, but applies
*>          transformations to all of H if WANTT is .TRUE..
*>          1 <= ILO <= max(1,IHI); IHI <= N.
*> \endverbatim
*>
*> \param[in,out] H
*> \verbatim
*>          H is DOUBLE PRECISION array, dimension (LDH,N)
*>          On entry, the upper Hessenberg matrix H.
*>          On exit, if INFO is zero and if WANTT is .TRUE., H is upper
*>          quasi-triangular in rows and columns ILO:IHI, with any
*>          2-by-2 diagonal blocks in standard form. If INFO is zero
*>          and WANTT is .FALSE., the contents of H are unspecified on
*>          exit.  The output state of H if INFO is nonzero is given
*>          below under the description of INFO.
*> \endverbatim
*>
*> \param[in] LDH
*> \verbatim
*>          LDH is INTEGER
*>          The leading dimension of the array H. LDH >= max(1,N).
*> \endverbatim
*>
*> \param[out] WR
*> \verbatim
*>          WR is DOUBLE PRECISION array, dimension (N)
*> \endverbatim
*>
*> \param[out] WI
*> \verbatim
*>          WI is DOUBLE PRECISION array, dimension (N)
*>          The real and imaginary parts, respectively, of the computed
*>          eigenvalues ILO to IHI are stored in the corresponding
*>          elements of WR and WI. If two eigenvalues are computed as a
*>          complex conjugate pair, they are stored in consecutive
*>          elements of WR and WI, say the i-th and (i+1)th, with
*>          WI(i) > 0 and WI(i+1) < 0. If WANTT is .TRUE., the
*>          eigenvalues are stored in the same order as on the diagonal
*>          of the Schur form returned in H, with WR(i) = H(i,i), and, if
*>          H(i:i+1,i:i+1) is a 2-by-2 diagonal block,
*>          WI(i) = sqrt(H(i+1,i)*H(i,i+1)) and WI(i+1) = -WI(i).
*> \endverbatim
*>
*> \param[in] ILOZ
*> \verbatim
*>          ILOZ is INTEGER
*> \endverbatim
*>
*> \param[in] IHIZ
*> \verbatim
*>          IHIZ is INTEGER
*>          Specify the rows of Z to which transformations must be
*>          applied if WANTZ is .TRUE..
*>          1 <= ILOZ <= ILO; IHI <= IHIZ <= N.
*> \endverbatim
*>
*> \param[in,out] Z
*> \verbatim
*>          Z is DOUBLE PRECISION array, dimension (LDZ,N)
*>          If WANTZ is .TRUE., on entry Z must contain the current
*>          matrix Z of transformations accumulated by DHSEQR, and on
*>          exit Z has been updated; transformations are applied only to
*>          the submatrix Z(ILOZ:IHIZ,ILO:IHI).
*>          If WANTZ is .FALSE., Z is not referenced.
*> \endverbatim
*>
*> \param[in] LDZ
*> \verbatim
*>          LDZ is INTEGER
*>          The leading dimension of the array Z. LDZ >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>           =   0: successful exit
*>          .GT. 0: If INFO = i, DLAHQR failed to compute all the
*>                  eigenvalues ILO to IHI in a total of 30 iterations
*>                  per eigenvalue; elements i+1:ihi of WR and WI
*>                  contain those eigenvalues which have been
*>                  successfully computed.
*>
*>                  If INFO .GT. 0 and WANTT is .FALSE., then on exit,
*>                  the remaining unconverged eigenvalues are the
*>                  eigenvalues of the upper Hessenberg matrix rows
*>                  and columns ILO thorugh INFO of the final, output
*>                  value of H.
*>
*>                  If INFO .GT. 0 and WANTT is .TRUE., then on exit
*>          (*)       (initial value of H)*U  = U*(final value of H)
*>                  where U is an orthognal matrix.    The final
*>                  value of H is upper Hessenberg and triangular in
*>                  rows and columns INFO+1 through IHI.
*>
*>                  If INFO .GT. 0 and WANTZ is .TRUE., then on exit
*>                      (final value of Z)  = (initial value of Z)*U
*>                  where U is the orthogonal matrix in (*)
*>                  (regardless of the value of WANTT.)
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup doubleOTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>     02-96 Based on modifications by
*>     David Day, Sandia National Laboratory, USA
*>
*>     12-04 Further modifications by
*>     Ralph Byers, University of Kansas, USA
*>     This is a modified version of DLAHQR from LAPACK version 3.0.
*>     It is (1) more robust against overflow and underflow and
*>     (2) adopts the more conservative Ahues & Tisseur stopping
*>     criterion (LAWN 122, 1997).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI,
     $                   ILOZ, IHIZ, Z, LDZ, INFO )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            IHI, IHIZ, ILO, ILOZ, INFO, LDH, LDZ, N
      LOGICAL            WANTT, WANTZ
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   H( LDH, * ), WI( * ), WR( * ), Z( LDZ, * )
*     ..
*
*  =========================================================
*
*     .. Parameters ..
      INTEGER            ITMAX
      PARAMETER          ( ITMAX = 30 )
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0d0, ONE = 1.0d0, TWO = 2.0d0 )
      DOUBLE PRECISION   DAT1, DAT2
      PARAMETER          ( DAT1 = 3.0d0 / 4.0d0, DAT2 = -0.4375d0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   AA, AB, BA, BB, CS, DET, H11, H12, H21, H21S,
     $                   H22, RT1I, RT1R, RT2I, RT2R, RTDISC, S, SAFMAX,
     $                   SAFMIN, SMLNUM, SN, SUM, T1, T2, T3, TR, TST,
     $                   ULP, V2, V3
      INTEGER            I, I1, I2, ITS, J, K, L, M, NH, NR, NZ
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   V( 3 )
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLABAD, DLANV2, DLARFG, DROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         WR( ILO ) = H( ILO, ILO )
         WI( ILO ) = ZERO
         RETURN
      END IF
*
*     ==== clear out the trash ====
      DO 10 J = ILO, IHI - 3
         H( J+2, J ) = ZERO
         H( J+3, J ) = ZERO
   10 CONTINUE
      IF( ILO.LE.IHI-2 )
     $   H( IHI, IHI-2 ) = ZERO
*
      NH = IHI - ILO + 1
      NZ = IHIZ - ILOZ + 1
*
*     Set machine-dependent constants for the stopping criterion.
*
      SAFMIN = DLAMCH( 'SAFE MINIMUM' )
      SAFMAX = ONE / SAFMIN
      CALL DLABAD( SAFMIN, SAFMAX )
      ULP = DLAMCH( 'PRECISION' )
      SMLNUM = SAFMIN*( DBLE( NH ) / ULP )
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      END IF
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of 1 or 2. Each iteration of the loop works
*     with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   20 CONTINUE
      L = ILO
      IF( I.LT.ILO )
     $   GO TO 160
*
*     Perform QR iterations on rows and columns ILO to I until a
*     submatrix of order 1 or 2 splits off at the bottom because a
*     subdiagonal element has become negligible.
*
      DO 140 ITS = 0, ITMAX
*
*        Look for a single small subdiagonal element.
*
         DO 30 K = I, L + 1, -1
            IF( ABS( H( K, K-1 ) ).LE.SMLNUM )
     $         GO TO 40
            TST = ABS( H( K-1, K-1 ) ) + ABS( H( K, K ) )
            IF( TST.EQ.ZERO ) THEN
               IF( K-2.GE.ILO )
     $            TST = TST + ABS( H( K-1, K-2 ) )
               IF( K+1.LE.IHI )
     $            TST = TST + ABS( H( K+1, K ) )
            END IF
*           ==== The following is a conservative small subdiagonal
*           .    deflation  criterion due to Ahues & Tisseur (LAWN 122,
*           .    1997). It has better mathematical foundation and
*           .    improves accuracy in some cases.  ====
            IF( ABS( H( K, K-1 ) ).LE.ULP*TST ) THEN
               AB = MAX( ABS( H( K, K-1 ) ), ABS( H( K-1, K ) ) )
               BA = MIN( ABS( H( K, K-1 ) ), ABS( H( K-1, K ) ) )
               AA = MAX( ABS( H( K, K ) ),
     $              ABS( H( K-1, K-1 )-H( K, K ) ) )
               BB = MIN( ABS( H( K, K ) ),
     $              ABS( H( K-1, K-1 )-H( K, K ) ) )
               S = AA + AB
               IF( BA*( AB / S ).LE.MAX( SMLNUM,
     $             ULP*( BB*( AA / S ) ) ) )GO TO 40
            END IF
   30    CONTINUE
   40    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order 1 or 2 has split off.
*
         IF( L.GE.I-1 )
     $      GO TO 150
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.10 ) THEN
*
*           Exceptional shift.
*
            S = ABS( H( L+1, L ) ) + ABS( H( L+2, L+1 ) )
            H11 = DAT1*S + H( L, L )
            H12 = DAT2*S
            H21 = S
            H22 = H11
         ELSE IF( ITS.EQ.20 ) THEN
*
*           Exceptional shift.
*
            S = ABS( H( I, I-1 ) ) + ABS( H( I-1, I-2 ) )
            H11 = DAT1*S + H( I, I )
            H12 = DAT2*S
            H21 = S
            H22 = H11
         ELSE
*
*           Prepare to use Francis' double shift
*           (i.e. 2nd degree generalized Rayleigh quotient)
*
            H11 = H( I-1, I-1 )
            H21 = H( I, I-1 )
            H12 = H( I-1, I )
            H22 = H( I, I )
         END IF
         S = ABS( H11 ) + ABS( H12 ) + ABS( H21 ) + ABS( H22 )
         IF( S.EQ.ZERO ) THEN
            RT1R = ZERO
            RT1I = ZERO
            RT2R = ZERO
            RT2I = ZERO
         ELSE
            H11 = H11 / S
            H21 = H21 / S
            H12 = H12 / S
            H22 = H22 / S
            TR = ( H11+H22 ) / TWO
            DET = ( H11-TR )*( H22-TR ) - H12*H21
            RTDISC = SQRT( ABS( DET ) )
            IF( DET.GE.ZERO ) THEN
*
*              ==== complex conjugate shifts ====
*
               RT1R = TR*S
               RT2R = RT1R
               RT1I = RTDISC*S
               RT2I = -RT1I
            ELSE
*
*              ==== real shifts (use only one of them)  ====
*
               RT1R = TR + RTDISC
               RT2R = TR - RTDISC
               IF( ABS( RT1R-H22 ).LE.ABS( RT2R-H22 ) ) THEN
                  RT1R = RT1R*S
                  RT2R = RT1R
               ELSE
                  RT2R = RT2R*S
                  RT1R = RT2R
               END IF
               RT1I = ZERO
               RT2I = ZERO
            END IF
         END IF
*
*        Look for two consecutive small subdiagonal elements.
*
         DO 50 M = I - 2, L, -1
*           Determine the effect of starting the double-shift QR
*           iteration at row M, and see if this would make H(M,M-1)
*           negligible.  (The following uses scaling to avoid
*           overflows and most underflows.)
*
            H21S = H( M+1, M )
            S = ABS( H( M, M )-RT2R ) + ABS( RT2I ) + ABS( H21S )
            H21S = H( M+1, M ) / S
            V( 1 ) = H21S*H( M, M+1 ) + ( H( M, M )-RT1R )*
     $               ( ( H( M, M )-RT2R ) / S ) - RT1I*( RT2I / S )
            V( 2 ) = H21S*( H( M, M )+H( M+1, M+1 )-RT1R-RT2R )
            V( 3 ) = H21S*H( M+2, M+1 )
            S = ABS( V( 1 ) ) + ABS( V( 2 ) ) + ABS( V( 3 ) )
            V( 1 ) = V( 1 ) / S
            V( 2 ) = V( 2 ) / S
            V( 3 ) = V( 3 ) / S
            IF( M.EQ.L )
     $         GO TO 60
            IF( ABS( H( M, M-1 ) )*( ABS( V( 2 ) )+ABS( V( 3 ) ) ).LE.
     $          ULP*ABS( V( 1 ) )*( ABS( H( M-1, M-1 ) )+ABS( H( M,
     $          M ) )+ABS( H( M+1, M+1 ) ) ) )GO TO 60
   50    CONTINUE
   60    CONTINUE
*
*        Double-shift QR step
*
         DO 130 K = M, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix. NR is the order of G.
*
            NR = MIN( 3, I-K+1 )
            IF( K.GT.M )
     $         CALL DCOPY( NR, H( K, K-1 ), 1, V, 1 )
            CALL DLARFG( NR, V( 1 ), V( 2 ), 1, T1 )
            IF( K.GT.M ) THEN
               H( K, K-1 ) = V( 1 )
               H( K+1, K-1 ) = ZERO
               IF( K.LT.I-1 )
     $            H( K+2, K-1 ) = ZERO
            ELSE IF( M.GT.L ) THEN
*               ==== Use the following instead of
*               .    H( K, K-1 ) = -H( K, K-1 ) to
*               .    avoid a bug when v(2) and v(3)
*               .    underflow. ====
               H( K, K-1 ) = H( K, K-1 )*( ONE-T1 )
            END IF
            V2 = V( 2 )
            T2 = T1*V2
            IF( NR.EQ.3 ) THEN
               V3 = V( 3 )
               T3 = T1*V3
*
*              Apply G from the left to transform the rows of the matrix
*              in columns K to I2.
*
               DO 70 J = K, I2
                  SUM = H( K, J ) + V2*H( K+1, J ) + V3*H( K+2, J )
                  H( K, J ) = H( K, J ) - SUM*T1
                  H( K+1, J ) = H( K+1, J ) - SUM*T2
                  H( K+2, J ) = H( K+2, J ) - SUM*T3
   70          CONTINUE
*
*              Apply G from the right to transform the columns of the
*              matrix in rows I1 to min(K+3,I).
*
               DO 80 J = I1, MIN( K+3, I )
                  SUM = H( J, K ) + V2*H( J, K+1 ) + V3*H( J, K+2 )
                  H( J, K ) = H( J, K ) - SUM*T1
                  H( J, K+1 ) = H( J, K+1 ) - SUM*T2
                  H( J, K+2 ) = H( J, K+2 ) - SUM*T3
   80          CONTINUE
*
               IF( WANTZ ) THEN
*
*                 Accumulate transformations in the matrix Z
*
                  DO 90 J = ILOZ, IHIZ
                     SUM = Z( J, K ) + V2*Z( J, K+1 ) + V3*Z( J, K+2 )
                     Z( J, K ) = Z( J, K ) - SUM*T1
                     Z( J, K+1 ) = Z( J, K+1 ) - SUM*T2
                     Z( J, K+2 ) = Z( J, K+2 ) - SUM*T3
   90             CONTINUE
               END IF
            ELSE IF( NR.EQ.2 ) THEN
*
*              Apply G from the left to transform the rows of the matrix
*              in columns K to I2.
*
               DO 100 J = K, I2
                  SUM = H( K, J ) + V2*H( K+1, J )
                  H( K, J ) = H( K, J ) - SUM*T1
                  H( K+1, J ) = H( K+1, J ) - SUM*T2
  100          CONTINUE
*
*              Apply G from the right to transform the columns of the
*              matrix in rows I1 to min(K+3,I).
*
               DO 110 J = I1, I
                  SUM = H( J, K ) + V2*H( J, K+1 )
                  H( J, K ) = H( J, K ) - SUM*T1
                  H( J, K+1 ) = H( J, K+1 ) - SUM*T2
  110          CONTINUE
*
               IF( WANTZ ) THEN
*
*                 Accumulate transformations in the matrix Z
*
                  DO 120 J = ILOZ, IHIZ
                     SUM = Z( J, K ) + V2*Z( J, K+1 )
                     Z( J, K ) = Z( J, K ) - SUM*T1
                     Z( J, K+1 ) = Z( J, K+1 ) - SUM*T2
  120             CONTINUE
               END IF
            END IF
  130    CONTINUE
*
  140 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  150 CONTINUE
*
      IF( L.EQ.I ) THEN
*
*        H(I,I-1) is negligible: one eigenvalue has converged.
*
         WR( I ) = H( I, I )
         WI( I ) = ZERO
      ELSE IF( L.EQ.I-1 ) THEN
*
*        H(I-1,I-2) is negligible: a pair of eigenvalues have converged.
*
*        Transform the 2-by-2 submatrix to standard Schur form,
*        and compute and store the eigenvalues.
*
         CALL DLANV2( H( I-1, I-1 ), H( I-1, I ), H( I, I-1 ),
     $                H( I, I ), WR( I-1 ), WI( I-1 ), WR( I ), WI( I ),
     $                CS, SN )
*
         IF( WANTT ) THEN
*
*           Apply the transformation to the rest of H.
*
            IF( I2.GT.I )
     $         CALL DROT( I2-I, H( I-1, I+1 ), LDH, H( I, I+1 ), LDH,
     $                    CS, SN )
            CALL DROT( I-I1-1, H( I1, I-1 ), 1, H( I1, I ), 1, CS, SN )
         END IF
         IF( WANTZ ) THEN
*
*           Apply the transformation to Z.
*
            CALL DROT( NZ, Z( ILOZ, I-1 ), 1, Z( ILOZ, I ), 1, CS, SN )
         END IF
      END IF
*
*     return to start of the main loop with new value of I.
*
      I = L - 1
      GO TO 20
*
  160 CONTINUE
      RETURN
*
*     End of DLAHQR
*
      END
c $Id: dlahqr.f 24343 2013-06-22 05:35:15Z d3y133 $

      logical function pre_parcnv(icomb,latt,patt,matt,natt)
c
c $Id: pre_parcom.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer icomb,matt,natt
      integer latt(2,matt)
      real*8 patt(4,2,matt,matt)
c
      integer i,j
c
c     C6,C12 -> C6,C12
c
      if(icomb.eq.1) then
      endif
c
c     epsilon,sigma  -> C6,C12
c
      if(icomb.eq.2) then
      endif
c
c     epsilon,(1/2)R* -> C6,C12
c
      if(icomb.eq.3) then
      do 1 i=1,natt
      do 2 k=1,2
      epsil=par(1,k,i,i)
      rstar=par(2,k,i,i)
      par(1,k,i,i)=2.0d0*epsil*epsil*((rstar*rstar)**6)
      par(2,k,i,i)=epsil*epsil*((rstar*rstar)**12)
    2 continue
      do 3 j=i+1,natt
      do 4 k=1,2
      epsil=par(1,k,i,j)
      rstar=par(2,k,i,j)
      par(1,k,i,i)=2.0d0*epsil*((rstar)**6)
      par(2,k,i,i)=epsil*((rstar)**12)
    4 continue
    3 continue
    1 continue
      endif
c
      pre_parcom=.true.
      return
      end

*
* $Id: ion_ion.F 21519 2011-11-12 04:32:33Z bylaska $
*


*     ********************************
*     *                              *
*     *         ion_ion_e            *
*     *                              *
*     ********************************
*
*   This function computes the (free-space) Coulomb energy between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*

      real*8 function ion_ion_e()
      implicit none
      

*     *** local variables ***
      integer i,j
      real*8 x,y,z,r,e

*     *** external functions ***
      integer  ion_nion,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion,ion_katm
      external psp_zv,ion_rion

      e = 0.0d0
      do j=1,ion_nion()
        do i=1,j-1
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)
          e = e + psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r
        end do
      end do

      ion_ion_e = e
      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_f            *
*     *                              *
*     ********************************
*
*   This routine computes the (free-space) Coulomb forces between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*
*   Exit -
*       f_ion ---- force vectors
*

      subroutine ion_ion_f(f_ion)
      implicit none
      real*8 f_ion(3,*)

*     *** local variables ***
      integer i,j
      real*8 x,y,z,r,v

*     *** external functions ***
      integer  ion_nion,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion,ion_katm
      external psp_zv,ion_rion

*     *** do nothing if only one atom ***
      if (ion_nion().eq.1) return

      do j=1,ion_nion()
        do i=1,j-1
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)

          v = psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r**3

          f_ion(1,i) = f_ion(1,i) + (x*v)
          f_ion(2,i) = f_ion(2,i) + (y*v)
          f_ion(3,i) = f_ion(3,i) + (z*v)

          f_ion(1,j) = f_ion(1,j) - (x*v)
          f_ion(2,j) = f_ion(2,j) - (y*v)
          f_ion(3,j) = f_ion(3,j) - (z*v)
        end do
      end do

      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_e_qm         *
*     *                              *
*     ********************************
*
*   This function computes the (free-space) Coulomb energy between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*

      real*8 function ion_ion_e_qm()
      implicit none
      

*     *** local variables ***
      integer i,j
      real*8 x,y,z,r,e

*     *** external functions ***
      integer  ion_nion_qm,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion_qm,ion_katm
      external psp_zv,ion_rion

      e = 0.0d0
      do j=1,ion_nion_qm()
        do i=1,j-1
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)
          e = e + psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r
        end do
      end do

      ion_ion_e_qm = e
      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_f_qm         *
*     *                              *
*     ********************************
*
*   This routine computes the (free-space) Coulomb forces between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*
*   Exit -
*       f_ion ---- force vectors
*

      subroutine ion_ion_f_qm(f_ion)
      implicit none
      real*8 f_ion(3,*)

*     *** local variables ***
      integer i,j
      real*8 x,y,z,r,v

*     *** external functions ***
      integer  ion_nion_qm,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion_qm,ion_katm
      external psp_zv,ion_rion

*     *** do nothing if only one atom ***
      if (ion_nion_qm().eq.1) return

      do j=1,ion_nion_qm()
        do i=1,j-1
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)

          v = psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r**3

          f_ion(1,i) = f_ion(1,i) + (x*v)
          f_ion(2,i) = f_ion(2,i) + (y*v)
          f_ion(3,i) = f_ion(3,i) + (z*v)

          f_ion(1,j) = f_ion(1,j) - (x*v)
          f_ion(2,j) = f_ion(2,j) - (y*v)
          f_ion(3,j) = f_ion(3,j) - (z*v)
        end do
      end do

      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_e_mm         *
*     *                              *
*     ********************************
*
*   This function computes the (free-space) Coulomb energy between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*

      real*8 function ion_ion_e_mm()
      implicit none
      

*     *** local variables ***
      integer i,j
      real*8 x,y,z,r,e

*     *** external functions ***
      integer  ion_nion,ion_nion_qm,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion,ion_nion_qm,ion_katm
      external psp_zv,ion_rion

      e = 0.0d0
      do j=ion_nion_qm()+1,ion_nion()
        do i=ion_nion_qm()+1,j-1
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)
          e = e + psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r
        end do
      end do

      ion_ion_e_mm = e
      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_f_mm         *
*     *                              *
*     ********************************
*
*   This routine computes the (free-space) Coulomb forces between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*
*   Exit -
*       f_ion ---- force vectors
*

      subroutine ion_ion_f_mm(f_ion)
      implicit none
      real*8 f_ion(3,*)

*     *** local variables ***
      integer i,j
      real*8 x,y,z,r,v

*     *** external functions ***
      integer  ion_nion,ion_nion_qm,ion_nion_mm,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion,ion_nion_qm,ion_nion_mm,ion_katm
      external psp_zv,ion_rion

*     *** do nothing if only one atom ***
      if (ion_nion_mm().eq.1) return

      do j=ion_nion_qm()+1,ion_nion()
        do i=ion_nion_qm()+1,j-1
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)

          v = psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r**3

          f_ion(1,i) = f_ion(1,i) + (x*v)
          f_ion(2,i) = f_ion(2,i) + (y*v)
          f_ion(3,i) = f_ion(3,i) + (z*v)

          f_ion(1,j) = f_ion(1,j) - (x*v)
          f_ion(2,j) = f_ion(2,j) - (y*v)
          f_ion(3,j) = f_ion(3,j) - (z*v)
        end do
      end do

      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_f_async      *
*     *                              *
*     ********************************
*
*   This routine computes the (free-space) Coulomb forces between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*
*   Exit -
*       f_ion ---- force vectors
*

      subroutine ion_ion_f_async(f_ion)
      implicit none
      real*8 f_ion(3,*)

*     *** local variables ***
      integer i,j,tnp,tid,dutask
      real*8 x,y,z,r,v

*     *** external functions ***
      integer  ion_nion,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion,ion_katm
      external psp_zv,ion_rion

*     *** do nothing if only one atom ***
      if (ion_nion().eq.1) return

      call Parallel_np(tnp)
      call Parallel_taskid(tid)

      dutask = 0
      do j=1,ion_nion()
        do i=1,j-1
         if (dutask.eq.tid) then
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)

          v = psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r**3

          f_ion(1,i) = f_ion(1,i) + (x*v)
          f_ion(2,i) = f_ion(2,i) + (y*v)
          f_ion(3,i) = f_ion(3,i) + (z*v)

          f_ion(1,j) = f_ion(1,j) - (x*v)
          f_ion(2,j) = f_ion(2,j) - (y*v)
          f_ion(3,j) = f_ion(3,j) - (z*v)
         end if
         dutask = mod((dutask+1),tnp)
        end do
      end do

      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_f_qm_async   *
*     *                              *
*     ********************************
*
*   This routine computes the (free-space) Coulomb forces between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*
*   Exit -
*       f_ion ---- force vectors
*

      subroutine ion_ion_f_qm_async(f_ion)
      implicit none
      real*8 f_ion(3,*)

*     *** local variables ***
      integer i,j,tnp,tid,dutask
      real*8 x,y,z,r,v

*     *** external functions ***
      integer  ion_nion_qm,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion_qm,ion_katm
      external psp_zv,ion_rion

*     *** do nothing if only one atom ***
      if (ion_nion_qm().eq.1) return

      call Parallel_np(tnp)
      call Parallel_taskid(tid)

      dutask=0
      do j=1,ion_nion_qm()
        do i=1,j-1
         if (dutask.eq.tid) then
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)

          v = psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r**3

          f_ion(1,i) = f_ion(1,i) + (x*v)
          f_ion(2,i) = f_ion(2,i) + (y*v)
          f_ion(3,i) = f_ion(3,i) + (z*v)

          f_ion(1,j) = f_ion(1,j) - (x*v)
          f_ion(2,j) = f_ion(2,j) - (y*v)
          f_ion(3,j) = f_ion(3,j) - (z*v)
         end if
         dutask = mod((dutask+1),tnp)
        end do
      end do

      return
      end


*     ********************************
*     *                              *
*     *         ion_ion_f_mm_async   *
*     *                              *
*     ********************************
*
*   This routine computes the (free-space) Coulomb forces between
*   ion cores.
*
*   Entry -
*       nion  ---- number of ions
*       katm  ---- element id number
*       r_ion ---- coordinates of ions
*
*   Exit -
*       f_ion ---- force vectors
*

      subroutine ion_ion_f_mm_async(f_ion)
      implicit none
      real*8 f_ion(3,*)

*     *** local variables ***
      integer i,j,tnp,tid,dutask
      real*8 x,y,z,r,v

*     *** external functions ***
      integer  ion_nion,ion_nion_qm,ion_nion_mm,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion,ion_nion_qm,ion_nion_mm,ion_katm
      external psp_zv,ion_rion

*     *** do nothing if only one atom ***
      if (ion_nion_mm().eq.1) return

      call Parallel_np(tnp)
      call Parallel_taskid(tid)

      dutask = 0
      do j=ion_nion_qm()+1,ion_nion()
        do i=ion_nion_qm()+1,j-1
         if (dutask.eq.tid) then
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)

          v = psp_zv(ion_katm(i))*psp_zv(ion_katm(j))/r**3

          f_ion(1,i) = f_ion(1,i) + (x*v)
          f_ion(2,i) = f_ion(2,i) + (y*v)
          f_ion(3,i) = f_ion(3,i) + (z*v)

          f_ion(1,j) = f_ion(1,j) - (x*v)
          f_ion(2,j) = f_ion(2,j) - (y*v)
          f_ion(3,j) = f_ion(3,j) - (z*v)
         end if
         dutask = mod((dutask+1),tnp)
        end do
      end do

      return
      end



*     ********************************
*     *                              *
*     *         ion_ion_efg          *
*     *                              *
*     ********************************
*
*   This routine computes the (free-space) electric field tensor
*   ion cores.

      subroutine ion_ion_efg(efg)
      implicit none
      real*8 efg(3,3,*)

*     *** local variables ***
      integer i,j
      real*8 x,y,z,r,v,v2

*     *** external functions ***
      integer  ion_nion,ion_katm
      real*8   psp_zv,ion_rion
      external ion_nion,ion_katm
      external psp_zv,ion_rion

*     *** do nothing if only one atom ***
      if (ion_nion().eq.1) return

      do j=1,ion_nion()
        do i=1,ion_nion()
          x = ion_rion(1,i) - ion_rion(1,j)
          y = ion_rion(2,i) - ion_rion(2,j)
          z = ion_rion(3,i) - ion_rion(3,j)
          r = dsqrt(x*x + y*y + z*z)

          v  = psp_zv(ion_katm(i))/r**3
          v2 = psp_zv(ion_katm(i))/r**5

          efg(1,1,j) = v - 3.0d0*x*x*v2
          efg(2,1,j) = -3.0d0*x*y*v2
          efg(3,1,j) = -3.0d0*x*z*v2

          efg(1,2,j) = -3.0d0*x*y*v2
          efg(2,2,j) = v - 3.0d0*y*y*v2
          efg(3,2,j) = -3.0d0*z*y*v2

          efg(1,3,j) = -3.0d0*x*z*v2
          efg(2,3,j) = -3.0d0*y*z*v2
          efg(3,3,j) = v - 3.0d0*z*z*v2
        end do
      end do

      return
      end

      subroutine argos_diana_grpdis(sgmnam,imol,isel,wt,x,igr)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*16 sgmnam(nsa)
      real*8 wt(nsa)
      integer isel(nsa),igr,imol(msa)
      real*8 x(nsa,3)
c
      integer igrp,jgrp
      integer i,j,jfrom,ito,ia,ja,number
      real*8 dist,dx,dy,dz
c
      igrp=igroups(igr,1)
      jgrp=igroups(igr,2)
c
      number=0
c
      if(ldef(igrp).lt.0) return
c
      write(lfngrp,1000) igr,igroups(igr,5)
 1000 format(2i5)
c
      ito=ldef(igrp)
      if(igrp.eq.jgrp) ito=ito-1
      do 1 i=1,ito
      ia=idef(igrp,i)
      jfrom=1
      if(igrp.eq.jgrp) jfrom=i+1
      do 2 j=jfrom,ldef(jgrp)
      ja=idef(jgrp,j)
      dx=abs(x(ia,1)-x(ja,1))
      dy=abs(x(ia,2)-x(ja,2))
      dz=abs(x(ia,3)-x(ja,3))
      if(igroups(igr,6).eq.1) then
      if(dz.gt.box(3)) dz=dz-box(3)
      elseif(igroups(igr,6).eq.2) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      elseif(igroups(igr,6).eq.3) then
      if(dx.gt.box(1)) dx=dx-box(1)
      if(dy.gt.box(2)) dy=dy-box(2)
      if(dz.gt.box(3)) dz=dz-box(3)
      endif
      dist=sqrt(dx*dx+dy*dy+dz*dz)
      if(dist.ge.rgroups(igr,1).and.dist.le.rgroups(igr,2)) then
      write(lfngrp,1001)
     + imol(ia),sgmnam(ia)(11:16),sgmnam(ia)(1:5),sgmnam(ia)(6:10),
     + imol(ja),sgmnam(ja)(11:16),sgmnam(ja)(1:5),sgmnam(ja)(6:10),dist
 1001 format(2(i5,a6,' ',a5,':',a5,' '),f12.6)
      number=number+1
      endif
    2 continue
    1 continue
c
      write(lfngrp,1002) 0
 1002 format(i5)
c
      return
      end
c $Id: argos_diana_grpdis.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdt_t3_2_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: ccsdt_t3_2_4.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p4 p5 h1 p12 )_vt + = 1 * P( 2 ) * Sum ( h9 p8 ) * t ( p4 p8 h1 h9 )_t * v ( h9 p5 p8 p12 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p4b
      INTEGER p5b
      INTEGER h1b
      INTEGER p12b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p8b
      INTEGER h9b
      INTEGER p4b_1
      INTEGER p8b_1
      INTEGER h1b_1
      INTEGER h9b_1
      INTEGER p5b_2
      INTEGER h9b_2
      INTEGER p12b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p4b = noab+1,noab+nvab
      DO p5b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO p12b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+p12b-1).ne.8)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+p12b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+p12b-1)))) .eq. ieor(irrep_v,irrep_t)) T
     &HEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+p12b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_t3_2_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p8b = noab+1,noab+nvab
      DO h9b = 1,noab
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h9b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p4b,p8b,h1b,h9b,p4b_1,p8b_1,h1b_1,h9b_1)
      CALL TCE_RESTRICTED_4(p5b,h9b,p12b,p8b,p5b_2,h9b_2,p12b_2,p8b_2)
      dim_common = int_mb(k_range+p8b-1) * int_mb(k_range+h9b-1)
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p12b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_t3_2_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_t3_2_4',2,MA_ERR)
      IF ((p8b .lt. p4b) .and. (h9b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p8b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h9b-1),int_mb(k_range+h1b-1)
     &,4,2,3,1,1.0d0)
      END IF
      IF ((p8b .lt. p4b) .and. (h1b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p8b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p8b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h9b-1)
     &,3,2,4,1,-1.0d0)
      END IF
      IF ((p4b .le. p8b) .and. (h9b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (p8b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h1b-1)
     &,4,1,3,2,-1.0d0)
      END IF
      IF ((p4b .le. p8b) .and. (h1b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p8b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+h1b-1),int_mb(k_range+h9b-1)
     &,3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_t3_2_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_t3_2_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_t3_2_4',5,MA_ERR)
      IF ((h9b .le. p5b) .and. (p8b .le. p12b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p12b_
     &2 - 1 + (noab+nvab) * (p8b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noa
     &b+nvab) * (h9b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p8b-1),int_mb(k_range+p12b-1
     &),4,2,1,3,1.0d0)
      END IF
      IF ((h9b .le. p5b) .and. (p12b .lt. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - 1 + (noab+nvab) * (p12b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noa
     &b+nvab) * (h9b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p12b-1),int_mb(k_range+p8b-1
     &),3,2,1,4,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_t3_2_4',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_t3_2_4',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_t3_2_4',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_t3_2_4',9,MA_ERR)
      IF ((p4b .le. p5b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+p4b-1
     &),4,2,3,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p12b 
     &- noab - 1 + nvab * (h1b - 1 + noab * (p5b - noab - 1 + nvab * (p4
     &b - noab - 1)))))
      END IF
      IF ((p5b .le. p4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+p4b-1
     &),2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p12b 
     &- noab - 1 + nvab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p5
     &b - noab - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_t3_2_4',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_t3_2_4',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE emb1(d_x1,k_x1_offset,d_x2,k_x2_offset,
     1                        d_t1,k_t1_offset,d_t2,k_t2_offset,
     2                        d_f1,k_f1_offset,d_v2,k_v2_offset,
     3                        d_e,k_e_offset,
     4                        d_ex1,k_ex1_offset,size_ex1,
     5                        d_ex2,k_ex2_offset,size_ex2,
     6                        d_c1,k_c1_offset,size_c1,
     7                        d_c2,k_c2_offset,size_c2,
     8                        excit,energy1,energy2,size_t1,size_x1)
C
C     $Id: emb1.F 19706 2010-10-29 17:52:31Z d3y133 $
C 
c from this point on we assume that corresponding one- and two-
c body components of R(d_x1,d_x2) and T(d_t1,d_t2) operators,
c and corresponding excitation energy are available.  
c objects c1 and c2 are created in tce_energy right before 
c calling this procedure. The same structure of x1 and c1 and
c x2 and c2 is assumed (irrep_c = irrep_x) 
c
c 
c Simplified version of bra-states, full form of moments
c
c

      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_t1
      integer k_t1_offset
      integer d_t2
      integer k_t2_offset
c *** sizes ***
      integer size_c1,size_c2
      integer size_ex1,size_ex2
      integer size_d2
c *************
      integer d_x1
      integer k_x1_offset
      integer d_x2
      integer k_x2_offset
      double precision r0xx  ! r0 
      double precision dr0xx ! r0*r0
      double precision d1xx  ! <(singles)+singles>
      double precision d2xx  ! <(doubles)+doubles>
      double precision d12xx ! <(singles+doubles)+(singles+doubles)>
      double precision d1xxt,d2xxt
      double precision d1xxr,d2xxr 
      double precision d1xxtr,d2xxtr 
      double precision excit ! eomsd excitation energy
      logical lr0            ! (true) r0*M3-calculated 
      integer d_ex1
      integer k_ex1_offset
      integer d_ex2
      integer k_ex2_offset 
      integer d_c1
      integer k_c1_offset
      integer d_c2
      integer k_c2_offset
      integer d_d2
      integer l_d2_offset
      integer k_d2_offset
c ***
      integer d_f1
      integer k_f1_offset
      integer d_v2
      integer k_v2_offset
      integer d_e
      integer k_e_offset
      integer t_h1b, t_h1
      integer t_h2b, t_h2
      integer t_h3b, t_h3
      integer t_p4b, t_p4
      integer t_p5b, t_p5
      integer t_p6b, t_p6
      integer k_den,l_den
      integer k_right1,l_right1  !r0*M3(T1,T2)
      integer k_right2,l_right2  !M3(T1,T2,X1,X2)
      integer k_right3,l_right3
c - T1/X1 LOCALIZATION -------------------
      integer l_t1_local,k_t1_local
      integer l_x1_local,k_x1_local
      integer size_t1,size_x1
c ---------------------------------------
c *** cr_ccsd_t_E ***
      integer k_den0,l_den0
c *******************
      integer size,i
      integer g_energy
      integer NXTVAL
      integer next
      integer nprocs
      integer count
c --- new intermediates ---
c  cr_ccsd_t_N1 or cr_ccsd_t_N
      integer d_i1_1,d_i1_2,d_i1_3
      integer k_i1_offset_1,k_i1_offset_2,k_i1_offset_3
      integer l_i1_offset_1,l_i1_offset_2,l_i1_offset_3
c  cr_ccsd_t_E
      integer d_i1_4,k_i1_offset_4,l_i1_offset_4
c  cr_ccsd_t_N2
      integer d_i2_1,d_i2_2,d_i2_3,d_i2_4,d_i2_5,d_i2_6
      integer k_i2_offset_1,k_i2_offset_2,k_i2_offset_3
      integer k_i2_offset_4,k_i2_offset_5,k_i2_offset_6
      integer l_i2_offset_1,l_i2_offset_2,l_i2_offset_3
      integer l_i2_offset_4,l_i2_offset_5,l_i2_offset_6
c  q3rexpt
      integer d_i3_1,d_i3_2
      integer k_i3_offset_1,k_i3_offset_2
      integer l_i3_offset_1,l_i3_offset_2
c  c2vt1_e
      integer d_ui1_1,d_ui1_2
      integer k_ui1_offset_1,k_ui1_offset_2
      integer l_ui1_offset_1,l_ui1_offset_2
c  c2f_e
      integer d_zi1_1
      integer k_zi1_offset_1
      integer l_zi1_offset_1 
c 
      double precision bdenex,bdengr
      double precision coeffx
c ----------------------------
      integer k_c2vs,k_c2ve,k_c2fs,k_c2fe
      integer l_c2vs,l_c2ve,l_c2fs,l_c2fe
      integer l_c1v,k_c1v
c ----------------------------
      double precision energy1,energy2
      double precision factor
      double precision den1,num1
      double precision den2,num2
      character*255 filename
      external NXTVAL
c *** debug ***
      double precision xxx
c *************
c
c Getting R0
      call  nr0(d_f1,d_e,d_t1,d_v2,d_x1,d_x2,k_f1_offset,
     &k_e_offset,k_t1_offset,k_v2_offset,k_x1_offset,k_x2_offset) 
      call reconcilefile(d_e,1)
      call get_block(d_e,r0xx,1,0)
      if(dabs(excit).gt.1.0d-7) then
         r0xx = r0xx/excit
      else
         write(6,1000)
      end if
      dr0xx = r0xx*r0xx
      lr0 = .true.
      if(dabs(r0xx).lt.1.0d-7) lr0 = .false.
c 
c Now on ga with handle d_e we store corresponding R0 value 
c
c
c
c Calculating one- and two-body overlaps
c
      if(lr0) then !symmetry of the reference
         call tce_zero(d_ex1,size_ex1)
         call tce_zero(d_ex2,size_ex2)
         call c1_c1(d_t1,d_ex1,k_t1_offset,k_ex1_offset) 
         call reconcilefile(d_ex1,1)
         d1xxt = 0.0d0 
         call get_block(d_ex1,d1xxt,1,0)
         call t2t12(d_c2,d_t1,d_t2,k_c2_offset,k_t1_offset,k_t2_offset)
         call c2_c2(d_c2,d_ex2,k_c2_offset,k_ex2_offset)
         call reconcilefile(d_ex2,1)
         d2xxt = 0.0d0
         call get_block(d_ex2,d2xxt,1,0)
c forming vector R1T1+R2, d_d2's irrep corresponds to irrep_x
c (in this case this is fully symmetric situation)
c on d_c2 we have (T2+1/2T1*T1)|Phi\rangle
            irrep_d=irrep_c
            call tce_zero(d_ex1,size_ex1)
            call tce_x2_offset(l_d2_offset,k_d2_offset,size_d2)
            call tce_filename('d2',filename)
            call createfile(filename,d_d2,size_d2)
            call tce_zero(d_d2,size_d2)
         call c2excit2(d_d2,d_t1,d_x1,d_x2,k_d2_offset,k_t1_offset,k_
     &   x1_offset,k_x2_offset)
c <C2+ D2>  here
      call c2_d2(d_c2,d_d2,d_ex1,k_c2_offset,k_d2_offset,k_ex1_offset)
         call reconcilefile(d_ex1,1)
         d2xxtr = 0.0d0
         call get_block(d_ex1,d2xxtr,1,0)
            call deletefile(d_d2)
            if (.not.ma_pop_stack(l_d2_offset))
     1        call errquit("tce_energy: MA problem",36,MA_ERR)
ccxxxx       call c2excit(d_c2,d_t1,d_t2,d_e,d_x1,d_x2,k_c2_offset,
ccxxxx     & k_t1_offset,k_t2_offset,k_e_offset,k_x1_offset,k_x2_offset)
ccxxxx       call c2_c2(d_c2,d_ex2,k_c2_offset,k_ex2_offset)
ccxxxx       call reconcilefile(d_ex2,1)
ccxxxx       d2xx = 0.0d0
ccxxxx       call get_block(d_ex2,d2xx,1,0)
c
         call tce_zero(d_ex1,size_ex1)
         call tce_zero(d_ex2,size_ex2)
         call x1_t1(d_ex1,d_t1,d_x1,k_ex1_offset,k_t1_offset,
     &   k_x1_offset)
         call reconcilefile(d_ex1,1)
         d1xxtr=0.0d0
         call get_block(d_ex1,d1xxtr,1,0)
c
         call tce_zero(d_ex1,size_ex1)
         call tce_zero(d_ex2,size_ex2)
         call tce_zero(d_c1,size_c1)
         call tce_zero(d_c2,size_c2)
         call c1excit2(d_c1,d_x1,k_c1_offset,k_x1_offset)
         call c2excit2(d_c2,d_t1,d_x1,d_x2,k_c2_offset,k_t1_offset,k_
     &   x1_offset,k_x2_offset)
         call c1_c1(d_c1,d_ex1,k_c1_offset,k_ex1_offset)
         call reconcilefile(d_ex1,1)
         d1xxr = 0.0d0 
         call get_block(d_ex1,d1xxr,1,0)
         call c2_c2(d_c2,d_ex2,k_c2_offset,k_ex2_offset)
         call reconcilefile(d_ex2,1)
         d2xxr = 0.0d0
         call get_block(d_ex2,d2xxr,1,0)
         d12xx = d1xxt*r0xx*r0xx+d2xxt*r0xx*r0xx+d1xxr+d2xxr+
     &           2.0d0*d1xxtr*r0xx+2.0d0*d2xxtr*r0xx

      else         !symmetry different form the symmetry of the reference
c        <(R1+R0*T1)^{\dagger} (R1+R0*T1)>
         call c1excit2(d_c1,d_x1,k_c1_offset,k_x1_offset)
         call c2excit2(d_c2,d_t1,d_x1,d_x2,k_c2_offset,k_t1_offset,k_
     &   x1_offset,k_x2_offset)
         call c1_c1(d_c1,d_ex1,k_c1_offset,k_ex1_offset)
         call reconcilefile(d_ex1,1)
         d1xx = 0.0d0 
         call get_block(d_ex1,d1xx,1,0)
c        <(R2+R1T1)^{\dagger} (R2+R1T1)>
         call c2_c2(d_c2,d_ex2,k_c2_offset,k_ex2_offset)
         call reconcilefile(d_ex2,1)
         d2xx = 0.0d0
         call get_block(d_ex2,d2xx,1,0)
         d12xx = d1xx+d2xx
      end if
c
c
c ---- initializing c1 and c2
c   
      if(lr0) then
         coeffx = 1.0d0
         call tce_zero(d_c1,size_c1)
         call tce_zero(d_c2,size_c2)
         call copyfile(d_t1,d_c1,size_c1)
         call dscalfile(r0xx,d_c1,size_c1)
         call daxpyfile(1,coeffx,d_x1,d_c1,size_c1)
         call t2t12(d_c2,d_t1,d_t2,k_c2_offset,k_t1_offset,k_t2_offset)
         call dscalfile(r0xx,d_c2,size_c2)
         call c2excit2(d_c2,d_t1,d_x1,d_x2,k_c2_offset,k_t1_offset,k_
     &   x1_offset,k_x2_offset)
      else
         call tce_zero(d_c1,size_c1)
         call tce_zero(d_c2,size_c2)
         call copyfile(d_x1,d_c1,size_c1)
         call c2excit2(d_c2,d_t1,d_x1,d_x2,k_c2_offset,k_t1_offset,k_
     &   x1_offset,k_x2_offset)
      end if
c - T1/X1 LOCALIZATION ----------
c    opening l_t1_local and l_x1_local
        if (.not.MA_PUSH_GET(mt_dbl,size_t1,'t1_local',
     1      l_t1_local,k_t1_local))
     1      call errquit('t1_local',1,MA_ERR)
        if (.not.MA_PUSH_GET(mt_dbl,size_x1,'x1_local',
     1      l_x1_local,k_x1_local))
     1      call errquit('x1_local',1,MA_ERR)
        call ma_zero(dbl_mb(k_t1_local),size_t1)
        call ma_zero(dbl_mb(k_x1_local),size_x1)
c    copy d_t1 ==> l_t1_local
c    copy x1(ivec) ==> l_x1_local
cc        call ga_get(d_t1,1,size_t1,1,1,dbl_mb(k_t1_local),1)
cc        call ga_get(d_x1,1,size_x1,1,1,dbl_mb(k_x1_local),1)
       call get_block(d_t1,dbl_mb(k_t1_local),size_t1,0)
       call get_block(d_x1,dbl_mb(k_x1_local),size_x1,0)
c -------------------------------
c
c
c     Caution! k_right & k_den are not even allocated yet
c     but they won't be used.
c --------------- initialization -----------------------------------
      if(lr0) then
      call cr_ccsd_t_N(dbl_mb(k_right1),d_f1,d_i1_1,d_i1_2,
     1  k_t1_local,d_t2,d_v2,k_f1_offset,k_i1_offset_1,k_i1_offset_2,
     2  k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3  l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
      end if
c
c      call cr_eomccsd_t_N2(dbl_mb(k_right2),d_f1,d_i2_1,d_i2_2,d_i2_3,
c     &d_i2_4,d_i2_5,d_i2_6,d_t1,d_t2,d_v2,d_x1,d_x2,k_f1_offset,
c     &k_i2_offset_1,k_i2_offset_2,k_i2_offset_3,k_i2_offset_4,
c     &k_i2_offset_5,k_i2_offset_6,k_t1_offset,k_t2_offset,k_v2_offset,
c     &k_x1_offset,k_x2_offset,l_i2_offset_1,l_i2_offset_2,l_i2_offset_3,
c     &l_i2_offset_4,l_i2_offset_5,l_i2_offset_6,t_h1b,t_h2b,t_h3b,t_p4b,
c     &t_p5b,t_p6b,1)
      call creomsd_t_n2_mem(dbl_mb(k_right2),d_f1,d_i2_1,d_i2_2,
     &d_i2_3,d_i2_4,k_t1_local,d_t2,d_v2,k_x1_local,
     &d_x2,k_f1_offset,k_i2_offset_1,
     &k_i2_offset_2,k_i2_offset_3,k_i2_offset_4,k_t1_offset,k_t2_offset,
     &k_v2_offset,k_x1_offset,k_x2_offset,l_i2_offset_1,l_i2_offset_2,
     &l_i2_offset_3,l_i2_offset_4,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
c
      if(lr0) then !--
      call cr_ccsd_t_E(dbl_mb(k_den0),d_i1_4,
     1  k_t1_local,d_t2,k_i1_offset_4,k_t1_offset,k_t2_offset,
     2  l_i1_offset_4,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
      call q3rexpt2(dbl_mb(k_den),d_i3_1,k_t1_local,d_t2,
     &k_x1_local,d_x2,
     &k_i3_offset_1,k_t1_offset,k_t2_offset,k_x1_offset,k_x2_offset,
     &l_i3_offset_1,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
      else !--
      call q3rexpt2(dbl_mb(k_den),d_i3_1,k_t1_local,d_t2,
     &k_x1_local,d_x2,
     &k_i3_offset_1,k_t1_offset,k_t2_offset,k_x1_offset,k_x2_offset,
     &l_i3_offset_1,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
      end if !--
c
      call c2vt1_s(dbl_mb(k_c2vs),d_v2,d_c2,k_v2_offset,k_c2_offset,
     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
c
ccc      call c2vt1_e(dbl_mb(k_c2ve),d_ui1_1,d_ui1_2,d_t1,d_v2,d_c2,
ccc     &k_ui1_offset_1,k_ui1_offset_2,k_t1_offset,k_v2_offset,k_c2_offset,
ccc     &l_ui1_offset_1,l_ui1_offset_2,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,
ccc     &1)
c
ccc      call c2f_s(dbl_mb(k_c2fs),d_f1,d_c2,k_f1_offset,k_c2_offset,
ccc     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
c
ccc      call c2f_e(dbl_mb(k_c2fe),d_zi1_1,d_t1,d_v2,d_c2,k_zi1_offset_1,
ccc     &k_t1_offset,k_v2_offset,k_c2_offset,l_zi1_offset_1,
ccc     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
c
      call c1v(dbl_mb(k_c1v),d_v2,d_c1,k_v2_offset,k_c1_offset,
     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
c 
c ------------------------------------------------------------------
c k_c2vs,k_c2ve,k_c2fs,k_c2fe
c
c     Get the numerator
c
      num1 = 0.0d0
      den1 = 0.0d0
c
      num2 = 0.0d0
      den2 = 0.0d0
c
      if (.not.ga_create(mt_dbl,1,1,'perturbative',1,1,g_energy))
     1  call errquit('ccsd_t: GA problem',0,GA_ERR)
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      do t_p4b = noab+1,noab+nvab
       do t_p5b = t_p4b,noab+nvab
        do t_p6b = t_p5b,noab+nvab
         do t_h1b = 1,noab
          do t_h2b = t_h1b,noab
           do t_h3b = t_h2b,noab
            if (next.eq.count) then
            if (int_mb(k_spin+t_p4b-1)
     1         +int_mb(k_spin+t_p5b-1)
     2         +int_mb(k_spin+t_p6b-1)
     3      .eq.int_mb(k_spin+t_h1b-1)
     4         +int_mb(k_spin+t_h2b-1)
     5         +int_mb(k_spin+t_h3b-1)) then
            if ((.not.restricted).or.
     1         (int_mb(k_spin+t_p4b-1)
     1         +int_mb(k_spin+t_p5b-1)
     2         +int_mb(k_spin+t_p6b-1)
     3         +int_mb(k_spin+t_h1b-1)
     4         +int_mb(k_spin+t_h2b-1)
     5         +int_mb(k_spin+t_h3b-1).le.8)) then
            if (ieor(int_mb(k_sym+t_p4b-1),
     1          ieor(int_mb(k_sym+t_p5b-1),
     2          ieor(int_mb(k_sym+t_p6b-1),
     3          ieor(int_mb(k_sym+t_h1b-1),
     4          ieor(int_mb(k_sym+t_h2b-1),
     5               int_mb(k_sym+t_h3b-1)))))).eq.irrep_x) then
c
c Symmetry control (above)
c 
            size = int_mb(k_range+t_p4b-1)
     1           * int_mb(k_range+t_p5b-1)
     2           * int_mb(k_range+t_p6b-1)
     3           * int_mb(k_range+t_h1b-1)
     4           * int_mb(k_range+t_h2b-1)
     5           * int_mb(k_range+t_h3b-1)
          if(lr0) then 
            if (.not.MA_PUSH_GET(mt_dbl,size,'moment 1,3',
     1        l_right1,k_right1)) call errquit('eomccsd_t',3,MA_ERR)
            if (.not.MA_PUSH_GET(mt_dbl,size,'t1t2_t13',
     1        l_den0,k_den0)) call errquit('eomccsd_t',3,MA_ERR)
          end if
            if (.not.MA_PUSH_GET(mt_dbl,size,'moment 2,3',
     1        l_right2,k_right2)) call errquit('eomccsd_t',3,MA_ERR)
            if (.not.MA_PUSH_GET(mt_dbl,size,'denominator',
     1        l_den,k_den)) call errquit('ccsd_t',3,MA_ERR)
c
            if (.not.MA_PUSH_GET(mt_dbl,size,'c2vs',
     1        l_c2vs,k_c2vs)) call errquit('c2vs',3,MA_ERR)
ccc            if (.not.MA_PUSH_GET(mt_dbl,size,'c2ve',
ccc     1        l_c2ve,k_c2ve)) call errquit('c2ve',3,MA_ERR)
ccc            if (.not.MA_PUSH_GET(mt_dbl,size,'c2fs',
ccc     1        l_c2fs,k_c2fs)) call errquit('c2fs',3,MA_ERR)
ccc            if (.not.MA_PUSH_GET(mt_dbl,size,'c2fe',
ccc     1        l_c2fe,k_c2fe)) call errquit('c2fe',3,MA_ERR)
            if (.not.MA_PUSH_GET(mt_dbl,size,'c1v',
     1        l_c1v,k_c1v)) call errquit('c2fe',3,MA_ERR)
c
          if(lr0) then
            do i = 1, size
             dbl_mb(k_right1+i-1) = 0.0d0
             dbl_mb(k_den0+i-1) = 0.0d0
            enddo
          end if
            do i = 1, size
cccx             dbl_mb(k_right3+i-1) = 0.0d0
             dbl_mb(k_right2+i-1) = 0.0d0
             dbl_mb(k_den+i-1) = 0.0d0
             dbl_mb(k_c2vs+i-1) = 0.0d0
ccc             dbl_mb(k_c2ve+i-1) = 0.0d0
ccc             dbl_mb(k_c2fs+i-1) = 0.0d0
ccc             dbl_mb(k_c2fe+i-1) = 0.0d0 
             dbl_mb(k_c1v+i-1) = 0.0d0
            enddo
c
c Moments are calculated here
c 
c
      if(lr0) then   
      call cr_ccsd_t_N(dbl_mb(k_right1),d_f1,d_i1_1,d_i1_2,
     1  k_t1_local,d_t2,d_v2,k_f1_offset,k_i1_offset_1,k_i1_offset_2,
     2  k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3  l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
      end if
c
c      call cr_eomccsd_t_N2(dbl_mb(k_right2),d_f1,d_i2_1,d_i2_2,d_i2_3,
c     &d_i2_4,d_i2_5,d_i2_6,d_t1,d_t2,d_v2,d_x1,d_x2,k_f1_offset,
c     &k_i2_offset_1,k_i2_offset_2,k_i2_offset_3,k_i2_offset_4,
c     &k_i2_offset_5,k_i2_offset_6,k_t1_offset,k_t2_offset,k_v2_offset,
c     &k_x1_offset,k_x2_offset,l_i2_offset_1,l_i2_offset_2,l_i2_offset_3,
c     &l_i2_offset_4,l_i2_offset_5,l_i2_offset_6,t_h1b,t_h2b,t_h3b,t_p4b,
c     &t_p5b,t_p6b,2)
      call creomsd_t_n2_mem(dbl_mb(k_right2),d_f1,d_i2_1,d_i2_2,
     &d_i2_3,d_i2_4,k_t1_local,d_t2,d_v2,
     &k_x1_local,d_x2,k_f1_offset,k_i2_offset_1,
     &k_i2_offset_2,k_i2_offset_3,k_i2_offset_4,k_t1_offset,k_t2_offset,
     &k_v2_offset,k_x1_offset,k_x2_offset,l_i2_offset_1,l_i2_offset_2,
     &l_i2_offset_3,l_i2_offset_4,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
c
      call c2vt1_s(dbl_mb(k_c2vs),d_v2,d_c2,k_v2_offset,k_c2_offset,
     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
c
ccc      call c2vt1_e(dbl_mb(k_c2ve),d_ui1_1,d_ui1_2,d_t1,d_v2,d_c2,
ccc     &k_ui1_offset_1,k_ui1_offset_2,k_t1_offset,k_v2_offset,k_c2_offset,
ccc     &l_ui1_offset_1,l_ui1_offset_2,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,
ccc     &2)
c
ccc      call c2f_s(dbl_mb(k_c2fs),d_f1,d_c2,k_f1_offset,k_c2_offset,
ccc     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
c
ccc      call c2f_e(dbl_mb(k_c2fe),d_zi1_1,d_t1,d_v2,d_c2,k_zi1_offset_1,
ccc     &k_t1_offset,k_v2_offset,k_c2_offset,l_zi1_offset_1,
ccc     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
c
      call c1v(dbl_mb(k_c1v),d_v2,d_c1,k_v2_offset,k_c1_offset,
     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
c
c
c
c Q3(R0+R1+R2)exp(T1+T2)|Ref> calculated here
c
      if(lr0) then
      call cr_ccsd_t_E(dbl_mb(k_den0),d_i1_4,
     1  k_t1_local,d_t2,k_i1_offset_4,k_t1_offset,k_t2_offset,
     2  l_i1_offset_4,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
      call q3rexpt2(dbl_mb(k_den),d_i3_1,k_t1_local,
     &d_t2,k_x1_local,d_x2,
     &k_i3_offset_1,k_t1_offset,k_t2_offset,k_x1_offset,k_x2_offset,
     &l_i3_offset_1,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
      else
      call q3rexpt2(dbl_mb(k_den),d_i3_1,k_t1_local,d_t2,
     &k_x1_local,d_x2,
     &k_i3_offset_1,k_t1_offset,k_t2_offset,k_x1_offset,k_x2_offset,
     &l_i3_offset_1,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
      end if
c
            if (restricted) then
              factor = 2.0d0
            else
              factor = 1.0d0
            endif
            if ((t_p4b.eq.t_p5b).and.(t_p5b.eq.t_p6b)) then
              factor = factor / 6.0d0
            else if ((t_p4b.eq.t_p5b).or.(t_p5b.eq.t_p6b)) then
              factor = factor / 2.0d0
            endif
            if ((t_h1b.eq.t_h2b).and.(t_h2b.eq.t_h3b)) then
              factor = factor / 6.0d0
            else if ((t_h1b.eq.t_h2b).or.(t_h2b.eq.t_h3b)) then
              factor = factor / 2.0d0
            endif
c
c
c
      if(lr0) then  !excited-state symm. = symm. of ref.
            i = 0
            do t_p4 = 1, int_mb(k_range+t_p4b-1)
             do t_p5 = 1, int_mb(k_range+t_p5b-1)
              do t_p6 = 1, int_mb(k_range+t_p6b-1)
               do t_h1 = 1, int_mb(k_range+t_h1b-1)
                do t_h2 = 1, int_mb(k_range+t_h2b-1)
                 do t_h3 = 1, int_mb(k_range+t_h3b-1)
                  i = i + 1
          bdenex=(-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p4b-1)+t_p4-1)
     4         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     5         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     6         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     7         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     8         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1)
     9         +excit)
          bdengr=(-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p4b-1)+t_p4-1)
     4         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     5         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     6         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     7         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     8         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1))
c <(C2V1-bar + C1V2-bar){\dagger}*R3>
c                  num1 = num1 + factor * 
c     1            (r0xx*dbl_mb(k_right1+i-1)+dbl_mb(k_right2+i-1))*
c     2            (dbl_mb(k_c2vs+i-1)+dbl_mb(k_c2ve+i-1)+
c     2             dbl_mb(k_c2fs+i-1)+dbl_mb(k_c2fe+i-1)+
c     2             dbl_mb(k_c1v+i-1))
c     3      / bdenex
                  num1 = num1 + factor *
     1            (r0xx*dbl_mb(k_right1+i-1)+dbl_mb(k_right2+i-1))*
     2            (dbl_mb(k_c2vs+i-1)+dbl_mb(k_c1v+i-1))
     3      / bdenex
c Multiplied by 2
                  den1 = den1 + factor * 2.0 *
     1            (r0xx*dbl_mb(k_den0+i-1)+dbl_mb(k_den+i-1))*
     2            (r0xx*dbl_mb(k_right1+i-1)+dbl_mb(k_right2+i-1))
     3      / bdenex
c ----
                  den1 = den1 + factor * 
     1             (r0xx*dbl_mb(k_den0+i-1)+dbl_mb(k_den+i-1))*
     2             (r0xx*dbl_mb(k_den0+i-1)+dbl_mb(k_den+i-1))
c ---- Multiplied by 2
                  den1 = den1 + factor * 2.0 *
     1            (r0xx*dbl_mb(k_den0+i-1)+dbl_mb(k_den+i-1))*
     2            (r0xx*dbl_mb(k_right1+i-1))
     3      / bdengr
c ----
                  den1 = den1 + factor * 
     1            (r0xx*dbl_mb(k_right1+i-1)*
     2             r0xx*dbl_mb(k_right1+i-1))
     3      / (bdengr*bdengr)
c ----
                  den1 = den1 + factor *
     2            (r0xx*dbl_mb(k_right1+i-1)+dbl_mb(k_right2+i-1))*
     2            (r0xx*dbl_mb(k_right1+i-1)+dbl_mb(k_right2+i-1))
     3      / (bdenex*bdenex)
c ----
                  den1 = den1 + factor * 2.0 *
     2            (r0xx*dbl_mb(k_right1+i-1)+dbl_mb(k_right2+i-1))*
     3            (r0xx*dbl_mb(k_right1+i-1))
     4      / (bdenex*bdengr)
c
c
                 enddo
                enddo
               enddo
              enddo
             enddo
            enddo 
      else       !excited-state symm. different from the symm. of ref.
            i = 0
            do t_p4 = 1, int_mb(k_range+t_p4b-1)
             do t_p5 = 1, int_mb(k_range+t_p5b-1)
              do t_p6 = 1, int_mb(k_range+t_p6b-1)
               do t_h1 = 1, int_mb(k_range+t_h1b-1)
                do t_h2 = 1, int_mb(k_range+t_h2b-1)
                 do t_h3 = 1, int_mb(k_range+t_h3b-1)
                  i = i + 1
          bdenex=(-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p4b-1)+t_p4-1)
     4         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     5         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     6         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     7         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     8         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1)
     9         +excit)
          bdengr=(-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p4b-1)+t_p4-1)
     4         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     5         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     6         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     7         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     8         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1))
c---
ccc                  num1 = num1 + factor * 
ccc     1            dbl_mb(k_right2+i-1)*
ccc     2            (dbl_mb(k_c2vs+i-1)+dbl_mb(k_c2ve+i-1)+
ccc     2             dbl_mb(k_c2fs+i-1)+dbl_mb(k_c2fe+i-1)+
ccc     2             dbl_mb(k_c1v+i-1))
ccc     2      / bdenex 
                  num1 = num1 + factor *
     1            dbl_mb(k_right2+i-1)*
     2            (dbl_mb(k_c2vs+i-1)+dbl_mb(k_c1v+i-1))
     2      / bdenex
c
c ----
                  den1 = den1 + factor * 2.0d0 *
     1            dbl_mb(k_den+i-1)*dbl_mb(k_right2+i-1)
     2      / bdenex 
c ----
                  den1 = den1 + factor * dbl_mb(k_den+i-1)*
     1                          dbl_mb(k_den+i-1)
c ----
                  den1 = den1 + factor * dbl_mb(k_right2+i-1) *
     1                   dbl_mb(k_right2+i-1)/(bdenex*bdenex) 
c
c
                 enddo
                enddo
               enddo
              enddo
             enddo
            enddo 
      end if
c
c
c
            if (.not.MA_POP_STACK(l_c1v))
     1        call errquit('c1v',6,MA_ERR)
ccc            if (.not.MA_POP_STACK(l_c2fe))
ccc     1        call errquit('c2fe',6,MA_ERR)
ccc            if (.not.MA_POP_STACK(l_c2fs))
ccc     1        call errquit('c2fs',6,MA_ERR)
ccc            if (.not.MA_POP_STACK(l_c2ve))
ccc     1        call errquit('c2ve',6,MA_ERR)
            if (.not.MA_POP_STACK(l_c2vs))
     1        call errquit('c2vs',6,MA_ERR)
c
            if (.not.MA_POP_STACK(l_den)) 
     1        call errquit('eomccsd_t',6,MA_ERR)
            if (.not.MA_POP_STACK(l_right2)) 
     1        call errquit('eomccsd_t',6,MA_ERR)
          if(lr0) then
            if (.not.MA_POP_STACK(l_den0)) 
     1        call errquit('eomccsd_t',6,MA_ERR)
            if (.not.MA_POP_STACK(l_right1)) 
     1        call errquit('eomccsd_t',6,MA_ERR)
          end if
            endif
            endif
            endif
            next = NXTVAL(nprocs)
            endif
            count = count + 1
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      next = NXTVAL(-nprocs)
c --- toggle = 3 ---
c
      call c1v(dbl_mb(k_c1v),d_v2,d_c1,k_v2_offset,k_c1_offset,
     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
c
ccc      call c2f_e(dbl_mb(k_c2fe),d_zi1_1,d_t1,d_v2,d_c2,k_zi1_offset_1,
ccc     &k_t1_offset,k_v2_offset,k_c2_offset,l_zi1_offset_1,
ccc     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
c
ccc      call c2f_s(dbl_mb(k_c2fs),d_f1,d_c2,k_f1_offset,k_c2_offset,
ccc     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
c
ccc      call c2vt1_e(dbl_mb(k_c2ve),d_ui1_1,d_ui1_2,d_t1,d_v2,d_c2,
ccc     &k_ui1_offset_1,k_ui1_offset_2,k_t1_offset,k_v2_offset,k_c2_offset,
ccc     &l_ui1_offset_1,l_ui1_offset_2,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,
ccc     &3)
c
      call c2vt1_s(dbl_mb(k_c2vs),d_v2,d_c2,k_v2_offset,k_c2_offset,
     &t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
c
      if(lr0) then
      call q3rexpt2(dbl_mb(k_den),d_i3_1,k_t1_local,d_t2,
     &k_x1_local,d_x2,
     &k_i3_offset_1,k_t1_offset,k_t2_offset,k_x1_offset,k_x2_offset,
     &l_i3_offset_1,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
      call cr_ccsd_t_E(dbl_mb(k_den0),d_i1_4,
     1  k_t1_local,d_t2,k_i1_offset_4,k_t1_offset,k_t2_offset,
     2  l_i1_offset_4,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
      else
      call q3rexpt2(dbl_mb(k_den),d_i3_1,k_t1_local,d_t2,
     &k_x1_local,d_x2,
     &k_i3_offset_1,k_t1_offset,k_t2_offset,k_x1_offset,k_x2_offset,
     &l_i3_offset_1,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
      end if
c
c      call cr_eomccsd_t_N2(dbl_mb(k_right2),d_f1,d_i2_1,d_i2_2,d_i2_3,
c     &d_i2_4,d_i2_5,d_i2_6,d_t1,d_t2,d_v2,d_x1,d_x2,k_f1_offset,
c     &k_i2_offset_1,k_i2_offset_2,k_i2_offset_3,k_i2_offset_4,
c     &k_i2_offset_5,k_i2_offset_6,k_t1_offset,k_t2_offset,k_v2_offset,
c     &k_x1_offset,k_x2_offset,l_i2_offset_1,l_i2_offset_2,l_i2_offset_3,
c     &l_i2_offset_4,l_i2_offset_5,l_i2_offset_6,t_h1b,t_h2b,t_h3b,t_p4b,
c     &t_p5b,t_p6b,3)
      call creomsd_t_n2_mem(dbl_mb(k_right2),d_f1,d_i2_1,d_i2_2,
     &d_i2_3,d_i2_4,k_t1_local,d_t2,d_v2,
     &k_x1_local,d_x2,k_f1_offset,k_i2_offset_1,
     &k_i2_offset_2,k_i2_offset_3,k_i2_offset_4,k_t1_offset,k_t2_offset,
     &k_v2_offset,k_x1_offset,k_x2_offset,l_i2_offset_1,l_i2_offset_2,
     &l_i2_offset_3,l_i2_offset_4,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
c
      if(lr0) then
      call cr_ccsd_t_N(dbl_mb(k_right1),d_f1,d_i1_1,d_i1_2,
     1  k_t1_local,d_t2,d_v2,k_f1_offset,k_i1_offset_1,k_i1_offset_2,
     2  k_t1_offset,k_t2_offset,k_v2_offset,l_i1_offset_1,
     3  l_i1_offset_2,t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,3)
      end if
c ------------------
c
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,num1,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,num1,1)
c
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,den1,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,den1,1)
c
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,num2,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,num2,1)
c
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,den2,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,den2,1)
c
cccx      call ga_get(g_energy,1,1,1,1,den2,1)
      if (.not.ga_destroy(g_energy))
     1  call errquit('ccsd_t: GA problem',1,GA_ERR)
c      den1 = den1 + 
c      den2 = den2 +
       energy1 = num1/(dr0xx+d12xx+den1)
cccx       energy2 = num2/(dr0xx+d12xx+den2)
c *** debug *********************************
c       write(6,*)'## from cr-eom ----- num2',num2
c       write(6,*)'## from cr-eom ----- den2',dr0xx+d12xx+den2
c      write(6,*)'from cr_eomsd_t - ALL DONE'
c      write(6,*)'dr0xx',dr0xx
c      write(6,*)'d12xx',d12xx
c      write(6,*)'den1',den1
c      write(6,*)'num1--- ',num1
c      write(6,*)'den1--- ',den1
c      write(6,*)'den --- ',dr0xx+d12xx+den1
c      call util_flush(6)
c *******************************************
c format statements
c - T1/X1 LOCALIZATION ------
         if(.not.MA_POP_STACK(l_x1_local))
     &      call errquit('l_x1_local',4,MA_ERR)
         if(.not.MA_POP_STACK(l_t1_local))
     &      call errquit('l_t1_local',4,MA_ERR)
c ---------------------------
 1000    format('corresponding excitation energy = 0')
c
      return
      end
c

*
* $Id: HGH_nonlocal.F 19707 2010-10-29 17:59:36Z d3y133 $
*


      subroutine HGH_nonlocal(n,l,
     >                        r,
     >                        nfft1,nfft2,nfft3,
     >                        G,
     >                        vnl)
      implicit none
      integer          n,l
      double precision r

      integer nfft1,nfft2,nfft3
      double precision G(nfft1/2+1,nfft2,nfft3,3)
      double precision vnl(nfft1/2+1,nfft2,nfft3)

      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      integer task_count,nfft3d
      integer k1,k2,k3
      double precision pi,twopi,forpi
      double precision P0,coef
      double precision r2,r3,r4,r5,r6,r7,r8,r9
      double precision g1,g2,g3,g4,a,poly


      call Parallel_np(np)
      call Parallel_taskid(taskid)

      nfft3d = (nfft1/2+1)*nfft2*nfft3
      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      P0 = pi**(1.25d0)

      r2 = r*r
      r3 = r2*r
      r4 = r3*r
      r5 = r4*r
      r6 = r5*r
      r7 = r6*r
      r8 = r7*r
      r9 = r8*r

      coef = 0.0d0
      if ((l.eq.0).and.(n.eq.1)) coef=4.0d0*dsqrt(2.0d0*r3)*P0
      if ((l.eq.0).and.(n.eq.2)) coef=8.0d0*dsqrt(2.0d0*r3/15.0d0)*P0
      if ((l.eq.0).and.(n.eq.3)) 
     >   coef=(16.0d0/3.0d0)*dsqrt(2.0d0*r3/105.0d0)*P0

      if ((l.eq.1).and.(n.eq.1)) coef=8.0d0*dsqrt(r5/3.0d0)*P0
      if ((l.eq.1).and.(n.eq.2)) coef=16.0d0*dsqrt(r5/105.0d0)*P0
      if ((l.eq.1).and.(n.eq.3)) 
     >   coef=(32.0d0/3.0d0)*dsqrt(r5/1155.0d0)*P0

      if ((l.eq.2).and.(n.eq.1)) coef=8.0d0*dsqrt(2*r7/15.0d0)*P0
      if ((l.eq.2).and.(n.eq.2)) 
     >    coef=(16.0d0/3.0d0)*dsqrt(2*r7/105.0d0)*P0

      if ((l.eq.3).and.(n.eq.1)) coef=16.0d0*dsqrt(r9/105.0d0)*P0


*======================  Fourier transformation  ======================
      poly = 0.0d0
      call dcopy(nfft3d,0.0d0,0,vnl,1)
      task_count = -1
      DO 700 k3=1,nfft3
      DO 700 k2=1,nfft2
      DO 700 k1=1,(nfft1/2+1)
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        g2=(G(k1,k2,k3,1)**2
     >     +G(k1,k2,k3,2)**2
     >     +G(k1,k2,k3,3)**2)
        g1= dsqrt(g2)
        g3 = g2*g1
        g4 = g2*g2


        a = dexp(-0.5d0*g2*r2)

*       **** f-wave  ****
        if ((l.eq.3).and.(n.eq.1)) poly = g3
    

*       **** d-wave ****
        if ((l.eq.2).and.(n.eq.1)) poly = g2
        if ((l.eq.2).and.(n.eq.2)) poly = g2*(7.0d0-g2*r2)
        

*       **** p-wave ****
        if ((l.eq.1).and.(n.eq.1)) poly = g1
        if ((l.eq.1).and.(n.eq.2)) poly = g1*(5.0d0-g2*r2)
        if ((l.eq.1).and.(n.eq.3)) poly = g1*(35.0d0-14.0d0*g2*r2+g4*r4)


*       **** s-wave ****
        if ((l.eq.0).and.(n.eq.1)) poly = 1.0d0
        if ((l.eq.0).and.(n.eq.2)) poly = (3.0d0-g2*r2)
        if ((l.eq.0).and.(n.eq.3)) poly = (15.0d0-10.0d0*g2*r2+g4*r4)
        

        vnl(k1,k2,k3)=coef*a*poly

  700 CONTINUE
      call Parallel_Vector_SumAll(nfft3d,vnl)

      return
      end

      subroutine tce_fock_driver(d_f1,l_f1_offset)
c
c $Id: tce_fock_destroy.F 19706 2010-10-29 17:52:31Z d3y133 $
c 
c Written by Jeff Hammond, January 2008.
c
      implicit none
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
c#include "geom.fh"
c#include "rtdb.fh"
c#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
#include "sf.fh"
#include "inp.fh"
#include "errquit.fh"
c#include "tce.fh"
c#include "tce_main.fh"
#include "tce_ints.fh"
      call deletefile(d_f1)
      if (.not.ma_pop_stack(l_f1_offset))
     1  call errquit("tce_fock_destroy: MA problem",l_f1_offset,MA_ERR)
      return
      end

      integer function argos_prep_shorts(xatm,latm,matm,ilo,ihi,jlo,jhi,
     + ishort,jshort,rshort)
c
c $Id: argos_prep_shorts.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to find atom ishort in [ilo:ihi] and jshort in [jlo,jhi]
c              with the shortest distance rshort in nm
c
c     in  : xatm(3,matm) = atomic coordinates
c         : latm(2,matm) = atomic numbers
c         : matm         = dimension of coordinate list
c         : ilo          = atom index ilo
c         : ihi          = atom index ihi
c         : jlo          = atom index jlo
c         : jhi          = atom index jhi
c
c     out : ishort       = atom index i with shortest distance
c         : jshort       = atom index j with shortest distance
c         : rshort       = distance between atoms ishort and jshort
c
      implicit none
c
      real*8 argos_prep_atsiz
      external argos_prep_atsiz
c
      integer matm
      real*8 xatm(3,matm)
      integer latm(5,matm)
      integer ilo,ihi,jlo,jhi,ishort(10),jshort(10)
      real*8 rshort(10)
c
      integer i,j,k,l,number,ishrt,jshrt
      real*8 dist,short
      integer nsh,ish(100),jsh(100)
      real*8 rsh(100)
      logical new
c
      nsh=0
      do 1 i=ilo,ihi
      if(latm(2,i).gt.1) then
      do 2 j=jlo,jhi
      if(latm(2,j).gt.1) then
      dist=sqrt((xatm(1,i)-xatm(1,j))*(xatm(1,i)-xatm(1,j))+
     + (xatm(2,i)-xatm(2,j))*(xatm(2,i)-xatm(2,j))+
     + (xatm(3,i)-xatm(3,j))*(xatm(3,i)-xatm(3,j)))
      if(dist.lt.argos_prep_atsiz(latm(2,i))+
     + argos_prep_atsiz(latm(2,j))) then
      nsh=nsh+1
      if(nsh.gt.100)
     + call md_abort('argos_prep_shorts: increase dimension',1)
      ish(nsh)=i
      jsh(nsh)=j
      rsh(nsh)=dist
      endif
      endif
    2 continue
      endif
    1 continue
c
      number=0
c
      if(nsh.gt.0) then
      do 3 i=1,nsh-1
      do 4 j=i+1,nsh
      if(rsh(i).gt.rsh(j)) then
      dist=rsh(i)
      k=ish(i)
      l=jsh(i)
      rsh(i)=rsh(j)
      ish(i)=ish(j)
      jsh(i)=jsh(j)
      rsh(j)=dist
      ish(j)=k
      jsh(j)=l
      endif
    4 continue
    3 continue
      do 5 i=1,nsh
      do 6 j=1,number
      if(ish(i).eq.ishort(j).or.jsh(i).eq.jshort(j)) goto 5
    6 continue
      number=number+1
      if(number.gt.10)
     +  call md_abort('argos_prep_shorts:increase dimension',2)
      ishort(number)=ish(i)
      jshort(number)=jsh(i)
      rshort(number)=rsh(i)
    5 continue
      endif
c
cc
c
c
c      number=0
c
c      do 1 l=1,10
c      ishrt=0
c      jshrt=0
c      short=0.0d0
c      do 2 i=ilo,ihi
c      do 3 j=jlo,jhi
c      do 4 k=1,number
c      if(ishort(k).eq.i.and.jshort(k).eq.j) goto 3
c    4 continue
c      if(i.ne.j.and.latm(2,i).gt.1.and.latm(2,j).gt.1) then
c      dist=sqrt((xatm(1,i)-xatm(1,j))*(xatm(1,i)-xatm(1,j))+
c     + (xatm(2,i)-xatm(2,j))*(xatm(2,i)-xatm(2,j))+
c     + (xatm(3,i)-xatm(3,j))*(xatm(3,i)-xatm(3,j)))
c      if(dist.lt.argos_prep_atsiz(latm(2,i))+argos_prep_atsiz(latm(2,j))
c     + .and.(ishrt.eq.0.or.dist.lt.short)) then
c      ishrt=i
c      jshrt=j
c      short=dist
c      endif
c      endif
c    3 continue
c    2 continue
c      if(ishrt.gt.0) then
c      number=number+1
c      if(number.gt.10)
c     + call md_abort('Too many links between fragment pair',number)
c      ishort(number)=ishrt
c      jshort(number)=jshrt
c      rshort(number)=short
c      endif
c    1 continue
c
      argos_prep_shorts=number
c
      return
      end

C> \ingroup selci
C> @{
C>
      subroutine selci_makehs(hij,i,j,ns,indbar,iocc,lists,
     $     w1,w2,work1,work2,f,g,int12,int34,numf,numf2)
*
* $Id: makehs.F 24780 2013-11-07 21:23:59Z d3y133 $
*
#include "implicit.fh"
#include "ciinfo.fh"
      dimension hij(*),indbar(*),iocc(*),lists(*),
     $     w1(nfmax,nfmax,nsmax),w2(nfmax2,nfmax,nsmax-1),
     $     work1(*),work2(*),f(*),g(*),int12(*),int34(*)
#include "stfunc.fh"
c
c     (i->j) |I> = |J>. Compute hij(u,v) = <Iu|H|Jv>.
c
c     hij(u,v) = { f(ij) + nj(jj|ij) }<Iu|Eij|Jv> +
c                sum(r socc .ne. i,j)[(ir|rj)<Iu|EirErj|Jv>]
c
c     do the <u|Eij|v> term
c
      call selci_eij(hij,i,j,ns,indbar,iocc,w1,w2)
      ii = iky(i) + i
      ij = itrian(i,j)
      jj = iky(j) + j
      fac = f(ij)
      nns = ns
      if (iocc(j).eq.1) then
         nns = nns - 2
         fac = fac + g(intadr(jj,ij))
      endif
      if (iocc(i).eq.3) nns = nns + 2
      numf = nf(ns)
      numf2 = nf(nns)
      nnf = numf*numf2
      call dscal(nnf,fac,hij,1)
c
c     do the two-electron term
c
      if (.not.(iocc(i).eq.1 .and. nf(ns-2).le.0)) then
         do 10 irrr = 1,ns
            ir = lists(irrr)
            if (ir.eq.i .or. ir.eq.j) goto 10
            call selci_eirerj(work2,i,ir,j,ns,indbar,iocc,w1,w2,work1)
            gg = g(intadr(itrian(ir,i),itrian(ir,j)))
            call daxpy(nnf,gg,work2,1,hij,1)
 10      continue
      endif
c
      end
C>
C> @}

      subroutine argos_md()
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      logical frequency
      real*8 timer_wall_total
      external frequency,timer_wall_total
c
      character*1 mdt
      logical ltmp
c
      lfirst=.true.
      lxw=.false.
      lvw=.false.
      lxs=.false.
      lvs=.false.
      lesp=.false.
c
c     equilibration
c
      ltmp=lhop
      lhop=.false.
      lequi=.true.
      lprpmf=.false.
      do 1 iequi=kequi+1,mequi
c
      mdstep=mdstep+1
      stime=stime+tstep
      lpmfc=npmf.gt.1.and.iequi.gt.npmf
      call timer_start(201)
      call argos_newton()
      call argos_prop_proper(mdstep,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme,
     + epot,epotw,epotsw,epots,volume,dwr,dbl_mb(i_dsr),ekin,etot,
     + npolit,dbl_mb(i_gsm),dbl_mb(i_esa),box,dbl_mb(i_xsmp))
      call argos_server
      call timer_stop(201)
    1 continue
      lpmfc=.true.
c
c     data gathering
c
      lhop=ltmp
      lequi=.false.
      lprpmf=iprpmf.ne.0
      if(lprpmf) lfnpmf=-iabs(lfnpmf)
      call timer_start(205)
      do 2 idacq=kdacq+1,mdacq
c
      mdstep=mdstep+1
      stime=stime+tstep
c
      lxw=frequency(mdstep,nfcoor)
      lvw=frequency(mdstep,nfvelo)
      lfw=frequency(mdstep,nfforc)
      lxs=frequency(mdstep,nfscoo)
      lvs=frequency(mdstep,nfsvel)
      lfs=frequency(mdstep,nfsfor)
      lesp=frequency(mdstep,nfesp)
c
      call argos_timer_init()
c
      call timer_start(201)
c
      call argos_newton()
c
      call timer_start(6)
c
      if(lfw.or.lfs) then
      call argos_space_gaputf(me,dbl_mb(i_fw),nwmloc,dbl_mb(i_fs),
     + nsaloc)
      endif
c
      call timer_stop(6)
c
      call timer_start(55)
      mdt=' '
      if(iguide.gt.0) mdt='g'
      write(projct,4000) nserie,mdt,mequi,idacq,tmpext,prsext,
     + filnam(1:38)
 4000 format(i2,' md',a1,i7,' + ',i7,' @',f7.2,e9.2,' ',a)
      if(frequency(mdstep,nfrest)) then
      call argos_wrtrst(lfnrst,rfile,.true.)
      endif
      if(frequency(mdstep,nftime)) call argos_wrtime
c
      call timer_stop(55)
c
      call argos_prop_proper(mdstep,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme,
     + epot,epotw,epotsw,epots,volume,dwr,dbl_mb(i_dsr),ekin,etot,
     + npolit,dbl_mb(i_gsm),dbl_mb(i_esa),box,dbl_mb(i_xsmp))
      call argos_server
      call argos_prop_step(mdstep,stime,eww,dbl_mb(i_esw),
     + dbl_mb(i_ess),dbl_mb(i_fss),dbl_mb(i_esk),epme)
c
      call timer_stop(201)
c
      if(frequency(mdstep,nfnewf).and.idacq.ne.mdacq) then
      if(me.eq.0) call argos_fopen(.true.)
      endif
c
c
      if(lstop) then
      if(me.eq.0) write(*,1000) tleft,tneed
 1000 format(///,' Time left (',f12.3,' s) is less than twice the ',
     + ' time needed to reach writing the next restart file (',
     + f12.3,' s)',//,' Simulation aborted',//)
      return
      endif
c
    2 continue
c
      return
      end
c $Id: argos_md.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_guided(fw,fs,gw,gs)
c
      implicit none
c
#include "argos.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      real*8 gw(mwm,3,mwa),gs(msa,3)
c
      integer i,j,k
c
      do 1 k=1,nwa
      do 2 j=1,3
      do 3 i=1,nwmloc
      gw(i,j,k)=factgg*gw(i,j,k)+factgf*(fw(i,j,k,1)+fguide*gw(i,j,k))
      fw(i,j,k,1)=fw(i,j,k,1)+fguide*gw(i,j,k)
    3 continue
    2 continue
    1 continue
c
      do 4 j=1,3
      do 5 i=1,nsaloc
      gs(i,j)=factgg*gs(i,j)+factgf*(fs(i,j,1)+fguide*gs(i,j))
      fs(i,j,1)=fs(i,j,1)+fguide*gs(i,j)
    5 continue
    4 continue
c
      call argos_space_copyg(dbl_mb(i_gw),dbl_mb(i_gs))
      call ga_sync()
c
      return
      end
c $Id: argos_guided.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: pawppv1.F 25664 2014-05-22 01:04:37Z bylaska $
*

*     **************************************
*     *                                    *
*     *           pawppv1                   *
*     *                                    *
*     **************************************

      logical function pawppv1(oprint_in,version,
     >                  psp_filename,formatted_filename,
     >                  ngrid,unita,locp,lmax,rlocal)
      implicit none
      logical          oprint_in
      integer          version
      character*50     psp_filename,formatted_filename
      integer          ngrid(3)
      double precision unita(3,3)
      integer locp,lmax
      real*8  rlocal

#include "errquit.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "stdio.fh"

*     ***** local variables ****
      integer taskid,MASTER,msglen
      parameter (MASTER=0)


*     **** 1d pseudopotential data ****
      integer psp_type
      integer n1dgrid,nbasis,icut,nmax
      real*8  zv,r1,rmax,core_kin_energy,core_ion_energy
      real*8  zion,sigma,rcore,amass,rc(25)
      real*8  log_amesh,amesh,ecorez,ecorecore
      character*2 atom
      character*80 comment

      integer bprj(2),mprj(2),lprj(2),nprj(2),prj_ps0(2),prj_ps(2)
      integer v_ps(2),core_ps(2),core_ae(2)
      integer core_ps_prime(2),core_ae_prime(2)
      integer dphi_ps(2),phi_ps(2),dphi_ae(2),phi_ae(2)
      integer eig(2),lps(2),nps(2),nae(2)
      integer rgrid(2)
      integer nmaxl(2)

*     **** matrix data ****
      integer Gijl(2)
      integer hartree_matrix(2),comp_charge_matrix(2),comp_pot_matrix(2)

*     ***** ngrid data *****
      integer nproj,nsize,nfft1,nfft2,nfft3
      integer vl(2),vlpaw(2),vnl(2),G_indx,G_hndl
      integer f1(2),f2(2),f3(2),f4(2),cs(2),sn(2)

*     **** ray data ****
      logical filter
      integer nray,G_ray_hndl,tmp_ray_hndl
      integer vnl_ray_hndl,vl_ray_hndl,vlpaw_ray_hndl
      integer G_ray_indx,tmp_ray_indx
      integer vnl_ray_indx,vl_ray_indx,vlpaw_ray_indx


*     **** other variables ****
      logical hprint,mprint,oprint,value
      integer idum,l,ii,i,j,ierr
      character*255 full_filename
      real*8 zcore,fourpi,unitg(3,3)

*     **** external functions ****
      logical  control_print,control_kbpp_filter
      external control_print,control_kbpp_filter
      real*8   log_integrate_def,log_coulomb0_energy,log_coulomb_energy
      external log_integrate_def,log_coulomb0_energy,log_coulomb_energy
      integer  kbpp_calc_nray
      external kbpp_calc_nray


      call Parallel_taskid(taskid)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)
      mprint = (taskid.eq.MASTER).and.control_print(print_medium)
      oprint = (oprint_in.or.hprint)


      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(psp_filename,.false.,.false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      open(unit=11,file=full_filename(1:l),
     >             status='old',form='formatted')
      read(11,*) psp_type
      read(11,'(A)') atom
      read(11,*) zv
      read(11,*) r1
      read(11,*) rmax
      read(11,*) n1dgrid
      read(11,*) nbasis
      read(11,*) (rc(i),i=1,nbasis)
      read(11,*) icut
      read(11,'(A)') comment
      read(11,*) core_kin_energy
      end if

      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,psp_type)
      call Parallel_Brdcst_values(MASTER,msglen,zv)
      call Parallel_Brdcst_values(MASTER,msglen,r1)
      call Parallel_Brdcst_values(MASTER,msglen,rmax)
      call Parallel_Brdcst_ivalues(MASTER,msglen,n1dgrid)
      call Parallel_Brdcst_ivalues(MASTER,msglen,nbasis)
      call Parallel_Brdcst_ivalues(MASTER,msglen,icut)
      call Parallel_Brdcst_values(MASTER,msglen,core_kin_energy)
      msglen = nbasis
      call Parallel_Brdcst_values(MASTER,msglen,rc)


*     **** define rgrid ****
      log_amesh = dlog(rmax/r1)/dble(n1dgrid-1)
      amesh     = dexp(log_amesh)
      value = MA_alloc_get(mt_dbl,n1dgrid,'rgrid',rgrid(2),rgrid(1))
      if (.not.value)  call errquit('pawppv1:out of heap',0,MA_ERR)
      dbl_mb(rgrid(1)) = r1
      do i=1,n1dgrid-1
        dbl_mb(rgrid(1)+i) = dbl_mb(rgrid(1)+i-1)*amesh
      end do

*     **** allocate rest of grid data ****
      value =           MA_alloc_get(mt_int,nbasis,'nae',nae(2),nae(1))
      value = value.and.MA_alloc_get(mt_int,nbasis,'nps',nps(2),nps(1))
      value = value.and.MA_alloc_get(mt_int,nbasis,'lps',lps(2),lps(1))
      value = value.and.MA_alloc_get(mt_dbl,nbasis,'eig',eig(2),eig(1))
      value = value.and.MA_alloc_get(mt_dbl,nbasis*n1dgrid,'phi_ae',
     >                              phi_ae(2),phi_ae(1))
      value = value.and.MA_alloc_get(mt_dbl,nbasis*n1dgrid,'dphi_ae',
     >                              dphi_ae(2),dphi_ae(1))
      value = value.and.MA_alloc_get(mt_dbl,nbasis*n1dgrid,'phi_ps',
     >                              phi_ps(2),phi_ps(1))
      value = value.and.MA_alloc_get(mt_dbl,nbasis*n1dgrid,'dphi_ps',
     >                              dphi_ps(2),dphi_ps(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'core_ae',
     >                              core_ae(2),core_ae(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'core_ps',
     >                              core_ps(2),core_ps(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'core_ae_prime',
     >                              core_ae_prime(2),core_ae_prime(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'core_ps_prime',
     >                              core_ps_prime(2),core_ps_prime(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'v_ps',
     >                              v_ps(2),v_ps(1))
      value = value.and.MA_alloc_get(mt_dbl,nbasis*n1dgrid,'prj_ps',
     >                              prj_ps(2),prj_ps(1))
      value = value.and.MA_alloc_get(mt_dbl,nbasis*n1dgrid,'prj_ps0',
     >                              prj_ps0(2),prj_ps0(1))
      if (.not.value)  call errquit('pawppv1:out of heap',1,MA_ERR)


      if (taskid.eq.MASTER) then
         read(11,*) (int_mb(nae(1)+j),
     >                                 dbl_mb(eig(1)+j),
     >                                 int_mb(nps(1)+j),
     >                                 int_mb(lps(1)+j),j=0,nbasis-1)
         read(11,*) ((dbl_mb(phi_ae(1)+i+j*n1dgrid),
     >                                  i=0,n1dgrid-1),
     >                                  j=0,nbasis-1)
         read(11,*) ((dbl_mb(dphi_ae(1)+i+j*n1dgrid), 
     >                                  i=0,n1dgrid-1),
     >                                  j=0,nbasis-1)
         read(11,*) ((dbl_mb(phi_ps(1)+i+j*n1dgrid), 
     >                                  i=0,n1dgrid-1),
     >                                  j=0,nbasis-1)
         read(11,*) ((dbl_mb(dphi_ps(1)+i+j*n1dgrid), 
     >                                  i=0,n1dgrid-1),
     >                                  j=0,nbasis-1)
         read(11,*) ((dbl_mb(prj_ps(1)+i+j*n1dgrid), 
     >                                  i=0,n1dgrid-1),
     >                                  j=0,nbasis-1)
         read(11,*) (dbl_mb(core_ae(1)+i),
     >                                 i=0,n1dgrid-1)
         read(11,*) (dbl_mb(core_ps(1)+i),
     >                                 i=0,n1dgrid-1)
         read(11,*) (dbl_mb(v_ps(1)+i),
     >                                 i=0,n1dgrid-1)
         read(11,*) sigma
         read(11,*) zion
         read(11,*) ((dbl_mb(prj_ps0(1)+i+j*n1dgrid),
     >                                  i=0,n1dgrid-1),
     >                                  j=0,nbasis-1)
         close(11)
      end if


      msglen = nbasis
      call Parallel_Brdcst_ivalues(MASTER,msglen,int_mb(nae(1)))
      call Parallel_Brdcst_ivalues(MASTER,msglen,int_mb(nps(1)))
      call Parallel_Brdcst_ivalues(MASTER,msglen,int_mb(lps(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(eig(1)))

      msglen = nbasis*n1dgrid
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(phi_ae(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(dphi_ae(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(phi_ps(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(dphi_ps(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(prj_ps(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(prj_ps0(1)))

      msglen = n1dgrid
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(core_ae(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(core_ps(1)))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(v_ps(1)))

      msglen = 1
      call Parallel_Brdcst_values(MASTER,msglen,sigma)
      call Parallel_Brdcst_values(MASTER,msglen,zion)
      

*     **** define nproj and lmax ****
      locp = -1
      lmax = -1
      nproj = 0
      do ii=1,nbasis
         l    = int_mb(lps(1)+ii-1)
         nproj = nproj + 2*l+1
         if (l.gt.lmax) lmax = l
      end do
      
*     **** define nmax ****
      if(.not. MA_push_get(mt_int,lmax+1,'nmaxl',nmaxl(2),nmaxl(1)))
     > call errquit('pawppv1:out of stack',2,MA_ERR)
      call icopy(lmax+1,0,0,int_mb(nmaxl(1)),1)
      do ii=1,nbasis
         l = int_mb(lps(1)+ii-1)
         int_mb(nmaxl(1)+l) = int_mb(nmaxl(1)+l) + 1
      end do
      nmax = 0
      do l=0,lmax
         if (int_mb(nmaxl(1)+l).gt.nmax) nmax = int_mb(nmaxl(1)+l)
      end do
      if(.not.MA_pop_stack(nmaxl(2)))
     > call errquit('pawppv1:error popping stack',0,MA_ERR)


*     **** allocate Gijl,Sijl,Tijl,vcore,Vpseuo ****
      l = nmax*nmax*(lmax+1)
      value=          MA_alloc_get(mt_dbl,5*l,'Gijl',Gijl(2),Gijl(1))
      !value=value.and.MA_alloc_get(mt_dbl,l,'Tijl',Tijl(2),Tijl(1))
      l = nbasis*nbasis*nbasis*nbasis*(2*lmax+1)
      value=value.and.
     >      MA_alloc_get(mt_dbl,l,'hartree_matrix',
     >                   hartree_matrix(2),hartree_matrix(1))
      l = nbasis*nbasis*(2*lmax+1)
      value=value.and.
     >      MA_alloc_get(mt_dbl,l,'comp_charge_matrix',
     >                   comp_charge_matrix(2),comp_charge_matrix(1))
      l = nbasis*nbasis*(2*lmax+1)
      value=value.and.
     >      MA_alloc_get(mt_dbl,l,'comp_pot_matrix',
     >                   comp_pot_matrix(2),comp_pot_matrix(1))

*     **** allocate nprj,lprj,mprj,bprj ****
      value=value.and.MA_alloc_get(mt_int,nproj,'nprj',nprj(2),nprj(1))
      value=value.and.MA_alloc_get(mt_int,nproj,'lprj',lprj(2),lprj(1))
      value=value.and.MA_alloc_get(mt_int,nproj,'mprj',mprj(2),mprj(1))
      value=value.and.MA_alloc_get(mt_int,nproj,'bprj',bprj(2),bprj(1))
      if (.not.value)  call errquit('pawppv1:out of heap',2,MA_ERR)


*    **** more temporary space ****
      value =           MA_alloc_get(mt_dbl,n1dgrid,'f1',f1(2),f1(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'f2',f2(2),f2(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'f3',f3(2),f3(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'f4',f4(2),f4(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'cs',cs(2),cs(1))
      value = value.and.MA_alloc_get(mt_dbl,n1dgrid,'sn',sn(2),sn(1))
      if (.not.value)call errquit('pawppv1:out of heap',0,MA_ERR)

*     **** allocate vl,vnl,vnlnrm G ****
      nsize = (ngrid(1)/2+1)*ngrid(2)*ngrid(3)
      value = MA_alloc_get(mt_dbl,nsize,'vl',vl(2),vl(1))
      value = value.and.MA_alloc_get(mt_dbl,nsize,
     >                               'vlpaw',vlpaw(2),vlpaw(1))
      value = value.and.MA_alloc_get(mt_dbl,nsize*(nproj),
     >                        'vnl',vnl(2), vnl(1))
      value = value.and.MA_alloc_get(mt_dbl,3*nsize,'G',G_hndl,G_indx)
      if (.not.value)call errquit('pawppv1:out of heap',0,MA_ERR)

*     **** preparation of constants ****
      nfft1=ngrid(1)
      nfft2=ngrid(2)
      nfft3=ngrid(3)
      call setup_kbpp(nfft1,nfft2,nfft3,unita,unitg,dbl_mb(G_indx))
      filter = control_kbpp_filter()

      !**** allocate memory for rays ****
      nray = kbpp_calc_nray(nfft1,nfft2,nfft3,unita)

      value =           MA_alloc_get(mt_dbl,nray,
     >                  'G_ray',G_ray_hndl,G_ray_indx)
      value = value.and.MA_alloc_get(mt_dbl,2*nray,
     >                  'vl_ray',vl_ray_hndl,vl_ray_indx)
      value = value.and.MA_alloc_get(mt_dbl,2*nray,
     >                  'vlpaw_ray',vlpaw_ray_hndl,vlpaw_ray_indx)
      value = value.and.MA_alloc_get(mt_dbl,2*nray*(nbasis),
     >                  'vnl_ray',vnl_ray_hndl,vnl_ray_indx)
      value = value.and.MA_alloc_get(mt_dbl,nray,
     >                  'tmp_ray',tmp_ray_hndl,tmp_ray_indx)
      if (.not.value)
     >   call errquit('pawppv1:out of heap memory',0,MA_ERR)

        call kbpp_generate_G_ray(nfft1,nfft2,nfft3,
     >                         unita,dbl_mb(G_ray_indx))

        zcore = zion - zv
        call integrate_pawppv1(version,rlocal,
     >                     n1dgrid,log_amesh,nbasis,nmax,lmax,icut,
     >                     zv,zcore,sigma,
     >                     int_mb(nps(1)),int_mb(lps(1)),
     >                                dbl_mb(v_ps(1)),
     >                                dbl_mb(prj_ps(1)),
     >                                dbl_mb(phi_ae(1)),
     >                                dbl_mb(dphi_ae(1)),
     >                                dbl_mb(phi_ps(1)),
     >                                dbl_mb(dphi_ps(1)),
     >                                dbl_mb(core_ae(1)),
     >                                dbl_mb(core_ps(1)),
     >                                dbl_mb(rgrid(1)),
     >                                dbl_mb(f1(1)),
     >                                dbl_mb(f2(1)),
     >                                dbl_mb(f3(1)),
     >                                dbl_mb(f4(1)),
     >                                dbl_mb(cs(1)),
     >                                dbl_mb(sn(1)),
     >                      nfft1,nfft2,nfft3,nproj,
     >                                dbl_mb(G_indx),
     >                                dbl_mb(vl(1)),
     >                                dbl_mb(vlpaw(1)),
     >                                dbl_mb(vnl(1)),
     >                                int_mb(nprj(1)),
     >                                int_mb(lprj(1)),
     >                                int_mb(mprj(1)),
     >                                int_mb(bprj(1)),
     >                                dbl_mb(Gijl(1)),
     >                                dbl_mb(hartree_matrix(1)),
     >                                dbl_mb(comp_charge_matrix(1)),
     >                                dbl_mb(comp_pot_matrix(1)),
     >                      nray,
     >                                dbl_mb(G_ray_indx),
     >                                dbl_mb(vl_ray_indx),
     >                                dbl_mb(vlpaw_ray_indx),
     >                                dbl_mb(vnl_ray_indx),
     >                                dbl_mb(tmp_ray_indx),
     >                                filter,
     >                      ierr)
        value = MA_free_heap(tmp_ray_hndl)
        value = value.and.MA_free_heap(vl_ray_hndl)
        value = value.and.MA_free_heap(vlpaw_ray_hndl)
        value = value.and.MA_free_heap(vnl_ray_hndl)
        value = value.and.MA_free_heap(G_ray_hndl)
        if (.not.value)
     >   call errquit('pawppv1:Error freeing memory',0,MA_ERR)


*      **** calculate radial derivatives of core densities ****
         call pawppv1_derivative_ngrid(
     >            n1dgrid,
     >            log_amesh,
     >            dbl_mb(rgrid(1)),
     >            dbl_mb(core_ae(1)),
     >            dbl_mb(core_ae_prime(1)))
         call pawppv1_derivative_ngrid(
     >            n1dgrid,
     >            log_amesh,
     >            dbl_mb(rgrid(1)),
     >            dbl_mb(core_ps(1)),
     >            dbl_mb(core_ps_prime(1)))

c*     *** integrate core density ***
c      fourpi = 16.0d0*datan(1.0d0)
c      zcore = fourpi*log_integrate_def(0,
c     >                         dbl_mb(core_ae(1)),
c     >                         2,dbl_mb(rgrid(1)),log_amesh,n1dgrid)
c      write(luout,*) "Zcore=",zcore,rmax,dbl_mb(rgrid(1)+n1dgrid-1)
c      zcore = fourpi*log_integrate_def(0,
c     >                         dbl_mb(core_ps(1)),
c     >                         2,dbl_mb(rgrid(1)),log_amesh,n1dgrid)
c      write(luout,*) "Zcoreps=",zcore

c*     **** compute the core_ion_energy = ecorez + ecorecore ****
c      ecorez = -zion*fourpi
c     >              *log_integrate_def(0,dbl_mb(core_ae(1)),
c     >                                 1,dbl_mb(rgrid(1)),
c     >                                 log_amesh,n1dgrid)
      if (dabs(zcore).gt.1.0d-9) then
         ecorez = log_coulomb0_energy(dbl_mb(core_ae(1)),zion-zv,
     >                               dbl_mb(rgrid(1)),n1dgrid,log_amesh,
     >                               zion)
         ecorecore = log_coulomb_energy(dbl_mb(core_ae(1)),zion-zv,
     >                               dbl_mb(rgrid(1)),n1dgrid,log_amesh)
         core_ion_energy = ecorez + ecorecore
      else
         core_ion_energy = 0.0d0
      end if



      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(formatted_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      if (mprint) then
      write(luout,*)
      write(luout,*) "Generated formatted_filename: ",full_filename(1:l)
c      if (filter) write(luout,*) "- filtering pseudopotential -"
      end if
      call openfile(2,full_filename,l,'w',l)

         call cwrite(2,comment,80)
         call iwrite(2,psp_type,1)
         call iwrite(2,version,1)
         call iwrite(2,ngrid,3)
         call dwrite(2,unita,9)
         call cwrite(2,atom,2)
         amass = 0.0d0
         call dwrite(2,amass,1)
         call dwrite(2,zv,1)
         call iwrite(2,lmax,1)
         !call iwrite(2,locp,1)
         call iwrite(2,nbasis,1)

         call iwrite(2,nmax,1)
         call dwrite(2,rc,lmax+1)

         call iwrite(2,nproj,1)
         if (nproj.gt.0) then
         call iwrite(2,int_mb(nprj(1)),nproj)
         call iwrite(2,int_mb(lprj(1)),nproj)
         call iwrite(2,int_mb(mprj(1)),nproj)
         call iwrite(2,int_mb(bprj(1)),nproj)
         call dwrite(2,dbl_mb(Gijl(1)),5*nmax*nmax*(lmax+1))
         end if

         if (version.eq.4) call dwrite(2,rlocal,1)
         rcore = 0.0d0
         call dwrite(2,rcore,1)


*        **** other PAW matrices ****
         l = nbasis*nbasis*nbasis*nbasis*(2*lmax+1)
         call dwrite(2,dbl_mb(hartree_matrix(1)),l)
         l = nbasis*nbasis*(2*lmax+1)
         call dwrite(2,dbl_mb(comp_charge_matrix(1)),l)
         call dwrite(2,dbl_mb(comp_pot_matrix(1)),l)

*        **** miscelaneous PAW energies ****
         call dwrite(2,core_kin_energy,1)
         call dwrite(2,core_ion_energy,1)

*        **** write 1d-wavefunctions ****
         call iwrite(2,n1dgrid,1)
         call iwrite(2,icut,1)
         call dwrite(2,log_amesh,1)
         call dwrite(2,r1,1)
         call dwrite(2,rmax,1)
         call dwrite(2,sigma,1)
         call dwrite(2,zion,1)
         call dwrite(2,dbl_mb(eig(1)),nbasis)
         call iwrite(2,int_mb(nae(1)),nbasis)
         call iwrite(2,int_mb(nps(1)),nbasis)
         call iwrite(2,int_mb(lps(1)),nbasis)

         call dwrite(2,dbl_mb(rgrid(1)),n1dgrid)
         call dwrite(2,dbl_mb(phi_ae(1)),n1dgrid*nbasis)
         call dwrite(2,dbl_mb(dphi_ae(1)),n1dgrid*nbasis)
         call dwrite(2,dbl_mb(phi_ps(1)),n1dgrid*nbasis)
         call dwrite(2,dbl_mb(dphi_ps(1)),n1dgrid*nbasis)
         call dwrite(2,dbl_mb(core_ae(1)),n1dgrid)
         call dwrite(2,dbl_mb(core_ps(1)),n1dgrid)
         call dwrite(2,dbl_mb(core_ae_prime(1)),n1dgrid)
         call dwrite(2,dbl_mb(core_ps_prime(1)),n1dgrid)

         call dwrite(2,dbl_mb(vl(1)),nsize)
         call dwrite(2,dbl_mb(vlpaw(1)),nsize)
         if (nproj.gt.0) then
            call dwrite(2,dbl_mb(vnl(1)),nsize*nproj)
         end if

      call closefile(2)
      end if


      value = .true.
      value = value.and.MA_free_heap(G_hndl)
      value = value.and.MA_free_heap(vnl(2))
      value = value.and.MA_free_heap(vlpaw(2))
      value = value.and.MA_free_heap(vl(2))
      value = value.and.MA_free_heap(sn(2))
      value = value.and.MA_free_heap(cs(2))
      value = value.and.MA_free_heap(f1(2))
      value = value.and.MA_free_heap(f2(2))
      value = value.and.MA_free_heap(f3(2))
      value = value.and.MA_free_heap(f4(2))

      value = value.and.MA_free_heap(Gijl(2))
      value = value.and.MA_free_heap(hartree_matrix(2))
      value = value.and.MA_free_heap(comp_charge_matrix(2))
      value = value.and.MA_free_heap(comp_pot_matrix(2))

      value = value.and.MA_free_heap(bprj(2))
      value = value.and.MA_free_heap(mprj(2))
      value = value.and.MA_free_heap(lprj(2))
      value = value.and.MA_free_heap(nprj(2))

      value = value.and.MA_free_heap(prj_ps0(2))
      value = value.and.MA_free_heap(prj_ps(2))
      value = value.and.MA_free_heap(v_ps(2))
      value = value.and.MA_free_heap(core_ps_prime(2))
      value = value.and.MA_free_heap(core_ae_prime(2))
      value = value.and.MA_free_heap(core_ps(2))
      value = value.and.MA_free_heap(core_ae(2))
      value = value.and.MA_free_heap(dphi_ps(2))
      value = value.and.MA_free_heap(phi_ps(2))
      value = value.and.MA_free_heap(dphi_ae(2))
      value = value.and.MA_free_heap(phi_ae(2))

      value = value.and.MA_free_heap(eig(2))
      value = value.and.MA_free_heap(lps(2))
      value = value.and.MA_free_heap(nps(2))
      value = value.and.MA_free_heap(nae(2))

      value = value.and.MA_free_heap(rgrid(2))
      if (.not.value)  call errquit('pawppv1:freeing heap',5,MA_ERR)

      pawppv1 = value
      return

 9999 call errquit('pawppv1:Error reading psp_filename',0,DISK_ERR)
      pawppv1 = value
      return

      END




c     *************************************************
c     *                                               *
c     *        pawppv1_derivative_ngrid               *
c     *                                               *
c     *************************************************
c
c  This routine computes the seven point derivative of f.
c  where f and df are stored on a logarithmic grid. The
c  dimensions of f and df are, f(1:ng), and df(1:ng)

      subroutine pawppv1_derivative_ngrid(ng,log_amesh,r,f,df)
      implicit none
      integer           ng
      double precision  log_amesh
      double precision  r(ng)
      double precision  f(ng)
      double precision df(ng)

      double precision one_over_60
      parameter (one_over_60 = 1.0d0/60.0d0)

      integer i,n1,n2,m1,m2
      double precision aa

      aa = one_over_60/log_amesh
      n1 = 1
      n2 = ng
      m1 = n1
      m2 = n2


      if (n1.le.3) then
        if ((n1.eq.1).and.(n1.ge.m1).and.(n1.le.m2)) then
          df(1) = aa*(-147.0d0*f(1)
     >               + 360.0d0*f(2)
     >               - 450.0d0*f(3)
     >               + 400.0d0*f(4)
     >               - 225.0d0*f(5)
     >               +  72.0d0*f(6)
     >               -  10.0d0*f(7))/r(1)
          n1 = n1+1
        end if
        if ((n1.eq.2).and.(n1.ge.m1).and.(n1.le.m2)) then
          df(2) = aa*( -10.0d0*f(1)
     >               -  77.0d0*f(2)
     >               + 150.0d0*f(3)
     >               - 100.0d0*f(4)
     >               +  50.0d0*f(5)
     >               -  15.0d0*f(6)
     >               +   2.0d0*f(7))/r(2)
          n1 = n1+1
        end if
        if ((n1.eq.3.and.(n1.ge.m1).and.(n1.le.m2))) then
          df(3) = aa*(  +2.0d0*f(1)
     >               -  24.0d0*f(2)
     >               -  35.0d0*f(3)
     >               +  80.0d0*f(4)
     >               -  30.0d0*f(5)
     >               +   8.0d0*f(6)
     >               -   1.0d0*f(7))/r(3)
          n1 = n1+1
        end if
      end if

      if (n2.ge.(ng-2)) then
        if ((n2.eq.ng).and.(n2.ge.m1).and.(n2.le.m2)) then
          df(ng) = aa*( +147.0d0*f(ng)
     >                - 360.0d0*f(ng-1)
     >                + 450.0d0*f(ng-2)
     >                - 400.0d0*f(ng-3)
     >                + 225.0d0*f(ng-4)
     >                -  72.0d0*f(ng-5)
     >                +  10.0d0*f(ng-6))/r(ng)
          n2 = n2-1
        end if
        if ((n2.eq.(ng-1).and.(n2.ge.m1).and.(n2.le.m2))) then
          df(ng-1) = aa*( +10.0d0*f(ng)
     >                  +  77.0d0*f(ng-1)
     >                  - 150.0d0*f(ng-2)
     >                  + 100.0d0*f(ng-3)
     >                  -  50.0d0*f(ng-4)
     >                  +  15.0d0*f(ng-5)
     >                  -   2.0d0*f(ng-6))/r(ng-1)
          n2 = n2-1
        end if
        if ((n2.eq.(ng-2).and.(n2.ge.m1).and.(n2.le.m2))) then
          df(ng-2) = aa*(  -2.0d0*f(ng)
     >                  +  24.0d0*f(ng-1)
     >                  +  35.0d0*f(ng-2)
     >                  -  80.0d0*f(ng-3)
     >                  +  30.0d0*f(ng-4)
     >                  -   8.0d0*f(ng-5)
     >                  +   1.0d0*f(ng-6))/r(ng-2)
          n2 = n2-1
        end if
      end if

      do i=n1,n2
        df(i) = aa*(  -1.0d0*f(i-3)
     >             +   9.0d0*f(i-2)
     >             -  45.0d0*f(i-1)
     >             +  45.0d0*f(i+1)
     >             -   9.0d0*f(i+2)
     >             +   1.0d0*f(i+3))/r(i)
      end do

      return
      end


      

      subroutine dia_chgdst(hist,xs,qs)
c
      implicit none
c
#include "dia_common.fh"
c
      real*8 hist(2,ldist),xs(msa,3),qs(msa)
c
      integer i,j
      real*8 range,drange
c
      do 1 i=1,ldist
      hist(1,i)=0.0d0
      hist(2,i)=0.0d0
    1 continue
c
      range=xsmax(3)-xsmin(3)
      do 2 i=1,nsa
      j=int((dble(ldist)*(xs(i,3)-xsmin(3)))/range)+1
      if(j.gt.0.and.j.le.ldist) then
      if(qs(i).lt.0.0d0) then
      hist(1,j)=hist(1,j)+qs(i)
      else
      hist(2,j)=hist(2,j)+qs(i)
      endif
      endif
    2 continue
c
      drange=range/dble(ldist)
      if(me.eq.0) then
      write(lfnhis,1000) time,ldist
 1000 format(f12.6,i5)
      write(lfnhis,1001) (xsmin(3)+(dble(i)-0.5d0)*drange,
     + hist(1,i),hist(2,i),hist(1,i)+hist(2,i),i=1,ldist)
 1001 format(4f12.6)
      endif
c
      return
      end
c $Id: dia_chgdst.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_space_pack_init(isl,numsa,iwl,numwm)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer isl(msa,mis2),numsa,iwl(mwm,miw2),numwm
c
      integer i,j,k,intsiz
c
      intsiz=8*ma_sizeof(mt_int,1,mt_byte)-1
c
      do 1 i=1,mis2
      misl(i)=0
    1 continue
c
      do 2 j=1,mis2
      do 3 i=1,numsa
      misl(j)=max(misl(j),isl(i,j))
    3 continue
    2 continue
      misl(lsdyn)=max(15,misl(lsdyn))
      misl(lsbox)=nbtot
      misl(lsnod)=np
c
      call ga_igop(msp_24,misl,mis2,'max')
c
      do 4 i=1,mis2
      k=misl(i)
      do 5 j=1,intsiz
      k=rshift(k,1)
      if(k.eq.0) then
      nbits(i)=j+1
      goto 4
      endif
    5 continue
      nbits(i)=intsiz
    4 continue
c
      npack=1
      ipack(1)=1
      k=nbits(1)
      do 6 i=2,mis2
      if(k+nbits(i).lt.intsiz) then
      ipack(npack)=ipack(npack)+1
      k=k+nbits(i)
      else
      npack=npack+1
      ipack(npack)=1
      k=nbits(i)
      endif
    6 continue
c
      do 7 i=1,mis2
      misl(i)=2**nbits(i)-1
    7 continue
c
      do 8 i=1,miw2
      miwl(i)=0
    8 continue
c
      do 9 j=1,miw2
      do 10 i=1,numwm
      miwl(j)=max(miwl(j),iwl(i,j))
   10 continue
    9 continue
      miwl(lwdyn)=15
      miwl(lwbox)=nbtot
      miwl(lwnod)=np
c
      call ga_igop(msp_25,miwl,miw2,'max')
c
      do 11 i=1,miw2
      k=miwl(i)
      do 12 j=1,intsiz
      k=rshift(k,1)
      if(k.eq.0) then
      nbitw(i)=j+1
      goto 11
      endif
   12 continue
      nbitw(i)=intsiz
   11 continue
c
      npackw=1
      ipackw(1)=1
      k=nbitw(1)
      do 13 i=2,miw2
      if(k+nbitw(i).lt.intsiz) then
      ipackw(npackw)=ipackw(npackw)+1
      k=k+nbitw(i)
      else
      npackw=npackw+1
      ipackw(npackw)=1
      k=nbitw(i)
      endif
   13 continue
c
      do 14 i=1,miw2
      miwl(i)=2**nbitw(i)-1
   14 continue
c
      if(me.eq.0) then
      write(lfnout,1001)
 1001 format(/,' DATA PACKING',/)
      write(lfnout,1002) ' Packing solute in  ',npack,
     + ' integers : ',(ipack(i),i=1,npack)
 1002 format(a,i2,a,15i4)
      write(lfnout,1003) ' significant bits : ',
     + (nbits(i),i=1,mis2)
 1003 format(14x,a,15i4)
      write(lfnout,1002) ' Packing solvent in ',npackw,
     + ' integers : ',(ipackw(i),i=1,npackw)
      write(lfnout,1003) ' significant bits : ',
     + (nbitw(i),i=1,miw2)
      endif
c
      if(npack.eq.mis2) npack=0
      if(npackw.eq.miw2) npackw=0
c      npackw=0
c
      if(npack.gt.0) then
      if(.not.ma_push_get(mt_int,msa*npack,'lpack',l_pack,i_pack))
     + call md_abort('Failed to allocate memory for pack',0)
      endif
      if(npackw.gt.0) then
      if(.not.ma_push_get(mt_int,mwm*npackw,'lpackw',l_packw,i_packw))
     + call md_abort('Failed to allocate memory for packw',0)
      endif
c
      call argos_space_pack_ga(numsa,isl,int_mb(i_pack),
     + numwm,iwl,int_mb(i_packw))
c
      return
      end
c $Id: argos_space_pack_init.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_cenmas(numw,xw,xwm,nums,
     + isat,isml,xs,xsm,gsm)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer numw,nums
      real*8 xw(mwm,3,mwa),xwm(mwm,3)
      real*8 xs(msa,3),xsm(msm,3),gsm(msm,4,2)
      integer isat(msa),isml(msa)
c
      call argos_cafe_comw(xw,xwm,1,numw)
      call argos_cafe_coms(isat,isml,xs,xsm,gsm,1,nums)
c
      return
      end
c $Id: argos_cafe_cenmas.F 21176 2011-10-10 06:35:49Z d3y133 $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     XF3cI_Step3 -- Do the last step of the three-center integral 
C     transformation
C
C REVISION
C     $Id: xf3ci_step3.F 19697 2010-10-29 16:57:34Z d3y133 $
C
C SYNOPSIS
      Logical Function XF3cI_Step3(G_In, NAIn, NIIn,
     $   AInlo, AInhi, IInlo, IInhi, SInlo, SInHi,
     $   G_C, SOutLo, SOutHi,
     $   G_Out, NAOut, NIOut, AOut, IOut, SOut)
      Implicit NONE
      Integer NAIn, NIIn, AInLo, AInHi, IInLo, IInHi, SInlo, SInHi
      Integer SOutLo, SOutHi, NAOut, NIOut, AOut, IOut, SOut
      Integer G_In, G_C, G_Out
C
C ARGUMENTS
C     G_In     GA handle for incoming (ia|s) integrals [IN]
C     NAIn     Size of A range in G_In [IN]
C     NIIn     Size of I range in G_In [IN]
C     AInLo    Lower limit of A range in G_In to transform [IN]
C     AInHi    Upper limit of A range in G_In to transform [IN]
C     IInLo    Lower limit of I range in G_In to transform [IN]
C     IInHi    Upper limit of I range in G_In to transform [IN]
C     SInLo    Lower limit of S range in G_In to transform [IN]
C     SInHi    Upper limit of S range in G_In to transform [IN]
C     G_C      GA handle for fitting basis transformation matrix [IN]
C     SOutLo   Lower limit of S in columns of G_C or in G_Out [IN]
C     SOutHi   Upper limit of S in columns of G_C or in G_Out [IN]
C     G_Out    GA handle for resulting (ia|s') [IN]
C     NAOut    Size of A range in G_Out [IN]
C     NIOut    Size of I range in G_Out [IN]
C     AOut     Destination A in G_Out for transformed integrals [IN]
C     IOut     Destination I in G_Out for transformed integrals [IN]
C     SOut     Destination S in G_Out for transformed integrals [IN]
C
C RETURN VALUE
C     .TRUE.   Successful completion
C     .FALSE.  Error condition.  Could be in input, basis info queries,
C              or memory operations (MA or GA).
C DESCRIPTION
C     Performs the transformation on the fitting basis index of the
C     three center integrals.  Both input and output integral matrices
C     are organized with the combined (ia| index in the first dimension
C     and the fitting basis index |s) as the second dimension.  Selected
C     regions of the input matrix can be specified.
C
C     Note that because of the index collapse in the first dimension
C     of the integral matrices, it is necessary to ask for the individual
C     sizes of A and I in order to do the calculations.  But the size
C     of S can be determined from the global arrays themselves, to
C     they do not need to be input.
C
C LIMITATIONS
C     Currently the transformed region must be the entire matrix.  This
C     restriction can be lifted when GA_DGEMM is capable of working
C     with submatrices.
C
C INCLUDE FILES
#include "mafdecls.fh"
#include "global.fh"
#include "numerical_constants.fh"
#include "stdio.fh"
#include "rimp2_timers.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer NAXF, NIXF, NSXFOut, Dim1In, Dim1Out, Type,
     $  NCRow, NCCol, NSIn, NSOut
      Logical Status
C
C     This routine is essentially synchronous anyway because GA_DGEMM
C     is SIMD, so to be fair, we should include only the time after
C     everyone meets up here.
C
      Call GA_Sync
      Call PStat_On(PS_Step3)
C
C     For convenience, determine the size of the region to be transformed
C
      NAXF = AInHi - AInLo + 1
      NIXF = IInHi - IInLo + 1
      NSXFOut = SOutHi - SOutLo + 1
c$$$C
c$$$      Write (LuOut, *) 'Step3 inputs ', GA_NodeID(), NAIn, NIIn,
c$$$     $   AInLo, AInHi, IInLo, IInHi, SInLo, SInHi, SOutLo, SOutHi,
c$$$     $   NAOut, NIOut, AOut, IOut, SOut
C
C     *****************
C     * Sanity checks *
C     *****************
C     Verify that we've got good GA & basis set handles
C
      Call GA_Check_Handle ( G_In, 'XF3cI_Step3: Input integrals')
      Call GA_Check_Handle ( G_Out, 'XF3cI_Step3: Output integrals')
      Call GA_Check_Handle ( G_C, 'XF3cI_Step3: Transformation')
C
C     Verify that the dimensions declared are consistent with arguments
C     and obtain the size of the S dimension for everyone.
C
      Call GA_Inquire( G_In,  Type, Dim1In, NSIn)
      Call GA_Inquire( G_Out, Type, Dim1Out, NSOut)
      Call GA_Inquire( G_C,   Type, NCRow, NCCol)
C
      If ( Dim1In .lt. NAIn*NIIn .OR. Dim1Out .lt. NAOut*NIOut ) then
         Write (LuErr, *) 'XF3cI_Step3: Declared I and A ',
     $      'dimensions inconsistent with GA for G_In or G_Out.'
         XF3cI_Step3 = .FALSE.
         Return
      EndIf
C
C     Verify that the specified regions fall within the matrices
C
      Status = .TRUE.
      Status = Status .AND. AInLo .ge. 1 .AND. AInLo .le. NAIn
      Status = Status .AND. AInHi .ge. 1 .AND. AInHi .le. NAIn
      Status = Status .AND. IInLo .ge. 1 .AND. IInLo .le. NIIn
      Status = Status .AND. IInHi .ge. 1 .AND. IInHi .le. NIIn
      Status = Status .AND. SInLo .ge. 1 .AND. SInLo .le. NSIn
      Status = Status .AND. SInHi .ge. 1 .AND. SInHi .le. NSIn
C
      Status = Status .AND. SInHi .le. NCRow
      Status = Status .AND. SOutHi .ge. 1 .AND. SOutHi .le. NCCol
C
      Status = Status .AND. AOut .ge. 1 .AND. AOut .le. NAOut
      Status = Status .AND. IOut .ge. 1 .AND. IOut .le. NIOut
      Status = Status .AND. SOut .ge. 1 .AND. SOut .le. NSOut
      Status = Status .AND. AOut + NAXF - 1 .le. NAOut
      Status = Status .AND. IOut + NIXF - 1 .le. NIOut
      Status = Status .AND. SOut + NSXFOut - 1 .le. NSOut
C
      If ( .NOT. Status ) then
         Write (LuErr, *) 'XF3cI_Step3: Trans. region ',
     $      'inconsistent with dimensions: G_In, G_C, or G_Out.'
         XF3cI_Step3 = .FALSE.
         Return
      EndIf
C
C     For the time being, make sure we're not asked to do a submatrix
C     that isn't rooted at (1,1)
C
      Status = .TRUE.
      Status = Status .AND. AInLo .eq. 1 .AND. AInHi .eq. NAIn
      Status = Status .AND. IInLo .eq. 1 
      Status = Status .AND. SInLo .eq. 1 
C
      Status = Status .AND. SOutLo .eq. 1
C
      Status = Status .AND. AOut .eq. 1 .AND. IOut .eq. 1
     $   .AND. SOut .eq. 1
C
      If ( .NOT. Status ) then
         Write (LuErr, *) 'XF3cI_Step3: Cannot transform ',
     $      ' submatrices yet!'
         XF3cI_Step3 = .FALSE.
         Return
      EndIf
C
C     *****************************************
C     * A very straightforward operation here *
C     *****************************************
C
      Call GA_DGEMM('N', 'N', NAXF*NIXF, NSOut, NSIn, FP_One, G_In, G_C,
     $   FP_Zero, G_Out)
C
      Call PStat_Off(PS_Step3)
C
      XF3cI_Step3 = .TRUE.
C
      Return
      End

*> \brief \b STREXC
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download STREXC + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/strexc.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/strexc.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/strexc.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE STREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, WORK,
*                          INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          COMPQ
*       INTEGER            IFST, ILST, INFO, LDQ, LDT, N
*       ..
*       .. Array Arguments ..
*       REAL               Q( LDQ, * ), T( LDT, * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> STREXC reorders the real Schur factorization of a real matrix
*> A = Q*T*Q**T, so that the diagonal block of T with row index IFST is
*> moved to row ILST.
*>
*> The real Schur form T is reordered by an orthogonal similarity
*> transformation Z**T*T*Z, and optionally the matrix Q of Schur vectors
*> is updated by postmultiplying it with Z.
*>
*> T must be in Schur canonical form (as returned by SHSEQR), that is,
*> block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*> 2-by-2 diagonal block has its diagonal elements equal and its
*> off-diagonal elements of opposite sign.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] COMPQ
*> \verbatim
*>          COMPQ is CHARACTER*1
*>          = 'V':  update the matrix Q of Schur vectors;
*>          = 'N':  do not update Q.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix T. N >= 0.
*> \endverbatim
*>
*> \param[in,out] T
*> \verbatim
*>          T is REAL array, dimension (LDT,N)
*>          On entry, the upper quasi-triangular matrix T, in Schur
*>          Schur canonical form.
*>          On exit, the reordered upper quasi-triangular matrix, again
*>          in Schur canonical form.
*> \endverbatim
*>
*> \param[in] LDT
*> \verbatim
*>          LDT is INTEGER
*>          The leading dimension of the array T. LDT >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] Q
*> \verbatim
*>          Q is REAL array, dimension (LDQ,N)
*>          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
*>          On exit, if COMPQ = 'V', Q has been postmultiplied by the
*>          orthogonal transformation matrix Z which reorders T.
*>          If COMPQ = 'N', Q is not referenced.
*> \endverbatim
*>
*> \param[in] LDQ
*> \verbatim
*>          LDQ is INTEGER
*>          The leading dimension of the array Q.  LDQ >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] IFST
*> \verbatim
*>          IFST is INTEGER
*> \endverbatim
*>
*> \param[in,out] ILST
*> \verbatim
*>          ILST is INTEGER
*>
*>          Specify the reordering of the diagonal blocks of T.
*>          The block with row index IFST is moved to row ILST, by a
*>          sequence of transpositions between adjacent blocks.
*>          On exit, if IFST pointed on entry to the second row of a
*>          2-by-2 block, it is changed to point to the first row; ILST
*>          always points to the first row of the block in its final
*>          position (which may differ from its input value by +1 or -1).
*>          1 <= IFST <= N; 1 <= ILST <= N.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is REAL array, dimension (N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          = 1:  two adjacent blocks were too close to swap (the problem
*>                is very ill-conditioned); T may have been partially
*>                reordered, and ILST points to the first row of the
*>                current position of the block being moved.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup realOTHERcomputational
*
*  =====================================================================
      SUBROUTINE STREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, WORK,
     $                   INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ
      INTEGER            IFST, ILST, INFO, LDQ, LDT, N
*     ..
*     .. Array Arguments ..
      REAL               Q( LDQ, * ), T( LDT, * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            WANTQ
      INTEGER            HERE, NBF, NBL, NBNEXT
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLAEXC, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input arguments.
*
      INFO = 0
      WANTQ = LSAME( COMPQ, 'V' )
      IF( .NOT.WANTQ .AND. .NOT.LSAME( COMPQ, 'N' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.MAX( 1, N ) ) ) THEN
         INFO = -6
      ELSE IF( IFST.LT.1 .OR. IFST.GT.N ) THEN
         INFO = -7
      ELSE IF( ILST.LT.1 .OR. ILST.GT.N ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'STREXC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
*     Determine the first row of specified block
*     and find out it is 1 by 1 or 2 by 2.
*
      IF( IFST.GT.1 ) THEN
         IF( T( IFST, IFST-1 ).NE.ZERO )
     $      IFST = IFST - 1
      END IF
      NBF = 1
      IF( IFST.LT.N ) THEN
         IF( T( IFST+1, IFST ).NE.ZERO )
     $      NBF = 2
      END IF
*
*     Determine the first row of the final block
*     and find out it is 1 by 1 or 2 by 2.
*
      IF( ILST.GT.1 ) THEN
         IF( T( ILST, ILST-1 ).NE.ZERO )
     $      ILST = ILST - 1
      END IF
      NBL = 1
      IF( ILST.LT.N ) THEN
         IF( T( ILST+1, ILST ).NE.ZERO )
     $      NBL = 2
      END IF
*
      IF( IFST.EQ.ILST )
     $   RETURN
*
      IF( IFST.LT.ILST ) THEN
*
*        Update ILST
*
         IF( NBF.EQ.2 .AND. NBL.EQ.1 )
     $      ILST = ILST - 1
         IF( NBF.EQ.1 .AND. NBL.EQ.2 )
     $      ILST = ILST + 1
*
         HERE = IFST
*
   10    CONTINUE
*
*        Swap block with next one below
*
         IF( NBF.EQ.1 .OR. NBF.EQ.2 ) THEN
*
*           Current block either 1 by 1 or 2 by 2
*
            NBNEXT = 1
            IF( HERE+NBF+1.LE.N ) THEN
               IF( T( HERE+NBF+1, HERE+NBF ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, NBF, NBNEXT,
     $                   WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            HERE = HERE + NBNEXT
*
*           Test if 2 by 2 block breaks into two 1 by 1 blocks
*
            IF( NBF.EQ.2 ) THEN
               IF( T( HERE+1, HERE ).EQ.ZERO )
     $            NBF = 3
            END IF
*
         ELSE
*
*           Current block consists of two 1 by 1 blocks each of which
*           must be swapped individually
*
            NBNEXT = 1
            IF( HERE+3.LE.N ) THEN
               IF( T( HERE+3, HERE+2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE+1, 1, NBNEXT,
     $                   WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            IF( NBNEXT.EQ.1 ) THEN
*
*              Swap two 1 by 1 blocks, no problems possible
*
               CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1, NBNEXT,
     $                      WORK, INFO )
               HERE = HERE + 1
            ELSE
*
*              Recompute NBNEXT in case 2 by 2 split
*
               IF( T( HERE+2, HERE+1 ).EQ.ZERO )
     $            NBNEXT = 1
               IF( NBNEXT.EQ.2 ) THEN
*
*                 2 by 2 Block did not split
*
                  CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1,
     $                         NBNEXT, WORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE + 2
               ELSE
*
*                 2 by 2 Block did split
*
                  CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1, 1,
     $                         WORK, INFO )
                  CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE+1, 1, 1,
     $                         WORK, INFO )
                  HERE = HERE + 2
               END IF
            END IF
         END IF
         IF( HERE.LT.ILST )
     $      GO TO 10
*
      ELSE
*
         HERE = IFST
   20    CONTINUE
*
*        Swap block with next one above
*
         IF( NBF.EQ.1 .OR. NBF.EQ.2 ) THEN
*
*           Current block either 1 by 1 or 2 by 2
*
            NBNEXT = 1
            IF( HERE.GE.3 ) THEN
               IF( T( HERE-1, HERE-2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-NBNEXT, NBNEXT,
     $                   NBF, WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            HERE = HERE - NBNEXT
*
*           Test if 2 by 2 block breaks into two 1 by 1 blocks
*
            IF( NBF.EQ.2 ) THEN
               IF( T( HERE+1, HERE ).EQ.ZERO )
     $            NBF = 3
            END IF
*
         ELSE
*
*           Current block consists of two 1 by 1 blocks each of which
*           must be swapped individually
*
            NBNEXT = 1
            IF( HERE.GE.3 ) THEN
               IF( T( HERE-1, HERE-2 ).NE.ZERO )
     $            NBNEXT = 2
            END IF
            CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-NBNEXT, NBNEXT,
     $                   1, WORK, INFO )
            IF( INFO.NE.0 ) THEN
               ILST = HERE
               RETURN
            END IF
            IF( NBNEXT.EQ.1 ) THEN
*
*              Swap two 1 by 1 blocks, no problems possible
*
               CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, NBNEXT, 1,
     $                      WORK, INFO )
               HERE = HERE - 1
            ELSE
*
*              Recompute NBNEXT in case 2 by 2 split
*
               IF( T( HERE, HERE-1 ).EQ.ZERO )
     $            NBNEXT = 1
               IF( NBNEXT.EQ.2 ) THEN
*
*                 2 by 2 Block did not split
*
                  CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-1, 2, 1,
     $                         WORK, INFO )
                  IF( INFO.NE.0 ) THEN
                     ILST = HERE
                     RETURN
                  END IF
                  HERE = HERE - 2
               ELSE
*
*                 2 by 2 Block did split
*
                  CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE, 1, 1,
     $                         WORK, INFO )
                  CALL SLAEXC( WANTQ, N, T, LDT, Q, LDQ, HERE-1, 1, 1,
     $                         WORK, INFO )
                  HERE = HERE - 2
               END IF
            END IF
         END IF
         IF( HERE.GT.ILST )
     $      GO TO 20
      END IF
      ILST = HERE
*
      RETURN
*
*     End of STREXC
*
      END
c $Id: strexc.f 24343 2013-06-22 05:35:15Z d3y133 $

      SUBROUTINE ccsdtq_lambda3_11_2_3(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsdtq_lambda3_11_2_3.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h4 h11 h13 h16 )_vt + = 1/2 * Sum ( p7 p8 ) * t ( p7 p8 h13 h16 )_t * v ( h4 h11 p7 p8 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h11b
      INTEGER h13b
      INTEGER h16b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p8b
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER h13b_1
      INTEGER h16b_1
      INTEGER h4b_2
      INTEGER h11b_2
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h4b = 1,noab
      DO h11b = 1,noab
      DO h13b = 1,noab
      DO h16b = h13b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h11b-
     &1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h16b-1).ne.8)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h11b-1) .eq. int_mb(k_spin+
     &h13b-1)+int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_mb
     &(k_sym+h13b-1),int_mb(k_sym+h16b-1)))) .eq. ieor(irrep_v,irrep_t))
     & THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h11b-1) * int_mb(k_r
     &ange+h13b-1) * int_mb(k_range+h16b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_11_2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO p8b = p7b,noab+nvab
      IF (int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1) .eq. int_mb(k_spin+h
     &13b-1)+int_mb(k_spin+h16b-1)) THEN
      IF (ieor(int_mb(k_sym+p7b-1),ieor(int_mb(k_sym+p8b-1),ieor(int_mb(
     &k_sym+h13b-1),int_mb(k_sym+h16b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p7b,p8b,h13b,h16b,p7b_1,p8b_1,h13b_1,h16b_1)
      CALL TCE_RESTRICTED_4(h4b,h11b,p7b,p8b,h4b_2,h11b_2,p7b_2,p8b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1)
      dima_sort = int_mb(k_range+h13b-1) * int_mb(k_range+h16b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_11_2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda3_11_2_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h16b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (p8b_1 - noab - 1 + nvab * (p7
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+h13b-1),int_mb(k_range+h16b-
     &1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda3_11_2_3',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda3_11_2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda3_11_2_3',5,MA_ERR)
      IF ((h11b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h11b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+h4b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1
     &),1,2,4,3,-1.0d0)
      END IF
      IF ((h4b .le. h11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h11b_2 - 1 + (noa
     &b+nvab) * (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h11b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1
     &),2,1,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda3_11_2_3',6
     &,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p7b .eq. p8b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda3_11_2
     &_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda3_11_2
     &_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda3_11_2_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h11b-1
     &),int_mb(k_range+h4b-1),int_mb(k_range+h16b-1),int_mb(k_range+h13b
     &-1),2,1,4,3,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h16b 
     &- 1 + noab * (h13b - 1 + noab * (h11b - 1 + noab * (h4b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda3_11_2_3',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda3_11_2
     &_3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

c $Id: prepint.F 24347 2013-06-23 04:26:26Z d3y133 $
cccc  subroutine prepint2(bl,eps,inuc,ibas,na,nbf,nsh,ncf,ncs,inx,
      subroutine prepint2(bl,    inuc,ibas,na,nbf,nsh,ncf,ncs,inx,
     *                    lcore,maxprice,scftype)
c---------------------------------------------------------------
c EPS is not used here, threshold is now set by calling 
c texas_set_accy before texas_init is called.
c---------------------------------------------------------------
c dimensions for logical matrices in commons logicd,logic1-11 :
c
c up to ff,ff :
c     parameter (lpar1=14,lpar2= 455,lpar3= 364,lpar4=5,lpar5=13)
c up to gg,gg :
c     parameter (lpar1=18,lpar2= 969,lpar3= 816,lpar4=6,lpar5=17)
c up to hh,hh :
c     parameter (lpar1=22,lpar2=1771,lpar3=1540,lpar4=7,lpar5=21)
c up to ii,ii :
c     parameter (lpar1=26,lpar2=2925,lpar3=2600,lpar4=8,lpar5=25)
c up to jj,jj :
c     parameter (lpar1=30,lpar2=4495,lpar3=4060,lpar4=9,lpar5=29)
c up to kk,kk (which is ii,ii + 2 )
cold      parameter (lpar1=34,lpar2=6545,lpar3=5984,lpar4=10,lpar5=33)
c up to ll,ll :
c     parameter (lpar1=38,lpar2=9139,lpar3=8436,lpar4=11,lpar5=37)
c up to mm,mm :
c     parameter (lpar1=42,lpar2=12341,lpar3=11480,lpar4=12,lpar5=41)
c---------------------------------------------------------------
c
      implicit real*8 (a-h,o-z)
      logical firstd
      character*11 scftype
c
      common /number/ zero,half,one,two,three,four,five,ten,ten6,tenm8,p
     1i,acc
c
#include "texas_lpar.fh"
cxx
      common /cpu/ intsize,iacc,icache,memreal
      common /infor/ icheck,firstd,ndirect,nprint,iblok,nbeg,nend
      common /infob/ inucx,ibasx,nax,nbfx,nshx,ncfx,ncsx
c
      common /memor1b/ nbl2
      common /memor2/ nqrtd, nibld,nkbld, nijbd,nijed, nklbd,nkled
c
      common /memors/ nsymx,ijshp,isymm
c----------------------------------------------------------------
c
      dimension bl(*)
      dimension inx(12,*)
c
c----------------------------------------------------------
c
      call txs_second(tim1)
c
c----------------------------------------------------------
c set up integral threshold :
c
c      call setup_thres(eps) 
c now done in texas_set_accy which calls setup_thresh() routine 
c----------------------------------------------------------
c setup the infob common :
c
      inucx=inuc
      ibasx=ibas 
      nax  =na
      nbfx =nbf
      nshx =nsh
      ncfx =ncf
      ncsx =ncs
c
cnew  nsymx=nsym
      nsymx=0
c----------------------------------------------------------
       call fprep
c
c----------------------------------------------------------
c setup logical matrices - old logobsa; common  /logicd/, logic1-11/
c
       call datlog(inx,ncs,lpar1,lpar2,lpar3,lpar4,lpar5)
c
c----------------------------------------------------------
c blocking procedure for pairs of contracted shells
c
       call txs_second(tim3)
       call blockin2(bl,lcore,inx,nbl2)
c
       call txs_second(tim4)
       timblok2=tim4-tim3
c
c----------------------------------------------------------
c
      call txs_second(tim2)
      timprep2=tim2-tim1
c
      end
c================================================================
c
      subroutine timepr(tblock)
      implicit real*8 (a-h,o-z)
c
      common /timex/ tconv1,tconv2,ttrobs
      common /time0/ tprec2
      common /time1/ tpre4n,txwpq ,tassem,tamshf,tdesti
      common /time2/ terint,ttrans
      common /time3/ tzeroi,tspeci
      common /time4/ tderiv
      common /time5/ tcheck,tuniq2,tmap4u
c
      data zero /0.d0/
c
      if(tblock.eq.zero) then
ctime
        tprec2=zero
        tconv1=zero
        tconv2=zero
        ttrobs=zero
        tpre4n=zero
        txwpq =zero
        tassem=zero
        tamshf=zero
        tdesti=zero
        terint=zero
        tzeroi=zero
        tspeci=zero
        ttrans=zero
        tderiv=zero
c
        tcheck=zero   
        tuniq2=zero   
        tmap4u=zero
ctime
      else
c
        write(8,120) tblock,tprec2,
     *                             tpre4n,tzeroi,txwpq,tconv1,tconv2,
     *                             ttrobs,tassem,tderiv,tamshf,ttrans,
     *               terint,tspeci,
     *               tblock+tprec2+terint+tspeci,      ! calculation
     *                             tuniq2,tmap4u,tcheck,tdesti,
     *               tuniq2+tmap4u+tcheck+tdesti,      ! interface
     *       tblock+tprec2+terint+tspeci + tuniq2+tmap4u+tcheck+tdesti 
c     call util_flush(8)
  120 format(
     *       '========================================================'/
     *       '                                                        '/
     *       'T I M I N G  O F  T E X A S  S U B R O U T I N E S (sec)'/
     *       '                                                        '/
     *       '========================================================'/
     *       'time for BLOCKIN=',f10.1/
     *       '--------------------------------------------------------'/
     *       'time for PRECALC=',f10.1/
     *       '--------------------------------------------------------'/
     *       '                             time for prec4n =',f10.1/   
     *       '                             time for zeroin =',f10.1/   
     *       '                             time for xwpq   =',f10.1/   
     *       '                             time for conv1x =',f10.1/   
     *       '                             time for conv2x =',f10.1/   
     *       '                             time for trobsa =',f10.1/   
     *       '                             time for assemb =',f10.1/   
     *       '                             time for derivx =',f10.1/   
     *       '                             time for amshif =',f10.1/   
     *       '                             time for transf =',f10.1/   
     *       '                             ---------------------------'/
     *       'time for ERINTEG=',f10.1/
     *       '--------------------------------------------------------'/
     *       'time for ERINTSP=',f10.1/
     *       '========================================================'/
     *       'CALCULATION TIME=',f10.1,'   (pure texas calculations)  '/
     *       '========================================================'/
     *       '                             time for uniq_pa=',f10.1/   
     *       '                             time for map2uni=',f10.1/   
     *       '                             time for checkio=',f10.1/   
     *       '                             time for destiny=',f10.1/   
     *       '                             ---------------------------'/
     *       'INTERFACE   TIME=',f10.1,'   (internal interface)       '/
     *       '========================================================'/
     *       'TOTAL TEXAS TIME=',f10.1/
     *       '========================================================')
c
      endif
c
      end
c================================================================
      subroutine setup_thresh(thres)
      implicit real*8 (a-h,o-z)
c----------------------------------------------------------------
c Set up the integral threshold :
c----------------------------------------------------------------
c Estimator1=16/(pi)**1/2 * Sab*Scd * 1/(a+b+c+d)**1/2
c
c  where Sab=(a+b)**-1 * (a*b)**+3/4 *exp(-ab/(a+b) * Rab**2 )
c
c
c    Estimator1 > eps    do integrals .
c
c It is done in a quadratic form by  Es1*Es1> eps**2
c
c    Sab**2  *  Scd**2 > pi/256 * eps**2  * (a+b+c+d)
c
c  epsr= pi/256 * eps**2
c
c  eps =eps -original thresh. for integrals,
c  eps1=1/eps  used to rescale integr. in precalc2a subroutine
c  epsr=pi/256 *eps**2-used in prec4neg and precspec subroutines.
c----------------------------------------------------------------
c pi256=pi/256
c
      common /neglect/ eps,eps1,epsr
      data one,pi256 /1.d0 , 0.012271846d0 /
c
      eps =thres
      eps1=one/eps
      epsr=pi256*eps*eps
c
ccc   write(6,*)' integ thresh from setup_thresh()=',eps
c----------------------------------------------------------
      end

      subroutine smd_vlist_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_vlist,sp_exlist,sp_coords
      character*32 tag,pname
      logical result
      logical oexlist

      pname = "smd_vlist_init_system"
c
      tag = "coordinates"
      call smd_system_get_component(sp_coords,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      oexlist = .true.
      tag = "excl_list"
      call smd_system_get_component(sp_exlist,tag,result)
      if(.not.result) oexlist = .false.

      tag = "verlet_list"
      call smd_system_get_component(sp_vlist,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_vlist_init(oexlist,sp_vlist,sp_exlist,sp_coords)
c
      return
      end

      subroutine smd_vlist_init(oexlist,sp_vlist,sp_exlist,sp_coord)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_vlist
      character*(*) sp_exlist
      character*(*) sp_coord
      logical oexlist
c
      character*32 pname
      character*80 tag
      integer np,nl
      integer i_p,i_l,i_c
      integer h_l
      integer i_list,i_clist
      integer i
      integer i_xp,i_xl
      integer i_cl,h_cl
      integer i_ct,h_ct
      double precision rc2
      integer nlb
      logical result
c
      pname = "smd_vlist_init"
c
c      write(*,*) "in "//pname
c
c     get coordinate information
c     --------------------------
      tag = "coords"
      call smd_data_get_index(sp_coord,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      call smd_data_get_size(sp_coord,tag,np,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for'//tag,0, RTDB_ERR)
      np = np/3
c
c     get excluded list information
c     -----------------------------
      if(oexlist) then
      tag = "exlist:pointer"
      call smd_data_get_index(sp_exlist,tag,i_xp,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      tag = "exlist:list"
      call smd_data_get_index(sp_exlist,tag,i_xl,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      end if
c
c     gestimate the size of pair list
c     ------------------------------
      nl =  min( 7*np*200, ma_inquire_avail(MT_INT))
      nl = nl/7
c
c     create pointer memory
c     ---------------------
      call smd_namespace_create(sp_vlist)
      tag = "vlist:pointer"
      call smd_data_create(sp_vlist,"vlist:pointer",np,MT_INT)
      call smd_data_get_index(sp_vlist,tag,i_p,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

c
c    create temporary scratch array for list since
c    we do not know the size yet
c    ---------------------------------------------
      if(.not.ma_push_get(mt_int,nl,'tmp l',h_l,i_l))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nl, MA_ERR)

      if(.not.ma_push_get(mt_dbl,3*nl,'tmp cl',h_cl,i_cl))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nl, MA_ERR)

      if(.not.ma_push_get(mt_dbl,3*np,'tmp',h_ct,i_ct))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nl, MA_ERR)


      call smd_cutoff_get_rcut_verlet(rc2)
      rc2=rc2*rc2

      if(oexlist) then
      call smd_vlist_set(np,
     +                   nl,
     +                   rc2,
     +                   dbl_mb(i_c),
     +                   int_mb(i_xp),
     +                   int_mb(i_xl),
     +                   int_mb(i_p),
     +                   int_mb(i_l),
     +                   dbl_mb(i_cl),
     +                   dbl_mb(i_ct),
     +                   result)

      else

      call smd_vlist_set1(np,
     +                   nl,
     +                   rc2,
     +                   dbl_mb(i_c),
     +                   int_mb(i_p),
     +                   int_mb(i_l),
     +                   dbl_mb(i_cl),
     +                   dbl_mb(i_ct),
     +                   result)


      end if
c
c     create list memory
c     nl now contains the actual size
c     we will buffer it though to allow for possible expansion
c     --------------------------------------------------------
      nlb = 500
      tag = "vlist:list"
      call smd_data_create(sp_vlist,tag,nl+nlb,MT_INT)
      call smd_data_get_index(sp_vlist,tag,i_list,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)


      do i=1,nl
       int_mb(i_list+i-1) = int_mb(i_l+i-1)
      end do 

      tag = "vlist:distances"
      call smd_data_create(sp_vlist,tag,3*(nl+nlb),MT_DBL)
      call smd_data_get_index(sp_vlist,tag,i_clist,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "vlist:displacement"
      call smd_data_create(sp_vlist,tag,3*np,MT_DBL)
 
      do i=1,3*nl
       dbl_mb(i_clist+i-1) = dbl_mb(i_cl+i-1)
      end do 
       
      if(.not.ma_pop_stack(h_ct))
     & call errquit(pname//'Failed to deallocate stack h_l',nl,
     &       MA_ERR)

     
      if(.not.ma_pop_stack(h_cl))
     & call errquit(pname//'Failed to deallocate stack h_l',nl,
     &       MA_ERR)


      if(.not.ma_pop_stack(h_l))
     & call errquit(pname//'Failed to deallocate stack h_l',nl,
     &       MA_ERR)


      return
      end
c
      subroutine smd_vlist_update(olist,ocoord)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      logical olist
      logical ocoord
c
      character*32 sp_vlist
      character*32 sp_exlist
      character*32 sp_coord
c
      character*32 pname
      character*80 tag
      integer np,nl
      integer i_p,i_l,i_c
      integer h_l
      integer i_list,i_clist
      integer i
      integer i_xp,i_xl
      double precision rc2
      integer nlb
      logical result
      integer i_ct,h_ct
      logical oexlist 
c
      pname = "smd_vlist_update"
c
c      write(*,*) "in "//pname
c
      if((.not.olist).and.(.not.ocoord)) return
c
c     get components
c     --------------
      tag = "coordinates"
      call smd_system_get_component(sp_coord,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      oexlist = .true.
      tag = "excl_list"
      call smd_system_get_component(sp_exlist,tag,result)
      if(.not.result) oexlist =.false.

      tag = "verlet_list"
      call smd_system_get_component(sp_vlist,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

c
      if(.not.olist) then
        call smd_vlist_update_coord(sp_vlist,sp_coord)
        goto 200
      end if
c
c     get coordinate information
c     --------------------------
      tag = "coords"
      call smd_data_get_index(sp_coord,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
       
      call smd_data_get_size(sp_coord,tag,np,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for'//tag,0, RTDB_ERR)
      np = np/3
c
c     get excluded list information
c     -----------------------------
      if(oexlist) then
      tag = "exlist:pointer"
      call smd_data_get_index(sp_exlist,tag,i_xp,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      tag = "exlist:list"
      call smd_data_get_index(sp_exlist,tag,i_xl,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      end if
c
c     get verlet list information
c     ---------------------------
      tag = "vlist:pointer"
      call smd_data_get_index(sp_vlist,tag,i_p,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "vlist:list"
      call smd_data_get_index(sp_vlist,tag,i_list,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      call smd_data_get_size(sp_vlist,tag,nl,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for'//tag,0, RTDB_ERR)
 
      tag = "vlist:distances"
      call smd_data_get_index(sp_vlist,tag,i_clist,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
c
c    create temporary scratch array for list
c    ---------------------------------------------

      if(.not.ma_push_get(mt_dbl,3*np,'tmp',h_ct,i_ct))
     + call errquit(pname//'Failed to allocate memory for tmp l',
     + nl, MA_ERR)


      call smd_cutoff_get_rcut_verlet(rc2)
      rc2=rc2*rc2

      if(oexlist) then
      call smd_vlist_set(np,
     +                   nl,
     +                   rc2,
     +                   dbl_mb(i_c),
     +                   int_mb(i_xp),
     +                   int_mb(i_xl),
     +                   int_mb(i_p),
     +                   int_mb(i_list),
     +                   dbl_mb(i_clist),
     +                   dbl_mb(i_ct),
     +                   result)

      else

      call smd_vlist_set1(np,
     +                   nl,
     +                   rc2,
     +                   dbl_mb(i_c),
     +                   int_mb(i_p),
     +                   int_mb(i_list),
     +                   dbl_mb(i_clist),
     +                   dbl_mb(i_ct),
     +                   result)


      end if
       
      if(.not.ma_pop_stack(h_ct))
     & call errquit(pname//'Failed to deallocate stack h_l',nl,
     &       MA_ERR)


200   continue
      return
      end
c
      subroutine smd_vlist_update_coord(sp_vlist,sp_coord)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) sp_vlist
      character*(*) sp_coord
c
      character*32 pname
      character*80 tag
      integer np,nl
      integer i_p,i_l,i_c
      integer i_list,i_clist
      integer i_cl
      logical result
c
      pname = "smd_vlist_init"
c
c      write(*,*) "in "//pname
c
c     get coordinate information
c     --------------------------
      tag = "coords"
      call smd_data_get_index(sp_coord,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      call smd_data_get_size(sp_coord,tag,np,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for'//tag,0, RTDB_ERR)
      np = np/3
c
c     get list information
c     --------------------
      tag = "vlist:pointer"
      call smd_data_get_index(sp_vlist,tag,i_p,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "vlist:list"
      call smd_data_get_index(sp_vlist,tag,i_list,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)


      tag = "vlist:distances"
      call smd_data_get_index(sp_vlist,tag,i_clist,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      nl = int_mb(i_p+np-1) - int_mb(i_p)
      call smd_vlist_update_coord0(np,nl,
     +                   dbl_mb(i_c),
     +                   int_mb(i_p),
     +                   int_mb(i_l),
     +                   dbl_mb(i_cl))

      call smd_lat_rebox(nl,dbl_mb(i_clist))

      return
      end
c
      subroutine smd_vlist_update_coord0(np,nl,c,point,
     >                         list,cl)
c
c     update coordinates in verlet pair list
c     point(i) is an index to list() array
c     that contains all the pairs of atom i
c     In other words all the atoms paired with atom i
c     are contained in list(point(i)),...,list(point(i+1)-1)
c     np     [in]  number of atoms (which is also size of pointer array)
c     nl     [in]  list size
c     c      [in]  coordinates
c     point  [in] verlet pointer
c     list   [in] verlet list
c     cl     [out] list of vectors (ri-rj)
      implicit none
#include "errquit.fh"
      integer np,nl
      double precision c(np,3)
      integer point(np)
      integer list(nl)
      double precision cl(nl,3)
c
      integer i,j
      integer nlist
      integer jnab,jbeg,jend

      character*30 pname
 
      pname = "smd_vlist_update_coord0"

      nlist=0
      do i=1,np-1
       jbeg=point(i)
       jend=point(i+1)-1

       if(jbeg.le.jend)then

        do jnab=jbeg,jend

         j=list(jnab)

         nlist = nlist + 1
         if(nlist.gt.nl)
     >       call errquit(
     >       pname//'out of bounds',0, RTDB_ERR)

         cl(nlist,1)=c(i,1)-c(j,1)
         cl(nlist,2)=c(i,2)-c(j,2)
         cl(nlist,3)=c(i,3)-c(j,3)

        enddo

       end if
      enddo


200   continue
      return

      END
c
      subroutine smd_vlist_set(np,nl,vcutsq,c,xp,xl,point,
     >                         list,cl,ct,result)
c
c     constructs verlet pairt list
c     point(i) is an index to list() array
c     that contains all the pairs of atom i
c     In other words all the atoms paired with atom i
c     are contained in list(point(i)),...,list(point(i+1)-1)
c     np     [in]  number of atoms (which is also size of pointer array)
c     nl     [inout] size of verlet list 
c     c      [in]  coordinates
c     xp     [in]  excluded pointer 
c     xl     [in]  excluded list
c     point  [out] verlet pointer
c     list   [out] verlet list
c     cl     [out] list of vectors (ri-rj)
c     result [out] status of subroutine
      implicit none
#include "errquit.fh"
      integer np
      integer nl
      double precision vcutsq
      double precision c(np,3)
      integer xp(np)
      integer xl(*)
      integer point(np)
      integer list(nl)
      double precision cl(nl,3)
      double precision ct(np,3)
      logical result
c
      integer i,j,k
      integer nlist
      integer eatm
      double precision rij(3),rijsq,cc(1,3)

      character*30 pname
 
      pname = "smd_vlist_set"

      result = .false.
      nlist=0

c      write(*,*) "vcutsq=",vcutsq
      do i=1,np-1

       point(i)=nlist+1
       if(xp(i).ne.xp(i+1))eatm=xp(i)

       k = 0
       do j=i+1,np

         k = k +1
         ct(k,1)=c(i,1)-c(j,1)
         ct(k,2)=c(i,2)-c(j,2)
         ct(k,3)=c(i,3)-c(j,3)

       end do


       call smd_lat_rebox(np,ct)


       k = 0
       do j=i+1,np

        k = k + 1
        if((xp(i).ne.xp(i+1)).and.(xl(eatm).eq.j))then

         eatm=min(eatm+1,(xp(i+1)-1))

        else

         rij(1)=ct(k,1)
         rij(2)=ct(k,2)
         rij(3)=ct(k,3)

         rijsq=rij(1)*rij(1)+rij(2)*rij(2)+rij(3)*rij(3)


         if(rijsq.lt.vcutsq)then

          nlist=nlist+1

          if(nlist.gt.nl)then
           result = .false.
           goto 200
          endif

          list(nlist)=j
          cl(nlist,1)=rij(1)
          cl(nlist,2)=rij(2)
          cl(nlist,3)=rij(3)

         endif

        endif

       enddo

      enddo

      point(np)=nlist+1

      nl = nlist

      result = .true.

200   continue
      return

      END

      subroutine smd_vlist_set1(np,nl,vcutsq,c,point,
     >                         list,cl,ct,result)
c
c     constructs verlet pairt list
c     point(i) is an index to list() array
c     that contains all the pairs of atom i
c     In other words all the atoms paired with atom i
c     are contained in list(point(i)),...,list(point(i+1)-1)
c     np     [in]  number of atoms (which is also size of pointer array)
c     nl     [inout] size of verlet list 
c     c      [in]  coordinates
c     xp     [in]  excluded pointer 
c     xl     [in]  excluded list
c     point  [out] verlet pointer
c     list   [out] verlet list
c     cl     [out] list of vectors (ri-rj)
c     result [out] status of subroutine
      implicit none
#include "errquit.fh"
      integer np
      integer nl
      double precision vcutsq
      double precision c(np,3)
      integer point(np)
      integer list(nl)
      double precision cl(nl,3)
      double precision ct(np,3)
      logical result
c
      integer i,j,k
      integer nlist
      integer eatm
      double precision rij(3),rijsq,cc(1,3)

      character*30 pname
 
      pname = "smd_vlist_set"

      result = .false.
      nlist=0

c      write(*,*) "vcutsq=",vcutsq
      do i=1,np-1

       point(i)=nlist+1

       k = 0
       do j=i+1,np

         k = k +1
         ct(k,1)=c(i,1)-c(j,1)
         ct(k,2)=c(i,2)-c(j,2)
         ct(k,3)=c(i,3)-c(j,3)

       end do


       call smd_lat_rebox(np,ct)


       k = 0
       do j=i+1,np

        k = k + 1

         rij(1)=ct(k,1)
         rij(2)=ct(k,2)
         rij(3)=ct(k,3)

         rijsq=rij(1)*rij(1)+rij(2)*rij(2)+rij(3)*rij(3)


         if(rijsq.lt.vcutsq)then

          nlist=nlist+1

          if(nlist.gt.nl)then
           result = .false.
           goto 200
          endif

          list(nlist)=j
          cl(nlist,1)=rij(1)
          cl(nlist,2)=rij(2)
          cl(nlist,3)=rij(3)

         endif

       enddo

      enddo

      point(np)=nlist+1

      nl = nlist

      result = .true.

200   continue
      return

      END

      SUBROUTINE smd_vlist_test(lupdate)
      implicit none
#include "smd_system.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c 
      logical lupdate
c
      integer na
      integer i_v,i_vd
      double precision t
      character*72 sp_vel
      character*72 sp_vlist
      logical result
      character*72 tag
      character*30 pname
      double precision vcut,rcut
c
      pname = "smd_vlist_test"
c
c     get velocity aray
c     -----------------
      tag = "velocity"
      call smd_system_get_component(sp_vel,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "vel"
      call smd_data_get_index(sp_vel,tag,i_v,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      call  smd_data_get_size(sp_vel,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
      na = na/3
c
c     get time step
c     ------------
      if(.not.smd_system_tstep(t)) 
     >  call errquit(
     >       pname//'no time step ',0,0)

c
c     get verlet displacement array
c     -----------------------------
      tag = "verlet_list"
      call smd_system_get_component(sp_vlist,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "vlist:displacement"
      call smd_data_get_index(sp_vlist,tag,i_vd,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, 0)
 
       call smd_cutoff_get_rcut(rcut)
       call smd_cutoff_get_rcut_verlet(vcut)

       call smd_vlist_test0(na,t,rcut,vcut,
     >     dbl_mb(i_vd),dbl_mb(i_v),lupdate)

      return

      END

      SUBROUTINE smd_vlist_test0(natms,tstep,rcut,vcut,ivv,vvv,lupdate)

      implicit none
c
      integer natms
      double precision rcut,vcut
      double precision tstep
      logical lupdate
      double precision ivv(natms,3)
      double precision vvv(natms,3)
c
      integer i,exceed

      double precision  tstepsq
      double precision  dispmax,dispxsq,dispysq,dispzsq,disprsq 

      logical lnew

      data lnew/.true./

      save lnew

      tstepsq=tstep**2

      if(lnew)then

       lupdate=.true.
       lnew=.false.

       do i=1,natms

        ivv(i,1)=0.0
        ivv(i,2)=0.0
        ivv(i,3)=0.0

       enddo

      else

       lupdate=.false.

       dispmax=((vcut-rcut)/2.0)**2

       do i=1,natms

        ivv(i,1)=ivv(i,1)+vvv(i,1)
        ivv(i,2)=ivv(i,2)+vvv(i,2)
        ivv(i,3)=ivv(i,3)+vvv(i,3)

       enddo

       exceed=0

       do i=1,natms

        dispxsq=ivv(i,1)**2
        dispysq=ivv(i,2)**2
        dispzsq=ivv(i,3)**2
        disprsq=tstepsq*(dispxsq+dispysq+dispzsq)
        if(disprsq.gt.dispmax) then
          exceed=exceed+1
          write(*,*) "verlet update disp",disprsq,dispmax
        end if
        if(exceed.ge.2)lupdate=.true.

       enddo

       if(lupdate)then

        do i=1,natms

         ivv(i,1)=0
         ivv(i,2)=0
         ivv(i,3)=0

        enddo

       endif

      endif

      return

      END
c $Id: smd_vlist.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine argos_cafe_lpfrog_bc(iwdt,xw,yw,vw,vwt,fw,numw,
     + isdt,isat,xs,ys,vs,vst,fs,nums,iwat,wgt,iwgmn,isgan)
c
c     leap frog variant by Brown and Clarke, Mol.Phys., 51, 1243 (1984)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
c
      integer numw,nums
      integer iwdt(mwm),isdt(msa),isat(msa),isgan(msa),iwgmn(mwm)
      real*8 xw(mwm,3,mwa),yw(mwm,3,mwa)
      real*8 vw(mwm,3,mwa),vwt(mwm,3,mwa),fw(mwm,3,mwa)
      real*8 xs(msa,3),ys(msa,3),vs(msa,3),vst(msa,3),fs(msa,3)
      integer iwat(mwa)
      real*8 wgt(mat,mset)
c
      integer iwa,iwm,isa
      real*8 factor,chi,ekin(2)
c
      if(numw.gt.0) then
      do 1 iwa=1,mwa
      factor=tstep/wgt(iwat(iwa),iset)
      do 2 iwm=1,numw
      yw(iwm,1,iwa)=xw(iwm,1,iwa)
      yw(iwm,2,iwa)=xw(iwm,2,iwa)
      yw(iwm,3,iwa)=xw(iwm,3,iwa)
      if(iand(iwdt(iwm),mfixed).eq.lfixed) then
      vw(iwm,1,iwa)=zero
      vw(iwm,2,iwa)=zero
      vw(iwm,3,iwa)=zero
      vwt(iwm,1,iwa)=zero
      vwt(iwm,2,iwa)=zero
      vwt(iwm,3,iwa)=zero
      else
      vwt(iwm,1,iwa)=vw(iwm,1,iwa)+half*fw(iwm,1,iwa)*factor
      vwt(iwm,2,iwa)=vw(iwm,2,iwa)+half*fw(iwm,2,iwa)*factor
      vwt(iwm,3,iwa)=vw(iwm,3,iwa)+half*fw(iwm,3,iwa)*factor
      endif
    2 continue
    1 continue
      endif
c
      if(nums.gt.0) then
      do 3 isa=1,nums
      factor=tstep/wgt(isat(isa),iset)
      ys(isa,1)=xs(isa,1)
      ys(isa,2)=xs(isa,2)
      ys(isa,3)=xs(isa,3)
      if(iand(isdt(isa),mfixed).eq.lfixed) then
      vs(isa,1)=zero
      vs(isa,2)=zero
      vs(isa,3)=zero
      vst(isa,1)=zero
      vst(isa,2)=zero
      vst(isa,3)=zero
      else
      vst(isa,1)=vs(isa,1)+half*fs(isa,1)*factor
      vst(isa,2)=vs(isa,2)+half*fs(isa,2)*factor
      vst(isa,3)=vs(isa,3)+half*fs(isa,3)*factor
      endif
    3 continue
      endif
c
      call argos_cafe_tw(vwt,numw,iwat,dbl_mb(i_mas),ekin(1))
      call argos_cafe_ts(vst,nums,isat,dbl_mb(i_mas),ekin(2))
c
      call ga_dgop(mcf_65,ekin,2,'+')
c
      chi=sqrt(tmpext/(factmp*(ekin(1)+ekin(2))))
c
      if(numw.gt.0) then
      do 4 iwa=1,mwa
      factor=tstep/wgt(iwat(iwa),iset)
      do 5 iwm=1,numw
      if(iand(iwdt(iwm),mfixed).ne.lfixed) then
      vw(iwm,1,iwa)=(two*chi-one)*vw(iwm,1,iwa)+chi*fw(iwm,1,iwa)*factor
      vw(iwm,2,iwa)=(two*chi-one)*vw(iwm,2,iwa)+chi*fw(iwm,2,iwa)*factor
      vw(iwm,3,iwa)=(two*chi-one)*vw(iwm,3,iwa)+chi*fw(iwm,3,iwa)*factor
      xw(iwm,1,iwa)=yw(iwm,1,iwa)+vw(iwm,1,iwa)*tstep
      xw(iwm,2,iwa)=yw(iwm,2,iwa)+vw(iwm,2,iwa)*tstep
      xw(iwm,3,iwa)=yw(iwm,3,iwa)+vw(iwm,3,iwa)*tstep
      endif
    5 continue
    4 continue
      endif
c
      if(nums.gt.0) then
      do 6 isa=1,nums
      factor=tstep/wgt(isat(isa),iset)
      if(iand(isdt(isa),mfixed).ne.lfixed) then
      vs(isa,1)=(two*chi-one)*vs(isa,1)+chi*fs(isa,1)*factor
      vs(isa,2)=(two*chi-one)*vs(isa,2)+chi*fs(isa,2)*factor
      vs(isa,3)=(two*chi-one)*vs(isa,3)+chi*fs(isa,3)*factor
      xs(isa,1)=xs(isa,1)+vs(isa,1)*tstep
      xs(isa,2)=xs(isa,2)+vs(isa,2)*tstep
      xs(isa,3)=xs(isa,3)+vs(isa,3)*tstep
      endif
    6 continue
      endif
c
      return
      end
c $Id: argos_cafe_lpfrog_bc.F 21176 2011-10-10 06:35:49Z d3y133 $

c
c $Id: frce_shrt.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE frce_shrt(iii,ntype,rij,rijsq,jbeg,jend,evdw)

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'p_const.inc'
      include 'cm_atom.inc'
      include 'cm_vlst.inc'
      include 'cm_pote.inc'
      include 'cm_cuto.inc'

      integer iii,i,j,k,l
      integer ntype,potindex
      integer jbeg,jend,imin,imax,idif

      real*8  evdw,rij,drij,rijsq,force

      dimension rij(mxnlist,3),rijsq(mxnlist)

      write(24,*) "printing vdw"
      evdw=0.0
      k=0

      do i=jbeg,jend

       j=list(i)
       k=k+1

       if(rijsq(k).lt.rcutsq)then

        drij=sqrt(rijsq(k))

        imin=min(atmtype(iii),atmtype(j))
        imax=max(atmtype(iii),atmtype(j))
        idif=imax-imin

        potindex=0
        do l=1,imin-1
         potindex=potindex+(ntype-l+1)
        enddo
        potindex=potindex+idif+1

        if(potkey(potindex).eq.1)then

         evdw=evdw+(potpar(potindex,1)/drij**12
     $             -potpar(potindex,2)/drij**6)

         force=(12*potpar(potindex,1)/drij**12
     $          -6*potpar(potindex,2)/drij**6)/rijsq(k)
         write(24,*) drij,rijsq(k)
         fff(iii,1)=fff(iii,1)+convfct2*force*rij(k,1)
         fff(iii,2)=fff(iii,2)+convfct2*force*rij(k,2)
         fff(iii,3)=fff(iii,3)+convfct2*force*rij(k,3)

         fff(j,1)=fff(j,1)-convfct2*force*rij(k,1)
         fff(j,2)=fff(j,2)-convfct2*force*rij(k,2)
         fff(j,3)=fff(j,3)-convfct2*force*rij(k,3)

        elseif(potkey(potindex).eq.2)then

         evdw=evdw+(potpar(potindex,1)
     $              *exp(-drij/potpar(potindex,2))
     $              -potpar(potindex,3)/drij**6)

         force=(drij*potpar(potindex,1)
     $         *exp(-drij/potpar(potindex,2))
     $         /potpar(potindex,2)-6*potpar(potindex,3)/drij**6)
     $         /rijsq(k)

         fff(iii,1)=fff(iii,1)+convfct2*force*rij(k,1)
         fff(iii,2)=fff(iii,2)+convfct2*force*rij(k,2)
         fff(iii,3)=fff(iii,3)+convfct2*force*rij(k,3)

         fff(j,1)=fff(j,1)-convfct2*force*rij(k,1)
         fff(j,2)=fff(j,2)-convfct2*force*rij(k,2)
         fff(j,3)=fff(j,3)-convfct2*force*rij(k,3)

        endif

       endif

      enddo

      return

      END

c $Id: ga_it2.F 25283 2014-02-25 01:05:48Z d3y133 $
C>
C> \defgroup kain Krylov subspace Accelerated Inexact Newton method (KAIN)
C>
C> \ingroup kain
C> @{
C>
C> \file ga_it2.F
C> \brief Implementation of Krylov-subspace nonlinear equation solver
C>
C> This files provides an implementation of the KAIN method to solve
C> linear and nonlinear systems of equations [1]. The solvers 
C> `ga_kain` and `ga_lkain` are general purpose routines. They require
C> a routine to calculate a matrix-vector product and a routine
C> to apply a preconditioner as arguments.
C>
C> [1] R.J. Harrison,
C>     <i>"Krylov Subspace Accelerated Inexact Newton Method for Linear
C>     and Nonlinear Systems",</i>
C>     Journal of Computational Chemistry (2004) <b>25</b>, pp 328-334,
C>     DOI: <a href="http://dx.doi.org/10.1002/jcc.10108">10.1002/jcc.10108</a>
C>
C> @}
c
C> \ingroup kain
C> @{
C>
C> \brief A trivial matrix-vector product routine
C>
C> This routine is simply there to test the code for system solvers.
C> The matrix-vector product it calculates is simply a product involving
C> an explicitly stored matrix. This matrix is passed through a common
C> block.
C>
      subroutine test_product(acc,g_x, g_Ax)
      implicit none
#include "errquit.fh"
      double precision acc !< [Input] Accuracy (not used here)
      integer g_x  !< [Input] Global array with vector
      integer g_Ax !< [Output] Global array with matrix-vector product
c
      integer g_a, g_b
      common /testme/ g_A, g_B
      integer n, nvec, typex, typeax
      double complex one, zero
c
      one  = cmplx(1.0d0,0.0d0)
      zero = cmplx(0.0d0,0.0d0)
c
      call ga_inquire(g_Ax, typeax, n, nvec)
      call ga_inquire(g_x, typex, n, nvec)
      if (typex.ne.typeax)
     $  call errquit("test_product: g_x not same type as g_Ax",
     $               typex,UERR)
      call ga_zero(g_Ax)
      call ga_dgemm('n', 'n', n, nvec, n, one, g_A, g_x, zero, g_Ax)
c
      end
C>
C> \brief A trivial non-linear matrix-vector product routine
C>
C> This routine is simply there to test the code for system solvers.
C> The matrix-vector product it calculates is simply a product involving
C> an explicitly stored matrix and it adds another vector to achieve
C> something non-linear. The additional matrix and vector are passed
C> through a common block.
C>
      subroutine test_nlproduct(acc,g_x, g_Ax)
      implicit none
#include "errquit.fh"
      double precision acc
      integer g_x, g_Ax
c
      integer g_a, g_b
      common /testme/ g_A, g_B
      integer n, nvec, typex, typeax, typeb
      double complex mone, one, zero
c
      mone = cmplx(-1.0d0,0.0d0)
      one  = cmplx(1.0d0,0.0d0)
      zero = cmplx(0.0d0,0.0d0)
c
      call ga_inquire(g_b, typeb, n, nvec)
      call ga_inquire(g_Ax, typeax, n, nvec)
      call ga_inquire(g_x, typex, n, nvec)
      if (typex.ne.typeax)
     $  call errquit("test_nlproduct: g_x not same type as g_Ax",
     $               typex,UERR)
      if (typex.ne.typeb)
     $  call errquit("test_nlproduct: g_x not same type as g_b",
     $               typex,UERR)
      call ga_zero(g_Ax)
      call ga_dgemm('n', 'n', n, nvec, n, one, g_A, g_x, zero, g_Ax)
      call ga_add(one, g_AX, mone, g_B, g_AX)
c
      end
C>
C> \brief A trivial preconditioner
C>
C> This routine is simply there to test the code for system solvers.
C> It simply scales the elements of a vector by
C> \f{eqnarray*}{
C>    x_i = \frac{x_i}{i - \epsilon}
C> \f}
C> where \f$ \epsilon \f$ is the shift.
C>
      subroutine test_precond(g_x,shift)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "global.fh"
      integer g_x
      double precision shift
      integer n, nvec, type
      integer i, ivec
      double precision x
      double complex zx
c
      call ga_inquire(g_x, type, n, nvec)
      if (ga_nodeid() .eq. 0) then
         if (type.eq.MT_DBL) then
            do ivec = 1, nvec
               do i = 1, n
                  call ga_get(g_x, i, i, ivec, ivec, x, 1)
                  x = x / (dble(i) - shift)
                  call ga_put(g_x, i, i, ivec, ivec, x, 1)
               end do
            end do
         else if (type.eq.MT_DCPL) then
            do ivec = 1, nvec
               do i = 1, n
                  call ga_get(g_x, i, i, ivec, ivec, zx, 1)
                  zx = zx / (dble(i) - shift)
                  call ga_put(g_x, i, i, ivec, ivec, zx, 1)
               end do
            end do
         else
            call errquit('test_precond: illegal type',type,UERR)
         endif
      end if
      call ga_sync()
c
      end
C>
C> \brief test driver for ga_lkain
C>
C> This routine drives a standard test of the ga_lkain 
C> and the ga_kain solver.
C> Because the test is fixed the subroutine takes no inputs
C> and it prints a summary on standard output. 
C>
      subroutine ga_lkain_test()
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
      integer n, nvec, maxsub, maxiter
c     parameter (n=300, nvec=1)
      parameter (n=10, nvec=1)
      double complex angle
      integer g_x
      double precision util_random
      external test_precond, test_product, test_nlproduct, util_random
c
      integer g_tx, g_ta, g_tb
      integer g_a, g_b
      common /testme/ g_a, g_b
c
      integer i
      logical  ga_copy_dz
      external ga_copy_dz
****      integer info
****      double precision a(n,n), b(n), w(n)
c
      maxsub = 4*nvec
      maxiter = 100
c
      if (.not. ga_create(MT_DBL, n, nvec, 'testx', 0, 0, g_x))
     $     call errquit('test kain', 1, GA_ERR)
      if (.not. ga_create(MT_DBL, n, nvec, 'testb', 0, 0, g_b))
     $     call errquit('test kain', 2, GA_ERR)
      if (.not. ga_create(MT_DBL, n, n, 'testA', 0, 0, g_A))
     $     call errquit('test kain', 3, GA_ERR)
c
      call ga_ran_fill(g_A, 1, n, 1, n)
      call ga_ran_fill(g_b, 1, n, 1, nvec)
      if (ga_nodeid() .eq. 0) then
         do i = 1, n
            call ga_put(g_a, i, i, i, i, 0.5*dble(i), 1)
         end do
      end if
      call ga_sync()
c
      call ga_copy(g_b, g_x)
      call test_precond(g_x,0.0d0)
      call util_flush(6)
      call ga_print(g_b)
      call ga_print(g_x)
      call util_flush(6)
c
****      call ga_get(g_a, 1, n, 1, n, a, n)
****      call ga_get(g_b, 1, n, 1, nvec, b, n)
****      call dgesv(n, nvec, a, n, w, b, n, info)
****      write(6,*) ' info ', info
****      call ga_put(g_x, 1, n, 1, nvec, b, n)
c
C     This should have something other than zero
      call ga_lkain(0,g_x, g_b,test_product,test_precond,1d-6,maxsub,
     $     maxiter,.true.,.true.)
      call util_flush(6)
      call ga_print(g_x)
      call util_flush(6)
      call ga_summarize(0)
      call ma_summarize_allocated_blocks()
c
      write(6,*)
      write(6,*)
      write(6,*)
      write(6,*) ' DOING NON LINEAR '
      write(6,*)
      write(6,*)
      write(6,*)
      call ga_copy(g_b, g_x)
      call test_precond(g_x,0.0d0)
      maxsub = 10
c
      call ga_kain(g_x, 
     $     test_nlproduct, test_precond, 
     $     1d-6, 
     $     10.0d0, 10.0d0,
     $     maxsub, maxiter, 
     $     .true.)
c
      call util_flush(6)
      call ga_print(g_x)
      call util_flush(6)
      call ga_summarize(0)
      call ma_summarize_allocated_blocks()
c
c     Same but now COMPLEX
c
      g_tx = g_x
      g_tb = g_b
      g_tA = g_A
      maxsub = 4*nvec
      maxiter = 100
      if (.not. ga_create(MT_DCPL, n, nvec, 'testx', 0, 0, g_x))
     $     call errquit('test kain', 1, GA_ERR)
      if (.not. ga_create(MT_DCPL, n, nvec, 'testb', 0, 0, g_b))
     $     call errquit('test kain', 2, GA_ERR)
      if (.not. ga_create(MT_DCPL, n, n, 'testA', 0, 0, g_A))
     $     call errquit('test kain', 3, GA_ERR)
c
c     call ga_ran_fill(g_A, 1, n, 1, n)
c     call ga_ran_fill(g_b, 1, n, 1, nvec)
c     if (ga_nodeid() .eq. 0) then
c        do i = 1, n
c           call ga_put(g_a, i, i, i, i, 0.5*cmplx(dble(i)), 1)
c        end do
c     end if
      if (.not. ga_copy_dz(g_tb,g_b)) 
     +  call errquit('test kain: copy g_b failed',0,GA_ERR)
      if (.not. ga_copy_dz(g_tA,g_A))
     +  call errquit('test kain: copy g_A failed',0,GA_ERR)
      call ga_sync()
      angle = cmplx(1.0d0,util_random(0))
      angle = angle/abs(angle)
      call ga_scale(g_b,angle)
      angle = cmplx(1.0d0,util_random(0))
      angle = angle/abs(angle)
      call ga_scale(g_A,angle)
c
      if (.not. ga_destroy(g_tx))
     $     call errquit('test kain', 1, GA_ERR)
      if (.not. ga_destroy(g_tb))
     $     call errquit('test kain', 2, GA_ERR)
      if (.not. ga_destroy(g_tA))
     $     call errquit('test kain', 3, GA_ERR)
c
      call ga_copy(g_b, g_x)
      call test_precond(g_x,0.0d0)
      call util_flush(6)
      call ga_print(g_b)
      call ga_print(g_x)
      call util_flush(6)
c
****      call ga_get(g_a, 1, n, 1, n, a, n)
****      call ga_get(g_b, 1, n, 1, nvec, b, n)
****      call dgesv(n, nvec, a, n, w, b, n, info)
****      write(6,*) ' info ', info
****      call ga_put(g_x, 1, n, 1, nvec, b, n)
c
C     This should have something other than zero
      call ga_lkain(0,g_x, g_b,test_product,test_precond,1d-6,maxsub,
     $     maxiter,.true.,.true.)
      call util_flush(6)
      call ga_print(g_x)
      call util_flush(6)
      call ga_summarize(0)
      call ma_summarize_allocated_blocks()
c
      write(6,*)
      write(6,*)
      write(6,*)
      write(6,*) ' DOING NON LINEAR '
      write(6,*)
      write(6,*)
      write(6,*)
      call ga_copy(g_b, g_x)
      call test_precond(g_x,0.0d0)
      maxsub = 10
c
      call ga_kain(g_x, 
     $     test_nlproduct, test_precond, 
     $     1d-6, 
     $     10.0d0, 10.0d0,
     $     maxsub, maxiter, 
     $     .true.)
c
      call util_flush(6)
      call ga_print(g_x)
      call util_flush(6)
      call ga_summarize(0)
      call ma_summarize_allocated_blocks()
      call errquit('done',0, MEM_ERR)
c
      if (.not. ga_destroy(g_x))
     $     call errquit('test kain', 1, GA_ERR)
      if (.not. ga_destroy(g_b))
     $     call errquit('test kain', 2, GA_ERR)
      if (.not. ga_destroy(g_A))
     $     call errquit('test kain', 3, GA_ERR)
c
      end
C>
C> \brief The Linear System Solver
C>
C> The routine solves a linear system of equations using a Krylov
C> subspace method:
C> \f{eqnarray*}{
C>   F(x) &=& b \\\\
C>   F(x) &=& Ax
C> \f}
C> The Right-Hand Side (RHS) matrix and the solution
C> matrix store the data pertaining to a single linear system in 
C> columns. Using multiple columns the solver can solve multiple
C> equations simultaneously. Internally one Krylov subspace is used
C> for all systems of equations, and subspace vectors contribute to
C> the solutions of all equations.
C>
C> An special argument `odiff` is provided that allows one to use a
C> difference strategy for the required matrix-vector products. I.e.
C> rather than computing 
C> \f{eqnarray*}{
C>     y &=& Ax_i
C> \f}
C> each iteration one uses a formulation that requires
C> \f{eqnarray*}{
C>     y' &=& A(x_i-x_{i-1})
C> \f}
C> As \f$ x \f$ converges \f$ x_i - x_{i-1} \f$ approaches \f$ 0 \f$.
C> This may be exploited in the matrix-vector product to achieve 
C> considerable savings.
C>
C> Furthermore the routine takes two subroutines as arguments. One 
C> provides the matrix-vector product and has the interface
C> ~~~~
C> subroutine product(acc,g_x,g_Ax)
C> ~~~~
C> which evaluates
C> \f{eqnarray*}{
C>   g_{Ax} &=& A g_x
C> \f}
C> where
C>
C> - acc: the accuracy required for the matrix-vector elements
C>
C> - g_x: is a global array containing the input vectors in columns
C> 
C> - g_Ax: is a global array that will contain the matrix-vector product
C>   results in columns
C>
C> Note that `ga_lkain` may pass global arrays with a different number
C> of vectors than the number of linear systems being solved. Hence
C> the product routine should check the actual dimension of g_x and
C> g_Ax.
C>
C> The second subroutine provides a preconditioner and has the 
C> interface
C> ~~~~
C> subroutine precond(g_x,shift)
C> ~~~~
C> where 
C> 
C> - g_x: is a global array holding a set of vectors that will have
C>   the preconditioner applied to them 
C>
C> - shift: is a shift to ensure the preconditioner is non-singular
C>
C> Note that the number of vectors may also here be different from the
C> number of linear systems being solved. Hence the dimension of g_x
C> should be tested. Finally, the shift is not used in this linear
C> system solver. The argument is provided to ensure that the same
C> preconditioner can be used in eigenvalue solvers where the shift is
C> used.
C> 
      subroutine ga_lkain(rtdb,g_x, g_b, product, precond, 
     $     tol, mmaxsub, maxiter, odiff, oprint)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
#include "rtdb.fh"
c
      integer g_x          !< [Input/Output] Initial guess/solution
      integer g_b          !< [Input] Right-hand side vectors
      external product     !< [Input] product routine
      external precond     !< [Input] preconditioner routine
      double precision tol !< [Input] convergence threshold
      integer mmaxsub      !< [Input] maximum subspace dimension
      integer maxiter      !< [Input] maximum no. of iterations
      logical odiff        !< [Input] use differences in product
      logical oprint       !< [Input] print flag
      integer rtdb         !< [Input] the RTDB handle
c
c     Solves the linear equations A(X)-B=0 for multiple vectors.
c
c     call product(acc,g_x, g_Ax)
c     . acc is the accuracy trequired for each element of the product
c     . g_x contains the vectors and g_Ax should be filled
c     .     with the product vectors.  The no. of vectors (columns) in
c     . g_x might differ from the no. of vectors input to ga_lkain().
c
c     call precond(g_x,shift)
c     . apply preconditioning directly to the vectors in g_x with the
c     . optional shift (not used here but used by the diagonalizer)
c
c     On input g_x should contain an initial guess.  It returns the
c     solution.
c
c     maxsub should be at least 3*nvec and can be beneficially increased
c     to about 10*nvec.
c
c     Needs to be extended to store the sub-space vectors out-of-core
c     at least while the product() routine is being executed.
c
      integer dimi, dimj
      integer iter, n, nvec, nsub, isub, typex, typeb, maxsub
      integer g_y, g_Ay, g_Ax, g_r, g_a, g_bb, g_c, g_xold, g_Axold
      double precision rmax, acc, ga_svd_tol
      double complex zero, one, mone
      logical converged
      logical odebug
c
      zero = cmplx(0.0d0,0.0d0)
      one  = cmplx(1.0d0,0.0d0)
      mone = cmplx(-1.0d0,0.0d0)
c
      odebug = util_print('debug lsolve', print_never) .and. 
     $     ga_nodeid().eq.0
      if (.not.rtdb_get(rtdb,'cphf:acc',mt_dbl,1,acc)) acc=0.01d0*tol
      call ga_inquire(g_b, typeb, dimi, dimj)
      call ga_inquire(g_x, typex, n, nvec)
      if (typeb.ne.typex) 
     $  call errquit("ga_lkain: solution and right-hand-side vectors not
     $ of same type",0,UERR)
      maxsub = mmaxsub          ! So don't modify input scalar arg
      if (maxsub .lt. 3*nvec) maxsub = 3*nvec
      maxsub = (maxsub/nvec)*nvec
c
      if (.not.rtdb_get(rtdb,'cphf:ga_svd_tol',mt_dbl,1,
     &                  ga_svd_tol)) then
c       See comment just before the ga_svd_solve_seq call to
c       understand these choices.
        if ((100*maxsub).lt.n) then
          ga_svd_tol = 1d-7
        else
          ga_svd_tol = 1d-14
        endif 
      endif
c
      if (oprint .and. ga_nodeid().eq.0) then
         write(6,1) n, nvec, maxsub, maxiter, tol, util_wallsec()
 1       format(//,'Iterative solution of linear equations',/,
     $        '  No. of variables', i9,/,
     $        '  No. of equations', i9,/,
     $        '  Maximum subspace', i9,/,
     $        '        Iterations', i9,/,
     $        '       Convergence', 1p,d9.1,/,
     $        '        Start time', 0p,f9.1,/)
         call util_flush(6)
      end if
c
      if (.not. ga_create(typex, n, maxsub, 'lkain: Y', 
     $     0, 0, g_y))
     $     call errquit('lkain: failed allocating subspace', maxsub,
     &       GA_ERR)
      if (.not. ga_create(typex, n, maxsub, 'lkain: Ay', 
     $     0, 0, g_Ay))
     $     call errquit('lkain: failed allocating subspace2', maxsub,
     &       GA_ERR)
      if (.not. ga_create(typex, n, nvec, 'lkain: Ax',
     $     0, 0, g_Ax))
     $     call errquit('lkain: failed allocating subspace3', nvec,
     &       GA_ERR)
      if (.not. ga_create(typex, n, nvec, 'lkain: r',
     $     0, 0, g_r))
     $     call errquit('lkain: failed allocating subspace4', nvec,
     &       GA_ERR)
      if (odiff) then
         if (.not. ga_create(typex, n, nvec, 'lkain: xold',
     $        0, 0, g_xold))
     $        call errquit('lkain: failed allocating subspace5', nvec,
     &       GA_ERR)
         if (.not. ga_create(typex, n, nvec, 'lkain: Axold',
     $        0, 0, g_Axold))
     $        call errquit('lkain: failed allocating subspace6', nvec,
     &       GA_ERR)
         call ga_zero(g_xold)
         call ga_zero(g_Axold)
      end if
      call ga_zero(g_y)
      call ga_zero(g_Ay)
      call ga_zero(g_Ax)
      call ga_zero(g_r)
      call ga_sync()
c
      if (oprint .and. ga_nodeid().eq.0) then
         write(6,2)
         call util_flush(6)
 2       format(/
     $        '   iter   nsub   residual    time',/,
     $        '   ----  ------  --------  ---------')
      end if
      nsub = 0
      converged = .false.
      do iter = 1, maxiter
         if (odiff) then
            call ga_add(one, g_x, mone, g_xold,  g_x)
         end if
         call product(acc,g_x, g_Ax)
         if (odiff) then
            call ga_add(one, g_Ax, one, g_Axold, g_Ax)
            call ga_add(one, g_x,  one, g_xold,  g_x)
            call ga_copy(g_x, g_xold)
            call ga_copy(g_Ax, g_Axold)
         end if
         call ga_zero(g_r)
         call ga_sync()
         call ga_add(one, g_b, mone, g_Ax, g_r) ! The residual
         call ga_sync()
         call ga_maxelt(g_r, rmax)
         if (oprint .and. ga_nodeid().eq.0) then
            write(6,3) iter, nsub+nvec, rmax, util_wallsec()
            call util_flush(6)
 3          format(' ', i5, i7, 3x,1p,d9.2,0p,f10.1)
         end if
         if (rmax .lt. tol) then
            converged = .true.
            goto 100
         end if
         call precond(g_Ax,0.0d0)
         call precond(g_r,0.0d0)
         call ga_sync()
c
c     Copy the vectors to the subspace work area
c
         call ga_copy_patch('n', 
     $        g_Ax, 1, n, 1, nvec, 
     $        g_Ay, 1, n, nsub+1, nsub+nvec)
         call ga_copy_patch('n', 
     $        g_x, 1, n, 1, nvec, 
     $        g_y, 1, n, nsub+1, nsub+nvec)
         nsub = nsub + nvec
c
c     Form and solve the subspace equations using SVD in order
c     to manage near linear dependence in the subspace.
c     
         if (.not. ga_create(typex, nsub, nsub, 'lkain: A', 0, 0, g_a))
     $        call errquit('lkain: allocating g_a?', nsub, GA_ERR)
         if (.not. ga_create(typex, nsub, nvec, 'lkain: B', 0, 0,g_bb))
     $        call errquit('lkain: allocating g_bb?', nsub, GA_ERR)
         if (.not. ga_create(typex, nsub, nvec, 'lkain: C', 0, 0, g_c))
     $        call errquit('lkain: allocating g_c?', nsub, GA_ERR)
         call ga_zero(g_a)
         call ga_zero(g_bb)
         call ga_zero(g_c)
         call ga_sync()
         call ga_dgemm('c','n',nsub,nsub,n,one,g_y,g_Ay,zero,g_a)
         call ga_sync()
         call ga_dgemm('c','n',nsub,nvec,n,one,g_y,g_r,zero,g_bb)
         call ga_sync()
         if (odebug) then
           call util_flush(6)
           call ga_print(g_a)
           call ga_print(g_bb)
           call util_flush(6)
         endif
c
c     The threshold used here should reflect the accuracy in the
c     products.  If very accurate products are used, then there is big
c     advantage for small cases (maxsub close to n) in using a very
c     small threshold in the SVD solve (e.g., 1e-14), but for more
c     realistic examples (maxsub << n) there is only a little
c     advantage and in the precence of real noise in the products
c     screening with a realistic threshold is important.
c
         call ga_svd_solve_seq(g_a,g_bb,g_c,ga_svd_tol)
         if (odebug) then
           call util_flush(6)
           call ga_print(g_c)
           call util_flush(6)
         endif
c
c     Form and add the correction, in parts, onto the solution
c
         call ga_sync()
         call ga_dgemm('n','n',n,nvec,nsub,mone,g_Ay,g_c,one,g_r)
         if (odebug) then
            call util_flush(6)
            write(6,*) ' The update in the complement '
            call util_flush(6)
            call ga_print(g_r)
         end if
         call ga_sync()
         call ga_add(one, g_r, one, g_x, g_x)
         call ga_sync()
         call ga_dgemm('n','n',n,nvec,nsub,one,g_y,g_c,zero,g_r)
         if (odebug) then
            call util_flush(6)
            write(6,*) ' The update in the subspace '
            call util_flush(6)
            call ga_print(g_r)
         end if
         call ga_sync()
         call ga_add(one, g_r, one, g_x, g_x)
         call ga_sync()
c
         if (.not. ga_destroy(g_a)) call errquit('lkain: a',0, GA_ERR)
         if (.not. ga_destroy(g_bb))call errquit('lkain: b',0, GA_ERR)
         if (.not. ga_destroy(g_c)) call errquit('lkain: c',0, GA_ERR)
c
c     Reduce the subspace as necessary
c
         if (nsub .eq. maxsub) then
            do isub = nvec+1, maxsub, nvec
               call ga_copy_patch('n', 
     $              g_Ay, 1, n, isub, isub+nvec-1, 
     $              g_Ax, 1, n, 1, nvec)
               call ga_copy_patch('n', 
     $              g_Ax, 1, n, 1, nvec,
     $              g_Ay, 1, n, isub-nvec, isub-1)
c
               call ga_copy_patch('n', 
     $              g_y, 1, n, isub, isub+nvec-1, 
     $              g_Ax, 1, n, 1, nvec)
               call ga_copy_patch('n', 
     $              g_Ax, 1, n, 1, nvec,
     $              g_y, 1, n, isub-nvec, isub-1)
            end do
            nsub = nsub - nvec
            call ga_sync()
         end if
c
      end do
 100  continue
c
      if (odiff) then
         if (.not. ga_destroy(g_xold)) call errquit('lkain: destroy',1,
     &       GA_ERR)
         if (.not. ga_destroy(g_Axold)) call errquit('lkain: destroy',2,
     &       GA_ERR)
      end if
      if (.not. ga_destroy(g_Ax)) call errquit('lkain: destroy',20,
     &       GA_ERR)
      if (.not. ga_destroy(g_Ay)) call errquit('lkain: destroy',3,
     &       GA_ERR)
      if (.not. ga_destroy(g_y)) call errquit('lkain: destroy',4,
     &       GA_ERR)
      if (.not. ga_destroy(g_r)) call errquit('lkain: destroy',5,
     &       GA_ERR)
c
      if (.not. converged) call errquit('lkain: not converged',0,
     &       CALC_ERR)
c
      end
C>
C> \brief The Non-Linear System Solver
C>
C> The routine solves a non-linear system of equations using a Krylov
C> subspace method.
C> \f{eqnarray*}{
C>   F(x) &=& 0 
C> \f}
C> For linear systems the vector function in the above equation would
C> be \f$ F(x) = Ax - b \f$ but this routine also allows for non-linear
C> vector functions.
C> The Right-Hand Side (RHS) matrix and the solution
C> matrix store the data pertaining to a single linear system in 
C> columns. Using multiple columns the solver can solve multiple
C> equations simultaneously. Internally one Krylov subspace is used
C> for all systems of equations, and subspace vectors contribute to
C> the solutions of all equations.
C>
C> Furthermore the routine takes two subroutines as arguments. One 
C> provides the vector residual and has the interface
C> ~~~~
C> subroutine residual(acc,g_x,g_Ax)
C> ~~~~
C> where
C>
C> - acc: the accuracy required for the matrix-vector elements
C>
C> - g_x: is a global array containing the input vectors in columns
C> 
C> - g_Ax: is a global array that will contain the residual-vector
C>   results in columns
C>
C> Note that `ga_lkain` may pass global arrays with a different number
C> of vectors than the number of linear systems being solved. Hence
C> the product routine should check the actual dimension of g_x and
C> g_Ax.
C>
C> The second subroutine provides a preconditioner and has the 
C> interface
C> ~~~~
C> subroutine precond(g_x,shift)
C> ~~~~
C> where 
C> 
C> - g_x: is a global array holding a set of vectors that will have
C>   the preconditioner applied to them 
C>
C> - shift: is a shift to ensure the preconditioner is non-singular
C>
C> Note that the number of vectors may also here be different from the
C> number of linear systems being solved. Hence the dimension of g_x
C> should be tested. Finally, the shift is not used in this linear
C> system solver. The argument is provided to ensure that the same
C> preconditioner can be used in eigenvalue solvers where the shift is
C> used.
C> 
      subroutine ga_kain(
     $     g_x, 
     $     residual, precond, 
     $     tol, 
     $     trustmin, trustmax, 
     $     maxsub, maxiter, 
     $     oprint)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "util.fh"
c
      integer g_x               !< [Input/Output] Initial guess/solution
      external residual         !< [Input] residual routine
      external precond          !< [Input] preconditioner routine
      double precision tol      !< [Input] convergence threshold
      double precision trustmin !< [Input] range to constrain trust radius
      double precision trustmax !< [Input] range to constrain trust radius
      integer maxsub            !< [Input] maximum subspace dimension
      integer maxiter           !< [Input] maximum no. of iterations
      logical oprint            !< [Input] print flag
c
c     Solves the non-linear equations f(X)=0 for multiple vectors.
c
c     call residual(acc, g_x, g_Ax)
c     . acc is the accuracy trequired for each element of the residual
c     . g_x contains the vectors and g_Ax should be filled
c     .     with the residual vectors.  The no. of vectors (columns) in
c     . g_x might differ from the no. of vectors input to ga_kain().
c
c     call precond(g_x,shift)
c     . apply preconditioning directly to the vectors in g_x with the
c     . optional shift (not used here but used by the diagonalizer)
c
c     On input g_x should contain an initial guess.  It returns the
c     solution.
c
      integer maxmaxsub
      parameter (maxmaxsub = 20)
      integer iter, n, nvec, nsub, isub, jsub, typex
      integer g_y, g_Ay, g_Ax, g_delta, g_a, g_b, g_c
      double precision rmax, acc, trust
      double precision a(maxmaxsub,maxmaxsub), b(maxmaxsub), 
     $                 c(maxmaxsub), csum
      double complex za(maxmaxsub,maxmaxsub), zb(maxmaxsub), 
     $               zc(maxmaxsub), zcsum
      double complex zero, one, mone
      logical converged
      logical odebug
c
      zero = cmplx(0.0d0,0.0d0)
      one  = cmplx(1.0d0,0.0d0)
      mone = cmplx(-1.0d0,0.0d0)
c
      trust = trustmin
      acc = 0.01d0*tol
      if (maxsub .gt. maxmaxsub) maxsub = maxmaxsub
      odebug = util_print('debug lsolve', print_never) .and. 
     $     ga_nodeid().eq.0
c
      call ga_inquire(g_x, typex, n, nvec)
      if (nvec .ne. 1) call errquit('kain: nvec?', nvec, GA_ERR)
c
      if (oprint .and. ga_nodeid().eq.0) then
         write(6,1) n, maxsub, tol, trustmin, trustmax, util_wallsec()
 1       format(//,'Iterative solution of non-linear equations',/,
     $        '  No. of variables', i9,/,
     $        '  Maximum subspace', i9,/,
     $        '       Convergence', 1p,d9.1,/,
     $        '     Trust min/max', 0p,2f6.2,
     $        '        Start time', 0p,f9.1,/)
         call util_flush(6)
      end if
c
      if (.not. ga_create(typex, n, maxsub, 'kain: Y', 
     $     0, 0, g_y))
     $     call errquit('kain: failed allocating subspace', maxsub,
     &       GA_ERR)
      if (.not. ga_create(typex, n, maxsub, 'kain: Ay', 
     $     0, 0, g_Ay))
     $     call errquit('kain: failed allocating subspace2', maxsub,
     &       GA_ERR)
      if (.not. ga_create(typex, n, 1, 'kain: Ax',
     $     0, 0, g_Ax))
     $     call errquit('kain: failed allocating subspace3', 1, GA_ERR)
      call ga_zero(g_y)
      call ga_zero(g_Ay)
c
      if (oprint .and. ga_nodeid().eq.0) then
         write(6,2)
 2       format(/
     $        '   iter   nsub   residual    time',/,
     $        '   ----  ------  --------  ---------')
      end if
      nsub = 0
      converged = .false.
      do iter = 1, maxiter
         call ga_zero(g_Ax)
         call residual(acc, g_x, g_Ax)
         call ga_maxelt(g_Ax, rmax)
         if (oprint .and. ga_nodeid().eq.0) then
            write(6,3) iter, nsub+1, rmax, util_wallsec()
 3          format(' ', i5, i7, 3x,1p,d9.2,0p,f10.1)
         end if
         if (rmax .lt. tol) then
            converged = .true.
            goto 100
         end if
c
c     Copy the vectors to the subspace work area
c
         call precond(g_Ax,0.0d0)
         call ga_copy_patch('n', 
     $        g_Ax, 1, n, 1, 1, 
     $        g_Ay, 1, n, nsub+1, nsub+1)
         call ga_copy_patch('n', 
     $        g_x, 1, n, 1, 1, 
     $        g_y, 1, n, nsub+1, nsub+1)
         nsub = nsub + 1
c
c     Not converged ... make the update
c
         g_delta = g_Ax         ! A reminder that these two are aliased
         call ga_scale(g_delta, mone)
c
         if (iter .gt. 1) then
c
c     Form the reduced space matrix and RHS
c
           if (typex.eq.MT_DBL) then
             call ga_local_mdot(n,nsub,nsub,a,maxmaxsub,g_y,g_Ay)
             do isub = 1, nsub-1
                b(isub) = -(a(isub,nsub) - a(nsub,nsub))
             end do
             do isub = 1, nsub-1
                do jsub = 1, nsub-1
                   a(isub,jsub) = a(isub,jsub)
     $                  - a(nsub,jsub) - a(isub,nsub) + a(nsub,nsub)
                end do
             end do
           else if (typex.eq.MT_DCPL) then
             call ga_local_zmdot(n,nsub,nsub,za,maxmaxsub,g_y,g_Ay)
             do isub = 1, nsub-1
                zb(isub) = -(za(isub,nsub) - za(nsub,nsub))
             end do
             do isub = 1, nsub-1
                do jsub = 1, nsub-1
                   za(isub,jsub) = za(isub,jsub)
     $                  - za(nsub,jsub) - za(isub,nsub) + za(nsub,nsub)
                end do
             end do
           else
             call errquit("ga_kain: illegal type",typex,UERR)
           endif
c
c     Solve the subspace equations (lazily using existing GA routine)
c     
            if (.not. ga_create(typex,nsub-1,nsub-1,'kain: A',
     $           nsub-1,nsub-1,g_a))
     $           call errquit('kain: allocating g_a?', nsub, GA_ERR)
            if (.not. ga_create(typex,nsub-1,1,'kain: B',nsub-1,1,g_b))
     $           call errquit('kain: allocating g_bb?', nsub, GA_ERR)
            if (.not. ga_create(typex,nsub-1,1,'kain: C',nsub-1,1,g_c))
     $           call errquit('kain: allocating g_c?', nsub, GA_ERR)
            if (ga_nodeid() .eq. 0) then
              if (typex.eq.MT_DBL) then
                call ga_put(g_a, 1, nsub-1, 1, nsub-1, a, maxmaxsub)
                call ga_put(g_b, 1, nsub-1, 1, 1, b, 1)
              else if (typex.eq.MT_DCPL) then
                call ga_put(g_a, 1, nsub-1, 1, nsub-1, za, maxmaxsub)
                call ga_put(g_b, 1, nsub-1, 1, 1, zb, 1)
              else
                call errquit("ga_kain: illegal type",typex,UERR)
              endif
            end if
            call ga_sync
c
            call ga_svd_solve_seq(g_a,g_b,g_c,1d-14)
c
            if (odebug) then
              call util_flush(6)
              call ga_print(g_c)
              call util_flush(6)
            endif
            if (typex.eq.MT_DBL) then
              if (ga_nodeid() .eq. 0)
     $           call ga_get(g_c, 1, nsub-1, 1, 1, c, 1)
              call ga_brdcst(1, c, mdtob(nsub-1), 0)
              write(6,*) ' KAIN SUBSPACE COEFFS'
              call output(c, 1, nsub-1, 1, 1, nsub-1, 1, 1)
            else if (typex.eq.MT_DCPL) then
              if (ga_nodeid() .eq. 0)
     $           call ga_get(g_c, 1, nsub-1, 1, 1, zc, 1)
              call ga_brdcst(1, zc, 2*mdtob(nsub-1), 0)
              write(6,*) ' KAIN SUBSPACE COEFFS'
              call zoutput(zc, 1, nsub-1, 1, 1, nsub-1, 1, 1)
            endif
            call ga_sync
            if (.not. ga_destroy(g_a)) call errquit('kain: a',0, GA_ERR)
            if (.not. ga_destroy(g_b)) call errquit('kain: b',0, GA_ERR)
            if (.not. ga_destroy(g_c)) call errquit('kain: c',0, GA_ERR)
c     
c     Form the correction
c     
            if (typex.eq.MT_DBL) then
              csum = 0.0d0
              do isub = 1, nsub-1
                 csum = csum + c(isub)
                 call ga_add_patch( c(isub),  g_y, 1, n, isub, isub, 
     $                one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
                 call ga_add_patch(-c(isub), g_Ay, 1, n, isub, isub, 
     $                one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
              end do
              call ga_add_patch(-csum,  g_y, 1, n, nsub, nsub, 
     $             one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
              call ga_add_patch( csum,  g_Ay, 1, n, nsub, nsub, 
     $             one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
            else if (typex.eq.MT_DCPL) then
              zcsum = 0.0d0
              do isub = 1, nsub-1
                 zcsum = zcsum + zc(isub)
                 call ga_add_patch( zc(isub),  g_y, 1, n, isub, isub, 
     $                one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
                 call ga_add_patch(-zc(isub), g_Ay, 1, n, isub, isub, 
     $                one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
              end do
              call ga_add_patch(-zcsum,  g_y, 1, n, nsub, nsub, 
     $             one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
              call ga_add_patch( zcsum,  g_Ay, 1, n, nsub, nsub, 
     $             one, g_delta, 1, n, 1, 1, g_delta, 1, n, 1, 1)
            endif
         endif
c
c     Step restriction
c
         call ga_maxelt(g_delta, rmax)
         if (rmax .gt. trust) then
            if (oprint) write(6,*) ' RESTRICTION ', rmax, trust
            call ga_scale(g_delta, trust/rmax)
         end if
c
         call ga_add(one, g_delta, one, g_x, g_x)
c     
c     Reduce the subspace as necessary (note g_delta=g_Ax destroyed)
c     
         if (nsub .eq. maxsub) then
            do isub = 2, maxsub
               call ga_copy_patch('n', 
     $              g_Ay, 1, n, isub, isub, 
     $              g_Ax, 1, n, 1, 1)
               call ga_copy_patch('n', 
     $              g_Ax, 1, n, 1, 1,
     $              g_Ay, 1, n, isub-1, isub-1)
c     
               call ga_copy_patch('n', 
     $              g_y, 1, n, isub, isub, 
     $              g_Ax, 1, n, 1, 1)
               call ga_copy_patch('n', 
     $              g_Ax, 1, n, 1, 1,
     $              g_y, 1, n, isub-1, isub-1)
            end do
            nsub = nsub - 1
         end if
c
      end do
 100  continue
c
      if (.not. ga_destroy(g_Ax)) call errquit('kain: destroy',20,
     &       GA_ERR)
      if (.not. ga_destroy(g_Ay)) call errquit('kain: destroy',3,
     &       GA_ERR)
      if (.not. ga_destroy(g_y)) call errquit('kain: destroy',4, GA_ERR)
c
      if (.not. converged) call errquit('kain: not converged',0,
     &       CALC_ERR)
c
      end
C>
C> \brief A direct linear system solver
C>
C> Solve for X from the linear equations
C> \f{eqnarray*}{
C>    A*X &=& B
C> \f}
C> or more explicitly
C> \f{eqnarray*}{
C>    A(m,n)*X(n,nvec) = B(m,nvec)
C> \f}
C> Where \f$ A \f$ is a general real matrix (not necessarily square, or
C> symmetric, or full rank) and \f$ X \f$ and \f$ B \f$ are matrices with one or more
C> columns representing the solutions and right hand sides.  Singular
C> values of \f$ A \f$ less than \f$ tol\f$  are neglected. \f$ X \f$ is returned.
C>
C> If the SVD of \f$ A \f$ is \f$ U*values*VT \f$, then the solution
C> is of the form
C> \f{eqnarray*}{
C>    V*(1/values)*UT*B
C> \f}
C> where the reciprocal of `values` less than `tol` are neglected.
C     
      subroutine ga_svd_solve_seq(g_a, g_b, g_x, tol)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
      integer g_a !< [Input] the matrix stored explicitly
      integer g_b !< [Input] the right-hand-sides
      integer g_x !< [Input/Output] the guess/solution
      double precision tol !< [Input] the tolerance
c
c     Solve for X from the linear equations
c
c     A*X = B
c
c     A(m,n)*X(n,nvec) = B(m,nvec)
c
c     Where A is a general real matrix (not necessarily square, or
c     symmetric, or full rank) and X and B are matrices with one or more
c     columns representing the solutions and right hand sides.  Singular
c     values of A less than tol are neglected.  X is returned.
c
c     If the SVD of A is U*values*VT, then the solution
c     is of the form
c
c     V*(1/values)*UT*B
c
c     where the reciprocal of values less than tol are neglected.
c     
      integer m,n,nn,type,nvec,nsing,l_val, k_val,g_u,g_vt,i,g_tmp
      double complex one, zero
      logical oprint
c
      oprint = util_print('debug svdsolve', print_high) .and.
     $     ga_nodeid().eq.0
c
      one  = cmplx(1.0d0,0.0d0)
      zero = cmplx(0.0d0,0.0d0)
c
      call ga_inquire(g_a, type, m, n)
      call ga_inquire(g_b, type, nn, nvec)
      if (nn .ne. n) call errquit('gasvdsol: b does not conform',nn,
     &       GA_ERR)
      nsing = min(m,n)
      if (.not. ma_push_get(MT_DBL, nsing, 'gasvdsol', l_val, k_val))
     $     call errquit('gasvdsol: val',nsing, MA_ERR)
      if (.not. ga_create(type,m,nsing,'gasvd',0,0,g_u))
     $     call errquit('gasvdsol: u',m*nsing, GA_ERR)
      if (.not. ga_create(type,nsing,n,'gasvd',0,0,g_vt))
     $     call errquit('gasvdsol: u',nsing*n, GA_ERR)
      if (.not. ga_create(type,nsing,nvec,'gasvd',0,0,g_tmp))
     $     call errquit('gasvdsol: tmp',nsing*nvec, GA_ERR)
      call ga_zero(g_tmp)
c
      call ga_svd_seq(g_a, g_u,g_vt,dbl_mb(k_val))
c
      do i = 0, nsing-1
        if (dbl_mb(k_val+i) .lt. tol) then
          if (ga_nodeid() .eq. 0 .and. oprint) then
            write(6,*) ' neglecting ', i+1, dbl_mb(k_val+i)
          endif
          dbl_mb(k_val+i) = 0.0d0
        else
          dbl_mb(k_val+i) = 1.0d0/dbl_mb(k_val+i)
        end if
      end do
c
      call ga_dgemm('c','n',nsing,nvec,m,one,g_u,g_b,zero,g_tmp)
      call ga_scale_lh(g_tmp,dbl_mb(k_val))
      call ga_zero(g_x)
      call ga_dgemm('c','n',n,nvec,nsing,one,g_vt,g_tmp,zero,g_x)
c
      if (.not. ga_destroy(g_tmp)) call errquit('gasvdsol: des',1,
     &       GA_ERR)
      if (.not. ga_destroy(g_u)) call errquit('gasvdsol: des',2,
     &       GA_ERR)
      if (.not. ga_destroy(g_vt)) call errquit('gasvdsol: des',3,
     &       GA_ERR)
      if (.not. ma_pop_stack(l_val)) call errquit('gasvdsol: pop',4,
     &       GA_ERR)
c
      end
C>
C> \brief Perform SVD on rectangular matrix
C>
      subroutine ga_svd_seq(g_a, g_u, g_vt, values)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
      integer g_a, g_u, g_vt
      double precision values(*)
c     
c     Perform SVD on rectangular matrix
c
c     nsing = min(n,m)
c     g_a(m,n)      --- input matrix
c     g_u(m,nsing)  --- left singular vectors (output)
c     g_vt(nsing,n) --- right singular vectors transposed (output)
c     values(nsing) --- singular values (output)
c
c     A = U*values*VT
c
c     A possible parallel algorithm is to diagonalize ATA to get
c     V and AAT to get U --- both have values**2 as eigenvalues.
c
      integer n, m, type, l_a, k_a, l_u, k_u, l_vt, k_vt, 
     $     l_work, k_work, lwork, info, nsing
      integer l_rwork, k_rwork
c     
      call ga_inquire(g_a, type, m, n)
      nsing = min(m,n)
      if (ga_nodeid() .eq. 0) then
         lwork = 10*max(m,n)
         if (.not. ma_push_get(type, m*n, 'gasvd', l_a, k_a))
     $        call errquit('gasvd: a',m*n, MA_ERR)
         if (.not. ma_push_get(type, m*nsing, 'gasvd', l_u, k_u))
     $        call errquit('gasvd: u',m*nsing, MA_ERR)
         if (.not. ma_push_get(type, nsing*n, 'gasvd', l_vt, k_vt))
     $        call errquit('gasvd: vt',nsing*n, MA_ERR)
         if (.not. ma_push_get(type, lwork, 'gasvd', l_work, k_work))
     $        call errquit('gasvd: work',lwork, MA_ERR)
         if (type.eq.MT_DCPL) then
            if (.not. ma_push_get(MT_DBL, lwork, 'gasvd',
     $                            l_rwork, k_rwork))
     $           call errquit('gasvd: work',lwork, MA_ERR)
         endif
c
         if (type.eq.MT_DBL) then
c
           call ga_get(g_a, 1, m, 1, n, dbl_mb(k_a), m)
c
           call dgesvd('s','s',m,n,dbl_mb(k_a),m,values,
     $          dbl_mb(k_u),m,dbl_mb(k_vt),nsing,
     $          dbl_mb(k_work),lwork,info)
           if (info .ne. 0) call errquit('gasvd:d: failed',info,MEM_ERR)
c
           call ga_put(g_u,  1, n,     1, nsing, dbl_mb(k_u),  n)
           call ga_put(g_vt, 1, nsing, 1, m,     dbl_mb(k_vt), n)
c
         else if (type.eq.MT_DCPL) then
c
           call ga_get(g_a, 1, m, 1, n, dcpl_mb(k_a), m)
c
           call zgesvd('s','s',m,n,dcpl_mb(k_a),m,values,
     $          dcpl_mb(k_u),m,dcpl_mb(k_vt),nsing,
     $          dcpl_mb(k_work),lwork,dbl_mb(k_rwork),info)
           if (info .ne. 0) call errquit('gasvd:z: failed',info,MEM_ERR)
c
           call ga_put(g_u,  1, n,     1, nsing, dcpl_mb(k_u),  n)
           call ga_put(g_vt, 1, nsing, 1, m,     dcpl_mb(k_vt), n)
c
         else
c
           call errquit('gasvd: illegal data type',type,UERR)
c
         endif
c
         if (.not. ma_chop_stack(l_a)) call errquit('gasvd ma',0,
     &       MA_ERR)
      end if
      call ga_sync()
      call ga_brdcst(1,values,n*8,0)
      call ga_sync()
c     
      end
C> @}

*> \brief \b ZSPMV computes a matrix-vector product for complex vectors using a complex symmetric packed matrix
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZSPMV + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zspmv.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zspmv.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zspmv.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZSPMV( UPLO, N, ALPHA, AP, X, INCX, BETA, Y, INCY )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INCX, INCY, N
*       COMPLEX*16         ALPHA, BETA
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         AP( * ), X( * ), Y( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZSPMV  performs the matrix-vector operation
*>
*>    y := alpha*A*x + beta*y,
*>
*> where alpha and beta are scalars, x and y are n element vectors and
*> A is an n by n symmetric matrix, supplied in packed form.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>           On entry, UPLO specifies whether the upper or lower
*>           triangular part of the matrix A is supplied in the packed
*>           array AP as follows:
*>
*>              UPLO = 'U' or 'u'   The upper triangular part of A is
*>                                  supplied in AP.
*>
*>              UPLO = 'L' or 'l'   The lower triangular part of A is
*>                                  supplied in AP.
*>
*>           Unchanged on exit.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the order of the matrix A.
*>           N must be at least zero.
*>           Unchanged on exit.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is COMPLEX*16
*>           On entry, ALPHA specifies the scalar alpha.
*>           Unchanged on exit.
*> \endverbatim
*>
*> \param[in] AP
*> \verbatim
*>          AP is COMPLEX*16 array, dimension at least
*>           ( ( N*( N + 1 ) )/2 ).
*>           Before entry, with UPLO = 'U' or 'u', the array AP must
*>           contain the upper triangular part of the symmetric matrix
*>           packed sequentially, column by column, so that AP( 1 )
*>           contains a( 1, 1 ), AP( 2 ) and AP( 3 ) contain a( 1, 2 )
*>           and a( 2, 2 ) respectively, and so on.
*>           Before entry, with UPLO = 'L' or 'l', the array AP must
*>           contain the lower triangular part of the symmetric matrix
*>           packed sequentially, column by column, so that AP( 1 )
*>           contains a( 1, 1 ), AP( 2 ) and AP( 3 ) contain a( 2, 1 )
*>           and a( 3, 1 ) respectively, and so on.
*>           Unchanged on exit.
*> \endverbatim
*>
*> \param[in] X
*> \verbatim
*>          X is COMPLEX*16 array, dimension at least
*>           ( 1 + ( N - 1 )*abs( INCX ) ).
*>           Before entry, the incremented array X must contain the N-
*>           element vector x.
*>           Unchanged on exit.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           X. INCX must not be zero.
*>           Unchanged on exit.
*> \endverbatim
*>
*> \param[in] BETA
*> \verbatim
*>          BETA is COMPLEX*16
*>           On entry, BETA specifies the scalar beta. When BETA is
*>           supplied as zero then Y need not be set on input.
*>           Unchanged on exit.
*> \endverbatim
*>
*> \param[in,out] Y
*> \verbatim
*>          Y is COMPLEX*16 array, dimension at least
*>           ( 1 + ( N - 1 )*abs( INCY ) ).
*>           Before entry, the incremented array Y must contain the n
*>           element vector y. On exit, Y is overwritten by the updated
*>           vector y.
*> \endverbatim
*>
*> \param[in] INCY
*> \verbatim
*>          INCY is INTEGER
*>           On entry, INCY specifies the increment for the elements of
*>           Y. INCY must not be zero.
*>           Unchanged on exit.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complex16OTHERauxiliary
*
*  =====================================================================
      SUBROUTINE ZSPMV( UPLO, N, ALPHA, AP, X, INCX, BETA, Y, INCY )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INCX, INCY, N
      COMPLEX*16         ALPHA, BETA
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * ), X( * ), Y( * )
*     ..
*
* =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
      COMPLEX*16         ZERO
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, INFO, IX, IY, J, JX, JY, K, KK, KX, KY
      COMPLEX*16         TEMP1, TEMP2
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = 1
      ELSE IF( N.LT.0 ) THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 ) THEN
         INFO = 6
      ELSE IF( INCY.EQ.0 ) THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZSPMV ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( N.EQ.0 ) .OR. ( ( ALPHA.EQ.ZERO ) .AND. ( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     Set up the start points in  X  and  Y.
*
      IF( INCX.GT.0 ) THEN
         KX = 1
      ELSE
         KX = 1 - ( N-1 )*INCX
      END IF
      IF( INCY.GT.0 ) THEN
         KY = 1
      ELSE
         KY = 1 - ( N-1 )*INCY
      END IF
*
*     Start the operations. In this version the elements of the array AP
*     are accessed sequentially with one pass through AP.
*
*     First form  y := beta*y.
*
      IF( BETA.NE.ONE ) THEN
         IF( INCY.EQ.1 ) THEN
            IF( BETA.EQ.ZERO ) THEN
               DO 10 I = 1, N
                  Y( I ) = ZERO
   10          CONTINUE
            ELSE
               DO 20 I = 1, N
                  Y( I ) = BETA*Y( I )
   20          CONTINUE
            END IF
         ELSE
            IY = KY
            IF( BETA.EQ.ZERO ) THEN
               DO 30 I = 1, N
                  Y( IY ) = ZERO
                  IY = IY + INCY
   30          CONTINUE
            ELSE
               DO 40 I = 1, N
                  Y( IY ) = BETA*Y( IY )
                  IY = IY + INCY
   40          CONTINUE
            END IF
         END IF
      END IF
      IF( ALPHA.EQ.ZERO )
     $   RETURN
      KK = 1
      IF( LSAME( UPLO, 'U' ) ) THEN
*
*        Form  y  when AP contains the upper triangle.
*
         IF( ( INCX.EQ.1 ) .AND. ( INCY.EQ.1 ) ) THEN
            DO 60 J = 1, N
               TEMP1 = ALPHA*X( J )
               TEMP2 = ZERO
               K = KK
               DO 50 I = 1, J - 1
                  Y( I ) = Y( I ) + TEMP1*AP( K )
                  TEMP2 = TEMP2 + AP( K )*X( I )
                  K = K + 1
   50          CONTINUE
               Y( J ) = Y( J ) + TEMP1*AP( KK+J-1 ) + ALPHA*TEMP2
               KK = KK + J
   60       CONTINUE
         ELSE
            JX = KX
            JY = KY
            DO 80 J = 1, N
               TEMP1 = ALPHA*X( JX )
               TEMP2 = ZERO
               IX = KX
               IY = KY
               DO 70 K = KK, KK + J - 2
                  Y( IY ) = Y( IY ) + TEMP1*AP( K )
                  TEMP2 = TEMP2 + AP( K )*X( IX )
                  IX = IX + INCX
                  IY = IY + INCY
   70          CONTINUE
               Y( JY ) = Y( JY ) + TEMP1*AP( KK+J-1 ) + ALPHA*TEMP2
               JX = JX + INCX
               JY = JY + INCY
               KK = KK + J
   80       CONTINUE
         END IF
      ELSE
*
*        Form  y  when AP contains the lower triangle.
*
         IF( ( INCX.EQ.1 ) .AND. ( INCY.EQ.1 ) ) THEN
            DO 100 J = 1, N
               TEMP1 = ALPHA*X( J )
               TEMP2 = ZERO
               Y( J ) = Y( J ) + TEMP1*AP( KK )
               K = KK + 1
               DO 90 I = J + 1, N
                  Y( I ) = Y( I ) + TEMP1*AP( K )
                  TEMP2 = TEMP2 + AP( K )*X( I )
                  K = K + 1
   90          CONTINUE
               Y( J ) = Y( J ) + ALPHA*TEMP2
               KK = KK + ( N-J+1 )
  100       CONTINUE
         ELSE
            JX = KX
            JY = KY
            DO 120 J = 1, N
               TEMP1 = ALPHA*X( JX )
               TEMP2 = ZERO
               Y( JY ) = Y( JY ) + TEMP1*AP( KK )
               IX = JX
               IY = JY
               DO 110 K = KK + 1, KK + N - J
                  IX = IX + INCX
                  IY = IY + INCY
                  Y( IY ) = Y( IY ) + TEMP1*AP( K )
                  TEMP2 = TEMP2 + AP( K )*X( IX )
  110          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP2
               JX = JX + INCX
               JY = JY + INCY
               KK = KK + ( N-J+1 )
  120       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of ZSPMV
*
      END
c $Id: zspmv.f 24343 2013-06-22 05:35:15Z d3y133 $

c
c $Id: pspw_charge.F 19707 2010-10-29 17:59:36Z d3y133 $
c
  
***********************************************************
*                                                         *
*                   PSPW-Charge module                    *
*                                                         *
*          Interfaced to nwchem-PSPW code                 *
*                                                         *
*    -- developed by Eric J. Bylaska on October 18,2001   *
*                                                         *
***********************************************************
*
*
*  

*     **********************************
*     *	                               *
*     *          pspw_charge_init      *
*     *                                *
*     **********************************
 
      subroutine pspw_charge_init(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "pspw_charge.fh"
#include "errquit.fh"


*     **** local variables ****
      logical value
      integer i,pzero,zero,G(3),npack0,nfft3d,gk(2),gk2(2),taskid
      real*8  gg,temp,temp2,pi,fourpi,epsilon,scal2
      character*16 t

*     **** external functions ****
      logical     ion_chargeexist,control_qmmm
      integer     G_indx
      real*8      lattice_omega
      external    ion_chargeexist,control_qmmm
      external    G_indx
      external    lattice_omega


*     *************************
*     **** read in charge data ****
*     *************************
      bqext  = geom_extbq_on()
      bqgeom = ion_chargeexist()

     
      if(bqext.and.bqgeom)
     +  call errquit("pspw_charge_init: cannot have both bq structures",
     +               0,0)
      if(bqext) then
        nion = geom_extbq_ncenter()
        charge(1) = geom_extbq_charge()
        r1(1)     = geom_extbq_coord()
      else if (bqgeom) then
         value = geom_create(geom,'chargegeometry')
         value = value.and.geom_rtdb_load(rtdb,geom,'chargegeometry')
         value = value.and.geom_ncent(geom,nion)
         if (.not. value) 
     >     call errquit('pspw_charge_init: opening chargegeometry',0,
     &       GEOM_ERR)

*        ***** Allocate pspw_charge geometries, and charges *****
         value = MA_alloc_get(mt_dbl,(3*nion),
     >                        'charge_r1',r1(2),r1(1))
         value = value.and.
     >           MA_alloc_get(mt_dbl,(nion),
     >                        'charge_charge',charge(2),charge(1))
         if (.not. value)
     >      call errquit('pspw_charge_init: pushing heap memory',0,
     &       MA_ERR)

*        **** read in charge geometries, and charges ****
         do i=1,nion
             value = value.and.
     >       geom_cent_get(geom,i,t,
     >                     dbl_mb(r1(1)+(i-1)*3),
     >                     dbl_mb(charge(1)+i-1))
         end do
         if (.not. value) 
     >   call errquit('pspw_charge_init:error reading chargegeometry',0,
     &       GEOM_ERR)

      else 
         nion = 0
      end if


*     **** don't do anything if there are no charges atoms ****
      if (nion.gt.0) then

*       **** set charge_type ****
        if (.not.rtdb_get(rtdb,
     >         'nwpw:charge_type',mt_int,1,charge_type)) then
          charge_type = 1
          if (control_qmmm()) charge_type = 3 ! set charge type 3 for qmmm
        end if
 
        if (charge_type.eq.2) then
           if (.not.rtdb_get(rtdb,
     >         'nwpw:charge_dielectric_d',mt_dbl,1,s_d))
     >       s_d = 0.5d0/0.529177d0

           if (.not.rtdb_get(rtdb,
     >         'nwpw:charge_dielectric_rho',mt_dbl,1,s_rho))
     >       s_rho = 2.5d0/0.529177d0

           if (.not.rtdb_get(rtdb,
     >         'nwpw:charge_rcut',mt_dbl,1,s_sigma))
     >       s_sigma = 0.8d0/0.529177d0

        end if
        if (charge_type.eq.3) then
           if (.not.rtdb_get(rtdb,'nwpw:charge_rcut',mt_dbl,1,s_sigma))
     >       s_sigma = (0.37d0/0.3d0)/0.529177d0  ! should give covalent radii for spc water
           if (.not.rtdb_get(rtdb,'nwpw:charge_ncut',mt_int,1,n_sigma))
     >       n_sigma = 4
        end if

        if (charge_type.eq.4) then
           if (.not.rtdb_get(rtdb,
     >         'nwpw:charge_rcut',mt_dbl,1,s_sigma))
     >       s_sigma = 0.8d0
           epsilon = 1.0d0/s_sigma


           call Parallel_taskid(taskid)
           pi = 4.0d0*datan(1.0d0)
           fourpi = 4.0d0*pi
           scal2  = 1.0d0/lattice_omega()
           call D3dB_nfft3d(1,nfft3d)
           call Pack_npack(0,npack0)
           G(1) = G_indx(1)
           G(2) = G_indx(2)
           G(3) = G_indx(3)

*          **** allocate vc_charge memory ****
           value =           MA_alloc_get(mt_dbl,npack0,'point_vc',
     >                                    vc_charge(2),vc_charge(1))
           value = value.and.MA_alloc_get(mt_dbl,npack0,'point_vc2',
     >                                    vc2_charge(2),vc2_charge(1))
           if (.not.value) call errquit('out of heap memory',0,MA_ERR)
           value = MA_push_get(mt_dbl,nfft3d,'gk',gk(2),gk(1))
           value = value.and.
     >             MA_push_get(mt_dbl,nfft3d,'gk2',gk2(2),gk2(1))
           if (.not.value) call errquit('out of stack memory',0,MA_ERR)


*          ***** find the G==0 point in the lattice *****
           call D3dB_ijktoindexp(1,1,1,1,zero,pzero)

*          **** long-range and short-range part of Greens function ****
           call dcopy(nfft3d,0.0d0,0,dbl_mb(gk(1)), 1)
           call dcopy(nfft3d,0.0d0,0,dbl_mb(gk2(1)),1)
           do i=1,nfft3d

              gg  = ( dbl_mb(G(1)+i-1)*dbl_mb(G(1)+i-1)
     >              + dbl_mb(G(2)+i-1)*dbl_mb(G(2)+i-1)
     >              + dbl_mb(G(3)+i-1)*dbl_mb(G(3)+i-1) )
               if ((pzero.eq.taskid) .and. (i.eq.zero)) then
                 !temp = pi/epsilon**2
                 temp = 0.0d0
              else
               temp = (fourpi/gg)*dexp(-gg/(4.0d0*epsilon**2))
               temp = (fourpi/gg)
              end if
              temp2 = 2.0d0*dexp(-gg/(epsilon**2))

              dbl_mb(gk(1) +i-1) = temp
              dbl_mb(gk2(1)+i-1) = temp2
           end do
           call Pack_t_pack(0,dbl_mb(gk(1)))
           call Pack_t_Copy(0,dbl_mb(gk(1)),dbl_mb(vc_charge(1)))
           call Pack_t_pack(0,dbl_mb(gk2(1)))
           call Pack_t_Copy(0,dbl_mb(gk2(1)),dbl_mb(vc2_charge(1)))
c           call Pack_t_SMul(0,scal2,dbl_mb(vc_charge(1)),
c     >                              dbl_mb(vc_charge(1)))
c           call Pack_t_SMul(0,scal2,dbl_mb(vc2_charge(1)),
c     >                              dbl_mb(vc2_charge(1)))
           call Pack_t_SMul1(0,scal2,dbl_mb(vc_charge(1)))
           call Pack_t_SMul1(0,scal2,dbl_mb(vc2_charge(1)))

           value =           MA_pop_stack(gk2(2))
           value = value.and.MA_pop_stack(gk(2))
           if (.not. value)
     >     call errquit('pspw_charge_init_init: poppingstack memory',0,
     >       MA_ERR)

           call qstrfac_init(nion)
           call qphafac_rion(dbl_mb(r1(1)))
        end if
      

      end if

      return
      end



*     **********************************
*     *	                               *
*     *        pspw_charge_destroy     *
*     *                                *
*     **********************************
      subroutine pspw_charge_destroy()
      implicit none

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "pspw_charge.fh"
#include "errquit.fh"

*     **** local variables ****
      logical value

      if (bqgeom) then
        value = geom_destroy(geom)

        if (.not. value) 
     >     call errquit('error destroying chargegeometry', 0, GEOM_ERR)
      end if

      return
      end

*     **********************************
*     *	                               *
*     *        pspw_charge_write       *
*     *                                *
*     **********************************

      subroutine pspw_charge_write(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "errquit.fh"
#include "pspw_charge.fh"

*     **** local variables ****
      logical value
      integer i
      double precision rxyz(3),q
      character*16 t

      integer  control_code
      external control_code

*     *******************************
*     **** write out charge data ****
*     *******************************
      if (bqgeom) then
      if (nion.gt.0) then
        value = .true.
        do i=1,nion
           value = value.and.geom_cent_get(geom,i,t,rxyz,q)
           value = value.and.
     >             geom_cent_set(geom,i,t,dbl_mb(r1(1)+(i-1)*3),q)
        end do

        value = value.and.geom_rtdb_delete(rtdb,'chargegeometry')
        if ((control_code().eq.1).or.
     >      (control_code().eq.2)) then
        value = value.and.geom_rtdb_store(rtdb,geom,'chargegeometry')
        end if
        value = value.and.geom_destroy(geom)
        if (.not. value) call errquit('error writing chargegeometry', 0,
     &       GEOM_ERR)
      end if
      end if

      return
      end




*     **********************************
*     *	                               *
*     *         pspw_charge_aname        *
*     *                                *
*     **********************************
      character*2 function pspw_charge_aname(i)
      implicit none
#include "errquit.fh"
      integer i

#include "stdio.fh"
#include "geom.fh"
#include "pspw_charge.fh"

*     **** local variables ****
      character*2  symbol
      character*16 t,name
      real*8 q

      if (bqgeom) then
        if (.not. geom_cent_tag(geom,i,t))
     >        call errquit(' pspw_charge_aname: failed ',i, GEOM_ERR)

        if (.not. geom_tag_to_element(t,symbol,name,q)) then
          symbol = 'bq'
        end if
      else
         symbol = 'bq'
      end if

      pspw_charge_aname = symbol
      return
      end


*     ***************************
*     *                         *
*     *   pspw_charge_charge    *
*     *                         *
*     ***************************
      real*8 function pspw_charge_charge(i)
      implicit none
      integer i

#include "mafdecls.fh"
#include "pspw_charge.fh"


      pspw_charge_charge = dbl_mb(charge(1)+i-1)
      return
      end


*     **********************************
*     *	                               *
*     *         pspw_charge_found        *
*     *                                *
*     **********************************
      logical function pspw_charge_found()
      implicit none

#include "pspw_charge.fh"
 
      logical value

      value = .false.
      if (nion.gt.0) value = .true.

      pspw_charge_found = value
      return
      end
c
      logical function pspw_bqext()
      implicit none

#include "pspw_charge.fh"
 
      logical value

      pspw_bqext = bqext

      return
      end

*     **********************************
*     *	                               *
*     *         pspw_charge_end	       *
*     *                                *
*     **********************************

      subroutine pspw_charge_end()
      implicit none

#include "mafdecls.fh"
#include "pspw_charge.fh"
#include "errquit.fh"

      logical value

      if (nion.gt.0) then
        value = .true.
        if (bqgeom) then
           value = value.and.MA_free_heap(r1(2))
           value = value.and.MA_free_heap(charge(2))
        end if

        if (charge_type.eq.4) then
          value=value.and.MA_free_heap(vc2_charge(2))
          value=value.and.MA_free_heap(vc_charge(2))
          call qstrfac_end()
        end if
        if (.not.value) 
     >    call errquit('pspw_charge_end: freeing heap',0, MA_ERR)
      end if
      return
      end

*     **********************************
*     *	                               *
*     *        pspw_charge_nion        *
*     *                                *
*     **********************************
      integer function pspw_charge_nion()
      implicit none

#include "pspw_charge.fh"

      pspw_charge_nion = nion
      return
      end


*     **********************************
*     *	                               *
*     *       pspw_charge_Print        *
*     *                                *
*     **********************************

      subroutine pspw_charge_Print(unit)
      implicit none
      integer unit

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     ***** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)
      integer ii,k

      character*2 pspw_charge_aname
      real*8      pspw_charge_charge
      external    pspw_charge_aname
      external    pspw_charge_charge

      if (nion.gt.0) then
      call Parallel_taskid(taskid)

      if (taskid.eq.MASTER) then
        if (charge_type.eq.1) then
          write(unit,1160)   
        end if
        if (charge_type.eq.2) then
          write(unit,1170)   
          write(unit,1171) s_d,s_rho,s_sigma   
        end if
        if (charge_type.eq.3) then
          write(unit,1175)
          write(unit,1176) n_sigma, s_sigma
        end if
        if (charge_type.eq.4) then
          write(unit,1177)
          write(unit,1178) s_sigma
        end if
        write(unit,1180)   
        do ii=1,nion
          write(unit,1190) ii,pspw_charge_aname(ii),
     >                     (dbl_mb(r1(1)+3*(ii-1)+k-1),k=1,3),
     >                       pspw_charge_charge(ii)

        end do
      end if

      end if
      return

 1160 format(/' Point charges used:')
 1170 format(/' Switching charges used:')
 1171 FORMAT(5X, '(d,rho,sigma) = (',3E11.3,' )  ')
 1175 format(/' qmmm charges used:')
 1176 format(5x,'(n_sigma,s_sigma) = (',I3,E11.3,')  ')
 1177 format(/' periodic charges used:')
 1178 format(5x,' s_sigma=',E11.3)
 1180 FORMAT(/' position of point charges (au): ')
 1190 FORMAT(5X, I4, A3  ,' (',3F11.5,' ) - charge = ',F10.3)
      end




*     **********************************
*     *	                               *
*     *       pspw_charge_PrintXYZ       *
*     *                                *
*     **********************************

      subroutine pspw_charge_PrintXYZ(unit)
      implicit none
      integer unit

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     ***** local variables ****
      integer taskid,MASTER
      parameter (MASTER=0)
      integer ii,k

      character*2 pspw_charge_aname
      external    pspw_charge_aname

      if (nion.gt.0) then
      call Parallel_taskid(taskid)

      if (taskid.eq.MASTER) then  
       do ii=1,nion
        write(unit,*) pspw_charge_aname(ii),'      ',
     >               (dbl_mb(r1(1)+3*(ii-1)+k-1)*0.529177d0,k=1,3)
       end do
      end if

      end if

      return
      end


*     **********************************
*     *	                               *
*     *        pspw_charge_rion        *
*     *                                *
*     **********************************
      real*8 function pspw_charge_rion(i,ii)
      implicit none
      integer i,ii

#include "mafdecls.fh"
#include "pspw_charge.fh"

      pspw_charge_rion = dbl_mb(r1(1)+3*(ii-1)+i-1)
      return
      end



*     **********************************
*     *	                               *
*     *     pspw_charge_Generate_V     *
*     *                                *
*     **********************************

      subroutine pspw_charge_Generate_V(n2ft3d,rgrid,Vqm)
      implicit none
      integer n2ft3d
      real*8 rgrid(3,*)
      real*8 Vqm(*)

#include "mafdecls.fh"
#include "pspw_charge.fh"
#include "errquit.fh"

*     ***** local variables ****
      logical value
      integer ii,ia,k,p1,p2,po2,npack0,exi(2),tmp(2),nx,ny,nz
      real*8  x1,y1,z1,q1,r,r2,rc,epsilon,ttt,sss,scal1,scal2
      real*8  rc1,rc2,rr1,rr1p

*     **** external functions ****
      integer  ion_katm
      external ion_katm
      real*8   util_erf,lattice_omega
      external util_erf,lattice_omega


      if (nion.gt.0) then

*        **** point charges ****
         if (charge_type.eq.1) then
           do ii=1,nion
              x1 = dbl_mb(r1(1)+3*(ii-1))
              y1 = dbl_mb(r1(1)+3*(ii-1)+1)
              z1 = dbl_mb(r1(1)+3*(ii-1)+2)
              q1 = dbl_mb(charge(1)+ii-1)
              do k=1,n2ft3d
                r = (rgrid(1,k)-x1)**2
     >            + (rgrid(2,k)-y1)**2
     >            + (rgrid(3,k)-z1)**2
                r = dsqrt(r)
                Vqm(k) = Vqm(k) - q1/r
              end do
           end do   

*        **** switching charge potential **** 
         else if (charge_type.eq.2) then
           do ii=1,nion
              x1 = dbl_mb(r1(1)+3*(ii-1))
              y1 = dbl_mb(r1(1)+3*(ii-1)+1)
              z1 = dbl_mb(r1(1)+3*(ii-1)+2)
              q1 = dbl_mb(charge(1)+ii-1)
              do k=1,n2ft3d
                r = (rgrid(1,k)-x1)**2
     >            + (rgrid(2,k)-y1)**2
     >            + (rgrid(3,k)-z1)**2
                r = dsqrt(r)

*               **** define dielectric switching function ****
                if (r.le.s_d) then
                   epsilon = 0.0d0
                else if (r.lt.(s_d+s_rho)) then
                   epsilon = 1.0d0-(1.0d0-(r-s_d)**2/s_rho**2)**2        
                else
                   epsilon = 1.0d0
                end if

                Vqm(k) = Vqm(k) - epsilon*q1*util_erf(r/s_sigma)/r
              end do
           end do   

*        **** short-range repulsion ****
         else if (charge_type.eq.3) then
           p1  = n_sigma
           po2 = n_sigma/2
           p2  = n_sigma+1
           do ii=1,nion
              x1 = dbl_mb(r1(1)+3*(ii-1))
              y1 = dbl_mb(r1(1)+3*(ii-1)+1)
              z1 = dbl_mb(r1(1)+3*(ii-1)+2)
              q1 = dbl_mb(charge(1)+ii-1)
              rc = abs(q1)*s_sigma
              if (rc.gt.1.0d0) rc=1.0d0 !stupid check
              !rc1 = abs(q1)*rc**p1
              rc1 = rc**p1
              rc2 = rc**p2
              do k=1,n2ft3d
                 r2 = (rgrid(1,k)-x1)**2
     >              + (rgrid(2,k)-y1)**2
     >              + (rgrid(3,k)-z1)**2
                 r = dsqrt(r2)
                 rr1  = r**p1
                 rr1p = r**p2
                 ttt = (rc1 - rr1)
                 sss = (rc2 - rr1p)

                 Vqm(k) = Vqm(k) - q1*(ttt/sss)
              end do
           end do   
           !call sub_coulomb_screened_init_print(Vqm,1.0d0,q1)

         else if (charge_type.eq.4) then

           call D3dB_nx(1,nx)
           call D3dB_ny(1,ny)
           call D3dB_nz(1,nz)
           scal1  = 1.0d0/dble(nx*ny*nz)
           scal2  = 1.0d0/lattice_omega()
           call Pack_npack(0,npack0)
           value = MA_push_get(mt_dcpl,npack0,'exi',exi(2),exi(1))
           value = value.and.
     >             MA_push_get(mt_dcpl,npack0,'tmp',tmp(2),tmp(1))
           if (.not.value) call errquit('out of stack memory',0,MA_ERR)

           call dcopy(n2ft3d,0.0d0,0,Vqm,1)
           call dcopy(2*npack0,0.0d0,0,dcpl_mb(tmp(1)),1)
           call dcopy(2*npack0,0.0d0,0,dcpl_mb(exi(1)),1)
           do ii=1,nion
             q1 = -dbl_mb(charge(1)+ii-1)
             call qstrfac_pack(0,ii,dcpl_mb(exi(1)))
             call Pack_cc_daxpy(0,q1,dcpl_mb(exi(1)),Vqm)
             call Pack_cc_daxpy(0,dabs(q1),dcpl_mb(exi(1)),
     >                                     dcpl_mb(tmp(1)))
           end do
c           call Pack_tc_Mul(0,dbl_mb(vc_charge(1)),Vqm,Vqm)
c           call Pack_tc_Mul(0,dbl_mb(vc2_charge(1)),dcpl_mb(tmp(1)),
c     >                                              dcpl_mb(tmp(1)))
           call Pack_tc_Mul2(0,dbl_mb(vc_charge(1)),Vqm)
           call Pack_tc_Mul2(0,dbl_mb(vc2_charge(1)),dcpl_mb(tmp(1)))
           !call Pack_cc_Sum(0,dcpl_mb(tmp(1)),Vqm,Vqm)
           call Pack_c_unpack(0,Vqm)
           call D3dB_cr_fft3b(1,Vqm)
           value =           MA_pop_stack(tmp(2))
           value = value.and.MA_pop_stack(exi(2))
           if (.not. value)
     >     call errquit('pspw_charge_Generate_V:poppingstack memory',0,
     >       MA_ERR)

           call sub_coulomb_screened_init_print(Vqm,1.0d0,q1)


         end if


      end if

      return
      end


*     **********************************
*     *	                               *
*     *     pspw_charge_rho_Fcharge    *
*     *                                *
*     **********************************

      subroutine pspw_charge_rho_Fcharge(n2ft3d,rgrid,rho,dv,fcharge)
      implicit none
      integer n2ft3d
      real*8 rgrid(3,*)
      real*8 rho(*)
      real*8 dv
      real*8 fcharge(3,*)

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     ***** local variables ****
      integer i,j,p1,po2,p2
      real*8 rx,ry,rz,c
      real*8 fx,fy,fz,verf,yerf,v
      real*8 x,y,z,q,r,r2,rc,epsilon,depsilon,sqrt_pi
      real*8 ttt,sss,rr1,rr1m,rr1p,rc1,rc2,rc1p
      double precision tttp,sssp

*     **** external functions ****
      real*8   util_erf
      external util_erf

      if (nion.gt.0) then
      sqrt_pi = dsqrt(4.0d0*datan(1.0d0))

*     **** point charges ****
      if (charge_type.eq.1) then
      do j=1,nion
         x = dbl_mb(r1(1)+3*(j-1))
         y = dbl_mb(r1(1)+3*(j-1)+1)
         z = dbl_mb(r1(1)+3*(j-1)+2)
         q = -dbl_mb(charge(1)+j-1)
         fx = 0.0d0
         fy = 0.0d0
         fz = 0.0d0
         do i=1,n2ft3d
            rx = x - rgrid(1,i)
            ry = y - rgrid(2,i)
            rz = z - rgrid(3,i)
            r  = dsqrt( rx**2 + ry**2 + rz**2)

            if (r .gt. 1.0d-8) then
              v    = -q/r**3
            else
              v = 0.0d0
            end if

            fx = fx + rho(i)*rx*v
            fy = fy + rho(i)*ry*v
            fz = fz + rho(i)*rz*v
         end do

         call D3dB_SumAll(fx)
         call D3dB_SumAll(fy)
         call D3dB_SumAll(fz)
         fcharge(1,j) = fcharge(1,j) - fx*dv
         fcharge(2,j) = fcharge(2,j) - fy*dv
         fcharge(3,j) = fcharge(3,j) - fz*dv
      end do


*     **** switching charge potential **** 
      else if (charge_type.eq.2) then
      do j=1,nion
         x = dbl_mb(r1(1)+3*(j-1))
         y = dbl_mb(r1(1)+3*(j-1)+1)
         z = dbl_mb(r1(1)+3*(j-1)+2)
         q = -dbl_mb(charge(1)+j-1)
         c = 1.0d0/s_sigma
         fx = 0.0d0
         fy = 0.0d0
         fz = 0.0d0
         do i=1,n2ft3d
            rx = x - rgrid(1,i)
            ry = y - rgrid(2,i)
            rz = z - rgrid(3,i)
            r  = dsqrt( rx**2 + ry**2 + rz**2)

            if (r .gt. 1.0d-8) then

*             **** define dielectric switching function ****
              if (r.le.s_d) then
                 epsilon  = 0.0d0
                 depsilon = 0.0d0
              else if (r.lt.(s_d+s_rho)) then
                 epsilon = 1.0d0-(1.0d0-(r-s_d)**2/s_rho**2)**2
                 depsilon = 4.0d0*((r-s_d)/s_rho**2)
     >                           *(1.0d0-(r-s_d)**2/s_rho**2)        
              else
                 epsilon  = 1.0d0
                 depsilon = 0.0d0
              end if
              yerf=r*c
              verf = util_erf(yerf)
              v    = epsilon*q*( (2.0d0/sqrt_pi)*(r*c)*exp(-(r*c)**2)
     >                          - verf)/r**3
     >             + depsilon*q*verf/r**2
            else
              v = 0.0d0
            end if

            fx = fx + rho(i)*rx*v
            fy = fy + rho(i)*ry*v
            fz = fz + rho(i)*rz*v
         end do

         call D3dB_SumAll(fx)
         call D3dB_SumAll(fy)
         call D3dB_SumAll(fz)
         fcharge(1,j) = fcharge(1,j) - fx*dv
         fcharge(2,j) = fcharge(2,j) - fy*dv
         fcharge(3,j) = fcharge(3,j) - fz*dv
      end do

*     **** short-range repulsion ****
      else if (charge_type.eq.3) then
      p1  = n_sigma
      p2  = n_sigma+1
      po2 = n_sigma/2
      do j=1,nion
         x = dbl_mb(r1(1)+3*(j-1))
         y = dbl_mb(r1(1)+3*(j-1)+1)
         z = dbl_mb(r1(1)+3*(j-1)+2)

         q = -dbl_mb(charge(1)+j-1)
         rc = abs(q)*s_sigma
         if (rc.gt.1.0d0) rc=1.0d0 !stupid check
         rc1 = rc**p1
         rc2 = rc**p2

         fx = 0.0d0
         fy = 0.0d0
         fz = 0.0d0
         do i=1,n2ft3d
            rx = x - rgrid(1,i)
            ry = y - rgrid(2,i)
            rz = z - rgrid(3,i)
            r  = dsqrt(rx*rx + ry*ry + rz*rz)

            !rr1m = r**(p1-1)
            !rr1  = r*rr1m
            !rr1p = r2*rr1m
            rr1m = r**(p1-1)
            rr1  = r**p1
            rr1p = r**p2

            ttt = (rc1 -  rr1)
            sss = (rc2 - rr1p)

            tttp = -p1*rr1m
            sssp = -p2*rr1

            if (r .gt. 1.0d-8) then
              v  = q*(tttp - (ttt/sss)*sssp)/(sss*r)
            else
              v  = 0.0d0
            end if

            fx = fx + rho(i)*rx*v
            fy = fy + rho(i)*ry*v
            fz = fz + rho(i)*rz*v
         end do

         call D3dB_SumAll(fx)
         call D3dB_SumAll(fy)
         call D3dB_SumAll(fz)
         fcharge(1,j) = fcharge(1,j) - fx*dv
         fcharge(2,j) = fcharge(2,j) - fy*dv
         fcharge(3,j) = fcharge(3,j) - fz*dv
      end do

      end if


      end if

      return
      end






*     **********************************
*     *	                               *
*     *     pspw_charge_Energy_ion     *
*     *                                *
*     **********************************

      real*8 function pspw_charge_Energy_ion()
      implicit none

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     **** local variables ****
      integer i,ii,ia
      real*8  qi, xi, yi, zi
      real*8  qii,xii,yii,zii
      real*8  r,energy

*     **** external functions ****
      integer   ion_nion,ion_katm
      real*8    ion_rion,psp_zv
      external  ion_nion,ion_katm
      external  ion_rion,psp_zv

      energy = 0.0d0
      do ii=1,ion_nion()
         ia = ion_katm(ii)
         qii = psp_zv(ia)
         xii = ion_rion(1,ii)
         yii = ion_rion(2,ii)
         zii = ion_rion(3,ii)
         do i=1,nion
            xi = dbl_mb(r1(1)+3*(i-1))
            yi = dbl_mb(r1(1)+3*(i-1)+1)
            zi = dbl_mb(r1(1)+3*(i-1)+2)
            qi = dbl_mb(charge(1)+i-1)
            r = (xi-xii)**2 + (yi-yii)**2 + (zi-zii)**2
            r = dsqrt(r)
            energy = energy + qi*qii/r
         end do
      end do


      pspw_charge_Energy_ion = energy
      return
      end




*     **********************************
*     *	                               *
*     *     pspw_charge_Fion_Fcharge   *
*     *                                *
*     **********************************

*    This routine calculates the forces between the QM ions and point charges.
*
*     Exit - fion: force on the QM ions
*            fcharge: force on the point charges
*
*     Uses - ion_nion,Q_Electrostatic_Force
*
*     Author - Eric Bylaska

      subroutine pspw_charge_Fion_Fcharge(fion,fcharge)
      implicit none
      real*8 fion(3,*)
      real*8 fcharge(3,*)

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     **** local variables ****
      integer i,j,nion_ion
      real*8  qi,ri(3),qj,rj(3)

*     **** external functions ****
      integer  ion_katm,ion_nion
      real*8   psp_zv,ion_rion
      external ion_katm,ion_nion
      external psp_zv,ion_rion

      if (nion.gt.0) then      
     
        nion_ion = ion_nion()

        do i=1,nion_ion
           qi = psp_zv(ion_katm(i))
           ri(1) = ion_rion(1,i)
           ri(2) = ion_rion(2,i)
           ri(3) = ion_rion(3,i)
           do j=1,nion
              qj = dbl_mb(charge(1)+j-1)            
              rj(1) = dbl_mb(r1(1)+3*(j-1))
              rj(2) = dbl_mb(r1(1)+3*(j-1)+1)
              rj(3) = dbl_mb(r1(1)+3*(j-1)+2)
              call Q_Electrostatic_Force(ri,qi,fion(1,i),
     >                                 rj,qj,fcharge(1,j))
           end do
        end do

      end if
      return
      end


*     **********************************
*     *	                               *
*     *    pspw_charge_charge_Fion     *
*     *                                *
*     **********************************

*    This routine calculates the forces between the QM ions and point charges.
*
*     Exit - fion: force on the QM ions
*            fcharge: force on the point charges
*
*     Uses - ion_nion,Q_Electrostatic_Force
*
*     Author - Eric Bylaska

      subroutine pspw_charge_charge_Fion(fion)
      implicit none
      real*8 fion(3,*)

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     **** local variables ****
      integer i,j,nion_ion
      real*8  qi,ri(3),qj,rj(3)
      real*8  fcharge(3)

*     **** external functions ****
      integer  ion_katm,ion_nion
      real*8   psp_zv,ion_rion
      external ion_katm,ion_nion
      external psp_zv,ion_rion

      if (nion.gt.0) then      
     
        fcharge(1) = 0.0d0
        fcharge(2) = 0.0d0
        fcharge(3) = 0.0d0
        nion_ion = ion_nion()

        do i=1,nion_ion
           qi = psp_zv(ion_katm(i))
           ri(1) = ion_rion(1,i)
           ri(2) = ion_rion(2,i)
           ri(3) = ion_rion(3,i)
           do j=1,nion
              qj = dbl_mb(charge(1)+j-1)            
              rj(1) = dbl_mb(r1(1)+3*(j-1))
              rj(2) = dbl_mb(r1(1)+3*(j-1)+1)
              rj(3) = dbl_mb(r1(1)+3*(j-1)+2)
              call Q_Electrostatic_Force(ri,qi,fion(1,i),
     >                                 rj,qj,fcharge)
           end do
        end do

      end if
      return
      end


*     **********************************
*     *	                               *
*     *     pspw_charge_Energy_charge  *
*     *                                *
*     **********************************

      real*8 function pspw_charge_Energy_charge()
      implicit none

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     **** local variables ****
      integer i,ii
      real*8  qi, xi, yi, zi
      real*8  qii,xii,yii,zii
      real*8  r,energy

*     **** external functions ****
      logical  nwpw_bqbq
      external nwpw_bqbq

      energy = 0.0d0
      if ((nion.gt.0).and.nwpw_bqbq()) then
        do ii=1,nion
           qii = dbl_mb(charge(1)+ii-1)            
           xii = dbl_mb(r1(1)+3*(ii-1))
           yii = dbl_mb(r1(1)+3*(ii-1)+1)
           zii = dbl_mb(r1(1)+3*(ii-1)+2)
           qii = dbl_mb(charge(1)+ii-1)
           do i=1,ii-1
              xi = dbl_mb(r1(1)+3*(i-1))
              yi = dbl_mb(r1(1)+3*(i-1)+1)
              zi = dbl_mb(r1(1)+3*(i-1)+2)
              qi = dbl_mb(charge(1)+i-1)
              r = (xi-xii)**2 + (yi-yii)**2 + (zi-zii)**2
              r = dsqrt(r)
              energy = energy + qi*qii/r
           end do
        end do
      end if

      pspw_charge_Energy_charge = energy
      return
      end


*     **********************************
*     *	                               *
*     *     pspw_charge_Fcharge        *
*     *                                *
*     **********************************

*    This routine calculates the force between the point charges.
*
*     Exit - fcharge: force on the point charges
*
*     Uses - Q_Electrostatic_Force
*
*     Author - Eric Bylaska

      subroutine pspw_charge_Fcharge(fcharge)
      implicit none
      real*8 fcharge(3,*)

#include "mafdecls.fh"
#include "pspw_charge.fh"

*     **** local variables ****
      integer i,j
      real*8  qi,ri(3),qj,rj(3)

*     **** external functions ****
      logical  nwpw_bqbq
      external nwpw_bqbq

      if ((nion.gt.0).and.(nwpw_bqbq())) then      
     
        do j=1,nion
           qj = dbl_mb(charge(1)+j-1)            
           rj(1) = dbl_mb(r1(1)+3*(j-1))
           rj(2) = dbl_mb(r1(1)+3*(j-1)+1)
           rj(3) = dbl_mb(r1(1)+3*(j-1)+2)
           do i=1,j-1
              qi = dbl_mb(charge(1)+i-1)            
              ri(1) = dbl_mb(r1(1)+3*(i-1))
              ri(2) = dbl_mb(r1(1)+3*(i-1)+1)
              ri(3) = dbl_mb(r1(1)+3*(i-1)+2)
              call Q_Electrostatic_Force(ri,qi,fcharge(1,i),
     >                                   rj,qj,fcharge(1,j))
           end do
        end do

      end if
      return
      end



*********************************************************************************************************




*     **********************************
*     *	                               *
*     *  pspw_charge_Generate_V_qmmm   *
*     *                                *
*     **********************************

      subroutine pspw_charge_Generate_V_qmmm(r1,charge1,n1,
     >                                       n2ft3d,rgrid,Vqm)
      implicit none
      real*8 r1(3,*),charge1(*)
      integer n1
      integer n2ft3d
      real*8 rgrid(3,*)
      real*8 Vqm(*)


*     ***** local variables ****
      integer ii,ia,k,p1,p2,po2
      real*8 x1,y1,z1,q1,r,r2,rc,ttt,sss
      real*8 rc1,rc2,rr1,rr1p
      real*8  s_sigma
      integer n_sigma

      if (n1.gt.0) then

        s_sigma = ((0.37d0/0.3d0)/0.529177d0)  ! should give covalent radii for spc water
        n_sigma = 4

*        **** short-range repulsion ****
         p1  = n_sigma
         po2 = n_sigma/2
         p2  = n_sigma+1
         do ii=1,n1
            x1 = r1(1,ii)
            y1 = r1(2,ii)
            z1 = r1(3,ii)
            q1 = charge1(ii)
c           a way to define covalent radius
            rc = abs(q1)*s_sigma
            if (rc.gt.1.0d0) rc=1.0d0 !stupid check
            !rc1 = abs(q1)*rc**p1
            rc1 = rc**p1
            rc2 = rc**p2
            do k=1,n2ft3d
               r2 = (rgrid(1,k)-x1)**2
     >            + (rgrid(2,k)-y1)**2
     >            + (rgrid(3,k)-z1)**2
               r = dsqrt(r2)
               rr1  = r**p1
               rr1p = r**p2
               ttt = (rc1 - rr1)
               sss = (rc2 - rr1p)

               Vqm(k) = Vqm(k) - q1*(ttt/sss)
            end do
         end do   


      end if

      return
      end






*     **********************************
*     *	                               *
*     *  pspw_charge_rho_Fcharge_qmmm  *
*     *                                *
*     **********************************
*
*     Calculates the force on the qmmm charges from the electronic density
*

      subroutine pspw_charge_rho_Fcharge_qmmm(r1,qcharge,nion,
     >                                     n2ft3d,rgrid,rho,dv,fcharge)
      implicit none
      real*8  r1(3,*),qcharge(*)
      integer nion
      integer n2ft3d
      real*8 rgrid(3,*)
      real*8 rho(*)
      real*8 dv
      real*8 fcharge(3,*)


*     ***** local variables ****
      integer i,j,p1,po2,p2
      real*8 rx,ry,rz,c
      real*8 fx,fy,fz,v
      real*8 x,y,z,q,r,r2,rc
      real*8 ttt,sss,rr1,rr1m,rr1p,rc1,rc2,rc1p
      double precision tttp,sssp
      integer n_sigma
      real*8  s_sigma

*     **** external functions ****

      if (nion.gt.0) then

      s_sigma = (0.37d0/0.3d0)/0.529177d0  ! should give covalent radii for spc water
      n_sigma = 4
 
      p1  = n_sigma
      p2  = n_sigma+1
      po2 = n_sigma/2
      do j=1,nion
         x = r1(1,j)
         y = r1(2,j)
         z = r1(3,j)
         q = -qcharge(j)
         rc = abs(q)*s_sigma
         if (rc.gt.1.0d0) rc=1.0d0  ! stupid check
         rc1 = rc**p1
         rc2 = rc**p2
         fx = 0.0d0
         fy = 0.0d0
         fz = 0.0d0
         do i=1,n2ft3d
            rx = x - rgrid(1,i)
            ry = y - rgrid(2,i)
            rz = z - rgrid(3,i)
            r  = dsqrt(rx*rx + ry*ry + rz*rz)

            !rr1m = r**(p1-1)
            !rr1  = r*rr1m
            !rr1p = r2*rr1m
            rr1m = r**(p1-1)
            rr1  = r**p1
            rr1p = r**p2

            ttt = (rc1  - rr1)
            sss = (rc2 - rr1p)

            tttp = -p1*rr1m
            sssp = -p2*rr1

            if (r .gt. 1.0d-8) then
              v  = q*(tttp - (ttt/sss)*sssp)/(sss*r)
            else
              v  = 0.0d0
            end if

            fx = fx + rho(i)*rx*v
            fy = fy + rho(i)*ry*v
            fz = fz + rho(i)*rz*v
         end do

         call D3dB_SumAll(fx)
         call D3dB_SumAll(fy)
         call D3dB_SumAll(fz)
         fcharge(1,j) = fcharge(1,j) - fx*dv
         fcharge(2,j) = fcharge(2,j) - fy*dv
         fcharge(3,j) = fcharge(3,j) - fz*dv

c         call D3dB_r_dsum(1,rho,sss)
c         write(*,*) "fq-elc a,",j,q,nion,n2ft3d,dv,sss*dv
c         write(*,*) "fq-elc b,",j,r1(1,j),r1(2,j),r1(3,j)
c         write(*,*) "fq-elc c,",j,fcharge(1,j),fcharge(2,j),fcharge(3,j)
c         write(*,*) "fq-elc d,",j,fx,fy,fz
c         write(*,*) "fq-elc e,",j,fx*dv,fy*dv,fz*dv
      end do


      end if

      return
      end





*     **********************************
*     *	                               *
*     *   pspw_charge_Energy_ion_qmmm  *
*     *                                *
*     **********************************

*    This routine calculates the energy between the QM ions and point charges.

      real*8 function pspw_charge_Energy_ion_qmmm(r1,qcharge,nion)
      implicit none
      real*8 r1(3,*),qcharge(*)
      integer nion


*     **** local variables ****
      integer i,ii,ia
      real*8  qi, xi, yi, zi
      real*8  qii,xii,yii,zii
      real*8  r,energy

*     **** external functions ****
      integer   ion_nion,ion_katm
      real*8    ion_rion,psp_zv
      external  ion_nion,ion_katm
      external  ion_rion,psp_zv

      energy = 0.0d0
      do ii=1,ion_nion()
         ia = ion_katm(ii)
         qii = psp_zv(ia)
         xii = ion_rion(1,ii)
         yii = ion_rion(2,ii)
         zii = ion_rion(3,ii)
         do i=1,nion
            xi = r1(1,i)
            yi = r1(2,i)
            zi = r1(3,i)
            qi = qcharge(i)
            r = (xi-xii)**2 + (yi-yii)**2 + (zi-zii)**2
            r = dsqrt(r)
            energy = energy + qi*qii/r
         end do
      end do

      pspw_charge_Energy_ion_qmmm = energy
      return
      end




*     **********************************
*     *	                               *
*     *  pspw_charge_Fion_Fcharge_qmmm *
*     *                                *
*     **********************************

*    This routine calculates the forces between the QM ions and point charges.
*
*     Exit - fion: force on the QM ions
*            fcharge: force on the point charges
*
*     Uses - ion_nion,Q_Electrostatic_Force
*
*     Author - Eric Bylaska

      subroutine pspw_charge_Fion_Fcharge_qmmm(r1,qcharge,nion,
     >                                         fion,fcharge)
      implicit none
      real*8 r1(3,*),qcharge(*)
      integer nion
      real*8 fion(3,*)
      real*8 fcharge(3,*)

*     **** local variables ****
      integer i,j,nion_ion
      real*8  qi,ri(3),qj,rj(3)

*     **** external functions ****
      integer  ion_katm,ion_nion
      real*8   psp_zv,ion_rion
      external ion_katm,ion_nion
      external psp_zv,ion_rion

      if (nion.gt.0) then      
     
        nion_ion = ion_nion()

        do i=1,nion_ion
           qi = psp_zv(ion_katm(i))
           ri(1) = ion_rion(1,i)
           ri(2) = ion_rion(2,i)
           ri(3) = ion_rion(3,i)
           do j=1,nion
              qj = qcharge(j)            
              rj(1) = r1(1,j)
              rj(2) = r1(2,j)
              rj(3) = r1(3,j)
              call Q_Electrostatic_Force(ri,qi,fion(1,i),
     >                                 rj,qj,fcharge(1,j))
           end do
        end do

      end if
      return
      end

*     **********************************
*     *	                               *
*     *  pspw_charge_ion_Fcharge_qmmm  *
*     *                                *
*     **********************************

*    This routine calculates the forces between the QM ions and point charges.
*
*     Exit - fion: force on the QM ions
*            fcharge: force on the point charges
*
*     Uses - ion_nion,Q_Electrostatic_Force
*
*     Author - Eric Bylaska

      subroutine pspw_charge_ion_Fcharge_qmmm(r1,qcharge,nion,fcharge)
      implicit none
      real*8 r1(3,*),qcharge(*)
      integer nion
      real*8 fcharge(3,*)

*     **** local variables ****
      integer i,j,nion_ion
      real*8  qi,ri(3),qj,rj(3)
      real*8 fion(3)

*     **** external functions ****
      integer  ion_katm,ion_nion
      real*8   psp_zv,ion_rion
      external ion_katm,ion_nion
      external psp_zv,ion_rion

      fion(1) = 0.0d0
      fion(2) = 0.0d0
      fion(3) = 0.0d0
      if (nion.gt.0) then      
     
        nion_ion = ion_nion()

        do i=1,nion_ion
           qi = psp_zv(ion_katm(i))
           ri(1) = ion_rion(1,i)
           ri(2) = ion_rion(2,i)
           ri(3) = ion_rion(3,i)
           do j=1,nion
              qj = qcharge(j)            
              rj(1) = r1(1,j)
              rj(2) = r1(2,j)
              rj(3) = r1(3,j)
              call Q_Electrostatic_Force(ri,qi,fion,
     >                                 rj,qj,fcharge(1,j))
           end do
        end do

      end if
      return
      end

      subroutine argos_cafe_sfree()
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
c      if(.not.lscr) call md_abort('Error 1 in argos_cafe_sfree',0)
      if(.not.lscr) return
c
      if(ipme.gt.0) then
      if(.not.ma_free_heap(l_dtheta))
     + call md_abort('Failed to free scratch array dtheta',0)
      if(.not.ma_free_heap(l_theta))
     + call md_abort('Failed to free scratch array theta',0)
      if(.not.ma_free_heap(l_pmew))
     + call md_abort('Failed to free scratch array pmew',0)
      if(.not.ma_free_heap(l_pmes))
     + call md_abort('Failed to free scratch array pmes',0)
      endif
c
      if(.not.ma_free_heap(l_smr6))
     + call md_abort('Failed to free scratch array smr6',0)
c
      if(.not.ma_free_heap(l_smr5))
     + call md_abort('Failed to free scratch array smr5',0)
c
      if(.not.ma_free_heap(l_smr4))
     + call md_abort('Failed to free scratch array smr4',0)
c
      if(.not.ma_free_heap(l_smr3))
     + call md_abort('Failed to free scratch array smr3',0)
c
      if(.not.ma_free_heap(l_smr2))
     + call md_abort('Failed to free scratch array smr2',0)
c
      if(.not.ma_free_heap(l_smr1))
     + call md_abort('Failed to free scratch array smr1',0)
c
      if(.not.ma_free_heap(l_s3r2))
     + call md_abort('Failed to free scratch array s3r2',0)
c
      if(.not.ma_free_heap(l_s3r1))
     + call md_abort('Failed to free scratch array s3r1',0)
c
      if(.not.ma_free_heap(l_s1r6))
     + call md_abort('Failed to free scratch array s1r6',0)
c
      if(.not.ma_free_heap(l_s1r5))
     + call md_abort('Failed to free scratch array s1r5',0)
c
      if(.not.ma_free_heap(l_s1r4))
     + call md_abort('Failed to free scratch array s1r4',0)
c
      if(.not.ma_free_heap(l_s1r3))
     + call md_abort('Failed to free scratch array s1r3',0)
c
      if(.not.ma_free_heap(l_s1r2))
     + call md_abort('Failed to free scratch array s1r2',0)
c
      if(.not.ma_free_heap(l_s1r1))
     + call md_abort('Failed to free scratch array s1r1',0)
c
      if(.not.ma_free_heap(l_s2i1))
     + call md_abort('Failed to free scratch array s2i1',0)
c
      if(.not.ma_free_heap(l_s1i6))
     + call md_abort('Failed to free scratch array s1i6',0)
c
      if(.not.ma_free_heap(l_s1i5))
     + call md_abort('Failed to free scratch array s1i5',0)
c
      if(.not.ma_free_heap(l_s1i4))
     + call md_abort('Failed to free scratch array s1i4',0)
c
      if(.not.ma_free_heap(l_s1i3))
     + call md_abort('Failed to free scratch array s1i3',0)
c
      if(.not.ma_free_heap(l_s1i2))
     + call md_abort('Failed to free scratch array s1i2',0)
c
      if(.not.ma_free_heap(l_s1i1))
     + call md_abort('Failed to free scratch array s1i1',0)
c
      lscr=.false.
c
      return
      end
c $Id: argos_cafe_sfree.F 21176 2011-10-10 06:35:49Z d3y133 $

c     $Id: ofpw_energy.F 19707 2010-10-29 17:59:36Z d3y133 $
      logical function ofpw_energy(rtdb)
      implicit none
      integer rtdb
      logical  ofpw_minimizer
      external ofpw_minimizer

      write(*,*) "hello from ofpw_energy"
      ofpw_energy = ofpw_minimizer(rtdb,0)
      return
      end

C> \ingroup selci
C> @{
      subroutine selci_mkinta(int12, int34)
*
* $Id: mkinta.F 24790 2013-11-11 18:56:49Z d3y133 $
*
#include "implicit.fh"
#include "ciinfo.fh"
      dimension itemp(8), int12(*), int34(*)
#include "bitops.fh"
c
c     make the integral addressing arrays
c     int34(ij) = position of ij amoungst pairs of same symmetry
c     int12(ij) = sum of int12(kl) for kl<ij and same symmetry
c
      call ifill(nsym,0,itemp,1)
      call ifill(nnorbs,0,int12,1)
      call ifill(nnorbs,0,int34,1)
      ij = 0
      do 10 i = 1,norbs
         do 20 j = 1,i
            ijs = ieor(isym(i),isym(j)) + 1
            itemp(ijs) = itemp(ijs) + 1
            ij = ij + 1
            int34(ij) = itemp(ijs)
 20      continue
 10   continue
c
      ipt = 0
      kl = 0
      do 30 k = 1,norbs
         do 40 l = 1,k
            kl = kl + 1
            int12(kl) = ipt
            ipt = ipt + int34(kl)
 40      continue
 30   continue
c     
      numint = ipt + int34(kl)
c
      end
C> @}

C> \ingroup nwint
C> @{
C>
C> \brief Compute 1-electron 1-center Gaussian periodic nuclear attraction
C> integrals derivatives
C>
C> See [1] for details.
C>
C> [1] JE Jaffe, AC Hess,
C>     <i>"Gaussian basis density functional theory for systems
C>     periodic in two or three dimensions: Energy and forces"</i>,
C>    J.Chem.Phys. <b>105</b>, 10983-10998 (1996), DOI:
C>    <a href="http://dx.doi.org/10.1063/1.472866">
C>    10.1063/1.472866</a>
C>
      subroutine intpd_1e1cpe(i_basis,ish,Ri,lscr,scr,lpea,Pea)
*
* $Id: intpd_1e1cpe.F 23398 2013-01-08 08:18:46Z d3y133 $
*
      implicit none
#include "apiP.fh"
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
c::external subroutines used
c errquit
c::functions
      logical int_chk_init
      logical int_chk_sh
      logical cando_nw_1e
      logical cando_nw
      integer int_nint_cart
      external int_chk_init
      external int_chk_sh
      external cando_nw_1e
      external cando_nw
      external int_nint_cart
c::passed
      integer i_basis           !< [Input] basis set handle for ish functions
      integer ish               !< [Input] lexical contraction/shell index
      integer lscr              !< [Input] length of the scratch array
      integer lpea              !< [Input] length of potential energy derivative integral array
      double precision Pea(lpea) !< [Output] potential energy derivative integral array
      double precision scr(lscr) !< [Scratch] scratch array
      double precision Ri(3)    !< [Input] translation vector for ish center (fractional coordinates)
c::local
      logical shells_ok
      integer mynint
      integer i_geom, ibas, ucont, mynat
      integer Li, i_prim, i_gen, i_iexp, i_icfp, i_cent
      double precision xyz_new_i(3) ! new coordinates for ish function center
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c check initialization and shells
c
      if (.not.int_chk_init('intpd_1e1cpe'))
     &    call errquit('intpd_1e1cpe: int_init was not called' ,0, 
     &            INT_ERR)
c
      shells_ok = int_chk_sh(i_basis,ish)
      if (.not.shells_ok)
     &    call errquit('intpd_1e1cpe: invalid contraction/shell',0,
     &             BASIS_ERR)
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
c
      ucont   = (sf_ibs_cn2ucn(ish,ibas))
      Li      = infbs_cont(CONT_TYPE ,ucont,ibas)
      i_prim  = infbs_cont(CONT_NPRIM,ucont,ibas)
      i_gen   = infbs_cont(CONT_NGEN ,ucont,ibas)
      i_iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      i_icfp  = infbs_cont(CONT_ICFP ,ucont,ibas)
      i_cent  = (sf_ibs_cn2ce(ish,ibas))
      i_geom  = ibs_geom(ibas)
      mynint  = int_nint_cart(i_basis,ish, 0,0, 0,0, 0,0)
      mynat = ncenter(i_geom)
      if (lpea*3*mynat.lt.mynint) stop ' internal error '
c
c.. translate ish center coordinates based on Ri
      call intp_txyz(i_cent,i_geom,Ri,xyz_new_i)
c
      if (cando_nw(i_basis,ish,0)) then        
        call hf1d(
     &      xyz_new_i,dbl_mb(mb_exndcf(i_iexp,ibas)),
     &      dbl_mb(mb_exndcf(i_icfp,ibas)), i_prim, i_gen, Li, i_cent,
     &      xyz_new_i,DCexp,DCcoeff, 1, 1, 0, i_cent,
     &      coords(1,1,i_geom),charge(1,i_geom),
     &      geom_invnucexp(1,i_geom),ncenter(i_geom),
c.............................. doS     doT     doV    canonical
     &      scr,scr,Pea,mynint,.false.,.false.,.true.,.false.,
c........... dryrun
     &      .false.,scr,lscr)
        if (bas_spherical(ibas)) then
          if (Li.eq.-1) i_gen = 1
          call spcart_2cBtran(Pea,scr,lscr,
     &        int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &        int_nbf_x( 0),int_nbf_x( 0), 0,    1,.false.,
     &        (3*ncenter(i_geom)),.false.)
        endif
      else
        call errquit('intpd_1e1cpe: could not do sp or nw integrals',0,
     &            INT_ERR)
      endif
c
      end
C> @}

      subroutine dia_wtfram(fmt,sgmnam,x,w,isel,tag,val,
     + iwsel,ndxw,ifr)
c
c $Id: dia_wtfram.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "dia_common.fh"
#include "mafdecls.fh"
c
      real*8 x(msa,3),w(mwm,mwa,3),val(nsa,2)
      integer isel(msa),iwsel(mwm),ndxw(nwm)
      integer ifr
      character*24 tag(msa,2)
      character*3 fmt
      character*16 sgmnam(msa)
c
      character*10 today,now
      integer i,j,k,l
      character*2 elemnt
c
      character*1 cdummy
      character*7 string
      integer nsb,ib,jb,nss,nwb
c
      character*255 fname
      character*255 color
      real*8 xh(3)
c
      real*8 xbmax,xbmin,ybmax,ybmin,zbmax,zbmin,factor
      integer*4 numato
c
      real*8 dia_atrad
      integer pre_atnum
      character*255 atom_color
      external dia_atrad,pre_atnum,atom_color
c
      real*8 rv(3),rw(3),rotang,rx(3),ry(3),rxi(3),rxj(3),twopi
c
      logical logw,logs
c
      logs=.true.
      logw=.not.lsonly
c
      twopi=8.0d0*tan(1.0d0)
c
      if(me.eq.0) then
c
c      if(lfncop.eq.lfncop) then
c      if(ncop.gt.mcopf.and.mcopf.gt.0) then
c      ncop=1
c      if(fmt.eq.'eci') write(lfncop,'(a)') 'End'
c      close(unit=lfncop)
c      icopf=icopf+1
c      call dia_wthdr(lfncop,fmtcop,byte_mb(i_snam),tag,isel,.false.)
c      endif
c      endif
c
c      if(lfncop.eq.lfnsup) then
c      if(nsup.gt.msupf.and.msupf.gt.0) then
c      nsup=1
c      if(fmt.eq.'eci') write(lfncop,'(a)') 'End'
c      close(unit=lfncop)
c      isupf=isupf+1
c      call dia_wthdr(lfnsup,fmtsup,byte_mb(i_snam),tag,isel,.false.)
c      endif
c      endif
c
      if(fmt.eq.'trj') then
      write(lfncop,1000)
 1000 format('frame')
      write(lfncop,1001) time,temp,pres,datum,tijd
 1001 format(2f12.6,e12.5,2a10)
c      write(*,'(a,2f12.6,e12.5)') 'frame ',time,temp,pres
      write(lfncop,1002) box(1),0.0,0.0,0.0,box(2),0.0,
     + 0.0,0.0,box(3)
 1002 format(3f12.6,/,3f12.6,/,3f12.6)
      write(lfncop,1003) lxw.and..not.lsonly,.false.,.false.,.false.,
     + lsx,.false.,.false.,.false.,nwsel,nwa,nsa
 1003 format(8l1,3i10)
      if(lxw.and..not.lsonly) then
      do 1 i=1,nwm
      if(iwsel(i).ne.0) then
      do 2 j=1,nwa
      write(lfncop,1004) (w(i,j,k),k=1,3)
 1004 format(3f8.3)
    2 continue
      endif
    1 continue
      endif
      if(lsx) then
      do 3 i=1,nsa
      write(lfncop,1005) (x(i,j),j=1,3)
 1005 format(3f8.3)
    3 continue
      endif
      endif
c
      if(fmt.eq.'arc') then
      call swatch(today,now)
      write(lfncop,2000) time,today,now
 2000 format('title ',t67,f10.3,/,'!DATE ',2a10)
      nss=0
      if(lsx) then
      do 4 i=1,nsa
      if(.not.lesd.or.isel(i).ne.0) then
      string=sgmnam(i)(13:16)//'   '
      if(sgmnam(i)(13:13).eq.' ') string=sgmnam(i)(14:16)//'    '
      if(sgmnam(i)(14:14).eq.' ') string=sgmnam(i)(15:16)//'     '
      if(sgmnam(i)(15:15).eq.' ') string=sgmnam(i)(16:16)//'      '
      if(sgmnam(i)(6:6).eq.' '.or.
     + sgmnam(i)(6:6).eq.'2'.or.sgmnam(i)(6:6).eq.'3'.or.
     + sgmnam(i)(6:6).eq.'4'.or.sgmnam(i)(6:6).eq.'1') then
      write(lfncop,2001) sgmnam(i)(6:9),(1.0d1*x(i,j),j=1,3),
     + sgmnam(i)(1:4),string,'?',sgmnam(i)(7:7)//' ',0.0
      else
      write(lfncop,2001) sgmnam(i)(6:9),(1.0d1*x(i,j),j=1,3),
     + sgmnam(i)(1:4),string,'?',sgmnam(i)(6:7),0.0
      endif
 2001 format(a4,1x,3f15.9,1x,a4,1x,a7,a1,7x,a2,f7.3)
      endif
    4 continue
      write(lfncop,2002)
      read(sgmnam(nsa)(13:16),'(i4)') nss
      endif
      if(lxw.and..not.lsonly) then
      do 44 i=1,nwm
      if(iwsel(i).ne.0) then
      write(string,'(i7)') i+nss
      if(string(1:1).eq.' ') string=string(2:7)//' '
      if(string(1:1).eq.' ') string=string(2:7)//' '
      if(string(1:1).eq.' ') string=string(2:7)//' '
      if(string(1:1).eq.' ') string=string(2:7)//' '
      if(string(1:1).eq.' ') string=string(2:7)//' '
      if(string(1:1).eq.' ') string=string(2:7)//' '
      if(string(1:1).eq.' ') string=string(2:7)//' '
      do 45 j=1,nwa
      if(wnam(j)(6:6).eq.' '.or.
     + wnam(j)(6:6).eq.'2'.or.wnam(j)(6:6).eq.'3'.or.
     + wnam(j)(6:6).eq.'4'.or.wnam(j)(6:6).eq.'1') then
      write(lfncop,2001) wnam(j)(6:9),(1.0d1*w(i,j,k),k=1,3),
     + wnam(j)(1:4),string,'?',wnam(j)(7:7)//' ',0.0
      else
      write(lfncop,2001) wnam(j)(6:9),(1.0d1*w(i,j,k),k=1,3),
     + wnam(j)(1:4),string,'?',wnam(j)(6:7),0.0
      endif
   45 continue
      write(lfncop,2002)
      endif
   44 continue
      endif
      write(lfncop,2002)
 2002 format('end')
      endif
c
      if(fmt.eq.'amb') then
      if(lxw.and..not.lsonly) then
      write(lfncop,3000) ((1.0d1*(x(i,j)+0.5d0*box(j)),j=1,3),i=1,nsa),
     + (((1.0d1*(w(ndxw(i),j,k)+0.5d0*box(k)),k=1,3),j=1,nwa),i=1,nwsel)
      else
      write(lfncop,3000) ((1.0d1*(x(i,j)+0.5d0*box(j)),j=1,3),i=1,nsa)
      endif
c      write(lfncop,3000) (1.0d1*box(j),j=1,3)
 3000 format(10f8.3)
      endif
c
      if(fmt.eq.'crd') then
      if(lxw.and..not.lsonly) then
      write(lfncop,3000) ((1.0d1*(x(i,j)),j=1,3),i=1,nsa),
     + (((1.0d1*(w(ndxw(i),j,k)),k=1,3),j=1,nwa),i=1,nwsel)
      else
      write(lfncop,3000) ((1.0d1*(x(i,j)),j=1,3),i=1,nsa)
      endif
      write(lfncop,3000) (1.0d1*box(j),j=1,3)
      endif
c
      if(fmt.eq.'bam') then
      if(lxw.and..not.lsonly) then
      write(lfncop) ((real(1.0d1*(x(i,j)+0.5d0*box(j))),j=1,3),i=1,nsa),
     + (((1.0d1*(w(i,j,k)+0.5d0*box(k)),k=1,3),j=1,nwa),i=1,nwm),
     + (real(1.0d1*box(j)),j=1,3)
      else
      write(lfncop) ((real(1.0d1*(x(i,j)+0.5d0*box(j))),j=1,3),i=1,nsa),
     + (real(1.0d1*box(j)),j=1,3)
      endif
      endif
c
      if(fmt.eq.'dcd') then
      if(.not.ldcd) then
      numato=nsa
      if(lxw.and..not.lsonly) numato=nsa+nwa*nwm
      write(lfncop) numato
      ldcd=.true.
      endif
      do 72 k=1,3
      if(lxw.and..not.lsonly) then
      write(lfncop) (1.0d1*(x(i,k)+0.5d0*box(k)),i=1,nsa),
     + ((1.0d1*(w(i,j,k)+0.5d0*box(k)),j=1,nwa),i=1,nwm)
      else
      write(lfncop) (1.0d1*(x(i,k)+0.5d0*box(k)),i=1,nsa)
      endif
   72 continue
      endif
c
      if(fmt.eq.'eci') then
      write(lfncop,5000) time
 5000 format('Time ',f12.4)
      write(lfncop,5001) nsa
 5001 format('Geometry{',/,i7,/,' ')
      do 5 i=1,nsa
      elemnt=sgmnam(i)(6:7)
      if(elemnt(1:1).eq.'1'.or.elemnt(1:1).eq.'2'.or.
     + elemnt(1:1).eq.'3'.or.elemnt(1:1).eq.'4') elemnt(1:1)=' '
      write(lfncop,5002) elemnt,(1.0d1*x(i,j),j=1,3)
 5002 format(a2,3f12.4)
    5 continue
      write(lfncop,5003)
 5003 format('}')
      endif
c
      if(fmt.eq.'mvm') then
      write(lfncop,6001) nsa
 6001 format('Geometry{',/,'num_atoms:',i7,/,'atom_list:')
      do 6 i=1,nsa
      elemnt=sgmnam(i)(6:7)
      if(elemnt(1:1).eq.'1'.or.elemnt(1:1).eq.'2'.or.
     + elemnt(1:1).eq.'3'.or.elemnt(1:1).eq.'4') elemnt(1:1)=' '
      write(lfncop,6002) elemnt,(1.0d1*x(i,j),j=1,3)
 6002 format(a2,3f12.4)
    6 continue
      open(unit=44,file='.header',form='formatted',
     + status='unknown')
      rewind(44)
      read(44,4401) nwa,nsa,nsb,nwb
 4401 format(4i10)
      do 7 i=1,nwa+nsa+nwb
      read(44,4402) cdummy
 4402 format(a1)
    7 continue
      write(lfncop,6003) nsb
 6003 format('num_bonds:      ',i7,/,'bond_list:')
      do 8 i=1,nsb
      read(44,6004) ib,jb
      write(lfncop,6004) ib,jb
 6004 format(2i8)
    8 continue
      close(unit=44)
      write(lfncop,6005)
 6005 format('}')
      endif
c
      if(fmt.eq.'frm') then
      if(lsx) then
      write(lfncop,7001)
 7001 format(/,'Geometry {')
      do 9 i=1,nsa
      if(isel(i).ne.0) write(lfncop,7002) (1.0d1*x(i,j),j=1,3)
 7002 format(3f12.4)
    9 continue
      write(lfncop,7003)
 7003 format('}')
      endif
      endif
c
      if(fmt.eq.'pdb') then
c      write(fname,'(a,i5.5,a)') root(1:index(root,'.')-1),indx,'.pdb '
c      write(*,'(a,a)') 'Writing ',fname
      call dia_wrtpdb(.false.,lfncop,fname,sgmnam,isel,x,iwsel,w,
     + logs,logw,ndxw,ifr)
      endif
c
      if(fmt.eq.'pov') then
      xbmax=x(1,1)
      xbmin=x(1,1)
      ybmax=x(1,2)
      ybmin=x(1,2)
      zbmax=x(1,3)
      zbmin=x(1,3)
      do 234 i=2,nsa
      xbmax=max(xbmax,x(i,1))
      xbmin=min(xbmin,x(i,1))
      ybmax=max(ybmax,x(i,2))
      ybmin=min(ybmin,x(i,2))
      zbmax=max(zbmax,x(i,3))
      zbmin=min(zbmin,x(i,3))
  234 continue
      if(lxw.and..not.lsonly) then
      do 235 i=1,nwm
      if(iwsel(i).ne.0) then
      do 236 j=1,nwa
      xbmax=max(xbmax,w(i,j,1))
      xbmin=min(xbmin,w(i,j,1))
      ybmax=max(ybmax,w(i,j,2))
      ybmin=min(ybmin,w(i,j,2))
      zbmax=max(zbmax,w(i,j,3))
      zbmin=min(zbmin,w(i,j,3))
  236 continue
      endif
  235 continue
      endif
      if(scale.le.0.0d0) then
      scale=2.0d0/max(xbmax-xbmin,ybmax-ybmin,zbmax-zbmin)
      xbmax=scale*xbmax
      xbmin=scale*xbmin
      ybmax=scale*ybmax
      ybmin=scale*ybmin
      zbmax=scale*zbmax
      zbmin=scale*zbmin
      if(me.eq.0) write(*,3333) scale
 3333 format(' Scaling set to ',f12.6)
      endif
      call povinc(lfncop,xbmin,xbmax,ybmin,ybmax,zbmin,zbmax)
      npov=npov+1
      write(fname,'(a,i5.5,a)') filpov(1:index(filpov,'.pov')-1),
     + npov,'.pov '
      open(unit=lfncop,file=fname(1:index(fname,' ')-1),
     + form='formatted',status='unknown')
      write(lfncop,8000)
 8000 format('#include "camera.inc"',/,'#include "colors.inc"',/,
     + '#include "plane.inc"')
      rv(1)=0.0d0
      rv(2)=0.0d0
      rv(3)=0.0d0
      rw(1)=0.0d0
      rw(2)=1.0d0
      rw(3)=0.0d0
      if(rangle.gt.0.0d0) rotang=(time/rangle)*twopi
      do 10 i=1,nsa
      rx(1)=x(i,1)
      rx(2)=x(i,2)
      rx(3)=x(i,3)
      if(rangle.gt.0.0d0) then
      ry(1)=x(i,1)
      ry(2)=x(i,2)
      ry(3)=x(i,3)
      call rotate(rv,rw,rotang,ry,rx)
      endif
      if(isel(i).ne.0) then
      write(lfncop,8003) sgmnam(i)
 8003 format('// ',a)
      k=pre_atnum(sgmnam(i)(6:7))
      color=atom_color(k)
      factor=scale*val(i,1)
      if(tag(i,2)(1:1).ne.' ') color=tag(i,2)
      if(tag(i,2)(1:5).eq.'atom ') color=atom_color(k) 
      if(k.gt.0) then
      if(tag(i,1)(1:3).eq.'cpk') then
      write(lfncop,8001) (scale*rx(j),j=1,3),
     + factor*abs(cpk)*dia_atrad(k),
     + color(1:index(color,' ')-1)
      else
      write(lfncop,8001) (scale*rx(j),j=1,3),
     + factor*abs(stick)*dia_atrad(1),
     + color(1:index(color,' ')-1)
      endif
 8001 format('sphere {',/,'  <',f12.6,',',f12.6,',',f12.6,'>,',/,
     + 3x,f12.6,/,
     + '  texture { pigment { ',a,' }',/,
     + '            finish  { ambient 0.16 ',/,
     + '                      diffuse 0.48 ',/,
     + '                      phong 1.25 ',/,
     + '                      phong_size 200 } }',/,'}')
      endif
      endif
   10 continue
      open(unit=44,file='.header',form='formatted',
     + status='unknown')
      rewind(44)
      read(44,4401) nwa,nsa,nsb,nwb
      do 11 i=1,nwa+nsa+nwb
      read(44,4402) cdummy
   11 continue
      do 12 i=1,nsb
      read(44,6004) ib,jb
      if(isel(ib).gt.0.and.isel(jb).gt.0) then
      if(rangle.gt.0.0d0) then
      ry(1)=x(ib,1)
      ry(2)=x(ib,2)
      ry(3)=x(ib,3)
      call rotate(rv,rw,rotang,ry,rxi)
      ry(1)=x(jb,1)
      ry(2)=x(jb,2)
      ry(3)=x(jb,3)
      call rotate(rv,rw,rotang,ry,rxj)
      else
      rxi(1)=x(ib,1)
      rxi(2)=x(ib,2)
      rxi(3)=x(ib,3)
      rxj(1)=x(jb,1)
      rxj(2)=x(jb,2)
      rxj(3)=x(jb,3)
      endif
      xh(1)=0.5d0*(rxi(1)+rxj(1))
      xh(2)=0.5d0*(rxi(2)+rxj(2))
      xh(3)=0.5d0*(rxi(3)+rxj(3))
      if(tag(ib,1)(1:3).ne.'cpk') then
      k=pre_atnum(sgmnam(ib)(6:7))
      color=atom_color(k)
      factor=scale*val(ib,1)
      if(tag(ib,2)(1:1).ne.' ') color=tag(ib,2)
      if(tag(ib,2)(1:5).eq.'atom ') color=atom_color(k) 
      write(lfncop,8002) (scale*rxi(j),j=1,3),
     + (scale*xh(j),j=1,3),factor*abs(stick)*dia_atrad(1),
     + color(1:index(color,' ')-1)
 8002 format('cylinder {',/,'  <',f12.6,',',f12.6,',',f12.6,'>,',/,
     + '  <',f12.6,',',f12.6,',',f12.6,'>,',/,
     + 3x,f12.6,/,'  open',/,'  texture { pigment { ',a,' } }',/,'}')
      endif
      if(tag(jb,1)(1:3).ne.'cpk') then
      k=pre_atnum(sgmnam(jb)(6:7))
      color=atom_color(k)
      factor=scale*val(jb,1)
      if(tag(jb,2)(1:1).ne.' ') color=tag(jb,2)
      if(tag(jb,2)(1:5).eq.'atom ') color=atom_color(k) 
      write(lfncop,8002) (scale*rxj(j),j=1,3),
     + (scale*xh(j),j=1,3),factor*abs(stick)*dia_atrad(1),
     + color(1:index(color,' ')-1)
      endif
      endif
   12 continue
      if(lxw.and..not.lsonly) then
      do 13 i=1,nwm
      if(iwsel(i).ne.0) then
      do 14 j=1,nwa
      if(rangle.gt.0.0d0) then
      ry(1)=w(i,j,1)
      ry(2)=w(i,j,2)
      ry(3)=w(i,j,3)
      call rotate(rv,rw,rotang,ry,rx)
      else
      rx(1)=w(i,j,1)
      rx(2)=w(i,j,2)
      rx(3)=w(i,j,3)
      endif
      k=pre_atnum(wnam(j)(6:7))
      color=atom_color(k)
      factor=scale*wval(j,1)
      if(wtag(j,2)(1:1).ne.' ') color=wtag(j,2)
      if(wtag(j,2)(1:5).eq.'atom ') color=atom_color(k) 
      if(k.gt.0) then
      if(wtag(j,1)(1:3).eq.'cpk') then
      write(lfncop,8001) (scale*rx(k),k=1,3),
     + factor*abs(cpk)*dia_atrad(k),
     + color(1:index(color,' ')-1)
      else
      write(lfncop,8001) (scale*rx(k),k=1,3),
     + factor*abs(stick)*dia_atrad(1),
     + color(1:index(color,' ')-1)
      endif
      endif
c
   14 continue
      endif
   13 continue
      rewind(44)
      read(44,4401) nwa,nsa,nsb,nwb
      do 17 i=1,nwa+nsa
      read(44,4402) cdummy
   17 continue
      do 15 l=1,nwb
      read(44,6004) ib,jb
      if(pre_atnum(wnam(ib)(6:7)).gt.1.or.
     + pre_atnum(wnam(jb)(6:7)).gt.1.) then
      do 16 i=1,nwm
      if(iwsel(i).ne.0) then
      if(rangle.gt.0.0d0) then
      ry(1)=w(i,ib,1)
      ry(2)=w(i,ib,2)
      ry(3)=w(i,ib,3)
      call rotate(rv,rw,rotang,ry,rxi)
      ry(1)=w(i,jb,1)
      ry(2)=w(i,jb,2)
      ry(3)=w(i,jb,3)
      call rotate(rv,rw,rotang,ry,rxj)
      else
      rxi(1)=w(i,ib,1)
      rxi(2)=w(i,ib,2)
      rxi(3)=w(i,ib,3)
      rxj(1)=w(i,jb,1)
      rxj(2)=w(i,jb,2)
      rxj(3)=w(i,jb,3)
      endif
      xh(1)=0.5d0*(rxi(1)+rxj(1))
      xh(2)=0.5d0*(rxi(2)+rxj(2))
      xh(3)=0.5d0*(rxi(3)+rxj(3))
      if(wtag(ib,1)(1:3).ne.'cpk') then
      k=pre_atnum(wnam(ib)(6:7))
      color=atom_color(k)
      factor=scale*val(ib,1)
      if(wtag(ib,2)(1:1).ne.' ') color=wtag(ib,2)
      if(wtag(ib,2)(1:5).eq.'atom ') color=atom_color(k) 
      write(lfncop,8002) (scale*rxi(j),j=1,3),
     + (scale*xh(j),j=1,3),factor*abs(stick)*dia_atrad(1),
     + color(1:index(color,' ')-1)
      endif
      if(wtag(jb,1)(1:3).ne.'cpk') then
      k=pre_atnum(wnam(jb)(6:7))
      color=atom_color(k)
      factor=scale*val(jb,1)
      if(wtag(jb,2)(1:1).ne.' ') color=wtag(jb,2)
      if(wtag(jb,2)(1:5).eq.'atom ') color=atom_color(k) 
      write(lfncop,8002) (scale*rxj(j),j=1,3),
     + (scale*xh(j),j=1,3),factor*abs(stick)*dia_atrad(1),
     + color(1:index(color,' ')-1)
      endif
      endif
   16 continue
      endif
   15 continue
      endif
      close(unit=lfncop)
      endif
c
      endif
c
      if(fmt.eq.'esp') then
      if(me.eq.0) then
      write(filchg,'(a,i5.5,a)') root(1:index(root,'.')-1),indx,'.xyz '
      write(filplt,'(a,i5.5,a)') root(1:index(root,'.')-1),indx,'.plt '
      write(filepz,'(a,i5.5,a)') root(1:index(root,'.')-1),indx,'.epz '
      call dia_wrtxyz(lfnchg,filchg,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xdat),dbl_mb(i_qdat),int_mb(i_wsel),dbl_mb(i_wdat),
     + .false.,.not.lsonly,int_mb(i_ndxw))
      write(filchg,'(a,i5.5,a)')
     + root(1:index(root,'.')-1),indx,'.xyzq '
      endif
      call dia_pltgrd(.true.,int_mb(i_isel))
      endif
c
      return
c
 9999 call md_abort('Oops',0)
      return
      end

c
c $Id: moeig_read.F 19707 2010-10-29 17:59:36Z d3y133 $
c
c This routine was essentially stolen from movecs_read, but only read
c the eigenvalues.
c
      logical function moeig_read(filename, iset, evals )
      implicit none
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "mafdecls.fh"
#include "msgids.fh"
#include "inp.fh"
#include "util.fh"
c
      character*(*) filename
      integer iset              ! No. (1,2) of set of vectors to read
      double precision evals(*) ! Must be at least nbf long (not nmo)
c
      integer nsets             ! No. of sets of vectors
      integer nbf               ! No. of functions in basis
      integer nmo(2)            ! No. of vectors in each set
      integer ok, jset, i, j
      integer unitno
      parameter (unitno = 67)
c
      call ga_sync()
      ok = 0
      if (ga_nodeid() .eq. 0) then
         open(unitno, status='old', form='unformatted', file=filename,
     $        err=1000)
c
c     Skip over uninteresting bits of the header
c
         read(unitno, err=1001, end=1001) ! convergence info
         read(unitno, err=1001, end=1001) ! scftype
         read(unitno, err=1001, end=1001) ! lentit
         read(unitno, err=1001, end=1001) ! title
         read(unitno, err=1001, end=1001) ! lenbas
         read(unitno, err=1001, end=1001) ! basis_name
         read(unitno, err=1001, end=1001) nsets
         read(unitno, err=1001, end=1001) nbf
         read(unitno, err=1001, end=1001) (nmo(i),i=1,nsets)
c
c     Skip over unwanted sets
c
         do jset = 1, iset-1
            read(unitno, err=1001, end=1001)
            read(unitno, err=1001, end=1001)
            do i = 1, nmo(jset)
               read(unitno, err=1001, end=1001)
            enddo
         enddo
         read(unitno, err=1001, end=1001) ! occ
         read(unitno, err=1001, end=1001) (evals(j),j=1,nbf)
         do i = 1, nmo(iset)
             read(unitno, err=1001, end=1001)  ! movecs
         enddo
 9       close(unitno,err=1002)
         ok = 1
      endif
c
 10   continue
      call ga_sync()
      call ga_brdcst(Msg_Vec_Stat+MSGINT, ok, mitob(1), 0) ! Propagate status
      if (ok .eq. 1) then
         call ga_brdcst(Msg_Vec_EVal+MSGDBL, evals, mdtob(nbf), 0)
      endif
c
      moeig_read = ok .eq. 1
      if (ga_nodeid() .eq. 0 .and. moeig_read .and.
     $     util_print('vectors i/o', print_default)) then
         write(6,22) filename(1:inp_strlen(filename))
 22      format(/' Read molecular orbitals from ',a/)
         call util_flush(6)
      endif
      return
c
 1000 write(6,*) ' moeig_read: failed to open ',
     $     filename(1:inp_strlen(filename))
      call util_flush(6)
      ok = 0
      goto 10
c
 1001 write(6,*) ' moeig_read: failing reading from ',
     $     filename(1:inp_strlen(filename))
      call util_flush(6)
      ok = 0
      close(unitno,err=1002)
      goto 10
c
 1002 write(6,*) ' moeig_read: failed to close',
     $     filename(1:inp_strlen(filename))
      call util_flush(6)
      ok = 0
      goto 10
c
      end

c $Id: intd_1e3ov.F 23249 2012-12-05 19:40:35Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Compute the 3 center overlap integral derivatives
C>
C> Compute the 3 center overlap integral derivatives as defined by
C> \f{eqnarray*}{
C>   \frac{\partial}{\partial X_x}({\mu}{\nu}{\lambda}) &=& \int_{-\infty}^{\infty}
C>   \frac{\partial g_{\mu}(X_\mu,r_{1})g_{\nu}(X_\nu,r_{1})g_{\lambda}(X_\lambda,r_{1})}{\partial X_x}dr_{1}
C> \f}
C> Where \f$X_x\f$ refers to a nuclear coordinate that can be any of 
C> \f$X_\mu\f$, \f$X_\nu\f$ or \f$X_\lambda\f$.
C>
C> The integral derivatives are returned in `dOV3`. The order in which the
C> integrals are stored is equivalent to the array being dimensioned as:
C> `dOV3(nint,ncoord,natom)` where `ncoord` is equal to 3 for the Cartesian
C> coordinates, and `natom` is equal to 3 for the atoms on which the Gaussians
C> are centered. The lexical indeces of the atoms are returned in `idatom`.
C> This relationship can be stated as: the integrals `dOV3(*,*,i)` belong to
C> atom `idatom(i)`.
C>
C> Finally, if any of the entries in `idatom` equals 0 then the data in `dOV3`
C> is invalid.
C>
c:tex-% this is part of the API Standard Integral routines.
c:tex-\subsection{intd\_1e3ov}
c:tex-This routine computes the 3 center overlap integral derivatives:
c:tex-\[
c:tex-\frac{\partial}{\partial q}({\mu}{\nu}{\lamda}) = \int_{-\infty}^{\infty}
c:tex-g_{\mu}(X,r_{1})g_{\nu}(X-R,r_{1})g_{\lamda}(X-R,r_{1})dr_{1}
c:tex-\]
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine intd_1e3ov (i_basis, ish, j_basis, jsh, k_basis, ksh,
     &       lscr, scr, ldov3, dOV3, idatom)
c:tex-\end{verbatim}
      implicit none
#include "nwc_const.fh"
#include "errquit.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geobasmapP.fh"
#include "geomP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
#include "stdio.fh"
c:: external subroutines used
c..  errquit
c::functions
      logical int_chk_sh, int_chk_init
      external int_chk_sh, int_chk_init
c::passed
c:tex-\begin{verbatim}
      integer i_basis            !< [Input] basis set handle for ish
      integer ish                !< [Input] i shell/contraction
      integer j_basis            !< [Input] basis set handle for jsh
      integer jsh                !< [Input] j shell/contraction
      integer k_basis            !< [Input] basis set handle for ksh
      integer ksh                !< [Input] k shell/contraction
      integer lscr               !< [Input] length of scratch array
      double precision scr(lscr) !< [Scratch] scratch array
      integer ldov3              !< [Input] length of 3c overlap integrals array
      double precision dOV3(*)   !< [Output] 3c overlap integrals
      integer idatom(3) !< [Output] array identifying centers for derivatives
c                       !  e.g., the first nint*3  derivatives go to center idatom(1)
c                       !        the second nint*3 derivatives go to center idatom(2)
c:tex-\end{verbatim}
c
c Order is...   nint*3*3 (3=> xyz, 3=atoms)
c
c  /                   |   
c | nint,d <ij>        |
c |      --------------|
c  \     d[idatom(1),x]|
c                          |
c       nint,d <ij>        |
c            --------------|
c            d[idatom(1),y]|
c                              |
c           nint,d <ij>        |
c                --------------|
c                d[idatom(1),z]|
c                                  |
c               nint,d <ij>        |
c                    --------------|
c                    d[idatom(2),x]|
c                                      |
c                   nint,d <ij>        |
c                        --------------|
c                        d[idatom(2),y]|
c                                          |
c                       nint,d <ij>        |
c                            --------------|
c                            d[idatom(2),z]|
c                                              |
c                           nint,d <ij>        |
c                                --------------|
c                                d[idatom(3),x]|
c                                                  |
c                               nint,d <ij>        |
c                                    --------------|
c                                    d[idatom(3),y]|
c                                                      \
c                                   nint,d <ij>         |
c                                        -------------- |
c                                        d[idatom(3),z]/
c If idatom(?) = 0 then do not use this 3*nint block of integral derivatives
c::local
      logical any_spherical
      logical shells_ok
      integer nint_intrnl
      integer ucont
      integer ibas, jbas, kbas
      integer i_geom, j_geom, k_geom
      integer Li, i_prim, i_gen, i_iexp, i_icfp, i_cent
      integer Lj, j_prim, j_gen, j_iexp, j_icfp, j_cent
      integer Lk, k_prim, k_gen, k_iexp, k_icfp, k_cent
c
      integer i_pov3, j_pov3, k_pov3
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c check initialization and shells
c
      if (.not.int_chk_init('intd_1e3ov'))
     &       call errquit('intd_1e3ov: int_init was not called' ,0,
     &            INT_ERR)
c
      shells_ok = int_chk_sh(i_basis,ish)
      shells_ok = shells_ok .and. int_chk_sh(j_basis,jsh)
      shells_ok = shells_ok .and. int_chk_sh(k_basis,ksh)
      if (.not.shells_ok)
     &       call errquit('intd_1e3ov: invalid contraction/shell',0,
     &            BASIS_ERR)
c
      call int_nogencont_check(i_basis,'intd_1e3ov:i_basis')
      call int_nogencont_check(j_basis,'intd_1e3ov:j_basis')
      call int_nogencont_check(k_basis,'intd_1e3ov:k_basis')
      call int_nospshell_check(i_basis,'intd_1e3ov:i_basis')
      call int_nospshell_check(j_basis,'intd_1e3ov:j_basis')
      call int_nospshell_check(k_basis,'intd_1e3ov:k_basis')
c
      ibas = i_basis + BASIS_HANDLE_OFFSET
      jbas = j_basis + BASIS_HANDLE_OFFSET
      kbas = k_basis + BASIS_HANDLE_OFFSET
c
      ucont   = (sf_ibs_cn2ucn(ish,ibas))
      Li      = infbs_cont(CONT_TYPE ,ucont,ibas)
      i_prim  = infbs_cont(CONT_NPRIM,ucont,ibas)
      i_gen   = infbs_cont(CONT_NGEN ,ucont,ibas)
      i_iexp  = infbs_cont(CONT_IEXP ,ucont,ibas)
      i_icfp  = infbs_cont(CONT_ICFP ,ucont,ibas)
      i_cent  = (sf_ibs_cn2ce(ish,ibas))
      i_geom  = ibs_geom(ibas)
c
      ucont   = (sf_ibs_cn2ucn(jsh,jbas))
      Lj      = infbs_cont(CONT_TYPE ,ucont,jbas)
      j_prim  = infbs_cont(CONT_NPRIM,ucont,jbas)
      j_gen   = infbs_cont(CONT_NGEN ,ucont,jbas)
      j_iexp  = infbs_cont(CONT_IEXP ,ucont,jbas)
      j_icfp  = infbs_cont(CONT_ICFP ,ucont,jbas)
      j_cent  = (sf_ibs_cn2ce(jsh,jbas))
      j_geom  = ibs_geom(jbas)
c
      ucont   = (sf_ibs_cn2ucn(ksh,kbas))
      Lk      = infbs_cont(CONT_TYPE ,ucont,kbas)
      k_prim  = infbs_cont(CONT_NPRIM,ucont,kbas)
      k_gen   = infbs_cont(CONT_NGEN ,ucont,kbas)
      k_iexp  = infbs_cont(CONT_IEXP ,ucont,kbas)
      k_icfp  = infbs_cont(CONT_ICFP ,ucont,kbas)
      k_cent  = (sf_ibs_cn2ce(ksh,kbas))
      k_geom  = ibs_geom(kbas)
c
      nint_intrnl = int_nbf_x(Li)*int_nbf_x(Lj)*int_nbf_x(Lk)
      if ((nint_intrnl*9).gt.ldov3) then
        write(luout,*)' buffer size too small '
        write(luout,*)' buffer size : ',ldov3
        write(luout,*)' needed      : ',(nint_intrnl*9)
        stop ' intd_1e3ov: fatal error '
      endif
c
      if ((i_cent.eq.j_cent).and.(j_cent.eq.k_cent)) then
        idatom(1) = 0
        idatom(2) = 0
        idatom(3) = 0
        call dcopy((9*nint_intrnl),0.0d00,0,dOV3,1)
        return
      endif
c
      if ((i_geom.ne.j_geom.or.j_geom.ne.k_geom).and.WarnP.eq.0) then
        write(luout,*)
     &      'intd_1e3ov: WARNING: possible geometry inconsistency'
        write(luout,*)'i_basis geometry handle:',i_geom
        write(luout,*)'j_basis geometry handle:',j_geom
        write(luout,*)'k_basis geometry handle:',k_geom
        WarnP = 1
      endif
c
      call hfd3ois(
     &    coords(1,i_cent,i_geom),
     &    dbl_mb(mb_exndcf(i_iexp,ibas)),
     &    dbl_mb(mb_exndcf(i_icfp,ibas)),
     &    i_prim, 1, Li,
     &    coords(1,j_cent,j_geom),
     &    dbl_mb(mb_exndcf(j_iexp,jbas)),
     &    dbl_mb(mb_exndcf(j_icfp,jbas)),
     &    j_prim, 1, Lj,
     &    coords(1,k_cent,k_geom),
     &    dbl_mb(mb_exndcf(k_iexp,kbas)),
     &    dbl_mb(mb_exndcf(k_icfp,kbas)),
     &    k_prim, 1, Lk,
     &    dOV3,nint_intrnl,
c.........DryRun
     &    .false.,scr,lscr)
c
      i_pov3 = 1                    ! pointer to i block of derivs
      j_pov3 = 3*nint_intrnl+i_pov3 ! pointer to j block of derivs
      k_pov3 = 3*nint_intrnl+j_pov3 ! pointer to k block of derivs
c
      any_spherical = bas_spherical(ibas).or.
     &    bas_spherical(jbas).or.bas_spherical(kbas)
      if ((i_cent.ne.j_cent).and.(i_cent.ne.k_cent).and.
     &                                       (j_cent.ne.k_cent)) then
        idatom(1) = i_cent
        idatom(2) = j_cent
        idatom(3) = k_cent
        if (any_spherical) then
          if (Li.eq.-1) i_gen = 1
          if (Lj.eq.-1) j_gen = 1
          if (Lk.eq.-1) k_gen = 1
          call spcart_3cBtran(dOV3,scr,lscr,
     &        int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &        int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &        int_nbf_x(Lk),int_nbf_s(Lk),Lk,k_gen,bas_spherical(kbas),
     &        9,.false.)
        endif
      else if (i_cent.eq.j_cent) then
        call daxpy(3*nint_intrnl,1.0d00,dOV3(j_pov3),1,dOV3(i_pov3),1)
        call dcopy(3*nint_intrnl,dOV3(k_pov3),1,dOV3(j_pov3),1)
        call dcopy(3*nint_intrnl,0.0d00,0,dOV3(k_pov3),1)
        idatom(1) = i_cent
        idatom(2) = k_cent
        idatom(3) = 0
        if (any_spherical) then
          if (Li.eq.-1) i_gen = 1
          if (Lj.eq.-1) j_gen = 1
          if (Lk.eq.-1) k_gen = 1
          call spcart_3cBtran(dOV3,scr,lscr,
     &        int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &        int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &        int_nbf_x(Lk),int_nbf_s(Lk),Lk,k_gen,bas_spherical(kbas),
     &        6,.false.)
        endif
      else if (i_cent.eq.k_cent) then
        call daxpy(3*nint_intrnl,1.0d00,dOV3(k_pov3),1,dOV3(i_pov3),1)
        call dcopy(3*nint_intrnl,0.0d00,0,dOV3(k_pov3),1)
        idatom(1) = i_cent
        idatom(2) = j_cent
        idatom(3) = 0
        if (any_spherical) then
          if (Li.eq.-1) i_gen = 1
          if (Lj.eq.-1) j_gen = 1
          if (Lk.eq.-1) k_gen = 1
          call spcart_3cBtran(dOV3,scr,lscr,
     &        int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &        int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &        int_nbf_x(Lk),int_nbf_s(Lk),Lk,k_gen,bas_spherical(kbas),
     &        6,.false.)
        endif
      else if (j_cent.eq.k_cent) then
        call daxpy(3*nint_intrnl,1.0d00,dOV3(k_pov3),1,dOV3(j_pov3),1)
        call dcopy(3*nint_intrnl,0.0d00,0,dOV3(k_pov3),1)
        idatom(1) = i_cent
        idatom(2) = j_cent
        idatom(3) = 0
        if (any_spherical) then
          if (Li.eq.-1) i_gen = 1
          if (Lj.eq.-1) j_gen = 1
          if (Lk.eq.-1) k_gen = 1
          call spcart_3cBtran(dOV3,scr,lscr,
     &        int_nbf_x(Li),int_nbf_s(Li),Li,i_gen,bas_spherical(ibas),
     &        int_nbf_x(Lj),int_nbf_s(Lj),Lj,j_gen,bas_spherical(jbas),
     &        int_nbf_x(Lk),int_nbf_s(Lk),Lk,k_gen,bas_spherical(kbas),
     &        6,.false.)
        endif
      else
        write(luout,*)'ijk->centers',i_cent,j_cent,k_cent
        write(luout,*)' fatal error '
        stop 'intd_1e3ov: how did I get here'
      endif
      end
C> @}

c 
c $Id: get_density.F 19707 2010-10-29 17:59:36Z d3y133 $ 
c 
      subroutine get_density(g_dens,g_vecs,theory,scftype,nalpha,
     *                       nbeta,nbfs,rtdb)
      implicit none
#include "errquit.fh"
c
c This routine gets alpha and beta densities and passes them back in g_dens.
c 
#include "mafdecls.fh"
#include "rtdb.fh"
      integer g_dens(*)    ! [output] density handles
      integer g_vecs(*)    ! [output] vector handles
      character*3 theory   ! [input]  HF or DFT
      character*4 scftype  ! [input]  RHF, UHF, or ROHF
      integer nalpha       ! [input]  number of alpha occupieds
      integer nbeta        ! [input]  number of beta occupieds
      integer nbfs         ! [input]  number of basis functions
      integer rtdb         ! [input]  RTDB handle
c
      integer l_evals, k_evals, l_occ, k_occ
      double precision rhffact
      character*255 movecs
c
      logical movecs_read
      external movecs_read
c
c Temporarily disable ROHF
c
      if (scftype.eq.'ROHF')
     *  call errquit('get_density: ROHF is not supported yet',555,
     &       CAPMIS_ERR)
c
      if (theory.eq.'HF') then
        if (.not. rtdb_cget(rtdb, 'scf:input vectors', 1, movecs))
     *    call errquit('get_density: SCF MO vectors not defined',555,
     &       RTDB_ERR)
      else if (theory.eq.'DFT') then
        if (.not. rtdb_cget(rtdb, 'dft:input vectors', 1, movecs))
     *   call errquit('get_density: DFT MO vectors not defined',555,
     &       RTDB_ERR)
      else
        call errquit('get_density:theory is unrecognized',555,
     &       INPUT_ERR)
      endif
c
c get additional space to store the eigenvalues and occupation numbers
c
      if (.not. ma_push_get(mt_dbl, nbfs,'MO evals', l_evals, k_evals))
     *  call errquit('get_density: could not allocate l_evals',nbfs,
     &       MA_ERR)
      if (.not. ma_push_get(mt_dbl, nbfs,'occ. numbers', l_occ, k_occ))
     *  call errquit('get_density: could not allocate l_occ',nbfs,
     &       MA_ERR)
c
c read vectors
c
      if (.not. movecs_read (movecs, 1, dbl_mb(k_occ), 
     *  dbl_mb(k_evals), g_vecs(1)))
     *  call errquit('get_density: could not read mo vectors', 555,
     &       DISK_ERR)
      if (scftype.eq.'UHF') then
        if (.not. movecs_read (movecs, 2, dbl_mb(k_occ), 
     *    dbl_mb(k_evals), g_vecs(2))) 
     *    call errquit('get_density: could not read beta vectors', 555,
     &       DISK_ERR)
      endif
c
c free additional space
c
      if (.not.ma_pop_stack(l_occ))
     *  call errquit('get_density:ma free occ',555, MA_ERR)
      if (.not.ma_pop_stack(l_evals))
     *  call errquit('get_density:ma free eval',555, MA_ERR)
c
c form the densities
c
      rhffact = 2.0
      if (scftype.eq.'UHF') rhffact = 1.0
      call ga_dgemm('n', 't', nbfs, nbfs, nalpha, rhffact,
     *   g_vecs(1), g_vecs(1), 0.0d0, g_dens(1))
      call ga_symmetrize(g_dens(1))
      if (scftype.eq.'UHF') then
        call ga_dgemm('n', 't', nbfs, nbfs, nbeta, rhffact,
     *    g_vecs(2), g_vecs(2), 0.0d0, g_dens(2))
        call ga_symmetrize(g_dens(2))
      endif
c
      end

C> \ingroup selci
C> @{
C>
      subroutine selci_eirerj(e,i,ir,j,ns,indbar,iocc,w1,w2,work)
*
* $Id: eirerj.F 24780 2013-11-07 21:23:59Z d3y133 $
*
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
      dimension e(*),indbar(*),iocc(*),work(*),
     $     w1(nfmax,nfmax,nsmax),w2(nfmax2,nfmax,nsmax-1)
c
c     e(u,v) = <Iu|EirErj|Iv>, where u,v label the spin functions
c     and the orbital occupation of I is specified by ns, iocc
c     and indbar. Only for i.ne.j.ne.r, and r singly occupied.
c
c     e(u,v) = sum(q) <Iu|Eir|Sq><Sq|Erj|Iv>
c
c     <Iu|Eir|Sq> = sum(p) <Iu|Eia|Tp><Tp|Ear|Sq> 
c
c     possible cases are:
c
c     iocc(i)  iocc(j)  case
c       1         0       1
c       1         1       2
c       3         0       3
c       3         1       4
c
      if (iocc(ir).ne.1 .or. ir.eq.i .or. ir.eq.j .or. i.eq.j)
     $     call errquit('eirerj: wrong i,r,j',ir, INPUT_ERR)
c
      icase = iocc(i)+iocc(j)
      goto (10,20,30,40) icase
      call errquit('eirerj: fell thru goto',icase, INPUT_ERR)
c
 10   continue
c
c     ni=1, nj=0 : e(u,v) = w1(u,p,ib)*w2(q,p,rb)*w2(q,s,rb)*w1(v,s,jb)
c                         ir    ->    ra    ->   rr    ->   ra   ->   jr
c
      numf = nf(ns)
      numf2 = nf(ns-2)
      ib = indbar(i) + (nsmax-ns)
      irb = indbar(ir) + (nsmax-ns)
      if (ir.gt.i) irb = irb - 1
      jb = indbar(j) + (nsmax-ns)
      if (j.gt.i) jb = jb - 1
*      call selci_mxma(w1(1,1,ib),1,nfmax,w2(1,1,irb),nfmax2,1,
*     $     e,1,numf,numf,numf,numf2)
      call selci_axbt(w1(1,1,ib),nfmax,w2(1,1,irb),nfmax2,
     $     e,numf,numf,numf,numf2)
*      call selci_mxma(e,1,numf,w2(1,1,irb),1,nfmax2,
*     $     work,1,numf,numf,numf2,numf)
      call selci_axb(e,numf,w2(1,1,irb),nfmax2,
     $     work,numf,numf,numf2,numf)
*      call selci_mxma(work,1,numf,w1(1,1,jb),nfmax,1,
*     $     e,1,numf,numf,numf,numf)
      call selci_axbt(work,numf,w1(1,1,jb),nfmax,
     $     e,numf,numf,numf,numf)
      return
c
 20   continue
c
c     ni=1, nj=1 : e(u,v) = w1(u,p,ib)*w2(q,p,rb)*w2(q,s,rb)*w2(v,s,jb)
c                        ijr    ->   jra    ->  rrj   ->   jra  ->   jjr
c     same as 10 except for last mxma
      numf = nf(ns)
      numf2 = nf(ns-2)
      ib = indbar(i) + (nsmax-ns)
      irb = indbar(ir) + (nsmax-ns)
      if (ir.gt.i) irb = irb - 1
      jb = indbar(j) + (nsmax-ns)
      if (j.gt.i) jb = jb - 1
*      call selci_mxma(w1(1,1,ib),1,nfmax,w2(1,1,irb),nfmax2,1,
*     $     e,1,numf,numf,numf,numf2)
      call selci_axbt(w1(1,1,ib),nfmax,w2(1,1,irb),nfmax2,
     $     e,numf,numf,numf,numf2)
*      call selci_mxma(e,1,numf,w2(1,1,irb),1,nfmax2,
*     $     work,1,numf,numf,numf2,numf)
      call selci_axb(e,numf,w2(1,1,irb),nfmax2,
     $     work,numf,numf,numf2,numf)
*      call selci_mxma(work,1,numf,w2(1,1,jb),nfmax2,1,
*     $     e,1,numf,numf,numf,numf2)
      call selci_axbt(work,numf,w2(1,1,jb),nfmax2,
     $     e,numf,numf,numf,numf2)
      return
c
 30   continue
c
c     ni=2, nj=0 : e(u,v) = w2(u,p,ib)*w2(q,p,rb)*w2(q,s,rb)*w1(v,s,jb)
c                        iir    ->   ira    ->  rri   ->   ira  ->   ijr
c
      numf = nf(ns)
      numf2 = nf(ns+2)
      ib = indbar(i) + (nsmax-ns-2)
      irb = indbar(ir) + (nsmax-ns-2)
      if (ir.gt.i) irb = irb + 1
      jb = indbar(j) + (nsmax-ns-2)
      if (j.gt.i) jb = jb + 1
*      call selci_mxma(w2(1,1,ib),1,nfmax2,w2(1,1,irb),nfmax2,1,
*     $     e,1,numf,numf,numf2,numf)
      call selci_axbt(w2(1,1,ib),nfmax2,w2(1,1,irb),nfmax2,
     $     e,numf,numf,numf2,numf)
*      call selci_mxma(e,1,numf,w2(1,1,irb),1,nfmax2,
*     $     work,1,numf,numf,numf,numf2)
      call selci_axb(e,numf,w2(1,1,irb),nfmax2,
     $     work,numf,numf,numf,numf2)
*      call selci_mxma(work,1,numf,w1(1,1,jb),nfmax,1,
*     $     e,1,numf,numf,numf2,numf2)
      call selci_axbt(work,numf,w1(1,1,jb),nfmax,
     $     e,numf,numf,numf2,numf2)
      return
c
 40   continue
c
c     ni=2, nj=1 : e(u,v) = w2(u,p,ib)*w2(q,p,rb)*w2(q,s,rb)*w2(v,s,jb)
c                        iijr   ->   ijra   ->  rrij  ->   ijra  ->   jjir
c     same as 30 except for last mxma
      numf = nf(ns)
      numf2 = nf(ns+2)
      ib = indbar(i) + (nsmax-ns-2)
      irb = indbar(ir) + (nsmax-ns-2)
      if (ir.gt.i) irb = irb + 1
      jb = indbar(j) + (nsmax-ns-2)
      if (j.gt.i) jb = jb + 1
*      call selci_mxma(w2(1,1,ib),1,nfmax2,w2(1,1,irb),nfmax2,1,
*     $     e,1,numf,numf,numf2,numf)
      call selci_axbt(w2(1,1,ib),nfmax2,w2(1,1,irb),nfmax2,
     $     e,numf,numf,numf2,numf)
*      call selci_mxma(e,1,numf,w2(1,1,irb),1,nfmax2,
*     $     work,1,numf,numf,numf,numf2)
      call selci_axb(e,numf,w2(1,1,irb),nfmax2,
     $     work,numf,numf,numf,numf2)
*      call selci_mxma(work,1,numf,w2(1,1,jb),nfmax2,1,
*     $     e,1,numf,numf,numf2,numf)
      call selci_axbt(work,numf,w2(1,1,jb),nfmax2,
     $     e,numf,numf,numf2,numf)
      return
c
      end
C>
C> @}

* $Id: shells.f 19696 2010-10-29 16:53:42Z d3y133 $
c--------------------------------------------------------------------
      subroutine txs_shells(inx,ics1,jcs1,kcs1,lcs1)
      common /types/itype,jtype,ktype,ltype,itype1,jtype1,ktype1,ltype1 
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
      common /lengt/ ilen,jlen,klen,llen, ilen1,jlen1,klen1,llen1
      common /gcont/ ngci1,ngcj1,ngck1,ngcl1,ngcd
      common /logic2/ len(1)
      dimension inx(12,*)
c
c This subroutine sets up TYPE and LENGTH of shells and
c contraction information including general contraction.
c
c  type of shells :
c
      itype=inx(12,ics1)
      jtype=inx(12,jcs1)
      ktype=inx(12,kcs1)
      ltype=inx(12,lcs1)
c
      itype1=itype
      jtype1=jtype
      ktype1=ktype
      ltype1=ltype
      if(itype.gt.4) itype1=itype-1
      if(jtype.gt.4) jtype1=jtype-1
      if(ktype.gt.4) ktype1=ktype-1
      if(ltype.gt.4) ltype1=ltype-1
c
      if(itype1.gt.5) itype1=itype1-1
      if(jtype1.gt.5) jtype1=jtype1-1
      if(ktype1.gt.5) ktype1=ktype1-1
      if(ltype1.gt.5) ltype1=ltype1-1
c
c needed for transformation i.e. d6->d5, f10->f7  :
c
      ilen=inx(3,ics1)
      jlen=inx(3,jcs1)
      klen=inx(3,kcs1)
      llen=inx(3,lcs1)
c
      ilen1=len(itype1)
      jlen1=len(jtype1)
      klen1=len(ktype1)
      llen1=len(ltype1)
c
c number of general contractions
c
      ngci=inx(4,ics1)
      ngcj=inx(4,jcs1)
      ngck=inx(4,kcs1)
      ngcl=inx(4,lcs1)
c
      ngci1=ngci+1
      ngcj1=ngcj+1
      ngck1=ngck+1
      ngcl1=ngcl+1
      ngcd=ngci1*ngcj1*ngck1*ngcl1
c
c contraction begining and end :
c
      ia=inx(1,ics1)+1
      ie=inx(5,ics1)
      ja=inx(1,jcs1)+1
      je=inx(5,jcs1)
      ka=inx(1,kcs1)+1
      ke=inx(5,kcs1)
      la=inx(1,lcs1)+1
      le=inx(5,lcs1)
c
c length of contractions
c
      lci=ie-ia+1
      lcj=je-ja+1
      lck=ke-ka+1
      lcl=le-la+1
      lcij=lci*lcj
      lckl=lck*lcl
c
      return
      end
c-----------------------------------------------
      subroutine iobara(ityp,jtyp,ktyp,ltyp,where)
      character*8 where
c
c Set up the OBARAI, SHELL and LCASES commons :
c
ctest
cccc  common /derivat/ ijderiv,klderiv
ctest
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
C
      common /logic1/ ndege(1)
      common /logic2/ len(1)
      common /logic3/ lensm(1)
      common /logic4/ nfu(1)
c
      COMMON/SHELL/LSHELLT,LSHELIJ,LSHELKL,LHELP,LCAS2(4),LCAS3(4)
      common /lcases/ lcase
C
c     DIMENSION NDEGE(16),LEN(16),LENSM(15)
c     DATA NDEGE/1,2,2,3,4,5,6,7,8,9,10,11,12,13,14,15/
c     DATA LEN  /1,3,4,6,10,15,21,28,36,45,55,66,78,91,105,120/
c     DATA LENSM/1,4,10,20,35,56,84,120,165,220,286,364,455,560,680/
C*******  UP TO: S P D F G H I J K L M N O P Q *******
C     LENSM(NSIJ)=TOTAL NUMBER OF FUNCTIONS UP TO GIVEN NSIJ
C************************************************************
      NQI=NDEGE(ITYP)
      NQJ=NDEGE(JTYP)
      NQK=NDEGE(KTYP)
      NQL=NDEGE(LTYP)
      NSIJ=NQI+NQJ-1
      NSKL=NQK+NQL-1
c--------
c for NMR derivatives
c     nsij=nsij+ijderiv
c     nskl=nskl+klderiv
c
      if (where.eq.'shif' .or. where.eq.'forc') then
        nsij=nsij+1
        nskl=nskl+1
      endif
      if (where.eq.'hess') then
        nsij=nsij+2
        nskl=nskl+2
      endif
c--------
C
      MMAX=NSIJ+NSKL-1
c     MMAX1=MMAX-1
C
      LNI=LEN(ITYP)
      LNJ=LEN(JTYP)
      LNK=LEN(KTYP)
      LNL=LEN(LTYP)
      LNIJKL=LNI*LNJ*LNK*LNL
C
      LNIJ=LENSM(NSIJ)
      LNKL=LENSM(NSKL)
C
       NSIJ1=NSIJ+1
       NSKL1=NSKL+1
       NQIJ=NQI
       IF(NQJ.GT.NQI) NQIJ=NQJ
       NQIJ1=NQIJ+1
       NQKL=NQK
       IF(NQL.GT.NQK) NQKL=NQL
       NQKL1=NQKL+1
c
cccccccccccccccccccccccccccccccc
c    handle the L-shell cases
c
       IJBEG=NFU(NQIJ)+1
       KLBEG=NFU(NQKL)+1
ccccc
       LHELP=0
       LSHELIJ=0
       LSHELKL=0
       LSHELLT=0
C
       LCAS2(1)=0
       LCAS2(2)=0
       LCAS2(3)=0
       LCAS2(4)=0
C
       LCAS3(1)=0
       LCAS3(2)=0
       LCAS3(3)=0
       LCAS3(4)=0
C
       IF(ITYP.EQ.3) THEN
         LSHELLT=LSHELLT+1
         LSHELIJ=LSHELIJ+1
         IF(JTYP.LE.3) IJBEG=1
         IF(KTYP.EQ.3) LCAS2(1)=1
         IF(LTYP.EQ.3) LCAS2(2)=1
       ENDIF
       IF(JTYP.EQ.3) THEN
         LSHELLT=LSHELLT+1
         LSHELIJ=LSHELIJ+2
         IF(ITYP.LE.3) IJBEG=1
         IF(KTYP.EQ.3) LCAS2(3)=1
         IF(LTYP.EQ.3) LCAS2(4)=1
       ENDIF
CCC
       IF(KTYP.EQ.3) THEN
         LSHELLT=LSHELLT+1
         LSHELKL=LSHELKL+1
         IF(LTYP.LE.3) KLBEG=1
         IF(LSHELIJ.EQ.3)  LCAS3(1)=1
       ENDIF
       IF(LTYP.EQ.3) THEN
         LSHELLT=LSHELLT+1
         LSHELKL=LSHELKL+2
         IF(KTYP.LE.3) KLBEG=1
         IF(LSHELIJ.EQ.3)  LCAS3(2)=1
         IF(LCAS2(1).EQ.1) LCAS3(3)=1
         IF(LCAS2(3).EQ.1) LCAS3(4)=1
       ENDIF
c
                           lcase=1        ! no l-shells
       if(lshellt.eq.1) then
         if(lshelij.eq.1)  lcase=2        ! lx/yz
         if(lshelij.eq.2)  lcase=3        ! xl/yz
         if(lshelkl.eq.1)  lcase=4        ! xy/lz
         if(lshelkl.eq.2)  lcase=5        ! xy/zl
       endif
       if(lshellt.eq.2) then        
         if(lshelij.eq.3)  lcase=6        ! ll/xy
         if(lshelkl.eq.3)  lcase=7        ! xy/ll
         if(lcas2(1).eq.1) lcase=8        ! lx/ly
         if(lcas2(2).eq.1) lcase=9        ! lx/yl
         if(lcas2(3).eq.1) lcase=10       ! xl/ly
         if(lcas2(4).eq.1) lcase=11       ! xl/yl
       endif
       if(lshellt.eq.3) then
         if(lcas3(1).eq.1) lcase=12       ! ll/lx
         if(lcas3(2).eq.1) lcase=13       ! ll/xl
         if(lcas3(3).eq.1) lcase=14       ! lx/ll
         if(lcas3(4).eq.1) lcase=15       ! xl/ll
       endif
       if(lshellt.eq.4)    lcase=16       ! ll/ll
c
      return
      end
c***************************
c-----------------------------------------------
      subroutine iobarb(ijderiv,klderiv)
c
c return original value of nsij,nskl and lnij,lnkl
c
c     common /derivat/ ijderiv,klderiv
      common/obarai/
     * lni,lnj,lnk,lnl,lnij,lnkl,lnijkl,MMAX,
     * NQI,NQJ,NQK,NQL,NSIJ,NSKL,
     * NQIJ,NQIJ1,NSIJ1,NQKL,NQKL1,NSKL1,ijbeg,klbeg
      common /logic3/ lensm(1)
c
C************************************************************
c
c---
      nsij=nsij-ijderiv
      nskl=nskl-klderiv
c---
C
      MMAX=NSIJ+NSKL-1
C
      LNIJ=LENSM(NSIJ)
      LNKL=LENSM(NSKL)
C
      NSIJ1=NSIJ+1
      NSKL1=NSKL+1
      end

*> \brief \b DLACPY copies all or part of one two-dimensional array to another.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLACPY + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlacpy.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlacpy.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlacpy.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLACPY( UPLO, M, N, A, LDA, B, LDB )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            LDA, LDB, M, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLACPY copies all or part of a two-dimensional matrix A to another
*> matrix B.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          Specifies the part of the matrix A to be copied to B.
*>          = 'U':      Upper triangular part
*>          = 'L':      Lower triangular part
*>          Otherwise:  All of the matrix A
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix A.  M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          The m by n matrix A.  If UPLO = 'U', only the upper triangle
*>          or trapezoid is accessed; if UPLO = 'L', only the lower
*>          triangle or trapezoid is accessed.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,M).
*> \endverbatim
*>
*> \param[out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB,N)
*>          On exit, B = A in the locations specified by UPLO.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,M).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE DLACPY( UPLO, M, N, A, LDA, B, LDB )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            LDA, LDB, M, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
      IF( LSAME( UPLO, 'U' ) ) THEN
         DO 20 J = 1, N
            DO 10 I = 1, MIN( J, M )
               B( I, J ) = A( I, J )
   10       CONTINUE
   20    CONTINUE
      ELSE IF( LSAME( UPLO, 'L' ) ) THEN
         DO 40 J = 1, N
            DO 30 I = J, M
               B( I, J ) = A( I, J )
   30       CONTINUE
   40    CONTINUE
      ELSE
         DO 60 J = 1, N
            DO 50 I = 1, M
               B( I, J ) = A( I, J )
   50       CONTINUE
   60    CONTINUE
      END IF
      RETURN
*
*     End of DLACPY
*
      END
c $Id: dlacpy.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine argos_space_rdrst(lfnrst,filrst,lfntop,filtop,
     + temp,tempw,temps,ipl,xw,vw,fw,xwcr,iwl,xs,vs,fs,xscr,isl,
     + bxw,bvw,bfw,brw,ibw,nw,bxs,bvs,bfs,ibs,ns,ndx,
     + ibownr,boxsiz,lseq,isndx)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer argos_space_btop
      external argos_space_btop
c
      integer lfnrst,lfntop
      character*255 filrst,filtop
      integer nw,ns
      integer ibownr(maxbox,3)
      integer ipl(mbox,mip2),iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3),xscr(msm,3)
      real*8 fw(mwm,3,mwa),fs(msa,3)
      real*8 bxw(nw,3,mwa),bxs(ns,3),brw(nw,3)
      real*8 bvw(nw,3,mwa),bvs(ns,3)
      real*8 bfw(nw,3,mwa),bfs(ns,3)
      integer ibw(nw,2),ibs(ns,mis2)
      real*8 boxsiz(maxbox,3)
      integer ndx(nw),lseq(mseq),isndx(mseq)
      real*8 temp,tempw,temps
c
      character*1 cdum
      real*8 rdum,cgx,cgy,cgz
      integer i,j,k,idum,jdum,kdum,number,ncyc,numw
      integer icyc,ibx,iby,ibz,ipx,ipy,ipz,node,new,nold
      integer ilw,ihw,jlw,jhw,ils,ihs,jls,jhs
      integer ili,ihi,jli,jhi,ilp,ihp,jlp,jhp
c
      integer nat,nqt,naw,nbw,nhw,ndw,now,ntw,nnw,nsmr
      real*8 boxi(3)
      logical lforces
      character*80 card
c
      integer l,m,ib(3),nbox,nb(3),joff,npars,icount,lasts
      real*8 xtmin,xtmax,xtx,xt(3)
c
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 util_nint
      external util_nint
#endif
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort('ERROR IN MEMORY USE ENTERING ARGOS_SPACE_RDRST',0)
      endif
c
      lpbc9=.true.
      nsmr=0
      icount=0
      lasts=0
      ndums=0
c
      if(me.eq.0) then
c
      open(unit=lfnrst,file=filrst(1:index(filrst,' ')-1),
     + status='old',form='formatted',err=9999)
      rewind(lfnrst)
c
      open(unit=lfntop,file=filtop(1:index(filtop,' ')-1),
     + status='old',form='formatted',err=9899)
      rewind(lfntop)
c
      write(lfnout,6000)
 6000 format(/,' TOPOLOGY FILE INFORMATION',/)
c
      read(lfntop,2001,end=9897,err=9898) card
 2001 format(a80)
      write(lfnout,6001) card
 6001 format(' Title',t15,a)
      read(lfntop,2001,end=9897,err=9898) card
      write(lfnout,6002) card
 6002 format(t15,a)
      read(lfntop,2001,end=9897,err=9898) card
      write(lfnout,6002) card
c
      read(lfntop,2001,end=9897,err=9898) card
      write(lfnout,6003) card(1:12),card(13:32),card(33:42)
 6003 format(' Version',t15,a,/,' Date',t15,a,/,' Force field',t15,a)
c
      read(lfntop,2002,end=9897,err=9898) npars
      read(lfntop,2002,end=9897,err=9898) nat
      read(lfntop,2002,end=9897,err=9898) nqt
      read(lfntop,2002,end=9897,err=9898) nseq
 2002 format(i5)
      read(lfntop,2001,end=9897,err=9898)
      do 1103 k=1,npars
      do 102 i=1,nat
      read(lfntop,2001,end=9897,err=9898)
      do 103 j=i,nat
      read(lfntop,2001,end=9897,err=9898)
  103 continue
  102 continue
 1103 continue
      do 104 i=1,nqt*npars
      read(lfntop,2001,end=9897,err=9898)
  104 continue
      do 4104 i=1,nseq
      read(lfntop,2001,end=9897,err=9898)
 4104 continue
      read(lfntop,2003,end=9897,err=9898) naw,nbw,nhw,ndw,now,ntw,nnw
 2003 format(5i7,2i10)
      read(lfntop,2001,end=9897,err=9898)
      do 105 i=1,naw
      read(lfntop,2001,end=9897,err=9898)
  105 continue
      do 106 i=1,nbw*(npars+1)
      read(lfntop,2001,end=9897,err=9898)
  106 continue
      do 107 i=1,nhw*(npars+1)
      read(lfntop,2001,end=9897,err=9898)
  107 continue
      do 108 i=1,ndw*(npars+1)
      read(lfntop,2001,end=9897,err=9898)
  108 continue
      do 109 i=1,now*(npars+1)
      read(lfntop,2001,end=9897,err=9898)
  109 continue
      if(ntw.gt.0) then
      read(lfntop,2004,end=9897,err=9898)
      read(lfntop,2004,end=9897,err=9898)
 2004 format(11i7)
      endif
      if(nnw.gt.0) then
      read(lfntop,2005,end=9997,err=9998)
      read(lfntop,2005,end=9997,err=9998)
 2005 format(11i7)
      endif
      read(lfntop,2001,end=9897,err=9898)
      do 204 i=1,npars
      read(lfntop,2001,end=9897,err=9898)
  204 continue
c
      write(lfnout,6100)
 6100 format(/,' RESTART FILE INFORMATION',/)
c
      read(lfnrst,1001,end=9997,err=9998) card
 1001 format(a80)
      write(lfnout,6101) card
 6101 format(' Title',t15,a)
      read(lfnrst,1001,end=9997,err=9998) card
      write(lfnout,6102) card
 6102 format(t15,a)
      read(lfnrst,1001,end=9997,err=9998) card
      write(lfnout,6002) card
c
      read(lfnrst,1016) card(1:32),nhist,lforces
 1016 format(a32,i5,4x,l1)
      write(lfnout,6103) card(1:12),card(13:32)
 6103 format(' Version',t15,a,/,' Date',t15,a)
c
      if(nhist.gt.0) write(lfnout,6104)
 6104 format(/,' History',/)
c
      if(nhist.gt.0) then
      do 21 i=1,nhist
      read(lfnrst,1017) hist(i)
 1017 format(a)
      write(lfnout,6105) hist(i)
 6105 format(1x,a)
   21 continue
      endif
      if(nhist.lt.mxhist) then
      nhist=nhist+1
      else
      do 22 i=1,nhist-1
      hist(i)=hist(i+1)
   22 continue
      endif
      do 23 i=1,80
      hist(nhist)(i:i)=' '
   23 continue
      read(lfnrst,1002,end=9997,err=9998) npbtyp,nbxtyp
 1002 format(i5,i5)
      read(lfnrst,1003,end=9997,err=9998) ((vlat(i,j),j=1,3),i=1,3)
 1003 format(3f12.6)
      read(lfnrst,1004,end=9997,err=9998) jdum
 1004 format(40x,i5)
      read(lfnrst,1005,end=9997,err=9998) temp,tempw,temps
 1005 format(3f12.6)
      do 2 i=1,3
      box(i)=vlat(i,i)
      boxh(i)=half*box(i)
      boxi(i)=one/box(i)
      do 3 j=1,3
      vlati(i,j)=vlat(i,j)
    3 continue
    2 continue
      call matinv(vlati,3,3)
      if(jdum.ne.0) then
      read(lfnrst,1001,end=9997,err=9998) cdum
      endif
      read(lfnrst,1006,end=9997,err=9998) idum
 1006 format(70x,i5)
      if(idum.gt.0) then
      read(lfnrst,1007,end=9997,err=9998) idum,jdum,kdum
 1007 format(3i5)
      read(lfnrst,1008,end=9997,err=9998) (rdum,i=1,idum)
      read(lfnrst,1008,end=9997,err=9998) (rdum,i=1,jdum)
      read(lfnrst,1008,end=9997,err=9998) (rdum,i=1,kdum)
 1008 format(4e20.12)
      endif
c
      if(nwm.gt.0) then
      number=0
      ncyc=nwm/nw+1
      numw=nw
      do 4 icyc=1,ncyc
      if(nwm-number.lt.numw) numw=nwm-number
      do 44 i=1,numw
      read(lfnrst,1009,end=9997,err=9998)
     + ((bxw(i,j,k),j=1,3),(bvw(i,j,k),j=1,3),k=1,nwa)
 1009 format(2x,6f13.8)
      if(lforces) read(lfnrst,1109,end=9997,err=9998)
     + ((bfw(i,j,k),j=1,3),k=1,nwa)
 1109 format(2x,6e13.6)
      read(lfnrst,1010,end=9997,err=9998) ibw(i,2),(brw(i,k),k=1,3)
 1010 format(i1,1x,3f13.8)
   44 continue
      do 5 i=1,numw
      cgx=zero
      cgy=zero
      cgz=zero
      do 6 k=1,nwa
      cgx=cgx+bxw(i,1,k)
      cgy=cgy+bxw(i,2,k)
      cgz=cgz+bxw(i,3,k)
      if(.not.lforces) then
      bfw(i,1,k)=zero
      bfw(i,2,k)=zero
      bfw(i,3,k)=zero
      endif
    6 continue
      ibx=0
      iby=0
      ibz=0
      if(nbxtyp.ne.1) then
      xt(1)=cgx
      xt(2)=cgy
      xt(3)=cgz
      else
      xt(1)=box(1)*(vlati(1,1)*cgx+vlati(1,2)*cgy+vlati(1,3)*cgz)
      xt(2)=box(2)*(vlati(2,1)*cgx+vlati(2,2)*cgy+vlati(2,3)*cgz)
      xt(3)=box(3)*(vlati(3,1)*cgx+vlati(3,2)*cgy+vlati(3,3)*cgz)
      endif
      do 7 j=1,nbx-1
      if(xt(1)/nwa+boxh(1).gt.boxsiz(j,1)) ibx=j
    7 continue
      do 8 j=1,nby-1
      if(xt(2)/nwa+boxh(2).gt.boxsiz(j,2)) iby=j
    8 continue
      do 9 j=1,nbz-1
      if(xt(3)/nwa+boxh(3).gt.boxsiz(j,3)) ibz=j
    9 continue
c
      if(npbtyp.gt.0) then
      if(ibx.ge.nbx) ibx=ibx-nbx
      if(iby.ge.nby) iby=iby-nby
      if(ibx.lt.0) ibx=ibx+nbx
      if(iby.lt.0) iby=iby+nby
      if(npbtyp.eq.1) then
      if(ibz.ge.nbz) ibz=ibz-nbz
      if(ibz.lt.0) ibz=ibz+nbz
      else
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibz.lt.0) ibz=0
      endif
      else
      if(ibx.ge.nbx) ibx=nbx-1
      if(iby.ge.nby) iby=nby-1
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibx.lt.0) ibx=0
      if(iby.lt.0) iby=0
      if(ibz.lt.0) ibz=0
      endif
      ipx=ibownr(ibx+1,1)
      ipy=ibownr(iby+1,2)
      ipz=ibownr(ibz+1,3)
c
      ndx(i)=(ipz*npy+ipy)*npx+ipx
      ibw(i,1)=(ibz*nby+iby)*nbx+ibx
      if(lnode0) then
      ndx(i)=0
      ibw(i,1)=0
      endif
    5 continue
      do 10 node=0,np-1
      new=0
      do 11 i=1,numw
      if(ndx(i).eq.node) then
      new=new+1
      iwl(new,lwgmn)=number+i
      iwl(new,lwnod)=node
      do 124 j=1,3
      do 12 k=1,nwa
      xw(new,j,k)=bxw(i,j,k)
      vw(new,j,k)=bvw(i,j,k)
      fw(new,j,k)=bfw(i,j,k)
   12 continue
      if(nserie.eq.0) then
      xwcr(new,j)=zero
      else
      xwcr(new,j)=brw(i,j)
      endif
  124 continue
      iwl(new,lwbox)=ibw(i,1)
      iwl(new,lwdyn)=5*ibw(i,2)
      endif
   11 continue
c
      if(new.gt.0) then
      call ga_distribution(ga_ip,node,ilp,ihp,jlp,jhp)
      call ga_get(ga_ip,ilp,ilp,jlp,jhp,ipl,mbox)
      nold=ipl(1,2)
      if(nold+new.gt.mwm) call md_abort('Dimension mwm too small',0)
      ipl(1,2)=ipl(1,2)+new
      call ga_put(ga_ip,ilp,ilp,jlp,jhp,ipl,mbox)
      call ga_distribution(ga_iw,node,ili,ihi,jli,jhi)
      ili=ili+nold
      ihi=ili+new-1
      call ga_put(ga_iw,ili,ihi,jli,jhi,iwl,mwm)
      call ga_distribution(ga_w,node,ilw,ihw,jlw,jhw)
      ilw=ilw+nold
      ihw=ilw+new-1
      call ga_put(ga_w,ilw,ihw,jlw,jlw+3*mwa-1,xw(1,1,1),mwm)
      call ga_put(ga_w,ilw,ihw,jlw+3*mwa,jlw+6*mwa-1,vw(1,1,1),mwm)
      call ga_put(ga_w,ilw,ihw,jlw+6*mwa,jlw+6*mwa+2,xwcr(1,1),mwm)
      call ga_put(ga_w,ilw,ihw,jlw+6*mwa+3,jlw+9*mwa+2,fw(1,1,1),mwm)
      endif
c
   10 continue
      number=number+numw
    4 continue
      endif
c
      if(nsa.gt.0) then
      nb(1)=nbx
      nb(2)=nby
      nb(3)=nbz
      nbox=0
      k=1
      joff=0
      do 13 i=1,nsa
      if(k.gt.ns) call md_abort
     + ('Increase memory for argos_space_rdrst buffer',0)
      read(lfnrst,1011,end=9997,err=9998)
     + ibs(k,11),(bxs(k,j),j=1,3),(bvs(k,j),j=1,3),ibs(k,12)
 1011 format(i1,1x,6f13.8,i5)
      if(ibs(k,12).lt.0) ndums=ndums+1
      if(lforces) then
      read(lfnrst,1111,end=9997,err=9998) (bfs(k,j),j=1,3)
 1111 format(2x,6e13.6)
      else
      bfs(k,1)=zero
      bfs(k,2)=zero
      bfs(k,3)=zero
      endif
      read(lfntop,2009,end=9897,err=9898) (ibs(k,j),j=1,10)
 2009 format(16x,i3,4i7,5i5)
c 2009 format(16x,10i5)
      if(ibs(k,3).ne.lasts) then
      icount=icount+1
      lasts=ibs(k,3)
      isndx(icount)=lasts
      endif
      ibs(k,3)=icount
      if(nsmr.lt.ibs(k,2)) nsmr=ibs(k,2)
      if(nserie.eq.0) then
      if(nsf.lt.ibs(k,1)) nsf=ibs(k,1)
      else
      if(nsf.lt.ibs(k,1))
     + call md_abort('Error in number of solute fractions',nsf)
      endif
c
c     if segment of this atom is different from the segment of previous atom
c     then distribute all previous atoms in the list
c
      if(k.gt.1) then
      if(ibs(k,3).ne.ibs(k-1,3)) then
      new=k-1
      goto 14
      endif
      endif
c
c     if this is the last atom distribute
c
      if(i.eq.nsa) then
      new=k
      goto 14
      endif
c
c     read next atom
c
      k=k+1
      goto 13
c
c     distribute atoms 1 through new
c
   14 continue
c
c     determine the center of geometry
c
      do 15 l=1,3
      xtmax=bxs(1,l)
      xtmin=bxs(1,l)
      do 16 j=1,new
      xtmax=max(xtmax,bxs(j,l))
      xtmin=min(xtmin,bxs(j,l))
   16 continue
      xtx=0.5d0*(xtmax+xtmin)
      if(npbtyp.ne.0) then
      if(abs(xtx).gt.boxh(l)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xtx=xtx-util_nint(xtx*boxi(l))*box(l)
#else
      xtx=xtx-nint(xtx*boxi(l))*box(l)
#endif
      endif
      endif
      ib(l)=0
      do 17 m=1,nb(l)-1
      if(xtx+boxh(l).gt.boxsiz(m,l)) ib(l)=m
   17 continue
   15 continue
c
c     periodic boundaries
c
      if(npbtyp.gt.0) then
      m=2
      if(npbtyp.eq.1) m=3
      do 18 l=1,m
      if(ib(l).ge.nb(l)) ib(l)=ib(l)-nb(l)
      if(ib(l).lt.0) ib(l)=ib(l)+nb(l)
   18 continue
      if(npbtyp.gt.1) then
      if(ib(3).ge.nb(3)) ib(3)=nb(3)-1
      if(ib(3).lt.0) ib(3)=0
      endif
      else
      do 19 l=1,3
      if(ib(l).ge.nb(l)) ib(l)=nb(l)-1
      if(ib(l).lt.0) ib(l)=0
   19 continue
      endif
c
c     determine owning node
c
      if(.not.lnode0) nbox=(ib(3)*nb(2)+ib(2))*nb(1)+ib(1)
      node=argos_space_btop(nbox,ibownr)
c
      do 120 j=1,new
      isl(j,lsgan)=joff+j
      isl(j,lsfrc)=ibs(j,1)
      isl(j,lsmol)=ibs(j,2)
      isl(j,lssgm)=ibs(j,3)
      isl(j,lsgrp)=ibs(j,4)
      isl(j,lspgr)=ibs(j,5)
      isl(j,lsatt)=ibs(j,6)
      isl(j,lsct1)=ibs(j,7)
      isl(j,lsct2)=ibs(j,8)
      isl(j,lsct3)=ibs(j,9)
      isl(j,lssss)=ibs(j,10)
      isl(j,lsdyn)=5*ibs(j,11)
      isl(j,lsbox)=nbox
      isl(j,lsnod)=node
      isl(j,lshop)=0
      if(ibs(j,12).gt.0) isl(j,lshop)=ibs(j,12)*2
      if(ibs(j,12).lt.0) isl(j,lshop)=(-ibs(j,12))*2+1
      do 121 l=1,3
      xs(j,l)=bxs(j,l)
      vs(j,l)=bvs(j,l)
      fs(j,l)=bfs(j,l)
  121 continue
  120 continue
      joff=joff+new
c
c     communicate data to node
c
      call ga_distribution(ga_ip,node,ilp,ihp,jlp,jhp)
      call ga_get(ga_ip,ilp,ilp+1,jlp,jhp,ipl,mbox)
      nold=ipl(2,2)
      if(nold+new.gt.msa)
     + call md_abort('Dimension msa too small (1)',nold+new)
      ipl(2,2)=ipl(2,2)+new
      call ga_put(ga_ip,ilp,ilp+1,jlp,jhp,ipl,mbox)
      call ga_distribution(ga_is,node,ili,ihi,jli,jhi)
      ili=ili+nold
      ihi=ili+new-1
      call ga_put(ga_is,ili,ihi,jli,jhi,isl,msa)
      call ga_distribution(ga_s,node,ils,ihs,jls,jhs)
      ils=ils+nold
      ihs=ils+new-1
      call ga_put(ga_s,ils,ihs,jls,jls+2,xs(1,1),msa)
      call ga_put(ga_s,ils,ihs,jls+3,jls+5,vs(1,1),msa)
      call ga_put(ga_s,ils,ihs,jls+9,jls+11,fs(1,1),msa)
c
c     make first atom of next segment first in the list
c
      if(k.gt.new) then
      do 122 j=1,12
      ibs(1,j)=ibs(k,j)
  122 continue
      do 123 j=1,3
      bxs(1,j)=bxs(k,j)
      bvs(1,j)=bvs(k,j)
      bfs(1,j)=bfs(k,j)
  123 continue
      k=2
      if(i.eq.nsa) then
      new=1
      k=1
      goto 14
      endif
      endif
c
   13 continue
      endif
c
      if(nsm.gt.0) then
      do 31 i=1,nsm
      xscr(i,1)=zero
      xscr(i,2)=zero
      xscr(i,3)=zero
   31 continue
      do 32 i=1,nsm
      read(lfnrst,1012,end=99,err=99) (xscr(i,j),j=1,3)
 1012 format(2x,3f13.8)
      if(nserie.eq.0) then
      xscr(i,1)=zero
      xscr(i,2)=zero
      xscr(i,3)=zero
      endif
   32 continue
      endif
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort('ERROR IN MEMORY IN ARGOS_SPACE_RDRST',1)
      endif
c
      if(nseq.gt.0) then
      read(lfnrst,1013) (lseq(i),i=1,nseq)
 1013 format(20i3)
      endif
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort('ERROR IN MEMORY IN ARGOS_SPACE_RDRST',2)
      endif
c
   99 continue
c
      close(unit=lfnrst,status='keep')
      close(unit=lfntop,status='keep')
c
      endif
c
      if(nseq.gt.0) then
      call ga_brdcst(msp_22,lseq,nseq*ma_sizeof(mt_int,1,mt_byte),0)
      endif
      call ga_brdcst(msp_28,ndums,ma_sizeof(mt_int,1,mt_byte),0)
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort('ERROR IN MEMORY USE EXITING ARGOS_SPACE_RDRST',0)
      endif
c
      return
 9897 call md_abort('EOF encountered on topology file',0)
 9898 call md_abort('Error reading topology file',1)
 9899 call md_abort('Error opening topology file',2)
 9997 call md_abort('EOF encountered on restart file',0)
 9998 call md_abort('Error reading restart file',0)
 9999 call md_abort('Error opening restart file',0)
      return
      end
c $Id: argos_space_rdrst.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function et_movecs_read(filename, iset, occ
     &     , evals, g_vecs, energy)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "mafdecls.fh"
#include "msgids.fh"
#include "cscfps.fh"
#include "inp.fh"
#include "util.fh"
c
      character*(*) filename
      integer iset              ! No. (1,2) of set of vectors to read
      double precision occ(*)   ! Must be at least nbf long (not nmo)
      double precision evals(*) ! Must be at least nbf long (not nmo)
      integer g_vecs
c
      integer nsets             ! No. of sets of vectors
      integer nbf               ! No. of functions in basis
      integer nmo(2)            ! No. of vectors in each set
      integer ok, jset, i, j
      integer l_vecs, k_vecs
      integer unitno
      parameter (unitno = 67)
      double precision energy, enrep
c     
      l_vecs = -1               ! An invalid MA handle
c
      if (oscfps) call pstat_on(ps_vecio)
      call ga_sync()
      ok = 0
      if (ga_nodeid() .eq. 0) then
         open(unitno, status='old', form='unformatted', file=filename,
     $        err=1000)
c
c     Skip over uninteresting bits of the header
c
         read(unitno, err=1001, end=1001) ! convergence info
         read(unitno, err=1001, end=1001) ! scftype
         read(unitno, err=1001, end=1001) ! lentit
         read(unitno, err=1001, end=1001) ! title
         read(unitno, err=1001, end=1001) ! lenbas
         read(unitno, err=1001, end=1001) ! basis_name
         read(unitno, err=1001, end=1001) nsets
         read(unitno, err=1001, end=1001) nbf
         read(unitno, err=1001, end=1001) (nmo(i),i=1,nsets)
c
         if (.not. ma_push_get(mt_dbl,nbf,'et_movecs_read'
     &       ,l_vecs,k_vecs))
     $        call errquit('et_movecs_read: ma failed', nbf, MA_ERR)
c
c     Skip over unwanted sets
c
         do jset = 1, iset-1
            read(unitno, err=1001, end=1001)
            read(unitno, err=1001, end=1001)
            do i = 1, nmo(jset)
               read(unitno, err=1001, end=1001)
            enddo
         enddo
c
      if (iset.eq.3) then
        read(unitno, err=1001) energy, enrep
        if (energy.eq.0.0d0.and.ga_nodeid().eq.0) then 
          write(6,*) 
          write(6,*) 'H(RR) or H(PP) not found in file ',filename
          write(6,*) 'The vectors are not converged. If you know'
          write(6,*) 'H(RR) and H(PP), you can still calculate V(RP)'
          write(6,*) 'using this equation : '
          write(6,*) 
          write(6,*) '             H(RP) - S(RP)*0.5*( H(RR) + H(PP) ) '
          write(6,*) 'V(RP) =      ----------------------------------- '
          write(6,*) '                   1 - S(RP)*S(RP)           '
          write(6,*) 
          energy = 0.0d0
        else
          energy = energy - enrep
        endif
      else
c
         read(unitno, err=1001, end=1001) (occ(j),j=1,nbf)
         read(unitno, err=1001, end=1001) (evals(j),j=1,nbf)
         do i = 1, nmo(iset)
            call sread(unitno, dbl_mb(k_vecs), nbf)
            call ga_put(g_vecs, 1, nbf, i, i, dbl_mb(k_vecs), 1)
         enddo
      endif
c
 9       close(unitno,err=1002)
         ok = 1
      endif
c
 10   continue
      if (l_vecs .ne. -1) then
	 if (.not. ma_pop_stack(l_vecs)) call errquit
     $      ('et_movecs_read: pop failed', l_vecs, MA_ERR)
      endif
      call ga_sync()
      call ga_brdcst(Msg_Vec_Stat+MSGINT, ok, mitob(1), 0) ! Propagate status
      if (ok .eq. 1) then
	 call ga_brdcst(Msg_Vec_NBF+MSGINT, nbf, mitob(1), 0)
	 call ga_brdcst(Msg_Vec_EVal+MSGDBL, evals, mdtob(nbf), 0)
	 call ga_brdcst(Msg_Vec_Occ+MSGDBL, occ,   mdtob(nbf), 0)
      endif
c
      et_movecs_read = ok .eq. 1
      if (ga_nodeid() .eq. 0 .and. et_movecs_read .and.
     $     util_print('vectors i/o', print_default)) then
c         write(6,22) filename(1:inp_strlen(filename))
c 22      format(/' Read molecular orbitals from ',a/)
         call util_flush(6)
      endif
      if (oscfps) call pstat_off(ps_vecio)
      return
c
 1000 write(6,*) ' et_movecs_read: failed to open ',
     $     filename(1:inp_strlen(filename))
      call util_flush(6)
      ok = 0
      goto 10
c
 1001 write(6,*) ' et_movecs_read: failing reading from ',
     $     filename(1:inp_strlen(filename))
      call util_flush(6)
      ok = 0
      close(unitno,err=1002)
      goto 10
c
 1002 write(6,*) ' et_movecs_read: failed to close',
     $     filename(1:inp_strlen(filename))
      call util_flush(6)
      ok = 0
      goto 10
c
      end
c $Id: et_movecs_read.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine dmd_input(rtdb)
*
* $Id: dmd_input.F 19696 2010-10-29 16:53:42Z d3y133 $
*
      implicit none
#include "rtdb.fh"
#include "context.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
#include "rel_consts.fh"
#include "errquit.fh"
c     
c     Read input for calculations with Dyall-Mod-Dirac
c     
c     All input is of the form:
c     <keyword>                          or   
c     <keyword> <on||off>                or
c     <keyword> <sf>  !future option     or
c     <keyword> <afw> !future option     or a combination of the last three
c     
      integer rtdb ! [input] handle to database
c    
      character*255 test
      logical dmd_run, atomic_nesc, one_e_approx, one_cent, do_ssss
      logical ss_set, ssss_set
c
c   Initialize parameters. If on rtdb, use these values (to preserve
c   persistence of settings), otherwise set to default.
c
      dmd_run  = .true.
      if (.not. rtdb_get(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
     &    atomic_nesc = .true.
      if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,one_e_approx))
     &    one_e_approx = .true.
      if (.not. rtdb_get(rtdb,'ss_one_cent',mt_log,1,one_cent)) 
     &    one_cent = .false.
      if (.not. rtdb_get(rtdb,'do_ssss',mt_log,1,do_ssss)) 
     &    do_ssss = .true.
c
c     Read input data beyond Dyall-Mod-Dirac; store in rtdb.
c     
      if (inp_a(test)) then
        if (inp_compare(.false., 'off', test)) then
          dmd_run = .false.
          if (.not. rtdb_put(rtdb, 'dyall_mod_dir', mt_log, 1, dmd_run))
     &        call errquit('dmd_input: rtdb_put failed', 0, RTDB_ERR)
          return
        elseif (inp_compare(.false., 'on', test)) then
          dmd_run  = .true.
        else if (inp_compare(.false., 'nesc1e', test)) then
          one_e_approx = .true.
        else if (inp_compare(.false., 'nesc2e', test)) then
          one_e_approx = .false.
          ss_set = .false.
          ssss_set = .false.
   10     if (inp_a(test)) then
            if (inp_compare(.false., 'ss1cent', test)) then
              if (ss_set) call errquit(
     &            ' Already set SS 1-center option',0, UNKNOWN_ERR)
              ss_set = .true.
              if (inp_a(test)) then
                if (inp_compare(.false., 'on', test)) then
                  one_cent = .true.
                else if (inp_compare(.false., 'off', test)) then
                  one_cent = .false.
                else
                  one_cent = .true.
                  call inp_prev_field()
                end if
              else
                one_cent = .true.
              end if
            elseif (inp_compare(.false., 'ssall', test)) then
              if (ss_set) call errquit(
     &            ' Already set SS 1-center option',0, UNKNOWN_ERR)
              ss_set = .true.
              one_cent = .false.
            else if (inp_compare(.false., 'ssss', test)) then
              if (ssss_set) call errquit(
     &            ' Already set SSSS option',0, UNKNOWN_ERR)
              ssss_set = .true.
              if (inp_a(test)) then
                if (inp_compare(.false., 'on', test)) then
                  do_ssss = .true.
                else if (inp_compare(.false., 'off', test)) then
                  do_ssss = .false.
                else
                  do_ssss = .true.
                  call inp_prev_field()
                end if
              else
                do_ssss = .true.
              end if
            else if (inp_compare(.false., 'nossss', test)) then
              if (ssss_set) call errquit(
     &            ' Already set SSSS option',0, UNKNOWN_ERR)
              ssss_set = .true.
              do_ssss = .false.
            else
              call errquit('dmd_input: unknown option for nesc2e',0,
     &       INPUT_ERR)
            end if
            go to 10
          end if
        else
          call errquit('dmd_input: unknown directive',0, INPUT_ERR)
        end if
      endif
c
c     If we are going to do Dyall-Modified-Dirac then print out information 
c
      if ((ga_nodeid() .eq. 0) .and. dmd_run .and. 
     $    util_print('dyall-mod-dirac', print_low)) then
        write(luout,20)
   20   format(//' Relativistic calculation using Dyall''s modification'
     &      ,' to the Dirac equation,',
     &      /5x,'K. G. Dyall, J. Chem. Phys. 100, 2118 (1994) ')
        if (atomic_nesc) write (luout,30)
   30   format(/' Calculation performed with normalized elimination of',
     &      ' small components (NESC) and atomic 4-spinor expansion,',/,
     &      5x,'K. G. Dyall, J. Chem. Phys. 106, 9618 (1997); K. G. Dy',
     &      'all and T. Enevoldsen, J. Chem. Phys. 111, 10000 (1999).')
        if (one_e_approx) then
          write (luout,40)
   40     format (/' Electron-electron interaction approximated by ',
     &        'neglecting the commutator of 1/r12 with the atomic FW ',
     &        'transformation,',/5x,
     &        'K. G. Dyall, in preparation.')
        else if (one_cent) then
          write (luout,50)
   50     format (/' Only one-center small component densities used ',
     &        'in two-electron integrals.')
        end if
        write (luout,*)
      endif
c
c     Put parameters in rtdb
c       
      if (.not. rtdb_put(rtdb,'dyall_mod_dir',mt_log,1,dmd_run))
     &    call errquit('dmd_input: rtdb_put failed', 0, RTDB_ERR)
      if (.not. rtdb_put(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
     &    call errquit('dmd_input: rtdb_put failed', 0, RTDB_ERR)
      if (.not. rtdb_put(rtdb,'nesc_1e_approx',mt_log,1,one_e_approx))
     &    call errquit('dmd_input: rtdb_put failed', 0, RTDB_ERR)
      if (.not. rtdb_put(rtdb,'ss_one_cent',mt_log,1,one_cent)) 
     &    call errquit('dmd_input: rtdb_put failed', 0, RTDB_ERR)
      if (.not. rtdb_put(rtdb,'do_ssss',mt_log,1,do_ssss)) 
     &    call errquit('dmd_input: rtdb_put failed', 0, RTDB_ERR)
c
      return
c       
      end

      subroutine fastj(rtdb, basis, g_dens, eps, data)
*
* $Id: fastj.F 21314 2011-10-27 21:26:46Z d3p852 $
*
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "bas.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "global.fh"
      integer rtdb
      integer basis
      integer g_dens
      double precision eps
      integer data(2)
c
c     Given a normalized basis set and a density matrix
c     solve Poisson's equation so that subsequent calls to
c     fastj_evaluate() can be used to evaluate the potential
c     at arbitrary interior points.  
c
c     eps controls the precision in an as yet unspecified fashion
c
c     data is returned and must be passed unchanged to fastj_evaluate()
c     
c     call fastj_tidy(data) ... used to free allocated resources
c     (MA heap and GA).
c     
      integer iat, ish, i, nsh, nbf, geom, nat, ishlo, ishhi, type,
     $     nprim, ngen, n, nx, ny, nz, l_grid, k_grid,
     $     depth, lmax, levelbc
      integer maxprim, maxgen, maxgrid, ntest, maxl
      parameter (maxprim = 31, maxgen=1, maxgrid=16,ntest=100000,
     $     maxl = FMM_LMAX)
      double precision alpha(maxprim), start, used
      double precision rtest(3,ntest), ptest(ntest), ptest2(ntest)
      double precision q(-maxl:maxl,0:maxl)
      logical osph, status
      character*16 tag
      integer gridinfo(5,maxgrid)
      double precision gridh(3,maxgrid)
      integer ngrid, nnx, nny, nnz, lenpoles
      double precision c(3), charge, x, y, z, xlo, xhi, ylo, yhi,
     $     zlo, zhi, range, side, resolution, pi, exponent, xx, yy, zz,
     $     hx, hy, hz, hx_fmm, hy_fmm, hz_fmm, 
*     $     test1, 
     $     test2, test3,
     $     errmax, errrelmax, errrelrms, errrms, err, rneglect, resn
      integer nbig, nprimtot
c
      integer lenpairs, lenxlm, l_list, k_list, l_pairs, k_pairs, 
     $     l_pairs2, k_pairs2, npairs, tree(300)
      double precision oversample, total_time
c
      double precision fastj_gaussian_range, potential
      double precision drand, fastj_r_neglected
      external fastj_gaussian_range, potential, drand
      external fastj_r_neglected
c
c     Initialize radial fits of potentials due to gaussians
c     and also the multipoles
c
      call anl_fit_init
      call xlm_init
      total_time = util_cpusec()
c
      write(6,*) ' before free g_dens ', g_dens
      call ga_summarize(0)
      if (.not. ga_destroy(-1000)) call errquit('-1000',0, GA_ERR)
      if (.not. ga_destroy(-999)) call errquit('-999',0, GA_ERR)
      if (.not. ga_destroy(-998)) call errquit('-998',0, GA_ERR)
      if (.not. ga_destroy(-996)) call errquit('-996',0, GA_ERR)
      if (.not. ga_destroy(-995)) call errquit('-995',0, GA_ERR)
      call ga_summarize(0)
c
c     Get info
c
      pi = 4.0d0*atan(1.0d0)
      if (.not. bas_numcont(basis, nsh)) call errquit('fastJ: basis?',0,
     &       BASIS_ERR)
      if (.not. bas_numbf(basis, nbf)) call errquit('fastJ: basis?',0,
     &       BASIS_ERR)
      if (.not. bas_geom(basis, geom)) call errquit('fastJ: basis?',0,
     &       BASIS_ERR)
      if (.not. geom_ncent(geom, nat)) call errquit('fastJ: geom?',0,
     &       GEOM_ERR)
c
      if (util_print('fastjranges',print_debug)) then
         write(6,76) eps
 76      format(' Ranges/resolutions for accuracy = ',1p,d9.1)
         do i = -7,7            ! alpha = 2**i
            range = fastj_gaussian_range(0, 2.0d0**i, eps)
            rneglect= fastj_r_neglected(0, 2.0d0**i, eps)
            exponent = 1.0d0/ (4.0d0 * 2.0d0**i)
            resolution = fastj_gaussian_range(0, exponent, eps)/pi
            resn = fastj_r_neglected(0, exponent, eps)/pi
            write(6,77) i, 2.0d0**i, range, rneglect, resolution, resn
 77         format(1x,i2,' alpha=',f8.4,' range=',f8.4, ' rneg=',f8.4,
     $           ' res=',f8.4, ' resneg=',f8.4)
         end do
      end if
c
c     Determine the solution volume.  It must enlose the space of
c     all basis function products.  Look at the range of the square
c     of functions on each center.
c
      nprimtot = 0
      do iat = 1, nat
         if (.not. bas_ce2cnr(basis, iat, ishlo, ishhi))
     $        call errquit('fastJ: bas_ce2cnr', 0, BASIS_ERR)
         if (.not. geom_cent_get(geom, iat, tag, c, charge))
     $        call errquit('fastJ: geom_cart_get ', iat, GEOM_ERR)
         x = c(1)
         y = c(2)
         z = c(3)
         if (iat .eq. 1) then
            xlo = x
            xhi = x
            ylo = y
            yhi = y
            zlo = z
            zhi = z
         end if
         do ish = ishlo, ishhi
            if (.not.bas_continfo(basis, ish, type, nprim, ngen, osph))
     $           call errquit('fastJ: bas_cont_info', ish, BASIS_ERR)
            type = abs(type)
            if (nprim.gt.maxprim .or. ngen.gt.maxgen)
     $           call errquit('fastJ: nprim or ngen?',nprim*100+ngen,
     &       UNKNOWN_ERR)
            if (.not.bas_get_exponent(basis, ish, alpha))
     $           call errquit('fastJ: bas_get_exponent?',ish, BASIS_ERR)
c
            nprimtot = nprimtot + nprim
            do i = 1, nprim
               range = fastj_r_neglected(2*type,2.0d0*alpha(i),eps)
               xlo = min(x-range,xlo)
               xhi = max(x+range,xhi)
               ylo = min(y-range,ylo)
               yhi = max(y+range,yhi)
               zlo = min(z-range,zlo)
               zhi = max(z+range,zhi)
            end do
         end do
      end do
c
c     Sidemin is the minimum dimension of a cube that contains everything.
c     The actual volume will include a border of 1 FMM box
c
c     The FMM handles non-cubic volumes except for the caching
c     of rotation operators.  Until this is fixed use a cubic volume
c
c     Pick initial guesses for the FMM tree depth and FFT grid points
c     but allow full override by the user.
c
      if (.not. rtdb_get(rtdb, 'fastj:depth', mt_int, 1, depth))
     $     depth = 4
      if (.not. rtdb_get(rtdb, 'fastj:levelbc', mt_int, 1, levelbc))
     $     levelbc = depth
c
      if (.not. rtdb_get(rtdb, 'fastj:lmax', mt_int, 1, lmax)) then
         lmax = nint(-log(eps/3.26e-3)/log(1.7783d0))
         lmax = max(7,lmax)     ! Required for eps=1e-4
      endif
      lmax = min(maxl,lmax)
c
      if (.not. rtdb_get(rtdb, 'fastj:oversample', mt_dbl, 1, 
     $     oversample)) oversample = 1.8d0
c
c     Adjust the domain size so that we have one FMM box on
c     either side so that we have accurate potentials everywhere
c     the products of basis functions are non-zero
c
      side = max(xhi-xlo,yhi-ylo,zhi-zlo) * 0.5d0
      side = side * 2.0d0**levelbc / (2.0d0**levelbc - 2.0d0)
      x = (xhi+xlo)/2.0d0       ! Volume center
      y = (yhi+ylo)/2.0d0
      z = (zhi+zlo)/2.0d0
      xlo = x - side
      xhi = x + side
      ylo = y - side
      yhi = y + side
      zlo = z - side
      zhi = z + side
c
c     Determine the resolution or grid spacing which will be used to
c     determine if functions can be represented on the grid or not
c
      if (.not. rtdb_get(rtdb, 'fastj:resolution', mt_dbl, 1, 
     $     resolution)) resolution = 6.66667d0
c
      if (.not. rtdb_get(rtdb, 'fastj:ngrid', mt_int, 1, n))
     $     n = (xhi-xlo)*resolution*oversample
c
      n = min(n,539)
c
      call fastj_optimize_n(n, 'nearby')
      nx = n
      ny = n
      nz = n
      hx  = (xhi-xlo)/dble(nx+1)
      hy  = (yhi-ylo)/dble(ny+1)
      hz  = (zhi-zlo)/dble(nz+1)
c
      hx_fmm = (xhi-xlo)/dble(2**depth) ! FMM box size
      hy_fmm = (yhi-ylo)/dble(2**depth)
      hz_fmm = (zhi-zlo)/dble(2**depth)
c      
      if (util_print('fastjinfo',print_debug)) 
     $     write(6,1) xlo, xhi, ylo, yhi, zlo, zhi
 1    format(' fastj: Solution volume: ',3(2f7.2,'  '))
c
c     Since we are temporaily restricted to cubic only do one dim
c
      resolution = 1d0/hz
      if (util_print('fastjinfo',print_debug)) 
     $     write(6,2) oversample, resolution/oversample, resolution, 
     $     nx, ny, nz,  depth, levelbc, lmax
 2    format(
     $       ' fastj:            Oversample ', f7.2/
     $       ' fastj:  FFT sampling density ', f7.2/
     $       ' fastj: FFT fine grid density ', f7.2/
     $       ' fastj:    No. of grid points ', 3i5/
     $       ' fastj:        FMM tree depth ', i5/
     $       ' fastj:  FMM tree level of bc ', i5/
     $       ' fastj:                  lmax ', i5)
c
c     Allocate the grid and tabulate the smooth component
c     of the density ... eventually this must be on a
c     nest of grids and we must compute the multipoles
c     and build the direct lists at the same time.
c
c     For efficient evaluation we allocate a nest of grids
c     so that we don't oversample smooth functions.
c
c     Since evaluating the density is so fast compared to the
c     FFT interpolation we don't evaluate on the very finest grid
c
      nnx = nx
      nny = ny
      nnz = nz
      do ngrid = 1, maxgrid
         if (ngrid .eq. 1) then
            status = ma_alloc_get(mt_dbl, nnx*nny*nnz, 'fastj: grid',
     $           l_grid, k_grid)
         else
            status = ma_push_get(mt_dbl, nnx*nny*nnz, 'fastj: grid',
     $           l_grid, k_grid) 
         end if
         if (.not. status) call errquit('fastj: ma grid',nnx*nny*nnz,
     &       UNKNOWN_ERR)
         call dfill(nnx*nny*nnz, 0.0d0, dbl_mb(k_grid), 1)
c
         gridinfo(1,ngrid) = nnx
         gridinfo(2,ngrid) = nny
         gridinfo(3,ngrid) = nnz
         gridinfo(4,ngrid) = k_grid
         gridinfo(5,ngrid) = l_grid
         gridh(1,ngrid) = (xhi-xlo)/dble(nnx+1)
         gridh(2,ngrid) = (xhi-xlo)/dble(nny+1)
         gridh(3,ngrid) = (xhi-xlo)/dble(nnz+1)
c
         if (util_print('fastjnest',print_debug)) 
     $        write(6,81) ngrid,
     $        (gridinfo(i,ngrid),i=1,3),(gridh(i,ngrid),i=1,3)
 81      format(' fastj: ',i2,' Allocated grid(',
     $        i4,',',i4,',',i4,')  with h(',f6.2,',',f6.2,',',f6.2,')')
c         
         if (ngrid .eq. 1) then
            nnx = (nnx+1)/oversample - 1
            nny = (nny+1)/oversample - 1
            nnz = (nnz+1)/oversample - 1
         else
            nnx = (nnx+1)/1.26 - 1
            nny = (nny+1)/1.26 - 1
            nnz = (nnz+1)/1.26 - 1
         endif
         call fastj_optimize_n(nnx, 'nearby')
         call fastj_optimize_n(nny, 'nearby')
         call fastj_optimize_n(nnz, 'nearby')
c
         if (nnx.lt.32 .or. nny.lt.32 .or. nnz.lt.32) goto 10
      end do
 10   if (ngrid .gt. maxgrid) ngrid = maxgrid
c
c     Also allocate space for the multipoles (entire octree) and
c     the linked list of shell-pairs assigned to each level.
c     The data linked by the list will be reallocated on the
c     heap when we know how big it is.
c
      lenpairs = nprimtot*(nprimtot+1)/2
*      lenpairs = 12*(nsh*(nsh+1)) ! 24*#pairs for primtives
      lenpoles = (8**(depth+1)-1)/7
      lenxlm   = (lmax+1)**2
      if (.not. ma_alloc_get(mt_int, lenpoles, 'fastj: list',
     $     l_list, k_list)) call errquit
     $     ('fastj: cannot allocate list ', lenpoles, MA_ERR)
      if (.not. ma_push_get(mt_int, lenpairs*2, 'fastj: pairs',
     $     l_pairs, k_pairs)) call errquit
     $     ('fastj: cannot allocate pairs for plan b ', lenpairs*2,
     &       MA_ERR)
c
      call fmm_tree_create(depth, lmax, tree)
c
      call fastj_density(ngrid, gridinfo, gridh,
     $     xlo, xhi, ylo, yhi, zlo, zhi,
     $     basis, geom, nat, nsh, nbf, g_dens, eps, oversample,
     $     q, lmax, depth, tree, int_mb(k_list), 
     $     int_mb(k_pairs), lenpairs, npairs)
c
      write(6,*) ' FMM tree after creating poles '
      call fmm_tree_summarize(tree)
      write(6,*)
c
c     Allocate minimal space for linked list on heap and copy
c
      if (.not. ma_alloc_get(mt_int, npairs*2, 'fastj: pairs2',
     $     l_pairs2, k_pairs2)) call errquit
     $     ('fastj: cannot allocate pairs ', npairs*2, MA_ERR)
      call icopy(npairs*2, int_mb(k_pairs), 1, int_mb(k_pairs2), 1)
c
c     Free up all of the memory we are no longer using
c
      if (ngrid .gt. 1) then
         if (.not. ma_chop_stack(gridinfo(5,2))) call errquit
     $        ('fastJ: ma chop failed ', 1, MA_ERR)
      end if
c
c     Only finest grid (no. 1) left now
c
      nx = gridinfo(1,1)
      ny = gridinfo(2,1)
      nz = gridinfo(3,1)
      k_grid = gridinfo(4,1)
      l_grid = gridinfo(5,1)
      hx = gridh(1,1)
      hy = gridh(2,1)
      hz = gridh(3,1)
c
c     Solve the sucker
c
      call solver(
     $     dbl_mb(k_grid), nx, ny, nz, 
     $     tree, depth, lmax, levelbc,
     $     xlo, xhi, ylo, yhi, zlo, zhi, .true., .true.)
c
      write(6,*) ' FMM tree after solving '
      call fmm_tree_summarize(tree)
      write(6,*)
c
      call fastj_pack_data(data,xlo,xhi,ylo,yhi,zlo,zhi,
     $     hx,hy,hz,k_grid,l_grid,tree,
     $     depth,lmax,nx,ny,nz,eps,l_list,k_list,l_pairs2,k_pairs2,
     $     npairs, g_dens, basis)
c
      total_time = util_cpusec() - total_time
      if (util_print('fastjinfo',print_debug)) write(6,1111) total_time
 1111 format(' fastj: Total solution time ', f8.2)
c
c     Now check the errors
c
      if (util_print('fastjerror',print_debug)) then
         errmax = 0.0d0
         errrms = 0.0d0
         errrelmax = 0.0d0
         errrelrms = 0.0d0
         nbig = 0
         do i = 1, ntest
*            x = xlo + 2.0d0*hx_fmm + drand(0)*(xhi-xlo-4.0d0*hx_fmm)
*            y = ylo + 2.0d0*hy_fmm + drand(0)*(yhi-ylo-4.0d0*hy_fmm)
*            z = zlo + 2.0d0*hz_fmm + drand(0)*(zhi-zlo-4.0d0*hz_fmm)
 333        x = xlo + hx_fmm + drand(0)*(xhi-xlo-2.0d0*hx_fmm)
            y = ylo + hy_fmm + drand(0)*(yhi-ylo-2.0d0*hy_fmm)
            z = zlo + hz_fmm + drand(0)*(zhi-zlo-2.0d0*hz_fmm)
            if ((x-xlo).lt.2*hx_fmm .or. (y-ylo).lt.2*hy_fmm .or.
     $           (z-zlo).lt.2*hz_fmm .or. (xhi-x).lt.2*hx_fmm .or.
     $           (yhi-y).lt.2*hy_fmm .or. (zhi-z).lt.2*hz_fmm) then
               rtest(1,i) = x
               rtest(2,i) = y
               rtest(3,i) = z
            else
               goto 333
            endif
         end do
c
         start = util_cpusec()
         call potential_list(basis, g_dens, ntest, rtest, ptest2, 
     $        eps*1d-2)
         used = (util_cpusec()-start)/ntest
         write(6,8321) used
 8321    format(' Time per point for potential_list  ', 1p, d9.2)

         start = util_cpusec()
         call fastj_eval_list_from_data(data, ntest, rtest, ptest)
         used = (util_cpusec()-start)/ntest
         write(6,8322) used
 8322    format(' Time per point for fastj_eval_list ', 1p, d9.2)
c
         do i = 1, ntest
            x = rtest(1,i)
            y = rtest(2,i)
            z = rtest(3,i)
*            test1 = fastj_eval_point(data, x, y, z)
            test2 = ptest2(i)   ! Old but faster
*            test3 = potential(basis, g_dens, x, y, z) ! Old and v. slow
            test3 = ptest(i)    ! New
            err = abs(test2 - test3)
            errrms = errrms + err*err
            if (abs(test2).gt.eps) then
               errrelmax = max(errrelmax, abs(err/test2))
               errrelrms = errrelrms + (err/test2)**2
            endif
            if (abs(err) .gt. errmax) then
               errmax = abs(err)
               xx = x
               yy = y
               zz = z
            end if
            if (abs(test2-test3) .gt. eps) then
               nbig = nbig + 1
*               write(6,781) i, x, y, z, test2, test3, test2-test3
* 781           format(1x,i5,2x,3f8.2,2x,2f16.10,1p,d9.2)
            end if
         end do
         errrms = sqrt(errrms / ntest)
         errrelrms = sqrt(errrelrms / ntest)
         write(6,82) errrms, errmax, errrelrms, errrelmax,
     $        xx, yy, zz, nbig
 82      format(' fastj: errrms', 1p, d9.2, 
     $        ', errmax=',d9.2,', errrelrms',d9.2, ', errrelmax',d9.2,
     $        0p/
     $         ' fastj: max error at ', 3f10.4, ' nbig', i5)
c     
         stop
c$$$         start = util_cpusec()
c$$$         do i = 1, 100
c$$$            x = xlo + 2.0d0*hx_fmm + drand(0)*(xhi-xlo-4.0d0*hx_fmm)
c$$$            y = ylo + 2.0d0*hy_fmm + drand(0)*(yhi-ylo-4.0d0*hy_fmm)
c$$$            z = zlo + 2.0d0*hz_fmm + drand(0)*(zhi-zlo-4.0d0*hz_fmm)
c$$$            test1 = fastj_eval_point(data, x, y, z)
c$$$         end do
c$$$         used = (util_cpusec()-start)/100
c$$$         write(6,83) used
c$$$ 83      format(' fastj: Time per function evaluation ', 1p,d9.2,' sec')
      end if
c
      end
      subroutine fastj_density(ngrid, gridinfo, gridh,
     $     xlo, xhi, ylo, yhi, zlo, zhi,
     $     basis, geom, nat, nsh, nbf, g_dens, eps, oversample, q,
     $     lmax, depth, tree, list, pairs, lenpairs, npairs)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "geom.fh"
#include "util.fh"
      integer ngrid
      integer gridinfo(5,ngrid)
      double precision gridh(3,ngrid)
      double precision xlo, xhi, ylo, yhi, zlo, zhi
      integer basis, geom, nat, nsh, nbf
      integer g_dens
      double precision eps, oversample
      integer lmax, depth, lenpairs
      double precision q(-lmax:lmax,0:lmax)
      integer tree(300)
      integer list((8**(depth+1)-1)/7)
      integer pairs(2, lenpairs) ! Plan B
      integer npairs            ! [output]
c
c     Parameters
c
      integer maxprim           ! Max. no. primitives in a contraction
      parameter (maxprim=31)
      integer ijtmax, ijtmax2, lencart, lenprod, maxn
      parameter (ijtmax = 5)      ! Max. angular momentum of shell
      parameter (ijtmax2 = 2*ijtmax)
      parameter (lencart = ((ijtmax2+1)*(ijtmax2+2))/2)
      parameter (lenprod = ((ijtmax2+1)*(ijtmax2+2)*(ijtmax2+3))/6)
      parameter (maxn = 1024)   ! Max. grid dimension
c
      double precision d(lencart,-ijtmax2:ijtmax2,0:ijtmax2),
     $     dinv(lenprod, -ijtmax2:ijtmax2,0:ijtmax2)
      double precision work(lenprod**2), ndens(lenprod**2), 
     $     dens(lencart**2),qn(-ijtmax2:ijtmax2,0:ijtmax2)
      double precision xi, yi, zi, xj, yj, zj, ri(3), rj(3), s
      double precision expi(maxprim), coeffi(maxprim)
      double precision expj(maxprim), coeffj(maxprim)
      double precision factor, charge, test
      double precision a, b, c, range
      double precision alpha, prefac, tol, dmax, pi
      double precision h, hx, hy, hz, resolution, scale, start, used
c
      character*16 tag
c
      integer ish,iat,ishlo,ishhi,itype,inprim,ingen,numi,ibflo,ibfhi
      integer jsh,jat,jshlo,jshhi,jtype,jnprim,jngen,numj,jbflo,jbfhi
      integer i, iprim, numi_cart
      integer j, jprim, numj_cart
      integer k, nx, ny, nz, nnx, nny, nnz, jk, jjkk, ijk, ind, ptr
      integer ishtop, ijtype, igrid, k_grid, kk_grid, l, n
c
      integer level, numlevel(0:8), numgrid(1:16)
      double precision hfmm, dist, x, y, z, totalq, rootpi, radial,
     $     tolres, tolgrid
c
      double precision fuzzy
      parameter (fuzzy = .5)    ! Fraction of neighbour for leaks .. was 0.5
c
      logical iosph, josph

      double precision fastj_gaussian_range, double_factorial,
     $     fastj_r_neglected, fastj_resolution
      external fastj_gaussian_range, double_factorial,
     $     fastj_r_neglected, fastj_resolution
c
      integer packshprim, packpair, ishprim, jshprim
#include "bitops.fh"
      packshprim(ish,iprim) = ior(lshift(ish,5),iprim)
      packpair(ishprim,jshprim) = ior(lshift(ishprim,16),jshprim)
c     
      call xlm_coeff_inv(ijtmax2,d,dinv)
      call xlm_norm(ijtmax2,qn,ijtmax2)
      pi = 4.0d0*atan(1.0d0)
      totalq = 0.0d0
      call ifill(9,0,numlevel,1)
      call ifill(16,0,numgrid,1)
c
c     Initialize the linked list assigning shell pairs to the FMM tree
c
      call ifill((8**(depth+1)-1)/7, -1, list, 1)
      npairs = 0
c
      rootpi = sqrt(4.0d0*atan(1.0d0))
      tol = eps * 1d-3          ! Screen very tightly on radial prefactor
c     .                         ! 1d-2 not quite enuf for adz 5water
c
      if (nx.gt.maxn .or. ny.gt.maxn .or. nz.gt.maxn) call errquit
     $     ('fastj: hard dimension of maxn exceeded ', maxn,
     &       UNKNOWN_ERR)
c
      start = util_cpusec()
      do jat = 1, nat
         if (.not. bas_ce2cnr(basis, jat, jshlo, jshhi))
     $        call errquit('fastJ dens: bas_ce2cnr', jat, BASIS_ERR)
         if (.not. geom_cent_get(geom, jat, tag, rj, charge))
     $        call errquit('fastJ: geom_cart_get ', jat, GEOM_ERR)
         xj = rj(1)
         yj = rj(2)
         zj = rj(3)
         do iat = 1, jat
            if (.not. bas_ce2cnr(basis, iat, ishlo, ishhi))
     $           call errquit('fastJ dens: bas_ce2cnr', iat, BASIS_ERR)
            if (.not. geom_cent_get(geom, iat, tag, ri, charge))
     $           call errquit('fastJ: geom_cart_get ', iat, GEOM_ERR)
            xi = ri(1)
            yi = ri(2)
            zi = ri(3)
            do jsh = jshlo, jshhi
               if (.not.bas_continfo(basis, jsh, jtype, jnprim,jngen, 
     $              josph)) call errquit('fastJ: bas_cont_info', jsh,
     &       BASIS_ERR)
               if (jtype .lt. 0 .or. jngen.ne.1) call errquit
     $              ('fastJ: no general/SP functions yet',0, BASIS_ERR)
               if (jtype .gt. ijtmax) call errquit
     $              ('fastJ: hard dimension ijtmax exceeded ', ijtmax,
     &       BASIS_ERR)
               if (.not. bas_cn2bfr(basis, jsh, jbflo, jbfhi))
     $              call errquit('fastJ dens: bas_cn2bfr', jsh,
     &       BASIS_ERR)
               if (.not.bas_get_exponent(basis, jsh, expj))
     $              call errquit('fastJ: bas_get_exponent?',jsh,
     &       BASIS_ERR)
               if (.not.bas_get_coeff(basis, jsh, coeffj))
     $              call errquit('fastJ: bas_get_coeff?',jsh,
     &       BASIS_ERR)
               numj = jbfhi - jbflo + 1
c
               ishtop = ishhi
               if (iat .eq. jat) ishtop = jsh
               do ish = ishlo, ishtop
                  if (.not.bas_continfo(basis,ish,itype,inprim,ingen, 
     $                 iosph)) call errquit('fastJ: bas_cont_info',ish,
     &       BASIS_ERR)
                  if (itype .gt. ijtmax) call errquit
     $                 ('fastJ: hard dimension ijtmax exceeded ',ijtmax,
     &       BASIS_ERR)
                  if (.not. bas_cn2bfr(basis, ish, ibflo, ibfhi))
     $                 call errquit('fastJ dens: bas_cn2bfr', ish,
     &       BASIS_ERR)
                  if (.not.bas_get_exponent(basis, ish, expi))
     $                 call errquit('fastJ: bas_get_exponent?',ish,
     &       BASIS_ERR)
                  if (.not.bas_get_coeff(basis, ish, coeffi))
     $                 call errquit('fastJ: bas_get_coeff?',ish,
     &       BASIS_ERR)
                  numi = ibfhi - ibflo + 1
c
                  ijtype = itype + jtype
c
c     Copy the block of density into local workspace and transform
c     to cartesians if necessary
c
                  factor = 2.0d0 ! This assumes symmetric density!
                  if (ish .eq. jsh) factor = 1.0d0
                  factor = factor
c
                  numi_cart = (itype+1)*(itype+2)/2
                  numj_cart = (jtype+1)*(jtype+2)/2
                  if (iosph) then
                     call ga_get(g_dens,ibflo,ibfhi,jbflo,jbfhi,
     $                    ndens,numi)
                     call dens_sph_to_cart(itype, jtype, 
     $                    ndens, numi, dens, work, numi_cart, numj_cart)
                     dmax = 0.0d0
                     do i = 1, numi_cart*numj_cart
                        dmax = max(dmax,abs(dens(i)))
                     end do
                  else
                     call ga_get(g_dens,ibflo,ibfhi,jbflo,jbfhi,
     $                    dens,numi)
                     dmax = 0.0d0
                     do i = 1, numi*numj
                        dmax = max(dmax,abs(dens(i)))
                     end do
                  end if
c
                  do jprim = 1, jnprim
                     do iprim = 1, inprim
                        call gaussian_product(
     $                       expi(iprim), xi, yi, zi,
     $                       expj(jprim), xj, yj, zj,
     $                       alpha, a, b, c, prefac)
c
                        prefac = prefac*factor*
     $                       coeffi(iprim)*coeffj(jprim) 
c
c     Test estimates the magnitude of any component of the product function
c
                        test = 0.0d0
                        scale = abs(prefac*dmax*rootpi/
     $                       (4.0d0*alpha*sqrt(alpha)))
                        do n = 0, ijtype
                           radial = scale
                           do l = n, 0, -2
                              test = max(test,
     $                             radial*double_factorial(n+l+1)/
     $                             (qn(l,l)*qn(l,l)))
                              radial = radial * (2.0d0*alpha)
                           end do
                           scale = scale / (2.0d0*alpha)
                        end do
c
                        if (test.gt.tol) then
*                           range = fastj_r_neglected(
*     $                          ijtype,alpha, 
*     $                          min(tol/abs(dmax*prefac),1d-4))

                           range = fastj_r_neglected(
     $                          ijtype,alpha, 
     $                          min(1d-2,eps/abs(dmax*prefac)))


*                           write(6,*) ish, jsh, iprim, jprim,
*     $                          ' RANGE ', range, dmax, prefac
c
c     Pick the most appropriate grid, reserving the finest grid for
c     oversampling.
c
                           tolres = min(1d-4,0.1d0*eps/abs(dmax*prefac))
                           resolution = fastj_r_neglected(ijtype,
     $                          0.25d0/alpha, tolres)/pi

*     Seems to work but no great advantage on systems tested
*                           tolres = min(1d-4,0.1d0*eps/abs(dmax*prefac))
*                           resolution = 1.1d0*
*     $                          fastj_resolution(alpha,ijtype,tolres)

                           h = 1.0d0/resolution
                           do igrid = ngrid,2,-1 ! Don't eval on grid 1
                              if (h .ge. gridh(1,igrid)) goto 333
                           end do
 333                       if (igrid .le. 1) then ! Don't eval on 1
c
c     The function cannot be represented on any available grid.
c     Find the smallest FMM box that will hold at least a large
c     fraction ... the distance of leakage into neighbouring
c     cells must be less than fuzzy*width
c     
                              ind = 1
c
                              do level = depth, 0, -1
                                 hfmm = (xhi-xlo)/2.0d0**level
                                 i = int((a-xlo)/hfmm)
                                 j = int((b-ylo)/hfmm)
                                 k = int((c-zlo)/hfmm)
                                 x = xlo + (dble(i)+0.5d0)*hfmm ! Box center
                                 y = ylo + (dble(j)+0.5d0)*hfmm
                                 z = zlo + (dble(k)+0.5d0)*hfmm
c     
c     To compute the distance to the nearest edge, compute 
c     max(dist. from center along each axis) and then is just h/2-dist.
c
                                 dist = max(abs(a-x),abs(b-y),abs(c-z))
                                 dist = hfmm*0.5d0 - dist ! Distance to edge
                                 dist = max(0d0,range-dist) ! Distance of spill
                                 if (dist .lt. fuzzy*hfmm) goto 222
                                 ind = ind + 8**level
                              end do
 222                          if (level .lt. 0) call errquit
     $                             ('fastj: solution volume?',0,
     &       UNKNOWN_ERR)
* 31                           format(1x,a,4i5,a,4i5,2f6.2)
*                              write(6,31) ' Assigning ', ish, iprim,
*     $                             jsh, jprim, ' to fmm box ', 
*     $                             level, i, j, k, hfmm, range
                              numlevel(level) = numlevel(level) + 1
c
c     Compute the multipole moments about the GPT center
c     then translate to the box center (expensive!)
c     
                              call pot_prim_shell_pair_multipoles(
     $                             dens,
     $                             itype, ri, numi_cart,
     $                             jtype, rj, numj_cart,
     $                             dinv, ijtmax2,
     $                             a, b, c, alpha, prefac,
     $                             q, lmax)
                              totalq = totalq + q(0,0)
*                              write(6,*) ' Q before translate '
*                              call xlm_print(lmax,q,lmax)
                              call xlm_translate2(lmax, 
     $                             x-a, y-b, z-c, q, lmax)
*                              write(6,*) ' Q after translate '
*                              call xlm_print(lmax,q,lmax)
*                              call xlm_translate2(lmax, 
*     $                             a-x, b-y, c-z, q, lmax)
*                              write(6,*) ' Q after translate back '
*                              call xlm_print(lmax,q,lmax)
*                              call xlm_translate2(lmax, 
*     $                             x-a, y-b, z-c, q, lmax)

c     
                              ind = ind+i+(2**level)*(j+2**level*k)
c
         if (ind .le. 0 .or. ind.gt.(8**(depth+1)-1)/7) call errquit
     $        ('ind ? ', ind, UNKNOWN_ERR)
*                              call xlm_accumulate_to_packed(lmax,
*     $                             poles(1,ind), q, lmax)
         call fmm_tree_add_cell(tree, level, i, j, k, q, lmax, lmax)
c     
c     Add the shell pair to the linked list of that box.  Rather
c     than add the primitive shell pair, add the contracted shell pair
c     if not already there.  The near field code must reproduce
c     the logic immediately above to figure out if a given primitive
c     pair is in that box.
c
c     Well, the above plan seems too prone to error ... instead we
c     save the shell and primitive data packed to save memory
c     
c$$$     This implements plan A ... note memory alloc must be changed
c$$$                              ptr = list(ind)
c$$$                              if (ptr .gt. 0) then
c$$$                                 odoit = ( pairs(1,ptr).ne.ish .or.
c$$$     $                                pairs(2,ptr).ne.jsh) 
c$$$                              else
c$$$                                 odoit = .true.
c$$$                              endif
c$$$                              if (odoit) then
c$$$                                 npairs = npairs + 1
c$$$                                 if (npairs.gt.lenpairs)call errquit
c$$$     $                                ('fastj:too many pairs',npairs)
c$$$                                 pairs(1,npairs) = ish
c$$$                                 pairs(2,npairs) = jsh
c$$$                                 pairs(3,npairs) = list(ind)
c$$$                                 list(ind) = npairs
c$$$                                 write(6,*) ' Adding ', ish, jsh,
c$$$     $                                level, i, j, k, ind, npairs
c$$$                              end if
c
c     Plan B
c
                              ptr = list(ind)
                              npairs = npairs + 1
                              if (npairs.gt.lenpairs)call errquit
     $                             ('fastj:too many pairs',npairs,
     &       UNKNOWN_ERR)
                              pairs(1,npairs) = packpair(
     $                             packshprim(ish,iprim),
     $                             packshprim(jsh,jprim))

c$$$
c$$$                              iijj = pairs(1,npairs)
c$$$                              iish  = iand(rshift(iijj,21),2047)
c$$$                              iiprim= iand(rshift(iijj,16),31)
c$$$                              ijsh  = iand(rshift(iijj,5),2047)
c$$$                              ijprim= iand(iijj,31)



                              pairs(2,npairs) = list(ind)
                              list(ind) = npairs
*                              write(6,*) ' Adding ', ish, iprim,
*     $                             jsh, jprim,
*     $                             level, i, j, k, ind, npairs
c$$$                              write(6,*) '*Adding ', iish, iiprim,
c$$$     $                             ijsh, ijprim
c
                           else
c     
c     The function is representable on a grid ... tabulate it
c     
                              numgrid(igrid) = numgrid(igrid) + 1
*                              write(6,*) ' Assigning ', ish, iprim,
*     $                             jsh, jprim, ' to grid ', igrid
                              call cart_dens_translate(
     $                             itype, xi, yi, zi, 
     $                             jtype, xj, yj, zj,
     $                             a, b, c, dens, work, ndens)
                              call cart_dens_product(
     $                             itype, jtype, work, ndens)
                              nx = gridinfo(1,igrid)
                              ny = gridinfo(2,igrid)
                              nz = gridinfo(3,igrid)
                              k_grid = gridinfo(4,igrid)
                              hx = gridh(1,igrid)
                              hy = gridh(2,igrid)
                              hz = gridh(3,igrid)
c     
                              range = fastj_r_neglected(
     $                             ijtype,alpha, 
     $                             min(1d-4,0.1d0*eps/abs(dmax*prefac)))
*                              tolgrid = 1d-2*eps/
*     $                             (4d0*3.14d0*range*range*hx)
                              tolgrid = 1d-4*eps
                              call fastj_density_eval(
     $                             ndens,
     $                             ijtype, alpha, prefac, range, 
     $                             a, b, c, 
     $                             dbl_mb(k_grid), nx, ny, nz, 
     $                             hx, hy, hz,
     $                             xlo, xhi, ylo, yhi, zlo, zhi, 
     $                             tolgrid)

                           end if !if (igrid)
                        end if   ! if (screen)
                     end do      ! do iprim
                  end do         ! do jprim
               end do            ! do ish
            end do               ! do jsh
         end do                  ! do iat
      end do                     ! do jat
c
      if (util_print('fastjinfo', print_debug)) then
         write(6,301) 'fastj: Numgrid  ', (numgrid(i),i=1,ngrid)
 301     format(1x,a,20i6)
         write(6,301) 'fastj: Numlevel ', (numlevel(i),i=0,depth)
      endif
c
      used = util_cpusec() - start
      if (util_print('fastjtime',print_debug))
     $     write(6,12) used
 12   format(' fastj: Evaluation of the density took ', f6.2)
c
c     Interpolate all of the grids down to the finest using the FFT
c
c     Note that we did not evaluate on grid 1 to save the cost of the FFT
c
      start = util_cpusec()
      do igrid = ngrid,2,-1     ! No need to do grid 1
         nx = gridinfo(1,igrid)
         ny = gridinfo(2,igrid)
         nz = gridinfo(3,igrid)
         k_grid = gridinfo(4,igrid)
         call vsint3d(nx,ny,nz,dbl_mb(k_grid))
         scale = 0.125d0/(dble(nx+1)*dble(ny+1)*dble(nz+1))
         call dscal(nx*ny*nz,scale,dbl_mb(k_grid),1)
      end do
      nnx = gridinfo(1,1)
      nny = gridinfo(2,1)
      nnz = gridinfo(3,1)
      kk_grid = gridinfo(4,1)
      do igrid = 2, ngrid       ! Grid 1 is the finest
         nx = gridinfo(1,igrid)
         ny = gridinfo(2,igrid)
         nz = gridinfo(3,igrid)
         k_grid = gridinfo(4,igrid)
         do k = 1, nz
            do j = 1, ny
               jk   =  k_grid +  nx*(j-1 +  ny*(k-1)) - 1
               jjkk = kk_grid + nnx*(j-1 + nny*(k-1)) - 1
               do i = 1, nx
                  dbl_mb(i+jjkk) = dbl_mb(i+jjkk) + dbl_mb(i+jk)
               end do
            end do
         end do
      end do
c
c     Here can either transform back and let the solver do a redundant
c     forward transformation, OR, stay in Fourier space.  However, if
c     stay in Fourier space need to rescale after the interpolation.
c     Note that we cannot mess with the density without doing the
c     FFT.
c
**      call vsint3d(nnx,nny,nnz,dbl_mb(kk_grid)) ! can be optimized away
c
      scale = 8.0d0*dble(nnx+1)*dble(nny+1)*dble(nnz+1)
      call dscal(nnx*nny*nnz,scale,dbl_mb(kk_grid),1)
c      
      used = util_cpusec() - start
      if (util_print('fastjtime',print_debug))
     $     write(6,13) used
 13   format(' fastj: Fourier interpolation to fine grid ',f6.2)
c
      if (util_print('fastjinfo',print_debug)) then
         s = 0.0d0
         do k = 1, nnz, 2
            do j = 1, nny, 2
               do i = 1, nnx, 2
                  ijk = kk_grid + i-1 + nnx*(j-1 + nny*(k-1))
                  s = s + dbl_mb(ijk)/(dble(i)*dble(j)*dble(k))
               end do
            end do
         end do
         s = s*8.0d0*gridh(1,1)**3 / pi**3
         write(6,33) s, totalq, s+totalq
 33      format(
     $        ' fastj: Norm of density on grid = ',f20.12/
     $        ' fastj: Norm of density in fmm  = ',f20.12/
     $        ' fastj: Norm of density total   = ',f20.12)
      end if
c
c     Screen the density for -ve values and check norm ... only
c     if we did the FFT!
c
c$$$      s = 0.0d0
c$$$      gmin = 0.0d0
c$$$      do k = 1, nnz
c$$$         do j = 1, nny
c$$$            do i = 1, nnx
c$$$               gmin = min(gmin,dbl_mb(kk_grid))
c$$$               if (dbl_mb(kk_grid) .lt. 0.0d0) dbl_mb(kk_grid) = 0.0d0
c$$$               s = s + dbl_mb(kk_grid)
c$$$               kk_grid = kk_grid + 1
c$$$            end do
c$$$         end do
c$$$      end do
c$$$      if (util_print('fastjdnorm',print_debug)) then
c$$$         s = s * gridh(1,1)**3.0d0
c$$$         write(6,31)  gmin
c$$$ 31      format(' fastj: Largest negative element ',1p,d9.2)
c$$$         write(6,32) s, s-nint(s)
c$$$ 32      format(' fastj: Trapezoidal integration of the density ',
c$$$     $        f15.10,2x,1p,d9.2)
c$$$      end if
c     
      end
      subroutine fastj_density_eval(
     $     ndens,
     $     ijtype, alpha, prefac, range, a, b, c, 
     $     g, nx, ny, nz, hx, hy, hz,
     $     xlo, xhi, ylo, yhi, zlo, zhi, tol)
      implicit none
      double precision ndens(*)
      integer ijtype
      double precision alpha, prefac, range, a, b, c, tol
      integer nx, ny, nz
      double precision g(nx, ny, nz), hx, hy, hz
      double precision xlo, ylo, zlo, xhi, yhi, zhi
c     
      integer maxn, ijtmax2
      parameter (maxn=1024, ijtmax2=10)
      double precision xx(maxn,0:ijtmax2), yy(maxn,0:ijtmax2),
     $     zz(maxn,0:ijtmax2)
      double precision ndmax
      double precision x, y, z, xxmax, s, sk
      integer i, j, k, l, p, ii, jj, kk, ind
      integer ilo, ihi, jlo, jhi, klo, khi
*      double precision fastj_gaussian_range
*      external fastj_gaussian_range
c
      ndmax = 0.0d0
      do i = 1,((ijtype+1)*(ijtype+2)*(ijtype+3))/6
         ndmax = max(ndmax,abs(ndens(i)))
      end do
c     
*      range = 1.1d0*fastj_gaussian_range(ijtype, alpha, 
*     $     min(tol/abs(ndmax*prefac),1d-4))
c     
*     write(6,*) ' primitive range ', range
c     
c     Precompute powers of cartesians and gaussians on the grid
c     
      ilo = max(int((a-range-xlo)/hx),1)
      ihi = min(int((a+range-xlo)/hx)+1,nx)
      jlo = max(int((b-range-ylo)/hy),1)
      jhi = min(int((b+range-ylo)/hy)+1,ny)
      klo = max(int((c-range-zlo)/hz),1)
      khi = min(int((c+range-zlo)/hz)+1,nz)
c     
*     write(6,*) ' restricted grid ',
*     $                          ilo, ihi, jlo, jhi, klo, khi
c     
      xxmax = 0.0d0
      x = xlo + ilo*hx - a
      do i = ilo, ihi
         xx(i,0)  = exp(-alpha*x*x)
         xxmax = max(xxmax,abs(xx(i,0)))
         x = x + hx
      end do
      y = ylo + jlo*hy - b
      do j = jlo, jhi
         yy(j,0) = exp(-alpha*y*y)
         y = y + hy
      end do
      z = zlo + klo*hz - c
      do k = klo, khi
         zz(k,0) = exp(-alpha*z*z)
         z = z + hz
      end do
c     
      do p = 1, ijtype
         x = xlo + ilo*hx - a
         do i = ilo, ihi
            xx(i,p) = xx(i,p-1)*x
            xxmax = max(xxmax,abs(xx(i,p)))
            x = x + hx
         end do
         y = ylo + jlo*hy - b
         do j = jlo, jhi
            yy(j,p) = yy(j,p-1)*y
            y = y + hy
         end do
         z = zlo + klo*hz - c
         do k = klo, khi
            zz(k,p) = zz(k,p-1)*z
            z = z + hz
         end do
      end do
c     
c     Try to get good pipelining and cache utilization by vectorizing
c     down the x direction of the grid in the inner loop.  By
c     evaluating over the cube rather than the sphere we do about
c     2x as many evaluations, but they are much more efficient.
c     
      if (ijtype .eq. 0) then
         do k = klo, khi
            sk = prefac*ndens(1)*zz(k,0)
            do j = jlo, jhi
               s = sk*yy(j,0)
               if (abs(s*xxmax) .gt. tol) then
                  do i = ilo, ihi
                     g(i,j,k) = g(i,j,k) + s*xx(i,0)
                  end do
               end if
            end do
         end do
      else
         do k = klo, khi
            ind = 0 
            do l = 0, ijtype
               do ii = l,0,-1
                  do jj = l-ii,0,-1
                     kk = l-ii-jj
                     ind = ind + 1
                     sk = prefac*ndens(ind)*zz(k,kk)
                     do j = jlo, jhi
                        s = sk*yy(j,jj)
                        if (abs(s*xxmax) .gt. tol) then
                           do i = ilo, ihi
                              g(i,j,k) = g(i,j,k) + s*xx(i,ii)
                           end do
                        end if
                     end do
                  end do
               end do
            end do
         end do
      end if                    ! if (ijtype)
c     
      end
      subroutine fastj_tidy(data)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
      integer data(2)
c
      double precision xlo,xhi,ylo,yhi,zlo,zhi,eps,hx,hy,hz
      integer k_grid, depth,lmax,nx,ny,nz, l_grid, tree(300)
      integer l_list,k_list,l_pairs2,k_pairs2,
     $     npairs,g_dens,basis
c
      call fastj_unpack_data(data,xlo,xhi,ylo,yhi,zlo,zhi,
     $     hx,hy,hz,k_grid,l_grid,tree,
     $     depth,lmax,nx,ny,nz,eps,l_list,k_list,l_pairs2,k_pairs2,
     $     npairs,g_dens,basis)
c
      if (.not. ma_free_heap(l_grid)) call errquit
     $     ('fastj_tidy: ma?',-1, MA_ERR)
      if (.not. ma_free_heap(l_list)) call errquit
     $     ('fastj_tidy: ma?',-1, MA_ERR)
      if (.not. ma_free_heap(l_pairs2)) call errquit
     $     ('fastj_tidy: ma?',-1, MA_ERR)
      if (.not. ma_free_heap(data(1))) call errquit
     $     ('fastj_tidy: ma?',1, MA_ERR)
      if (.not. ma_free_heap(data(2))) call errquit
     $     ('fastj_tidy: ma?',2, MA_ERR)
c
      call fmm_tree_destroy(tree)
c
      end
      subroutine fastj_optimize_n(n, mode)
      implicit none
      integer n
      character*(*) mode
c
c     Find a number of the form 2^i 3^j 5^k 7^l - 1 that is close to n.
c     Optionally force it to be an upperbound.
c
c     For ESSL need to impose additional constraints.
c
      integer n2, n3, n5, n7, ii2, ii3, ii5, ii7, i2, i3, i5, i7
      double precision test, diff
c
      n = n + 1                 ! Temporarily to force to power of radix
c
      n2 = log(dble(n))/log(2.0d0) + 1
      n3 = log(dble(n))/log(3.0d0) + 1
      n5 = log(dble(n))/log(5.0d0) + 1
      n7 = log(dble(n))/log(7.0d0) + 1
#ifdef ESSL
      n3 = min(2,n3)
      n5 = min(1,n5)
      n7 = min(1,n7)
#else
      n7 = 0
#endif
      ii2 = 0
      ii3 = 0
      ii5 = 0
      ii7 = 0
      diff = n
      do i2 = 0, n2
         do i3 = 0, n3
            do i5 = 0, n5
               do i7 = 0, n7
                  test = (2d0**i2)*(3d0**i3)*(5d0**i5)*(7d0**i7) + 1d-6
                  if (test.ge.n .or. mode.ne.'upperbound') then
                     if (abs(test-n) .lt. diff) then
                        diff = abs(test - n)
                        ii2 = i2
                        ii3 = i3
                        ii5 = i5
                        ii7 = i7
                     end if
                  end if
               end do
            end do
         end do
      end do
c
      n = (2d0**ii2)*(3d0**ii3)*(5d0**ii5)*(7d0**ii7)  - 1
c
      end
c$$$      double precision function fastj_eval_point(data,x,y,z)
c$$$      implicit none
c$$$#include "mafdecls.fh"
c$$$c
c$$$      double precision x, y, z
c$$$      integer data(2)
c$$$c
c$$$c     Evaluate the potential at a point ... not as efficient
c$$$c     as doing multiple points
c$$$c
c$$$      integer k_grid, lmax, depth, nx, ny, nz, l_grid
c$$$      double precision xlo, xhi, ylo, yhi, zlo, zhi, hx, hy, hz, eps
c$$$      double precision potgrid, potfmm, hfmm
c$$$      integer order, ninterp
c$$$      double precision tn_interp_3d_point, fmm_potential
c$$$      integer tree(300)
c$$$c
c$$$c     Get the data
c$$$c
c$$$      call fastj_unpack_data(
c$$$     $     data,
c$$$     $     xlo,xhi,ylo,yhi,zlo,zhi,
c$$$     $     hx, hy, hz,
c$$$     $     k_grid, l_grid, tree,
c$$$     $     depth,lmax,nx,ny,nz,eps)
c$$$c
c$$$      hfmm = (xhi - xlo)/2.0d0**depth
c$$$      if ( x.lt.(xlo+hfmm) .or. x.gt.(xhi-hfmm) .or.
c$$$     $     y.lt.(ylo+hfmm) .or. y.gt.(yhi-hfmm) .or.
c$$$     $     z.lt.(zlo+hfmm) .or. z.gt.(zhi-hfmm) ) then
c$$$         fastj_eval_point = 0.0d0
c$$$         return
c$$$      end if
c$$$c
c$$$*      write(6,*) ' xlo,xhi,ylo,yhi,zlo,zhi ',xlo,xhi,ylo,yhi,zlo,zhi
c$$$*      write(6,*) ' hx, hy, hz ', hx, hy, hz
c$$$*      write(6,*) ' k_grid, k_poles,depth,lmax,nx,ny,nz,eps ',
c$$$*     $     k_grid, k_poles,depth,lmax,nx,ny,nz,eps
c$$$c
c$$$      if (eps.ge.1d-6) then
c$$$         order = 17
c$$$      else if (eps.ge.1d-8) then
c$$$         order = 25
c$$$      else
c$$$         order = 33
c$$$      end if
c$$$      ninterp = order + 1 + 2
c$$$c
c$$$      potgrid = tn_interp_3d_point(dbl_mb(k_grid),nx,ny,nz,hx,hy,hz,
c$$$     $     x-xlo,y-ylo, z-zlo,ninterp,order)
c$$$c
c$$$      potfmm = fmm_potential(depth,lmax,tree,
c$$$     $     xhi-xlo,yhi-ylo,zhi-zlo,x-xlo,y-ylo,z-zlo)
c$$$c
c$$$**      write(6,*) ' potgrid, potfmm ', potgrid, potfmm
c$$$c
c$$$      fastj_eval_point = -(potgrid + potfmm)
c$$$c      
c$$$      end
      subroutine fastj_eval_list_from_data(data, n, coords, v)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "util.fh"
c
      integer n
      double precision coords(3,n), v(n)
      integer data(2)
c
c     Evaluate the potential at a list of points within the volume
c
      integer k_grid, lmax, depth, nx, ny, nz, l_grid
      double precision xlo, xhi, ylo, yhi, zlo, zhi, hx, hy, hz, eps
      integer order, ninterp, twol
      integer tree(300)
      integer l_list, k_list, l_pairs2, k_pairs2, npairs, g_dens, basis
      double precision tn_interp_3d_point
*      double precision fmm_potential
c
      integer k_map, l_map, k_list_info, l_list_info, k_next, l_next,
     $     k_coords_r, kx, ky, kz, ptr, numr, k_v_r, l_v_r,
     $     ish, jsh, l_coords_r, ind, level, k_near, l_near,
     $     k_v_near, l_v_near, jj, k_xyz, iijj, iprim, jprim
      integer kxp, kyp, kzp, luse, levelp
      integer lq
      parameter (lq = FMM_LMAX)
      double precision q(-lq:lq,0:lq)
      double precision hxp, hyp, hzp, xo, yo, zo, rtwol
      double precision x, y, z, potfmm, potgrid, fact
      logical present(31*31)    ! Max. prim. sq
c
      integer sh_info(4,2047)   ! 1=type; 2=nprim; 3=ngen; 4=osph
      integer sh_bfr(2,2047)    ! 1=lo; 2=hi
      integer ishprev, jshprev, nprimj, nprimi, numi, numj, i, j
      
      integer level_do_grid
c
      integer l_fit, k_fit
c
      integer lmax2, lencart, lenprod
      parameter (lmax2 = 2*5)   ! Twice max angular momentum - h functions
      parameter (lencart = ((lmax2+1)*(lmax2+2))/2)
      parameter (lenprod = ((lmax2+1)*(lmax2+2)*(lmax2+3))/6)
c
      double precision start, used, tfar, tgrid
      integer ilo, ihi, jlo, jhi, klo, khi
      double precision vol_xlo, vol_ylo, vol_zlo ! Volume for interp
      integer k_gtmp, l_gtmp, ngrid_per_box, ngx, ngy, ngz,
     $     ngrid_per_vol, nborder, maxorder, minorder,
     $     max_ngrid_per_vol, stride, ind_save
      double precision hfmm, potgrid1, xlm_local_potential
c
      double precision 
     $     d(lencart,-lmax2:lmax2,0:lmax2),
     $     dinv(lenprod, -lmax2:lmax2,0:lmax2),
     $     dens(lencart**2)

      double precision obin(0:34), tbin(0:34)

      integer numfit
#include "bitops.fh"
      numfit(i) = (2*i+9)*(i+2)*(i+1)/6 ! Sum of (n+1)*(n+3) n=0..i

      call xlm_init()
      call anl_fit_init()
      call xlm_coeff_inv(lmax2,d,dinv)
      call dfill(35,0.0d0,obin,1)
      call dfill(35,0.0d0,tbin,1)
c
      ngx = 1         ! get rid of compiler warnings
      ngy = 1
      ngz = 1
c
c     Get the data
c
      call fastj_unpack_data(
     $     data,
     $     xlo,xhi,ylo,yhi,zlo,zhi,
     $     hx, hy, hz,
     $     k_grid, l_grid, tree,
     $     depth,lmax,nx,ny,nz,eps,l_list,k_list,l_pairs2,k_pairs2,
     $     npairs, g_dens, basis)
c
      write(6,*) ' Unpacking'
      write(6,*) ' xlo,xhi,ylo,yhi,zlo,zhi ',xlo,xhi,ylo,yhi,zlo,zhi
      write(6,*) ' hx, hy, hz ', hx, hy, hz
      write(6,*) ' k_grid, depth,lmax,nx,ny,nz,eps ',
     $     k_grid, depth,lmax,nx,ny,nz,eps
      write(6,*) ' l_list, k_list, l_pairs2, k_pairs2, npairs ',
     $     l_list, k_list, l_pairs2, k_pairs2, npairs
      write(6,*) ' g_dens ', g_dens
      call fmm_tree_summarize(tree)
c

      level_do_grid = min(4,depth)
      if (nx .eq. 0) level_do_grid = 999

      if (eps .ge. 1d-4) then
         minorder = 3           ! Actually will use 5.
         maxorder = 7
         nborder = 3
         stride = 2
      else if (eps .ge. 1d-6) then
         minorder = 3           ! Actually will use 5.
         maxorder = 15
         nborder = 3
         stride = 2
      else if (eps .ge. 1d-8) then
         minorder = 3           ! Actually will use 7
         maxorder = 23          ! was 23
         nborder = 5
         stride = 4
      else
         minorder = 11           ! Actually will use 11
         maxorder = 27          
         nborder = 5             ! ?
         stride = 4
      endif
c
      call dfill(n, 0.0d0, v, 1)
c
      call bas_all_cn_info(basis, sh_info, sh_bfr)
c
      if (.not. ma_push_get(mt_int, n, 'map', l_map, k_map))
     $     call errquit('fj: map ', n, MA_ERR)
      if (.not. ma_push_get(mt_int,2*8**depth,'info',l
     $     _list_info,k_list_info)) call errquit('fj: info ',2*8**depth,
     &       GA_ERR)
      if (.not. ma_push_get(mt_int, n, 'next', l_next, k_next))
     $     call errquit('fj: next ', n, MA_ERR)
      if (.not. ma_push_get(mt_dbl, 3*n, 'near', l_near, k_near))
     $     call errquit('fj: near ', 3*n, MA_ERR)
      if (.not. ma_push_get(mt_dbl, n, 'v_near', l_v_near, k_v_near))
     $     call errquit('fj: v_near', n, MA_ERR)
      if (.not. ma_push_get(mt_dbl, 3*n, 'cr', l_coords_r, k_coords_r))
     $     call errquit('fj: coords_r ', 3*n, MA_ERR)
      if (.not. ma_push_get(mt_dbl, n, 'vr', l_v_r, k_v_r))
     $     call errquit('fj: vr ', n, MA_ERR)
      if (.not. ma_push_get(mt_dbl, numfit(maxorder), 
     $     'fit', l_fit, k_fit))
     $     call errquit('fj: fit ',numfit(maxorder), MA_ERR)
c
      do i = minorder, maxorder
         if (i .le. 9) then
            call tn_fitting_matrix(i,i+1,dbl_mb(k_fit+numfit(i-1)))
         else
            call tn_fitting_matrix(i,i+3,dbl_mb(k_fit+numfit(i-1)))
         endif
      enddo
c
      hfmm = (xhi-xlo)/2.0d0**level_do_grid ! Assumes cubic box
      ngrid_per_box = hfmm/hx  + 1
      ninterp = maxorder + 1 + 2 ! Dynamically reset below
      if (ngrid_per_box .lt. ninterp) 
     $     nborder = nborder + (ninterp-ngrid_per_box-1)/2 + 1
      max_ngrid_per_vol = ngrid_per_box + 2*nborder
      if (mod(max_ngrid_per_vol,2).eq.0) 
     $     max_ngrid_per_vol = max_ngrid_per_vol + 1
      write(6,*) ' max_ngrid_per_vol ', max_ngrid_per_vol
c      
      if (.not. ma_push_get(mt_dbl, (max_ngrid_per_vol)**3, 
     $     'gtmp', l_gtmp, k_gtmp)) call errquit('fj: gtmp ', 
     $     max_ngrid_per_vol**3, MA_ERR)
c
c     Pairs may have been assigned to the top few levels of the
c     octree if they span all/most of the domain.  Also, ind
c     is being accumulated so must start from the finest
c
      ind = 0
      do level = depth, 0, -1
         ind_save = ind
         start = util_cpusec()

         twol = 2**level

         call fmm_points_to_boxes(level, n, coords,
     $        xlo, xhi, ylo, yhi, zlo, zhi,
     $        int_mb(k_next), int_mb(k_list_info), 
     $        dbl_mb(k_coords_r), int_mb(k_map))
         call dfill(n, 0.0d0, dbl_mb(k_v_r), 1)

         do kz = 0, twol-1
            do ky = 0, twol-1
               do kx = 0, twol-1
c
                  ptr = int_mb(k_list+ind) ! Head of shell pair linked list
c
                  if (ptr .gt. 0) then 
                     call fmm_make_list_of_near_points(
     $                    level, kx, ky, kz,
     $                    n, dbl_mb(k_coords_r), int_mb(k_list_info),
     $                    dbl_mb(k_near), numr)
                  else
                     numr = 0
                  endif
c
                  if (numr .gt. 0) then
*                     write(6,*) level, kx, ky, kz, ind+1, numr
                     call dfill(numr, 0.0d0, dbl_mb(k_v_near), 1)
c
c     Traverse the linked list of primtive shell pairs for this box/level
c     and evaluate the near field potentials.
c     Also bundle back into contracted shell as an optimization.
c     Note that some pairs of primtives may be missing so must
c     form a mask to see if pairs are present or not.
c
c
                     ishprev = -1
                     jshprev = -1
 10                  if (ptr .gt. 0) then
                        ptr = (ptr - 1)*2
                        iijj = int_mb(k_pairs2+ptr  )
                        ptr  = int_mb(k_pairs2+ptr+1)
c
                        ish  = iand(rshift(iijj,21),2047)
                        iprim= iand(rshift(iijj,16),31)
                        jsh  = iand(rshift(iijj,5),2047)
                        jprim= iand(iijj,31)
                        if (ish.ne.ishprev .or. jsh.ne.jshprev) then
                           if (ishprev .ne. -1) then
c     EVALUATE HERE using ishprev and jshprev
*                              write(6,*) '   Evaluating1 ',
*     $                             ishprev,jshprev, nprimi, nprimj

                              call ga_get(g_dens, 
     $                             sh_bfr(1,ishprev), sh_bfr(2,ishprev),
     $                             sh_bfr(1,jshprev), sh_bfr(2,jshprev),
     $                             dens, numi)

                              fact = 1.0d0
                              if (ishprev.ne.jshprev) fact = 2.0d0

                              call potential_from_shell_pair(
     $                             basis, ishprev, jshprev,
     $                             dens, numi, eps*1d-1, d, dinv, lmax2,
     $                             numr, 
     $                             dbl_mb(k_near), dbl_mb(k_v_near),
     $                             fact, .true., present, nprimi)
     $                             
                           endif
                           ishprev = ish
                           jshprev = jsh
                           nprimi = sh_info(2,ish)
                           nprimj = sh_info(2,jsh)
                           numi = sh_bfr(2,ish) - sh_bfr(1,ish) + 1
                           numj = sh_bfr(2,jsh) - sh_bfr(1,jsh) + 1
                           do i = 1, nprimi*nprimj
                              present(i) = .false.
                           enddo
                        endif
c
*                        write(6,*)  '     ', ish, iprim, jsh, jprim
                        present(iprim + (jprim-1)*nprimi) = .true.
                        goto 10
                     endif
                     if (ishprev .ne. -1) then
c     EVALUATE HERE using ishprev and jshprev
*                        write(6,*) '   Evaluating2 ',
*     $                       ishprev,jshprev, nprimi, nprimj
                        call ga_get(g_dens, 
     $                       sh_bfr(1,ishprev), sh_bfr(2,ishprev),
     $                       sh_bfr(1,jshprev), sh_bfr(2,jshprev),
     $                       dens, numi)
                        
                        fact = 1.0d0
                        if (ishprev.ne.jshprev) fact = 2.0d0
                        
                        call potential_from_shell_pair(
     $                       basis, ishprev, jshprev,
     $                       dens, numi, eps*1d-1, d, dinv, lmax2,
     $                       numr, 
     $                       dbl_mb(k_near), dbl_mb(k_v_near),
     $                       fact, .true., present, nprimi)
     $                       
                     endif
                     call fmm_add_values_from_near_points(
     $                    level, kx, ky, kz,
     $                    n, dbl_mb(k_v_r), int_mb(k_list_info),
     $                    dbl_mb(k_v_near), numr)
c     add the potential from the near field into reordered points
                  endif
                  ind = ind + 1
               enddo
            enddo
         enddo
c
c     Do the grid
c
         tgrid = 0.0d0
         if (level.eq.level_do_grid .and. nx.gt.0) then
            tgrid = util_cpusec()
            ind = ind_save
            do kz = 0, twol-1
               do ky = 0, twol-1
                  do kx = 0, twol-1
                     k_xyz = k_list_info + 2*(kx + twol*(ky + twol*kz))
c
c     Gather a cube of points with nborder points on either side
c     in order to improve memory locality.  
c
c     Tried examining necessary precision at box center but it did
c     not work ... now examine each point.
c
                     if (int_mb(k_xyz) .le. int_mb(k_xyz+1)) then
c
                        ngrid_per_vol = max_ngrid_per_vol
c     
                        x = xlo + dble(kx)*hfmm ! Coords of box corner
                        y = ylo + dble(ky)*hfmm
                        z = zlo + dble(kz)*hfmm
                        ilo = max(1, int((x-xlo)/hx)-nborder)
                        ilo = min(ilo,nx-ngrid_per_vol+1)
                        ilo = max(1,ilo)
                        jlo = max(1, int((y-ylo)/hy)-nborder)
                        jlo = min(jlo,ny-ngrid_per_vol+1)
                        jlo = max(1,jlo)
                        klo = max(1, int((z-zlo)/hz)-nborder)
                        klo = min(klo,nz-ngrid_per_vol+1)
                        klo = max(1,klo)
                        ihi = min(nx, ilo+ngrid_per_vol-1)
                        jhi = min(ny, jlo+ngrid_per_vol-1)
                        khi = min(nz, klo+ngrid_per_vol-1)
                        
                        vol_xlo = xlo + (ilo-1)*hx
                        vol_ylo = ylo + (jlo-1)*hy
                        vol_zlo = zlo + (klo-1)*hz
                        
                        ngx = (ihi - ilo + 1)
                        ngy = (jhi - jlo + 1)
                        ngz = (khi - klo + 1)
                        
c$$$                        call fastj_copy3d(nx,ny,nz,
c$$$     $                       ilo,ihi,jlo,jhi,klo,khi,
c$$$     $                       dbl_mb(k_grid), dbl_mb(k_gtmp))

c$$$                        ijk = k_gtmp - ilo
c$$$                        do k = klo, khi
c$$$                           do j = jlo, jhi
c$$$                              jkgrid = k_grid-1 + nx*(j-1 + ny*(k-1))
c$$$                              do i = ilo, ihi
c$$$                                 dbl_mb(i + ijk) = dbl_mb(i + jkgrid)
c$$$                              enddo
c$$$                              ijk = ijk + (ihi - ilo + 1)
c$$$                           enddo
c$$$                        enddo
                     endif
c
                     do j = int_mb(k_xyz), int_mb(k_xyz+1)
                        jj = k_coords_r + (j-1)*3
c
                        x = dbl_mb(jj  )
                        y = dbl_mb(jj+1)
                        z = dbl_mb(jj+2)

                        order = minorder
                        if (order .le. 9) then
                           ninterp = order + 1
                        else
                           ninterp = order + 3
                        endif
                        if (ninterp.gt.ngx .or.
     $                       ninterp.gt.ngy .or. ninterp.gt.ngz)
     $                       call errquit('aajsflk ',
     $                       ninterp + 100*(ngx+100*(ngy+100*ngz)),
     &       UNKNOWN_ERR)
c$$$                        potgrid1 = tn_interp_3d_point(
c$$$     $                       dbl_mb(k_gtmp), ngx, ngy, ngz, hx, hy, hz,
c$$$     $                       x-vol_xlo, y-vol_ylo, z-vol_zlo, 
c$$$     $                       ninterp, order, 
c$$$     $                          dbl_mb(k_fit+numfit(order-1)))
                        potgrid1 = tn_interp_3d_point(
     $                       dbl_mb(k_grid), nx, ny, nz, hx, hy, hz,
     $                       x-xlo, y-ylo, z-zlo, 
     $                       ninterp, order, 
     $                          dbl_mb(k_fit+numfit(order-1)))
                        do order = minorder+stride,maxorder, stride
                           if (order .le. 9) then
                              ninterp = order + 1
                           else
                              ninterp = order + 3
                           endif
                           if (ninterp.gt.ngx .or.
     $                          ninterp.gt.ngy .or. ninterp.gt.ngz)
     $                          call errquit('aajsflk ',
     $                          ninterp + 100*(ngx+100*(ngy+100*ngz)),
     &       UNKNOWN_ERR)
c$$$                           potgrid = tn_interp_3d_point(
c$$$     $                          dbl_mb(k_gtmp), ngx, ngy, ngz,hx, hy,hz,
c$$$     $                          x-vol_xlo, y-vol_ylo, z-vol_zlo, 
c$$$     $                          ninterp, order,
c$$$     $                          dbl_mb(k_fit+numfit(order-1)))
                        potgrid = tn_interp_3d_point(
     $                       dbl_mb(k_grid), nx, ny, nz, hx, hy, hz,
     $                       x-xlo, y-ylo, z-zlo, 
     $                       ninterp, order, 
     $                          dbl_mb(k_fit+numfit(order-1)))

                           if (abs(potgrid-potgrid1).lt.0.1d0*eps) 
     $                          goto 31
                           potgrid1 = potgrid
                        enddo
*                        write(6,*) ' Used maxorder ', x, y, z, potgrid
                        order = order - stride
 31                     continue
                        obin(order) = obin(order) + 1
                        tbin(order) = tbin(order) + 2*(ninterp)**3 +
     $                       3*order + 22 + ninterp*(order+1)*2
*                        potgrid = tn_interp_3d_point(
*     $                       dbl_mb(k_grid), nx, ny, nz, hx, hy, hz,
*     $                       x-xlo, y-ylo, z-zlo, ninterp, order)
c
                        dbl_mb(k_v_r+j-1) = dbl_mb(k_v_r+j-1) - potgrid
                     enddo
                  ind = ind + 1
                  enddo
               enddo
            enddo
            tgrid = util_cpusec() - tgrid
         endif
c
         tfar = 0.0d0
         if (level .eq. depth) then
c     
c     Evaluate the potential from the far field
c
            tfar = util_cpusec()
            ind = 0
            do kz = 0, twol-1
               do ky = 0, twol-1
                  do kx = 0, twol-1
                     k_xyz = k_list_info + 2*(kx + twol*(ky + twol*kz))
                     if (int_mb(k_xyz) .le. int_mb(k_xyz+1)) then
c     
c     Walk up tree until find cell with local potential
c     
                        kxp = kx
                        kyp = ky
                        kzp = kz
                        rtwol = 1.0d0 / twol
                        do levelp = level, 2, -1
                           call fmm_tree_get_cell(tree, levelp, 
     $                          kxp, kyp, kzp, q, lq, luse)
                           if (luse .ge. 0) goto 666
                           kxp = kxp / 2
                           kyp = kyp / 2
                           kzp = kzp / 2
                           rtwol = rtwol + rtwol
                        enddo
 666                    continue
                        if (luse .ge. 0) then
                           hxp = (xhi-xlo)*rtwol
                           hyp = (yhi-ylo)*rtwol
                           hzp = (zhi-zlo)*rtwol
                           xo  = (dble(kxp)+0.5d0)*hxp + xlo ! Coords of box center
                           yo  = (dble(kyp)+0.5d0)*hyp + ylo
                           zo  = (dble(kzp)+0.5d0)*hzp + zlo
c     
                           do j = int_mb(k_xyz), int_mb(k_xyz+1)
                              jj = k_coords_r + (j-1)*3
                              x = dbl_mb(jj  )
                              y = dbl_mb(jj+1)
                              z = dbl_mb(jj+2)
*                              potfmm = fmm_potential(
*     $                             depth,lmax,tree,
*     $                             xhi-xlo, yhi-ylo, zhi-zlo,
*     $                             x-xlo, y-ylo, z-zlo)
                              
                              potfmm = xlm_local_potential(
     $                             x-xo,y-yo,z-zo,
     $                             q,lq,luse)

                              dbl_mb(k_v_r+j-1) = dbl_mb(k_v_r+j-1) - 
     $                             potfmm
                           enddo
                        endif
                     endif
                     ind = ind + 1
                  enddo
               enddo
            enddo
            tfar = util_cpusec() - tfar
         endif
c
c     Add the potential from this level back into the output order
c
         do j = 0,n-1
*            write(6,*) ' mapping ', j, int_mb(k_map+j), 
*     $           v(int_mb(k_map+j)), dbl_mb(k_v_r+j)
            v(int_mb(k_map+j)) = v(int_mb(k_map+j)) + dbl_mb(k_v_r+j)
         enddo
c
         used = util_cpusec() - start
         write(6,781) level, used, tfar, tgrid
 781     format(' Level ', i2,': used=', f8.2, '  far=',f8.2,
     $        '  grid=',f8.2)
      enddo                     ! level
c
      write(6,*) ' obin '
      call doutput(obin,1,34,1,1,34,1,1)
      write(6,*) ' tbin '
      call doutput(tbin,1,34,1,1,34,1,1)
c
      if (.not. ma_chop_stack(l_map)) call errquit('sigh',0, MA_ERR)
c
      end
      subroutine fastj_unpack_data(data,xlo,xhi,ylo,yhi,zlo,zhi,
     $     hx,hy,hz,k_grid,l_grid,tree,
     $     depth,lmax,nx,ny,nz,eps,l_list,k_list,l_pairs2,k_pairs2,
     $     npairs,g_dens,basis)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
c
      integer data(2)
      double precision xlo,xhi,ylo,yhi,zlo,zhi,eps,hx,hy,hz
      integer k_grid,depth,lmax,nx,ny,nz,k_r,k_i,l_grid
      integer l_list,k_list,l_pairs2,k_pairs2, npairs, g_dens, basis
      integer tree(300)
c
***      write(6,*) ' UNPACKED handles ', data(1), data(2)
      if (.not. ma_get_index(data(1),k_r))
     $     call errquit('fastj_unpack: invalid data',1, MA_ERR)
      if (.not. ma_get_index(data(2),k_i))
     $     call errquit('fastj_pack: invalid data',2, MA_ERR)
c
      xlo     =  dbl_mb(k_r   )
      xhi     =  dbl_mb(k_r+ 1)
      ylo     =  dbl_mb(k_r+ 2)
      yhi     =  dbl_mb(k_r+ 3)
      zlo     =  dbl_mb(k_r+ 4)
      zhi     =  dbl_mb(k_r+ 5)
      eps     =  dbl_mb(k_r+ 6)
      hx      =  dbl_mb(k_r+ 7)
      hy      =  dbl_mb(k_r+ 8)
      hz      =  dbl_mb(k_r+ 9)
                               
      k_grid  =  int_mb(k_i   )
      l_grid  =  int_mb(k_i+ 1)
*      k_poles =  int_mb(k_i+ 2)
*      l_poles =  int_mb(k_i+ 3)
      depth   =  int_mb(k_i+ 4)
      lmax    =  int_mb(k_i+ 5)
      nx      =  int_mb(k_i+ 6)
      ny      =  int_mb(k_i+ 7)
      nz      =  int_mb(k_i+ 8)
      l_list  =  int_mb(k_i+ 9)
      k_list  =  int_mb(k_i+10)
      l_pairs2=  int_mb(k_i+11)
      k_pairs2=  int_mb(k_i+12)
      npairs  =  int_mb(k_i+13)
      g_dens  =  int_mb(k_i+14)
      basis   =  int_mb(k_i+15)
      call icopy(300, int_mb(k_i+16), 1, tree, 1)
c
      end
      subroutine fastj_pack_data(data,xlo,xhi,ylo,yhi,zlo,zhi,
     $     hx, hy, hz, k_grid, l_grid, tree,
     $     depth,lmax,nx,ny,nz,eps,l_list,k_list,l_pairs2,k_pairs2,
     $     npairs, g_dens,basis)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
c
      integer data(2)
      double precision xlo,xhi,ylo,yhi,zlo,zhi,eps,hx,hy,hz
      integer k_grid, depth,lmax,nx,ny,nz, l_grid
      integer l_list,k_list,l_pairs2,k_pairs2, npairs, g_dens, basis
      integer tree(300)
c
      integer l_r, k_r, l_i, k_i
c
      if (.not. ma_alloc_get(mt_dbl,10, 'fastjr', l_r, k_r))
     $     call errquit('fastj_pack: unable to alloc data',1, MA_ERR)
      if (.not. ma_alloc_get(mt_int,300+16, 'fastji', l_i, k_i))
     $     call errquit('fastj_pack: unable to alloc data',2, MA_ERR)
c
      data(1) = l_r
      data(2) = l_i
c
      dbl_mb(k_r   ) = xlo
      dbl_mb(k_r+ 1) = xhi
      dbl_mb(k_r+ 2) = ylo
      dbl_mb(k_r+ 3) = yhi
      dbl_mb(k_r+ 4) = zlo
      dbl_mb(k_r+ 5) = zhi
      dbl_mb(k_r+ 6) = eps
      dbl_mb(k_r+ 7) = hx
      dbl_mb(k_r+ 8) = hy
      dbl_mb(k_r+ 9) = hz

      int_mb(k_i   ) = k_grid
      int_mb(k_i+ 1) = l_grid
*      int_mb(k_i+ 2) = k_poles
*      int_mb(k_i+ 3) = l_poles
      int_mb(k_i+ 4) = depth
      int_mb(k_i+ 5) = lmax
      int_mb(k_i+ 6) = nx
      int_mb(k_i+ 7) = ny
      int_mb(k_i+ 8) = nz
      int_mb(k_i+ 9) = l_list
      int_mb(k_i+10) = k_list
      int_mb(k_i+11) = l_pairs2
      int_mb(k_i+12) = k_pairs2
      int_mb(k_i+13) = npairs
      int_mb(k_i+14) = g_dens
      int_mb(k_i+15) = basis
      call icopy(300, tree, 1, int_mb(k_i+16), 1)
c
      end
      subroutine pot_prim_shell_pair_multipoles(
     $     dens,
     $     itype, ri, numi,
     $     jtype, rj, numj,
     $     dinv, lmaxd,
     $     a, b, c, alpha, prefac,
     $     mpoles, maxl)
      implicit none
#include "errquit.fh"
c
c     Given a block of the density matrix over a pair of CARTESIAN
c     PRIMITIVE shells and a detailed description of those shells
c     compute the multipole moments about the given coords (a,b,c)
c     which MUST be the GPT center.
c
c     .   mpoles() = multipole moments about center WITHOUT field terms
c
c     If radius is returned as 0.0d0 then the is no significant overlap
c     between the shells and the entire pair may be neglected.
c     
c     If spherical basis functions are used, the density matrix block
c     must first be transformed using dens_cart_to_sph().
c
c     Input shell parameters (numi/j = dimension of cartesian shells)
c
      integer itype, numi
      integer jtype, numj
      double precision ri(3)
      double precision rj(3)
c
      double precision dens(numi,numj) ! Cartesian density block
      integer lmaxd
      double precision dinv(*)  ! [input] dinv from xlm_coeff_inv
      integer maxl
      double precision mpoles(-maxl:maxl,0:maxl) ! [output] mpoles about center
      double precision a, b, c, alpha, prefac ! [input]
c
c     Local variables
c
      integer lmax, lmax2, lenprod
      parameter (lmax = 5)      ! Max. angular momentum of shell
      parameter (lmax2 = 2*lmax)
      parameter (lenprod = ((lmax+1)*(lmax+2)*(lmax+3))/6)
      double precision df(lmax2+1)
      double precision work(lenprod**2), ndens(lenprod**2) 
      double precision qn(-lmax2:lmax2,0:lmax2) ! [scratch]
c
      integer ijtype
      integer i, l, m, n, nlm
      double precision factor, pi, rootpi, scale
      double precision radial
c
c     Externals
c
      double precision double_factorial, fastj_gaussian_range
      external double_factorial, fastj_gaussian_range
c
c     Sanity checks
c
      if (itype.gt.lmax .or. jtype.gt.lmax) call errquit
     $     ('pot_shell_pair_multipole: lmax?',itype*1000+jtype,
     &       UNKNOWN_ERR)
c     
      ijtype = itype + jtype
      pi = 4.0d0*atan(1.0d0)
      rootpi = sqrt(pi)
      do i = 1, 2*ijtype + 1
         df(i) = double_factorial(i)
      end do
c
c     Compute the multipoles about the natrual center
c
      call xlm_norm(ijtype, qn, lmax2)
      do l = 0, ijtype
         do m = -l,l
            qn(m,l) = 1.0d0/(qn(m,l)*qn(m,l))
         end do
      end do
c
c     Translate density to product center and reform as spherical
c
      if (ijtype .eq. 0) then
         ndens(1) = dens(1,1)
      else
         call cart_dens_trans_prod_sph(
     $        itype, ri(1), ri(2), ri(3), 
     $        jtype, rj(1), rj(2), rj(3), 
     $        a, b, c, work, dinv, lmaxd, 
     $        dens, ndens)
      end if
c
c     Form multipoles at the GPT center (a,b,c) for this shell
c     
      do l = 0, maxl
         do m = -l, l
            mpoles(m,l) = 0.0d0
         end do
      end do
      nlm = 0
      scale = prefac*rootpi/(4.0d0*alpha*sqrt(alpha))
      do n = 0, ijtype
         radial = scale
         do l = n, 0, -2
            factor = radial*df(n+l+1)
            do m = -l, l
               nlm = nlm + 1
               mpoles(m,l) = mpoles(m,l) + ndens(nlm)*factor
            end do
            radial = radial * (2.0d0*alpha)
         end do
         scale = scale / (2.0d0*alpha)
      end do
      do l = 0, ijtype
         do m = -l, l
            mpoles(m,l) = mpoles(m,l)*qn(m,l)
         end do
      end do
c
      end

      subroutine dummy(a)
      end
      
      subroutine fastj_copy3d(nx,ny,nz,ilo,ihi,jlo,jhi,klo,khi,grid,tmp)
      implicit none
      integer nx,ny,nz,ilo,ihi,jlo,jhi,klo,khi
      double precision grid(nx,ny,nz),tmp(ilo:ihi,jlo:jhi,klo:khi)
c
c     Copy a sub-volume from the grid into a dense array
c
      integer i, j, k
      do k = klo, khi
         do j = jlo, jhi
            do i = ilo, ihi
               tmp(i,j,k) = grid(i,j,k)
            enddo
         enddo
      enddo
      end
      double precision function fastj_resolution(a,n,eps)
      implicit none
      double precision a
      double precision n
      double precision eps
c
c     Estimate the required resolution by examining the
c     decay of the fourier transform of a gaussian
c
      double precision t0
      double precision t1
      double precision pi
      parameter (pi = 3.141593d0)
      double precision double_factorial
      external double_factorial
c
      t0 = sqrt(log(2d0*a/(pi*eps**4)))
      t1 = sqrt(t0**2-2d0*n*log(a)-
     $     2d0*log(double_factorial(n))+
     $     2d0*(2d0*n-1d0)*log(sqrt(a)*t0))

c$$$      t0 = sqrt(log(2d0*a/pi/eps**4)-2d0*n*log(a)-
c$$$     $     2d0*log(double_factorial(n)))
c$$$      t1 = sqrt(t0**2+2d0*(2d0*n-1d0)*log(sqrt(a)*t0))

      fastj_resolution = sqrt(a)*t1 / pi

      return
      end
 

      SUBROUTINE ccsdtq_lr_alpha_16_8_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_16_8_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h9 p12 h14 p11 )_ytrb + = 1 * Sum ( h4 h5 p1 p2 ) * trb ( p1 p2 p12 h4 h5 h14 )_trb * y ( h4 h5 h9 p1 p2 p11 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p12b
      INTEGER h9b
      INTEGER h14b
      INTEGER p11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER p2b
      INTEGER h4b
      INTEGER h5b
      INTEGER p12b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h14b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h9b_2
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p11b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p12b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO h14b = 1,noab
      DO p11b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h9b-1)+int_mb(k_spin+p12b-
     &1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+p11b-1).ne.8)) THEN
      IF (int_mb(k_spin+h9b-1)+int_mb(k_spin+p12b-1) .eq. int_mb(k_spin+
     &h14b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h9b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_mb
     &(k_sym+h14b-1),int_mb(k_sym+p11b-1)))) .eq. ieor(irrep_y,irrep_trb
     &)) THEN
      dimc = int_mb(k_range+h9b-1) * int_mb(k_range+p12b-1) * int_mb(k_r
     &ange+h14b-1) * int_mb(k_range+p11b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_16_8_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      IF (int_mb(k_spin+p12b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &) .eq. int_mb(k_spin+h14b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+h5
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb
     &(k_sym+p2b-1),ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h4b-1),i
     &nt_mb(k_sym+h5b-1)))))) .eq. irrep_trb) THEN
      CALL TCE_RESTRICTED_6(p12b,p1b,p2b,h14b,h4b,h5b,p12b_1,p1b_1,p2b_1
     &,h14b_1,h4b_1,h5b_1)
      CALL TCE_RESTRICTED_6(h9b,h4b,h5b,p11b,p1b,p2b,h9b_2,h4b_2,h5b_2,p
     &11b_2,p1b_2,p2b_2)
      dim_common = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+h4b-1) * int_mb(k_range+h5b-1)
      dima_sort = int_mb(k_range+p12b-1) * int_mb(k_range+h14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h9b-1) * int_mb(k_range+p11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_16_8_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_16_8_1',2,MA_ERR)
      IF ((p2b .le. p12b) .and. (h5b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p12b_1 - n
     &oab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p12b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h14b-1),6,3,5,4,2,1,1.0d0)
      END IF
      IF ((p2b .le. p12b) .and. (h4b .le. h14b) .and. (h14b .lt. h5b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (h4b_1 - 1 + noab * (p12b_1 - n
     &oab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p12b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h5b-1),5,3,6,4,2,1,-1.0d0)
      END IF
      IF ((p2b .le. p12b) .and. (h14b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (h14b_1 - 1 + noab * (p12b_1 - n
     &oab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),4,3,6,5,2,1,1.0d0)
      END IF
      IF ((p1b .le. p12b) .and. (p12b .lt. p2b) .and. (h5b .le. h14b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - no
     &ab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+p2b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h14b-1),6,2,5,4,3,1,-1.0d0)
      END IF
      IF ((p1b .le. p12b) .and. (p12b .lt. p2b) .and. (h4b .le. h14b) .a
     &nd. (h14b .lt. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - no
     &ab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+p2b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h5b-1),5,2,6,4,3,1,1.0d0)
      END IF
      IF ((p1b .le. p12b) .and. (p12b .lt. p2b) .and. (h14b .lt. h4b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (h14b_1 - 1 + noab * (p2b_1 - no
     &ab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p1b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+p2b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),4,2,6,5,3,1,-1.0d0)
      END IF
      IF ((p12b .lt. p1b) .and. (h5b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - no
     &ab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h14b-1),6,1,5,4,3,2,1.0d0)
      END IF
      IF ((p12b .lt. p1b) .and. (h4b .le. h14b) .and. (h14b .lt. h5b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - no
     &ab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h5b-1),5,1,6,4,3,2,-1.0d0)
      END IF
      IF ((p12b .lt. p1b) .and. (h14b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (h14b_1 - 1 + noab * (p2b_1 - no
     &ab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),4,1,6,5,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_16_8_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_16_8_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_16_8_1',5,MA_ERR)
      IF ((h5b .le. h9b) .and. (p2b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h9b_2 - 1 + noab * (h5b_2 - 1 + noab * (h4b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p11b-1),6,3,2,1,5,4,1.0d0)
      END IF
      IF ((h5b .le. h9b) .and. (p1b .le. p11b) .and. (p11b .lt. p2b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h9b_2 - 1 + noab * (h5b_2 - 1 + noab * (h4b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p2b-1),5,3,2,1,6,4,-1.0d0)
      END IF
      IF ((h5b .le. h9b) .and. (p11b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (h9b_2 - 1 + noab * (h5b_2 - 1 + noab * (h4b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h9b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),4,3,2,1,6,5,1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h9b .lt. h5b) .and. (p2b .le. p11b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h5b_2 - 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h5b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p11b-1),6,2,3,1,5,4,-1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h9b .lt. h5b) .and. (p1b .le. p11b) .and
     &. (p11b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h5b_2 - 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h5b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p2b-1),5,2,3,1,6,4,1.0d0)
      END IF
      IF ((h4b .le. h9b) .and. (h9b .lt. h5b) .and. (p11b .lt. p1b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (h5b_2 - 1 + noab * (h9b_2 - 1 + noab * (h4b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+h5b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),4,2,3,1,6,5,-1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (p2b .le. p11b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p11b_
     &2 - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h5b_2 - 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p11b-1),6,1,3,2,5,4,1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (p1b .le. p11b) .and. (p11b .lt. p2b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p11b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h5b_2 - 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+p2b-1),5,1,3,2,6,4,-1.0d0)
      END IF
      IF ((h9b .lt. h4b) .and. (p11b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p11b_2 - noab - 1
     & + nvab * (h5b_2 - 1 + noab * (h4b_2 - 1 + noab * (h9b_2 - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),int_mb(k_range+p11b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),4,1,3,2,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_16_8_1',
     &6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p1b .eq. p2b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_16_
     &8_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_16_
     &8_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_16_8_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p11b-1
     &),int_mb(k_range+h9b-1),int_mb(k_range+h14b-1),int_mb(k_range+p12b
     &-1),2,4,3,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p11b 
     &- noab - 1 + nvab * (h14b - 1 + noab * (p12b - noab - 1 + nvab * (
     &h9b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_16_8_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_16_
     &8_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_prop_finish()
c
      implicit none
c
#include "argos_prop.fh"
#include "mafdecls.fh"
c
      if(ntype.eq.3.and.me.eq.0) then
      if(.not.ma_pop_stack(l_dfrm))
     + call md_abort('Failed to deallocate dfrm',me)
      if(.not.ma_pop_stack(l_dfr))
     + call md_abort('Failed to deallocate dfr',me)
      endif
c
      return
      end
c $Id: argos_prop_finish.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: paw_energy_kin_atom.F 19707 2010-10-29 17:59:36Z d3y133 $
*


!**************************************************
!
!       Name: paw_kin_atom_energy
!
!       Purpose: calculates atom portion of the kinetic energy
!
!       Created: Mon Feb 10 13:46:23 PST 2003       
!**************************************************
      function paw_energy_kin_atom()
      implicit none

#include "mafdecls.fh"
#include "paw_geom.fh"
#include "paw_ma.fh"
#include "paw_matrix_kin_data.fh"
#include "paw_basis.fh"
#include "paw_ovlp_data.fh"

      double precision  paw_energy_kin_atom
      integer in,ia
      integer i_w,i_mtr,i_mtr0
      integer i,j,li,lj,mi,mj
      integer nb
      double precision ekin

      ekin = 0.D0
      i_w = 0
      do in=1,ion_nion()
        ia = ion_katm(in)
        nb = paw_basis_nbasis(ia)
        i_mtr0 = int_mb(i_paw_kin_matrix(1) + ia - 1)
        ekin = ekin + paw_basis_core_kin_energy(ia)
        do i=1,nb
          li = paw_basis_orb_l(i,ia)
          do mi=-li,li
            do j=1,nb
              lj = paw_basis_orb_l(j,ia)
                do mj=-lj,lj
                i_mtr = i_mtr0 +i+(j-1)*nb
                if(mi.eq.mj) then
                  ekin = ekin + dcpl_mb(paw_ovlp_w(1)+i_w)*
     >                          dbl_mb(paw_kin_matrix(1) + i_mtr - 1) 
                end if
                i_w = i_w +1
                end do
             end do
           end do   
         end do
      end do
 
      paw_energy_kin_atom = ekin

      end

 

        subroutine tce_mrcc_macpy(k_a,k_b,size)
        implicit none
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_mrcc.fh"
#include "tce_main.fh"

      double precision k_a(*),k_b(*)
      integer size
      integer i,j

      do i=1,size 
        k_b(i) = k_a(i)
      enddo

      return
      end

c $Id: tce_mrcc_macpy.F 24345 2013-06-22 06:19:30Z d3y133 $

      SUBROUTINE md_scle(ntshel)

      implicit none

      integer i,ntshel

      if(ntshel.gt.0)then

       do i=1,4

        call com_motion()
        call scle_velo()
        call shll_qnch(ntshel)

       enddo

      else

       call com_motion()
       call scle_velo()

      endif

      return

      END
c $Id: md_scle.f 22502 2012-05-20 06:11:57Z d3y133 $

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c #define USE_SUMMA 1
#ifdef  USE_SUMMA
#  define GA_CREATE  ga_create2
#  define GA_DGEMM   ga_summa___
#else
#  define GA_CREATE  ga_create
#  define GA_DGEMM   ga_dgemm
#endif

#define BASE_NAME  'matrixA.da'
#define BASE_NAME1 'matrixB.da'
#define BASE_NAME2 'matrixC.da'
#ifdef  HPIODIR
#  define FNAME   HPIODIR//BASE_NAME
#  define FNAME1  HPIODIR//BASE_NAME1
#  define FNAME2  HPIODIR//BASE_NAME2
#else
#  define FNAME   BASE_NAME
#  define FNAME1  BASE_NAME1
#  define FNAME2  BASE_NAME2
#endif

      program test
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
      integer max_arrays
      integer status
      double precision max_sz, max_disk, max_mem
      data max_arrays, max_sz, max_disk, max_mem /4,1d8,1d10, 1d6/

#include "mp3.fh"
      if (.not. ma_init(MT_DBL, 800000, 800000))
     $     call ga_error('ma_init failed', 1)
      call ga_initialize()
      if(dra_init(max_arrays, max_sz, max_disk, max_mem).ne.0)
     $           call ga_error('dra_init failed: ',0)
c
      call testit()
c
      status = dra_terminate()
      call ga_terminate()
      call MP_FINALIZE()
      end


      subroutine testit()
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
#include "mp3def.fh"
c
      integer n, nrhs, nb
      integer g_temp
      integer d_a, d_b, d_c
      integer i, j, req
      integer nproc, me
c     
      parameter (n = 500)
      parameter (nrhs = n/2)
      parameter (nb = n/5)
c
      double precision temp(n), mbytes
      double precision tt0, tt1
      logical status
      integer util_mdtob
      external util_mdtob
c     ...................................................
c     
      nproc = ga_nnodes()
      me    = ga_nodeid()
c     
c***  Create global arrays
c
      if (.not. GA_CREATE(MT_DBL, n, n, 'temp', 1, 1, g_temp))
     $     call ga_error(' GA_CREATE failed: temp ',1)
c     
c***  creating disk arrays
c
      if (me.eq.0) print*, 'Creating Disk Array A:',n,' x',n
      if(dra_create(MT_DBL, n, n, 'A', 
     &    FNAME, 
     &    DRA_RW, nb, n, d_a).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
      if (me.eq.0) print*, 'Creating Disk Array B:',n,' x',n
      if(dra_create(MT_DBL, n, nrhs, 'B',
     &    FNAME1, 
     &    DRA_RW, n, nb, d_b).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
      if (me.eq.0) print*, 'Creating Disk Array C:',n,' x',n
      if(dra_create(MT_DBL, n, nrhs, 'C',
     &    FNAME2, 
     &    DRA_RW, nb, nb, d_c).ne.0)
     $   CALL ga_error('dra_create failed: ',0)
c
c*************************  Fill in arrays A & B  ************************
c
      do j = 1+me, n, nproc ! static load balancing
         do i = 1, n
            temp(i) = 1d0*(i +j)
         enddo
         call ga_put(g_temp, 1,n, j,j, temp,n)
      enddo
*     call ga_print(g_temp, 1)
      call ga_sync()
c
c...  writing to disk arrays 
c
      if(me.eq.0) print *, 'writing global array  to disk'
      if (me.eq.0)call ffflush(6)
      tt0 = MP_TIMER()
      if(dra_write(g_temp,d_a,req).ne.0)
     $   CALL ga_error('write failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      if(dra_close(d_a).ne.0)call ga_error('dra_close failed: ',d_a)
      tt1 = MP_TIMER() -tt0
      mbytes = 1e-6*util_mdtob(n*n)
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
c
c     Now, array B
c
      status =  ga_destroy(g_temp)
      if (.not. ga_create(MT_DBL, n, nrhs, 'temp', 1, 1, g_temp))
     $     call ga_error(' GA_CREATE failed: temp ',1)
c
      do j = 1+me, nrhs, nproc ! static load balancing
         do i = 1, n
            temp(i) = dble(j)
         enddo
         call ga_put(g_temp, 1,n, j,j, temp,n)
      enddo
*     call ga_print(g_temp, 1)
      call ga_sync()
c
c...  writing to disk arrays
c
      if(me.eq.0) print *, 'writing global array  to disk'
      if (me.eq.0)call ffflush(6)
      tt0 = MP_TIMER()
      if(dra_write(g_temp,d_b,req).ne.0)
     $   CALL ga_error('write failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      if(dra_close(d_b).ne.0)call ga_error('dra_close failed: ',d_b)
      tt1 = MP_TIMER() -tt0
      mbytes = 1e-6*util_mdtob(n*n)
      if (me.eq.0)then
          write(6,100)mbytes,tt1,mbytes/tt1
      endif
c
c**********************************************************************
c
c***  opening disk arrays
      if(dra_open(FNAME,DRA_R, d_a).ne.0)
     &            call ga_error('dra_open failed',0)
      if(dra_open(FNAME1,DRA_R, d_b).ne.0)
     &            call ga_error('dra_open failed',0)
c
      if (me .eq. 0) then
         print *,' '
         print *,' Checking out-of-core matrix multiplication'
         print *,' '
         call ffflush(6)
      endif
c
      call ga_sync()
      tt0 = MP_TIMER()
      call chunk_mxm(n, nrhs, nb, d_a, d_b, d_c)
      tt1 = MP_TIMER() -tt0
      if(me.eq.0)print *,'time=',tt1,' MFLOPS=', 2d-6*n*n*nrhs/tt1 
c
c     this is a hack to avoid specifying -lglobal twice 
      if(ga_nnodes().le.0) call ga_dgemm()
      call ga_sync()
c
      if(me.eq.0) print *, 'reading global array from disk',g_temp
      if (me.eq.0)call ffflush(6)
      if(dra_read(g_temp,d_c,req).ne.0)call ga_error('read failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
c     if(dra_close(d_a).ne.0)call ga_error('dra_close failed: ',d_a)
c
c***  clean-up
c
      if(dra_delete(d_a).ne.0)
     &            call ga_error('dra_delete failed',0)
      if(dra_delete(d_b).ne.0)
     &            call ga_error('dra_delete failed',0)
      if(dra_delete(d_c).ne.0)
     &            call ga_error('dra_delete failed',0)
c
c
*     call ga_print(g_temp, 1)
      do j = 1+me, nrhs, nproc ! check result
         call ga_get(g_temp, 1,n, j,j, temp,n)
         do i = 1, n
            if(ABS(temp(i)-0.5d0*n*j*(n+1+2*i)).gt. 1d-8) then
              print *,i,j, temp(i)
              call ga_error('error :',i)
            endif
         enddo
      enddo
      call ga_sync()
c
c***  delete temp GA array
      status = ga_destroy(g_temp)
      if(me.eq.0) print *, 'all done'
100   format(g11.2,' MB  time=',g11.2,' rate=',g11.3,'MB/s')
      end


c     given current (i,j) compute (ni, nj) - next pair of loop indices
c     i - outermost loop, j- innermost loop
c     return .false. if (i,j) = (ni,nj), otherwise .true.
c     
      logical function Next2D(i, imin, imax, j, jmin, jmax, ni, nj)
      implicit none
      integer i, imin, imax, j, jmin, jmax, ni, nj
c
      if(i .lt. imin .or. j.lt.jmin)then
c          to handle initial out-of-range indices
           ni = imin
           nj = jmin
      else
           ni = i
           nj = j+1
      endif
      if(nj.gt.jmax)then
         nj = jmin
         ni = ni + 1
      endif
      if(ni.gt.imax)ni=imin            ! restart from the beginning 
      Next2D = ni.ne.i .or. nj.ne.j    ! check if we have a new pair
      end
        

c     given current (i,j) block, issues asynchronous read for next block of matrix
c      
      integer function Prefetch_Next(g_a, d_a, i, j, nb, n, m)
      implicit none
#include "global.fh"
#include "dra.fh"
      integer g_a, d_a, i, j, nb, n,m
      integer jlo, jhi, ni, nj, chunks_i, chunks_j, nc
      integer LO, HI
      logical next2d
      external next2d
      LO(i)  = (i-1)*nb +1
      HI(i)  = MIN(LO(i) + nb -1, m)
c
      chunks_i = 1  ! chunking j only - reads full columns
      chunks_j = (m+nb-1)/nb
      if( next2d(i, 1, chunks_i, j, 1, chunks_j, ni, nj)) then
        jlo = LO(nj)
        jhi = HI(nj)
        nc  = jhi -jlo+1
        if(dra_read_section(.false., g_a, 1, n, 1, nc,
     &             d_a, 1, n, jlo, jhi, prefetch_next).ne.0)
     &                       call ga_error('dra_read failed:',0)

      else
        Prefetch_Next = DRA_REQ_INVALID ! there is nothing new to read
      endif
      end
   

c     Out-of-core matrix multiplication C = A*B, with prefetching.
c
c     A is n x n, B and C are n x m. All arrays reside on disk.
c     nb is a block dimension for the in-core matrices, A_incore: nb x n;
c     B_incore: n x nb; C_incore: nb x nb.
c
      subroutine chunk_mxm(n, m, nb, d_a, d_b, d_c)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
#include "mp3def.fh"

      integer n, m, nb, d_a, d_b, d_c
      integer i, j, chunks_i, chunks_j
      integer ilo, ihi, jlo, jhi, nr, nc
      integer g_a_chunk, g_b_chunk(2), g_c_chunk
      logical status
      integer req, req_b, req_c, Prefetch_Next
      integer nxt_idx, cur_idx
      double precision tot, t0
      logical ga_create2
      integer LO, HI, NEXT
      LO(i,n)  = (i-1)*nb +1
      HI(i,n)  = MIN(LO(i,n) + nb -1, n)
      NEXT(i)  = Mod(i+2,2)+1        ! generates series: 1, 2, 1, 2, 1, ...
c
      chunks_i = (n+nb-1)/nb
      chunks_j = (m+nb-1)/nb
c
c***  create temporary "chunk" GA arrays
c
      if (.not. GA_CREATE(MT_DBL, nb, n, 'a', 1, 1, g_a_chunk))
     $     call ga_error('chunk_mxm: GA_CREATE failed: g_a ',0)

      if (.not. GA_CREATE(MT_DBL, n, nb, 'b(1)', 1, 1, g_b_chunk(1)))
     $     call ga_error('chunk_mxm: GA_CREATE failed: g_b(1) ',0)
      if (.not. GA_CREATE(MT_DBL, n, nb, 'b(2)', 1, 1, g_b_chunk(2)))
     $     call ga_error('chunk_mxm: GA_CREATE failed: g_b(2) ',0)

      if (.not. GA_CREATE(MT_DBL, nb, nb, 'c', 1, 1, g_c_chunk))
     $     call ga_error('chunk_mxm: GA_CREATE failed: g_c ',0)
c
c
      cur_idx = 1
      req_b = Prefetch_Next(g_b_chunk(cur_idx), d_b, 0, 0, nb, n, m)
      if(dra_wait(req_b).ne.0) call ga_error('dra_wait failed:',req)
 
      do i = 1, chunks_i
c
         ilo = LO(i,n)
         ihi = HI(i,n) 
         nr  = ihi-ilo+1
         if(dra_read_section(.false., g_a_chunk, 1, nr, 1, n,
     &                               d_a, ilo, ihi, 1, n, req).ne.0)
     &                          call ga_error('dra_read failed:',0)
         if(dra_wait(req).ne.0)  call ga_error('dra_wait failed:',req)
c
*        call ga_print_patch(g_a_chunk, 1, nr, 1, n, 1)
         do j = 1, chunks_j
c
            jlo = LO(j,m)
            jhi = HI(j,m) 
            nc  = jhi-jlo+1

            if(dra_wait(req_b).ne.0) 
     $                 call ga_error('dra_wait failed:',req_b)
            nxt_idx = NEXT(cur_idx)
            req_b = prefetch_next(g_b_chunk(nxt_idx), d_b, i,j, nb, n,m)
c
c           handle the case when we have the data & there in nothing to prefetch
            if(req_b .eq. DRA_REQ_INVALID)then
                     nxt_idx = cur_idx
                     print *, 'invalid',i,j
            endif
c
*           call ga_print_patch(g_b_chunk(cur_idx), 1, n, 1, nc, 1)
            t0 =MP_TIMER()
            call GA_DGEMM('n','n', nr, nc, n, 1d0, 
     $                     g_a_chunk, g_b_chunk(cur_idx), 0d0,g_c_chunk)
            tot = MP_TIMER() -t0

*           call ga_print_patch(g_c_chunk, 1, nr, 1,nc, 1)
            cur_idx = nxt_idx

            if(dra_write_section(.false., g_c_chunk, 1, nr, 1, nc,
     &                          d_c, ilo, ihi, jlo, jhi, req_c).ne.0)
     &                       call ga_error('dra_write failed for C:',0)
            if(dra_wait(req_c).ne.0)call ga_error('wait failed:',req_c)
            if(ga_nodeid().eq.0)
     &         write(6,'(2i5,5x,2e15.4)')i,j,tot, MP_TIMER()
         enddo
      enddo
      if(dra_wait(req_b).ne.0) call ga_error('dra_wait failed:',req_b)
c
*     call ga_print(g_c, 1)
      status =  ga_destroy(g_c_chunk)
      status =  ga_destroy(g_b_chunk(2)) .and. status
      status =  ga_destroy(g_b_chunk(1)) .and. status
      status =  ga_destroy(g_a_chunk)    .and. status
      if (.not.status) print *,'ga_destroy failed'
      end

      subroutine argos_space_alloc
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      integer isize
c
      if(.not.ma_push_get(mt_int,np,'bindex',l_bindex,i_bindex))
     + call md_abort('Failed to allocate bindex',0)
      if(.not.ma_push_get(mt_int,54*np,'buren',l_buren,i_buren))
     + call md_abort('Failed to allocate buren',0)
      if(.not.ma_push_get(mt_int,3*maxbox,'owner',l_iown,i_iown))
     + call md_abort('Failed to allocate owner',0)
      if(.not.ma_push_get(mt_dbl,3*maxbox,'bxsiz',l_boxs,i_boxs))
     + call md_abort('Failed to allocate bxsiz',0)
      if(.not.ma_push_get(mt_int,6*maxbox,'ibxrg',l_boxr,i_boxr))
     + call md_abort('Failed to allocate ibxrg',0)
      if(.not.ma_push_get(mt_int,6*maxbox,'rng',l_rng,i_rng))
     + call md_abort('Failed to allocate rng',me)
c
      if(.not.ma_push_get(mt_int,mip2*mbox,'ipl',l_ipl,i_ipl))
     + call md_abort('Failed to allocate ipl',0)
      if(.not.ma_push_get(mt_int,mip2*mbox,'jpl',l_jpl,i_jpl))
     + call md_abort('Failed to allocate jpl',0)
c
      mseq=nseq
c
      if(.not.ma_push_get(mt_int,mseq,'lseq',l_lseq,i_lseq))
     + call md_abort('Failed to allocate lseq',0)
      if(.not.ma_push_get(mt_int,mseq,'sndx',l_sndx,i_sndx))
     + call md_abort('Failed to allocate sndx',0)
c
      if(.not.ga_create(mt_int,np*mbox,mip2,'ip',mbox,mip2,ga_ip))
     + call md_abort('Failed to create global array ip',0)
c
      return
      end
c $Id: argos_space_alloc.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: fci_3pdm.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_3pdm(vec, nvec, work, twopdm)
      implicit none
#include "fciinfo.fh"
c     
      integer nvec              ! [input] No. of vectors
      double precision vec(ndets, nvec) ! [input] The CI vectors
      double precision work(nactiv,nactiv,nactiv,nactiv,nvec,nvec)
      double precision twopdm(nactiv,nactiv,nactiv,nactiv,nvec,nvec) ! [output]
      integer nvecmx            ! Maximum value of nvec
      parameter (nvecmx=3) 
      double precision epqrstu(ndetmx*nvecmx*nactmx*nactmx) ! Workspace
      integer numsu, sulist(2,nactmx*nactmx)
      integer iwalk, idim, iocc(nactmx), nsi, ioff, p, q, r, s, t, u, su
      integer pq, rs, tu, sym
      integer ivec, jvec, ivsu, w, uhi
      double precision sum, diff, test, count
c     
c     Test code for the 3-pdm coupling coeff generation ... there are
c     much more efficient ways to compute the actual density matrix.
c     
      integer indsq
      indsq(p,q) = (p-1)*nactiv + q
c     
      test = 1d-4
      count = 0.0d0
c     
      if (nvec.gt.nvecmx) call fci_err('fci_2pdm: nvecmx? ', nvec)
c     
c     Generate all of the coupling coefficients test the code
c     but only accumulate the sum(p) Epp,rs,tu for comparison
c     with the two-pdm
c
      call dfill(0.0d0, work, 1, (nactiv**4)*(nvec**2))
      count = 0.0d0
      do p = 1, nactiv
         do q = 1, nactiv
            pq = indsq(p,q)
            do 10 iwalk = 1, nwalko
               call fci_owalk_info(iwalk, iocc, nsi, ioff, idim, sym)
               if (sym.ne.statesym .or. iocc(q).eq.1) goto 10
               do r = 1, p
                  do t = 1, r
                     call fci_couple3(vec, nvec, p, q, r, t, 
     $                    iocc, idim, numsu, sulist, epqrstu)
                     count = count + numsu*idim*nvec
c     
                     do su = 1, numsu
                        s = sulist(1,su)
                        u = sulist(2,su)
                        rs = indsq(r,s)
                        tu = indsq(t,u)
                        do ivec = 1, nvec
                           ivsu = idim*(ivec-1 + nvec*(su-1))
                           do jvec = 1, nvec
                              sum = 0.0d0
                              do w = 1, idim
                                 sum = sum + epqrstu(ivsu+w)*
     $                                vec(ioff+w,jvec)
                              enddo
c
                              if (p.eq.q) 
     $                             work(r,s,t,u,ivec,jvec) = 
     $                                work(r,s,t,u,ivec,jvec) + sum
                              if (pq.ne.rs .and. r.eq.s)
     $                             work(p,q,t,u,ivec,jvec) = 
     $                             work(p,q,t,u,ivec,jvec) + sum
                              if (pq.ne.tu .and. rs.ne.tu .and. t.eq.u) 
     $                             work(r,s,p,q,ivec,jvec) = 
     $                             work(r,s,p,q,ivec,jvec) + sum
                           enddo
                        enddo
                     enddo
                  enddo
               enddo
 10         continue            ! iwalk loop
         enddo
      enddo
c
c     Must still symmetrize off-diagonal over rs,tu
c
      do ivec = 1, nvec
         do jvec = 1, nvec
            do r = 1, nactiv
               do s = 1, nactiv
                  do t = 1, r
                     uhi = nactiv
                     if (t.eq.r) uhi = s - 1 ! Off diagonal only
                     do u = 1, uhi
                        sum = work(r,s,t,u,ivec,jvec) + 
     $                       work(t,u,r,s,ivec,jvec)
                        work(r,s,t,u,ivec,jvec) = sum
                        work(t,u,r,s,ivec,jvec) = sum
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
c     
      write(6,1) count
 1    format(/' No. of 3-particle coupling coeffs = ', 1p,d9.2)
c     
c     Test the PQ trace
c     
      do ivec = 1, nvec
         do jvec = 1, nvec
            do u = 1, nactiv
               do t = 1, nactiv
                  do s = 1, nactiv
                     do r = 1, nactiv
                        diff = twopdm(r,s,t,u,ivec,jvec) - 
     $                       work(r,s,t,u,ivec,jvec)/dfloat(nelec-2)
                        if (abs(diff) .gt. test) call fci_err
     $                       ('3pdm: bad trace ',1000*r+100*s+10*t+u)
                     enddo
                  enddo
               enddo
            enddo
            write(6,*) ' 3-pdm ', ivec, jvec, ' has good pq trace'
         enddo
      enddo
c     
      end

*
* $Id: menode.f 19708 2010-10-29 18:04:21Z d3y133 $
*
*======================================================================
*
* DISCLAIMER
*
* This material was prepared as an account of work sponsored by an
* agency of the United States Government.  Neither the United States
* Government nor the United States Department of Energy, nor Battelle,
* nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
* ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
* COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
* SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
* INFRINGE PRIVATELY OWNED RIGHTS.
*
* ACKNOWLEDGMENT
*
* This software and its documentation were produced with Government
* support under Contract Number DE-AC06-76RLO-1830 awarded by the United
* States Department of Energy.  The Government retains a paid-up
* non-exclusive, irrevocable worldwide license to reproduce, prepare
* derivative works, perform publicly and display publicly by or for the
* Government, including the right to distribute to other Government
* contractors.
*
*======================================================================
*
*  -- PEIGS  routine (version 2.1) --
*     Pacific Northwest Laboratory
*     July 28, 1995
*
*======================================================================
c PeIGS utility routine
c
c
      integer function menode(Npprocs, nproclist)
      implicit none
      integer Npprocs, nproclist(*)
c
c     Purpose:
c
c     returns the index of the first occurrance of
c     the current processor ( relative node number ) id
c     in a list of Npprocs processors
c     given in a list (nproclist)
c     
      integer mxmynd
      external mxmynd
      external xerbla
      integer indx, me
c     
c     
      me = mxmynd ()
      indx = 0
 10   continue
      indx = indx + 1
      if ( indx .gt. Npprocs ) goto 999
      if ( me .ne. nproclist(indx)) goto 10
      menode = indx - 1
      return
c     
  999 CONTINUE
* 999  write(*,*) 'ERROR: function menode, node: ',  
*     1     me, ' not in node list', Npprocs
c
c      call xerbla('menode', 1)
c
      menode = -1
      return
      end
      

      subroutine cctrans()
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "global.fh"
#include "cuccsdtP.fh"
c
c     Generate the following lists of integrals.  Each list
c     is stored just like the amplitudes, but with SO's 
c     instead of virtuals.  Note lists 13 and 14 contribute
c     to lists 9 and 12, and that list 7 is not used (nor made).
c
c     i,j = particle-transformed occupied orbitals
c     m,n = hole-transformed occupied orbitals
c     u,v = symmetry-adapted occupied orbitals
c
c     u - the SOs arising from the unique AO shells in the
c     .   range ushuqlo, ushuqhi
c     All other indices span the complete range.
c
c     #  Integral        Spins           Storage  Used for 
c     -- --------------- --------------- -------- --------------
c     1. (ui|vj)-(uj|vi) i=alpha j=alpha I(jv,iu) Z1,Z6
c     2. (ui|vj)         i=alpha j=beta           Z2,Z7
c     3. (ui|vj)         i=beta  j=alpha          Z5,Z8
c     4. (ui|vj)-(uj|vi) i=beta  j=beta           Z3,Z4
c
c     5. (um|vn)-(un|vm) m=alpha n=alpha I(nv,mu) aaA and F
c     6. (um|vn)         m=alpha n=beta           abA and F
c    *7. (um|vn)         m=beta  n=alpha          *Not used
c     8. (um|vn)-(un|vm) m=beta  n=beta           bbA and F
c
c     9. (ui|vn)-(uv|in) i=alpha n=alpha I(nv,iu) aaC1,abC4
c     10.(ui|vn)         i=alpha n=beta           abC1,bbC2
c     11.(ui|vn)         i=beta  n=alpha          abC5,aaC2
c     12.(ui|vn)-(uv|in) i=beta  n=beta           abC1,abC2
c
c     13.(uv|in)         i=alpha n=alpha I(nv,iu) abC3
c     14.(uv|in)         i=beta  n=beta           abC5
c
c     The occ-SO pairs are stored as follows
c
c     fill oso_off with -99999999
c     ind = 0
c     do symiu
c     .  do u in natural order
c     .     -> symu and symi
c     .     oso_off(u,symiu) = ind
c     .     do i of symi
c     .        pair(1+ind) = T(i,u)
c     .        ind = ind + 1
c     
c     Can also address pairs as
c     pair(1 + i-o_sym(1,symi,spini) + oso_off(u,symiu)) = T(i,u)
c
c     The lists will be used in large matrix multiplications
c     as follows:
c
c     Z(iu,nw) = <ij|uv>*T(jv,nw)
c     do sym(iu) -> sym(jv) -> sym(nw)
c     .   Read T, allocate Z
c     .   Z(iu,nw) <- I(jv,iu)*T(jv,nw)
c     end do
c
c     For best performance we need the symmetry sub-blocks distributed
c     across the whole machine as separate dense arrays.  Thus, each
c     list is stored with a separate GA for each pair symmetry.
c     
c     Need the occ*SO addressing arrays ... IN WHAT SO LABELLING?
c   
c     The initial parallel algorithm is not entirely satisfactory
c     since in order to keep memory feasible it does a lot of
c     communication.  It also may be complicated to balance
c     available parallelism and memory usage without doing
c     even more communication.
c
c     do blocks of u 
c     .  do blocks of w 
c     .     goal is to make (uw|vi) and (uw|vn) both alpha and beta
c     .     next 4 loops in parallel
c     .     do u in block
c     .        do w in block
c     .           do blocks of v
c     .              do blocks of l
c     .                 make (uw|vl)
c     .                 -> (uw|vi) and (uw|li) (ditto for n)
c     .     sync
c     .     transform the second index
c     
c     Input is
c
c     ush_uqlo, ush_uqhi - range of symmetry unique AO shells for U
c     
c     output is
c
c     14*nirrep global arrays
c
      integer urange(2,0:7), wrange(2,0:7)
      integer i, ir
      integer lists(0:7,14)
      integer nush_block, ush_block(2,nw_max_shells_small)
      integer nwsh_block, wsh_block(2,nw_max_shells_small)

      integer nxtask
      external nxtask
c
c     Someone has already made the addressing lists needed 
c     here for the results, and in the C-term and B-term
c
c     iu_len(symiu,spini) -> #pairs iu of given symmetry and spin with u
c     an SO in the second labelling scheme restricted to the range of u
c
c     iu_off(u,symiu,spini) -> offset to (i,u) with u an SO in the
c     second labelling scheme restricted to the range of u
c
c     iso_len(symiv,spini)-> #pairs iv for v any SO in the second
c     labelling scheme over all SOs
c
c     iso_off(v,symiv,spini) -> offset to (i,v) with v any SO in the
c     second labelling scheme over all SOs
c
c     Allocate the global arrays for the results.
c     How should they be best distributed?
c
      call ifill(14*8, -1, lists, 1)
      do symiu = 0,nir-1
         lena = iso_len(symiu,0)
         lenb = iso_len(symiu,1)
         ulena = iu_len(symiu,0)
         ulenb = iu_len(symiu,1)
         if (.not. ga_create(mt_dbl, lena, ulena, 'list 1', 0, 0, 
     $        lists(symiu,1)) 
     $        call errquit('cctrans: failed allocating list', 1, GA_ERR)
         if (.not. ga_create(mt_dbl, lenb, ulena, 'list 2', 0, 0, 
     $        lists(symiu,2)) 
     $        call errquit('cctrans: failed allocating list', 2, GA_ERR)
         if (.not. ga_create(mt_dbl, lena, ulenb, 'list 3', 0, 0, 
     $        lists(symiu,3)) 
     $        call errquit('cctrans: failed allocating list', 3, GA_ERR)
         if (.not. ga_create(mt_dbl, lenb, ulenb, 'list 4', 0, 0, 
     $        lists(symiu,4)) 
     $        call errquit('cctrans: failed allocating list', 4, GA_ERR)
         if (.not. ga_create(mt_dbl, lena, ulena, 'list 5', 0, 0, 
     $        lists(symiu,5)) 
     $        call errquit('cctrans: failed allocating list', 5, GA_ERR)
         if (.not. ga_create(mt_dbl, lenb, ulena, 'list 6', 0, 0, 
     $        lists(symiu,6)) 
     $        call errquit('cctrans: failed allocating list', 6, GA_ERR)
c$$$         if (.not. ga_create(mt_dbl, lena, ulenb, 'list 7', 0, 0, 
c$$$     $        lists(symiu,7)) 
c$$$     $        call errquit('cctrans: failed allocating list', 7)
         if (.not. ga_create(mt_dbl, lenb, ulenb, 'list 8', 0, 0, 
     $        lists(symiu,8)) 
     $        call errquit('cctrans: failed allocating list', 8, GA_ERR)
         if (.not. ga_create(mt_dbl, lena, ulena, 'list 9', 0, 0, 
     $        lists(symiu,9)) 
     $        call errquit('cctrans: failed allocating list', 9, GA_ERR)
         if (.not. ga_create(mt_dbl, lenb, ulena, 'list 10', 0, 0, 
     $        lists(symiu,10)) 
     $        call errquit('cctrans: failed allocating list', 10,
     &       GA_ERR)
         if (.not. ga_create(mt_dbl, lena, ulenb, 'list 11', 0, 0, 
     $        lists(symiu,11)) 
     $        call errquit('cctrans: failed allocating list', 11,
     &       GA_ERR)
         if (.not. ga_create(mt_dbl, lenb, ulenb, 'list 12', 0, 0, 
     $        lists(symiu,12)) 
     $        call errquit('cctrans: failed allocating list', 12,
     &       GA_ERR)
         if (.not. ga_create(mt_dbl, lena, ulena, 'list 13', 0, 0, 
     $        lists(symiu,13)) 
     $        call errquit('cctrans: failed allocating list', 13,
     &       GA_ERR)
         if (.not. ga_create(mt_dbl, lenb, ulenb, 'list 14', 0, 0, 
     $        lists(symiu,14)) 
     $        call errquit('cctrans: failed allocating list', 14,
     &       GA_ERR)
      end do
      do i = 1, 14
         do symiu = 0, nir-1
            if (lists(symiu,i) .ne. -1) call ga_zero(lists(symiu,i))
         end do
      end do
c
c     Block the u and w shells to control global memory.  For maximum
c     parallelism we want just one block of each.  For now force to one
c     block
c
      nush_block = 1
      ush_block(1,1) = ush_uqlo
      ush_block(2,1) = ush_uqhi
      nwsh_block = 1
      wsh_block(1,1) = 1
      wsh_block(2,1) = sh_n_uq
c
      do ush_blk = 1, nush_block
         ush_blk_lo = ush_block(1,ush_blk)
         ush_blk_hi = ush_block(2,ush_blk)
         call soints_shblock_info(basis, ush_blk_lo, ush_blk_hi, urange)
         write(6,*) ' urange ', ((urange(i,ir),i=1,2),ir=0,nir-1)
c
         do wsh_blk = 1, nwsh_block
            wsh_blk_lo = wsh_block(1,wsh_blk)
            wsh_blk_hi = wsh_block(2,wsh_blk)
            call soints_shblock_info(basis, wsh_blk_lo, wsh_blk_hi, 
     $           wrange)
            write(6,*) ' wrange ', ((wrange(i,ir),i=1,2),ir=0,nir-1)
c
c     For u and w in the given ranges of symmetry unique shells (-> SOs)
c     we will make <vw|iu> for i an occupied orbital
c     ({hole,particle}*{alpha,beta} -> 4 sets) and a SOs v in the second
c     or symmetry blocked labelling.  Since we end up doing lots of
c     small accumulates into this temporary array (to limit local memory
c     consumption) we may eventually bundle all 4 sets into one array,
c     but for now we have one array per set.
c
c     The symmetry of vw pairs is predetermined by symiu = symvw
c     and they are stored as follows.
c     do symw -> symv
c     .   do w in irrep
c     .      do v in irrep
c     
c     Figure out the size of the global arrays <vw|iu>
c
            lena = 0
            lenb = 0
            do symiu = 0, nir-1
               symvw = symiu
               do symw = 0, nir-1
                  symv = ieor(symvw,symw)
                  dimw = wrange(2,symw)-wrange(1,symw)+1
                  dimv = bf_per_ir(symv)
                  lena = lena + dimv*dimw*iu_len(symiu,1)
                  lenb = lenb + dimv*dimw*iu_len(symiu,2)
               end do
            end do
            if (.not. ga_create(mt_dbl, lena, 1, '<vw|iu>1', 0, 0, 
     $           g_vwiu(1)) 
     $           call errquit('cctrans: failed allocating <vw|iu>', 1,
     &       GA_ERR)
            if (.not. ga_create(mt_dbl, lena, 2, '<vw|iu>2', 0, 0, 
     $           g_vwiu(2)) 
     $           call errquit('cctrans: failed allocating <vw|iu>', 1,
     &       GA_ERR)
            if (.not. ga_create(mt_dbl, lenb, 3, '<vw|iu>3', 0, 0, 
     $           g_vwiu(3)) 
     $           call errquit('cctrans: failed allocating <vw|iu>', 3,
     &       GA_ERR)
            if (.not. ga_create(mt_dbl, lenb, 4, '<vw|iu>4', 0, 0, 
     $           g_vwiu(4)) 
     $           call errquit('cctrans: failed allocating <vw|iu>', 4,
     &       GA_ERR)
c
c     Need to determine the blocksize for the v and l loops again to
c     control local memory and increase parallelism ... for now hardwire
c     to 2 for debug.
c
c     Next four loops run in parallel.
c
            vsh_blk_size = 2
            count = 0
            next = nxtask(nproc, 1)
            do ush = ush_blk_lo, ush_blk_hi
               do wsh = wsh_blk_lo, wsh_blk_hi
                  do vsh_blk_lo = 1, sh_n_uq, vsh_blk_size
                     vsh_blk_hi = 
     $                    min(vsh_blk_lo+vsh_blk_size-1,sh_n_uq)
                     do lsh_blk_lo = 1, vsh_blk_lo, vsh_blk_size ! v>=l
                        lsh_blk_hi = 
     $                       min(lsh_blk_lo+vsh_blk_size-1,sh_n_uq)
                        if (next .eq. count) then
                           call cctrans2(ush, wsh,
     $                          vsh_blk_lo, vsh_blk_hi,
     $                          lsh_blk_lo, lsh_blk_hi,
     $                          info about <vw|iu>,
     $                          addressing arrays, 
     $                          )
                           next = nxtask(nproc, 1)
                        end if
                        count = count + 1
                     end do
                  end do
               end do
            end do
c
c     Barrier
c
            next = nxtask(-nproc, 1)
            call ga_sync()
c
c     Data parallel transformation of v or w
c
            do iset = 1, nset
               do symiu = 0, nir-1
                  call ga_distribution(g_vwiu(iset), me, 
     $                 vwlo, vwhi, iulo, iuhi)
                  iu = 1
                  do symiu = 0, nir-1
                     do symu = 0, nir-1
                        symi = ieor(symiu,symu)
                        do u = urange(1,symu),urange(2,symu)
                           do i = ilo(symi,iset),ihi(symi,iset) ??? irange ??
                              if (iu.ge.iulo .and. iu.le.iuhi) then
                                 ----> get (vw|iu)
                                 ----> transform and accumulate results
                              end if
                              iu = iu + 1
                           end do
                        end do
                     end do
                  end do
               end do
            end do
c
            call ga_sync()
c
            free up <vw|iu> and other work space
c            
         end do                 ! blocks of wsh
      end do                    ! blocks of ush
c
c     Done
c
      end
      subroutine cctrans2(ush, wsh,
     $     vsh_blk_lo, vsh_blk_hi,
     $     lsh_blk_lo, lsh_blk_hi,
     $     ) 
      implicit none
#include "mafdecls.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "global.fh"
#include "cuccsdtP.fh"
      integer ush, vsh, vsh_blk_lo, vsh_blk_hi, lsh_blk_lo, lsh_blk_hi
c     
c     For given ranges of unique AO shells (-> range of SOs) with
c     restriction vsh>=lsh, transform (uw|vl) -> (uw|vi) (for up to 4
c     different i's) accumulating results into the global array.
c     
c     Have to further sub-block vsh and lsh in order to keep memory
c     tractable, but we should have enough room to accumulate (uw|vi)
c     and (uw|li) before adding into the global array (if we don't
c     do this there will be too much communication).  The local
c     result is stored as I(v,i,w,u) and I(l,i,w,u).
c     
      integer nvblock, vblock(2,nw_max_shells_small)
      integer nlblock, lblock(2,nw_max_shells_small)
      integer ninblock, lo
      integer vblk, lblk
c     
c     Block the shells so that there are roughly no more than XX
c     functions in each block (better would be to look at the memory
c     available)
c     
      call cctrans_block(nvblock, vblock, vsh_blk_lo, vsh_blk_hi)
      call cctrans_block(nlblock, lblock, lsh_blk_lo, lsh_blk_hi)
c     
      allocate memory for the temporary stuff
c     
      do vblk = 1, nvblock
         lblktop = nlbock
         if (vsh_blk_lo .eq. lsh_blk_lo) lblktop = vblk
         do lblk = 1, nlblock
            call cctrans3(ush, wsh, 
     $           vblock(1,vblk), vblock(2,vblk),
     $           lblock(1,lblk), lblock(2,lblk),
            ...)
         end do
      end do
c     
c     Accumulate to the GA ... this is the bit that is doing too
c     much communication if this routine is called more than once
c     due to exterior blocking of v and l.   The four target
c     GAs could be combined ---- 4x message no. reduction
c     
      ind = 0
      do symwu = 0, nir-1
         symvi = symwu
         do symu = 0, nir-1
            symw = ieor(symwu,symu)
            do u = urange(1,symu), urange(2,symu)
               do w = wrange(1,symw), wrange(2,symw)
                  do symi = 0, nir-1
                     symv = ieor(symvi,symi)
                     vlo = vrange(1,symv)
                     vhi = vrange(2,symv)
                     vdim = vhi - vlo + 1
                     if (vdim .gt. 0) then
                        do iset = 1, nset ! Inside in prep for bundling
                           ptr = ind + k_viwu(iset)
                           do i = ilo(symi,iset),ihi(symi,iset)
c
c     GA is <vw|iu> stored linearly.
c
                              vwiu = vlo
                              iu = 1 + i-ilo(symi,iset) + 
     $                             iu_off(u,symiu,spini)
                              vw = 1 + 
                           end do
                        end do
                     end if
c
                     if (v_blk_lo != l_blk_lo) ditto for l block
c
                  end do
               end do
            end do
         end do
      end do
                           
c     
      free locals
c     
c     Done
c     
      end
      subroutine cctrans_block(nvblock, vblock, vsh_blk_lo, vsh_blk_hi)
      implicit none
#include "cuccsdtP.fh"
      integer nvblock, vblock(2,*), vsh_blk_lo, vsh_blk_hi
c
      integer ninblock, lo, vsh
c
      nvblock = 0
      ninblock = 0
      lo = vsh_blk_lo
      do vsh = vsh_blk_lo, vsh_blk_hi
         ninblock = ninblock + sh_uq_bf(2,vsh) - sh_uq_bf(1,vsh) + 1
         if ( (ninblock.ge.32) .or. (vsh.eq.vsh_blk_hi) ) then
            ninblock = 0
            nvblock = nvblock + 1
            vblocks(1,nvblock) = lo
            vblocks(2,nvblock) = vsh
            lo = vsh+1
         end if
      end do
c
      end
      subroutine cctrans3(ush, wsh, 
     $     vsh_blk_lo, vsh_blk_hi, lsh_blk_lo, lsh_blk_hi,
     $     fullvrange, fulllrange, irange, nset, c, ldc, 
     $     k_viwu, k_liwu) 
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "global.fh"
#include "cuccsdtP.fh"
      integer ush, vsh, vsh_blk_lo, vsh_blk_hi, lsh_blk_lo, lsh_blk_hi
      integer fullvrange(2,0:7), fulllrange(2,0:7)
      integer nset
      integer irange(2,0:7,nset)
      double precision c(nbf,ldc,nset)
      integer k_viwu(nset), k_liwu(nset)
c     
c     Actually get to do something in this routine.
c     
c     For symmetry unique shells u and w, and ranges of v and l
c     compute the integrals and transform v and l to i.
c     
c     k_viwu(iset) is the offset in dbl_mb for (vi|wu) which
c     is stored as (ditto for (li|wu))
c     do symwu
c     .  symvi = symwu
c     .  do symu
c     .     -> symw
c     .     do u = SOs of symu from u-shell
c     .        do w = SOs of symw from w-shell
c     .           do symi
c     .              -> symv
c     .              do i occupied orbitals of symi
c     .                 do v of symv from v-shell-block
c     .                    (vi|wu)
c     
c     The lambda (l) arrays will only be referenced if the 
c     nu (v) and lambda blocks are not the same.
c     
      integer
     $     loff(nw_max_nbf_small),     lrange(2,0:7), 
     $     voff(nw_max_nbf_small,0:7), vrange(2,0:7),
     $     woff(nw_max_nbf_small,0:7), wrange(2,0:7),
     $     uoff(nw_max_nbf_small,0:7), urange(2,0:7),
     $     lenlv(0:7), lenwu(0:7), leng, symwuoff(0:7)
      integer lvwu, symwu, symu, symw, u, w, symv, syml, symi,
     $     vlo, vhi, vdim, llo, lhi, ldim, 
     $     fullvlo, fullvhi, fullvdim, fullllo, fulllhi, fullldim,
     $     iset, k_g, l_g
      integer vioff(0:7,0:7,4), lioff(0:7,0:7,4)
c     
c     Compute g(l,v,w,u) = (lv|wu) 
c     
      call soints_block_info(basis, nbf,
     $     lsh_blk_lo, lsh_blk_hi, loff, lrange,
     $     vsh_blk_lo, vsh_blk_hi, voff, vrange,
     $     wsh, wsh, woff, wrange,
     $     ush, ush, uoff, urange,
     $     lenlv, lenwu, symwuoff, leng)
c     
      if (.not. ma_push_get(mt_dbl, leng, 'cctrans3', l_g, k_g))
     $     call errquit('cctrans3: no room for g', leng, MA_ERR)
c     
      call soints_block(basis, nbf,
     $     lsh_blk_lo, lsh_blk_hi, loff, lrange,
     $     vsh_blk_lo, vsh_blk_hi, voff, vrange,
     $     wsh, wsh, woff, wrange,
     $     ush, ush, uoff, urange,
     $     1d-12, dbl_mb(k_g))
c
c     Convenience adressing arrays
c
      li = 0
      vi = 0
      do symvi = 0, nir-1
         do symi = 0, nir-1
            symv = ieor(symvi,symi)
            vioff(symv,symi) = vi
            lioff(symv,symi) = li
            vi = vi + fullvdim(symv)*idim(symi,iset)
            li = li + fullldim(symv)*idim(symi,iset)
      end do
c     
c     Transform v and l to i.  Loop thru the SO integrals in the order
c     generated.
c     
      do iset = 1, nset
         viwu = k_viwu(iset)
         liwu = k_liwu(iset)
         lvwu = k_g
         do symwu = 0, nir-1
            symlv = symwu
            do symu = 0, nir-1
               symw = ieor(symwu,symu)
               do u = urange(1,symu), urange(2,symu)
                  do w = wrange(1,symw), wrange(2,symw)
                     do symv = 0, nir-1
                        syml = ieor(symlv,symv)
c     Info about the SO integrals just computed
                        vlo = vrange(1,symv)
                        vhi = vrange(2,symv)
                        vdim = vhi - vlo + 1
                        llo = lrange(1,syml)
                        lhi = lrange(2,syml)
                        ldim = lhi - llo + 1
c     Info about the results being accumulated
                        fullvlo = fullvrange(1,symv)
                        fullvhi = fullvrange(2,symv)
                        fullvdim = fullvhi - fullvlo + 1
                        fullllo = fulllrange(1,syml)
                        fulllhi = fulllrange(2,syml)
                        fullldim = fulllhi - fullllo + 1
                        if (vdim*ldim .gt. 0) then
c     (lv|wu) -> (li|wu) ... v -> i
                           ptr = liwu + lioff(syml,symi)+llo-fullllo
                           call dgemm('n','n',
     $                          ldim,idim(symi,iset),vdim,
     $                          1.0d0,dbl_mb(lvwu),ldim,
     $                          c(vlo,ilo(symi,iset),iset),nbf,
     $                          1.0d0,dbl_mb(ptr),fullldim)
c     (lv|wu) -> (vi|wu) ... transpose and l -> i
                           ptr = viwu + vioff(symv,symi)+vlo-fullvlo

                           need to do a little more to get the correct
                           results address for l since are not going
                           thru the l symmetry in order !!!!

                           symi = syml
                           call dgemm('t','n',
     $                          vdim,idim(symi,iset),ldim,
     $                          1.0d0,dbl_mb(lvwu),ldim,
     $                          c(llo,ilo(symi,iset),iset),nbf,
     $                          1.0d0,dbl_mb(ptr),fullvdim)
                        end if
                        lvwu = lvwu + vdim*ldim
                     end do
                     do symi = 0, nir-1
                        symv = ieor(symvi,symi)
                        viwu = viwu + fullvdim(symv)*idim(symi,iset)
                        liwu = liwu + fullldim(symv)*idim(symi,iset)
                     end do
                  end do
               end do
            end do
         end do
      end do
c     
      if (.not. ma_pop_stack(l_g)) call errquit
     $     ('cctrans3: freeing g?', 0, MA_ERR)
c     
      end
c $Id: cctrans.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine  ycopy(n,dx,incx,dy,incy)
*
* $Id: ycopy.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      implicit none
#include "y64.fh"
      double precision dx(*),dy(*)
      integer incx,incy,n
c
      INTGR4  n4,incx4,incy4
c
      n4=n
      incx4=incx
      incy4=incy
c
      call  dcopy(n4,dx,incx4,dy,incy4)
      return
      end

c      program test
c      implicit none
c
c      integer nion,n,na,nqm,nb,lr
c      real*8  a_in,b_in,aqm,da,a_out,b_out
c
c      write(*,*) "Enter a,b,aqm,nion,lr:"
c      read(*,*) a_in,b_in,aqm,nion,lr
c 
c      call FMM_Generate_Box(a_in,b_in,aqm,nion,lr,
c     >                      n,na,nqm,nb,da,a_out,b_out)
c
c      write(*,*)
c      write(*,*) "da,n,n*da      = ",n,da,da*n
c      write(*,*) "a_in,a_out,na  = ",na,a_in,a_out
c      write(*,*) "b_in,b_out,nb  = ",nb,b_in,b_out
c      write(*,*) "aqm,nqm        = ",nqm,aqm
c      write(*,*) 
c      stop
c      end

*     **********************************************
*     *                                            *
*     *             FMM_start                      *
*     *                                            *
*     **********************************************
*
      subroutine FMM_start()
      implicit none

#include "util.fh"
#include "stdio.fh"
#include "fmm.fh"

*     **** local variables ****
      integer MASTER,taskid,np
      parameter (MASTER=0)

      logical oprint
      integer l,m,i,j,k,lm

*     **** external functions ****
      logical  control_fmm,control_print
      integer  control_fmm_lmax,control_fmm_lr,ion_nion,control_version
      external control_fmm,control_print
      external control_fmm_lmax,control_fmm_lr,ion_nion,control_version

      fmm      = control_fmm().and.(control_version().eq.4)
      if (fmm) then
         lmax = control_fmm_lmax()
         lr   = control_fmm_lr()
         levels = nint(dlog(dble(ion_nion()))/dlog(8.0d0)) - lr
         nboxes = 8**levels
         tboxes = 0
         do l=0,levels
            tboxes = tboxes + 8**l
         end  do

         call Parallel_taskid(taskid)
         call Parallel_np(np)
         oprint = (taskid.eq.MASTER).and.control_print(print_medium)

c         value = MA_alloc_get(mt_dbl,26*(lmax+1)**2,'first_tlm_fmm',
c     >                       first_tlm_fmm(2),first_tlm_fmm(1))
c         value = value.and.
c     >           MA_alloc_get(mt_dbl,98*(lmax+1)**2,'second_tlm_fmm',
c     >                        second_tlm_fmm(2),second_tlm_fmm(1))
c         value = value.and.
c     >           MA_alloc_get(mt_dbl,7216,'interaction_tlm_fmm',
c     >                        interaction_tlm_fmm(2),interaction_tlm_fmm(1))
c
c*        **** first neigbors of the current box      ****
c*        **** first_count = 3*3*3 - 1*1*1 = 27-1 = 26 ****
c         first_count = 0
c         do k=-1,1
c            do j=-1,1
c               do i=-1,1
c                  if ((i.ne.0).or.(j.ne.0).or.(k.eq.0)) then
c                     do l=0,fmm_lmax
c                     do m=-l,l
c                        dbl_mb(first_tlm_fmm(1)+first_count) 
c     >                     = Tesseral3_lm(l,m,dble(i),dble(j),dble(k))
c                        first_count = first_count + 1
c                     end do
c                     end do
c                  end if
c               end do
c            end do
c         end do
c
c*        **** second nearest neigbors of the current box ****
c*        **** second_count = 5*5*5 - 3*3*3 = 125-27 = 98 ****
c         second_count = 0
c         do k=-2,2
c            do j=-2,2
c               do i=-2,2
c                  if ((i*i+j*j+k*k).gt.2) then
c                     do l=0,fmm_lmax
c                     do m=-l,l
c                        dbl_mb(second_tlm_fmm(1)+second_count) 
c     >                     = Tesseral3_lm(l,m,dble(i),dble(j),dble(k))
c                        second_count = second_count + 1
c                     end do
c                     end do
c                  end if
c               end do
c            end do
c         end do

c*        **** interaction neigbors - set of boxes which are children of            ****
c*        **** the nearest and second nearest neighbors of the current boxes        ****
c*        **** parent which are not nearest or second nearest neighbors of          ****
c*        **** the current box                                                      ****
c*        **** interaction_count=8*(8*5*5*5-98)=8*(8*125-98)=8*(1000-98)=8*902=7216 ****

         if (oprint) then
            write(luout,100) lmax,lr,
     >                       levels,
     >                       nboxes,tboxes
         end if
      end if
      return
  100 format(/" FMM - Fast Multipole Algorithm",
     >    /"     - fmm_lmax = ",i3," fmm_lr = ",i3,
     >    /"     - number of refinement levels = ",i2,
     >    /"     - nboxes (finest level) = ",i8,      
     >    /"     - nboxes (total)        = ",i8/)      
      end


*     **********************************************
*     *                                            *
*     *                FMM_end                     *
*     *                                            *
*     **********************************************

      subroutine FMM_end()
      implicit none

#include "fmm.fh"

      if (fmm) then
      end if
      return
      end


      logical function FMM_fmm()
      implicit none

#include "fmm.fh"

      FMM_fmm = fmm
      return
      end

      integer function FMM_lmax()
      implicit none

#include "fmm.fh"
     
      FMM_lmax = lmax
      return
      end

*     **********************************************
*     *                                            *
*     *             FMM_Setup_Tree                 *
*     *                                            *
*     **********************************************

*   This routine generates a box gridding and tree for FMM calculations.
*
*   Entry - nion - number of ions
*           rion - atom positions
*           levels - number of tree levels
* 
*   Exit - a_out  - box length
*          ion_boxindx - box indexes for the ions

      subroutine FMM_Setup_Tree(nion,rion,levels,a_out,ion_boxindx)
      implicit none
      integer nion
      real*8  rion(3,*)
      integer levels

      real*8 a_out
      integer ion_boxindx(3,*)

*     **** local variables ****
      integer ii,n,n2
      real*8  aover2

      aover2 = 0.0d0
      do ii=1,nion
         if (dabs(rion(1,ii)).gt.aover2) aover2=dabs(rion(1,ii))
         if (dabs(rion(2,ii)).gt.aover2) aover2=dabs(rion(2,ii))
         if (dabs(rion(3,ii)).gt.aover2) aover2=dabs(rion(3,ii))
      end do
      aover2 = aover2 + 0.5d0
      a_out = 2*aover2

      n = 2**levels
      n2 = n*n
      do ii=1,nion
         ion_boxindx(1,ii) =  idint(n*(rion(1,ii)+aover2)/a_out)
         ion_boxindx(2,ii) =  idint(n*(rion(2,ii)+aover2)/a_out)
         ion_boxindx(3,ii) =  idint(n*(rion(3,ii)+aover2)/a_out)
      end do

      return
      end

*     **********************************************
*     *                                            *
*     *             FMM_Setup_Mlm                  *
*     *                                            *
*     **********************************************

      subroutine FMM_Setup_Mlm(nion,katm,rion,qatm,
     >                         levels,a,ion_boxindx,
     >                         lmax,Mlm)
      implicit none
      integer nion,katm(*)
      real*8  rion(3,*)
      real*8  qatm(*)
      integer levels
      real*8  a
      integer ion_boxindx(3,*)
      integer lmax
      complex*16 Mlm((lmax+1)**2,*)

*     **** local variables ****
      integer taskid,np
      integer ii,i,j,k,n,n2,ibox,idx,l,m
      real*8 aover2,da,xc,yc,zc,q

*     **** external functions ****
      complex*16 rSphericalHarmonic3
      external   rSphericalHarmonic3

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      n = 2**levels
      n2 = n*n
      da = a/dble(a)
      aover2 = a/2.0d0
      call dcopy(2*((lmax+1)**2)*(n*n*n),0.0d0,0,Mlm,1)
      do ii=1,nion
         if (mod(ii,np).eq.taskid) then
            q = qatm(katm(ii))
            xc = -aover2 + (ion_boxindx(1,ii)+0.5d0)*da
            yc = -aover2 + (ion_boxindx(2,ii)+0.5d0)*da
            zc = -aover2 + (ion_boxindx(3,ii)+0.5d0)*da
            ibox = 1 + ion_boxindx(1,ii) 
     >           + ion_boxindx(2,ii)*n 
     >           + ion_boxindx(3,ii)*n2
            idx = 1
            do l=0,lmax
            do m=-l,l
               Mlm(idx,ibox) = Mlm(idx,ibox) 
     >                       + q*rSphericalHarmonic3(l,-m,
     >                                               xc-rion(1,ii),
     >                                               yc-rion(2,ii),
     >                                               zc-rion(3,ii))
               idx = idx + 1
            end do
            end do
         end if
      end do
      call Parallel_Vector_SumAll(((lmax+1)**2)*(n*n*n),Mlm)

      return
      end

*     **********************************************
*     *                                            *
*     *             FMM_Generate_Box               *
*     *                                            *
*     **********************************************
*
*   This routine generates a box gridding for FMM calculations.
*
*   Entry - a_in - guess for start of box 
*           b_in - guess for end of box 
*           aqm  - simple cubic side length
*           nion - number of ions
*           lr   - level reduction factor
* 
*   Exit - levels - number of tree levels
*          n      - number of boxes from a to b
*          na     - number of boxes from a to (-aqm/2)
*          nqm    - number of boxes from (-aqm/2) to (aqm/2)
*          nb     - number of boxes from (aqm/2) to b
*          da     - length of small boxes
*          a_out  - box start
*          b_out  - box end
*
      subroutine FMM_Generate_Box(a_in,b_in,aqm,nion,lr,
     >                            levels,n,na,nqm,nb,da,a_out,b_out)
      implicit none
      real*8 a_in,b_in,aqm
      integer nion,lr
      integer levels,n,na,nqm,nb
      real*8 da,a_out,b_out

      levels = idint(dlog(1.0d0*nion)/dlog(8.0d0))-lr
      n = 2**levels

      nqm = idint(n*aqm/(b_in-a_in))
      da = aqm/dble(nqm)

      na = idint(n*(-0.5d0*aqm-a_in)/(b_in-a_in))
      nb = n - nqm - na
      a_out = -0.5d0*aqm - na*da
      b_out =  0.5d0*aqm + nb*da
      return
      end



*     **********************************************
*     *                                            *
*     *              FMM_rion_Llm                  *
*     *                                            *
*     **********************************************
*
      subroutine FMM_rion_Llm(lmax,nion,katm,rion,qatm,rsphere2,Llm)
      implicit none
      integer lmax
      integer nion,katm(*)
      real*8 rion(3,*),qatm(*),rsphere2,Llm(*)

*     **** local variables ****
      integer taskid,np
      integer ii,l,m,idx
      real*8 fourpi,r2

*     **** external functions ****
      real*8   Tesseral3_lm_over_rl
      external Tesseral3_lm_over_rl

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      fourpi = 16.0d0*datan(1.0d0)
      call dcopy((lmax+1)**2,0.0d0,0,Llm,1)
      do ii=1,nion
         if (mod(ii,np).eq.taskid) then
            r2 = rion(1,ii)**2+rion(2,ii)**2+rion(3,ii)**2
            if (r2.gt.rsphere2) then
               idx = 1
               do l=0,lmax
               do m=-l,l
                  Llm(idx) = Llm(idx) 
     >                     + (fourpi/dble(2*l+1))
     >                      *qatm(katm(ii))
     >                      *Tesseral3_lm_over_rl(l,m,rion(1,ii),
     >                                                rion(2,ii),
     >                                                rion(3,ii))
                  idx = idx + 1
               end do
               end do
            end if
         end if
      end do
      call Parallel_Vector_SumAll((lmax+1)**2,Llm)
      return
      end



*     **********************************************
*     *                                            *
*     *              FMM_fion_Mlm                  *
*     *                                            *
*     **********************************************
*
      subroutine FMM_fion_Mlm(lmax,nion,katm,rion,qatm,rsphere2,
     >                        Mlm,fion)
      implicit none
      integer lmax
      integer nion,katm(*)
      real*8 rion(3,*),qatm(*),rsphere2,Mlm(*),fion(3,*)

*     **** local variables ****
      integer taskid,np
      integer ii,l,m,idx
      real*8 fourpi,r2,coef,dtx,dty,dtz


      call Parallel_np(np)
      call Parallel_taskid(taskid)

      fourpi = 16.0d0*datan(1.0d0)
      do ii=1,nion
         if (mod(ii,np).eq.taskid) then
            r2 = rion(1,ii)**2+rion(2,ii)**2+rion(3,ii)**2
            if (r2.gt.rsphere2) then
               idx = 1
               do l=0,lmax
                  coef = (fourpi/dble(2*l+1))*qatm(katm(ii))
                  do m=-l,l
                     call dTesseral3_lm_over_rl(l,m,rion(1,ii),
     >                                              rion(2,ii),
     >                                              rion(3,ii),
     >                                              dtx,dty,dtz)
                     fion(1,ii) = fion(1,ii) + dtx*coef*Mlm(idx)
                     fion(2,ii) = fion(2,ii) + dty*coef*Mlm(idx)
                     fion(3,ii) = fion(3,ii) + dtz*coef*Mlm(idx)
                     idx = idx + 1
                  end do
               end do
            end if
         end if
      end do
      return
      end



c*     **********************************************
c*     *                                            *
c*     *              FMM_rgrid_Mlm                 *
c*     *                                            *
c*     **********************************************
c
c      subroutine FMM_rgrid_Mlm(lmax,ngrid,rgrid,Mlm)
c      implicit none
c      integer lmax
c      integer ngrid
c      real*8  rgrid(3,*)
c      real*8  Mlm(*)
c
c*     **** local variables ****
c      integer i,l,m,idx
c      real*8 x,y,z
c
c*     **** external functions ****
c      real*8   Tesseral3_lm_rl
c      external Tesseral3_lm_rl
c
c      do i=1,ngrid
c         x = rgrid(1,i)
c         y = rgrid(2,i)
c         z = rgrid(3,i)
c         vl(i) = 0.0d0
c         idx = 1
c         do l=0,lmax
c         do m=-l,l
c            vl(i) = vl(i) + Llm(idx)*Tesseral3_lm_over_rl(l,m,x,y,z)
c            idx = idx + 1
c         end do
c         end do
c      end do
c      return
c      end 

*     ***************************************
*     *                                     *
*     *           FMM_A_over_i              *
*     *                                     *
*     ***************************************
      complex*16 function FMM_A_over_i(l,m)
      implicit none
      integer l,m

*     **** local variables ****
      integer    i,mod_m
      real*8     A
      complex*16 img
       
 
      img  = dcmplx(0.0d0,1.0d0)
      mod_m = abs(m)
      A = 1
      do i=1,(l-mod_m)
        A = A*dble(i)
      end do
      A = A*A
      do i=(l-mod_m+1),(l+mod_m)
        A = A*dble(i)
      end do
      A = ((-1)**l)/dsqrt(A)

      FMM_A_over_i = A/img**mod_m
      return
      end

*     **********************************************
*     *                                            *
*     *              FMM_Translate_Mlm             *
*     *                                            *
*     **********************************************

      subroutine FMM_Translate_Mlm(lmax,Olm,Nlm,x,y,z)
      implicit none
      integer lmax
      complex*16 Olm(*)
      complex*16 Nlm(*)
      real*8 x,y,z

#include "mafdecls.fh"
#include "errquit.fh"


*     **** local variables ****
      logical value
      integer l,m,idx,n
      integer rYlm(2),A(2),B(2),AB(2),tmp22(2),tmp42(2)

*     **** external functions ****
      complex*16 rSphericalHarmonic3
      external   rSphericalHarmonic3

      n = (2*lmax+2)*(4*lmax+2)

*     **** allocate stack ****
      value = MA_push_get(mt_dcpl,(lmax+1)**2,'rYlm',rYlm(2),rYlm(1))
      value=value.and.MA_push_get(mt_dcpl,n,'A',  A(2), A(1))
      value=value.and.MA_push_get(mt_dcpl,n,'B',  B(2), B(1))
      value=value.and.MA_push_get(mt_dcpl,n,'AB',AB(2),AB(1))
      value=value.and.
     >      MA_push_get(mt_dcpl,(2*lmax+2),'tmp22',tmp22(2),tmp22(1))
      value=value.and.
     >      MA_push_get(mt_dcpl,(4*lmax+2),'tmp42',tmp42(2),tmp42(1))
      if (.not.value)
     >   call errquit('FMM_Translate_Mlm:out of stack',0,MA_ERR)

      call dcffti(2*lmax+2,dcpl_mb(tmp22(1)))
      call dcffti(4*lmax+2,dcpl_mb(tmp42(1)))

      idx = 0
      do l=0,lmax
         do m=-l,l
            dcpl_mb(rYlm(1)+idx) = rSphericalHarmonic3(l,-m,x,y,z)
         end do
      end do

      call FMM_Translate_Mlm_sub1(lmax,Olm,dcpl_mb(rYlm(1)),
     >                           dcpl_mb(A(1)),dcpl_mb(B(1)))

      call FMM_Translate_sub2(lmax,dcpl_mb(A(1)),dcpl_mb(B(1)),
     >                        dcpl_mb(AB(1)),
     >                        dcpl_mb(tmp22(1)),dcpl_mb(tmp42(1)))

      call FMM_Translate_Mlm_sub3(lmax,dcpl_mb(AB(1)),Nlm)
            

*     **** deallocate stack ****
      value = MA_pop_stack(tmp42(2))
      value = value.and.MA_pop_stack(tmp22(2))
      value = value.and.MA_pop_stack(AB(2))
      value = value.and.MA_pop_stack(B(2))
      value = value.and.MA_pop_stack(A(2))
      value = value.and.MA_pop_stack(rYlm(2))
      if (.not.value)
     >   call errquit('FMM_Translate_Mlm:popping stack',0,MA_ERR)
      return
      end

*     ***************************************
*     *                                     *
*     *        FMM_Translate_Mlm_sub1       *
*     *                                     *
*     ***************************************
      subroutine FMM_Translate_Mlm_sub1(lmax,Olm,rYlm,A,B)
      implicit none
      integer lmax
      complex*16 Olm(*),rYlm(*)
      complex*16 A(2*lmax+2,4*lmax+2)
      complex*16 B(2*lmax+2,4*lmax+2)


*     **** local variables ****
      integer idx,i,j,l,m
      complex*16 ctmp

*     **** external functions ****
      complex*16 FMM_A_over_i
      external   FMM_A_over_i

      call dcopy(2*(2*lmax+2)*(4*lmax+2),0.0d0,0,A,1)
      call dcopy(2*(2*lmax+2)*(4*lmax+2),0.0d0,0,B,1)
      idx = 1
      j   = 1
      do l=0,lmax
         i=1
         do m=-l,l
            ctmp = FMM_A_over_i(l,m)
            A(i,j) = Olm(idx) *ctmp
            B(i,j) = rYlm(idx)*ctmp
             
            i = i + 1
            idx = idx + 1
         end do
         j = j + 1
      end do
      return
      end 

*     ***************************************
*     *                                     *
*     *        FMM_Translate_sub2           *
*     *                                     *
*     ***************************************
      subroutine FMM_Translate_sub2(lmax,A,B,AB,tmp22,tmp42)
      implicit none
      integer lmax
      complex*16  A(2*lmax+2,4*lmax+2)
      complex*16  B(2*lmax+2,4*lmax+2)
      complex*16 AB(2*lmax+2,4*lmax+2)
      complex*16 tmp22(*),tmp42(*)

*     **** local variables ****
      integer i,j,n

      n = (2*lmax+2)*(4*lmax+2)
      do j=1,(4*lmax+2)
         call dcfftf(2*lmax+2,A(1,j),tmp22)
         call dcfftf(2*lmax+2,B(1,j),tmp22)
      end do
      do i=1,(2*lmax+2)
         call dcfftf(4*lmax+2,A(i,1),tmp42)
         call dcfftf(4*lmax+2,B(i,1),tmp42)
      end do
      do j=1,(4*lmax+2)
         do i=1,(2*lmax+2)
            AB(i,j) = A(i,j)*B(i,j)
         end do
      end do

      do i=1,(2*lmax+2)
         call dcfftb(4*lmax+2,AB(i,1),tmp42)
      end do
      do j=1,(4*lmax+2)
         call dcfftb(2*lmax+2,AB(1,j),tmp22)
      end do
      call dscal(2*n,1.0d0/dble(n),AB,1)

      return
      end

*     ***************************************
*     *                                     *
*     *        FMM_Translate_Mlm_sub3       *
*     *                                     *
*     ***************************************
      subroutine FMM_Translate_Mlm_sub3(lmax,AB,Mlm)
      implicit none
      integer lmax
      complex*16 AB(2*lmax+2,4*lmax+2)
      complex*16 Mlm(*)

*     **** local variables ****
      integer idx,i,j,l,m

*     **** external functions ****
      complex*16 FMM_A_over_i
      external   FMM_A_over_i

* Jeff added these because they are implicit with Intel Fortran 
* and either this code is never used, is fine to give undefined behavior
* or assumes initialization to zero.
      idx = 0
      j   = 0
      i   = 0

      do l=0,lmax
         do m=-l,l
            Mlm(idx) = AB(i,j)/FMM_A_over_i(l,m)
            i = i + 1
            idx = idx + 1
         end do
         j = j + 1
      end do
      return
      end


*     **********************************************
*     *                                            *
*     *              FMM_Translate_Llm             *
*     *                                            *
*     **********************************************

      subroutine FMM_Translate_Llm(lmax,Olm,Nlm,x,y,z)
      implicit none
      integer lmax
      complex*16 Olm(*)
      complex*16 Nlm(*)
      real*8 x,y,z

#include "mafdecls.fh"
#include "errquit.fh"


*     **** local variables ****
      logical value
      integer l,m,idx,n
      integer rYlm(2),A(2),B(2),AB(2),tmp22(2),tmp42(2)

*     **** external functions ****
      complex*16 rSphericalHarmonic3
      external   rSphericalHarmonic3

      n = (2*lmax+2)*(4*lmax+2)

*     **** allocate stack ****
      value = MA_push_get(mt_dcpl,(lmax+1)**2,'rYlm',rYlm(2),rYlm(1))
      value=value.and.MA_push_get(mt_dcpl,n,'A',  A(2), A(1))
      value=value.and.MA_push_get(mt_dcpl,n,'B',  B(2), B(1))
      value=value.and.MA_push_get(mt_dcpl,n,'AB',AB(2),AB(1))
      value=value.and.
     >      MA_push_get(mt_dcpl,2*lmax+2,'tmp22',tmp22(2),tmp22(1))
      value=value.and.
     >      MA_push_get(mt_dcpl,4*lmax+2,'tmp42',tmp42(2),tmp42(1))
      if (.not.value)
     >   call errquit('FMM_Translate_Llm:out of stack',0,MA_ERR)

      call dcffti(2*lmax+2,dcpl_mb(tmp22(1)))
      call dcffti(4*lmax+2,dcpl_mb(tmp42(1)))

      idx = 0
      do l=0,lmax
         do m=-l,l
            dcpl_mb(rYlm(1)+idx) = rSphericalHarmonic3(l,m,x,y,z)
         end do
      end do

      call FMM_Translate_Llm_sub1(lmax,Olm,dcpl_mb(rYlm(1)),
     >                           dcpl_mb(A(1)),dcpl_mb(B(1)))

      call FMM_Translate_sub2(lmax,dcpl_mb(A(1)),dcpl_mb(B(1)),
     >                        dcpl_mb(AB(1)),
     >                        dcpl_mb(tmp22(1)),dcpl_mb(tmp42(1)))

      call FMM_Translate_Llm_sub3(lmax,dcpl_mb(AB(1)),Nlm)


*     **** deallocate stack ****
      value = MA_pop_stack(tmp42(2))
      value = value.and.MA_pop_stack(tmp22(2))
      value = value.and.MA_pop_stack(AB(2))
      value = value.and.MA_pop_stack(B(2))
      value = value.and.MA_pop_stack(A(2))
      value = value.and.MA_pop_stack(rYlm(2))
      if (.not.value)
     >   call errquit('FMM_Translate_Llm:popping stack',0,MA_ERR)
      return
      end


*     ***************************************
*     *                                     *
*     *        FMM_Translate_Llm_sub1       *
*     *                                     *
*     ***************************************
      subroutine FMM_Translate_Llm_sub1(lmax,Olm,rYlm,A,B)
      implicit none
      integer lmax
      complex*16 Olm(*),rYlm(*)
      complex*16 A(2*lmax+2,4*lmax+2)
      complex*16 B(2*lmax+2,4*lmax+2)


*     **** local variables ****
      integer idx,i,j,l,m,sgn
      complex*16 ctmp

*     **** external functions ****
      complex*16 FMM_A_over_i
      external   FMM_A_over_i

      call dcopy(2*(2*lmax+2)*(4*lmax+2),0.0d0,0,A,1)
      call dcopy(2*(2*lmax+2)*(4*lmax+2),0.0d0,0,B,1)
      idx = 1
      j   = 1
      sgn = 1
      do l=0,lmax
         i=1
         do m=-l,l
            ctmp = FMM_A_over_i(l,m)
            A(i,j) = sgn*Olm(idx)/ctmp
            B(i,j) = rYlm(idx)*ctmp

            i = i + 1
            idx = idx + 1
         end do
         j = j + 1
         sgn = -sgn
      end do
      return
      end



*     ***************************************
*     *                                     *
*     *        FMM_Translate_Llm_sub3       *
*     *                                     *
*     ***************************************
      subroutine FMM_Translate_Llm_sub3(lmax,AB,Llm)
      implicit none
      integer lmax
      complex*16 AB(2*lmax+2,4*lmax+2)
      complex*16 Llm(*)

*     **** local variables ****
      integer idx,i,j,l,m,sgn

*     **** external functions ****
      complex*16 FMM_A_over_i
      external   FMM_A_over_i

* Jeff: idx was not initialized before and defaults to zero with Intel,
* which appears to be the primary compiler for testing.
      idx = 0

      sgn = 1
      j=1
      do l=0,lmax
         i=1
         do m=-l,l
            Llm(idx) = sgn*AB(i,j)/FMM_A_over_i(l,m)
            i = i + 1
            idx = idx + 1
         end do
         j = j + 1
         sgn = -sgn
      end do
      return
      end


*     ***************************************
*     *                                     *
*     *        FMM_reduce_levels            *
*     *                                     *
*     ***************************************
*
*    This function translates index values between different levels of an octree grid

      integer function FMM_reduce_levels(nl,l,lr)
      implicit none
      integer nl,l,lr

      FMM_reduce_levels = ishft(ishft(ibits(nl,2*l,l),-lr),2*(l-lr))
     >                  + ishft(ishft(ibits(nl,l,l),-lr),(l-lr)) 
     >                  + ishft(ibits(nl,0,l),-lr)
      return
      end

      subroutine argos_cafe_slowt(vw,numw,vs,nums,iwat,isat,wgt)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "msgids.fh"
c
      integer numw,nums
      real*8 vw(mwm,3,mwa),vs(msa,3),wgt(mat,mset)
      integer iwat(mwa),isat(msa)
c
      integer i,j,k
      real*8 vb(3)
c
      do 1 i=1,3
      vb(i)=zero
    1 continue
c
      do 2 k=1,3
      do 3 j=1,nwa
      do 4 i=1,numw
      vb(k)=vb(k)+wgt(iwat(j),iset)*vw(i,k,j)
    4 continue
    3 continue
      do 5 i=1,nums
      vb(k)=vb(k)+wgt(isat(i),iset)*vs(i,k)
    5 continue
      vb(k)=vb(k)/wbox
    2 continue
c
      call ga_dgop(mcf_50,vb,3,'+')
c
      do 6 k=1,3
      do 7 j=1,nwa
      do 8 i=1,numw
      vw(i,k,j)=vw(i,k,j)-vb(k)
    8 continue
    7 continue
      do 9 i=1,nums
      vs(i,k)=vs(i,k)-vb(k)
    9 continue
    6 continue
c
      return
      end
c $Id: argos_cafe_slowt.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdt_t3a_8_4(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: ccsdt_t3a_8_4.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h12 p4 p5 h1 h2 h3 )_vt + = 1/12 * P( 2 ) * Sum ( p7 p8 ) * t ( p4 p7 p8 h1 h2 h3 )_t * v ( h12 p5 p7 p8 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p4b
      INTEGER p5b
      INTEGER h12b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p8b
      INTEGER p4b_1
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER h3b_1
      INTEGER p5b_2
      INTEGER h12b_2
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      LOGICAL ACOLO,ACOLO_O_2P
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p4b = noab+1,noab+nvab
      DO p5b = noab+1,noab+nvab
      DO h12b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = h2b,noab
      IF (next.eq.count) THEN
      IF(acolo_o_2p(p4b,p5b,h1b,h2b,h3b)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+
     &int_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+h12b-1
     &) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h12b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),in
     &t_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+h12b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_
     &mb(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_t3_8_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO p8b = p7b,noab+nvab
      IF(acolo(p4b,p7b,p8b,h1b,h2b,h3b)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb(
     &k_sym+p8b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p4b,p7b,p8b,h1b,h2b,h3b,p4b_1,p7b_1,p8b_1,h1
     &b_1,h2b_1,h3b_1)
      CALL TCE_RESTRICTED_4(p5b,h12b,p7b,p8b,p5b_2,h12b_2,p7b_2,p8b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1)
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1) * int_mb(k_range+h3b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h12b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_t3_8_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_t3_8_4',2,MA_ERR)
      IF ((p8b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),6,5,4,3,2,1,1.0d0)
      END IF
      IF ((p7b .lt. p4b) .and. (p4b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p8b_1 - noa
     &b - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p8b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),6,5,4,2,3,1,-1.0d0)
      END IF
      IF ((p4b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h2b_1 - 1 + noab * (h1b_1 - 1 + noab * (p8b_1 - noa
     &b - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p4b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p8b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h3b-1),6,5,4,1,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_t3_8_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_t3_8_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_t3_8_4',5,MA_ERR)
      IF ((h12b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (p5b_2 - 1 + (noab
     &+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1
     &),1,2,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_t3_8_4',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p7b .eq. p8b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_t3_8_4',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_t3_8_4',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END IF !active
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_t3_8_4',9,MA_ERR)
      IF ((p4b .le. p5b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h3b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,2,1,5,4,3,1.0d0/12
     &.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h12b - 1 + noab *
     & (p5b - noab - 1 + nvab * (p4b - noab - 1)))))))
      END IF
      IF ((p5b .le. p4b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h3b-1),int_mb(k_range+h2b-1
     &),int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),2,6,1,5,4,3,-1.0d0/1
     &2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h12b - 1 + noab *
     & (p4b - noab - 1 + nvab * (p5b - noab - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_t3_8_4',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_t3_8_4',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      END IF !active
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

c
c $Id: hnd_hlfd_ij.F 19696 2010-10-29 16:53:42Z d3y133 $
c
c Modified from HONDO integral code
c
      subroutine hnd_hlfd_ij2(xyzi,expi,coefi,i_nprim,i_ngen,Li,
     1  xyzj,expj,coefj,j_nprim,j_ngen,Lj,kat,didvij,djdvij,zan,xyz,
     2  nder,nint,scr,lscr)
c
c This is a wrapper routine, setting up scratch blocks used in actual
c integral routine
c
      implicit none
c
      integer i_nprim   ! [input] num. prims on function i
      integer i_ngen    ! [input] num general conts on func. i
      integer Li        ! [input] angular momentum of func. i
      integer j_nprim   ! [input] num. prims on function j
      integer j_ngen    ! [input] num general conts on func. j
      integer Lj        ! [input] angular momentum of func. j
      integer nder      ! [input] should always be 2=2nd der
      integer nint      ! [input] number of base integrals
      integer kat       ! [input] lexical number of an atom
      integer lscr      ! [input] length of scratch space
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim) ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen) ! [input] j coeffs
      double precision xyz(3,*) ! [input] all atom positions
      double precision didvij(nint,3,3) ! [output] 2nd der integrals
      double precision djdvij(nint,3,3) ! [output] 2nd der integrals
      double precision zan(*)   ! [input] nuclear charges
      double precision scr(lscr) ! [input] scratch buffer
c
#include "hnd_pointers.fh"
c
c Use scratch for temps in integral calculation
c Scratch needs are 
c (6*(Li+2)*(Lj+2)+12*(Li+1)*(Lj+1))*((Li+Lj+nder)/2+1)
c
c The pointers are defined in hdn_pointers.fh
c
      call hnd_hlfd_ij21(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,expj,
     1  coefj,j_nprim,j_ngen,Lj,kat,didvij,djdvij,zan,xyz,nder,nint,
     2  scr(hdp(1)) ,scr(hdp(2)) ,scr(hdp(3)) ,scr(hdp(4)),scr(hdp(5)),
     3  scr(hdp(6)) ,scr(hdp(7)) ,scr(hdp(8)) ,scr(hdp(9)),scr(hdp(10)),
     4  scr(hdp(11)),scr(hdp(12)),scr(hdp(13)),scr(hdp(14)),
     5  scr(hdp(15)),scr(hdp(16)),scr(hdp(17)),scr(hdp(18)))
c
      return
      end
c
      subroutine hnd_hlfd_ij21(xyzi,expi,coefi,i_nprim,i_ngen,Li,
     1  xyzj,expj,coefj,j_nprim,j_ngen,Lj,kat,didvij,djdvij,zan,xyz,
     2  nder,nint,xv,yv,zv,dxv,dyv,dzv,dxvdi,dyvdi,dzvdi,dxvdj,dyvdj, 
     3  dzvdj,ddxvdi,ddyvdi,ddzvdi,ddxvdj,ddyvdj,ddzvdj)
c
c  This is a routine that computes additional cross 2nd derivative Helman-
c  Feynman/orbital terms.  It is assumed that the buffers for the integrals
c  have been zeroed before entering this routine.
c
      implicit none
#include "hnd_rys.fh"
#include "hnd_tol.fh"
#include "stdio.fh"
#include "errquit.fh"
      integer i_nprim   ! [input] num. prims on function i
      integer i_ngen    ! [input] num general conts on func. i
      integer Li        ! [input] angular momentum of func. i
      integer j_nprim   ! [input] num. prims on function j
      integer j_ngen    ! [input] num general conts on func. j
      integer Lj        ! [input] angular momentum of func. j
      integer nder      ! [input] should always be 2=2nd der
      integer nint      ! [input] number of base integrals
      integer kat       ! [input] lexical number of an atom
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim) ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen) ! [input] j coeffs
      double precision xyz(3,*) ! [input] all atom positions
      double precision didvij(nint,3,3) ! [output] 2nd der integrals
      double precision djdvij(nint,3,3) ! [output] 2nd der integrals
      double precision zan(*)   ! [input] nuclear charges
c
      common/hnd_xyzder/xint,yint,zint,tx,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     1                             ni,nj,cx,cy,cz
      double precision xint, yint, zint, tx, x0, y0, z0, xi, yi, zi
      double precision xj, yj, zj, cx, cy, cz
      double precision rln10, zero, one, tol, rr, ai, aj, arri
      double precision axi, ayi, azi, csi, cpi, cdi, cfi, cgi
      double precision aa, aa1, dum, fac, csj, cpj, cdj, cfj, cgj
      double precision ax, ay, az, dum1, dum2, pij
      double precision dumxx, dumyy, dumzz, dumxy, dumxz, dumyz
      double precision dumyx, dumzx, dumzy
      double precision two, pi212, aax, aay, aaz, znuc
      double precision uu, ww, w2, tt, xv, yv, zv
      double precision dxv, dyv, dzv
      double precision dxvdi, dyvdi, dzvdi
      double precision dxvdj, dyvdj, dzvdj
      double precision ddxvdi, ddyvdi, ddzvdi
      double precision ddxvdj, ddyvdj, ddzvdj
      integer ni, nj, iroot, Nxyz
      integer lit, maxi, ljt,maxj
      integer ig, jg, ij, i, j, ix, iy, iz, jx, jy, jz
      integer litder, ljtder
      dimension w2(maxrys), Nxyz(3)
      dimension    xv(Li+2,Lj+2,*),   yv(Li+2,Lj+2,*),   zv(Li+2,Lj+2,*)
      dimension   dxv(Li+2,Lj+2,*),  dyv(Li+2,Lj+2,*),  dzv(Li+2,Lj+2,*)
      dimension dxvdi(Li+1,Lj+1,*),dyvdi(Li+1,Lj+1,*),dzvdi(Li+1,Lj+1,*)
      dimension dxvdj(Li+1,Lj+1,*),dyvdj(Li+1,Lj+1,*),dzvdj(Li+1,Lj+1,*)
      dimension ddxvdi(Li+1,Lj+1,*),ddyvdi(Li+1,Lj+1,*)
      dimension ddzvdi(Li+1,Lj+1,*),ddxvdj(Li+1,Lj+1,*)
      dimension ddyvdj(Li+1,Lj+1,*),ddzvdj(Li+1,Lj+1,*)
      data rln10  /2.30258d+00/
      data zero   /0.0d+00/
      data one    /1.0d+00/
      data two    /2.0d+00/
      data pi212  /1.1283791670955d+00/
c
      tol =rln10*itol
c
c     ----- calculate derivatives of -hlf- term -----
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit=Li + 1
      maxi=lit*(lit+1)/2
c
      litder=lit+nder-1
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt=Lj + 1
      maxj=ljt*(ljt+1)/2
c
      ljtder=ljt+nder-1
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
      nroots=(lit+ljt+nder-2)/2+1
      if(nroots.gt.maxrys) then
         write(luout,9997) maxrys,lit,ljt,nroots
         call errquit('hnd_hlfd_ij2: maxrys is too large!',555, INT_ERR)
      endif
c
c     ----- i primitive -----
c
      do 7000 ig=1,i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do 6000 jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=one/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) go to 6000
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      pij=fac*csi*csj*aa1*pi212
c
c     ----- nuclear attraction derivatives -----
c
      aax=aa*ax
      aay=aa*ay
      aaz=aa*az
c                      
      znuc=-zan(kat)
      cx=xyz(1,kat)
      cy=xyz(2,kat)
      cz=xyz(3,kat)
      yy=aa*((ax-cx)**2+(ay-cy)**2+(az-cz)**2)
      call hnd_droot
      do 420 iroot=1,nroots
      uu=u9(iroot)*aa
      ww=w9(iroot)*znuc
      w2(iroot)=ww*uu*two
      tt=one/(aa+uu)
      tx= sqrt(tt)
      x0=(aax+uu*cx)*tt
      y0=(aay+uu*cy)*tt
      z0=(aaz+uu*cz)*tt
c
      do 410 j=1,ljtder
      nj=j
      do 410 i=1,litder
      ni=i
      call hnd_sxyz
c     call original hnd_dsyxz instead?
      xv(i,j,iroot)=xint
      yv(i,j,iroot)=yint
      zv(i,j,iroot)=zint
      call hnd_dervxyz(1)
      dxv(i,j,iroot)=xint
      dyv(i,j,iroot)=yint
      dzv(i,j,iroot)=zint
  410 continue
c
      call hnd_deriaj( dxvdi(1,1,iroot), dyvdi(1,1,iroot),
     1              dzvdi(1,1,iroot), dxvdj(1,1,iroot),
     1              dyvdj(1,1,iroot), dzvdj(1,1,iroot),
     1              xv(1,1,iroot),    yv(1,1,iroot),   zv(1,1,iroot),
     2          lit,ljt,ai,aj)
      call hnd_deriaj(ddxvdi(1,1,iroot),ddyvdi(1,1,iroot),
     1             ddzvdi(1,1,iroot), ddxvdj(1,1,iroot),
     1             ddyvdj(1,1,iroot), ddzvdj(1,1,iroot),
     1             dxv(1,1,iroot),   dyv(1,1,iroot),  dzv(1,1,iroot),
     2          lit,ljt,ai,aj)
c
  420 continue
c
      ij=0
      do 450 i=1,maxi
      call getNxyz(Li,i,Nxyz)
      ix = Nxyz(1) + 1
      iy = Nxyz(2) + 1
      iz = Nxyz(3) + 1
      do 440 j=1,maxj
      call getNxyz(Lj,j,Nxyz)
      jx = Nxyz(1) + 1
      jy = Nxyz(2) + 1
      jz = Nxyz(3) + 1
      dumxx=zero
      dumxy=zero
      dumxz=zero
      dumyx=zero
      dumyy=zero
      dumyz=zero
      dumzx=zero
      dumzy=zero
      dumzz=zero
      do 430 iroot=1,nroots
      dumxx=dumxx+w2(iroot)*
     1  (ddxvdi(ix,jx,iroot)* yv   (iy,jy,iroot)* zv   (iz,jz,iroot))
      dumxy=dumxy+w2(iroot)*
     1  (dxvdi (ix,jx,iroot)*dyv   (iy,jy,iroot)* zv   (iz,jz,iroot))
      dumxz=dumxz+w2(iroot)*
     1  (dxvdi (ix,jx,iroot)* yv   (iy,jy,iroot)*dzv   (iz,jz,iroot))
      dumyx=dumyx+w2(iroot)*
     1  (dxv   (ix,jx,iroot)*dyvdi (iy,jy,iroot)* zv   (iz,jz,iroot))
      dumyy=dumyy+w2(iroot)*
     1  ( xv   (ix,jx,iroot)*ddyvdi(iy,jy,iroot)* zv   (iz,jz,iroot))
      dumyz=dumyz+w2(iroot)*
     1  ( xv   (ix,jx,iroot)*dyvdi (iy,jy,iroot)*dzv   (iz,jz,iroot))
      dumzx=dumzx+w2(iroot)*
     1  (dxv   (ix,jx,iroot)* yv   (iy,jy,iroot)*dzvdi (iz,jz,iroot))
      dumzy=dumzy+w2(iroot)*
     1  ( xv   (ix,jx,iroot)*dyv   (iy,jy,iroot)*dzvdi (iz,jz,iroot))
      dumzz=dumzz+w2(iroot)*
     1  ( xv   (ix,jx,iroot)* yv   (iy,jy,iroot)*ddzvdi(iz,jz,iroot))
  430 continue
      ij=ij+1
      didvij(ij,1,1)=didvij(ij,1,1)+dumxx*pij
      didvij(ij,1,2)=didvij(ij,1,2)+dumxy*pij
      didvij(ij,1,3)=didvij(ij,1,3)+dumxz*pij
      didvij(ij,2,1)=didvij(ij,2,1)+dumyx*pij
      didvij(ij,2,2)=didvij(ij,2,2)+dumyy*pij
      didvij(ij,2,3)=didvij(ij,2,3)+dumyz*pij
      didvij(ij,3,1)=didvij(ij,3,1)+dumzx*pij
      didvij(ij,3,2)=didvij(ij,3,2)+dumzy*pij
      didvij(ij,3,3)=didvij(ij,3,3)+dumzz*pij
c
c handle the djdvij part
c
      dumxx=zero
      dumxy=zero
      dumxz=zero
      dumyx=zero
      dumyy=zero
      dumyz=zero
      dumzx=zero
      dumzy=zero
      dumzz=zero
      do 435 iroot=1,nroots
      dumxx=dumxx+w2(iroot)*
     1  (ddxvdj(ix,jx,iroot)* yv   (iy,jy,iroot)* zv   (iz,jz,iroot))
      dumxy=dumxy+w2(iroot)*
     1  (dxvdj (ix,jx,iroot)*dyv   (iy,jy,iroot)* zv   (iz,jz,iroot))
      dumxz=dumxz+w2(iroot)*
     1  (dxvdj (ix,jx,iroot)* yv   (iy,jy,iroot)*dzv   (iz,jz,iroot))
      dumyx=dumyx+w2(iroot)*
     1  (dxv   (ix,jx,iroot)*dyvdj (iy,jy,iroot)* zv   (iz,jz,iroot))
      dumyy=dumyy+w2(iroot)*
     1  ( xv   (ix,jx,iroot)*ddyvdj(iy,jy,iroot)* zv   (iz,jz,iroot))
      dumyz=dumyz+w2(iroot)*
     1  ( xv   (ix,jx,iroot)*dyvdj (iy,jy,iroot)*dzv   (iz,jz,iroot))
      dumzx=dumzx+w2(iroot)*
     1  (dxv   (ix,jx,iroot)* yv   (iy,jy,iroot)*dzvdj (iz,jz,iroot))
      dumzy=dumzy+w2(iroot)*
     1  ( xv   (ix,jx,iroot)*dyv   (iy,jy,iroot)*dzvdj (iz,jz,iroot))
      dumzz=dumzz+w2(iroot)*
     1  ( xv   (ix,jx,iroot)* yv   (iy,jy,iroot)*ddzvdj(iz,jz,iroot))
  435 continue
      djdvij(ij,1,1)=djdvij(ij,1,1)+dumxx*pij
      djdvij(ij,1,2)=djdvij(ij,1,2)+dumxy*pij
      djdvij(ij,1,3)=djdvij(ij,1,3)+dumxz*pij
      djdvij(ij,2,1)=djdvij(ij,2,1)+dumyx*pij
      djdvij(ij,2,2)=djdvij(ij,2,2)+dumyy*pij
      djdvij(ij,2,3)=djdvij(ij,2,3)+dumyz*pij
      djdvij(ij,3,1)=djdvij(ij,3,1)+dumzx*pij
      djdvij(ij,3,2)=djdvij(ij,3,2)+dumzy*pij
      djdvij(ij,3,3)=djdvij(ij,3,3)+dumzz*pij
c
  440 continue
  450 continue
c
 6000 continue
 7000 continue
c
      return
 9997 format(' in -hlfd- , the rys quadrature is not implememented',
     1       ' beyond -nroots- = ',i3,/,
     2       ' lit,ljt,nroots= ',3i3)
      end

      subroutine hamild(pcap, qcap, fc, fo, s, u, t, h, dos, dt,
     +                  c, smin, qmin, nbb)
C$Id: hamild.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c.......................................................................
c
c     construct fock matrices. this is a direct s c f procedure,
c     and the two-electron integrals are recalculated for every
c     iteration.
c.......................................................................
#include "cguess.fh"
c
      integer nbb
      real *8  c(*), smin(nbb,*), qmin(nbb,*)
      real *8  pcap(*), qcap(*), fc(*), fo(*), s(*)
      real *8  u(*), t(*), h(*), dos(*), dt(*)
c
      integer i, j, m, n
      integer nstep1, nstep2, nstep, nsh, nbas1, naddr, j1
      integer k, nosh1
      real *8 occucl, fact1, fact2, term1, term2
c
      call teigd (pcap, qcap, u, t, dt, dos)
c.......................................................................
c     compute smin and qmin
c.......................................................................
      nstep1 = 0
      nstep2 = 0
      nstep = 0
      do 50 i = 1 , nsym
         nsh = ncsh(i) + nosh(i)
         nbas1 = nbas(i)
         do j = 1 , nsh
            naddr = nstep2 + (j-1)*nbas1
            j1 = nstep + j
            do m = 1 , nbas1
               smin(m,j1) = 0.d0
               qmin(m,j1) = 0.d0
               do n = 1 , nbas1
                  k = max(m,n)*(max(m,n)-1)/2 + min(m,n) + nstep1
                  smin(m,j1) = smin(m,j1) + s(k)*c(n+naddr)
                  qmin(m,j1) = qmin(m,j1) + qcap(k)*c(n+naddr)
               enddo
            enddo
         enddo
         nstep = nstep + nsh
         nstep2 = nstep2 + nbas1**2
         nstep1 = nstep1 + n1(i)
 50   continue
c.......................................................................
c     compute fc and fo
c.......................................................................
      k = 1
      nstep = 0
      do i = 1 , nsym
         occucl = 4*i - 2
         nosh1 = nosh(i)
         nsh = ncsh(i) + nosh1
         fact1 = occucl/(occucl-nccup(i))
         fact2 = nccup(i)/(occucl-nccup(i))
         nbas1 = nbas(i)
         do m = 1 , nbas1
            do n = 1 , m
               term1 = 0.d0
               term2 = 0.d0
               do j = 1 , nsh
                  j1 = j + nstep
                  if (j.ne.nsh .or. nosh1.eq.0) then
                     term1 = term1 + smin(m,j1)*qmin(n,j1) + qmin(m,j1)
     +                       *smin(n,j1)
                  else
                     term2 = smin(m,j1)*qmin(n,j1) + qmin(m,j1)
     +                       *smin(n,j1)
                  end if
               enddo
               fo(k) = fact1*term1 + pcap(k) + h(k) - qcap(k)
               fc(k) = fact2*term2 + pcap(k) + h(k)
               k = k + 1
            enddo
         enddo
         nstep = nstep + nsh
      enddo
      return
      end

      double precision function util_random(iseed)
      implicit none
#include "errquit.fh"
c $Id: util_random.F 26140 2014-09-03 00:19:44Z edo $
c
c routine to give a random number [0,1]
c
c     iseed is an integer seed when non-zero used to initialize the sequence     
c
#if defined(IBM) || defined(SP1) || ( defined(BGQ) && !defined(GFORTRAN) )
      integer iseed
      if(iseed.gt.0) call srand(dble(iseed))
      util_random=rand()
#elif defined(KSR)
      real random
      external random
      integer iseed
* on KSR if iseed != 0 it resets the sequence
      util_random=dble/work/u13377/nwchem(random(iseed))
#elif defined(SGI) || defined(SGITFP)
       integer iseed
       real*8 rand
       external rand
       if(iseed.gt.0) call srand(dble(iseed))
       util_random=rand()
#elif defined(CRAY)
      integer iseed
      if(iseed.gt.0) call ranset(iseed)
      util_random=ranf()
#elif defined(WIN32) &&!defined(__MINGW32__)
      integer iseed
      double precision drand
      external drand
      if (iseed.gt.0) call srand(iseed)
      util_random = drand(0)
#elif (defined(LINUX) || defined(CYGNUS)) && !defined(LINUXALPHA)
      integer iseed
      double precision linux_rand
      external linux_rand
      if(iseed.gt.0) call linux_sran(iseed)
      util_random=linux_rand()
#else
      integer iseed
      double precision drand
      external drand
      util_random = drand(iseed)
#endif
      end

c    *******************************************************************
c    ** gear 5-value predictor-corrector algorithm for translation.   **
c    **                                                               **
c    ** reference:                                                    **
c    **                                                               **
c    ** gear, numerical initial value problems in ordinary            **
c    ** differential equations (prentice-hall,1971).                  **
c    **                                                               **
c    ** supplied routines:                                            **
c    **                                                               **
c    ** subroutine predic ( dt )                                      **
c    **    predicts the new positions, velocities, etc.               **
c    ** subroutine correc ( dt, m, k )                                **
c    **    corrects the positions, velocities etc. using gear method  **
c    **                                                               **
c    ** principal variables:                                          **
c    **                                                               **
c    ** integer n                  number of molecules                **
c    ** real    dt                 timestep                           **
c    ** real    rx(n),ry(n),rz(n)  positions                          **
c    ** real    vx(n),vy(n),vz(n)  velocities                         **
c    ** real    ax(n),ay(n),az(n)  accelerations                      **
c    ** real    bx(n),by(n),bz(n)  third derivatives                  **
c    ** real    cx(n),cy(n),cz(n)  fourth derivatives                 **
c    ** real    fx(n),fy(n),fz(n)  forces                             **
c    **                                                               **
c    ** usage:                                                        **
c    **                                                               **
c    ** at each timestep, call predic, force, correc in order         **
c    ** followed by accumulation of thermodynamic quantities.         **
c    ** the force routine (not supplied here: see f.17) calculates    **
c    ** potential energy and forces on all atoms.                     **
c    *******************************************************************



        subroutine predic (n, dt )

c    *******************************************************************
c    ** predictor routine                                             **
c    **                                                               **
c    ** in timestep-scaled variables the predictor is the pascal      **
c    ** triangle matrix.  in unscaled variables it is a taylor series **
c    **                                                               **
c    ** usage:                                                        **
c    **                                                               **
c    ** predic is called to advance the coordinates, velocities etc.  **
c    ** by one timestep dt, prior to force evaluation.                **
c    *******************************************************************

        integer     n 
        double precision r(3,n), v(3,n), a(3,n), b(3,n), c(3,n)
        double precision dt
        integer     i,j
C ---- dt# are the Taylor expansion series terms dt1=dt, dt2=dt^2/2, dt3=dt^3/6 etc. 
        real        dt1, dt2, dt3, dt4

c    *******************************************************************

       dt1 = dt
       dt2 = dt1 * dt / 2.0
       dt3 = dt2 * dt / 3.0
       dt4 = dt3 * dt / 4.0

       do i = 1,n 
        do j=1,3
         r(j,i) = r(j,i) + dt1*v(j,i) + dt2*a(j,i)  
     1          +  dt3*b(j,i) + dt4*c(j,i)
         v(j,i) = v(j,i) + dt1*a(j,i) + dt2*b(j,i) + dt3*c(j,i)
         a(j,i) = a(j,i) + dt1*b(j,i) + dt2*c(j,i)
         b(j,i) = b(j,i) + dt1*c(j,i)
        enddo
       enddo 

        return
        end



        subroutine correc (n, dt, mass, ek )

c    *******************************************************************
c    ** corrector routine                                             **
c    **                                                               **
c    ** corrects positions, velocities etc. after force evaluation.   **
c    ** in timestep-scaled variables the numerical coefficients are   **
c    ** given by gear (ref above): 19/120, 3/4, 1, 1/2, 1/12.         **
c    ** in unscaled form these must be multiplied by factors          **
c    ** involving the timestep as shown here.                         **
c    **                                                               **
c    ** principal variables:                                          **
c    **                                                               **
c    ** real    m                        atomic mass                  **
c    ** real    ek                        kinetic energy per atom      **
c    ** real    c0,c1,c2,c3              gear coefficients            **
c    **                                                               **
c    ** usage:                                                        **
c    **                                                               **
c    ** it is assumed that intermolecular forces have been calculated **
c    ** and stored in force (gradient of the potential). correc simply
c       applies the corrector   **
c    ** equations based on the differences between predicted and      **
c    ** evaluated accelerations.  it also calculates kinetic energy.  **
c    *******************************************************************

        integer     n
        double precision r(3,n), v(3,n), a(3,n), b(3,n), c(3,n)
        double precision dt, force(3,n)
        integer     i,j
C ---- dt# are the Taylor expansion series terms dt1=dt, dt2=dt^2/2, dt3=dt^3/6 etc.
        double precision        dt1, dt2, dt3, dt4
        double precision       mass(n), ek
        double precision ai(3),corr(3)
        double precision  cr, cv, cb, cc
        double precision  c0, c1, c3, c4
        parameter ( c0 = 19.0 / 120.0, c1 = 3.0 / 4.0,
     1              c3 = 1.0 / 2.0,    c4 = 1.0 / 12.0 )

c    *******************************************************************

        dt1 = dt
        dt2 = dt1 * dt / 2.0
        dt3 = dt2 * dt / 3.0
        dt4 = dt3 * dt / 4.0

        cr = c0 * dt2
        cv = c1 * dt2 / dt1
        cb = c3 * dt2 / dt3
        cc = c4 * dt2 / dt4

        ek = 0.0

        do i = 1, n
         do j=1,3  
           
           ai(j) = force(j,i) / mass(i)
           corr(j) = ai(j) - a(j,i)

           r(j,i) = r(j,i) + cr * corr(j)
           v(j,i) = v(j,i) + cv * corr(j)
           a(j,i) = ai(j)
           b(j,i) = b(j,i) + cb * corr(j)
           c(j,i) = c(j,i) + cc * corr(j)
         
        
           ek = ek + v(j,i) ** 2 
         enddo 
       enddo 

       ek = 0.5 * mass(i) * ek

       return
       end




c $Id: pred-corr.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function argos_prepare_nonbon(iatm,natm,lbnd,mbnd,ibnd,
     + nbnd,
     + lang,mang,iang,nang,l3rd,m3rd,i3rd,n3rd,lnon,mnon,nnon)
c
c $Id: argos_prepare_nonbon.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer iatm,natm,mbnd,ibnd,nbnd,mang,iang,nang
      integer m3rd,i3rd,n3rd,mnon,nnon
      integer lbnd(4,mbnd),lang(5,mang),l3rd(2,m3rd),lnon(2,mnon)
c
      integer i,j,k
c
      do 1 i=iatm,natm-1
      do 2 j=i+1,natm
      do 3 k=ibnd,nbnd
      if(lbnd(1,k).eq.i.and.lbnd(2,k).eq.j) goto 2
    3 continue
      do 4 k=iang,nang
      if(lang(1,k).eq.i.and.lang(3,k).eq.j) goto 2
    4 continue
      do 5 k=i3rd,n3rd
      if(l3rd(1,k).eq.i.and.l3rd(2,k).eq.j) goto 2
    5 continue
      do 6 k=1,nnon
      if(lnon(1,k).eq.i.and.lnon(2,k).eq.j) goto 2
    6 continue
      nnon=nnon+1
      if(nnon.gt.mnon) call md_abort('increase mnon',9999)
      lnon(1,nnon)=i
      lnon(2,nnon)=j
    2 continue
    1 continue
c
      argos_prepare_nonbon=.true.
      return
      end

*
* $Id: paw_matrix_core.F 20364 2011-05-20 20:38:23Z d3p852 $
*

!**************************************************
!
!       name:
!
!       purpose 
!
!       created:        7/9/2002
!**************************************************
      subroutine  init_paw_core_matrix()
      implicit none
  
#include "mafdecls.fh"
#include "paw_basis.fh"
#include "paw_matrix_core_data.fh"
#include "paw_utils.fh"
#include "paw_ma.fh"


      !*** local variables ***
      logical ok
      integer it,tot_ntype
      integer matr_size, matr_index

      tot_ntype = paw_basis_tot_ntype()
      ok = my_alloc(mt_int,tot_ntype,"i_paw_core_matrix",
     >                   i_paw_core_matrix)
      if (.not.ok) 
     > call errquit("init_paw_core_matrix: out of memory",0,0)
  
      !*** determine matrix size ***
      matr_size = 0
      do it=1,tot_ntype
        matr_size = matr_size + int_mb(paw_basis_i_nbasis(it))**2
      end do

      !*** set the indexing to access diff atom types ***
      int_mb(i_paw_core_matrix(1) )  = 0
      do it=1,tot_ntype-1
        int_mb(i_paw_core_matrix(1) +it) = 
     >         int_mb(i_paw_core_matrix(1) + it - 1) 
     >       + int_mb(paw_basis_i_nbasis(it))**2
      end do

      ok = my_alloc(mt_dbl,matr_size,"paw_core_matrix",paw_core_matrix)
      if (.not.ok) 
     > call errquit("init_paw_core_matrix: out of memory",0,1)
  
      do it=1,tot_ntype
    
        matr_index = int_mb(i_paw_core_matrix(1) +it-1)
        call find_core_matrix( int_mb(paw_basis_i_i_cut(it)),
     >                        int_mb(paw_basis_i_ngrid(it)),
     >                        int_mb(paw_basis_i_nbasis(it)),
     >                        int_mb(paw_basis_i_orb_l(it)),
     >                        dbl_mb(paw_basis_i_log_amesh(it)),
     >                        dbl_mb(paw_basis_i_rgrid(it)),
     >                        dbl_mb(paw_basis_i_core_density(it)),
     >                        dbl_mb(paw_basis_i_ps_core_density(it)),
     >                        dbl_mb(paw_basis_i_phi_ae(it)),
     >                        dbl_mb(paw_basis_i_phi_ps(it)),
     >                        dbl_mb(paw_core_matrix(1) + matr_index))
      end do

      return
      end !subroutine init_paw_core_matrix

      subroutine  end_paw_core_matrix()
      implicit none
  
#include "mafdecls.fh"
#include "paw_basis.fh"
#include "paw_matrix_core_data.fh"
#include "paw_utils.fh"
#include "paw_ma.fh"

      !*** local variables ***
      logical ok

      ok =        my_dealloc(i_paw_core_matrix)
      ok = ok.and.my_dealloc(paw_core_matrix)
      if (.not.ok) 
     > call errquit("end_paw_core_matrix: error freeing heap",0,0)

      return
      end !subroutine end_paw_core_matrix


!**************************************************
!
!       name:
!
!       purpose 
!
!       created:        7/9/2002
!**************************************************
      subroutine find_core_matrix( ic,
     >                        ngrid,
     >                        nbasis,
     >                        orb_l,
     >                        log_amesh,
     >                        r,
     >                        core_density,
     >                        ps_core_density,
     >                        phi_ae,
     >                        phi_ps,
     >                        matrix)
      implicit none
      integer    ic
      integer    ngrid
      integer    nbasis
      integer    orb_l(nbasis)

      double precision     log_amesh
      double precision     r(ngrid)
      double precision     core_density(ngrid)
      double precision     ps_core_density(ngrid)
      double precision     phi_ae(ngrid,nbasis)
      double precision     phi_ps(ngrid,nbasis)
      double precision     matrix(nbasis,nbasis)

#include "mafdecls.fh"
#include "integrate.fh"
#include "paw_utils.fh"   
#include "paw_ma.fh"   

      !*** local variables ***
      logical  ok
      integer  i,j,ii
      integer  l
      integer  power_r,power_f
      integer  i_f1,l_f1
      integer  i_f2,l_f2
      integer  i_f3,l_f3
      integer  i_f4,l_f4
      double precision  tmp


      power_r = 0

      !*** temporary array for calculations ***
      ok =        ma_push_get(mt_dbl,ic,"tmp_array1",l_f1,i_f1)
      ok = ok.and.ma_push_get(mt_dbl,ic,"tmp_array2",l_f2,i_f2)
      ok = ok.and.ma_push_get(mt_dbl,ic,"tmp_array3",l_f3,i_f3)
      ok = ok.and.ma_push_get(mt_dbl,ic,"tmp_array4",l_f4,i_f4)
      if (.not.ok)
     > call errquit('find_core_matrix: out of stack memory',0,0)


      do ii=1,ic
      dbl_mb(i_f3+ii-1) = core_density(ii)*r(ii)**2
      dbl_mb(i_f4+ii-1) = ps_core_density(ii)*r(ii)**2
      end do

      do i=1,nbasis
        l = orb_l(i)
        power_f = 2*orb_l(i) + 2
        do j=1,i
          if(orb_l(i).eq.orb_l(j)) then
    
            power_f = 2*l+2
            do ii=1,ic
            dbl_mb(i_f1+ii-1) =  phi_ae(ii,i)*phi_ae(ii,j)
            dbl_mb(i_f2+ii-1) =  phi_ps(ii,i)*phi_ps(ii,j)
            end do
   
            tmp = find_multipole_energy(0,ic,r,power_f,
     >                                  dbl_mb(i_f1),2,
     >                                  dbl_mb(i_f3),log_amesh)
     >          - find_multipole_energy(0,ic,r,power_f,
     >                                  dbl_mb(i_f2),2,
     >                                  dbl_mb(i_f4),log_amesh)

            matrix(i,j) = tmp
            matrix(j,i) = tmp
          else
            matrix(i,j) = 0.0d0
            matrix(j,i) = 0.0d0
          end if

        end do
      end do

      ok =        ma_pop_stack(l_f4)
      ok = ok.and.ma_pop_stack(l_f3)
      ok = ok.and.ma_pop_stack(l_f2)
      ok = ok.and.ma_pop_stack(l_f1)
      if (.not.ok)
     > call errquit('find_core_matrix:error popping stack',0,1)

      return
      end



      subroutine paw_core_matrix_ptr(ptr)
      implicit none
      integer ptr

#include "paw_matrix_core_data.fh"

      ptr = paw_core_matrix(1)

      return
      end

      subroutine fock_2e_from_file(geom, basis, nfock, ablklen,
     $     jfac, kfac, tol2e, oskel,
     $     dij, dik, dli, djk, dlj, dlk,
     $     fij, fik, fli, fjk, flj, flk,
     $     tmp, vg_dens, vg_fock)
      implicit none
#include "util.fh"
#include "cscfps.fh"
#include "cfock.fh"
c
c     $Id: fock_2e_file.F 19707 2010-10-29 17:59:36Z d3y133 $
c
c     Accumulate the contribution to the fock matrices from
c     integrals store in the integral file.  Simply read thru
c     the file getting a range of indices, fetch the corresponding
c     density matrix blocks and then read the integrals in that
c     block.
c
      integer geom, basis
      integer nfock
      integer ablklen
      double precision jfac(nfock)
      double precision kfac(nfock)
      double precision tol2e
      logical oskel
      double precision dij(nfock*ablklen),dik(nfock*ablklen)
      double precision dli(nfock*ablklen),djk(nfock*ablklen)
      double precision dlj(nfock*ablklen),dlk(nfock*ablklen)
      double precision fij(nfock*ablklen),fik(nfock*ablklen)
      double precision fli(nfock*ablklen),fjk(nfock*ablklen)
      double precision flj(nfock*ablklen),flk(nfock*ablklen)
      double precision tmp(ablklen)
      integer vg_dens(nfock)
      integer vg_fock(nfock)
c
      double precision den_tol, denmax, dtol2e
      integer ilo, jlo, klo, llo
      integer ihi, jhi, khi, lhi
      integer ijk_prev(3,2)
      integer blklen
c
      logical int2e_get_bf_range, int2e_file_read
      external int2e_get_bf_range, int2e_file_read
c
      if (oscfps) call pstat_on(ps_fock_io)
c
      den_tol = max(tol2e*0.01d0,1.0d-300) ! To avoid a hard zero
c
      ijk_prev(1,1) = -1
      ijk_prev(2,1) = -1
      ijk_prev(3,1) = -1
      ijk_prev(1,2) = -1
      ijk_prev(2,2) = -1
      ijk_prev(3,2) = -1
c
      blklen = nfock*ablklen
      call dfill(blklen, 0.0d0, fij, 1)
      call dfill(blklen, 0.0d0, fik, 1)
      call dfill(blklen, 0.0d0, fli, 1)
      call dfill(blklen, 0.0d0, fjk, 1)
      call dfill(blklen, 0.0d0, flj, 1)
      call dfill(blklen, 0.0d0, flk, 1)
c
c     Loop over blocks of integral labels
c
 10   if (int2e_get_bf_range(ilo,ihi,jlo,jhi,klo,khi,llo,lhi)) then
c
c     Get matrices for this block of labels
c
         call fock_init_cmul(ihi-ilo+1,jhi-jlo+1,lhi-llo+1)
         call fock_2e_cache_dens_fock(
     $        ilo, jlo, klo, llo,
     $        ihi, jhi, khi, lhi,
     $        ijk_prev,
     $        nfock, vg_dens, vg_fock,
     $        jfac, kfac, 
     $        dij, dik, dli, djk, dlj, dlk,
     $        fij, fik, fli, fjk, flj, flk,
     $        tmp)
c
         call fock_density_screen(nfock,
     $        ilo, jlo, klo, llo,
     $        ihi, jhi, khi, lhi,
     $        ilo, jlo, klo, llo,
     $        ihi, jhi, khi, lhi,
     $        dij, dik, dli, djk, dlj, dlk, denmax)
c
         dtol2e = min(dentolmax, den_tol/max(1d-10,denmax), 
     $        den_tol/max(1d-10,denmax**2))
c     
         call int2e_file_fock_block(nfock, dtol2e,
     $           dij, dik, dli, djk, dlj, dlk,
     $           fij, fik, fli, fjk, flj, flk)
c
c     Update F blocks
c     
         call fock_upd_blk(nfock, vg_fock,
     $        llo, lhi, ilo, ihi, kfac, fli, tmp)
         call fock_upd_blk(nfock, vg_fock,
     $        llo, lhi, jlo, jhi, kfac, flj, tmp)
         call fock_upd_blk(nfock, vg_fock,
     $        llo, lhi, klo, khi, jfac, flk, tmp)
c     
         goto 10
c     
      end if
c
      if (ijk_prev(1,1) .ne. -1) then
         call fock_upd_blk(nfock, vg_fock, 
     $        ijk_prev(1,1), ijk_prev(1,2),
     $        ijk_prev(2,1), ijk_prev(2,2),
     $        jfac, fij, tmp)
         call fock_upd_blk(nfock, vg_fock,
     $        ijk_prev(2,1), ijk_prev(2,2),
     $        ijk_prev(3,1), ijk_prev(3,2),
     $        kfac, fjk, tmp )
         call fock_upd_blk( nfock, vg_fock,
     $        ijk_prev(1,1), ijk_prev(1,2),
     $        ijk_prev(3,1), ijk_prev(3,2),
     $        kfac, fik, tmp )
      end if
c     
      if (oscfps) call pstat_off(ps_fock_io)
c
      end
      subroutine fock_2e_rep_from_file(geom, basis, nfock, nbf,
     $     jfac, kfac, tol2e, oskel, dens, fock)
      implicit none
#include "errquit.fh"
#include "util.fh"
#include "cscfps.fh"
#include "cfock.fh"
#include "global.fh"
      integer geom, basis
      integer nfock, nbf
      double precision jfac(nfock), kfac(nfock)
      double precision tol2e
      logical oskel
      double precision dens(nfock,nbf*nbf), fock(nfock,nbf*nbf)
c
      double precision den_tol, denmax
      integer ilo, jlo, klo, llo
      integer ihi, jhi, khi, lhi, i, j
c
      logical int2e_get_bf_range, int2e_file_read
      external int2e_get_bf_range, int2e_file_read
      integer idamax
      external idamax
c
      if (oscfps) call pstat_on(ps_fock_io)
c
      denmax = 0.0d0
      do i = 1, nfock
         j = idamax(nbf*nbf, dens(i,1), nfock)
         denmax = max(denmax, abs(dens(i,j)))
      end do
      den_tol = min(dentolmax,tol2e/denmax,tol2e/denmax**2) ! Threshold to screen integs only
c
      if (ga_nodeid().eq.0 .and. util_print('fockfile',print_debug))
     $     write(6,*) 'fockfile: tols ',tol2e, dentolmax, denmax,den_tol
c
      call fock_init_cmul(nbf,nbf,nbf) ! lookup table for f build
c
c     Loop over blocks of integral labels
c
 10   if (int2e_get_bf_range(ilo,ihi,jlo,jhi,klo,khi,llo,lhi)) then
         if (ilo.ne.1 .or. jlo.ne.1 .or. klo.ne.1 .or. llo.ne.1)
     $        call errquit('not a replicated file?',0, UNKNOWN_ERR)
         if (ihi.ne.nbf .or. jhi.ne.nbf .or. khi.ne.nbf.or. lhi.ne.nbf)
     $        call errquit('not a replicated file?',0, UNKNOWN_ERR)
c
         call int2e_file_rep_fock(nfock, nbf,
     $        jfac, kfac, den_tol, dens, fock)
c
         goto 10
c     
      end if
c
      if (oscfps) call pstat_off(ps_fock_io)
c
      end

*
* $Id: kbppv3.F 22549 2012-06-02 21:11:04Z bylaska $
*

*     **************************************
*     *                                    *
*     *           kbppv3                   *
*     *                                    *
*     **************************************

      logical function kbppv3(oprint_in,version,
     >                  psp_filename,formatted_filename,
     >                  ngrid,unita,locp,lmax,rlocal)
      implicit none
      logical          oprint_in
      integer          version
      character*50     psp_filename,formatted_filename
      integer          ngrid(3)
      double precision unita(3,3)
      integer locp,lmax
      real*8  rlocal

#include "errquit.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "stdio.fh"

      integer taskid,MASTER,msglen
      parameter (MASTER=0)

*     **** 1d pseudopotential data ****
      character*2 atom
      character*80 comment
      double precision zv,amass
      integer lmax0,lmmax,lmax1,locp1
      double precision rc(0:9),rlocal1
      integer nrho
      double precision drho
      integer rho_indx,vp_indx,wp_indx,sc_r_indx,sc_k_indx
      integer rho_hndl,vp_hndl,wp_hndl,sc_r_hndl,sc_k_hndl

      integer          isemicore
      logical          semicore
      double precision rcore,core_charge

      integer f_indx,cs_indx,sn_indx
      integer n_prj_indx,l_prj_indx,m_prj_indx,b_prj_indx
      integer f_hndl,cs_hndl,sn_hndl
      integer n_prj_hndl,l_prj_hndl,m_prj_hndl,b_prj_hndl

*     ***** ngrid data *****
      integer vl_indx,vnl_indx,vnlnrm_indx,G_indx
      integer vl_hndl,vnl_hndl,vnlnrm_hndl,G_hndl

*     **** ray data ****
      integer nray,G_ray_hndl,tmp_ray_hndl
      integer rho_sc_k_ray_hndl,vnl_ray_hndl,vl_ray_hndl
      integer G_ray_indx,tmp_ray_indx
      integer rho_sc_k_ray_indx,vnl_ray_indx,vl_ray_indx


*     **** other variables ****
      logical value,mprint,hprint,oprint,filter
      double precision unitg(3,3)
      integer nsize,i,l,ierr,psp_type
      integer nfft1,nfft2,nfft3
      integer nmax,nprj
      character*255 full_filename

*     **** external functions ****
      logical  control_print,control_kbpp_ray,control_kbpp_filter
      external control_print,control_kbpp_ray,control_kbpp_filter
      double precision simp
      external         simp
      integer  kbpp_calc_nray
      external kbpp_calc_nray


c      call Parallel_Init()
      call Parallel_taskid(taskid)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)
      mprint = (taskid.eq.MASTER).and.control_print(print_medium)
      oprint = (oprint_in.or.hprint)

      value = .false.
  
*     ***** read in pseudopotential data ****
      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(psp_filename,.false.,.false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      open(unit=11,file=full_filename(1:l),
     >             status='old',form='formatted')
      read(11,'(A2)') atom
      read(11,*) zv,amass,lmax0,lmax1,locp1,rlocal1
      read(11,*) (rc(i),i=0,lmax0)
      read(11,*) nrho,drho
      read(11,'(A)') comment
      end if

      msglen = 1
      call Parallel_Brdcst_values(MASTER,msglen,zv)
      call Parallel_Brdcst_values(MASTER,msglen,amass)
      call Parallel_Brdcst_values(MASTER,msglen,rlocal1)
      call Parallel_Brdcst_ivalues(MASTER,msglen,lmax0)
      call Parallel_Brdcst_ivalues(MASTER,msglen,lmax1)
      call Parallel_Brdcst_ivalues(MASTER,msglen,locp1)

      msglen = lmax0+1
      call Parallel_Brdcst_values(MASTER,msglen,rc)
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,nrho)
      call Parallel_Brdcst_values(MASTER,msglen,drho)


*     **** set the maximum angular momentum ****
      if (lmax.eq.-1)    lmax = lmax1
      if (lmax.gt.lmax0) lmax = lmax0
      if (lmax.lt.0)     lmax = lmax0

*     **** set the local potential ****
      if (locp.eq.-1)   locp = locp1
      if (locp.gt.lmax) locp = lmax
      if (locp.lt.0)    locp = lmax

*     **** set the local potential ****
      if (rlocal.eq.1.0d0)   rlocal = rlocal1
      

*     **** allocate rho, vp, and wp ****
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'rho',rho_hndl,rho_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho*(lmax+1),
     >                        'vp',vp_hndl, vp_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho*(lmax+1),
     >                        'wp', wp_hndl, wp_indx)
      value = value.and.MA_alloc_get(mt_dbl,2*nrho,
     >                        'sc', sc_r_hndl, sc_r_indx)
      if (.not.value) 
     > call errquit('kbppv3:out of heap memory',0,MA_ERR)

      if (taskid.eq.MASTER) then
      call read_vpwp(11,nrho,lmax,dbl_mb(rho_indx),
     >                         dbl_mb(vp_indx),
     >                         dbl_mb(wp_indx))
      call read_semicore(11,isemicore,rcore,nrho,dbl_mb(sc_r_indx))
      close(11)
      end if

      msglen = nrho
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(rho_indx))
      msglen = nrho*(lmax+1)
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(vp_indx))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(wp_indx))

      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,isemicore)
      semicore = (isemicore.eq.1)
      if (semicore) then
      msglen = 2*nrho
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(sc_r_indx))
      else
         rcore = 0.0d0
      end if


*    **** more temporary space ****
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'f',f_hndl,f_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho,
     >                        'cs',cs_hndl,cs_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho,
     >                        'sn',sn_hndl,sn_indx)
      if (.not.value) 
     > call errquit('kbppv3:out of heap memory',0,MA_ERR)

*     **** allocate vl,vnl,vnlnrm G ****
      lmmax = (lmax+1)**2 - (2*locp+1)
      nprj  = lmmax
      nsize = (ngrid(1)/2+1)*ngrid(2)*ngrid(3)
      value = MA_alloc_get(mt_dbl,nsize,
     >                        'vl',vl_hndl,vl_indx)
      value = value.and.MA_alloc_get(mt_dbl,nsize*(lmmax),
     >                        'vnl',vnl_hndl, vnl_indx)
      value = value.and.MA_alloc_get(mt_dbl,(lmax+1),
     >                        'vnlnrm', vnlnrm_hndl, vnlnrm_indx)
      value = value.and.MA_alloc_get(mt_dbl,nsize*(3),
     >                        'G',G_hndl, G_indx)
      value = value.and.MA_alloc_get(mt_dbl,4*nsize,
     >                        'sc_k',sc_k_hndl,sc_k_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'n_prj', n_prj_hndl, n_prj_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'l_prj', l_prj_hndl, l_prj_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'm_prj', m_prj_hndl, m_prj_indx)
      value = value.and.MA_alloc_get(mt_int,nprj,
     >                        'b_prj', b_prj_hndl, b_prj_indx)
      if (.not.value) 
     > call errquit('kbppv3:out of heap memory',0,MA_ERR)


*     **** preparation of constants ****
      nfft1=ngrid(1)
      nfft2=ngrid(2)
      nfft3=ngrid(3)
      call setup_kbpp(nfft1,nfft2,nfft3,unita,unitg,dbl_mb(G_indx))
      filter = control_kbpp_filter()

      if (control_kbpp_ray()) then
        !**** allocate memory for rays ****
        nray = kbpp_calc_nray(nfft1,nfft2,nfft3,unita)

        value =           MA_alloc_get(mt_dbl,nray,
     >                  'G_ray',G_ray_hndl,G_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,2*nray,
     >                  'vl_ray',vl_ray_hndl,vl_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,2*nray*(lmax+1),
     >                  'vnl_ray',vnl_ray_hndl,vnl_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,2*nray*2,
     >              'rho_sc_k_ray',rho_sc_k_ray_hndl,rho_sc_k_ray_indx)
        value = value.and.MA_alloc_get(mt_dbl,nray,
     >                  'tmp_ray',tmp_ray_hndl,tmp_ray_indx)
        if (.not.value) 
     >   call errquit('kbppv3:out of heap memory',0,MA_ERR)

        call kbpp_generate_G_ray(nfft1,nfft2,nfft3,
     >                         unita,
     >                         dbl_mb(G_ray_indx))
        call integrate_kbppv3_new(version,rlocal,
     >                      nrho,drho,lmax,locp,zv,
     >                                dbl_mb(vp_indx),
     >                                dbl_mb(wp_indx),
     >                                dbl_mb(rho_indx),
     >                                dbl_mb(f_indx),
     >                                dbl_mb(cs_indx),
     >                                dbl_mb(sn_indx),
     >                      nfft1,nfft2,nfft3,lmmax,
     >                                dbl_mb(G_indx),
     >                                dbl_mb(vl_indx),
     >                                dbl_mb(vnl_indx),
     >                                int_mb(n_prj_indx),
     >                                int_mb(l_prj_indx),
     >                                int_mb(m_prj_indx),
     >                                int_mb(b_prj_indx),
     >                                dbl_mb(vnlnrm_indx),
     >                                semicore,
     >                                dbl_mb(sc_r_indx),
     >                                dbl_mb(sc_k_indx),
     >                      nray,
     >                                dbl_mb(G_ray_indx),
     >                                dbl_mb(vl_ray_indx),
     >                                dbl_mb(vnl_ray_indx),
     >                                dbl_mb(rho_sc_k_ray_indx),
     >                                dbl_mb(tmp_ray_indx),
     >                                filter,
     >                      ierr)
        value = MA_free_heap(tmp_ray_hndl)
        value = value.and.MA_free_heap(rho_sc_k_ray_hndl)
        value = value.and.MA_free_heap(vnl_ray_hndl)
        value = value.and.MA_free_heap(vl_ray_hndl)
        value = value.and.MA_free_heap(G_ray_hndl)
        if (.not.value) 
     >   call errquit('kbppv3:Error freeing memory',0,MA_ERR)

      else
        call integrate_kbppv3(version,rlocal,
     >                      nrho,drho,lmax,locp,zv,
     >                                dbl_mb(vp_indx),
     >                                dbl_mb(wp_indx),
     >                                dbl_mb(rho_indx),
     >                                dbl_mb(f_indx),
     >                                dbl_mb(cs_indx),
     >                                dbl_mb(sn_indx),
     >                      nfft1,nfft2,nfft3,lmmax,
     >                                dbl_mb(G_indx),
     >                                dbl_mb(vl_indx),
     >                                dbl_mb(vnl_indx),
     >                                int_mb(n_prj_indx),
     >                                int_mb(l_prj_indx),
     >                                int_mb(m_prj_indx),
     >                                int_mb(b_prj_indx),
     >                                dbl_mb(vnlnrm_indx),
     >                                semicore,
     >                                dbl_mb(sc_r_indx),
     >                                dbl_mb(sc_k_indx),
     >                      ierr)
      end if



      if ((taskid.eq.MASTER).and.(oprint)) then
      write(luout,*) "     ********************************************"
      write(luout,*) "     *                                          *"
      write(luout,*) "     *     KBPPV3 - Pseudopotential Formatter   *"
      write(luout,*) "     *                                          *"
      write(luout,*) "     *      version last updated 4/15/99        *"
      write(luout,*) "     *                                          *"
      write(luout,*) "     * This code was written by Eric J. Bylaska *"
      write(luout,*) "     * and was based upon algorithms and code   *"
      write(luout,*) "     * developed by the group of                *"
      write(luout,*) "     * Prof. John H. Weare                      *"
      write(luout,*) "     ********************************************"
      call nwpw_message(1)
      write(luout,*)
      write(luout,*) "Pseudpotential Data"
      write(luout,*) "-------------------"
      write(luout,*) "  atom     :",atom
      write(luout,*) "  charge   :",zv
      write(luout,*) "  mass no. :",amass
      write(luout,*) "  highest angular component      :",lmax0
      write(luout,*) "  highest angular component used :",lmax
      write(luout,*) "  local potential used           :",locp
      if (version.eq.4) 
     >   write(luout,*) "  aperiodic cutoff radius        :",rlocal
      write(luout,111) "  cutoffs: ",(rc(i), i=0,lmax)
      if (semicore) then
        write(luout,*)
        write(luout,115) "  semi-core charge included, rcore:",rcore
        do i=1,nrho
           dbl_mb(f_indx+i-1) = dbl_mb(sc_r_indx+i-1)
     >                        * dbl_mb(rho_indx+i-1)**2
        end do
        core_charge=16.0d0*datan(1.0d0)*SIMP(nrho,dbl_mb(f_indx),drho)
        write(luout,115) "  semi-core charge                :",
     >                   core_charge,dbl_mb(sc_k_indx)
         do i=1,nrho
           dbl_mb(f_indx+i-1) = dbl_mb(sc_r_indx+i-1+nrho)
     >                        * dbl_mb(rho_indx+i-1)**2
         end do
         core_charge=16.0d0*datan(1.0d0)*SIMP(nrho,dbl_mb(f_indx),drho)
         write(luout,115) "  Semi-core charge gradient       :",
     >                core_charge

      end if
      write(luout,*)
      write(luout,*) "Simulation Cell"
      write(luout,*) "---------------"
      if (version.eq.3) write(luout,112) "  boundry: periodic"
      if (version.eq.4) write(luout,112) "  boundry: aperiodic"
      write(luout,113) "  ngrid  :",ngrid
      write(luout,114) "  unita  :",unita(1,1),unita(2,1),unita(3,1)
      write(luout,114) "          ",unita(1,2),unita(2,2),unita(3,2)
      write(luout,114) "          ",unita(1,3),unita(2,3),unita(3,3)
      write(luout,*)
  111 format(a,10f10.3)
  112 format(a)
  113 format(a,3I4)
  114 format(a,3F10.3)
  115 format(a,2E14.6)
      end if

      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(formatted_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      if (mprint) then
      write(luout,*)
      write(luout,*) "Generated formatted_filename: ",full_filename(1:l)
      if (filter) write(luout,*) "- filtering pseudopotential -"
      !write(luout,*)
      end if
      call openfile(2,full_filename,l,'w',l)     

         call cwrite(2,comment,80)
         psp_type = 0
         call iwrite(2,psp_type,1)
         call iwrite(2,version,1)
         call iwrite(2,ngrid,3)
         call dwrite(2,unita,9)
         call cwrite(2,atom,2)
         call dwrite(2,amass,1)
         call dwrite(2,zv,1)
         call iwrite(2,lmax,1)
         call iwrite(2,locp,1)
     
         nmax = 1
         call iwrite(2,nmax,1)
         call dwrite(2,rc,lmax+1)

         call iwrite(2,nprj,1)
         if (nprj.gt.0) then
         call iwrite(2,int_mb(n_prj_indx),nprj)
         call iwrite(2,int_mb(l_prj_indx),nprj)
         call iwrite(2,int_mb(m_prj_indx),nprj)
         call iwrite(2,int_mb(b_prj_indx),nprj)
         call dwrite(2,dbl_mb(vnlnrm_indx),(lmax+1))
         end if

         if (version.eq.4) call dwrite(2,rlocal,1)
         call dwrite(2,rcore,1)

         call dwrite(2,dbl_mb(vl_indx),nsize)
         if (nprj.gt.0) then
            call dwrite(2,dbl_mb(vnl_indx),nsize*lmmax)
         end if

         if (semicore) then
           call dwrite(2,dbl_mb(sc_k_indx),4*nsize)
         end if
      call closefile(2)
      end if
     

*     **** free heap space ****
      value = MA_free_heap(rho_hndl)
      value = value.and.MA_free_heap(vp_hndl)
      value = value.and.MA_free_heap(wp_hndl)
      value = value.and.MA_free_heap(sc_r_hndl)
      value = value.and.MA_free_heap(sc_k_hndl)
      value = value.and.MA_free_heap(f_hndl)
      value = value.and.MA_free_heap(cs_hndl)
      value = value.and.MA_free_heap(sn_hndl)

      value = value.and.MA_free_heap(vl_hndl)
      value = value.and.MA_free_heap(vnl_hndl)
      value = value.and.MA_free_heap(vnlnrm_hndl)
      value = value.and.MA_free_heap(G_hndl)
      value = value.and.MA_free_heap(n_prj_hndl)
      value = value.and.MA_free_heap(l_prj_hndl)
      value = value.and.MA_free_heap(m_prj_hndl)
      value = value.and.MA_free_heap(b_prj_hndl)
      if (.not.value) 
     > call errquit('kbppv3:Error freeing memory',0,MA_ERR)

      
      if ((taskid.eq.MASTER).and.(oprint)) call nwpw_message(4)

      kbppv3 = value
      return

 9999 call errquit('kbppv3:Error reading psp_filename',0, DISK_ERR)
      kbppv3 = value
      return

      END

      subroutine read_vpwp(unit,nrho,lmax,rho,vp,wp)
      implicit none
      integer unit
      integer nrho,lmax
      double precision rho(nrho)
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:lmax)

#include "errquit.fh"

      integer i,j


      do i=1,nrho
        read(unit,*,ERR=9999,END=9999) rho(i),(vp(i,j),j=0,lmax)
      end do
      do i=1,nrho
        read(unit,*,ERR=9999,END=9999) rho(i),(wp(i,j),j=0,lmax)
      end do

c     read(unit,*,ERR=9999,END=9999)(rho(i),(vp(i,j),j=0,lmax),i=1,nrho)
c     read(unit,*,ERR=9999,END=9999)(rho(i),(wp(i,j),j=0,lmax),i=1,nrho)

c     read(11,*,ERR=9116,END=9117)(RHO(I),(VP(I,J),J=0,LMAX),I=1,NRHO)
c     read(11,*,ERR=9116,END=9117)(RHO(I),(WP(I,J),J=0,LMAX),I=1,NRHO)

      
      return
 9999 call errquit('kbppv3:Error reading psp_filename',0, DISK_ERR)
      end


      subroutine read_vpwp_extra(unit,nrho,lmax,lmax0,nextra,rho,vp,wp)
      implicit none           
      integer unit
      integer nrho,lmax,lmax0,nextra
      double precision rho(nrho)
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:(lmax+nextra))
     
#include "errquit.fh"
      
      integer i,j             
      real*8  tmp(0:20)

     
      do i=1,nrho
        read(unit,*,ERR=9999,END=9999) rho(i),(vp(i,j),j=0,lmax)
      end do
      do i=1,nrho              
        read(unit,*,ERR=9999,END=9999) rho(i),(tmp(j),j=0,lmax0+nextra)
        do j=0,lmax
           wp(i,j) = tmp(j)
        end do
        do j=1,nextra
           wp(i,j+lmax) = tmp(j+lmax0)
        end do
      end do
      return
 9999 call errquit('kbppv3:Error reading psp_filename',0, DISK_ERR)
      end


      subroutine read_vpwpup(unit,nrho,lmax,rho,vp,wp,up)
      implicit none
      integer unit
      integer nrho,lmax
      double precision rho(nrho)
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:lmax)
      double precision up(nrho,0:lmax)

#include "errquit.fh"

      integer i,j

      do i=1,nrho
        read(unit,*,ERR=9999,END=9999) rho(i),(vp(i,j),j=0,lmax)
      end do
      do i=1,nrho
        read(unit,*,ERR=9999,END=9999) rho(i),
     >                                 (wp(i,j),j=0,lmax),
     >                                 (up(i,j),j=0,lmax)
      end do
      
      return
 9999 call errquit('kbppv3:Error reading psp_filename',0, DISK_ERR)
      end


      subroutine read_semicore(unit,isemicore,rcore,nrho,rho_sc)
      implicit none
      integer unit
      integer isemicore
      double precision rcore
      integer nrho
      double precision rho_sc(nrho,2),rr

#include "errquit.fh"

      integer i

      read(unit,*,ERR=8887,END=8887) rcore

*     **** read density ****
      do i=1,nrho
        read(unit,*,ERR=8889,END=8889) rr,rho_sc(i,1)
      end do

*     **** read density gradient ****
      do i=1,nrho
        read(unit,*,ERR=8889,END=8889) rr,rho_sc(i,2)
      end do

      isemicore = 1
      return

 8887 isemicore = 0
      rcore = 0.0d0
      return

 8889 call errquit('kbppv3:Error reading psp_filename, in semicore',0,
     &       DISK_ERR)
      end

*
* $Id: lcao_generate_vnlmatrix.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      subroutine lcao_generate_vnlmatrix(vnlmatrix,phi1,phi2)
      implicit none
      integer vnlmatrix
      complex*16 phi1(*)
      complex*16 phi2(*)

#include "mafdecls.fh"
#include "global.fh"

*     **** local variables ****
      logical move,frac
      integer i,j,nbasis,npack1
      integer ne(2),ispin
      real*8  sum,fion(3),occ(1)

*     ***** external functions ****
      integer  aorbs_nbasis
      external aorbs_nbasis

      
      call Pack_npack(1,npack1)
      nbasis = aorbs_nbasis()
      ispin = 1
      ne(1) = 1
      ne(2) = 0
      move =.false.
      frac = .false.
      do j=1,nbasis

*        **** get phi2 ****
         call aorbs_aorb(j,phi1)
         call Pack_c_Zero(1,phi2)
         call v_nonlocal(ispin,ne,phi1,phi2,move,fion,frac,occ)

         do i=1,j

*           **** get phi1 ****
            call aorbs_aorb(i,phi1)
            call Pack_cc_dot(1,phi1,phi2,sum)
            sum = -sum
            call ga_fill_patch(vnlmatrix,i,i,j,j,sum)
            call ga_fill_patch(vnlmatrix,j,j,i,i,sum)
         end do
      end do

      return
      end

      logical function pre_wrtxyz(lfnout,lfnxyz,filxyz,lfnqqq,filqqq,
     + num,mat,isat,xs,qsa,msa,nsa,box)
c
c $Id: pre_wrtxyz.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
      character*2 pre_atnam
      external pre_atnam
c
      integer lfnout,lfnxyz,lfnqqq,msa,nsa,mat
      character*255 filxyz,filqqq
      integer num(mat)
      integer isat(msa)
      real*8 xs(3,msa),qsa(msa),box(3)
c
      integer length
c
      integer i,k
c
c     open XYZ file
c
      length=index(filxyz,' ')-1
      open(unit=lfnxyz,file=filxyz(1:length),form='formatted',
     + status='unknown',err=9999)
c
      write(lfnxyz,1000) nsa
 1000 format('* Coordinates in XYZ format',/,i5)  
      do 1 i=1,nsa
      write(lfnxyz,1001) pre_atnam(num(isat(i))),(1.0d1*xs(k,i),k=1,3)
 1001 format(a2,3f12.6)
    1 continue
      close(unit=lfnxyz)
c
      if(util_print('files',print_default)) then
      write(lfnout,1002) filxyz(1:length)
 1002 format(' Created xyz',t40,a,/)
      endif
c
      filqqq=filxyz
      i=index(filxyz,'.xyz')
      if(i.gt.1) then
      filqqq(i:i+5)='.xyzq '
      else
      filqqq=filxyz(1:length)//'_q'
      endif
c
      length=index(filqqq,' ')-1
      open(unit=lfnqqq,file=filqqq(1:length),form='formatted',
     + status='unknown',err=9999)
c
      write(lfnqqq,2000) nsa,1,box
 2000 format(i7,i3,3f12.6)
      do 2 i=1,nsa
      write(lfnqqq,2001) pre_atnam(num(isat(i))),(1.0d1*xs(k,i),k=1,3),
     + qsa(i)
 2001 format(a2,4f12.6)
    2 continue
      close(unit=lfnqqq)
c
      if(util_print('files',print_default)) then
      write(lfnout,2002) filqqq(1:length)
 2002 format(' Created q',t40,a,/)
      endif
c
      pre_wrtxyz=.true.
      return
c
 9999 continue
      pre_wrtxyz=.false.
      return
      end

      subroutine ccsd_qr_beta(rtdb,d_a0,d_b0,d_f1,d_v2,d_d1,
     1           d_t1,d_t2,d_y1,d_y2,d_yr1,d_yr2,d_tr1,d_tr2,
     2           k_a0_offset,k_b0_offset,
     3           k_f1_offset,k_v2_offset,k_d1_offset,
     4           k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset,
     5           k_tr1_offset,k_tr2_offset,k_yr1_offset,k_yr2_offset,
     6           size_yr1,size_yr2)
      implicit none
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_prop.fh"
#include "tce_restart.fh"
c
      integer rtdb
      integer i,j,dummy,axis,dynaxis,dynfreq
      integer omegacount,omegasign
      integer irrep_g
      parameter (irrep_g=0)
      integer d_a0,d_b0,d_f1,d_v2,d_d1(3)
      integer d_t1,d_t2,d_y1,d_y2
      integer d_tr1(9),d_tr2(9),d_yr1(6),d_yr2(6)
      integer k_a0_offset,k_b0_offset
      integer k_f1_offset,k_v2_offset,k_d1_offset(3)
      integer k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset
      integer k_tr1_offset(3),k_tr2_offset(3)
      integer k_yr1_offset(3),k_yr2_offset(3)
      integer size_yr1(3),size_yr2(3)
      integer d_rr1(3),d_rr2(3)
      integer sym_abelian_axis
      external sym_abelian_axis
      double precision omega
      logical nodezero,guess
      character*4 irrepname
      character*3 axisname(3)  ! Axis
      data axisname/'X','Y','Z'/
c
      nodezero=(ga_nodeid().eq.0)
c
#ifdef DEBUG_PRINT
      if (nodezero) write(6,*) 'top of ccsd_qr_beta'
      call util_flush(6)
#endif
c
      do omegacount=1,bnumfreq
        omega = bfreq(omegacount)
        if (omega.eq.(0.0d0)) then
          dynfreq = 1
        else
          dynfreq = 2
        endif
        do axis = 1, 3
          if (respaxis(axis)) then
            irrep_d=sym_abelian_axis(geom,axis)
            call sym_irrepname(geom,irrep_d+1,irrepname)
            if (nodezero.and.util_print('mod1',print_default)) then
              write(LuOut,*)
              write(LuOut,9440) axisname(axis),irrepname
            endif
            irrep_o=irrep_d
            irrep_x=irrep_d
c
            if (skip_tr) then
              if (nodezero) write(LuOut,9700)
            else
              do omegasign=1,dynfreq
                if (omegasign.eq.1) then
                  omega = (1.0d0)*bfreq(omegacount)
                  dynaxis = 0
                elseif (omegasign.eq.2) then
                  omega = (-1.0d0)*bfreq(omegacount)
                  dynaxis = 3
                endif
c
                if (nodezero) write(LuOut,9431) omega
c
                guess = ((omegacount.eq.1).and.guess_qr_real)
                call ccsd_qr_iter(guess,axis,dynaxis,omega,
     1               d_f1,d_v2,d_d1,d_t1,d_t2,d_y1,d_y2,
     2               d_tr1,d_tr2,d_yr1,d_yr2,k_f1_offset,k_v2_offset,
     3               k_d1_offset,k_t1_offset,k_t2_offset,
     4               k_y1_offset,k_y2_offset,k_tr1_offset,k_tr2_offset,
     5               k_yr1_offset,k_yr2_offset,size_yr1,size_yr2)
c
              enddo ! omegasign loop
            endif ! skip_tr
          endif ! respaxis(axis)
        enddo ! axis loop
c
#ifdef DEBUG_PRINT
        if (nodezero) write(6,*) 'calling ccsd_qr_alpha_eval'
        call util_flush(6)
#endif
c
        call ccsd_qr_alpha_eval(omega,d_a0,d_f1,d_v2,d_d1,
     1       d_t1,d_t2,d_y1,d_y2,d_tr1,d_tr2,d_yr1,d_yr2,
     2       k_a0_offset,k_f1_offset,k_v2_offset,k_d1_offset,
     4       k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset,
     5       k_tr1_offset,k_tr2_offset,k_yr1_offset,k_yr2_offset)
c
#ifdef DEBUG_PRINT
        if (nodezero) write(6,*) 'calling ccsd_qr_beta_eval'
        call util_flush(6)
#endif
c
        if (nopolar) then
          if (nodezero) write(LuOut,9701)
        else
          call ccsd_qr_beta_eval(omega,d_b0,d_f1,d_v2,d_d1,
     1         d_t1,d_t2,d_y1,d_y2,d_tr1,d_tr2,d_yr1,d_yr2,
     2         k_b0_offset,k_f1_offset,k_v2_offset,k_d1_offset,
     4         k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset,
     5         k_tr1_offset,k_tr2_offset,k_yr1_offset,k_yr2_offset)
        endif
c
      enddo ! omegacount loop
c
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9082 format(1x,'amplitude norm of ',A9,' = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
 9120 format(1x,A)
 9121 format(/,1x,A)
 9122 format(1x,A,i4)
 9420 format(1x,i4,f25.13,2f8.1)
 9431 format(/,1x,'Frequency = ',f15.7,' / au')
 9440 format(1x,A3,' axis ( ',A4,'symmetry)')
 9700 format(1x,'Skipping CCSD-QR iterations')
 9701 format(1x,'Skipping evaluation of hyperpolarizability by request')
      return
      end


      subroutine ccsd_qr_iter(guess,axis,dynaxis,omega,
     1           d_f1,d_v2,d_d1,d_t1,d_t2,d_y1,d_y2,
     2           d_tr1,d_tr2,d_yr1,d_yr2,
     3           k_f1_offset,k_v2_offset,k_d1_offset,
     4           k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset,
     5           k_tr1_offset,k_tr2_offset,k_yr1_offset,k_yr2_offset,
     6           size_yr1,size_yr2)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
c#include "tce_diis.fh"
#include "tce_prop.fh"
#include "tce_restart.fh"
c
      integer i,j,dummy,axis,dynaxis,iter
      integer irrep_g
      parameter (irrep_g=0)
      integer d_f1,d_v2,d_d1(3)
      integer d_t1,d_t2,d_y1,d_y2,d_b1(3),d_b2(3)
      integer d_tr1(9),d_tr2(9),d_yr1(6),d_yr2(6)
      integer d_yrr1(3),d_yrr2(3)
      integer k_f1_offset,k_v2_offset,k_d1_offset(3)
      integer k_t1_offset,k_t2_offset
      integer k_y1_offset,k_y2_offset
      integer k_tr1_offset(3),k_tr2_offset(3)
      integer k_yr1_offset(3),k_yr2_offset(3)
      integer size_yr1(3),size_yr2(3)
      integer sym_abelian_axis
      external sym_abelian_axis
      double precision omega
      double precision cpu, wall
      double precision residual
      double precision rr1            ! Residual tr1
      double precision rr2            ! Residual tr2
      double precision ddotfile
      external ddotfile
      logical nodezero,guess
      character*4 irrepname
      character*255 filename
      character*5 yrr1filename(3) ! File name stub
      data yrr1filename/'yrr1x','yrr1y','yrr1z'/
      character*5 yrr2filename(3) ! File name stub
      data yrr2filename/'yrr2x','yrr2y','yrr2z'/
      character*3 b1filename(3) ! File name stub
      data b1filename/'b1x','b1y','b1z'/
      character*3 b2filename(3) ! File name stub
      data b2filename/'b2x','b2y','b2z'/
c
      nodezero=(ga_nodeid().eq.0)
c
c     form and store constant RHS of linear equations
c
      if (nodezero) write(LuOut,9120) 'Forming RHS'
      cpu=-util_cpusec()
      wall=-util_wallsec()
c
      call tce_filename(b1filename(axis),filename)
      call createfile(filename,d_b1(axis),size_yr1(axis))
      call tce_zero(d_b1(axis),size_yr1(axis))
c
      call tce_filename(b2filename(axis),filename)
      call createfile(filename,d_b2(axis),size_yr2(axis))
      call tce_zero(d_b2(axis),size_yr2(axis))
c
      if (save_lr(1)) then
        if(nodezero) then
          write(LuOut,*) 'Saving QR-B1 now...'
        endif
        call yr1_restart_save(d_b1(axis),k_yr1_offset(axis),
     1       size_yr1(axis),axis,handle_qb1(axis),irrep_d)
      endif
      if (save_lr(2)) then
        if(nodezero) then
          write(LuOut,*) 'Saving QR-B2 now...'
        endif
        call yr2_restart_save(d_b2(axis),k_yr2_offset(axis),
     1       size_yr2(axis),axis,handle_qb2(axis),irrep_d)
      endif
c
      irrep_y=irrep_g ! using Lambda(0) amplitudes
      call ccsd_y_o1(d_b1(axis),d_d1(axis),d_t1,d_t2,
     1     d_y1,d_y2,k_yr1_offset(axis),
     2     k_d1_offset(axis),k_t1_offset,k_t2_offset,
     3     k_y1_offset,k_y2_offset)
      call ccsd_y_tr1(d_f1,d_b1(axis),d_t1,d_t2,d_v2,
     1     d_tr1(axis+dynaxis),d_tr2(axis+dynaxis),d_y1,
     2     d_y2,k_f1_offset,k_yr1_offset(axis),
     3     k_t1_offset,k_t2_offset,k_v2_offset,
     4     k_tr1_offset(axis),k_tr2_offset(axis),
     5     k_y1_offset,k_y2_offset)
      call ccsd_y_o2(d_b2(axis),d_d1(axis),d_t1,
     1     d_y1,d_y2,k_yr2_offset(axis),
     2     k_d1_offset(axis),k_t1_offset,
     3     k_y1_offset,k_y2_offset)
      call ccsd_y_tr2(d_f1,d_b2(axis),d_t1,d_v2,
     1     d_tr1(axis+dynaxis),d_tr2(axis+dynaxis),d_y1,
     2     d_y2,k_f1_offset,k_yr2_offset(axis),
     3     k_t1_offset,k_v2_offset,
     4     k_tr1_offset(axis),k_tr2_offset(axis),
     5     k_y1_offset,k_y2_offset)
c
      call reconcilefile(d_b1(axis),size_yr1(axis))
      call reconcilefile(d_b2(axis),size_yr2(axis))
c
      if (guess) then
        if (nodezero) write(6,9121) 'Initial guess y = b/Adiag'
c
        call tce_zero(d_yr1(axis),size_yr1(axis))
        call tce_zero(d_yr2(axis),size_yr2(axis))
c
        irrep_y = irrep_d
        call tce_jacobi_lr1(d_b1(axis),d_yr1(axis),k_yr1_offset(axis),
     1                      0.0d0,0.0d0)
        call tce_jacobi_lr2(d_b2(axis),d_yr2(axis),k_yr2_offset(axis),
     1                      0.0d0,0.0d0)
      endif
c
      cpu=cpu+util_cpusec()
      wall=wall+util_wallsec()
      if (nodezero) write(LuOut,9020) cpu,wall
c
      call tce_diis_init()
      do iter=1,maxiter
        cpu=-util_cpusec()
        wall=-util_wallsec()
        if (nodezero.and.(iter.eq.1)) write(LuOut,9400) "CCSD-YR"
c
        call tce_filename(yrr1filename(axis),filename)
        call createfile(filename,d_yrr1(axis),size_yr1(axis))
        call copyfile(d_b1(axis),d_yrr1(axis),size_yr1(axis))
        call daxpyfile(1,(1.0d0)*omega,d_yr1(axis+dynaxis),
     1       d_yrr1(axis),size_yr1(axis))
c
        irrep_y=irrep_d ! using Lambda(1) amplitudes
        call eomccsd_y1(d_f1,d_yrr1(axis),d_t1,d_t2,d_v2,
     1       d_yr1(axis+dynaxis),d_yr2(axis+dynaxis),k_f1_offset,
     2       k_yr1_offset(axis),k_t1_offset,k_t2_offset,
     3       k_v2_offset,k_yr1_offset(axis),k_yr2_offset(axis))
c
        call tce_filename(yrr2filename(axis),filename)
        call createfile(filename,d_yrr2(axis),size_yr2(axis))
        call copyfile(d_b2(axis),d_yrr2(axis),size_yr2(axis))
        call daxpyfile(1,(1.0d0)*omega,d_yr2(axis+dynaxis),
     1       d_yrr2(axis),size_yr2(axis))
c
        irrep_y=irrep_d ! using Lambda(1) amplitudes
        call eomccsd_y2(d_f1,d_yrr2(axis),d_t1,d_t2,d_v2,
     1       d_yr1(axis+dynaxis),d_yr2(axis+dynaxis),k_f1_offset,
     2       k_yr2_offset(axis),k_t1_offset,k_t2_offset,
     3       k_v2_offset,k_yr1_offset(axis),k_yr2_offset(axis))
c
        call reconcilefile(d_yrr1(axis),size_yr1(axis))
        call reconcilefile(d_yrr2(axis),size_yr2(axis))
c
        rr1 = ddotfile(d_yrr1(axis),d_yrr1(axis),size_yr1(axis))
        rr2 = ddotfile(d_yrr2(axis),d_yrr2(axis),size_yr2(axis))
c
        residual = max(rr1,rr2)
        cpu=cpu+util_cpusec()
        wall=wall+util_wallsec()
        if (nodezero) write(LuOut,9420) iter,residual,cpu,wall
        if (residual .lt. thresh) then
          if (nodezero) then
            write(LuOut,9410)
          endif
          if (ampnorms) then
            rr1 = ddotfile(d_yr1(axis+dynaxis),d_yr1(axis+dynaxis),
     1                     size_yr1(axis))
            rr1 = ddotfile(d_yr2(axis+dynaxis),d_yr2(axis+dynaxis),
     1                     size_yr2(axis))
            if (nodezero) then
              write(LuOut,9082) "Lambda(1) singles",rr1
              write(LuOut,9082) "Lambda(1) doubles",rr2
            endif
          endif
c
          call deletefile(d_yrr2(axis))
          call deletefile(d_yrr1(axis))
          call tce_diis_tidy()
          if (save_lr(1)) then
            if(nodezero) then
              write(LuOut,*) 'Saving L1(1) now...'
            endif
            call yr1_restart_save(d_yr1(axis),k_yr1_offset(axis),
     1           size_yr1(axis),axis,handle_yr1(axis),irrep_d)
          endif
          if (save_lr(2)) then
            if(nodezero) then
              write(LuOut,*) 'Saving L2(1) now...'
            endif
            call yr2_restart_save(d_yr2(axis),k_yr2_offset(axis),
     1           size_yr2(axis),axis,handle_yr2(axis),irrep_d)
          endif
          call deletefile(d_b2(axis))
          call deletefile(d_b1(axis))
          return
        endif
        if (save_lr(1).and.(mod(iter,save_interval).eq.0)) then
          if(nodezero) then
            write(LuOut,*) 'Saving L1(1) now...'
          endif
          call yr1_restart_save(d_yr1(axis),k_yr1_offset(axis),
     1         size_yr1(axis),axis,handle_yr1(axis),irrep_d)
        endif
        if (save_lr(2).and.(mod(iter,save_interval).eq.0)) then
          if(nodezero) then
            write(LuOut,*) 'Saving L2(1) now...'
          endif
          call yr2_restart_save(d_yr2(axis),k_yr2_offset(axis),
     1   size_yr2(axis),axis,handle_yr2(axis),irrep_d)
        endif
c        write(LuOut,*) "before tce_diis2"
        irrep_y=irrep_d
        call tce_diis2(.true.,iter,.true.,.true.,.false.,.false.,
     1       d_yrr1(axis),d_yr1(axis+dynaxis),k_yr1_offset(axis),
     2       size_yr1(axis),
     3       d_yrr2(axis),d_yr2(axis+dynaxis),k_yr2_offset(axis),
     4       size_yr2(axis),
     5       dummy,dummy,dummy,dummy,
     6       dummy,dummy,dummy,dummy,omega)
c       write(LuOut,*) "after tce_diis2"
        call deletefile(d_yrr2(axis))
        call deletefile(d_yrr1(axis))
        if (nodezero) call util_flush(LuOut)
      enddo ! iter loop
      call deletefile(d_b2(axis))
      call deletefile(d_b1(axis))
      call errquit('ccsd_qr_iter: maxiter exceeded',iter,CALC_ERR)
c
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9082 format(1x,'amplitude norm of ',A9,' = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
 9120 format(1x,A)
 9121 format(1x,A)
 9122 format(1x,A,i4)
 9400 format(/,1x,A,' iterations',/,
     1  1x,'---------------------------------------------',/
     2  1x,'Iter          Residuum            Cpu    Wall',/
     3  1x,'---------------------------------------------')
 9410 format(
     1  1x,'---------------------------------------------',/
     2  1x,'Iterations converged')
 9420 format(1x,i4,f25.13,2f8.1)
 9431 format(/,1x,'Frequency = ',f15.7,' / au')
 9440 format(1x,A3,' axis ( ',A4,'symmetry)')
      return
      end


      subroutine ccsd_qr_alpha_eval(omega,d_a0,d_f1,d_v2,d_d1,
     1           d_t1,d_t2,d_y1,d_y2,d_tr1,d_tr2,d_yr1,d_yr2,
     2           k_a0_offset,k_f1_offset,k_v2_offset,k_d1_offset,
     3           k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset,
     4           k_tr1_offset,k_tr2_offset,k_yr1_offset,k_yr2_offset)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_prop.fh"
c
      integer i,j,dummy,axis,axisA,axisB
      integer irrep_g
      parameter (irrep_g=0)
      integer d_a0,d_f1,d_v2,d_d1(3)
      integer d_t1,d_t2,d_y1,d_y2
      integer k_a0_offset
      integer k_f1_offset,k_v2_offset,k_d1_offset(3)
      integer k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset
      integer d_tr1(9),d_tr2(9),d_yr1(6),d_yr2(6)
      integer k_tr1_offset(3),k_tr2_offset(3)
      integer k_yr1_offset(3),k_yr2_offset(3)
      integer sym_abelian_axis
      external sym_abelian_axis
      double precision omega
      double precision cpu, wall
      double precision residual
      double precision alpha1,alpha2,alpha3,alpha4
      double precision au2ang   ! Conversion factor from bohr to Angstrom
      double precision au2ang3  ! Conversion factor from bohr^3 to Angstrom^3
      double precision auXnm    ! Conversion factor from a.u. (frequency) to nm (wavelength)
      double precision alpha(3,3)       ! Dipole polarizability tensor
      double precision alphacopy(3,3)   ! Dipole polarizability tensor copy
      double precision alphaiso         ! Isotropic dipole polarizability
      double precision alphaani         ! Anisotropic dipole polarizability
      double precision alphaevr(3)      ! Dipole polarizability tensor eigenvalues (real)
      double precision alphaevi(3)      ! Dipole polarizability tensor eigenvalues (imag)
      double precision aeigvec(3,3)     ! dummy dgeev eigenvectors
      double precision ddotfile
      external ddotfile
      parameter (auXnm=45.563353d0)
      parameter (au2ang=5.29177249d-01)
      parameter (au2ang3=au2ang*au2ang*au2ang)
      logical nodezero
      character*4 irrepname
      character*3 axisname(3)  ! Axis
      data axisname/'X','Y','Z'/
      character*255 filename
c
      nodezero=(ga_nodeid().eq.0)
c
#ifdef DEBUG_PRINT
      if (nodezero) write(6,*) 'top of ccsd_qr_alpha_eval'
      call util_flush(6)
#endif
c
c CCSD-QR evaluation step
c
      cpu=-util_cpusec()
      wall=-util_wallsec()
      do axisA = 1, 3
        irrep_a=sym_abelian_axis(geom,axisA)
        do axisB = 1, axisA
          irrep_b=sym_abelian_axis(geom,axisB)
          alpha(axisA,axisB)=0.0d0
          if ( respaxis(axisA).and.respaxis(axisB) ) then
c
#ifdef DEBUG_PRINT
            if (nodezero) then
              write(LuOut,*) "axisA = ",axisA
              write(LuOut,*) "axisB = ",axisB
              call util_flush(6)
            endif
#endif
c
            alpha1=0.0d0
            alpha2=0.0d0
            alpha3=0.0d0
            alpha4=0.0d0
            call tce_filename('a0',filename)
            call createfile(filename,d_a0,1)
            call tce_zero(d_a0,1)
c
            irrep_y=irrep_g
            irrep_d=irrep_a
            irrep_tr=irrep_b
c
            call alpha_1(d_d1(axisA),d_a0,d_t1,d_t2,
     1           d_tr1(axisB),d_tr2(axisB),
     2           d_y1,d_y2,k_d1_offset(axisA),k_a0_offset,
     4           k_t1_offset,k_t2_offset,k_tr1_offset(axisB),
     5           k_tr2_offset(axisB),k_y1_offset,k_y2_offset)
            call reconcilefile(d_a0,1)
            call get_block(d_a0,alpha1,1,0)
            call tce_zero(d_a0,1)
c
            if (omega.eq.0.0d0) then
              alpha2=alpha1
            else
              call alpha_1(d_d1(axisA),d_a0,d_t1,d_t2,
     1             d_tr1(axisB+3),d_tr2(axisB+3),
     2             d_y1,d_y2,k_d1_offset(axisA),k_a0_offset,
     4             k_t1_offset,k_t2_offset,k_tr1_offset(axisB),
     5             k_tr2_offset(axisB),k_y1_offset,k_y2_offset)
              call reconcilefile(d_a0,1)
              call get_block(d_a0,alpha2,1,0)
              call tce_zero(d_a0,1)
            endif
c
            irrep_o=irrep_a
            irrep_y=irrep_b
c
            call alpha_2_yr(d_a0,d_d1(axisA),d_t1,d_t2,
     1           d_yr1(axisB),d_yr2(axisB),
     2           k_a0_offset,k_d1_offset(axisA),k_t1_offset,
     3           k_t2_offset,k_yr1_offset(axisB),k_yr2_offset(axisB))
            call reconcilefile(d_a0,1)
            call get_block(d_a0,alpha3,1,0)
            call tce_zero(d_a0,1)
c
            if (omega.eq.0.0d0) then
              alpha4=alpha3
            else
              call alpha_2_yr(d_a0,d_d1(axisA),d_t1,d_t2,
     1             d_yr1(axisB+3),d_yr2(axisB+3),
     2             k_a0_offset,k_d1_offset(axisA),k_t1_offset,
     3             k_t2_offset,k_yr1_offset(axisB),k_yr2_offset(axisB))
              call reconcilefile(d_a0,1)
              call get_block(d_a0,alpha4,1,0)
              call tce_zero(d_a0,1)
            endif
c
            alpha(axisA,axisB)=(-0.5d0)*(alpha1+alpha2+alpha3+alpha4)
            call deletefile(d_a0)
c
#ifdef DEBUG_PRINT
            if (nodezero) then
              write(LuOut,*) "alpha1 = ",alpha1
              write(LuOut,*) "alpha2 = ",alpha2
              write(LuOut,*) "alpha3 = ",alpha3
              write(LuOut,*) "alpha4 = ",alpha4
              write(LuOut,*) "alpha(axisA,axisB) = ",alpha(axisA,axisB)
              call util_flush(LuOut)
            endif
#endif
c
          endif ! respaxis(axisA,axisB)
        enddo ! axisB loop
      enddo ! axisA loop
      cpu=cpu+util_cpusec()
      wall=wall+util_wallsec()
c
      do i = 1, 3
        do j = 1, i
          alphacopy(i,j)=alpha(i,j)
          alphacopy(j,i)=alpha(i,j)
        enddo
      enddo
c
      call hnd_diag(alphacopy,alphaevr,3,.false.,.false.)
c
      alphaiso = (alphaevr(1)+alphaevr(2)+alphaevr(3))/3.0d0
      alphaani = (alphaevr(1)-alphaevr(2))*(alphaevr(1)-alphaevr(2))
     1         + (alphaevr(1)-alphaevr(3))*(alphaevr(1)-alphaevr(3))
     2         + (alphaevr(2)-alphaevr(3))*(alphaevr(2)-alphaevr(3))
      alphaani = dsqrt(0.5d0*alphaani)
c
      if ((.not.(respaxis(1).and.respaxis(2).and.respaxis(3)))
     1    .and.nodezero) write(LuOut,9911)
c
      if (omega.ne.0.0d0) then
        if (nodezero) write(LuOut,9434) "CCSD Lambda Response",
     1    omega,auXnm/omega,
     2    alpha(1,1),alpha(2,1),alpha(3,1),
     3    au2ang3*alpha(1,1),au2ang3*alpha(2,1),au2ang3*alpha(3,1),
     4    alpha(2,1),alpha(2,2),alpha(3,2),
     5    au2ang3*alpha(2,1),au2ang3*alpha(2,2),au2ang3*alpha(3,2),
     6    alpha(3,1),alpha(3,2),alpha(3,3),
     7    au2ang3*alpha(3,1),au2ang3*alpha(3,2),au2ang3*alpha(3,3),
     8    alphaevr(1),alphaevr(2),alphaevr(3),
     9    au2ang3*alphaevr(1),au2ang3*alphaevr(2),au2ang3*alphaevr(3),
     1    alphaiso,au2ang3*alphaiso,alphaani,au2ang3*alphaani
      else
        if (nodezero) write(LuOut,9435) "CCSD Lambda Response",
     1    omega,
     2    alpha(1,1),alpha(2,1),alpha(3,1),
     3    au2ang3*alpha(1,1),au2ang3*alpha(2,1),au2ang3*alpha(3,1),
     4    alpha(2,1),alpha(2,2),alpha(3,2),
     5    au2ang3*alpha(2,1),au2ang3*alpha(2,2),au2ang3*alpha(3,2),
     6    alpha(3,1),alpha(3,2),alpha(3,3),
     7    au2ang3*alpha(3,1),au2ang3*alpha(3,2),au2ang3*alpha(3,3),
     8    alphaevr(1),alphaevr(2),alphaevr(3),
     9    au2ang3*alphaevr(1),au2ang3*alphaevr(2),au2ang3*alphaevr(3),
     1    alphaiso,au2ang3*alphaiso,alphaani,au2ang3*alphaani
      endif
      if (nodezero) write(LuOut,9020) cpu, wall
      call util_flush(LuOut)
c
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9082 format(1x,'amplitude norm of ',A9,' = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
 9120 format(1x,A)
 9121 format(/,1x,A)
 9122 format(1x,A,i4)
 9420 format(1x,i4,f25.13,2f8.1)
 9431 format(/,1x,'Frequency = ',f15.7,' / au')
 9434 format(/,1x,A,' polarizability / au ',/
     1  1x,'Frequency  = ',f15.7,' / au',/
     1  1x,'Wavelength = ',f15.7,' / nm',/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     2  1x,'                    atomic units (bohr^3)       '
     2    ,'       |                   angstroms^3           ',/
     2  1x,'                 X              Y              Z',
     2  1x,'      |             X              Y              Z',/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     4  1x,'X      ',3f15.7,3x,'|',3f15.7,/
     5  1x,'Y      ',3f15.7,3x,'|',3f15.7,/
     6  1x,'Z      ',3f15.7,3x,'|',3f15.7,/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     6  1x,'Eigs = ',3f15.7,3x,'|',3f15.7,/
     6  1x,'Isotropic   = ',8x,1f15.7,3x,15x,'|',15x,1f15.7,/
     6  1x,'Anisotropic = ',8x,1f15.7,3x,15x,'|',15x,1f15.7,/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------')
 9435 format(/,1x,A,' polarizability / au ',/
     1  1x,'Frequency  = ',f15.7,' / au',/
     1  1x,'Wavelength =        Infinity / nm',/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     2  1x,'                    atomic units (bohr^3)       '
     2    ,'       |                   angstroms^3           ',/
     2  1x,'                 X              Y              Z',
     2  1x,'      |             X              Y              Z',/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     4  1x,'X      ',3f15.7,3x,'|',3f15.7,/
     5  1x,'Y      ',3f15.7,3x,'|',3f15.7,/
     6  1x,'Z      ',3f15.7,3x,'|',3f15.7,/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     6  1x,'Eigs = ',3f15.7,3x,'|',3f15.7,/
     6  1x,'Isotropic   = ',8x,1f15.7,3x,15x,'|',15x,1f15.7,/
     6  1x,'Anisotropic = ',8x,1f15.7,3x,15x,'|',15x,1f15.7,/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------')
 9911 format(/,1x,'Warning: you have not solved ',
     1            'the response equations for all axes.  ',
     2            'Please analyze the results carefully as ',
     3            'the average and anisotropic polarizabilities ',
     4            'are surely wrong.',/)
 9440 format(1x,A3,' axis ( ',A4,'symmetry)')
      return
      end


      subroutine ccsd_qr_beta_eval(omega,d_b0,d_f1,d_v2,d_d1,
     1           d_t1,d_t2,d_y1,d_y2,d_tr1,d_tr2,d_yr1,d_yr2,
     2           k_b0_offset,k_f1_offset,k_v2_offset,k_d1_offset,
     3           k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset,
     4           k_tr1_offset,k_tr2_offset,k_yr1_offset,k_yr2_offset)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_prop.fh"
c
      integer i,j,dummy,axis
      integer axisA,axisB,axisC
      integer irrep_g
      parameter (irrep_g=0)
      integer d_b0,d_f1,d_v2,d_d1(3)
      integer d_t1,d_t2,d_y1,d_y2
      integer k_b0_offset,k_f1_offset,k_v2_offset,k_d1_offset(3)
      integer k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset
      integer d_tr1(9),d_tr2(9),d_yr1(6),d_yr2(6)
      integer k_tr1_offset(3),k_tr2_offset(3)
      integer k_yr1_offset(3),k_yr2_offset(3)
      integer sym_abelian_axis
      external sym_abelian_axis
      double precision omega
      double precision cpu, wall
      double precision beta1,beta2,beta3,beta4
      double precision beta(3,3,3)      ! Dipole hyperpolarizability tensor
      double precision au2ang   ! Conversion factor from bohr to Angstrom
      double precision au2ang3  ! Conversion factor from bohr^3 to Angstrom^3
      double precision auXnm    ! Conversion factor from a.u. (frequency) to nm (wavelength)
      double precision ddotfile
      external ddotfile
      parameter (auXnm=45.563353d0)
      parameter (au2ang=5.29177249d-01)
      parameter (au2ang3=au2ang*au2ang*au2ang)
      logical nodezero
      character*4 irrepname
      character*3 axisname(3)  ! Axis
      data axisname/'X','Y','Z'/
      character*255 filename
c
      nodezero=(ga_nodeid().eq.0)
c
#ifdef DEBUG_PRINT
      if (nodezero) write(6,*) 'top of ccsd_qr_beta_eval'
      call util_flush(6)
#endif
c
      do axisC = 1, 3
        do axisB = 1, 3
          do axisA = 1, 3
            beta(axisA,axisB,axisC)=0.0d0
          enddo
        enddo
      enddo
c
c CCSD-QR evaluation step
c
      cpu=-util_cpusec()
      wall=-util_wallsec()
      do axisA = 1, 3
        irrep_a=sym_abelian_axis(geom,axisA)
        do axisB = 1, 3
          irrep_b=sym_abelian_axis(geom,axisB)
          do axisC = 1, 3
            irrep_c=sym_abelian_axis(geom,axisC)
            if ( ( respaxis(axisA).and.respaxis(axisB) )
     &                          .and.respaxis(axisC) ) then
c
#ifdef DEBUG_PRINT
              if (nodezero) then
                write(LuOut,*) "axisA = ",axisA
                write(LuOut,*) "axisB = ",axisB
                write(LuOut,*) "axisC = ",axisC
                call util_flush(6)
              endif
#endif
c
              beta1=0.0d0
              beta2=0.0d0
              beta3=0.0d0
              beta4=0.0d0
              call tce_filename('b0',filename)
              call createfile(filename,d_b0,1)
c
              irrep_y=irrep_g
              irrep_tra=irrep_a
              irrep_trb=irrep_b
              irrep_trc=irrep_c
c              write(LuOut,*) "beta_1"
              call beta_1(d_b0,d_t1,d_tr1(axisA),d_tr2(axisA),
     1             d_tr1(axisB),d_tr2(axisB),d_tr1(axisC),d_tr2(axisC),
     2             d_v2,d_y1,d_y2,k_b0_offset,k_t1_offset,
     3             k_tr1_offset(axisA),k_tr2_offset(axisA),
     4             k_tr1_offset(axisB),k_tr2_offset(axisB),
     5             k_tr1_offset(axisC),k_tr2_offset(axisC),
     6             k_v2_offset,k_y1_offset,k_y2_offset)
              call reconcilefile(d_b0,1)
              call get_block(d_b0,beta1,1,0)
              call tce_zero(d_b0,1)
c
              irrep_y=irrep_g
              irrep_d=irrep_a
              irrep_tra=irrep_b
              irrep_trb=irrep_c
c              write(LuOut,*) "beta_2"
              call beta_2(d_d1(axisA),d_b0,d_tr1(axisB),d_tr2(axisB),
     1             d_tr1(axisC),d_tr2(axisC),d_y1,d_y2,
     2             k_d1_offset(axisA),k_b0_offset,
     3             k_tr1_offset(axisB),k_tr2_offset(axisB),
     4             k_tr1_offset(axisC),k_tr2_offset(axisC),
     5             k_y1_offset,k_y2_offset)
              call reconcilefile(d_b0,1)
              call get_block(d_b0,beta2,1,0)
              call tce_zero(d_b0,1)
c
              irrep_y=irrep_a
              irrep_tra=irrep_b
              irrep_trb=irrep_c
c              write(LuOut,*) "beta_3"
              call beta_3(d_f1,d_b0,d_t1,d_t2,d_tr1(axisB),d_tr2(axisB),
     1             d_tr1(axisC),d_tr2(axisC),d_v2,
     2             d_yr1(axisA),d_yr2(axisA),
     3             k_f1_offset,k_b0_offset,k_t1_offset,k_t2_offset,
     4             k_tr1_offset(axisB),k_tr2_offset(axisB),
     5             k_tr1_offset(axisC),k_tr2_offset(axisC),k_v2_offset,
     6             k_yr1_offset(axisA),k_yr2_offset(axisA))
              call reconcilefile(d_b0,1)
              call get_block(d_b0,beta3,1,0)
              call tce_zero(d_b0,1)
c
              irrep_y=irrep_a
              irrep_d=irrep_b
              irrep_tr=irrep_c
c              write(LuOut,*) "beta_4"
              call beta_4(d_d1(axisB),d_b0,d_t1,d_t2,
     1             d_tr1(axisC),d_tr2(axisC),d_yr1(axisA),d_yr2(axisA),
     2             k_d1_offset(axisB),k_b0_offset,
     3             k_t1_offset,k_t2_offset,
     4             k_tr1_offset(axisC),k_tr2_offset(axisC),
     5             k_yr1_offset(axisA),k_yr2_offset(axisA))
              call reconcilefile(d_b0,1)
              call get_block(d_b0,beta4,1,0)
              call tce_zero(d_b0,1)
c
c              write(LuOut,*) "beta1 = ",beta1
c              write(LuOut,*) "beta2 = ",beta2
c              write(LuOut,*) "beta3 = ",beta3
c              write(LuOut,*) "beta4 = ",beta4
c
c             This term contributes to only one component
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta1
c
c             These terms both contribute to three components
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta2
              beta(axisB,axisC,axisA)=beta(axisB,axisC,axisA)-beta2
              beta(axisC,axisA,axisB)=beta(axisC,axisA,axisB)-beta2
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta3
              beta(axisB,axisC,axisA)=beta(axisB,axisC,axisA)-beta3
              beta(axisC,axisA,axisB)=beta(axisC,axisA,axisB)-beta3
c
c             This term contributes to six components
c
              beta(axisA,axisB,axisC)=beta(axisA,axisB,axisC)-beta4
              beta(axisA,axisC,axisB)=beta(axisA,axisC,axisB)-beta4
              beta(axisB,axisA,axisC)=beta(axisB,axisA,axisC)-beta4
              beta(axisB,axisC,axisA)=beta(axisB,axisC,axisA)-beta4
              beta(axisC,axisA,axisB)=beta(axisC,axisA,axisB)-beta4
              beta(axisC,axisB,axisA)=beta(axisC,axisB,axisA)-beta4
c
              call deletefile(d_b0)
c
            endif ! respaxis(axisA,axisB,axisC)
          enddo ! axisB loop
        enddo ! axisB loop
      enddo ! axisA loop
c
      if (nodezero) then
        write(LuOut,*)
        write(LuOut,9120) "CCSD Quadratic Response"
        write(LuOut,9504)
        write(LuOut,9502)
        do axisA = 1, 3
          do axisB = 1, 3
            do axisC = 1, 3
              if (dabs(beta(axisA,axisB,axisC)).gt.1.0d-6)
     1        write(LuOut,9503) axisname(axisA),axisname(axisB),
     2                          axisname(axisC),beta(axisA,axisB,axisC),
     3                          ' / au'
            enddo
          enddo
        enddo
        write(LuOut,9502)
      endif
      cpu=cpu+util_cpusec()
      wall=wall+util_wallsec()
      if (nodezero) write(LuOut,9020) cpu, wall
      call util_flush(LuOut)
c
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9082 format(1x,'amplitude norm of ',A9,' = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
 9120 format(1x,A)
 9121 format(/,1x,A)
 9122 format(1x,A,i4)
 9400 format(/,1x,A,' iterations',/,
     1  1x,'---------------------------------------------',/
     2  1x,'Iter          Residuum            Cpu    Wall',/
     3  1x,'---------------------------------------------')
 9410 format(
     1  1x,'---------------------------------------------',/
     2  1x,'Iterations converged')
 9420 format(1x,i4,f25.13,2f8.1)
 9431 format(/,1x,'Frequency = ',f15.7,' / au')
 9434 format(/,1x,A,' polarizability / au ',/
     1  1x,'Frequency  = ',f15.7,' / au',/
     1  1x,'Wavelength = ',f15.7,' / nm',/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     2  1x,'                    atomic units (bohr^3)       '
     2    ,'       |                   angstroms^3           ',/
     2  1x,'                 X              Y              Z',
     2  1x,'      |             X              Y              Z',/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     4  1x,'X      ',3f15.7,3x,'|',3f15.7,/
     5  1x,'Y      ',3f15.7,3x,'|',3f15.7,/
     6  1x,'Z      ',3f15.7,3x,'|',3f15.7,/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------',/
     6  1x,'Eigs = ',3f15.7,3x,'|',3f15.7,/
     6  1x,'Isotropic   = ',8x,1f15.7,3x,15x,'|',15x,1f15.7,/
     6  1x,'Anisotropic = ',8x,1f15.7,3x,15x,'|',15x,1f15.7,/
     3  1x,'-----------------------------------------------'
     3    ,'--------|-----------------------------------------------')
 9435 format(/,1x,A,' C6 coefficients ',/
     1  1x,'--------------------------------',/
     2  1x,'C6(XX)  ',f15.7,/
     3  1x,'C6(YY)  ',f15.7,/
     4  1x,'C6(ZZ)  ',f15.7,/
     5  1x,'C6(XY)  ',f15.7,/
     6  1x,'C6(XZ)  ',f15.7,/
     7  1x,'C6(YZ)  ',f15.7,/
     8  1x,'C6(AVG) ',f15.7,/
     9  1x,'C6(ANI) ',f15.7,/
     1  1x,'--------------------------------')
 9911 format(/,1x,'Warning: you have not solved ',
     1            'the response equations for all axes.  ',
     2            'Please analyze the results carefully as ',
     3            'the average and anisotropic polarizabilities ',
     4            'are surely wrong.',/)
 9440 format(1x,A3,' axis ( ',A4,'symmetry)')
 9502 format(1x,'-----------------------------------------------')
 9503 format(1x,'beta(',a1,',',a1,',',a1,') = ',f18.9,a)
 9504 format(1x,'Static Hyperpolarizability')
 9505 format(1x,'Second Harmonic Generation (SHG)')
 9506 format(1x,'Optical Rectification (OR)')
 9507 format(1x,'Electro-Optic Pockels Effect (EOPE)')
 9508 format(1x,'beta(',f1.5,',',f1.5,',',f1.5,')')
      return
      end



      subroutine ccsd_lr_d1_build(omega,d_rho1,d_a0,d_f1,d_v2,d_d1,
     1           d_t1,d_t2,d_y1,d_y2,d_tr1,d_tr2,d_yr1,d_yr2,
     2           k_rho1_offset,
     3           k_a0_offset,k_f1_offset,k_v2_offset,k_d1_offset,
     4           k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset,
     5           k_tr1_offset,k_tr2_offset,k_yr1_offset,k_yr2_offset)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_prop.fh"
c
      integer i,j,dummy,axis,axisA
      integer irrep_g
      parameter (irrep_g=0)
      integer d_rho1(3)
      integer d_a0,d_f1,d_v2,d_d1(3)
      integer d_t1,d_t2,d_y1,d_y2
      integer k_rho1_offset(3)
      integer k_a0_offset
      integer k_f1_offset,k_v2_offset,k_d1_offset(3)
      integer k_t1_offset,k_t2_offset,k_y1_offset,k_y2_offset
      integer d_tr1(9),d_tr2(9),d_yr1(6),d_yr2(6)
      integer k_tr1_offset(3),k_tr2_offset(3)
      integer k_yr1_offset(3),k_yr2_offset(3)
      integer sym_abelian_axis
      external sym_abelian_axis
      double precision omega
      double precision cpu, wall
      logical nodezero
      character*4 irrepname
      character*3 axisname(3)  ! Axis
      data axisname/'X','Y','Z'/
      character*255 filename
c
      nodezero=(ga_nodeid().eq.0)
c
#ifdef DEBUG_PRINT
      if (nodezero) write(6,*) 'top of ccsd_lr_d1_build'
      call util_flush(6)
#endif
c
c CCSD-QR evaluation step
c
      cpu=-util_cpusec()
      wall=-util_wallsec()
      do axisA = 1, 3
        irrep_a=sym_abelian_axis(geom,axisA)
        if (respaxis(axisA)) then
c
#ifdef DEBUG_PRINT
            if (nodezero) then
              write(LuOut,*) "axisA = ",axisA
              call util_flush(6)
            endif
#endif
c
c           irrep_t=irrep_g
            irrep_y=irrep_g
            irrep_tr=irrep_a
            irrep_yr=irrep_a
c
c           irrep_tr symmetry
c
            call ccsd_lr_d1_hh(d_rho1(axisA),
     1           d_t1,d_tr1(axisA),d_tr2(axisA),
     2           d_y1,d_y2,d_yr1(axisA),
     3           k_rho1_offset(axisA),
     4           k_t1_offset,k_tr1_offset(axisA),k_tr2_offset(axisA),
     5           k_y1_offset,k_y2_offset,k_yr1_offset(axisA))
c
c           irrep_tr symmetry
c
            call ccsd_lr_d1_hp(d_rho1(axisA),
     1           d_t1,d_t2,d_tr1(axisA),d_tr2(axisA),
     2           d_y1,d_y2,d_yr1(axisA),d_yr2(axisA),
     3           k_rho1_offset(axisA),
     4           k_t1_offset,k_t2_offset,
     5           k_tr1_offset(axisA),k_tr2_offset(axisA),
     6           k_y1_offset,k_y2_offset,
     7           k_yr1_offset(axisA),k_yr2_offset(axisA))
c
c           irrep_tr symmetry
c
            call ccsd_lr_d1_pp(d_rho1(axisA),
     1           d_t1,d_t2,d_tr1(axisA),d_tr2(axisA),
     2           d_y1,d_y2,d_yr1(axisA),d_yr2(axisA),
     3           k_rho1_offset(axisA),
     4           k_t1_offset,k_t2_offset,
     5           k_tr1_offset(axisA),k_tr2_offset(axisA),
     6           k_y1_offset,k_y2_offset,
     7           k_yr1_offset(axisA),k_yr2_offset(axisA))
c
c           irrep_yr symmetry
c
            call ccsd_lr_d1_ph(d_rho1(axisA),
     1           d_t1,d_yr1(axisA),
     2           k_rho1_offset(axisA),
     3           k_t1_offset,k_yr1_offset(axisA))
c
        endif ! respaxis(axisA)
      enddo ! axisA loop
      cpu=cpu+util_cpusec()
      wall=wall+util_wallsec()
c
      if (nodezero) write(LuOut,9020) cpu, wall
      call util_flush(LuOut)
c
 9020 format(1x,'Cpu & wall time / sec',2f15.1)
 9082 format(1x,'amplitude norm of ',A9,' = ',f25.15)
 9100 format(1x,i4,2f18.13,2f8.1)
 9120 format(1x,A)
 9121 format(/,1x,A)
 9122 format(1x,A,i4)
 9420 format(1x,i4,f25.13,2f8.1)
 9431 format(/,1x,'Frequency = ',f15.7,' / au')
 9440 format(1x,A3,' axis ( ',A4,'symmetry)')
      return
      end
c $Id: ccsd_qr_beta.F 25546 2014-05-02 21:05:32Z d3y133 $

c $Id: freeze_input.F 19707 2010-10-29 17:59:36Z d3y133 $
      subroutine freeze_input(rtdb, module)
      implicit none
#include "inp.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "geom.fh"
      integer rtdb
      character*(*) module      ! [input]
c
c     .  [FREEZE [[core] (atomic || <integer nfzc default 0>)] \
c     .          [virtual <integer nfzv default 0>]]
c
c     Freeze directive has already been detected.  Just process
c     this line
c     External Routines

      character*80 key
      character*20 test, space
      integer mlen
      integer n

      character*16 tag
      character*20 symbol
      character*20 element
      integer atn
      integer tagfrz(60)
      integer numcore(60)
      integer num
      integer num_elem             !loop counter
      logical find_atn
      logical is_atom

      num_elem = 1
      is_atom = .false.
c
      mlen = inp_strlen(module)
      space = 'frozen core'
c
c     Remove previous entries so empty directive forces freeze nothing.
c
      key = ' '
      write(key,'(a,'':'',a)') module(1:mlen),'frozen core'
      call rtdb_clean(rtdb,key)
      key = ' '
      write(key,'(a,'':'',a,'':'')') module(1:mlen),'frozen virtual'
      call rtdb_clean(rtdb,key)
c
 10   if (.not. inp_a(test)) return
c
      if (inp_compare(.false.,test,'core')) then
         space = 'frozen core'
      else if (inp_compare(.false.,test,'virtual')) then
         space = 'frozen virtual'
      else if (inp_compare(.false.,test,'atomic')) then
         key = ' '
         write(key,'(a,'':'',a,'':'',a)') module(1:mlen),
     $        space(1:inp_strlen(space)), 'freeze by atoms'
         if (.not. rtdb_put(rtdb, key, mt_log, 1, .true.))
     $        call errquit('freeze_input: failed writing rtbd',0,0)
       
 20      if(inp_a(tag)) then
           find_atn = geom_tag_to_element(tag, symbol, element, atn)
           if( find_atn ) then
             tagfrz(num_elem) = atn

             if(inp_i(num)) then
               numcore(num_elem) = num
               num_elem = num_elem + 1
               is_atom = .true.
               goto 20
            end if
          end if
         endif

         if(is_atom) then
           num_elem = num_elem - 1 
           space = 'number tag elements'
           key = ' '
           write(key, '(a,'':'',a,'':'',a)') module(1:mlen),
     $       space(1:inp_strlen(space)), 'freeze by atoms'
           call rtdb_clean(rtdb, key)
           if(.not. rtdb_put(rtdb, key, mt_int, 1, num_elem)) then
             call errquit('freeze_input: failed writing to rtdb', 0,0)
           endif
 
           space = 'tag freeze'
           key = ' '
           write(key,'(a,'':'',a,'':'',a)') module(1:mlen),
     $        space(1:inp_strlen(space)), 'freeze by atoms'
           call rtdb_clean(rtdb, key)
           if(.not. rtdb_put(rtdb, key, mt_int, num_elem, tagfrz)) then
             call errquit('freeze_input: failed writing to rtdb', 0,0)
           endif
           
           space = 'num freeze'
           key = ' '
           write(key,'(a,'':'',a,'':'',a)') module(1:mlen),
     $        space(1:inp_strlen(space)), 'freeze by atoms'
           call rtdb_clean(rtdb, key)
           if(.not. rtdb_put(rtdb, key, mt_int, num_elem, numcore)) then
             call errquit('freeze_input: failed writing to rtdb', 0,0)
           endif
         endif

         space = 'frozen core'         !restore default

      else 
         call inp_prev_field()
	 if (.not. inp_i(n)) call errquit
     $      ('freeze_input: looking for nfzc/v',0,0)
         key = ' '
         write(key, '(a,'':'',a)') module(1:mlen),
     $           space(1:inp_strlen(space))
         if (.not. rtdb_put(rtdb, key, mt_int, 1, n))
     $        call errquit('freeze_input: failed writing rtdb',0,0)
         space = 'frozen core'         ! restore default
      endif
c      
      goto 10
c
      end
      

      SUBROUTINE ccsdt_lr_beta_4_5_3_1_1(d_a,k_a_offset,d_b,k_b_offset,d
     &_c,k_c_offset)
C     $Id: ccsdt_lr_beta_4_5_3_1_1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h2 h4 h12 p9 )_ytra + = -1 * Sum ( h7 p5 p6 ) * tra ( p5 p6 h7 h12 )_tra * y ( h2 h4 h7 p5 p6 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h4b
      INTEGER h12b
      INTEGER p9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER h7b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h12b_1
      INTEGER h7b_1
      INTEGER h2b_2
      INTEGER h4b_2
      INTEGER h7b_2
      INTEGER p9b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO h4b = h2b,noab
      DO h12b = 1,noab
      DO p9b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h12b-1)+int_mb(k_spin+p9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &12b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h12b-1),int_mb(k_sym+p9b-1)))) .eq. ieor(irrep_y,irrep_tra))
     & THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+h12b-1) * int_mb(k_range+p9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_4_5_3_1_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h7b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &12b-1)+int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h12b-1),int_mb(k_sym+h7b-1)))) .eq. irrep_tra) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h12b,h7b,p5b_1,p6b_1,h12b_1,h7b_1)
      CALL TCE_RESTRICTED_6(h2b,h4b,h7b,p9b,p5b,p6b,h2b_2,h4b_2,h7b_2,p9
     &b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+h7b-1)
      dima_sort = int_mb(k_range+h12b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p9b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_4_5_3_1_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_beta_4_5_3_1_1',2,MA_ERR)
      IF ((h7b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h7b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h12b-1
     &),4,3,2,1,1.0d0)
      END IF
      IF ((h12b .lt. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + noab * (h12b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h12b-1),int_mb(k_range+h7b-1
     &),3,4,2,1,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_beta_4_5_3_1_1'
     &,3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_4_5_3_1_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_beta_4_5_3_1_1',5,MA_ERR)
      IF ((h7b .lt. h2b) .and. (p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),6,3,2,1,5,4,1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (p5b .le. p9b) .and. (p9b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),5,3,2,1,6,4,-1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h4b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,3,2,1,6,5,1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (h7b .lt. h4b) .and. (p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),6,3,1,2,5,4,-1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (h7b .lt. h4b) .and. (p5b .le. p9b) .and.
     & (p9b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),5,3,1,2,6,4,1.0d0)
      END IF
      IF ((h2b .le. h7b) .and. (h7b .lt. h4b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h4b_2 - 1 + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h4b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,3,1,2,6,5,-1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p6b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p9b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h7b_2 - 1 + noab * (h4b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p9b-1),6,2,1,3,5,4,1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p5b .le. p9b) .and. (p9b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p9b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (h7b_2 - 1 + noab * (h4b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p9b-1),int_mb(k_range+p6b-1),5,2,1,3,6,4,-1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (p9b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p9b_2 - noab - 1 
     &+ nvab * (h7b_2 - 1 + noab * (h4b_2 - 1 + noab * (h2b_2 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h7b-1),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),4,2,1,3,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_beta_4_5_3_1_1'
     &,6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_beta_4_5_3
     &_1_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_beta_4_5_3
     &_1_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_beta_4_5_3_1_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h2b-1),int_mb(k_range+h12b-1
     &),3,2,4,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (h12b - 1 + noab * (h4b - 1 + noab * (h2b - 1))
     &)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_beta_4_5_3_1_1'
     &,10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_beta_4_5_3
     &_1_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

C $Id: read_drdy_rtdb.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c ***************************************************************************
c     read5 -> read_drdy_rtdb
c ***************************************************************************
      subroutine read_drdy_rtdb(rtdb)
      implicit none 
#include "errquit.fh"
* set up local input file from master nwchem input on rtdb.
#include "drdyP.fh"
#include "stdio.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "inp.fh"
*::passed:
      Integer rtdb ! [input] RTDB handle
*::local:
      character*255 filename
*
      character * 80 string
      integer istrt, isect, iend
      integer i, j
      character*255 rtdbname
      character*255 drdystring
      integer len_drdy
      integer count
c
c read and write file
c
      lu_drdy_rline = 55
      call util_file_name('drdy_input',.false.,.false.,filename)
      open(unit=lu_drdy_rline,file=filename,status='unknown')
      close(unit=lu_drdy_rline,status='delete')
      call util_file_unlink(filename)
      open(unit=lu_drdy_rline,file=filename,
     &      form='formatted',status='new', err=99999)
c
      count = 0
      rtdbname = 'drdy:nwchem:line:count'
      if (.not.rtdb_get(rtdb,rtdbname,mt_int,1,count)) then
        write(fu6,*)' no input for drdy '
        call errquit('read_drdy_rtdb: fatal error ',911, RTDB_ERR)
      endif
c
      do i = 1,count
        write(rtdbname,10000)i
        if (.not.rtdb_cget(rtdb,rtdbname,1,drdystring)) then
          write(fu6,*)' could not rtdb_cget ',
     &          rtdbname(1:(inp_strlen(rtdbname)))
          call errquit('read_drdy_rtdb: fatal error ',911, RTDB_ERR)
        endif
        len_drdy = inp_strlen(drdystring)
        write(lu_drdy_rline,'(a)') drdystring(1:len_drdy)
      enddo
      rewind lu_drdy_rline
c
c     start off by finding the first section given in the input deck
c
      call drdy_rline(string,istrt,isect,iend)
c
c     error check - check that the file wasn't empty and that the 
c     first line found was the start of a section
c
      if (iend.eq.1) then
         write(fu6,1000)
1000     format(1x,'error:  input file was empty')
         call errquit('read_drdy_rtdb: fatal error',911, RTDB_ERR)
      end if
c
      if (isect.ne.1) then
         write(fu6,1100)
1100     format(1x,'error:  first non-comment, non-blank line must be'
     *             ,' a section header that begins with a *')
         call errquit('read_drdy_rtdb: fatal error',911, RTDB_ERR)
      end if
c
c     Call the correct routine to read in the data in this section.  
c     control will come back here once another section header has
c     been found.  This will continue until an end-of-file mark
c     has been encoutered.
c
      do while (iend.eq.0)
         j = istrt + 1
         if (string(j:j+5).eq.'genera') then
               call drdy_rgener(string,iend,istrt)
         else if (string(j:j+5).eq.'react1') then
               irepr(1) = 1
               call drdy_rstat(string,iend,istrt,1)
         else if (string(j:j+5).eq.'react2') then
               irepr(2) = 1
               call drdy_rstat(string,iend,istrt,2)
         else if (string(j:j+4).eq.'prod1') then
               irepr(3) = 1
               call drdy_rstat(string,iend,istrt,3)
         else if (string(j:j+4).eq.'prod2') then
               irepr(4) = 1
               call drdy_rstat(string,iend,istrt,4)
         else if (string(j:j+4).eq.'start') then
               irepr(5) = 1
               call drdy_rstat(string,iend,istrt,5)
         else if (string(j:j+3).eq.'path') then
               call drdy_rpath(string,iend,istrt)
         else
               write(fu6,1200) string(j-1:80)
               call errquit('read_drdy_rtdb: fatal error',911, RTDB_ERR)
         end if
      end do
c
1200  format(3x,'Error:  the following is not a valid section name',
     *         /A80)
c
      return
99999 continue
      write(fu6,*)' read_drdy_rtdb: could not open: ',filename
      call errquit('read_drdy_rtdb: fatal error',911, RTDB_ERR)
10000 format('drdy:',i10)
      end

c**************************************************
c     Main driver for all qmmm optimization tasks *
c**************************************************
C> \ingroup task
C> @{
      function task_qmmm_optimize(rtdb)
c     $Id: task_qmmm_optimize.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
      integer rtdb
      logical task_qmmm_optimize
      double precision cpu, wall
c     
      logical  status
c     
      character*32 pname
      character*30 operation
c     
      logical   qmmm_mixed_optimization
      external  qmmm_mixed_optimization
c
      logical   qmmm_pes
      external  qmmm_pes
c
      logical divcon
      logical opes
c
      pname = "task_qmmm_optimize"
c
      cpu  = util_cpusec()
      wall = util_wallsec()
c
      if(qmmm_print_debug())
     >  write(*,*) "in " //pname, ga_nodeid()

      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, .false.))
     $     call errquit('task_optimize: failed to invalidate status',0,
     &       RTDB_ERR)

c
c     figure out the optimization task
c     --------------------------------
      if (.not. rtdb_get(rtdb, 'qmmm:pes', mt_log, 
     $                   1, opes))
     $     opes = .false.

      if (.not. rtdb_cget(rtdb, 'task:operation', 1, operation))
     $     operation = ' '

      if (inp_compare(.false., 'saddle', operation)) then
        if (.not. rtdb_put(rtdb,'driver:modsad',mt_int,1,1))
     $        call errquit('task_saddle: rtdb corrupt?', 0, RTDB_ERR)
      end if

      if(qmmm_print_debug())
     >  write(*,*) "opes",opes


      if (.not. rtdb_get(rtdb, 'driver:divcon', mt_log, 
     $                   1, divcon))
     $     divcon = .false.


      status = .true.
c
c     pes task
c     --------
      if(opes) then
          status=qmmm_pes(rtdb)
        go to 110
      end if
c
c     default multiregion optimization
c     --------------------------------
      status = qmmm_mixed_optimization(rtdb)
c
110   continue
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - wall
      if (.not. rtdb_put(rtdb, 'task:cputime', mt_dbl, 1, cpu))
     $     call errquit('task_optimize: failed storing cputime',0,
     &       RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:walltime', mt_dbl, 1, wall))
     $     call errquit('task_optimize: failed storing walltime',0,
     &       RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, status))
     $     call errquit('task_optimize: failed to set status',0,
     &       RTDB_ERR)
c     
      call mm_write_restart()
      call mm_write_restart_default()
      task_qmmm_optimize = status
c     
      end
C> @}
c
      function qmmm_mixed_optimization(rtdb)
c     $Id: task_qmmm_optimize.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
      integer rtdb
      logical qmmm_mixed_optimization
      double precision cpu, wall
c     
      logical  status
c     
      integer   i,k
      character*84 tag
      character*32 pname
      character*48 string
c     
      logical   qmmm_optimizer
      external  qmmm_optimizer
c
      logical   qmmm_energy_gradient
      external  qmmm_energy_gradient
c
      logical oesp
c
      logical oconv
      character*30 region(3)
      character*30 method(3)
      character*30 xyz(3)
      integer maxiter(3)
      integer nmethod
      integer nxyz
      integer nmaxiter
      integer nregion
      integer ncycles
      character*60 xyzfile,xyztmp
      double precision enew,eold,etol
c
      character*255 rfile
      character*255 stub
c
      pname = "qmmm_mixed_optimization"
c
      qmmm_mixed_optimization = .true.
c
      cpu  = util_cpusec()
      wall = util_wallsec()
c
      if(qmmm_print_debug())
     >  write(*,*) "in " //pname, ga_nodeid()
c
c     region definitions
c     ------------------
      tag ="qmmm:convergence"
      if (.not.rtdb_get(rtdb,tag(1:inp_strlen(tag)),
     >                 mt_dbl,1,etol)) 
     >      etol = 1.0d-4
c
c     region definitions
c     ------------------
      tag ="qmmm:region"
      if (.not.rtdb_get(rtdb,tag(1:inp_strlen(tag))//"_n",
     >                 mt_int,1,nregion)) 
     >      call errquit(pname//tag,0,RTDB_ERR)
c
c     no region so exiting out
c     -----------------------
      if(nregion.eq.0) return

      if(nregion.gt.3) 
     >      call errquit(pname//"too many regions",0,0)
      if (.not.rtdb_cget(rtdb,tag,nregion,region)) 
     >      call errquit(pname//tag,0,RTDB_ERR)
c
c     method definitions if any
c     -------------------------
      tag ="qmmm:method"
      do i=1,nregion
        call qmmm_optimization_method(method(i),
     >                                region(i))
      end do
      if (rtdb_get(rtdb,tag(1:inp_strlen(tag))//"_n",
     >                 mt_int,1,nmethod)) then
        if(nmethod.gt.3) 
     >       call errquit(pname//"too many methods",0,0)
        if (.not.rtdb_cget(rtdb,tag,nmethod,method)) 
     >       call errquit(pname//tag,0,RTDB_ERR)
      end if
c
c     xyz files
c     ---------
      tag ="qmmm:xyz"
      do i=1,nregion
        xyz(i) = " "
      end do
      if (rtdb_get(rtdb,tag(1:inp_strlen(tag))//"_n",
     >                 mt_int,1,nxyz)) then
        if(nxyz.gt.3) 
     >       call errquit(pname//"too many xyz",0,0)
        if (.not.rtdb_cget(rtdb,tag,nxyz,xyz)) 
     >       call errquit(pname//tag,0,RTDB_ERR)
      end if
c
c
c     max iterations if any
c     ---------------------
      tag ="qmmm:maxiter"
      do i=1,nregion
        call qmmm_optimization_maxiter(maxiter(i),
     >                                region(i))
      end do
      if (rtdb_get(rtdb,tag(1:inp_strlen(tag))//"_n",
     >                 mt_int,1,nmaxiter)) then
        if(nmaxiter.gt.3) 
     >       call errquit(pname//"too many maxiters",0,0)
        if (.not.rtdb_get(rtdb,tag,mt_int,nmaxiter,maxiter)) 
     >       call errquit(pname//tag,0,RTDB_ERR)
      end if
c
      if (.not. rtdb_get(rtdb,'qmmm:ncycles',mt_int,1,ncycles))
     +  ncycles = 1

      if (.not. rtdb_get(rtdb, 'qmmm:esp_density', mt_log, 
     $                   1, oesp))
     $     oesp = .false.


      status = .true.
c
c     print informational header
c     --------------------------
      if(qmmm_master()) then
        write(luout,10) 
        write(luout,12)
        write(luout,12) " QM/MM Multiple Region Optimization"

        do k=1,nregion
            write(luout,13) k,region(k),method(k),maxiter(k)
        end do 
        write(luout,12)
10      format("@",48("-"))
12      format("@",a)
13      format("@ region",i1,":  ",a10,"with ",a10,"maxiter =",i3)
        write(luout,12)
        write(luout,10)
      end if

c
c     start the optimization cycle
c     ----------------------------
      eold = 0.0d0
      do i=1,ncycles
       if(ga_nodeid().eq.0) then
         write(luout,14) i
         write(luout,12)
14     format("@ ncycle =",I3)
       end if
       if(oesp) call qmmm_esp_reset(rtdb)
       do k=1,nregion
c
         if(maxiter(k).eq.0) goto 111
         xyzfile = " "
         if(xyz(k).ne." ") then
           xyztmp  = xyz(k)
           write(xyzfile,'(A,"-",I3.3)') 
     >       xyztmp(1:inp_strlen(xyztmp)),i 
         end if

         status = qmmm_optimizer(rtdb,region(k),method(k),
     >                         xyzfile,maxiter(k))
111    continue
       end do
c
c     evaluate energy each cycle
c     updating pair lists and periodic
c     conditions at the same time
c     ---------------------------
      call qmmm_cons_reset()
      call  qmmm_bq_data_reload()
      call qmmm_set_interface("qm")
      call md_sp()
      status = qmmm_energy_gradient(rtdb,.false.) 
      call qmmm_energy_rtdb_push(rtdb)
      call qmmm_print_energy3(rtdb)
      call qmmm_print_spring_energy(rtdb)
      if (.not. rtdb_get(rtdb,'qmmm:energy',mt_dbl,1,enew))
     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)
c
c      save restart file
c      -----------------
       stub = " "
       rfile = " "
       write(stub,'(i3.3,".rst")') i
       call util_file_name(stub(1:inp_strlen(stub)),.false.,
     >                     .false.,rfile)
       call mm_write_restart_named(rfile,.false.)
c
c      test for convergence
c      --------------------
       oconv = i.gt.1.and.
     >         abs(enew-eold).lt.etol
       if(oconv) goto 109
       eold = enew
      end do
109   continue
      if(ga_nodeid().eq.0) then
         write(luout,10) 
         write(luout,12) 
         write(luout,15) 
         write(luout,12) 
15     format("@  OPTIMIZATION FINISHED ")
      end if

      status = .true.         
c     
110   continue
c--- commenting this out because energy
c--- is already calculated during each cycle
cc
cc     final energy evaluation
cc     ---------------------------
c      call qmmm_cons_reset()
c      call qmmm_bq_data_update_active()
c      call qmmm_set_interface("qm")
c      call md_sp()
c      status = qmmm_energy_gradient(rtdb,.false.) 
c      call qmmm_energy_rtdb_push(rtdb)
c      call qmmm_print_energy3(rtdb)
cc
c----------------------------------------------
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - wall
c     
      call mm_write_restart()
      qmmm_mixed_optimization = status
c     
      end
c
      function driver1(rtdb)
c     $Id: task_qmmm_optimize.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
      integer rtdb
      logical driver1
      double precision cpu, wall
c     
      logical  status
c     
      character*32 pname
c     
      logical   driver
      external  driver
      logical   qmmm_energy_gradient
      external  qmmm_energy_gradient
      integer nr,resid(2),i,k,resall(3)
      logical ignore
      character*255 filename, dir,xyz
      double precision energy

      xyz = "test"
      nr = 1
      resall(1)=1
      resall(2)=2
      resall(3)=3

      pname = "driver1"

      do i=1,10
      do k=1,58,2
      resid(1) = k
      resid(2) = k+1
      call qmmm_geom_end()
      ignore = rtdb_delete(rtdb,'geometry')
      call mm_free_solute_res(2,resid)
      call qmmm_geom_init(rtdb,.true.)
      status = driver(rtdb)
      call mm_write_restart()
         dir      = ' '
         filename = ' ' 
         call util_directory_name(dir, .false., 0)
         write(filename,13) dir(1:inp_strlen(dir)), 
     $        xyz(1:inp_strlen(xyz)),i,k
 13      format(a,'/',a,'-',i3.3,'-',i3.3,'.pdb')
         open(88,file=filename,form='formatted',status='unknown',
     $        err=133)

         call mm_print_system_file(88)
         write(*,*) "filename",filename(1:inp_strlen(filename))
         close(88,status='keep',err=133)
c
c      call mm_free_solute_res(3,resall)
c      call mm_task_sp()
c      status = qmmm_energy_gradient(rtdb,.false.) 
c      call qmmm_energy_rtdb_push(rtdb)
c      if (.not. rtdb_get(rtdb,'qmmm:energy',mt_dbl,1,energy))
c     $     call errquit('qmmm: failed get energy', 0, RTDB_ERR)
c      write(*,*) "qmmm_energy",i,k,energy
      end do
      end do
      call mm_print_info()

      driver1 = status

      return

 133  call errquit(pname//'error opening/closing xyz file',0, GEOM_ERR)
     
      end
c
      subroutine qmmm_optimization_method(method,region)
c     $Id: task_qmmm_optimize.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
#include "mm_utils.fh"

      character*(*) region,method
      character*(40) buffer
c
      if (region.eq."qm") then
        method = "bfgs"
      else if (region.eq."qmlink") then
        method = "bfgs"
      else if (region.eq."mm_solute") then
        method = "lbfgs"
      else if (region.eq."mm") then
        method = "sd"
      else if (region.eq."solute") then
        method = "sd"
      else if (region.eq."solvent") then
        method = "sd"
      else if (region.eq."all") then
        method = "sd"
      else
        buffer = region
        call errquit("Unknown region "//buffer,0,0)
      end if
c
c      if (region.eq."all") then
c        method = "sd"
c      else if (region.eq."solvent") then
c        method = "sd"
c      else if (region.eq."solvent") then
c        method = "sd"
c      else
c        method = "lbfgs"
c      end if
c
      return

      end
c
      subroutine qmmm_optimization_maxiter(maxiter,region)
c     $Id: task_qmmm_optimize.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
#include "mm_utils.fh"

      integer       maxiter
      character*(*) region
c
      if(region.eq."qm") then
        maxiter = 20
      else if (region.eq."qmlink") then
        maxiter = 20
      else if (region.eq."mm") then
        maxiter = 100
      else if (region.eq."solvent") then
        maxiter = 100
      else
        maxiter = 50
      end if

      return

      end
c
      function qmmm_optimizer(rtdb,region,method,xyz,maxiter)
c     $Id: task_qmmm_optimize.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
#include "mm_utils.fh"

      integer rtdb
      logical qmmm_optimizer
      character*(*) region,method,xyz
      integer maxiter
c
      logical  status
c     
      character*32 pname
      character*48 string
c     
      logical   driver
      external  driver
      logical   qmmm_lbfgsb_driver
      external  qmmm_lbfgsb_driver
      logical   qmmm_energy_gradient
      external  qmmm_energy_gradient
      logical task_qmmm_gradient
      external task_qmmm_gradient
      integer   i,k
      logical ignore
      double precision energy
      double precision grms_quantum
      double precision grms_classical
      double precision grms_solvent
      integer ncycles
      logical oesp,ofrozen
      integer nact

      pname = "qmmm_optimizer"

      qmmm_optimizer = .true.
c
c     define set of active atoms
c     --------------------------
      call qmmm_cons_reset()
      call qmmm_cons_set("fix","solute")
      call qmmm_cons_set("fix","solvent")
      call qmmm_cons_set("free",region)
c
      if (.not. rtdb_get(rtdb, 'qmmm:esp_density', mt_log, 
     $                   1, oesp))
     $     oesp = .false.
c
      if (.not. rtdb_get(rtdb, 'qmmm:frozen_density', mt_log, 
     $                   1, ofrozen))
     $     ofrozen = .false.
c
c      call qmmm_bq_data_update_active()
c
      call qmmm_cons_get_nacts_qm(nact)
c
      oesp = oesp.and.(nact.eq.0)
      ofrozen = ofrozen.and.(nact.eq.0)
c
      if(qmmm_master()) then
        if(oesp) then
         write(luout,14) region,
     >                    method
        else if (ofrozen) then
         write(luout,15) region,
     >                    method
        else
         write(luout,16) region,
     >                    method
        end if

      end if

14       format("@",/,"@ Optimizing " ,a10," region with ",a6,
     >          /,"@ and esp fitted charges for the qm region",
     >           /,"@")
15       format("@",/,"@ Optimizing " ,a10," region with ",a6,
     >          /,"@ and static density for the qm region",
     >          /,"@")
16       format("@",/,"@ Optimizing " ,a10," region with ",a6,
     >          /,"@")
c
c     perform an optimization as requested
c     ------------------------------------
      if(method.eq."bfgs") then
         call qmmm_geom_init_aux(rtdb,"geometry")
         if (.not. rtdb_cput(rtdb,'driver:xyz',1,xyz))
     $        call errquit(pname,0, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'driver:nptopt',mt_int,1,maxiter))
     $        call errquit(pname,0, RTDB_ERR)
         call qmmm_set_interface("qm")
         status = driver(rtdb)
         ignore = rtdb_delete(rtdb,'geometry')
         call qmmm_geom_aux_end(rtdb)
       else if(method.eq."lbfgs") then
         if (.not. rtdb_cput(rtdb,'driver:xyz',1,xyz))
     $        call errquit(pname,0, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'driver:nptopt',mt_int,1,maxiter))
     $        call errquit(pname,0, RTDB_ERR)
         call qmmm_set_interface("qm")
         status =  qmmm_lbfgsb_driver(rtdb)
       else if(method.eq."sd") then
         call qmmm_set_interface("mm")
         call mm_set_sd_maxiter(maxiter)
         call md_em()
       else
         call errquit(pname//'unknown method',0, RTDB_ERR)
       end if


      return

      end
c
      function qmmm_pes(irtdb)
c      function qmmm_pes(irtdb,optimizer)
c     $Id: task_qmmm_optimize.F 22841 2012-09-12 06:55:13Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "qmmm.fh"
#include "inp.fh"
#include "msgids.fh"
#include "tcgmsg.fh"
      integer irtdb
      logical optimizer
      external optimizer
      logical qmmm_pes
      double precision cpu, wall
c     
      logical  status
c     
      character*32 pname
c     
      logical   qmmm_mixed_optimization
      external  qmmm_mixed_optimization
      logical ignore
      character*255 filename, dir,xyz,prefix
      character*255 filename0
      character*255 movecs
      character*255 movecs0
      double precision energy
      double precision rb(2)
      integer np
      integer ip
      integer in
      double precision dr
      double precision r
      integer i1,i2,i3
      logical ofile
      logical backward
      logical loadrst
      logical loadmovecs
      integer ncycles
      integer istart
      integer iend

      pname = "qmmm_pes"

c
c     get lower/upper  limits for pes scan
c     ------------------------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_bounds',mt_dbl,
     +                    2,rb))
     + call errquit(pname//'Failed to get pes bounds',
     + 1, RTDB_ERR)

c
c     get number of points for pes scan
c     ------------------------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_ncycles',mt_int,
     +                    1,ncycles))
     + ncycles = 1
c
c     get number of points for pes scan
c     ------------------------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_npoints',mt_int,
     +                    1,np))
     + call errquit(pname//'Failed to get pes points',
     + 1, RTDB_ERR)
c
c     get starting point
c     ------------------
      if (.not. rtdb_get(irtdb,'qmmm:pes_istart',mt_int,
     +                    1,istart))
     +    istart = 1
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_iend',mt_int,
     +                    1,iend))
     +    iend = np
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_backward',mt_log,
     +                    1,backward))
     +  backward = .false.
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_loadrst',mt_log,
     +                    1,loadrst))
     +  loadrst = .false.
c
      if (.not. rtdb_get(irtdb,'qmmm:pes_loadmovecs',mt_log,
     +                    1,loadmovecs))
     +  loadmovecs = .false.
c
c     directory name to dump restart files
c     ------------------------------------
      dir      = ' '
      call util_directory_name(dir, .false., 0)
c
c     file prefix from mm module
c     --------------------------
      call mm_system_prefix(prefix)
c      write(*,*) "pes, mm_system_prefix", prefix(1:inp_strlen(prefix))
c
c     construct movecs file name  
      movecs0 = ' '
      call util_file_name("movecs",.false.,.false.,movecs0)        
      ignore = rtdb_delete(irtdb,'dft:input vectors')
      ignore = rtdb_delete(irtdb,'scf:input vectors')
c 
c     set increments and initial value
c     --------------------------------
      dr = (rb(2)-rb(1))/(np-1)
      r  = rb(1)

      do in=1,ncycles
      if(backward) then
        i1=iend
        i2=istart
        i3=-1
      else
        i1=istart
        i2=iend
        i3=1
      end if
c
c     actually do the scan
c     --------------------
      do ip=i1,i2,i3
        r  = rb(1)+dr*(ip-1) 
        if(ga_nodeid().eq.0) then
          write(*,15) ip,r
        end if
        if (.not. rtdb_put(irtdb,'qmmm:r_spring',mt_dbl,
     +                     1,r))
     +  call errquit(pname//'Failed to set r_spring',
     +  1, RTDB_ERR)

c       construct restart file name  
        filename0 = ' '
        call mm_restart_filename(filename0)
        filename = ' '
        write(filename,13) dir(1:inp_strlen(dir)), 
     $     prefix(1:inp_strlen(prefix)),ip

c       start load restart file if it exists and requested     
        if(loadrst) then
          if(ga_nodeid().eq.0) then 
            inquire(file=filename,exist=ofile)
            if(ofile) then 
             write(*,*) "pes: found restart file",
     >                 filename(1:inp_strlen(filename))
            call util_file_copy(filename(1:inp_strlen(filename)),
     >                          filename0(1:inp_strlen(filename0)))
            end if
          end if
          call ga_brdcst(msg_qmmm_misc, ofile, mitob(1), 0)
          call ga_sync()
          if(ofile) 
     >      call mm_reload_rst(irtdb,filename0)
        end if
c       end load restart 
c       start load movecs if it exists and requested     
        movecs = ' '
        write(movecs,17) dir(1:inp_strlen(dir)), 
     $   prefix(1:inp_strlen(prefix)),ip
        if(loadmovecs) then
          if(ga_nodeid().eq.0) then 
            inquire(file=movecs,exist=ofile)
            if(ofile) then 
             write(*,*) "pes: found movecs file",
     >                 movecs(1:inp_strlen(movecs))
            call util_file_copy(movecs(1:inp_strlen(movecs)),
     >                          movecs0(1:inp_strlen(movecs0)))
            end if
          end if
          call ga_sync()
        end if
c       end load restart 
        status = qmmm_mixed_optimization(irtdb)
        if (.not. rtdb_get(irtdb,'qmmm:energy',mt_dbl,1,energy))
     $       call errquit('qmmm: failed get energy', 0, RTDB_ERR)
        if(ga_nodeid().eq.0) 
     >     write(*,16) energy,r
        call mm_write_restart_named(filename,.false.)
        if(ga_nodeid().eq.0) then 
           write(*,*) "pes: saving movecs file",
     >                 movecs0(1:inp_strlen(movecs0)),
     >                 movecs(1:inp_strlen(movecs))
          call util_file_copy(movecs0(1:inp_strlen(movecs0)),
     >                        movecs(1:inp_strlen(movecs)))
        end if
        call ga_sync()

      end do
      backward = .not.backward
      end do
      qmmm_pes = status

 13      format(a,'/',a,'_pes',i3.3,'.rst')
 14      format(a,'_pes',i3.3,'.rst')
 15      format("@pes: point ", I2,3X,"spring length = ",F12.6)
 16      format("@pes: energy =  ", F18.12,3X,"length = ",F12.6)
 17      format(a,'/',a,'_pes',i3.3,'.movecs')

      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      subroutine cluster_com
#include "common.fh"
c
      integer i
      double precision masstot, dx, dy, dz
      double precision r,rdot,com(10)
c
c   This subroutine calculates the center of mass (COM) of the cluster of
c   particles of type 2, excluding the lone particle.
c
      if (nocluster) return
      cl_cmx = 0.0d00
      cl_cmy = 0.0d00
      cl_cmz = 0.0d00
      cl_acmx = 0.0d00
      cl_acmy = 0.0d00
      cl_acmz = 0.0d00
      cl_vcmx = 0.0d00
      cl_vcmy = 0.0d00
      cl_vcmz = 0.0d00
      masstot = 0.0d00
c
      do i = 1, antot
c      if (at(i).eq.2.and.aidx(i).ne.cl_lone_particle) then
        if (at(i).eq.2) then
          cl_cmx = cl_cmx + mass(i)*ra(i,1,6)
          cl_cmy = cl_cmy + mass(i)*ra(i,2,6)
          cl_cmz = cl_cmz + mass(i)*ra(i,3,6)
          cl_acmx = cl_acmx + ra(i,1,4)
          cl_acmy = cl_acmy + ra(i,2,4)
          cl_acmz = cl_acmz + ra(i,3,4)
          cl_vcmx = cl_vcmx + mass(i)*ra(i,1,2)
          cl_vcmy = cl_vcmy + mass(i)*ra(i,2,2)
          cl_vcmz = cl_vcmz + mass(i)*ra(i,3,2)
          masstot = masstot + mass(i)
        endif
      end do
      com(1) = cl_cmx
      com(2) = cl_cmy
      com(3) = cl_cmz
      com(4) = cl_vcmx
      com(5) = cl_vcmy
      com(6) = cl_vcmz
      com(7) = cl_acmx
      com(8) = cl_acmy
      com(9) = cl_acmz
      com(10) = masstot
      call ga_dgop(3,com,10,'+')
      cl_cmx  = com(1)
      cl_cmy  = com(2)
      cl_cmz  = com(3)
      cl_acmx  = com(7)
      cl_acmy  = com(8)
      cl_acmz  = com(9)
      cl_vcmx  = com(4)
      cl_vcmy  = com(5)
      cl_vcmz  = com(6)
      masstot = com(10)
      if (masstot.gt.0.0d00) then
        cl_cmx = cl_cmx / masstot
        cl_cmy = cl_cmy / masstot
        cl_cmz = cl_cmz / masstot
        cl_acmx = cl_acmx / masstot
        cl_acmy = cl_acmy / masstot
        cl_acmz = cl_acmz / masstot
        cl_vcmx = cl_vcmx / masstot
        cl_vcmy = cl_vcmy / masstot
        cl_vcmz = cl_vcmz / masstot
      endif
      cl_mass = masstot
c
      return
      end
c
      subroutine cluster_therm
#include "common.fh"
c
      integer i
      double precision dx, dy, dz
      double precision r,rdot
c
c  remove component of velocity that lies along the vector from COM
c  to the particle, if particle is outside cluster radius. This gradually
c  forces particles to form a drop.
c
      if (nocluster) return
      if (istep.ge.equil_1) return
      call cluster_com
      do i = 1, antot
c        if (at(i).eq.2.and.aidx(i).ne.cl_lone_particle) then
        if (at(i).eq.2) then
          dx = ra(i,1,1) - cl_cmx
          dy = ra(i,2,1) - cl_cmy
          dz = ra(i,3,1) - cl_cmz
          r = sqrt(dx**2 + dy**2 + dz**2)
          dx = dx/r
          dy = dy/r
          dz = dz/r
          if (r.gt.r_cluster) then
            rdot = ra(i,1,2)*dx+ra(i,2,2)*dy+ra(i,3,2)*dz
            if (rdot.gt.0.0d00) then
              ra(i,1,2) = ra(i,1,2) - 2.0d00*rdot*dx
              ra(i,2,2) = ra(i,2,2) - 2.0d00*rdot*dy
              ra(i,3,2) = ra(i,3,2) - 2.0d00*rdot*dz
            endif
          endif
        endif
      end do
c
      return
      end
c
      subroutine cluster_center
#include "common.fh"
c
c  move center of mass to origin (only perform this if it is immediately
c  followed by a call to update subroutine)
c
      integer i,me
      logical debug
      if (nocluster) return
      if (istep.eq.0.or.(mod(istep,ilist).eq.0.and.
     +    t_rmndr.eq.0.0d00)) then
        me = ga_nodeid()
        if (istep.ge.6932366) then
          debug = .false.
        else
          debug = .false.
        endif
        if (debug) then
          write(6,*) me,' mod(istep,ilist) = ',mod(istep,ilist)
          write(6,*) me,' ilist = ',ilist
        endif
        call cluster_com
        if (debug) write(6,*) me,'cl_cmx (a) = ',cl_cmx,istep
        if (debug) write(6,*) me,'cl_cmy (a) = ',cl_cmy,istep
        if (debug) write(6,*) me,'cl_cmz (a) = ',cl_cmz,istep
        do i = 1, antot
          ra(i,1,6) = ra(i,1,6) - cl_cmx
          ra(i,2,6) = ra(i,2,6) - cl_cmy
          ra(i,3,6) = ra(i,3,6) - cl_cmz
        end do
        call fixper
        call cluster_com
        if (debug) write(6,*) me,'cl_cmx (b) = ',cl_cmx,istep
        if (debug) write(6,*) me,'cl_cmy (b) = ',cl_cmy,istep
        if (debug) write(6,*) me,'cl_cmz (b) = ',cl_cmz,istep
      endif
      return
      end
c
      subroutine cluster_old_at
#include "common.fh"
c
c   store original coordinates of cluster atoms
c
      integer i, icnt, jcnt
      if (nocluster) return
      icnt = 0
      jcnt = 0
      do i = 1, antot
        if (at(i).eq.2) then
          icnt = icnt + 1
          cl_at(icnt) = i
          cl_old(icnt,1,1) = ra(i,1,1)
          cl_old(icnt,2,1) = ra(i,2,1)
          cl_old(icnt,3,1) = ra(i,3,1)
          cl_old(icnt,1,2) = ra(i,1,6)
          cl_old(icnt,2,2) = ra(i,2,6)
          cl_old(icnt,3,2) = ra(i,3,6)
          cl_old(icnt,1,3) = ra(i,1,2)
          cl_old(icnt,2,3) = ra(i,2,2)
          cl_old(icnt,3,3) = ra(i,3,2)
        endif
        if (at(i).eq.1) then
          jcnt = jcnt + 1
          sl_at(jcnt) = i
          sl_old(jcnt,1,1) = ra(i,1,1)
          sl_old(jcnt,2,1) = ra(i,2,1)
          sl_old(jcnt,3,1) = ra(i,3,1)
          sl_old(jcnt,1,2) = ra(i,1,6)
          sl_old(jcnt,2,2) = ra(i,2,6)
          sl_old(jcnt,3,2) = ra(i,3,6)
          sl_old(jcnt,1,3) = ra(i,1,2)
          sl_old(jcnt,2,3) = ra(i,2,2)
          sl_old(jcnt,3,3) = ra(i,3,2)
        endif
      end do
c
      cl_cm_old(1) = cl_cmx
      cl_cm_old(2) = cl_cmy
      cl_cm_old(3) = cl_cmz
      cl_vcm_old(1) = cl_vcmx
      cl_vcm_old(2) = cl_vcmy
      cl_vcm_old(3) = cl_vcmz
c
      do i = 1, 3
        cl_alen1_old(i) = alen1(i)
        cl_alen2_old(i) = alen2(i)
      end do
      cl_vol1_old = vol1
      cl_vol2_old = vol2
      cl_box_old(1) = xbox
      cl_box_old(2) = ybox
      cl_box_old(3) = zbox
      cl_scal1_old = scal1
      cl_scal2_old = scal2
c
      cl_tot = icnt
      sl_tot = jcnt
      return
      end
c
      subroutine cluster_check_cllsn
#include "common.fh"
c
c   This subroutine checks to see if any of the cluster particles have moved
c   beyond the cutoff radius from the center of mass of the cluster. If they
c   have, then the initial guess for the particle coordinates and velocities
c   is modified to reflect the collision with the restraining sphere.
c
      integer icnt, iat, i, j, ii, jj, iloc, imin, scndat, reset
      double precision r, r2, rx, ry, rz, dtmax, tsav
      double precision rrx, rry, rrz, vvx, vvy, vvz
      double precision vn, vx, vy, vz, fx, fy, fz, mu, v2, f2
      double precision vrdot, frdot, vfdot, a, b, c
      double precision t1, t2, tcut, comm(4), tmax, htausq
      double precision rnx, rny, rnz, vpx, vpy, vpz, vllx, vlly, vllz
      double precision t3, t4, ax, ay, az, tchk, tmin, t_est
      double precision r1x, r1y, r1z, r2x, r2y, r2z, rmax, rskin, rn
      double precision cluster_find_tau
      integer failsafe, ibuf(MD_MAXPROC), me, nproc, twohit
      logical debug
      integer iter
c
      iter = 0
      l_cllsn = .false.
      if (nocluster) then
        t_rmndr = 0.0d00
        t_done = tau
        return
      endif
      me = ga_nodeid()
      nproc = ga_nnodes()
      if (istep.ge.68365721.and.istep.le.68365723) then
        debug = .false.
      else
        debug = .false.
      endif
      rskin = 0.02d00
      tmax = t_rmndr
      if (t_rmndr.eq.tau) cllsn_isav = 0
  100 dtmax = 2.0d00*t_rmndr
      twohit = 0
      failsafe = 0
      iat = 0
      iloc = 0
      tsav = 0.0d00
      rmax = r_cluster
      if (debug) write(6,*) me,' atot = ',atot,istep
      if (debug) write(6,*) me,' antot = ',antot,istep
      if (debug) write(6,*) me, ' r_cluster = ',r_cluster,istep
      if (debug) write(6,*) me,' t_rmndr = ',tmax,istep
      if (debug) write(6,*) me,' cl_cmx(1) = ',cl_cmx,istep
      if (debug) write(6,*) me,' cl_cmy(1) = ',cl_cmy,istep
      if (debug) write(6,*) me,' cl_cmz(1) = ',cl_cmz,istep
      do i = 1, cl_tot
        ii = cl_at(i)
        rx = ra(ii,1,6) - cl_cmx
        ry = ra(ii,2,6) - cl_cmy
        rz = ra(ii,3,6) - cl_cmz
        r2 = rx**2 + ry**2 + rz**2
        r = sqrt(r2)
c        if (debug) write(6,*) me, 'ra(ii,1,6) ',ra(ii,1,6),istep
c        if (debug) write(6,*) me, 'ra(ii,2,6) ',ra(ii,2,6),istep
c        if (debug) write(6,*) me, 'ra(ii,3,6) ',ra(ii,3,6),istep
        if (r.gt.r_cluster) then
          if (r.gt.rmax) rmax = r
          if (debug) write(6,*) me,' tmax = ',tmax,istep
          if (debug) write(6,*) me,' dtmax = ',dtmax,istep
          if (debug) write(6,*) me,' ii = ',ii,istep
          if (debug) write(6,*) me,' antot = ',antot,istep
          if (debug) write(6,*) me,' r-r_cluster ',r-r_cluster,istep
          if (debug) write(6,*) me,' r_cluster = ',r_cluster,istep
          if (debug) write(6,*) me,' sqrt(r2) = ',sqrt(r2),istep
          if (debug) write(6,*) me,' ra(1) = ',ra(ii,1,6),istep
          if (debug) write(6,*) me,' ra(2) = ',ra(ii,2,6),istep
          if (debug) write(6,*) me,' ra(3) = ',ra(ii,3,6),istep
          if (debug) write(6,*) me,' cl_cmx = ',cl_cmx,istep
          if (debug) write(6,*) me,' cl_cmy = ',cl_cmy,istep
          if (debug) write(6,*) me,' cl_cmz = ',cl_cmz,istep
          if (debug) write(6,*) me,' r_cluster_old = ',r_cluster_old,
     +      istep
          if (debug) write(6,*) me,' cl_old(1) = ',cl_old(i,1,2),istep
          if (debug) write(6,*) me,' cl_old(2) = ',cl_old(i,2,2),istep
          if (debug) write(6,*) me,' cl_old(3) = ',cl_old(i,3,2),istep
          if (debug) write(6,*) me,' cl_cm_old(1) = ',cl_cm_old(1),istep
          if (debug) write(6,*) me,' cl_cm_old(2) = ',cl_cm_old(2),istep
          if (debug) write(6,*) me,' cl_cm_old(3) = ',cl_cm_old(3),istep
          if (debug) write(6,*) me,' r_old = ', sqrt(
     +      + (cl_old(i,1,2)-cl_cm_old(1))**2
     +      + (cl_old(i,2,2)-cl_cm_old(2))**2
     +      + (cl_old(i,3,2)-cl_cm_old(3))**2)
          rn = sqrt(rx**2+ry**2+rz**2)
          vn = ra(ii,1,2)*rx+ra(ii,2,2)*ry+ra(ii,3,2)*rz
          vn = vn/rn
          t_est = vn*(rn-r_cluster)
          tcut = cluster_find_tau(ii,i,cllsn_isav,tmax,.false.)
          if (debug) write(6,*) me,' tcut = ',tcut,istep
          if (debug) write(6,*) me,' t_est = ',t_est,istep
          if (debug) write(6,155) me,1,tcut,istep
  155     format(i3,' tcut at ',i1,': ',f12.4,' step: ',i8)
c
c   Check to see if collision is earlier than previously found collisions
c   and that it is also greater than zero.
c
          if (tcut.lt.dtmax.and.tcut.gt.0.0d00) then
c
c   Try to protect against numerical roundoff by checking that different
c   particle collides with sphere or that collision time is significantly
c   greater than zero if it is the same particle
c
            if (.not.(ii.eq.cllsn_isav.and.tcut.lt.1.0d-03)) then
              dtmax = tcut
              tsav = tcut
              iat = ii
              iloc = i
            else
              write(6,101) ii, tcut, istep
  101         format('Rejected collision of atom ',i8,' at time ',
     +               f16.8,' at step ',i8)
              failsafe = 1
            endif
          else if (tcut.lt.0.0d00) then
            write(6,*) ga_nodeid(),' vn ',vn,istep
            write(6,*) ga_nodeid(),' t_est ',t_est,istep
            write(6,*) ga_nodeid(),' r-r_cluster ',r-r_cluster,istep
            write(6,*) ga_nodeid(),' Returned negative value at 1',istep
            failsafe = 1
          endif
#if 0
c
c   Check for trajectories that may have gone out and then back into
c   confining sphere
c
        else if (r_cluster-r.lt.rskin.and.r_cluster-r.gt.0.0d00) then
          vn = rx*ra(ii,1,2)+ry*ra(ii,2,2)+rz*ra(ii,3,2)
          if (vn.le.0.0d00) then
            tcut = cluster_find_tau(ii,i,cllsn_isav,tmax,.true.)
            if (tcut.lt.dtmax.and.tcut.gt.0.0d00) then
              write(6,*) 'Found looping trajectory',istep
              write(6,*) 'dtmax = ',dtmax,istep
              write(6,*) 'tcut = ',tcut,istep
              write(6,*) 'ii = ',ii,istep
              write(6,*) 'cllsn_isav = ',cllsn_isav,istep
              write(6,*) 'r = ',r,istep
              write(6,*) 'r_cluster = ',r_cluster,istep
              if (.not.(ii.eq.cllsn_isav.and.tcut.lt.1.0d-10)) then
                write(6,*) 'Resetting trajectory',istep
                dtmax = tcut
                tsav = tcut
                iat = ii
                iloc = i
              else
                write(6,*)'Not resetting trajectory (loop is too short)'
              endif
            endif
          endif
#endif
        endif
      end do 
c
c   Check to see if a collision occured on another processor
c
      ibuf(1) = iat
      ibuf(2) = failsafe
      if (debug) write(6,*) me,' iat = ',iat,istep
      if (debug) write(6,*) me,' failsafe = ',failsafe,istep
      if (debug) write(6,*) me,' ibuf(1) = ',ibuf(1),istep
      if (debug) write(6,*) me,' ibuf(2) = ',ibuf(2),istep
      call ga_igop(5,ibuf,2,'+')
      if (debug) write(6,*) me,' ibuf(1) = ',ibuf(1),istep
      if (debug) write(6,*) me,' ibuf(2) = ',ibuf(2),istep
c
c   No collisions detected. Step is complete so just return.
c
      if (ibuf(1).eq.0.and.ibuf(2).eq.0) then
        t_rmndr = 0.0d00
        t_done = tau
        if (debug) write(6,*) me,' Returning with no hits ',istep
        return
      endif
c
c   If no solution found for atom outside confining sphere, then bail
c   completely and increase diameter of confining sphere so that all
c   atoms are enclosed.
c
      if (ibuf(2).gt.0) then
        call ga_dgop(4,rmax,1,'max')
        if (debug) write(6,*) me,' r_cluster (a) = ',r_cluster
        r_cluster = r_cluster + (rmax - r_cluster)*1.1d00
        if (debug) write(6,*) me,' r_cluster (b) = ',r_cluster
        if (ga_nodeid().eq.0) then
          write(6,*) ga_nodeid(),' Returned negative value at 2',istep
        endif
        failcount = failcount + 1
        t_rmndr = 0.0d00
        t_done = tau
        return
      endif
c
c   At this point, a collision has been detected on at least on
c   processor. Check to find minimum time if collisions occur on more
c   than one processor.
c
      if (iat.eq.0) then
        tsav = tau
      endif
      a = tsav
      call ga_dgop(6,a,1,'min')
c
c   Find mass of particle that has first collision with confining sphere
c
      if (a.eq.tsav) then
        b = mass(iat)
      else
        b = 0.0d00
      endif
      call ga_dgop(7,b,1,'max')
 1000 mmass = cl_mass - b
      tcut = a
      if (debug) write(6,155) me,2,tcut,istep
      if (tsav.ne.a) then
        iat = 0
        iloc = 0
        cllsn_isav = 0
        if (debug) write(6,*) me,' cllsn_isav(1): ',cllsn_isav
      else
        cllsn_isav = iat
        if (debug) write(6,*) me,' cllsn_isav(2): ',cllsn_isav
      endif
c
c  Handle degenerate case of only two atoms in cluster, which will
c  generally have two simultaneous collisions
c
      if (ctot.eq.2) then
        do i = 1, nproc
          if (i-1.eq.me) then
            ibuf(i) = iat
          else
            ibuf(i) = 0
          endif
        end do
        call ga_igop(3,ibuf,nproc,'+')
        j = 0
        iat = 0
        cllsn_isav = 0
        do i = 1, nproc
          if (ibuf(i).gt.0.and.i-1.eq.me.and.j.eq.0) then
            iat = ibuf(i)
            cllsn_isav = ibuf(i)
            j = 1
          else if (ibuf(i).gt.0) then
            j = 1
          endif
        end do
c
c  Make sure that correct mass is being used for collision
c
        if (iat.ne.0) then
          b = mass(iat)
        else
          b = 0.0d00
        endif
        call ga_dgop(6,b,1,'max')
        mmass = cl_mass - b
      endif
c
c   Now recalculate coordinates of all particles in the cluster
c
      call cluster_reset(tcut)
      call cluster_com !CHECK
c
c   Check to see if there were any trajectories that pass through confining
c   sphere twice (i.e. goes out and then comes back in). Don't bother with
c   check if there are only 2 particles in system.
c
      if (ctot.eq.2) then
        go to 2000
      endif
      reset = 0
      tchk = 0.0d00
      scndat = 0
      tmin = tcut
      tsav = tcut
      failsafe = 0
      do i = 1, cl_tot
        ii = cl_at(i)
        rx = ra(ii,1,6) - cl_cmx
        ry = ra(ii,2,6) - cl_cmy
        rz = ra(ii,3,6) - cl_cmz
        r = sqrt(rx**2+ry**2+rz**2)
        if (r.ge.r_cluster.and.ii.ne.cllsn_isav) then
          tchk = cluster_find_tau(ii,i,cllsn_isav,tcut,.false.)
          if (debug) write(6,155) me,7,tchk,istep
          if (debug) write(6,*) me, 'ii: ',ii
          if (debug) write(6,*) me, 'cllsn_isav: ',cllsn_isav
          reset = 1
          if (tchk.lt.tmin.and.tchk.gt.0.0d00) then
            if (debug) write(6,*) me,' Shorter collision found'
            tmin = tchk
            imin = ii
            if (debug) write(6,155) me,4,tchk,istep
            if (debug) write(6,155) me,5,tmin,istep
          else if (tchk.lt.0.0d00) then
            write(6,*) ga_nodeid(),' Returned negative value at 3',istep
            failsafe = 1
          else
c
c  This case should theoretically be impossible, but it may occur because of
c  roundoff
c
            write(6,*) me,' tchk greater than or equal to tmin',istep
            write(6,*) me,' tchk = ',tchk,istep
            write(6,*) me,' tmin = ',tmin,istep
            failsafe = 1
          endif
        endif
      end do
      ibuf(1) = reset
      ibuf(2) = failsafe
      call ga_igop(2,ibuf,2,'+')
c
c   No solution for tau found, so increase confining sphere and then bail
c
      if (ibuf(2).gt.0) then
        if (debug) write(6,*) me,' rmax (c) = ',rmax
        call ga_dgop(4,rmax,1,'max')
        if (debug) write(6,*) me,' rmax (d) = ',rmax
        if (debug) write(6,*) me,' r_cluster (c) = ',r_cluster
        r_cluster = r_cluster + (rmax - r_cluster)*1.1d00
        if (debug) write(6,*) me,' r_cluster (d) = ',r_cluster
        if (ga_nodeid().eq.0) then
          write(6,*) 'Bogus value of collision time at 2'
        endif
        call cluster_reset(t_rmndr)
        t_rmndr = 0.0d00
        t_done = tau
        return
      endif
      reset = ibuf(1)
c
c   Shorter collision found so recalculate positions
c
      if (reset.gt.0) then
        if (tmin.le.tsav) then
          if (debug) write(6,*) 'tmin = ',tmin,istep
          if (debug) write(6,*) 'tsav = ',tsav,istep
          a = tmin
        else
          a = tau
        endif
        call ga_dgop(2,a,1,'min')
c
        if (a.le.tsav) then
          if (a.ne.tmin) then
            iat = 0
            iloc = 0
            cllsn_isav = 0
            if (debug) write(6,*) me,'cllsn_isav(3): ',cllsn_isav
          else
            cllsn_isav = imin
            if (debug) write(6,*) me,'cllsn_isav(4): ',cllsn_isav
          endif
          tcut = a
          tsav = a   !BJP is this correct?
          if (debug) write(6,155) me,3,tcut,istep
          if (iat.gt.0) then
            b = mass(iat)
          else
            b = 0.0d00
          endif
          call ga_dgop(7,b,1,'+')
          call cluster_reset(0.0d00)
          iter = iter + 1
          if (iter.gt.100) debug = .true.
          if (iter.gt.1000) call ga_error('Too many iterations',0)
          go to 1000
        endif
      endif
c
 2000 l_cllsn = .true.
      cllsn_idx = cllsn_isav
c 
      t_rmndr = tmax - tcut
      t_done = tau - t_rmndr
      if (debug) write(6,*) me, 't_rmndr = ',t_rmndr
      if (debug) write(6,*) me, 't_done = ',t_done
c
      return
      end
c
      double precision function cluster_find_tau(iat,iloc,isav,tmax,
     +                                           forward)
#include "common.fh"
c
c   This function calculates the time at which a particle outside the confining
c   sphere would have collided with the sphere.
c
      integer iat, iloc, isav
      double precision r, r2, rx, ry, rz, dr
      double precision rrx, rry, rrz, vvx, vvy, vvz
      double precision vx, vy, vz, fx, fy, fz, v2, f2
      double precision clcut, frdot, vrdot, vfdot, a, b, c
      double precision t, t1, t2, tcut, tmax, thi, tlo, tmid
      double precision ttmin,ttmax
      integer i,j,me,iter
      logical forward, debug
c
c  A particle lies outside the cutoff. Find particle that crosses
c  cutoff first.
c
      if (istep.ge.68365721.and.istep.le.68365723) then
        debug = .false.
      else
        debug = .false.
      endif
      me = ga_nodeid()
      mmass = cl_mass - mass(iat)
c
c  Calculate center of mass and velocity of center of mass of remaining
c  particles in cluster (these are the rr and vv vectors)
c
      rrx = (cl_mass*cl_cm_old(1) - mass(iat)*cl_old(iloc,1,2))/mmass
      rry = (cl_mass*cl_cm_old(2) - mass(iat)*cl_old(iloc,2,2))/mmass
      rrz = (cl_mass*cl_cm_old(3) - mass(iat)*cl_old(iloc,3,2))/mmass
      vvx = (cl_mass*cl_vcm_old(1) - mass(iat)*cl_old(iloc,1,3))/mmass
      vvy = (cl_mass*cl_vcm_old(2) - mass(iat)*cl_old(iloc,2,3))/mmass
      vvz = (cl_mass*cl_vcm_old(3) - mass(iat)*cl_old(iloc,3,3))/mmass
c
c  The r and v vectors are the relative coordinates and velocities of
c  particle iat and the center of mass vectors. The vector f is the
c  force along this relative coordinate.
c
      rx = cl_old(iloc,1,2) - cl_cm_old(1)
      ry = cl_old(iloc,2,2) - cl_cm_old(2)
      rz = cl_old(iloc,3,2) - cl_cm_old(3)
      vx = cl_old(iloc,1,3) - cl_vcm_old(1)
      vy = cl_old(iloc,2,3) - cl_vcm_old(2)
      vz = cl_old(iloc,3,3) - cl_vcm_old(3)
      fx = ra(iat,1,3) - cl_acmx
      fy = ra(iat,2,3) - cl_acmy
      fz = ra(iat,3,3) - cl_acmz
c
      r = sqrt(rx**2 + ry**2 + rz**2)
c
c  Note that we are using acceleration instead of force,
c  so factors of reduced mass disappear
c
      vrdot = vx*rx + vy*ry + vz*rz
      frdot = fx*rx + fy*ry + fz*rz
      vfdot = vx*fx + vy*fy + vz*fz
      clcut = r_cluster
      v2 = vx**2 + vy**2 + vz**2
      a = v2+frdot
      b = 2.0d00*vrdot
c
c      c = rx**2 + ry**2 + rz**2 - clcut**2
c
c  Calculate c to minimize roundoff error from subtracting large numbers
c
      dr = r - clcut
      c = 2.0d00*r*dr+dr**2
      f2 = fx**2 + fy**2 + fz**2
c
c    Scan forwards from 0 to find a final value of t2. If no final
c    value found, then return with value of -1.
c
              if (debug) write(6,*) me, 'iat: ',iat
              if (debug) write(6,*) me, 'a: ',a
              if (debug) write(6,*) me, 'b: ',b
              if (debug) write(6,*) me, 'c: ',c
              if (debug) write(6,*) me, 'f2: ',f2
              if (debug) write(6,*) me, 'vfdot: ',vfdot
      if (forward) then
        t = tmax
        t1 = 0.0d00
        ttmin = t1
        ttmax = t
c        tlo = c + t1*(b + t1*(a+t1*(vfdot+t1*0.25d00*f2)))
        tlo = (-c-t1**2*(a+t1*(vfdot+t1*0.25d00*f2)))/b - t1
        do i = 1, 1000
          if (t.eq.tmax) then
            t2= tmax*dble(i)/1000.0d00
c            thi = c + t2*(b + t2*(a+t2*(vfdot+t2*0.25d00*f2)))
            thi = (-c-t2**2*(a+t2*(vfdot+t2*0.25d00*f2)))/b - t2
            if ((thi.ge.0.0d00.and.tlo.le.0.0d00).or.
     +          (thi.le.0.0d00.and.tlo.ge.0.0d00)) then
              t = t2
              write(6,*) ga_nodeid(),' tmin = ',ttmin,istep
              write(6,*) ga_nodeid(),' tmax = ',ttmax,istep
              write(6,*) ga_nodeid(),' tlo = ',tlo,istep
              write(6,*) ga_nodeid(),' thi = ',thi,istep
              write(6,*) ga_nodeid(),' t = ',t,istep
              go to 500
            endif
          endif
        end do
        cluster_find_tau = -1.0d00
        return
c
c    scan backwards from tmax to find an initial value of t1
c
      else
        t = 0.0d00
        t2 = tmax
c        thi = c + t2*(b + t2*(a+t2*(vfdot+t2*0.25d00*f2)))
        thi = (-c-t2**2*(a+t2*(vfdot+t2*0.25d00*f2)))/b - t2
        do i = 1, 1000
          if (t.eq.0.0d00) then
            t1= tmax - tmax*dble(i)/1000.0d00
c            tlo = c + t1*(b + t1*(a+t1*(vfdot+t1*0.25d00*f2)))
            tlo = (-c-t1**2*(a+t1*(vfdot+t1*0.25d00*f2)))/b - t1
            if ((thi.ge.0.0d00.and.tlo.le.0.0d00).or.
     +          (thi.le.0.0d00.and.tlo.ge.0.0d00)) then
              t = t1
              if (debug) write(6,*) me, 'tlo: ',tlo
              if (debug) write(6,*) me, 'thi: ',thi
              if (debug) write(6,*) me, 't: ',t
              go to 500
            endif
          endif
        end do
      endif
c
c  Use bisections to find accurate solution
c
  500 if (forward) then
        t1 = 0.0d00
        t2 = t
      else
        t1 = t
        t2 = tmax
        if (debug) write(6,*) me, 't1: ',t1
        if (debug) write(6,*) me, 't2: ',t2
      endif
      iter = 0
c  600 tlo = c + t1*(b + t1*(a+t1*(vfdot+t1*0.25d00*f2)))
c      thi = c + t2*(b + t2*(a+t2*(vfdot+t2*0.25d00*f2)))
  600 tlo = (-c-t1**2*(a+t1*(vfdot+t1*0.25d00*f2)))/b - t1
      thi = (-c-t2**2*(a+t2*(vfdot+t2*0.25d00*f2)))/b - t2
      if ((thi.ge.0.0d00.and.tlo.le.0.0d00).or.
     +    (thi.le.0.0d00.and.tlo.ge.0.0d00)) then
        t = 0.5d00*(t1+t2)
c        tmid = c + t*(b + t*(a+t*(vfdot+t*0.25d00*f2)))
        tmid = (-c-t**2*(a+t*(vfdot+t*0.25d00*f2)))/b - t
        if ((tmid.ge.0.0d00.and.thi.le.0.0d00).or.
     +      (tmid.le.0.0d00.and.thi.ge.0.0d00)) then
            t1 = t
        else if ((tmid.ge.0.0d00.and.tlo.le.0.0d00).or.
     +           (tmid.le.0.0d00.and.tlo.ge.0.0d00)) then
            t2 = t
        endif
        tcut = 0.5d00*(t1+t2)
        iter = iter + 1
        if (abs(t1-t2)/tau.gt.1.0d-14.and.iter.lt.1000) go to 600
c
c  Protect against numerical roundoff errors
c
        if (iter.ge.1000) then
          write(6,*) ga_nodeid(),' Maxed out on iterations'
        endif
        if (forward.and.(tcut.lt.1.0d-10.or.
     +      abs(tcut-tmax).lt.1.0d-10)) then
          cluster_find_tau = -1.0d00
          return
        endif
      else
        open(unit=2,file='tau.dat',status='unknown')
        do j = 0, 1000
          t = tmax*dble(j)/1000.0d00
          t1 = (-c-t**2*(a+t*(vfdot+t*0.25d00*f2)))/b - t
          tmid = c + t*(b + t*(a+t*(vfdot+t*0.25d00*f2)))
          write(2,300) t,t1, tmid
  300     format(3('    ',f16.8))
        end do
        close(2)
        if (iat.ne.isav) then
          if (abs(thi).lt.0.000001d00) then
            tcut = tmax
          else if (abs(tlo).lt.0.000001d00) then
            if (vrdot.gt.0.0d00) then
              tcut = 0.0d00
            else
              tcut = tmax
            endif
          else
            if (forward) write(6,*) 'Searching forward'
            write(6,*) 'Collision time does not converge at step ',istep
            tcut = -1.0d00
          endif
        else
          tcut = 4.0d00*tau
        endif
      endif
c
      if (forward) write(6,*) ga_nodeid(),' tcut = ',tcut
      cluster_find_tau = tcut 
      return
      end
c
      double precision function cluster_check_radius()
#include "common.fh"
      double precision rx, ry, rz, r2, cl2
      integer i
c
c   check to make sure that all cluster particles are within cluster
c   radius
c
      cl2 = 0.0d00
      do i = 1, antot
        if (at(i).eq.2) then
          rx = ra(i,1,6) - cl_cmx
          ry = ra(i,2,6) - cl_cmy
          rz = ra(i,3,6) - cl_cmz
          r2 = rx**2 + ry**2 + rz**2
          if (r2.gt.cl2) cl2 = r2
        endif
      end do
      call ga_dgop(4,cl2,1,'max')
c
      cluster_check_radius = sqrt(cl2)
      return
      end
c
      subroutine cluster_mc
#include "common.fh"
c
c  Perform Monte Carlo adjustment of volume on confining volume
c
      double precision r_old, delta_r, r2, cl2, rx, ry, rz, pi
      double precision vol_new, vol_old, x, ran1, ratio
      integer i, icnt, iat, me
      logical force_move,debug
c
      if (nocluster) return
      if (istep.ge.6932366) then
        debug = .false.
      else
        debug = .false.
      endif
      call cluster_com
      me = ga_nodeid()
      r_cluster_old = r_cluster
      r_old = r_cluster
      force_move = .false.
      delta_r = 0.2
      if (debug) write(6,*)me,' (1) r_cluster ',r_cluster,istep
      if (me.eq.0) then
        r_cluster = r_cluster + delta_r*(ran1(0)-0.5d00)
      else
        r_cluster = 0.0d00
      endif
      if (debug) write(6,*)me,' (2) r_cluster ',r_cluster,istep
      call ga_dgop(1,r_cluster,1,'+')
      if (debug) write(6,*)me,' (3) r_cluster ',r_cluster,istep
c
c  If new value of r_cluster falls outside of allowed interval then
c  it is rejected, unless old value was aready outside interval.
c
      if (r_cluster.ge.cl_upper.or.r_cluster.le.cl_lower) then
c
c  If new values move cluster radius closer to cutoffs from the outside,
c  then accept them, reject them otherwise. Before accepting move, make
c  sure that there are no illegal overlaps.
c
        force_move = .true.
        if (r_cluster.gt.r_old.and.r_cluster.gt.cl_upper) then
          r_cluster = r_old
        else if (r_cluster.lt.r_old.and.r_cluster.lt.cl_lower) then
          r_cluster = r_old
        endif
        if (r_cluster.eq.r_old) return
      endif
      if (debug) write(6,*)me,' (4) r_cluster ',r_cluster,istep
c
c  Check to see if any particles are outside new value of r_cluster.
c  If so, then new value is rejected.
c
      if (r_cluster.lt.r_old) then
        icnt = 0
        cl2 = r_cluster**2
        do i = 1, antot
          if (at(i).eq.2) then
            rx = ra(i,1,6) - cl_cmx
            ry = ra(i,2,6) - cl_cmy
            rz = ra(i,3,6) - cl_cmz
            r2 = rx**2 + ry**2 + rz**2
            if (r2.gt.cl2) then
              icnt = icnt + 1
            endif
          endif
        end do
        call ga_igop(9,icnt,1,'+')
        if (icnt.gt.0) then
          r_cluster = r_old
          return
        endif
      endif
      if (debug) write(6,*)me,' (5) r_cluster ',r_cluster,istep
      if (force_move) return
c
c  Accept with Monte Carlo probability.
c
      pi = 4.0d00*atan(1.0d00)
      vol_new = 4.0d00*pi*r_cluster**3/3.0d00
      vol_old = 4.0d00*pi*r_old**3/3.0d00
      ratio = (r_cluster/r_old)**2
c
      x = ratio*exp(-cl_prssr*(vol_new-vol_old)/mc_tmprtr)
      if (me.eq.0) then
        if (x.ge.1.0d00) then
          icnt = 1
        else 
          if (ran1(0).lt.x) then
            icnt = 1
          else
            icnt = 0
          endif
        endif
      else
        icnt = 0
      endif
      call ga_igop(1,icnt,1,'+')
      if (icnt.eq.0) then
        r_cluster = r_old
      endif
      if (debug) write(6,*)me,' (6) r_cluster ',r_cluster,istep
      return
      end
c
      subroutine cluster_binr
#include "common.fh"
c
c  Bin the current value of r_cluster
c
      double precision dr
      integer ir, isample
      if (nocluster) return
c
c  Find bin
c
      dr = r_cluster - cl_lower
      ir = int(dr/mc_step) + 1
      if (ir.le.0) ir = 1
      if (ir.gt.mcbins) ir = mcbins
      mc_cnt = mc_cnt + 1
c
c  Find slice for statistics
c
      if (istep.gt.mc_start) then
        isample = int(10.0d00*(dble(istep-mc_start)-0.5d00)
     +          / dble(nstep-mc_start)) + 1
        if (isample.gt.10) isample = 10
      else
        isample = 1
      endif
      r_cnt(isample) = r_cnt(isample) + 1
      r_distr(ir,isample) = r_distr(ir,isample) + 1
      return
      end
c
      subroutine cluster_print_binr
#include "common.fh"
c
c  Print out the distribution of r_cluster
c
      double precision rdist(MAXBINS), norm, r, normi
      double precision rdist2(MAXBINS), sum
      double precision sigr(MAXBINS),sigr2(MAXBINS)
      double precision sig2(MAXBINS),sig2_2(MAXBINS)
      double precision rdisti(MAXBINS,10),rdisti2(MAXBINS,10)
      integer itot, i, j, isample
      character*32 filename
c
      if (nocluster) return
      if (task_id.lt.10) then
        write(filename,100) task_id
      else if (task_id.ge.10.and.task_id.lt.100) then
        write(filename,101) task_id
      else if (task_id.ge.100.and.task_id.lt.1000) then
        write(filename,102) task_id
      else if (task_id.ge.1000.and.task_id.lt.10000) then
        write(filename,103) task_id
      endif
  100 format('cl.distr.',i1)
  101 format('cl.distr.',i2)
  102 format('cl.distr.',i3)
  103 format('cl.distr.',i4)
c
c  Evaluate normalized distribution and uncertainty for P(r)
c
      if (mc_cnt.lt.0) return
      norm = dble(mc_cnt)
      do i = 1, mcbins
        rdist(i) = 0.0d00
        rdist2(i) = 0.0d00
        sig2(i) = 0.0d00
        sig2_2(i) = 0.0d00
        sigr(i) = 0.0d00
        sigr2(i) = 0.0d00
        do j = 1, 10
          rdisti(i,j) = 0.0d00
          rdisti2(i,j) = 0.0d00
        end do
      end do
      do j = 1, 10
        normi = dble(r_cnt(j))
        do i = 1, mcbins
          rdist(i) = rdist(i) + dble(r_distr(i,j))/norm
          rdisti(i,j) = dble(r_distr(i,j))/normi
        end do
      end do
      do j = 1, 10
        do i = 1, mcbins
          sig2(i) = sig2(i) + rdisti(i,j)**2
        end do
      end do
      do i = 1, mcbins
        sigr(i) = (sig2(i)-10.0d00*rdist(i)**2)/9.0d00
      end do
c
c  Uncertainty at the 95% confidence level
c
      do i = 1, mcbins
        sigr(i) = 2.23d00*sqrt(sigr(i)/10.d00)
      end do
      sum = 0.0d00
      do i = 1, mcbins
        sum = sum + rdist(i)
      end do
      do i = 1, mcbins
        rdist(i) = rdist(i)/(sum*mc_step)
        sigr(i) = sigr(i)/(sum*mc_step)
      end do
c
c  Evaluate normalized distribution and uncertainty for P(V)
c
      do j = 1, 10
        normi = dble(r_cnt(j))
        do i = 1, mcbins
          r = cl_lower + (dble(i)-0.5d00)*mc_step
          rdist2(i) = rdist2(i) + dble(r_distr(i,j))/(r**2*norm)
          rdisti2(i,j) = dble(r_distr(i,j))/(r**2*normi)
        end do
      end do
      do j = 1, 10
        do i = 1, mcbins
          sig2_2(i) = sig2_2(i) + rdisti2(i,j)**2
        end do
      end do
      do i = 1, mcbins
        sigr2(i) = (sig2_2(i)-10.0d00*rdist2(i)**2)/9.0d00
      end do
c
c  Uncertainty at the 95% confidence level
c
      do i = 1, mcbins
        sigr2(i) = 2.23d00*sqrt(sigr2(i)/10.d00)
      end do
      sum = 0.0d00
      do i = 1, mcbins
        sum = sum + rdist2(i)
      end do
      do i = 1, mcbins
        rdist2(i) = rdist2(i)/(sum*mc_step)
        sigr2(i) = sigr2(i)/(sum*mc_step)
      end do
c
      if (ga_nodeid().eq.0) then
        open(unit=2,file=filename,status='unknown')
        do i = 1, mcbins
          r = cl_lower + (dble(i)-0.5d00)*mc_step
          write(2,200) r, rdist(i), rdist2(i),sigr(i),sigr2(i)
  200     format(f12.4,'    ',f16.8,'    ',f16.8,'       ',
     +           f16.8,'       'f16.8)
        end do
        close(2)
      endif
c
      return
      end
c
      subroutine cluster_clear_binr
#include "common.fh"
c
c  clear the distribution of r_cluster
c
      integer itot, i, j
c
      if (nocluster) return
      do j = 1, 10
        do i = 1, MAXBINS
          r_distr(i,j) = 0
        end do
        r_cnt(j) = 0
      end do
      mc_cnt = 0
      mc_start = istep
c
      return
      end
c
      subroutine cluster_reset_binr(iflg)
#include "common.fh"
c
c   recalculate bounds for confining sphere
c
      integer iflg,ilow,ihi,imax,i
      if (nocluster) return
      if (iflg.eq.1) then
c
c   find minimum and maximum values of distribution and reset
c   windows to just bound these values
c
        if (ga_nodeid().eq.0.and.l_rad) then
          open(unit=3,file="win1.dat",status='unknown')
          do i = 1, mcbins
            write(3,*) i, r_distr(i,1)
          end do
        endif
        ilow = 0
        ihi = 0
        do i = 1, mcbins
          if (r_distr(i,1).gt.0.and.ilow.eq.0) then
            ilow = i-1
            if (ilow.lt.1) ilow = 1
          endif
          if (ilow.gt.0.and.ihi.eq.0.and.r_distr(i,1).eq.0) then
            ihi = i
          endif
        end do
        if (ihi.eq.0) ihi = mcbins
        if (ihi.lt.mcbins) then
          cl_upper = cl_lower + mc_step*dble(ihi)
        endif
        if (ihi.gt.1) then
          cl_lower = cl_lower + mc_step*dble(ilow-1)
        endif
      else if (iflg.eq.2) then
c
c   reset bounds so that maximum is set at radius value that
c   is the maximum value of distribution
c
        ilow = 1
        ihi = 0
        imax = 0
        do i = 1, mcbins
c          if (r_distr(i,1).gt.0.and.ilow.eq.0) then
c            ilow = i-1
c            if (ilow.lt.1) ilow = 1
c          endif
          if (r_distr(i,1).gt.imax) then
            ihi = i
            imax = r_distr(i,1)
          endif
        end do
        if (ihi.eq.0) ihi = mcbins
        if (ihi.lt.mcbins) then
          cl_upper = cl_lower + mc_step*dble(ihi)
        endif
        if (ilow.gt.1) then
          cl_lower = cl_lower + mc_step*dble(ilow-1)
        endif
      endif
      cl_upper = 3.5d00
      cl_lower = 0.5d00
      cl_upper = 4.5d00
      cl_lower = 0.5d00
      mc_step = (cl_upper-cl_lower)/dble(mcbins)
      call cluster_clear_binr
      return
      end
c
      subroutine cluster_do_cllsn
#include "common.fh"
      integer iat, i, j, ii, jj, iloc, isav, scndat
      double precision r, r2, rc2, rx, ry, rz
      double precision rrx, rry, rrz, vvx, vvy, vvz
      double precision vx, vy, vz, fx, fy, fz, mu, v2, f2
      double precision comm(4), tmax, tcut, vrdot
      double precision rnx, rny, rnz, vpx, vpy, vpz, vllx, vlly, vllz
c
c  Re-evaluate all particle velocities. First, recalculate center of
c  mass and center of mass velocity of cluster at new coordinates
c  and velocities.
c
      if (nocluster) return
      cllsn_cnt = cllsn_cnt + 1
      iat = cllsn_idx
      call cluster_com
      if (iat.gt.0) then
        rrx = (cl_mass*cl_cmx - mass(iat)*ra(iat,1,6))/mmass
        rry = (cl_mass*cl_cmy - mass(iat)*ra(iat,2,6))/mmass
        rrz = (cl_mass*cl_cmz - mass(iat)*ra(iat,3,6))/mmass
        vvx = (cl_mass*cl_vcmx - mass(iat)*ra(iat,1,2))/mmass
        vvy = (cl_mass*cl_vcmy - mass(iat)*ra(iat,2,2))/mmass
        vvz = (cl_mass*cl_vcmz - mass(iat)*ra(iat,3,2))/mmass
c
c  The r and v vectors are the relative coordinates and velocities of
c  particle iat and the center of mass vectors. The vector f is the
c  force along this relative coordinate.
c
        rx = ra(iat,1,6) - rrx
        ry = ra(iat,2,6) - rry
        rz = ra(iat,3,6) - rrz
        vx = ra(iat,1,2) - vvx
        vy = ra(iat,2,2) - vvy
        vz = ra(iat,3,2) - vvz
c
c  Decompose velocity v into components that are parallel and perpendicular
c  to r. Save this information for computing post-collision velocities.
c
        r = sqrt(rx**2 + ry**2 + rz**2)
        rnx = rx/r
        rny = ry/r
        rnz = rz/r
        vrdot = vx*rnx + vy*rny + vz*rnz
        vllx = vrdot * rnx
        vlly = vrdot * rny
        vllz = vrdot * rnz
        vpx = vx - vllx
        vpy = vy - vlly
        vpz = vz - vllz
        comm(1) = (vpx-vllx-vx)/cl_mass
        comm(2) = (vpy-vlly-vy)/cl_mass
        comm(3) = (vpz-vllz-vz)/cl_mass
        comm(4) = mmass
      else
        comm(1) = 0.0d00
        comm(2) = 0.0d00
        comm(3) = 0.0d00
        comm(4) = 0.0d00
      endif
      call ga_dgop(8,comm,4,'+')
      vvx = comm(1)
      vvy = comm(2)
      vvz = comm(3)
      mmass = comm(4)
c
      do i = 1, cl_tot
        ii = cl_at(i)
        if (ii.eq.iat) then
          ra(ii,1,2) = ra(ii,1,2) + mmass*vvx
          ra(ii,2,2) = ra(ii,2,2) + mmass*vvy
          ra(ii,3,2) = ra(ii,3,2) + mmass*vvz
        else
          ra(ii,1,2) = ra(ii,1,2) - mass(ii)*vvx
          ra(ii,2,2) = ra(ii,2,2) - mass(ii)*vvy
          ra(ii,3,2) = ra(ii,3,2) - mass(ii)*vvz
        endif
      end do
      call cluster_old_at
c 
      return
      end
c
      subroutine cluster_reset(dt)
#include "common.fh"
      double precision dt, htausq, scale
      integer i, ii
c
c  Reset coordinates and velocities using old values from beginning of
c  step.
c
      htausq = 0.5d00*dt**2
      do i = 1, cl_tot
        ii = cl_at(i)
        ra(ii,1,1) = cl_old(i,1,1)+dt*cl_old(i,1,3)+htausq*ra(ii,1,3)
        ra(ii,2,1) = cl_old(i,2,1)+dt*cl_old(i,2,3)+htausq*ra(ii,2,3)
        ra(ii,3,1) = cl_old(i,3,1)+dt*cl_old(i,3,3)+htausq*ra(ii,3,3)
        ra(ii,1,6) = cl_old(i,1,2)+dt*cl_old(i,1,3)+htausq*ra(ii,1,3)
        ra(ii,2,6) = cl_old(i,2,2)+dt*cl_old(i,2,3)+htausq*ra(ii,2,3)
        ra(ii,3,6) = cl_old(i,3,2)+dt*cl_old(i,3,3)+htausq*ra(ii,3,3)
        ra(ii,1,2) = cl_old(i,1,3)+dt*ra(ii,1,3)
        ra(ii,2,2) = cl_old(i,2,3)+dt*ra(ii,2,3)
        ra(ii,3,2) = cl_old(i,3,3)+dt*ra(ii,3,3)
      end do
#if 1
      do i = 1, sl_tot
        ii = sl_at(i)
        ra(ii,1,1) = sl_old(i,1,1)+dt*sl_old(i,1,3)+htausq*ra(ii,1,3)
        ra(ii,2,1) = sl_old(i,2,1)+dt*sl_old(i,2,3)+htausq*ra(ii,2,3)
        ra(ii,3,1) = sl_old(i,3,1)+dt*sl_old(i,3,3)+htausq*ra(ii,3,3)
        ra(ii,1,6) = sl_old(i,1,2)+dt*sl_old(i,1,3)+htausq*ra(ii,1,3)
        ra(ii,2,6) = sl_old(i,2,2)+dt*sl_old(i,2,3)+htausq*ra(ii,2,3)
        ra(ii,3,6) = sl_old(i,3,2)+dt*sl_old(i,3,3)+htausq*ra(ii,3,3)
        ra(ii,1,2) = sl_old(i,1,3)+dt*ra(ii,1,3)
        ra(ii,2,2) = sl_old(i,2,3)+dt*ra(ii,2,3)
        ra(ii,3,2) = sl_old(i,3,3)+dt*ra(ii,3,3)
      end do
#endif
#if 1
c
c   resete extended Hamiltonian parameters
c
      if ((prsflg.or.ptflg).and.ipmode.eq.0) then
        vol1 = cl_vol1_old + dt * cl_vol2_old + htausq * vol3
        vol2 = cl_vol2_old + dt * vol3
        scale = vol1 / (cl_box_old(1) * cl_box_old(2) * cl_box_old(3))
        scale = exp(log(scale)/3.0d00)
        xbox = scale * cl_box_old(1)
        ybox = scale * cl_box_old(2)
        zbox = scale * cl_box_old(3)
        xbox2 = 0.5d00 * xbox
        ybox2 = 0.5d00 * ybox
        zbox2 = 0.5d00 * zbox
      endif
c
      if ((prsflg.or.ptflg).and.ipmode.eq.1) then
        do 500 i = 1, 3
          alen1(i) = cl_alen1_old(i) + dt * cl_alen2_old(i)
     +             + htausq * alen3(i)
          alen2(i) = cl_alen2_old(i) + dt * alen3(i)
  500   continue
        xbox = alen1(1)
        ybox = alen1(2)
        zbox = alen1(3)
        xbox2 = 0.5d00 * xbox
        ybox2 = 0.5d00 * ybox
        zbox2 = 0.5d00 * zbox
      endif
c
      if ((prsflg.or.ptflg).and.ipmode.eq.2) then
        do 600 i = 1, 2
          alen1(i) = cl_alen1_old(i) + dt * cl_alen2_old(i)
     +             + htausq * alen3(i)
          alen2(i) = cl_alen2_old(i) + dt * alen3(i)
  600   continue
        xbox = alen1(1)
        ybox = alen1(2)
        xbox2 = 0.5d00 * xbox
        ybox2 = 0.5d00 * ybox
      endif
c
c   predictor step for time scale
c
      if (tmpflg.or.ptflg) then
        scal1 = cl_scal1_old + dt * cl_scal2_old + htausq * scal3
        scal2 = cl_scal2_old + dt * scal3 
      endif
c
c   center of mass parameters
c
      cl_cmx = cl_cm_old(1)
      cl_cmy = cl_cm_old(2)
      cl_cmz = cl_cm_old(3)
      cl_vcmx = cl_vcm_old(1)
      cl_vcmy = cl_vcm_old(2)
      cl_vcmz = cl_vcm_old(3)
#endif
      return
      end

        subroutine tce_mrcc_gacp(g_a,g_b,pga,size)
        implicit none
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
#include "tce_main.fh"

        integer g_a,g_b
        integer pga
        integer size
        integer l_buff,k_buff
        integer chunksize
        integer i,ntask,j
        integer istart,iend
        integer count,next,nprocs
        integer nxtasksub
        external nxtasksub

        nprocs = GA_PGROUP_NNODES(pga)
        count = 0
        next = nxtasksub(nprocs,1,pga)

        chunksize = pgbsize*pgbsize*pgbsize
        ntask = size/chunksize

        if(ntask.eq.0)ntask=1
        if((ntask*chunksize).lt.size)ntask=ntask+1

c        if(ga_pgroup_nodeid(pga).eq.0)
c     1 write(LuOut,"('CHUNKSIZE:',I10,' SIZE:',I12,' NTASK:',I10)")
c     2 chunksize,size,ntask

        do i=1,ntask

        if(count.eq.next) then


        if (.not.ma_push_get(mt_dbl,chunksize,'buff',l_buff,
     1  k_buff)) call errquit('tce_mrcc_gacp: MA problem',1,
     2  MA_ERR)

        do j=1,chunksize
          dbl_mb(k_buff+j-1)=0.0d0
        enddo

        istart = (i-1)*chunksize+1
        iend = i*chunksize

        if(iend.gt.size)iend=size

        call ga_get(g_a,istart,iend,1,1,dbl_mb(k_buff),1)
        call ga_put(g_b,istart,iend,1,1,dbl_mb(k_buff),1)

        if (.not.ma_pop_stack(l_buff))
     1  call errquit('tce_mrcc_gacp: MA problem',2,MA_ERR)

        next = nxtasksub(nprocs,1,pga)

        endif

        count = count + 1

        enddo

        next = nxtasksub(-nprocs,1,pga)
        call ga_pgroup_sync(pga)

        return
        end

        subroutine tce_mrcc_daxp(n,coefficients,g_a,g_b,size,iref)
        implicit none
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
#include "tce_main.fh"

        integer g_a(maxdiism,maxref),g_b
        integer pga
        integer size
        integer l_buff,k_buff,l_buff2,k_buff2
        integer chunksize
        integer i,ntask,j,k
        integer istart,iend
        integer count,next,nprocs
        integer nxtasksub
        external nxtasksub
        integer n,iref
        double precision coefficients(*)

        pga = int_mb(k_innodes+ga_nnodes()+ga_nodeid()) 

        nprocs = GA_PGROUP_NNODES(pga)
        count = 0
        next = nxtasksub(nprocs,1,pga)

        chunksize = pgbsize*pgbsize*pgbsize
        ntask = size/chunksize

        if(ntask.eq.0)ntask=1
        if((ntask*chunksize).lt.size)ntask=ntask+1

        do i=1,ntask

        if(count.eq.next) then

        if (.not.ma_push_get(mt_dbl,chunksize,'buff',l_buff,
     1  k_buff)) call errquit('tce_mrcc_gacp: MA problem',1,
     2  MA_ERR)

        if (.not.ma_push_get(mt_dbl,chunksize,'buff2',l_buff2,
     1  k_buff2)) call errquit('tce_mrcc_gacp: MA problem',3,
     2  MA_ERR)

        do j=1,chunksize
          dbl_mb(k_buff+j-1)=0.0d0
          dbl_mb(k_buff2+j-1)=0.0d0
        enddo

        istart = (i-1)*chunksize+1
        iend = i*chunksize

        if(iend.gt.size)iend=size

        do k=1,n

        call ga_get(g_a(k,iref),istart,iend,1,1,dbl_mb(k_buff),1)

        do j=1,chunksize
          dbl_mb(k_buff2+j-1) = dbl_mb(k_buff2+j-1) +
     1 coefficients(k) * dbl_mb(k_buff+j-1)
        enddo
        enddo

        call ga_put(g_b,istart,iend,1,1,dbl_mb(k_buff2),1)

        if (.not.ma_pop_stack(l_buff2))
     1  call errquit('tce_mrcc_gacp: MA problem',4,MA_ERR)

        if (.not.ma_pop_stack(l_buff))
     1  call errquit('tce_mrcc_gacp: MA problem',2,MA_ERR)

        next = nxtasksub(nprocs,1,pga)

        endif

        count = count + 1

        enddo

        next = nxtasksub(-nprocs,1,pga)
        call ga_pgroup_sync(pga)

        return
        end



c $Id: tce_mrcc_gacp.F 24345 2013-06-22 06:19:30Z d3y133 $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     rimp2_v_e2 -- Evaluate MP2 energy using V-approximation 3 ctr ints.
C
C REVISION
C     $Id: rimp2_v_e2.F 24516 2013-08-16 01:59:29Z edo $
C
C SYNOPSIS
      Logical Function RIMP2_V_E2( rtdb, D_Int, FNInt, TopSpin, NMO,
     $   NOcc, NVir, NFit, FitBas, Eig, LDEig, Contrib, E2,
     $   Mem_Opt, IBlock, JBlock,actualname)
      Implicit NONE
C
      Character*(*) FNInt
      Integer TopSpin, D_Int(TopSpin), NMO(TopSpin), NFit, FitBas,
     $   IBlock, JBlock, LDEig, rtdb
      Integer NOcc(TopSpin), NVir(TopSpin)
      Double precision Eig(LDEig, TopSpin), Contrib(TopSpin, TopSpin)
      Double precision E2
      Character*(*) Mem_Opt,actualname
C
C ARGUMENTS
C     rtdb     Handle for run-time database [IN]
C     D_Int    Handles for integral files [IN]
C     FNInt    File name for MO basis 3-center integrals [IN]
C     TopSpin  Number of spins in reference (RHF=1, UHF=2) [IN]
C     NMO      Number of MOs [IN]
C     NOcc     Number of occupied orbitals for each spin [IN]
C     NVir     Number of virtual orbitals for each spin [IN]
C     NFit     Number of functions in fitting basis [IN]
C     FitBas   Handle for fitting basis [IN]
C     Eig      Eigenvalues of reference Fock matrix [IN]
C     Contrib  E(2) broken down by spin case. (The ba, or 2,1 element
C              is always zero) [OUT]
C     E2       The second order MBPT energy [OUT]
C     Mem_Opt  Memory allocation optimization mode [IN]
C     IBlock   User-requested blocksize [IN]
C     JBlock   User-requested blocksize [IN]
C
C RETURN VALUE
C     .TRUE.   If calculation completed successfully.
C     .FALSE.  If an error occurred.
C 
C DESCRIPTION
C     Computes the second order perturbation theory (MBPT(2), MP2)
C     contribution to the correlation energy using 3-center integrals
C     to approximate the usual four-center two-electron integrals
C     in the "V-approximation" of Vahtras, Almlof, and Feyereisen.
C     The 3-center integrals are obtained through calls to the function
C     Get_3ci_block.  Both RHF and UHF canonical references are handled.
C
C REFERENCES
C     Feyereisen, Fitzgerald, and Komornicki, Chem. Phys. Lett. 208,
C     359 (1993).
C     Vahtras, Almlof, and Feyereisen, ?
C
C NOTES
C     There are a couple of problems with the present algorithm.
C     Mainly it does things one block at a time.  This is going to be
C     inefficient if one wants to try to do this directly rather than
C     from disk, because we can probably store more than one block at
C     a time in core.  The other point is that the load balance is not
C     necessarily spectacular -- only those nodes which end up with 
C     data on them will be involved in the work.  In particular, since
C     the G_A and G_B matrices are only O(N^2), and we want to keep
C     the block sizes reasonable, they may not be spread out across the
C     whole machine.
C
C MEMORY USE
C     Global: 2*NVir*NFit + NVir*NVir
C
C INCLUDE FILES
#include "global.fh"
#include "mafdecls.fh"
#include "numerical_constants.fh"
#include "stdio.fh"
#include "rimp2_timers.fh"
#include "util.fh"
#include "rtdb.fh"
C
C EXTERNAL ROUTINES
      Logical Open_3ci_File, Get_3cInts, Close_3cI_File,
     $  GA_Create_One_By_Shells
      External Open_3cI_File, Get_3cInts, Close_3cI_File,
     $  GA_Create_One_By_Shells
C
      external Sum_Pairs
      Double Precision Sum_Pairs
      Integer LNBlnk
      External LNBlnk
#ifdef BAD_GACCESS
      External rimp2_ddotp
      Double precision rimp2_ddotp
#endif
c$$$C
c$$$      External GA_DASum_Patch, GA_DAMax_Patch
c$$$      Double precision GA_DASum_Patch, GA_DAMax_Patch
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C PARAMETERS
C
      Integer MinChunk             ! Minimum panel size that is reasonable
      Parameter ( MinChunk = -64)  ! for global distribution of data
C
C LOCAL VARIBLES
      Integer I, J, ISpin, JSpin, JTop, JTop2
      Integer Proc
      Double Precision Fact, PairE
      Logical Status, PermSym
      Integer G_bigI, ILo, IHi, NI, G_bigJ, JLo, JHi, NJ, G_bigA, G_BigB
      Integer HH_PairE, IH_PairE
c$$$      Double precision ChkSum, MxElem
      Character*255 String1
      Integer NewIBlk, NewJBlk
      Logical PrInfo
c
      double precision fss, fos ! Spin Component Scaled (SCS) MP2
      logical scs               ! SCS flag
C
      Call GA_Sync
      Call PStat_On(PS_Energy)
C
      PrInfo = Util_Print('information', Print_Low)
C
C     ************************
C     * Check inputs & setup *
C     ************************
C
      If (TopSpin .lt. 1 .OR. TopSpin .gt. 2) then
         Write (LuErr, *) ' Bad value of TopSpin ', TopSpin
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf
      If (LDEig .lt. 1) then
         Write (LuErr, *) ' Bad value of LDEig ', LDEig
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf
      If (NOcc(1) .lt. 0 .OR. NOcc(TopSpin) .lt. 0) then
         Write (LuErr, *) ' Bad value of NOcc ', NOcc
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf
      If (NVir(1) .lt. 0 .OR. NVir(TopSpin) .lt. 0) then
         Write (LuErr, *) ' Bad value of NVir ', NVir
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf
      If (NOcc(1) + NVir(1) .gt. NMO(1)
     $   .OR. NOcc(TopSpin) + NVir(TopSpin) .gt. NMO(TopSpin) ) then
         Write (LuErr, *) ' Bad value of NOcc+NVir ', NOcc, '+', NVir
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf
      If (NFit .lt. 1) then
         Write (LuErr, *) ' Bad value of NFit ', NFit
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf

c     flag and scaling factors for SCS-MP2
      if (.not. rtdb_get(rtdb, 'mp2:scs', mt_log, 1, scs))
     $  scs = .false.       ! flag for SCS
      if (scs) then
         if (.not. rtdb_get(rtdb, 'mp2:fss', mt_dbl, 1, fss))
     $     fss = 1.0d0/3.0d0   ! same spin scaling factor for SCS-MP2
         if (.not. rtdb_get(rtdb, 'mp2:fos', mt_dbl, 1, fos))
     $     fos = 1.2d0         ! opposite spin scaling factor for SCS-MP2
      else
         fss = 1.0d0
         fos = 1.0d0
      endif


C
C     Get my processor number
C
      Proc = GA_NodeID()
C
C     Clear out the energy contribution matrix
C
      Call dlaset('Full', TopSpin, TopSpin, FP_Zero, FP_Zero,
     $     Contrib, TopSpin)
C
      Status = .TRUE.
      Status = Status .AND. MA_Push_Get(MT_Int, 2*TopSpin-1,
     $   'Pair energy handles', HH_PairE, IH_PairE)
      If ( .NOT. Status ) then
         Write (LuErr, *) ' Unable to allocate Pair energy handles'
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf

C
      Do ISpin = 1, TopSpin
         Do JSpin = ISpin, TopSpin
            Status = Status .AND.
     $         GA_Create( MT_Dbl, NOcc(ISpin), NOcc(JSpin),
     $         'Pair Energies', MinChunk, MinChunk,
     $         Int_MB(IH_PairE + ISpin + JSpin - 2) )
            If ( .NOT. Status ) then
              Write (LuErr, *) ' Unable to allocate Pair energy handles'
              RIMP2_V_E2 = .FALSE.
              Return
            EndIf
            Call GA_Zero( Int_MB(IH_PairE + ISpin + JSpin - 2 ) )
         EndDo
      EndDo
C
C     ***************************
C     * Determine loop blocking *
C     ***************************
C
      Call RIMP2_E_Mem(TopSpin, NOcc, NVir, FitBas, Mem_Opt,
     $   NewIBlk, NewJBlk)
      If ( IBlock .le. 0) then
         IBlock = NewIBlk
      Else
         IBlock = Min(IBlock, NewIBlk)
      EndIf
      If ( JBlock .le. 0) then
         JBlock = NewJBlk
      Else
         JBlock = Min(JBlock, NewJBlk)
      EndIf
C
      If ( PrInfo .AND. GA_NodeID() .eq. 0)
     $   Write (LUOut, 9100) IBlock, JBlock
 9100 Format(1X, 'Energy evaluation using block sizes ', 2I5)
C
C     *****************************************************************
C     * Loop over occupied orbitals of both spins for the first index *
C     *****************************************************************
C
      Do ISpin = 1, TopSpin
C
C        Create the global array for the I block
C
         Status = GA_Create_One_By_Shells( MT_Dbl,
     $      Min( NOcc(ISpin), IBlock) * NVir(ISpin), FitBas,
     $      'Integral matrix 1', G_bigI)
C
         If ( .NOT. Status ) then
            Write (LuErr, *) ' Unable to allocate for big I block'
            RIMP2_V_E2 = .FALSE.
            Return
         EndIf
C
C        Open integral file
C
         Status = Open_3ci_file(D_Int(ISpin), FNInt, ISpin,
     $      NVir(ISpin), NOcc(ISpin), G_bigI,actualname)
#ifdef DEBUG
         write(luout,*) ga_nodeid(),' ve2 opened FD ',D_Int(ISpin)
         call util_flush(luout)
#endif
         If ( .NOT. Status ) then
            Write (LuErr, *) 'RIMP2_v_E2:  Problems opening ',
     $         'integral file for spin ', ISpin, '!'
            RIMP2_v_E2 = .FALSE.
            Return
         EndIf
C
         Do ILo = 1, NOcc(ISpin), IBlock
            IHi = Min( NOcc(ISpin), ILo + IBlock - 1)
            NI = IHi - ILo + 1
C
C           Get integrals (ia|s') for this I
C
            Call PStat_On( PS_Rd_3ci)
            If ( .NOT. Get_3cInts(D_Int(ISpin), G_bigI, NVir(ISpin),
     $         ILo, IHi) ) then
               Write( LuErr, *) ' Unable to get integral block ',
     $            I, ISpin
               RIMP2_V_E2 = .FALSE.
               Return
            EndIf
            Call PStat_Off( PS_Rd_3ci)
C
            If ( Util_Print('3c ints', Print_Debug) )
     $         Call GA_Print( G_bigI )
C
C           *************************
C           * Second occupied index *
C           *************************
C           Should cover both spins if I is alpha, giving the pure 
C           alpha and mixed spin components, but only beta Js are 
C           required when I is beta -- only the pure beta 
C           contribution is left.
C
            Do JSpin = ISpin, TopSpin
C
C              Open integral file if JSpin != ISpin
C              NOTE: This routine gets the distribution of the fitting
C              basis from the GA that's passed in.  We don't create the
C              real target array for these guys until a little later,
C              but we can use G_bigI here because the fitting basis will
C              not change with the spin case.
C
               If ( JSpin .ne. ISpin) then
                  Status = Open_3ci_file(D_Int(JSpin), FNInt, JSpin,
     $               NVir(JSpin), NOcc(JSpin), G_bigI,actualname)
                  If ( .NOT. Status ) then
                     Write (LuErr, *) 'RIMP2_v_E2:  Problems opening ',
     $                  'integral file for spin ', JSpin, ' !'
                     RIMP2_v_E2 = .FALSE.
                     Return
                  EndIf
               EndIf
C
C              Use permutational symmetry if possible
C
               If ( ISpin .eq. JSpin) then
                  JTop = IHi
                  PermSym = .TRUE.
               Else
                  JTop = NOcc(JSpin)
                  PermSym = .FALSE.
               EndIf
C              
               Do JLo = 1, JTop, JBlock
                  JHi = Min( JTop, JLo + JBlock - 1)
                  NJ = JHi - JLo + 1
C
C                 Create GAs for result of multiplication and
C                 second set of integrals (J).  Do the result matrix
C                 first so GA's are treated like a stack to avoid
C                 a big hole when the J is freed and we continue using A.
C
                  If ( .NOT. GA_Create( MT_Dbl, NI*NVir(ISpin),
     $               NJ*NVir(JSpin), 'Temporary matrix big A', MinChunk,
     $               MinChunk, G_bigA) ) then
                     Write (LuErr, *) ' Unable to allocate big A'
                     RIMP2_V_E2 = .FALSE.
                     Return
                  EndIf
C
                  Status = GA_Create_One_By_Shells( MT_Dbl,
     $               NJ * NVir(JSpin), FitBas,
     $               'Integral matrix 2', G_bigJ)
C
                  If ( .NOT. Status ) then
                     Write (LuErr, *) ' Unable to allocate integral ',
     $                  ' block ', J, JSpin
                     RIMP2_V_E2 = .FALSE.
                     Return
                  EndIf
C
C                 Find the integrals (jb|s') for this J.  Try to use
C                 the I patch if possible.  For simplicity, we
C                 must get the _whole_ patch from I because Get_3cInts
C                 doesn't understand GA patches.
C                 
                  If ( ISpin .eq. JSpin .AND. JLo .ge. ILo
     $               .AND. JHi .le. IHi) then
                     Call GA_Sync
#ifdef BAD_GACCESS
                     Call rimp2_copypp('N',
#else
                     Call GA_Copy_Patch('N',
#endif
     $                  G_BigI, (JLo-ILo)*NVir(JSpin)+1,
     $                          (JHi-ILo+1)*NVir(JSpin), 1, NFit,
     $                  G_bigJ, 1, NJ*NVir(JSpin),       1, NFit )
                     Call GA_Sync
                  Else
                     Call PStat_On( PS_Rd_3ci)
                     If ( .NOT. Get_3cInts(D_Int(JSpin), G_bigJ,
     $                  NVir(JSpin), JLo, JHi) ) then
                        Write( LuErr, *)
     $                     ' Unable to get integral block ',
     $                     JLo, JSpin
                        RIMP2_V_E2 = .FALSE.
                        Return
                     EndIf
                     Call PStat_Off( PS_Rd_3ci)
                  EndIf
C
                  If ( Util_Print('3c ints', Print_Debug) )
     $               Call GA_Print( G_bigJ )
C
C                 ******************************************************
C                 * Form a block of four-center two-electron integrals *
C                 ******************************************************
C                 from these three-center things:
C                    (ia|jb) = (ia|s')(s'|jb)
C                 where the |s') = V^{-1/2} |s) has been done
C                 as part of the transformation.
C
                  Call GA_Sync
                  Call PStat_On( PS_form_4ci)
                  Call GA_DGEMM('N', 'T',
     $               NI*NVir(ISpin), NJ* NVir(JSpin), NFit,
     $               FP_One, G_bigI, G_bigJ, FP_Zero, G_bigA)
                  Call PStat_Off( PS_form_4ci)
C
                  If ( Util_Print('progress reports', Print_Default))
     $               then
                     String1 = ' ' ! Note all machines initialize mem.
                     Write (String1, 9210) ILo, IHi, JLo, JHi
                     Call Progress_Report(LuOut,
     $                  String1(:LNBlnk(String1)))
 9210                Format('RIMP2_V_E2: Approx. ints. done (',
     $                  I5, ':', I5, ',', I5, ':', I5, ')')
                  EndIf
C
                  If ( Util_Print('4c ints', Print_Debug) )
     $               Call GA_Print( G_bigA )
C
C                 The J integral block is no longer needed and can
C                 now be freed.  This alows us to reuse the space
C                 to hold the temporary matrix B for the other
C                 half of this iteration.
C
                  If ( .NOT. GA_Destroy( G_bigJ) ) then
                     Write (LuErr, *) ' Unable to free integral block ',
     $                  JLo, JSpin
                     RIMP2_V_E2 = .FALSE.
                     Return
                  EndIf
C
C                 Now we have a matrix of (approximate) 4c2e integrals
C                 for this particular IJ.
C
C                 The E(2) energy is a dot product of this matrix
C                 with a linear combination of the matrix and its
C                 transpose. Make the necessary workspace and initialize
C                 it with a copy of A.
C
                  If ( .NOT. GA_Create( MT_Dbl, NI*NVir(ISpin),
     $               NJ*NVir(JSpin), 'Temporary matrix big B', MinChunk,
     $               MinChunk, G_bigB) ) then
                     Write (LuErr, *) ' Unable to allocate big B'
                     RIMP2_V_E2 = .FALSE.
                     Return
                  EndIf
C
C                 ********************************************
C                 * Form the B matrix, which is related to A *
C                 ********************************************
C                 Term          A                  B
C                 RHF        (IA|JB)     2 (IA|JB) - (IB|JA)
C                 UHF AA     (IA|JB)       (IA|JB) - (IB|JA)
C                 UHF Ab     (IA|jb)       (IA|jb) 
C                 UHF bb     (ia|jb)       (ia|jb) - (ib|ja)
C
C                 Introducing SCS scaling, the above table transforms into
C
C                 Term          A                           B
C                 RHF        (IA|JB)      (fss+fos) (IA|JB) - fss (IB|JA)
C                 UHF AA     (IA|JB)         fss    (IA|JB) - fss (IB|JA)
C                 UHF Ab     (IA|jb)         fos    (IA|jb) 
C                 UHF bb     (ia|jb)         fss    (ia|jb) - fss (ib|ja)
C
C                 Where fss and fos are the same-spin and opposite-spin scaling
C                 factors, respectively. In the conventional case we have 
C                 fss = fos = 1.0, and we recover the previous expressions.
C
C                 So in every case except UHF Ab, we can initialize
C                 B with A transpose, but on a block-wise basis.
C
                  Call GA_Sync
                  Call PStat_On( PS_form_ab)
                  If ( PermSym ) then
                     Call GA_Zero(G_bigB)
C
                     Do I = ILo, IHi
C
C                       Use permutational symmetry if possible
C                       (already know that ISpin .eq. JSpin)
C                       
                        If ( ILo .eq. JLo .AND. IHi .eq. JHi) then
                           JTop2 = I
                        Else
                           JTop2 = JHi
                        EndIf
C
                        Do J = JLo, JTop2
C
C                          Copy from an IJ block of A to the 
C                          coresponding IJ block of B, but with
C                          transposition.  This routine is data parallel
C                          in that nodes which don't have any part of
C                          the patch to be copies will just fall through
C                          and immediately go on to the next loop
C                          iteration.
C
#ifdef BAD_GACCESS
                     Call rimp2_copypp('T',
#else
                           Call GA_Copy_Patch('T',
#endif
     $                        G_bigA, (I-ILo)*NVir(ISpin)+1,
     $                                (I-ILo+1)*NVir(ISpin),
     $                                (J-JLo)*NVir(JSpin)+1,
     $                                (J-JLo+1)*NVir(JSpin),
     $                        G_bigB, (I-ILo)*NVir(ISpin)+1,
     $                                (I-ILo+1)*NVir(ISpin),
     $                                (J-JLo)*NVir(JSpin)+1,
     $                                (J-JLo+1)*NVir(JSpin) )
                        EndDo
                     EndDo
C
C                    Now we must make sure everyone has a consistent
C                    copy of B before moving on.
C
                     Call GA_Sync
C
C                    Scale B and add some multiple of A to it,
C                    according to the SCS scaling above
C
                     Fact = fss + fos * Dble( 2 - TopSpin )
                     Call GA_DAdd( Fact, G_bigA, -fss, G_bigB,
     $                  G_bigB)
                  Else
C
C                    For the mimxed-spin case, its just a straight copy
C
                     Call GA_Copy( G_bigA, G_bigB)
                     if ( fos .ne. 1.0d0 ) call GA_Dscal( G_bigB, fos )
                  EndIf
                  Call PStat_Off( PS_form_ab)
C
                  If ( Util_Print('progress reports', Print_Default))
     $               then
                     String1 = ' ' ! Note all machines initialize mem.
                     Write (String1, 9220) ILo, IHi, JLo, JHi
                     Call Progress_Report(LuOut,
     $                  String1(:LNBlnk(String1)))
 9220                Format('RIMP2_V_E2: Copy to B done (',
     $                  I5, ':', I5, ',', I5, ':', I5, ')')
                  EndIf
C
                  If ( Util_Print('4c ints b', Print_Debug) )
     $               Call GA_Print( G_bigB )
C
C                 ***************************
C                 * Apply denominators to B *
C                 ***************************
C                 Each processor does this on the panel of B it owns.
C
                  Call GA_Sync
                  Call PStat_On( PS_denom)
                  Call RIMP2_Denom( G_bigB, ILo, JLo, NVir(ISpin),
     $               NVir(JSpin), Eig(1, ISpin), Eig(1, JSpin),
     $               Eig(1+NOcc(ISpin), ISpin),
     $               Eig(1+NOcc(JSpin), JSpin) )
                  Call PStat_Off( PS_denom)
C
                  If ( Util_Print('progress reports', Print_Default))
     $               then
                     String1 = ' ' ! Note all machines initialize mem.
                     Write (String1, 9230) ILo, IHi, JLo, JHi
                     Call Progress_Report(LuOut,
     $                  String1(:LNBlnk(String1)))
 9230                Format('RIMP2_V_E2: Denominators done (',
     $                  I5, ':', I5, ',', I5, ':', I5, ')')
                  EndIf
C
                  If ( Util_Print('amplitudes', Print_Debug) )
     $               Call GA_Print( G_bigB )
C
C                 ***********************
C                 * Form IJ pair energy *
C                 ***********************
C                 Another data parallel routine.
C
                  Call GA_Sync
                  Call PStat_On(PS_PrEn)
C
                  Do I = ILo, IHi
C
C                    Use permutational symmetry if possible
C                       
                     If ( (ILo .eq. JLo .AND. IHi .eq. JHi) 
     $                  .AND. PermSym) then
                        JTop2 = I
                     Else
                        JTop2 = JHi
                     EndIf
C
                     Do J = JLo, JTop2
C
#ifdef BAD_GACCESS
                     paire=rimp2_ddotp(
#else
                        PairE = GA_DDot_Patch(
#endif
     $                     G_bigA, 'N', (I-ILo)*NVir(ISpin)+1,
     $                                  (I-ILo+1)*NVir(ISpin),
     $                                  (J-JLo)*NVir(JSpin)+1,
     $                                  (J-JLo+1)*NVir(JSpin),
     $                     G_bigB, 'N', (I-ILo)*NVir(ISpin)+1,
     $                                  (I-ILo+1)*NVir(ISpin),
     $                                  (J-JLo)*NVir(JSpin)+1,
     $                                  (J-JLo+1)*NVir(JSpin) )
#ifndef BAD_GACCESS
                        PairE = PairE/ga_nnodes()
#endif
C
C                       If this turns out to be too much traffic, we
C                       might want to create a local array to contain
C                       only our IJs and accumulate into it.  But
C                       wait until perfomance says we need to.  For
C                       now, we'll just avoid sending zeros across
C                       the machine.
C
                        If ( PairE .ne. FP_Zero )
     $                     Call GA_Acc(
     $                        Int_MB( IH_PairE + ISpin + JSpin - 2),
     $                        I, I, J, J, PairE, 1, FP_One)
                     EndDo
                  EndDo
                  Call PStat_Off(PS_PrEn)
C
                  If ( Util_Print('partial pair energies', Print_Debug))
     $               Call GA_Print(
     $                        Int_MB( IH_PairE + ISpin + JSpin - 2) )
C
C                 Free up these matrices -- the space can be reused for
C                 the J integral matrix, and their sizes may change when
C                 the spin cases change.
C                 
                  If ( .NOT. GA_Destroy( G_bigB) ) then
                     Write (LuErr, *) ' Unable to free big B'
                     RIMP2_V_E2 = .FALSE.
                     Return
                  EndIf
                  If ( .NOT. GA_Destroy( G_bigA) ) then
                     Write (LuErr, *) ' Unable to free big A'
                     RIMP2_V_E2 = .FALSE.
                     Return
                  EndIf
C
                  If ( Util_Print('progress reports', Print_Default))
     $               then
                     String1 = ' ' ! Note all machines initialize mem.
                     Write (String1, 9200) ILo, IHi, JLo, JHi
                     Call Progress_Report(LuOut,
     $                  String1(:LNBlnk(String1)))
 9200                Format('RIMP2_V_E2: Completed block (',
     $                  I5, ':', I5, ',', I5, ':', I5, ')')
                  EndIf
C
               EndDo            ! J (blocks)
            EndDo               ! JSpin
         EndDo                  ! I (blocks)
C
C        This may change size with the next spin case
C
         If ( .NOT. GA_Destroy( G_bigI) ) then
            Write (LuErr, *) ' Unable to free big I integral block'
            RIMP2_V_E2 = .FALSE.
            Return
         EndIf
C        
      EndDo                     ! ISpin
C
C     ************************
C     * Close & delete files *
C     ************************
C
      Status = .TRUE.
      Do ISpin = 1, TopSpin
         Status = Status .AND. Close_3cI_File( D_Int(ISpin), 'DELETE',
     ,        actualname)
      EndDo
C
      If ( .NOT. Status ) then
         Write (LuErr, *) 'RIMP2_V_E2:  Problems closing ',
     $      'integral file(s)!'
         RIMP2_V_E2 = .FALSE.
         Return
      EndIf
C
C     ***********************
C     * Print pair energies *
C     ***********************
C
      If ( Util_Print('pair energies', Print_Debug) ) then
         If ( Proc .eq. 0 ) then
            If ( TopSpin .eq. 1) then
               Call Banner(LuOut,
     $            'Pair Correlation Energies (spin adapted)',
     $            '-', .TRUE., .TRUE., .FALSE.)
            Else
               Call Banner(LuOut, 'Pair Correlation Energies',
     $            '-', .TRUE., .TRUE., .FALSE.)
            EndIf
         EndIf
C
         Do ISpin = 1, TopSpin
            Do JSpin = ISpin, TopSpin
               Call GA_Print( Int_MB(IH_PairE+ISpin+JSpin-2) )
            EndDo
         EndDo
      EndIf
C
C     ***********************************
C     * Compute total energy from pairs *
C     ***********************************
C
      Do ISpin = 1, TopSpin
         Do JSpin = ISpin, TopSpin
            Contrib(ISpin, JSpin) =
     $         Sum_Pairs( Int_MB(IH_PairE+ISpin+JSpin-2) ,
     $         ISpin .eq. JSpin)
         EndDo
      EndDo
C
C     ***************************
C     * Finished with the pairs *
C     ***************************
C
      Do ISpin = 1, TopSpin
         Do JSpin = ISpin, TopSpin
            Status = GA_Destroy( Int_MB(IH_PairE+ISpin+JSpin-2) )
         EndDo
      EndDo
C
      Status = Status .AND. MA_Pop_Stack(HH_PairE)
C
C     *****************************************************
C     * For UHF case, pure spin components must be scaled *
C     *****************************************************
C
      If ( TopSpin .eq. 2)
     $   Call dscal(TopSpin, FP_Half, Contrib, TopSpin+1)
C
C     *************************************
C     * And the total from the components *
C     *************************************
C     This means the caller doesn't have to fiddle with anything
C     if only the total correlation energy is important.
C
      E2 = FP_Zero
      Do JSpin = 1, TopSpin
         Do ISpin = 1, TopSpin
            E2 = E2 + Contrib(ISpin, JSpin)
         EndDo
      EndDo
C
      Call GA_Sync
      Call PStat_Off(PS_Energy)
C
      RIMP2_V_E2 = .TRUE.
      Return
      End
#ifdef BAD_GACCESS
      double precision function rimp2_ddotp(
     $                     g_a, tra, ailo,aihi,ajlo,ajhi,
     $                     g_b, trb, bilo,bihi,bjlo,bjhi)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      integer g_a, ailo,aihi,ajlo,ajhi,
     $        g_b, bilo,bihi,bjlo,bjhi
      character *1 tra,trb
      double precision ddot
      external ddot
c
      integer n,lda,ldb
      integer k_a,l_a,k_b,l_b
      integer me,iloa,ihia,jloa,jhia
c
      if(tra.ne.'N'.or.trb.ne.'N') call errquit(
     $ 'rimp2ddot not ready ',0,0)
      lda=aihi-ailo+1
      me=ga_nodeid()
      rimp2_ddotp=0d0
c
c     check intersect
c
      call ga_distribution(g_a, me,iloa,ihia,jloa,jhia)
      if( ihia.lt. ailo.or. aihi.lt.iloa) return 
      if( jhia.lt.ajlo.or. ajhi.lt.jloa) return 

      ldb=bihi-bilo+1
      n=(ajhi-ajlo+1)*(aihi-ailo+1)
      if(.not.ma_push_get(MT_DBL,(aihi-ailo+1)*(ajhi-ajlo+1),
     $  'scratch buff', l_a, k_a)) call
     $  errquit('rimp2_ddot: pushget failed',0,0)
      if(.not.ma_push_get(MT_DBL,(bihi-bilo+1)*(bjhi-bjlo+1),
     $  'scratch buff', l_b, k_b)) call
     $  errquit('rimp2_ddot: pushget failed',0,0)

      call ga_get(g_a,ailo,aihi,ajlo,ajhi,dbl_mb(k_a),lda)
      call ga_get(g_b,bilo,bihi,bjlo,bjhi,dbl_mb(k_b),ldb)
      rimp2_ddotp=ddot(n,dbl_mb(k_a),1,dbl_mb(k_b),1)
      if(.not.ma_pop_stack(l_b)) call 
     $  errquit('riddot: popstack failed',0,0)
      if(.not.ma_pop_stack(l_a)) call 
     $  errquit('riddot: popstack failed',0,0)
c
      return
      end
      subroutine rimp2_copypp(trans, g_a, ailo, aihi, ajlo, ajhi,
     *     g_b, bilo, bihi, bjlo, bjhi)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
      character *1 trans 
      integer g_a, ailo, aihi, ajlo, ajhi,
     *     g_b, bilo, bihi, bjlo, bjhi
c
      integer n,lda,ldb
      integer k_a,l_a,k_b,l_b
      integer me,iloa,ihia,jloa,jhia
c
      lda=aihi-ailo+1
      ldb=bihi-bilo+1
      n=(ajhi-ajlo+1)*(aihi-ailo+1)
c
c     check intersect
c
      me=ga_nodeid()
      call ga_distribution(g_a, me,iloa,ihia,jloa,jhia)
      if( ihia.lt. ailo.or. aihi.lt.iloa) return 
      if( jhia.lt.ajlo.or. ajhi.lt.jloa) return 
      if(.not.ma_push_get(MT_DBL,(aihi-ailo+1)*(ajhi-ajlo+1),
     $  'scratch buff', l_a, k_a)) call
     $  errquit('rimp2_ddot: pushget failed',0,0)
      if (trans.ne.'N') then
         if(.not.ma_push_get(MT_DBL,(bihi-bilo+1)*(bjhi-bjlo+1),
     $        'scratch buff', l_b, k_b)) call
     $        errquit('rimp2_ddot: pushget failed',0,0)
      endif

      call ga_get(g_a,ailo,aihi,ajlo,ajhi,dbl_mb(k_a),lda)
      if(trans.eq.'N') then
         call ga_put(g_b,bilo,bihi,bjlo,bjhi,dbl_mb(k_a),ldb)
      else
         call util_transpose(dbl_mb(k_a),lda,dbl_mb(k_b),ldb,
     @  aihi-ailo+1,ajhi-ajlo+1)
         call ga_put(g_b,bilo,bihi,bjlo,bjhi,dbl_mb(k_b),ldb)
      endif
      if (trans.ne.'N') then
         if(.not.ma_pop_stack(l_b)) call 
     $        errquit('ricopyp: popstack failed',0,0)
      endif
      if(.not.ma_pop_stack(l_a)) call 
     $  errquit('ricopyp: popstack failed',0,0)
      return
      end
#endif

      subroutine grad_get_dens_all (omp2,ouhf,orohf,
     $     d_ij,  d_kl,  d_ik,  d_jl,  d_il,  d_jk,
     $     d_ij2, d_kl2, d_ik2, d_jl2, d_il2, d_jk2, 
     $     d_ij3, d_kl3, d_ik3, d_jl3, d_il3, d_jk3, 
     $     d_ij4, d_kl4, d_ik4, d_jl4, d_il4, d_jk4, 
     $     d_ik5, d_jl5, d_il5, d_jk5,
     $     d_ik6, d_jl6, d_il6, d_jk6, 
     $     d_ik7, d_jl7, d_il7, d_jk7, 
     $     d_ik8, d_jl8, d_il8, d_jk8, 
     $     blen,
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     ilo_prev, jlo_prev, klo_prev,
     $     g_dens,exso)
c
c     Wrapper for all of the grad_get_dens routines.  Note that
c     some of the arrays passed into here are not allocated
c     if they are not being used at the given level of theory.
c     The addresses will be valid but DON'T write to them.
c
      implicit none
#include "errquit.fh"
#include "global.fh"
      logical omp2,ouhf,orohf
      integer g_dens(*), blen, 
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     ilo_prev, jlo_prev, klo_prev
      double precision 
     $     d_ij(*),  d_kl(*),  d_ik(*),  d_jl(*),  d_il(*),  d_jk(*),
     $     d_ij2(*), d_kl2(*), d_ik2(*), d_jl2(*), d_il2(*), d_jk2(*), 
     $     d_ij3(*), d_kl3(*), d_ik3(*), d_jl3(*), d_il3(*), d_jk3(*), 
     $     d_ij4(*), d_kl4(*), d_ik4(*), d_jl4(*), d_il4(*), d_jk4(*),
     $     d_ik5(*), d_jl5(*), d_il5(*), d_jk5(*),
     $     d_ik6(*), d_jl6(*), d_il6(*), d_jk6(*), 
     $     d_ik7(*), d_jl7(*), d_il7(*), d_jk7(*), 
     $     d_ik8(*), d_jl8(*), d_il8(*), d_jk8(*)
c
      logical ogetij, ogetik, ogetjk, exso
c
c     Reuse data we already have ... l is inner loop so cannot save this.
c
      ogetij = ilo.ne.ilo_prev .or. jlo.ne.jlo_prev
      ogetik = ilo.ne.ilo_prev .or. klo.ne.klo_prev
      ogetjk = jlo.ne.jlo_prev .or. klo.ne.klo_prev
c
      ilo_prev = ilo
      jlo_prev = jlo
      klo_prev = klo

c
      if (.not. omp2) then
         if (ouhf) then
            if(.not.exso)
     $           call grad_get_dens_uhf(d_ij, d_kl, d_ik, 
     $           d_jl, d_il, d_jk,
     $           d_ik2, d_jl2, d_il2, d_jk2, blen, 
     $           ilo, ihi, jlo, jhi, 
     $           klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
            if(exso)
     $           call grad_get_dens_exso(
     &           d_ij, d_kl, 
     &           d_ik,  d_jl,  d_il,  d_jk,
     $           d_ik2, d_jl2, d_il2, d_jk2, 
     &           d_ik3, d_jl3, d_il3, d_jk3, 
     &           d_ik4, d_jl4, d_il4, d_jk4,
     &           d_ik5, d_jl5, d_il5, d_jk5, 
     &           d_ik6, d_jl6, d_il6, d_jk6,
     &           d_ik7, d_jl7, d_il7, d_jk7, 
     &           d_ik8, d_jl8, d_il8, d_jk8,
     &           blen, 
     $           ilo, ihi, jlo, jhi, 
     $           klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
         else if (orohf) then
            call grad_get_dens_rohf(d_ij, d_kl, d_ik, 
     $           d_jl, d_il, d_jk,
     $           d_ij2, d_kl2, d_ik2, 
     $           d_jl2, d_il2, d_jk2, blen, 
     $           ilo, ihi, jlo, jhi, 
     $           klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
         else
            call grad_get_dens(d_ij, d_kl, d_ik, 
     $           d_jl, d_il, d_jk, blen,
     $           ilo, ihi, jlo, jhi, 
     $           klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens(1))
         end if
      else                      ! MP2
         if (ouhf) then
            call grad_get_dens_ump2(d_ij, d_kl, d_ik, 
     $           d_jl, d_il, d_jk,
     $           d_ij2, d_kl2, d_ik2, 
     $           d_jl2, d_il2, d_jk2, 
     $           d_ij3, d_kl3, d_ik3, 
     $           d_jl3, d_il3, d_jk3, 
     $           d_ij4, d_kl4, d_ik4, 
     $           d_jl4, d_il4, d_jk4, 
     $           blen,
     $           ilo, ihi, jlo, jhi, 
     $           klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
         else if (orohf) then
            call errquit('no ROMP2 gradients yet', 0, CAPMIS_ERR)
         else                   ! rmp2
            call grad_get_dens_rmp2(d_ij, d_kl, d_ik, 
     $           d_jl, d_il, d_jk,
     $           d_ij2, d_kl2, d_ik2, 
     $           d_jl2, d_il2, d_jk2, 
     $           blen,
     $           ilo, ihi, jlo, jhi, 
     $           klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
         end if
      end if
c
      end
      subroutine grad_get_dens(d_ij, d_kl, d_ik, d_jl, d_il, d_jk, 
     $           blen,
     $           ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
c$Id: grad_getdens.F 19708 2010-10-29 18:04:21Z d3y133 $
C
C     get blocks from density matrix and make sure no block is
C     transferred twice
C
      implicit none

#include "global.fh"

      integer g_dens, blen, 
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     li, lj, lk, ll
      logical ogetij, ogetik, ogetjk

      double precision d_ij, d_kl, d_ik, d_jl, d_il, d_jk

      dimension d_ij(blen,blen),d_kl(blen,blen),d_ik(blen,blen),
     $          d_jl(blen,blen),d_il(blen,blen),d_jk(blen,blen)

      logical eij, ejk, ekl, eil, eik, ejl

      eij = (ilo.eq.jlo)
      ejk = (jlo.eq.klo)
      ekl = (klo.eq.llo)
      eil = (ilo.eq.llo)
      eik = (ilo.eq.klo)
      ejl = (jlo.eq.llo)

      li = ihi - ilo + 1
      lj = jhi - jlo + 1
      lk = khi - klo + 1
      ll = lhi - llo + 1

C     i,j
      if (ogetij) call ga_get (g_dens, ilo, ihi, jlo, jhi, d_ij, blen)

C     k,l
      if (eik.and.ejl) then
        call grad_copy (d_ij, d_kl, li, lj, blen)
      else if (eil.and.ejk) then
        call grad_transp (d_ij, d_kl, li, lj, blen)
      else
        call ga_get (g_dens, klo, khi, llo, lhi, d_kl, blen)
      endif

C     i,k
      if (ogetik) then
         if (ejk) then
            call grad_copy (d_ij, d_ik, li, lj, blen)
         else if (eil) then
            call grad_transp (d_kl, d_ik, lk, ll, blen)
         else
            call ga_get (g_dens, ilo, ihi, klo, khi, d_ik, blen)
         endif
      endif

C     j,l
      if (ejk) then
        call grad_copy (d_kl, d_jl, lk, ll, blen)
      else if (eij.and.ejl) then
        call grad_copy (d_ij, d_jl, li, lj, blen)
      else if (eil) then
        call grad_transp (d_ij, d_jl, li, lj, blen)
      else if (eij.and.ekl) then
        call grad_copy (d_ik, d_jl, li, lk, blen)
      else if (ejk.and.eil) then
        call grad_transp (d_ik, d_jl, li, lk, blen)
      else
        call ga_get (g_dens, jlo, jhi, llo, lhi, d_jl, blen)
      endif

C     i,l
      if (ejl) then
        call grad_copy (d_ij, d_il, li, lj, blen)
      else if (eik) then
        call grad_copy (d_kl, d_il, lk, ll, blen)
      else if (eij) then
        call grad_copy (d_jl, d_il, lj, ll, blen)
      else if (ekl) then
        call grad_copy (d_ik, d_il, li, lk, blen)
      else
        call ga_get (g_dens, ilo, ihi, llo, lhi, d_il, blen)
      endif

C     j,k
      if (ogetjk) then
         if (ekl) then
            call grad_copy (d_jl, d_jk, lj, ll, blen)
         else if (eij) then
            call grad_copy (d_ik, d_jk, li, lk, blen)
         else if (eik) then
            call grad_transp (d_ij, d_jk, li, lj, blen)
         else if (ejl) then
            call grad_transp (d_kl, d_jk, lk, ll, blen)
         else if (eij.and.ekl) then
            call grad_copy (d_il, d_jk, li, ll, blen)
         else if (ejl.and.eik) then
            call grad_transp (d_il, d_jk, li, ll, blen)
         else
            call ga_get (g_dens, jlo, jhi, klo, khi, d_jk, blen)
         endif
      endif
c
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine grad_get_dens_rohf(d_ij, d_kl, d_ik, d_jl, d_il, d_jk,  
     $           d_ij2, d_kl2, d_ik2, d_jl2, d_il2, d_jk2, blen,
     $           ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
C
C     get blocks from density matrix and make sure no block is
C     transferred twice
C
      implicit none

#include "global.fh"

      integer g_dens, blen, 
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     li, lj, lk, ll
      logical ogetij, ogetik, ogetjk

      double precision d_ij, d_kl, d_ik, d_jl, d_il, d_jk, 
     $          d_ij2, d_kl2, d_ik2, d_jl2, d_il2, d_jk2

      dimension d_ij(blen,blen),d_kl(blen,blen),d_ik(blen,blen),
     $          d_jl(blen,blen),d_il(blen,blen),d_jk(blen,blen),
     $          d_ij2(blen,blen),d_kl2(blen,blen),d_ik2(blen,blen),
     $          d_jl2(blen,blen),d_il2(blen,blen),d_jk2(blen,blen)
      dimension g_dens(3)

      logical eij, ejk, ekl, eil, eik, ejl

      eij = (ilo.eq.jlo)
      ejk = (jlo.eq.klo)
      ekl = (klo.eq.llo)
      eil = (ilo.eq.llo)
      eik = (ilo.eq.klo)
      ejl = (jlo.eq.llo)

      li = ihi - ilo + 1
      lj = jhi - jlo + 1
      lk = khi - klo + 1
      ll = lhi - llo + 1

C     i,j
      if (ogetij) then
         call ga_get (g_dens(2), ilo, ihi, jlo, jhi, d_ij, blen)
         call ga_get (g_dens(3), ilo, ihi, jlo, jhi, d_ij2, blen)
      endif

C     k,l
      if (eik.and.ejl) then
        call grad_copy (d_ij, d_kl, li, lj, blen)
        call grad_copy (d_ij2, d_kl2, li, lj, blen)
      else if (eil.and.ejk) then
        call grad_transp (d_ij, d_kl, li, lj, blen)
        call grad_transp (d_ij2, d_kl2, li, lj, blen)
      else
        call ga_get (g_dens(2), klo, khi, llo, lhi, d_kl, blen)
        call ga_get (g_dens(3), klo, khi, llo, lhi, d_kl2, blen)
      endif

C     i,k
      if (ogetik) then
         if (ejk) then
            call grad_copy (d_ij, d_ik, li, lj, blen)
            call grad_copy (d_ij2, d_ik2, li, lj, blen)
         else if (eil) then
            call grad_transp (d_kl, d_ik, lk, ll, blen)
            call grad_transp (d_kl2, d_ik2, lk, ll, blen)
         else 
            call ga_get (g_dens(2), ilo, ihi, klo, khi, d_ik, blen)
            call ga_get (g_dens(3), ilo, ihi, klo, khi, d_ik2, blen)
         endif
      endif

C     j,l
      if (ejk) then
        call grad_copy (d_kl, d_jl, lk, ll, blen)
        call grad_copy (d_kl2, d_jl2, lk, ll, blen)
      else if (eij.and.ejl) then
        call grad_copy (d_ij, d_jl, li, lj, blen)
        call grad_copy (d_ij2, d_jl2, li, lj, blen)
      else if (eil) then
        call grad_transp (d_ij, d_jl, li, lj, blen)
        call grad_transp (d_ij2, d_jl2, li, lj, blen)
      else if (eij.and.ekl) then
        call grad_copy (d_ik, d_jl, li, lk, blen)
        call grad_copy (d_ik2, d_jl2, li, lk, blen)
      else if (ejk.and.eil) then
        call grad_transp (d_ik, d_jl, li, lk, blen)
        call grad_transp (d_ik2, d_jl2, li, lk, blen)
      else
        call ga_get (g_dens(2), jlo, jhi, llo, lhi, d_jl, blen)
        call ga_get (g_dens(3), jlo, jhi, llo, lhi, d_jl2, blen)
      endif

C     i,l
      if (ejl) then
        call grad_copy (d_ij, d_il, li, lj, blen)
        call grad_copy (d_ij2, d_il2, li, lj, blen)
      else if (eik) then
        call grad_copy (d_kl, d_il, lk, ll, blen)
        call grad_copy (d_kl2, d_il2, lk, ll, blen)
      else if (eij) then
        call grad_copy (d_jl, d_il, lj, ll, blen)
        call grad_copy (d_jl2, d_il2, lj, ll, blen)
      else if (ekl) then
        call grad_copy (d_ik, d_il, li, lk, blen)
        call grad_copy (d_ik2, d_il2, li, lk, blen)
      else
        call ga_get (g_dens(2), ilo, ihi, llo, lhi, d_il, blen)
        call ga_get (g_dens(3), ilo, ihi, llo, lhi, d_il2, blen)
      endif

C     j,k
      if (ogetjk) then
         if (ekl) then
            call grad_copy (d_jl, d_jk, lj, ll, blen)
            call grad_copy (d_jl2, d_jk2, lj, ll, blen)
         else if (eij) then
            call grad_copy (d_ik, d_jk, li, lk, blen)
            call grad_copy (d_ik2, d_jk2, li, lk, blen)
         else if (eik) then
            call grad_transp (d_ij, d_jk, li, lj, blen)
            call grad_transp (d_ij2, d_jk2, li, lj, blen)
         else if (ejl) then
            call grad_transp (d_kl, d_jk, lk, ll, blen)
            call grad_transp (d_kl2, d_jk2, lk, ll, blen)
         else if (eij.and.ekl) then
            call grad_copy (d_il, d_jk, li, ll, blen)
            call grad_copy (d_il2, d_jk2, li, ll, blen)
         else if (ejl.and.eik) then
            call grad_transp (d_il, d_jk, li, ll, blen)
            call grad_transp (d_il2, d_jk2, li, ll, blen)
         else
            call ga_get (g_dens(2), jlo, jhi, klo, khi, d_jk, blen)
            call ga_get (g_dens(3), jlo, jhi, klo, khi, d_jk2, blen)
         endif
      endif
c
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine grad_get_dens_uhf(d_ij, d_kl, d_ik, d_jl, d_il, d_jk, 
     $           d_ik2, d_jl2, d_il2, d_jk2, blen,
     $           ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
C
C     get blocks from density matrix and make sure no block is
C     transferred twice
C
      implicit none

#include "global.fh"

      integer g_dens, blen, 
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     li, lj, lk, ll
      logical ogetij, ogetik, ogetjk

      double precision d_ij, d_kl, d_ik, d_jl, d_il, d_jk, 
     $     d_ik2, d_jl2, d_il2, d_jk2

      dimension d_ij(blen,blen),d_kl(blen,blen),d_ik(blen,blen),
     $          d_jl(blen,blen),d_il(blen,blen),d_jk(blen,blen),
     $          d_ik2(blen,blen),d_jl2(blen,blen),d_il2(blen,blen),
     $          d_jk2(blen,blen)
      dimension g_dens(2)

      logical eij, ejk, ekl, eil, eik, ejl

      eij = (ilo.eq.jlo)
      ejk = (jlo.eq.klo)
      ekl = (klo.eq.llo)
      eil = (ilo.eq.llo)
      eik = (ilo.eq.klo)
      ejl = (jlo.eq.llo)

      li = ihi - ilo + 1
      lj = jhi - jlo + 1
      lk = khi - klo + 1
      ll = lhi - llo + 1

C     i,j
      if (ogetij) call ga_get(g_dens(1), ilo, ihi, jlo, jhi, d_ij, blen)

C     k,l
      if (eik.and.ejl) then
        call grad_copy (d_ij, d_kl, li, lj, blen)
      else if (eil.and.ejk) then
        call grad_transp (d_ij, d_kl, li, lj, blen)
      else
        call ga_get (g_dens(1), klo, khi, llo, lhi, d_kl, blen)
      endif

C     i,k
      if (ogetik) then
         if (ejk) then
            call grad_copy (d_ij, d_ik, li, lj, blen)
         else if (eil) then
            call grad_transp (d_kl, d_ik, lk, ll, blen)
         else
            call ga_get (g_dens(1), ilo, ihi, klo, khi, d_ik, blen)
         endif
         call ga_get (g_dens(2), ilo, ihi, klo, khi, d_ik2, blen)
      endif

C     j,l
      if (ejk) then
        call grad_copy (d_kl, d_jl, lk, ll, blen)
      else if (eij.and.ejl) then
        call grad_copy (d_ij, d_jl, li, lj, blen)
      else if (eil) then
        call grad_transp (d_ij, d_jl, li, lj, blen)
      else if (eij.and.ekl) then
        call grad_copy (d_ik, d_jl, li, lk, blen)
      else if (ejk.and.eil) then
        call grad_transp (d_ik, d_jl, li, lk, blen)
      else
        call ga_get (g_dens(1), jlo, jhi, llo, lhi, d_jl, blen)
      endif

      if (eij .and. ekl) then
        call grad_copy (d_ik2, d_jl2, li, lk, blen)
      else if (eil .and. ejk) then
        call grad_transp (d_ik2, d_jl2, li, lk, blen)
      else
        call ga_get (g_dens(2), jlo, jhi, llo, lhi, d_jl2, blen)
      endif

C     i,l
      if (ejl) then
        call grad_copy (d_ij, d_il, li, lj, blen)
      else if (eik) then
        call grad_copy (d_kl, d_il, lk, ll, blen)
      else if (eij) then
        call grad_copy (d_jl, d_il, lj, ll, blen)
      else if (ekl) then
        call grad_copy (d_ik, d_il, li, lk, blen)
      else
        call ga_get (g_dens(1), ilo, ihi, llo, lhi, d_il, blen)
      endif

      if (ekl) then
        call grad_copy (d_ik2, d_il2, li, lk, blen)
      else if (eij) then
        call grad_copy (d_jl2, d_il2, lj, ll, blen)
      else
        call ga_get (g_dens(2), ilo, ihi, llo, lhi, d_il2, blen)
      endif

C     j,k
      if (ogetjk) then
         if (ekl) then
            call grad_copy (d_jl, d_jk, lj, ll, blen)
         else if (eij) then
            call grad_copy (d_ik, d_jk, li, lk, blen)
         else if (eik) then
            call grad_transp (d_ij, d_jk, li, lj, blen)
         else if (ejl) then
            call grad_transp (d_kl, d_jk, lk, ll, blen)
         else if (eij.and.ekl) then
            call grad_copy (d_il, d_jk, li, ll, blen)
         else if (ejl.and.eik) then
            call grad_transp (d_il, d_jk, li, ll, blen)
         else
            call ga_get (g_dens(1), jlo, jhi, klo, khi, d_jk, blen)
         endif

         if (eij) then
            call grad_copy (d_ik2, d_jk2, li, lk, blen)
         else if (ekl) then
            call grad_copy (d_jl2, d_jk2, lj, ll, blen)
         else if (eik .and. ejl) then
            call grad_transp (d_il2, d_jk2, li, ll, blen)
         else
            call ga_get (g_dens(2), jlo, jhi, klo, khi, d_jk2, blen)
         endif
      endif
c
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine grad_get_dens_exso(d_ij, d_kl, d_ik, d_jl, d_il, d_jk, 
     $           d_ik2, d_jl2, d_il2, d_jk2, 
     $           d_ik3, d_jl3, d_il3, d_jk3, 
     $           d_ik4, d_jl4, d_il4, d_jk4, 
     $           d_ik5, d_jl5, d_il5, d_jk5, 
     $           d_ik6, d_jl6, d_il6, d_jk6, 
     $           d_ik7, d_jl7, d_il7, d_jk7, 
     $           d_ik8, d_jl8, d_il8, d_jk8, 
     &           blen,
     $           ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
C
C     get blocks from density matrix and make sure no block is
C     transferred twice
C
      implicit none

#include "global.fh"

      integer g_dens, blen, 
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     li, lj, lk, ll
      logical ogetij, ogetik, ogetjk

      double precision d_ij, d_kl, d_ik, d_jl, d_il, d_jk, 
     $     d_ik2, d_jl2, d_il2, d_jk2,
     $     d_ik3, d_jl3, d_il3, d_jk3,
     $     d_ik4, d_jl4, d_il4, d_jk4,
     $     d_ik5, d_jl5, d_il5, d_jk5,
     $     d_ik6, d_jl6, d_il6, d_jk6,
     $     d_ik7, d_jl7, d_il7, d_jk7,
     $     d_ik8, d_jl8, d_il8, d_jk8

      dimension d_ij(blen,blen),d_kl(blen,blen),d_ik(blen,blen),
     $          d_jl(blen,blen),d_il(blen,blen),d_jk(blen,blen),
     $          d_ik2(blen,blen),d_jl2(blen,blen),d_il2(blen,blen),
     $          d_jk2(blen,blen),
     $          d_ik3(blen,blen),d_jl3(blen,blen),d_il3(blen,blen),
     $          d_jk3(blen,blen),
     $          d_ik4(blen,blen),d_jl4(blen,blen),d_il4(blen,blen),
     $          d_jk4(blen,blen),
     $          d_ik5(blen,blen),d_jl5(blen,blen),d_il5(blen,blen),
     $          d_jk5(blen,blen),
     $          d_ik6(blen,blen),d_jl6(blen,blen),d_il6(blen,blen),
     $          d_jk6(blen,blen),
     $          d_ik7(blen,blen),d_jl7(blen,blen),d_il7(blen,blen),
     $          d_jk7(blen,blen),
     $          d_ik8(blen,blen),d_jl8(blen,blen),d_il8(blen,blen),
     $          d_jk8(blen,blen)
      dimension g_dens(8)

      logical eij, ejk, ekl, eil, eik, ejl

      eij = (ilo.eq.jlo)
      ejk = (jlo.eq.klo)
      ekl = (klo.eq.llo)
      eil = (ilo.eq.llo)
      eik = (ilo.eq.klo)
      ejl = (jlo.eq.llo)

      li = ihi - ilo + 1
      lj = jhi - jlo + 1
      lk = khi - klo + 1
      ll = lhi - llo + 1

C     i,j
      if (ogetij)call ga_get(g_dens(1), ilo, ihi, jlo, jhi, d_ij, blen)

C     k,l
      if (eik.and.ejl) then
        call grad_copy (d_ij, d_kl, li, lj, blen)
      else if (eil.and.ejk) then
        call grad_transp (d_ij, d_kl, li, lj, blen)
      else
        call ga_get (g_dens(1), klo, khi, llo, lhi, d_kl, blen)
      endif

C     i,k
      if (ogetik) then
c     dens(1) and dens(2)
         if (ejk) then
            call grad_copy (d_ij, d_ik, li, lj, blen)
         else if (eil) then
            call grad_transp (d_kl, d_ik, lk, ll, blen)
         else
            call ga_get (g_dens(1), ilo, ihi, klo, khi, d_ik, blen)
         endif
         call ga_get (g_dens(2), ilo, ihi, klo, khi, d_ik2, blen)
c     dens(3) and dens(4)
         call ga_get (g_dens(3), ilo, ihi, klo, khi, d_ik3, blen)
         call ga_get (g_dens(4), ilo, ihi, klo, khi, d_ik4, blen)
c     dens(5) and dens(6)
         call ga_get (g_dens(5), ilo, ihi, klo, khi, d_ik5, blen)
         call ga_get (g_dens(6), ilo, ihi, klo, khi, d_ik6, blen)
c     dens(7) and dens(8)
         call ga_get (g_dens(7), ilo, ihi, klo, khi, d_ik7, blen)
         call ga_get (g_dens(8), ilo, ihi, klo, khi, d_ik8, blen)
      endif

C     j,l
c     dens(1) and dens(2)
      if (ejk) then
         call grad_copy (d_kl, d_jl, lk, ll, blen)
      else if (eij.and.ejl) then
         call grad_copy (d_ij, d_jl, li, lj, blen)
      else if (eil) then
         call grad_transp (d_ij, d_jl, li, lj, blen)
      else if (eij.and.ekl) then
         call grad_copy (d_ik, d_jl, li, lk, blen)
      else if (ejk.and.eil) then
         call grad_transp (d_ik, d_jl, li, lk, blen)
      else
         call ga_get (g_dens(1), jlo, jhi, llo, lhi, d_jl, blen)
      endif

      if (eij .and. ekl) then
        call grad_copy (d_ik2, d_jl2, li, lk, blen)
      else if (eil .and. ejk) then
        call grad_transp (d_ik2, d_jl2, li, lk, blen)
      else
        call ga_get (g_dens(2), jlo, jhi, llo, lhi, d_jl2, blen)
      endif
c
c     dens(3) and dens(4)
c
      call ga_get (g_dens(3), jlo, jhi, llo, lhi, d_jl3, blen)
      call ga_get (g_dens(4), jlo, jhi, llo, lhi, d_jl4, blen)
c
c     dens(5) and dens(6)
c
      call ga_get (g_dens(5), jlo, jhi, llo, lhi, d_jl5, blen)
      call ga_get (g_dens(6), jlo, jhi, llo, lhi, d_jl6, blen)
c
c     dens(7) and dens(8)
c
      call ga_get (g_dens(7), jlo, jhi, llo, lhi, d_jl7, blen)
      call ga_get (g_dens(8), jlo, jhi, llo, lhi, d_jl8, blen)


C     i,l
c
c     dens(1) and dens(2)
c
      if (ejl) then
        call grad_copy (d_ij, d_il, li, lj, blen)
      else if (eik) then
        call grad_copy (d_kl, d_il, lk, ll, blen)
      else if (eij) then
        call grad_copy (d_jl, d_il, lj, ll, blen)
      else if (ekl) then
        call grad_copy (d_ik, d_il, li, lk, blen)
      else
        call ga_get (g_dens(1), ilo, ihi, llo, lhi, d_il, blen)
      endif

      if (ekl) then
        call grad_copy (d_ik2, d_il2, li, lk, blen)
      else if (eij) then
        call grad_copy (d_jl2, d_il2, lj, ll, blen)
      else
        call ga_get (g_dens(2), ilo, ihi, llo, lhi, d_il2, blen)
      endif
c
c     dens(3) and dnes(4)
c
      call ga_get (g_dens(3), ilo, ihi, llo, lhi, d_il3, blen)
      call ga_get (g_dens(4), ilo, ihi, llo, lhi, d_il4, blen)
c
c     dens(5) and dnes(6)
c     
      call ga_get (g_dens(5), ilo, ihi, llo, lhi, d_il5, blen)
      call ga_get (g_dens(6), ilo, ihi, llo, lhi, d_il6, blen)
c     
c     dens(7) and dnes(8)
c     
      call ga_get (g_dens(7), ilo, ihi, llo, lhi, d_il7, blen)
      call ga_get (g_dens(8), ilo, ihi, llo, lhi, d_il8, blen)

C     j,k
      if (ogetjk) then
c
c     dens(1) and dens(2)
c
         if (ekl) then
            call grad_copy (d_jl, d_jk, lj, ll, blen)
         else if (eij) then
            call grad_copy (d_ik, d_jk, li, lk, blen)
         else if (eik) then
            call grad_transp (d_ij, d_jk, li, lj, blen)
         else if (ejl) then
            call grad_transp (d_kl, d_jk, lk, ll, blen)
         else if (eij.and.ekl) then
            call grad_copy (d_il, d_jk, li, ll, blen)
         else if (ejl.and.eik) then
            call grad_transp (d_il, d_jk, li, ll, blen)
         else
            call ga_get (g_dens(1), jlo, jhi, klo, khi, d_jk, blen)
         endif
c
         if (eij) then
            call grad_copy (d_ik2, d_jk2, li, lk, blen)
         else if (ekl) then
            call grad_copy (d_jl2, d_jk2, lj, ll, blen)
         else if (eik .and. ejl) then
            call grad_transp (d_il2, d_jk2, li, ll, blen)
         else
            call ga_get (g_dens(2), jlo, jhi, klo, khi, d_jk2, blen)
         endif
c
c     dens(3) and dens(4)
c
            call ga_get (g_dens(3), jlo, jhi, klo, khi, d_jk3, blen)
            call ga_get (g_dens(4), jlo, jhi, klo, khi, d_jk4, blen)
c
c     dens(5) and dens(6)
c
            call ga_get (g_dens(5), jlo, jhi, klo, khi, d_jk5, blen)
            call ga_get (g_dens(6), jlo, jhi, klo, khi, d_jk6, blen)
c
c     dens(7) and dens(8)
c
            call ga_get (g_dens(7), jlo, jhi, klo, khi, d_jk7, blen)
            call ga_get (g_dens(8), jlo, jhi, klo, khi, d_jk8, blen)
      endif
c
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine grad_get_dens_rmp2 (
     $           d_ij, d_kl, d_ik, d_jl, d_il, d_jk, 
     $           p_ij, p_kl, p_ik, p_jl, p_il, p_jk, 
     $           blen,
     $           ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
C
C     get blocks from density matrices and make sure no block is
C     transferred twice
C
C     (a,b) denotes spin, d is the HF part and p contains (twice) the 
C     second order correction
C
      implicit none

#include "global.fh"

      integer g_dens, blen, 
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     li, lj, lk, ll

      double precision d_ij, d_kl, d_ik, d_jl, d_il, d_jk,
     $                 p_ij, p_kl, p_ik, p_jl, p_il, p_jk
      logical ogetij, ogetik, ogetjk

      dimension g_dens(3)
      dimension d_ij(blen,blen),d_kl(blen,blen),d_ik(blen,blen),
     $          d_jl(blen,blen),d_il(blen,blen),d_jk(blen,blen),
     $          p_ij(blen,blen),p_kl(blen,blen),p_ik(blen,blen),
     $          p_jl(blen,blen),p_il(blen,blen),p_jk(blen,blen)

      logical eij, ejk, ekl, eil, eik, ejl

      eij = (ilo.eq.jlo)
      ejk = (jlo.eq.klo)
      ekl = (klo.eq.llo)
      eil = (ilo.eq.llo)
      eik = (ilo.eq.klo)
      ejl = (jlo.eq.llo)

      li = ihi - ilo + 1
      lj = jhi - jlo + 1
      lk = khi - klo + 1
      ll = lhi - llo + 1

C     i,j
      if (ogetij) then
         call ga_get (g_dens(2), ilo, ihi, jlo, jhi, d_ij, blen)
         call ga_get (g_dens(3), ilo, ihi, jlo, jhi, p_ij, blen)
      endif

C     k,l
      if (eik.and.ejl) then
        call grad_copy (d_ij, d_kl, li, lj, blen)
        call grad_copy (p_ij, p_kl, li, lj, blen)
      else if (eil.and.ejk) then
        call grad_transp (d_ij, d_kl, li, lj, blen)
        call grad_transp (p_ij, p_kl, li, lj, blen)
      else
        call ga_get (g_dens(2), klo, khi, llo, lhi, d_kl, blen)
        call ga_get (g_dens(3), klo, khi, llo, lhi, p_kl, blen)
      endif

C     i,k
      if (ogetik) then
         if (ejk) then
            call grad_copy (d_ij, d_ik, li, lj, blen)
            call grad_copy (p_ij, p_ik, li, lj, blen)
         else if (eil) then
            call grad_transp (d_kl, d_ik, lk, ll, blen)
            call grad_transp (p_kl, p_ik, lk, ll, blen)
         else
            call ga_get (g_dens(2), ilo, ihi, klo, khi, d_ik, blen)
            call ga_get (g_dens(3), ilo, ihi, klo, khi, p_ik, blen)
         endif
      endif

C     j,l
      if (ejk) then
         call grad_copy (d_kl, d_jl, lk, ll, blen)
         call grad_copy (p_kl, p_jl, lk, ll, blen)
      else if (eij.and.ejl) then
         call grad_copy (d_ij, d_jl, li, lj, blen)
         call grad_copy (p_ij, p_jl, li, lj, blen)
      else if (eil) then
         call grad_transp (d_ij, d_jl, li, lj, blen)
         call grad_transp (p_ij, p_jl, li, lj, blen)
      else if (eij.and.ekl) then
         call grad_copy (d_ik, d_jl, li, lk, blen)
         call grad_copy (p_ik, p_jl, li, lk, blen)
      else if (ejk.and.eil) then
         call grad_transp (d_ik, d_jl, li, lk, blen)
         call grad_transp (p_ik, p_jl, li, lk, blen)
      else
         call ga_get (g_dens(2), jlo, jhi, llo, lhi, d_jl, blen)
         call ga_get (g_dens(3), jlo, jhi, llo, lhi, p_jl, blen)
      endif

C     i,l
      if (ejl) then
        call grad_copy (d_ij, d_il, li, lj, blen)
        call grad_copy (p_ij, p_il, li, lj, blen)
      else if (eik) then
        call grad_copy (d_kl, d_il, lk, ll, blen)
        call grad_copy (p_kl, p_il, lk, ll, blen)
      else if (eij) then
        call grad_copy (d_jl, d_il, lj, ll, blen)
        call grad_copy (p_jl, p_il, lj, ll, blen)
      else if (ekl) then
        call grad_copy (d_ik, d_il, li, lk, blen)
        call grad_copy (p_ik, p_il, li, lk, blen)
      else
        call ga_get (g_dens(2), ilo, ihi, llo, lhi, d_il, blen)
        call ga_get (g_dens(3), ilo, ihi, llo, lhi, p_il, blen)
      endif

C     j,k
      if (ogetjk) then
         if (ekl) then
            call grad_copy (d_jl, d_jk, lj, ll, blen)
            call grad_copy (p_jl, p_jk, lj, ll, blen)
         else if (eij) then
            call grad_copy (d_ik, d_jk, li, lk, blen)
            call grad_copy (p_ik, p_jk, li, lk, blen)
         else if (eik) then
            call grad_transp (d_ij, d_jk, li, lj, blen)
            call grad_transp (p_ij, p_jk, li, lj, blen)
         else if (ejl) then
            call grad_transp (d_kl, d_jk, lk, ll, blen)
            call grad_transp (p_kl, p_jk, lk, ll, blen)
         else if (eij.and.ekl) then
            call grad_copy (d_il, d_jk, li, ll, blen)
            call grad_copy (p_il, p_jk, li, ll, blen)
         else if (ejl.and.eik) then
            call grad_transp (d_il, d_jk, li, ll, blen)
            call grad_transp (p_il, p_jk, li, ll, blen)
         else
            call ga_get (g_dens(2), jlo, jhi, klo, khi, d_jk, blen)
            call ga_get (g_dens(3), jlo, jhi, klo, khi, p_jk, blen)
         endif
      endif
c
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine grad_get_dens_ump2 (
     $           da_ij, da_kl, da_ik, da_jl, da_il, da_jk, 
     $           db_ij, db_kl, db_ik, db_jl, db_il, db_jk, 
     $           pa_ij, pa_kl, pa_ik, pa_jl, pa_il, pa_jk, 
     $           pb_ij, pb_kl, pb_ik, pb_jl, pb_il, pb_jk, 
     $           blen,
     $           ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $           ogetij, ogetik, ogetjk,
     $           g_dens)
C
C     get blocks from density matrices and make sure no block is
C     transferred twice
C
C     (a,b) denotes spin, d is the HF part and p contains (twice) the 
C     second order correction
C
      implicit none

#include "global.fh"

      integer g_dens, blen, 
     $     ilo, ihi, jlo, jhi, klo, khi, llo, lhi,
     $     li, lj, lk, ll
      logical ogetij, ogetik, ogetjk

      double precision da_ij, da_kl, da_ik, da_jl, da_il, da_jk,
     $                 db_ij, db_kl, db_ik, db_jl, db_il, db_jk,
     $                 pa_ij, pa_kl, pa_ik, pa_jl, pa_il, pa_jk,
     $                 pb_ij, pb_kl, pb_ik, pb_jl, pb_il, pb_jk

      dimension g_dens(5)
      dimension da_ij(blen,blen),da_kl(blen,blen),da_ik(blen,blen),
     $          da_jl(blen,blen),da_il(blen,blen),da_jk(blen,blen),
     $          db_ij(blen,blen),db_kl(blen,blen),db_ik(blen,blen),
     $          db_jl(blen,blen),db_il(blen,blen),db_jk(blen,blen),
     $          pa_ij(blen,blen),pa_kl(blen,blen),pa_ik(blen,blen),
     $          pa_jl(blen,blen),pa_il(blen,blen),pa_jk(blen,blen),
     $          pb_ij(blen,blen),pb_kl(blen,blen),pb_ik(blen,blen),
     $          pb_jl(blen,blen),pb_il(blen,blen),pb_jk(blen,blen)

      logical eij, ejk, ekl, eil, eik, ejl

      eij = (ilo.eq.jlo)
      ejk = (jlo.eq.klo)
      ekl = (klo.eq.llo)
      eil = (ilo.eq.llo)
      eik = (ilo.eq.klo)
      ejl = (jlo.eq.llo)

      li = ihi - ilo + 1
      lj = jhi - jlo + 1
      lk = khi - klo + 1
      ll = lhi - llo + 1

C     i,j
      if (ogetij) then
         call ga_get (g_dens(2), ilo, ihi, jlo, jhi, da_ij, blen)
         call ga_get (g_dens(3), ilo, ihi, jlo, jhi, db_ij, blen)
         call ga_get (g_dens(4), ilo, ihi, jlo, jhi, pa_ij, blen)
         call ga_get (g_dens(5), ilo, ihi, jlo, jhi, pb_ij, blen)
      endif

C     k,l
      if (eik.and.ejl) then
        call grad_copy (da_ij, da_kl, li, lj, blen)
        call grad_copy (db_ij, db_kl, li, lj, blen)
        call grad_copy (pa_ij, pa_kl, li, lj, blen)
        call grad_copy (pb_ij, pb_kl, li, lj, blen)
      else if (eil.and.ejk) then
        call grad_transp (da_ij, da_kl, li, lj, blen)
        call grad_transp (db_ij, db_kl, li, lj, blen)
        call grad_transp (pa_ij, pa_kl, li, lj, blen)
        call grad_transp (pb_ij, pb_kl, li, lj, blen)
      else
        call ga_get (g_dens(2), klo, khi, llo, lhi, da_kl, blen)
        call ga_get (g_dens(3), klo, khi, llo, lhi, db_kl, blen)
        call ga_get (g_dens(4), klo, khi, llo, lhi, pa_kl, blen)
        call ga_get (g_dens(5), klo, khi, llo, lhi, pb_kl, blen)
      endif

C     i,k
      if (ogetik) then
         if (ejk) then
            call grad_copy (da_ij, da_ik, li, lj, blen)
            call grad_copy (db_ij, db_ik, li, lj, blen)
            call grad_copy (pa_ij, pa_ik, li, lj, blen)
            call grad_copy (pb_ij, pb_ik, li, lj, blen)
         else if (eil) then
            call grad_transp (da_kl, da_ik, lk, ll, blen)
            call grad_transp (db_kl, db_ik, lk, ll, blen)
            call grad_transp (pa_kl, pa_ik, lk, ll, blen)
            call grad_transp (pb_kl, pb_ik, lk, ll, blen)
         else
            call ga_get (g_dens(2), ilo, ihi, klo, khi, da_ik, blen)
            call ga_get (g_dens(3), ilo, ihi, klo, khi, db_ik, blen)
            call ga_get (g_dens(4), ilo, ihi, klo, khi, pa_ik, blen)
            call ga_get (g_dens(5), ilo, ihi, klo, khi, pb_ik, blen)
         endif
      endif

C     j,l
      if (ejk) then
        call grad_copy (da_kl, da_jl, lk, ll, blen)
        call grad_copy (db_kl, db_jl, lk, ll, blen)
        call grad_copy (pa_kl, pa_jl, lk, ll, blen)
        call grad_copy (pb_kl, pb_jl, lk, ll, blen)
      else if (eij.and.ejl) then
        call grad_copy (da_ij, da_jl, li, lj, blen)
        call grad_copy (db_ij, db_jl, li, lj, blen)
        call grad_copy (pa_ij, pa_jl, li, lj, blen)
        call grad_copy (pb_ij, pb_jl, li, lj, blen)
      else if (eil) then
        call grad_transp (da_ij, da_jl, li, lj, blen)
        call grad_transp (db_ij, db_jl, li, lj, blen)
        call grad_transp (pa_ij, pa_jl, li, lj, blen)
        call grad_transp (pb_ij, pb_jl, li, lj, blen)
      else if (eij.and.ekl) then
        call grad_copy (da_ik, da_jl, li, lk, blen)
        call grad_copy (db_ik, db_jl, li, lk, blen)
        call grad_copy (pa_ik, pa_jl, li, lk, blen)
        call grad_copy (pb_ik, pb_jl, li, lk, blen)
      else if (ejk.and.eil) then
        call grad_transp (da_ik, da_jl, li, lk, blen)
        call grad_transp (db_ik, db_jl, li, lk, blen)
        call grad_transp (pa_ik, pa_jl, li, lk, blen)
        call grad_transp (pb_ik, pb_jl, li, lk, blen)
      else
        call ga_get (g_dens(2), jlo, jhi, llo, lhi, da_jl, blen)
        call ga_get (g_dens(3), jlo, jhi, llo, lhi, db_jl, blen)
        call ga_get (g_dens(4), jlo, jhi, llo, lhi, pa_jl, blen)
        call ga_get (g_dens(5), jlo, jhi, llo, lhi, pb_jl, blen)
      endif

C     i,l
      if (ejl) then
        call grad_copy (da_ij, da_il, li, lj, blen)
        call grad_copy (db_ij, db_il, li, lj, blen)
        call grad_copy (pa_ij, pa_il, li, lj, blen)
        call grad_copy (pb_ij, pb_il, li, lj, blen)
      else if (eik) then
        call grad_copy (da_kl, da_il, lk, ll, blen)
        call grad_copy (db_kl, db_il, lk, ll, blen)
        call grad_copy (pa_kl, pa_il, lk, ll, blen)
        call grad_copy (pb_kl, pb_il, lk, ll, blen)
      else if (eij) then
        call grad_copy (da_jl, da_il, lj, ll, blen)
        call grad_copy (db_jl, db_il, lj, ll, blen)
        call grad_copy (pa_jl, pa_il, lj, ll, blen)
        call grad_copy (pb_jl, pb_il, lj, ll, blen)
      else if (ekl) then
        call grad_copy (da_ik, da_il, li, lk, blen)
        call grad_copy (db_ik, db_il, li, lk, blen)
        call grad_copy (pa_ik, pa_il, li, lk, blen)
        call grad_copy (pb_ik, pb_il, li, lk, blen)
      else
        call ga_get (g_dens(2), ilo, ihi, llo, lhi, da_il, blen)
        call ga_get (g_dens(3), ilo, ihi, llo, lhi, db_il, blen)
        call ga_get (g_dens(4), ilo, ihi, llo, lhi, pa_il, blen)
        call ga_get (g_dens(5), ilo, ihi, llo, lhi, pb_il, blen)
      endif

C     j,k
      if (ogetjk) then
         if (ekl) then
            call grad_copy (da_jl, da_jk, lj, ll, blen)
            call grad_copy (db_jl, db_jk, lj, ll, blen)
            call grad_copy (pa_jl, pa_jk, lj, ll, blen)
            call grad_copy (pb_jl, pb_jk, lj, ll, blen)
         else if (eij) then
            call grad_copy (da_ik, da_jk, li, lk, blen)
            call grad_copy (db_ik, db_jk, li, lk, blen)
            call grad_copy (pa_ik, pa_jk, li, lk, blen)
            call grad_copy (pb_ik, pb_jk, li, lk, blen)
         else if (eik) then
            call grad_transp (da_ij, da_jk, li, lj, blen)
            call grad_transp (db_ij, db_jk, li, lj, blen)
            call grad_transp (pa_ij, pa_jk, li, lj, blen)
            call grad_transp (pb_ij, pb_jk, li, lj, blen)
         else if (ejl) then
            call grad_transp (da_kl, da_jk, lk, ll, blen)
            call grad_transp (db_kl, db_jk, lk, ll, blen)
            call grad_transp (pa_kl, pa_jk, lk, ll, blen)
            call grad_transp (pb_kl, pb_jk, lk, ll, blen)
         else if (eij.and.ekl) then
            call grad_copy (da_il, da_jk, li, ll, blen)
            call grad_copy (db_il, db_jk, li, ll, blen)
            call grad_copy (pa_il, pa_jk, li, ll, blen)
            call grad_copy (pb_il, pb_jk, li, ll, blen)
         else if (ejl.and.eik) then
            call grad_transp (da_il, da_jk, li, ll, blen)
            call grad_transp (db_il, db_jk, li, ll, blen)
            call grad_transp (pa_il, pa_jk, li, ll, blen)
            call grad_transp (pb_il, pb_jk, li, ll, blen)
         else
            call ga_get (g_dens(2), jlo, jhi, klo, khi, da_jk, blen)
            call ga_get (g_dens(3), jlo, jhi, klo, khi, db_jk, blen)
            call ga_get (g_dens(4), jlo, jhi, klo, khi, pa_jk, blen)
            call ga_get (g_dens(5), jlo, jhi, klo, khi, pb_jk, blen)
         endif
      endif
c
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine grad_copy (d_1, d_2, l1, l2, ld)
      implicit none
      integer l1, l2, ld, i, j
      double precision d_1, d_2
      dimension d_1(ld,ld), d_2(ld,ld)
      do 20, j=1, l2
        do 10, i=1, l1
          d_2(i,j) = d_1(i,j)
 10     continue
 20   continue
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine grad_transp (d_1, d_2, l1, l2, ld)
      implicit none
      integer l1, l2, ld, i, j
      double precision d_1, d_2
      dimension d_1(ld,ld), d_2(ld,ld)
      do 20, j=1, l2
        do 10, i=1, l1
          d_2(j,i) = d_1(i,j)
 10     continue
 20   continue
      return
      end

      subroutine sp_setup(node,iwl,xw,xwcr,vw,gw,numwm,
     + isl,xs,xscr,vs,gs,numsa,lpack)
c
c $Id: sp_main.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3),xscr(msm,3)
      real*8 gw(mwm,3,mwa),gs(msa,3)
      logical lpack
c
      integer i_qlst,l_qlst
c
      if(iguide.gt.0) then
      call sp_gagetixvf(node,iwl,int_mb(i_packw),xw,xwcr,vw,gw,numwm,
     + isl,int_mb(i_pack),xs,vs,gs,numsa,int_mb(i_ipl))
      else
      call sp_gagetixv(node,iwl,int_mb(i_packw),xw,xwcr,vw,numwm,
     + isl,int_mb(i_pack),xs,vs,numsa,int_mb(i_ipl))
      endif
c
      if(me.eq.node) then
      nwmloc=numwm
      nsaloc=numsa
      call sp_qatoms(isl,numsa)
      if(.not.ma_push_get(mt_int,nsa,'qlst',l_qlst,i_qlst))
     + call md_abort('Failed to allocate memory for qlst',0)
      call sp_latoms(isl,int_mb(i_qlst),numsa)
      if(.not.ma_pop_stack(l_qlst))
     + call md_abort('Failed to deallocate memory for qlst',0)
      call sp_putix(me,iwl,xw,numwm,isl,xs,numsa)
      endif
c
      if(nsm.gt.0) call sp_getxscr(xscr,dbl_mb(i_xscr))
c
      return
      end
      subroutine sp_getxscr(xscr,xscrs)
c
      implicit none
c
#include "sp_common.fh"
c
      real*8 xscr(msm,3),xscrs(msm,3)
c
      integer i,j
c
      do 1 j=1,3
      do 2 i=1,nsm
      xscr(i,j)=xscrs(i,j)
    2 continue
    1 continue
c
      return
      end
      subroutine sp_pack_finish()
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      if(npackw.gt.0) then
      if(.not.ma_pop_stack(l_packw))
     + call md_abort('Failed to deallocate memory for packw',0)
      endif
      if(npack.gt.0) then
      if(.not.ma_pop_stack(l_pack))
     + call md_abort('Failed to deallocate memory for pack',0)
      endif
c
      return
      end
      subroutine sp_pack_init(isl,numsa,iwl,numwm)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer isl(msa,mis2),numsa,iwl(mwm,miw2),numwm
c
      integer i,j,k,intsiz
c
      intsiz=8*ma_sizeof(mt_int,1,mt_byte)-1
c
      do 1 i=1,mis2
      misl(i)=0
    1 continue
c
      do 2 j=1,mis2
      do 3 i=1,numsa
      misl(j)=max(misl(j),isl(i,j))
    3 continue
    2 continue
      misl(lsdyn)=max(15,misl(lsdyn))
      misl(lsbox)=nbtot
      misl(lsnod)=np
c
      call ga_igop(msp_24,misl,mis2,'max')
c
      do 4 i=1,mis2
      k=misl(i)
      do 5 j=1,intsiz
      k=rshift(k,1)
      if(k.eq.0) then
      nbits(i)=j+1
      goto 4
      endif
    5 continue
      nbits(i)=intsiz
    4 continue
c
      npack=1
      ipack(1)=1
      k=nbits(1)
      do 6 i=2,mis2
      if(k+nbits(i).lt.intsiz) then
      ipack(npack)=ipack(npack)+1
      k=k+nbits(i)
      else
      npack=npack+1
      ipack(npack)=1
      k=nbits(i)
      endif
    6 continue
c
      do 7 i=1,mis2
      misl(i)=2**nbits(i)-1
    7 continue
c
      do 8 i=1,miw2
      miwl(i)=0
    8 continue
c
      do 9 j=1,miw2
      do 10 i=1,numwm
      miwl(j)=max(miwl(j),iwl(i,j))
   10 continue
    9 continue
      miwl(lwdyn)=15
      miwl(lwbox)=nbtot
      miwl(lwnod)=np
c
      call ga_igop(msp_25,miwl,miw2,'max')
c
      do 11 i=1,miw2
      k=miwl(i)
      do 12 j=1,intsiz
      k=rshift(k,1)
      if(k.eq.0) then
      nbitw(i)=j+1
      goto 11
      endif
   12 continue
      nbitw(i)=intsiz
   11 continue
c
      npackw=1
      ipackw(1)=1
      k=nbitw(1)
      do 13 i=2,miw2
      if(k+nbitw(i).lt.intsiz) then
      ipackw(npackw)=ipackw(npackw)+1
      k=k+nbitw(i)
      else
      npackw=npackw+1
      ipackw(npackw)=1
      k=nbitw(i)
      endif
   13 continue
c
      do 14 i=1,miw2
      miwl(i)=2**nbitw(i)-1
   14 continue
c
      if(me.eq.0) then
      write(lfnout,1001)
 1001 format(/,' DATA PACKING',/)
      write(lfnout,1002) ' Packing solute in  ',npack,
     + ' integers : ',(ipack(i),i=1,npack)
 1002 format(a,i2,a,15i4)
      write(lfnout,1003) ' significant bits : ',
     + (nbits(i),i=1,mis2)
 1003 format(14x,a,15i4)
      write(lfnout,1002) ' Packing solvent in ',npackw,
     + ' integers : ',(ipackw(i),i=1,npackw)
      write(lfnout,1003) ' significant bits : ',
     + (nbitw(i),i=1,miw2)
      endif
c
      if(npack.eq.mis2) npack=0
      if(npackw.eq.miw2) npackw=0
c      npackw=0
c
      if(npack.gt.0) then
      if(.not.ma_push_get(mt_int,msa*npack,'lpack',l_pack,i_pack))
     + call md_abort('Failed to allocate memory for pack',0)
      endif
      if(npackw.gt.0) then
      if(.not.ma_push_get(mt_int,mwm*npackw,'lpackw',l_packw,i_packw))
     + call md_abort('Failed to allocate memory for packw',0)
      endif
c
      call sp_pack_ga(numsa,isl,int_mb(i_pack),
     + numwm,iwl,int_mb(i_packw))
c
      return
      end
      subroutine sp_pack_ga(numsa,isl,islp,numwm,iwl,iwlp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      integer numsa,isl(msa,mis2),islp(msa,npack)
      integer numwm,iwl(mwm,miw2),iwlp(mwm,npackw)
c
      integer il,ih,jl,jh
c
      if(numsa.gt.0.and.npack.gt.0) then
      call ga_distribution(ga_is,me,il,ih,jl,jh)
      call ga_get(ga_is,il,il+numsa-1,jl,jh,isl,msa)  
      call sp_pack(numsa,isl,islp)      
      call ga_put(ga_is,il,il+numsa-1,jl,jl+npack-1,islp,msa)
      endif
c
      if(numwm.gt.0.and.npackw.gt.0) then
      call ga_distribution(ga_iw,me,il,ih,jl,jh)
      call ga_get(ga_iw,il,il+numwm-1,jl,jh,iwl,mwm)
      call sp_packw(numwm,iwl,iwlp)
      call ga_put(ga_iw,il,il+numwm-1,jl,jl+npackw-1,iwlp,mwm)
      endif
c
      call ga_sync()
c
      return
      end
      subroutine sp_pack(numsa,isl,islp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer numsa,isl(msa,mis2),islp(msa,npack)
c
      integer i,j,k,ipck
c
      ipck=0
      do 1 j=1,npack
      do 2 i=1,numsa
      islp(i,j)=0
    2 continue
      do 3 k=1,ipack(j)
      ipck=ipck+1
      do 4 i=1,numsa
      islp(i,j)=lshift(islp(i,j),nbits(ipck))+isl(i,ipck)
    4 continue
    3 continue
    1 continue
c
      return
      end
      subroutine sp_unpack(numsa,isl,islp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer numsa,isl(msa,mis2),islp(msa,npack)
c
      integer i,j,k,ipck
c
      ipck=mis2+1
      do 1 j=npack,1,-1
      do 2 k=ipack(j),1,-1
      ipck=ipck-1
      do 3 i=1,numsa
      isl(i,ipck)=iand(islp(i,j),misl(ipck))
      islp(i,j)=rshift(islp(i,j)-isl(i,ipck),nbits(ipck))
    3 continue
    2 continue
    1 continue
c
      return
      end
      subroutine sp_packw(numwm,iwl,iwlp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer numwm,iwl(mwm,miw2),iwlp(mwm,npackw)
c
      integer i,j,k,ipck
c
      ipck=0
      do 1 j=1,npackw
      do 2 i=1,numwm
      iwlp(i,j)=0
    2 continue
      do 3 k=1,ipackw(j)
      ipck=ipck+1
      do 4 i=1,numwm
      iwlp(i,j)=lshift(iwlp(i,j),nbitw(ipck))+iwl(i,ipck)
    4 continue
    3 continue
    1 continue
c
      return
      end
      subroutine sp_unpackw(numwm,iwl,iwlp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer numwm,iwl(mwm,miw2),iwlp(mwm,npackw)
c
      integer i,j,k,ipck
c
      ipck=miw2+1
      do 1 j=npackw,1,-1
      do 2 k=ipackw(j),1,-1
      ipck=ipck-1
      do 3 i=1,numwm
      iwl(i,ipck)=iand(iwlp(i,j),miwl(ipck))
      iwlp(i,j)=rshift(iwlp(i,j)-iwl(i,ipck),nbitw(ipck))
    3 continue
    2 continue
    1 continue
c
      return
      end
      subroutine sp_latoms(isl,lst,nums)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      integer nums
      integer isl(msa,mis2),lst(nsa)
c
      integer i
c
      do 1 i=1,nsa
      lst(i)=0
    1 continue
c
      call cf_links(lquant,nums,isl(1,lsgan),isl(1,lsdyn),lst)
c
      call ga_igop(msp_21,lst,nsa,'+')
c
      do 2 i=1,nums
      if(iand(isl(i,lsdyn),lquant).eq.0.and.lst(isl(i,lsgan)).gt.0)
     + isl(i,lsdyn)=ior(isl(i,lsdyn),lqlink)
    2 continue
c
      do 3 i=1,nsa
      lst(i)=0
    3 continue
c
      call cf_links(lqlink,nums,isl(1,lsgan),isl(1,lsdyn),lst)
c
      call ga_igop(msp_26,lst,nsa,'+')
c
      do 4 i=1,nums
      if(iand(isl(i,lsdyn),lqlink).eq.0.and.lst(isl(i,lsgan)).gt.0)
     + isl(i,lsdyn)=ior(isl(i,lsdyn),lqsoft)
    4 continue
c
      return
      end
      subroutine sp_qatoms(isl,numsa)
c
      implicit none
c
#include "sp_common.fh"
c
      integer cf_quantuma
      external cf_quantuma
c
      integer numsa
      integer isl(msa,mis2)
c
      integer i,itype
c
      do 1 i=1,numsa
      itype=cf_quantuma(isl(i,lsatt))
      if(itype.eq.1.or.itype.eq.2) isl(i,lsdyn)=ior(isl(i,lsdyn),lquant)
      if(itype.eq.2) isl(i,lsdyn)=ior(isl(i,lsdyn),lqhigh)
    1 continue
c
      return
      end
      subroutine sp_getixv(node,iwl,xw,xwcr,vw,numwm,isl,xs,vs,numsa)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3)
c
      call sp_gagetixv(node,iwl,int_mb(i_packw),xw,xwcr,vw,numwm,
     + isl,int_mb(i_pack),xs,vs,numsa,int_mb(i_ipl))
c
      if(me.eq.node) then
      nwmloc=numwm
      nsaloc=numsa
      endif
c
      return
      end
      subroutine sp_putp(node,pw,pwp,numwm,ps,psp,numsa,lpp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      logical lpp
      integer il,ih,jl,jh
c
      if(numwm.gt.0) then
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_put(ga_w,il,ih,jl+12*mwa+3,jl+18*mwa+2,pw,mwm)
      if(lpp) call ga_put(ga_w,il,ih,jl+18*mwa+3,jl+30*mwa+2,pwp,mwm)
      endif
c
      if(numsa.gt.0) then
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_put(ga_s,il,ih,jl+12,jl+17,ps,msa)
      if(lpp) call ga_put(ga_s,il,ih,jl+18,jl+30,psp,msa)
      endif
c
      return
      end
      subroutine sp_getp(node,pw,pwp,numwm,ps,psp,numsa,lpp,ndx)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa,ndx
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      logical lpp
      integer il,ih,jl,jh
c
      if(numwm.gt.0) then
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      if(ndx.eq.1) then
      call ga_get(ga_w,il,ih,jl+12*mwa+3,jl+15*mwa+2,pw,mwm)
      if(lpp) call ga_get(ga_w,il,ih,jl+18*mwa+3,jl+24*mwa+2,pwp,mwm)
      elseif(ndx.eq.2) then
      call ga_get(ga_w,il,ih,jl+15*mwa+3,jl+18*mwa+2,pw(1,1,1,2),mwm)
      if(lpp) call ga_get(ga_w,il,ih,jl+18*mwa+3,jl+24*mwa+2,pwp,mwm)
      else
      call ga_get(ga_w,il,ih,jl+12*mwa+3,jl+18*mwa+2,pw,mwm)
      if(lpp) call ga_get(ga_w,il,ih,jl+18*mwa+3,jl+24*mwa+2,pwp,mwm)
      endif
      endif
c
      if(numsa.gt.0) then
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      if(ndx.eq.1) then
      call ga_get(ga_s,il,ih,jl+12,jl+14,ps,msa)
      if(lpp) call ga_get(ga_s,il,ih,jl+15,jl+20,psp,msa)
      elseif(ndx.eq.2) then
      call ga_get(ga_s,il,ih,jl+15,jl+17,ps(1,1,2),msa)
      if(lpp) call ga_get(ga_s,il,ih,jl+15,jl+20,psp,msa)
      else
      call ga_get(ga_s,il,ih,jl+12,jl+17,ps,msa)
      if(lpp) call ga_get(ga_s,il,ih,jl+15,jl+20,psp,msa)
      endif
      endif
c
      return
      end
      subroutine sp_putix(node,iwl,xw,numwm,isl,xs,numsa)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
c
      call sp_gaputix(node,iwl,int_mb(i_packw),xw,numwm,
     + isl,int_mb(i_pack),xs,numsa,int_mb(i_ipl))
c
      return
      end
      subroutine sp_update(node,vlatt,
     + iwl,xw,xwcr,vw,numwm,isl,xs,vs,numsa)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3),vlatt(3,3)
c
      integer i,j
c
      call sp_gaputixv(node,iwl,int_mb(i_packw),xw,xwcr,vw,numwm,
     + isl,int_mb(i_pack),xs,vs,numsa,int_mb(i_ipl))
c
      do 1 j=1,3
      box(j)=vlat(j,j)
      boxh(j)=half*box(j)
      do 2 i=1,3
      vlat(i,j)=vlatt(i,j)
      vlati(i,j)=vlatt(i,j)
    2 continue
    1 continue
c
      call matinv(vlati,3,3)
c
      if(me.eq.node) then
      nwmloc=numwm
      nsaloc=numsa
      endif
c
      return
      end
      subroutine sp_gagetixv(node,iwl,iwlp,xw,xwcr,vw,numwm,isl,islp,
     + xs,vs,numsa,ipl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3)
      integer ipl(mbox,mip2)
      integer il,ih,jl,jh
c
      call ga_distribution(ga_ip,node,il,ih,jl,jh)
      call ga_get(ga_ip,il,ih,jl,jh,ipl,mbox)
      numwm=ipl(1,2)
      numsa=ipl(2,2)
c
      if(numwm.gt.0) then
      call ga_distribution(ga_iw,node,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_get(ga_iw,il,il+numwm-1,jl,jh,iwl,mwm)
      else
      call ga_get(ga_iw,il,il+numwm-1,jl,jl+npackw-1,iwlp,mwm)
      call sp_unpackw(numwm,iwl,iwlp)
      endif
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_get(ga_w,il,ih,jl,jl+3*mwa-1,xw,mwm)
      call ga_get(ga_w,il,ih,jl+3*mwa,jl+6*mwa-1,vw,mwm)
      call ga_get(ga_w,il,ih,jl+6*mwa,jl+6*mwa+2,xwcr,mwm)
      endif
c
      if(numsa.gt.0) then
      call ga_distribution(ga_is,node,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_get(ga_is,il,il+numsa-1,jl,jh,isl,msa)
      else
      call ga_get(ga_is,il,il+numsa-1,jl,jl+npack-1,islp,msa)
      call sp_unpack(numsa,isl,islp)
      endif
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_get(ga_s,il,ih,jl,jl+2,xs,msa)
      call ga_get(ga_s,il,ih,jl+3,jl+5,vs,msa)
      endif
c
      return
      end
      subroutine sp_gagetixvf(node,iwl,iwlp,xw,xwcr,vw,fw,
     + numwm,isl,islp,xs,vs,fs,numsa,ipl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3)
      real*8 fw(mwm,3,mwa),fs(msa,3)
      integer ipl(mbox,mip2)
      integer il,ih,jl,jh
c
      call ga_distribution(ga_ip,node,il,ih,jl,jh)
      call ga_get(ga_ip,il,ih,jl,jh,ipl,mbox)
      numwm=ipl(1,2)
      numsa=ipl(2,2)
c
      if(numwm.gt.0) then
      call ga_distribution(ga_iw,node,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_get(ga_iw,il,il+numwm-1,jl,jh,iwl,mwm)
      else
      call ga_get(ga_iw,il,il+numwm-1,jl,jl+npackw-1,iwlp,mwm)
      call sp_unpackw(numwm,iwl,iwlp)
      endif
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_get(ga_w,il,ih,jl,jl+3*mwa-1,xw,mwm)
      call ga_get(ga_w,il,ih,jl+3*mwa,jl+6*mwa-1,vw,mwm)
      call ga_get(ga_w,il,ih,jl+6*mwa,jl+6*mwa+2,xwcr,mwm)
      call ga_get(ga_w,il,ih,jl+6*mwa+3,jl+9*mwa+2,fw,mwm)
      endif
c
      if(numsa.gt.0) then
      call ga_distribution(ga_is,node,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_get(ga_is,il,il+numsa-1,jl,jh,isl,msa)
      else
      call ga_get(ga_is,il,il+numsa-1,jl,jl+npack-1,islp,msa)
      call sp_unpack(numsa,isl,islp)
      endif
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_get(ga_s,il,ih,jl,jl+2,xs,msa)
      call ga_get(ga_s,il,ih,jl+3,jl+5,vs,msa)
      call ga_get(ga_s,il,ih,jl+9,jl+11,fs,msa)
      endif
c
      return
      end
      subroutine sp_gaputixv(node,iwl,iwlp,xw,xwcr,vw,numwm,isl,islp,
     + xs,vs,numsa,ipl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3),xwcr(mwm,3)
      real*8 vw(mwm,3,mwa),vs(msa,3)
      integer ipl(mbox,mip2)
      integer il,ih,jl,jh
c
      ipl(1,2)=numwm
      ipl(2,2)=numsa
      call ga_distribution(ga_ip,node,il,ih,jl,jh)
      call ga_put(ga_ip,il,ih,jl,jh,ipl,mbox)
c
      if(numwm.gt.0) then
      call ga_distribution(ga_iw,node,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_put(ga_iw,il,il+numwm-1,jl,jh,iwl,mwm)
      else
      call sp_packw(numwm,iwl,iwlp)
      call ga_put(ga_iw,il,il+numwm-1,jl,jl+npackw-1,iwlp,mwm)
      endif
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_put(ga_w,il,ih,jl,jl+3*mwa-1,xw,mwm)
      call ga_put(ga_w,il,ih,jl+3*mwa,jl+6*mwa-1,vw,mwm)
      call ga_put(ga_w,il,ih,jl+6*mwa,jl+6*mwa+2,xwcr,mwm)
      endif
c
      if(numsa.gt.0) then
      call ga_distribution(ga_is,node,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_put(ga_is,il,il+numsa-1,jl,jh,isl,msa)
      else
      call sp_pack(numsa,isl,islp)
      call ga_put(ga_is,il,il+numsa-1,jl,jl+npack-1,islp,msa)
      endif
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_put(ga_s,il,ih,jl,jl+2,xs,msa)
      call ga_put(ga_s,il,ih,jl+3,jl+5,vs,msa)
      endif
c
      return
      end
      subroutine sp_gaputf(node,fw,numwm,fs,numsa)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      real*8 fw(mwm,3,mwa),fs(msa,3)
      integer il,ih,jl,jh
c
      if(numwm.gt.0) then
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_put(ga_w,il,ih,jl+6*mwa+3,jl+9*mwa+2,fw,mwm)
      endif
      if(numsa.gt.0) then
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_put(ga_s,il,ih,jl+6,jl+8,fs,msa)
      endif
c
      return
      end
      subroutine sp_gagetf(node,fw,numwm,fs,numsa)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      real*8 fw(mwm,3,mwa),fs(msa,3)
      integer il,ih,jl,jh
c
      if(numwm.gt.0) then
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_get(ga_w,il,ih,jl+6*mwa+3,jl+9*mwa+2,fw,mwm)
      endif
      if(numsa.gt.0) then
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_get(ga_s,il,ih,jl+6,jl+8,fs,msa)
      endif
c
      return
      end
      subroutine sp_gaputix(node,iwl,iwlp,xw,numwm,
     + isl,islp,xs,numsa,ipl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer node,numwm,numsa
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      integer ipl(mbox,mip2)
      integer il,ih,jl,jh
c
      ipl(1,2)=numwm
      ipl(2,2)=numsa
      call ga_distribution(ga_ip,node,il,ih,jl,jh)
      call ga_put(ga_ip,il,ih,jl,jh,ipl,mbox)
c
      if(numwm.gt.0) then
      call ga_distribution(ga_iw,node,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_put(ga_iw,il,il+numwm-1,jl,jh,iwl,mwm)
      else
      call sp_packw(numwm,iwl,iwlp)
      call ga_put(ga_iw,il,il+numwm-1,jl,jl+npackw-1,iwlp,mwm)
      endif
      call ga_distribution(ga_w,node,il,ih,jl,jh)
      ih=il+numwm-1
      call ga_put(ga_w,il,ih,jl,jl+3*mwa-1,xw,mwm)
      endif
c
      if(numsa.gt.0) then
      call ga_distribution(ga_is,node,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_put(ga_is,il,il+numsa-1,jl,jh,isl,msa)
      else
      call sp_pack(numsa,isl,islp)
      call ga_put(ga_is,il,il+numsa-1,jl,jl+npack-1,islp,msa)
      endif
      call ga_distribution(ga_s,node,il,ih,jl,jh)
      ih=il+numsa-1
      call ga_put(ga_s,il,ih,jl,jl+2,xs,msa)
      endif
c
      return
      end
      subroutine sp_owner(xw,iwl,numwm,xs,isl,numsa)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      real*8 xw(mwm,3,mwa),xs(msa,3)
      integer iwl(mwm,miw2),isl(msa,mis2)
      integer numwm,numsa
c
c     determine solvent ownership
c
      call sp_ownerw(xw,iwl,numwm,dbl_mb(i_boxs),int_mb(i_iown))
c
c     determine solute ownership
c
      call sp_owners(xs,isl,numsa,dbl_mb(i_boxs),int_mb(i_iown))
c
      return
      end
      subroutine sp_ownerw(xw,iwl,numwm,boxsiz,ibownr)
c
      implicit none
c
#include "sp_common.fh"
c
      real*8 xw(mwm,3,mwa)
      real*8 boxsiz(maxbox,3)
      integer iwl(mwm,miw2),ibownr(maxbox,3)
      integer numwm
c
      integer iwm,ibx,iby,ibz,i,k,ipx,ipy,ipz
      real*8 cgx,cgy,cgz,xt(3)
c
c     determine the box and owning node for each solvent molecule
c
      do 1 iwm=1,numwm
      cgx=zero
      cgy=zero
      cgz=zero
      do 2 k=1,nwa
      cgx=cgx+xw(iwm,1,k)
      cgy=cgy+xw(iwm,2,k)
      cgz=cgz+xw(iwm,3,k)
    2 continue
      ibx=0
      iby=0
      ibz=0
      if(nbxtyp.ne.1) then
      xt(1)=cgx
      xt(2)=cgy
      xt(3)=cgz
      else
      xt(1)=box(1)*(vlati(1,1)*cgx+vlati(1,2)*cgy+vlati(1,3)*cgz)
      xt(2)=box(2)*(vlati(2,1)*cgx+vlati(2,2)*cgy+vlati(2,3)*cgz)
      xt(3)=box(3)*(vlati(3,1)*cgx+vlati(3,2)*cgy+vlati(3,3)*cgz)
      endif
      do 3 i=1,nbx-1
      if(xt(1)/nwa+boxh(1).gt.boxsiz(i,1)) ibx=i
    3 continue
      do 4 i=1,nby-1
      if(xt(2)/nwa+boxh(2).gt.boxsiz(i,2)) iby=i
    4 continue
      do 5 i=1,nbz-1
      if(xt(3)/nwa+boxh(3).gt.boxsiz(i,3)) ibz=i
    5 continue
      if(npbtyp.gt.0) then
      if(ibx.ge.nbx) ibx=ibx-nbx
      if(iby.ge.nby) iby=iby-nby
      if(ibx.lt.0) ibx=ibx+nbx
      if(iby.lt.0) iby=iby+nby
      if(npbtyp.eq.1) then
      if(ibz.ge.nbz) ibz=ibz-nbz
      if(ibz.lt.0) ibz=ibz+nbz
      else
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibz.lt.0) ibz=0
      endif
      else
      if(ibx.ge.nbx) ibx=nbx-1
      if(iby.ge.nby) iby=nby-1
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibx.lt.0) ibx=0
      if(iby.lt.0) iby=0
      if(ibz.lt.0) ibz=0
      endif
      ipx=ibownr(ibx+1,1)
      ipy=ibownr(iby+1,2)
      ipz=ibownr(ibz+1,3)
      iwl(iwm,lwbox)=(ibz*nby+iby)*nbx+ibx
      iwl(iwm,lwnod)=(ipz*npy+ipy)*npx+ipx
    1 continue
c
      return
      end
      subroutine sp_owners(xs,isl,numsa,boxsiz,ibownr)
c
      implicit none
c
#include "sp_common.fh"
c
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 util_nint
      external util_nint
#endif
c
      real*8 xs(msa,3)
      real*8 boxsiz(maxbox,3)
      integer ibownr(maxbox,3)
      integer isl(msa,mis2)
      integer numsa,nfold
c
      integer isa,isaf,isal,jsa,ibox,inod,k
      integer ibx,iby,ibz,i,ipx,ipy,ipz
      real*8 xcgx,xcgy,xcgz,boxi(3),xcg(3)
      real*8 xcgmax,xcgmin,factor
c
      boxi(1)=one/box(1)
      boxi(2)=one/box(2)
      boxi(3)=one/box(3)
      nfold=0
c
      isaf=1
      isal=0
      do 1 isa=1,numsa
c
      if(isa.lt.numsa) then
      if(isl(isa+1,lssgm).ne.isl(isaf,lssgm)) isal=isa
      else
      isal=isa
      endif
c
      if(isal.gt.0) then
c
      do 322 k=1,3
      xcgmin=xs(isaf,k)
      xcgmax=xs(isaf,k)
      do 323 jsa=isaf,isal
      xcgmin=min(xcgmin,xs(jsa,k))
      xcgmax=max(xcgmax,xs(jsa,k))
  323 continue
      xcg(k)=0.5d0*(xcgmax+xcgmin)
  322 continue
c
c      xcgx=xcg(1)
c      xcgy=xcg(2)
c      xcgz=xcg(3)
      xcgx=zero
      xcgy=zero
      xcgz=zero
      do 2 jsa=isaf,isal
      xcgx=xcgx+xs(jsa,1)
      xcgy=xcgy+xs(jsa,2)
      xcgz=xcgz+xs(jsa,3)
    2 continue
      factor=one/dble(isal-isaf+1)
      xcgx=factor*xcgx
      xcgy=factor*xcgy
      xcgz=factor*xcgz
cx
      xcgx=xcg(1)
      xcgy=xcg(2)
      xcgz=xcg(3)
c
      if(npbtyp.ne.0) then
      if(abs(xcgx).gt.boxh(1)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xcgx=xcgx-util_nint(xcgx*boxi(1))*box(1)
#else
      xcgx=xcgx-nint(xcgx*boxi(1))*box(1)
#endif
      nfold=1
      endif
      if(abs(xcgy).gt.boxh(2)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xcgy=xcgy-util_nint(xcgy*boxi(2))*box(2)
#else
      xcgy=xcgy-nint(xcgy*boxi(2))*box(2)
#endif
      nfold=1
      endif
      if(abs(xcgz).gt.boxh(3)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xcgz=xcgz-util_nint(xcgz*boxi(3))*box(3)
#else
      xcgz=xcgz-nint(xcgz*boxi(3))*box(3)
#endif
      nfold=1
      endif
      endif
c
      ibx=0
      iby=0
      ibz=0
      do 3 i=1,nbx-1
      if(xcgx+boxh(1).gt.boxsiz(i,1)) ibx=i
    3 continue
      do 4 i=1,nby-1
      if(xcgy+boxh(2).gt.boxsiz(i,2)) iby=i
    4 continue
      do 5 i=1,nbz-1
      if(xcgz+boxh(3).gt.boxsiz(i,3)) ibz=i
    5 continue
      if(npbtyp.gt.0) then
      if(ibx.ge.nbx) ibx=ibx-nbx
      if(iby.ge.nby) iby=iby-nby
      if(ibx.lt.0) ibx=ibx+nbx
      if(iby.lt.0) iby=iby+nby
      if(npbtyp.eq.1) then
      if(ibz.ge.nbz) ibz=ibz-nbz
      if(ibz.lt.0) ibz=ibz+nbz
      else
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibz.lt.0) ibz=0
      endif
      else
      if(ibx.ge.nbx) ibx=nbx-1
      if(iby.ge.nby) iby=nby-1
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibx.lt.0) ibx=0
      if(iby.lt.0) iby=0
      if(ibz.lt.0) ibz=0
      endif
      ipx=ibownr(ibx+1,1)
      ipy=ibownr(iby+1,2)
      ipz=ibownr(ibz+1,3)
      ibox=(ibz*nby+iby)*nbx+ibx
      inod=(ipz*npy+ipy)*npx+ipx
      do 6 jsa=isaf,isal
      isl(jsa,lsbox)=ibox
      isl(jsa,lsnod)=inod
    6 continue
c
      isaf=isa+1
      isal=0
c
      endif
c
    1 continue
c
      return
      end
      subroutine sp_travel(bx,xw,vw,xwcr,gw,iwl,numwm,
     + xs,vs,gs,isl,numsa)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      real*8 xw(mwm,3,mwa),vw(mwm,3,mwa),xwcr(mwm,3)
      real*8 xs(msa,3),vs(msa,3),bx(3)
      real*8 gw(mwm,3,mwa),gs(msa,3)
      integer iwl(mwm,miw2),isl(msa,mis2)
      integer numwm,numsa
c
      integer lenx,i_ndx,l_ndx,i_itmp,l_itmp,i_rtmp,l_rtmp
c
      call ga_sync()
c
      box(1)=bx(1)
      box(2)=bx(2)
      box(3)=bx(3)
c
      call sp_bscale(dbl_mb(i_boxs))
c
      call sp_owner(xw,iwl,nwmloc,xs,isl,nsaloc)
c
      lenx=max(nwm,nsa)
      if(.not.ma_push_get(mt_int,lenx,'ndx',l_ndx,i_ndx))
     + call md_abort('Failed to allocate ndx',0)
      if(.not.ma_push_get(mt_int,lenx,'itmp',l_itmp,i_itmp))
     + call md_abort('Failed to allocate itmp',0)
      if(.not.ma_push_get(mt_dbl,lenx,'rtmp',l_rtmp,i_rtmp))
     + call md_abort('Failed to allocate rtmp',0)
c
      call sp_trvl(xw,vw,xwcr,gw,iwl,int_mb(i_packw),
     + xs,vs,gs,isl,int_mb(i_pack),
     + dbl_mb(i_boxs),int_mb(i_iown),int_mb(i_ipl),
     + int_mb(i_ndx),int_mb(i_itmp),dbl_mb(i_rtmp),lenx)
c
      call ga_sync()
c
      if(.not.ma_pop_stack(l_rtmp))
     + call md_abort('Failed to de-allocate rtmp',0)
      if(.not.ma_pop_stack(l_itmp))
     + call md_abort('Failed to de-allocate itmp',0)
      if(.not.ma_pop_stack(l_ndx))
     + call md_abort('Failed to de-allocate ndx',0)
c
      call sp_gaputixv(me,iwl,int_mb(i_packw),xw,xwcr,vw,nwmloc,
     + isl,int_mb(i_pack),xs,vs,nsaloc,int_mb(i_ipl))
c
      call sp_lbbl_indices()
c
      numwm=nwmloc
      numsa=nsaloc
c
      return
      end
      subroutine sp_trvl(xw,vw,xwcr,gw,iwl,iwlp,xs,vs,gs,isl,islp,
     + boxsiz,ibownr,ipl,ndx,itmp,rtmp,lenx)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "msgids.fh"
c
      real*8 xw(mwm,3,mwa),vw(mwm,3,mwa),xwcr(mwm,3)
      real*8 xs(msa,3),vs(msa,3)
      real*8 gw(mwm,3,mwa),gs(msa,3)
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      integer lenx
      real*8 boxsiz(maxbox,3)
      integer ipl(mbox,mip2),ibownr(maxbox,3)
      integer ndx(lenx),itmp(lenx)
      real*8 rtmp(lenx)
      logical lrec(27)
c
      integer i,indexw,indexs,j,k,ibx,iby,ibz,ipx,ipy,ipz
      integer isbox,isnod,nrbox
      integer ilp,ihp,jlp,jhp
      integer il,ih,jl,jh,ilw,ihw,jlw,jhw,ils,ihs,jls,jhs
      integer iliw,ihiw,jliw,jhiw
      integer ilis,ihis,jlis,jhis
      integer iwm,iwstay,jwstay,lwstay,nwgo,nwgosm
      integer nwgtsm
      integer nwnew,nwstay,iwmloc,jwmloc,lwmloc,irw
      integer isa,jsa,isstay,jsstay,icsgm,ifsgm,ilsgm
      integer nsnew,nsstay,lsstay,isaloc,jsaloc,lsaloc,irs
      integer nsgo,jnode,iwfr,iwto,isfr,isto
      real*8 factor,xscx,xscy,xscz,boxi(3)
      integer itemps,nfold
      logical lend
      character*255 string
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      real*8 util_nint
      external util_nint
#endif
c
      boxi(1)=one/box(1)
      boxi(2)=one/box(2)
      boxi(3)=one/box(3)
      nfold=0
      lpbc9=.false.
c
      nwstay=0
c
c     order the solvent molecules
c
      if(nwmloc.gt.0) then
      do 1 i=1,nwmloc
      ndx(i)=i
    1 continue
      endif
      if(nwmloc.gt.1) then
      lwmloc=nwmloc/2+1
      irw=nwmloc
    2 continue
      if(lwmloc.gt.1) then
      lwmloc=lwmloc-1
      itemps=ndx(lwmloc)
      else
      itemps=ndx(irw)
      ndx(irw)=ndx(1)
      irw=irw-1
      if(irw.eq.1) then
      ndx(1)=itemps
      goto 3
      endif
      endif
      iwmloc=lwmloc
      jwmloc=lwmloc+lwmloc
    4 continue
      if(jwmloc.le.irw) then
      if(jwmloc.lt.irw) then
      if((iwl(ndx(jwmloc),lwnod).eq.iwl(ndx(jwmloc+1),lwnod).and.
     + iwl(ndx(jwmloc),lwbox).le.iwl(ndx(jwmloc+1),lwbox)).or.
     + ((iwl(ndx(jwmloc),lwnod).eq.me.or.
     + (iwl(ndx(jwmloc),lwnod).ne.me.and.
     + iwl(ndx(jwmloc),lwnod).le.iwl(ndx(jwmloc+1),lwnod))).and.
     + iwl(ndx(jwmloc+1),lwnod).ne.me)) jwmloc=jwmloc+1
      endif
      if((iwl(itemps,lwnod).eq.iwl(ndx(jwmloc),lwnod).and.
     + iwl(itemps,lwbox).le.iwl(ndx(jwmloc),lwbox)).or.
     + ((iwl(itemps,lwnod).eq.me.or. (iwl(itemps,lwnod).ne.me.and.
     + iwl(itemps,lwnod).le.iwl(ndx(jwmloc),lwnod))).and.
     + iwl(ndx(jwmloc),lwnod).ne.me)) then
      ndx(iwmloc)=ndx(jwmloc)
      iwmloc=jwmloc
      jwmloc=jwmloc+jwmloc
      else
      jwmloc=irw+1
      endif
      goto 4
      endif
      ndx(iwmloc)=itemps
      goto 2
    3 continue
c
      do 5 k=1,3
      do 8 i=1,nwmloc
      rtmp(i)=xwcr(i,k)
    8 continue
      do 9 i=1,nwmloc
      xwcr(i,k)=rtmp(ndx(i))
    9 continue
      do 10 j=1,nwa
      do 11 i=1,nwmloc
      rtmp(i)=xw(i,k,j)
   11 continue
      do 12 i=1,nwmloc
      xw(i,k,j)=rtmp(ndx(i))
   12 continue
      do 13 i=1,nwmloc
      rtmp(i)=vw(i,k,j)
   13 continue
      do 14 i=1,nwmloc
      vw(i,k,j)=rtmp(ndx(i))
   14 continue
      if(iguide.gt.0) then
      do 113 i=1,nwmloc
      rtmp(i)=gw(i,k,j)
  113 continue
      do 114 i=1,nwmloc
      gw(i,k,j)=rtmp(ndx(i))
  114 continue
      endif
   10 continue
    5 continue
      do 18 k=1,miw2
      do 19 i=1,nwmloc
      itmp(i)=iwl(i,k)
   19 continue
      do 20 i=1,nwmloc
      iwl(i,k)=itmp(ndx(i))
   20 continue
   18 continue
      endif
c
      if(nwmloc.gt.0) then
      do 21 iwm=1,nwmloc
      if(iwl(iwm,lwnod).eq.me) then
      nwstay=iwm
      else
c
c     check if moving atoms go to neighboring processor
c
      do 222 k=1,27
      if(iwl(iwm,lwnod).eq.neighb(k,1)) goto 223
  222 continue
      write(string,'(a,i4,a,i4,a,i4,9f6.2)')
     +  'sp_travel: solvent molecule ',
     + iwl(iwm,lwgmn),' moving to non-neighbor ',iwl(iwm,lwnod),
     + ' from ',me,((xw(iwm,i,j),i=1,3),j=1,3)
      call md_abort(string,me)
  223 continue
c
      endif
c
c     testcode
c
      if(iand(idebug,8).eq.8) then
      if(iwl(iwm,lwnod).ne.me) write(lfndbg,'(a,3i5)')
     +  'Travel w fnd ',me,iwl(iwm,lwnod),iwl(iwm,lwgmn)
      endif
c
c     end test code
c
   21 continue
      endif
c
c     order the solute atoms
c
c     isl(isa,lsbox) : box
c     isl(isa,lsnod) : node
c     isl(isa,lssgm) : segment
c
      nsstay=0
      if(nsaloc.gt.0) then
      do 22 i=1,nsaloc
      ndx(i)=i
   22 continue
      endif
c
      if(nsaloc.gt.1) then
      lsaloc=nsaloc/2+1
      irs=nsaloc
   23 continue
      if(lsaloc.gt.1) then
      lsaloc=lsaloc-1
      itemps=ndx(lsaloc)
      else
      itemps=ndx(irs)
      ndx(irs)=ndx(1)
      irs=irs-1
      if(irs.eq.1) then
      ndx(1)=itemps
      goto 24
      endif
      endif
      isaloc=lsaloc
      jsaloc=lsaloc+lsaloc
   25 continue
      if(jsaloc.le.irs) then
      if(jsaloc.lt.irs) then
      if((isl(ndx(jsaloc),lsnod).eq.isl(ndx(jsaloc+1),lsnod).and.
     + (isl(ndx(jsaloc),lsbox).lt.isl(ndx(jsaloc+1),lsbox).or.
     + (isl(ndx(jsaloc),lsbox).eq.isl(ndx(jsaloc+1),lsbox).and.
     + isl(ndx(jsaloc),lssgm).le.isl(ndx(jsaloc+1),lssgm)))).or.
     + ((isl(ndx(jsaloc),lsnod).eq.me.or.
     + (isl(ndx(jsaloc),lsnod).ne.me.and.
     + isl(ndx(jsaloc),lsnod).le.isl(ndx(jsaloc+1),lsnod))).and.
     + isl(ndx(jsaloc+1),lsnod).ne.me)) jsaloc=jsaloc+1
      endif
      if((isl(itemps,lsnod).eq.isl(ndx(jsaloc),lsnod).and.
     + (isl(itemps,lsbox).lt.isl(ndx(jsaloc),lsbox).or.
     + (isl(itemps,lsbox).eq.isl(ndx(jsaloc),lsbox).and.
     + isl(itemps,lssgm).le.isl(ndx(jsaloc),lssgm)))).or.
     + ((isl(itemps,lsnod).eq.me.or. (isl(itemps,lsnod).ne.me.and.
     + isl(itemps,lsnod).le.isl(ndx(jsaloc),lsnod))).and.
     + isl(ndx(jsaloc),lsnod).ne.me)) then
      ndx(isaloc)=ndx(jsaloc)
      isaloc=jsaloc
      jsaloc=jsaloc+jsaloc
      else
      jsaloc=irs+1
      endif
      goto 25
      endif
      ndx(isaloc)=itemps
      goto 23
   24 continue
c
      do 26 k=1,3
      do 27 i=1,nsaloc
      rtmp(i)=xs(i,k)
   27 continue
      do 28 i=1,nsaloc
      xs(i,k)=rtmp(ndx(i))
   28 continue
      do 29 i=1,nsaloc
      rtmp(i)=vs(i,k)
   29 continue
      do 30 i=1,nsaloc
      vs(i,k)=rtmp(ndx(i))
   30 continue
      if(iguide.gt.0) then
      do 2129 i=1,nsaloc
      rtmp(i)=gs(i,k)
 2129 continue
      do 2130 i=1,nsaloc
      gs(i,k)=rtmp(ndx(i))
 2130 continue
      endif
   26 continue
      do 40 k=1,mis2
      do 41 i=1,nsaloc
      itmp(i)=isl(i,k)
   41 continue
      do 42 i=1,nsaloc
      isl(i,k)=itmp(ndx(i))
   42 continue
   40 continue
      endif
c
      if(nsa.gt.0) then
      do 43 isa=1,nsaloc
      if(isl(isa,lsnod).eq.me) then
      nsstay=isa
      else
c
c     check if moving atoms go to neighboring processor
c
      do 444 k=1,27
      if(isl(isa,lsnod).eq.neighb(k,1)) goto 445
  444 continue
      write(string,'(a,i4,a,i4,a,i4,3f6.2)')
     +  'sp_travel: solute segment ',
     + isl(isa,lssgm),' moving to non-neighbor ',isl(isa,lsnod),
     + ' from ',me,(xs(isa,i),i=1,3)
      call md_abort(string,me)
  445 continue
c
      endif
   43 continue
      endif
c
c     make packages ready for shipment
c
c     loop over all neighboring nodes
c
      call ga_distribution(ga_iw,me,iliw,ihiw,jliw,jhiw)
      call ga_distribution(ga_w,me,ilw,ihw,jlw,jhw)
      call ga_distribution(ga_is,me,ilis,ihis,jlis,jhis)
      call ga_distribution(ga_s,me,ils,ihs,jls,jhs)
c
      indexw=0
      indexs=0
      nwgosm=0
c
      do 70 i=1,27
      jnode=neighb(i,1)
      if(jnode.ge.0.and.jnode.ne.me) then
c
c     for the solvent
c
      iwfr=0
      iwto=0
      do 71 iwm=nwstay+1,nwmloc
      if(iwl(iwm,lwnod).eq.jnode) then
      if(iwfr.eq.0) iwfr=iwm
      iwto=iwm
c
c     testcode
c
      if(iand(idebug,8).eq.8) then
      if(iwl(iwm,lwnod).ne.me) write(lfndbg,'(a,3i5)')
     +  'Travel w snd ',me,iwl(iwm,lwnod),iwl(iwm,lwgmn)
      endif
c
c     end test code
c
      endif
   71 continue
c
c     if molecules need to travel copy coordinates etc into global array
c
      nwgo=iwto-iwfr+1
      if(iwfr.eq.0) nwgo=0
      ipl(1,1)=0
      ipl(1,2)=0
c
      if(nwgo.gt.0) then
      nwgosm=nwgosm+nwgo
      il=iliw+indexw
      ih=il+nwgo-1
      if(npackw.eq.0) then
      call ga_put(ga_iw,il,ih,jliw,jhiw,iwl(iwfr,1),mwm)
      else
      call sp_packw(ih-il+1,iwl(iwfr,1),iwlp(iwfr,1))
      call ga_put(ga_iw,il,ih,jliw,jliw+npackw-1,iwlp(iwfr,1),mwm)
      endif
      il=ilw+indexw
      ih=il+nwgo-1
      call ga_put(ga_w,il,ih,jlw,jlw+3*mwa-1,xw(iwfr,1,1),mwm)
      call ga_put(ga_w,il,ih,jlw+3*mwa,jlw+6*mwa-1,vw(iwfr,1,1),mwm)
      call ga_put(ga_w,il,ih,jlw+6*mwa,jlw+6*mwa+2,xwcr(iwfr,1),mwm)
      if(iguide.gt.0) then
      call ga_put(ga_w,il,ih,jlw+6*mwa+3,jlw+9*mwa+2,gw(iwfr,1,1),mwm)
      endif
      ipl(1,1)=indexw+1
      ipl(1,2)=indexw+nwgo
      indexw=indexw+nwgo
      endif
c
c     for the solute
c
      isfr=0
      isto=0
      do 72 isa=nsstay+1,nsaloc
      if(isl(isa,lsnod).eq.jnode) then
      if(isfr.eq.0) isfr=isa
      isto=isa
      endif
   72 continue
      nsgo=isto-isfr+1
      if(isfr.eq.0) nsgo=0
      ipl(1,3)=0
      ipl(1,4)=0
      if(nsgo.gt.0) then
      il=ilis+indexs
      ih=il+nsgo-1
      if(npack.eq.0) then
      call ga_put(ga_is,il,ih,jlis,jhis,isl(isfr,1),msa)
      else
      call sp_pack(ih-il+1,isl(isfr,1),islp(isfr,1))
      call ga_put(ga_is,il,ih,jlis,jlis+npack-1,islp(isfr,1),msa)
      endif
      call ga_put(ga_s,il,ih,jls,jls+2,xs(isfr,1),msa)
      call ga_put(ga_s,il,ih,jls+3,jls+5,vs(isfr,1),msa)
      if(iguide.gt.0) then
      call ga_put(ga_s,il,ih,jls+6,jls+8,gs(isfr,1),msa)
      endif
      ipl(1,3)=indexs+1
      ipl(1,4)=indexs+nsgo
      indexs=indexs+nsgo
      endif
c
c     inform other node of number of molecules to get
c
      if(ipl(1,1).gt.0.or.ipl(1,3).gt.0) then
      call ga_distribution(ga_ip,jnode,ilp,ihp,jlp,jhp)
      ilp=ilp+2+i
      call ga_put(ga_ip,ilp,ilp,jlp,jhp,ipl,mbox)
      endif
      endif
      lrec(i)=.false.
   70 continue
c
      call ga_sync()
c
c     receive molecules from other nodes
c
      nwgtsm=0
c
      call ga_distribution(ga_ip,me,ilp,ihp,jlp,jhp)
      call ga_get(ga_ip,ilp,ilp+30,jlp,jhp,ipl,mbox)
c
      do 74 i=1,27
      jnode=neighb(i,2)
      if(jnode.ge.0.and.jnode.ne.me.and..not.lrec(i)) then
c
      iwfr=ipl(3+i,1)
      iwto=ipl(3+i,2)
      isfr=ipl(3+i,3)
      isto=ipl(3+i,4)
c
      nwnew=iwto-iwfr+1
      nsnew=isto-isfr+1
c
      if(iwfr.eq.0) nwnew=0
      if(isfr.eq.0) nsnew=0
c
      if(nwstay+nwnew.gt.mwm) then
      write(string,'(a,i7,a,i7)')
     + 'Travel: mwm needs increase with ',nwnew,' to ',nwstay+nwnew
      call md_abort(string,me)
      endif
      if(nsstay+nsnew.gt.msa) then
      write(string,'(a,i7,a,i7)')
     + 'Travel: msa needs increase with ',nsnew,' to ',nsstay+nsnew
      call md_abort(string,me)
      endif
c
      lrec(i)=.true.
c
      if(iwfr.gt.0) then
      nwgtsm=nwgtsm+nwnew
      iwto=ipl(3+i,2)
      call ga_distribution(ga_iw,jnode,iliw,ihiw,jliw,jhiw)
      call ga_distribution(ga_w,jnode,ilw,ihw,jlw,jhw)
c
c     get data for additional molecules
c
      il=iliw+iwfr-1
      ih=iliw+iwto-1
      if(npackw.eq.0) then
      call ga_get(ga_iw,il,ih,jliw,jhiw,iwl(nwstay+1,1),mwm)
      else
      call ga_get(ga_iw,il,ih,jliw,jliw+npackw-1,iwlp(nwstay+1,1),mwm)
      call sp_unpackw(ih-il+1,iwl(nwstay+1,1),iwlp(nwstay+1,1))
      endif
      call ga_get(ga_w,il,ih,jlw,jlw+3*mwa-1,xw(nwstay+1,1,1),mwm)
      call ga_get(ga_w,il,ih,jlw+3*mwa,jlw+6*mwa-1,vw(nwstay+1,1,1),mwm)
      call ga_get(ga_w,il,ih,jlw+6*mwa,jlw+6*mwa+2,xwcr(nwstay+1,1),mwm)
      if(iguide.gt.0) then
      call ga_get(ga_w,il,ih,jlw+6*mwa+3,jlw+9*mwa+2,
     + gw(nwstay+1,1,1),mwm)
      endif
c
c     testcode
c
      if(iand(idebug,8).eq.8) then
      write(lfndbg,'(a,3i5)')
     +  ('Travel w rcv ',me,jnode,iwl(nwstay+k,lwgmn),k=1,nwnew)
      endif
c
c     end test code
c
c
c     update number of local solvent molecules
c
      nwstay=nwstay+nwnew
c
      endif
c
c     for the solute
c
      if(isfr.gt.0) then
      call ga_distribution(ga_is,jnode,ilis,ihis,jlis,jhis)
      call ga_distribution(ga_s,jnode,ils,ihs,jls,jhs)
      il=ilis+isfr-1
      ih=ilis+isto-1
      jl=jlis
      jh=jhis
      if(npack.eq.0) then
      call ga_get(ga_is,il,ih,jlis,jhis,isl(nsstay+1,1),msa)
      else
      call ga_get(ga_is,il,ih,jlis,jlis+npack-1,islp(nsstay+1,1),msa)
      call sp_unpack(ih-il+1,isl(nsstay+1,1),islp(nsstay+1,1))
      endif
      call ga_get(ga_s,il,ih,jls,jls+2,xs(nsstay+1,1),msa)
      call ga_get(ga_s,il,ih,jls+3,jls+5,vs(nsstay+1,1),msa)
      if(iguide.gt.0) then
      call ga_get(ga_s,il,ih,jls+6,jls+8,gs(nsstay+1,1),msa)
      endif
c
      nsstay=nsstay+nsnew
      endif
c
      endif
c
c     reset the pointers to zero
c
      ipl(3+i,1)=0
      ipl(3+i,2)=0
      ipl(3+i,3)=0
      ipl(3+i,4)=0
c
   74 continue
c
c     reset ipl in global array
c
      call ga_put(ga_ip,ilp,ilp+30,jlp,jhp,ipl,mbox)
c
c     order the solvent molecules according to subbox and
c     store indices into ip
c
c     ip(1,1)    : number of boxes on this node
c     ip(1,2)    : number of solvent molecules on this node
c     ip(2,2)    : number of solute atoms on this node
c
c     ip(3+i,1)  : index for solvents to be moved to the i-th neighbor
c
c     ip(30+i,1) : number of i-th box on this node
c     ip(30+i,2) : index to first solvent in i-th box
c     ip(30+i,3) : index to lasst solvent in i-th box
c
      if(nwstay.gt.0.and.(nwgosm.gt.0.or.nwgtsm.gt.0)) then
      do 81 i=1,nwstay
      ndx(i)=i
   81 continue
      if(nwstay.gt.1) then
      lwstay=nwstay/2+1
      irw=nwstay
   82 continue
      if(lwstay.gt.1) then
      lwstay=lwstay-1
      itemps=ndx(lwstay)
      else
      itemps=ndx(irw)
      ndx(irw)=ndx(1)
      irw=irw-1
      if(irw.eq.1) then
      ndx(1)=itemps
      goto 83
      endif
      endif
      iwstay=lwstay
      jwstay=lwstay+lwstay
   84 continue
      if(jwstay.le.irw) then
      if(jwstay.lt.irw) then
      if(iwl(ndx(jwstay),lwbox).le.iwl(ndx(jwstay+1),lwbox))
     + jwstay=jwstay+1
      endif
      if(iwl(itemps,lwbox).le.iwl(ndx(jwstay),lwbox)) then
      ndx(iwstay)=ndx(jwstay)
      iwstay=jwstay
      jwstay=jwstay+jwstay
      else
      jwstay=irw+1
      endif
      goto 84
      endif
      ndx(iwstay)=itemps
      goto 82
   83 continue
c
      do 85 k=1,3
      do 88 i=1,nwstay
      rtmp(i)=xwcr(i,k)
   88 continue
      do 89 i=1,nwstay
      xwcr(i,k)=rtmp(ndx(i))
   89 continue
      do 90 j=1,nwa
      do 91 i=1,nwstay
      rtmp(i)=xw(i,k,j)
   91 continue
      do 92 i=1,nwstay
      xw(i,k,j)=rtmp(ndx(i))
   92 continue
      do 93 i=1,nwstay
      rtmp(i)=vw(i,k,j)
   93 continue
      do 94 i=1,nwstay
      vw(i,k,j)=rtmp(ndx(i))
   94 continue
      if(iguide.gt.0) then
      do 193 i=1,nwstay
      rtmp(i)=gw(i,k,j)
  193 continue
      do 194 i=1,nwstay
      gw(i,k,j)=rtmp(ndx(i))
  194 continue
      endif
   90 continue
   85 continue
      do 98 k=1,miw2
      do 99 i=1,nwstay
      itmp(i)=iwl(i,k)
   99 continue
      do 100 i=1,nwstay
      iwl(i,k)=itmp(ndx(i))
  100 continue
   98 continue
c
      endif
      endif
c
c     order the solute according to segment
c
      if(nsstay.gt.0) then
      do 122 i=1,nsstay
      ndx(i)=i
  122 continue
      if(nsstay.gt.1) then
      lsstay=nsstay/2+1
      irs=nsstay
  123 continue
      if(lsstay.gt.1) then
      lsstay=lsstay-1
      itemps=ndx(lsstay)
      else
      itemps=ndx(irs)
      ndx(irs)=ndx(1)
      irs=irs-1
      if(irs.eq.1) then
      ndx(1)=itemps
      goto 124
      endif
      endif
      isstay=lsstay
      jsstay=lsstay+lsstay
  125 continue
      if(jsstay.le.irs) then
      if(jsstay.lt.irs) then
      if(isl(ndx(jsstay),lssgm).le.isl(ndx(jsstay+1),lssgm))
     + jsstay=jsstay+1
      endif
      if(isl(itemps,lssgm).le.isl(ndx(jsstay),lssgm)) then
      ndx(isstay)=ndx(jsstay)
      isstay=jsstay
      jsstay=jsstay+jsstay
      else
      jsstay=irs+1
      endif
      goto 125
      endif
      ndx(isstay)=itemps
      goto 123
  124 continue
      endif
c
c     for each segment : 1. determine box number
c                        2. assign box number to each atom
c                        3. when box not owned by node:
c                           a. assign box number
c                           b. assign correct node number
c
      goto 666
      icsgm=isl(ndx(1),lssgm)
      ifsgm=1
      ilsgm=1
      do 126 isa=2,nsstay+1
c
c     if isa is first atom of a new segment or very last atom
c
      
      if(isa.le.nsstay) then
      lend=isl(ndx(isa),lssgm).ne.icsgm
      else
      lend=.true.
      endif
      if(lend) then
      if(isa.gt.nsstay) ilsgm=nsstay
      if(ifsgm.gt.0.and.ilsgm.ge.ifsgm) then
      xscx=zero
      xscy=zero
      xscz=zero
      do 127 jsa=ifsgm,ilsgm
      xscx=xscx+xs(ndx(jsa),1)
      xscy=xscy+xs(ndx(jsa),2)
      xscz=xscz+xs(ndx(jsa),3)
  127 continue
      factor=one/dble(ilsgm-ifsgm+1)
      xscx=factor*xscx
      xscy=factor*xscy
      xscz=factor*xscz
      if(npbtyp.ne.0) then
      if(abs(xscx).gt.boxh(1)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xscx=xscx-util_nint(xscx*boxi(1))*box(1)
#else
      xscx=xscx-nint(xscx*boxi(1))*box(1)
#endif
      nfold=1
      endif
      if(abs(xscy).gt.boxh(2)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xscy=xscy-util_nint(xscy*boxi(2))*box(2)
#else
      xscy=xscy-nint(xscy*boxi(2))*box(2)
#endif
      nfold=1
      endif
      if(abs(xscz).gt.boxh(3)) then
#if defined(CRAY_T3D) || defined(CRAY_T3E)
      xscz=xscz-util_nint(xscz*boxi(3))*box(3)
#else
      xscz=xscz-nint(xscz*boxi(3))*box(3)
#endif
      nfold=1
      endif
      endif
c
c     determine the box number
c
      ibx=0
      iby=0
      ibz=0
      do 128 i=1,nbx-1
      if(xscx+boxh(1).gt.boxsiz(i,1)) ibx=i
  128 continue
      do 129 i=1,nby-1
      if(xscy+boxh(2).gt.boxsiz(i,2)) iby=i
  129 continue
      do 1130 i=1,nbz-1
      if(xscz+boxh(3).gt.boxsiz(i,3)) ibz=i
 1130 continue
      if(npbtyp.gt.0) then
      if(ibx.ge.nbx) ibx=ibx-nbx
      if(iby.ge.nby) iby=iby-nby
      if(ibx.lt.0) ibx=ibx+nbx
      if(iby.lt.0) iby=iby+nby
      if(npbtyp.eq.1) then
      if(ibz.ge.nbz) ibz=ibz-nbz
      if(ibz.lt.0) ibz=ibz+nbz
      else
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibz.lt.0) ibz=0
      endif
      else
      if(ibx.ge.nbx) ibx=nbx-1
      if(iby.ge.nby) iby=nby-1
      if(ibz.ge.nbz) ibz=nbz-1
      if(ibx.lt.0) ibx=0
      if(iby.lt.0) iby=0
      if(ibz.lt.0) ibz=0
      endif
      ipx=ibownr(ibx+1,1)
      ipy=ibownr(iby+1,2)
      ipz=ibownr(ibz+1,3)
      isbox=(ibz*nby+iby)*nbx+ibx
      isnod=(ipz*npy+ipy)*npx+ipx
c
c     assign box and node numbers
c
      do 1131 jsa=ifsgm,ilsgm
      isl(ndx(jsa),lsbox)=isbox
      isl(ndx(jsa),lsnod)=isnod
 1131 continue
c
      endif
      if(isa.le.nsstay) icsgm=isl(ndx(isa),lssgm)
      ifsgm=isa
      else
      ilsgm=isa
      endif
  126 continue
  666 continue
c
c     order solute according to box, segment, charge group, atom number
c
      if(nsstay.gt.1) then
      lsstay=nsstay/2+1
      irs=nsstay
  132 continue
      if(lsstay.gt.1) then
      lsstay=lsstay-1
      itemps=ndx(lsstay)
      else
      itemps=ndx(irs)
      ndx(irs)=ndx(1)
      irs=irs-1
      if(irs.eq.1) then
      ndx(1)=itemps
      goto 133
      endif
      endif
      isstay=lsstay
      jsstay=lsstay+lsstay
  134 continue
      if(jsstay.le.irs) then
      if(jsstay.lt.irs) then
      if(isl(ndx(jsstay),lsbox).lt.isl(ndx(jsstay+1),lsbox).or.
     + (isl(ndx(jsstay),lsbox).eq.isl(ndx(jsstay+1),lsbox).and.
     + (isl(ndx(jsstay),lssgm).lt.isl(ndx(jsstay+1),lssgm).or.
     + (isl(ndx(jsstay),lssgm).eq.isl(ndx(jsstay+1),lssgm).and.
     + (isl(ndx(jsstay),lsgrp).lt.isl(ndx(jsstay+1),lsgrp).or.
     + (isl(ndx(jsstay),lsgrp).eq.isl(ndx(jsstay+1),lsgrp).and.
     + isl(ndx(jsstay),lsgan).le.isl(ndx(jsstay+1),lsgan)))))))
     + jsstay=jsstay+1
      endif
      if(isl(itemps,lsbox).lt.isl(ndx(jsstay),lsbox).or.
     + (isl(itemps,lsbox).eq.isl(ndx(jsstay),lsbox).and.
     + (isl(itemps,lssgm).lt.isl(ndx(jsstay),lssgm).or.
     + (isl(itemps,lssgm).eq.isl(ndx(jsstay),lssgm).and.
     + (isl(itemps,lsgrp).lt.isl(ndx(jsstay),lsgrp).or.
     + (isl(itemps,lsgrp).eq.isl(ndx(jsstay),lsgrp).and.
     + isl(itemps,lsgan).le.isl(ndx(jsstay),lsgan))))))) then
      ndx(isstay)=ndx(jsstay)
      isstay=jsstay
      jsstay=jsstay+jsstay
      else
      jsstay=irs+1
      endif
      goto 134
      endif
      ndx(isstay)=itemps
      goto 132
  133 continue
      endif
c
      do 135 k=1,3
      do 136 i=1,nsstay
      rtmp(i)=xs(i,k)
  136 continue
      do 137 i=1,nsstay
      xs(i,k)=rtmp(ndx(i))
  137 continue
      do 138 i=1,nsstay
      rtmp(i)=vs(i,k)
  138 continue
      do 139 i=1,nsstay
      vs(i,k)=rtmp(ndx(i))
  139 continue
      if(iguide.gt.0) then
      do 1138 i=1,nsstay
      rtmp(i)=gs(i,k)
 1138 continue
      do 1139 i=1,nsstay
      gs(i,k)=rtmp(ndx(i))
 1139 continue
      endif
  135 continue
      do 149 k=1,mis2
      do 150 i=1,nsstay
      itmp(i)=isl(i,k)
  150 continue
      do 151 i=1,nsstay
      isl(i,k)=itmp(ndx(i))
  151 continue
  149 continue
c
      endif
c
      do 200 i=1,ipl(1,1)
      ipl(30+i,2)=0
      ipl(30+i,3)=0
      ipl(30+i,4)=0
      ipl(30+i,5)=0
  200 continue
c
      do 201 i=1,ipl(1,1)
      nrbox=ipl(30+i,1)
      if(nwstay.gt.0) then
      do 202 iwm=1,nwstay
      if(iwl(iwm,lwbox).eq.nrbox) then
      if(ipl(30+i,2).eq.0) ipl(30+i,2)=iwm
      ipl(30+i,3)=iwm
      endif
  202 continue
      endif
      if(nsstay.gt.0) then
      do 203 isa=1,nsstay
      if(isl(isa,lsbox).eq.nrbox) then
      if(ipl(30+i,4).eq.0) ipl(30+i,4)=isa
      ipl(30+i,5)=isa
      endif
  203 continue
      endif
  201 continue
c
      nwmloc=nwstay
      ipl(1,2)=nwmloc
      nsaloc=nsstay
      ipl(2,2)=nsaloc
c
      call ga_igop(msp_23,nfold,1,'+')
      lpbc9=nfold.gt.0
c
      return
      end
      subroutine sp_nbbl(n)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer n
c
      n=nbbl
      if(lqmd) n=0
c
      return
      end
      subroutine sp_prefetch_all(n,iwl,xw,isl,xs)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer n
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(2),ps(2)
      real*8 pwp(2),psp(2)
c
      n=nbbl
      if(lqmd) n=0
c
      call sp_lbbl_prefetch(int_mb(i_bb),int_mb(i_ipl),int_mb(i_jpl),
     + iwl,int_mb(i_packw),xw,pw,pwp,isl,int_mb(i_pack),xs,ps,psp,
     + .false.)
c
      icbbl=nbbl
c
      return
      end
      subroutine sp_prefetch(n,iwl,xw,isl,xs)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer n
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(2),ps(2)
      real*8 pwp(2),psp(2)
      logical lfetch,lnext
      integer ibbl,nfetched
c
      n=nbbl
      if(lqmd) n=0
c
      nfetched=0
      if(ibget.lt.0) nbget=nbbl+1
c
      do 1 ibbl=1,nbbl
      call sp_ibbl_prefetch(ibbl,int_mb(i_bb),int_mb(i_ipl),
     + int_mb(i_jpl),iwl,int_mb(i_packw),xw,pw,pwp,isl,int_mb(i_pack),
     + xs,ps,psp,.false.,lfetch,lnext)
      icbbl=ibbl
      if(lfetch) nfetched=nfetched+1
      if(nfetched.ge.nbget.and..not.lnext) return
 1    continue
c
      return
      end
      subroutine sp_prefetch_next(iwl,xw,isl,xs)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(2),ps(2)
      real*8 pwp(2),psp(2)
      logical lfetch,lnext
      integer ibbl,nfetched
c
      if(icbbl.ge.nbbl) return
c
      nfetched=0
      do 1 ibbl=icbbl+1,nbbl
      call sp_ibbl_prefetch(ibbl,int_mb(i_bb),int_mb(i_ipl),
     + int_mb(i_jpl),iwl,int_mb(i_packw),xw,pw,pwp,isl,int_mb(i_pack),
     + xs,ps,psp,.false.,lfetch,lnext)
      icbbl=ibbl
      if(lfetch) nfetched=nfetched+1
      if(nfetched.gt.0.and..not.lnext) return
 1    continue
c
      return
      end

      subroutine sp_prefetch_p(n,iwl,xw,pw,pwp,isl,xs,ps,psp)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer n
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
c
      n=nbbl
      if(lqmd) n=0
c
      call sp_lbbl_prefetch(int_mb(i_bb),int_mb(i_ipl),int_mb(i_jpl),
     + iwl,int_mb(i_packw),xw,pw,pwp,isl,int_mb(i_pack),xs,ps,psp,
     + .true.)
c
      return
      end
      subroutine sp_lbbl_prefetch(lbbl,ipl,jpl,
     + iwl,iwlp,xw,pw,pwp,isl,islp,xs,ps,psp,lpp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer lbbl(mbbl,mbb2),ipl(mbox,mip2),jpl(mbox,mip2)
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      logical lpp
c
      integer ibbl,i,j,indexw,indexs,indx,jndx,nndexw,nndexs
      integer jproc,jcell
      integer jccell,iccell
      integer ih,il,jh,jl
      integer nsnon,nwnon
      integer jwfr,jwto,jsfr,jsto
      integer handle_is,handle_iw,handle_s,handle_w
      integer handle_ps,handle_pw,handle_psp,handle_pwp
      character*80 string
c
      jccell=-1
      indexw=nwmloc+1
      indexs=nsaloc+1
      nndexw=indexw
      nndexs=indexs
      do 1 ibbl=1,nbbl
c
      handle_iw=0
      handle_is=0
      handle_w=0
      handle_s=0
      handle_pw=0
      handle_ps=0
      handle_pwp=0
      handle_psp=0
c
      jproc=lbbl(ibbl,1)
      jcell=lbbl(ibbl,2)
c
      if(jproc.eq.me) then
c
      jccell=jcell
c
      else
c
      if(jcell.ne.jccell) then
c
      indexw=nndexw
      indexs=nndexs
c
      jwfr=lbbl(ibbl,11)
      jwto=lbbl(ibbl,12)
      jsfr=lbbl(ibbl,13)
      jsto=lbbl(ibbl,14)
c
      if(jwfr.gt.0) then
      nwnon=jwto-jwfr+1
      if(indexw+nwnon.gt.mwm)
     + call md_abort('Dimension mwm too small',indexw+nwnon)
      call ga_distribution(ga_iw,jproc,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_nbget(ga_iw,il+jwfr-1,il+jwto-1,jl,jh,
     + iwl(indexw,1),mwm,handle_iw)
      else
      call ga_nbget(ga_iw,il+jwfr-1,il+jwto-1,jl,jl+npackw-1,
     + iwlp(indexw,1),mwm,handle_iw)
      endif
      call ga_distribution(ga_w,jproc,il,ih,jl,jh)
      call ga_nbget(ga_w,il+jwfr-1,il+jwto-1,jl,jl+3*mwa-1,
     + xw(indexw,1,1),mwm,handle_w)
      if(lpp) then
      call ga_nbget(ga_w,il+jwfr-1,il+jwto-1,jl+12*mwa+3,jl+18*mwa+2,
     + pw(indexw,1,1,1),mwm,handle_pw)
      if(lfree) call ga_nbget(ga_w,il+jwfr-1,il+jwto-1,
     + jl+18*mwa+3,jl+30*mwa+2,pwp(indexw,1,1,1,1),mwm,handle_pwp)
      endif
      nndexw=indexw+nwnon
      endif
c
      if(jsfr.gt.0) then
      nsnon=jsto-jsfr+1
      if(indexs+nsnon.gt.msa)
     + call md_abort('Dimension msa too small (2)',indexs+nsnon)
      call ga_distribution(ga_is,jproc,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_nbget(ga_is,il+jsfr-1,il+jsto-1,jl,jh,
     + isl(indexs,1),msa,handle_is)
      else
      call ga_nbget(ga_is,il+jsfr-1,il+jsto-1,jl,jl+npack-1,
     + islp(indexs,1),msa,handle_is)
      endif
      call ga_distribution(ga_s,jproc,il,ih,jl,jh)
      call ga_nbget(ga_s,il+jsfr-1,il+jsto-1,jl,jl+2,
     + xs(indexs,1),msa,handle_s)
      if(lpp) then
      call ga_nbget(ga_s,il+jsfr-1,il+jsto-1,jl+12,jl+14,
     + ps(indexs,1,1),msa,handle_ps)
      if(lfree) call ga_nbget(ga_s,il+jsfr-1,il+jsto-1,jl+15,jl+20,
     + psp(indexs,1,1,1),msa,handle_psp)
      endif
      nndexs=indexs+nsnon
      endif
c
      endif
c
      jccell=jcell
c
      endif
c
      lbbl(ibbl, 5)=indexw
      lbbl(ibbl, 6)=indexs
      lbbl(ibbl,15)=handle_iw
      lbbl(ibbl,16)=handle_w
      lbbl(ibbl,17)=handle_is
      lbbl(ibbl,18)=handle_s
      lbbl(ibbl,19)=handle_pw
      lbbl(ibbl,20)=handle_ps
      lbbl(ibbl,21)=handle_pwp
      lbbl(ibbl,22)=handle_psp
c
    1 continue
c
      if(iand(idebug,16).eq.16) then
      write(lfndbg,2000)
 2000 format(' Cell-cell list lbbl',/)
      write(lfndbg,2001) ((lbbl(i,j),j=1,18),i=1,nbbl)
 2001 format(18i6)
      endif
c
      return
      end
      subroutine sp_ibbl_prefetch(ibbl,lbbl,ipl,jpl,
     + iwl,iwlp,xw,pw,pwp,isl,islp,xs,ps,psp,lpp,lfetch,lnext)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer ibbl
      integer lbbl(mbbl,mbb2),ipl(mbox,mip2),jpl(mbox,mip2)
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      logical lpp,lfetch,lnext
c
      integer i,j,indexw,indexs,indx,jndx,nndexw,nndexs
      integer jproc,jcell
      integer jccell,iccell
      integer ih,il,jh,jl
      integer nsnon,nwnon
      integer jwfr,jwto,jsfr,jsto
      integer handle_is,handle_iw,handle_s,handle_w
      integer handle_ps,handle_pw,handle_psp,handle_pwp
      character*80 string
c
      lfetch=.false.
c
      if(ibbl.eq.1) then
      jccell=-1
      else
      jccell=lbbl(ibbl-1,2)
      endif
      indexw=lbbl(ibbl,5)
      indexs=lbbl(ibbl,6)
c
      handle_iw=0
      handle_is=0
      handle_w=0
      handle_s=0
      handle_pw=0
      handle_ps=0
      handle_pwp=0
      handle_psp=0
c
      jproc=lbbl(ibbl,1)
      jcell=lbbl(ibbl,2)
c
      if(jproc.eq.me) then
c
      jccell=jcell
c
      else
c
      if(jcell.ne.jccell) then
c
      jwfr=lbbl(ibbl,11)
      jwto=lbbl(ibbl,12)
      jsfr=lbbl(ibbl,13)
      jsto=lbbl(ibbl,14)
c
      if(jwfr.gt.0) then
      nwnon=jwto-jwfr+1
      if(indexw+nwnon.gt.mwm)
     + call md_abort('Dimension mwm too small',indexw+nwnon)
      call ga_distribution(ga_iw,jproc,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_nbget(ga_iw,il+jwfr-1,il+jwto-1,jl,jh,
     + iwl(indexw,1),mwm,handle_iw)
      else
      call ga_nbget(ga_iw,il+jwfr-1,il+jwto-1,jl,jl+npackw-1,
     + iwlp(indexw,1),mwm,handle_iw)
      endif
      call ga_distribution(ga_w,jproc,il,ih,jl,jh)
      call ga_nbget(ga_w,il+jwfr-1,il+jwto-1,jl,jl+3*mwa-1,
     + xw(indexw,1,1),mwm,handle_w)
      if(lpp) then
      call ga_nbget(ga_w,il+jwfr-1,il+jwto-1,jl+12*mwa+3,jl+18*mwa+2,
     + pw(indexw,1,1,1),mwm,handle_pw)
      if(lfree) call ga_nbget(ga_w,il+jwfr-1,il+jwto-1,
     + jl+18*mwa+3,jl+30*mwa+2,pwp(indexw,1,1,1,1),mwm,handle_pwp)
      endif
      lfetch=.true.
      endif
c
      if(jsfr.gt.0) then
      nsnon=jsto-jsfr+1
      if(indexs+nsnon.gt.msa)
     + call md_abort('Dimension msa too small (2)',indexs+nsnon)
      call ga_distribution(ga_is,jproc,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_nbget(ga_is,il+jsfr-1,il+jsto-1,jl,jh,
     + isl(indexs,1),msa,handle_is)
      else
      call ga_nbget(ga_is,il+jsfr-1,il+jsto-1,jl,jl+npack-1,
     + islp(indexs,1),msa,handle_is)
      endif
      call ga_distribution(ga_s,jproc,il,ih,jl,jh)
      call ga_nbget(ga_s,il+jsfr-1,il+jsto-1,jl,jl+2,
     + xs(indexs,1),msa,handle_s)
      if(lpp) then
      call ga_nbget(ga_s,il+jsfr-1,il+jsto-1,jl+12,jl+14,
     + ps(indexs,1,1),msa,handle_ps)
      if(lfree) call ga_nbget(ga_s,il+jsfr-1,il+jsto-1,jl+15,jl+20,
     + psp(indexs,1,1,1),msa,handle_psp)
      endif
      lfetch=.true.
      endif
c
      endif
c
      jccell=jcell
c
      endif
c
      lbbl(ibbl,15)=handle_iw
      lbbl(ibbl,16)=handle_w
      lbbl(ibbl,17)=handle_is
      lbbl(ibbl,18)=handle_s
      lbbl(ibbl,19)=handle_pw
      lbbl(ibbl,20)=handle_ps
      lbbl(ibbl,21)=handle_pwp
      lbbl(ibbl,22)=handle_psp
c
      lnext=.false.
      if(ibbl.lt.nbbl) then
      lnext=lbbl(ibbl+1,2).eq.lbbl(ibbl,2)
      endif
c
      return
      end
      subroutine sp_nbwait(ibbl,lnew,lhandl,lself,lpbcs,
     + iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto,iwl,isl)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      integer ibbl,iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto,lhandl
      integer isl(msa,mis2),iwl(mwm,miw2)
      logical lself,lpbcs,lnew
c
      lpbcs=lpbc9
      call sp_nbwait2(ibbl,lnew,int_mb(i_bb),lhandl,lself,
     + iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto,
     + iwl,int_mb(i_packw),isl,int_mb(i_pack))
c
      return
      end
      subroutine sp_nbwait2(ibbl,lnew,lbbl,lhandl,lself,
     + iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto,iwl,iwlp,isl,islp)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      integer ibbl,iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto,lhandl
      integer lbbl(mbbl,mbb2)
      integer isl(msa,mis2),islp(msa,npack)
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      logical lself,lnew
      integer indexs,indexw
      integer handle_iw,handle_w,handle_is,handle_s
      integer handle_pw,handle_ps,handle_pwp,handle_psp
      integer i
c
      lnew=.false.
      indexw=lbbl(ibbl,5)
      indexs=lbbl(ibbl,6)
      iwfr=lbbl(ibbl, 7)
      iwto=lbbl(ibbl, 8)
      isfr=lbbl(ibbl, 9)
      isto=lbbl(ibbl,10)
      jwfr=lbbl(ibbl,11)
      jwto=lbbl(ibbl,12)
      jsfr=lbbl(ibbl,13)
      jsto=lbbl(ibbl,14)
      if(lbbl(ibbl,1).ne.me) then
      if(lbbl(ibbl,11).gt.0) then
      jwfr=lbbl(ibbl,5)
      jwto=jwfr+lbbl(ibbl,12)-lbbl(ibbl,11)
      endif
      if(lbbl(ibbl,13).gt.0) then
      jsfr=lbbl(ibbl,6)
      jsto=jsfr+lbbl(ibbl,14)-lbbl(ibbl,13)
      endif
      endif
      lself=lbbl(ibbl,2).eq.lbbl(ibbl,3)
      lhandl=lbbl(ibbl,4)
c
      handle_iw=lbbl(ibbl,15)
      handle_w=lbbl(ibbl,16)
      handle_is=lbbl(ibbl,17)
      handle_s=lbbl(ibbl,18)
      handle_pw=lbbl(ibbl,19)
      handle_ps=lbbl(ibbl,20)
      handle_pwp=lbbl(ibbl,21)
      handle_psp=lbbl(ibbl,22)
c
      if(handle_iw.ne.0.or.handle_w.ne.0) then
      lnew=.true.
      call ga_nbwait(handle_iw)
      call ga_nbwait(handle_w)
      if(npackw.ne.0) then
      call sp_unpackw(jwto-jwfr+1,iwl(indexw,1),iwlp(indexw,1))
      endif
      endif
      if(handle_is.ne.0.or.handle_s.ne.0) then
      lnew=.true.
      call ga_nbwait(handle_is)
      call ga_nbwait(handle_s)
      if(npackw.ne.0) then
      call sp_unpack(jsto-jsfr+1,isl(indexs,1),islp(indexs,1))
      endif
      endif
      if(handle_pw.ne.0.or.handle_ps.ne.0) then
      lnew=.true.
      call ga_nbwait(handle_pw)
      call ga_nbwait(handle_ps)
      endif
      if(handle_pwp.ne.0.or.handle_psp.ne.0) then
      lnew=.true.
      call ga_nbwait(handle_pwp)
      call ga_nbwait(handle_psp)
      endif
c
      return
      end
      subroutine sp_nbwaitf()
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      call sp_nbwait3(int_mb(i_bb))
c
      return
      end
      subroutine sp_nbwait3(lbbl)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
#include "global.fh"
c
      integer ibbl
      integer lbbl(mbbl,mbb2)
      integer handle_iw,handle_fw,handle_is,handle_fs
      integer handle_fwl,handle_fsl
c
      do 1 ibbl=1,nbbl
c
      handle_iw=lbbl(ibbl,15)
      handle_fw=lbbl(ibbl,16)
      handle_is=lbbl(ibbl,17)
      handle_fs=lbbl(ibbl,18)
      handle_fwl=lbbl(ibbl,19)
      handle_fsl=lbbl(ibbl,20)
c
      if(handle_iw.ne.0) then
      call ga_nbwait(handle_iw)
      endif
      if(handle_fw.ne.0) then
      call ga_nbwait(handle_fw)
      endif
      if(handle_is.ne.0) then
      call ga_nbwait(handle_is)
      endif
      if(handle_fs.ne.0) then
      call ga_nbwait(handle_fs)
      endif
      if(handle_fwl.ne.0) then
      call ga_nbwait(handle_fwl)
      endif
      if(handle_fsl.ne.0) then
      call ga_nbwait(handle_fsl)
      endif
c
    1 continue
c
      return
      end
      subroutine sp_lbbl_indices()
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      call sp_lbbl_ind(int_mb(i_bb),int_mb(i_ipl),int_mb(i_jpl))
c
      return
      end
      subroutine sp_lbbl_ind(lbbl,ipl,jpl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer lbbl(mbbl,mbb2),ipl(mbox,mip2),jpl(mbox,mip2)
c
      integer ibbl,jproc,jcell,icell,jcproc,jccell,iccell
      integer i,j,indx,jndx,il,ih,jl,jh,indexw,indexs,nndexw,nndexs
      character*80 string
c
      jcproc=-1
      jccell=-1
      iccell=-1
      indexw=nwmloc+1
      indexs=nsaloc+1
      nndexw=indexw
      nndexs=indexs
c
c      if(iand(idebug,16).eq.16) then
c      write(lfndbg,3000) ((lbbl(ibbl,i),i=1,3),ibbl=1,nbbl)
c 3000 format(3i5)
c      endif
      do 1 ibbl=1,nbbl
c
      jproc=lbbl(ibbl,1)
      jcell=lbbl(ibbl,2)
      icell=lbbl(ibbl,3)
      lbbl(ibbl, 5)=0
      lbbl(ibbl, 6)=0
      if(iand(idebug,16).eq.16) then
      write(lfndbg,222) ibbl,nbbl,jproc,jcell,icell,jccell,iccell
  222 format(7i5)
      endif
      do 234 j=1,3
  234 continue
c
c     get indices for icell on the local node
c
      if(iccell.ne.icell) then
      indx=0
      do 2 i=1,ipl(1,1)
      if(ipl(30+i,1).eq.icell) indx=30+i
    2 continue
      if(indx.eq.0) then
      do 232 j=1,3
  232 continue
      write(*,1000) me,(ipl(30+i,1),i=1,ipl(1,1))
 1000 format(/,'Cells on proc',i5,' :',t20,20i5,/,(t20,20i5))
      write(string,1001) icell,me
 1001 format('SP0001: Could not find icell',i5,' on proc',i5)
      call md_abort(string,0)
      endif
      iccell=icell
      endif
      lbbl(ibbl, 7)=ipl(indx,2)
      lbbl(ibbl, 8)=ipl(indx,3)
      lbbl(ibbl, 9)=ipl(indx,4)
      lbbl(ibbl,10)=ipl(indx,5)
c
c     get indices for jcell if on the local node
c
      if(jproc.eq.me) then
c
      if(jccell.ne.jcell) then
      jndx=0
      do 3 i=1,ipl(1,1)
      if(ipl(30+i,1).eq.jcell) jndx=30+i
    3 continue
      if(jndx.eq.0) then
      write(*,1000) me,(ipl(30+i,1),i=1,ipl(1,1))
      write(string,1002) jcell,me
 1002 format('SP0001: Could not find jcell',i5,' on proc',i5)
      call md_abort(string,0)
      endif
      jccell=jcell
      endif
      lbbl(ibbl,11)=ipl(jndx,2)
      lbbl(ibbl,12)=ipl(jndx,3)
      lbbl(ibbl,13)=ipl(jndx,4)
      lbbl(ibbl,14)=ipl(jndx,5)
c
c     get indices for jcell if on the remote node
c
      else
c
      if(jproc.ne.jcproc) then
      call ga_distribution(ga_ip,jproc,il,ih,jl,jh)
      call ga_get(ga_ip,il,ih,jl,jh,jpl,mbox)
      jcproc=jproc
      endif
c
      if(jcell.ne.jccell) then
      jndx=0
      do 4 i=1,jpl(1,1)
      if(jpl(30+i,1).eq.jcell) jndx=30+i
    4 continue
      if(jndx.eq.0) then
      if(iand(idebug,16).eq.16) then
      write(lfndbg,1003) jcell,jproc
 1003 format('Could not find cell',i5,' on proc',i5,' in sp_lbbl')
      write(lfndbg,1004) jproc,(jpl(30+i,1),i=1,jpl(1,1))
 1004 format('Cell list obtained from proc',i5,' is',/,(20i5))
      call util_flush(lfndbg)
      endif
c
      write(*,1005) jproc,(jpl(30+i,1),i=1,jpl(1,1))
 1005 format(/,'Cells on proc',i5,':',t20,20i5,/,(t20,20i5))
      write(string,1006) jcell,jproc
 1006 format('SP0002: Could not find remote jcell',i5,' on proc',i5)
      call md_abort(string,me)
      endif
      jccell=jcell
c
      if(nbget.ne.0) then
      indexw=nndexw
      indexs=nndexs
      if(jpl(jndx,2).gt.0) nndexw=indexw+jpl(jndx,3)-jpl(jndx,2)+1
      if(jpl(jndx,4).gt.0) nndexs=indexs+jpl(jndx,5)-jpl(jndx,4)+1
      endif
c
      endif
c
      lbbl(ibbl, 5)=indexw
      lbbl(ibbl, 6)=indexs
      lbbl(ibbl,11)=jpl(jndx,2)
      lbbl(ibbl,12)=jpl(jndx,3)
      lbbl(ibbl,13)=jpl(jndx,4)
      lbbl(ibbl,14)=jpl(jndx,5)
c
      endif
c
    1 continue
c
      if(nndexw.gt.mwm) then
      write(string,1007) mwm,nndexw
 1007 format('Increase dimension mwm from ',i7,' to ',i7)
      call md_abort(string,me)
      endif
      if(nndexs.gt.msa) then
      write(string,1008) msa,nndexs
 1008 format('Increase dimension msa from ',i7,' to ',i7)
      call md_abort(string,me)
      endif
c
      return
      end
      subroutine sp_gethdl(ibbl,lhandl,lself,iwfr,iwto,isfr,isto)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer ibbl,lhandl
      integer iwfr,iwto,isfr,isto
      logical lself
c
      call sp_gthdl(ibbl,lhandl,lself,iwfr,iwto,isfr,isto,
     + int_mb(i_bb),int_mb(i_ipl))
c
      return
      end
      subroutine sp_gthdl(ibbl,lhandl,lself,iwfr,iwto,isfr,isto,
     + lbbl,ipl)
c
      implicit none
c
#include "sp_common.fh"
c
      integer ibbl,lhandl
      integer iwfr,iwto,isfr,isto
      integer lbbl(mbbl,mbb2)
      integer ipl(mbox,mip2)
      logical lself
c
      integer ndx,i,ibox
      character*255 string
c
      if(ibbl.le.0.or.ibbl.gt.nbbl)
     + call md_abort('Index to lbbl out of range',ibbl)
c
      ibox=lbbl(ibbl,3)
      lhandl=lbbl(ibbl,4)
      lself=ibox.eq.lbbl(ibbl,2)
c
      ndx=0
      do 1 i=1,ipl(1,1)
      if(ipl(30+i,1).eq.ibox) ndx=30+i
    1 continue
c
      if(ndx.eq.0) then
      write(*,1000) me,(ipl(30+i,1),i=1,ipl(1,1))
 1000 format(/,'Boxes on node',i5,':',t20,20i5,/,(t20,20i5))
      write(string,1001) ibox,me
 1001 format('SP0001: Could not find box',i5,' on node',i5)
      call md_abort(string,0)
      endif
c
      iwfr=ipl(ndx,2)
      iwto=ipl(ndx,3)
      isfr=ipl(ndx,4)
      isto=ipl(ndx,5)
c
      return
      end
      subroutine sp_getxpbl(ibbl,lhandl,
     + iwl,xw,pw,pwp,iwfr,iwto,jwfr,jwto,
     + isl,xs,ps,psp,isfr,isto,jsfr,jsto,lself,lpbcs)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer ibbl,lhandl
      integer iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      logical lself,lpbcs
c
      call sp_gtxpbl(ibbl,lhandl,
     + iwl,int_mb(i_packw),xw,pw,pwp,iwfr,iwto,jwfr,jwto,
     + isl,int_mb(i_pack),xs,ps,psp,isfr,isto,jsfr,jsto,
     + int_mb(i_bb),int_mb(i_ipl),int_mb(i_jpl),lself,.true.)
c
      lpbcs=lpbc9
c
      return
      end
      logical function sp_local(ibbl)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer ibbl
      logical local
c
      call sp_gtlocal(ibbl,local,int_mb(i_bb))
c
      sp_local=local
c
      return
      end
      subroutine sp_gtlocal(ibbl,local,lbbl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer ibbl
      logical local
      integer lbbl(mbbl,mbb2)
c
      local=lbbl(ibbl,1).eq.me
c
      return
      end
      subroutine sp_getxbl(ibbl,lhandl,
     + iwl,xw,iwfr,iwto,jwfr,jwto,isl,xs,isfr,isto,jsfr,jsto,
     + lself,lpbcs)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer ibbl,lhandl
      integer iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      logical lself,lpbcs
      real*8 pw(2),pwp(2),ps(2),psp(2)
c
      call sp_gtxpbl(ibbl,lhandl,
     + iwl,int_mb(i_packw),xw,pw,pwp,iwfr,iwto,jwfr,jwto,
     + isl,int_mb(i_pack),xs,ps,psp,isfr,isto,jsfr,jsto,
     + int_mb(i_bb),int_mb(i_ipl),int_mb(i_jpl),lself,.false.)
c
      lpbcs=lpbc9
c
      return
      end
      subroutine sp_getda(jnode,jsfr,jsto,isl,isga,isq3,xs,ndxda)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer jnode,jsfr,jsto,ndxda
      integer isga(msa),isq3(msa),isl(msa,mis2)
      real*8 xs(msa,3)
c
      integer il,ih,jl,jh
      integer l_islt,i_islt
c
      if(.not.ma_push_get(mt_int,msa*mis2,'islt',l_islt,i_islt))
     + call md_abort('Failed to allocate memory for islt',0)
      call sp_gtda(jnode,jsfr,jsto,int_mb(i_islt),int_mb(i_pack),
     + isga,isq3,xs,ndxda)
      if(.not.ma_pop_stack(l_islt))
     + call md_abort('Failed to deallocate memory for islt',0)
c
      return
      end
      subroutine sp_gtda(jnode,jsfr,jsto,isl,islp,isga,isq3,xs,ndxda)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer jnode,jsfr,jsto,ndxda
      integer isl(msa,mis2),islp(msa,npack)
      integer isga(msa),isq3(msa)
      real*8 xs(msa,3)
c
      integer i,il,ih,jl,jh
c
      if(npack.eq.0) then
      call ga_distribution(ga_is,jnode,il,ih,jl,jh)
      call ga_get(ga_is,il+jsfr-1,il+jsto-1,jl,jl,
     + isga(ndxda+1),msa)
      call ga_get(ga_is,il+jsfr-1,il+jsto-1,jl+lsct3-1,jl+lsct3-1,
     + isq3(ndxda+1),msa)
      else
      call ga_distribution(ga_is,jnode,il,ih,jl,jh)
      call ga_get(ga_is,il+jsfr-1,il+jsto-1,jl,jl+npack-1,
     + islp(nsaloc+1,1),msa)
      call sp_unpack(jsto-jsfr+1,isl(nsaloc+1,1),islp(nsaloc+1,1))
      do 1 i=1,jsto-jsfr
      isga(ndxda+i)=isl(nsaloc+i,lsgan)
      isq3(ndxda+i)=isl(nsaloc+i,lsct3)
    1 continue
      endif
      call ga_distribution(ga_s,jnode,il,ih,jl,jh)
      call ga_get(ga_s,il+jsfr-1,il+jsto-1,jl,jl+2,
     + xs(ndxda+1,1),msa)
c
      return
      end
      subroutine sp_gtxpbl(ibbl,lhandl,
     + iwl,iwlp,xw,pw,pwp,iwfr,iwto,jwfr,jwto,
     + isl,islp,xs,ps,psp,isfr,isto,jsfr,jsto,
     + lbbl,ipl,jpl,lself,lpp)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer ibbl,lhandl,iwfr,iwto,jwfr,jwto,isfr,isto,jsfr,jsto
      integer iwl(mwm,miw2),iwlp(mwm,npackw)
      integer isl(msa,mis2),islp(msa,npack)
      real*8 xw(mwm,3,mwa),xs(msa,3)
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      integer lbbl(mbbl,mbb2)
      integer ipl(mbox,mip2),jpl(mbox,mip2)
      logical lself,lpp
c
      integer i,ibox,jbox,jnode,il,ih,jl,jh,ndx,nwnon,nsnon
      character*80 string
c
      if(ibbl.le.0.or.ibbl.gt.nbbl)
     + call md_abort('Index to lbbl out of range',ibbl)
c
      jnode=lbbl(ibbl,1)
      jbox=lbbl(ibbl,2)
      ibox=lbbl(ibbl,3)
      lhandl=lbbl(ibbl,4)
c
      lself=ibox.eq.jbox
c
      if(ibbl.eq.1) then
      jcnode=-1
      jcbox=-1
      icbox=-1
      endif
c
      if(ibox.ne.icbox) then
      ndx=0
      do 1 i=1,ipl(1,1)
      if(ipl(30+i,1).eq.ibox) ndx=30+i
    1 continue
c
      if(ndx.eq.0) then
      write(*,1000) me,(ipl(30+i,1),i=1,ipl(1,1))
 1000 format(/,'Boxes on node',i5,':',t20,20i5,/,(t20,20i5))
      write(string,1001) ibox,me
 1001 format('SP0001: Could not find local ibox',i5,' on node',i5)
      call md_abort(string,me)
      endif
c
      icbox=ibox
      iwfr=ipl(ndx,2)
      iwto=ipl(ndx,3)
      isfr=ipl(ndx,4)
      isto=ipl(ndx,5)
      endif
c
      if(jnode.eq.me) then
c
      if(jbox.ne.jcbox) then
      ndx=0
      do 2 i=1,ipl(1,1)
      if(ipl(30+i,1).eq.jbox) ndx=30+i
    2 continue
c
      if(ndx.eq.0) then
      write(*,1000) me,(ipl(30+i,1),i=1,ipl(1,1))
      write(string,1002) jbox,me
 1002 format('SP0001: Could not find local jbox',i5,' on node',i5)
      call md_abort(string,me)
      endif
c
      jcbox=jbox
      jwfr=ipl(ndx,2)
      jwto=ipl(ndx,3)
      jsfr=ipl(ndx,4)
      jsto=ipl(ndx,5)
      endif
c
      else
c
      if(jnode.ne.jcnode) then
      call ga_distribution(ga_ip,jnode,il,ih,jl,jh)
      call ga_get(ga_ip,il,ih,jl,jh,jpl,mbox)
      jcnode=jnode
      endif
c
      if(jbox.ne.jcbox) then
      ndx=0
      do 3 i=1,jpl(1,1)
      if(jpl(30+i,1).eq.jbox) ndx=30+i
    3 continue
      if(ndx.eq.0) then
      if(iand(idebug,4).eq.4) then
      write(lfndbg,8000) jbox,jnode
 8000 format('Could not find box',i5,' on node',i5,' in sp_gtxpbl')
      write(lfndbg,8001) jnode,(jpl(30+i,1),i=1,jpl(1,1))
 8001 format('Box list obtained from node',i5,' is',/,(20i5))
      call util_flush(lfndbg)
      endif
c
      write(*,1003) jnode,(jpl(30+i,1),i=1,jpl(1,1))
 1003 format(/,'Boxes on node',i5,':',t20,20i5,/,(t20,20i5))
      write(string,1004) jbox,jnode
 1004 format('SP0002: Could not find remote jbox',i5,' on node',i5)
      call md_abort(string,me)
c
      endif
      jcbox=jbox
      jwfr=jpl(ndx,2)
      jwto=jpl(ndx,3)
      jsfr=jpl(ndx,4)
      jsto=jpl(ndx,5)
      if(jwfr.gt.0) then
      nwnon=jwto-jwfr+1
      if(nwmloc+nwnon.gt.mwm)
     + call md_abort('Dimension mwm too small',nwmloc+nwnon)
      call ga_distribution(ga_iw,jnode,il,ih,jl,jh)
      if(npackw.eq.0) then
      call ga_get(ga_iw,il+jwfr-1,il+jwto-1,jl,jh,iwl(nwmloc+1,1),mwm)
      else
      call ga_get(ga_iw,il+jwfr-1,il+jwto-1,jl,jl+npackw-1,
     + iwlp(nwmloc+1,1),mwm)
      call sp_unpackw(jwto-jwfr+1,iwl(nwmloc+1,1),iwlp(nwmloc+1,1))
      endif
      call ga_distribution(ga_w,jnode,il,ih,jl,jh)
      call ga_get(ga_w,il+jwfr-1,il+jwto-1,jl,jl+3*mwa-1,
     + xw(nwmloc+1,1,1),mwm)
      if(lpp) then
      call ga_get(ga_w,il+jwfr-1,il+jwto-1,jl+12*mwa+3,jl+18*mwa+2,
     + pw(nwmloc+1,1,1,1),mwm)
      if(lfree) call ga_get(ga_w,il+jwfr-1,il+jwto-1,
     + jl+18*mwa+3,jl+30*mwa+2,pwp(nwmloc+1,1,1,1,1),mwm)
      endif
      jwfr=nwmloc+1
      jwto=nwmloc+1+jpl(ndx,3)-jpl(ndx,2)
      endif
      if(jsfr.gt.0) then
      nsnon=jsto-jsfr+1
      if(nsaloc+nsnon.gt.msa)
     + call md_abort('Dimension msa too small (3)',nsaloc+nsnon)
      call ga_distribution(ga_is,jnode,il,ih,jl,jh)
      if(npack.eq.0) then
      call ga_get(ga_is,il+jsfr-1,il+jsto-1,jl,jh,isl(nsaloc+1,1),msa)
      else
      call ga_get(ga_is,il+jsfr-1,il+jsto-1,jl,jl+npack-1,
     + islp(nsaloc+1,1),msa)
      call sp_unpack(jsto-jsfr+1,isl(nsaloc+1,1),islp(nsaloc+1,1))
      endif
      call ga_distribution(ga_s,jnode,il,ih,jl,jh)
      call ga_get(ga_s,il+jsfr-1,il+jsto-1,jl,jl+2,
     + xs(nsaloc+1,1),msa)
      if(lpp) then
      call ga_get(ga_s,il+jsfr-1,il+jsto-1,jl+12,jl+14,
     + ps(nsaloc+1,1,1),msa)
      if(lfree) call ga_get(ga_s,il+jsfr-1,il+jsto-1,jl+15,jl+20,
     + psp(nsaloc+1,1,1,1),msa)
      endif
      jsfr=nsaloc+1
      jsto=nsaloc+1+jpl(ndx,5)-jpl(ndx,4)
      endif
      endif
c
      endif
c
      return
      end
      subroutine sp_accpbl(ibbl,lhandl,pw,pwp,ps,psp,lpair,iwz,isz)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer ibbl,lhandl
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      logical lpair
      integer iwz(mwm),isz(msa)
c
      call sp_acpbl(ibbl,lhandl,pw,pwp,ps,psp,int_mb(i_bb),
     + int_mb(i_jpl))
c
      return
      end
      subroutine sp_acpbl(ibbl,lhandl,pw,pwp,ps,psp,lbbl,jpl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer ibbl,lhandl
      real*8 pw(mwm,3,mwa,2),ps(msa,3,2)
      real*8 pwp(mwm,3,mwa,2,2),psp(msa,3,2,2)
      integer lbbl(mbbl,mbb2)
      integer jpl(mbox,mip2)
c
      integer i,j,k,l,m,ibox,jbox,jnode,il,ih,jl,jh,ndx,nwnon,nsnon
      integer jwfr,jwto,jsfr,jsto
c
      if(ibbl.le.0.or.ibbl.gt.nbbl)
     + call md_abort('Index to lbbl out of range',ibbl)
c
      jnode=lbbl(ibbl,1)
      jbox=lbbl(ibbl,2)
      ibox=lbbl(ibbl,3)
      lbbl(ibbl,4)=lhandl
c
      if(jnode.eq.me) return
      if(ibbl.lt.nbbl) then
      if(lbbl(ibbl+1,1).eq.jnode.and.lbbl(ibbl+1,2).eq.jbox) return
      endif
c
      ndx=0
      do 3 i=1,jpl(1,1)
      if(jpl(30+i,1).eq.jbox) ndx=30+i
    3 continue
      if(ndx.eq.0) then
      if(iand(idebug,4).eq.4) then
      write(lfndbg,8000) jbox,jnode
 8000 format('Could not find box',i5,' on node',i5,' in sp_acpbl')
      write(lfndbg,8001) jnode,(jpl(30+i,1),i=1,jpl(1,1))
 8001 format('Box list obtained from node',i5,' is',/,(20i5))
      call util_flush(lfndbg)
      endif
      call md_abort('Remote processor cell not found (0) ',0)
      endif
      jwfr=jpl(ndx,2)
      jwto=jpl(ndx,3)
      jsfr=jpl(ndx,4)
      jsto=jpl(ndx,5)
      if(jwfr.gt.0) then
      nwnon=jwto-jwfr+1
      if(nwmloc+nwnon.gt.mwm)
     + call md_abort('Dimension mwm too small',nwmloc+nwnon)
      call ga_distribution(ga_w,jnode,il,ih,jl,jh)
      call ga_acc(ga_w,il+jwfr-1,il+jwto-1,jl+12*mwa+3,jl+15*mwa+2,
     + pw(nwmloc+1,1,1,1),mwm,one)
      if(lfree) call ga_acc(ga_w,il+jwfr-1,il+jwto-1,jl+15*mwa+3,
     + jl+21*mwa+2,pwp(nwmloc+1,1,1,1,1),mwm,one)
c      if(llong) call ga_acc(ga_w,il+jwfr-1,il+jwto-1,jl+9*mwa+3,
c     + jl+12*mwa+2,fw(nwmloc+1,1,1,2),mwm,one)
c      if(lpair) then
c      call ga_distribution(ga_iwz,jnode,il,ih,jl,jh)
c      call ga_acc(ga_iwz,il+jwfr-1,il+jwto-1,jl,jl,iwz(nwmloc+1),mwm,1)
c      endif
      endif
      if(jsfr.gt.0) then
      nsnon=jsto-jsfr+1
      if(nsaloc+nsnon.gt.msa)
     + call md_abort('Dimension msa too small (4)',nsaloc+nsnon)
      call ga_distribution(ga_s,jnode,il,ih,jl,jh)
      call ga_acc(ga_s,il+jsfr-1,il+jsto-1,jl+12,jl+14,
     + ps(nsaloc+1,1,1),msa,one)
      if(lfree) call ga_acc(ga_s,il+jsfr-1,il+jsto-1,jl+15,jl+20,
     + psp(nsaloc+1,1,1,1),msa,one)
c      if(lpair) then
c      call ga_distribution(ga_isz,jnode,il,ih,jl,jh)
c      call ga_acc(ga_isz,il+jsfr-1,il+jsto-1,jl,jl,isz(nsaloc+1),msa,1)
c      endif
      endif
c
      m=1
      if(llong) m=2
c
      do 9 l=1,m
      do 4 k=1,mwa
      do 5 j=1,3
      do 6 i=nwmloc+1,mwm
      pw(i,j,k,l)=zero
    6 continue
    5 continue
    4 continue
c
      do 7 j=1,3
      do 8 i=nsaloc+1,msa
      ps(i,j,l)=zero
    8 continue
    7 continue
    9 continue
c
      return
      end
      subroutine sp_accfbl(ibbl,lhandl,fw,fs,lpair,iwz,isz)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer ibbl,lhandl
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      logical lpair
      integer iwz(mwm),isz(msa)
c
      call sp_acfbl(ibbl,lhandl,fw,fs,int_mb(i_bb),int_mb(i_jpl),
     + lpair,iwz,isz)
c
      return
      end
      subroutine sp_acfbl(ibbl,lhandl,fw,fs,lbbl,jpl,lpair,iwz,isz)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer ibbl,lhandl
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      integer lbbl(mbbl,mbb2)
      integer jpl(mbox,mip2)
      logical lpair
      integer iwz(mwm),isz(msa)
c
      integer i,j,k,l,m,ibox,jbox,jnode,il,ih,jl,jh,ndx,nwnon,nsnon
      integer jwfr,jwto,jsfr,jsto
c
      if(ibbl.le.0.or.ibbl.gt.nbbl)
     + call md_abort('Index to lbbl out of range',ibbl)
c
      jnode=lbbl(ibbl,1)
      jbox=lbbl(ibbl,2)
      ibox=lbbl(ibbl,3)
      lbbl(ibbl,4)=lhandl
c
      if(jnode.eq.me) return
      if(ibbl.lt.nbbl) then
      if(lbbl(ibbl+1,1).eq.jnode.and.lbbl(ibbl+1,2).eq.jbox) return
      endif
c
      ndx=0
      do 3 i=1,jpl(1,1)
      if(jpl(30+i,1).eq.jbox) ndx=30+i
    3 continue
      if(ndx.eq.0)
     + call md_abort('Remote processor cell not found (2) ',0)
      jwfr=jpl(ndx,2)
      jwto=jpl(ndx,3)
      jsfr=jpl(ndx,4)
      jsto=jpl(ndx,5)
      if(jwfr.gt.0) then
      nwnon=jwto-jwfr+1
      if(nwmloc+nwnon.gt.mwm)
     + call md_abort('Dimension mwm too small',nwmloc+nwnon)
      call ga_distribution(ga_w,jnode,il,ih,jl,jh)
      call ga_acc(ga_w,il+jwfr-1,il+jwto-1,jl+6*mwa+3,jl+9*mwa+2,
     + fw(nwmloc+1,1,1,1),mwm,one)
      if(llong) call ga_acc(ga_w,il+jwfr-1,il+jwto-1,jl+9*mwa+3,
     + jl+12*mwa+2,fw(nwmloc+1,1,1,2),mwm,one)
      if(lpair) then
      call ga_distribution(ga_iwz,jnode,il,ih,jl,jh)
      call ga_acc(ga_iwz,il+jwfr-1,il+jwto-1,jl,jl,iwz(nwmloc+1),mwm,1)
      endif
      endif
      if(jsfr.gt.0) then
      nsnon=jsto-jsfr+1
      if(nsaloc+nsnon.gt.msa)
     + call md_abort('Dimension msa too small (5)',nsaloc+nsnon)
      call ga_distribution(ga_s,jnode,il,ih,jl,jh)
      call ga_acc(ga_s,il+jsfr-1,il+jsto-1,jl+6,jl+8,
     + fs(nsaloc+1,1,1),msa,one)
      if(llong) call ga_acc(ga_s,il+jsfr-1,il+jsto-1,jl+9,jl+11,
     + fs(nsaloc+1,1,2),msa,one)
      if(lpair) then
      call ga_distribution(ga_isz,jnode,il,ih,jl,jh)
      call ga_acc(ga_isz,il+jsfr-1,il+jsto-1,jl,jl,isz(nsaloc+1),msa,1)
      endif
      endif
c
      m=1
      if(llong) m=2
c
      do 9 l=1,m
      do 4 k=1,mwa
      do 5 j=1,3
      do 6 i=nwmloc+1,mwm
      fw(i,j,k,l)=zero
    6 continue
    5 continue
    4 continue
c
      do 7 j=1,3
      do 8 i=nsaloc+1,msa
      fs(i,j,l)=zero
    8 continue
    7 continue
    9 continue
c
      do 10 i=nwmloc+1,mwm
      iwz(i)=0
   10 continue
      do 11 i=nsaloc+1,msa
      isz(i)=0
   11 continue
c
      return
      end
      subroutine sp_nbaccfbl(ibbl,lhandl,fw,fs,lpair,iwz,isz)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      integer ibbl,lhandl
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      logical lpair
      integer iwz(mwm),isz(msa)
c
      call sp_nbacfbl(ibbl,lhandl,fw,fs,int_mb(i_bb),int_mb(i_jpl),
     + lpair,iwz,isz)
c
      return
      end
      subroutine sp_nbacfbl(ibbl,lhandl,fw,fs,lbbl,jpl,lpair,iwz,isz)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
c
      integer ibbl,lhandl
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      integer lbbl(mbbl,mbb2)
      integer jpl(mbox,mip2)
      logical lpair
      integer iwz(mwm),isz(msa)
c
      integer i,j,k,l,m,ibox,jbox,jnode,il,ih,jl,jh,ndx,nwnon,nsnon
      integer jwfr,jwto,jsfr,jsto,indexw,indexs
      integer handle_iw,handle_fw,handle_is,handle_fs
      integer handle_fwl,handle_fsl
c
      handle_iw=0
      handle_is=0
      handle_fw=0
      handle_fs=0
      handle_fwl=0
      handle_fsl=0
c
      if(ibbl.le.0.or.ibbl.gt.nbbl)
     + call md_abort('Index to lbbl out of range',ibbl)
c
      jnode=lbbl(ibbl,1)
      jbox=lbbl(ibbl,2)
      ibox=lbbl(ibbl,3)
      lbbl(ibbl,4)=lhandl
c
      if(jnode.eq.me) return
      if(ibbl.lt.nbbl) then
      if(lbbl(ibbl+1,1).eq.jnode.and.lbbl(ibbl+1,2).eq.jbox) return
      endif
c
c      ndx=0
c      do 3 i=1,jpl(1,1)
c      if(jpl(30+i,1).eq.jbox) ndx=30+i
c    3 continue
c      if(ndx.eq.0)
c     + call md_abort('Remote processor cell not found (3) ',0)
c
      jwfr=lbbl(ibbl,11)
      jwto=lbbl(ibbl,12)
      jsfr=lbbl(ibbl,13)
      jsto=lbbl(ibbl,14)
c
c      if(lbbl(ibbl,1).ne.me) then
c      if(lbbl(ibbl,12).gt.0) then
c      jwfr=lbbl(ibbl,5)
c      jwto=jwfr+lbbl(ibbl,12)-lbbl(ibbl,11)
c      endif
c      if(lbbl(ibbl,14).gt.0) then
c      jsfr=lbbl(ibbl,6)
c      jsto=jsfr+lbbl(ibbl,14)-lbbl(ibbl,13)
c      endif
c      endif
c
      indexw=lbbl(ibbl,5)
      indexs=lbbl(ibbl,6)
c
      m=1
      if(llong) m=2
c
      if(jwfr.gt.0) then
      nwnon=jwto-jwfr+1
      if(indexw+nwnon.gt.mwm)
     + call md_abort('Dimension mwm too small',indexw+nwnon)
      call ga_distribution(ga_w,jnode,il,ih,jl,jh)
      call ga_nbacc(ga_w,il+jwfr-1,il+jwto-1,jl+6*mwa+3,jl+9*mwa+2,
     + fw(indexw,1,1,1),mwm,one,handle_fw)
      if(llong) call ga_nbacc(ga_w,il+jwfr-1,il+jwto-1,jl+9*mwa+3,
     + jl+12*mwa+2,fw(indexw,1,1,2),mwm,one,handle_fwl)
      if(lpair) then
      call ga_distribution(ga_iwz,jnode,il,ih,jl,jh)
      call ga_nbacc(ga_iwz,il+jwfr-1,il+jwto-1,jl,jl,
     + iwz(indexw),mwm,1,handle_iw)
      endif
      do 9 l=1,m
      do 4 k=1,mwa
      do 5 j=1,3
      do 6 i=indexw,indexw+nwnon-1
      fw(i,j,k,l)=zero
    6 continue
    5 continue
    4 continue
    9 continue
      do 10 i=indexw,indexw+nwnon-1
      iwz(i)=0
   10 continue
      endif
c
      if(jsfr.gt.0) then
      nsnon=jsto-jsfr+1
      if(indexs+nsnon.gt.msa)
     + call md_abort('Dimension msa too small (5)',indexs+nsnon)
      call ga_distribution(ga_s,jnode,il,ih,jl,jh)
      call ga_nbacc(ga_s,il+jsfr-1,il+jsto-1,jl+6,jl+8,
     + fs(indexs,1,1),msa,one,handle_fs)
      if(llong) call ga_nbacc(ga_s,il+jsfr-1,il+jsto-1,jl+9,jl+11,
     + fs(indexs,1,2),msa,one,handle_fsl)
      if(lpair) then
      call ga_distribution(ga_isz,jnode,il,ih,jl,jh)
      call ga_nbacc(ga_isz,il+jsfr-1,il+jsto-1,jl,jl,
     + isz(indexs),msa,1,handle_is)
      endif
      do 12 l=1,m
      do 7 j=1,3
      do 8 i=indexs,indexs+nsnon-1
      fs(i,j,l)=zero
    8 continue
    7 continue
   12 continue
      do 11 i=indexs,indexs+nsnon-1
      isz(i)=0
   11 continue
      endif
c
      lbbl(ibbl,15)=handle_iw
      lbbl(ibbl,16)=handle_fw
      lbbl(ibbl,17)=handle_is
      lbbl(ibbl,18)=handle_fs
      lbbl(ibbl,19)=handle_fwl
      lbbl(ibbl,20)=handle_fsl
c
      return
      end
      subroutine sp_bscale(boxsiz)
c
      implicit none
c
#include "sp_common.fh"
c
      real*8 boxsiz(maxbox,3)
c
      integer ibx,iby,ibz
      real*8 boxscl
c
c     scale the subbox boundaries
c
      boxscl=box(1)/boxsiz(nbx,1)
      do 1 ibx=1,nbx
      boxsiz(ibx,1)=boxscl*boxsiz(ibx,1)
    1 continue
      boxscl=box(2)/boxsiz(nby,2)
      do 2 iby=1,nby
      boxsiz(iby,2)=boxscl*boxsiz(iby,2)
    2 continue
      boxscl=box(3)/boxsiz(nbz,3)
      do 3 ibz=1,nbz
      boxsiz(ibz,3)=boxscl*boxsiz(ibz,3)
    3 continue
c
      return
      end
      subroutine sp_balanc(stime,syntim,waltim,lpsyn)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
c
      logical sp_diffbb
      external sp_diffbb
c
      real*8 stime,syntim,waltim
      logical lpsyn
c
      integer l_dlb,i_dlb,i_nod,l_nod,i_nen,l_nen,i_lst,l_lst
c
c      if(loadb.eq.0) return
c
      if(.not.ma_verify_allocator_stuff())
     + call md_abort('Problems in sp_balanc at 1',me)
      if(.not.ma_push_get(mt_int,np,'nod',l_nod,i_nod))
     + call md_abort('Failed to allocate nod',me)
      if(.not.ma_push_get(mt_int,2*(np+1),'lst',l_lst,i_lst))
     + call md_abort('Failed to allocate lst',me)
      if(.not.ma_push_get(mt_int,mbbl*np,'nen',l_nen,i_nen))
     + call md_abort('Failed to allocate nen',me)
      if(.not.ma_push_get(mt_dbl,np+1,'dlb',l_dlb,i_dlb))
     + call md_abort('Failed to allocate dlb',me)
      if(.not.ma_verify_allocator_stuff())
     + call md_abort('Problems in sp_balanc at 2',me)
c
      call sp_dldbal(stime,syntim,waltim,int_mb(i_nod),int_mb(i_lst),
     + int_mb(i_nen),int_mb(i_bb),dbl_mb(i_dlb),lpsyn,int_mb(i_bindex),
     + int_mb(i_buren),np+1)
      if(.not.ma_verify_allocator_stuff())
     + call md_abort('Problems in sp_balanc at 3',me)
c
      if(.not.ma_pop_stack(l_dlb))
     + call md_abort('Failed to deallocate dlb',me)
      if(.not.ma_pop_stack(l_nen))
     + call md_abort('Failed to deallocate nen',me)
      if(.not.ma_pop_stack(l_lst))
     + call md_abort('Failed to deallocate lst',me)
      if(.not.ma_pop_stack(l_nod))
     + call md_abort('Failed to deallocate nod',me)
      if(.not.ma_verify_allocator_stuff())
     + call md_abort('Problems in sp_balanc at 4',me)
c
      if(sp_diffbb(dbl_mb(i_boxs),int_mb(i_rng))) then
      call sp_numbb(int_mb(i_iown),dbl_mb(i_boxs))
      call sp_listbb(int_mb(i_iown),dbl_mb(i_boxs),int_mb(i_bb))
      endif
      if(.not.ma_verify_allocator_stuff())
     + call md_abort('Problems in sp_balanc at 5',me)
c
      return
      end
      subroutine sp_dldbal(stime,syntim,waltim,nod,nlst,nen,lbbl,dlb,
     + lpsyn,ibindx,iburen,npp)
c
      implicit none
c
#include "sp_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer sp_btop
      external sp_btop
c
      integer npp
      integer nod(np),nlst(npp,2),nen(np,mbbl)
      integer lbbl(mbbl,mbb2)
      real*8 stime,syntim,synsum,waltim,dlb(*),factor,facx,facy,facz
      logical lpsyn
      logical lbsize
c
      integer i,j,k,n,ibusy,least,iproc,icell,jcell,itemp,jtemp
      integer intsiz,ibindx(np),iburen(np,27,2)
      logical lnb(27)
      integer nfr,nto,node
c
c     no load balancing needed if run on single processor
c
      if(np.eq.1) return
c
c     collect the synchronization times converted into integers
c
      do 1 i=1,np
      nlst(i,1)=0
      nlst(i,2)=0
      nod(i)=i-1
    1 continue
      nlst(me+1,1)=int(1.0d6*syntim)
      nlst(npp,1)=int(1.0d6*waltim)
      nlst(npp,2)=0
c
      do 2 i=1,nbbl
      iproc=lbbl(i,1)
      if(iproc.ne.me) then
      n=ibindx(iproc+1)
      if(n.gt.0) nlst(me+1,2)=ior(nlst(me+1,2),2**(n-1))
      endif
    2 continue
c
c     get the size of an integer on this machine in bits
c
      intsiz=ma_sizeof(mt_int,1,mt_byte)
c
c      if(intsiz.le.32) then
      call ga_igop(msp_14,nlst,2*npp,'+')
c      else
c      do 3 i=1,np
c      nlst(i,1)=lshift(nlst(i,1),32)+nlst(i,2)
c    3 continue
c      call ga_igop(msp_14,nlst,np,'+')
c      do 4 i=1,np
c      nlst(i,2)=iand(nlst(i,1),8589934591)
c      nlst(i,1)=rshift(nlst(i,1),32)
c    4 continue
c      endif
c
      synsum=0.0d0
      do 5 i=1,np
      dlb(i)=dble(nlst(i,1))*1.0d-6
      synsum=synsum+dlb(i)
    5 continue
      waltim=(dble(nlst(npp,1))*1.0d-6/dble(np))
c
      if(nldup.lt.0) then
      tslow=synsum
      nldup=nldup+1
      else
      if(synsum.gt.tslow) then
      nldup=nldup+1
      else
      tslow=synsum
      nldup=0
      endif
      endif
c
c     if the accumulated synchronization time is less than 0.0001 sec
c     no load balancing is needed
c
      if(synsum.lt.1.0d-4) return
c
c     determine the busiest processor
c     if the busiest processor has no off-processor box-box pairs
c     load balancing will be done by resizing
c
      ibusy=1
      do 6 i=2,np
      if(abs(dlb(i)).lt.abs(dlb(ibusy))) ibusy=i
    6 continue
c
c     if the busiest processor has no off-processor pairs in the
c     cell-cell list loadbalancing will be done by resizing
c
      lbsize=nlst(ibusy,2).eq.0
      if(nldup.ge.lbpair) lbsize=.true.
c
c     order node list
c
      do 7 i=1,np-1
      do 8 j=i+1,np
      if(dlb(nod(i)+1).gt.dlb(nod(j)+1)) then
      n=nod(i)
      nod(i)=nod(j)
      nod(j)=n
      endif
    8 continue
    7 continue
c
c     load balancing based on cell resizing
c
c     1  if specified as only method in input
c     2. if busiest processor has no off-processor cell-cell pairs (lbsize true)
c     3. if busiest alternates between two processors (lpipo true)
c
      if(loadb.eq.1.or.(loadb.eq.3.and.(lbsize.or.lpipo))) then
      factor=(1.0d0-factld*(synsum/dble(np)-dlb(ibusy))/waltim)**third
      facx=1.0d0
      facy=1.0d0
      facz=1.0d0
      call sp_resize(ibusy-1,int_mb(i_iown),dbl_mb(i_boxs),factor,
     + facx,facy,facz)
      if(me.eq.0.and.lpsyn) then
      write(lfnsyn,3000) 1,stime,synsum,waltim,ibusy-1,
     + factor,facx,facy,facz,lpipo
 3000 format('synchronization',/,i5,3f12.6,/,i5,4f12.6,4x,l1)
      do 9 i=1,np
      write(lfnsyn,3001) nod(i),dlb(nod(i)+1)
 3001 format(i5,f12.6)
    9 continue
      call sp_wrtbxsz(lfnsyn,dbl_mb(i_boxs))
      endif
      ipairf=-3
      ipairt=-4
      lpipo=.false.
      tsyncp=synsum
      nldup=0
      tslow=synsum
      return
      endif
c
c     cascade implementation
c
      if(me.eq.0) then
c
      do 12 i=1,np
      nen(i,1)=-1
   12 continue
c
c     for each processor find least busy neighbor in cell-cell list
c
      do 10 i=1,np
      node=nod(i)
      n=nlst(node+1,2)
      do 11 j=1,27
      lnb(j)=iand(n,1).eq.1
      n=rshift(n,1)
   11 continue
      least=-1
      do 13 j=1,27
      iproc=iburen(node+1,j,1)
      if(nen(iproc+1,1).eq.-1) then
      if(iproc.ne.node.and.lnb(j)) then
      if(least.ge.0) then
      if(dlb(iproc+1).gt.dlb(least+1)) least=iproc
      else
      if(dlb(iproc+1).gt.dlb(node+1)) least=iproc
      endif
      endif
      endif
   13 continue
c
c     nen(i,1) contains processor id that processor i-1 will receive from
c
      if(least.ge.0) then
      if(nen(least+1,1).lt.0) then
      nen(least+1,1)=node
      endif
      endif
c
   10 continue
c
      endif
c
c
c     broadcast the list
c
      call ga_brdcst(msp_16,nen(1,1),np*intsiz,0)
c
c     determine cell pair transfer list
c
c     the list contains the box-box pairs to be moved as follows:
c
c        nen(i,1) = ibox+1
c        nen(1,2) = jbox+1
c
c     the pair will move from iproc to jproc
c
      do 14 i=1,np
      if(me.eq.nen(i,1)) then
      do 15 j=1,nbbl
      if(lbbl(j,1).eq.i-1) then
      nen(i,1)=lbbl(j,3)+1
      nen(i,2)=lbbl(j,2)+1
      goto 14
      endif
   15 continue
      else
      nen(i,1)=0
      nen(i,2)=0
      endif
   14 continue
c
      call ga_igop(msp_17,nen,2*np,'+')
c
c     cascading
c
      call sp_cascad(nen,int_mb(i_bb))
c
      if(me.eq.0.and.lpsyn) then
      write(lfnsyn,3002) 2,stime,synsum,waltim,nldup,tslow
 3002 format('synchronization',/,i5,3f12.6,i5,f12.6)
      do 16 i=1,np
      write(lfnsyn,3003) nod(i),dlb(nod(i)+1)
 3003 format(i5,f12.6,i7,i5)
   16 continue
      endif
c
      return
      end
      subroutine sp_resize(ipmin,ibownr,boxsiz,factor,facx,facy,facz)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer ipmin,ibownr(maxbox,3)
      real*8 factor,facx,facy,facz,boxsiz(maxbox,3)
c
      integer ibx,iby,ibz,ipminx,ipminy,ipminz
      real*8 bxi,bxr,byi,byr,bzi,bzr,rfact
c
c     load balancing based on resizing of node domains
c     ------------------------------------------------
c
      ipminx=mod(ipmin,npx)
      ipminy=mod((ipmin-ipminx)/npx,npy)
      ipminz=((ipmin-ipminx)/npx-ipminy)/npy
c
c     resizing boxes in x-dimension
c
      if(npx.gt.1.and.isload.eq.0) then
      do 7 ibx=nbx,2,-1
      boxsiz(ibx,1)=boxsiz(ibx,1)-boxsiz(ibx-1,1)
    7 continue
      bxi=zero
      bxr=zero
      do 8 ibx=1,nbx
      if(ibownr(ibx,1).eq.ipminx) then
      facx=1.0d0/boxsiz(ibx,1)
      boxsiz(ibx,1)=factor*boxsiz(ibx,1)
      if(boxsiz(ibx,1).lt.bxmin) boxsiz(ibx,1)=bxmin
      facx=facx*boxsiz(ibx,1)
      bxi=bxi+boxsiz(ibx,1)
      else
      bxr=bxr+boxsiz(ibx,1)
      endif
    8 continue
      rfact=(box(1)-bxi)/bxr
      do 9 ibx=1,nbx
      if(ibownr(ibx,1).ne.ipminx) boxsiz(ibx,1)=rfact*boxsiz(ibx,1)
      if(ibx.gt.1) boxsiz(ibx,1)=boxsiz(ibx,1)+boxsiz(ibx-1,1)
    9 continue
      endif
c
c     resizing boxes in y-dimension
c
      if(npy.gt.1.and.isload.eq.0) then
      do 10 iby=nby,2,-1
      boxsiz(iby,2)=boxsiz(iby,2)-boxsiz(iby-1,2)
   10 continue
      byi=zero
      byr=zero
      do 11 iby=1,nby
      if(ibownr(iby,2).eq.ipminy) then
      facy=1.0d0/boxsiz(iby,2)
      boxsiz(iby,2)=factor*boxsiz(iby,2)
      if(boxsiz(iby,2).lt.bymin) boxsiz(iby,2)=bymin
      facy=facy*boxsiz(iby,2)
      byi=byi+boxsiz(iby,2)
      else
      byr=byr+boxsiz(iby,2)
      endif
   11 continue
      rfact=(box(2)-byi)/byr
      do 12 iby=1,nby
      if(ibownr(iby,2).ne.ipminy) boxsiz(iby,2)=rfact*boxsiz(iby,2)
      if(iby.gt.1) boxsiz(iby,2)=boxsiz(iby,2)+boxsiz(iby-1,2)
   12 continue
      endif
c
c     resizing boxes in z-dimension
c
      if(npz.gt.1) then
      do 13 ibz=nbz,2,-1
      boxsiz(ibz,3)=boxsiz(ibz,3)-boxsiz(ibz-1,3)
   13 continue
      bzi=zero
      bzr=zero
      do 14 ibz=1,nbz
      if(ibownr(ibz,3).eq.ipminz) then
      facz=1.0d0/boxsiz(ibz,3)
      boxsiz(ibz,3)=factor*boxsiz(ibz,3)
      if(boxsiz(ibz,3).lt.bzmin) boxsiz(ibz,3)=bzmin
      facz=facz*boxsiz(ibz,3)
      bzi=bzi+boxsiz(ibz,3)
      else
      bzr=bzr+boxsiz(ibz,3)
      endif
   14 continue
      rfact=(box(3)-bzi)/bzr
      do 15 ibz=1,nbz
      if(ibownr(ibz,3).ne.ipminz) boxsiz(ibz,3)=rfact*boxsiz(ibz,3)
      if(ibz.gt.1) boxsiz(ibz,3)=boxsiz(ibz,3)+boxsiz(ibz-1,3)
   15 continue
      endif
c
      call ga_brdcst
     + (msp_19,boxsiz,ma_sizeof(mt_dbl,3*maxbox,mt_byte),0)
c
      return
      end
      subroutine sp_wrtbxsz(lfn,boxsiz)
c
      implicit none
c
#include "sp_common.fh"
c
      real*8 boxsiz(maxbox,3)
      integer lfn
c
      integer i
c
      write(lfn,1000) 1,nbx,(boxsiz(i,1),i=1,nbx)
      write(lfn,1000) 2,nby,(boxsiz(i,2),i=1,nby)
      write(lfn,1000) 3,nbz,(boxsiz(i,3),i=1,nbz)
 1000 format(i3,i5,5f10.5,/,(8x,5f10.5))
c
      return
      end
      logical function sp_diffbb(boxsiz,ibxrng)
c
      implicit none
c
#include "sp_common.fh"
c
      integer ibxrng(maxbox,3,2)
      real*8 boxsiz(maxbox,3)
      integer i,ib,j,k,num
      real*8 rd
c
c     temporarily skip for non-rectangular boxes
c
      if(nbxtyp.eq.1) then
      sp_diffbb=.true.
      return
      endif
c
c     initialize
c
      if(nbbdif.lt.0) then
      do 1 k=1,2
      do 2 j=1,3
      do 3 i=1,maxbox
      ibxrng(i,j,k)=-1
    3 continue
    2 continue
    1 continue
      endif
c
      nbbdif=0
c
      do 4 i=1,nbx
      num=0
      rd=zero
      do 5 j=1,nbx
      ib=i+1
      if(ib.gt.nbx) ib=ib-nbx
      rd=rd+boxsiz(ib,1)
      if(rd.gt.rlong) goto 6
      num=num+1
    5 continue
    6 continue
      if(num.ne.ibxrng(i,1,1)) then
      ibxrng(i,1,1)=num
      nbbdif=nbbdif+1
      endif
      num=0
      rd=zero
      do 7 j=1,nbx
      ib=i-1
      if(ib.lt.1) ib=ib+nbx
      rd=rd+boxsiz(ib,1)
      if(rd.gt.rlong) goto 8
      num=num+1
    7 continue
    8 continue
      if(num.ne.ibxrng(i,1,2)) then
      ibxrng(i,1,2)=num
      nbbdif=nbbdif+1
      endif
    4 continue
c
      do 9 i=1,nby
      num=0
      rd=zero
      do 10 j=1,nby
      ib=i+1
      if(ib.gt.nby) ib=ib-nby
      rd=rd+boxsiz(ib,2)
      if(rd.gt.rlong) goto 11
      num=num+1
   10 continue
   11 continue
      if(num.ne.ibxrng(i,2,1)) then
      ibxrng(i,2,1)=num
      nbbdif=nbbdif+1
      endif
      num=0
      rd=zero
      do 12 j=1,nby
      ib=i-1
      if(ib.lt.1) ib=ib+nby
      rd=rd+boxsiz(ib,2)
      if(rd.gt.rlong) goto 13
      num=num+1
   12 continue
   13 continue
      if(num.ne.ibxrng(i,2,2)) then
      ibxrng(i,2,2)=num
      nbbdif=nbbdif+1
      endif
    9 continue
c
      do 14 i=1,nbz
      num=0
      rd=zero
      do 15 j=1,nbz
      ib=i+1
      if(ib.gt.nbz) ib=ib-nbz
      rd=rd+boxsiz(ib,3)
      if(rd.gt.rlong) goto 16
      num=num+1
   15 continue
   16 continue
      if(num.ne.ibxrng(i,3,1)) then
      ibxrng(i,3,1)=num
      nbbdif=nbbdif+1
      endif
      num=0
      rd=zero
      do 17 j=1,nbz
      ib=i-1
      if(ib.lt.1) ib=ib+nbz
      rd=rd+boxsiz(ib,3)
      if(rd.gt.rlong) goto 18
      num=num+1
   17 continue
   18 continue
      if(num.ne.ibxrng(i,3,2)) then
      ibxrng(i,3,2)=num
      nbbdif=nbbdif+1
      endif
   14 continue
c
      sp_diffbb=nbbdif.ne.0
c
      return
      end
      subroutine sp_cascad(ltran,lbbl)
c
      implicit none
c
#include "sp_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer sp_btop
      external sp_btop
c
      integer ltran(np,3),lbbl(mbbl,mbb2)
c
      integer i,j,k,ltemp
      integer icell,jcell,iproc,jproc
      logical lfirst
c
c     load balancing based on cascade box-list redistribution
c     -------------------------------------------------------
c
      do 1 i=1,np
      ltran(i,1)=ltran(i,1)-1
      ltran(i,2)=ltran(i,2)-1
      ltran(i,3)=-1
      if(ltran(i,2).ge.0) ltran(i,3)=sp_btop(ltran(i,2),int_mb(i_iown))
    1 continue
c
c     remove transfers involving double processors
c
      do 2 i=2,np
      if(ltran(i,1).ge.0) then
      iproc=sp_btop(ltran(i,1),int_mb(i_iown))
      jproc=sp_btop(ltran(i,2),int_mb(i_iown))
      do 3 j=1,i-1
      if(sp_btop(ltran(j,1),int_mb(i_iown)).eq.jproc.or.
     + sp_btop(ltran(j,2),int_mb(i_iown)).eq.jproc) then
      ltran(i,1)=-1
      ltran(i,2)=-1
      goto 2
      endif
    3 continue
      endif
    2 continue
c
c     process the transfer list
c
      lfirst=.true.
      do 4 i=1,np
c
      iproc=-1
      jproc=-1
      icell=ltran(i,1)
      jcell=ltran(i,2)
      if(icell.ge.0) then
      iproc=sp_btop(icell,int_mb(i_iown))
      jproc=sp_btop(jcell,int_mb(i_iown))
      if(lfirst) then
      lpipo=(iproc.eq.ipairt).and.(jproc.eq.ipairf)
      ipairf=iproc
      ipairt=jproc
      lfirst=.false.
      endif
c
c     remove pair
c
      if(iproc.eq.me) then
      k=0
      do 5 j=1,nbbl
      if(lbbl(j,2).ne.jcell.or.lbbl(j,3).ne.icell) then
      k=k+1
      lbbl(k,1)=lbbl(j,1)
      lbbl(k,2)=lbbl(j,2)
      lbbl(k,3)=lbbl(j,3)
      endif
    5 continue
      nbbl=k
      endif
c
c     add pair
c
      if(jproc.eq.me) then
      nbbl=nbbl+1
      lbbl(nbbl,1)=iproc
      lbbl(nbbl,2)=icell
      lbbl(nbbl,3)=jcell
      endif
c
      endif
    4 continue
c
c     order the new box-box list
c
      nbbloc=0
      do 6 i=1,nbbl-1
      do 7 j=i+1,nbbl
      if((lbbl(i,1).ne.me.and.lbbl(j,1).eq.me).or.
     + (lbbl(i,1).gt.lbbl(j,1).and.lbbl(i,1).ne.me).or.
     + (lbbl(i,1).eq.lbbl(j,1).and.lbbl(i,2).gt.lbbl(j,2)).or.
     + (lbbl(i,1).eq.lbbl(j,1).and.lbbl(i,2).eq.lbbl(j,2).and.
     + lbbl(i,3).gt.lbbl(j,3))) then
      ltemp=lbbl(i,1)
      lbbl(i,1)=lbbl(j,1)
      lbbl(j,1)=ltemp
      ltemp=lbbl(i,2)
      lbbl(i,2)=lbbl(j,2)
      lbbl(j,2)=ltemp
      ltemp=lbbl(i,3)
      lbbl(i,3)=lbbl(j,3)
      lbbl(j,3)=ltemp
      endif
    7 continue
      if(lbbl(i,1).eq.me) nbbloc=i
    6 continue
      if(lbbl(nbbl,1).eq.me) nbbloc=nbbl
c
      return
      end

*
* $Id: neb_drv.F 25912 2014-07-15 01:15:00Z bylaska $
*

*     ****************************************
*     *                                      *
*     *                neb                   *
*     *                                      *
*     ****************************************
      logical function neb(rtdb)
      implicit none
      integer rtdb

#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"

c     
*     **** local variables ****     
      logical value,newchain,svalue,verlet,oprint,done,converged,found
      logical ostress,finishedstep,converged1
      character*9 cvg1,cvg2,cvg3,cvg4
      character*4    mark
      character*50 bead_list,filename
      character*80 title,neb_movecs
      character*30 tmp
      character*255 full_filename,full_filename2,filename2
      character ch_tmp
      integer ii,shift,print_shift,print_count,jj,manyjj,itm,goodjj
      integer i,it,nbeads,nion,ng,m,nebsteps,neb_algorithm
      integer nbeads1,nbeads2
      integer e1(2),g0(2),g1(2),s(2),t1(2),v1(2),c0(2),c1(2)
      integer mass(2),dti(2),cs(2),gs(2)
      real*8  path_energy,path_distance,norm,norm0,time_step,kbeads
      real*8  Gmax,Grms,Xmax,Xrms,dE,path_energy0,emid,emax,emin,trust
      real*8  nebGmax,nebGrms,nebXmax,nebXrms,nebdE,sum,sum2,t,alpha
      real*8  alphamin,deltaE,sum0,sum0_old,time_step0
      real*8  emid0,emin0,emax0

*     **** external functions ****
      logical task_gradient
      external task_gradient
      integer  size_bead_list,nion_bead_list
      real*8   energy_bead_list
      external size_bead_list,nion_bead_list
      external energy_bead_list
      character*7 bead_index_name
      external    bead_index_name


      oprint = ga_nodeid() .eq. 0

      if (oprint) then
         write(luout,*)
         write(luout,*)
         call util_print_centered(luout,
     >        'NWChem Minimum Energy Pathway Program (NEB)',
     >        40,.true.)
         write(luout,*)
         write(luout,*)
      endif

      if (rtdb_cget(rtdb,'title',1,title)) then
         if (oprint) then
            write(luout,*)
            write(luout,*)
            call util_print_centered(6, title, 40, .false.)
            write(luout,*)
            write(luout,*)
         endif
      endif
      if (.not. rtdb_get(rtdb,'neb:gmax',mt_dbl,1,nebgmax))
     >   nebgmax = 0.00045d0
      if (.not. rtdb_get(rtdb,'neb:grms',mt_dbl,1,nebgrms))
     >   nebgrms = 0.00030d0
      if (.not. rtdb_get(rtdb,'neb:xmax',mt_dbl,1,nebxmax))
     >   nebxmax = 0.000180d0
      if (.not. rtdb_get(rtdb,'neb:xrms',mt_dbl,1,nebxrms))
     >   nebxrms = 0.000120d0

      if (.not.rtdb_get(rtdb,'neb:stepsize',mt_dbl,1,time_step))
     >  time_step = 1.0d0
      if (.not.rtdb_get(rtdb,'neb:trust',mt_dbl,1,trust))
     >  trust = 0.1d0
      if (.not.rtdb_get(rtdb,'neb:kbeads',mt_dbl,1,kbeads))
     >  kbeads = 0.1d0
      if (.not.rtdb_get(rtdb,'neb:steps',mt_int,1,nebsteps))      
     >   nebsteps = 5

      if (.not.rtdb_cget(rtdb,'neb:movecs',1,neb_movecs)) then
         call util_file_prefix('movecs',neb_movecs)
      end if

*     *** neb_algorithm ***
      if (.not.rtdb_get(rtdb,'neb:algorithm',mt_int,1,neb_algorithm))
     >  neb_algorithm = 0
      if (.not.rtdb_get(rtdb,'neb:m',mt_int,1,m))  m = 5

      if (.not.rtdb_get(rtdb,'neb:print_shift',mt_int,1,print_shift))
     >   print_shift = 0

*     **** neb_epath filename ****
      call util_file_prefix('neb_epath',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                             full_filename)

*     **** includestress? ****
      if (.not. rtdb_get(rtdb,'includestress',mt_log,1,ostress))
     >   ostress = .false.



*  RRR only initialize if this is a new neb chain!
*     **** initialize neb list ****
      bead_list = 'bead_list'
      newchain = .false.
      if (.not.rtdb_get(rtdb,'bead_list:new',mt_log,1,newchain))
     >  newchain = .true.

      if(newchain) then
        if (oprint) write(*,*)'NEW NEB CHAIN, INITIALIZING'
        call neb_initialize(rtdb,bead_list)
        print_count = 0
      else
         if (oprint) write(*,*)'EXISTING NEB CHAIN? RESTARTING'
         call set_rtdb_bead_list(rtdb)
         nbeads1 = size_bead_list(bead_list)
         if (.not.rtdb_get(rtdb,'neb:nbeads',mt_int,1,nbeads2))
     >      nbeads2 = 5
         if (nbeads1.ne.nbeads2) then
            if (oprint) write(*,*) 'RESIZING NEB CHAIN'
            call neb_resize_path(rtdb,bead_list,nbeads1,nbeads2)
         end if
         if (.not.rtdb_get(rtdb,'neb:print_count',mt_int,1,print_count))
     >      print_count = 0
      end if
      newchain = .false.

      nbeads = size_bead_list(bead_list)
      nion   = nion_bead_list(bead_list,1)
      ng     = 3*nion*nbeads

      if (oprint) then

         if (neb_algorithm.eq.0) then
            tmp = "Fixed Point"
         else if (neb_algorithm.eq.1) then
            tmp = "Verlet"
         else if (neb_algorithm.eq.2) then
            tmp = "refining conjugate gradient"
         else
            tmp = "not implemented"
         end if
         
         write(luout,*)
         write(luout,1) nebgmax,nebgrms,nebxmax,nebxrms,
     >                  time_step,trust,nebsteps,nbeads,m,nion,kbeads,
     >                  neb_algorithm,tmp,
     >                  neb_movecs
         if (ostress) 
     >      write(luout,*) ' INCLUDING STRESS !!!!!!!!!!!!!!!!'
         write(luout,*)
         write(luout,*)
 1       format(
     >        ' maximum gradient threshold         (gmax) = ', f10.6,/,
     >        ' rms gradient threshold             (grms) = ', f10.6,/,
     >        ' maximum cartesian step threshold   (xmax) = ', f10.6,/,
     >        ' rms cartesian step threshold       (xrms) = ', f10.6,/,
     >        0p,/,
     >        ' step size                      (stepsize) = ', f10.6,/,
     >        ' fixed trust radius                (trust) = ', f10.6,/,
     >        ' maximum number of steps         (maxiter) = ', i4,/,
     >        ' number of images in path         (nbeads) = ', i4,/,
     >        ' number of histories               (nhist) = ', i4,/,
     >        ' number of atoms                           = ', i4,/,
     >        ' NEB spring constant in a.u.      (kbeads) = ', f10.6,/,
     >        ' NEB algorithm                 (algorithm) = ', i4,
     >                                                   1x,'(',a30,')'/,
     >        ' NEB movecs filename                       = ', a)
      end if


*     **** allocate space for gradients and coordinates ****
      value  = MA_alloc_get(mt_dbl,nbeads,'e1',e1(2),e1(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'g0',g0(2),g0(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'g1',g1(2),g1(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'s',s(2),s(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'t1',t1(2),t1(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'v1',v1(2),v1(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'c0',c0(2),c0(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'c1',c1(2),c1(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,ng,'dti',dti(2),dti(1))
      if (.not.value) 
     >  call errquit('neb failed - increase heap memory',1,0)


      value  = 
     >         MA_alloc_get(mt_dbl,m*ng,'cs',cs(2),cs(1))
      value  = value.and.
     >         MA_alloc_get(mt_dbl,m*ng,'gs',gs(2),gs(1))
      if (.not.value) 
     >  call errquit('neb failed - increase heap memory',1,0)


*     *** set dti ***
      value  = MA_alloc_get(mt_dbl,nion,'mass',mass(2),mass(1))      
      if (.not.value) 
     >  call errquit('neb failed - increase heap memory',2,0)
      call neb_masses_get(rtdb,dbl_mb(mass(1)))

      do i=1,nbeads
        do it=1,nion
          dbl_mb(dti(1)+3*nion*(i-1)+3*(it-1)   )
     >    = -(time_step**2)/dbl_mb(mass(1)+it-1)
          dbl_mb(dti(1)+3*nion*(i-1)+3*(it-1) +1)
     >    = -(time_step**2)/dbl_mb(mass(1)+it-1)
          dbl_mb(dti(1)+3*nion*(i-1)+3*(it-1) +2)
     >    = -(time_step**2)/dbl_mb(mass(1)+it-1)
        end do
      end do
      value = MA_free_heap(mass(2))      
      if (.not.value) call errquit('neb failed',3,0)
  

*     **** initial step ****
      if (oprint) write(luout,*) "neb: Calculating Initial Path Energy"
      call neb_coords_get(bead_list,dbl_mb(c1(1)))
      call runall_bead_list(bead_list,task_gradient)
      call neb_energies_get(bead_list,dbl_mb(e1(1)))
      call dcopy(ng,0.0d0,0,dbl_mb(t1(1)),1)
      call dcopy(ng,0.0d0,0,dbl_mb(g1(1)),1)
      call neb_gradient_get(bead_list,kbeads,
     >                      dbl_mb(c1(1)),
     >                      dbl_mb(e1(1)),
     >                      dbl_mb(t1(1)),
     >                      dbl_mb(g1(1))) 
      sum0 = ddot(ng,dbl_mb(g1(1)),1,dbl_mb(g1(1)),1)
      sum0_old = sum0
      manyjj = 0
      goodjj = 0
      time_step0 = time_step

c      do i=1,ng
c       write(*,*) "i,c1(i)=",i,dbl_mb(c1(1)+i-1)
c      end do

      call neb_path_energy(bead_list,
     >                     path_distance,
     >                     path_energy) 

      if (oprint) then
         write(luout,*) "neb: sum0=",sum0,ng
         write(luout,*)
         write(luout,*) "neb: Initial Path Energy    "
         write(luout,*) "neb: -----------------------"
         do i=1,nbeads
            write(luout,*) "neb: ",i,dbl_mb(e1(1)+i-1)
         end do
         write(luout,*)
      end if
      call create_xyz_file_bead_list(luout,bead_list,.true.)

      norm = dsqrt(ddot(ng,dbl_mb(g1(1)),1,dbl_mb(g1(1)),1))
      if (oprint) write(luout,*) "Path Energy, Path Distance, |G_neb|:",
     >            path_energy,path_distance,norm

      call dcopy(ng,dbl_mb(g1(1)),1,dbl_mb(s(1)),1)

      it  = 0
      itm = 0
      done = .false.
      do while (.not.done)
         it  = it + 1
         itm = itm + 1
         if (oprint) write(luout,*) 'neb: iteration #',it,itm

*        *** save old forces  and coordinates ***
         call dcopy(ng,dbl_mb(c1(1)),1,dbl_mb(c0(1)),1)
         call dcopy(ng,dbl_mb(g1(1)),1,dbl_mb(g0(1)),1)

         norm0=norm

         
*         ***** fixed point iteration ****
          if (neb_algorithm.eq.0) then
             if (oprint) write(luout,*)'neb: using fixed point'

             if (itm.le.m) then
                shift = (itm-1)*ng
                call dcopy(ng,dbl_mb(c0(1)),1,dbl_mb(cs(1)+shift),1)
                call dcopy(ng,dbl_mb(g0(1)),1,dbl_mb(gs(1)+shift),1)
                if (itm.gt.1) then
                   call neb_lmbfgs(ng,itm,
     >                             dbl_mb(cs(1)),
     >                             dbl_mb(gs(1)),
     >                             dbl_mb(s(1)))
                else
                   call dcopy(ng,dbl_mb(g0(1)),1,dbl_mb(s(1)),1)
                end if
             else
                do ii=1,m-1
                   shift = (ii-1)*ng
                   call dcopy(ng,dbl_mb(cs(1)+shift+ng),1,
     >                           dbl_mb(cs(1)+shift),   1)
                   call dcopy(ng,dbl_mb(gs(1)+shift+ng),1,
     >                           dbl_mb(gs(1)+shift),   1)
 
                end do
                shift = (m-1)*ng
                call dcopy(ng,dbl_mb(c0(1)),1,dbl_mb(cs(1)+shift),1)
                call dcopy(ng,dbl_mb(g0(1)),1,dbl_mb(gs(1)+shift),1)
                call neb_lmbfgs(ng,m,
     >                          dbl_mb(cs(1)),
     >                          dbl_mb(gs(1)),
     >                          dbl_mb(s(1)))
             end if
c             call neb_project_gradient(nion,nbeads,
c     >                                dbl_mb(t1(1)),
c     >                                dbl_mb(s(1)))

             finishedstep = .false.
             alpha = time_step
             jj = 0
             do while ((.not.finishedstep).and.(jj.lt.9))
             jj = jj + 1
             sum = ddot(ng,dbl_mb(g0(1)),1,dbl_mb(s(1)),1)

             if ((sum.le.0.0d0).or.(sum0.gt.sum0_old))  then
                call dcopy(ng,dbl_mb(g0(1)),1,dbl_mb(s(1)),1)
                itm = 0
                if (oprint) write(*,*) "neb: s=g and itm reset to 0"
             end if

             sum2 = dsqrt(ddot(ng,dbl_mb(s(1)),1,dbl_mb(s(1)),1))
     >              /dble(nbeads)
             if (oprint) 
     >          write(*,*) "neb: |<s|s>|,<g|s>=",sum2,sum

             call neb_move(ng,
     >                     (-alpha),
     >                     dbl_mb(c0(1)),
     >                     dbl_mb(c1(1)),
     >                     dbl_mb(s(1)))
              call neb_coords_set(bead_list,dbl_mb(c1(1)))

              if (oprint) write(luout,*) "neb: running internal beads"
              call runmid_bead_list(bead_list,task_gradient)

              call neb_energies_get(bead_list,dbl_mb(e1(1)))
              call neb_gradient_get(bead_list,kbeads,
     >                             dbl_mb(c1(1)),
     >                             dbl_mb(e1(1)),
     >                             dbl_mb(t1(1)),
     >                             dbl_mb(g1(1)))
               sum0     = ddot(ng,dbl_mb(g1(1)),1,dbl_mb(g1(1)),1)

               finishedstep = (sum0.le.sum0_old)
               if (.not.finishedstep) then
                   alpha = 0.50d0*alpha
                   manyjj = manyjj+1
                   goodjj = 0
                   if (manyjj.gt.2) then
                      time_step = 0.5d0*time_step
                      manyjj = 0
                      if (oprint) 
     >                   write(*,*) "neb: reducing timestep=",time_step
                   end if
               end if
               if (finishedstep.and.(jj.eq.1)) then
                  goodjj = goodjj + 1
                  if (goodjj.gt.10) then
                     time_step = 2.0d0*time_step
                     if (time_step.gt.time_step0) time_step = time_step0
                     goodjj = 0
                  end if
               end if

               if(oprint) 
     >             write(*,*) "neb: sum0,sum0_old=",
     >                        sum0,sum0_old,jj,finishedstep,alpha

c               if (finishedstep) sum0_old = sum0

             end do
             sum0_old = sum0


*         ***** Verlet iteration ****
          else if (neb_algorithm.eq.1) then
            IF (oprint) write(luout,*)'neb: using verlet algroithm'
            call neb_verlet_update(ng,
     >                         dbl_mb(c0(1)),
     >                         dbl_mb(c1(1)),
     >                         dbl_mb(v1(1)),
     >                         dbl_mb(dti(1)),
     >                         dbl_mb(g1(1)))

            call neb_coords_set(bead_list,dbl_mb(c1(1)))
            call runmid_bead_list(bead_list,task_gradient)
            call neb_energies_get(bead_list,dbl_mb(e1(1)))
            call neb_gradient_get(bead_list,kbeads,
     >                            dbl_mb(c1(1)),
     >                            dbl_mb(e1(1)),
     >                            dbl_mb(t1(1)),
     >                            dbl_mb(g1(1)))

*         ***** refined CG iteration ****
          else if (neb_algorithm.eq.2) then
            if (oprint) write(luout,*) 'neb: using cg algorithm'
            call neb_cg_direction(ng,
     >                         dbl_mb(g0(1)),
     >                         dbl_mb(g1(1)),
     >                         dbl_mb(s(1)))

            do ii=1,10

            if (oprint) write(luout,*) "neb: refining time step"
              call neb_move(ng,
     >                      time_step,
     >                      dbl_mb(c0(1)),
     >                      dbl_mb(c1(1)),
     >                      dbl_mb(s(1)))

              call neb_coords_set(bead_list,dbl_mb(c1(1)))
              if (oprint) write(luout,*) "neb: running internal beads"
              call runmid_bead_list(bead_list,task_gradient)
              call neb_energies_get(bead_list,dbl_mb(e1(1)))
              call neb_gradient_get(bead_list,kbeads,
     >                             dbl_mb(c1(1)),
     >                             dbl_mb(e1(1)),
     >                             dbl_mb(t1(1)),
     >                             dbl_mb(g1(1)))

              norm = dsqrt(ddot(ng,dbl_mb(g1(1)),1,dbl_mb(g1(1)),1))
              if(oprint)  write(luout,*) "neb: new gnorm=",norm
              if(oprint)  write(luout,*) "neb: old gnorm0=",norm0
              if(norm.gt.norm0) then
                time_step=time_step/2.0d0
                if (oprint) 
     >             write(luout,*) "neb: reducing time step ",time_step
              else
                call dscal(ng,time_step,dbl_mb(s(1)),1)
                if (oprint) 
     >             write(luout,*) "neb: accepting time step ",time_step
                go to 19
              end if
            end do
         end if
19       continue         

         if (oprint) then
            inquire(file=full_filename,exist=found)
*           **** CIF FILE already exists - parse to EOF ****
            if (found) then
              open(unit=19,file=full_filename,form='formatted',
     >             status='old')
              do while(.true.)
                read(19,*,ERR=30,END=30) ch_tmp
              end do
 30           continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(SOLARIS) || defined(__crayx1) || defined(GCC46)
              backspace 19
#endif
            write(19,*) " "
*           **** .neb_epath FILE does not exist ****
            else
              open(unit=19,file=full_filename,form='formatted')
            end if
            write(19,*) 
     > "#-------------------------------------------------------"
            write(19,*)  "# NEB Path iteration = ",it
            write(19,*)  "# algorithm          = ",neb_algorithm
            write(19,*)  "# nbeads             = ",nbeads
            write(19,*)  "# nhist              = ",m
            write(19,*)  "# natoms             = ",nion
            write(19,*)  "# kbeads             = ",kbeads
            write(19,*)  "# stepsize           = ",time_step
            write(19,*)  "# trust              = ",trust
            write(19,*)  "# path energy        = ",path_energy
            write(19,*)  "# path distance      = ",path_distance
            write(19,*)  "# dE                 = ",dE
            write(19,*)  "# Gmax               = ",Gmax
            write(19,*)  "# Grms               = ",Grms
            write(19,*)  "# Xmax               = ",Xmax
            write(19,*)  "# Xrms               = ",Xrms
            write(19,*) 
     > "#-------------------------------------------------------"
            do i=1,nbeads
               t = (i-1)/dble(nbeads-1)
               write(19,*) t,dbl_mb(e1(1)+i-1)
            end do
            close(19)
         end if


*        *** RRR write out cumulative path energy
         if (oprint) then
            write(luout,*)
            write(luout,*) "neb: Path Energy #",it
            write(luout,*) "----------------------------"
            do i=1,nbeads
               write(luout,*) "neb: ",i,dbl_mb(e1(1)+i-1)
            end do
            write(luout,*)
         end if
         call create_xyz_file_bead_list(luout,bead_list,.true.)

*        **** write out current xyz file ***
         print_count = print_count + 1
         if (print_shift.gt.0) then
            if (mod(print_count,print_shift).eq.0) then
               call util_file_prefix(
     >                  'nebpath'//bead_index_name(print_count)//'.xyz',
     >                  filename2)
               call util_file_name_noprefix(filename2,.false.,
     >                             .false.,
     >                             full_filename2)
                if (oprint) 
     >            open(unit=23,file=full_filename2,form='formatted')
                call create_xyz_file_bead_list(23,bead_list,.false.)
                if (oprint) close(23)
            end if
         end if
         if (.not.rtdb_put(rtdb,'neb:print_count',mt_int,1,print_count))
     >      call errquit('setting neb:print_count failed',4,RTDB_ERR)

         emid0 = path_energy/path_distance
         call neb_path_energy(bead_list,
     >                        path_distance,
     >                        path_energy) 
         dE = dabs((path_energy/path_distance) - emid0)
         call neb_calc_convergence(ng,dbl_mb(g1(1)),
     >                                dbl_mb(c0(1)),
     >                                dbl_mb(c1(1)),
     >                                Gmax,Grms,Xmax,Xrms)

         emid0 = emid
         emin0 = emin
         emax0 = emax

         emin = +99.0d99
         emax = -99.0d99
         do i=1,nbeads
             if (dbl_mb(e1(1)+i-1)>emax) 
     >          emax = dbl_mb(e1(1)+i-1)
             if (dbl_mb(e1(1)+i-1)<emin) 
     >          emin = dbl_mb(e1(1)+i-1)
         end do
         i = nbeads/2
         if (i.lt.1) i = 1
         emid = dbl_mb(e1(1)+i-1)

         dE = dE + dabs(emid-emid0)
         dE = dE + dabs(emin-emin0)
         dE = dE + dabs(emax-emax0)

         if (oprint) then
           cvg1 = ' '
           cvg2 = ' '
           cvg3 = ' '
           cvg4 = ' '
           if (gmax .lt. nebGmax) cvg1 = '     ok  '
           if (grms .lt. nebGrms) cvg2 = '     ok  '
           if (xrms .lt. nebXrms) cvg3 = '     ok  '
           if (xmax .lt. nebXmax) cvg4 = '     ok  '

           mark = '@neb'
           if (it .gt. 1) mark = ' '

           write(luout,12)  mark," "
           write(luout,12)  mark,"NEB Method"
           write(luout,13)  mark,"algorithm      = ",neb_algorithm
           write(luout,13)  mark,"maxiter        = ",nebsteps
           write(luout,13)  mark,"nbeads         = ",nbeads
           write(luout,13)  mark,"nhist          = ",m
           write(luout,13)  mark,"natoms         = ",nion
           write(luout,14)  mark,"stepsize       = ",time_step
           write(luout,14)  mark,"trust          = ",trust
           write(luout,14)  mark,"kbeads         = ",kbeads
           write(luout,14)  mark,"Gmax tolerance = ",nebGmax
           write(luout,14)  mark,"Grms tolerance = ",nebGrms
           write(luout,14)  mark,"Xmax tolerance = ",nebXmax
           write(luout,14)  mark,"Xrms tolerance = ",nebXrms
           write(luout,12)  mark," "

           write(luout,10) mark, mark
     
           mark = '@neb'
           write(luout,11) mark, it, path_energy/path_distance, 
     >       emid,emin,emax,
     >       Gmax, Grms, Xrms, Xmax, util_wallsec(),
     >       cvg1,cvg2,cvg3,cvg4
 10        format(
     >        /,a4,' Step    Intrinsic E    Mid-Point E ',
     >        '     Minimum E      Maximum E   Gmax',
     >        '     Grms     Xrms     Xmax   Walltime',
     >        /,a4,' ---- -------------- -------------- --------------',
     >        ' --------------',
     >        ' -------- -------- -------- -------- --------')
 11        format(
     >        a4,i5,4f15.6,1p,4f9.5,f9.1,/,
     >        1x,5x,17x,9x,4a9,/)
 12        format(a4,1x,a)
 13        format(a4,1x,a,i9)
 14        format(a4,1x,a,e9.3)

         endif

        converged1 = (Gmax.le.nebgmax)
        converged =               (Grms.le.nebgrms)
        converged = converged.and.(Xmax.le.nebxmax)
        converged = converged.and.(Xrms.le.nebxrms)
        if (dE.gt.1.0d-6) converged = converged.and.converged1

        done = converged.or.(it.ge.nebsteps)
  
      end do
      if (oprint) then
         if (converged) then
            write(luout,'(a)') "@neb  NEB calculation converged"
            if (.not.converged1) 
     >         write(luout,'(2a)') 
     >           "@neb  However NEB Gmax not converged",
     >           "...Try increasing the number of beads."
         else
            write(luout,'(a)') "@neb   NEB calculation not converged"
         end if
          
      end if


*     **** write out final path energies ****
      call util_file_prefix('neb_final_epath',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                             full_filename)
      if (oprint) then
         open(unit=19,file=full_filename,form='formatted')
         write(19,*) 
     > "#-------------------------------------------------------"
         write(19,*)  "# NEB Path"
         write(19,*)  "# algorithm     = ",neb_algorithm
         write(19,*)  "# nbeads        = ",nbeads
         write(19,*)  "# nhist         = ",m
         write(19,*)  "# natoms        = ",nion
         write(19,*)  "# kbeads        = ",kbeads
         write(19,*)  "# stepsize      = ",time_step
         write(19,*)  "# trust         = ",trust
         write(19,*)  "# path energy   = ",path_energy
         write(19,*)  "# path distance = ",path_distance
         write(19,*)  "# dE            = ",dE
         write(19,*)  "# Gmax          = ",Gmax
         write(19,*)  "# Grms          = ",Grms
         write(19,*)  "# Xmax          = ",Xmax
         write(19,*)  "# Xrms          = ",Xrms
         write(19,*) 
     > "#-------------------------------------------------------"
         do i=1,nbeads
            t = (i-1)/dble(nbeads-1)
            write(19,*) t,dbl_mb(e1(1)+i-1)
         end do
         close(19)
      end if

*     **** write out final xyz movies energies ****
      call util_file_prefix('neb_final.xyz',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                             full_filename)
       if (oprint) open(unit=19,file=full_filename,form='formatted')
       call create_xyz_file_bead_list(19,bead_list,.false.)
       if (oprint) close(19)


      value = value.and.MA_free_heap(cs(2))
      value = value.and.MA_free_heap(gs(2))
      value = value.and.MA_free_heap(dti(2))
      value = value.and.MA_free_heap(c1(2))
      value = value.and.MA_free_heap(c0(2))
      value = value.and.MA_free_heap(v1(2))
      value = value.and.MA_free_heap(t1(2))
      value = value.and.MA_free_heap(s(2))
      value = value.and.MA_free_heap(g1(2))
      value = value.and.MA_free_heap(g0(2))
      value = value.and.MA_free_heap(e1(2))      
      if (.not.value) call errquit('neb failed',4,0)

      if (.not.rtdb_put(rtdb,'bead_list:new',mt_log,1,.false.))
     > call errquit('setting bead_list:new failed',4,RTDB_ERR)

      call ga_sync()
      neb = .true. 
      end

*
* $Id: v_psi_write.F 23511 2013-01-29 18:51:04Z bylaska $
*

*     ***********************************
*     *             			*
*     *           v_psi_write		*
*     *             			*
*     ***********************************

      subroutine v_psi_write(ispin,ne,psi2)
      implicit none 
      integer ispin,ne(2)
      double complex psi2(*)
      integer occupation

#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"

*    *** local variables ***
      integer version,l
      integer nfft3d,npack1
      integer nfft(3)
      real*8  unita(3,3)
      character*50 filename
      character*255 full_filename

      integer MASTER,taskid,taskid_i,taskid_j,taskid_p
      parameter(MASTER=0)
      integer n,q,pj

c     complex*16 tmp(*)
      integer tmp(2),tmp2(2)
      logical value,lprint,pio

*     ***** local functions ****
      character*50 control_output_v_psi
      external     control_output_v_psi
      double precision control_unita
      external         control_unita
      integer  control_ngrid,control_version
      external control_ngrid,control_version
      logical  control_print,control_parallel_io
      external control_print,control_parallel_io

      call nwpw_timing_start(50)
      call ga_sync()
      call Parallel_taskid(taskid)
      call Parallel2d_taskid_i(taskid_i)
      call Parallel2d_taskid_j(taskid_j)
      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(1,npack1)

      pio = control_parallel_io()
      if (pio) then
         taskid_p = taskid_i
      else
         taskid_p = taskid
      end if
      lprint= ((taskid.eq.MASTER).and.control_print(print_low))


      value = MA_push_get(mt_dcpl,nfft3d,'tmp',tmp(2),tmp(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,nfft3d,'tmp2',tmp2(2),tmp2(1))
      if (.not. value) 
     >  call errquit('v_psi_write:out of stack',0,MA_ERR)

      version = control_version()
      nfft(1) = control_ngrid(1)
      nfft(2) = control_ngrid(2)
      nfft(3) = control_ngrid(3)

      unita(1,1) = control_unita(1,1)
      unita(2,1) = control_unita(2,1)
      unita(3,1) = control_unita(3,1)
      unita(1,2) = control_unita(1,2)
      unita(2,2) = control_unita(2,2)
      unita(3,2) = control_unita(3,2)
      unita(1,3) = control_unita(1,3)
      unita(2,3) = control_unita(2,3)
      unita(3,3) = control_unita(3,3)

*     **** open ELCIN binary file ****
      if (taskid_p.eq.MASTER) then
         filename = control_output_v_psi()
         full_filename = filename
         call util_file_name_resolve(full_filename, .false.)
         l = index(full_filename,' ') -1
         if (lprint) write(*,1210) full_filename(1:l)
 1210    FORMAT(/' output vpsi filename:',A)

         l = index(full_filename,' ') -1
         call openfile(6,full_filename,l,'w',l)

         if (taskid.eq.MASTER) then
            call iwrite(6,version,1)
            call iwrite(6,nfft,3)
            call dwrite(6,unita,9)
            call iwrite(6,ispin,1)
            call iwrite(6,ne,2)
            occupation = -1
            call iwrite(6,occupation,1)
         else
            if (pio) then
               call ishift_fileptr(6,4)
               call dshift_fileptr(6,9)
               call ishift_fileptr(6,4)
            end if
         end if
      end if

*     *** read in 3d blocks ***
      do n=1,(ne(1)+ne(2))
         call Dneall_ntoqp(n,q,pj)
         if (pj.eq.taskid_j) then
           call Pack_c_Copy(1,psi2(1+(q-1)*npack1),dcpl_mb(tmp2(1)))
           call Pack_c_unpack(1,dcpl_mb(tmp2(1)))
         end if
         if (pio) then
            call D3dB_c_write_pio(1,6,dcpl_mb(tmp2(1)),
     >                                dcpl_mb(tmp(1)),pj)
         else
            call D3dB_c_write(1,6,dcpl_mb(tmp2(1)),
     >                            dcpl_mb(tmp(1)),pj)
         end if
    
      end do

*     *** close ELCIN binary file ***
      call ga_sync()
      if (taskid_p.eq.MASTER) then
        call closefile(6)
      end if
      call ga_sync()

      value =           MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp(2))
      if (.not. value) 
     >  call errquit('v_psi_write:error popping stack',0,MA_ERR)

      call nwpw_timing_end(50)
      return
      end

      subroutine yswap (n,dx,incx,dy,incy)
*
* $Id: yswap.F 22591 2012-06-18 21:06:29Z d3p852 $
*
      implicit none
#include "y64.fh"
      double precision dx(*),dy(*)
      integer incx,incy,n
c
      INTGR4 incx4,incy4,n4
c
      if(n.le.0)return
c
      incx4=incx
      incy4=incy
      n4=n
c
      call dswap (n4,dx,incx4,dy,incy4)
      return
      end

      SUBROUTINE OFFSET_ccsdt_lr_alpha2_9_15_8_2_1(l_a_offset,k_a_offset
     &,size)
C     $Id: OFFSET_ccsdt_lr_alpha2_9_15_8_2_1.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i4 ( h2 h9 h10 h15 p3 p7 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h2b
      INTEGER h9b
      INTEGER h10b
      INTEGER h15b
      INTEGER p3b
      INTEGER p7b
      length = 0
      DO h2b = 1,noab
      DO h9b = h2b,noab
      DO h10b = h9b,noab
      DO h15b = 1,noab
      DO p3b = noab+1,noab+nvab
      DO p7b = p3b,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1
     &) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p7
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h9b-1),ieor(int_mb(
     &k_sym+h10b-1),ieor(int_mb(k_sym+h15b-1),ieor(int_mb(k_sym+p3b-1),i
     &nt_mb(k_sym+p7b-1)))))) .eq. ieor(irrep_y,irrep_trb)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h9b-1
     &)+int_mb(k_spin+h10b-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+p3b-1)
     &+int_mb(k_spin+p7b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdt_lr_alpha2_9_15_8_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h2b = 1,noab
      DO h9b = h2b,noab
      DO h10b = h9b,noab
      DO h15b = 1,noab
      DO p3b = noab+1,noab+nvab
      DO p7b = p3b,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h10b-1
     &) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p7
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h9b-1),ieor(int_mb(
     &k_sym+h10b-1),ieor(int_mb(k_sym+h15b-1),ieor(int_mb(k_sym+p3b-1),i
     &nt_mb(k_sym+p7b-1)))))) .eq. ieor(irrep_y,irrep_trb)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h9b-1
     &)+int_mb(k_spin+h10b-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+p3b-1)
     &+int_mb(k_spin+p7b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p7b - noab - 1 + nvab * (p3b - noab - 1 
     &+ nvab * (h15b - 1 + noab * (h10b - 1 + noab * (h9b - 1 + noab * (
     &h2b - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h2b-1) * int_mb(k_range+h9b-1) * int_
     &mb(k_range+h10b-1) * int_mb(k_range+h15b-1) * int_mb(k_range+p3b-1
     &) * int_mb(k_range+p7b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine argos_cafe_lww(lself,lpbc,xwm,idt,iwfr,iwto,jwfr,jwto,
     + nlocw,mpairs,npairs,lwwjpt,lwwin,lwwj,list,rwx,rw)
c $Id: argos_cafe_lww.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
#include "argos_cafe_common.fh"
#include "bitops.fh"
#include "mafdecls.fh"
c
      integer nlocw
      real*8 rwx(mscr,3),rw(mscr)
      real*8 xwm(mwm,3)
      integer lwwj(*),lwwjpt(nlocw,2)
      integer lwwin(nlocw,2)
      integer list(mwm,2),idt(mwm)
      logical lself,lpbc
c
      integer iwm,jwm,iwmfr,iwfr,iwmto,iwto,jwmfr,jwfr,jwmto,jwto
      integer ilist,nlist,mpairs,npairs
c
      iwmfr=iwfr
      if(lself) then
      lwwin(nlocw,1)=0
      lwwin(nlocw,2)=0
      lwwjpt(nlocw,1)=0
      lwwjpt(nlocw,2)=0
      iwmto=iwto-1
      jwmfr=0
      jwmto=iwto
      else
      iwmto=iwto
      jwmfr=jwfr
      jwmto=jwto
      endif
c
      npairs=0
      do 1 iwm=iwmfr,iwmto
      if(lself) jwmfr=iwm+1
c
      do 3 jwm=jwmfr,jwmto
      rwx(jwm,1)=xwm(iwm,1)-xwm(jwm,1)
      rwx(jwm,2)=xwm(iwm,2)-xwm(jwm,2)
      rwx(jwm,3)=xwm(iwm,3)-xwm(jwm,3)
    3 continue
      if(lpbc) call argos_cafe_pbc(1,rwx,mscr,rwx,mscr,0,jwmfr,jwmto)
      do 8 jwm=jwmfr,jwmto
      rw(jwm)=rwx(jwm,1)**2+rwx(jwm,2)**2+rwx(jwm,3)**2
    8 continue
      do 4 jwm=jwmfr,jwmto
      list(jwm,1)=0
      list(jwm,2)=0
      if(rw(jwm).lt.rshrt2.and.
     + (iand(idt(iwm),mdynam).eq.ldynam.or.
     + iand(idt(jwm),mdynam).eq.ldynam)) list(jwm,1)=1
      if(rw(jwm).lt.rrest2 .and.
     + (iand(idt(iwm),mrestr).eq.lrestr.or.
     + iand(idt(jwm),mrestr).eq.lrestr)) list(jwm,1)=1
    4 continue
      if(npww.eq.2) then
      do 2 jwm=jwmfr,jwmto
      if(rw(jwm).lt.rlong2.and.
     + (iand(idt(iwm),mdynam).eq.ldynam.or.
     + iand(idt(jwm),mdynam).eq.ldynam)) list(jwm,2)=1
      if(list(jwm,1).eq.1) list(jwm,2)=0
    2 continue
      endif
c
c     short range pairlist
c
      nlist=0
      do 9 jwm=jwmfr,jwmto
      if(list(jwm,1).eq.1) then
      nlist=nlist+1
      list(nlist,1)=jwm
      endif
    9 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 5 ilist=1,nlist
      lwwj(npairs+ilist)=list(ilist,1)
    5 continue
      lwwjpt(iwm-iwmfr+1,1)=npairs+1
      npairs=npairs+nlist
      lsww=lsww+nlist
      lwwin(iwm-iwmfr+1,1)=nlist
c
c     long range pairs
c
      nlist=0
      if(npww.eq.2) then
      do 12 jwm=jwmfr,jwmto
      if(list(jwm,2).eq.1) then
      nlist=nlist+1
      list(nlist,2)=jwm
      endif
   12 continue
      if(npairs+nlist.gt.mpairs)
     + call md_abort('Insufficient memory for pairlist',0)
      do 13 ilist=1,nlist
      lwwj(npairs+ilist)=list(ilist,2)
   13 continue
      lwwjpt(iwm-iwmfr+1,2)=npairs+1
      npairs=npairs+nlist
      llww=llww+nlist
      lwwin(iwm-iwmfr+1,2)=nlist
      endif
    1 continue
c
      return
      end

      SUBROUTINE ccsdt_o2(d_i0,d_o1,d_t1,d_t2,d_t3,k_i0_offset,k_o1_offs
     &et,k_t1_offset,k_t2_offset,k_t3_offset)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_to + = -1 * P( 2 ) * Sum ( h5 ) * t ( p3 p4 h1 h5 )_t * i1 ( h5 h2 )_o
C         i1 ( h5 h1 )_o + = 1 * o ( h5 h1 )_o
C         i1 ( h5 h1 )_ot + = 1 * Sum ( p6 ) * o ( h5 p6 )_o * t ( p6 h1 )_t
C     i0 ( p3 p4 h1 h2 )_to + = -1 * P( 2 ) * Sum ( p5 ) * o ( p3 p5 )_o * t ( p4 p5 h1 h2 )_t
C     i0 ( p3 p4 h1 h2 )_to + = 1 * Sum ( p6 h5 ) * o ( h5 p6 )_o * t ( p3 p4 p6 h1 h2 h5 )_t
C     i0 ( p3 p4 h1 h2 )_ott + = -1 * P( 2 ) * Sum ( h5 ) * t ( p3 h5 )_t * i1 ( h5 p4 h1 h2 )_ot
C         i1 ( h5 p3 h1 h2 )_ot + = -1 * Sum ( p6 ) * o ( h5 p6 )_o * t ( p3 p6 h1 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_o1
      INTEGER k_o1_offset
      INTEGER d_t3
      INTEGER k_t3_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      CHARACTER*255 filename
      CALL OFFSET_ccsdt_o2_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_o2_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_o2_1_1(d_o1,k_o1_offset,d_i1,k_i1_offset)
      CALL ccsdt_o2_1_2(d_o1,k_o1_offset,d_t1,k_t1_offset,d_i1,k_i1_offs
     &et)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_o2_1(d_t2,k_t2_offset,d_i1,k_i1_offset,d_i0,k_i0_offset
     &)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_o2',-1,MA_
     &ERR)
      CALL ccsdt_o2_2(d_o1,k_o1_offset,d_t2,k_t2_offset,d_i0,k_i0_offset
     &)
      CALL ccsdt_o2_3(d_o1,k_o1_offset,d_t3,k_t3_offset,d_i0,k_i0_offset
     &)
      CALL OFFSET_ccsdt_o2_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_o2_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_o2_4_1(d_o1,k_o1_offset,d_t2,k_t2_offset,d_i1,k_i1_offs
     &et)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_o2_4(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset
     &)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_o2',-1,MA_
     &ERR)
      RETURN
      END
      SUBROUTINE ccsdt_o2_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_to + = -1 * P( 2 ) * Sum ( h5 ) * t ( p3 p4 h1 h5 )_t * i1 ( h5 h2 )_o
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h5b_1
      INTEGER h5b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_o)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_o2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h5b,p3b_1,p4b_1,h1b_1,h5b_1)
      CALL TCE_RESTRICTED_2(h5b,h2b,h5b_2,h2b_2)
      dim_common = int_mb(k_range+h5b-1)
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_o2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_o2_1',2,MA_ERR)
      IF ((h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h5b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_o2_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_o2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_o2_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h5b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_o2_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_o2_1',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_o2_1',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_o2_1',9,MA_ERR)
      IF ((h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_o2_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_o2_1',11,MA_E
     &RR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_o2_1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 h1 )_o + = 1 * o ( h5 h1 )_o
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h1b
      INTEGER dimc
      INTEGER h5b_1
      INTEGER h1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h5b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_o) TH
     &EN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h1b-1)
      CALL TCE_RESTRICTED_2(h5b,h1b,h5b_1,h1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_o2_1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_o2_1_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + (noab+nvab) * (h5b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_o2_1_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_o2_1_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h5b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_o2_1_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_o2_1_1',5,MA_
     &ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsdt_o2_1_1(l_a_offset,k_a_offset,size)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 h1 )_o
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h5b
      INTEGER h1b
      length = 0
      DO h5b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_o) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdt_o2_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h5b = 1,noab
      DO h1b = 1,noab
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+h1b-1)) .eq. irrep_o) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h1b - 1 + noab * (h5b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h5b-1) * int_mb(k_range+h1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsdt_o2_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 h1 )_ot + = 1 * Sum ( p6 ) * o ( h5 p6 )_o * t ( p6 h1 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER h5b_1
      INTEGER p6b_1
      INTEGER p6b_2
      INTEGER h1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h5b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &o,irrep_t)) THEN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_o2_1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p6b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+p6b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(h5b,p6b,h5b_1,p6b_1)
      CALL TCE_RESTRICTED_2(p6b,h1b,p6b_2,h1b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h5b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_o2_1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_o2_1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p6b_1
     & - 1 + (noab+nvab) * (h5b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+p6b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_o2_1_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_o2_1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_o2_1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h1b_2
     & - 1 + noab * (p6b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_o2_1_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_o2_1_2',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_o2_1_2',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_o2_1_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h5b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_o2_1_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_o2_1_2',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_o2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_to + = -1 * P( 2 ) * Sum ( p5 ) * o ( p3 p5 )_o * t ( p4 p5 h1 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p3b_1
      INTEGER p5b_1
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER h1b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO p4b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_o)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_o2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+p5b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,p5b,p3b_1,p5b_1)
      CALL TCE_RESTRICTED_4(p4b,p5b,h1b,h2b,p4b_2,p5b_2,h1b_2,h2b_2)
      dim_common = int_mb(k_range+p5b-1)
      dima_sort = int_mb(k_range+p3b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_o2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_o2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - 1 + (noab+nvab) * (p3b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p5b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_o2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_o2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_o2_2',5,MA_ERR)
      IF ((p5b .lt. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (p4b_2 - noab - 1 + nvab * (p5b_
     &2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p4b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (p5b_2 - noab - 1 + nvab * (p4b_
     &2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_o2_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_o2_2',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_o2_2',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_o2_2',9,MA_ERR)
      IF ((p3b .le. p4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((p4b .le. p3b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p3b - noab - 1 + nvab * (p4b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_o2_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_o2_2',11,MA_E
     &RR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_o2_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_to + = 1 * Sum ( p6 h5 ) * o ( h5 p6 )_o * t ( p3 p4 p6 h1 h2 h5 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER p6b
      INTEGER h5b_1
      INTEGER p6b_1
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER p6b_2
      INTEGER h1b_2
      INTEGER h2b_2
      INTEGER h5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_t,irrep_o)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_o2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p6b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+p6b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(h5b,p6b,h5b_1,p6b_1)
      CALL TCE_RESTRICTED_6(p3b,p4b,p6b,h1b,h2b,h5b,p3b_2,p4b_2,p6b_2,h1
     &b_2,h2b_2,h5b_2)
      dim_common = int_mb(k_range+h5b-1) * int_mb(k_range+p6b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_o2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_o2_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p6b_1
     & - 1 + (noab+nvab) * (h5b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+p6b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_o2_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_o2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_o2_3',5,MA_ERR)
      IF ((p6b .lt. p3b) .and. (h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (h5b_2 - 1 + noab * (p4b_2 - noa
     &b - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p6b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,3,2,1,4,1.0d0)
      END IF
      IF ((p6b .lt. p3b) .and. (h1b .le. h5b) .and. (h5b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h5b_2 - 1 + noab * (h1b_2 - 1 + noab * (p4b_2 - noa
     &b - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p6b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h2b-1),6,4,3,2,1,5,-1.0d0)
      END IF
      IF ((p6b .lt. p3b) .and. (h2b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h5b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (h1b_2 - 1 + noab * (p4b_2 - noa
     &b - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p6b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),5,4,3,2,1,6,1.0d0)
      END IF
      IF ((p3b .le. p6b) .and. (p6b .lt. p4b) .and. (h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (h5b_2 - 1 + noab * (p4b_2 - noa
     &b - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p3b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p4b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,3,1,2,4,-1.0d0)
      END IF
      IF ((p3b .le. p6b) .and. (p6b .lt. p4b) .and. (h1b .le. h5b) .and.
     & (h5b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h5b_2 - 1 + noab * (h1b_2 - 1 + noab * (p4b_2 - noa
     &b - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p3b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h2b-1),6,4,3,1,2,5,1.0d0)
      END IF
      IF ((p3b .le. p6b) .and. (p6b .lt. p4b) .and. (h2b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h5b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (h1b_2 - 1 + noab * (p4b_2 - noa
     &b - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p3b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),5,4,3,1,2,6,-1.0d0)
      END IF
      IF ((p4b .le. p6b) .and. (h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (h5b_2 - 1 + noab * (p6b_2 - noa
     &b - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p6b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h2b-1),6,5,2,1,3,4,1.0d0)
      END IF
      IF ((p4b .le. p6b) .and. (h1b .le. h5b) .and. (h5b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h5b_2 - 1 + noab * (h1b_2 - 1 + noab * (p6b_2 - noa
     &b - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h2b-1),6,4,2,1,3,5,-1.0d0)
      END IF
      IF ((p4b .le. p6b) .and. (h2b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h5b_2
     & - 1 + noab * (h2b_2 - 1 + noab * (h1b_2 - 1 + noab * (p6b_2 - noa
     &b - 1 + nvab * (p4b_2 - noab - 1 + nvab * (p3b_2 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p6b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h5b-1),5,4,2,1,3,6,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_o2_3',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_o2_3',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_o2_3',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_o2_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_o2_3',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_o2_3',11,MA_E
     &RR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_o2_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset
     &)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_ott + = -1 * P( 2 ) * Sum ( h5 ) * t ( p3 h5 )_t * i1 ( h5 p4 h1 h2 )_ot
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER p3b_1
      INTEGER h5b_1
      INTEGER p4b_2
      INTEGER h5b_2
      INTEGER h1b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO p4b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_o,ieor(irrep_t
     &,irrep_t))) THEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_o2_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h5b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h5b,p3b_1,h5b_1)
      CALL TCE_RESTRICTED_4(p4b,h5b,h1b,h2b,p4b_2,h5b_2,h1b_2,h2b_2)
      dim_common = int_mb(k_range+h5b-1)
      dima_sort = int_mb(k_range+p3b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_o2_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_o2_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h5b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_o2_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_o2_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_o2_4',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (h5b_2 - 1 + noab * (p4b_2 - noa
     &b - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_o2_4',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_o2_4',7,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_o2_4',8,MA_ER
     &R)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_o2_4',9,MA_ERR)
      IF ((p3b .le. p4b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((p4b .le. p3b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p3b - noab - 1 + nvab * (p4b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_o2_4',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_o2_4',11,MA_E
     &RR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsdt_o2_4_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offs
     &et)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 p3 h1 h2 )_ot + = -1 * Sum ( p6 ) * o ( h5 p6 )_o * t ( p3 p6 h1 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h5b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER h5b_1
      INTEGER p6b_1
      INTEGER p3b_2
      INTEGER p6b_2
      INTEGER h1b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_o,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_o2_4_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      IF (int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p6b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),int_mb(k_sym+p6b-1)) .eq. irrep_o) TH
     &EN
      CALL TCE_RESTRICTED_2(h5b,p6b,h5b_1,p6b_1)
      CALL TCE_RESTRICTED_4(p3b,p6b,h1b,h2b,p3b_2,p6b_2,h1b_2,h2b_2)
      dim_common = int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+h5b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_o2_4_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_o2_4_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p6b_1
     & - 1 + (noab+nvab) * (h5b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+p6b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_o2_4_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_o2_4_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_o2_4_1',5,MA_ERR)
      IF ((p6b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (p3b_2 - noab - 1 + nvab * (p6b_
     &2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((p3b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (h1b_2 - 1 + noab * (p6b_2 - noab - 1 + nvab * (p3b_
     &2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_o2_4_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_o2_4_1',7,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_o2_4_1',8,MA_
     &ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_o2_4_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p3b-1),int_mb(k_range+h5b-1)
     &,3,4,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h5b - 1 + noab * (p3b - noab - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_o2_4_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_o2_4_1',11,MA
     &_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsdt_o2_4_1(l_a_offset,k_a_offset,size)
C     $Id: ccsdt_o2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 p3 h1 h2 )_ot
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p3b
      INTEGER h5b
      INTEGER h1b
      INTEGER h2b
      length = 0
      DO p3b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_o,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+p3b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdt_o2_4_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p3b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_o,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+p3b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h2b - 1 + noab * (h1b - 1 + noab * (h5b 
     &- 1 + noab * (p3b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p3b-1) * int_mb(k_range+h5b-1) * int_
     &mb(k_range+h1b-1) * int_mb(k_range+h2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      SUBROUTINE ccsdt_lambda1_10_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_
     &c_offset)
C     $Id: ccsdt_lambda1_10_2.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 h3 )_yt + = 1/2 * Sum ( h6 p5 p4 ) * t ( p4 p5 h3 h6 )_t * y ( h2 h6 p4 p5 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p5b
      INTEGER h6b
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER h3b_1
      INTEGER h6b_1
      INTEGER h2b_2
      INTEGER h6b_2
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h2b = 1,noab
      DO h3b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h2b-1) .eq. int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),int_mb(k_sym+h3b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lambda1_10_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO p5b = p4b,noab+nvab
      DO h6b = 1,noab
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h
     &3b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+h3b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p4b,p5b,h3b,h6b,p4b_1,p5b_1,h3b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h2b,h6b,p4b,p5b,h2b_2,h6b_2,p4b_2,p5b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_m
     &b(k_range+h6b-1)
      dima_sort = int_mb(k_range+h3b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lambda1_10_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lambda1_10_2',2,MA_ERR)
      IF ((h6b .lt. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h3b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+h3b-1),int_mb(k_range+h6b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lambda1_10_2',3,MA
     &_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lambda1_10_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lambda1_10_2',5,MA_ERR)
      IF ((h6b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab 
     &* (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,2,1,4,3,-1.0d0)
      END IF
      IF ((h2b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h2b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,1,2,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lambda1_10_2',6,MA
     &_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p4b .eq. p5b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lambda1_10_2'
     &,7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lambda1_10_2'
     &,8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lambda1_10_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h3b-1),1,2,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h3b -
     & 1 + noab * (h2b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lambda1_10_2',10,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lambda1_10_2'
     &,11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

C> \ingroup selci
C> @{
      subroutine selci_wthcon(iflcon, title, multi, nelec, issss,
     $     norbs, 
     &     nnsmax, nci, noconf, nintpo, nbitpi, nbpsy, isym, nsym,
     &     inttyp,nsneed)
*
* $Id: wthcon.f 24790 2013-11-11 18:56:49Z d3y133 $
*
      character*80 title
      dimension nbpsy(8), isym(255), nsneed(3)
c
c     write header of the ciconf file
c
      write(iflcon) title, multi, nelec, issss, norbs, nnsmax, 
     &     nci, noconf, nintpo, nbitpi, nbpsy, isym, nsym, inttyp,
     &     nsneed
c      write(6,*) ' in rdhcon '
c      write(6,*) ' title, multi, nelec, issss, norbs, nnsmax, nci,',
c     &     'noconf, nintpo, nbitpi '
c      write(6,*) title
c      write(6,*) multi, nelec, issss, norbs, nnsmax, nci, noconf,
c     &     nintpo, nbitpi, nbpsy, isym, inttyp, nsneed
      end
C> @}

c
c $Id: frce_shel.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE frce_shel(ntshel,eshel)

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'p_const.inc'
      include 'cm_atom.inc'
      include 'cm_latt.inc'
      include 'cm_shel.inc'

      integer i,iatm1,iatm2,ishel,ntshel

      real*8  eshel,rij,dijt,force,kcst

      dimension rij(mxshel2,3)

      eshel=0.0

      do i=1,ntshel

       iatm1=shllist(i,1)
       iatm2=shllist(i,2)

       rij(i,1)=ccc(iatm1,1)-ccc(iatm2,1)
       rij(i,2)=ccc(iatm1,2)-ccc(iatm2,2)
       rij(i,3)=ccc(iatm1,3)-ccc(iatm2,3)

      enddo

      call tool_rebox(ntshel,mxshel2,latt,rlatt,rij)

      do i=1,ntshel

       iatm1=shllist(i,1)
       iatm2=shllist(i,2)
       ishel=shllist(i,3)

       kcst=shelfrce(ishel)

       dijt=sqrt(rij(i,1)**2+rij(i,2)**2+rij(i,3)**2)

       eshel=eshel+0.5*kcst*dijt**2

       force=-kcst

       fff(iatm1,1)=fff(iatm1,1)+convfct2*force*rij(i,1)
       fff(iatm1,2)=fff(iatm1,2)+convfct2*force*rij(i,2)
       fff(iatm1,3)=fff(iatm1,3)+convfct2*force*rij(i,3)

       fff(iatm2,1)=fff(iatm2,1)-convfct2*force*rij(i,1)
       fff(iatm2,2)=fff(iatm2,2)-convfct2*force*rij(i,2)
       fff(iatm2,3)=fff(iatm2,3)-convfct2*force*rij(i,3)

      enddo

      return

      END

      subroutine smd_atom_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_atom
      character*32 tag,pname
      logical result

      pname = "smd_atom_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_atom_init(sp_atom)

      return
      end

      subroutine smd_atom_init(namespace)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
c
      character*32 pname
      character*80 tag
      integer nt
      integer i_t,i_tr,i_ir,i_qf
      integer i_iconst
      logical result
c
      logical geom_tag_to_charge
      external geom_tag_to_charge
c
      pname = "smd_atom_init"
c
c      write(*,*) "in "//pname
c
c     get total number of atoms from pdb file
c     ---------------------------------------
      call smd_coordfile_natoms(nt)
c      write(*,*) "in 1"//pname
      if(nt.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)
c
c     create atom namespace
c     ---------------------
      call smd_namespace_create(namespace)
c      write(*,*) "in 2"//pname
c
c     create atom data structures
c     ---------------------------
      call smd_data_create(namespace,"atom:iconst",1,MT_INT)
      call smd_data_create(namespace,"atom:name",16*nt,MT_BYTE)
      call smd_data_create(namespace,"atom:formal_charge",nt,MT_DBL)
      call smd_data_create(namespace,"atom:resname",16*nt,MT_BYTE)
      call smd_data_create(namespace,"atom:resid",nt,MT_INT)

c
c    don't ask
c    --------
      tag = "atom:iconst"
      call smd_data_get_index(namespace,tag,i_iconst,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      int_mb(i_iconst) = nt
c
c     fill in names from pdb file
c     ---------------------------
      tag = "atom:name"
      call smd_data_get_index(namespace,tag,i_t,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "atom:resname"
      call smd_data_get_index(namespace,tag,i_tr,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "atom:resid"
      call smd_data_get_index(namespace,tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "atom:formal_charge"
      call smd_data_get_index(namespace,tag,i_qf,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)


c      write(*,*) "in 3"//pname,ga_nodeid()
      call smd_coordfile_read_atomres(nt,
     +                         byte_mb(i_t),
     +                         byte_mb(i_tr),
     +                         int_mb(i_ir))

c      write(*,*) "in 4"//pname,ga_nodeid()
c      call util_flush(6)
      if(.not.geom_tag_to_charge(nt,byte_mb(i_t),dbl_mb(i_qf)))
     >  call errquit(
     >       pname//'error setting formal charge',0, RTDB_ERR)
c      write(*,*) "out "//pname,ga_nodeid()
c      call util_flush(6)
      return
      end

      subroutine smd_atom_ntot(namespace,ntot)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      integer ntot
c
      character*72 tag
      character*30 pname
      integer i_iconst
      logical result

      pname = "smd_atom_ntot"
      tag = "atom:iconst"
      call smd_data_get_index(namespace,tag,i_iconst,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting ntot '//tag,0, RTDB_ERR)
      ntot = int_mb(i_iconst)

      return
      end

      subroutine smd_atom_nres(namespace,nr)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      integer nr
c
      character*72 tag
      character*30 pname
      integer i_ir
      logical result
      integer nt
      integer ir,ir0,i

      pname = "smd_atom_nres"
      tag = "atom:resid"
      call smd_data_get_index(namespace,tag,i_ir,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting '//tag,0, RTDB_ERR)
      call smd_data_get_size(namespace,tag,nt,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size '//tag,0, RTDB_ERR)

      nr = 0
      ir0 = 0
      do i=1,nt
       ir = int_mb(i_ir+i-1)
       if(ir0.ne.ir) then
          ir0=ir
          nr = nr + 1
       end if
      end do
       
      return
      end

      subroutine smd_atom_ntot1(namespace,ntot)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
      integer ntot
c
      character*72 tag
      character*30 pname
      logical result

      pname = "smd_atom_ntot"
      tag = "atom:xyz"
      call smd_data_get_size(namespace,tag,ntot,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting size for '//tag,0, RTDB_ERR)
      ntot = ntot/3

      return
      end

      subroutine smd_atom_end(rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer rtdb
c
      return
      end

      subroutine smd_atom_rebox(namespace)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) namespace
c
      character*72 tag
      character*30 pname
      integer na
      integer i_c,i_lrc,i_lc
      logical result

      pname = "smd_atom_rebox"

c
c     get atomic coordinates
c     ----------------------
      tag = "atom:xyz"
      call smd_data_get_index(namespace,tag,i_c,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_data_get_size(namespace,tag,na,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      na = na/3
c
c     get lattice params
c     ------------------
      tag = "lat:cell"
      call smd_data_get_index(namespace,tag,i_lc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "lat:rcell"
      call smd_data_get_index(namespace,tag,i_lrc,result)
      if(.not. result)
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_util_rebox(na,
     >                    dbl_mb(i_lc),
     >                    dbl_mb(i_lrc),
     >                    dbl_mb(i_c))

      return
      end
c $Id: smd_atom.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine tce_guess_t1(d_t1,k_t1_offset)
c
c $Id: tce_guess_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_t1
      integer p1b
      integer h2b
      integer p1
      integer h2
      integer k_t1_offset
      integer size
      integer l_t1,k_t1
      integer i
      integer nprocs
      integer count
      integer next
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical nodezero
      logical noloadbalance
c
c     ================
c     Loop over blocks
c     ================
c
      nodezero = (ga_nodeid().eq.0)
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_t1))))
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (noloadbalance.or.(next.eq.count)) then
            if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then 
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1)).eq.0) then
              size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
              if (.not.ma_push_get(mt_dbl,size,'kar1',l_t1,k_t1))
     1          call errquit('guess_t1: MA problem',0,MA_ERR)
              call get_hash_block(d_t1,dbl_mb(k_t1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
              i = 0
              do p1 = 1,int_mb(k_range+p1b-1)
                do h2 = 1,int_mb(k_range+h2b-1)
                  i = i + 1
                  dbl_mb(k_t1+i-1) = dbl_mb(k_t1+i-1)
     1           / (-dbl_mb(k_evl_sorted+int_mb(k_offset+p1b-1)+p1-1)
     2              +dbl_mb(k_evl_sorted+int_mb(k_offset+h2b-1)+h2-1))
                enddo
              enddo
              call put_hash_block(d_t1,dbl_mb(k_t1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
              if (.not.ma_pop_stack(l_t1))
     1          call errquit('guess_t1: MA problem',1,MA_ERR)
            endif
            endif
            endif
cc            next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end
c
c
c
c
c
c
c
c
c
c
c
c
      subroutine tce_guess_t1_zero(d_t1,k_t1_offset)
c
c $Id: tce_guess_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_t1
      integer p1b
      integer h2b
      integer k_t1_offset
      integer size
      integer l_t1,k_t1
      integer i
      integer nprocs
      integer count
      integer next
cc      integer nxtval
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
c
c     ================
c     Loop over blocks
c     ================
c
      nprocs = ga_nnodes()
      count = 0
cc      next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (next.eq.count) then
            if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then
            if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1        +int_mb(k_spin+h2b-1).ne.4)) then
            if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1)).eq.0) then
              size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
              if (.not.ma_push_get(mt_dbl,size,'t1',l_t1,k_t1))
     1          call errquit('tce_guess_t1: MA problem',0,MA_ERR)
              do i = 1,size
                dbl_mb(k_t1+i-1) = 0.0d0
              enddo
              call put_hash_block(d_t1,dbl_mb(k_t1),size,
     1          int_mb(k_t1_offset),((p1b-noab-1)*noab+h2b-1))
              if (.not.ma_pop_stack(l_t1))
     1          call errquit('tce_guess_t1: MA problem',1,MA_ERR)
            endif
            endif
            endif
cc            next = nxtval(nprocs)
      next = NXTASK(nprocs, 1)
          endif
          count = count + 1
        enddo
      enddo
cc      next = nxtval(-nprocs)
      next = NXTASK(-nprocs, 1)
      call ga_sync()
      return
      end  
c
c
c
c
c
c
c
c
c
c
c
c
c
      SUBROUTINE t1mp2(d_f1,d_i0,d_t2,d_v2,k_f1_offset,k_i0_offset,k_t2_
     &offset,k_v2_offset)
C     $Id: tce_guess_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_f + = 1 * f ( p2 h1 )_f
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h4 h5 p3 ) * t ( p2 p3 h4 h5 )_t * v ( h4 h5 h1 p3 )_v
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * v ( h5 p2 p3 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      CALL t1mp2_1(d_f1,k_f1_offset,d_i0,k_i0_offset)
      CALL t1mp2_2(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i0,k_i0_offset)
      CALL t1mp2_3(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i0,k_i0_offset)
      RETURN
      END
      SUBROUTINE t1mp2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: tce_guess_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_f + = 1 * f ( p2 h1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
cc      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER p2b_1
      INTEGER h1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      INTEGER NXTASK
      EXTERNAL NXTASK
cc      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. irrep_f) TH
     &EN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      CALL TCE_RESTRICTED_2(p2b,h1b,p2b_1,h1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('t1mp2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &t1mp2_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + (noab+nvab) * (p2b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('t1mp2_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &t1mp2_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('t1mp2_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('t1mp2_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      END DO
      END DO
cc      next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE t1mp2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: tce_guess_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h4 h5 p3 ) * t ( p2 p3 h4 h5 )_t * v ( h4 h5 h1 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
cc      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER p2b_1
      INTEGER p3b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER h1b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
cc      EXTERNAL NXTVAL
      INTEGER NXTASK
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('t1mp2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &4b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h4b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p2b,p3b,h4b,h5b,p2b_1,p3b_1,h4b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,h1b,p3b,h4b_2,h5b_2,h1b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('t1mp2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &t1mp2_2',2,MA_ERR)
      IF ((p3b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p2b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('t1mp2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('t1mp2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &t1mp2_2',5,MA_ERR)
      IF ((h1b .le. p3b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (h1b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p3b_2
     & - 1 + (noab+nvab) * (h1b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))),p3b_2,h1b_2,h5b_2,h4b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('t1mp2_2',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('t1mp2_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('t1mp2_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &t1mp2_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('t1mp2_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('t1mp2_2',11,MA_ERR)
      END IF
      END IF
      END IF
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      END DO
      END DO
cc      next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE t1mp2_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset)
C     $Id: tce_guess_t1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * v ( h5 p2 p3 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
cc      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER h5b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h5b_1
      INTEGER p2b_2
      INTEGER h5b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
cc      EXTERNAL NXTVAL
      INTEGER NXTASK
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('t1mp2_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h5b = 1,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h5b,p3b_1,p4b_1,h1b_1,h5b_1)
      CALL TCE_RESTRICTED_4(p2b,h5b,p3b,p4b,p2b_2,h5b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('t1mp2_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &t1mp2_3',2,MA_ERR)
      IF ((h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h1b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h5b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('t1mp2_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('t1mp2_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &t1mp2_3',5,MA_ERR)
      IF ((h5b .le. p2b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p4b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))),p4b_2,p3b_2,p2b_2,h5b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,2,1,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('t1mp2_3',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('t1mp2_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('t1mp2_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &t1mp2_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('t1mp2_3',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('t1mp2_3',11,MA_ERR)
      END IF
      END IF
      END IF
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      END DO
      END DO
cc      next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE ccsdt_y_tr3_12(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: ccsdt_y_tr3_12.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytrv + = 1/4 * P( 3 ) * Sum ( h12 h10 ) * i1 ( h4 h5 h6 h10 h12 p1 )_ytr * v ( h10 h12 p2 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h10b
      INTEGER h12b
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER p1b_1
      INTEGER h10b_1
      INTEGER h12b_1
      INTEGER h10b_2
      INTEGER h12b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,ieor(irrep_tr,irrep_v))) T
     &HEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr3_12',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h10b = 1,noab
      DO h12b = h10b,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+h10b-1)+int_mb(k_spin+h12
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+h10b-1),in
     &t_mb(k_sym+h12b-1)))))) .eq. ieor(irrep_y,irrep_tr)) THEN
      CALL TCE_RESTRICTED_6(h4b,h5b,h6b,p1b,h10b,h12b,h4b_1,h5b_1,h6b_1,
     &p1b_1,h10b_1,h12b_1)
      CALL TCE_RESTRICTED_4(h10b,h12b,p2b,p3b,h10b_2,h12b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+h10b-1) * int_mb(k_range+h12b-1)
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+h6b-1) * int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr3_12',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr3_12',2,MA_ERR)
      IF ((h12b .le. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (h12b_1 - 1 + noab * (h10b_1 - 1 + noab * (h6
     &b_1 - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h10b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p1b-1),6,3,2,1,5,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr3_12',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr3_12',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr3_12',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (noa
     &b+nvab) * (h10b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h12b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-
     &1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr3_12',6,MA_ERR
     &)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h10b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr3_12',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr3_12',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr3_12',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,4,3,2,1,1.0d0/4.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (p1b - noab - 1 + nvab
     & * (h6b - 1 + noab * (h5b - 1 + noab * (h4b - 1)))))))
      END IF
      IF ((p2b .le. p1b) .and. (p1b .le. p3b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,4,2,3,1,-1.0d0/4.
     &0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (p2b - noab - 1 + nvab
     & * (h6b - 1 + noab * (h5b - 1 + noab * (h4b - 1)))))))
      END IF
      IF ((p3b .le. p1b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,4,2,1,3,1.0d0/4.0
     &d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (p2b - noab - 1 + nvab
     & * (h6b - 1 + noab * (h5b - 1 + noab * (h4b - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr3_12',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr3_12',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

* $Id: destdul.f 19696 2010-10-29 16:53:42Z d3y133 $
      subroutine destdul(ikbl,nbls,nblok1,ncs,inx,buf,
     *     buffer, icfx,jcfx,kcfx,lcfx, q4, use_q4,
     *     icfg,jcfg,kcfg,lcfg,ngcd,lnijkl,indxp,ipres,iqorder,
     *     map_txs_pnl)
c----------------------------------------------------------------
c     gradient derivatives 
c     
c     This is called for PNL-requested set of contracted shell quartets.
c     Only non-zero Integrals return WITH labels and they do not have 
c     to be in PNL-requested order.
c     
c     buf           - in-comming integrals
c     
c     buffer        - outgoing integrals
c     icfx()-lcfx() - corresponding labels (PNL)
c----------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      integer map_txs_pnl(*)    ! txs to pnl basis map = ncfunct
      logical use_q4
      common /contr/ ngci,ngcj,ngck,ngcl,lci,lcj,lck,lcl,lcij,lckl
      common /lengt/ ilen,jlen,klen,llen, ilen1,jlen1,klen1,llen1
      common /neglect/ eps,eps1,epsr
      common /pnl002/ ncshell,ncfunct,nblock2,integ_n0
      common /intgop/ ncache,maxprice,iprint,iblock
c----------------------------------------------------------------------
      double precision savezerotol
      common /csavezerotol/ savezerotol ! Used in detbul,set in texas_hf
c----------------------------------------------------------------------
c     
      dimension icfx(*),jcfx(*),kcfx(*),lcfx(*)
      dimension nblok1(2,*)
      dimension buf(9,nbls,lnijkl,ngcd)
      dimension inx(12,*)
c     
cccc  dimension buffer(9,*)
      dimension buffer(12,*)
c     
      dimension icfg(*),jcfg(*),kcfg(*),lcfg(*)
      dimension ipres(*), iqorder(*)
      dimension indxp(*)
      dimension q4(*)
      dimension lder(12)        ! to re-order derivativs according to atoms
      dimension iix(4)
c
      double precision xtmp(12)
c     
      double precision threshold ! For screening output integrals
c--------------------------------
      data zero,half /0.d0,0.5d0/
c----------------------------
c     do not zero out integ_n0 here
c----------------------------
c     loop over quartets belonging to the block IKBL :
c     
c     
      do 10  ijklp=1,nbls
         ijkl=indxp(ijklp)
         if(ijkl.eq.0) go to 10
         iqreq=ipres(ijkl)
         if(iqreq.eq.0) go to 10
         iorder=iqorder(iqreq)
c     test
c     write(6,*)'destDul iorder=',iorder
c     test
         call reorder_der1(iorder,lder)
         if(use_q4) THEN
            symfact=q4(iqreq)
         else
            symfact = 1.0d0
         endif
c     
         threshold = savezerotol/symfact
c     
c---------------------------------------
c     write(6 ,1230)  ijkl,iqreq,iorder
c     1230 format('quart=',i5,' req-quart=,i5,'  iorder=',i4 )
c---------------------------------------
         ijcs=nblok1(1,ijkl)   
         klcs=nblok1(2,ijkl)  
         call get_ij_half(ijcs,ics,jcs)
         call get_ij_half(klcs,kcs,lcs)
         if(ngcd.eq.1) then
            ngcq=1
            icfg(1)=inx(11,ics)
            jcfg(1)=inx(11,jcs)
            kcfg(1)=inx(11,kcs)
            lcfg(1)=inx(11,lcs)
         else
            call indexg(inx,ics,jcs,kcs,lcs,ijcs,klcs,
     *           ilen,jlen,klen,llen, icfg,jcfg,kcfg,lcfg,ngcq)
         endif
c     
         do iqu=1,ngcq
            icff=icfg(iqu)
            jcff=jcfg(iqu)
            kcff=kcfg(iqu)
            lcff=lcfg(iqu)
            icff=map_txs_pnl(icff+1)-1 ! Relies on txs order = pnl order
            jcff=map_txs_pnl(jcff+1)-1
            kcff=map_txs_pnl(kcff+1)-1
            lcff=map_txs_pnl(lcff+1)-1
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            integ=0
            do icf=icff+1,icff+ilen
               do jcf=jcff+1,jcff+jlen
                  do kcf=kcff+1,kcff+klen
                     do lcf=lcff+1,lcff+llen
                        integ=integ+1
c------>                   xint0=buf(integ)
                        xtmp( 1)=buf(1,ijklp,integ,iqu) ! xinta
                        xtmp( 2)=buf(4,ijklp,integ,iqu) ! yinta
                        xtmp( 3)=buf(7,ijklp,integ,iqu) ! zinta
                        xtmp( 4)=buf(2,ijklp,integ,iqu) ! xintb
                        xtmp( 5)=buf(5,ijklp,integ,iqu) ! yintb
                        xtmp( 6)=buf(8,ijklp,integ,iqu) ! zintb
                        xtmp( 7)=buf(3,ijklp,integ,iqu) ! xintc
                        xtmp( 8)=buf(6,ijklp,integ,iqu) ! yintc
                        xtmp( 9)=buf(9,ijklp,integ,iqu) ! zintc
                        xnorm = 0.0d0
                        do i = 1, 9
                           xnorm = xnorm + xtmp(i)*xtmp(i)
                        enddo
                        if (xnorm .gt. threshold*threshold) then
                           xtmp(10)=-(xtmp(1)+xtmp(4)+xtmp(7))
                           xtmp(11)=-(xtmp(2)+xtmp(5)+xtmp(8))
                           xtmp(12)=-(xtmp(3)+xtmp(6)+xtmp(9))
                           integ_n0=integ_n0+1
                           do i = 1, 12
                              buffer(lder(i),integ_n0) = xtmp(i)*symfact
                           enddo
                           call lab_req(iorder,icf,jcf,kcf,lcf,iix)
c     
c---------------------------> icfx(integ_n0)=icf
c     jcfx(integ_n0)=jcf
c     kcfx(integ_n0)=kcf
c---------------------------> lcfx(integ_n0)=lcf
                           icfx(integ_n0)=iix(1)
                           jcfx(integ_n0)=iix(2)
                           kcfx(integ_n0)=iix(3)
                           lcfx(integ_n0)=iix(4)
c     
                           if(iprint.ge.2) then
                              call print_der1(ics,jcs,kcs,lcs,inx,
     *                             buf(1,ijklp,integ,iqu),
     *                             icf,jcf,kcf,lcf)
                           endif
                        endif   !   threshold
                     enddo
                  enddo
               enddo
            enddo
         enddo
c     
 10   continue
c--------------------------------------------------------
      end

*
* $Id: lcao_dnlist.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************************************
*     *															*
*     *   		   		lcao_dnlist library						*
*     *															*
*     *   Author - Eric Bylaska									*
*     *   date   - 10/09/01										*
*     *															*
*     ***********************************************************

*
*

*     ***********************************
*     *									*
*     *	       lcao_dnlist_init			*	
*     *									*
*     ***********************************
      subroutine lcao_dnlist_init(maxsize0)
      implicit none
#include "errquit.fh"
      integer maxsize0

#include "mafdecls.fh"
#include "lcao_dnlist.fh"

*     **** local variables ****
      logical value

      maxsize = maxsize0
      size    = 0

*    ***** allocate memory from heap memory ****
      value = MA_alloc_get(mt_int,(maxsize),'dnlist',
     >                     dnlist(2),dnlist(1))
      value = value.and.
     >        MA_alloc_get(mt_int,(maxsize),'dnlist_tag',
     >                     dnlist_tag(2),dnlist_tag(1))
      if (.not. value)
     > call errquit('lcao_dnlist_init: out of heap memory',0, MA_ERR)

      return
      end


*     ***********************************
*     *									*
*     *	       lcao_dnlist_end			*	
*     *									*
*     ***********************************

      subroutine lcao_dnlist_end()
      implicit none
#include "errquit.fh"
     
#include "mafdecls.fh"
#include "lcao_dnlist.fh"


*     **** local variables ****
      logical value
      integer i,mindx

      value = .true.
      do i=1,size
         mindx = int_mb(dnlist_tag(1)+i-1)
         value = value.and.MA_free_heap(mindx)
      end do
      value = value.and.MA_free_heap(dnlist_tag(2))
      value = value.and.MA_free_heap(dnlist(2))
      if (.not. value)
     > call errquit('lcao_dnlist_init: freeing heap memory',0, MA_ERR)

      size    = 0
      maxsize = 0
      return
      end

*     ***********************************
*     *									*
*     *	        lcao_dnlist_new  		*	
*     *									*
*     ***********************************
      subroutine lcao_dnlist_new(n2ft3d,index)
      implicit none
#include "errquit.fh"
      integer n2ft3d
      integer index

#include "mafdecls.fh"
#include "lcao_dnlist.fh"

*     **** local variables ****
      logical value
      integer indx,mindx

      if (size.ge.maxsize) 
     > call errquit('lcao_dnlist_new: maxsize exceeded',0, INPUT_ERR)

      value = MA_alloc_get(mt_dbl,(n2ft3d),'dn',
     >                     mindx,indx)
      if (.not.value) 
     > call errquit('lcao_dnlist_new: out of heap memory',0, MA_ERR)

      size = size + 1
      int_mb(dnlist(1)    +size-1) = indx
      int_mb(dnlist_tag(1)+size-1) = mindx

      index  = indx
      return
      end
         


*     ***********************************
*     *									*
*     *	        lcao_dnlist_get  		*	
*     *									*
*     ***********************************
      subroutine lcao_dnlist_get(count,index)
      implicit none
#include "errquit.fh"
      integer count
      integer index

#include "mafdecls.fh"
#include "lcao_dnlist.fh"

      if ((count.gt.size).or.(count.lt.1)) 
     > call errquit('lcao_dnlist_get: bad count',0, INPUT_ERR)

      index   = int_mb(dnlist(1)+count-1)
      return
      end


*     ***********************************
*     *									*
*     *	        lcao_dnlist_size 		*	
*     *									*
*     ***********************************
      integer function lcao_dnlist_size()
      implicit none

#include "lcao_dnlist.fh"

      lcao_dnlist_size = size
      return
      end

*     ***********************************
*     *									*
*     *	        lcao_dnlist_maxsize 	*	
*     *									*
*     ***********************************
      integer function lcao_dnlist_maxsize()
      implicit none

#include "lcao_dnlist.fh"

      lcao_dnlist_maxsize = maxsize
      return
      end

*     ***********************************
*     *									*
*     *	        lcao_dnlist_shift 		*	
*     *									*
*     ***********************************
      subroutine lcao_dnlist_shift()
      implicit none

#include "mafdecls.fh"
#include "lcao_dnlist.fh"

*     **** local variables ****
      integer count,indx,indxp
      integer itmp

      itmp  = int_mb(dnlist(1))
      do count=1,size-1
         indx  = dnlist(1)+count-1
         indxp = dnlist(1)+count
         int_mb(indx) = int_mb(indxp)

      end do
      indx  = dnlist(1)+size-1
      int_mb(indx) = itmp

      return
      end

C> \ingroup selci
C> @{
C>
      integer function selci_idmin(n,a,ia)
*
* $Id: idmin.f 24790 2013-11-11 18:56:49Z d3y133 $
*
      real *8 a(ia,*)
      real *8 val
c
c     return index of minimum value in array a
c
      val = a(1,1)
      ind = 1
c
      do 10 i = 1,n
         if (a(1,i).lt.val) then
            val = a(1,i)
            ind = i
         endif
10    continue
c
      selci_idmin = ind
      end
C>
C> @}

*> \brief \b DTREVC
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DTREVC + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dtrevc.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dtrevc.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dtrevc.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
*                          LDVR, MM, M, WORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          HOWMNY, SIDE
*       INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
*       ..
*       .. Array Arguments ..
*       LOGICAL            SELECT( * )
*       DOUBLE PRECISION   T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
*      $                   WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DTREVC computes some or all of the right and/or left eigenvectors of
*> a real upper quasi-triangular matrix T.
*> Matrices of this type are produced by the Schur factorization of
*> a real general matrix:  A = Q*T*Q**T, as computed by DHSEQR.
*> 
*> The right eigenvector x and the left eigenvector y of T corresponding
*> to an eigenvalue w are defined by:
*> 
*>    T*x = w*x,     (y**T)*T = w*(y**T)
*> 
*> where y**T denotes the transpose of y.
*> The eigenvalues are not input to this routine, but are read directly
*> from the diagonal blocks of T.
*> 
*> This routine returns the matrices X and/or Y of right and left
*> eigenvectors of T, or the products Q*X and/or Q*Y, where Q is an
*> input matrix.  If Q is the orthogonal factor that reduces a matrix
*> A to Schur form T, then Q*X and Q*Y are the matrices of right and
*> left eigenvectors of A.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SIDE
*> \verbatim
*>          SIDE is CHARACTER*1
*>          = 'R':  compute right eigenvectors only;
*>          = 'L':  compute left eigenvectors only;
*>          = 'B':  compute both right and left eigenvectors.
*> \endverbatim
*>
*> \param[in] HOWMNY
*> \verbatim
*>          HOWMNY is CHARACTER*1
*>          = 'A':  compute all right and/or left eigenvectors;
*>          = 'B':  compute all right and/or left eigenvectors,
*>                  backtransformed by the matrices in VR and/or VL;
*>          = 'S':  compute selected right and/or left eigenvectors,
*>                  as indicated by the logical array SELECT.
*> \endverbatim
*>
*> \param[in,out] SELECT
*> \verbatim
*>          SELECT is LOGICAL array, dimension (N)
*>          If HOWMNY = 'S', SELECT specifies the eigenvectors to be
*>          computed.
*>          If w(j) is a real eigenvalue, the corresponding real
*>          eigenvector is computed if SELECT(j) is .TRUE..
*>          If w(j) and w(j+1) are the real and imaginary parts of a
*>          complex eigenvalue, the corresponding complex eigenvector is
*>          computed if either SELECT(j) or SELECT(j+1) is .TRUE., and
*>          on exit SELECT(j) is set to .TRUE. and SELECT(j+1) is set to
*>          .FALSE..
*>          Not referenced if HOWMNY = 'A' or 'B'.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix T. N >= 0.
*> \endverbatim
*>
*> \param[in] T
*> \verbatim
*>          T is DOUBLE PRECISION array, dimension (LDT,N)
*>          The upper quasi-triangular matrix T in Schur canonical form.
*> \endverbatim
*>
*> \param[in] LDT
*> \verbatim
*>          LDT is INTEGER
*>          The leading dimension of the array T. LDT >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] VL
*> \verbatim
*>          VL is DOUBLE PRECISION array, dimension (LDVL,MM)
*>          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
*>          contain an N-by-N matrix Q (usually the orthogonal matrix Q
*>          of Schur vectors returned by DHSEQR).
*>          On exit, if SIDE = 'L' or 'B', VL contains:
*>          if HOWMNY = 'A', the matrix Y of left eigenvectors of T;
*>          if HOWMNY = 'B', the matrix Q*Y;
*>          if HOWMNY = 'S', the left eigenvectors of T specified by
*>                           SELECT, stored consecutively in the columns
*>                           of VL, in the same order as their
*>                           eigenvalues.
*>          A complex eigenvector corresponding to a complex eigenvalue
*>          is stored in two consecutive columns, the first holding the
*>          real part, and the second the imaginary part.
*>          Not referenced if SIDE = 'R'.
*> \endverbatim
*>
*> \param[in] LDVL
*> \verbatim
*>          LDVL is INTEGER
*>          The leading dimension of the array VL.  LDVL >= 1, and if
*>          SIDE = 'L' or 'B', LDVL >= N.
*> \endverbatim
*>
*> \param[in,out] VR
*> \verbatim
*>          VR is DOUBLE PRECISION array, dimension (LDVR,MM)
*>          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
*>          contain an N-by-N matrix Q (usually the orthogonal matrix Q
*>          of Schur vectors returned by DHSEQR).
*>          On exit, if SIDE = 'R' or 'B', VR contains:
*>          if HOWMNY = 'A', the matrix X of right eigenvectors of T;
*>          if HOWMNY = 'B', the matrix Q*X;
*>          if HOWMNY = 'S', the right eigenvectors of T specified by
*>                           SELECT, stored consecutively in the columns
*>                           of VR, in the same order as their
*>                           eigenvalues.
*>          A complex eigenvector corresponding to a complex eigenvalue
*>          is stored in two consecutive columns, the first holding the
*>          real part and the second the imaginary part.
*>          Not referenced if SIDE = 'L'.
*> \endverbatim
*>
*> \param[in] LDVR
*> \verbatim
*>          LDVR is INTEGER
*>          The leading dimension of the array VR.  LDVR >= 1, and if
*>          SIDE = 'R' or 'B', LDVR >= N.
*> \endverbatim
*>
*> \param[in] MM
*> \verbatim
*>          MM is INTEGER
*>          The number of columns in the arrays VL and/or VR. MM >= M.
*> \endverbatim
*>
*> \param[out] M
*> \verbatim
*>          M is INTEGER
*>          The number of columns in the arrays VL and/or VR actually
*>          used to store the eigenvectors.
*>          If HOWMNY = 'A' or 'B', M is set to N.
*>          Each selected real eigenvector occupies one column and each
*>          selected complex eigenvector occupies two columns.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (3*N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup doubleOTHERcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The algorithm used in this program is basically backward (forward)
*>  substitution, with scaling to make the the code robust against
*>  possible overflow.
*>
*>  Each eigenvector is normalized so that the element of largest
*>  magnitude has magnitude 1; here the magnitude of a complex number
*>  (x,y) is taken to be |x| + |y|.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, MM, M, WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      DOUBLE PRECISION   T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLV, BOTHV, LEFTV, OVER, PAIR, RIGHTV, SOMEV
      INTEGER            I, IERR, II, IP, IS, J, J1, J2, JNXT, K, KI, N2
      DOUBLE PRECISION   BETA, BIGNUM, EMAX, OVFL, REC, REMAX, SCALE,
     $                   SMIN, SMLNUM, ULP, UNFL, VCRIT, VMAX, WI, WR,
     $                   XNORM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX
      DOUBLE PRECISION   DDOT, DLAMCH
      EXTERNAL           LSAME, IDAMAX, DDOT, DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DCOPY, DGEMV, DLALN2, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SQRT
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   X( 2, 2 )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      BOTHV = LSAME( SIDE, 'B' )
      RIGHTV = LSAME( SIDE, 'R' ) .OR. BOTHV
      LEFTV = LSAME( SIDE, 'L' ) .OR. BOTHV
*
      ALLV = LSAME( HOWMNY, 'A' )
      OVER = LSAME( HOWMNY, 'B' )
      SOMEV = LSAME( HOWMNY, 'S' )
*
      INFO = 0
      IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -1
      ELSE IF( .NOT.ALLV .AND. .NOT.OVER .AND. .NOT.SOMEV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( LEFTV .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( RIGHTV .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE
*
*        Set M to the number of columns required to store the selected
*        eigenvectors, standardize the array SELECT if necessary, and
*        test MM.
*
         IF( SOMEV ) THEN
            M = 0
            PAIR = .FALSE.
            DO 10 J = 1, N
               IF( PAIR ) THEN
                  PAIR = .FALSE.
                  SELECT( J ) = .FALSE.
               ELSE
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).EQ.ZERO ) THEN
                        IF( SELECT( J ) )
     $                     M = M + 1
                     ELSE
                        PAIR = .TRUE.
                        IF( SELECT( J ) .OR. SELECT( J+1 ) ) THEN
                           SELECT( J ) = .TRUE.
                           M = M + 2
                        END IF
                     END IF
                  ELSE
                     IF( SELECT( N ) )
     $                  M = M + 1
                  END IF
               END IF
   10       CONTINUE
         ELSE
            M = N
         END IF
*
         IF( MM.LT.M ) THEN
            INFO = -11
         END IF
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DTREVC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set the constants to control overflow.
*
      UNFL = DLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL DLABAD( UNFL, OVFL )
      ULP = DLAMCH( 'Precision' )
      SMLNUM = UNFL*( N / ULP )
      BIGNUM = ( ONE-ULP ) / SMLNUM
*
*     Compute 1-norm of each column of strictly upper triangular
*     part of T to control overflow in triangular solver.
*
      WORK( 1 ) = ZERO
      DO 30 J = 2, N
         WORK( J ) = ZERO
         DO 20 I = 1, J - 1
            WORK( J ) = WORK( J ) + ABS( T( I, J ) )
   20    CONTINUE
   30 CONTINUE
*
*     Index IP is used to specify the real or complex eigenvalue:
*       IP = 0, real eigenvalue,
*            1, first of conjugate complex pair: (wr,wi)
*           -1, second of conjugate complex pair: (wr,wi)
*
      N2 = 2*N
*
      IF( RIGHTV ) THEN
*
*        Compute right eigenvectors.
*
         IP = 0
         IS = M
         DO 140 KI = N, 1, -1
*
            IF( IP.EQ.1 )
     $         GO TO 130
            IF( KI.EQ.1 )
     $         GO TO 40
            IF( T( KI, KI-1 ).EQ.ZERO )
     $         GO TO 40
            IP = -1
*
   40       CONTINUE
            IF( SOMEV ) THEN
               IF( IP.EQ.0 ) THEN
                  IF( .NOT.SELECT( KI ) )
     $               GO TO 130
               ELSE
                  IF( .NOT.SELECT( KI-1 ) )
     $               GO TO 130
               END IF
            END IF
*
*           Compute the KI-th eigenvalue (WR,WI).
*
            WR = T( KI, KI )
            WI = ZERO
            IF( IP.NE.0 )
     $         WI = SQRT( ABS( T( KI, KI-1 ) ) )*
     $              SQRT( ABS( T( KI-1, KI ) ) )
            SMIN = MAX( ULP*( ABS( WR )+ABS( WI ) ), SMLNUM )
*
            IF( IP.EQ.0 ) THEN
*
*              Real right eigenvector
*
               WORK( KI+N ) = ONE
*
*              Form right-hand side
*
               DO 50 K = 1, KI - 1
                  WORK( K+N ) = -T( K, KI )
   50          CONTINUE
*
*              Solve the upper quasi-triangular system:
*                 (T(1:KI-1,1:KI-1) - WR)*X = SCALE*WORK.
*
               JNXT = KI - 1
               DO 60 J = KI - 1, 1, -1
                  IF( J.GT.JNXT )
     $               GO TO 60
                  J1 = J
                  J2 = J
                  JNXT = J - 1
                  IF( J.GT.1 ) THEN
                     IF( T( J, J-1 ).NE.ZERO ) THEN
                        J1 = J - 1
                        JNXT = J - 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
                     CALL DLALN2( .FALSE., 1, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale X(1,1) to avoid overflow when updating
*                    the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        IF( WORK( J ).GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL DSCAL( KI, SCALE, WORK( 1+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
*
*                    Update right-hand side
*
                     CALL DAXPY( J-1, -X( 1, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
*
                  ELSE
*
*                    2-by-2 diagonal block
*
                     CALL DLALN2( .FALSE., 2, 1, SMIN, ONE,
     $                            T( J-1, J-1 ), LDT, ONE, ONE,
     $                            WORK( J-1+N ), N, WR, ZERO, X, 2,
     $                            SCALE, XNORM, IERR )
*
*                    Scale X(1,1) and X(2,1) to avoid overflow when
*                    updating the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        BETA = MAX( WORK( J-1 ), WORK( J ) )
                        IF( BETA.GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           X( 2, 1 ) = X( 2, 1 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL DSCAL( KI, SCALE, WORK( 1+N ), 1 )
                     WORK( J-1+N ) = X( 1, 1 )
                     WORK( J+N ) = X( 2, 1 )
*
*                    Update right-hand side
*
                     CALL DAXPY( J-2, -X( 1, 1 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL DAXPY( J-2, -X( 2, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                  END IF
   60          CONTINUE
*
*              Copy the vector x or Q*x to VR and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL DCOPY( KI, WORK( 1+N ), 1, VR( 1, IS ), 1 )
*
                  II = IDAMAX( KI, VR( 1, IS ), 1 )
                  REMAX = ONE / ABS( VR( II, IS ) )
                  CALL DSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
                  DO 70 K = KI + 1, N
                     VR( K, IS ) = ZERO
   70             CONTINUE
               ELSE
                  IF( KI.GT.1 )
     $               CALL DGEMV( 'N', N, KI-1, ONE, VR, LDVR,
     $                           WORK( 1+N ), 1, WORK( KI+N ),
     $                           VR( 1, KI ), 1 )
*
                  II = IDAMAX( N, VR( 1, KI ), 1 )
                  REMAX = ONE / ABS( VR( II, KI ) )
                  CALL DSCAL( N, REMAX, VR( 1, KI ), 1 )
               END IF
*
            ELSE
*
*              Complex right eigenvector.
*
*              Initial solve
*                [ (T(KI-1,KI-1) T(KI-1,KI) ) - (WR + I* WI)]*X = 0.
*                [ (T(KI,KI-1)   T(KI,KI)   )               ]
*
               IF( ABS( T( KI-1, KI ) ).GE.ABS( T( KI, KI-1 ) ) ) THEN
                  WORK( KI-1+N ) = ONE
                  WORK( KI+N2 ) = WI / T( KI-1, KI )
               ELSE
                  WORK( KI-1+N ) = -WI / T( KI, KI-1 )
                  WORK( KI+N2 ) = ONE
               END IF
               WORK( KI+N ) = ZERO
               WORK( KI-1+N2 ) = ZERO
*
*              Form right-hand side
*
               DO 80 K = 1, KI - 2
                  WORK( K+N ) = -WORK( KI-1+N )*T( K, KI-1 )
                  WORK( K+N2 ) = -WORK( KI+N2 )*T( K, KI )
   80          CONTINUE
*
*              Solve upper quasi-triangular system:
*              (T(1:KI-2,1:KI-2) - (WR+i*WI))*X = SCALE*(WORK+i*WORK2)
*
               JNXT = KI - 2
               DO 90 J = KI - 2, 1, -1
                  IF( J.GT.JNXT )
     $               GO TO 90
                  J1 = J
                  J2 = J
                  JNXT = J - 1
                  IF( J.GT.1 ) THEN
                     IF( T( J, J-1 ).NE.ZERO ) THEN
                        J1 = J - 1
                        JNXT = J - 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
                     CALL DLALN2( .FALSE., 1, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR, WI,
     $                            X, 2, SCALE, XNORM, IERR )
*
*                    Scale X(1,1) and X(1,2) to avoid overflow when
*                    updating the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        IF( WORK( J ).GT.BIGNUM / XNORM ) THEN
                           X( 1, 1 ) = X( 1, 1 ) / XNORM
                           X( 1, 2 ) = X( 1, 2 ) / XNORM
                           SCALE = SCALE / XNORM
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL DSCAL( KI, SCALE, WORK( 1+N ), 1 )
                        CALL DSCAL( KI, SCALE, WORK( 1+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
*
*                    Update the right-hand side
*
                     CALL DAXPY( J-1, -X( 1, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL DAXPY( J-1, -X( 1, 2 ), T( 1, J ), 1,
     $                           WORK( 1+N2 ), 1 )
*
                  ELSE
*
*                    2-by-2 diagonal block
*
                     CALL DLALN2( .FALSE., 2, 2, SMIN, ONE,
     $                            T( J-1, J-1 ), LDT, ONE, ONE,
     $                            WORK( J-1+N ), N, WR, WI, X, 2, SCALE,
     $                            XNORM, IERR )
*
*                    Scale X to avoid overflow when updating
*                    the right-hand side.
*
                     IF( XNORM.GT.ONE ) THEN
                        BETA = MAX( WORK( J-1 ), WORK( J ) )
                        IF( BETA.GT.BIGNUM / XNORM ) THEN
                           REC = ONE / XNORM
                           X( 1, 1 ) = X( 1, 1 )*REC
                           X( 1, 2 ) = X( 1, 2 )*REC
                           X( 2, 1 ) = X( 2, 1 )*REC
                           X( 2, 2 ) = X( 2, 2 )*REC
                           SCALE = SCALE*REC
                        END IF
                     END IF
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL DSCAL( KI, SCALE, WORK( 1+N ), 1 )
                        CALL DSCAL( KI, SCALE, WORK( 1+N2 ), 1 )
                     END IF
                     WORK( J-1+N ) = X( 1, 1 )
                     WORK( J+N ) = X( 2, 1 )
                     WORK( J-1+N2 ) = X( 1, 2 )
                     WORK( J+N2 ) = X( 2, 2 )
*
*                    Update the right-hand side
*
                     CALL DAXPY( J-2, -X( 1, 1 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL DAXPY( J-2, -X( 2, 1 ), T( 1, J ), 1,
     $                           WORK( 1+N ), 1 )
                     CALL DAXPY( J-2, -X( 1, 2 ), T( 1, J-1 ), 1,
     $                           WORK( 1+N2 ), 1 )
                     CALL DAXPY( J-2, -X( 2, 2 ), T( 1, J ), 1,
     $                           WORK( 1+N2 ), 1 )
                  END IF
   90          CONTINUE
*
*              Copy the vector x or Q*x to VR and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL DCOPY( KI, WORK( 1+N ), 1, VR( 1, IS-1 ), 1 )
                  CALL DCOPY( KI, WORK( 1+N2 ), 1, VR( 1, IS ), 1 )
*
                  EMAX = ZERO
                  DO 100 K = 1, KI
                     EMAX = MAX( EMAX, ABS( VR( K, IS-1 ) )+
     $                      ABS( VR( K, IS ) ) )
  100             CONTINUE
*
                  REMAX = ONE / EMAX
                  CALL DSCAL( KI, REMAX, VR( 1, IS-1 ), 1 )
                  CALL DSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
                  DO 110 K = KI + 1, N
                     VR( K, IS-1 ) = ZERO
                     VR( K, IS ) = ZERO
  110             CONTINUE
*
               ELSE
*
                  IF( KI.GT.2 ) THEN
                     CALL DGEMV( 'N', N, KI-2, ONE, VR, LDVR,
     $                           WORK( 1+N ), 1, WORK( KI-1+N ),
     $                           VR( 1, KI-1 ), 1 )
                     CALL DGEMV( 'N', N, KI-2, ONE, VR, LDVR,
     $                           WORK( 1+N2 ), 1, WORK( KI+N2 ),
     $                           VR( 1, KI ), 1 )
                  ELSE
                     CALL DSCAL( N, WORK( KI-1+N ), VR( 1, KI-1 ), 1 )
                     CALL DSCAL( N, WORK( KI+N2 ), VR( 1, KI ), 1 )
                  END IF
*
                  EMAX = ZERO
                  DO 120 K = 1, N
                     EMAX = MAX( EMAX, ABS( VR( K, KI-1 ) )+
     $                      ABS( VR( K, KI ) ) )
  120             CONTINUE
                  REMAX = ONE / EMAX
                  CALL DSCAL( N, REMAX, VR( 1, KI-1 ), 1 )
                  CALL DSCAL( N, REMAX, VR( 1, KI ), 1 )
               END IF
            END IF
*
            IS = IS - 1
            IF( IP.NE.0 )
     $         IS = IS - 1
  130       CONTINUE
            IF( IP.EQ.1 )
     $         IP = 0
            IF( IP.EQ.-1 )
     $         IP = 1
  140    CONTINUE
      END IF
*
      IF( LEFTV ) THEN
*
*        Compute left eigenvectors.
*
         IP = 0
         IS = 1
         DO 260 KI = 1, N
*
            IF( IP.EQ.-1 )
     $         GO TO 250
            IF( KI.EQ.N )
     $         GO TO 150
            IF( T( KI+1, KI ).EQ.ZERO )
     $         GO TO 150
            IP = 1
*
  150       CONTINUE
            IF( SOMEV ) THEN
               IF( .NOT.SELECT( KI ) )
     $            GO TO 250
            END IF
*
*           Compute the KI-th eigenvalue (WR,WI).
*
            WR = T( KI, KI )
            WI = ZERO
            IF( IP.NE.0 )
     $         WI = SQRT( ABS( T( KI, KI+1 ) ) )*
     $              SQRT( ABS( T( KI+1, KI ) ) )
            SMIN = MAX( ULP*( ABS( WR )+ABS( WI ) ), SMLNUM )
*
            IF( IP.EQ.0 ) THEN
*
*              Real left eigenvector.
*
               WORK( KI+N ) = ONE
*
*              Form right-hand side
*
               DO 160 K = KI + 1, N
                  WORK( K+N ) = -T( KI, K )
  160          CONTINUE
*
*              Solve the quasi-triangular system:
*                 (T(KI+1:N,KI+1:N) - WR)**T*X = SCALE*WORK
*
               VMAX = ONE
               VCRIT = BIGNUM
*
               JNXT = KI + 1
               DO 170 J = KI + 1, N
                  IF( J.LT.JNXT )
     $               GO TO 170
                  J1 = J
                  J2 = J
                  JNXT = J + 1
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).NE.ZERO ) THEN
                        J2 = J + 1
                        JNXT = J + 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side.
*
                     IF( WORK( J ).GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL DSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             DDOT( J-KI-1, T( KI+1, J ), 1,
     $                             WORK( KI+1+N ), 1 )
*
*                    Solve (T(J,J)-WR)**T*X = WORK
*
                     CALL DLALN2( .FALSE., 1, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL DSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
                     VMAX = MAX( ABS( WORK( J+N ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  ELSE
*
*                    2-by-2 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side.
*
                     BETA = MAX( WORK( J ), WORK( J+1 ) )
                     IF( BETA.GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL DSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             DDOT( J-KI-1, T( KI+1, J ), 1,
     $                             WORK( KI+1+N ), 1 )
*
                     WORK( J+1+N ) = WORK( J+1+N ) -
     $                               DDOT( J-KI-1, T( KI+1, J+1 ), 1,
     $                               WORK( KI+1+N ), 1 )
*
*                    Solve
*                      [T(J,J)-WR   T(J,J+1)     ]**T * X = SCALE*( WORK1 )
*                      [T(J+1,J)    T(J+1,J+1)-WR]                ( WORK2 )
*
                     CALL DLALN2( .TRUE., 2, 1, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            ZERO, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE )
     $                  CALL DSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+1+N ) = X( 2, 1 )
*
                     VMAX = MAX( ABS( WORK( J+N ) ),
     $                      ABS( WORK( J+1+N ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  END IF
  170          CONTINUE
*
*              Copy the vector x or Q*x to VL and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL DCOPY( N-KI+1, WORK( KI+N ), 1, VL( KI, IS ), 1 )
*
                  II = IDAMAX( N-KI+1, VL( KI, IS ), 1 ) + KI - 1
                  REMAX = ONE / ABS( VL( II, IS ) )
                  CALL DSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
*
                  DO 180 K = 1, KI - 1
                     VL( K, IS ) = ZERO
  180             CONTINUE
*
               ELSE
*
                  IF( KI.LT.N )
     $               CALL DGEMV( 'N', N, N-KI, ONE, VL( 1, KI+1 ), LDVL,
     $                           WORK( KI+1+N ), 1, WORK( KI+N ),
     $                           VL( 1, KI ), 1 )
*
                  II = IDAMAX( N, VL( 1, KI ), 1 )
                  REMAX = ONE / ABS( VL( II, KI ) )
                  CALL DSCAL( N, REMAX, VL( 1, KI ), 1 )
*
               END IF
*
            ELSE
*
*              Complex left eigenvector.
*
*               Initial solve:
*                 ((T(KI,KI)    T(KI,KI+1) )**T - (WR - I* WI))*X = 0.
*                 ((T(KI+1,KI) T(KI+1,KI+1))                )
*
               IF( ABS( T( KI, KI+1 ) ).GE.ABS( T( KI+1, KI ) ) ) THEN
                  WORK( KI+N ) = WI / T( KI, KI+1 )
                  WORK( KI+1+N2 ) = ONE
               ELSE
                  WORK( KI+N ) = ONE
                  WORK( KI+1+N2 ) = -WI / T( KI+1, KI )
               END IF
               WORK( KI+1+N ) = ZERO
               WORK( KI+N2 ) = ZERO
*
*              Form right-hand side
*
               DO 190 K = KI + 2, N
                  WORK( K+N ) = -WORK( KI+N )*T( KI, K )
                  WORK( K+N2 ) = -WORK( KI+1+N2 )*T( KI+1, K )
  190          CONTINUE
*
*              Solve complex quasi-triangular system:
*              ( T(KI+2,N:KI+2,N) - (WR-i*WI) )*X = WORK1+i*WORK2
*
               VMAX = ONE
               VCRIT = BIGNUM
*
               JNXT = KI + 2
               DO 200 J = KI + 2, N
                  IF( J.LT.JNXT )
     $               GO TO 200
                  J1 = J
                  J2 = J
                  JNXT = J + 1
                  IF( J.LT.N ) THEN
                     IF( T( J+1, J ).NE.ZERO ) THEN
                        J2 = J + 1
                        JNXT = J + 2
                     END IF
                  END IF
*
                  IF( J1.EQ.J2 ) THEN
*
*                    1-by-1 diagonal block
*
*                    Scale if necessary to avoid overflow when
*                    forming the right-hand side elements.
*
                     IF( WORK( J ).GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL DSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        CALL DSCAL( N-KI+1, REC, WORK( KI+N2 ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             DDOT( J-KI-2, T( KI+2, J ), 1,
     $                             WORK( KI+2+N ), 1 )
                     WORK( J+N2 ) = WORK( J+N2 ) -
     $                              DDOT( J-KI-2, T( KI+2, J ), 1,
     $                              WORK( KI+2+N2 ), 1 )
*
*                    Solve (T(J,J)-(WR-i*WI))*(X11+i*X12)= WK+I*WK2
*
                     CALL DLALN2( .FALSE., 1, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            -WI, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL DSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                        CALL DSCAL( N-KI+1, SCALE, WORK( KI+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
                     VMAX = MAX( ABS( WORK( J+N ) ),
     $                      ABS( WORK( J+N2 ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  ELSE
*
*                    2-by-2 diagonal block
*
*                    Scale if necessary to avoid overflow when forming
*                    the right-hand side elements.
*
                     BETA = MAX( WORK( J ), WORK( J+1 ) )
                     IF( BETA.GT.VCRIT ) THEN
                        REC = ONE / VMAX
                        CALL DSCAL( N-KI+1, REC, WORK( KI+N ), 1 )
                        CALL DSCAL( N-KI+1, REC, WORK( KI+N2 ), 1 )
                        VMAX = ONE
                        VCRIT = BIGNUM
                     END IF
*
                     WORK( J+N ) = WORK( J+N ) -
     $                             DDOT( J-KI-2, T( KI+2, J ), 1,
     $                             WORK( KI+2+N ), 1 )
*
                     WORK( J+N2 ) = WORK( J+N2 ) -
     $                              DDOT( J-KI-2, T( KI+2, J ), 1,
     $                              WORK( KI+2+N2 ), 1 )
*
                     WORK( J+1+N ) = WORK( J+1+N ) -
     $                               DDOT( J-KI-2, T( KI+2, J+1 ), 1,
     $                               WORK( KI+2+N ), 1 )
*
                     WORK( J+1+N2 ) = WORK( J+1+N2 ) -
     $                                DDOT( J-KI-2, T( KI+2, J+1 ), 1,
     $                                WORK( KI+2+N2 ), 1 )
*
*                    Solve 2-by-2 complex linear equation
*                      ([T(j,j)   T(j,j+1)  ]**T-(wr-i*wi)*I)*X = SCALE*B
*                      ([T(j+1,j) T(j+1,j+1)]               )
*
                     CALL DLALN2( .TRUE., 2, 2, SMIN, ONE, T( J, J ),
     $                            LDT, ONE, ONE, WORK( J+N ), N, WR,
     $                            -WI, X, 2, SCALE, XNORM, IERR )
*
*                    Scale if necessary
*
                     IF( SCALE.NE.ONE ) THEN
                        CALL DSCAL( N-KI+1, SCALE, WORK( KI+N ), 1 )
                        CALL DSCAL( N-KI+1, SCALE, WORK( KI+N2 ), 1 )
                     END IF
                     WORK( J+N ) = X( 1, 1 )
                     WORK( J+N2 ) = X( 1, 2 )
                     WORK( J+1+N ) = X( 2, 1 )
                     WORK( J+1+N2 ) = X( 2, 2 )
                     VMAX = MAX( ABS( X( 1, 1 ) ), ABS( X( 1, 2 ) ),
     $                      ABS( X( 2, 1 ) ), ABS( X( 2, 2 ) ), VMAX )
                     VCRIT = BIGNUM / VMAX
*
                  END IF
  200          CONTINUE
*
*              Copy the vector x or Q*x to VL and normalize.
*
               IF( .NOT.OVER ) THEN
                  CALL DCOPY( N-KI+1, WORK( KI+N ), 1, VL( KI, IS ), 1 )
                  CALL DCOPY( N-KI+1, WORK( KI+N2 ), 1, VL( KI, IS+1 ),
     $                        1 )
*
                  EMAX = ZERO
                  DO 220 K = KI, N
                     EMAX = MAX( EMAX, ABS( VL( K, IS ) )+
     $                      ABS( VL( K, IS+1 ) ) )
  220             CONTINUE
                  REMAX = ONE / EMAX
                  CALL DSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
                  CALL DSCAL( N-KI+1, REMAX, VL( KI, IS+1 ), 1 )
*
                  DO 230 K = 1, KI - 1
                     VL( K, IS ) = ZERO
                     VL( K, IS+1 ) = ZERO
  230             CONTINUE
               ELSE
                  IF( KI.LT.N-1 ) THEN
                     CALL DGEMV( 'N', N, N-KI-1, ONE, VL( 1, KI+2 ),
     $                           LDVL, WORK( KI+2+N ), 1, WORK( KI+N ),
     $                           VL( 1, KI ), 1 )
                     CALL DGEMV( 'N', N, N-KI-1, ONE, VL( 1, KI+2 ),
     $                           LDVL, WORK( KI+2+N2 ), 1,
     $                           WORK( KI+1+N2 ), VL( 1, KI+1 ), 1 )
                  ELSE
                     CALL DSCAL( N, WORK( KI+N ), VL( 1, KI ), 1 )
                     CALL DSCAL( N, WORK( KI+1+N2 ), VL( 1, KI+1 ), 1 )
                  END IF
*
                  EMAX = ZERO
                  DO 240 K = 1, N
                     EMAX = MAX( EMAX, ABS( VL( K, KI ) )+
     $                      ABS( VL( K, KI+1 ) ) )
  240             CONTINUE
                  REMAX = ONE / EMAX
                  CALL DSCAL( N, REMAX, VL( 1, KI ), 1 )
                  CALL DSCAL( N, REMAX, VL( 1, KI+1 ), 1 )
*
               END IF
*
            END IF
*
            IS = IS + 1
            IF( IP.NE.0 )
     $         IS = IS + 1
  250       CONTINUE
            IF( IP.EQ.-1 )
     $         IP = 0
            IF( IP.EQ.1 )
     $         IP = -1
*
  260    CONTINUE
*
      END IF
*
      RETURN
*
*     End of DTREVC
*
      END
c $Id: dtrevc.f 24343 2013-06-22 05:35:15Z d3y133 $

c
c $Id: hnd_vstat.F 19696 2010-10-29 16:53:42Z d3y133 $
c
c Modified from HONDO
c
      subroutine hnd_vstat(xyzi,expi,coefi,i_nprim,i_ngen, Li, 
     1     xyzj,expj,coefj, j_nprim, j_ngen, Lj, 
     1     xyz,zan,nat,dens,s,ti,vi,lstv,doS,doT,doV,scr,lscr)
c
c This is a wrapper routine, setting up scratch blocks used in actual
c integral routine
c
      implicit none
c
      integer i_nprim           ! [input] num. prims on function i
      integer i_ngen            ! [input] num general conts on func. i
      integer Li                ! [input] angular momentum of func. i
      integer j_nprim           ! [input] num. prims on function j
      integer j_ngen            ! [input] num general conts on func. j
      integer Lj                ! [input] angular momentum of func. j
      integer nat               ! [input] number of atoms
      integer lscr              ! [input] size of scratch array
      integer lstv              ! [input] size of any integral buffer
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim) ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen) ! [input] j coeffs
      double precision xyz(3,nat) ! [input] all atom positions
      double precision zan(nat) ! [input] charges on all atoms
      double precision dens(*)  ! [input] (transition)density 
      double precision scr(lscr) ! [scratch] scratch buffers
      double precision s(lstv)  ! [output] overlap integrals
      double precision ti(lstv) ! [output] kinetic energy integrals
      double precision vi(lstv) ! [output] potential integrals
      logical doS               ! [input] compute overlap (True/False)
      logical doT               ! [input] compute kinetic (True/False)
      logical doV               ! [input] compute potential (True/False)
c
      integer ss,st,tt,tv,vv, dd
c
c Use scratch for temps in integral calculation
c Scratch needs are dependent on integral types:
c doS : 3*(Li+1)*(Lj+3)
c doT : 3*(Li+1)*(Lj+3)+3*(Li+1)*(Lj+1)
c doV : 3*(Li+1)*(Lj+1)*((Li+Lj)/2+1)
c
      ss = 0
      tt = 0
      vv = 0
      st = 1
      tv = 1
      dd = (Li+1)*(Li+2)*(Lj+1)*(Lj+2)/4
      if (doS.or.doT) then
         ss = dd + (Li+1) * (Lj+3)
         st = st + 3 * ss
         if (doV) tv = st
         if (doT) then
            tt = (Li+1) * (Lj+1)
            if (doV) tv = tv + 3 * tt
         endif
      endif
      if (doV) vv = (Li+1) * (Lj+1) * ((Li+Lj)/2+1)
c
      call hnd_vstat1(xyzi,expi,coefi,i_nprim,i_ngen, Li, 
     1     xyzj,expj,coefj, j_nprim, j_ngen, Lj, 
     1     xyz,zan,nat,dens,s,ti,vi,lstv,doS,doT,doV,scr(1),
     3     scr(1+dd),scr(1+ss),scr(1+2*ss),scr(st),scr(st+tt),
     4     scr(st+2*tt),scr(tv),scr(tv+vv),scr(tv+2*vv))
c
      return
      end
c
      subroutine hnd_vstat1(xyzi,expi,coefi,i_nprim,i_ngen, Li, 
     1     xyzj,expj,coefj, j_nprim, j_ngen, Lj, 
     1     xyz,zan,nat,dens,s,ti,vi,lstv,doS,doT,doV,dij,
     1     xs,ys,zs,xt,yt,zt,xv,yv,zv)
c     
      implicit none
#include "stdio.fh"
#include "hnd_rys.fh"
#include "hnd_tol.fh"
#include "errquit.fh"
      integer i_nprim           ! [input] num. prims on function i
      integer i_ngen            ! [input] num general conts on func. i
      integer Li                ! [input] angular momentum of func. i
      integer j_nprim           ! [input] num. prims on function j
      integer j_ngen            ! [input] num general conts on func. j
      integer Lj                ! [input] angular momentum of func. j
      integer nat               ! [input] number of atoms
      integer lscr              ! [input] size of scratch array
      integer lstv              ! [input] size of any integral buffer
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim) ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen) ! [input] j coeffs
      double precision xyz(3,nat) ! [input] all atom positions
      double precision zan(nat) ! [input] charges on all atoms
      double precision dens(*)  ! [input] (transition)density 
      double precision s(lstv)  ! [output] overlap integrals
      double precision ti(lstv) ! [output] kinetic energy integrals
      double precision vi(lstv) ! [output] potential integrals
      logical doS               ! [input] compute overlap (True/False)
      logical doT               ! [input] compute kinetic (True/False)
      logical doV               ! [input] compute potential (True/False)
      double precision tol, aa, aa1, rr, ai, arri, axi, ayi, azi
      double precision csi, cpi, cdi, cfi, cgi, aj, fac
      double precision csj, cpj, cdj, cfj, cgj, ax, ay, az
      double precision xs, ys, zs, xt, yt, zt, dum, dum1, dum2
      double precision xint, yint, zint, t, x0, y0, z0, xi, yi, zi 
      double precision xj, yj, zj, ccx, ccy, ccz 
      double precision rln10, zero, one, pi212
      double precision aax, aay, aaz, znuc, cx, cy, cz, uu, ww, tt
      double precision xv, yv, zv, dij
      integer lit, ljt, maxi, maxj, ljtmod, jg
      integer ijx, ijy, ijz, ij, i, j
      integer ni, nj, ig, ic, iroot
      integer ix, iy, iz, jx, jy, jz, Nxyz(3)
      logical some
      common/hnd_xyzder/xint,yint,zint,t,x0,y0,z0,xi,yi,zi,xj,yj,zj,
     1     ni,nj,ccx,ccy,ccz
      dimension xs(Li+1,Lj+3)  ,ys(Li+1,Lj+3)  ,zs(Li+1,Lj+3)
      dimension xt(Li+1,Lj+1)  ,yt(Li+1,Lj+1)  ,zt(Li+1,Lj+1)
      dimension xv(Li+1,Lj+1,*),yv(Li+1,Lj+1,*),zv(Li+1,Lj+1,*)
      dimension dij(*)
      data rln10  /2.30258d+00/
      data zero   /0.0d+00/
      data one    /1.0d+00/
      data pi212  /1.1283791670955d+00/
c    
c      write(*,*)"basis function information" 
c      write(*,*)"xyz=", xyz, xyzi,xyzj
c      write(*,*)"expi,coefi,i_nprim,i_ngen, Li", 
c     &     expi, coefi,i_nprim,i_ngen, Li
c      write(*,*)"expj,coefj,j_nprim,j_ngen, Lj", 
c     &     expj, coefj,j_nprim,j_ngen, Lj
      
c      write(*,*)"vints in hnd_vstat, before"
c      write(*,"(4f12.8)")((xyz(ig,jg),ig=1,3),vi(jg),jg=1,nat)
c
      tol=rln10*itol
c     
c     ----- calculate -s-, -t-, and -v- integrals -----
c     
      some = .false.
      if(some) write(luout,9999)
c     
c     ----- ishell -----
c     
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi=lit*(lit+1)/2
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj=ljt*(ljt+1)/2
      ljtmod=ljt+2
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
      nroots=(lit+ljt-2)/2+1
      if(nroots.gt.maxrys) then
         write(luout,9997) maxrys,lit,ljt,nroots
         call errquit('hnd_stvint: angular momentum too high',555,
     &       INT_ERR)
      endif
c
      if (doS) call dcopy(lstv,zero,0,s,1)
      if (doT) call dcopy(lstv,zero,0,ti,1)
c
c      if (doV) call dcopy(lstv,zero,0,vi,1)
c
c     do not fill vi with zero's since the contributions are summed over 
c     all basis pairs
c
c     ----- i primitive -----
c
      do 7000 ig=1,i_nprim
         ai=expi(ig)
         arri=ai*rr
         axi=ai*xi
         ayi=ai*yi
         azi=ai*zi
         csi=coefi(ig,i_ngen)
c     
c     ----- j primitive -----
c     
         do 6000 jg=1,j_nprim
            aj=expj(jg)
            aa=ai+aj
            aa1=one/aa
            dum=aj*arri*aa1
            if(dum.gt.tol) go to 6000 ! the integral is zero
            fac= exp(-dum)
            csj=coefj(jg,j_ngen)
            ax=(axi+aj*xj)*aa1
            ay=(ayi+aj*yj)*aa1
            az=(azi+aj*zj)*aa1
c     
c     ----- density factor -----
c     
            ij=0
            dum2=fac*csi*csj
            do 3600 i=1,maxi
               do 360 j=1,maxj
                  ij=ij+1
                  dij(ij)=dum2*dens(ij)
 360           continue
 3600       continue
c     
c     ----- overlap and kinetic energy -----
c     
            if (doS.or.doT) then
            t = sqrt(aa1)
            x0=ax
            y0=ay
            z0=az
            do 3700 j=1,ljtmod
               nj=j
               do 370 i=1,lit
                  ni=i
                  call hnd_sxyz
                  xs(i,j)=xint*t
                  ys(i,j)=yint*t
                  zs(i,j)=zint*t
 370           continue
 3700       continue
c
            if (doT) call hnd_txyz(xt,yt,zt,xs,ys,zs,lit,ljt,aj)
c     
            ij=0
            do 390 i=1,maxi
               call getNxyz(Li,i,Nxyz)
               ix = Nxyz(1) + 1
               iy = Nxyz(2) + 1
               iz = Nxyz(3) + 1
               do 380 j=1,maxj
                  call getNxyz(Lj,j,Nxyz)
                  jx = Nxyz(1) + 1
                  jy = Nxyz(2) + 1
                  jz = Nxyz(3) + 1
                  ij=ij+1
                  dum =xs(ix,jx)*ys(iy,jy)*zs(iz,jz)
                  if (doS) s(ij)= s(ij)+ dum*dij(ij)
                  if (doT) then
                     dum =xt(ix,jx)*ys(iy,jy)*zs(iz,jz)
     1                    +xs(ix,jx)*yt(iy,jy)*zs(iz,jz)
     2                    +xs(ix,jx)*ys(iy,jy)*zt(iz,jz)
                     ti(ij)=ti(ij)+(dum*dij(ij))
                  endif
 380           continue
 390        continue
            endif  ! of overlap and kinetic energy integral
c     
c     ----- nuclear attraction -----
c     
            if (doV) then
               aax=aa*ax
               aay=aa*ay
               aaz=aa*az
               do 500 ic=1,nat
                  znuc=-zan(ic)
                  cx=xyz(1,ic)
                  cy=xyz(2,ic)
                  cz=xyz(3,ic)
                  yy=aa*((ax-cx)**2+(ay-cy)**2+(az-cz)**2)
                  call hnd_droot
                  do 420 iroot=1,nroots
                     uu=u9(iroot)*aa
                     ww=w9(iroot)*znuc
                     tt=one/(aa+uu)
                     t = sqrt(tt)
                     x0=(aax+uu*cx)*tt
                     y0=(aay+uu*cy)*tt
                     z0=(aaz+uu*cz)*tt
                     do 4100 j=1,ljt
                        nj=j
                        do 410 i=1,lit
                           ni=i
                           call hnd_sxyz
                           xv(i,j,iroot)=xint
                           yv(i,j,iroot)=yint
                           zv(i,j,iroot)=zint*ww
 410                    continue
 4100                continue
 420              continue
c
                  ij=0
                  do 450 i=1,maxi
                     call getNxyz(Li,i,Nxyz)
                     ix = Nxyz(1) + 1
                     iy = Nxyz(2) + 1
                     iz = Nxyz(3) + 1
                     do 440 j=1,maxj
                        call getNxyz(Lj,j,Nxyz)
                        jx = Nxyz(1) + 1
                        jy = Nxyz(2) + 1
                        jz = Nxyz(3) + 1
                        dum=zero
                        do 430 iroot=1,nroots
c                           write(*,*)"ic,ix,iy,iz,jx,jy,jz,xv,yy,zv",
c     &                          ic,ix,iy,iz,jx,jy,jz,
c     &                          xv(ix,jx,iroot),yv(iy,jy,iroot),
c     &                          zv(iz,jz,iroot)
                           dum=dum+xv(ix,jx,iroot)
     &                          *yv(iy,jy,iroot)*zv(iz,jz,iroot)
 430                    continue
                        dum=dum*(aa1*pi212)
                        ij=ij+1
c                        write(*,"('den(ij)=', f10.4,'   ai=',f10.4,
c     &                       '   aj=',f10.4
c     &                       '   ci=',f10.4,'   aj=',f10.4,'   soo=',
c     &                       f10.4)")
c     &                       dens(ij),ai,aj,dum1/fac,dum2/dum1,dij(ij)
c                        write(*,"('i=',i5,'   j=',i5,'   ij=',i5,
c     &                       '   dum=',f12.8,'   dij=',f12.8,
c     &                       '   dij*dum=',f12.8)")
c     &                       i,j,ij,dum,dij(ij),dum*dij(ij)
                        vi(ic)=vi(ic)+dum*dij(ij)
 440                 continue
 450              continue
c
 500           continue
            endif               ! of nuclear part
c     
 6000    continue
 7000 continue
c
      if(some) write(luout,9998)
      return
 9999 format(/,10x,20(1h-),/,10x,'1 electron integrals',
     2       /,10x,20(1h-))
 9998 format(' ...... end of one-electron integrals ......')
 9997 format(' in -hnd_stvint- the rys quadrature is not implemented',
     1       ' beyond -nroots- = ',i2,/,
     2       ' lit,ljt,nroots= ',3i3)
      end

C> \ingroup selci
C> @{
      subroutine selci_stool(iconf,ept,ept_mp,enew,ptnorm,ptnorm_mp,
     &     nroot,irange,nrange,iwpt,
     &     noconfi,ioconf,nintpo,nconmx,ncold)
*
* $Id: stool.F 24790 2013-11-11 18:56:49Z d3y133 $
*
      implicit real*8 (a-h,o-z), integer(i-n)
#include "errquit.fh"
c     
c     collect info from the other processes for restart
c     
      dimension ioconf(nintpo,nconmx),irange(nrange),
     &     ept(nroot),enew(nroot),ptnorm(nroot),
     &     ept_mp(nroot),ptnorm_mp(nroot)
c     
c     spare arrays needed
c     
      dimension eptn(50), enewn(50), ptnormn(50), irangen(21)
      dimension eptn_mp(50), ptnormn_mp(50)
      integer pmap(0:1023)      ! 1024 max process count
c     
c     irest = unit for restart tape 'selci.r.?'
c     ? is 1 or 2
c     istde = standard error
c     istdo = standard output
c     
      parameter(irest = 69)
      parameter(istde=0,istdo=6)
#include "cselcifiles.fh"
#include "global.fh"
      integer icall
      data icall/0/
c     
      its = mtime()
      if (nroot.gt.50) call errquit('STOOL: hard dimension fail',
     $     nroot, INPUT_ERR)
      me = ga_nodeid()
      master = 0
      if (ga_nnodes() .gt. 1024) call errquit('ptidy: too many procs',
     $     0, INPUT_ERR)
      call ga_list_nodeid(pmap, ga_nnodes()) ! Map to msg passing layer
*     write(6,*) ga_nodeid(),' processor map ', 
*     $     (pmap(i),i=0,ga_nnodes()-1)
      node0 = pmap(0)
c     
c     check existence of file
c     The following two lines are to take care of compiler warnings.
c     
      ifile  = 1
      idfile = 2

      if (me.eq.master) then
         icall = icall + 1
         ifile  = 1
         idfile = 2
         if(mod(icall,2).eq.0) then
            ifile  = 2
            idfile = 1
         endif
      endif
c     
c     do not update vector length
c     if a crash occurs then node 0 (master) will 
c     hold all results of previous work.  
c     
      noconf = noconfi
      isync = 1
      if (me.ne.master) then
         call snd(21, (noconf-ncold), mitob(1), node0, isync)
         call snd(22, ioconf(1,ncold+1),mitob(nintpo*(noconf-ncold)),
     &        node0,isync)
         call snd(23, ept, mdtob(nroot), node0, isync)
         call snd(24, enew, mdtob(nroot), node0, isync)
         call snd(25, ptnorm, mdtob(nroot), node0, isync)
         call snd(26, irange, mitob(21), node0, isync)
         call snd(27, ept_mp, mdtob(nroot), node0, isync)
         call snd(28, ptnorm_mp, mdtob(nroot), node0, isync)
         call dfill(nroot,0.0d0,ept,1)
         call dfill(nroot,0.0d0,ept_mp,1)
         call dfill(nroot,0.0d0,enew,1)
         call dfill(nroot,0.0d0,ptnorm,1)
         call dfill(nroot,0.0d0,ptnorm_mp,1)
         call ifill(21,0,irange,1)
      else
         ipt = noconf+1
         do iislave=1,ga_nnodes()-1
            islave = pmap(iislave)
            call rcv(21, new, mitob(1), len, islave, node, isync)
            noconf = noconf + new
            if (noconf.le.nconmx) then
               call rcv(22, ioconf(1,ipt), mitob(nintpo*new), len,
     $              islave, node, isync)
               ipt = ipt + new
            else
               call errquit(' stool: noconf exceeded nconmx ',
     &              noconf, INPUT_ERR)
            endif
            call rcv(23, eptn, mdtob(nroot), len, islave, node,
     &           isync)
            call rcv(24, enewn, mdtob(nroot), len, islave, node,
     &           isync)
            call rcv(25, ptnormn, mdtob(nroot), len, islave, node,
     &           isync)
            call rcv(26, irangen, mitob(nrange), len, islave, node,
     &           isync)
            call rcv(27, eptn_mp, mdtob(nroot), len, islave, node,
     &           isync)
            call rcv(28, ptnormn_mp, mdtob(nroot), len, islave, node,
     &           isync)
            do i = 1,nroot
               ept(i) = ept(i) + eptn(i)
               ept_mp(i) = ept_mp(i) + eptn_mp(i)
               enew(i) = enew(i) + enewn(i)
               ptnorm(i) = ptnorm(i) + ptnormn(i)
               ptnorm_mp(i) = ptnorm_mp(i) + ptnormn_mp(i)
            enddo
            do i = 1,nrange
               irange(i) = irange(i) + irangen(i)
            enddo
         enddo
         open(unit=irest,file=names(ifile),access='sequential',
     &        form='unformatted',status='unknown',
     &        err=90911)
         close(unit=irest,status='delete')
         open(unit=irest,file=names(ifile),access='sequential',
     &        form='unformatted',status='unknown',
     &        err=90911)
         rewind irest
c     
         write(irest)iconf,ncold,nroot,nrange,noconf,nintpo,nconmx,
     $        iwpt
         write(irest)(irange(ii),ii=1,nrange)
         write(irest)(ept(ii),ii=1,nroot)
         write(irest)(ept_mp(ii),ii=1,nroot)
         write(irest)(enew(ii),ii=1,nroot)
         write(irest)(ptnorm(ii),ii=1,nroot)
         write(irest)(ptnorm_mp(ii),ii=1,nroot)
         nloop = noconf
         do jj = 1,nloop
            write(irest)(ioconf(ii,jj),ii=1,nintpo)
         enddo
         write(istdo,'(a,i6,a,i6)')
     &        ' checkpointed at iconf = ',iconf,' of ',ncold
c     
c     close restart tape
c     
         close(unit=irest,status='keep')
         if(me.eq.0)call util_flush(istdo)
c     
c     delete other restart tape
c     
         open(unit=irest,file=names(idfile),access='sequential',
     &        form='unformatted',status='unknown',
     &        err=90912)
         close(unit=irest,status='delete')
         itf = mtime()
      endif
c
      call ga_sync()
c     
      return
c     
90911 call errquit('stool: error opening restart file',0, DISK_ERR)
90912 call errquit('stool: error opening restart file',0, DISK_ERR)
c     
      end
C> @}

      SUBROUTINE GAL_DGETRF( M, N, A, LDA, IPIV, INFO )
*
*  -- LAPACK routine (version 1.1) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  GAL_DGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*
*  This is the right-looking Level 3 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix to be factored.
*          On exit, the factors L and U from the factorization
*          A = P*L*U; the unit diagonal elements of L are not stored.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  IPIV    (output) INTEGER array, dimension (min(M,N))
*          The pivot indices; for 1 <= i <= min(M,N), row i of the
*          matrix was interchanged with row IPIV(i).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, U(i,i) is exactly zero. The factorization
*                has been completed, but the factor U is exactly
*                singular, and division by zero will occur if it is used
*                to solve a system of equations.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IINFO, J, JB, NB
*     ..
*     .. External Subroutines ..
      EXTERNAL           GAL_DGEMM, GAL_DGETF2, GAL_DLASWP
      EXTERNAL           GAL_DTRSM, GAL_XERBLA
*     ..
*     .. External Functions ..
      INTEGER            GAL_ILAENV
      EXTERNAL           GAL_ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
*     call flush()
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL GAL_XERBLA( 'GAL_DGETRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = GAL_ILAENV( 1, 'GAL_DGETRF', ' ', M, N, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.MIN( M, N ) ) THEN
*
*        Use unblocked code.
*
         CALL GAL_DGETF2( M, N, A, LDA, IPIV, INFO )
      ELSE
*
*        Use blocked code.
*
         DO 20 J = 1, MIN( M, N ), NB
            JB = MIN( MIN( M, N )-J+1, NB )
*
*           Factor diagonal and subdiagonal blocks and test for exact
*           singularity.
*
            CALL GAL_DGETF2( M-J+1, JB, A( J, J ), LDA, IPIV( J ),
     $                       IINFO )
*
*           Adjust INFO and the pivot indices.
*
            IF( INFO.EQ.0 .AND. IINFO.GT.0 )
     $         INFO = IINFO + J - 1
            DO 10 I = J, MIN( M, J+JB-1 )
               IPIV( I ) = J - 1 + IPIV( I )
   10       CONTINUE
*
*           Apply interchanges to columns 1:J-1.
*
            CALL GAL_DLASWP( J-1, A, LDA, J, J+JB-1, IPIV, 1 )
*
            IF( J+JB.LE.N ) THEN
*
*              Apply interchanges to columns J+JB:N.
*
               CALL GAL_DLASWP( N-J-JB+1, A( 1, J+JB ), LDA, J, J+JB-1,
     $                      IPIV, 1 )
*
*              Compute block row of U.
*
               CALL GAL_DTRSM( 'Left', 'Lower', 'No transpose', 'Unit',
     $                     JB,
     $                     N-J-JB+1, ONE, A( J, J ), LDA, A( J, J+JB ),
     $                     LDA )
               IF( J+JB.LE.M ) THEN
*
*                 Update trailing submatrix.
*
                  CALL GAL_DGEMM( 'No transpose', 'No transpose',
     $                        M-J-JB+1,
     $                        N-J-JB+1, JB, -ONE, A( J+JB, J ), LDA,
     $                        A( J, J+JB ), LDA, ONE, A( J+JB, J+JB ),
     $                        LDA )
               END IF
            END IF
   20    CONTINUE
      END IF
      RETURN
*
*     End of GAL_DGETRF
*
      END

      subroutine tce_mrcc_diis_save(transpose,iter,t1,t2,t3,t4,
     1  d_r1m,d_t1m,k_t1_offsetm,size_t1m,
     2  d_r2m,d_t2m,k_t2_offsetm,size_t2m,
     3  d_r3m,d_t3m,k_t3_offsetm,size_t3m,
     4  d_r4m,d_t4m,k_t4_offsetm,size_t4m,
     5  rtdb)
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "tce_diis.fh"
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
#include "rtdb.fh"

      logical transpose
      logical t1, t2, t3, t4
      integer d_r1m(maxref)
      integer d_t1m(maxref)
      integer k_t1_offsetm(maxref)
      integer d_r1_diis
      integer d_t1_diis
      integer size_t1m(maxref)
      integer d_r2m(maxref)
      integer d_t2m(maxref)
      integer k_t2_offsetm(maxref)
      integer d_r2_diis
      integer d_t2_diis
      integer size_t2m(maxref)
      integer d_r3m(maxref)
      integer d_t3m(maxref)
      integer k_t3_offsetm(maxref)
      integer d_r3_diis
      integer d_t3_diis
      integer size_t3m(maxref)
      integer d_r4m(maxref)
      integer d_t4m(maxref)
      integer k_t4_offsetm(maxref)
      integer d_r4_diis
      integer d_t4_diis
      integer size_t4m(maxref)
      logical nodezero
      character*255 filename
      integer i,j
      double precision a(maxdiism+1,maxdiism+1)
      double precision b(maxdiism+1)
      integer iwork(maxdiism+1)
      integer info
      double precision ddotfile
      external ddotfile

      integer iref
c      logical mrccdebug
      integer rtdb
      character*3 namechunk
      character*3 namechunk2
c
c     ======================
c     Initialize parameters
c     ======================
c
c       if (.not.rtdb_get(rtdb,'mrcc:debug',mt_log,1,mrccdebug))
c     1 mrccdebug = .false.
c       if (.not.rtdb_get(rtdb,'bwcc:nref', mt_int, 1, nref))
c     1  call ERRQUIT('tce_mrcc_readref',1,RTDB_ERR)

       nodezero = (ga_nodeid() .eq. 0)

       if ((diis.le.0).or.lconverged) then

       return

       endif

c
c     =====================
c         Copy T files
c     =====================
c
      do iref=1,nref

      if((int_mb(k_refafi+iref-1).eq.mypgid).or.(.not.lusesub)) then ! SG

      if (t1) then
      t1_pointerm(iref) = t1_pointerm(iref) + 1
      if (t1_pointerm(iref) .gt. diis) t1_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(t1_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.t1_diis_existm(t1_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")t1_pointerm(iref)
        call tce_filename('t1.d'//namechunk//namechunk2,filename)
      if(.not.lusesub) then
        call createfile(filename,d_t1_diis,size_t1m(iref))
      else
        call pgcreatefile(filename,d_t1_diis,size_t1m(iref),mypgid)
      endif
        t1_diism(t1_pointerm(iref),iref) = d_t1_diis
        t1_diis_existm(t1_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(t1_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_t1_diis = t1_diism(t1_pointerm(iref),iref)
      endif
      if(lusesub) then
      call tce_mrcc_gacp(d_t1m(iref),d_t1_diis,mypgid,size_t1m(iref))
      else
      call copyfile(d_t1m(iref),d_t1_diis,size_t1m(iref))
      endif
c      if((t1_pointerm(iref).eq.1).and.(t1_diis_existm(diis,iref))) then
c          call ga_add(1.0d0,t1_diism(t1_pointerm(iref),iref),
c     1 -1.0d0,t1_diism(diis,iref),r1_diism(t1_pointerm(iref),iref))
c      endif
      endif
c
c T2
c
      if (t2) then
      t2_pointerm(iref) = t2_pointerm(iref) + 1
      if (t2_pointerm(iref) .gt. diis) t2_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(t2_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.t2_diis_existm(t2_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")t2_pointerm(iref)
        call tce_filename('t2.d'//namechunk//namechunk2,filename)
      if(.not.lusesub) then
        call createfile(filename,d_t2_diis,size_t2m(iref))
      else
        call pgcreatefile(filename,d_t2_diis,size_t2m(iref),mypgid)
      endif
        t2_diism(t2_pointerm(iref),iref) = d_t2_diis
        t2_diis_existm(t2_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(t2_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_t2_diis = t2_diism(t2_pointerm(iref),iref)
      endif
      if(lusesub) then
      call tce_mrcc_gacp(d_t2m(iref),d_t2_diis,mypgid,size_t2m(iref))
      else
      call copyfile(d_t2m(iref),d_t2_diis,size_t2m(iref))
      endif
c      if((t2_pointerm(iref).eq.1).and.(t2_diis_existm(diis,iref))) then
c          call ga_add(1.0d0,t2_diism(t2_pointerm(iref),iref),
c     1 -1.0d0,t2_diism(diis,iref),r2_diism(t2_pointerm(iref),iref))
c      endif
      endif
c
c T3
c
      if (t3) then
      t3_pointerm(iref) = t3_pointerm(iref) + 1
      if (t3_pointerm(iref) .gt. diis) t3_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(t3_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.t3_diis_existm(t3_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")t3_pointerm(iref)
        call tce_filename('t3.d'//namechunk//namechunk2,filename)
        call createfile(filename,d_t3_diis,size_t3m(iref))
        call gatoeaf(d_t3_diis)
        call gatodra(d_t3_diis)
        t3_diism(t3_pointerm(iref),iref) = d_t3_diis
        t3_diis_existm(t3_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(t3_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_t3_diis = t3_diism(t3_pointerm(iref),iref)
      endif
      call copyfile(d_t3m(iref),d_t3_diis,size_t3m(iref))
      endif

      endif ! SG

      enddo !iref

c
c     =====================
c         Copy r files
c     =====================
c

      do iref=1,nref

      if((int_mb(k_refafi+iref-1).eq.mypgid).or.(.not.lusesub)) then ! SG

      if (t1) then
      r1_pointerm(iref) = r1_pointerm(iref) + 1
      if (r1_pointerm(iref) .gt. diis) r1_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*) 'diis_exist',(r1_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.r1_diis_existm(r1_pointerm(iref),iref)) then

        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")r1_pointerm(iref)
        call tce_filename("r1.d"//namechunk//namechunk2,filename)
      if(.not.lusesub) then
        call createfile(filename,d_r1_diis,size_t1m(iref))
      else
        call pgcreatefile(filename,d_r1_diis,size_t1m(iref),mypgid)
      endif
        r1_diism(r1_pointerm(iref),iref) = d_r1_diis
        r1_diis_existm(r1_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(r1_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_r1_diis = r1_diism(r1_pointerm(iref),iref)
      endif
c      call tce_r1_divide(d_r1,k_t1_offset)
      if(iter.eq.1) then
      if(lusesub) then
      call tce_mrcc_gacp(d_r1m(iref),d_r1_diis,mypgid,size_t1m(iref))
      else
      call copyfile(d_r1m(iref),d_r1_diis,size_t1m(iref))
      endif
      endif
      endif
c
c R2
c
      if (t2) then
      r2_pointerm(iref) = r2_pointerm(iref) + 1
      if (r2_pointerm(iref) .gt. diis) r2_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(r2_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.r2_diis_existm(r2_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")r2_pointerm(iref)
        call tce_filename("r2.d"//namechunk//namechunk2,filename)
      if(.not.lusesub) then
        call createfile(filename,d_r2_diis,size_t2m(iref))
      else
        call pgcreatefile(filename,d_r2_diis,size_t2m(iref),mypgid)
      endif
        call gatoeaf(d_r2_diis)
        call gatodra(d_r2_diis)
        r2_diism(r2_pointerm(iref),iref) = d_r2_diis
        r2_diis_existm(r2_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(r2_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_r2_diis = r2_diism(r2_pointerm(iref),iref)
      endif
c      call tce_r2_divide(d_r2,k_t2_offset)
      if(iter.eq.1) then
      if(lusesub) then
      call tce_mrcc_gacp(d_r2m(iref),d_r2_diis,mypgid,size_t2m(iref))
      else
      call copyfile(d_r2m(iref),d_r2_diis,size_t2m(iref))
      endif
      endif
      endif
c
c R3
c
      if (t3) then
      r3_pointerm(iref) = r3_pointerm(iref) + 1
      if (r3_pointerm(iref) .gt. diis) r3_pointerm(iref) = 1
      if (nodezero.and.mrccdebug) then
        write(LuOut,*)
        write(LuOut,*) 'diis_exist',(r3_diis_existm(i,iref),i=1,diis)
        call util_flush(LuOut)
      endif
      if (.not.r3_diis_existm(r3_pointerm(iref),iref)) then
        write(namechunk,"(I3.3)")iref
        write(namechunk2,"(I3.3)")r3_pointerm(iref)
        call tce_filename("r3.d"//namechunk//namechunk2,filename)
        call createfile(filename,d_r3_diis,size_t3m(iref))
        call gatoeaf(d_r3_diis)
        call gatodra(d_r3_diis)
        r3_diism(r3_pointerm(iref),iref) = d_r3_diis
        r3_diis_existm(r3_pointerm(iref),iref) = .true.
        if (nodezero.and.mrccdebug) then
          write(LuOut,9010) 'diis',filename(1:20)
          write(LuOut,9020) 'diis',(r3_diism(i,iref),i=1,diis)
          call util_flush(LuOut)
        endif
      else
        d_r3_diis = r3_diism(r3_pointerm(iref),iref)
      endif
c      call tce_r3_divide(d_r3,k_t3_offset)
      call copyfile(d_r3m(iref),d_r3_diis,size_t3m(iref))
      endif

      endif ! SG
      enddo !iref

 9010 format(1x,A,' file name    = ',A)
 9020 format(1x,A,' file handles = ',20i5)


       return
       end

c $Id: tce_mrcc_diis_save.F 24345 2013-06-22 06:19:30Z d3y133 $

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_SAVE(HESS,GRAD,COORD,ENERGY,IERR)
c $Id: stpr_save.F 25540 2014-05-01 22:33:27Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      LOGICAL SECO, SWSEC, SWFIR
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      COMMON / PARAM / PSTEPP(20)
      COMMON / SWITCH / SECO, SWSEC, SWFIR
#include "cstprfiles.fh"
      DIMENSION HESS(NAT3TR),
     &          GRAD(NAT3),
     &          COORD(3,NATOM)
      IERR = 0
#if defined(OPENCLOSE)
      OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE=FILE41,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN', err=10)
      REWIND (UNIT=ITAP41)
#else
      REWIND ITAP41
#endif
C
C     Write previous step parameters PSTEPP.
C
      WRITE(ITAP41, ERR=10)PSTEPP
C
C     Write HESS.
C
*debug:      write(6,*)'hess stpr_save',nat3tr
*debug:      do i=1,nat3tr
*debug:        if (abs(hess(i)).gt.1.0d-5)
*debug:     &      write(6,*)' hess (',i,') =',hess(i)
*debug:      enddo
      CALL stpr_wrtsq (ITAP41,HESS,NAT3TR,IERR)
      IF(IERR.NE.0)GOTO 10
C
C     Write GRAD.
C
      CALL stpr_wrtsq (ITAP41,GRAD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 10
C
C     Write COORD.
C
      CALL stpr_wrtsq (ITAP41,COORD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 10
C
C     Write ENERGY.
C
      WRITE(ITAP41, ERR=10)ENERGY
#if defined(OPENCLOSE)
      close(unit=itap41,status='keep')
#endif
      RETURN
   10 CONTINUE
      IERR = 1
      RETURN
      end
      subroutine stpr_RETRVE(HESS,GRAD,COORD,ENERGY,IERR)
*      ENTRY stpr_RETRVE(HESS,GRAD,COORD,ENERGY,IERR)
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      LOGICAL SECO, SWSEC, SWFIR
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
      COMMON / PARAM / PSTEPP(20)
      COMMON / SWITCH / SECO, SWSEC, SWFIR
#include "cstprfiles.fh"
      DIMENSION HESS(NAT3TR),
     &          GRAD(NAT3),
     &          COORD(3,NATOM)
c
      IERR = 0
#if defined(OPENCLOSE)
      OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE=FILE41,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN', err=20)
      REWIND (UNIT=ITAP41)
#else
      REWIND ITAP41
#endif
C
C     Read previous step parameters PSTEPP.
C
      READ(ITAP41, END=20, ERR=20)PSTEPP
C
C     Read HESS.
C
      CALL stpr_readsq (ITAP41,HESS,NAT3TR,IERR)
      IF(IERR.NE.0)GOTO 20
*debug:      write(6,*)'hess stpr_retrve',nat3tr
*debug:      do i=1,nat3tr
*debug:        if (abs(hess(i)).gt.1.0d-5)
*debug:     &      write(6,*)' hess (',i,') =',hess(i)
*debug:      enddo
C
C     Read GRAD.
C
      CALL stpr_readsq (ITAP41,GRAD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 20
C
C     Read COORD.
C
      CALL stpr_readsq (ITAP41,COORD,NAT3,IERR)
      IF(IERR.NE.0)GOTO 20
C
C     Read ENERGY.
C
      READ(ITAP41, END=20, ERR=20)ENERGY
#if defined(OPENCLOSE)
      close(unit=itap41,status='keep')
#endif
      RETURN
   20 CONTINUE
      IERR = 1
      RETURN
      end
      subroutine stpr_PUTP(GMXMUM,GLNGTH,SLNGTH,EOLD,ENERGY,
     &           EDIFF,E2OLD,ERATIO,TRUSTO,TRUST,TRUSTN,
     &           E2NEW,NWALK,NNEG)
*      ENTRY stpr_PUTP(GLNGTH,SLNGTH,EOLD,ENERGY,
*     &           EDIFF,E2OLD,ERATIO,TRUSTO,TRUST,TRUSTN,
*     &           E2NEW,NWALK,NNEG)
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / PARAM / PSTEPP(20)
#include "cstprfiles.fh"
C
C     PSTEPP(3) currently not used.
C
      PSTEPP(1)  = GLNGTH
      PSTEPP(2)  = GMXMUM
      PSTEPP(4)  = SLNGTH
      PSTEPP(5)  = EOLD
      PSTEPP(6)  = ENERGY
      PSTEPP(7)  = EDIFF
      PSTEPP(8)  = E2OLD
      PSTEPP(9)  = ERATIO
      PSTEPP(10) = TRUSTO
      PSTEPP(11) = TRUST
      PSTEPP(12) = TRUSTN
      PSTEPP(13) = E2NEW
      PSTEPP(14) = dble(NWALK)
      PSTEPP(15) = dble(NNEG)
C
C     Write previous step parameters PSTEPP.
C
#if defined(OPENCLOSE)
      OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE41,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN', err=30)
      REWIND (UNIT=ITAP41)
      WRITE(ITAP41)PSTEPP
00001 continue
      read(itap41,end=00030)
      goto 00001
00030 continue
      close(unit=itap41,status='keep')
#else
      REWIND ITAP41
      WRITE(ITAP41)PSTEPP
#endif
      RETURN
      end
      subroutine stpr_GETP(GMXMUM,GLNGTH,SLNGTH,EOLD,ENERGY,
     &           EDIFF,E2OLD,ERATIO,TRUSTO,TRUST,TRUSTN,
     &           E2NEW,NWALK,NNEG)
*      ENTRY stpr_GETP(GMXMUM,GLNGTH,SLNGTH,EOLD,ENERGY,
*     &           EDIFF,E2OLD,ERATIO,TRUSTO,TRUST,TRUSTN,
*     &           E2NEW,NWALK,NNEG)
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / PARAM / PSTEPP(20)
#include "cstprfiles.fh"
C
C     If not first step read previous step parameters PSTEPP from
C     disk.
C
      IF(NWALK.GT.1)THEN
#if defined(OPENCLOSE)
        OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE=FILE41,
     &      ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
        REWIND (UNIT=ITAP41)
        READ(ITAP41)PSTEPP
        close(unit=itap41,status='keep')
#else
        REWIND ITAP41
        READ(ITAP41)PSTEPP
#endif
      ENDIF
C
C     PSTEPP(3) currently not used.
C
      GLNGTH = PSTEPP(1)
      GMXMUM = PSTEPP(2)
      SLNGTH = PSTEPP(4)
      EOLD   = PSTEPP(5)
      ENERGY = PSTEPP(6)
      EDIFF  = PSTEPP(7)
      E2OLD  = PSTEPP(8)
      ERATIO = PSTEPP(9)
      TRUSTO = PSTEPP(10)
      TRUST  = PSTEPP(11)
      TRUSTN = PSTEPP(12)
      E2NEW  = PSTEPP(13)
#if defined(CRAY) || defined(KSR)
      NWALK  = NINT(PSTEPP(14))
      NNEG   = NINT(PSTEPP(15))
#else
      NWALK = IDNINT(PSTEPP(14))
      NNEG  = IDNINT(PSTEPP(15))
#endif
      RETURN
      end
      subroutine stpr_GTNPO(EOLD,E2OLD,TRUST,SOLD,NWALK)
*      ENTRY stpr_GTNPO(EOLD,E2OLD,TRUST,SOLD,NWALK)
C
C     Read previous step parameters PSTEPP.
C
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / PARAM / PSTEPP(20)
#include "cstprfiles.fh"
#if defined(OPENCLOSE)
      OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE=FILE41,
     &   ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP41)
      READ(ITAP41)PSTEPP
      close(unit=itap41,status='keep')
#else
      REWIND ITAP41
      READ(ITAP41)PSTEPP
#endif
      EOLD = PSTEPP(5)
      E2OLD = PSTEPP(8)
      TRUST = PSTEPP(11)
      SOLD = PSTEPP(4)
#if defined(CRAY) || defined(KSR)
      NWALK = NINT(PSTEPP(14))
#else
      NWALK = IDNINT(PSTEPP(14))
#endif
      RETURN
      end
      subroutine stpr_GETNP(EOLD,E2OLD,TRUST,SOLD,NWALK)
*      ENTRY stpr_GETNP(EOLD,E2OLD,TRUST,SOLD,NWALK)
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / PARAM / PSTEPP(20)
#include "cstprfiles.fh"
C
C     Read previous step parameters PSTEPP.
C
#if defined(OPENCLOSE)
      OPEN (UNIT=ITAP41, FORM='UNFORMATTED', FILE=FILE41,
     &    ACCESS='SEQUENTIAL', STATUS='UNKNOWN')
      REWIND (UNIT=ITAP41)
      READ(ITAP41)PSTEPP
      close(unit=itap41,status='keep')
#else
      REWIND ITAP41
      READ(ITAP41)PSTEPP
#endif
      EOLD = PSTEPP(6)
      E2OLD = PSTEPP(13)
      TRUST = PSTEPP(12)
      SOLD = PSTEPP(4)
#if defined(CRAY) || defined(KSR)
      NWALK = NINT(PSTEPP(14))
#else
      NWALK = IDNINT(PSTEPP(14))
#endif
      RETURN
      END
C> @}

c
c $Id: print_final.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE print_final()

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'cm_atom.inc'

      integer  i

      write(output,'(/,a4,1x,i12)')'COOR',natms

      do i=1,natms

       write(output,'(i3,3(1x,g20.10))')atmtype(i),
     $  ccc(i,1),ccc(i,2),ccc(i,3)

      enddo

      return

      END

*
* $Id: sneblw2.F 19708 2010-10-29 18:04:21Z d3y133 $
*
#include "blas_lapackf.h"
*======================================================================
*
* DISCLAIMER
*
* This material was prepared as an account of work sponsored by an
* agency of the United States Government.  Neither the United States
* Government nor the United States Department of Energy, nor Battelle,
* nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
* ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
* COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
* SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
* INFRINGE PRIVATELY OWNED RIGHTS.
*
* ACKNOWLEDGMENT
*
* This software and its documentation were produced with Government
* support under Contract Number DE-AC06-76RLO-1830 awarded by the United
* States Department of Energy.  The Government retains a paid-up
* non-exclusive, irrevocable worldwide license to reproduce, prepare
* derivative works, perform publicly and display publicly by or for the
* Government, including the right to distribute to other Government
* contractors.
*
*======================================================================
*
*  -- PEIGS  routine (version 2.1) --
*     Pacific Northwest Laboratory
*     July 28, 1995
*
*======================================================================
      INTEGER FUNCTION SNEBLW2(N, V, D, E, WORK, INFO )
*     
*     
*     Same functionality as neblw1 from the Eispack library
*     but using LAPACK code.  
*     
*     WARNING:  in this code E(1) is the first subdiagonal
*     element of T and E(N) is junk.  While in
*     neblw1 E(1) is junk and E(2) is the first
*     subdiagonal element of T.
*     
*     D.M. Elwood 09/26/94
*     
*     .. Scalar Arguments ..
      INTEGER            N, INFO
      REAL   V
*     ..
*     .. Array Arguments ..
      REAL   D( * ), E( * ), WORK( * )
*     ..
*     
*     Purpose
*     =======
*     
*     NEBLW2 computes the number of eigenvalues of a symmetric
*     tridiagonal matrix, T, which are less than or equal to V.  Uses
*     code from LAPACK's DSTEBZ and DLAEBZ.
*     
*     Arguments
*     =========
*     
*     N       (input) INTEGER
*     The dimension of the tridiagonal matrix T.  N >= 0.
*
*     V       (input) REAL
*     Compute the number of eigenvalues less than or equal to V.
*     
*     D       (input) REAL array, dimension (N)
*          The n diagonal elements of the tridiagonal matrix T.  To
*          avoid overflow, the matrix must be scaled so that its largest
*          entry is no greater than overflow**(1/2) * underflow**(1/4)
*          in absolute value, and for greatest accuracy, it should not
*          be much smaller than that.
*
*  E       (input) REAL array, dimension (N-1)
*          The (n-1) off-diagonal elements of the tridiagonal matrix T.
*          To avoid overflow, the matrix must be scaled so that its
*          largest entry is no greater than overflow**(1/2) *
*          underflow**(1/4) in absolute value, and for greatest
*          accuracy, it should not be much smaller than that.
*
*  WORK    (workspace) REAL array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*  =====================================================================
*
*     .. Parameters ..
      REAL   ZERO, ONE
      PARAMETER          ( ZERO = 0.0, ONE = 1.0 )
*     ..
*     .. Local Scalars ..
      INTEGER            J, MOUT
      REAL   PIVMIN, SAFEMN, TMP1, ULP
*     ..
*     .. External Functions ..
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
#include "blas_lapack.data"
*     ..
*     .. Executable Statements ..
*
      INFO = 0
*
*     Check for Errors
*
      IF( N.LT.0 )
     $   INFO = -1
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'NEWBLW2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      SNEBLW2 = 0
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
c      SAFEMN = SLAMCH( 'S' )
c      ULP = SLAMCH( 'P' )
c
      SAFEMN = SLAMCHS
      ULP = SLAMCHP

*
*     Special Case when N=1
*
      IF( N.EQ.1 ) THEN
         IF( D( 1 ) .LE. V ) THEN
            SNEBLW2 = 1
         ELSE
            SNEBLW2 = 0
         END IF
         RETURN
      END IF
*
*     Compute Splitting Points
*     Set WORK = E * E
*
      WORK( N ) = ZERO
      PIVMIN = ONE
*
      DO 10 J = 2, N
         TMP1 = E( J-1 )**2
         IF( ABS( D( J )*D( J-1 ) )*ULP**2+SAFEMN.GT.TMP1 ) THEN
            WORK( J-1 ) = ZERO
         ELSE
            WORK( J-1 ) = TMP1
            PIVMIN = MAX( PIVMIN, TMP1 )
         END IF
   10 CONTINUE
      PIVMIN = PIVMIN*SAFEMN
*
*     Compute the number of eigenvalues in the initial intervals.
*
      TMP1 = D( 1 ) - V
      IF( ABS( TMP1 ).LT.PIVMIN )
     $   TMP1 = -PIVMIN
      MOUT = 0
      IF( TMP1.LE.ZERO )
     $   MOUT = 1
*
      DO 20 J = 2, N
         TMP1 = D( J ) - WORK( J-1 ) / TMP1 - V
         IF( ABS( TMP1 ).LT.PIVMIN )
     $      TMP1 = -PIVMIN
         IF( TMP1.LE.ZERO )
     $      MOUT = MOUT + 1
   20 CONTINUE
      SNEBLW2 = MOUT
*
*     End of NEWBLW2
*
      RETURN
      END

      logical function argos_prep_scnseq(iunit,dirnam,lfnout,
     + kseq,cseq,mseq,ksgm,csgm,msgm)
c
c $Id: argos_prep_scnseq.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     function to scan database for segments in sequence
c
c     return value:
c          .false. : scan failed
c          .true.  : scan completed successfully
c
c     in  : iunit     = dbase logical file number
c           filnam    = dbase file name
c           lfnout    = output file logical file number
c           mseq      = dimension of the sequence list
c     out : kseq(1,*) = segment numbers
c           kseq(2,*) = number of atoms
c           kseq(3,*) = index to unique segment
c           cseq      = segment names
c
      implicit none
c
#include "util.fh"
c
      integer iunit,lfnout,mseq,msgm
      integer kseq(3,mseq),ksgm(3,msgm)
      character*5 cseq(2,mseq),csgm(msgm)
      character*255 dirnam,filnam
c
      character*80 card
      integer length,lseq,isgm,i
      logical found
c
      lseq=mseq
c
      length=index(dirnam,' ')-1
c
      if(util_print('where',print_debug)) then
      write(lfnout,2006) dirnam(1:length)
 2006 format(/,'argos_prep_scnseq  ',a)
      endif
c
c     initialize the lists
c
      do 9 i=1,msgm
      ksgm(1,i)=0
    9 continue
c
      do 10 i=1,lseq
c      write(lfnout,1000) i,kseq(1,i),cseq(1,i),kseq(2,i),kseq(3,i)
c 1000 format(2i5,2x,a5,2i5)
      ksgm(1,kseq(3,i))=ksgm(1,kseq(3,i))+1
      if(ksgm(1,kseq(3,i)).eq.1) csgm(kseq(3,i))=cseq(1,i)
   10 continue
c
      do 11 i=1,msgm
      filnam=dirnam(1:length)//csgm(i)(1:index(csgm(i),' ')-1)//'.frg'
      found=.false.
      open(iunit,file=filnam,form='formatted',status='old',err=19)
      found=.true.
      close(iunit)
   19 continue
c      if(found) then
c      write(lfnout,1001) i,csgm(i),ksgm(1,i),
c     + filnam(1:index(filnam,' ')-1)
c 1001 format(i5,2x,a5,i5,2x,a)
c      else
c      write(lfnout,1002) i,csgm(i),ksgm(1,i)
c 1002 format(i5,2x,a5,i5)
c      endif
   11 continue
c
      argos_prep_scnseq=.true.
      return
      end

C $Id: rel_oneld.F 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
c:tex-\subsection{rel\_oneld}
c:tex-This routine generates the modified one-electron gradient integrals
c:tex-for a relativistic basis set. These are the gradients of the modified 
c:tex-kinetic energy, the modified potential energy and the modified overlap,
c:tex-\begin{eqnarray}
c:tex-&& \tilde{T}_{ab} = T_{ab}^{LS} + T_{ab}^{SL} - T_{ab}^{SS} 
c:tex- \nonumber \\ 
c:tex-&& \tilde{V}^{sf}_{ab} = V_{ab}^{LL} + {{\alpha^2}\over{4}}
c:tex-   \nabla_A\cdot\nabla_B V_{ab}^{SS}
c:tex-&& \tilde{V}^{so}_{ab} = V_{ab}^{LL} + {{\alpha^2}\over{4}}
c:tex-   \nabla_A\times\nabla_B V_{ab}^{SS}
c:tex- \nonumber \\ 
c:tex-&& \tilde{S}_{ab} = S_{ab}^{LL} + {{\alpha^2}\over{2}} T_{ab}^{SS} 
c:tex- \nonumber 
c:tex-\end{eqnarray}
c:tex-
c:tex-\noindent Author: K. G. Dyall
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine rel_oneld (
     &    Axyz,zeta_A,coefL_A,coefS_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &    Bxyz,zeta_B,coefL_B,coefS_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &    Cxyz,zan,exinv,nat,S,T,V,lstv,doStil,doTtil,doVtil,canAB,
     &    do_nw,do_hnd,nonrel,DryRun,scr,lscr,ibug,ntyp)
c:tex-\end{verbatim}
      implicit none
#include "stdio.fh"
#include "rel_consts.fh"
#include "errquit.fh"
*
c:tex-{\it Argument list:}
c:tex-\begin{verbatim}
      integer n_prim_A ! [input] num. prims in shell A
      integer n_cont_A ! [input] num general conts in shell A
      integer l_A      ! [input] angular momentum of shell A
      integer ictr_A   ! [input] lexical atom index for shell A
      integer n_prim_B ! [input] num. prims in shell B
      integer n_cont_B ! [input] num general conts in shell B
      integer l_B      ! [input] angular momentum of shell B 
      integer ictr_B   ! [input] lexical atom index for shell B
      integer nat      ! [input] number of atoms
      integer lscr     ! [input] size of scratch array
      integer lstv     ! [input] size of any integral buffer
      integer ibug    ! [input] debug variable
      integer ntyp    ! [input] potential energy integral type
      double precision Axyz(3)          ! [input] position of center A
      double precision zeta_A(n_prim_A) ! [input] exponents of shell A
      double precision coefL_A(n_prim_A,n_cont_A) ! [input] A large coeffs
      double precision coefS_A(n_prim_A,n_cont_A) ! [input] A small coeffs
      double precision Bxyz(3)          ! [input] position of center B
      double precision zeta_B(n_prim_B) ! [input] exponents of shell B 
      double precision coefL_B(n_prim_B,n_cont_B)  ! [input] B large coeffs
      double precision coefS_B(n_prim_B,n_cont_B)  ! [input] B small coeffs
      double precision Cxyz(3,nat)  ! [input] all atom positions
      double precision zan(nat)     ! [input] charges on all atoms
      double precision exinv(nat)   ! [input] inverse nuclear exponents
      double precision scr(lscr)    ! [scratch] scratch buffers
      double precision S(lstv*3*2)      ! [output] overlap integrals
      double precision T(lstv*3*2)      ! [output] kinetic energy integrals
      double precision V(lstv*3*nat,ntyp) ! [output] potential integrals
      logical doStil     ! [input] compute modified overlap (True/False)
      logical doTtil     ! [input] compute modified kinetic (True/False)
      logical doVtil     ! [input] compute modified potential (True/False)
      logical canAB   ! [input] compute only canonical ints (false only)
      logical do_nw   ! [input] can do NW integrals
      logical do_hnd  ! [input] can do HONDO integrals
      logical nonrel  ! [input] true if either centre is nonrelativistic
      logical DryRun  ! [input] true means only compute required memory
c:tex-\end{verbatim}
c:tex-See rel_pot for a description of the allowed values of ibug and ntyp
c:tex-Note that in the current version of this routine, the call to rel_pot 
c:tex-uses a dummy ntyp=1. It is kept in the input so that in future, the 
c:tex-spin-orbit integrals can also be obtained with a call to this routine.
c:tex-
c:tex-{\it Subroutines called:} hf1d, rel\_pot, daxpy, dcopy
*
      integer n_cart_a  ! cartesian components of shell A
      integer n_cart_b  ! cartesian components of shell B
      integer n_cart_ab ! n_cart_a*n_cart_b
      integer n_cont_ab ! n_cont_a*n_cont_b
      integer n_all_b   ! n_cart_b*n_cont_b
      integer n_all_a   ! n_cart_a*n_cont_a
      integer n_ab      ! number of integrals
      integer n_ab6     ! n_ab*6, number of gradient integrals for T and S
      integer n_ab3at   ! n_ab*3*nat, number of gradient integrals for V
      integer n_cartp_a ! cartesian components for l_A+1
      integer n_cartp_b ! cartesian components for l_B+1
      integer n_cartm_a ! cartesian components for l_A-1
      integer n_cartm_b ! cartesian components for l_B-1
      integer n_intpp   ! number of integrals for l_A+1,l_B+1
      integer n_intpm   ! number of integrals for l_A-1,l_B+1
      integer n_intmp   ! number of integrals for l_A+1,l_B-1
      integer n_intmm   ! number of integrals for l_A-1,l_B-1
      integer i_xca     ! address in scr of exp*coef for shell A
      integer i_xcb     ! address in scr of exp*coef for shell B
      integer i_pp      ! address in scr of integrals for l_A+1,l_B+1
      integer i_pm      ! address in scr of integrals for l_A-1,l_B+1
      integer i_mp      ! address in scr of integrals for l_A+1,l_B-1
      integer i_mm      ! address in scr of integrals for l_A-1,l_B-1
      integer i_scr     ! address of free space in scr
      integer memscr    ! free space in scr
      integer max_mem   ! maximum memory used
      integer i,j,k,l,m ! loop indices etc.
      double precision one ! Obvious!
      parameter (one = 1.0D0)
*
      integer n_allp_b   ! n_cartp_b*n_cont_b
      integer n_allp_a   ! n_cartp_a*n_cont_a
      integer n_allm_b   ! n_cartm_b*n_cont_b
      integer n_allm_a   ! n_cartm_a*n_cont_a
*
      logical debug_gen       ! do general debug printing
      logical debug_addresses ! do address debug printing
      logical debug_arrays    ! do array debug printing
      logical doS     ! compute overlap (True/False)
      logical doT     ! compute kinetic (True/False)
      logical doV     ! compute potential (True/False)
      character*12 pot_type(4)  ! potential type labels
      character*1 xyz(3)  ! coordinate labels
      data pot_type
     &    /'      Scalar','z spin-orbit','y spin-orbit','x spin-orbit'/
      data xyz/'x','y','z'/
*
      debug_gen = ibug .gt. 0
      debug_addresses = mod(ibug,2) .eq. 1
      debug_arrays = (mod(ibug,10)/2 .eq. 1) .and. .not.DryRun
      max_mem = 0
*
      if (.not.(do_nw .or. do_hnd)) call errquit
     &    ('rel_oneld: can''t do NW or HONDO integrals',99, INT_ERR)
*
      if (debug_gen) then
        write (LuOut,*) 'Beginning rel_oneld'
        write (LuOut,*) 'l_A',l_A
        write (LuOut,*) 'n_prim_A',n_prim_A
        write (LuOut,*) 'n_cont_A',n_cont_A
        write (LuOut,*) 'ictr_A',ictr_A
        write (LuOut,*) 'l_B',l_B
        write (LuOut,*) 'n_prim_B',n_prim_B
        write (LuOut,*) 'n_cont_B',n_cont_B
        write (LuOut,*) 'ictr_B',ictr_B
        if (doStil) write (LuOut,*) 'Doing overlaps'
        if (doTtil) write (LuOut,*) 'Doing kinetic energy'
        if (doVtil) write (LuOut,*) 'Doing potential energy'
        call util_flush(LuOut)
      end if
*
      n_cart_a = (l_a+1)*(l_a+2)/2
      n_cart_b = (l_b+1)*(l_b+2)/2
      n_cart_ab = n_cart_a*n_cart_b
      n_cont_ab = n_cont_a*n_cont_b
      n_all_a = n_cart_a*n_cont_a
      n_all_b = n_cart_b*n_cont_b
      n_ab = n_cart_ab*n_cont_ab
      n_ab6 = n_ab*6
      n_ab3at = n_ab*3*nat
      if (lstv .lt. n_ab .and. .not.DryRun) call errquit (
     &      'Integral buffer length too small in rel_oneld',99,
     &       MEM_ERR)
      if (debug_addresses) then
        write (LuOut,*) 'n_cart_a',n_cart_a
        write (LuOut,*) 'n_cart_b',n_cart_b
        write (LuOut,*) 'n_cart_ab',n_cart_ab
        write (LuOut,*) 'n_cont_ab',n_cont_ab
        write (LuOut,*) 'n_all_a',n_all_a
        write (LuOut,*) 'n_all_b',n_all_b
        write (LuOut,*) 'n_ab',n_ab
        call util_flush(LuOut)
      end if
      if (debug_arrays) then
        call ecp_matpr (coefL_A,1,n_prim_a,1,n_cont_a,
     &      1,n_prim_a,1,n_cont_a,'L coef A','E',120,6)
        call ecp_matpr (coefS_A,1,n_prim_a,1,n_cont_a,
     &      1,n_prim_a,1,n_cont_a,'S coef A','E',120,6)
        call ecp_matpr (coefL_B,1,n_prim_b,1,n_cont_b,
     &      1,n_prim_b,1,n_cont_b,'L coef B','E',120,6)
        call ecp_matpr (coefS_B,1,n_prim_b,1,n_cont_b,
     &      1,n_prim_b,1,n_cont_b,'S coef B','E',120,6)
        call util_flush(LuOut)
      end if
*
*   Calculate large component overlap and nuclear attraction integrals
*
      doS = doStil
      doT = doTtil.and.nonrel
      doV = doVtil
      memscr = lscr
      if (do_nw) then
        call hf1d(
     &      Axyz,zeta_A,coefL_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &      Bxyz,zeta_B,coefL_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &      Cxyz,zan,exinv,nat,S,T,V,n_ab,doS,doT,doV,canAB,
     &      DryRun,scr,memscr)
      else
        call hnd_stvintd(
     &      Axyz,zeta_A,coefL_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &      Bxyz,zeta_B,coefL_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &      Cxyz,zan,nat,S,T,V,n_ab,doS,doT,doV,scr,memscr)
      end if
      if (debug_arrays) then
        i = 1
        do j = 1,3
          write (LuOut,'(2A)') xyz(j),' component of derivatives'
          if (doS) call ecp_matpr(S(i),1,n_all_b,1,n_all_a,
     &        1,n_all_b,1,n_all_a,'LL overlap','E',120,6)
          if (doT) call ecp_matpr(T(i),1,n_all_b,1,n_all_a,
     &        1,n_all_b,1,n_all_a,'LL kinetic','E',120,6)
          if (doV) call ecp_matpr(V(i,1),1,n_all_b,1,n_all_a,
     &        1,n_all_b,1,n_all_a,'LL potential','E',120,6)
          i = i+n_ab
          call util_flush(LuOut)
        end do
      end if
      if (DryRun) max_mem = max(max_mem,memscr)
      if (debug_gen) write (LuOut,*) 'Large component done'
      if (nonrel) return
*
*   Calculate kinetic energy integrals, correction to overlaps
*
      if (doTtil) then
        doS = .false.
        doT = .true.
        doV = .false.
        memscr = lscr-n_ab6
        if (do_nw) then
          call hf1d(
     &        Axyz,zeta_A,coefL_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &        Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &        Cxyz,zan,exinv,nat,S,T,V,n_ab,doS,doT,doV,canAB,
     &        DryRun,scr(n_ab6+1),memscr)
        else
          call hnd_stvintd(
     &        Axyz,zeta_A,coefL_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &        Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &        Cxyz,zan,nat,S,T,V,n_ab,doS,doT,doV,
     &        scr(n_ab6+1),memscr)
        end if
        if (DryRun) max_mem = max(max_mem,memscr)
        if (debug_arrays) then
          i = 1
          do j = 1,3
            write (LuOut,'(1x,2A)') xyz(j),' component of derivatives'
            call ecp_matpr(T(i),1,n_all_b,1,n_all_a,
     &          1,n_all_b,1,n_all_a,'LS kinetic','E',120,6)
            i = i+n_ab
            call util_flush(LuOut)
          end do
        end if
        memscr = lscr-n_ab6
        if (do_nw) then
          call hf1d(
     &        Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &        Bxyz,zeta_B,coefL_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &        Cxyz,zan,exinv,nat,S,scr,V,n_ab,doS,doT,doV,canAB,
     &        DryRun,scr(n_ab6+1),memscr)
        else
          call hnd_stvintd(
     &        Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &        Bxyz,zeta_B,coefL_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &        Cxyz,zan,nat,S,scr,V,n_ab,doS,doT,doV,
     &        scr(n_ab6+1),memscr)
        end if
        if (debug_arrays) then
          i = 1
          do j = 1,3
            write (LuOut,'(1x,2A)') xyz(j),' component of derivatives'
            call ecp_matpr(scr(i),1,n_all_b,1,n_all_a,
     &          1,n_all_b,1,n_all_a,'SL kinetic','E',120,6)
            i = i+n_ab
            call util_flush(LuOut)
          end do
        end if
        if (DryRun) then
          max_mem = max(max_mem,memscr+n_ab6)
        else
          call daxpy (n_ab6,one,scr,1,T,1)
        end if
        if (debug_arrays) then
          i = 1
          do j = 1,3
            write (LuOut,'(1x,2A)') xyz(j),' component of derivatives'
            call ecp_matpr(T(i),1,n_all_b,1,n_all_a,
     &          1,n_all_b,1,n_all_a,'LS+SL kinetic','E',120,6)
            i = i+n_ab
          end do
          call util_flush(LuOut)
        end if
      end if
      if (doStil .or. doTtil) then
        doS = .false.
        doT = .true.
        doV = .false.
        memscr = lscr-n_ab6
        if (do_nw) then
          call hf1d(
     &        Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &        Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &        Cxyz,zan,exinv,nat,S,scr,V,n_ab,doS,doT,doV,canAB,
     &        DryRun,scr(n_ab6+1),memscr)
        else
          call hnd_stvintd(
     &        Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A,ictr_A,
     &        Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B,ictr_B,
     &        Cxyz,zan,nat,S,scr,V,n_ab,doS,doT,doV,
     &        scr(n_ab6+1),memscr)
        end if
        if (DryRun) then
          max_mem = max(max_mem,memscr+n_ab6)
        else
          if (debug_arrays) then
            i = 1
            do j = 1,3
              write (LuOut,'(1x,2A)') xyz(j),' component of derivatives'
              call ecp_matpr(scr(i),1,n_all_b,1,n_all_a,
     &            1,n_all_b,1,n_all_a,'SS kinetic','E',120,6)
              i = i+n_ab
            end do
            call util_flush(LuOut)
          end if
          if (doTtil) call daxpy (n_ab6,-one,scr,1,T,1)
          if (doStil) call daxpy (n_ab6,halsq,scr,1,S,1)
          if (debug_arrays) then
            i = 1
            do j = 1,3
              write (LuOut,'(1x,2A)') xyz(j),' component of derivatives'
              if (doTtil) call ecp_matpr(T(i),1,n_all_b,1,n_all_a,
     &            1,n_all_b,1,n_all_a,'LS+SL-SS kinetic','E',120,6)
              if (doStil) call ecp_matpr(S(i),1,n_all_b,1,n_all_a,
     &            1,n_all_b,1,n_all_a,'LL+SS overlap','E',120,6)
              i = i+n_ab
              call util_flush(LuOut)
            end do
          end if
        end if
        if (debug_gen) write (LuOut,*) 'KE & overlap done'
      end if
      if (.not.doVtil) return
*
*   Generate small component potential arrays
*
*
*   Set up pointers to scratch space for coefficients multiplied by 
*   exponents and for integrals with shifted l values
*
      n_cartp_a = n_cart_a+l_A+2
      n_cartp_b = n_cart_b+l_B+2
      n_cartm_a = n_cart_a-l_A-1
      n_cartm_b = n_cart_b-l_B-1
      n_intpp = n_cartp_a*n_cartp_b*n_cont_ab
      n_intpm = n_cartm_a*n_cartp_b*n_cont_ab
      n_intmp = n_cartp_a*n_cartm_b*n_cont_ab
      n_intmm = n_cartm_a*n_cartm_b*n_cont_ab
      n_allp_b = n_cartp_b*n_cont_b
      n_allp_a = n_cartp_a*n_cont_a
      n_allm_b = n_cartm_b*n_cont_b
      n_allm_a = n_cartm_a*n_cont_a
      i_xca = 1
      i_xcb = i_xca+n_prim_A*n_cont_A
      i_pp = i_xcb+n_prim_B*n_cont_B
      i_pm = i_pp+n_intpp*3*nat
      i_mp = i_pm+n_intpm*3*nat
      i_mm = i_mp+n_intmp*3*nat
      i_scr = max(i_xca+n_ab3at*ntyp,i_mm+n_intmm*3*nat)
      memscr = lscr-i_scr+1

      if (debug_addresses) then
        write (LuOut,*) 'n_cartp_a',n_cartp_a
        write (LuOut,*) 'n_cartp_b',n_cartp_b
        write (LuOut,*) 'n_cartm_a',n_cartm_a
        write (LuOut,*) 'n_cartm_b',n_cartm_b
        write (LuOut,*) 'n_intpp',n_intpp
        write (LuOut,*) 'n_intpm',n_intpm
        write (LuOut,*) 'n_intmp',n_intmp
        write (LuOut,*) 'n_intmm',n_intmm
        write (LuOut,*) 'i_xca,i_xcb',i_xca,i_xcb
        write (LuOut,*) 'i_pp,i_pm,i_mp,i_mm',i_pp,i_pm,i_mp,i_mm
        write (LuOut,*) 'i_scr',i_scr
        call util_flush(LuOut)
      end if
*
*   Set up coefficients multiplied by exponents
*
      memscr = lscr-i_scr+1
      if (.not.DryRun) then
        if (memscr .lt. 0) call errquit (
     &      'Insufficient scratch memory in rel_oneld',99, MEM_ERR)
        k = i_xca-1
        do j = 1,n_cont_a
          do i = 1,n_prim_A
            scr(k+i) = zeta_A(i)*coefS_A(i,j)
          end do
          k = k+n_prim_A
        end do
        k = i_xcb-1
        do j = 1,n_cont_B
          do i = 1,n_prim_B
            scr(k+i) = zeta_B(i)*coefS_B(i,j)
          end do
          k = k+n_prim_B
        end do
      end if
      doS = .false.
      doT = .false.
      doV = .true.
*
*         Calculate integrals for l_A+1, l_B+1
*
      if (do_nw) then
        call hf1d(
     &      Axyz,zeta_A,scr(i_xca),n_prim_A,n_cont_A,l_A+1,ictr_A,
     &      Bxyz,zeta_B,scr(i_xcb),n_prim_B,n_cont_B,l_B+1,ictr_B,
     &      Cxyz,zan,exinv,nat,S,T,scr(i_pp),n_intpp,doS,doT,doV,
     &      canAB,DryRun,scr(i_scr),memscr)
      else
        call hnd_stvintd(
     &      Axyz,zeta_A,scr(i_xca),n_prim_A,n_cont_A,l_A+1,ictr_A,
     &      Bxyz,zeta_B,scr(i_xcb),n_prim_B,n_cont_B,l_B+1,ictr_B,
     &      Cxyz,zan,nat,S,T,scr(i_pp),n_intpp,doS,doT,doV,
     &      scr(i_scr),memscr)
      end if
      if (debug_arrays) then
        k = i_pp
        do i = 1,nat
          do l = 1,3
            write (LuOut,'(//1x,2A,I3)') xyz(l),
     &          ' component of derivatives for center',i
            call ecp_matpr(scr(k),1,n_allp_b,1,n_allp_a,
     &          1,n_allp_b,1,n_allp_a,'l_A+1,l_B+1','E',120,6)
            k = k+n_ab
            call util_flush(LuOut)
          end do
        end do
      end if
      if (DryRun) then
        max_mem = max(max_mem,i_scr+memscr-1)
        memscr = lscr-i_scr+1
      end if
*
*         Calculate integrals for l_A-1, l_B+1
*
      if (l_A .gt. 0) then
        if (do_nw) then
          call hf1d(
     &        Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A-1,ictr_A,
     &        Bxyz,zeta_B,scr(i_xcb),n_prim_B,n_cont_B,l_B+1,ictr_B,
     &        Cxyz,zan,exinv,nat,S,T,scr(i_pm),n_intpm,doS,doT,doV,
     &        canAB,DryRun,scr(i_scr),memscr)
        else
          call hnd_stvintd(
     &        Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A-1,ictr_A,
     &        Bxyz,zeta_B,scr(i_xcb),n_prim_B,n_cont_B,l_B+1,ictr_B,
     &        Cxyz,zan,nat,S,T,scr(i_pm),n_intpm,doS,doT,doV,
     &        scr(i_scr),memscr)
        end if
        if (DryRun) then
          max_mem = max(max_mem,i_scr+memscr-1)
          memscr = lscr-i_scr+1
        end if
        if (debug_arrays) then
          k = i_pm
          do i = 1,nat
            do l = 1,3
              write (LuOut,'(//1x,2A,I3)') xyz(l),
     &            ' component of derivatives for center',i
              call ecp_matpr(scr(k),1,n_allp_b,1,n_allm_a,
     &            1,n_allp_b,1,n_allm_a,'l_A-1,l_B+1','E',120,6)
              k = k+n_ab
              call util_flush(LuOut)
            end do
          end do
        end if
      end if
*
*         Calculate integrals for l_A+1, l_B-1
*
      if (l_B .gt. 0) then
        if (do_nw) then
          call hf1d(
     &        Axyz,zeta_A,scr(i_xca),n_prim_A,n_cont_A,l_A+1,ictr_A,
     &        Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B-1,ictr_B,
     &        Cxyz,zan,exinv,nat,S,T,scr(i_mp),n_intmp,doS,doT,doV,
     &        canAB,DryRun,scr(i_scr),memscr)
        else
          call hnd_stvintd(
     &        Axyz,zeta_A,scr(i_xca),n_prim_A,n_cont_A,l_A+1,ictr_A,
     &        Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B-1,ictr_B,
     &        Cxyz,zan,nat,S,T,scr(i_mp),n_intmp,doS,doT,doV,
     &        scr(i_scr),memscr)
        end if
        if (debug_arrays) then
          k = i_mp
          do i = 1,nat
            do l = 1,3
              write (LuOut,'(//1x,2A,I3)') xyz(l),
     &            ' component of derivatives for center',i
              call ecp_matpr(scr(k),1,n_allm_b,1,n_allp_a,
     &            1,n_allm_b,1,n_allp_a,'l_A+1,l_B-1','E',120,6)
              k = k+n_ab
              call util_flush(LuOut)
            end do
          end do
        end if
        if (DryRun) then
          max_mem = max(max_mem,i_scr+memscr-1)
          memscr = lscr-i_scr+1
        end if
*     
*         Calculate integrals for l_A-1, l_B-1
*
        if (l_A .gt. 0) then
          if (do_nw) then
            call hf1d(
     &          Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A-1,ictr_A,
     &          Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B-1,ictr_B,
     &          Cxyz,zan,exinv,nat,S,T,scr(i_mm),n_intmm,doS,doT,doV,
     &          canAB,DryRun,scr(i_scr),memscr)
          else
            call hnd_stvintd(
     &          Axyz,zeta_A,coefS_A,n_prim_A,n_cont_A,l_A-1,ictr_A,
     &          Bxyz,zeta_B,coefS_B,n_prim_B,n_cont_B,l_B-1,ictr_B,
     &          Cxyz,zan,nat,S,T,scr(i_mm),n_intmm,doS,doT,doV,
     &          scr(i_scr),memscr)
          end if
          if (debug_arrays) then
            k = i_mm
            do i = 1,nat
              do l = 1,3
                write (LuOut,'(//1x,2A,I3)') xyz(l),
     &              ' component of derivatives for center',i
                call ecp_matpr(scr(k),1,n_allm_b,1,n_allm_a,
     &              1,n_allm_b,1,n_allm_a,'l_A-1,l_B-1','E',120,6)
                k = k+n_ab
                call util_flush(LuOut)
              end do
            end do
          end if
          if (DryRun) then
            max_mem = max(max_mem,i_scr+memscr-1)
            memscr = lscr-i_scr+1
          end if
        end if
      end if
*
*     Compute the relativistic potential energy integrals
*
      call rel_pot (scr(i_pp),scr(i_pm),scr(i_mp),scr(i_mm),
     &    scr,n_ab3at,ntyp,
     &    l_A,n_cartp_a,n_cart_a,n_cartm_a,n_cont_A*3*nat,
     &    l_B,n_cartp_b,n_cart_b,n_cartm_b,n_cont_B,
     &    DryRun,scr(i_scr),memscr,ibug/10)
      if (DryRun) then
        max_mem = max(max_mem,i_scr+memscr-1)
        lscr = max_mem
      else
        i = 1
        do j = 1,ntyp
          if (debug_arrays) then
            write (LuOut,'(//2A)') pot_type(j),' potential'
            k = i
            do m = 1,nat
              do l = 1,3
                write (LuOut,'(//1x,2A,I3)') xyz(l),
     &              ' component of derivatives for center',m
                call ecp_matpr(scr(k),1,n_all_b,1,n_all_a,
     &              1,n_all_b,1,n_all_a,'SS potential','E',120,6)
                k = k+n_ab
                call util_flush(LuOut)
              end do
            end do
          end if
          call daxpy (n_ab3at,qalsq,scr(i),1,V(1,j),1)
          if (debug_arrays) then
            k = 1
            do m = 1,nat
              do l = 1,3
                write (LuOut,'(1x,2A,I3)') xyz(l),
     &              ' component of derivatives for center',m
                call ecp_matpr(scr(k),1,n_all_b,1,n_all_a,1,n_all_b,
     &              1,n_all_a,'Relativistic potential','E',120,6)
                call util_flush(LuOut)
                k = k+n_ab
              end do
            end do
          end if
          i = i+n_ab3at
        end do
      end if
      if (debug_gen) write (LuOut,*) 'Exiting rel_oneld'
*
      return
      end

      subroutine ccsd_t_pstat_init(rtdb)
      implicit none
#include "pstat.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "ccsd_t_ps.fh"
      integer rtdb
      integer junk
c
      if (.not. rtdb_get(rtdb, 'tce:pstat',
     $     MT_LOG, 1, otceps)) otceps = .false.
c
      if (.not. otceps) return
c
      if (.not. pstat_allocate('tce:cctdbl', pstat_qstat, 0, junk,
     $     ps_cctdbl)) call errquit('dft: dft_pstat_init', 0,0)
      if (.not. pstat_allocate('tce:sdkrnl', pstat_qstat, 0, junk,
     $     ps_sdkrnl)) call errquit('dft: dft_pstat_init', 0,0)
      if (.not. pstat_allocate('tce:sxoffl', pstat_qstat, 0, junk,
     $     ps_sxoff)) call errquit('dft: dft_pstat_init', 0,0)
      if (.not. pstat_allocate('tce:vtoffl', pstat_qstat, 0, junk,
     $     ps_vtoff)) call errquit('dft: dft_pstat_init', 0,0)
c       
      call pstat_on(ps_tce)
      otceps = .true.
c
      end
      subroutine ccsd_t_pstat_print()
      implicit none
#include "pstat.fh"
#include "ccsd_t_ps.fh"
c     
      if (otceps) then
         call pstat_off(ps_tce)
         call pstat_print_all
         otceps = .false.
c
c     delete the TCE timers
c
         if (.not. pstat_free(ps_cctdbl))call errquit('dft_pstat?', 0,0)
         if (.not. pstat_free(ps_sdkrnl))call errquit('dft_pstat?', 0,0)
         if (.not. pstat_free(ps_sxoff))call errquit('dft_pstat?', 0,0)
         if (.not. pstat_free(ps_vtoff))call errquit('dft_pstat?', 0,0)
c
      endif
c
      end
c $Id: ccsd_t_pstat.F 25610 2014-05-14 01:10:40Z edo $
      subroutine ccsd_t_fdist_init()
      implicit none
#include "dist.fh"
#include "ccsd_t_ps.fh"
#include "rtdb.fh"
      if (.not. otceps) return
c
      fdist_sdkrnl11 = getdist( 'sd_1_1_totl')
      fdist_sdcomp11 = getdist( 'sd_1_1_comp')
      fdist_sdkrnl12 = getdist( 'sd_1_2_totl')
      fdist_sdcomp12 = getdist( 'sd_1_2_comp')
      fdist_sdkrnl13 = getdist( 'sd_1_3_totl')
      fdist_sdcomp13 = getdist( 'sd_1_3_comp')
      fdist_sdkrnl14 = getdist( 'sd_1_4_totl')
      fdist_sdcomp14 = getdist( 'sd_1_4_comp')
      fdist_sdkrnl15 = getdist( 'sd_1_5_totl')
      fdist_sdcomp15 = getdist( 'sd_1_5_comp')
      fdist_sdkrnl16 = getdist( 'sd_1_6_totl')
      fdist_sdcomp16 = getdist( 'sd_1_6_comp')
      fdist_sdkrnl17 = getdist( 'sd_1_7_totl')
      fdist_sdcomp17 = getdist( 'sd_1_7_comp')
      fdist_sdkrnl18 = getdist( 'sd_1_8_totl')
      fdist_sdcomp18 = getdist( 'sd_1_8_comp')
      fdist_sdkrnl19 = getdist( 'sd_1_9_totl')
      fdist_sdcomp19 = getdist( 'sd_1_9_comp')
      fdist_sdkrnl21 = getdist( 'sd_2_1_totl')
      fdist_sdcomp21 = getdist( 'sd_2_1_comp')
      fdist_sdkrnl22 = getdist( 'sd_2_2_totl')
      fdist_sdcomp22 = getdist( 'sd_2_2_comp')
      fdist_sdkrnl23 = getdist( 'sd_2_3_totl')
      fdist_sdcomp23 = getdist( 'sd_2_3_comp')
      fdist_sdkrnl24 = getdist( 'sd_2_4_totl')
      fdist_sdcomp24 = getdist( 'sd_2_4_comp')
      fdist_sdkrnl25 = getdist( 'sd_2_5_totl')
      fdist_sdcomp25 = getdist( 'sd_2_5_comp')
      fdist_sdkrnl26 = getdist( 'sd_2_6_totl')
      fdist_sdcomp26 = getdist( 'sd_2_6_comp')
      fdist_sdkrnl27 = getdist( 'sd_2_7_totl')
      fdist_sdcomp27 = getdist( 'sd_2_7_comp')
      fdist_sdkrnl28 = getdist( 'sd_2_8_totl')
      fdist_sdcomp28 = getdist( 'sd_2_8_comp')
      fdist_sdkrnl29 = getdist( 'sd_2_9_totl')
      fdist_sdcomp29 = getdist( 'sd_2_9_comp')
      fdist_vtoff = getdist( 'v_and_t_offload')
      fdist_sxoff = getdist( 'triplesx_offload')
c
      end
c $Id: ccsd_t_pstat.F 25610 2014-05-14 01:10:40Z edo $
      subroutine tce_sdtime0(t0)
      implicit none
#include "ccsd_t_ps.fh"
#include "util.fh"
      double precision t0
#ifdef USE_OPENMP
      double precision omp_get_wtime
      external omp_get_wtime
#endif
      if (otceps) then
#ifdef USE_OPENMP
         t0=omp_get_wtime()
#else
         t0=util_wallsec()
#endif
         call pstat_on(ps_sdkrnl)
      endif
      return
      end
c
      subroutine tce_sdtime(t0,deltat_mic,
     ,     fdist_sdkrnl_in,fdist_sdcomp_in)
      implicit none
#include "ccsd_t_ps.fh"
#include "util.fh"
      double precision t0
      integer deltat_mic
      integer fdist_sdkrnl_in,fdist_sdcomp_in
c
      integer deltat_tot
#ifdef USE_OPENMP
      double precision omp_get_wtime
      external omp_get_wtime
#endif
      if(.not.otceps) return
      call pstat_off(ps_sdkrnl)
#ifdef USE_OPENMP
      deltat_tot=(omp_get_wtime() - t0)*1.D6
#else
      deltat_tot=(util_wallsec() - t0)*1.D6
#endif
         call util_flush(6)
      if(deltat_tot.lt.deltat_mic) 
     D    deltat_tot=deltat_mic
      call updist(fdist_sdcomp_in, deltat_mic)
      call updist(fdist_sdkrnl_in, deltat_tot)
      call updist(fdist_vtoff, (deltat_tot-deltat_mic))
      return
      end

c program qqq 
c with diis implementation
       implicit none
       integer  nu, nv, ngr ,icr,icl,i,dd 
       real*8 r1, r2, tau, solperm,t, tol,lambd,dr  
c parameters(nv number of solute sites  nu number of solute sites ngr number of grid points)
c solperm solvent relative permittivity
c tau(aa-1) separation between short and long range functions in 1/angstroms
c icr type of combination rule: 1-arithmetic; 2-geometric 
c t(k)  temperature in kelvins
c tol residue tolerance
c lamd mixing parameter
c icl closure type: 1-hnc; 2-kh
c tau debye parameter for spliting potnetial into short and long part
c solperm dielectric permitivity of the solvent
c dd number of diis basis vectors
c      ngr=4096
c      nu=12 
c      nv=4 
c      tau=1
c      solperm=1
c      icr=1
c      t=298
c      tol=1e-5
c      lambd=0.5 
c      icl=2 
       open(3, file='uvpar.data', status='old')
       read(3,102) nu,nv,icr,icl,ngr,tau,solperm,t,tol,lambd,dd 
       print*, nu,nv,icr,icl,ngr,tau,solperm,t,tol,lambd,dd 
       close(3)
c parameters(r1 first grid point r2 second grid point)
c      reading of r1 and r2  
       open(3, file='full.data', status='old')      
        read(3,104) r1,r2          
       close(3)
104    format(1x,f12.7) 
       dr=r2-r1
!      print*, r1,r2,dr
       call risminput(nv,nu,ngr,dr,r1,tau,
     * solperm,icr,t,tol,lambd,icl,dd) 
 102   format(4(1x,i4),1x,i8,5(2x,e9.4),1x,i4) 
       stop
       end 
cccc
       subroutine risminput(nv,nu,ngr,dr,r1,tau,
     * solperm,icr,t,tol,lambd,icl,dd) 
       implicit none
       integer  nu, isu(1:nu), mu(1:nu)
       real*8 wu(1:nu,1:nu,1:ngr),sgvv(1:nv)
       real*8 xu(1:nu),yu(1:nu),zu(1:nu),sigu(1:nu)
       real*8 epsiu(1:nu),qqu(1:nu) 
       integer  nv, ngr, isv(1:nv), mv(1:nv)
       real*8 den(1:nv),xv(1:nv),yv(1:nv),zv(1:nv),sigv(1:nv)
       real*8 epsiv(1:nv),qqv(1:nv)    
       real*8 sigvv(1:nv), epsvv(1:nv),qvv(1:nv)
       integer  i, icr, icl,nvv,ims(1:nv),nd,k,dd       
       real*8 r1,dr, dk, rgrid(1:ngr),kgrid(1:ngr),pi 
       character (4) tv(1:nv), tu(1:nu)
       real*8 tau,solperm,t, tol,lambd,kb
       integer j1,j
       real*8 c3(1:nu,1:nv,1:ngr),hu(1:nu,1:nv,1:ngr) 
       real*8 gam(1:nu,1:nv,1:ngr)
c
c      solvent input
c tv type of cite isv type of species mv multiplicity  den density (1/a3) xvyvzv[xyz](a) 
c sigv  sigma(a) epsiv epsilon(kj/mol) qqv charge(e)
c      number of lines in solvt..data should be equal nv
       open(3, file='solvent3.data', status='old')      
        do i=1,nv
         read(3,103)tv(i),isv(i),mv(i),den(i),  
     *   xv(i),yv(i),zv(i),sigv(i), epsiv(i),qqv(i) 
!        print *, tv(i),isv(i),mv(i),den(i),  
!    *   xv(i),yv(i),zv(i),sigv(i), epsiv(i),qqv(i)  
        enddo
       close(3)
 103   format(a4,2x,i4,2x,i4,7(2x,e10.4))
c
c      sorting
       call sort(nv,tv,isv,mv,ims,nvv) 
!      print*, (ims(i), i=1,nv)
c      calculations interaction parameters for reduced matrix
       call vpot(nv,ims,nvv,sigv,epsiv,qqv,sgvv,epsvv,qvv)
!      do i=1,nvv 
!       print*, sgvv(i),epsvv(i),qvv(i),i,ims(i)
!      enddo
c
c      solute input
c tu type of cite isu type of species mu multiplicity  xuyuzu[xyz](a) 
c      sigu sigma(a) epsiu epsilon(kj/mol) qqu charge(e)
       open(3, file='solute2.data', status='old')      
        do i=1,nu
         read(3,102)tu(i),isu(i),mu(i),  
     *   xu(i),yu(i),zu(i),sigu(i),epsiu(i),qqu(i) 
         print *,tu(i),isu(i),mu(i),  
     *   xu(i),yu(i),zu(i),sigu(i),epsiu(i),qqu(i)
        enddo
       close(3)
 102   format(a4,2x,i4,2x,i4,6(2x,e10.4))                
c
c      creat rgrid rgrd(i) creat kgrid kgrid(i)
       pi=2*asin(1.0)
c      the zero point is excluded
       r1=dr   
       dk=pi/(ngr+1)/dr
       do i=1,ngr
        rgrid(i)=r1+dr*(i-1) 
        kgrid(i)=i*dk 
       enddo 
c
c      wu(i,j,k) intramolecular solute function
       call wucreat(nu,ngr,kgrid,tu,isu,xu,yu,zu,wu) 
!      do k=1,ngr,40
!       print*, (wu(1,i,k), i=1,9)
!      enddo
c       
       call rism(nu,nv,nvv,ngr,icl,kgrid,rgrid,tv,isv,den,mv,xv,yv,zv,
     * icr,ims,tau,solperm,sgvv,epsvv,qvv,sigu,epsiu,qqu,t,lambd,
     * tol,wu,dd)          
       return
       end subroutine 
cccc
c
c subroutine for rearrangement of the solvent data which excludes the same sites
c defined by paramters tv and mv
c
       subroutine sort(nv,tv,isv,mv,ims,nvv)
       implicit none
       integer  nv, isv(1:nv), mv(1:nv),ims(1:nv),mvt(1:nv)
       integer  i,i1,j1,j2,icc,imm(1:nv),max,nvv      
       character (4) tv(1:nv)
c
c      initialization of connectivity vector      
       do i=1,nv
        ims(i)=i 
        imm(i)=1
        mvt(i)=mv(i)  
       enddo
c      sorting 
       do j1=1,nv-1
        do j2=j1+1,nv
         if((tv(j1).eq.tv(j2)).and.(isv(j1).eq.isv(j2))
     *    .and.(mv(j2).ne.1)) then 
c         replace current value of ims by the first found
          ims(j2)=ims(j1)
c         change indicator of replacement
          imm(j2)=2
c         change multiplicity
          mv(j2)=1 
c         shift all others except replaced by 1
          if(j2.ne.nv) then
           do i1=j2+1,nv
            if(imm(i1).eq.1) then  
             ims(i1)=ims(i1)-1
             else 
             ims(i1)=ims(i1)
            endif 
           enddo
          endif  
          else 
          ims(j2)=ims(j2)
         endif
!       print*, j2,ims(j2),mv(j2),imm(j2)
        enddo
       enddo
c      evaluation of maximal value of different sites
       max=ims(1) 
       do i=2,nv
        if(ims(i).ge.max) then
         max=ims(i)
         else
         max=max 
        endif
       enddo
       nvv=max
c      replace changed mv by the initial one 
       do i=1,nv
        mv(i)=mvt(i)
       enddo
       return
       end subroutine 
c
c      subroutine for calculation potential parameters for reduced matrix
c
       subroutine vpot(nv,ims,nvv,sigv,epsiv,qqv,sgvv,epsvv,qvv) 
       implicit none
       integer  nv,nvv 
       real*8 sgvv(1:nvv),epsvv(1:nvv),qvv(1:nvv)        
       real*8 sigv(1:nv),epsiv(1:nv),qqv(1:nv)    
       integer  i,ims(1:nv),j1,j2,icr       
       do i=1,nv  
        sgvv(ims(i))=sigv(i)
        epsvv(ims(i))=epsiv(i)
        qvv(ims(i))=qqv(i)
!       print*, sgvv(ims(i)),sigv(i),i,ims(i)
       enddo 
       return
       end subroutine
c
c      prepration of wu(i,j,k) intramoplecular solute matrix
c
       subroutine wucreat(nu,ngr,kgrid,tu,isu,xu,yu,zu,wu)
       implicit none
       integer  nu, ngr, isu(1:nu), mu(1:nu)
       real*8 wu(1:nu,1:nu,1:ngr), dist(1:nu,1:nu)
       real*8 xu(1:nu),yu(1:nu),zu(1:nu)   
       integer  i, j1,j2,icr       
       real*8 kgrid(1:ngr),sik  
       character (4) tu(1:nu) 
c      dis(i,j) intramolecular distances      
       do i=1,ngr
        do j1=1,nu
         do j2=1,nu
          dist(j1,j2)=(((xu(j1)-xu(j2))**2+(yu(j1)-yu(j2))**2+
     *    (zu(j1)-zu(j2))**2))**(1.0/2)
          wu(j1,j2,i)=sik(kgrid(i)*dist(j1,j2))
         enddo
        enddo
       enddo 
       return
       end subroutine 
c
       real*8 function sik(x)
       real*8 x
       if(x.lt.1d-22)then
        sik=1
       else
       sik=sin(x)/x
       endif
       return
       end
c
c creat susceptibility of solvent
c
       subroutine chicreat(nd,nv,ngr,ims,nvv,kgrid,tv,
     * isv,den,mv,xv,yv,zv,chi) 
       implicit none
       real*8 wv(1:nvv,1:nvv,1:ngr), chi(1:nvv,1:nvv,1:ngr),hd(1:ngr)
       integer  nv, ngr, isv(1:nv), mv(1:nv)
       real*8 den(1:nv),xv(1:nv),yv(1:nv),zv(1:nv),sigv(1:nv)    
       integer  i,j,j1,j2,icr,nvv,ims(1:nv),nd       
       real*8 r1, r2, dr, dk, rgrid(1:ngr),kgrid(1:ngr),pi
       real*8 hsol(1:nd,1:ngr), rr(1:ngr)
       real*8 h1(1:nvv,1:nvv,1:ngr),h2(1:ngr),h3(1:nvv,1:nvv,1:ngr)
       character (4) tv(1:nv)
       pi=2*asin(1.0)
       
c 
c reading of solvent rdfs 
        open(3, file='full.data', status='old')      
        do i=1,ngr
         read(3,104) rr(i), (hsol(j,i), j=1,nd)
        enddo
       close(3)
104    format(11(1x,f12.7)) 
       dr=rr(2)-rr(1) 
!      do i=1,ngr,40
!       print*, (hsol(j,i), j=1,9)
!      enddo
c 
c      sin fft transform of rdfs with proper arrangement in array
       do j=1,nvv
        do j1=j,nvv
         do i=2,ngr 
          h1(j,j1,i)=(hsol(nvv*(j-1)-j*(j-1)/2+j1,i)-1)*rr(i) 
          h2(i)=h1(j,j1,i)
         enddo
         call sinft(h2,ngr)
c        normalization of sin-fft with excluding the zeropoint (x=0)
         do i=1,ngr-1
          h3(j,j1,i)=h2(i+1)/kgrid(i)
         enddo
         h3(j,j1,ngr)=h3(j,j1,ngr-1)
        enddo
       enddo
c      symmetric indeces
       do j=1,nvv
        do j1=j,nvv
         do i=1,ngr 
          h3(j1,j,i)=h3(j,j1,i)
         enddo           
        enddo
       enddo
!      do i=1,ngr,40       
!       print*, (h3(j,3,i), j=1,4) 
!      enddo 
c
c wv(i,j,k) intramolecular solvent function
c
       call wcreat(nv,ngr,nvv,ims,kgrid,tv,isv,xv,yv,zv,wv) 
!      do i=1,ngr,40
!       print*, (wv(1,j1,i), j1=1,nvv)
!      enddo
c
c chi(i,j,k) solvent susceptibility
c      
       dr=rr(2)-rr(1)   
       do i=1,ngr
        do j1=1,nv
         do j2=1,nv
          chi(ims(j1),ims(j2),i)=wv(ims(j1),ims(j2),i)
     *    +4*pi*dr*mv(j1)*mv(j2)*den(j1)*h3(ims(j1),ims(j2),i)
         enddo
        enddo      
       enddo
!      do i=1,ngr,40
!       print*, (chi(2,j,i), j=1,4) 
!      enddo
       return
       end subroutine 
c
c caculation of reduced solvent matrix
c
       subroutine wcreat(nv,ngr,nvv,ims,kgrid,tv,isv,xv,yv,zv,wv) 
       implicit none
       real*8 wv(1:nvv,1:nvv,1:ngr),dist(1:nv,1:nv)
       real*8 ws(1:nv,1:nvv,1:ngr)
       integer  nv, ngr, isv(1:nv),mv(1:nv)
       real*8 den(1:nv),xv(1:nv),yv(1:nv),zv(1:nv),sigv(1:nv)    
       integer  i, j1,j2,nvv,ims(1:nv),t       
       real*8 kgrid(1:ngr),pi,sik,co(1:nv,1:nv,1:ngr) 
       character (4) tv(1:nv)
       pi=2*asin(1.0)  
c
c      initialization of wv(i,j,k) & calculating of the 11 element
c
       do i=1, ngr         
        do j1=1,nv
         do j2=1,nv          
           wv(ims(j1),ims(j2),i)=0
           ws(j1,ims(j2),i)=0  
         enddo
        enddo
       enddo            
c      dist(i,j) distance between i and j sites
c      co(i,j,k) sik between i and j sites
c      reducing number of coloumns
       do i=1,ngr
        do j1=1,nv       
         do j2=1,nv
c         calculations all other columns
c         if they belong to the same molecule
          if(isv(j1).eq.isv(j2)) then        
           dist(j1,j2)=(((xv(j1)-xv(j2))**2+
     *     (yv(j1)-yv(j2))**2+(zv(j1)-zv(j2))**2))**(1.0/2)           
           co(j1,j2,i)=sik(kgrid(i)*dist(j1,j2))
           ws(j1,ims(j2),i)= ws(j1,ims(j2),i)+co(j1,j2,i)
          endif
         enddo  
        enddo 
       enddo
c      reducing the number of rows 
       do i=1,ngr        
        do j2=1,nvv       
         do j1=1,nv   
          wv(ims(j1),j2,i)=wv(ims(j1),j2,i)+ws(j1,j2,i)        
         enddo  
        enddo
       enddo 
!      do i=1,ngr,40
!       print*, (wv(1,j1,i), j1=1,nvv)
!      enddo
       return
       end subroutine 
c
c  creat solute-solvent potentials
c
       subroutine potcreat(nvv,nu,ngr,icr,kgrid,rgrid,tau,solperm,
     * sgvv,epsvv,qvv,sigu,epsiu,qqu,plj,ul) 
       implicit none
       integer  nu,nv, ngr,nvv 
       real*8 sigu(1:nu),epsiu(1:nu),qqu(1:nu)        
       real*8 sgvv(1:nvv),epsvv(1:nvv),qvv(1:nvv)    
       integer  i, j1,j2,icr       
       real*8 r1, r2, dr, dk, rgrid(1:ngr),kgrid(1:ngr),pi 
       real*8 sigvv(1:nu,1:nvv), epsivv(1:nu,1:nvv)     
       real*8 ul(1:nu,1:nvv,1:ngr),plj(1:nu,1:nvv,1:ngr)
       real*8 nav,tau, echar,solperm,uthre,ck 
c      constants for potential
       pi=2*asin(1.0)
       nav=6.02214179e+23
       echar=4.803e-10
       ck=nav*echar**2/solperm*0.01
       uthre=1000   
c
c calculation lj parameters
       call combrule(nu,nvv,icr,sgvv,sigu,epsiu,epsvv,sigvv,epsivv)
c
c plj(j1,j2,r) lj potential+short part from coulomb
c ul(j1,j2,k) is the fourier trasnform of long range interactions
       do i=1,ngr 
        do j1=1,nu
         do j2=1,nvv
          ul(j1,j2,i)=4*pi*ck*qqu(j1)*qvv(j2)*exp(-kgrid(i)**2/4/tau**2)
          ul(j1,j2,i)=ul(j1,j2,i)/kgrid(i)**2
          plj(j1,j2,i)=4*epsivv(j1,j2)*
     *    ((sigvv(j1,j2)/rgrid(i))**(12)-(sigvv(j1,j2)/rgrid(i))**(6))
          plj(j1,j2,i)=plj(j1,j2,i)+ck
     *    *qqu(j1)*qvv(j2)/rgrid(i)*(1-erf(tau*rgrid(i)))
          if (plj(j1,j2,i).ge. uthre) then 
           plj(j1,j2,i)=uthre
          endif 
         enddo
        enddo
       enddo
!      do i=1,40
!       print*, (plj(1,j1,i), j1=1,4)
!      enddo 
       return
       end subroutine 
c
c   calculations of parameters for solute-solvent interactions
c
       subroutine combrule(nu,nvv,icr,sgvv,sigu,
     * epsiu,epsvv,sigvv,epsivv) 
       implicit none
       integer  nu, nv, icr,nvv
       real*8 sigu(1:nu), epsiu(1:nu), sgvv(1:nvv), epsvv(1:nvv)          
       real*8 sigvv(1:nu,1:nvv), epsivv(1:nu,1:nvv)
       integer  i, j1,j2   
       do j1=1,nu
        do j2=1,nvv
         epsivv(j1,j2)=(epsiu(j1)*epsvv(j2))**(1.0/2)
         if (icr.eq.1) then
          sigvv(j1,j2)=(sigu(j1)+sgvv(j2))/2
          else
          sigvv(j1,j2)=(sigu(j1)*sgvv(j2))**(1.0/2)
         endif
!        print *, sigvv(j1,j2), epsivv(j1,j2), j1,j2
        enddo
       enddo
       return
       end subroutine  
c 
c site-site ornstein-zernike in k-space
c
       subroutine ssoz(nvv,nu,ngr,nv,ims,mv,wu,c3,chi,hu)
       implicit none
       integer  nu, nvv, nv, ngr, i,j1,j,k1,ims(1:nv),mv(1:nv)        
       real*8 rgrid(1:ngr),kgrid(1:ngr)  
       real*8 pi,ct
       real*8 c3(1:nu,1:nvv,1:ngr),hu(1:nu,1:nvv,1:ngr)
       real*8 ctt(1:nu,1:nvv,1:ngr),h1(1:nu,1:nvv,1:ngr)
       real*8 wu(1:nu,1:nu,1:ngr), chi(1:nvv,1:nvv,1:ngr)  
c      calculations of right product of matrix via summation over solvent sites         
       do i=1,ngr
        do j1=1,nu 
         do j=1,nvv
          ct=0
          do k1=1,nvv
           ct=c3(j1,k1,i)*chi(k1,j,i)+ct
          enddo 
          ctt(j1,j,i)=ct
         enddo
        enddo
       enddo
!      do i=1,ngr,40       
!       print*, (ctt(1,j,i), j=1,4) 
!      enddo 
c      calculations of left product of matrix via summation over solute sites        
       do i=1,ngr
        do j1=1,nu 
         do j=1,nvv
          ct=0
          do k1=1,nu
           ct=wu(j1,k1,i)*ctt(k1,j,i)+ct
          enddo 
          hu(j1,j,i)=ct
          h1(j1,j,i)=hu(j1,j,i)
         enddo
        enddo
       enddo
       do i=1,ngr
        do j1=1,nu 
         do j=1,nv
          hu(j1,ims(j),i)=h1(j1,ims(j),i)/mv(j)
         enddo
        enddo
       enddo
!      do i=1,ngr,40       
!       print*, (hu(1,j,i),h1(1,j,i), j=1,4)  
!      enddo 
       return
       end subroutine
c
c  subroutine for closure
c                       
       subroutine clos(nvv,nu,ngr,t,plj,cr,gam,icl)
       implicit none
       integer  nu, nvv, ngr, i,j1,j,icl
       real*8 plj(1:nu,1:nvv,1:ngr)          
       real*8 t, kb,pi,lexp
       real*8 cr(1:nu,1:nvv,1:ngr),gam(1:nu,1:nvv,1:ngr)           
       kb=8.13441e-3 
       do i=1,ngr
        do j=1,nu
         do j1=1,nvv
          if(icl.eq.1) then
           cr(j,j1,i)=exp(-1.0/kb/t*plj(j,j1,i)+gam(j,j1,i))
     *     -gam(j,j1,i)-1
          endif  
          if(icl.eq.2) then
           cr(j,j1,i)=lexp(-1.0/kb/t*plj(j,j1,i)+gam(j,j1,i))
     *     -gam(j,j1,i)-1
          endif
         enddo
        enddo
       enddo
       return
       end subroutine 
c
       real*8 function lexp(x)
       real*8 x
       if(x.le.0.0)then
        lexp=exp(x)
        else
        lexp=1+x
       endif
       return
       end      
c
ccc
c    
       subroutine rism(nu,nv,nvv,ngr,icl,kgrid,rgrid,tv,isv,
     * den,mv,xv,yv,zv,
     * icr,ims,tau,solperm,sgvv,epsvv,qvv,sigu,epsiu,qqu,t,
     * lambd,tol,wu,dd)       
       implicit none
c      parameters
       integer  nu, nv,nd,nvv, ngr, i,j1,j,k1,icl,k        
       real*8 rgrid(1:ngr),kgrid(1:ngr)  
       real*8 pi,dk,t,tau,solperm,tol,lambd,del0,kb,dr
c      solute
       real*8 wu(1:nu,1:nu,1:ngr), chi(1:nvv,1:nvv,1:ngr)   
       real*8 sigu(1:nu),epsiu(1:nu),qqu(1:nu)
c      solvent 
       integer  icr,isv(1:nv),mv(1:nv),ims(1:nv)
       real*8 den(1:nv),xv(1:nv),yv(1:nv),zv(1:nv)  
       real*8 wv(1:nvv,1:nvv,1:ngr)
       real*8 sgvv(1:nvv),epsvv(1:nvv),qvv(1:nvv)
       character (4) tv(1:nv)
c      potential
       real*8 plj(1:nu,1:nvv,1:ngr), ul(1:nu,1:nvv,1:ngr)
c      functions
       real*8 cr(1:nu,1:nvv,1:ngr),c2(1:ngr),tt(1:nu,1:nvv)  
       real*8 ht(1:ngr),c3(1:nu,1:nvv,1:ngr),cf3(1:nu,1:nvv,1:ngr)
       real*8 cold(1:nu,1:nvv,1:ngr),cnew(1:nu,1:nvv,1:ngr)
       real*8 gfold(1:nu,1:nvv,1:ngr),hu(1:nu,1:nvv,1:ngr) 
       real*8 gold(1:nu,1:nvv,1:ngr), gnew(1:nu,1:nvv,1:ngr)   
       real*8 hold(1:nu,1:nvv,1:ngr), hnew(1:nu,1:nvv,1:ngr)             
       real*8 del(1:nu,1:nvv),mmaxi,mmax(1:nu),mmmax 
c      diis functions and counts
       real*8 ggo(1:dd,1:nu,1:nvv,1:ngr),dgg(1:dd,1:nu,1:nvv,1:ngr)
       integer kd,dd 
c
       pi=2*asin(1.0)       
c      nd total number of different rdfs
       nd=(nvv+1)*nvv/2     
c      chi(i,j,k) solvent susceptibility
c
       call chicreat(nd,nv,ngr,ims,nvv,kgrid,tv,isv,den,mv,xv,yv,zv,chi) 
!      do i=1,ngr,40 
!       print*, (chi(2,j,i), j=1,4) 
!      enddo
c
c      plj(j1,j2,r) lj potential+short part from coulomb
c      ul(j1,j2,k) is the fourier trasnform of long range interactions
c
       call potcreat(nvv,nu,ngr,icr,kgrid,rgrid,tau,solperm,
     * sgvv,epsvv,qvv,sigu,epsiu,qqu,plj,ul) 
!      do k=1,40
!       print*, (plj(i,1,k), i=1,9)
!      enddo            
cc     initial value of c_short(r)       
       kb=8.13441e-3
       do i=1,ngr
        do j=1,nu
         do j1=1,nvv
          gold(j,j1,i)=0
          cold(j,j1,i)=0
         enddo
        enddo
       enddo  
c      starting counts for diis (kd) and for iterations k1
       k1=1
       kd=1
  1    continue  
c      calculating c_new(r) and h_new(r) from closure
       call clos(nvv,nu,ngr,t,plj,cnew,gold,icl)
       do j=1,nu
        do j1=1,nvv
         do i=1,ngr
          hold(j,j1,i)=gold(j,j1,i)+cnew(j,j1,i) 
         enddo
        enddo
       enddo 
!      do i=1,ngr,40       
!       print*, rgrid(i),(cnew(1,j,i), j=1,4)  
!      enddo          
c      fast fourier transform
       dr=rgrid(2)-rgrid(1)      
       do j=1,nu
        do j1=1,nvv
         c2(1)=0
         do i=1,ngr-1 
          c2(i+1)=cnew(j,j1,i)*rgrid(i) 
         enddo
         call sinft(c2,ngr)
c        normalization of sin-fft with excluding the zeropoint (x=0)
         do i=1,ngr-1
          cf3(j,j1,i)=4*pi*c2(i+1)/kgrid(i)*dr 
         enddo
         cf3(j,j1,ngr)=cf3(j,j1,ngr-1) 
        enddo
       enddo       
!      do i=1,40       
!       print*, kgrid(i), (cf3(1,j1,i), j1=1,4) 
!      enddo        
       dk=kgrid(2)-kgrid(1)
       pi=2*asin(1.0)       
c       adding the long-range potential to c_short 
c
       do i=1,ngr
        do j=1,nu
         do j1=1,nvv
          cf3(j,j1,i)=cf3(j,j1,i)-1.0/kb/t*ul(j,j1,i)
         enddo
        enddo
       enddo 
c      calculations of fourier transform of h(i,j,k) by
c      site-site ornstein-zerinike equations
c       
       call ssoz(nvv,nu,ngr,nv,ims,mv,wu,cf3,chi,hu)
!      do i=1,ngr,40       
!       print*, (hu(1,j,i), j=1,4)  
!      enddo 
c      inverse fourier transform of h(i,j,k) & calculations of gamma(i,i,r) 
       do j=1,nu
        do j1=1,nvv
         ht(1)=0
         do i=1,ngr-1 
          ht(i+1)=hu(j,j1,i)*kgrid(i)         
         enddo
         call sinft(ht,ngr)
         do i=1,ngr-1
          hnew(j,j1,i)=ht(i+1)*dk/2/rgrid(i)/pi**2
          gnew(j,j1,i)=hnew(j,j1,i)-cnew(j,j1,i) 
         enddo   
         gnew(j,j1,ngr)=gnew(j,j1,ngr-1)
         hnew(j,j1,ngr)=hnew(j,j1,ngr-1) 
        enddo
       enddo 
!      do i=1,40       
!       print*, (gnew(1,j,i), j=1,4)  
!      enddo                      
c      intialization del
       do j=1,nu
        do j1=1,nvv
         del(j,j1)=0
        enddo
       mmax(j)=0 
       enddo
       mmaxi=0 
c      evaluation of accuracy
       do j=1,nu
        do j1=1,nvv
         do i=1,ngr
          del(j,j1)=del(j,j1)+(gnew(j,j1,i)-gold(j,j1,i))**2                                
         enddo
         mmax(j)=del(j,j1)+mmax(j)                 
        enddo
        mmaxi=mmaxi+mmax(j)  
       enddo  
!      do j=1,nu
!      print*, (del(j,j1), j1=1,4),mmmax  
!      enddo
c      normalization
       del0=(mmaxi/ngr/nu/nvv)**(1.0/2)
c      diis procedure
       call  diis(nu,nvv,ngr,lambd,kd,dd,gold,gnew,ggo,dgg)
c      old functions as new functions for new cycle
       do j=1,nu
        do j1=1,nvv
         do i=1,ngr
          gold(j,j1,i)=gnew(j,j1,i)
          cold(j,j1,i)=cnew(j,j1,i) 
         enddo    
        enddo
       enddo 
  107  format(9(1x,e10.4))
       k1=k1+1 
       print*, k1,kd,del0       
       if(k1.ge.700) goto 2         
        if(del0.ge.tol) goto 1
 2     continue  
       open(3, file='g1.data', status='old')  
        do k=1,ngr        
         write(3,107)(gnew(1,i,k)+cnew(1,i,k), i=1,4)  
        enddo
       close(3)
       return 
       end subroutine
c 
c      subroutine for evaluation diis residues dgg and matrix coefficients ss
c
       subroutine diis(nu,nvv,ngr,lam,k1,dd,hold,hnew,ggo,dgg)
       implicit none
       real*8 ggo(1:dd,1:nu,1:nvv,1:ngr),dgg(1:dd,1:nu,1:nvv,1:ngr)
       real*8 ss(1:dd+1,1:dd+1),hold(1:nu,1:nvv,1:ngr)
       real*8 s0(1:dd+1),s1,lam,hnew(1:nu,1:nvv,1:ngr)
       integer k1,dd,jd,jd1
       integer j,j1,i,nu,nvv,ngr
       integer ipiv(1:dd+1),info
c      initialization of overlap matrix for diis
       do jd=1,dd
        do jd1=1,dd
         ss(jd,jd1)=0
        enddo
        s0(jd)=0
        ss(jd,dd+1)=-1
        ss(dd+1,jd)=-1
       enddo
       ss(dd+1,dd+1)=0 
       s0(dd+1)=-1
c      calculation of basis
       do j=1,nu
        do j1=1,nvv
         do i=1,ngr     
          ggo(k1,j,j1,i)=hnew(j,j1,i) 
          dgg(k1,j,j1,i)=hnew(j,j1,i)-hold(j,j1,i)
c         calculation of elements of overlaping  matrix
          if(k1.eq.dd) then
           do jd=1,dd
            do jd1=jd,dd        
             ss(jd,jd1)=(dgg(jd,j,j1,i)*dgg(jd1,j,j1,i))/ngr+ss(jd,jd1)
c            symmerization
             ss(jd1,jd)=ss(jd,jd1)
            enddo
           enddo
          endif
         enddo
        enddo 
       enddo
c      solution of diis equation and change of baisis
       if(k1.eq.dd) then
        do jd=1,dd 
c        print*, (ss(jd,jd1), jd1=1,dd)
        enddo     
        call dgesv(dd+1,1,ss,dd+1,ipiv,s0,dd+1,info)            
        do i=1,ngr
         do j=1,nu
          do j1=1,nvv
           s1=0
c          calculation sum for new solution
           do jd=1,dd          
            s1=s1+s0(jd)*ggo(jd,j,j1,i)+lam*s0(jd)*dgg(jd,j,j1,i)  
           enddo
c          change of  diis basis
           do jd=1,dd-1           
            ggo(jd,j,j1,i)=ggo(jd+1,j,j1,i)
            dgg(jd,j,j1,i)=dgg(jd+1,j,j1,i)  
           enddo
           hnew(j,j1,i)=s1
          enddo
         enddo
        enddo 
       endif
c      matrix singular or has illegal value see dgeesv
       if((k1.eq.dd).and.(info.ne.0)) then 
        k1=1
        print*, info
        go to 1
       endif        
c      change count for diis                  
       if(k1.lt.dd) then
        k1=k1+1
        else 
        k1=dd
       endif  
 1     continue    
       return
       end subroutine
c
c uses realft
c calculates the sine transform of a set of n real-valued data points stored in array y(1:n).
c the number n must be a power of 2. on exit y is replaced by its transform. this program,
c without changes, also calculates the inverse sine transform, but in this case the output array
c should be multiplied by 2/n.
c
      subroutine sinft(y,n)
      integer n
      real*8 y(n)
      integer j
      real*8 sum,y1,y2
      double precision theta,wi,wpi,wpr,wr,wtemp
      theta=3.141592653589793d0/dble(n)
      wr=1.0d0
      wi=0.0d0
      wpr=-2.0d0*sin(0.5d0*theta)**2
      wpi=sin(theta)
      y(1)=0.0
      do 11 j=1,n/2
        wtemp=wr
        wr=wr*wpr-wi*wpi+wr
        wi=wi*wpr+wtemp*wpi+wi
        y1=wi*(y(j+1)+y(n-j+1))
        y2=0.5*(y(j+1)-y(n-j+1))
        y(j+1)=y1+y2
        y(n-j+1)=y1-y2
11    continue
      call realft(y,n,+1)
      sum=0.0
      y(1)=0.5*y(1)
      y(2)=0.0
      do 12 j=1,n-1,2
        sum=sum+y(j)
        y(j)=y(j+1)
        y(j+1)=sum
12    continue
      return
      end subroutine
c
cc uses four1
c calculates the fourier transform of a set of n real-valued data points. replaces this data
c (which is stored in array data(1:n)) by the positive frequency half of its complex fourier
c transform. the real-valued rst and last components of the complex transform are returned
c as elements data(1) and data(2), respectively. n must be a power of 2. this routine
c also calculates the inverse transform of a complex data array if it is the transform of real
c data. (result in this case must be multiplied by 2/n.)
c
      subroutine realft(data,n,isign)
      integer isign,n
      real*8 data(n)
      integer i,i1,i2,i3,i4,n2p3
      real*8 c1,c2,h1i,h1r,h2i,h2r,wis,wrs
      double precision theta,wi,wpi,wpr,wr,wtemp
      theta=3.141592653589793d0/dble(n/2)
      c1=0.5
      if (isign.eq.1) then
        c2=-0.5
        call four1(data,n/2,+1)
      else
        c2=0.5
        theta=-theta
      endif
      wpr=-2.0d0*sin(0.5d0*theta)**2
      wpi=sin(theta)
      wr=1.0d0+wpr
      wi=wpi
      n2p3=n+3
      do 11 i=2,n/4
        i1=2*i-1
        i2=i1+1
        i3=n2p3-i2
        i4=i3+1
        wrs=sngl(wr)
        wis=sngl(wi)
        h1r=c1*(data(i1)+data(i3))
        h1i=c1*(data(i2)-data(i4))
        h2r=-c2*(data(i2)+data(i4))
        h2i=c2*(data(i1)-data(i3))
        data(i1)=h1r+wrs*h2r-wis*h2i
        data(i2)=h1i+wrs*h2i+wis*h2r
        data(i3)=h1r-wrs*h2r+wis*h2i
        data(i4)=-h1i+wrs*h2i+wis*h2r
        wtemp=wr
        wr=wr*wpr-wi*wpi+wr
        wi=wi*wpr+wtemp*wpi+wi
11    continue
      if (isign.eq.1) then
        h1r=data(1)
        data(1)=h1r+data(2)
        data(2)=h1r-data(2)
      else
        h1r=data(1)
        data(1)=c1*(h1r+data(2))
        data(2)=c1*(h1r-data(2))
        call four1(data,n/2,-1)
      endif
      return
      end subroutine
cc replaces data(1:2*nn) by its discrete fourier transform, if isign is input as 1; or replaces
c data(1:2*nn) by nn times its inverse discrete fourier transform, if isign is input as -1.
c data is a complex array of length nn or, equivalently, a real array of length 2*nn. nn
c must be an integer power of 2 (this is not checked for!).
      subroutine four1(data,nn,isign)
      integer isign,nn
      real*8 data(2*nn)
      integer i,istep,j,m,mmax,n
      real*8 tempi,tempr
      double precision theta,wi,wpi,wpr,wr,wtemp
      n=2*nn
      j=1
      do 11 i=1,n,2
        if(j.gt.i)then
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        endif
        m=n/2
1       if ((m.ge.2).and.(j.gt.m)) then
          j=j-m
          m=m/2
        goto 1
        endif
        j=j+m
11    continue
      mmax=2
2     if (n.gt.mmax) then
        istep=2*mmax
        theta=6.28318530717959d0/(isign*mmax)
        wpr=-2.d0*sin(0.5d0*theta)**2
        wpi=sin(theta)
        wr=1.d0
        wi=0.d0
        do 13 m=1,mmax,2
          do 12 i=m,n,istep
            j=i+mmax
            tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
            tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
            data(j)=data(i)-tempr
            data(j+1)=data(i+1)-tempi
            data(i)=data(i)+tempr
            data(i+1)=data(i+1)+tempi
12        continue
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
13      continue
        mmax=istep
      goto 2
      endif
      return
      end subroutine
ccc lapack subroutines
ccc
      subroutine dgesv( n, nrhs, a, lda, ipiv, b, ldb, info )
*
*  -- lapack driver routine (version 3.2) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     november 2006
*
*     .. scalar arguments ..
      integer            info, lda, ldb, n, nrhs
*     ..
*     .. array arguments ..
      integer            ipiv( * )
      double precision   a( lda, * ), b( ldb, * )
*     ..
*
*  purpose
*  =======
*
*  dgesv computes the solution to a real system of linear equations
*     a * x = b,
*  where a is an n-by-n matrix and x and b are n-by-nrhs matrices.
*
*  the lu decomposition with partial pivoting and row interchanges is
*  used to factor a as
*     a = p * l * u,
*  where p is a permutation matrix, l is unit lower triangular, and u is
*  upper triangular.  the factored form of a is then used to solve the
*  system of equations a * x = b.
*
*  arguments
*  =========
*
*  n       (input) integer
*          the number of linear equations, i.e., the order of the
*          matrix a.  n >= 0.
*
*  nrhs    (input) integer
*          the number of right hand sides, i.e., the number of columns
*          of the matrix b.  nrhs >= 0.
*
*  a       (input/output) double precision array, dimension (lda,n)
*          on entry, the n-by-n coefficient matrix a.
*          on exit, the factors l and u from the factorization
*          a = p*l*u; the unit diagonal elements of l are not stored.
*
*  lda     (input) integer
*          the leading dimension of the array a.  lda >= max(1,n).
*
*  ipiv    (output) integer array, dimension (n)
*          the pivot indices that define the permutation matrix p;
*          row i of the matrix was interchanged with row ipiv(i).
*
*  b       (input/output) double precision array, dimension (ldb,nrhs)
*          on entry, the n-by-nrhs matrix of right hand side matrix b.
*          on exit, if info = 0, the n-by-nrhs solution matrix x.
*
*  ldb     (input) integer
*          the leading dimension of the array b.  ldb >= max(1,n).
*
*  info    (output) integer
*          = 0:  successful exit
*          < 0:  if info = -i, the i-th argument had an illegal value
*          > 0:  if info = i, u(i,i) is exactly zero.  the factorization
*                has been completed, but the factor u is exactly
*                singular, so the solution could not be computed.
*
*  =====================================================================
*
*     .. external subroutines ..
      external           dgetrf, dgetrs, xerbla
*     ..
*     .. intrinsic functions ..
      intrinsic          max
*     ..
*     .. executable statements ..
*
*     test the input parameters.
*
      info = 0
      if( n.lt.0 ) then
         info = -1
      else if( nrhs.lt.0 ) then
         info = -2
      else if( lda.lt.max( 1, n ) ) then
         info = -4
      else if( ldb.lt.max( 1, n ) ) then
         info = -7
      end if
      if( info.ne.0 ) then
         call xerbla( 'dgesv ', -info )
         return
      end if
*
*     compute the lu factorization of a.
*
      call dgetrf( n, n, a, lda, ipiv, info )
      if( info.eq.0 ) then
*
*        solve the system a*x = b, overwriting b with x.
*
         call dgetrs( 'no transpose', n, nrhs, a, lda, ipiv, b, ldb,
     $                info )
      end if
      return
*
*     end of dgesv
*
      end
ccc
      subroutine dgetrf( m, n, a, lda, ipiv, info )
*
*  -- lapack routine (version 3.2) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     november 2006
*
*     .. scalar arguments ..
      integer            info, lda, m, n
*     ..
*     .. array arguments ..
      integer            ipiv( * )
      double precision   a( lda, * )
*     ..
*
*  purpose
*  =======
*
*  dgetrf computes an lu factorization of a general m-by-n matrix a
*  using partial pivoting with row interchanges.
*
*  the factorization has the form
*     a = p * l * u
*  where p is a permutation matrix, l is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and u is upper
*  triangular (upper trapezoidal if m < n).
*
*  this is the right-looking level 3 blas version of the algorithm.
*
*  arguments
*  =========
*
*  m       (input) integer
*          the number of rows of the matrix a.  m >= 0.
*
*  n       (input) integer
*          the number of columns of the matrix a.  n >= 0.
*
*  a       (input/output) double precision array, dimension (lda,n)
*          on entry, the m-by-n matrix to be factored.
*          on exit, the factors l and u from the factorization
*          a = p*l*u; the unit diagonal elements of l are not stored.
*
*  lda     (input) integer
*          the leading dimension of the array a.  lda >= max(1,m).
*
*  ipiv    (output) integer array, dimension (min(m,n))
*          the pivot indices; for 1 <= i <= min(m,n), row i of the
*          matrix was interchanged with row ipiv(i).
*
*  info    (output) integer
*          = 0:  successful exit
*          < 0:  if info = -i, the i-th argument had an illegal value
*          > 0:  if info = i, u(i,i) is exactly zero. the factorization
*                has been completed, but the factor u is exactly
*                singular, and division by zero will occur if it is used
*                to solve a system of equations.
*
*  =====================================================================
*
*     .. parameters ..
      double precision   one
      parameter          ( one = 1.0d+0 )
*     ..
*     .. local scalars ..
      integer            i, iinfo, j, jb, nb
*     ..
*     .. external subroutines ..
      external           dgemm, dgetf2, dlaswp, dtrsm, xerbla
*     ..
*     .. external functions ..
      integer            ilaenv
      external           ilaenv
*     ..
*     .. intrinsic functions ..
      intrinsic          max, min
*     ..
*     .. executable statements ..
*
*     test the input parameters.
*
      info = 0
      if( m.lt.0 ) then
         info = -1
      else if( n.lt.0 ) then
         info = -2
      else if( lda.lt.max( 1, m ) ) then
         info = -4
      end if
      if( info.ne.0 ) then
         call xerbla( 'dgetrf', -info )
         return
      end if
*
*     quick return if possible
*
      if( m.eq.0 .or. n.eq.0 )
     $   return
*
*     determine the block size for this environment.
*
      nb = ilaenv( 1, 'dgetrf', ' ', m, n, -1, -1 )
      if( nb.le.1 .or. nb.ge.min( m, n ) ) then
*
*        use unblocked code.
*
         call dgetf2( m, n, a, lda, ipiv, info )
      else
*
*        use blocked code.
*
         do 20 j = 1, min( m, n ), nb
            jb = min( min( m, n )-j+1, nb )
*
*           factor diagonal and subdiagonal blocks and test for exact
*           singularity.
*
            call dgetf2( m-j+1, jb, a( j, j ), lda, ipiv( j ), iinfo )
*
*           adjust info and the pivot indices.
*
            if( info.eq.0 .and. iinfo.gt.0 )
     $         info = iinfo + j - 1
            do 10 i = j, min( m, j+jb-1 )
               ipiv( i ) = j - 1 + ipiv( i )
   10       continue
*
*           apply interchanges to columns 1:j-1.
*
            call dlaswp( j-1, a, lda, j, j+jb-1, ipiv, 1 )
*
            if( j+jb.le.n ) then
*
*              apply interchanges to columns j+jb:n.
*
               call dlaswp( n-j-jb+1, a( 1, j+jb ), lda, j, j+jb-1,
     $                      ipiv, 1 )
*
*              compute block row of u.
*
               call dtrsm( 'left', 'lower', 'no transpose', 'unit', jb,
     $                     n-j-jb+1, one, a( j, j ), lda, a( j, j+jb ),
     $                     lda )
               if( j+jb.le.m ) then
*
*                 update trailing submatrix.
*
                  call dgemm( 'no transpose', 'no transpose', m-j-jb+1,
     $                        n-j-jb+1, jb, -one, a( j+jb, j ), lda,
     $                        a( j, j+jb ), lda, one, a( j+jb, j+jb ),
     $                        lda )
               end if
            end if
   20    continue
      end if
      return
*
*     end of dgetrf
*
      end
ccc
      subroutine dgetf2( m, n, a, lda, ipiv, info )
*
*  -- lapack routine (version 3.2) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     november 2006
*
*     .. scalar arguments ..
      integer            info, lda, m, n
*     ..
*     .. array arguments ..
      integer            ipiv( * )
      double precision   a( lda, * )
*     ..
*
*  purpose
*  =======
*
*  dgetf2 computes an lu factorization of a general m-by-n matrix a
*  using partial pivoting with row interchanges.
*
*  the factorization has the form
*     a = p * l * u
*  where p is a permutation matrix, l is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and u is upper
*  triangular (upper trapezoidal if m < n).
*
*  this is the right-looking level 2 blas version of the algorithm.
*
*  arguments
*  =========
*
*  m       (input) integer
*          the number of rows of the matrix a.  m >= 0.
*
*  n       (input) integer
*          the number of columns of the matrix a.  n >= 0.
*
*  a       (input/output) double precision array, dimension (lda,n)
*          on entry, the m by n matrix to be factored.
*          on exit, the factors l and u from the factorization
*          a = p*l*u; the unit diagonal elements of l are not stored.
*
*  lda     (input) integer
*          the leading dimension of the array a.  lda >= max(1,m).
*
*  ipiv    (output) integer array, dimension (min(m,n))
*          the pivot indices; for 1 <= i <= min(m,n), row i of the
*          matrix was interchanged with row ipiv(i).
*
*  info    (output) integer
*          = 0: successful exit
*          < 0: if info = -k, the k-th argument had an illegal value
*          > 0: if info = k, u(k,k) is exactly zero. the factorization
*               has been completed, but the factor u is exactly
*               singular, and division by zero will occur if it is used
*               to solve a system of equations.
*
*  =====================================================================
*
*     .. parameters ..
      double precision   one, zero
      parameter          ( one = 1.0d+0, zero = 0.0d+0 )
*     ..
*     .. local scalars ..
      double precision   sfmin 
      integer            i, j, jp
*     ..
*     .. external functions ..
      double precision   dlamch      
      integer            idamax
      external           dlamch, idamax
*     ..
*     .. external subroutines ..
      external           dger, dscal, dswap, xerbla
*     ..
*     .. intrinsic functions ..
      intrinsic          max, min
*     ..
*     .. executable statements ..
*
*     test the input parameters.
*
      info = 0
      if( m.lt.0 ) then
         info = -1
      else if( n.lt.0 ) then
         info = -2
      else if( lda.lt.max( 1, m ) ) then
         info = -4
      end if
      if( info.ne.0 ) then
         call xerbla( 'dgetf2', -info )
         return
      end if
*
*     quick return if possible
*
      if( m.eq.0 .or. n.eq.0 )
     $   return
*
*     compute machine safe minimum 
* 
      sfmin = dlamch('s')  
*
      do 10 j = 1, min( m, n )
*
*        find pivot and test for singularity.
*
         jp = j - 1 + idamax( m-j+1, a( j, j ), 1 )
         ipiv( j ) = jp
         if( a( jp, j ).ne.zero ) then
*
*           apply the interchange to columns 1:n.
*
            if( jp.ne.j )
     $         call dswap( n, a( j, 1 ), lda, a( jp, 1 ), lda )
*
*           compute elements j+1:m of j-th column.
*
            if( j.lt.m ) then 
               if( abs(a( j, j )) .ge. sfmin ) then 
                  call dscal( m-j, one / a( j, j ), a( j+1, j ), 1 ) 
               else 
                 do 20 i = 1, m-j 
                    a( j+i, j ) = a( j+i, j ) / a( j, j ) 
   20            continue 
               end if 
            end if 
*
         else if( info.eq.0 ) then
*
            info = j
         end if
*
         if( j.lt.min( m, n ) ) then
*
*           update trailing submatrix.
*
            call dger( m-j, n-j, -one, a( j+1, j ), 1, a( j, j+1 ), lda,
     $                 a( j+1, j+1 ), lda )
         end if
   10 continue
      return
*
*     end of dgetf2
*
      end
ccc
      subroutine dger(m,n,alpha,x,incx,y,incy,a,lda)
*     .. scalar arguments ..
      double precision alpha
      integer incx,incy,lda,m,n
*     ..
*     .. array arguments ..
      double precision a(lda,*),x(*),y(*)
*     ..
*
*  purpose
*  =======
*
*  dger   performs the rank 1 operation
*
*     a := alpha*x*y' + a,
*
*  where alpha is a scalar, x is an m element vector, y is an n element
*  vector and a is an m by n matrix.
*
*  arguments
*  ==========
*
*  m      - integer.
*           on entry, m specifies the number of rows of the matrix a.
*           m must be at least zero.
*           unchanged on exit.
*
*  n      - integer.
*           on entry, n specifies the number of columns of the matrix a.
*           n must be at least zero.
*           unchanged on exit.
*
*  alpha  - double precision.
*           on entry, alpha specifies the scalar alpha.
*           unchanged on exit.
*
*  x      - double precision array of dimension at least
*           ( 1 + ( m - 1 )*abs( incx ) ).
*           before entry, the incremented array x must contain the m
*           element vector x.
*           unchanged on exit.
*
*  incx   - integer.
*           on entry, incx specifies the increment for the elements of
*           x. incx must not be zero.
*           unchanged on exit.
*
*  y      - double precision array of dimension at least
*           ( 1 + ( n - 1 )*abs( incy ) ).
*           before entry, the incremented array y must contain the n
*           element vector y.
*           unchanged on exit.
*
*  incy   - integer.
*           on entry, incy specifies the increment for the elements of
*           y. incy must not be zero.
*           unchanged on exit.
*
*  a      - double precision array of dimension ( lda, n ).
*           before entry, the leading m by n part of the array a must
*           contain the matrix of coefficients. on exit, a is
*           overwritten by the updated matrix.
*
*  lda    - integer.
*           on entry, lda specifies the first dimension of a as declared
*           in the calling (sub) program. lda must be at least
*           max( 1, m ).
*           unchanged on exit.
*
*  further details
*  ===============
*
*  level 2 blas routine.
*
*  -- written on 22-october-1986.
*     jack dongarra, argonne national lab.
*     jeremy du croz, nag central office.
*     sven hammarling, nag central office.
*     richard hanson, sandia national labs.
*
*  =====================================================================
*
*     .. parameters ..
      double precision zero
      parameter (zero=0.0d+0)
*     ..
*     .. local scalars ..
      double precision temp
      integer i,info,ix,j,jy,kx
*     ..
*     .. external subroutines ..
      external xerbla
*     ..
*     .. intrinsic functions ..
      intrinsic max
*     ..
*
*     test the input parameters.
*
      info = 0
      if (m.lt.0) then
          info = 1
      else if (n.lt.0) then
          info = 2
      else if (incx.eq.0) then
          info = 5
      else if (incy.eq.0) then
          info = 7
      else if (lda.lt.max(1,m)) then
          info = 9
      end if
      if (info.ne.0) then
          call xerbla('dger  ',info)
          return
      end if
*
*     quick return if possible.
*
      if ((m.eq.0) .or. (n.eq.0) .or. (alpha.eq.zero)) return
*
*     start the operations. in this version the elements of a are
*     accessed sequentially with one pass through a.
*
      if (incy.gt.0) then
          jy = 1
      else
          jy = 1 - (n-1)*incy
      end if
      if (incx.eq.1) then
          do 20 j = 1,n
              if (y(jy).ne.zero) then
                  temp = alpha*y(jy)
                  do 10 i = 1,m
                      a(i,j) = a(i,j) + x(i)*temp
   10             continue
              end if
              jy = jy + incy
   20     continue
      else
          if (incx.gt.0) then
              kx = 1
          else
              kx = 1 - (m-1)*incx
          end if
          do 40 j = 1,n
              if (y(jy).ne.zero) then
                  temp = alpha*y(jy)
                  ix = kx
                  do 30 i = 1,m
                      a(i,j) = a(i,j) + x(ix)*temp
                      ix = ix + incx
   30             continue
              end if
              jy = jy + incy
   40     continue
      end if
*
      return
*
*     end of dger  .
*
      end
ccc
      subroutine dscal(n,da,dx,incx)
*     .. scalar arguments ..
      double precision da
      integer incx,n
*     ..
*     .. array arguments ..
      double precision dx(*)
*     ..
*
*  purpose
*  =======
*
*     dscal scales a vector by a constant.
*     uses unrolled loops for increment equal to one.
*
*  further details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. local scalars ..
      integer i,m,mp1,nincx
*     ..
*     .. intrinsic functions ..
      intrinsic mod
*     ..
      if (n.le.0 .or. incx.le.0) return
      if (incx.eq.1) go to 20
*
*        code for increment not equal to 1
*
      nincx = n*incx
      do 10 i = 1,nincx,incx
          dx(i) = da*dx(i)
   10 continue
      return
*
*        code for increment equal to 1
*
*
*        clean-up loop
*
   20 m = mod(n,5)
      if (m.eq.0) go to 40
      do 30 i = 1,m
          dx(i) = da*dx(i)
   30 continue
      if (n.lt.5) return
   40 mp1 = m + 1
      do 50 i = mp1,n,5
          dx(i) = da*dx(i)
          dx(i+1) = da*dx(i+1)
          dx(i+2) = da*dx(i+2)
          dx(i+3) = da*dx(i+3)
          dx(i+4) = da*dx(i+4)
   50 continue
      return
      end
ccc
      subroutine dswap(n,dx,incx,dy,incy)
*     .. scalar arguments ..
      integer incx,incy,n
*     ..
*     .. array arguments ..
      double precision dx(*),dy(*)
*     ..
*
*  purpose
*  =======
*
*     interchanges two vectors.
*     uses unrolled loops for increments equal one.
*
*  further details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. local scalars ..
      double precision dtemp
      integer i,ix,iy,m,mp1
*     ..
*     .. intrinsic functions ..
      intrinsic mod
*     ..
      if (n.le.0) return
      if (incx.eq.1 .and. incy.eq.1) go to 20
*
*       code for unequal increments or equal increments not equal
*         to 1
*
      ix = 1
      iy = 1
      if (incx.lt.0) ix = (-n+1)*incx + 1
      if (incy.lt.0) iy = (-n+1)*incy + 1
      do 10 i = 1,n
          dtemp = dx(ix)
          dx(ix) = dy(iy)
          dy(iy) = dtemp
          ix = ix + incx
          iy = iy + incy
   10 continue
      return
*
*       code for both increments equal to 1
*
*
*       clean-up loop
*
   20 m = mod(n,3)
      if (m.eq.0) go to 40
      do 30 i = 1,m
          dtemp = dx(i)
          dx(i) = dy(i)
          dy(i) = dtemp
   30 continue
      if (n.lt.3) return
   40 mp1 = m + 1
      do 50 i = mp1,n,3
          dtemp = dx(i)
          dx(i) = dy(i)
          dy(i) = dtemp
          dtemp = dx(i+1)
          dx(i+1) = dy(i+1)
          dy(i+1) = dtemp
          dtemp = dx(i+2)
          dx(i+2) = dy(i+2)
          dy(i+2) = dtemp
   50 continue
      return
      end
ccc
      subroutine xerbla( srname, info )
*
*  -- lapack auxiliary routine (preliminary version) --
*     univ. of tennessee, univ. of california berkeley and nag ltd..
*     november 2006
*
*     .. scalar arguments ..
      character*(*)      srname
      integer            info
*     ..
*
*  purpose
*  =======
*
*  xerbla  is an error handler for the lapack routines.
*  it is called by an lapack routine if an input parameter has an
*  invalid value.  a message is printed and execution stops.
*
*  installers may consider modifying the stop statement in order to
*  call system-specific exception-handling facilities.
*
*  arguments
*  =========
*
*  srname  (input) character*(*)
*          the name of the routine which called xerbla.
*
*  info    (input) integer
*          the position of the invalid parameter in the parameter list
*          of the calling routine.
*
* =====================================================================
*
*     .. intrinsic functions ..
      intrinsic          len_trim
*     ..
*     .. executable statements ..
*
      write( *, fmt = 9999 )srname( 1:len_trim( srname ) ), info
*
      stop
*
 9999 format( ' ** on entry to ', a, ' parameter number ', i2, ' had ',
     $      'an illegal value' )
*
*     end of xerbla
*
      end
ccc
      subroutine dgetrs( trans, n, nrhs, a, lda, ipiv, b, ldb, info )
*
*  -- lapack routine (version 3.2) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     november 2006
*
*     .. scalar arguments ..
      character          trans
      integer            info, lda, ldb, n, nrhs
*     ..
*     .. array arguments ..
      integer            ipiv( * )
      double precision   a( lda, * ), b( ldb, * )
*     ..
*
*  purpose
*  =======
*
*  dgetrs solves a system of linear equations
*     a * x = b  or  a' * x = b
*  with a general n-by-n matrix a using the lu factorization computed
*  by dgetrf.
*
*  arguments
*  =========
*
*  trans   (input) character*1
*          specifies the form of the system of equations:
*          = 'n':  a * x = b  (no transpose)
*          = 't':  a'* x = b  (transpose)
*          = 'c':  a'* x = b  (conjugate transpose = transpose)
*
*  n       (input) integer
*          the order of the matrix a.  n >= 0.
*
*  nrhs    (input) integer
*          the number of right hand sides, i.e., the number of columns
*          of the matrix b.  nrhs >= 0.
*
*  a       (input) double precision array, dimension (lda,n)
*          the factors l and u from the factorization a = p*l*u
*          as computed by dgetrf.
*
*  lda     (input) integer
*          the leading dimension of the array a.  lda >= max(1,n).
*
*  ipiv    (input) integer array, dimension (n)
*          the pivot indices from dgetrf; for 1<=i<=n, row i of the
*          matrix was interchanged with row ipiv(i).
*
*  b       (input/output) double precision array, dimension (ldb,nrhs)
*          on entry, the right hand side matrix b.
*          on exit, the solution matrix x.
*
*  ldb     (input) integer
*          the leading dimension of the array b.  ldb >= max(1,n).
*
*  info    (output) integer
*          = 0:  successful exit
*          < 0:  if info = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. parameters ..
      double precision   one
      parameter          ( one = 1.0d+0 )
*     ..
*     .. local scalars ..
      logical            notran
*     ..
*     .. external functions ..
      logical            lsame
      external           lsame
*     ..
*     .. external subroutines ..
      external           dlaswp, dtrsm, xerbla
*     ..
*     .. intrinsic functions ..
      intrinsic          max
*     ..
*     .. executable statements ..
*
*     test the input parameters.
*
      info = 0
      notran = lsame( trans, 'n' )
      if( .not.notran .and. .not.lsame( trans, 't' ) .and. .not.
     $    lsame( trans, 'c' ) ) then
         info = -1
      else if( n.lt.0 ) then
         info = -2
      else if( nrhs.lt.0 ) then
         info = -3
      else if( lda.lt.max( 1, n ) ) then
         info = -5
      else if( ldb.lt.max( 1, n ) ) then
         info = -8
      end if
      if( info.ne.0 ) then
         call xerbla( 'dgetrs', -info )
         return
      end if
*
*     quick return if possible
*
      if( n.eq.0 .or. nrhs.eq.0 )
     $   return
*
      if( notran ) then
*
*        solve a * x = b.
*
*        apply row interchanges to the right hand sides.
*
         call dlaswp( nrhs, b, ldb, 1, n, ipiv, 1 )
*
*        solve l*x = b, overwriting b with x.
*
         call dtrsm( 'left', 'lower', 'no transpose', 'unit', n, nrhs,
     $               one, a, lda, b, ldb )
*
*        solve u*x = b, overwriting b with x.
*
         call dtrsm( 'left', 'upper', 'no transpose', 'non-unit', n,
     $               nrhs, one, a, lda, b, ldb )
      else
*
*        solve a' * x = b.
*
*        solve u'*x = b, overwriting b with x.
*
         call dtrsm( 'left', 'upper', 'transpose', 'non-unit', n, nrhs,
     $               one, a, lda, b, ldb )
*
*        solve l'*x = b, overwriting b with x.
*
         call dtrsm( 'left', 'lower', 'transpose', 'unit', n, nrhs, one,
     $               a, lda, b, ldb )
*
*        apply row interchanges to the solution vectors.
*
         call dlaswp( nrhs, b, ldb, 1, n, ipiv, -1 )
      end if
*
      return
*
*     end of dgetrs
*
      end
ccc
      subroutine dgemm(transa,transb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc)
*     .. scalar arguments ..
      double precision alpha,beta
      integer k,lda,ldb,ldc,m,n
      character transa,transb
*     ..
*     .. array arguments ..
      double precision a(lda,*),b(ldb,*),c(ldc,*)
*     ..
*
*  purpose
*  =======
*
*  dgemm  performs one of the matrix-matrix operations
*
*     c := alpha*op( a )*op( b ) + beta*c,
*
*  where  op( x ) is one of
*
*     op( x ) = x   or   op( x ) = x',
*
*  alpha and beta are scalars, and a, b and c are matrices, with op( a )
*  an m by k matrix,  op( b )  a  k by n matrix and  c an m by n matrix.
*
*  arguments
*  ==========
*
*  transa - character*1.
*           on entry, transa specifies the form of op( a ) to be used in
*           the matrix multiplication as follows:
*
*              transa = 'n' or 'n',  op( a ) = a.
*
*              transa = 't' or 't',  op( a ) = a'.
*
*              transa = 'c' or 'c',  op( a ) = a'.
*
*           unchanged on exit.
*
*  transb - character*1.
*           on entry, transb specifies the form of op( b ) to be used in
*           the matrix multiplication as follows:
*
*              transb = 'n' or 'n',  op( b ) = b.
*
*              transb = 't' or 't',  op( b ) = b'.
*
*              transb = 'c' or 'c',  op( b ) = b'.
*
*           unchanged on exit.
*
*  m      - integer.
*           on entry,  m  specifies  the number  of rows  of the  matrix
*           op( a )  and of the  matrix  c.  m  must  be at least  zero.
*           unchanged on exit.
*
*  n      - integer.
*           on entry,  n  specifies the number  of columns of the matrix
*           op( b ) and the number of columns of the matrix c. n must be
*           at least zero.
*           unchanged on exit.
*
*  k      - integer.
*           on entry,  k  specifies  the number of columns of the matrix
*           op( a ) and the number of rows of the matrix op( b ). k must
*           be at least  zero.
*           unchanged on exit.
*
*  alpha  - double precision.
*           on entry, alpha specifies the scalar alpha.
*           unchanged on exit.
*
*  a      - double precision array of dimension ( lda, ka ), where ka is
*           k  when  transa = 'n' or 'n',  and is  m  otherwise.
*           before entry with  transa = 'n' or 'n',  the leading  m by k
*           part of the array  a  must contain the matrix  a,  otherwise
*           the leading  k by m  part of the array  a  must contain  the
*           matrix a.
*           unchanged on exit.
*
*  lda    - integer.
*           on entry, lda specifies the first dimension of a as declared
*           in the calling (sub) program. when  transa = 'n' or 'n' then
*           lda must be at least  max( 1, m ), otherwise  lda must be at
*           least  max( 1, k ).
*           unchanged on exit.
*
*  b      - double precision array of dimension ( ldb, kb ), where kb is
*           n  when  transb = 'n' or 'n',  and is  k  otherwise.
*           before entry with  transb = 'n' or 'n',  the leading  k by n
*           part of the array  b  must contain the matrix  b,  otherwise
*           the leading  n by k  part of the array  b  must contain  the
*           matrix b.
*           unchanged on exit.
*
*  ldb    - integer.
*           on entry, ldb specifies the first dimension of b as declared
*           in the calling (sub) program. when  transb = 'n' or 'n' then
*           ldb must be at least  max( 1, k ), otherwise  ldb must be at
*           least  max( 1, n ).
*           unchanged on exit.
*
*  beta   - double precision.
*           on entry,  beta  specifies the scalar  beta.  when  beta  is
*           supplied as zero then c need not be set on input.
*           unchanged on exit.
*
*  c      - double precision array of dimension ( ldc, n ).
*           before entry, the leading  m by n  part of the array  c must
*           contain the matrix  c,  except when  beta  is zero, in which
*           case c need not be set on entry.
*           on exit, the array  c  is overwritten by the  m by n  matrix
*           ( alpha*op( a )*op( b ) + beta*c ).
*
*  ldc    - integer.
*           on entry, ldc specifies the first dimension of c as declared
*           in  the  calling  (sub)  program.   ldc  must  be  at  least
*           max( 1, m ).
*           unchanged on exit.
*
*  further details
*  ===============
*
*  level 3 blas routine.
*
*  -- written on 8-february-1989.
*     jack dongarra, argonne national laboratory.
*     iain duff, aere harwell.
*     jeremy du croz, numerical algorithms group ltd.
*     sven hammarling, numerical algorithms group ltd.
*
*  =====================================================================
*
*     .. external functions ..
      logical lsame
      external lsame
*     ..
*     .. external subroutines ..
      external xerbla
*     ..
*     .. intrinsic functions ..
      intrinsic max
*     ..
*     .. local scalars ..
      double precision temp
      integer i,info,j,l,ncola,nrowa,nrowb
      logical nota,notb
*     ..
*     .. parameters ..
      double precision one,zero
      parameter (one=1.0d+0,zero=0.0d+0)
*     ..
*
*     set  nota  and  notb  as  true if  a  and  b  respectively are not
*     transposed and set  nrowa, ncola and  nrowb  as the number of rows
*     and  columns of  a  and the  number of  rows  of  b  respectively.
*
      nota = lsame(transa,'n')
      notb = lsame(transb,'n')
      if (nota) then
          nrowa = m
          ncola = k
      else
          nrowa = k
          ncola = m
      end if
      if (notb) then
          nrowb = k
      else
          nrowb = n
      end if
*
*     test the input parameters.
*
      info = 0
      if ((.not.nota) .and. (.not.lsame(transa,'c')) .and.
     +    (.not.lsame(transa,'t'))) then
          info = 1
      else if ((.not.notb) .and. (.not.lsame(transb,'c')) .and.
     +         (.not.lsame(transb,'t'))) then
          info = 2
      else if (m.lt.0) then
          info = 3
      else if (n.lt.0) then
          info = 4
      else if (k.lt.0) then
          info = 5
      else if (lda.lt.max(1,nrowa)) then
          info = 8
      else if (ldb.lt.max(1,nrowb)) then
          info = 10
      else if (ldc.lt.max(1,m)) then
          info = 13
      end if
      if (info.ne.0) then
          call xerbla('dgemm ',info)
          return
      end if
*
*     quick return if possible.
*
      if ((m.eq.0) .or. (n.eq.0) .or.
     +    (((alpha.eq.zero).or. (k.eq.0)).and. (beta.eq.one))) return
*
*     and if  alpha.eq.zero.
*
      if (alpha.eq.zero) then
          if (beta.eq.zero) then
              do 20 j = 1,n
                  do 10 i = 1,m
                      c(i,j) = zero
   10             continue
   20         continue
          else
              do 40 j = 1,n
                  do 30 i = 1,m
                      c(i,j) = beta*c(i,j)
   30             continue
   40         continue
          end if
          return
      end if
*
*     start the operations.
*
      if (notb) then
          if (nota) then
*
*           form  c := alpha*a*b + beta*c.
*
              do 90 j = 1,n
                  if (beta.eq.zero) then
                      do 50 i = 1,m
                          c(i,j) = zero
   50                 continue
                  else if (beta.ne.one) then
                      do 60 i = 1,m
                          c(i,j) = beta*c(i,j)
   60                 continue
                  end if
                  do 80 l = 1,k
                      if (b(l,j).ne.zero) then
                          temp = alpha*b(l,j)
                          do 70 i = 1,m
                              c(i,j) = c(i,j) + temp*a(i,l)
   70                     continue
                      end if
   80             continue
   90         continue
          else
*
*           form  c := alpha*a'*b + beta*c
*
              do 120 j = 1,n
                  do 110 i = 1,m
                      temp = zero
                      do 100 l = 1,k
                          temp = temp + a(l,i)*b(l,j)
  100                 continue
                      if (beta.eq.zero) then
                          c(i,j) = alpha*temp
                      else
                          c(i,j) = alpha*temp + beta*c(i,j)
                      end if
  110             continue
  120         continue
          end if
      else
          if (nota) then
*
*           form  c := alpha*a*b' + beta*c
*
              do 170 j = 1,n
                  if (beta.eq.zero) then
                      do 130 i = 1,m
                          c(i,j) = zero
  130                 continue
                  else if (beta.ne.one) then
                      do 140 i = 1,m
                          c(i,j) = beta*c(i,j)
  140                 continue
                  end if
                  do 160 l = 1,k
                      if (b(j,l).ne.zero) then
                          temp = alpha*b(j,l)
                          do 150 i = 1,m
                              c(i,j) = c(i,j) + temp*a(i,l)
  150                     continue
                      end if
  160             continue
  170         continue
          else
*
*           form  c := alpha*a'*b' + beta*c
*
              do 200 j = 1,n
                  do 190 i = 1,m
                      temp = zero
                      do 180 l = 1,k
                          temp = temp + a(l,i)*b(j,l)
  180                 continue
                      if (beta.eq.zero) then
                          c(i,j) = alpha*temp
                      else
                          c(i,j) = alpha*temp + beta*c(i,j)
                      end if
  190             continue
  200         continue
          end if
      end if
*
      return
*
*     end of dgemm .
*
      end
ccc
      subroutine dtrsm(side,uplo,transa,diag,m,n,alpha,a,lda,b,ldb)
*     .. scalar arguments ..
      double precision alpha
      integer lda,ldb,m,n
      character diag,side,transa,uplo
*     ..
*     .. array arguments ..
      double precision a(lda,*),b(ldb,*)
*     ..
*
*  purpose
*  =======
*
*  dtrsm  solves one of the matrix equations
*
*     op( a )*x = alpha*b,   or   x*op( a ) = alpha*b,
*
*  where alpha is a scalar, x and b are m by n matrices, a is a unit, or
*  non-unit,  upper or lower triangular matrix  and  op( a )  is one  of
*
*     op( a ) = a   or   op( a ) = a'.
*
*  the matrix x is overwritten on b.
*
*  arguments
*  ==========
*
*  side   - character*1.
*           on entry, side specifies whether op( a ) appears on the left
*           or right of x as follows:
*
*              side = 'l' or 'l'   op( a )*x = alpha*b.
*
*              side = 'r' or 'r'   x*op( a ) = alpha*b.
*
*           unchanged on exit.
*
*  uplo   - character*1.
*           on entry, uplo specifies whether the matrix a is an upper or
*           lower triangular matrix as follows:
*
*              uplo = 'u' or 'u'   a is an upper triangular matrix.
*
*              uplo = 'l' or 'l'   a is a lower triangular matrix.
*
*           unchanged on exit.
*
*  transa - character*1.
*           on entry, transa specifies the form of op( a ) to be used in
*           the matrix multiplication as follows:
*
*              transa = 'n' or 'n'   op( a ) = a.
*
*              transa = 't' or 't'   op( a ) = a'.
*
*              transa = 'c' or 'c'   op( a ) = a'.
*
*           unchanged on exit.
*
*  diag   - character*1.
*           on entry, diag specifies whether or not a is unit triangular
*           as follows:
*
*              diag = 'u' or 'u'   a is assumed to be unit triangular.
*
*              diag = 'n' or 'n'   a is not assumed to be unit
*                                  triangular.
*
*           unchanged on exit.
*
*  m      - integer.
*           on entry, m specifies the number of rows of b. m must be at
*           least zero.
*           unchanged on exit.gchuev-874 
*
*  n      - integer.
*           on entry, n specifies the number of columns of b.  n must be
*           at least zero.
*           unchanged on exit.
*
*  alpha  - double precision.
*           on entry,  alpha specifies the scalar  alpha. when  alpha is
*           zero then  a is not referenced and  b need not be set before
*           entry.
*           unchanged on exit.
*
*  a      - double precision array of dimension ( lda, k ), where k is m
*           when  side = 'l' or 'l'  and is  n  when  side = 'r' or 'r'.
*           before entry  with  uplo = 'u' or 'u',  the  leading  k by k
*           upper triangular part of the array  a must contain the upper
*           triangular matrix  and the strictly lower triangular part of
*           a is not referenced.
*           before entry  with  uplo = 'l' or 'l',  the  leading  k by k
*           lower triangular part of the array  a must contain the lower
*           triangular matrix  and the strictly upper triangular part of
*           a is not referenced.
*           note that when  diag = 'u' or 'u',  the diagonal elements of
*           a  are not referenced either,  but are assumed to be  unity.
*           unchanged on exit.
*
*  lda    - integer.
*           on entry, lda specifies the first dimension of a as declared
*           in the calling (sub) program.  when  side = 'l' or 'l'  then
*           lda  must be at least  max( 1, m ),  when  side = 'r' or 'r'
*           then lda must be at least max( 1, n ).
*           unchanged on exit.
*
*  b      - double precision array of dimension ( ldb, n ).
*           before entry,  the leading  m by n part of the array  b must
*           contain  the  right-hand  side  matrix  b,  and  on exit  is
*           overwritten by the solution matrix  x.
*
*  ldb    - integer.
*           on entry, ldb specifies the first dimension of b as declared
*           in  the  calling  (sub)  program.   ldb  must  be  at  least
*           max( 1, m ).
*           unchanged on exit.
*
*  further details
*  ===============
*
*  level 3 blas routine.
*
*
*  -- written on 8-february-1989.
*     jack dongarra, argonne national laboratory.
*     iain duff, aere harwell.
*     jeremy du croz, numerical algorithms group ltd.
*     sven hammarling, numerical algorithms group ltd.
*
*  =====================================================================
*
*     .. external functions ..
      logical lsame
      external lsame
*     ..
*     .. external subroutines ..
      external xerbla
*     ..
*     .. intrinsic functions ..
      intrinsic max
*     ..
*     .. local scalars ..
      double precision temp
      integer i,info,j,k,nrowa
      logical lside,nounit,upper
*     ..
*     .. parameters ..
      double precision one,zero
      parameter (one=1.0d+0,zero=0.0d+0)
*     ..
*
*     test the input parameters.
*
      lside = lsame(side,'l')
      if (lside) then
          nrowa = m
      else
          nrowa = n
      end if
      nounit = lsame(diag,'n')
      upper = lsame(uplo,'u')
*
      info = 0
      if ((.not.lside) .and. (.not.lsame(side,'r'))) then
          info = 1
      else if ((.not.upper) .and. (.not.lsame(uplo,'l'))) then
          info = 2
      else if ((.not.lsame(transa,'n')) .and.
     +         (.not.lsame(transa,'t')) .and.
     +         (.not.lsame(transa,'c'))) then
          info = 3
      else if ((.not.lsame(diag,'u')) .and. (.not.lsame(diag,'n'))) then
          info = 4
      else if (m.lt.0) then
          info = 5
      else if (n.lt.0) then
          info = 6
      else if (lda.lt.max(1,nrowa)) then
          info = 9
      else if (ldb.lt.max(1,m)) then
          info = 11
      end if
      if (info.ne.0) then
          call xerbla('dtrsm ',info)
          return
      end if
*
*     quick return if possible.
*
      if (m.eq.0 .or. n.eq.0) return
*
*     and when  alpha.eq.zero.
*
      if (alpha.eq.zero) then
          do 20 j = 1,n
              do 10 i = 1,m
                  b(i,j) = zero
   10         continue
   20     continue
          return
      end if
*
*     start the operations.
*
      if (lside) then
          if (lsame(transa,'n')) then
*
*           form  b := alpha*inv( a )*b.
*
              if (upper) then
                  do 60 j = 1,n
                      if (alpha.ne.one) then
                          do 30 i = 1,m
                              b(i,j) = alpha*b(i,j)
   30                     continue
                      end if
                      do 50 k = m,1,-1
                          if (b(k,j).ne.zero) then
                              if (nounit) b(k,j) = b(k,j)/a(k,k)
                              do 40 i = 1,k - 1
                                  b(i,j) = b(i,j) - b(k,j)*a(i,k)
   40                         continue
                          end if
   50                 continue
   60             continue
              else
                  do 100 j = 1,n
                      if (alpha.ne.one) then
                          do 70 i = 1,m
                              b(i,j) = alpha*b(i,j)
   70                     continue
                      end if
                      do 90 k = 1,m
                          if (b(k,j).ne.zero) then
                              if (nounit) b(k,j) = b(k,j)/a(k,k)
                              do 80 i = k + 1,m
                                  b(i,j) = b(i,j) - b(k,j)*a(i,k)
   80                         continue
                          end if
   90                 continue
  100             continue
              end if
          else
*
*           form  b := alpha*inv( a' )*b.
*
              if (upper) then
                  do 130 j = 1,n
                      do 120 i = 1,m
                          temp = alpha*b(i,j)
                          do 110 k = 1,i - 1
                              temp = temp - a(k,i)*b(k,j)
  110                     continue
                          if (nounit) temp = temp/a(i,i)
                          b(i,j) = temp
  120                 continue
  130             continue
              else
                  do 160 j = 1,n
                      do 150 i = m,1,-1
                          temp = alpha*b(i,j)
                          do 140 k = i + 1,m
                              temp = temp - a(k,i)*b(k,j)
  140                     continue
                          if (nounit) temp = temp/a(i,i)
                          b(i,j) = temp
  150                 continue
  160             continue
              end if
          end if
      else
          if (lsame(transa,'n')) then
*
*           form  b := alpha*b*inv( a ).
*
              if (upper) then
                  do 210 j = 1,n
                      if (alpha.ne.one) then
                          do 170 i = 1,m
                              b(i,j) = alpha*b(i,j)
  170                     continue
                      end if
                      do 190 k = 1,j - 1
                          if (a(k,j).ne.zero) then
                              do 180 i = 1,m
                                  b(i,j) = b(i,j) - a(k,j)*b(i,k)
  180                         continue
                          end if
  190                 continue
                      if (nounit) then
                          temp = one/a(j,j)
                          do 200 i = 1,m
                              b(i,j) = temp*b(i,j)
  200                     continue
                      end if
  210             continue
              else
                  do 260 j = n,1,-1
                      if (alpha.ne.one) then
                          do 220 i = 1,m
                              b(i,j) = alpha*b(i,j)
  220                     continue
                      end if
                      do 240 k = j + 1,n
                          if (a(k,j).ne.zero) then
                              do 230 i = 1,m
                                  b(i,j) = b(i,j) - a(k,j)*b(i,k)
  230                         continue
                          end if
  240                 continue
                      if (nounit) then
                          temp = one/a(j,j)
                          do 250 i = 1,m
                              b(i,j) = temp*b(i,j)
  250                     continue
                      end if
  260             continue
              end if
          else
*
*           form  b := alpha*b*inv( a' ).
*
              if (upper) then
                  do 310 k = n,1,-1
                      if (nounit) then
                          temp = one/a(k,k)
                          do 270 i = 1,m
                              b(i,k) = temp*b(i,k)
  270                     continue
                      end if
                      do 290 j = 1,k - 1
                          if (a(j,k).ne.zero) then
                              temp = a(j,k)
                              do 280 i = 1,m
                                  b(i,j) = b(i,j) - temp*b(i,k)
  280                         continue
                          end if
  290                 continue
                      if (alpha.ne.one) then
                          do 300 i = 1,m
                              b(i,k) = alpha*b(i,k)
  300                     continue
                      end if
  310             continue
              else
                  do 360 k = 1,n
                      if (nounit) then
                          temp = one/a(k,k)
                          do 320 i = 1,m
                              b(i,k) = temp*b(i,k)
  320                     continue
                      end if
                      do 340 j = k + 1,n
                          if (a(j,k).ne.zero) then
                              temp = a(j,k)
                              do 330 i = 1,m
                                  b(i,j) = b(i,j) - temp*b(i,k)
  330                         continue
                          end if
  340                 continue
                      if (alpha.ne.one) then
                          do 350 i = 1,m
                              b(i,k) = alpha*b(i,k)
  350                     continue
                      end if
  360             continue
              end if
          end if
      end if
*
      return
*
*     end of dtrsm .
*
      end
ccc
      subroutine dlaswp( n, a, lda, k1, k2, ipiv, incx )
*
*  -- lapack auxiliary routine (version 3.2) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     november 2006
*
*     .. scalar arguments ..
      integer            incx, k1, k2, lda, n
*     ..
*     .. array arguments ..
      integer            ipiv( * )
      double precision   a( lda, * )
*     ..
*
*  purpose
*  =======
*
*  dlaswp performs a series of row interchanges on the matrix a.
*  one row interchange is initiated for each of rows k1 through k2 of a.
*
*  arguments
*  =========
*
*  n       (input) integer
*          the number of columns of the matrix a.
*
*  a       (input/output) double precision array, dimension (lda,n)
*          on entry, the matrix of column dimension n to which the row
*          interchanges will be applied.
*          on exit, the permuted matrix.
*
*  lda     (input) integer
*          the leading dimension of the array a.
*
*  k1      (input) integer
*          the first element of ipiv for which a row interchange will
*          be done.
*
*  k2      (input) integer
*          the last element of ipiv for which a row interchange will
*          be done.
*
*  ipiv    (input) integer array, dimension (k2*abs(incx))
*          the vector of pivot indices.  only the elements in positions
*          k1 through k2 of ipiv are accessed.
*          ipiv(k) = l implies rows k and l are to be interchanged.
*
*  incx    (input) integer
*          the increment between successive values of ipiv.  if ipiv
*          is negative, the pivots are applied in reverse order.
*
*  further details
*  ===============
*
*  modified by
*   r. c. whaley, computer science dept., univ. of tenn., knoxville, usa
*
* =====================================================================
*
*     .. local scalars ..
      integer            i, i1, i2, inc, ip, ix, ix0, j, k, n32
      double precision   temp
*     ..
*     .. executable statements ..
*
*     interchange row i with row ipiv(i) for each of rows k1 through k2.
*
      if( incx.gt.0 ) then
         ix0 = k1
         i1 = k1
         i2 = k2
         inc = 1
      else if( incx.lt.0 ) then
         ix0 = 1 + ( 1-k2 )*incx
         i1 = k2
         i2 = k1
         inc = -1
      else
         return
      end if
*
      n32 = ( n / 32 )*32
      if( n32.ne.0 ) then
         do 30 j = 1, n32, 32
            ix = ix0
            do 20 i = i1, i2, inc
               ip = ipiv( ix )
               if( ip.ne.i ) then
                  do 10 k = j, j + 31
                     temp = a( i, k )
                     a( i, k ) = a( ip, k )
                     a( ip, k ) = temp
   10             continue
               end if
               ix = ix + incx
   20       continue
   30    continue
      end if
      if( n32.ne.n ) then
         n32 = n32 + 1
         ix = ix0
         do 50 i = i1, i2, inc
            ip = ipiv( ix )
            if( ip.ne.i ) then
               do 40 k = n32, n
                  temp = a( i, k )
                  a( i, k ) = a( ip, k )
                  a( ip, k ) = temp
   40          continue
            end if
            ix = ix + incx
   50    continue
      end if
*
      return
*
*     end of dlaswp
*
      end
ccc
      integer function ilaenv( ispec, name, opts, n1, n2, n3, n4 )
*
*  -- lapack auxiliary routine (version 3.2.1)                        --
*
*  -- april 2009                                                      --
*
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*
*     .. scalar arguments ..
      character*( * )    name, opts
      integer            ispec, n1, n2, n3, n4
*     ..
*
*  purpose
*  =======
*
*  ilaenv is called from the lapack routines to choose problem-dependent
*  parameters for the local environment.  see ispec for a description of
*  the parameters.
*
*  ilaenv returns an integer
*  if ilaenv >= 0: ilaenv returns the value of the parameter specified by ispec
*  if ilaenv < 0:  if ilaenv = -k, the k-th argument had an illegal value.
*
*  this version provides a set of parameters which should give good,
*  but not optimal, performance on many of the currently available
*  computers.  users are encouraged to modify this subroutine to set
*  the tuning parameters for their particular machine using the option
*  and problem size information in the arguments.
*
*  this routine will not function correctly if it is converted to all
*  lower case.  converting it to all upper case is allowed.
*
*  arguments
*  =========
*
*  ispec   (input) integer
*          specifies the parameter to be returned as the value of
*          ilaenv.
*          = 1: the optimal blocksize; if this value is 1, an unblocked
*               algorithm will give the best performance.
*          = 2: the minimum block size for which the block routine
*               should be used; if the usable block size is less than
*               this value, an unblocked routine should be used.
*          = 3: the crossover point (in a block routine, for n less
*               than this value, an unblocked routine should be used)
*          = 4: the number of shifts, used in the nonsymmetric
*               eigenvalue routines (deprecated)
*          = 5: the minimum column dimension for blocking to be used;
*               rectangular blocks must have dimension at least k by m,
*               where k is given by ilaenv(2,...) and m by ilaenv(5,...)
*          = 6: the crossover point for the svd (when reducing an m by n
*               matrix to bidiagonal form, if max(m,n)/min(m,n) exceeds
*               this value, a qr factorization is used first to reduce
*               the matrix to a triangular form.)
*          = 7: the number of processors
*          = 8: the crossover point for the multishift qr method
*               for nonsymmetric eigenvalue problems (deprecated)
*          = 9: maximum size of the subproblems at the bottom of the
*               computation tree in the divide-and-conquer algorithm
*               (used by xgelsd and xgesdd)
*          =10: ieee nan arithmetic can be trusted not to trap
*          =11: infinity arithmetic can be trusted not to trap
*          12 <= ispec <= 16:
*               xhseqr or one of its subroutines,
*               see iparmq for detailed explanation
*
*  name    (input) character*(*)
*          the name of the calling subroutine, in either upper case or
*          lower case.
*
*  opts    (input) character*(*)
*          the character options to the subroutine name, concatenated
*          into a single character string.  for example, uplo = 'u',
*          trans = 't', and diag = 'n' for a triangular routine would
*          be specified as opts = 'utn'.
*
*  n1      (input) integer
*  n2      (input) integer
*  n3      (input) integer
*  n4      (input) integer
*          problem dimensions for the subroutine name; these may not all
*          be required.
*
*  further details
*  ===============
*
*  the following conventions have been used when calling ilaenv from the
*  lapack routines:
*  1)  opts is a concatenation of all of the character options to
*      subroutine name, in the same order that they appear in the
*      argument list for name, even if they are not used in determining
*      the value of the parameter specified by ispec.
*  2)  the problem dimensions n1, n2, n3, n4 are specified in the order
*      that they appear in the argument list for name.  n1 is used
*      first, n2 second, and so on, and unused problem dimensions are
*      passed a value of -1.
*  3)  the parameter value returned by ilaenv is checked for validity in
*      the calling subroutine.  for example, ilaenv is used to retrieve
*      the optimal blocksize for strtri as follows:
*
*      nb = ilaenv( 1, 'strtri', uplo // diag, n, -1, -1, -1 )
*      if( nb.le.1 ) nb = max( 1, n )
*
*  =====================================================================
*
*     .. local scalars ..
      integer            i, ic, iz, nb, nbmin, nx
      logical            cname, sname
      character          c1*1, c2*2, c4*2, c3*3, subnam*6
*     ..
*     .. intrinsic functions ..
      intrinsic          char, ichar, int, min, real
*     ..
*     .. external functions ..
      integer            ieeeck, iparmq
      external           ieeeck, iparmq
*     ..
*     .. executable statements ..
*
      go to ( 10, 10, 10, 80, 90, 100, 110, 120,
     $        130, 140, 150, 160, 160, 160, 160, 160 )ispec
*
*     invalid value for ispec
*
      ilaenv = -1
      return
*
   10 continue
*
*     convert name to upper case if the first character is lower case.
*
      ilaenv = 1
      subnam = name
      ic = ichar( subnam( 1: 1 ) )
      iz = ichar( 'z' )
      if( iz.eq.90 .or. iz.eq.122 ) then
*
*        ascii character set
*
         if( ic.ge.97 .and. ic.le.122 ) then
            subnam( 1: 1 ) = char( ic-32 )
            do 20 i = 2, 6
               ic = ichar( subnam( i: i ) )
               if( ic.ge.97 .and. ic.le.122 )
     $            subnam( i: i ) = char( ic-32 )
   20       continue
         end if
*
      else if( iz.eq.233 .or. iz.eq.169 ) then
*
*        ebcdic character set
*
         if( ( ic.ge.129 .and. ic.le.137 ) .or.
     $       ( ic.ge.145 .and. ic.le.153 ) .or.
     $       ( ic.ge.162 .and. ic.le.169 ) ) then
            subnam( 1: 1 ) = char( ic+64 )
            do 30 i = 2, 6
               ic = ichar( subnam( i: i ) )
               if( ( ic.ge.129 .and. ic.le.137 ) .or.
     $             ( ic.ge.145 .and. ic.le.153 ) .or.
     $             ( ic.ge.162 .and. ic.le.169 ) )subnam( i:
     $             i ) = char( ic+64 )
   30       continue
         end if
*
      else if( iz.eq.218 .or. iz.eq.250 ) then
*
*        prime machines:  ascii+128
*
         if( ic.ge.225 .and. ic.le.250 ) then
            subnam( 1: 1 ) = char( ic-32 )
            do 40 i = 2, 6
               ic = ichar( subnam( i: i ) )
               if( ic.ge.225 .and. ic.le.250 )
     $            subnam( i: i ) = char( ic-32 )
   40       continue
         end if
      end if
*
      c1 = subnam( 1: 1 )
      sname = c1.eq.'s' .or. c1.eq.'d'
      cname = c1.eq.'c' .or. c1.eq.'z'
      if( .not.( cname .or. sname ) )
     $   return
      c2 = subnam( 2: 3 )
      c3 = subnam( 4: 6 )
      c4 = c3( 2: 3 )
*
      go to ( 50, 60, 70 )ispec
*
   50 continue
*
*     ispec = 1:  block size
*
*     in these examples, separate code is provided for setting nb for
*     real and complex.  we assume that nb will take the same value in
*     single or double precision.
*
      nb = 1
*
      if( c2.eq.'ge' ) then
         if( c3.eq.'trf' ) then
            if( sname ) then
               nb = 64
            else
               nb = 64
            end if
         else if( c3.eq.'qrf' .or. c3.eq.'rqf' .or. c3.eq.'lqf' .or.
     $            c3.eq.'qlf' ) then
            if( sname ) then
               nb = 32
            else
               nb = 32
            end if
         else if( c3.eq.'hrd' ) then
            if( sname ) then
               nb = 32
            else
               nb = 32
            end if
         else if( c3.eq.'brd' ) then
            if( sname ) then
               nb = 32
            else
               nb = 32
            end if
         else if( c3.eq.'tri' ) then
            if( sname ) then
               nb = 64
            else
               nb = 64
            end if
         end if
      else if( c2.eq.'po' ) then
         if( c3.eq.'trf' ) then
            if( sname ) then
               nb = 64
            else
               nb = 64
            end if
         end if
      else if( c2.eq.'sy' ) then
         if( c3.eq.'trf' ) then
            if( sname ) then
               nb = 64
            else
               nb = 64
            end if
         else if( sname .and. c3.eq.'trd' ) then
            nb = 32
         else if( sname .and. c3.eq.'gst' ) then
            nb = 64
         end if
      else if( cname .and. c2.eq.'he' ) then
         if( c3.eq.'trf' ) then
            nb = 64
         else if( c3.eq.'trd' ) then
            nb = 32
         else if( c3.eq.'gst' ) then
            nb = 64
         end if
      else if( sname .and. c2.eq.'or' ) then
         if( c3( 1: 1 ).eq.'g' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nb = 32
            end if
         else if( c3( 1: 1 ).eq.'m' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nb = 32
            end if
         end if
      else if( cname .and. c2.eq.'un' ) then
         if( c3( 1: 1 ).eq.'g' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nb = 32
            end if
         else if( c3( 1: 1 ).eq.'m' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nb = 32
            end if
         end if
      else if( c2.eq.'gb' ) then
         if( c3.eq.'trf' ) then
            if( sname ) then
               if( n4.le.64 ) then
                  nb = 1
               else
                  nb = 32
               end if
            else
               if( n4.le.64 ) then
                  nb = 1
               else
                  nb = 32
               end if
            end if
         end if
      else if( c2.eq.'pb' ) then
         if( c3.eq.'trf' ) then
            if( sname ) then
               if( n2.le.64 ) then
                  nb = 1
               else
                  nb = 32
               end if
            else
               if( n2.le.64 ) then
                  nb = 1
               else
                  nb = 32
               end if
            end if
         end if
      else if( c2.eq.'tr' ) then
         if( c3.eq.'tri' ) then
            if( sname ) then
               nb = 64
            else
               nb = 64
            end if
         end if
      else if( c2.eq.'la' ) then
         if( c3.eq.'uum' ) then
            if( sname ) then
               nb = 64
            else
               nb = 64
            end if
         end if
      else if( sname .and. c2.eq.'st' ) then
         if( c3.eq.'ebz' ) then
            nb = 1
         end if
      end if
      ilaenv = nb
      return
*
   60 continue
*
*     ispec = 2:  minimum block size
*
      nbmin = 2
      if( c2.eq.'ge' ) then
         if( c3.eq.'qrf' .or. c3.eq.'rqf' .or. c3.eq.'lqf' .or. c3.eq.
     $       'qlf' ) then
            if( sname ) then
               nbmin = 2
            else
               nbmin = 2
            end if
         else if( c3.eq.'hrd' ) then
            if( sname ) then
               nbmin = 2
            else
               nbmin = 2
            end if
         else if( c3.eq.'brd' ) then
            if( sname ) then
               nbmin = 2
            else
               nbmin = 2
            end if
         else if( c3.eq.'tri' ) then
            if( sname ) then
               nbmin = 2
            else
               nbmin = 2
            end if
         end if
      else if( c2.eq.'sy' ) then
         if( c3.eq.'trf' ) then
            if( sname ) then
               nbmin = 8
            else
               nbmin = 8
            end if
         else if( sname .and. c3.eq.'trd' ) then
            nbmin = 2
         end if
      else if( cname .and. c2.eq.'he' ) then
         if( c3.eq.'trd' ) then
            nbmin = 2
         end if
      else if( sname .and. c2.eq.'or' ) then
         if( c3( 1: 1 ).eq.'g' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nbmin = 2
            end if
         else if( c3( 1: 1 ).eq.'m' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nbmin = 2
            end if
         end if
      else if( cname .and. c2.eq.'un' ) then
         if( c3( 1: 1 ).eq.'g' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nbmin = 2
            end if
         else if( c3( 1: 1 ).eq.'m' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nbmin = 2
            end if
         end if
      end if
      ilaenv = nbmin
      return
*
   70 continue
*
*     ispec = 3:  crossover point
*
      nx = 0
      if( c2.eq.'ge' ) then
         if( c3.eq.'qrf' .or. c3.eq.'rqf' .or. c3.eq.'lqf' .or. c3.eq.
     $       'qlf' ) then
            if( sname ) then
               nx = 128
            else
               nx = 128
            end if
         else if( c3.eq.'hrd' ) then
            if( sname ) then
               nx = 128
            else
               nx = 128
            end if
         else if( c3.eq.'brd' ) then
            if( sname ) then
               nx = 128
            else
               nx = 128
            end if
         end if
      else if( c2.eq.'sy' ) then
         if( sname .and. c3.eq.'trd' ) then
            nx = 32
         end if
      else if( cname .and. c2.eq.'he' ) then
         if( c3.eq.'trd' ) then
            nx = 32
         end if
      else if( sname .and. c2.eq.'or' ) then
         if( c3( 1: 1 ).eq.'g' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nx = 128
            end if
         end if
      else if( cname .and. c2.eq.'un' ) then
         if( c3( 1: 1 ).eq.'g' ) then
            if( c4.eq.'qr' .or. c4.eq.'rq' .or. c4.eq.'lq' .or. c4.eq.
     $          'ql' .or. c4.eq.'hr' .or. c4.eq.'tr' .or. c4.eq.'br' )
     $           then
               nx = 128
            end if
         end if
      end if
      ilaenv = nx
      return
*
   80 continue
*
*     ispec = 4:  number of shifts (used by xhseqr)
*
      ilaenv = 6
      return
*
   90 continue
*
*     ispec = 5:  minimum column dimension (not used)
*
      ilaenv = 2
      return
*
  100 continue
*
*     ispec = 6:  crossover point for svd (used by xgelss and xgesvd)
*
      ilaenv = int( real( min( n1, n2 ) )*1.6e0 )
      return
*
  110 continue
*
*     ispec = 7:  number of processors (not used)
*
      ilaenv = 1
      return
*
  120 continue
*
*     ispec = 8:  crossover point for multishift (used by xhseqr)
*
      ilaenv = 50
      return
*
  130 continue
*
*     ispec = 9:  maximum size of the subproblems at the bottom of the
*                 computation tree in the divide-and-conquer algorithm
*                 (used by xgelsd and xgesdd)
*
      ilaenv = 25
      return
*
  140 continue
*
*     ispec = 10: ieee nan arithmetic can be trusted not to trap
*
*     ilaenv = 0
      ilaenv = 1
      if( ilaenv.eq.1 ) then
         ilaenv = ieeeck( 1, 0.0, 1.0 )
      end if
      return
*
  150 continue
*
*     ispec = 11: infinity arithmetic can be trusted not to trap
*
*     ilaenv = 0
      ilaenv = 1
      if( ilaenv.eq.1 ) then
         ilaenv = ieeeck( 0, 0.0, 1.0 )
      end if
      return
*
  160 continue
*
*     12 <= ispec <= 16: xhseqr or one of its subroutines. 
*
      ilaenv = iparmq( ispec, name, opts, n1, n2, n3, n4 )
      return
*
*     end of ilaenv
*
      end
ccc
      integer          function ieeeck( ispec, zero, one )
*
*  -- lapack auxiliary routine (version 3.2.2) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     june 2010
*
*     .. scalar arguments ..
      integer            ispec
      real               one, zero
*     ..
*
*  purpose
*  =======
*
*  ieeeck is called from the ilaenv to verify that infinity and
*  possibly nan arithmetic is safe (i.e. will not trap).
*
*  arguments
*  =========
*
*  ispec   (input) integer
*          specifies whether to test just for inifinity arithmetic
*          or whether to test for infinity and nan arithmetic.
*          = 0: verify infinity arithmetic only.
*          = 1: verify infinity and nan arithmetic.
*
*  zero    (input) real
*          must contain the value 0.0
*          this is passed to prevent the compiler from optimizing
*          away this code.
*
*  one     (input) real
*          must contain the value 1.0
*          this is passed to prevent the compiler from optimizing
*          away this code.
*
*  return value:  integer
*          = 0:  arithmetic failed to produce the correct answers
*          = 1:  arithmetic produced the correct answers
*
*     .. local scalars ..
      real               nan1, nan2, nan3, nan4, nan5, nan6, neginf,
     $                   negzro, newzro, posinf
*     ..
*     .. executable statements ..
      ieeeck = 1
*
      posinf = one / zero
      if( posinf.le.one ) then
         ieeeck = 0
         return
      end if
*
      neginf = -one / zero
      if( neginf.ge.zero ) then
         ieeeck = 0
         return
      end if
*
      negzro = one / ( neginf+one )
      if( negzro.ne.zero ) then
         ieeeck = 0
         return
      end if
*
      neginf = one / negzro
      if( neginf.ge.zero ) then
         ieeeck = 0
         return
      end if
*
      newzro = negzro + zero
      if( newzro.ne.zero ) then
         ieeeck = 0
         return
      end if
*
      posinf = one / newzro
      if( posinf.le.one ) then
         ieeeck = 0
         return
      end if
*
      neginf = neginf*posinf
      if( neginf.ge.zero ) then
         ieeeck = 0
         return
      end if
*
      posinf = posinf*posinf
      if( posinf.le.one ) then
         ieeeck = 0
         return
      end if
*
*
*
*
*     return if we were only asked to check infinity arithmetic
*
      if( ispec.eq.0 )
     $   return
*
      nan1 = posinf + neginf
*
      nan2 = posinf / neginf
*
      nan3 = posinf / posinf
*
      nan4 = posinf*zero
*
      nan5 = neginf*negzro
*
      nan6 = nan5*zero
*
      if( nan1.eq.nan1 ) then
         ieeeck = 0
         return
      end if
*
      if( nan2.eq.nan2 ) then
         ieeeck = 0
         return
      end if
*
      if( nan3.eq.nan3 ) then
         ieeeck = 0
         return
      end if
*
      if( nan4.eq.nan4 ) then
         ieeeck = 0
         return
      end if
*
      if( nan5.eq.nan5 ) then
         ieeeck = 0
         return
      end if
*
      if( nan6.eq.nan6 ) then
         ieeeck = 0
         return
      end if
*
      return
      end
ccc
      integer function idamax(n,dx,incx)
*     .. scalar arguments ..
      integer incx,n
*     ..
*     .. array arguments ..
      double precision dx(*)
*     ..
*
*  purpose
*  =======
*
*     idamax finds the index of element having max. absolute value.
*
*  further details
*  ===============
*
*     jack dongarra, linpack, 3/11/78.
*     modified 3/93 to return if incx .le. 0.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*  =====================================================================
*
*     .. local scalars ..
      double precision dmax
      integer i,ix
*     ..
*     .. intrinsic functions ..
      intrinsic dabs
*     ..
      idamax = 0
      if (n.lt.1 .or. incx.le.0) return
      idamax = 1
      if (n.eq.1) return
      if (incx.eq.1) go to 20
*
*        code for increment not equal to 1
*
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
          if (dabs(dx(ix)).le.dmax) go to 5
          idamax = i
          dmax = dabs(dx(ix))
    5     ix = ix + incx
   10 continue
      return
*
*        code for increment equal to 1
*
   20 dmax = dabs(dx(1))
      do 30 i = 2,n
          if (dabs(dx(i)).le.dmax) go to 30
          idamax = i
          dmax = dabs(dx(i))
   30 continue
      return
      end
ccc
      logical function lsame(ca,cb)
*
*  -- lapack auxiliary routine (version 3.1) --
*     univ. of tennessee, univ. of california berkeley and nag ltd..
*     november 2006
*
*     .. scalar arguments ..
      character ca,cb
*     ..
*
*  purpose
*  =======
*
*  lsame returns .true. if ca is the same letter as cb regardless of
*  case.
*
*  arguments
*  =========
*
*  ca      (input) character*1
*
*  cb      (input) character*1
*          ca and cb specify the single characters to be compared.
*
* =====================================================================
*
*     .. intrinsic functions ..
      intrinsic ichar
*     ..
*     .. local scalars ..
      integer inta,intb,zcode
*     ..
*
*     test if the characters are equal
*
      lsame = ca .eq. cb
      if (lsame) return
*
*     now test for equivalence if both characters are alphabetic.
*
      zcode = ichar('z')
*
*     use 'z' rather than 'a' so that ascii can be detected on prime
*     machines, on which ichar returns a value with bit 8 set.
*     ichar('a') on prime machines returns 193 which is the same as
*     ichar('a') on an ebcdic machine.
*
      inta = ichar(ca)
      intb = ichar(cb)
*
      if (zcode.eq.90 .or. zcode.eq.122) then
*
*        ascii is assumed - zcode is the ascii code of either lower or
*        upper case 'z'.
*
          if (inta.ge.97 .and. inta.le.122) inta = inta - 32
          if (intb.ge.97 .and. intb.le.122) intb = intb - 32
*
      else if (zcode.eq.233 .or. zcode.eq.169) then
*
*        ebcdic is assumed - zcode is the ebcdic code of either lower or
*        upper case 'z'.
*
          if (inta.ge.129 .and. inta.le.137 .or.
     +        inta.ge.145 .and. inta.le.153 .or.
     +        inta.ge.162 .and. inta.le.169) inta = inta + 64
          if (intb.ge.129 .and. intb.le.137 .or.
     +        intb.ge.145 .and. intb.le.153 .or.
     +        intb.ge.162 .and. intb.le.169) intb = intb + 64
*
      else if (zcode.eq.218 .or. zcode.eq.250) then
*
*        ascii is assumed, on prime machines - zcode is the ascii code
*        plus 128 of either lower or upper case 'z'.
*
          if (inta.ge.225 .and. inta.le.250) inta = inta - 32
          if (intb.ge.225 .and. intb.le.250) intb = intb - 32
      end if
      lsame = inta .eq. intb
*
*     return
*
*     end of lsame
*
      end
ccc
      integer function iparmq( ispec, name, opts, n, ilo, ihi, lwork )
*
*  -- lapack auxiliary routine (version 3.2) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     november 2006
*     
*     .. scalar arguments ..
      integer            ihi, ilo, ispec, lwork, n
      character          name*( * ), opts*( * )
*
*  purpose
*  =======
*
*       this program sets problem and machine dependent parameters
*       useful for xhseqr and its subroutines. it is called whenever 
*       ilaenv is called with 12 <= ispec <= 16
*
*  arguments
*  =========
*
*       ispec  (input) integer scalar
*              ispec specifies which tunable parameter iparmq should
*              return.
*
*              ispec=12: (inmin)  matrices of order nmin or less
*                        are sent directly to xlahqr, the implicit
*                        double shift qr algorithm.  nmin must be
*                        at least 11.
*
*              ispec=13: (inwin)  size of the deflation window.
*                        this is best set greater than or equal to
*                        the number of simultaneous shifts ns.
*                        larger matrices benefit from larger deflation
*                        windows.
*
*              ispec=14: (inibl) determines when to stop nibbling and
*                        invest in an (expensive) multi-shift qr sweep.
*                        if the aggressive early deflation subroutine
*                        finds ld converged eigenvalues from an order
*                        nw deflation window and ld.gt.(nw*nibble)/100,
*                        then the next qr sweep is skipped and early
*                        deflation is applied immediately to the
*                        remaining active diagonal block.  setting
*                        iparmq(ispec=14) = 0 causes ttqre to skip a
*                        multi-shift qr sweep whenever early deflation
*                        finds a converged eigenvalue.  setting
*                        iparmq(ispec=14) greater than or equal to 100
*                        prevents ttqre from skipping a multi-shift
*                        qr sweep.
*
*              ispec=15: (nshfts) the number of simultaneous shifts in
*                        a multi-shift qr iteration.
*
*              ispec=16: (iacc22) iparmq is set to 0, 1 or 2 with the
*                        following meanings.
*                        0:  during the multi-shift qr sweep,
*                            xlaqr5 does not accumulate reflections and
*                            does not use matrix-matrix multiply to
*                            update the far-from-diagonal matrix
*                            entries.
*                        1:  during the multi-shift qr sweep,
*                            xlaqr5 and/or xlaqraccumulates reflections and uses
*                            matrix-matrix multiply to update the
*                            far-from-diagonal matrix entries.
*                        2:  during the multi-shift qr sweep.
*                            xlaqr5 accumulates reflections and takes
*                            advantage of 2-by-2 block structure during
*                            matrix-matrix multiplies.
*                        (if xtrmm is slower than xgemm, then
*                        iparmq(ispec=16)=1 may be more efficient than
*                        iparmq(ispec=16)=2 despite the greater level of
*                        arithmetic work implied by the latter choice.)
*
*       name    (input) character string
*               name of the calling subroutine
*
*       opts    (input) character string
*               this is a concatenation of the string arguments to
*               ttqre.
*
*       n       (input) integer scalar
*               n is the order of the hessenberg matrix h.
*
*       ilo     (input) integer
*       ihi     (input) integer
*               it is assumed that h is already upper triangular
*               in rows and columns 1:ilo-1 and ihi+1:n.
*
*       lwork   (input) integer scalar
*               the amount of workspace available.
*
*  further details
*  ===============
*
*       little is known about how best to choose these parameters.
*       it is possible to use different values of the parameters
*       for each of chseqr, dhseqr, shseqr and zhseqr.
*
*       it is probably best to choose different parameters for
*       different matrices and different parameters at different
*       times during the iteration, but this has not been
*       implemented --- yet.
*
*
*       the best choices of most of the parameters depend
*       in an ill-understood way on the relative execution
*       rate of xlaqr3 and xlaqr5 and on the nature of each
*       particular eigenvalue problem.  experiment may be the
*       only practical way to determine which choices are most
*       effective.
*
*       following is a list of default values supplied by iparmq.
*       these defaults may be adjusted in order to attain better
*       performance in any particular computational environment.
*
*       iparmq(ispec=12) the xlahqr vs xlaqr0 crossover point.
*                        default: 75. (must be at least 11.)
*
*       iparmq(ispec=13) recommended deflation window size.
*                        this depends on ilo, ihi and ns, the
*                        number of simultaneous shifts returned
*                        by iparmq(ispec=15).  the default for
*                        (ihi-ilo+1).le.500 is ns.  the default
*                        for (ihi-ilo+1).gt.500 is 3*ns/2.
*
*       iparmq(ispec=14) nibble crossover point.  default: 14.
*
*       iparmq(ispec=15) number of simultaneous shifts, ns.
*                        a multi-shift qr iteration.
*
*                        if ihi-ilo+1 is ...
*
*                        greater than      ...but less    ... the
*                        or equal to ...      than        default is
*
*                                0               30       ns =   2+
*                               30               60       ns =   4+
*                               60              150       ns =  10
*                              150              590       ns =  **
*                              590             3000       ns =  64
*                             3000             6000       ns = 128
*                             6000             infinity   ns = 256
*
*                    (+)  by default matrices of this order are
*                         passed to the implicit double shift routine
*                         xlahqr.  see iparmq(ispec=12) above.   these
*                         values of ns are used only in case of a rare
*                         xlahqr failure.
*
*                    (**) the asterisks (**) indicate an ad-hoc
*                         function increasing from 10 to 64.
*
*       iparmq(ispec=16) select structured matrix multiply.
*                        (see ispec=16 above for details.)
*                        default: 3.
*
*     ================================================================
*     .. parameters ..
      integer            inmin, inwin, inibl, ishfts, iacc22
      parameter          ( inmin = 12, inwin = 13, inibl = 14,
     $                   ishfts = 15, iacc22 = 16 )
      integer            nmin, k22min, kacmin, nibble, knwswp
      parameter          ( nmin = 75, k22min = 14, kacmin = 14,
     $                   nibble = 14, knwswp = 500 )
      real               two
      parameter          ( two = 2.0 )
*     ..
*     .. local scalars ..
      integer            nh, ns
*     ..
*     .. intrinsic functions ..
      intrinsic          log, max, mod, nint, real
*     ..
*     .. executable statements ..
      if( ( ispec.eq.ishfts ) .or. ( ispec.eq.inwin ) .or.
     $    ( ispec.eq.iacc22 ) ) then
*
*        ==== set the number simultaneous shifts ====
*
         nh = ihi - ilo + 1
         ns = 2
         if( nh.ge.30 )
     $      ns = 4
         if( nh.ge.60 )
     $      ns = 10
         if( nh.ge.150 )
     $      ns = max( 10, nh / nint( log( real( nh ) ) / log( two ) ) )
         if( nh.ge.590 )
     $      ns = 64
         if( nh.ge.3000 )
     $      ns = 128
         if( nh.ge.6000 )
     $      ns = 256
         ns = max( 2, ns-mod( ns, 2 ) )
      end if
*
      if( ispec.eq.inmin ) then
*
*
*        ===== matrices of order smaller than nmin get sent
*        .     to xlahqr, the classic double shift algorithm.
*        .     this must be at least 11. ====
*
         iparmq = nmin
*
      else if( ispec.eq.inibl ) then
*
*        ==== inibl: skip a multi-shift qr iteration and
*        .    whenever aggressive early deflation finds
*        .    at least (nibble*(window size)/100) deflations. ====
*
         iparmq = nibble
*
      else if( ispec.eq.ishfts ) then
*
*        ==== nshfts: the number of simultaneous shifts =====
*
         iparmq = ns
*
      else if( ispec.eq.inwin ) then
*
*        ==== nw: deflation window size.  ====
*
         if( nh.le.knwswp ) then
            iparmq = ns
         else
            iparmq = 3*ns / 2
         end if
*
      else if( ispec.eq.iacc22 ) then
*
*        ==== iacc22: whether to accumulate reflections
*        .     before updating the far-from-diagonal elements
*        .     and whether to use 2-by-2 block structure while
*        .     doing it.  a small amount of work could be saved
*        .     by making this choice dependent also upon the
*        .     nh=ihi-ilo+1.
*
         iparmq = 0
         if( ns.ge.kacmin )
     $      iparmq = 1
         if( ns.ge.k22min )
     $      iparmq = 2
*
      else
*        ===== invalid value of ispec =====
         iparmq = -1
*
      end if
*
*     ==== end of iparmq ====
*
      end
ccc
      double precision function dlamch( cmach )
*
*  -- lapack auxiliary routine (version 3.3.0) --
*  -- lapack is a software package provided by univ. of tennessee,    --
*  -- univ. of california berkeley, univ. of colorado denver and nag ltd..--
*     based on lapack dlamch but with fortran 95 query functions
*     see: http://www.cs.utk.edu/~luszczek/lapack/lamch.html
*     and  http://www.netlib.org/lapack-dev/lapack-coding/program-style.html#id2537289
*     july 2010
*
*     .. scalar arguments ..
      character          cmach
*     ..
*
*  purpose
*  =======
*
*  dlamch determines double precision machine parameters.
*
*  arguments
*  =========
*
*  cmach   (input) character*1
*          specifies the value to be returned by dlamch:
*          = 'e' or 'e',   dlamch := eps
*          = 's' or 's ,   dlamch := sfmin
*          = 'b' or 'b',   dlamch := base
*          = 'p' or 'p',   dlamch := eps*base
*          = 'n' or 'n',   dlamch := t
*          = 'r' or 'r',   dlamch := rnd
*          = 'm' or 'm',   dlamch := emin
*          = 'u' or 'u',   dlamch := rmin
*          = 'l' or 'l',   dlamch := emax
*          = 'o' or 'o',   dlamch := rmax
*
*          where
*
*          eps   = relative machine precision
*          sfmin = safe minimum, such that 1/sfmin does not overflow
*          base  = base of the machine
*          prec  = eps*base
*          t     = number of (base) digits in the mantissa
*          rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
*          emin  = minimum exponent before (gradual) underflow
*          rmin  = underflow threshold - base**(emin-1)
*          emax  = largest exponent before overflow
*          rmax  = overflow threshold  - (base**emax)*(1-eps)
*
* =====================================================================
*
*     .. parameters ..
      double precision   one, zero
      parameter          ( one = 1.0d+0, zero = 0.0d+0 )
*     ..
*     .. local scalars ..
      double precision   rnd, eps, sfmin, small, rmach
*     ..
*     .. external functions ..
      logical            lsame
      external           lsame
*     ..
*     .. intrinsic functions ..
      intrinsic          digits, epsilon, huge, maxexponent,
     $                   minexponent, radix, tiny
*     ..
*     .. executable statements ..
*
*
*     assume rounding, not chopping. always.
*
      rnd = one
*
      if( one.eq.rnd ) then
         eps = epsilon(zero) * 0.5
      else
         eps = epsilon(zero)
      end if
*
      if( lsame( cmach, 'e' ) ) then
         rmach = eps
      else if( lsame( cmach, 's' ) ) then
         sfmin = tiny(zero)
         small = one / huge(zero)
         if( small.ge.sfmin ) then
*
*           use small plus a bit, to avoid the possibility of rounding
*           causing overflow when computing  1/sfmin.
*
            sfmin = small*( one+eps )
         end if
         rmach = sfmin
      else if( lsame( cmach, 'b' ) ) then
         rmach = radix(zero)
      else if( lsame( cmach, 'p' ) ) then
         rmach = eps * radix(zero)
      else if( lsame( cmach, 'n' ) ) then
         rmach = digits(zero)
      else if( lsame( cmach, 'r' ) ) then
         rmach = rnd
      else if( lsame( cmach, 'm' ) ) then
         rmach = minexponent(zero)
      else if( lsame( cmach, 'u' ) ) then
         rmach = tiny(zero)
      else if( lsame( cmach, 'l' ) ) then
         rmach = maxexponent(zero)
      else if( lsame( cmach, 'o' ) ) then
         rmach = huge(zero)
      else
         rmach = zero
      end if
*
      dlamch = rmach
      return
*
*     end of dlamch
*
      end
************************************************************************
*
      double precision function dlamc3( a, b )
*
*  -- lapack auxiliary routine (version 3.3.0) --
*     univ. of tennessee, univ. of california berkeley and nag ltd..
*     november 2010
*
*     .. scalar arguments ..
      double precision   a, b
*     ..
*
*  purpose
*  =======
*
*  dlamc3  is intended to force  a  and  b  to be stored prior to doing
*  the addition of  a  and  b ,  for use in situations where optimizers
*  might hold one of these in a register.
*
*  arguments
*  =========
*
*  a       (input) double precision
*  b       (input) double precision
*          the values a and b.
*
* =====================================================================
*
*     .. executable statements ..
*
      dlamc3 = a + b
*
      return
*
*     end of dlamc3
*
      end
*
************************************************************************
c $Id: rism1d.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdt_lr_beta_2_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsdt_lr_beta_2_5.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_vtrbtray + = 1/4 * Sum ( p10 p11 h13 h9 ) * y ( h9 h13 p10 p11 )_y * i1 ( p10 p11 h9 h13 )_vtrbtra
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h9b
      INTEGER h13b
      INTEGER p10b
      INTEGER p11b
      INTEGER h9b_1
      INTEGER h13b_1
      INTEGER p10b_1
      INTEGER p11b_1
      INTEGER p10b_2
      INTEGER p11b_2
      INTEGER h9b_2
      INTEGER h13b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperh(2)
      INTEGER isuperh
      INTEGER nsubp(2)
      INTEGER isubp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      IF (next.eq.count) THEN
      IF (0 .eq. ieor(irrep_v,ieor(irrep_trb,ieor(irrep_tra,irrep_y)))) 
     &THEN
      dimc = 1
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h9b = 1,noab
      DO h13b = h9b,noab
      DO p10b = noab+1,noab+nvab
      DO p11b = p10b,noab+nvab
      IF (int_mb(k_spin+h9b-1)+int_mb(k_spin+h13b-1) .eq. int_mb(k_spin+
     &p10b-1)+int_mb(k_spin+p11b-1)) THEN
      IF (ieor(int_mb(k_sym+h9b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb
     &(k_sym+p10b-1),int_mb(k_sym+p11b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h9b,h13b,p10b,p11b,h9b_1,h13b_1,p10b_1,p11b_
     &1)
      CALL TCE_RESTRICTED_4(p10b,p11b,h9b,h13b,p10b_2,p11b_2,h9b_2,h13b_
     &2)
      dim_common = int_mb(k_range+h9b-1) * int_mb(k_range+h13b-1) * int_
     &mb(k_range+p10b-1) * int_mb(k_range+p11b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_5',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p11b_
     &1 - noab - 1 + nvab * (p10b_1 - noab - 1 + nvab * (h13b_1 - 1 + no
     &ab * (h9b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h13b-1),int_mb(k_range+p10b-1),int_mb(k_range+p11b
     &-1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_beta_2_5',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_beta_2_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_5',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h13b_
     &2 - 1 + noab * (h9b_2 - 1 + noab * (p11b_2 - noab - 1 + nvab * (p1
     &0b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p10b-1
     &),int_mb(k_range+p11b-1),int_mb(k_range+h9b-1),int_mb(k_range+h13b
     &-1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_beta_2_5',6,MA_
     &ERR)
      nsuperh(1) = 1
      nsuperh(2) = 1
      isuperh = 1
      IF (h9b .eq. h13b) THEN
      nsuperh(isuperh) = nsuperh(isuperh) + 1
      ELSE
      isuperh = isuperh + 1
      END IF
      nsubp(1) = 1
      nsubp(2) = 1
      isubp = 1
      IF (p10b .eq. p11b) THEN
      nsubp(isubp) = nsubp(isubp) + 1
      ELSE
      isubp = isubp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperh(1))/FACTORIAL(nsuperh(2))/FACTORIAL(nsubp(1))/FACTORIAL(ns
     &ubp(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_5',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_5',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_beta_2_5',9,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_c_sort),dbl_mb(k_c),1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_beta_2_5',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_beta_2_5',
     &11,MA_ERR)
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

C $Id: setpth.F 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine drdy_setpth
C
C Setup for first step off saddle point
C
      Implicit None
#include "errquit.fh"
c
#include "drdyP.fh"
#include "stdio.fh"
*::local::
      Integer i,ierr,ilrg
      Double Precision u1max
C
      write(fu6,600)
C Calculation for step off saddle point
C Diagonalize hessian matrix stored in f
      Call drdy_diagf (n3tm,n3,fspsv,hess,vec0,u0,vec1,vec2,ierr)
      if (ierr.ne.0) then
         write(fu6,6000) ierr
         call errquit('drdy_setpth:drdy_diagf error',555, INPUT_ERR)
      endif
C It is assumed that the smallest (most negative) eigenvalue is ordered first.
C    Determine phase of the eigenvector so that largest component is positive.
      u1max = 0.0d00
      do i = 1,n3
         if (abs(u0(i,1)) .ge. u1max) then
            u1max = abs(u0(i,1))
            ilrg = i
         end if
      enddo
C Switch sign if (largest element)*dir < 0
      if (u0(ilrg,1)*dir .lt. 0.0d00) then
         do i = 1,n3
            u0(i,1) = -u0(i,1)
         enddo
      endif
C Save initial direction vector
      do i = 1, n3
         vec0sv(i) = u0(i,1)
         vec1sv(i) = 0.0d00
      enddo
      write(fu6,601) (vec0sv(i),i=1,n3)
C           
      if (lgs(31).ge.3) then
C Calculate quadratic correction to step off saddle point
         call drdy_pmlqsp
         write(fu6,602) (vec1sv(i),i=1,n3)
      endif
      Return
600   Format(//,' Set up to take first step off saddle point')
601   Format(/,' Vector for initial step off saddle point=',/,
     *   (T35,0p9f9.4))
602   Format(/,' Second order correction for vector=',/,
     *   (T35,0p9f9.4))
6000  Format (' in subroutine diagf error in call to eispack routine',
     *   ' rsp, ierr=', I5)
      End

      subroutine cf_dww(xw,xwm,pw,pwp,iwfrom,nlocw,lpbc,chg,iwq,
     + lwwndx,lwwjpt,lwwin,lwwj,rwc,xi,xj,rwx,pl,pj,fi,fj)
c
c $Id: cf_d.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "cf_common.fh"
c
      real*8 xw(mwm,3,mwa),xwm(mwm,3)
      real*8 pw(mwm,3,mwa,2),pwp(mwm,3,mwa,2,2)
      integer iwfrom,nlocw
      logical lpbc
      real*8 chg(mqt,mqp,mset)
      integer iwq(mwa)
      integer lwwndx(0:mwm,2),lwwin(nlocw,2),lwwjpt(nlocw,2),lwwj(*)
c
      real*8 rwc(mscr,3),rwx(mscr,3)
      real*8 xi(mscr,3,mwa),xj(mscr,3,mwa)
      real*8 pl(mscr,3,mwa),pj(mscr,3,mwa)
      real*8 fi(mscr,3,mwa),fj(mscr,3,mwa)
c
      integer ix,ipset,nax2,nwwlen(2)
      integer iwfr,ipww,number,iwm,iwpm,nax,iwpj,iwa,jwa,iax,iwmn,lwwptr
      real*8 pai,paj,qai,qaj
      real*8 rx,ry,rz,ri2,ri3,rmi,rmj,pix,piy,piz,pjx,pjy,pjz
c
      real*8 qfaci
c
      qfaci=one/qfac
c
c     calculation of solvent-solvent intermolecular energies and forces
c
      iwfr=iwfrom-1
c
c     loop over both short and long range parts
c
      do 1 ipww=1,npww
c
c     Evaluate the outer index array
c
      nwwlen(ipww)=0
      lwwndx(0,ipww)=0
      number=0
      do 2 iwm=1,nlocw
      if(number+lwwin(iwm,ipww).gt.mscr) then
      nwwlen(ipww)=nwwlen(ipww)+1
      lwwndx(nwwlen(ipww),ipww)=iwm-1
      number=0
      endif
      number=number+lwwin(iwm,ipww)
    2 continue
      if(number.gt.0) then
      nwwlen(ipww)=nwwlen(ipww)+1
      lwwndx(nwwlen(ipww),ipww)=nlocw
      endif
c
c     loop over number of cycles to complete pairlist
c
      do 3 iwpm=1,nwwlen(ipww)
      nax=0
c
c     collect coordinates into workarrays
c
      do 4 iwm=lwwndx(iwpm-1,ipww)+1,lwwndx(iwpm,ipww)
      iwpj=lwwjpt(iwm,ipww)-1
      do 5 iwmn=1,lwwin(iwm,ipww)
      lwwptr=lwwj(iwpj+iwmn)
      rwc(nax+iwmn,1)=xwm(lwwptr,1)-xwm(iwfr+iwm,1)
      rwc(nax+iwmn,2)=xwm(lwwptr,2)-xwm(iwfr+iwm,2)
      rwc(nax+iwmn,3)=xwm(lwwptr,3)-xwm(iwfr+iwm,3)
    5 continue
c
      if(.not.lpbc) then
      do 6 iwa=1,mwa
      do 7 iwmn=1,lwwin(iwm,ipww)
      lwwptr=lwwj(iwpj+iwmn)
      xi(nax+iwmn,1,iwa)=xw(iwfr+iwm,1,iwa)
      xi(nax+iwmn,2,iwa)=xw(iwfr+iwm,2,iwa)
      xi(nax+iwmn,3,iwa)=xw(iwfr+iwm,3,iwa)
      xj(nax+iwmn,1,iwa)=xw(lwwptr,1,iwa)
      xj(nax+iwmn,2,iwa)=xw(lwwptr,2,iwa)
      xj(nax+iwmn,3,iwa)=xw(lwwptr,3,iwa)
      pl(nax+iwmn,1,iwa)=pw(iwfr+iwm,1,iwa,2)
      pl(nax+iwmn,2,iwa)=pw(iwfr+iwm,2,iwa,2)
      pl(nax+iwmn,3,iwa)=pw(iwfr+iwm,3,iwa,2)
      pj(nax+iwmn,1,iwa)=pw(lwwptr,1,iwa,2)
      pj(nax+iwmn,2,iwa)=pw(lwwptr,2,iwa,2)
      pj(nax+iwmn,3,iwa)=pw(lwwptr,3,iwa,2)
    7 continue
    6 continue
      else
      call cf_pbc(0,rwc,mscr,rwx,mscr,nax,1,lwwin(iwm,ipww))
      do 9 iwmn=1,lwwin(iwm,ipww)
      lwwptr=lwwj(iwpj+iwmn)
      rwc(nax+iwmn,1)=rwc(nax+iwmn,1)-rwx(iwmn,1)
      rwc(nax+iwmn,2)=rwc(nax+iwmn,2)-rwx(iwmn,2)
      rwc(nax+iwmn,3)=rwc(nax+iwmn,3)-rwx(iwmn,3)
    9 continue
c
      do 10 iwa=1,mwa
      do 11 iwmn=1,lwwin(iwm,ipww)
      lwwptr=lwwj(iwpj+iwmn)
      xi(nax+iwmn,1,iwa)=xw(iwfr+iwm,1,iwa)
      xi(nax+iwmn,2,iwa)=xw(iwfr+iwm,2,iwa)
      xi(nax+iwmn,3,iwa)=xw(iwfr+iwm,3,iwa)
      xj(nax+iwmn,1,iwa)=xw(lwwptr,1,iwa)-rwx(iwmn,1)
      xj(nax+iwmn,2,iwa)=xw(lwwptr,2,iwa)-rwx(iwmn,2)
      xj(nax+iwmn,3,iwa)=xw(lwwptr,3,iwa)-rwx(iwmn,3)
      pl(nax+iwmn,1,iwa)=pw(iwfr+iwm,1,iwa,2)
      pl(nax+iwmn,2,iwa)=pw(iwfr+iwm,2,iwa,2)
      pl(nax+iwmn,3,iwa)=pw(iwfr+iwm,3,iwa,2)
      pj(nax+iwmn,1,iwa)=pw(lwwptr,1,iwa,2)
      pj(nax+iwmn,2,iwa)=pw(lwwptr,2,iwa,2)
      pj(nax+iwmn,3,iwa)=pw(lwwptr,3,iwa,2)
   11 continue
   10 continue
      endif
      nax=nax+lwwin(iwm,ipww)
    4 continue
c
c     zero temporary arrays fi and fj
c
      do 12 iwa=1,mwa
      do 13 ix=1,3
      do 14 iax=1,nax
      fi(iax,ix,iwa)=zero
      fj(iax,ix,iwa)=zero
   14 continue
   13 continue
   12 continue
c
c     loops over number of atoms in a solvent molecule
c
c     calculated here is 4*pi*epsilon*field and not just the field
c     since the polarization is given in alpha/(4*pi*epsilon) in
c     stead of just alpha, the induced dipole is obtained by the
c     product of pwa and pw
c
      do 20 iwa=1,mwa
      qai=qfaci*chg(iwq(iwa),1,iset)
      pai=chg(iwq(iwa),2,iset)
      do 21 jwa=1,mwa
      qaj=qfaci*chg(iwq(jwa),1,iset)
      paj=chg(iwq(jwa),2,iset)
      do 22 iax=1,nax
      rx=xj(iax,1,jwa)-xi(iax,1,iwa)
      ry=xj(iax,2,jwa)-xi(iax,2,iwa)
      rz=xj(iax,3,jwa)-xi(iax,3,iwa)
      pix=pai*pl(iax,1,iwa)
      piy=pai*pl(iax,2,iwa)
      piz=pai*pl(iax,3,iwa)
      pjx=paj*pj(iax,1,jwa)
      pjy=paj*pj(iax,2,jwa)
      pjz=paj*pj(iax,3,jwa)
      ri2=one/(rx**2+ry**2+rz**2)
      ri3=sqrt(ri2)*ri2
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1,iwa)=fi(iax,1,iwa)+((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2,iwa)=fi(iax,2,iwa)+((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3,iwa)=fi(iax,3,iwa)+((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1,jwa)=fj(iax,1,jwa)+((rmi+qai)*rx-pix)*ri3
      fj(iax,2,jwa)=fj(iax,2,jwa)+((rmi+qai)*ry-piy)*ri3
      fj(iax,3,jwa)=fj(iax,3,jwa)+((rmi+qai)*rz-piz)*ri3
   22 continue
   21 continue
   20 continue
c
c     Update the electric field arrays
c
      iax=0
      do 23 iwm=lwwndx(iwpm-1,ipww)+1,lwwndx(iwpm,ipww)
      iwpj=lwwjpt(iwm,ipww)-1
      do 24 iwa=1,mwa
      do 25 iwmn=1,lwwin(iwm,ipww)
      lwwptr=lwwj(iwpj+iwmn)
      pw(iwfr+iwm,1,iwa,1)=pw(iwfr+iwm,1,iwa,1)+fi(iax+iwmn,1,iwa)
      pw(iwfr+iwm,2,iwa,1)=pw(iwfr+iwm,2,iwa,1)+fi(iax+iwmn,2,iwa)
      pw(iwfr+iwm,3,iwa,1)=pw(iwfr+iwm,3,iwa,1)+fi(iax+iwmn,3,iwa)
      pw(lwwptr,1,iwa,1)=pw(lwwptr,1,iwa,1)+fj(iax+iwmn,1,iwa)
      pw(lwwptr,2,iwa,1)=pw(lwwptr,2,iwa,1)+fj(iax+iwmn,2,iwa)
      pw(lwwptr,3,iwa,1)=pw(lwwptr,3,iwa,1)+fj(iax+iwmn,3,iwa)
   25 continue
   24 continue
      iax=iax+lwwin(iwm,ipww)
   23 continue
c
c     thermodynamic perturbation and integration
c
      do 30 ipset=2,3
      if((ipset.eq.2.and.ipert2).or.
     + (ipset.eq.3.and.ipert3)) then
c
      nax2=0
      do 31 iwm=lwwndx(iwpm-1,ipww)+1,lwwndx(iwpm,ipww)
      iwpj=lwwjpt(iwm,ipww)-1
      do 32 iwa=1,mwa
      do 33 iwmn=1,lwwin(iwm,ipww)
      lwwptr=lwwj(iwpj+iwmn)
      pl(nax2+iwmn,1,iwa)=pwp(iwfr+iwm,1,iwa,ipset-1,2)
      pl(nax2+iwmn,2,iwa)=pwp(iwfr+iwm,2,iwa,ipset-1,2)
      pl(nax2+iwmn,3,iwa)=pwp(iwfr+iwm,3,iwa,ipset-1,2)
      pj(nax2+iwmn,1,iwa)=pwp(lwwptr,1,iwa,ipset-1,2)
      pj(nax2+iwmn,2,iwa)=pwp(lwwptr,2,iwa,ipset-1,2)
      pj(nax2+iwmn,3,iwa)=pwp(lwwptr,3,iwa,ipset-1,2)
   33 continue
   32 continue
      nax2=nax2+lwwin(iwm,ipww)
   31 continue
c
      if(nax.ne.nax2) call md_abort('Error in dipww',me)
c
c
      do 40 iwa=1,mwa
      do 41 ix=1,3
      do 42 iax=1,nax
      fi(iax,ix,iwa)=zero
      fj(iax,ix,iwa)=zero
   42 continue
   41 continue
   40 continue
c
      do 34 iwa=1,mwa
      qai=qfaci*chg(iwq(iwa),1,ipset)
      pai=chg(iwq(iwa),2,ipset)
      do 35 jwa=1,mwa
      qaj=qfaci*chg(iwq(jwa),1,ipset)
      paj=chg(iwq(jwa),2,ipset)
      do 36 iax=1,nax
      rx=xj(iax,1,jwa)-xi(iax,1,iwa)
      ry=xj(iax,2,jwa)-xi(iax,2,iwa)
      rz=xj(iax,3,jwa)-xi(iax,3,iwa)
      pix=pai*pl(iax,1,iwa)
      piy=pai*pl(iax,2,iwa)
      piz=pai*pl(iax,3,iwa)
      pjx=paj*pj(iax,1,jwa)
      pjy=paj*pj(iax,2,jwa)
      pjz=paj*pj(iax,3,jwa)
      ri2=one/(rx**2+ry**2+rz**2)
      ri3=sqrt(ri2)*ri2
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1,iwa)=fi(iax,1,iwa)+((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2,iwa)=fi(iax,2,iwa)+((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3,iwa)=fi(iax,3,iwa)+((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1,jwa)=fj(iax,1,jwa)+((rmi+qai)*rx-pix)*ri3
      fj(iax,2,jwa)=fj(iax,2,jwa)+((rmi+qai)*ry-piy)*ri3
      fj(iax,3,jwa)=fj(iax,3,jwa)+((rmi+qai)*rz-piz)*ri3
   36 continue
   35 continue
   34 continue
c
c     Update the electric field arrays
c
      iax=0
      do 37 iwm=lwwndx(iwpm-1,ipww)+1,lwwndx(iwpm,ipww)
      iwpj=lwwjpt(iwm,ipww)-1
      do 38 iwa=1,mwa
      do 39 iwmn=1,lwwin(iwm,ipww)
      lwwptr=lwwj(iwpj+iwmn)
      pwp(iwfr+iwm,1,iwa,ipset-1,1)=pwp(iwfr+iwm,1,iwa,ipset-1,1)+
     + fi(iax+iwmn,1,iwa)
      pwp(iwfr+iwm,2,iwa,ipset-1,1)=pwp(iwfr+iwm,2,iwa,ipset-1,1)+
     + fi(iax+iwmn,2,iwa)
      pwp(iwfr+iwm,3,iwa,ipset-1,1)=pwp(iwfr+iwm,3,iwa,ipset-1,1)+
     + fi(iax+iwmn,3,iwa)
      pwp(lwwptr,1,iwa,ipset-1,1)=pwp(lwwptr,1,iwa,ipset-1,1)+
     + fj(iax+iwmn,1,iwa)
      pwp(lwwptr,2,iwa,ipset-1,1)=pwp(lwwptr,2,iwa,ipset-1,1)+
     + fj(iax+iwmn,2,iwa)
      pwp(lwwptr,3,iwa,ipset-1,1)=pwp(lwwptr,3,iwa,ipset-1,1)+
     + fj(iax+iwmn,3,iwa)
   39 continue
   38 continue
      iax=iax+lwwin(iwm,ipww)
   37 continue
      endif
   30 continue
c
c
    3 continue
    1 continue
c
      return
      end
      subroutine cf_dsw(xs,xsm,ps,psp,isdt,ismf,isml,isq1,isfrom,nums,
     + xw,xwm,pw,pwp,iwq,lpbc,chg,lswndx,lswjpt,lswin,lswj,
     + rwc,xi,xj,rwx,pl,pj,fi,fj,isal)
c
c $Id: cf_d.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "cf_common.fh"
c
      real*8 xs(msa,3),xsm(msm,3),ps(msa,3,2),psp(msa,3,2,2)
      integer isdt(msa),ismf(msa),isml(msa),isq1(msa)
      integer isfrom,nums
      real*8 xw(mwm,3,mwa),xwm(mwm,3),pw(mwm,3,mwa,2),pwp(mwm,3,mwa,2,2)
      integer iwq(mwa)
      logical lpbc
      real*8 chg(mqt,mqp,mset)
      integer lswndx(0:msa,2),lswjpt(nums,2),lswin(nums,2),lswj(*)
      real*8 rwc(mscr,3),xi(mscr,3),xj(mscr,3,mwa),rwx(mscr,3)
      real*8 pl(mscr,3),pj(mscr,3,mwa),fi(mscr,3),fj(mscr,3,mwa)
      integer isal(mscr)
c
      integer ispj,ism,lswptr,ipset,nswlen(2)
      integer isfr,ipsw,number,isa,jwa,ismn,ispm,iax,nax,nax2
      real*8 qai,qaj,pai,paj,rx,ry,rz,pix,piy,piz,pjx,pjy,pjz
      real*8 ri2,ri3,rmi,rmj
#include "bitops.fh"
c
      real*8 qfaci
c
      qfaci=one/qfac
c
c     this subroutine evaluates the solute-solvent forces for nums
c     solute atoms starting from isfrom. the interacting solvent
c     molecules are determined from the pairlist.
c
      isfr=isfrom-1
c
c     loop over short and long range pairs
c
      do 1 ipsw=1,npsw
c
c     evaluate outer index array
c
      nswlen(ipsw)=0
      lswndx(0,ipsw)=0
      number=0
      do 2 isa=1,nums
      if(number+lswin(isa,ipsw).gt.mscr .or.
     + (ismf(isfr+isa).ne.ismf(isfr+isa-1).and.number.gt.0)) then
      nswlen(ipsw)=nswlen(ipsw)+1
      lswndx(nswlen(ipsw),ipsw)=isa-1
      number=0
      endif
      number=number+lswin(isa,ipsw)
    2 continue
      if(number.gt.0) then
      nswlen(ipsw)=nswlen(ipsw)+1
      lswndx(nswlen(ipsw),ipsw)=nums
      endif
c
c     loop over number of cycles to complete pairlist
c
      do 3 ispm=1,nswlen(ipsw)
      nax=0
c
c     vacuo conditions
c
c      if(npbtyp.eq.0) then
c      if(.not.lpbc) then
      do 4 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      ism=isml(isfr+isa)
c
c     collect center of mass distance vectors
c
      if(lpbc.or.ism.eq.0) then
      do 6 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      rwc(nax+ismn,1)=xs(isfr+isa,1)-xwm(lswptr,1)
      rwc(nax+ismn,2)=xs(isfr+isa,2)-xwm(lswptr,2)
      rwc(nax+ismn,3)=xs(isfr+isa,3)-xwm(lswptr,3)
    6 continue
      if(lpbc) call cf_pbc(0,rwc,mscr,rwx,mscr,nax,1,lswin(isa,ipsw))
      else
      do 5 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      rwc(nax+ismn,1)=xsm(ism,1)-xwm(lswptr,1)
      rwc(nax+ismn,2)=xsm(ism,2)-xwm(lswptr,2)
      rwc(nax+ismn,3)=xsm(ism,3)-xwm(lswptr,3)
    5 continue
      endif
c
c     collect solute coordinates and atomic polarization fields
c
c      if(iand(isdt(isfr+isa),mdynam).eq.ldynam) then
      do 7 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      xi(nax+ismn,1)=xs(isfr+isa,1)
      xi(nax+ismn,2)=xs(isfr+isa,2)
      xi(nax+ismn,3)=xs(isfr+isa,3)
      pl(nax+ismn,1)=ps(isfr+isa,1,2)
      pl(nax+ismn,2)=ps(isfr+isa,2,2)
      pl(nax+ismn,3)=ps(isfr+isa,3,2)
      isal(nax+ismn)=isfr+isa
    7 continue
c      else
c      do 8 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      xi(nax+ismn,1)=xs(isfr+isa,1)
c      xi(nax+ismn,2)=xs(isfr+isa,2)
c      xi(nax+ismn,3)=xs(isfr+isa,3)
c      pl(nax+ismn,1)=ps(isfr+isa,1,2)
c      pl(nax+ismn,2)=ps(isfr+isa,2,2)
c      pl(nax+ismn,3)=ps(isfr+isa,3,2)
c      isal(nax+ismn)=isfr+isa
c    8 continue
c      endif
c
c     collect solvent coordinates and atomic polarization fields
c
      do 8 jwa=1,mwa
      if(lpbc) then
      do 9 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      xj(nax+ismn,1,jwa)=xw(lswptr,1,jwa)+rwx(ismn,1)
      xj(nax+ismn,2,jwa)=xw(lswptr,2,jwa)+rwx(ismn,2)
      xj(nax+ismn,3,jwa)=xw(lswptr,3,jwa)+rwx(ismn,3)
      pj(nax+ismn,1,jwa)=pw(lswptr,1,jwa,2)
      pj(nax+ismn,2,jwa)=pw(lswptr,2,jwa,2)
      pj(nax+ismn,3,jwa)=pw(lswptr,3,jwa,2)
    9 continue
      else
      do 10 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      xj(nax+ismn,1,jwa)=xw(lswptr,1,jwa)
      xj(nax+ismn,2,jwa)=xw(lswptr,2,jwa)
      xj(nax+ismn,3,jwa)=xw(lswptr,3,jwa)
      pj(nax+ismn,1,jwa)=pw(lswptr,1,jwa,2)
      pj(nax+ismn,2,jwa)=pw(lswptr,2,jwa,2)
      pj(nax+ismn,3,jwa)=pw(lswptr,3,jwa,2)
   10 continue
      endif
    8 continue
      nax=nax+lswin(isa,ipsw)
    4 continue
c      else
cc
cc     periodic boundary conditions
cc
c      do 11 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
c      ispj=lswjpt(isa,ipsw)-1
c      ism=isml(isfr+isa)
cc
cc     collect center of mass distance vectors
cc
c      do 12 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      rwc(nax+ismn,1)=xs(isfr+isa,1)-xwm(lswptr,1)
c      rwc(nax+ismn,2)=xs(isfr+isa,2)-xwm(lswptr,2)
c      rwc(nax+ismn,3)=xs(isfr+isa,3)-xwm(lswptr,3)
c      rwx(ismn,1)=zero
c      rwx(ismn,2)=zero
c      rwx(ismn,3)=zero
c      if(abs(rwc(nax+ismn,1)).gt.boxh(1)) then
c      rwx(ismn,1)=sign(box(1),xs(isfr+isa,1))
c      endif
c      if(abs(rwc(nax+ismn,2)).gt.boxh(2)) then
c      rwx(ismn,2)=sign(box(2),xs(isfr+isa,2))
c      endif
c      if(npbtyp.eq.1) then
c      if(abs(rwc(nax+ismn,3)).gt.boxh(3)) then
c      rwx(ismn,3)=sign(box(3),xs(isfr+isa,3))
c      endif
c      endif
c      if(ism.gt.0) then
c      rwc(nax+ismn,1)=xsm(ism,1)-xwm(lswptr,1)-rwx(ismn,1)
c      rwc(nax+ismn,2)=xsm(ism,2)-xwm(lswptr,2)-rwx(ismn,2)
c      rwc(nax+ismn,3)=xsm(ism,3)-xwm(lswptr,3)-rwx(ismn,3)
c      else
c      rwc(nax+ismn,1)=xs(isfr+isa,1)-xwm(lswptr,1)-rwx(ismn,1)
c      rwc(nax+ismn,2)=xs(isfr+isa,2)-xwm(lswptr,2)-rwx(ismn,2)
c      rwc(nax+ismn,3)=xs(isfr+isa,3)-xwm(lswptr,3)-rwx(ismn,3)
c      endif
c   12 continue
cc
cc     collect solute coordinates and atomic polarization fields
cc
c      do 13 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      xi(nax+ismn,1)=xs(isfr+isa,1)
c      xi(nax+ismn,2)=xs(isfr+isa,2)
c      xi(nax+ismn,3)=xs(isfr+isa,3)
c      pl(nax+ismn,1)=ps(isfr+isa,1,2)
c      pl(nax+ismn,2)=ps(isfr+isa,2,2)
c      pl(nax+ismn,3)=ps(isfr+isa,3,2)
c      isal(nax+ismn)=isfr+isa
c   13 continue
cc
cc     collect solvent coordinates and atomic polarization fields
cc
c      do 14 jwa=1,mwa
c      do 15 ismn=1,lswin(isa,ipsw)
c      lswptr=lswj(ispj+ismn)
c      xj(nax+ismn,1,jwa)=xw(lswptr,1,jwa)+rwx(ismn,1)
c      xj(nax+ismn,2,jwa)=xw(lswptr,2,jwa)+rwx(ismn,2)
c      xj(nax+ismn,3,jwa)=xw(lswptr,3,jwa)+rwx(ismn,3)
c      pj(nax+ismn,1,jwa)=pw(lswptr,1,jwa,2)
c      pj(nax+ismn,2,jwa)=pw(lswptr,2,jwa,2)
c      pj(nax+ismn,3,jwa)=pw(lswptr,3,jwa,2)
c   15 continue
c   14 continue
c      nax=nax+lswin(isa,ipsw)
c   11 continue
c      endif
c
c     zero temparary arays fi and fj
c
      do 16 iax=1,nax
      fi(iax,1)=zero
      fi(iax,2)=zero
      fi(iax,3)=zero
   16 continue
      do 17 jwa=1,mwa
      do 18 iax=1,nax
      fj(iax,1,jwa)=zero
      fj(iax,2,jwa)=zero
      fj(iax,3,jwa)=zero
   18 continue
   17 continue
c
c     loop over the number of atoms in a solvent molecule
c
c     calculated here is 4*pi*epsilon*field and not just the field
c     since the polarization is given in alpha/(4*pi*epsilon) in
c     stead of just alpha, the induced dipole is obtained by the
c     product of pwa and pw
c
      do 19 jwa=1,mwa
      qaj=qfaci*chg(iwq(jwa),1,iset)
      paj=chg(iwq(jwa),2,iset)
      do 20 iax=1,nax
      isa=isal(iax)
      qai=qfaci*chg(isq1(isa),1,iset)
      pai=chg(isq1(isa),2,iset)
      rx=xj(iax,1,jwa)-xi(iax,1)
      ry=xj(iax,2,jwa)-xi(iax,2)
      rz=xj(iax,3,jwa)-xi(iax,3)
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1,jwa)
      pjy=paj*pj(iax,2,jwa)
      pjz=paj*pj(iax,3,jwa)
      ri2=one/(rx**2+ry**2+rz**2)
      ri3=sqrt(ri2)*ri2
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=fi(iax,1)+((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=fi(iax,2)+((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=fi(iax,3)+((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1,jwa)=fj(iax,1,jwa)+((rmi+qai)*rx-pix)*ri3
      fj(iax,2,jwa)=fj(iax,2,jwa)+((rmi+qai)*ry-piy)*ri3
      fj(iax,3,jwa)=fj(iax,3,jwa)+((rmi+qai)*rz-piz)*ri3
   20 continue
   19 continue
c
c     update the electric field arrays
c
      iax=0
      do 21 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      do 22 ismn=1,lswin(isa,ipsw)
      ps(isfr+isa,1,1)=ps(isfr+isa,1,1)+fi(iax+ismn,1)
      ps(isfr+isa,2,1)=ps(isfr+isa,2,1)+fi(iax+ismn,2)
      ps(isfr+isa,3,1)=ps(isfr+isa,3,1)+fi(iax+ismn,3)
   22 continue
      do 23 jwa=1,mwa
      do 24 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pw(lswptr,1,jwa,1)=pw(lswptr,1,jwa,1)+fj(iax+ismn,1,jwa)
      pw(lswptr,2,jwa,1)=pw(lswptr,2,jwa,1)+fj(iax+ismn,2,jwa)
      pw(lswptr,3,jwa,1)=pw(lswptr,3,jwa,1)+fj(iax+ismn,3,jwa)
   24 continue
   23 continue
      iax=iax+lswin(isa,ipsw)
   21 continue
c
c     thermodynamic integration and perturbation
c
      do 30 ipset=2,3
      if((ipset.eq.2.and.ipert2).or.
     + (ipset.eq.3.and.ipert3)) then
c
      nax2=0
      do 31 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      do 32 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pl(nax2+ismn,1)=psp(isfr+isa,1,2,ipset-1)
      pl(nax2+ismn,2)=psp(isfr+isa,2,2,ipset-1)
      pl(nax2+ismn,3)=psp(isfr+isa,3,2,ipset-1)
   32 continue
      do 33 jwa=1,mwa
      do 34 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pj(nax2+ismn,1,jwa)=pwp(lswptr,1,jwa,2,ipset-1)
      pj(nax2+ismn,2,jwa)=pwp(lswptr,2,jwa,2,ipset-1)
      pj(nax2+ismn,3,jwa)=pwp(lswptr,3,jwa,2,ipset-1)
   34 continue
   33 continue
      nax2=nax2+lswin(isa,ipsw)
   31 continue
c
      if(nax.ne.nax2) call md_abort('Error in dipsw',me)
c
      do 41 iax=1,nax
      fi(iax,1)=zero
      fi(iax,2)=zero
      fi(iax,3)=zero
   41 continue
      do 42 jwa=1,mwa
      do 43 iax=1,nax
      fj(iax,1,jwa)=zero
      fj(iax,2,jwa)=zero
      fj(iax,3,jwa)=zero
   43 continue
   42 continue
c
      do 35 jwa=1,mwa
      qaj=qfaci*chg(iwq(jwa),1,ipset)
      paj=chg(iwq(jwa),2,ipset)
      do 36 iax=1,nax
      isa=isal(iax)
      qai=qfaci*chg(isq1(isa),1,ipset)
      pai=chg(isq1(isa),2,ipset)
      rx=xj(iax,1,jwa)-xi(iax,1)
      ry=xj(iax,2,jwa)-xi(iax,2)
      rz=xj(iax,3,jwa)-xi(iax,3)
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1,jwa)
      pjy=paj*pj(iax,2,jwa)
      pjz=paj*pj(iax,3,jwa)
      ri2=one/(rx**2+ry**2+rz**2)
      ri3=sqrt(ri2)*ri2
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=fi(iax,1)+((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=fi(iax,2)+((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=fi(iax,3)+((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1,jwa)=fj(iax,1,jwa)+((rmi+qai)*rx-pix)*ri3
      fj(iax,2,jwa)=fj(iax,2,jwa)+((rmi+qai)*ry-piy)*ri3
      fj(iax,3,jwa)=fj(iax,3,jwa)+((rmi+qai)*rz-piz)*ri3
   36 continue
   35 continue
c
c     update the electric field arrays
c
      iax=0
      do 37 isa=lswndx(ispm-1,ipsw)+1,lswndx(ispm,ipsw)
      ispj=lswjpt(isa,ipsw)-1
      do 38 ismn=1,lswin(isa,ipsw)
      psp(isfr+isa,1,ipset-1,1)=psp(isfr+isa,1,ipset-1,1)+fi(iax+ismn,1)
      psp(isfr+isa,2,ipset-1,1)=psp(isfr+isa,2,ipset-1,1)+fi(iax+ismn,2)
      psp(isfr+isa,3,ipset-1,1)=psp(isfr+isa,3,ipset-1,1)+fi(iax+ismn,3)
   38 continue
      do 39 jwa=1,mwa
      do 40 ismn=1,lswin(isa,ipsw)
      lswptr=lswj(ispj+ismn)
      pwp(lswptr,1,jwa,ipset-1,1)=pwp(lswptr,1,jwa,ipset-1,1)+
     + fj(iax+ismn,1,jwa)
      pwp(lswptr,2,jwa,ipset-1,1)=pwp(lswptr,2,jwa,ipset-1,1)+
     + fj(iax+ismn,2,jwa)
      pwp(lswptr,3,jwa,ipset-1,1)=pwp(lswptr,3,jwa,ipset-1,1)+
     + fj(iax+ismn,3,jwa)
   40 continue
   39 continue
      iax=iax+lswin(isa,ipsw)
   37 continue
      endif
   30 continue
c
    3 continue
    1 continue
c
      return
      end
      subroutine cf_dss(xs,xsm,ps,psp,ismf,isml,isq2,isq3,isfrom,nums,
     + lpbc,chg,lssndx,lssjpt,lssin,lssj,xi,xj,rwc,rwi1,rwi2,rwi6,
     + rwx,rw,fi,fj,f,isal,jsal,jmal,jfal,pl,pj)
c
c $Id: cf_d.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "cf_common.fh"
c
      real*8 xs(msa,3),xsm(msm,3),ps(msa,3,2),psp(msa,3,2,2)
      integer ismf(msa),isml(msa),isq2(msa),isq3(msa)
      integer isfrom,nums
      logical lpbc
      real*8 chg(mqt,mqp,mset)
      integer lssndx(0:msa,2),lssjpt(nums,2),lssin(nums,2)
c
      real*8 xi(mscr,3),xj(mscr,3),rwx(mscr,3),rwi1(mscr)
      real*8 rwi2(mscr),rwi6(mscr),rwc(mscr,3),rw(mscr)
      real*8 f(mscr),fi(mscr,3),fj(mscr,3),pl(mscr,3),pj(mscr,3)
      integer isal(mscr),jsal(mscr),jmal(mscr),jfal(mscr)
      integer lssj(*)
c
      integer isa,jsa,jsf,ipset
      integer isfr,nsslen(2)
      integer ipss,number,isslen,nax,nax2,jsaptr
      integer jnum,lssptr,iax,ism,jsm
c
      real*8 ri1,ri2,ri3,rx,ry,rz,pix,piy,piz,pjx,pjy,pjz,rmi,rmj
      real*8 qai,pai,qaj,paj
c
#include "bitops.fh"
c
      real*8 qfaci
c
      qfaci=one/qfac
c
c     solute non-bonded pairs
c     =======================
c
      isfr=isfrom-1
c
c     loop over both short and long range pairlists
c
      do 1 ipss=1,npss
c
c     evaluate outer index array
c
      nsslen(ipss)=0
      lssndx(0,ipss)=0
      number=0
      do 2 isa=1,nums
      if(number+lssin(isa,ipss).gt.mscr .or.
     + (ismf(isfr+isa).ne.ismf(isfr+isa-1).and.number.gt.0)) then
      nsslen(ipss)=nsslen(ipss)+1
      lssndx(nsslen(ipss),ipss)=isa-1
      number=0
      endif
      number=number+lssin(isa,ipss)
    2 continue
      if(number.gt.0) then
      nsslen(ipss)=nsslen(ipss)+1
      lssndx(nsslen(ipss),ipss)=nums
      endif
c
c     loop over number of cycles to complete pairlists
c
      do 3 isslen=1,nsslen(ipss)
      nax=0
      ism=isml(isfr+lssndx(isslen,ipss))
c
c     collect coordinates into workarrays
c
c      if(npbtyp.eq.0) then
      do 4 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      ism=isml(isfr+isa)
      if(lpbc) then
      do 151 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      rwc(nax+jnum,1)=xs(isfr+isa,1)-xs(lssptr,1)
      rwc(nax+jnum,2)=xs(isfr+isa,2)-xs(lssptr,2)
      rwc(nax+jnum,3)=xs(isfr+isa,3)-xs(lssptr,3)
  151 continue
      call cf_pbc(0,rwc,mscr,rwx,mscr,nax,1,lssin(isa,ipss))
      endif
      do 5 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      jsf=ismf(lssptr)
      isal(nax+jnum)=isfr+isa
      jsal(nax+jnum)=lssptr
      jmal(nax+jnum)=jsf
      jsm=isml(lssptr)
      jfal(nax+jnum)=2
      if(ism.ne.jsm) jfal(nax+jnum)=3
      if(ism.gt.0) then
      if(jsm.gt.0) then
      rwc(nax+jnum,1)=xsm(ism,1)-xsm(jsm,1)
      rwc(nax+jnum,2)=xsm(ism,2)-xsm(jsm,2)
      rwc(nax+jnum,3)=xsm(ism,3)-xsm(jsm,3)
      else
      rwc(nax+jnum,1)=xsm(ism,1)-xs(lssptr,1)
      rwc(nax+jnum,2)=xsm(ism,2)-xs(lssptr,2)
      rwc(nax+jnum,3)=xsm(ism,3)-xs(lssptr,3)
      endif
      else
      if(jsm.gt.0) then
      rwc(nax+jnum,1)=xs(isfr+isa,1)-xsm(jsm,1)
      rwc(nax+jnum,2)=xs(isfr+isa,2)-xsm(jsm,2)
      rwc(nax+jnum,3)=xs(isfr+isa,3)-xsm(jsm,3)
      else
      rwc(nax+jnum,1)=xs(isfr+isa,1)-xs(lssptr,1)
      rwc(nax+jnum,2)=xs(isfr+isa,2)-xs(lssptr,2)
      rwc(nax+jnum,3)=xs(isfr+isa,3)-xs(lssptr,3)
      endif
      endif
    5 continue
      if(.not.lpbc) then
      do 7 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      xi(nax+jnum,1)=xs(isfr+isa,1)
      xi(nax+jnum,2)=xs(isfr+isa,2)
      xi(nax+jnum,3)=xs(isfr+isa,3)
      xj(nax+jnum,1)=xs(lssptr,1)
      xj(nax+jnum,2)=xs(lssptr,2)
      xj(nax+jnum,3)=xs(lssptr,3)
      pl(nax+jnum,1)=ps(isfr+isa,1,2)
      pl(nax+jnum,2)=ps(isfr+isa,2,2)
      pl(nax+jnum,3)=ps(isfr+isa,3,2)
      pj(nax+jnum,1)=ps(lssptr,1,2)
      pj(nax+jnum,2)=ps(lssptr,2,2)
      pj(nax+jnum,3)=ps(lssptr,3,2)
      isal(nax+jnum)=isfr+isa
      jsal(nax+jnum)=lssptr
    7 continue
      else
      do 8 jnum=1,lssin(isa,ipss)
      rwc(nax+jnum,1)=rwc(nax+jnum,1)-rwx(jnum,1)
      rwc(nax+jnum,2)=rwc(nax+jnum,2)-rwx(jnum,2)
      rwc(nax+jnum,3)=rwc(nax+jnum,3)-rwx(jnum,3)
      lssptr=lssj(jsaptr+jnum)
      xi(nax+jnum,1)=xs(isfr+isa,1)
      xi(nax+jnum,2)=xs(isfr+isa,2)
      xi(nax+jnum,3)=xs(isfr+isa,3)
      xj(nax+jnum,1)=xs(lssptr,1)+rwx(jnum,1)
      xj(nax+jnum,2)=xs(lssptr,2)+rwx(jnum,2)
      xj(nax+jnum,3)=xs(lssptr,3)+rwx(jnum,3)
      pl(nax+jnum,1)=ps(isfr+isa,1,2)
      pl(nax+jnum,2)=ps(isfr+isa,2,2)
      pl(nax+jnum,3)=ps(isfr+isa,3,2)
      pj(nax+jnum,1)=ps(lssptr,1,2)
      pj(nax+jnum,2)=ps(lssptr,2,2)
      pj(nax+jnum,3)=ps(lssptr,3,2)
      isal(nax+jnum)=isfr+isa
      jsal(nax+jnum)=lssptr
    8 continue
      endif
      nax=nax+lssin(isa,ipss)
    4 continue
c      else
c      do 8 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
c      jsaptr=lssjpt(isa,ipss)-1
c      ism=isl(isfr+isa,lsmol)
c      do 9 jnum=1,lssin(isa,ipss)
c      lssptr=lssj(jsaptr+jnum)
c      jsa=lssptr
c      rwx(jnum,1)=zero
c      rwx(jnum,2)=zero
c      rwx(jnum,3)=zero
c      if(abs(xs(isfr+isa,1)-xs(jsa,1)).gt.boxh(1)) then
c      rwx(jnum,1)=sign(box(1),xs(isfr+isa,1))
c      endif
c      if(abs(xs(isfr+isa,2)-xs(jsa,2)).gt.boxh(2)) then
c      rwx(jnum,2)=sign(box(2),xs(isfr+isa,2))
c      endif
c      if(npbtyp.eq.1) then
c      if(abs(xs(isfr+isa,3)-xs(jsa,3)).gt.boxh(3)) then
c      rwx(jnum,3)=sign(box(3),xs(isfr+isa,3))
c      endif
c      endif
c      jsf=isl(lssptr,lsfrc)
c      isal(nax+jnum)=isfr+isa
c      jsal(nax+jnum)=lssptr
c      jmal(nax+jnum)=jsf
c      jsm=isl(lssptr,lsmol)
c      jfal(nax+jnum)=2
c      if(ism.ne.jsm) jfal(nax+jnum)=3
c      if(ism.gt.0) then
c      if(jsm.gt.0) then
c      rwc(nax+jnum,1)=xsm(ism,1)-xsm(jsm,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xsm(ism,2)-xsm(jsm,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xsm(ism,3)-xsm(jsm,3)-rwx(jnum,3)
c      else
c      rwc(nax+jnum,1)=xsm(ism,1)-xs(lssptr,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xsm(ism,2)-xs(lssptr,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xsm(ism,3)-xs(lssptr,3)-rwx(jnum,3)
c      endif
c      else
c      if(jsm.gt.0) then
c      rwc(nax+jnum,1)=xs(isfr+isa,1)-xsm(jsm,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xs(isfr+isa,2)-xsm(jsm,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xs(isfr+isa,3)-xsm(jsm,3)-rwx(jnum,3)
c      else
c      rwc(nax+jnum,1)=xs(isfr+isa,1)-xs(lssptr,1)-rwx(jnum,1)
c      rwc(nax+jnum,2)=xs(isfr+isa,2)-xs(lssptr,2)-rwx(jnum,2)
c      rwc(nax+jnum,3)=xs(isfr+isa,3)-xs(lssptr,3)-rwx(jnum,3)
c      endif
c      endif
c    9 continue
c      do 11 jnum=1,lssin(isa,ipss)
c      lssptr=lssj(jsaptr+jnum)
c      xi(nax+jnum,1)=xs(isfr+isa,1)
c      xi(nax+jnum,2)=xs(isfr+isa,2)
c      xi(nax+jnum,3)=xs(isfr+isa,3)
c      xj(nax+jnum,1)=xs(lssptr,1)+rwx(jnum,1)
c      xj(nax+jnum,2)=xs(lssptr,2)+rwx(jnum,2)
c      xj(nax+jnum,3)=xs(lssptr,3)+rwx(jnum,3)
c      pl(nax+jnum,1)=ps(isfr+isa,1,2)
c      pl(nax+jnum,2)=ps(isfr+isa,2,2)
c      pl(nax+jnum,3)=ps(isfr+isa,3,2)
c      pj(nax+jnum,1)=ps(lssptr,1,2)
c      pj(nax+jnum,2)=ps(lssptr,2,2)
c      pj(nax+jnum,3)=ps(lssptr,3,2)
c   11 continue
c      nax=nax+lssin(isa,ipss)
c    8 continue
c      endif
c
      do 12 iax=1,nax
      isa=isal(iax)
      jsa=jsal(iax)
      if(jfal(iax).eq.2) then
      qai=qfaci*chg(isq2(isa),1,iset)
      pai=chg(isq2(isa),2,iset)
      qaj=qfaci*chg(isq2(jsa),1,iset)
      paj=chg(isq2(jsa),2,iset)
      else
      qai=qfaci*chg(isq3(isa),1,iset)
      pai=chg(isq3(isa),2,iset)
      qaj=qfaci*chg(isq3(jsa),1,iset)
      paj=chg(isq3(jsa),2,iset)
      endif
      rx=xj(iax,1)-xi(iax,1)
      ry=xj(iax,2)-xi(iax,2)
      rz=xj(iax,3)-xi(iax,3)
      ri2=one/(rx*rx+ry*ry+rz*rz)
      ri1=sqrt(ri2)
      ri3=ri1*ri2
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1)
      pjy=paj*pj(iax,2)
      pjz=paj*pj(iax,3)
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1)=((rmi+qai)*rx-pix)*ri3
      fj(iax,2)=((rmi+qai)*ry-piy)*ri3
      fj(iax,3)=((rmi+qai)*rz-piz)*ri3
   12 continue
c
c     accumulate fields into solute field arrays
c
      iax=0
      do 13 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      do 14 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      ps(isfr+isa,1,1)=ps(isfr+isa,1,1)+fi(iax+jnum,1)
      ps(isfr+isa,2,1)=ps(isfr+isa,2,1)+fi(iax+jnum,2)
      ps(isfr+isa,3,1)=ps(isfr+isa,3,1)+fi(iax+jnum,3)
      ps(lssptr,1,1)=ps(lssptr,1,1)+fj(iax+jnum,1)
      ps(lssptr,2,1)=ps(lssptr,2,1)+fj(iax+jnum,2)
      ps(lssptr,3,1)=ps(lssptr,3,1)+fj(iax+jnum,3)
   14 continue
      iax=iax+lssin(isa,ipss)
   13 continue
c
c     thermodynamic integration and perturbation
c
      do 15 ipset=2,3
      if((ipset.eq.2.and.ipert2).or.
     + (ipset.eq.3.and.ipert3)) then
c
      nax2=0
      do 16 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      do 17 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      pl(nax2+jnum,1)=psp(isfr+isa,1,ipset-1,2)
      pl(nax2+jnum,2)=psp(isfr+isa,2,ipset-1,2)
      pl(nax2+jnum,3)=psp(isfr+isa,3,ipset-1,2)
      pj(nax2+jnum,1)=psp(lssptr,1,ipset-1,2)
      pj(nax2+jnum,2)=psp(lssptr,2,ipset-1,2)
      pj(nax2+jnum,3)=psp(lssptr,3,ipset-1,2)
   17 continue
      nax2=nax2+lssin(isa,ipss)
   16 continue
c
      if(nax2.ne.nax) call md_abort('Error in dips',me)
c
      do 18 iax=1,nax
      isa=isal(iax)
      jsa=jsal(iax)
      if(jfal(iax).eq.2) then
      qai=qfaci*chg(isq2(isa),1,ipset)
      pai=chg(isq2(isa),2,ipset)
      qaj=qfaci*chg(isq2(jsa),1,ipset)
      paj=chg(isq2(jsa),2,ipset)
      else
      qai=qfaci*chg(isq3(isa),1,ipset)
      pai=chg(isq3(isa),2,ipset)
      qaj=qfaci*chg(isq3(jsa),1,ipset)
      paj=chg(isq3(jsa),2,ipset)
      endif
      rx=xj(iax,1)-xi(iax,1)
      ry=xj(iax,2)-xi(iax,2)
      rz=xj(iax,3)-xi(iax,3)
      ri2=one/(rx*rx+ry*ry+rz*rz)
      ri1=sqrt(ri2)
      ri3=ri1*ri2
      pix=pai*pl(iax,1)
      piy=pai*pl(iax,2)
      piz=pai*pl(iax,3)
      pjx=paj*pj(iax,1)
      pjy=paj*pj(iax,2)
      pjz=paj*pj(iax,3)
      rmi=three*(rx*pix+ry*piy+rz*piz)*ri2
      rmj=three*(rx*pjx+ry*pjy+rz*pjz)*ri2
      fi(iax,1)=((rmj-qaj)*rx-pjx)*ri3
      fi(iax,2)=((rmj-qaj)*ry-pjy)*ri3
      fi(iax,3)=((rmj-qaj)*rz-pjz)*ri3
      fj(iax,1)=((rmi+qai)*rx-pix)*ri3
      fj(iax,2)=((rmi+qai)*ry-piy)*ri3
      fj(iax,3)=((rmi+qai)*rz-piz)*ri3
   18 continue
c
c     accumulate fields into solute field arrays
c
      iax=0
      do 19 isa=lssndx(isslen-1,ipss)+1,lssndx(isslen,ipss)
      jsaptr=lssjpt(isa,ipss)-1
      do 20 jnum=1,lssin(isa,ipss)
      lssptr=lssj(jsaptr+jnum)
      psp(isfr+isa,1,ipset-1,1)=psp(isfr+isa,1,ipset-1,1)+fi(iax+jnum,1)
      psp(isfr+isa,2,ipset-1,1)=psp(isfr+isa,2,ipset-1,1)+fi(iax+jnum,2)
      psp(isfr+isa,3,ipset-1,1)=psp(isfr+isa,3,ipset-1,1)+fi(iax+jnum,3)
      psp(lssptr,1,ipset-1,1)=psp(lssptr,1,ipset-1,1)+fj(iax+jnum,1)
      psp(lssptr,2,ipset-1,1)=psp(lssptr,2,ipset-1,1)+fj(iax+jnum,2)
      psp(lssptr,3,ipset-1,1)=psp(lssptr,3,ipset-1,1)+fj(iax+jnum,3)
   20 continue
      iax=iax+lssin(isa,ipss)
   19 continue
c
      endif
   15 continue
    3 continue
    1 continue
c
      return
      end

       subroutine mm_set_irtdb(irtdb0)
         implicit none
#include "md_common.fh"
         integer irtdb0
         
         irtdb=irtdb0

       end

       subroutine mm_set_sd_maxiter(n)
         implicit none
#include "md_common.fh"
         integer n
         
         msdit = n 

       end

       subroutine mm_get_lquant(lquant0)
         implicit none
#include "md_common.fh"
         integer lquant0
         
         lquant0 = lquant

       end

       subroutine mm_get_lqlink(lqlink0)
         implicit none
#include "md_common.fh"
         integer lqlink0
         
         lqlink0 = lqlink

       end

       subroutine mm_get_nsaloc(nsaloc0)
         implicit none
#include "md_common.fh"
         integer nsaloc0
         
         nsaloc0=nsaloc

       end

       subroutine mm_get_nwmloc(nwmloc0)
         implicit none
#include "md_common.fh"
         integer nwmloc0
         
         nwmloc0=nwmloc

       end

       subroutine mm_get_mdacq(mdacq0)
         implicit none
#include "md_common.fh"
         integer mdacq0
         
         mdacq0 = mdacq

       end

       subroutine mm_set_mdacq(mdacq0)
         implicit none
#include "md_common.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
         integer mdacq0
         
         mdacq = mdacq0
         ldacq = mdacq0
     
        if(.not.rtdb_put(irtdb,'md:mdacq',mt_int,1,mdacq0))
     + call md_abort('md_input: rtdb_put failed',0)
        if(.not.rtdb_put(irtdb,'md:ldacq',mt_int,1,mdacq0))
     + call md_abort('md_input: rtdb_put failed',0)
   
       end

       subroutine mm_set_high_precision()
         implicit none
#include "md_common.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
         nprec = 2
         if(.not.rtdb_put(irtdb,'md:nprec',mt_int,1,nprec))
     + call md_abort('md_input: rtdb_put failed',0)

       end

       subroutine mm_get_mequi(mequi0)
         implicit none
#include "md_common.fh"
         integer mequi0
         
         mequi0 = mequi

       end

       subroutine mm_set_mequi(mequi0)
         implicit none
#include "md_common.fh"
         integer mequi0
         
         mequi = mequi0

       end

       subroutine mm_set_nfc(nf,nfs)
         implicit none
#include "rtdb.fh"
#include "md_common.fh"
#include "mafdecls.fh"
         integer nf,nfs

         if(.not.rtdb_put(irtdb,'md:nfcoor',mt_int,1,nf))
     +    call md_abort('md_rtdbin: rtdb_get failed',50)
         if(.not.rtdb_put(irtdb,'md:nfscoo',mt_int,1,nfs))
     +    call md_abort('md_rtdbin: rtdb_get failed',51)
         
         nfcoor = nf
         nfscoo = nfs

       end

       subroutine mm_get_nfc(nf,nfs)
         implicit none
#include "md_common.fh"
         integer nf,nfs
         
         nf  = nfcoor
         nfs =nfscoo

       end

       subroutine mm_get_nfrest(nf)
         implicit none
#include "md_common.fh"
         integer nf
         
         nf  = nfrest

       end

       subroutine mm_set_keep_restart()
         implicit none
#include "md_common.fh"
         
         keepr = 1

       end

       subroutine mm_unset_keep_restart()
         implicit none
#include "md_common.fh"
         
         keepr = 0

       end

       subroutine mm_get_keep_restart_index(i)
         implicit none
#include "md_common.fh"
         integer i
         
         i = keepr-1

       end

       subroutine mm_get_msa(msa0)
         implicit none
#include "md_common.fh"
         integer msa0
         
         msa0=msa

       end

       subroutine mm_get_temp(temp0)
         implicit none
#include "md_common.fh"
         double precision temp0
         
         temp0 = temp 

       end

       subroutine mm_get_stime(stime0)
         implicit none
#include "md_common.fh"
         double precision stime0
         
         stime0 = stime

       end

       subroutine mm_get_mwm(mwm0)
         implicit none
#include "md_common.fh"
         integer mwm0
         
         mwm0=mwm

       end

       subroutine mm_get_mwa(mwa0)
         implicit none
#include "md_common.fh"
         integer mwa0
         
         mwa0=mwa

       end

       subroutine mm_get_psdt(psdt)
         implicit none
#include "md_common.fh"
         integer psdt
         
         psdt = i_is+(lsdyn-1)*msa

       end

       subroutine mm_get_pwdt(pwdt)
         implicit none
#include "md_common.fh"
         integer pwdt
         
         pwdt = i_iw+(lwdyn-1)*mwm

       end

       subroutine mm_get_pwl(pwl)
         implicit none
#include "md_common.fh"
         integer pwl
         
         pwl = i_iw+(lwgmn-1)*mwm

       end

       subroutine mm_get_psl(psl)
         implicit none
#include "md_common.fh"
         integer psl
         
         psl = i_is+(lsgan-1)*msa

       end

       subroutine mm_get_psg(psg)
         implicit none
#include "md_common.fh"
         integer psg
         
         psg = i_is+(lsgrp-1)*msa

       end

       subroutine mm_get_psgm(psgm)
         implicit none
#include "md_common.fh"
         integer psgm
         
         psgm = i_is+(lssgm-1)*msa

       end

       subroutine mm_get_psat(psat)
         implicit none
#include "md_common.fh"
         integer psat
         
         psat = i_is+(lsatt-1)*msa

       end

       subroutine mm_get_psq(psq)
         implicit none
#include "md_common.fh"
         integer psq
         
         psq = i_is+(lsct1-1)*msa

       end

       subroutine mm_get_psz(psz)
         implicit none
#include "md_common.fh"
         integer psz
         
         psz = i_isz

       end

       subroutine mm_get_pwz(pwz)
         implicit none
#include "md_common.fh"
         integer pwz
         
         pwz = i_iwz

       end

       subroutine mm_get_pxs(pxs)
         implicit none
#include "md_common.fh"
         integer pxs
         
         pxs = i_xs

       end

       subroutine mm_get_pxw(pxw)
         implicit none
#include "md_common.fh"
         integer pxw
         
         pxw = i_xw

       end

       subroutine mm_get_pfs(pfs)
         implicit none
#include "md_common.fh"
         integer pfs
         
         pfs = i_fs

       end

       subroutine mm_get_pfw(pfw)
         implicit none
#include "md_common.fh"
         integer pfw
         
         pfw = i_fw

       end

      subroutine mm_clear_bqzone(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
c        local variables
         integer psz

         call mm_get_psz(psz)

         int_mb(psz+i-1)=0
         
       end

      subroutine mm_clear_bqwzone(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
c        local variables
         integer pwz

         call mm_get_pwz(pwz)

         int_mb(pwz+i-1)=0
         
       end

       function mm_quant(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_quant
c        local variables
         integer psdt

         call mm_get_psdt(psdt)
         mm_quant = iand(int_mb(psdt+i-1),lquant).ne.0
         
       end

       function mm_classical(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_classical
c        local variables
         integer psdt

         call mm_get_psdt(psdt)
         mm_classical = iand(int_mb(psdt+i-1),lquant).eq.0
         
       end

       function mm_ww(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         double precision  mm_ww
c        local variables

         mm_ww = dbl_mb(i_wws+i-1)
         
       end

       function mm_record()
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_record
c        local variables

         mm_record = lxw.or.lxs
         
       end

       function mm_quant_link(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_quant_link
c        local variables
         integer psdt

         call mm_get_psdt(psdt)
         mm_quant_link = iand(int_mb(psdt+i-1),lquant).ne.0
         mm_quant_link = mm_quant_link .or. 
     >                   iand(int_mb(psdt+i-1),lqlink).ne.0
          
       end

       function mm_link(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_link
c        local variables
         integer psdt

         call mm_get_psdt(psdt)
         mm_link = iand(int_mb(psdt+i-1),lqlink).ne.0
         
       end

       function mm_lqsoft(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_lqsoft
c        local variables
         integer psdt,lqsoft

         lqsoft = 64
         call mm_get_psdt(psdt)
         mm_lqsoft = iand(int_mb(psdt+i-1),lqsoft).ne.0
         
       end       

      function mm_bqwzone(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_bqwzone
c        local variables
         integer pwz

         call mm_get_pwz(pwz)

         mm_bqwzone = int_mb(pwz+i-1).gt.0
         
       end

      function mm_bqzone(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_bqzone
c        local variables
         integer psdt,psz

         call mm_get_psdt(psdt)
         call mm_get_psz(psz)

         mm_bqzone = iand(int_mb(psdt+i-1),lquant).eq.0
c         mm_bqzone = mm_bqzone .and. iand(int_mb(psdt+i-1),lqlink).eq.0
         mm_bqzone = mm_bqzone .and. int_mb(psz+i-1).gt.0
         
       end

      function mm_active_bqs(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_active_bqs
c        local variables
         integer psdt,psz

         call mm_get_psdt(psdt)
         call mm_get_psz(psz)

         mm_active_bqs = (iand(int_mb(psdt+i-1),mfixed).ne.lfixed).and.
     >               (iand(int_mb(psdt+i-1),lquant).eq.0).and.
     >               (int_mb(psz+i-1).gt.0)
         
       end

      function mm_active_bqw(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_active_bqw
c        local variables
         integer pwdt,pwz

         call mm_get_pwdt(pwdt)
         call mm_get_pwz(pwz)

         mm_active_bqw = (iand(int_mb(pwdt+i-1),mfixed).ne.lfixed).and.
     >               (int_mb(pwz+i-1).gt.0)
         
       end

      function mm_fixed_w(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_fixed_w
c        local variables
         integer pwdt

         call mm_get_pwdt(pwdt)

         mm_fixed_w = iand(int_mb(pwdt+i-1),mfixed).eq.lfixed
         
       end

      function mm_fixed(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_fixed
c        local variables
         integer psdt

         call mm_get_psdt(psdt)

         mm_fixed = iand(int_mb(psdt+i-1),mfixed).eq.lfixed
         
       end

      function mm_active(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_active
c        local variables
         integer psdt

         call mm_get_psdt(psdt)

         mm_active = iand(int_mb(psdt+i-1),mfixed).ne.lfixed
         
       end

      function mm_active_qm(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_active_qm
c        local variables
         integer psdt

         call mm_get_psdt(psdt)

         mm_active_qm = (iand(int_mb(psdt+i-1),mfixed).ne.lfixed)
     >                   .and.
     >                  (iand(int_mb(psdt+i-1),lquant).ne.0) 
         
       end

      function mm_active_classical(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_active_classical
c        local variables
         integer psdt

         call mm_get_psdt(psdt)

         mm_active_classical = 
     >                (iand(int_mb(psdt+i-1),mfixed).ne.lfixed)
     >                .and.
     >               (iand(int_mb(psdt+i-1),lqlink).eq.0) 
     >                .and.
     >               (iand(int_mb(psdt+i-1),lquant).eq.0) 
         
       end

      function mm_active_link(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_active_link
c        local variables
         integer psdt

         call mm_get_psdt(psdt)

         mm_active_link = (iand(int_mb(psdt+i-1),mfixed).ne.lfixed)
     >                .and.
     >               (iand(int_mb(psdt+i-1),lqlink).ne.0) 
         
       end

      function mm_active_w(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_active_w
c        local variables
         integer pwdt

         call mm_get_pwdt(pwdt)

         mm_active_w = iand(int_mb(pwdt+i-1),mfixed).ne.lfixed
         
       end

      function mm_identity(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_identity

         mm_identity = .true.
         
       end

      function mm_link_bqzone(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_link_bqzone
c        local variables
         integer psdt,psz

         call mm_get_psdt(psdt)
         call mm_get_psz(psz)

         mm_link_bqzone = iand(int_mb(psdt+i-1),lquant).eq.0
         mm_link_bqzone = mm_link_bqzone .and. int_mb(psz+i-1).gt.0
         
       end

      function mm_qmbqzone(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         logical mm_qmbqzone
c        local variables
         integer psdt,psz

         call mm_get_psdt(psdt)
         call mm_get_psz(psz)

         mm_qmbqzone = iand(int_mb(psdt+i-1),lquant).eq.0 .or.
     >                 int_mb(psz+i-1).gt.0
         
       end

      function mm_element(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         integer mm_element
c        local variables
         integer psat
         integer cf_element
         external cf_element

         call mm_get_psat(psat)

         mm_element = cf_element(int_mb(psat+i-1))
         
       end

      function mm_solute_charge(i)
         implicit none
#include "mafdecls.fh"
#include "md_common.fh"
         integer i
         double precision  mm_solute_charge
c        local variables
         double precision cf_charge
         external cf_charge

         mm_solute_charge= cf_charge(int_mb(i_is+(lsct1-1)*msa+i-1))
         
       end

       subroutine mm_print_psl_psz()
         implicit none
#include "md_common.fh"
#include "mafdecls.fh"
         integer ns,psz,psl
         integer i
         
         call  mm_get_psz(psz)
         call  mm_get_psl(psl)
         call mm_get_nsaloc(ns)
         
         do i=1,ns
c           write(*,*) int_mb(psl+i-1),
c     >                int_mb(psz+i-1)
         end do

       end


c $Id: mm_utils.F 21176 2011-10-10 06:35:49Z d3y133 $

C $Id: path2.F 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine drdy_path2(iopt,delss,delsh,sold,smax,xsign)
C
C  Calculate steepest descent path from saddle point
C     iopt  -  option for following MEP
C              =1, use Euler integrator
C              =2, use Page-McIver LQA algorithm
C              =3, use Page-McIver CLQA algorithm
C              =4, use Page-McIver CUBE algorithm
C
      Implicit none
#include "errquit.fh"
      Integer iopt
      Double Precision delss,delsh,sold,smax,xsign
      Integer i,ierr,j,nbar,nosc
      Double Precision delsf,dotp,dxmag,shess,swf
C
      Double Precision eps
c
#include "drdyP.fh"
C
      data eps/1.d-6/
C
      delsf = xsign*(s-sold)
      shess = s
      nosc = 0
      nbar = (n3*(n3+1))/2
      do while (s*xsign.lt.smax*xsign-dels*eps)
         if (iopt.le.1) then
            call drdy_euler (n3tm,n3,x,dx,dels)
         elseif (iopt.eq.2) then
            ierr = 0
            call drdy_pmlqa (n3tm,n3,nbar,x,dx,f,hess,amass,dels,
     *       vec0,vec1,u0,scr1,vec2,ierr)
            if (ierr.ne.0) then
               write(fu6,*) ' error in pmlqa'
               call errquit('error in pmlqa',555, UNKNOWN_ERR)
            endif
         elseif (iopt.eq.3) then
            ierr = 0
            call drdy_pmclqa (n3tm,n3,nbar,x,dx,f,fold,hess,amass,
     &            dels,delsf,vec0,vec1,u0,scr1,vec2,ierr)
            if (ierr.ne.0) then
               write(fu6,*) ' error in pmclqa'
               call errquit('error in pmlqa',555, UNKNOWN_ERR)
            endif
         elseif (iopt.ge.4) then
            call drdy_pmcube (n3tm,n3,x,dx,f,fold,amass,dels,delsf,
     *       vec0,vec1,vec2)
         endif
         call drdy_center (natom,n3,amass,x,scr1)
         s = s + dels*xsign
         delss = delss + dels
         delsh = delsh + dels
         if (delss.lt.delsv*(1.0d00-eps) .and.
     *    delsh.lt.delhss*(1.0d00-eps)) then
            Call drdy_pot1 (x,v,dx,scr1,amass,natom,n3)
         else
            if (iopt.ge.3) then
C Store previous hessian matrix in fold
               do i = 1,n3
                  do j = 1,n3
                     fold(j,i) = f(j,i)
                  enddo
               enddo
               sold = shess
               delsf = xsign*(s-sold)
               shess = s
            endif
            Call drdy_pot2 (x,v,dx,f,hess,scr1,amass,natom,n3,n3tm,
     *                 nbar)
            delsh = 0.0d00
         endif
         write(fu6,610) s,v-vzero,(x(i),i=1,n3)
         dxmag = 0.0d00
         do i = 1,n3
            dxmag = dxmag + dx(i)*dx(i)
         enddo
         dxmag = sqrt(dxmag)
         write(fu6,611) dxmag,(dx(i)/dxmag,i=1,n3)
C Check for oscillating gradient
         dotp = 0.0d00
         do i = 1,n3
            dotp = dotp + dxold(i)*dx(i)/dxmag
            dxold(i) = dx(i)/dxmag
         enddo
         if (dotp.lt. 0.0d00) then
            nosc = nosc + 1
            if (nosc .ge. 5) then
               write (fu6,6000)
               call errquit('The gradient is unstable',555, INPUT_ERR)
            endif 
         else
            nosc = 0
         endif
         if (delss.ge.delsv*(1.0d00-eps)) then
            swf = s
            if(lgs(38).gt.0) call drdy_wfiles(swf,0)
            if (lgs(39).ne.0) then
               call drdy_potsp(x,vspc,scr1,amass,natom,n3)
               write (fu6,612) vspc-vzerosp
               if(lgs(38).eq.4) call drdy_wfiles(swf,1)
            endif
            call drdy_rphwrt(7)
            if(lgs(2).ne.0) then
               ierr = 0
               call drdy_projct(ierr)
               if (ierr.eq.0) call drdy_fdiag(n3,nf(5),ierr,lgs(2))
            endif
            delss = 0.0d00
         endif
      enddo
      return
610   Format (t4,0pf12.5,1pe13.5,T33,'x=',(T35,0p9f9.4))
611   Format (15x,1pe13.5,T32,'dx=',(T35,0p9f9.4))
612   Format(11x,'Vsp=',1pe13.5)
6000  Format (//,' ********** The direction of the gradient vector',
     * ' has changed by more than 90 degrees for the last 5 steps.',/,
     * 12x,'Either the step size should be decreased, or another',
     * ' integrator should be tried.')
      end

      subroutine argos_cafe_external_field(nums,fs,isq,numw,fw,iwq,chg)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer nums,numw
      integer isq(msa),iwq(mwa)
      real*8 fs(msa,3),fw(mwm,3,mwa),chg(mqt,mqp,mset)
c
      integer i,j,k
      real*8 efield,q,df
c
      efield=field*cos(2.0d-6*pi*ffreq*stime)
c
      if(numw.gt.0) then
      do 1 k=1,nwa
      q=chg(iwq(k),1,iset)*efield
      do 2 j=1,3
      df=q*fvect(j)
      do 3 i=1,numw
      fw(i,j,k)=fw(i,j,k)+df
    3 continue
    2 continue
    1 continue
      endif
c
      if(nums.gt.0) then
      do 4 j=1,3
      do 5 i=1,nums
      fs(i,j)=fs(i,j)+chg(isq(i),1,iset)*efield*fvect(j)
    5 continue
    4 continue
      endif
c
      return
      end
c $Id: argos_cafe_external_field.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup nwint
C> @{ 
C>
C> \brief Compute 3-center 2-electron integral 2nd derivatives
C>       
C> Compute the 3-center 2-electron integral 2nd derivatives as given by
C> \f{eqnarray*}{
C> \frac{\partial^2({\mu}|{\nu}{\lambda})}{\partial X_x\partial X_y} = \int_{-\infty}^{\infty} \frac{\partial^2 g_{\mu}(X_{\mu},r_{1})\frac{1}{r_{12}}
C> g_{\nu}(X_{\nu},r_{2})g_{\lambda}(X_{\lambda},r_{2})}{\partial X_x\partial X_y}dr_{1}dr_{2}
C> \f}
C> The integral derivatives are stored in an order that is consistent with
C> the declaration `ERI(natcrd*(natcrd+1)/2,nint)`, where `nint` is the number
C> of integrals in the shell triplet, `natcrd` is the number of Cartesian
C> coordinates in the shell triplet, i.e. 9 ( = 3 atoms * 3 coordinates).
C> The actual lexical indeces of the atoms on which the shells `ish`,
C> `jsh` and `ksh` are centered are returned in `idatom`.
C> 
      subroutine intdd_2e3c(brain, ish, ketin, jsh, ksh,
     &       lscr, scr, leri, eri, idatom)
c $Id: intdd_2e3c.F 23303 2012-12-18 19:51:31Z d3y133 $
      implicit none
c
* basic api routine to generate 4 center two electron 
* integral second derivatives 
c
* The buffer comes out as:
*      (upper triangle block derivative, basis indecies)
c------------------------------------------------------------
c construct all 10 blocks of sec.der. (output) from 6 blocks:
c
c          AA AB AC AD                AA AB AC 
c             BB BC BD      from         BB BC
c                CC CD                      CC
c                   DD  
c      1-6, 7-15,16-24,25-33         1-6, 7-15,16-24
c          34-39,40-48,49-57             25-30,31-39
c                58-63,64-72                   40-45
c                      73-78
c------------------------------------------------------------
* block AA: (1-6)  | block BB: (34-39)| block CC: (58-63)   |
c       axax=1     |       bxbx=34    |       cxcx=58       |
c       axay=2     |       bxby=35    |       cxcy=59       |
c       axaz=3     |       bxbz=36    |       cxcz=60       |
c       ayay=4     |       byby=37    |       cycy=61       |
c       ayaz=5     |       bybz=38    |       cycz=62       |
c       azaz=6     |       bzbz=39    |       czcz=63       |
* block AB: (7-15) | block BC: (40-48)| block CD: (64-72)   |
c       axbx=7     |       bxcx=40    |       cxdx=64       |
c       axby=8     |       bxcy=41    |       cxdy=65       |
c       axbz=9     |       bxcz=42    |       cxdz=66       |
c       aybx=10    |       bycx=43    |       cydx=67       |
c       ayby=11    |       bycy=44    |       cydy=68       |
c       aybz=12    |       bycz=45    |       cydz=69       |
c       azbx=13    |       bzcx=46    |       czdx=70       |
c       azby=14    |       bzcy=47    |       czdy=71       |
c       azbz=15    |       bzcz=48    |       czdz=72       |
* block AC: (16-24)| block BD: (49-57)| block DD: (73-78)   |
c       axcx=16    |       bxdx=49    |       dxdx=73       |
c       axcy=17    |       bxdy=50    |       dxdy=74       |
c       axcz=18    |       bxdz=51    |       dxdz=75       |
c       aycx=19    |       bydx=52    |       dydy=76       |
c       aycy=20    |       bydy=53    |       dydz=77       |
c       aycz=21    |       bydz=54    |       dzdz=78       |
c       azcx=22    |       bzdx=55    |                     |
c       azcy=23    |       bzdy=56    |                     |
c       azcz=24    |       bzdz=57    |                     |
* block AD: (25-33)|                  |                     |
c       axdx=25    |                  |                     |
c       axdy=26    |                  |                     |
c       axdz=27    |                  |                     |
c       aydx=28    |                  |                     |
c       aydy=29    |                  |                     |
c       aydz=30    |                  |                     |
c       azdx=31    |                  |                     |
c       azdy=32    |                  |                     |
c       azdz=33    |                  |                     |
c------------------------------------------------------------
#include "stdio.fh"
#include "errquit.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
c
c::external subroutines used
c errquit
c::functions
      integer int_nint_cart
      external int_nint_cart
ckw
      integer int_nint
      external int_nint
c
      logical cando_nw
      logical cando_txs
      external cando_nw
      external cando_txs
ckw
c::passed
      integer brain !< [Input] basis set handle for bra basis
      integer ish   !< [Input] lexical contraction index 
      integer jsh   !< [Input] lexical contraction index 
      integer ketin !< [Input] basis set handle for ket basis
      integer ksh   !< [Input] lexical contraction index 
      integer lscr  !< [Input] length of scratch array
      integer leri  !< [Input] length of eri array
      double precision scr(lscr) !< [Scratch] scratch array for integral code.
      double precision eri(leri) !< [Output]  array for two electron integral derivatives.
c NOTE: length of idatom is always 4 because there can be at most 4 centers involved
      integer idatom(4)          !< [Output]  array identifying centers for derivatives
c
c::local
      integer nint, ucont
      integer bra, ket, ab_geom, cd_geom
      integer iatom
      integer jatom
      integer katom
c
      double precision roff(3)
      integer txs_i, txs_j, txs_k, txs_l
      logical status_nw, status_txs
      logical dum_log
      integer nintzero, num_quart, dummy_lab
      double precision q4
ckw
c
      logical used_nw
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      used_nw = .false.
      nint = int_nint_cart(brain,ish,0, 0,ketin,jsh,ketin,ksh)
*
      if (nint*78.gt.leri) then
        write(luout,*) 'nint*78 = ',nint*78
        write(luout,*) 'leri     = ',leri
        call errquit('intdd_2e3c: nint>leri error',911, INT_ERR)
      endif
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
c
      ab_geom = ibs_geom(bra)
      cd_geom = ibs_geom(ket)
      if (ab_geom.ne.cd_geom) then
        write(luout,*)
     &      'intdd_2e3c.F: two different geometries for',
     &         ' derivatives?'
        call errquit('intdd_2e3c: geom error ',911, GEOM_ERR)
      endif
c
      ucont = (sf_ibs_cn2ucn(ish,bra))
      iatom = (sf_ibs_cn2ce(ish,bra))
      idatom(1)=iatom
      idatom(2)=0
c
      ucont = (sf_ibs_cn2ucn(jsh,ket))
      jatom = (sf_ibs_cn2ce(jsh,ket))
      idatom(3)=jatom
c
      ucont = (sf_ibs_cn2ucn(ksh,ket))
      katom = (sf_ibs_cn2ce(ksh,ket))
      idatom(4)=katom
c
      if (iatom.eq.jatom.and.jatom.eq.katom) then
        call dcopy((nint*78),0.0d00,0,eri,1)
        call ifill(4,-1,idatom,1)
        return
      endif
c
      status_nw  = .false.
      status_txs =.true.
      status_txs = status_txs .and.
     &    cando_txs(brain,ish,0).and.cando_txs(ketin,jsh,ksh)
c
      if (status_txs) then
        call dcopy(3,0.0d00,0,roff,1)
        q4 = 1.0d00
        txs_i = ish
        txs_j = 0
        txs_k = jsh
        txs_l = ksh
        num_quart=1
        dum_log=.false.
c
        call texas_hf2_m(
     &      brain,txs_i,txs_j,
     &      ketin,txs_k,txs_l,num_quart,
     &      q4,.false.,
c...............................use roff set false
     &      roff,roff,roff,roff,.false.,
     &      eri, leri, dummy_lab, dummy_lab, dummy_lab, dummy_lab,
c...............gen labs .. more_integrals
     &      nint, .false., dum_log, scr, lscr, 0.0d0,'der2_int')
        write(6,*)' intdd:2e3c:txshfm:nint = ',nint
        if (nint .eq. 0) then
          nintzero = int_nint(brain,ish,0,0,ketin,jsh,ketin,ksh)
          nintzero = nintzero*78
          call dcopy(nintzero, 0.0d0, 0, eri, 1)
          call ifill(4,-9,idatom,1)
        endif
c
      else
        write(luout,*)'intdd_2e3c: could not use the texas '
        write(luout,*)'           integral second derivatives'
        write(luout,*)' Please notify nwchem-support@emsl.pnl.gov with'
        write(luout,*)'        the input deck and output available'
        call errquit('intdd_2e3c: fatal error',911, INT_ERR)
      endif
c
      end
C> @}

      subroutine qhop_asite(msa,xs,idon,idong,resd,istatd,iacc,
     + iaccg,resa,istata,xacc,doff,aoff,flada)
c
c $Id: qhop_asite.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "qhop_common.fh"
#include "mafdecls.fh"
c
c     declaration of arguments
c
      integer msa,idon,idong,resd,iacc,iaccg,resa,istatd,istata,doff,
     + aoff,flada
      real*8 xacc(11),xs(msa,3)
c
      call qhop_asite2(msa,xs,idon,idong,resd,istatd,iacc,
     + iaccg,resa,istata,xacc,doff,aoff,flada,
     + int_mb(i_ptseq),int_mb(i_ptarat),int_mb(i_iarat),
     + dbl_mb(i_racs),dbl_mb(i_racs+mxar),int_mb(i_ptpar),
     + dbl_mb(i_par),dbl_mb(i_par+7*maxpar),dbl_mb(i_par+14*maxpar),
     + dbl_mb(i_par+17*maxpar),dbl_mb(i_par+23*maxpar),
     + dbl_mb(i_par+28*maxpar))
c
      return
      end
      subroutine qhop_asite2(msa,xs,idon,idong,resd,istatd,iacc,
     + iaccg,resa,istata,xacc,doff,aoff,flada,
     + ptseq,ptarat,arat,deq,aneq,ptpar,tunnel,defe12,zpef,
     + tdsgl,tstval,e12fxy)
c
c $Id: qhop_asite.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "qhop_common.fh"
c
c     declaration of arguments
c
      integer msa,idon,idong,resd,iacc,iaccg,resa,istatd,istata,doff,
     + aoff,flada
      real*8 xacc(11),xs(msa,3)
c
      real*8 tunnel(maxpar,7),defe12(maxpar,7),zpef(maxpar,3),
     + tdsgl(maxpar,6),tstval(maxpar,5),e12fxy(maxpar,3)
      real*8 deq(mxar),aneq(mxar)
      integer ptseq(maxseq,2),ptpar(maxpar),arat(mxar,4),ptarat(mxseq)
c
c     declaration of variables
c
      integer typ,i,idr(2),idhv(2),inh,inhv,numh,nhv(2)
      real*8 dist,ang,d2
      real*8 cost,sint,cosp,sinp,th,ph,alpha
      real*8 trsl,rds,fct
      real*8 xh2(3),xacc2(2),xdr(3),xr12(3),xar(3),xdrp(2),norm,r1(3),
     + sid1(3),sid2(3),nsid(2),xrh(3),nrh,r1pbc(3)
      real*8 tol,pi
c
      parameter(tol=1E-15)
      parameter(pi=3.14159265)      
c
      typ=arat(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2),2)  
      nhv(1)=arat(ptarat(ptseq(resd,1))+idong-
     + ptseq(resd,2),3)
      nhv(2)=arat(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2),3)
c
c     Calculating indexes and eq. dist and agle
c
      ang=aneq(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2))
      dist=deq(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2))
c      write (*,98),'angdi ',ang,dist
c 98   format(a6,2f10.6)
c
      ang=1.910610
      idhv(1)=arat(ptarat(ptseq(resd,1))+idong-
     + ptseq(resd,2),1)+idon
      idhv(2)=arat(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2),1)+iacc
c
      idr(1)=idhv(2)+
     + arat(ptarat(ptseq(resa,1))+idong-
     + ptseq(resd,2)+arat(ptarat(ptseq(resd,1))
     + +idong-ptseq(resd,2),1),1)
      idr(2)=idhv(2)+
     + arat(ptarat(ptseq(resa,1))+idong-
     + ptseq(resd,2)+arat(ptarat(ptseq(resd,1))
     + +idong-ptseq(resd,2),1),2)
c
c     H in a "cone" position: typ=1 or OH-
c
      if(typ.eq.1.or.(typ.eq.3.and.istata.eq.3))then
c
      if(typ.eq.3)idr(1)=idhv(2)+1
      xdr(1)=xs(idhv(2),1)-xs(idr(1),1)
      xdr(2)=xs(idhv(2),2)-xs(idr(1),2)
      xdr(3)=xs(idhv(2),3)-xs(idr(1),3)
      call cf_pbc(1,xdr,1,xdr,1,0,1,1)
c     
      norm=sqrt(xdr(1)**2+xdr(2)**2+xdr(3)**2)
      trsl=-dist*cos(ang)+norm
      rds=dist*sin(pi-ang)
c  
      if(xdr(1).lt.tol.and.xdr(2).lt.tol)then
c
c     H projection on the circle plane coincides with the center of 
c     the circle, all points are equally distant
c     
      xacc(1)=rds+xs(idhv(2),1)
      xacc(2)=xs(idhv(2),2)
      xacc(3)=xs(idhv(2),3)+sign(trsl,xs(idhv(2),3)-xs(idr(1),3))
      return
      else
      ph=atan(-(xdr(2)/(xdr(1))))
      endif
c
      sinp=sin(ph)
      cosp=cos(ph)
c
      xdrp(1)=xdr(1)*cos(ph)-xdr(2)*sin(ph)
      if((xdr(3)).lt.tol)then
      th=pi/2.
      else
      th=atan(xdrp(1)/xdr(3))
      endif
      xdrp(2)=sin(th)*xdrp(1)+cos(th)*xdr(3)
      if(xdrp(2).lt.0)th=th+pi
c      
      sint=sin(th)
      cost=cos(th)
c     
c     trasforming the coordinates of the hydrogen in the new system
c     
      xar(1)=xs(iacc,1)-xs(idr(1),1)
      xar(2)=xs(iacc,2)-xs(idr(1),2)
      xar(3)=xs(iacc,3)-xs(idr(1),3)
      call cf_pbc(1,xar,1,xar,1,0,1,1)
c
      xh2(1)=cosp*cost*xar(1)-cost*sinp*xar(2)-sint*xar(3)
      xh2(2)=sinp*xar(1)+cosp*xar(2)
      xh2(3)=sint*cosp*xar(1)-sint*sinp*xar(2)+cost*xar(3)
         
c
c     calculating the new hydrogen coordinates in transformed system
c      
      fct=sqrt(xh2(1)**2+xh2(2)**2)
      if(fct.gt.tol)then
      xacc2(1)=xh2(1)*(rds/fct)
      xacc2(2)=xh2(2)*(rds/fct)
      else
      xacc2(1)=rds
      xacc2(2)=0
      endif
c     
c     Retrasforming the coordinates into the original system 
c     
      xacc(1)=cost*cosp*xacc2(1)+sinp*xacc2(2)+sint*cosp
     +     *trsl+xs(idr(1),1)
      xacc(2)=-cost*sinp*xacc2(1)+cosp*xacc2(2)-sint*sinp
     +     *trsl+xs(idr(1),2)
      xacc(3)=-sint*xacc2(1)+cost*trsl+xs(idr(1),3)
c          
c     H in the "bisetrix" position 
c     
      else if(typ.eq.2.or.(typ.eq.3.and.istata.eq.2))then
c
      if(typ.eq.3)then
c
c     water: O is attacched to the two H
c
      idr(1)=idhv(2)+1
      idr(2)=idhv(2)+2
      endif
c
      xr12(1)=(xs(idr(1),1)+xs(idr(2),1))/2
      xr12(2)=(xs(idr(1),2)+xs(idr(2),2))/2
      xr12(3)=(xs(idr(1),3)+xs(idr(2),3))/2
c
      xrh(1)=xs(idhv(2),1)-xr12(1)
      xrh(2)=xs(idhv(2),2)-xr12(2)
      xrh(3)=xs(idhv(2),3)-xr12(3)
      call cf_pbc(1,xrh,1,xrh,1,0,1,1)
c
      nrh=sqrt(xrh(1)**2+xrh(2)**2+xrh(3)**2)
      xacc(1)=xs(idhv(2),1)+dist*(xrh(1)/nrh)
      xacc(2)=xs(idhv(2),2)+dist*(xrh(2)/nrh)
      xacc(3)=xs(idhv(2),3)+dist*(xrh(3)/nrh)
c
c     H2O: idr(1) and idr(2) are the indexes of the two non dummy H
c
      else if(typ.eq.4)then      
c
c     if acceptor is water then fix exactly the 2 angles
c
      xdr(1)=xs(idhv(2)+1,1)-xs(idhv(2),1)
      xdr(2)=xs(idhv(2)+1,2)-xs(idhv(2),2)
      xdr(3)=xs(idhv(2)+1,3)-xs(idhv(2),3)     
      call cf_pbc(1,xdr,1,xdr,1,0,1,1)
c      write (*,91),'xdr1 ',xdr
      
      if(abs(xdr(1)).gt.tol)then                                  
         if(abs(xdr(2)).gt.tol)then
            th=atan(-xdr(1)/xdr(2))
c            write (*,92),'theta ',th,xdr(1),xdr(2)
 92         format(a6,3f10.6)
         else
            th=-sign(1.d0,xdr(1))*(pi/2)
c            write *,'thetanotol ',xdr(1)-tol,xdr(2)-tol
         endif
      else
         th=0                                              
      endif 
      xdrp(1)=-xdr(1)*sin(th)+xdr(2)*cos(th)                     
                                                              
      if(abs(xdrp(1)).gt.tol)then                               
         if(abs(xdr(3)).gt.tol)then                              
            ph=atan(-xdrp(1)/xdr(3)) 
c            write (*,92),'phi ',ph,xdrp(1),xdr(3)
         else                                                 
            ph=-sign(1.d0,xdrp(1))                      
c            write *,'phinotol ',xdrp(1)-tol,xdr(3)-tol
         endif                                                
      else                                                    
         ph=0                                                
      endif                                                   
      xdrp(2)=-xdrp(1)*sin(ph)+xdr(3)*cos(ph)
      if(xdrp(2).le.0)ph=ph+pi

      xdr(1)=xs(idhv(2)+2,1)-xs(idhv(2),1)
      xdr(2)=xs(idhv(2)+2,2)-xs(idhv(2),2)
      xdr(3)=xs(idhv(2)+2,3)-xs(idhv(2),3)
      call cf_pbc(1,xdr,1,xdr,1,0,1,1)

      call rot(th,xdr(1),xdr(2),xdr(3),3)
      call rot(ph,xdr(1),xdr(2),xdr(3),1)
c      write (*,91),'xdr2 ',xdr
      if(abs(xdr(2)).gt.tol)then
         if(abs(xdr(1)).gt.tol)then
            alpha=atan(xdr(2)/xdr(1))
c            write (*,92),'alpha ',alpha,xdr(2),xdr(1)
         else
            alpha=sign(1.d0,xdr(2))
         endif
      else
         alpha=0
      endif
      xdrp(1)=xdr(1)*cos(alpha)+xdr(2)*sin(alpha)
      if(xdrp(1).le.0)then
         if(alpha.le.0)then
            alpha=alpha+pi
         else
            alpha=alpha-pi
         endif
      endif
c
c     Found the angles, perform rotation
c
      xdr(1)=xs(idhv(1),1)-xs(idhv(2),1)
      xdr(2)=xs(idhv(1),2)-xs(idhv(2),2)
      xdr(3)=xs(idhv(1),3)-xs(idhv(2),3)
      call cf_pbc(1,xdr,1,xdr,1,0,1,1)

      call rot(th,xdr(1),xdr(2),xdr(3),3)
      call rot(ph,xdr(1),xdr(2),xdr(3),1)
      call rot(alpha,xdr(1),xdr(2),xdr(3),3)
      xr12(1)=xdr(1)
      xr12(2)=xdr(2)
      xr12(3)=xdr(3)
      xdr(1)=xs(idhv(2)+2,1)-xs(idhv(2),1)
      xdr(2)=xs(idhv(2)+2,2)-xs(idhv(2),2)
      xdr(3)=xs(idhv(2)+2,3)-xs(idhv(2),3)
      call cf_pbc(1,xdr,1,xdr,1,0,1,1)

      call rot(th,xdr(1),xdr(2),xdr(3),3)
      call rot(ph,xdr(1),xdr(2),xdr(3),1)
      call rot(alpha,xdr(1),xdr(2),xdr(3),3)
c      write (*,91),'xdr3 ',xdr
      d2=dist**2
      xacc(3)=dist*cos(ang)
      xacc(1)=(1/xdr(1))*xacc(3)*(0.1-xdr(3))
      xacc(2)=sqrt(d2-xacc(3)**2-xacc(1)**2)
c      write (*,93),'xacc1 ',xacc(1),xacc(2),xacc(3),d2,cos(ang)
c      write(*,94),'norm ',xacc(1)**2+xacc(2)**2+xacc(3)**2
      d2=abs(xr12(2)-xacc(2))-abs(xr12(2)+xacc(2))
      if(d2.ge.0)xacc(2)=-xacc(2)
      xdr(1)=xacc(1)
      xdr(2)=xacc(2)
      xdr(3)=xacc(3)
      call rot(-alpha,xdr(1),xdr(2),xdr(3),3)
      call rot(-ph,xdr(1),xdr(2),xdr(3),1)
      call rot(-th,xdr(1),xdr(2),xdr(3),3)
c      write (*,94),'norm ',xacc(1)**2+xacc(2)**2+xacc(3)**2
      xacc(1)=xdr(1)+xs(idhv(2),1)
      xacc(2)=xdr(2)+xs(idhv(2),2)
      xacc(3)=xdr(3)+xs(idhv(2),3)
c      write (*,93),'xacc2 ',xacc(1),xacc(2),xacc(3),d2,cos(ang)
 91   format(a5,3f10.6)
 93   format(a6,5f10.6)
 94   format(a5,f10.6)

      else if(typ.eq.5)then
         
         xar(1)=xs(idon,1)-xs(idhv(2),1)
         xar(2)=xs(idon,2)-xs(idhv(2),2)
         xar(3)=xs(idon,3)-xs(idhv(2),3)
         call cf_pbc(1,xar,1,xar,1,0,1,1)
         norm=sqrt(xar(1)**2+xar(2)**2+xar(3)**2)
         xacc(1)=xs(idhv(2),1)+dist*(xar(1)/norm)
         xacc(2)=xs(idhv(2),2)+dist*(xar(2)/norm)
         xacc(3)=xs(idhv(2),3)+dist*(xar(3)/norm)
      endif
c
c     Calculating angle and donor-acceptor dist
c
      r1(1)=xs(idhv(1),1)-xs(idhv(2),1)
      r1(2)=xs(idhv(1),2)-xs(idhv(2),2)
      r1(3)=xs(idhv(1),3)-xs(idhv(2),3)
      r1pbc(1)=r1(1)
      r1pbc(2)=r1(2)
      r1pbc(3)=r1(3)
      call cf_pbc(1,r1,1,r1,1,0,1,1)
      xacc(4)=sqrt(r1(1)**2+r1(2)**2+r1(3)**2)
c  
c     calculating midpoint of donor-acceptor
c
      if(abs(r1pbc(1)-r1(1)).lt.0.001) then
      xacc(6)=(xs(idhv(1),1)+xs(idhv(2),1))/2      
      xacc(9)=xacc(6)
      else
      xacc(6)=(xs(idhv(1),1)+(r1pbc(1)-r1(1))+xs(idhv(2),1))/2
      xacc(9)=xacc(6)-(r1pbc(1)-r1(1))
      endif
c
      if(abs(r1pbc(2)-r1(2)).lt.0.001) then
      xacc(7)=(xs(idhv(1),2)+xs(idhv(2),2))/2      
      xacc(10)=xacc(7)
      else
      xacc(7)=(xs(idhv(1),2)+(r1pbc(2)-r1(2))+xs(idhv(2),2))/2
      xacc(10)=xacc(7)-(r1pbc(2)-r1(2))
      endif
c
      if(abs(r1pbc(3)-r1(3)).lt.0.001) then
      xacc(8)=(xs(idhv(1),3)+xs(idhv(2),3))/2      
      xacc(11)=xacc(8)
      else
      xacc(8)=(xs(idhv(1),3)+(r1pbc(3)-r1(3))+xs(idhv(2),3))/2
      xacc(11)=xacc(8)-(r1pbc(3)-r1(3))
      endif
c
      sid1(1)=xs(idhv(1),1)-xs(idon,1)
      sid1(2)=xs(idhv(1),2)-xs(idon,2)
      sid1(3)=xs(idhv(1),3)-xs(idon,3)
      call cf_pbc(1,sid1,1,r1,1,0,1,1)
      sid2(1)=xs(idhv(2),1)-xs(idon,1)
      sid2(2)=xs(idhv(2),2)-xs(idon,2)
      sid2(3)=xs(idhv(2),3)-xs(idon,3)
      call cf_pbc(1,sid2,1,r1,1,0,1,1)
c
      nsid(1)=sqrt(sid1(1)**2+sid1(2)**2+sid1(3)**2)
      nsid(2)=sqrt(sid2(1)**2+sid2(2)**2+sid2(3)**2)
c
      xacc(5)=(sid1(1)*sid2(1)+sid1(2)*sid2(2)+sid1(3)*sid2(3))*
     +         (1/(nsid(1)*nsid(2)))
      xacc(5)=acos(xacc(5))
c
c
c     debug: print shift of proton
c
      r1(1)=xs(idon,1)-xacc(1)
      r1(2)=xs(idon,2)-xacc(2)
      r1(3)=xs(idon,3)-xacc(3)
      call cf_pbc(1,r1,1,r1,1,0,1,1)
c      dshop=sqrt(r1(1)**2+r1(2)**2+r1(3)**2)
c      print*,"mov ",resd,idong,resa,norm,xacc(4),xacc(5)
c     Shift for permutation of donor H
c
      numh=arat(ptarat(ptseq(resd,1))+idong-
     + ptseq(resd,2),4)
      inh=-arat(ptarat(ptseq(resd,1))+idong-
     + ptseq(resd,2),1)
      inhv=arat(ptarat(ptseq(resd,1))+idong-
     + ptseq(resd,2),3)
      if(numh.eq.1)then
      doff=0
      else if(numh.eq.2)then
      doff=numh-inh
c      doff=numh-inh-iand(((istatd-1)/(2**(inhv-1))+1),1)
      else
      doff=numh-inh-(istatd-1)
      endif
c      print*,'don ',resd,inh,doff,istatd
c
c     Shift for permutation of acceptor dummy site
c     Currently if nhv>1,only one dummy is allowed
c
      numh=arat(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2),4)
      inh=-arat(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2),1)
      inhv=arat(ptarat(ptseq(resa,1))+iaccg-
     + ptseq(resa,2),3)
      aoff=inh-numh-1+iand(((istata-1)/(2**(inhv-1))+1),1)
      aoff=0
c      if(numh>2)aoff=numh-inh-(istata-2)
c     print*,'acc ',resa,inh,doff,istata
c
c      print 1021,typ,doff,aoff,xacc,numh,inh,istatd
c 1021 format(3i5,5f8.3,3i5)
c
c      flag to see if res are same type
c
      flada=0
      if(ptseq(resa,1).eq.ptseq(resd,1))flada=1
      return
      end

      subroutine rot(angle,x,y,z,axis)

      implicit none

      real*8 angle,x,y,z,x1,y1,z1
      integer axis

      x1=x
      y1=y
      z1=z

      if(axis.eq.3)then
         x=x1*cos(angle)+y1*sin(angle)
         y=-x1*sin(angle)+y1*cos(angle)
      else if(axis.eq.1) then
         y=y1*cos(angle)+z1*sin(angle)
         z=-y1*sin(angle)+z1*cos(angle)
      else

      endif
      end

      subroutine smd_input(rtdb)
c
      implicit none
#include "errquit.fh"
c
#include "stdio.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      character*32 tag
      character*32 pname
      character*255 token
      character*80 mtoken(10)
      integer  itoken(10)
      double precision  ftoken(10)
      integer ip,np
c
      pname = "smd_input: "
c
c      write(luout,*) "in ",pname
c
      call inp_set_field(0)
c
c     start parsing input
c     ------------------
      if (.not.inp_a(token))
     + call errquit(pname//'no input available',0, INPUT_ERR)
      if (.not.inp_compare(.false.,token,'smd'))
     + call errquit('smd_input: no input available',0, INPUT_ERR)
      goto 2
    1 continue
      if (.not.inp_read()) call errquit('smd_input: premature EOF',0,
     &       INPUT_ERR)
    2 continue
      if(.not.inp_a(token)) goto 1
c
c     charges
c     ----------
      if(inp_compare(.false.,'charge',token)) then
        call smd_input_charge(rtdb)
        goto 2
      endif
c
c     velocities
c     ----------
      if(inp_compare(.false.,'veloc',token)) then
        call smd_input_veloc(rtdb)
        goto 2
      endif
c
c     coordinates
c     ----------
      if(inp_compare(.false.,'coord',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_a(mtoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:coordfile"
        if (.not.rtdb_cput(rtdb,tag,1,mtoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     parameters
c     ----------
      if(inp_compare(.false.,'param',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_a(mtoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:paramfile"
        if (.not.rtdb_cput(rtdb,tag,1,mtoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     kvec
c     -----
      if(inp_compare(.false.,'kvec',token)) then
        np = 3
        do ip = 1,np
          if(.not.inp_i(itoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:kvec"
        if (.not.rtdb_put(rtdb,tag,mt_int,3,itoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     lat_a
c     -----
      if(inp_compare(.false.,'lat_a',token)) then
        np = 3
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:lat_a"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,3,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     lat_b
c     -----
      if(inp_compare(.false.,'lat_b',token)) then
        np = 3
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:lat_b"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,3,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     lat_c
c     -----
      if(inp_compare(.false.,'lat_c',token)) then
        np = 3
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:lat_c"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,3,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     ndata
c     -----
      if(inp_compare(.false.,'ndata',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_i(itoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:ndata"
        if (.not.rtdb_put(rtdb,tag,mt_int,np,itoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     nequil
c     -----
      if(inp_compare(.false.,'nequil',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_i(itoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:nequil"
        if (.not.rtdb_put(rtdb,tag,mt_int,np,itoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     nprint
c     -----
      if(inp_compare(.false.,'nprint',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_i(itoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:nprint"
        if (.not.rtdb_put(rtdb,tag,mt_int,np,itoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     step
c     -----
      if(inp_compare(.false.,'step',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:step"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,np,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     rcut
c     ----
      if(inp_compare(.false.,'rcut',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:rcut"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,np,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     temp
c     -----
      if(inp_compare(.false.,'temp',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:temp_target"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,np,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     ewald
c     -----
      if(inp_compare(.false.,'ewald',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:ewald"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,np,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c
c     verlet
c     ------
      if(inp_compare(.false.,'verlet',token)) then
        np = 1
        do ip = 1,np
          if(.not.inp_f(ftoken(ip))) then
             call errquit(pname//token,0,
     &           INPUT_ERR)
          end if
        end do
        tag="smd:verlet"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,np,ftoken(1))) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
          goto 2
      endif
c     
c     print level 
c     -------------------
      if (inp_compare(.false.,'print', token)) then
         call util_print_input(rtdb, "smd")
         go to 2
      end if
c
      if (token.eq.'end') then
c        write(luout,*) "out of ",pname
c        write(*,*) "RTDB after smd"
c        if(.not.rtdb_print(rtdb,.true.))
c     >      call errquit(pname//'failed to print rtdb',0,
c     >       RTDB_ERR)
        return
      endif
c
        if(.not.rtdb_print(rtdb,.true.))
     >      call errquit(pname//'failed to print rtdb',0,
     >       RTDB_ERR)
       write(luout,*)' unrecognized token in smd input:',
     + token(1:inp_strlen(token))
       call errquit(pname//'failed ',0,
     >        RTDB_ERR)
      return
998   call errquit(pname//'no token found '//token,0,
     >        RTDB_ERR)
999   call errquit(pname//'failed to store '//tag,0,
     >        RTDB_ERR)

      end

      subroutine smd_input_veloc(rtdb)
c
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      character*32 tag
      character*32 pname
      character*255 token
      integer ip,np
c
      pname = "smd_input_vel"
c
      write(luout,*) "in ",pname
c
      np = inp_n_field()
c
      if(np.eq.1) goto 200
c
      call inp_set_field(1)
c
c     start parsing input
c     ------------------
2     continue
      if(inp_cur_field().eq.np) return
      if (.not.inp_a(token))
     + call errquit(pname,0, INPUT_ERR)
      write(*,*) "current token",token,
     +           inp_cur_field(),np
c
c     input files
c     -----------
      if(inp_compare(.false.,'input',token) ) then
        if(.not.inp_a(token)) 
     >   call errquit(pname//' input ',0,INPUT_ERR)
        tag="smd:veloc:input"
        if (.not.rtdb_cput(rtdb,tag,1,token)) 
     >        call errquit(pname//'failed to store'//tag,0,
     >         RTDB_ERR)

        goto 2
      endif
c
c     output files
c     -----------
      if(inp_compare(.false.,'output',token) ) then
        if(.not.inp_a(token)) 
     >   call errquit(pname//' input ',0,INPUT_ERR)
        tag="smd:veloc:output"
        if (.not.rtdb_cput(rtdb,tag,1,token)) 
     >        call errquit(pname//'failed to store'//tag,0,
     >         RTDB_ERR)

        goto 2
      endif


200   continue
      write(luout,*) "out ",pname
      return
      end

      subroutine smd_input_charge(rtdb)
c
      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      character*32 tag
      character*32 pname
      character*255 token
      integer ip,np
c
      pname = "smd_input_charge"
c
      write(luout,*) "in ",pname
c
      np = inp_n_field()
c
      if(np.eq.1) goto 200
c
      call inp_set_field(1)
c
c     start parsing input
c     ------------------
2     continue
      if(inp_cur_field().eq.np) return
      if (.not.inp_a(token))
     + call errquit(pname,0, INPUT_ERR)
      write(*,*) "current token",token,
     +           inp_cur_field(),np
c
c     input files
c     -----------
      if(inp_compare(.false.,'input',token) ) then
        if(.not.inp_a(token)) 
     >   call errquit(pname//' input ',0,INPUT_ERR)
        tag="smd:charge:input"
        if (.not.rtdb_cput(rtdb,tag,1,token)) 
     >        call errquit(pname//'failed to store'//tag,0,
     >         RTDB_ERR)

        goto 2
      endif
c
c     output files
c     -----------
      if(inp_compare(.false.,'output',token) ) then
        if(.not.inp_a(token)) 
     >   call errquit(pname//' input ',0,INPUT_ERR)
        tag="smd:charge:output"
        if (.not.rtdb_cput(rtdb,tag,1,token)) 
     >        call errquit(pname//'failed to store'//tag,0,
     >         RTDB_ERR)

        goto 2
      endif


200   continue
      write(luout,*) "out ",pname
      return
      end
c $Id: smd_input.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine ccsd_iterdrv2(rtdb,basis,nsh,ncor,nocc,nvir,nact,nbf,
     &                        maxit,Thre,iprt,cmo,eorb,t1,
     &                        ht1,scra,scrb,hiu,hia,habe,giu,gabe,
     &                        bbkp,bb,g_t2,g_ht2,
     &                        mxvec,eccsd,max2e,mem2,
     &                        g_ncoul,g_nexch,tklst,offt2,nvp1,
     $     refener, Tol2E, occd, oconverged, eccsdos)
C     $Id: ccsd_iterdrv2.F 25168 2014-01-23 02:05:45Z edo $
      implicit none
#include "errquit.fh"
#include "util.fh"
#include "stdio.fh"
c
      integer rtdb,basis,nsh,ncor,nocc,nvir,nact,nbf,maxit,iprt,
     & g_t2,g_ht2,g_nt2,g_nht2,mxvec,g_ncoul,g_nexch,
     &        tklst(nsh*(nsh+1)/2,2)
      Double Precision Thre, Tol2E
      double precision time_iter_start
      integer time_prev_iter
      logical oconverged        ! Return convergence status
      logical occd
c
       double precision cmo(nbf,nbf),eorb(nbf),t1(*),
     &                  ht1(*),scra(*),scrb(*),
     &                  hiu(*),hia(*),habe(*),giu(*),gabe(*),
     &                  bbkp(*),bb(*),eccsd, refener, eccsdos
c
c$$$      double precision rtc
c$$$      external rtc
c
#include "ccsd_len.fh"
*rak-s
#include "ccsd_time.fh"
*rak-e
c
      integer iter,idiis,ndiis,bev,jhi,jlo,ihi,ilo,offt2,nvp1,
     &        i,av,lhoo,lhoov
      integer max2e,mem2
      double precision eold,dabs,tx(4),rms,deccsd,
     &                 tstart,tend

      Integer IAm
      logical orestart, oprint
      character*255 t2file, filename

      logical ccsd_read_restart, ccsd_write_restart
      external ccsd_read_restart, ccsd_write_restart


C
#include "msgids.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "ccsdps.fh"
#include "ccsd_data.fh"
#include "chemio.h"
#include "eaf.fh"
c
      double precision zip
      data zip/0.0d00/
c
      double precision util_scratch_dir_avail_for_me
      external util_scratch_dir_avail_for_me
c
      IAm = GA_NodeID()
c
      oprint = util_print('information', print_low)
C
      call ga_sync()
      if (occsdps) then
         call pstat_on(ps_itrdrv)
      else
         call qenter('iterdrv',0)
      endif
c
      lhoo=nocc*(nocc+1)/2
      lhoov=nvir*nocc*(nocc+1)/2
c
      nvp1=nvir+1

c - integrals for ccsd_sxy (calculate as much as possible once and read after that)
c - input switch to avoid using disk
      if (.not. rtdb_get(rtdb, 'ccsd:usedisk', mt_log, 1, use_disk))
#ifdef NOIO
c     direct by default to avoid io
     $   use_disk=.false.
#else
     $   use_disk=.true.
#endif
      if (use_disk) then
         store_avail=util_scratch_dir_avail_for_me()
c - convert back to bytes
         store_avail=store_avail*1024
         call util_file_name('ccsdints',.true.,.true.,filename)
         if (eaf_open(filename,EAF_RW,sxy_hl).ne.0) call
     $      errquit('ccsd_iterdrv2: failed to open file',0,DISK_ERR)
      endif
      repeat=.false.

c - starting vectors

      call ga_distribution(g_t2,iam,jlo,jhi,ilo,ihi)

      call util_file_name('t2', .false.,.false.,t2file)

c - if converged, read vectors and return
c - else check if one can restart
      if (.not.rtdb_get(rtdb, 'ccsd:restart',MT_LOG, 1, orestart))
     $    orestart = .true.   ! By default always try to restart
      if (.not.rtdb_get(rtdb, 'ccsd:converged',MT_LOG, 1, oconverged))
     $    oconverged = .false.  ! Not converged yet
      if(.not.rtdb_get(rtdb,'ccsd:useinmemst2',mt_log, 1,use_inmem_st2))
     $   use_inmem_st2=.true. ! Old default kept ST2 in GA

      if (orestart.or.oconverged) then
          orestart = ccsd_read_restart(t2file, g_t2, nvir, lhoov)
          if (oconverged) oconverged = orestart
      endif

c Note that if restart fails orestart will be set false
      if (.not. orestart) then
         if (iam .eq. 0 .and. oprint) write(luout,*) 
     M        ' Using MP2 initial guess vector '
        call dfill(lnov,zip,t1,1)
        if (nvp1.ge.ilo.and.nvp1.le.ihi)then
         call ga_put(g_t2,1,lnov,nvp1,nvp1,t1,1)
        endif
        call ccsd_mkt2(ncor,nocc,nvir,nact,eorb,scra,
     &                 scrb,g_nexch,g_t2,iprt)
      endif
      call ccsd_mktask(basis,nsh,tklst)
c
c ------------------------------------------------------------
c if the calculation is already converged get out of here
c ------------------------------------------------------------
c
      if(oconverged) then
         if (iam.eq.0 .and. oprint)write(luout,*) 
     $      'CCSD is already converged'
         offt2 = 0
         if(.not.rtdb_get(rtdb, 'ccsd:corlenerg',MT_DBL, 1, eccsd))
     $      eccsd=zip
         call ga_sync()
         if (occsdps) then
            call pstat_off(ps_itrdrv)
         else
            call qexit('iterdrv',0)
         endif
         return
      endif
c
c ------------------------------------------------------------
c create square GAs with proposed final ordering
c ------------------------------------------------------------
c
      if (.not.ga_create(MT_DBL,lnov,lnov,'nt2',
     &                   nvir,nvir,g_nt2))
     &     call errquit('ga_create g_nt2 failed',0, GA_ERR)
      if (.not.ga_create(MT_DBL,lnov,lnov,'nht2',
     &                   nvir,nvir,g_nht2))
     &     call errquit('ga_create g_nht2 failed',0, GA_ERR)
c
      call ga_sync()
c
      iter=0
      idiis=0
      ndiis=0
      eccsd=zip
      eold=zip
      rms=thre+thre
      deccsd=thre+thre
c
c ----------------------------------------------------------
c begin iterations
c ----------------------------------------------------------
      if (iam.eq.0 .and. oprint)write(luout,1234)
*rak 1234 format(//,71(1h-),/,' iter',8x,'correlation',11x,'delta',9x,
*rak     &       'rms',/,15x,'energy',14x,'energy',/,71(1h-))
 1234 format(//,73('-'),/,' iter',5x,'correlation',5x,'delta',7x,
     &       'rms',7x,'T2',5x,'Non-T2',6x,'Main',
     &    /,13x,'energy',6x,'energy',6x,'error',
     &    6x,'ampl',5x,'ampl',6x,'Block',
     &    /,48x,'time',5x,'time',6x,'time',
     &    /,73('-'))
   99 continue
      time_iter_start = util_wallsec()
      iter=iter+1
      idiis=idiis+1
      if (idiis.gt.mxvec)idiis=1
      ndiis=ndiis+1
      if (ndiis.gt.mxvec)ndiis=mxvec
      offt2=(idiis-1)*lhoov

c
c     Write out the current T1 and T2 for possible restart
c     (note that T1 is kept at end of T2)
c
      if (.not. ccsd_write_restart(t2file, g_t2, nvir, lhoov, offt2))
     $     call errquit('ccsd: failed saving vector for restart',0,
     &       UNKNOWN_ERR)
c
      oconverged = .false.
      if (dabs(rms).lt.thre.and.dabs(deccsd).lt.thre)then
         oconverged = .true.
         if(.not.rtdb_put(rtdb, 'ccsd:corlenerg',MT_DBL, 1, eccsd))
     $     call errquit('ccsd_iterdrv2: rtdb_put failed', 0, RTDB_ERR)
         if(.not.rtdb_put(rtdb, 'ccsd:converged',MT_LOG, 1, oconverged))
     $     call errquit('ccsd_iterdrv2: rtdb_put failed', 0, RTDB_ERR)
        if (iam.eq.0 .and. oprint)write(luout,1236)
 1236   format(18x,'*************converged*************',18x,
     &         /,73('-'),/)
        goto 999 
      endif
      if (iter.gt.maxit)then
        if (iam.eq.0 .and. oprint)write(luout,1237)
 1237   format(18x,'****maximum iterations exceeded****',18x,
     &         /,73('-'),/)
        goto 999
      endif
      if (iprt.gt.5.and.iam.eq.0)write(luout,134)iter,idiis,ndiis
 134  format(' iteration ',i3,' idiis ',i3,' ndiis ',i3)

*
*     RJH ... hack for CCD
      if (occd) then
      if (iam.eq.0)then
         call dfill(lnov, 0.0d0, t1, 1)
         call ga_put(g_t2,offt2+1,offt2+lnov,nvp1,nvp1,t1,lnov)
      endif
      endif
*
*

      if (iam.eq.0)then
       call ga_get(g_t2,offt2+1,offt2+lnov,nvp1,nvp1,t1,lnov)
      endif
c
      if (iam.eq.0.and.iprt.gt.5)then
       print *,'starting t1 vector'
       write(luout,139)(t1(i),i=1,lnov)
  139   format(4e14.4)
       do av=1,nvir
        call ga_get(g_t2,offt2+1,offt2+lhoov,av,av,scra,lhoov)
        print *,'starting t2 for av ',av
        write(luout,139)(scra(i),i=1,lhoov)
       enddo
      endif
c
      call ga_brdcst(msg_cc_t1a,t1,mdtob(lnov),0)
      tx(3)=tcgtime()
c
c ----------------------------------------------------------
c form ``sigma'' vector
c ----------------------------------------------------------
      call dfill(lnov,zip,ht1,1)
      call dfill(lhoov,zip,scra,1)
      call ga_distribution(g_ht2,iam,jlo,jhi,ilo,ihi)
      call ga_sync
      do bev=1,nvir+1
         if (bev.ge.ilo.and.bev.le.ihi)then
            call ga_put(g_ht2,offt2+1,offt2+lhoov,bev,bev,scra,1)
         endif
      enddo
      if (nvp1.ge.ilo.and.nvp1.le.ihi)then
         call ga_put(g_ht2,offt2+1,offt2+lnov,nvp1,nvp1,scra,1)
      endif
      call ga_sync()
      tx(1)=tcgtime()
      call ccsd_pampt2(basis,idiis,nsh,ncor,nocc,nvir,nact,nbf,
     &                iprt,cmo,eorb,t1,ht1,
     $                scra,scrb,hiu,hia,habe,giu,gabe,
     &                g_t2,g_ht2,g_nt2,g_nht2,eccsd,
     &                g_ncoul,g_nexch,tklst, Tol2E, occd, eccsdos)
      call ga_sync()
*
*     RJH more CCD hacks
*
      if (occd) then
      if (iam .eq. 0) then
         call dfill(lnov,zip,ht1,1)
         call ga_put(g_ht2,offt2+1,offt2+lnov,nvp1,nvp1,t1,lnov)
      endif
      call ga_sync()
      endif


      tx(2)=tcgtime()
      tstart=tx(2)
      call ccsd_pdiis(nocc,nvir,idiis,ndiis,t1,ht1,scra,scrb,mxvec,
     &                 bbkp,bb,iprt,iter,rms,g_t2,g_ht2,lhoov)
      call ga_sync()
      deccsd=eccsd-eold
      eold=eccsd
      tx(4)=tcgtime()
      tend=tx(4)
      if (iprt.gt.5.and.iam.eq.0)print *,' time pdiis ',tend-tstart
      if (iam.eq.0 .and. oprint)then
          write(luout,1235)iter,eccsd,deccsd,rms,
     &      tx(2)-tx(1),
     &      tx(4)-tx(3)-(tx(2)-tx(1)),
     &      main_block_time
      call util_flush(luout)
 1235 format(i4,f18.10,2(1p,d11.3,0p),3(f9.2))
c
      call ecce_print1('ccsd total energy', mt_dbl, eccsd+refener, 1)
      call ecce_print1('ccsd delta energy', mt_dbl, deccsd, 1)
      call ecce_print1('ccsd rms error', mt_dbl, rms, 1)
c
      endif
c
      time_prev_iter = nint((util_wallsec() - time_iter_start)*1.2d0)
c
      if (util_test_time_remaining(rtdb,time_prev_iter)) then
        goto 99
      else
        if (.not. ccsd_write_restart(t2file, g_t2, nvir, lhoov, offt2))
     $       call errquit('ccsd: failed saving vector for restart',1,
     &         UNKNOWN_ERR)
        goto 999
      endif
c
 999  continue
c
      if (.not.ga_destroy(g_nht2))
     &    call errquit('ga_dest g_nht2 fail',0, GA_ERR)
      if (.not.ga_destroy(g_nt2))
     &    call errquit('ga_dest g_nt2 fail',0, GA_ERR)
c
      if (use_disk) then
         if (eaf_close(sxy_hl).ne.0) call
     $   errquit('ccsd_iterdrv2: failed to close file',0,DISK_ERR)
      endif
c
      call ga_sync()
      if (occsdps) then
         call pstat_off(ps_itrdrv)
      else
         call qexit('iterdrv',0)
      endif
      return
      end
      logical function ccsd_read_restart(t2file, g_t2, nvir, lhoov)
      implicit none
#include "global.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
      character*(*) t2file
      integer nvir, lhoov
      integer g_t2
      logical oprint
c
      logical file_read_ga_patch
      external file_read_ga_patch
c
      call ga_sync
c
      oprint = util_print('information', print_low)
c
      ccsd_read_restart = 
     $     file_read_ga_patch(t2file,g_t2,1,lhoov,1,nvir+1)

      if (ga_nodeid().eq. 0 .and. oprint) then
         if (ccsd_read_restart) then
            write(luout,*) ' Restarting from old vector in ',
     $           t2file(1:inp_strlen(t2file))
         else
            write(luout,*) ' Failed reading restart vector from ',
     $           t2file(1:inp_strlen(t2file))
         endif
      endif
c
      end
      logical function ccsd_write_restart(t2file, g_t2, nvir, lhoov, 
     $     offt2)
      implicit none
#include "global.fh"
#include "util.fh"
#include "stdio.fh"
      character*(*) t2file
      integer nvir, lhoov, offt2
      integer g_t2
c
      logical file_write_ga_patch
      external file_write_ga_patch
c
c     file_write_ga_patch does a ga_sync immediately upon entry, 
c     so this call is unnecessary
c
c      call ga_sync
c
      ccsd_write_restart = 
     $     file_write_ga_patch(t2file,g_t2,offt2+1,offt2+lhoov,1,nvir+1)

      if ((.not. ccsd_write_restart) .and. ga_nodeid().eq. 0
     $     .and. util_print('information', print_low)) 
     $     write(luout,*) ' Write of T2 failed'
c
      end

         

C> \ingroup basis
C> @{
C>
C> \brief Compute the checksum of a basis set instance
C>
C> \return Return .true. if successfull, and .false. otherwise
C>
      logical function bas_checksum(basisin, sum)
      implicit none
*
* $Id: bas_checksum.F 22825 2012-09-07 16:29:35Z d3y133 $
*
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "mafdecls.fh"
      integer basisin  !< [Input] The basis set handle
      character*32 sum !< [Output] The checksum
c
      integer dtob, itob, ltob, basis, ntags, i
      logical bas_check_handle
      external bas_check_handle
#include "bas_exndcf.fh"
c
      bas_checksum = bas_check_handle(basisin, 'bas_checksum')
      if (.not. bas_checksum) return
c
      dtob = ma_sizeof(mt_dbl, 1, mt_byte)
      itob = ma_sizeof(mt_int, 1, mt_byte)
      ltob = ma_sizeof(mt_log, 1, mt_byte)
c
      basis = basisin + BASIS_HANDLE_OFFSET
      ntags = infbs_head(HEAD_NTAGS, basis)
c
c     Checksum just the unique basis info
c
c     Spherical
c     Header
c     Tags
c     Coefficients and exponents
c
      call checksum_init()
      call checksum_update(ltob, bas_spherical(basis))
      call checksum_update(itob*ndbs_head, infbs_head(1,basis))
      do i = 1, ntags
         call checksum_char_update(bs_tags(i,basis))
      enddo
      call checksum_update(dtob*exndcf(SZ_exndcf,basis),
     $     dbl_mb(exndcf(K_exndcf,basis)))
      call checksum_final(sum)
c
      end
C> @}

      Subroutine hf1PRtoAB(dP,dR,dA,dB,alpha,ipair,ff,NPP,Nint,
     &       ictrA,ictrB)
c $Id: hf1PRtoAB.f 19696 2010-10-29 16:53:42Z d3y133 $

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

c--> Derivative integrals wrt to (P,R).

      Dimension dP(NPP,Nint),dR(NPP,Nint)

c--> Derivative integrals wrt to (A,B).

      Dimension dA(Nint),dB(Nint)

c--> Exponents & Pair Index

      Dimension alpha(2,NPP),ipair(2,NPP)

c--> Scratch space.

      Dimension ff(2,NPP)
c--> locals
      double precision sumA, sumB
c
c Transform derivative integrals wrt (P,R) to (A,B).
c
c N.B. It is assumed that the product of contraction coefficients has been
c      factored into each primitive (P,R) integral derivative. Thus, this 
c      routine currently transforms primitive (P,R) integral derivatives to 
c      contracted (A,B) integral derivatives.
c
c*******************************************************************************

c Initialize derivative integrals wrt to (A,B).

      if(ictra.eq.ictrb) then
        do 00100 nn = 1,Nint
          sumA = 0.0d00
          do 00200 mp = 1,NPP
            sumA = sumA + dP(mp,nn)
00200     continue
          dA(nn) = sumA
00100   continue
        call dlaset(' ',nint,1,0.0d00,0.0d00,dB,nint)
      else
c Compute exponent ratios.

      do 20 mp = 1,NPP
       ff(1,mp) = alpha(1,mp)/(alpha(1,mp) + alpha(2,mp))
       ff(2,mp) = alpha(2,mp)/(alpha(1,mp) + alpha(2,mp))
   20 continue

c Transform.

      do 40 nn = 1,Nint

        sumA = 0.0d00
        sumB = 0.0d00
        do 30 mp = 1,NPP
          sumA = sumA + (ff(1,mp)*dP(mp,nn) + dR(mp,nn))
          sumB = sumB + (ff(2,mp)*dP(mp,nn) - dR(mp,nn))
 30     continue
        dA(nn) = sumA
        dB(nn) = sumB
 40   continue
      endif

      end

      subroutine nwints_xlm_norm(qn,e,D,Ld)
* $Id: xlm_norm.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none
#include "mafdecls.fh"
c
c     initialize data to normalize solid spherical harmonics
c
c     e(m) = -1 if m > 0 and m odd
c             1 otherwise
c     qn(m,l) = normalization constant required by Condon & Shortley
c               so that the unnormalized xml satisfy
c               qn( m,l) * x( m,l) = r^l * Re (Yml) m >= 0
c               qn(-m,l) * x(-m,l) = r^l * Im (Yml) m >= 0
c               |m| <= l, 0 otherwise
c
      integer Ld                       ! max angular momentum
      double precision e(-Ld:Ld)       ! [scratch] prefactor
      double precision qn(-Ld:Ld,0:Ld) ! [scratch] normalization constants
c......................................! [input/output] transformation matrix
      double precision D((((Ld+1)*(Ld+2))/2),-Ld:Ld,0:Ld) 
c::local
      integer L2s
      integer l, m
      double precision pi4
      double precision pi, fact
#if defined (QN_NEW_WAY)
      double precision pi, pi2x, resultlmm, resultlpm
#endif
      double precision norm

c
c... initialize e and qn

*rak:      write(6,*)' ma 1'
*rak:      if (.not.ma_verify_allocator_stuff()) stop ' ma ver'
      call dcopy((2*Ld+1)*(Ld+1),0.0d00,0,qn,1)
*rak:      write(6,*)' ma 2'
*rak:      if (.not.ma_verify_allocator_stuff()) stop ' ma ver'
*rak:      write(6,*) Ld
      do m = -Ld, 0
         e(m) = 1.0d0
      end do
      do m = 1, Ld
        if (mod(m,2).eq.0) then
          e(m) = 1.0d00
        else
          e(m) = -1.0d00
        endif
      end do

*rak:      write(6,*)' ma 3'
*rak:      if (.not.ma_verify_allocator_stuff()) stop ' ma ver'
c... form qn values via recursion

      pi4 = 16.0d0*atan(1.0d0)
      do l = 0, Ld
         qn(0,l) = (2*l+1)/pi4
         do m = 1, l
            qn( m,l) = qn(m-1,l)/((l+m)*(l-m+1))
            qn(-m,l) = qn(m,l)
         end do
      end do
*rak:      write(6,*)' ma 4'
*rak:      if (.not.ma_verify_allocator_stuff()) stop ' ma ver'
      do l = 0, Ld
         do m = -l, l
            qn(m,l) = e(m) * sqrt(qn(m,l))
         end do
      end do
*...  fix m=0 dependence (found emperically)
*...  multiply all m=0 coeffs by 1/sqrt(2)
*...  this gives all 2l+1 values the same diagonal value
      do l = 0, Ld
        qn(0,l) = qn(0,l)/sqrt(2.0d00)
      enddo
*... fix L>2 dependence (found emperically)
*...  multiply all coeffs by sqrt(8pi/(2l+1))
*...  this gives a diagional spherical overlap matrix
      pi = 2.0d0*dacos(0.0d00)
      do l = 0, Ld
        fact = 8.0d00*pi/(2.0d00*dble(l)+1.00d00)
        fact = sqrt(fact)    ! 
        do m = -l,l
          qn(m,l)=qn(m,l)*fact
        enddo
      enddo
#if defined (QN_NEW_WAY)
      call print_qn(Ld,qn,' old way ')
      pi = 2.0d0*dacos(0.0d00)
      pi2x = 2*pi
      write(6,*) 'pi =',pi
      call dcopy((2*Ld+1)*(Ld+1),0.0d00,0,qn,1)
      do l = 0, Ld
        do m = -l,l
          call dofact(resultlmm,(l-abs(m)))
          call dofact(resultlpm,(l+abs(m)))
          qn(m,l) = (2*l+1)/2 * resultlmm/resultlpm/pi2x
          qn(m,l) = e(m)*sqrt(qn(m,l))
        enddo
      enddo
      do l = 0, Ld
        qn(0,l) = qn(0,l)/sqrt(2.0d00)
      enddo
      call print_qn(Ld,qn,' new way ')
#endif
*rak:      write(6,*)' ma 5'
*rak:      if (.not.ma_verify_allocator_stuff()) stop ' ma ver'

c... transform D to normalized spherical coefficients

      do l = 0,Ld
        L2s = ((L+1)*(L+2))/2
        do m = -l,l
          norm = qn(m,l)
          call dscal(L2s,norm,D(1,m,l),1)
        enddo
      enddo
*rak:      write(6,*)' ma 6'
*rak:      if (.not.ma_verify_allocator_stuff()) stop ' ma ver'
c
      end
#if defined (QN_NEW_WAY)
      subroutine print_qn(Ld,qn,msg)
      implicit none
      integer Ld
      double precision qn(-Ld:Ld,0:Ld) 
      character*(*) msg

c
      integer l,m
      do l = 0, Ld
        do m = -l,l
          write(6,10000)msg,l,m,qn(m,l)

        enddo
      enddo
10000 format(1x,a,1x,'qn(',i3,',',i4,') = ',f20.6)
      end
      subroutine dofact(result,n)
      implicit none
      integer n
      double precision result
c
      integer i, nr
      nr = 1
      do i=n,1,-1
        nr = nr*i
      enddo
      result = dble(nr)
      write(6,*)' factorial of ',n,' is ', nr
      end
#endif

      SUBROUTINE ccsdtq_lr_alpha_15_31_10_2(d_a,k_a_offset,d_b,k_b_offse
     &t,d_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_31_10_2.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h14 p13 h15 p3 )_ytrbt + = 1/6 * Sum ( h10 h11 h12 p7 p8 ) * t ( p7 p8 p13 h10 h11 h12 )_t * i4 ( h10 h11 h12 h14 h15 p3 p7 p8 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p13b
      INTEGER h14b
      INTEGER h15b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p8b
      INTEGER h10b
      INTEGER h11b
      INTEGER h12b
      INTEGER p13b_1
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER h10b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER h14b_2
      INTEGER h10b_2
      INTEGER h11b_2
      INTEGER h12b_2
      INTEGER h15b_2
      INTEGER p3b_2
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p13b = noab+1,noab+nvab
      DO h14b = 1,noab
      DO h15b = 1,noab
      DO p3b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h14b-1)+int_mb(k_spin+p13b
     &-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      IF (int_mb(k_spin+h14b-1)+int_mb(k_spin+p13b-1) .eq. int_mb(k_spin
     &+h15b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+p13b-1),ieor(int_m
     &b(k_sym+h15b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,ieor(irre
     &p_trb,irrep_t))) THEN
      dimc = int_mb(k_range+h14b-1) * int_mb(k_range+p13b-1) * int_mb(k_
     &range+h15b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_31_10_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO p8b = p7b,noab+nvab
      DO h10b = 1,noab
      DO h11b = h10b,noab
      DO h12b = h11b,noab
      IF (int_mb(k_spin+p13b-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1
     &) .eq. int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h
     &12b-1)) THEN
      IF (ieor(int_mb(k_sym+p13b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb
     &(k_sym+p8b-1),ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h11b-1),
     &int_mb(k_sym+h12b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p13b,p7b,p8b,h10b,h11b,h12b,p13b_1,p7b_1,p8b
     &_1,h10b_1,h11b_1,h12b_1)
      CALL TCE_RESTRICTED_8(h14b,h10b,h11b,h12b,h15b,p3b,p7b,p8b,h14b_2,
     &h10b_2,h11b_2,h12b_2,h15b_2,p3b_2,p7b_2,p8b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+p8b-1) * int_m
     &b(k_range+h10b-1) * int_mb(k_range+h11b-1) * int_mb(k_range+h12b-1
     &)
      dima_sort = int_mb(k_range+p13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h14b-1) * int_mb(k_range+h15b-1) * int_
     &mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_31_10_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_31_10_2',2,MA_ERR)
      IF ((p8b .le. p13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (p13b_1 -
     & noab - 1 + nvab * (p8b_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+p13b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),3,6,5,4,2,1,1.0d0
     &)
      END IF
      IF ((p7b .le. p13b) .and. (p13b .lt. p8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (p8b_1 - 
     &noab - 1 + nvab * (p13b_1 - noab - 1 + nvab * (p7b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p13b-1),int_mb(k_range+p8b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),2,6,5,4,3,1,-1.0d
     &0)
      END IF
      IF ((p13b .lt. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h12b_
     &1 - 1 + noab * (h11b_1 - 1 + noab * (h10b_1 - 1 + noab * (p8b_1 - 
     &noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p13b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p13b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1),int_mb(k_range+h10b-
     &1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),1,6,5,4,3,2,1.0d0
     &)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_31_10
     &_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_31_10_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_31_10_2',5,MA_ERR)
      IF ((h12b .le. h14b) .and. (h15b .le. p7b) .and. (p8b .lt. p3b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h12b_2 - 1 + n
     &oab * (h11b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &8b-1),int_mb(k_range+p3b-1),8,5,4,3,2,1,7,6,1.0d0)
      END IF
      IF ((h12b .le. h14b) .and. (h15b .le. p7b) .and. (p7b .lt. p3b) .a
     &nd. (p3b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h12b_2 - 1 + n
     &oab * (h11b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &3b-1),int_mb(k_range+p8b-1),7,5,4,3,2,1,8,6,-1.0d0)
      END IF
      IF ((h12b .le. h14b) .and. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h14b_2 - 1 + noab * (h12b_2 - 1 + n
     &oab * (h11b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p3b-1),int_mb(k_range+p
     &7b-1),int_mb(k_range+p8b-1),6,5,4,3,2,1,8,7,1.0d0)
      END IF
      IF ((h11b .le. h14b) .and. (h14b .lt. h12b) .and. (h15b .le. p7b) 
     &.and. (p8b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h14b_2 - 1 + n
     &oab * (h11b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h14b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &8b-1),int_mb(k_range+p3b-1),8,5,3,4,2,1,7,6,-1.0d0)
      END IF
      IF ((h11b .le. h14b) .and. (h14b .lt. h12b) .and. (h15b .le. p7b) 
     &.and. (p7b .lt. p3b) .and. (p3b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h14b_2 - 1 + n
     &oab * (h11b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h14b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &3b-1),int_mb(k_range+p8b-1),7,5,3,4,2,1,8,6,1.0d0)
      END IF
      IF ((h11b .le. h14b) .and. (h14b .lt. h12b) .and. (p3b .le. p7b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h14b_2 - 1 + n
     &oab * (h11b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h11b-1),int_mb(k_range+h14b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p3b-1),int_mb(k_range+p
     &7b-1),int_mb(k_range+p8b-1),6,5,3,4,2,1,8,7,-1.0d0)
      END IF
      IF ((h10b .le. h14b) .and. (h14b .lt. h11b) .and. (h15b .le. p7b) 
     &.and. (p8b .lt. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h11b_2 - 1 + n
     &oab * (h14b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &8b-1),int_mb(k_range+p3b-1),8,5,2,4,3,1,7,6,1.0d0)
      END IF
      IF ((h10b .le. h14b) .and. (h14b .lt. h11b) .and. (h15b .le. p7b) 
     &.and. (p7b .lt. p3b) .and. (p3b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h11b_2 - 1 + n
     &oab * (h14b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &3b-1),int_mb(k_range+p8b-1),7,5,2,4,3,1,8,6,-1.0d0)
      END IF
      IF ((h10b .le. h14b) .and. (h14b .lt. h11b) .and. (p3b .le. p7b)) 
     &THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h11b_2 - 1 + n
     &oab * (h14b_2 - 1 + noab * (h10b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h10b-1
     &),int_mb(k_range+h14b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p3b-1),int_mb(k_range+p
     &7b-1),int_mb(k_range+p8b-1),6,5,2,4,3,1,8,7,1.0d0)
      END IF
      IF ((h14b .lt. h10b) .and. (h15b .le. p7b) .and. (p8b .lt. p3b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p8b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h11b_2 - 1 + n
     &oab * (h10b_2 - 1 + noab * (h14b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &8b-1),int_mb(k_range+p3b-1),8,5,1,4,3,2,7,6,-1.0d0)
      END IF
      IF ((h14b .lt. h10b) .and. (h15b .le. p7b) .and. (p7b .lt. p3b) .a
     &nd. (p3b .le. p8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (p7b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h11b_2 - 1 + n
     &oab * (h10b_2 - 1 + noab * (h14b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p7b-1),int_mb(k_range+p
     &3b-1),int_mb(k_range+p8b-1),7,5,1,4,3,2,8,6,1.0d0)
      END IF
      IF ((h14b .lt. h10b) .and. (p3b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p8b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (p3b_2 - noab - 1 
     &+ nvab * (h15b_2 - 1 + noab * (h12b_2 - 1 + noab * (h11b_2 - 1 + n
     &oab * (h10b_2 - 1 + noab * (h14b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h14b-1
     &),int_mb(k_range+h10b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12
     &b-1),int_mb(k_range+h15b-1),int_mb(k_range+p3b-1),int_mb(k_range+p
     &7b-1),int_mb(k_range+p8b-1),6,5,1,4,3,2,8,7,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_31_10
     &_2',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p7b .eq. p8b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h10b .eq. h11b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h11b .eq. h12b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,12.0d0/FACTORIAL
     &(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(n
     &subh(2))/FACTORIAL(nsubh(3)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_
     &b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &31_10_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &31_10_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_31_10_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+h14b-1),int_mb(k_range+p13b
     &-1),3,4,2,1,1.0d0/6.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (h15b - 1 + noab * (p13b - noab - 1 + nvab * (h
     &14b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_31_10
     &_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &31_10_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

c
c $Id: verlt_test.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE verlt_test(tstep,ivv,lupdate)

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'cm_atom.inc'
      include 'cm_cuto.inc'

      integer i,exceed

      real*8 tstep,tstepsq,ivv
      real*8 dispmax,dispxsq,dispysq,dispzsq,disprsq 

      logical lnew,lupdate

      dimension ivv(mxatms,3) 

      data lnew/.true./

      save lnew

      tstepsq=tstep**2

      if(lnew)then

       lupdate=.true.
       lnew=.false.

       do i=1,natms

        ivv(i,1)=0.0
        ivv(i,2)=0.0
        ivv(i,3)=0.0

       enddo

      else

       lupdate=.false.

       dispmax=((vcut-rcut)/2.0)**2

       do i=1,natms

        ivv(i,1)=ivv(i,1)+vvv(i,1)
        ivv(i,2)=ivv(i,2)+vvv(i,2)
        ivv(i,3)=ivv(i,3)+vvv(i,3)

       enddo

       exceed=0

       do i=1,natms

        dispxsq=ivv(i,1)**2
        dispysq=ivv(i,2)**2
        dispzsq=ivv(i,3)**2
        disprsq=tstepsq*(dispxsq+dispysq+dispzsq)
        if(disprsq.gt.dispmax)exceed=exceed+1
        if(exceed.ge.2)lupdate=.true.

       enddo

       if(lupdate)then

        do i=1,natms

         ivv(i,1)=0
         ivv(i,2)=0
         ivv(i,3)=0

        enddo

       endif

      endif

      return

      END

*> \brief \b DLAQR2 performs the orthogonal similarity transformation of a Hessenberg matrix to detect and deflate fully converged eigenvalues from a trailing principal submatrix (aggressive early deflation).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLAQR2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlaqr2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlaqr2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlaqr2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLAQR2( WANTT, WANTZ, N, KTOP, KBOT, NW, H, LDH, ILOZ,
*                          IHIZ, Z, LDZ, NS, ND, SR, SI, V, LDV, NH, T,
*                          LDT, NV, WV, LDWV, WORK, LWORK )
* 
*       .. Scalar Arguments ..
*       INTEGER            IHIZ, ILOZ, KBOT, KTOP, LDH, LDT, LDV, LDWV,
*      $                   LDZ, LWORK, N, ND, NH, NS, NV, NW
*       LOGICAL            WANTT, WANTZ
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   H( LDH, * ), SI( * ), SR( * ), T( LDT, * ),
*      $                   V( LDV, * ), WORK( * ), WV( LDWV, * ),
*      $                   Z( LDZ, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    DLAQR2 is identical to DLAQR3 except that it avoids
*>    recursion by calling DLAHQR instead of DLAQR4.
*>
*>    Aggressive early deflation:
*>
*>    This subroutine accepts as input an upper Hessenberg matrix
*>    H and performs an orthogonal similarity transformation
*>    designed to detect and deflate fully converged eigenvalues from
*>    a trailing principal submatrix.  On output H has been over-
*>    written by a new Hessenberg matrix that is a perturbation of
*>    an orthogonal similarity transformation of H.  It is to be
*>    hoped that the final version of H has many zero subdiagonal
*>    entries.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] WANTT
*> \verbatim
*>          WANTT is LOGICAL
*>          If .TRUE., then the Hessenberg matrix H is fully updated
*>          so that the quasi-triangular Schur factor may be
*>          computed (in cooperation with the calling subroutine).
*>          If .FALSE., then only enough of H is updated to preserve
*>          the eigenvalues.
*> \endverbatim
*>
*> \param[in] WANTZ
*> \verbatim
*>          WANTZ is LOGICAL
*>          If .TRUE., then the orthogonal matrix Z is updated so
*>          so that the orthogonal Schur factor may be computed
*>          (in cooperation with the calling subroutine).
*>          If .FALSE., then Z is not referenced.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix H and (if WANTZ is .TRUE.) the
*>          order of the orthogonal matrix Z.
*> \endverbatim
*>
*> \param[in] KTOP
*> \verbatim
*>          KTOP is INTEGER
*>          It is assumed that either KTOP = 1 or H(KTOP,KTOP-1)=0.
*>          KBOT and KTOP together determine an isolated block
*>          along the diagonal of the Hessenberg matrix.
*> \endverbatim
*>
*> \param[in] KBOT
*> \verbatim
*>          KBOT is INTEGER
*>          It is assumed without a check that either
*>          KBOT = N or H(KBOT+1,KBOT)=0.  KBOT and KTOP together
*>          determine an isolated block along the diagonal of the
*>          Hessenberg matrix.
*> \endverbatim
*>
*> \param[in] NW
*> \verbatim
*>          NW is INTEGER
*>          Deflation window size.  1 .LE. NW .LE. (KBOT-KTOP+1).
*> \endverbatim
*>
*> \param[in,out] H
*> \verbatim
*>          H is DOUBLE PRECISION array, dimension (LDH,N)
*>          On input the initial N-by-N section of H stores the
*>          Hessenberg matrix undergoing aggressive early deflation.
*>          On output H has been transformed by an orthogonal
*>          similarity transformation, perturbed, and the returned
*>          to Hessenberg form that (it is to be hoped) has some
*>          zero subdiagonal entries.
*> \endverbatim
*>
*> \param[in] LDH
*> \verbatim
*>          LDH is integer
*>          Leading dimension of H just as declared in the calling
*>          subroutine.  N .LE. LDH
*> \endverbatim
*>
*> \param[in] ILOZ
*> \verbatim
*>          ILOZ is INTEGER
*> \endverbatim
*>
*> \param[in] IHIZ
*> \verbatim
*>          IHIZ is INTEGER
*>          Specify the rows of Z to which transformations must be
*>          applied if WANTZ is .TRUE.. 1 .LE. ILOZ .LE. IHIZ .LE. N.
*> \endverbatim
*>
*> \param[in,out] Z
*> \verbatim
*>          Z is DOUBLE PRECISION array, dimension (LDZ,N)
*>          IF WANTZ is .TRUE., then on output, the orthogonal
*>          similarity transformation mentioned above has been
*>          accumulated into Z(ILOZ:IHIZ,ILO:IHI) from the right.
*>          If WANTZ is .FALSE., then Z is unreferenced.
*> \endverbatim
*>
*> \param[in] LDZ
*> \verbatim
*>          LDZ is integer
*>          The leading dimension of Z just as declared in the
*>          calling subroutine.  1 .LE. LDZ.
*> \endverbatim
*>
*> \param[out] NS
*> \verbatim
*>          NS is integer
*>          The number of unconverged (ie approximate) eigenvalues
*>          returned in SR and SI that may be used as shifts by the
*>          calling subroutine.
*> \endverbatim
*>
*> \param[out] ND
*> \verbatim
*>          ND is integer
*>          The number of converged eigenvalues uncovered by this
*>          subroutine.
*> \endverbatim
*>
*> \param[out] SR
*> \verbatim
*>          SR is DOUBLE PRECISION array, dimension (KBOT)
*> \endverbatim
*>
*> \param[out] SI
*> \verbatim
*>          SI is DOUBLE PRECISION array, dimension (KBOT)
*>          On output, the real and imaginary parts of approximate
*>          eigenvalues that may be used for shifts are stored in
*>          SR(KBOT-ND-NS+1) through SR(KBOT-ND) and
*>          SI(KBOT-ND-NS+1) through SI(KBOT-ND), respectively.
*>          The real and imaginary parts of converged eigenvalues
*>          are stored in SR(KBOT-ND+1) through SR(KBOT) and
*>          SI(KBOT-ND+1) through SI(KBOT), respectively.
*> \endverbatim
*>
*> \param[out] V
*> \verbatim
*>          V is DOUBLE PRECISION array, dimension (LDV,NW)
*>          An NW-by-NW work array.
*> \endverbatim
*>
*> \param[in] LDV
*> \verbatim
*>          LDV is integer scalar
*>          The leading dimension of V just as declared in the
*>          calling subroutine.  NW .LE. LDV
*> \endverbatim
*>
*> \param[in] NH
*> \verbatim
*>          NH is integer scalar
*>          The number of columns of T.  NH.GE.NW.
*> \endverbatim
*>
*> \param[out] T
*> \verbatim
*>          T is DOUBLE PRECISION array, dimension (LDT,NW)
*> \endverbatim
*>
*> \param[in] LDT
*> \verbatim
*>          LDT is integer
*>          The leading dimension of T just as declared in the
*>          calling subroutine.  NW .LE. LDT
*> \endverbatim
*>
*> \param[in] NV
*> \verbatim
*>          NV is integer
*>          The number of rows of work array WV available for
*>          workspace.  NV.GE.NW.
*> \endverbatim
*>
*> \param[out] WV
*> \verbatim
*>          WV is DOUBLE PRECISION array, dimension (LDWV,NW)
*> \endverbatim
*>
*> \param[in] LDWV
*> \verbatim
*>          LDWV is integer
*>          The leading dimension of W just as declared in the
*>          calling subroutine.  NW .LE. LDV
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (LWORK)
*>          On exit, WORK(1) is set to an estimate of the optimal value
*>          of LWORK for the given values of N, NW, KTOP and KBOT.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is integer
*>          The dimension of the work array WORK.  LWORK = 2*NW
*>          suffices, but greater efficiency may result from larger
*>          values of LWORK.
*>
*>          If LWORK = -1, then a workspace query is assumed; DLAQR2
*>          only estimates the optimal workspace size for the given
*>          values of N, NW, KTOP and KBOT.  The estimate is returned
*>          in WORK(1).  No error message related to LWORK is issued
*>          by XERBLA.  Neither H nor Z are accessed.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup doubleOTHERauxiliary
*
*> \par Contributors:
*  ==================
*>
*>       Karen Braman and Ralph Byers, Department of Mathematics,
*>       University of Kansas, USA
*>
*  =====================================================================
      SUBROUTINE DLAQR2( WANTT, WANTZ, N, KTOP, KBOT, NW, H, LDH, ILOZ,
     $                   IHIZ, Z, LDZ, NS, ND, SR, SI, V, LDV, NH, T,
     $                   LDT, NV, WV, LDWV, WORK, LWORK )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            IHIZ, ILOZ, KBOT, KTOP, LDH, LDT, LDV, LDWV,
     $                   LDZ, LWORK, N, ND, NH, NS, NV, NW
      LOGICAL            WANTT, WANTZ
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   H( LDH, * ), SI( * ), SR( * ), T( LDT, * ),
     $                   V( LDV, * ), WORK( * ), WV( LDWV, * ),
     $                   Z( LDZ, * )
*     ..
*
*  ================================================================
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0d0, ONE = 1.0d0 )
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION   AA, BB, BETA, CC, CS, DD, EVI, EVK, FOO, S,
     $                   SAFMAX, SAFMIN, SMLNUM, SN, TAU, ULP
      INTEGER            I, IFST, ILST, INFO, INFQR, J, JW, K, KCOL,
     $                   KEND, KLN, KROW, KWTOP, LTOP, LWK1, LWK2,
     $                   LWKOPT
      LOGICAL            BULGE, SORTED
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEHRD, DGEMM, DLABAD, DLACPY, DLAHQR,
     $                   DLANV2, DLARF, DLARFG, DLASET, DORMHR, DTREXC
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, INT, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     ==== Estimate optimal workspace. ====
*
      JW = MIN( NW, KBOT-KTOP+1 )
      IF( JW.LE.2 ) THEN
         LWKOPT = 1
      ELSE
*
*        ==== Workspace query call to DGEHRD ====
*
         CALL DGEHRD( JW, 1, JW-1, T, LDT, WORK, WORK, -1, INFO )
         LWK1 = INT( WORK( 1 ) )
*
*        ==== Workspace query call to DORMHR ====
*
         CALL DORMHR( 'R', 'N', JW, JW, 1, JW-1, T, LDT, WORK, V, LDV,
     $                WORK, -1, INFO )
         LWK2 = INT( WORK( 1 ) )
*
*        ==== Optimal workspace ====
*
         LWKOPT = JW + MAX( LWK1, LWK2 )
      END IF
*
*     ==== Quick return in case of workspace query. ====
*
      IF( LWORK.EQ.-1 ) THEN
         WORK( 1 ) = DBLE( LWKOPT )
         RETURN
      END IF
*
*     ==== Nothing to do ...
*     ... for an empty active block ... ====
      NS = 0
      ND = 0
      WORK( 1 ) = ONE
      IF( KTOP.GT.KBOT )
     $   RETURN
*     ... nor for an empty deflation window. ====
      IF( NW.LT.1 )
     $   RETURN
*
*     ==== Machine constants ====
*
      SAFMIN = DLAMCH( 'SAFE MINIMUM' )
      SAFMAX = ONE / SAFMIN
      CALL DLABAD( SAFMIN, SAFMAX )
      ULP = DLAMCH( 'PRECISION' )
      SMLNUM = SAFMIN*( DBLE( N ) / ULP )
*
*     ==== Setup deflation window ====
*
      JW = MIN( NW, KBOT-KTOP+1 )
      KWTOP = KBOT - JW + 1
      IF( KWTOP.EQ.KTOP ) THEN
         S = ZERO
      ELSE
         S = H( KWTOP, KWTOP-1 )
      END IF
*
      IF( KBOT.EQ.KWTOP ) THEN
*
*        ==== 1-by-1 deflation window: not much to do ====
*
         SR( KWTOP ) = H( KWTOP, KWTOP )
         SI( KWTOP ) = ZERO
         NS = 1
         ND = 0
         IF( ABS( S ).LE.MAX( SMLNUM, ULP*ABS( H( KWTOP, KWTOP ) ) ) )
     $        THEN
            NS = 0
            ND = 1
            IF( KWTOP.GT.KTOP )
     $         H( KWTOP, KWTOP-1 ) = ZERO
         END IF
         WORK( 1 ) = ONE
         RETURN
      END IF
*
*     ==== Convert to spike-triangular form.  (In case of a
*     .    rare QR failure, this routine continues to do
*     .    aggressive early deflation using that part of
*     .    the deflation window that converged using INFQR
*     .    here and there to keep track.) ====
*
      CALL DLACPY( 'U', JW, JW, H( KWTOP, KWTOP ), LDH, T, LDT )
      CALL DCOPY( JW-1, H( KWTOP+1, KWTOP ), LDH+1, T( 2, 1 ), LDT+1 )
*
      CALL DLASET( 'A', JW, JW, ZERO, ONE, V, LDV )
      CALL DLAHQR( .true., .true., JW, 1, JW, T, LDT, SR( KWTOP ),
     $             SI( KWTOP ), 1, JW, V, LDV, INFQR )
*
*     ==== DTREXC needs a clean margin near the diagonal ====
*
      DO 10 J = 1, JW - 3
         T( J+2, J ) = ZERO
         T( J+3, J ) = ZERO
   10 CONTINUE
      IF( JW.GT.2 )
     $   T( JW, JW-2 ) = ZERO
*
*     ==== Deflation detection loop ====
*
      NS = JW
      ILST = INFQR + 1
   20 CONTINUE
      IF( ILST.LE.NS ) THEN
         IF( NS.EQ.1 ) THEN
            BULGE = .FALSE.
         ELSE
            BULGE = T( NS, NS-1 ).NE.ZERO
         END IF
*
*        ==== Small spike tip test for deflation ====
*
         IF( .NOT.BULGE ) THEN
*
*           ==== Real eigenvalue ====
*
            FOO = ABS( T( NS, NS ) )
            IF( FOO.EQ.ZERO )
     $         FOO = ABS( S )
            IF( ABS( S*V( 1, NS ) ).LE.MAX( SMLNUM, ULP*FOO ) ) THEN
*
*              ==== Deflatable ====
*
               NS = NS - 1
            ELSE
*
*              ==== Undeflatable.   Move it up out of the way.
*              .    (DTREXC can not fail in this case.) ====
*
               IFST = NS
               CALL DTREXC( 'V', JW, T, LDT, V, LDV, IFST, ILST, WORK,
     $                      INFO )
               ILST = ILST + 1
            END IF
         ELSE
*
*           ==== Complex conjugate pair ====
*
            FOO = ABS( T( NS, NS ) ) + SQRT( ABS( T( NS, NS-1 ) ) )*
     $            SQRT( ABS( T( NS-1, NS ) ) )
            IF( FOO.EQ.ZERO )
     $         FOO = ABS( S )
            IF( MAX( ABS( S*V( 1, NS ) ), ABS( S*V( 1, NS-1 ) ) ).LE.
     $          MAX( SMLNUM, ULP*FOO ) ) THEN
*
*              ==== Deflatable ====
*
               NS = NS - 2
            ELSE
*
*              ==== Undeflatable. Move them up out of the way.
*              .    Fortunately, DTREXC does the right thing with
*              .    ILST in case of a rare exchange failure. ====
*
               IFST = NS
               CALL DTREXC( 'V', JW, T, LDT, V, LDV, IFST, ILST, WORK,
     $                      INFO )
               ILST = ILST + 2
            END IF
         END IF
*
*        ==== End deflation detection loop ====
*
         GO TO 20
      END IF
*
*        ==== Return to Hessenberg form ====
*
      IF( NS.EQ.0 )
     $   S = ZERO
*
      IF( NS.LT.JW ) THEN
*
*        ==== sorting diagonal blocks of T improves accuracy for
*        .    graded matrices.  Bubble sort deals well with
*        .    exchange failures. ====
*
         SORTED = .false.
         I = NS + 1
   30    CONTINUE
         IF( SORTED )
     $      GO TO 50
         SORTED = .true.
*
         KEND = I - 1
         I = INFQR + 1
         IF( I.EQ.NS ) THEN
            K = I + 1
         ELSE IF( T( I+1, I ).EQ.ZERO ) THEN
            K = I + 1
         ELSE
            K = I + 2
         END IF
   40    CONTINUE
         IF( K.LE.KEND ) THEN
            IF( K.EQ.I+1 ) THEN
               EVI = ABS( T( I, I ) )
            ELSE
               EVI = ABS( T( I, I ) ) + SQRT( ABS( T( I+1, I ) ) )*
     $               SQRT( ABS( T( I, I+1 ) ) )
            END IF
*
            IF( K.EQ.KEND ) THEN
               EVK = ABS( T( K, K ) )
            ELSE IF( T( K+1, K ).EQ.ZERO ) THEN
               EVK = ABS( T( K, K ) )
            ELSE
               EVK = ABS( T( K, K ) ) + SQRT( ABS( T( K+1, K ) ) )*
     $               SQRT( ABS( T( K, K+1 ) ) )
            END IF
*
            IF( EVI.GE.EVK ) THEN
               I = K
            ELSE
               SORTED = .false.
               IFST = I
               ILST = K
               CALL DTREXC( 'V', JW, T, LDT, V, LDV, IFST, ILST, WORK,
     $                      INFO )
               IF( INFO.EQ.0 ) THEN
                  I = ILST
               ELSE
                  I = K
               END IF
            END IF
            IF( I.EQ.KEND ) THEN
               K = I + 1
            ELSE IF( T( I+1, I ).EQ.ZERO ) THEN
               K = I + 1
            ELSE
               K = I + 2
            END IF
            GO TO 40
         END IF
         GO TO 30
   50    CONTINUE
      END IF
*
*     ==== Restore shift/eigenvalue array from T ====
*
      I = JW
   60 CONTINUE
      IF( I.GE.INFQR+1 ) THEN
         IF( I.EQ.INFQR+1 ) THEN
            SR( KWTOP+I-1 ) = T( I, I )
            SI( KWTOP+I-1 ) = ZERO
            I = I - 1
         ELSE IF( T( I, I-1 ).EQ.ZERO ) THEN
            SR( KWTOP+I-1 ) = T( I, I )
            SI( KWTOP+I-1 ) = ZERO
            I = I - 1
         ELSE
            AA = T( I-1, I-1 )
            CC = T( I, I-1 )
            BB = T( I-1, I )
            DD = T( I, I )
            CALL DLANV2( AA, BB, CC, DD, SR( KWTOP+I-2 ),
     $                   SI( KWTOP+I-2 ), SR( KWTOP+I-1 ),
     $                   SI( KWTOP+I-1 ), CS, SN )
            I = I - 2
         END IF
         GO TO 60
      END IF
*
      IF( NS.LT.JW .OR. S.EQ.ZERO ) THEN
         IF( NS.GT.1 .AND. S.NE.ZERO ) THEN
*
*           ==== Reflect spike back into lower triangle ====
*
            CALL DCOPY( NS, V, LDV, WORK, 1 )
            BETA = WORK( 1 )
            CALL DLARFG( NS, BETA, WORK( 2 ), 1, TAU )
            WORK( 1 ) = ONE
*
            CALL DLASET( 'L', JW-2, JW-2, ZERO, ZERO, T( 3, 1 ), LDT )
*
            CALL DLARF( 'L', NS, JW, WORK, 1, TAU, T, LDT,
     $                  WORK( JW+1 ) )
            CALL DLARF( 'R', NS, NS, WORK, 1, TAU, T, LDT,
     $                  WORK( JW+1 ) )
            CALL DLARF( 'R', JW, NS, WORK, 1, TAU, V, LDV,
     $                  WORK( JW+1 ) )
*
            CALL DGEHRD( JW, 1, NS, T, LDT, WORK, WORK( JW+1 ),
     $                   LWORK-JW, INFO )
         END IF
*
*        ==== Copy updated reduced window into place ====
*
         IF( KWTOP.GT.1 )
     $      H( KWTOP, KWTOP-1 ) = S*V( 1, 1 )
         CALL DLACPY( 'U', JW, JW, T, LDT, H( KWTOP, KWTOP ), LDH )
         CALL DCOPY( JW-1, T( 2, 1 ), LDT+1, H( KWTOP+1, KWTOP ),
     $               LDH+1 )
*
*        ==== Accumulate orthogonal matrix in order update
*        .    H and Z, if requested.  ====
*
         IF( NS.GT.1 .AND. S.NE.ZERO )
     $      CALL DORMHR( 'R', 'N', JW, NS, 1, NS, T, LDT, WORK, V, LDV,
     $                   WORK( JW+1 ), LWORK-JW, INFO )
*
*        ==== Update vertical slab in H ====
*
         IF( WANTT ) THEN
            LTOP = 1
         ELSE
            LTOP = KTOP
         END IF
         DO 70 KROW = LTOP, KWTOP - 1, NV
            KLN = MIN( NV, KWTOP-KROW )
            CALL DGEMM( 'N', 'N', KLN, JW, JW, ONE, H( KROW, KWTOP ),
     $                  LDH, V, LDV, ZERO, WV, LDWV )
            CALL DLACPY( 'A', KLN, JW, WV, LDWV, H( KROW, KWTOP ), LDH )
   70    CONTINUE
*
*        ==== Update horizontal slab in H ====
*
         IF( WANTT ) THEN
            DO 80 KCOL = KBOT + 1, N, NH
               KLN = MIN( NH, N-KCOL+1 )
               CALL DGEMM( 'C', 'N', JW, KLN, JW, ONE, V, LDV,
     $                     H( KWTOP, KCOL ), LDH, ZERO, T, LDT )
               CALL DLACPY( 'A', JW, KLN, T, LDT, H( KWTOP, KCOL ),
     $                      LDH )
   80       CONTINUE
         END IF
*
*        ==== Update vertical slab in Z ====
*
         IF( WANTZ ) THEN
            DO 90 KROW = ILOZ, IHIZ, NV
               KLN = MIN( NV, IHIZ-KROW+1 )
               CALL DGEMM( 'N', 'N', KLN, JW, JW, ONE, Z( KROW, KWTOP ),
     $                     LDZ, V, LDV, ZERO, WV, LDWV )
               CALL DLACPY( 'A', KLN, JW, WV, LDWV, Z( KROW, KWTOP ),
     $                      LDZ )
   90       CONTINUE
         END IF
      END IF
*
*     ==== Return the number of deflations ... ====
*
      ND = JW - NS
*
*     ==== ... and the number of shifts. (Subtracting
*     .    INFQR from the spike length takes care
*     .    of the case of a rare QR failure while
*     .    calculating eigenvalues of the deflation
*     .    window.)  ====
*
      NS = NS - INFQR
*
*      ==== Return optimal workspace. ====
*
      WORK( 1 ) = DBLE( LWKOPT )
*
*     ==== End of DLAQR2 ====
*
      END
c $Id: dlaqr2.f 24343 2013-06-22 05:35:15Z d3y133 $

*
* $Id: berry_phase_pol.F 19707 2010-10-29 17:59:36Z d3y133 $
*
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Polarization calculated through Berry's Phase Approach
c  This is really simple since we have the Silvestrelli Overlap
c  Matrix routine from pspw_wannier. 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine berry_phase_pol(psi,psir)
      implicit none
      integer psi(2),psir(2)
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
      integer i,npack1,nfft3d,n2fft,nesq,idir,ms,ispin,ne(2)
      integer pivs(2),smat(2),nemax,info,n,ik,j
      real*8 pol(3,3),tx,ty,tz,ex,ey,ez,dx,dy,dz,tmp
      real*8 gs,g(3),dv
      complex*16 det
      logical val
ccccc external ccccccccccccccccccccccccccc
      integer ion_katm,ion_nion
      real*8 ion_rion,psp_zv,lattice_unitg,lattice_omega
      external ion_katm,ion_nion
      external ion_rion,psp_zv,lattice_unitg,lattice_omega
cccccccccccccccccccccccccccccccccccccccccc
c      VAL=MA_SET_AUTO_VERIFY(.TRUE.)
ccccccccccccccccccccccccccccccccccccccccccc
      call Pack_npack(1,npack1)
      call D3db_nfft3d(1,nfft3d)
      call psi_get_ne(ispin,ne)
      n2fft=nfft3d*2
      nesq=ne(1)*ne(1)*2
      val=MA_push_get(mt_int,ne(1),'pivs',pivs(2),pivs(1))
      val=val.and.MA_push_get(mt_dcpl,nesq,'smat',smat(2),smat(1))
      if (.not.val) then
        call errquit("berry_phase_pol: stack depleted",0,0)
      end if
      nemax = ne(1)+ne(2)
      do n=1,nemax
         call Pack_c_Copy(1,dcpl_mb(psi(1)+(n-1)*npack1),
     >                       dbl_mb(psir(1)+(n-1)*n2fft))
      end do
      call Grsm_gh_fftb(nfft3d,nemax,dbl_mb(psir(1)))
      call Grsm_h_Zero_Ends(nfft3d,nemax,dbl_mb(psir(1)))
      do idir=1,3
         det=dcmplx(1.0d0,0.0d0)
         g(1)=lattice_unitg(1,idir)
         g(2)=lattice_unitg(2,idir)
         g(3)=lattice_unitg(3,idir) 
         gs=(g(1)*g(1)+g(2)*g(2)+g(3)*g(3))
         if (dabs(gs).lt.1.d-12) then
           call errquit("g too small!",0,0)
         end if
         gs=1.d0/gs
         do ms=1,ispin
            call silvestrelli_overlap(g,ne(ms),
     &          dbl_mb( psir(1)+(ms-1)*n2fft*ne(1) ),
     &          dcpl_mb(smat(1)))
            call zgetrf(ne(ms),ne(ms),dcpl_mb(smat(1)),
     &         ne(ms),int_mb(pivs(1)),info)
            if (info.ne.0) then
              call errquit("berry_phase_pol:failed",0,0)
            end if
            do i=1,ne(ms)
              det=det*dcpl_mb(smat(1)+(i-1)*ne(ms)+i-1)
            end do
         end do
         tmp= -datan2(dimag(det),dble(det))
         if (ispin.eq.1) then 
           tmp=tmp*2.0d0
         end if 
         pol(1,idir)= tmp*g(1)*gs
         pol(2,idir)= tmp*g(2)*gs
         pol(3,idir)= tmp*g(3)*gs 
      end do
      dx=0.0d0
      dy=0.0d0
      dz=0.0d0
      do i=1,ion_nion()
        ik=ion_katm(i)
        dx=dx+psp_zv(ik)*ion_rion(1,i)
        dy=dy+psp_zv(ik)*ion_rion(2,i)
        dz=dz+psp_zv(ik)*ion_rion(3,i)
      end do
      ex=0.0d0
      ey=0.0d0
      ez=0.0d0
      do i=1,3
         ex=ex+pol(1,i)
         ey=ey+pol(2,i)
         ez=ez+pol(3,i)
      end do
      tx=dx-ex
      ty=dy-ey
      tz=dz-ez
c      if (nodeid.eq.MASTER) then
      write(6,*)"--------------------------------"
      write(6,*)"Berry Phase Results for the"
      write(6,*)"Components of the Polarization Tensor"
      write(6,1000)pol(1,1),pol(2,1),pol(3,1) 
      write(6,1000)pol(1,2),pol(2,2),pol(3,2) 
      write(6,1000)pol(1,3),pol(2,3),pol(3,3) 
      write(6,*)"--------------------------------"
      write(6,*)"Electronic DelP = P Omega in"
      write(6,*)"Cartesian Cooridinates"
      write(6,*)"--------------------------------"
      write(6,*)"Nuclear"
      write(6,1000)dx,dy,dz
      tmp=dsqrt(dx*dx+dy*dy+dz*dz)
      write(6,1010)tmp
      write(6,*)"Electronic"
      write(6,1000)ex,ey,ez
      tmp=dsqrt(ex*ex+ey*ey+ez*ez)
      write(6,1010)tmp
      write(6,*)"Total"
      write(6,1000)tx,ty,tz
      tmp=dsqrt(tx*tx+ty*ty+tz*tz)
      write(6,1010)tmp
      call flush(6)
c      end if
      val=MA_pop_stack(smat(2))
      val=val.and.MA_pop_stack(pivs(2))
      if (.not.val) then
        call errquit("berry_phase_pol: pop stack failed!",0,0)
      end if
1000  format("x= ",d15.6," y= ",d15.6," z= ",d15.6)
1010  format("|mu|= ",d15.6)
      return
      end
ccccccccccccc
 
             
             

      SUBROUTINE vib_WRTFREQ(rtdb,EIGVAL,NAT3,ZEROPE,NPRI)
* $Id: vib_wrtfreq.F 25619 2014-05-14 23:57:23Z bylaska $
C
C This routine scales the eigenvalues properly and then converts them
C      to wavenumbers
C
      IMPLICIT none
#include "errquit.fh"
c
#include "rtdb.fh"
#include "stdio.fh"
#include "mafdecls.fh"
c
      integer rtdb
      integer nat3
      LOGICAL ZEROPE
      integer npri
      double precision EIGVAL(NAT3)    ! eigenvalues
c
      integer maxfrq
      PARAMETER (MAXFRQ = 2000)
      double precision d1, d2
      PARAMETER(D1=1.0D00,D2=2.0D00)
      double precision ams, wave
      integer numans
      COMMON /cvib_SETCON/ AMS(36),WAVE,NUMANS      ! setup parameters
      double precision PRFREQ(MAXFRQ)    ! freqencies to be written to tape10
c
      double precision scale, dd1, zero, sumfreq, rate, xdum, freq, zpe
      double precision ezero,ethermal,hthermal,temp,thetav
      double precision inertia_A,inertia_B,inertia_C,thetaA,thetaB,
     ,     thetaC,M
      double precision Strans,Srot,Svib,scalefreq
      double precision Cv_trans,Cv_rot,Cv_vib
      integer sigma
      integer i,it,ntemp,h_actlist,l_actlist,ma_type
      logical linear

*     ****  conversions and constants ****
      double precision AUKCAL,c,h,kgas,Rgas,inertprod
      parameter (AUKCAL=627.5093314d0)
      parameter (c=2.998e+10,h=6.626e-27,kgas=1.3807e-16)   ! cgs units
      parameter (Rgas = 1.9863d0/1000.0d0/AUKCAL)           ! atomic units

c
*rak:      ITAP96 = 96
c: error check :
      if (nat3.gt.maxfrq) then
c        dimension problems
        write(luout,*)' maxfrq = ',maxfrq
        write(luout,*)' nat3   = ',nat3
        write(luout,*)' increase maxfrq to ',nat3
        call errquit('vib_wrtfreq:',nat3, INPUT_ERR)
        stop ' error'
      endif
C
C Scale eigenvalues down by 1000
C
      SCALE = 1.0D-03   ! Scaling factor after diagonaization
      call dscal(nat3,scale,eigval,1) ! Scale eigenvalues
C
      DD1 = D1          ! used with dsign function
C      WRITE(6,10000)    ! write header
10000 FORMAT(//,1X,31('-'),' Vibrations ',31('-'),/,
     +5X,'#',6X,'Eigenvalue',14X,'Frequency (cm**-1)',/,1X,74('-'))
10001 FORMAT(1X,I5,D20.10,F20.3)
      ZERO=0.0D00
      SUMFREQ=zero
      RATE=2.860D-03    ! Note that there is a slight error in this conversion - RATE = R*h*c/k = 2.857778587 kcal/mol 
      DO 00100 I=1,NAT3 ! loop over coordinates
         XDUM = EIGVAL(I) ! eigenvalue
         FREQ = SIGN(DD1,XDUM)*SQRT(ABS(XDUM))*WAVE ! form frequency
         PRFREQ(I) = FREQ
C         WRITE(6,10001,ERR=00099)I,XDUM,FREQ ! write it out
         EIGVAL(I) = FREQ
         IF(ZEROPE) THEN
            IF (FREQ.GT.ZERO)THEN
              SUMFREQ=SUMFREQ+FREQ
            ENDIF
         END IF
         GO TO 00100
C00099    WRITE(6,*)EIGVAL(I),FREQ  ! in case of error with format
00100 CONTINUE
      IF(ZEROPE)THEN
        ZPE=0.5D00*SUMFREQ*RATE

         !**** removed bad ZPE printout ...EJB***
c        WRITE (6,10002)ZPE
c        call ecce_print1('zero point energy',mt_dbl,zpe,1)
c        if(.not. rtdb_put(rtdb,'vib:zpe',MT_DBL,1,zpe))
c     &      call errquit('vib_wrtfreq:rtdb_put of ZPE failed',
c     &      555, RTDB_ERR)
      ENDIF
10002 FORMAT(1X,//,'From the projected analysis ',/,
     &    'The Zero-Point Energy (Kcal/mol) = ',
     &    f20.8)


*     ********************************************************
*     **** Cannoncial Partition Equations for Ideal       ****
*     **** polyatomic gas                                 ****
*     ********************************************************
      IF(ZEROPE)THEN

*       *** define rotational constants ****
        call vib_geom_parameters_get(rtdb,M,
     >     inertia_A,inertia_B,inertia_C,sigma,linear)
        thetaA = inertia_A*(h*c/kgas)
        thetaB = inertia_B*(h*c/kgas)
        thetaC = inertia_C*(h*c/kgas)
        write(6,10010) 
        write(6,10011) inertia_A,thetaA
        write(6,10012) inertia_B,thetaB
        write(6,10013) inertia_C,thetaC
10010 FORMAT(/1X,'Rotational Constants',
     >       /1X,'--------------------')
10011 FORMAT( 1X,'A= ',f10.6,' cm-1  (',f10.6,' K)')
10012 FORMAT( 1X,'B= ',f10.6,' cm-1  (',f10.6,' K)')
10013 FORMAT( 1X,'C= ',f10.6,' cm-1  (',f10.6,' K)')
       
*       *** define scalefreq ***
        if(.not. rtdb_get(rtdb,'vib:scalefreq',MT_DBL,1,scalefreq))
     &      scalefreq = 1.0d0

*        **** define temperatures
         if (.not. rtdb_ma_get(rtdb, 'vib:temperature', ma_type,
     >        ntemp, h_actlist)) then
            ntemp = 1

            if (.not.MA_alloc_get(mt_dbl,(ntemp),'temp',
     >                            h_actlist,l_actlist))
     >      call errquit(
     >       'vib_WRTFREQ: ma_get_index failed for actlist',911, MA_ERR)

            dbl_mb(l_actlist) = 298.15d0
         else        

            if (.not.MA_get_index(h_actlist,l_actlist))
     >      call errquit(
     >       'vib_WRTFREQ: ma_get_index failed for actlist',911, MA_ERR)
         end if

        do it=1,ntemp
        temp = dbl_mb(l_actlist+it-1)

*       ********************************************************
*       **** Write out thermal Corrections to Energies      ****
*       **** frequencies are assumed to be in units of cm-1 ****
*       ********************************************************
        ezero    = 0.0d0
        ethermal = 0.0d0

*       **** add vibrational thermal corrections ***
        do i=1,nat3
            
          freq = scalefreq*eigval(i) ! eigenvalue

          if (freq.gt.0.1d0) then
            thetav = freq*(h*c/kgas)    !freqency temperature in Kelvin from cm-1
            if (temp.gt.zero) then
              xdum   = exp(-thetav/temp)
            else
              xdum = 0.0d0
            end if
            xdum   = xdum/(1.0d0-xdum)
            ezero    = ezero    + 0.5d0*thetav
            ethermal = ethermal + thetav*(0.5d0 + xdum)
          end if
        end do
        ezero    = ezero*Rgas
        ethermal = ethermal*Rgas

        if (linear) then
        ethermal = ethermal + 2.5d0*Rgas*temp ! add translational(3/2RT) and rotation(2/2RT) thermal corrections
        else
        ethermal = ethermal + 3.0d0*Rgas*temp ! add translational(3/2RT) and rotation(3/2RT) thermal corrections
        end if

        hthermal = ethermal + Rgas*temp       ! htermal = ethermal+pV=ethermal+RT, since pV=RT
       
        WRITE (6,10023) temp
        WRITE (6,10022) scalefreq
        if (linear) then
           write(6,10027)
           if (.not.rtdb_put(rtdb,'vib:linear',mt_log,1,.true.))
     &        call errquit('vib: failed to set linear',555, RTDB_ERR)
        endif
        WRITE (6,10024) ezero*AUKCAL,   ezero
        WRITE (6,10025) ethermal*AUKCAL,ethermal
        WRITE (6,10026) hthermal*AUKCAL,hthermal
10022 FORMAT(1X,'frequency scaling parameter      = ',f8.4)
10023 FORMAT(//1X,'Temperature                      = ',f8.2,'K')
10024 FORMAT(/1X,'Zero-Point correction to Energy  = ',f8.3, 
     .     ' kcal/mol  (',f10.6,' au)')
10025 FORMAT( 1X,'Thermal correction to Energy     = ',f8.3, 
     .     ' kcal/mol  (',f10.6,' au)')
10026 FORMAT( 1X,'Thermal correction to Enthalpy   = ',f8.3, 
     .     ' kcal/mol  (',f10.6,' au)')
10027 FORMAT(//1X,'Linear Molecule                   ')

*     ********************************************************
*     **** Write out Entropies                            ****
*     **** frequencies are assumed to be in units of cm-1 ****
*     **** Formulas taken from Herzberg                   ****
*     ********************************************************

        Cv_trans = (3.0d0/2.0d0)*Rgas
        Strans = (5.0d0/2.0d0)*Rgas*log(temp)
     >         + (3.0d0/2.0d0)*Rgas*log(M) 
     >         - 2.3135d0/AUKCAL/1000.0d0
        inertprod=inertia_A*inertia_B*inertia_C
        if (abs(inertprod).lt.1d-9) then
           Cv_rot = (2.0d0/2.0d0)*Rgas
           Srot=0.0d0
           if (linear) then
             Srot   = (Rgas)*(  log(temp) 
     >                        - log(inertia_C) 
     >                        - log(dble(sigma))) 
     >              + 1.2639d0/AUKCAL/1000.0d0
           end if
        else
           Cv_rot = (3.0d0/2.0d0)*Rgas
           Srot   = (Rgas/2.0d0)*( 3.0d0*log(temp) -
     >          log(inertprod) -
     >          2.0d0*log(dble(sigma))) +
     >           3.0327d0/AUKCAL/1000.0d0
        endif

*       **** add up vibrational contributions ****
        Cv_vib = 0.0d0
        Svib   = 0.0d0
        if (temp.gt.0.0d0) then
        do i=1,nat3

          freq = scalefreq*eigval(i) ! eigenvalue

          if (freq.gt.(0.1d0)) then
            thetav = freq*(h*c/kgas)    !freqency temperature in Kelvin from cm-1
            xdum   = thetav/temp
c  fix to take avoid abnormal values
            if(xdum.lt.20d0*2.3025d0) then
            Cv_vib = Cv_vib + exp(xdum)* (xdum/(exp(xdum)-1.0d0))**2 
            Svib   = Svib + xdum/(exp(xdum)-1.0d0)   
     >             - log(1.0d0-exp(-xdum))
            endif
          end if
        end do
        end if
        Cv_vib = Cv_vib*Rgas
        Svib   = Svib*Rgas


        write(6,10030) (Strans+Srot+Svib)*AUKCAL*1000.0d0
        write(6,10031) Strans*AUKCAL*1000.0d0,M
        write(6,10032) Srot*AUKCAL*1000.0d0,sigma
        write(6,10033) Svib*AUKCAL*1000.0d0
10030   FORMAT(/1X,'Total Entropy                    = ',f8.3,
     .       ' cal/mol-K')
10031   FORMAT( 1X,'  - Translational                = ',f8.3,
     .       ' cal/mol-K (mol. weight =',f9.4,')')
10032   FORMAT( 1X,'  - Rotational                   = ',f8.3,
     .       ' cal/mol-K (symmetry #  =',I9,  ')')
10033   FORMAT( 1X,'  - Vibrational                  = ',f8.3,
     .       ' cal/mol-K')

        write(6,10040) (Cv_trans+Cv_rot+Cv_vib)*AUKCAL*1000.0d0
        write(6,10041) Cv_trans*AUKCAL*1000.0d0
        write(6,10042) Cv_rot*AUKCAL*1000.0d0
        write(6,10043) Cv_vib*AUKCAL*1000.0d0
10040   FORMAT(/1X,'Cv (constant volume heat capacity) = ',f8.3,
     .       ' cal/mol-K')
10041   FORMAT( 1X,'  - Translational                  = ',f8.3,
     .       ' cal/mol-K')
10042   FORMAT( 1X,'  - Rotational                     = ',f8.3,
     .       ' cal/mol-K')
10043   FORMAT( 1X,'  - Vibrational                    = ',f8.3,
     .       ' cal/mol-K')

       end do !it loop

*      *** free heap ***
       if (.not. MA_free_heap(h_actlist))
     >   call errquit('h_actlist:error freeing heap memory',0, MA_ERR)

      END IF
*rak:      IF (NPRI.EQ.0) WRITE (ITAP96,10002)ZPE
*rak:      GO TO 00096
*rak:      ELSE
*rak:      END IF
C
00096 RETURN                    ! go home
      END

      subroutine vib_geom_parameters_get(rtdb,M,AA,BB,CC,sigma,linear)
      implicit none
#include "errquit.fh"
      integer rtdb
      double precision M,AA,BB,CC
      integer          sigma
      logical          linear


#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "sym.fh"

*     **** local variables ****
      integer          geom,natoms,ii,nops
      double precision amass,meig(3),mtensor(3,3),q,qt
      integer          r1(2)
      integer          lwork,ierr
      parameter (lwork=9)
      double precision work(lwork)
      character*16 t
      double precision fconv,eps

*     ****  conversions and constants ****
      double precision AUKCAL,c,h,kgas,Rgas
      parameter (AUKCAL=627.5093314d0)
      parameter (c=2.998e+10,h=6.626e-27,kgas=1.3807e-16)   ! cgs units
      parameter (Rgas = 1.9863d0/1000.0d0/AUKCAL)           ! atomic units
      parameter (fconv=4.6497791d-41, eps=1d-9)

*     **** external functions ****
      double precision deter3
      external         deter3


      if (.not.geom_create(geom,'geometry')) call errquit
     &    ('vib_geom_parameters_get: error creating geometry',911,
     &       GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'geometry')) call errquit
     &    ('vib_geom_parameters_get: error loading geometry',911,
     &       RTDB_ERR)
      if (.not.geom_ncent(geom,natoms)) call errquit
     &    ('vib_geom_parameters_get: errorgetting number of atoms',911,
     &       GEOM_ERR)

*     **** calculate the symmetry number ****
      nops  = sym_number_ops(geom)
      if (.not. MA_push_get(mt_dbl,(nops*3*4),'r1',r1(2),r1(1)))
     >   call errquit('vib_geom_parameters_set: push stack',0, MA_ERR)
      call sym_ops_get(geom,nops,dbl_mb(r1(1)))
      sigma = 1                                                 ! Identity not included
      do ii=1,nops
        mtensor(1,1) = dbl_mb(r1(1)+ (ii-1)*3 + 0 + 0*(nops*3)) !crazy format
        mtensor(2,1) = dbl_mb(r1(1)+ (ii-1)*3 + 1 + 0*(nops*3))
        mtensor(3,1) = dbl_mb(r1(1)+ (ii-1)*3 + 2 + 0*(nops*3))
        mtensor(1,2) = dbl_mb(r1(1)+ (ii-1)*3 + 0 + 1*(nops*3))
        mtensor(2,2) = dbl_mb(r1(1)+ (ii-1)*3 + 1 + 1*(nops*3))
        mtensor(3,2) = dbl_mb(r1(1)+ (ii-1)*3 + 2 + 1*(nops*3))
        mtensor(1,3) = dbl_mb(r1(1)+ (ii-1)*3 + 0 + 2*(nops*3))
        mtensor(2,3) = dbl_mb(r1(1)+ (ii-1)*3 + 1 + 2*(nops*3))
        mtensor(3,3) = dbl_mb(r1(1)+ (ii-1)*3 + 2 + 2*(nops*3))
        q = deter3(mtensor) 
        if (abs(q-1.0d0) .lt. 1.0d-6) sigma = sigma+1
      end do

      if (.not. MA_pop_stack(r1(2)))
     >  call errquit('vib_geom_parameters_set: pop stack',1, MA_ERR)


*     ***** calculate molecular weight ****
      M = 0.0d0     
      do ii=1,natoms
         if(.not.geom_mass_get(geom, ii, amass)) call
     &        errquit(' mass_get  failed ',ii, GEOM_ERR)
         M = M + amass
      enddo

*     ***** calculate inertia tensor ****
      if (.not. MA_push_get(mt_dbl,(3*natoms),'r1',r1(2),r1(1)))
     >   call errquit('vib_geom_parameters_set: push stack',2, MA_ERR)

      call dcopy(3*natoms,0.0d0,0,dbl_mb(r1(1)),1)
      do ii=1,natoms
         if (.not.geom_cent_get(geom,ii,t,dbl_mb(r1(1)+(ii-1)*3),q))
     >   call errquit('vib_geom_parameters_set: error reading ions',0,
     &       GEOM_ERR)
      end do

      call geom_momint0(geom,dbl_mb(r1(1)),natoms,meig,mtensor,.true.,
     .     .false.,.false.)

      if (.not. MA_pop_stack(r1(2)))
     >  call errquit('vib_geom_parameters_set: pop stack',3, MA_ERR)
      call DSYEV('N','U',3,mtensor,3,meig,work,lwork,ierr)

      !meig(1) = fconv*meig(1)  ! convert to cgs units
      !meig(2) = fconv*meig(2)
      !meig(3) = fconv*meig(3)

      q = 4.0d0*datan(1.0d0)
      q = 8.0d0*q*q             ! 8*pi^2
      q = h/(q*c)               ! h/(8*pi^2*c) - there is an error in old McQuarrie

      q = q/fconv               ! convert to cgs units

      AA = 0.0d0
      BB = 0.0d0
      CC = 0.0d0
      if(abs(meig(1)).gt.eps) AA = q/meig(1)    ! in units of cm-1
      if(abs(meig(2)).gt.eps) BB = q/meig(2)
      if(abs(meig(3)).gt.eps) CC = q/meig(3)

      linear = .false.
      if ((AA.le.eps).and.((BB-CC).le.eps)) linear = .true.


*     **** recalculate the symmetry number  - Dinfh = 2, Cinfh = 1 ****
      if (linear) then

        nops  = sym_number_ops(geom)
        if (.not. MA_push_get(mt_dbl,(nops*3*4),'r1',r1(2),r1(1)))
     >     call errquit('vib_geom_parameters_set: push stack',4, MA_ERR)
        call sym_ops_get(geom,nops,dbl_mb(r1(1)))
        sigma = 1                                                 ! Identity not included
        do ii=1,nops
          mtensor(1,1) = dbl_mb(r1(1)+ (ii-1)*3 + 0 + 0*(nops*3)) !crazy format
          mtensor(2,1) = dbl_mb(r1(1)+ (ii-1)*3 + 1 + 0*(nops*3))
          mtensor(3,1) = dbl_mb(r1(1)+ (ii-1)*3 + 2 + 0*(nops*3))
          mtensor(1,2) = dbl_mb(r1(1)+ (ii-1)*3 + 0 + 1*(nops*3))
          mtensor(2,2) = dbl_mb(r1(1)+ (ii-1)*3 + 1 + 1*(nops*3))
          mtensor(3,2) = dbl_mb(r1(1)+ (ii-1)*3 + 2 + 1*(nops*3))
          mtensor(1,3) = dbl_mb(r1(1)+ (ii-1)*3 + 0 + 2*(nops*3))
          mtensor(2,3) = dbl_mb(r1(1)+ (ii-1)*3 + 1 + 2*(nops*3))
          mtensor(3,3) = dbl_mb(r1(1)+ (ii-1)*3 + 2 + 2*(nops*3))
          q = deter3(mtensor)
          qt = mtensor(1,1)+mtensor(2,2)+mtensor(3,3)
          if ((abs(q+1.0d0).lt.1.0d-6).and.(abs(qt+3.0d0).lt.1.0d-6))
     >       sigma = 2
        end do
        if (.not. MA_pop_stack(r1(2)))
     >    call errquit('vib_geom_parameters_set: pop stack',5, MA_ERR)

      end if
*
      if (.not.geom_destroy(geom)) call errquit
     &    ('vib_geom_parameters_get: geom_destroy failed',911, GEOM_ERR)

      return
      end

      SUBROUTINE GAL_DLASWP( N, A, LDA, K1, K2, IPIV, INCX )
*
*  -- LAPACK auxiliary routine (version 1.1) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCX, K1, K2, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  GAL_DLASWP performs a series of row interchanges on the matrix A.
*  One row interchange is initiated for each of rows K1 through K2 of A.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the matrix of column dimension N to which the row
*          interchanges will be applied.
*          On exit, the permuted matrix.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*
*  K1      (input) INTEGER
*          The first element of IPIV for which a row interchange will
*          be done.
*
*  K2      (input) INTEGER
*          The last element of IPIV for which a row interchange will
*          be done.
*
*  IPIV    (input) INTEGER array, dimension (M*abs(INCX))
*          The vector of pivot indices.  Only the elements in positions
*          K1 through K2 of IPIV are accessed.
*          IPIV(K) = L implies rows K and L are to be interchanged.
*
*  INCX    (input) INTEGER
*          The increment between successive values of IPIV.  If IPIV
*          is negative, the pivots are applied in reverse order.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IP, IX
*     ..
*     .. External Subroutines ..
      EXTERNAL           GAL_DSWAP
*     ..
*     .. Executable Statements ..
*
*     Interchange row I with row IPIV(I) for each of rows K1 through K2.
*
      IF( INCX.EQ.0 )
     $   RETURN
      IF( INCX.GT.0 ) THEN
         IX = K1
      ELSE
         IX = 1 + ( 1-K2 )*INCX
      END IF
      IF( INCX.EQ.1 ) THEN
         DO 10 I = K1, K2
            IP = IPIV( I )
            IF( IP.NE.I )
     $         CALL GAL_DSWAP( N, A( I, 1 ), LDA, A( IP, 1 ), LDA )
   10    CONTINUE
      ELSE IF( INCX.GT.1 ) THEN
         DO 20 I = K1, K2
            IP = IPIV( IX )
            IF( IP.NE.I )
     $         CALL GAL_DSWAP( N, A( I, 1 ), LDA, A( IP, 1 ), LDA )
            IX = IX + INCX
   20    CONTINUE
      ELSE IF( INCX.LT.0 ) THEN
         DO 30 I = K2, K1, -1
            IP = IPIV( IX )
            IF( IP.NE.I )
     $         CALL GAL_DSWAP( N, A( I, 1 ), LDA, A( IP, 1 ), LDA )
            IX = IX + INCX
   30    CONTINUE
      END IF
*
      RETURN
*
*     End of GAL_DLASWP
*
      END

      subroutine mrcc_daxfile(n,coefficients,d_in,d_out,size,iref)
c
c     A linear combination of files
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_mrcc.fh"
#include "tce_mrcc_diis.fh"
#include "tce_main.fh"

      integer n
      integer d_in(maxdiism,maxref)
      integer d_out
      integer size
      integer nblocks,blocksize
      integer l_temp1,k_temp1
      integer l_temp2,k_temp2
      integer i,j,k,l
      logical nodezero
      double precision coefficients(*)
      logical dinisga, doutisga
      integer nxtask, next, nprocs, count
      external nxtask
      integer nxtasksub
      external nxtasksub
      logical noloadbalance
      integer iref

      if (ioalg.ne.2)
     1  call errquit('unable to dax non-GA file',0,UNKNOWN_ERR)

      nodezero = (ga_nodeid().eq.0)

      nblocks = size/buffer_size

      if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
      blocksize = size/nblocks
      if (nblocks*blocksize.lt.size) blocksize = blocksize + 1

cjb HERE
        if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1    l_temp1,k_temp1))
     2    call errquit('daxfile: MA problem',0,MA_ERR)

        if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1    l_temp2,k_temp2))
     2    call errquit('daxfile: MA problem',1,MA_ERR)

        count = 0
        if(lusesub) then
          nprocs = GA_pgroup_NNODES(mypgid)
          next = NXTASKsub(nprocs,1,mypgid)
        else
          nprocs = GA_NNODES()
          next = NXTASK(nprocs,1)
        endif

        do i = 1,nblocks
          if (next.eq.count) then
            if (util_print('daxfile',print_debug))
     1        write(LuOut,9210) ga_nodeid(),(i-1)*blocksize,
     2                          min(size,i*blocksize)-(i-1)*blocksize
            k = 0
            do j = (i-1)*blocksize+1,min(size,i*blocksize)
              k = k + 1
              dbl_mb(k_temp1+k-1) = 0.0d0
            enddo
            do l = 1,n
              call get_block(d_in(l,iref),dbl_mb(k_temp2),
     1          min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
              k = 0
              do j = (i-1)*blocksize+1,min(size,i*blocksize)
                k = k + 1
                dbl_mb(k_temp1+k-1) = dbl_mb(k_temp1+k-1) 
     1          + coefficients(l) * dbl_mb(k_temp2+k-1)
              enddo
            enddo
            call put_block(d_out,dbl_mb(k_temp1),
     1        min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
          if(lusesub) then
            next = NXTASKsub(nprocs,1,mypgid)
          else
            next = NXTASK(nprocs,1)
          endif
          endif
          count = count + 1
        enddo

          if(lusesub) then
            next = NXTASKsub(-nprocs,1,mypgid)
            call ga_pgroup_sync(mypgid)
          else
            next = NXTASK(-nprocs,1)
            call ga_sync()
          endif

        if (.not.ma_pop_stack(l_temp2))
     1    call errquit('createfile: MA problem',2,MA_ERR)

        if (.not.ma_pop_stack(l_temp1))
     1    call errquit('createfile: MA problem',3,MA_ERR)

 9180 format(/,1x,'  input file handle:',i10,' size:',i10,
     1            ' coefficient:',f15.10)
 9190 format(/,1x,' output file handle:',i10,' size:',i10)
 9200 format(  1x,'            nblocks:',i10,' size:',i10)
 9210 format(  1x,i3,'          offset:',i10,' size:',i10)
      return
      end
c $Id: tce_mrcc_daxfile.F 24345 2013-06-22 06:19:30Z d3y133 $

      subroutine atscf_atomic_scf(geom, basis, iat, oprint,
     $     nl_out, ncsh_out, nosh_out, nccup_out, nbc_out,
     $     cc_out, energy_out, eps_out,spec)
      implicit none
#include "errquit.fh"
* $Id: atscf_atscf.F 19708 2010-10-29 18:04:21Z d3y133 $
#include "geom.fh"
#include "bas.fh"
#include "cguess.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "util.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "stdio.fh"
      integer geom, basis       ! [input] Handles
      integer iat               ! [input] Atom number in NWChem numbering
      logical oprint,spec       ! [input] If true the SCF prints stuff
      integer nl_out            ! [output] No. of angular momenta (= sym)
      integer ncsh_out(*)       ! [output] No. of closed shells per sym
      integer nosh_out(*)       ! [output] No. of open shells per sym
      integer nccup_out(*)      ! [output] Occupation no. of open shells
      integer nbc_out(*)        ! [output] No. of basis shells per sym
      double precision cc_out(*) ! [output] MO coefficients
      double precision energy_out ! [output] Energy
      double precision eps_out(*) ! [output] Orbital energies
c
c     Perform an atomic SCF for a given atom and return energetics
c     and enough information to reconstruct the wavefunction
c
      integer l2
      integer ntr, nsq
      integer i10, ipcap, iqcap, ifc, ifo, is, iu, it, i
      integer ih, idc, idos, idt, idold, iss, ic, icopn, ismin
      integer iqmin, itransf, icc, last, memq, l_scr, k_scr
c
      integer ii, ii_out, ieps, ieps_out
c
c     allow for maximum of 100 bfns (NWChem shells) on any given atom
c
      ntr = nb*(nb+1)/2
      l2 = ntr
      nsq = nb * nb
c
c     dynamically allocate memory
c
      call guess_mem(memq)
      if (.not. ma_push_get(mt_dbl, memq,'atomic guess', l_scr, k_scr))
     $     call errquit('atomscf:guess_dens: ma_push failed', memq,
     &       MA_ERR)
      call dfill(memq,0.0d00,dbl_mb(k_scr),1)
c
c     This is verbatim from denat
c
      i10 = k_scr
      ipcap = i10 + l2
      iqcap = ipcap + ntr
      ifc = iqcap + ntr
      ifo = ifc + ntr
      is = ifo + ntr
      iu = is + ntr
      it = iu + ntr
      ih = it + ntr
      idc = ih + ntr
      idos = idc + ntr
      idt = idos + ntr
      idold = idt + ntr
      iss = idold + ntr
      ic = iss + ntr
c
      icopn = ic + nsq
      ismin = icopn + nsq
      iqmin = ismin + nb * no
      itransf = iqmin + nb * no
      icc = itransf + nsq
      last = icc + nsq
      if ((last - i10) .gt. memq) call errquit
     $     ('atomscf:guess_dens: memory?', memq, MEM_ERR)
c..
      call atscf_do_atscf(geom, basis, iat,
     $     dbl_mb(i10), oprint,
     +     dbl_mb(ipcap), dbl_mb(iqcap), dbl_mb(ifc), dbl_mb(ifo), 
     $     dbl_mb(is), dbl_mb(iu), 
     +     dbl_mb(it), dbl_mb(ih), dbl_mb(idc), dbl_mb(idos), 
     $     dbl_mb(idt), dbl_mb(idold), dbl_mb(iss) ,
     +     dbl_mb(ic), dbl_mb(icopn), dbl_mb(ismin), dbl_mb(iqmin), 
     $     dbl_mb(itransf), dbl_mb(icc), nb,spec)
c
c     Copy stuff into output arguments
c
      energy_out = energ
      nl_out = nsym             ! Highest basis ang. mom. (s=1,p=2,d=3,f=4)
      ii     = icc
      ii_out = 1
      ieps     = 1
      ieps_out = 1
      do i = 1, nsym
         ncsh_out(i) = ncsh(i)
         nosh_out(i) = nosh(i)
         nccup_out(i)= nccup(i)
         nbc_out(i)  = nbc(i)
c     Copy only occupied orbitals and eigenvalues
         call dcopy(nbc(i)*(ncsh(i)+nosh(i)),dbl_mb(ii),1,
     $        cc_out(ii_out),1)
         ii     = ii     + nbc(i)*nbc(i)
         ii_out = ii_out + nbc(i)*(ncsh(i)+nosh(i))
         call dcopy(ncsh(i)+nosh(i),eps(ieps),1,eps_out(ieps_out),1)
         ieps     = ieps     + ncsh(i)+nosh(i)
         ieps_out = ieps_out + ncsh(i)+nosh(i)
      enddo 
c
      if (oprint) then
c
c     This only to debug this interface
c
         write(6,*) ' Atomic SCF for atom ', iat
         write(6,*) ' nl_out    ', nl_out
         write(6,*) ' ncsh   ', (ncsh_out(i),i=1,nl_out)
         write(6,*) ' nosh   ', (nosh_out(i),i=1,nl_out)
         write(6,*) ' nccup  ', (nccup_out(i),i=1,nl_out)
         write(6,*) ' nbc    ', (nbc_out(i),i=1,nl_out)
         write(6,*) ' energy ', energy_out
         ii_out   = 1
         ieps_out = 1
         do i = 1, nl_out
            write(6,*) ' Occupied eigenvalues for symmetry ', i
            call output(eps_out(ieps_out),1,(ncsh_out(i)+nosh_out(i)),
     $           1,1,nbc_out(i),1,1)
            ieps_out = ieps_out + (ncsh_out(i)+nosh_out(i))
            write(6,*) ' Occupied eigenvectors for symmetry ', i
            call output(cc_out(ii_out),1,nbc_out(i),
     $           1,(ncsh_out(i)+nosh_out(i)), nbc_out(i),nbc_out(i),1)
            ii_out = ii_out + nbc(i)*(ncsh(i)+nosh(i))
         enddo
      endif
c
      if (.not. ma_pop_stack(l_scr))
     $     call errquit
     &    ('atomscf:guess_dens: pop_stack failed', 0, MEM_ERR)
c
      end
      subroutine atscf_do_atscf(geom, basis, iat,
     $     hatom, oprin,
     +     pcap, qcap, fc, fo, s, u, t, h, dc, dos, dt, dold, ss,
     +     cvec, copn, smin, qmin, transf, cc, nbb,spec)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "cguess.fh"
#include "msgids.fh"
      integer geom, basis
      integer iat
c     
      integer nbb               ! No. of primtives used to dimension arrays
      real *8 hatom(*)
      real *8 pcap(*), qcap(*), fc(*), fo(*), s(*), u(*), t(*)
      real *8 h(*), dc(*), dos(*), dt(*), dold(*), ss(*)
      real *8 cvec(*), copn(*), smin(nbb,*), qmin(nbb,*),transf(*),cc(*)
      logical oprin,spec
      integer iwrite
      character*16 tag, element
c
      logical ospherical
c     
      integer ic(4,nb),iiloc(nb,4)
c     
      integer isymax
      real *8 znps
      data iwrite/6/
c     
      call atscf_bas_gather(geom, basis, iat, ic, iiloc,
     $     isymax, hatom, znps, element, tag, ospherical)
c     
      call atomd(oprin,iwrite,znps,ic,isymax,hatom,
     +     pcap, qcap, fc, fo, s, u, t, h, dc, dos, dt, dold, ss,
     +     cvec, copn, smin, qmin, transf, cc, nbb,
     +     element, tag,spec)
c
      end

      SUBROUTINE eomccsd_1pdm_pp_mo(d_i0,d_t1,d_t2,d_x0,d_x1,d_x2,d_y1,d
     &_y2,k_i0_offset,k_t1_offset,k_t2_offset,k_x0_offset,k_x1_offset,k_
     &x2_offset,k_y1_offset,k_y2_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 )_yx + = 1 * Sum ( h3 ) * x ( p1 h3 )_x * y ( h3 p2 )_y
C     i0 ( p1 p2 )_yx + = 1/2 * Sum ( h4 h5 p3 ) * x ( p1 p3 h4 h5 )_x * y ( h4 h5 p2 p3 )_y
C     i0 ( p1 p2 )_yxt + = 1 * Sum ( h3 ) * t ( p1 h3 )_t * i1 ( h3 p2 )_yx
C         i1 ( h3 p1 )_yx + = 1 * x ( )_x * y ( h3 p1 )_y
C         i1 ( h3 p1 )_yx + = 1 * Sum ( h5 p4 ) * x ( p4 h5 )_x * y ( h3 h5 p1 p4 )_y
C     i0 ( p1 p2 )_ytx + = 1/2 * x ( )_x * i1 ( p1 p2 )_yt
C         i1 ( p1 p2 )_yt + = 1 * Sum ( h4 h5 p3 ) * t ( p1 p3 h4 h5 )_t * y ( h4 h5 p2 p3 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_x1
      INTEGER k_x1_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_x2
      INTEGER k_x2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_x0
      INTEGER k_x0_offset
      INTEGER l_i1_offset
      INTEGER size_i1
      INTEGER d_t2
      INTEGER k_t2_offset
      CHARACTER*255 filename
      CALL eomccsd_1pdm_pp_mo_1(d_x1,k_x1_offset,d_y1,k_y1_offset,d_i0,k
     &_i0_offset)
      CALL eomccsd_1pdm_pp_mo_2(d_x2,k_x2_offset,d_y2,k_y2_offset,d_i0,k
     &_i0_offset)
      CALL OFFSET_eomccsd_1pdm_pp_mo_3_1(l_i1_offset,k_i1_offset,size_i1
     &)
      CALL TCE_FILENAME('eomccsd_1pdm_pp_mo_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL eomccsd_1pdm_pp_mo_3_1(d_x0,k_x0_offset,d_y1,k_y1_offset,d_i1
     &,k_i1_offset)
      CALL eomccsd_1pdm_pp_mo_3_2(d_x1,k_x1_offset,d_y2,k_y2_offset,d_i1
     &,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL eomccsd_1pdm_pp_mo_3(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k
     &_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('eomccsd_1pdm_pp_
     &mo',-1,MA_ERR)
      CALL OFFSET_eomccsd_1pdm_pp_mo_4_1(l_i1_offset,k_i1_offset,size_i1
     &)
      CALL TCE_FILENAME('eomccsd_1pdm_pp_mo_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL eomccsd_1pdm_pp_mo_4_1(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i1
     &,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL eomccsd_1pdm_pp_mo_4(d_x0,k_x0_offset,d_i1,k_i1_offset,d_i0,k
     &_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('eomccsd_1pdm_pp_
     &mo',-1,MA_ERR)
      RETURN
      END
      SUBROUTINE eomccsd_1pdm_pp_mo_1(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 )_yx + = 1 * Sum ( h3 ) * x ( p1 h3 )_x * y ( h3 p2 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p1b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &y,irrep_x)) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h3b-1)) .eq. irrep_x) TH
     &EN
      CALL TCE_RESTRICTED_2(p1b,h3b,p1b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,p2b,h3b_2,p2b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_1',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_1',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_1',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_1pdm_pp_mo_2(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 )_yx + = 1/2 * Sum ( h4 h5 p3 ) * x ( p1 p3 h4 h5 )_x * y ( h4 h5 p2 p3 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &y,irrep_x)) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &4b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h4b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_x) THEN
      CALL TCE_RESTRICTED_4(p1b,p3b,h4b,h5b,p1b_1,p3b_1,h4b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p2b,p3b,h4b_2,h5b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_2',2,MA_ERR)
      IF ((p3b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_2',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_2',5,MA_ERR)
      IF ((p3b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p3b-1),int_mb(k_range+p2b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p2b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_2',6,
     &MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_2',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_1pdm_pp_mo_3(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 )_yxt + = 1 * Sum ( h3 ) * t ( p1 h3 )_t * i1 ( h3 p2 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p1b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &y,ieor(irrep_x,irrep_t))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h3b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p1b,h3b,p1b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,p2b,h3b_2,p2b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_1pdm_pp_mo_3_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 p1 )_yx + = 1 * x ( )_x * y ( h3 p1 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b_2
      INTEGER p1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &y,irrep_x)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (0 .eq. irrep_x) THEN
      CALL TCE_RESTRICTED_2(h3b,p1b,h3b_2,p1b_2)
      dim_common = 1
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_a),dbl_mb(k_a_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3_1',
     &6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3_1',8,MA_ERR)
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h3b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_eomccsd_1pdm_pp_mo_3_1(l_a_offset,k_a_offset,siz
     &e)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 p1 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER p1b
      length = 0
      DO h3b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &y,irrep_x)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &y,irrep_x)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p1b - noab - 1 + nvab * (h3b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE eomccsd_1pdm_pp_mo_3_2(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 p1 )_yx + = 1 * Sum ( h5 p4 ) * x ( p4 h5 )_x * y ( h3 h5 p1 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER h5b
      INTEGER p4b_1
      INTEGER h5b_1
      INTEGER h3b_2
      INTEGER h5b_2
      INTEGER p1b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h3b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &y,irrep_x)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO h5b = 1,noab
      IF (int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+h5b-1)) .eq. irrep_x) TH
     &EN
      CALL TCE_RESTRICTED_2(p4b,h5b,p4b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h3b,h5b,p1b,p4b,h3b_2,h5b_2,p1b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+h5b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (p4b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h5b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3_2',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_3_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3_2',5,MA_ERR)
      IF ((h5b .lt. h3b) .and. (p4b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((h5b .lt. h3b) .and. (p1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h3b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+p1b-1),int_mb(k_range+p4b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF ((h3b .le. h5b) .and. (p4b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p4b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p4b-1),int_mb(k_range+p1b-1)
     &,4,1,2,3,-1.0d0)
      END IF
      IF ((h3b .le. h5b) .and. (p1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h3b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p4b-1)
     &,3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3_2',
     &6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_3_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h3b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h3b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_3_2',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &3_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_1pdm_pp_mo_4(d_a,k_a_offset,d_b,k_b_offset,d_c,
     &k_c_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 )_ytx + = 1/2 * x ( )_x * i1 ( p1 p2 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &y,ieor(irrep_t,irrep_x))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (0 .eq. irrep_x) THEN
      CALL TCE_RESTRICTED_2(p1b,p2b,p1b_2,p2b_2)
      dim_common = 1
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_a),dbl_mb(k_a_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_4',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_4',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_4',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &4',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &4',8,MA_ERR)
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_4',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_4',10
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &4',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_1pdm_pp_mo_4_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p1 p2 )_yt + = 1 * Sum ( h4 h5 p3 ) * t ( p1 p3 h4 h5 )_t * y ( h4 h5 p2 p3 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER p1b_1
      INTEGER p3b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_4_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &4b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h4b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p1b,p3b,h4b,h5b,p1b_1,p3b_1,h4b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p2b,p3b,h4b_2,h5b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_4_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_4_1',2,MA_ERR)
      IF ((p3b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_4_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_1pdm_pp_mo_4_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_4_1',5,MA_ERR)
      IF ((p3b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p3b-1),int_mb(k_range+p2b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p2b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_4_1',
     &6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &4_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &4_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_1pdm_pp_mo_4_1',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_4_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_
     &4_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_eomccsd_1pdm_pp_mo_4_1(l_a_offset,k_a_offset,siz
     &e)
C     $Id: eomccsd_1pdm_pp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p1 p2 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p1b
      INTEGER p2b
      length = 0
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('eomccsd_1pdm_pp_mo_4_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+p2b-1)) .eq. ieor(irrep_
     &y,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p2b - noab - 1 + nvab * (p1b - noab - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END

      subroutine esp_grid(x,q,g,v)
c
c $Id: esp_grid.F 24389 2013-07-12 05:23:02Z d3y133 $
c
      implicit none
c
#include "esp_params.fh"
#include "esp_common.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      real*8 x(3,natoms),q(natoms),g(3,mxgrid),v(mxgrid)
      real*8 d,dmin,rcut2,rad2
      integer i,ix,iy,iz,ia,j
c
      if(newgrd.eq.0) then
        if(me.eq.0) then
          call util_file_name('grid',.false.,.false.,grdfil)
          open(unit=lfngrd,file=grdfil,form='formatted',status='old')
          rewind(lfngrd)
          read(lfngrd,'(i10,f20.10)') ngrid,charge
          do 10 i=1,ngrid
            read(lfngrd,'(4f20.10)') (g(j,i),j=1,3),v(i)
   10     continue
          close(unit=lfngrd)
        endif
        call ga_brdcst(mre_013,v,ngrid*ma_sizeof(mt_dbl,1,mt_byte),0)
      else
c
c       determine actual number of grid points
c
        if(me.eq.0) then
          rcut2=rcut*rcut
          ngrid=1
          do 1 iz=0,mgrid(3)+1
            do 2 iy=0,mgrid(2)+1
              do 3 ix=0,mgrid(1)+1
                g(1,ngrid)=xmin(1)-rcut+dble(ix)*spac
                g(2,ngrid)=xmin(2)-rcut+dble(iy)*spac
                g(3,ngrid)=xmin(3)-rcut+dble(iz)*spac
                dmin=rcut2
                ia=1
                do 4 i=1,natoms
                  rad2=(cnm2au*radius(int(q(i))))**2
                  d=(g(1,ngrid)-x(1,i))*(g(1,ngrid)-x(1,i))
     +             +(g(2,ngrid)-x(2,i))*(g(2,ngrid)-x(2,i))
     +             +(g(3,ngrid)-x(3,i))*(g(3,ngrid)-x(3,i))
                  if(rad2-d.gt.small) goto 3
                  if(dmin-d.gt.small) dmin=d
    4           continue
                if(rcut2-dmin.gt.small) then
cx                write(*,'(i5,7f12.6)') ngrid,(x(i,1),i=1,3),
cx     +                   (g(i,ngrid),i=1,3),sqrt(dmin)
                  ngrid=ngrid+1
                  if(ngrid.gt.mxgrid)
     +               call md_abort('Not enough memory available',0)
                endif
    3         continue
    2       continue
    1     continue
          ngrid=ngrid-1
        endif
      endif
c
c     broadcast grid to other nodes
c
      if(np.gt.0) then
        call ga_brdcst(mre_001,ngrid,ma_sizeof(mt_int,1,mt_byte),0)
        call ga_brdcst(mre_002,g,3*ngrid*ma_sizeof(mt_dbl,1,mt_byte),0)
      endif
c
c     determine gridpoints handled by current node
c
      if(np.gt.1) then
        ngfr=me*(ngrid/np)+1
        ngto=(me+1)*(ngrid/np)
        if(me.eq.np-1) ngto=ngrid
      else
        ngfr=1
        ngto=ngrid
      endif
c
      return
      end

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     rhf_fock -- Compute and return a complete Fock matrix, along with
C     one- and two-electron energies.
C
C REVISION
C     $Id: rhf_fock.F 19707 2010-10-29 17:59:36Z d3y133 $
C
C SYNOPSIS
      Subroutine RHF_Fock( Geom, Basis, G_Dens, Tol2e, OSkel,
     $   G_Fock, EOne, ETwo)
      Implicit NONE
#include "errquit.fh"
      Integer Geom           ! [in]  Geometry handle
      Integer Basis          ! [in]  Basis set handle
      Integer G_Dens         ! [in]  GA handle for AO density
      Double Precision Tol2e ! [in]  selection threshold for 2e integs
      Logical OSkel          ! [in]  Use symmetry (petite-list skeleton)
      Integer G_Fock         ! [in]  GA handle for Fock matrix (GA overwritten)
      Double Precision EOne  ! [out] Energy of one-electron terms
      Double Precision ETwo  ! [out] Energy of two-electron terms
C
C DESCRIPTION
C     Given a density matrix construct a full RHF Fock matrix (both one-
C     and two-electron terms), returning the Fock matrix along with the
C     energies.
C
C     E(SCF) = EOne + ETwo + (Nuclear Repulsion Energy)
C
C INCLUDED FILES
#include "global.fh"
c$$$#include "cscfps.fh"
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer G_HCore ! Temporary GA, cloned from G_Fock
c     
c     The guess density must be symmetrized if sym is used
c     
      if (OSkel) then
c$$$         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .true., G_Dens)
c$$$         if (oscfps) call pstat_off(ps_sym_sym)
      endif
c     
      If ( .NOT. GA_Duplicate( G_Fock, G_HCore, 'Temp HCore') )
     $   Call ErrQuit('RHF_Fock: Can''t create GA for HCore', 0, GA_ERR)
c     
c     Build the fock_matrix
c     
      call ga_zero(G_Fock)
      call ga_zero(g_hcore)
      call int_1e_ga(basis, basis, g_hcore,'kinetic', OSkel)
      call int_1e_ga(basis, basis, g_hcore,'potential', OSkel)
c     
      call rhf_fock_2e(geom, basis, G_Dens, G_Fock, Tol2e,
     &   .true., .true., OSkel)
c     
c     Compute contributions to the energy and symmetrize
c     
      EOne = ga_ddot(g_hcore,G_Dens)
      ETwo = 0.5d0*ga_ddot(G_Fock,G_Dens)
      call ga_dadd(1.d0,g_hcore,1.d0,G_Fock,G_Fock)
      if (.not. ga_destroy(g_hcore)) call errquit
     $     ('rhf_fock: destroy of hcore?', 0, GA_ERR)
c     
      if (OSkel) then
c$$$         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .false., G_Fock)
c$$$         if (oscfps) call pstat_off(ps_sym_sym)
      endif
c     
      Return
      End

*
* $Id: wvfnc_reformat.F 19707 2010-10-29 17:59:36Z d3y133 $
*

      logical function wvfnc_reformat(rtdb)
      implicit none
      integer rtdb
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"

      logical value
      integer version
 
      integer ierr

      integer ne(2),ispin

      character*50 new_wavefunction_filename
      character*50 old_wavefunction_filename
      character*255 full_filename,full_filename2
      character*50 cell_name,rtdb_unita

      integer ngrid(3)
      integer cfull(2)
      integer nfft3d,n2ft3d
      integer ms,n,l,occupation

      double precision unita(3,3)
      double precision unita2(3,3)

      value = .false.
      version = 3

*     **** get wavefunction information ****
      value = rtdb_cget(rtdb,'cgsd:output_wavefunction_filename',
     >                  1,old_wavefunction_filename)
      value = value.and.
     >        rtdb_cget(rtdb,'cgsd:input_wavefunction_filename',
     >                  1,new_wavefunction_filename)

      if (.not. value)
     >   call errquit('wvfnc_reformat: error reading filenames ',0,
     &       RTDB_ERR)

*     **** cell: stuff ****
      value = value.and.
     >        rtdb_cget(rtdb,'cgsd:cell_name',1,cell_name)
      l = index(cell_name,' ') - 1
      rtdb_unita = cell_name(1:l)//':unita'
      value = value.and.
     >        rtdb_get(rtdb,rtdb_unita,mt_dbl,9,unita2)

      if (.not. value)
     >   call errquit('wvfnc_reformat: error reading cell ',0, RTDB_ERR)


 
      call util_file_name_noprefix(old_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin,1)
      call iread(5,ne,2)
      call iread(5,occupation,1)
 
      call util_file_name('wvfnc_reformat',
     >                    .true.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      call openfile(6,full_filename,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,ngrid,3)
      call dwrite(6,unita2,9)
      call iwrite(6,ispin,1)
      call iwrite(6,ne,2)
      call iwrite(6,occupation,1)
       
       nfft3d = ( ngrid(1)/2+1)* ngrid(2)* ngrid(3)
       n2ft3d = 2* nfft3d

      write(*,*)
      write(*,*) '  -------------------------  '
      write(*,*) ' | adjusting wavefunctions | '
      write(*,*) '  -------------------------  '
      call nwpw_message(1)
      write(*,*)

      write(*,109) old_wavefunction_filename
      write(*,110) new_wavefunction_filename
      write(*,111) 
      write(*,112)  unita(1,1), unita(2,1), unita(3,1),
     >             unita2(1,1),unita2(2,1),unita2(3,1)
      write(*,113)  unita(1,2), unita(2,2), unita(3,2),
     >             unita2(1,2),unita2(2,2),unita2(3,2)
      write(*,112)  unita(1,3), unita(2,3), unita(3,3),
     >             unita2(1,3),unita2(2,3),unita2(3,3)
  109 format(' old filename: ',A)
  110 format(' new filename: ',A)

  111 format(2x,'unita:',28x,'unita2:')
  112 format(3F7.3, 13x, 3F7.3)
  113 format(3F7.3, 5x,"-->",5x, 3F7.3)
 
*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull(2),cfull(1))


      do ms=1,ispin
        do n=1,ne(ms)
          write(*,*) "copying .... psi:", n," spin:",ms
          call  dread(5,dcpl_mb(cfull(1)),n2ft3d)
          call dwrite(6,dcpl_mb(cfull(1)),n2ft3d)
        end do
      end do
      call closefile(5)
      call closefile(6)

c     *** copy wvfnc_expander to new_wavefunction_filename ****
      call util_file_name_noprefix(new_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)
      call util_file_copy(full_filename,full_filename2)
      call util_file_unlink(full_filename)
      IERR=0
      GO TO 9999
 
 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999
 
 9999 value = MA_free_heap(cfull(2))
      IF(IERR.EQ.0) THEN
        WRITE(6,*) ' JOB HAS BEEN COMPLETED.  CODE=',IERR
      ELSE
        WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
        value = .false.
      ENDIF
      call nwpw_message(4)
      write(*,*)
      
      wvfnc_reformat = value
      return 
      end
 

      SUBROUTINE OFFSET_ccsdtq_lr_alpha_15_52_7_1(l_a_offset,k_a_offset,
     &size)
C     $Id: offset_ccsdtq_lr_alpha_15_52_7_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h8 h9 h18 h16 p5 p6 )_ytrb
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h8b
      INTEGER h9b
      INTEGER h18b
      INTEGER h16b
      INTEGER p5b
      INTEGER p6b
      length = 0
      DO h8b = 1,noab
      DO h9b = h8b,noab
      DO h18b = h9b,noab
      DO h16b = 1,noab
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h18b-1
     &) .eq. int_mb(k_spin+h16b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h9b-1),ieor(int_mb(
     &k_sym+h18b-1),ieor(int_mb(k_sym+h16b-1),ieor(int_mb(k_sym+p5b-1),i
     &nt_mb(k_sym+p6b-1)))))) .eq. ieor(irrep_y,irrep_trb)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1
     &)+int_mb(k_spin+h18b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+p5b-1)
     &+int_mb(k_spin+p6b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lr_alpha_15_52_7_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h8b = 1,noab
      DO h9b = h8b,noab
      DO h18b = h9b,noab
      DO h16b = 1,noab
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      IF (int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)+int_mb(k_spin+h18b-1
     &) .eq. int_mb(k_spin+h16b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h8b-1),ieor(int_mb(k_sym+h9b-1),ieor(int_mb(
     &k_sym+h18b-1),ieor(int_mb(k_sym+h16b-1),ieor(int_mb(k_sym+p5b-1),i
     &nt_mb(k_sym+p6b-1)))))) .eq. ieor(irrep_y,irrep_trb)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1
     &)+int_mb(k_spin+h18b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+p5b-1)
     &+int_mb(k_spin+p6b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p6b - noab - 1 + nvab * (p5b - noab - 1 
     &+ nvab * (h16b - 1 + noab * (h18b - 1 + noab * (h9b - 1 + noab * (
     &h8b - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h8b-1) * int_mb(k_range+h9b-1) * int_
     &mb(k_range+h18b-1) * int_mb(k_range+h16b-1) * int_mb(k_range+p5b-1
     &) * int_mb(k_range+p6b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine print_exndcf(msg)
      implicit none
c $Id: basisP.F 19708 2010-10-29 18:04:21Z d3y133 $
#include "nwc_const.fh"
#include "basP.fh"
#include "util.fh"
      character *(*) msg
      integer i,j
      write(6,*)'<<<< print_exndcf: ',msg,' >>>>'
      do i = 1, nbasis_bsmx
        write(6,10000)i,(exndcf(j,i), j=1,3)
      enddo
10000 format(' basis:',i2,' handle :',i10,/
     &       '         ', ' index  :',i10,/
     &       '         ', ' size   :',i10/)
      end
*.....................................................................
      logical function bas_add_ucnt_init(basisin)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "bas_exndcf_dec.fh"
      integer basisin
c::local
      integer input_size
      parameter(input_size = 10000)
      integer basis, h_tmp, k_tmp
c
#include "bas_exndcf_sfn.fh"
c
      basis = basisin + BASIS_HANDLE_OFFSET
c
      bas_add_ucnt_init = ma_alloc_get(
     &    mt_dbl,input_size,' input for basis heap ',
     &    h_tmp,k_tmp)
      exndcf(H_exndcf,basis) = h_tmp
      exndcf(K_exndcf,basis)= k_tmp
      if (.not. bas_add_ucnt_init) call errquit
     &    ('bas_add_unct_init: error allocating input heap space',911,
     &       MEM_ERR)
      call dfill(input_size,0.0d00,dbl_mb(k_tmp),1)
      exndcf(SZ_exndcf,basis) = input_size
      end
*.....................................................................
      logical function bas_add_ucnt_tidy(basisin)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "bas_exndcf_dec.fh"
      integer basisin
c::local
      integer basis 
      integer h_tmp
c
#include "bas_exndcf_sfn.fh"
c
      basis = basisin + BASIS_HANDLE_OFFSET
c
      h_tmp = exndcf(H_exndcf,basis)
      bas_add_ucnt_tidy = ma_free_heap(h_tmp)
      if (.not.bas_add_ucnt_tidy) call errquit
     &    ('bas_add_unct_tidy: error freeing heap',911, MEM_ERR)
      exndcf(H_exndcf ,basis) = -1
      exndcf(K_exndcf ,basis) = 0
      exndcf(SZ_exndcf,basis) = 0
      bas_add_ucnt_tidy = .true.
      end
*.....................................................................
      logical function bas_set_ecp_basis(basis)
      implicit none
#include "basdeclsP.fh"
#include "nwc_const.fh"
#include "basP.fh"
      logical bas_check_handle
      external bas_check_handle
c      
      integer basis
c
      integer bas
c
      bas_set_ecp_basis = bas_check_handle(basis,'bas_set_ecp_basis')
      if (.not. bas_set_ecp_basis) return
      bas = basis + BASIS_HANDLE_OFFSET
c
      infbs_head(Head_ECP,bas) = 1
      end
*.....................................................................
      logical function bas_set_so_basis(basis)
      implicit none
#include "basdeclsP.fh"
#include "nwc_const.fh"
#include "basP.fh"
      logical bas_check_handle
      external bas_check_handle
c      
      integer basis
c
      integer bas
c
      bas_set_so_basis = bas_check_handle(basis,'bas_set_so_basis')
      if (.not. bas_set_so_basis) return
      bas = basis + BASIS_HANDLE_OFFSET
c
      infbs_head(Head_ECP,bas) = 2
      end
*.....................................................................
      logical function ecp_set_num_elec(ecpid,tag,num_elec,stdtag)
      implicit none
#include "basdeclsP.fh"
#include "nwc_const.fh"
#include "basP.fh"
*functions::
      logical ecp_check_handle
      logical bas_add_utag
      external ecp_check_handle
      external bas_add_utag
*passed::
      integer ecpid      ! [input] basis set handle
      character*16 tag   ! [input] tag to set number of electrons for
      integer num_elec   ! [input] number of electrons ecp replaces
      character*(*) stdtag ! [input] name associated with ecp on tag
c
*local::
      integer ecp_indx
      integer itag
c
c     sets the number of electrons replaced by the ecp on the 
c     specified tag.  If the tag is not present it will also add 
c     that by calling bas_add_utag
c      
      ecp_set_num_elec = ecp_check_handle(ecpid,'ecp_set_num_elec')
      if (.not. ecp_set_num_elec) return
      ecp_indx = ecpid + BASIS_HANDLE_OFFSET
c
c     Make sure that the tag is in the list
c
      ecp_set_num_elec = bas_add_utag(ecpid, tag, stdtag, itag)
      if (.not. ecp_set_num_elec) return
      infbs_tags(Tag_Nelec,itag,ecp_indx) = num_elec
c
      end
*.....................................................................
      logical function ecp_get_num_elec(ecpid,tag,num_elec)
      implicit none
#include "basdeclsP.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "stdio.fh"
*functions::
      logical ecp_check_handle
      external ecp_check_handle
*passed::
      integer ecpid      ! [input] basis set handle
      character*16 tag   ! [input] tag to get number of electrons for
      integer num_elec   ! [input] number of electrons ecp replaces
c
*local::
      integer ecp_indx
      integer itag, ntag
c
c     gets the number of electrons replaced by the ecp on the 
c     specified tag.  If the tag is not present it will error
*
c
      ecp_get_num_elec = ecp_check_handle(ecpid,'ecp_get_num_elec')
      if (.not.ecp_get_num_elec) return
      ecp_indx = ecpid + BASIS_HANDLE_OFFSET
c
      ntag = infbs_head(Head_Ntags,ecp_indx)
      do itag = 1,ntag
        if (tag.eq.bs_tags(itag,ecp_indx)) then
          num_elec = infbs_tags(Tag_Nelec,itag,ecp_indx)
          ecp_get_num_elec = .true.
          return
        endif
      enddo
c
      num_elec = 0
      ecp_get_num_elec = .false.
c
      end
*.....................................................................
      logical function bas_add_utag(basisin, tag, stdtag, itag)
      implicit none
#include "basdeclsP.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "inp.fh"
      integer basisin           ! [input] basis handle
      character*(*) tag         ! [input] name of tag
      character*(*) stdtag      ! [input] name of basis set on tag
      integer itag              ! [output] index of tag
c
      integer basis             ! [local] index into basis arrays
      logical bas_check_handle
      external bas_check_handle
      integer tmp
c
c     Add the unique tag to the list of tags in the basis,
c     incrementing the no. of tags if necessary.
c     Return in itag the index of the unique tag
c
      bas_add_utag = bas_check_handle(basisin, 'bas_add_utag')
      if (.not. bas_add_utag) return
      basis = basisin + BASIS_HANDLE_OFFSET
c
      do itag = 1, infbs_head(HEAD_NTAGS,basis)
        if (bs_tags(itag,basis) .eq. tag) then
          if (bs_stdname(itag,basis).eq.'unknown') then
            bs_stdname(itag,basis) = stdtag
          else if (bs_stdname(itag,basis) .ne. stdtag) then
            if (.not.(bs_stdname(itag,basis)(1:9).eq.'modified:')) then
              tmp = inp_strlen(bs_stdname(itag,basis))
              bs_stdname(itag,basis) =
     &            'modified:'//bs_stdname(itag,basis)(1:tmp)
            endif
          endif
          return             
        endif
      enddo
c
c     No match found ... append new tag to the list
c
      itag = infbs_head(HEAD_NTAGS,basis) + 1
      if (itag .gt. ntags_bsmx) then
         write(6,*) 'bas_add_utag: too many tags', itag
         bas_add_utag = .false.
         return
      endif
c
      infbs_head(HEAD_NTAGS,basis) = itag
      bs_tags(itag,basis) = tag
      bs_stdname(itag,basis) = stdtag
c
      end
*.....................................................................
      subroutine bas_err_info(info)
      implicit none
#include "nwc_const.fh"
#include "basP.fh"
c     
      character*(*) info        ! [input]
      integer bas,basin
      integer nbas
      logical status
c     
c     For internal use of the basis set routines only: print out
c     info of known basis sets to aid in diagnosing a problem
c     
c::function
      logical bas_print
      external bas_print
c
      nbas = 0
      do 00100 bas = 1, nbasis_bsmx
        if (bsactive(bas)) nbas = nbas + 1
00100 continue
      write(6,'(1x,a,a,i2)')
     &       info, ': open basis sets:',nbas
c
      nbas = 0
      do 00200 bas = 1, nbasis_bsmx
        if (bsactive(bas)) then
          basin = bas - BASIS_HANDLE_OFFSET
          status = bas_print(basin)
        endif
00200 continue
c
      if (nbasis_rtdb .gt. 0) then
        write(6,'(1x,a,a,i3)')
     &         info,': basis sets in current rtdb ',nbasis_rtdb
        do 00300 bas = 1, nbasis_rtdb
          write(6,'(1x,a,1x,i3,3x,a,1x,a)')
     &           'number:',bas,
     &           'basis set name:',
     &           bs_names_rtdb(bas)(1:len_bs_rtdb(bas))
00300   continue
      endif
c     
      end
*.....................................................................
      logical function bas_ucontinfo(basisin,icont,itype,
     &       nprimo,ngeno,sphcart)
      implicit none
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
c::function
      logical bas_check_handle
      external bas_check_handle
c::passed
      integer basisin, icont, nprimo, ngeno, sphcart, itype
c::local
      integer basis,myucont,icontmax
c
      nprimo = -123
      ngeno  = -456
      sphcart = -789
c
      bas_ucontinfo = bas_check_handle(basisin,'bas_ucontinfo')
      if (.not.bas_ucontinfo) return

      basis = basisin + BASIS_HANDLE_OFFSET 
c
      icontmax = infbs_head(HEAD_NCONT,basis)
c
      if (.not.(icont.gt.0.and.icont.le.icontmax)) then
        write(6,*)' bas_continfo: ERROR '
        write(6,*)' unique contraction range for basis is 1:',
     &         icontmax
        write(6,*)' information requested for contraction:',icont
        bas_ucontinfo = .false.
        return
      endif
c
      myucont = icont
      if (bas_spherical(basis)) then
        sphcart = 1
      else
        sphcart = 0
      endif
      itype   = infbs_cont(CONT_TYPE,myucont,basis)
      nprimo  = infbs_cont(CONT_NPRIM,myucont,basis)
      ngeno   = infbs_cont(CONT_NGEN,myucont,basis)
      bas_ucontinfo=.true.
      return
      end
*.....................................................................
      logical function bas_unumcont(basisin,numcont)
      implicit none
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
c::function
      logical bas_check_handle
      external bas_check_handle
c::passed
      integer basisin,numcont
c::local
      integer basis
c
      numcont = -6589
      bas_unumcont = bas_check_handle(basisin,'bas_numcont')
      if (.not.bas_unumcont) return

      basis = basisin + BASIS_HANDLE_OFFSET 

      numcont = infbs_head(HEAD_NCONT,basis)

      bas_unumcont = .true.
      return
      end
*.....................................................................
      block data basis_data
c
c Block data structure to initialize the common block variables in the
c  internal basis set object data structures
c
      implicit none
#include "nwc_const.fh"
#include "basP.fh"
c     
      data nbasis_rtdb /0/
      data bsactive /nbasis_bsmx*.false./
      data bas_spherical /nbasis_bsmx*.false./
      data angular_bs /nbasis_bsmx*-565/
      data bas_norm_id /nbasis_bsmx*-565/
      data nbfmax_bs /nbasis_bsmx*-565/
      data bsversion /5.00d00/
* version 5 includes so stuff
c     
      end
*.....................................................................
      integer function nbf_from_ucont(ucont,basisin)
c
c function that returns the number of basis functions in a contraction
c 
c  types 0->S, 1->P, 2->D, 3->F etc. -1->SP -2->SPD
c
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
c:: function
      logical bas_check_handle
      external bas_check_handle
c:: passed
      integer ucont   ! [input] unique contraction 
      integer basisin ! [input] basis set handle
c:: local
      integer type
      integer basis
      integer ngen
c
      if(.not.bas_check_handle(basisin,'nbf_from_ucont'))
     &  call errquit('nbf_from_ucont: bad basis handle',basisin,
     &       BASIS_ERR)
c
      basis = basisin + BASIS_HANDLE_OFFSET
c
      type = infbs_cont(CONT_TYPE,ucont,basis)
      ngen = infbs_cont(CONT_NGEN,ucont,basis)
      if (type.ge.0) then 
        if (bas_spherical(basis)) then
          nbf_from_ucont = ngen*(2*type+1)
        else
          nbf_from_ucont = ngen*(type+1)*(type+2)/2
        endif
      else if (type.eq.-1) then
        nbf_from_ucont = ngen*2
      else if (type.eq.-2) then
        if (bas_spherical(basis)) then
          nbf_from_ucont = ngen*9/3
        else
          nbf_from_ucont = ngen*10/3
        endif
      else 
        call errquit('nbf_from_ucont: bad cont type',type, BASIS_ERR)
      endif
      end
*.....................................................................
      logical function bas_set_spherical(basisin, ospherical)
      implicit none
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
c
      integer basisin    ! [input] basis set handle
      logical ospherical ! [input] logical for spherical setting
c
      integer basis
c
      bas_set_spherical = .false.
c
      basis = basisin + BASIS_HANDLE_OFFSET
      if (ospherical) then
        infbs_head(HEAD_SPH,basis) = 1
        bas_spherical(basis) = .true.
      else
        infbs_head(HEAD_SPH,basis) = 0
        bas_spherical(basis) = .false.
      endif
      bas_set_spherical = .true.
      end
*.....................................................................
      logical function bas_get_spherical(basisin, is_spherical)
      implicit none
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
c
      integer basisin      ! [input] basis get handle
      logical is_spherical ! [output] logical for spherical getting
c
      integer basis
c
      bas_get_spherical = .false.
c
      basis = basisin + BASIS_HANDLE_OFFSET
      if (infbs_head(head_sph,basis).eq.1) then 
        is_spherical = .true.
      else
        is_spherical = .false.
      endif
      bas_get_spherical = .true.
      end
*.....................................................................
      logical function bas_name_exist_rtdb(rtdb,name)
      implicit none
#include "errquit.fh"
*
* function to determin if "name" has been stored on the 
* current rtdb in actual or translated by a set directive.
*
#include "mafdecls.fh"
#include "rtdb.fh"
#include "context.fh"
#include "inp.fh"      
#include "nwc_const.fh"
#include "basP.fh"      
c::functions
      logical  bas_rtdb_in
      external bas_rtdb_in
c::passed 
      integer rtdb ! [input] run time data base handle
      character*(*) name ! [input] test name
c::local
      integer index
      character*256 trans_name
c
      bas_name_exist_rtdb = bas_rtdb_in(rtdb)
      if (.not.bas_name_exist_rtdb) call errquit
     &    ('bas_name_exist_rtdb: bas_rtdb_in failed',911, RTDB_ERR)
c
      bas_name_exist_rtdb = .false.
      if (inp_match
     &    (nbasis_rtdb,.false.,name,bs_names_rtdb,index)) then
        bas_name_exist_rtdb = .true.
        return
      endif
      if (context_rtdb_match(rtdb,name,trans_name)) then
        if (inp_match
     &      (nbasis_rtdb,.false.,trans_name,bs_names_rtdb,index)) then
          bas_name_exist_rtdb = .true.
          return
        endif
      endif
      end

*
* $Id: wvfnc_ionize.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     *******************************************
*     *						*
*     *	 	   wvfnc_ionize			*
*     *						*
*     *******************************************

      logical function wvfnc_ionize(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"
#include "errquit.fh"

      logical value
      integer version
 
      integer ierr

      integer ne(2),ispin,nne(2)

      character*50 new_wavefunction_filename
      character*50 old_wavefunction_filename
      character*255 full_filename,full_filename2


      integer ngrid(3)
      integer dngrid(3)
      integer cfull(2),dcfull(2)
      integer nfft3d,n2ft3d
      integer dnfft3d,dn2ft3d
      integer ms,n,l,ma_type,occupation


      double precision unita(3,3)
      integer norbs_up,up_orbital_list(2)
      integer norbs_dn,dn_orbital_list(2)

      logical  ionize_orbital_notfound
      external ionize_orbital_notfound

      value = .false.
      version = 3

*     **** get wavefunction information ****
      value = rtdb_cget(rtdb,'ionize:old_wavefunction_filename',
     >                  1,old_wavefunction_filename)
      value = rtdb_cget(rtdb,'ionize:new_wavefunction_filename',
     >                  1,new_wavefunction_filename)

      norbs_up = 0
      norbs_dn = 0
      if (rtdb_ma_get(rtdb, 'ionize:up_orbitals', ma_type,
     >                norbs_up, up_orbital_list(2))) then

         if (.not.MA_get_index(up_orbital_list(2),up_orbital_list(1)))
     >      call errquit(
     >       'wvfnc_ionize: ma_get_index failed for actlist',911,
     &       MA_ERR)
      end if
      if (rtdb_ma_get(rtdb, 'ionize:dn_orbitals', ma_type,
     >                norbs_dn, dn_orbital_list(2))) then

         if (.not.MA_get_index(dn_orbital_list(2),dn_orbital_list(1)))
     >      call errquit(
     >       'wvfnc_ionize: ma_get_index failed for actlist',911,
     &       MA_ERR)
      end if


 
      call util_file_name_noprefix(old_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin,1)
      call iread(5,ne,2)
      call iread(5,occupation,1)
 
      nne(1) = ne(1) - norbs_up
      nne(2) = ne(2) - norbs_dn
      call util_file_name('wvfnc_expander',
     >                    .true.,
     >                    .false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      call openfile(6,full_filename,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,ngrid,3)
      call dwrite(6,unita,9)
      call iwrite(6,ispin,1)
      call iwrite(6,nne,2)
      call iwrite(6,occupation,1)

       
       nfft3d = ( ngrid(1)/2+1)* ngrid(2)* ngrid(3)
       n2ft3d = 2* nfft3d

      write(*,109) old_wavefunction_filename
      write(*,110) new_wavefunction_filename
      write(*,111) ne(1), ne(2),
     >             nne(1),nne(2)
  109 format(' old_filename: ',A)
  110 format(' new_filename: ',A)
  111 format(' converting  : ',I4,'x',I4,' --> ', 
     >                         I4,'x',I4)
 
*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull(2),cfull(1))


      do ms=1,ispin
        do n=1,ne(ms)
          call dread(5,dcpl_mb(cfull(1)),n2ft3d)

          if (ionize_orbital_notfound(ms,n,
     >                       int_mb(up_orbital_list(1)),norbs_up,
     >                       int_mb(dn_orbital_list(1)),norbs_dn)) then
            write(*,*) "copying .... psi:", n," spin:",ms
            call dwrite(6,dcpl_mb(cfull(1)),n2ft3d)
          else
            write(*,*) "removing .... psi:", n," spin:",ms
          end if

        end do
      end do
      call closefile(5)
      call closefile(6)

c     *** copy wvfnc_expander to new_wavefunction_filename ****
      call util_file_name_noprefix(new_wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)
      call util_file_copy(full_filename,full_filename2)
      call util_file_unlink(full_filename)
      IERR=0
      GO TO 9999
 
 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999
 
 9999 value = MA_free_heap(cfull(2))
      if (norbs_up.gt.0) value = MA_free_heap(up_orbital_list(2))
      if (norbs_dn.gt.0) value = MA_free_heap(dn_orbital_list(2))
      !IF(IERR.EQ.0) THEN
      !  WRITE(6,*) ' JOB HAS BEEN COMPLETED.  CODE=',IERR
      !ELSE
      !  WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
      !  value = .false.
      !ENDIF
      !call nwpw_message(4)
      
      wvfnc_ionize = value
      return 
      end
 
*     *******************************************
*     *                                         *
*     *            ionize_orbital_notfound      *
*     *                                         *
*     *******************************************

      logical function ionize_orbital_notfound(ms,n,
     >                                         up_orbs,nup,
     >                                         dn_orbs,ndn)
      implicit none
      integer ms,n
      integer up_orbs(*),nup
      integer dn_orbs(*),ndn

      logical notfound
      integer i

      notfound = .true.

      if (ms.eq.1) then
         do i=1,nup
           if (up_orbs(i).eq.n) notfound = .false.
         end do
      end if
      if (ms.eq.2) then
         do i=1,ndn
           if (dn_orbs(i).eq.n) notfound = .false.
         end do
      end if

      ionize_orbital_notfound = notfound
      return
      end

      subroutine argos_diana_wdefin()
c
      implicit none
c
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      integer id
      character*5 cs,ct
      real*8 rtag
      integer i,j,k
c
      read(card(8:31),1000) id,rtag,cs
 1000 format(i7,f12.6,a5)
c
      if(id.eq.0) then
      ndef=0
      else
      if(id.lt.0) then
      id=-id
      ldef(id)=0
      endif
      if(id.eq.ndef+1) then
      ndef=id
      ldef(id)=0
      endif
      if(id.gt.ndef) call md_abort('Groups to be defined in order',id)
      if(ldef(id).gt.0) ldef(id)=0
c
      if(cs(1:1).eq.'_') cs(1:1)=' '
c
      do 3 i=1,nwa
      ct=wnam(i)(6:10)
      do 4 j=1,5
      if(cs(j:j).eq.'?') ct(j:j)='?'
    4 continue
      if(cs.eq.'     '.or.cs.eq.ct) then
      do 6 k=1,-ldef(id)
      if(idef(id,k).eq.i) goto 7
    6 continue
      ldef(id)=ldef(id)-1
      if(-ldef(id).gt.mxnum) call md_abort('Too many atoms in group',id)
      idef(id,-ldef(id))=i
    7 continue
      endif
    3 continue
c
      write(*,1001) id,-ldef(id)
 1001 format(' Atom group',i5,' contains ',i7,' atoms')
c
      endif
c
c     broadcast to all nodes
c
      if(np.gt.1) then
      call ga_brdcst(mag_d06,ndef,ma_sizeof(mt_int,1,mt_byte),0)
      call ga_brdcst(mag_d06,ldef,ndef*ma_sizeof(mt_int,1,mt_byte),0)
      do 10 i=1,ndef
      call ga_brdcst(mag_d06,idef(i,1),
     + ldef(i)*ma_sizeof(mt_int,1,mt_byte),0)
   10 continue
      endif
c
      return
      end
c $Id: argos_diana_wdefin.F 21176 2011-10-10 06:35:49Z d3y133 $

c $Id: et_input.F 24529 2013-08-19 20:24:57Z niri $
      subroutine et_input(rtdb)
      implicit none
#include "errquit.fh"
c
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
c     
      integer rtdb, method_2e, fmo
      character*255 test
      double precision tol2e
c
 100  if (.not. inp_read()) call errquit('et_input: inp_read failed',0,
     &       INPUT_ERR)
c
       if (.not. inp_a(test))
     $     call errquit('scf_input: failed to read keyword', 0,
     &       INPUT_ERR)
c     
c     print level is read
c     -------------------
      if (inp_compare(.false.,'print', test)) then
         call util_print_input(rtdb, "et")
c
      goto 100
c
c     MO vector filenames are read
c     ----------------------------
      else if (inp_compare(.false.,'vectors', test)) then
         call et_vecs_input(rtdb,'et')
c 
      goto 100
c
c     screening tolerances are read
c     -----------------------------
      else if (inp_compare(.false.,'tol2e', test)) then
         if (.not. inp_f(tol2e)) call errquit
     $        ('et_input: tol2e <thresh>',0, INPUT_ERR)
         if (.not. rtdb_put(rtdb,'et:tol2e', MT_DBL, 1, tol2e))
     $        call errquit('et_input: rtdb_put of tol2e failed',0,
     &       RTDB_ERR)
c 
      goto 100
c
c     choice of 2e method is read
c     ---------------------------
      else if (inp_compare(.false.,'fock', test)) then
        method_2e = 1
         if (.not. rtdb_put(rtdb,'et:method_2e', MT_INT, 1, method_2e))
     $        call errquit('et_input: rtdb_put of method_2e failed',0,
     &       RTDB_ERR)
c
      goto 100
c
      else if (inp_compare(.false.,'nofock', test)) then
        method_2e = 2
c
         if (.not. rtdb_put(rtdb,'et:method_2e', MT_INT, 1, method_2e))
     $        call errquit('et_input: rtdb_put of method_2e failed',0,
     &       RTDB_ERR)
c
      goto 100
c
c     choice of FMO method
c     ---------------------------
      else if (inp_compare(.false.,'fmo', test)) then
        fmo = 1
         if (.not. rtdb_put(rtdb,'et:fmo', MT_INT, 1, fmo))
     $        call errquit('et_input: rtdb_put of fmo failed',0,
     &       RTDB_ERR)
c
      goto 100
c
c     end of input block
c     -------------------
      else if (.not. inp_compare(.false.,'end', test)) then
       continue
      endif
c     
c
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      function wraptime()
      double precision wraptime
#if HAVE_ETIME      
      real*4 etime,tarray(2)
      external etime
c
c   This function returns the UNIX clock time in seconds.
c   It is designed to minimize the effort required to 
c   convert the timing statistics in going from one
c   machine to another.
c
c      SGI
c
      wraptime = dble(etime(tarray))
#else
c
c      NO TIME STATISTICS
c
      wraptime = 0.0d00
#endif
c
      return
      end
c
      subroutine tmout
#include "common.fh"
      double precision tmax(MAXTIM),tmin(MAXTIM)
      integer i,pnum
c
c  This routine writes out the timekeeping statistics to
c  the output file 'md.out'
c
      do i = 1, MAXTIM
        tmin(i) = tmstat(i)
        tmax(i) = tmstat(i)
      end do
      call ga_dgop(5,tmstat,MAXTIM,'+')
      call ga_dgop(5,tmax,MAXTIM,'max')
      call ga_dgop(5,tmin,MAXTIM,'min')
      pnum = ga_nnodes()
      do i = 1, MAXTIM
        tmstat(i) = tmstat(i)/dble(pnum)
      end do
      if (ga_nodeid().ne.0) return
c
      if (l_stdio) then
        write(6,100) tmstat(1),tmin(1),tmax(1)
        write(6,200) tmstat(2),tmin(2),tmax(2)
        write(6,300) tmstat(3),tmin(3),tmax(3)
        write(6,400) tmstat(4),tmin(4),tmax(4)
        write(6,500) tmstat(5),tmin(5),tmax(5)
        write(6,2300) tmstat(23),tmin(23),tmax(23)
        write(6,550) tmstat(6)+tmstat(7)+tmstat(8)
        write(6,600) tmstat(6),tmin(6),tmax(6)
        write(6,700) tmstat(7),tmin(7),tmax(7)
        write(6,750)
        write(6,800) tmstat(8),tmin(8),tmax(8)
        write(6,2800) tmstat(28),tmin(28),tmax(28)
        write(6,1400) tmstat(14),tmin(14),tmax(14)
        write(6,850) tmstat(9)+tmstat(10)
        write(6,900) tmstat(9),tmin(9),tmax(9)
        write(6,1000) tmstat(10),tmin(10),tmax(10)
        write(6,1050) tmstat(11)+tmstat(12)+tmstat(13)
        write(6,1100) tmstat(11),tmin(11),tmax(11)
        write(6,1200) tmstat(12),tmin(12),tmax(12)
        write(6,1300) tmstat(13),tmin(13),tmax(13)
        write(6,1500) tmstat(15),tmin(15),tmax(15)
        write(6,1600) tmstat(16),tmin(16),tmax(16)
      endif
c
  100 format('Total elapsed time for calculation     ',3f8.1,' (sec)')
  200 format('Total time in force calculation        ',3f8.1,' (sec)')
  300 format('          Pairwise interactions        ',3f8.1,' (sec)')
  400 format('          Bending interactions         ',3f8.1,' (sec)')
  500 format('          Stretching interactions      ',3f8.1,' (sec)')
  550 format('Total time exchanging particle lists   ',f8.1,' (sec)')
  600 format('          Gathering list               ',3f8.1,' (sec)')
  700 format('          Scattering list              ',3f8.1,' (sec)')
  750 format('          Updating lists               ',3f8.1,' (sec)')
  800 format('             Coordinates               ',3f8.1,' (sec)')
  850 format('Total time sorting lists               ',f8.1,' (sec)')
  900 format('          Sorting local list           ',3f8.1,' (sec)')
 1000 format('          Sorting buffer list          ',3f8.1,' (sec)')
 1050 format('Total time sending messages            ',f8.1,' (sec)')
 1100 format('          Gather                       ',3f8.1,' (sec)')
 1200 format('          Scatter                      ',3f8.1,' (sec)')
 1300 format('          Update                       ',3f8.1,' (sec)')
 1400 format('             Angles                    ',3f8.1,' (sec)')
 1500 format('Total time calculating stress tensor   ',3f8.1,' (sec)')
 1600 format('Total time in scatter synchronization  ',3f8.1,' (sec)')
 2300 format('Total time constructing neighbor list  ',3f8.1,' (sec)')
 2800 format('             Bonds                     ',3f8.1,' (sec)')
c
      return
      end

      SUBROUTINE ccsd_t_singles_l(a_i0,d_t1,d_v2,
     &k_t1_offset,k_v2_offset,t
     &_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,toggle)
C     $Id: ccsd_t_singles_l.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = 1 * P( 9 ) * t ( p4 h1 )_t * v ( p5 p6 h2 h3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER toggle
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      DOUBLE PRECISION a_i0(*)
      IF (toggle .eq. 2) CALL ccsd_t_singles_l_1(d_t1,k_t1_offset,
     &d_v2,k_v
     &2_offset,a_i0,t_p4b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b)
      RETURN
      END
      SUBROUTINE ccsd_t_singles_l_1(d_a,k_a_offset,
     &d_b,k_b_offset,a_c,t_p4
     &b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b)
C     $Id: ccsd_t_singles_l.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = 1 * P( 9 ) * t ( p4 h1 )_t * v ( p5 p6 h2 h3 )_v
c
c elimination of the transpositions (kowalski,august,2009)
c
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
c -- peta-exa --
      INTEGER a3(9,6)
      INTEGER ia6,ja6
c --------------
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
c
cc      DO p4b = noab+1,noab+nvab
cc      DO p5b = noab+1,noab+nvab
cc      DO p6b = p5b,noab+nvab
cc      DO h1b = 1,noab
cc      DO h2b = 1,noab
cc      DO h3b = h2b,noab
c
        a3(1,1)=t_p4b
        a3(1,2)=t_p5b
        a3(1,3)=t_p6b
        a3(1,4)=t_h1b
        a3(1,5)=t_h2b
        a3(1,6)=t_h3b
c
        a3(2,1)=t_p4b
        a3(2,2)=t_p5b
        a3(2,3)=t_p6b
        a3(2,4)=t_h2b
        a3(2,5)=t_h1b
        a3(2,6)=t_h3b
c
        a3(3,1)=t_p4b
        a3(3,2)=t_p5b
        a3(3,3)=t_p6b
        a3(3,4)=t_h3b
        a3(3,5)=t_h1b
        a3(3,6)=t_h2b
c
        a3(4,1)=t_p5b
        a3(4,2)=t_p4b
        a3(4,3)=t_p6b
        a3(4,4)=t_h1b
        a3(4,5)=t_h2b
        a3(4,6)=t_h3b
c
        a3(5,1)=t_p5b
        a3(5,2)=t_p4b
        a3(5,3)=t_p6b
        a3(5,4)=t_h2b
        a3(5,5)=t_h1b
        a3(5,6)=t_h3b
c
        a3(6,1)=t_p5b
        a3(6,2)=t_p4b
        a3(6,3)=t_p6b
        a3(6,4)=t_h3b
        a3(6,5)=t_h1b
        a3(6,6)=t_h2b
c
        a3(7,1)=t_p6b
        a3(7,2)=t_p4b
        a3(7,3)=t_p5b
        a3(7,4)=t_h1b
        a3(7,5)=t_h2b
        a3(7,6)=t_h3b
c
        a3(8,1)=t_p6b
        a3(8,2)=t_p4b
        a3(8,3)=t_p5b
        a3(8,4)=t_h2b
        a3(8,5)=t_h1b
        a3(8,6)=t_h3b
c
        a3(9,1)=t_p6b
        a3(9,2)=t_p4b
        a3(9,3)=t_p5b
        a3(9,4)=t_h3b
        a3(9,5)=t_h1b
        a3(9,6)=t_h2b
c
        do ia6=1,8
         if(a3(ia6,1).ne.0) then
         do ja6=ia6+1,9
          if((a3(ia6,1).eq.a3(ja6,1)).and.(a3(ia6,2).eq.a3(ja6,2))
     &     .and.(a3(ia6,3).eq.a3(ja6,3)).and.(a3(ia6,4).eq.a3(ja6,4))
     &     .and.(a3(ia6,5).eq.a3(ja6,5)).and.(a3(ia6,6).eq.a3(ja6,6)))
     &     then
           a3(ja6,1)=0
           a3(ja6,2)=0
           a3(ja6,3)=0
           a3(ja6,4)=0
           a3(ja6,5)=0
           a3(ja6,6)=0
          end if
         enddo 
         end if
        enddo 
c
      do ia6=1,9
      p4b=a3(ia6,1)
      p5b=a3(ia6,2)
      p6b=a3(ia6,3)
      h1b=a3(ia6,4)
      h2b=a3(ia6,5)
      h3b=a3(ia6,6)
      if((p5b.le.p6b).and.(h2b.le.h3b).and.(p4b.ne.0)) then
      skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+p6b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
ccx      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
ccx     & ERRQUIT('ccsd_t_singles_1',0,MA_ERR)
ccx      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p4b,h1b,p4b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p5b,p6b,h2b,h3b,p5b_2,p6b_2,h2b_2,h3b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h2b-1) * int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_t_singles_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_t_singles_1',2,MA_ERR)
      CALL GET_HASH_BLOCK_MA(dbl_mb(d_a),dbl_mb(k_a),dima,
     & int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p4b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_t_singles_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_t_singles_1',4,MA_ERR)
ccx      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
ccx     &ccsd_t_singles_1',5,MA_ERR)
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b_sort),dimb,
     &int_mb(k_b_offset),(h3b_2
     & - 1 + (noab+nvab) * (h2b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (p5b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b_sort),dimb,
     &int_mb(k_b_offset),
     &(h3b_2
     & - 1 + (noab+nvab) * (h2b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (p5b_2 - 1)))),h3b_2,h2b_2,p6b_2,p5b_2)
      end if
ccx      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
ccx     &,int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1)
ccx     &,4,3,2,1,1.0d0)
ccx      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_t_singles_1',6,MA_E
ccx     &RR)
ccx      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
ccx     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
ccx     &t),dima_sort)
ccx      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_t_singles_1',7
ccx     &,MA_ERR)
ccx      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_t_singles_1',8
ccx     &,MA_ERR)
ccx      END IF
ccx      END IF
ccx      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,4,3,5,2,1,1.0d0)

      call sd_t_s1_1(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,4,3,2,5,1,-1.0d0)

      call sd_t_s1_2(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,4,3,2,1,5,1.0d0)

      call sd_t_s1_3(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,6,3,5,2,1,-1.0d0)

      call sd_t_s1_4(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,6,3,2,5,1,1.0d0)

      call sd_t_s1_5(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,6,3,2,1,5,-1.0d0)

      call sd_t_s1_6(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,3,6,5,2,1,1.0d0)

      call sd_t_s1_7(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,3,6,2,5,1,-1.0d0)

      call sd_t_s1_8(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
ccx      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),int_
ccx     &mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),int_
ccx     &mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,3,6,2,1,5,1.0d0)

      call sd_t_s1_9(int_mb(k_range+h3b-1),int_mb(k_range+h2b-1),
     1               int_mb(k_range+h1b-1),int_mb(k_range+p6b-1),
     2               int_mb(k_range+p5b-1),int_mb(k_range+p4b-1),
     4               a_c,dbl_mb(k_a_sort),dbl_mb(k_b_sort))

      END IF
ccx      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_t_singles_1',9
ccx     &,MA_ERR)

      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_t_singles_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_t_singles_1',8
     &,MA_ERR)
c
      END IF
      END IF
      END IF
c
      END IF
      END IF
      END IF
      END IF
c
      END IF
      END DO
      RETURN
      END
c
      subroutine sd_t_s1_1(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h3d,h2d,h1d,p6d,p5d,p4d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
       triplesx(h3,h2,h1,p6,p5,p4)=triplesx(h3,h2,h1,p6,p5,p4)
     1   + t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_2(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h3d,h1d,h2d,p6d,p5d,p4d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
       triplesx(h3,h1,h2,p6,p5,p4)=triplesx(h3,h1,h2,p6,p5,p4)
     1   - t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_3(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h1d,h3d,h2d,p6d,p5d,p4d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p4=1,p4d
      do p5=1,p5d
      do p6=1,p6d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
       triplesx(h1,h3,h2,p6,p5,p4)=triplesx(h1,h3,h2,p6,p5,p4)
     1   + t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_4(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h3d,h2d,h1d,p6d,p4d,p5d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p5=1,p5d
      do p4=1,p4d
      do p6=1,p6d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
       triplesx(h3,h2,h1,p6,p4,p5)=triplesx(h3,h2,h1,p6,p4,p5)
     1   - t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_5(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h3d,h1d,h2d,p6d,p4d,p5d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p5=1,p5d
      do p4=1,p4d
      do p6=1,p6d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
       triplesx(h3,h1,h2,p6,p4,p5)=triplesx(h3,h1,h2,p6,p4,p5)
     1   + t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_6(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h1d,h3d,h2d,p6d,p4d,p5d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p5=1,p5d
      do p4=1,p4d
      do p6=1,p6d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
       triplesx(h1,h3,h2,p6,p4,p5)=triplesx(h1,h3,h2,p6,p4,p5)
     1   - t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_7(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h3d,h2d,h1d,p4d,p6d,p5d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p5=1,p5d
      do p6=1,p6d
      do p4=1,p4d
      do h1=1,h1d
      do h2=1,h2d
      do h3=1,h3d
       triplesx(h3,h2,h1,p4,p6,p5)=triplesx(h3,h2,h1,p4,p6,p5)
     1   + t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_8(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h3d,h1d,h2d,p4d,p6d,p5d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p5=1,p5d
      do p6=1,p6d
      do p4=1,p4d
      do h2=1,h2d
      do h1=1,h1d
      do h3=1,h3d
       triplesx(h3,h1,h2,p4,p6,p5)=triplesx(h3,h1,h2,p4,p6,p5)
     1   - t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end
c
      subroutine sd_t_s1_9(h3d,h2d,h1d,p6d,p5d,p4d,
     2               triplesx,t1sub,v2sub)
      IMPLICIT NONE
      integer h3d,h2d,h1d,p6d,p5d,p4d
      integer h3,h2,h1,p6,p5,p4
      double precision triplesx(h1d,h3d,h2d,p4d,p6d,p5d)
      double precision t1sub(p4d,h1d)
      double precision v2sub(h3d,h2d,p6d,p5d)
      do p5=1,p5d
      do p6=1,p6d
      do p4=1,p4d
      do h2=1,h2d
      do h3=1,h3d
      do h1=1,h1d
       triplesx(h1,h3,h2,p4,p6,p5)=triplesx(h1,h3,h2,p4,p6,p5)
     1   + t1sub(p4,h1)*v2sub(h3,h2,p6,p5)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      return
      end

      logical function analyz(irtdb0)
c
c $Id: analyz.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_params.fh"
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
c
      integer irtdb0
c
c     NWChem MD analysis module
c
c     Author: T.P.Straatsma
c       High Performance Computational Chemistry
c       Environmental Molecular Sciences Laboratory
c       Pacific Northwest National Laboratory
c     Copyright 1998 Pacific Northwest National Laboratory
c
c     me : number current node
c     np : number of nodes
c
      me=ga_nodeid()
      np=ga_nnodes()
c
      if(me.eq.0) then
      write(6,*)
      write(6,*)
      call util_print_centered(6,'Analysis Module',40,.true.)
      write(6,*)
      write(6,*)
      call ecce_print_module_entry('analyze')
      endif
c
      irtdb=irtdb0
c
      call ana_task()
c
      analyz=.true.
c
      return
      end

      subroutine qhop_setup(mparms,nparms,matm,natm,mseq,nseq,
     + catm,latm,cseq,lseq)
c
c $Id: qhop_setup_tj.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
c     input variables
c     ---------------
c
c     matm            : dimension of atom arrays
c     natm            : number of atoms
c     mseq            : dimension of residue arrays
c     nseq            : number of residues
c     nparms          : number of parameter sets
c     mparms          : number of parameter sets plus 1
c     cseq            : residue names
c     catm(1,1:natm)  : atom names
c     catm(k,1:natm)  : atom types in parameter set k-1
c     latm(5,1:natm)  : residue number
c     latm(10,1:natm) : + heavy atom attached to protonatable hydrogen
c                       - protonatable hydrogen, relative index to heavy atom
c     lseq(5,1:nseq)  : number of protonation states of residue
c     lseq(6,1:nseq)  : current protonation state of residue
c
      integer matm,natm,mseq,nseq,nparms,mparms
      character*10 cseq(mseq)
      character*6 catm(mparms,matm)
      integer latm(10,matm),lseq(6,mseq)
c
      integer i,j
c
      do 1 i=1,natm
c
      write(*,1000) i,catm(1,i),latm(5,i),cseq(latm(5,i)),latm(10,i),
     + lseq(5,latm(5,i)),lseq(6,latm(5,i))
c
 1000 format(i5,1x,a6,1x,i5,1xa10,3i5)
c
    1 continue
c
      return
      end

*> \brief \b IZAMAX
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       INTEGER FUNCTION IZAMAX(N,ZX,INCX)
* 
*       .. Scalar Arguments ..
*       INTEGER INCX,N
*       ..
*       .. Array Arguments ..
*       COMPLEX*16 ZX(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>    IZAMAX finds the index of element having max. absolute value.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup aux_blas
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>     jack dongarra, 1/15/85.
*>     modified 3/93 to return if incx .le. 0.
*>     modified 12/3/93, array(1) declarations changed to array(*)
*> \endverbatim
*>
*  =====================================================================
      INTEGER FUNCTION IZAMAX(N,ZX,INCX)
*
*  -- Reference BLAS level1 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER INCX,N
*     ..
*     .. Array Arguments ..
      COMPLEX*16 ZX(*)
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      DOUBLE PRECISION DMAX
      INTEGER I,IX
*     ..
*     .. External Functions ..
      DOUBLE PRECISION DCABS1
      EXTERNAL DCABS1
*     ..
      IZAMAX = 0
      IF (N.LT.1 .OR. INCX.LE.0) RETURN
      IZAMAX = 1
      IF (N.EQ.1) RETURN
      IF (INCX.EQ.1) THEN
*
*        code for increment equal to 1
*
         DMAX = DCABS1(ZX(1))
         DO I = 2,N
            IF (DCABS1(ZX(I)).GT.DMAX) THEN
               IZAMAX = I
               DMAX = DCABS1(ZX(I))
            END IF
         END DO
      ELSE
*
*        code for increment not equal to 1
*
         IX = 1
         DMAX = DCABS1(ZX(1))
         IX = IX + INCX
         DO I = 2,N
            IF (DCABS1(ZX(IX)).GT.DMAX) THEN
               IZAMAX = I
               DMAX = DCABS1(ZX(IX))
            END IF
            IX = IX + INCX
         END DO
      END IF
      RETURN
      END
c $Id: izamax.f 24342 2013-06-22 05:32:15Z d3y133 $

*
* $Id: setup_kbpp.f 19707 2010-10-29 17:59:36Z d3y133 $
*

*     *****************************************************
*     *                                                   *
*     *                setup_kbpp                         *
*     *                                                   *
*     *****************************************************

      subroutine setup_kbpp(nfft1,nfft2,nfft3,unita,unitg,G)
      implicit none
      integer nfft1,nfft2,nfft3
      double precision unita(3,3),unitg(3,3)
      double precision G(nfft1/2+1,nfft2,nfft3,3)

*     **** local variables ***** 
      integer i,j,k
      integer k1,k2,k3
      integer nffth1,nffth2,nffth3
      double precision g1,g2,g3


      call get_unitg(unita,unitg)

      nffth3 = nfft3/2
      nffth2 = nfft2/2
      nffth1 = nfft1/2
*     **** less confusing algorithm ****
      do k3 = -nffth3+1, nffth3
         do k2 = -nffth2+1, nffth2
            do k1 = 0,nffth1
               g1 = k1*unitg(1,1) + k2*unitg(1,2) +k3*unitg(1,3)
               g2 = k1*unitg(2,1) + k2*unitg(2,2) +k3*unitg(2,3)
               g3 = k1*unitg(3,1) + k2*unitg(3,2) +k3*unitg(3,3)
               i=k1
               j=k2
               k=k3
c              if (i .lt. 0) i = i + nfft1
               if (j .lt. 0) j = j + nfft2
               if (k .lt. 0) k = k + nfft3

               G(i+1,j+1,k+1,1) = g1
               G(i+1,j+1,k+1,2) = g2
               G(i+1,j+1,k+1,3) = g3

            end do  
         end do
      end do


      return
      end




      subroutine get_unitg(unita,unitg)
      implicit none

******************************************************************************
*                                                                            *
*     This routine computes primitive vectors                                *
*               in reciporocal space and the volume of primitive cell.       *
*                                                                            *
*     Inputs:                                                                *
*             unita  --- primitive vectors in coordination space             *
*                                                                            *
*     Outputs:                                                               *
*             unitg  --- primitive vectors in reciprocal space               *
*                                                                            *
*     Library:  dscal from BLAS                                              *
*                                                                            *
*     Last modification:  3/30/99  by Eric Bylaska                           *
*                                                                            *
******************************************************************************


*     ------------------
*     argument variables
*     ------------------
      double precision unita(3,3), unitg(3,3)

*     ---------------
*     local variables
*     ---------------
      double precision volume
      double precision twopi

      twopi = 8.0d0*datan(1.0d0)


*     -----------------------------------------
*     primitive vectors in the reciprocal space 
*     -----------------------------------------
      unitg(1,1) = unita(2,2)*unita(3,3) - unita(3,2)*unita(2,3)
      unitg(2,1) = unita(3,2)*unita(1,3) - unita(1,2)*unita(3,3)
      unitg(3,1) = unita(1,2)*unita(2,3) - unita(2,2)*unita(1,3)
      unitg(1,2) = unita(2,3)*unita(3,1) - unita(3,3)*unita(2,1)
      unitg(2,2) = unita(3,3)*unita(1,1) - unita(1,3)*unita(3,1)
      unitg(3,2) = unita(1,3)*unita(2,1) - unita(2,3)*unita(1,1)
      unitg(1,3) = unita(2,1)*unita(3,2) - unita(3,1)*unita(2,2)
      unitg(2,3) = unita(3,1)*unita(1,2) - unita(1,1)*unita(3,2)
      unitg(3,3) = unita(1,1)*unita(2,2) - unita(2,1)*unita(1,2)
      volume = unita(1,1)*unitg(1,1)
     >       + unita(2,1)*unitg(2,1)
     >       + unita(3,1)*unitg(3,1)
      call dscal(9,twopi/volume,unitg,1)

*     ---------------------
*     volume of a unit cell
*     ---------------------
      volume=dabs(volume)

      return
      end

      subroutine ana_task
c
c $Id: ana_task.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_common.fh"
#include "ana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      logical ignore
c
      integer lfncmd
      character*255 filcmd,fil,string
c
      character*80 card
      integer nsai,msai,nwmi,mwmi,nwai,mwai,it,ndx
      integer nframe,nread,num,i,j,k,ivec,ia,ja
      real*8 rms0,rms1,val,range
      character*3 fmt
      logical active
c
      logical ana_rdfram,ana_wrtvec
      real*8 ana_bond,ana_angle,ana_torsion
      external ana_rdfram,ana_wrtvec
      external ana_bond,ana_angle,ana_torsion
      integer idpdb,i_temp,l_temp
      logical lsuper,lsaver
      character*8 option
c
c     set sequential access to rtdb
c     and ignore current state
c
      ignore=rtdb_parallel(.false.)
c
      lfntcl=64
      lfnavg=65
      lfnhol=66
      lfnpin=67
      lfnpou=68
      lfncmd=69
      lfnloc=70
      lfnhba=71
      lfnecc=72
      lfnrdf=73
      lfnref=76
      lfntrj=77
      lfncop=78
      lfnsup=79
      lfnchg=80
      lfnplt=81
      lfnxyz=82
      lfnana=83
      lfnrms=84
      lfnprj=85
      lfnval=86
      lfncov=87
      lfnvec=88
      lfnmin=89
      lfnmax=90
      lfntop=91
      lfnhis=92
      lfnepz=93
      lfngrp=94
      lfnord=95
      lfnsel=96
      lfndie=97
      lfnamp=98
c
      ltop=.false.
c
      do 44 i=1,mhis
      idhis(i,3)=40+i
   44 continue
      do 46 i=1,mord
      rord(i,1)=zero
      rord(i,2)=zero
   46 continue
c
      lsonly=.false.
      lsuper=.false.
c
      ifrfr=1
      ifrto=0
      ifrsk=1
      ifrst=0
      ilast=0
c
      nbnds=0
      nangs=0
      ntors=0
      nimps=0
c
      ndef=0
c
      nhis=0
      lhis=0
c
      nrot=0
c
      lsel=.false.
      lsels=.false.
      lselo=.false.
      active=.false.
      lrms=.false.
      lana=.false.
      lrama=.false.
      lesd=.false.
      lloc=.false.
      lhbond=.false.
      lrdf=.false.
      lesppt=.false.
c
      nave=0
      ndata=0
      time=0.0d0
      timr=0.0d0
      ldist=0
      icent=0
      jcent=0
      scale=1.0d0
      cpk=1.0d0
      stick=1.0d0
c
      ngrid=10
      iesppb=0
      rcut=1.0d0
c
      ifr=1
      indx=1
c
      rhbmin=0.0d0
      rhbmax=0.2d0
      hbdmin=1.9d0
      hbdmax=3.1416d0
      hbamin=1.9d0
      hbamax=3.1416d0
      numwhb=0
c
      ngroup=0
      ngroups=0
      if(.not.ma_push_get(mt_int,maxgrp*mxdef*mxnum,'iwrk',l_wrk,i_wrk))
     + call md_abort('Could not allocate wrk',0)
c
      if(me.eq.0) then
      if(.not.rtdb_cget(irtdb,'ana:filcmd',1,filcmd))
     + call md_abort('Error rtdb_get filcmd',0)
      open(unit=lfncmd,file=filcmd(1:index(filcmd,' ')-1),
     + form='formatted',status='old',err=9999)
      rewind(unit=lfncmd)
      endif
c
    1 continue
      lesd=.false.
c
      if(me.eq.0) then
      read(lfncmd,1000,end=9999) card
 1000 format(a)
      endif
      call util_char_ga_brdcst(mag_d00,card,0)
c
c     read reference coordinates
c     --------------------------
c
      if(card(1:6).eq.'refer ') then
      filref=card(8:80)
c
c     get the size from the reference file
c
      call ana_sizref(nsai,msai,nwmi,mwmi,nwai,mwai)
c
c     allocate memory and initialize
c
      call ana_init(nsai,msai,nwmi,mwmi,nwai,mwai,.true.)
c
c     read the reference coordinates
c
      call ana_rdref(dbl_mb(i_xref))
c
c
c     determine which atoms will be handled by this node
c
      num=nsa/np+1
      ifr=me*num+1
      ito=(me+1)*num
      if(ifr.gt.nsa) then
      num=0
      ifr=nsa
      else
      if(ito.gt.nsa) ito=nsa
      num=ito-ifr+1
      endif
c
      call ana_all(int_mb(i_ssel),1,dbl_mb(i_swt),nsel)
      lsel=.false.
      call ana_all(int_mb(i_isel),1,dbl_mb(i_wt),nsel)
      call ana_wall(int_mb(i_wsel),1,int_mb(i_ndxw))
c
      if(me.eq.0) then
      write(*,'(a,a)') ' Reference coordinates read from ',
     + filref(1:index(filref,' ')-1)
      write(*,'(/,a,i5)') ' Number of atoms is ',nsai
      endif
      goto 1
      endif
c
c     read topology file
c     ------------------
c
      if(card(1:6).eq.'topol ') then
      filtop=card(8:80)
      call ana_siztop()
      if(.not.ma_push_get(mt_int,7*msgm,'iram',l_iram,i_iram))
     + call md_abort('Could not allocate iram',0)
      if(.not.ma_push_get(mt_int,msa,'imol',l_imol,i_imol))
     + call md_abort('Could not allocate imol',0)
      if(.not.ma_push_get(mt_int,2*msb,'sbnd',l_sbnd,i_sbnd))
     + call md_abort('Could not allocate sbnd',0)
      call ana_rdtop(byte_mb(i_snam),dbl_mb(i_qdat),dbl_mb(i_qwdat),
     + int_mb(i_iram),int_mb(i_imol),int_mb(i_sbnd))
c
      if(me.eq.0) then
      if(ltop) then
      write(*,'(a,a)') ' Topology read from ',
     + filtop(1:index(filtop,' ')-1)
      else
      write(*,'(a,a)') ' Topology could not be read from ',
     + filtop(1:index(filtop,' ')-1)
      endif
      endif
      goto 1
      endif
c
c     read trajectory file header
c     ---------------------------
c
      if(card(1:6).eq.'file  ') then
      read(card(8:17),'(2i5)') ifrst,ilast
      filtrj=card(18:80)
c
      fmttrj='trj'
      if(index(filtrj,'.sco').gt.0) fmttrj='sco'
      if(index(filtrj,'.coo').gt.0) fmttrj='coo'
c
      call ana_rdhdr(byte_mb(i_snam))
c
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      endif
c
      call ana_all(int_mb(i_isel),1,dbl_mb(i_wt),nsel)
      call ana_wall(int_mb(i_wsel),1,int_mb(i_ndxw))
      lsel=.false.
c
      if(me.eq.0) then
      write(*,'(/,a,a)') ' Trajectory file header from ',
     + filtrj(1:index(filtrj,' ')-1)
      endif
      goto 1
      endif
c
      if(card(1:6).eq.'scale ') then
      read(card(7:18),'(f12.6)') scale
      goto 1
      endif
c
      if(card(1:6).eq.'cpk   ') then
      read(card(7:18),'(f12.6)') cpk
      goto 1
      endif
c
      if(card(1:6).eq.'stick ') then
      read(card(7:18),'(f12.6)') stick
      goto 1
      endif
c
c     atom selection
c     --------------
c
      if(card(1:6).eq.'select') then
      if(.not.lsel) then
      call ana_all(int_mb(i_isel),0,dbl_mb(i_wt),nsel)
      lsel=.true.
      endif
      call ana_select(card,byte_mb(i_snam),int_mb(i_isel),dbl_mb(i_wt),
     + dbl_mb(i_xref),nsel)
      if(me.eq.0) then
      write(*,3003) nsel,nsa
 3003 format(' Selected',i5,' out of',i5,' atoms')
      endif
      goto 1
      endif
      if(card(1:6).eq.'selecs') then
      if(.not.lsels) then
      call ana_all(int_mb(i_ssel),0,dbl_mb(i_swt),nsel)
      lsels=.true.
      endif
      call ana_select(card,byte_mb(i_snam),int_mb(i_ssel),dbl_mb(i_swt),
     + dbl_mb(i_xref),nsel)
      if(me.eq.0) then
      write(*,3533) nsel,nsa
 3533 format(' Selected',i5,' out of',i5,' atoms for superposition')
      endif
      goto 1
      endif
      if(card(1:6).eq.'seleco') then
      if(.not.lselo) then
      call ana_all(int_mb(i_osel),0,dbl_mb(i_owt),nselo)
      lselo=.true.
      endif
      call ana_select(card,byte_mb(i_snam),int_mb(i_osel),dbl_mb(i_owt),
     + dbl_mb(i_xref),nselo)
      if(me.eq.0) then
      write(*,3633) nselo,nsa
 3633 format(' Selected',i5,' out of',i5,' atoms for output')
      endif
      goto 1
      endif
c
c     save atom selection
c     -------------------
c
      if(card(1:6).eq.'savsel') then
      filsel=card(8:80)
      call ana_savsel(lfnsel,filsel,int_mb(i_wsel),int_mb(i_isel))
      goto 1
      endif
      if(card(1:6).eq.'savsls') then
      filsel=card(8:80)
      call ana_savsel(lfnsel,filsel,int_mb(i_wsel),int_mb(i_ssel))
      goto 1
      endif
c
c     read atom selection
c     -------------------
c
      if(card(1:5).eq.'rdsel') then
      filsel=card(8:80)
      call ana_readsel(lfnsel,filsel,int_mb(i_wsel),int_mb(i_isel))
      call ana_wcount(int_mb(i_wsel),int_mb(i_ndxw))
      goto 1
      endif
      if(card(1:6).eq.'rdsels') then
      filsel=card(8:80)
      call ana_readsel(lfnsel,filsel,int_mb(i_wsel),int_mb(i_ssel))
      call ana_wcount(int_mb(i_wsel),int_mb(i_ndxw))
      goto 1
      endif
c
c     index
c     -----
c
      if(card(1:6).eq.'index ') then
      read(card(7:16),'(i10)') indx
      goto 1
      endif
c
c     set hydrogen bond criteria
c     --------------------------
c
      if(card(1:7).eq.'hbdist ') then
      read(card(8:31),'(2f12.6)') rhbmin,rhbmax
      goto 1
      endif
      if(card(1:7).eq.'hbdang ') then
      read(card(8:31),'(2f12.6)') hbdmin,hbdmax
      goto 1
      endif
      if(card(1:7).eq.'hbaang ') then
      read(card(8:31),'(2f12.6)') hbamin,hbamax
      goto 1
      endif
      if(card(1:7).eq.'numwhb ') then
      read(card(8:12),'(i5)') numwhb
      goto 1
      endif
      if(card(1:6).eq.'hbond  ') then
      lhbond=.true.
      call ana_hbond_init(byte_mb(i_snam),int_mb(i_sbnd),int_mb(i_hbnd))
      goto 1
      endif
c
c     solvent selection
c     -----------------
c
      if(card(1:6).eq.'wselct') then
      read(card(8:19),'(f12.6)') range
c
      call ana_wall(int_mb(i_wsel),0,int_mb(i_ndxw))
c
      if(nsel.eq.0) call md_abort('No solute atoms selected',0)
c
      call ana_rdhdr(byte_mb(i_snam))
      nread=0
      nwrit=0
      nframe=0
   20 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 20
      if(nframe.eq.(nframe/ifrsk)*ifrsk.and.lsx.and.lxw) then
c
      call ana_wselect(int_mb(i_isel),dbl_mb(i_xdat),
     + int_mb(i_wsel),dbl_mb(i_wdat),range,int_mb(i_ndxw))
c
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 20
      call ga_igop(mag_d13,int_mb(i_wsel),mwm,'+')
      endif
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
c
      call ana_wcount(int_mb(i_wsel),int_mb(i_ndxw))
      call ana_all(int_mb(i_isel),1,dbl_mb(i_wt),nsel)
      lsel=.false.
      write(*,3303) nwsel,nwm
 3303 format(/,' Selected',i5,' out of',i5,' solvent molecules')
      endif
c
      goto 1
      endif
c
c     solute atom group definition
c     ----------------------------
c
      if(card(1:6).eq.'define') then
      call ana_define(card,byte_mb(i_snam),int_mb(i_isel),dbl_mb(i_wt),
     + dbl_mb(i_xref))
      if(me.eq.0) then
      write(*,3004) ndef
 3004 format(' Defined',i5,' atom groups')
      endif
      goto 1
      endif
c
c     solvent atom group definition
c     -----------------------------
c
      if(card(1:6).eq.'wdefin') then
      call ana_wdefin(card)
      if(me.eq.0) then
      write(*,3004) ndef
      endif
      goto 1
      endif
c
c     atom group analysis
c     -------------------
c
      if(card(1:6).eq.'group ') then
      call ana_group(card,byte_mb(i_snam),int_mb(i_imol),
     + int_mb(i_isel),dbl_mb(i_wt),dbl_mb(i_xref),int_mb(i_wrk))
      goto 1
      endif
c
c     atom groups directives
c     ----------------------
c
      if(card(1:6).eq.'groups') then
      call ana_groups(card,byte_mb(i_snam),int_mb(i_imol),
     + int_mb(i_isel),dbl_mb(i_wt),dbl_mb(i_xref))
      goto 1
      endif
c
c     atom groups directives
c     ----------------------
c
      if(card(1:6).eq.'histo ') then
      if(card(22:26).eq.'    1') then
      nhis=nhis+1
      rhis=-0.6d0*box(3)
      if(nhis.gt.mhis)
     + call md_abort('Too many histogram directives ',nhis)
      read(card(8:21),'(2i7)') idhis(nhis,1),idhis(nhis,2)
      if(idhis(nhis,2).eq.0) idhis(nhis,2)=mlhis
      do 45 i=1,mlhis
      ihis(i,nhis)=0
   45 continue
      fil=card(54:80)
      if(fil(1:1).eq.' ')
     + call md_abort('No histogram filename given',nhis)
      open(unit=idhis(nhis,3),file=fil(1:index(fil,' ')-1),
     + form='formatted',status='unknown')
      endif
      goto 1
      endif
c
c     radial distribution function
c     ----------------------------
c
      if(card(1:6).eq.'rdf   ') then
      read(card,'(7x,i7,f12.6)') nrdf,rrdf
      lrdf=.true.
      goto 1
      endif
c
c     electrostatic potentials at selected points
c     -------------------------------------------
c
      if(card(1:6).eq.'esppnt') then
      string=card(8:80)
      ndx=index(string,' ')-1
      filpin=string(1:ndx)
      string=string(ndx+2:80)
      ndx=index(string,' ')-1
      filhol=string(1:index(string,' ')-1)
      string=string(ndx+2:80)
      ndx=index(string,' ')-1
      filpou=string(1:index(string,' ')-1)
      string=string(ndx+2:80)
      filavg=string(1:index(string,' ')-1)
      write(*,'(a,a,a,a)') ' esppnt ',
     + filpin(1:index(filpin,' ')),filhol(1:index(filhol,' ')),
     + filpou(1:index(filpou,' ')-1),filavg(1:index(filavg,' ')-1)
      call ana_esppt(int_mb(i_isel),dbl_mb(i_xdat),dbl_mb(i_wdat),
     + dbl_mb(i_qdat),dbl_mb(i_qwdat))
      endif
c
c     order parameters
c     ----------------
c
      if(card(1:7).eq.'order  ') then
      read(card(8:26),'(i5,2i7)') it,ia,ja
      if(it.eq.nord+1) nord=nord+1
      if(it.gt.nord) call md_abort('Order index too large',it)
      if(it.gt.mord) call md_abort('Order index too large',it)
      idord(it,1)=ia
      idord(it,2)=ja
      if(me.eq.0) then
      do 56 i=3,4
      read(lfncmd,1000,end=9999) card
      call ana_index(card,byte_mb(i_snam),idord(it,i),ia)
   56 continue
      endif
      call ga_brdcst(mag_d08,idord,4*mord*ma_sizeof(mt_int,1,mt_byte),0)
      goto 1
      endif
c
c     root mean square deviation
c     --------------------------
c
      if(card(1:6).eq.'rmsdev') then
      lrms=.true.
      ndata=0
      goto 1
      endif
c
c     ramachandran analysis
c     ---------------------
c
      if(card(1:6).eq.'diel  ') then
      ldiel=.true.
      goto 1
      endif
c
c     ramachandran analysis
c     ---------------------
c
      if(card(1:6).eq.'rama  ') then
      lrama=.true.
      goto 1
      endif
c
c     bond specification
c     ------------------
c
      if(card(1:6).eq.'bond  ') then
      read(card(8:12),'(i5)') it
      if(it.eq.nbnds+1) nbnds=nbnds+1
      if(it.gt.nbnds) call md_abort('Bond index too large',it)
      if(it.gt.mxbnds) call md_abort('Bond index too large',it)
      if(me.eq.0) then
      do 7 i=1,2
      read(lfncmd,1000,end=9999) card
      call ana_index(card,byte_mb(i_snam),ibnds(it,i,1),ibnds(it,i,2))
    7 continue
c      write(*,'(2i5)') (ibnds(it,i),i=1,2)
      endif
      call ga_brdcst(mag_d07,ibnds,
     + 4*mxbnds*ma_sizeof(mt_int,1,mt_byte),0)
      goto 1
      endif
c
c     angle specification
c     -------------------
c
      if(card(1:5).eq.'angle') then
      read(card(8:12),'(i5)') it
      if(it.eq.nangs+1) nangs=nangs+1
      if(it.gt.nangs) call md_abort('Angle index too large',it)
      if(it.gt.mxangs) call md_abort('Angle index too large',it)
      if(me.eq.0) then
      do 8 i=1,3
      read(lfncmd,1000,end=9999) card
      call ana_index(card,byte_mb(i_snam),iangs(it,i,1),iangs(it,i,2))
    8 continue
c      write(*,'(3i5)') (iangs(it,i),i=1,3)
      endif
      call ga_brdcst(mag_d08,iangs,
     + 6*mxangs*ma_sizeof(mt_int,1,mt_byte),0)
      goto 1
      endif
c
c     torsion specification
c     ---------------------
c
      if(card(1:6).eq.'torsio') then
      read(card(8:12),'(i5)') it
      if(it.eq.ntors+1) ntors=ntors+1
      if(it.gt.ntors) call md_abort('Torsion index skipped',it)
      if(it.gt.mxtors) call md_abort('Torsion index too large',it)
      if(me.eq.0) then
      do 9 i=1,4
      read(lfncmd,1000,end=9999) card
      call ana_index(card,byte_mb(i_snam),itors(it,i,1),itors(it,i,2))
    9 continue
c      write(*,'(4i5)') (itors(it,i),i=1,4)
      endif
      call ga_brdcst(mag_d09,itors,
     + 8*mxtors*ma_sizeof(mt_int,1,mt_byte),0)
      goto 1
      endif
c
c     improper specification
c     ----------------------
c
      if(card(1:6).eq.'improp') then
      read(card(8:12),'(i5)') it
      if(it.eq.nimps+1) nimps=nimps+1
      if(it.gt.nimps) call md_abort('Improper index too large',it)
      if(it.gt.mximps) call md_abort('Improper index too large',it)
      if(me.eq.0) then
      do 12 i=1,4
      read(lfncmd,1000,end=9999) card
      call ana_index(card,byte_mb(i_snam),iimps(it,i,1),iimps(it,i,2))
   12 continue
c      write(*,'(4i5)') (iimps(it,i),i=1,4)
      endif
      call ga_brdcst(mag_d10,iimps,
     + 8*mximps*ma_sizeof(mt_int,1,mt_byte),0)
      goto 1
      endif
c
c     charge distribution
c     -------------------
c
      if(card(1:6).eq.'chgdst') then
      read(card(8:12),'(i5)') ldist
      goto 1
      endif
c
c     center fraction
c     ---------------
      if(card(1:6).eq.'center') then
      read(card(8:17),'(2i5)') icent,jcent
      if(icent.gt.0) then
c
c     center-fold the reference coordinates
c
      call ana_center_ref(dbl_mb(i_xref))
c
      endif
      goto 1
      endif
c
c     rotations
c
      if(card(1:6).eq.'rotat0') then
      nrot=0
      goto 1
      endif
      if(card(1:6).eq.'rotatx') then
      nrot=nrot+1
      if(nrot.gt.100) call md_abort('Increase dimension irot',0)
      irot(nrot)=1
      read(card(8:19),'(f12.6)') arot(nrot)
      goto 1
      endif
      if(card(1:6).eq.'rotaty') then
      nrot=nrot+1
      if(nrot.gt.100) call md_abort('Increase dimension irot',0)
      irot(nrot)=2
      read(card(8:19),'(f12.6)') arot(nrot)
      goto 1
      endif
      if(card(1:6).eq.'rotatz') then
      nrot=nrot+1
      if(nrot.gt.100) call md_abort('Increase dimension irot',0)
      irot(nrot)=3
      read(card(8:19),'(f12.6)') arot(nrot)
      goto 1
      endif
c
c     atom tag
c     --------
c
      if(card(1:6).eq.'label ') then
      call ana_tag(card,byte_mb(i_snam),dbl_mb(i_xref))
      goto 1
      endif
c
c     select which frames to read
c     ---------------------------
c
      if(card(1:6).eq.'frame ') then
      read(card(8:37),'(3i10)') ifrfr,ifrto,ifrsk
      if(me.eq.0) then
      write(*,'(/,3(a,i10))') ' Selected frames ',ifrfr,' to ',ifrto,
     + ' by',ifrsk
      endif
      timoff=0.0d0
      time=0.0d0
      timr=0.0d0
      goto 1
      endif
c
c     write pdb
c     ---------
c
      if(card(1:6).eq.'wrtpdb') then
      lsuper=card(15:17).eq.'sup'
      lsonly=card(19:21).eq.'sol'
      read(card(7:14),'(i8)') idpdb
      read(card(23:80),'(a)') filcop
      i=index(filcop,'.')
      fmt=filcop(i+1:i+3)
c
      call ana_rdhdr(byte_mb(i_snam))
c
      nread=0
      nwrit=0
      nframe=0
      if(idpdb.gt.0) then
  222 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.idpdb) goto 222
      if(lsuper) then
      call super2(dbl_mb(i_xdat+ifr-1),int_mb(i_idat+ifr-1),
     + num,msa,dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms),
     + nsa,msa,.true.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa)
      call ana_xcollect(dbl_mb(i_xdat),ifr,num,msa)
      endif
      if(fmt.eq.'pdb') then
      call ana_wrtpdb(lfncop,filcop,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xdat),int_mb(i_wsel),dbl_mb(i_wdat),.false.,.not.lsonly,
     + int_mb(i_ndxw))
      elseif(fmt.eq.'xyz') then
      call ana_wrtxyz(lfncop,filcop,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xdat),dbl_mb(i_qdat),int_mb(i_wsel),dbl_mb(i_wdat),
     + .false.,.not.lsonly,int_mb(i_ndxw))
      else
      call md_abort('Illegal file format specified',0)
      endif
      endif
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      close(unit=lfncop)
      write(*,'(/,a,i10,a,a)') ' Written frame ',idpdb,' to ',
     + filcop(1:index(filcop,' ')-1)
      lsonly=.false.
      endif
      else
      if(fmt.eq.'pdb') then
      call ana_wrtpdb(lfncop,filcop,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xref),int_mb(i_wsel),dbl_mb(i_wdat),.false.,.false.,
     + int_mb(i_ndxw))
      elseif(fmt.eq.'xyz') then
      call ana_wrtxyz(lfncop,filcop,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xdat),dbl_mb(i_qdat),int_mb(i_wsel),dbl_mb(i_wdat),
     + .false.,.false.,int_mb(i_ndxw))
      else
      call md_abort('Illegal file format specified',0)
      endif
      if(me.eq.0) then
      close(unit=lfncop)
      write(*,'(/,a,a)') ' Written reference solute coordinates to ',
     + filcop(1:index(filcop,' ')-1)
      lsonly=.false.
      endif
      endif
c
      goto 1
      endif
c
c     copy frames
c     -----------
c
      if(card(1:6).eq.'copy  '.or.card(1:6).eq.'copys ') then
      lsonly=card(1:6).eq.'copys '
      read(card(8:12),'(i5)') mcopf
      read(card(13:24),'(f12.6)') rangle
      read(card(25:80),'(a)') filcop
      i=index(filcop,'.')
      fmt=filcop(i+1:i+3)
      root=filcop(1:i)
      ncop=1
      icopf=1
c
c      if(nsel.eq.0) call md_abort('No atoms selected',0)
c
c     write header
c
      call ana_rdhdr(byte_mb(i_snam))
      call ana_wthdr(lfncop,fmt,byte_mb(i_snam),byte_mb(i_tag),
     + int_mb(i_isel),.not.lsonly)
c
      nread=0
      nwrit=0
      nframe=0
    2 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 2
      if(nframe.eq.(nframe/ifrsk)*ifrsk) then
      call ana_wtfram(lfncop,fmt,dbl_mb(i_xdat),byte_mb(i_snam),
     + dbl_mb(i_wdat),int_mb(i_isel),byte_mb(i_tag),dbl_mb(i_val),
     + int_mb(i_wsel),int_mb(i_ndxw))
      nwrit=nwrit+1
      indx=indx+1
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 2
      endif
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      close(unit=lfncop)
      write(*,'(/,a,i10,a,a)') ' Copied ',nwrit,' frames to ',
     + filcop(1:index(filcop,' ')-1)
      lsonly=.false.
      endif
c
      goto 1
      endif
c
c     clean frames
c     ------------
c
      if(card(1:6).eq.'clean ') then
      read(card(8:13),'(i6)') nclean
      lclean=nclean.gt.0
      goto 1
      endif
c
c     super frames
c     -----------
c
      if(card(1:6).eq.'super '.or.card(1:6).eq.'supers') then
      lsonly=card(1:6).eq.'supers'
      read(card(8:19),'(f12.6)') rangle
      read(card(20:80),'(a)') filsup
      i=index(filsup,'.')
      fmt=filsup(i+1:i+3)
      root=filsup(1:i)
c
      if(nsel.eq.0) call md_abort('No atoms selected',0)
c
c     write header
c
      call ana_rdhdr(byte_mb(i_snam))
      call ana_wthdr(lfnsup,fmt,byte_mb(i_snam),byte_mb(i_tag),
     + int_mb(i_isel),.not.lsonly)
c
      nread=0
      nwrit=0
      nframe=0
    3 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 3
      if(nframe.eq.(nframe/ifrsk)*ifrsk.and.lsx) then
      call super2(dbl_mb(i_xdat+ifr-1),int_mb(i_idat+ifr-1),num,msa,
     + dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms),
     + nsa,msa,.true.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa)
      call ana_xcollect(dbl_mb(i_xdat),ifr,num,msa)
      call ana_wtfram(lfnsup,fmt,dbl_mb(i_xdat),byte_mb(i_snam),
     + dbl_mb(i_wdat),int_mb(i_isel),byte_mb(i_tag),dbl_mb(i_val),
     + int_mb(i_wsel),int_mb(i_ndxw))
      nwrit=nwrit+1
      indx=indx+1
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 3
      endif
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      close(unit=lfnsup)
      write(*,'(/,a,i10,a,a)') ' Superimposed ',nwrit,' frames to ',
     + filsup(1:index(filsup,' ')-1)
      lsonly=.false.
      endif
c
      goto 1
      endif
c
c     scan frames
c     -----------
c
      if(card(1:6).eq.'scan  '.or.card(1:6).eq.'scans ') then
      lsuper=card(1:6).eq.'scans '
      read(card(8:80),'(a)') string
      filram=string(1:index(string,' ')-1)//'.ram'
      filrms=string(1:index(string,' ')-1)//'.rms'
      filana=string(1:index(string,' ')-1)//'.ana'
      filhis=string(1:index(string,' ')-1)//'.his'
      filgrp=string(1:index(string,' ')-1)//'.grp'
      filord=string(1:index(string,' ')-1)//'.ord'
      filloc=string(1:index(string,' ')-1)//'.loc'
      filhba=string(1:index(string,' ')-1)//'.hba'
      fildie=string(1:index(string,' ')-1)//'.die'
      time=0.0d0
c
      if(lrdf) then
      call ana_rdf_init()
      print*,'rdf_init'
      endif
c
c     read file header
c
      call ana_rdhdr(byte_mb(i_snam))
c
      lana=nbnds+nangs+ntors+nimps.gt.0
c
      if(me.eq.0) then
      if(lana) then
      open(unit=lfnana,file=filana(1:index(filana,' ')-1),
     + form='formatted',status='unknown',err=9999)
      write(*,3333) filana(1:index(filana,' ')-1)
 3333 format(/,' Opening scn file ',a)
      call ana_anahdr(byte_mb(i_snam))
      endif
      if(lrama) then
      open(unit=lfnram,file=filram(1:index(filram,' ')-1),
     + form='formatted',status='unknown')
      call ana_ramhdr(byte_mb(i_snam),int_mb(i_iram))
      endif
      if(ldiel) then
      open(unit=lfndie,file=fildie(1:index(fildie,' ')-1),
     + form='formatted',status='unknown')
      endif
      if(lrms) then
      open(unit=lfnrms,file=filrms(1:index(filrms,' ')-1),
     + form='formatted',status='unknown')
      endif
      if(lhbond) then
      open(unit=lfnhba,file=filhba(1:index(filhba,' ')-1),
     + form='formatted',status='unknown')
      call ana_hbond_header(byte_mb(i_snam),int_mb(i_isel),
     + int_mb(i_hbnd))
      if(.not.ma_push_get(mt_int,mwm,'temp',l_temp,i_temp))
     + call md_abort('Could not allocate temp',0)
      endif
      if(ngroups.gt.0) then
      open(unit=lfngrp,file=filgrp(1:index(filgrp,' ')-1),
     + form='formatted',status='unknown')
      write(lfngrp,4001) ngroups
 4001 format(i5)
      do 4002 i=1,ngroups
      write(lfngrp,4003) igroups(i,5),
     + ldef(igroups(i,1)),ldef(igroups(i,2))
 4003 format(3i5)
 4002 continue
      endif
      if(nord.gt.0) then
      open(unit=lfnord,file=filord(1:index(filord,' ')-1),
     + form='formatted',status='unknown')
      endif
      if(ngroup.gt.0) then
      open(unit=lfnloc,file=filloc(1:index(filloc,' ')-1),
     + form='formatted',status='unknown')
      call ana_lochdr(byte_mb(i_snam),int_mb(i_imol),int_mb(i_isel))
      endif
      endif
c
      if(ldist.gt.0) then
      if(.not.ma_push_get(mt_dbl,2*ldist,'hist',l_hist,i_hist))
     + call md_abort('Failed to allocate hist',0)
      open(unit=lfnhis,file=filhis(1:index(filhis,' ')-1),
     + form='formatted',status='unknown')
      endif
c
      nread=0
      nwrit=0
      nframe=0
   10 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 10
      if(nframe.eq.(nframe/ifrsk)*ifrsk) then
c
      if(lsuper) then
      call super2(dbl_mb(i_xdat+ifr-1),int_mb(i_idat+ifr-1),
     + num,msa,dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms),
     + nsa,msa,.true.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa,.true.)
      call ana_xcollect(dbl_mb(i_xdat),ifr,num,msa)
      endif
c
c     evaluate bond lenghts
c
      do 11 i=1,nbnds
      rbnds(i)=ana_bond(dbl_mb(i_xdat),msa,dbl_mb(i_wdat),mwm,mwa,
     + ibnds(i,1,1),ibnds(i,1,2),ibnds(i,2,1),ibnds(i,2,2),box)
   11 continue
c
c     evaluate angles
c
      do 13 i=1,nangs
      rangs(i)=ana_angle(dbl_mb(i_xdat),msa,dbl_mb(i_wdat),mwm,mwa,
     + iangs(i,1,1),iangs(i,1,2),iangs(i,2,1),iangs(i,2,2),
     + iangs(i,3,1),iangs(i,3,2))
   13 continue
c
c     evaluate torsions
c
      do 14 i=1,ntors
      rtors(i)=ana_torsion(dbl_mb(i_xdat),msa,dbl_mb(i_wdat),mwm,mwa,
     + itors(i,1,1),itors(i,1,2),itors(i,2,1),itors(i,2,2),
     + itors(i,3,1),itors(i,3,2),itors(i,4,1),itors(i,4,2))
   14 continue
c
c     charge histogram
c
      if(ldist.gt.0) then
      if(.not.ltop) call md_abort('Topology needed',0)
      call ana_chgdst(dbl_mb(i_hist),dbl_mb(i_xdat),dbl_mb(i_qdat))
      endif
c
c     write bonded interaction values to file
c
      if(me.eq.0.and.lana) then
      write(lfnana,2323) time,(rbnds(i),i=1,nbnds),(rangs(i),i=1,nangs),
     + (rtors(i),i=1,ntors)
 2323 format(5f12.6)
      nwrit=nwrit+1
      endif
c
c     ramachandran analysis
c
      if(lrama) then
      call ana_rama(dbl_mb(i_xdat),int_mb(i_iram))
      endif
c
c     dielectric analysis
c
      if(ldiel) then
      call ana_diel(dbl_mb(i_xdat),dbl_mb(i_qdat),int_mb(i_isel),
     + dbl_mb(i_wdat),dbl_mb(i_qwdat),int_mb(i_wsel))
      endif
c
c     root mean square deviation
c
      if(lrms) then
      if(np.gt.1) then
      call ana_rmsdev(dbl_mb(i_xdat+ifr-1),int_mb(i_idat+ifr-1),num,
     + dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms))
      else
      call ana_rmsdev(dbl_mb(i_xdat),int_mb(i_idat),nsa,
     + dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms))
      endif
      endif
c
c     hydrogen bond analysis
c
      if(lhbond) then
      call ana_hbond(dbl_mb(i_xdat),dbl_mb(i_wdat),int_mb(i_isel),
     + int_mb(i_hbnd),int_mb(i_temp))
      endif
c
      if(ngroup.gt.0) then
      do 3307 i=1,ngroup
      if(igroup(i,2).eq.1)
     + call ana_grploc(byte_mb(i_snam),int_mb(i_imol),int_mb(i_isel),
     + dbl_mb(i_wt),dbl_mb(i_xdat),i,int_mb(i_wrk))
 3307 continue
      endif
c
      if(lrdf) then
      call ana_rdf(int_mb(i_isel),dbl_mb(i_xdat),dbl_mb(i_wdat),
     + int_mb(i_rdf))
      endif
c
      if(ngroups.gt.0) then
      if(me.eq.0) write(lfngrp,4004) time
 4004 format('frame',/,f12.6)
      do 3301 i=1,ngroups
      if(igroups(i,5).eq.1)
     + call ana_grpcogdis(byte_mb(i_snam),int_mb(i_imol),int_mb(i_isel),
     + dbl_mb(i_wt),dbl_mb(i_xdat),i)
      if(igroups(i,5).eq.2)
     + call ana_grpdis(byte_mb(i_snam),int_mb(i_imol),int_mb(i_isel),
     + dbl_mb(i_wt),dbl_mb(i_xdat),i)
      if(igroups(i,5).eq.4)
     + call ana_grpcogang(byte_mb(i_snam),int_mb(i_imol),int_mb(i_isel),
     + dbl_mb(i_wt),dbl_mb(i_xdat),i)
      if(igroups(i,5).eq.5)
     + call ana_grpvectors(byte_mb(i_snam),int_mb(i_imol),
     + int_mb(i_isel),dbl_mb(i_wt),dbl_mb(i_xdat),i)
 3301 continue
      endif
c
      if(nhis.gt.0) then
      do 3302 i=1,nhis
      call ana_histo(dbl_mb(i_xdat),dbl_mb(i_wdat),i)
 3302 continue
      endif
c
      if(nord.gt.0) then
      call ana_order(dbl_mb(i_xdat))
      endif
c
      ndata=ndata+1
c
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 10
      endif
c
      if(ldist.gt.0) then
      if(.not.ma_pop_stack(l_hist))
     + call md_abort('Failed to deallocate hist',0)
      close(unit=lfnhis)
      endif
c
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      if(lrdf) call ana_rdfwrt(int_mb(i_isel),int_mb(i_rdf))
      if(lana) then
      close(unit=lfnana)
      write(*,'(a)') ' Closing scn file '
      write(*,'(/,a,i10,a,a)') ' Scanned ',nwrit,' frames to ',
     + filana(1:index(filana,' ')-1)
      endif
      if(lrama) close(unit=lfnram)
      if(ldiel) close(unit=lfndie)
      if(lrms) then
      write(*,'(a)') ' Closing scn file '
      write(*,'(/,a,i10,a,a)') ' Scanned ',ndata,' frames to ',
     + filrms(1:index(filrms,' ')-1)
      endif
      if(ngroups.gt.0) then
      close(unit=lfngrp)
      write(*,'(a)') ' Closing grp file '
      write(*,'(/,a,i10,a,a)') ' Scanned ',ndata,' frames to ',
     + filgrp(1:index(filgrp,' ')-1)
      endif
      if(nord.gt.0) then
      do 3308 i=1,nord
      write(lfnord,3309) i,abs(half*(three*rord(i,2)/dble(ndata)-one))
 3309 format(i5,f12.6)
 3308 continue
      close(unit=lfnord)
      write(*,'(a)') ' Closing ord file '
      write(*,'(/,a,i10,a,a)') ' Scanned ',ndata,' frames to ',
     + filord(1:index(filord,' ')-1)
      endif
      if(nhis.gt.0) then
      do 3304 i=1,nhis
      dhis=1.2d0*box(3)/real(idhis(i,2))
      do 3305 j=1,idhis(i,2)
      write(idhis(i,3),3306) rhis+(j-1)*dhis,real(ihis(j,i))/real(ndata)
 3306 format(f12.6,f12.6)
 3305 continue
      close(unit=idhis(i,3))
 3304 continue
      endif
      endif
c
      if(lrdf) then
      print*,'deallocating rdf'
      if(.not.ma_pop_stack(l_rdf))
     + call md_abort('Failed to deallocate rdf',0)
      endif
c
      if(lhbond) then
      if(.not.ma_pop_stack(l_temp))
     + call md_abort('Failed to deallocate temp',0)
      endif
c
      nbnds=0
      nangs=0
      ntors=0
      nimps=0
      lrms=.false.
      lana=.false.
      ldist=0
c
      goto 1
      endif
c
c     calculate average coordinates
c     -----------------------------
c
      if(card(1:6).eq.'saver '.or.card(1:6).eq.'aver  ') then
c
      lsaver=card(1:6).eq.'saver '
c
      if(card(7:7).eq.' ') then
      filcop=' '
      else
      read(card(7:80),'(a)') filcop
      endif
      i=index(filcop,'.')
      if(i.le.0) then
      fmt='pdb'
      else
      fmt=filcop(i+1:i+3)
      endif
c
      if(nsel.eq.0) call md_abort('No atoms selected',0)
c
      call ana_rdhdr(byte_mb(i_snam))
      nave=0
      nread=0
      nframe=0
    4 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 4
      if(nframe.eq.(nframe/ifrsk)*ifrsk) then
      if(lsaver) then
      call super2(dbl_mb(i_xdat+ifr-1),int_mb(i_idat+ifr-1),num,msa,
     + dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms),
     + nsa,msa,.true.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa,.true.)
      call ana_xcollect(dbl_mb(i_xdat),ifr,num,msa)
      endif
c
      call ana_xaver(dbl_mb(i_xdat+ifr-1),dbl_mb(i_xadat+ifr-1),
     + num,msa,nave)
c
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 4
      endif
c
      if(me.eq.0) then
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      endif
c
      call ana_xmean(dbl_mb(i_xadat+ifr-1),num,msa,nave)
      if(np.gt.1) call ana_update(dbl_mb(i_xadat),msa,ifr,ifr+num-1)
c
      if(me.eq.0) then
      write(*,'(/,a,i10,a)') ' Averaged ',nave,' frames'
      endif
c
      if(filcop(1:1).ne.' ') then
      if(fmt.eq.'pdb') then
      call ana_wrtpdb(lfncop,filcop,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xadat),int_mb(i_wsel),dbl_mb(i_wdat),.false.,.false.,
     + int_mb(i_ndxw))
      elseif(fmt.eq.'xyz') then
      call ana_wrtxyz(lfncop,filcop,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xadat),dbl_mb(i_qdat),int_mb(i_wsel),dbl_mb(i_wdat),
     + .false.,.false.,int_mb(i_ndxw))
      endif
      if(lsaver) then
      write(*,'(/,a,a)')
     +  ' Averaged superimposed coordinates written to ',
     + filcop(1:index(filcop,' ')-1)
      else
      write(*,'(/,a,a)')
     +  ' Averaged coordinates written to ',
     + filcop(1:index(filcop,' ')-1)
      endif
      endif
      goto 1
      endif
c
c     build covariance matrix
c     -----------------------
c
      if(card(1:6).eq.'covar ') then
      fil=card(8:80)
      if(nsel.eq.0) call md_abort('No atoms selected',0)
c
      if(active) call ana_edfinal()
      active=.true.
c
      call ana_rdhdr(byte_mb(i_snam))
      nave=0
      nread=0
      nframe=0
      call ana_edinit()
    5 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 5
      if(nframe.eq.(nframe/ifrsk)*ifrsk) then
      call super2(dbl_mb(i_xdat+ifr-1),int_mb(i_idat+ifr-1),num,msa,
     + dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms),
     + nsa,msa,.true.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa,.true.)
      call ana_xcollect(dbl_mb(i_xdat),ifr,num,msa)
c
      if(np.gt.1) call ana_update(dbl_mb(i_xdat),msa,ifr,ifr+num-1)
c
      call ana_covar(int_mb(i_ndx),dbl_mb(i_cov),int_mb(i_isel),
     + dbl_mb(i_xdat),dbl_mb(i_xadat))
c
      nave=nave+1
c
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 5
      endif
c
      call ga_sync()
      call ga_scale(ga_cov,1.0d0/dble(nave))
c
      if(me.eq.0) then
      if(util_print('frames_read',print_debug)) then
      write(*,'(/,a)') ' Covariance matrix generation completed'
      endif
      endif
c
      call ga_sync()
c      call ga_print(ga_cov)
      call ga_diag_std(ga_cov,ga_vec,dbl_mb(i_cov))
c
      call ga_sync()
      do 19 i=1,3*nsel
      int_mb(i_ord+i-1)=i
   19 continue
      do 17 i=1,3*nsel-1
      do 18 j=i+1,3*nsel
      if(abs(dbl_mb(i_cov-1+int_mb(i_ord+i-1))).lt.
     + abs(dbl_mb(i_cov-1+int_mb(i_ord+j-1)))) then
      k=int_mb(i_ord+i-1)
      int_mb(i_ord+i-1)=int_mb(i_ord+j-1)
      int_mb(i_ord+j-1)=k 
      endif
   18 continue
   17 continue
c
      if(me.eq.0) then
      write(*,'(/,a,i10,a)') ' Covariance matrix diagonalized for ',
     + nave,' frames'
      write(*,'(/,a,//,(5x,6e12.5))') ' Eigenvalues',
     + (dbl_mb(i_cov-1+int_mb(i_ord+i-1)),i=1,3*nsel)
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      endif
c
      goto 1
      endif
c
c     projection
c     ----------
c
      if(card(1:6).eq.'projec') then
      lesd=.true.
      read(card(8:14),'(i7)') ivec
      fil=card(15:80)
      i=index(fil,'.')
      if(i.eq.0) then
      fmt='trj'
      filprj=fil(1:index(fil,' ')-1)//'.trj'
      filval=fil(1:index(fil,' ')-1)//'.val'
      filvec=fil(1:index(fil,' ')-1)//'.vec'
      filtcl=fil(1:index(fil,' ')-1)//'.tcl'
      filecc=fil(1:index(fil,' ')-1)//'.ecce.out'
      filmin=fil(1:index(fil,' ')-1)//'_min.pdb'
      filmax=fil(1:index(fil,' ')-1)//'_max.pdb'
      filamp=fil(1:index(fil,' ')-1)//'.amp'
      else
      filprj=fil
      fmt=filprj(i+1:i+3)
      filval=fil(1:i-1)//'.val'
      filvec=fil(1:i-1)//'.vec'
      filtcl=fil(1:i-1)//'.tcl'
      filecc=fil(1:i-1)//'.ecce.out'
      filmin=fil(1:i-1)//'_min.pdb'
      filmax=fil(1:i-1)//'_max.pdb'
      filamp=fil(1:i-1)//'.amp'
      endif
c
      if(nsel.eq.0) call md_abort('No atoms selected',0)
      if(.not.active) call md_abort('No ED matrix active',0)
c
      if(me.eq.0) then
      open(unit=lfnprj,file=filprj(1:index(filprj,' ')-1),
     + form='formatted',status='unknown',err=9999)
      open(unit=lfnval,file=filval(1:index(filval,' ')-1),
     + form='formatted',status='unknown',err=9999)
      endif
c
      call ana_wthdr(lfnprj,fmt,byte_mb(i_snam),byte_mb(i_tag),
     + int_mb(i_isel),.false.)
c
      k=int_mb(i_ord+ivec-1)
      call ga_get(ga_vec,1,3*nsel,k,k,dbl_mb(i_cov),1)
c
      call ana_rdhdr(byte_mb(i_snam))
      nave=0
      nread=0
      nframe=0
c
      valmin=1.0d0
      valmax=-1.0d0
c
    6 continue
      if(ana_rdfram(dbl_mb(i_xdat),int_mb(i_idat),dbl_mb(i_wdat))) then
      nread=nread+1
      if(nread.lt.ifrfr) goto 6
      if(nframe.eq.(nframe/ifrsk)*ifrsk) then
c      call super2(dbl_mb(i_xdat+ifr-1),int_mb(i_idat+ifr-1),num,msa,
c     + dbl_mb(i_xref),dbl_mb(i_swt),dbl_mb(i_wt),dbl_mb(i_xrms),
c     + nsa,msa,.true.,rms0,rms1,dbl_mb(i_wdat),mwm,nwm,mwa,nwa,.true.)
      call ana_xcollect(dbl_mb(i_xdat),ifr,num,msa)
c
      if(np.gt.1) call ana_update(dbl_mb(i_xdat),msa,ifr,ifr+num-1)
c
      call ana_projec(int_mb(i_ndx),dbl_mb(i_cov),int_mb(i_isel),
     + dbl_mb(i_xdat),dbl_mb(i_xadat),msa,val,
     + dbl_mb(i_xp))
c
      lxw=.false.
      call ana_wtfram(lfnprj,fmt,dbl_mb(i_xp),byte_mb(i_snam),
     + dbl_mb(i_wdat),int_mb(i_isel),byte_mb(i_tag),dbl_mb(i_val),
     + int_mb(i_wsel),int_mb(i_ndxw))
c
      nave=nave+1
c
      if(me.eq.0) then
      write(lfnval,'(i5,f12.6)') nave,val
      endif
c
      endif
      nframe=nframe+1
      if(ifrto.lt.ifrfr.or.nread.lt.ifrto) goto 6
      endif
c
      if(.not.ana_wrtvec(ivec,fil,int_mb(i_ndx),dbl_mb(i_xadat)))
     + goto 9999
c
      lesd=.false.
c
      goto 1
      endif
c
c     make report from file
c     ---------------------
c
      if(card(1:6).eq.'report') then
      option=card(8:15)
      fil=card(16:80)
      call ana_report_file(option,fil,lfnloc)
      endif
c
c     generate esp grid from an xyzq file
c     -----------------------------------
c
      if(card(1:6).eq.'espplt') then
c
      string=card(8:80)
      read(string(1:4),'(i4)') ngrid
      read(string(5:8),'(i4)') iesppb
      read(string(9:20),'(f12.6)') rcut
      string=card(28:80)
      i=index(string,' ')
      filchg=string(1:i)
      filplt=string(i+1:80)
      filepz=filplt(1:index(filplt,'.'))//'epz '
c
      if(filchg(1:1).ne.' ') call ana_pltgrd(.true.,int_mb(i_isel))
c
      goto 1
      endif
c
      if(me.eq.0) close(unit=lfncmd,status='delete')
c      if(me.eq.0) close(unit=lfncmd,status='keep')
c
      if(active) call ana_edfinal()
c
      if(.not.ma_pop_stack(l_sbnd))
     + call md_abort('Could not deallocate sbnd',0)
      if(.not.ma_pop_stack(l_imol))
     + call md_abort('Could not deallocate imol',0)
      if(.not.ma_pop_stack(l_iram))
     + call md_abort('Could not deallocate iram',0)
c
      call ana_finish(byte_mb(i_snam),.true.)
c
      if(.not.ma_pop_stack(l_wrk))
     + call md_abort('Could not deallocate iwrk',0)
c
      ignore=rtdb_parallel(.true.)
c
      return
c
 9999 continue
      call md_abort('Error opening command file',0)
c
      return
      end
      subroutine ana_update(x,m,ifr,ito)
c
      implicit none
c
      integer m,ifr,ito
      real*8 x(m,3)
c
#include "global.fh"
#include "msgids.fh"
c
      integer i,j
c
      if(ifr.gt.1) then
      do 1 j=1,3
      do 2 i=1,ifr-1
      x(i,j)=0.0d0
    2 continue
    1 continue
      endif
      if(ito.lt.m) then
      do 3 j=1,3
      do 4 i=ito+1,m
      x(i,j)=0.0d0
    4 continue
    3 continue
      endif
c
      call ga_dgop(mag_d12,x,3*m,'+')
c
      return
      end
      subroutine ana_anahdr(sgmnam)
c
      implicit none
c
#include "ana_common.fh"
#include "ana_params.fh"
c
      character*16 sgmnam(nsa)
      character*11 atom(4)
      integer i,j
c
      write(lfnana,1000) nbnds,nangs,ntors,nimps
 1000 format(4i10)
c
      do 1 i=1,nbnds
      do 11 j=1,2
      if(ibnds(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(ibnds(i,j,1))(12:16),':',
     + sgmnam(ibnds(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+ibnds(i,j,1),':',
     + wnam(ibnds(i,j,2))(6:10)
      endif
   11 continue
c
      write(lfnana,1001) (atom(j),j=1,2)
 1001 format(a11,'-',a11)
    1 continue
c
      do 2 i=1,nangs
      do 21 j=1,3
      if(iangs(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(iangs(i,j,1))(12:16),':',
     + sgmnam(iangs(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+iangs(i,j,1),':',
     + wnam(iangs(i,j,2))(6:10)
      endif
   21 continue
      write(lfnana,1002) (atom(j),j=1,3)
 1002 format(a11,'-',a11,'-',a11)
    2 continue
c
      do 3 i=1,ntors
      do 31 j=1,4
      if(itors(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(itors(i,j,1))(12:16),':',
     + sgmnam(itors(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+itors(i,j,1),':',
     + wnam(itors(i,j,2))(6:10)
      endif
   31 continue
      write(lfnana,1003) (atom(j),j=1,4)
 1003 format(a11,'-',a11,'-',a11,'-',a11)
    3 continue
c
      do 4 i=1,nimps
      do 41 j=1,4
      if(iimps(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(iimps(i,j,1))(12:16),':',
     + sgmnam(iimps(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+iimps(i,j,1),':',
     + wnam(iimps(i,j,2))(6:10)
      endif
   41 continue
      write(lfnana,1003) (atom(j),j=1,4)
    4 continue
c
      return
      end
      logical function ana_wrtvec(ivec,fil,ndx,xa)
c
      implicit none
c
#include "ana_common.fh"
#include "ana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer ivec
      character*255 fil
      integer i,j,k,l
      real*8 value,xa(msa,3)
      integer ndx(nsa)
c
      if(me.eq.0) then
      open(unit=lfntcl,file=filtcl(1:index(filtcl,' ')-1),
     + form='formatted',status='unknown',err=9999)
      open(unit=lfnvec,file=filvec(1:index(filvec,' ')-1),
     + form='formatted',status='unknown',err=9999)
      open(unit=lfnecc,file=filecc(1:index(filecc,' ')-1),
     + form='formatted',status='unknown',err=9999)
      open(unit=lfnamp,file=filamp(1:index(filamp,' ')-1),
     + form='formatted',status='unknown',err=9999)
      k=0
      l=0
      do 15 i=1,nsel
      value=0.0d0
      do 16 j=1,3
      value=value+(dbl_mb(i_cov+k))**2
      k=k+1
   16 continue
      l=l+1
      write(lfntcl,5555)
     + (10.0*xa(ndx(i),j),j=1,3),
     + (dbl_mb(i_cov+k-4+j),j=1,3)
 5555 format('draw vector2 {',3f12.6,'} {',3f12.6,'} 1.0 10')
      write(lfnamp,'(i5,f12.6)') i,sqrt(value)
   15 continue
c
      write(lfnecc,3013)
 3013 format('%begin%input file%1%char',/,
     + 'geometry noautosym units nm')
      do 314 i=1,nsa
      if(int_mb(i_osel+i-1).eq.1) then
      if(byte_mb(i_snam+(i-1)*16+5).eq.'2'.or.
     + byte_mb(i_snam+(i-1)*16+5).eq.'3'.or.
     + byte_mb(i_snam+(i-1)*16+5).eq.'4') then
      write(lfnecc,3014) ' ',byte_mb(i_snam+(i-1)*16+6),
     + (dbl_mb(i_xadat+i-1+j*msa),j=0,2)
      else
      write(lfnecc,3014) (byte_mb(i_snam+(i-1)*16+j),j=5,6),
     + (dbl_mb(i_xadat+i-1+j*msa),j=0,2)
      endif
 3014 format(2a1,1x,3f12.6)
      endif
  314 continue
      write(lfnecc,3012) nselo
 3012 format('end',/,'basis "ao basis" spherical print',/,
     + ' C library "6-31+G*"',/,
     + ' N library "6-31+G*"',/,
     + ' O library "6-31+G*"',/,
     + ' H library "6-31+G*"',/,
     + ' S library "6-31+G*"',/,
     + ' P library "6-31+G*"',/,
     + ' Ca library "6-31+G*"',/,
     + ' Na library "6-31+G*"',/,
     + 'end',/,
     + 'task scf gradient',/,
     + '%end%input file%1%char',/,
     + 'task_gradient%begin%total gradient%3 ',i7,'%double')
c
      k=0
      do 315 i=1,nsa
      if(int_mb(i_osel+i-1).eq.1) then
      if(int_mb(i_isel+i-1).eq.0) then
      write(lfnecc,3015) 0.0d0,0.0d0,0.0d0
 3015 format(3f12.6)
      else
      write(lfnecc,3015) (dbl_mb(i_cov+k+j),j=0,2)
      k=k+3
      endif
      endif
  315 continue
      write(lfnecc,3011) nselo
 3011 format('task_gradient%end%total gradient%3 ',i7,'%double')
c
      close(unit=lfntcl)
      close(unit=lfnvec)
      close(unit=lfnecc)
      close(unit=lfnval)
      close(unit=lfnprj)
      close(unit=lfnamp)
      write(*,'(/,a,i5,a,a)') ' Projection of vector ',ivec,
     +' written to ',fil(1:index(fil,' ')-1)
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      endif
      ana_wrtvec=.true.
      return
 9999 continue
      ana_wrtvec=.false.
      return
      end
      subroutine ana_xcollect(x,ifrom,nx,mx)
c
      implicit none
c
#include "ana_common.fh"
#include "ana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer ifrom,nx,mx
      real*8 x(mx,3)
c
      integer i,j
c
      if(np.gt.1) then
c
      do 1 j=1,3
      do 2 i=1,ifrom-1
      x(i,j)=zero
    2 continue
    1 continue
c
      do 3 j=1,3
      do 4 i=ifrom+nx+1,mx
      x(i,j)=zero
    4 continue
    3 continue
c
      call ga_dgop(mag_d08,x,3*mx,'+')
c
      endif
c
      return
      end
     

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c $Id: pg2test.F,v 1.6 2004-12-01 22:39:46 manoj Exp $
c vector boxes lack arithmetic precision 
#ifdef CRAY_YMP
# define THRESH 1d-10
# define THRESHF 1e-5
#elif defined(FUJITSU)
# define THRESH 1d-12
# define THRESHF 1e-5
#else
# define THRESH 1d-13
# define THRESHF 1e-5
#endif

#define MISMATCH(x,y) abs(x-y)/max(1d0,abs(x)).gt.THRESH
#define MISMATCHF(x,y) abs(x-y)/max(1.0,abs(x)).gt.THRESHF 

#define NEW_API
c#define GA3
#define NGA_GATSCAT

      program main
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer heap, stack, fudge, ma_heap, me, nproc
      integer inode,proclist(100),i,j,nprocs
      integer proc_group(0:100)
      logical status
      parameter (heap=200*200*4, fudge=100, stack=200*200)
      integer n,m,grp_id
      parameter (n = 128)
      integer ndim, dims(2), chunk(2)
      integer g_w, midproc
c     
c***  Intitialize a message passing library
c
#include "mp3.fh"
c
c***  Initialize GA
c
c     There are 2 choices: ga_initialize or ga_initialize_ltd.
c     In the first case, there is no explicit limit on memory usage.
c     In the second, user can set limit (per processor) in bytes.
c
      call ga_initialize()
      nproc = ga_nnodes()
      me = ga_nodeid()
c
c***  Initialize the MA package
c     MA must be initialized before any global array is allocated
c
      ma_heap = heap/nproc + fudge 
      ma_heap = 2*ma_heap
      status = ma_init(MT_DCPL, stack, ma_heap)
      if (.not. status) call ga_error('ma_init failed',-1) 
c
c     we can also use GA_set_memory_limit BEFORE first ga_create call
c
      call GA_set_memory_limit(util_mdtob(ma_heap))
c
c***  Create a global array on the current default (world) group
c
      ndim = 2
      dims(1) = n
      dims(2) = n
      g_w = ga_create_handle()
      call ga_set_data(g_w,ndim,dims,MT_DBL)
      call ga_set_array_name(g_w,'w')
      status = ga_allocate(g_w)
      call ga_zero(g_w)
c
      midproc = nproc/2
      do i = 1, midproc
        proclist(i) = i-1
      end do
      nprocs = midproc
      proc_group(0) = ga_pgroup_create(proclist, nprocs)
      do i = midproc + 1, nproc
        proclist(i-midproc) = i-1
      end do
      nprocs = nproc - midproc
      proc_group(1) = ga_pgroup_create(proclist, nprocs)

c
      write(6,*) 'Groups have been created'
      call ga_sync()
      if (me.ge.midproc) then
          call runtest(proc_group(1), g_w)
      else
      endif
c
c***  Check if memory limits are enforced 
c
c      call check_mem(util_mdtob(ma_heap*ga_nnodes()))
c
c***  Tidy up the GA package
c
      call ga_sync()
      write(0,*) 'Calling ga_terminate'
      call ga_terminate()
c
c***  Tidy up after message-passing library
c
      call MP_FINALIZE()
c
      stop
      end
c
      subroutine runtest(grp_id, g_w)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer me, nproc, grp_id, g_w
      logical status

      me = ga_pgroup_nodeid(grp_id)
      nproc = ga_pgroup_nnodes(grp_id)

      if(me.eq.0)then
         print *,' GA initialized '
         call ffflush(6)
      endif
c
c
c     Uncomment the below line to register external memory allocator
c     for dynamic arrays inside GA routines.
c      call register_ext_memory()
c
      if(me.eq.(nproc-1))then
        print *, 'using ', nproc,' process(es) ', ga_cluster_nnodes(),
     $           ' cluster nodes'
        print *,'process ', me, ' is on node ',ga_cluster_nodeid(),
     $          ' with ',  ga_cluster_nprocs(-1), ' processes' 
        call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
c***  Check support for double precision arrays
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' CHECKING DOUBLES  '
         write(6,*)
         call ffflush(6)
      endif

      call check_dbl(grp_id, g_w)
c
c***  Check support for double precision complex arrays
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' CHECKING DOUBLE COMPLEX  '
         write(6,*)
         call ffflush(6)
      endif

      call check_complex(grp_id)
c
c***  Check support for integer arrays
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' CHECKING INTEGERS  '
         write(6,*)
         call ffflush(6)
      endif

      call check_int(grp_id)
c
c
c***  Check support for single precision
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' CHECKING SINGLE PRECISION  '
         write(6,*)
         call ffflush(6)
      endif
 
      call check_flt(grp_id) 
c     
      if (me.eq.0) then
         write(6,*)
         write(6,*)'CHECKING Wrappers to Message Passing Collective ops'
         write(6,*)
         call ffflush(6)
      endif

      call check_wrappers(grp_id)
c
      if(me.eq.0) call ga_print_stats()
      if(me.eq.0) print *,' ' 
      if(me.eq.0) print *,'All tests succesful ' 
c
      return
      end


      subroutine check_dbl(grp_id, g_w)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c     
      integer n,m,grp_id
      parameter (n = 128)
      parameter (m = 2*n)
      double precision a(n,n), b(n,n), v(m),w(m)
      integer ndim, dims(2), chunk(2)
      integer iv(m), jv(m)
#ifdef NGA_GATSCAT
      integer ijv(2,m)
#endif
      logical status
      integer g_a, g_b, g_w
      integer iran, i,j, loop,nloop,maxloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, int, ij, inc, ii, jj
      parameter (maxloop = 100)
      integer maxproc
      parameter (maxproc = 128)
      double precision crap, sum1, sum2, x
      double precision nwords
      logical found
      integer lprocs,inode,iproc,nnodes
      intrinsic int
      iran(i) = int(drand(0)*real(i)) + 1
c     
      nproc = ga_pgroup_nnodes(grp_id)
      me    = ga_pgroup_nodeid(grp_id)
      lprocs = nproc
      inode = me
      nnodes = ga_cluster_nnodes()
      iproc = me
      nloop = Min(maxloop,n)
c     
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = i-1 + (j-1)*n
            b(i,j) =-1. 
         enddo
      enddo
*      write(6,*) ' correct '
*      call output(a, 1, n, 1, n, n, n, 1)
*      call ffflush(6)
c
c     Create a global array
c
c     print *,ga_nodeid(), ' creating array'
*     call ffflush(6)
c     call setdbg(1)
      g_a = ga_create_handle()
      ndim = 2
      dims(1) = n
      dims(2) = n
      call ga_set_data(g_a,ndim,dims,MT_DBL)
      call ga_set_array_name(g_a,'a')
      write(6,*) 'grp_id ',grp_id
      call ga_set_pgroup(g_a,grp_id)
      status = ga_allocate(g_a)
      if (.not. status) then
         write(6,*) ' ga_create failed'
         call ffflush(6)
         call ga_error('... exiting ',0)
      endif
c
c     check if handle is valid. be quiet unless error
c
      if(.not.ga_valid_handle(g_a)) call ga_error("invalid handle",g_a)
c
      call ga_distribution(g_a,me,ilo, ihi, jlo, jhi)
      call ga_pgroup_sync(grp_id)
c     
c     Zero the array
c
      if (me .eq. 0) then 
         write(6,21) 
 21      format(/'> Checking zero ... ')
         call ffflush(6)
      endif
      call ga_zero(g_a)

c
c     Check that it is indeed zero
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      call ga_pgroup_sync(grp_id)
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. 0.0d0) then
               write(6,*) me,' zero ', i, j, b(i,j)
               call ffflush(6)
c              call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_zero is OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Each node fills in disjoint sections of the array
c
      if (me .eq. 0) then
         write(6,2) 
 2       format(/'> Checking disjoint put ... ')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      inc = (n-1)/20 + 1
      inc = n
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
*               write(6,4) me, ilo, ihi, jlo, jhi
* 4             format(' node ',i2,' checking put ',4i4)
*               call ffflush(6)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_pgroup_sync(grp_id)
c
c     All nodes check all of a
c
      call util_dfill(n*n, 0.0d0, b, 1)
*     call ga_print(g_a,1)
      call ga_get(g_a, 1, n, 1, n, b, n)
*      write(6,*) ' after get'
*      call output(b, 1, n, 1, n, n, n, 1)
c
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' put ', me, i, j, a(i,j),b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_put is OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Now check nloop random gets from each node
c
      if (me .eq. 0) then
         write(6,5) nloop
 5       format(/'> Checking random get (',i5,' calls)...')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      nwords = 0
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c     
         call util_dfill(n*n, 0.0d0, b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
         if (me .eq. 0 .and. mod(loop-1, max(1,nloop/20)).eq.0) then
            write(6,1) loop, me, ilo, ihi, jlo, jhi, nwords
 1          format(' call ',i5, ' node ',i2,' checking get ',4i4,
     $           ' total ',d9.2)
            call ffflush(6)
         endif
         sum1 = 0.0d0
         do j = jlo, jhi
            do i = ilo, ihi
               sum1 = sum1 + b(i,j)
               if (b(i,j) .ne. a(i,j)) then
                  write(6,*) i, j, b(i,j), a(i,j)
                  call ffflush(6)
                  call ga_error('... exiting ',0)
               endif
            enddo
         enddo
c
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_get is OK'
         write(6,*)
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Each node accumulates into disjoint sections of the array
c
      if (me .eq. 0) then
         write(6,9) 
 9       format(/'> Checking accumulate ... ')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c     
      crap = drand(12345)       ! Same seed for each process
      do j = 1, n
         do i = 1, n
c           b(i,j) = drand(0)
            b(i,j) = i+j 
         enddo
      enddo
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
c           x = drand(0)
            x = 10.
            ilo = i
            ihi = min(i+inc-1, n)
            if(ihi.eq.n-1)ihi=n
c           ihi = min(i+inc, n)
            jlo = j
            jhi = min(j+inc-1, n)
            if(jhi.eq.n-1)jhi=n
c           jhi = min(j+inc-1, n)
*               call ffflush(6)
            if (mod(ij,nproc) .eq. me) then
c               print *, me, 'checking accumulate ',ilo,ihi,jlo,jhi,x
* 11            format(' node ',i2,' checking accumulate ',4i4)
*               call ffflush(6)
               call ga_acc(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n, x)
            endif
            ij = ij + 1
c     
c           Each process applies all updates to its local copy
c
            do jj = jlo, jhi
               do ii = ilo, ihi
                  a(ii,jj) = a(ii,jj) + x * b(ii,jj)
               enddo
            enddo
         enddo
      enddo
      call ga_pgroup_sync(grp_id)
c
c     All nodes check all of a
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if(MISMATCH(b(i,j),a(i,j)))then
               write(6,*) ' acc ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
c              call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' disjoint ga_acc is OK'
         write(6,*)
      endif
c
c     overlapping accumulate
      call ga_pgroup_sync(grp_id)
      g_b = ga_create_handle()
      call ga_set_data(g_b,ndim,dims,MT_DBL)
      call ga_set_array_name(g_b,'b')
      call ga_set_pgroup(g_b,grp_id)
      if (.not.ga_allocate(g_b)) then
         call ga_error('ga_create failed for second array ',0)
      endif
c
      call ga_zero(g_b)
      call ga_pgroup_sync(grp_id)
      call ga_acc(g_b, n/2, n/2, n/2, n/2, 1d0, 1, 1d0)
      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         call ga_get(g_b, n/2, n/2, n/2, n/2, b(1,1), 1)
         x = abs(b(1,1) -1d0*nproc)
         if(x.gt. 1d-10)then
            write(6,*)'val=',b(1,1),' expected=',nproc, x
            call ga_error('overlapping accumulate failed',0)
         endif
         if (me.eq.0) then
           write(6,*)
           write(6,*) ' overlapping ga_acc is OK'
           write(6,*)
         endif
      endif
c
c     Check the ga_add function
c
      if (me .eq. 0) then
         write(6,91)
 91      format(/'> Checking add ...')
         call ffflush(6)
      endif
c
c
      crap = drand(12345)       ! Everyone has same seed
      do j = 1, n
         do i = 1, n
            b(i,j) = drand(0)
            a(i,j) = 0.1d0*a(i,j) + 0.9d0*b(i,j)
         enddo
      enddo
      
      if (me.eq.0) call ga_put(g_b, 1, n, 1, n, b, n)
      call ga_add(0.1d0, g_a, 0.9d0, g_b, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if(MISMATCH(b(i,j), a(i,j)))then
               write(6,*) ' add ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0) 
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' add is OK '
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Check the ddot function
c
      if (me .eq. 0) then
         write(6,19) 
 19      format(/'> Checking ddot ...')
         call ffflush(6)
      endif
      crap = drand(12345)       ! Everyone has same seed
      sum1 = 0.0d0
      do j = 1, n
         do i = 1, n
            b(i,j) = drand(0)
            sum1 = sum1 + a(i,j)*b(i,j)
         enddo
      enddo
      if (me.eq.0) then 
         call ga_put(g_b, 1, n, 1, n, b, n)
         call ga_put(g_a, 1, n, 1, n, a, n)
      endif
      call ga_pgroup_sync(grp_id)
      sum2 = ga_ddot(g_a,g_b)
      if(MISMATCH(sum1, sum2))then
         write(6,*) ' ddot wrong ', sum1, sum2
         call ffflush(6)
         call ga_error('... exiting ',0)
      else if (me.eq.0) then
         write(6,*)
         write(6,*) ' ddot is OK '
         write(6,*)
      endif
c
c     Check the ga_scale function
c
      if (me .eq. 0) then
         write(6,92)
 92      format(/'> Checking scale ...')
         call ffflush(6)
      endif
      call ga_scale(g_a, 0.123d0)
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            a(i,j) = a(i,j)*0.123d0
            if (MISMATCH(b(i,j), a(i,j)))then
               write(6,*) ' dscal ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scale is OK '
         write(6,*)
      endif
c
c     Check the ga_copy function
c
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking copy'
         write(6,*)
         call ffflush(6)
      endif
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      call ga_copy(g_a, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' copy ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' copy is OK '
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Check the ga_copy function between two groups
c
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking copy between groups'
         write(6,*)
         call ffflush(6)
      endif
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      call ga_copy(g_a, g_w)
      call ga_get(g_w, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' copy ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' copy is OK from small group to big group'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
      call ga_zero(g_a)
      call ga_copy(g_w, g_a)
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' copy ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' copy is OK from big group to small group'
         write(6,*)
      endif
c
c     Test copy_patch
c
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking copy_patch between groups'
         write(6,*)
         call ffflush(6)
      endif
c
c   klugy mechanism for zeroing g_w
c
      call ga_zero(g_a)
      call ga_copy(g_a,g_w)
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
c
      ilo = n/4+1
      jlo = n/4+1
      ihi = ilo + n/2
      jhi = jlo + n/2
      call ga_copy_patch('n',g_a,ilo,ihi,jlo,jhi,g_w,ilo,ihi,jlo,jhi)
      call ga_get(g_w, 1, n, 1, n, b, n)
      do j = jlo, jhi
         do i = ilo, ihi
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' copy ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' copy_patch is OK from small group to big group'
         write(6,*)
      endif
c
      call ga_zero(g_a)
      call ga_copy_patch('n',g_w,ilo,ihi,jlo,jhi,g_a,ilo,ihi,jlo,jhi)
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = jlo, jhi
         do i = ilo, ihi
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' copy ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' copy_patch is OK from big group to small group'
         write(6,*)
      endif
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*) '> Checking scatter/gather (might be slow)... '
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      do j = 1, 10 
       call ga_pgroup_sync(grp_id)
       itmp = iran(nproc)-1
       if(me.eq.itmp) then
#ifndef NGA_GATSCAT
         do loop = 1,m 
           ilo = iran(n) 
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
         enddo 
         write(6,*) 'Calling ga_gather'
         call ga_gather(g_a, v, iv, jv, m)
         write(6,*) 'Completed ga_gather'
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,v(loop),1)
           if(v(loop)  .ne. a(ilo,jlo))then
             write(6,*)me,' gather ', ilo,',',jlo,',', a(ilo,jlo)
     &             ,' ',v(loop)
             call ffflush(6)
             call ga_error('... exiting ',0)
           endif
         enddo
#else
         do loop = 1,m 
           ilo = iran(n) 
           jlo = iran(n)
           ijv(1,loop) = ilo
           ijv(2,loop) = jlo
         enddo 
         call nga_gather(g_a, v, ijv, m)
         do loop = 1,m
           ilo= ijv(1,loop)
           jlo= ijv(2,loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,v(loop),1)
           if(v(loop)  .ne. a(ilo,jlo))then
             write(6,*)me,' gather ', ilo,',',jlo,',', a(ilo,jlo)
     &             ,' ',v(loop)
             call ffflush(6)
             call ga_error('... exiting ',0)
           endif
         enddo
#endif
       endif
      enddo
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' gather is  OK'
         write(6,*)
         call ffflush(6)
      endif
c

      do j = 1,10 
       call ga_pgroup_sync(grp_id)
       if(me.eq.iran(ga_pgroup_nnodes(grp_id))-1) then
#ifndef NGA_GATSCAT
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
c          v(loop) = DSIN(a(ilo,jlo)+b(ilo,jlo)) 
           v(loop) = 1d0 *(ilo+jlo)
         enddo 
         call ga_scatter(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop) 
           call ga_get(g_a,ilo,ilo,jlo,jlo,w(loop),1)
c          if(v(loop)  .ne. w(loop))then 
           if(w(loop)  .ne. 1d0 *(ilo+jlo) )then 
             write(6,*)me,' scatter ', ilo,',',jlo,',',w(loop) 
     &             ,' ', 1d0 *(ilo+jlo) 
             call ffflush(6)
             call ga_error('... exiting ',0)
           endif
         enddo 
#else
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           ijv(1,loop) = ilo
           ijv(2,loop) = jlo
c          v(loop) = DSIN(a(ilo,jlo)+b(ilo,jlo)) 
           v(loop) = 1d0 *(ilo+jlo)
         enddo 
         call nga_scatter(g_a, v, ijv, m)
         do loop = 1,m
           ilo= ijv(1,loop)
           jlo= ijv(2,loop) 
           call ga_get(g_a,ilo,ilo,jlo,jlo,w(loop),1)
c          if(v(loop)  .ne. w(loop))then 
           if(w(loop)  .ne. 1d0 *(ilo+jlo) )then 
             write(6,*)me,' scatter ', ilo,',',jlo,',',w(loop) 
     &             ,' ', 1d0 *(ilo+jlo) 
             call ffflush(6)
             call ga_error('... exiting ',0)
           endif
         enddo 
#endif
       endif
       call ga_pgroup_sync(grp_id)
      enddo
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scatter is  OK'
         write(6,*)
      endif
c
      call ga_pgroup_sync(grp_id)
c
c     scatter-acc available in GA ver. 3.0
#ifdef GA3
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' checking scatter-accumulate'
         write(6,*)
      endif
c
      crap = drand(1234)
      call ga_zero(g_a)
c
      do j = 1, n
         do i = 1, n
            b(i,j) =0.
         enddo
      enddo
c
      x = .1d0
      ii =n
      do jj = 1,1 
        call ga_pgroup_sync(grp_id)
        do loop = 1, ii 

c         generate unique i,j pairs
10        continue
          i = iran(n)
          j=iran(n)
          if (found(i,j, iv, jv, loop-1) ) goto 10
#ifndef NGA_GATSCAT
          iv(loop) = i
          jv(loop) = j
#else
          ijv(1,loop) = i
          ijv(2,loop) = j
#endif
          v(loop) = 1d0 *(i+j)
          b(i,j) = b(i,j) + nproc*x*v(loop) ! update local ref. array
        enddo


#ifndef NGA_GATSCAT
        call ga_scatter_acc(g_a,v,iv,jv, ii,x)
#else
        call nga_scatter_acc(g_a,v,ijv,ii,x)
#endif

c
        call ga_pgroup_sync(grp_id)
c     
c       check the result
c
        call ga_get(g_a, 1, n, 1,n, a, n)

        do loop = 1,ii
#ifndef NGA_GATSCAT
          i = iv(loop)
          j = jv(loop)
#else
          i = ijv(1,loop)
          j = ijv(2,loop)
#endif
          if(MISMATCH(a(i,j),b(i,j)))then
             print *,'Error',i,j,loop,a(i,j),'expected=',b(i,j)  
*            if(me.eq.0)then
*              do ii=1,loop
*                   print *,'element',ii, iv(ii),jv(ii)
*              enddo
*            endif
             call ga_error('scatter-acc error in trial ',jj) 
          endif
        enddo
        call ga_pgroup_sync(grp_id)

      enddo

      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scatter-accumulate is  OK'
         write(6,*)
      endif
#endif

c
c     Delete the global arrays
c
      status = ga_destroy(g_b)
      status = ga_destroy(g_a)
c     
      return
      end

c-----------------------------------------------------------------
      subroutine check_complex(grp_id)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c
      integer n,m,grp_id
      parameter (n = 60)
      parameter (m = 2*n)
      double complex a(n,n), b(n,n), v(m),w(m)
      integer ndim, dims(2), chunk(2), p_mirror
      integer iv(m), jv(m)
      logical status
      integer g_a, g_b
      integer iran, i,j, loop,nloop,maxloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, int, ij, inc, ii, jj, nnodes
      parameter (maxloop = 100)
      integer maxproc
      parameter (maxproc = 128)
      double precision crap, real
      double precision nwords
      double complex   x, sum1, sum2, factor
      integer lprocs, inode, iproc
      intrinsic int
      iran(i) = int(drand(0)*real(i)) + 1
c
      nproc = ga_pgroup_nnodes(grp_id)
      me    = ga_pgroup_nodeid(grp_id)
      inode = ga_cluster_nodeid()
      lprocs = ga_cluster_nprocs(inode)
      nnodes = ga_cluster_nnodes()
      iproc = mod(me,lprocs)
      nloop = Min(maxloop,n)
c
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = cmplx(dble(i-1), dble((j-1)*n))
            b(i,j) = cmplx(-1d0,1d0)
         enddo
      enddo
c
c     Create a global array
c
c     print *,ga_nodeid(), ' creating array'
      call ffflush(6)
c     call setdbg(1)
      ndim = 2
      dims(1) = n
      dims(2) = n
      g_a = ga_create_handle()
      call ga_set_data(g_a,ndim,dims,MT_DCPL)
      call ga_set_array_name(g_a,'a')
      call ga_set_pgroup(g_a,grp_id)
      status = ga_allocate(g_a)
      if (.not. status) then
         write(6,*) ' ga_create failed'
         call ga_error('... exiting ',0)
      endif
      g_b = ga_create_handle()
      call ga_set_data(g_b,ndim,dims,MT_DCPL)
      call ga_set_array_name(g_b,'b')
      call ga_set_pgroup(g_b,grp_id)
      if (.not.ga_allocate(g_b)) then
         call ga_error('ga_create failed for second array ',0)
      endif

      call ga_distribution(g_a,me,ilo, ihi, jlo, jhi)
      call ga_pgroup_sync(grp_id)
c
c     Zero the array
c
      if (me .eq. 0) then
         write(6,21)
 21      format(/'> Checking zero ... ')
         call ffflush(6)
      endif
      call ga_zero(g_a)
c
c     Check that it is indeed zero
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      call ga_pgroup_sync(grp_id)
      do i = 1, n
         do j = 1, n
            if(b(i,j).ne.(0d0,0d0)) then
               write(6,*) me,' zero ', i, j, b(i,j)
               call ffflush(6)
c              call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_zero is OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Each node fills in disjoint sections of the array
c
      if (me .eq. 0) then
         write(6,2)
 2       format(/'> Checking disjoint put ... ')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_pgroup_sync(grp_id)
c
c     All nodes check all of a
c
      call util_qfill(n*n, (0d0,0d0), b, 1)
      call ga_get(g_a, 1, n, 1, n, b, n)
c
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' put ', me, i, j, a(i,j),b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_put is OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Now check nloop random gets from each node
c
      if (me .eq. 0) then
         write(6,5) nloop
 5       format(/'> Checking random get (',i5,' calls)...')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      nwords = 0
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c
         call util_qfill(n*n, (0.0d0,0d0), b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
         if (me .eq. 0 .and. mod(loop-1, max(1,nloop/20)).eq.0) then
            write(6,1) loop, me, ilo, ihi, jlo, jhi, nwords
 1          format(' call ',i5, ' node ',i2,' checking get ',4i4,
     $           ' total ',d9.2)
            call ffflush(6)
         endif
         do j = jlo, jhi
            do i = ilo, ihi
               if (b(i,j) .ne. a(i,j)) then
                  write(6,*)'error:', i, j, b(i,j), a(i,j)
                  call ga_error('... exiting ',0)
               endif
            enddo
         enddo
c
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_get is OK'
         write(6,*)
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Each node accumulates into disjoint sections of the array
c
      if (me .eq. 0) then
         write(6,9)
 9       format(/'> Checking accumulate ... ')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      crap = drand(12345)       ! Same seed for each process
      do j = 1, n
         do i = 1, n
            b(i,j) = cmplx(drand(0),drand(1))
            b(i,j) = cmplx(dble(i),dble(j))
         enddo
      enddo
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
c           x = cmplx(drand(0),0.333d0)
c           x = cmplx(0.333d0,0)
*           x = cmplx(0d0,0d0)
            x = 0 
            ilo = i
            ihi = min(i+inc-1, n)
            if(ihi.eq.n-1)ihi=n
            jlo = j
            jhi = min(j+inc-1, n)
            if(jhi.eq.n-1)jhi=n
            if (mod(ij,nproc) .eq. me) then
               call ga_acc(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n, x)
            endif
            ij = ij + 1
c
c           Each process applies all updates to its local copy
c
            do jj = jlo, jhi
               do ii = ilo, ihi
                  a(ii,jj) = a(ii,jj) + x * b(ii,jj)
               enddo
            enddo
         enddo
      enddo
      call ga_pgroup_sync(grp_id)
c
c     All nodes check all of a
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (MISMATCH(b(i,j), a(i,j)))then
               write(6,*) ' acc ', me, i, j, a(i,j), b(i,j)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' disjoint ga_acc is OK'
         write(6,*)
      endif
c
c     overlapping accumulate
c
      call ga_zero(g_b)
      call ga_acc(g_b, n/2, n/2, n/2, n/2, (1d0,-1d0), 1, (1d0,0d0))
      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         call ga_get(g_b, n/2, n/2, n/2, n/2, x, 1)
         if (MISMATCH(x, ((1d0,-1d0)*nproc)))then
c        if(error.gt. (1d-8))then
            write(6,*)'val=',x,' expected=(',nproc,',',-nproc,')'
            call ga_error('overlapping accumulate failed',0)
         endif
         write(6,*)
         write(6,*) ' overlapping ga_acc is OK'
         write(6,*)
      endif
c
c     Check the ga_copy function
c
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking copy'
         write(6,*)
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      call ga_copy(g_a, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' copy ', me, i, j, a(i,j), b(i,j)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' copy is OK '
         write(6,*)
      endif
c
c
c     Check the ga_scale function
c
      if (me .eq. 0) then
         write(6,92)
 92      format(/'> Checking scale ...')
         call ffflush(6)
      endif
      factor = (1d0,-1d0)
      call ga_scale(g_a, factor)
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            a(i,j) = a(i,j)*factor
            if (MISMATCH(b(i,j), a(i,j)))then
               write(6,*) ' dscal ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scale is OK '
         write(6,*)
      endif
c
c     Check scatter&gather
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*) '> Checking scatter/gather (might be slow)... '
         call ffflush(6)
         if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      endif
      call ga_pgroup_sync(grp_id)
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      do j = 1, 10
       call ga_pgroup_sync(grp_id)
       itmp = iran(nproc)-1
       if(me.eq.itmp) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
         enddo
         call ga_gather(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,v(loop),1)
           if(v(loop)  .ne. a(ilo,jlo))then
             write(6,*)me,' gather ', ilo,',',jlo,',', a(ilo,jlo)
     &             ,' ',v(loop)
             call ffflush(6)
             call ga_error('... exiting ',0)
           endif
         enddo
       endif
      enddo
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' gather is  OK'
         write(6,*)
         call ffflush(6)
      endif
c
      do j = 1,10
       call ga_pgroup_sync(grp_id)
       if(me.eq.iran(ga_nnodes())-1) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
           v(loop) = (1d0,-1d0) *(ilo+jlo)
         enddo
         call ga_scatter(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,w(loop),1)
           if(w(loop)  .ne. (1d0,-1d0) *(ilo+jlo) )then
             write(6,*)me,' scatter ', ilo,',',jlo,',',w(loop)
     &             ,' ', (1d0,-1d0) *(ilo+jlo)
             call ffflush(6)
           endif
         enddo
       endif
       call ga_pgroup_sync(grp_id)
      enddo
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scatter is  OK'
         write(6,*)
      endif
c
c     Check ga_add
c
      if (me .eq. 0) then
         write(6,91)
 91      format(/'> Checking add ...')
         call ffflush(6)
      endif
      call ga_get(g_a, 1, n, 1, n, a, n)
      crap = drand(12345)       ! Everyone has same seed
      do j = 1, n
         do i = 1, n
            b(i,j) = cmplx(drand(0), drand(1))
            a(i,j) = (0.1d0,-.1d0)*a(i,j) + (.9d0,-.9d0)*b(i,j)
         enddo
      enddo

      if (me.eq.0) call ga_put(g_b, 1, n, 1, n, b, n)
      call ga_add((0.1d0,-.1d0), g_a, (0.9d0,-.9d0), g_b, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (MISMATCH(b(i,j), a(i,j)))then
               write(6,*) ' add ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' add is OK '
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Check the zdot function
c
      if (me .eq. 0) then
         write(6,19)
 19      format(/'> Checking zdot ...')
         call ffflush(6)
      endif
      crap = drand(12345)       ! Everyone has same seed
      sum1 = (0.0d0,0.d0)
      do j = 1, n
         do i = 1, n
            b(i,j) = cmplx(drand(0), drand(1))
            sum1 = sum1 + a(i,j)*b(i,j)
         enddo
      enddo
      if (me.eq.0) then
         call ga_put(g_b, 1, n, 1, n, b, n)
         call ga_put(g_a, 1, n, 1, n, a, n)
      endif
      call ga_pgroup_sync(grp_id)
      sum2 =  ga_zdot(g_a,g_b)
      if (MISMATCH(sum1, sum2))then
         write(6,*) ' zdot wrong ', sum1, sum2
         call ffflush(6)
         call ga_error('... exiting ',0)
      else if (me.eq.0) then
         write(6,*)
         write(6,*) ' zdot is OK '
         write(6,*)
      endif
c
c     Delete the global arrays
c
  123 continue
      status = ga_destroy(g_b)
      status = ga_destroy(g_a)
c
      return
      end
c-----------------------------------------------------------------




      subroutine check_int(grp_id)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c     
      integer n,grp_id
      parameter (n = 128)
      integer a(n,n), b(n,n)
      logical status
      integer g_a
      integer iran, i, j, loop, nloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, int, ij, inc, dimi, dimj, ii, jj
      integer ndim, dims(2), chunk(2), p_mirror, nnodes
      integer lprocs, inode, iproc,lproc, nprocs
      double precision nwords
      parameter (nloop = 100)
      integer maxproc
      parameter (maxproc = 128)
      integer map(5,maxproc), found, np,k
      double precision crap, sum1, real
      integer buf, abs_me
      intrinsic int
      iran(i) = int(drand(0)*real(i)) + 1
c     
      nproc = ga_pgroup_nnodes(grp_id)
      me    = ga_pgroup_nodeid(grp_id)
      abs_me = ga_nodeid()
      inode = ga_cluster_nodeid()
      lprocs = ga_cluster_nprocs(inode)
      nnodes = ga_cluster_nnodes()
      iproc = mod(me,lprocs)
c     
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = i-1 + (j-1)*1000
         enddo
      enddo
c     
c     Create a global array
c
      ndim = 2
      dims(1) = n
      dims(2) = n
      chunk(1) = 0
      chunk(2) = 0
      g_a = ga_create_handle()
      call ga_set_data(g_a,ndim,dims,MT_INT)
      call ga_set_array_name(g_a,'a')
      call ga_set_pgroup(g_a,grp_id)
      if (.not.ga_allocate(g_a)) then
         write(6,*) ' ga_create failed'
         call ffflush(6)
         call ga_error('... exiting ',0)
      endif
c     
c     Zero the array
c
      if (me .eq. 0) then
         write(6,21) 
 21      format(/'> Checking zero ... ')
         call ffflush(6)
      endif
      call ga_zero(g_a)
c
c     Check that it is indeed zero
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. 0) then
               write(6,*) ' zero ', me, i, j, b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_zero is OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Each node fills in disjoint sections of the array
c
      if (me .eq. 0) then
         write(6,2) 
 2       format(/'> Checking disjoint put ... ')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
c              write(6,4) me, ilo, ihi, jlo, jhi
c4             format(' node ',i2,' checking put ',4i4)
c              call ffflush(6)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_pgroup_sync(grp_id)
c
c     All nodes check all of a
c
      if(me.eq.0)then
        call ga_get(g_a, 1, n, 1, n, b, n)
        do i = 1, n
           do j = 1, n
              if (b(i,j) .ne. a(i,j)) then
                 write(6,*) ' put ', me, i, j, a(i,j),b(i,j)
                 call ffflush(6)
                 call ga_error('... exiting ',0)
              endif
           enddo
        enddo
      endif
      call ga_pgroup_sync(grp_id)
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_put is OK'
         write(6,*)
      endif
c
c     Now check nloop random gets from each node
c
      if (me .eq. 0) then
         write(6,5) nloop
 5       format(/'> Checking random get (',i5,' calls)...')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      nwords = 0
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c     
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c
         call util_ifill(n*n, 0.0d0, b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
c
         if (me .eq. 0 .and. mod(loop-1, max(1,nloop/20)).eq.0) then
            write(6,1) loop, me, ilo, ihi, jlo, jhi, nwords
 1          format(' call ',i5, ' node ',i2,' checking get ',4i4,
     $           ' total ',d9.2)
            call ffflush(6)
         endif
c
         sum1 = 0.0d0
         do j = jlo, jhi
            do i = ilo, ihi
               sum1 = sum1 + b(i,j)
               if (b(i,j) .ne. a(i,j)) then
                  write(6,*) 'error ', i, j, b(i,j), a(i,j)
                  call ffflush(6)
                  call ga_error('... exiting ',0)
               endif
            enddo
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_get is OK'
         write(6,*)
      endif
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0 .and. n.gt.7) then
         write(6,*)
         write(6,*) '> Checking ga_print_patch --- should see '
         write(6,*)' [2002 3002 4002 5002 6002]'  
         write(6,*)' [2003 3003 4003 5003 6003]'  
         write(6,*)' [2004 3004 4004 5004 6004]'  
         write(6,*)
         call ffflush(6)
      endif
      if(n.gt.5) call ga_print_patch(g_a,3,5,3,7,0)
c
      call ga_pgroup_sync(grp_id)
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*)
         write(6,*) '> Checking read_inc ... '
         write(6,*)
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      inc =5 
c     every processor will be operating on somebody elses data
c
      lproc = nproc - me - 1
c
      call ga_distribution(g_a,lproc,ilo,ihi,jlo,jhi)
c
      dimi = ihi-ilo
      dimj = jhi-jlo
      write(6,111) me,ilo,ihi,jlo,jhi,dimi,dimj
  111 format(i2,'..',4i8,'.',2i8)
      call ga_pgroup_sync(grp_id)
      if(ilo .gt.0 .and. jhi .gt. 0)then
       do loop = 1,nloop 
         ii= IABS(iran(dimi))
         jj= IABS(iran(dimj))
         i=ilo + Mod(ii,dimi)
         j=jlo + Mod(jj,dimj)
c
c        write(6,*) me,'..',ilo,ihi,jlo,jhi,'.',dimi,dimj,'..',i,j
c        call ffflush(6)
         buf = ga_read_inc(g_a,i,j,inc)
         if(a(i,j).ne. buf)then   
            write(6,*)me,'READ_inc ', i,',',j,',', a(i,j),' ',buf,me 
            call ffflush(6)
         endif
         call ga_get(g_a, i,i,j,j, buf,1) 
         a(i,j) = a(i,j)+inc 
         if(a(i,j).ne.  buf)then   
            write(6,*)me,'read_INC ', i,',',j,',', a(i,j),' ',buf,me
            call ffflush(6)
         endif
       enddo
      endif
      call ga_pgroup_sync(grp_id)
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' read_inc is OK'
         write(6,*)
      endif
c
c
c
#if 000
      if (me.eq.0) then
         write(6,*)
         write(6,*) '> checking ga_fence and ga_lock'
         write(6,*)
         call ffflush(6)
      endif
c
      call ga_zero(g_a)
c
c***  use ga_read_inc and elements g_a(1:2,1) to implement a lock
c***  compute g_a(:,n) = sum (1(:)) for P processors
c     
      status = ga_create_mutexes(1)
      if (.not. status) then
         call ga_error('ga_create_mutexes failed ',0)
      endif

      if(n.lt.2)call ga_error('insufficient n to test ga_fence',n)

      call ga_lock(0)
c     call my_lock(g_a)

c          get original values  g_a(:,n)
           call ga_get(g_a, 1,n, n,n, b,n)
c          add my contribution
           do i =1,n
              b(i,1)= b(i,1)+1
           enddo
c
c          need to use fence to assure that coms complete before leaving
c          Critical Section
c
           call ga_init_fence()
                call ga_put(g_a, 1,n, n,n, b,n)
           call ga_fence()
      call ga_unlock(0)
c     call my_unlock(g_a)
c
333   if(.not.ga_destroy_mutexes())
     $   call ga_error('mutex not destroyed',0)

      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         call ga_get(g_a, 1,n, n,n, b,n)
         do i =1,n
              if(b(i,1).ne. nproc)then
                  print *, 'mismatch',b(i,1),nproc
                  call ga_error('fence failed',i)
              endif
         enddo
         write(6,*)
         write(6,*) ' ga_fence and ga_lock are OK'
         write(6,*)
      endif 
#endif
c
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) '> checking ga_locate_region'
         write(6,*)
         call ffflush(6)
      endif

      status = ga_locate_region(g_a, 1, n, 1,n, map,np)
      found = 0
      do j=1,n
         do i=1,n
            b(i,j)=-1
         enddo
      enddo
      if(me.eq.0)call ga_put(g_a,1,n,1,n,b,n)
      call ga_pgroup_sync(grp_id)
      do k = 1, np
         if(map(5,k).eq.me)then
                if(found.eq.1) then
                    write(6,*)'double entry in map for proc ',me
                    call ffflush(6)
                endif
                do j= map(3,k), map(4,k)
                  do i= map(1,k), map(2,k)
                    b(i,j)=1*me
                  enddo
                enddo
                call ga_put(g_a, map(1,k),map(2,k),map(3,k),map(4,k),
     &                 b(map(1,k),map(3,k)),n)
                found = 1
         endif
      enddo
      call ga_pgroup_sync(grp_id)
c
      do k = 1, np
         if(map(5,k).eq.me)then
                call ga_get(g_a, map(1,k),map(2,k),map(3,k),map(4,k),
     &                 a(map(1,k),map(3,k)),n)
                do j= map(3,k), map(4,k)
                      do i= map(1,k), map(2,k)
                        if(b(i,j).ne.a(i,j)) then
                           write(6,*)
     &                     'proc ',me, 'overlap with ',a(i,j)
                           call ffflush(6)
                        endif
                      enddo
                enddo
         endif
      enddo
      call ga_pgroup_sync(grp_id)
c
      if(me.eq.0)then

        call ga_get(g_a,1,n,1,n,a,n)
        do j=1,n
         do i=1,n
            if(a(i,j).eq.-1)then
               write(6,*)'i=',i,' j=',j, ' not assigned '
               call ga_error('... exiting ',0)
            endif
         enddo
        enddo
      endif

      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_locate_region is OK'
         write(6,*)
         call ffflush(6)
      endif
c     
c     Delete the global array
c
      status = ga_destroy(g_a)
c     
      return
      end

c---------------------------------------------------------------------

      subroutine check_flt(grp_id)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer n, m, grp_id
      parameter (n =10) 
      parameter (m=2*n)
      real a(n,n), b(n,n), v(m), w(m)
      integer iv(m), jv(m)
      logical status
      integer g_a, g_b
      integer iran, i, j, loop, nloop, maxloop, ilo, ihi, jlo, jhi, itmp
      integer nproc, me, int, ij, inc, ii, jj, nnodes
      double precision nwords
      parameter (maxloop = 100)
      integer maxproc
      integer ndim, dims(2), chunk(2), p_mirror
      parameter (maxproc = 128)
      double precision crap
      real x, sum1, sum2
      logical found
      integer lprocs, inode, iproc
      intrinsic int
      iran(i) = int(drand(0)*real(i)) + 1

      nproc = ga_pgroup_nnodes(grp_id)
      me    = ga_pgroup_nodeid(grp_id)
      inode = ga_cluster_nodeid()
      lprocs = ga_cluster_nprocs(inode)
      nnodes = ga_cluster_nnodes()
      iproc = mod(me,lprocs)
      nloop = Min(maxloop,n)
c     
c     a() is a local copy of what the global array should start as
c
      do j = 1, n
         do i = 1, n
            a(i,j) = i-1 + (j-1)*n
            b(i,j) = -1.
         enddo
      enddo

c     
c     Create a global array
c
      ndim = 2
      dims(1) = n
      dims(2) = n
      chunk(1) = 0
      chunk(2) = 0
      g_a = ga_create_handle()
      call ga_set_data(g_a,ndim,dims,MT_REAL)
      call ga_set_array_name(g_a,'a')
      call ga_set_pgroup(g_a,grp_id)
      if (.not.ga_allocate(g_a)) then
         write(6,*) ' ga_create failed'
         call ffflush(6)
         call ga_error('... exiting ',0)
      endif
c
c     check if handle is valid. be quiet unless error
c
      if(.not.ga_valid_handle(g_a)) call ga_error("invalid handle",g_a)
c
      call ga_distribution(g_a,me,ilo, ihi, jlo, jhi)
      call ga_pgroup_sync(grp_id)      
c     
c     Zero the array
c
      if (me .eq. 0) then
         write(6,21) 
 21      format(/'> Checking zero ... ')          
         call ffflush(6)
      endif
      call ga_zero(g_a)
c
c     Check that it is indeed zero
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      call ga_pgroup_sync(grp_id)
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. 0.0) then
               write(6,*) ' zero ', me, i, j, b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_zero is OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Each node fills in disjoint sections of the array
c
      if (me .eq. 0) then
         write(6,2) 
 2       format(/'> Checking disjoint put ... ')   
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
            if (mod(ij,nproc) .eq. me) then
               ilo = i
               ihi = min(i+inc, n)
               jlo = j
               jhi = min(j+inc, n)
c               write(6,4) me, ilo, ihi, jlo, jhi
c 4             format(' node ',i2,' checking put ',4i4)
c               call ffflush(6)
               call ga_put(g_a, ilo, ihi, jlo, jhi, a(ilo, jlo), n)
            endif
            ij = ij + 1
         enddo
      enddo
      call ga_pgroup_sync(grp_id)
c
c     All nodes check all of a
c
      call ga_get(g_a, 1, n, 1, n, b, n)
      do i = 1, n
         do j = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' put ', me, i, j, a(i,j),b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      call ga_pgroup_sync(grp_id)
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_put is OK'
         write(6,*)
      endif
c
c     Now check nloop random gets from each node
c
      if (me .eq. 0) then
         write(6,5) nloop
 5       format(/'> Checking random get (',i5,' calls)...')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      nwords = 0
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      do loop = 1, nloop
         ilo = iran(loop)
         ihi = iran(loop)
         if (ihi.lt. ilo) then
            itmp = ihi
            ihi = ilo
            ilo = itmp
         endif
         jlo = iran(loop)
         jhi = iran(loop)
         if (jhi.lt. jlo) then
            itmp = jhi
            jhi = jlo
            jlo = itmp
         endif
c     
         nwords = nwords + (ihi-ilo+1)*(jhi-jlo+1)
c
         call util_rfill(n*n, 0.0, b, 1)
         call ga_get(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n)
c
         if (me .eq. 0 .and. mod(loop-1, max(1,nloop/20)).eq.0) then
            write(6,1) loop, me, ilo, ihi, jlo, jhi, nwords
 1          format(' call ',i5, ' node ',i2,' checking get ',4i4,
     $           ' total ',d9.2)
            call ffflush(6)
         endif
c
         sum1 = 0.0d0
         do j = jlo, jhi
            do i = ilo, ihi
               sum1 = sum1 + b(i,j)
               if (b(i,j) .ne. a(i,j)) then
                  write(6,*) 'error ', i, j, b(i,j), a(i,j)
                  call ffflush(6)
                  call ga_error('... exiting ',0)
               endif
            enddo
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_get is OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Each node accumulates into disjoint sections of the array
c
      if (me .eq. 0) then
         write(6,9)
 9       format(/'> Checking accumulate ... ')
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)

c
      crap = drand(12345)       ! Same seed for each process
      do j = 1, n
         do i = 1, n
c           b(i,j) = real(drand(0))
            b(i,j) = i+j
         enddo
      enddo
c
      inc = (n-1)/20 + 1
      ij = 0
      do j = 1, n, inc
         do i = 1, n, inc
c           x = real(drand(0))
            x = 10.
            ilo = i
            ihi = min(i+inc-1, n)
            if(ihi.eq.n-1)ihi=n
c           ihi = min(i+inc, n)
            jlo = j
            jhi = min(j+inc-1, n)
            if(jhi.eq.n-1)jhi=n
c           jhi = min(j+inc-1, n)
*               call ffflush(6)
            if (mod(ij,nproc) .eq. me) then
c               print *, me, 'checking accumulate ',ilo,ihi,jlo,jhi,x
* 11            format(' node ',i2,' checking accumulate ',4i4)
*               call ffflush(6)
               call ga_acc(g_a, ilo, ihi, jlo, jhi, b(ilo, jlo), n, x)
            endif
            ij = ij + 1
c
c           Each process applies all updates to its local copy
c
            do jj = jlo, jhi
               do ii = ilo, ihi
                  a(ii,jj) = a(ii,jj) + x * b(ii,jj)
               enddo
            enddo
         enddo
      enddo
      call ga_pgroup_sync(grp_id)                       
c
c     All nodes check all of a
      call ga_get(g_a, 1, n, 1, n, b, n)
c
      do j = 1, n
         do i = 1, n
            if(MISMATCHF(b(i,j),a(i,j)))then
               write(6,*) ' acc ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' disjoint ga_acc is OK'
         write(6,*)
      endif
c
c     overlapping accumulate
      call ga_pgroup_sync(grp_id)
      g_b = ga_create_handle()
      call ga_set_data(g_b,ndim,dims,MT_REAL)
      call ga_set_array_name(g_b,'b')
      call ga_set_pgroup(g_b,grp_id)
      if (.not.ga_allocate(g_b)) then
         call ga_error('ga_create failed for second array ',0)
      endif
c
      call ga_zero(g_b)
      call ga_acc(g_b, n/2, n/2, n/2, n/2, 1.0, 1, 1.0)
      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         call ga_get(g_b, n/2, n/2, n/2, n/2, b(1,1), 1)
         x = abs(b(1,1) -1*nproc)
         if(x.gt. 1e-10)then
            write(6,*)'val=',b(1,1),' expected=',nproc, x
            call ga_error('overlapping accumulate failed',0)
         endif
         write(6,*)
         write(6,*) ' overlapping ga_acc is OK'
         write(6,*)
      endif
c
c     Check the ga_add function
c
      if (me .eq. 0) then
         write(6,91)
 91      format(/'> Checking add ...')
         call ffflush(6)
      endif                           
c
      crap = drand(12345)       ! Everyone has same seed
      do j = 1, n
         do i = 1, n
            b(i,j) = real(drand(0)*real(i)) + 1
            a(i,j) = 0.1*a(i,j) + 0.9*b(i,j)
         enddo
      enddo
      if (me.eq.0) call ga_put(g_b, 1, n, 1, n, b, n)
      call ga_add(0.1, g_a, 0.9, g_b, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if(MISMATCHF(b(i,j), a(i,j)))then
               write(6,*) ' add ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
CCC               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' add is OK '
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
c     Check the sdot function
c
      if (me .eq. 0) then
         write(6,19)
 19      format(/'> Checking sdot ...')
         call ffflush(6)
      endif
      crap = drand(12345)       ! Everyone has same seed
      sum1 = 0.0
      do j = 1, n
         do i = 1, n
            b(i,j) = drand(0)
            sum1 = sum1 + a(i,j)*b(i,j)
         enddo
      enddo
      if (me.eq.0) then
         call ga_put(g_b, 1, n, 1, n, b, n)
         call ga_put(g_a, 1, n, 1, n, a, n)
      endif
      call ga_pgroup_sync(grp_id)
      sum2 = ga_sdot(g_a,g_b)
      if(MISMATCHF(sum1, sum2))then
         write(6,*) ' fdot wrong ', sum1, sum2
         call ffflush(6)
            call ga_error('... exiting ',0)
      else if (me.eq.0) then
         write(6,*)
         write(6,*) ' sdot is OK '
         write(6,*)
      endif
c
c     Check the ga_scale function
c
      if (me .eq. 0) then
         write(6,92)
 92      format(/'> Checking scale ...')
         call ffflush(6)
      endif
      call ga_scale(g_a, 0.123)
      call ga_get(g_a, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            a(i,j) = a(i,j)*0.123
            if (MISMATCHF(b(i,j), a(i,j)))then
               write(6,*) ' dscal ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
CCC               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scale is OK '
         write(6,*)
      endif
c                                
c     Check the ga_copy function
c
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking copy'
         write(6,*)
         call ffflush(6)
      endif
      if(me.eq.0) call ga_put(g_a, 1, n, 1, n, a, n)
      call ga_copy(g_a, g_b)
      call ga_get(g_b, 1, n, 1, n, b, n)
      do j = 1, n
         do i = 1, n
            if (b(i,j) .ne. a(i,j)) then
               write(6,*) ' copy ', me, i, j, a(i,j), b(i,j)
               call ffflush(6)
               call ga_error('... exiting ',0)
            endif
         enddo
      enddo
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' copy is OK '
         write(6,*)
      endif
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*) '> Checking scatter/gather (might be slow)... '
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
c
      crap = drand(ga_nodeid()*51 +1) !Different seed for each proc
      do j = 1, 10
       call ga_pgroup_sync(grp_id)
       itmp = iran(nproc)-1
       if(me.eq.itmp) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
         enddo
         call ga_gather(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,v(loop),1)
           if(v(loop)  .ne. a(ilo,jlo))then
             write(6,*)me,' gather ', ilo,',',jlo,',', a(ilo,jlo)
     &             ,' ',v(loop)
             call ffflush(6)
             call ga_error('... exiting ',0)
           endif                                     
         enddo
       endif
      enddo
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' gather is  OK'
         write(6,*)
         call ffflush(6)
      endif
c
 
      do j = 1,10
       call ga_pgroup_sync(grp_id)
       if(me.eq.iran(ga_nnodes())-1) then
         do loop = 1,m
           ilo = iran(n)
           jlo = iran(n)
           iv(loop) = ilo
           jv(loop) = jlo
c          v(loop) = DSIN(a(ilo,jlo)+b(ilo,jlo))
           v(loop) = 1.0 *(ilo+jlo)
         enddo
         call ga_scatter(g_a, v, iv, jv, m)
         do loop = 1,m
           ilo= iv(loop)
           jlo= jv(loop)
           call ga_get(g_a,ilo,ilo,jlo,jlo,w(loop),1)
c          if(v(loop)  .ne. w(loop))then
           if(w(loop)  .ne. 1.0 *(ilo+jlo) )then
             write(6,*)me,' scatter ', ilo,',',jlo,',',w(loop)
     &             ,' ', 1.0 *(ilo+jlo)
             call ffflush(6)
             call ga_error('... exiting ',0)
           endif
         enddo
       endif
       call ga_pgroup_sync(grp_id)
      enddo
c
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scatter is  OK'
         write(6,*)
      endif
c
      call ga_pgroup_sync(grp_id)
c
c     scatter-acc available in GA ver. 3.0
#ifdef GA3                                         
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' checking scatter-accumulate'
         write(6,*)
      endif
c
      crap = drand(1234)
      call ga_zero(g_a)
c
      do j = 1, n
         do i = 1, n
            b(i,j) =0.
         enddo
      enddo
c
      x = .1d0
      ii =n
      do jj = 1,1
          call ga_pgroup_sync(grp_id)
        do loop = 1, ii
 
c          generate unique i,j pairs
10         continue
              i = iran(n)
              j=iran(n)
           if (found(i,j, iv, jv, loop-1) ) goto 10

           iv(loop) = i
           jv(loop) = j
           v(loop) = 1.0 *(i+j)
           b(i,j) = b(i,j) + nproc*x*v(loop) ! update local ref. array
        enddo
 
        call ga_scatter_acc(g_a,v,iv,jv, ii,x)
 
c
        call ga_pgroup_sync(grp_id)
c
c       check the result
c
        call ga_get(g_a, 1, n, 1,n, a, n)
 
        do loop = 1,ii
          i = iv(loop)
          j = jv(loop)
          if(MISMATCHF(a(i,j),b(i,j)))then
             print *,'Error',i,j,loop,a(i,j),'expected=',b(i,j)
*            if(me.eq.0)then
*              do ii=1,loop
*                   print *,'element',ii, iv(ii),jv(ii)
*              enddo
*            endif
             call ga_error('scatter-acc error in trial ',jj)
          endif
        enddo                                 
          call ga_pgroup_sync(grp_id)
 
      enddo
 
      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' scatter-accumulate is  OK'
         write(6,*)
      endif
#endif                      
c
c     Delete the global array
c
      status = ga_destroy(g_a)
c     
      return
      end
c_____________________________________________________________

      subroutine check_wrappers(grp_id) 
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      double precision sum
      integer isum, ibuf(2)
      integer me, nproc, grp_id, root
      real fsum
c
      nproc = ga_pgroup_nnodes(grp_id)
      me = ga_pgroup_nodeid(grp_id)
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking ga_igop'
         write(6,*)
         call ffflush(6)
      endif
      ibuf(1) = 1
      ibuf(2) =  me
      call ga_pgroup_igop(grp_id,10000, ibuf, 2, '+')
      if(ibuf(1).ne.nproc)then
        call ga_error('ga_igop error',isum)
      endif
      if(ibuf(2).ne.((nproc-1)*nproc/2))then
        call ga_error('ga_igop error -2',isum)
      endif
      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_igop is  OK'
         write(6,*)
      endif
      call ga_pgroup_sync(grp_id)
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking ga_dgop'
         write(6,*)
         call ffflush(6)
      endif
      sum = 1d0 * me
      call ga_pgroup_dgop(grp_id,10000, sum, 1, '+')
      if(Int(sum).ne.((nproc-1)*nproc/2))then
        call ga_error('ga_dgop error',Int(sum))
      endif
      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_dgop is  OK'
         write(6,*)
      endif
c
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking ga_sgop'
         write(6,*)
         call ffflush(6)
      endif
      fsum = 1.0 * me
      call ga_pgroup_sgop(grp_id,10000, fsum, 1, '+')
      if(Int(sum).ne.((nproc-1)*nproc/2))then
        call ga_error('ga_fgop error',Int(sum))
      endif
      call ga_pgroup_sync(grp_id)
      if (me.eq.0) then
         write(6,*)
         write(6,*) ' ga_sgop is  OK'
         write(6,*)
      endif
c                                   
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> Checking ga_brdcst'
         write(6,*)
         call ffflush(6)
      endif
      if(me.eq.nproc-1)then
        ibuf(1) = me
        ibuf(2) = nproc
      endif
      root = 7
      call ga_pgroup_brdcst(grp_id,1000,ibuf,util_mitob(2),nproc-1)
      if(ibuf(1).ne.nproc-1)call ga_error('ibuf(1) error',ibuf(1))
      if(ibuf(2).ne.nproc)call ga_error('ibuf(2) error',ibuf(2))
      call ga_pgroup_sync(grp_id)
      if (me .eq. 0) then
         write(6,*)
         write(6,*)'> ga_brdcst is OK '
         write(6,*)
         call ffflush(6)
      endif
      call ga_pgroup_sync(grp_id)
      return
      end


      subroutine check_mem(mem_size)
      implicit none
      integer mem_size
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
c
      integer n,nmax,left,need, me,procs,g_a, g_b 
      logical status
c
      if(.not. ga_memory_limited())return
      me = ga_nodeid()
      procs = ga_nnodes()
      nmax = int(dsqrt(dble(mem_size/util_mitob(1))))
      left =  mem_size/procs - ga_inquire_memory()
      n = nmax/2
      need = util_mdtob(n*n)/procs
c
      if(me.eq.0)then
        write(6,*)' '
        if(ga_uses_ma())then
           write(6,*)' CHECKING GA MEMORY RESTRICTIONS (MA used)'
        else
           write(6,*)' CHECKING GA MEMORY RESTRICTIONS (MA not used)'
        endif
        write(6,*)' '
        write(6,*)' '
        call print_mem_info(n,left, need, mem_size/procs)
      endif
c
      status = ga_create(MT_DBL, n, n, 'a', 0, 0, g_a)
c
      if(me.eq.0) then
        if(status) then
              write(6,*) '  success'
        else
              write(6,*) '  failure'
        endif
        call ffflush(6)
      endif
c
      n = nmax
      left =  mem_size/procs - ga_inquire_memory()
      need = util_mdtob(n*n)/procs
      if(me.eq.0)then
        call print_mem_info(n,left, need, mem_size/procs)
      endif
c
      status = ga_create(MT_DBL, n, n, 'b', 0, 0, g_b)
c
      if(me.eq.0) then
        if(status) then
              write(6,*) '  success'
        else
              write(6,*) '  failure'
        endif
        write(6,*)' '
        write(6,*)' '
        call ffflush(6)
      endif
      status = ga_destroy(g_a)
      end

     

      subroutine print_mem_info(n,left, need, total)
      implicit none
      integer n,left, need, total
c
      write(6,*)' '
      if(left - need .ge. 0) then
        write(6,1)n,n 
1       format('> Creating array ',i4,' by ',i4,' -- should succeed')
      else
        write(6,2)n,n 
2       format('> Creating array ',i4,' by ',i4,' -- SHOULD FAIL')
      endif
      write(6,3) need, left, total
3     format('  (need ',i7,' and  ',i7,' out of ',i7,' bytes are left)')
      write(6,*)' '
      call ffflush(6)
c
      end


      
      subroutine my_lock(g_b)
      implicit none
#include "global.fh"
      integer g_b, val, flag, i
      logical first_time
      double precision  dummy 
      common /lock/ val 
      common /dum/ dummy
      data first_time /.true./
c
c     this awkward initialization is to avoid a weird problem 
C     with block data on SUN
      if(first_time)then
        first_time = .false.
        dummy = .0
      endif
c
      val = ga_read_inc(g_b,1,1, 1)
10    call ga_get(g_b, 2,2,1,1, flag, 1)
           if(flag.eq.val) return 
c
c          to reduce memory stress,  wait a while before retrying
           do i = 1, 100
              dummy = dummy + .1 
           enddo 
      goto 10
      end


      subroutine my_unlock(g_b)
      implicit none
#include "global.fh"
      integer g_b, val
      common /lock/ val
c
      call ga_put(g_b, 2,2,1,1, val+1, 1) 
      end


      logical function found(i,j, iv, jv, n)
      integer n
      integer i,j, iv(n), jv(n)
      integer loop

      found = .false.
      do loop = 1, n
               if(i .eq. iv(loop) .and. j .eq.jv(loop))then
                 found = .true.
                 goto 99
               endif
            enddo
99    continue
      return
      end 
      
            
      subroutine proc_remap()
      implicit none
#include "global.fh"
      integer proc(100),nproc,i
      nproc = ga_nnodes()
      if(nproc.gt.100)
     $   call ga_error("remap requires<=100 processes",nproc)
      do i = 1, nproc
         proc(i) = nproc-i
      enddo
c     call ga_register_proclist(proc,nproc)
      end

      
      subroutine util_rfill(n,val,a,ia)
      implicit none
      real  a(*), val
      integer n, ia, i
c
c     initialise real array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

      
      subroutine util_dfill(n,val,a,ia)
      implicit none
      double precision  a(*), val
      integer n, ia, i
c
c     initialise double precision array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

      subroutine util_ifill(n,val,a,ia)
      implicit none
      integer n, ia, i, a(*),val
c
c     initialise integer array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

      subroutine util_qfill(n,val,a,ia)
      implicit none
      double  complex  a(*), val
      integer n, ia, i
c
c     initialise double complex array to scalar value
c
      if (ia.eq.1) then
         do 10 i = 1, n
            a(i) = val
 10      continue
      else
         do 20 i = 1,(n-1)*ia+1,ia
            a(i) = val
 20      continue
      endif
c
      end

      SUBROUTINE ccsdt_y_tr2_11_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: ccsdt_y_tr2_11_4.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h3 p11 h13 h14 )_vtr + = -2 * Sum ( h8 p6 ) * tr ( p6 p11 h8 h13 )_tr * i2 ( h3 h8 h14 p6 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER p11b
      INTEGER h13b
      INTEGER h14b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p6b
      INTEGER h8b
      INTEGER p11b_1
      INTEGER p6b_1
      INTEGER h13b_1
      INTEGER h8b_1
      INTEGER h3b_2
      INTEGER h8b_2
      INTEGER h14b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO p11b = noab+1,noab+nvab
      DO h13b = 1,noab
      DO h14b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+p11b-
     &1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+p11b-1) .eq. int_mb(k_spin+
     &h13b-1)+int_mb(k_spin+h14b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+p11b-1),ieor(int_mb
     &(k_sym+h13b-1),int_mb(k_sym+h14b-1)))) .eq. ieor(irrep_v,irrep_tr)
     &) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+p11b-1) * int_mb(k_r
     &ange+h13b-1) * int_mb(k_range+h14b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr2_11_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p6b = noab+1,noab+nvab
      DO h8b = 1,noab
      IF (int_mb(k_spin+p11b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+
     &h13b-1)+int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p11b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb
     &(k_sym+h13b-1),int_mb(k_sym+h8b-1)))) .eq. irrep_tr) THEN
      CALL TCE_RESTRICTED_4(p11b,p6b,h13b,h8b,p11b_1,p6b_1,h13b_1,h8b_1)
      CALL TCE_RESTRICTED_4(h3b,h8b,h14b,p6b,h3b_2,h8b_2,h14b_2,p6b_2)
      dim_common = int_mb(k_range+p6b-1) * int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+p11b-1) * int_mb(k_range+h13b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h14b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr2_11_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr2_11_4',2,MA_ERR)
      IF ((p6b .le. p11b) .and. (h8b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h8b_1 - 1 + noab * (p11b_1 - noab - 1 + nvab * (p6
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+h8b-1),int_mb(k_range+h13b-
     &1),4,2,3,1,1.0d0)
      END IF
      IF ((p6b .le. p11b) .and. (h13b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h13b_1 - 1 + noab * (p11b_1 - noab - 1 + nvab * (p6
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p11b-1),int_mb(k_range+h13b-1),int_mb(k_range+h8b-
     &1),3,2,4,1,-1.0d0)
      END IF
      IF ((p11b .lt. p6b) .and. (h8b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h8b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p11
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h8b-1),int_mb(k_range+h13b-
     &1),4,1,3,2,-1.0d0)
      END IF
      IF ((p11b .lt. p6b) .and. (h13b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h13b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p11
     &b_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p11b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h13b-1),int_mb(k_range+h8b-
     &1),3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr2_11_4',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr2_11_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr2_11_4',5,MA_ERR)
      IF ((h8b .lt. h3b) .and. (h14b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (h14b_2 - 1 + noab * (h3b_2 - 1 + noab * (h8b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h14b-1),int_mb(k_range+p6b-1
     &),3,2,1,4,-1.0d0)
      END IF
      IF ((h3b .le. h8b) .and. (h14b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (h14b_2 - 1 + noab * (h8b_2 - 1 + noab * (h3b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h14b-1),int_mb(k_range+p6b-1
     &),3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr2_11_4',6,MA_E
     &RR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr2_11_4',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr2_11_4',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr2_11_4',9,MA_ERR)
      IF ((h13b .le. h14b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p11b
     &-1),2,4,3,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h14b 
     &- 1 + noab * (h13b - 1 + noab * (p11b - noab - 1 + nvab * (h3b - 1
     &)))))
      END IF
      IF ((h14b .le. h13b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h14b-1
     &),int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p11b
     &-1),2,4,1,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h13b 
     &- 1 + noab * (h14b - 1 + noab * (p11b - noab - 1 + nvab * (h3b - 1
     &)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr2_11_4',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr2_11_4',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      subroutine pdfded(k,kdim,g_dens,dhelp,factor,dmult,lm,nbci,iiloc)
C$Id: pdfded.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c.......................................................................
c
c     routine for distributing atomic densities to the molecular
c     density matrix. note that the number of orbitals differ in
c     the molecular and atomic case for d and f orbitals. transformat-
c     ion matrices are provided in dmult(*,*). to work out these tables
c     real atomic orbitals are needed. for f functions these are:
c              sqrt(1/60)*(2zzz-3zyy-3zxx)
c              sqrt(1/40)*(4zzy-yyy-xxy)
c              sqrt(1/40)*(4zzx-xxx-xyy)
c                    xyz
c              sqrt(1/4)*(xxz-yyz)
c              sqrt(1/24)*(3xxy-yyy)
c              sqrt(1/24)*(3xyy-xxx)
c     normalization of primitives is given by (xyz:xyz)=1, (xxy:xxy)=3
c     (xxx:xxx)=15.
c
c.......................................................................
c..
      integer g_dens
      integer k, kdim, lm, nbci
      real *8 dhelp(*),dmult(kdim,kdim)
      real *8 factor
      integer iiloc(nbci)
c
      integer l, na, m, nb
      integer ll,mm
      integer lmsave, nbrang
      real *8 delem,xx
c     
c..
c..
      do l = 1 , nbci
         lmsave = lm
         do na = 1 , kdim
            lm = lmsave
            do m = 1 , l
               lm = lm + 1
               delem = dhelp(lm)*factor
               nbrang = kdim
               if (m.eq.l) nbrang = na
               do nb = 1 , nbrang
                  xx = delem*dmult(na,nb)
                  ll = iiloc(l)+nb-1
                  mm = iiloc(m)+na-1
                  call ga_put(g_dens,ll,ll,mm,mm,xx,1)
                  call ga_put(g_dens,mm,mm,ll,ll,xx,1)
               enddo
            enddo
         enddo
      enddo
c..
      return
      end

*
* $Id: task_vscf.F 22850 2012-09-13 07:05:49Z d3y133 $
*
C> \ingroup task
C> @{
C>
C> \brief Generic interface to perform Vibrational SCF (VSCF) calculations
C>
C> VSCF calculations explore the anharmonicity of the potential energy
C> surface using finite displacements along two normal modes simultanously.
C>
C> \return Return .true. if successfull, and .false. otherwise.
C>
      logical function task_vscf(rtdb)
c     
c     Also will be hooked up to analytic methods as they are available.
c
c     Since this routine is directly invoked by application modules
c     no input is processed in this routine.
c
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "stdio.fh"
#include "global.fh"
#include "eaf.fh"
#include "msgids.fh"
#include "inp.fh"
#include "util.fh"
c
      logical task_freq
      external task_freq
c     
      integer rtdb !< [Input] The RTDB handle
c     
      integer nat, geom, i
      integer ngrid, ncoup, iexc
      integer l_freq, k_freq, l_nmode, k_nmode, nc
      integer fd
      double precision offset
      character*255 filename
      character*32 theory
      double precision vcfct
      logical status, dmdr, freq_done
c     
      double precision cpu, wall
c 
c  set up a couple of variables that I will eventually let be user controlled
c
      dmdr = .false.
c    
      call ecce_print_module_entry('task vscf')
      cpu  = util_cpusec()
      wall = util_wallsec()
c
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, .false.))
     $     call errquit('task_vscf: failed to invalidate status',0,
     &       RTDB_ERR)
      if (ga_nodeid().eq.0 .and.
     $    util_print('task_vscf', print_low)) then
        write(LuOut,*)
        write(LuOut,*)
        call util_print_centered(LuOut,'VSCF Analysis',40,.true.)
        write(LuOut,*)
      endif
c
c     First do a frequency analysis. Check if restart and frequencies
c     were already done
c
      if (.not. rtdb_get(rtdb,'vscf:freq_done',mt_log,1,freq_done))
     $      freq_done=.false.
      status = .true.
      if (.not.freq_done) status = task_freq(rtdb)
      if (.not.status) then
         call errquit('task_vscf: task_freq failed',911, CALC_ERR)
      else
         if (.not. rtdb_put(rtdb,'vscf:freq_done',mt_log,1,freq_done))
     $   call errquit('task_vscf: rtdb_put freq_done',911, RTDB_ERR)
      endif
c
c     Create/load reference geometry to get the number of atoms
c
      if (.not.geom_create(geom,'geometry')) call errquit
     $      ('task_vscf:geom_create failed?',1, GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'geometry'))
     $      call errquit
     $      ('task_vscf:geom_rtdb_load failed?',2, RTDB_ERR)
      if (.not. geom_ncent(geom,nat)) call errquit
     $      ('task_vscf:geom_ncent failed?',3, GEOM_ERR)
      nc = nat*3
      if (.not. geom_destroy(geom)) call errquit
     $      ('task_vscf:geom_destroy failed?',911, GEOM_ERR)
c
c     Load parameters from rtdb or assign defaults
c
      if (.not. rtdb_get(rtdb,'vscf:ngrid',mt_int,1,ngrid))
     $      ngrid = 16
      if (.not. rtdb_get(rtdb,'vscf:iexc',mt_int,1,iexc))
     $      iexc = 1
      if (.not. rtdb_get(rtdb,'vscf:ncoup',mt_int,1,ncoup))
     $      ncoup = 2
      if (.not. rtdb_get(rtdb,'vscf:vcfct',mt_dbl,1,vcfct))
     $      vcfct = 1.0d+0
c
c  allocate space for freq and normal modes
c
      if (.not. ma_push_get(mt_dbl, nc,'frequencies', l_freq, k_freq))
     &    call errquit('task_vscf: could not allocate l_freq',nc,MA_ERR)
      if (.not. 
     &  ma_push_get(mt_dbl, nc*nc,'normal modes', l_nmode, k_nmode))
     &   call errquit('task_vscf: could not allocate l_nmode',nc*nc,
     &       MA_ERR)
c
c  read in frequencies and normal modes
c
      if (ga_nodeid().eq.0) then
        call util_file_name('nmode',.false.,.false.,filename)
        if (eaf_open(filename,eaf_rw,fd).ne.0)
     &    call errquit('task_vscf:eaf_open failed',555, DISK_ERR)
        offset = 16 
        if (eaf_read(fd,offset,dbl_mb(k_freq),nc*8).ne.0)
     &     call errquit('task_vscf:error reading frequencies',555,
     &       DISK_ERR)
        offset = offset + nc*8
        if (eaf_read(fd,offset,dbl_mb(k_nmode),nc*nc*8).ne.0)
     &    call errquit('task_vscf:error reading modes',555, DISK_ERR)
        if (eaf_close(fd).ne.0)
     &    call errquit('task_vscf:file close problem',555, DISK_ERR)
      endif                                                       
c
c need to allocate freq and nmode for other nodes and broadcast from
c node 0
c
      call ga_brdcst(msg_frq,dbl_mb(k_freq),
     &               nc*ma_sizeof(mt_dbl,1,mt_byte),0)
      call ga_brdcst(msg_eigv,dbl_mb(k_nmode),
     &               nc*nc*ma_sizeof(mt_dbl,1,mt_byte),0)
c
c     Actually do the deed
c
      call vscfm(ngrid,dmdr,ncoup,vcfct,iexc,
     &     rtdb,nat,dbl_mb(k_nmode),dbl_mb(k_freq))
c
c     get rid of extra memory
c
      if (.not. ma_pop_stack(l_nmode))
     $  call errquit('task_vscf:ma_pop of l_nmode failed',555, MA_ERR)
      if (.not. ma_pop_stack(l_freq))
     $  call errquit('task_vscf:ma_pop of l_freq failed',555, MA_ERR)
c
      cpu  = util_cpusec() - cpu
      wall = util_wallsec() - cpu
c
      if (.not. rtdb_put(rtdb, 'task:cputime', mt_dbl, 1, cpu))
     $     call errquit('task_vscf: failed storing cputime',0, RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:walltime', mt_dbl, 1, wall))
     $     call errquit('task_vscf: failed storing walltime',0,
     &       RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'task:status', mt_log, 1, .true.))
     $     call errquit('task_vscf: failed to set status',0, RTDB_ERR)
c
      call ecce_print1('cpu time', mt_dbl, cpu, 1)
      call ecce_print1('wall time', mt_dbl, wall, 1)
      task_vscf = status
      if (task_vscf) then
        call ecce_print_module_exit('task vscf', 'ok')
      else
        call ecce_print_module_exit('task vscf', 'failed')
      endif
c
c
      end
C> @}

      subroutine get_block_ind(d_file,array,size,key_ix,indexc)
c      subroutine get_block_ind(d_file,array,size,offset,indexc)
c
c $Id: get_block_ind.F 21249 2011-10-20 18:29:14Z kowalski $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sf.fh"
#include "eaf.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "sym.fh"
c      integer dummy
      integer d_file
cccx      integer d_f
      integer size
cccx      integer offset
      double precision array(size)
      integer request
      integer l_a,k_a
      integer i,j,k,l
      integer ispin
      integer indexc
      integer g1b,g2b,g3b,g4b
      integer g1,g2,g3,g4
      integer size1,size2,size3,size4
      integer length
      integer offset_alpha,key_alpha
      logical used
c--      logical parallel
      character*255 filename
c --- controls the logic of orbital integrals --
      logical l31s,l42s,lp31p42
      logical l32s,l41s,lp32p41
      integer ig1b,ig2b,ig3b,ig4b
      integer irow,icol,ires
      integer index_pair
      integer check_key
      logical uaadaa, ubbdbb
      logical uabdab,ubadba,ubadab,uabdba
c --- keys to orbital part
      integer key_ix,nkey,first_h,second_h
      integer i1,j1,k1,l1
      integer inx1,inx2,inx3,inx4
c
c         print*,'tce_sort version get_block_ind'
c
      cpusecs(5) = cpusecs(5) - util_cpusec()
      cpusecs(55) = cpusecs(55) - util_wallsec()
c--      parallel = (ga_nnodes().gt.1)
cccx      if (util_print('get_block',print_debug)) then
cccx         write(LuOut,9000) ga_nodeid(),d_file,size,offset
cccx      endif
ccccx      if (offset .eq. -1)
ccccx     1  call errquit('get_block: illegal offset',0,UNKNOWN_ERR)
c
c
c
c
c keys to orbital integrals!
c
c
      DO g3b = 1,noab+nvab
      DO g4b = g3b,noab+nvab
      DO g1b = 1,noab+nvab
      DO g2b = g1b,noab+nvab
      IF (int_mb(k_spin+g3b-1)+int_mb(k_spin+g4b-1) .eq. int_mb(k_spin+g
     &1b-1)+int_mb(k_spin+g2b-1)) THEN
      IF (ieor(int_mb(k_sym+g3b-1),ieor(int_mb(k_sym+g4b-1),ieor(int_mb(
     &k_sym+g1b-1),int_mb(k_sym+g2b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+g3b-1)+int_mb(k_spin+g4b-1
     &)+int_mb(k_spin+g1b-1)+int_mb(k_spin+g2b-1).ne.8)) THEN
c
      nkey=g2b-1+(noab+nvab)*(g1b-1+
     &(noab+nvab)*(g4b-1+(noab+nvab)*(g3b-1)))
c
      if(key_ix.eq.nkey) then !----
       inx3=g3b
       inx4=g4b
       inx1=g1b
       inx2=g2b
c first half
        j1 = int_mb(k_b2am+g3b-1)
        i1 = int_mb(k_b2am+g1b-1)
        l1 = int_mb(k_b2am+g4b-1)
        k1 = int_mb(k_b2am+g2b-1)
        if(i1.ge.j1) then
         i = i1
         j = j1
        else
         i = j1
         j = i1
        end if
        if(k1.ge.l1) then
         k = k1
         l = l1
        else
         k = l1
         l = k1
        end if
         irow = INDEX_PAIR(i,j)
         icol = INDEX_PAIR(k,l)
         if(irow.ge.icol) then
          ires = INDEX_PAIR(irow,icol)
         else
          ires = INDEX_PAIR(icol,irow)
         end if
         first_h = IRES
        j1 = int_mb(k_b2am+g3b-1)
        i1 = int_mb(k_b2am+g2b-1)
        l1 = int_mb(k_b2am+g4b-1)
        k1 = int_mb(k_b2am+g1b-1)
        if(i1.ge.j1) then
         i = i1
         j = j1
        else
         i = j1
         j = i1
        end if
        if(k1.ge.l1) then
         k = k1
         l = l1
        else
         k = l1
         l = k1
        end if
         irow = INDEX_PAIR(i,j)
         icol = INDEX_PAIR(k,l)
         if(irow.ge.icol) then
          ires = INDEX_PAIR(irow,icol)
         else
          ires = INDEX_PAIR(icol,irow)
         end if
         second_h = ires
c ---------
         go to 1000
      end if ! -----
c
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
c
 1000 CONTINUE
c
c
         irow = 0
         icol = 0
         ires = 0
         g1b  = 0
         g2b  = 0
         g3b  = 0
         g4b  = 0
c
c
c
      if (ioalg.eq.2) then
c v^{ g3b < g4b}_{ g1b < g2b } => ( g3b g1b | g4b g2b ) - ( g3b g2b | g4b g1b )
        uaadaa=.false.
        ubbdbb=.false.
        uabdab=.false.
        ubadba=.false.
        ubadab=.false.
        uabdba=.false.
c--        length = int_mb(k_o2ot_offset)
c--        g3b = int_mb(k_o2ot_offset+indexc)
c--        g4b = int_mb(k_o2ot_offset+length+indexc)
c--        g1b = int_mb(k_o2ot_offset+2*length+indexc)
c--        g2b = int_mb(k_o2ot_offset+3*length+indexc)
        g3b=inx3
        g4b=inx4
        g1b=inx1
        g2b=inx2
c CHECK POINT
        if((g3b.ne.inx3).or.(g4b.ne.inx4).or.(g1b.ne.inx1).or.
     &     (g2b.ne.inx2)) then
           call errquit('get_block_ind:g-ind failed',0,UNKNOWN_ERR)
        end if
c
        ispin=int_mb(k_spin+g3b-1)+int_mb(k_spin+g4b-1)+
     1        int_mb(k_spin+g1b-1)+int_mb(k_spin+g2b-1)
        if(ispin.eq.4) uaadaa=.true.
        if(ispin.eq.8) ubbdbb=.true.
        if(int_mb(k_spin+g3b-1).eq.1.and.int_mb(k_spin+g4b-1).eq.2.and.
     1     int_mb(k_spin+g1b-1).eq.1.and.int_mb(k_spin+g2b-1).eq.2)
     2     uabdab=.true.
        if(int_mb(k_spin+g3b-1).eq.2.and.int_mb(k_spin+g4b-1).eq.1.and.
     1     int_mb(k_spin+g1b-1).eq.2.and.int_mb(k_spin+g2b-1).eq.1)
     2     ubadba=.true.
        if(int_mb(k_spin+g3b-1).eq.2.and.int_mb(k_spin+g4b-1).eq.1.and.
     1     int_mb(k_spin+g1b-1).eq.1.and.int_mb(k_spin+g2b-1).eq.2)
     2     ubadab=.true.
        if(int_mb(k_spin+g3b-1).eq.1.and.int_mb(k_spin+g4b-1).eq.2.and.
     1     int_mb(k_spin+g1b-1).eq.2.and.int_mb(k_spin+g2b-1).eq.1)
     2     uabdba=.true.
c        if ((ispin.eq.6).or.(ispin.eq.4).or.(ispin.eq.8)) then
        if (uaadaa.or.ubbdbb.or.uabdab.or.ubadba) then
c first half
c--         key_alpha = int_mb(k_o2o_offset+indexc)
        key_alpha = first_h
c CHECK POINT
         if(key_alpha.ne.first_h) then
          write(6,*)'key_alpha first_h',key_alpha,first_h
          call util_flush(6)
          call errquit('get_block_ind:first_h',0,UNKNOWN_ERR)
         end if
c defining the order
         ig2b=int_mb(k_b2am+g2b-1)
         ig1b=int_mb(k_b2am+g1b-1)
         ig3b=int_mb(k_b2am+g3b-1)
         ig4b=int_mb(k_b2am+g4b-1)
         if(ig3b.ge.ig1b) then
            l31s=.false.
            irow=index_pair(ig3b,ig1b)
         else
            l31s=.true.
            irow=index_pair(ig1b,ig3b)
         end if
         if(ig4b.ge.ig2b) then
            l42s=.false.
            icol=index_pair(ig4b,ig2b)
         else
            l42s=.true.
            icol=index_pair(ig2b,ig4b)
         end if
         if(irow.ge.icol) then
            lp31p42=.false.
            check_key=index_pair(irow,icol)
         else
            lp31p42=.true.
            check_key=index_pair(icol,irow)
         end if
ccx         call tce_hash_n(int_mb(k_v2_alpha_offset),
ccx     1                 key_alpha,offset_alpha)
c - exascale ---
        if(model.eq.'ccsd_act') then
         call tce_hash_v2_act(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
        else
         call tce_hash_v2(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
        end if
c ---
c check_key test
ccx         if(check_key.ne.key_alpha)
ccx     1   call errquit('get_block_ind:check_key1',0,UNKNOWN_ERR)
c
c
c
         IF(.not.MA_PUSH_GET(mt_dbl,size,'noname',l_a,k_a))
     1           CALL ERRQUIT('get-block-ind1',2,MA_ERR)
         do i = 1, size
           dbl_mb(k_a+i-1) = 0.0d0
c           array(i) = 0.0d0
         enddo
         do i = 1, size
c           dbl_mb(k_a+i-1) = 0.0d0
           array(i) = 0.0d0
         enddo
         call ga_get(d_v2orb,offset_alpha+1,offset_alpha+size,1,1,
     1         dbl_mb(k_a),1)
c
         size3 = int_mb(k_range+g3b-1)
         size1 = int_mb(k_range+g1b-1)
         size4 = int_mb(k_range+g4b-1)
         size2 = int_mb(k_range+g2b-1)
c
c
c --- ( g3 g1 | g4 g2 )
        if((.not.lp31p42).and.(.not.l31s).and.(.not.l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g2-1)*size4+g4-1)*size1+g1-1)*size3+g3-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 3142
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,4,2,3,1,1.0d0)
         go to 200
        end if
c --- ( g3 g1 | g2 g4 )
        if((.not.lp31p42).and.(.not.l31s).and.(l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g4-1)*size2+g2-1)*size1+g1-1)*size3+g3-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 3124
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size4,size2,size1,size3,4,1,3,2,1.0d0)
         go to 200
        end if
c --- ( g1 g3 | g4 g2 )
        if((.not.lp31p42).and.(l31s).and.(.not.l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g2-1)*size4+g4-1)*size3+g3-1)*size1+g1-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 1342
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size4,size3,size1,3,2,4,1,1.0d0)
         go to 200
        end if
c --- ( g1 g3 | g2 g4 )
        if((.not.lp31p42).and.(l31s).and.(l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g4-1)*size2+g2-1)*size3+g3-1)*size1+g1-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 1324
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size4,size2,size3,size1,3,1,4,2,1.0d0)
         go to 200
        end if
c --- ( g4 g2 | g3 g1 )
        if((lp31p42).and.(.not.l31s).and.(.not.l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g1-1)*size3+g3-1)*size2+g2-1)*size4+g4-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 4231
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size3,size2,size4,2,4,1,3,1.0d0)
         go to 200
        end if
c --- ( g4 g2 | g1 g3 )
        if((lp31p42).and.(l31s).and.(.not.l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g3-1)*size1+g1-1)*size2+g2-1)*size4+g4-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 4213
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size1,size2,size4,1,4,2,3,1.0d0)
         go to 200
        end if
c --- ( g2 g4 | g3 g1 )
        if((lp31p42).and.(.not.l31s).and.(l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g1-1)*size3+g3-1)*size4+g4-1)*size2+g2-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 2431
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size3,size4,size2,2,3,1,4,1.0d0)
         go to 200
        end if
c --- ( g2 g4 | g1 g3 )
        if((lp31p42).and.(l31s).and.(l42s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) +
c     1    dbl_mb(k_a+(((g3-1)*size1+g1-1)*size4+g4-1)*size2+g2-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 2413
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size1,size4,size2,1,3,2,4,1.0d0)
         go to 200
        end if
c
 200     continue
c
         IF(.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('get-block-ind2',3,MA_ERR)
         end if !spin cases
c
c
c
c
c
c
        if (uaadaa.or.ubbdbb.or.uabdba.or.ubadab) then
c second half
c--         key_alpha = int_mb(k_o2o_offset+indexc+length)
        key_alpha = second_h
c CHECK POINT
         if(key_alpha.ne.second_h) then
          write(6,*)'key_alpha second_h',key_alpha,second_h
          call util_flush(6)
          call errquit('get_block_ind:second_h',0,UNKNOWN_ERR)
         end if
c defining the order
         ig2b=int_mb(k_b2am+g2b-1)
         ig1b=int_mb(k_b2am+g1b-1)
         ig3b=int_mb(k_b2am+g3b-1)
         ig4b=int_mb(k_b2am+g4b-1)
         if(ig3b.ge.ig2b) then
            l32s=.false.
            irow=index_pair(ig3b,ig2b)
         else
            l32s=.true.
            irow=index_pair(ig2b,ig3b)
         end if
         if(ig4b.ge.ig1b) then
            l41s=.false.
            icol=index_pair(ig4b,ig1b)
         else
            l41s=.true.
            icol=index_pair(ig1b,ig4b)
         end if
         if(irow.ge.icol) then
            lp32p41=.false.
            check_key=index_pair(irow,icol)
         else
            lp32p41=.true.
            check_key=index_pair(icol,irow)
         end if
c
         if(uabdba.or.ubadab) then
          do i = 1, size
c--- not opened yet            dbl_mb(k_a+i-1) = 0.0d0
            array(i) = 0.0d0
          enddo
         end if
c
ccx         call tce_hash_n(int_mb(k_v2_alpha_offset),
ccx     1                 key_alpha,offset_alpha)
c - exascale ---
        if(model.eq.'ccsd_act') then
         call tce_hash_v2_act(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
        else
         call tce_hash_v2(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
        end if
c ---
c check_key test
ccx         if(check_key.ne.key_alpha)
ccx     1   call errquit('get_block_ind:check_key2',0,UNKNOWN_ERR)
c -------------
         IF(.not.MA_PUSH_GET(mt_dbl,size,'noname',l_a,k_a))
     1           CALL ERRQUIT('get-block-ind1',2,MA_ERR)
         do i = 1, size
           dbl_mb(k_a+i-1) = 0.0d0
         enddo
         call ga_get(d_v2orb,offset_alpha+1,offset_alpha+size,1,1,
     1         dbl_mb(k_a),1)
c
c
         size3 = int_mb(k_range+g3b-1)
         size1 = int_mb(k_range+g1b-1)
         size4 = int_mb(k_range+g4b-1)
         size2 = int_mb(k_range+g2b-1)
c
c
c --- ( g3 g2 | g4 g1 )
        if((.not.lp32p41).and.(.not.l32s).and.(.not.l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g1-1)*size4+g4-1)*size2+g2-1)*size3+g3-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 3241
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size2,size3,4,2,1,3,-1.0d0)
         go to 300
        end if
c --- ( g3 g2 | g1 g4 )
        if((.not.lp32p41).and.(.not.l32s).and.(l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g4-1)*size1+g1-1)*size2+g2-1)*size3+g3-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 3214
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,4,1,2,3,-1.0d0)
         go to 300
        end if
c --- ( g2 g3 | g4 g1 )
        if((.not.lp32p41).and.(l32s).and.(.not.l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g1-1)*size4+g4-1)*size3+g3-1)*size2+g2-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 2341
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size3,size2,3,2,1,4,-1.0d0)
         go to 300
        end if
c --- ( g2 g3 | g1 g4 )
        if((.not.lp32p41).and.(l32s).and.(l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g4-1)*size1+g1-1)*size3+g3-1)*size2+g2-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 2314
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size3,size2,3,1,2,4,-1.0d0)
         go to 300
        end if
c --- ( g4 g1 | g3 g2 )
        if((lp32p41).and.(.not.l32s).and.(.not.l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g2-1)*size3+g3-1)*size1+g1-1)*size4+g4-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 4132
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size3,size1,size4,2,4,3,1,-1.0d0)
         go to 300
        end if
c --- ( g4 g1 | g2 g3 )
        if((lp32p41).and.(l32s).and.(.not.l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g3-1)*size2+g2-1)*size1+g1-1)*size4+g4-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 4123
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size2,size1,size4,1,4,3,2,-1.0d0)
         go to 300
        end if
c --- ( g1 g4 | g3 g2 )
        if((lp32p41).and.(.not.l32s).and.(l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g2-1)*size3+g3-1)*size4+g4-1)*size1+g1-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 1432
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,2,3,4,1,-1.0d0)
         go to 300
        end if
c --- ( g1 g4 | g2 g3 )
        if((lp32p41).and.(l32s).and.(l41s)) then
c         i = 0
c         do g3 = 1,int_mb(k_range+g3b-1)
c         do g4 = 1,int_mb(k_range+g4b-1)
c         do g1 = 1,int_mb(k_range+g1b-1)
c         do g2 = 1,int_mb(k_range+g2b-1)
c         i=i+1
c          array(i) = array(i) -
c     1    dbl_mb(k_a+(((g3-1)*size2+g2-1)*size4+g4-1)*size1+g1-1)
c         enddo
c         enddo
c         enddo
c         enddo
c         dummy = 1423
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size2,size1,size4,1,3,4,2,-1.0d0)
         go to 300
        end if
c
c
c
 300    continue
c
         IF(.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('get-block-ind2',3,MA_ERR)
         end if !spin cases
c
c
c
      end if    !ioalg
c
      cpusecs(5) = cpusecs(5) + util_cpusec()
      cpusecs(55) = cpusecs(55) + util_wallsec()
      return
      end
c
c
c
c
c
c
c
c








c
      subroutine get_block_ind_i(d_file,array,size,key_ix,indexc,
     &                         w2b,w1b,w4b,w3b)
c      subroutine get_block_ind(d_file,array,size,offset,indexc)
c
c $Id: get_block_ind.F 21249 2011-10-20 18:29:14Z kowalski $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sf.fh"
#include "eaf.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "sym.fh"
c      integer dummy
      integer d_file
cccx      integer d_f
      integer size
cccx      integer offset
      double precision array(size)
c#ifdef TCESORT
c      double precision array2(size)
c#endif
      integer request
      integer l_a,k_a
      integer i,j,k,l
      integer ispin
      integer indexc
      integer g1b,g2b,g3b,g4b
      integer w1b,w2b,w3b,w4b
      integer g1,g2,g3,g4
      integer size1,size2,size3,size4
      integer length
      integer offset_alpha,key_alpha
      logical used
c--      logical parallel
      character*255 filename
c --- controls the logic of orbital integrals --
      logical l31s,l42s,lp31p42
      logical l32s,l41s,lp32p41
      integer ig1b,ig2b,ig3b,ig4b
      integer irow,icol,ires
      integer index_pair
      integer check_key
      logical uaadaa, ubbdbb
      logical uabdab,ubadba,ubadab,uabdba
c - exascale ---
cc      LOGICAL is_active_1,is_active_2,is_active_3,is_active_4
c --- keys to orbital part
      integer key_ix,nkey,first_h,second_h
      integer i1,j1,k1,l1
      integer inx1,inx2,inx3,inx4
      external index_pair
c
c
       inx3=w3b
       inx4=w4b
       inx1=w1b
       inx2=w2b
        j1 = int_mb(k_b2am+w3b-1)
        i1 = int_mb(k_b2am+w1b-1)
        l1 = int_mb(k_b2am+w4b-1)
        k1 = int_mb(k_b2am+w2b-1)
        if(i1.ge.j1) then
         i = i1
         j = j1
        else
         i = j1
         j = i1
        end if
        if(k1.ge.l1) then
         k = k1
         l = l1
        else
         k = l1
         l = k1
        end if
         irow = INDEX_PAIR(i,j)
         icol = INDEX_PAIR(k,l)
         if(irow.ge.icol) then
           first_h= k - 1 + (noa+nva) * (l - 1 + (noa+nva) * (i-
     &               1 + (noa+nva) * (j - 1)))
         else
           first_h= i - 1 + (noa+nva) * (j - 1 + (noa+nva) * (k-
     &               1 + (noa+nva) * (l - 1)))
         end if
        j1 = int_mb(k_b2am+w3b-1)
        i1 = int_mb(k_b2am+w2b-1)
        l1 = int_mb(k_b2am+w4b-1)
        k1 = int_mb(k_b2am+w1b-1)
        if(i1.ge.j1) then
         i = i1
         j = j1
        else
         i = j1
         j = i1
        end if
        if(k1.ge.l1) then
         k = k1
         l = l1
        else
         k = l1
         l = k1
        end if
         irow = INDEX_PAIR(i,j)
         icol = INDEX_PAIR(k,l)
         if(irow.ge.icol) then
          second_h= k - 1 + (noa+nva) * (l - 1 + (noa+nva) * (i-
     &               1 + (noa+nva) * (j - 1)))
         else
          second_h= i - 1 + (noa+nva) * (j - 1 + (noa+nva) * (k-
     &               1 + (noa+nva) * (l - 1)))
         end if
c
c
         irow = 0
         icol = 0
         ires = 0
         g1b  = 0
         g2b  = 0
         g3b  = 0
         g4b  = 0
c
c
c
      if (ioalg.eq.2) then
c v^{ g3b < g4b}_{ g1b < g2b } => ( g3b g1b | g4b g2b ) - ( g3b g2b | g4b g1b )
        uaadaa=.false.
        ubbdbb=.false.
        uabdab=.false.
        ubadba=.false.
        ubadab=.false.
        uabdba=.false.
        g3b=inx3
        g4b=inx4
        g1b=inx1
        g2b=inx2
c CHECK POINT
        if((g3b.ne.inx3).or.(g4b.ne.inx4).or.(g1b.ne.inx1).or.
     &     (g2b.ne.inx2)) then
           call errquit('get_block_ind:g-ind failed',0,UNKNOWN_ERR)
        end if
c
        ispin=int_mb(k_spin+g3b-1)+int_mb(k_spin+g4b-1)+
     1        int_mb(k_spin+g1b-1)+int_mb(k_spin+g2b-1)
        if(ispin.eq.4) uaadaa=.true.
        if(ispin.eq.8) ubbdbb=.true.
        if(int_mb(k_spin+g3b-1).eq.1.and.int_mb(k_spin+g4b-1).eq.2.and.
     1     int_mb(k_spin+g1b-1).eq.1.and.int_mb(k_spin+g2b-1).eq.2)
     2     uabdab=.true.
        if(int_mb(k_spin+g3b-1).eq.2.and.int_mb(k_spin+g4b-1).eq.1.and.
     1     int_mb(k_spin+g1b-1).eq.2.and.int_mb(k_spin+g2b-1).eq.1)
     2     ubadba=.true.
        if(int_mb(k_spin+g3b-1).eq.2.and.int_mb(k_spin+g4b-1).eq.1.and.
     1     int_mb(k_spin+g1b-1).eq.1.and.int_mb(k_spin+g2b-1).eq.2)
     2     ubadab=.true.
        if(int_mb(k_spin+g3b-1).eq.1.and.int_mb(k_spin+g4b-1).eq.2.and.
     1     int_mb(k_spin+g1b-1).eq.2.and.int_mb(k_spin+g2b-1).eq.1)
     2     uabdba=.true.
c        if ((ispin.eq.6).or.(ispin.eq.4).or.(ispin.eq.8)) then
        if (uaadaa.or.ubbdbb.or.uabdab.or.ubadba) then
c first half
        key_alpha = first_h
c defining the order
         ig2b=int_mb(k_b2am+g2b-1)
         ig1b=int_mb(k_b2am+g1b-1)
         ig3b=int_mb(k_b2am+g3b-1)
         ig4b=int_mb(k_b2am+g4b-1)
         if(ig3b.ge.ig1b) then
            l31s=.false.
            irow=index_pair(ig3b,ig1b)
         else
            l31s=.true.
            irow=index_pair(ig1b,ig3b)
         end if
         if(ig4b.ge.ig2b) then
            l42s=.false.
            icol=index_pair(ig4b,ig2b)
         else
            l42s=.true.
            icol=index_pair(ig2b,ig4b)
         end if
         if(irow.ge.icol) then
            lp31p42=.false.
            check_key=index_pair(irow,icol)
         else
            lp31p42=.true.
            check_key=index_pair(icol,irow)
         end if
c - exascale ---
       if(model.eq.'ccsd_act') then
        call tce_hash_v2_act(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha) 
       else
         call tce_hash_v2(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
       end if
c ---
c check_key test
cc         if(check_key.ne.key_alpha)
cc     1   call errquit('get_block_ind:check_key1',0,UNKNOWN_ERR)
c
c
c
         IF(.not.MA_PUSH_GET(mt_dbl,size,'noname',l_a,k_a))
     1           CALL ERRQUIT('get-block-ind1',2,MA_ERR)
         do i = 1, size
c --- ACHTUNG ATTENTION UWAGA BHUMAHE
ccx           dbl_mb(k_a+i-1) = 0.0d0
           array(i) = 0.0d0
         enddo
         call ga_get(d_v2orb,offset_alpha+1,offset_alpha+size,1,1,
     1         dbl_mb(k_a),1)
c
         size1 = int_mb(k_range+g1b-1)
         size2 = int_mb(k_range+g2b-1)
         size3 = int_mb(k_range+g3b-1)
         size4 = int_mb(k_range+g4b-1)
c
c
c --- ( g3 g1 | g4 g2 )
        if((.not.lp31p42).and.(.not.l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g2-1)*size4+g4-1)*size1+g1-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3142000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,4,2,3,1,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
c#endif
         go to 200
        end if
c --- ( g3 g1 | g2 g4 )
        if((.not.lp31p42).and.(.not.l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g4-1)*size2+g2-1)*size1+g1-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3124000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size4,size2,size1,size3,4,1,3,2,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 200
        end if
c --- ( g1 g3 | g4 g2 )
        if((.not.lp31p42).and.(l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g2-1)*size4+g4-1)*size3+g3-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1342000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size4,size3,size1,3,2,4,1,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 200
        end if
c --- ( g1 g3 | g2 g4 )
        if((.not.lp31p42).and.(l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g4-1)*size2+g2-1)*size3+g3-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1324000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size4,size2,size3,size1,3,1,4,2,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 200
        end if
c --- ( g4 g2 | g3 g1 )
        if((lp31p42).and.(.not.l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g1-1)*size3+g3-1)*size2+g2-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4231000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size3,size2,size4,2,4,1,3,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 200
        end if
c --- ( g4 g2 | g1 g3 )
        if((lp31p42).and.(l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g3-1)*size1+g1-1)*size2+g2-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4213000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size1,size2,size4,1,4,2,3,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 200
        end if
c --- ( g2 g4 | g3 g1 )
        if((lp31p42).and.(.not.l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g1-1)*size3+g3-1)*size4+g4-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2431000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size3,size4,size2,2,3,1,4,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 200
        end if
c --- ( g2 g4 | g1 g3 )
        if((lp31p42).and.(l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g3-1)*size1+g1-1)*size4+g4-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2413000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size1,size4,size2,1,3,2,4,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 200
        end if
c
 200     continue
c
         IF(.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('get-block-ind2',3,MA_ERR)
         end if !spin cases
c
c
c
c
        if (uaadaa.or.ubbdbb.or.uabdba.or.ubadab) then
c second half
        key_alpha = second_h
c defining the order
         ig2b=int_mb(k_b2am+g2b-1)
         ig1b=int_mb(k_b2am+g1b-1)
         ig3b=int_mb(k_b2am+g3b-1)
         ig4b=int_mb(k_b2am+g4b-1)
         if(ig3b.ge.ig2b) then
            l32s=.false.
            irow=index_pair(ig3b,ig2b)
         else
            l32s=.true.
            irow=index_pair(ig2b,ig3b)
         end if
         if(ig4b.ge.ig1b) then
            l41s=.false.
            icol=index_pair(ig4b,ig1b)
         else
            l41s=.true.
            icol=index_pair(ig1b,ig4b)
c *** debug ***
c        write(6,*)'from gbbi sh 3 irow',ig1b,ig4b,icol
c *************
         end if
         if(irow.ge.icol) then
            lp32p41=.false.
            check_key=index_pair(irow,icol)
         else
            lp32p41=.true.
            check_key=index_pair(icol,irow)
         end if
c
         if(uabdba.or.ubadab) then
          do i = 1, size
c--- k_a is not opened          dbl_mb(k_a+i-1) = 0.0d0
            array(i) = 0.0d0
          enddo
         end if
c
c - exascale ---
       if(model.eq.'ccsd_act') then
         call tce_hash_v2_act(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
       else
         call tce_hash_v2(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
       end if
c ---
         IF(.not.MA_PUSH_GET(mt_dbl,size,'noname',l_a,k_a))
     1           CALL ERRQUIT('get-block-ind1',2,MA_ERR)
c --- ACHTUNG ATTENTION UWAGA BHUMAHE
c         do i = 1, size
c           dbl_mb(k_a+i-1) = 0.0d0
c         enddo
         call ga_get(d_v2orb,offset_alpha+1,offset_alpha+size,1,1,
     1         dbl_mb(k_a),1)
c
c
         size3 = int_mb(k_range+g3b-1)
         size1 = int_mb(k_range+g1b-1)
         size4 = int_mb(k_range+g4b-1)
         size2 = int_mb(k_range+g2b-1)
c
c
c --- ( g3 g2 | g4 g1 )
        if((.not.lp32p41).and.(.not.l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g1-1)*size4+g4-1)*size2+g2-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3241001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size2,size3,4,2,1,3,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c --- ( g3 g2 | g1 g4 )
        if((.not.lp32p41).and.(.not.l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g4-1)*size1+g1-1)*size2+g2-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3214001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,4,1,2,3,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c --- ( g2 g3 | g4 g1 )
        if((.not.lp32p41).and.(l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g1-1)*size4+g4-1)*size3+g3-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2341001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size3,size2,3,2,1,4,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c --- ( g2 g3 | g1 g4 )
        if((.not.lp32p41).and.(l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
c         call zero_array(array,size,size1,size2,size3,size4)
c         call zero_array(array2,size,size1,size2,size3,size4)
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g4-1)*size1+g1-1)*size3+g3-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2314001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size3,size2,3,1,2,4,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c --- ( g4 g1 | g3 g2 )
        if((lp32p41).and.(.not.l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g2-1)*size3+g3-1)*size1+g1-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4132001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size3,size1,size4,2,4,3,1,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c --- ( g4 g1 | g2 g3 )
        if((lp32p41).and.(l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g3-1)*size2+g2-1)*size1+g1-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4123001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size2,size1,size4,1,4,3,2,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c --- ( g1 g4 | g3 g2 )
        if((lp32p41).and.(.not.l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g2-1)*size3+g3-1)*size4+g4-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1432001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,2,3,4,1,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c --- ( g1 g4 | g2 g3 )
        if((lp32p41).and.(l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g3-1)*size2+g2-1)*size4+g4-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1423001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size2,size1,size4,1,3,4,2,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)                    dummy)
         go to 300
        end if
c
c
c
 300    continue
c
         IF(.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('get-block-ind2',3,MA_ERR)
         end if !spin cases
c
c
c
      end if    !ioalg
c
c
c      cpusecs(5) = cpusecs(5) + util_cpusec()
c      cpusecs(55) = cpusecs(55) + util_wallsec()
      return
      end









c
c
c
c
c
c
c
c
c
      subroutine get_block_ind_i_przerobiony(
     &d_file,array,size,key_ix,indexc,
     &                         w2b,w1b,w4b,w3b)
c      subroutine get_block_ind(d_file,array,size,offset,indexc)
c
c $Id: get_block_ind.F 21249 2011-10-20 18:29:14Z kowalski $
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sf.fh"
#include "eaf.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
#include "sym.fh"
c      integer dummy
      integer d_file
cccx      integer d_f
      integer size
cccx      integer offset
      double precision array(size)
c#ifdef TCESORT
c      double precision array2(size)
c#endif
      integer request
      integer l_a,k_a
      integer i,j,k,l
      integer ispin
      integer indexc
      integer g1b,g2b,g3b,g4b
      integer w1b,w2b,w3b,w4b
      integer g1,g2,g3,g4
      integer size1,size2,size3,size4
      integer length
      integer offset_alpha,key_alpha
      logical used
c--      logical parallel
      character*255 filename
c --- controls the logic of orbital integrals --
      logical l31s,l42s,lp31p42
      logical l32s,l41s,lp32p41
      integer ig1b,ig2b,ig3b,ig4b
      integer irow,icol,ires
      integer index_pair
      integer check_key
      logical uaadaa, ubbdbb
      logical uabdab,ubadba,ubadab,uabdba
c --- keys to orbital part
      integer key_ix,nkey,first_h,second_h
      integer i1,j1,k1,l1
      integer inx1,inx2,inx3,inx4
      external index_pair
c
c         print*,'tce_sort version get_block_ind_i'
c
c
c
c      cpusecs(5) = cpusecs(5) - util_cpusec()
c      cpusecs(55) = cpusecs(55) - util_wallsec()
c
c
c
c
c keys to orbital integrals!
c
c
       inx3=w3b
       inx4=w4b
       inx1=w1b
       inx2=w2b
        j1 = int_mb(k_b2am+w3b-1)
        i1 = int_mb(k_b2am+w1b-1)
        l1 = int_mb(k_b2am+w4b-1)
        k1 = int_mb(k_b2am+w2b-1)
        if(i1.ge.j1) then
         i = i1
         j = j1
        else
         i = j1
         j = i1
        end if
        if(k1.ge.l1) then
         k = k1
         l = l1
        else
         k = l1
         l = k1
        end if
         irow = INDEX_PAIR(i,j)
         icol = INDEX_PAIR(k,l)
         if(irow.ge.icol) then
          ires = INDEX_PAIR(irow,icol)
         else
          ires = INDEX_PAIR(icol,irow)
         end if
         first_h = IRES
        j1 = int_mb(k_b2am+w3b-1)
        i1 = int_mb(k_b2am+w2b-1)
        l1 = int_mb(k_b2am+w4b-1)
        k1 = int_mb(k_b2am+w1b-1)
        if(i1.ge.j1) then
         i = i1
         j = j1
        else
         i = j1
         j = i1
        end if
        if(k1.ge.l1) then
         k = k1
         l = l1
        else
         k = l1
         l = k1
        end if
         irow = INDEX_PAIR(i,j)
         icol = INDEX_PAIR(k,l)
         if(irow.ge.icol) then
          ires = INDEX_PAIR(irow,icol)
         else
          ires = INDEX_PAIR(icol,irow)
         end if
         second_h = ires
c
c
         irow = 0
         icol = 0
         ires = 0
         g1b  = 0
         g2b  = 0
         g3b  = 0
         g4b  = 0
c
c
c
      if (ioalg.eq.2) then
c v^{ g3b < g4b}_{ g1b < g2b } => ( g3b g1b | g4b g2b ) - ( g3b g2b | g4b g1b )
        uaadaa=.false.
        ubbdbb=.false.
        uabdab=.false.
        ubadba=.false.
        ubadab=.false.
        uabdba=.false.
c--        length = int_mb(k_o2ot_offset)
c--        g3b = int_mb(k_o2ot_offset+indexc)
c--        g4b = int_mb(k_o2ot_offset+length+indexc)
c--        g1b = int_mb(k_o2ot_offset+2*length+indexc)
c--        g2b = int_mb(k_o2ot_offset+3*length+indexc)
        g3b=inx3
        g4b=inx4
        g1b=inx1
        g2b=inx2
c CHECK POINT
        if((g3b.ne.inx3).or.(g4b.ne.inx4).or.(g1b.ne.inx1).or.
     &     (g2b.ne.inx2)) then
           call errquit('get_block_ind:g-ind failed',0,UNKNOWN_ERR)
        end if
c
        ispin=int_mb(k_spin+g3b-1)+int_mb(k_spin+g4b-1)+
     1        int_mb(k_spin+g1b-1)+int_mb(k_spin+g2b-1)
        if(ispin.eq.4) uaadaa=.true.
        if(ispin.eq.8) ubbdbb=.true.
        if(int_mb(k_spin+g3b-1).eq.1.and.int_mb(k_spin+g4b-1).eq.2.and.
     1     int_mb(k_spin+g1b-1).eq.1.and.int_mb(k_spin+g2b-1).eq.2)
     2     uabdab=.true.
        if(int_mb(k_spin+g3b-1).eq.2.and.int_mb(k_spin+g4b-1).eq.1.and.
     1     int_mb(k_spin+g1b-1).eq.2.and.int_mb(k_spin+g2b-1).eq.1)
     2     ubadba=.true.
        if(int_mb(k_spin+g3b-1).eq.2.and.int_mb(k_spin+g4b-1).eq.1.and.
     1     int_mb(k_spin+g1b-1).eq.1.and.int_mb(k_spin+g2b-1).eq.2)
     2     ubadab=.true.
        if(int_mb(k_spin+g3b-1).eq.1.and.int_mb(k_spin+g4b-1).eq.2.and.
     1     int_mb(k_spin+g1b-1).eq.2.and.int_mb(k_spin+g2b-1).eq.1)
     2     uabdba=.true.
c        if ((ispin.eq.6).or.(ispin.eq.4).or.(ispin.eq.8)) then
        if (uaadaa.or.ubbdbb.or.uabdab.or.ubadba) then
c first half
c--         key_alpha = int_mb(k_o2o_offset+indexc)
        key_alpha = first_h
c CHECK POINT
         if(key_alpha.ne.first_h) then
          write(6,*)'key_alpha first_h',key_alpha,first_h
          call util_flush(6)
          call errquit('get_block_ind:first_h',0,UNKNOWN_ERR)
         end if
c defining the order
         ig2b=int_mb(k_b2am+g2b-1)
         ig1b=int_mb(k_b2am+g1b-1)
         ig3b=int_mb(k_b2am+g3b-1)
         ig4b=int_mb(k_b2am+g4b-1)
         if(ig3b.ge.ig1b) then
            l31s=.false.
            irow=index_pair(ig3b,ig1b)
         else
            l31s=.true.
            irow=index_pair(ig1b,ig3b)
         end if
         if(ig4b.ge.ig2b) then
            l42s=.false.
            icol=index_pair(ig4b,ig2b)
         else
            l42s=.true.
            icol=index_pair(ig2b,ig4b)
         end if
         if(irow.ge.icol) then
            lp31p42=.false.
            check_key=index_pair(irow,icol)
         else
            lp31p42=.true.
            check_key=index_pair(icol,irow)
         end if
ccx         call tce_hash_n(int_mb(k_v2_alpha_offset),
ccx     1                 key_alpha,offset_alpha)
c - exascale ---
       if(model.eq.'ccsd_act') then
        call tce_hash_v2_act(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
       else
         call tce_hash_v2(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
       end if
c ---
c check_key test
ccx         if(check_key.ne.key_alpha)
ccx     1   call errquit('get_block_ind:check_key1',0,UNKNOWN_ERR)
c
c
c
         IF(.not.MA_PUSH_GET(mt_dbl,size,'noname',l_a,k_a))
     1           CALL ERRQUIT('get-block-ind1',2,MA_ERR)
         do i = 1, size
           dbl_mb(k_a+i-1) = 0.0d0
c           array(i) = 0.0d0
         enddo
         do i = 1, size
c           dbl_mb(k_a+i-1) = 0.0d0
           array(i) = 0.0d0
         enddo
         call ga_get(d_v2orb,offset_alpha+1,offset_alpha+size,1,1,
     1         dbl_mb(k_a),1)
c
         size1 = int_mb(k_range+g1b-1)
         size2 = int_mb(k_range+g2b-1)
         size3 = int_mb(k_range+g3b-1)
         size4 = int_mb(k_range+g4b-1)
c
c
c --- ( g3 g1 | g4 g2 )
        if((.not.lp31p42).and.(.not.l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g2-1)*size4+g4-1)*size1+g1-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3142000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,4,2,3,1,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
c#endif
         go to 200
        end if
c --- ( g3 g1 | g2 g4 )
        if((.not.lp31p42).and.(.not.l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g4-1)*size2+g2-1)*size1+g1-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3124000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size4,size2,size1,size3,4,1,3,2,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 200
        end if
c --- ( g1 g3 | g4 g2 )
        if((.not.lp31p42).and.(l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g2-1)*size4+g4-1)*size3+g3-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1342000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size4,size3,size1,3,2,4,1,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 200
        end if
c --- ( g1 g3 | g2 g4 )
        if((.not.lp31p42).and.(l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g4-1)*size2+g2-1)*size3+g3-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1324000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size4,size2,size3,size1,3,1,4,2,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 200
        end if
c --- ( g4 g2 | g3 g1 )
        if((lp31p42).and.(.not.l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g1-1)*size3+g3-1)*size2+g2-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4231000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size3,size2,size4,2,4,1,3,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 200
        end if
c --- ( g4 g2 | g1 g3 )
        if((lp31p42).and.(l31s).and.(.not.l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g3-1)*size1+g1-1)*size2+g2-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4213000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size1,size2,size4,1,4,2,3,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 200
        end if
c --- ( g2 g4 | g3 g1 )
        if((lp31p42).and.(.not.l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g1-1)*size3+g3-1)*size4+g4-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2431000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size3,size4,size2,2,3,1,4,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 200
        end if
c --- ( g2 g4 | g1 g3 )
        if((lp31p42).and.(l31s).and.(l42s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) +
     1    dbl_mb(k_a+(((g3-1)*size1+g1-1)*size4+g4-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2413000
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size1,size4,size2,1,3,2,4,1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 200
        end if
c
 200     continue
c
         IF(.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('get-block-ind2',3,MA_ERR)
         end if !spin cases
c
c
c
c
        if (uaadaa.or.ubbdbb.or.uabdba.or.ubadab) then
c second half
c--         key_alpha = int_mb(k_o2o_offset+indexc+length)
        key_alpha = second_h
c CHECK POINT
         if(key_alpha.ne.second_h) then
          write(6,*)'key_alpha second_h',key_alpha,second_h
          call util_flush(6)
          call errquit('get_block_ind:second_h',0,UNKNOWN_ERR)
         end if
c defining the order
         ig2b=int_mb(k_b2am+g2b-1)
         ig1b=int_mb(k_b2am+g1b-1)
         ig3b=int_mb(k_b2am+g3b-1)
         ig4b=int_mb(k_b2am+g4b-1)
         if(ig3b.ge.ig2b) then
            l32s=.false.
            irow=index_pair(ig3b,ig2b)
         else
            l32s=.true.
            irow=index_pair(ig2b,ig3b)
         end if
         if(ig4b.ge.ig1b) then
            l41s=.false.
            icol=index_pair(ig4b,ig1b)
         else
            l41s=.true.
            icol=index_pair(ig1b,ig4b)
         end if
         if(irow.ge.icol) then
            lp32p41=.false.
            check_key=index_pair(irow,icol)
         else
            lp32p41=.true.
            check_key=index_pair(icol,irow)
         end if
c
         if(uabdba.or.ubadab) then
          do i = 1, size
c--- k_a is not opened          dbl_mb(k_a+i-1) = 0.0d0
            array(i) = 0.0d0
          enddo
         end if
c
ccx         call tce_hash_n(int_mb(k_v2_alpha_offset),
ccx     1                 key_alpha,offset_alpha)
c - exascale ---
       if(model.eq.'ccsd_act') then
         call tce_hash_v2_act(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
       else
         call tce_hash_v2(int_mb(k_v2_alpha_offset),
     1                 key_alpha,offset_alpha)
       end if
c ---
c check_key test
ccx         if(check_key.ne.key_alpha)
ccx     1   call errquit('get_block_ind:check_key2',0,UNKNOWN_ERR)
c -------------
         IF(.not.MA_PUSH_GET(mt_dbl,size,'noname',l_a,k_a))
     1           CALL ERRQUIT('get-block-ind1',2,MA_ERR)
         do i = 1, size
           dbl_mb(k_a+i-1) = 0.0d0
         enddo
         call ga_get(d_v2orb,offset_alpha+1,offset_alpha+size,1,1,
     1         dbl_mb(k_a),1)
c
c
         size3 = int_mb(k_range+g3b-1)
         size1 = int_mb(k_range+g1b-1)
         size4 = int_mb(k_range+g4b-1)
         size2 = int_mb(k_range+g2b-1)
c
c
c --- ( g3 g2 | g4 g1 )
        if((.not.lp32p41).and.(.not.l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g1-1)*size4+g4-1)*size2+g2-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3241001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size2,size3,4,2,1,3,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c --- ( g3 g2 | g1 g4 )
        if((.not.lp32p41).and.(.not.l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g4-1)*size1+g1-1)*size2+g2-1)*size3+g3-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 3214001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,4,1,2,3,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c --- ( g2 g3 | g4 g1 )
        if((.not.lp32p41).and.(l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g1-1)*size4+g4-1)*size3+g3-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2341001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size3,size2,3,2,1,4,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c --- ( g2 g3 | g1 g4 )
        if((.not.lp32p41).and.(l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
c         call zero_array(array,size,size1,size2,size3,size4)
c         call zero_array(array2,size,size1,size2,size3,size4)
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g4-1)*size1+g1-1)*size3+g3-1)*size2+g2-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 2314001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size1,size4,size3,size2,3,1,2,4,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c --- ( g4 g1 | g3 g2 )
        if((lp32p41).and.(.not.l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g2-1)*size3+g3-1)*size1+g1-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4132001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size3,size1,size4,2,4,3,1,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c --- ( g4 g1 | g2 g3 )
        if((lp32p41).and.(l32s).and.(.not.l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g3-1)*size2+g2-1)*size1+g1-1)*size4+g4-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 4123001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size2,size1,size4,1,4,3,2,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c --- ( g1 g4 | g3 g2 )
        if((lp32p41).and.(.not.l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g2-1)*size3+g3-1)*size4+g4-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1432001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size2,size1,size4,size3,2,3,4,1,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c --- ( g1 g4 | g2 g3 )
        if((lp32p41).and.(l32s).and.(l41s)) then
c         call copy_array(array2,array,size,size1,size2,size3,size4)
#ifdef LOOPS
         i = 0
         do g3 = 1,int_mb(k_range+g3b-1)
         do g4 = 1,int_mb(k_range+g4b-1)
         do g1 = 1,int_mb(k_range+g1b-1)
         do g2 = 1,int_mb(k_range+g2b-1)
         i=i+1
          array(i) = array(i) -
     1    dbl_mb(k_a+(((g3-1)*size2+g2-1)*size4+g4-1)*size1+g1-1)
         enddo
         enddo
         enddo
         enddo
         dummy = 1423001
#endif
         call tce_sortacc_4(dbl_mb(k_a),array,
     &                      size3,size2,size1,size4,1,3,4,2,-1.0d0)
c         call test_array(array2,array,size,size1,size2,size3,size4,
c          &                    dummy)
         go to 300
        end if
c
c
c
 300    continue
c
         IF(.not.MA_POP_STACK(l_a))
     1            CALL ERRQUIT('get-block-ind2',3,MA_ERR)
         end if !spin cases
c
c
c
      end if    !ioalg
c
c      cpusecs(5) = cpusecs(5) + util_cpusec()
c      cpusecs(55) = cpusecs(55) + util_wallsec()
      return
      end

#ifdef LOOPS

      subroutine copy_array(array2,array,size,size1,size2,size3,size4)
      implicit none
c#include "util.fh"
c#include "stdio.fh"
#include "errquit.fh"
c#include "tce.fh"
c#include "tce_main.fh"
      integer size,i
      double precision array(size)
      double precision array2(size)
      integer g1,g2,g3,g4
      integer size1,size2,size3,size4

         i = 0
         do g3 = 1,size3
         do g4 = 1,size4
         do g1 = 1,size1
         do g2 = 1,size2
         i=i+1
          array2(i) = array(i)
         enddo
         enddo
         enddo
         enddo

      return
      end

      subroutine test_array(array2,array,size,size1,size2,size3,size4,
     &                      dummy)
      implicit none
c#include "util.fh"
c#include "stdio.fh"
#include "errquit.fh"
c#include "tce.fh"
c#include "tce_main.fh"
      integer size,dummy,i
      double precision array(size)
      double precision array2(size)
      integer g1,g2,g3,g4
      integer size1,size2,size3,size4
      logical throw

         throw=.false.
         i = 0
         do g3 = 1,size3
         do g4 = 1,size4
         do g1 = 1,size1
         do g2 = 1,size2
         i=i+1
          if ( (abs(array(i)).gt.(1.0d-9)).or.
     &         (abs(array2(i)).gt.(1.0d-9)) ) then
          if (array(i).ne.array2(i)) then
            print*,'PROBLEM',i,array(i),array2(i)
            throw=.true.
          endif
          endif
         enddo
         enddo
         enddo
         enddo
         if (throw)
     &     call errquit('get_block_ind: test failed',dummy,UNKNOWN_ERR)

      return
      end

      subroutine zero_array(array,size,size1,size2,size3,size4)
      implicit none
c#include "util.fh"
c#include "stdio.fh"
#include "errquit.fh"
c#include "tce.fh"
c#include "tce_main.fh"
      integer size,i
      double precision array(size)
      integer g1,g2,g3,g4
      integer size1,size2,size3,size4

         i = 0
         do g3 = 1,size3
         do g4 = 1,size4
         do g1 = 1,size1
         do g2 = 1,size2
         i=i+1
          array(i) = 0.0d0
         enddo
         enddo
         enddo
         enddo

      return
      end

#endif

      logical function argos_prep_slvrd(lfnslv,filslv,
     + xw,vw,mwm,mwa,nwm,nwa,box)
c
c $Id: argos_prep_slvrd.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer lfnslv,mwm,mwa,nwm,nwa
      character*255 filslv
      real*8 xw(3,mwa,mwm),vw(3,mwa,mwm),box(3),vlat(3,3)
c
      character*1 cdum
      integer i,j,k,idum,jdum,kdum,nsa,npbtyp
      real*8 rdum
c
      open(unit=lfnslv,file=filslv(1:index(filslv,' ')-1),
     + status='old',err=9999)
c
      do 1 i=1,4
      read(lfnslv,1000) cdum
 1000 format(a1)
    1 continue
      read(lfnslv,1001) npbtyp
 1001 format(i5)
      read(lfnslv,1002) ((vlat(i,j),j=1,3),i=1,3)
 1002 format(3f12.6)
      box(1)=vlat(1,1)
      box(2)=vlat(2,2)
      box(3)=vlat(3,3)
      read(lfnslv,1003) jdum
 1003 format(40x,i5)
      read(lfnslv,1000) cdum
      if(jdum.ne.0) then
      read(lfnslv,1000) cdum
      endif
      read(lfnslv,1004) nwm,nwa,jdum,nsa,idum
 1004 format(4i10,30x,i5)
      if(idum.gt.0) then
      read(lfnslv,1005) idum,jdum,kdum
 1005 format(3i5)
      read(lfnslv,1006) (rdum,i=1,idum)
      read(lfnslv,1006) (rdum,i=1,jdum)
      read(lfnslv,1006) (rdum,i=1,kdum)
 1006 format(4e20.12)
      endif
c
      if(nwm.ne.mwm) goto 9998
      if(nsa.ne.0) goto 9998
c
      do 3 k=1,nwm
      read(lfnslv,1007) ((xw(i,j,k),i=1,3),(vw(i,j,k),i=1,3),j=1,nwa)
 1007 format(2x,6f13.8)
      read(lfnslv,1000) cdum
    3 continue
c
      close(unit=lfnslv)
c
      argos_prep_slvrd=.true.
      return
c
c
 9998 continue
      close(unit=lfnslv)
 9999 continue
      argos_prep_slvrd=.false.
      return
      end

c
c $Id: nwpw_gaunt.F 21338 2011-10-30 00:13:59Z bylaska $
c

*     ***********************************
*     *                                 *
*     *  	 nwpw_gaunt_init 	*
*     *                                 *
*     ***********************************
      subroutine paw_gaunt_init(iscomplex)
      implicit none
      logical iscomplex

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_gaunt_data.fh"

*     !**** local varialbles ****
      logical value
      integer i,j,k,indx
      integer l1,l2,l3,m1,m2,m3

      integer sizel,sizel2

      !**** external functions ****
      real*8   nwpw_gen_gaunt_coeff_sub
      external nwpw_gen_gaunt_coeff_sub

      call nwpw_timing_start(15)

      gaunt_complex = iscomplex
      gaunt_lmax = 8

      sizel  = (gaunt_lmax+1)
      sizel2 = sizel**2

      value = MA_alloc_get(mt_dbl,sizel*sizel2*sizel2,
     >                    'gaunt_coeff',
     >                     gaunt_coeff(2),
     >                     gaunt_coeff(1))
      if (.not. value) 
     >   call errquit('nwpw_gaunt_init:out of heap memory',0,
     >                MA_ERR)


      do l1=0,gaunt_lmax
      do l2=0,gaunt_lmax
      do l3=0,gaunt_lmax

        do m2=-l2,l2
        do m3=-l3,l3
          m1 = m2-m3

          if (abs(m1) .le. l1) then
            i = l1
            j = l2**2 + (l2+m2)
            k = l3**2 + (l3+m3)
            indx = i + j*sizel + k*sizel*sizel2

            dbl_mb(gaunt_coeff(1)+indx)
     >      =nwpw_gen_gaunt_coeff_sub(l1,m1,l2,m2,l3,m3) 
          end if

        end do
        end do

      end do
      end do
      end do
      
      call nwpw_timing_end(15)
      return
      end

*     ***********************************
*     *                                 *
*     *  	 nwpw_gaunt_end  	*
*     *                                 *
*     ***********************************
      subroutine nwpw_gaunt_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_gaunt_data.fh"


      call nwpw_timing_start(15)

      if (.not.MA_free_heap(nwpw_gaunt_coeff(2)))
     > call errquit('paw_gaunt_end:error freeing heap memory',0,MA_ERR)

      call nwpw_timing_end(15)
      return
      end

*     ***********************************
*     *                                 *
*     *       nwpw_gen_gaunt_coeff	*
*     *                                 *
*     ***********************************
      double precision function nwpw_gen_gaunt_coeff(l1,m1,l2,m2,l3,m3)
      implicit none
      integer  l1,l2,l3
      integer  m1,m2,m3

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_gaunt_data.fh"


      !**** local variables ****
      integer i,j,k,indx
      integer sizel,sizel2
      real*8 sum

      !**** external functions ****
      real*8   nwpw_gen_gaunt_coeff_sub
      external nwpw_gen_gaunt_coeff_sub

      call nwpw_timing_start(15)

!      IF(l1<0 .OR. l2<0 .OR. l3<0) THEN
!       CALL fatal_error("Invalid parameter in gen_gaunt_coeff, negative l")
!      END IF
!
!      IF(l1<ABS(m1) .OR. l3<ABS(m3) .OR. l2<ABS(m2)) THEN
!       CALL fatal_error("Invalid parameter in gen_gaunt_coeff, m > l")
!      END IF

      !*** gaunt coefficient zero ***
      if ((-m1+m2-m3).ne.0) then
        sum = 0.0d0

      !*** calculate gaunt coefficient ***
      else if ((l1.gt.gaunt_lmax) .or. 
     >         (l2.gt.gaunt_lmax) .or. 
     >         (l3.gt.gaunt_lmax)) then
        sum = nwpw_gen_gaunt_coeff_sub(l1,m1,l2,m2,l3,m3)

      !*** retrieve precomputed gaunt coefficient ***
      else
        sizel  = (gaunt_lmax+1)
        sizel2 = sizel**2
        i = l1
        j = l2**2 + (l2+m2)
        k = l3**2 + (l3+m3)
        indx = i + j*sizel + k*sizel*sizel2
        sum = dbl_mb(gaunt_coeff(1)+indx)
      end if

      call nwpw_timing_end(15)

      nwpw_gen_gaunt_coeff = sum
      return
      end


*     ***********************************
*     *                                 *
*     *      nwpw_gen_gaunt_coeff_sub	*
*     *                                 *
*     ***********************************

      real*8 function nwpw_gen_gaunt_coeff_sub(iscmplx,
     >                                         l1,m1,l2,m2,l3,m3)
      implicit none
      logical iscmplx
      integer l1,l2,l3
      integer m1,m2,m3
      integer i
      integer order
      real*8  x1,x2
     

#include"paw_spher_func.fh"


*     *** local variables ****
      double precision pi
      double precision fourpi
      parameter(pi = 3.14159265358979323846264338327950288419D0)
      parameter(fourpi = pi*4.0D0)

c     work arrays for integration
      double precision x(100),w(100)


      !**** Error Checking ****
      if (l1.lt.0 .or. l2.lt.0 .or. l3.lt.0) call errquit(
     1   'Invalid parameter in gen_gaunt_coeff, negative l',0,1)
      If (l1.lt.abs(m1) .or. l3.lt.abs(m3) .or. l2.lt.abs(m2)) call 
     1   errquit('Invalid parameter in gen_gaunt_coeff, m > l',0,1)

      !**** Do integration over angle phi ****
      if (iscmplx) then
         if ((-m1) + m2 - m3 .ne. 0) then
            nwpw_gen_gaunt_coeff_sub = 0.0d0
            return 
         endif
      else
      endif

      !**** Check the triangle rule ****
      if (l3.gt.l1+l2 .or. l3.lt.abs(l1-l2)) then
         nwpw_gen_gaunt_coeff_sub = 0.0d0
         return 
      endif

      !**** Check if the integrand is odd function==>integral is zero ****
      if (mod(l1 + l2 + l3,2) .eq. 1) then
         nwpw_gen_gaunt_coeff_sub = 0.0d0
         return 
      endif

      !**** hANDLE THE EXEPTIONAL CASE ****
      if (l1.eq.0 .and. l2.eq.0 .and. l3.eq.0) then
         nwpw_gen_gaunt_coeff_sub = 1.0d0/dsqrt(fourpi)
         return 
      endif
      x1 = -1.0
      x2 =  1.0
      order = l1 + l2 + l3

      !**** Generate weights and coordinates for Gauss-Legendre integration ****
      CALL gauss_weights(x1,x2,x,w,order)
      nwpw_gen_gaunt_coeff_sub = 0.0d0
      do i = 1, order
         nwpw_gen_gaunt_coeff_sub = nwpw_gen_gaunt_coeff_sub 
     >                       + w(i)*theta_lm(l1,m1,x(i))
     >                             *theta_lm(l2,m2,x(i))
     >                             *theta_lm(l3,m3,x(i))
      end do

      nwpw_gen_gaunt_coeff_sub = nwpw_gen_gaunt_coeff_sub*2.0d0*pi

      return
      end 
 

      SUBROUTINE ccsdtq_lambda2_28(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsdtq_lambda2_28.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h3 h4 p1 p2 )_yttv + = 1/2 * P( 2 ) * Sum ( h8 h12 h13 ) * i1 ( h3 h4 h8 h12 h13 p1 )_ytt * v ( h12 h13 h8 p2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h8b
      INTEGER h12b
      INTEGER h13b
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER h8b_1
      INTEGER p1b_1
      INTEGER h12b_1
      INTEGER h13b_1
      INTEGER h12b_2
      INTEGER h13b_2
      INTEGER p2b_2
      INTEGER h8b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,ieor(irrep_t
     &,ieor(irrep_t,irrep_v)))) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_28',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h8b = 1,noab
      DO h12b = 1,noab
      DO h13b = h12b,noab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+h8b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h13
     &b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h8b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+h12b-1),in
     &t_mb(k_sym+h13b-1)))))) .eq. ieor(irrep_y,ieor(irrep_t,irrep_t))) 
     &THEN
      CALL TCE_RESTRICTED_6(h3b,h4b,h8b,p1b,h12b,h13b,h3b_1,h4b_1,h8b_1,
     &p1b_1,h12b_1,h13b_1)
      CALL TCE_RESTRICTED_4(h12b,h13b,p2b,h8b,h12b_2,h13b_2,p2b_2,h8b_2)
      dim_common = int_mb(k_range+h8b-1) * int_mb(k_range+h12b-1) * int_
     &mb(k_range+h13b-1)
      dima_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_mb
     &(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_28',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_28',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h13b_
     &1 - 1 + noab * (h12b_1 - 1 + noab * (p1b_1 - noab - 1 + nvab * (h8
     &b_1 - 1 + noab * (h4b_1 - 1 + noab * (h3b_1 - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h8b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h13b-1),4,2,1,6,5,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_28',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_28',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda2_28',5,MA_ERR)
      IF ((h8b .le. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - 1 + (noab+nvab) * (h8b_2 - 1 + (noab+nvab) * (h13b_2 - 1 + (noa
     &b+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h13b-1),int_mb(k_range+h8b-1),int_mb(k_range+p2b-
     &1),4,2,1,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda2_28',6,MA_
     &ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h12b .eq. h13b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda2_28',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_28',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_28',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF ((p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h4b-1),int_mb(k_range+h3b-1)
     &,4,3,1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (h4b - 1 + noab * (h3b
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_28',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda2_28',
     &11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_diana_adddistance()
c
c     add distance to the distance list
c     -------------------------------
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      logical lequiv
      integer last
      integer i,iddist,ndistp
      integer ndims(4)
c
      read(card(8:13),1000) lequiv,iddist
 1000 format(l1,i5)
c
      ndistp=ndist
      ndist=ndist+1
      if(ndist.gt.mxdist) call md_abort('Increase dimension mxdist',0)
c
      if(me.eq.0) then
      do 1 i=1,2
      read(lfncmd,1001,end=9999) card
 1001 format(a)
      call argos_diana_index(byte_mb(i_snam),
     + idist(ndist,i,1),idist(ndist,i,2))
    1 continue
      idist(ndist,1,3)=iddist
      idist(ndist,2,3)=1
c
      last=ndist
c      if(lequiv) then
c      call argos_diana_equitors(int_mb(i_iequi),int_mb(i_imol),
c     + idtors)
c      endif
      call argos_diana_listdist(byte_mb(i_snam),last)
c
      idist(ndist,2,3)=ndist-ndistp
      endif
c
      call ga_brdcst(mag_d09,idist,
     + 12*mxdist*ma_sizeof(mt_int,1,mt_byte),0)
c
      ndims(1)=0
      ndims(2)=0
      ndims(3)=ndist
      ndims(4)=0
c
      call ga_brdcst(mag_d10,ndims,4*ma_sizeof(mt_int,1,mt_byte),0)
c
      ndist=ndims(3)
c
      return
 9999 continue
      call md_abort('Failed to read distance',0)
      return
      end
c $Id: argos_diana_adddistance.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine dia_average()
c
c $Id: dia_average.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     get atom selection
c     ------------------
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      character*3 fmt
      character*80 fil
      integer i
c
      if(nsel.eq.0) call md_abort('No atoms selected',0)
c
c     get the average coordinates
c
      call ga_distribution(ga_trj,me,il,ih,jl,jh)
      call ga_access(ga_trj,il,ih,jl,jh,ndx,ld)
c
      call dia_xaver(dbl_mb(ndx),dbl_mb(i_xadat))
c
      if(card(7:7).eq.' ') return
c
      if(me.eq.0) then
c
      read(card(7:80),'(a)') fil
c
      i=index(fil,'.')
      if(i.le.0) then
      fmt='pdb'
      else
      fmt=filcop(i+1:i+3)
      endif
c
      if(fmt.eq.'pdb') then
      call dia_wrtpdb(.true.,lfncop,fil,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xadat),int_mb(i_wsel),dbl_mb(i_wdat),.false.,.false.,
     + int_mb(i_ndxw))
      elseif(fmt.eq.'xyz') then
      call dia_wrtxyz(lfncop,fil,byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_xadat),dbl_mb(i_qdat),int_mb(i_wsel),dbl_mb(i_wdat),
     + .false.,.false.,int_mb(i_ndxw))
      endif
c
      write(*,'(/,a,a)')
     +  ' Averaged coordinates written to ',
     + fil(1:index(fil,' ')-1)
c
      endif
c
      return
      end

      subroutine mp2_make_nos(rtdb, basis, nbf, nmo, noa, nob,
     $     g_p_tot_a, g_p_tot_b, g_vecs_a, g_vecs_b, scftype, nfrozen,
     $     title)
*
* $Id: mp2_make_nos.F 21508 2011-11-11 01:53:51Z edo $
*
      implicit none
#include "errquit.fh"
#include "util.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "inp.fh"
      integer basis,rtdb,nbf,nmo
      integer g_p_tot_a,g_p_tot_b
      integer g_vecs_a,g_vecs_b
      integer noa, nob
      character*(*) scftype, title
      integer nfrozen
      character*255 filename
      character*8 string
c
c     Make the MP2 natural orbitals
c
      integer l_eval, k_eval, g_dens, g_nos(2), 
     $     g_work, g_vecs(2), g_p(2), no(2)
      integer iset, i, nsets, ioff, nmos(2)
      logical oprint
      logical movecs_write
      external movecs_write
c
      call util_file_name('mp2nos',.false.,.false.,filename)
c
      oprint = util_print('no occupation',print_default)
c
      g_vecs(1) = g_vecs_a
      g_vecs(2) = g_vecs_b
      g_p(1)    = g_p_tot_a
      g_p(2)    = g_p_tot_b
      no(1)     = noa
      no(2)     = nob
      nmos(1)   = nmo
      nmos(2) = nmo
c
      if(.not.ma_push_get(mt_dbl, 2*nbf,'mp2 nos', l_eval,k_eval))      
     $     call errquit('mp2_nos: allocating eval?', nbf, MA_ERR)
      call dfill(2*nbf, 0.0d0, dbl_mb(k_eval), 1)
c
*ga:1:0
      if(.not.ga_create(mt_dbl, nmo, nmo, 'mp2 nos a', nmo, 0,
     $     g_dens)) call errquit('mp2_nos: ga_create a failed',0,
     &       GA_ERR)
*ga:1:0
      if(.not.ga_create(mt_dbl, nmo, nmo, 'mp2 nos b', nmo, 0,
     $     g_work)) call errquit('mp2_nos: ga_create b failed',0,
     &       GA_ERR)
*ga:1:0
      if(.not.ga_create(mt_dbl, nbf, nmo, 'mp2 nos c', nbf, 0,
     $     g_nos(1))) call errquit('mp2_nos: ga_create c failed',0,
     &       GA_ERR)
      if (scftype .eq. 'UHF') then
*ga:1:0
         if(.not.ga_create(mt_dbl, nbf, nmo, 'mp2 nos d', nbf, 0,
     $        g_nos(2))) call errquit('mp2_nos: ga_create d failed',0,
     &       GA_ERR)
      endif
c
      if (scftype .eq. 'RHF') then
         nsets = 1
      else
         nsets = 2
      endif
c
      do iset = 1, nsets
         ioff = (iset-1)*nbf
c
c     Make the total density
c
         call ga_copy(g_p(iset), g_dens)
         if (ga_nodeid() .eq. 0) then
c
c     Put distinct -ve values into the frozen core so that they
c     are not mixed and the order is preserved ... undo this later.
c     Also add in the SCF occupation.
c
            do i = 1, nfrozen
               call ga_put(g_dens, i,i,i,i, dble(2*nfrozen-i), 1)
            enddo
            do i = nfrozen+1,no(iset)
               call ga_acc(g_dens, i,i,i,i, 1.0d0, 1, 1.0d0)
            enddo
         endif
         call ga_sync
c
c     This is dumb.  In order to get the NOs in order most strongly
c     to most weakly occupied, negate the density.
c
         call ga_scale(g_dens,-1.0d0)
c
#ifdef PARALLEL_DIAG
#ifdef SCALAPACK
         call ga_pdsyev  (g_dens, g_work, dbl_mb(k_eval+ioff), 0)
#else
         call ga_diag_std(g_dens, g_work, dbl_mb(k_eval+ioff))
#endif
#else
         call ga_diag_std_seq(g_dens, g_work, dbl_mb(k_eval+ioff))
#endif
c
c     Undo sign munging
c
         do i = 1, nmo
            dbl_mb(k_eval+i-1+ioff) = -dbl_mb(k_eval+i-1+ioff)
         enddo
c
c     Undo munging to stop core from mixing
c
         do i = 1, nfrozen      
            dbl_mb(k_eval+i-1+ioff) = 1.0d0
         enddo
c         
         if (scftype .eq. 'RHF') then
            do i = 1, nmo
               dbl_mb(k_eval+i-1+ioff) = dbl_mb(k_eval+i-1+ioff)*2.0d0
            enddo
         endif
c
         call ga_dgemm('n', 'n', nbf, nmo, nmo, 1.0d0,
     $        g_vecs(iset), g_work, 0.0d0, g_nos(iset))
c
         if (oprint) then
            if (ga_nodeid() .eq. 0) then
               if (scftype .eq. 'RHF') then
                  string = 'RHF'
               else
                  if (iset .eq. 1) then
                     string = 'alpha'
                  else
                     string = 'beta'
                  endif
               endif
               write(6,1) string
 1             format(/' MP2 ',a,' natural orbital occupation',
     $              ' numbers'/)
               call output(dbl_mb(k_eval+ioff),1,nmo,1,1,nmo,1,1)
               call util_flush(6)
            endif
            if (util_print('natural orbitals',print_debug)) 
     $           call ga_print(g_nos(iset))
         endif
c
      enddo
c
      call ga_sync
c
      call util_file_name('mp2nos',.false.,.false.,filename)
c
      if (.not. movecs_write(rtdb, basis, filename, 
     $     'mp2', title,
     $     nbf, nsets, nmos, dbl_mb(k_eval), nbf, 
     $     dbl_mb(k_eval), nbf, g_nos))
     $     call errquit('mp2_nos: failed writing nos',0, DISK_ERR)
c
      if (oprint .and. ga_nodeid().eq.0) then
         write(6,*)
         write(6,*) ' MP2 natural orbitals output to ',
     $        filename(1:inp_strlen(filename))
         write(6,*)
         call util_flush(6)
      endif
c
      if (.not. ma_pop_stack(l_eval)) call errquit('mp2_nos: ma?',0,
     &       MA_ERR)
      if (.not. ga_destroy(g_dens)) call errquit('mp2_nos: ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_work)) call errquit('mp2_nos: ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_nos(1))) call errquit('mp2_nos: ga?',0,
     &       GA_ERR)
      if (scftype .eq. 'UHF') then
         if (.not. ga_destroy(g_nos(2))) call errquit('mp2_nos: ga?',0,
     &       GA_ERR)
      endif
c
      end

*> \brief \b DLASRT sorts numbers in increasing or decreasing order.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLASRT + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlasrt.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlasrt.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlasrt.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLASRT( ID, N, D, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          ID
*       INTEGER            INFO, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   D( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> Sort the numbers in D in increasing order (if ID = 'I') or
*> in decreasing order (if ID = 'D' ).
*>
*> Use Quick Sort, reverting to Insertion sort on arrays of
*> size <= 20. Dimension of STACK limits N to about 2**32.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ID
*> \verbatim
*>          ID is CHARACTER*1
*>          = 'I': sort D in increasing order;
*>          = 'D': sort D in decreasing order.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The length of the array D.
*> \endverbatim
*>
*> \param[in,out] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          On entry, the array to be sorted.
*>          On exit, D has been sorted into increasing order
*>          (D(1) <= ... <= D(N) ) or into decreasing order
*>          (D(1) >= ... >= D(N) ), depending on ID.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERcomputational
*
*  =====================================================================
      SUBROUTINE DLASRT( ID, N, D, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          ID
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            SELECT
      PARAMETER          ( SELECT = 20 )
*     ..
*     .. Local Scalars ..
      INTEGER            DIR, ENDD, I, J, START, STKPNT
      DOUBLE PRECISION   D1, D2, D3, DMNMX, TMP
*     ..
*     .. Local Arrays ..
      INTEGER            STACK( 2, 32 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input paramters.
*
      INFO = 0
      DIR = -1
      IF( LSAME( ID, 'D' ) ) THEN
         DIR = 0
      ELSE IF( LSAME( ID, 'I' ) ) THEN
         DIR = 1
      END IF
      IF( DIR.EQ.-1 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLASRT', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
      STKPNT = 1
      STACK( 1, 1 ) = 1
      STACK( 2, 1 ) = N
   10 CONTINUE
      START = STACK( 1, STKPNT )
      ENDD = STACK( 2, STKPNT )
      STKPNT = STKPNT - 1
      IF( ENDD-START.LE.SELECT .AND. ENDD-START.GT.0 ) THEN
*
*        Do Insertion sort on D( START:ENDD )
*
         IF( DIR.EQ.0 ) THEN
*
*           Sort into decreasing order
*
            DO 30 I = START + 1, ENDD
               DO 20 J = I, START + 1, -1
                  IF( D( J ).GT.D( J-1 ) ) THEN
                     DMNMX = D( J )
                     D( J ) = D( J-1 )
                     D( J-1 ) = DMNMX
                  ELSE
                     GO TO 30
                  END IF
   20          CONTINUE
   30       CONTINUE
*
         ELSE
*
*           Sort into increasing order
*
            DO 50 I = START + 1, ENDD
               DO 40 J = I, START + 1, -1
                  IF( D( J ).LT.D( J-1 ) ) THEN
                     DMNMX = D( J )
                     D( J ) = D( J-1 )
                     D( J-1 ) = DMNMX
                  ELSE
                     GO TO 50
                  END IF
   40          CONTINUE
   50       CONTINUE
*
         END IF
*
      ELSE IF( ENDD-START.GT.SELECT ) THEN
*
*        Partition D( START:ENDD ) and stack parts, largest one first
*
*        Choose partition entry as median of 3
*
         D1 = D( START )
         D2 = D( ENDD )
         I = ( START+ENDD ) / 2
         D3 = D( I )
         IF( D1.LT.D2 ) THEN
            IF( D3.LT.D1 ) THEN
               DMNMX = D1
            ELSE IF( D3.LT.D2 ) THEN
               DMNMX = D3
            ELSE
               DMNMX = D2
            END IF
         ELSE
            IF( D3.LT.D2 ) THEN
               DMNMX = D2
            ELSE IF( D3.LT.D1 ) THEN
               DMNMX = D3
            ELSE
               DMNMX = D1
            END IF
         END IF
*
         IF( DIR.EQ.0 ) THEN
*
*           Sort into decreasing order
*
            I = START - 1
            J = ENDD + 1
   60       CONTINUE
   70       CONTINUE
            J = J - 1
            IF( D( J ).LT.DMNMX )
     $         GO TO 70
   80       CONTINUE
            I = I + 1
            IF( D( I ).GT.DMNMX )
     $         GO TO 80
            IF( I.LT.J ) THEN
               TMP = D( I )
               D( I ) = D( J )
               D( J ) = TMP
               GO TO 60
            END IF
            IF( J-START.GT.ENDD-J-1 ) THEN
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
            ELSE
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
            END IF
         ELSE
*
*           Sort into increasing order
*
            I = START - 1
            J = ENDD + 1
   90       CONTINUE
  100       CONTINUE
            J = J - 1
            IF( D( J ).GT.DMNMX )
     $         GO TO 100
  110       CONTINUE
            I = I + 1
            IF( D( I ).LT.DMNMX )
     $         GO TO 110
            IF( I.LT.J ) THEN
               TMP = D( I )
               D( I ) = D( J )
               D( J ) = TMP
               GO TO 90
            END IF
            IF( J-START.GT.ENDD-J-1 ) THEN
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
            ELSE
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
            END IF
         END IF
      END IF
      IF( STKPNT.GT.0 )
     $   GO TO 10
      RETURN
*
*     End of DLASRT
*
      END
c $Id: dlasrt.f 24343 2013-06-22 05:35:15Z d3y133 $

      logical function pre_mkfrg(irtdb,source,iunit,lfnpar,
     + lfnout,iconst,
     + lseq,cseq,mseq,nseq,lsgm,csgm,msgm,nsgm,latm,catm,xatm,qatm,matm,
     + natm,lato,cato,xato,qato,mato,nato,lbnd,mbnd,lbndt,mbndt,
     + lang,mang,ldih,mdih,limp,mimp,
     + maxscf,qscale,llnk,clnk,mlnk,nlnk)
c
c $Id: pre_mkfrg.F 19697 2010-10-29 16:57:34Z d3y133 $
c
c     function to prepare missing fragment definitions
c
c     in  : iunit     = dbase logical file number
c           dir_t     = dbase directory name
c           lfnout    = output file logical file number
c           mseq      = dimension of the sequence list
c
c     out : lseq(1,*) = segment numbers
c           lseq(2,*) = number of atoms
c           lseq(3,*) = index to unique segment
c           lsgm(1,i) = number of segments of type i
c           lsgm(2,i) = source: 0=not found; 1=s; 2=x; 3=u; 4=t;
c           cseq      = segment names
c
c
      implicit none
c
#include "mafdecls.fh"
#include "util.fh"
#include "pre_common.fh"
c
      logical pre_hnames,pre_hybrid
      external pre_hnames,pre_hybrid
c
      integer irtdb
      character*80 source
      integer mring,maxscf,iconst
      parameter (mring=2000)
      integer lring(6,mring)
      logical aring(mring)
c
      integer pre_atnum
      logical pre_short,pre_bnd,pre_ang,pre_dih,pre_impctr,pre_bonds
      external pre_atnum
      external pre_short,pre_bnd,pre_ang,pre_dih,pre_impctr,pre_bonds
      logical pre_atype,pre_charge
      external pre_atype,pre_charge
c
      integer iunit,lfnpar,lfnout
      integer mseq,msgm,matm,mato
      integer nseq,nsgm,natm,nato
      integer mbnd,mang,mdih,mimp
      integer mbndt,nbndt
      integer lseq(6,mseq),lsgm(3,msgm),latm(5,matm),lato(5,mato)
      character*5 cseq(2,mseq),csgm(msgm)
      character*6 catm(3,matm),cato(3,mato)
      real*8 xatm(3,matm),qatm(matm),xato(3,mato),qato(mato),qscale,qsum
      integer lbnd(2,mbnd),lang(3,mang),ldih(4,mdih),limp(4,mimp)
      integer lbndt(2,mbndt)
      character*255 filnam
      integer mlnk,nlnk
      integer llnk(4,mlnk)
      character*4 clnk(2,mlnk)
c
      integer lentmp,length,len_f
c
      integer mtyp,i_ltyp,l_ltyp
      integer nring3,nring4,nring5,nring6
c
      integer i,j,natoms,ilo,ihi,iseq,jlo,jhi,ilist
      integer ibnd,nbnd,nang,ndih,nconn,linkid
      logical found
      character*10 date,time
c
      integer i_wrk,l_wrk
c  
      pre_mkfrg=.true.
c    
      if(util_print('where',print_debug)) then
      write(lfnout,2000)
 2000 format(/,'pre_mkfrg ')
      endif
c
      lentmp=index(dirpar(mdirpar),' ')-1
      ilist=0
c
      nbndt=0
      if(.not.pre_bonds(xatm,latm,matm,1,natm,lbndt,mbndt,nbndt,
     + llnk,clnk,mlnk,nlnk)) call md_abort('Error in pre_bonds',0)
c
      if(iconst.gt.0) then
      if(.not.pre_hybrid(xatm,latm,matm,natm,lbndt,mbndt,nbndt))
     + call md_abort('Error in pre_hybrid',0)
      endif
c
      do 1 i=1,nsgm
      if(lsgm(2,i).eq.0) then
      ilist=0
c
c      if(util_print('where',print_debug)) then
      write(lfnout,2005) csgm(i)
 2005 format(/,' Creating fragment for residue ',a5,/)
c      endif
c
c     determine index first segment of this type in sequence list
c     -----------------------------------------------------------
c
      iseq=0
      do 2 j=1,mseq
      if(lseq(2,j).eq.i) then
      iseq=j
      goto 3
      endif
    2 continue
      pre_mkfrg=.false.
      return
    3 continue
c
c     find indices ilo : first atom of this segment
c     ------------ ihi : last atom for this segment
c                  jlo : first atom
c                  jhi : last atom
c
      ilo=lseq(3,iseq)
      ihi=lseq(3,iseq+1)-1
c
      linkid=3
      do 55 j=ilo,ihi
      if(latm(5,j).ge.3) then
      latm(5,j)=linkid
      linkid=linkid+1
      endif
   55 continue
c
      if(ilist.eq.0) then
c
      jlo=1
      jhi=natm
c      if(csgm(i)(5:5).eq.'N'.or.csgm(i)(5:5).eq.'M') jlo=ilo
c      if(csgm(i)(5:5).eq.'C'.or.csgm(i)(5:5).eq.'M') jhi=ihi
c
c     determine the number of 'real' atoms
c     ------------------------------------
c
      natoms=0
      do 5 j=jlo,jhi
      if(latm(2,j).le.0) latm(2,j)=pre_atnum(catm(2,j)(1:2))
      if(latm(2,j).gt.0) natoms=natoms+1
    5 continue
c
c     complete the list of bonds for the fragment
c     -------------------------------------------
c
      nbnd=0
      if(.not.ma_push_get(mt_int,12*mato,'wrk',l_wrk,i_wrk))
     + call md_abort('Unable to allocate wrk array',0)
      if(.not.pre_bnd(xatm,latm,catm,matm,natm,ilo,ihi,
     + xato,lato,cato,mato,nato,lbnd,mbnd,nbnd,maxscf,
     + llnk,clnk,mlnk,nlnk,iconst,mang,lang,mdih,ldih,
     + int_mb(i_wrk)))
     + call md_abort('pre_bnd failed',9999)
      if(.not.ma_pop_stack(l_wrk))
     + call md_abort('Unable to deallocate wrk array',0)
c
c     redetermine hydrogen names
c     --------------------------
      if(source(1:3).ne.'pdb') then
      if(.not.pre_hnames(lato,cato,mato,nato,lbnd,mbnd,nbnd))
     + call md_abort('pre_hnames failed',9999)
      endif
c
c     complete the list of angles for the fragment
c     --------------------------------------------
c
      nang=0
      if(.not.pre_ang(lbnd,mbnd,nbnd,lang,mang,nang))
     + call md_abort('pre_ang failed',9999)
c
c     complete the list of torsions for the fragment
c     --------------------------------------------
c
      ndih=0
      if(.not.pre_dih(lang,mang,nang,ldih,mdih,ndih))
     + call md_abort('pre_dih failed in pre_mkfrg',9999)
c
c     count number of bonds for each atom
c     -----------------------------------
c
      do 13 j=1,nato
      lato(1,j)=lato(3,j)
      lato(3,j)=0
      if(lato(5,j).gt.0) lato(3,j)=1
   13 continue
      do 14 ibnd=1,nbnd
      lato(3,lbnd(1,ibnd))=lato(3,lbnd(1,ibnd))+1
      lato(3,lbnd(2,ibnd))=lato(3,lbnd(2,ibnd))+1
   14 continue
c
      ilist=1
      endif
c
c     determine center types
c     ----------------------
c
      if(.not.pre_impctr(lfnout,lato,mato,1,1,nato,nato,
     + lbnd,mbnd,nbnd,lang,mang,nang,ldih,mdih,ndih,
     + lring,aring,mring,nring3,nring4,nring5,nring6))
     + call md_abort('pre_impctr failed',9999)
c
c     memory allocation for work array ltyp
c     -------------------------------------
c
      mtyp=nato+50
      if(.not.ma_push_get(mt_int,15*mtyp,'ltyp',l_ltyp,i_ltyp))
     + call md_abort('Memory allocation failed for ltyp',9999)
c
c     determine atom types
c     --------------------
c
      if(.not.pre_atype(lfnout,lfnpar,
     + lato,cato,mato,lbnd,mbnd,nbnd,
     + 1,1,nato,nato,int_mb(i_ltyp),mtyp,lring,aring,mring,
     + nring3,nring4,nring5,nring6,
     + latm,matm,natm,lbndt,mbndt,nbndt)) then
      call md_abort('pre_atype failed',9999)
      endif
c
c     memory deallocation
c     -------------------
c
      if(.not.ma_pop_stack(l_ltyp))
     + call md_abort('Memory deallocation failed for ltyp',9999)
c
c     check if all atom types could be determined
c     -------------------------------------------
c
      found=.true.
      do 16 j=1,nato
      if(lato(2,j).gt.0) then
      if(cato(3,j)(1:1).eq.' ') found=.false.
      endif
   16 continue
c
c     guestimate partial charges
c     --------------------------
c
      if(found) then
      if(.not.pre_charge(irtdb,lfnout,lfnpar,
     + source,jlo,ilo,ihi,jhi,
     + lato,cato,xato,qato,mato,nato,lbnd,mbnd,nbnd,maxscf,qscale))
     + call md_abort('pre_charge failed',9999)
      else
      if(.not.pre_charge(irtdb,lfnout,lfnpar,
     + source,jlo,ilo,ihi,jhi,
     + lato,cato,xato,qato,mato,nato,lbnd,mbnd,nbnd,0,qscale))
     + call md_abort('pre_charge failed',9999)
      endif
c
c     write the fragment file
c     -----------------------
c
      length=index(csgm(i),' ')-1
      if(length.le.0) length=5
      filnam=dirpar(mdirpar)(1:lentmp)//csgm(i)(1:length)//'.frg '
      len_f=index(filnam,' ')-1
      if(.not.found) filnam=filnam(1:len_f)//'_TMP'
      len_f=index(filnam,' ')-1
c
      if(util_print('where',print_debug)) then
      write(lfnout,'(a,a)') 'Writing new fragment file ',
     + filnam(1:len_f)
      endif
      open(unit=iunit,file=filnam(1:len_f),form='formatted',
     + status='unknown',err=9999)
c
      call swatch(date,time)
c
      write(iunit,2001) date,time
 2001 format('# This is an automatically generated fragment file',/,
     + '# Atom types and connectivity were derived from coordinates',/,
     + '# Atomic partial charges are crude estimates',/,
     + '# ',2a10,/,'#')
      length=index(csgm(i),' ')-1
      if(length.le.0) length=5
c
c     write: csgm(i) : fragment name preceded by $
c            nato    : number of atoms
c            1       : number of parameter sets / protonation states
c            1       : default protonation state
c            0       : number of Z-matrix definitions
c            csgm(i) : file name
c
      write(iunit,2002) csgm(i)(1:length),nato,1,1,0,csgm(i)(1:length)
 2002 format('$',a,/,4i5,/,a)
      if(util_print('sequence',print_medium)) then
      write(lfnout,3002) csgm(i)(1:length)
 3002 format(/,' Fragment ',t40,a,//,
     + '  num name  type   link cntr  grp pgrp    charge     polarizab',
     + /)
      endif
      found=.true.
      qsum=0.0d0
      do 6 j=1,nato
      if(lato(2,j).gt.0) then
c
      if(util_print('sequence',print_medium)) then
      write(lfnout,3003) j,cato(2,j),cato(3,j),
     + lato(5,j),lato(4,j),0,1,1,qato(j),0.0
 3003 format(i5,1x,a4,2x,a6,5i5,2f12.6)
      qsum=qsum+qato(j)
      endif
      write(iunit,2003) j,cato(2,j),cato(3,j),
     + lato(5,j),lato(4,j),0,1,1,qato(j),0.0
 2003 format(i5,a4,2x,a6,5i5,2f12.6)
      if(cato(3,j)(1:1).eq.' ') found=.false.
      endif
    6 continue
      if(util_print('sequence',print_medium)) then
      write(lfnout,3009) qsum
 3009 format(43x,'------------',/,25x,'total charge ',f12.6)
      endif
c
      nconn=0 
      do 15 ibnd=1,nbnd
      if(lbnd(1,ibnd).ge.1.and.lbnd(1,ibnd).le.nato.and.
     + lbnd(2,ibnd).ge.1.and.lbnd(2,ibnd).le.nato) then
      write(iunit,2004) lbnd(1,ibnd),lbnd(2,ibnd)
 2004 format(2i5)
      nconn=nconn+1
      endif
   15 continue
c
      if(nconn.gt.0.and.util_print('sequence',print_medium)) then
      write(lfnout,3004) 
      do 18 ibnd=1,nbnd
      if(lbnd(1,ibnd).ge.1.and.lbnd(1,ibnd).le.nato.and.
     + lbnd(2,ibnd).ge.1.and.lbnd(2,ibnd).le.nato)
     + write(lfnout,3005) lbnd(1,ibnd),lbnd(2,ibnd)
   18 continue
 3004 format(/,' Connectivity',/)
 3005 format(5x,i3,'-',i3)
      endif
c
      close(unit=iunit)
      if(util_print('sequence',print_medium)) then
      write(lfnout,3006)
 3006 format(' ')
      endif
c
      if(util_print('sequence',print_medium)) then
      write(lfnout,3007) filnam(1:len_f)
 3007 format(' Created fragment',t40,a,/)
      endif
c
      if(.not.found.and.util_print('sequence',print_none)) then
      write(lfnout,3008) csgm(i)(1:length)
 3008 format(' Unresolved atom types in fragment ',a,/)
      pre_mkfrg=.false.
c      call md_abort('Unresolved atom types',0)
      endif
c
      lsgm(2,i)=-6
c
      endif
    1 continue
c
c      pre_mkfrg=.true.
      return
c
 9999 continue
      pre_mkfrg=.false.
      return
      end

*
* $Id: lattice.f 22182 2012-03-17 16:48:22Z bylaska $
*

      subroutine lattice_min_difference(x,y,z)
      implicit none
      real*8 x,y,z

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 ua(3,3),unitg(3,3)
      common / lattice_block / ua,unitg,ecut,wcut,omega

      real*8 ub(3,3)
      common / lattice_block2 / ub

*     *** local variables ****
      real*8 c1,c2,c3

      c1 = x*ub(1,1) + y*ub(2,1) + z*ub(3,1)
      c2 = x*ub(1,2) + y*ub(2,2) + z*ub(3,2)
      c3 = x*ub(1,3) + y*ub(2,3) + z*ub(3,3)
      c1 = c1 - DNINT(c1)
      c2 = c2 - DNINT(c2)
      c3 = c3 - DNINT(c3)
      x = ua(1,1)*c1 + ua(1,2)*c2 + ua(1,3)*c3
      y = ua(2,1)*c1 + ua(2,2)*c2 + ua(2,3)*c3
      z = ua(3,1)*c1 + ua(3,2)*c2 + ua(3,3)*c3

      return
      end

      subroutine lattice_frac_to_r1(n,f1,r1)
      implicit none
      integer n
      real*8 f1(3,*),r1(3,*)

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 ua(3,3),unitg(3,3)
      common / lattice_block / ua,unitg,ecut,wcut,omega

*     **** local variables ***
      integer i

      do i=1,n
         r1(1,i) = f1(1,i)*ua(1,1) + f1(2,i)*ua(2,1) + f1(3,i)*ua(3,1)
         r1(2,i) = f1(1,i)*ua(1,2) + f1(2,i)*ua(2,2) + f1(3,i)*ua(3,2)
         r1(3,i) = f1(1,i)*ua(1,3) + f1(2,i)*ua(2,3) + f1(3,i)*ua(3,3)
      end do
      return
      end

      subroutine lattice_r1_to_frac(n,r1,f1)
      implicit none
      integer n
      real*8 r1(3,*),f1(3,*)

*     **** common block ****
      real*8 ub(3,3)
      common / lattice_block2 / ub

*     **** local variables ***
      integer i

      do i=1,n
         f1(1,i) = r1(1,i)*ub(1,1) + r1(2,i)*ub(2,1) + r1(3,i)*ub(3,1)
         f1(2,i) = r1(1,i)*ub(1,2) + r1(2,i)*ub(2,2) + r1(3,i)*ub(3,2)
         f1(3,i) = r1(1,i)*ub(1,3) + r1(2,i)*ub(2,3) + r1(3,i)*ub(3,3)
      end do
      return
      end

      subroutine lattice_fragcell(n1,r1)
      implicit none
      real*8  rcm(3)
      integer n1
      real*8  r1(3,*)

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 ua(3,3),unitg(3,3)
      common / lattice_block / ua,unitg,ecut,wcut,omega

*     **** common block ****
      real*8 ub(3,3)
      common / lattice_block2 / ub

*     **** local variables ****
      integer i,j
      real*8 fcm

      do i=2,n1
         do j=1,3
            fcm = (r1(1,i)-r1(1,1))*ub(1,j) 
     >          + (r1(2,i)-r1(2,1))*ub(2,j) 
     >          + (r1(3,i)-r1(3,1))*ub(3,j)
            do while (fcm.gt.0.5)
               r1(1,i) = r1(1,i) - ua(1,j)
               r1(2,i) = r1(2,i) - ua(2,j)
               r1(3,i) = r1(3,i) - ua(3,j)
               fcm = (r1(1,i)-r1(1,1))*ub(1,j) 
     >             + (r1(2,i)-r1(2,1))*ub(2,j) 
     >             + (r1(3,i)-r1(3,1))*ub(3,j)
            end do
            do while (fcm.le.(-0.5))
               r1(1,i) = r1(1,i) + ua(1,j)
               r1(2,i) = r1(2,i) + ua(2,j)
               r1(3,i) = r1(3,i) + ua(3,j)
               fcm = (r1(1,i)-r1(1,1))*ub(1,j) 
     >             + (r1(2,i)-r1(2,1))*ub(2,j) 
     >             + (r1(3,i)-r1(3,1))*ub(3,j)
            end do
         end do
      end do
      return
      end


      subroutine lattice_incell1_frag(rcm,n1,r1)
      implicit none 
      real*8  rcm(3)
      integer n1
      real*8  r1(3,*)

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 ua(3,3),unitg(3,3)
      common / lattice_block / ua,unitg,ecut,wcut,omega

*     **** common block ****
      real*8 ub(3,3)
      common / lattice_block2 / ub

*     **** local variables ****
      integer i
      real*8 fcm(3)

      call lattice_r1_to_frac(1,rcm,fcm)
      
      do while (fcm(1).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,1)
         rcm(2) = rcm(2) - ua(2,1)
         rcm(3) = rcm(3) - ua(3,1)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,1)
           r1(2,i) = r1(2,i) - ua(2,1)
           r1(3,i) = r1(3,i) - ua(3,1)
         end do
         fcm(1) = rcm(1)*ub(1,1) + rcm(2)*ub(2,1) + rcm(3)*ub(3,1)
      end do
      do while (fcm(1).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,1)
         rcm(2) = rcm(2) + ua(2,1)
         rcm(3) = rcm(3) + ua(3,1)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,1)
           r1(2,i) = r1(2,i) + ua(2,1)
           r1(3,i) = r1(3,i) + ua(3,1)
         end do
         fcm(1) = rcm(1)*ub(1,1) + rcm(2)*ub(2,1) + rcm(3)*ub(3,1)
      end do

      do while (fcm(2).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,2)
         rcm(2) = rcm(2) - ua(2,2)
         rcm(3) = rcm(3) - ua(3,2)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,2)
           r1(2,i) = r1(2,i) - ua(2,2)
           r1(3,i) = r1(3,i) - ua(3,2)
         end do
         fcm(2) = rcm(1)*ub(1,2) + rcm(2)*ub(2,2) + rcm(3)*ub(3,2)
      end do
      do while (fcm(2).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,2)
         rcm(2) = rcm(2) + ua(2,2)
         rcm(3) = rcm(3) + ua(3,2)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,2)
           r1(2,i) = r1(2,i) + ua(2,2)
           r1(3,i) = r1(3,i) + ua(3,2)
         end do
         fcm(2) = rcm(1)*ub(1,2) + rcm(2)*ub(2,2) + rcm(3)*ub(3,2)
      end do

      do while (fcm(3).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,3)
         rcm(2) = rcm(2) - ua(2,3)
         rcm(3) = rcm(3) - ua(3,3)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,3)
           r1(2,i) = r1(2,i) - ua(2,3)
           r1(3,i) = r1(3,i) - ua(3,3)
         end do
         fcm(3) = rcm(1)*ub(1,3) + rcm(2)*ub(2,3) + rcm(3)*ub(3,3)
      end do
      do while (fcm(3).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,3)
         rcm(2) = rcm(2) + ua(2,3)
         rcm(3) = rcm(3) + ua(3,3)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,3)
           r1(2,i) = r1(2,i) + ua(2,3)
           r1(3,i) = r1(3,i) + ua(3,3)
         end do
         fcm(3) = rcm(1)*ub(1,3) + rcm(2)*ub(2,3) + rcm(3)*ub(3,3)
      end do
      return
      end

      subroutine lattice_incell2_frag(rcm,n1,r1,r2)
      implicit none 
      real*8  rcm(3)
      integer n1
      real*8  r1(3,*)
      real*8  r2(3,*)

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 ua(3,3),unitg(3,3)
      common / lattice_block / ua,unitg,ecut,wcut,omega

*     **** common block ****
      real*8 ub(3,3)
      common / lattice_block2 / ub

*     **** local variables ****
      integer i
      real*8 fcm(3)

      call lattice_r1_to_frac(1,rcm,fcm)
      
      do while (fcm(1).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,1)
         rcm(2) = rcm(2) - ua(2,1)
         rcm(3) = rcm(3) - ua(3,1)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,1)
           r1(2,i) = r1(2,i) - ua(2,1)
           r1(3,i) = r1(3,i) - ua(3,1)

           r2(1,i) = r2(1,i) - ua(1,1)
           r2(2,i) = r2(2,i) - ua(2,1)
           r2(3,i) = r2(3,i) - ua(3,1)
         end do
         fcm(1) = rcm(1)*ub(1,1) + rcm(2)*ub(2,1) + rcm(3)*ub(3,1)
      end do
      do while (fcm(1).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,1)
         rcm(2) = rcm(2) + ua(2,1)
         rcm(3) = rcm(3) + ua(3,1)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,1)
           r1(2,i) = r1(2,i) + ua(2,1)
           r1(3,i) = r1(3,i) + ua(3,1)

           r2(1,i) = r2(1,i) + ua(1,1)
           r2(2,i) = r2(2,i) + ua(2,1)
           r2(3,i) = r2(3,i) + ua(3,1)
         end do
         fcm(1) = rcm(1)*ub(1,1) + rcm(2)*ub(2,1) + rcm(3)*ub(3,1)
      end do

      do while (fcm(2).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,2)
         rcm(2) = rcm(2) - ua(2,2)
         rcm(3) = rcm(3) - ua(3,2)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,2)
           r1(2,i) = r1(2,i) - ua(2,2)
           r1(3,i) = r1(3,i) - ua(3,2)

           r2(1,i) = r2(1,i) - ua(1,2)
           r2(2,i) = r2(2,i) - ua(2,2)
           r2(3,i) = r2(3,i) - ua(3,2)
         end do
         fcm(2) = rcm(1)*ub(1,2) + rcm(2)*ub(2,2) + rcm(3)*ub(3,2)
      end do
      do while (fcm(2).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,2)
         rcm(2) = rcm(2) + ua(2,2)
         rcm(3) = rcm(3) + ua(3,2)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,2)
           r1(2,i) = r1(2,i) + ua(2,2)
           r1(3,i) = r1(3,i) + ua(3,2)

           r2(1,i) = r2(1,i) + ua(1,2)
           r2(2,i) = r2(2,i) + ua(2,2)
           r2(3,i) = r2(3,i) + ua(3,2)
         end do
         fcm(2) = rcm(1)*ub(1,2) + rcm(2)*ub(2,2) + rcm(3)*ub(3,2)
      end do

      do while (fcm(3).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,3)
         rcm(2) = rcm(2) - ua(2,3)
         rcm(3) = rcm(3) - ua(3,3)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,3)
           r1(2,i) = r1(2,i) - ua(2,3)
           r1(3,i) = r1(3,i) - ua(3,3)

           r2(1,i) = r2(1,i) - ua(1,3)
           r2(2,i) = r2(2,i) - ua(2,3)
           r2(3,i) = r2(3,i) - ua(3,3)
         end do
         fcm(3) = rcm(1)*ub(1,3) + rcm(2)*ub(2,3) + rcm(3)*ub(3,3)
      end do
      do while (fcm(3).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,3)
         rcm(2) = rcm(2) + ua(2,3)
         rcm(3) = rcm(3) + ua(3,3)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,3)
           r1(2,i) = r1(2,i) + ua(2,3)
           r1(3,i) = r1(3,i) + ua(3,3)

           r2(1,i) = r2(1,i) + ua(1,3)
           r2(2,i) = r2(2,i) + ua(2,3)
           r2(3,i) = r2(3,i) + ua(3,3)
         end do
         fcm(3) = rcm(1)*ub(1,3) + rcm(2)*ub(2,3) + rcm(3)*ub(3,3)
      end do
      return
      end

      subroutine lattice_incell3_frag(rcm,n1,r1,r2,r3)
      implicit none 
      real*8  rcm(3)
      integer n1
      real*8  r1(3,*)
      real*8  r2(3,*)
      real*8  r3(3,*)

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 ua(3,3),unitg(3,3)
      common / lattice_block / ua,unitg,ecut,wcut,omega

*     **** common block ****
      real*8 ub(3,3)
      common / lattice_block2 / ub

*     **** local variables ****
      integer i
      real*8 fcm(3)

      call lattice_r1_to_frac(1,rcm,fcm)
      
      do while (fcm(1).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,1)
         rcm(2) = rcm(2) - ua(2,1)
         rcm(3) = rcm(3) - ua(3,1)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,1)
           r1(2,i) = r1(2,i) - ua(2,1)
           r1(3,i) = r1(3,i) - ua(3,1)

           r2(1,i) = r2(1,i) - ua(1,1)
           r2(2,i) = r2(2,i) - ua(2,1)
           r2(3,i) = r2(3,i) - ua(3,1)

           r3(1,i) = r3(1,i) - ua(1,1)
           r3(2,i) = r3(2,i) - ua(2,1)
           r3(3,i) = r3(3,i) - ua(3,1)
         end do
         fcm(1) = rcm(1)*ub(1,1) + rcm(2)*ub(2,1) + rcm(3)*ub(3,1)
      end do
      do while (fcm(1).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,1)
         rcm(2) = rcm(2) + ua(2,1)
         rcm(3) = rcm(3) + ua(3,1)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,1)
           r1(2,i) = r1(2,i) + ua(2,1)
           r1(3,i) = r1(3,i) + ua(3,1)

           r2(1,i) = r2(1,i) + ua(1,1)
           r2(2,i) = r2(2,i) + ua(2,1)
           r2(3,i) = r2(3,i) + ua(3,1)

           r3(1,i) = r3(1,i) + ua(1,1)
           r3(2,i) = r3(2,i) + ua(2,1)
           r3(3,i) = r3(3,i) + ua(3,1)
         end do
         fcm(1) = rcm(1)*ub(1,1) + rcm(2)*ub(2,1) + rcm(3)*ub(3,1)
      end do

      do while (fcm(2).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,2)
         rcm(2) = rcm(2) - ua(2,2)
         rcm(3) = rcm(3) - ua(3,2)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,2)
           r1(2,i) = r1(2,i) - ua(2,2)
           r1(3,i) = r1(3,i) - ua(3,2)

           r2(1,i) = r2(1,i) - ua(1,2)
           r2(2,i) = r2(2,i) - ua(2,2)
           r2(3,i) = r2(3,i) - ua(3,2)

           r3(1,i) = r3(1,i) - ua(1,2)
           r3(2,i) = r3(2,i) - ua(2,2)
           r3(3,i) = r3(3,i) - ua(3,2)
         end do
         fcm(2) = rcm(1)*ub(1,2) + rcm(2)*ub(2,2) + rcm(3)*ub(3,2)
      end do
      do while (fcm(2).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,2)
         rcm(2) = rcm(2) + ua(2,2)
         rcm(3) = rcm(3) + ua(3,2)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,2)
           r1(2,i) = r1(2,i) + ua(2,2)
           r1(3,i) = r1(3,i) + ua(3,2)

           r2(1,i) = r2(1,i) + ua(1,2)
           r2(2,i) = r2(2,i) + ua(2,2)
           r2(3,i) = r2(3,i) + ua(3,2)

           r3(1,i) = r3(1,i) + ua(1,2)
           r3(2,i) = r3(2,i) + ua(2,2)
           r3(3,i) = r3(3,i) + ua(3,2)
         end do
         fcm(2) = rcm(1)*ub(1,2) + rcm(2)*ub(2,2) + rcm(3)*ub(3,2)
      end do

      do while (fcm(3).gt.(0.5d0))
         rcm(1) = rcm(1) - ua(1,3)
         rcm(2) = rcm(2) - ua(2,3)
         rcm(3) = rcm(3) - ua(3,3)
         do i=1,n1
           r1(1,i) = r1(1,i) - ua(1,3)
           r1(2,i) = r1(2,i) - ua(2,3)
           r1(3,i) = r1(3,i) - ua(3,3)

           r2(1,i) = r2(1,i) - ua(1,3)
           r2(2,i) = r2(2,i) - ua(2,3)
           r2(3,i) = r2(3,i) - ua(3,3)

           r3(1,i) = r3(1,i) - ua(1,3)
           r3(2,i) = r3(2,i) - ua(2,3)
           r3(3,i) = r3(3,i) - ua(3,3)
         end do
         fcm(3) = rcm(1)*ub(1,3) + rcm(2)*ub(2,3) + rcm(3)*ub(3,3)
      end do
      do while (fcm(3).le.(-0.5d0))
         rcm(1) = rcm(1) + ua(1,3)
         rcm(2) = rcm(2) + ua(2,3)
         rcm(3) = rcm(3) + ua(3,3)
         do i=1,n1
           r1(1,i) = r1(1,i) + ua(1,3)
           r1(2,i) = r1(2,i) + ua(2,3)
           r1(3,i) = r1(3,i) + ua(3,3)

           r2(1,i) = r2(1,i) + ua(1,3)
           r2(2,i) = r2(2,i) + ua(2,3)
           r2(3,i) = r2(3,i) + ua(3,3)

           r3(1,i) = r3(1,i) + ua(1,3)
           r3(2,i) = r3(2,i) + ua(2,3)
           r3(3,i) = r3(3,i) + ua(3,3)
         end do
         fcm(3) = rcm(1)*ub(1,3) + rcm(2)*ub(2,3) + rcm(3)*ub(3,3)
      end do
      return
      end


      real*8 function lattice_wcut()
      implicit none

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      lattice_wcut = wcut
      return
      end

      real*8 function lattice_ecut()
      implicit none

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      lattice_ecut = ecut
      return
      end

      real*8 function lattice_ggcut()
      implicit none

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      lattice_ggcut = 2.0d0*ecut
      return
      end

      real*8 function lattice_wggcut()
      implicit none

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      lattice_wggcut = 2.0d0*wcut
      return
      end



      real*8 function lattice_omega()
      implicit none

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      lattice_omega = omega
      return
      end

      real*8 function lattice_unita(i,j)
      implicit none
      integer i,j

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      lattice_unita = unita(i,j)
      return
      end


      real*8 function lattice_unitg(i,j)
      implicit none
      integer i,j

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      lattice_unitg = unitg(i,j)
      return
      end

*     ********************************************
*     *                                          *
*     *          lattice_unitg_frozen            *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      real*8 function lattice_unitg_frozen(i,j)
      implicit none
      integer i,j

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_unitg_frozen = unitg_frozen(i,j)
      return
      end

*     ********************************************
*     *                                          *
*     *          lattice_unita_frozen            *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      real*8 function lattice_unita_frozen(i,j)
      implicit none
      integer i,j

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_unita_frozen = unita_frozen(i,j)
      return
      end

*     ********************************************
*     *                                          *
*     *          lattice_omega_frozen            *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      real*8 function lattice_omega_frozen()
      implicit none

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_omega_frozen = omega_frozen
      return
      end

*     ********************************************
*     *                                          *
*     *          lattice_wcut_frozen             *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      real*8 function lattice_wcut_frozen()
      implicit none

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_wcut_frozen = wcut_frozen
      return
      end

*     ********************************************
*     *                                          *
*     *          lattice_ecut_frozen             *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      real*8 function lattice_ecut_frozen()
      implicit none

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_ecut_frozen = ecut_frozen
      return
      end

*     ********************************************
*     *                                          *
*     *          lattice_ggcut_frozen            *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      real*8 function lattice_ggcut_frozen()
      implicit none

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_ggcut_frozen = 2.0d0*ecut_frozen
      return
      end

*     ********************************************
*     *                                          *
*     *         lattice_wggcut_frozen            *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      real*8 function lattice_wggcut_frozen()
      implicit none

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_wggcut_frozen = 2.0d0*wcut_frozen
      return
      end

*     ********************************************
*     *                                          *
*     *         lattice_frozen                   *
*     *                                          *
*     ********************************************

*     frozen lattice structure - used to determine masking arrays

      logical function lattice_frozen()
      implicit none

*     **** common blocks ****
      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen

      lattice_frozen = frozen
      return
      end




*     *********************************************
*     *                                           *
*     *               lattice_init                *
*     *                                           *
*     *********************************************

      subroutine lattice_init()
      implicit none

*     **** common block ****
      real*8 ecut,wcut,omega
      real*8 unita(3,3),unitg(3,3)
      common / lattice_block / unita,unitg,ecut,wcut,omega

      real*8 ub(3,3)
      common / lattice_block2 / ub

      logical frozen
      real*8 ecut_frozen,wcut_frozen,omega_frozen
      real*8 unita_frozen(3,3),unitg_frozen(3,3)
      common / lattice_froze / unita_frozen,unitg_frozen,
     >                         ecut_frozen,wcut_frozen,
     >                         omega_frozen,frozen


*     **** local variables ****
      integer nx,ny,nz
      integer nxh,nyh,nzh
      real*8  gx,gy,gz,gg
      real*8  gg1,gg2,gg3
      real*8  ecut0,wcut0

*     **** external functions ****
      logical  control_frozen
      integer  control_ngrid
      real*8   control_unita,control_ecut,control_wcut
      real*8   control_unita_frozen
      external control_frozen
      external control_ngrid
      external control_unita,control_ecut,control_wcut
      external control_unita_frozen
        
      ecut0 = control_ecut()
      wcut0 = control_wcut()

*     **** define lattice ****
      unita(1,1) = control_unita(1,1)
      unita(2,1) = control_unita(2,1)
      unita(3,1) = control_unita(3,1)
      unita(1,2) = control_unita(1,2)
      unita(2,2) = control_unita(2,2)
      unita(3,2) = control_unita(3,2)
      unita(1,3) = control_unita(1,3)
      unita(2,3) = control_unita(2,3)
      unita(3,3) = control_unita(3,3)
      call get_cube(unita,unitg,omega)

*     **** define frozen lattice - note this is only different from unita if nwpw:frozen_lattice is set ****
      frozen = control_frozen()
      unita_frozen(1,1) = control_unita_frozen(1,1)
      unita_frozen(2,1) = control_unita_frozen(2,1)
      unita_frozen(3,1) = control_unita_frozen(3,1)
      unita_frozen(1,2) = control_unita_frozen(1,2)
      unita_frozen(2,2) = control_unita_frozen(2,2)
      unita_frozen(3,2) = control_unita_frozen(3,2)
      unita_frozen(1,3) = control_unita_frozen(1,3)
      unita_frozen(2,3) = control_unita_frozen(2,3)
      unita_frozen(3,3) = control_unita_frozen(3,3)
      call get_cube(unita_frozen,unitg_frozen,omega_frozen)

*     **** define ub ****
      call dcopy(9,unitg,1,ub,1)
      call dscal(9,(1.0d0/(8.0d0*datan(1.0d0))),ub,1)
       


*     *** set the ecut variable using the frozen lattice***
c     call D3dB_nx(1,nx)
c     call D3dB_ny(1,ny)
c     call D3dB_nz(1,nz)
      nx = control_ngrid(1)
      ny = control_ngrid(2)
      nz = control_ngrid(3)
      nxh = nx/2
      nyh = ny/2
      nzh = nz/2

      gx = unitg_frozen(1,1)*dble(nxh)
      gy = unitg_frozen(2,1)*dble(nxh)
      gz = unitg_frozen(3,1)*dble(nxh)
      gg1 = gx*gx + gy*gy + gz*gz

      gx = unitg_frozen(1,2)*dble(nyh)
      gy = unitg_frozen(2,2)*dble(nyh)
      gz = unitg_frozen(3,2)*dble(nyh)
      gg2 = gx*gx + gy*gy + gz*gz

      gx = unitg_frozen(1,3)*dble(nzh)
      gy = unitg_frozen(2,3)*dble(nzh)
      gz = unitg_frozen(3,3)*dble(nzh)
      gg3 = gx*gx + gy*gy + gz*gz

      gg = gg1
      if (gg2.lt.gg) gg=gg2
      if (gg3.lt.gg) gg=gg3

      ecut = 0.5d0*gg
      if (ecut0.lt.ecut) then
         ecut = ecut0
      end if

      wcut = ecut
      if (wcut0.lt.wcut) then
         wcut = wcut0
      end if

*     **** set ecut,wcut for frozen lattice ****
      wcut_frozen = wcut
      ecut_frozen = ecut

      return
      end



*     *******************************
*     *                             *
*     *         lattice_r_grid      *
*     *                             *
*     *******************************
*
*     This routine computes coordinates of grid points in
*     the unit cell
*
*     Uses -
*          Parallel_taskid --- processor number
*          D3dB_nx --- number of grid points in direction 1
*          D3dB_ny --- number of grid points in direction 2
*          D3dB_nz --- number of grid points in direction 2
*          lattice_unita -- primitive lattice vectors in real space
*
*     Exit -
*          r  --- coordinates of grid points (Rx,Ry,Rz)
*
*
      subroutine lattice_r_grid(r)
      implicit none
      real*8 r(3,*)

*     **** local variables ****
      integer nfft3d,n2ft3d
      integer i,j,k,p,taskid
      integer index,k1,k2,k3
      integer np1,np2,np3
      integer nph1,nph2,nph3
      real*8  a(3,3),dk1,dk2,dk3

*     **** external functions ****
      real*8   lattice_unita
      external lattice_unita


*     **** constants ****
      call Parallel2d_taskid_i(taskid)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      call D3dB_nx(1,np1)
      call D3dB_ny(1,np2)
      call D3dB_nz(1,np3)

      nph1 = np1/2
      nph2 = np2/2
      nph3 = np3/2

*     **** elemental vectors ****
      do i=1,3
         a(i,1) = lattice_unita(i,1)/dble(np1)
         a(i,2) = lattice_unita(i,2)/dble(np2)
         a(i,3) = lattice_unita(i,3)/dble(np3)
      end do

      call dcopy(3*n2ft3d,0.0d0,0,r,1)

*     **** grid points in coordination space ****
      do k3 = -nph3, nph3-1
        do k2 = -nph2, nph2-1
          do k1 = -nph1, nph1-1

               i = k1 + nph1
               j = k2 + nph2
               k = k3 + nph3

               !call D3dB_ktoqp(1,k+1,q,p)
               call D3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
               if (p .eq. taskid) then
c                 index = (q-1)*(np1+2)*np2
c    >                  + j    *(np1+2)
c    >                  + i+1
                dk1=dble(k1)
                dk2=dble(k2)
                dk3=dble(k3)
                r(1,index) = a(1,1)*dk1 + a(1,2)*dk2 + a(1,3)*dk3
                r(2,index) = a(2,1)*dk1 + a(2,2)*dk2 + a(2,3)*dk3
                r(3,index) = a(3,1)*dk1 + a(3,2)*dk2 + a(3,3)*dk3

c*               **** reverse y and z ****
c                r(1,index) = a(1,1)*k1 + a(1,2)*k3 + a(1,3)*k2
c                r(2,index) = a(2,1)*k1 + a(2,2)*k3 + a(2,3)*k2
c                r(3,index) = a(3,1)*k1 + a(3,2)*k3 + a(3,3)*k2

               end if
          end do
        end do
      end do

      return
      end


      subroutine lattice_r_grid_sym(r)
      implicit none
      real*8 r(3,*)

*     **** local variables ****
      integer nfft3d,n2ft3d
      integer i,j,k,p,taskid
      integer index,k1,k2,k3
      integer np1,np2,np3
      integer nph1,nph2,nph3
      real*8  a(3,3),dk1,dk2,dk3

*     **** external functions ****
      real*8   lattice_unita
      external lattice_unita


*     **** constants ****
      call Parallel2d_taskid_i(taskid)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      call D3dB_nx(1,np1)
      call D3dB_ny(1,np2)
      call D3dB_nz(1,np3)

      nph1 = np1/2
      nph2 = np2/2
      nph3 = np3/2

*     **** elemental vectors ****
      do i=1,3
         a(i,1) = lattice_unita(i,1)/dble(np1)
         a(i,2) = lattice_unita(i,2)/dble(np2)
         a(i,3) = lattice_unita(i,3)/dble(np3)
      end do

      call dcopy(3*n2ft3d,0.0d0,0,r,1)

*     **** grid points in coordination space ****
      do k3 = -nph3+1, nph3-1
        do k2 = -nph2+1, nph2-1
          do k1 = -nph1+1, nph1-1

               i = k1 + nph1
               j = k2 + nph2
               k = k3 + nph3

               !call D3dB_ktoqp(1,k+1,q,p)
               call D3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
               if (p .eq. taskid) then
c                 index = (q-1)*(np1+2)*np2
c    >                  + j    *(np1+2)
c    >                  + i+1
                dk1=dble(k1)
                dk2=dble(k2)
                dk3=dble(k3)
                r(1,index) = a(1,1)*dk1 + a(1,2)*dk2 + a(1,3)*dk3
                r(2,index) = a(2,1)*dk1 + a(2,2)*dk2 + a(2,3)*dk3
                r(3,index) = a(3,1)*dk1 + a(3,2)*dk2 + a(3,3)*dk3

c*               **** reverse y and z ****
c                r(1,index) = a(1,1)*k1 + a(1,2)*k3 + a(1,3)*k2
c                r(2,index) = a(2,1)*k1 + a(2,2)*k3 + a(2,3)*k2
c                r(3,index) = a(3,1)*k1 + a(3,2)*k3 + a(3,3)*k2

               end if
          end do
        end do
      end do

      return
      end

      subroutine lattice_mask_sym(r)
      implicit none
      real*8 r(*)

*     **** local variables ****
      integer nfft3d,n2ft3d
      integer i,j,k,p,taskid
      integer index,k1,k2,k3
      integer np1,np2,np3
      integer nph1,nph2,nph3


*     **** constants ****
      call Parallel2d_taskid_i(taskid)
      call D3dB_nfft3d(1,nfft3d)
      n2ft3d = 2*nfft3d
      call D3dB_nx(1,np1)
      call D3dB_ny(1,np2)
      call D3dB_nz(1,np3)

      nph1 = np1/2
      nph2 = np2/2
      nph3 = np3/2


      call dcopy(n2ft3d,0.0d0,0,r,1)

*     **** grid points in coordination space ****
      do k3 = -nph3+1, nph3-1
        do k2 = -nph2+1, nph2-1
          do k1 = -nph1+1, nph1-1

               i = k1 + nph1
               j = k2 + nph2
               k = k3 + nph3

               !call D3dB_ktoqp(1,k+1,q,p)
               call D3dB_ijktoindex2p(1,i+1,j+1,k+1,index,p)
               if (p .eq. taskid) then
c                 index = (q-1)*(np1+2)*np2
c    >                  + j    *(np1+2)
c    >                  + i+1

                r(index) =  1.0d0
               end if
          end do
        end do
      end do

      return
      end




      subroutine get_cube(unita,unitg,volume)

******************************************************************************
*                                                                            *
*     This routine computes primitive vectors both in coordination           *
*     space and in reciporocal space and the volume of primitive cell.       *
*                                                                            *
*     Inputs:                                                                *
*             type --- type of cube (1=SC, 2=FCC, 3=BCC, 4=linear)           *
*             unit --- lattice constants                                     *
*                                                                            *
*     Outputs:                                                               *
*             volume --- volume of primitive cell                            *
*             unita  --- primitive vectors in coordination space             *
*             unitg  --- primitive vectors in reciprocal space               *
*                                                                            *
*     Library:  DSCAL from BLAS                                              *
*                                                                            *
*     Last modification:  7/03/93  by R. Kawai                               *
*                                                                            *
******************************************************************************

      implicit none

*     ------------------
*     argument variables
*     ------------------
      double precision unita(3,3), unitg(3,3)
      double precision volume

*     ---------------
*     local variables
*     ---------------
      double precision twopi

      twopi = 8.0d0*datan(1.0d0)


*     -----------------------------------------
*     primitive vectors in the reciprocal space 
*     -----------------------------------------
      unitg(1,1) = unita(2,2)*unita(3,3) - unita(3,2)*unita(2,3)
      unitg(2,1) = unita(3,2)*unita(1,3) - unita(1,2)*unita(3,3)
      unitg(3,1) = unita(1,2)*unita(2,3) - unita(2,2)*unita(1,3)
      unitg(1,2) = unita(2,3)*unita(3,1) - unita(3,3)*unita(2,1)
      unitg(2,2) = unita(3,3)*unita(1,1) - unita(1,3)*unita(3,1)
      unitg(3,2) = unita(1,3)*unita(2,1) - unita(2,3)*unita(1,1)
      unitg(1,3) = unita(2,1)*unita(3,2) - unita(3,1)*unita(2,2)
      unitg(2,3) = unita(3,1)*unita(1,2) - unita(1,1)*unita(3,2)
      unitg(3,3) = unita(1,1)*unita(2,2) - unita(2,1)*unita(1,2)
*     ---------------------
*     volume of a unit cell
*     ---------------------
      volume = unita(1,1)*unitg(1,1)
     >       + unita(2,1)*unitg(2,1)
     >       + unita(3,1)*unitg(3,1)
      call dscal(9,twopi/volume,unitg,1)

      volume=dabs(volume)
      return
      end

*     *******************************
*     *                             *
*     *     lattice_abc_abg         *
*     *                             *
*     *******************************
*
*     This routine computes a,b,c,alpha,beta,gamma.
*
      subroutine lattice_abc_abg(a,b,c,alpha,beta,gamma)
      implicit none
      real*8 a,b,c
      real*8 alpha,beta,gamma

*     *** local variables ****
      real*8 d2,pi

*     **** external functions ****
      real*8   lattice_unita
      external lattice_unita

*     **** determine a,b,c,alpha,beta,gmma ***
      pi = 4.0d0*datan(1.0d0)
      a = dsqrt(lattice_unita(1,1)**2 
     >        + lattice_unita(2,1)**2 
     >        + lattice_unita(3,1)**2)
      b = dsqrt(lattice_unita(1,2)**2 
     >        + lattice_unita(2,2)**2 
     >        + lattice_unita(3,2)**2)
      c = dsqrt(lattice_unita(1,3)**2 
     >        + lattice_unita(2,3)**2 
     >        + lattice_unita(3,3)**2)
 
      d2 = (lattice_unita(1,2)-lattice_unita(1,3))**2 
     >   + (lattice_unita(2,2)-lattice_unita(2,3))**2 
     >   + (lattice_unita(3,2)-lattice_unita(3,3))**2
      alpha = (b*b + c*c - d2)/(2.0d0*b*c)
      alpha = dacos(alpha)*180.0d0/pi
 
      d2 = (lattice_unita(1,3)-lattice_unita(1,1))**2 
     >   + (lattice_unita(2,3)-lattice_unita(2,1))**2 
     >   + (lattice_unita(3,3)-lattice_unita(3,1))**2
      beta = (c*c + a*a - d2)/(2.0d0*c*a)
      beta = dacos(beta)*180.0d0/pi
 
      d2 = (lattice_unita(1,1)-lattice_unita(1,2))**2 
     >   + (lattice_unita(2,1)-lattice_unita(2,2))**2 
     >   + (lattice_unita(3,1)-lattice_unita(3,2))**2
      gamma = (a*a + b*b - d2)/(2.0d0*a*b)
      gamma = dacos(gamma)*180.0d0/pi

      return
      end

      subroutine argos_cafe_print_dera(lfnout,number)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer lfnout,number
c
      call argos_cafe_print_der(lfnout,number,byte_mb(i_snam),
     + dbl_mb(i_sti))
c
      return
      end
c $Id: argos_cafe_print_dera.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: integrate_kbppv3e_new.f 24639 2013-10-12 00:43:28Z bylaska $
*
      subroutine integrate_kbppv3e_new(version,rlocal,
     >                            nrho,drho,lmax,locp,nmax,
     >                            n_extra,n_expansion,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nfft3d,nprj,
     >                            G,vl,vnl,
     >                            n_prj,l_prj,m_prj,b_prj,vnlnrm,
     >                            semicore,rho_sc_r,rho_sc_k,
     >                            nray,G_ray,vl_ray,vnl_ray,
     >                            rho_sc_k_ray,tmp_ray,
     >                            filter,
     >                            ierr)
      implicit none
      integer          version
      double precision rlocal
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      integer          nmax
      integer          n_extra,n_expansion(0:lmax)
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:(lmax+n_extra))
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nfft3d,nprj
      double precision G(nfft3d,3)
      double precision vl(nfft3d)
      double precision vnl(nfft3d,nprj)
      integer          n_prj(nprj),l_prj(nprj),m_prj(nprj)
      integer          b_prj(nprj)
      double precision vnlnrm(nmax,nmax,0:lmax)

      logical semicore
      double precision rho_sc_r(nrho,2)
      double precision rho_sc_k(nfft3d,4)

      integer nray
      double precision G_ray(nray)
      double precision vl_ray(nray,2)
      double precision vnl_ray(nray,0:(lmax+n_extra),2)
      double precision rho_sc_k_ray(nray,2,2)
      double precision tmp_ray(nray)
      logical filter


      integer ierr

      integer np,taskid,MASTER
      integer np_i,np_j,taskid_i,taskid_j,countj
      parameter (MASTER=0)

*     *** local variables ****
      integer lcount
      integer k1,k2,k3,i,l,nx,pzero,zero,n,nb,n1,n2
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3,p
      double precision gx,gy,gz,a,q,d
      double precision ecut,wcut,dG,yp1
      integer indx(5,0:3)

*     **** external functions ****
      double precision dsum,simp,control_ecut,control_wcut
      double precision nwpw_splint
      external         dsum,simp,control_ecut,control_wcut
      external         nwpw_splint

*     **** set up indx(n,l) --> to wp ****
      nb = lmax+1
      do l=0,lmax
         indx(1,l) = l
         do n=2,n_expansion(l)
            indx(n,l) = nb
            nb = nb+1
         end do
      end do


      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)
      call Parallel2d_taskid_i(taskid_i)
      call Parallel2d_taskid_j(taskid_j)

      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      if (lmax.gt.3) then
        ierr=1
        return
      end if
      if ((nrho/2)*2.EQ.nrho) then
        ierr=2
        return
      end if

      P0=DSQRT(FORPI)
      P1=DSQRT(3.0d0*FORPI)
      P2=DSQRT(15.0d0*FORPI)
      P3=DSQRT(105.0d0*FORPI)

*::::::::::::::::::  Define non-local pseudopotential  ::::::::::::::::
      do l=0,lmax
        if (l.ne.locp) then
          do i=1,nrho
            vp(i,l)=vp(i,l)-vp(i,locp)
          end do
        end if
      end do

*:::::::::::::::::::::  Normarization constants  ::::::::::::::::::::::
      lcount = 0
      do l=0,lmax
        if (l.eq.locp) then
           do n2 = 1, n_expansion(l)
           do n1 = n2,n_expansion(l)
              vnlnrm(n1,n2,l) = 0.0d0
              vnlnrm(n2,n1,l) = 0.0d0
           end do
           end do
        else
           do n2 = 1, n_expansion(l)
              do i=1,nrho
                 f(i)=vp(i,l)*wp(i,indx(n2,l))**2
              end do
              a=simp(nrho,f,drho)
              vnlnrm(n2,n2,l) = a
              do n1 = n2+1,n_expansion(l)
                 do i=1,nrho
                    f(i)=vp(i,l)*wp(i,indx(n1,l))*wp(i,indx(n2,l))
                 end do
                 a=simp(nrho,f,drho)
                 vnlnrm(n1,n2,l) = a
                 vnlnrm(n2,n1,l) = a
              end do
           end do
           if (n_expansion(l).eq.1) then
              vnlnrm(1,1,l) = 1/a
           else if (n_expansion(l).eq.2) then
              d = vnlnrm(1,1,l)*vnlnrm(2,2,l)
     >          - vnlnrm(1,2,l)*vnlnrm(2,1,l)
              q = vnlnrm(1,1,l)
              vnlnrm(1,1,l) = vnlnrm(2,2,l)/d
              vnlnrm(2,2,l) = q/d
              vnlnrm(1,2,l) = -vnlnrm(1,2,l)/d
              vnlnrm(2,1,l) = -vnlnrm(2,1,l)/d
           else
              call nwpw_matrix_invert(n_expansion(l),vnlnrm(1,1,l),nmax)
           end if
        end if
      end do


*     ************* compute ray fourier transforms *********************
      call integrate_kbppv3e_ray(version,rlocal,
     >                            nrho,drho,lmax,locp,nmax,
     >                            n_extra,n_expansion,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nray,
     >                            G_ray,vl_ray,vnl_ray,
     >                            semicore,rho_sc_r,rho_sc_k_ray,
     >                            ierr)

*     **** filter the rays ****
      if (filter) then
         ecut = control_ecut()
         wcut = control_wcut()
         call kbpp_filter_ray(nray,G_ray,ecut,vl_ray)
         do l=0,lmax
            if (l.ne.locp) then
              do n=1,n_expansion(l)
                 call kbpp_filter_ray(nray,G_ray,wcut,
     >                                vnl_ray(1,indx(n,l),1))
              end do
            end if
         end do
         if (semicore) then
           call kbpp_filter_ray(nray,G_ray,ecut,rho_sc_k_ray(1,1,1))
           call kbpp_filter_ray(nray,G_ray,ecut,rho_sc_k_ray(1,2,1))
         end if
      end if

*     **** setup cubic bsplines ****
      dG = G_ray(3)-G_ray(2)
      !yp1 = (vl_ray(3,1)-vl_ray(2,1))/dG
      !**** five point formula ***
      yp1 = ( -50.0d0*vl_ray(2,1)
     >       + 96.0d0*vl_ray(3,1)
     >       - 72.0d0*vl_ray(4,1)
     >       + 32.0d0*vl_ray(5,1)
     >       -  6.0d0*vl_ray(6,1))/(24.0d0*dG)
      call nwpw_spline(G_ray(2),vl_ray(2,1),nray-1,yp1,0.0d0,
     >                          vl_ray(2,2),tmp_ray)
      do l=0,lmax
         if (l.ne.locp) then
            do n=1,n_expansion(l)
               call nwpw_spline(G_ray,
     >                          vnl_ray(1,indx(n,l),1),
     >                          nray,0.0d0,0.0d0,
     >                          vnl_ray(1,indx(n,l),2),tmp_ray)
            end do
         end if
      end do
      if (semicore) then
         call nwpw_spline(G_ray,rho_sc_k_ray(1,1,1),nray,0.0d0,0.0d0,
     >                          rho_sc_k_ray(1,1,2),tmp_ray)
         call nwpw_spline(G_ray,rho_sc_k_ray(1,2,1),nray,0.0d0,0.0d0,
     >                          rho_sc_k_ray(1,2,2),tmp_ray)
      end if
*     ======================  Fourier transformation  ======================
      call dcopy(nfft3d,0.0d0,0,vl,1)
      call dcopy(nprj*nfft3d,0.0d0,0,vnl,1)
      call dcopy(4*nfft3d,0.0d0,0,rho_sc_k,1)

*     ***** find the G==0 point in the lattice *****
      call D3dB_ijktoindexp(1,1,1,1,zero,pzero)
      
      countj = -1
      DO 700 k1=1,nfft3d

        countj = mod(countj+1,np_j)
        if (countj.ne.taskid_j) go to 700
        if ((pzero.eq.taskid_i).and.(k1.eq.zero)) go to 700

        Q=DSQRT(G(k1,1)**2
     >         +G(k1,2)**2
     >         +G(k1,3)**2)
        nx = (Q/dG) + 1.0d0

        
        GX=G(k1,1)/Q
        GY=G(k1,2)/Q
        GZ=G(k1,3)/Q

        lcount = nprj+1
        GO TO (500,400,300,200), LMAX+1


*       ::::::::::::::::::::::::::::::  f-wave  ::::::::::::::::::::::::::::::
  200   CONTINUE
        if (locp.ne.3) then
          do n=1,n_expansion(3)
            D = nwpw_splint(G_ray,vnl_ray(1,indx(n,3),1),
     >                            vnl_ray(1,indx(n,3),2),nray,nx,Q)

             lcount = lcount-1
             vnl(k1,lcount)=D*GY*(3.0d0*(1.0d0-GZ*GZ)-4.0d0*GY*GY)
     >                            /dsqrt(24.0d0)
             lcount = lcount-1
             vnl(k1,lcount)=D*GX*GY*GZ
             lcount = lcount-1
             vnl(k1,lcount)=D*GY*(5.0d0*GZ*GZ-1.0d0)
     >                            /dsqrt(40.0d0)
             lcount = lcount-1
             vnl(k1,lcount)=D*GZ*(5.0d0*GZ*GZ-3.0d0)
     >                            /dsqrt(60.0d0)
             lcount = lcount-1
             vnl(k1,lcount)=D*GX*(5.0d0*GZ*GZ-1.0d0)
     >                            /dsqrt(40.0d0)
             lcount = lcount-1
             vnl(k1,lcount)=D*GZ*(GX*GX - GY*GY)
     >                            /2.0d0
             lcount = lcount-1
             vnl(k1,lcount)=D*GX*(4.0d0*GX*GX-3.0d0*(1.0d0-GZ*GZ))
     >                            /dsqrt(24.0d0)
          end do
        end if
*       ::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
  300   CONTINUE
        if (locp.ne.2) then
          do n=1,n_expansion(2)
             D = nwpw_splint(G_ray,vnl_ray(1,indx(n,2),1),
     >                             vnl_ray(1,indx(n,2),2),nray,nx,Q)
             lcount = lcount-1
             vnl(k1,lcount)=D*GX*GY
             lcount = lcount-1
             vnl(k1,lcount)=D*GY*GZ
             lcount = lcount-1
             vnl(k1,lcount)=D*(3.0d0*GZ*GZ-1.0d0)
     >                             /(2.0d0*dsqrt(3.0d0))
             lcount = lcount-1
             vnl(k1,lcount)=D*GZ*GX
             lcount = lcount-1
             vnl(k1,lcount)=D*(GX*GX-GY*GY)/(2.0d0)
          end do
        end if
*       ::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
  400   CONTINUE
        if (locp.ne.1) then
          do n=1,n_expansion(1)
             P = nwpw_splint(G_ray,vnl_ray(1,indx(n,1),1),
     >                             vnl_ray(1,indx(n,1),2),nray,nx,Q)
             lcount = lcount-1
             vnl(k1,lcount)=P*GY
             lcount = lcount-1
             vnl(k1,lcount)=P*GZ
             lcount = lcount-1
             vnl(k1,lcount)=P*GX
          end do
        end if
*       ::::::::::::::::::::::::::::::  s-wave  :::::::::::::::::::::::::::::::
  500   CONTINUE
        if (locp.ne.0) then
          do n=1,n_expansion(0)
             P = nwpw_splint(G_ray,vnl_ray(1,indx(n,0),1),
     >                             vnl_ray(1,indx(n,0),2),nray,nx,Q)
             lcount = lcount-1
             vnl(k1,lcount)=P
          end do
        end if
*       ::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
  600   CONTINUE
        P = nwpw_splint(G_ray(2),vl_ray(2,1),vl_ray(2,2),nray-1,nx-1,Q)
        vl(k1)=P
       
*       ::::::::::::::::::::: semicore density :::::::::::::::::::::::::::::::
        if (semicore) then
           P = nwpw_splint(G_ray,rho_sc_k_ray(1,1,1),
     >                           rho_sc_k_ray(1,1,2),nray,nx,Q)
           rho_sc_k(k1,1) = P

           P = nwpw_splint(G_ray,rho_sc_k_ray(1,2,1),
     >                           rho_sc_k_ray(1,2,2),nray,nx,Q)
           rho_sc_k(k1,2)=P*GX
           rho_sc_k(k1,3)=P*GY
           rho_sc_k(k1,4)=P*GZ

        end if
    
  700 CONTINUE
      call D1dB_Vector_SumAll(4*nfft3d,rho_sc_k)
      call D1dB_Vector_SumAll(nfft3d,vl)
      call D1dB_Vector_Sumall(nprj*nfft3d,vnl)



*     :::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      
      if (pzero.eq.taskid_i) then

*        **** local potential ****
         vl(zero)=vl_ray(1,1)

*        **** semicore density ****
         if (semicore) then
            rho_sc_k(zero,1) = rho_sc_k_ray(1,1,1)
            rho_sc_k(zero,2) = 0.0d0
            rho_sc_k(zero,3) = 0.0d0
            rho_sc_k(zero,4) = 0.0d0
         end if

         do l=1,nprj
           vnl(zero,l)=0.0d0
         end do
*        *** only j0 is non-zero at zero ****
         if (locp.ne.0) then
            do n=1,n_expansion(0)
               vnl(zero,n_expansion(0)-n+1)=vnl_ray(1,indx(n,0),1)
            end do
         end if
      end if


*     ********************************    
*     **** define n_prj and l_prj ****
*     ********************************
      lcount = nprj+1
      GO TO (950,940,930,920), lmax+1


        !::::::  f-wave  :::::::
  920   CONTINUE
        if (locp.ne.3) then
          do n=1,n_expansion(3)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = -3
             b_prj(lcount) = indx(n,3)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = -2
             b_prj(lcount) = indx(n,3)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = -1
             b_prj(lcount) = indx(n,3)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 0
             b_prj(lcount) = indx(n,3)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 1
             b_prj(lcount) = indx(n,3)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 2
             b_prj(lcount) = indx(n,3)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 3
             m_prj(lcount) = 3
             b_prj(lcount) = indx(n,3)+1
          end do
        end if


        !::::  d-wave  ::::
  930   CONTINUE
        if (locp.ne.2) then
          do n=1,n_expansion(2)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = -2
             b_prj(lcount) = indx(n,2)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = -1
             b_prj(lcount) = indx(n,2)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = 0
             b_prj(lcount) = indx(n,2)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = 1
             b_prj(lcount) = indx(n,2)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 2
             m_prj(lcount) = 2
             b_prj(lcount) = indx(n,2)+1
          end do
        end if


        !::::  p-wave  ::::
  940   CONTINUE
        if (locp.ne.1) then
          do n=1,n_expansion(1)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 1
             m_prj(lcount) = -1
             b_prj(lcount) = indx(n,1)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 1
             m_prj(lcount) = 0
             b_prj(lcount) = indx(n,1)+1

             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 1
             m_prj(lcount) = 1
             b_prj(lcount) = indx(n,1)+1
          end do
        end if

        !::::  s-wave  ::::
  950   CONTINUE
        if (locp.ne.0) then
          do n=1,n_expansion(0)
             lcount = lcount-1
             n_prj(lcount) = n
             l_prj(lcount) = 0
             m_prj(lcount) = 0
             b_prj(lcount) = indx(n,0)+1
          end do
        end if

      IERR=0
      RETURN
      END

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c vector boxes lack arithmetic precision 
#ifdef CRAY_YMP
# define THRESH 1d-10
#elif defined(FUJITSU)
# define THRESH 1d-12
# define THRESHF 1e-5
#else
# define THRESH 1d-13
# define THRESHF 1e-5
#endif
#define MISMATCH(x,y) abs(x-y)/max(1d0,abs(x)).gt.THRESH
#define MISMATCHF(x,y) abs(x-y)/max(1.0,abs(x)).gt.THRESHF

#define USE_FAST_MERGE 0

      program main
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer heap, stack, fudge, ma_heap, me
      integer nmax, DIM, nwidth, MAXPROC, nloop
      parameter (nmax = 1025, DIM = 2, MAXPROC = 2000)
      parameter (nloop = 50)
      integer ndim, nprocs, tprocs, pdims(7), type, dcnt, maxval
      integer g_a, g_b, g_c, g_aa, g_bb, g_cc, iproc
      integer inode, tnodes, p_m, ix, iy, xinc, yinc
      integer i, j, k, l, ii, jj, dims(7), mdim, ndims(7)
      integer lo(7), hi(7), ld(7)
      integer lo2(7), hi2(7)
      integer lo3(7), hi3(7)
      integer lo4(7), hi4(7)
      integer lo5(7), hi5(7)
      integer chunk(7), imax, jmax, iloop, afail, bfail, cfail
      double precision a(nmax, nmax), b(nmax,nmax), c(nmax,nmax)
      double precision ta(nmax, nmax), tb(nmax,nmax),tc(nmax,nmax)
      double precision tat(nmax, nmax)
      double precision start,start1,t1,t2,t3,t4,t5,t6,t7
      double precision alpha, beta
#if USE_FAST_MERGE
      integer mblock,iblock
#endif
      logical status, ltest
      parameter (heap=400*400*4, fudge=100, stack=400*400*4)
c
c***  Intitialize a message passing library
c
#include "mp3.fh"
      mdim = nmax
c
c***  Initialize GA
c
c     There are 2 choices: ga_initialize or ga_initialize_ltd.
c     In the first case, there is no explicit limit on memory usage.
c     In the second, user can set limit (per processor) in bytes.
c
      call ga_initialize()
      me = ga_nodeid()
c     we can also use GA_set_memory_limit BEFORE first ga_create call
c
      ma_heap = heap + fudge 
c      call GA_set_memory_limit(util_mdtob(ma_heap))
c
      if(ga_nodeid().eq.0)then
         print *,' GA initialized '
         call ffflush(6)
      endif
c
c***  Initialize the MA package
c     MA must be initialized before any global array is allocated
c
      status = ma_init(MT_DBL, stack, ma_heap)
      if (.not. status) call ga_error('ma_init failed',-1) 
c
      if(me.eq.0)then
        print *, 'using ', ga_nnodes(), ' process(es)'
        call ffflush(6)
      endif
#if USE_FAST_MERGE
      if(me.eq.0)then
        print *,'*'
        print *,'* Using fast merge algorithm'
        print *,'*'
      endif
#endif
c
c   Test matrix multiply for mirrored arrays
c
      ndim = 2
c
c   processor distribution on node
c
      inode = ga_cluster_nodeid()
      nprocs = ga_cluster_nprocs(inode)
      tnodes = ga_cluster_nnodes()
      tprocs = ga_nnodes()
      iproc = mod(me,nprocs)
      call factor(tnodes,ndim,ndims)
      call factor(nprocs,ndim,pdims)
c
      if (me.eq.0) then
        write(6,*) '*'
        write(6,*) '*  Number of processors: ',tprocs
        write(6,*) '*  Number of processors/node : ',nprocs
        write(6,*) '*  Matrix dimension : ',mdim
        write(6,*) '*'
      endif
c
c   create global arrays
c
      do i = 1, ndim
        chunk(i) = 0
        dims(i) = mdim
        lo(i) = 1
        hi(i) = mdim
        ld(i) = nmax
      end do
      type = MT_DBL
      p_m = ga_pgroup_get_mirror()
      status = nga_create(type, ndim, dims,"aa", chunk, g_aa)
      if (status.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Global array AA creation was successful'
        write(6,*) '*'
      elseif (.not.status) then
        write(6,*) 'Global array creation failure on ',me
      endif
      status = nga_create(type, ndim, dims,"bb", chunk, g_bb)
      if (status.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Global array BB creation was successful'
        write(6,*) '*'
      elseif (.not.status) then
        write(6,*) 'Global array creation failure on ',me
      endif
      status = nga_create(type, ndim, dims,"cc", chunk, g_cc)
      if (status.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Global array CC creation was successful'
        write(6,*) '*'
      elseif (.not.status) then
        write(6,*) 'Global array creation failure on ',me
      endif
#define MIRROR 1
#if MIRROR
      status = nga_create_config(type, ndim, dims,"a", chunk, p_m, g_a)
      if (status.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Global array A creation was successful'
        write(6,*) '*'
      elseif (.not.status) then
        write(6,*) 'Global array creation failure on ',me
      endif
      status = nga_create_config(type, ndim, dims,"b", chunk, p_m, g_b)
      if (status.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Global array B creation was successful'
        write(6,*) '*'
      elseif (.not.status) then
        write(6,*) 'Global array creation failure on ',me
      endif
      status = nga_create_config(type, ndim, dims,"c", chunk, p_m, g_c)
      if (status.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Global array C creation was successful'
        write(6,*) '*'
      elseif (.not.status) then
        write(6,*) 'Global array creation failure on ',me
      endif
#endif
c
c      initialize a and b matrices
c
      k = 0
      l = 7
      do j = 1, mdim
        do i = 1, mdim
          k =  k+1
          k = mod(k,29)
          a(i,j) = dble(k)
          l = l + 1
          l = mod(l,37)
          b(i,j) = dble(l)
        end do
      end do
c
c      initialize global arrays
c
#if MIRROR
      if (iproc.eq.0) then
        call nga_put(g_a,lo,hi,a,ld)
        call nga_put(g_b,lo,hi,b,ld)
      endif
      call ga_zero(g_c)
#endif
      if (me.eq.0) then
        call nga_put(g_aa,lo,hi,a,ld)
        call nga_put(g_bb,lo,hi,b,ld)
      endif
      call ga_zero(g_cc)
      if (me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Initialized global arrays with data'
        write(6,*) '*'
      endif
      call ga_sync()
c
c      work out which chunk of matrix c this node is responsible
c      for
c
      t1 = 0.0d00
      t2 = 0.0d00
      t3 = 0.0d00
      t4 = 0.0d00
      t5 = 0.0d00
      t6 = 0.0d00
      t7 = 0.0d00
      do iloop = 1, nloop
        call ga_zero(g_cc)
#if MIRROR
        call ga_zero(g_c)
        start = util_timer()
        start1 = util_timer()
#if !USE_FAST_MERGE
        ix = mod(inode,ndims(1))
        iy = (inode - ix)/ndims(1)
        xinc = dims(1)/ndims(1)
        yinc = dims(2)/ndims(2)
        lo2(1) = ix*xinc+1
        lo2(2) = iy*yinc+1
        if (ix.ne.ndims(1)-1) then
          hi2(1) = (ix+1)*xinc
        else
          hi2(1) = dims(1)
        endif
        if (iy.ne.ndims(2)-1) then
          hi2(2) = (iy+1)*yinc
        else
          hi2(2) = dims(2)
        endif
#else
        mblock = ga_num_mirrored_seg(g_c)
        do iblock = 1, mblock
        call ga_get_mirrored_block(g_c,iblock,lo2,hi2)
#endif
c
c      work out which chunk of matrix c this processor is responsible
c      for
c
        ix = mod(iproc,pdims(1))
        iy = (iproc - ix)/(hi2(1)-lo2(1)+1)
        xinc = (hi2(1)-lo2(1)+1)/pdims(1)
        yinc = (hi2(2)-lo2(2)+1)/pdims(2)
        lo3(1) = ix*xinc+lo2(1)
        lo3(2) = iy*yinc+lo2(2)
        if (ix.ne.pdims(1)-1) then
          hi3(1) = (ix+1)*xinc+lo2(1)-1
        else
          hi3(1) = hi2(1)
        endif
        if (iy.ne.pdims(2)-1) then
          hi3(2) = (iy+1)*yinc+lo2(2)-1
        else
          hi3(2) = hi2(2)
        endif
        t3 = t3 + util_timer() - start1
c
        start1 = util_timer()
#define DGEMM2 1
#if (DGEMM2 && !USE_FAST_MERGE)
        lo4(1) = lo2(1)
        hi4(1) = hi2(1)
        lo4(2) = 1
        hi4(2) = dims(2)
        lo5(1) = 1
        hi5(1) = dims(1)
        lo5(2) = lo2(2)
        hi5(2) = hi2(2)
c
c    perform matrix patch multiplies
c
        alpha = 1.0
        beta = 0.0
        start1 = util_timer()
        call ga_matmul_patch('n','n',alpha,beta,
     +                       g_a,lo4(1),hi4(1),lo4(2),hi4(2),
     +                       g_b,lo5(1),hi5(1),lo5(2),hi5(2),
     +                       g_c,lo2(1),hi2(1),lo2(2),hi2(2))

        t5 = t5 + util_timer() - start1
#else
        lo4(1) = lo3(1)
        hi4(1) = hi3(1)
        lo4(2) = 1
        hi4(2) = dims(2)
        call nga_get(g_a,lo4,hi4,ta,ld)
        lo4(1) = 1
        hi4(1) = dims(1)
        lo4(2) = lo3(2)
        hi4(2) = hi3(2)
        call nga_get(g_b,lo4,hi4,tb,ld)
        t4 = t4 + util_timer() - start1
        start1 = util_timer()
        imax = hi3(1) - lo3(1) + 1
        do i = 1, imax
          do j = 1, mdim
            tat(j,i) = ta(i,j)
          end do
        end do
        imax = hi3(1) - lo3(1) + 1
        jmax = hi3(2) - lo3(2) + 1
        do j = 1, jmax
          do i = 1, imax
            tc(i,j) = 0.0d00
            do k = 1, mdim
              tc(i,j) = tc(i,j) + tat(k,i)*tb(k,j)
            end do
          end do
        end do
        t5 = t5 + util_timer() - start1
        start1 = util_timer()
        call nga_put(g_c,lo3,hi3,tc,ld)
        t6 = t6 + util_timer() - start1
#endif
#if USE_FAST_MERGE
        end do
#endif
        call ga_mask_sync(.true.,.false.)
        start1 = util_timer()
#if USE_FAST_MERGE
        call ga_fast_merge_mirrored(g_c) 
#else
        call ga_merge_mirrored(g_c) 
#endif
        t7 = t7 + util_timer() - start1
        t1 = t1 + util_timer() - start
#else
        do i = 1, mdim
          do j = 1, mdim
            tat(j,i) = a(i,j)
          end do
        end do
        do i = 1, mdim
          do j = 1, mdim
            c(i,j) = 0.0d00
            do k = 1, mdim
              c(i,j) = c(i,j) + tat(k,i)*b(k,j)
            end do
          end do
        end do
#endif
c
c   do a conventional ga matrix multiply
c
        alpha = 1.0
        beta = 0.0
        call ga_sync()
        start = util_timer()
#define DGEMM 1
#if DGEMM
        call ga_dgemm('n','n',mdim,mdim,mdim,alpha,g_aa,g_bb,beta,g_cc)
#else
        do i = 1, mdim
          do j = 1, mdim
            tat(j,i) = a(i,j)
          end do
        end do
        do i = 1, mdim
          do j = 1, mdim
            tc(i,j) = 0.0d00
            do k = 1, mdim
              tc(i,j) = tc(i,j) + tat(k,i)*b(k,j)
            end do
          end do
        end do
#endif
        t2 = t2 + util_timer() - start
        call ga_sync()
c
c   check to see if matrix operations agree
c
#if MIRROR
        call nga_get(g_c,lo,hi,c,ld)
#endif
#if DGEMM
        call nga_get(g_cc,lo,hi,tc,ld)
#endif
        call ga_sync()
        ltest = .true.
        afail = 0
        bfail = 0
        cfail = 0
        do i = 1, mdim
          do j = 1, mdim
            if (c(i,j).ne.tc(i,j)) then
              cfail = cfail+1
              ltest = .false.
              if (c(i,j).eq.0.0d00) then
                afail = afail + 1
              endif
              if (tc(i,j).eq.0.0d00) then
                bfail = bfail + 1
              endif
            end if
          end do
        end do
        if (ltest) then
          if (me.eq.0) write(6,*) 'Matrices agree for iteration ',iloop
        else
          if (me.eq.0) then
            write(6,*) 'Matrices disagree for iteration',iloop
            write(6,*) '  Total number of disagreements',cfail
            write(6,*) '  Total number of zeros in mirrored array',afail
            write(6,*) '  Total number of zeros in dgemm array',bfail
          endif
        endif
      end do
c
      call ga_dgop(MT_DBL,t1,1,'+')
      call ga_dgop(MT_DBL,t2,1,'+')
      call ga_dgop(MT_DBL,t3,1,'+')
      call ga_dgop(MT_DBL,t4,1,'+')
      call ga_dgop(MT_DBL,t5,1,'+')
      call ga_dgop(MT_DBL,t6,1,'+')
      call ga_dgop(MT_DBL,t7,1,'+')
      t1 = t1/dble(nloop*tprocs)
      t2 = t2/dble(nloop*tprocs)
      t3 = t3/dble(nloop*tprocs)
      t4 = t4/dble(nloop*tprocs)
      t5 = t5/dble(nloop*tprocs)
      t6 = t6/dble(nloop*tprocs)
      t7 = t7/dble(nloop*tprocs)
      if (me.eq.0) then
        write(6,*) 'Elapsed time for Mirrored matrix multiply ',t1
        write(6,*) '  Elapsed time for initial setup ',t3
        write(6,*) '  Elapsed time for copy to buffers ',t4
        write(6,*) '  Elapsed time for partial multiply ',t5
        write(6,*) '  Elapsed time for copy from buffer',t6
        write(6,*) '  Elapsed time for merge',t7
        write(6,*) 'Elapsed time for Conventional matrix multiply ',t2
      endif
c
c***  Tidy up the GA package
c
      if(ga_nodeid().eq.0)print *,' All tests successful'
c      
      call ga_terminate()
c
c***  Tidy up after message-passing library
c
      call MP_FINALIZE()

c
      stop
      end
c
      subroutine factor(p,ndim,dims)
      implicit none
      integer i,j,p,ndim,dims(7),imin,mdim
      integer ip,ifac,pmax,prime(1000)
      integer fac(1000)
c
      i = 1
      ip = p
      do i = 1, ndim
        dims(i) = 1
      end do
c
c    factor p completely
c    first, find all prime numbers less than or equal to p
c
      pmax = 0
      do i = 2, p
        do j = 1, pmax
          if (mod(i,prime(j)).eq.0) go to 100
        end do
        pmax = pmax + 1
        prime(pmax) = i
  100   continue
      end do
c
c    find all prime factors of p
c
      ifac = 0
      do i = 1, pmax
  200   if (mod(ip,prime(i)).eq.0) then
          ifac = ifac + 1
          fac(ifac) = prime(i)
          ip = ip/prime(i)
          go to 200
        endif
      end do
c
c    determine dimensions of processor grid
c
      do i = ifac, 1, -1
c
c    find dimension with minimum value
c
        imin = dims(1)
        mdim = 1
        do j = 2, ndim
          if (dims(j).lt.imin) then
            imin = dims(j)
            mdim = j
          endif
        end do
        dims(mdim) = dims(mdim)*fac(i)
      end do
c
      return
      end

C $Id: ecp_gaussq.f 25483 2014-04-11 01:05:16Z edo $
      SUBROUTINE ECP_GAUSSQ(KIND, N, ALPHA, BETA, KPTS, ENDPTS, B, T, W)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION MUZERO
C
C           THIS SET OF ROUTINES COMPUTES THE NODES X(I) AND WEIGHTS
C        C(I) FOR GAUSSIAN-TYPE QUADRATURE RULES WITH PRE-ASSIGNED
C        NODES.  THESE ARE USED WHEN ONE WISHES TO APPROXIMATE
C
C                 INTEGRAL (FROM A TO B)  F(X) W(X) DX
C
C                              N
C        BY                   SUM C  F(X )
C                             I=1  I    I
C
C        HERE W(X) IS ONE OF SIX POSSIBLE NON-NEGATIVE WEIGHT
C        FUNCTIONS (LISTED BELOW), AND F(X) IS THE
C        FUNCTION TO BE INTEGRATED.  GAUSSIAN QUADRATURE IS PARTICULARLY
C        USEFUL ON INFINITE INTERVALS (WITH APPROPRIATE WEIGHT
C        FUNCTIONS), SINCE THEN OTHER TECHNIQUES OFTEN FAIL.
C
C           ASSOCIATED WITH EACH WEIGHT FUNCTION W(X) IS A SET OF
C        ORTHOGONAL POLYNOMIALS.  THE NODES X(I) ARE JUST THE ZEROES
C        OF THE PROPER N-TH DEGREE POLYNOMIAL.
C
C     INPUT PARAMETERS
C
C        KIND     AN INTEGER BETWEEN 1 AND 6 GIVING THE TYPE OF
C                 QUADRATURE RULE
C
C        KIND = 1=  LEGENDRE QUADRATURE, W(X) = 1 ON (-1, 1)
C        KIND = 2=  CHEBYSHEV QUADRATURE OF THE FIRST KIND
C                   W(X) = 1/SQRT(1 - X*X) ON (-1, +1)
C        KIND = 3=  CHEBYSHEV QUADRATURE OF THE SECOND KIND
C                   W(X) = SQRT(1 - X*X) ON (-1, 1)
C        KIND = 4=  HERMITE QUADRATURE, W(X) = EXP(-X*X) ON
C                   (-INFINITY, +INFINITY)
C        KIND = 5=  JACOBI QUADRATURE, W(X) = (1-X)**ALPHA * (1+X)**
C                   BETA ON (-1, 1), ALPHA, BETA .GT. -1.
C                   NOTE= KIND=2 AND 3 ARE A SPECIAL CASE OF THIS.
C        KIND = 6=  GENERALIZED LAGUERRE QUADRATURE, W(X) = EXP(-X)*
C                   X**ALPHA ON (0, +INFINITY), ALPHA .GT. -1
C
C        N        THE NUMBER OF POINTS USED FOR THE QUADRATURE RULE
C        ALPHA    DOUBLE PRECISION PARAMETER USED ONLY FOR GAUSS-JACOBI
C                 AND GAUSS-LAGUERRE QUADRATURE (OTHERWISE USE 0.).
C        BETA     DOUBLE PRECISION PARAMETER USED ONLY FOR GAUSS-JACOBI
C                 QUADRATURE (OTHERWISE USE 0.).
C        KPTS     (INTEGER) NORMALLY 0, UNLESS THE LEFT OR RIGHT END-
C                 POINT (OR BOTH) OF THE INTERVAL IS REQUIRED TO BE A
C                 NODE (THIS IS CALLED GAUSS-RADAU OR GAUSS-LOBATTO
C                 QUADRATURE).  THEN KPTS IS THE NUMBER OF FIXED
C                 ENDPOINTS (1 OR 2).
C        ENDPTS   DOUBLE PRECISION ARRAY OF LENGTH 2.  CONTAINS THE
C                 VALUES OF ANY FIXED ENDPOINTS, IF KPTS = 1 OR 2.
C        B        DOUBLE PRECISION SCRATCH ARRAY OF LENGTH N
C
C     OUTPUT PARAMETERS (BOTH ARRAYS OF LENGTH N)
C
C        T        WILL CONTAIN THE DESIRED NODES X(1),,,X(N)
C        W        WILL CONTAIN THE DESIRED WEIGHTS C(1),,,C(N)
C
C     SUBROUTINES REQUIRED
C
C        GBSLVE, CLASS, AND GBTQL2 ARE PROVIDED. UNDERFLOW MAY SOMETIMES
C        OCCUR, BUT IT IS HARMLESS IF THE UNDERFLOW INTERRUPTS ARE
C        TURNED OFF AS THEY ARE ON THIS MACHINE.
C
C     ACCURACY
C
C        THE ROUTINE WAS TESTED UP TO N = 512 FOR LEGENDRE QUADRATURE,
C        UP TO N = 136 FOR HERMITE, UP TO N = 68 FOR LAGUERRE, AND UP
C        TO N = 10 OR 20 IN OTHER CASES.  IN ALL BUT TWO INSTANCES,
C        COMPARISON WITH TABLES IN REF. 3 SHOWED 12 OR MORE SIGNIFICANT
C        DIGITS OF ACCURACY.  THE TWO EXCEPTIONS WERE THE WEIGHTS FOR
C        HERMITE AND LAGUERRE QUADRATURE, WHERE UNDERFLOW CAUSED SOME
C        VERY SMALL WEIGHTS TO BE SET TO ZERO.  THIS IS, OF COURSE,
C        COMPLETELY HARMLESS.
C
C     METHOD
C
C           THE COEFFICIENTS OF THE THREE-TERM RECURRENCE RELATION
C        FOR THE CORRESPONDING SET OF ORTHOGONAL POLYNOMIALS ARE
C        USED TO FORM A SYMMETRIC TRIDIAGONAL MATRIX, WHOSE
C        EIGENVALUES (DETERMINED BY THE IMPLICIT QL-METHOD WITH
C        SHIFTS) ARE JUST THE DESIRED NODES.  THE FIRST COMPONENTS OF
C        THE ORTHONORMALIZED EIGENVECTORS, WHEN PROPERLY SCALED,
C        YIELD THE WEIGHTS.  THIS TECHNIQUE IS MUCH FASTER THAN USING A
C        ROOT-FINDER TO LOCATE THE ZEROES OF THE ORTHOGONAL POLYNOMIAL.
C        FOR FURTHER DETAILS, SEE REF. 1.  REF. 2 CONTAINS DETAILS OF
C        GAUSS-RADAU AND GAUSS-LOBATTO QUADRATURE ONLY.
C
C     REFERENCES
C
C        1.  GOLUB, G. H., AND WELSCH, J. H.,  CALCULATION OF GAUSSIAN
C            QUADRATURE RULES,  MATHEMATICS OF COMPUTATION 23 (APRIL,
C            1969), PP. 221-230.
C        2.  GOLUB, G. H.,  SOME MODIFIED MATRIX EIGENVALUE PROBLEMS,
C            SIAM REVIEW 15 (APRIL, 1973), PP. 318-334 (SECTION 7).
C        3.  STROUD AND SECREST, GAUSSIAN QUADRATURE FORMULAS, PRENTICE-
C            HALL, ENGLEWOOD CLIFFS, N.J., 1966.
C
C     ..................................................................
C
      DIMENSION  B(N),T(N),W(N),ENDPTS(2)
C
      CALL ECP_CLASS (KIND, N, ALPHA, BETA, B, T, MUZERO)
C
C           THE MATRIX OF COEFFICIENTS IS ASSUMED TO BE SYMMETRIC.
C           THE ARRAY T CONTAINS THE DIAGONAL ELEMENTS, THE ARRAY
C           B THE OFF-DIAGONAL ELEMENTS.
C           MAKE APPROPRIATE CHANGES IN THE LOWER RIGHT 2 BY 2
C           SUBMATRIX.
C
      IF (KPTS.EQ.0)  GO TO 100
      IF (KPTS.EQ.2)  GO TO  50
C
C           IF KPTS=1, ONLY T(N) MUST BE CHANGED
C
      T(N) =ECP_GBSLVE(ENDPTS(1),N,T,B)*B(N-1)**2 + ENDPTS(1)
      GO TO 100
C
C           IF KPTS=2, T(N) AND B(N-1) MUST BE RECOMPUTED
C
   50 GAM =ECP_GBSLVE(ENDPTS(1),N,T,B)
      T1 = ((ENDPTS(1) - ENDPTS(2))/(ECP_GBSLVE(ENDPTS(2),N,T,B) - GAM))
      B(N-1) =  SQRT(T1)
      T(N) = ENDPTS(1) + GAM*T1
C
C           NOTE THAT THE INDICES OF THE ELEMENTS OF B RUN FROM 1 TO N-1
C           AND THUS THE VALUE OF B(N) IS ARBITRARY.
C           NOW COMPUTE THE EIGENVALUES OF THE SYMMETRIC TRIDIAGONAL
C           MATRIX, WHICH HAS BEEN MODIFIED AS NECESSARY.
C           THE METHOD USED IS A QL-TYPE METHOD WITH ORIGIN SHIFTING
C
  100 W(1) = 1.0d00
      DO 105 I = 2, N
  105    W(I) = 0.0d00
C
      CALL ECP_GBTQL2 (N, T, B, W, IERR)
      DO 110 I = 1, N
  110    W(I) = MUZERO * W(I) * W(I)
C
      RETURN
      END
C
C
C
      DOUBLE PRECISION FUNCTION ECP_GBSLVE(SHIFT, N, A, B)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (ONE = 1.0d00)
C
C       THIS PROCEDURE PERFORMS ELIMINATION TO SOLVE FOR THE
C       N-TH COMPONENT OF THE SOLUTION DELTA TO THE EQUATION
C
C             (JN - SHIFT*IDENTITY) * DELTA  = EN,
C
C       WHERE EN IS THE VECTOR OF ALL ZEROES EXCEPT FOR 1 IN
C       THE N-TH POSITION.
C
C       THE MATRIX JN IS SYMMETRIC TRIDIAGONAL, WITH DIAGONAL
C       ELEMENTS A(I), OFF-DIAGONAL ELEMENTS B(I).  THIS EQUATION
C       MUST BE SOLVED TO OBTAIN THE APPROPRIATE CHANGES IN THE LOWER
C       2 BY 2 SUBMATRIX OF COEFFICIENTS FOR ORTHOGONAL POLYNOMIALS.
C
C
      DIMENSION  A(N),B(N)
C
      ALPHA = A(1) - SHIFT
      NM1 = N - 1
      DO 10 I = 2, NM1
   10    ALPHA = A(I) - SHIFT - B(I-1)**2/ALPHA
      ECP_GBSLVE = ONE/ALPHA
      RETURN
      END
C
C
C
      SUBROUTINE ECP_CLASS(KIND, N, ALPHA, BETA, B, A, MUZERO)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION  MUZERO
C
C           THIS PROCEDURE SUPPLIES THE COEFFICIENTS A(J), B(J) OF THE
C        RECURRENCE RELATION
C
C             B P (X) = (X - A ) P   (X) - B   P   (X)
C              J J            J   J-1       J-1 J-2
C
C        FOR THE VARIOUS CLASSICAL (NORMALIZED) ORTHOGONAL POLYNOMIALS,
C        AND THE ZERO-TH MOMENT
C
C             MUZERO = INTEGRAL W(X) DX
C
C        OF THE GIVEN POLYNOMIAL   WEIGHT FUNCTION W(X).  SINCE THE
C        POLYNOMIALS ARE ORTHONORMALIZED, THE TRIDIAGONAL MATRIX IS
C        GUARANTEED TO BE SYMMETRIC.
C
C           THE INPUT PARAMETER ALPHA IS USED ONLY FOR LAGUERRE AND
C        JACOBI POLYNOMIALS, AND THE PARAMETER BETA IS USED ONLY FOR
C        JACOBI POLYNOMIALS.  THE LAGUERRE AND JACOBI POLYNOMIALS
C        REQUIRE THE GAMMA FUNCTION.
C
C     ..................................................................
C
      DIMENSION  A(N),B(N)
      PARAMETER (ZERO = 0.0d00, ONE = 1.0d00, TWO = 2.0d00)
      PARAMETER (FOUR = 4.0d00, HALF = ONE/TWO)
C
      PI = FOUR*ATAN(ONE)
      NM1 = N - 1
      GO TO (10, 20, 30, 40, 50, 60), KIND
C
C              KIND = 1=  LEGENDRE POLYNOMIALS P(X)
C              ON (-1, +1), W(X) = 1.
C
   10 MUZERO = TWO
      DO 11 I = 1, NM1
         A(I) = ZERO
         ABI = I
   11    B(I) = ABI/ SQRT(4*ABI*ABI - ONE  )
      A(N) = ZERO
      RETURN
C
C              KIND = 2=  CHEBYSHEV POLYNOMIALS OF THE FIRST KIND T(X)
C              ON (-1, +1), W(X) = 1 / SQRT(1 - X*X)
C
   20 MUZERO = PI
      DO 21 I = 1, NM1
         A(I) = ZERO
   21    B(I) = HALF
      B(1) =  SQRT(HALF  )
      A(N) = ZERO
      RETURN
C
C              KIND = 3=  CHEBYSHEV POLYNOMIALS OF THE SECOND KIND U(X)
C              ON (-1, +1), W(X) = SQRT(1 - X*X)
C
   30 MUZERO = PI/TWO
      DO 31 I = 1, NM1
         A(I) = ZERO
   31    B(I) = HALF
      A(N) = ZERO
      RETURN
C
C              KIND = 4=  HERMITE POLYNOMIALS H(X) ON (-INFINITY,
C              +INFINITY), W(X) = EXP(-X**2)
C
   40 MUZERO =  SQRT(PI)
      DO 41 I = 1, NM1
         A(I) = ZERO
   41    B(I) =  SQRT(I/TWO  )
      A(N) = ZERO
      RETURN
C
C              KIND = 5=  JACOBI POLYNOMIALS P(ALPHA, BETA)(X) ON
C              (-1, +1), W(X) = (1-X)**ALPHA + (1+X)**BETA, ALPHA AND
C              BETA GREATER THAN -1
C
   50 AB = ALPHA + BETA
      ABI = TWO + AB
      MUZERO = TWO ** (AB + ONE) * ECP_DGAMMA(ALPHA + ONE) * 
     X ECP_DGAMMA(BETA + ONE) / ECP_DGAMMA(ABI)
      A(1) = (BETA - ALPHA)/ABI
      B(1) =  SQRT(FOUR*(ONE+ALPHA)*(ONE+BETA)/((ABI+ONE)*ABI*ABI))
      A2B2 = BETA*BETA - ALPHA*ALPHA
      DO 51 I = 2, NM1
         DI = I
         ABI = TWO  *DI + AB
         A(I) = A2B2/((ABI - TWO  )*ABI)
   51    B(I) =  SQRT (FOUR*DI*(DI + ALPHA)*(DI + BETA)*(DI + AB)/
     1   ((ABI*ABI - ONE)*ABI*ABI))
      ABI = TWO *N + AB
      A(N) = A2B2/((ABI - TWO  )*ABI)
      RETURN
C
C              KIND = 6=  LAGUERRE POLYNOMIALS L(ALPHA)(X) ON
C              (0, +INFINITY), W(X) = EXP(-X) * X**ALPHA, ALPHA GREATER
C              THAN -1.
C
   60 MUZERO = ECP_DGAMMA(ALPHA + ONE)
      DO 61 I = 1, NM1
         A(I) = TWO  *I - ONE   + ALPHA
   61    B(I) =  SQRT(I*(I + ALPHA))
      A(N) = TWO  *N - 1 + ALPHA
      RETURN
      END
C     ------------------------------------------------------------------
C
      SUBROUTINE ECP_GBTQL2(N, D, E, Z, IERR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION  MACHEP
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE IMTQL2,
C     NUM. MATH. 12, 377-383(1968) BY MARTIN AND WILKINSON,
C     AS MODIFIED IN NUM. MATH. 15, 450(1970) BY DUBRULLE.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 241-248(1971).
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND FIRST COMPONENTS OF THE
C     EIGENVECTORS OF A SYMMETRIC TRIDIAGONAL MATRIX BY THE IMPLICIT QL
C     METHOD, AND IS ADAPTED FROM THE EISPAK ROUTINE IMTQL2
C
C     ON INPUT=
C
C        N IS THE ORDER OF THE MATRIX;
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX;
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS FIRST N-1 POSITIONS.  E(N) IS ARBITRARY;
C
C        Z CONTAINS THE FIRST ROW OF THE IDENTITY MATRIX.
C
C      ON OUTPUT=
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT BUT
C          UNORDERED FOR INDICES 1, 2, ..., IERR-1;
C
C        E HAS BEEN DESTROYED;
C
C        Z CONTAINS THE FIRST COMPONENTS OF THE ORTHONORMAL EIGENVECTORS
C          OF THE SYMMETRIC TRIDIAGONAL MATRIX.  IF AN ERROR EXIT IS
C          MADE, Z CONTAINS THE EIGENVECTORS ASSOCIATED WITH THE STORED
C          EIGENVALUES;
C
C        IERR IS SET TO
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     ------------------------------------------------------------------
C
      INTEGER I, J, K, L, M, N, II, MML, IERR
      DIMENSION  D(N),E(N),Z(N)
      double precision dlamch
      external dlamch
      PARAMETER (ZERO = 0.0d00, ONE = 1.0d00, TWO = 2.0d00)
      PARAMETER (FOUR = 4.0d00, HALF = ONE/TWO)
C
C     ========== MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC.
C                MACHEP = 16.0D0**(-13) FOR LONG FORM ARITHMETIC
C                ON S360 ==========
c     inverse of the square root of the overflow
       machep=1d0/sqrt(dlamch('o'))
C
      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      E(N) = ZERO
      DO 240 L = 1, N
         J = 0
C     ========== LOOK FOR SMALL SUB-DIAGONAL ELEMENT ==========
  105    DO 110 M = L, N
            IF (M .EQ. N) GO TO 120
            IF ( ABS(E(M)) .LE. MACHEP * ( ABS(D(M)) +  ABS(D(M+1))))
     X         GO TO 120
  110    CONTINUE
C
  120    P = D(L)
         IF (M .EQ. L) GO TO 240
         IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     ========== FORM SHIFT ==========
         G = (D(L+1) - P) / (TWO   * E(L))
         R =  SQRT(G*G+ONE  )
         G = D(M) - P + E(L) / (G +  SIGN(R, G))
         S = ONE
         C = ONE
         P = ZERO
         MML = M - L
C     ========== FOR I=M-1 STEP -1 UNTIL L DO -- ==========
         DO 200 II = 1, MML
            I = M - II
            F = S * E(I)
            B = C * E(I)
            IF ( ABS(F) .LT.  ABS(G)) GO TO 150
            C = G / F
            R =  SQRT(C*C+ONE  )
            E(I+1) = F * R
            S = ONE   / R
            C = C * S
            GO TO 160
  150       S = F / G
            R =  SQRT(S*S+ONE  )
            E(I+1) = G * R
            C = ONE   / R
            S = S * C
  160       G = D(I+1) - P
            R = (D(I) - G) * S + TWO   * C * B
            P = S * R
            D(I+1) = G + P
            G = C * R - B
C     ========== FORM FIRST COMPONENT OF VECTOR ==========
            F = Z(I+1)
            Z(I+1) = S * Z(I) + C * F
            Z(I) = C * Z(I) - S * F
C
  200    CONTINUE
C
         D(L) = D(L) - P
         E(L) = G
         E(M) = ZERO
         GO TO 105
  240 CONTINUE
C     ========== ORDER EIGENVALUES AND EIGENVECTORS ==========
      DO 300 II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 260 J = II, N
            IF (D(J) .GE. P) GO TO 260
            K = J
            P = D(J)
  260    CONTINUE
C
         IF (K .EQ. I) GO TO 300
         D(K) = D(I)
         D(I) = P
C
         P = Z(I)
         Z(I) = Z(K)
         Z(K) = P
C
  300 CONTINUE
C
      GO TO 1001
C     ========== SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ==========
 1000 IERR = L
 1001 RETURN
C     ========== LAST CARD OF GBTQL2 ==========
      END
      double precision FUNCTION  ECP_DGAMMA(ZZ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     MODIFIED 4/4/88 BY DWS TO BE ACCURATE FOR ZZ GT 3.
C  THIS IS A PROCEDURE THAT EVALUATES GAMMA(Z) FOR
C     0 LT Z LE 3 TO 16 SIGNIFICANT FIGURES
C    IT IS BASED ON A CHEBYSHEV-TYPE POLYNOMIAL
C   APPROXIMATION GIVEN IN H. WERNER AND R. COLLINGE, MATH. COMPUT.
C    15 (1961), PP. 195-97.
C   APPROXIMATIONS TO THE GAMMA FUNCTION, ACCURATE UP TO 18 SIGNIFICANT
C   DIGITS, MAY BE FOUND IN THE PAPER QUOTED ABOVE
C
C
C
      DIMENSION  A(18)
      PREFAC=1.0D0
      Z=ZZ
   44 CONTINUE
      IF(Z.LT.3.0D0)GO TO 45
      Z=Z-1.0D0
      PREFAC=PREFAC*Z
      GO TO 44
   45 CONTINUE
C
      A(1)=1.0D0
      A(2)=.4227843350984678D0
      A(3)=.4118403304263672D0
      A(4)=.0815769192502609D0
      A(5)=.0742490106800904D0
      A(6)=-.0002669810333484D0
      A(7)=.0111540360240344D0
      A(8)=-.0028525821446197D0
      A(9)=.0021036287024598D0
      A(10)=-.0009184843690991D0
      A(11)=.0004874227944768D0
      A(12)=-.0002347204018919D0
      A(13)=.0001115339519666D0
      A(14)=-.0000478747983834D0
      A(15)=.0000175102727179D0
      A(16)=-.0000049203750904D0
      A(17)=.0000009199156407D0
      A(18)=-.0000000839940496D0
C
C
C
      IF(Z.LE.1.0D0  ) GO TO 10
      IF(Z.LE.2.0D0  ) GO TO 20
      T=Z-2.0D0
      GO TO 30
10    T=Z
      GO TO 30
20    T=Z-1.0D0
30    P=A(18)
      DO 40 K=17,1,-1
        P=T*P+A(K)
   40 CONTINUE
C
      P=P*PREFAC
      IF(Z.GT.2.0D0  ) GO TO 50
      IF(Z.GT.1.0D0  ) GO TO 60
      ECP_DGAMMA=P/(Z*(Z+1.0D0  ))
      RETURN
60    ECP_DGAMMA=P/Z
      RETURN
50    ECP_DGAMMA=P
      RETURN
      END

      SUBROUTINE dip_r(d_i0,d_o1,d_t1,d_tr1,d_tr2,d_v2,k_i0_offset,k_o1_
     &offset,k_t1_offset,k_tr1_offset,k_tr2_offset,k_v2_offset)
C     $Id: dip_r.F 19698 2010-10-29 17:03:09Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_to + = 1 * Sum ( p5 h6 ) * t ( p5 h6 )_t * i1 ( h6 p5 )_o
C         i1 ( h6 p5 )_o + = 1 * o ( h6 p5 )_o
C         i1 ( h6 p5 )_vtr + = 1 * Sum ( h4 p3 ) * tr ( p3 h4 )_tr * v ( h4 h6 p3 p5 )_v
C     i0 ( )_vtr + = 1/4 * Sum ( h3 h4 p1 p2 ) * tr ( p1 p2 h3 h4 )_tr * v ( h3 h4 p1 p2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_tr2
      INTEGER k_tr2_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER l_i1_offset
      INTEGER d_o1
      INTEGER k_o1_offset
      INTEGER size_i1
      INTEGER d_tr1
      INTEGER k_tr1_offset
      CHARACTER*255 filename
      CALL OFFSET_dip_r_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('dip_r_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL dip_r_1_1(d_o1,k_o1_offset,d_i1,k_i1_offset)
      CALL dip_r_1_2(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i1,k_i1_offse
     &t)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL dip_r_1(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('dip_r',-1,MA_ERR
     &)
      CALL dip_r_2(d_tr2,k_tr2_offset,d_v2,k_v2_offset,d_i0,k_i0_offset)
      RETURN
      END

      SUBROUTINE T2_C2(d_i0,d_t1,d_t2,d_x1,d_x2,k_i0_offset,k_t1_offset,
     &k_t2_offset,k_x1_offset,k_x2_offset,coef)
C     $Id: T2_C2.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_x + = 1 * x ( p3 p4 h1 h2 )_x
C     i0 ( p3 p4 h1 h2 )_xt + = 1 * P( 4 ) * t ( p3 h1 )_t * i1 ( p4 h2 )_x
C         i1 ( p3 h1 )_x + = 1 * x ( p3 h1 )_x
C         i1 ( p3 h1 )_t + = 1/2 * t ( p3 h1 )_t
C     i0 ( p3 p4 h1 h2 )_t + = 1 * t ( p3 p4 h1 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_x2
      INTEGER k_x2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER l_i1_offset
      INTEGER d_x1
      INTEGER k_x1_offset
      INTEGER size_i1
      CHARACTER*255 filename
      double precision coef
      CALL T2_C2_1(d_x2,k_x2_offset,d_i0,k_i0_offset,coef)
      CALL OFFSET_T2_C2_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('T2_C2_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL T2_C2_2_1(d_x1,k_x1_offset,d_i1,k_i1_offset)
      CALL T2_C2_2_2(d_t1,k_t1_offset,d_i1,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL T2_C2_2(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,k_i0_offset,
     1 coef)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('T2_C2',-1,MA_ERR
     &)
      if(model.ne.'succsd') then
        CALL T2_C2_3(d_t2,k_t2_offset,d_i0,k_i0_offset,coef)
      endif
      RETURN
      END
      SUBROUTINE T2_C2_1(d_a,k_a_offset,d_c,k_c_offset,coef)
C     $Id: T2_C2.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_x + = 1 * x ( p3 p4 h1 h2 )_x
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      double precision coef
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_x) THEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h2b,p3b_1,p4b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('T2_C2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &T2_C2_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('T2_C2_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &T2_C2_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,coef)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('T2_C2_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('T2_C2_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE T2_C2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offset,
     1 coef)
C     $Id: T2_C2.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_xt + = 1 * P( 4 ) * t ( p3 h1 )_t * i1 ( p4 h2 )_x
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      double precision coef
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER p4b_2
      INTEGER h2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO p4b = noab+1,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. ieor(irrep_x,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('T2_C2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h1b,p3b_1,h1b_1)
      CALL TCE_RESTRICTED_2(p4b,h2b,p4b_2,h2b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('T2_C2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &T2_C2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h1b-1),2,1,-1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('T2_C2_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('T2_C2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &T2_C2_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h2b_2
     & - 1 + noab * (p4b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h2b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('T2_C2_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('T2_C2_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('T2_C2_2',8,MA_ERR)
      END IF
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &T2_C2_2',9,MA_ERR)
      IF ((p3b .le. p4b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,4,2,3,1,coef)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((p3b .le. p4b) .and. (h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,4,2,1,3,-coef)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      END IF
      IF ((p4b .le. p3b) .and. (h1b .le. h2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,2,4,3,1,-coef)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p3b - noab - 1 + nvab * (p4b - noab
     & - 1)))))
      END IF
      IF ((p4b .le. p3b) .and. (h2b .le. h1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,2,4,1,3,coef)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1 + noab * (p3b - noab - 1 + nvab * (p4b - noab
     & - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('T2_C2_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('T2_C2_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE T2_C2_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: T2_C2.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p3 h1 )_x + = 1 * x ( p3 h1 )_x
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h1b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_x) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1)
      CALL TCE_RESTRICTED_2(p3b,h1b,p3b_1,h1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('T2_C2_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &T2_C2_2_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('T2_C2_2_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &T2_C2_2_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p3b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p3b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('T2_C2_2_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('T2_C2_2_1',5,MA_ERR
     &)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_T2_C2_2_1(l_a_offset,k_a_offset,size)
C     $Id: T2_C2.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p3 h1 )_x
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p3b
      INTEGER h1b
      length = 0
      DO p3b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_x) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('T2_C2_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p3b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_x) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h1b - 1 + noab * (p3b - noab - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE T2_C2_2_2(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: T2_C2.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p3 h1 )_t + = 1/2 * t ( p3 h1 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER h1b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1)
      CALL TCE_RESTRICTED_2(p3b,h1b,p3b_1,h1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('T2_C2_2_2',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &T2_C2_2_2',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h1b-1),2,1,-1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('T2_C2_2_2',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &T2_C2_2_2',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p3b-1),2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p3b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('T2_C2_2_2',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('T2_C2_2_2',5,MA_ERR
     &)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE T2_C2_3(d_a,k_a_offset,d_c,k_c_offset,coef)
C     $Id: T2_C2.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p3 p4 h1 h2 )_t + = 1 * t ( p3 p4 h1 h2 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      double precision coef
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p3b
      INTEGER p4b
      INTEGER h1b
      INTEGER h2b
      INTEGER dimc
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1
     &)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1).ne.8)) THEN
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      dimc = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb(k_ra
     &nge+h1b-1) * int_mb(k_range+h2b-1)
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h2b,p3b_1,p4b_1,h1b_1,h2b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_mb
     &(k_range+h1b-1) * int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('T2_C2_3',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &T2_C2_3',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('T2_C2_3',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &T2_C2_3',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-coef)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (p4b - noab - 1 + nvab * (p3b - noab
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('T2_C2_3',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('T2_C2_3',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE OFFSET_ccsdtq_lr_alpha_15_48_9_4_1_1(l_a_offset,k_a_off
     &set,size)
C     $Id: offset_ccsdtq_lr_alpha_15_48_9_4_1_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i5 ( h10 h11 h12 h18 p3 p5 p7 p8 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h10b
      INTEGER h11b
      INTEGER h12b
      INTEGER h18b
      INTEGER p3b
      INTEGER p5b
      INTEGER p7b
      INTEGER p8b
      length = 0
      DO h10b = 1,noab
      DO h11b = h10b,noab
      DO h12b = h11b,noab
      DO h18b = h12b,noab
      DO p3b = noab+1,noab+nvab
      DO p5b = p3b,noab+nvab
      DO p7b = p5b,noab+nvab
      DO p8b = p7b,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h12b
     &-1)+int_mb(k_spin+h18b-1) .eq. int_mb(k_spin+p3b-1)+int_mb(k_spin+
     &p5b-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_m
     &b(k_sym+h12b-1),ieor(int_mb(k_sym+h18b-1),ieor(int_mb(k_sym+p3b-1)
     &,ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+p8
     &b-1)))))))) .eq. irrep_y) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b
     &-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h18b-1)+int_mb(k_spin+p3b-
     &1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1).
     &ne.16)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lr_alpha_15_48_9_4_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h10b = 1,noab
      DO h11b = h10b,noab
      DO h12b = h11b,noab
      DO h18b = h12b,noab
      DO p3b = noab+1,noab+nvab
      DO p5b = p3b,noab+nvab
      DO p7b = p5b,noab+nvab
      DO p8b = p7b,noab+nvab
      IF (int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h12b
     &-1)+int_mb(k_spin+h18b-1) .eq. int_mb(k_spin+p3b-1)+int_mb(k_spin+
     &p5b-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1)) THEN
      IF (ieor(int_mb(k_sym+h10b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_m
     &b(k_sym+h12b-1),ieor(int_mb(k_sym+h18b-1),ieor(int_mb(k_sym+p3b-1)
     &,ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+p8
     &b-1)))))))) .eq. irrep_y) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h10b-1)+int_mb(k_spin+h11b
     &-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h18b-1)+int_mb(k_spin+p3b-
     &1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p7b-1)+int_mb(k_spin+p8b-1).
     &ne.16)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p8b - noab - 1 + nvab * (p7b - noab - 1 
     &+ nvab * (p5b - noab - 1 + nvab * (p3b - noab - 1 + nvab * (h18b -
     & 1 + noab * (h12b - 1 + noab * (h11b - 1 + noab * (h10b - 1)))))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h10b-1) * int_mb(k_range+h11b-1) * in
     &t_mb(k_range+h12b-1) * int_mb(k_range+h18b-1) * int_mb(k_range+p3b
     &-1) * int_mb(k_range+p5b-1) * int_mb(k_range+p7b-1) * int_mb(k_ran
     &ge+p8b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      block data ga_block_project
C$Id: ga_it_proj.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "cproject.fh"
c
      data oproject/.false./
      data nroot_proj/0/
      data g_proj/-9999/
      data n_proj/-1/
c
      end
      subroutine ga_init_project(n, nroot, maxiter, maxsub, tol,
     $     precond, product, oprint, eval0)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "cproject.fh"
      integer n                 ! Matrix size
      integer nroot             ! No. of roots to project
      integer maxiter
      integer maxsub
      double precision tol
      external product, precond ! Functions for solvers
      logical oprint
      double precision eval0
c     
      double precision acc_proj(max_proj)
      integer iter, iroot
      logical ga_iter_diag
      external ga_iter_diag
      external ga_block_project ! For T3D linker
c     
c     Comment out the next line to enable roots to be improved
c     by calling this routine multiple times
c
***** if (oproject) return
      if (.not. oproject) then
         if (nroot .gt. max_proj) call errquit
     $        ('ga_init_project: max_proj exceeded', nroot, INPUT_ERR)
c     
         nroot_proj = nroot
         n_proj     = n
*ga:1:0
         if (.not. ga_create(MT_DBL, n, nroot, 'ga_project', 0, nroot,
     $        g_proj)) call errquit('ga_init_project: ga_create?', 0,
     &       GA_ERR)
         call ga_zero(g_proj)
      else
         if (nroot_proj.ne.nroot .or. n_proj.ne.n) call errquit
     $        ('ga_init_project: mismatch of dimensions', 0, GA_ERR)
      endif
c     
      if (.not. ga_iter_diag(n, nroot, maxiter, maxsub, tol,
     $     precond, product, oprint, eval0, g_proj, e_proj,
     $     acc_proj, iter)) then
         do iroot = nroot,1,-1
            if (acc_proj(iroot).gt.1.0d0) nroot_proj = nroot_proj - 1
         enddo
         if (nroot_proj .ne. nroot) then
            if (ga_nodeid() .eq. 0) then
               write(6,1) nroot_proj, nroot
 1             format('  ga_init_project: only got',i3,' roots of',i3)
               call util_flush(6)
            endif
            if (nroot_proj .eq. 0) call errquit
     $           ('ga_init_project: no roots extracted', 0, GA_ERR)
         endif
      endif
c     
      oproject = .true.
c     
      end
      subroutine ga_term_project
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "cproject.fh"
c
      if (oproject) then
         if(.not. ga_destroy(g_proj))
     &      call errquit('ga_term_project: ga_destroy failed',911,
     &       GA_ERR)
      endif
      oproject = .false.
c
      end
      subroutine ga_precond_project(g_x, shift, precond, g_work)
      implicit none
#include "global.fh"
#include "cproject.fh"
      integer g_x
      double precision shift
      external precond
      integer g_work
c     
c     The user provides the routine precond that computes an
c     approximation to the shifted inverse of the matrix
c     being solved.  This routine combines this preconditioner
c     with the eigenvectors computed by ga_init_project to
c     come up with an improved preconditioner
c     
c     Let A be the matrix being inverted, e(u) be the u'th 
c     eigenvector with eigenvalue v(u), D be the approximation
c     to A inverted by precond() and P be a projection operator
c     onto the subspace of known eigenvectors.
c     
c     Then, this routine uses as an approximation to A
c     
c     PDP + sum(u=1,nroot) v(u) e(u) e(u)T
c     
c     where
c     
c     P = 1 - sum(u=1,nroot) e(u) e(u)T
c     
c     The inverse of this matrix is
c     
c     PD^-1P + sum(u=1,nroot) v(u)^-1 e(u) e(u)T
c     
      integer iroot, n, nroot
      double precision scale
c     
      if (.not. oproject) then
         call precond(g_x, shift)
      else
         n = n_proj
         nroot = nroot_proj
c     
c     Form P D^-1 P b in work
c     
         call ga_copy_patch('n', g_x, 1, n, 1, 1, g_work, 1, n, 1, 1)
c     
         do iroot = 1, nroot
            scale = ga_ddot_patch(
     $           g_x, 'n', 1, n, 1, 1,
     $           g_proj, 'n', 1, n, iroot, iroot)
            call ga_dadd_patch(
     $           1.0d0, g_work, 1, n, 1, 1,
     $           -scale, g_proj, 1, n, iroot, iroot,
     $           g_work, 1, n, 1, 1)
         enddo
c     
         call precond(g_work, shift)
c     
         do iroot = 1, nroot
            scale = ga_ddot_patch(
     $           g_work, 'n', 1, n, 1, 1,
     $           g_proj, 'n', 1, n, iroot, iroot)
            call ga_dadd_patch(
     $           1.0d0, g_work, 1, n, 1, 1,
     $           -scale, g_proj, 1, n, iroot, iroot,
     $           g_work, 1, n, 1, 1)
         enddo
c     
c     Add on the piece due to the eigenvectors
c     
         do iroot = 1, nroot
            scale = ga_ddot_patch(
     $           g_x, 'n', 1, n, 1, 1,
     $           g_proj, 'n', 1, n, iroot, iroot)
            scale = scale / e_proj(iroot)
            call ga_dadd_patch(
     $           1.0d0, g_work, 1, n, 1, 1,
     $           scale, g_proj, 1, n, iroot, iroot,
     $           g_work, 1, n, 1, 1)
         enddo
c     
c     Copy the result back
c     
         call ga_copy_patch('n', g_work, 1, n, 1, 1, g_x, 1, n, 1, 1)
      endif
c     
      end

*
* $Id: kbpp_band_orb.F 25260 2014-02-14 00:44:00Z bylaska $
*

*     **************************************
*     *                                    *
*     *           kbpp_band_orb            *
*     *                                    *
*     **************************************

      logical function kbpp_band_orb(oprint_in,version,
     >                  psp_filename,formatted_filename,
     >                  ngrid,unita,locp,lmax,
     >                  nbrillioun,kvectors,
     >                  rcut,lmbda)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "msgtypesf.h"
#include "util.fh"

      logical          oprint_in
      integer          version
      character*50     psp_filename,formatted_filename
      integer          ngrid(3)
      double precision unita(3,3)
      integer locp,lmax
      integer nbrillioun
      real*8  kvectors(3,*)
      real*8 rcut,lmbda

*     **** local variables ****
      character*255 full_filename

      integer taskid,MASTER,msglen
      parameter (MASTER=0)

*     **** 1d pseudopotential data ****
      character*2 atom
      character*80 comment
      double precision zv,amass
      integer lmax0,lmmax,lmax1,locp1
      double precision rc(0:9),rlocal1
      integer nrho
      double precision drho
      integer rho_indx,vp_indx,wp_indx,sc_r_indx
      integer rho_hndl,vp_hndl,wp_hndl,sc_r_hndl

      integer          isemicore
      logical          semicore
      double precision rcore,core_charge

      integer f_indx,cs_indx,sn_indx
      integer f_hndl,cs_hndl,sn_hndl

*     ***** ngrid data *****
      integer borbs_indx,G_indx
      integer borbs_hndl,G_hndl


*     **** other variables ****
      logical value,mprint,hprint,oprint,filter,kray
      double precision unitg(3,3)
      integer nsize,i,l,ierr,nb,psp_type
      integer nfft1,nfft2,nfft3
      integer nmax

*     **** external functions ****
      logical  control_print
      external control_print

      call Parallel_taskid(taskid)
      hprint = (taskid.eq.MASTER).and.control_print(print_high)
      mprint = (taskid.eq.MASTER).and.control_print(print_medium)
      oprint = (oprint_in.or.hprint)


      value = .false.
  
*     ***** read in pseudopotential data ****
      if (taskid.eq.MASTER) then
      call util_file_name_noprefix(psp_filename,.false.,.false.,
     >                    full_filename)
      l = index(full_filename,' ') - 1
      open(unit=11,file=full_filename(1:l),
     >             status='old',form='formatted')
      read(11,*) atom
      read(11,*) zv,amass,lmax0,lmax1,locp1,rlocal1
      read(11,*) (rc(i),i=0,lmax0)
      read(11,*) nrho,drho
      read(11,'(A)') comment
      end if

      psp_type=0
      msglen = 1
      call Parallel_Brdcst_values(MASTER,msglen,zv)
      call Parallel_Brdcst_values(MASTER,msglen,amass)
      call Parallel_Brdcst_ivalues(MASTER,msglen,lmax0)
      call Parallel_Brdcst_ivalues(MASTER,msglen,lmax1)
      call Parallel_Brdcst_ivalues(MASTER,msglen,locp1)

      msglen = lmax0+1
      call Parallel_Brdcst_values(MASTER,msglen,rc)
      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,nrho)
      call Parallel_Brdcst_values(MASTER,msglen,drho)

*     **** set the maximum angular momentum ****
      lmax = lmax0

*     **** set the local potential ****
      locp = lmax

*     **** allocate rho, vp, and wp ****
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'rho',rho_hndl,rho_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho*(lmax+1),
     >                        'vp',vp_hndl, vp_indx)
      value = value.and.MA_alloc_get(mt_dbl,nrho*(lmax+1),
     >                        'wp', wp_hndl, wp_indx)
      value = value.and.MA_alloc_get(mt_dbl,2*nrho,
     >                        'sc', sc_r_hndl, sc_r_indx)
      if (.not.value)
     > call errquit("kbpp_band_orb: out of stack memory",0,MA_ERR)

      if (taskid.eq.MASTER) then
      call read_vpwp_band(11,nrho,lmax,dbl_mb(rho_indx),
     >                         dbl_mb(vp_indx),
     >                         dbl_mb(wp_indx))
c      call read_semicore_band(11,isemicore,rcore,nrho,dbl_mb(sc_r_indx))
      close(11)
      end if

      msglen = nrho
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(rho_indx))
      msglen = nrho*(lmax+1)
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(vp_indx))
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(wp_indx))

      msglen = 1
      call Parallel_Brdcst_ivalues(MASTER,msglen,isemicore)
      semicore = (isemicore.eq.1)
      if (semicore) then
      msglen = 2*nrho
      call Parallel_Brdcst_values(MASTER,msglen,dbl_mb(sc_r_indx))
      else
         rcore = 0.0d0
      end if


*    **** more temporary space ****
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'f',f_hndl,f_indx)
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'cs',cs_hndl,cs_indx)
      value = MA_alloc_get(mt_dbl,nrho,
     >                        'sn',sn_hndl,sn_indx)
      if (.not.value)
     > call errquit("kbpp_band_orb: out of stack memory",0,MA_ERR)

*     **** allocate vl,vnl,vnlnrm G ****
      lmmax = (lmax+1)**2 - (2*locp+1)
      nsize = ngrid(1)*ngrid(2)*ngrid(3)

      value = value.and.MA_alloc_get(mt_dbl,nsize*(lmmax),
     >                        'borbs',borbs_hndl, borbs_indx)
      value = value.and.MA_alloc_get(mt_dbl,nsize*(3),
     >                        'G',G_hndl, G_indx)

      if (.not.value)
     > call errquit("kbpp_band_orb: out of stack memory",0,MA_ERR)

      call damp_kbpp_band_orb(nrho,lmax,rcut,lmbda,
     >                   dbl_mb(rho_indx),dbl_mb(wp_indx))




*     **** preparation of constants ****
      nfft1=ngrid(1)
      nfft2=ngrid(2)
      nfft3=ngrid(3)
      call setup_kbpp_band(nfft1,nfft2,nfft3,unita,unitg,dbl_mb(G_indx))
     

      if ((taskid.eq.MASTER).and.(oprint)) then
      write(*,*) "     ********************************************"
      write(*,*) "     *                                          *"
      write(*,*) "     * KBPP_BAND_ORB-ATOMIC orbital Formatter   *"
      write(*,*) "     *                                          *"
      write(*,*) "     *        version last updated 01/01/02     *"
      write(*,*) "     *                                          *"
      write(*,*) "     *        developed by Eric J. Bylaska      *"
      write(*,*) "     *                                          *"
      write(*,*) "     ********************************************"
      call nwpw_message(1)
      write(*,*)
      write(*,*) "Pseudpotential Data"
      write(*,*) "-------------------"
      write(*,*) "  atom     :",atom
      write(*,*) "  charge   :",zv
      write(*,*) "  mass no. :",amass
      write(*,*) "  highest angular component      :",lmax0
      write(*,*) "  highest angular component used :",lmax
      write(*,*) "  local potential used           :",locp
      write(*,111) "  cutoffs: ",(rc(i), i=0,lmax)

      write(*,*)
      write(*,*) "Simulation Cell"
      write(*,*) "---------------"
      if (version.eq.3) write(*,112) "  boundry: periodic"
      write(*,113) "  ngrid  :",ngrid
      write(*,114) "  unita  :",unita(1,1),unita(2,1),unita(3,1)
      write(*,114) "          ",unita(1,2),unita(2,2),unita(3,2)
      write(*,114) "          ",unita(1,3),unita(2,3),unita(3,3)
      write(*,*)
  111 format(a,10f10.3)
  112 format(a)
  113 format(a,3I4)
  114 format(a,3F10.3)
  115 format(a,2E14.6)
      end if



      if (taskid.eq.MASTER) then
        call util_file_name_noprefix(formatted_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)
          l = index(full_filename,' ') - 1
         if (mprint) then
         write(*,*)
         write(*,*) "Generated formatted_filename: ",full_filename(1:l)
         end if
         call openfile(2,full_filename,l,'w',l)     
         call iwrite(2,version,1)
         call iwrite(2,ngrid,3)
         call dwrite(2,unita,9)
         call cwrite(2,atom,2)
         call iwrite(2,lmax,1)
         call iwrite(2,locp,1)
         call dwrite(2,rcut,1)
         call dwrite(2,lmbda,1)
         call iwrite(2,nbrillioun,1)
         call dwrite(2,kvectors,3*nbrillioun)
      end if

      do nb=1,nbrillioun

         if ((oprint).and.(taskid.eq.MASTER))
     >      write(*,*) "generating brillioun #",nb

         call integrate_kbpp_band_orb(version,
     >                      kvectors(1,nb),
     >                      nrho,drho,lmax,locp,
     >                                dbl_mb(wp_indx),
     >                                dbl_mb(rho_indx),
     >                                dbl_mb(f_indx),
     >                                dbl_mb(cs_indx),
     >                                dbl_mb(sn_indx),
     >                      nfft1,nfft2,nfft3,lmmax,
     >                                dbl_mb(G_indx),
     >                                dbl_mb(borbs_indx),
     >                      ierr)
         if (taskid.eq.MASTER) 
     >     call dwrite(2,dbl_mb(borbs_indx),nsize*lmmax)
      end do
      if (taskid.eq.MASTER) then
         call closefile(2)
      end if
     
*     **** free heap space ****
      value = MA_free_heap(rho_hndl)
      value = value.and.MA_free_heap(vp_hndl)
      value = value.and.MA_free_heap(wp_hndl)
      value = value.and.MA_free_heap(sc_r_hndl)

      value = value.and.MA_free_heap(f_hndl)
      value = value.and.MA_free_heap(cs_hndl)
      value = value.and.MA_free_heap(sn_hndl)

      value = value.and.MA_free_heap(borbs_hndl)
      value = value.and.MA_free_heap(G_hndl)

      if (.not.value)
     > call errquit("kbpp_band_orb: error freeing memory",0,MA_ERR)

      
      if ((taskid.eq.MASTER).and.(oprint)) call nwpw_message(4)
      kbpp_band_orb = value
      return

 9999 call errquit('kbpp_band_orb:Error reading pspfilename',0,DISK_ERR)
      kbpp_band_orb = value
      END


         
      subroutine damp_kbpp_band_orb(nrho,lmax,rcut,lmbda,rho,w)
      implicit none
      integer nrho,lmax 
      real*8 rcut,lmbda,rho(nrho),w(nrho,0:lmax)

      integer i,l
    
      if (lmbda.gt.0.0d0) then
         do l=0,lmax
            do i=1,nrho 
              w(i,l) = w(i,l)*dexp(-(rho(i)/rcut)**lmbda)
            end do 
         end do
      end if
      return 
      end

      subroutine argos_prop_record()
c
      implicit none
c
#include "argos_prop.fh"
c
      integer i
      character*10 pdate,ptime
c
      if(me.ne.0) return
c
      if(.not.lfhdr) then
      call swatch(pdate,ptime)
      write(lfnprp,3000) nprop,pdate,ptime,np,npfft
 3000 format(i7,1x,2a10,2i5)
      write(lfnprp,3001) (pronam(ixp(i)),i=1,nprop)
 3001 format(a50)
      lfhdr=.true.
      endif
      write(lfnprp,3002)
 3002 format('frame')
      if(iprop.eq.0) then
      write(lfnprp,3003) (p(ixp(i)),i=1,nprop)
      else
      write(lfnprp,3003) (psump(ixp(i))/dble(nsump),i=1,nprop)
 3003 format(4(1pe12.5))
      endif
      nsump=0
      do 1 i=1,nprop
      psump(ixp(i))=zero
    1 continue
c
      return
      end
c $Id: argos_prop_record.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_fsb(nbonds,indexl,msb,msp,ibnd,bnd,rbnd,
     + natoms,ndim,igan,isgm,imol,idyn,ichg,chg,xs,fs,ess,lpbc,lpbcs,
     + lupden,lupdti,dera,lseq)
c
c $Id: argos_cafe_fsb.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     argos_cafe_fsb returns forces and energies for solute bonds
c
c     =====================================================
c
c     description of arguments
c     ------------------------
c
c     in: integer nbonds     = number of bonds to consider
c         integer indexl     = index list
c
c         integer idsb(msb)  = global atom id i
c         integer jdsb(msb)  = global atom id j
c         integer isbs(msb)  = bond type
c         real*8 cdsb(msb,6) = bond force constants
c         real*8 ddsb(msb,6) = bond reference value
c         real*8 rdsb(msb)   = bond value
c
c         integer natoms     = number of atoms in arrays
c         integer ndim       = leading dimension atom arrays
c         integer igan(ndim) = global atom numbers
c         integer imol(ndim) = atom molecule fraction
c         integer idyn(ndim) = atom dynamics type
c         real*8 qs(ndim)    = atomic charges
c         real*8 xs(ndim,3)  = atom coordinates
c
c    out: real*8 fs(ndim,3)  = atom forces (ACCUMULATED)
c         real*8 usb(msb)    = bond energies
c
      implicit none
c
#include "argos_cafe_common.fh"
c
c     declaration of arguments
c     ------------------------
c
      integer msb,msp
      integer ibnd(msb,3)
      real*8 bnd(msb,msp,mset),rbnd(msb,2)
      integer isgm(msa),lseq(mseq)
c
      integer nbonds
      integer indexl(nbonds)
c
      logical lpbc,lpbcs,lupden,lupdti
      real*8 dera(6,nsatot)
c
      integer natoms,ndim
      integer igan(ndim),imol(ndim),idyn(ndim),ichg(ndim)
      real*8 chg(mqt,mqp,mset)
      real*8 xs(ndim,3),fs(ndim,3)
      real*8 dx(3)
c
c     declaration of local variables
c     ------------------------------
c
      integer i,j,isb,isa,jsa,isf,jsf,ibset
      real*8 factu,dercon,qij,ferfc,fderfc,qijp2,qijp3
      real*8 bond,dbond,for,dfor,dfs1,dfs2,dfs3,eterm
      real*8 xs1,xs2,xs3,rss,rss2,rssi,rss2i,ess(msf,msf,mpe,2)
c
#include "argos_cafe_funcs_dec.fh"
#include "bitops_decls.fh"
#include "argos_cafe_funcs_sfn.fh"
#include "bitops_funcs.fh"
c
c     solute bonds
c     ============
c
cx      write(*,'(4i7)') (i,(ibnd(i,j),j=1,3),i=1,msb)
c
cx      write(*,'(10i7)') (igan(j),j=1,natoms)
cx      write(*,'(a,i7)') 'bonds  ',nbonds
cx      write(*,'(10i7)') (indexl(j),j=1,nbonds)
c
      do 1 i=1,nbonds
c
c     find index into list of bonds
c
      isb=indexl(i)
c
c     find local atom numbers involved in this bond
c
      isa=0
      jsa=0
      do 2 j=1,natoms
      if(ibnd(isb,1).eq.igan(j)) isa=j
      if(ibnd(isb,2).eq.igan(j)) jsa=j
    2 continue
c
      if(nfhop.eq.0) then
      ibset=iset
      else
      ibset=lseq(isgm(isa))
      endif
c
c      write(*,'(a,5i5)') 'bond ',i,nbonds,isb,isa,jsa
c
c     find solute molecule numbers involved in this constrained
c
      isf=imol(isa)
      jsf=imol(jsa)
c      write(*,'(a,6i5)') 'bond ',i,nbonds,isa,jsa,isf,jsf
c
c     determine actual distance between the atoms
c
      xs1=xs(isa,1)-xs(jsa,1)
      xs2=xs(isa,2)-xs(jsa,2)
      xs3=xs(isa,3)-xs(jsa,3)
c
c     periodic boundary conditions
c
      if(lpbc.or.lpbcs) then
      dx(1)=xs1
      dx(2)=xs2
      dx(3)=xs3
      call argos_cafe_pbc(1,dx,1,dx,1,0,1,1)
      xs1=dx(1)
      xs2=dx(2)
      xs3=dx(3)
      endif
c
      rss2=xs1**2+xs2**2+xs3**2
      if(rss2.gt.tiny) then
      rss=sqrt(rss2)
      rssi=one/rss
      rss2i=rssi*rssi
      else
      rss=zero
      rssi=one
      rss2i=one
      endif
c
      rbnd(isb,1)=rss
c
c     if bond not constrained or pme
c
      if(iand(ibnd(isb,3),icnstr).eq.0.or.ipme.ne.0) then
c
c     if bond not constrained
c
      if(iand(ibnd(isb,3),icnstr).eq.0) then
c
c     determine fraction of energy to be counted
c     this depends on the atoms being dynamic or fixed
c
      factu=zero
      if(iand(idyn(isa),mdynam).eq.ldynam.or.
     + iand(idyn(jsa),mdynam).eq.ldynam) factu=one
c      if((iand(idyn(isa),mdynam).eq.ldynam.and.
c     + iand(idyn(jsa),mdynam).ne.ldynam) .or.
c     + (iand(idyn(isa),mdynam).ne.ldynam.and.
c     + iand(idyn(jsa),mdynam).eq.ldynam)) factu=half
      if(includ.eq.1) factu=one
c
c     find reference bond length and force constant
c
      bond=bnd(isb,1,ibset)
      for=bnd(isb,2,ibset)
c
      dbond=rss-bond
c
c     evaluate energies and forces
c
      rbnd(isb,2)=half*for*dbond*dbond
      eterm=zero
      if(lupden) then
      ess(isf,isf,1,1)=ess(isf,isf,1,1)+half*factu*rbnd(isb,2)
      ess(jsf,jsf,1,1)=ess(jsf,jsf,1,1)+half*factu*rbnd(isb,2)
      endif
      eterm=factu*rbnd(isb,2)
      dfor=for*dbond*rssi
      dfs1=dfor*xs1
      dfs2=dfor*xs2
      dfs3=dfor*xs3
      fs(isa,1)=fs(isa,1)-dfs1
      fs(jsa,1)=fs(jsa,1)+dfs1
      fs(isa,2)=fs(isa,2)-dfs2
      fs(jsa,2)=fs(jsa,2)+dfs2
      fs(isa,3)=fs(isa,3)-dfs3
      fs(jsa,3)=fs(jsa,3)+dfs3
c
c     evaluate hessian
 
cx      if(ihess.gt.0) then
cx      isag=igan(isa)
cx      jsag=igan(jsa)
c
cx      hess=for*(one-bond*rssi*(one+xs1*xs1*rss2i))
cx      hs(isa,1,1,isag)=hs(isa,1,1,isag)+hess
cx      hs(isa,1,1,jsag)=hs(isa,1,1,jsag)-hess
cx      hs(jsa,1,1,jsag)=hs(jsa,1,1,jsag)-hess
cx      hs(jsa,1,1,isag)=hs(jsa,1,1,isag)+hess
c
cx      hess=for*(one-bond*rssi*(one+xs2*xs2*rss2i))
cx      hs(isa,2,2,isag)=hs(isa,2,2,isag)+hess
cx      hs(isa,2,2,jsag)=hs(isa,2,2,jsag)-hess
cx      hs(jsa,2,2,jsag)=hs(jsa,2,2,jsag)-hess
cx      hs(jsa,2,2,isag)=hs(jsa,2,2,isag)+hess
c
cx      hess=for*(one-bond*rssi*(one+xs3*xs3*rss2i))
cx      hs(isa,3,3,isag)=hs(isa,3,3,isag)+hess
cx      hs(isa,3,3,jsag)=hs(isa,3,3,jsag)-hess
cx      hs(jsa,3,3,jsag)=hs(jsa,3,3,jsag)-hess
cx      hs(jsa,3,3,isag)=hs(jsa,3,3,isag)+hess
c
cx      hess=for*bond*xs1*xs2*rss2i*rssi
cx      hs(isa,1,2,isag)=hs(isa,1,2,isag)+hess
cx      hs(isa,2,1,isag)=hs(isa,2,1,isag)+hess
cx      hs(isa,1,2,jsag)=hs(isa,1,2,jsag)-hess
cx      hs(isa,2,1,jsag)=hs(isa,2,1,jsag)-hess
cx      hs(jsa,1,2,jsag)=hs(jsa,1,2,jsag)-hess
cx      hs(jsa,2,1,jsag)=hs(jsa,2,1,jsag)-hess
cx      hs(jsa,1,2,isag)=hs(jsa,1,2,isag)+hess
cx      hs(jsa,2,1,isag)=hs(jsa,2,1,isag)+hess
c
cx      hess=for*bond*xs1*xs3*rss2i*rssi
cx      hs(isa,1,3,isag)=hs(isa,1,3,isag)+hess
cx      hs(isa,3,1,isag)=hs(isa,3,1,isag)+hess
cx      hs(isa,1,3,jsag)=hs(isa,1,3,jsag)-hess
cx      hs(isa,3,1,jsag)=hs(isa,3,1,jsag)-hess
cx      hs(jsa,1,3,jsag)=hs(jsa,1,3,jsag)-hess
cx      hs(jsa,3,1,jsag)=hs(jsa,3,1,jsag)-hess
cx      hs(jsa,1,3,isag)=hs(jsa,1,3,isag)+hess
cx      hs(jsa,3,1,isag)=hs(jsa,3,1,isag)+hess
c
cx      hess=for*bond*xs2*xs3*rss2i*rssi
cx      hs(isa,2,3,isag)=hs(isa,2,3,isag)+hess
cx      hs(isa,3,2,isag)=hs(isa,3,2,isag)+hess
cx      hs(isa,2,3,jsag)=hs(isa,2,3,jsag)-hess
cx      hs(isa,3,2,jsag)=hs(isa,3,2,jsag)-hess
cx      hs(jsa,2,3,jsag)=hs(jsa,2,3,jsag)-hess
cx      hs(jsa,3,2,jsag)=hs(jsa,3,2,jsag)-hess
cx      hs(jsa,2,3,isag)=hs(jsa,2,3,isag)+hess
cx      hs(jsa,3,2,isag)=hs(jsa,3,2,isag)+hess
c
cx      endif
c
      if(lupdti) then
c
c     for thermodynamic perturbations evaluate the energies using
c     the 'perturbed' parameters in set 2 and/or 3
c
      if(ip2(18))
     + ep2(1)=ep2(1)-eterm+factu*half*bnd(isb,2,2)*(rss-bnd(isb,1,2))**2
      if(ip3(18))
     + ep3(1)=ep3(1)-eterm+factu*half*bnd(isb,2,3)*(rss-bnd(isb,1,3))**2
c
c     for thermodynamic integrations evaluate the derivative
c
      if(ith(18)) then
      dercon=dbond*(half*dbond*bnd(isb,2,4)-for*bnd(isb,1,4))
      deriv(18,1)=deriv(18,1)+dercon
      if(npgdec.gt.1) then
      dera(5,ibnd(isb,1))=dera(5,ibnd(isb,1))+half*dercon
      dera(5,ibnd(isb,2))=dera(5,ibnd(isb,2))+half*dercon
      endif
      endif
c
      endif
      endif
c
      if(ipme.ne.0) then
      qij=chg(ichg(isa),1,ibset)*chg(ichg(jsa),1,ibset)
      ferfc=one-erfc(ealpha*rss)
      fderfc=-(ealpha*derfc(ealpha*rss))
      epmecs=epmecs-ferfc*qij*rssi
      if(lupden) then
      ess(isf,isf,9,1)=ess(isf,isf,9,1)-half*ferfc*qij*rssi
      ess(jsf,jsf,9,1)=ess(jsf,jsf,9,1)-half*ferfc*qij*rssi
      if(ipert2) then
      qijp2=chg(ichg(isa),1,2)*chg(ichg(jsa),1,2)
      ess(isf,isf,10,1)=ess(isf,isf,10,1)-half*ferfc*qijp2*rssi
      ess(jsf,jsf,10,1)=ess(jsf,jsf,10,1)-half*ferfc*qijp2*rssi
      endif
      if(ipert3) then
      qijp3=chg(ichg(isa),1,3)*chg(ichg(jsa),1,3)
      ess(isf,isf,11,1)=ess(isf,isf,11,1)-half*ferfc*qijp3*rssi
      ess(jsf,jsf,11,1)=ess(jsf,jsf,11,1)-half*ferfc*qijp3*rssi
      endif
      endif
      dfor=-(qij*rssi*rssi*(ferfc*rssi-fderfc))
      dfs1=dfor*xs1
      dfs2=dfor*xs2
      dfs3=dfor*xs3
      fs(isa,1)=fs(isa,1)-dfs1
      fs(jsa,1)=fs(jsa,1)+dfs1
      fs(isa,2)=fs(isa,2)-dfs2
      fs(jsa,2)=fs(jsa,2)+dfs2
      fs(isa,3)=fs(isa,3)-dfs3
      fs(jsa,3)=fs(jsa,3)+dfs3
      vpmeb(1)=vpmeb(1)+dfs1*xs1
      vpmeb(2)=vpmeb(2)+dfs2*xs1
      vpmeb(3)=vpmeb(3)+dfs3*xs1
      vpmeb(4)=vpmeb(4)+dfs2*xs2
      vpmeb(5)=vpmeb(5)+dfs3*xs2
      vpmeb(6)=vpmeb(6)+dfs3*xs3
      endif
c
      endif
c
    1 continue
c
      return
      end

      logical function argos_prepare_equiv(csa,isml,isgm,msa,nsa,iequi,
     + msm,nsm)
c
c $Id: argos_prepare_equiv.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "mafdecls.fh"
#include "util.fh"
c
      integer msa,msm,nsa,nsm
      character*16 csa(msa)
      integer isml(msa),isgm(msa),iequi(msm,4)
c
      integer i,j,ia,ja,number
c
      do 1 i=1,msm
      iequi(i,1)=0
      iequi(i,2)=0
      iequi(i,3)=0
      iequi(i,4)=0
    1 continue
c
      do 2 i=1,nsa
      if(iequi(isml(i),1).eq.0) iequi(isml(i),1)=i
      iequi(isml(i),2)=i
    2 continue
c
      do 3 i=1,nsm-1
      do 4 j=i+1,nsm
      if(iequi(j,3).eq.0) then
      if(iequi(i,2)-iequi(i,1).eq.iequi(j,2)-iequi(j,1)) then
      do 5 ia=iequi(i,1),iequi(i,2)
      ja=ia+iequi(j,1)-iequi(i,1)
      if(csa(ia).ne.csa(ja)) goto 4
    5 continue
      iequi(j,3)=i
      endif
      endif
    4 continue
    3 continue
c
      do 6 i=1,msm
      iequi(i,4)=iequi(i,1)
      iequi(i,1)=0
      iequi(i,2)=0
    6 continue
c
      do 7 i=1,nsa
      if(iequi(isml(i),1).eq.0) iequi(isml(i),1)=isgm(i)
      iequi(isml(i),2)=isgm(i)
    7 continue
c
      do 8 i=1,nsm
      number=1
      do 9 j=1,nsm
      if(iequi(j,3).eq.i) number=number+1
    9 continue
      if(number.gt.1) write(*,1000) number,i
 1000 format(/,i5,' equivalent solute molecules ',i5)
    8 continue
c
      argos_prepare_equiv=.true.
      return
c
c 9999 continue
c      argos_prepare_equiv=.false.
      return
      end

      subroutine ana_input(irtdb)
c
c $Id: ana_input.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "rtdb.fh"
#include "inp.fh"
#include "global.fh"
#include "mafdecls.fh"
c
      integer irtdb
c
      character*255 item,prefix,atom,tag,atomi,atomj,atomk,atoml,filtop
      character*255 filcmd,filchg,filplt,filxyz,filref,filtrj,filcop
      character*255 filpin,filhol,filpou,filavg
      integer lfncmd,numcmd,len,ivec,nspac,ibond,iangl,itors,iplan,icd
      integer ifrfr,ifrto,ifrsk,ifrst,ilast,isel,jsel,ksel,lsel
      integer iopt,ivctr,iorder
      integer itag,iatag,jatag,ipbc,nrdf,mcopf
      real*8 timoff,rsel,rtag,rcut,scale,cpk,stick,rval,rmin,rmax,rang
      real*8 arota,rrdf
      logical lref,lfil,lsol,lsuper,lselo
      integer iesppb,lent,idpdb,indx,icent,jcent,nwhb,nclean
      character*8 option
c
      if(ga_nodeid().eq.0) then
      call util_print_centered(6,'Analysis Input Module',40,.true.)
      endif
c
      if(.not.rtdb_cget(irtdb,'file_prefix',1,prefix))
     + call md_abort('rtdb_cget failed on file_prefix',9999)
c
      len=0
      lfncmd=69
      numcmd=0
      lref=.false.
      lfil=.false.
      nrdf=0
      rrdf=1.0d0
c
      timoff=0.0d0
      scale=1.0d0
      cpk=1.0d0
      stick=1.0d0
      icent=0
c
    1 continue
c
      if(.not.inp_read()) call md_abort('ana_input: inp_read failed',0)
c
    2 continue
c
      if(.not.inp_a(item)) goto 1
c
    3 continue
c
c     system command defines initial filenames and opens command file
c     ---------------------------------------------------------------
c
      if(inp_compare(.false.,'system',item)) then
      if(len.gt.0) call md_abort('ana_input: duplicate system',0)
      if(.not.inp_a(prefix)) call md_abort('ana_input: error system',0)
      len=index(prefix,' ')-1
      filcmd=prefix(1:len)//'.cmd '
      filchg=prefix(1:len)//'.q '
      filplt=prefix(1:len)//'.plt '
      filxyz=prefix(1:len)//'.xyz '
      filref=prefix(1:len)//'.rst '
      filtrj=prefix(1:len)//'.trj '
      lent=index(prefix,'_')-1
      if(lent.le.0) lent=len
      filtop=prefix(1:lent)//'.top '
c
      open(unit=lfncmd,file=filcmd(1:index(filcmd,' ')-1),
     + form='formatted',status='unknown',err=9999)
      rewind(unit=lfncmd)
      numcmd=0
c
      goto 2
      endif
c
c     define reference file
c     ---------------------
c
      if(inp_compare(.false.,'reference',item)) then
      if(.not.inp_a(filref)) call md_abort('Error in reference file',0)
      lent=index(filref,'_')-1
      if(lent.le.0) lent=index(filref,'.')-1
      if(lent.le.0) call md_abort('Error in topology file',0)
      filtop=filref(1:lent)//'.top '
      write(lfncmd,1000) filref(1:index(filref,' ')-1)
      write(lfncmd,2000) filtop(1:index(filtop,' ')-1)
 1000 format('refer  ',a)
 2000 format('topol  ',a)
      numcmd=numcmd+1
      lref=.true.
      goto 2
      endif
      if(.not.lref) then
      write(lfncmd,1000) filref(1:index(filref,' ')-1)
      numcmd=numcmd+1
      write(lfncmd,2000) filtop(1:index(filtop,' ')-1)
      numcmd=numcmd+1
      lref=.true.
      endif
c
c     define trajectory file(s)
c     -------------------------
c
      if(inp_compare(.false.,'file',item)) then
      if(.not.inp_a(filtrj)) call md_abort('Error in trajectory file',0)
      if(index(filtrj,'.trj').le.0.and.index(filtrj,'.sco').le.0.and.
     + index(filtrj,'.coo').le.0)
     + filtrj=filtrj(1:index(filtrj,' ')-1)//'.trj '
      if(.not.inp_i(ifrst)) ifrst=0
      if(.not.inp_i(ilast)) ilast=0
      write(lfncmd,1001) ifrst,ilast,filtrj(1:index(filtrj,' ')-1)
 1001 format('file   ',2i5,a)
      numcmd=numcmd+1
      lfil=.true.
      goto 2
      endif
c
c     define simulation time offset
c     -----------------------------
c
      if(inp_compare(.false.,'time',item)) then
      if(.not.inp_f(timoff)) call md_abort('Error in time offset',0)
      write(lfncmd,1002) timoff
 1002 format('time   ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
c
c     define centering fraction
c     -------------------------
c
      if(inp_compare(.false.,'center',item)) then
      if(.not.inp_i(icent)) call md_abort('Error in center',0)
      if(.not.inp_i(jcent)) jcent=icent
      write(lfncmd,1306) icent,jcent
 1306 format('center ',2i5)
      numcmd=numcmd+1
      goto 2
      endif
c
c     define frequency processing frames
c     ----------------------------------
c
      if(inp_compare(.false.,'frames',item)) then
      if(.not.inp_i(ifrfr)) call md_abort('Error in frames',0)
      if(.not.inp_i(ifrto)) then
      ifrto=ifrfr
      ifrfr=1
      ifrsk=1
      else
      if(.not.inp_i(ifrsk)) ifrsk=1
      endif
      write(lfncmd,1003) ifrfr,ifrto,ifrsk
 1003 format('frame  ',3i10)
      numcmd=numcmd+1
      goto 2
      endif
c
c     define scale (for povray output only)
c     -------------------------------------
c
      if(inp_compare(.false.,'scale',item)) then
      if(.not.inp_f(scale)) call md_abort('Error in scale',0)
      write(lfncmd,1303) scale
 1303 format('scale ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
c
c     define scale (for povray output only)
c     -------------------------------------
c
      if(inp_compare(.false.,'cpk',item)) then
      if(.not.inp_f(cpk)) cpk=1.0d0
      write(lfncmd,1304) cpk
 1304 format('cpk   ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
c
      if(inp_compare(.false.,'stick',item)) then
      if(.not.inp_f(stick)) stick=1.0d0
      write(lfncmd,1305) stick
 1305 format('stick ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
c
c     write pdb file of selected frame
c     --------------------------------
c
      if(inp_compare(.false.,'write',item)) then
      if(.not.inp_i(idpdb)) idpdb=0
      lsol=.false.
      lsuper=.false.
 3301 continue
      if(.not.inp_a(filcop)) call md_abort('Error in copy',0)
      if(filcop(1:6).eq.'solute') then
      lsol=.true.
      goto 3301
      endif
      if(filcop(1:5).eq.'super') then
      lsuper=.true.
      goto 3301
      endif
      option='        '
      if(lsuper) option='sup     '
      if(lsol) option=option(1:3)//' sol '
      if(index(filcop,'.').le.0)
     + filcop=filcop(1:index(filcop,' ')-1)//'.pdb '
      if(filcop.eq.filtrj) call md_abort('File name conflict',0)
      write(lfncmd,3004) idpdb,option,filcop(1:index(filcop,' ')-1)
 3004 format('wrtpdb',i8,a8,a)
      numcmd=numcmd+1
      goto 2
      endif
c
c     copy frames to file
c     -------------------
c
      if(inp_compare(.false.,'copy',item)) then
      if(.not.inp_i(mcopf)) mcopf=0
      if(.not.inp_a(filcop)) call md_abort('Error in copy',0)
      lsol=.false.
      if(filcop(1:6).eq.'solute') then
      if(.not.inp_a(filcop)) call md_abort('Error in super',0)
      lsol=.true.
      endif
      rang=0.0d0
      if(filcop(1:6).eq.'rotate') then
      if(.not.inp_f(rang)) call md_abort('Error in rotation time',0)
      if(.not.inp_a(filcop)) call md_abort('Error in super',0)
      endif
      if(index(filcop,'.').le.0)
     + filcop=filcop(1:index(filcop,' ')-1)//'.trj '
      if(filcop.eq.filtrj) call md_abort('File name conflict',0)
      if(lsol) then
      write(lfncmd,1004) mcopf,rang,filcop(1:index(filcop,' ')-1)
 1004 format('copys  ',i5,f12.6,a)
      else
      write(lfncmd,1024) mcopf,rang,filcop(1:index(filcop,' ')-1)
 1024 format('copy   ',i5,f12.6,a)
      endif
      numcmd=numcmd+1
      goto 2
      endif
c
c     clean up frames to file
c     -----------------------
c
      if(inp_compare(.false.,'clean',item)) then
      if(.not.inp_i(nclean)) nclean=0
      write(lfncmd,1034) nclean
 1034 format('clean  ',i6)
      numcmd=numcmd+1
      goto 2
      endif
c
c     superimpose frames and write to file
c     ------------------------------------
c
      if(inp_compare(.false.,'super',item)) then
      if(.not.inp_a(filcop)) call md_abort('Error in super',0)
      lsol=.false.
      if(filcop(1:6).eq.'solute') then
      if(.not.inp_a(filcop)) call md_abort('Error in super',0)
      lsol=.true.
      endif
      rang=0.0d0
      if(filcop(1:6).eq.'rotate') then
      if(.not.inp_f(rang)) call md_abort('Error in rotation time',0)
      if(.not.inp_a(filcop)) call md_abort('Error in super',0)
      endif
      if(index(filcop,'.').le.0)
     + filcop=filcop(1:index(filcop,' ')-1)//'.trj '
      if(filcop.eq.filtrj) call md_abort('File name conflict',0)
      if(lsol) then
      write(lfncmd,1005) rang,filcop(1:index(filcop,' ')-1)
 1005 format('supers ',f12.6,a)
      else
      write(lfncmd,1025) rang,filcop(1:index(filcop,' ')-1)
 1025 format('super  ',f12.6,a)
      endif
      numcmd=numcmd+1
      goto 2
      endif
c
c     scan frames and write to file
c     -----------------------------
c
      if(inp_compare(.false.,'scan',item)) then
      if(.not.inp_a(item)) call md_abort('Error in scan',0)
      if(inp_compare(.false.,'super',item)) then
      if(.not.inp_a(filcop)) call md_abort('Error in scan',0)
      write(lfncmd,1016) filcop(1:index(filcop,' ')-1)
 1016 format('scans  ',a)
      else
      filcop=item
      write(lfncmd,1023) filcop(1:index(filcop,' ')-1)
 1023 format('scan   ',a)
      endif
      numcmd=numcmd+1
      goto 2
      endif
c
c     select atoms
c     ------------
c
      if(inp_compare(.false.,'select',item)) then
      lsuper=.false.
      lselo=.false.
      rsel=0.0d0
 1255 continue
      if(.not.inp_a(atom)) call md_abort('Error in select',0)
      if(atom(1:5).eq.'super') then
      lsuper=.true.
      lselo=.false.
      goto 1255
      endif
      if(atom(1:6).eq.'output') then
      lsuper=.false.
      lselo=.true.
      goto 1255
      endif
      if(atom(1:5).eq.'range') then
      if(.not.inp_f(rsel)) call md_abort('Error in select',1)
      goto 1255
      endif
      if(atom(1:7).eq.'solvent') then
      if(lsuper) call md_abort('Can not select super solvent',0)
      if(.not.inp_f(rsel)) call md_abort('No range specified',0)
      write(lfncmd,1206) rsel
 1206 format('wselct ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
      if(atom(1:4).eq.'save') then
      if(.not.inp_a(atom)) call md_abort('No file specified',0)
      if(lsuper) then
      write(lfncmd,1258) atom(1:index(atom,' ')-1)
 1258 format('savsls ',a)
      else
      write(lfncmd,1208) atom(1:index(atom,' ')-1)
 1208 format('savsel ',a)
      endif
      numcmd=numcmd+1
      goto 2
      endif
      if(atom(1:4).eq.'read') then
      if(.not.inp_a(atom)) call md_abort('No file specified',0)
      if(lsuper) then
      write(lfncmd,1259) atom(1:index(atom,' ')-1)
 1259 format('rdsels ',a)
      else
      write(lfncmd,1209) atom(1:index(atom,' ')-1)
 1209 format('rdsel  ',a)
      endif
      numcmd=numcmd+1
      goto 2
      endif
    4 continue
      if(lsuper) then
      write(lfncmd,1056) rsel,atom(1:index(atom,' ')-1)
 1056 format('selecs ',f12.6,a)
      elseif(lselo) then
      write(lfncmd,1057) rsel,atom(1:index(atom,' ')-1)
 1057 format('seleco ',f12.6,a)
      else
      write(lfncmd,1006) rsel,atom(1:index(atom,' ')-1)
 1006 format('select ',f12.6,a)
      endif
      numcmd=numcmd+1
      if(inp_a(atom)) goto 4
      goto 2
      endif
c
c     define groups of solute atoms
c     -----------------------------
c
      if(inp_compare(.false.,'define',item)) then
      if(.not.inp_i(isel)) call md_abort('ana_input: define',0)
      if(.not.inp_f(rsel)) rsel=0.0d0
      if(.not.inp_a(atom)) call md_abort('ana_input: define',0)
      if(atom(1:7).eq.'solvent') then
      if(.not.inp_f(rsel)) rsel=0.0d0
      if(.not.inp_a(atom)) atom=' '
      write(lfncmd,1207) isel,rsel,atom(1:index(atom,' ')-1)
 1207 format('wdefin ',i7,f12.6,a)
      numcmd=numcmd+1
      goto 2
      endif
    6 continue
      write(lfncmd,1020) isel,rsel,atom(1:index(atom,' ')-1)
 1020 format('define ',i7,f12.6,a)
      numcmd=numcmd+1
      if(inp_a(atom)) goto 6
      goto 2
      endif
c
c     do things with groups of atoms
c     ------------------------------
c
      if(inp_compare(.false.,'groups',item)) then
      if(.not.inp_i(isel)) call md_abort('No igroup specified',0)
      if(.not.inp_i(jsel)) jsel=-1
      if(.not.inp_i(ksel)) ksel=-1
      if(.not.inp_i(lsel)) lsel=-1
      if(.not.inp_a(item)) call md_abort('No group function',0)
      ipbc=0
      if(inp_compare(.false.,'periodic',item)) then
      if(.not.inp_i(ipbc)) ipbc=3
      if(.not.inp_a(item)) call md_abort('No group function',0)
      endif
      iopt=0
      if(inp_compare(.false.,'distance',item)) iopt=1
      if(inp_compare(.false.,'distances',item)) iopt=2
      if(inp_compare(.false.,'zcoordinate',item)) iopt=3
      if(inp_compare(.false.,'angle',item)) iopt=4
      if(inp_compare(.false.,'vectors',item)) iopt=5
      if(.not.inp_f(rsel)) rsel=0.0d0
      if(.not.inp_f(rval)) rval=rsel
      if(.not.inp_a(item)) item=' '
      if(iopt.eq.1.and.jsel.le.0)
     + call md_abort('Error in groups definition',4)
      if(iopt.eq.2.and.jsel.le.0)
     + call md_abort('Error in groups definition',5)
      if(iopt.eq.4.and.(jsel.le.0.or.ksel.le.0))
     + call md_abort('Error in groups definition',6)
c      if(iopt.eq.5.and.(jsel.le.0.or.ksel.le.0.or.lsel.le.0))
c     + call md_abort('Error in groups definition',7)
      write(lfncmd,1022) isel,jsel,ksel,lsel,iopt,ipbc,rsel,rval,
     + item(1:index(item,' ')-1)
 1022 format('groups ',4i7,i5,i3,2f12.6,a)
      numcmd=numcmd+1
      goto 2
      endif
c
c     do things with groups of atoms on the trajectory
c     ------------------------------------------------
c
      if(inp_compare(.false.,'histogram',item)) then
      if(.not.inp_i(isel)) call md_abort('No group specified',0)
      if(.not.inp_i(jsel)) jsel=0
      if(.not.inp_a(item)) call md_abort('No group function',0)
      ipbc=0
      if(inp_compare(.false.,'periodic',item)) then
      if(.not.inp_i(ipbc)) ipbc=3
      if(.not.inp_a(item)) call md_abort('No group function',0)
      endif
      ksel=0
      if(inp_compare(.false.,'zcoordinate',item)) ksel=1
      if(.not.inp_f(rsel)) rsel=0.0d0
      if(.not.inp_f(rval)) rval=rsel
      if(.not.inp_a(item)) item=' '
      write(lfncmd,1021) isel,jsel,ksel,ipbc,rsel,rval,
     + item(1:index(item,' ')-1)
 1021 format('histo  ',2i7,i5,i3,2f12.6,a)
      numcmd=numcmd+1
      goto 2
      endif
c
c     electrostatic potentials at specific positions
c     ----------------------------------------------
c
      if(inp_compare(.false.,'esp_points',item)) then
      if(.not.inp_a(filpin)) filpin='espp.inp '
      if(.not.inp_a(filhol)) filpin='espp.hol '
      if(.not.inp_a(filpou)) filpou='espp.dat '
      if(.not.inp_a(filavg)) filpou='espp.avg '
      write(lfncmd, 1055) filpin(1:index(filpin,' ')),
     + filhol(1:index(filhol,' ')),filpou(1:index(filpou,' ')),
     + filavg(1:index(filavg,' '))
 1055 format('esppnt ',a,a,a,a)
      numcmd=numcmd+1
      goto 2
      endif
c
c     radial distribution function
c     ----------------------------
c
      if(inp_compare(.false.,'rdf',item)) then
      if(.not.inp_i(nrdf))
     + call md_abort('No rdf number of bins specified',0)
      if(.not.inp_f(rrdf)) call md_abort('No rdf range specified',0)
      write(lfncmd,1032) nrdf,rrdf
 1032 format('rdf    ',i7,f12.6)
      numcmd=numcmd+1
      goto 2
      endif
c
c     group analysis
c     --------------
c
      if(inp_compare(.false.,'group',item)) then
      if(.not.inp_i(isel)) call md_abort('No group specified',0)
      if(.not.inp_a(item)) call md_abort('No group function',0)
      ipbc=0
      if(inp_compare(.false.,'periodic',item)) then
      if(.not.inp_i(ipbc)) ipbc=3
      if(.not.inp_a(item)) call md_abort('No group function',0)
      endif
      ksel=0
      if(inp_compare(.false.,'local',item)) ksel=1
      if(.not.inp_f(rsel)) rsel=0.0d0
      if(.not.inp_f(rval)) rval=rsel
      if(.not.inp_a(item)) item=' '
      if(ksel.eq.0) call md_abort('Unknown group function specified',0)
      write(lfncmd,1030) isel,ksel,ipbc,rsel,rval,
     + item(1:index(item,' ')-1)
 1030 format('group  ',i7,i5,i3,2f12.6,a)
      numcmd=numcmd+1
      goto 2
      endif
c
c     calculate order parameter
c     -------------------------
c
      if(inp_compare(.false.,'order',item)) then
      if(.not.inp_i(iorder)) call md_abort('No iorder specified',0)
      if(.not.inp_i(isel)) call md_abort('No igroup specified',0)
      if(.not.inp_i(jsel)) call md_abort('No jgroup specified',0)
      if(.not.inp_a(atomi)) call md_abort('No iatom specified',0)
      if(.not.inp_a(atomj)) call md_abort('No jatom specified',0)
      if(isel.eq.jsel) call md_abort('Order groups identical',isel)
      write(lfncmd,1028) iorder,isel,jsel 
 1028 format('order  ',i5,2i7)
      write(lfncmd,1029) atomi(1:index(atomi,' ')-1)
      write(lfncmd,1029) atomj(1:index(atomj,' ')-1)
 1029 format(a)
      numcmd=numcmd+1
      goto 2
      endif
c
c     define vectors
c     --------------
c
      if(inp_compare(.false.,'vector',item)) then
      if(.not.inp_i(ivctr)) call md_abort('Error in vector',0)
      if(.not.inp_a(atomi)) call md_abort('Error in vector',0)
      if(.not.inp_a(atomj)) call md_abort('Error in vector',0)
      write(lfncmd,1026) ivctr
 1026 format('vector ',i5)
      write(lfncmd,1027) atomi(1:index(atomi,' ')-1)
      write(lfncmd,1027) atomj(1:index(atomj,' ')-1)
 1027 format(a)
      goto 2
      endif
c
c     define bonds
c     ------------
c
      if(inp_compare(.false.,'bond',item).or.
     + inp_compare(.false.,'distance',item)) then
      if(.not.inp_i(ibond)) call md_abort('Error in bond',0)
      if(.not.inp_a(atomi)) call md_abort('Error in bond',0)
      if(.not.inp_a(atomj)) call md_abort('Error in bond',0)
      write(lfncmd,1012) ibond
 1012 format('bond   ',i5)
      write(lfncmd,1013) atomi(1:index(atomi,' ')-1)
      write(lfncmd,1013) atomj(1:index(atomj,' ')-1)
 1013 format(a)
      goto 2
      endif

c
c     define angles
c     -------------
c
      if(inp_compare(.false.,'angle',item)) then
      if(.not.inp_i(iangl)) call md_abort('Error in angle',0)
      if(.not.inp_a(atomi)) call md_abort('Error in angle',0)
      if(.not.inp_a(atomj)) call md_abort('Error in angle',0)
      if(.not.inp_a(atomk)) call md_abort('Error in angle',0)
      write(lfncmd,1014) iangl
 1014 format('angle  ',i5)
      write(lfncmd,1013) atomi(1:index(atomi,' ')-1)
      write(lfncmd,1013) atomj(1:index(atomj,' ')-1)
      write(lfncmd,1013) atomk(1:index(atomk,' ')-1)
      goto 2
      endif
c
c     define torsions
c     ---------------
c
      if(inp_compare(.false.,'torsion',item)) then
      if(.not.inp_i(itors)) call md_abort('Error in torsion',0)
      if(.not.inp_a(atomi)) call md_abort('Error in torsion',0)
      if(.not.inp_a(atomj)) call md_abort('Error in torsion',0)
      if(.not.inp_a(atomk)) call md_abort('Error in torsion',0)
      if(.not.inp_a(atoml)) call md_abort('Error in torsion',0)
      write(lfncmd,1015) itors
 1015 format('torsio ',i5)
      write(lfncmd,1013) atomi(1:index(atomi,' ')-1)
      write(lfncmd,1013) atomj(1:index(atomj,' ')-1)
      write(lfncmd,1013) atomk(1:index(atomk,' ')-1)
      write(lfncmd,1013) atoml(1:index(atoml,' ')-1)
      goto 2
      endif
c
c     define impropers
c     ----------------
c
      if(inp_compare(.false.,'improper',item)) then
      if(.not.inp_i(iplan)) call md_abort('Error in improper',0)
      if(.not.inp_a(atomi)) call md_abort('Error in improper',0)
      if(.not.inp_a(atomj)) call md_abort('Error in improper',0)
      if(.not.inp_a(atomk)) call md_abort('Error in improper',0)
      if(.not.inp_a(atoml)) call md_abort('Error in improper',0)
      write(lfncmd,1017) iplan
 1017 format('improp ',i5)
      write(lfncmd,1013) atomi(1:index(atomi,' ')-1)
      write(lfncmd,1013) atomj(1:index(atomj,' ')-1)
      write(lfncmd,1013) atomk(1:index(atomk,' ')-1)
      write(lfncmd,1013) atoml(1:index(atoml,' ')-1)
      goto 2
      endif
c
c     charge distribution
c     -------------------
c
      if(inp_compare(.false.,'charge_distribution',item)) then
      if(.not.inp_i(icd)) call md_abort('Error in improper',0)
      write(lfncmd,1018) icd
 1018 format('chgdst ',i5)
      goto 2
      endif
c
c     label atoms
c     -----------
c
      if(inp_compare(.false.,'label',item).or.
     + inp_compare(.false.,'render',item).or.
     + inp_compare(.false.,'color',item)) then
      rtag=0.0d0
      rval=1.0d0
      if(inp_compare(.false.,'render',item)) then
      itag=1
      elseif(inp_compare(.false.,'color',item)) then
      itag=2
      else
      if(.not.inp_i(itag)) call md_abort('Error in label',0)
      endif
      if(.not.inp_a(tag)) call md_abort('Error in label',0)
      iatag=-1
      jatag=-1
      if(inp_i(iatag)) then
      if(.not.inp_i(jatag)) jatag=iatag
      if(.not.inp_f(rtag)) rtag=0.0d0
      else
      if(inp_f(rval)) then
      if(inp_i(iatag)) then
      if(.not.inp_i(jatag)) jatag=iatag
      if(.not.inp_f(rtag)) rtag=0.0d0
      endif
      endif
      endif
      if(.not.inp_a(atom)) atom=' '
    5 continue
      write(lfncmd,1007) itag,tag,rval,iatag,jatag,rtag,
     + atom(1:index(atom,' ')-1)
 1007 format('label  ',i3,a24,f12.6,2i7,f12.6,a)
      numcmd=numcmd+1
      if(atom(1:1).eq.' ') goto 2
      if(inp_a(atom)) goto 5
      goto 2
      endif
c
c     define rotation
c     ---------------
c
      if(inp_compare(.false.,'rotate',item)) then
      if(.not.inp_a(item)) call md_abort('Error in rotate',0)
      if(inp_compare(.false.,'off',item)) then
      write(lfncmd,1588)
 1588 format('rotat0 ')
      numcmd=numcmd+1
      goto 2
      endif
      if(inp_compare(.false.,'x',item)) then
      if(.not.inp_f(arota)) call md_abort('Error in rotate',0)
      write(lfncmd,1587) arota
 1587 format('rotatx ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
      if(inp_compare(.false.,'y',item)) then
      if(.not.inp_f(arota)) call md_abort('Error in rotate',0)
      write(lfncmd,1586) arota
 1586 format('rotaty ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
      if(inp_compare(.false.,'z',item)) then
      if(.not.inp_f(arota)) call md_abort('Error in rotate',0)
      write(lfncmd,1585) arota
 1585 format('rotatz ',f12.6)
      numcmd=numcmd+1
      goto 2
      endif
      endif
c
c     ramachandran analysis
c     ---------------------
c
      if(inp_compare(.false.,'dielectric',item)) then
      write(lfncmd,1089)
 1089 format('diel   ')
      numcmd=numcmd+1
      goto 2
      endif
c
c     ramachandran analysis
c     ---------------------
c
      if(inp_compare(.false.,'ramachandran',item)) then
      write(lfncmd,1088)
 1088 format('rama   ')
      numcmd=numcmd+1
      goto 2
      endif
c
c     root mean square deviation analysis
c     -----------------------------------
c
      if(inp_compare(.false.,'rmsd',item)) then
      write(lfncmd,1008)
 1008 format('rmsdev ')
      numcmd=numcmd+1
      goto 2
      endif
c
c     set hydrogen bond criteria
c     --------------------------
c
      if(inp_compare(.false.,'hbond',item)) then
      if(inp_a(item)) then
 6644 continue
      if(inp_compare(.false.,'distance',item)) then
      if(.not.inp_f(rmin)) call md_abort('Error in hbond',0)
      if(.not.inp_f(rmax)) then
      rmax=rmin
      rmin=0.0d0
      endif
      write(lfncmd,1066) rmin,rmax
 1066 format('hbdist ',2f12.6)
      if(inp_a(item)) goto 6644
      elseif(inp_compare(.false.,'donorangle',item).or.
     + inp_compare(.false.,'angle',item)) then
      if(.not.inp_f(rmin)) call md_abort('Error in hbond',0)
      if(.not.inp_f(rmax)) rmax=3.1416d0
      write(lfncmd,1067) rmin,rmax
 1067 format('hbdang ',2f12.6)
      if(inp_a(item)) goto 6644
      elseif(inp_compare(.false.,'acceptorangle',item)) then
      if(.not.inp_f(rmin)) call md_abort('Error in hbond',0)
      if(.not.inp_f(rmax)) then
      rmax=3.1416d0
      endif
      write(lfncmd,1068) rmin,rmax
 1068 format('hbaang ',2f12.6)
      if(inp_a(item)) goto 6644
      elseif(inp_compare(.false.,'solvent',item)) then
      if(.not.inp_i(nwhb)) nwhb=1
      write(lfncmd,1168) nwhb
 1168 format('numwhb ',i5)
      if(inp_a(item)) goto 6644
      endif
      endif
      write(lfncmd,1069)
 1069 format('hbond  ')
      goto 2
      endif
c
c     average structure
c     -----------------
c
      if(inp_compare(.false.,'average',item)) then
      if(.not.inp_a(item)) call md_abort('No average file',0)
      if(item(1:5).eq.'super') then
      if(.not.inp_a(item)) call md_abort('No average file',0)
      write(lfncmd,1070) item
 1070 format('saver ',a)
      numcmd=numcmd+1
      else
      write(lfncmd,1071) item
 1071 format('aver  ',a)
      numcmd=numcmd+1
      endif
      goto 2
      endif
c
c     essential dynamics analysis
c     ---------------------------
c
      if(inp_compare(.false.,'essential',item)) then
      if(.not.inp_a(item)) item=' ' 
      write(lfncmd,1009) item(1:index(item,' ')-1)
 1009 format('saver  ',/,'covar  ',a)
      numcmd=numcmd+2
      goto 2
      endif
c
c     essential dynamics analysis
c     ---------------------------
c
      if(inp_compare(.false.,'project',item)) then
      if(.not.inp_i(ivec)) call md_abort('No vector specified',0)
      if(.not.inp_a(item)) call md_abort('No projection file',0)
      write(lfncmd,1010) ivec,item(1:index(item,' ')-1)
 1010 format('projec ',i7,a)
      numcmd=numcmd+1
      goto 1
      endif
c
c     electrostatic potential
c     -----------------------     
c
      if(inp_compare(.false.,'esp',item)) then
      if(.not.inp_i(nspac)) nspac=10
      if(.not.inp_f(rcut)) rcut=1.0d0
      iesppb=0
      filplt=' '
      filchg=' '
      if(inp_a(item)) then
      if(inp_compare(.false.,'periodic',item)) then
      if(.not.inp_i(iesppb)) iesppb=3
      if(inp_a(filchg)) then
      if(.not.inp_a(filplt)) filplt=' '
      endif
      else
      filchg=item
      if(.not.inp_a(filplt)) filplt=' '
      endif
      endif
      if(filchg(1:1).ne.' ') then
      if(index(filchg,'.xyzq').le.0)
     + filchg=filchg(1:index(filchg,' ')-1)//'.xyzq '
      if(filplt(1:1).eq.' ')
     + filplt=filchg(1:index(filchg,'.xyzq')-1)//'.plt '
      endif
      if(filplt(1:1).ne.' ') then
      if(index(filplt,'.plt').le.0)
     + filplt=filchg(1:index(filchg,'.xyzq')-1)//'.plt '
      endif
      write(lfncmd,1011) nspac,iesppb,rcut,
     + filchg(1:index(filchg,' ')-1),
     + filplt(1:index(filplt,' ')-1)
 1011 format('espplt ',i4,i4,f12.6,a,' ',a)
      numcmd=numcmd+1
      goto 1
      endif
c
      if(inp_compare(.false.,'index',item)) then
      if(.not.inp_i(indx)) indx=1
      write(lfncmd,1019) indx
 1019 format('index ',i10)
      numcmd=numcmd+1
      goto 2
      endif
c
c     make report
c     -----------
c
      if(inp_compare(.false.,'report',item)) then
      if(.not.inp_a(item)) call md_abort('No report file',0)
      if(.not.inp_a(tag)) tag=' '
      option='        '
      if(inp_compare(.false.,'local',tag)) option='local   '
      write(lfncmd,1031) tag,item(1:index(item,' ')-1)
 1031 format('report ',a8,a)
      numcmd=numcmd+1
      goto 2
      endif
c 
      if(.not.inp_compare(.false.,'end',item)) then
      write(6,1999) item
 1999 format('Unknown field ',a)
      call md_abort('Error reading input file',0)
      endif
c
c     close command file
c
      write(lfncmd,1099)
 1099 format('end    ')
      close(unit=lfncmd)
      if(numcmd.le.0) call md_abort('Error: no analysis commands',0)
c
c     put command file name on rtdb
c     -----------------------------
c
      if(.not.rtdb_cput(irtdb,'ana:filcmd',1,filcmd))
     + call md_abort('Error rtdb_put filcmd failed',0)
c
      return
c
 9999 call md_abort('Error opening command file',0)
c
      return
      end

c
c $Id: paw_utils.F 19707 2010-10-29 17:59:36Z d3y133 $
c

      function find_multipole_energy(l,nrange,g_r,
     >                               power_q1,q1,power_q2,q2,log_amesh) 
      implicit none
      integer           l
      integer           nrange
      double precision  g_r(*)
      integer           power_q2
      double precision  q1(*)
      integer           power_q1
      double precision  q2(*)
      double precision  log_amesh

      double precision find_multipole_energy  !result
    
#include "paw_params.fh"
#include "integrate.fh"
#include "mafdecls.fh"

      !*** local variables ***
      logical ok
      integer   power_f,ii
      integer   q1_l(2)
      integer q2_l(2)
      integer f_tmp(2) 
c      double precision  q1_l(nrange)
c      double precision  q2_l(nrange)
c      double precision  f_tmp(nrange) 
      double precision  w

      ok = MA_push_get(mt_dbl,nrange,
     >                    'q1_l',q1_l(2),q1_l(1))
      if (.not.ok) call errquit('find_multipole_energy: push stack',0,0)
      ok = MA_push_get(mt_dbl,nrange,
     >                    'q2_l',q2_l(2),q2_l(1))
      if (.not.ok) call errquit('find_multipole_energy: push stack',0,0)
      ok = MA_push_get(mt_dbl,nrange,
     >                    'f_tmp',f_tmp(2),f_tmp(1))
      if (.not.ok) call errquit('find_multipole_energy: push stack',0,0)


      call indef_integr(power_q1,q1,l,g_r,log_amesh,
     >         nrange,dbl_mb(q1_l(1)))
      call indef_integr(power_q1,q2,l,g_r,log_amesh,
     >         nrange,dbl_mb(q2_l(1)))

      do ii=1,nrange
        dbl_mb(f_tmp(1)+ii-1) = (q1(ii)*dbl_mb(q2_l(1)+ii-1) + 
     >                           dbl_mb(q1_l(1)+ii-1)*q2(ii))/
     >                           g_r(ii)**(l+1)
      end do
      power_f = power_q1 +  power_q2 

      w = def_integr(power_f,dbl_mb(f_tmp(1)),0,g_r,log_amesh,nrange)
      w = w*FOURPI/(2.0d0*l + 1.0d0)

      find_multipole_energy = w

      ok = MA_pop_stack(f_tmp(2))
      if (.not.ok) call errquit('find_multipole_energy: push stack',0,0)
      ok = MA_pop_stack(q2_l(2))
      if (.not.ok) call errquit('find_multipole_energy: push stack',0,0)
      ok = MA_pop_stack(q1_l(2))
      if (.not.ok) call errquit('find_multipole_energy: push stack',0,0)

      return
      end 

*
* $Id: fci_ofndwt.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_ofind_weight(iwalk,iocc)
      implicit none
#include "fciinfo.fh"
c     
c     find the lexical index of a path on orbital graph
c     for nelec electrons and nactiv orbitals
c     
      integer iwalk             ! [output]
      integer iocc(*)           ! [input]
c
      integer iwgt, irow, iorb
c     
      iwgt = 1
      irow = 1
      do 10 iorb = 1,nactiv
         iwgt = iwgt + karcwt(iocc(iorb),irow,iorb)
         irow = karc(iocc(iorb),irow,iorb)
*        if(irow.le.0) call fci_err('invalid arc in ofind_weight',iwgt)
 10   continue
      if(irow.ne.nelec+1)
     &     call fci_err('invalid tail in ofind_weight',irow)
      iwalk=iwgt
c
      end

*
* $Id: pspw_reformat_c_wvfnc.F 24363 2013-07-05 16:52:27Z bylaska $
*

      logical function  pspw_reformat_c_wvfnc(nbrill)
      implicit none
      integer nbrill

#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
 
*     **** local variables ****
      logical value,oprint,hprint
      character*50 wavefunction_filename,filename
      character*255 full_filename,full_filename2
      character*255 full_filename3
      integer version,ierr
      integer ne(2),ispin,neall
      integer ngrid(3)
      integer cfull(2),cfull_out(2)
      integer nfft3d,n2ft3d,nfft3d_out
      integer n,l,nb,occupation

      double precision unita(3,3)

*     ***** local functions ****
      logical  control_print
      external control_print

      character*50 control_input_psi
      external     control_input_psi


      value = .false.
      hprint = control_print(print_high)
      oprint = control_print(print_medium)



      version = 3  ! or 4


      wavefunction_filename = control_input_psi() 
      call util_file_name_noprefix(wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin,1)
      call iread(5,ne,2)
      call iread(5,occupation,1)
 
      version = 5
      filename = "junk.wvfnc"
      call util_file_name_noprefix(filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)

      l = index(full_filename2,' ') - 1
      call openfile(6,full_filename2,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,ngrid,3)
      call dwrite(6,unita,9)
      call iwrite(6,ispin,1)
      call iwrite(6,ne,2)
      call iwrite(6,nbrill,1)
      call iwrite(6,occupation,1)
       
       nfft3d = ( ngrid(1)/2+1)*ngrid(2)*ngrid(3)
       n2ft3d = 2* nfft3d
       nfft3d_out =  ngrid(1)*ngrid(2)*ngrid(3)

      if (oprint) then
      write(*,*)
      write(*,*) 
     > '+ converting wavefunctions from pspw format to band format'

      end if

      l = index(wavefunction_filename,' ') - 1
      filename = wavefunction_filename(1:l)//".pspw"
      call util_file_name_noprefix(filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename3)

      if (oprint) then
      write(*,109) wavefunction_filename
      write(*,110) filename
      end if
  109 format(' filename converted    : ',A)
  110 format(' pspw filename moved to: ',A)

      neall = ne(1) + ne(2) 
*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull(2),cfull(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d_out,
     >                     'cfull_out',cfull_out(2),cfull_out(1))
      if (.not.value) 
     > call errquit("pspw_reformat_c_wvfnc:push stack",0, MA_ERR)

       
      do nb=1,nbrill
        do n=1,neall

          if (hprint) then
          write(*,111) "converting ... psi:",n," nb:",nb
          end if
  111     format(A,I4,A,I2,A,I4)

          call  dread(5,dcpl_mb(cfull(1)),n2ft3d)
          call  convert_real_to_complex(ngrid(1),ngrid(2),ngrid(3),
     >                                  dcpl_mb(cfull(1)),
     >                                  dcpl_mb(cfull_out(1)))
          call dwrite(6,dcpl_mb(cfull_out(1)),2*nfft3d_out)
        end do
      end do
      call closefile(5)
      call closefile(6)
      value = MA_free_heap(cfull(2))
      value = MA_free_heap(cfull_out(2))

c     *** copy junk.wvfncr to wavefunction_filename ****
      call util_file_copy(full_filename,full_filename3)
      call util_file_copy(full_filename2,full_filename)
      call util_file_unlink(full_filename2)
      IERR=0
      GO TO 9999
 
 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999
 
 9999 IF(IERR.ne.0) THEN
        WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
        value = .false.
      ENDIF
      
      pspw_reformat_c_wvfnc = value
      return 
      end



      logical function  pspw_reformat_c_ewvfnc(nbrill)
      implicit none
      integer nbrill

#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
 
*     **** local variables ****
      logical value,oprint,hprint
      character*50 wavefunction_filename,filename
      character*255 full_filename,full_filename2
      character*255 full_filename3
      integer version,ierr
      integer ne(2),ispin,neall
      integer ngrid(3)
      integer cfull(2),cfull_out(2)
      integer nfft3d,n2ft3d,nfft3d_out
      integer n,l,nb,occupation

      double precision unita(3,3)

*     ***** local functions ****
      logical  control_print
      external control_print

      character*50 control_input_epsi
      external     control_input_epsi

      value = .false.
      hprint = control_print(print_high)
      oprint = control_print(print_medium)

      version = 3  ! or 4

      wavefunction_filename = control_input_epsi() 
      call util_file_name_noprefix(wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin,1)
      call iread(5,ne,2)
      call iread(5,occupation,1)
 
      version = 5
      filename = "junk.wvfnc"
      call util_file_name_noprefix(filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)

      l = index(full_filename2,' ') - 1
      call openfile(6,full_filename2,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,ngrid,3)
      call dwrite(6,unita,9)
      call iwrite(6,ispin,1)
      call iwrite(6,ne,2)
      call iwrite(6,nbrill,1)
      call iwrite(6,occupation,1)
       
       nfft3d = ( ngrid(1)/2+1)*ngrid(2)*ngrid(3)
       n2ft3d = 2* nfft3d
       nfft3d_out =  ngrid(1)*ngrid(2)*ngrid(3)

      if (oprint) then
      write(*,*)
      write(*,*) 
     > '+ converting wavefunctions from pspw format to band format'

      end if

      l = index(wavefunction_filename,' ') - 1
      filename = wavefunction_filename(1:l)//".pspw"
      call util_file_name_noprefix(filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename3)

      if (oprint) then
      write(*,109) wavefunction_filename
      write(*,110) filename
      end if
  109 format(' filename converted    : ',A)
  110 format(' pspw filename moved to: ',A)

      neall = ne(1) + ne(2) 
*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull(2),cfull(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d_out,
     >                     'cfull_out',cfull_out(2),cfull_out(1))
      if (.not.value) 
     > call errquit("pspw_reformat_c_ewvfnc:push stack",0, MA_ERR)

       
      do nb=1,nbrill
        do n=1,neall

          if (hprint) then
          write(*,111) "converting ... psi:",n," nb:",nb
          end if
  111     format(A,I4,A,I2,A,I4)

          call  dread(5,dcpl_mb(cfull(1)),n2ft3d)
          call  convert_real_to_complex(ngrid(1),ngrid(2),ngrid(3),
     >                                  dcpl_mb(cfull(1)),
     >                                  dcpl_mb(cfull_out(1)))
          call dwrite(6,dcpl_mb(cfull_out(1)),2*nfft3d_out)
        end do
      end do
      call closefile(5)
      call closefile(6)
      value = MA_free_heap(cfull(2))
      value = MA_free_heap(cfull_out(2))

c     *** copy junk.wvfncr to wavefunction_filename ****
      call util_file_copy(full_filename,full_filename3)
      call util_file_copy(full_filename2,full_filename)
      call util_file_unlink(full_filename2)
      IERR=0
      GO TO 9999
 
 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999
 
 9999 IF(IERR.ne.0) THEN
        WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
        value = .false.
      ENDIF
      
      pspw_reformat_c_ewvfnc = value
      return 
      end



      logical function  pspw_reformat_c_v_wvfnc(nbrill)
      implicit none
      integer nbrill

#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"

*     **** local variables ****
      logical value,oprint,hprint
      character*50 wavefunction_filename,filename
      character*255 full_filename,full_filename2
      character*255 full_filename3
      integer version,ierr
      integer ne(2),ispin,neall
      integer ngrid(3)
      integer cfull(2),cfull_out(2)
      integer nfft3d,n2ft3d,nfft3d_out
      integer n,l,nb,occupation

      double precision unita(3,3)

*     ***** local functions ****
      logical  control_print
      external control_print

      character*50 control_input_v_psi
      external     control_input_v_psi

      value = .false.
      hprint = control_print(print_high)
      oprint = control_print(print_medium)

      version = 3  ! or 4

      wavefunction_filename = control_input_v_psi()
      call util_file_name_noprefix(wavefunction_filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename)

      l = index(full_filename,' ') - 1
      call openfile(5,full_filename,l,'r',l)
      call iread(5,version,1)
      call iread(5,ngrid,3)
      call dread(5,unita,9)
      call iread(5,ispin,1)
      call iread(5,ne,2)
      call iread(5,occupation,1)

      version = 5
      filename = "junk.wvfnc"
      call util_file_name_noprefix(filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename2)

      l = index(full_filename2,' ') - 1
      call openfile(6,full_filename2,l,'w',l)
      call iwrite(6,version,1)
      call iwrite(6,ngrid,3)
      call dwrite(6,unita,9)
      call iwrite(6,ispin,1)
      call iwrite(6,ne,2)
      call iwrite(6,nbrill,1)
      call iwrite(6,occupation,1)

       nfft3d = ( ngrid(1)/2+1)*ngrid(2)*ngrid(3)
       n2ft3d = 2* nfft3d
       nfft3d_out =  ngrid(1)*ngrid(2)*ngrid(3)


      if (oprint) then
      write(*,*)
      write(*,*)
     > '+ converting wavefunctions from pspw format to band format'

      end if

      l = index(wavefunction_filename,' ') - 1
      filename = wavefunction_filename(1:l)//".pspw"
      call util_file_name_noprefix(filename,
     >                    .false.,
     >                    .false.,
     >                    full_filename3)

      if (oprint) then
      write(*,109) wavefunction_filename
      write(*,110) filename
      end if
  109 format(' filename converted    : ',A)
  110 format(' pspw filename moved to: ',A)

      neall = ne(1) + ne(2)
*     ***** allocate wavefunction memory ****
      value = MA_alloc_get(mt_dcpl,nfft3d,
     >                     'cfull',cfull(2),cfull(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,nfft3d_out,
     >                     'cfull_out',cfull_out(2),cfull_out(1))
      if (.not.value)
     > call errquit("pspw_reformat_c_ewvfnc:push stack",0, MA_ERR)

      do nb=1,nbrill
        do n=1,neall

          if (hprint) then
          write(*,111) "converting ... psi:",n," nb:",nb
          end if
  111     format(A,I4,A,I2,A,I4)

          call  dread(5,dcpl_mb(cfull(1)),n2ft3d)
          call  convert_real_to_complex(ngrid(1),ngrid(2),ngrid(3),
     >                                  dcpl_mb(cfull(1)),
     >                                  dcpl_mb(cfull_out(1)))
          call dwrite(6,dcpl_mb(cfull_out(1)),2*nfft3d_out)
        end do
      end do
      call closefile(5)
      call closefile(6)
      value = MA_free_heap(cfull(2))
      value = MA_free_heap(cfull_out(2))

c     *** copy junk.wvfncr to wavefunction_filename ****
      call util_file_copy(full_filename,full_filename3)
      call util_file_copy(full_filename2,full_filename)
      call util_file_unlink(full_filename2)
      IERR=0
      GO TO 9999

 9110 IERR=10
      GO TO 9999
 9111 IERR=11
      GO TO 9999

 9999 IF(IERR.ne.0) THEN
        WRITE(6,*) ' JOB HAS BEEN TERMINATED DUE TO CODE=',IERR
        value = .false.
      ENDIF

      pspw_reformat_c_v_wvfnc = value
      return
      end








      subroutine convert_real_to_complex(nx,ny,nz,A,B)
      implicit none
      integer nx,ny,nz
      complex*16 A(nx/2+1,ny,nz)
      complex*16 B(nx,ny,nz)

*     **** local variables ****
      integer nxh,nyh,nzh
      integer k1,k2,k3
      integer i,j,k
      integer ii,jj,kk

      nxh = nx/2
      nyh = ny/2
      nzh = nz/2

      call dcopy(2*nx*ny*nz,0.0d0,0,B,1)

      do k3 = -nzh+1,nzh-1
      do k2 = -nyh+1,nyh-1
      do k1 = 0,nxh-1
         i = k1
         j = k2
         k = k3
         if (i .lt. 0) i = i + nx
         if (j .lt. 0) j = j + ny
         if (k .lt. 0) k = k + nz
         B(i+1,j+1,k+1) = A(i+1,j+1,k+1)

         if (k1.ne.0) then
           ii = -k1
           jj = -k2
           kk = -k3
           if (ii .lt. 0) ii = ii + nx
           if (jj .lt. 0) jj = jj + ny
           if (kk .lt. 0) kk = kk + nz
           B(ii+1,jj+1,kk+1) = dconjg(A(i+1,j+1,k+1))
         end if
      end do
      end do
      end do
      return
      end 


 
 

      SUBROUTINE ccsdtq_lr_alpha_15_37_2(d_a,k_a_offset,d_b,k_b_offset,d
     &_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_37_2.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h7 p17 h15 p10 )_yttra + = -1/6 * Sum ( h4 h5 h6 p1 p2 ) * tra ( p1 p2 p17 h4 h5 h6 )_tra * i3 ( h4 h5 h6 h7 h15 p1 p2 p10 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p17b
      INTEGER h7b
      INTEGER h15b
      INTEGER p10b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER p2b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p17b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h7b_2
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER h15b_2
      INTEGER p10b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p17b = noab+1,noab+nvab
      DO h7b = 1,noab
      DO h15b = 1,noab
      DO p10b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+p17b-
     &1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+p10b-1).ne.8)) THEN
      IF (int_mb(k_spin+h7b-1)+int_mb(k_spin+p17b-1) .eq. int_mb(k_spin+
     &h15b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),ieor(int_mb(k_sym+p17b-1),ieor(int_mb
     &(k_sym+h15b-1),int_mb(k_sym+p10b-1)))) .eq. ieor(irrep_y,ieor(irre
     &p_t,irrep_tra))) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+p17b-1) * int_mb(k_r
     &ange+h15b-1) * int_mb(k_range+p10b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_37_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p17b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &) .eq. int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+p17b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb
     &(k_sym+p2b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),in
     &t_mb(k_sym+h6b-1)))))) .eq. irrep_tra) THEN
      CALL TCE_RESTRICTED_6(p17b,p1b,p2b,h4b,h5b,h6b,p17b_1,p1b_1,p2b_1,
     &h4b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_8(h7b,h4b,h5b,h6b,h15b,p10b,p1b,p2b,h7b_2,h4b_
     &2,h5b_2,h6b_2,h15b_2,p10b_2,p1b_2,p2b_2)
      dim_common = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p17b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h7b-1) * int_mb(k_range+h15b-1) * int_m
     &b(k_range+p10b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_37_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_37_2',2,MA_ERR)
      IF ((p2b .le. p17b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p17b_1 - no
     &ab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p17b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),3,6,5,4,2,1,1.0d0)
      END IF
      IF ((p1b .le. p17b) .and. (p17b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - noa
     &b - 1 + nvab * (p17b_1 - noab - 1 + nvab * (p1b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p17b-1),int_mb(k_range+p2b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),2,6,5,4,3,1,-1.0d0)
      END IF
      IF ((p17b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - noa
     &b - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p17b_1 - noab - 1))))))
     &)
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p17b-1
     &),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+h4b-1
     &),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),1,6,5,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_37_2'
     &,3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_37_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_37_2',5,MA_ERR)
      IF ((h6b .le. h7b) .and. (h15b .le. p1b) .and. (p2b .le. p10b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1
     &),int_mb(k_range+p10b-1),8,5,4,3,2,1,7,6,1.0d0)
      END IF
      IF ((h6b .le. h7b) .and. (h15b .le. p1b) .and. (p1b .le. p10b) .an
     &d. (p10b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p10b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p10b-
     &1),int_mb(k_range+p2b-1),7,5,4,3,2,1,8,6,-1.0d0)
      END IF
      IF ((h6b .le. h7b) .and. (p10b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p10b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h7b_2 - 1 + noab * (h6b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p10b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),6,5,4,3,2,1,8,7,1.0d0)
      END IF
      IF ((h5b .le. h7b) .and. (h7b .lt. h6b) .and. (h15b .le. p1b) .and
     &. (p2b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h7b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h7b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1
     &),int_mb(k_range+p10b-1),8,5,3,4,2,1,7,6,-1.0d0)
      END IF
      IF ((h5b .le. h7b) .and. (h7b .lt. h6b) .and. (h15b .le. p1b) .and
     &. (p1b .le. p10b) .and. (p10b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p10b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h7b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h7b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p10b-
     &1),int_mb(k_range+p2b-1),7,5,3,4,2,1,8,6,1.0d0)
      END IF
      IF ((h5b .le. h7b) .and. (h7b .lt. h6b) .and. (p10b .lt. p1b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p10b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h7b_2 - 1 + no
     &ab * (h5b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h7b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p10b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),6,5,3,4,2,1,8,7,-1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (h7b .lt. h5b) .and. (h15b .le. p1b) .and
     &. (p2b .le. p10b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1 + no
     &ab * (h7b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1
     &),int_mb(k_range+p10b-1),8,5,2,4,3,1,7,6,1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (h7b .lt. h5b) .and. (h15b .le. p1b) .and
     &. (p1b .le. p10b) .and. (p10b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p10b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1 + no
     &ab * (h7b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p10b-
     &1),int_mb(k_range+p2b-1),7,5,2,4,3,1,8,6,-1.0d0)
      END IF
      IF ((h4b .le. h7b) .and. (h7b .lt. h5b) .and. (p10b .lt. p1b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p10b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1 + no
     &ab * (h7b_2 - 1 + noab * (h4b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p10b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),6,5,2,4,3,1,8,7,1.0d0)
      END IF
      IF ((h7b .lt. h4b) .and. (h15b .le. p1b) .and. (p2b .le. p10b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p10b_
     &2 - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1 + no
     &ab * (h4b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1
     &),int_mb(k_range+p10b-1),8,5,1,4,3,2,7,6,-1.0d0)
      END IF
      IF ((h7b .lt. h4b) .and. (h15b .le. p1b) .and. (p1b .le. p10b) .an
     &d. (p10b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p10b_2 - noab - 1 + nvab * (p1b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1 + no
     &ab * (h4b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p1b-1),int_mb(k_range+p10b-
     &1),int_mb(k_range+p2b-1),7,5,1,4,3,2,8,6,1.0d0)
      END IF
      IF ((h7b .lt. h4b) .and. (p10b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p10b_2 - noab - 1
     & + nvab * (h15b_2 - 1 + noab * (h6b_2 - 1 + noab * (h5b_2 - 1 + no
     &ab * (h4b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h15b-1),int_mb(k_range+p10b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),6,5,1,4,3,2,8,7,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_37_2'
     &,6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p1b .eq. p2b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,12.0d0/FACTORIAL
     &(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(n
     &subh(2))/FACTORIAL(nsubh(3)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_
     &b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &37_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &37_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_37_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p10b-1
     &),int_mb(k_range+h15b-1),int_mb(k_range+h7b-1),int_mb(k_range+p17b
     &-1),3,4,2,1,-1.0d0/6.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p10b 
     &- noab - 1 + nvab * (h15b - 1 + noab * (p17b - noab - 1 + nvab * (
     &h7b - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_37_2'
     &,10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &37_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE tce_mo2e_zones_4a_disk_ga_chop_act(rtdb,d_v2,
     1                                kax_v2_alpha_offset,
     1                                size_2e)
C     $Id: tce_mo2e_zones_4a_disk_ga_chop_act.F 21409 2011-11-05 06:36:24Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     t ( p1 p2 h3 h4 )_t 
      IMPLICIT NONE
#include "rtdb.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "schwarz.fh"
#include "sym.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
c
c written by K.Kowalski
c
c     max. number of p2 groups =50
c      INTEGER imaxsize,ix
c      INTEGER ptpart,p2length(50),p2dim(50),p2off(50),i,length
c
c p2off - not used
c transposition of l_az2 not necessary
c
      integer rtdb                 ! Run-time database
      integer d_v2                 ! MO integrals
      integer kax_v2_alpha_offset  ! MO integrals offset
      integer size_2e              ! 2e file size
c
      INTEGER size_2g2a,l_2g2a,k_2g2a
      INTEGER azone1,azone2,azone3,azone4
      INTEGER g1b,g2b,g3b,g4b
      INTEGER igi1,igi2,igi3,igi4
      INTEGER ii,i,j,k,l,N,ipos1,ipos2,ipos3,ipos4
      INTEGER del1,del2,p1rel,p2rel
      INTEGER size_4a,l_4a,k_4a
c
      integer mu,nu,rho,sigma
      integer mu_lo,mu_hi
      integer nu_lo,nu_hi
      integer rho_lo,rho_hi
      integer sigma_lo,sigma_hi
      integer mu_range
      integer nu_range
      integer rho_range
      integer sigma_range
      integer mu1,nu1,rho1,sigma1
      integer shift_mu,shift_nu
      integer shift_rho,shift_sigma
      integer work1,work2          ! Work array sizes
      integer l_work1,k_work1      ! Work array 1
      integer l_work2,k_work2      ! Work array 2
      integer imu1,inu1,irho1,isigma1
c
      integer l_movecs_orb,k_movecs_orb
      integer l_gpair,k_gpair
      integer len_pair,g12_shift
c ATTENTION,ACHTUNG,UWAGA 
      integer taskl_az12(5000,2),taskl,igo 
      integer isumr(100,2),idivchop,ipip
c
      integer size_2g2z,l_2g2z,k_2g2z
      integer tot_azone1_sh,tot_azone2_sh
      integer tot_azone3_sh,tot_azone4_sh
      integer ixi,jxi,point_pair
      integer size_stripe,l_p34,k_p34
      integer addr,xoffset_34
      integer size_g3g4,xoffset_p34
      integer size_g4321,k_g4321,l_g4321
c
      integer l_integral,l_coeff
      integer k_integral,k_coeff
      integer size_ic,size_icc,size_integral,size_coeff,max_na
      integer l_aux,k_aux,size_aux,iend
c
      integer iha,ihb !number of corr. alpha, beta holes
      integer ipa,ipb !number of corr. alpha, beta particles
      integer INDEX_PAIR,icol,irow
c compression
      integer xoffset_g12(20000),xoffset_size(20000)
      integer xoffset_size_p1p2(20000)
      integer key_start(20000),key_end(20000)
      integer size_temp,size_temp_4g,xoffset_temp_4g,size_p1p2
      integer max_size_temp,xoffset_temp,iclose,iopen,offset_2g2z
      integer imaxp12,istart,ibuba,sumx
      double precision wall,cpu,wall1,cpu1,wall2,cpu2,wall3,cpu3
c *** debug ***
       double precision xtot1,xtot2,xtot3
c *************
      double precision tot_zone(20000)
      integer l_g12piece,k_g12piece,size_g12p
c - exascale ---
      LOGICAL is_active_4_o
c --------------
c 
      integer l_4af_offset,k_4af_offset,d_4af
      integer sf_chunk,request
      integer key_4af,offset_4af,size_4af,size_max_4ea
      character*255 filename
c 
      logical parallel
c
      INTEGER length
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      EXTERNAL NXTASK
      logical nodezero
      logical idiskl
c
c
c
      parallel = .true.
c
      if(idisk.eq.0) then
       idiskl=.false.
      else
       idiskl=.true.
      end if
c
      max_size_temp=imaxsize**4
c
c
c
      do ii=1,5000
       taskl_az12(ii,1)=0
       taskl_az12(ii,2)=0
      enddo
      do ii=1,20000
       tot_zone(ii)=0.0d0
      enddo
      if(atpart.gt.20000) 
     &  call errquit('tce_zones: atpart too big',1,MA_ERR)
      sumx=0
      do ii=1,atpart
       tot_zone(ii)=sumx
       sumx=sumx+nalength(ii)
      enddo
c
      nodezero=(ga_nodeid().eq.0)
c
      taskl=1
      DO azone3 = 1,atpart      !sigma
      DO azone4 = azone3,atpart !rho
       taskl_az12(taskl,1)=azone3 
       taskl_az12(taskl,2)=azone4
       taskl=taskl+1 
      END DO
      END DO
      taskl=taskl-1
c
      if(taskl.gt.5000) 
     &  call errquit('tce_zones: taskl_z12_1',1,MA_ERR)
      if(ichop.gt.100)
     &  call errquit('tce_zones: ichop problem',1,MA_ERR)
      do ii=1,100
       isumr(ii,1)=0
       isumr(ii,2)=0
      enddo
c
        idivchop=taskl/ichop
        do ii=1,ichop
         if(ii.lt.ichop) then
          isumr(ii,1)=(ii-1)*idivchop+1
          isumr(ii,2)=ii*idivchop
         else
          isumr(ii,1)=(ii-1)*idivchop+1
          isumr(ii,2)=taskl
         end if
        enddo
c
c this module is called only if intorb = .true.
c N is the number of correlated orbitals
        N = nmo(1) - nfc(1) - nfv(1)
        iha = nocc(1)-nfc(1)
        ihb = nocc(ipol)-nfc(ipol)
        ipa = nmo(1)-nocc(1)-nfv(1)
        ipb = nmo(ipol)-nocc(ipol)-nfv(ipol)
c
c     Offset for 4a file
c
cc      sf_chunk=(imaxsize+10)**4
      sf_chunk=(imaxsize)**4
c
      if(nodezero) then
       size_max_4ea=0
       do igo=1,ichop
        call tce_4a_chop_size(size_4af,igo,isumr,taskl_az12)
        if(size_4af.gt.size_max_4ea) size_max_4ea=size_4af
        write(6,*)'next size_4af ====>',size_4af
       enddo
       write(6,*)'size_2e =====',size_2e
      end if
c
      call ga_sync()
c
c
      max_na=0
      do ixi=1,atpart
       if(nalength(ixi).gt.max_na) max_na=nalength(ixi)
      enddo
        size_ic=2*((max_na)**4)+1
        size_icc=tile_dim*max_na
c
       if (.not.ma_push_get(mt_dbl,size_ic,'l_int',
     1  l_integral,k_integral))
     1  call errquit('tce_4s: MA problem l_int',0,MA_ERR)
c
       if (.not.ma_push_get(mt_dbl,size_icc,'l_coeff',
     1  l_coeff,k_coeff))
     1  call errquit('tce_4s: MA problem l_coeff',0,MA_ERR)
c
c
c   MAIN LOOP over partition
c
c
c -------------------------------------------------------------------
       do igo=1,ichop ! ---------------------------------------------
c -------------------------------------------------------------------
c
c
c
c
c
c GA is assumed
       call tce_4a_offset_chop(l_4af_offset,k_4af_offset,size_4af,
     &      igo,isumr,taskl_az12)
c
c
       call createfile(filename,d_4af,size_4af)
       call reconcilefile(d_4af,size_4af)
       call ga_zero(d_4af)
c
c
c
c     Pair's structure of the integral file
      call tce_mo2e_pairs_act(l_gpair,k_gpair,len_pair)
      len_pair = int_mb(k_gpair)
c
c
c alpha orbitals only
c
      if (.not.ma_push_get(mt_dbl,nbf*(iha+ipa)
     1  ,"sorted MO coeffs",
     2  l_movecs_orb,k_movecs_orb))
     3  call errquit('tce_mo2e_zone: MA problem 1',0,
     2    BASIS_ERR)
      call dfill(nbf*(iha+ipa),0.0d0, dbl_mb(k_movecs_orb), 1)
cccx      call dcopy(nbf*(iha+ipa),0.0d0,0,dbl_mb(k_movecs_orb), 1)
      do i=1,iha
      do isigma1=1,nbf
       dbl_mb(k_movecs_orb+(i-1)*nbf+isigma1-1)=
     & dbl_mb(k_movecs_sorted+(i-1)*nbf+isigma1-1)
      enddo
      enddo
      do i=iha+1,iha+ipa
      do isigma1=1,nbf
       dbl_mb(k_movecs_orb+(i-1)*nbf+isigma1-1)=
     & dbl_mb(k_movecs_sorted+(i+ihb-1)*nbf+isigma1-1)
      enddo
      enddo
c
c
      call int_mem_2e4c(work1,work2)
      if (.not.ma_push_get(mt_dbl,work1,'work1',l_work1,k_work1))
     1  call errquit('tce_ao2e: MA problem work1',0,MA_ERR)
      if (.not.ma_push_get(mt_dbl,work2,'work2',l_work2,k_work2))
     1  call errquit('tce_ao2e: MA problem work2',1,MA_ERR)
c
c
c 
c 4af file formed here
c
c
c             cpu1 = - util_cpusec()
c             wall1 = - util_wallsec()
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO azone1 = 1,atpart      !nu
      DO azone2 = azone1,atpart !mu
cccx      DO azone3 = 1,atpart      !sigma
cccx      DO azone4 = azone3,atpart !rho
      DO ipip=isumr(igo,1),isumr(igo,2)
      azone3=taskl_az12(ipip,1)
      azone4=taskl_az12(ipip,2)
      IF (next.eq.count) THEN
c ---------------------------
        size_4a = nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
c        write(6,555) ga_nodeid(),azone1,azone2,azone3,azone4,size_4a
c        call util_flush(6)
c             cpu1 = - util_cpusec()
c             wall1 = - util_wallsec()
        if(.not.ma_push_get(mt_dbl,size_4a,'4a',l_4a,k_4a))
     1     call errquit('tce_4af_zones1: MA problem',0,MA_ERR)
        call dfill(size_4a, 0.0d0, dbl_mb(k_4a), 1)
cccx        call dcopy(size_4a, 0.0d0, 0, dbl_mb(k_4a), 1)
         shift_mu = 0
         do mu    = a2length(azone2)+1,a2length(azone2+1)
            if (.not.bas_cn2bfr(ao_bas_han,mu,mu_lo,mu_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            mu_range = mu_hi - mu_lo + 1
         shift_nu = 0
         do nu    = a2length(azone1)+1,a2length(azone1+1)
            if (.not.bas_cn2bfr(ao_bas_han,nu,nu_lo,nu_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            nu_range = nu_hi - nu_lo + 1
         shift_rho = 0
         do rho   = a2length(azone4)+1,a2length(azone4+1)
            if (.not.bas_cn2bfr(ao_bas_han,rho,rho_lo,rho_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            rho_range = rho_hi - rho_lo + 1
         shift_sigma = 0
         do sigma = a2length(azone3)+1,a2length(azone3+1)
            if (.not.bas_cn2bfr(ao_bas_han,sigma,sigma_lo,sigma_hi))
     1      call errquit('tce_ao2e: basis fn range problem 1',0,
     2      BASIS_ERR)
            sigma_range = sigma_hi - sigma_lo + 1
            if (schwarz_shell(rho,sigma)*schwarz_shell(mu,nu)
     1          .ge. tol2e) then
cccx            call dfill(work1, 0.0d0, dbl_mb(k_work1), 1)
cccx            call dfill(work2, 0.0d0, dbl_mb(k_work2), 1)
            call int_2e4c(ao_bas_han,mu,nu,ao_bas_han,rho,sigma,
     1           work2,dbl_mb(k_work2),work1,dbl_mb(k_work1))
c
            i=0
             do mu1     = 1,mu_range
             do nu1     = 1,nu_range
             do rho1    = 1,rho_range
             do sigma1  = 1,sigma_range
            i=i+1
            inu1=nu1+shift_nu
            isigma1=sigma1+shift_sigma
            imu1=mu1+shift_mu
            irho1=rho1+shift_rho
c (isigma1,irho1|inu1, imu1)
            ipos1=(((imu1-1)*nalength(azone1)+inu1-1)*
     1            nalength(azone4)+irho1-1)*nalength(azone3)
     2            +isigma1
            dbl_mb(k_4a+ipos1-1)=dbl_mb(k_work1+i-1)
            enddo
            enddo
            enddo
            enddo
c
            end if !schwarz  screening
         shift_sigma = shift_sigma + sigma_range
         enddo !sigma
         shift_rho   = shift_rho + rho_range
         enddo !rho
         shift_nu    = shift_nu + nu_range
         enddo !nu
         shift_mu    = shift_mu + mu_range
         enddo !mu
c
c fixing offsets and sf_writing
         key_4af=azone4 - 1 + atpart * (azone3 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
         call tce_hash(int_mb(k_4af_offset),key_4af,offset_4af)
c
        call ga_put(d_4af,offset_4af+1,offset_4af+size_4a,1,1,
     1    dbl_mb(k_4a),1)
c closing l_4a file
        if (.not.ma_pop_stack(l_4a))
     1   call errquit('tcc_mo2e_4af2: l_4a',15,MA_ERR)
c ---------------------------
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO !ipip ==> azone3, azone4
      ENDDO !azone2
      ENDDO !azone1
c
c
       call ga_sync()
c
c
c
      next = nxtask(-nprocs,1)
c
c
      call reconcilefile(d_4af,size_4af)
c
c
c
c
c
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO g3b = 1,noa+nva   !k
      DO g4b = g3b,noa+nva !l
      DO azone1 = 1,atpart !nu
      DO azone2 = azone1,atpart !mu
      IF (next.eq.count) THEN
c
c *** debug ***
c       write(6,777)ga_nodeid(),g3b,g4b,azone1,azone2
c       call util_flush(6)
c *************
c             cpu1 = - util_cpusec()
c             wall1 = - util_wallsec()
c
      size_2g2a=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1          *nalength(azone1)*nalength(azone2)
      if (.not.ma_push_get(mt_dbl,size_2g2a,'2g2a',l_2g2a,k_2g2a))
     1    call errquit('tce_r2_divide1: MA problem',0,MA_ERR)
      call dfill(size_2g2a, 0.0d0, dbl_mb(k_2g2a), 1)
cccx      call dcopy(size_2g2a, 0.0d0, 0,dbl_mb(k_2g2a), 1)
c
cccx      DO azone3 = 1,atpart      !sigma
cccx      DO azone4 = azone3,atpart !rho
      DO ipip=isumr(igo,1),isumr(igo,2)
      azone3=taskl_az12(ipip,1)
      azone4=taskl_az12(ipip,2)
c
        size_4a = nalength(azone1)*nalength(azone2)*
     1            nalength(azone3)*nalength(azone4)
        if(.not.ma_push_get(mt_dbl,size_4a,'4a',l_4a,k_4a))
     1     call errquit('tce_r2_divide2: MA problem',0,MA_ERR)
cccx        call dfill(size_4a, 0.0d0, dbl_mb(k_4a), 1)
cccx        call dcopy(size_4a, 0.0d0, 0, dbl_mb(k_4a), 1)
c TIMINGS ==============================
c             cpu1 = - util_cpusec()
c             wall1 = - util_wallsec()
c ======================================
c
c
c
c
         key_4af=azone4 - 1 + atpart * (azone3 - 1 +
     &          atpart * (azone2 - 1 + atpart * (azone1 - 1)))
         call tce_hash(int_mb(k_4af_offset),key_4af,offset_4af)
c
        call ga_get(d_4af,offset_4af+1,offset_4af+size_4a,1,1,
     1    dbl_mb(k_4a),1)
c
c
       tot_azone3_sh=tot_zone(azone3)
       tot_azone4_sh=tot_zone(azone4)
c
      if(azone3.ne.azone4) then !!============azone3.ne.azone4
c --- C_[g3][sigma]
       i = 0 
       do isigma1 =  1,nalength(azone3)
       do igi3    =  1,int_mb(k_range_alpha+g3b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g3b-1)+igi3-1)*nbf+tot_azone3_sh
     &       +isigma1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c --- C_[g3][sigma]([sigma]<[rho]|[nu] [mu])
c            zone3   zone3  zone4
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g3b-1),  !m
     1 nalength(azone1)*nalength(azone2)*nalength(azone4), !n
     1 nalength(azone3), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g3b-1), !lda
     1 dbl_mb(k_4a),nalength(azone3),          ! B,ldb
     1 0.0d0,dbl_mb(k_integral),
     1 int_mb(k_range_alpha+g3b-1))
c transposition ([g3][rho]|[nu][mu]) => ([rho][g3]|[nu][mu]) 
c
       size_aux=int_mb(k_range_alpha+g3b-1)*nalength(azone4)*
     1          nalength(azone1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux1: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g3b-1),nalength(azone4),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
      do i=1,size_aux
       dbl_mb(k_integral+i-1)=dbl_mb(k_aux+i-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux1',15,MA_ERR)
c C([g4][azone4=rho])
       i = 0
       do irho1   =  1,nalength(azone4)
       do igi4    =  1,int_mb(k_range_alpha+g4b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g4][azone4=rho])([rho][g3]|[azone1][azone2])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g4b-1),  !m
     1 nalength(azone1)*nalength(azone2)*int_mb(k_range_alpha+g3b-1), !n
     1 nalength(azone4), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g4b-1), !lda
     1 dbl_mb(k_integral),nalength(azone4),          ! B,ldb
     1 1.0d0,dbl_mb(k_2g2a),
     1 int_mb(k_range_alpha+g4b-1))
c  done with first  part of azone3.ne.azone4 case ----------------
c  transposition of atomic integrals
c  ([sigma=azone3][rho=azone4]|[nu][mu]) ==>
c  ([rho][sigma]|[nu][mu])
       size_aux=size_4a
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_4a),dbl_mb(k_aux),
     & nalength(azone3),nalength(azone4),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
ccx      if (.not.ma_pop_stack(l_aux))
ccx     1     call errquit('l_aux2',15,MA_ERR) ! see after dgemm
c C([g3][azone4=rho])
       i = 0
       do irho1   =  1,nalength(azone4)
       do igi3    =  1,int_mb(k_range_alpha+g3b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g3b-1)+igi3-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g3][azone4=rho])([rho=azone4][sigma=azone3]|[nu][mu])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g3b-1),  !m
     1 nalength(azone1)*nalength(azone2)*nalength(azone3), !n
     1 nalength(azone4), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g3b-1), !lda
     1 dbl_mb(k_aux),nalength(azone4),          ! B,ldb
     1 0.0d0,dbl_mb(k_integral),
     1 int_mb(k_range_alpha+g3b-1))
c
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c transposition ([g3][sigma]|[nu][mu]) => ([sigma][g3]|[nu][mu])
c
       size_aux=int_mb(k_range_alpha+g3b-1)*nalength(azone3)*
     1          nalength(azone1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux1: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g3b-1),nalength(azone3),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
      do i=1,size_aux
       dbl_mb(k_integral+i-1)=dbl_mb(k_aux+i-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux1',15,MA_ERR)
c C([g4][azone3=sigma])
       i = 0
       do isigma1   =  1,nalength(azone3)
       do igi4    =  1,int_mb(k_range_alpha+g4b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone3_sh
     &       +isigma1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g4][azone3=sigma])([sigma][g3]|[azone1][azone2])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g4b-1),  !m
     1 nalength(azone1)*nalength(azone2)*int_mb(k_range_alpha+g3b-1), !n
     1 nalength(azone3), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g4b-1), !lda
     1 dbl_mb(k_integral),nalength(azone3),          ! B,ldb
     1 1.0d0,dbl_mb(k_2g2a),
     1 int_mb(k_range_alpha+g4b-1))
      end if !azone3.ne.azone4
c
c
c
      if(azone3.eq.azone4) then
c --- C_[g3][sigma]
       i = 0 
       do isigma1 =  1,nalength(azone3)
       do igi3    =  1,int_mb(k_range_alpha+g3b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g3b-1)+igi3-1)*nbf+tot_azone3_sh
     &       +isigma1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c --- C_[g3][sigma]([sigma]=[rho]|[nu] [mu])
c            zone3   zone3  zone4
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g3b-1),  !m
     1 nalength(azone1)*nalength(azone2)*nalength(azone4), !n
     1 nalength(azone3), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g3b-1), !lda
     1 dbl_mb(k_4a),nalength(azone3),          ! B,ldb
     1 0.0d0,dbl_mb(k_integral),
     1 int_mb(k_range_alpha+g3b-1))
c transposition ([g3][rho]|[nu][mu]) => ([rho][g3]|[nu][mu]) 
c
       size_aux=int_mb(k_range_alpha+g3b-1)*nalength(azone4)*
     1          nalength(azone1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux1: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g3b-1),nalength(azone4),
     & nalength(azone1),nalength(azone2),
     &2,1,3,4,1.0d0)
      do i=1,size_aux
       dbl_mb(k_integral+i-1)=dbl_mb(k_aux+i-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux1',15,MA_ERR)
c C([g4][azone4=rho])
       i = 0
       do irho1   =  1,nalength(azone4)
       do igi4    =  1,int_mb(k_range_alpha+g4b-1)
       i = i+1
       ipos1=(int_mb(k_offset_alpha+g4b-1)+igi4-1)*nbf+tot_azone4_sh
     &       +irho1
       dbl_mb(k_coeff+i-1)=dbl_mb(k_movecs_orb+ipos1-1)
       enddo
       enddo
c C([g4][azone4=rho])([rho][g3]|[azone1][azone2])
      call  dgemm('N','N',
     1 int_mb(k_range_alpha+g4b-1),  !m
     1 nalength(azone1)*nalength(azone2)*int_mb(k_range_alpha+g3b-1), !n
     1 nalength(azone4), !k
     1 1.0d0,
     1 dbl_mb(k_coeff),                    !A
     1 int_mb(k_range_alpha+g4b-1), !lda
     1 dbl_mb(k_integral),nalength(azone4),          ! B,ldb
     1 1.0d0,dbl_mb(k_2g2a),
     1 int_mb(k_range_alpha+g4b-1))
      end if !azone3.eq.azone4
c
c
c
        if (.not.ma_pop_stack(l_4a))
     1   call errquit('tcc_mo2e_trans_zones: l_4a',15,MA_ERR)
cccx      ENDDO !azone4
c one step ahead
cccx      ENDDO !azone3
       ENDDO !ipip
c
c
c
c g2 g1 do loops
c open (g4 g3 | all symmetry allowed g2 g1) - equally good we can split it into 
c                                              pieces
c (k,l|i,j) pieces
c
c   calculate point_pair index here
         ixi=noa+nva-g3b+1
         jxi=noa+nva-g4b+1
         point_pair=((noa+nva)*(noa+nva+1))/2-((ixi-1)*ixi)/2-jxi+1
         size_stripe=int_mb(k_gpair+point_pair)
         xoffset_p34 = int_mb(k_gpair+len_pair+point_pair)
         addr=int_mb(k_gpair+2*len_pair+point_pair)
c
c - exascale ---
       if((size_stripe.eq.0).and.(xoffset_p34.eq.0)) go to 300
c ---
c
c
c offset for blocking the (nu mu | g2 g1 ) = C*C matrix
c
      do i=1,1000
       key_start(i) = 0
       key_end(i)   = 0
       xoffset_g12(i)  = 0
       xoffset_size(i) = 0
       xoffset_size_p1p2(i) = 0
      enddo 
      imaxp12=0
      size_temp=0
      size_temp_4g=0
      xoffset_temp=0 
      xoffset_temp_4g=0
      size_p1p2=0
      i=1
      DO g1b = 1,noa+nva   !l
      DO g2b = g1b,noa+nva !k
c - exascale ---
      IF(.not.((g3b.gt.noa).and.(g4b.gt.noa).and.(g1b.gt.noa).and.
     &   (g2b.gt.noa).and.(.not.is_active_4_o(g3b,g4b,g1b,g2b)))) THEN
c ---
       IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     & int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
       IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1)
     & ,ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq.
     & irrep_v) THEN
       IROW=INDEX_PAIR(g4b,g3b)
       ICOL=INDEX_PAIR(g2b,g1b)
       IF(IROW.GE.ICOL) THEN
         if(size_temp_4g.eq.0) then
          key_start(i)=icol
         end if
         size_temp=size_temp+int_mb(k_range_alpha+g2b-1)
     1          *int_mb(k_range_alpha+g1b-1)
     1          *nalength(azone1)*nalength(azone2)
         size_temp_4g=size_temp_4g+int_mb(k_range_alpha+g2b-1)
     1          *int_mb(k_range_alpha+g1b-1)
     2          *int_mb(k_range_alpha+g3b-1) 
     3          *int_mb(k_range_alpha+g4b-1)
         size_p1p2=size_p1p2+int_mb(k_range_alpha+g2b-1)
     1          *int_mb(k_range_alpha+g1b-1)
         ibuba=icol
c
c         if(size_temp.gt.max_size_temp) then
c has to be fully consistent with later part
c
         if(size_temp_4g.gt.max_size_temp) then
           xoffset_g12(i)=xoffset_temp_4g
           xoffset_size(i)=size_temp
           xoffset_size_p1p2(i)=size_p1p2
           xoffset_temp=xoffset_temp+size_temp
           xoffset_temp_4g=xoffset_temp_4g+size_temp_4g
           key_end(i)=icol
           size_temp=0
           size_temp_4g=0
           size_p1p2=0
           imaxp12=i
           i=i+1
          end if
       END IF
       END IF
       END IF
c --- exascale -
       END IF
c --------------
      ENDDO
      ENDDO
c
      if(size_temp_4g.ne.0) then
           xoffset_g12(i)=xoffset_temp_4g
           xoffset_size(i)=size_temp
           xoffset_size_p1p2(i)=size_p1p2
           key_end(i)=ibuba
           imaxp12=i
      end if
c
      if(i.gt.1000) 
     1  call errquit('tce_zone: xoffset-size-problem',0,MA_ERR)
c
c
      do i =1, imaxp12
        size_g12p=int_mb(k_range_alpha+g4b-1)*
     1                int_mb(k_range_alpha+g3b-1)*
     1                xoffset_size_p1p2(i)
        if (.not.ma_push_get(mt_dbl,size_g12p,'g12piece',
     1      l_g12piece,k_g12piece))
     1      call errquit('tce_zone: MA g12-piece ',0,MA_ERR)
c TRY IF THIS CAN BE BY-PASSED
        call dfill(size_g12p, 0.0d0, dbl_mb(k_g12piece), 1)
c
c
c
c
      offset_2g2z=0 !
c
c
c
      iend=0
      istart=0
      DO g1b = 1,noa+nva     !l
      DO g2b = g1b,noa+nva   !k 
       ICOL=INDEX_PAIR(g2b,g1b)
       IF(iend.eq.1) go to 4444
       if(istart.ne.1) then
        IF(ICOL.eq.key_start(i)) istart=1
       end if
       if(icol.eq.key_end(i)) iend=1
       IF(istart.eq.1) THEN
c - exascale ---
      IF(.not.((g3b.gt.noa).and.(g4b.gt.noa).and.(g1b.gt.noa).and.
     &   (g2b.gt.noa).and.(.not.is_active_4_o(g3b,g4b,g1b,g2b)))) THEN
c ---
       IF (int_mb(k_spin_alpha+g3b-1)+int_mb(k_spin_alpha+g4b-1).eq.
     & int_mb(k_spin_alpha+g1b-1)+int_mb(k_spin_alpha+g2b-1)) THEN
       IF (ieor(int_mb(k_sym_alpha+g3b-1),ieor(int_mb(k_sym_alpha+g4b-1)
     & ,ieor(int_mb(k_sym_alpha+g1b-1),int_mb(k_sym_alpha+g2b-1)))) .eq.
     & irrep_v) THEN
       IROW=INDEX_PAIR(g4b,g3b)
       ICOL=INDEX_PAIR(g2b,g1b)
       IF(IROW.GE.ICOL) THEN
        tot_azone1_sh=tot_zone(azone1)
        tot_azone2_sh=tot_zone(azone2)
       if(azone1.ne.azone2) then !-----------------
c C_([mu-azone2][g2])
        ii=0
        do igi2    =  1,int_mb(k_range_alpha+g2b-1)
        do imu1    =  1,nalength(azone2)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone2_sh
     &           +imu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo 
c ([g4][g3]|[nu-azone1][mu-azone2])*C_([mu-azone2][g2])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   nalength(azone1),                                        !m
     1   int_mb(k_range_alpha+g2b-1),                             !n
     3   nalength(azone2),                                        !k
     4   1.0d0,dbl_mb(k_2g2a),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   nalength(azone1),
     6   dbl_mb(k_coeff),nalength(azone2),
     7   0.0d0,dbl_mb(k_integral),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   nalength(azone1))
c transposition ([g4][g3]|[nu-azone1][g2])=>([g4][g3]|[g2][nu-azone1])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *int_mb(k_range_alpha+g2b-1)*nalength(azone1)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     &int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1), 
     &nalength(azone1),int_mb(k_range_alpha+g2b-1), 
     &1,2,4,3,1.0d0)
      do ii=1,size_aux
       dbl_mb(k_integral+ii-1)=dbl_mb(k_aux+ii-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c C_([nu-azone1][g1])
        ii=0
        do igi1    =  1,int_mb(k_range_alpha+g1b-1)
        do inu1    =  1,nalength(azone1)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g1b-1)+igi1-1)*nbf+tot_azone1_sh
     &           +inu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[g2][nu-azone1])*C_([nu-azone1][g1])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   int_mb(k_range_alpha+g2b-1),                             !m
     1   int_mb(k_range_alpha+g1b-1),                             !n
     3   nalength(azone1),                                        !k
     4   1.0d0,dbl_mb(k_integral),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   int_mb(k_range_alpha+g2b-1),
     6   dbl_mb(k_coeff),nalength(azone1),
     7   1.0d0,dbl_mb(k_g12piece+offset_2g2z),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   int_mb(k_range_alpha+g2b-1))
c done with first  part of azone3.ne.azone4 case ----------------
c  transposition of atomic integrals
c  ([g4][g3]|[azone1-nu][azone2-mu]) ==>
c  ([g4][g3]|[azone2-mu][azone1-nu])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *nalength(azone1)*nalength(azone2) 
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_2g2a),dbl_mb(k_aux),
     & int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1),
     & nalength(azone1),nalength(azone2), 
     & 1,2,4,3,1.0d0)
ccx      if (.not.ma_pop_stack(l_aux))
ccx     1     call errquit('l_aux2',15,MA_ERR) ! see after dgemm
c C([azone1-nu][g2])
        ii=0
        do igi2    =  1,int_mb(k_range_alpha+g2b-1)
        do inu1    =  1,nalength(azone1)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone1_sh
     &           +inu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[azone2-mu][azone1-nu])*C([azone1-nu][g2])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   nalength(azone2),                                        !m
     1   int_mb(k_range_alpha+g2b-1),                             !n
     3   nalength(azone1),                                        !k
     4   1.0d0,dbl_mb(k_aux),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   nalength(azone2),
     6   dbl_mb(k_coeff),nalength(azone1),
     7   0.0d0,dbl_mb(k_integral),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   nalength(azone2))
c
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c transposition ([g4][g3]|[azone2-mu][g2])=>([g4][g3]|[g2][azone2-mu])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *int_mb(k_range_alpha+g2b-1)*nalength(azone2)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     &int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1),
     &nalength(azone2),int_mb(k_range_alpha+g2b-1),
     &1,2,4,3,1.0d0)
      do ii=1,size_aux
       dbl_mb(k_integral+ii-1)=dbl_mb(k_aux+ii-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c C([azone2-mu][g1])
        ii=0
        do igi1    =  1,int_mb(k_range_alpha+g1b-1)
        do imu1    =  1,nalength(azone2)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g1b-1)+igi1-1)*nbf+tot_azone2_sh
     &           +imu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[g2][azone2-mu])*C([azone2-mu][g1])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   int_mb(k_range_alpha+g2b-1),                             !m
     1   int_mb(k_range_alpha+g1b-1),                             !n
     3   nalength(azone2),                                        !k
     4   1.0d0,dbl_mb(k_integral),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   int_mb(k_range_alpha+g2b-1),
     6   dbl_mb(k_coeff),nalength(azone2),
     7   1.0d0,dbl_mb(k_g12piece+offset_2g2z),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   int_mb(k_range_alpha+g2b-1))
c
        offset_2g2z=offset_2g2z+int_mb(k_range_alpha+g4b-1)*
     1    int_mb(k_range_alpha+g3b-1)*int_mb(k_range_alpha+g2b-1)*
     1    int_mb(k_range_alpha+g1b-1)
       end if ! azone1.ne.azone2 !-----------------
c
c second part 
c
        if(azone1.eq.azone2) then
c C_([mu-azone2][g2])
        ii=0
        do igi2    =  1,int_mb(k_range_alpha+g2b-1)
        do imu1    =  1,nalength(azone2)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g2b-1)+igi2-1)*nbf+tot_azone2_sh
     &           +imu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo 
c ([g4][g3]|[nu-azone1][mu-azone2])*C_([mu-azone2][g2])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   nalength(azone1),                                        !m
     1   int_mb(k_range_alpha+g2b-1),                             !n
     3   nalength(azone2),                                        !k
     4   1.0d0,dbl_mb(k_2g2a),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   nalength(azone1),
     6   dbl_mb(k_coeff),nalength(azone2),
     7   0.0d0,dbl_mb(k_integral),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   nalength(azone1))
c transposition ([g4][g3]|[nu-azone1][g2])=>([g4][g3]|[g2][nu-azone1])
       size_aux=int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)
     1 *int_mb(k_range_alpha+g2b-1)*nalength(azone1)
       if(.not.ma_push_get(mt_dbl,size_aux,'aux',l_aux,k_aux))
     1     call errquit('tce_aux2: MA problem',0,MA_ERR)
      CALL TCE_SORT_4KG_(dbl_mb(k_integral),dbl_mb(k_aux),
     &int_mb(k_range_alpha+g4b-1),int_mb(k_range_alpha+g3b-1), 
     &nalength(azone1),int_mb(k_range_alpha+g2b-1), 
     &1,2,4,3,1.0d0)
      do ii=1,size_aux
       dbl_mb(k_integral+ii-1)=dbl_mb(k_aux+ii-1)
      enddo
      if (.not.ma_pop_stack(l_aux))
     1     call errquit('l_aux2',15,MA_ERR)
c C_([nu-azone1][g1])
        ii=0
        do igi1    =  1,int_mb(k_range_alpha+g1b-1)
        do inu1    =  1,nalength(azone1)
         ii = ii+1
         ipos1=(int_mb(k_offset_alpha+g1b-1)+igi1-1)*nbf+tot_azone1_sh
     &           +inu1
         dbl_mb(k_coeff+ii-1)=dbl_mb(k_movecs_orb+ipos1-1)
        enddo
        enddo
c ([g4][g3]|[g2][nu-azone1])*C_([nu-azone1][g1])
         call dgemm('N','N',
     1   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     1   int_mb(k_range_alpha+g2b-1),                             !m
     1   int_mb(k_range_alpha+g1b-1),                             !n
     3   nalength(azone1),                                        !k
     4   1.0d0,dbl_mb(k_integral),
     5   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     5   int_mb(k_range_alpha+g2b-1),
     6   dbl_mb(k_coeff),nalength(azone1),
     7   1.0d0,dbl_mb(k_g12piece+offset_2g2z),
     8   int_mb(k_range_alpha+g4b-1)*int_mb(k_range_alpha+g3b-1)*
     8   int_mb(k_range_alpha+g2b-1))
c
        offset_2g2z=offset_2g2z+int_mb(k_range_alpha+g4b-1)*
     1    int_mb(k_range_alpha+g3b-1)*int_mb(k_range_alpha+g2b-1)*
     1    int_mb(k_range_alpha+g1b-1)
c
        end if !azone1.eq.azone2
c !---------------------------------------------------------------------
       END IF ! irow.gt.icol
       END IF ! symmetry
       END IF ! spin
c --- exascale -
       END IF
c --------------
       END IF ! istart
      ENDDO  ! g2b-loop ends up here
      ENDDO  ! g1b-loop ends up here
c 
 4444 continue
c
c now put here add_block
      call add_block(d_v2,dbl_mb(k_g12piece),size_g12p,
     &               xoffset_p34+xoffset_g12(i))
      istart=0
c
c
cccx         if (.not.ma_pop_stack(l_2g2z))
cccx     1   call errquit('tcc_mo2e_trans_zones: l_2g2z',15,MA_ERR)
         if (.not.ma_pop_stack(l_g12piece))
     1   call errquit('tcc_mo2e_trans_zones: l_g12piece',15,MA_ERR)
      ENDDO  ! i = 1,imaxp12 
c
c - exascale ---
 300   continue
c ---
c

      if (.not.ma_pop_stack(l_2g2a))
     1  call errquit('tcc_mo2e_trans_zones: MA problem',15,MA_ERR)
c
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      ENDDO !azone2
      ENDDO !azone1
      ENDDO !g4b
      ENDDO !g3b
c
      next = nxtask(-nprocs,1)
c
c      if(.not.idiskl) then
         call reconcilefile(d_v2,size_2e)
c      end if
c
c *** debug ***
c
c      if(nodezero) then
c      write(6,*)'DONE --- DONE ---- DONE ---- DONE'
c      end if
c
c *************
      if (.not.ma_pop_stack(l_work2))
     1  call errquit('tcc_ao2e: MA problem',14,MA_ERR)
      if (.not.ma_pop_stack(l_work1))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_movecs_orb))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_gpair))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
c
c
       call deletefile(d_4af)
c
c
c
      if (.not.ma_pop_stack(l_4af_offset))
     1  call errquit('tcc_ao2e: MA problem',15,MA_ERR)
c
       call ga_sync()
c
c --------------------------------------------------------
       enddo ! igo loop ----------------------------------
c --------------------------------------------------------
c
c
      if (.not.ma_pop_stack(l_coeff))
     1  call errquit('tcc_off_4a: MA problem',15,MA_ERR)
c
      if (.not.ma_pop_stack(l_integral))
     1  call errquit('tcc_off_4a: MA problem',15,MA_ERR)
c
c
c
      call ga_sync()
c *** debug ***
c 800  format('DGEMM1 MAX',i5,2x,3f15.5)
c 801  format('DGEMM2 ',i5,2x,3f15.5)
 9000 format('PART1',i4,1x,'Cpu  wall ',2(f17.12,1x),3x,'g4b g3b',2i5)
c 9001 format('PART2',i4,1x,'Cpu  wall ',2(f17.12,1x),3x,'g4b g3b',2i5)
c 9003 format('PART1-4a',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9004 format('PART1-2g2z',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9005 format('PART1-dgemm',i4,1x,'Cpu  wall ',2(f17.12,1x))
c 9010 format('  P1-mnrs',i3,1x,2i5,1x,2i5,1x,'Cpu  wall ',2(f17.12,1x))
  555  format('atom loop ',2x,i5,3x,2i5,3x,2i5,i12)
  556  format('atom time',2x,i5,3x,2i5,3x,2i5,'Cpu wall ',2(f12.7,1x))
  777  format('main do loop ',2x,i5,3x,2i5,3x,2i5)
  775  format('main loop step1 ',2x,i5,3x,2i5,3x,2i5)
  776  format('main loop step2 ',2x,i5,3x,2i5,3x,2i5)
  778  format('PART1',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',2(f17.12,1x))
  779  format('PART2',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',2(f17.12,1x))
  780  format('ADD BLOCK',2x,i5,3x,2i5,3x,2i5,2x,'Cpu  wall ',
     &        2(f17.12,1x))
c *************
c
      RETURN
      END
c
c

*
* $Id: integrate_stress.F 24639 2013-10-12 00:43:28Z bylaska $
*

*     **********************************
*     *                                *
*     *        integrate_stress        *
*     *                                *
*     **********************************

      subroutine integrate_stress(version,rlocal,
     >                            nrho,drho,lmax,locp,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nfft1,nfft2,nfft3,lmmax,
     >                            G,dvl,dvnl,
     >                            semicore,rho_sc_r,rho_sc_k,
     >                            ierr)
      implicit none
#include "errquit.fh"
      integer          version
      double precision rlocal
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:lmax)
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nfft1,nfft2,nfft3,lmmax
      double precision G(nfft1/2+1,nfft2,nfft3,3)
      double precision dvl(nfft1/2+1,nfft2,nfft3)
      double precision dvnl(nfft1/2+1,nfft2,nfft3,3,lmmax)

      logical semicore
      double precision rho_sc_r(nrho,2)
      double precision rho_sc_k(nfft1/2+1,nfft2,nfft3,4)

      integer ierr

      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      integer lcount,task_count,nfft3d
      integer k1,k2,k3,i,l
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3,p,pp
      double precision gx,gy,gz,a,q,d,dd
      double precision duxdGx,duxdGy,duxdGz
      double precision duydGx,duydGy,duydGz
      double precision duzdGx,duzdGy,duzdGz
      double precision sumx,sumy,sumz
      double precision T,dTdux,dTduy,dTduz

*     **** external functions ****
      double precision dsum,simp
      external         dsum,simp

      if (version.ne.3) then
         call errquit('integrate_stress - unit cell is aperiodic',0,
     &       INPUT_ERR)
      end if
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      nfft3d = (nfft1/2+1)*nfft2*nfft3
      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi

      IF(LMMAX.GT.16) THEN
        IERR=1
        RETURN
      ENDIF
      IF((nrho/2)*2.Eq.nrho) THEN
        IERR=2
        RETURN
      ENDIF

      P0=dsqrt(forpi)
      P1=dsqrt(3.0d0*forpi)
      P2=dsqrt(15.0d0*forpi)
      P3=dsqrt(105.0d0*forpi)

*::::::::::::::::::  Define non-local pseudopotential  ::::::::::::::::
      do l=0,lmax
        if (l.ne.locp) then
          do I=1,nrho
            vp(i,l)=vp(i,l)-vp(i,locp)
          end do
        end if
      end do

*======================  Fourier transformation  ======================
      call dcopy(nfft3d,0.0d0,0,dvl,1)
      call dcopy(3*lmmax*nfft3d,0.0d0,0,dvnl,1)
      call dcopy(4*nfft3d,0.0d0,0,rho_sc_k,1)
      task_count = -1
      DO 700 k3=1,nfft3
      DO 700 k2=1,nfft2
      DO 700 k1=1,(nfft1/2+1)
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        q=DSqRT(G(k1,k2,k3,1)**2
     >         +G(k1,k2,k3,2)**2
     >         +G(k1,k2,k3,3)**2)

        if ((k1.eq.1).and.(k2.eq.1).and.(k3.eq.1)) go to 700

        
        gx=G(k1,k2,k3,1)/q
        gy=G(k1,k2,k3,2)/q
        gz=G(k1,k2,k3,3)/q
        DO i=1,nrho
          cs(i)=DCOS(q*rho(i))
          sn(i)=DSIN(q*rho(i))
        END DO

*       **** calculate du_r/dG_s ****
        duxdGx = 1.0d0/q -gx*gx/q
        duxdGy = -gx*gy/q
        duxdGz = -gx*gz/q

        duydGx = -gy*gx/q
        duydGy = 1.0d0/q - gy*gy/q
        duydGz = -gy*gz/q

        duzdGx = -gz*gx/q
        duzdGy = -gz*gy/q
        duzdGz = 1.0d0/q - gz*gz/q

        lcount = lmmax+1
        GO TO (500,400,300,200), LMAX+1


*::::::::::::::::::::::::::::::  f-wave  ::::::::::::::::::::::::::::::
  200   CONTINUE
        if (locp.ne.3) then
           F(1)=0.0d0
           do i=2,nrho
             A=sn(i)/(q*rho(i))
             A=15.0d0*(A-cs(i))/(q*rho(i))**2 - 6*A + cs(i)
             f(i)=A*wp(i,3)*vp(i,3)
           end do
           D=P3*SIMP(nrho,F,drho)/q

           F(1)=0.0d0
           do i=2,nrho
             A= -60.0d0*sn(i)/(rho(i)**3 * q**5)
     >        +  60.0d0*cs(i)/(rho(i)**2 * q**4)
     >        +  27.0d0*sn(i)/(rho(i)    * q**3)
     >        -   7.0d0*cs(i)/(q**2)
     >        -   rho(i)*sn(i)/q
             f(i)=A*wp(i,3)*vp(i,3)
           end do
           DD=P3*SIMP(nrho,F,drho)

           lcount = lcount-1
           T = gy*(3.0d0*(1.0d0-gz*gz)-4.0d0*gy*gy)/dsqrt(24.0d0)
           dTdux = 0.0d0
           dTduy = (3.0d0*(1.0d0-gz*gz)-12.0d0*gy*gy)/dsqrt(24.0d0)
           dTduz = -6.0d0*gy*gz/dsqrt(24.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =gx*gy*gz 
           dTdux = gy*gz
           dTduy = gx*gz
           dTduz = gx*gy
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T = gy*(5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0)
           dTdux = 0.0d0
           dTduy =(5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0)
           dTduz =10.0d0*gy*gz/dsqrt(40.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =gz*(5.0d0*gz*gz-3.0d0)/dsqrt(60.0d0)
           dTdux = 0.0d0
           dTduy = 0.0d0
           dTduz =(15.0d0*gz*gz -3.0d0)/dsqrt(60.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =  gx*(5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0) 
           dTdux = (5.0d0*gz*gz-1.0d0)/dsqrt(40.0d0)
           dTduy = 0.0d0
           dTduz = 10.0d0*gx*gz/dsqrt(40.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T =gz*(gx*gx - gy*gy)/2.0d0 
           dTdux =  gx*gz
           dTduy = -gy*gz
           dTduz = (gx*gx-gy*gy)/2.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

           lcount = lcount-1
           T = gx*(4.0d0*gx*gx - 3.0d0*(1.0d0-gz*gz))/dsqrt(24.0d0)
           dTdux = (12.0d0*gx*gx-3.0d0*(1.0d0-gz*gz))/dsqrt(24.0d0)
           dTduy = 0.0d0
           dTduz = 6.0d0*gx*gz/dsqrt(24.0d0)
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
           dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
           dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

        end if



*::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
  300   CONTINUE
        if (locp.ne.2) then
          F(1)=0.0d0
          DO i=2,nrho
            A=3.0d0*(sn(i)/(q*rho(i))-cs(i))/(q*rho(i))-sn(i)
            f(i)=A*wp(i,2)*vp(i,2)
          END DO
          D=P2*SIMP(nrho,F,drho)/q

          F(1)=0.0d0
          DO i=2,nrho
            A= -9.0d0*sn(i)/(rho(i)**2 * q**4)
     >       +  9.0d0*cs(i)/(rho(i)    * q**3)
     >       +  4.0d0*sn(i)/(q**2)
     >       -  rho(i)*cs(i)/q
            f(i)=A*wp(i,2)*vp(i,2)
          END DO
          DD=P2*SIMP(nrho,F,drho)

          lcount = lcount-1
          T = gx*gy
          dTdux = gy
          dTduy = gx
          dTduz = 0.0d0
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = gy*gz
          dTdux = 0.0d0
          dTduy = gz
          dTduz = gy
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = (3.0d0*gz*gz-1.0d0)/(2.0d0*dsqrt(3.0d0)) 
          dTdux = 0.0d0
          dTduy = 0.0d0
          dTduz = 6.0d0*gz/(2.0d0*dsqrt(3.0d0))
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = gz*gx
          dTdux = gz
          dTduy = 0.0d0
          dTduz = gx
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz

          lcount = lcount-1
          T = (gx*gx-gy*gy)/2.0d0
          dTdux = gx
          dTduy = -gy
          dTduz = 0.0d0
          sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
          sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
          sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
          dvnl(k1,k2,k3,1,lcount)=DD*T*gx + D*sumx
          dvnl(k1,k2,k3,2,lcount)=DD*T*gy + D*sumy
          dvnl(k1,k2,k3,3,lcount)=DD*T*gz + D*sumz
        end if

*::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
  400   CONTINUE
        if (locp.ne.1) then
           F(1)=0.0d0
           DO i=2,nrho
             f(i)=(sn(i)/(q*rho(i)) - cs(i)) * wp(i,1)*vp(i,1)
           END DO
           P=P1*SIMP(nrho,F,drho)/q

           F(1)=0.0d0
           DO i=2,nrho
             f(i)=wp(i,1)*vp(i,1)* ( -2.0d0*sn(i)/(rho(i) * q**3)
     >                              + 2.0d0*cs(i)/(q**2)
     >                              + rho(i)*sn(i)/q)
           END DO
           PP=P1*SIMP(nrho,F,drho)

           lcount = lcount-1
           T = gy
           dTdux = 0.0d0
           dTduy = 1.0d0
           dTduz = 0.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)= PP*T*gx + P*sumx
           dvnl(k1,k2,k3,2,lcount)= PP*T*gy + P*sumy
           dvnl(k1,k2,k3,3,lcount)= PP*T*gz + P*sumz

           lcount = lcount-1
           T = gz
           dTdux = 0.0d0
           dTduy = 0.0d0
           dTduz = 1.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)= PP*T*gx + P*sumx
           dvnl(k1,k2,k3,2,lcount)= PP*T*gy + P*sumy
           dvnl(k1,k2,k3,3,lcount)= PP*T*gz + P*sumz

           lcount = lcount-1
           T = gx
           dTdux = 1.0d0
           dTduy = 0.0d0
           dTduz = 0.0d0
           sumx = dTdux*duxdGx + dTduy*duydGx + dTduz*duzdGx
           sumy = dTdux*duxdGy + dTduy*duydGy + dTduz*duzdGy
           sumz = dTdux*duxdGz + dTduy*duydGz + dTduz*duzdGz
           dvnl(k1,k2,k3,1,lcount)= PP*T*gx + P*sumx
           dvnl(k1,k2,k3,2,lcount)= PP*T*gy + P*sumy
           dvnl(k1,k2,k3,3,lcount)= PP*T*gz + P*sumz

        end if

*::::::::::::::::::::::::::::::  s-wave  :::::::::::::::::::::::::::::::
  500   CONTINUE
        if (locp.ne.0) then
          DO i=1,nrho
            f(i)=wp(i,0)*vp(i,0) * ( -sn(i)/(q**2) 
     >                              + rho(i)*cs(i)/q)
          END DO
          P = P0*SIMP(nrho,F,drho)
          lcount = lcount-1
          dvnl(k1,k2,k3,1,lcount) = P *gx
          dvnl(k1,k2,k3,2,lcount) = P *gy
          dvnl(k1,k2,k3,3,lcount) = P *gz
        end if

*::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
  600   CONTINUE

        do  i=1,nrho
          f(i)=rho(i)*vp(i,locp)*(rho(i)*cs(i)-sn(i)/q)
        end do
        dvl(k1,k2,k3)= SIMP(nrho,f,drho)*forpi/q
     >   + zv*forpi/(q*q)*(2.0d0*cs(nrho)/q + rho(nrho)*sn(nrho))
 


*::::::::::::::::::::: semicore density :::::::::::::::::::::::::::::::
        if (semicore) then
           
           do  i=1,nrho
             f(i)=rho(i)*dsqrt(rho_sc_r(i,1))*(rho(i)*cs(i)-sn(i)/q)
           end do
           rho_sc_k(k1,k2,k3,1)= SIMP(nrho,f,drho)*forpi/q
        end if
    
  700 CONTINUE

      call Parallel_Vector_SumAll(4*nfft3d,rho_sc_k)
      call Parallel_Vector_SumAll(nfft3d,dvl)
      call Parallel_Vector_Sumall(3*lmmax*nfft3d,dvnl)

*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      
      dvl(1,1,1)= 0.0d0
      do l=1,lmmax
        dvnl(1,1,1,1,l)=0.0d0
        dvnl(1,1,1,2,l)=0.0d0
        dvnl(1,1,1,3,l)=0.0d0
      end do


      IERR=0
      RETURN
      END

C> \ingroup selci
C> @{
C>
      subroutine selci_eijkj(e,i,k,j,ns,indbar,iocc,
     $     w1,w2,work,numf,numf2)
*
* $Id: eijkj.F 24780 2013-11-07 21:23:59Z d3y133 $
*
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
      dimension e(*),indbar(*),iocc(*),work(*),
     $     w1(nfmax,nfmax,nsmax),w2(nfmax2,nfmax,nsmax-1)
c
c     e(u,v) = <Iu|Eij,kj|Iv>, where u,v label the spin functions
c     and the orbital occupation of I is specified by ns, iocc
c     and indbar. Only for i.ne.j.ne.k. i and k are assumed
c     to be in order of decreasing occupaion in I
c
c     Note that this value is independent of j and can be simplified later
c
c     possible cases are:
c
c     iocc(i)  iocc(k)  case
c       1         1       1
c       3         1       2
c       3         3       3
c
      numf = nf(ns)
      icase = (iocc(i)+iocc(k))/2
      goto (10,20,30) icase
      call errquit('eijkj: invalid case',icase, INPUT_ERR)
c
c     ni=1, nk=1: e(u,v) = w1(u,q,ib)*w1(q,p,kb)*w1(s,p,jb)*w2(v,s,jb)
c
 10   continue
      numf2 = nf(ns-2)
      ib = indbar(i) + (nsmax-ns)
      kb = indbar(k) + (nsmax-ns)
      if (k.gt.i) kb = kb - 1
      jb = indbar(j) + (nsmax-ns)
      if (j.gt.i) jb = jb - 1
      if (j.gt.k) jb = jb - 1
*      call selci_mxma(w1(1,1,ib),1,nfmax,w1(1,1,kb),1,nfmax,
*     $     e,1,numf,numf,numf,numf)
      call selci_axb(w1(1,1,ib),nfmax,w1(1,1,kb),nfmax,
     $     e,numf,numf,numf,numf)
*      call selci_mxma(e,1,numf,w1(1,1,jb),nfmax,1,
*     $     work,1,numf,numf,numf,numf)
      call selci_axbt(e,numf,w1(1,1,jb),nfmax,
     $     work,numf,numf,numf,numf)
*      call selci_mxma(work,1,numf,w2(1,1,jb),nfmax2,1,
*     $     e,1,numf,numf,numf,numf2)
      call selci_axbt(work,numf,w2(1,1,jb),nfmax2,
     $     e,numf,numf,numf,numf2)
      return
c
c     ni=2, nk=1: e(u,v) = w2(u,q,ib)*w1(q,p,kb)*w1(s,p,jb)*w2(v,s,jb)
c
 20   continue
      numf2 = nf(ns+2)
      ib = indbar(i) + (nsmax-ns-2)
      kb = indbar(k) + (nsmax-ns-2)
      if (k.gt.i) kb = kb + 1
      jb = indbar(j) + (nsmax-ns-2)
      if (j.gt.i) jb = jb + 1
      if (j.gt.k) jb = jb - 1
*      call selci_mxma(w2(1,1,ib),1,nfmax2,w1(1,1,kb),1,nfmax,
*     $     e,1,numf,numf,numf2,numf2)
      call selci_axb(w2(1,1,ib),nfmax2,w1(1,1,kb),nfmax,
     $     e,numf,numf,numf2,numf2)
*      call selci_mxma(e,1,numf,w1(1,1,jb),nfmax,1,
*     $     work,1,numf,numf,numf2,numf2)
      call selci_axbt(e,numf,w1(1,1,jb),nfmax,
     $     work,numf,numf,numf2,numf2)
*      call selci_mxma(work,1,numf,w2(1,1,jb),nfmax2,1,
*     $     e,1,numf,numf,numf2,numf)
      call selci_axbt(work,numf,w2(1,1,jb),nfmax2,
     $     e,numf,numf,numf2,numf)
      numf2 = numf
      return
c
c     ni=2, nk=2: e(u,v) = w2(u,q,ib)*w2(q,p,kb)*w1(s,p,jb)*w2(v,s,jb)
c                       iikk   ->  kkia   ->  ikab    ->  ijka   ->  jjik
c
 30   continue
      numf2 = nf(ns+2)
      numf4 = nf(ns+4)
      ib = indbar(i) + (nsmax-ns-2)
      kb = indbar(k) + (nsmax-ns-4)
      if (k.gt.i) kb = kb + 1
      jb = indbar(j) + (nsmax-ns-4)
      if (j.gt.i) jb = jb + 1
      if (j.gt.k) jb = jb + 1
*      call selci_mxma(w2(1,1,ib),1,nfmax2,w2(1,1,kb),1,nfmax2,
*     $     e,1,numf,numf,numf2,numf4)
      call selci_axb(w2(1,1,ib),nfmax2,w2(1,1,kb),nfmax2,
     $     e,numf,numf,numf2,numf4)
*      call selci_mxma(e,1,numf,w1(1,1,jb),nfmax,1,
*     $     work,1,numf,numf,numf4,numf4)
      call selci_axbt(e,numf,w1(1,1,jb),nfmax,
     $     work,numf,numf,numf4,numf4)
*      call selci_mxma(work,1,numf,w2(1,1,jb),nfmax2,1,
*     $     e,1,numf,numf,numf4,numf2)
      call selci_axbt(work,numf,w2(1,1,jb),nfmax2,
     $     e,numf,numf,numf4,numf2)
      return
c
      end
C>
C> @}

      subroutine opprint(symops,rotoop,maxops,nops,itype)
C$Id: opprint.f 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
      integer maxops, nops, itype
      character*2 rotoop(maxops)
      double precision symops(maxops*3,4)
      integer i, j, k, indx
c***********************************************************************
c     
c     print the matrix representations of the operators
c     
c***********************************************************************
        write(*,9)
        write(*,12)
        write(*,13) nops
        do 100 i=1,nops
          indx=(i-1)*3
c         
c         Add next block to avoid printing out bad rotoop data for pt. grps
c         
          if(itype.eq.0) then
            rotoop(i)='pt'
            write(*,8) rotoop(i)
          elseif(itype.eq.3) then
            write(*,8) rotoop(i)
          endif
          do 150 j=1,3
            write(*,10) (symops((indx+j),k), k=1,4)
  150     continue
  100   continue
    8 format(/,25x,a2,' fold Rotoinversion Operator')
    9 format(//,20x,'---------- FULL LISTING OF GROUP ----------')
   10 format(19x,4(f10.6))
   12 format(/,18x,'MATRIX REPRESENTATIONS OF THE GROUP OPERATORS',/)
   13 format(5x,'EXCLUDING THE IDENTITY OPERATOR THERE ARE',I3,' OPERATO
     &RS IN THIS GROUP')
      return
      end

c $Id: int_pgen1e.F 23378 2013-01-05 22:46:06Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Print a block of 1-electron integrals
C>
C> Print a generic block of 1-electron integrals including labels.
C> The routine support two print levels:
C>
C> * 0 - Print the integrals and labels
C>
C> * 1 - Print shell information in addition to the integrals and labels
C>
c:tex-% This is part of the standard API
c:tex-\subsection{int\_pgen1e}
c:tex-This routine prints a generic one electron block of integrals.
c:tex-This requires the labels be generated and input to this routine.
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_pgen1e(msg, i_basis, ish, j_basis, jsh, 
     &       ilab, jlab, l1e, Gen1e, print_level)
c:tex-\end{verbatim}
      implicit none
c
c generic one electron printing routine
c  print_level = 0 print only lables and integrals
c              = 1 print shell information etc. 
c
#include "nwc_const.fh"
#include "errquit.fh"
#include "basP.fh"
#include "geobasmapP.fh"
c
c::external subroutines used
c errquit
c::function
      logical int_chk_sh
      external int_chk_sh
c::passed
c:tex-\begin{verbatim}
      character*(*) msg           !< [Input] informational message
      integer i_basis             !< [Input] basis set handle for i shell
      integer j_basis             !< [Input] basis set handle for j shell
      integer ish                 !< [Input] i shell
      integer jsh                 !< [Input] j shell 
      integer l1e                 !< [Input] number of integrals and labels
      integer ilab(l1e)           !< [Input] i basis functions labels
      integer jlab(l1e)           !< [Input] j basis functions labels
      double precision Gen1e(l1e) !< [Input] integrals to be printed
      integer print_level         !< [Input] print level to be used
c. . . . . . . . . . . . . .! print_level = 0 print lables and integrals
c. . . . . . . . . . . . . .!             = 1 also print shell info.
c:tex-\end{verbatim}
c
c::local
      integer ii
      integer stdout
c
      stdout = 6
c
      if (print_level.ge.1) then
        write(stdout,*)'pgen1e:',msg
        write(stdout,10000)i_basis,j_basis,ish,jsh
      endif
c
      do 00100 ii = 1,l1e
        write(stdout,10001)ilab(ii),jlab(ii),Gen1e(ii)
00100 continue
c
10000 format(1x,'<ibasis:jbasis>-<',i4,':',i4,'>',5x,
     &       '<ish:jsh>-<',i3,':',i3,'>')
10001 format('i = ',i4,' j = ',i4,5x,'1eval = ',1pd20.10)
c
      end
C> @}

      SUBROUTINE ccsdtq_lambda1_21_5_1(d_a,k_a_offset,d_b,k_b_offset,d_c
     &,k_c_offset)
C     $Id: ccsdtq_lambda1_21_5_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h2 h12 p15 p18 h13 h14 h16 h17 )_vt + = 1 * Sum ( p5 p6 ) * t ( p5 p6 p15 p18 h13 h14 h16 h17 )_t * v ( h2 h12 p5 p6 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p15b
      INTEGER p18b
      INTEGER h12b
      INTEGER h13b
      INTEGER h14b
      INTEGER h16b
      INTEGER h17b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER p15b_1
      INTEGER p18b_1
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h13b_1
      INTEGER h14b_1
      INTEGER h16b_1
      INTEGER h17b_1
      INTEGER h2b_2
      INTEGER h12b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h2b = 1,noab
      DO p15b = noab+1,noab+nvab
      DO p18b = p15b,noab+nvab
      DO h12b = 1,noab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      DO h16b = h14b,noab
      DO h17b = h16b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h12b-
     &1)+int_mb(k_spin+p15b-1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+h13b-
     &1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+h17b-
     &1).ne.16)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+p15b-
     &1)+int_mb(k_spin+p18b-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+
     &h14b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+h17b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h12b-1),ieor(int_mb
     &(k_sym+p15b-1),ieor(int_mb(k_sym+p18b-1),ieor(int_mb(k_sym+h13b-1)
     &,ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h16b-1),int_mb(k_sym+
     &h17b-1)))))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h12b-1) * int_mb(k_r
     &ange+p15b-1) * int_mb(k_range+p18b-1) * int_mb(k_range+h13b-1) * i
     &nt_mb(k_range+h14b-1) * int_mb(k_range+h16b-1) * int_mb(k_range+h1
     &7b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_21_5_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      IF (int_mb(k_spin+p15b-1)+int_mb(k_spin+p18b-1)+int_mb(k_spin+p5b-
     &1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+h
     &14b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+h17b-1)) THEN
      IF (ieor(int_mb(k_sym+p15b-1),ieor(int_mb(k_sym+p18b-1),ieor(int_m
     &b(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(k_sym+h13b-1),
     &ieor(int_mb(k_sym+h14b-1),ieor(int_mb(k_sym+h16b-1),int_mb(k_sym+h
     &17b-1)))))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_8(p15b,p18b,p5b,p6b,h13b,h14b,h16b,h17b,p15b_1
     &,p18b_1,p5b_1,p6b_1,h13b_1,h14b_1,h16b_1,h17b_1)
      CALL TCE_RESTRICTED_4(h2b,h12b,p5b,p6b,h2b_2,h12b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1)
      dima_sort = int_mb(k_range+p15b-1) * int_mb(k_range+p18b-1) * int_
     &mb(k_range+h13b-1) * int_mb(k_range+h14b-1) * int_mb(k_range+h16b-
     &1) * int_mb(k_range+h17b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h12b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_21_5_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda1_21_5_1',2,MA_ERR)
      IF ((p6b .le. p15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1 + nvab 
     &* (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+p15b-1),int_mb(k_range+p18b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1
     &6b-1),int_mb(k_range+h17b-1),8,7,6,5,4,3,2,1,1.0d0)
      END IF
      IF ((p5b .le. p15b) .and. (p15b .lt. p6b) .and. (p6b .le. p18b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p18b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab *
     & (p15b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p15b-1),int_mb(k_range+p6b-1),int_mb(k_range+p18b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1
     &6b-1),int_mb(k_range+h17b-1),8,7,6,5,4,2,3,1,-1.0d0)
      END IF
      IF ((p5b .le. p15b) .and. (p18b .lt. p6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p6b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab *
     & (p15b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p15b-1),int_mb(k_range+p18b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1
     &6b-1),int_mb(k_range+h17b-1),8,7,6,5,3,2,4,1,1.0d0)
      END IF
      IF ((p15b .lt. p5b) .and. (p6b .le. p18b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p18b_1 - noab - 1 + nvab * (p6b_1 - noab - 1 + nvab *
     & (p5b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p18b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1
     &6b-1),int_mb(k_range+h17b-1),8,7,6,5,4,1,3,2,1.0d0)
      END IF
      IF ((p15b .lt. p5b) .and. (p5b .le. p18b) .and. (p18b .lt. p6b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p6b_1 - noab - 1 + nvab * (p18b_1 - noab - 1 + nvab *
     & (p5b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p18b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1
     &6b-1),int_mb(k_range+h17b-1),8,7,6,5,3,1,4,2,-1.0d0)
      END IF
      IF ((p18b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h17b_
     &1 - 1 + noab * (h16b_1 - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 -
     & 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * 
     &(p18b_1 - noab - 1 + nvab * (p15b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p15b-1
     &),int_mb(k_range+p18b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),int_mb(k_range+h1
     &6b-1),int_mb(k_range+h17b-1),8,7,6,5,2,1,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda1_21_5_1',3
     &,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lambda1_21_5_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lambda1_21_5_1',5,MA_ERR)
      IF ((h12b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h2b_2 - 1 + (noab
     &+nvab) * (h12b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h12b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),1,2,4,3,-1.0d0)
      END IF
      IF ((h2b .le. h12b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h12b_2 - 1 + (noa
     &b+nvab) * (h2b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1
     &),2,1,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lambda1_21_5_1',6
     &,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lambda1_21_5
     &_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda1_21_5
     &_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda1_21_5_1',9,MA_ERR)
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h12b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h17b-1),int_mb(k_range+h16b
     &-1),int_mb(k_range+h14b-1),int_mb(k_range+h13b-1),int_mb(k_range+p
     &18b-1),int_mb(k_range+p15b-1),2,1,8,7,6,5,4,3,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h17b 
     &- 1 + noab * (h16b - 1 + noab * (h14b - 1 + noab * (h13b - 1 + noa
     &b * (p18b - noab - 1 + nvab * (p15b - noab - 1 + nvab * (h12b - 1 
     &+ noab * (h2b - 1)))))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda1_21_5_1',1
     &0,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lambda1_21_5
     &_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_diana_settag(sgmnam,tag,val,x)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      character*16 sgmnam(nsa)
      character*24 ttag,tag(nsa,2)
      real*8 x(nsa,3),val(nsa,2)
c
      integer i,j,k,itag
      integer is,js,it
      character*11 cato
      character*5 cs,ct,csgm,cst
      real*8 rtag,rtag2,r2,rval
c
c     do selection on node 0
c
      if(me.eq.0) then
c
      read(card,6901,end=9999) itag,ttag,rval,is,js,rtag,cato
 6901 format(7x,i3,a24,f12.6,2i7,f12.6,a11)
      csgm='     '
      k=index(cato,':')-1
      if(k.le.0) k=0
      if(k.gt.0) then
      if(k.le.5) csgm(1:k)=cato(1:k)
      k=k+1
      endif
      cs(1:5)=cato(k+1:k+5)
      if(is.ne.0.and.js.ne.0) then
      if(is.gt.0) then
      write(*,6902) itag,ttag(1:index(ttag,' ')-1),
     + cs(1:index(cs,' ')),is,js,rtag
 6902 format(' Label ',i2,' set to ',a,' for atoms ',a,
     + ' in segments',
     + i7,' through ',i7,' and atoms within ',f12.6, ' nm')
      else
      write(*,6903) itag,ttag(1:index(ttag,' ')-1),
     + cs(1:index(cs,' ')),rtag
 6903 format(' Label ',i2,' set to ',a,' for atoms ',a,
     + ' in all segments and atoms within ',f12.6, ' nm')
      endif
      if(cs(1:1).eq.'_') cs(1:1)=' '
      do 3 i=1,nsa
      read(sgmnam(i),'(a5,a5,i6)') cst,ct,it
      do 4 j=1,5
      if(cs(j:j).eq.'?') ct(j:j)='?'
      if(csgm(j:j).eq.'?') cst(j:j)='?'
    4 continue
      if((is.eq.-1.or.(is.le.it.and.js.ge.it)).and.
     + (cs.eq.'     '.or.cs.eq.ct).and.
     + (csgm.eq.'     '.or.csgm.eq.cst)) then
      tag(i,itag)=ttag
      val(i,itag)=rval
      if(rtag.gt.0.0d0) then
      rtag2=rtag*rtag
      do 5 k=1,nsa
      r2=(x(k,1)-x(i,1))**2+(x(k,2)-x(i,2))**2+(x(k,3)-x(i,3))**2
      if(r2.le.rtag2) then
      tag(k,itag)=ttag
      val(k,itag)=rval
      endif
    5 continue
      endif
      endif
    3 continue
c
      else
      write(*,6904) itag,ttag(1:index(ttag,' ')-1),
     + cs(1:index(cs,' '))
 6904 format(' Label ',i2,' set to ',a,' for solvent atoms ',a)
c     + ' in solvent and solvent atoms within ',f12.6, ' nm')
      if(cs(1:1).eq.'_') cs(1:1)=' '
      do 6 i=1,nwa
      read(wnam(i),'(5x,a5,i6)') ct,it
      do 7 j=1,5
      if(cs(j:j).eq.'?') ct(j:j)='?'
    7 continue
      if(cs.eq.'     '.or.cs.eq.ct) then
      wtag(i,itag)=ttag
      wval(i,itag)=rval
c      if(rtag.gt.0.0d0) then
c      rtag2=rtag*rtag
c      do 8 k=1,nsa
c      r2=(x(k,1)-x(i,1))**2+(x(k,2)-x(i,2))**2+(x(k,3)-x(i,3))**2
c      if(r2.le.rtag2) tag(k,itag)=ttag
c    8 continue
c      endif
      endif
    6 continue
 
      endif
c
      endif
c
c     broadcast to all nodes
c
#if !defined(WIN32)
      if(np.gt.1) then
      call ga_brdcst(mag_d06,byte_mb(i_tag),48*nsa,0)
      call ga_brdcst(mag_d06,dbl_mb(i_tag),16*nsa,0)
      endif
#endif
c
      return
c
 9999 continue
c
      call md_abort('Error in settag',0)
      return
      end
c $Id: argos_diana_settag.F 21176 2011-10-10 06:35:49Z d3y133 $

c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c++++++++++++++++++++ FA precond routines ++++++++++++++++++ START
      subroutine uhf_hessv_precond3(g_x, 
     &                              omega)
c
c     Author : Fredy W. Aquino, Northwestern University
c     Date   : 03-24-12
c Note.- slight modification of uhf_precond()
c --> Experimental (not published yet)

      implicit none
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "cscf.fh"
#include "cuhf.fh"
      integer g_x
      double precision omega
c      
      integer nvir, nocc(2), iset
      integer i, j, ioff, ibase
      integer l_diag, k_diag, l_x, k_x
      integer g_f(2), ivec, nvec, gtype, vlen
      double precision diag, denominator, shift, dnrm
      integer ilo(2), ihi(2)
c
      logical oprint, olprint

      diag(i) = dbl_mb(k_diag + i - 1)
c     
      g_f(1) = cuhf_g_falpha
      g_f(2) = cuhf_g_fbeta
      nocc(1) = nalpha
      nocc(2) = nbeta

      oprint = util_print('precond',print_high)
      olprint = oprint .and. (ga_nodeid().eq.0)

      if (.not.ma_push_get(MT_DBL,nmo,'uhf: tmp',l_diag,k_diag))
     $     call errquit('uhf_precond: cannot allocate',0, MA_ERR)
      if (.not.ma_push_get(MT_DBL,nmo,'uhf: tmp',l_x,k_x))
     $     call errquit('uhf_hdiag_scale: cannot allocate',0, MA_ERR)

      call ga_sync()
      call ga_inquire(g_x, gtype, vlen, nvec)

c      shift = lshift + 2.0d0*omega

      shift = lshift + omega ! FA-03-13-14

      if (oprint) then
        do ivec = 1, nvec
          ilo(1) = 1
          ilo(2) = ivec
          ihi(1) = vlen
          ihi(2) = ivec
          call nga_normf_patch(g_x,ilo,ihi,dnrm)
          if (olprint) then
            write(LuOut,'(1x,a,": in g_x = ",i4,f24.8)')
     +      __FILE__,ivec,dnrm
          endif
        enddo
      endif

      ibase = 1
      do iset = 1, 2
         nvir = nmo - nocc(iset)
         if (nvir .gt. 0) then
            call ga_get_diagonal(g_f(iset), dbl_mb(k_diag))
            do ivec = 1, nvec
               do i = ga_nodeid()+1, nocc(iset), ga_nnodes()
                  ioff = (i-1)*nvir + ibase
                  call ga_get(g_x, ioff, ioff+nvir-1, ivec, ivec,
     $                 dbl_mb(k_x),1)
                  do j=1,nvir
c                     denominator = 2.d0 * (diag(j+nocc(iset)) - diag(i))
c     $                    + shift

                   denominator = (diag(j+nocc(iset))-diag(i))+shift ! FA-03-13-14

                   if (denominator .lt. 0.1d0) denominator = 0.1d0
c                     dbl_mb(k_x+j-1) = dbl_mb(k_x+j-1) / denominator
                   dbl_mb(k_x+j-1)=2.0d0* dbl_mb(k_x+j-1)/denominator ! FA-03-13-14
                  end do
                  call ga_put(g_x, ioff, ioff+nvir-1, ivec, ivec,
     $                 dbl_mb(k_x),1)
               end do
            enddo
         endif
         ibase = ibase + nocc(1)*(nmo-nocc(1))
      end do

      if (oprint) then
        do ivec = 1, nvec
          ilo(1) = 1
          ilo(2) = ivec
          ihi(1) = vlen
          ihi(2) = ivec
          call nga_normf_patch(g_x,ilo,ihi,dnrm)
          if (olprint) then
            write(LuOut,'(1x,a,": out g_x = ",i4,f24.8)')
     +      __FILE__,ivec,dnrm
          endif
        enddo
      endif

      if (.not. ma_pop_stack(l_x)) call errquit('uhf:pop x',0, MA_ERR)
      if (.not. ma_pop_stack(l_diag)) call errquit('uhf:pop ',0, MA_ERR)
      call ga_sync()

      end

      subroutine uhf_hessv_precond3_damp(
     &                              g_x, 
     &                              g_x_im,
     &                              omega,
     &                              gamwidth)
c
c     Author : Fredy W. Aquino, Northwestern University
c     Date   : 03-24-12
c Note.- modification of uhf_precond() following
c        rohf_hessv_precond3_damp()
c --> Experimental (not published yet)

      implicit none
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "cscf.fh"
#include "cuhf.fh"
      integer g_x,g_x_im
      double precision omega,    ! [input] frequency
     &                 gamwidth, ! [input]
     &                 gamwidth1
c      
      integer nvir, nocc(2), iset
      integer i, j, ioff, ibase
      integer l_diag, k_diag, 
     &        l_x   , k_x,
     &        l_x_im, k_x_im
      integer g_f(2), ivec, nvec, gtype, vlen
      double precision diag, denominator, shift, dnrm
      integer ilo(2), ihi(2)
      logical oprint, olprint

      double precision tmpre,tmpim,
     &                 factor_re,factor_im,
     &                 den


      external scale_gx_jth

      diag(i) = dbl_mb(k_diag + i - 1)
     
      g_f(1) = cuhf_g_falpha
      g_f(2) = cuhf_g_fbeta
      nocc(1) = nalpha
      nocc(2) = nbeta

      oprint = util_print('precond',print_high)
      olprint = oprint .and. (ga_nodeid().eq.0)

      if (.not.ma_push_get(MT_DBL,nmo,'uhf: diag',l_diag,k_diag))
     $     call errquit('uhf_precond_damp: cannot allocate',0, MA_ERR)
      if (.not.ma_push_get(MT_DBL,nmo,'uhf: x',l_x,k_x))
     $     call errquit('uhf_precond_damp: cannot allocate',0, MA_ERR)
      if (.not.ma_push_get(MT_DBL,nmo,'uhf: x_im',l_x_im,k_x_im))
     $     call errquit('uhf_precond_damp: cannot allocate',0, MA_ERR)

      call ga_sync()
      call ga_inquire(g_x, gtype, vlen, nvec)

      gamwidth1= gamwidth       
      shift    = lshift + omega 

      if (oprint) then
        do ivec = 1, nvec
          ilo(1) = 1
          ilo(2) = ivec
          ihi(1) = vlen
          ihi(2) = ivec
          call nga_normf_patch(g_x,ilo,ihi,dnrm)
          if (olprint) then
            write(LuOut,'(1x,a,": in g_x = ",i4,f24.8)')
     +      __FILE__,ivec,dnrm
          endif
        enddo
      endif

      ibase = 1
      do iset = 1, 2
         nvir = nmo - nocc(iset)
         if (nvir .gt. 0) then
            call ga_get_diagonal(g_f(iset), dbl_mb(k_diag))
            do ivec = 1, nvec
               do i = ga_nodeid()+1, nocc(iset), ga_nnodes()
                  ioff = (i-1)*nvir + ibase
                  call ga_get(g_x   , ioff, ioff+nvir-1, ivec, ivec,
     $                        dbl_mb(k_x),1)
                  call ga_get(g_x_im, ioff, ioff+nvir-1, ivec, ivec,
     $                        dbl_mb(k_x_im),1)

                  do j=1,nvir
                     denominator = (diag(j+nocc(iset))-diag(i))+shift
                     if (denominator .lt. 0.1d0) denominator = 0.1d0
                     den= denominator**2 + gamwidth1**2        
                     factor_re =  2.0d0*denominator/den
                     factor_im =  2.0d0*gamwidth1/den 
                     tmpre = dbl_mb(k_x   +j-1)   
                     tmpim = dbl_mb(k_x_im+j-1)   
                     dbl_mb(k_x   +j-1)=tmpre*factor_re+tmpim*factor_im
                     dbl_mb(k_x_im+j-1)=tmpim*factor_re-tmpre*factor_im 
                  end do ! end-loop-j
                  call ga_put(g_x   , ioff, ioff+nvir-1, ivec, ivec,
     $                        dbl_mb(k_x)   ,1)
                  call ga_put(g_x_im, ioff, ioff+nvir-1, ivec, ivec,
     $                        dbl_mb(k_x_im),1)
               end do
            enddo
         endif
         ibase = ibase + nocc(1)*(nmo-nocc(1))
      end do

      if (oprint) then
        do ivec = 1, nvec
          ilo(1) = 1
          ilo(2) = ivec
          ihi(1) = vlen
          ihi(2) = ivec
          call nga_normf_patch(g_x,ilo,ihi,dnrm)
          if (olprint) then
            write(LuOut,'(1x,a,": out g_x = ",i4,f24.8)')
     +      __FILE__,ivec,dnrm
          endif
        enddo
      endif
      if (.not. ma_pop_stack(l_x_im)) 
     &   call errquit('uhf:pop x-im',0, MA_ERR)
      if (.not. ma_pop_stack(l_x))    
     &   call errquit('uhf:pop x-re',0, MA_ERR)
      if (.not. ma_pop_stack(l_diag)) 
     &   call errquit('uhf:pop ' ,0, MA_ERR)

      call ga_sync()

      end
c++++++++++++++++++++ FA precond routines ++++++++++++++++++ END
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c $Id: uhf_precond_ext.F 25617 2014-05-14 15:12:54Z faquino $

      subroutine hnd_xyzgia(gijkl,ng,nimax,njmax,nkmax,nlmax)
      implicit double precision (a-h,o-z)
      dimension gijkl(ng,3,3,nlmax,nkmax,njmax,nimax)
c
c     ----- shift down for x1,y1,z1 -giao- integrals -----
c
      do ni=1,nimax-1
         do nj=1,njmax
            do nk=1,nkmax
               do nl=1,nlmax
                  do ixyz=1,3
                     do ig=1,ng
      gijkl(ig,ixyz,2,nl,nk,nj,ni)=gijkl(ig,ixyz,1,nl,nk,nj,ni+1)
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
c
c     ----- shift down for x2,y2,z2 -giao- integrals -----
c
      do ni=1,nimax
         do nj=1,njmax
            do nk=1,nkmax-1
               do nl=1,nlmax
                  do ixyz=1,3
                     do ig=1,ng
      gijkl(ig,ixyz,3,nl,nk,nj,ni)=gijkl(ig,ixyz,1,nl,nk+1,nj,ni)
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
c
      return
      end
c $Id: hnd_xyzgia.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine put_1pdm_ph_2(d_1pdm,k_1pdm_offset,d_ph,k_ph_offset)
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
c
      integer d_1pdm,k_1pdm_offset
      integer d_ph,k_ph_offset
      integer p1b,h2b
      integer p1,h2
      integer size
      integer l_r1,k_r1,l_r1_sort,k_r1_sort
      integer i
c
      integer nprocs
      integer next
      integer count
      integer nxtask
      external nxtask
c
      nprocs=ga_nnodes( )
      count = 0
      next = nxtask(nprocs,1)
c
      do p1b = noab+1,noab+nvab
      do h2b = 1,noab
         if(next.eq.count) then
c
         if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then
         if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1      +int_mb(k_spin+h2b-1).ne.4)) then
         if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1))
     1      .eq.irrep_e) then
            size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
            if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1        call errquit('put_1pdm_ph: MA problem',0,MA_ERR)
c
            call get_hash_block(d_ph,dbl_mb(k_r1),size,
     1        int_mb(k_ph_offset),((p1b-noab-1)*noab+h2b-1))
            call put_hash_block(d_1pdm,dbl_mb(k_r1),size,
     1        int_mb(k_1pdm_offset),(h2b-1)+(p1b-1)*(noab+nvab))
c
            if (.not.ma_pop_stack(l_r1))
     1      call errquit('put_1pdm_ph: MA problem',1,MA_ERR)
c
         endif
         endif
         endif
c
         next=nxtask(nprocs,1)
         endif
         count=count+1
c
      enddo
      enddo
c
      next=nxtask(-nprocs,1)
      call ga_sync( )
c
      end

c $Id: put_1pdm_ph_2.F 21176 2011-10-10 06:35:49Z d3y133 $

c     $Id: pspw_noit_energy.F 19707 2010-10-29 17:59:36Z d3y133 $
      logical function pspw_noit_energy(rtdb)
      implicit none
      integer rtdb

      logical  cgsdv5
      external cgsdv5

      pspw_noit_energy = cgsdv5(rtdb,-1)
      return
      end

*     *****************************************************
*     *                                                   *
*     *                setup                              *
*     *                                                   *
*     *****************************************************

      subroutine setup(nfft1,nfft2,nfft3,unita,unitg,G,IERR)
*
* $Id: junk.f 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
      integer nfft1,nfft2,nfft3
      double precision unita(3,3),unitg(3,3)
      double precision G(nfft1/2+1,nfft2,nfft3,3)





      call get_unitg(unita,unitg)

      nffth3 = nfft3/2
      nffth2 = nfft2/2
      nffth1 = nfft1/2
*     **** less confusing algorithm ****
      do k3 = -nffth3+1, nffth3
         do k2 = -nffth2+1, nffth2
            do k1 = 0,nffth1
               g1 = k1*unitg(1,1) + k2*unitg(1,2) +k3*unitg(1,3)
               g2 = k1*unitg(2,1) + k2*unitg(2,2) +k3*unitg(2,3)
               g3 = k1*unitg(3,1) + k2*unitg(3,2) +k3*unitg(3,3)
               i=k1
               j=k2
               k=k3
c              if (i .lt. 0) i = i + nfft1
               if (j .lt. 0) j = j + nfft2
               if (k .lt. 0) k = k + nfft3

               G(i+1,j+1,k+1,1) = g1
               G(i+1,j+1,k+1,2) = g2
               G(i+1,j+1,k+1,3) = g3

            end do  
         end do
      end do

      IERR=0
      RETURN
      END




      subroutine kbpp(nrmax,vp,wp,rho,f,cs,sn
     >                nfft1,nfft2,nfft3,vl,vnl,G)
      implicit none



      DIMENSION VP(NRMAX,0:3),WP(NRMAX,0:3),RHO(NRMAX)
      DIMENSION VL(nfft1/2+1,nfft2,nfft3)
      DIMENSION VNL(nfft1/2+1,nfft2,nfft3,9)
      DIMENSION VNLNRM(9)
      dimension unit(3)
      DIMENSION UNITA(3,3),UNITG(3,3)
      DIMENSION G(nfft1/2+1,nfft2,nfft3,3)
      DIMENSION F(NRMAX),CS(NRMAX),SN(NRMAX)

 
      common / HAMANN / vp,wp,rho,drho,nrho,lmax
      common / PSEUDO / vl,vnl,vnlnrm,zv,lmmax 
      common / LATTIC / g,unita,unitg,unit,omega,icube


      PI=4.0d0*DATAN(1.0d0)
      TWOPI=2.0d0*PI
      FORPI=4.0d0*PI

*     Total number of non-local pseudopotentials
      LMMAX=LMAX**2

      IF(LMMAX.GT.9) THEN
        IERR=1
        RETURN
      ENDIF
      IF(NRHO.GT.NRMAX) THEN
        IERR=3
        RETURN
      ENDIF
      IF((NRHO/2)*2.EQ.NRHO) THEN
        IERR=4
        RETURN
      ENDIF

      P0=DSQRT(FORPI)
      P1=DSQRT(3.0d0*FORPI)
      P2=DSQRT(15.0d0*FORPI)

*::::::::::::::::::  Define non-local pseudopotential  ::::::::::::::::
      DO 100 L=0,LMAX-1
        DO 100 I=1,NRHO
          VP(I,L)=VP(I,L)-VP(I,LMAX)
  100 CONTINUE

*:::::::::::::::::::::  Normarization constants  ::::::::::::::::::::::
      DO 130 L=0,LMAX-1
        DO 110 I=1,NRHO
          F(I)=VP(I,L)*WP(I,L)**2
  110   CONTINUE
        A=SIMP(NRHO,F,DRHO)
        DO 120 I=L**2+1,(L+1)**2
          VNLNRM(I)=A
  120   CONTINUE
  130 CONTINUE

*======================  Fourier transformation  ======================
      DO 700 k3=1,nfft3
      DO 700 k2=1,nfft2
      DO 700 k1=1,(nfft1/2+1)
        Q=DSQRT(G(k1,k2,k3,1)**2
     >         +G(k1,k2,k3,2)**2
     >         +G(k1,k2,k3,3)**2)

        if ((k1.eq.1).and.(k2.eq.1).and.(k3.eq.1)) go to 700

        GX=G(k1,k2,k3,1)/Q
        GY=G(k1,k2,k3,2)/Q
        GZ=G(k1,k2,k3,3)/Q
        DO 200 I=1,NRHO
          CS(I)=DCOS(Q*RHO(I))
          SN(I)=DSIN(Q*RHO(I))
  200   CONTINUE

        GO TO (600,500,400,300), LMAX+1

*::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
  300   CONTINUE
        F(1)=0.0d0
        DO 310 I=2,NRHO
          A=3.0d0*(SN(I)/(Q*RHO(I))-CS(I))/(Q*RHO(I))-SN(I)
          F(I)=A*WP(I,2)*VP(I,2)
  310   CONTINUE
        D=P2*SIMP(NRHO,F,DRHO)/Q
        VNL(k1,k2,k3,5)=D*(3.0d0*GZ*GZ-1.0d0)/(2.0d0*dsqrt(3.0d0))
        VNL(k1,k2,k3,6)=D*GX*GY
        VNL(k1,k2,k3,7)=D*GY*GZ
        VNL(k1,k2,k3,8)=D*GZ*GX
        VNL(k1,k2,k3,9)=D*(GX*GX-GY*GY)/(2.0d0)

*::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
  400   CONTINUE
         F(1)=0.0d0
         DO 410 I=2,NRHO
           F(I)=(SN(I)/(Q*RHO(I))-CS(I))*WP(I,1)*VP(I,1)
  410    CONTINUE
         P=P1*SIMP(NRHO,F,DRHO)/Q
         VNL(k1,k2,k3,2)=P*GX
         VNL(k1,k2,k3,3)=P*GY
         VNL(k1,k2,k3,4)=P*GZ

*::::::::::::::::::::::::::::::  s-wave  :::::::::::::::::::::::::::::::
  500   CONTINUE
        DO 510 I=1,NRHO
          F(I)=SN(I)*WP(I,0)*VP(I,0)
  510   CONTINUE
        VNL(k1,k2,k3,1)=P0*SIMP(NRHO,F,DRHO)/Q

*::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
  600   CONTINUE
        DO 610 I=1,NRHO
          F(I)=RHO(I)*VP(I,LMAX)*SN(I)
  610   CONTINUE
        VL(k1,k2,k3)=SIMP(NRHO,F,DRHO)*FORPI/Q-ZV*FORPI*CS(NRHO)/(Q*Q)

  700 CONTINUE

*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      

      DO 800 I=1,NRHO
        F(I)=VP(I,LMAX)*RHO(I)**2
  800 CONTINUE
      VL(1,1,1)=FORPI*SIMP(NRHO,F,DRHO)+TWOPI*ZV*RHO(NRHO)**2

      DO 810 I=1,NRHO
        F(I)=RHO(I)*WP(I,0)*VP(I,0)
  810 CONTINUE
      VNL(1,1,1,1)=P0*SIMP(NRHO,F,DRHO)

      DO 820 L=2,LMMAX
        VNL(1,1,1,L)=0.0d0
  820 CONTINUE

      IERR=0
      RETURN
      END

      double precision function simp(n,y,h)
      implicit none
      integer n
      double precision y(n)
      double precision h,s
      integer n,ne,no

      ne=n/2
      no=ne+1
      S=2.0d0*dsum(no,y(1),2) + 4.0d0*dsum(ne,y(2),2)-y(1)-y(n)
      simp=s*h/3.0d0
      return
      end



      subroutine get_unitg(unita,unitg)
      implicit none

******************************************************************************
*                                                                            *
*     This routine computes primitive vectors                                *
*               in reciporocal space and the volume of primitive cell.       *
*                                                                            *
*     Inputs:                                                                *
*             unita  --- primitive vectors in coordination space             *
*                                                                            *
*     Outputs:                                                               *
*             unitg  --- primitive vectors in reciprocal space               *
*                                                                            *
*     Library:  dscal from BLAS                                              *
*                                                                            *
*     Last modification:  3/30/99  by Eric Bylaska                           *
*                                                                            *
******************************************************************************


*     ------------------
*     argument variables
*     ------------------
      double precision unita(3,3), unitg(3,3)

*     ---------------
*     local variables
*     ---------------
      double precision volume
      double precision twopi

      twopi = 8.0d0*datan(1.0d0)


*     -----------------------------------------
*     primitive vectors in the reciprocal space 
*     -----------------------------------------
      unitg(1,1) = unita(2,2)*unita(3,3) - unita(3,2)*unita(2,3)
      unitg(2,1) = unita(3,2)*unita(1,3) - unita(1,2)*unita(3,3)
      unitg(3,1) = unita(1,2)*unita(2,3) - unita(2,2)*unita(1,3)
      unitg(1,2) = unita(2,3)*unita(3,1) - unita(3,3)*unita(2,1)
      unitg(2,2) = unita(3,3)*unita(1,1) - unita(1,3)*unita(3,1)
      unitg(3,2) = unita(1,3)*unita(2,1) - unita(2,3)*unita(1,1)
      unitg(1,3) = unita(2,1)*unita(3,2) - unita(3,1)*unita(2,2)
      unitg(2,3) = unita(3,1)*unita(1,2) - unita(1,1)*unita(3,2)
      unitg(3,3) = unita(1,1)*unita(2,2) - unita(2,1)*unita(1,2)
      volume = unita(1,1)*unitg(1,1)
     >       + unita(2,1)*unitg(2,1)
     >       + unita(3,1)*unitg(3,1)
      call dscal(9,twopi/volume,unitg,1)

*     ---------------------
*     volume of a unit cell
*     ---------------------
      volume=dabs(volume)

      return
      end

      Subroutine getNxyz(lambda,ic,Nxyz)
c $Id: getNxyz.F 19696 2010-10-29 16:53:42Z d3y133 $
      implicit none

      integer lambda, ic, Nxyz(3)

#include "sh_order.fh"

      integer l, l3, nc

c
c Get the angular momentum exponents for the "ic" component of a shell of
c Cartesian GTFs of angular momentum "lambda".
c
c The order of components in shells of increasing angular momentum was defined
c by the routine "defNxyz" as follows:
c
c     Data s/ 0,0,0 /
c
c     Data p/ 1,0,0,
c    &        0,1,0,
c    &        0,0,1 /
c
c     Data d/ 2,0,0,
c    &        1,1,0,
c    &        1,0,1,
c    &        0,2,0,
c    &        0,1,1,
c    &        0,0,2 /
c
c     Data f/ 3,0,0,
c    &        2,1,0,
c    &        2,0,1,
c    &        1,2,0,
c    &        1,1,1,
c    &        1,0,2,
c    &        0,3,0,
c    &        0,2,1,
c    &        0,1,2,
c    &        0,0,3 /
c
c     etc.
c
c******************************************************************************

c Define the angular momentum indices for the given shell component.
#ifdef DEBUG
      if( lambda.le.linit )then
#endif

       nc =  (lambda*(lambda+1)*(lambda+2))/6 + ic
       Nxyz(1) = Ixyz(1,nc)
       Nxyz(2) = Ixyz(2,nc)
       Nxyz(3) = Ixyz(3,nc)

#ifdef DEBUG
      else

       write(*,*)
       write(*,*) 'GETNXYZ:  Shell component ordering was defined for'
       write(*,*) '          shells up through L = ',linit,'.'
       write(*,*) '          Initialization (defNxyz) should include '
       write(*,*) '          shells up through L = ',lambda,'.'
       stop

      end if
#endif

      end

*
* $Id: lcao_wvfnc_bak.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      logical function lcao_wvfnc(oprint,it_max,
     >                      wavefunction_filename,
     >             			version,
     >						ngrid,
     >						unita,
     >						ispin,
     >						ne)

      implicit none
#include "errquit.fh"
      logical oprint
      integer it_max
      character*50 wavefunction_filename
      integer      version
      integer      ngrid(3)
      real*8       unita(3,3)
      integer      ispin,ne(2)

#include "mafdecls.fh"
#include "global.fh"
 
*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)

      real*8 ALPHA,talpha
      parameter (ALPHA=0.30d0)

      logical value,value2,reset_diis
      integer ms,i,ia,icharge
      integer dn(2),phi1(2),phi2(2)
      integer ee(2),eigs(2)
      integer smatrix,kematrix
      integer vlmatrix,vnlmatrix,vhxcmatrix(2)
      integer psimatrix(2),hmatrix(2)
      integer nbasis,nbasis2,n2ft3d,npack1,it
      real*8  rho_error

*     **** external functions ****
      logical     psp_semicore,aorbs_init,aorbs_readall
      character*2 psp_atom
      integer     aorbs_norbs,aorbs_nbasis,ion_nkatm,psp_lmax
      integer     psp_locp,psp_lmmax,ion_natm,psp_npsp
      integer     control_version
      integer     ewald_ncut,ewald_nshl3d
      real*8      psp_ncore,psp_rcore,psp_rlocal,psp_rc,psp_zv
      real*8      ewald_rcut
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg
      external    psp_semicore,aorbs_init,aorbs_readall
      external    psp_atom
      external    aorbs_norbs,aorbs_nbasis,ion_nkatm,psp_lmax
      external    psp_locp,psp_lmmax,ion_natm,psp_npsp
      external    control_version
      external    ewald_ncut,ewald_nshl3d
      external    psp_ncore,psp_rcore,psp_rlocal,psp_rc,psp_zv
      external    ewald_rcut
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg
      integer  pack_nwave_all
      integer  control_gga
      integer  control_ngrid,pack_nwave
      external pack_nwave_all
      external control_gga
      external control_ngrid,pack_nwave
      character*12 control_boundry
      external     control_boundry


      call Parallel_taskid(taskid)
      call D3dB_n2ft3d(1,n2ft3d)
      call Pack_npack(1,npack1)

*     **** initialize atomic orbitals ****
      value = aorbs_init()
      value = value.and.aorbs_readall()
      if (.not.value) go to 100
      nbasis = aorbs_nbasis()
      nbasis2 = nbasis**2

*     ***** allocate memory from heap memory ****
      value = value.and.
     >        MA_alloc_get(mt_dbl,(2*n2ft3d),'dn',dn(2),dn(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,(npack1),'phi1',phi1(2),phi1(1))
      value = value.and.
     >        MA_alloc_get(mt_dcpl,(npack1),'phi2',phi2(2),phi2(1))
      value = value.and.
     >        MA_alloc_get(mt_dbl,(2*nbasis),'ee',ee(2),ee(1))
      eigs(1) = ee(1)
      eigs(2) = ee(1) + nbasis

*     ***** allocate matrices using GA ****
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'smatrix',
     >                  1,1,smatrix)
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'kematrix',
     >                  1,1,kematrix)
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'vlmatrix',
     >                  1,1,vlmatrix)
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'vnlmatrix',
     >                  1,1,vnlmatrix)
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'vhxcmatrix1',
     >                  1,1,vhxcmatrix(1))
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'hmatrix1',
     >                  1,1,hmatrix(1))
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'psimatrix1',
     >                  1,1,psimatrix(1))
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'vhxcmatrix2',
     >                  1,1,vhxcmatrix(2))
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'hmatrix2',
     >                  1,1,hmatrix(2))
      value = value.and.
     >        ga_create(mt_dbl,nbasis,nbasis,'psimatrix2',
     >                  1,1,psimatrix(2))
      if (.not. value) then
        go to 100 
      end if

      if ((taskid.eq.MASTER).and.(oprint)) then
        write(*,1000)
        write(*,1010)
        write(*,1020)
        write(*,1010)
        write(*,1030)
        write(*,1010)
        write(*,1040)
        write(*,1010)
        write(*,1000)
        write(*,1110) 
        call nwpw_message(1)


         write(6,1121) control_boundry(),control_version()
         if (ispin.eq.1) write(6,1130) 'restricted'
         if (ispin.eq.2) write(6,1130) 'unrestricted'
         IF (control_gga().eq.0) THEN
            write(6,1131) 'Vosko et al parameterization'
         ELSE IF (control_gga().eq.1) THEN
            write(6,1131)
     >      'PBE96 (White and Bird) parameterization'
         ELSE
            write(6,1131) 'unknown parameterization'
            call errquit('bad exchange_correlation',0, INPUT_ERR)
         END IF

        write(*,1117) 
        do ia=1,ion_nkatm()
           write(*,1118) psp_atom(ia),aorbs_norbs(ia)
        end do
        write(*,1119) nbasis


        write(6,1140)
         do ia = 1,psp_npsp()
           write(6,1150) ia,psp_atom(ia),
     >                    psp_zv(ia),psp_lmax(ia)
           write(6,1152) psp_lmax(ia)
           write(6,1153) psp_locp(ia)
           write(6,1154) psp_lmmax(ia)
           if (control_version().eq.4) write(6,1156) psp_rlocal(ia)
           if (psp_semicore(ia))
     >         write(6,1155) psp_rcore(ia),psp_ncore(ia)
           write(6,1151) (psp_rc(i,ia),i=0,psp_lmax(ia))
         end do

         icharge = -(ne(1)+ne(ispin))
         do ia=1,ion_nkatm()
           icharge = icharge + ion_natm(ia)*psp_zv(ia)
         end do
         write(6,1159) icharge

        write(*,1220) ispin, ne(1), ne(ispin)
        write(6,1230)
         write(6,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(6,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(6,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(6,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(6,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(6,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         write(6,1231) lattice_omega()
         write(6,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(0),pack_nwave(0)
         write(6,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(1),pack_nwave(1)
         if (control_version().eq.3) then
         write(6,1260) ewald_rcut(),ewald_ncut()
         write(6,1261) ewald_mandelung()
         end if
         write(6,1270)
         write(6,1300)
         write(6,1305)
         call util_flush(6)

        write(*,*)
      end if

*     ********************************
*     **** generate phaze factors ****
*     ********************************
      call phafac()

*     **********************************
*     **** initialize lcao matrices ****
*     **********************************
      call lcao_generate_smatrix(smatrix,
     >                           dcpl_mb(phi1(1)),
     >                           dcpl_mb(phi2(1)))
      call lcao_generate_kematrix(kematrix,
     >                           dcpl_mb(phi1(1)),
     >                           dcpl_mb(phi2(1)))
      call lcao_generate_vlmatrix(vlmatrix,
     >                           dcpl_mb(phi1(1)),
     >                           dcpl_mb(phi2(1)))
      call lcao_generate_vnlmatrix(vnlmatrix,
     >                           dcpl_mb(phi1(1)),
     >                           dcpl_mb(phi2(1)))
      call lcao_init_dn(ispin,ne,n2ft3d,
     >                  dbl_mb(dn(1)),
     >                  dcpl_mb(phi2(1)))

      call lcao_diis_dn_init(4)
      rho_error = 1000.0d0
      do it=0,it_max-1
         call lcao_generate_vhxcmatrix(ispin,n2ft3d,
     >                           dbl_mb(dn(1)),
     >                           vhxcmatrix,
     >                           dcpl_mb(phi1(1)),
     >                           dcpl_mb(phi2(1)))
         do ms=1,ispin

*          **** generate spin hamiltonian ****
           call ga_add(1.0d0,kematrix,
     >                 1.0d0,vlmatrix,
     >                 hmatrix(ms))
           call ga_add(1.0d0,vnlmatrix,
     >                 1.0d0,hmatrix(ms),
     >                 hmatrix(ms))
           call ga_add(1.0d0,vhxcmatrix(ms),
     >                 1.0d0,hmatrix(ms),
     >                 hmatrix(ms))
   
*          **** diagonalize spin hamiltonian ****
           call ga_diag_reuse(it,
     >                  hmatrix(ms),
     >                  smatrix,
     >                  psimatrix(ms),
     >                  dbl_mb(eigs(ms)))

         end do

*        **** calculate new density ****
         if (it.eq.0) talpha=1.00d0
         if (it.eq.1) talpha = ALPHA
         call lcao_new_mix_dn(talpha,
     >                       ispin,ne,n2ft3d,
     >                       dbl_mb(dn(1)),
     >                       psimatrix,
     >                       dcpl_mb(phi2(1)),
     >                       rho_error,
     >                       reset_diis)

        write(*,*) "rho error:",it,rho_error,talpha
        if (rho_error.lt.1.0d-6) go to 50
       
        if (reset_diis) then
           call lcao_diis_dn_end()
           call lcao_diis_dn_init(4)
        end if

      end do
 50   call lcao_diis_dn_end()
      call lcao_write_psi(wavefunction_filename,
     >                    version,
     >                    ngrid,
     >                    unita,
     >                    ispin,ne,
     >                    psimatrix,dcpl_mb(phi2(1)))


*     ***** free heap memory ****
  100 continue
      value2 = MA_free_heap(dn(2))
      value2 = MA_free_heap(phi1(2))
      value2 = MA_free_heap(phi2(2))
      value2 = MA_free_heap(ee(2))
      value2 = ga_destroy(smatrix)
      value2 = ga_destroy(kematrix)
      value2 = ga_destroy(vlmatrix)
      value2 = ga_destroy(vnlmatrix)
      value2 = ga_destroy(vhxcmatrix(1))
      value2 = ga_destroy(hmatrix(1))
      value2 = ga_destroy(psimatrix(1))
      value2 = ga_destroy(vhxcmatrix(2))
      value2 = ga_destroy(hmatrix(2))
      value2 = ga_destroy(psimatrix(2))
      call aorbs_end()

c     value = .false.
      lcao_wvfnc = value
      return
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*                 LCAO Calculations                *')
 1030 FORMAT(10X,'*       [ NorthWest Chemistry implementation ]     *')
 1040 FORMAT(10X,'*                  Version #2.00                   *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(' Reading in ELCIN file(1-yes, 0-no): ',I1)
 1115 FORMAT(/' Pseudopotentials used:')
 1116 FORMAT(5X,A,'  # of L: ',I1)
 1117 FORMAT(/' Atomic orbitals used:')
 1118 FORMAT(5X,A,'  # of orbitals: ',I6)
 1119 FORMAT(/' Number of basis functions:',I4)
 1121 FORMAT(/5X,' boundry conditions   = ',A,'(version', I1,')')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A2,'  core charge:',F4.1,'  lmax=',I1)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i2)
 1153 FORMAT(12X,' local potential used           : ',i2)
 1154 FORMAT(12X,' number of non-local projections: ',i2)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1159 FORMAT(/' total charge:',I2)

 1160 FORMAT(/' ATOMIC COMPOSITION:')
 1170 FORMAT(7(5X,A2,':',I3))
 1180 FORMAT(/' INITIAL POSITION OF IONS:')
 1190 FORMAT(5X, I4, A3  ,' (',3F11.5,' )')
 1200 FORMAT(5X,'  G.C. ',' (',3F11.5,' )')
 1210 FORMAT(5X,' C.O.M.',' (',3F11.5,' )')
 1220 FORMAT(' # of Electrons(ispin=',I1,')  :',I4,' up',I4,' down')
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,' volume : ',F10.1)
 1241 FORMAT(5x,' lattice: a1=<',3f8.3,' >')
 1242 FORMAT(5x,'          a2=<',3f8.3,' >')
 1243 FORMAT(5x,'          a3=<',3f8.3,' >')
 1244 FORMAT(5x,'          b1=<',3f8.3,' >')
 1245 FORMAT(5x,'          b2=<',3f8.3,' >')
 1246 FORMAT(5x,'          b3=<',3f8.3,' >')

 1250 FORMAT(5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')

 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters:')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'fictacious mass=',F10.1)
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (electron)',E12.3,' (ion)')
 1300 FORMAT(//)

 1305 FORMAT(10X,'================ ITERATION =========================')
 1310 FORMAT(I8,E20.10,2E15.5)
 1320 FORMAT(' NUMBER OF ELECTRONS: SPIN UP=',F11.5,'  DOWN=',F11.5)
 1330 FORMAT(/' COMPARISON BETWEEN HAMILTONIAN AND LAMBDA MATRIX')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1350 FORMAT(/' ORTHONORNALITY')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  SUMMARY OF RESULTS  =================')
 1420 FORMAT( ' FINAL POSITION OF IONS:')
 1430 FORMAT(/' TOTAL     ENERGY    :',E19.10,' (',E15.5,'/ION)')
 1440 FORMAT( ' TOTAL ORBITAL ENERGY:',E19.10,' (',E15.5,'/ION)')
 1450 FORMAT( ' HARTREE   ENERGY    :',E19.10,' (',E15.5,'/ELECTRON)')
 1460 FORMAT( ' EXC-CORR  ENERGY    :',E19.10,' (',E15.5,'/ELECTRON)')
 1470 FORMAT( ' ION-ION   ENERGY    :',E19.10,' (',E15.5,'/ION)')
 1500 FORMAT(/' ORBITAL ENERGIES:')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV)'))
 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

      end

      subroutine put_hash_block(d_file,array,size,hash,key)
c
c $Id: put_hash_block.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
      integer d_file
      integer size
      integer hash(*)
      integer key
      integer offset
      double precision array(size)
c
      call tce_hash(hash,key,offset)
      call put_block(d_file,array,size,offset)
      return
      end






      subroutine put_hash_block_sf(d_file,array,size,hash,key)
c
c $Id: put_hash_block.F 19706 2010-10-29 17:52:31Z d3y133 $
c
      implicit none
      integer d_file
      integer size
      integer hash(*)
      integer key
      integer offset
      double precision array(size)
c
      call tce_hash(hash,key,offset)
      call put_block_sf(d_file,array,size,offset)
      return
      end

*
* $Id: lcao_mlist.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ***********************************************************
*     *															*
*     *   		   		lcao_mlist library						*
*     *															*
*     *   Author - Eric Bylaska									*
*     *   date   - 10/09/01										*
*     *															*
*     ***********************************************************

*
*

*     ***********************************
*     *									*
*     *	       lcao_mlist_init			*	
*     *									*
*     ***********************************
      subroutine lcao_mlist_init(maxsize0,ispin0,nbasis0)
      implicit none
#include "errquit.fh"
      integer maxsize0
      integer ispin0
      integer nbasis0

#include "mafdecls.fh"
#include "lcao_mlist.fh"

*     **** local variables ****
      logical value

      maxsize = maxsize0
      ispin   = ispin0
      nbasis  = nbasis0
      size    = 0

*    ***** allocate memory from heap memory ****
      value = MA_alloc_get(mt_int,(ispin*maxsize),'mlist',
     >                     mlist(2),mlist(1))
      if (.not. value)
     > call errquit('lcao_mlist_init: out of heap memory',0, MA_ERR)

      return
      end


*     ***********************************
*     *									*
*     *	       lcao_mlist_end			*	
*     *									*
*     ***********************************

      subroutine lcao_mlist_end()
      implicit none
#include "errquit.fh"
     
#include "mafdecls.fh"
#include "global.fh"
#include "lcao_mlist.fh"


*     **** local variables ****
      logical value
      integer i,mindx

      value = .true.
      do i=1,size
         mindx = int_mb(mlist(1)+i-1)
         value = value.and.ga_destroy(mindx)
      end do
      if (ispin.gt.1) then
        do i=1,size
         mindx = int_mb(mlist(1)+i-1+(ispin-1)*maxsize)
         value = value.and.ga_destroy(mindx)
        end do
      end if
      value = value.and.MA_free_heap(mlist(2))
      if (.not. value)
     > call errquit('lcao_mlist_init: freeing heap memory',0, MA_ERR)

      size    = 0
      maxsize = 0
      return
      end

*     ***********************************
*     *									*
*     *	        lcao_mlist_new  		*	
*     *									*
*     ***********************************
      subroutine lcao_mlist_new(index)
      implicit none
#include "errquit.fh"
      integer index(*)

#include "mafdecls.fh"
#include "global.fh"
#include "lcao_mlist.fh"

*     **** local variables ****
      logical value
      integer indx,indx2

      if (size.ge.maxsize) 
     > call errquit('lcao_mlist_new: maxsize exceeded',0, MA_ERR)

      value = ga_create(mt_dbl,nbasis,nbasis,'mlist',1,1,indx)
      if (ispin.gt.1)
     > value = value.and.
     >         ga_create(mt_dbl,nbasis,nbasis,'mlist',1,1,indx2)
      if (.not.value) 
     > call errquit('lcao_mlist_new: out of ga memory',0, GA_ERR)

      size = size + 1
      int_mb(mlist(1)+size-1) = indx
      if (ispin.gt.1)
     > int_mb(mlist(1)+size-1+(ispin-1)*maxsize) = indx2

      index(1)  = indx
      if (ispin.gt.1)
     > index(2)  = indx2
      return
      end
         


*     ***********************************
*     *									*
*     *	        lcao_mlist_get  		*	
*     *									*
*     ***********************************
      subroutine lcao_mlist_get(count,index)
      implicit none
#include "errquit.fh"
      integer count
      integer index(*)

#include "mafdecls.fh"
#include "lcao_mlist.fh"

      if ((count.gt.size).or.(count.lt.1)) 
     > call errquit('lcao_mlist_get: bad count',0, INPUT_ERR)

      index(1)   = int_mb(mlist(1)+count-1)
      if (ispin.gt.1)
     > index(2)   = int_mb(mlist(1)+count-1+(ispin-1)*maxsize)
      return
      end


*     ***********************************
*     *									*
*     *	        lcao_mlist_size 		*	
*     *									*
*     ***********************************
      integer function lcao_mlist_size()
      implicit none

#include "lcao_mlist.fh"

      lcao_mlist_size = size
      return
      end

*     ***********************************
*     *									*
*     *	        lcao_mlist_maxsize 	*	
*     *									*
*     ***********************************
      integer function lcao_mlist_maxsize()
      implicit none

#include "lcao_mlist.fh"

      lcao_mlist_maxsize = maxsize
      return
      end

*     ***********************************
*     *									*
*     *	        lcao_mlist_shift 		*	
*     *									*
*     ***********************************
      subroutine lcao_mlist_shift()
      implicit none

#include "mafdecls.fh"
#include "lcao_mlist.fh"

*     **** local variables ****
      integer count,indx,indxp
      integer itmp

      itmp  = int_mb(mlist(1))
      do count=1,size-1
         indx  = mlist(1)+count-1
         indxp = mlist(1)+count
         int_mb(indx) = int_mb(indxp)

      end do
      indx  = mlist(1)+size-1
      int_mb(indx) = itmp

      if (ispin.gt.1) then
        itmp  = int_mb(mlist(1)+(ispin-1)*maxsize)
        do count=1,size-1
           indx  = mlist(1)+count-1+(ispin-1)*maxsize
           indxp = mlist(1)+count  +(ispin-1)*maxsize
           int_mb(indx) = int_mb(indxp)

        end do
        indx  = mlist(1)+size-1+(ispin-1)*maxsize
        int_mb(indx) = itmp
      end if

      return
      end

*> \brief <b> DSYEV computes the eigenvalues and, optionally, the left and/or right eigenvectors for SY matrices</b>
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DSYEV + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dsyev.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dsyev.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dsyev.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DSYEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          JOBZ, UPLO
*       INTEGER            INFO, LDA, LWORK, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), W( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DSYEV computes all eigenvalues and, optionally, eigenvectors of a
*> real symmetric matrix A.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] JOBZ
*> \verbatim
*>          JOBZ is CHARACTER*1
*>          = 'N':  Compute eigenvalues only;
*>          = 'V':  Compute eigenvalues and eigenvectors.
*> \endverbatim
*>
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangle of A is stored;
*>          = 'L':  Lower triangle of A is stored.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA, N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the
*>          leading N-by-N upper triangular part of A contains the
*>          upper triangular part of the matrix A.  If UPLO = 'L',
*>          the leading N-by-N lower triangular part of A contains
*>          the lower triangular part of the matrix A.
*>          On exit, if JOBZ = 'V', then if INFO = 0, A contains the
*>          orthonormal eigenvectors of the matrix A.
*>          If JOBZ = 'N', then on exit the lower triangle (if UPLO='L')
*>          or the upper triangle (if UPLO='U') of A, including the
*>          diagonal, is destroyed.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] W
*> \verbatim
*>          W is DOUBLE PRECISION array, dimension (N)
*>          If INFO = 0, the eigenvalues in ascending order.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The length of the array WORK.  LWORK >= max(1,3*N-1).
*>          For optimal efficiency, LWORK >= (NB+2)*N,
*>          where NB is the blocksize for DSYTRD returned by ILAENV.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*>          > 0:  if INFO = i, the algorithm failed to converge; i
*>                off-diagonal elements of an intermediate tridiagonal
*>                form did not converge to zero.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup doubleSYeigen
*
*  =====================================================================
      SUBROUTINE DSYEV( JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO )
*
*  -- LAPACK driver routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), W( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, LQUERY, WANTZ
      INTEGER            IINFO, IMAX, INDE, INDTAU, INDWRK, ISCALE,
     $                   LLWORK, LWKOPT, NB
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      DOUBLE PRECISION   DLAMCH, DLANSY
      EXTERNAL           LSAME, ILAENV, DLAMCH, DLANSY
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASCL, DORGTR, DSCAL, DSTEQR, DSTERF, DSYTRD,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      WANTZ = LSAME( JOBZ, 'V' )
      LOWER = LSAME( UPLO, 'L' )
      LQUERY = ( LWORK.EQ.-1 )
*
      INFO = 0
      IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
*
      IF( INFO.EQ.0 ) THEN
         NB = ILAENV( 1, 'DSYTRD', UPLO, N, -1, -1, -1 )
         LWKOPT = MAX( 1, ( NB+2 )*N )
         WORK( 1 ) = LWKOPT
*
         IF( LWORK.LT.MAX( 1, 3*N-1 ) .AND. .NOT.LQUERY )
     $      INFO = -8
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYEV ', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         RETURN
      END IF
*
      IF( N.EQ.1 ) THEN
         W( 1 ) = A( 1, 1 )
         WORK( 1 ) = 2
         IF( WANTZ )
     $      A( 1, 1 ) = ONE
         RETURN
      END IF
*
*     Get machine constants.
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      EPS = DLAMCH( 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = SQRT( BIGNUM )
*
*     Scale matrix to allowable range, if necessary.
*
      ANRM = DLANSY( 'M', UPLO, N, A, LDA, WORK )
      ISCALE = 0
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
      IF( ISCALE.EQ.1 )
     $   CALL DLASCL( UPLO, 0, 0, ONE, SIGMA, N, N, A, LDA, INFO )
*
*     Call DSYTRD to reduce symmetric matrix to tridiagonal form.
*
      INDE = 1
      INDTAU = INDE + N
      INDWRK = INDTAU + N
      LLWORK = LWORK - INDWRK + 1
      CALL DSYTRD( UPLO, N, A, LDA, W, WORK( INDE ), WORK( INDTAU ),
     $             WORK( INDWRK ), LLWORK, IINFO )
*
*     For eigenvalues only, call DSTERF.  For eigenvectors, first call
*     DORGTR to generate the orthogonal matrix, then call DSTEQR.
*
      IF( .NOT.WANTZ ) THEN
         CALL DSTERF( N, W, WORK( INDE ), INFO )
      ELSE
         CALL DORGTR( UPLO, N, A, LDA, WORK( INDTAU ), WORK( INDWRK ),
     $                LLWORK, IINFO )
         CALL DSTEQR( JOBZ, N, W, WORK( INDE ), A, LDA, WORK( INDTAU ),
     $                INFO )
      END IF
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         IF( INFO.EQ.0 ) THEN
            IMAX = N
         ELSE
            IMAX = INFO - 1
         END IF
         CALL DSCAL( IMAX, ONE / SIGMA, W, 1 )
      END IF
*
*     Set WORK(1) to optimal workspace size.
*
      WORK( 1 ) = LWKOPT
*
      RETURN
*
*     End of DSYEV
*
      END
c $Id: dsyev.f 24343 2013-06-22 05:35:15Z d3y133 $

c
c $Id: hnd_dipder.F 19696 2010-10-29 16:53:42Z d3y133 $
c
c  Modified from the HONDO dipole integral code
c
      subroutine hnd_dipder(xyzi, expi, coefi,i_nprim,i_ngen, Li,
     *  xyzj, expj, coefj, j_nprim, j_ngen, Lj,
     *  center, buf, lbuf, nint, scr, lscr)
c
c This routine calculates the dipole derivative integrals.  This is a
c wrapper to the work routine hnd_ddipint.
c
      implicit none
c
      integer i_nprim  ! [input] num. prims on function i
      integer i_ngen   ! [input] num general conts on func. i
      integer Li       ! [input] angular momentum of func. i
      integer j_nprim  ! [input] num. prims on function j
      integer j_ngen   ! [input] num general conts on func. j
      integer Lj       ! [input] angular momentum of func. j
      integer lscr     ! [input] size of scratch array
      integer lbuf     ! [input] size of any integral
      integer nint     ! [input] size of any integral buffer
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim)  ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen)  ! [input] j coeffs
      double precision center(3)  ! [input] center for expansion
      double precision scr(lscr)  ! [scratch] scratch buffer
      double precision buf(lbuf)  ! [output] dipole derivative integrals
c
      double precision zero
      data zero   /0.0d+00/
c
# include "hnd_pointers.fh"
c
c Zero out the integral 
c
      call dcopy(nint*18,zero,0,buf,1)
c
c Use scratch for temps in integral calculation
c Scratch needs are 6*(Li+2)*(Lj+2)+12*(Li+1)*(Lj+1)
c
c The pointers are defined in hdn_pointers.fh
c
      call hnd_ddipint(xyzi, expi, coefi,i_nprim,i_ngen, Li,
     *  xyzj, expj, coefj, j_nprim, j_ngen, Lj,
     *  center, buf, buf((nint*9)+1),nint,
     *  scr(tvp(1)),scr(tvp(2)),scr(tvp(3)),scr(tvp(4)),scr(tvp(5)),
     *  scr(tvp(6)),scr(tvp(7)),scr(tvp(8)),scr(tvp(9)),
     *  scr(tvp(10)),scr(tvp(11)),scr(tvp(12)),scr(tvp(13)),
     *  scr(tvp(14)),scr(tvp(15)),scr(tvp(16)),scr(tvp(17)),
     *  scr(tvp(18)))
c
      return
      end
c
      subroutine hnd_ddipint(xyzi, expi, coefi,i_nprim,i_ngen, Li,
     *  xyzj, expj, coefj, j_nprim, j_ngen, Lj, center, didij, djdij, 
     *  nint, xin, yin,zin, xxin, yyin, zzin, dxsdi, dysdi, dzsdi, 
     *  dxxdi, dyydi, dzzdi, dxsdj, dysdj, dzsdj, dxxdj, dyydj, dzzdj)
c
c This is the main work routine for the dipole derivative integrals.
c It is assumed the didij and djdij have been zeroed before entering.
c
      implicit none
#include "hnd_tol.fh"
#include "stdio.fh"
#include "errquit.fh"
      integer i_nprim  ! [input] num. prims on function i
      integer i_ngen   ! [input] num general conts on func. i
      integer Li       ! [input] angular momentum of func. i
      integer j_nprim  ! [input] num. prims on function j
      integer j_ngen   ! [input] num general conts on func. j
      integer Lj       ! [input] angular momentum of func. j
      integer nint     ! [input] number of base integrals
      double precision xyzi(3)  ! [input] position of center i
      double precision expi(i_nprim) ! [input] exponents on i
      double precision coefi(i_nprim,i_ngen) ! [input] i coeffs
      double precision xyzj(3)  ! [input] position of center j
      double precision expj(j_nprim)  ! [input] exponents on j
      double precision coefj(j_nprim,j_ngen)  ! [input] j coeffs
      double precision center(3)  ! [input] center for expansion
      double precision didij(nint,9) ! [output] dip.der. integrals wrt i
      double precision djdij(nint,9) ! [ouptut] dip.der. integrals wrt j
c
      integer ni, nj
      integer ijx, ijy, ijz, ix, iy, iz, jx, jy, jz
      integer nder, lit, ljt, litder, ljtder
      integer maxi, maxj
      integer ig, jg, ij, i, j
      double precision zero, one
      double precision rln10, tol
      double precision rr, ai, arri, axi, ayi, azi
      double precision aj, aa, aa1, dum, fac
      double precision csi, cpi, cdi, cfi, cgi
      double precision csj, cpj, cdj, cfj, cgj
      double precision ax, ay, az, dum1, dum2
      double precision dij
      double precision xin, yin,zin, xxin, yyin, zzin
      double precision dxsdi, dysdi, dzsdi, dxxdi, dyydi, dzzdi
      double precision dxsdj, dysdj, dzsdj, dxxdj, dyydj, dzzdj
      double precision dumxdx, dumydx, dumzdx
      double precision dumxdy, dumydy, dumzdy
      double precision dumxdz, dumydz, dumzdz
      double precision xint, yint, zint, xintx, yinty, zintz
      double precision t, xc, yc, zc, x0, y0, z0
      double precision xi, yi, zi, xj, yj, zj
      double precision t1
c
      common/hnd_xyzdip/xint,yint,zint,xintx,yinty,zintz,t,xc,yc,zc,
     1              x0,y0,z0,xi,yi,zi,xj,yj,zj,ni,nj
      dimension   xin(Li+2,Lj+2),  yin(Li+2,Lj+2),  zin(Li+2,Lj+2)
      dimension  xxin(Li+2,Lj+2), yyin(Li+2,Lj+2), zzin(Li+2,Lj+2)
      dimension dxsdi(Li+1,Lj+1),dysdi(Li+1,Lj+1),dzsdi(Li+1,Lj+1)
      dimension dxsdj(Li+1,Lj+1),dysdj(Li+1,Lj+1),dzsdj(Li+1,Lj+1)
      dimension dxxdi(Li+1,Lj+1),dyydi(Li+1,Lj+1),dzzdi(Li+1,Lj+1)
      dimension dxxdj(Li+1,Lj+1),dyydj(Li+1,Lj+1),dzzdj(Li+1,Lj+1)
      dimension Nxyz(3)
      data zero  /0.0d+00/
      data one   /1.0e+00/
      data rln10 /2.30258d+00/
c
      tol=rln10*itol
      nder = 1
c
      xc=center(1)
      yc=center(2)
      zc=center(3)
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi=lit*(lit+1)/2
c
      litder=lit+nder
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj=ljt*(ljt+1)/2
c
      ljtder=ljt+nder
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
      nroots=(lit+ljt-2)/2+1
      if(nroots.gt.maxrys) then
         write(luout,9997) maxrys,lit,ljt,nroots
         call errquit('hnd_dipder: angular momentum too high',555,
     &       BASIS_ERR)
      endif
c
c     ----- i primitive -----
c
      do 7000 ig=1,i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do 6000 jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=one/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) go to 6000  ! the integral is zero
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      dij=fac*csi*csj
c
c     ----- dipole moment integrals -----
c
      t = sqrt(aa)
      t1=one/t
      x0=ax
      y0=ay
      z0=az
      do 370 j=1,ljtder
      nj=j
      do 370 i=1,litder
      ni=i
      call hnd_dipxyz
       xin(i,j)=xint*t1
       yin(i,j)=yint*t1
       zin(i,j)=zint*t1
      xxin(i,j)=xintx*t1
      yyin(i,j)=yinty*t1
      zzin(i,j)=zintz*t1
  370 continue
c
      call hnd_deriaj(dxsdi,dysdi,dzsdi,dxsdj,dysdj,dzsdj,
     *                xin,yin,zin,
     *                lit,ljt,ai,aj)
      call hnd_deriaj(dxxdi,dyydi,dzzdi,dxxdj,dyydj,dzzdj,
     *                xxin,yyin,zzin,
     *                lit,ljt,ai,aj)
      ij=0
      do 390 i=1,maxi
      call getNxyz(Li,i,Nxyz)
      ix = Nxyz(1) + 1
      iy = Nxyz(2) + 1
      iz = Nxyz(3) + 1
      do 390 j=1,maxj
      call getNxyz(Lj,j,Nxyz)
      jx = Nxyz(1) + 1
      jy = Nxyz(2) + 1
      jz = Nxyz(3) + 1
      ij=ij+1
c
c  First do derivative wrt the first atom
c
      dumxdx = dxxdi(ix,jx)*  yin(iy,jy)*  zin(iz,jz)
      dumydx = dxsdi(ix,jx)* yyin(iy,jy)*  zin(iz,jz)
      dumzdx = dxsdi(ix,jx)*  yin(iy,jy)* zzin(iz,jz)
      dumxdy =  xxin(ix,jx)*dysdi(iy,jy)*  zin(iz,jz)
      dumydy =   xin(ix,jx)*dyydi(iy,jy)*  zin(iz,jz)
      dumzdy =   xin(ix,jx)*dysdi(iy,jy)* zzin(iz,jz)
      dumxdz =  xxin(ix,jx)*  yin(iy,jy)*dzsdi(iz,jz)
      dumydz =   xin(ix,jx)* yyin(iy,jy)*dzsdi(iz,jz)
      dumzdz =   xin(ix,jx)*  yin(iy,jy)*dzzdi(iz,jz)
c
      didij(ij,1) = didij(ij,1) + dij*dumxdx
      didij(ij,2) = didij(ij,2) + dij*dumydx
      didij(ij,3) = didij(ij,3) + dij*dumzdx
      didij(ij,4) = didij(ij,4) + dij*dumxdy
      didij(ij,5) = didij(ij,5) + dij*dumydy
      didij(ij,6) = didij(ij,6) + dij*dumzdy
      didij(ij,7) = didij(ij,7) + dij*dumxdz
      didij(ij,8) = didij(ij,8) + dij*dumydz
      didij(ij,9) = didij(ij,9) + dij*dumzdz
c
c  Next do derivative wrt the second atom
c
      dumxdx = dxxdj(ix,jx)*  yin(iy,jy)*  zin(iz,jz)
      dumydx = dxsdj(ix,jx)* yyin(iy,jy)*  zin(iz,jz)
      dumzdx = dxsdj(ix,jx)*  yin(iy,jy)* zzin(iz,jz)
      dumxdy =  xxin(ix,jx)*dysdj(iy,jy)*  zin(iz,jz)
      dumydy =   xin(ix,jx)*dyydj(iy,jy)*  zin(iz,jz)
      dumzdy =   xin(ix,jx)*dysdj(iy,jy)* zzin(iz,jz)
      dumxdz =  xxin(ix,jx)*  yin(iy,jy)*dzsdj(iz,jz)
      dumydz =   xin(ix,jx)* yyin(iy,jy)*dzsdj(iz,jz)
      dumzdz =   xin(ix,jx)*  yin(iy,jy)*dzzdj(iz,jz)
c
      djdij(ij,1) = djdij(ij,1) + dij*dumxdx
      djdij(ij,2) = djdij(ij,2) + dij*dumydx
      djdij(ij,3) = djdij(ij,3) + dij*dumzdx
      djdij(ij,4) = djdij(ij,4) + dij*dumxdy
      djdij(ij,5) = djdij(ij,5) + dij*dumydy
      djdij(ij,6) = djdij(ij,6) + dij*dumzdy
      djdij(ij,7) = djdij(ij,7) + dij*dumxdz
      djdij(ij,8) = djdij(ij,8) + dij*dumydz
      djdij(ij,9) = djdij(ij,9) + dij*dumzdz
  390 continue
c
 6000 continue
 7000 continue
      return
c
 9997 format(' in -hnd_stvint- the rys quadrature is not implemented',
     1       ' beyond -nroots- = ',i2,/,
     2       ' lit,ljt,nroots= ',3i3)
      end

c $Id: tamd_input.F 25988 2014-08-12 01:16:48Z bylaska $

*     *********************************************
*     *                                           *
*     *              tamd_input                   *
*     *                                           *
*     *********************************************
      subroutine tamd_input(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "geom.fh"
#include "util.fh"
#include "nwc_const.fh"
#include "errquit.fh"
c
c

      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 22)
      character*18 dirs(num_dirs)
      data dirs / 'update',
     >            'zfixed',
     >            'print',
     >            'print_shift',
     >            'bond',
     >            'angle',
     >            'dihedral',
     >            'coord_number',
     >            'n-plane',
     >            'x',
     >            'y',
     >            'z',
     >            'tempered',
     >            'boundary',
     >            'potential_filename',
     >            'ld_trace',
     >            'sn2-surface',
     >            '2bonds',
     >            'ld_trace2diff',
     >            'bond_difference2',
     >            'equation',
     >            'end'/

      integer num_dirs2          ! No. of known directives
      parameter (num_dirs2 = 13)
      character*10 dirs2(num_dirs2)
      data dirs2 / 'index1',
     >             'index2',
     >             'n',
     >             'm',
     >             'r0',
     >             'gamma',
     >             'k',
     >             'mass',
     >             'ztemp',
     >             'zinitial',
     >             'range',
     >             'nrange',
     >             'sprik'/

      integer num_dirs3          ! No. of known directives
      parameter (num_dirs3 = 8)
      character*10 dirs3(num_dirs3)
      data dirs3 / 'gamma',
     >             'k',
     >             'mass',
     >             'ztemp',
     >             'zinitial',
     >             'range',
     >             'nrange',
     >             'nvector'/
c
      logical       value,spline,zfixed
      character*80  rtdb_name
      character*255 test,dir_name,sdir_name
      character*4   elem1,elem2
      integer ind,ind2,ind3           ! Index of matched directive

      integer metaindexmax
      integer nmeta,nxmeta_all,nindxmeta,nparammeta
      integer maxmetacount,metacount,metarayshift,metaraycount
      integer maxmetaprintcount
      integer j,jstart,jlast,jstride,n1,n2,i,d,jj(10)
      integer nka,nkb,nkc,nkd,nka_gs,nkb_gs,nkc_gs,nkd_gs

      integer sindx(50),index_start1(2),index_start2(2)
      integer pmeta(2),ameta(2),bmeta(2),indxmeta(2),sindxmeta(2)
      integer nxmeta(2),parammeta(2),sparammeta(2),ymeta(2)
      real*8  sdist(50),dTtempered

      integer nemach
      character*500 eqnstring

*     **** external functions ****
      character*7 c_index_name
      external    c_index_name
      logical     nwpw_parse_boolean
      external    nwpw_parse_boolean
      integer     nwpw_expression_compile
      external    nwpw_expression_compile

      metaindexmax = 1000
      nmeta = 0
      nxmeta_all = 1
      nindxmeta  = 0
      nparammeta = 0

      if (.not.MA_push_get(mt_int,10,'nxmeta',
     >                    nxmeta(2),nxmeta(1)))
     >   call errquit('cannot allocate stack for tamd_input',0,
     >                MA_ERR)

      if (.not.MA_push_get(mt_int,10,'sindxmeta',
     >                    sindxmeta(2),sindxmeta(1)))
     >   call errquit('cannot allocate stack for tamd_input',0,
     >                MA_ERR)

      if (.not.MA_push_get(mt_int,10,'sparammeta',
     >                    sparammeta(2),sparammeta(1)))
     >   call errquit('cannot allocate stack for tamd_input',0,
     >                MA_ERR)

      if (.not.MA_push_get(mt_int,metaindexmax,'indxmeta',
     >                    indxmeta(2),indxmeta(1)))
     >   call errquit('cannot allocate stack for tamd_input',0,
     >                MA_ERR)

      if (.not.MA_push_get(mt_int,10,'pmmeta',
     >                    pmeta(2),pmeta(1)))
     >   call errquit('cannot allocate stack for tamd_input',2,
     >                MA_ERR)

      if (.not.MA_push_get(mt_dbl,10,'ammeta',
     >                    ameta(2),ameta(1)))
     >   call errquit('cannot allocate stack for tamd_input',2,
     >                MA_ERR)

      if (.not.MA_push_get(mt_dbl,10,'bmmeta',
     >                    bmeta(2),bmeta(1)))
     >   call errquit('cannot allocate stack for tamd_input',3,
     >                MA_ERR)

      if (.not.MA_push_get(mt_dbl,metaindexmax,'parammeta',
     >                    parammeta(2),parammeta(1)))
     >   call errquit('cannot allocate stack for tamd_input',1,
     >                MA_ERR)


 10   if (.not. inp_read()) 
     >  call errquit(
     >  'tamd_input: inp_read failed',0,INPUT_ERR)
      if (.not. inp_a(test))
     >  call errquit(
     >  'tamd_input: failed to read keyword',0,INPUT_ERR)

      if (.not. inp_match(num_dirs,.false.,test,dirs,ind))
     >  call errquit(
     >  'tamd_input: unknown_directive',ind,INPUT_ERR)

      goto ( 100, 110, 120,150, 200, 300, 400, 500,600,701,702,703,800,
     >       900,1000,1100,1200,1300,1400,1500,1700,
     >      9999) ind
      call errquit(
     >     'tamd_input: unimplemented directive',ind,INPUT_ERR)

c
c  update
c
 100  if (inp_i(sindx(1))) then
         rtdb_name = 'tamd_update'
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,sindx)
         if (.not. value) call errquit(
     >   'tamd_input:failed writing update',0, RTDB_ERR)
      end if

      goto 10

c
c  zfixed [True|False|...]
c
 110  if (inp_a(sdir_name)) then
         zfixed = nwpw_parse_boolean(sdir_name,.true.)
      else
         zfixed = .true.
      end if
      rtdb_name = 'tamd_zfixed'
      value = rtdb_put(rtdb,rtdb_name,mt_log,1,zfixed)
      if (.not. value) call errquit(
     >'tamd_input:failed writing update',0, RTDB_ERR)

      goto 10

c
c  print
c
 120  if (inp_i(sindx(1))) then
         rtdb_name = 'tamd_print'
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,sindx)
         if (.not. value) call errquit(
     >   'tamd_input:failed writing update',0, RTDB_ERR)
      end if

      goto 10

c
c  print_shift
c
 150  if (inp_i(sindx(1))) then
         rtdb_name = 'tamd_print_shift'
         value = rtdb_put(rtdb,rtdb_name,mt_int,1,sindx)
         if (.not. value) call errquit(
     >   'tamd_input:failed writing update',150, RTDB_ERR)
      end if

      goto 10


c
c  bond
c
 200  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then

*     **** set defaults for gamma,k,mass,ztemp,zinitial ****
      sdist(1) =    0.00010d0
      sdist(2) =    0.05000d0
      sdist(3) =   30.0d0
      sdist(4) = 1000.0d0
      sdist(5) = -1.0
      sdist(6) = -1.0
      sdist(7) = -1.0
      sdist(8) = -1.0
      sindx(3) = 501

 201  if (.not.inp_a(test)) goto 299
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'tamd_input: unknown directive',0,INPUT_ERR)

      goto ( 210,220,230,240,250,260,270) ind3
      call errquit(
     >     'tamd_input: unimplemented directive',ind3,INPUT_ERR)

c
c gamma, default=0.00010 au = 0.06275 kcal/mol
c
 210  if (.not.inp_f(sdist(1))) sdist(1)=0.00010d0
      goto 201
c
c k, default = 0.05 au
c
 220  if (.not.inp_f(sdist(2))) sdist(2)=0.05d0
      goto 201
c
c mass, default=30.0 au
c
 230  if (.not.inp_f(sdist(3))) sdist(3)= 30.0d0
      goto 201
c
c ztemp, default = 1000.0K
c
 240  if (.not.inp_f(sdist(4))) sdist(4)=1000.0d0
      goto 201

c
c zinitial
c
 250  if (.not.inp_f(sdist(5))) sdist(5)=-1.0d0
      if (.not.inp_f(sdist(6))) sdist(6)=-1.0d0
      goto 201

c
c range
c
 260  if (.not.inp_f(sdist(7))) sdist(7)=-1.0d0
      if (.not.inp_f(sdist(8))) sdist(8)=-1.0d0
      goto 201

c
c nrange, default = 501
c
 270  if (.not.inp_i(sindx(3))) sindx(3)=501
      goto 201



 299  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 1
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      nindxmeta  = nindxmeta + 3

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      dbl_mb(parammeta(1)+nparammeta+2) = sdist(3)
      dbl_mb(parammeta(1)+nparammeta+3) = sdist(4)
      dbl_mb(parammeta(1)+nparammeta+4) = sdist(5)
      dbl_mb(parammeta(1)+nparammeta+5) = sdist(6)
      nparammeta  = nparammeta + 6

      nxmeta_all = nxmeta_all*sindx(3)
      int_mb(nxmeta(1)+nmeta) = sindx(3)
      dbl_mb(ameta(1)+nmeta)  = sdist(7)
      dbl_mb(bmeta(1)+nmeta)  = sdist(8)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'tamd_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'tamd_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'tamd_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'tamd_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'tamd_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'tamd_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'tamd_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'tamd_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'tamd_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'tamd_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'tamd_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'tamd_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'tamd_input:failed writing bond',0,RTDB_ERR)

      end if
      end if

      goto 10

c
c  angle
c
 300  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then

*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(3) = -999.0d0
      sdist(4) = -999.0d0
      sindx(4) = 501

 301  if (.not.inp_a(test)) goto 399
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto (310,320,330,340) ind3
      call errquit(
     >     'metadynamics_input: unimplemented directive',ind3,INPUT_ERR)

c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 310  if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 301
c
c sigma, default = 0.1 au
c
 320  if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 301
c
c range
c
 330  if (.not.inp_f(sdist(3))) sdist(3)=-999.0d0
      if (.not.inp_f(sdist(4))) sdist(4)=-999.0d0
      goto 301
c
c nrange, default = 501
c
 340  if (.not.inp_i(sindx(4))) sindx(4)=501
      goto 301

 399  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 2
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      int_mb(indxmeta(1)+nindxmeta+3) = sindx(3)
      nindxmeta  = nindxmeta + 4

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      nparammeta  = nparammeta + 2

      nxmeta_all = nxmeta_all*sindx(4)
      int_mb(nxmeta(1)+nmeta) = sindx(4)
      dbl_mb(ameta(1)+nmeta)  = sdist(3)
      dbl_mb(bmeta(1)+nmeta)  = sdist(4)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing angle',0,RTDB_ERR)

      end if
      end if
      end if

      goto 10

c
c  dihedral
c
 400  if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then

*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(3) = -999.0d0
      sdist(4) = -999.0d0
      sindx(5) = 501

 401  if (.not.inp_a(test)) goto 499
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto (410,420,430,440) ind3
      call errquit(
     >     'metadynamics_input: unimplemented directive',ind3,INPUT_ERR)

c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 410  if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 401
c
c sigma, default = 0.1 au
c
 420  if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 401
c
c range
c
 430  if (.not.inp_f(sdist(3))) sdist(3)=-4.0d0*datan(1.0d0)
      if (.not.inp_f(sdist(4))) sdist(4)= 4.0d0*datan(1.0d0)
      goto 401
c
c nrange, default = 501
c
 440  if (.not.inp_i(sindx(5))) sindx(5)=501
      goto 401

 499  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 3
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      int_mb(indxmeta(1)+nindxmeta+3) = sindx(3)
      int_mb(indxmeta(1)+nindxmeta+4) = sindx(4)
      nindxmeta  = nindxmeta + 5

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      nparammeta  = nparammeta + 2

      nxmeta_all = nxmeta_all*sindx(5)
      int_mb(nxmeta(1)+nmeta) = sindx(5)
      dbl_mb(ameta(1)+nmeta)  = sdist(3)
      dbl_mb(bmeta(1)+nmeta)  = sdist(4)
      int_mb(pmeta(1)+nmeta)  = 1

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing dihedral',0,RTDB_ERR)

      end if
      end if
      end if
      end if

      goto 10

c
c  coord_number
c
 500  if (.not.MA_push_get(mt_int,nw_max_atom,'indx_start1',
     >                    index_start1(2),index_start1(1)))
     >    call errquit(
     > 'metadynamics_input:failed allocating index_start1',0,MA_ERR)
      if (.not.MA_push_get(mt_int,nw_max_atom,'indx_start2',
     >                    index_start2(2),index_start2(1)))
     >    call errquit(
     > 'metadynamics_input:failed allocating index_start2',0,MA_ERR)

      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(3) = 6.0d0
      sdist(4) = 12.0d0
      sdist(5) = 3.0d0
      sdist(6) = -1.0d0
      sdist(7) = -1.0d0
      sdist(8) = -1.0d0
      sindx(1) = 501
      n1 = 0
      n2 = 0
 501  if (.not. inp_a(test)) goto 599
      if (.not. inp_match(num_dirs2,.false.,test,dirs2,ind2))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto ( 510,520,530,540,550,560,570,580,590,595 ) ind2
      call errquit(
     >     'metadynamics_input: unimplemented directive',ind2,INPUT_ERR)
c
c index1
c
 510  n1 = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start1(1)+n1) = j
          n1 = n1+1
         end do
      end do

      goto 501
c
c index2 
c
 520  n2 = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start2(1)+n2) = j
          n2 = n2+1
         end do
      end do

      goto 501
c
c n
c
 530  if (.not.inp_f(sdist(3))) sdist(3)=6.0d0
      goto 501
c
c m
c
 540  if (.not.inp_f(sdist(4))) sdist(4)=12.0d0
      goto 501
c
c r0
c
 550  if (.not.inp_f(sdist(5))) sdist(5)=3.0d0
      goto 501
c
c w
c
 560  if (.not.inp_f(sdist(1))) sdist(1)=0.00005
      goto 501
c
c sigma
c
 570  if (.not.inp_f(sdist(2))) sdist(2)=0.10d0
      goto 501
c
c range
c
 580  if (.not.inp_f(sdist(7))) sdist(7)=-1.0d0
      if (.not.inp_f(sdist(8))) sdist(8)=-1.0d0
      goto 501
c
c nrange
c
 590  if (.not.inp_i(sindx(1))) sindx(1)=501
      goto 501
c
c sprik
c
 595  sdist(6)=1.0d0
      goto 501

 599  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 4
      int_mb(indxmeta(1)+nindxmeta+1) = n1
      int_mb(indxmeta(1)+nindxmeta+2) = n2
      do j=1,n1
         int_mb(indxmeta(1)+nindxmeta+2+j) 
     >      = int_mb(index_start1(1)+j-1)
      end do
      do j=1,n2
         int_mb(indxmeta(1)+nindxmeta+2+n1+j) 
     >      = int_mb(index_start2(1)+j-1)
      end do
      nindxmeta  = nindxmeta + 3+n1+n2

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      dbl_mb(parammeta(1)+nparammeta+2) = sdist(3)
      dbl_mb(parammeta(1)+nparammeta+3) = sdist(4)
      dbl_mb(parammeta(1)+nparammeta+4) = sdist(5)
      dbl_mb(parammeta(1)+nparammeta+5) = sdist(6)
      nparammeta  = nparammeta + 6

      nxmeta_all = nxmeta_all*sindx(1)
      int_mb(nxmeta(1)+nmeta) = sindx(1)
      dbl_mb(ameta(1)+nmeta)  = sdist(7)
      dbl_mb(bmeta(1)+nmeta)  = sdist(8)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing coord_num',0,RTDB_ERR)

      if (.not.MA_pop_stack(index_start2(2))) call errquit(
     > 'metadynamics_input:failed deallocating index_start2',0,MA_ERR)
      if (.not.MA_pop_stack(index_start1(2))) call errquit(
     > 'metadynamics_input:failed deallocating index_start1',0,MA_ERR)

      goto 10

c
c  n-plane
c
 600  if (inp_i(sindx(1))) then
      n1 = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(index_start1(1)+n1) = j
          n1 = n1+1
         end do
      end do

*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(3) = 0.0d0
      sdist(4) = 0.0d0
      sdist(5) = 1.0d0
      sdist(6) = -999.0d0
      sdist(7) = -999.0d0
      sindx(2) = 501

 601  if (.not.inp_a(test)) goto 699
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto ( 610,620,630,640,650) ind3
      call errquit(
     >   'metadynamics_inputn: unimplemented directive',ind3,INPUT_ERR)

c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 610  if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 601
c
c sigma, default = 0.1 au
c
 620  if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 601
c
c range
c
 630  if (.not.inp_f(sdist(6))) sdist(6)=-999.0d0
      if (.not.inp_f(sdist(7))) sdist(7)=-999.0d0
      goto 601
c
c nrange, default = 501
c
 640  if (.not.inp_i(sindx(2))) sindx(2)=501
      goto 601
c
c normal
c
 650  if (.not.inp_f(sdist(3))) sdist(3)=0.0d0
      if (.not.inp_f(sdist(4))) sdist(4)=0.0d0
      if (.not.inp_f(sdist(5))) sdist(5)=1.0d0
      goto 601

 699  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 5
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = n1
      do j=1,n1
         int_mb(indxmeta(1)+nindxmeta+2+j)
     >      = int_mb(index_start1(1)+j-1)
      end do
      nindxmeta  = nindxmeta + 3+n1

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      dbl_mb(parammeta(1)+nparammeta+2) = sdist(3)
      dbl_mb(parammeta(1)+nparammeta+3) = sdist(4)
      dbl_mb(parammeta(1)+nparammeta+4) = sdist(5)
      nparammeta  = nparammeta + 5

      nxmeta_all = nxmeta_all*sindx(2)
      int_mb(nxmeta(1)+nmeta) = sindx(2)
      dbl_mb(ameta(1)+nmeta)  = sdist(6)
      dbl_mb(bmeta(1)+nmeta)  = sdist(7)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing n-plane',0,RTDB_ERR)

      end if
      goto 10

c
c  x,y,z
c
 701  sindx(1) = 1
      goto 704
 702  sindx(1) = 2
      goto 704
 703  sindx(1) = 3
      goto 704

 704  if (inp_i(sindx(2))) then

*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(3) = -999.0d0
      sdist(4) = -999.0d0
      sindx(3) = 501

 705  if (.not.inp_a(test)) goto 799
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto ( 710,720,730,740) ind3
      call errquit(
     >     'metadynamics_input: unimplemented directive',ind3,INPUT_ERR)

c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 710  if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 705
c
c sigma, default = 0.1 au
c
 720  if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 705
c
c range
c
 730  if (.not.inp_f(sdist(3))) sdist(3)=-999.0d0
      if (.not.inp_f(sdist(4))) sdist(4)=-999.0d0
      goto 705
c
c nrange, default = 501
c
 740  if (.not.inp_i(sindx(3))) sindx(3)=501
      goto 705


 799  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 6
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      nindxmeta  = nindxmeta + 3

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      nparammeta  = nparammeta + 2

      nxmeta_all = nxmeta_all*sindx(3)
      int_mb(nxmeta(1)+nmeta) = sindx(3)
      dbl_mb(ameta(1)+nmeta)  = sdist(3)
      dbl_mb(bmeta(1)+nmeta)  = sdist(4)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing x,y,z',0,RTDB_ERR)

      end if
      goto 10
 


c
c  tempered
c
 800  if (.not.inp_f(sdist(1))) sdist(1)=-1.0d0
      rtdb_name='metadynamics_tempered'
      if (.not.rtdb_put(rtdb,rtdb_name,mt_dbl,1,sdist))
     >   call errquit('metadynamics_input:failed writing tempered',
     >                 0,RTDB_ERR)

      goto 10

c
c  boundary
c
 900  if (.not.inp_f(sdist(1))) sdist(1)= 0.0d0
      if (.not.inp_f(sdist(2))) sdist(2)= 1.0d0
      rtdb_name='metadynamics_boundary'
      if (.not.rtdb_put(rtdb,rtdb_name,mt_dbl,2,sdist))
     >   call errquit('metadynamics_input:failed writing boundary',
     >                 0,RTDB_ERR)
      goto 10

c
c  potential_filename
c
 1000  if (inp_a(rtdb_name)) then
          call util_file_name_noprefix(rtdb_name,.false.,
     >                                 .false.,
     >                                 test)
          write(*,'(A,A)') 
     >      "....Reading metadynamics potential_filename=",rtdb_name
          open(unit=53,file=test,form='formatted')
 
          read(53,*) test
          read(53,*) test,nmeta
          read(53,*) test,(int_mb(nxmeta(1)+i-1),i=1,nmeta)
          read(53,*) test,(int_mb(sindxmeta(1)+i-1),i=1,nmeta)
          read(53,*) test,(int_mb(sparammeta(1)+i-1),i=1,nmeta)
          read(53,*) test,(dbl_mb(ameta(1)+i-1),i=1,nmeta)
          read(53,*) test,(dbl_mb(bmeta(1)+i-1),i=1,nmeta)
          read(53,*) test,(int_mb(pmeta(1)+i-1),i=1,nmeta)
          read(53,*) test,nindxmeta
          read(53,*) test,(int_mb(indxmeta(1)+i-1),i=1,nindxmeta)
          read(53,*) test,nparammeta
          read(53,*) test,(dbl_mb(parammeta(1)+i-1),i=1,nparammeta)
          read(53,*) test,maxmetacount
          read(53,*) test,metacount
          read(53,*) test,metarayshift
          read(53,*) test,metaraycount
          read(53,*) test,maxmetaprintcount
          read(53,*) test,dTtempered
          read(53,*) test,nxmeta_all

          if (.not.MA_push_get(mt_dbl,nxmeta_all,'ymmeta',
     >                         ymeta(2),ymeta(1)))
     >    call errquit('cannot allocate stack, metadynamics_input',22,
     >                 MA_ERR)

          do d=1,nmeta
             jj(d) = 0
          end do
          do i=1,nxmeta_all
             read(53,'(12F15.6)')
     >            (sdist(d),d=1,nmeta),dbl_mb(ymeta(1)+i-1)

             jj(1) = jj(1) + 1
             if (jj(1).ge.int_mb(nxmeta(1))) then
                read(53,*)
             end if
             do d=1,nmeta-1
                if (jj(d).ge.int_mb(nxmeta(1)+d-1)) then
                   jj(d) = 0
                   jj(d+1) = jj(d+1)+1
                end if
             end do
          end do
          close(53)

          rtdb_name = 'metadynamics_nindxmeta'
          value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
          rtdb_name = 'metadynamics_sindxmeta'
          value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
          rtdb_name = 'metadynamics_indxmeta'
          value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                     nindxmeta,int_mb(indxmeta(1)))
          rtdb_name = 'metadynamics_nparammeta'
          value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
          rtdb_name = 'metadynamics_sparammeta'
          value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                     nmeta,int_mb(sparammeta(1)))
          rtdb_name = 'metadynamics_parammeta'
          value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                     nparammeta,dbl_mb(parammeta(1)))
          rtdb_name = 'metadynamics_ameta'
          value = value.and.
     >            rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
          rtdb_name = 'metadynamics_bmeta'
          value = value.and.
     >            rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
          rtdb_name = 'metadynamics_pmeta'
          value = value.and.
     >            rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
          rtdb_name = 'metadynamics_nxmeta'
          value = value.and.
     >           rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
          rtdb_name = 'metadynamics_nmeta'
          value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
          rtdb_name = 'metadynamics_nxmeta_all'
          value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)

          rtdb_name = 'metadynamics_update'
          value=value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,maxmetacount)
          rtdb_name = 'metadynamics_metacount'
          value=value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,metacount)
          rtdb_name = 'metadynamics_print_shift'
          value=value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,metarayshift)
          rtdb_name = 'metadynamics_metaraycount'
          value=value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,metaraycount)
          rtdb_name = 'metadynamics_print'
          value=value.and.
     >          rtdb_put(rtdb,rtdb_name,mt_int,1,maxmetaprintcount)
          rtdb_name = 'metadynamics_tempered'
          value=value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,1,dTtempered)
          rtdb_name = 'metadynamics_ymeta'
          value=value.and.
     >       rtdb_put(rtdb,rtdb_name,mt_dbl,nxmeta_all,dbl_mb(ymeta(1)))

          if (.not. value) call errquit(
     >    'metadynamics_input:writing potential_filename',0,RTDB_ERR)

          if (.not.MA_pop_stack(ymeta(2)))
     >    call errquit('cannot pop stack for metadynamics_input',22,
     >                 MA_ERR)
      end if
      goto 10

c
c  ld_trace: local_density_trace ion_index l  ........
c
 1100 if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then

*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(3) = -999.0d0
      sdist(4) = -999.0d0
      sindx(3) = 501

 1101 if (.not.inp_a(test)) goto 1199
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto ( 1110,1120,1130,1140) ind3
      call errquit(
     >     'metadynamics_input: unimplemented directive',ind3,INPUT_ERR)

c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 1110 if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 1101
c
c sigma, default = 0.1 au
c
 1120  if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 1101
c
c range
c
 1130  if (.not.inp_f(sdist(3))) sdist(3)=-999.0d0
      if (.not.inp_f(sdist(4))) sdist(4)=-999.0d0
      goto 1101
c
c nrange, default = 1101
c
 1140  if (.not.inp_i(sindx(3))) sindx(3)=501
      goto 1101


 1199  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 7
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      nindxmeta  = nindxmeta + 3

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      nparammeta  = nparammeta + 2

      nxmeta_all = nxmeta_all*sindx(3)
      int_mb(nxmeta(1)+nmeta) = sindx(3)
      dbl_mb(ameta(1)+nmeta)  = sdist(3)
      dbl_mb(bmeta(1)+nmeta)  = sdist(4)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing bond',0,RTDB_ERR)

      end if
      end if

      goto 10

c
c  sn2-surface type dr wr ar br dp wp ap bp er ep erp
c
 1200 if (inp_f(sdist(1)).and.
     >    inp_f(sdist(2)).and.
     >    inp_f(sdist(3)).and.
     >    inp_f(sdist(4)).and.
     >    inp_f(sdist(5)).and.
     >    inp_f(sdist(6)).and.
     >    inp_f(sdist(7)).and.
     >    inp_f(sdist(8)).and.
     >    inp_f(sdist(9)).and.
     >    inp_f(sdist(10)).and.
     >    inp_f(sdist(11)).and.
     >    inp_f(sdist(12)) ) then

      rtdb_name = 'metadynamics_sn2-surface'
      if (.not.rtdb_put(rtdb,rtdb_name,mt_dbl,12,sdist))
     >   call errquit('metadynamics_input:failed writing sn2-surface',
     >                 0,RTDB_ERR)
     
      end if

      goto 10
c
c  2bonds indx1 indx2 indx3 indx3 d1a d2a d1b d2b
c
 1300 if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then
      if (inp_i(sindx(4))) then

      if (inp_f(sdist(3))) then
      if (inp_f(sdist(4))) then
      if (inp_f(sdist(5))) then
      if (inp_f(sdist(6))) then

*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(7) = 0.0d0
      sdist(8) = 1.0d0
      sindx(5) = 501

 1301 if (.not.inp_a(test)) goto 1399
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto ( 1310,1320,1330,1340) ind3
      call errquit(
     >     'metadynamics_input: unimplemented directive',ind3,INPUT_ERR)

c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 1310 if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 1301
c
c sigma, default = 0.1 au
c
 1320 if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 1301
c
c range
c
 1330 if (.not.inp_f(sdist(7))) sdist(7)=0.0d0
      if (.not.inp_f(sdist(8))) sdist(8)=1.0d0
      goto 1301
c
c nrange, default = 501
c
 1340 if (.not.inp_i(sindx(5))) sindx(5)=501
      goto 1301

 1399  continue

      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 8
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      int_mb(indxmeta(1)+nindxmeta+3) = sindx(3)
      int_mb(indxmeta(1)+nindxmeta+4) = sindx(4)
      nindxmeta  = nindxmeta + 5

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      dbl_mb(parammeta(1)+nparammeta+2) = sdist(3)
      dbl_mb(parammeta(1)+nparammeta+3) = sdist(4)
      dbl_mb(parammeta(1)+nparammeta+4) = sdist(5)
      dbl_mb(parammeta(1)+nparammeta+5) = sdist(6)
      nparammeta  = nparammeta + 6

      nxmeta_all = nxmeta_all*sindx(5)
      int_mb(nxmeta(1)+nmeta) = sindx(5)
      dbl_mb(ameta(1)+nmeta)  = sdist(7)
      dbl_mb(bmeta(1)+nmeta)  = sdist(8)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing bond',0,RTDB_ERR)

      end if
      end if
      end if
      end if
      end if
      end if
      end if
      end if

      goto 10


c
c  ld_trace2diff: local_density_trace ion_index1 ion_index2 l  ........
c
 1400 if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then

*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(3) = -999.0d0
      sdist(4) = -999.0d0
      sindx(4) = 501

 1401 if (.not.inp_a(test)) goto 1499
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'metadynamics_input: unknown directive',0,INPUT_ERR)

      goto ( 1410,1420,1430,1440) ind3
      call errquit(
     >     'metadynamics_input: unimplemented directive',ind3,INPUT_ERR)

c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 1410 if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 1401
c
c sigma, default = 0.1 au
c
 1420  if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 1401
c
c range
c
 1430  if (.not.inp_f(sdist(3))) sdist(3)=-999.0d0
      if (.not.inp_f(sdist(4))) sdist(4)=-999.0d0
      goto 1401
c
c nrange, default = 501
c
 1440  if (.not.inp_i(sindx(4))) sindx(4)=501
      goto 1401


 1499  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 9
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      int_mb(indxmeta(1)+nindxmeta+3) = sindx(3)
      nindxmeta  = nindxmeta + 4

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      nparammeta  = nparammeta + 2

      nxmeta_all = nxmeta_all*sindx(4)
      int_mb(nxmeta(1)+nmeta) = sindx(4)
      dbl_mb(ameta(1)+nmeta)  = sdist(3)
      dbl_mb(bmeta(1)+nmeta)  = sdist(4)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing bond',0,RTDB_ERR)

      end if
      end if
      end if

      goto 10

c
c  bond_difference2 indx1 indx2 indx3 
c
 1500 if (inp_i(sindx(1))) then
      if (inp_i(sindx(2))) then
      if (inp_i(sindx(3))) then


*     *** set defaults for w,sigma,range and nrange ***
      sdist(1) = 0.00005d0
      sdist(2) = 0.10000d0
      sdist(7) = -20.0d0
      sdist(8) = 20.0d0
      sindx(5) = 501

 1501 if (.not.inp_a(test)) goto 1599
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'tamd_input: unknown directive',0,INPUT_ERR)

      goto ( 1510,1520,1530,1540) ind3
      call errquit(
     >     'tamd_input: unimplemented directive',ind3,INPUT_ERR)
c
c w, default=0.00005 au = 0.03175 kcal/mol
c
 1510 if (.not.inp_f(sdist(1))) sdist(1)=0.00005d0
      goto 1501
c
c sigma, default = 0.1 au
c
 1520 if (.not.inp_f(sdist(2))) sdist(2)=0.1d0
      goto 1501
c
c range
c
 1530 if (.not.inp_f(sdist(7))) sdist(7)= -20.0d0
      if (.not.inp_f(sdist(8))) sdist(8)=  20.0d0
      goto 1501
c
c nrange, default = 501
c
 1540 if (.not.inp_i(sindx(5))) sindx(5)=501
      goto 1501

 1599  continue

      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 10
      int_mb(indxmeta(1)+nindxmeta+1) = sindx(1)
      int_mb(indxmeta(1)+nindxmeta+2) = sindx(2)
      int_mb(indxmeta(1)+nindxmeta+3) = sindx(3)
      nindxmeta  = nindxmeta + 4

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      nparammeta  = nparammeta + 2

      nxmeta_all = nxmeta_all*sindx(5)
      int_mb(nxmeta(1)+nmeta) = sindx(5)
      dbl_mb(ameta(1)+nmeta)  = sdist(7)
      dbl_mb(bmeta(1)+nmeta)  = sdist(8)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'metadynamics_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'metadynamics_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'metadynamics_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'metadynamics_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'metadynamics_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'metadynamics_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'metadynamics_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'metadynamics_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'metadynamics_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'metadynamics_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'metadynamics_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'metadynamics_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'metadynamics_input:failed writing bond',0,RTDB_ERR)

      end if
      end if
      end if

      goto 10


c
c  equation
c
 1700 if (inp_a(eqnstring)) then

      nemach = nwpw_expression_compile(rtdb,eqnstring)

*     **** set defaults for gamma,k,mass,ztemp,zinitial ****
      sdist(1) =    0.00010d0
      sdist(2) =    0.05000d0
      sdist(3) =   30.0d0
      sdist(4) = 1000.0d0
      sdist(5) = 0.0d0
      sdist(6) = 0.0d0
      sdist(7) = -1.0d0
      sdist(8) = -1.0d0
      sindx(3) = 501

 1701 if (.not.inp_a(test)) goto 1799
      if (.not. inp_match(num_dirs3,.false.,test,dirs3,ind3))
     >  call errquit(
     >  'tamd_input: unknown directive',0,INPUT_ERR)

      goto (1710,1720,1730,1740,1750,1760,1770) ind3
      call errquit(
     >     'tamd_input: unimplemented directive',ind3,INPUT_ERR)

c
c gamma, default=0.00010 au = 0.06275 kcal/mol
c
 1710 if (.not.inp_f(sdist(1))) sdist(1)=0.00010d0
      goto 1701
c
c k, default = 0.05 au
c
 1720 if (.not.inp_f(sdist(2))) sdist(2)=0.05d0
      goto 1701
c
c mass, default=30.0 au
c
 1730 if (.not.inp_f(sdist(3))) sdist(3)= 30.0d0
      goto 1701
c
c ztemp, default = 1000.0K
c
 1740 if (.not.inp_f(sdist(4))) sdist(4)=1000.0d0
      goto 1701

c
c zinitial
c
 1750 if (.not.inp_f(sdist(5))) sdist(5)=0.0d0
      if (.not.inp_f(sdist(6))) sdist(6)=0.0d0
      goto 1701

c
c range
c
 1760 if (.not.inp_f(sdist(7))) sdist(7)=-1.0d0
      if (.not.inp_f(sdist(8))) sdist(8)=-1.0d0
      goto 1701

c
c nrange, default = 501
c
 1770 if (.not.inp_i(sindx(3))) sindx(3)=501
      goto 1701


 1799  continue
      int_mb(sindxmeta(1) +nmeta)     = nindxmeta
      int_mb(indxmeta(1)+nindxmeta)   = 12
      int_mb(indxmeta(1)+nindxmeta+1) = nemach
      nindxmeta  = nindxmeta + 2

      int_mb(sparammeta(1)+nmeta)       = nparammeta
      dbl_mb(parammeta(1)+nparammeta)   = sdist(1)
      dbl_mb(parammeta(1)+nparammeta+1) = sdist(2)
      dbl_mb(parammeta(1)+nparammeta+2) = sdist(3)
      dbl_mb(parammeta(1)+nparammeta+3) = sdist(4)
      dbl_mb(parammeta(1)+nparammeta+4) = sdist(5)
      dbl_mb(parammeta(1)+nparammeta+5) = sdist(6)
      nparammeta  = nparammeta + 6

      nxmeta_all = nxmeta_all*sindx(3)
      int_mb(nxmeta(1)+nmeta) = sindx(3)
      dbl_mb(ameta(1)+nmeta)  = sdist(7)
      dbl_mb(bmeta(1)+nmeta)  = sdist(8)
      int_mb(pmeta(1)+nmeta)  = 0

      nmeta = nmeta + 1

      rtdb_name = 'tamd_nindxmeta'
      value =           rtdb_put(rtdb,rtdb_name,mt_int,1,nindxmeta)
      rtdb_name = 'tamd_sindxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sindxmeta(1)))
      rtdb_name = 'tamd_indxmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nindxmeta,int_mb(indxmeta(1)))
      rtdb_name = 'tamd_nparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nparammeta)
      rtdb_name = 'tamd_sparammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,
     >                 nmeta,int_mb(sparammeta(1)))
      rtdb_name = 'tamd_parammeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_dbl,
     >                 nparammeta,dbl_mb(parammeta(1)))
      rtdb_name = 'tamd_ameta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(ameta(1)))
      rtdb_name = 'tamd_bmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_dbl,nmeta,dbl_mb(bmeta(1)))
      rtdb_name = 'tamd_pmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(pmeta(1)))
      rtdb_name = 'tamd_nxmeta'
      value = value.and.
     >        rtdb_put(rtdb,rtdb_name,mt_int,nmeta,int_mb(nxmeta(1)))
      rtdb_name = 'tamd_nmeta'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nmeta)
      rtdb_name = 'tamd_nxmeta_all'
      value = value.and.rtdb_put(rtdb,rtdb_name,mt_int,1,nxmeta_all)
      if (.not. value) call errquit(
     >'tamd_input:failed writing bond',0,RTDB_ERR)

      end if

      goto 10






 9999 continue
      
*     **** pop stack ****
      if (.not.MA_pop_stack(parammeta(2)))
     >   call errquit('cannot pope stack for metadynamics_input',1,
     >                MA_ERR)
      if (.not.MA_pop_stack(bmeta(2)))
     >   call errquit('cannot pop stack for metadynamics_input',3,
     >                MA_ERR)
      if (.not.MA_pop_stack(ameta(2)))
     >   call errquit('cannot pop stack for metadynamics_input',2,
     >                MA_ERR)
      if (.not.MA_pop_stack(pmeta(2)))
     >   call errquit('cannot pop stack for metadynamics_input',0,
     >                MA_ERR)
      if (.not.MA_pop_stack(indxmeta(2)))
     >   call errquit('cannot pop stack for metadynamics_input',0,
     >                MA_ERR)
      if (.not.MA_pop_stack(sparammeta(2)))
     >   call errquit('cannot pop stack for metadynamics_input',0,
     >                MA_ERR)
      if (.not.MA_pop_stack(sindxmeta(2)))
     >   call errquit('cannot pop stack for metadynamics_input',0,
     >                MA_ERR)
      if (.not.MA_pop_stack(nxmeta(2)))
     >   call errquit('cannot pop stack for metadynamics_input',0,
     >                MA_ERR)

      return
      end

      SUBROUTINE list_bonds(nbond,ntbond,bondatm)

      implicit none

      include 'p_array.inc'
      include 'p_input.inc'
      include 'cm_atom.inc'
      include 'cm_bond.inc'

      integer i,j,k
      integer nbond,ntbond,bondatm 

      dimension bondatm(mxbond,2)

      ntbond=0

      do i=1,natms

       do j=1,nbond

        if(atmtype(i).eq.bondatm(j,1))then

         ntbond=ntbond+1
         if(ntbond.gt.mxbond2)then
          write(output,*)'Increase mxbond2 to ',ntbond
          stop
         endif

         k=bondatm(j,2)-bondatm(j,1)
         if(typmol(atmtype(i)).ne.typmol(atmtype(i+k)))then
          write(output,*)'Bonded atoms must be from the same molecule'
          stop
         endif

         bonlist(ntbond,1)=i
         bonlist(ntbond,2)=i+k
         bonlist(ntbond,3)=j

        endif

       enddo

      enddo
 
      return

      END
c $Id: list_bonds.f 22502 2012-05-20 06:11:57Z d3y133 $

*
* $Id: HGH_band_local.F 19707 2010-10-29 17:59:36Z d3y133 $
*


      subroutine HGH_band_local(version,
     >                     zv,rloc,C1,C2,C3,C4,
     >                     nfft1,nfft2,nfft3,
     >                     G,
     >                     vl)
      implicit none
      integer          version
      double precision zv,rloc,C1,C2,C3,C4

      integer nfft1,nfft2,nfft3
      double precision G(nfft1,nfft2,nfft3,3)
      double precision vl(nfft1,nfft2,nfft3)


      integer np,taskid,MASTER
      parameter (MASTER=0)

*     *** local variables ****
      integer task_count,nfft3d
      integer k1,k2,k3
      double precision pi,twopi,forpi
      double precision b0,b1
      double precision x,x2,x4,x6,a,f,Q


*     **** Error function parameters ****


      call Parallel_np(np)
      call Parallel_taskid(taskid)
      nfft3d = nfft1*nfft2*nfft3
      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi
      b0 = -forpi*zv
      b1 = dsqrt(8.0d0*pi*pi*pi)*(rloc*rloc*rloc)
      
*======================  Fourier transformation  ======================
      call dcopy(nfft3d,0.0d0,0,vl,1)
      task_count = -1
      DO 700 k3=1,nfft3
      DO 700 k2=1,nfft2
      DO 700 k1=1,nfft1
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        if ((k1.eq.1).and.(k2.eq.1).and.(k3.eq.1)) go to 700


        Q=DSQRT(G(k1,k2,k3,1)**2
     >         +G(k1,k2,k3,2)**2
     >         +G(k1,k2,k3,3)**2)

        x = Q*rloc
        x2 = x*x
        x4 = x2*x2
        x6 = x4*x2
        a = dexp(-0.5d0*x2)

        f = b0*a/(Q*Q)
     >    + b1*a
     >        *( C1 
     >         + C2*(3.0d0-x2)
     >         + C3*(15.0d0 - 10.0d0*x2 + x4)
     >         + C4*(105.0d0 - 105.0d0*x2 + 21.0d0*x4 - x6))

        vl(k1,k2,k3)= f
    
  700 continue


      call Parallel_Vector_SumAll(nfft3d,vl)


      vl(1,1,1)=b1*(C1+C2*3.0d0+C3*15.0D0+C4*105.0D0)-b0*0.5d0*rloc*rloc
      
      return
      end

c     Wrapper method to invoke calculation on an SMD monomer calculation.
c     @author Sriram Krishnamoorthy
c
c     This method is invoked from the dynamic process group client
C     -server implementation.  


c     Wrapper method invoked from the C client-server scheduler
c     @param tskid IN Id of task to execute (here monomer id)
c     @param p_grp IN Handle to GA group on which to execute
c

      block data process_data
      implicit none
#include "process_task.fh"
      data populate_first_time /.true./
      data populate_done /.false./
      end

      subroutine process_task(tskid, p_grp)
      implicit none
      integer tskid, p_grp 

#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "global.fh"

      integer rtdb_grp !rtdb of p_grp (to be created)
      double precision etime1,etime2
c
      external duplicate_rtdb !duplicate an rtdb file
c
      if(ga_pgroup_get_default().ne.p_grp) 
     $  call errquit('Default group not properly set',p_grp,0)
c

      call cpu_time(etime1)
      call duplicate_rtdb(rtdb_grp, p_grp)
      call cpu_time(etime2)
c      write(*,*) "time monomer rtdb",etime2-etime1

      call smd_rtdb_set_handle(rtdb_grp)
c
      call ga_pgroup_sync(ga_pgroup_get_default())
      call smd_monomer(tskid)
      call ga_pgroup_sync(ga_pgroup_get_default())
c
c      call smd_charge_ga_print()
      if(.not.rtdb_close(rtdb_grp, 'delete'))
     + call errquit('Failed to close group rtdb',0, GEOM_ERR)
c
      end !process_task

c     Create a temporary file name
c     fname_out OUT File name
c     world_ldr_ir IN proc id of leader of this grp in world
c     grp_id IN id of this group
      subroutine create_file_name(base, fname_out, world_ldr_id, 
     *     grp_id)
      implicit none
      character*(*) base, fname_out
      integer world_ldr_id, grp_id

#include "global.fh"
      character*100 name
      character*100 pname

      pname = "create_file_name"

      if(grp_id.ge.9999) 
     &   call errquit('too big a group id', grp_id, 0)
      
      if(world_ldr_id.ge.9999) 
     &   call errquit('too big a world ldr id', world_ldr_id, 0)


      name = " "
      write(name,'(A7,A1,I4.4,A1,I4.4)') base, '.', world_ldr_id, '.',
     *    grp_id

      call util_file_name(name,.true.,.false.,fname_out)


      end
      subroutine create_file_name_perm(base, fname_out, world_ldr_id, 
     *     grp_id)
      implicit none
      character*(*) base, fname_out
      integer world_ldr_id, grp_id

#include "global.fh"
      character*100 name
      character*100 pname

      pname = "create_file_name"

      if(grp_id.ge.9999) 
     &   call errquit('too big a group id', grp_id, 0)
      
      if(world_ldr_id.ge.9999) 
     &   call errquit('too big a world ldr id', world_ldr_id, 0)


      name = " "
      write(name,'(A7,A1,I4.4,A1,I4.4)') base, '.', world_ldr_id, '.',
     *    grp_id

      call util_file_name(name,.false.,.false.,fname_out)


      end

c     Replaces util_sgmovecs to make the file names group aware
      subroutine create_movecs(rtdb)
      implicit none
      integer rtdb

#include "util.fh"      
#include "rtdb.fh"
#include "global.fh"

      character*100 fname, base,fname_in
      character*255 theory, tag
      integer p_grp
      
      base = "test.movecs"
      p_grp = ga_pgroup_get_default()

      call create_file_name(base,fname, 
     *     ga_pgroup_absolute_id(p_grp, 0),
     *     p_grp)
c
c Set output movecs
c
c      if (.not.(rtdb_cget(rtdb,'task:theory',1,theory)))
c     *     call errquit('rtdb_get task:theory failed',0,0)
      if (.not.rtdb_cget(rtdb,"smd:theory",1,
     >                   theory)) then
       write(0,*) "PLEASE SET smd:theory"
       call errquit('failed to get theory',0,0)
      end if
      if (theory.eq.'dft') then
       tag='dft:output vectors'
      else
       tag='scf:output vectors'
      endif
c
      if (.not. rtdb_cput(rtdb,tag,1,fname)) then
       write (6,*) 'error in rtdb_cput'
      endif
c
      if (theory.eq.'dft') then
       tag='dft:input vectors'
      else
       tag='scf:input vectors'
      endif
      if (.not. rtdb_cget(rtdb,tag,1,fname_in)) then
       write (6,*) 'error in rtdb_cput'
      endif
      if(ga_nodeid().eq.0) then
        write(*,*) "movecs copy",fname_in,fname
        call util_file_copy(fname_in,fname)
      end if
      if (.not. rtdb_cput(rtdb,tag,1,fname)) then
       write (6,*) 'error in rtdb_cput'
      endif
ccc
      end !create_movecs


c     @param rtdb_in IN
c     @param rtdb_out OUT
c     @param p_out IN
      subroutine duplicate_rtdb(rtdb_out, p_out)
      implicit none
      integer rtdb_out, p_out

#include "stdio.fh"
#include "global.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util_sgroup.fh"
      
      character*100 fname_in, fname_out, name, base
      integer myproc, i, world_ldr_id
      logical status, mode

      base = "dyn_db"
      world_ldr_id=0
      myproc = ga_nodeid()

      call ga_pgroup_sync(p_out)
C
C     Node 0 of the group now copies the original RTDB to a group specific one
C
      if (myproc .eq. 0) then
         world_ldr_id = ga_pgroup_nodeid(ga_pgroup_get_world())
         call create_file_name(base,fname_out, world_ldr_id, p_out)

         call smd_rtdb_get_name(fname_in)
c
c         write (*,*) 'rtdb filename_in', fname_in
c         write (*,*) 'rtdb filename_out', fname_out
c         call util_flush(6)
         inquire(file=fname_in,exist=status)
         if(.not.status) then
c     most likely cause of error: permdir not available on this node
            write(0,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(0,*) ' ! please change permanent_dir (2) to a   !'
            write(0,*) ' ! filesystem available to all the    !'
            write(0,*) ' ! processors (e.g. NFS, GPFS, Lustre)!'
            write(0,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            call errquit(' util_sgrtdb: failed to open rtdb',0,0)
         endif
c
         call util_file_copy(fname_in, fname_out)
        
        inquire(file=fname_out, exist=status)
        if (.not. status) then
          write (0,*) 'copy failed'
          call errquit('duplicate_file: problem with system call', 0, 0)
        else if (sgprint) then
c          write(6,*) ' rtdb copied ', ga_pgroup_get_default()
c          call flush(6)
        endif
      endif


      world_ldr_id = ga_pgroup_absolute_id(p_out, 0);
c      call ga_pgroup_brdcst(p_out, MT_INT, world_ldr_id, 1, 0);
c      call ga_igop(world_ldr_id,1,'+')
      call create_file_name(base,fname_out, world_ldr_id, p_out)

      if (.not. rtdb_open(fname_out,'old',rtdb_out)) call errquit
     *     (' rtdb_open old failed ',0,myproc)
c
c     Create movecs for each subgroup
c
      call create_movecs(rtdb_out)
c
      end !duplicate_rtdb



c     task_list IN Task list to insert tasks into
      subroutine populate_tasks(task_list)
      integer task_list

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "util.fh"
#include "global.fh"
#include "process_task.fh"

      integer nr, na, i, ntsks, ga_charges
      logical changed_flag
      integer lo(1), hi(1), ld(1)
      double precision diff
      integer istart,iend,nrpoc

c      istart=1
c      iend=4
      call smd_rtdb_get_istart(istart)
      call smd_rtdb_get_iend(iend)
      call smd_rtdb_get_nproc(nproc)
      if(populate_done)
     &  call errquit('trying to populate_tasks'// 
     &    ' after done',0,0)

      call smd_system_ntot(na)
      call smd_system_nres(nr)


      ntsks = 0
      if(populate_first_time) then

         call smd_charge_get_ptr(i_q)

         if(.not.ma_alloc_get(MT_DBL,
     +        na,
     +        "tmp q",
     +        tmp_h_q,
     +        tmp_i_q))
     +        call errquit('memory allocation',
     +        na,
     +        MA_ERR)

         old_i_q = i_q
         new_i_q = tmp_i_q

c         do i = 1, nr
        do i = istart,iend
            call sched_grp_insert_task(task_list, i, nproc)
            ntsks = ntsks + 1
         enddo
         
         populate_first_time = .false.
      else
c
c         call smd_charge_ga_handle(ga_charges)
c
c         lo(1) = 1
c         hi(1) = na
c         ld(1) = 1
c         call nga_get(ga_charges,lo, hi, dbl_mb(new_i_q), ld)
c
c         changed_flag = .false.
c         do i = 1, na
c            diff = dabs(dbl_mb(new_i_q+i-1)-dbl_mb(old_i_q+i-1))
c            if(diff.gt.0.00001) then
c              write(*,*) "charge difference",
c     >                   diff
c              changed_flag = .true.
c              goto 100
c            end if
c         end do
c 100     continue
c
c         if(changed_flag) then
cc            do i = 1, nr
c           do i = istart,iend
c               call sched_grp_insert_task(task_list, i, 1)
c               ntsks = ntsks + 1
c            enddo
c         endif
c
c         !Flip new and old pointers
c         i = new_i_q
c         new_i_q = old_i_q
c         old_i_q = i
      end if

      if(ntsks.eq.0) then
         if(.not.ma_free_heap(tmp_h_q))
     $        call errquit('memory deallocation',0,tmp_h_q)
         populate_done=.true.
      end if

      end !populate_tasks

c $Id: process_task.F 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine argos_space_start(lout,lfntop,filtop,lfnrst,filrst,
     + lsyn,filsyn,nsyn,
     + rsht,rlng,rinp,rsgmi,
     + npxi,npyi,npzi,nbxi,nbyi,nbzi,
     + npbt,nbxt,boxt,vlatt,lpbc,
     + nwmi,mwmi,nwai,mwai,nsfi,msfi,nsmi,msmi,nsai,msai,
     + ldb,lbp,fld,lpol,lfre,temp,tempw,temps,iguidi,
     + ldbg,idbg,prjct,mbbi,nseri,isld,irset,ictrl,nseqi,
     + i_lseqi,ndumsi,nbgeti,npreci,madbxi)
c
c
c $Id: argos_space_start.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
c
      logical argos_space_rdrest,argos_space_diffbb
      external argos_space_rdrest,argos_space_diffbb
c
      integer lfntop,lfnrst,lsyn,nsyn,ldbg,idbg,lout
      character*255 filtop,filrst,filsyn
      real*8 rsht,rlng,rinp,boxt(3),vlatt(3,3),rtemp(3)
      real*8 temp,tempw,temps,fld,rsgmi
      integer itemp(2)
      integer npxi,npyi,npzi,nbxi,nbyi,nbzi,isld,irset,nseqi,i_lseqi
      integer nwmi,mwmi,nwai,mwai,nsfi,msfi,nsmi,msmi,nsai,msai
      integer lenscr,ldb,lbp,npbt,nbxt,iguidi,mbbi,nseri,ictrl,ndumsi
      integer nbgeti,npreci,madbxi
      logical lpol,lfre,ignore,lpbc
      character*80 prjct
c
      integer i,j,l_f,i_f
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort('ERROR IN MEMORY USE AT START ARGOS_SPACE_START',0)
      endif
c
      me=ga_nodeid()
      np=ga_nnodes()
c
      project=prjct
c
      idebug=idbg
      lfndbg=ldbg
      icntrl=ictrl
      lfnout=lout
c
      lfnsyn=lsyn
      nfsync=nsyn
      isload=isld
      ireset=irset
      nbget=nbgeti
      nprec=npreci
      ibget=nbget
      madbox=madbxi
c
      rshort=rsht
      rlong=max(rsht,rlng)
      rbox=rinp
      ntwin=1
      if(rlng.gt.rsht) ntwin=2
      ltwin=rlng.gt.rsht
c
      loadb=ldb
      lbpair=lbp
      factld=fld
c
      lpola=lpol
      lfree=lfre
c
      nbx=nbxi
      nby=nbyi
      nbz=nbzi
      nbxin=nbxi
      nbyin=nbyi
      nbzin=nbzi
c
      npx=npxi
      npy=npyi
      npz=npzi
c
      mbbl=0
      nbbdif=-1
c
      mwm=mwmi
      msa=max(msai,msmi)
      mbbreq=mbbi
      mbblp=0
      nserie=nseri
c
      iguide=iguidi
c
      npack=0
      npackw=0
c
      rsgm=rsgmi
c
      call argos_space_nrnode()
c
      call argos_space_dimens(lfnrst,filrst)
c
      call argos_space_alloc()
c
      call argos_space_decomp(int_mb(i_iown),dbl_mb(i_boxs),
     + int_mb(i_buren),int_mb(i_bindex))
c
      call argos_space_initip(int_mb(i_iown),int_mb(i_ipl))
c
      call argos_space_numbb(int_mb(i_iown),dbl_mb(i_boxs))
c
      if(argos_space_diffbb(dbl_mb(i_boxs),int_mb(i_rng)))
     + call argos_space_listbb(int_mb(i_iown),dbl_mb(i_boxs),
     + int_mb(i_bb))
c
      call argos_space_alloc2()
c
      if(ireset.eq.0) then
      ignore=argos_space_rdrest(lfnrst,filrst,dbl_mb(i_boxs))
      endif
      if(np.gt.1) then
      call ga_brdcst(msp_02,nsm,ma_sizeof(mt_int,1,mt_byte),0)
      endif
      msm=max(1,nsm)
      if(.not.ma_push_get(mt_dbl,msm*3,'xscr',l_xscr,i_xscr))
     + call md_abort('Failed to allocate xscr',0)
c
      lenscr=3*max(mwm*mwa,msa)
      if(.not.ma_push_get(mt_dbl,lenscr,'x',l_x,i_x))
     + call md_abort('Failed to allocate x',0)
      if(.not.ma_push_get(mt_dbl,lenscr,'v',l_v,i_v))
     + call md_abort('Failed to allocate v',0)
      if(.not.ma_push_get(mt_dbl,lenscr,'f',l_f,i_f))
     + call md_abort('Failed to allocate f',0)
      if(.not.ma_push_get(mt_dbl,3*mwm*mwa,'r',l_r,i_r))
     + call md_abort('Failed to allocate r',0)
      lenscr=max(miw2*mwm,mis2*msa)
      if(.not.ma_push_get(mt_int,lenscr,'i',l_i,i_i))
     + call md_abort('Failed to allocate i',0)
      lenscr=ma_inquire_avail(mt_byte)/
     + ((9*mwa+3)*ma_sizeof(mt_dbl,1,mt_byte)+
     + (mis2+4)*ma_sizeof(mt_int,1,mt_byte))-1
      if(.not.ma_push_get(mt_dbl,lenscr*3*mwa,'bx',l_bx,i_bx))
     + call md_abort('Failed to allocate bx',0)
      if(.not.ma_push_get(mt_dbl,lenscr*3*mwa,'bv',l_bv,i_bv))
     + call md_abort('Failed to allocate bv',0)
      if(.not.ma_push_get(mt_dbl,lenscr*3*mwa,'bf',l_bf,i_bf))
     + call md_abort('Failed to allocate bf',0)
      if(.not.ma_push_get(mt_dbl,lenscr*3,'br',l_br,i_br))
     + call md_abort('Failed to allocate br',0)
      if(.not.ma_push_get(mt_int,lenscr*max(mis2,2),'bi',l_bi,i_bi))
     + call md_abort('Failed to allocate bi',0)
      if(.not.ma_push_get(mt_int,lenscr,'n',l_n,i_n))
     + call md_abort('Failed to allocate n',0)
c
      call ga_sync()
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort
     + ('ERROR IN MEMORY USE BEFORE RDRST IN ARGOS_SPACE_START',0)
      endif
c
      call argos_space_rdrst(lfnrst,filrst,lfntop,filtop,
     + temp,tempw,temps,int_mb(i_ipl),
     + dbl_mb(i_x),dbl_mb(i_v),dbl_mb(i_f),dbl_mb(i_r),int_mb(i_i),
     + dbl_mb(i_x),dbl_mb(i_v),dbl_mb(i_f),dbl_mb(i_xscr),int_mb(i_i),
     + dbl_mb(i_bx),dbl_mb(i_bv),dbl_mb(i_bf),dbl_mb(i_br),
     + int_mb(i_bi),lenscr,
     + dbl_mb(i_bx),dbl_mb(i_bv),dbl_mb(i_bf),int_mb(i_bi),
     + lenscr,int_mb(i_n),
     + int_mb(i_iown),dbl_mb(i_boxs),int_mb(i_lseq),int_mb(i_sndx))
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort
     + ('ERROR IN MEMORY USE AFTER RDRST IN ARGOS_SPACE_START',0)
      endif
c
      if(.not.ma_pop_stack(l_n))
     + call md_abort('Failed to deallocate n',0)
      if(.not.ma_pop_stack(l_bi))
     + call md_abort('Failed to deallocate bi',0)
      if(.not.ma_pop_stack(l_br))
     + call md_abort('Failed to deallocate br',0)
      if(.not.ma_pop_stack(l_bf))
     + call md_abort('Failed to deallocate bf',0)
      if(.not.ma_pop_stack(l_bv))
     + call md_abort('Failed to deallocate bv',0)
      if(.not.ma_pop_stack(l_bx))
     + call md_abort('Failed to deallocate bx',0)
      if(.not.ma_pop_stack(l_i))
     + call md_abort('Failed to deallocate i',0)
      if(.not.ma_pop_stack(l_r))
     + call md_abort('Failed to deallocate r',0)
      if(.not.ma_pop_stack(l_f))
     + call md_abort('Failed to deallocate f',0)
      if(.not.ma_pop_stack(l_v))
     + call md_abort('Failed to deallocate v',0)
      if(.not.ma_pop_stack(l_x))
     + call md_abort('Failed to deallocate x',0)
c
      if(np.gt.1) then
      rtemp(1)=temp
      rtemp(2)=tempw
      rtemp(3)=temps
      call ga_brdcst(msp_01,rtemp,ma_sizeof(mt_dbl,3,mt_byte),0)
      temp=rtemp(1)
      tempw=rtemp(2)
      temps=rtemp(3)
      itemp(1)=nsm
      itemp(2)=nsf
      call ga_brdcst(msp_02,itemp,ma_sizeof(mt_int,2,mt_byte),0)
      nsm=itemp(1)
      nsf=itemp(2)
      endif
c
      nwmi=nwm
      nwai=nwa
      nsmi=nsm
      nsai=nsa
c
      mwmi=mwm
      mwai=mwa
      msai=msa
c
      npbt=npbtyp
      nbxt=nbxtyp
c
      do 1 i=1,3
      boxt(i)=box(i)
      do 2 j=1,3
      vlatt(i,j)=vlat(i,j)
    2 continue
    1 continue
c
      nsfi=nsf
      msfi=max(1,nsf)
      msmi=max(1,nsm)
c
      third=1.0d0/3.0d0
      nldup=-2
      ipairf=-1
      ipairt=-1
      lpipo=.false.
c
      lpbc=npbtyp.gt.0
c
      if(me.eq.0) then
      if(nfsync.gt.0) then
      open(unit=lfnsyn,file=filsyn(1:index(filsyn,' ')-1),
     + status='unknown')
      write(lfnsyn,3000) np
 3000 format(i5)
      endif
      endif
c
      nseqi=nseq
      i_lseqi=i_lseq
c
      ndumsi=ndums
c
      if(.not.ma_verify_allocator_stuff()) then
      call md_abort('ERROR IN MEMORY USE AT EXIT ARGOS_SPACE_START',0)
      endif
c
      return
      end

C $Id: drdy_synch.F 26028 2014-08-25 20:36:49Z edo $
      subroutine drdy_synch(opcode,calling_routine)
      implicit none
#include "errquit.fh"
#include "drdyP.fh"
#include "nwc_drdyP.fh"
#include "tcgmsg.fh"
#include "msgids.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "printlevels.fh"
*::functions::
      logical  task_energy, task_gradient, task_hessian
      logical nw_inp_from_character
      external nw_inp_from_character
      external task_energy, task_gradient, task_hessian
*::passed::
      integer opcode
      character*(*)calling_routine
*::local::
      character*32 drdy_theory, bname, ename, basis
      character*255 input
      integer current_print_level
      logical status
      logical status_rtdb, status_ignore
      logical extra_sync
      integer found_task
*
*      write(fu6,*)' drdy_synch called with code ',opcode,
*     &    ' from ',calling_routine,' node =',me_drdy
*      call util_flush(6)
      if (me_drdy.eq.master) then
        extra_sync = .true.
        if (.not.
     &        rtdb_cput(my_rtdb,'scf:input vectors',1,'atomic')) then
          write(fu6,*)' could not reset input vectors to atomic '
          call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
        endif
        if (.not.
     &        rtdb_cput(my_rtdb,'dft:input vectors',1,'atomic')) then
          write(fu6,*)' could not reset input vectors to atomic '
          call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
        endif
*        if (.not.
*     &        rtdb_cput(my_rtdb,'mp2:input vectors',1,'atomic')) then
*          write(fu6,*)' could not reset input vectors to atomic '
*          call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
*        endif
        if (.not.
     &        rtdb_cput(my_rtdb,'mcscf:input vectors',1,'atomic')) then
          write(fu6,*)' could not reset input vectors to atomic '
          call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
        endif
c
c If we are not doing a single point calculation at a higher level
c of theory, just set the theory in the rtdb.
c
        if (opcode .ne. DRDY_CODE_SPENERGY) then
          if (.not.rtdb_cget(my_rtdb,'drdy:theory',1,drdy_theory)) then
            write(fu6,*)' could not determine drdy:theory'
            call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
          endif
          call inp_lcase(drdy_theory)
          if (.not.rtdb_cput(my_rtdb,'task:theory',1,drdy_theory)) then
            write(fu6,*)' could not write drdy:theory -> theory'
            call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
          endif
          if (rtdb_cget(my_rtdb,'drdy:input',1,input)) then
            if (.not.nw_inp_from_character(my_rtdb,input)) then
              write(fu6,*) 'could not process drdy:theory input'
              call errquit('drdy_synch: fatal error ',555, RTDB_ERR)
            endif
            extra_sync=.false.
          endif
c
c Otherwise we need to set the information for the single point
c information (theory,basis,ecp,input).
c
        else
          if (.not.rtdb_cget(my_rtdb,'drdy:sptheory',1,
     &                       drdy_theory)) then
            write(fu6,*)' could not determine drdy:sptheory'
            call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
          endif
          if (.not.rtdb_cput(my_rtdb,'task:theory',1,drdy_theory)) then
            write(fu6,*)' could not write drdy:sptheory -> theory'
            call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
          endif
c
c Save original information and set new info if available.  Note that
c input overwrites the old information and is essentially impossible to
c get back.  The user is responsible for input on the "theory" line of
c the drdy input to get back the "defaults".
c
          if (.not. rtdb_cget(my_rtdb,'ao basis',1,bname)) bname = ' '
          if (.not. rtdb_cget(my_rtdb,'ecp basis',1,ename)) ename = ' '
          if (rtdb_cget(my_rtdb,'drdy:spbasis',1,basis)) then
            if (.not.rtdb_cput(my_rtdb,'ao basis',1,basis)) then
              write(fu6,*) 'could not write drdy:spbasis->ao basis'
              call errquit('drdy_synch: fatal error ',555, RTDB_ERR)
            endif
          endif
          if (rtdb_cget(my_rtdb,'drdy:specp',1,basis)) then
            if (.not.rtdb_cput(my_rtdb,'ecp basis',1,basis)) then
              write(fu6,*) 'could not write drdy:specp->ecp basis'
              call errquit('drdy_synch: fatal error ',555, RTDB_ERR)
            endif
          endif
          if (rtdb_cget(my_rtdb,'drdy:spinput',1,input)) then
            if (.not.nw_inp_from_character(my_rtdb,input)) then
              write(fu6,*) 'could not process drdy:theorysp input'
              call errquit('drdy_synch: fatal error ',555, RTDB_ERR)
            endif
            extra_sync = .false.
          endif
        endif
* input routines have ga_sync() calls in them, so we have to do a ga_sync()
* call to match that, but if we don't do input reading, then we fake it
* on the master
        if (extra_sync)  then
*         So, we didn't parse any input, so fake it
          call ga_sync()
          found_task = 0
          call ga_igop(33,found_task,1,'+')
        endif
      endif

00001 continue
      if (me_drdy.ne.master) then
        call ga_sync()
        found_task = 0
        call ga_igop(33,found_task,1,'+')
      endif

*      write(fu6,*)' B4 msg_drdy_opcode = ',msg_drdy_opcode,
*     &    ' opcode = ',opcode,' node=',me_drdy
*      call util_flush(6)
      call ga_brdcst(msg_DRDY_OPCODE, opcode, mitob(1), master)
      call ga_sync()
*      write(fu6,*)' AF msg_drdy_opcode = ',msg_drdy_opcode,
*     &    ' opcode = ',opcode,' node=',me_drdy
*      call util_flush(6)
*     call util_print_common_data
      call util_print_get_level(current_print_level)
      call util_print_set_level(print_none)
*     call util_print_common_data
      if ((opcode .eq. DRDY_CODE_ENERGY).or.
     &    (opcode .eq. DRDY_CODE_SPENERGY)) then
        status_rtdb   = rtdb_parallel(.true.)
*        call setdbg(0)
        status        = task_energy(my_rtdb)
*        call setdbg(1)
        status_ignore = rtdb_parallel(status_rtdb)
      elseif (opcode .eq. DRDY_CODE_GRADIENT) then
        status_rtdb   = rtdb_parallel(.true.)
*        call setdbg(0)
        status        = task_gradient(my_rtdb)
*        call setdbg(1)
        status_ignore = rtdb_parallel(status_rtdb)
      elseif (opcode .eq. DRDY_CODE_HESSIAN) then
        status_rtdb   = rtdb_parallel(.true.)
*        call setdbg(0)
        status        = task_hessian(my_rtdb)
        call ga_sync()
        status        = status.and.task_gradient(my_rtdb)
*        call setdbg(1)
        status_ignore = rtdb_parallel(status_rtdb)
      elseif (opcode .eq. DRDY_CODE_DONE) then
        call ga_sync()
        return
      else
        write(fu6,*)' unknown opcode ',opcode
        call errquit('drdy_synch: fatal error ',911, RTDB_ERR)
      endif
      call util_print_set_level(current_print_level)
      call ga_sync()
      if (me_drdy.eq.master) then
c
c If doing the single point energy, reset info to original
c
        if (opcode .eq. DRDY_CODE_SPENERGY) then
          status_ignore = rtdb_delete(my_rtdb, 'ao basis')
          status_ignore = rtdb_delete(my_rtdb, 'ecp basis')
          if (bname .ne. ' ') then
            if (.not. rtdb_cput(my_rtdb,'ao basis',1,bname)) 
     &        call errquit
     &        ('drdy_synch:failed resetting user basis name',0,
     &       RTDB_ERR)
          end if
          if (ename .ne. ' ') then
            if (.not. rtdb_cput(my_rtdb,'ecp basis',1,ename)) 
     &         call errquit
     &         ('drdy_synch:failed resetting user ecp name',0,
     &       RTDB_ERR)
          end if
        end if
        return
      endif
      opcode = 0
      goto 00001
      end

      subroutine smd_charge_init_system()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 sp_charge,sp_param,sp_atom,sp_type
      character*32 tag,pname
      character*255 filename
      logical result

      pname = "smd_charge_init_system"
c
      tag = "atom"
      call smd_system_get_component(sp_atom,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "parameters"
      call smd_system_get_component(sp_param,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "charge"
      call smd_system_get_component(sp_charge,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      tag = "type"
      call smd_system_get_component(sp_type,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)


      call smd_charge_init(sp_charge)
      call smd_chargefile_input(filename,result)
      if(result) then
        call smd_charge_read(filename) 
      else
        call smd_charge_set()
      end if
c
      return
      end

      subroutine smd_charge_init(sp_charge)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
#include "smd_charge_data.fh"
c     
      character*(*) sp_charge
c
      character*32 pname
      character*255 filename
      integer na
c
      integer ndims, type, ga_charges
      integer dims(1), chunk(1)
      integer rtdb
c
      pname = "smd_charge_init"
c
c      write(*,*) "in "//pname
c
      type = MT_DBL
      ndims = 1
c
c     get total number of atoms 
c     -------------------------
      call smd_atom_ntot(na)
      if(na.le.0)
     >  call errquit(
     >       pname//'no atoms ',0, RTDB_ERR)
c
c     create charge data structures
c     ---------------------------
      call smd_namespace_create(sp_charge)
      call smd_data_create(sp_charge,"charge",na,MT_DBL)
      return
      end

      subroutine smd_charge_set()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*32 pname,tag
      integer na
      logical result
      integer i_q,i_q0,i_id
      integer i,j
      double precision q0
c
      pname = "smd_charge_set"
c
c      write(*,*) "in "//pname
c
      tag = "charge"
      call smd_get_ind_dim(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      tag = "param:charge"
      call smd_get_ind(tag,i_q0,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      tag = "type:id"
      call smd_get_ind(tag,i_id,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)

      do i=1,na
       j=int_mb(i_id+i-1)
       q0=dbl_mb(i_q0+j-1)
       dbl_mb(i_q+i-1)=q0
      end do

      return
      end

      subroutine smd_charge_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      integer un
c
      character*72 sp_charge
      character*32 pname,tag
      integer na
      logical result
      integer i_q
      integer i
c
      pname = "smd_charge_print"
c
c      write(*,*) "in "//pname
c
      tag = "charge"
      call smd_get_ind_dim(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      do i=1,na
       write(un,*) i,dbl_mb(i_q+i-1)
      end do

      return
      end

      subroutine smd_charge_write(filename)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) filename
c
      integer un
      character*72 sp_charge
      character*32 pname,tag
      integer na
      logical result
      integer i_q
      integer i
c
      pname = "smd_charge_write"
c
c      write(*,*) "in "//pname
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
      open(unit=un,status="unknown",form="formatted",file=filename)
c
      tag = "charge"
      call smd_get_ind_dim(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      do i=1,na
       write(un,*) dbl_mb(i_q+i-1)
      end do

      close(un)

      return
      end

      subroutine smd_charge_write_default()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(255) filename
      logical result
      call smd_chargefile_output(filename,result)
c
      if(result) then
        call smd_charge_write(filename) 
      end if
      return
      end

      subroutine smd_charge_read(filename)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      character*(*) filename
c
      integer un
      character*72 sp_charge
      character*32 pname,tag
      integer na
      logical result
      integer i_q
      integer i
c
      pname = "smd_charge_read"
c
c      write(*,*) "in "//pname
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
      open(unit=un,status="old",form="formatted",file=filename)
c
      tag = "charge"
      call smd_get_ind_dim(tag,i_q,na,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, rtdb_err)

      do i=1,na
       read(un,*) dbl_mb(i_q+i-1)
      end do

      close(un)

      return
      end

      subroutine smd_chargefile_output(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_chargefile_input"

      result = .true.
      call smd_rtdb_get_string("smd:charge:output",1,
     >                           filename,result)

      end

      subroutine smd_chargefile_input(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_chargefile_input"

      result = .true.
      call smd_rtdb_get_string("smd:charge:input",1,
     >                           filename,result)

      end
c $Id: smd_charge.F 21176 2011-10-10 06:35:49Z d3y133 $

*> \brief \b DLAED1 used by sstedc. Computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix. Used when the original matrix is tridiagonal.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLAED1 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlaed1.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlaed1.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlaed1.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLAED1( N, D, Q, LDQ, INDXQ, RHO, CUTPNT, WORK, IWORK,
*                          INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            CUTPNT, INFO, LDQ, N
*       DOUBLE PRECISION   RHO
*       ..
*       .. Array Arguments ..
*       INTEGER            INDXQ( * ), IWORK( * )
*       DOUBLE PRECISION   D( * ), Q( LDQ, * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLAED1 computes the updated eigensystem of a diagonal
*> matrix after modification by a rank-one symmetric matrix.  This
*> routine is used only for the eigenproblem which requires all
*> eigenvalues and eigenvectors of a tridiagonal matrix.  DLAED7 handles
*> the case in which eigenvalues only or eigenvalues and eigenvectors
*> of a full symmetric matrix (which was reduced to tridiagonal form)
*> are desired.
*>
*>   T = Q(in) ( D(in) + RHO * Z*Z**T ) Q**T(in) = Q(out) * D(out) * Q**T(out)
*>
*>    where Z = Q**T*u, u is a vector of length N with ones in the
*>    CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.
*>
*>    The eigenvectors of the original matrix are stored in Q, and the
*>    eigenvalues are in D.  The algorithm consists of three stages:
*>
*>       The first stage consists of deflating the size of the problem
*>       when there are multiple eigenvalues or if there is a zero in
*>       the Z vector.  For each such occurence the dimension of the
*>       secular equation problem is reduced by one.  This stage is
*>       performed by the routine DLAED2.
*>
*>       The second stage consists of calculating the updated
*>       eigenvalues. This is done by finding the roots of the secular
*>       equation via the routine DLAED4 (as called by DLAED3).
*>       This routine also calculates the eigenvectors of the current
*>       problem.
*>
*>       The final stage consists of computing the updated eigenvectors
*>       directly using the updated eigenvalues.  The eigenvectors for
*>       the current problem are multiplied with the eigenvectors from
*>       the overall problem.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>         On entry, the eigenvalues of the rank-1-perturbed matrix.
*>         On exit, the eigenvalues of the repaired matrix.
*> \endverbatim
*>
*> \param[in,out] Q
*> \verbatim
*>          Q is DOUBLE PRECISION array, dimension (LDQ,N)
*>         On entry, the eigenvectors of the rank-1-perturbed matrix.
*>         On exit, the eigenvectors of the repaired tridiagonal matrix.
*> \endverbatim
*>
*> \param[in] LDQ
*> \verbatim
*>          LDQ is INTEGER
*>         The leading dimension of the array Q.  LDQ >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] INDXQ
*> \verbatim
*>          INDXQ is INTEGER array, dimension (N)
*>         On entry, the permutation which separately sorts the two
*>         subproblems in D into ascending order.
*>         On exit, the permutation which will reintegrate the
*>         subproblems back into sorted order,
*>         i.e. D( INDXQ( I = 1, N ) ) will be in ascending order.
*> \endverbatim
*>
*> \param[in] RHO
*> \verbatim
*>          RHO is DOUBLE PRECISION
*>         The subdiagonal entry used to create the rank-1 modification.
*> \endverbatim
*>
*> \param[in] CUTPNT
*> \verbatim
*>          CUTPNT is INTEGER
*>         The location of the last eigenvalue in the leading sub-matrix.
*>         min(1,N) <= CUTPNT <= N/2.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is DOUBLE PRECISION array, dimension (4*N + N**2)
*> \endverbatim
*>
*> \param[out] IWORK
*> \verbatim
*>          IWORK is INTEGER array, dimension (4*N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit.
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*>          > 0:  if INFO = 1, an eigenvalue did not converge
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERcomputational
*
*> \par Contributors:
*  ==================
*>
*> Jeff Rutter, Computer Science Division, University of California
*> at Berkeley, USA \n
*>  Modified by Francoise Tisseur, University of Tennessee
*>
*  =====================================================================
      SUBROUTINE DLAED1( N, D, Q, LDQ, INDXQ, RHO, CUTPNT, WORK, IWORK,
     $                   INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            CUTPNT, INFO, LDQ, N
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            INDXQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), Q( LDQ, * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            COLTYP, I, IDLMDA, INDX, INDXC, INDXP, IQ2, IS,
     $                   IW, IZ, K, N1, N2, ZPP1
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLAED2, DLAED3, DLAMRG, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( MIN( 1, N / 2 ).GT.CUTPNT .OR. ( N / 2 ).LT.CUTPNT ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAED1', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     The following values are integer pointers which indicate
*     the portion of the workspace
*     used by a particular array in DLAED2 and DLAED3.
*
      IZ = 1
      IDLMDA = IZ + N
      IW = IDLMDA + N
      IQ2 = IW + N
*
      INDX = 1
      INDXC = INDX + N
      COLTYP = INDXC + N
      INDXP = COLTYP + N
*
*
*     Form the z-vector which consists of the last row of Q_1 and the
*     first row of Q_2.
*
      CALL DCOPY( CUTPNT, Q( CUTPNT, 1 ), LDQ, WORK( IZ ), 1 )
      ZPP1 = CUTPNT + 1
      CALL DCOPY( N-CUTPNT, Q( ZPP1, ZPP1 ), LDQ, WORK( IZ+CUTPNT ), 1 )
*
*     Deflate eigenvalues.
*
      CALL DLAED2( K, N, CUTPNT, D, Q, LDQ, INDXQ, RHO, WORK( IZ ),
     $             WORK( IDLMDA ), WORK( IW ), WORK( IQ2 ),
     $             IWORK( INDX ), IWORK( INDXC ), IWORK( INDXP ),
     $             IWORK( COLTYP ), INFO )
*
      IF( INFO.NE.0 )
     $   GO TO 20
*
*     Solve Secular Equation.
*
      IF( K.NE.0 ) THEN
         IS = ( IWORK( COLTYP )+IWORK( COLTYP+1 ) )*CUTPNT +
     $        ( IWORK( COLTYP+1 )+IWORK( COLTYP+2 ) )*( N-CUTPNT ) + IQ2
         CALL DLAED3( K, N, CUTPNT, D, Q, LDQ, RHO, WORK( IDLMDA ),
     $                WORK( IQ2 ), IWORK( INDXC ), IWORK( COLTYP ),
     $                WORK( IW ), WORK( IS ), INFO )
         IF( INFO.NE.0 )
     $      GO TO 20
*
*     Prepare the INDXQ sorting permutation.
*
         N1 = K
         N2 = N - K
         CALL DLAMRG( N1, N2, D, 1, -1, INDXQ )
      ELSE
         DO 10 I = 1, N
            INDXQ( I ) = I
   10    CONTINUE
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of DLAED1
*
      END
c $Id: dlaed1.f 24343 2013-06-22 05:35:15Z d3y133 $

ckbn ccsd_t_singles modified for mrcc
      SUBROUTINE tce_mrcc_q3vnt1(a_i0,d_t1,d_v2,k_t1_offset,k_v2_offset,
     + t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,toggle)
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = 1 * P( 9 ) * t ( p4 h1 )_t * v ( p5 p6 h2 h3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER toggle
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      DOUBLE PRECISION a_i0(*)
      IF (toggle .eq. 2) CALL ccsd_t_q3vnt1_1(d_t1,k_t1_offset,d_v2,
     &   k_v2_offset,a_i0,t_p4b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b)
      RETURN
      END
      SUBROUTINE ccsd_t_q3vnt1_1(d_a,k_a_offset,d_b,k_b_offset,a_c,t_p4
     &b,t_p5b,t_p6b,t_h1b,t_h2b,t_h3b)
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p4 p5 p6 h1 h2 h3 )_vt + = 1 * P( 9 ) * t ( p4 h1 )_t * v ( p5 p6 h2 h3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_p4b
      INTEGER t_p5b
      INTEGER t_p6b
      INTEGER t_h1b
      INTEGER t_h2b
      INTEGER t_h3b
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER h2b_2
      INTEGER h3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO p4b = noab+1,noab+nvab
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h1b = 1,noab
      DO h2b = 1,noab
      DO h3b = h2b,noab
      skipped = .true.
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) skipped = .false.
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1
     &)+int_mb(k_spin+p6b-1)+int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+i
     &nt_mb(k_spin+h3b-1).ne.12)) THEN
      IF (int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),ieor(int_mb(k_sym+p5b-1),ieor(int_mb(
     &k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h2b-1),int
     &_mb(k_sym+h3b-1)))))) .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = int_mb(k_range+p4b-1) * int_mb(k_range+p5b-1) * int_mb(k_ra
     &nge+p6b-1) * int_mb(k_range+h1b-1) * int_mb(k_range+h2b-1) * int_m
     &b(k_range+h3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd_t_q3vnt1_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p4b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p4b,h1b,p4b_1,h1b_1)
      CALL TCE_RESTRICTED_4(p5b,p6b,h2b,h3b,p5b_2,p6b_2,h2b_2,h3b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+p4b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb
     &(k_range+h2b-1) * int_mb(k_range+h3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd_t_q3vnt1_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd_t_q3vnt1_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p4b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd_t_q3vnt1_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd_t_q3vnt1_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd_t_q3vnt1_1',5,MA_ERR)
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h3b_2
     & - 1 + (noab+nvab) * (h2b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (p5b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(h3b_2
     & - 1 + (noab+nvab) * (h2b_2 - 1 + (noab+nvab) * (p6b_2 - 1 + (noab
     &+nvab) * (p5b_2 - 1)))),h3b_2,h2b_2,p6b_2,p5b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h3b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd_t_q3vnt1_1',6,MA_E
     &RR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd_t_q3vnt1_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd_t_q3vnt1_1',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,4,3,5,2,1,1.0d0)
      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,4,3,2,5,1,-1.0d0)
      END IF
      IF ((t_p4b .eq. p4b) .and. (t_p5b .eq. p5b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),6,4,3,2,1,5,1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,6,3,5,2,1,-1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,6,3,2,5,1,1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p4b) .and. (t_p6b .eq. p6b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,6,3,2,1,5,-1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h1b) .and. (t_h2b .eq. h2b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,3,6,5,2,1,1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h1b) .and. (t_h3b .eq. h
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,3,6,2,5,1,-1.0d0)
      END IF
      IF ((t_p4b .eq. p5b) .and. (t_p5b .eq. p6b) .and. (t_p6b .eq. p4b)
     & .and. (t_h1b .eq. h2b) .and. (t_h2b .eq. h3b) .and. (t_h3b .eq. h
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+h3b-1),
     &int_mb(k_range+h2b-1),int_mb(k_range+p6b-1),int_mb(k_range+p5b-1),
     &int_mb(k_range+h1b-1),int_mb(k_range+p4b-1),4,3,6,2,1,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd_t_q3vnt1_1',9
     &,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

c $Id: tce_mrcc_q3vnt1.F 24345 2013-06-22 06:19:30Z d3y133 $

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      subroutine cl_sim(natom1,natom2,task)
#include "common.fh"
c
      double precision tbeg,wraptime
      integer i,j,nprocs,ndim,me,task
      integer heap, stack, natom1, natom2
      integer blocks(2),map0(MD_MAXPROC)
      integer map1(MD_MAXPROC),map2(MD_MAXPROC+1)
      character*32 filename
      logical status
c
c   This is the main calling program for the Molecular Dynamics
c   calculation.
c
c   set io control flags
c
      l_stdio = .true.
      l_rad = .false.
      l_rst = .false.
      l_step = .true.
      l_oldcfg = .false.
c
      do i = 1, MAXTIM
        tmstat(i) = 0.0d00
      end do
      tbeg = wraptime()
c
c   create communication arrays
c
      nprocs = ga_nnodes()
      me = ga_nodeid()
c
c   create map and block arrays to use irregular distributions
c
      map2(1) = 1
      blocks(1) = 1
      blocks(2) = nprocs
      do i = 1, nprocs
        map0(i) = i
        map1(i) = (i-1)*MAXAT + 1
        map2(i+1) = (i-1)*MAXAT + 1
      end do
c
      ndim = 1
      g_size = ga_create_handle()
      call ga_set_data(g_size,ndim,nprocs,MT_INT)
      call ga_set_irreg_distr(g_size,map0,blocks(2))
c      call ga_set_chunk(g_size,ndim)
      status = ga_allocate(g_size)
c
      g_coords = ga_create_handle()
      ndim = 2
      gcoords_hi(1) = 3
      gcoords_hi(2) = MAXAT*nprocs
      call ga_set_data(g_coords,ndim,gcoords_hi,MT_DBL)
      call ga_set_irreg_distr(g_coords,map2,blocks)
c      gcoords_hi(2) = MAXAT
c      call ga_set_chunk(g_coords,gcoords_hi)
      status = ga_allocate(g_coords)
c
      g_frc = ga_create_handle()
      ndim = 2
      gfrc_hi(1) = 3
      gfrc_hi(2) = MAXAT*nprocs
      call ga_set_data(g_frc,ndim,gfrc_hi,MT_DBL)
      call ga_set_irreg_distr(g_frc,map2,blocks)
c      gfrc_hi(2) = MAXAT
c      call ga_set_chunk(g_frc,gfrc_hi)
      status = ga_allocate(g_frc)
c
      g_acc = ga_create_handle()
      ndim = 2
      gacc_hi(1) = 3
      gacc_hi(2) = MAXAT*nprocs
      call ga_set_data(g_acc,ndim,gacc_hi,MT_DBL)
      call ga_set_irreg_distr(g_acc,map2,blocks)
c      gacc_hi(2) = MAXAT
c      call ga_set_chunk(g_acc,gacc_hi)
      status = ga_allocate(g_acc)
c
      g_index = ga_create_handle()
      ndim = 1
      gindex_hi = MAXAT*nprocs
      call ga_set_data(g_index,ndim,gindex_hi,MT_INT)
      call ga_set_irreg_distr(g_index,map1,blocks(2))
c      gindex_hi = MAXAT
c      call ga_set_chunk(g_index,gindex_hi)
      status = ga_allocate(g_index)
c
      g_rvec = ga_create_handle()
      ndim = 1
      grvec_hi = MAXAT*nprocs
      call ga_set_data(g_rvec,ndim,grvec_hi,MT_DBL)
      call ga_set_irreg_distr(g_rvec,map1,blocks(2))
c      grvec_hi = MAXAT
c      call ga_set_chunk(g_rvec,grvec_hi)
      status = ga_allocate(g_rvec)
c
      g_iat = ga_create_handle()
      ndim = 2
      giat_hi(1) = 2
      giat_hi(2) = MAXAT*nprocs
      call ga_set_data(g_iat,ndim,giat_hi,MT_INT)
      call ga_set_irreg_distr(g_iat,map2,blocks)
c      giat_hi(2) = MAXAT
c      call ga_set_chunk(g_iat,giat_hi)
      status = ga_allocate(g_iat)
c
c   set up arrays for describing data held by each processor
c
      do i = 0, nprocs-1
        gsize_lo(i) = 0
        gindex_lo(i) = 0
        grvec_lo(i) = 0
        do j = 1, 2
          gcoords_lo(j,i) = 0
          gfrc_lo(j,i) = 0
          gacc_lo(j,i) = 0
          giat_lo(j,i) = 0
        end do
      end do
      call nga_distribution(g_size,me,gsize_lo(me),gsize_hi)
      call ga_igop(1,gsize_lo,nprocs,'+')
      call nga_distribution(g_coords,me,gcoords_lo(1,me),gcoords_hi)
      call ga_igop(2,gcoords_lo,2*nprocs,'+')
      call nga_distribution(g_frc,me,gfrc_lo(1,me),gfrc_hi)
      call ga_igop(3,gfrc_lo,2*nprocs,'+')
      call nga_distribution(g_acc,me,gacc_lo(1,me),gacc_hi)
      call ga_igop(4,gacc_lo,2*nprocs,'+')
      call nga_distribution(g_index,me,gindex_lo(me),gindex_hi)
      call ga_igop(5,gindex_lo,nprocs,'+')
      call nga_distribution(g_rvec,me,grvec_lo(me),grvec_hi)
      call ga_igop(6,grvec_lo,nprocs,'+')
      call nga_distribution(g_iat,me,giat_lo(1,me),giat_hi)
      call ga_igop(7,giat_lo,2*nprocs,'+')
c
c   Read in variables and initial configuration
c
      task_id = task
      if (me.eq.0.and.l_stdio) then
        if (task.lt.10) then
          write(filename,100) task
        else if (task.ge.10.and.task.lt.100) then
          write(filename,101) task
        else if (task.ge.100.and.task.lt.1000) then
          write(filename,102) task
        else if (task.ge.1000.and.task.lt.10000) then
          write(filename,103) task
        endif
  100   format('md.out',i1)
  101   format('md.out',i2)
  102   format('md.out',i3)
  103   format('md.out',i4)
        open(unit=6,file=filename,status='unknown')
      endif
      if (me.eq.0.and.l_rad)
     +  open(unit=7,file='rad.dat',status='unknown')
      call rdpar
      call atomin
      r_cluster = 0.0d00
      if (.not.l_oldcfg) then
        if (me.eq.0) call newcfg(natom1,natom2,task,r_cluster,rcut)
      endif
      call ga_dgop(3,r_cluster,1,'+')
      call rdcfg
      call shuffle
c
c   Initialize MD calculations
c
      call mdinit
c
c   Begin MD calculation
c
      call mdstep
      tmstat(1) = tmstat(1) + wraptime() - tbeg
      call mdout
c
c   Close out calculation
c
      if (l_stdio) close(6)
      if (l_rad) close(7)
      status = ga_destroy(g_size)
      status = ga_destroy(g_coords)
      status = ga_destroy(g_frc)
      status = ga_destroy(g_acc)
      status = ga_destroy(g_index)
      status = ga_destroy(g_rvec)
      status = ga_destroy(g_iat)
c
      return
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c vector boxes lack arithmetic precision 
#ifdef CRAY_YMP
# define THRESH 1d-10
#elif defined(FUJITSU)
# define THRESH 1d-12
# define THRESHF 1e-5
#else
# define THRESH 1d-13
# define THRESHF 1e-5
#endif
#define MISMATCH(x,y) abs(x-y)/max(1d0,abs(x)).gt.THRESH
#define MISMATCHF(x,y) abs(x-y)/max(1.0,abs(x)).gt.THRESHF

#define USE_CORNERS

#define PRINT_VAL
c#define NEW_API
c
c  Add some control over which tests are performed
c
#define TEST_1
#define TEST_2
#define TEST_3
#define TEST_4
c#define TEST_5
#define TEST_6
#define TEST_7
#define TEST_8

      program main
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "testutil.fh"
      integer heap, stack, fudge, ma_heap, me
      integer nmax, DIM, nwidth, MAXPROC, nloop
      parameter (nmax = 1000, DIM = 2, nwidth = 2, MAXPROC = 2000)
      parameter (nloop = 50)
      integer ndim, nproc, pdims(7), type, dcnt, g_a, maxval, nbhandle
      integer i, j, dims(7), width(7), map(2*nmax)
      integer lo(7), hi(7), ld(7)
      integer lo2(7), hi2(7), ld2(7)
      integer dims3(7), ld3(7), chunk(7)
      MA_ACCESS_INDEX_TYPE index3
      integer a(nmax, nmax), b(nmax+2*nwidth,nmax+2*nwidth)
      double precision start,t1,t2,t3,t4,t5,tmp
      double precision t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18
      double precision t19,t20,t21,t22,t23,t24,t25,t26,t27
      logical status, safe_put, safe_get, has_data(0:MAXPROC-1)
      parameter (heap=1000*1000*4, fudge=1000, stack=1000*1000)
      logical corner_flag
c     
c***  Intitialize a message passing library
c
#include "mp3.fh"
#ifdef USE_CORNERS
      corner_flag = .true.
#else
      corner_flag = .false.
#endif
c
c***  Initialize GA
c
c     There are 2 choices: ga_initialize or ga_initialize_ltd.
c     In the first case, there is no explicit limit on memory usage.
c     In the second, user can set limit (per processor) in bytes.
c
      print*
      call ga_initialize()
      nproc = ga_nnodes()
      me = ga_nodeid()
c     we can also use GA_set_memory_limit BEFORE first ga_create call
c
      ma_heap = heap + fudge 
      call GA_set_memory_limit(util_mdtob(ma_heap))
c
      if(ga_nodeid().eq.0)then
         print *,' GA initialized '
         call ffflush(6)
      endif
c
c***  Initialize the MA package
c     MA must be initialized before any global array is allocated
c
      status = ma_init(MT_DCPL, stack, ma_heap)
      if (.not. status) call ga_error('ma_init failed',-1) 
c
      if(me.eq.0)then
        print *, 'using ', nproc, ' process(es)'
        call ffflush(6)
      endif
c
c   Test ghost distributions
c
      ndim = DIM
c
c   Create irregular distribution on all nodes
c
      call factor(nproc,ndim,pdims)
      dims(1) = pdims(1) * nmax
      dims(2) = pdims(2) * nmax
      maxval = 1
      do i = 1, ndim
        maxval = dims(i)*maxval
      end do
      maxval = maxval - 1
c
      dcnt = 1
      do i = 1, pdims(1)
        map(dcnt) = (i-1)*nmax + 1
        dcnt = dcnt + 1
      end do
      do i = 1, pdims(2)
        map(dcnt) = (i-1)*nmax + 1
        dcnt = dcnt + 1
      end do
c
      do i = 1, ndim
        width(i) = nwidth
        chunk(i) = 1
        if (pdims(i).gt.dims(i)) pdims(i) = dims(i)
        if (me.eq.0) then
          write(6,*) 'Value of pdims(',i,') is ',pdims(i)
        endif
        call ffflush(6)
c        do j = 1, pdims(i)
c          if (j.eq.1) then
c            map(dcnt) = 1
c          else
c            map(dcnt) = ((j-1)*dims(i))/pdims(i) + 1
c          endif
c          dcnt = dcnt + 1
c        end do
        ld(i) = nmax
      end do
      if (me.eq.0) then
        do i = 1, dcnt - 1
          write(6,'("map(",i2,") = ",i5)') i,map(i)
          call ffflush(6)
        end do
      endif

      type = MT_INT
#ifdef NEW_API
      g_a = ga_create_handle();
      call ga_set_data(g_a,ndim,dims,type)
      call ga_set_array_name(g_a,"test_array")
      call ga_set_irreg_distr(g_a,map,pdims)
      call ga_set_ghosts(g_a,width)
      status = ga_allocate(g_a)
#else
      status = nga_create_ghosts_irreg (type, ndim, dims, width,
     +        "test_array", map, pdims, g_a)
c      status = nga_create_ghosts(type, ndim, dims, width,
c     +                           "test_array", chunk, g_a)
#endif

      if (status.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '* Global array creation was successful'
        write(6,*) '*'
      elseif (.not.status) then
        write(6,*) 'Global array creation failure on ',me
      endif
c
c   Find processors that have data
c
      call ga_sync
      do i = 0, nproc-1
        call nga_distribution(g_a, i, lo, hi)
        has_data(i) = .true.
        do j = 1, ndim
          if (lo(j).eq.0.and.hi(j).eq.-1) has_data(i) = .false.
        end do
        call ffflush(6)
        call ga_sync
      end do
c
c     initialize g_a
c
      call ga_sync
      call nga_distribution(g_a, me, lo, hi)
      do i = 1, hi(1) - lo(1) + 1
        do j = 1, hi(2) - lo(2) + 1
          a(i,j) = (i + lo(1) - 2)*dims(1) + (j + lo(2) - 2)
        end do
      end do
      safe_put = .true.
      do i = 1, ndim
        if (hi(i).lt.lo(i)) safe_put = .false.
      end do
      if (has_data(me).and.safe_put) call nga_put(g_a, lo, hi, a, ld)
c
c     get patch with ghost cells
c
      do i = 1, ndim
        lo2(i) = lo(i) - width(i)
        hi2(i) = hi(i) + width(i)
        ld2(i) = ld(i) + 2*width(i)
      end do
      call ga_sync
      call ffflush(6)
      safe_get = .true.
c      do i = 1, ndim
c        if (hi2(i)-lo2(i).ge.dims(i)) safe_get = .false.
c      end do

      t19 = 0.0d00
      t20 = 0.0d00
      t21 = 0.0d00
      do i = 1, nloop
        start = util_timer()
        call ga_ghost_barrier
        t19 = t19 + util_timer() - start
        start = util_timer()
        if (has_data(me).and.safe_get)
     +    call nga_periodic_get(g_a, lo2, hi2, b, ld2)
        t20 = t20 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t21 = t21 + util_timer() - start
      end do
      t19 = t19/dble(nloop)
      t20 = t20/dble(nloop)
      t21 = t21/dble(nloop)

  102 format(14i5)
      if (me.eq.0) then
        write(6,*) '*'
        write(6,*) '*   Performing nga_access_ghosts'
        write(6,*) '*'
        call ffflush(6)
      endif
      if (has_data(me)) call nga_access_ghosts(g_a, dims3,
     +    index3, ld3)
      call ga_sync

#ifdef TEST_1
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing update 1'
        write(6,*)
      endif
      t1 = 0.0d00
      t2 = 0.0d00
      t3 = 0.0d00
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t1 = t1 + util_timer() - start
        start = util_timer()
        call ga_update1_ghosts(g_a)
        t2 = t2 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t3 = t3 + util_timer() - start
      end do
      t1 = t1/dble(nloop)
      t2 = t2/dble(nloop)
      t3 = t3/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,1)
      call ga_sync
#endif

#ifdef TEST_2
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing update 2'
        write(6,*)
      endif
      t4 = 0.0d00
      t5 = 0.0d00
      t6 = 0.0d00
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t4 = t4 + util_timer() - start
        start = util_timer()
        status = ga_update2_ghosts(g_a)
        t5 = t5 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t6 = t6 + util_timer() - start
      end do
      t4 = t4/dble(nloop)
      t5 = t5/dble(nloop)
      t6 = t6/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,2)
      call ga_sync
#endif

#ifdef TEST_3
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing update 3'
        write(6,*)
      endif
      t7 = 0.0d00
      t8 = 0.0d00
      t9 = 0.0d00
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t7 = t7 + util_timer() - start
        start = util_timer()
        status = ga_update3_ghosts(g_a)
        t8 = t8 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t9 = t9 + util_timer() - start
      end do
      t7 = t7/dble(nloop)
      t8 = t8/dble(nloop)
      t9 = t9/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,3)
      call ga_sync
#endif

#ifdef TEST_4
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing update 4'
        write(6,*)
      endif
      t10 = 0.0d00
      t11 = 0.0d00
      t12 = 0.0d00
      call ga_sync
      call ga_set_ghost_corner_flag(g_a,corner_flag)
c
      status = ga_set_update4_info(g_a)
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t10 = t10 + util_timer() - start
        start = util_timer()
        status = ga_update4_ghosts(g_a)
        t11 = t11 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t12 = t12 + util_timer() - start
      end do
      t10 = t10/dble(nloop)
      t11 = t11/dble(nloop)
      t12 = t12/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,4)
      call ga_sync
#endif

#ifdef TEST_5
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing update 5'
        write(6,*)
      endif
      t13 = 0.0d00
      t14 = 0.0d00
      t15 = 0.0d00
      call ga_sync
      call ga_set_ghost_corner_flag(g_a,corner_flag)
c
      status = ga_set_update5_info(g_a)
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t13 = t13 + util_timer() - start
        start = util_timer()
c     write(6,*) 'got to ga_update5_ghosts'
        status = ga_update5_ghosts(g_a)
c     write(6,*) 'completed ga_update5_ghosts'
        t14 = t14 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t15 = t15 + util_timer() - start
      end do
      t13 = t13/dble(nloop)
      t14 = t14/dble(nloop)
      t15 = t15/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,5)
      call ga_sync
#endif

#ifdef TEST_6
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing update 6'
        write(6,*)
      endif
      t16 = 0.0d00
      t17 = 0.0d00
      t18 = 0.0d00
      call ga_sync
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t16 = t16 + util_timer() - start
        start = util_timer()
        status = ga_update6_ghosts(g_a)
        t17 = t17 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t18 = t18 + util_timer() - start
      end do
      t16 = t16/dble(nloop)
      t17 = t17/dble(nloop)
      t18 = t18/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,6)
      call ga_sync
#endif

#ifdef TEST_7
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing update 7'
        write(6,*)
      endif
      t22 = 0.0d00
      t23 = 0.0d00
      t24 = 0.0d00
      call ga_sync
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t22 = t22 + util_timer() - start
        start = util_timer()
        status = ga_update7_ghosts(g_a)
        t23 = t23 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t24 = t24 + util_timer() - start
      end do
      t22 = t22/dble(nloop)
      t23 = t23/dble(nloop)
      t24 = t24/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,7)
      call ga_sync
#endif

#ifdef TEST_8
      if (me.eq.0) then
        write(6,*)
        write(6,*) 'Testing non-blocking update'
        write(6,*)
      endif
      t25 = 0.0d00
      t26 = 0.0d00
      t27 = 0.0d00
      call ga_sync
      do i = 1, nloop
        call zero_ghosts(int_mb(index3),ld3,a,hi(1)-lo(1)+1,width,dims3)
        start = util_timer()
        call ga_ghost_barrier
        t25 = t25 + util_timer() - start
        start = util_timer()
        call nga_update_ghosts_nb(g_a,nbhandle)
        call ga_nbwait(nbhandle)
        t26 = t26 + util_timer() - start
        start = util_timer()
        call ga_ghost_barrier
        t27 = t27 + util_timer() - start
      end do
      t25 = t25/dble(nloop)
      t26 = t26/dble(nloop)
      t27 = t27/dble(nloop)
#ifdef PRINT_VAL
      if (maxval.lt.10000)
     +      call aprint(int_mb(index3),dims3(1),dims3(2),ld3,has_data)
#endif
      call atest(int_mb(index3),dims3(1),dims3(2),ld3,b,
     +           nmax+2*width(1),has_data,width,corner_flag,8)
      call ga_sync
#endif

      if (me.eq.0) then
        write(6,*) '*'
        write(6,*) '*   Completed updates successfully'
        write(6,*) '*'
        call ffflush(6)
      endif
      call ga_sync
c
#ifdef TEST_1
      tmp = t2
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 1,tmp/dble(nproc)
      endif
      tmp = t1
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t3
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
#ifdef TEST_2
      tmp = t5
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 2,tmp/dble(nproc)
      endif
      tmp = t4
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t6
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
#ifdef TEST_3
      tmp = t8
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 3,tmp/dble(nproc)
      endif
      tmp = t7
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t9
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
#ifdef TEST_4
      tmp = t11
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 4,tmp/dble(nproc)
      endif
      tmp = t10
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t12
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
#ifdef TEST_5
      tmp = t14
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 5,tmp/dble(nproc)
      endif
      tmp = t13
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t15
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
#ifdef TEST_6
      tmp = t17
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 6,tmp/dble(nproc)
      endif
      tmp = t16
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t18
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
#ifdef TEST_7
      tmp = t23
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 7,tmp/dble(nproc)
      endif
      tmp = t22
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t24
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
#ifdef TEST_8
      tmp = t26
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,300) 8,tmp/dble(nproc)
      endif
      tmp = t25
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t27
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
#endif
      tmp = t20
      call ga_dgop(6,tmp,1,'+')
      if (me.eq.0) then
        write(6,310) tmp/dble(nproc)
      endif
      tmp = t19
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,400) tmp/dble(nproc)
      endif
      tmp = t21
      call ga_dgop(3,tmp,1,'+')
      if (me.eq.0) then
        write(6,500) tmp/dble(nproc)
      endif
  300 format('Average time for ga_update',i1,'_ghosts ',e12.3)
  310 format('Average time for nga_periodic_get  ',e12.3)
  400 format('   Average time for prior sync ',e12.3)
  500 format('   Average time for post sync  ',e12.3)
  127 continue
c
      if(ga_nodeid().eq.0) print *,'All tests successful '
c      
c***  Tidy up the GA package
c
      call ga_terminate()
c
c***  Tidy up after message-passing library
c
      call MP_FINALIZE()

c
      stop
      end
c
      subroutine zero_ghosts(a,lda,b,ldb,w,dims)
      integer lda,ldb,w(*),dims(*)
      integer a(lda,*),b(ldb,*)
      integer i, j
      do j = 1, dims(2)
        do i = 1, dims(1)
          if ((i.gt.w(1).and.i.le.dims(1)-w(1)).and.
     +        (j.gt.w(2).and.j.le.dims(2)-w(2))) then
            a(i,j) = b(i-w(1),j-w(2))
          else
            a(i,j) = 0
          endif
        end do
      end do
      return
      end
c
      subroutine aprint(a,nrow,ncol,ld,has_data)
#include "global.fh"
      integer ld
      integer a(ld,*)
      integer i, j, k, nproc
      logical has_data(0:1999)
       
      nproc = ga_nnodes()
      do k = 1, nproc
        call ga_sync
        if (k-1.eq.ga_nodeid().and.has_data(k-1)) then
          write(6,*) '*'
          write(6,*) '*   Data on processor ',k-1
          write(6,*) '*'
          do i = 1, min(nrow,12)
            write (6,102) (a(i,j), j = 1, min(ncol,12))
  102       format(14i5)
          end do
        endif
        call ffflush(6)
      enddo
c
      return
      end
c
      subroutine atest(a,nrow,ncol,ld,b,ld2,has_data,width,
     +                 check_corner, idx)
#include "global.fh"
      integer ld, width(7)
      integer a(ld,*), b(ld2,*)
      integer i, j, nproc, me, idx
      logical has_data(0:1999), check_data
      logical check_corner

      nproc = ga_nnodes()
      me = ga_nodeid()
      check_data = .true.
      call ga_sync
      if (has_data(me)) then
        do i = 1, nrow
          do j = 1, ncol
            if (.not.check_corner.and.(.not.
     +          ((i.le.width(1).and.j.le.width(2)).or.
     +           (i.le.width(1).and.j.gt.ncol-width(2)).or.
     +           (i.gt.nrow-width(1).and.j.le.width(2)).or.
     +           (i.gt.nrow-width(1).and.j.gt.ncol-width(2))))) then
              if (a(i,j).ne.b(i,j)) check_data = .false.
            else if (check_corner) then
              if (a(i,j).ne.b(i,j)) check_data = .false.
            endif
          end do
        end do
      else
        check_data = .false.
      endif
      if (check_data) then
        i = 1
      else
        i = 0
      endif
      call ga_igop(1,i,1,'+')
      if (i.ne.nproc) then
        check_data = .false.
      else
        check_data = .true.
      endif
      if (check_data.and.me.eq.0) then
        write(6,*) '*'
        write(6,*) '*   Data from nga_access_ghosts and'
        write(6,*) '*   nga_periodic_get is the same on'
        write(6,100) idx
  100   format(    ' *   all processors for update ',i1)
        write(6,*) '*'
      else if (.not.check_data) then
        write(6,*) '*'
        write(6,*) '*   Data from nga_access_ghosts and'
        write(6,*) '*   nga_periodic_get is NOT the same on'
        write(6,200) me,idx
  200   format(    ' *   processor ',i2,' for update ',i1)
        write(6,*) '*'
      endif
      call ffflush(6)
c
      return
      end
c
      subroutine factor(p,ndim,dims)
      implicit none
      integer i,j,p,ndim,dims(7),imin,mdim
      integer ip,ifac,pmax,prime(1000)
      integer fac(1000)
c
      i = 1
      ip = p
      do i = 1, ndim
        dims(i) = 1
      end do
c
c    factor p completely
c    first, find all prime numbers less than or equal to p
c
      pmax = 0
      do i = 2, p
        do j = 1, pmax
          if (mod(i,prime(j)).eq.0) go to 100
        end do
        pmax = pmax + 1
        prime(pmax) = i
  100   continue
      end do
c
c    find all prime factors of p
c
      ifac = 0
      do i = 1, pmax
  200   if (mod(ip,prime(i)).eq.0) then
          ifac = ifac + 1
          fac(ifac) = prime(i)
          ip = ip/prime(i)
          go to 200
        endif
      end do
c
c    determine dimensions of processor grid
c
      do i = ifac, 1, -1
c
c    find dimension with minimum value
c
        imin = dims(1)
        mdim = 1
        do j = 2, ndim
          if (dims(j).lt.imin) then
            imin = dims(j)
            mdim = j
          endif
        end do
        dims(mdim) = dims(mdim)*fac(i)
      end do
c
      return
      end

c     $Id: band_stress.F 19707 2010-10-29 17:59:36Z d3y133 $

      logical function band_stress(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "rtdb.fh"

*     **** local variables ****
      logical numerical

*     **** external functions ****
      logical  band_minimizer,band_stress_numerical
      external band_minimizer,band_stress_numerical

      if (.not.
     >  rtdb_get(rtdb,'nwpw:stress_numerical',mt_log,1,numerical))
     >  numerical = .false.

      if (numerical) then
        band_stress = band_stress_numerical(rtdb)
      else
        band_stress = band_minimizer(rtdb,3)
      end if

      return
      end

#if  defined(HPUX)
      double precision function derf(x)
      implicit none
      double precision x,util_erf,derf
      external util_erf
      derf=util_erf(x)
      return
      end

      double precision function derfc(x)
      implicit none
      double precision x,util_erfc,derfc
      external util_erfc
      derfc=util_erfc(x)
      return
      end
c
      double precision function erfc(x)
      implicit none
      double precision x,util_erfc
      external util_erfc
      erfc=util_erfc(x)
      return
      end
c
#endif                                                                          

      real*8 function util_erf(x) 
      implicit none
      real*8 x
*     **** local variables ****
      real*8 f
*     ***** external functions ****
      real*8  gammp
      external gammp
      IF(x.lt.0.0d0)then
        f = -gammp(0.5d0,x**2)
      ELSE
        f = +gammp(0.5d0,x**2)
      ENDIF
      util_erf = f
      return
      end 

      real*8 function util_erfc(x) 
      implicit none
      real*8 x
*     **** local variables ****
      real*8 f
*     ***** external functions ****
      real*8  gammp
      external gammp
      IF(x.lt.0.0d0)then
        f = -gammp(0.5d0,x**2)
      ELSE
        f = +gammp(0.5d0,x**2)
      ENDIF
      util_erfc = 1.0d0-f
      return
      end 

c*************************************************************************
c !
c !      This is a slightly modified version of Log(Gamma) function
c !      program from Num. Rec.
c !************************************************************************

      real*8 function ln_gamma(xx)
      implicit none
      real*8  xx

*     *** local variables ****
      integer j
      real*8 ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     >24.01409824083091d0,-1.231739572450155d0,0.1208650973866179d-2,
     >-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*dlog(tmp)-tmp
      ser=1.000000000190015d0
      DO 11 j=1,6
        y=y+1.0d0
        ser=ser+cof(j)/y
11    CONTINUE

      ln_gamma=tmp+dlog(stp*ser/x)

      return
      END

      real*8 function util_gamma(x)
      implicit none
      real*8 x

      real*8 xx
      real*8   ln_gamma
      external ln_gamma

      XX = X
      util_gamma = dexp(ln_gamma(xx))

      return
      END

      real*8 function util_gammp(a,x)
      implicit none
      real*8 a,x

#include "errquit.fh"

*     **** external functions ****
      real*8   gammcf,gamser,gln

      IF(x.LT.0.0d0 .OR. a.LE.0.0d0) THEN
        call errquit('bad arguments in util_gammp',0, INPUT_ERR)
      END IF

      IF (x .lt. (a+1.0d0)) THEN
        call gser(gamser,a,x,gln)
        util_gammp=gamser
      ELSE
        CALL gcf(gammcf,a,x,gln)
        util_gammp=1.0d0-gammcf
      ENDIF
      return
      end


     
      real*8 function gammp(a,x)
      implicit none
      real*8 a,x

#include "errquit.fh"

*     **** external functions ****
      real*8   gammcf,gamser,gln

      IF(x.LT.0.0d0 .OR. a.LE.0.0d0) THEN
        call errquit('bad arguments in gammp',0, INPUT_ERR)
      END IF

      IF (x .lt. (a+1.0d0)) THEN
        call gser(gamser,a,x,gln)
        gammp=gamser
      ELSE
        CALL gcf(gammcf,a,x,gln)
        gammp=1.0d0-gammcf
      ENDIF
      return
      end

      SUBROUTINE gcf(gammcf,a,x,gln)
      implicit none
#include "errquit.fh"
      integer ITMAX
      real*8  a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=1000,EPS=3.0d-12,FPMIN=1.0d-30)
      real*8       an,b,c,d,del,h
      double precision undovl
      parameter(undovl=-20d0*2.3025d0)
      integer i
      real*8   ln_gamma
      external ln_gamma

      gln=ln_gamma(a)
      b=x + 1.0d0 - a
      c=1.0d0/FPMIN
      d=1.0d0/b
      h=d
      DO 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.0d0
        d=an*d+b
        IF(DABS(d).lt.FPMIN) d=FPMIN
        c=b+an/c
        IF(DABS(c).lt.FPMIN) c=FPMIN
        d=1.0d0/d
        del=d*c
        h=h*del
        IF(DABS(del-1.0d0).lt.EPS) GOTO 1
11    CONTINUE
      call errquit('a too large, ITMAX too small in gcf',0, INPUT_ERR)
1     if((-x+a*LOG(x)-gln).gt.undovl) then
         gammcf=DEXP(-x+a*LOG(x)-gln)*h
      else
         gammcf=0d0
      endif
      return
      END 



      subroutine gser(gamser,a,x,gln)
      implicit none
#include "errquit.fh"
      real*8    a,x
      real*8   gamser,gln
    
*     **** parameters ****
      integer  ITMAX 
      parameter (ITMAX=1000)
      real*8  EPS
      parameter (EPS=3.0d-12)

*     **** local variables ****
      integer n
      real*8  ap,del,sum

*     **** external functions ***
      real*8   ln_gamma
      external ln_gamma


      gln=ln_gamma(a)

      IF(x.le.0.0d0) THEN
        IF(x.lt.0.0d0) call errquit('x < 0 in gser',0, UNKNOWN_ERR)
          gamser=0.0d0
          RETURN
      ENDIF

      ap=a
      sum=1.0d0/a
      del=sum
      DO n=1,ITMAX
        ap=ap+1.0d0
        del=del*x/ap
        sum=sum+del
        IF(DABS(del).lt.DABS(sum)*EPS) GOTO 1
      END DO

      CALL errquit('a too large, ITMAX too small in gser',0, INPUT_ERR)

1     gamser=sum*DEXP(-x+a*LOG(x)-gln)

      return
      END 
c $Id: util_erf.F 21327 2011-10-28 17:04:38Z bylaska $

      logical function argos_prep_topsiz(lfntop,filtop,lfnout,
     + nat,nsa,nwa,nsb,nqu,nseq)
c
c $Id: argos_prep_topsiz.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer lfntop,lfnout,nsa,nwa,nat,nqu
      character*255 filtop
      character*1 cdummy
      character*80 card
c
      integer nwb,nwh,nwd,nwo,nwt,nwn,nsb,nsh,nsd,nso,nst,nsx
      integer i,j,k,len,npar,nseq
c
      len=index(filtop,' ')-1
      open(unit=lfntop,file=filtop(1:len),form='formatted',
     + status='old',err=9999)
c
      do 1 i=1,4
      read(lfntop,1000) cdummy
 1000 format(a1)
    1 continue
      read(lfntop,1001) npar
      read(lfntop,1001) nat
      read(lfntop,1001) nqu
      read(lfntop,1001) nseq
      read(lfntop,1000) cdummy
 1001 format(i5)
      do 2 i=1,nat*npar
      read(lfntop,1000) cdummy
    2 continue
      do 3 i=1,nat
      do 4 j=i,nat
      do 5 k=1,npar
      read(lfntop,1000) cdummy
    5 continue
    4 continue
    3 continue
      do 6 i=1,nqu*npar
      read(lfntop,1000) cdummy
    6 continue
      do 7 i=1,nseq
      read(lfntop,1000) cdummy
    7 continue
      read(lfntop,1002) nwa,nwb,nwh,nwd,nwo,nwt,nwn
      read(lfntop,1002) nsa,nsb,nsh,nsd,nso,nst,nsx
 1002 format(7i7)
c
      close(unit=lfntop)
c
      argos_prep_topsiz=.true.
      return
c
 9998 continue
      close(unit=lfntop)
 9999 continue
      argos_prep_topsiz=.false.
      return
      end

      subroutine gather(n,a,b,indx)
*
* $Id: gather.f 19707 2010-10-29 17:59:36Z d3y133 $
*
      integer n, indx(n)
      double precision a(n),b(*)
      integer i
      
      do i=1,n
        a(i) = b(indx(i))
      enddo
      return
      end

      

            block data initial_smd_cutoff_data
      implicit none
#include "smd_cutoff_data.fh"
c     
      data ostatus /.false./
      data rcut /0.0d0/
      data rcut_verlet /0.0d0/


      end

      subroutine smd_cutoff_get_rcut(arcut)
      implicit none
#include "smd_cutoff_data.fh"

      double precision arcut

      arcut = rcut

      end 

      subroutine smd_cutoff_set_rcut(arcut)
      implicit none
#include "smd_cutoff_data.fh"

      double precision arcut

      rcut = arcut

      end 

      subroutine smd_cutoff_get_rcut_verlet(arcut_verlet)
      implicit none
#include "smd_cutoff_data.fh"

      double precision arcut_verlet

      arcut_verlet = rcut_verlet

      end 

      subroutine smd_cutoff_set_rcut_verlet(arcut_verlet)
      implicit none
#include "smd_cutoff_data.fh"

      double precision arcut_verlet

      rcut_verlet = arcut_verlet

      end 

      subroutine smd_cutoff_print(un)
      implicit none
#include "smd_cutoff_data.fh"

      integer un

      write(un,*) "cutoff data"
      write(un,*) "cutoff radius",rcut
      write(un,*) "verlet cutoff radius",rcut_verlet

      end 

      subroutine smd_cutoff_init()
      implicit none
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_cutoff_data.fh"

c
      character*32 tag
      character*32 pname
      integer rtdb

      pname = "smd_cutoff_init"

      call smd_rtdb_get_handle(rtdb)
      tag="smd:rcut"
        if (.not.rtdb_get(rtdb,tag,mt_dbl,1,rcut)) 
     >      call errquit(pname//'failed to get'//tag,0,
     >       RTDB_ERR)

      tag="smd:verlet" 
        if (.not.rtdb_get(rtdb,tag,mt_dbl,1,rcut_verlet)) 
     >      call errquit(pname//'failed to get'//tag,0,
     >       RTDB_ERR)


      end 
c $Id: smd_cutoff_data.F 22502 2012-05-20 06:11:57Z d3y133 $

      function smd_monomer(im)
      implicit none

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "global.fh"
      logical smd_monomer
      integer im
c
      character*72 namespace
      character*32 pname
      integer rtdb
      logical result
      double precision qm_energy
      logical task_energy_doit
      external task_energy_doit
      logical esp
      external esp
      integer util_sgroup_mygroup
      external util_sgroup_mygroup
      logical mode
      character*72 tag
      character*256 movecs
      character*16 theory


      pname = "smd_monomer"
      write(*,*) "in "//pname
c
      theory = "dft"
      call smd_geom_monomer_create(im)

      call ga_pgroup_sync(ga_pgroup_get_default())

      call smd_rtdb_get_handle(rtdb)
      result = task_energy_doit(rtdb,theory,qm_energy)

        if(.not.rtdb_put(rtdb,'esp:newgrd',mt_int,1,1))
     +     call errquit('esp: rtdb_put newgrd failed',0,0)

     
      if (theory.eq.'dft') then
       tag='dft:output vectors'
      else
       tag='scf:output vectors'
      endif

      if (.not.rtdb_cget(rtdb,tag,1,
     >                   movecs)) then
       write (6,*) 'error in rtdb_cget'
      end if
c
      if (.not.rtdb_cput(rtdb,'esp:input vectors',1,
     >                   movecs)) then
       write (6,*) 'error in rtdb_cput'
      end if
c
      if(.not.esp(rtdb))
     &    call errquit(pname//'failed esp call', 100,
     &                 RTDB_ERR)

      call smd_geom_push_charges(im)

      if(ga_nodeid().eq.0)
     & call smd_charge_ga_set1(im)
c      call smd_charge_ga_set(im)
 
 
      call smd_geom_monomer_end()

      write(*,*) "Goodbye from "//pname,util_sgroup_mygroup(),qm_energy
      smd_monomer = .true.

      return
      end function
c $Id: smd_monomer.dft.F 22502 2012-05-20 06:11:57Z d3y133 $

C> \ingroup selci
C> @{
      subroutine selci_inicij(w1,w2)
*
* $Id: inicij.F 24790 2013-11-11 18:56:49Z d3y133 $
*
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
#include "ceij.fh"
c
      dimension w1(nfmax,nfmax,nsmax),w2(nfmax2,nfmax,nsmax-1)
      data big /0.17976931348623132d+309/
c
c     make the coupling coefficient arrays <*|eij|*> for
c     up to 8 unpaired electrons (hard dimensions in ceij)
c
c     make sure of unambiguous disaster if unitialized
c     elements are accessed
c
      call dfill(nfc*nfc*nsc*(nsc+1),big,case1,1)
      call dfill(nfc*nfc2*nsc*nsc,big,case1,1)
      call dfill(nfc*nfc*nsc*(nsc+1),big,case4,1)
c
      do 5 ns = nsmax,0,-2
         if (ns.le.8) then
            nseij = ns
            ns4eij = min(ns,nsmax-2)
            goto 6
         endif
 5    continue
      write(6,*) ' nsmax, nseij, ns4eij ',nsmax, nseij, ns4eij
      call errquit('inicij: failed to initialize nseij etc. ',nseij,
     &       CALC_ERR)
 6    continue
      numf = nf(nseij)
      numf2 = nf(nseij-2)
      ns = nseij
      nsdiff = nsmax - ns
c
c     case 1: iocc(i)=1, iocc(j)=0
c
      do 10 iib = 1,ns
         do 20 jjb = 1,ns+1
            jb = jjb + nsdiff
            if (jjb.gt.iib) jb = jb - 1
            ib = iib + nsdiff
            call selci_axbt(w1(1,1,ib),nfmax, w1(1,1,jb),nfmax,
     $           case1(1,1,iib,jjb),nfc, numf, numf, numf)
 20      continue
 10   continue
c
c     case 2: iocc(i) = 1, iocc(j) = 1
c
c     case 3: iocc(i) = 3, iocc(j) = 0 is the same as swapping the
c             indices ib and jb and then transposing the matrix
c
      do 30 iib = 1,ns
         do 40 jjb = 1,ns
            if (iib.eq.jjb) goto 40
            jb = jjb + nsdiff
            if (jjb.gt.iib) jb = jb - 1
            ib = iib + nsdiff
            call selci_axbt(w1(1,1,ib),nfmax, w2(1,1,jb),nfmax2,
     $           case2(1,1,iib,jjb),nfc, numf, numf, numf2)
 40      continue
 30   continue
c
c     case 4: iocc(i) = 3, iocc(j) = 1
c
      ns = ns4eij
      numf = nf(ns4eij)
      numf2 = nf(ns+2)
      nsdiff = nsmax - (ns+2)
c
      do 50 iib = 1,ns+1
         do 60 jjb = 1,ns
            jb = jjb + nsdiff
            if (jjb.ge.iib) jb = jb + 1
            ib = iib + nsdiff
            call selci_axbt(w2(1,1,ib),nfmax2, w2(1,1,jb),nfmax2,
     $           case4(1,1,iib,jjb),nfc, numf, numf2, numf)
 60      continue
 50   continue
c
      end
C> @}

C $Id: fdiag.F 19708 2010-10-29 18:04:21Z d3y133 $
      Subroutine drdy_fdiag (ndim,nfreq,ierr,jprnt)
C
      Implicit none
      Integer ndim,nfreq,ierr,jprnt
C
#include "drdyP.fh"
C
      Integer i,j,jp,m,m1,m2,mp,n,nbar
      Double Precision temp
C
C  Diagonalize hessian and write out frequencies and eigenvectors
      n=1
      nbar = (ndim*(ndim+1))/2
      call drdy_RSP (n3tm,ndim,nbar,hess,scr1,n,eigvec,scr2,scr3,ierr)
      if (ierr.eq.0) then
C Sort eigenvalues in scr1 into descending order, and shift locations
C  of eigenvectors to match
         m = 2
         do while (m.le.ndim)
            temp = scr1(m)
            do i = 1,ndim
               scr2(i) = eigvec(i,m)
            enddo
            j = 1
            do while (j.lt.m .and. temp.lt.scr1(j))
               j = j + 1
            enddo
            jp = m
            do while (jp.gt.j)
               scr1(jp) = scr1(jp-1)
               do i = 1,ndim
                  eigvec(i,jp) = eigvec(i,jp-1)
               enddo
               jp = jp - 1
            enddo
            scr1(j) = temp
            do i = 1,ndim
               eigvec(i,j) = scr2(i)
            enddo
            m = m + 1
         enddo
C look for large negative eigenvalues to replace small positive or negative ones
         j = nfreq
         jp = ndim
         do while (jp.gt.nfreq+1 .and. j.ge.1
     *    .and. -scr1(jp).gt.abs(scr1(j)))
            temp = scr1(jp)
            scr1(jp) = scr1(j)
            scr1(j) = temp
            do i = 1,ndim
               temp = eigvec(i,jp)
               eigvec(i,jp) = eigvec(i,j)
               eigvec(i,j) = temp
            enddo
            j = j - 1
            jp = jp - 1
         enddo
C Calculate frequencies
         do m = 1,ndim
            scr2(m) = autocm*scr1(m)
            if (scr2(m).ne.0.0d00) scr2(m) = 
     *       scr2(m)/(sqrt(redm*abs(scr1(m))))
         enddo
         if (jprnt.ne.0) then
            write(fu6,600)
            m1 = 1
            m2 = min(6,ndim)
            do while (m1.le.ndim)
               Write(fu6,601) (m,m=m1,m2)
               Write(fu6,602) (scr1(m),m=m1,m2)
               Write(fu6,603) (scr2(m),m=m1,m2)
               Write(fu6,604)
               do m = 1,ndim
                  Write(fu6,605) m,(eigvec(m,mp), mp=m1,m2)
               enddo
               Write(fu6,*) ' '
               m1 = m2+1
               m2 = min(m1+5,ndim)
            enddo
         endif
      else
         write(fu6,606)
      endif
C
      return
600   Format(/,' Eigenvalues and eigenvectors of hessian')
601   Format(/,23x,'m=',i8,5i13)
602   Format(2x,'Eigenvalues (au)=',T26,6f13.6)
603   Format(2x,'Frequencies (cm^-1)=',T26,6f13.6)
604   Format(2x,'Eigenvectors=')
605   Format(20x,i5,6f13.6)
606   Format(/,' error in call to rsp, frequencies not calculated')
      end

      Subroutine hf1d(
     &       Axyz,Aprims,Acoefs,NPA,NCA,La,ictrA,
     &       Bxyz,Bprims,Bcoefs,NPB,NCB,Lb,ictrB,
     &       Cxyz,zan,exinv,ncenters,
     &       bO2I,bKEI,bNAI,Nint,
     &       O2I,KEI,NAI,canAB,dryrun,W0,maxW0)
c $Id: hf1d.F 19963 2011-02-17 00:39:03Z d3y133 $

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

#include "errquit.fh"

      Logical dryrun
      Logical O2I,KEI,NAI,canAB,GenCon

c--> Cartesian Coordinates, Primitives & Contraction Coefficients

      Dimension Axyz(3),Aprims(NPA),Acoefs(NPA,NCA)
      Dimension Bxyz(3),Bprims(NPB),Bcoefs(NPB,NCB)

c--> Nuclear Cartesian Coordinates, Charges & Inverse Exponents

      Dimension Cxyz(3,ncenters),zan(ncenters),exinv(ncenters)

c--> Blocks of Overlap, Kinetic Energy & Nuclear Attraction Integrals

      Dimension bO2I(Nint,*),bKEI(Nint,*),bNAI(Nint,*)

c--> Derivative Indices

      Dimension inder1(3,3),inder2(6,6)

c--> Scratch Space.

      Dimension W0(maxW0)

      Data inder1/ 1,0,0,
     &             0,1,0,
     &             0,0,1 /

      Data inder2/ 1,0,0,0,0,0,
     &             0,1,0,0,0,0,
     &             0,0,1,0,0,0,
     &             0,0,0,1,0,0,
     &             0,0,0,0,1,0,
     &             0,0,0,0,0,1 /
c
c Compute gradient of the overlap, kinetic energy, and nuclear attraction 
c integrals for 2 shells of contracted Gaussians functions.
c
c The derivative indices specify the order of differentiation for each 
c coordinate:
c
c      inder1(i,n), i=1-3:   d/dRx, d/dRy, d/dRz
c
c      inder2(i,n), i=1-3:   d/dPx, d/dPy, d/dPz
c                   i=4-6:   d/dRx, d/dRy, d/dRz
c
c******************************************************************************

#if defined(INTDEBUG)
      call hf_print_set(1)
      call hf_print('hf1d: a shell',axyz,aprims,acoefs,npa,nca,la)
      call hf_print('hf1d: b shell',bxyz,bprims,bcoefs,npb,ncb,lb)
      call hf_print_set(0)
#endif
      MXD = 1

c Determine whether general or segmented contraction is used.

      NCP = NCA*NCB

      GenCon = NCP.ne.1

      if( GenCon )then
        write(*,*) 'HF1D: Not yet ready for general contraction.'
        call errquit('HF1D: Not yet ready for general contraction.',
     &               0,UERR)
      end if

c To determine all the Hermite expansion coefficients required to evaluate
c the kinetic energy integrals, increment the angular momenta by one.

      if( KEI )then
       Li = 1
      else
       Li = 0
      end if

c Define the angular momentum of the overlap distribution.

      Lp = La + Lb

c Increment "Lp" to account for the order of differentiation.

      Lp = Lp + MXD

c Define the accumulated number of angular momentum functions <= Lp.

      Lp3 = ((Lp+1)*(Lp+2)*(Lp+3))/6

c Define the prefactor of the overlap distribution "P".

c Assign pointers to scratch space.
 
      i_ALPHAp = 1
      i_IPAIRp = i_ALPHAp + 2*(NPA*NPB)
      i_left   = i_IPAIRp + 2*(NPA*NPB) - 1
 
      i_ESp   = (maxW0+1) - 3*(NPA*NPB)
      i_right = i_ESp
 
      if( i_left.ge.i_right )then
 
       write(*,*) 'HF1D:  Insufficient scratch space.'
       write(*,*) '        needed    ',i_left + (maxW0-(i_right-1))
       write(*,*) '        allocated ',maxW0
 
       write(*,*) 'From the left '
       write(*,*) 'ALPHAp:  ',i_ALPHAp
       write(*,*) 'IPAIRp:  ',i_IPAIRp
       write(*,*) 'From the right '
       write(*,*) 'ESp   :  ',i_ESp
 
       call errquit('HF1D:  Insufficient scratch space.',i_right-i_left,
     &              UERR)
 
      end if
 
      MaxMem = 1    ! take care of compiler warnings
      if (dryrun) then
        MaxMem = i_left + (maxW0 - (i_right-1))
        NPP = NPA*NPB
      else
        call hfset(Axyz,Aprims,Acoefs,NPA,NCA,
     &         Bxyz,Bprims,Bcoefs,NPB,NCB,
     &         GenCon,W0(i_ALPHAp),W0(i_IPAIRp),W0(i_ESp),NPP)
      endif

c Define the Hermite linear expansion coefficients.

c Assign pointers to scratch space.

      lprod = ((La+Li)+(Lb+Li)+1)*((La+Li)+1)*((Lb+Li)+1)

      i_Ep   = i_IPAIRp + 2*(NPA*NPB)
      i_pf   = i_Ep     + 3*NPP*(MXD+1)*lprod
      i_left = i_pf     + 2*NPP - 1

      if( i_left.ge.i_right )then

       write(*,*) 'HF1D:  Insufficient scratch space.'
       write(*,*) '        needed    ',i_left + (maxW0-(i_right-1))
       write(*,*) '        allocated ',maxW0

       write(*,*) 'From the right '
       write(*,*) 'ALPHAp:  ',i_ALPHAp
       write(*,*) 'IPAIRp:  ',i_IPAIRp
       write(*,*) 'Ep    :  ',i_Ep
       write(*,*) 'pf    :  ',i_pf
       write(*,*) 'From the left '
       write(*,*) 'ESp   :  ',i_ESp

       call errquit('HF1D:  Insufficient scratch space.',i_right-i_left,
     &              UERR)

      end if

      if (dryrun) then
        MaxMem = max(MaxMem, (i_left+(maxW0-(i_right-1))))
      else
        do 100 nd = 0,MXD

          call hfmke(Axyz,Bxyz,W0(i_ALPHAp),W0(i_ESp),W0(i_Ep),
     &           W0(i_pf),nd,NPP,MXD,La+Li,Lb+Li)

100     continue
      endif

c Compute the 2-center overlap integrals, <a|S|b>.

      if( O2I.and.(.not.dryrun))then

       Nder = 3

       call hfd2oi(W0(i_Ep),bO2I,NPP,Nint,La,Lb,Li,MXD,inder1,Nder,
     &             canAB)

       do 200 n = 1,Nint
        bO2I(n,4) = -bO2I(n,1)
        bO2I(n,5) = -bO2I(n,2)
        bO2I(n,6) = -bO2I(n,3)
  200  continue

#if defined(INTDEBUG)
       write(6,*)' ints from hf1d '
       call output(bO2i,1,nint,1,6,nint,6,1)
#endif
      end if
       
c Compute kinetic energy integrals, <a|T|b>.

      if( KEI )then

c Assign pointers to scratch space.

       i_Ti  = i_Ep + 3*NPP*(MXD+1)*lprod
       i_top = i_Ti + NPP - 1

       if( i_top.gt.maxW0 )then

        write(*,*) 'HF1D:  Insufficient scratch space.'
        write(*,*) '        needed    ',i_top
        write(*,*) '        allocated ',maxW0

        write(*,*) 'ALPHAp:  ',i_ALPHAp 
        write(*,*) 'IPAIRp:  ',i_IPAIRp
        write(*,*) 'Ep    :  ',i_Ep
        write(*,*) 'Ti    :  ',i_Ti

        call errquit('HF1D:  Insufficient scratch space.',maxW0-i_top,
     &               UERR)

       end if

       if (dryrun) then
         MaxMem = max( MaxMem, i_top)
       else
         Nder = 3

         call hfdkei(W0(i_ALPHAp),W0(i_Ep),bKEI,W0(i_Ti),
     &          NPP,Nint,La,Lb,Li,MXD,inder1,Nder,canAB)

         do 300 n = 1,Nint
           bKEI(n,4) = -bKEI(n,1)
           bKEI(n,5) = -bKEI(n,2)
           bKEI(n,6) = -bKEI(n,3)
300      continue

       endif
      end if
       
c Compute nuclear attraction integrals, <a|V|b>.

      if( NAI )then

c Define the auxiliary function integrals.

c Assign scratch space.

       i_R0  = i_Ep  + 3*NPP*(MXD+1)*lprod
       i_IJK = i_R0  + NPP*Lp3
       i_R0C = i_IJK + (Lp+1)**3
       i_P   = i_R0C + NPP*Lp3*ncenters
       i_RS  = i_P   + NPP*3
       i_PC  = i_RS  + NPP
       i_ff  = i_PC  + NPP*3
       i_Rj  = i_ff  + NPP*2
       i_top = i_Rj  + NPP*(Lp+1)*Lp3 - 1

       if( i_top.gt.maxW0 )then

        write(*,*) 'HF1D:  Insufficient scratch space.'
        write(*,*) '        needed    ',i_top
        write(*,*) '        allocated ',maxW0

        write(*,*) 'ALPHAp:  ',i_ALPHAp 
        write(*,*) 'IPAIRp:  ',i_IPAIRp
        write(*,*) 'Ep    :  ',i_Ep
        write(*,*) 'R0    :  ',i_R0
        write(*,*) 'IJK   :  ',i_IJK
        write(*,*) 'R0C   :  ',i_R0C
        write(*,*) 'P     :  ',i_P
        write(*,*) 'RS    :  ',i_RS
        write(*,*) 'PC    :  ',i_PC
        write(*,*) 'ff    :  ',i_ff
        write(*,*) 'Rj    :  ',i_Rj

        call errquit('HF1D:  Insufficient scratch space.',maxW0-i_top,
     &               UERR)

       end if

       if (dryrun) then
         MaxMem = max(MaxMem, i_top)
       else
         call hf1mkr(Axyz,Bxyz,Cxyz,zan,exinv,ncenters,
     &          W0(i_ALPHAp),W0(i_P),W0(i_RS),W0(i_PC),W0(i_ff),
     &          W0(i_Rj),W0(i_R0),W0(i_R0C),W0(i_IJK),
     &          NPP,Lp,Lp3,.TRUE.)

c Compute the derivative wrt to each of the nuclear attraction centers.
c This accounts for the operator dependence on the the nuclear coordinates.

         call hfefi(W0(i_Ep),W0(i_R0C),W0(i_IJK),bNAI,
     &          NPP,Nint,La,Lb,Li,Lp,Lp3,ncenters,
     &          MXD,canAB,ictra,ictrb)

       endif
c Compute compute the derivative wrt to the centers of the Gaussian functions.

c Assign scratch space.

       i_VP  = i_IJK + (Lp+1)**3
       i_VR  = i_VP  + NPP*(Nint*3)
       i_VA  = i_VR  + NPP*(Nint*3)
       i_VB  = i_VA  + (Nint*3)
       i_ff  = i_VB  + (Nint*3)
       i_top = i_ff  + NPP*2 - 1

       if( i_top.gt.maxW0 )then

        write(*,*) 'HF1D:  Insufficient scratch space.'
        write(*,*) '        needed    ',i_top
        write(*,*) '        allocated ',maxW0

        write(*,*) 'ALPHAp:  ',i_ALPHAp 
        write(*,*) 'IPAIRp:  ',i_IPAIRp
        write(*,*) 'Ep    :  ',i_Ep
        write(*,*) 'R0    :  ',i_R0
        write(*,*) 'IJK   :  ',i_IJK
        write(*,*) 'VP    :  ',i_VP
        write(*,*) 'VR    :  ',i_VR
        write(*,*) 'VA    :  ',i_VA
        write(*,*) 'VB    :  ',i_VB
        write(*,*) 'ff    :  ',i_ff

        call errquit('HF1D:  Insufficient scratch space.',maxW0-i_top,
     &               UERR)

       end if

       if (dryrun) then
         MaxMem = max(MaxMem, i_top)
       else
c Compute the derivatives wrt to (P,R).

c Compute the derivatives of the primitive integrals.

         Nder = 6

         call hfdnai(W0(i_Ep),W0(i_R0),W0(i_IJK),W0(i_VP),
     &          NPP,Nint,La,Lb,Li,Lp,Lp3,ncenters,
     &          MXD,inder2,Nder,canAB)
         
c Transform to obtain derivatives wrt (A,B).
         
         call hf1PRtoAB(W0(i_VP),W0(i_VR),W0(i_VA),W0(i_VB),
     &          W0(i_ALPHAp),W0(i_IPAIRp),W0(i_ff),NPP,Nint*3,
     &          ictrA,ictrB)
         
c Combine the two components of the derivatives of NAIs.
c
c   (1) the derivative wrt to each of the nuclear attraction centers,
c   (2) the derivative wrt to the centers of the Gaussian functions.
         
         if( ictrA.eq.ictrB )then
           call daxpy(Nint*3,1.D0,W0(i_VA),1,bNAI(1,((ictrA-1)*3+1)),1)         
         else
           call daxpy(Nint*3,1.D0,W0(i_VA),1,bNAI(1,((ictrA-1)*3+1)),1)
           call daxpy(Nint*3,1.D0,W0(i_VB),1,bNAI(1,((ictrB-1)*3+1)),1)
         end if
         
       endif
      end if
      
c Return the maximum amount of scratch space required by a "dry run".

      if( DryRun ) maxW0 = MaxMem
c
      end

c
C> \brief Setup the COSMO cavity surface
C>
      subroutine hnd_cosset(rtdb,nat,c,radius)
      implicit none
c
c              ----- starting from -icosahedron- -----
c
c     pass, napex, nface, error =   0      12      20      20
c     pass, napex, nface, error =   1      42      80     100    0.4982
c     pass  napex, nface, error =   2     162     320     420    0.1848
c     pass  napex, nface, error =   3     642    1280    1700    0.0523
c     pass  napex, nface, error =   4    2562    5120    6820    0.0135
c     pass  napex, nface, error =   5   10242   20480   27300    0.0034
c
c              ----- starting from -octahedron-  -----
c
c     pass, napex, nface, error =   0       6       8       8
c     pass, napex, nface, error =   1      18      32      40    0.8075
c     pass  napex, nface, error =   2      66     128     168    0.4557
c     pass  napex, nface, error =   3     258     512     680    0.1619
c     pass  napex, nface, error =   4    1026    2048    2728    0.0451
c     pass  napex, nface, error =   5    4098    8192   10920    0.0116
c     pass  napex, nface, error =   6   16386   32768   43688    0.0029
c
#include "errquit.fh"
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "stdio.fh"
c
      integer rtdb                 !< [Input] The RTDB handle
      integer nat                  !< [Input] The number of atoms
      double precision c(3,nat)    !< [Input] The atomic coordinates
      double precision radius(nat) !< [Input] The atomic radii
c
      double precision dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      double precision adiag,dsurf,dvol,srfmol,volmol,ptspatm
      integer          lineq,minbem,maxbem,ificos,ifscrn
      common/hnd_cospar/dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      common/hnd_cosmod/lineq,minbem,maxbem,ificos,ifscrn
      common/hnd_cosdat/adiag,dsurf,dvol,srfmol,volmol,ptspatm
c
      integer   mxface, mxapex
      parameter (mxface=43688)
      parameter (mxapex=16386)
      logical     dbug, stat
      integer l_i10,  i10
      integer l_i20,  i20
      integer l_i30,  i30
      integer l_i40,  i40
      integer l_i50,  i50
      integer l_i60,  i60
      integer l_i70,  i70
      integer l_i80,  i80
      integer l_i90,  i90
      integer l_i100, i100
      integer l_i110, i110
      integer l_i120, i120
      integer l_i130, i130
      integer need
c
      dbug=.false.
      if(dbug.and.ga_nodeid().eq.0) then
         write(luout,9999)
      endif
c
      if(ificos.eq.0.and.maxbem.gt.6) then
         write(luout,*) '-maxbem- too large for parameters in -cosset-'
         call errquit('hnd_cosset, -maxbem- too large',911,0)
      elseif(ificos.ne.0.and.maxbem.gt.7) then
         write(luout,*) '-maxbem- too large for parameters in -cosset-'
         call errquit('hnd_cosset, -maxbem- too large',911,0)
      endif
c
c     ----- partition memory -----
c
      need = 6*nat + 7*mxface + 7*mxface*nat + 3*mxapex
c
c     ----- allocate memory block -----
c
c     if(.not.ma_push_get(mt_dbl,need,'mem init:cosmo:hnd_cosset:1',
c    &    i_init,init))
c    & call errquit('hnd_cosset, malloc of init  failed',911,MA_ERR)
c
      stat = .true.
      stat = stat.and.ma_push_get(mt_dbl,3*nat,"xyzatm",l_i10,i10)
      stat = stat.and.ma_push_get(mt_dbl,  nat,"ratm",l_i20,i20)
      stat = stat.and.ma_push_get(mt_int,  nat,"nspa",l_i30,i30)
      stat = stat.and.ma_push_get(mt_int,  nat,"nppa",l_i40,i40)
      stat = stat.and.ma_push_get(mt_int,3*mxface,"ijkfac",l_i50,i50)
      stat = stat.and.ma_push_get(mt_dbl,3*mxface,"xyzseg",l_i60,i60)
      stat = stat.and.ma_push_get(mt_int,  mxface,"ijkseg",l_i70,i70)
      stat = stat.and.ma_push_get(mt_log,  mxface*nat,"insseg",
     &                                                l_i80,i80)
      stat = stat.and.ma_push_get(mt_dbl,3*mxface*nat,"xyzspa",
     &                                                l_i90,i90)
      stat = stat.and.ma_push_get(mt_int,  mxface*nat,"ijkspa",
     &                                                l_i100,i100)
      stat = stat.and.ma_push_get(mt_int,  mxface*nat,"numpps",
     &                                                l_i110,i110)
      stat = stat.and.ma_push_get(mt_dbl,3*mxapex    ,"apex",
     &                                                l_i120,i120)
      stat = stat.and.ma_push_get(mt_dbl,  mxface*nat,"xyzff",
     &                                                l_i130,i130)
c     i10 =init                    ! xyzatm(3,nat)
c     i20 =i10 +3*nat              !   ratm(  nat)
c     i30 =i20 +  nat              !   nspa(  nat)
c     i40 =i30 +  nat              !   nppa(  nat)
c     i50 =i40 +  nat              ! ijkfac(3,mxface)
c     i60 =i50 +3*mxface             ! xyzseg(3,mxface)
c     i70 =i60 +3*mxface             ! ijkseg(  mxface)
c     i80 =i70 +  mxface             ! insseg(  mxface,nat)
c     i90 =i80 +  mxface*nat         ! xyzspa(3,mxface,nat)
c     i100=i90 +3*mxface*nat         ! ijkspa(  mxface,nat)
c     i110=i100+  mxface*nat         ! numpps(  mxface,nat)
c     i120=i110+  mxface*nat         ! apex(3,mxapex)
c
c     ----- get -cosmo- surface -----
c
      call hnd_cossrf(nat,c,radius,nat,mxface,mxapex,
     1                dbl_mb(i10),dbl_mb(i20),int_mb(i30),int_mb(i40),
     2                int_mb(i50),dbl_mb(i60),int_mb(i70),
     3                log_mb(i80),dbl_mb(i90),int_mb(i100),int_mb(i110),
     4                dbl_mb(i120),dbl_mb(i130),rtdb)
c
c     ----- release memory block -----
c
      if(.not.ma_chop_stack(l_i10)) call
     &  errquit('hnd_cosset, ma_pop_stack of init failed',911,MA_ERR)
c
      return
 9999 format(/,10x,15(1h-),
     1       /,10x,'-cosmo- surface',
     2       /,10x,15(1h-))
      end
c
C> \brief Generate the COSMO cavity surface
C>
      subroutine hnd_cossrf(nat,c,radius,mxatm,mxfac,mxapx,
     1                  xyzatm,ratm,nspa,nppa,
     2                  ijkfac,xyzseg,ijkseg,insseg,
     3                  xyzspa,ijkspa,numpps,apex,xyzff,rtdb)
      implicit none
c
#include "nwc_const.fh"
#include "rtdb.fh"
#include "global.fh"
#include "stdio.fh"
c
      integer rtdb, nat
      integer mxatm
      integer mxfac
      integer mxapx
      double precision      c(3,nat  )
      double precision radius(    nat)
      double precision xyzatm(3,mxatm)
      double precision   ratm(  mxatm)
      integer            nspa(  mxatm)
      integer            nppa(  mxatm)
      integer          ijkfac(3,mxfac)
      double precision xyzseg(3,mxfac)
      integer          ijkseg(  mxfac)
      logical          insseg(  mxfac,mxatm)
      double precision xyzspa(3,mxfac,mxatm)
      integer          ijkspa(  mxfac,mxatm)
      integer          numpps(  mxfac,mxatm)
      double precision   apex(3,mxapx)
      double precision  xyzff(  mxfac,mxatm)
c
      double precision bohr
      parameter (bohr=0.529177249d+00)
      logical    some
      logical    out
      logical    more
      logical    dbug
      double precision dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      double precision adiag,dsurf,dvol,srfmol,volmol,ptspatm
      integer          lineq,minbem,maxbem,ificos,ifscrn
      common/hnd_cospar/dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      common/hnd_cosmod/lineq,minbem,maxbem,ificos,ifscrn
      common/hnd_cosdat/adiag,dsurf,dvol,srfmol,volmol,ptspatm
c
      integer i, iat, lfac, lseg, ndiv, nfac, nseg
      integer mfac
c
      dbug=.false.
      more=.false.
      more=more.or.dbug
      out =.false. 
      out =out.or.more
      some=.false.
      some=some.or.out
c
c     ----- approximate sphere with segments and points -----
c
      do iat = 1, mxatm
        nspa(iat) = 0
        nppa(iat) = 0
      enddo
      nseg = 0
      nfac = 0
      ndiv = 0
      call hnd_cossph(nseg,nfac,ndiv,
     1                ijkfac,xyzseg,ijkseg,mxfac,apex,mxapx,
     2                dsurf,dvol,adiag)
      ptspatm = dble(nseg)
c
c     ----- debug printing -----
c
      if(out.and.ga_nodeid().eq.0) then
         write(luout,9999) nseg,nfac,ndiv,dsurf,dvol
         write(luout,9995) adiag
         if(more) then
            write(luout,9998)
            do lseg=1,nseg
               write(luout,9997) lseg,xyzseg(1,lseg),xyzseg(2,lseg),
     1                             xyzseg(3,lseg),ijkseg(  lseg)
            enddo
         endif
         if(dbug) then
            write(luout,9996)
            do lfac=1,nfac
               mfac=lfac+nseg
               write(luout,9997) mfac,xyzseg(1,mfac),xyzseg(2,mfac),
     1                             xyzseg(3,mfac),ijkseg(  mfac)
            enddo
         endif
      endif
c
c     ----- set molecule -----
c
      do iat=1,nat
         do i=1,3
            xyzatm(i,iat)=c(i,iat)
         enddo
      enddo
      do iat=1,nat
         if(radius(iat).eq.0.0d0) then
            ratm(iat)=0.0d0
         else
            ratm(iat)=radius(iat)/bohr
         endif
      enddo
c
c     ----- create -solvent accessible surface- of the molecule -----
c
      call hnd_cossas(nat,xyzatm,ratm,mxatm,
     1                nspa,nppa,xyzspa,ijkspa,
     2                nseg,nfac,xyzseg,ijkseg,insseg,
     3                numpps,xyzff,mxfac,rtdb)
c
      return
 9999 format(' nseg,nfac,ndiv=nfac/nseg,dsurf,dvol = ',3i7,2f10.6)
 9998 format('  seg  ','      x     ','      y     ','      z     ',
     1       ' seg ',/,1x,47(1h-))
 9997 format(i7,3f12.8,i5,f12.8)
 9996 format('  fac  ','      x     ','      y     ','      z     ',
     1       ' seg ',/,1x,47(1h-))
 9995 format(' adiag           = ',f12.6)
      end
C>
C> \brief Construct the Solvent Accessible Surface (SAS) from the
C> triangulated spheres
C>
C> ## The legacy of Klamt and Sch&uuml;&uuml;rmann ##
C>
C> This subroutine was originally written to implement the algorithm
C> to construct the Solvent Accessible Surface as proposed by 
C> Klamt and Sch&uuml;&uuml;rmann [1]. This algorithm worked as follows:
C>
C> If two spheres partially overlap then parts of the surface need
C> to be eliminated. Segments that are contained entirely within the
C> sphere of another atom will be eliminated completely. Segments
C> that straddle the boundary between two spheres will have their
C> surface reduced proportional to the fraction that resides within the
C> sphere of the other atom. This fraction is established by counting
C> the number of faces that fall within the sphere of the other atom. 
C> In addition the location of the charge representing a segment should
C> be calculated as the center of the remaining points representing the
C> faces (see [1] page 802, 2nd column, 2nd paragraph), but currently
C> that is not done.
C>
C> To understand the approach suggested above it is important to know
C> the concepts "segments" and "faces". 
C> - "Segments" are parts of the surface of the sphere that will be
C>   represented by a single COSMO charge.
C> - "Faces" are further refinements of segments. I.e. segments have
C>   been partitioned into a number of faces. The faces are used to
C>   eliminate parts of a segment that are within the sphere of another
C>   atom. By counting the remaining faces the surface area of a segment
C>   can be adjusted.
C> The trick with segments and faces is needed to create a smoother
C> boundary between neighboring spheres without introducing large 
C> numbers of COSMO charges. The smooth boundary is needed to keep
C> discretization errors small, whereas "small" numbers of COSMO charges
C> are needed to keep the cost of calculating the COSMO charges low.
C>
C> The segments have been generated in `hnd_cossph` by partitioning the
C> triangles of the original polyhedron `minbem` times. The faces have
C> generated by partitioning the segments an additional `maxbem-minbem`
C> times.
C>
C> ## The new smooth approach of York and Karplus ##
C>
C> The approach by Klamt and Sch&uuml;&uuml;rmann [1] led to problems
C> because the corresponding potential energy surface was not 
C> continuous. York and Karplus [2] proposed a method that provides
C> a smooth potential energy surface and this subroutine was changed
C> to implement this new approach. This meant that some things stayed
C> the same as before (for example minbem still works the same way
C> to generate the surface charge positions), other things changed
C> significantly (maxbem and rsolve are now entirely obsolete and not
C> used anymore, also the elimination of point charges is no longer
C> based on reducing the segment surface area until it vanishes, instead
C> the surface charge of a segment is quenched with a switching function
C> to eliminate the contribution of a surface point).
C>
C> ### References ###
C>
C> [1] A. Klamt, G. Sch&uuml;&uuml;rmann,
C>     "COSMO: a new approach to dielectric screening in solvents with
C>      explicit expressions for the screening energy and its gradient",
C>     <i>J. Chem. Soc., Perkin Trans. 2</i>, 1993, pp 799-805, DOI:
C>     <a href="http://dx.doi.org/10.1039/P29930000799">
C>     10.1039/P29930000799</a>.
C>
C> [2] D.M. York, M. Karplus,
C>     "A smooth solvation potential based on the conductor-like
C>      screening model", <i>J. Phys. Chem. A</i> (1999) <b>103</b>,
C>     pp 11060-11079, DOI:
C>     <a href="http://dx.doi.org/10.1021/jp992097l">
C>     10.1021/jp992097l</a>.
C>
      subroutine hnd_cossas(nat,xyzatm,ratm,mxatom,
     1                      nspa,nppa,xyzspa,ijkspa,
     2                      nseg,nfac,xyzseg,ijkseg,insseg,
     3                      numpps,xyzff,mxface,rtdb)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "stdio.fh"
#include "bq.fh"
#include "prop.fh"
c
      integer rtdb    !< [Input] The RTDB handle
      integer nat     !< [Input] The actual number of atoms
      integer mxface  !< [Input] The maximum number of faces
      integer mxatom  !< [Input] The maximum number of atoms
      integer nseg    !< [Input] The actual number of segments
      integer nfac    !< [Input] The actual number of faces
c
      double precision bohr
      parameter  (bohr=0.529177249d+00)
      logical     dbug
      double precision dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      double precision adiag,dsurf,dvol,srfmol,volmol,ptspatm
      integer lineq,minbem,maxbem,ificos,ifscrn
      common/hnd_cospar/dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      common/hnd_cosmod/lineq,minbem,maxbem,ificos,ifscrn
      common/hnd_cosdat/adiag,dsurf,dvol,srfmol,volmol,ptspatm
      double precision xyzatm(3,mxatom) !< [Input] The atom positions
      double precision   ratm(  mxatom) !< [Input] The atom radii
      integer            nspa(  mxatom) !< [Output] The number of
                                        !< segments remaining for
                                        !< each atom
      integer            nppa(  mxatom) !< [Output] The number of faces
                                        !< remaining for each atom
      double precision xyzseg(3,mxface) !< [Input] The coordinates of 
                                        !< the segment and face points
                                        !< on the unit sphere
      integer          ijkseg(  mxface) !< [Input] List for every
                                        !< face what the corresponding
                                        !< segment is, if ijkseg(ii) is
                                        !< 0 then face ii should be 
                                        !< ignored (has been eliminated)
      logical          insseg(  mxface,mxatom) !< [Output] If .false.
                                               !< keep the segment or
                                               !< face, discard it
                                               !< otherwise
      double precision xyzspa(3,mxface,mxatom)
      integer          ijkspa(  mxface,mxatom)
      integer          numpps(  mxface,mxatom)
      double precision  xyzff(  mxface,mxatom)
      double precision zero, one
      data zero    /0.0d+00/
      data one     /1.0d+00/
      integer l_efcc, k_efcc, l_efcs, k_efcs, l_efcz, k_efcz
      integer l_efclb, k_efclb, k_efciat, l_efciat
      double precision ratm_real,dij,dum,cavdsp,pi,zetai,zetaii
      integer m,mfac,mseg
      integer nefc,iat,jat,npp,i,iseg,ifac,ief,ipp
c
      double precision cosff
      external         cosff
c
c     MN solvation models -->
c
      logical do_cosmo_smd
c
c     <-- MN solvation models
c
      double precision dist, xi, yi, zi, xj, yj, zj, rin, rout, alphai
      parameter (alphai = 0.5d0)
      dist(xi,yi,zi,xj,yj,zj)=sqrt((xj-xi)**2+(yj-yi)**2+(zj-zi)**2)
      rin(iat)=ratm(iat)*(1.0d0-alphai*gammas*sqrt(0.25d0**minbem))
      rout(iat)=ratm(iat)*(1.0d0+(1.0d0-alphai)*gammas*
     &                     sqrt(0.25d0**minbem))
c
      dbug=.false.
      pi = acos(-1.0d0)
c
      if(ga_nodeid().eq.0) then
         write(luout,9999)
      endif
c
c     ----- print atomic centers -----
c
      if(ga_nodeid().eq.0) then
         write(luout,9998)
         do iat=1,nat
            write(luout,9997) iat,xyzatm(1,iat),xyzatm(2,iat),
     1                                       xyzatm(3,iat),
     2                    (ratm(iat)*bohr)
         enddo
      endif
c
c     ----- clear arrays ..... -----
c
      do iat=1,nat
         do i=1,mxface
            ijkspa(i,iat)=0
            numpps(i,iat)=0
            xyzff(i,iat)=zero
         enddo
      enddo
c
c     ----- sift through atomic centers and decide if a face -----
c           belongs to the -sas- or is inside the molecule.
c
      do iat=1,nat
c
         if(ratm(iat).ne.zero) then
            do iseg=1,nseg
               ijkspa(iseg,iat)=ijkseg(iseg)
               xyzff(iseg,iat)=one
               do m=1,3
                  xyzspa(m,iseg,iat)=xyzseg(m,iseg)*ratm(iat)
     1                              +xyzatm(m,iat)
               enddo
            enddo
            do ifac=1,nfac
               ijkspa(ifac+nseg,iat)=ijkseg(ifac+nseg)
               do m=1,3
                  xyzspa(m,ifac+nseg,iat)=xyzseg(m,ifac+nseg)*ratm(iat)
     1                                   +xyzatm(m,iat)
               enddo
            enddo
            if(dbug.and.ga_nodeid().eq.0) then
               write(luout,9996) iat
               write(luout,9995) (ijkspa(ifac+nseg,iat),ifac=1,nfac)
            endif
            do jat=1,nat
               dij=dist(xyzatm(1,iat),
     1                  xyzatm(2,iat),
     2                  xyzatm(3,iat),
     3                  xyzatm(1,jat),
     4                  xyzatm(2,jat),
     5                  xyzatm(3,jat))
               if((jat.ne.iat).and.(ratm(jat).ne.zero)
     1                        .and.(dij.lt.(ratm(iat)+rout(jat)))) then
                  do iseg=1,nseg
                     dum=dist(xyzspa(1,iseg,iat),
     1                        xyzspa(2,iseg,iat),
     2                        xyzspa(3,iseg,iat),
     3                        xyzatm(1,jat),
     4                        xyzatm(2,jat),
     5                        xyzatm(3,jat))
                     xyzff(iseg,iat) = xyzff(iseg,iat) *
     1                 cosff((dum-rin(jat))/(rout(jat)-rin(jat)))
                  enddo
               endif
            enddo
            if(dbug.and.ga_nodeid().eq.0) then
               write(luout,9996) iat
               write(luout,9995) (ijkspa(ifac+nseg,iat),ifac=1,nfac)
            endif
c
c     ----- check segments belonging to -sas- -----
c
            do iseg=1,nseg
               insseg(iseg,iat)=.not.(xyzff(iseg,iat).ge.swtol)
            enddo
            if(dbug.and.ga_nodeid().eq.0) then
               write(luout,9994) iat
               write(luout,9993) (insseg(iseg,iat),iseg=1,nseg)
            endif
            mseg=0
            do iseg=1,nseg
               if(.not.insseg(iseg,iat)) mseg=mseg+1
            enddo
            mfac=0
            nspa(iat)=mseg
            nppa(iat)=mfac
c
         endif
c
      enddo
c
      if(ga_nodeid().eq.0) then
         write(luout,9985) nseg,nfac
         write(luout,9992)
         do iat=1,nat
            npp=0
            do iseg=1,nseg
               npp=npp+numpps(iseg,iat)
            enddo
            write(luout,9991) iat,nspa(iat),nppa(iat),npp
         enddo
      endif
      if(dbug.and.ga_nodeid().eq.0) then
         write(luout,9987)
         do iat=1,nat
            do iseg=1,nseg
               write(luout,9986) iat,iseg,numpps(iseg,iat)
            enddo
         enddo
      endif
c
c    Count the number of surface points, i.e. number of point charges
c    and generate memory to store them
c
      nefc = 0
      do iat=1,nat
         if(ratm(iat).ne.zero) then
            do iseg=1,nseg
               if(.not.insseg(iseg,iat)) nefc = nefc+1
            enddo
         endif
      enddo
c
c     Allocate memory for point charges
c
      if(.not.ma_push_get(mt_dbl,nefc*3,'cosmo efcc',l_efcc,k_efcc))
     & call errquit('cosmo_cossas malloc k_efcc failed',911,MA_ERR)
      if(.not.ma_push_get(mt_dbl,nefc,'cosmo efcs',l_efcs,k_efcs))
     & call errquit('cosmo_cossas malloc k_efcs failed',911,MA_ERR)
      if(.not.ma_push_get(mt_int,nefc,'cosmo efciat',l_efciat,k_efciat))
     & call errquit('cosmo_cossas malloc k_efciat failed',911,MA_ERR)
      if(.not.ma_push_get(mt_dbl,nefc,'cosmo efcz',l_efcz,k_efcz))
     & call errquit('cosmo_cossas malloc k_efcz failed',911,MA_ERR)
      if(.not.ma_push_get(mt_byte,nefc*8,'cosmo tags',l_efclb,k_efclb))
     & call errquit('cosmo_cossas malloc k_tag failed',911,MA_ERR)
c
c     ----- save coordinates of surface points -----
c           save segment surfaces
c           save segment to atom mapping
c
      srfmol=zero
      volmol=zero
      ief   =0
      do iat=1,nat
         if(ratm(iat).ne.zero) then
            ratm_real=ratm(iat)
            do iseg=1,nseg
               if(.not.insseg(iseg,iat)) then
                  ief=ief+1
                  do i=1,3
                     dbl_mb(k_efcc+3*(ief-1)+i-1)=xyzatm(i,iat)
     1                          +xyzseg(i,iseg)*ratm_real
                  enddo
c
c                 --- eval eq.(67) from [2] ---
c
                  ipp=numpps(iseg,iat)
                  dum=4.00d0**(maxbem-minbem)
                  dum=16.0d0 ! MAXBEM is obsolete in York and Karplus approach
                  zetai=zeta*sqrt(nseg*dum)/(ratm_real*sqrt(2.0d0*pi))
                  zetaii=zetai/sqrt(2.0d0)
                  dbl_mb(k_efcs+ief-1) = (1.0d0/xyzff(iseg,iat))
     1                                 * 2.0d0*zetaii/sqrt(pi)
                  srfmol   = srfmol + xyzff(iseg,iat)*dsurf*ratm_real**2
                  volmol   = volmol + xyzff(iseg,iat)*dvol *ratm_real**3
                  int_mb(k_efciat+ief-1)=iat
               endif
            enddo
         endif
      enddo
      srfmol=srfmol*(bohr**2)
      volmol=volmol*(bohr**3)
c
      if(ga_nodeid().eq.0) then
         write(luout,9990) nefc
         write(luout,9984) srfmol 
         write(luout,9983) volmol 
      endif 
c
c     ----- Cavity/Dispersion free energy ---
c           Sitkoff, Sharp, and Honig,
c           J.Phys.Chem. 98, 1978 (1994)
c
      cavdsp=0.860+0.005*srfmol
c
c MN solvation models -->
c
c      if(ga_nodeid().eq.0) then
c         write(luout,9981) cavdsp
c      endif
      if (.not.
     $ rtdb_get(rtdb,'cosmo:do_cosmo_smd',mt_log,1,do_cosmo_smd))
     $ call errquit('hnd_cossas: cannot get do_cosmo_smd from rtdb',
     $ 0,rtdb_err)
      if(ga_nodeid().eq.0) then
       if (.not.do_cosmo_smd) write(luout,9981) cavdsp
      endif
c
c <-- MN solvation models
c
c     ----- print segment surfaces -----
c
      if(dbug.and.ga_nodeid().eq.0) then
         write(luout,9989)
         do ief=1,nefc
            write(luout,9988) ief,dbl_mb(k_efcs+ief-1),
     &                        int_mb(k_efciat+ief-1)
         enddo
      endif
c
      do ief=1,nefc
         dbl_mb(k_efcz+ief-1)=zero
      enddo
      do ief=1,nefc
         byte_mb(k_efclb+(ief-1)*8)='        '
      enddo
c
c     ----- write out to -rtdb- -----
c
      if(.not.rtdb_put(rtdb,'cosmo:nefc',mt_int,1     ,nefc))
     $   call errquit('hnd_cossas: rtdb put failed for nefc  ',911,
     &       rtdb_err)
      if(.not.rtdb_put(rtdb,'cosmo:efcc',mt_dbl,3*nefc,dbl_mb(k_efcc)))
     $   call errquit('hnd_cossas: rtdb put failed for efcc  ',912,
     &       rtdb_err)
      if(.not.rtdb_put(rtdb,'cosmo:efcz',mt_dbl,  nefc,dbl_mb(k_efcz)))
     $   call errquit('hnd_cossas: rtdb put failed for efcz  ',913,
     &       rtdb_err)
      if(.not.rtdb_put(rtdb,'cosmo:efcs',mt_dbl,  nefc,dbl_mb(k_efcs)))
     $   call errquit('hnd_cossas: rtdb put failed for efcs  ',914,
     &       rtdb_err)
c
c     ----- reset cosmo:rawt to avoid trouble in cosmo charge 
c           calculation -----
c
      if(.not.rtdb_put(rtdb,'cosmo:rawt',mt_dbl,  nefc,dbl_mb(k_efcz)))
     $   call errquit('hnd_cossas: rtdb put failed for rawt  ',915,
     &       rtdb_err)
c
c     We will need the next bit of information to calculate the analytic
c     COSMO gradients. This table describes the relationship between
c     the COSMO charges and the associated atoms. So we better save this
c     info.
c
      if(.not.rtdb_put(rtdb,'cosmo:efciat',mt_int,nefc,
     $                 int_mb(k_efciat)))
     $   call errquit('hnd_cossas: rtdb put failed for iatefc',916,
     &       rtdb_err)
c     if(.not.rtdb_cput(rtdb,'char variable',nefc,byte_mb(k_efclb)))
c    $   call errquit('hnd_cossas: rtdb put failed for efclab',917,
c    &       rtdb_err)
c
      if(.not.ma_pop_stack(l_efclb)) call
     &   errquit('cosmo_cossas chop stack k_efclb failed',911,MA_ERR)
      if(.not.ma_pop_stack(l_efcz)) call
     &   errquit('cosmo_cossas chop stack k_efcz failed',911,MA_ERR)
      if(.not.ma_pop_stack(l_efciat)) call
     &   errquit('cosmo_cossas chop stack k_efciat failed',911,MA_ERR)
      if(.not.ma_pop_stack(l_efcs)) call
     &   errquit('cosmo_cossas chop stack k_efcs failed',911,MA_ERR)
      if(.not.ma_pop_stack(l_efcc)) call
     &   errquit('cosmo_cossas chop stack k_efcc failed',911,MA_ERR)
c
      return
 9999 format(/,1x,'solvent accessible surface',/,1x,26(1h-))
 9998 format(/,1x,'---------- ATOMIC COORDINATES (A.U.) ----------',
     1            '-- VDWR(ANG.) --')
 9997 format(  1x,i5,3f14.8,f10.3)
 9996 format(/,1x,'---------- SEGMENTS FOR -IAT- = ',i5)
 9995 format(16i4)
 9994 format(/,1x,'-INSSEG- FACES FOR IAT = ',i5)
 9993 format(16l4)
 9992 format(  1x,'atom',' ( ','  nspa',',','  nppa',' )',/,1x,22(1h-))
 9991 format(  1x,   i4 ,' ( ',     i6 ,',',     i6 ,' )',i8)
 9990 format(  1x,'number of -cosmo- surface points = ',i8)
 9989 format(  1x,'SEGMENT SURFACES =',/,1x,18(1h-))
 9988 format(i8,f10.5,i5)
 9987 format(  1x,'NUMBER OF FACES / SEGMENT =',/,1x,27(1h-))
 9986 format(3i5)
 9985 format(' number of segments per atom = ',i10,/,
     1       ' number of   points per atom = ',i10)
 9984 format(' molecular surface = ',f10.3,' angstrom**2')
 9983 format(' molecular volume  = ',f10.3,' angstrom**3')
 9981 format(' G(cav/disp)       = ',f10.3,' kcal/mol')
      end
c
C> \brief Triangulate a sphere using the Boundary Element Method (BEM)
C>
C> This routine approximates a sphere starting from either an
C> octahedron or an icosahedron and partitioning the triangles that
C> make up these polyhedra. Each triangle is partitioned into four
C> triangles at each level in the recursion. The procedure is starting
C> from an equal sided triangle, select the midpoints of all three
C> sides, and draw a triangle through the three midpoints. This way four
C> triangles of equal size are obtained. However, the midpoints of the
C> original sides do not lie on the surface of the sphere and therefore
C> they need to be projected outwards. This outwards projection changes
C> the size of the central triangle more than that of the other three.
C> So in the final triangulation the triangles are not all of the same
C> size, but this is ignored in the COSMO formalism.
C>
C> Ultimately we are interested only in the triangles at 2 levels of
C> granularity:
C>
C> - minbem: these triangles are referred to as "segments" and
C>   represent the sphere and their centers become the positions for
C>   the COSMO charges.
C>
C> - maxbem: these triangles are referred to as "faces" and they are 
C>   used to adjust the surface of the segments in regions where two
C>   atomic spheres meet and the segments straddle the boundary between
C>   both spheres.
C>
C> All other triangles are reduced to mere artefacts of the triangle
C> generation algorithm. The array `ijkseg` administrates what the 
C> status of a triangle is. It lists for each face which segment it is
C> part of.
C>
C> In addition this routine computes `adiag` of [1] Eq.(B1). The 
C> expression in this routine can be obtained from Eq.(B1) as
C> \f{eqnarray*}{
C>   \frac{1}{2R}
C>   &=&\frac{M}{2}\sum_{\nu=2}^M\frac{M^{-2}}{||t_1-t_\nu||}
C>    + MM^{-2}\frac{a_{\mathrm{diag}}}{2} \\\\
C>   \frac{a_{\mathrm{diag}}}{M}
C>   &=&\frac{1}{R}-\sum_{\nu=2}^M\frac{M^{-1}}{||t_1-t_\nu||} \\\\
C>   a_{\mathrm{diag}}
C>   &=&\frac{M}{R}-\sum_{\nu=2}^M\frac{1}{||t_1-t_\nu||}
C> \f}
C> The expression implemented in this routine can be mapped onto this
C> by
C> \f{eqnarray*}{
C>   a_{\mathrm{diag}}' &=& \left(\frac{4\pi}{M}\right)^{1/2}
C>         \left(M-\sum_{\nu=2}\frac{1}{||t_1'-t_\nu'||}\right)
C> \f}
C> where \f$a_{\mathrm{diag}}'\f$ is `adiag` as calculated in this
C> routine, the \f$t'\f$ are points in the unit sphere (as opposed to
C> \f$t\f$ which are points on the sphere with radius \f$R\f$).
C> In the routines `hnd_coschg`, `hnd_cosaxd` and `hnd_cosxad` this is
C> multiplied with 
C> \f$|S_\mu|^{-1/2} = \left(\frac{4\pi R^2}{M}\right)^{-1/2}\f$ to give
C> the proper \f$a_{\mathrm{diag}}\f$
C> \f{eqnarray*}{
C>   a_{\mathrm{diag}} &=& \left(\frac{4\pi}{M}\right)^{1/2}
C>         \left(M-\sum_{\nu=2}\frac{1}{||t_1'-t_\nu'||}\right)
C>         \left(\frac{M}{4\pi R^2}\right)^{1/2} \\\\
C>   &=& \frac{1}{R}
C>       \left(M-\sum_{\nu=2}\frac{1}{||t_1'-t_\nu'||}\right) \\\\
C>   &=& \left(\frac{M}{R}-\sum_{\nu=2}\frac{1}{||t_1-t_\nu||}\right)
C> \f}
C> In ref.[1] Eq.(B2) is wrong because of a spurious scale factor
C> \f$4\pi R^2/M\f$.
C>
C> ### References ###
C>
C> [1] A. Klamt, G. Sch&uuml;&uuml;rmann,
C>     "COSMO: a new approach to dielectric screening in solvents with
C>      explicit expressions for the screening energy and its gradient",
C>     <i>J. Chem. Soc., Perkin Trans. 2</i>, 1993, pp 799-805, DOI:
C>     <a href="http://dx.doi.org/10.1039/P29930000799">
C>     10.1039/P29930000799</a>.
C>
      subroutine hnd_cossph(nseg,nfac,ndiv,
     1                  ijkfac,xyzseg,ijkseg,mxface,apex,mxapex,
     2                  dsurf,dvol,adiag)
      implicit double precision (a-h,o-z)
#include "global.fh"
#include "stdio.fh"
c
c              ----- starting from -icosahedron- -----
c
c     pass, napex, nface, error =   0      12      20      20
c     pass, napex, nface, error =   1      42      80     100    0.4982
c     pass  napex, nface, error =   2     162     320     420    0.1848
c     pass  napex, nface, error =   3     642    1280    1700    0.0523
c     pass  napex, nface, error =   4    2562    5120    6820    0.0135
c     pass  napex, nface, error =   5   10242   20480   27300    0.0034
c
c              ----- starting from -octahedron-  -----
c
c     pass, napex, nface, error =   0       6       8       8
c     pass, napex, nface, error =   1      18      32      40    0.8075
c     pass  napex, nface, error =   2      66     128     168    0.4557
c     pass  napex, nface, error =   3     258     512     680    0.1619
c     pass  napex, nface, error =   4    1026    2048    2728    0.0451
c     pass  napex, nface, error =   5    4098    8192   10920    0.0116
c     pass  napex, nface, error =   6   16386   32768   43688    0.0029
c
      dimension   apex(3,*)
      dimension ijkfac(3,*)
      dimension ijkseg(  *)
      dimension xyzseg(3,*)
c
      common/hnd_cospar/dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      common/hnd_cosmod/lineq,minbem,maxbem,ificos,ifscrn
c
      parameter (mxpass=    7)
      dimension minfac(mxpass)
      dimension maxfac(mxpass)
      dimension minico(mxpass)
      dimension maxico(mxpass)
      dimension minoct(mxpass)
      dimension maxoct(mxpass)
      dimension ijknew(3)
      dimension ijkold(3)
      equivalence (ijkold(1),iold),(ijkold(2),jold),(ijkold(3),kold)
      equivalence (ijknew(1),inew),(ijknew(2),jnew),(ijknew(3),knew)
      logical icos
      logical octa
      logical some,out,dbug
      data minico /    1,   21,  101,  421, 1701, 6821,    0/
      data maxico /   20,  100,  420, 1700, 6820,27300,    0/
      data minoct /    1,    9,   41,  169,  681, 2729,10921/
      data maxoct /    8,   40,  168,  680, 2728,10920,43688/
      data zero  /0.0d+00/
      data one   /1.0d+00/
      data two   /2.0d+00/
      data three /3.0d+00/
      data four  /4.0d+00/
c
      dist(xi,yi,zi,xj,yj,zj)=sqrt((xj-xi)**2+(yj-yi)**2+(zj-zi)**2)
c
      dbug=.false.
      out =.false.
      out =out.or.dbug
      some=.false.
      some=some.or.out
c
      pi=four*atan(one)
      rad=one
      cir= two*pi*rad
      srf=four*pi*rad**2
      vol=four*pi*rad**3/three
c
      npass=maxbem
c
c     ----- define  hedron  -----
c           define -minfac- 
c           define -maxfac- 
c
      icos=ificos.ne.0
      octa=.not.icos
      if(icos) then
         call hnd_sphico(apex,napex,ijkfac,ijkseg,nface)
         do ipass=1,mxpass
            minfac(ipass)=minico(ipass)
            maxfac(ipass)=maxico(ipass)
         enddo
      endif
      if(octa) then
         call hnd_sphoct(apex,napex,ijkfac,ijkseg,nface)
         do ipass=1,mxpass
            minfac(ipass)=minoct(ipass)
            maxfac(ipass)=maxoct(ipass)
         enddo
      endif
      if(some.or.out.or.dbug.and.ga_nodeid().eq.0) then
         if(icos) then
            write(luout,9994)
         endif
         if(octa) then
            write(luout,9982)
         endif
         if(out) then
            write(luout,*) '-minbem- = ',minbem
            write(luout,*) '-maxbem- = ',maxbem
            write(luout,*) '-minfac- = ',minfac
            write(luout,*) '-maxfac- = ',maxfac
            write(luout,*) '-npass - = ',npass
            write(luout,9999)
            do iapex=1,napex
               write(luout,9998) iapex,apex(1,iapex),
     1                              apex(2,iapex),
     2                              apex(3,iapex)
            enddo
         endif
      endif
c
c     ----- loop over divisions to create sphere -----
c
      mxfac=0
      ipass=1
  100 ipass=ipass+1
         mnfac=mxfac+1
         mxfac=nface
         if(out.and.ga_nodeid().eq.0) then
            write(luout,9996) ipass,napex,nface,mnfac,mxfac
         endif
c
         dmin =one
         mapex=napex
         mface=nface
         do lface=mnfac,mxfac
            iold=ijkfac(1,lface)
            jold=ijkfac(2,lface)
            kold=ijkfac(3,lface)
            call hnd_sphapx(apex,mapex,ijkfac,ijkseg,mface,lface,
     1                      ijkold,ijknew,dijk)
            dmin=min(dmin,dijk)
         enddo
         napex=mapex
         nface=mface
         if(out.and.ga_nodeid().eq.0) then
            write(luout,9995) napex,nface
         endif
c
c     ----- print out new apeces -----
c
         if(dbug.and.ga_nodeid().eq.0) then
            do iapex=1,napex
               write(luout,9998) iapex,apex(1,iapex),apex(2,iapex),
     1                              apex(3,iapex)
            enddo
         endif
c
c     ----- print approximate volume -----
c
         radapp=    dmin
         radrat=    dmin
         raderr=one-radrat
         srfapp=srf*dmin**2
         srfrat=    dmin**2
         srferr=one-srfrat
         volapp=vol*dmin**3
         volrat=    dmin**3
         volerr=one-volrat
         if(out.and.ga_nodeid().eq.0) then
            write(luout,9997) vol,volapp,volrat,volerr
            write(luout,9992) srf,srfapp,srfrat,srferr
            write(luout,9991) rad,radapp,radrat,raderr
         endif
c
c     ----- assign early segment to each face -----
c
         if(ipass.gt.(minbem+1)) then
            if(dbug.and.ga_nodeid().eq.0) then
               write(luout,9981) ipass
               write(luout,9980) (minfac(i),i=1,ipass)
               write(luout,9979) (maxfac(i),i=1,ipass)
            endif
            maxseg=maxfac(minbem)
            lfacmn=minfac(ipass)
            lfacmx=maxfac(ipass)
            if(dbug.and.ga_nodeid().eq.0) then
               write(luout,9990) ipass
               write(luout,9988) (ijkseg(lface),lface=lfacmn,lfacmx)
            endif
            do lface=lfacmn,lfacmx
               ijkseg(lface)=ijkseg(ijkseg(lface))
               if(ijkseg(lface).gt.maxseg.and.ga_nodeid().eq.0) then
                  write(luout,9987) lface,ijkseg(lface)
               endif
            enddo
            if(dbug.and.ga_nodeid().eq.0) then
               write(luout,9989) ipass
               write(luout,9988) (ijkseg(lface),lface=lfacmn,lfacmx)
            endif
         endif
c
      if(ipass.lt.npass) go to 100
c
c     ----- end of loop over tessalating passes -----
c
      if(dbug.and.ga_nodeid().eq.0) then
         do ipass=1,npass
            lfacmn=minfac(ipass)
            lfacmx=maxfac(ipass)
            write(luout,9989) ipass
            write(luout,*) '-lfacmn- = ',lfacmn
            write(luout,*) '-lfacmx- = ',lfacmx
            write(luout,9988) (ijkseg(lface),lface=lfacmn,lfacmx)
         enddo
      endif
      if(some.or.out.or.dbug.and.ga_nodeid().eq.0) then
         write(luout,9993) npass,napex,minfac(npass),maxfac(npass),
     1                  radapp,raderr,srfapp,srferr,volapp,volerr
      endif
c
c     ----- at this point each of the faces is assigned to one -----
c           segment. now define centers of segments ...
c
      third =one/three
      lfacmn= minfac(minbem)
      lfacmx= maxfac(minbem)
      do lface=lfacmn,lfacmx
         mface=lface-lfacmn+1
         ijkseg(mface)=mface
         i=ijkfac(1,lface)
         j=ijkfac(2,lface)
         k=ijkfac(3,lface)
         do m=1,3
            xyzseg(m,mface)=(apex(m,i)+apex(m,j)+apex(m,k))*third
         enddo
         dseg=one/dist(xyzseg(1,mface),xyzseg(2,mface),xyzseg(3,mface),
     1                 zero,zero,zero)
         do m=1,3
            xyzseg(m,mface)=xyzseg(m,mface)*dseg
         enddo
      enddo
      nseg=(lfacmx-lfacmn+1)
c
      if(dbug.and.ga_nodeid().eq.0) then
         lfacmn=1
         lfacmx=nseg
         write(luout,*)    'segment to segment mapping = '
         write(luout,9988) (ijkseg(lface),lface=lfacmn,lfacmx)
      endif
c
c     ----- now the faces ... -----
c
      if(npass.gt.minbem) then
         lfacmn=minfac(minbem+1)
         lfacmx=maxfac(npass   )
         do lface=lfacmn,lfacmx
            mface=lface-lfacmn+1    
     1                        +(maxfac(minbem)-minfac(minbem)+1)
            ijkseg(mface)=ijkseg(lface)
     1                        -(               minfac(minbem)-1)
            i=ijkfac(1,lface)
            j=ijkfac(2,lface)
            k=ijkfac(3,lface)
            do m=1,3
               xyzseg(m,mface)=(apex(m,i)+apex(m,j)+apex(m,k))*third
            enddo
            dseg=one/dist(xyzseg(1,mface),
     1                    xyzseg(2,mface),
     2                    xyzseg(3,mface),zero,zero,zero)
            do m=1,3
               xyzseg(m,mface)=xyzseg(m,mface)*dseg
            enddo
         enddo
         nfac=(lfacmx-lfacmn+1)
c
c        ----- only keep the faces at granularity maxbem -----
c        ----- discard all other faces -----
c
         do lface=1,maxfac(maxbem-1)-minfac(minbem+1)+1
           ijkseg(nseg+lface) = 0
         enddo
      else
         do iseg=1,nseg
            ifac=iseg+nseg
            ijkseg(ifac)=ijkseg(iseg)
            do m=1,3
               xyzseg(m,ifac)=xyzseg(m,iseg)
            enddo
         enddo
         nfac=nseg
      endif
c
      if(dbug.and.ga_nodeid().eq.0) then
         lfacmn=nseg+1
         lfacmx=nseg+nfac
         write(luout,*)    ' face   to segment mapping = '
         write(luout,9988) (ijkseg(lface),lface=lfacmn,lfacmx)
      endif
c
c     ----- calculate -dsurf dvol- for the -cosmo- theory -----
c
      nfac =nseg
      ndiv =nfac/nseg
      dsurf=srf/dble(nfac)
      dvol =vol/dble(nfac)
      if(some.or.out.or.dbug.and.ga_nodeid().eq.0) then
         write(luout,9986) nseg,nfac,ndiv,dsurf,dvol
      endif
      if(out.and.ga_nodeid().eq.0) then
         write(luout,9985)
         do i=1,nseg
            done=dist(xyzseg(1,i),xyzseg(2,i),xyzseg(3,i),
     1                zero,zero,zero)
            write(luout,9984) i,
     1                     xyzseg(1,i),xyzseg(2,i),xyzseg(3,i),
     2                     ijkseg(i),done
         enddo
      endif
      if(dbug.and.ga_nodeid().eq.0) then
         write(luout,9985)
         do i=nseg+1,nseg+nfac
            done=dist(xyzseg(1,i),xyzseg(2,i),xyzseg(3,i),
     1                zero,zero,zero)
            write(luout,9984) (i-nseg),
     1                     xyzseg(1,i),xyzseg(2,i),xyzseg(3,i),
     2                     ijkseg(i),done
         enddo
      endif
c
c     ----- calculate -adiag- of the -cosmo- theory -----
c
      avgdia=zero
      avgfac=zero
      do mseg=1,nseg
         sum=zero
         do lseg=1,nseg
            if(lseg.ne.mseg) then
               l1=mseg
               l2=lseg
         sum=sum+rad/dist(xyzseg(1,l2),xyzseg(2,l2),xyzseg(3,l2),
     1                    xyzseg(1,l1),xyzseg(2,l1),xyzseg(3,l1))
            endif
         enddo
         fac=(dble(nseg)-sum)/sqrt(dble(nseg))
         adiag=sqrt(four*pi)*fac
         if(some.or.out.or.dbug.and.ga_nodeid().eq.0) then
            write(luout,9983) mseg,adiag,fac,dble(nseg),sum
         endif
         avgdia=avgdia+adiag
         avgfac=avgfac+fac
      enddo
      adiag=avgdia/dble(nseg)
      fac  =avgfac/dble(nseg)
      if(some.or.out.or.dbug.and.ga_nodeid().eq.0) then
         write(luout,9978)      adiag,fac               
      endif
c
      return
 9999 format(/,1x,'  apex',5x,'x',6x,5x,'y',6x,5x,'z',6x,/,1x,42(1h-))
 9998 format(1x,i6,f12.8,f12.8,f12.8)
 9997 format(' vol, approx., ratio, error = ',2f12.8,2 f8.4)
 9996 format(' pass, napex, nface, mnfac, mxfac = ',i3,4i8)
 9995 format('       napex, nface               = ',3x,2i8)
 9994 format(1x,'sphere from -icosahedron-',/,1x,25(1h-))
 9993 format(' npass = ',i2,' napex = ',i8,
     1       ' minfac = ',i8,' maxfac = ',i8,/,
     2       ' rad = ',f10.6,' error = ',f8.4,/,
     3       ' srf = ',f10.6,' error = ',f8.4,/,
     4       ' vol = ',f10.6,' error = ',f8.4)
 9992 format(' srf, approx., ratio, error = ',2f12.8,2 f8.4)
 9991 format(' rad, approx., ratio, error = ',2f12.8,2 f8.4)
 9990 format(' absolute -ijkseg- , for -ipass- = ',i5)
 9989 format(' relative -ijkseg- , for -ipass- = ',i5)
 9988 format(12i6)
 9987 format(' assigned segment for -lface- = ',i7,
     1       ' is = ',i7,' ( greater than -maxseg- = ',i4,' )')
 9986 format(' nseg,nfac,ndiv=nfac/nseg,dsurf,dvol = ',3i7,2f10.6)
 9985 format('   pt  ','      x     ','      y     ','      z     ',
     1       ' seg ','    norm    ',/,1x,59(1h-))
 9984 format(i7,3f12.8,i5,f12.8)
 9983 format(' mseg,adiag,fac,m,sum = ',i7,4f12.6)
 9982 format(1x,'sphere from -octahedron-',/,1x,24(1h-))
 9981 format(' pass # = ',i5)
 9980 format(' minfac = ',10i5)
 9979 format(' maxfac = ',10i5)
 9978 format('      adiag,fac       = ',   2f12.6)
      end
C>
C> \brief Setup the data for an Octahedron
C>
C> This routine initiates the segments of an octahedron. The output
C> is split over a few arrays. One array `apex` holds the coordinates
C> of the corners of the triangles, another array `ijkfac` lists 
C> for each triangle which points in the `apex` array hold the
C> corresponding corner points, and finally `ijkseg` record the 
C> mapping between faces and segments.
C>
      subroutine hnd_sphoct(apex,napex,ijkfac,ijkseg,nface)
      implicit none
#include "global.fh"
#include "stdio.fh"
c
      logical out
      integer            napex     !< [Output] The number of apeces
      integer            nface     !< [Output] The number of faces
      double precision    xyz(3,6)
      integer             ijk(3,8)
      double precision   apex(3,*) !< [Output] The corners of the 
                                   !< triangles
      integer          ijkfac(3,*) !< [Output] For each triangle which
                                   !< points make up its corners
      integer          ijkseg(  *) !< [Output] For each face the number
                                   !< of the segment it belongs to
      integer iapex, lface
      data xyz / 1.0d+00, 0.0d+00, 0.0d+00, 0.0d+00, 1.0d+00, 0.0d+00,
     1          -1.0d+00, 0.0d+00, 0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00,
     2           0.0d+00, 0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00/
      data ijk / 5, 1, 2, 5, 2, 3, 5, 3, 4, 5, 4, 1,
     1           6, 1, 2, 6, 2, 3, 6, 3, 4, 6, 4, 1/
c
      out=.false.
      out=out.and.ga_nodeid().eq.0
c
      if(out) then
         write(luout,9997)
      endif
c
c     ----- set the 6 apeces of an octahedron -----
c
c     1     1.     0.     0.
c     2     0.     1.     0.
c     3    -1.     0.     0.
c     4     0.    -1.     0.
c     5     0.     0.     1.
c     6     0.     0.    -1.
c
      napex=6
      do iapex=1,napex
         apex(1,iapex)=xyz(1,iapex)
         apex(2,iapex)=xyz(2,iapex)
         apex(3,iapex)=xyz(3,iapex)
      enddo
      if(out) then
         write(luout,9999)
         do iapex=1,napex
            write(luout,9998) iapex,apex(1,iapex),apex(2,iapex),
     1                           apex(3,iapex)
         enddo
      endif
c
      nface=8
      do lface=1,nface
         ijkfac(1,lface)=ijk(1,lface)
         ijkfac(2,lface)=ijk(2,lface)
         ijkfac(3,lface)=ijk(3,lface)
         ijkseg(  lface)=      lface
      enddo
c
      if(out) then
         write(luout,*) '...... end of -sphoct- ......'
      endif
      return
 9999 format(/,1x,'  apex',5x,'x',6x,5x,'y',6x,5x,'z',6x,/,1x,42(1h-))
 9998 format(1x,i6,f12.8,f12.8,f12.8)
 9997 format(/,1x,'octahedron',/,1x,10(1h-))
      end
c
      subroutine hnd_sphico(apex,napex,ijkfac,ijkseg,nface)
      implicit double precision (a-h,o-z)
#include "global.fh"
#include "stdio.fh"
c
      logical out
      dimension      c(3,12)
      dimension      s(3,12)
      dimension    ijk(3,20)
      dimension   apex(3,*)
      dimension ijkfac(3,*)
      dimension ijkseg(  *)
      data c   / 0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00, 1.0d+00, 0.0d+00,
     1           0.0d+00,-1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00,
     2           0.0d+00, 0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00, 1.0d+00,
     3           0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00,
     4           1.0d+00, 0.0d+00, 0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00,
     5          -1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00, 0.0d+00/
      data s   / 0.0d+00, 0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00,
     1           0.0d+00, 0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00,
     2           1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00, 0.0d+00,
     3           1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00, 0.0d+00,
     4           0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00,
     5           0.0d+00, 1.0d+00, 0.0d+00, 0.0d+00,-1.0d+00, 0.0d+00/
      data ijk / 1, 2, 9, 1, 9, 5, 1, 5, 6, 1, 6,11, 1,11, 2,
     1                    2, 9, 7, 2, 7, 8, 2, 8,11,
     2           3, 4,10, 3,10, 5, 3, 5, 6, 3, 6,12, 3,12, 4,
     3                    4,10, 7, 4, 7, 8, 4, 8,12,
     4           9,10, 7, 9, 5,10,11,12, 8,11, 6,12/
      data one  /1.0d+00/
      data two  /2.0d+00/
      data five /5.0d+00/
c
      out=.false.
      out=out.and.ga_nodeid().eq.0
c
      if(out) then
         write(luout,9997)
      endif
c
c     ----- set the 12 apeces of an icosahedron -----
c
c     1     0.     cosa   sina
c     2     0.     cosa  -sina
c     3     0.    -cosa   sina
c     4     0.    -cosa  -sina
c     5     sina   0.     cosa
c     6    -sina   0.     cosa
c     7     sina   0.    -cosa
c     8    -sina   0.    -cosa
c     9     cosa   sina   0.
c    10     cosa  -sina   0.
c    11    -cosa   sina   0.
c    12    -cosa  -sina   0.
c
      ang=acos(one/sqrt(five))/two
      cosa=cos(ang)
      sina=sin(ang)
      napex=12
      do iapex=1,napex
         apex(1,iapex)=cosa*c(1,iapex)+sina*s(1,iapex)
         apex(2,iapex)=cosa*c(2,iapex)+sina*s(2,iapex)
         apex(3,iapex)=cosa*c(3,iapex)+sina*s(3,iapex)
      enddo
      if(out) then
         write(luout,9999)
         do iapex=1,napex
            write(luout,9998) iapex,apex(1,iapex),apex(2,iapex),
     1                           apex(3,iapex)
         enddo
      endif
c
      nface=20
      do lface=1,nface
         ijkfac(1,lface)=ijk(1,lface)
         ijkfac(2,lface)=ijk(2,lface)
         ijkfac(3,lface)=ijk(3,lface)
         ijkseg(  lface)=      lface
      enddo
c
      if(out) then
         write(luout,*) '...... end of -sphico- ......'
      endif
      return
 9999 format(/,1x,'  apex',5x,'x',6x,5x,'y',6x,5x,'z',6x,/,1x,42(1h-))
 9998 format(1x,i6,f12.8,f12.8,f12.8)
 9997 format(/,1x,'icosahedron',/,1x,11(1h-))
      end
C>
C> \brief Partition a given triangle into four triangles and project
C> them outward onto the unit sphere
C>
      subroutine hnd_sphapx(apex,mapex,ijkfac,ijkseg,mface,lface,
     1                             ijkold,ijknew,dmin)
      implicit double precision (a-h,o-z)
#include "global.fh"
#include "stdio.fh"
c
      logical out
      logical duplic
      dimension   apex(3,*)
      dimension ijkfac(3,*)
      dimension ijkseg(  *)
      dimension ijkold(3)
      dimension ijknew(3)
      dimension    xyz(3,3)
      dimension      d(3)
      dimension xyzijk(3)
      equivalence (xyz(1,1),xij),(xyz(2,1),yij),(xyz(3,1),zij),
     1            (xyz(1,2),xjk),(xyz(2,2),yjk),(xyz(3,2),zjk),
     2            (xyz(1,3),xki),(xyz(2,3),yki),(xyz(3,3),zki)
      data zero  /0.0d+00/
      data pt5   /0.5d+00/
      data one   /1.0d+00/
      data three /3.0d+00/
      data tol   /1.0d-04/
c
      dist(x1,y1,z1,x2,y2,z2)=sqrt((x2-x1)**2+(y2-y1)**2+(z2-z1)**2)
c
      out=.false.
      out=out.and.ga_nodeid().eq.0
c
c     ----- create mid-point of the 3 edges -----
c
      iold=ijkold(1)
      jold=ijkold(2)
      kold=ijkold(3)
      do m=1,3
         xyz(m,1)=(apex(m,iold)+apex(m,jold))*pt5
         xyz(m,2)=(apex(m,jold)+apex(m,kold))*pt5
         xyz(m,3)=(apex(m,kold)+apex(m,iold))*pt5
      enddo
c
c     ----- project onto sphere -----
c
      d(1)=dist(xij,yij,zij,zero,zero,zero)
      d(2)=dist(xjk,yjk,zjk,zero,zero,zero)
      d(3)=dist(xki,yki,zki,zero,zero,zero)
      d(1)=one/d(1)
      d(2)=one/d(2)
      d(3)=one/d(3)
      do l=1,3
         do m=1,3
            xyz(m,l)=xyz(m,l)*d(l)
         enddo
      enddo
c
c     ----- check for duplicate apeces -----
c
      newapx=0
      do iapx=1,3
         duplic=.false.
         lduplc=0
         do lapex=1,mapex
            dd=dist(xyz(1,  iapx),xyz(2,  iapx),xyz(3,  iapx),
     1              apex(1,lapex),apex(2,lapex),apex(3,lapex))
            if(abs(dd).lt.tol) then
               duplic=.true.
               lduplc=lapex
            endif
         enddo
         if(duplic) then
            ijknew(iapx)=lduplc
            if(out) then
               write(luout,9999) iapx,ijkold,lduplc
            endif
         else
            newapx=newapx+1
            japx=mapex+newapx
            ijknew(iapx)=japx
            do m=1,3
               apex(m,japx)=xyz(m,iapx)
            enddo
            if(out) then
               write(luout,9998) iapx,ijkold,japx,
     1                        apex(1,japx),apex(2,japx),apex(3,japx)
            endif
         endif
      enddo
      mapex=mapex+newapx
c
c     ----- make up new faces and their centers -----
c
      third=one/three
      dmin =one
c
      mface=mface+1
      ijkseg(  mface)=lface
      ijkfac(1,mface)=ijkold(1)
      ijkfac(2,mface)=ijknew(1)
      ijkfac(3,mface)=ijknew(3)
      do m=1,3
         xyzijk(m)=(apex(m,iold)+apex(m,jold)+apex(m,kold))*third
      enddo
      dijk=dist(xyzijk(1),xyzijk(2),xyzijk(3),zero,zero,zero)
      dmin=min(dmin,dijk)
c
      mface=mface+1
      ijkseg(  mface)=lface
      ijkfac(1,mface)=ijkold(2)
      ijkfac(2,mface)=ijknew(1)
      ijkfac(3,mface)=ijknew(2)
      do m=1,3
         xyzijk(m)=(apex(m,iold)+apex(m,jold)+apex(m,kold))*third
      enddo
      dijk=dist(xyzijk(1),xyzijk(2),xyzijk(3),zero,zero,zero)
      dmin=min(dmin,dijk)
c
      mface=mface+1
      ijkseg(  mface)=lface
      ijkfac(1,mface)=ijkold(3)
      ijkfac(2,mface)=ijknew(2)
      ijkfac(3,mface)=ijknew(3)
      do m=1,3
         xyzijk(m)=(apex(m,iold)+apex(m,jold)+apex(m,kold))*third
      enddo
      dijk=dist(xyzijk(1),xyzijk(2),xyzijk(3),zero,zero,zero)
      dmin=min(dmin,dijk)
c
      mface=mface+1
      ijkseg(  mface)=lface
      ijkfac(1,mface)=ijknew(1)
      ijkfac(2,mface)=ijknew(2)
      ijkfac(3,mface)=ijknew(3)
      do m=1,3
         xyzijk(m)=(apex(m,iold)+apex(m,jold)+apex(m,kold))*third
      enddo
      dijk=dist(xyzijk(1),xyzijk(2),xyzijk(3),zero,zero,zero)
      dmin=min(dmin,dijk)
c
      if(out) then
         write(luout,9997) dmin,mface
      endif
c
      return
 9999 format(' duplicated apex =',i2,' for face ',3i5,'. same as = ',i5)
 9998 format('    new     apex =',i2,' for face ',3i5,'.  newapx = ',i5,
     1       /,7x,3f12.8)
 9997 format(' --- dmin = ',f12.8,' --- mface = ',i10)
      end
c
C> \brief Calculate the screened COSMO charges
C>
C> ## Introduction ##
C>
C> In the COSMO model [1] the charges to represent the solvation effects
C> are obtained from solving a linear system of equations \f$ Ax=b \f$.
C> In this system \f$ b \f$ is the electrostatic potential at the 
C> point charge positions. The matrix \f$ A \f$ consists of the 
C> electrostatic interaction between two unit charges at the point
C> charge position, i.e.
C> \f{eqnarray*}{
C>   A_{\mu\nu} &=& ||t_\mu - t_\nu||^{-1} \\\\
C>   A_{\mu\mu} &=& 3.8 |S_\mu|^{-1/2} \\\\
C>              &=& a_{\mathrm{diag}} |S_\mu|^{-1/2}
C> \f}
C> where \f$ S_\mu \f$ is the surface area associated with the COSMO
C> charge (see [1] Eqs. 7a and 7b). The quantity \f$a_{\mathrm{diag}}\f$
C> is evaluated using Eq.(B1). This done in two steps in that the
C> this quantity is evaluated for the unit sphere in `hnd_cossph`, any
C> remaining scale factors are applied in the evaluation of \f$A\f$.
C>
C> The original COSMO approach has problems when charge approach each
C> other and the interaction becomes singular. Therefore we have 
C> replaced this with a model where the interactions are smooth [4]
C> which is outlined below.
C>
C> ## Surface charges satisfying Gauss's theorem ##
C>
C> Solving these equations gives the "raw" COSMO charges \f$ x \f$.
C> These charges should sum up to the total charge contained within 
C> the Solvent Accessible Surface. For 2 reasons that will be in
C> practice not be exactly true:
C>
C> - The discretization of the SAS is not perfect
C>
C> - The electron distribution being represented with Gaussian functions
C>   extends beyond the SAS
C>
C> Therefore the raw COSMO charges are corrected by adding corrections
C> based on a Lagrange multiplier technique [4]. The corresponding
C> equations can be derived by starting from an energy expression
C> in terms of the solute charge distribution and the surface charges.
C> This energy expression including the Lagrange term is
C> \f{eqnarray*}{
C>   E(Q,q,\lambda) &=& \frac{1}{2}Q^TCQ + Q^TBq
C>                   +  \frac{1}{2f(\epsilon)}q^TAq
C>                   +  \lambda\left(f(\epsilon)Q_{in}+\sum_i q_i\right)
C> \f}
C> where \f$Q\f$ is the charge distribution of the solute (including
C> both nucleii and electrons), \f$q\f$ is the surface charge
C> distribution, \f$f(\epsilon)\f$ is the dielectric screening constant
C> as discussed below, \f$Q_{in}\f$ is the charge within the cavity
C> or equivalently the solute charge, and finally \f$A\f$, \f$B\f$,
C> and \f$C\f$ are Coulomb matrices.
C>
C> From this equation the surface charges can be derived by minimizing
C> \f$E\f$ wrt \f$q\f$ and \f$\lambda\f$. This yields
C> \f{eqnarray*}{
C>    \frac{\partial E}{\partial q} 
C>       &=& BQ + \frac{1}{f(\epsilon)}Aq + \Lambda = 0\\\\
C>    \frac{\partial E}{\partial \lambda}
C>       &=& f(\epsilon)Q_{in} + \sum_i q_i = 0
C> \f}
C> where \f$\Lambda\f$ is a vector of which each element is
C> \f$\lambda\f$, i.e. \f$\forall_i, \Lambda_i = \lambda\f$. 
C> Next we get
C> \f{eqnarray*}{
C>   q &=& -f(\epsilon)A^{-1}\left(BQ+\Lambda\right) \\\\
C>   \lambda &=& \frac{Q_{in}-\sum_i\left[A^{-1}BQ\right]_i}{
C>                     \sum_{ij}A^{-1}_{ij}}
C> \f}
C> Because \f$E\f$ is variationally optimized wrt \f$Q\f$, \f$q\f$,
C> and \f$\lambda\f$ the gradient expression only involves derivatives
C> of \f$A\f$, \f$B\f$ and \f$C\f$ just like the original COSMO
C> gradients [1].
C>
C> Previously the surface charge correction was implemented by scaling
C> the raw COSMO charges.
C> However, this led to complications with neutral molecules
C> where the correct integrated surface charge is 0. Hence the 
C> correction factor would be 0 as well, eliminating the COSMO charges
C> and hence all solvation effects. This problem had been patched by
C> calculating the COSMO charges for the nucleii and the electrons 
C> separately. This led to a cumbersome and expensive algorithm. So
C> the use of a Lagrange constraint is a solution that is
C> preferred over scaling the charges. The difference between the two
C> approaches should be small provided the discretization is fine
C> enough.
C>
C> In the COSMO model [1] it is realized that dielectric screening
C> scales as
C> \f{eqnarray*}{
C>   f(\epsilon) &= \frac{\epsilon-1}{\epsilon+a}, & 0\le a \le 2
C> \f}
C> Klamt and Sch&uuml;&uuml;rmann suggested to use \f$ a = 1/2 \f$, 
C> essentially based on an argument that the true value should not 
C> exceed 1 (see appendix A). Stevanovich and Truong [3] realized that
C> the screened charges should be such that the Gauss theorem holds,
C> which requires \f$ a = 0 \f$ (see Eq. (5)). Based on this physical
C> motivation the latter value is used by default.
C>
C> The linear system of equations to be solved may be tackled in 2
C> different ways. For small systems a direct solver is appriopriate,
C> whereas for large systems an iterative solver is used. These solvers
C> have different implications. If \f$ N \f$ is the number of COSMO
C> charges then
C>
C> - the direct solver uses \f$ O(N^2) \f$ memory and \f$ O(N^3) \f$
C>   instructions
C>
C> - the iterative solver uses \f$ O(N) \f$ memory and \f$ k*O(N^2) \f$
C>   instructions (\f$ k \f$ is the number of iterations to convergence)
C>
C> The costs are based on the assumptions that for the direct solver
C> the matrix is stored explicitly and the inverse is not stored but
C> recalculated every time. For the iterative solver only a 
C> matrix-vector multiplication is implemented that regenerates the
C> matrix elements every time, and the number of iterations is roughly
C> independent from the values of the matrix. 
C>
C> Based on these assumptions the iterative solver is optimal for large
C> systems both with respect to memory requirements as well as compute
C> requirements. The case for the iterative solver can be improved 
C> further by parallelizing the matrix-vector multiplication which
C> reduces the compute cost per processor to \f$ k*O(N^2)/N_{proc} \f$.
C> Furthermore if we start the iterative solver in each SCF cycle with
C> the solution from the previous iteration rather than \f$ x=0 \f$ then
C> \f$ k \f$ may be reduced as well. In practice \f$ k \f$ does not
C> depend strongly on the initial value of \f$ x \f$, reductions by at
C> most a factor 2 are seen when the SCF is nearly converged.
C>
C> ## Singularity free surface charge self-interaction ##
C>
C> The cavity in continuum solvation models is constructed by creating
C> spherical cavities around all atoms and merging these volumes. The
C> Solvent Accessible Surface (SAS) is created representing the
C> spherical surface around every atom with points and eliminating the 
C> points that fall inside the sphere around a neighboring atom.
C> Klamt et al. [1] suggested representing the surface charge by point
C> charges at the surface discretization points. This leads to
C> singularities in the solvation energy when some of these points come
C> together, typically in the vicinity of the boundary between spheres.
C>
C> The singularities in the surface self-interaction energy need to be
C> addressed to ensure that sensible geometry optimizations are 
C> possible. York and Karplus [4] suggested formally replacing the 
C> surface point charges by Gaussian charge distributions. This leads
C> to an interaction of the form
C> \f{eqnarray*}{
C>   A(r_i,r_j) &=& \frac{\mathrm{erf}(\zeta_{ij}r_{ij})}{r_{ij}}
C> \f}
C> This interaction is relatively easily implemented in force fields
C> where all charges are point charges. Implementing this for the
C> interaction between a point charge and an electron distribution
C> is conceptually harder to do.
C>
C> A consistent implementation would need to use this expression for
C> both the \f$A\f$ and \f$B\f$ matrix. Scalmani and Frisch [5] have
C> sought to do this exactly by explicitly representing the surface
C> charges as Gaussians. This could be done of course using the 
C> charge density fitting integrals but it would require some 
C> engineering as the surface charges would need to be stored in a
C> geometry object. Lange and Herbert [6,7] have followed York and
C> Karplus more closely and applied this approximation only to
C> matrix \f$A\f$ and not to the surface charge-electron interaction.
C> However, even applying this interaction just for \f$A\f$ is 
C> problematic as the expression still contains singularities at
C> \f$r_{ij} = 0\f$ that have to be handled explicitly to avoid floating
C> point exceptions.
C>
C> Considering the use of the potential above in more detail we have
C> \f{eqnarray*}{
C>   A(r_i,r_j) &=& \frac{\mathrm{erf}(\zeta_{ij}r_{ij})}{r_{ij}} \\\\
C>   A(r_i,r_i) &=& \lim_{r_{ij}\to 0}\frac{\mathrm{erf}(\zeta_{ii}r_{ij})}{r_{ij}}(F(r_i))^{-1} \\\\
C>              &=& \zeta_i\sqrt{2/\pi}(F(r_i))^{-1} \\\\
C>   \zeta_{ij} &=& \frac{\zeta_i\zeta_j}{
C>                        \left(\zeta_i^2+\zeta_j^2\right)^{1/2}} \\\\
C>   \zeta_i    &=& \frac{\zeta}{R_I\sqrt{w_i}} \\\\
C>              &=& \frac{\zeta}{\sqrt{|S_i|}} \\\\
C>              &=& \frac{\zeta\sqrt{M}}{R_I\sqrt{2\pi}}
C> \f}
C> where \f$R_I\f$ is the radius of the cavity around atom \f$I\f$,
C> \f$w_i\f$ is the weight of point \f$i\f$ on the unit sphere, hence 
C> \f$R_I\sqrt{w_i}\f$ is equivalent to the surface \f$|S_i|\f$ of the
C> point, \f$\zeta\f$ is a width parameter for the Gaussian distribution
C> that has been optimized to reproduce the Born solvation energy,
C> \f$M\f$ is the number of discretization points on the sphere.
C> In [4] Table 1 it is shown that \f$\zeta\f$ is essentially
C> \f$4.90\f$ for Lebedev grids (for the Boundary Element Mesh we
C> use it is \f$1.00\f$). Finally \f$F_i\f$ is the switching function
C> defined below.
C> From this the limit of two point charges approaching eachother can
C> be established as
C> \f{eqnarray*}{
C>   \lim_{r_j \to r_i} A(r_i,r_j) &=& \zeta_{ij}\frac{2}{\sqrt{\pi}}
C> \f}
C> When two point charges come so close together that \f$r_{ij} < C\f$
C> then this last expression has to be used, otherwise the regular
C> expression for \f$A(r_i,r_j)\f$ should be used.
C>
C> The gradient of this expression is given by
C> \f{eqnarray*}{
C>   \nabla_M A(r_i,r_j)
C>   &=& -\left(\mathrm{erf}(\zeta_{ij}r_{ij})-
C>        \frac{2\zeta_{ij}}{\sqrt{\pi}}
C>        e^{-\zeta_{ij}^2r_{ij}^2}\right)
C>        \frac{\nabla_M r_{ij}}{r_{ij}^2} \\\\
C>   \nabla_M A(r_i,r_i)
C>   &=& -A(r_i,r_i)\sum_B\frac{\partial F}{\partial R_B}\nabla_M r_i
C> \f}
C>
C> ## Continuous switching functions ##
C>
C> In order to obtain a smooth function wrt the nuclear coordinates
C> it is necessary that when the atoms move the surface areas associated
C> with a point charge change smoothly. The approach suggested by 
C> York and Karplus [4] proposes to use multiple radii around an atom. 
C> Each atom has an inner radius \f$R_{in}\f$ and an outer radius
C> \f$R_{out}\f$. The difference between them is the switching radius 
C> \f$R_{sw} = R_{out} - R_{in}\f$. The areas of cavity surface points
C> are multiplied with a weighting factor based on their relative
C> position. In practice the diagonal elements of \f$A\f$ are scaled 
C> by the inverse of the surface areas generating corresponding weights
C> as
C> \f{eqnarray*}{
C>   r_{A,i} - R_B \ge R_{out},&& W_{Ai,B} = 1 \\\\
C>   r_{A,i} - R_B \le R_{in}, && W_{Ai,B} = \infty \\\\
C>   R_{in} < r_{A,i}-R_B < R_{out},
C>      && W_{Ai,B} = 1/f\left(\frac{r_{A,i}-R_B-R_{in}}{R_{SW}}\right)
C> \f}
C> where the function \f$f(r)\f$ is given by
C> \f{eqnarray*}{
C>   f(r) &=& r^3\left(10-15r+6r^2\right) \\\\
C>   \frac{\partial f(r)}{\partial r} &=& 30r^2(r-1)^2
C> \f}
C> The weighting function overall is given by
C> \f{eqnarray*}{
C>    F_{Ai} = \prod_{B\neq A} W_{Ai,B}
C> \f}
C> It can be shown that if \f$F_{Ai}\f$ is close to \f$0\f$ then
C> the corresponding point will not contribute to the energy
C> expression and can be eliminated. This is most easily shown by
C> considering the energy expression and substituting the surface
C> charge expression. If \f$F_{Ai}\f$ goes to 0 then the diagonal
C> element \f$A(r_i,r_i)\f$ approaches infinity. This means that the
C> corresponding row and column in \f$A^{-1}\f$ goes to zero, and
C> the energy expression depends only on \f$A^{-1}\f$ hence the 
C> corresponding point will not contribute to the energy.
C>
C> One interesting observation is that matrix \f$A\f$ is used in
C> linear system of equations \f$Aq = BQ\f$. The condition number of
C> the matrix \f$A\f$ determines the ratio of the relative error in
C> \f$x\f$ and the relative error in \f$BQ\f$. In particular, the 
C> larger the condition number the larger the relative error in \f$x\f$
C> for a given relative error in \f$BQ\f$. The condition number
C> is given by
C> \f{eqnarray*}{
C>    K(A) = \left|\frac{\lambda_{\mathrm{max}}(A)}{
C>                       \lambda_{\mathrm{min}}(A)}\right|
C> \f}
C> where \f$\lambda_{\mathrm{max}}(A)\f$ is the maximum eigenvalue, 
C> and \f$\lambda_{\mathrm{min}}(A)\f$ is the minimal eigenvalue of 
C> \f$A\f$. The approach by York and Karplus for eliminating surface
C> charges is based on raising the condition number to infinity, at
C> which point the vector \f$q\f$ must become very inaccurate. Hence
C> the cutoff for eliminating charges must be chosen carefully to
C> limit the condition number of the remaining part of \f$A\f$.
C>
C> ### References ###
C>
C>   [1] A. Klamt, G. Sch&uuml;&uuml;rmann,
C>   "COSMO: a new approach to dielectric screening in solvents with
C>    explicit expressions for the screening energy and its gradient",
C>   <i>J. Chem. Soc., Perkin Trans. 2</i>, 1993, pp 799-805, DOI:
C>   <a href="http://dx.doi.org/10.1039/P29930000799">
C>   10.1039/P29930000799</a>.
C>
C>   [2] M.A. Aguilar, F.J. Olivares del Valle, J. Tomasi,
C>   "Nonequilibrium solvation: An ab initio quantummechanical method
C>    in the continuum cavity model approximation",
C>   <i>J. Chem. Phys.</i> (1993) <b>98</b>, pp 7375-7384, DOI:
C>   <a href="http://dx.doi.org/10.1063/1.464728">
C>   10.1063/1.464728</a>.
C>
C>   [3] E.V. Stefanovich, T.N. Truong,
C>   "Optimized atomic radii for quantum dielectric continuum solvation
C>    models", <i>Chem. Phys. Lett.</i> (1995) <b>244</b>, pp 65-74,
C>   DOI:
C>   <a href="http://dx.doi.org/10.1016/0009-2614(95)00898-E">
C>   10.1016/0009-2614(95)00898-E</a>.
C>
C>   [4] D.M. York, M. Karplus,
C>   "A smooth solvation potential based on the conductor-like 
C>    screening model", <i>J. Phys. Chem. A</i> (1999) <b>103</b>,
C>   pp 11060-11079, DOI:
C>   <a href="http://dx.doi.org/10.1021/jp992097l">
C>   10.1021/jp992097l</a>.
C>
C>   [5] G. Scalmani, M.J. Frisch,
C>   "Continuous surface charge polarizable continuum models of
C>    solvation. I. General formalism", <i>J. Chem. Phys.</i> (2010)
C>   <b>132</b>, 114110, DOI:
C>   <a href="http://dx.doi.org/10.1063/1.3359469">
C>   10.1063/1.3359469</a>.
C>
C>   [6] A.W. Lange, J.M. Herbert, 
C>   "Polarizable continuum reaction-field solvation models affording
C>    smooth potential energy surfaces", <i>J. Phys. Chem. Lett.</i>
C>   (2010) <b>1</b>, pp 556-561, DOI:
C>   <a href="http://dx.doi.org/10.1021/jz900282c">
C>   10.1021/jz900282c</a>.
C>
C>   [7] A.W. Lange, J.M. Herbert,
C>   "A smooth, nonsingular, and faithful discretization scheme for
C>    polarizable continuum models: The switching/Gaussian approach",
C>   <i>J. Chem. Phys.</i> (2010) <b>133</b>, 244111, DOI:
C>   <a href="http://dx.doi.org/10.1063/1.3511297">
C>   10.1063/1.3511297</a>.
C>
      subroutine hnd_coschg(g_dens,ndens,rtdb,geom,basis,nat,nefc,
     &                      efcc,efcs,efcz,efciat,ratm,ecos,
     &                      cosmo_file)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geom.fh"
#include "bq.fh"
#include "stdio.fh"
#include "prop.fh"
#include "util.fh"
#include "inp.fh"
c
      integer ndens         !< [Input] the number of density matrices
      integer g_dens(ndens) !< [Input] the handle for the density
                            !< matrices
      integer rtdb          !< [Input] the RTDB handle
      integer geom          !< [Input] the molecular geometry handle
      integer basis         !< [Input] the molecular basis set handle
      integer nat           !< [Input] the number of atoms
      integer nefc          !< [Input] the number of COSMO charges
c
      double precision efcc(3,nefc) !< [Input] the COSMO charge
                                    !< coordinates
      double precision efcs(nefc)   !< [Input] the COSMO charge
                                    !< surface area
c
      double precision efcz(nefc)   !< [Output] the COSMO charges
      integer          efciat(nefc) !< [Input] the atom associated
                                    !< with each surface charge
      double precision ratm(nat)    !< [Input] the atom radii
      double precision ecos !< [Output] the energy contribution due to
                            !< the COSMO charges
      logical  status
c
      logical  dbug,more,out,direct,noall,all,elec,nucl,iefc_done
      character*16 at_tag
      integer istrlen
      character*255 cosmo_file
      integer fn
      integer lineq ! 0: fast direct solver, 1: slow iterative solver
      integer minbem 
      integer maxbem 
      integer ificos ! 0 use octahedron, 1 use icosahedron tesselation
      integer ifscrn ! do screening/correction?
      integer iat ! counter over atoms
      integer jef ! counter over COSMO charges
      integer l_i10, i10
      integer l_i11, i11
      integer l_i12, i12
      integer l_i20, i20
      integer l_i21, i21
      integer l_i22, i22
      integer l_i30, i30
      integer l_i40, i40
      integer l_i50, i50
      integer l_i60, i60
      integer l_i70, i70
      integer l_i80, i80
      integer l_i90, i90
      integer i,ipt,ief ! counters
      integer i_init ! number of ints in memory requirement vector
      integer init ! memory requirement vector
      integer ierr ! error flag
      integer iep ! memory offset of b from Ax=b
      integer nodcmp ! flag specifying how to handle errors
      integer need ! the amount of memory needed
c
      integer l_epot, l_xyzpt, l_zanpt ! memory handles
      integer k_epot, k_xyzpt, k_zanpt ! memory offsets
c
      double precision adiag
      double precision dsurf
      double precision dvol
      double precision srfmol
      double precision volmol
      double precision dielec    ! dielectric constant (slow component)
      double precision dielecinf ! optical dielectric constant (fast component)
      double precision screen ! dielectric screening factor
      double precision rsolv
      double precision zeta,gammas,swtol
      double precision ptspatm
      common/hnd_cosmod/lineq,minbem,maxbem,ificos,ifscrn
      common/hnd_cosdat/adiag,dsurf,dvol,srfmol,volmol,ptspatm
      common/hnd_cospar/dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      double precision charge ! the total QM region charge
      double precision chgfac ! scale factor for COSMO charges
      double precision chgcos ! the total COSMO surface charge
      double precision chgcvg ! the convergence of the COSMO charges
      double precision chgina ! the inv(A) COSMO charge
      double precision corcos ! the COSMO charge correction
      double precision errcos ! the COSMO charge error
      double precision delchg ! charge difference
      double precision aii,aij,bij,chgief,dij,deta,dum,oldief
      double precision atmefc ! atom - COSMO charge interaction
      double precision efcefc ! COSMO charge - COSMO charge interaction
      double precision elcefc ! electron - COSMO charge interaction
      double precision allefc ! total QM - COSMO charge interaction
      double precision zan ! charges
      double precision xi, xj, xn, xp ! X-coordinates
      double precision yi, yj, yn, yp ! Y-coordinates
      double precision zi, zj, zn, zp ! Z-coordinates
      double precision qi, qj ! charges
      double precision rr ! distance
      double precision solnrg ! solvation energy
      double precision dlambda ! lambda (surface charge correction)
      double precision pi
      double precision x(1)
      equivalence (x(1),dbl_mb(1))
      double precision zero, pt5, one, two ! constants
      data zero   /0.0d+00/
      data pt5    /0.5d+00/
      data one    /1.0d+00/
      data two    /2.0d+00/
      double precision zetai, zetaj, zetaij
      double precision bohr
      parameter (bohr=0.529177249d0)
      logical stat
c
      double precision util_erf
      logical util_io_unit
      external util_io_unit, util_erf
c
c MN solvation models --> 
c
      double precision gspol, gstote, estote, gspoldyn, gspolneq
      double precision disp_cosmo_vem
      double precision dvem1, dvem2, dvem3, dvem4, dvem5
      double precision espolgsrf, espol, espolin, espoldyn, delwvem
      double precision wgsrf_cosmo_vem, wstar_cosmo_vem
      double precision wcgsrf_cosmo_vem, w_cosmo_vem, wold_cosmo_vem
      double precision tolw
      logical do_cosmo_smd
      integer do_cosmo_vem, istep_cosmo_vem
c
c     possible values of istep_cosmo_vem: 
c     =0 (initial GS SCF to get GSRF+GS MOs), 
c     =1 (TDDFT + ES density to get ESRF),
c     =2 (calculate expect. values of the new Fock operator containing ESRF and repeat =1)  
c     =3 (when the VEM excitation calculation is converged either exit
c         or proceed to GS emission calculation)
c
      integer iter_cosmo_vem
      integer l_efczfx, k_efczfx  ! memory handles for fixed cosmo-vem charges
      integer g_vem(3) ! ga handles for cosmo-vem GS potential, GS charges, and ES noneq charges
c
      wgsrf_cosmo_vem = zero
      wstar_cosmo_vem = zero
      tolw = 0.00001d0
      iter_cosmo_vem = 0
      dvem1=(dielecinf-one)*dielec/dielecinf/(dielec-one)
      dvem2=(dielec-dielecinf)/dielecinf/(dielec-one)
c
      if (.not. rtdb_get
     $ (rtdb,'cosmo:istep_cosmo_vem',mt_int,1,istep_cosmo_vem))
     $  call errquit('hnd_coschg: cannot get istep_cosmo_vem',
     $  0,rtdb_err)
      if (.not. rtdb_get
     $ (rtdb,'cosmo:do_cosmo_vem',mt_int,1,do_cosmo_vem))
     $  call errquit('hnd_coschg: cannot get do_cosmo_vem',
     $  0,rtdb_err)
      if (.not. rtdb_get
     $ (rtdb,'cosmo:do_cosmo_smd',mt_log,1,do_cosmo_smd))
     $  call errquit('hnd_coschg: cannot get do_cosmo_smd',
     $  0,rtdb_err)
c
      if (do_cosmo_vem.ne.0) then
c
c     --- an array for cosmo-vem charges
c
        if (.not.ma_push_get
     $ (mt_dbl,nefc,"hnd_coschg:efczfx",l_efczfx,k_efczfx))
     &   call errquit("hnd_coschg: malloc efczfx failed",0,MA_ERR)
      endif
c
      if (istep_cosmo_vem.eq.2.or.(do_cosmo_vem.eq.2.and.
     $ istep_cosmo_vem.eq.3)) then
c restore charges from GA g_vem(3), pass them through this subroutine
c without change, and save them under "cosmo_bq_efc" along with
c tesserae's geometries for later use in nwdft/scf_dft/dft_fockbld.F 
c
        call ga_sync()
c
       if(.not.rtdb_get(rtdb,'cosmo:g_vem',mt_int,3,g_vem))
     $  call errquit('hnd_coschg: cannot get g_vem from rtdb',
     $  0,rtdb_err)
        call nga_get(g_vem(3), 1, nefc, x(k_efczfx), nefc)       
c
        call ga_sync()
      endif
c
c <-- MN solvation models
c
      more=.false.
      dbug=.false.
      dbug=dbug.or.more
      out =.false.
      out =out.or.dbug
c
      pi = acos(-1.0d0)
c
      dbug=dbug.and.ga_nodeid().eq.0
      more=more.and.ga_nodeid().eq.0
      out =out .and.ga_nodeid().eq.0
c
      iefc_done=.false.
      all=.false.
      ecos=zero
      istrlen = 0
c
c     ----- get electrostatic potential at surface points -----
c
c     --- total field
      if (.not.ma_push_get(mt_dbl,nefc,"hnd_coschg:i10",l_i10,i10))
     &   call errquit("hnd_coschg: malloc i10 failed",913,MA_ERR)
c     --- nuclear field
      if (.not.ma_push_get(mt_dbl,nefc,"hnd_coschg:i11",l_i11,i11))
     &   call errquit("hnd_coschg: malloc i11 failed",914,MA_ERR)
c     --- electron field
      if (.not.ma_push_get(mt_dbl,nefc,"hnd_coschg:i12",l_i12,i12))
     &   call errquit("hnd_coschg: malloc i12 failed",914,MA_ERR)
c
c     ----- calculate electronic contribution at all points -----
c
      call hnd_elfcon(basis,geom,g_dens(ndens),efcc,nefc,x(i12),0)
      do ipt=1,nefc
         x(i12+ipt-1) = -x(i12+ipt-1)
      enddo
c
c     ----- nuclear contribution -----
c
      if (.not.geom_ncent(geom,nat)) call
     &    errquit('hnd_coschg: geom_ncent',911,GEOM_ERR)
      if (.not. ma_push_get(mt_dbl,3*nat,'xyz pnt',l_xyzpt,k_xyzpt))
     &    call errquit('hnd_coschg: ma failed',911,MA_ERR)
      if (.not. ma_push_get(mt_dbl,nat,'epot pnt',l_epot,k_epot))
     &    call errquit('hnd_coschg: ma failed',911,MA_ERR)
      if (.not. ma_push_get(mt_dbl,nat,'zan pnt',l_zanpt,k_zanpt))
     &    call errquit('hnd_coschg: ma failed',911,MA_ERR)
      do iat=1,nat
        if(.not.geom_cent_get(geom,iat,at_tag,dbl_mb(k_xyzpt+3*(iat-1)),
     &     dbl_mb(k_zanpt+iat-1))) call
     &     errquit('hnd_coschg: geom_cent_get',911,GEOM_ERR)
      enddo ! iat
c
      do ipt=1,nefc
         xp = efcc(1,ipt)
         yp = efcc(2,ipt)
         zp = efcc(3,ipt)
         x(i11+ipt-1) = 0.0d0
         do i = 1,nat
            xn  = dbl_mb(k_xyzpt  +3*(i-1)) - xp
            yn  = dbl_mb(k_xyzpt+1+3*(i-1)) - yp
            zn  = dbl_mb(k_xyzpt+2+3*(i-1)) - zp
            zan = dbl_mb(k_zanpt+i-1)
            rr =  sqrt(xn*xn + yn*yn + zn*zn)
            x(i11+ipt-1) = x(i11+ipt-1) + zan/rr
         enddo ! i
         x(i10+ipt-1) = x(i11+ipt-1) + x(i12+ipt-1)
      enddo ! ipt
c
c     ----- get surface charges -----
c
c     ----- set up the memory based on the solver -----
c     lineq = 0: fast direct solver, lineq = 1: slow iterative solver
c
      if (lineq.eq.0) then
c
        stat = .true.
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i20",
     &                                l_i20,i20)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i21",
     &                                l_i21,i21)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i22",
     &                                l_i22,i22)
        stat = stat .and. ma_push_get(mt_dbl,nefc*nefc,"hnd_coschg i30",
     &                                l_i30,i30)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i40",
     &                                l_i40,i40)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i50",
     &                                l_i50,i50)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i80",
     &                                l_i80,i80)
c
c      check memory
c
       if (.not.stat) then
        call errquit("hnd_coschg: out of memory: lineq = 0 ",950,MA_ERR)
       endif
c
      else if (lineq.eq.1) then
c
        stat = .true.
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i20",
     &                                l_i20,i20)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i21",
     &                                l_i21,i21)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i22",
     &                                l_i22,i22)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i30",
     &                                l_i30,i30)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i40",
     &                                l_i40,i40)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i50",
     &                                l_i50,i50)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i60",
     &                                l_i60,i60)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i70",
     &                                l_i70,i70)
        stat = stat .and. ma_push_get(mt_dbl,nefc,"hnd_coschg i80",
     &                                l_i80,i80)
c
c      check memory
c
       if (.not.stat) then
        call errquit("hnd_coschg: out of memory: lineq = 1 ",950,MA_ERR)
       endif
c
      else 
       call errquit("hnd_coschg: unknown solver",911,INPUT_ERR)
      end if ! lineq 
c
      if(out) then
         if(lineq.eq.1) then
            write(luout,*) 'use iterative method for -lineq-'
         else
            write(luout,*) 'use in-memory method for -lineq-'
         endif
      endif
c
      if(lineq.eq.0) then
c
c     ----- in memory -----
c
         if(out) then
            write(luout,*) '-lineq- in memory'
         endif
c
c     ----- calculate q* = A^{-1}BQ -----
c
         iep=i10

         do ief=1,nefc
            x(ief+i20-1)=x(ief+iep-1)
         enddo

         call hnd_cosmata(nat,nefc,efcc,efcs,efciat,ratm,x(i30))
c
         nodcmp=1
         call hnd_linequ(x(i30),nefc,x(i20),nefc,
     1                   x(i40),x(i50),deta,ierr,nodcmp)
c
c     ----- calculate t = A^{-1}1 -----
c
         do ief=1,nefc
            x(ief+i80-1)=one
         enddo

         call hnd_cosmata(nat,nefc,efcc,efcs,efciat,ratm,x(i30))
c
         nodcmp=1
         call hnd_linequ(x(i30),nefc,x(i80),nefc,
     1                   x(i40),x(i50),deta,ierr,nodcmp)
c
      else
c
c     ----- iterative -----
c
         if(out) then
            write(luout,*) 'iterative -lineq-'
         endif
c
c     ----- calculate qraw = q* = A^{-1}BQ -----
c
         if (.not.rtdb_get(rtdb,'cosmo:qraw',mt_dbl,nefc,x(i20))) then
c
c           If no raw COSMO charges were found initialize x=0
c
            do ief=1,nefc
               x(ief+i20-1)=zero
            enddo
         endif
c
         direct=.true.
c
c     ----- solve ... -----
c
         iep=i10

         call hnd_cosequ(nat,x(iep),x(i20),nefc,
     1                   x(i40),x(i50),x(i60),x(i70),
     2                   efcc,efcs,efciat,ratm)
c
         if (.not.rtdb_put(rtdb,'cosmo:qraw',mt_dbl,nefc,x(i20))) then
            call errquit('hnd_coschg: could not store raw COSMO charge',
     1                   nefc,RTDB_ERR)
         endif
c
c     ----- calculate t = A^{-1}1 -----
c
         if (.not.rtdb_get(rtdb,'cosmo:rawt',mt_dbl,nefc,x(i80))) then
c
c           If no raw A^{-1}1 charges were found initialize x=0
c
            do ief=1,nefc
               x(ief+i80-1)=zero
            enddo
         endif
c
         direct=.true.
c
c     ----- solve ... -----
c
         do ief=1,nefc
            x(ief+i21-1)=one
         enddo
         iep=i21

         call hnd_cosequ(nat,x(iep),x(i80),nefc,
     1                   x(i40),x(i50),x(i60),x(i70),
     2                   efcc,efcs,efciat,ratm)
c
         if (.not.rtdb_put(rtdb,'cosmo:rawt',mt_dbl,nefc,x(i80))) then
            call errquit('hnd_coschg: could not store raw A^{-1}1',
     1                   nefc,RTDB_ERR)
         endif
      endif
c
c     ----- correct the COSMO charges ... -----
c
      chgcos=zero
      chgina=zero ! inverse of A
      do ief=1,nefc
         chgief=x(ief+i20-1)
         chgcos=chgcos+chgief
         chgina=chgina+x(i80+ief-1)
      enddo
      if (.not. rtdb_get(rtdb, 'charge', MT_DBL, 1, charge))
     $     charge = 0.0d0
      errcos=charge-chgcos
      dlambda=errcos/chgina
      if (ifscrn.ne.1) then
         do ief=1,nefc
            x(ief+i20-1)=x(ief+i20-1)+dlambda*x(i80+ief-1)
         enddo
      endif
c
c     ----- charge screening due to the dielectric medium -----
c
c     ----- set screening factor -----
c
      if(ifscrn.eq.0) then
         chgfac=one
      elseif(ifscrn.eq.1) then
         chgfac=screen
      elseif(ifscrn.eq.2) then
         chgfac=screen
      else
         write(luout,*) 'illegal -ifscrn- ... stop. = ',ifscrn
         call errquit('hnd_coschg: illegal -ifscrn-...',911,UERR)
         chgfac=one
      endif

      if(out) then
         write(luout,*) ' ifscrn                       = ',ifscrn
         write(luout,9984) chgfac
      endif
c
c     ----- apply screening factor -----
c
      chgcos=zero
      do ief=1,nefc
         x(ief+i20-1)=-chgfac*x(ief+i20-1)
         chgcos=chgcos+x(ief+i20-1)
      enddo
c
c     ----- store effective charges in -efcz- ... -----
c           check convergence ...
c
      chgcvg=zero
      do ief=1,nefc
         oldief=efcz(ief)
         chgief=   x(ief+i20-1)
         delchg=abs(chgief-oldief)
         if(delchg.gt.chgcvg) then
            chgcvg=delchg
         endif
         efcz(ief)=chgief
      enddo
c
c MN solvation models -->
c
      do ief=1,nefc
         if (istep_cosmo_vem.eq.2.and.do_cosmo_vem.ne.0) then
c fixed ES nonequilibrium cosmo-vem charges to be added to the Fock matrix
c later on (excitation VEM)
           efcz(ief)=x(k_efczfx+ief-1)
         endif
         if (istep_cosmo_vem.eq.3.and.do_cosmo_vem.eq.2) then
c GS RF containing ES cosmo-vem charges (slow portion) to calculate
c the VEM energy in the case of nonequilibrium emission to the GS
          efcz(ief)=dvem1*efcz(ief)+dvem2*x(k_efczfx+ief-1)
         endif
      enddo
c
c <-- MN solvation models
c
      if(all) then
         if(out) then
            write(luout,9987) chgcvg
         endif
      endif

      if(dbug) then
         write(luout,9998)
         do ief=1,nefc
            write(luout,9997) ief,(efcc(i,ief),i=1,3),efcz(ief)
         enddo
      endif
c
c     ----- calculate energy terms from -cosmo- charges -----
c
      allefc=zero
      atmefc=zero
      efcefc=zero
      do jef=1,nefc
         xj=efcc(1,jef)
         yj=efcc(2,jef)
         zj=efcc(3,jef)
         qj=efcz(  jef)
         zetaj=zeta*sqrt(ptspatm)/(ratm(efciat(jef))*sqrt(2.0d0*pi))
c
         allefc=allefc+qj*x(jef+i10-1)
c
         do iat=1,nat
            xi=dbl_mb(k_xyzpt  +3*(iat-1))
            yi=dbl_mb(k_xyzpt+1+3*(iat-1))
            zi=dbl_mb(k_xyzpt+2+3*(iat-1))
            qi=dbl_mb(k_zanpt+iat-1)
            dij=sqrt((xi-xj)**2+(yi-yj)**2+(zi-zj)**2)
            bij=one/dij
            atmefc=atmefc+qi*bij*qj
         enddo
c
         do ief=1,nefc
            zetai=zeta*sqrt(ptspatm)/(ratm(efciat(ief))*sqrt(2.0d0*pi))
            xi=efcc(1,ief)
            yi=efcc(2,ief)
            zi=efcc(3,ief)
            qi=efcz(  ief)
            if(ief.eq.jef) then
               aij=efcs(ief)
            else
               dij=sqrt((xi-xj)**2+(yi-yj)**2+(zi-zj)**2)
               zetaij=zetai*zetaj/sqrt(zetai**2+zetaj**2)
               if (dij.lt.1.0d-6) then
                 aij=2.0d0*zetaij/sqrt(pi)
               else
                 aij=util_erf(zetaij*dij)/dij
               endif
            endif
            efcefc=efcefc+qi*aij*qj
         enddo
      enddo
      efcefc= efcefc/(two*chgfac)
      elcefc= allefc-atmefc
      solnrg= allefc+efcefc
      ecos  = atmefc+efcefc
      if (out) then
         write(luout,9991) atmefc
         write(luout,9990) elcefc
         write(luout,9995) efcefc
         write(luout,9988) solnrg
         write(luout,9989) allefc,(-two*efcefc)
         write(luout,9994) ecos  
      endif
c
c     ----- other form of the solvation energy ... -----
c
      allefc=zero
      atmefc=zero
      elcefc=zero
      do jef=1,nefc
         xj=efcc(1,jef)
         yj=efcc(2,jef)
         zj=efcc(3,jef)
         qj=efcz(  jef)
c
         allefc=allefc+qj*x(jef+i10-1)
         atmefc=atmefc+qj*x(jef+i11-1)
         elcefc=elcefc+qj*x(jef+i12-1)
      enddo
      solnrg= pt5* allefc
c     no idea what the following line is supposed to mean
c     ecos  = pt5*(atmefc-elcefc)
      if (out) then
         write(luout,9991) atmefc
         write(luout,9990) elcefc
         write(luout,9989) allefc
         write(luout,9988) solnrg
         write(luout,9994) ecos
      endif

      if(dbug) then
         write(luout,9998)
         do ief=1,nefc
            write(luout,9997) ief,(efcc(i,ief),i=1,3),efcz(ief)
         enddo
      endif
c
      if(out) then
         write(luout,9993)
      endif
c
c     ----- save -cosmo- charges and energy to -rtdb- -----
c
      if (.not. rtdb_put(rtdb,'cosmo:energy',mt_dbl,1,ecos))
     &   call errquit('hnd_coschg: rtdb put failed for ecos',911,
     &       rtdb_err)
      if(.not.rtdb_put(rtdb,'cosmo:efcz',mt_dbl,  nefc,efcz))
     $   call errquit('hnd_coschg: rtdb put failed for efcz',912,
     &       rtdb_err)
c
c     ----- for the time being, save in 'geometry' object -----
c
      if(out) then
         write(luout,*) 'in -hnd_coschg ... for -efc- geom = ',geom
      endif
      status=bq_set(cosmo_bq_efc,nefc,efcz,efcc)
      if (.not.status) then
         call errquit('hnd_coschg: bq_set failed !', 0,
     &       geom_err)
      endif
      status=bq_rtdb_store(rtdb,cosmo_bq_efc)
      if (.not.status) then
         call errquit('hnd_coschg: bq_rtdb_store failed !', 0,
     &       geom_err)
      endif
     
c
c     ----- printing cosmo charges for bq module -----
c
      istrlen = inp_strlen(cosmo_file)
      if (istrlen.le.0) cosmo_file = "cosmo.xyz"
      call util_file_name_resolve(cosmo_file,.false.)
      if(ga_nodeid().eq.0) then
        if(.not.util_io_unit(80,90,fn))
     +     call errquit('cannot get free unit', 0,
     +       0)
c
        open(unit=fn,form="formatted",file=cosmo_file)
        if (dbug) then
          write(*,*) "printing cosmo charges for bq module",
     +     cosmo_file
        end if
c
        write(fn,*) nefc
        write(fn,*) "cosmo charges (= -Bq-charge) (coordinates in Angstr
     +om) format: Bq x y z q"
        do ief=1,nefc
           write(fn,*) 
     +      "Bq",
     +      efcc(1,ief)*bohr,
     +      efcc(2,ief)*bohr,
     +      efcc(3,ief)*bohr,
     +     -efcz(  ief)
        end do
        close(fn)
      end if
c
c MN solvation models -->
c
      if (do_cosmo_vem.ne.0.or.do_cosmo_smd) then
      ecos = pt5*(atmefc-elcefc)
      endif   
c
c save V_GS and Q_GS for VEM calculation
c
      call ga_sync()
c
      if (do_cosmo_vem.ne.0.and.istep_cosmo_vem.eq.0) then
       if(.not.rtdb_get(rtdb,'cosmo:g_vem',mt_int,3,g_vem)) then
        status = nga_create(mt_dbl, 1, nefc, 'V_GS', nefc, g_vem(1))
        status = nga_create(mt_dbl, 1, nefc, 'Q_GS', nefc, g_vem(2))
        status = nga_create(mt_dbl, 1, nefc, 'Q_neq', nefc, g_vem(3))
        if(.not.rtdb_put(rtdb,'cosmo:g_vem',mt_int,3,g_vem))
     $  call errquit('hnd_coschg: cannot put g_vem in rtdb',
     $  0,rtdb_err)
       endif
       call ga_zero(g_vem)
       call nga_put(g_vem(1), 1, nefc, x(i10),nefc)
       call ga_sync()
       call nga_put(g_vem(2), 1, nefc, efcz, nefc)
       call ga_sync()
      end if
c
c      save 1/2*V_gs*Q_gs for VEM calculation or for SMD output     
c
      if ((do_cosmo_vem.eq.0.and.do_cosmo_smd).or.
     $ (do_cosmo_vem.ne.0.and.istep_cosmo_vem.eq.0).or.
     $ (do_cosmo_vem.eq.2.and.istep_cosmo_vem.eq.3)) then
        gspol = zero
        do ief=1,nefc
         gspol = gspol + x(ief+i10-1) * efcz(ief) * pt5
        end do 
        if(.not.rtdb_put(rtdb,'cosmo:gspol',mt_dbl,1,gspol))
     $  call errquit('hnd_coschg: cannot put gspol in rtdb',
     $  0,rtdb_err)
      endif
c
c      save Gp_gs_neq and Gp_gs_dyn for VEM emission calculation  
c
      if (do_cosmo_vem.eq.2.and.istep_cosmo_vem.eq.3) then
        if(.not.rtdb_get(rtdb,
     $ 'cosmo:espol',mt_dbl,1,espol)) call errquit
     $ ('hnd_coschg: cannot get espol from rtdb',
     $ 0,rtdb_err)
        gspolneq = gspol - espol * dvem2       
        do ief=1,nefc
         gspolneq = gspolneq + x(ief+i10-1) * pt5 * dvem2 *
     $    x(k_efczfx+ief-1)
        end do
        if(.not.rtdb_put(rtdb,'cosmo:gspolneq',mt_dbl,1,gspolneq))
     $  call errquit('hnd_coschg: rtdb put failed for gspolneq',
     $  0,rtdb_err)
c
        gspoldyn = zero
        do ief=1,nefc
         gspoldyn = gspoldyn + pt5 * x(ief+i10-1) * 
     $ (efcz(ief) - dvem2 * x(k_efczfx+ief-1))
        end do
        if(.not.rtdb_put(rtdb,'cosmo:gspoldyn',mt_dbl,1,gspoldyn))
     $  call errquit('hnd_coschg: rtdb put failed for gspoldyn',
     $  0,rtdb_err)
      endif
c
      call ga_sync()
c
      if (do_cosmo_vem.ne.0.and.istep_cosmo_vem.eq.1) then
c
c      at this stage the excited-state cosmo charges should have been
c      calculated in tddft_grad_compute_g.F.
c
c      calculate noneq charges from current ES charges and saved GS charges
c
        if (do_cosmo_vem.eq.2) dvem1=one
        if (do_cosmo_vem.eq.2) dvem2=zero
        espolgsrf = zero
        espolin = zero
        espoldyn = zero
        delwvem = zero
       if(.not.rtdb_get(rtdb,'cosmo:g_vem',mt_int,3,g_vem))
     $  call errquit('hnd_coschg: cannot get g_vem from rtdb',
     $  0,rtdb_err)
        do ief=1,nefc
         call nga_get(g_vem(1), ief, ief, dvem3, 1)
         call nga_get(g_vem(2), ief, ief, dvem4, 1)
         espolgsrf=espolgsrf+(x(ief+i10-1)-pt5*dvem3)*dvem4
         espolin=espolin+(x(ief+i10-1)-pt5*dvem3)*dvem2*dvem4
         espoldyn=espoldyn+pt5*x(ief+i10-1)*dvem1*efcz(ief)
         delwvem=delwvem+pt5*(x(ief+i10-1)-dvem3)*
     $ (efcz(ief)-dvem4)*dvem1
         dvem5=dvem1*efcz(ief)+dvem2*dvem4
         x(k_efczfx+ief-1)=dvem5
        end do
c
        call ga_sync()
c
        if (.not. rtdb_get(rtdb, 'dft:gstote', mt_dbl, 1, gstote))
     $ call errquit('hnd_coschg: cannot get gstote from rtdb',
     $ 0,rtdb_err)
        if(.not.rtdb_get(rtdb,'cosmo:gspol',mt_dbl,1,gspol))
     $  call errquit('hnd_coschg: cannot get gspol from rtdb',
     $ 0,rtdb_err)
        if (.not.rtdb_get
     $ (rtdb,'tddft:wgsrf_cosmo_vem',mt_dbl,1,wgsrf_cosmo_vem))
     $  call errquit
     $('hnd_coschg: cannot get wgsrf_cosmo_vem from rtdb',
     $ 0,rtdb_err)
        if(.not.rtdb_get(rtdb,
     $ 'cosmo:wold_cosmo_vem',mt_dbl,1,wold_cosmo_vem)) 
     $ wold_cosmo_vem = zero
        status = rtdb_get
     $ (rtdb,'tddft:wstar_cosmo_vem',mt_dbl,1,wstar_cosmo_vem)
c
        espol=espolin+espoldyn
        wcgsrf_cosmo_vem=wgsrf_cosmo_vem+delwvem
        w_cosmo_vem=wstar_cosmo_vem-delwvem
c
        if (status) then
         estote=gstote+w_cosmo_vem
         if(.not.rtdb_put(rtdb,
     $ 'cosmo:estote',mt_dbl,1,estote)) call errquit
     $ ('hnd_coschg: cannot put estote in rtdb',
     $ 0,rtdb_err)
         if(.not.rtdb_put(rtdb,
     $ 'cosmo:espol',mt_dbl,1,espol)) call errquit
     $ ('hnd_coschg: cannot put espol in rtdb',
     $ 0,rtdb_err)
         if (dabs(w_cosmo_vem-wold_cosmo_vem).le.tolw) then
          istep_cosmo_vem = 3
         endif
        endif
c
        if(.not.rtdb_get(rtdb,
     $ 'cosmo:iter_cosmo_vem',mt_int,1,iter_cosmo_vem)) 
     $  iter_cosmo_vem = 0
        iter_cosmo_vem = iter_cosmo_vem + 1
        if(.not.rtdb_put(rtdb,
     $ 'cosmo:iter_cosmo_vem',mt_int,1,iter_cosmo_vem)) 
     $  call errquit
     $ ('hnd_coschg: cannot put iter_cosmo_vem in rtdb',
     $ 0,rtdb_err)
c
        wold_cosmo_vem = w_cosmo_vem
        if(.not.rtdb_put(rtdb,
     $ 'cosmo:wold_cosmo_vem',mt_dbl,1,wold_cosmo_vem)) call errquit
     $ ('hnd_coschg: cannot put wold_cosmo_vem in rtdb',
     $ 0,rtdb_err)
c
        if(ga_nodeid().eq.0) then
         if (.not.status) then
          write (luout,9960)
          write (luout,9961) iter_cosmo_vem
          write (luout,9962) gstote
          write (luout,9963) gspol,gspol*27.211399d0
          write (luout,9964) (gstote+wgsrf_cosmo_vem)
          write (luout,9965) espolgsrf,espolgsrf*27.211399d0
          write (luout,9966) wgsrf_cosmo_vem,wgsrf_cosmo_vem*27.211399d0
          write (luout,9967) (gstote+wcgsrf_cosmo_vem)
          write (luout,9968) espol,espol*27.211399d0
          write (luout,9969) espoldyn,espoldyn*27.211399d0
          write (luout,9970) delwvem,delwvem*27.211399d0
          write (luout,9971) 
     $ wcgsrf_cosmo_vem,wcgsrf_cosmo_vem*27.211399d0
         else 
          write (luout,9960)
          write (luout,9961) iter_cosmo_vem
          write (luout,9962) gstote
          write (luout,9963) gspol,gspol*27.211399d0
          write (luout,9964) (gstote+wgsrf_cosmo_vem)
          write (luout,9965) espolgsrf,espolgsrf*27.211399d0
          write (luout,9966) wgsrf_cosmo_vem,wgsrf_cosmo_vem*27.211399d0
          write (luout,9972) estote
          write (luout,9973) espol,espol*27.211399d0
          write (luout,9969) espoldyn,espoldyn*27.211399d0
          write (luout,9970) delwvem,delwvem*27.211399d0
          write (luout,9974)
     $ w_cosmo_vem,w_cosmo_vem*27.211399d0
         endif
        end if
c
c if do_cosmo_vem=1 g_vem(3)[Q_neq] contains nonequilibrium charges composed of
c slow GS charges and fast ES charges; if do_cosmo_vem=2 Q_neq contains
c full (equilibrium) ES charges 
c
       call ga_zero(g_vem(3))
       call nga_put(g_vem(3), 1, nefc, x(k_efczfx),nefc)
c
       call ga_sync()
c
        if (
     $ rtdb_get(rtdb,'cosmo:disp_cosmo_vem',mt_dbl,1,disp_cosmo_vem))
     $    then
          if(ga_nodeid().eq.0) write (luout,9975)
     $ disp_cosmo_vem,disp_cosmo_vem*27.211399d0
        endif
c
        if (iter_cosmo_vem.gt.8) then
          istep_cosmo_vem = 3
          if(ga_nodeid().eq.0) write (luout,9976)
        else
          if (istep_cosmo_vem.eq.3.and.
     $    ga_nodeid().eq.0) write (luout,9977)
        endif
c
      end if
c     end of print Vi and Qi for VEM calculation
c
      if (do_cosmo_vem.ne.0.and.(istep_cosmo_vem.eq.1.or.
     $ istep_cosmo_vem.eq.3)) then
c change istep_cosmo_vem from 1 (TDDFT) to 2 (SCF on fixed MOs)
       if (istep_cosmo_vem.eq.1) istep_cosmo_vem = 2
        if (.not.
     $ rtdb_put(rtdb,'cosmo:istep_cosmo_vem',mt_int,1,istep_cosmo_vem))
     $  call errquit('hnd_coschg: cannot put istep_cosmo_vem in rtdb',
     $ 0,rtdb_err)
      endif
c
c <-- MN solvation models
c
c     ----- release memory block -----
c
      if(.not.ma_chop_stack(l_i10)) call
     &  errquit('hnd_coschg, ma_pop_stack of init failed',911,MA_ERR)
c
      return
 9999 format(/,10x,15(1h-),
     1       /,10x,'-cosmo- charges',
     2       /,10x,15(1h-))
 9998 format(4x,'iefc',6x,'x',5x,6x,'y',5x,6x,'z',5x,5x,'q',4x,
     1     /,1x,53(1h-))
 9997 format(1x,i7,3f12.6,f10.6)
 9995 format(' -efcefc- energy = ',f20.12)
 9994 format(' -ecos  - energy = ',f20.12)
 9993 format(' ...... end of -coschg- ......')
 9992 format(' cosmo potential at -ief = ',i6,f16.10)
 9991 format(' -atmefc- energy = ',f20.12)
 9990 format(' -elcefc- energy = ',f20.12)
 9989 format(' -allefc- energy = ',f20.12,f20.12)
 9988 format(' -solnrg- energy = ',f20.12)
 9987 format(' -cosmo- charges convergence = ',f10.6)
 9986 format(' -wfntyp- = ',a8)
 9985 format(' -scftyp- = ',a8)
 9984 format(' applied screening factor -chgfac- = ',f10.6)
c
c MN solvation models -->
c
 9960 format(/,
     $'                          COSMO-VEM solvation results',/,
     $'                          ---------------------------',/
     $' Reference for the VEM model:',/,
     $' Marenich, A. V.; Cramer, C. J.; Truhlar, D. G.;',
     $' Guido, C. A.; Mennucci, B.;',/,' Scalmani, G.; Frisch, M. J.',
     $' Chem. Sci. 2011, 2, 2143',/)
 9961 format(1x,
     $'excitation spectrum data:  GS = initial state, ES = final state',
     $ /,1x,'iteration #',I1)
 9962 format(1x,
     $'(1)          GS equilibrium total free energy = ',
     $ f20.10)
 9963 format(1x,
     $'(2)               GS polarization free energy = ',
     $ f20.10,' (',f10.4,' eV)')
 9964 format(1x,
     $'(3)                 GSRF ES total free energy = ',
     $ f20.10)
 9965 format(1x,
     $'(4)          GSRF ES polarization free energy = ',
     $ f20.10,' (',f10.4,' eV)')
 9966 format(1x,
     $'(5)          GSRF excitation energy (3) - (1) = ',
     $ f20.10,' (',f10.4,' eV)')
 9967 format(1x,
     $'(6)                cGSRF ES total free energy = ',
     $ f20.10)
 9968 format(1x,
     $'(7)         cGSRF ES polarization free energy = ',
     $ f20.10,' (',f10.4,' eV)')
 9969 format(1x,
     $'(8)        fast polarization component of (7) = ',
     $ f20.10,' (',f10.4,' eV)')
 9970 format(1x,
     $'(9)                 1/2 * delV * delQdyn term = ',
     $ f20.10,' (',f10.4,' eV)')
 9971 format(1x,
     $'(10)        cGSRF excitation energy (6) - (1) = ',
     $ f20.10,' (',f10.4,' eV)')
 9972 format(1x,
     $'(6)                  VEM ES total free energy = ',
     $ f20.10)
 9973 format(1x,
     $'(7)           VEM ES polarization free energy = ',
     $ f20.10,' (',f10.4,' eV)')
 9974 format(1x,
     $'(10) VEM vertical excitation energy (6) - (1) = ',
     $ f20.10,' (',f10.4,' eV)')
 9975 format(1x,
     $'(11)    SMSSP solute-solvent dispersion shift = ',
     $ f20.10,' (',f10.4,' eV)')
 9976 format(/,1x,
     $ 'Number of VEM iterations has reached maximum of 9')
 9977 format(/,1x,
     $ 'VEM vertical excitation energy converged')
c
c <-- MN solvation models
c
      end
C>
C> \brief Compute matrix A
C> 
C> Compute matrix `A` as needed for the in-memory COSMO
C> charge fitting.
C>
      subroutine hnd_cosmata(nat,nefc,efcc,efcs,efciat,ratm,a)
      implicit none
      integer          nat  !< [Input] The number of atoms
      integer          nefc !< [Input] The number of surface charges
      double precision efcc(3,nefc) !< [Input] The surface charge coords
      double precision efcs(nefc)   !< [Input] The surface areas
      integer          efciat(nat)  !< [Input] The atom of a surface 
                                    !< charge
      double precision ratm(nat)    !< [Input] The atom radii
      double precision a(nefc,nefc) !< [Output] Matrix `A`
c
      integer jef, ief
      double precision aii, xi, xj, yi, yj, zi, zj, dij, one
      double precision zetai, zetaj, zetaij
      parameter (one = 1.0d0)
c
      double precision dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      double precision adiag,dsurf,dvol,srfmol,volmol,ptspatm
      common/hnd_cospar/dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      common/hnd_cosdat/adiag,dsurf,dvol,srfmol,volmol,ptspatm
c
      double precision util_erf
      external util_erf
c
      double precision pi
      pi = acos(-1.0d0)
c
      do jef=1,nefc
         zetaj=zeta*sqrt(ptspatm)/(ratm(efciat(jef))*sqrt(2.0d0*pi))
         xj=efcc(1,jef)
         yj=efcc(2,jef)
         zj=efcc(3,jef)
         do ief=1,nefc
            if(ief.eq.jef) then
               aii=efcs(ief)
               a(ief,jef)=aii
            else
               zetai=zeta*sqrt(ptspatm) /
     &               (ratm(efciat(ief))*sqrt(2.0d0*pi))
               zetaij=zetai*zetaj/sqrt(zetai**2+zetaj**2)
               xi=efcc(1,ief)
               yi=efcc(2,ief)
               zi=efcc(3,ief)
               dij=sqrt((xi-xj)**2+(yi-yj)**2+(zi-zj)**2)
               if (dij.lt.1.0d-6) then
                 a(ief,jef)=2.0d0*zetaij*sqrt(1.0d0/pi)
               else
                 a(ief,jef)=util_erf(zetaij*dij)/dij
               endif
            endif
         enddo
      enddo
c
      end
C>
C> \brief On the fly matrix-vector multiplication
C>
C> This routine multiplies the COSMO matrix with the current guess
C> for the charge vector using a dot-product based algorithm. The matrix
C> is generated on the fly. For performance reasons the routine is
C> replicated data parallel.
C>
      subroutine hnd_cosaxd(nat,x,ax,nefc,efcc,efcs,efciat,ratm)
      implicit none
#include "global.fh"
#include "msgids.fh"
c
      integer          nat  !< [Input] The number of atoms
      integer          nefc !< [Input] The number of surface charges
      double precision efcc(3,nefc) !< [Input] The surface charge coords
      double precision efcs(nefc)   !< [Input] The surface areas
      integer          efciat(nefc) !< [Input] The atom of a surface 
                                    !< charge
      double precision ratm(nat)    !< [Input] The atom radii
      double precision x(nefc)      !< [Input] Vector `x`
      double precision ax(nefc)     !< [Output] Matrix-vector product
                                    !< `Ax`
c
      double precision zetai, zetaj, zetaij, pi, aij, dij, dum, xj
      double precision zero, one
      parameter (zero=0.0d+00, one=1.0d+00)
c
      double precision dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      double precision adiag,dsurf,dvol,srfmol,volmol,ptspatm
      common/hnd_cospar/dielec,dielecinf,screen,rsolv,zeta,gammas,swtol
      common/hnd_cosdat/adiag,dsurf,dvol,srfmol,volmol,ptspatm
c
      double precision util_erf
      external util_erf
c
c     Introduced a trivial replicated data parallelization of this
c     matrix-vector multiplication
c
      double precision r
      integer i, j
      r (i,j)=sqrt((efcc(1,i)-efcc(1,j))**2+
     1             (efcc(2,i)-efcc(2,j))**2+
     2             (efcc(3,i)-efcc(3,j))**2)
c     d (i  )=adiag/sqrt(efcs(i))
c
      pi=acos(-1.0d0)
      call dfill(nefc,0.0d0,ax,1)
      do i=ga_nodeid()+1,nefc,ga_nnodes()
         zetai=zeta*sqrt(ptspatm) /
     &         (ratm(efciat(i))*sqrt(2.0d0*pi))
         dum=zero
         do j=1,nefc
            if(j.eq.i) then
               aij=efcs(i)
            else
               zetaj=zeta*sqrt(ptspatm) /
     &               (ratm(efciat(j))*sqrt(2.0d0*pi))
               zetaij=zetai*zetaj/sqrt(zetai**2+zetaj**2)
               dij=r(i,j)
               if (dij.lt.1.0d-6) then
                 aij=2.0d0*zetaij*sqrt(1.0d0/pi)
               else
                 aij=util_erf(zetaij*dij)/dij
               endif
            endif
            xj=x(j)
            dum=dum+aij*xj
         enddo
         ax(i)=dum
      enddo
      call ga_dgop(msg_cosaxd,ax,nefc,'+')
c
      return
      end
C>
C> \brief On the fly vector-matrix multiplication
C>
C> This routine multiplies the current guess for the COSMO charges
C> with the matrix. The routine is replicated data parallel.
C> The matrix `A` is symmetric so we simply call the matrix-vector
C> product.
C>
      subroutine hnd_cosxad(nat,x,xa,nefc,efcc,efcs,efciat,ratm)
      implicit none
      integer          nat  !< [Input] The number of atoms
      integer          nefc !< [Input] The number of surface charges
      double precision efcc(3,nefc) !< [Input] The surface charge coords
      double precision efcs(nefc)   !< [Input] The surface areas
      integer          efciat(nefc) !< [Input] The atom of a surface 
                                    !< charge
      double precision ratm(nat)    !< [Input] The atom radii
      double precision x(nefc)      !< [Input] Vector `x`
      double precision xa(nefc)     !< [Output] Vector-matrix product
                                    !< `xA`
c
      call hnd_cosaxd(nat,x,xa,nefc,efcc,efcs,efciat,ratm)
c
      return
      end
C>
C> \brief Solve a linear system of equations using an iterative
C> procedure
C>
C> This routine solves a linear system of equations \f$A\cdot x = b\f$
C> using an iterative procedure based on [1] page 70.
C>
C> ### References ###
C>
C> [1] W.H. Press, B.P. Flannery, S.A. Teukolsky, W.T. Vetterling,
C>     "Numerical Recipes: in Fortran 77", 2nd edition, Volume 1, 
C>     Cambridge University Press, 1992, ISBN: 0-521-43064-X,
C>     <a href="http://apps.nrbook.com/fortran/index.html">nrbook</a>.
C>
C> [2]  A. Klamt, G. Sch&uuml;&uuml;rmann,
C>     "COSMO: a new approach to dielectric screening in solvents with
C>      explicit expressions for the screening energy and its gradient",
C>     <i>J. Chem. Soc., Perkin Trans. 2</i>, 1993, pp 799-805, DOI:
C>     <a href="http://dx.doi.org/10.1039/P29930000799">
C>     10.1039/P29930000799</a>.
C>
      subroutine hnd_cosequ(nat,b,x,nefc,g,h,xi,xj,efcc,efcs,efciat,
     &                      ratm)
      implicit none
c
c     ----- solve a * x = b , using an iterative procedure       -----
c
c     ----- numerical recipes (p.70), cambridge university press -----
c          w.h.press, b.p.flannery, s.a.teukolsky, w.t.vetterling
c
#include "errquit.fh"
#include "stdio.fh"
#include "global.fh"
c
      logical     dbug
      integer          nat  !< [Input] The number of atoms
      integer          nefc !< [Input] The number of surface charges
      double precision efcc(3,nefc) !< [Input] The surface charge coords
      double precision efcs(nefc)   !< [Input] The surface areas
      integer          efciat(nefc) !< [Input] The atom of a surface 
                                    !< charge
      double precision ratm(nat)    !< [Input] The atom radii
      double precision b(nefc)      !< [Input] The RHS of Ax=b
      double precision x(nefc)      !< [Output] The solution of Ax=b
c
      double precision g(nefc) !< [Scratch]
      double precision h(nefc) !< [Scratch]
      double precision xi(nefc) !< [Scratch]
      double precision xj(nefc) !< [Scratch]
c
      double precision rp, bsq, anum, aden, rsq, gg, dgg, gam
      double precision zero, eps, eps2
      data zero   /0.0d+00/
      data eps    /1.0d-07/
c
      integer i, j, irst, iter
c
      dbug=.false.
      if(dbug) then
         write(luout,*) 'in -cosequ-'
         do i=1,nefc
            write(luout,9999) i,b(i)
         enddo
      endif
c
      eps2=nefc*eps*eps
      irst=0
   10 irst=irst+1
      call hnd_cosaxd(nat,x,xi,nefc,efcc,efcs,efciat,ratm)
      rp=zero
      bsq=zero
      do j=1,nefc
         bsq=bsq+b(j)*b(j)
         xi(j)=xi(j)-b(j)
         rp=rp+xi(j)*xi(j)
      enddo ! j
      call hnd_cosxad(nat,xi,g,nefc,efcc,efcs,efciat,ratm)
      do j=1,nefc
         g(j)=-g(j)
         h(j)= g(j)
      enddo ! j
      do iter=1,10*nefc
         call hnd_cosaxd(nat,h,xi,nefc,efcc,efcs,efciat,ratm)
         anum=zero
         aden=zero
         do j=1,nefc
            anum=anum+g(j)*h(j)
            aden=aden+xi(j)*xi(j)
         enddo ! j
         if(aden.eq.zero) then
            write(luout,*) 'very singular matrix'
            call errquit('hnd_cosequ: singular matrix',911,UERR)
         endif
         anum=anum/aden
         do j=1,nefc
            xi(j)=x(j)
            x(j)=x(j)+anum*h(j)
         enddo ! j
         call hnd_cosaxd(nat,x,xj,nefc,efcc,efcs,efciat,ratm)
         rsq=zero
         do j=1,nefc
            xj(j)=xj(j)-b(j)
            rsq=rsq+xj(j)*xj(j)
         enddo ! j
         if (iter.gt.10*nefc-min(10,nefc/10)) then
           if (ga_nodeid().eq.0) then
             write(luout,'(" hnd_cosequ: it,residue,thresh = ",
     &                     i5,2f12.5)')iter,rsq,bsq*eps2
           endif
         endif
         if(rsq.eq.rp.or.rsq.le.bsq*eps2) return
         if(rsq.gt.rp) then
            do j=1,nefc
               x(j)=xi(j)
            enddo ! j
            if(irst.ge.3) return
            go to 10
         endif
         rp=rsq
         call hnd_cosxad(nat,xj,xi,nefc,efcc,efcs,efciat,ratm)
         gg=zero
         dgg=zero
         do j=1,nefc
            gg=gg+g(j)*g(j)
            dgg=dgg+(xi(j)+g(j))*xi(j)
         enddo ! j
         if(gg.eq.zero) return
         gam=dgg/gg
         do j=1,nefc
            g(j)=-xi(j)
            h(j)=g(j)+gam*h(j)
         enddo ! j
      enddo ! iter
      write(luout,*) 'too many iterations'
      call errquit('hnd_cosequ: too many iters',911,UERR)
      return
 9999 format(i8,f16.8)
      end
C>
C> \brief Direct linear system solver
C>
C> This is direct linear system solver. On return the matrix A has been
C> destroyed.
C>
      subroutine hnd_linequ(a,lda,b,n,ib,t,deta,ierr,nodcmp)
      implicit real*8 (a-h,o-z)
      dimension a(lda,1),b(n),ib(n),t(n)
c
c     ----- solve a * x = b , with x returned in b -----
c
      if(nodcmp.ne.1) go to 20
c
      call hnd_ludcmp(a,lda,n,ib,t,deta,ierr)
      do 10 j=1,n
   10 deta=deta*a(j,j)
c
   20 continue
      call hnd_lubksb(a,lda,n,ib,b)
c
      return
      end
c
      subroutine hnd_lubksb(a,lda,n,ib,b)
      implicit real*8 (a-h,o-z)
c
      dimension a(lda,1),ib(n),b(n)
      data zero /0.0d+00/
c
      ii=0
      do 12 i=1,n
         ll=ib(i)
         sum=b(ll)
         b(ll)=b(i)
         if(ii.ne.0) then
            do 11 j=ii,i-1
               sum=sum-a(i,j)*b(j)
   11       continue
         else if (sum.ne.zero) then
            ii=i
         endif
         b(i)=sum
   12 continue
      do 14 i=n,1,-1
         sum=b(i)
         if(i.lt.n) then
            do 13 j=i+1,n
               sum=sum-a(i,j)*b(j)
   13       continue
         endif
         b(i)=sum/a(i,i)
   14 continue
      return
      end
c
      subroutine hnd_ludcmp(a,lda,n,ib,vv,d,ierr)
      implicit real*8 (a-h,o-z)
c
      dimension a(lda,1),ib(n),vv(n)
      data tiny     /1.0d-20/
      data zero,one /0.0d+00,1.0d+00/
c
      ierr=0
      d=one
      do 12 i=1,n
         aamax=zero
         do 11 j=1,n
            if( abs(a(i,j)).gt.aamax) aamax= abs(a(i,j))
   11    continue
         if(aamax.eq.zero) then
            ierr=1
            return
         endif
         vv(i)=one/aamax
   12 continue
      do 19 j=1,n
         if(j.gt.1) then
            do 14 i=1,j-1
               sum=a(i,j)
               if(i.gt.1) then
                  do 13 k=1,i-1
                     sum=sum-a(i,k)*a(k,j)
   13             continue
                  a(i,j)=sum
               endif
   14       continue
         endif
         aamax=zero
         imax=0
         do 16 i=j,n
            sum=a(i,j)
            if(j.gt.1) then
               do 15 k=1,j-1
                  sum=sum-a(i,k)*a(k,j)
   15          continue
               a(i,j)=sum
            endif
            dum=vv(i)* abs(sum)
            if(dum.ge.aamax) then
               imax=i
               aamax=dum
            endif
   16    continue
         if(j.ne.imax) then
            do 17 k=1,n
               dum=a(imax,k)
               a(imax,k)=a(j,k)
               a(j,k)=dum
   17       continue
            d=-d
            vv(imax)=vv(j)
         endif
         ib(j)=imax
         if(j.ne.n) then
            if(a(j,j).eq.zero) a(j,j)=tiny
            dum=one/a(j,j)
            do 18 i=j+1,n
               a(i,j)=a(i,j)*dum
   18       continue
         endif
   19 continue
      if(a(n,n).eq.zero) a(n,n)=tiny
      return
      end
C>
C> \brief Compute the function \f$f(r)\f$
C>
C> Computes the function \f$f(r)\f$ as discussed with function
C> `hnd_coschg`. This function is Eq.(64) in [1].
C>
C> ### References ###
C>
C> [1] D.M. York, M. Karplus,
C>     "A smooth solvation potential based on the conductor-like
C>      screening model", <i>J. Phys. Chem. A</i> (1999) <b>103</b>,
C>     pp 11060-11079, DOI:
C>     <a href="http://dx.doi.org/10.1021/jp992097l">
C>     10.1021/jp992097l</a>.
C>
      double precision function cosff(r)
      implicit none
#include "errquit.fh"
      double precision r !< [Input] penetration fraction
c
      if (r.lt.0.0d0) then
        cosff = 0.0d0
      else if (r.gt.1.0d0) then
        cosff = 1.0d0
      else
        cosff = r**3*(10.0d0-15.0d0*r+6.0d0*r**2)
      endif
c
      return
      end
C>
C> \brief Compute the function \f$\frac{\partial f(r)}{\partial r}\f$
C>
C> Computes the function \f$\frac{\partial f(r)}{\partial r}\f$ as
C> discussed with function `hnd_coschg`. This function is the 
C> derivative of Eq.(64) in [1].
C>
C> ### References ###
C>
C> [1] D.M. York, M. Karplus,
C>     "A smooth solvation potential based on the conductor-like
C>      screening model", <i>J. Phys. Chem. A</i> (1999) <b>103</b>,
C>     pp 11060-11079, DOI:
C>     <a href="http://dx.doi.org/10.1021/jp992097l">
C>     10.1021/jp992097l</a>.
C>
      double precision function cosdff(r)
      implicit none
#include "errquit.fh"
      double precision r !< [Input] penetration fraction
c
      if (r.lt.0.0d0) then
        cosdff = 0.0d0
      else if (r.gt.1.0d0) then
        cosdff = 0.0d0
      else
        cosdff = 30.0d0*(r**2)*((1.0d0-r)**2)
      endif
c
      return
      end
c $Id: hnd_cosmo_lib.F 25742 2014-06-08 07:38:13Z d3y133 $

      subroutine argos_space_lbbl_ind(lbbl,ipl,jpl)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
c
      integer lbbl(mbbl,mbb2),ipl(mbox,mip2),jpl(mbox,mip2)
c
      integer ibbl,jproc,jcell,icell,jcproc,jccell,iccell
      integer i,j,indx,jndx,il,ih,jl,jh,indexw,indexs,nndexw,nndexs
      character*80 string
c
      jcproc=-1
      jccell=-1
      iccell=-1
      indexw=nwmloc+1
      indexs=nsaloc+1
      nndexw=indexw
      nndexs=indexs
c
c      if(iand(idebug,16).eq.16) then
c      write(lfndbg,3000) ((lbbl(ibbl,i),i=1,3),ibbl=1,nbbl)
c 3000 format(3i5)
c      endif
      do 1 ibbl=1,nbbl
c
      jproc=lbbl(ibbl,1)
      jcell=lbbl(ibbl,2)
      icell=lbbl(ibbl,3)
      lbbl(ibbl, 5)=0
      lbbl(ibbl, 6)=0
      if(iand(idebug,16).eq.16) then
      write(lfndbg,222) ibbl,nbbl,jproc,jcell,icell,jccell,iccell
  222 format(7i5)
      endif
      do 234 j=1,3
  234 continue
c
c     get indices for icell on the local node
c
      if(iccell.ne.icell) then
      indx=0
      do 2 i=1,ipl(1,1)
      if(ipl(30+i,1).eq.icell) indx=30+i
    2 continue
      if(indx.eq.0) then
      do 232 j=1,3
  232 continue
      write(*,1000) me,(ipl(30+i,1),i=1,ipl(1,1))
 1000 format(/,'Cells on proc',i5,' :',t20,20i5,/,(t20,20i5))
      write(string,1001) icell,me
 1001 format('SP0001: Could not find icell',i5,' on proc',i5)
      call md_abort(string,0)
      endif
      iccell=icell
      endif
      lbbl(ibbl, 7)=ipl(indx,2)
      lbbl(ibbl, 8)=ipl(indx,3)
      lbbl(ibbl, 9)=ipl(indx,4)
      lbbl(ibbl,10)=ipl(indx,5)
c
c     get indices for jcell if on the local node
c
      if(jproc.eq.me) then
c
      if(jccell.ne.jcell) then
      jndx=0
      do 3 i=1,ipl(1,1)
      if(ipl(30+i,1).eq.jcell) jndx=30+i
    3 continue
      if(jndx.eq.0) then
      write(*,1000) me,(ipl(30+i,1),i=1,ipl(1,1))
      write(string,1002) jcell,me
 1002 format('SP0001: Could not find jcell',i5,' on proc',i5)
      call md_abort(string,0)
      endif
      jccell=jcell
      endif
      lbbl(ibbl,11)=ipl(jndx,2)
      lbbl(ibbl,12)=ipl(jndx,3)
      lbbl(ibbl,13)=ipl(jndx,4)
      lbbl(ibbl,14)=ipl(jndx,5)
c
c     get indices for jcell if on the remote node
c
      else
c
      if(jproc.ne.jcproc) then
      call ga_distribution(ga_ip,jproc,il,ih,jl,jh)
      call ga_get(ga_ip,il,ih,jl,jh,jpl,mbox)
      jcproc=jproc
      endif
c
      if(jcell.ne.jccell) then
      jndx=0
      do 4 i=1,jpl(1,1)
      if(jpl(30+i,1).eq.jcell) jndx=30+i
    4 continue
      if(jndx.eq.0) then
      if(iand(idebug,16).eq.16) then
      write(lfndbg,1003) jcell,jproc
 1003 format('Could not find cell',i5,' on proc',i5,
     + ' in argos_space_lbbl')
      write(lfndbg,1004) jproc,(jpl(30+i,1),i=1,jpl(1,1))
 1004 format('Cell list obtained from proc',i5,' is',/,(20i5))
      call util_flush(lfndbg)
      endif
c
      write(*,1005) jproc,(jpl(30+i,1),i=1,jpl(1,1))
 1005 format(/,'Cells on proc',i5,':',t20,20i5,/,(t20,20i5))
      write(string,1006) jcell,jproc
 1006 format('SP0002: Could not find remote jcell',i5,' on proc',i5)
      call md_abort(string,me)
      endif
      jccell=jcell
c
      if(nbget.ne.0) then
      indexw=nndexw
      indexs=nndexs
      if(jpl(jndx,2).gt.0) nndexw=indexw+jpl(jndx,3)-jpl(jndx,2)+1
      if(jpl(jndx,4).gt.0) nndexs=indexs+jpl(jndx,5)-jpl(jndx,4)+1
      endif
c
      endif
c
      lbbl(ibbl, 5)=indexw
      lbbl(ibbl, 6)=indexs
      lbbl(ibbl,11)=jpl(jndx,2)
      lbbl(ibbl,12)=jpl(jndx,3)
      lbbl(ibbl,13)=jpl(jndx,4)
      lbbl(ibbl,14)=jpl(jndx,5)
c
      endif
c
    1 continue
c
      if(nndexw.gt.mwm) then
      write(string,1007) mwm,nndexw
 1007 format('Increase dimension mwm from ',i7,' to ',i7)
      call md_abort(string,me)
      endif
      if(nndexs.gt.msa) then
      write(string,1008) msa,nndexs
 1008 format('Increase dimension msa from ',i7,' to ',i7)
      call md_abort(string,me)
      endif
c
      return
      end
c $Id: argos_space_lbbl_ind.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup selci
C> @{
C>
      subroutine selci_renorm(n,a,ia,anorm)
*
* $Id: selci_renorm.f 24780 2013-11-07 21:23:59Z d3y133 $
*
      implicit double precision (a-h,o-z)
      dimension a(*)
c
      aa = 0.0d0
      do 10 i = 1,1+(n-1)*ia,ia
         aa = aa + a(i)*a(i)
 10   continue
      anorm = sqrt(aa)
      if (anorm.ne.0.0d0) then
        scale = 1.0d0 / anorm
        do 20 i = 1,1+(n-1)*ia,ia
           a(i) = scale * a(i)
 20     continue
      endif
c
      end
C>
C> @}

      subroutine int_pxvp_ga(ibas, g_x, g_y, g_z, oskel)
*
* $Id: int_pxvp_ga.F 19696 2010-10-29 16:53:42Z d3y133 $
*
c
c     Gather pxVp integrals from int_1epxvpe on a shell by shell basis
c     and put them per component in a GA.
c
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "inp.fh"
#include "bas.fh"
#include "cscfps.fh"
#include "sym.fh"
#include "util.fh"
#include "errquit.fh"
c
c     arguments
c
      integer ibas
      integer g_x, g_y, g_z
      logical oskel
c
c     local variables
c
      integer nshell_i, idim
      integer ishell, jshell, iproc, nproc, mem1, max1e
      integer ijshell, ilo, ihi, jlo, jhi
      integer l_buf, l_scr
      integer k_buf, k_scr
      logical odoit
      double precision q2
c
      call ga_sync()
      call ga_zero(g_x)
      call ga_zero(g_y)
      call ga_zero(g_z)
c     if(oscfps) call pstat_on(ps_int_pxvp)
c
c     grab basis set info type stuff
c
      if(.not.bas_numcont(ibas,nshell_i))call errquit
     $  ('int_dip_ga: bas_numcont failed for ibas',ibas, BASIS_ERR)
c
c      Allocate temporary arrays
c
      call int_mem_1e(max1e, mem1)
c     call emem_1e_pvp(ibas, ibas, max1e, mem1, 3)
      if (.not. MA_push_get(MT_DBL,max1e*3,'int_pxvp_ga:buf',l_buf,
     $    k_buf)) call errquit('int_pxvp_ga: ma failed', max1e, MA_ERR)
      if (.not. MA_push_get(MT_DBL, mem1,'int_pxvp_ga:scr',l_scr,k_scr))
     $     call errquit('int_pxvp_ga: ma failed', mem1, MA_ERR)
c      
c     loop over shells
c
      iproc = ga_nodeid()
      nproc = ga_nnodes()
      ijshell = 0
      q2 = 1.0d0
      do jshell = 1,nshell_i
         do ishell = 1,nshell_i
            if(mod(ijshell, nproc) .eq. iproc) then
               odoit = .true.
               if (oskel)
     $              odoit = sym_shell_pair(ibas, ishell, jshell, q2)
               if (odoit) then
                  if (.not. bas_cn2bfr(ibas, ishell, ilo, ihi))
     $                 call errquit('int_1e_ga: bas_cn2bfr ?', ibas,
     &       GA_ERR)
                  if (.not. bas_cn2bfr(ibas, jshell, jlo, jhi))
     $                 call errquit('int_1e_ga: bas_cn2bfr ?', ibas,
     &       BASIS_ERR)
                  idim = ihi - ilo + 1
c
c     Generate the integrals
c
                  call int_1epxvpe (ibas, jshell, ibas, ishell,
     $                    mem1, dbl_mb(k_scr), max1e, dbl_mb(k_buf))
c
c     Add integrals into the global arrays
c
                  call ga_acc(g_z, ilo, ihi, jlo, jhi, 
     $                        dbl_mb(k_buf), idim, q2)
                  call ga_acc(g_y, ilo, ihi, jlo, jhi, 
     $                        dbl_mb(k_buf+max1e), idim, q2)
                  call ga_acc(g_x, ilo, ihi, jlo, jhi, 
     $                        dbl_mb(k_buf+(max1e*2)), idim, q2)
               endif
            endif
            ijshell = ijshell + 1
         enddo
      enddo
      call ga_sync()
c
      if(.not.MA_pop_stack(l_scr))
     $   call errquit('int_pxvp_ga:pop failed',0, GA_ERR)
      if(.not.MA_pop_stack(l_buf)) 
     $   call errquit('int_pxvp_ga:pop failed',0, GA_ERR)
c
      call ga_sync()
c
c     if(oscfps) call pstat_off(ps_int_pxvp)
c
      end          

c
c $Id: com_motion.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE com_motion()

      implicit none

      include 'p_input.inc'
      include 'p_array.inc'
      include 'cm_atom.inc'

      integer i,iatm

      real*8 commass,comxvv,comyvv,comzvv

      comxvv=0.d0
      comyvv=0.d0
      comzvv=0.d0
      commass=0.d0

      do i=1,natms

       iatm=atmtype(i)
       comxvv=comxvv+vvv(i,1)*typmass(iatm)
       comyvv=comyvv+vvv(i,2)*typmass(iatm)
       comzvv=comzvv+vvv(i,3)*typmass(iatm)
       commass=commass+typmass(iatm)

      enddo

      comxvv=comxvv/commass
      comyvv=comyvv/commass
      comzvv=comzvv/commass

      do i=1,natms

       vvv(i,1)=vvv(i,1)-comxvv
       vvv(i,2)=vvv(i,2)-comyvv
       vvv(i,3)=vvv(i,3)-comzvv

      enddo

      return

      END

      subroutine swrite(itape,a,n)
#include "errquit.fh"
*
* $Id: swrite.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      double precision a(n)
      parameter (lenbuf = 524287) ! 4*1024*1024/8 - 1
c
      if (n.le.0) return
      left = n
      nbuf = (n-1)/lenbuf + 1
      do 10 ibuf = 1,nbuf
        m = min(lenbuf, left)
        call sswrit(itape, a(1 + (ibuf-1)*lenbuf), m)
        left = left - m
10    continue
      if (left.ne.0) call errquit('swrite: left .ne. 0',left, DISK_ERR)
c
      end
      subroutine sswrit(itape,a,n)
      double precision a(n)
c
      write(itape,err=20) a
      return
 20   call errquit('sswrit: error writing to unit ', itape, DISK_ERR)
c
      end

#define NBLOCKS 4


*
*     ***********************************
*     *					*
*     *	        D1dB_SumAll		*	
*     *					*
*     ***********************************

      subroutine D1dB_SumAll(sum)
c     implicit none
      real*8  sum

#include "D1dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


      integer msglen,mpierr,np
      real*8  sumall


*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j
    
      call Parallel2d_np_j(np)
      if (np.gt.1) then
#ifdef MPI4
        stupid_msglen = 1
        call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                     stupid_sum,stupid_comm_j,stupid_ierr)
#else
        msglen = 1
        call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                      MPI_SUM,Parallel2d_comm_j(),mpierr)
#endif
        sum = sumall
      end if

      return
      end


*     ***********************************
*     *					*
*     *	        D1dB_ISumAll		*	
*     *					*
*     ***********************************

      subroutine D1dB_ISumAll(sum)
c     implicit none
      integer  sum


#include "D1dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


      integer msglen,mpierr,np
      integer sumall

*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j

      call Parallel2d_np_j(np)
      if (np.gt.1) then
#ifdef MPI4
        stupid_msglen = 1
        stupid_tsum = sum
        call MPI_Allreduce(stupid_tsum,stupid_tsum2,stupid_msglen,
     >                     stupid_integer,
     >                     stupid_sum,stupid_comm_j,stupid_ierr)
        sum = stupid_tsum2
#else
        msglen = 1
        call MPI_Allreduce(sum,sumall,msglen,MPI_INTEGER,
     >                       MPI_SUM,Parallel2d_comm_j(),mpierr)
        sum = sumall
#endif
      end if

      return
      end


*     ***********************************
*     *                                 *
*     *         D1dB_MaxAll             *
*     *                                 *
*     ***********************************
      subroutine D1dB_MaxAll(sum)
c     implicit none
      real*8  sum

#include "D1dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


      integer msglen,mpierr,np
      real*8  sumall

*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j

      call Parallel2d_np_j(np)
      if (np.gt.1) then
#ifdef MPI4
        stupid_msglen = 1
        call MPI_Allreduce(sum,sumall,stupid_msglen,stupid_double,
     >                      stupid_max,stupid_comm_j,stupid_ierr)
#else
        msglen = 1
        call MPI_Allreduce(sum,sumall,msglen,MPI_DOUBLE_PRECISION,
     >                      MPI_MAX,Parallel2d_comm_j(),mpierr)
#endif
        sum = sumall
      end if

      return
      end


*     ***********************************
*     *                                 *
*     *         D1dB_iMaxAll            *
*     *                                 *
*     ***********************************
      subroutine D1dB_iMaxAll(isum)
c     implicit none
      integer  isum

#include "D1dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


      integer msglen,mpierr,np
      integer isumall,iisum

*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j

      call Parallel2d_np_j(np)
      if (np.gt.1) then
#ifdef MPI4
        stupid_msglen = 1
        call stupid_icopy8to4(1,isum,iisum)
        call MPI_Allreduce(iisum,isumall,stupid_msglen,stupid_integer,
     >                      stupid_max,stupid_comm_j,stupid_ierr)
        call stupid_icopy4to8(1,isumall,isum)
#else
        msglen = 1
        call MPI_Allreduce(isum,isumall,msglen,MPI_INTEGER,
     >                      MPI_MAX,Parallel2d_comm_j(),mpierr)
        isum = isumall
#endif
      end if

      return
      end





*     ***********************************
*     *					*
*     *	        D1dB_Vector_SumAll	*	
*     *					*
*     ***********************************

      subroutine D1dB_Vector_SumAll(n,sum)
c     implicit none
      integer n
      real*8  sum(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "D1dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

      logical value
      integer msglen
      integer sumall(2),np,mpierr

*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j

      call Parallel2d_np_j(np)
      call nwpw_timing_start(2)
      if (np.gt.1) then

*     ***** allocate temporary space ****
      value = MA_push_get(mt_dbl,n,'sumall',sumall(2),sumall(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

#ifdef MPI4
      stupid_msglen = n
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),stupid_msglen,
     >                stupid_double,
     >                stupid_sum,stupid_comm_j,stupid_ierr)
#else
      msglen = n
      call MPI_Allreduce(sum,dbl_mb(sumall(1)),msglen,
     >                MPI_DOUBLE_PRECISION,
     >                MPI_SUM,Parallel2d_comm_j(),mpierr)
#endif

      call dcopy(n,dbl_mb(sumall(1)),1,sum,1)
      value = MA_pop_stack(sumall(2))

      end if
      call nwpw_timing_end(2)
      return
      end


*     ***********************************
*     *					*
*     *	        D1dB_Vector_ISumAll	*	
*     *					*
*     ***********************************

      subroutine D1dB_Vector_ISumAll(n,sum)
c     implicit none
      integer n
      integer  sum(*)


#include "mafdecls.fh"
#include "errquit.fh"
#include "D1dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


      logical value
      integer msglen,sumall(2),sumall1(2),mpierr,np

*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j

      call Parallel2d_np_j(np)
      call nwpw_timing_start(2)
      if (np.gt.1) then

*       ***** allocate temporary space ****
        value = MA_push_get(mt_int,n,'sumall',sumall(2),sumall(1))
        if (.not. value) call errquit('out of stack memory',0, MA_ERR)


#ifdef MPI4
        if (.not.MA_push_get(mt_int,n,'sumall1',sumall1(2),sumall1(1)))
     >     call errquit('out of stack memory',0, MA_ERR)
        stupid_msglen = n
        call stupid_icopy8to4(n,sum,int_mb(sumall1(1)))
        call MPI_Allreduce(int_mb(sumall1(1)),
     >                     int_mb(sumall(1)),stupid_msglen,
     >                stupid_integer,
     >                stupid_sum,stupid_comm_j,stupid_ierr)
      call stupid_icopy4to8(n,int_mb(sumall(1)),sum)
      if (.not.MA_pop_stack(sumall1(2)))
     > call errquit('error popping stack',0, MA_ERR)
#else
        msglen = n
        call MPI_Allreduce(sum,int_mb(sumall(1)),msglen,
     >                MPI_INTEGER,
     >                MPI_SUM,Parallel2d_comm_j(),mpierr)
        call icopy(n,int_mb(sumall(1)),1,sum,1)
#endif

        value = MA_pop_stack(sumall(2))
        if (.not. value) call errquit('error popping stack',0, MA_ERR)

      end if
      call nwpw_timing_end(2)

      return
      end


*     ***********************************
*     *                                 *
*     *      D1dB_Brdcst_values         *
*     *                                 *
*     ***********************************

      subroutine D1dB_Brdcst_values(psend,nsize,sum)
      implicit none
      integer psend,nsize
      real*8  sum(*)

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif


#ifdef MPI4
      integer*4 tpsend
      integer np

      call Parallel2d_np_j(np)
      if (np.gt.1) then
         stupid_msglen = nsize
         tpsend        = psend
         call MPI_Bcast(sum,stupid_msglen,stupid_double,
     >                  tpsend,stupid_comm_j,stupid_ierr)
      end if
#else
*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j

      integer ierr,np

      call Parallel2d_np_j(np)
      if (np.gt.1) then
         call MPI_Bcast(sum,nsize,MPI_DOUBLE_PRECISION,
     >                  psend,Parallel2d_comm_j(),ierr)
      end if
#endif

      return
      end




*     ***********************************
*     *                                 *
*     *         D1dB_start_rot          *
*     *                                 *
*     ***********************************
*
* This routine start sends A buffer to proc_to = mod(taskid_j+j,np_j)
* and receives W buffer from proc_from = mod(taskid_j-j+np_j,np_j)
* where taskid_j and np_j is the taskid and number of processors for
* the Parallel2d_comm_j communicator
*
      subroutine D1dB_start_rot(j,
     >                          A,W,lda,na,
     >                          request)
      implicit none
      integer j
      real*8 A(*),W(*)
      integer lda,na(*)
      integer request(*)

#include "D1dB.fh"

#include "mpif.h"
#ifdef MPI4
#include "stupid_mpi4.fh"
#endif

*     **** local variables ****
      integer amsglen,wmsglen
      integer proc_to,proc_from,msgtype,mpierr
      integer taskid_j

*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j

      call Parallel2d_taskid_j(taskid_j)

      proc_to   = mod(taskid_j+j,np_j)
      proc_from = mod(taskid_j-j+np_j,np_j)
      msgtype   = j
      amsglen = lda*na(taskid_j+1)
      wmsglen = lda*na(proc_from+1)

#ifdef MPI4
            if (wmsglen.gt.0) then
               stupid_msglen = wmsglen
               stupid_type   = msgtype
               stupid_taskid = proc_from
               call MPI_IRECV(W,
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_comm_j,
     >                    stupid_request,stupid_ierr)
               request(1) = stupid_request
               request(3) = 1
            else
               request(3) = 0
            end if

            if (amsglen.gt.0) then
               stupid_msglen = amsglen
               stupid_type   = msgtype
               stupid_taskid = proc_to
               call MPI_ISEND(A,
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_comm_j,
     >                     stupid_request,stupid_ierr)
               request(2) = stupid_request
               request(4) = 1
            else
               request(4) = 0
            end if
#else
            if (wmsglen.gt.0) then
               call MPI_IRECV(W,wmsglen,MPI_DOUBLE_PRECISION,
     >                    proc_from,
     >                    msgtype,Parallel2d_comm_j(),
     >                    request(1),mpierr)
               request(3) = 1
            else
               request(3) = 0
            end if
            if (amsglen.gt.0) then
               call MPI_ISEND(A,amsglen,MPI_DOUBLE_PRECISION,
     >                     proc_to,
     >                     msgtype,Parallel2d_comm_j(),
     >                     request(2),mpierr)
               request(4) = 1
            else
               request(4) = 0
            end if
#endif

      if ((request(3).eq.1).and.(request(4).eq.1)) then
         request(3) = 1
      else if (request(3).eq.1) then
         request(3) = 2
      else if (request(4).eq.1) then
         request(3) = 3
      else 
         request(3) = 4
      end if

      return
      end

*     ***********************************
*     *                                 *
*     *         D1dB_end_rot            *
*     *                                 *
*     ***********************************
*
*  This routine waits for the sends and receives to 
* finish that were started with D1dB_start_rot routine.
* 
      subroutine D1dB_end_rot(request)
      implicit none
      integer request(*)

*     **** wait for completion of mp_send, also do a sync ****
      if (request(3).eq.1) then
         call Parallel_mpiWaitAll(2,request)
      else if (request(3).eq.2) then
         call Parallel_mpiWaitAll(1,request)
      else if (request(3).eq.3) then
          call Parallel_mpiWaitAll(1,request(2))
      endif

      return
      end



*     ***********************************
*     *                                 *
*     *         D1dB_isendrecv          *
*     *                                 *
*     ***********************************
      subroutine D1dB_isendrecv(pto,  ssize,sdata,
     >                          pfrom,rsize,rdata,
     >                          request,reqcnt)
      implicit none
      integer pto,ssize
      real*8  sdata(*)
      integer pfrom,rsize
      real*8  rdata(*)
      integer request(*)
      integer reqcnt

#include "D1dB.fh"

#ifdef MPI4
#include "stupid_mpi4.fh"
#else
#include "mpif.h"
#endif

*     **** local variables ****
      integer msgtype,mpierr

*     **** external functions ****
      integer  Parallel2d_comm_j
      external Parallel2d_comm_j


      msgtype   = 7

#ifdef MPI4
            if (rsize.gt.0) then
               stupid_msglen = rsize
               stupid_type   = msgtype
               stupid_taskid = pfrom
               call MPI_IRECV(rdata,
     >                    stupid_msglen,stupid_double,
     >                    stupid_taskid,
     >                    stupid_type,stupid_comm_j,
     >                    stupid_request,stupid_ierr)
               reqcnt          = reqcnt + 1
               request(reqcnt) = stupid_request
            end if

            if (ssize.gt.0) then
               stupid_msglen = ssize
               stupid_type   = msgtype
               stupid_taskid = pto
               call MPI_ISEND(sdata,
     >                     stupid_msglen,stupid_double,
     >                     stupid_taskid,
     >                     stupid_type,stupid_comm_j,
     >                     stupid_request,stupid_ierr)
               reqcnt          = reqcnt + 1
               request(reqcnt) = stupid_request
            end if
#else
            if (rsize.gt.0) then
               reqcnt = reqcnt + 1
               call MPI_IRECV(rdata,rsize,MPI_DOUBLE_PRECISION,
     >                    pfrom,
     >                    msgtype,Parallel2d_comm_j(),
     >                    request(reqcnt),mpierr)
            end if
            if (ssize.gt.0) then
               reqcnt = reqcnt + 1
               call MPI_ISEND(sdata,ssize,MPI_DOUBLE_PRECISION,
     >                     pto,
     >                     msgtype,Parallel2d_comm_j(),
     >                     request(reqcnt),mpierr)
            end if
#endif

      return
      end

*     ***********************************
*     *                                 *
*     *         D1dB_WaitAll            *
*     *                                 *
*     ***********************************
*
*  This routine waits for the sends and receives to 
* finish that were started with D1dB_isendrecv
* 
      subroutine D1dB_WaitAll(request,reqcnt)
      implicit none
      integer request(*)
      integer reqcnt

*     **** local variables ****
      integer np

*     **** wait for completion of mp_send, also do a sync ****
      call Parallel2d_np_j(np)
      if (np.gt.1) then
         call Parallel_mpiWaitAll(reqcnt,request)
         reqcnt = 0
      end if
      return
      end

c     ****************************************
c     *                                      *
c     *          D1dB_Brdcst_step            *
c     *                                      *
c     ****************************************
c
c  This routine performs step l of a butterfly Broadcast all algorithm. The step
c  l spans from 0..(Level-1) where the number of levels is Level = Log(np_j)/Log(2).
c
c   Entry - l: Butterfly step 0...(Level-1)
c           na: an array of length np_j containing the number of orbitals per taskid_j
c           blocks0: number of blocks to send size=blocks0, 
c                    the exceptions are:
c                    if blocks0==0: the block size is size=2**l.
c                    if blocks0==-1: block size is size=(np_j-2**Level)/2 + 1 for l==(Level-1),
c                                    blocksize is size=2**l otherwise
c           n2ft3d: leading size of psi_rep
c           psi_rep: data array
c   Exit -
c           psi_rep: modified data array 
c           requests,reqcnt: tags for asychronous message passing
c
      subroutine D1dB_Brdcst_step(l,na,blocks0,
     >                            n2ft3d,psi_rep,
     >                            requests,reqcnt)
      implicit none
      integer l,na(*),blocks0
      integer n2ft3d
      real*8 psi_rep(n2ft3d,*)
      integer requests(*),reqcnt

*     *** local variables ***
      integer taskid_j,np_j
      integer i,pr,ps,shift,size,Level
      integer pto,pfrom,rsize,ssize,rindx,sindx

*     *** local variables ***
      integer  Butter_levels
      external Butter_levels

      call Parallel2d_taskid_j(taskid_j)
      call Parallel2d_np_j(np_j)

cccc      Level = (log(dble(np_j))/log(2.0d0))
      Level = Butter_levels(np_j)

      shift = 2**l
      pfrom = mod(taskid_j     +shift,np_j)
      pto   = mod(taskid_j+np_j-shift,np_j)

*     *** hfx exception ***
      if (blocks0.lt.0) then
         if (l.eq.(Level-1)) then
            size = ((np_j-2**Level)/2) + 1
         else
            size =  shift
         end if
*     *** standard butterfly exception ***
      elseif  (blocks0.eq.0) then
         size = shift
*     *** user blocksize ***
      else
         size = blocks0
      end if

*     *** determine message sizes ***
      rsize = 0
      ssize = 0
      do i=0,(size-1)
        pr = mod(pfrom    + i,np_j)
        ps = mod(taskid_j + i,np_j)
        rsize = rsize + na(pr+1)
        ssize = ssize + na(ps+1)
      end do

*     *** determine message indexes ***
      rindx = 1
      do  i=0,(shift-1)
        ps = mod(taskid_j + i,np_j)
        rindx = rindx + na(ps+1)
      end do
      sindx = 1


*     *** will be much more complicated for synchronous ***
      reqcnt = 0
      call D1dB_isendrecv(pto,  ssize*n2ft3d,psi_rep(1,sindx),
     >                    pfrom,rsize*n2ft3d,psi_rep(1,rindx),
     >                    requests,reqcnt)
      return
      end


c     ****************************************
c     *                                      *
c     *           D1dB_Reduce_step           *
c     *                                      *
c     ****************************************
c
c  This routine performs step l of a butterfly Reduceall algorithm. The step
c  l spans from 0..(Level-1) where the number of levels is Level = Log(np_j)/Log(2).
c
c   Entry - l: Butterfly step 0...(Level-1)
c           na: an array of length np_j containing the number of orbitals per taskid_j
c           blocks0: number of blocks to send size=blocks0, 
c                    the exceptions are:
c                    if blocks0==0: the block size is size=2**l.
c                    if blocks0==-1: block size is size=(np_j-2**Level)/2 + 1 for l==(Level-1),
c                                    blocksize is size=2**l otherwise
c           n2ft3d: leading size of psi_rep
c           hpsi_rep: data array
c           tmp: tempory data array. Needs to be at least  n2ft3d*size
c
c   Exit - hpsi_rep: modified data array
c          requests,reqcnt: tags for asychronous message passing
c
      subroutine D1dB_Reduce_step(l,na,blocks0,
     >                            n2ft3d,hpsi_rep,tmp)
      implicit none
      integer l,na(*),blocks0
      integer n2ft3d
      real*8 hpsi_rep(n2ft3d,*)
      real*8 tmp(*)

*     *** local variables ***
      integer taskid_j,np_j
      integer i,pr,ps,size,shift,Level,pfrom,pto
      integer rsize,ssize,rindx,sindx
      integer requests(10),reqcnt

*     *** local variables ***
      integer  Butter_levels
      external Butter_levels

      call Parallel2d_taskid_j(taskid_j)
      call Parallel2d_np_j(np_j)

cccccc      !Level = (log(dble(np_j))/log(2.0d0))
      Level = Butter_levels(np_j)

      shift = 2**l
      pfrom = mod(taskid_j+np_j-shift,np_j)
      pto   = mod(taskid_j     +shift,np_j)

*     *** hfx exception ***
      if (blocks0.lt.0) then
         if (l.eq.(Level-1)) then
            size = ((np_j-2**Level)/2) + 1
         else
            size =  shift
         end if
*     *** standard butterfly exception ***
      elseif  (blocks0.eq.0) then
         size = shift
*     *** user blocksize ***
      else
         size = blocks0
      end if

*     *** determine message sizes ***
      rsize = 0
      ssize = 0
      do i=0,(size-1)
        pr = mod(taskid_j + i,np_j)
        ps = mod(pto      + i,np_j)
        rsize = rsize + na(pr+1)
        ssize = ssize + na(ps+1)
      end do

*     *** determine message indexes ***
      rindx = 1
      sindx = 1
      do i=0,(shift-1)
         ps = mod(taskid_j  + i,np_j)
         sindx = sindx + na(ps+1)
      end do


*     *** will be much more complicated for synchronous ***
      reqcnt = 0
      call D1dB_isendrecv(pto,  ssize*n2ft3d,hpsi_rep(1,sindx),
     >                    pfrom,rsize*n2ft3d,tmp,
     >                    requests,reqcnt)

      call D1dB_WaitAll(requests,reqcnt)
      call daxpy(rsize*n2ft3d,1.0d0,tmp,1,hpsi_rep(1,rindx),1)

      return
      end
c $Id: D1dB-mpi.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE mr_ccsd_e(d_f1,d_i0,d_t1,d_t2,d_v2,k_f1_offset,
     +k_i0_offset
     &,k_t1_offset,k_t2_offset,k_v2_offset)
C     $Id: mr_ccsd_e.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_tf + = 1 * Sum ( p5 h6 ) * t ( p5 h6 )_t * i1 ( h6 p5 )_f
C         i1 ( h6 p5 )_f + = 1 * f ( h6 p5 )_f
C         i1 ( h6 p5 )_vt + = 1/2 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 h6 p3 p5 )_v
C     i0 ( )_vt + = 1/4 * Sum ( h3 h4 p1 p2 ) * t ( p1 p2 h3 h4 )_t * v ( h3 h4 p1 p2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER l_i1_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER size_i1
      CHARACTER*255 filename
      CALL OFFSET_mr_ccsd_e_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('mr_ccsd_e_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL mr_ccsd_e_1_1(d_f1,k_f1_offset,d_i1,k_i1_offset)
      CALL mr_ccsd_e_1_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i1,
     +k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL mr_ccsd_e_1(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0,
     +k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('mr_ccsd_e',-1,
     +MA_ERR)
      CALL mr_ccsd_e_2(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i0,
     +k_i0_offset)
      RETURN
      END
      SUBROUTINE mr_ccsd_e_1(d_a,k_a_offset,d_b,k_b_offset,d_c,
     +k_c_offset)
C     $Id: mr_ccsd_e.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_tf + = 1 * Sum ( p5 h6 ) * t ( p5 h6 )_t * i1 ( h6 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h6b
      INTEGER p5b_1
      INTEGER h6b_1
      INTEGER h6b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      IF (next.eq.count) THEN
      IF (0 .eq. ieor(irrep_t,irrep_f)) THEN
      dimc = 1
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mr_ccsd_e_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h6b = 1,noab
      IF (int_mb(k_spin+p5b-1) .eq. int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+h6b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p5b,h6b,p5b_1,h6b_1)
      CALL TCE_RESTRICTED_2(h6b,p5b,h6b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h6b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mr_ccsd_e_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mr_ccsd_e_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (p5b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h6b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mr_ccsd_e_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mr_ccsd_e_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mr_ccsd_e_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h6b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p5b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mr_ccsd_e_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mr_ccsd_e_1',7,
     +MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mr_ccsd_e_1',8,
     +MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mr_ccsd_e_1',9,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_c_sort),dbl_mb(k_c),1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mr_ccsd_e_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mr_ccsd_e_1',11,
     +MA_ERR)
      END IF
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mr_ccsd_e_1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: mr_ccsd_e.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h6 p5 )_f + = 1 * f ( h6 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h6b
      INTEGER p5b
      INTEGER dimc
      INTEGER h6b_1
      INTEGER p5b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO h6b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p5b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1)) .eq. irrep_f) TH
     &EN
      dimc = int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
      CALL TCE_RESTRICTED_2(h6b,p5b,h6b_1,p5b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mr_ccsd_e_1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mr_ccsd_e_1_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p5b_1
     & - 1 + (noab+nvab) * (h6b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p5b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mr_ccsd_e_1_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mr_ccsd_e_1_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h6b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h6b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mr_ccsd_e_1_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mr_ccsd_e_1_1',5,
     +MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_mr_ccsd_e_1_1(l_a_offset,k_a_offset,size)
C     $Id: mr_ccsd_e.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h6 p5 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h6b
      INTEGER p5b
      length = 0
      DO h6b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p5b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('mr_ccsd_e_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h6b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p5b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p5b - noab - 1 + nvab * (h6b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE mr_ccsd_e_1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,
     +k_c_offset)
C     $Id: mr_ccsd_e.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h6 p5 )_vt + = 1/2 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 h6 p3 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h6b
      INTEGER p5b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER p3b_1
      INTEGER h4b_1
      INTEGER h6b_2
      INTEGER h4b_2
      INTEGER p5b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      DO h6b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h6b-1)+int_mb(k_spin+p5b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h6b-1),int_mb(k_sym+p5b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mr_ccsd_e_1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h4b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h4b,p3b_1,h4b_1)
      CALL TCE_RESTRICTED_4(h6b,h4b,p5b,p3b,h6b_2,h4b_2,p5b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p5b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mr_ccsd_e_1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mr_ccsd_e_1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h4b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mr_ccsd_e_1_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mr_ccsd_e_1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mr_ccsd_e_1_2',5,MA_ERR)
      IF ((h4b .le. h6b) .and. (p3b .le. p5b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p5b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))),p5b_2,p3b_2,h6b_2,h4b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p5b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((h4b .le. h6b) .and. (p5b .lt. p3b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      else 
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p3b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))),p3b_2,p5b_2,h6b_2,h4b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p5b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF ((h6b .lt. h4b) .and. (p3b .le. p5b)) THEN
      if(.not.intorb) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p5b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))),p5b_2,p3b_2,h4b_2,h6b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p3b-1),int_mb(k_range+p5b-1)
     &,4,1,2,3,-1.0d0)
      END IF
      IF ((h6b .lt. h4b) .and. (p5b .lt. p3b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p3b_2
     & - 1 + (noab+nvab) * (p5b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))),p3b_2,p5b_2,h4b_2,h6b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p3b-1)
     &,3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mr_ccsd_e_1_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mr_ccsd_e_1_2',7,
     +MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mr_ccsd_e_1_2',8,
     +MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mr_ccsd_e_1_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p5b-1)
     &,int_mb(k_range+h6b-1),2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p5b -
     & noab - 1 + nvab * (h6b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mr_ccsd_e_1_2',10,
     +MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mr_ccsd_e_1_2',11,
     +MA_ERR)
      END IF
      END IF
      END IF
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE mr_ccsd_e_2(d_a,k_a_offset,d_b,k_b_offset,d_c,
     +k_c_offset)
C     $Id: mr_ccsd_e.F 24345 2013-06-22 06:19:30Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_vt + = 1/4 * Sum ( h3 h4 p1 p2 ) * t ( p1 p2 h3 h4 )_t * v ( h3 h4 p1 p2 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p1b
      INTEGER p2b
      INTEGER h3b
      INTEGER h4b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h3b_1
      INTEGER h4b_1
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTASK
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs, 1)
      IF (next.eq.count) THEN
      IF (0 .eq. ieor(irrep_v,irrep_t)) THEN
      dimc = 1
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('mr_ccsd_e_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h3b-1),int_mb(k_sym+h4b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h3b,h4b,p1b_1,p2b_1,h3b_1,h4b_1)
      CALL TCE_RESTRICTED_4(h3b,h4b,p1b,p2b,h3b_2,h4b_2,p1b_2,p2b_2)
      dim_common = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('mr_ccsd_e_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &mr_ccsd_e_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h4b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('mr_ccsd_e_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('mr_ccsd_e_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &mr_ccsd_e_2',5,MA_ERR)
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h3b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p2b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h3b_2 - 1)))),p2b_2,p1b_2,h4b_2,h3b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('mr_ccsd_e_2',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p1b .eq. p2b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h3b .eq. h4b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('mr_ccsd_e_2',7,
     +MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('mr_ccsd_e_2',8,
     +MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &mr_ccsd_e_2',9,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_c_sort),dbl_mb(k_c),1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('mr_ccsd_e_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('mr_ccsd_e_2',11,
     +MA_ERR)
      END IF
      next = NXTASK(nprocs, 1)
      END IF
      count = count + 1
      next = NXTASK(-nprocs, 1)
      call GA_SYNC()
      RETURN
      END

      program test
*
* $Id: newtestfmm.F 21484 2011-11-09 21:22:15Z d3p852 $
*
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
c
      double precision total_flops
      common / totalf / total_flops
c
      integer lmax, depth, tree(300)
      parameter (lmax=16, depth=4)
      double precision fmm_potential, direct_sum, drand
      double precision fmm_direct_potential
      external fmm_potential, fmm_direct_potential, direct_sum, 
     $     drand
      double precision x, y, z, dimx, dimy, dimz, time
      real*4 etime, stuff(2)
c
      integer ncharge, i, ntest, j
      parameter (ncharge = 5000, ntest=1000)
      double precision charges(ncharge), coords(3,ncharge)
      double precision chargesr(ncharge), coordsr(3,ncharge)
      double precision pot1(ncharge), pot2(ncharge), pot3(ncharge)
      integer list_next(ncharge), map(ncharge),
     $     list_info(2,0:2**depth-1,0:2**depth-1,0:2**depth-1)
c
      double precision far, near, err, relerr, l2err, l2norm, sum
c
      if (.not. ma_init(mt_dbl, 60000000, 60000000))
     $     call errquit('nwchem: ma_init failed', -1, MA_ERR)
c
      call xlm_init
      total_flops = 0.0d0
c
      dimx = 1.0d0
      dimy = 1.0d0
      dimz = 1.0d0
      do i = 1, ncharge
         charges(i) = drand(0)-0.5d0
         coords(1,i)= drand(0)
         coords(2,i)= drand(0)
         coords(3,i)= drand(0)
*         write(6,77) charges(i), (coords(j,i),j=1,3)
* 77      format(f12.6,2x,3f12.6)
      enddo
c
      write(6,*)
      write(6,*)
      write(6,*) ' Depth ', depth, ' lmax ', lmax
c
      call fmm_tree_create(depth, lmax, tree)
      write(6,*) ' RIght after create '
      call fmm_tree_summarize(tree)
c
      time = etime(stuff)
      call fmm_charges_to_poles(depth, lmax, tree, dimx, dimy, dimz,
     $     coords, charges, ncharge, list_info, list_next,
     $     map)
      write(6,*) ' RIght after charges to polse '
      call fmm_tree_summarize(tree)
c
      time = etime(stuff) - time
      write(6,61) ' Time to form multipoles ', time
 61   format(1x,a,1x,f8.2)
c     
      time = etime(stuff)
      call fmm(depth, lmax, tree, dimx, dimy, dimz)
      time = etime(stuff) - time
      write(6,61) ' Time to perform far field summation ', time
      write(6,*) ' RIght after FMM '
      call fmm_tree_summarize(tree)
c
      l2err = 0.0d0
      l2norm = 0.0d0
      err = 0.0d0
      relerr = 0.0d0
      do i = 1, ntest
         x = drand(0)
         y = drand(0)
         z = drand(0)
         far = fmm_potential(depth,lmax,tree,dimx,dimy,dimz,
     $        x,y,z)
         near = fmm_direct_potential(
     $        lmax, depth, dimx, dimy, dimz, x, y, z,
     $        coords, charges, ncharge, list_info, map)
         sum = direct_sum(coords, charges, ncharge, x, y, z)
         err = max(err,abs(sum-far-near))
*         write(6,*) ' far, near, sum, err ', far, near, sum, err
         relerr = max(relerr, abs(sum-far-near)/sum)
         l2err = l2err + (sum-far-near)**2
         l2norm = l2norm + sum**2
      enddo
      write(6,62) ' MAX abs err = ', err
 62   format(1x,a,1p,d9.2)
      write(6,62) ' MAX rel err = ', relerr
      write(6,62) ' L2 err norm = ', sqrt(l2err/l2norm)
c
**      write(6,*) ' total flops ', total_flops
c
c$$$      time = etime(stuff)
c$$$      do j = 1, 1000
c$$$         far = fmm_potential(depth,lmax,tree,dimx,dimy,dimz,x,y,z)
c$$$         near = fmm_direct_potential(lmax, depth,
c$$$     $        dimx, dimy, dimz, x, y, z,
c$$$     $        coords, charges, ncharge, list_info, map)
c$$$      enddo
c$$$      time = etime(stuff)-time
c$$$      write(6,61) ' time per FMM potential eval ', time/1000
c$$$      time = etime(stuff)
c$$$      do j = 1, 1000
c$$$         sum = direct_sum(coords, charges, ncharge, x, y, z)
c$$$      enddo
c$$$      time = etime(stuff)-time
c$$$      write(6,61) ' time per direct potential eval ', time/1000
c
      time = etime(stuff)
      do j = 1, ncharge
         chargesr(j) = charges(map(j))
         coordsr(1,j) = coords(1,map(j))
         coordsr(2,j) = coords(2,map(j))
         coordsr(3,j) = coords(3,map(j))
      enddo
      call fmm_potential_at_charges2(depth, lmax, tree, 
     $     dimx,dimy,dimz,
     $     coordsr, chargesr, ncharge, list_info, pot3)
      do j = 1, ncharge
         pot1(map(j)) = pot3(j)
      enddo
      time = etime(stuff)-time
      write(6,61) ' Time to evaluate all FMM potentials ', time
c
      time = etime(stuff)
      call direct_sum_at_charges(coords, charges, ncharge, pot2)
      time = etime(stuff)-time
      write(6,61) ' Time to evaluate all direct potentials ', time
c
      l2err = 0.0d0
      l2norm = 0.0d0
      err = 0.0d0
      do i = 1, ncharge
         err = max(err,abs(pot1(i)-pot2(i)))
         l2err = l2err + (pot1(i)-pot2(i))**2
         l2norm = l2norm + pot1(i)**2
      enddo
      write(6,62) ' MAX abs err at charges = ', err
      write(6,62) ' L2 err norm at charges = ', sqrt(l2err/l2norm)
c 
      end

*
* $Id: paw_stress_numerical.F 19707 2010-10-29 17:59:36Z d3y133 $
*

      logical function paw_stress_numerical(rtdb)
      implicit none
      integer rtdb

#include "mafdecls.fh"
#include "global.fh"
#include "msgtypesf.h"
#include "rtdb.fh"
#include "geom.fh"
#include "errquit.fh"

*     **** local variables ***
      integer taskid,MASTER
      parameter (MASTER=0)
      logical value,value2

      real*8 stress(3,3)
      real*8 unita(3,3)

*     **** external functions ****
      logical  paw_minimizer,paw_stress_fd
      external paw_minimizer,paw_stress_fd

      taskid = ga_nodeid()


      if (taskid.eq.MASTER) then
        write(*,*) '  ******************************************** '
        write(*,*) '  *                                          * '
        write(*,*) '  *     PAW Stress Numerical - version 1.0   * '
        write(*,*) '  *                                          * '
        write(*,*) '  *      version last updated 4/24/02        * '
        write(*,*) '  *                                          * '
        write(*,*) '  ******************************************** '
        call nwpw_message(1)
      end if


*     **** minimize psi ***
      value = paw_minimizer(rtdb,1)
      if(.not. value) 
     > call errquit(
     > 'paw_stress_numerical:paw_gradient did not converge: error',
     >  0,CALC_ERR)

*     **** calculate stress tensor ***
      value = .true.
      value = value.and.rtdb_parallel(.true.)
      value = value.and.paw_stress_fd(rtdb)
      if(.not. value) 
     >   call errquit('paw_stress_numerical did not converge: error',0,
     &       CALC_ERR)
 

      call ga_sync()

      paw_stress_numerical = value
      return
      end
 

      block data initial_smd_control_data
      implicit none
#include "smd_control_data.fh"
c     
      data smd_control_fstatus /smd_control_nf*.false./

      data smd_control_fname /"rcut",
     c                       "rcut_verlet",
     c                       "step",
     c                       "temp"/

      data smd_control_istatus /smd_control_ni*.false./

      data smd_control_iname /"ndata",
     c                       "nequil",
     c                       "nprint",
     c                       "temp"/


      end

      subroutine smd_control_set_component(aname,sp_name)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_control_data.fh"
c     
      character*(*) aname
      character*(*) sp_name
c
      character*32 pname,tag
      integer nrec
      integer i
      logical result
      logical ocase
c
      pname = "smd_control_set_component"
c
      write(*,*) "in "//pname
c
c     case sensitive
      ocase = .true.
c
      nrec = smd_control_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_control_rname,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      smd_control_cname(i) = sp_name
      
      return
      end

      subroutine smd_control_get_component(sp_name,aname,oexist)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_control_data.fh"
c     
      character*(*) aname
      character*(*) sp_name
c
      character*32 pname,tag
      integer nrec
      integer i
      logical oexist,result
      logical ocase
c
      pname = "smd_control_get_component"
c
      write(*,*) "in "//pname
c
c     case sensitive
      ocase = .true.
c
      nrec = smd_control_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_control_rname,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      sp_name = smd_control_cname(i)
      oexist = sp_name.ne." "
      
      return
      end

      subroutine smd_control_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_control_data.fh"
c     
      integer un
c
      integer i
c
      character*30 pname
      pname = "smd_control_print"
c
      write(*,*) "in "//pname
      do i=1,smd_control_nc
        write(un,'(A16,"=",A16)') smd_control_rname(i),
     >                 smd_control_cname(i)
      end do
      
      return
      end
c $Id: smd_control_data.F 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE ccsdt_y_tr1(d_f1,d_i0,d_t1,d_t2,d_t3,d_tr1,d_tr2,d_tr3,
     &d_v2,d_y1,d_y2,d_y3,k_f1_offset,k_i0_offset,k_t1_offset,k_t2_offse
     &t,k_t3_offset,k_tr1_offset,k_tr2_offset,k_tr3_offset,k_v2_offset,k
     &_y1_offset,k_y2_offset,k_y3_offset)
C     $Id: ccsdt_y_tr1.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h2 p1 )_ftry + = -1 * Sum ( h7 ) * y ( h7 p1 )_y * i1 ( h2 h7 )_ftr
C         i1 ( h2 h7 )_ftr + = 1 * Sum ( p3 ) * tr ( p3 h7 )_tr * i2 ( h2 p3 )_f
C             i2 ( h2 p3 )_f + = 1 * f ( h2 p3 )_f
C             i2 ( h2 p3 )_vt + = 1 * Sum ( h6 p5 ) * t ( p5 h6 )_t * v ( h2 h6 p3 p5 )_v
C         i1 ( h2 h7 )_vtr + = 1 * Sum ( h4 p3 ) * tr ( p3 h4 )_tr * v ( h2 h4 h7 p3 )_v
C         i1 ( h2 h7 )_vtr + = -1/2 * Sum ( h6 p3 p4 ) * tr ( p3 p4 h6 h7 )_tr * v ( h2 h6 p3 p4 )_v
C         i1 ( h2 h7 )_vtrt + = 1 * Sum ( p3 ) * t ( p3 h7 )_t * i2 ( h2 p3 )_vtr
C             i2 ( h2 p3 )_vtr + = 1 * Sum ( h6 p5 ) * tr ( p5 h6 )_tr * v ( h2 h6 p3 p5 )_v
C     i0 ( h2 p1 )_ytrf + = -1 * Sum ( h3 ) * i1 ( h2 h3 )_ytr * f ( h3 p1 )_f
C         i1 ( h2 h3 )_ytr + = 1 * Sum ( p4 ) * tr ( p4 h3 )_tr * y ( h2 p4 )_y
C         i1 ( h2 h3 )_ytr + = 1/2 * Sum ( h6 p5 p4 ) * tr ( p4 p5 h3 h6 )_tr * y ( h2 h6 p4 p5 )_y
C         i1 ( h2 h3 )_ytr + = 1/12 * Sum ( h8 h7 p6 p5 p4 ) * tr ( p4 p5 p6 h3 h7 h8 )_tr * y ( h2 h7 h8 p4 p5 p6 )_y
C     i0 ( h2 p1 )_ytrv + = 1 * Sum ( h10 h8 ) * i1 ( h10 h8 )_ytr * v ( h2 h8 h10 p1 )_v
C         i1 ( h10 h8 )_ytr + = 1 * Sum ( p3 ) * tr ( p3 h8 )_tr * y ( h10 p3 )_y
C         i1 ( h10 h8 )_ytr + = 1/2 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h8 )_tr * y ( h5 h10 p3 p4 )_y
C         i1 ( h10 h8 )_ytr + = 1/12 * Sum ( h7 h6 p5 p4 p3 ) * tr ( p3 p4 p5 h6 h7 h8 )_tr * y ( h6 h7 h10 p3 p4 p5 )_y
C     i0 ( h2 p1 )_ytrv + = 1 * Sum ( p9 p10 ) * i1 ( p9 p10 )_ytr * v ( h2 p10 p1 p9 )_v
C         i1 ( p9 p10 )_ytr + = 1 * Sum ( h4 ) * tr ( p9 h4 )_tr * y ( h4 p10 )_y
C         i1 ( p9 p10 )_ytr + = 1/2 * Sum ( h6 h5 p3 ) * tr ( p3 p9 h5 h6 )_tr * y ( h5 h6 p3 p10 )_y
C         i1 ( p9 p10 )_ytr + = 1/12 * Sum ( h8 h7 h6 p4 p3 ) * tr ( p3 p4 p9 h6 h7 h8 )_tr * y ( h6 h7 h8 p3 p4 p10 )_y
C     i0 ( h2 p1 )_vtry + = 1 * Sum ( p8 ) * y ( h2 p8 )_y * i1 ( p8 p1 )_vtr
C         i1 ( p8 p1 )_vtr + = -1 * Sum ( h4 p3 ) * tr ( p3 h4 )_tr * v ( h4 p8 p1 p3 )_v
C         i1 ( p8 p1 )_vttr + = -1 * Sum ( h4 ) * tr ( p8 h4 )_tr * i2 ( h4 p1 )_vt
C             i2 ( h4 p1 )_vt + = 1 * Sum ( h6 p5 ) * t ( p5 h6 )_t * v ( h4 h6 p1 p5 )_v
C         i1 ( p8 p1 )_vtrt + = -1 * Sum ( h4 ) * t ( p8 h4 )_t * i2 ( h4 p1 )_vtr
C             i2 ( h4 p1 )_vtr + = 1 * Sum ( h6 p5 ) * tr ( p5 h6 )_tr * v ( h4 h6 p1 p5 )_v
C     i0 ( h2 p1 )_vtry + = -1/2 * Sum ( p9 h11 h12 ) * y ( h11 h12 p1 p9 )_y * i1 ( h2 p9 h11 h12 )_vtr
C         i1 ( h2 p9 h11 h12 )_vtr + = -1 * Sum ( h7 ) * tr ( p9 h7 )_tr * i2 ( h2 h7 h11 h12 )_v
C             i2 ( h2 h7 h11 h12 )_v + = 1 * v ( h2 h7 h11 h12 )_v
C             i2 ( h2 h7 h11 h12 )_vt + = -2 * Sum ( p3 ) * t ( p3 h11 )_t * i3 ( h2 h7 h12 p3 )_v
C                 i3 ( h2 h7 h12 p3 )_v + = 1 * v ( h2 h7 h12 p3 )_v
C                 i3 ( h2 h7 h12 p3 )_vt + = -1/2 * Sum ( p5 ) * t ( p5 h12 )_t * v ( h2 h7 p3 p5 )_v
C             i2 ( h2 h7 h11 h12 )_vt + = 1/2 * Sum ( p3 p4 ) * t ( p3 p4 h11 h12 )_t * v ( h2 h7 p3 p4 )_v
C         i1 ( h2 p9 h11 h12 )_vtr + = -2 * Sum ( p3 ) * tr ( p3 h11 )_tr * i2 ( h2 p9 h12 p3 )_v
C             i2 ( h2 p9 h12 p3 )_v + = 1 * v ( h2 p9 h12 p3 )_v
C             i2 ( h2 p9 h12 p3 )_vt + = -1/2 * Sum ( p5 ) * t ( p5 h12 )_t * v ( h2 p9 p3 p5 )_v
C         i1 ( h2 p9 h11 h12 )_ftr + = 1 * Sum ( p5 ) * tr ( p5 p9 h11 h12 )_tr * i2 ( h2 p5 )_f
C             i2 ( h2 p5 )_f + = 1 * f ( h2 p5 )_f
C             i2 ( h2 p5 )_vt + = 1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h2 h8 p5 p7 )_v
C         i1 ( h2 p9 h11 h12 )_vtr + = -2 * Sum ( h6 p4 ) * tr ( p4 p9 h6 h11 )_tr * i2 ( h2 h6 h12 p4 )_v
C             i2 ( h2 h6 h12 p4 )_v + = 1 * v ( h2 h6 h12 p4 )_v
C             i2 ( h2 h6 h12 p4 )_vt + = -1 * Sum ( p7 ) * t ( p7 h12 )_t * v ( h2 h6 p4 p7 )_v
C         i1 ( h2 p9 h11 h12 )_vtr + = 1/2 * Sum ( p3 p4 ) * tr ( p3 p4 h11 h12 )_tr * v ( h2 p9 p3 p4 )_v
C         i1 ( h2 p9 h11 h12 )_vtr + = -1/2 * Sum ( h8 p4 p5 ) * tr ( p4 p5 p9 h8 h11 h12 )_tr * v ( h2 h8 p4 p5 )_v
C         i1 ( h2 p9 h11 h12 )_vtrt + = -2 * Sum ( h7 ) * t ( p9 h7 )_t * i2 ( h2 h7 h11 h12 )_vtr
C             i2 ( h2 h7 h11 h12 )_vtr + = -1 * Sum ( p3 ) * tr ( p3 h11 )_tr * i3 ( h2 h7 h12 p3 )_v
C             i2 ( h2 h7 h11 h12 )_vtr + = 1/4 * Sum ( p3 p4 ) * tr ( p3 p4 h11 h12 )_tr * v ( h2 h7 p3 p4 )_v
C             i2 ( h2 h7 h11 h12 )_vtrt + = 1/2 * Sum ( p3 ) * t ( p3 h11 )_t * i3 ( h2 h7 h12 p3 )_vtr
C                 i3 ( h2 h7 h12 p3 )_vtr + = 1 * Sum ( p5 ) * tr ( p5 h12 )_tr * v ( h2 h7 p3 p5 )_v
C         i1 ( h2 p9 h11 h12 )_vtrt + = -1 * Sum ( p3 ) * t ( p3 h11 )_t * i2 ( h2 p9 h12 p3 )_vtr
C             i2 ( h2 p9 h12 p3 )_vtr + = -1 * Sum ( p5 ) * tr ( p5 h12 )_tr * v ( h2 p9 p3 p5 )_v
C         i1 ( h2 p9 h11 h12 )_vtrt + = 2 * Sum ( h6 p4 ) * t ( p4 p9 h6 h11 )_t * i2 ( h2 h6 h12 p4 )_vtr
C             i2 ( h2 h6 h12 p4 )_vtr + = 1 * Sum ( p7 ) * tr ( p7 h12 )_tr * v ( h2 h6 p4 p7 )_v
C         i1 ( h2 p9 h11 h12 )_vtrt + = 1 * Sum ( p4 ) * t ( p4 p9 h11 h12 )_t * i2 ( h2 p4 )_vtr
C             i2 ( h2 p4 )_vtr + = 1 * Sum ( h8 p7 ) * tr ( p7 h8 )_tr * v ( h2 h8 p4 p7 )_v
C     i0 ( h2 p1 )_ytrv + = 1 * Sum ( h7 h9 p10 ) * i1 ( h2 h7 h9 p10 )_ytr * v ( h9 p10 h7 p1 )_v
C         i1 ( h2 h7 h9 p10 )_ytr + = 1 * Sum ( p3 ) * tr ( p3 h9 )_tr * y ( h2 h7 p3 p10 )_y
C         i1 ( h2 h7 h9 p10 )_ytr + = -1/2 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h9 )_tr * y ( h2 h5 h7 p3 p4 p10 )_y
C     i0 ( h2 p1 )_vtry + = -1/2 * Sum ( p5 p6 h4 ) * y ( h2 h4 p5 p6 )_y * i1 ( p5 p6 h4 p1 )_vtr
C         i1 ( p5 p6 h4 p1 )_vtr + = -1 * Sum ( p3 ) * tr ( p3 h4 )_tr * v ( p5 p6 p1 p3 )_v
C     i0 ( h2 p1 )_ytrv + = 1 * Sum ( p12 h11 ) * i1 ( p12 h11 )_ytr * v ( h2 h11 p1 p12 )_v
C         i1 ( p12 h11 )_ytr + = 1 * Sum ( h5 p3 ) * tr ( p3 p12 h5 h11 )_tr * y ( h5 p3 )_y
C         i1 ( p12 h11 )_ytr + = 1/4 * Sum ( h7 h6 p4 p3 ) * tr ( p3 p4 p12 h6 h7 h11 )_tr * y ( h6 h7 p3 p4 )_y
C         i1 ( p12 h11 )_yttr + = -1 * Sum ( h8 ) * tr ( p12 h8 )_tr * i2 ( h8 h11 )_yt
C             i2 ( h8 h11 )_yt + = 1 * Sum ( p5 ) * t ( p5 h11 )_t * y ( h8 p5 )_y
C             i2 ( h8 h11 )_yt + = 1/2 * Sum ( h5 p4 p3 ) * t ( p3 p4 h5 h11 )_t * y ( h5 h8 p3 p4 )_y
C             i2 ( h8 h11 )_yt + = 1/12 * Sum ( h7 h6 p5 p4 p3 ) * t ( p3 p4 p5 h6 h7 h11 )_t * y ( h6 h7 h8 p3 p4 p5 )_y
C         i1 ( p12 h11 )_ytrt + = -1/2 * Sum ( h8 ) * t ( p12 h8 )_t * i2 ( h8 h11 )_ytr
C             i2 ( h8 h11 )_ytr + = 1 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h11 )_tr * y ( h5 h8 p3 p4 )_y
C             i2 ( h8 h11 )_ytr + = 1/6 * Sum ( h7 h6 p5 p4 p3 ) * tr ( p3 p4 p5 h6 h7 h11 )_tr * y ( h6 h7 h8 p3 p4 p5 )_y
C             i2 ( h8 h11 )_ytr + = 2 * Sum ( p5 ) * tr ( p5 h11 )_tr * y ( h8 p5 )_y
C         i1 ( p12 h11 )_yttr + = -1/2 * Sum ( h5 h6 p3 ) * tr ( p3 p12 h5 h6 )_tr * i2 ( h5 h6 h11 p3 )_yt
C             i2 ( h5 h6 h11 p3 )_yt + = 1 * Sum ( p7 ) * t ( p7 h11 )_t * y ( h5 h6 p3 p7 )_y
C             i2 ( h5 h6 h11 p3 )_yt + = -5/18 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h11 )_t * i3 ( h5 h6 h9 p3 p7 p8 )_y
C                 i3 ( h5 h6 h9 p3 p7 p8 )_y + = 1 * y ( h5 h6 h9 p3 p7 p8 )_y
C                 i3 ( h5 h6 h9 p3 p7 p8 )_y + = 4/5 * y ( h5 h6 h9 p3 p7 p8 )_y
C         i1 ( p12 h11 )_yttr + = -1/12 * Sum ( h6 h7 h8 p3 p4 ) * tr ( p3 p4 p12 h6 h7 h8 )_tr * i2 ( h6 h7 h8 h11 p3 p4 )_yt
C             i2 ( h6 h7 h8 h11 p3 p4 )_yt + = 1 * Sum ( p9 ) * t ( p9 h11 )_t * y ( h6 h7 h8 p3 p4 p9 )_y
C         i1 ( p12 h11 )_ytrt + = -1/2 * Sum ( h5 h6 p3 ) * t ( p3 p12 h5 h6 )_t * i2 ( h5 h6 h11 p3 )_ytr
C             i2 ( h5 h6 h11 p3 )_ytr + = 1 * Sum ( p7 ) * tr ( p7 h11 )_tr * y ( h5 h6 p3 p7 )_y
C             i2 ( h5 h6 h11 p3 )_ytr + = -5/18 * Sum ( h9 p8 p7 ) * tr ( p7 p8 h9 h11 )_tr * i3 ( h5 h6 h9 p3 p7 p8 )_y
C         i1 ( p12 h11 )_ytrt + = -1/12 * Sum ( h6 h7 h8 p3 p4 ) * t ( p3 p4 p12 h6 h7 h8 )_t * i2 ( h6 h7 h8 h11 p3 p4 )_ytr
C             i2 ( h6 h7 h8 h11 p3 p4 )_ytr + = 1 * Sum ( p9 ) * tr ( p9 h11 )_tr * y ( h6 h7 h8 p3 p4 p9 )_y
C     i0 ( h2 p1 )_ytrv + = 1/2 * Sum ( p14 h13 h11 ) * i1 ( h2 p14 h11 h13 )_ytr * v ( h11 h13 p1 p14 )_v
C         i1 ( h2 p14 h11 h13 )_ytr + = -1 * Sum ( p3 ) * tr ( p3 p14 h11 h13 )_tr * y ( h2 p3 )_y
C         i1 ( h2 p14 h11 h13 )_ytr + = 1/2 * Sum ( h6 p4 p3 ) * tr ( p3 p4 p14 h6 h11 h13 )_tr * y ( h2 h6 p3 p4 )_y
C         i1 ( h2 p14 h11 h13 )_ytrt + = -1/2 * Sum ( h10 ) * t ( p14 h10 )_t * i2 ( h2 h10 h11 h13 )_ytr
C             i2 ( h2 h10 h11 h13 )_ytr + = -1 * Sum ( p4 p3 ) * tr ( p3 p4 h11 h13 )_tr * y ( h2 h10 p3 p4 )_y
C             i2 ( h2 h10 h11 h13 )_ytr + = 1/3 * Sum ( h6 p5 p4 p3 ) * tr ( p3 p4 p5 h6 h11 h13 )_tr * y ( h2 h6 h10 p3 p4 p5 )_y
C             i2 ( h2 h10 h11 h13 )_yttr + = 2 * Sum ( p5 ) * tr ( p5 h13 )_tr * i3 ( h2 h10 h11 p5 )_yt
C                 i3 ( h2 h10 h11 p5 )_yt + = 1 * Sum ( p7 ) * t ( p7 h11 )_t * y ( h2 h10 p5 p7 )_y
C                 i3 ( h2 h10 h11 p5 )_yt + = 1 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h11 )_t * y ( h2 h9 h10 p5 p7 p8 )_y
C             i2 ( h2 h10 h11 h13 )_ytrt + = 2 * Sum ( p5 ) * t ( p5 h13 )_t * i3 ( h2 h10 h11 p5 )_ytr
C                 i3 ( h2 h10 h11 p5 )_ytr + = 1 * Sum ( p7 ) * tr ( p7 h11 )_tr * y ( h2 h10 p5 p7 )_y
C                 i3 ( h2 h10 h11 p5 )_ytr + = 1 * Sum ( h9 p8 p7 ) * tr ( p7 p8 h9 h11 )_tr * y ( h2 h9 h10 p5 p7 p8 )_y
C         i1 ( h2 p14 h11 h13 )_yttr + = 2 * Sum ( h5 p3 ) * tr ( p3 p14 h5 h13 )_tr * i2 ( h2 h5 h11 p3 )_yt
C             i2 ( h2 h5 h11 p3 )_yt + = 1 * Sum ( p7 ) * t ( p7 h11 )_t * y ( h2 h5 p3 p7 )_y
C         i1 ( h2 p14 h11 h13 )_ytrt + = -1 * t ( p14 h11 )_t * i2 ( h2 h13 )_ytr
C             i2 ( h2 h13 )_ytr + = 1 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h13 )_tr * y ( h2 h5 p3 p4 )_y
C             i2 ( h2 h13 )_ytr + = -1/6 * Sum ( h7 h6 p5 p4 p3 ) * tr ( p3 p4 p5 h6 h7 h13 )_tr * y ( h2 h6 h7 p3 p4 p5 )_y
C         i1 ( h2 p14 h11 h13 )_yttr + = -1/2 * Sum ( h6 h7 p3 p4 ) * tr ( p3 p4 p14 h6 h7 h13 )_tr * i2 ( h2 h6 h7 h11 p3 p4 )_yt
C             i2 ( h2 h6 h7 h11 p3 p4 )_yt + = 1 * Sum ( p9 ) * t ( p9 h11 )_t * y ( h2 h6 h7 p3 p4 p9 )_y
C         i1 ( h2 p14 h11 h13 )_ytrt + = -1/4 * Sum ( p7 p8 ) * t ( p7 p8 h11 h13 )_t * i2 ( h2 p14 p7 p8 )_ytr
C             i2 ( h2 p14 p7 p8 )_ytr + = 1 * Sum ( h6 h5 p3 ) * tr ( p3 p14 h5 h6 )_tr * y ( h2 h5 h6 p3 p7 p8 )_y
C         i1 ( h2 p14 h11 h13 )_ytrt + = 1/2 * Sum ( h9 p7 ) * t ( p7 p14 h9 h11 )_t * i2 ( h2 h9 h13 p7 )_ytr
C             i2 ( h2 h9 h13 p7 )_ytr + = -1 * Sum ( h5 p3 p4 ) * tr ( p3 p4 h5 h13 )_tr * i3 ( h2 h5 h9 p3 p4 p7 )_y
C                 i3 ( h2 h5 h9 p3 p4 p7 )_y + = 1 * y ( h2 h5 h9 p3 p4 p7 )_y
C         i1 ( h2 p14 h11 h13 )_yttr + = -1/2 * Sum ( h10 ) * tr ( p14 h10 )_tr * i2 ( h2 h10 h11 h13 )_yt
C             i2 ( h2 h10 h11 h13 )_yt + = -1 * Sum ( p4 p3 ) * t ( p3 p4 h11 h13 )_t * y ( h2 h10 p3 p4 )_y
C             i2 ( h2 h10 h11 h13 )_yt + = 1/3 * Sum ( h6 p5 p4 p3 ) * t ( p3 p4 p5 h6 h11 h13 )_t * y ( h2 h6 h10 p3 p4 p5 )_y
C             i2 ( h2 h10 h11 h13 )_ytt + = 2 * Sum ( p5 ) * t ( p5 h13 )_t * i3 ( h2 h10 h11 p5 )_yt
C         i1 ( h2 p14 h11 h13 )_ytrt + = 2 * Sum ( h5 p3 ) * t ( p3 p14 h5 h13 )_t * i2 ( h2 h5 h11 p3 )_ytr
C             i2 ( h2 h5 h11 p3 )_ytr + = 1 * Sum ( p7 ) * tr ( p7 h11 )_tr * y ( h2 h5 p3 p7 )_y
C         i1 ( h2 p14 h11 h13 )_yttr + = -1 * tr ( p14 h11 )_tr * i2 ( h2 h13 )_yt
C             i2 ( h2 h13 )_yt + = 1 * Sum ( h5 p4 p3 ) * t ( p3 p4 h5 h13 )_t * y ( h2 h5 p3 p4 )_y
C             i2 ( h2 h13 )_yt + = -1/6 * Sum ( h7 h6 p5 p4 p3 ) * t ( p3 p4 p5 h6 h7 h13 )_t * y ( h2 h6 h7 p3 p4 p5 )_y
C         i1 ( h2 p14 h11 h13 )_ytrt + = -1/2 * Sum ( h6 h7 p3 p4 ) * t ( p3 p4 p14 h6 h7 h13 )_t * i2 ( h2 h6 h7 h11 p3 p4 )_ytr
C             i2 ( h2 h6 h7 h11 p3 p4 )_ytr + = 1 * Sum ( p9 ) * tr ( p9 h11 )_tr * y ( h2 h6 h7 p3 p4 p9 )_y
C         i1 ( h2 p14 h11 h13 )_yttr + = -1/4 * Sum ( p7 p8 ) * tr ( p7 p8 h11 h13 )_tr * i2 ( h2 p14 p7 p8 )_yt
C             i2 ( h2 p14 p7 p8 )_yt + = 1 * Sum ( h6 h5 p3 ) * t ( p3 p14 h5 h6 )_t * y ( h2 h5 h6 p3 p7 p8 )_y
C         i1 ( h2 p14 h11 h13 )_yttr + = 1/2 * Sum ( h9 p7 ) * tr ( p7 p14 h9 h11 )_tr * i2 ( h2 h9 h13 p7 )_yt
C             i2 ( h2 h9 h13 p7 )_yt + = -1 * Sum ( h5 p3 p4 ) * t ( p3 p4 h5 h13 )_t * i3 ( h2 h5 h9 p3 p4 p7 )_y
C         i1 ( h2 p14 h11 h13 )_ytttr + = 1/2 * Sum ( p3 ) * tr ( p3 h13 )_tr * i2 ( h2 p14 h11 p3 )_ytt
C             i2 ( h2 p14 h11 p3 )_ytt + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p14 h9 h10 )_t * i3 ( h2 h9 h10 h11 p3 p7 )_yt
C                 i3 ( h2 h9 h10 h11 p3 p7 )_yt + = 1 * Sum ( p5 ) * t ( p5 h11 )_t * y ( h2 h9 h10 p3 p5 p7 )_y
C         i1 ( h2 p14 h11 h13 )_ytrtt + = 1/2 * Sum ( p3 ) * t ( p3 h13 )_t * i2 ( h2 p14 h11 p3 )_ytrt
C             i2 ( h2 p14 h11 p3 )_ytrt + = 1 * Sum ( h9 h10 p7 ) * t ( p7 p14 h9 h10 )_t * i3 ( h2 h9 h10 h11 p3 p7 )_ytr
C                 i3 ( h2 h9 h10 h11 p3 p7 )_ytr + = 1 * Sum ( p5 ) * tr ( p5 h11 )_tr * y ( h2 h9 h10 p3 p5 p7 )_y
C             i2 ( h2 p14 h11 p3 )_yttr + = 1 * Sum ( h9 h10 p7 ) * tr ( p7 p14 h9 h10 )_tr * i3 ( h2 h9 h10 h11 p3 p7 )_yt
C     i0 ( h2 p1 )_ytrv + = -1/4 * Sum ( h8 h12 h13 ) * i1 ( h2 h8 h12 h13 )_ytr * v ( h12 h13 h8 p1 )_v
C         i1 ( h2 h8 h12 h13 )_ytr + = 1 * Sum ( p4 p3 ) * tr ( p3 p4 h12 h13 )_tr * y ( h2 h8 p3 p4 )_y
C         i1 ( h2 h8 h12 h13 )_ytr + = -1/3 * Sum ( h6 p5 p4 p3 ) * tr ( p3 p4 p5 h6 h12 h13 )_tr * y ( h2 h6 h8 p3 p4 p5 )_y
C         i1 ( h2 h8 h12 h13 )_yttr + = 2 * Sum ( p3 ) * tr ( p3 h12 )_tr * i2 ( h2 h8 h13 p3 )_yt
C             i2 ( h2 h8 h13 p3 )_yt + = 1 * Sum ( p5 ) * t ( p5 h13 )_t * y ( h2 h8 p3 p5 )_y
C         i1 ( h2 h8 h12 h13 )_ytrt + = -2 * Sum ( p7 ) * t ( p7 h13 )_t * i2 ( h2 h8 h12 p7 )_ytr
C             i2 ( h2 h8 h12 p7 )_ytr + = 1 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h12 )_tr * y ( h2 h5 h8 p3 p4 p7 )_y
C         i1 ( h2 h8 h12 h13 )_ytrt + = 2 * Sum ( p3 ) * t ( p3 h12 )_t * i2 ( h2 h8 h13 p3 )_ytr
C             i2 ( h2 h8 h13 p3 )_ytr + = 1 * Sum ( p5 ) * tr ( p5 h13 )_tr * y ( h2 h8 p3 p5 )_y
C         i1 ( h2 h8 h12 h13 )_yttr + = -2 * Sum ( p7 ) * tr ( p7 h13 )_tr * i2 ( h2 h8 h12 p7 )_yt
C             i2 ( h2 h8 h12 p7 )_yt + = 1 * Sum ( h5 p4 p3 ) * t ( p3 p4 h5 h12 )_t * y ( h2 h5 h8 p3 p4 p7 )_y
C     i0 ( h2 p1 )_ytrv + = 1 * Sum ( p12 h10 p11 ) * i1 ( h2 p12 h10 p11 )_ytr * v ( h10 p11 p1 p12 )_v
C         i1 ( h2 p12 h10 p11 )_ytr + = 1 * Sum ( h5 p3 ) * tr ( p3 p12 h5 h10 )_tr * y ( h2 h5 p3 p11 )_y
C         i1 ( h2 p12 h10 p11 )_ytr + = -1/4 * Sum ( h7 h6 p4 p3 ) * tr ( p3 p4 p12 h6 h7 h10 )_tr * y ( h2 h6 h7 p3 p4 p11 )_y
C         i1 ( h2 p12 h10 p11 )_yttr + = -1 * Sum ( h6 ) * tr ( p12 h6 )_tr * i2 ( h2 h6 h10 p11 )_yt
C             i2 ( h2 h6 h10 p11 )_yt + = 1 * Sum ( p5 ) * t ( p5 h10 )_t * y ( h2 h6 p5 p11 )_y
C             i2 ( h2 h6 h10 p11 )_yt + = -1/2 * Sum ( h5 p4 p3 ) * t ( p3 p4 h5 h10 )_t * y ( h2 h5 h6 p3 p4 p11 )_y
C         i1 ( h2 p12 h10 p11 )_ytrt + = 1/2 * Sum ( h6 ) * t ( p12 h6 )_t * i2 ( h2 h6 h10 p11 )_ytr
C             i2 ( h2 h6 h10 p11 )_ytr + = 1 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h10 )_tr * y ( h2 h5 h6 p3 p4 p11 )_y
C             i2 ( h2 h6 h10 p11 )_ytr + = -2 * Sum ( p5 ) * tr ( p5 h10 )_tr * y ( h2 h6 p5 p11 )_y
C         i1 ( h2 p12 h10 p11 )_yttr + = 1/2 * Sum ( h5 h6 p3 ) * tr ( p3 p12 h5 h6 )_tr * i2 ( h2 h5 h6 h10 p3 p11 )_yt
C             i2 ( h2 h5 h6 h10 p3 p11 )_yt + = 1 * Sum ( p7 ) * t ( p7 h10 )_t * y ( h2 h5 h6 p3 p7 p11 )_y
C         i1 ( h2 p12 h10 p11 )_ytrt + = 1/2 * Sum ( h5 h6 p3 ) * t ( p3 p12 h5 h6 )_t * i2 ( h2 h5 h6 h10 p3 p11 )_ytr
C             i2 ( h2 h5 h6 h10 p3 p11 )_ytr + = 1 * Sum ( p7 ) * tr ( p7 h10 )_tr * y ( h2 h5 h6 p3 p7 p11 )_y
C     i0 ( h2 p1 )_ytrv + = -1/4 * Sum ( h7 h8 h6 ) * i1 ( h7 h8 h6 p1 )_ytr * v ( h2 h6 h7 h8 )_v
C         i1 ( h7 h8 h6 p1 )_ytr + = 1 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h6 )_tr * y ( h5 h7 h8 p1 p3 p4 )_y
C     i0 ( h2 p1 )_vtry + = 1/2 * Sum ( p15 p12 h13 h14 h11 ) * y ( h11 h13 h14 p1 p12 p15 )_y * i1 ( h2 p12 p15 h11 h13 h14 )_vtr
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtr + = -1 * Sum ( p4 ) * tr ( p4 p15 h13 h14 )_tr * i2 ( h2 p12 h11 p4 )_v
C             i2 ( h2 p12 h11 p4 )_v + = 1 * v ( h2 p12 h11 p4 )_v
C             i2 ( h2 p12 h11 p4 )_vt + = -1 * Sum ( h8 ) * t ( p12 h8 )_t * v ( h2 h8 h11 p4 )_v
C             i2 ( h2 p12 h11 p4 )_vt + = -1 * Sum ( p7 ) * t ( p7 h11 )_t * v ( h2 p12 p4 p7 )_v
C             i2 ( h2 p12 h11 p4 )_vt + = -2/3 * Sum ( h10 p8 ) * t ( p8 p12 h10 h11 )_t * i3 ( h2 h10 p4 p8 )_v
C                 i3 ( h2 h10 p4 p8 )_v + = 1 * v ( h2 h10 p4 p8 )_v
C                 i3 ( h2 h10 p4 p8 )_v + = 1/2 * v ( h2 h10 p4 p8 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_ftr + = -1/6 * Sum ( p4 ) * tr ( p4 p12 p15 h11 h13 h14 )_tr * i2 ( h2 p4 )_f
C             i2 ( h2 p4 )_f + = 1 * f ( h2 p4 )_f
C             i2 ( h2 p4 )_vt + = 1 * Sum ( h10 p9 ) * t ( p9 h10 )_t * v ( h2 h10 p4 p9 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtr + = -1/2 * Sum ( h8 p5 ) * tr ( p5 p12 p15 h8 h13 h14 )_tr * i2 ( h2 h8 h11 p5 )_v
C             i2 ( h2 h8 h11 p5 )_v + = 1 * v ( h2 h8 h11 p5 )_v
C             i2 ( h2 h8 h11 p5 )_vt + = -1 * Sum ( p9 ) * t ( p9 h11 )_t * v ( h2 h8 p5 p9 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtr + = -1/6 * Sum ( p4 p5 ) * tr ( p4 p5 p15 h11 h13 h14 )_tr * v ( h2 p12 p4 p5 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtrt + = -1/6 * Sum ( h10 ) * t ( p12 h10 )_t * i2 ( h2 h10 p15 h11 h13 h14 )_vtr
C             i2 ( h2 h10 p15 h11 h13 h14 )_vtr + = -1 * Sum ( p4 p5 ) * tr ( p4 p5 p15 h11 h13 h14 )_tr * v ( h2 h10 p4 p5 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtrt + = -1 * Sum ( p4 ) * t ( p4 p15 h13 h14 )_t * i2 ( h2 p12 h11 p4 )_vtr
C             i2 ( h2 p12 h11 p4 )_vtr + = -1 * Sum ( h8 ) * tr ( p12 h8 )_tr * v ( h2 h8 h11 p4 )_v
C             i2 ( h2 p12 h11 p4 )_vtr + = -1 * Sum ( p7 ) * tr ( p7 h11 )_tr * v ( h2 p12 p4 p7 )_v
C             i2 ( h2 p12 h11 p4 )_vtr + = -2/3 * Sum ( h10 p8 ) * tr ( p8 p12 h10 h11 )_tr * i3 ( h2 h10 p4 p8 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtrt + = 1/2 * Sum ( h8 p5 ) * t ( p5 p12 p15 h8 h13 h14 )_t * i2 ( h2 h8 h11 p5 )_vtr
C             i2 ( h2 h8 h11 p5 )_vtr + = 1 * Sum ( p9 ) * tr ( p9 h11 )_tr * v ( h2 h8 p5 p9 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vttr + = -1/6 * Sum ( h10 ) * tr ( p12 h10 )_tr * i2 ( h2 h10 p15 h11 h13 h14 )_vt
C             i2 ( h2 h10 p15 h11 h13 h14 )_vt + = -1 * Sum ( p4 p5 ) * t ( p4 p5 p15 h11 h13 h14 )_t * v ( h2 h10 p4 p5 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtrt + = -1/6 * Sum ( p5 ) * t ( p5 p12 p15 h11 h13 h14 )_t * i2 ( h2 p5 )_vtr
C             i2 ( h2 p5 )_vtr + = 1 * Sum ( h10 p9 ) * tr ( p9 h10 )_tr * v ( h2 h10 p5 p9 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtrtt + = 1 * Sum ( p8 ) * t ( p8 p12 h11 h14 )_t * i2 ( h2 p15 h13 p8 )_vtrt
C             i2 ( h2 p15 h13 p8 )_vtrt + = 1 * Sum ( h6 ) * t ( p15 h6 )_t * i3 ( h2 h6 h13 p8 )_vtr
C                 i3 ( h2 h6 h13 p8 )_vtr + = 1 * Sum ( p3 ) * tr ( p3 h13 )_tr * v ( h2 h6 p3 p8 )_v
C             i2 ( h2 p15 h13 p8 )_vttr + = 1 * Sum ( h6 ) * tr ( p15 h6 )_tr * i3 ( h2 h6 h13 p8 )_vt
C                 i3 ( h2 h6 h13 p8 )_vt + = 1 * Sum ( p3 ) * t ( p3 h13 )_t * v ( h2 h6 p3 p8 )_v
C         i1 ( h2 p12 p15 h11 h13 h14 )_vtttr + = 1 * Sum ( p8 ) * tr ( p8 p12 h11 h14 )_tr * i2 ( h2 p15 h13 p8 )_vtt
C             i2 ( h2 p15 h13 p8 )_vtt + = 1 * Sum ( h6 ) * t ( p15 h6 )_t * i3 ( h2 h6 h13 p8 )_vt
C     i0 ( h2 p1 )_ytrv + = -1/4 * Sum ( p4 p7 p8 ) * i1 ( h2 p4 p7 p8 )_ytr * v ( p7 p8 p1 p4 )_v
C         i1 ( h2 p4 p7 p8 )_ytr + = 1 * Sum ( h6 h5 p3 ) * tr ( p3 p4 h5 h6 )_tr * y ( h2 h5 h6 p3 p7 p8 )_y
C     i0 ( h2 p1 )_ytrtv + = 1/2 * Sum ( h9 p7 h6 ) * i1 ( h9 p7 h6 p1 )_ytrt * v ( h2 h6 h9 p7 )_v
C         i1 ( h9 p7 h6 p1 )_ytrt + = 1 * Sum ( h8 ) * t ( p7 h8 )_t * i2 ( h8 h9 h6 p1 )_ytr
C             i2 ( h8 h9 h6 p1 )_ytr + = 1 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h6 )_tr * y ( h5 h8 h9 p1 p3 p4 )_y
C         i1 ( h9 p7 h6 p1 )_yttr + = 1 * Sum ( h8 ) * tr ( p7 h8 )_tr * i2 ( h8 h9 h6 p1 )_yt
C             i2 ( h8 h9 h6 p1 )_yt + = 1 * Sum ( h5 p4 p3 ) * t ( p3 p4 h5 h6 )_t * y ( h5 h8 h9 p1 p3 p4 )_y
C     i0 ( h2 p1 )_ytrtv + = -1/12 * Sum ( p14 p11 h13 ) * i1 ( p11 p14 h13 p1 )_ytrt * v ( h2 h13 p11 p14 )_v
C         i1 ( p11 p14 h13 p1 )_ytrt + = -1 * Sum ( h9 h10 ) * t ( p11 p14 h9 h10 )_t * i2 ( h9 h10 h13 p1 )_ytr
C             i2 ( h9 h10 h13 p1 )_ytr + = -1 * Sum ( h5 p4 p3 ) * tr ( p3 p4 h5 h13 )_tr * i3 ( h5 h9 h10 p1 p3 p4 )_y
C                 i3 ( h5 h9 h10 p1 p3 p4 )_y + = 1 * y ( h5 h9 h10 p1 p3 p4 )_y
C                 i3 ( h5 h9 h10 p1 p3 p4 )_y + = 1/2 * y ( h5 h9 h10 p1 p3 p4 )_y
C         i1 ( p11 p14 h13 p1 )_yttr + = -1 * Sum ( h9 h10 ) * tr ( p11 p14 h9 h10 )_tr * i2 ( h9 h10 h13 p1 )_yt
C             i2 ( h9 h10 h13 p1 )_yt + = -1 * Sum ( h5 p4 p3 ) * t ( p3 p4 h5 h13 )_t * i3 ( h5 h9 h10 p1 p3 p4 )_y
C         i1 ( p11 p14 h13 p1 )_ytttr + = -3 * Sum ( h4 ) * tr ( p14 h4 )_tr * i2 ( h4 p11 h13 p1 )_ytt
C             i2 ( h4 p11 h13 p1 )_ytt + = 1 * Sum ( h6 ) * t ( p11 h6 )_t * i3 ( h4 h6 h13 p1 )_yt
C                 i3 ( h4 h6 h13 p1 )_yt + = 1 * Sum ( h9 p8 p7 ) * t ( p7 p8 h9 h13 )_t * y ( h4 h6 h9 p1 p7 p8 )_y
C         i1 ( p11 p14 h13 p1 )_yttrt + = -3 * Sum ( h4 ) * t ( p14 h4 )_t * i2 ( h4 p11 h13 p1 )_yttr
C             i2 ( h4 p11 h13 p1 )_yttr + = 1 * Sum ( h6 ) * tr ( p11 h6 )_tr * i3 ( h4 h6 h13 p1 )_yt
C             i2 ( h4 p11 h13 p1 )_ytrt + = 1 * Sum ( h6 ) * t ( p11 h6 )_t * i3 ( h4 h6 h13 p1 )_ytr
C                 i3 ( h4 h6 h13 p1 )_ytr + = 1 * Sum ( h9 p8 p7 ) * tr ( p7 p8 h9 h13 )_tr * y ( h4 h6 h9 p1 p7 p8 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_y3
      INTEGER k_y3_offset
      INTEGER l_i1_offset
      INTEGER d_tr1
      INTEGER k_tr1_offset
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER size_i1
      INTEGER d_tr2
      INTEGER k_tr2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER l_i2_offset
      INTEGER size_i2
      INTEGER d_tr3
      INTEGER k_tr3_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_i3
      INTEGER k_i3_offset
      INTEGER l_i3_offset
      INTEGER size_i3
      INTEGER d_t3
      INTEGER k_t3_offset
      CHARACTER*255 filename
#if !defined(CCSDTLR)
      CALL ERRQUIT('CCSDTLR not compiled (ccsdt_y_tr1.F)',
     &              0,CAPMIS_ERR)
      RETURN
      END
#else
      CALL OFFSET_ccsdt_y_tr1_1_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_1_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_y_tr1_1_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_1_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_1_1_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL ccsdt_y_tr1_1_1_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_1_1(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL ccsdt_y_tr1_1_2(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_1_3(d_tr2,k_tr2_offset,d_v2,k_v2_offset,d_i1,k_i1
     &_offset)
      CALL OFFSET_ccsdt_y_tr1_1_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_1_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_1_4_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_1_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_1(d_y1,k_y1_offset,d_i1,k_i1_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_2_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_2_1(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_2_2(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_2_3(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i1,k_i1
     &_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_2(d_i1,k_i1_offset,d_f1,k_f1_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_3_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_3_1(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_3_2(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_3_3(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i1,k_i1
     &_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_3(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_4_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_4_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_4_1(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_4_2(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_4_3(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i1,k_i1
     &_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_4(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_5_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_5_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_5_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i1,k_i1
     &_offset)
      CALL OFFSET_ccsdt_y_tr1_5_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_5_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_5_2_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_5_2(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_5_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_5_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_5_3_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_5_3(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_5(d_y1,k_y1_offset,d_i1,k_i1_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_6_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_y_tr1_6_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_6_1_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL OFFSET_ccsdt_y_tr1_6_1_2_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_1_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_6_1_2_1(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_6_1_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i3,k_
     &i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_6_1_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_i2
     &_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL ccsdt_y_tr1_6_1_3(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_1(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_6_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_6_2_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdt_y_tr1_6_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_2(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_6_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_6_3_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL ccsdt_y_tr1_6_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_3(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_6_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_6_4_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdt_y_tr1_6_4_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_4(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL ccsdt_y_tr1_6_5(d_tr2,k_tr2_offset,d_v2,k_v2_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_6_6(d_tr3,k_tr3_offset,d_v2,k_v2_offset,d_i1,k_i1
     &_offset)
      CALL OFFSET_ccsdt_y_tr1_6_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_6_7_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_7_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_6_7_1_1(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_6_7_1_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i3,k_
     &i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_6_7_1(d_tr1,k_tr1_offset,d_i3,k_i3_offset,d_i2,k_
     &i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL ccsdt_y_tr1_6_7_2(d_tr2,k_tr2_offset,d_v2,k_v2_offset,d_i2,k_
     &i2_offset)
      CALL OFFSET_ccsdt_y_tr1_6_7_3_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_7_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_6_7_3_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i3,
     &k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_6_7_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_i2
     &_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_7(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_6_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_6_8_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_8(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_6_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_6_9_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_9(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_6_10_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_6_10_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_6_10_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_6_10(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_6(d_y2,k_y2_offset,d_i1,k_i1_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_7_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_7_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_7_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_7_2(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i1,k_i1
     &_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_7(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_8_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_8_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_8_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i1,k_i1
     &_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_8(d_y2,k_y2_offset,d_i1,k_i1_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_9_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_9_1(d_tr2,k_tr2_offset,d_y1,k_y1_offset,d_i1,k_i1
     &_offset)
      CALL ccsdt_y_tr1_9_2(d_tr3,k_tr3_offset,d_y2,k_y2_offset,d_i1,k_i1
     &_offset)
      CALL OFFSET_ccsdt_y_tr1_9_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_9_3_1(d_t1,k_t1_offset,d_y1,k_y1_offset,d_i2,k_i2
     &_offset)
      CALL ccsdt_y_tr1_9_3_2(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i2,k_i2
     &_offset)
      CALL ccsdt_y_tr1_9_3_3(d_t3,k_t3_offset,d_y3,k_y3_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_9_3(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_9_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_9_4_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i2,k_
     &i2_offset)
      CALL ccsdt_y_tr1_9_4_2(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i2,k_
     &i2_offset)
      CALL ccsdt_y_tr1_9_4_3(d_tr1,k_tr1_offset,d_y1,k_y1_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_9_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_9_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_9_5_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i2,k_i2
     &_offset)
      CALL OFFSET_ccsdt_y_tr1_9_5_2_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_5_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_9_5_2_1(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_9_5_2_2(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_9_5_2(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2,k_i2
     &_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_9_5(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_9_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_9_6_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i2,k_i2
     &_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_9_6(d_tr3,k_tr3_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_9_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_9_7_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i2,k_
     &i2_offset)
      CALL OFFSET_ccsdt_y_tr1_9_7_2_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_7_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_9_7_2_1(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_9_7_2_2(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_9_7_2(d_tr2,k_tr2_offset,d_i3,k_i3_offset,d_i2,k_
     &i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_9_7(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_9_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_9_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_9_8_1(d_tr1,k_tr1_offset,d_y3,k_y3_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_9_8(d_t3,k_t3_offset,d_i2,k_i2_offset,d_i1,k_i1_o
     &ffset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_9(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_off
     &set)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_10_1(d_tr2,k_tr2_offset,d_y1,k_y1_offset,d_i1,k_i
     &1_offset)
      CALL ccsdt_y_tr1_10_2(d_tr3,k_tr3_offset,d_y2,k_y2_offset,d_i1,k_i
     &1_offset)
      CALL OFFSET_ccsdt_y_tr1_10_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_3_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i2,k
     &_i2_offset)
      CALL ccsdt_y_tr1_10_3_2(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i2,k
     &_i2_offset)
      CALL OFFSET_ccsdt_y_tr1_10_3_3_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_3_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_3_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i3,k
     &_i3_offset)
      CALL ccsdt_y_tr1_10_3_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i3,k
     &_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_3_3(d_tr1,k_tr1_offset,d_i3,k_i3_offset,d_i2,k
     &_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_3_4_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_3_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_3_4_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i3
     &,k_i3_offset)
      CALL ccsdt_y_tr1_10_3_4_2(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i3
     &,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_3_4(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_i
     &2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_3(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_4_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_4(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_5_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i2,k
     &_i2_offset)
      CALL ccsdt_y_tr1_10_5_2(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_5(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_6_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_6(d_tr3,k_tr3_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_7_1(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_7(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_10_8_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_8_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_8_1_1(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_10_8_1_2(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_8_1(d_tr2,k_tr2_offset,d_i3,k_i3_offset,d_i2,k
     &_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_8(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_9_1(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i2,k_i
     &2_offset)
      CALL ccsdt_y_tr1_10_9_2(d_t3,k_t3_offset,d_y3,k_y3_offset,d_i2,k_i
     &2_offset)
      CALL OFFSET_ccsdt_y_tr1_10_9_3_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_9_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_9_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i3,k
     &_i3_offset)
      CALL ccsdt_y_tr1_10_9_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i3,k
     &_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_9_3(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_i
     &2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_9(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_10_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_10_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_10_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_10(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_11_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_11_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_11_1(d_t2,k_t2_offset,d_y2,k_y2_offset,d_i2,k_
     &i2_offset)
      CALL ccsdt_y_tr1_10_11_2(d_t3,k_t3_offset,d_y3,k_y3_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_11(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_12_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_12_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_12_1(d_tr1,k_tr1_offset,d_y3,k_y3_offset,d_i2,
     &k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_12(d_t3,k_t3_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_13_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_13_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_10_13_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i2,k_
     &i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_13(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_14_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_14_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_10_14_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_14_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_14_1_1(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_10_14_1_2(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_14_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2,k_
     &i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_14(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_15_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_15_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_10_15_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_15_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_15_1_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i3,
     &k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_15_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2,k_
     &i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_15(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_16_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_16_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_10_16_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_16_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_16_1_1(d_tr1,k_tr1_offset,d_y3,k_y3_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_16_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2,k_
     &i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_10_16_2_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_10_16_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_10_16_2_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i3,
     &k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_10_16_2(d_tr2,k_tr2_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_10_16(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_10(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_11_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_11_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_11_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_i
     &1_offset)
      CALL ccsdt_y_tr1_11_2(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i1,k_i
     &1_offset)
      CALL OFFSET_ccsdt_y_tr1_11_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_11_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_11_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_11_3(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_11_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_11_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_11_4_1(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_11_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_11_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_11_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_11_5_1(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_11_5(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_11_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_11_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_11_6_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_11_6(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_11(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_12_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_12_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_12_1(d_tr2,k_tr2_offset,d_y2,k_y2_offset,d_i1,k_i
     &1_offset)
      CALL ccsdt_y_tr1_12_2(d_tr3,k_tr3_offset,d_y3,k_y3_offset,d_i1,k_i
     &1_offset)
      CALL OFFSET_ccsdt_y_tr1_12_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_12_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_12_3_1(d_t1,k_t1_offset,d_y2,k_y2_offset,d_i2,k_i
     &2_offset)
      CALL ccsdt_y_tr1_12_3_2(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_12_3(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_12_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_12_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_12_4_1(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i2,k
     &_i2_offset)
      CALL ccsdt_y_tr1_12_4_2(d_tr1,k_tr1_offset,d_y2,k_y2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_12_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_12_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_12_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_12_5_1(d_t1,k_t1_offset,d_y3,k_y3_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_12_5(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_12_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_12_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_12_6_1(d_tr1,k_tr1_offset,d_y3,k_y3_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_12_6(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_12(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_13_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_13_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_13_1(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_13(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_y_tr1_14_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_1_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdt_y_tr1_14_1_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i
     &2_offset)
      CALL ccsdt_y_tr1_14_1_3(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i
     &2_offset)
      CALL OFFSET_ccsdt_y_tr1_14_1_4_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_1_4_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_14_1_4_1(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_14_1_4_2(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_14_1_4(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2,k_i
     &2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_1(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_2_1(d_f1,k_f1_offset,d_i2,k_i2_offset)
      CALL ccsdt_y_tr1_14_2_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_2(d_tr3,k_tr3_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_3_1(d_v2,k_v2_offset,d_i2,k_i2_offset)
      CALL ccsdt_y_tr1_14_3_2(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_3(d_tr3,k_tr3_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL ccsdt_y_tr1_14_4(d_tr3,k_tr3_offset,d_v2,k_v2_offset,d_i1,k_i
     &1_offset)
      CALL OFFSET_ccsdt_y_tr1_14_5_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_5_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_5_1(d_tr3,k_tr3_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_5(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_6_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_6_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_6_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL ccsdt_y_tr1_14_6_2(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL OFFSET_ccsdt_y_tr1_14_6_3_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_6_3_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_14_6_3_1(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_14_6_3_2(d_v2,k_v2_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_14_6_3(d_tr2,k_tr2_offset,d_i3,k_i3_offset,d_i2,k
     &_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_6(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_7_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_7_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_7_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_7(d_t3,k_t3_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_8_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_8_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_8_1(d_t3,k_t3_offset,d_v2,k_v2_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_8(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_9_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_9_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_14_9_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_9(d_t3,k_t3_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_10_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_10_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_14_10_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_10_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_14_10_1_1(d_tr1,k_tr1_offset,d_v2,k_v2_offset,d_i
     &3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_14_10_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_
     &i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_10_2_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_10_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_14_10_2_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i3,
     &k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_14_10_2(d_tr1,k_tr1_offset,d_i3,k_i3_offset,d_i2,
     &k_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_10(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1
     &_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_14_11_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_11_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_14_11_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_14_11_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_14_11_1_1(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i3,
     &k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_14_11_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_
     &i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_14_11(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_
     &i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_14(d_y3,k_y3_offset,d_i1,k_i1_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_15_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_15_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL ccsdt_y_tr1_15_1(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i1,k_i
     &1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_15(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_16_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_16_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_y_tr1_16_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_16_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_16_1_1(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i2,k
     &_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_16_1(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_16_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_16_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL ccsdt_y_tr1_16_2_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i2,k_i
     &2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_16_2(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_16(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_17_1(l_i1_offset,k_i1_offset,size_i1)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL OFFSET_ccsdt_y_tr1_17_1_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_1_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_17_1_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_1_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_17_1_1_1(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_17_1_1_2(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_17_1_1(d_tr2,k_tr2_offset,d_i3,k_i3_offset,d_i2,k
     &_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_17_1(d_t2,k_t2_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_17_2_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_17_2_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_2_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_17_2_1_1(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL ccsdt_y_tr1_17_2_1_2(d_y3,k_y3_offset,d_i3,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_17_2_1(d_t2,k_t2_offset,d_i3,k_i3_offset,d_i2,k_i
     &2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_17_2(d_tr2,k_tr2_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_17_3_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_3_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_17_3_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_3_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_17_3_1_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i3,k
     &_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_17_3_1(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_i
     &2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_17_3(d_tr1,k_tr1_offset,d_i2,k_i2_offset,d_i1,k_i
     &1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_17_4_1(l_i2_offset,k_i2_offset,size_i2)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_4_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL OFFSET_ccsdt_y_tr1_17_4_1_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_4_1_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_17_4_1_1(d_t2,k_t2_offset,d_y3,k_y3_offset,d_i3,k
     &_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_17_4_1(d_tr1,k_tr1_offset,d_i3,k_i3_offset,d_i2,k
     &_i2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL OFFSET_ccsdt_y_tr1_17_4_2_1(l_i3_offset,k_i3_offset,size_i3)
      CALL TCE_FILENAME('ccsdt_y_tr1_17_4_2_1_i3',filename)
      CALL CREATEFILE(filename,d_i3,size_i3)
      CALL ccsdt_y_tr1_17_4_2_1(d_tr2,k_tr2_offset,d_y3,k_y3_offset,d_i3
     &,k_i3_offset)
      CALL RECONCILEFILE(d_i3,size_i3)
      CALL ccsdt_y_tr1_17_4_2(d_t1,k_t1_offset,d_i3,k_i3_offset,d_i2,k_i
     &2_offset)
      CALL DELETEFILE(d_i3)
      IF (.not.MA_POP_STACK(l_i3_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL ccsdt_y_tr1_17_4(d_t1,k_t1_offset,d_i2,k_i2_offset,d_i1,k_i1_
     &offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL ccsdt_y_tr1_17(d_i1,k_i1_offset,d_v2,k_v2_offset,d_i0,k_i0_of
     &fset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('ccsdt_y_tr1',-1,
     &MA_ERR)
      RETURN
      END
#endif

      subroutine smd_ewald_init()
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c
      integer rtdb
      character*32 sp_lat
      character*32 pname
      character*80 tag
      integer i_rl
      integer kmax(3)
      double precision alpha
      double precision ralphsq
      double precision rksqmax

      logical result
c
      pname = "smd_ewald_init"
c
c      write(*,*) "in "//pname

c
      call smd_rtdb_get_handle(rtdb)
c
      call smd_system_get_component(sp_lat,"lattice",result)
      if(.not.result) return
c
      call smd_ewald_rtdb_read(alpha,kmax,rtdb)
c
      tag = "lat:rcell"
      call smd_data_get_index(sp_lat,tag,i_rl,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_ewald_compute(ralphsq,rksqmax,alpha,kmax,dbl_mb(i_rl))
      call smd_ewald_set_kmax(kmax)
      call smd_ewald_set_alpha(alpha)
      call smd_ewald_set_rksqmax(rksqmax)
      call smd_ewald_set_ralphsq(ralphsq)

c      call smd_ewald_print(6)
      return
      end

      subroutine smd_ewald_rtdb_read(alpha,kmax,rtdb)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "global.fh"
c     
      double precision alpha
      integer kmax(3)
      integer rtdb
c
      character*32 pname
      character*80 tag
c
      pname = "smd_ewald_rtdb_read"
c
c      write(*,*) "in "//pname
c
      tag = "smd:ewald"
      if (.not.rtdb_get(rtdb,tag,mt_dbl,1,alpha)) 
     >      call errquit(pname//'failed to read'//tag,0,
     >       RTDB_ERR)
c
      tag = "smd:kvec"
      if (.not.rtdb_get(rtdb,tag,mt_int,3,kmax(1))) 
     >      call errquit(pname//'failed to read'//tag,0,
     >       RTDB_ERR)

      return
      end

      subroutine smd_ewald_compute(ralphsq,rksqmax,alpha,kmax,rlatt)

      implicit none
#include "smd_const_data.fh"

      double precision ralphsq,rksqmax,alpha
      integer kmax(3)
      double precision rlatt(3,3)
c
      double precision axb1,axb2,axb3
      double precision bxc1,bxc2,bxc3
      double precision cxa1,cxa2,cxa3
      double precision xvector,yvector,zvector
      double precision rvol
      

      ralphsq=-0.25/alpha**2


      axb1=rlatt(2,1)*rlatt(3,2)-rlatt(3,1)*rlatt(2,2)
      axb2=rlatt(3,1)*rlatt(1,2)-rlatt(1,1)*rlatt(3,2)
      axb3=rlatt(1,1)*rlatt(2,2)-rlatt(2,1)*rlatt(1,2)
      bxc1=rlatt(2,2)*rlatt(3,3)-rlatt(3,2)*rlatt(2,3)
      bxc2=rlatt(3,2)*rlatt(1,3)-rlatt(1,2)*rlatt(3,3)
      bxc3=rlatt(1,2)*rlatt(2,3)-rlatt(2,2)*rlatt(1,3)
      cxa1=rlatt(2,3)*rlatt(3,1)-rlatt(2,1)*rlatt(3,3)
      cxa2=rlatt(1,1)*rlatt(3,3)-rlatt(3,1)*rlatt(1,3)
      cxa3=rlatt(2,1)*rlatt(1,3)-rlatt(1,1)*rlatt(2,3)

      rvol=abs(rlatt(1,1)*bxc1+rlatt(2,1)*bxc2+rlatt(3,1)*bxc3)

      xvector=rvol/sqrt(bxc1*bxc1+bxc2*bxc2+bxc3*bxc3)*kmax(1)
      yvector=rvol/sqrt(cxa1*cxa1+cxa2*cxa2+cxa3*cxa3)*kmax(2)
      zvector=rvol/sqrt(axb1*axb1+axb2*axb2+axb3*axb3)*kmax(3)

      rksqmax=min(xvector,yvector,zvector)
      rksqmax=rksqmax*1.05*twopi
      rksqmax=rksqmax**2

      return

      END

      subroutine smd_ewald_self()

      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      double precision  ewald1
      integer i
      character*30 pname
      character*32 sp_charge
      character*32 tag
      integer i_q,nq
      double precision alpha
      logical result

      pname = "smd_ewald_self"


      call smd_system_get_component(sp_charge,"charge",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no charge ',0,0)

      tag = "charge"
      call smd_data_get_index(sp_charge,tag,i_q,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      call smd_data_get_size(sp_charge,tag,nq,result)


      call smd_ewald_get_alpha(alpha)

      ewald1=0.0

      do i=1,nq

       ewald1=ewald1+dbl_mb(i_q+i-1)*dbl_mb(i_q+i-1)

      enddo

      ewald1=-convfct1*alpha*ewald1/sqrpi

      write(*,*) "ewald1",ewald1
      
      call smd_energy_set_component("ewald self",ewald1)

      return

      END

      subroutine smd_ewald_recip()

      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      double precision  ewald2
      character*30 pname
      character*32 sp_charge
      character*32 sp_coord
      character*32 sp_lattice
      character*32 sp_force
      character*32 sp
      character*32 tag
      integer i_q,nq
      integer h_eikx,i_eikx
      integer h_eiky,i_eiky
      integer h_eikz,i_eikz
      integer h_eikr,i_eikr
      integer i_f,i_c,i_rc
      double precision vol
      double precision rksqmax,ralphsq
      integer kmax(3)
      integer ntmp,nk
      logical result

      pname = "smd_ewald_recip"


c
c     get components
c     --------------
      call smd_system_get_component(sp_charge,"charge",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no charge ',0,0)

      call smd_system_get_component(sp_coord,"coordinates",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no coordinates ',0,0)

      call smd_system_get_component(sp_lattice,"lattice",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no lattice ',0,0)

      call smd_system_get_component(sp_force,"force",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no force ',0,0)

c
c     get coord data
c     --------------
      tag = "coords"
      sp = sp_coord
      call smd_data_get_index(sp,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     get charge data
c     --------------
      tag = "charge"
      sp = sp_charge
      call smd_data_get_index(sp,tag,i_q,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      call smd_data_get_size(sp,tag,nq,result)
      write(*,*) "nq=",nq
c
c     get force data
c     --------------
      tag = "force"
      sp = sp_force
      call smd_data_get_index(sp,tag,i_f,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     get lattice data
c     ----------------
      sp = sp_lattice
      tag = "lat:rcell"
      call smd_data_get_index(sp,tag,i_rc,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      call smd_latt_get_vol(sp,vol)
c
c     get ewald data
c     --------------
      call smd_ewald_get_ralphsq(ralphsq)
      call smd_ewald_get_rksqmax(rksqmax)
      call smd_ewald_get_kmax(kmax)
 
      nk = max(kmax(1),kmax(2),kmax(3))
c
c    create temporary scratch array 
c    ---------------------------------------------
      ntmp = 2*(nk+1)*nq
      if(.not.ma_push_get(mt_dbl,ntmp,'tmp eikx',h_eikx,i_eikx))
     + call errquit(pname//'Failed to allocate memory ',
     + ntmp, MA_ERR)
      ntmp = 2*nq*(2*nk+1)
      if(.not.ma_push_get(mt_dbl,ntmp,'tmp eiky',h_eiky,i_eiky))
     + call errquit(pname//'Failed to allocate memory ',
     + ntmp, MA_ERR)
      ntmp = 2*nq*(2*nk+1)
      if(.not.ma_push_get(mt_dbl,ntmp,'tmp eikz',h_eikz,i_eikz))
     + call errquit(pname//'Failed to allocate memory ',
     + ntmp, MA_ERR)
      ntmp = 2*nq
      if(.not.ma_push_get(mt_dbl,ntmp,'tmp eikr',h_eikr,i_eikr))
     + call errquit(pname//'Failed to allocate memory ',
     + ntmp, MA_ERR)


      call  smd_ewald_recip_generic(
     >                          nq,
     >                          nk,
     >                          dbl_mb(i_eikr),
     >                          dbl_mb(i_eikx),
     >                          dbl_mb(i_eiky),
     >                          dbl_mb(i_eikz),
     >                          ralphsq,
     >                          rksqmax,
     >                          vol,
     >                          dbl_mb(i_rc),
     >                          kmax,
     >                          dbl_mb(i_c),
     >                          dbl_mb(i_q),
     >                          dbl_mb(i_f),
     >                          ewald2)

      write(*,*) "ewald reciprocal",ewald2

      if(.not.ma_pop_stack(h_eikr))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_eikz))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)


      if(.not.ma_pop_stack(h_eiky))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      if(.not.ma_pop_stack(h_eikx))
     & call errquit(pname//'Failed to deallocate stack',0,
     &       MA_ERR)

      call smd_energy_set_component("ewald reciprocal",ewald2)

      return

      END

      subroutine smd_ewald_excl()

      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      double precision  ewald2
      character*30 pname
      character*32 sp_charge
      character*32 sp_coord
      character*32 sp_lattice
      character*32 sp_force
      character*32 sp_exlist
      character*32 sp
      character*32 tag
      integer i_q,nq
      integer i_f,i_c,i_rlat
      integer i_lat
      integer i_l,i_p
      integer nl
      double precision vol
      double precision alpha
      double precision rcutsq
      integer kmax(3)
      integer ntmp,nk
      logical result

      pname = "smd_ewald_excl"


      ewald2 = 0.0d0
c
c     get components
c     --------------
      call smd_system_get_component(sp_exlist,"excl_list",result)
      if(.not.result) return

      call smd_system_get_component(sp_charge,"charge",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no charge ',0,0)

      call smd_system_get_component(sp_coord,"coordinates",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no coordinates ',0,0)

      call smd_system_get_component(sp_lattice,"lattice",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no lattice ',0,0)

      call smd_system_get_component(sp_force,"force",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no force ',0,0)

c
c     get exluded list data
c     ---------------------
      sp = sp_exlist
      tag = "exlist:pointer"
      call smd_data_get_index(sp,tag,i_p,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "exlist:list"
      call smd_data_get_index(sp_exlist,tag,i_l,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      call smd_data_get_size(sp,tag,nl,result)
       if(nl.eq.0) return

c
c     get coord data
c     --------------
      tag = "coords"
      sp = sp_coord
      call smd_data_get_index(sp,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     get charge data
c     --------------
      tag = "charge"
      sp = sp_charge
      call smd_data_get_index(sp,tag,i_q,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      call smd_data_get_size(sp,tag,nq,result)
      write(*,*) "nq=",nq
c
c     get force data
c     --------------
      tag = "force"
      sp = sp_force
      call smd_data_get_index(sp,tag,i_f,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     get lattice data
c     ----------------
      sp = sp_lattice
      tag = "lat:rcell"
      call smd_data_get_index(sp,tag,i_rlat,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "lat:cell"
      call smd_data_get_index(sp,tag,i_lat,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)


      call smd_latt_get_vol(sp,vol)

c
c     get ewald data
c     --------------
      call smd_ewald_get_alpha(alpha)
c
c     get cutoff data
c     ---------------
      call smd_cutoff_get_rcut(rcutsq)
      rcutsq = rcutsq*rcutsq

      call       smd_ewald_excl_generic(nq,
     >                                  nl,
     >                                  alpha,
     >                                  rcutsq,
     >                                  dbl_mb(i_lat),
     >                                  dbl_mb(i_rlat),
     >                                  dbl_mb(i_q),
     >                                  dbl_mb(i_c),
     >                                  dbl_mb(i_f),
     >                                  int_mb(i_p),
     >                                  int_mb(i_l),
     >                                  ewald2)

      call smd_energy_set_component("ewald excluded",ewald2)
      return

      END

      subroutine smd_ewald_real()

      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      double precision  ewald2
      character*30 pname
      character*32 sp_charge
      character*32 sp_lattice
      character*32 sp_force
      character*32 sp_vlist
      character*32 sp
      character*32 tag
      integer i_q,nq
      integer i_f,i_c,i_rlat
      integer i_lat
      integer i_l,i_p
      integer nl
      double precision vol
      double precision alpha
      double precision rcutsq
      integer kmax(3)
      integer ntmp,nk
      logical result

      pname = "smd_ewald_real"


      ewald2 = 0.0d0
c
c     get components
c     --------------
      call smd_system_get_component(sp_charge,"charge",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no charge ',0,0)

      call smd_system_get_component(sp_force,"force",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no force ',0,0)

      call smd_system_get_component(sp_vlist,"verlet_list",result)
      if(.not.result)
     >  call errquit(
     >       pname//'no verlet_list ',0,0)

c
c     get verlet list data
c     --------------------
      sp = sp_vlist
      tag = "vlist:pointer"
      call smd_data_get_index(sp,tag,i_p,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)

      tag = "vlist:list"
      call smd_data_get_index(sp,tag,i_l,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)
      call smd_data_get_size(sp,tag,nl,result)
       if(nl.eq.0) return

      tag = "vlist:distances"
      call smd_data_get_index(sp_vlist,tag,i_c,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for'//tag,0, RTDB_ERR)


c
c     get charge data
c     --------------
      tag = "charge"
      sp = sp_charge
      call smd_data_get_index(sp,tag,i_q,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
      call smd_data_get_size(sp,tag,nq,result)
      write(*,*) "nq=",nq
c
c     get force data
c     --------------
      tag = "force"
      sp = sp_force
      call smd_data_get_index(sp,tag,i_f,result)
      if(.not. result) 
     >  call errquit(
     >       pname//'error getting index for '//tag,0, RTDB_ERR)
c
c     get ewald data
c     --------------
      call smd_ewald_get_alpha(alpha)
c
c     get cutoff data
c     ---------------
      call smd_cutoff_get_rcut(rcutsq)
      rcutsq = rcutsq*rcutsq

      write(*,*) "nl=",nl
      call       smd_ewald_real_generic(nq,
     >                                  nl,
     >                                  alpha,
     >                                  rcutsq,
     >                                  dbl_mb(i_q),
     >                                  dbl_mb(i_c),
     >                                  dbl_mb(i_f),
     >                                  int_mb(i_p),
     >                                  int_mb(i_l),
     >                                  ewald2)

c      write(*,*) "ewald4",ewald2
      
      call smd_energy_set_component("ewald real",ewald2)
      return

      END
c $Id: smd_ewald.F 22502 2012-05-20 06:11:57Z d3y133 $

       SUBROUTINE INDINT (STRING, START, END)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C Purpose:      Find the position of the first valid integer in STRING
C
C Arguments:    STRING   character string (input only)
C               START    index of beginning of integer (output only)
C               END      index of last digit of integer (output only)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Header: /tmp/mss/nwchem/src/util/indint.F,v 1.1 1997-03-24 02:00:36 gg502 Exp $
C
C $Log: not supported by cvs2svn $
C Revision 1.1  1996/08/27 21:56:14  d3e129
C removed requirments of LLE, LGE, LLT, LGT for SGITFP.
C rak
C
C Revision 1.3  1995/12/16 21:06:34  gg502
C The great implicit none-ification :-)
C
c Revision 1.2  1995/02/02  23:21:10  d3g681
c RJH: A CVS ID for every file and automated generation of a version output
c
c Revision 1.1  1994/06/14  21:54:18  gg502
c First cut at RIMP2.
c
c Revision 1.1  91/08/26  23:09:37  bernhold
c Initial revision
c 
c Revision 1.1  90/05/14  17:13:09  bernhold
c Initial revision
c 
C
C System:       Standard FORTRAN 77
C
C Copyright 1988 David E. Bernholdt
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C$Id: indint.F 19707 2010-10-29 17:59:36Z d3y133 $
       IMPLICIT NONE
       CHARACTER*(*) STRING
       CHARACTER*1 C
       INTEGER START, END
       INTEGER I
       LOGICAL INONE, SIGN
#if defined(SGITFP)
       logical l_llt, l_lgt, l_lge, l_lle
       integer ic_c, ic_0, ic_9
#endif
C
       START = 0
       END = 0
       INONE = .FALSE.
       SIGN = .FALSE.
#if defined(SGITFP)
c
       ic_0  = ichar('0')
       ic_9  = ichar('9')
#endif
C
       DO 100 I = 1, LEN(STRING)
          C = STRING(I:I)
#if defined(SGITFP)
          ic_c  = ichar(c)
          l_llt = ic_c.lt.ic_0
          l_lgt = ic_c.gt.ic_9
          l_lge = ic_c.ge.ic_0
          l_lle = ic_c.le.ic_9
          IF (INONE .AND. (l_llt .OR. l_lgt)) THEN
#else
          IF (INONE .AND. (LLT(C,'0') .OR. LGT(C,'9'))) THEN
#endif
C               End of an integer...
             INONE = .FALSE.
C               Check to make sure it wasn't just a + or a -
             IF (SIGN .AND. (START .EQ. I-1)) THEN
                SIGN = .FALSE.
                START = 0
             ELSE
                END = I - 1
                RETURN
             ENDIF
          ELSEIF (.NOT.INONE .AND. 
     1           (C.EQ.'-' .OR. C.EQ.'+')) THEN
C               This is a sign character, which may begin an integer
             SIGN = .TRUE.
             INONE = .TRUE.
             START = I
#if defined(SGITFP)
          ELSEIF (.NOT.INONE .AND. 
     1           (l_lge .AND. l_lle)) THEN
#else
          ELSEIF (.NOT.INONE .AND. 
     1           (LGE(C,'0') .AND. LLE(C,'9'))) THEN
#endif
C               This is a digit, which does begin an integer
             INONE = .TRUE.
             START = I
          ENDIF
 100   CONTINUE
C
C      If we as still INONE here, the integer is at the end of STRING
C
       IF (INONE) END = LEN(STRING)
       RETURN
       END

      subroutine top(htop,nbig,nsmall,hpvhm,lmtop,nstate,hpvbtrn,
     1     nbfmax,nchnl,nchan,nscat,nlm,iprint,ntot,nfree,ibcondx
     2     ,htopp,hpvhmp,hpvbtrnp,itell,ihow,ovbftrnp,istat,ioft,cov,
     $     nbas,nopen)
      implicit real*8 (a-h,o-z)
c
c     construct numerator (h-e) from various pieces
c     
      complex*16 htop(nbig,nsmall),hpvhm(lmtop,lmtop,nchnl**2)
      complex*16 cov(nbig,nsmall)
      complex*16 htopp(nbig,nsmall),hpvhmp(lmtop,lmtop,nchnl**2)
      complex*16 hpvbtrn(lmtop,nbfmax,nchnl**2)
      complex*16 hpvbtrnp(lmtop,nbfmax,nchnl**2)
      complex*16 ovbftrnp(lmtop,nbfmax,nchnl)
      integer nscat(nchnl),nlm(nchnl),nbas(nchnl)
      character*8 itell,ihow,istat,ioft
      istart=0
      do 21 ic=1,nchan
21    istart=istart+nscat(ic)
c
c     free free part
c
      iprev=0
c     do 31 ic=1,nchan
c.....tnr...9-94.......
      do 31 ic=1,nopen
         nlmic=nlm(ic)
         jprev=0
         do 30 jc=1,nopen
            nlmjc=nlm(jc)
            ist=nchan*(ic-1) + jc
            do ilm=1,nlmic
               do jlm=1,nlmjc
                  isub=ilm+iprev+istart
                  jsub=jlm+jprev
                  htop(isub,jsub)=hpvhm(ilm,jlm,ist)
                  htopp(isub,jsub)=hpvhmp(ilm,jlm,ist)
               enddo
            enddo
            jprev=jprev+nlmjc
 30      continue
         iprev=iprev+nlmic
 31   continue
c
c     new nall determination  ..tnr 6/20/94
c     
      nall=isub
c     
c     bound-free part
c     
      iprev=0
      do 41 ic=1,nopen
         nlmic=nlm(ic)
         jprev=0
         do 40 jc=1,nchan
            nsjc=nscat(jc)
            icc=nchan*(ic-1) + jc
            do 39 ilm=1,nlmic
               if(ibcondx.eq.0) then
                  do 37 jsc=1,nsjc
                     isub=ilm+iprev
                     jsub=jsc+jprev
                     htopp(jsub,isub) = conjg( hpvbtrnp(ilm,jsc,icc))
                     htop(jsub,isub) = conjg( hpvbtrn(ilm,jsc,icc))
 37               continue
               else
                  do 38 jsc=1,nsjc
                     isub=ilm+iprev
                     jsub=jsc+jprev
                     htopp(jsub,isub) = imag( hpvbtrnp(ilm,jsc,icc))
                     htop(jsub,isub) = imag( hpvbtrn(ilm,jsc,icc))
 38               continue
               endif
 39         continue
            jprev=jprev+nsjc
 40      continue
         iprev=iprev+nlmic
 41   continue
c     ... tnr 6/20/94
      nfree=iprev
c     nball=jprev
c     
      if(ihow.eq.itell)then
c     ... tnr 6/20/94
c     nall=nfree+jprev do not write (7)
c
c     write(7)((htopp(i,j),i=1,nall),j=1,nfree)
c     
c     load and write out bound-free overlap matrix
c     
         do i=1,nbig
            do j=1,nfree
               cov(i,j)=0.
            enddo
         enddo
         if(istat.eq.ioft)then
            nlmprev=0
            nbprev=0
c.....tnr...9-94.......
c     do 11 i=1,nchan
            do 11 i=1,nopen
               nlmic=nlm(i)
               nsic=nbas(i)      
               do 12 ilm=1,nlmic
                  ill=ilm+nlmprev
                  if(ibcondx.eq.0) then
                     do 13 ib=1,nsic
                        ibb=ib+nbprev
                        cov(ibb,ill)=conjg(ovbftrnp(ilm,ib,i))
 13                  continue
                  else
                     do 14 ib=1,nsic
                        ibb=ib+nbprev
                        cov(ibb,ill)=imag(ovbftrnp(ilm,ib,i))
 14                  continue
                  endif
 12            continue
               nlmprev=nlmprev+nlmic
               nbprev=nbprev+nsic
 11         continue
         endif
c         write(7)nbprev
c         write(7)((cov(i,j),i=1,nbprev),j=1,nfree)
c         write(7)((htop(i,j),i=1,nall),j=1,nfree)
      endif
c
      if(iprint.ne.0) then
         write(6,107)
 107     format(//' numerator matrix of (h-e)')
         do 60 i=1,nfree
            write(6,108) i,(htop(j,i),j=1,ntot)
 60      continue
 108     format(1x,i3,6f12.5,/,(4x,6f12.5))
      endif
      return
      end
c $Id: top.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsd2_t_left(a_i0,d_f1,d_i1_2,d_i1_3,d_i1_5,d_t1,d_v2,d
     &_y1,d_y2,k_f1_offset,k_i1_offset_2,k_i1_offset_3,k_i1_offset_5,k_t
     &1_offset,k_v2_offset,k_y1_offset,k_y2_offset,l_i1_offset_2,l_i1_of
     &fset_3,l_i1_offset_5,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b,toggle)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1 * P( 9 ) * y ( h4 p1 )_y * v ( h5 h6 p2 p3 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = 1 * P( 9 ) * y ( h4 h5 p1 p2 )_y * i1 ( h6 p3 )_f
C         i1 ( h4 p1 )_f + = 1 * f ( h4 p1 )_f
C         i1 ( h4 p1 )_vt + = 1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h4 h8 p1 p7 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( h9 ) * y ( h4 h9 p1 p2 )_y * i1 ( h5 h6 h9 p3 )_v
C         i1 ( h4 h5 h9 p1 )_v + = 1 * v ( h4 h5 h9 p1 )_v
C         i1 ( h4 h5 h9 p1 )_vt + = -1 * Sum ( p7 ) * t ( p7 h9 )_t * v ( h4 h5 p1 p7 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( p7 ) * y ( h4 h5 p1 p7 )_y * v ( h6 p7 p2 p3 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = -1 * P( 9 ) * Sum ( h8 ) * i1 ( h4 h5 h8 p1 )_yt * v ( h6 h8 p2 p3 )_v
C         i1 ( h4 h5 h8 p1 )_yt + = -1 * Sum ( p7 ) * t ( p7 h8 )_t * y ( h4 h5 p1 p7 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER toggle
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_i1_2
      INTEGER k_i1_offset_2
      INTEGER l_i1_offset_2
      INTEGER d_i1_3
      INTEGER k_i1_offset_3
      INTEGER l_i1_offset_3
      INTEGER d_i1_5
      INTEGER k_i1_offset_5
      INTEGER l_i1_offset_5
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER size_i1_2
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER size_i1_3
      INTEGER size_i1_5
      DOUBLE PRECISION a_i0(*)
      CHARACTER*255 filename
      IF (toggle .eq. 3) THEN
      CALL DELETEFILE(d_i1_5)
      IF (.not.MA_POP_STACK(l_i1_offset_5)) CALL ERRQUIT('ccsd2_t_left',
     &-1,MA_ERR)
      END IF
      IF (toggle .eq. 3) THEN
      CALL DELETEFILE(d_i1_3)
      IF (.not.MA_POP_STACK(l_i1_offset_3)) CALL ERRQUIT('ccsd2_t_left',
     &-1,MA_ERR)
      END IF
      IF (toggle .eq. 3) THEN
      CALL DELETEFILE(d_i1_2)
      IF (.not.MA_POP_STACK(l_i1_offset_2)) CALL ERRQUIT('ccsd2_t_left',
     &-1,MA_ERR)
      END IF
      IF (toggle .eq. 2) CALL ccsd2_t_left_1(d_y1,k_y1_offset,d_v2,k_v2_
     &offset,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_t_left_2_1(l_i1_offset_2,k_i1
     &_offset_2,size_i1_2)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_t_left_2_1_i1',filenam
     &e)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i1_2,size_i1_2)
      IF (toggle .eq. 1) CALL ccsd2_t_left_2_1(d_f1,k_f1_offset,d_i1_2,k
     &_i1_offset_2)
      IF (toggle .eq. 1) CALL ccsd2_t_left_2_2(d_t1,k_t1_offset,d_v2,k_v
     &2_offset,d_i1_2,k_i1_offset_2)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i1_2,size_i1_2)
      IF (toggle .eq. 2) CALL ccsd2_t_left_2(d_y2,k_y2_offset,d_i1_2,k_i
     &1_offset_2,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_t_left_3_1(l_i1_offset_3,k_i1
     &_offset_3,size_i1_3)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_t_left_3_1_i1',filenam
     &e)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i1_3,size_i1_3)
      IF (toggle .eq. 1) CALL ccsd2_t_left_3_1(d_v2,k_v2_offset,d_i1_3,k
     &_i1_offset_3)
      IF (toggle .eq. 1) CALL ccsd2_t_left_3_2(d_t1,k_t1_offset,d_v2,k_v
     &2_offset,d_i1_3,k_i1_offset_3)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i1_3,size_i1_3)
      IF (toggle .eq. 2) CALL ccsd2_t_left_3(d_y2,k_y2_offset,d_i1_3,k_i
     &1_offset_3,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      IF (toggle .eq. 2) CALL ccsd2_t_left_4(d_y2,k_y2_offset,d_v2,k_v2_
     &offset,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      IF (toggle .eq. 1) CALL OFFSET_ccsd2_t_left_5_1(l_i1_offset_5,k_i1
     &_offset_5,size_i1_5)
      IF (toggle .eq. 1) CALL TCE_FILENAME('ccsd2_t_left_5_1_i1',filenam
     &e)
      IF (toggle .eq. 1) CALL CREATEFILE(filename,d_i1_5,size_i1_5)
      IF (toggle .eq. 1) CALL ccsd2_t_left_5_1(d_t1,k_t1_offset,d_y2,k_y
     &2_offset,d_i1_5,k_i1_offset_5)
      IF (toggle .eq. 1) CALL RECONCILEFILE(d_i1_5,size_i1_5)
      IF (toggle .eq. 2) CALL ccsd2_t_left_5(d_i1_5,k_i1_offset_5,d_v2,k
     &_v2_offset,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      RETURN
      END
      SUBROUTINE ccsd2_t_left_1(d_a,k_a_offset,d_b,k_b_offset,a_c,t_h4b,
     &t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1 * P( 9 ) * y ( h4 p1 )_y * v ( h5 h6 p2 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h4b_1
      INTEGER p1b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_v)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1)) .eq. irrep_y) TH
     &EN
      CALL TCE_RESTRICTED_2(h4b,p1b,h4b_1,p1b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p2b,p3b,h5b_2,h6b_2,p2b_2,p3b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p2b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (h4b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_1',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_1',5,MA_ERR)
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))),p3b_2,p2b_2,h6b_2,h5b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_1',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_1',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_1',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,4,3,5,2,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,4,3,2,5,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,4,3,2,1,5,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,6,3,5,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,6,3,2,5,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,6,3,2,1,5,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,3,6,5,2,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,3,6,2,5,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,3,6,2,1,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_1',9,M
     &A_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_t_left_2(d_a,k_a_offset,d_b,k_b_offset,a_c,t_h4b,
     &t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = 1 * P( 9 ) * y ( h4 h5 p1 p2 )_y * i1 ( h6 p3 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = noab+1,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_f)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,p2b,h4b_1,h5b_1,p1b_1,p2b_1)
      CALL TCE_RESTRICTED_2(h6b,p3b,h6b_2,p3b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h5b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_2',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (h6b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p3b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_2',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_2',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_2',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,2,4,3,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,2,1,4,3,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,2,4,1,3,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),2,6,5,4,3,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),2,6,5,1,4,3,1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),2,6,5,4,1,3,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,2,5,4,3,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,2,5,1,4,3,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,2,5,4,1,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_2',9,M
     &A_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_t_left_2_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 p1 )_f + = 1 * f ( h4 p1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER p1b
      INTEGER dimc
      INTEGER h4b_1
      INTEGER p1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1)) .eq. irrep_f) TH
     &EN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1)
      CALL TCE_RESTRICTED_2(h4b,p1b,h4b_1,p1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_2_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_2_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - 1 + (noab+nvab) * (h4b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_2_1',2,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_t_left_2_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h4b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h4b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_t_left_2_1',4,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_2_1',5
     &,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_t_left_2_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 p1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h4b
      INTEGER p1b
      length = 0
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_t_left_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1)) .eq. irrep_f) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p1b - noab - 1 + nvab * (h4b - 1)
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_t_left_2_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 p1 )_vt + = 1 * Sum ( h8 p7 ) * t ( p7 h8 )_t * v ( h4 h8 p1 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h8b
      INTEGER p7b_1
      INTEGER h8b_1
      INTEGER h4b_2
      INTEGER h8b_2
      INTEGER p1b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h4b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      DO h8b = 1,noab
      IF (int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+h8b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p7b,h8b,p7b_1,h8b_1)
      CALL TCE_RESTRICTED_4(h4b,h8b,p1b,p7b,h4b_2,h8b_2,p1b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1) * int_mb(k_range+h8b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (p7b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h8b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_2_2',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_2_2',5,MA_ERR)
      IF ((h8b .lt. h4b) .and. (p7b .lt. p1b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))),p1b_2,p7b_2,h4b_2,h8b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF ((h8b .lt. h4b) .and. (p1b .le. p7b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h4b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))),p7b_2,p1b_2,h4b_2,h8b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,-1.0d0)
      END IF
      IF ((h4b .le. h8b) .and. (p7b .lt. p1b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))),p1b_2,p7b_2,h8b_2,h4b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,1,2,3,-1.0d0)
      END IF
      IF ((h4b .le. h8b) .and. (p1b .le. p7b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))),p7b_2,p1b_2,h8b_2,h4b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_2_2',6,MA_E
     &RR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_2_2',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_2_2',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_t_left_2_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h4b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h4b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_t_left_2_2',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_2_2',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_t_left_3(d_a,k_a_offset,d_b,k_b_offset,a_c,t_h4b,
     &t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( h9 ) * y ( h4 h9 p1 p2 )_y * i1 ( h5 h6 h9 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h9b
      INTEGER h4b_1
      INTEGER h9b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER h9b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = noab+1,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_v)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h9b = 1,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h9b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h9b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h4b,h9b,p1b,p2b,h4b_1,h9b_1,p1b_1,p2b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,h9b,h5b_2,h6b_2,p3b_2,h9b_2)
      dim_common = int_mb(k_range+h9b-1)
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1) * int_mb
     &(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_3',2,MA_ERR)
      IF ((h9b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h4b_1 - 1 + noab 
     &* (h9b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h4b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h9b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h9b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_3',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h9b_2
     & - 1 + noab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab * (h5b_
     &2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+h9b-1)
     &,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_3',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_3',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_3',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,3,2,5,4,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,3,2,1,5,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,3,2,5,1,4,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,6,2,5,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,6,2,1,5,4,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,6,2,5,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,2,6,5,4,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,2,6,1,5,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,2,6,5,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_3',9,M
     &A_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_t_left_3_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h9 p1 )_v + = 1 * v ( h4 h5 h9 p1 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER p1b
      INTEGER h9b
      INTEGER dimc
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER p1b_1
      INTEGER h9b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO h9b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+h9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+h9b-1)))) .eq. irrep_v) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+h9b-1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,h9b,h4b_1,h5b_1,p1b_1,h9b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_3_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_3_1',1,MA_ERR)
      IF ((h9b .le. p1b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - 1 + (noab+nvab) * (h9b_1 - 1 + (noab+nvab) * (h5b_1 - 1 + (noab
     &+nvab) * (h4b_1 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),
     &(p1b_1
     & - 1 + (noab+nvab) * (h9b_1 - 1 + (noab+nvab) * (h5b_1 - 1 + (noab
     &+nvab) * (h4b_1 - 1)))),p1b_1,h9b_1,h5b_1,h4b_1)
      end if
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h9b-1),int_mb(k_range+p1b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_3_1',2,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_t_left_3_1',3,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h5b-1),int_mb(k_range+h4b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (p1b - noab - 1 + nvab * (h5b - 1 + noab * (h4b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_t_left_3_1',4,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_3_1',5
     &,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_t_left_3_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h9 p1 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h4b
      INTEGER h5b
      INTEGER p1b
      INTEGER h9b
      length = 0
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO h9b = 1,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+p1b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_t_left_3_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO h9b = 1,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &9b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h9b-1),int_mb(k_sym+p1b-1)))) .eq. irrep_v) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h9b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h9b - 1 + noab * (p1b - noab - 1 + nvab 
     &* (h5b - 1 + noab * (h4b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_
     &mb(k_range+p1b-1) * int_mb(k_range+h9b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_t_left_3_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h9 p1 )_vt + = -1 * Sum ( p7 ) * t ( p7 h9 )_t * v ( h4 h5 p1 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER p1b
      INTEGER h9b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p7b_1
      INTEGER h9b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p1b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO h9b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+h9b-1).ne.8)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+h9b-1)))) .eq. ieor(irrep_v,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+h9b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_3_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      IF (int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+h9b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p7b,h9b,p7b_1,h9b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,p7b,h4b_2,h5b_2,p1b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1)
      dima_sort = int_mb(k_range+h9b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_3_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_3_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (p7b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h9b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_3_2',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_3_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_3_2',5,MA_ERR)
      IF ((p7b .lt. p1b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p1b_2
     & - 1 + (noab+nvab) * (p7b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))),p1b_2,p7b_2,h5b_2,h4b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p1b .le. p7b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p7b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))),p7b_2,p1b_2,h5b_2,h4b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_3_2',6,MA_E
     &RR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_3_2',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_3_2',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_t_left_3_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h4b-1),int_mb(k_range+h9b-1)
     &,3,2,1,4,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h9b -
     & 1 + noab * (p1b - noab - 1 + nvab * (h5b - 1 + noab * (h4b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_t_left_3_2',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_3_2',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE ccsd2_t_left_4(d_a,k_a_offset,d_b,k_b_offset,a_c,t_h4b,
     &t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( p7 ) * y ( h4 h5 p1 p7 )_y * v ( h6 p7 p2 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER p1b_1
      INTEGER p7b_1
      INTEGER h6b_2
      INTEGER p7b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_v)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p7b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p7b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,p7b,h4b_1,h5b_1,p1b_1,p7b_1)
      CALL TCE_RESTRICTED_4(h6b,p7b,p2b,p3b,h6b_2,p7b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p7b-1)
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_4',2,MA_ERR)
      IF ((p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (h5b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p1b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p7b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h5b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_4',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_4',5,MA_ERR)
      IF ((h6b .le. p7b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (p7b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (p7b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))),p3b_2,p2b_2,p7b_2,h6b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_4',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_4',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_4',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,4,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,2,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,2,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,4,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,2,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,2,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,4,2,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,2,4,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_4',9,M
     &A_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_t_left_5(d_a,k_a_offset,d_b,k_b_offset,a_c,t_h4b,
     &t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_ytv + = -1 * P( 9 ) * Sum ( h8 ) * i1 ( h4 h5 h8 p1 )_yt * v ( h6 h8 p2 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h8b
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER p1b_1
      INTEGER h8b_1
      INTEGER h6b_2
      INTEGER h8b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,ieor(irrep_t,irrep_v))) TH
     &EN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h8b = 1,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+h8b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,h8b,h4b_1,h5b_1,p1b_1,h8b_1)
      CALL TCE_RESTRICTED_4(h6b,h8b,p2b,p3b,h6b_2,h8b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_5',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (p1b_1 - noab - 1 + nvab * (h5b_1 - 1 + noab * (h4b_
     &1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+h8b-1)
     &,3,2,1,4,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_5',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_5',5,MA_ERR)
      IF ((h8b .lt. h6b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h8b_2 - 1)))),p3b_2,p2b_2,h6b_2,h8b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h6b .le. h8b)) THEN
      if(.not.intorb) then
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      else
      CALL GET_HASH_BLOCK_I(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),
     &(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h8b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))),p3b_2,p2b_2,h8b_2,h6b_2)
      end if
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_5',6,MA_ERR
     &)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_5',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_5',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,4,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,2,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,2,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,4,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,2,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,2,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,4,2,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,2,4,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_5',9,M
     &A_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE ccsd2_t_left_5_1(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h8 p1 )_yt + = -1 * Sum ( p7 ) * t ( p7 h8 )_t * y ( h4 h5 p1 p7 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER nxtask
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h4b
      INTEGER h5b
      INTEGER p1b
      INTEGER h8b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER p7b_1
      INTEGER h8b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER p1b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL nxtask
      nprocs = GA_NNODES()
      count = 0
      next = nxtask(nprocs,1)
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO h8b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+h8b-1).ne.8)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+h8b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+h8b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsd2_t_left_5_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      IF (int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p7b-1),int_mb(k_sym+h8b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p7b,h8b,p7b_1,h8b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,p7b,h4b_2,h5b_2,p1b_2,p7b_2)
      dim_common = int_mb(k_range+p7b-1)
      dima_sort = int_mb(k_range+h8b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsd2_t_left_5_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsd2_t_left_5_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (p7b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+h8b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsd2_t_left_5_1',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsd2_t_left_5_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsd2_t_left_5_1',5,MA_ERR)
      IF ((p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - noab - 1 + nvab * (p7b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p1b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsd2_t_left_5_1',6,MA_E
     &RR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsd2_t_left_5_1',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsd2_t_left_5_1',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsd2_t_left_5_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h4b-1),int_mb(k_range+h8b-1)
     &,3,2,1,4,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h8b -
     & 1 + noab * (p1b - noab - 1 + nvab * (h5b - 1 + noab * (h4b - 1)))
     &))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsd2_t_left_5_1',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsd2_t_left_5_1',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = nxtask(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = nxtask(-nprocs,1)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_ccsd2_t_left_5_1(l_a_offset,k_a_offset,size)
C     $Id: ccsd2_t_left.F 23885 2013-03-25 04:14:00Z kowalski $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h5 h8 p1 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h4b
      INTEGER h5b
      INTEGER p1b
      INTEGER h8b
      length = 0
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO h8b = 1,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &8b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h8b-1),int_mb(k_sym+p1b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h8b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsd2_t_left_5_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO p1b = noab+1,noab+nvab
      DO h8b = 1,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+h
     &8b-1)+int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h8b-1),int_mb(k_sym+p1b-1)))) .eq. ieor(irrep_y,irrep_t)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h8b-1)+int_mb(k_spin+p1b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h8b - 1 + noab * (p1b - noab - 1 + nvab 
     &* (h5b - 1 + noab * (h4b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_
     &mb(k_range+p1b-1) * int_mb(k_range+h8b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

*     *************************************************
*     *                                               *
*     *          nwpw_compcharge_atomic_coulomb       *
*     *                                               *
*     *************************************************

*     This routine computes the atomic coulomb interactions

      subroutine nwpw_compcharge_atomic_coulomb(ii,ia,ispin,ne,nprj,
     >                                          sw1,sw2,eh_atom)
      implicit none
      integer ii,ia
      integer ispin,ne(2),nprj
      real*8  sw1(ne(1)+ne(2),nprj)
      real*8  sw2(ne(1)+ne(2),nprj)
      real*8  eh_atom

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_compcharge.fh"

      return
      end


*     *************************************************
*     *                                               *
*     *              nwpw_compcharge_Watom            *
*     *                                               *
*     *************************************************
*
*
      real*8 function nwpw_compcharge_Watom(ii,ia,ispin,ne,nprj,sw1)
      implicit none
      integer ii,ia
      integer ispin,ne(2),nprj
      real*8  sw1(ne(1)+ne(2),nprj)
      real*8  dmatrix(nprj,nprj)

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_compcharge.fh"

*     **** local variables ****
      integer iii,iia,n,k,ms,lm,iprj,jprj,shift,indx,indx1,n1(2),n2(2)
      real*8  scal,coeff,w

*     **** external functions ****
      real*8   lattice_omega
      external lattice_omega


      iii = int_mb(ion_iontopaw(1) +ii-1)
      iia = int_mb(katm_iontopaw(1)+ia-1)

      indx = (iii-1)*2*lm_size_max
      call dcopy(2*lm_size_max,0.0d0,0,dbl_mb(Qlm(1)+indx),1)
      n1(1) = 1
      n1(2) = ne(1)+1
      n2(1) = ne(1)
      n2(2) = ne(1)+ne(2)
      scal = 1.0d0/lattice_omega()

      shift = int_mb(shift_Tndiff(1)+iia-1)
      do k=1,int_mb(nindx_Tndiff(1)+iia-1)
         lm    = int_mb(lm_Tndiff(1)+shift+k-1)
         iprj  = int_mb(iprj_Tndiff(1)+shift+k-1)
         jprj  = int_mb(jprj_Tndiff(1)+shift+k-1)
         coeff = scal*dbl_mb(coeff_Tndiff(1)+shift+k-1)
         do ms=1,ispin
            w = 0.0d0
            do n=n1(ms),n2(ms)
               w = w + sw1(n,iprj)*sw1(n,jprj)
            end do
c            indx1 = (iii-1)*2*lm_size_max+(ms-1)*lm_size_max + lm
            indx1 = indx + (ms-1)*lm_size_max + lm
            dbl_mb(Qlm(1)+indx1) = dbl_mb(Qlm(1)+indx1) + coeff*w
         end do
      end do
      call D1dB_Vector_SumAll(2*lm_size_max,dbl_mb(Qlm(1)+indx))

      return
      end 

*     ***************************************************
*     *                                                 *
*     *         nwpw_compcharge_density_matrix          *
*     *                                                 *
*     ***************************************************
*
*     This routine computes a spin dependent density matrix using sw1
*
      subroutine nwpw_compcharge_density_matrix(ispin,ne,nprj,sw1,wmatrix)
      implicit none
      integer ispin,ne(2),nprj
      real*8  sw1(ne(1)+ne(2),nprj)
      real*8  wmatrix(nprj,nprj,2)

*     **** local variables ****
      integer i,j,ms,n,n1(2),n2(2)

      n1(1) = 1
      n2(1) = ne(1)
      n1(2) = ne(1)+1
      n2(2) = ne(1)+ne(2)

      call dcopy(2*nprj*nprj,0.0d0,0,wmatrix,1)
      do j=1,nprj
         do ms=1,ispin
         do n=n1(ms),n2(ms)
            wmatrix(j,j,ms) = wmatrix(j,j,ms) + sw1(n,j)*sw1(n,j)
         end do
         end do
      end do

      do j=1,nprj
         do i=j+1,nprj
            do ms=1,ispin
            do n=n1(ms),n2(ms)
               tmp = sw1(n,i)*sw1(n,j)
               wmatrix(i,j,ms) = wmatrix(i,j,ms) + tmp
               wmatrix(j,i,ms) = wmatrix(j,i,ms) + tmp
            end do
            end do
         end do
      end do
      return
      end


*    **********************************************************
*    *                                                        *
*    *              nwpw_compcharge_Watom1_sub                *
*    *                                                        *
*    **********************************************************
      real*8 function nwpw_compcharge_Watom1_sub(ispin,nprj,wmatrix,
     >                                            nindx1,
     >                                            iprj_indx1,jprj_indx1,
     >                                            kprj_indx1,lprj_indx1,
     >                                            vh_indx1)
      implicit none
      integer ispin,ne(2),nprj
      real*8  wmatrix(nprj,nprj,2)
      integer nindx1
      integer iprj_indx1(*),jprj_indx1(*)
      integer kprj_indx1(*),lprj_indx1(*)
      real*8  vh_indx1(*)

*     **** local variables ****
      integer k,ms,lm,iprj,jprj,kprj,lprj
      real*8 vh,W

      W = 0.0d0
      do k=1,nindx1
         iprj = iprj_indx1(k)
         jprj = jprj_indx1(k)
         kprj = kprj_indx1(k)
         lprj = lprj_indx1(k)
         vh   = vh_indx1(k)
         do ms=1,ispin
            W = W + 0.5d0*vh*
     >                   *wdensity(iprj,jprj,ms)
     >                   *wdensity(kprj,lprj,ms)
         end do
      end do
      if (ispin.eq.1) W = W + W

      nwpw_compcharge_Watom1_sub = W
      return 
      end

*    **********************************************************
*    *                                                        *
*    *              nwpw_compcharge_Watom2_sub                *
*    *                                                        *
*    **********************************************************
      real*8 function nwpw_compcharge_Watom2_sub(ispin,nprj,wmatrix,
     >                                           lmsize_max,Qlm,
     >                                           nindx2,lm_indx2(*),
     >                                           iprj_indx2,jprj_indx2,
     >                                           vcmp_indx2)
      implicit none
      integer ispin,ne(2),nprj
      real*8  wmatrix(nprj,nprj,2)
      integer nindx2,lm_indx2(*)
      integer iprj_indx2(*),jprj_indx2(*)
      real*8  vcmp_indx2(*)

*     **** local variables ****
      integer k,lm,iprj,jprj,ms
      real*8 W,vg

      W = 0.0d0
      do k=1,nindx2
         lm   = lm_indx2(k)
         iprj = iprj_indx2(k)
         jprj = jprj_indx2(k)
         vcmp = vcmp_indx2(k)
         do ms=1,ispin
            W = W + (Qlm(lm,1)+Qlm(lm,ispin))*vcmp*wdensity(iprj,jprj,ms)
         end do
      end do
      if (ispin.eq.1) W = W + W

      nwpw_compcharge_Watom2_sub = W
      return
      end

*    **********************************************************
*    *                                                        *
*    *              nwpw_compcharge_Watom3_sub                *
*    *                                                        *
*    **********************************************************
      real*8 function nwpw_compcharge_Watom3_sub(ispin,lmsize_max,Qlm,
     >                                           nindx3,lm_indx3,
     >                                           vg_indx3)
      implicit none
      integer ispin,ne(2),nprj
      real*8  wmatrix(nprj,nprj,2)
      integer nindx3,lm_indx3(*)
      real*8  vg_indx3(*)

*     **** local variables ****
      integer k,lm
      real*8 W,vg

      W = 0.0d0
      do k=1,nindx3
         lm = lm_indx3(k)
         vg = vg_indx3(k)
         W  = W + 0.5d0*vg*(Qlm(lm,1)+Qlm(lm,ispin))
      end do
      if (ispin.eq.1) W = W + W
     
      nwpw_compcharge_Watom3_sub = W
      return
      end

      subroutine nwpw_compcharge_Vatom1_sub(ispin,ne,nprj,sw1,wmatrix,
     >                                      nindx1,
     >                                      iprj_indx1,jprj_indx1,
     >                                      kprj_indx1,lprj_indx1,
     >                                      vh_indx1)
      implicit none
      integer ispin,ne(2),nprj
      real*8  sw1(ne(1)+ne(2),nprj)
      real*8  wmatrix(nprj,nprj,2)
      integer nindx1
      integer iprj_indx1(*),jprj_indx1(*)
      integer kprj_indx1(*),lprj_indx1(*)
      real*8  vh_indx1(*)

      do k=1,nindx1
         iprj = iprj_indx1(k)
         jprj = jprj_indx1(k)
         kprj = kprj_indx1(k)
         lprj = lprj_indx1(k)
         vh   = vh_indx1(k)
         wab = 0.0d0
         wcd = 0.0d0
         do n=1,ne(1)+ne(2)
            wcd = wcd + sw1(n,kprj)*sw1(n,lprj)
         end do
         if (ispin.eq.1) wcd = wcd+wcd
         do n=1,ne(1)+ne(2)
            sw2(n,iprj) = vh*wcd*sw1(n,jprj)
         end do
      end do

      return
      end


c $Id: nwpw_compcharge2.F 25011 2013-12-19 17:45:25Z d3y133 $

      subroutine util_nwsort(n,value,vector,order)
c
c $Id: util_nwsort.F 24349 2013-06-23 04:30:58Z d3y133 $
c
c Sort the eigenvalues and eigenvectors 
c in an ascending/descending order
c Written by So Hirata, Feb 2002.
c (c) Battelle, PNNL, 2002.
c
      implicit none
      integer n
      double precision value(n)
      double precision vector(n,n)
      double precision minval,maxval,swap
      character*1 order
      integer i,j,k

      if ((order.eq.'A').or.(order.eq.'a')) then
        do i=1,n-1
          minval=value(i)
          k=0
          do j=i+1,n
            if (value(j).lt.minval) then
              k=j
              minval=value(j)
            endif
          enddo
          if (k.ne.0) then
            swap=value(i)
            value(i)=value(k)
            value(k)=swap
            do j=1,n
              swap=vector(j,i)
              vector(j,i)=vector(j,k)
              vector(j,k)=swap
            enddo
          endif
        enddo
      else if ((order.eq.'D').or.(order.eq.'d')) then
        do i=1,n-1
          maxval=value(i)
          k=0
          do j=i+1,n
            if (value(j).gt.maxval) then
              k=j
              maxval=value(j)
            endif
          enddo
          if (k.ne.0) then
            swap=value(i)
            value(i)=value(k)
            value(k)=swap
            do j=1,n
              swap=vector(j,i)
              vector(j,i)=vector(j,k)
              vector(j,k)=swap
            enddo
          endif
        enddo
      endif
      return
      end

      subroutine argos_server
c
      implicit none
c
#include "argos.fh"
c
#if !defined(WIN32)
      integer*4 create_client_socket
      integer client_socket_write
      external create_client_socket,client_socket_write
c
      integer*4 iiport,lens
c
      character*255 string
      integer numbyt
c
      if(iport.le.0.or.me.gt.0) return
c
c     open socket to server
c
      iiport=iport
      if(.not.lserver) then
      write(*,1) server(1:index(server,' ')-1),iiport
    1 format('Attempt to open socket to ',a,' port ',i5)
      isocket=create_client_socket(server,iiport)
      lserver=isocket.gt.0
      endif
c
      if(lserver) then
      print*,'server socket open'
      else
      print*,'server socket error'
      endif
c
      if(.not.lserver) return
c
      write(string,1000) stime,etot,temp,pres*1.0125d-5,volume
 1000 format("tETpV",4f12.3,f12.6)
c
      lens=66
      string(66:66)=char(13)
c
      numbyt=client_socket_write(isocket,string,lens)
c
      print*,'Bytes written to socket is ',numbyt
c
#endif
      return
      end
c $Id: argos_server.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: rak31.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      logical function rak_justrunvib(rtdb)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "global.fh"
#include "geom.fh"
      integer rtdb
c
      character*255 filehess
      logical ignore
      integer geom, nat
      ignore = rtdb_parallel(.false.)
      if ((ga_nodeid()).eq.0) then
         if (.not. rtdb_cget(rtdb, 'task:hessian file name', 1,
     $        filehess)) then
            call util_file_name('hess',  .false., .false.,filehess)
         endif
c
c     create/load reference geometry
c
        if (.not.geom_create(geom,'geometry')) call errquit
     $      ('task_freq:geom_create failed?',1, GEOM_ERR)
        if (.not.geom_rtdb_load(rtdb,geom,'geometry'))
     $      call errquit
     $      ('task_freq:geom_rtdb_load failed?',2, RTDB_ERR)
        if (.not. geom_ncent(geom,nat)) call errquit
     $      ('task_freq:geom_ncent failed?',3, GEOM_ERR)
        if (.not. geom_destroy(geom)) call errquit
     $      ('task_freq:geom_destroy failed?',911, GEOM_ERR)
        call vib_vib(rtdb,filehess,.true.,
     $      0,.false.,0,.false.,nat)
      endif
      call ga_sync()
      ignore = rtdb_parallel(.true.)
      rak_justrunvib = .true.
      end

*
* $Id: ddot.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      double precision function ddot(n,dx,incx,dy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dy(1),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      ddot = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      ddot = dtemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dx(i)*dy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dtemp = dtemp + dx(i)*dy(i) + dx(i + 1)*dy(i + 1) +
     *   dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
   50 continue
   60 ddot = dtemp
      return
      end

      subroutine argos_cafe_copya(ia,nami,wgti,numa,nam,wgt,num,ityp)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer ia
      character*6 nami(24),nam(mat,nparms)
      real*8 wgti(24),wgt(mat,mset)
      integer numa(24),num(mat,nparms),ityp(mat,nparms)
c
      integer i
c
      if(.not.lfree) then
      do 1 i=1,nparms
      nam(ia,i)=nami(i)
      wgt(ia,i)=wgti(i)
      num(ia,i)=numa(i)
      ityp(ia,i)=0
      if(nam(ia,i)(6:6).eq.'Q') ityp(ia,i)=1
      if(nam(ia,i)(6:6).eq.'H') ityp(ia,i)=2
    1 continue
      else
      do 2 i=1,3
      nam(ia,i)=nami(i)
      wgt(ia,i)=wgti(i)
      num(ia,i)=numa(i)
      ityp(ia,i)=0
      if(nam(ia,i)(6:6).eq.'Q') ityp(ia,i)=1
      if(nam(ia,i)(6:6).eq.'H') ityp(ia,i)=2
    2 continue
      wgt(ia,4)=wgt(ia,3)-wgt(ia,2)
      wgt(ia,5)=wgt(ia,2)
      wgt(ia,6)=wgt(ia,3)
      endif
c
      return
      end
c $Id: argos_cafe_copya.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine get_input_filename(input_filename)
C     $Id: get_inp_file.F 22340 2012-04-25 22:02:33Z edo $
      implicit none
#include "util.fh"
#include "inp.fh"
#include "global.fh"
#include "stdio.fh"
      character*(*) input_filename
c     
c     Process zero ends up with the name of the input file
c     from the command line arguments or nwchem.nw if the first
c     argument begins with a hypen (-).
c
c     If the file cannot be accessed append .nw
c     
      character*(nw_max_path_len) test
      integer arg,nargs
#if defined(CRAY)
      integer ilen,ierror
#endif
#if defined(FUJITSU_VPP)
      logical file_exists
#endif
      integer l
#ifdef USE_POSIXF
      integer*4 ipxfargc
      external ipxfargc
      nargs =ipxfargc() 
#else
#if defined(EXT_INT) 
      integer*4 iargc
#else
      integer iargc
#endif
#if !(defined(IFCV8) || defined(HPUX)|| ( __GNUC__ >= 4))
      external iargc
#endif
c     
      nargs = iargc()
#endif
      do arg = 1, nargs
         call util_getarg(arg,test)
         if (arg .eq. 1) input_filename = test
         write(LuOut,1) arg, test(1:inp_strlen(test))
c
c     hack to get nwchem.nw to be read with mpi
c
         if(inp_strlen(test).eq.0.and.arg.eq.1) 
     $        input_filename(1:1)='-'
 1       format(' argument',i3,' = ',a)
      enddo
 2    continue
      if (nargs .ge. 1) then
         if (input_filename(1:1) .eq. '-') 
     $        input_filename = 'nwchem.nw'
      else
         input_filename = 'nwchem.nw'
      endif
c
#if defined(CYGNUS) || defined(WIN32)
      call fix_windows_path(input_filename)
#endif
c
#ifdef FUJITSU_VPP
      inquire (file=input_filename, exist=file_exists)
       if (.not. file_exists) goto 10
#else
      open(LuIn,file=input_filename,status='old',err=10)
      close(LuIn)
#endif
      return
c
 10   l = inp_strlen(input_filename)
      write(LuOut,*) ' Unable to open ',input_filename(1:l), 
     $     ' --- appending .nw'
      input_filename(l+1:l+3) = '.nw'
c     
      end

      SUBROUTINE OFFSET_ccsdtq_lr_alpha_15_39_5_1(l_a_offset,k_a_offset,
     &size)
C     $Id: offset_ccsdtq_lr_alpha_15_39_5_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h3 h4 p13 h16 p1 p11 )_ytrat
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h3b
      INTEGER h4b
      INTEGER p13b
      INTEGER h16b
      INTEGER p1b
      INTEGER p11b
      length = 0
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p13b = noab+1,noab+nvab
      DO h16b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p11b = p1b,noab+nvab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+p13b-1
     &) .eq. int_mb(k_spin+h16b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p1
     &1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p13b-1),ieor(int_mb(k_sym+h16b-1),ieor(int_mb(k_sym+p1b-1),i
     &nt_mb(k_sym+p11b-1)))))) .eq. ieor(irrep_y,ieor(irrep_tra,irrep_t)
     &)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p13b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+p1b-1)
     &+int_mb(k_spin+p11b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lr_alpha_15_39_5_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO p13b = noab+1,noab+nvab
      DO h16b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p11b = p1b,noab+nvab
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+p13b-1
     &) .eq. int_mb(k_spin+h16b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p1
     &1b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+p13b-1),ieor(int_mb(k_sym+h16b-1),ieor(int_mb(k_sym+p1b-1),i
     &nt_mb(k_sym+p11b-1)))))) .eq. ieor(irrep_y,ieor(irrep_tra,irrep_t)
     &)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+p13b-1)+int_mb(k_spin+h16b-1)+int_mb(k_spin+p1b-1)
     &+int_mb(k_spin+p11b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p11b - noab - 1 + nvab * (p1b - noab - 1
     & + nvab * (h16b - 1 + noab * (p13b - noab - 1 + nvab * (h4b - 1 + 
     &noab * (h3b - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) * int_
     &mb(k_range+p13b-1) * int_mb(k_range+h16b-1) * int_mb(k_range+p1b-1
     &) * int_mb(k_range+p11b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      LOGICAL FUNCTION IS_ACTIVE_1(g1b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER g1b
      is_active_1 = .false.
      if(int_mb(k_active+g1b-1).eq.1) is_active_1 = .true.
      RETURN
      END
      LOGICAL FUNCTION IS_ACTIVE_2(g1b,g2b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER g1b
      INTEGER g2b
      is_active_2 = .false.
      if((int_mb(k_active+g1b-1).eq.1).and.
     &   (int_mb(k_active+g2b-1).eq.1)) is_active_2 = .true.
      RETURN
      END
      LOGICAL FUNCTION IS_ACTIVE_3(g1b,g2b,g3b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER g1b
      INTEGER g2b
      INTEGER g3b
      is_active_3 = .false.
      if((int_mb(k_active+g1b-1).eq.1).and.
     &   (int_mb(k_active+g2b-1).eq.1).and.
     &   (int_mb(k_active+g3b-1).eq.1)) is_active_3 = .true. 
      RETURN
      END
      LOGICAL FUNCTION IS_ACTIVE_4(g1b,g2b,g3b,g4b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER g1b
      INTEGER g2b
      INTEGER g3b
      INTEGER g4b
      is_active_4 = .false.
      if((int_mb(k_active+g1b-1).eq.1).and.
     &   (int_mb(k_active+g2b-1).eq.1).and.
     &   (int_mb(k_active+g3b-1).eq.1).and.
     &   (int_mb(k_active+g4b-1).eq.1)) is_active_4 = .true.
      RETURN
      END
      LOGICAL FUNCTION IS_ACTIVE_4_O(g1b,g2b,g3b,g4b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER g1b
      INTEGER g2b
      INTEGER g3b
      INTEGER g4b
      is_active_4_o = .false.
      if((int_mb(k_active_o+g1b-1).eq.1).and.
     &   (int_mb(k_active_o+g2b-1).eq.1).and.
     &   (int_mb(k_active_o+g3b-1).eq.1).and.
     &   (int_mb(k_active_o+g4b-1).eq.1)) is_active_4_o = .true.
      RETURN
      END
      LOGICAL FUNCTION ONE_OF_TWO_ACT(g1b,g2b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER g1b
      INTEGER g2b
      one_of_two_act = .false.
      if((int_mb(k_active+g1b-1).eq.1).or.
     &   (int_mb(k_active+g2b-1).eq.1)) one_of_two_act = .true.
      RETURN
      END
      LOGICAL FUNCTION is_active_t(h1,h2,h3,p1,p2,p3)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER h1,h2,h3
      INTEGER p1,p2,p3
      INTEGER ahole,aparticle
      is_active_t = .false.
      ahole=int_mb(k_active+h1-1)+int_mb(k_active+h2-1)
     &     +int_mb(k_active+h3-1)
      aparticle=int_mb(k_active+p1-1)+int_mb(k_active+p2-1)
     &      +int_mb(k_active+p3-1)
      if((ahole.ge.2).and.(aparticle.ge.2)) is_active_t = .true.
      RETURN
      END
      LOGICAL FUNCTION is_active_t_iii(h1,h2,h3,p1,p2,p3)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER h1,h2,h3
      INTEGER p1,p2,p3
      INTEGER ahole,aparticle
      is_active_t_iii = .false.
      ahole=int_mb(k_active+h1-1)+int_mb(k_active+h2-1)
     &     +int_mb(k_active+h3-1)
      aparticle=int_mb(k_active+p1-1)+int_mb(k_active+p2-1)
     &      +int_mb(k_active+p3-1)
      if((ahole.eq.3).and.(aparticle.eq.3)) is_active_t_iii = .true.
      RETURN
      END

c $Id: activity.F 21409 2011-11-05 06:36:24Z d3y133 $

      SUBROUTINE vib_CHKHESS(HESS,NAT3,first_pass)
* $Id: vib_chkhess.F 19708 2010-10-29 18:04:21Z d3y133 $
C
C  This routine checks to make sure the analytic Hessian is symmetric
C
      IMPLICIT NONE ! REAL*8 (A-H,O-Z)
#include "stdio.fh"
      LOGICAL LSYM
      double precision thresh
      PARAMETER(THRESH = 1.0D-5)
      integer nat3
      double precision HESS(NAT3,NAT3) ! full square Hessian
      logical first_pass
c
      double precision xdiff
      integer iii,  jjj, jjjend
C
      LSYM = .TRUE.
      DO 00100 III = 2,NAT3  ! loop over size-1
         JJJEND = III-1
         DO 00100 JJJ = 1,JJJEND
            XDIFF = HESS(III,JJJ)-HESS(JJJ,III)  ! difference of ij and ji
            XDIFF = ABS(XDIFF)
            IF(XDIFF.GT.THRESH)THEN ! is it symmetric?
               WRITE(luout,*)
               WRITE(luout,*)' **** HESSIAN NOT SYMMETRIC ****'
               WRITE(luout,*)' HESS(',III,',',JJJ,') =',HESS(III,JJJ)
               WRITE(luout,*)' HESS(',JJJ,',',III,') =',HESS(JJJ,III)
               WRITE(luout,*)
               LSYM = .FALSE.
            ENDIF
00100 CONTINUE
C
      IF (LSYM.and.first_pass) THEN
        WRITE(luout,*)
        WRITE(luout,*)' Nuclear Hessian passed symmetry test '
        WRITE(luout,*)
      END IF
      RETURN
      END

*     **************************************************
*     *                                                *
*     *            nwpw_meta_gga_bd                    *
*     *                                                *
*     **************************************************
      block data nwpw_meta_gga_bd
      implicit none
#include "nwpw_meta_gga.fh"
      data meta_on/.false./
      end

*     **************************************************
*     *                                                *
*     *            nwpw_meta_gga_init                  *
*     *                                                *
*     **************************************************
      subroutine nwpw_meta_gga_init()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_meta_gga.fh"
#include "nwxc.fh"

*     **** local variables ****
      logical ok
      integer n2ft3d

      meta_on = nwxc_is_mgga()

      if (meta_on) then
         call D3dB_n2ft3d(1,n2ft3d)
         ok =        MA_alloc_get(mt_dbl, 2*n2ft3d,
     >                     'dfdtau',dfdtau(2),dfdtau(1))
         ok = ok.and.MA_alloc_get(mt_dbl, 2*n2ft3d,
     >                     'tau',tau(2),tau(1))
         if (.not.ok)
     >      call errquit('nwpw_meta_gga_init:out of heap',0,MA_ERR)
         call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(dfdtau(1)),1)
         call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(tau(1)),1)
      end if
      return
      end

*     **************************************************
*     *                                                *
*     *            nwpw_meta_gga_end                   *
*     *                                                *
*     **************************************************
      subroutine nwpw_meta_gga_end()
      implicit none

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_meta_gga.fh"

      logical ok

      if (meta_on) then
         ok =        MA_free_heap(dfdtau(2))
         ok = ok.and.MA_free_heap(tau(2))
         if (.not.ok)
     >      call errquit('nwpw_meta_gga_end:freeing heap',0,MA_ERR)
      end if
      meta_on = .false.
      return
      end

*     **************************************************
*     *                                                *
*     *            nwpw_meta_gga_on                    *
*     *                                                *
*     **************************************************
      logical function nwpw_meta_gga_on()
      implicit none

#include "nwpw_meta_gga.fh"

      nwpw_meta_gga_on = meta_on
      return
      end



*     **************************************************
*     *                                                *
*     *            nwpw_meta_gga_gen_tau               *
*     *                                                *
*     **************************************************

*   This routine computes
*   tau = |grad psi|
*
      subroutine nwpw_meta_gga_gen_tau(ispin,neq,psi)
      implicit none
      integer ispin,neq(2)
      complex*16 psi(*)


#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_meta_gga.fh"

*     **** local variables ****
      integer ms,n,n2ft3d,nfft3d,npack1,xyz,nx,ny,nz
      integer G(3),n1(2),n2(2),dpsi(2)
      real*8 scal2

*     **** external functions ****
      integer  Pack_G_indx
      external Pack_G_indx
      real*8   lattice_omega
      external lattice_omega


      if (meta_on) then 
      n1(1) = 1
      n2(1) = neq(1)
      n1(2) = neq(1)+1
      n2(2) = neq(1)+neq(2)

      scal2 = 0.5d0/lattice_omega()

      call D3dB_nfft3d(1,nfft3d)
      call D3dB_n2ft3d(1,n2ft3d)
      call Pack_npack(1,npack1)

*     **** allocate stack memory ****
      if (.not.MA_push_get(mt_dcpl, nfft3d,'dpsi',dpsi(2),dpsi(1)))
     >   call errquit('nwpw_meta_gga_Hpsik:out of stack',0,MA_ERR)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(dpsi(1)),1)

      G(1)  = Pack_G_indx(1,1)
      G(2)  = Pack_G_indx(1,2)
      G(3)  = Pack_G_indx(1,3)

      call dcopy(2*n2ft3d,0.0d0,0,dbl_mb(tau(1)),1)
      do ms=1,ispin
         do n=n1(ms),n2(ms)
            do xyz=1,3

*              **** compute dpsi(G,1:3) ****
               call Pack_tc_iMul(1,dbl_mb(G(xyz)),
     >                             psi(1+(n-1)*npack1),
     >                             dcpl_mb(dpsi(1)))

*              **** compute dpsi(r,1:3) ****
               call Pack_c_unpack(1,dcpl_mb(dpsi(1)))
               call D3dB_cr_fft3b(1,dcpl_mb(dpsi(1)))

*              **** tau(r,ms) += dpsi(r,ms)**2 ****
               call D3dB_rr_SqrAdd(1,dcpl_mb(dpsi(1)),
     >                               dbl_mb(tau(1)+(ms-1)*n2ft3d))
            end do
         end do
         call D3dB_r_SMul1(1,(scal2),dbl_mb(tau(1)+(ms-1)*n2ft3d))
         call D3dB_r_Zero_Ends(1,dbl_mb(tau(1)+(ms-1)*n2ft3d))
      end do

*     **** deallocate stack ****
      if (.not.MA_pop_stack(dpsi(2)))
     >   call errquit('nwpw_meta_gga_Hpsik:popping stack',0,MA_ERR)


      end if
      return
      end


*     **************************************************
*     *                                                *
*     *            nwpw_meta_gga_Hpsik                 *
*     *                                                *
*     **************************************************

*   This routine computes
*   Hpsik = del dot (dfdtau * del psi)
*
      subroutine nwpw_meta_gga_Hpsik(ispin,neq,psi,Hpsi)
      implicit none
      integer ispin,neq(2)
      complex*16 psi(*)
      complex*16 Hpsi(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_meta_gga.fh"

*     **** local variables ****
      integer ms,n,n2ft3d,nfft3d,npack1,nx,ny,nz,xyz
      integer G(3),n1(2),n2(2),dpsi(2)
      real*8 scal1,scal2

*     **** external functions ****
      integer  Pack_G_indx
      external Pack_G_indx
      real*8   lattice_omega
      external lattice_omega

      if (meta_on) then
      n1(1) = 1
      n2(1) = neq(1)
      n1(2) = neq(1)+1
      n2(2) = neq(1)+neq(2)

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 0.5d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()


      call D3dB_nfft3d(1,nfft3d)
      call D3dB_n2ft3d(1,n2ft3d)
      call Pack_npack(1,npack1)

*     **** allocate stack memory ****
      if (.not.MA_push_get(mt_dcpl, nfft3d,'dpsi',dpsi(2),dpsi(1)))
     >   call errquit('nwpw_meta_gga_Hpsik:out of stack',0,MA_ERR)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(dpsi(1)),1)

      G(1)  = Pack_G_indx(1,1)
      G(2)  = Pack_G_indx(1,2)
      G(3)  = Pack_G_indx(1,3)

      do ms=1,ispin
      do n=n1(ms),n2(ms)
         do xyz=1,3

*           **** compute dpsi(G,1:3) ****
            call Pack_tc_iMul(1,dbl_mb(G(xyz)),
     >                          psi(1+(n-1)*npack1),
     >                          dcpl_mb(dpsi(1)))

*           **** compute dpsi(r,1:3) ****
            !call Pack_c_SMul1(1,scal2,dcpl_mb(dpsi(1)))
            call Pack_c_unpack(1,dcpl_mb(dpsi(1)))
            call D3dB_cr_fft3b(1,dcpl_mb(dpsi(1)))

*           **** multiply dpsi(r,1:3) = dfdtau(r,ms)*dpsi(r,1:3) ****
            call D3dB_rr_Mul2(1,dbl_mb(dfdtau(1)+(ms-1)*n2ft3d),
     >                          dcpl_mb(dpsi(1)))

*           **** compute dpsi(G,1:3) ****
            call D3dB_r_Zero_Ends(1,dcpl_mb(dpsi(1)))
            call D3dB_rc_fft3f(1,dcpl_mb(dpsi(1)))
            call Pack_c_pack(1,dcpl_mb(dpsi(1)))

*           **** compute Hpsi = grad dot dpsi(G) ****
            call Pack_c_SMul1(1,(scal1),dcpl_mb(dpsi(1)))
            call Pack_tc_iMul2(1,dbl_mb(G(xyz)),
     >                          dcpl_mb(dpsi(1)))
            call Pack_cc_Sum2(1,dcpl_mb(dpsi(1)),Hpsi(1+(n-1)*npack1))

         end do
      end do
      end do

*     **** deallocate stack ****
      if (.not.MA_pop_stack(dpsi(2)))
     >   call errquit('nwpw_meta_gga_Hpsik:popping stack',0,MA_ERR)

      end if
      return
      end


*     **************************************************
*     *                                                *
*     *            nwpw_meta_gga_pxc                   *
*     *                                                *
*     **************************************************
      real*8 function nwpw_meta_gga_pxc(ispin,neq,psi)
      implicit none
      integer ispin,neq(2)
      complex*16 psi(*)

#include "mafdecls.fh"
#include "errquit.fh"
#include "nwpw_meta_gga.fh"

*     **** local variables ****
      integer ms,n,n2ft3d,nfft3d,npack1,nx,ny,nz,xyz
      integer G(3),n1(2),n2(2),dpsi(2)
      real*8 scal1,scal2,ee
      real*8 pmeta

*     **** external functions ****
      integer  Pack_G_indx
      external Pack_G_indx
      real*8   lattice_omega
      external lattice_omega

      pmeta = 0.0d0

      if (meta_on) then
      n1(1) = 1
      n2(1) = neq(1)
      n1(2) = neq(1)+1
      n2(2) = neq(1)+neq(2)

      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      scal1 = 0.5d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()


      call D3dB_nfft3d(1,nfft3d)
      call D3dB_n2ft3d(1,n2ft3d)
      call Pack_npack(1,npack1)

*     **** allocate stack memory ****
      if (.not.MA_push_get(mt_dcpl, nfft3d,'dpsi',dpsi(2),dpsi(1)))
     >   call errquit('nwpw_meta_gga_Hpsik:out of stack',0,MA_ERR)
      call dcopy(2*nfft3d,0.0d0,0,dcpl_mb(dpsi(1)),1)

      G(1)  = Pack_G_indx(1,1)
      G(2)  = Pack_G_indx(1,2)
      G(3)  = Pack_G_indx(1,3)

      do ms=1,ispin
      do n=n1(ms),n2(ms)
         do xyz=1,3

*           **** compute dpsi(G,1:3) ****
            call Pack_tc_iMul(1,dbl_mb(G(xyz)),
     >                          psi(1+(n-1)*npack1),
     >                          dcpl_mb(dpsi(1)))

*           **** compute dpsi(r,1:3) ****
            !call Pack_c_SMul1(1,scal2,dcpl_mb(dpsi(1)))
            call Pack_c_unpack(1,dcpl_mb(dpsi(1)))
            call D3dB_cr_fft3b(1,dcpl_mb(dpsi(1)))

*           **** multiply dpsi(r,1:3) = dfdtau(r,ms)*dpsi(r,1:3) ****
            call D3dB_rr_Mul2(1,dbl_mb(dfdtau(1)+(ms-1)*n2ft3d),
     >                          dcpl_mb(dpsi(1)))

*           **** compute dpsi(G,1:3) ****
            call D3dB_r_Zero_Ends(1,dcpl_mb(dpsi(1)))
            call D3dB_rc_fft3f(1,dcpl_mb(dpsi(1)))
            call Pack_c_pack(1,dcpl_mb(dpsi(1)))

*           **** compute Hpsi = grad dot dpsi(G) ****
            call Pack_c_SMul1(1,(scal1),dcpl_mb(dpsi(1)))
            call Pack_tc_iMul2(1,dbl_mb(G(xyz)),
     >                          dcpl_mb(dpsi(1)))
            call Pack_cc_idot(1,psi(1+(n-1)*npack1),dcpl_mb(dpsi(1)),ee)
            pmeta = pmeta - ee

         end do
      end do
      end do

*     **** deallocate stack ****
      if (.not.MA_pop_stack(dpsi(2)))
     >   call errquit('nwpw_meta_gga_Hpsik:popping stack',0,MA_ERR)

      call Parallel_SumAll(pmeta)
      if (ispin.eq.1) pmeta = pmeta + pmeta

      end if

      nwpw_meta_gga_pxc = pmeta
      return
      end
c $Id: nwpw_meta_gga.F 25011 2013-12-19 17:45:25Z d3y133 $

*
* $Id: rak22.F 22841 2012-09-12 06:55:13Z d3y133 $
*
C> \ingroup task
C> @{
      logical function task_accy(rtdb)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "geom.fh"
#include "bas.fh"
#include "rtdb.fh"
#include "global.fh"
      logical int_normalize
      external int_normalize
      integer rtdb
      integer geom, basis
      integer szbuf, maxg, maxscr, lmax, nshell
      integer size_grad, size_scr, size_labs
      integer h_grad_1, h_grad_2, h_labs, h_scr
      integer k_grad_1, k_grad_2, k_labs, k_scr
      logical status
c
      if (.not.geom_create(geom,'geometry'))
     &    call errquit('raktest_accy: geom_create failed?',911,
     &       GEOM_ERR)
c
      if (.not. geom_rtdb_load(rtdb,geom,'geometry')) call errquit
     &    ('raktest_accy: geom_rtdb_load -ref failed',911, RTDB_ERR)
      
c
      if (.not.bas_create(basis,'ao basis')) call errquit
     &      ('bas_create failed',911, BASIS_ERR)
      if (.not.bas_rtdb_load(rtdb,geom,basis,'ao basis')) call errquit
     &      ('bas_rtdb_load failed',911, RTDB_ERR)
c
      if (ga_nodeid().eq.0) then
        if (.not.geom_print(geom)) stop ' print error'
        if (.not.bas_print(basis)) stop ' print error'
        if (.not.gbs_map_print(basis)) stop ' gbs_map_print 2?'
      endif
      if (.not.int_normalize(rtdb,basis)) stop ' norm error 1'
      if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont fe'
      if (.not.bas_high_angular(basis,Lmax)) stop 'bas_ha fe'
c
      szbuf = (Lmax+1)*(Lmax+2)/2
      szbuf = szbuf**4
c
      call intd_init(rtdb,1,basis)
      call intb_mem_2e4c(maxg,maxscr)
      maxscr = maxscr + szbuf
      maxscr = maxscr + maxscr/5 + 1
      maxscr = max(51000,maxscr)
c
      size_grad = 12*szbuf ! 2 grad buffers
      size_scr  = maxscr
      size_labs = 4*szbuf ! for labels
c
      if (.not.ma_push_get(mt_dbl,size_grad,' grad buf 1 ',
     &    h_grad_1, k_grad_1)) stop ' push failed grad 1'
      if (.not.ma_push_get(mt_dbl,size_grad,' grad buf 2 ',
     &    h_grad_2, k_grad_2)) stop ' push failed grad 2'
      if (.not.ma_push_get(mt_dbl,size_scr,' scratch ',
     &    h_scr, k_scr)) stop ' push failed scratch '
      if (.not.ma_push_get(mt_int,size_labs,' labels ',
     &    h_labs, k_labs)) stop ' push failed labels'
      call task_accy_a(rtdb,geom,basis,
     &    size_grad,size_scr,size_labs,nshell,
     &    dbl_mb(k_grad_1),dbl_mb(k_grad_2),
     &    dbl_mb(k_scr),int_mb(k_labs))
c
      
c
      status = .true.
      status = status.and.ma_pop_stack(h_labs)
      status = status.and.ma_pop_stack(h_scr)
      status = status.and.ma_pop_stack(h_grad_1)
      status = status.and.ma_pop_stack(h_grad_2)
      task_accy = status
c
      end
C> @}
      subroutine task_accy_a(rtdb,geom,basis,
     &    lgrad,lscr,llab,nshell,
     &    grad1, grad2, scr, labs)
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "bas.fh"
c::functions
      logical intb_init4c
      logical intb_2e4c
      external intb_init4c
      external intb_2e4c
      integer rtdb,geom,basis
      integer lgrad, lscr, llab
      integer nshell
      double precision grad1(12,*)
      double precision grad2(12,*)
      double precision scr(lscr)
      integer labs(4,*)
c
      double precision q4
      double precision dummy
      integer me, nproc
      integer task_count
      integer i, j, k, l
      integer ish, jsh, ksh, lsh
      integer tish, tjsh, tksh, tlsh
      integer ilo, ihi, nbfi
      integer jlo, jhi, nbfj
      integer klo, khi, nbfk 
      integer llo, lhi, nbfl
      integer nint
c
      q4 = 1.0d00
      dummy = 1.0d00
      me    = ga_nodeid()
      nproc = ga_nnodes()
      task_count = (me-1)
      do ish = 1,nshell
        if (.not.bas_cn2bfr(basis,ish,ilo,ihi)) stop 'cn2bfr i'        
        nbfi = ihi - ilo + 1
        do jsh = 1,nshell
          if (.not.bas_cn2bfr(basis,jsh,jlo,jhi)) stop 'cn2bfr j'        
          nbfj = jhi - jlo + 1
          do ksh = 1,nshell
            if (.not.bas_cn2bfr(basis,ksh,klo,khi)) stop 'cn2bfr k'        
            nbfk = khi - klo + 1
            do lsh = 1,nshell
              if (.not.bas_cn2bfr(basis,lsh,llo,lhi)) stop 'cn2bfr l'        
              nbfl = lhi - llo + 1
              nint = nbfi*nbfj*nbfk*nbfl
              task_count = task_count + 1
              if (mod(task_count,nproc).eq.0) then
                tish = ish
                tjsh = jsh
                tksh = ksh
                tlsh = lsh
                call ifill((4*nint),0,labs,1)
                call dfill(nint,0.0d00,grad1,1)
                if (.not.intb_init4c(
     &              basis,tish,tjsh,
     &              basis,tksh,tlsh,1,
     &              q4,.false.,lscr,scr,nint,dummy)) stop 'error'
00100           continue
              endif
            enddo
          enddo
        enddo
      enddo
c
      end

*
*     $Id: pspw_lmbfgs.F 19707 2010-10-29 17:59:36Z d3y133 $                       
*

      subroutine pspw_lmbfgs_init(max_m0,g)
      implicit none
      integer max_m0
      complex*16 g(*)

#include "pspw_lmbfgs_common.fh"


*     **** external functions ****
      integer  psi_neq
      external psi_neq

      max_m = max_m0
      call Pack_npack(1,npack1)
      neall = psi_neq(1)+psi_neq(2)
      nsize = neall*npack1
      call pspw_Grsm_list_init('lmbfgs',2*max_m,2*nsize)

      m = 1
c      call Grsm_gg_dScale(npack1,neall,(-1.0d0),g,g)
      call Grsm_gg_dScale1(npack1,neall,(-1.0d0),g)
      call pspw_Grsm_list_store(2*m-1,g)
      call pspw_Grsm_list_store(2*m,g)
c      call Grsm_gg_dScale(npack1,neall,(-1.0d0),g,g)
      call Grsm_gg_dScale1(npack1,neall,(-1.0d0),g)
      return
      end



      subroutine pspw_lmbfgs(tmin,g,s)
      implicit none
      real*8 tmin
      complex*16 g(*)
      complex*16 s(*)


#include "mafdecls.fh"
#include "pspw_lmbfgs_common.fh"

*     **** local variables ****
      logical value,ondisk
      integer k,ngras
      real*8 alpha(20),beta,sum,h0
      integer yy(2),ss(2)

*     **** external functions ****
      logical  control_lmbfgs_ondisk
      external control_lmbfgs_ondisk

      ondisk = control_lmbfgs_ondisk()
      ngras = 2*npack1*neall

      !call Grsm_gg_dScale(npack1,neall,(-1.0d0),g,g)
      call dscal(ngras,(-1.0d0),g,1)

*     **** allocate yy and ss ****
      if (ondisk) then
        value = MA_push_get(mt_dbl,2*nsize,'yy',yy(2),yy(1))
        value = value.and.
     >          MA_push_get(mt_dbl,2*nsize,'ss',ss(2),ss(1))
        if (.not.value) call errquit('pspw_lmbfgs: push stack',0,0)
      end if

      !call Grsm_gg_copy(npack1,neall,g,s)
      call dcopy(ngras,g,1,s,1)

      if (ondisk) then
        call pspw_Grsm_list_load(2*m-1,dbl_mb(yy(1)))
        call pspw_Grsm_list_load(2*m,  dbl_mb(ss(1)))
      else
        call pspw_Grsm_list_ptr(2*m-1,yy(1))
        call pspw_Grsm_list_ptr(2*m,  ss(1))
      end if
      call psi_1geodesic_Gtransport(tmin,dbl_mb(yy(1)))
      call psi_1geodesic_transport(tmin,dbl_mb(ss(1)))
      !call Grsm_ggg_Sub(npack1,neall,g,dbl_mb(yy(1)),dbl_mb(yy(1)))
      call daxpy(ngras,(-1.0d0),g,1,dbl_mb(yy(1)),1)
      call dscal(ngras,(-1.0d0),dbl_mb(yy(1)),1)
      if (ondisk) then
        call pspw_Grsm_list_store(2*m-1,dbl_mb(yy(1)))
        call pspw_Grsm_list_store(2*m,  dbl_mb(ss(1)))
      end if

      call Grsm_gg_trace(npack1,neall,
     >                   dbl_mb(yy(1)),
     >                   dbl_mb(ss(1)),
     >                   sum)
      call D1dB_SumAll(sum)
      
      !*** exit if dividing by small number ***
      if (dabs(sum).lt.1.0d-15) go to 211

      rho(m) = 1.0d0/sum
      call Grsm_gg_trace(npack1,neall,
     >                   dbl_mb(ss(1)),
     >                   s,
     >                   sum)
      call D1dB_SumAll(sum)
      alpha(m) = rho(m)*sum
      !call Grsm_gg_daxpy(npack1,neall,-alpha(m),dbl_mb(yy(1)),s)
      call daxpy(ngras,(-alpha(m)),dbl_mb(yy(1)),1,s,1)
      do k=(m-1),1, -1
         if (ondisk) then
           call pspw_Grsm_list_load(2*k-1,dbl_mb(yy(1)))
           call pspw_Grsm_list_load(2*k,  dbl_mb(ss(1)))
         else
           call pspw_Grsm_list_ptr(2*k-1,yy(1))
           call pspw_Grsm_list_ptr(2*k,  ss(1))
         end if
         call psi_1geodesic_Gtransport(tmin,dbl_mb(yy(1)))
         call psi_1geodesic_Gtransport(tmin,dbl_mb(ss(1)))
         if (ondisk) then
           call pspw_Grsm_list_store(2*k-1,dbl_mb(yy(1)))
           call pspw_Grsm_list_store(2*k,  dbl_mb(ss(1)))
         end if

         call Grsm_gg_trace(npack1,neall,
     >                   dbl_mb(ss(1)),
     >                   s,
     >                   sum)
         call D1dB_SumAll(sum)
         alpha(k) = rho(k)*sum
         !call Grsm_gg_daxpy(npack1,neall,-alpha(k),dbl_mb(yy(1)),s)
         call daxpy(ngras,(-alpha(k)),dbl_mb(yy(1)),1,s,1)
      end do

   
*     **** preconditioner ****
c      call Grsm_gg_dScale(npack1,neall,h0,s,s)


      do k=1,(m-1)

         call Grsm_gg_trace(npack1,neall,
     >                   dbl_mb(yy(1)),
     >                   s,
     >                   sum)
         call D1dB_SumAll(sum)
         beta = rho(k)*sum
         sum = alpha(k) - beta
      
         !call Grsm_gg_daxpy(npack1,neall,sum,dbl_mb(ss(1)),s)
         call daxpy(ngras,sum,dbl_mb(ss(1)),1,s,1)
         if (ondisk) then
           call pspw_Grsm_list_load(2*(k+1)-1,dbl_mb(yy(1)))
           call pspw_Grsm_list_load(2*(k+1),  dbl_mb(ss(1)))
         else
           call pspw_Grsm_list_ptr(2*(k+1)-1,yy(1))
           call pspw_Grsm_list_ptr(2*(k+1),  ss(1))
         end if

      end do
      call Grsm_gg_trace(npack1,neall,
     >                dbl_mb(yy(1)),
     >                s,
     >                sum)
      call D1dB_SumAll(sum)
      beta = rho(m)*sum
      sum = alpha(m) - beta
      !call Grsm_gg_daxpy(npack1,neall,sum,dbl_mb(ss(1)),s)
      call daxpy(ngras,sum,dbl_mb(ss(1)),1,s,1)
      if (m.lt.max_m) then
         m = m+1
      else
         call pspw_Grsm_list_shift()
         call pspw_Grsm_list_shift()
         do k=1,(m-1)
            rho(k) = rho(k+1)
         end do
      end if

      call dscal(ngras,(-1.0d0),s,1)
 211  call pspw_Grsm_list_store(2*m-1,g)
      call pspw_Grsm_list_store(2*m,s)
      call dscal(ngras, (-1.0d0),g,1)

      if (ondisk) then
        value = MA_pop_stack(ss(2))
        value = value.and.
     >          MA_pop_stack(yy(2))
        if (.not.value) call errquit('pspw_lmbfgs:pop stack',2,0)
      end if

      return 
      end

      subroutine argos_partition_end
c
      implicit none
c
#include "argos.fh"
#include "global.fh"
      integer grp_handle
      logical status
c
      grp_handle = ga_pgroup_get_default()
      call ga_pgroup_set_default(ga_pgroup_get_world())
      status = ga_pgroup_destroy(grp_handle)
c
      call ga_sync()
c
      np = ga_nnodes()
      me = ga_nodeid()
      return
      end
c $Id: argos_partition_end.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdtq_t4_8_6(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_off
     &set)
C     $Id: ccsdtq_t4_8_6.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h13 p5 p6 p7 h1 h2 h3 h4 )_vtt + = 1/12 * P( 18 ) * Sum ( p14 ) * t ( p5 p14 h1 h2 )_t * i2 ( h13 p6 p7 h3 h4 p14 )_vt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h13b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER h4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p14b
      INTEGER p5b_1
      INTEGER p14b_1
      INTEGER h1b_1
      INTEGER h2b_1
      INTEGER p6b_2
      INTEGER p7b_2
      INTEGER h13b_2
      INTEGER h3b_2
      INTEGER h4b_2
      INTEGER p14b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p5b = noab+1,noab+nvab
      DO p6b = noab+1,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h13b = 1,noab
      DO h1b = 1,noab
      DO h2b = h1b,noab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+h1b-1)+
     &int_mb(k_spin+h2b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1).ne.
     &16)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     &+int_mb(k_spin+h13b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h2b
     &-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h1b-1),ie
     &or(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h3b-1),int_mb(k_sym+h4b-1
     &)))))))) .eq. ieor(irrep_v,ieor(irrep_t,irrep_t))) THEN
      dimc = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_ra
     &nge+p7b-1) * int_mb(k_range+h13b-1) * int_mb(k_range+h1b-1) * int_
     &mb(k_range+h2b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_t4_8_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p14b = noab+1,noab+nvab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p14b-1) .eq. int_mb(k_spin+
     &h1b-1)+int_mb(k_spin+h2b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p14b-1),ieor(int_mb
     &(k_sym+h1b-1),int_mb(k_sym+h2b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p5b,p14b,h1b,h2b,p5b_1,p14b_1,h1b_1,h2b_1)
      CALL TCE_RESTRICTED_6(p6b,p7b,h13b,h3b,h4b,p14b,p6b_2,p7b_2,h13b_2
     &,h3b_2,h4b_2,p14b_2)
      dim_common = int_mb(k_range+p14b-1)
      dima_sort = int_mb(k_range+p5b-1) * int_mb(k_range+h1b-1) * int_mb
     &(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p6b-1) * int_mb(k_range+p7b-1) * int_mb
     &(k_range+h13b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_t4_8_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_t4_8_6',2,MA_ERR)
      IF ((p14b .lt. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p5b_1 - noab - 1 + nvab * (p14b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p14b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,2,1,-1.0d0)
      END IF
      IF ((p5b .le. p14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h2b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p14b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p14b-1),int_mb(k_range+h1b-1),int_mb(k_range+h2b-1
     &),4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_t4_8_6',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_t4_8_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_t4_8_6',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p14b_
     &2 - noab - 1 + nvab * (h4b_2 - 1 + noab * (h3b_2 - 1 + noab * (h13
     &b_2 - 1 + noab * (p7b_2 - noab - 1 + nvab * (p6b_2 - noab - 1)))))
     &))
      CALL TCE_SORT_6(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+h13b-1),int_mb(k_range+h3b-1
     &),int_mb(k_range+h4b-1),int_mb(k_range+p14b-1),5,4,3,2,1,6,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_t4_8_6',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_t4_8_6',7,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_t4_8_6',8,MA
     &_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_t4_8_6',9,MA_ERR)
      IF ((p5b .le. p6b) .and. (h2b .le. h3b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),8,5,4,3,7,6,2,1,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab
     & * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p6b) .and. (h3b .le. h1b) .and. (h2b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),8,5,4,3,2,7,6,1,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab
     & * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p6b) .and. (h1b .le. h3b) .and. (h3b .le. h2b) .and.
     & (h2b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),8,5,4,3,7,2,6,1,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h2b - 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab
     & * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p6b) .and. (h3b .le. h1b) .and. (h1b .le. h4b) .and.
     & (h4b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),8,5,4,3,2,7,1,6,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h4b - 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab
     & * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p6b) .and. (h1b .le. h3b) .and. (h4b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),8,5,4,3,7,2,1,6,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab
     & * (p5b - noab - 1)))))))))
      END IF
      IF ((p5b .le. p6b) .and. (h4b .le. h1b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),8,5,4,3,2,1,7,6,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab
     & * (p5b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h2b .le. h3b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,8,4,3,7,6,2,1,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p5b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h3b .le. h1b) .and.
     & (h2b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,8,4,3,2,7,6,1,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p5b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h1b .le. h3b) .and.
     & (h3b .le. h2b) .and. (h2b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,8,4,3,7,2,6,1,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h2b - 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p5b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h3b .le. h1b) .and.
     & (h1b .le. h4b) .and. (h4b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,8,4,3,2,7,1,6,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h4b - 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p5b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h1b .le. h3b) .and.
     & (h4b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,8,4,3,7,2,1,6,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p5b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p6b .le. p5b) .and. (p5b .le. p7b) .and. (h4b .le. h1b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,8,4,3,2,1,7,6,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p7b - noab - 1 + nvab * (p5b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p5b) .and. (h2b .le. h3b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,4,8,3,7,6,2,1,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h3b - 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p5b - noab - 1 + nvab * (p7b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p5b) .and. (h3b .le. h1b) .and. (h2b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,4,8,3,2,7,6,1,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h2b - 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p5b - noab - 1 + nvab * (p7b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p5b) .and. (h1b .le. h3b) .and. (h3b .le. h2b) .and.
     & (h2b .le. h4b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,4,8,3,7,2,6,1,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h4b -
     & 1 + noab * (h2b - 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p5b - noab - 1 + nvab * (p7b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p5b) .and. (h3b .le. h1b) .and. (h1b .le. h4b) .and.
     & (h4b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,4,8,3,2,7,1,6,-1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h4b - 1 + noab * (h1b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p5b - noab - 1 + nvab * (p7b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p5b) .and. (h1b .le. h3b) .and. (h4b .le. h2b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,4,8,3,7,2,1,6,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * (h1b - 1 + noab * 
     &(h13b - 1 + noab * (p5b - noab - 1 + nvab * (p7b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF ((p7b .le. p5b) .and. (h4b .le. h1b)) THEN
      CALL TCE_SORT_8(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h13b-1),int_mb(k_range+p7b-1
     &),int_mb(k_range+p6b-1),int_mb(k_range+h2b-1),int_mb(k_range+h1b-1
     &),int_mb(k_range+p5b-1),5,4,8,3,2,1,7,6,1.0d0/12.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h2b -
     & 1 + noab * (h1b - 1 + noab * (h4b - 1 + noab * (h3b - 1 + noab * 
     &(h13b - 1 + noab * (p5b - noab - 1 + nvab * (p7b - noab - 1 + nvab
     & * (p6b - noab - 1)))))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_t4_8_6',10,MA_ERR
     &)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_t4_8_6',11,M
     &A_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      SUBROUTINE OFFSET_beta_1_3_1_8_1_1(l_a_offset,k_a_offset,size)
C     $Id: offset_beta_1_3_1_8_1_1.F 19698 2010-10-29 17:03:09Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i4 ( h2 h4 h11 p5 )_vtrc
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h2b
      INTEGER h4b
      INTEGER h11b
      INTEGER p5b
      length = 0
      DO h2b = 1,noab
      DO h4b = h2b,noab
      DO h11b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &11b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h11b-1),int_mb(k_sym+p5b-1)))) .eq. ieor(irrep_v,irrep_trc))
     & THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h11b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('beta_1_3_1_8_1_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h2b = 1,noab
      DO h4b = h2b,noab
      DO h11b = 1,noab
      DO p5b = noab+1,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+h
     &11b-1)+int_mb(k_spin+p5b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+h4b-1),ieor(int_mb(
     &k_sym+h11b-1),int_mb(k_sym+p5b-1)))) .eq. ieor(irrep_v,irrep_trc))
     & THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h4b-1
     &)+int_mb(k_spin+h11b-1)+int_mb(k_spin+p5b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p5b - noab - 1 + nvab * (h11b - 1 + noab
     & * (h4b - 1 + noab * (h2b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h2b-1) * int_mb(k_range+h4b-1) * int_
     &mb(k_range+h11b-1) * int_mb(k_range+p5b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine ana_rtdbin
c
c $Id: ana_rtdbin.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_common.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "msgids.fh"
c
c      if(me.eq.0) then
c      if(.not.rtdb_cget(irtdb,'ana:filcmd',1,filcmd))
c     + call md_abort('Error rtdb_get filcmd',0)
c      endif
c
c      integer ibroad(10)
cc
cc     input options from rtdb
cc
c      if(me.eq.0) then
cc
cc     reference input file
cc
c      if(.not.rtdb_cget(irtdb,'ana:filref',1,filref))
c     + call md_abort('ana_input: rtdb_get failed',0)
cc
cc     trajectory input file
cc
c      if(.not.rtdb_cget(irtdb,'ana:filtrj',1,filtrj))
c     + call md_abort('ana_input: rtdb_get failed',0)
cc
cc     copy trajectory
cc
c      if(.not.rtdb_cget(irtdb,'ana:filcop',1,filcop))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_cget(irtdb,'ana:fmtcop',1,fmtcop))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_get(irtdb,'ana:lcop',mt_int,1,lcop))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_get(irtdb,'ana:mcopf',mt_int,1,mcopf))
c     + call md_abort('ana_input: rtdb_get failed',0)
cc
cc     superimpose trajectory
cc
c      if(.not.rtdb_cget(irtdb,'ana:filsup',1,filsup))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_cget(irtdb,'ana:fmtsup',1,fmtsup))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_get(irtdb,'ana:lsup',mt_int,1,lsup))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_get(irtdb,'ana:msupf',mt_int,1,msupf))
c     + call md_abort('ana_input: rtdb_get failed',0)
cc
c      if(.not.rtdb_get(irtdb,'ana:timoff',mt_dbl,1,timoff))
c     + call md_abort('ana_input: rtdb_get failed',0)
cc
c      if(.not.rtdb_get(irtdb,'ana:ifrfr',mt_int,1,ifrfr))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_get(irtdb,'ana:ifrto',mt_int,1,ifrto))
c     + call md_abort('ana_input: rtdb_get failed',0)
cc
c      if(.not.rtdb_get(irtdb,'ana:ifrst',mt_int,1,ifrst))
c     + call md_abort('ana_input: rtdb_get failed',0)
c      if(.not.rtdb_get(irtdb,'ana:ilast',mt_int,1,ilast))
c     + call md_abort('ana_input: rtdb_get failed',0)
cc
cc     root mean square deviation
cc
c      if(.not.rtdb_get(irtdb,'ana:irmsd',mt_int,1,irmsd))
c     + call md_abort('ana_rtdbin: rtdb_get failed',1)
cc
c      if(.not.rtdb_get(irtdb,'ana:lplt',mt_int,1,lplt))
c     + call md_abort('ana_rtdbin: rtdb_get failed',1)
c      if(.not.rtdb_get(irtdb,'ana:spac',mt_dbl,1,spac))
c     + call md_abort('ana_rtdbin: rtdb_get failed',0)
c      if(.not.rtdb_get(irtdb,'ana:rcut',mt_dbl,1,rcut))
c     + call md_abort('ana_rtdbin: rtdb_get failed',0)
c      if(.not.rtdb_cget(irtdb,'ana:filchg',1,filchg))
c     + call md_abort('ana_rtdbin: rtdb_get failed',0)
c      if(.not.rtdb_cget(irtdb,'ana:filplt',1,filplt))
c     + call md_abort('ana_rtdbin: rtdb_get failed',0)
c      if(.not.rtdb_cget(irtdb,'ana:filxyz',1,filxyz))
c     + call md_abort('ana_rtdbin: rtdb_get failed',0)
cc
c      endif
cc
cc     broadcast options to all nodes
cc
c      if(np.gt.1) then
c      ibroad(1)=irmsd
c      ibroad(2)=lcop
c      ibroad(3)=lsup
c      ibroad(4)=ifrfr
c      ibroad(5)=ifrto
c      ibroad(6)=lplt
c      call ga_brdcst(mag_d00,ibroad,6*ma_sizeof(mt_int,1,mt_byte),0)
c      irmsd=ibroad(1)
c      lcop=ibroad(2)
c      lsup=ibroad(3)
c      ifrfr=ibroad(4)
c      ifrto=ibroad(5)
c      lplt=ibroad(6)
c      endif
cc
cc     logical file numbers
cc
c      lfnana=75
c      lfnref=76
c      lfntrj=77
c      lfncop=78
c      lfnsup=79
c      lfnchg=80
c      lfnplt=81
c      lfnxyz=82
cc
cc     set flags on what to do
cc
c      ltrj=irmsd
cc
c      if(lcop.gt.0) ltrj=ltrj+1
c      if(lsup.gt.0) ltrj=ltrj+1
c
      return
      end

      subroutine argos_diana_rama()
c
c $Id: argos_diana_rama.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_diana_params.fh"
#include "argos_diana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      character*255 string
      integer ilt,iht,jlt,jht,ndxt,ldt
c
      string=card(8:80)
      strram=string
c
c     get access to local trajectory and time
c
      call ga_distribution(ga_trj,me,il,ih,jl,jh)
      call ga_access(ga_trj,il,ih,jl,jh,ndx,ld)
      call ga_distribution(ga_trt,me,ilt,iht,jlt,jht)
      call ga_access(ga_trt,ilt,iht,jlt,jht,ndxt,ldt)
c
      call argos_diana_rama1(int_mb(i_iram),dbl_mb(ndx),dbl_mb(ndxt))
c
      return
      end

      subroutine argos_diana_hbond(xs,xw,isel,ihbnd,idone)
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
c
      real*8 argos_diana_angle
      external argos_diana_angle
c
      real*8 xs(msa,3),xw(mwm,mwa,3)
      integer ihbnd(msa),isel(msa),idone(mwm)
c
      integer i,j,k,l,n
      real*8 d,a
c
      write(lfnhba,1000) time
 1000 format('frame',/,f12.6,/,'solute-solute')
      do 1 i=1,nsa-1
      do 2 j=i+1,nsa
      if(ihbnd(i)*ihbnd(j).lt.0.and.(isel(i).gt.0.or.isel(j).gt.0)) then
      if(ihbnd(i).lt.0.and.ihbnd(j).eq.i) goto 2
      if(ihbnd(j).lt.0.and.ihbnd(i).eq.j) goto 2
      d=sqrt((xs(i,1)-xs(j,1))**2+(xs(i,2)-xs(j,2))**2+
     + (xs(i,3)-xs(j,3))**2)
      if(d.gt.rhbmin.and.d.lt.rhbmax) then
      if(ihbnd(i).gt.0) then
      a=argos_diana_angle(xs,msa,xw,mwm,mwa,ihbnd(i),0,i,0,j,0)
      else
      a=argos_diana_angle(xs,msa,xw,mwm,mwa,ihbnd(j),0,j,0,i,0)
      endif
      if(a.gt.hbdmin.and.a.lt.hbdmax) then
      write(lfnhba,1001) i,j,d,a
 1001 format(2i7,2f12.6)
      endif
      endif
      endif
    2 continue
    1 continue
c
      if(lxw.and.numwhb.gt.0) then
      write(lfnhba,1002)
 1002 format('solute-solvent')
c
      do 3 i=1,nwm
      idone(i)=0
    3 continue
c
      do 4 i=1,nsa
      do 5 j=1,nwm
      do 6 k=1,nwa
c
      if(ihbnd(i)*ihbndw(k).lt.0.and.isel(i).gt.0) then
      d=sqrt((xs(i,1)-xw(j,k,1))**2+(xs(i,2)-xw(j,k,2))**2+
     + (xs(i,3)-xw(j,k,3))**2)
      if(d.gt.rhbmin.and.d.lt.rhbmax) then
      if(ihbnd(i).gt.0) then
      a=argos_diana_angle(xs,msa,xw,mwm,mwa,ihbnd(i),0,i,0,j,k)
      else
      a=argos_diana_angle(xs,msa,xw,mwm,mwa,j,ihbndw(k),j,k,i,0)
      endif
      if(a.gt.hbdmin.and.a.lt.hbdmax) then
      write(lfnhba,1003) i,j,k,d,a
 1003 format(3i7,2f12.6)
      idone(j)=1
      endif
      endif
      endif
c
    6 continue
    5 continue
    4 continue
c
      if(numwhb.gt.1) then
      write(lfnhba,1004)
 1004 format('solvent-solvent')
      do 7 n=1,numwhb-1
      do 8 i=1,nwm-1
      do 9 j=i+1,nwm
      if((idone(i).eq.n.and.idone(j).eq.0).or.
     + (idone(i).eq.0.and.idone(j).eq.n)) then
      do 10 k=1,nwa
      do 11 l=1,nwa
      if(ihbndw(k)*ihbndw(l).lt.0) then
      d=sqrt((xw(i,k,1)-xw(j,l,1))**2+(xw(i,k,2)-xw(j,l,2))**2+
     + (xw(i,k,3)-xw(j,l,3))**2)
      if(d.gt.rhbmin.and.d.lt.rhbmax) then
      if(ihbndw(i).gt.0) then
      a=argos_diana_angle(xs,msa,xw,mwm,mwa,i,ihbndw(i),i,k,j,l)
      else
      a=argos_diana_angle(xs,msa,xw,mwm,mwa,j,ihbndw(l),j,l,i,k)
      endif
      if(a.gt.hbdmin.and.a.lt.hbdmax) then
      write(lfnhba,1005) i,k,j,l,d,a,n
 1005 format(4i7,2f12.6,i5)
      if(idone(i).eq.0) idone(i)=n+1
      if(idone(j).eq.0) idone(j)=n+1
      endif
      endif
      endif
   11 continue
   10 continue
      endif
    9 continue
    8 continue
    7 continue
      endif
c
      endif
c
      return
      end
c $Id: argos_diana_hbond.F 21176 2011-10-10 06:35:49Z d3y133 $

*
* $Id: fci_prteop.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_prteop(ionel,nonel)
      implicit integer(a-z)
      integer ionel(5,*)
c
      write(6,1)
1     format(/' one electron coupling coefficients (i j K J value)'/)
      write(6,2) ((ionel(i,j),i=1,5),j=1,nonel)
2     format(3(2i3,2i6,i3,4x))
      return
      end

      subroutine mrcc_uhf_energy(g_vecs, eone, etwo, enrep, energy,
     + logzorafromdft)
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "geom.fh"
#include "cuhf.fh"
#include "cscf.fh"
#include "util.fh"
#include "cscfps.fh"
#include "rtdb.fh"
#include "bgj.fh"
#include "stdio.fh"
#include "zora.fh"


c     
cjb Modyfied code from ddscf/uhf.F for MR CC purposes 
c
      integer g_vecs(2)
      double precision energy
      integer g_grad
ckbn zora
      logical logzorafromdft
c     
      double precision eone, etwo, enrep
      integer gtype, grow, gcol
      integer d(4), f(6), nfock
      integer g_a_dens, g_a_coul, g_a_exch, g_a_xc
      integer g_b_dens, g_b_coul, g_b_exch, g_b_xc
      integer g_hcore
      double precision jfac(4), kfac(4), one, zero, mone
      parameter (one=1.0d0, zero=0.0d0, mone=-1.0d0)
      double precision e_a_coul, e_a_exch, e_b_coul, e_b_exch,
     &     e_a_xc, e_b_xc
      double precision errmaxa, errmaxb
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
      logical odebug
      logical cphf_uhf
      logical nodezero
c      double precision cpu,wall

      nodezero = (ga_nodeid().eq.0)

cjb Some parameters for one step energy only

      odebug = .false.
      cphf_uhf = .false.
      energy = 0.0d0
      eone = 0.0d0
      etwo = 0.0d0


cjb Weight of energy contributions
ckbn     cpu = - util_cpusec()
ckbn      wall = - util_wallsec()

      call uhf_jkfac(jfac,kfac)
c     
c     Arrays for AO density, coulomb and exchange matrices
c
      g_a_coul = ga_create_atom_blocked(geom, basis, 'uhf:a coul')
      g_b_coul = ga_create_atom_blocked(geom, basis, 'uhf:b coul')
      g_a_exch = ga_create_atom_blocked(geom, basis, 'uhf:a exch')
      g_b_exch = ga_create_atom_blocked(geom, basis, 'uhf:b exch')
      if(cphf_uhf)then
         g_a_xc   = ga_create_atom_blocked(geom, basis, 'uhf:a xc')
         g_b_xc   = ga_create_atom_blocked(geom, basis, 'uhf:b xc')
      endif
      g_a_dens = ga_create_atom_blocked(geom, basis, 'uhf:a dens')
      g_b_dens = ga_create_atom_blocked(geom, basis, 'uhf:b dens')
      call ga_zero(g_a_dens)
      call ga_zero(g_b_dens)

c
c     Make the densites and build the fock matrices
c
ckbn      cpu = cpu + util_cpusec()
ckbn     wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf1", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
      call ga_dgemm('n', 't', nbf, nbf, nalpha, one, g_vecs(1),
     $     g_vecs(1), zero, g_a_dens)
      if (nbeta .gt. 0) then
         call ga_dgemm('n', 't', nbf, nbf, nbeta, one, g_vecs(2),
     $        g_vecs(2), zero, g_b_dens)
      else
         call ga_zero(g_b_dens)
      endif

ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf2", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
c kk ---
ckbn       if(nodezero) then
ckbn         write(6,*)'tce_mrcc_uhf_step1'
ckbn         call util_flush(6)
ckbn       end if
c ------
      call ga_copy(g_a_dens,g_a_coul)
c kk ---
ckbn       if(nodezero) then
ckbn         write(6,*)'tce_mrcc_uhf_step2'
ckbn         call util_flush(6)
ckbn       end if
c ------
      call ga_copy(g_b_dens,g_b_coul)
c kk ---
ckbn       if(nodezero) then
ckbn         write(6,*)'tce_mrcc_uhf_step3'
ckbn         call util_flush(6)
ckbn       end if
c ------
ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf3", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
      if (oskel) then
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .true., g_a_dens)
         if (oscfps) call pstat_off(ps_sym_sym)
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .true., g_b_dens)
         if (oscfps) call pstat_off(ps_sym_sym)
      endif
      call ga_dadd(one, g_a_dens, mone, g_a_coul, g_a_coul)
      call ga_dadd(one, g_b_dens, mone, g_b_coul, g_b_coul)
      call ga_maxelt(g_a_coul, errmaxa)
      call ga_maxelt(g_b_coul, errmaxb)
      if (max(errmaxa,errmaxb).gt.1d-4) then
         if (ga_nodeid().eq.0) then
            write(6,77) errmaxa,errmaxb
 77         format(' Warning: spatial symmetry breaking in UHF: ',
     $           1p,2d9.2)
            call util_flush(6)
         endif
      endif

c
c      if (odebug) then
c         call ga_print(g_vecs(1))
c         call ga_print(g_vecs(2))
c         call ga_print(g_a_dens)
c         call ga_print(g_b_dens)
c      endif

      call ga_zero(g_a_coul)
      call ga_zero(g_b_coul)
      call ga_zero(g_a_exch)
      call ga_zero(g_b_exch)
      if(cphf_uhf)then
         call ga_zero(g_a_xc)
         call ga_zero(g_b_xc)
      endif
ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf4", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
      d(1) = g_a_dens
      d(2) = g_a_dens
      d(3) = g_b_dens
      d(4) = g_b_dens
      f(1) = g_a_coul
      f(2) = g_a_exch
      f(3) = g_b_coul
      f(4) = g_b_exch
      if(cphf_uhf)then
         f(5) = g_a_xc
         f(6) = g_b_xc
      endif
      if(cphf_uhf)then
         nfock = 6
      else
         nfock = 4
      endif
      call do_riscf (.false.)
ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf4.5", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
      call fock_2e(geom, basis, nfock, jfac, kfac, tol2e,
     $     oskel, d, f, .false.)
ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf4.7", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
      call do_riscf (.true.)
c
      e_a_coul = 0.5d0*
     $     (ga_ddot(g_a_dens,g_a_coul) + ga_ddot(g_a_dens,g_b_coul))
      e_b_coul = 0.5d0*
     $     (ga_ddot(g_b_dens,g_a_coul) + ga_ddot(g_b_dens,g_b_coul))
      e_a_exch = 0.5d0*ga_ddot(g_a_dens,g_a_exch)
      e_b_exch = 0.5d0*ga_ddot(g_b_dens,g_b_exch)
      etwo = e_a_coul + e_b_coul - e_a_exch - e_b_exch
      if(cphf_uhf)then
         e_a_xc = ga_ddot(g_a_dens,g_a_xc)
         e_b_xc = ga_ddot(g_b_dens,g_b_xc)
         etwo = etwo + e_a_xc + e_b_xc
      endif
c
      if (odebug .and. ga_nodeid().eq.0) then
         write(6,*) ' coulomb energies', e_a_coul, e_b_coul
         write(6,*) ' exchang energies', e_a_exch, e_b_exch
         call util_flush(6)
      endif
ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf5", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
c      if (odebug) then
c         call ga_print(g_a_coul)
c         call ga_print(g_a_exch)
c      endif
c     Form energies and AO fock matrices
c
c     Fa (in g_a_coul) = h + J(a) + J(b) - K(a)
c     Fb (in g_b_coul) = h + J(a) + J(b) - K(b)
c
c     E = ((Da + Db)*h + Da*Fa + Db*Fb) / 2
c     Eone = h * (Da + Db)
c
c     2e denotes 2-electron components only
c
      call ga_dadd(one, g_a_coul, one, g_b_coul, g_a_coul)
c kk ---
ckbn       if(nodezero) then
ckbn         write(6,*)'tce_mrcc_uhf_step4'
ckbn         call util_flush(6)
ckbn       end if
c ------
      call ga_copy(g_a_coul, g_b_coul)
c kk ---
ckbn       if(nodezero) then
ckbn         write(6,*)'tce_mrcc_uhf_step5'
ckbn         call util_flush(6)
ckbn       end if
c ------
      call ga_dadd(one, g_a_coul, mone, g_a_exch, g_a_coul)
      call ga_dadd(one, g_b_coul, mone, g_b_exch, g_b_coul)
      if(cphf_uhf)then
         call ga_dadd(one, g_a_coul, one, g_a_xc, g_a_coul)
         call ga_dadd(one, g_b_coul, one, g_b_xc, g_b_coul)
      endif
c
c     reuse g_a_exch to hold the 1-e integrals
c
      g_hcore = g_a_exch
      call ga_zero(g_hcore)
      call int_1e_ga(basis, basis, g_hcore, 'kinetic', oskel)
ckbn zora This is a hack to add zora in mrcc it assumes g_hcore is not deleted after dft calculation for core level paper
      if(logzorafromdft) then
       call ga_dadd(1.d0,g_hcore,1.d0,g_zora_Kinetic(1),g_hcore) ! zora kinetic
      endif
      call int_1e_ga(basis, basis, g_hcore, 'potential', oskel)
      eone =
     $     (ga_ddot(g_a_dens,g_hcore) + ga_ddot(g_b_dens,g_hcore))
      call ga_dadd(one, g_hcore, one, g_a_coul, g_a_coul)
      call ga_dadd(one, g_hcore, one, g_b_coul, g_b_coul)
c
      if (oskel) then
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .false., g_a_coul)
         if (oscfps) call pstat_off(ps_sym_sym)
         if (oscfps) call pstat_on(ps_sym_sym)
         call sym_symmetrize(geom, basis, .false., g_b_coul)
         if (oscfps) call pstat_off(ps_sym_sym)
      endif
ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf6", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif
ckbn      cpu = - util_cpusec()
ckbn      wall = - util_wallsec()
c
cjb      if (odebug) then
cjb         call ga_print(g_a_coul)
cjb         call ga_print(g_b_coul)
cjb      endif
c
c     Transform the Fock matrices to the MO basis using g_a_dens for scratch
c
c
c     Free up dead global arrays
c
      if (.not. ga_destroy(g_a_dens)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_b_dens)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if(cphf_uhf)then
         if (.not. ga_destroy(g_a_xc)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
         if (.not. ga_destroy(g_b_xc)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      endif
      if (.not. ga_destroy(g_a_exch)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_b_exch)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_a_coul)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_b_coul)) call errquit('uhf_e: destroy',0,
     &       GA_ERR)

c
c     extract the gradient
c
c
      if (.not. geom_nuc_rep_energy(geom, enrep))
     $     call errquit('uhf_energy: no repulsion energy?', 0, GEOM_ERR)
      energy = eone + etwo + enrep
c
      if (ga_nodeid().eq.0) then
c         write(6,*) ' eone, etwo, enrep, energy ',
c     $        eone, etwo, enrep, energy
       write(6,'(A,4F20.12)')"eone,etwo,enrep,energy",
     +                       eone,etwo,enrep,energy
      endif
c
ckbn      cpu = cpu + util_cpusec()
ckbn      wall = wall + util_wallsec()
ckbn      if(nodezero) then
ckbn        write(LuOut,'(A,2f15.5)')"tce_mrcc_uhf7", cpu, wall
ckbn        call util_flush(LuOut)
ckbn      endif

      end
c $Id: tce_mrcc_uhf.F 24345 2013-06-22 06:19:30Z d3y133 $

      subroutine fock_2e_cache_dens_fock(
     $     ilo, jlo, klo, llo,
     $     ihi, jhi, khi, lhi,
     $     ijk_prev,
     $     nfock, vg_dens, vg_fock,
     $     jfac, kfac, 
     $     dij, dik, dli, djk, dlj, dlk,
     $     fij, fik, fli, fjk, flj, flk,
     $     tmp)
      implicit none
#include "cscfps.fh"
c
c     $Id: fock_2e_cdf.F 19707 2010-10-29 17:59:36Z d3y133 $
c
c     For the given ranges of i,j,k,l fetch the six blocks
c     of the density matrices (ij,ik,il,jk,jl,kl) and accumulate
c     the fock matrix blocks.  Scale the fock matrix blocks
c     by the necessary factors for Coulomb/Exchange.
c     Take advantage of caching by storing in ijk_prev() the
c     previous i,j,k ranges (l assumed to be inner loop and
c     thus not to benefit from caching).  If any of ij,ik,jk
c     have not changed then nothing need be done for those
c     blocks.
c
c     !! ijk_prev() must be preserved between calls and set
c     to invalid basis function labels (-1) on the first call.
c     
      integer ilo, jlo, klo, llo
      integer ihi, jhi, khi, lhi
      integer ijk_prev(3,2)     ! old values (i/j/k, lo/hi)
      integer nfock             ! No. of matrices
      integer vg_dens(nfock), vg_fock(nfock) ! GA handles
      double precision jfac(nfock), kfac(nfock)
      double precision
     $     dij(nfock,*), dik(nfock,*), dli(nfock,*),
     $     djk(nfock,*), dlj(nfock,*), dlk(nfock,*)
      double precision
     $     fij(nfock,*), fik(nfock,*), fli(nfock,*),
     $     fjk(nfock,*), flj(nfock,*), flk(nfock,*)
      double precision tmp(*)
c
      integer idim, jdim, kdim, ldim
c
      if (oscfps) call pstat_on(ps_gaops)
c
c     Assume that blocking is fixed and therefore only
c     need to compare ilo with ilo_prev, etc.
c
      idim = ihi - ilo + 1
      jdim = jhi - jlo + 1
      kdim = khi - klo + 1
      ldim = lhi - llo + 1
c     
c     Blocks of D/F without l label ... caching is useful
c     
      if (ijk_prev(1,1).ne.ilo .or. ijk_prev(2,1).ne.jlo) then
         if (ijk_prev(1,1) .ne.-1)
     $        call fock_upd_blk( nfock, vg_fock,
     $        ijk_prev(1,1), ijk_prev(1,2),
     $        ijk_prev(2,1), ijk_prev(2,2),
     $        jfac, fij, tmp )
         call fock_get_blk(nfock, vg_dens,
     $        ilo, ihi, jlo, jhi, dij, tmp)
         call dfill((idim*jdim*nfock), 0.0d0, fij, 1)
      end if
      if (ijk_prev(1,1).ne.ilo .or. ijk_prev(3,1).ne.klo) then
         if (ijk_prev(1,1).ne.-1)
     $        call fock_upd_blk(nfock, vg_fock,
     $        ijk_prev(1,1), ijk_prev(1,2),
     $        ijk_prev(3,1), ijk_prev(3,2), kfac, fik, tmp)
         call fock_get_blk(nfock, vg_dens,
     $        ilo, ihi, klo, khi, dik, tmp)
         call dfill((idim*kdim*nfock), 0.0d0, fik, 1)
      end if
      if (ijk_prev(2,1).ne.jlo .or. ijk_prev(3,1).ne.klo) then
         if (ijk_prev(2,1) .ne. -1)
     $        call fock_upd_blk(nfock, vg_fock,
     $        ijk_prev(2,1), ijk_prev(2,2),
     $        ijk_prev(3,1), ijk_prev(3,2), kfac, fjk, tmp)
         call fock_get_blk(nfock, vg_dens,
     $        jlo, jhi, klo, khi, djk, tmp)
         call dfill((jdim*kdim*nfock), 0.0d0, fjk, 1)
      end if
c
c     Blocks with l label always change
c
      call fock_get_blk(nfock, vg_dens,
     $     llo, lhi, klo, khi, dlk, tmp)
      call fock_get_blk(nfock, vg_dens,
     $     llo, lhi, ilo, ihi, dli, tmp)
      call fock_get_blk(nfock, vg_dens,
     $     llo, lhi, jlo, jhi, dlj, tmp)
      call dfill((kdim*ldim*nfock), 0.0d0, flk, 1)
      call dfill((idim*ldim*nfock), 0.0d0, fli, 1)
      call dfill((jdim*ldim*nfock), 0.0d0, flj, 1)
c     
      ijk_prev(1,1) = ilo
      ijk_prev(2,1) = jlo
      ijk_prev(3,1) = klo
      ijk_prev(1,2) = ihi
      ijk_prev(2,2) = jhi
      ijk_prev(3,2) = khi
c     
      if (oscfps) call pstat_off(ps_gaops)
c
      end

      SUBROUTINE ccsdtq_lr_alpha_15_42_3_1(d_a,k_a_offset,d_b,k_b_offset
     &,d_c,k_c_offset)
C     $Id: ccsdtq_lr_alpha_15_42_3_1.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h3 h12 h14 h15 p1 p2 )_ytra + = -1 * Sum ( h7 p5 p6 ) * tra ( p5 p6 h7 h15 )_tra * y ( h3 h7 h12 h14 p1 p2 p5 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h3b
      INTEGER h12b
      INTEGER h14b
      INTEGER h15b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER p6b
      INTEGER h7b
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h15b_1
      INTEGER h7b_1
      INTEGER h3b_2
      INTEGER h12b_2
      INTEGER h14b_2
      INTEGER h7b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h3b = 1,noab
      DO h12b = h3b,noab
      DO h14b = h12b,noab
      DO h15b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h3b-1)+int_mb(k_spin+h12b-
     &1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+h15b-1)+int_mb(k_spin+p1b-1
     &)+int_mb(k_spin+p2b-1).ne.12)) THEN
      IF (int_mb(k_spin+h3b-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+h14b-
     &1) .eq. int_mb(k_spin+h15b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p
     &2b-1)) THEN
      IF (ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h12b-1),ieor(int_mb
     &(k_sym+h14b-1),ieor(int_mb(k_sym+h15b-1),ieor(int_mb(k_sym+p1b-1),
     &int_mb(k_sym+p2b-1)))))) .eq. ieor(irrep_y,irrep_tra)) THEN
      dimc = int_mb(k_range+h3b-1) * int_mb(k_range+h12b-1) * int_mb(k_r
     &ange+h14b-1) * int_mb(k_range+h15b-1) * int_mb(k_range+p1b-1) * in
     &t_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_42_3_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h7b = 1,noab
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h
     &15b-1)+int_mb(k_spin+h7b-1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+h15b-1),int_mb(k_sym+h7b-1)))) .eq. irrep_tra) THEN
      CALL TCE_RESTRICTED_4(p5b,p6b,h15b,h7b,p5b_1,p6b_1,h15b_1,h7b_1)
      CALL TCE_RESTRICTED_8(h3b,h12b,h14b,h7b,p1b,p2b,p5b,p6b,h3b_2,h12b
     &_2,h14b_2,h7b_2,p1b_2,p2b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_m
     &b(k_range+h7b-1)
      dima_sort = int_mb(k_range+h15b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h3b-1) * int_mb(k_range+h12b-1) * int_m
     &b(k_range+h14b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_42_3_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_42_3_1',2,MA_ERR)
      IF ((h7b .le. h15b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h15b_
     &1 - 1 + noab * (h7b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h7b-1),int_mb(k_range+h15b-1
     &),4,3,2,1,1.0d0)
      END IF
      IF ((h15b .lt. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h7b_1
     & - 1 + noab * (h15b_1 - 1 + noab * (p6b_1 - noab - 1 + nvab * (p5b
     &_1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),int_mb(k_range+h15b-1),int_mb(k_range+h7b-1
     &),3,4,2,1,-1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_15_42_3_
     &1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_15_42_3_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_42_3_1',5,MA_ERR)
      IF ((h7b .lt. h3b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),8,7,4,3,2,1,6,5,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (p5b .lt. p1b) .and. (p1b .le. p6b) .and.
     & (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,6,4,3,2,1,7,5,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (p5b .lt. p1b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,6,4,3,2,1,8,5,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (p1b .le. p5b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,5,4,3,2,1,7,6,-1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (p1b .le. p5b) .and. (p5b .lt. p2b) .and.
     & (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,5,4,3,2,1,8,6,1.0d0)
      END IF
      IF ((h7b .lt. h3b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h3b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h3b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),6,5,4,3,2,1,8,7,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .le. h12b) .and. (p6b .lt. p1b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),8,7,4,3,1,2,6,5,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .le. h12b) .and. (p5b .lt. p1b) .and
     &. (p1b .le. p6b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,6,4,3,1,2,7,5,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .le. h12b) .and. (p5b .lt. p1b) .and
     &. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,6,4,3,1,2,8,5,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .le. h12b) .and. (p1b .le. p5b) .and
     &. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,5,4,3,1,2,7,6,1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .le. h12b) .and. (p1b .le. p5b) .and
     &. (p5b .lt. p2b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,5,4,3,1,2,8,6,-1.0d0)
      END IF
      IF ((h3b .le. h7b) .and. (h7b .le. h12b) .and. (p2b .le. p5b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h12b_2 -
     & 1 + noab * (h7b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h12b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),6,5,4,3,1,2,8,7,1.0d0)
      END IF
      IF ((h12b .lt. h7b) .and. (h7b .le. h14b) .and. (p6b .lt. p1b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h7b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),8,7,4,2,1,3,6,5,-1.0d0)
      END IF
      IF ((h12b .lt. h7b) .and. (h7b .le. h14b) .and. (p5b .lt. p1b) .an
     &d. (p1b .le. p6b) .and. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h7b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,6,4,2,1,3,7,5,1.0d0)
      END IF
      IF ((h12b .lt. h7b) .and. (h7b .le. h14b) .and. (p5b .lt. p1b) .an
     &d. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h7b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,6,4,2,1,3,8,5,-1.0d0)
      END IF
      IF ((h12b .lt. h7b) .and. (h7b .le. h14b) .and. (p1b .le. p5b) .an
     &d. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h7b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,5,4,2,1,3,7,6,-1.0d0)
      END IF
      IF ((h12b .lt. h7b) .and. (h7b .le. h14b) .and. (p1b .le. p5b) .an
     &d. (p5b .lt. p2b) .and. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h7b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,5,4,2,1,3,8,6,1.0d0)
      END IF
      IF ((h12b .lt. h7b) .and. (h7b .le. h14b) .and. (p2b .le. p5b)) TH
     &EN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h14b_2 - 1 + noab * (h7b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h7b-1),int_mb(k_range+h14b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),6,5,4,2,1,3,8,7,-1.0d0)
      END IF
      IF ((h14b .lt. h7b) .and. (p6b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (p6b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h14b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h14b-1),int_mb(k_range+h7b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),8,7,3,2,1,4,6,5,1.0d0)
      END IF
      IF ((h14b .lt. h7b) .and. (p5b .lt. p1b) .and. (p1b .le. p6b) .and
     &. (p6b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h14b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h14b-1),int_mb(k_range+h7b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,6,3,2,1,4,7,5,-1.0d0)
      END IF
      IF ((h14b .lt. h7b) .and. (p5b .lt. p1b) .and. (p2b .le. p6b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p1b_2 - noab - 1 
     &+ nvab * (p5b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h14b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h14b-1),int_mb(k_range+h7b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,6,3,2,1,4,8,5,1.0d0)
      END IF
      IF ((h14b .lt. h7b) .and. (p1b .le. p5b) .and. (p6b .lt. p2b)) THE
     &N
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p6b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h14b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h14b-1),int_mb(k_range+h7b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-
     &1),int_mb(k_range+p2b-1),8,5,3,2,1,4,7,6,1.0d0)
      END IF
      IF ((h14b .lt. h7b) .and. (p1b .le. p5b) .and. (p5b .lt. p2b) .and
     &. (p2b .le. p6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (p5b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h14b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h14b-1),int_mb(k_range+h7b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p6b-1),7,5,3,2,1,4,8,6,-1.0d0)
      END IF
      IF ((h14b .lt. h7b) .and. (p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p2b_2 - noab - 1 
     &+ nvab * (p1b_2 - noab - 1 + nvab * (h7b_2 - 1 + noab * (h14b_2 - 
     &1 + noab * (h12b_2 - 1 + noab * (h3b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h14b-1),int_mb(k_range+h7b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p6b-1),6,5,3,2,1,4,8,7,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_15_42_3_
     &1',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &42_3_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &42_3_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_15_42_3_1',9,MA_ERR)
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h14b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+h3b-1),int_mb(k_range+h15b-1),5,4,3,6,2,1,-1.0d0
     &)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h15b - 1 + noab * (h1
     &4b - 1 + noab * (h12b - 1 + noab * (h3b - 1)))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_15_42_3_
     &1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_15_
     &42_3_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* $Id: coulomb.F 24638 2013-10-11 23:57:35Z bylaska $
*

      subroutine coulomb_init()
      implicit none 
#include "errquit.fh"

#include "mafdecls.fh"

*     **** common block used for coulomb.f ****
c     real*8 vc(nfft3d)
      integer vc_indx,vc_hndl
      common / vc_block / vc_indx,vc_hndl

*     **** local variables ****
      integer npack0,nfft3d,G(3)
      integer i,j,k
      integer zero,qzero,pzero,taskid
      integer nx,ny,nxh,nyh
      real*8  fourpi,gg
      logical value
      integer tmp1(2)

*     **** external functions ****
*     real*8 G(nfft3d,3)
      integer  G_indx
      external G_indx
      double precision toll
      parameter (toll=1d-16)

      call nwpw_timing_start(7)
      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(0,npack0)
      G(1) = G_indx(1)
      G(2) = G_indx(2)
      G(3) = G_indx(3)

*     **** allocate vc memory ****
      value = MA_alloc_get(mt_dbl,npack0,'vc',vc_hndl,vc_indx)
      if (.not. value) call errquit('out of heap memory',0, MA_ERR)

      value = MA_push_get(mt_dbl,nfft3d,'tmp1',tmp1(2),tmp1(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      call Parallel2d_taskid_i(taskid)
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      nxh=nx/2
      nyh=ny/2

*     ***** find the G==0 point in the lattice *****
      i=0
      j=0
      k=0
c     call D3dB_ktoqp(1,k+1,qzero,pzero)
c     zero = (qzero-1)*(nxh+1)*ny
c    >     + j*(nxh+1)
c    >     + i+1
      call D3dB_ijktoindexp(1,i+1,j+1,k+1,zero,pzero)

*     ***** form Vc = 4*pi/G**2  *****
      fourpi = 4.0d0*(4.0d0*datan(1.0d0))
      do i = 1,nfft3d
         
         gg  = ( dbl_mb(G(1)+i-1)*dbl_mb(G(1)+i-1)
     >         + dbl_mb(G(2)+i-1)*dbl_mb(G(2)+i-1)
     >         + dbl_mb(G(3)+i-1)*dbl_mb(G(3)+i-1) )

         if (((pzero.eq.taskid) .and. (i.eq.zero)).or.
     E    (abs(gg) .lt.toll))  then
            dbl_mb(tmp1(1)+i-1) = 0.0d0
         else
            dbl_mb(tmp1(1)+i-1) = fourpi/gg
         end if
        
      end do
      call Pack_t_pack(0,dbl_mb(tmp1(1)))
      call Pack_t_Copy(0,dbl_mb(tmp1(1)),dbl_mb(vc_indx))
      value = MA_pop_stack(tmp1(2))

      call nwpw_timing_end(7)


      return
      end

      subroutine coulomb_end()
      implicit none
#include "mafdecls.fh"

*     **** common block used for coulomb.f ****
      integer vc_indx,vc_hndl
      common / vc_block / vc_indx,vc_hndl
      logical value

      value = MA_free_heap(vc_hndl)
      return
      end


      subroutine coulomb_v(dng,vc_out)
      implicit none
      complex*16 dng(*)
      complex*16 vc_out(*)

#include "mafdecls.fh"


*     **** common block used for coulomb.f ****
      integer vc_indx,vc_hndl
      common / vc_block / vc_indx,vc_hndl

      call nwpw_timing_start(7)
      call Pack_tc_Mul(0,dbl_mb(vc_indx),dng,vc_out)
      call nwpw_timing_end(7)

      return 
      end


      real*8 function coulomb_e(dng)
      implicit none
#include "errquit.fh"
      complex*16 dng(*)

#include "mafdecls.fh"

*     **** common block used for coulomb.f ****
*     real*8 vc(nfft3d)
*     common / vc_block / vc
      integer vc_indx,vc_hndl
      common / vc_block / vc_indx,vc_hndl


*     **** local variables ****
      integer npack0
      real*8 ec

c     real*8  tmp1(*)
      integer tmp1(2)
      logical value

*     **** external functions ****
      real*8 lattice_omega
      external lattice_omega

      call nwpw_timing_start(7)
      call Pack_npack(0,npack0)
      value = MA_push_get(mt_dbl,npack0,'tmp1',tmp1(2),tmp1(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
      
      call Pack_ct_Sqr(0,dng,dbl_mb(tmp1(1)))
      call Pack_tt_dot(0,dbl_mb(tmp1(1)),dbl_mb(vc_indx),ec)
       
      ec = 0.5d0*ec*lattice_omega()

      value = MA_pop_stack(tmp1(2))
      call nwpw_timing_end(7)

      coulomb_e = ec
      return 
      end





      subroutine coulomb_euv(dng,euv)
*
* $Id: coulomb.F 24638 2013-10-11 23:57:35Z bylaska $
*
      implicit none 
#include "errquit.fh"
      complex*16 dng(*)
      real*8 euv(3,3)

#include "mafdecls.fh"

*     **** common block used for coulomb.f ****
      integer vc_indx,vc_hndl
      common / vc_block / vc_indx,vc_hndl


*     **** local variables ****
      integer npack0,nfft3d,G(2,3)
      integer i,j
      integer u,v,s
      logical value

      real*8 pi,fourpi,scal,ss,sum
      real*8 hm(3,3),Bus(3,3),ecoul 
      integer tmp1(2),tmp2(2)

*     **** external functions ****
c     real*8 G(nfft3d,3)
      integer  G_indx
      external G_indx

      real*8   lattice_unitg,lattice_omega,coulomb_e
      external lattice_unitg,lattice_omega,coulomb_e



      pi     = 4.0d0*datan(1.0d0)
      fourpi = 4.0d0*pi
      scal   = 1.0d0/(2.0d0*pi)

*     *** define hm ****
      do j=1,3
      do i=1,3
         hm(i,j) = scal*lattice_unitg(i,j)
      end do
      end do      


      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(0,npack0)

      value = MA_push_get(mt_dbl,nfft3d,
     >                     'G1',G(2,1),G(1,1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
      value = MA_push_get(mt_dbl,nfft3d,
     >                     'G2',G(2,2),G(1,2))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)
      value = MA_push_get(mt_dbl,nfft3d,
     >                     'G3',G(2,3),G(1,3))
      if (.not. value) call errquit('out of stack  memory',0, MA_ERR)

      value = MA_push_get(mt_dbl,npack0,'tmp1',tmp1(2),tmp1(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      value = MA_push_get(mt_dbl,npack0,'tmp2',tmp2(2),tmp2(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)

      call dcopy(nfft3d,dbl_mb(G_indx(1)),1,dbl_mb(G(1,1)),1)
      call dcopy(nfft3d,dbl_mb(G_indx(2)),1,dbl_mb(G(1,2)),1)
      call dcopy(nfft3d,dbl_mb(G_indx(3)),1,dbl_mb(G(1,3)),1)
      call Pack_t_pack(0,dbl_mb(G(1,1)))
      call Pack_t_pack(0,dbl_mb(G(1,2)))
      call Pack_t_pack(0,dbl_mb(G(1,3)))

*     **** tmp2(G) = (n(G)**2) * (4*pi/G**2)**2  ****
      call Pack_ct_Sqr(0,dng,dbl_mb(tmp1(1)))
      call Pack_tt_Mul(0,dbl_mb(tmp1(1)),dbl_mb(vc_indx),
     >                                   dbl_mb(tmp2(1)))
c      call Pack_tt_Mul(0,dbl_mb(tmp2(1)),dbl_mb(vc_indx),
c     >                                   dbl_mb(tmp2(1)))
      call Pack_tt_Mul2(0,dbl_mb(vc_indx),dbl_mb(tmp2(1)))


*     **** Bus = Sum(G) (omega/4*pi)*tmp2(G)*Gu*Gs ****
      call dcopy(9,0.0d0,0,Bus,1)
      ss     = lattice_omega()/fourpi
      do u=1,3
      do s=u,3
        call Pack_tt_Mul(0,dbl_mb(G(1,u)),
     >                     dbl_mb(G(1,s)),
     >                     dbl_mb(tmp1(1)))
        call Pack_tt_dot(0,dbl_mb(tmp1(1)),dbl_mb(tmp2(1)),sum)

        Bus(u,s) = ss*sum
      end do
      end do
      do u=1,3
      do s=u+1,3
         Bus(s,u) = Bus(u,s)
      end do
      end do

      ecoul = coulomb_e(dng)
      do v=1,3
      do u=1,3
         euv(u,v) = -ecoul*hm(u,v)
         do s=1,3
            euv(u,v) = euv(u,v) + Bus(u,s)*hm(s,v)
         end do
      end do
      end do
 
      value = MA_pop_stack(tmp2(2))
      value = MA_pop_stack(tmp1(2))
      value = MA_pop_stack(G(2,3)) 
      value = MA_pop_stack(G(2,2)) 
      value = MA_pop_stack(G(2,1))

      return
      end


*     **********************************************
*     *                                            *
*     *              coulomb_efg                   *
*     *                                            *
*     **********************************************
      subroutine coulomb_efg(dng,efg_smoothr,efg_smoothi)

      implicit none 

      complex*16 dng(*)
      real*8 efg_smoothr(3,3,*),efg_smoothi(3,3,*) ! real and complex parts

#include "mafdecls.fh"
#include "errquit.fh"

*     **** common block used for coulomb.f ****
      integer vc_indx,vc_hndl
      common / vc_block / vc_indx,vc_hndl

*     **** local variables ****
      logical value
      integer npack0,nfft3d
      integer ii,k
      integer u,v
      integer Gtmp(2),G(3),tmp1(2),tmp2(2),exi(2)
      real*8 w,gg
      integer mu,nu,nion
      real*8 rdng,cdng,gvec(3),termgg
      real*8 pi,two_pi,four_pi,sqrt_pi
      real*8 phase,cosgr,singr
      real*8 r1,r2,r3
      complex*16 zsum

*     **** external functions ****
      integer  G_indx,ion_nion
      external G_indx,ion_nion
      real*8   lattice_omega,ion_rion
      external lattice_omega,ion_rion

      pi = 4.0d0*datan(1.0d0)
      sqrt_pi  = dsqrt(pi)
      two_pi   = 2.0d0*pi
      four_pi  = 4.0d0*pi

      call D3dB_nfft3d(1,nfft3d)
      call Pack_npack(0,npack0)

      value = MA_push_get(mt_dbl,3*nfft3d,'Gtmp',Gtmp(2),Gtmp(1))
      G(1) = Gtmp(1)
      G(2) = Gtmp(1)+nfft3d
      G(3) = Gtmp(2)+nfft3d
      value = value.and.
     >        MA_push_get(mt_dbl,npack0,'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dbl,npack0,'tmp2',tmp2(2),tmp2(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,npack0,'exi',exi(2),exi(1))
      if (.not. value) 
     > call errquit('coulomb_efg:out of stack memory',0, MA_ERR)

      call dcopy(nfft3d,dbl_mb(G_indx(1)),1,dbl_mb(G(1)),1)
      call dcopy(nfft3d,dbl_mb(G_indx(2)),1,dbl_mb(G(2)),1)
      call dcopy(nfft3d,dbl_mb(G_indx(3)),1,dbl_mb(G(3)),1)
      call Pack_t_pack(0,dbl_mb(G(1)))
      call Pack_t_pack(0,dbl_mb(G(2)))
      call Pack_t_pack(0,dbl_mb(G(3)))

*     **** initialize ***
      nion = ion_nion()
      do mu = 1,3
        do nu = 1,3
          do ii=1,nion
             efg_smoothr(mu,nu,ii) = 0.0d0
             efg_smoothi(mu,nu,ii) = 0.0d0
          end do ! ii
        end do ! nu
      end do ! mu

      !*** compute (-1/3)gg ***
       do k=1,npack0
          dbl_mb(tmp1(1)+k-1) = -( dbl_mb(G(1)+k-1)**2
     >                           + dbl_mb(G(2)+k-1)**2
     >                           + dbl_mb(G(3)+k-1)**2)/3.0d0
       end do ! k
c
       do ii=1,nion
         call strfac_pack(0,ii,dcpl_mb(exi(1)))
         do mu=1,3
            call Pack_ttt_dzaxpy(0,dbl_mb(G(mu)),
     >                             dbl_mb(G(mu)),
     >                             dbl_mb(tmp1(1)),
     >                             dbl_mb(tmp2(1)))
            call Pack_tt_Mul2(0,dbl_mb(vc_indx),dbl_mb(tmp2(1)))

            zsum = dcmplx(0.0d0,0.0d0) 
            do k=1,npack0
               zsum = zsum 
     >              - 2.0d0*dng(k)
     >                     *dcpl_mb(exi(1)+k-1)
     >                     *dbl_mb(tmp2(1)+k-1)
            end do
            efg_smoothr(mu,mu,ii) = dble(zsum)
            efg_smoothi(mu,mu,ii) = dimag(zsum)

            do nu=mu+1,3
               call Pack_tt_Mul(0,dbl_mb(G(mu)),
     >                            dbl_mb(G(nu)),
     >                            dbl_mb(tmp2(1)))
               call Pack_tt_Mul2(0,dbl_mb(vc_indx),dbl_mb(tmp2(1)))

               zsum = dcmplx(0.0d0,0.0d0) 
               do k=1,npack0
                  zsum = zsum - 2.0d0*dng(k)
     >                               *dcpl_mb(exi(1)+k-1)
     >                               *dbl_mb(tmp2(1)+k-1)
               end do
               efg_smoothr(mu,nu,ii) = dble(zsum)
               efg_smoothr(nu,mu,ii) = dble(zsum)
               efg_smoothi(mu,nu,ii) = dimag(zsum)
               efg_smoothi(nu,mu,ii) = dimag(zsum)

            end do  ! nu
         end do ! mu
      end do ! ii

c      do k=1,npack0
c        gvec(1) = dbl_mb(G(1)+k-1)
c        gvec(2) = dbl_mb(G(2)+k-1)
c        gvec(3) = dbl_mb(G(3)+k-1)
c        gg = gvec(1)*gvec(1) + gvec(2)*gvec(2) + gvec(3)*gvec(3)
c        if (gg .gt. 0.d0) then  ! eliminate g=o term
c          do ii=1,nion
c            r1 = ion_rion(1,ii)
c            r2 = ion_rion(2,ii)
c            r3 = ion_rion(3,ii)
c            phase = (gvec(1)*r1+gvec(2)*r2+gvec(3)*r3)
c            cosgr = cos(phase)  ! cos(G.R)
c            singr = sin(phase)  ! sin(G.R)
c            do mu=1,3
c             do nu=1,3
c                termgg = gvec(mu)*gvec(nu) 
c                if (mu == nu) termgg = termgg - gg/3.d0
c                rdng = real(dng(k))
c                cdng = aimag(dng(k))
c!
c                efg_smoothr(mu,nu,ii) = efg_smoothr(mu,nu,ii) -   ! real part
c     &            2.0d0*four_pi*termgg*(rdng*cosgr-cdng*singr)/gg 
c                efg_smoothi(mu,nu,ii) = efg_smoothi(mu,nu,ii) -   ! imag part
c     &            2.0d0*four_pi*termgg*(rdng*singr+cdng*cosgr)/gg 
c             end do ! nu
c            end do ! mu
c          end do ! ii
c        end if ! gg ne 0
c      end do ! k

      call D3dB_Vector_SumAll(9*nion,efg_smoothr)
      call D3dB_Vector_SumAll(9*nion,efg_smoothi)
!
      value =           MA_pop_stack(exi(2))
      value = value.and.MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2))
      value = value.and. MA_pop_stack(Gtmp(2))
      if (.not. value) call errquit('coulomb_efg:popstack',1,MA_ERR)
!
      return
      end

      SUBROUTINE ccsdt_y_tr1_15(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_of
     &fset)
C     $Id: ccsdt_y_tr1_15.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h2 p1 )_ytrv + = -1/4 * Sum ( p4 p7 p8 ) * i1 ( h2 p4 p7 p8 )_ytr * v ( p7 p8 p1 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER p7b
      INTEGER p8b
      INTEGER h2b_1
      INTEGER p4b_1
      INTEGER p7b_1
      INTEGER p8b_1
      INTEGER p7b_2
      INTEGER p8b_2
      INTEGER p1b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubp(2)
      INTEGER isubp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO p1b = noab+1,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h2b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),int_mb(k_sym+p1b-1)) .eq. ieor(irrep_
     &y,ieor(irrep_tr,irrep_v))) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_15',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO p7b = noab+1,noab+nvab
      DO p8b = p7b,noab+nvab
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+p
     &7b-1)+int_mb(k_spin+p8b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+p7b-1),int_mb(k_sym+p8b-1)))) .eq. ieor(irrep_y,irrep_tr)) T
     &HEN
      CALL TCE_RESTRICTED_4(h2b,p4b,p7b,p8b,h2b_1,p4b_1,p7b_1,p8b_1)
      CALL TCE_RESTRICTED_4(p7b,p8b,p1b,p4b,p7b_2,p8b_2,p1b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+p7b-1) * int_m
     &b(k_range+p8b-1)
      dima_sort = int_mb(k_range+h2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_15',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr1_15',2,MA_ERR)
      IF ((h2b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p8b_1
     & - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (p4b_1 - noab - 1 
     &+ nvab * (h2b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p7b-1),int_mb(k_range+p8b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr1_15',3,MA_ERR
     &)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_15',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr1_15',5,MA_ERR)
      IF ((p4b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p1b_2
     & - 1 + (noab+nvab) * (p4b_2 - 1 + (noab+nvab) * (p8b_2 - 1 + (noab
     &+nvab) * (p7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+p4b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p1b .le. p4b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (p1b_2 - 1 + (noab+nvab) * (p8b_2 - 1 + (noab
     &+nvab) * (p7b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p7b-1)
     &,int_mb(k_range+p8b-1),int_mb(k_range+p1b-1),int_mb(k_range+p4b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr1_15',6,MA_ERR
     &)
      nsubp(1) = 1
      nsubp(2) = 1
      isubp = 1
      IF (p7b .eq. p8b) THEN
      nsubp(isubp) = nsubp(isubp) + 1
      ELSE
      isubp = isubp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubp(1))/FACTORIAL(nsubp(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr1_15',7,M
     &A_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr1_15',8,M
     &A_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr1_15',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h2b-1),2,1,-1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p1b -
     & noab - 1 + nvab * (h2b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr1_15',10,MA_ER
     &R)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr1_15',11,
     &MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* $Id: band_cpmd.F 24513 2013-08-14 17:43:02Z bylaska $
*

***********************************************************************
*                                                                     *
*                         band_cpmd                                   *
*                                                                     *
***********************************************************************

      logical function band_cpmd(rtdb)
      implicit none
      integer rtdb

#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "stdio.fh"
#include "util.fh"
#include "errquit.fh"
      
      logical value

      real*8 kb
      parameter (kb=3.16679d-6)
c      real*8 autoatm
c      parameter (autoatm =290.360032539d6)


      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j,np_k
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3),nwave,nfft3d,n2ft3d
      integer npack0,npack1

*     **** electronic variables ****
      logical spin_orbit
      real*8 icharge
      integer ispin,ispinq
      integer ne(2),nemax,neall,neq(2),nemaxq
      integer nbrillioun,nbrillq
      real*8  en(2)
      real*8 dipole(3)

      integer psi0_tag,psi1_tag,psi2_tag,next
      integer psi0_shift,psi1_shift,psi2_shift
      integer dn(2)
      integer Hpsi_tag,psir_tag
    

*     ***** energy variables ****
      real*8  E(50),eke,eave,evar,cv

      integer eig_tag,hml_tag,svec_tag
      integer eig_shift,hml_shift,svec_shift

*     **** psi smearing block ****
      logical fractional
      integer smearoccupation,smeartype
      real*8 smearfermi(2),smearcorrection,smearkT

*     **** error variables ****
      integer ierr

*     **** local variables ****
      complex*16 zero,one
      parameter (zero=(0.0d0,0.0d0), one=(1.0d0,0.0d0))

      logical verlet,mulliken,SA,found,calc_pressure
      logical lprint,mprint,hprint
      integer ms,if1,if2,vers
      real*8  gx,gy,gz,cx,cy,cz
      real*8  vgx,vgy,vgz,vcx,vcy,vcz
      real*8  ekg,eki0,eki1,sum
      real*8  eke0,eke1,f0,f1,f2,f3,f4,f5,f6
      real*8  EV,pi,dt,a,b,c,alpha,beta,gamma
      real*8  emotion_time_shift
      integer i,j,k,ia,n,nn,nb
      integer ii,jj,index,indx
      integer icount,it_in,it_out,icount_shift
      real*8 w,sumall,pressure,stress(3,3),p1,p2
      real*8 Te_init,Tr_init,Te_new,Tr_new,sa_decay(2),sa_alpha(2)
      integer nfft3,mapping,mapping1d
      parameter (nfft3=32)
      character*50 filename
      character*255 full_filename
  


*     **** external functions ****
      real*8      cpsp_zv,cpsp_rc,ewald_rcut,ion_amass
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg
      integer     ewald_ncut,ewald_nshl3d
      integer     cpsp_nprj,cpsp_lmax,cpsp_locp,ion_nkatm,cpsp_psp_type
      character*4 ion_atom,ion_aname
      external    cpsp_zv,cpsp_rc,ewald_rcut,ion_amass
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg
      external    ewald_ncut,ewald_nshl3d
      external    cpsp_nprj,cpsp_lmax,cpsp_locp,ion_nkatm,cpsp_psp_type
      external    ion_atom,ion_aname

      real*8   control_rti,control_rte,ion_rion
      real*8   ion_vion,ion_com_ke,ion_ke,control_fractional_kT
      real*8   ion_Temperature,ion_com_Temperature
      external control_rti,control_rte,ion_rion
      external ion_vion,ion_com_ke,ion_ke,control_fractional_kT
      external ion_Temperature,ion_com_Temperature
      real*8   control_time_step,control_fake_mass,brillioun_weight
      external control_time_step,control_fake_mass,brillioun_weight
      logical  control_read,control_move,ion_init,ion_q_FixIon
      external control_read,control_move,ion_init,ion_q_FixIon
      logical  ion_q_zFixIon
      external ion_q_zFixIon

      logical  brillioun_print
      external brillioun_print
      real*8   brillioun_weight_brdcst
      external brillioun_weight_brdcst
      real*8   brillioun_ks_brdcst,brillioun_k_brdcst
      external brillioun_ks_brdcst,brillioun_k_brdcst
      integer  Cram_nwave_all_brdcst,Cram_nwave_brdcst
      external Cram_nwave_all_brdcst,Cram_nwave_brdcst
      real*8   cpsi_eig_brdcst_tag,cpsi_occ_brdcst_tag
      external cpsi_eig_brdcst_tag,cpsi_occ_brdcst_tag
      real*8   cpsi_sv_brdcst_tag
      external cpsi_sv_brdcst_tag

      integer  brillioun_nbrillioun,control_fractional_smeartype
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external brillioun_nbrillioun,control_fractional_smeartype
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      integer  cpsi_data_alloc,cpsi_data_get_next,cpsi_data_get_chnk
      external cpsi_data_alloc,cpsi_data_get_next,cpsi_data_get_chnk
      integer  Pneb_nbrillq,Pneb_ispinq,Pneb_w_size,Cram_nwave_all
      external Pneb_nbrillq,Pneb_ispinq,Pneb_w_size,Cram_nwave_all

      character*12 control_boundry
      external     control_boundry

      logical  pspw_reformat_c_wvfnc,pspw_reformat_c_v_wvfnc
      external pspw_reformat_c_wvfnc,pspw_reformat_c_v_wvfnc
      logical      cpsp_semicore,pspw_qmmm_found
      real*8       cpsp_rcore,cpsp_ncore,cpsp_rlocal,ion_TotalCharge
      external     cpsp_semicore,pspw_qmmm_found
      external     cpsp_rcore,cpsp_ncore,cpsp_rlocal,ion_TotalCharge

      logical  control_Nose,control_Mulliken,control_print,Nose_restart
      external control_Nose,control_Mulliken,control_print,Nose_restart

      integer  Nose_Mchain,Nose_Nchain,psi_get_version,v_psi_get_version
      external Nose_Mchain,Nose_Nchain,psi_get_version,v_psi_get_version
  
      real*8   control_Nose_Te,Nose_Qe,Nose_Pe,Nose_Ee0
      external control_Nose_Te,Nose_Qe,Nose_Pe,Nose_Ee0

      real*8   control_Nose_Tr,Nose_Qr,Nose_Pr,Nose_Er0
      external control_Nose_Tr,Nose_Qr,Nose_Pr,Nose_Er0
      logical      v_psi_filefind
      external     v_psi_filefind
      real*8   nwpw_timing
      external nwpw_timing

      logical  control_out_of_time,control_new_vpsi,control_fractional
      external control_out_of_time,control_new_vpsi

      logical  control_SA,control_Fei,pspw_SIC,pspw_HFX,control_pressure
      real*8   control_SA_decay
      external control_SA,control_Fei,pspw_SIC,pspw_HFX,control_pressure
      external control_SA_decay

      integer  control_np_dimensions,control_mapping,control_mapping1d
      external control_np_dimensions,control_mapping,control_mapping1d


      logical  control_translation,control_rotation,control_balance
      external control_translation,control_rotation,control_balance
     
      character*255 cpsp_comment,comment
      external      cpsp_comment
      integer  ion_nconstraints,ion_ndof
      external ion_nconstraints,ion_ndof
      logical  ion_disp_on
      external ion_disp_on




*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(30,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      if (.not.control_read(14,rtdb))
     >   call errquit('band_cpmd:error reading control',0,DISK_ERR)

      lprint = ((taskid.eq.MASTER).and.(control_print(print_low)))
      mprint = ((taskid.eq.MASTER).and.(control_print(print_medium)))
      hprint = ((taskid.eq.MASTER).and.(control_print(print_high)))

      if (taskid.eq.MASTER) call current_second(cpu1)

*     ***** print out header ****
      if (mprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1031)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1042)
         write(luout,1043)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
      end if
      
      call Parallel3d_Init(control_np_dimensions(2),
     >                     control_np_dimensions(3))
      call Parallel3d_np_i(np_i)
      call Parallel3d_np_j(np_j)
      call Parallel3d_np_k(np_k)

      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      nwave = 0
      mapping = control_mapping()

*     **** initialize D3dB data structure ****
      call C3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
      call C3dB_nfft3d(1,nfft3d)

*     **** initialize psi_data ****
      call cpsi_data_init(20)

*     **** initialize lattice and packing data structure ****
      call lattice_init()
      call c_G_init()
      call brillioun_init()
      call Cram_Init()
      call C3dB_pfft_init()

*     ***** Initialize double D3dB data structure ****
      if ((control_gga().ge.10).and.(control_gga().lt.100)) then
         call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)
         call G_init()
         call mask_init()
      end if

*     **** read ions ****
      value = ion_init(rtdb)
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)

*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call cpsp_init()
      call cpsp_readall()
      if (cpsp_semicore(0)) call c_semicore_check()


*     **** initialize G,mask,ke,and coulomb data structures ****
      call cstrfac_init()
      call cke_init()
      call c_coulomb_init()
      call ewald_init()


      call psi_get_ne(ispin,ne)
      if (ispin.eq.3) then
         spin_orbit = .true.
         ispin=2
      else
         spin_orbit = .false.
      end if
      nbrillioun = brillioun_nbrillioun()
      call Pneb_init(ispin,ne,nbrillioun,spin_orbit)
      call Pneb_neq(neq)


*     ***** allocate psi2, psi1, and psi0 wavefunctions ****
      call psi_get_ne_occupation(ispin,ne,smearoccupation)
      if (smearoccupation.gt.0) then
         fractional = .true.
      else
         fractional = .false.
      end if
      mapping1d = control_mapping1d()
      ispinq  = Pneb_ispinq()
      nbrillq = Pneb_nbrillq()

      call Cram_npack(0,npack0)
      call Cram_max_npack(npack1)
      nemaxq = neq(1)+neq(2)
      neall  = ne(1) +ne(2)

      psi2_tag = cpsi_data_alloc(nbrillq,nemaxq,2*npack1)
      psi1_tag = cpsi_data_alloc(nbrillq,nemaxq,2*npack1)
      psi0_tag = cpsi_data_alloc(nbrillq,nemaxq,2*npack1)

*     *** fractional orbitals ***
      if (smearoccupation.gt.0) then
        call cpsi_data_set_next(psi2_tag,
     >                 cpsi_data_alloc(nbrillq,nemaxq,1))
        call cpsi_data_set_next(psi1_tag,
     >                 cpsi_data_alloc(nbrillq,nemaxq,1))
        call cpsi_data_set_next(psi0_tag,
     >                 cpsi_data_alloc(nbrillq,nemaxq,1))
        smeartype = control_fractional_smeartype()
        smearkT   = control_fractional_kT()
      end if

c     **** allocate other variables ****
      Hpsi_tag = cpsi_data_alloc(nbrillq,nemaxq,2*npack1)
      psir_tag = cpsi_data_alloc(nbrillq,nemaxq,2*nfft3d)
      hml_tag  = cpsi_data_alloc(nbrillq,1,2*Pneb_w_size(0,1))
      eig_tag  = cpsi_data_alloc(nbrillq,ne(1)+ne(2),1)
      svec_tag = cpsi_data_alloc(nbrillq,neq(1),3)
      value = MA_alloc_get(mt_dbl,2*nfft3d,'dn',dn(2),dn(1))
      if (.not. value)
     >  call errquit('band_cpmd:out of heap memory',0,MA_ERR)

*     **** convert from pspw format to band format ****
      vers = psi_get_version()
      if ((vers.eq.3).or.(vers.eq.4)) then
        value = rtdb_parallel(.false.)
        if (taskid.eq.MASTER) then
          value= pspw_reformat_c_wvfnc(1)
        end if
        value = rtdb_parallel(.true.)
      end if

*     *****  read psi2 wavefunctions ****
      call cpsi_read(spin_orbit,ispin,ne,nbrillioun,psi2_tag)

*     **** move  wavefunction velocities ****
      if (control_new_vpsi()) then
        call v_cpsi_delete()
      end if

*     **** generate initial wavefunction velocities if it does not exist ****
      if (.not.v_psi_filefind()) then
        call v_cpsi_new(spin_orbit,ispin,ne,nbrillioun)
      end if

*     **** convert from pspw format to band format ****
      vers = v_psi_get_version()
      if ((vers.eq.3).or.(vers.eq.4)) then
        value = rtdb_parallel(.false.)
        if (taskid.eq.MASTER) then
          value= pspw_reformat_c_v_wvfnc(1)
        end if
        value = rtdb_parallel(.true.)
      end if


*     *****  read psi0 wavefunctions ****
      call v_cpsi_read(spin_orbit,ispin,ne,nbrillioun,psi1_tag)


c*     **** initialize QM/MM ****
c      call pspw_qmmm_init(rtdb)
c


*     ******************************
*     **** scaling psi velocity ****
*     ******************************
      call cpsi_data_copyall(psi1_tag,psi0_tag)
      call cpsi_data_scalall(control_rte(),psi1_tag)
      call Pneb_ff_traceall_tag(0,0,psi0_tag,psi0_tag,eke0)
      call Pneb_ff_traceall_tag(0,0,psi1_tag,psi1_tag,eke1)
      eke0 = control_fake_mass()*eke0
      eke1 = control_fake_mass()*eke1
      call ion_init_ke(ekg,eki0,eki1)

*     **** Initialize thermostats ****
      if (control_Nose()) then
         call cke_ave(ispin,neq,psi2_tag,w)
         call Nose_Init((ne(1)+ne(2)),w)
      end if


*     **** Initialize simulated annealing ****
      SA       = .false.
      Te_init  = 0.0d0
      Tr_init  = 0.0d0
      sa_alpha(1) = 1.0d0
      sa_alpha(2) = 1.0d0
      if (control_SA()) then
         if (control_Nose()) then
            SA          = .true.
            sa_decay(1) = control_SA_decay(1)
            sa_decay(2) = control_SA_decay(2)
            Te_init     = control_Nose_Te()
            Tr_init     = control_Nose_Tr()
         else
            dt = control_time_step()
            SA          = .false.
            sa_decay(1) = control_SA_decay(1)
            sa_decay(2) = control_SA_decay(2)
            sa_alpha(1) = dexp( -(dt/control_SA_decay(1)) ) 
            sa_alpha(2) = dexp( -(dt/control_SA_decay(2)) ) 
         end if
      end if


c*     **** initialize dplot ****
c      call dplot_iteration_init()


c*     **** initialize SIC and HFX ****
c      call pspw_init_SIC(rtdb,ne)
c      call pspw_init_HFX(rtdb,ispin,ne)


*     **** initialize pressure ****
      calc_pressure = control_pressure()
      pressure      = 0.0d0
      p1            = 0.0d0
      p2            = 0.0d0
      if (calc_pressure) then
         call cpsp_stress_init()
         call cpsp_stress_readall()
      end if



*                |**************************|
******************   summary of input data  **********************
*                |**************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)
      mulliken = control_Mulliken()

*     **** determine en ****
      if (.not.spin_orbit) then
        next    = cpsi_data_get_next(psi2_tag)
        icharge = 0.0d0
        en(1)   = 0.0d0
        en(2)   = 0.0d0
        b = dble(3-ispin)
        do nb=1,nbrillq
        w = brillioun_weight(nb)
        do ms=1,ispin
          do i=1,ne(ms)
            if (next.lt.0) then
               a = 1.0d0
            else
               indx = cpsi_data_get_chnk(next,nb)+i-1
               indx = indx + (ms-1)*ne(1)
               a = dbl_mb(indx)
            end if
            icharge = icharge - b*a*w
            en(ms)  = en(ms) + a*w
          end do
        end do
        end do
        call K1dB_Vector_SumAll(2,en)
        call K1dB_SumAll(icharge)
      else
        icharge   = -ne(1)
        en(1)     =  ne(1)
        en(ispin) =  ne(ispin)
      end if

      if (mprint) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j,np_k
         if (mapping.eq.1) write(luout,1112)
         if (mapping.eq.2) write(luout,1113)
         if (mapping.eq.3) write(luout,1118)
         if (control_balance()) then
           write(luout,1114)
         else
           write(luout,1116)
         end if

         write(luout,1115)
         write(luout,1121) control_boundry(),control_version()
         if (ispin.eq.1) write(luout,1130) 'restricted'
         if (ispin.eq.2) write(luout,1130) 'unrestricted'

         call v_bwexc_print(luout,control_gga())

c         if (fractional) write(6,1132)
c         call pspw_print_SIC(6)
c         call pspw_print_HFX(6)

         write(luout,1140)
         do ia = 1,ion_nkatm()
           write(luout,1150) ia,ion_atom(ia),cpsp_zv(ia),cpsp_lmax(ia)
           comment = cpsp_comment(ia)
           i = inp_strlen(comment)
           write(luout,1157) comment(1:i)
           write(luout,1158) cpsp_psp_type(ia)
           write(luout,1152) cpsp_lmax(ia)
           write(luout,1153) cpsp_locp(ia)
           write(luout,1154) cpsp_nprj(ia)
           if (cpsp_semicore(ia))
     >         write(luout,1155) cpsp_rcore(ia),cpsp_ncore(ia)
           write(luout,1151) (cpsp_rc(i,ia),i=0,cpsp_lmax(ia))
         end do

         icharge = icharge + ion_TotalCharge()
         write(luout,1159) icharge

         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),
     >                    (ion_rion(K,I),K=1,3),ion_amass(i)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),
     >                    (ion_rion(K,I),K=1,3),ion_amass(i)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         write(luout,1181)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
         write(luout,1211) ion_nconstraints(),ion_ndof()

         write(luout,1220) en(1),en(ispin),' (Fourier space)'
         write(luout,1221) ne(1),neq(1),
     >                     ne(ispin),neq(ispin),' (Fourier space)'

         write(luout,1230)
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         write(luout,1231) lattice_omega()
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()

         write(luout,1255)
         write(luout,1256) brillioun_nbrillioun()
      end if

c     **** print brillioun zone - extra logic for distributed kpoints ****
      if (brillioun_print()) then
         do i=1,brillioun_nbrillioun()
            f0 = brillioun_weight_brdcst(i)
            f1 = brillioun_ks_brdcst(1,i)
            f2 = brillioun_ks_brdcst(2,i)
            f3 = brillioun_ks_brdcst(3,i)
            f4 = brillioun_k_brdcst(1,i)
            f5 = brillioun_k_brdcst(2,i)
            f6 = brillioun_k_brdcst(3,i)
            if (mprint) write(luout,1257) f0,f1,f2,f3,f4,f5,f6
         end do
      else
        if (mprint) write(luout,1258)
      end if

      if1 = Cram_nwave_all_brdcst(0)
      if2 = Cram_nwave_brdcst(0)
      if (mprint) then
         write(luout,1249)
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                     if1,if2
      end if

      if (brillioun_print()) then
        do i=1,brillioun_nbrillioun()
          if1 = Cram_nwave_all_brdcst(i)
          if2 = Cram_nwave_brdcst(i)
          if (mprint) then
          write(luout,1251) i,lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                      if1,if2
          end if
        end do
      else
        if (mprint) write(luout,1252)
      end if

      if (mprint) then
         write(luout,1270)
         if (.not.control_translation()) write(luout,1271)
         if (.not.control_rotation())    write(luout,1272)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_rte(),control_rti()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()

         write(luout,1222) eke0,eki0,ekg
         write(luout,1223) eke1,eki1
         write(luout,1224) (eke1-eke0),(eki1-eki0)
         if (control_Nose()) then
           write(luout,1295)
           if (Nose_restart()) then
              write(luout,*) "    thermostats resused"
           else
              write(luout,*) "    thermostats initialized"
           end if
           do i=1,Nose_Mchain()
             write(luout,1297) i,control_Nose_Te(),Nose_Qe(i),
     >                     Nose_Pe(i),Nose_Ee0(i)
           end do
           do i=1,Nose_Nchain()
             write(luout,1298) i,control_Nose_Tr(),Nose_Qr(i),
     >                   Nose_Pr(i),Nose_Er0(i)
           end do
         else
           write(luout,1294)
         end if
        if (calc_pressure) write(luout,1293)
        if (control_SA()) then
           write(luout,1296) sa_decay(1),sa_decay(2)
         end if


         if (mulliken) write(luout,1299)
         write(luout,1300)
         write(luout,1305)
         call util_flush(luout)
      end if

*                |***************************|
******************     start iterations      **********************
*                |***************************|
*     **** open xyz and MOTION file ****
      call xyz_init()          ! unit=18
      call MOTION_init(rtdb)   ! unit=19

*     *** fei io ****
      call fei_init(rtdb)

*     **** ecce print ****
      call ecce_print_module_entry('task Car-Parrinello')
      !call ecce_print_module_entry('driver')
      call movecs_ecce_print_off()




*     ************************************
*     **** open up other MOTION files ****
*     ************************************


*     **** open EMOTION file ****
      if (.not.rtdb_cget(rtdb,'cpmd:emotion_filename',1,filename))
     >  call util_file_prefix('emotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER) then

         emotion_time_shift = 0.0d0
         icount_shift       = 0
         inquire(file=full_filename,exist=found)
         if (found) then
           open(unit=31,file=full_filename,form='formatted',
     >          status='old')
           do while (found)
           read(31,*,end=100) emotion_time_shift,w,sum
           E(25) = E(25) + sum                          !*** take care of running sums ***
           E(26) = E(26) + sum*sum
           icount_shift = icount_shift + 1
           end do
  100      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1) || defined(GCC46)
           backspace 31
#endif
         else
           open(unit=31,file=full_filename,form='formatted',
     >          status='new')
         end if
      end if


*     **** open EIGMOTION file ****
c      if (mulliken) then
c        if (.not.rtdb_cget(rtdb,'cpmd:eigmotion_filename',1,filename))
c     >    call util_file_prefix('eigmotion',filename)
c      call util_file_name_noprefix(filename,.false.,
c     >                             .false.,
c     >                    full_filename)
c      if (taskid.eq.MASTER) 
c     >   open(unit=32,file=full_filename,form='formatted')
c      end if

c*     **** open HMOTION file ****
c      if (mulliken) then
c       if (.not.rtdb_cget(rtdb,'cpmd:hmotion_filename',1,filename))
c     >  call util_file_prefix('hmotion',filename)
c      call util_file_name_noprefix(filename,.false.,
c     >                             .false.,
c     >                    full_filename)
c      if (taskid.eq.MASTER) 
c     >   open(unit=34,file=full_filename,form='formatted')
c      end if

c*     **** open OMOTION file ****
c      if (mulliken) call Orb_Init(rtdb,ispin,ne) !unit=33

*     **** write initial position to xyz data ****
      call xyz_write()

*     ***** first step using velocity ****
      verlet = .false.
      call band_inner_loop_md(verlet,sa_alpha,
     >                      ispin,ispinq,ne,neq,nbrillioun,nbrillq,
     >                      nfft3d,
     >                      psi0_tag,psi1_tag,psi2_tag,dbl_mb(dn(1)),
     >                      1,0,
     >                      E,
     >                      hml_tag,
     >                      psir_tag,Hpsi_tag,
     >                      calc_pressure,pressure,p1,p2)

      if (taskid.eq.MASTER) call current_second(cpu2)
      if ((mprint).and.(.not.calc_pressure))  call nwpw_message(6)
      if ((mprint).and.     (calc_pressure))  call nwpw_message(9)
      
       it_in  = control_it_in()
       it_out = control_it_out()
       icount = 0
       verlet = .true.
       eke    = 0.0d0
       if (it_out.lt.1) goto 102
 
 
       dt = control_time_step()
 
       Te_new = Te_init
       Tr_new = Tr_init
  101 continue
         icount = icount + 1
         call  band_inner_loop_md(verlet,sa_alpha,
     >                      ispin,ispinq,ne,neq,nbrillioun,nbrillq,
     >                      nfft3d,
     >                      psi0_tag,psi1_tag,psi2_tag,dbl_mb(dn(1)),
     >                      it_in,((icount-1)*it_in),
     >                      E,
     >                      hml_tag,
     >                      psir_tag,Hpsi_tag,
     >                      calc_pressure,pressure,p1,p2)
         eke = eke + E(3)

         !**** calculate pressure ****

         if (taskid.eq.MASTER) then 

           if (mprint) then
              if (calc_pressure) then
                if (SA) then
                write(luout,1309) icount*it_in,E(1),E(2),E(3),E(4),
     >                        Te_new,Tr_new,pressure
                else
                write(luout,1310) icount*it_in,E(1),E(2),E(3),E(4),
     >                        ion_Temperature(),pressure
                end if
              else
                if (SA) then
                write(luout,1309) icount*it_in,E(1),E(2),E(3),E(4),
     >                        Te_new,Tr_new
                else
                write(luout,1310) icount*it_in,E(1),E(2),E(3),E(4),
     >                        ion_Temperature()
                end if
              end if
              call util_flush(luout)
           end if

*          **** write out EMOTION data ****
           eave = E(25)/dble(icount+icount_shift)
           evar = E(26)/dble(icount+icount_shift)
           evar = evar - eave*eave
           if (control_Nose()) then
             write(31,1311) icount*it_in*dt + emotion_time_shift,
     >                    e(1),e(2),e(3),e(4),e(5),e(6),
     >                    e(7),e(8),e(9),e(10),
     >                    eave,evar,ion_Temperature(),pressure
           else
             write(31,1311) icount*it_in*dt + emotion_time_shift,
     >                    e(1),e(2),e(3),e(4),e(5),e(6),
     >                    e(7),e(8),
     >                    eave,evar,ion_Temperature(),pressure
           end if
           call util_flush(31)

c*          **** write out EIGMOTION data -diagonal hml matrix ****
c           if (mulliken) then
c           write(32,1311) icount*it_in*dt,
c     >       (( dbl_mb(hml(1)+ii-1+(ii-1)*ne(1)+(ms-1)*ne(1)*ne(1)), 
c     >         ii=1,ne(ms)),ms=1,ispin)
c           call util_flush(32)
c           end if

c*          **** write out HMOTION data - hml matrix ****
c           if (mulliken) then
c           write(34,1312) icount*it_in*dt,ispin
c           do ms=1,ispin
c             write(34,1313) ms,ne(ms),ne(ms)
c             do ii=1,ne(ms)
c               write(34,1311) 
c     >         (dbl_mb(hml(1)+ii-1+(jj-1)*ne(1)+(ms-1)*ne(1)*ne(1)), 
c     >          jj=1,ne(ms))
c             end do
c           end do
c           call util_flush(34)
c           end if

         end if

*        **** write xyz data ****
         call xyz_write()
         call MOTION_write((icount*it_in*control_time_step()))

c*        **** write OMOTION data ****
c         if (mulliken) call Orb_Write(dcpl_mb(psi1(1)))

*        **** update thermostats using SA decay ****
         if (SA) then
           t1 = icount*it_in*dt/sa_decay(1)
           t2 = icount*it_in*dt/sa_decay(2)
           Te_new = Te_init*dexp(-t1)
           Tr_new = Tr_init*dexp(-t2)
           call Nose_reset_T(Te_new,Tr_new)
         end if

*        **** exit early ****
         if (control_out_of_time()) then
            if (mprint)
     >       write(luout,*) 
     >       ' *** out of time. iteration terminated'
            go to 102
         end if
      if (icount.lt.it_out) go to 101
      if (mprint)
     > write(luout,*) 
     > '*** arived at the Maximum iteration.   terminated.'
 
*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::

  102 continue

*     **** close xyz and MOTION files ****
      call xyz_end()
      call MOTION_end()
      if (taskid.eq.MASTER) then
        close(unit=31)
c        close(unit=32)
c        close(unit=34)
      end if

*     *** close fei io ****
      call fei_end()

c*     **** close OMOTION file ****
c      if (mulliken) call Orb_End()

*     **** ecce print ****
      !call ecce_print_module_exit('driver', 'ok')
      call ecce_print_module_exit('task Car-Parrinello', 'ok')


*     **** finalize pressure ****
      if (calc_pressure) then
         call cpsp_stress_end()
      end if


      if (mprint) CALL nwpw_message(3)
      if (taskid.eq.MASTER) call current_second(cpu3)


*         |****************************************|
*********** produce CHECK file and diagonalize hml *****************
*         |****************************************|

*     **** produce CHECK FILE ****
      if (taskid.eq.MASTER) then
         call util_file_name('CHECK',.true.,
     >                               .false.,
     >                       full_filename)
         open(unit=17,file=full_filename,form='formatted')
      end if

*     **** check total number of electrons ****
      do ms =1,ispin
         call C3dB_r_dsum(1,dbl_mb(dn(1)+(ms-1)*nfft3d),sumall)
         en(ms) = sumall*lattice_omega()
     >             /dble(ngrid(1)*ngrid(2)*ngrid(3))
      end do
      if (taskid.eq.MASTER) then
         write(17,1320) (en(ms),ms=1,ispin)
      end if

c*     **** comparison between hamiltonian an lambda matrix ****
c      if (taskid.eq.MASTER) write(17,1330)
c      do ms=1,ispin
c         do i=1,ne(ms)
c         do j=1,ne(ms)
c            w   = Dneall_m_value(0,ms,i,j,dbl_mb(hml(1)))
c            sum = Dneall_m_value(0,ms,i,j,dbl_mb(lmd(1)))
c
c            if (taskid.eq.MASTER)
c     >      write(17,1340) ms,i,j,w,sum,w-sum
c
c         end do
c         end do
c      end do
c
c*     **** check orthonormality ****
c      if (taskid.eq.MASTER) then
c         write(17,1350)
c      end if
c
c      call Dneall_ffm_Multiply(0,dcpl_mb(psi1(1)),
c     >                           dcpl_mb(psi1(1)),npack1,
c     >                           dbl_mb(lmd(1)))
c      do ms=1,ispin
c         do j=1,ne(ms)
c         do i=j,ne(ms)
c            w  = Dneall_m_value(0,ms,i,j,dbl_mb(lmd(1)))
c            if (taskid.eq.MASTER) write(17,1360) ms,i,j,w
c         end do
c         end do
c      end do
c
*     **** close check file ****
      if (taskid.eq.MASTER) then
         close(17)
      end if


*     ***** diagonalize the hamiltonian matrix ****
      call cpsi_data_update(hml_tag)
      call cpsi_data_update(eig_tag)
      do nb=1,nbrillq
        hml_shift = cpsi_data_get_chnk(hml_tag,nb)
        eig_shift = cpsi_data_get_chnk(eig_tag,nb)
        call Pneb_w_diag(0,nb,dbl_mb(eig_shift),dbl_mb(hml_shift))
      end do
      call cpsi_data_noupdate(hml_tag)
      call cpsi_data_noupdate(eig_tag)


*     ***** rotate the psi and v_psi ****
      call cpsi_data_update(psi2_tag)
      call cpsi_data_update(psi0_tag)
      do nb=1,nbrillq
        psi0_shift = cpsi_data_get_chnk(psi0_tag,nb)
        psi1_shift = cpsi_data_get_chnk(psi1_tag,nb)
        psi2_shift = cpsi_data_get_chnk(psi2_tag,nb)
        hml_shift  = cpsi_data_get_chnk(hml_tag,nb)

*       **** rotate psi ****
        call Pneb_fwf_Multiply(0,nb,
     >                       one,
     >                       dbl_mb(psi1_shift),npack1,
     >                       dbl_mb(hml_shift),
     >                       zero,
     >                       dbl_mb(psi2_shift))

*       **** rotate v_psi ****
        call dcopy(2*npack1*nemaxq,dbl_mb(psi0_shift),1,
     >                             dbl_mb(psi1_shift),1)
        call Pneb_fwf_Multiply(0,nb,
     >                       one,
     >                       dbl_mb(psi1_shift),npack1,
     >                       dbl_mb(hml_shift),
     >                       zero,
     >                       dbl_mb(psi0_shift))

      end do
      call cpsi_data_noupdate(psi2_tag)
      call cpsi_data_noupdate(psi0_tag)




*                |***************************|
****************** report summary of results **********************
*                |***************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)

      if (mprint) then
         call print_elapsed_time(icount*it_in*dt)
         write(luout,1300)
         write(luout,1410)
         write(luout,1420)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(6,1193) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz


         write(luout,1421)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
         write(luout,1211) ion_nconstraints(),ion_ndof()

         write(luout,*)
         write(luout,1320) en(1),en(ispin),' (real space)'
         write(luout,1430) E(2),E(2)/ion_nion()
         write(luout,1440) E(5),E(5)/neall
         write(luout,1450) E(6),E(6)/neall
         write(luout,1460) E(7),E(7)/neall
         write(luout,1470) E(8),E(8)/neall
         write(luout,1471) E(3),E(3)/neall
         write(luout,1472) ion_ke(),ion_ke()/ion_nion()

c         if (pspw_qmmm_found()) then
c            write(6,1700)
c            write(6,1701)
c            write(6,1702) E(11)
c            write(6,1703) E(12)
c            write(6,1704) E(13)
ccc            write(6,1705) E(14)
c            write(6,1706) E(15)
c         end if
         if (ion_disp_on()) then
           write(luout,1720) E(33)
         end if

         if (control_Nose()) then
           write(luout,1473) E(9),E(9)/neall
           write(luout,1474) E(10),E(10)/ion_nion()
         end if
         write(luout,1226) E(3),ion_ke(),ion_com_ke()
         eke = eke/dble(it_out)

*        **** !!!!Cram_nwave_all probably not correct!!!!
         eke = 2.0d0*eke/kb/(ne(1)+ne(ispin))/Cram_nwave_all(1)
         !eke = 2.0d0*eke/kb/(ne(1)+ne(ispin))

*       **** write out Temperatures ****
         write(luout,1491) eke
         eki0 = ion_Temperature()
         write(luout,1480) eki0
         write(luout,1490) ion_com_Temperature()

         eave = E(25)/dble(icount+icount_shift)
         evar = E(26)/dble(icount+icount_shift)
         evar = evar - eave*eave
         cv = (evar)/(kb*ion_Temperature()**2)
         cv = cv/dble(ion_nion())
         write(luout,1492) eave
         write(luout,1493) evar
         write(luout,1494) cv

      end if

      NN=ne(1)-ne(2)
      EV=27.2116d0
      if (mprint) then
        if (control_fractional()) then
          if (ispin.eq.1) then
            write(luout,1507) smearfermi(1),smearfermi(1)*EV
          else
            write(luout,1507) smearfermi(1),smearfermi(1)*EV,
     >                        smearfermi(2),smearfermi(2)*EV
          end if
        end if
      end if

*     *** generate spinorbit vector ***
      if (spin_orbit) call Pneb_f_SOSpins_tag(psi2_tag,svec_tag)

*     *** printout the eigenvalue spetra ****
      if (brillioun_print()) then
      do nb=1,brillioun_nbrillioun()
        f0 = brillioun_weight_brdcst(nb)
        f1 = brillioun_ks_brdcst(1,nb)
        f2 = brillioun_ks_brdcst(2,nb)
        f3 = brillioun_ks_brdcst(3,nb)
        f4 = brillioun_k_brdcst(1,nb)
        f5 = brillioun_k_brdcst(2,nb)
        f6 = brillioun_k_brdcst(3,nb)
        if (mprint) then
          write(luout,1508) nb,f0,f1,f2,f3,f4,f5,f6
          write(luout,1500)
        end if
        next = cpsi_data_get_next(psi1_tag)
        if (spin_orbit) then
c          if (mprint) write(luout,1511)
          do i=0,ne(1)-1
            f1=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag, nb,1,ne(1)-i)
            f2=cpsi_sv_brdcst_tag( spin_orbit,svec_tag,nb,ne(1)-i,1)
            f3=cpsi_sv_brdcst_tag( spin_orbit,svec_tag,nb,ne(1)-i,2)
            f4=cpsi_sv_brdcst_tag( spin_orbit,svec_tag,nb,ne(1)-i,3)
            f0 = dsqrt(f2*f2 + f3*f3 + f4*f4)
            f5=cpsi_occ_brdcst_tag(ne,spin_orbit,next,    nb,1,ne(1)-i)
            if (mprint) write(luout,1512) f1,f1*EV,f0,f2,f3,f4,f5
          end do
        else
          do i=0,NN-1
            f1=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag,nb,1,ne(1)-i)
            f2=cpsi_occ_brdcst_tag(ne,spin_orbit,next,   nb,1,ne(1)-i)
            if (mprint) write(luout,1510) f1,f1*EV,f2
          end do
          do i=0,ne(2)-1
           f1=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag,nb,1,ne(1)-i-NN)
           f2=cpsi_occ_brdcst_tag(ne,spin_orbit,next,   nb,1,ne(1)-i-NN)
           f3=cpsi_eig_brdcst_tag(ne,spin_orbit,eig_tag,nb,2,ne(2)-i)
           f4=cpsi_occ_brdcst_tag(ne,spin_orbit,next,   nb,2,ne(2)-i)
           if (mprint) write(luout,1510) f1,f1*EV,f2,f3,f3*EV,f4
          end do
        end if
      end do
      endif

*     *** Extra energy output added for QA test ****
      if (mprint) then
         write(luout,1600) E(2)
      end if

*                |***************************|
******************         Prologue          **********************
*                |***************************|
c
c*     **** calculate spin contamination ****
c      call Calculate_psi_spin2(ispin,ne,npack1,dcpl_mb(psi2(1)),
c     >                         fractional,dbl_mb(occ2(1)),
c     >                         dipole)
c
c*     **** calculate the Dipole ***
c      call Calculate_Dipole(ispin,ne,n2ft3d,dbl_mb(dn(1)),dipole)

*     ***** write wavefunctions and v_wavefunctions ****
      call cpsi_write(  spin_orbit,ispin,ne,nbrillioun,psi2_tag)
      call v_cpsi_write(spin_orbit,ispin,ne,nbrillioun,psi0_tag)

*     **** write geometry to rtdb ****
      call ion_write(rtdb)


*     **** deallocate heap memory ****
      call ewald_end()
      call cstrfac_end()
      call c_coulomb_end()
      call cke_end()
      call cpsp_end()
      call Cram_end()
      call c_G_end()
      call brillioun_end()
      call ion_end()
      call ion_end_FixIon()
       if (control_Nose()) call Nose_end()

c      call pspw_end_SIC()
c      call pspw_end_HFX()
c      call pspw_qmmm_end()

      call cpsi_data_dealloc(Hpsi_tag)
      call cpsi_data_dealloc(psir_tag)
      next = cpsi_data_get_next(psi0_tag)
      if (next.ge.0) call cpsi_data_dealloc(next)
      call cpsi_data_dealloc(psi0_tag)
      next = cpsi_data_get_next(psi1_tag)
      if (next.ge.0) call cpsi_data_dealloc(next)
      call cpsi_data_dealloc(psi1_tag)
      next = cpsi_data_get_next(psi2_tag)
      if (next.ge.0) call cpsi_data_dealloc(next)
      call cpsi_data_dealloc(psi2_tag)
      call cpsi_data_dealloc(hml_tag)
      call cpsi_data_dealloc(eig_tag)
      call cpsi_data_dealloc(svec_tag)
      value = MA_free_heap(dn(2))
      if (.not. value)
     >  call errquit('band_cpmd:error freeing heap',0,MA_ERR)



      call C3dB_pfft_end()
      call cpsi_data_end()
      call C3dB_end(1)
      if ((control_gga().ge.10).and.(control_gga().lt.100)) then
         call mask_end()
         call G_end()
         call D3dB_end(1)
      end if

*     **** do anaylysis on MOTION files ****
      call cpmd_properties(rtdb)


*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (mprint) then
         CALL current_second(cpu4)

         t1=cpu2-cpu1
         t2=cpu3-cpu2
         t3=cpu4-cpu3
         t4=cpu4-cpu1
         av=t2/dble(icount*it_in)
         write(luout,*)
         write(luout,*) '-----------------'
         write(luout,*) 'cputime in seconds'
         write(luout,*) 'prologue    : ',T1
         write(luout,*) 'main loop   : ',T2
         write(luout,*) 'epilogue    : ',T3
         write(luout,*) 'total       : ',T4
         write(luout,*) 'cputime/step: ',AV
         write(luout,*)

         call nwpw_timing_print_final(.true.,(icount*it_in))
         CALL nwpw_message(4)
      end if 


      call Parallel3d_Finalize()
      call Parallel_Finalize()
      band_cpmd = value
      return
cc
ccc
*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*     Car-Parrinello microcluster calculation      *')
 1030 FORMAT(10X,'*      [   extended Lagrangian molecular   ]       *')
 1031 FORMAT(10X,'*      [        dynamics simulation        ]       *')
 1035 FORMAT(10x,'*      [ NorthWest Chemistry implementation ]      *')
 1040 FORMAT(10X,'*            version #5.00   06/01/99              *')
 1041 FORMAT(10X,'*    This code was developed by Eric J. Bylaska,   *')
 1042 FORMAT(10X,'*    and was based upon algorithms and code        *')
 1043 FORMAT(10X,'*    developed by the group of Prof. John H. Weare *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I16)
 1112 FORMAT( ' parallel mapping         :         1d slab')
 1113 FORMAT( ' parallel mapping         :      2d hilbert')
 1114 FORMAT( ' parallel mapping         :        balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         :    not balanced')
 1118 FORMAT( ' parallel mapping         :       2d hcurve')
 1117 FORMAT( ' processor grid           :',I4,' x',I4,' x',I4)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I1)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)
 1159 FORMAT(/' total charge=',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I3))
 1180 FORMAT(/' initial position of ions:')
 1181 FORMAT(/' initial velocity of ions:')
 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5  ,' (',3F11.5,
     >       ' ) - atomic mass= ',F6.3,' - fixed')
 1192 FORMAT(5X, I4, A5  ,' (',3F11.5,' )')
 1193 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - z fixed')
 1200 FORMAT(5X,'   G.C.  ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1211 FORMAT(5X,'   number of constraints = ', I6,' ( DOF = ',I6,' )' )
 1220 FORMAT(/' number of electrons: spin up=',F6.2,16x,
     >                               '  down=',F6.2,A)
 1221 FORMAT( ' number of orbitals : spin up=',I6,
     >        ' (',I4,' per task)',
     >        '  down=',I6,
     >        ' (',I4,' per task)',
     >        A)
 1222 format(5x,' initial kinetic energy: ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)',/50x,
     >                                      e12.5,' (c.o.m.)')
 1223 format(5x,' after scaling:          ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)')
 1224 format(5x,' increased energy:       ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)')
 1226 format(/' final kinetic energy:  ',e12.5,' (psi)', 2x,
     >                                      e12.5,' (ion)',/44x,
     >                                      e12.5,' (c.o.m.)')
 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,' volume : ',F10.1)
 1232 FORMAT(/5x,' lattice:    a=',f8.3,'    b=',f8.3,'     c=',f8.3,
     >       /5x,'         alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')


 1249 FORMAT(/' computational grids:')
 1250 FORMAT(5X,' density     cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc ',I3,' cutoff=',F7.3,
     &        '  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1252 FORMAT(5x, ' wavefunction grids not printed - ',
     >           'number of k-point is very large')

 1255 FORMAT(/' brillouin zone:')
 1256 FORMAT(5x,' number of zone points:',I3)
 1257 FORMAT(5x,' weight=',f8.3,'  ks=<',3f8.3,' >, k=<',3f8.3,'>')
 1258 FORMAT(5x,' number of k-point is very large or distributed')

 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters:')
 1271 FORMAT(5x, ' translation constrained')
 1272 FORMAT(5x, ' rotation constrained')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' cooling/heatting rates: ',e12.5,' (psi)',2x,
     >                                       e12.5,' (ion)')
 1293 format(/' Pressure Output Generated         ')
 1294 format(/' Constant Energy Simulation                     ')
 1295 format(/' Nose-Hoover Simulation - Thermostat Parameters:')
 1296 format(5x, 'SA decay rates  =',e10.3,' (elc)',e10.3,' (ion)')
 1297 format(5x, 'link = ',I3,
     > ' Te =',f8.2,' Qe =',e10.3,' 2*pi/we=',e10.3,' Ee0=',e10.3)
 1298 format(5x, 'link = ',I3,
     > ' Tr =',f8.2,' Qr =',e10.3,' 2*pi/wr=',e10.3,' Er0=',e10.3)
 1299 format(//' Mulliken Analysis Output Generated            ')
 1300 FORMAT(//)
 1305 FORMAT(10X,'============ Car-Parrinello iteration ==============')
 1309 FORMAT(I8,2E19.10,2E14.5,2F9.1,3E11.3)
 1310 FORMAT(I8,2E19.10,2E14.5,F14.2,3E11.3)
 1311 format(100e19.10)
 1312 format(e14.6,i3)
 1313 format(3i4)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1331 FORMAT(/' Elements of Hamiltonian matrix (up/restricted)')
 1332 FORMAT(/' Elements of Hamiltonian matrix (down)')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1341 FORMAT(I3,2I3,' H=',E16.6)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT(/' final position of ions:')
 1421 FORMAT(/' final velocity of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1455 FORMAT( ' SIC-hartree energy  :',E19.10,' (',E15.5,'/electron)')
 1456 FORMAT( ' SIC-exc-corr energy :',E19.10,' (',E15.5,'/electron)')
 1457 FORMAT( ' HF exchange energy  :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1471 FORMAT(/' Kinetic energy (elc)    :',E19.10,' (',E15.5,'/elc)')
 1472 FORMAT( ' Kinetic energy (ion)    :',E19.10,' (',E15.5,'/ion)')
 1473 FORMAT( ' thermostat energy (elc) :',E19.10,' (',E15.5,'/elc)')
 1474 FORMAT( ' thermostat energy (ion) :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(' Temperature :    ',F10.1,' K (ion)')
 1490 FORMAT('             :    ',F10.1,' K (c.o.m.)')
 1491 FORMAT(' Temperature :    ',F10.1,' K (elc)')
 1492 FORMAT(/' Eaverage           :    ',E19.10)
 1493 FORMAT( ' Evariance          :    ',E19.10)
 1494 FORMAT( ' Cv - f*kb/(2*nion) :    ',E19.10)
 1499 FORMAT( ' K.S. SIC-hartree energy  :',E19.10,
     >        ' (',E15.5,'/electron)')
 1501 FORMAT( ' K.S. SIC-exc-corr energy :',E19.10,
     >        ' (',E15.5,'/electron)')
 
 1500 FORMAT(/' orbital energies:')
 1507 FORMAT(/' Fermi energy =',2(E18.7,' (',F8.3,'eV)'))
 1508 FORMAT(/' Brillouin zone point: ',i3,
     >       /'    weight=',f10.6,
     >       /'    k     =<',3f8.3,'> . <b1,b2,b3> ',
     >       /'          =<',3f8.3,'>')
 1510 FORMAT(4(E18.7,' (',F8.3,'eV) occ=',F5.3))
 1511 FORMAT(33x,"Spin(Sz,Sy,Sz)")
 1512 FORMAT(E18.7,' (',F8.3,' eV) (|s| =',F6.3,
     >       ', s = <',F7.3,',',F7.3,',',F7.3,'> ) occ=',F5.3)

 1600 FORMAT(/' Total BAND energy   :',E19.10)

 1700 FORMAT(/' QM/MM-pol-vib/CAV Energies')
 1701 FORMAT( ' --------------------------')
 1702 FORMAT( ' LJ energy              :',E19.10)
 1703 FORMAT( ' Residual Coulomb energy:',E19.10)
 1704 FORMAT( ' MM Vibration energy    :',E19.10)
 1705 FORMAT( ' MM Vibration energy    :',E19.10)
 1706 FORMAT( ' (QM+MM)/Cavity energy  :',E19.10)

 1720 FORMAT(/' Dispersion energy   :',E19.10)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(6,9010) ierr
      call Parallel3d_Finalize()
      call Parallel_Finalize()

      band_cpmd = value
      return
      END

      subroutine sym_2pdm_ao(d_r2,k_r2_offset,nshblocks,
     1           bfglo,bfghi)
c
c Prints the particle-hole block of the 1-e reduced density matrix
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
      integer d_r2, k_r2_offset
      integer nshblocks, bfglo(*), bfghi(*)
      integer ib,jb,kb,lb,idim,jdim,kdim,ldim
      integer i1,j1,k1,l1, i
      integer k_r2_1,l_r2_1
      integer k_r2_2,l_r2_2
      integer k_r2_3,l_r2_3
      integer k_r2_4,l_r2_4
      integer k_r2_5,l_r2_5
      integer k_r2_6,l_r2_6
      integer k_r2_7,l_r2_7
      integer k_r2_8,l_r2_8
      integer l_a,k_a
      integer size
      integer ind1,ind2,ind3,ind4,ind5,ind6,ind7,ind8
      logical nodezero
      double precision res
c
      integer nxtask
      integer next
      integer count
      integer nprocs
      external nxtask
c

c      nodezero = (ga_nodeid().eq.0)
      nprocs=ga_nnodes( )
      count=0
      next=nxtask(nprocs,1)
c
      do ib=1,nshblocks
c         idim=bfghi(ib)-bfglo(ib)+1
c      do jb=1,nshblocks
      do jb=ib,nshblocks
c         jdim=bfghi(jb)-bfglo(jb)+1
c      do kb=1,nshblocks
      do kb=ib,nshblocks
c         kdim=bfghi(kb)-bfglo(kb)+1
c      do lb=1,nshblocks
      do lb=jb,nshblocks
         if(next.eq.count) then
         if(ib.eq.jb.and.lb.lt.kb) then
         else
c           write(6,'(a,4i4)') 'ib,jb,kb,lb=',ib,jb,kb,lb
c           write(6,'(a,4i4)') 'kb,jb,ib,lb=',kb,jb,ib,lb
c           write(6,'(a,4i4)') 'ib,lb,kb,jb=',ib,lb,kb,jb
c           write(6,'(a,4i4)') 'kb,lb,ib,jb=',kb,lb,ib,jb
c           write(6,'(a,4i4)') 'jb,ib,lb,kb=',jb,ib,lb,kb
c           write(6,'(a,4i4)') 'lb,ib,jb,kb=',lb,ib,jb,kb
c           write(6,'(a,4i4)') 'jb,kb,lb,ib=',jb,kb,lb,ib
c           write(6,'(a,4i4)') 'lb,kb,jb,ib=',lb,kb,jb,ib
c
         idim=bfghi(ib)-bfglo(ib)+1
         jdim=bfghi(jb)-bfglo(jb)+1
         kdim=bfghi(kb)-bfglo(kb)+1
         ldim=bfghi(lb)-bfglo(lb)+1
c
         size = idim*jdim*kdim*ldim
         if (.not.ma_push_get(mt_dbl,size,'r2_1',l_r2_1,k_r2_1))
     1   call errquit('sym_2pdm_ao: ma problem',0,ma_err)
         if (.not.ma_push_get(mt_dbl,size,'r2_2',l_r2_2,k_r2_2))
     1   call errquit('sym_2pdm_ao: ma problem',1,ma_err)
         if (.not.ma_push_get(mt_dbl,size,'r2_3',l_r2_3,k_r2_3))
     1   call errquit('sym_2pdm_ao: ma problem',2,ma_err)
         if (.not.ma_push_get(mt_dbl,size,'r2_4',l_r2_4,k_r2_4))
     1   call errquit('sym_2pdm_ao: ma problem',3,ma_err)
         if (.not.ma_push_get(mt_dbl,size,'r2_5',l_r2_5,k_r2_5))
     1   call errquit('sym_2pdm_ao: ma problem',4,ma_err)
         if (.not.ma_push_get(mt_dbl,size,'r2_6',l_r2_6,k_r2_6))
     1   call errquit('sym_2pdm_ao: ma problem',5,ma_err)
         if (.not.ma_push_get(mt_dbl,size,'r2_7',l_r2_7,k_r2_7))
     1   call errquit('sym_2pdm_ao: ma problem',6,ma_err)
         if (.not.ma_push_get(mt_dbl,size,'r2_8',l_r2_8,k_r2_8))
     1   call errquit('sym_2pdm_ao: ma problem',7,ma_err)
c
         call dfill(size,0.d0,dbl_mb(k_r2_1),1)
         call dfill(size,0.d0,dbl_mb(k_r2_2),1)
         call dfill(size,0.d0,dbl_mb(k_r2_3),1)
         call dfill(size,0.d0,dbl_mb(k_r2_4),1)
         call dfill(size,0.d0,dbl_mb(k_r2_5),1)
         call dfill(size,0.d0,dbl_mb(k_r2_6),1)
         call dfill(size,0.d0,dbl_mb(k_r2_7),1)
         call dfill(size,0.d0,dbl_mb(k_r2_8),1)
c
c        (i,j,k,l)
         call get_hash_block(d_r2,dbl_mb(k_r2_1),size,
     1        int_mb(k_r2_offset),(lb-1)+(kb-1)*nshblocks
     1        +(jb-1)*nshblocks*nshblocks
     1        +(ib-1)*nshblocks*nshblocks*nshblocks)
c        (k,j,i,l)
         call get_hash_block(d_r2,dbl_mb(k_r2_2),size,
     1        int_mb(k_r2_offset),(lb-1)+(ib-1)*nshblocks
     1        +(jb-1)*nshblocks*nshblocks
     1        +(kb-1)*nshblocks*nshblocks*nshblocks)
c        (i,l,k,j)
         call get_hash_block(d_r2,dbl_mb(k_r2_3),size,
     1        int_mb(k_r2_offset),(jb-1)+(kb-1)*nshblocks
     1        +(lb-1)*nshblocks*nshblocks
     1        +(ib-1)*nshblocks*nshblocks*nshblocks)
c        (k,l,i,j)
         call get_hash_block(d_r2,dbl_mb(k_r2_4),size,
     1        int_mb(k_r2_offset),(jb-1)+(ib-1)*nshblocks
     1        +(lb-1)*nshblocks*nshblocks
     1        +(kb-1)*nshblocks*nshblocks*nshblocks)
c        (j,i,l,k)
         call get_hash_block(d_r2,dbl_mb(k_r2_5),size,
     1        int_mb(k_r2_offset),(kb-1)+(lb-1)*nshblocks
     1        +(ib-1)*nshblocks*nshblocks
     1        +(jb-1)*nshblocks*nshblocks*nshblocks)
c        (l,i,j,k)
         call get_hash_block(d_r2,dbl_mb(k_r2_6),size,
     1        int_mb(k_r2_offset),(kb-1)+(jb-1)*nshblocks
     1        +(ib-1)*nshblocks*nshblocks
     1        +(lb-1)*nshblocks*nshblocks*nshblocks)
c        (j,k,l,i)
         call get_hash_block(d_r2,dbl_mb(k_r2_7),size,
     1        int_mb(k_r2_offset),(ib-1)+(lb-1)*nshblocks
     1        +(kb-1)*nshblocks*nshblocks
     1        +(jb-1)*nshblocks*nshblocks*nshblocks)
c        (l,k,j,i)
         call get_hash_block(d_r2,dbl_mb(k_r2_8),size,
     1        int_mb(k_r2_offset),(ib-1)+(jb-1)*nshblocks
     1        +(kb-1)*nshblocks*nshblocks
     1        +(lb-1)*nshblocks*nshblocks*nshblocks)
c
            do i1 = 1, idim
            do j1 = 1, jdim
            do k1 = 1, kdim
            do l1 = 1, ldim
               ind1 = (l1-1)+(k1-1)*ldim+(j1-1)*ldim*kdim
     1               +(i1-1)*ldim*kdim*jdim
               ind2 = (l1-1)+(i1-1)*ldim+(j1-1)*ldim*idim
     1               +(k1-1)*ldim*idim*jdim
               ind3 = (j1-1)+(k1-1)*jdim+(l1-1)*jdim*kdim
     1               +(i1-1)*jdim*kdim*ldim
               ind4 = (j1-1)+(i1-1)*jdim+(l1-1)*jdim*idim
     1               +(k1-1)*jdim*idim*ldim
               ind5 = (k1-1)+(l1-1)*kdim+(i1-1)*kdim*ldim
     1               +(j1-1)*kdim*ldim*idim
               ind6 = (k1-1)+(j1-1)*kdim+(i1-1)*kdim*jdim
     1               +(l1-1)*kdim*jdim*idim
               ind7 = (i1-1)+(l1-1)*idim+(k1-1)*idim*ldim
     1               +(j1-1)*idim*ldim*kdim
               ind8 = (i1-1)+(j1-1)*idim+(k1-1)*idim*jdim
     1               +(l1-1)*idim*jdim*kdim
               res = (1.d0/8.d0)*(
     1               dbl_mb(k_r2_1+ind1)+dbl_mb(k_r2_2+ind2)+
     1               dbl_mb(k_r2_3+ind3)+dbl_mb(k_r2_4+ind4)+
     1               dbl_mb(k_r2_5+ind5)+dbl_mb(k_r2_6+ind6)+
     1               dbl_mb(k_r2_7+ind7)+dbl_mb(k_r2_8+ind8) )
c
               dbl_mb(k_r2_1+ind1)=res
               dbl_mb(k_r2_2+ind2)=res
               dbl_mb(k_r2_3+ind3)=res
               dbl_mb(k_r2_4+ind4)=res
               dbl_mb(k_r2_5+ind5)=res
               dbl_mb(k_r2_6+ind6)=res
               dbl_mb(k_r2_7+ind7)=res
               dbl_mb(k_r2_8+ind8)=res
c 
            enddo
            enddo
            enddo
            enddo
c        (i,j,k,l)
         call put_hash_block(d_r2,dbl_mb(k_r2_1),size,
     1        int_mb(k_r2_offset),(lb-1)+(kb-1)*nshblocks
     1        +(jb-1)*nshblocks*nshblocks
     1        +(ib-1)*nshblocks*nshblocks*nshblocks)
c        (k,j,i,l)
         call put_hash_block(d_r2,dbl_mb(k_r2_2),size,
     1        int_mb(k_r2_offset),(lb-1)+(ib-1)*nshblocks
     1        +(jb-1)*nshblocks*nshblocks
     1        +(kb-1)*nshblocks*nshblocks*nshblocks)
c        (i,l,k,j)
         call put_hash_block(d_r2,dbl_mb(k_r2_3),size,
     1        int_mb(k_r2_offset),(jb-1)+(kb-1)*nshblocks
     1        +(lb-1)*nshblocks*nshblocks
     1        +(ib-1)*nshblocks*nshblocks*nshblocks)
c        (k,l,i,j)
         call put_hash_block(d_r2,dbl_mb(k_r2_4),size,
     1        int_mb(k_r2_offset),(jb-1)+(ib-1)*nshblocks
     1        +(lb-1)*nshblocks*nshblocks
     1        +(kb-1)*nshblocks*nshblocks*nshblocks)
c        (j,i,l,k)
         call put_hash_block(d_r2,dbl_mb(k_r2_5),size,
     1        int_mb(k_r2_offset),(kb-1)+(lb-1)*nshblocks
     1        +(ib-1)*nshblocks*nshblocks
     1        +(jb-1)*nshblocks*nshblocks*nshblocks)
c        (l,i,j,k)
         call put_hash_block(d_r2,dbl_mb(k_r2_6),size,
     1        int_mb(k_r2_offset),(kb-1)+(jb-1)*nshblocks
     1        +(ib-1)*nshblocks*nshblocks
     1        +(lb-1)*nshblocks*nshblocks*nshblocks)
c        (j,k,l,i)
         call put_hash_block(d_r2,dbl_mb(k_r2_7),size,
     1        int_mb(k_r2_offset),(ib-1)+(lb-1)*nshblocks
     1        +(kb-1)*nshblocks*nshblocks
     1        +(jb-1)*nshblocks*nshblocks*nshblocks)
c        (l,k,j,i)
         call put_hash_block(d_r2,dbl_mb(k_r2_8),size,
     1        int_mb(k_r2_offset),(ib-1)+(jb-1)*nshblocks
     1        +(kb-1)*nshblocks*nshblocks
     1        +(lb-1)*nshblocks*nshblocks*nshblocks)
c
            if (.not.ma_pop_stack(l_r2_8))
     1        call errquit('sym_2pdm_ao: MA problem',9,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2_7))
     1        call errquit('sym_2pdm_ao: MA problem',10,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2_6))
     1        call errquit('sym_2pdm_ao: MA problem',11,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2_5))
     1        call errquit('sym_2pdm_ao: MA problem',12,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2_4))
     1        call errquit('sym_2pdm_ao: MA problem',13,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2_3))
     1        call errquit('sym_2pdm_ao: MA problem',14,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2_2))
     1        call errquit('sym_2pdm_ao: MA problem',15,MA_ERR)
c
            if (.not.ma_pop_stack(l_r2_1))
     1        call errquit('sym_2pdm_ao: MA problem',16,MA_ERR)
            endif
            next=nxtask(nprocs,1)
            endif
            count=count+1
c
      enddo
      enddo
      enddo
      enddo
      next=nxtask(-nprocs,1)
      call ga_sync( )
c
c     check if it is symmetrized
c
c      do ib=1,nshblocks
c         idim=bfghi(ib)-bfglo(ib)+1
c      do jb=1,nshblocks
c         jdim=bfghi(jb)-bfglo(jb)+1
c      do kb=1,nshblocks
c         kdim=bfghi(kb)-bfglo(kb)+1
c      do lb=1,nshblocks
c         ldim=bfghi(lb)-bfglo(lb)+1
c         size = idim*jdim*kdim*ldim
c         if (.not.ma_push_get(mt_dbl,size,'r2_1',l_r2_1,k_r2_1))
c     1   call errquit('sym_2pdm_ao: ma problem',0,ma_err)
cc        (i,j,k,l)
c         call get_hash_block(d_r2,dbl_mb(k_r2_1),size,
c     1        int_mb(k_r2_offset),(lb-1)+(kb-1)*nshblocks
c     1        +(jb-1)*nshblocks*nshblocks
c     1        +(ib-1)*nshblocks*nshblocks*nshblocks)
cc
c         i=0
c         do i1 = 1, idim
c         do j1 = 1, jdim
c         do k1 = 1, kdim
c         do l1 = 1, ldim
c            i=i+1
c            write(6,'(a,4i5,a,f20.16)') 'sym checking 2PDM AO',
c     1               bfglo(ib)+i1-1, bfglo(jb)+j1-1,
c     1               bfglo(kb)+k1-1, bfglo(lb)+l1-1,'=',
c     1               dbl_mb(k_r2_1+i-1)
cc
c         enddo
c         enddo
c         enddo
c         enddo
c         if (.not.ma_pop_stack(l_r2_1))
c     1   call errquit('sym_2pdm_ao: MA problem',16,MA_ERR)
cc
c      enddo
c      enddo
c      enddo
c      enddo
cc
      return
      end
c $Id: sym_2pdm_ao.F 21176 2011-10-10 06:35:49Z d3y133 $

c
c $Id: read_line.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE read_lin(input,ifield,istart,inum_char,irecord,lend)

      implicit none

! This subroutine reads in an input line

      integer i,ifield,iswitch,input,irec_len,istart,inum_char

      character*1 irecord

      logical lcomm,lend

      parameter(irec_len=100)

      dimension istart(irec_len),inum_char(irec_len)
      dimension irecord(irec_len)

      ifield  = 0
      iswitch = 0
      lcomm   = .false.
      lend    = .false.

      read(input,20,end=100)(irecord(i),i=1,irec_len)
20    format(100A1)

      do i=1,irec_len
       if(irecord(i).eq.'#'.and.ifield.eq.0)lcomm = .true.
       if(irecord(i).eq.' ')then
        iswitch = 0
       elseif(iswitch.eq.0)then
        call chg_case(irecord(i))
        ifield = ifield + 1
        istart(ifield) = i
        inum_char(ifield) = 1
        iswitch = 1
       else
        call chg_case(irecord(i))
        inum_char(ifield) = inum_char(ifield) + 1
       endif
      enddo

      goto 200

100   continue

      lend = .true.

200   continue

      return

      END

      integer function argos_cafe_numcon(idb,ndb,ia)
c
      implicit none
c
      integer ia,ndb
      integer idb(ndb,4)
c
      integer i,number
c
      number=0
c
      do 1 i=1,ndb
      if(idb(i,3).eq.1.and.(idb(i,1).eq.ia.or.idb(i,2).eq.ia))
     + number=number+1
    1 continue
c
      argos_cafe_numcon=number
c
      return
      end
c $Id: argos_cafe_numcon.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function et_calc(rtdb,Vba)
      implicit none
#include "errquit.fh"
c
c     This function calculates Vba, the electron transfer matrix element.
*
* $Id: et_calc.F 19821 2010-12-14 07:46:49Z d3y133 $
c
*
#include "rtdb.fh"
#include "util.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "global.fh"
#include "apiP.fh"
#include "bas.fh"
#include "geom.fh"
#include "cscf.fh"
#include "stdio.fh"
c
      integer rtdb, me
      integer i, j, k
      integer l_vals,k_vals
      integer g_tmp,g_s,g_ahandle(2),g_bhandle(2),g_d,g_temp
      integer nocc(2)
      integer g_u,g_vt,g_phandle(2)
      integer g_av,g_bu,g_t,g_h1
      integer g_avecsa,g_avecsb,g_bvecsa,g_bvecsb
      integer mem2, max2e, lena, lenb
      integer method_2e, anmo(2), bnmo(2), nbf_file, nset

      logical et_movecs_read
      external et_movecs_read
      logical ga_copy
      external ga_copy
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
      logical movecs_read_header
      external movecs_read_header

      character*255 a_file, b_file, basis_name,
     E     a_filedir,b_filedir
      character*2 pname(2)

      double precision Vba
      double precision prod(2)
      double precision Sba,omega1
      double precision detu(2),detv(2),detprod,omega2
      double precision Haa,Hbb,Hba,val, dum
      data Haa,Hbb,Hba/3*0.0d0/

      me=ga_nodeid()

      if (me.eq.0) then
      Call Util_Print_Centered(LuOut,'Electron Transfer Calculation'
     &     ,40,.true.)
      write(LuOut,*)
      endif
c
c -------------
c for printing:
c -------------
c
      call util_print_push
      call util_print_rtdb_load(rtdb,"et")
c
c -------------------------------
c load geometry and symmetry info
c -------------------------------
c
      if (.not. geom_create(geom, 'geometry'))
     $     call errquit('et_calc: geom_create?', 0, GEOM_ERR)
      if (.not. geom_rtdb_load(rtdb, geom, 'geometry'))
     $     call errquit('et_calc: no geometry ', 0, RTDB_ERR)
c
c ----------------------------------------
c load the basis set and get info about it
c ----------------------------------------
c
      if (.not. bas_create(basis, 'ao basis'))
     $     call errquit('et_calc: bas_create?', 0, BASIS_ERR)
      if (.not. bas_rtdb_load(rtdb, geom, basis, 'ao basis'))
     $        call errquit('et_calc: no ao basis set', 0, RTDB_ERR)
c
c  -------
c  get nbf
c  -------
c
      if (.not.bas_numbf(basis,nbf))
     $     call errquit('bas_numbf failed',0, BASIS_ERR)
c
c ------------------
c initialize the API 
c ------------------
c
      call int_init(rtdb, 1, basis)
      call int_acc_std()
      call int_normalize(rtdb,basis)
c
c  -------------------------------
c  calculate the overlap integrals
c  -------------------------------
c
      if(.not.ga_create(mt_dbl,nbf,nbf,'s',0,0,g_s))
     $        call errquit('task_et ga_create failed', 0, GA_ERR)
      call ga_zero(g_s)
      call int_1e_ga(basis, basis, g_s, 'overlap', .false.)  

      if (util_print("et",print_debug)) then
       call ga_print(g_s)
      endif
c
c ---------------------------
c Read MO vectors from files
c ---------------------------
c
      if (.not. rtdb_cget(rtdb, 'a_vecs', 1, a_file))
     $     call errquit('et_calc: couldnt get a_vecs filename',0,
     &       RTDB_ERR)
c
      if (.not. rtdb_cget(rtdb, 'b_vecs', 1, b_file))
     $     call errquit('et_calc: couldnt get a_vecs filename',0,
     &       RTDB_ERR)
c
      lena = inp_strlen(a_file)
      lenb = inp_strlen(b_file)
c
      if (me.eq.0) then
      write(LuOut,*)'MO vectors for reactants: ',a_file(1:lena)
      write(LuOut,*)'MO vectors for products : ',b_file(1:lenb)
      write(LuOut,*)
      endif
c
c -----------------------------------------------------
c Allocate occupation and eigenvalue vectors. 
c 'occ' is used to calculate nocc, 'eval' is never used.
c ------------------------------------------------------
c
      if (.not.ma_push_get(mt_dbl,nbf,'occ',l_occ,k_occ))
     $         call errquit('ma_push_get failed for occ',k_occ, MA_ERR)

      if (.not.ma_push_get(mt_dbl,nbf,'evals',l_eval,k_eval))
     $        call errquit('ma_push_get failed for evals',k_eval,
     &       MA_ERR)
c
c ------------------------------------------------
c Read header to check that nset=2
c ------------------------------------------------
c
c a_file:
c -------
c
      call et_filename(a_file,a_filedir)
      if(.not.movecs_read_header(a_filedir(1:inp_strlen(a_filedir)),
     E     title,basis_name,
     &   scftype,nbf_file,nset,anmo,2)) 
     &   call errquit('et_calc: movecs_read_header failed',me, DISK_ERR)

      if (nset.ne.2) then
        call errquit('et_calc: only UHF/ODFT orbitals allowed',nset,
     &       INPUT_ERR)
      endif

      if (nbf_file.ne.nbf) then
        call errquit('et_calc: basis function mismatch',nbf_file,
     &       BASIS_ERR)
      endif

c b_file:
c -------
c
      call et_filename(b_file,b_filedir)
      if(.not.movecs_read_header(b_filedir(1:inp_strlen(b_filedir)),
     E     title,basis_name,
     &   scftype,nbf_file,nset,bnmo,2)) 
     &   call errquit('et_calc: movecs_read_header failed',me, DISK_ERR)

      if (nset.ne.2) then
        call errquit('et_calc: only UHF/ODFT orbitals allowed',nset,
     &       INPUT_ERR)
      endif

      if (nbf_file.ne.nbf) then
        call errquit('et_calc: basis function mismatch',nbf_file,
     &       BASIS_ERR)
      endif
c
c -------------------------------------------------------
c allocate arrays for MO coefficients, for state A
c -------------------------------------------------------
c
      if (.not.ga_create(mt_dbl,nbf,nbf,'A alpha',0,0,g_avecsa))
     $         call errquit('ga_create failed for A alpha',g_avecsa,
     &       GA_ERR)

      if (.not.ga_create(mt_dbl,nbf,nbf,'A beta',0,0,g_avecsb))
     $         call errquit('ga_create failed for A beta',g_avecsb,
     &       GA_ERR)

      call ga_zero (g_avecsa)
      call ga_zero (g_avecsb)
c 
c ------------------------------------------------------------------
c read occ, evals, mo coefficients for alpha orbitals from a_file
c ------------------------------------------------------------------
c
      if(.not.et_movecs_read(a_filedir(1:inp_strlen(a_filedir)),
     A     1,dbl_mb(k_occ)
     $   ,dbl_mb(k_eval),g_avecsa,dum))
     $ call errquit('et_movecs_read failed for alpha mos',0, DISK_ERR)
c
c -------------------------------------
c get nocc(1): # of occupied alpha mo's
c -------------------------------------
c
      nocc(1)=0
      do i = 1,nbf
       nocc(1) = nocc(1) + dbl_mb(k_occ+i-1)
      enddo

      if (util_print("et",print_high)) then
      if(me.eq.0) then
        write(LuOut,*) nocc(1), " occupied alpha orbitals"
        write(LuOut,*)
      endif
        call ga_print(g_avecsa)
      endif
c
c ------------------------------------------------------------------
c read occ, evals, mo coefficients for beta orbitals from a_file
c ------------------------------------------------------------------
c
      if(.not.et_movecs_read(a_filedir(1:inp_strlen(a_filedir)),
     E     2,dbl_mb(k_occ)
     $     ,dbl_mb(k_eval),g_avecsb, dum))
     $ call errquit('et_movecs_read failed for beta mos',0, DISK_ERR)
c
c -------------------------------------
c get nocc(2): # of occupied alpha mo's
c -------------------------------------
c
      nocc(2)=0
      do i = 1,nbf
       nocc(2) = nocc(2) + dbl_mb(k_occ+i-1)
      enddo

      if (util_print("et",print_high)) then
      if(me.eq.0) then
        write(LuOut,*) nocc(2), " occupied  beta orbitals"
        write(LuOut,*)
      endif
        call ga_print(g_avecsb)
      endif
c
c -------------------------------------------------------
c allocate arrays for MO coefficients, for state B
c -------------------------------------------------------
c
      if (.not.ga_create(mt_dbl,nbf,nbf,'B alpha',0,0,g_bvecsa))
     $         call errquit('ga_create failed for B alpha',g_bvecsa,
     &       GA_ERR)

      if (.not.ga_create(mt_dbl,nbf,nbf,'B beta',0,0,g_bvecsb))
     $         call errquit('ga_create failed for B beta',g_bvecsb,
     &       GA_ERR)

      call ga_zero (g_bvecsa)
      call ga_zero (g_bvecsb)
c
c -----------------------------------------------------------
c read occ, evals, mo coefficients from b_file.  It is 
c assumed that the number of occupied alpha and beta orbitals
c is the same as in the a_file.
c -----------------------------------------------------------
c
      if(.not.et_movecs_read(b_filedir(1:inp_strlen(b_filedir)),
     E     1,dbl_mb(k_occ)
     $   ,dbl_mb(k_eval) ,g_bvecsa, dum))
     $   call errquit('et_movecs_read failed for alpha mos',0, DISK_ERR)
c
      if(.not.et_movecs_read(b_filedir(1:inp_strlen(b_filedir)),
     E     2,dbl_mb(k_occ)
     $  ,dbl_mb(k_eval) ,g_bvecsb, dum))
     $   call errquit('et_movecs_read failed for beta mos',0, DISK_ERR)
c
      if (util_print("et",print_high)) then
       call ga_print(g_bvecsa)
       call ga_print(g_bvecsb)
      endif
c
c --------------------------------------------------
c Read converged scf or dft energy from movecs file.
c --------------------------------------------------
c
      if(.not.et_movecs_read(a_filedir(1:inp_strlen(a_filedir)),3
     $   ,dbl_mb(k_occ),dbl_mb(k_eval),1, Haa)) 
     $   call errquit('et_movecs_read failed for Haa',0, DISK_ERR)
c
      if(.not.et_movecs_read(b_filedir(1:inp_strlen(b_filedir)),3
     $   ,dbl_mb(k_occ),dbl_mb(k_eval),1, Hbb)) 
     $   call errquit('et_movecs_read failed for Hbb',0, DISK_ERR)
c
      if (me.eq.0) then
      write(LuOut,9995) 'Electronic energy of reactants   ','H(RR)',Haa
      write(LuOut,9995) 'Electronic energy of products    ','H(PP)',Hbb
      endif
c
c -----------------------------------------------
c calculate D=B'*S*A for alpha and beta electrons
c -----------------------------------------------
c
      g_ahandle(1)=g_avecsa
      g_ahandle(2)=g_avecsb
      g_bhandle(1)=g_bvecsa
      g_bhandle(2)=g_bvecsb
c
c
c detprod is the product of det(U)*det(V) for alpha and beta electrons,
c and is used later.
c ----------------------------------------------------------------------
c
      detprod=1.0d0
c
c -----------------------------------------------------
c  pname is needed for generalized density matrices:
c  Pa is for alpha electrons, Pb is for beta electrons.
c -----------------------------------------------------
c
      pname(1)='pa'
      pname(2)='pb'
c
c ------------------------
c begin alpha/beta loop j
c ------------------------
c
      do j = 1,2 
c
      if (util_print("et",print_high)) then
      if(me.eq.0) then
       write(LuOut,*) 
       write(LuOut,*) '---------------'
       if(j.eq.1) write(LuOut,*) 'ALPHA ELECTRONS'
       if(j.eq.2) write(LuOut,*) ' BETA ELECTRONS'
       write(LuOut,*) '---------------'
      endif
      endif
c
c  -----------------------------------------------
c  Perform matrix multiplication to get D = B'*S*A
c  -----------------------------------------------
c
      call ga_sync()
c
      if(.not.ga_create(mt_dbl,nocc(j),nocc(j),'d',0,0,g_d))
     $        call errquit('task_et ga_create failed', g_d, GA_ERR)
c
      if(.not.ga_create(mt_dbl,nbf,nbf,'temp',0,0,g_tmp))
     $        call errquit('task_et ga_create failed', g_d, GA_ERR)
c
      call ga_dgemm('T','N',nocc(j),nbf,nbf,1.d0,g_bhandle(j)
     &               ,g_s,0.d0,g_tmp)
c
      call ga_dgemm('N','N',nocc(j),nocc(j),nbf,1.d0,g_tmp
     &               ,g_ahandle(j),0.d0,g_d)
c
      if (.not.ga_destroy(g_tmp))
     &  call errquit('could not destroy tmp array',g_tmp, GA_ERR)
c
      if (util_print("et",print_debug)) then
       call ga_print(g_d)
      endif
c
c ----------------------------------------------
c Perform SVD to get U, V', and singluar values
c ----------------------------------------------
c
      if(.not.ga_create(mt_dbl,nocc(j),nocc(j),'u',0,0,g_u))
     $        call errquit('task_et ga_create failed', g_u, GA_ERR)
c
      if(.not.ga_create(mt_dbl,nocc(j),nocc(j),'vt',0,0,g_vt))
     $        call errquit('task_et ga_create failed', g_vt, GA_ERR)
c
      call ga_zero(g_u)
      call ga_zero(g_vt)
      if (.not.ma_push_get(mt_dbl,nocc(j),'values',l_vals,k_vals))
     $        call errquit('ma_push_get failed for values ',k_vals,
     &       MA_ERR)
c
      call ga_svd_seq(g_d,g_u,g_vt,dbl_mb(k_vals))
c
c prod is the product of singular values.
c ---------------------------------------
c
      prod(j) = 1.0d0
      do k = 1,nocc(j)
         prod(j) = prod(j)*dbl_mb(k_vals+k-1)
      enddo
c      write(LuOut,*)'prod',j,prod(j)
c      write(LuOut,*)'singular values',(dbl_mb(k_vals+i-1),i=1,nocc(j))
c
c
      if (.not.ga_destroy(g_d))
     &  call errquit('could not destroy D array',g_d, GA_ERR)
c
      if (util_print("et",print_debug)) then
      call ga_print(g_u)
      call ga_print(g_vt)
      endif
c
c
c --------------------------
c calculate det(U) and det(V)
c --------------------------
c
       call et_det('N',g_u,nocc(j),detu(j))
       call et_det('T',g_vt,nocc(j),detv(j))
       detprod = detprod*detu(j)*detv(j)
c       write(LuOut,*) j,'detu,detv',detu(j),detv(j)
c
c ------------------------------------------------------------
c                                               ^       ^
c perform matrix mult to get transformed A & B: A = AV, B = BU
c ------------------------------------------------------------
c
      if(.not.ga_create(mt_dbl,nbf,nocc(j),'av',0,0,g_av))
     $        call errquit('task_et ga_create failed', g_av, GA_ERR)
c
      if(.not.ga_create(mt_dbl,nbf,nocc(j),'bu',0,0,g_bu))
     $        call errquit('task_et ga_create failed', g_bu, GA_ERR)
c
      call ga_zero(g_av)
      call ga_dgemm('N','T',nbf,nocc(j),nocc(j),1.d0,g_ahandle(j),g_vt
     &         ,0.d0,g_av)
c
      call ga_zero(g_bu)
      call ga_dgemm('N','N',nbf,nocc(j),nocc(j),1.d0,g_bhandle(j),g_u
     &         ,0.d0,g_bu)
c
c
      if (.not.ga_destroy(g_ahandle(j))) 
     &  call errquit('could not destroy mo vectors array',g_ahandle(j),
     &       GA_ERR)
      if (.not.ga_destroy(g_bhandle(j))) 
     &  call errquit('could not destroy mo vectors array',g_bhandle(j),
     &       GA_ERR)
c
      if (.not.ga_destroy(g_u))
     &  call errquit('could not destroy U array',g_u,
     &       GA_ERR)
      if (.not.ga_destroy(g_vt))
     &  call errquit('could not destroy VT array',g_vt,
     &       GA_ERR)
c
      if (util_print("et",print_high)) then
      if(me.eq.0) then
        write(LuOut,*) 
        write(LuOut,*) 'SVD transformed MO vectors for state A'
      endif
        call ga_print (g_av)
      if(me.eq.0) then
        write(LuOut,*) 
        write(LuOut,*) 'SVD transformed MO vectors for state B'
      endif
        call ga_print (g_bu)
      endif
c
c
c    --------------------------------------------------------------
c                                   N
c                                -------
c     Calculates   T(i) =     PRODUCT  d(j) where N = nalpha or nbeta
c                                -------
c                                j.NE.i  
c    --------------------------------------------------------------
c    
      if(.not.ga_create(mt_dbl,nocc(j),nocc(j),'t',0,0,g_t))
     $        call errquit('task_et ga_create failed', g_t, GA_ERR)
      call ga_zero(g_t)
c
      if(nocc(j).gt.1) then
c
        do i = 1,nocc(j)
          val = 1.0d0
            do k = 1,nocc(j)
              if(k.ne.i) val = val * dbl_mb(k_vals+k-1)
            enddo
          call ga_put(g_t,i,i,i,i,val,1)
        enddo
      else
         val = 1.0d0
         call ga_put(g_t,1,1,1,1,val,1)
c
      endif
      call ga_sync()
c
      if (util_print("et",print_debug)) then
      call ga_print(g_t) 
      endif
c
c -----------------------------------------------------
c                                            ^ ^
c  calculate generalized density matrix, P = ATB'
c  Pa is for alpha electrons, Pb is for beta electrons.
c -----------------------------------------------------
c
      if(.not.ga_create(mt_dbl,nbf,nbf,pname(j),0,0,g_phandle(j)))
     $        call errquit('task_et ga_create failed', g_phandle(j),
     &       GA_ERR)
c
      if(.not.ga_create(mt_dbl,nbf,nocc(j),'temp',0,0,g_temp))
     $        call errquit('task_et ga_create failed', g_temp, GA_ERR)
c
      call ga_zero(g_phandle(j))
c
      call ga_dgemm('N','N',nbf,nocc(j),nocc(j),1.d0,g_av,g_t
     &         ,0.d0,g_temp)
c
      call ga_dgemm('N','T',nbf,nbf,nocc(j),1.0d0,g_temp,g_bu
     &         ,0.0d0,g_phandle(j))
c
c
      if (.not.ga_destroy(g_av)) 
     &  call errquit('could not destroy transformed MO vectors',g_av,
     &       GA_ERR)
      if (.not.ga_destroy(g_bu)) 
     &  call errquit('could not destroy transformed MO vectors',g_bu,
     &       GA_ERR)
c
      if (.not.ga_destroy(g_t)) 
     &  call errquit('could not destroy T array',g_t, GA_ERR)
      if (.not.ga_destroy(g_temp)) 
     &  call errquit('could not destroy temp array',g_temp, GA_ERR)
c
c
      if (util_print("et",print_debug)) then
      call ga_print(g_phandle(j))
      endif
c
c
c --------------------
c end alpha/beta loop:
c --------------------
      enddo    
c
      if (.not.ga_destroy(g_s)) 
     &  call errquit('could not destroy overlap array',g_s, GA_ERR)

c
c Pa is scaled by prod(b), Pb is scaled by prod(a)
c ------------------------------------------------
c
       call ga_dscal(g_phandle(1),prod(2))
       call ga_dscal(g_phandle(2),prod(1))

      if (util_print("et",print_debug)) then
      if(me.eq.0) then
       write(LuOut,*) 
       write(LuOut,*) 'scaled generalized density matrices:' 
       write(LuOut,*) 
      endif
       call ga_print(g_phandle(1))
       call ga_print(g_phandle(2))
      endif
c
c
c -----------------------------------------
c calculate overlap of state A with state B
c -----------------------------------------
c
       Sba = prod(1)*prod(2)*detprod
c
c
      if(me.eq.0) then
       write(LuOut,*)
       write(LuOut,9997) Sba
       write(LuOut,*)
      endif
c
 9997 format(1x,'Reactants/Products overlap S(RP) : ',1Pd9.2)
c
c --------------------------------------------
c calculate the 1e contribution to Vba, omega1
c --------------------------------------------
c
      if(.not.ga_create(mt_dbl,nbf,nbf,'h1',0,0,g_h1))
     $        call errquit('task_et ga_create failed', g_h1, GA_ERR)
c
c get H1 integrals
c ----------------
c
      call ga_zero(g_h1)
      call int_1e_ga(basis, basis, g_h1, 'kinetic', .false.)  
      call int_1e_ga(basis, basis, g_h1, 'potential', .false.)  
c
      if (util_print("et",print_debug)) then
          call ga_print(g_h1)
      endif
c
       omega1 = 0.0d0
       omega1 = omega1 + ga_ddot (g_h1,g_phandle(1))
       omega1 = omega1 + ga_ddot (g_h1,g_phandle(2))
c
       call ga_sync()
       omega1 = omega1*detprod
c
      if(me.eq.0) then
       write(LuOut,*) 'Reactants/Products interaction energy:    '
       write(LuOut,*) '-------------------------------------           '
       write(LuOut,9995) 'One-electron contribution        ','H1(RP)',
     &    omega1
      endif
c
      if (.not.ga_destroy(g_h1))
     &  call errquit('could not destroy H1 array',g_h1, GA_ERR)
c
c --------------------------------------------
c calculate the 2e contribution to Vba, omega2
c --------------------------------------------
c
      if (.not. rtdb_get(rtdb, 'et:tol2e', MT_DBL, 1, tol2e)) then
       tol2e    =  min(1.0d-7,dabs(Sba)*1.0d-7)
       tol2e    =  max(1.0d-12,tol2e)
      endif

c ------------------------------------------------------------------------
c Two methods are available. One uses the scf fock builder (method_2e=1),
c the other uses et_2e (method_2e=2). et_2e is more accurate, but much more
c time consuming and should only be used for very small systems, or very 
c weakly interacting systems (with small overlap), or for debugging purposes.
c ------------------------------------------------------------------------
c
      if (.not.rtdb_get(rtdb,'et:method_2e',MT_INT,1,method_2e)) then
          method_2e = 1
      endif
c
      if (method_2e.EQ.1) then
c for some unknown reason I have to terminate and re-init the API for
c et_fock to work with ECP's
      call int_terminate()
      call et_fock(rtdb,geom,basis,
     &  g_phandle(1),g_phandle(2),nbf,tol2e,omega2)
      endif
c
      if (method_2e.EQ.2) then
       call int_mem_2e4c(mem2,max2e)
       mem2 = max(mem2,max2e)
       call et_2e(rtdb,nbf,basis,geom,max2e,mem2,tol2e,
     &           g_phandle(1),g_phandle(2),omega2)
      endif
c
c ----------------------------------------------------
c destroy density arrays and calculate omega2 and Hba
c ----------------------------------------------------
c
      if (.not.ga_destroy(g_phandle(1)))
     &  call errquit('could not destroy P array',g_phandle(1), GA_ERR)
      if (.not.ga_destroy(g_phandle(2)))
     &  call errquit('could not destroy P array',g_phandle(2), GA_ERR)
c
       omega2 = omega2 * (detprod/ ( prod(1)*prod(2) ) ) 
       omega2 = omega2 / 2.0d0
c
       Hba = omega1+omega2
c
      if(me.eq.0) then
       write(LuOut,9995) 'Two-electron contribution        ','H2(RP)',
     &    omega2
       write(LuOut,9995) 'Total interaction energy         ','H(RP)',
     &    Hba
       write(LuOut,*)
      endif
c
c
c ---------------------------------------------
c Finally, calculate the ET matrix element, Vba
c ---------------------------------------------
c
c
       Vba =  Hba - Sba*(Haa+Hbb)*0.5d0
       Vba = Vba/(1.0d0-Sba*Sba)
       Vba = dabs (Vba)
c
       if (.not. rtdb_put(rtdb,'et:V(RP)', MT_DBL, 1, Vba))
     $        call errquit('et_calc: rtdb_put of V(RP) failed',0,
     &       RTDB_ERR)
c
c
c -------------
c Print results
c -------------
c
      if(me.eq.0) then
      write(LuOut,9996) Vba,Vba*2.194746d5,
     &              Vba*27.2114d0,Vba*627.510d0
      write(LuOut,*) 
      endif
c
 9995 format (a34,1x,a6,1x,F18.10)
 9996 format( 1x,'Electron Transfer Coupling Energy |V(RP)|',F18.10,/, 
     &  49x,F11.3,' cm-1',/,
     &  49x,F11.6,' eV',/,
     &  49x,F11.3,' kcal/mol')
c


      if (.not.ma_chop_stack(l_vals)) 
     &    call errquit('unable to destroy MA',l_vals, MA_ERR)
      if (.not.ma_chop_stack(l_eval)) 
     &    call errquit('unable to destroy MA',l_eval, MA_ERR)
      if (.not.ma_chop_stack(l_occ)) 
     &    call errquit('unable to destroy MA',l_occ, MA_ERR)
c
c
      et_calc=.true.
c
      call util_print_pop
c
         if (.not. geom_destroy(geom)) call errquit
     $        ('et_calc: geom destroy failed', 0, GEOM_ERR)
         if (.not. bas_destroy(basis)) call errquit
     $        ('et_calc: basis destroy failed',0, BASIS_ERR)
c
      call int_terminate()
c
c
      return
      end
      subroutine et_filename(file,dirfile)
      implicit none
#include "inp.fh"
#include "global.fh"
      character*(*) file,dirfile
c
      character*255 dirss
      integer lenn0,lenn1,i
c

      call util_directory_name(dirss, .false., ga_nodeid())
      dirfile(1:inp_strlen(dirss))=dirss(1:inp_strlen(dirss))
      dirfile(inp_strlen(dirss)+1:inp_strlen(dirss)+1)='/'
      lenn0=inp_strlen(dirss)+2
      lenn1=inp_strlen(dirss)+inp_strlen(file)+1
      dirfile(lenn0:lenn1)=file(1:inp_strlen(file))
      do i=lenn1+1,255
      dirfile(i:i)=' '
      enddo
      
      return
      end

      subroutine util_flush(unit)
C$Id: util_flush.F 24670 2013-10-18 18:59:34Z d3y133 $
      implicit none
#include "stdio.fh"
      integer unit
#ifdef CRAY
      integer*4 iunit4
#endif
c
c     Flush buffered output for the fortran unit
c
#if defined(SUN)      || defined(KSR)    || defined(PARAGON) || \
    defined(SOLARIS)  || \
    defined(IBM)||defined(LINUX)||defined(MACX)
      call flush(unit)
#endif
#ifdef CRAY
      iunit4=unit
      call flush(iunit4)
#endif
#if defined(PSCALE)
      call util_cflush()
#endif
#if defined(SGI)
      if (unit.eq.luout) then
        call sgi_flush6()
      else
        call flush(unit)
      endif
#endif
#if defined(IPSC) || defined(DELTA)
      call forflush(unit)
#endif
#if defined(GFORTRAN)
      call flush(unit)
#endif
      call util_cflush()
c
      end

      subroutine argos_diana_listdist(sgmnam,last)
c
      implicit none
c
#include "argos_diana_common.fh"
c
      integer last
      character*16 sgmnam(msa)
      integer i,j
c
      if(me.eq.0) then
      do 5 i=last,ndist
      write(cdist(i),1000) i,idist(i,1,3),(sgmnam(idist(i,j,1))(11:16),
     + ':',sgmnam(idist(i,j,1))(1:10),j=1,2)
 1000 format(2i4,4(a6,a,a10))
    5 continue
      endif
c
      return
      end
c $Id: argos_diana_listdist.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine rohf_k2cf(basis, nbf, nmo, nclosed, nopen,
     $                     g_kvec, g_vecs, g_result)
C     $Id: rohf_k2cf.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "cscfps.fh"
c     
c     Transform mo-coeffs from k-vector using exp(K)
c     
c     Arguments
c
      integer nbf, basis, nmo, nclosed, nopen
      integer g_kvec, g_vecs, g_result
c     
      integer g_temp
      double precision one, zero
      parameter (one=1.0d0, zero=0.0d0)
c     
      if (oscfps) call pstat_on(ps_k2cf)
c
      if (.not. ga_create(MT_DBL, nmo, nmo, 'k2cf: temp',
     $     32, 32, g_temp)) call errquit('rohf_k2cf: GA temp',0, GA_ERR)
      call rohf_k2u( basis, nbf, nmo, nclosed, nopen,
     $               g_kvec, g_temp )
c
c     Transform MO's
c     
      call ga_dgemm('n', 'n', nbf, nmo, nmo, one, g_vecs,
     $               g_temp, zero, g_result)
c
      if (.not.ga_destroy(g_temp))
     $     call errquit('rohf_k2cf: cannot destroy temp',0, GA_ERR)
c
*      call ga_orthog_mos(basis, g_result)
c
      if (oscfps) call pstat_off(ps_k2cf)
c
      end
      subroutine rohf_k2u( basis, nbf, nmo, nclosed, nopen,
     $                     g_kvec, g_u )
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
c
c  
c  Generate U = exp(K)
c  K is the antisymmetric matrix form of k
c
c     
c     Arguments
c
      integer nbf, basis, nmo, nclosed, nopen
      integer g_kvec, g_u
c     
      integer nvir
      integer i,l_tmp,k_tmp,iioff,ivoff,nnnodes
      integer tmp_siz
      double precision one, mone, zero
      parameter (one=1.0d0, mone=-1.0d0, zero=0.0d0)
      double precision kmax
c     
      call ga_sync()
      nnnodes = ga_nnodes()
c     
c     Form K-matrix from vector
c     
      nvir = nmo - nclosed - nopen
      ivoff = nclosed + nopen + 1
      tmp_siz =  max(nvir,nopen)
c
c
      if (.not. ma_push_get(MT_DBL,tmp_siz,'temp k',l_tmp,k_tmp))
     $     call errquit('k2cf: ma failed on tmp',tmp_siz, MA_ERR)
c
      call ga_zero(g_u)
      if (nvir .gt. 0) then
         do i=ga_nodeid()+1,nclosed+nopen,nnnodes
            iioff = (i-1)*nvir
            call ga_get(g_kvec,iioff+1,iioff+nvir,1,1,
     $           dbl_mb(k_tmp),nvir)
            call ga_put(g_u,ivoff,nmo,i,i,dbl_mb(k_tmp),nvir)
            call dscal(nvir,mone,dbl_mb(k_tmp),1)
            call ga_put(g_u,i,i,ivoff,nmo,dbl_mb(k_tmp),1)
         enddo
      endif
      if (nopen .gt. 0) then
         do i=ga_nodeid()+1,nclosed,nnnodes
            iioff = (nclosed+nopen)*nvir + (i-1)*nopen
            call ga_get(g_kvec,iioff+1,iioff+nopen,1,1,
     $           dbl_mb(k_tmp),nopen)
            call ga_put(g_u,(nclosed+1),(nclosed+nopen),i,i,
     $           dbl_mb(k_tmp),nopen)
            call dscal(nopen,mone,dbl_mb(k_tmp),1)
            call ga_put(g_u,i,i,(nclosed+1),(nclosed+nopen),
     $           dbl_mb(k_tmp),1)
         enddo
      endif
      if (.not. ma_pop_stack(l_tmp))
     $     call errquit('k2cf: pop failed', 0, MA_ERR)
c
c     Make near zeoes exactly zero so that sparsity tests in the
c     matrix multiply work well ... we only need to maintain
c     quadratic convergence.
c     Cannot screen with a large number (greater than accuracy in integrals) 
c     since in a non-abelian group we could break symmetry ... either
c     screen with a small threshold or screen with a large one and then
c     enforce symmetry (which is expensive in high order groups).
c     Also, screening must tend to zero for high convergence
c
      call ga_maxelt(g_u, kmax)
      kmax = min(kmax*1d-2,kmax*kmax,1d-12)
      call ga_screen(g_u, kmax)
c     
c     Get a unitary 2nd order approximation to exp(K)
c     
      call matrix_exp(g_u )
      end

c===============================================================c
c                                                               c
c       Socrates - an NWChem module for teaching                c
c       Copyright © 2009 Jeff Hammond                           c
c                                                               c
c       Developed by:                                           c
c                                                               c
c               Jeff R. Hammond                                 c
c               Leadership Computing Facility                   c
c               Argonne National Laboratory                     c
c               jhammond@mcs.anl.gov                            c
c                                                               c
c===============================================================c
      logical function socrates_input(rtdb)
c
c $Id: socrates_input.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
#include "inp.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
#include "errquit.fh"
#include "stdio.fh"
#include "global.fh"
c
      integer rtdb
      integer itemp
      integer scf_alg
      integer nopen
c
      double precision dtemp
      double precision tol2e
      double precision int_thresh
c
      character*20 test
      character*20 ctemp
c
      logical debug
      logical nodezero
      logical ltemp
c
#ifdef DEBUG_PRINT
      debug = (GA_NodeId().eq.0) ! debug print on nodezero only
c      debug = .true. ! debug print everywhere
#else
      parameter debug = .false.
#endif
      if (debug) write(LuOut,*) 'top of socrates_input'
c
      nodezero = (GA_NodeId().eq.0) 
c
      socrates_input = .false.
c
c ----------
c Read input
c ----------
c
c
 10   if (.not. inp_read()) then
        call errquit(__FILE__,__LINE__,INPUT_ERR)
      endif
      if (.not. inp_a(test)) then
        call errquit(__FILE__,__LINE__,INPUT_ERR)
      endif
c
c     PRINT
c
      if (inp_compare(.false.,test,'print')) then
        if (debug) write(LuOut,100) 'print'
        call util_print_input(rtdb,'socrates')
c
c     SCF_ALG
c
      elseif (inp_compare(.false.,test,'scf_alg')) then
        if (debug) write(LuOut,100) 'scf_alg'
        if (.not.inp_i(scf_alg)) then
           if (nodezero) write(LuOut,*) 'usage: scf_alg <int>'
           call errquit(__FILE__,__LINE__,INPUT_ERR)
        endif
        if (.not.rtdb_put(rtdb,'socrates:scf_alg',mt_int,1,
     1                    scf_alg)) then
           call errquit(__FILE__,__LINE__,RTDB_ERR)
        endif
c
c     NOPEN
c
      elseif (inp_compare(.false.,test,'nopen')) then
        if (debug) write(LuOut,100) 'nopen'
        if (.not.inp_i(nopen)) then
           if (nodezero) write(LuOut,*) 'usage: nopen <int>'
           call errquit(__FILE__,__LINE__,INPUT_ERR)
        endif
        if (.not.rtdb_put(rtdb,'socrates:nopen',mt_int,1,
     1                    nopen)) then
           call errquit(__FILE__,__LINE__,RTDB_ERR)
        endif
c
c     INT_THRESH
c
      elseif (inp_compare(.false.,test,'int_thresh')) then
        if (debug) write(LuOut,100) 'int_thresh'
        if (.not.inp_f(int_thresh)) then
           if (nodezero) write(LuOut,*) 'usage: int_thresh <float>'
           call errquit(__FILE__,__LINE__,INPUT_ERR)
        endif
        if (.not.rtdb_put(rtdb,'socrates:int_thresh',mt_dbl,1,
     1                    int_thresh)) then
           call errquit(__FILE__,__LINE__,RTDB_ERR)
        endif
c
c     TOL2E
c
      elseif (inp_compare(.false.,test,'tol2e')) then
        if (debug) write(LuOut,100) 'tol2e'
        if (.not.inp_f(tol2e)) then
           if (nodezero) write(LuOut,*) 'usage: tol2e <float>'
           call errquit(__FILE__,__LINE__,INPUT_ERR)
        endif
        if (.not.rtdb_put(rtdb,'socrates:tol2e',mt_dbl,1,tol2e)) then
           call errquit(__FILE__,__LINE__,RTDB_ERR)
        endif
c
c     END
c
      else if (inp_compare(.false.,test,'end')) then
        goto 20
      else
        call errquit(__FILE__,__LINE__,INPUT_ERR)
      endif
      goto 10
c
c ------
c Return
c ------
c
 20   continue
c
      socrates_input = .true.
c
      if (debug) write(LuOut,*) 'end of socrates_input'
c
      return
c
 100  format(8x,'keyword found:         ',a20)
 150  format(8x,'using value:           ',i20)
 160  format(8x,'using value:           ',f20.8)
 170  format(8x,'using value:           ',a20)
 200  format(8x,'value not found for:   ',a20,/,
     &          'using default value of ',i20)
c
      end

      subroutine gatoeaf(d_sf)
c
c $Id: gatoeaf.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Unload data from GA to EAF
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "eaf.fh"
#include "dra.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_sf
      integer d_temp
      integer i
      integer size
      logical nodezero
      integer nblocks
      integer blocksize
      integer l_temp, k_temp
c
      nodezero = (ga_nodeid().eq.0)
      if (ioalg.eq.6) then
        if (.not.fileisga(d_sf))
     1    call errquit('gatoeaf: no GA found',0,UNKNOWN_ERR)
        call ga_sync()
        size = filesizes(d_sf)
        if (eaf_open(filenames(d_sf), EAF_RW, d_temp).ne.0)
     1    call errquit('gatoeaf: eaf problem',0,DISK_ERR)
        nblocks = size/buffer_size
        if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
        blocksize = size/nblocks
        if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
        if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1    l_temp,k_temp))
     2    call errquit('gatoeaf: MA problem',0,MA_ERR)
        do i = 1,nblocks
          call ga_get(filehandles(d_sf),(i-1)*blocksize+1,
     1      min(size,i*blocksize),1,1,dbl_mb(k_temp),1)
          if (eaf_write(d_temp,dfloat(bytes)*dfloat((i-1)*blocksize),
     1      dbl_mb(k_temp),
     2      bytes*(min(size,i*blocksize)-(i-1)*blocksize)).ne.0)
     3      call errquit('gatoeaf: eaf problem',7,DISK_ERR)
        enddo
        if (.not.ma_pop_stack(l_temp))
     1    call errquit('gatoeaf: MA problem',1,MA_ERR)
        if (.not.ga_destroy(filehandles(d_sf)))
     1    call errquit('gatoeaf: GA problem',0,GA_ERR)
        filehandles(d_sf) = d_temp
        fileisga(d_sf) = .false.
        call ga_sync()
      endif
      return
      end

      subroutine ccsd_mkt2(ncor,nocc,nvir,nact,eorb,
     $                     t2,scra,g_nexch,g_t2,iprt)
C     $Id: ccsd_mkt2.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
      integer ncor,nocc,nvir,nact,iprt,g_t2,g_nexch
      double precision eorb(*),t2(*),scra(*)
c
      integer iam
c
      integer jlo,jhi,ilo,ihi
      integer a,b,i,j,lhoov,ad1,ad2,lhoo
C
#include "ccsd_len.fh"
#include "global.fh"
#include "tcgmsg.fh"
C
      IAm = GA_NodeID()

      if (iprt.gt.5)print *,' making starting t2 '
c
      lhoo=nocc*(nocc+1)/2
      lhoov=nvir*nocc*(nocc+1)/2
c
      call ga_sync
      call ga_distribution(g_t2,iam,jlo,jhi,ilo,ihi)
      do a=1,nvir
        if (a.ge.ilo.and.a.le.ihi)then
          do i=1,nocc
            ad1=(i-1)*nact+nocc+a
            call ga_get(g_nexch,1,nocc*nact,ad1,ad1,t2,nocc*nact)
            do j=1,i
            do b=1,nvir
              ad1=(b-1)*lhoo+i*(i-1)/2+j
              ad2=(j-1)*nact+nocc+b
              scra(ad1)=t2(ad2)/(eorb(ncor+i)+eorb(ncor+j)
     &                          -eorb(ncor+nocc+a)-eorb(ncor+nocc+b))
            enddo
            enddo
          enddo
          if (iprt.gt.50)then
           print *,'t2 start ',a
           write(*,435)(scra(i),i=1,lhoov)
 435       format(4e15.5)
          endif
          call ga_put(g_t2,1,lhoov,a,a,scra,lhoov)
        endif
      enddo
      call ga_sync
c
      return
      end

      subroutine sym_bas_irreps(basis, oprint, nbf_per_ir)
C$Id: sym_bs_irrep.F 25068 2014-01-03 07:48:53Z d3y133 $
      implicit none
#include "errquit.fh"
#include "bas.fh"
#include "geom.fh"
#include "sym.fh"
#include "mafdecls.fh"
#include "util.fh"
      integer basis             ! [input] basis handle
      logical oprint            ! [input]
      integer nbf_per_ir(*)     ! [output] 
c     
c     Return the number of functions per irreducible representation
c     that are present in the specified basis set
c     
      integer geom
      integer icent, jcent, ncent
      integer nir
c     
      integer ang_max
      integer maxf, maxr
      integer l_r, k_r
      integer ishlo, ishhi, ilo, ihi, ish, nbf
      integer class, op, ir, itrace, i
      double precision trace
c     
      integer maxireps, maxops
      parameter (maxireps = 20, maxops=120)
      double precision c(maxireps)
c     
      integer op_class_index(maxops)
c     
      integer nop,  iclass_dim(maxireps)
      character*8 zir(maxireps), zclass(maxireps), group_name
      double precision chars(maxireps*maxireps)
c
      integer itype, nprim, ngen, sphcart, n, irrep_dim
      logical do_spherical
c
      double precision sym_trace_bas_op
      external sym_trace_bas_op
c
c     Get basis and geom info
c     
      if (.not. bas_geom(basis, geom)) call errquit
     $     ('sym_bas_irreps: no geometry from basis?', basis, BASIS_ERR)
      if (.not. bas_numbf(basis, nbf)) call errquit
     $     ('sym_bas_irreps: bas_numbf?', basis, BASIS_ERR)
      if (.not. bas_high_angular(basis, ang_max))
     $     call errquit('sym_bas_irreps: bas_high_angular', basis,
     &       BASIS_ERR)
      maxf = ((ang_max+1)*(ang_max+2))/2 ! Size of largest cart. shell
      maxr = (ang_max+1)*maxf*maxf ! Size of transformation matrices
      do_spherical = bas_is_spherical(basis)
c     
      if (.not. ma_push_get(MT_DBL, maxr, 'r', l_r, k_r))
     $     call errquit('sym_bas_irreps: ma failed', maxr, MA_ERR)
c
      if (.not. geom_ncent(geom, ncent)) call errquit
     $     ('sym_bas_irreps: geom_ncent ?', geom, GEOM_ERR)
c     
c     Get character table information and class mapping
c     
      call sym_group_name(geom,group_name)
      if (.not. sym_char_table(group_name, nop, nir, iclass_dim,
     $     zir, zclass, chars)) 
     $     call errquit('sym_bas_irreps: no char table',0, GEOM_ERR)
      call sym_op_classify(geom, op_class_index)
c
      call dfill(nir, 0.0d0, c, 1)
      c(1) = nbf                ! Have to do indentity manually
c
c     Loop thru operations and get the representation matrices
c     
      do op = 1, nop-1          ! Don't include identity
         call sym_bas_op
     &      (geom, op, dbl_mb(k_r), maxf, ang_max, do_spherical)
         class = op_class_index(op)
c
*         write(6,*) ' OP = ', op, class
c     
         do icent = 1, ncent
c
*            write(6,*) '      CENT = ', icent
c
            if (.not. bas_ce2cnr(basis, icent, ishlo, ishhi))
     $           call errquit('sym_bas_irreps: bas_ce2cnr',0, BASIS_ERR)
            jcent = sym_center_map(geom, icent, op)
            if (icent .eq. jcent) then
c     
c     Center maps into iself ... compute the trace of the matrix
c     
               do ish = ishlo, ishhi
                  if (.not. bas_continfo(basis, ish, itype, nprim,
     $                 ngen, sphcart)) call errquit
     $                 ('sym_bas_irreps: bas_continfo', icent,
     &       BASIS_ERR)
                  if (.not. bas_cn2bfr(basis, ish, ilo, ihi))
     $                 call errquit('sym_bas_irreps: bas_ce2cnr',0,
     &       BASIS_ERR)
                  n = (ihi - ilo + 1)
                  trace = 0.0d0
                  if (itype .eq. -1) then
                     trace = trace + sym_trace_bas_op(dbl_mb(k_r),
     $                    ang_max, maxf, 1, 0)
                     trace = trace + sym_trace_bas_op(dbl_mb(k_r),
     $                    ang_max, maxf, 3, 1)
                     ngen = 1
                  else
                     n = n / ngen
                     trace = trace + sym_trace_bas_op(dbl_mb(k_r),
     $                    ang_max, maxf, n, itype)
                  endif
c
*                  write(6,*) '         ish ', ish, itype, trace, ngen
c     
                  c(class) = c(class) + trace*ngen
               enddo
            endif
         enddo
      enddo
*c
*      write(6,*) ' NBF = ', nbf
*c     
c
c     Now project onto the characters of the irreps.  All would
c     be simple except for groups where the characters are
c     naturally complex and are combined here as separate irreps
c     whose characters are the real and imaginary parts of one
c     of the complex conjugate pair of irreps.  This leads to the
c     second of this pair having a ZERO character for the identity.
c     Also, if this character is used in a projection operator then
c     the operator is NOT idempotent.  Ugh.   However, twice the
c     character of the first 'irrep' will serve to provide a good 
c     projection operator provided it is faked as if of unit dimension.
c     
      call ifill(nir, 0, nbf_per_ir, 1)
      n = 0
      do ir = 1, nir
         irrep_dim = nint(chars((ir-1)*nir+1))
         if (irrep_dim .eq. 0) then
c
c     This is the wierd case noted above.  Simply reuse the trace
c     from the previous irrep ... it should be the same since the
c     basis set posseses the point group symmetry
c
            continue
         else
            trace = ddot(nir, c, 1, chars((ir-1)*nir+1), 1)/dble(nop)
            itrace = nint(trace)
            if (abs(trace-dble(itrace)).gt.1d-6.or.trace.lt.-1d-6) then
               write(6,*) ' sym_bas_irreps ', (c(i),i=1,nir)
               write(6,*) ' sym_bas_irreps ', trace
               write(6,*) ' sym_bas_irreps ', ir
               call errquit('sym_bas_irreps: bad character', 0,
     &       INPUT_ERR)
            endif
            itrace = itrace*irrep_dim
         endif
         nbf_per_ir(ir) = itrace
         n = n + nbf_per_ir(ir)
      enddo
c
c     Check that we have all of the functions
c
      if (n .ne. nbf) then
         write(6,*) ' sym_bas_irreps ', (c(i),i=1,nir)
         write(6,*) ' sym_bas_irreps ', n, nbf
         call errquit('sym_bas_irreps: lost some functions', 0,
     &       BASIS_ERR)
      endif
c     
      if (oprint) then
         call util_print_centered(6, 'Symmetry analysis of basis',
     $        18, .true.)
         write(6,*)
         do ir = 1, nir
            write(6,1) zir(ir), nbf_per_ir(ir)
         enddo
 1       format(8x, a8, i5)
         write(6,*)
      endif
c
      if (.not. ma_pop_stack(l_r)) call errquit
     $     ('sym_bas_irreps: memory corrupt?',0, MA_ERR)
c
      end

      subroutine qmd_forces(irtdb,isag,isat,xs,fs,msa,nsa,energy,lesp)
c
c $Id: qmd_main.F 25576 2014-05-07 18:17:06Z edo $
c
      implicit none
#include "errquit.fh"
c
#include "rtdb.fh"
#include "geom.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "qmd_common.fh"
#include "constants.fh"
c
      external task_gradient,esp
      logical task_gradient,esp
c
c      data lgeom/0/
c
      integer irtdb
      integer msa,nsa
      integer isag(msa),isat(msa)
      real*8 xs(msa,3),fs(msa,3),energy
      logical lesp
c
      integer i,isa
      integer i_qmdq,l_qmdq,i_qmdt,l_qmdt,i_qmdb,l_qmdb
      real*8 c(3),q
      character*16 tag
c
      if(lgeom.eq.0) then
      if(.not.geom_create(igeom,'geometry'))
     + call errquit('qmd: failed to create geometry',0, GEOM_ERR)
      if(.not.ma_push_get(mt_dbl,nsa,'qmdq',l_qmdq,i_qmdq))
     + call errquit('Failed to allocate qmdq',0, MA_ERR)
      if(.not.ma_push_get(mt_byte,16*nsa,'qmdt',l_qmdt,i_qmdt))
     + call errquit('Failed to allocate qmdt',0, MA_ERR)
      call qmd_geom_init(nsa,isag,isat,dbl_mb(i_qmdq),byte_mb(i_qmdt))
      if(ga_nodeid().eq.0) then
      if(.not.geom_cart_set(igeom,nsa,byte_mb(i_qmdt),xs,
     + dbl_mb(i_qmdq))) call errquit('Failed to initialize geom',0,
     &       GEOM_ERR)
      endif
      if(.not.geom_rtdb_store(irtdb,igeom,'geometry'))
     + call errquit('Failed to store geom to rtdb',0, RTDB_ERR)
      if(.not.ma_pop_stack(l_qmdt))
     + call errquit('Failed to deallocate qmdt',0, MA_ERR)
      if(.not.ma_pop_stack(l_qmdq))
     + call errquit('Failed to deallocate qmdq',0, MA_ERR)
      lgeom=1
      endif
c
      if(.not.geom_rtdb_load(irtdb,igeom,'geometry'))
     + call errquit('Failed to load geometry from rtdb',0, RTDB_ERR)
c
      do 1 i=1,nsa
      isa=isag(i)
      if(.not.geom_cent_get(igeom,isa,tag,c,q))
     + call errquit('geom_cent_get failed',isa, GEOM_ERR)
      c(1)=xs(isa,1)*cnm2au
      c(2)=xs(isa,2)*cnm2au
      c(3)=xs(isa,3)*cnm2au
      if(.not.geom_cent_set(igeom,i,tag,c,q))
     + call errquit('geom_cent_set failed',isa, GEOM_ERR)
    1 continue
      if(.not.geom_rtdb_store(irtdb,igeom,'geometry'))
     + call errquit('geom_rtdb_store failed',0, RTDB_ERR)
c
      call ga_sync()
      if(jdebug.gt.0) call ma_summarize_allocated_blocks()
      call ga_sync()
      if(.not.task_gradient(irtdb))
     + call errquit('qmd: Task_gradient failed',0, CALC_ERR)
      call ga_sync()
      if(lesp) then
      if(.not.esp(irtdb)) call errquit('qmd esp error',0, RTDB_ERR)
      endif
c
      if(.not.ma_push_get(mt_dbl,3*msa,'qmdb',l_qmdb,i_qmdb))
     + call errquit('Failed to allocate qmdq',0, MA_ERR)
      if(.not.ma_verify_allocator_stuff())
     + call errquit('Error qmd_forces 1',0, MA_ERR)
      call qmd_f(irtdb,isag,dbl_mb(i_qmdb),fs,msa,nsa,energy)
      if(.not.ma_verify_allocator_stuff())
     + call errquit('Error qmd_forces 2',0, MA_ERR)
      if(.not.ma_pop_stack(l_qmdb))
     + call errquit('Failed to deallocate qmdb',0, MA_ERR)
c
      return
      end
      subroutine qmd_f(irtdb,isag,buf,fs,msa,nsa,energy)
c
      implicit none
#include "errquit.fh"
c
#include "rtdb.fh"
#include "mafdecls.fh"
#include "qmd_common.fh"
#include "constants.fh"
c
      integer irtdb,msa,nsa
      integer isag(msa)
      real*8 buf(3,msa),fs(msa,3),energy
c
      integer i,isa
c
      if(.not.rtdb_get(irtdb,'task:gradient',mt_dbl,3*msa,buf))
     + call errquit('qmd_f: rtdb_get gradient failed',0, RTDB_ERR)
      if(.not.rtdb_get(irtdb,'task:energy',mt_dbl,1,energy))
     + call errquit('qmd_f: rtdb_get energy failed',0, RTDB_ERR)
c
      do 2 i=1,nsa
      isa=isag(i)
      fs(isa,1)=(-buf(1,i))*(cau2kj/cau2nm)
      fs(isa,2)=(-buf(2,i))*(cau2kj/cau2nm)
      fs(isa,3)=(-buf(3,i))*(cau2kj/cau2nm)
    2 continue
c
      energy=energy*cau2kj
c
      return
      end
      subroutine qmd_geom_init(nsa,isag,isat,q,tag)
c
      implicit none
c
      integer cf_element
      external cf_element
c
      integer nsa
      integer isag(nsa),isat(nsa)
      real*8 q(nsa)
      character*16 tag(nsa)
c
      integer i,ia
c
      do 1 i=1,nsa
      ia=cf_element(isat(i))
      call cf_num2tag(ia,tag(isag(i)))
      q(i)=dble(ia)
    1 continue
c
      return
      end
      subroutine qmd_wrttrj(lfntrj,mwm,nwm,mwa,nwa,msa,nsa,
     + lxw,lvw,lxs,lvs,box,stime,pres,temp,tempw,temps,xw,vw,xs,vs)
c
      integer lfntrj,msa,nsa,mwm,nwm,mwa,nwa
      logical lxw,lvw,lxs,lvs
      real*8 stime,pres,temp,tempw,temps,box(3)
      real*8 xw(mwm,3,mwa),vw(mwm,3,mwa)
      real*8 xs(msa,3),vs(msa,3)
c
      character*10 rdate,rtime
c
#include "global.fh"
c
      if(ga_nodeid().eq.0) then
c
      call swatch(rdate,rtime)
c
      write(lfntrj,1000)
 1000 format('frame')
      write(lfntrj,1001) stime,temp,pres,rdate,rtime
 1001 format(2f12.6,1pe12.5,1x,2a10)
      write(lfntrj,1002) box(1),0.0d0,0.0d0
      write(lfntrj,1002) 0.0d0,box(2),0.0d0
      write(lfntrj,1002) 0.0d0,0.0d0,box(3)
 1002 format(3f12.6)
      write(lfntrj,1003) lxw,lvw,lxs,lvs,nwm,nwa,nsa
 1003 format(4l1,3i10)
c
      if((lxw.or.lvw).and.nwm.gt.0) then
      if(lvw) then
      do 1 i=1,nwm
      write(lfntrj,1004) ((xw(i,j,k),j=1,3),(vw(i,j,k),j=1,3),k=1,nwa)
 1004 format(6f8.3)
    1 continue
      else
      do 2 i=1,nwm
      write(lfntrj,1005) ((xw(i,j,k),j=1,3),k=1,nwa)
 1005 format(3f8.3)
    2 continue
      endif
      endif
c
      if((lxs.or.lvs).and.nsa.gt.0) then
      if(lvs) then
      do 3 i=1,nsa
      write(lfntrj,1006) (xs(i,j),j=1,3),(vs(i,j),j=1,3)
 1006 format(6f8.3)
    3 continue
      else
      do 4 i=1,nsa
      write(lfntrj,1007) (xs(i,j),j=1,3)
 1007 format(3f8.3)
    4 continue
      endif
      endif
c
      endif
c
      return
      end

      logical function pre_atmscn(lfnsgm,filsgm,atmnam,num,link)
c
c $Id: pre_atmscn.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer lfnsgm,num,link
      character*255 filsgm
      character*4 atmnam
c
      character*80 card
      integer i,j,length,natm,ilnk,npar
      character*6 name
      real*8 version
c
      length=index(filsgm,' ')-1
      open(unit=lfnsgm,file=filsgm(1:length),form='formatted',
     + status='old',err=9999)
c
      num=0
      link=0
c
    1 continue
      read(lfnsgm,1000,err=9999,end=9999) card
 1000 format(a)
      if(card(1:1).eq.'#'.or.card(1:1).eq.'$') goto 1
      read(card,1001,err=9999) version
 1001 format(f12.6)
      read(lfnsgm,1002,err=9999) natm,npar
 1002 format(i5,25x,i5)
      do 2 i=1,npar
      read(lfnsgm,1000,err=9999,end=9999) card
    2 continue
      do 3 i=1,natm
      read(lfnsgm,1003) name,ilnk 
 1003 format(5x,a6,10x,i5)
      if(name(1:4).eq.atmnam) then
      link=ilnk
      num=i
      close(unit=lfnsgm)
      pre_atmscn=.true.
      return
      endif
      do 4 j=1,npar
      read(lfnsgm,1000,err=9999,end=9999) card
    4 continue
    3 continue
      close(unit=lfnsgm)
 9999 continue
      pre_atmscn=.false.
      return
      end

c $Id: int_l1eh1.F 23339 2013-01-03 17:50:16Z d3y133 $
*
C> \ingroup nwint
C> @{
C>
C> \brief Compute the 1 electron hamiltonian with zero integrals
C> removed
C>
C> This routine computes the 1 electron hamiltonian, (\f$H1\f$)
C> with labels and zero valued integrals removed. 
C> 
C> \f{eqnarray*}{
C> H1 & = & T + V      \\\\
C> T  & = & ({\mu}|\frac{-1}{2}\nabla^{2}|{\nu}) \\\\
C>    & = & \int_{-\infty}^{\infty} g_{\mu}(X_{\mu},r_{1})\frac{-1}{2}
C> \nabla^{2}(r_{1})g_{\nu}(X_{\nu},r_{1})dr_{1} \\\\
C> V  & = & ({\mu}|\sum_{\alpha}\frac{-Z_{\alpha}}{|r_{1}-R_{\alpha}|}|{\nu}) \\\\
C>    & = & \int_{-\infty}^{\infty} g_{\mu}(X_{\mu},r_{1})\sum_{\alpha}\frac
C> {-Z_{\alpha}}{|r_{1}-R_{\alpha}|}g_{\nu}(X_{\nu},r_{1})dr_{1} 
C> \f}
C> 
C> If an ECP is defined then the ECP integral contributions are summed 
C> directly into the $H1$ integrals.  
C>
c:tex-% this is part of the API Standard Integral routines.
c:tex-\subsection{int\_l1eh1}
c:tex-This routine computes the 1 electron hamiltonian, ($H1$)
c:tex-with labels and ``zero'' integrals removed. 
c:tex-
c:tex-\begin{eqnarray*}
c:tex-H1 & = & T + V      \\
c:tex-T  & = & ({\mu}|\frac{-1}{2}\nabla^{2}|{\nu}) \\
c:tex-   & = & \int_{-\infty}^{\infty} g_{\mu}(X_{\mu},r_{1})\frac{-1}{2}
c:tex-\nabla^{2}(r_{1})g_{\nu}(X_{\nu},r_{1})dr_{1} \\
c:tex-V  & = & ({\mu}|\sum_{\alpha}\frac{-Z_{\alpha}}{|r_{1}-R_{\alpha}|}|{\nu}) \\
c:tex-   & = & \int_{-\infty}^{\infty} g_{\mu}(X_{\mu},r_{1})\sum_{\alpha}\frac
c:tex-{-Z_{\alpha}}{|r_{1}-R_{\alpha}|}g_{\nu}(X_{\nu},r_{1})dr_{1} 
c:tex-\end{eqnarray*}
c:tex-
c:tex-If an ECP is defined then the ECP integral contributions are summed 
c:tex-directly into the $H1$ integrals.  
c:tex-
c:tex-{\it Syntax:}
c:tex-\begin{verbatim}
      subroutine int_l1eh1(i_basis, ish, j_basis, jsh, zerotol,
     &       ilab, jlab, lh1, H1, lscr, scr, numgen) 
c:tex-\end{verbatim}
      implicit none
#include "nwc_const.fh"
#include "errquit.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "mafdecls.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
#include "util.fh"
c
c::external subroutines used
c errquit
c::function
      logical int_chk_sh
      external int_chk_sh
      integer int_nint_cart
      external int_nint_cart
c::passed
c:tex-\begin{verbatim}
      integer i_basis !< [Input] basis set handle for ish
      integer ish     !< [Input] i shell/contraction
      integer j_basis !< [Input] basis set handle for jsh
      integer jsh     !< [Input] j shell/contraction
      integer lscr    !< [Input] length of scratch array
      double precision zerotol   !< [Input] zero threshold 
      double precision scr(lscr) !< [Scratch] scratch array
      integer lh1                !< [Input] length of 1e buffers.
      integer numgen             !< [Output] number of H1 integrals
      integer ilab(lh1)          !< [Output] i bas fun labels array
      integer jlab(lh1)          !< [Output] j bas fun labels array
      double precision H1(lh1)   !< [Output] 1e H1 integrals
c:tex-\end{verbatim}
c::local
      integer ibas, jbas, icount, i, j
      logical ijbas
      logical shells_ok
      logical nonzero
      integer numint, newlscr
c
#include "bas_ibs_sfn.fh"
c
      shells_ok = int_chk_sh(i_basis,ish)
      shells_ok = shells_ok .and. int_chk_sh(j_basis,jsh)
      if (.not.shells_ok)
     &       call errquit('int_l1eh1: invalid contraction/shell',0, 
     &       BASIS_ERR)
c      
      ibas  = i_basis + BASIS_HANDLE_OFFSET
      jbas  = j_basis + BASIS_HANDLE_OFFSET
      ijbas = ibas .eq. jbas
c
      numint = int_nint_cart(i_basis,ish,j_basis,jsh, 0,0, 0,0)
      newlscr = lscr - numint
      call int_1eh1(i_basis, ish, j_basis, jsh,
     &    newlscr,scr(numint+1),numint,scr)
c
      numgen = 0
      icount = 0
      do 00100 i = (sf_ibs_cn2bfr(1,ish,ibas)),
     &      (sf_ibs_cn2bfr(2,ish,ibas))
        do 00200 j = (sf_ibs_cn2bfr(1,jsh,jbas)),
     &        (sf_ibs_cn2bfr(2,jsh,jbas))
          icount = icount + 1
          nonzero = abs(scr(icount)).ge.zerotol
          if (nonzero) then
            if ((.not.ijbas).or.i.ge.j) then
              numgen = numgen + 1
              H1(numgen) = scr(icount)
              ilab(numgen) = i
              jlab(numgen) = j
            endif
          endif
c
00200   continue
00100 continue
c
      end
C> @}

* $Id: vib_intense.F 19708 2010-10-29 18:04:21Z d3y133 $
      subroutine vib_intense(rtdb,eigvec,eigval,nat,ddpolx,ddpolq,
     &    intensity,first_pass)
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "util.fh"
      integer nat
      integer rtdb
      double precision eigvec(3,nat,3,nat)  ! (cart,q)
      double precision eigval(3,nat)        ! (q)
      double precision ddpolx(3,3,nat)      ! (m,cart)
      double precision ddpolq(3,3,nat)      ! (m,q)
      double precision intensity(3,nat,4)   ! (q,3)  3->1 = au, 
* . . . . . . . . . . . . . . . . . . . . . !           2 = (debye/angs)**2,
* . . . . . . . . . . . . . . . . . . . . . !           3 = (KM/mole)
* . . . . . . . . . . . . . . . . . . . . . !           4 = arbitrary units 
* . . . . . . . . . . . . . . . . . . . . . !               normalized units
      logical first_pass
c
      integer iq, iqatom, iqxyz, iqm, atom, xyz
      double precision ddq, dint, ave_intensity, factor
      double precision dpdq1, dpdq2, dpdq3
      integer ivalx, ivala
      double precision val
      logical printit
      logical debug
c
      debug = util_print('everything',print_debug)
c
c fix phase of eigvec
c
      do iqatom = 1,nat
        do iqxyz = 1,3
          ivalx = -1
          ivala = -1
          val = -1.0d00
          do atom = 1,nat
            do xyz = 1,3
              if (abs(eigvec(xyz,atom,iqxyz,iqatom)).gt.val) then
                val = eigvec(xyz,atom,iqxyz,iqatom)
                ivala = atom
                ivalx = xyz
              endif
            enddo
          enddo
          if (eigvec(ivalx,ivala,iqxyz,iqatom).lt.0.0d00) then
            do atom = 1,nat
              do xyz = 1,3
                eigvec(xyz,atom,iqxyz,iqatom)=
     &              -eigvec(xyz,atom,iqxyz,iqatom)
              enddo
            enddo
          endif
        enddo
      enddo
c
*...  first form ddpolq from ddpolx
c
      do iqatom = 1,nat
        do iqxyz = 1,3
          do iqm = 1,3
            ddq = 0.0d00
            do atom = 1,nat
              do xyz = 1,3
                ddq = ddq +
*ddpolx(q,cart)eigvec(cart,q)
     &              ddpolx(iqm,xyz,atom)*eigvec(xyz,atom,iqxyz,iqatom)
              enddo
            enddo
            ddpolq(iqm,iqxyz,iqatom) = ddq
          enddo
        enddo
      enddo
c
c write dipole derivatives in normal modes 
c
      printit = util_print('dipole derivatives',print_default)
      printit = printit.or.debug
      if (printit) then
        write(luout,'(//)')
        write(luout,10000)
        if (first_pass) then
          write(luout,10001)
        else
          write(luout,10002)
        endif
        iq = 0
        do iqatom = 1,nat
          do iqxyz = 1,3
            iq = iq + 1
            dpdq1 = ddpolq(1,iqxyz,iqatom)*2.5417478d00/0.529177249d00
            dpdq2 = ddpolq(2,iqxyz,iqatom)*2.5417478d00/0.529177249d00
            dpdq3 = ddpolq(3,iqxyz,iqatom)*2.5417478d00/0.529177249d00
            write(luout,10003)
     &          iq,eigval(iqxyz,iqatom),dpdq1,dpdq2,dpdq3
          enddo
        enddo
        write(luout,10000)
        write(luout,'(//)')
      endif
c
*... form Intensity vector
c
      call dfill ((3*nat*4),0.0d00,intensity,1)
c
      ave_intensity = 0.0d00
      do iqatom = 1,nat
        do iqxyz = 1,3
          dint = 0.0d00
          do iqm = 1,3
            dint = dint +
     &          ddpolq(iqm,iqxyz,iqatom)*ddpolq(iqm,iqxyz,iqatom)
          enddo
          intensity(iqxyz,iqatom,1) = dint
          ave_intensity = ave_intensity + dint
*
* from A Physicists Desk Reference, The Second Edition of Physics Vade Mecum
*      Herbert L. Anderson, Editor in Chief
*      Copyright (C) 1989 American Institute of Physics
*      335 East 45th Street, New York, NY 10017
*
*1 debye = 10**(-18) esu cm * [1 e/4.8032068 x 10**(-10) esu]*[1 m /100cm]*[a0/5.29177249 x 10**(-11) m]
*1 debye = (1.0/4.8032068/5.29177249) * 10**(-18 + 10 - 2 + 11) e a0
*1 debye = (1.0/4.8032068/5.29177249) * 10**(1) e a0
*1 e a0  = (4.8032068*5.29177249) * 10**(-1) debye
*1 e a0  = 25.417477608 * 10**(-1) debye
*1 e a0  = 2.5417477608 debye
*
*use 1 e a0 = 2.541 7478 debye
*
          intensity(iqxyz,iqatom,2) =
     &        dint*2.5417478d00/0.529177249d00 ! bohr->angstrom matches current geom data
     &        *2.5417478d00/0.529177249d00
          intensity(iqxyz,iqatom,3) =
     &        intensity(iqxyz,iqatom,2)*42.2547  ! convert to KM/mol from debye**2/angs**2
        enddo
      enddo
c
      ave_intensity = ave_intensity/3.0d00/nat
c
      if (debug) then
        iq = 0
        do iqatom = 1,nat
          do iqxyz = 1,3
            iq = iq + 1
            write(luout,90000)
     &          iq,
     &          eigval(iqxyz,iqatom),
     &          intensity(iqxyz,iqatom,1),
     &          intensity(iqxyz,iqatom,2),
     &          intensity(iqxyz,iqatom,3)
          enddo
        enddo
      endif
c
*... normalize the average intensity to max = 10.0
c  10.0 = value*factor
c
      factor = 10.d00/ave_intensity
      call dcopy((3*nat),intensity(1,1,1),1,intensity(1,1,4),1)
      call dscal((3*nat),factor,intensity(1,1,4),1)
c
      if (debug) then
        iq = 0
        do iqatom = 1,nat
          do iqxyz = 1,3
            iq = iq + 1
            write(luout,90001)
     &          iq,
     &          eigval(iqxyz,iqatom),
     &          intensity(iqxyz,iqatom,4)
          enddo
        enddo
      endif
c
*... print information out.
c
      printit = util_print('IR intensities',print_low)
      printit = printit.or.debug
      if (printit) then
        write(luout,*)' '
        write(luout,*)' '
        write(luout,10000)
        if (first_pass) then
          write(luout,10004)
        else
          write(luout,10005)
        endif
        iq = 0
        do iqatom = 1,nat
          do iqxyz = 1,3
            iq = iq + 1
            write(luout,10006)
     &          iq,eigval(iqxyz,iqatom),
     &          (intensity(iqxyz,iqatom,iqm),iqm=1,4)
          enddo
        enddo
        write(luout,10000)
        write(luout,'(//)')
        call util_flush(luout)
      endif
c
*... print information to ecce file
c      
      if (first_pass) then
        call ecce_print1('intensities',
     &      mt_dbl,intensity(1,1,1),(3*nat))
        if(.not. rtdb_put(rtdb,'vib:intensities',MT_DBL,3*nat,
     &      intensity(1,1,1)))
     &      call errquit('vib_intense:rtdb_put of intensities failed',
     &      555, RTDB_ERR)
        call ecce_print1('intensities (debye/ang)2',
     &      mt_dbl,intensity(1,1,2),(3*nat))
        call ecce_print1('intensities (KM/mol)',
     &      mt_dbl,intensity(1,1,3),(3*nat))
      else
        call ecce_print1('projected intensities',
     &      mt_dbl,intensity(1,1,1),(3*nat))
        if(.not. rtdb_put(rtdb,'vib:projected intensities',
     &      MT_DBL,3*nat,intensity(1,1,1)))
     &      call errquit(
     &      'vib_intense:rtdb_put of projected intensities failed',
     &      555, RTDB_ERR)
        call ecce_print1('projected intensities (debye/ang)2',
     &      mt_dbl,intensity(1,1,2),(3*nat))
        call ecce_print1('projected intensities (KM/mol)',
     &      mt_dbl,intensity(1,1,3),(3*nat))
      endif
c
10000 format(1x,76('-'))
10001 format(
     &    1x,'Normal',1x,'Eigenvalue',1x,'||',
     &    9x,'Derivative Dipole Moments (debye/angs)',/,
     &    2x,'Mode',
     &    3x,'[cm**-1]',2x,'||',
     &    6x,'[d/dqX]',
     &   13x,'[d/dqY]',
     &   11x,'[d/dqZ]',/,
     &    1x,'------',
     &    1x,'----------',1x,'||',
     &    1x,'------------------',
     &    1x,'------------------',
     &    1x,'-----------------')
10002 format(
     &    1x,'Normal',1x,'Eigenvalue',1x,'||',
     &    4x,'Projected Derivative Dipole Moments (debye/angs)',/,
     &    2x,'Mode',
     &    3x,'[cm**-1]',2x,'||',
     &    6x,'[d/dqX]',
     &   13x,'[d/dqY]',
     &   11x,'[d/dqZ]',/,
     &    1x,'------',
     &    1x,'----------',1x,'||',
     &    1x,'------------------',
     &    1x,'------------------',
     &    1x,'-----------------')
10003 format(2x,i3,3x,f10.3,1x,'||',
     &    2x,f10.3,10x,f10.3,8x,f10.3)
10004 format(
     &    1x,'Normal',1x,'Eigenvalue',1x,'||',
     &   14x,'   Infra Red Intensities',/,
     &    2x,'Mode',
     &    3x,'[cm**-1]',2x,'||',
     &    1x,'[atomic units]',
     &    1x,'[(debye/angs)**2]',
     &    1x,'[(KM/mol)]',
     &    1x,'[arbitrary]',/,
     &    1x,'------',
     &    1x,'----------',1x,'||',
     &    1x,'--------------',
     &    1x,'-----------------',
     &    1x,'----------',
     &    1x,'-----------')
10005 format(
     &    1x,'Normal',1x,'Eigenvalue',1x,'||',
     &    8x,'   Projected Infra Red Intensities',/,
     &    2x,'Mode',
     &    3x,'[cm**-1]',2x,'||',
     &    1x,'[atomic units]',
     &    1x,'[(debye/angs)**2]',
     &    1x,'[(KM/mol)]',
     &    1x,'[arbitrary]',/,
     &    1x,'------',
     &    1x,'----------',1x,'||',
     &    1x,'--------------',
     &    1x,'-----------------',
     &    1x,'----------',
     &    1x,'-----------')
10006 format(2x,i3,3x,f10.3,1x,'||',
     &    1x,f11.6,6x,f10.3,4x,f10.3,2x,f10.3)
90000 format(1x,'Intensity for eigenvalue ',i3,' [',f10.3,
     &    ' cm**(-1)] is ',
     &    f10.3,' [atomic units] ',
     &    f10.3,'[(debey/angs)**2]',
     &    f10.3,'[(KM/mol)]')
90001 format(1x,'Normalized Intensity for eigenvalue ',i3,' [',f10.3,
     &    ' cm**(-1)] is ',f10.3,' arbitrary units ')
c
      end

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_hesupd ( STEP, GRAD, HESIAN, SCR )
c $Id: stpr_hesupd.F 25540 2014-05-01 22:33:27Z d3y133 $
C
C     This subroutine updates the hessian using the hessian from the
C     old geometry and the difference in the coordinates and
C     gradients between the current and old geometries.
C
C     For finding a minimum on the surface (OMIN or STD =.TRUE.)
C     the BFGS  update is used; for TS=.TRUE. the Powell method
C     is chosen.
C     Note that hessian is a symmetric packed vector.
C
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
#include "errquit.fh"
      PARAMETER (ZERO=0.0D0, ONE=1.0D0, TOLER=1.0D-25)
      COMMON / STAPES / ITAP05, ITAP06, ITAP41,
     &                  ITAP44, ITAP45
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
#include "chow.fh"
      DIMENSION STEP(NAT3), GRAD(NAT3), HESIAN(NAT3TR), SCR(NAT3)
      IF (OMIN.OR.STD) THEN
C
C       BFGS update
C       first, form vector hessian matrix times step vector
C       also, form dot products grad dot step and step dot
C       (hessian*step)
C
        DM1 = ZERO
        DM2 = ZERO
        DO 20 I = 1,NAT3
          SCR(I) = ZERO
          DO 10 J = 1,NAT3
            IJ = MAX(I,J)*(MAX(I,J)-1)/2 + MIN(I,J)
            SCR(I) = SCR(I) + HESIAN(IJ)*STEP(J)
   10     CONTINUE
          DM1 = DM1 + STEP(I)*GRAD(I)
          DM2 = DM2 + STEP(I)*SCR(I)
   20   CONTINUE
        IF (ABS(DM1) .LE. TOLER) THEN
          WRITE (ITAP06,1000) DM1
 1000     FORMAT ('  * ERROR * Dot product of STEP with',
     &               '  GRAD = ',1PD12.4)
          call errquit('stepper:hesupd fatal error',911, UNKNOWN_ERR)
        ENDIF
        IF (ABS(DM2) .LE. TOLER) THEN
          WRITE (ITAP06,2000) DM2
 2000     FORMAT ('  * ERROR * STEP*HESIAN*STEP = ',1PD12.4)
          call errquit('stepper:hesupd fatal error',911, UNKNOWN_ERR)
        ENDIF
        DM1 = ONE/DM1
        DM2 = ONE/DM2
C
C       update
C
        DO 40 I = 1,NAT3
          DO 30 J = 1,I
            IJ = MAX(I,J)*(MAX(I,J)-1)/2 + MIN(I,J)
            HESIAN(IJ) = HESIAN(IJ) +
     &                   DM1*GRAD(I)*GRAD(J) - DM2*SCR(I)*SCR(J)
   30     CONTINUE
   40   CONTINUE
      ELSE IF (TS) THEN
C
C       Powell update
C       First, form T vector = grad - hessian times step
C       Also form dot products T dot step and step dot step
C
        DM1 = ZERO
        DM2 = ZERO
        DO 60 I = 1,NAT3
          SCR(I) = ZERO
          DO 50 J = 1,NAT3
            IJ = MAX(I,J)*(MAX(I,J)-1)/2 + MIN(I,J)
            SCR(I) = SCR(I) + HESIAN(IJ)*STEP(J)
   50     CONTINUE
          SCR(I) = GRAD(I) - SCR(I)
          DM1 = DM1 + STEP(I)*STEP(I)
          DM2 = DM2 + STEP(I)*SCR(I)
   60   CONTINUE
        IF (ABS(DM1) .LE. TOLER) THEN
          WRITE (ITAP06,3000) DM1
 3000     FORMAT ('  * ERROR * norm of step vector = ',
     &    1PD12.4)
          call errquit('stepper:hesupd fatal error',911, UNKNOWN_ERR)
        ENDIF
        DM1 = ONE/DM1
C
C       update
C
        DO 80 I = 1,NAT3
          DO 70 J = 1,I
            IJ = MAX(I,J)*(MAX(I,J)-1)/2 + MIN(I,J)
            HESIAN(IJ) = HESIAN(IJ) + DM1*(SCR(I)*STEP(J) +
     &                   STEP(I)*SCR(J) - STEP(I)*STEP(J)*DM1*DM2)
   70     CONTINUE
   80   CONTINUE
      ELSE
        WRITE (ITAP06,*)' UNKNOWN TYPE OF CALCULATION IN HESUPD'
        call errquit('stepper:hesupd fatal error',911, INPUT_ERR)
      ENDIF
      RETURN
      END
C> @}

*> \brief \b DLASWP performs a series of row interchanges on a general rectangular matrix.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLASWP + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlaswp.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlaswp.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlaswp.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLASWP( N, A, LDA, K1, K2, IPIV, INCX )
* 
*       .. Scalar Arguments ..
*       INTEGER            INCX, K1, K2, LDA, N
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       DOUBLE PRECISION   A( LDA, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLASWP performs a series of row interchanges on the matrix A.
*> One row interchange is initiated for each of rows K1 through K2 of A.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix A.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the matrix of column dimension N to which the row
*>          interchanges will be applied.
*>          On exit, the permuted matrix.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.
*> \endverbatim
*>
*> \param[in] K1
*> \verbatim
*>          K1 is INTEGER
*>          The first element of IPIV for which a row interchange will
*>          be done.
*> \endverbatim
*>
*> \param[in] K2
*> \verbatim
*>          K2 is INTEGER
*>          The last element of IPIV for which a row interchange will
*>          be done.
*> \endverbatim
*>
*> \param[in] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (K2*abs(INCX))
*>          The vector of pivot indices.  Only the elements in positions
*>          K1 through K2 of IPIV are accessed.
*>          IPIV(K) = L implies rows K and L are to be interchanged.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>          The increment between successive values of IPIV.  If IPIV
*>          is negative, the pivots are applied in reverse order.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup doubleOTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Modified by
*>   R. C. Whaley, Computer Science Dept., Univ. of Tenn., Knoxville, USA
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DLASWP( N, A, LDA, K1, K2, IPIV, INCX )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INCX, K1, K2, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, I1, I2, INC, IP, IX, IX0, J, K, N32
      DOUBLE PRECISION   TEMP
*     ..
*     .. Executable Statements ..
*
*     Interchange row I with row IPIV(I) for each of rows K1 through K2.
*
      IF( INCX.GT.0 ) THEN
         IX0 = K1
         I1 = K1
         I2 = K2
         INC = 1
      ELSE IF( INCX.LT.0 ) THEN
         IX0 = 1 + ( 1-K2 )*INCX
         I1 = K2
         I2 = K1
         INC = -1
      ELSE
         RETURN
      END IF
*
      N32 = ( N / 32 )*32
      IF( N32.NE.0 ) THEN
         DO 30 J = 1, N32, 32
            IX = IX0
            DO 20 I = I1, I2, INC
               IP = IPIV( IX )
               IF( IP.NE.I ) THEN
                  DO 10 K = J, J + 31
                     TEMP = A( I, K )
                     A( I, K ) = A( IP, K )
                     A( IP, K ) = TEMP
   10             CONTINUE
               END IF
               IX = IX + INCX
   20       CONTINUE
   30    CONTINUE
      END IF
      IF( N32.NE.N ) THEN
         N32 = N32 + 1
         IX = IX0
         DO 50 I = I1, I2, INC
            IP = IPIV( IX )
            IF( IP.NE.I ) THEN
               DO 40 K = N32, N
                  TEMP = A( I, K )
                  A( I, K ) = A( IP, K )
                  A( IP, K ) = TEMP
   40          CONTINUE
            END IF
            IX = IX + INCX
   50    CONTINUE
      END IF
*
      RETURN
*
*     End of DLASWP
*
      END
c $Id: dlaswp.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine smd_paramfile_natoms(na)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer na
      logical result
c
      character*(180) buffer
      character*(nw_max_path_len) filename
      integer un
      character*30 pname
c
      pname = "smd_paramfile_natoms"
c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)

c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)


      na = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."ATOM") then
        na = na + 1
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_paramfile_nshake(na)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer na
c
      character*(180) buffer
      integer un
c
      character*30 pname
      logical result
      character*(nw_max_path_len) filename
c
      pname = "smd_paramfile_nshake"
c      write(*,*) "in "//pname
c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)


      na = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:5).eq."SHAKE") then
        na = na + 1
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_paramfile_nbond(na)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer na
c
      character*(180) buffer
      integer un
      logical result
      character*(nw_max_path_len) filename
c
      character*30 pname

      pname = "smd_paramfile_nbond"
c      write(*,*) "in "//pname
c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)
c
      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)


      na = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:4).eq."BOND") then
        na = na + 1
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_paramfile_nres(na)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer na
c
      character*(180) buffer
      integer un
      character*30 pname
      logical result
      character*(nw_max_path_len) filename
c
      pname = "smd_paramfile_nres"

c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)
c

      if(.not.util_get_io_unit(un))
     >   call errquit("cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)


      na = 0
100   continue
      read(un,'(A180)',end=200) buffer
      if(buffer(1:3).eq."MOL") then
        na = na + 1
      end if
      goto 100
200   continue
      close(un)

      end

      subroutine smd_paramfile_read_atom(na,ta,tt,tr,mass,q)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer na
      character*(smd_string_size) ta(na)
      character*(smd_string_size) tt(na)
      character*(smd_string_size) tr(na)
      double precision mass(na)
      double precision q(na)
c
      character*180 buffer
      character*4 tag
      character*30 pname
      character*(smd_string_size) rtag
      integer i
      integer un
      logical result
      character*(nw_max_path_len) filename

      pname = "smd_paramfile_read_params"
c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)
c

      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)


      i=0
100   continue
      read(un,'(A180)',end=150) buffer
      if(buffer(1:3).eq."MOL") then
        read(buffer,*) tag,rtag
        goto 100
      end if
      if(buffer(1:4).eq."ATOM") then
         i = i +1
         if(i.gt.na)
     >  call errquit(pname//"insufficient array size",0,0)
         read(buffer,*) tag,tag,ta(i),tt(i),mass(i),q(i)
         tr(i)=rtag
         goto 100
      end if
      goto 100
150   continue
      close(un)
      return
      end

      subroutine smd_paramfile_read_pot(np,pt,
     +                                  p1,p2,p3,
     +                                  nt,tt,tr)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer np
      integer pt(np)
      double precision p1(np)
      double precision p2(np)
      double precision p3(np)
      integer nt
      character*(smd_string_size) tt(nt)
      character*(smd_string_size) tr(nt)
c
      character*180 buffer
      character*4 tag
      character*(smd_string_size) tag1,tag2
      character*30 pname
      integer i,i1,i2,npr
      integer un

      logical result
      character*(nw_max_path_len) filename

      pname = "smd_paramfile_read_pot"

c      write(*,*) "in "//pname
c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)
c

      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)

      i = 0
      npr = 0
      do i1=1,nt
       do i2=i1,nt
        i = i+1
         rewind(un)
100      continue
         read(un,'(A180)',end=150) buffer
         if(buffer(1:3).eq."POT") then
          read(buffer,*) tag,tag1,tag2
          if(tt(i1).eq.tag1) then
           if(tt(i2).eq.tag2) goto 110
          end if
          if(tt(i1).eq.tag2) then
           if(tt(i2).eq.tag1) goto 110
          end if
         end if
         goto 100
110      continue
         read(buffer,*) tag,tag1,tag2,pt(i),
     +                  p1(i),p2(i),p3(i)
         npr = npr + 1
150      continue
       end do
      end do
      
      np = npr

c      i = 0
c      do i1=1,nt
c       do i2=i1,nt
c        i = i+1
c        write(*,*) "index",i,
c     +             ((i1-1)*(2*nt+2-i1))/2+i2-i1+1,
cc     +             (i1*(i1+1))/2+i2-i1,
c     +             i1,i2,nt
c        write(*,*) pt(i),p1(i),p2(i),p3(i)
c       end do
c      end do
c 
      close(un)
      return
      end

      subroutine smd_paramfile_read_shake(ns,nt,s1,s2,d,tt)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer nt
      integer ns
      integer s1(ns)
      integer s2(ns)
      double precision d(ns)
      character*(smd_string_size) tt(nt)
c
      character*180 buffer
      character*4 tag
      character*(smd_string_size) tag1,tag2
      character*30 pname
      integer i,j,i1,i2
      double precision dtmp
      integer un

      logical result
      character*(nw_max_path_len) filename

      pname = "smd_paramfile_read_shake"

c      write(*,*) "in "//pname
c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)
c

      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)

      i = 0
      do i1=1,nt
       do i2=i1+1,nt
         rewind(un)
100      continue
         read(un,'(A180)',end=150) buffer
         if(buffer(1:5).eq."SHAKE") then
          read(buffer,*) tag,tag1,tag2,dtmp
          if(tt(i1).eq.tag1) then
           if(tt(i2).eq.tag2) goto 110
          end if
          if(tt(i1).eq.tag2) then
           if(tt(i2).eq.tag1) goto 110
          end if
         end if
         goto 100
110      continue
         i = i + 1
         s1(i) = i1
         s2(i) = i2
         d(i)  =dtmp
150      continue
       end do
      end do
       
      ns = i

      close(un)
      return
      end

      subroutine smd_paramfile_read_bond(nb,nt,s1,s2,
     >                                   it,d,k,ta,tr)
      implicit none
#include "mafdecls.fh"
#include "errquit.fh"
#include "util.fh"
#include "inp.fh"
#include "smd_const_data.fh"
      integer nt
      integer nb
      integer s1(nb)
      integer s2(nb)
      integer it(nb)
      double precision d(nb)
      double precision k(nb)
      character*(smd_string_size) ta(nt)
      character*(smd_string_size) tr(nt)
c
      character*180 buffer
      character*4 tag
      character*(smd_string_size) atag1,atag2,rtag
      character*30 pname
      integer i,j,i1,i2
      integer s1t,s2t,itt
      double precision dt,kt
      logical lr,la1,la2
      integer un

      logical result
      character*(nw_max_path_len) filename

      pname = "smd_paramfile_read_bond"

c      write(*,*) "in "//pname
c
      call smd_paramfile(filename,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no parameter file found',0, 0)
c

      if(.not.util_get_io_unit(un))
     >   call errquit(pname//"cannot get file number",0,0)
c
      open(unit=un,status="old",form="formatted",file=filename)


      i=0
100   continue
      read(un,'(A180)',end=150) buffer
      if(buffer(1:3).eq."MOL") then
        read(buffer,*) tag,rtag
        goto 100
      end if
      if(buffer(1:4).eq."BOND") then
         if(i+1.gt.nb)
     >  call errquit(pname//"insufficient array size",0,0)
         read(buffer,*) tag,atag1,atag2,itt,dt,kt
         s1t = 0
         s2t = 0
         do j=1,nt
           lr = rtag.eq.tr(j)
           la1 = atag1.eq.ta(j)
           la2 = atag2.eq.ta(j)
           if(lr.and.la1)  s1t=j
           if(lr.and.la2)  s2t=j
           if(s1t*s2t.ne.0) then
             i = i +1
             s1(i) = min(s1t,s2t)
             s2(i) = max(s1t,s2t)
             it(i) = itt
             d(i) = dt
             k(i) = kt
             goto 100
           end if
         end do 
      end if
      goto 100
150   continue

      close(un)
      return
      end

      subroutine smd_paramfile(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_paramfile"

      result = .true.
      call smd_rtdb_get_string("smd:paramfile",1,
     >                           filename,result)

      end
c $Id: smd_paramfile.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup stpr_priv
C> @{
      SUBROUTINE stpr_sumstc(STEP,COORD,ATMASS,CMASS,TENIN,CNVGRD)
c     $Id: stpr_sumstc.F 25540 2014-05-01 22:33:27Z d3y133 $
      IMPLICIT  REAL*8(A-H,O-Z), INTEGER(I-N)
      LOGICAL CNVGRD
      COMMON / CFACE / IWCTR,NATOM,ICALC
      COMMON / DIMS / NAT3, NAT3SQ, NAT3TR
#include "util.fh"
#include "chow.fh"
      DIMENSION STEP(NAT3),COORD(3,NATOM),ATMASS(NATOM),CMASS(3),
     &     TENIN(3,3)
      IF(.NOT.CNVGRD)THEN
C     
C     Add STEP to COORD.
C     
         IJ = 0
         DO 20 I = 1, NATOM
            DO 10 J = 1,3
               IJ = IJ + 1
               COORD(J,I) = COORD(J,I) + STEP(IJ)
 10         CONTINUE
 20      CONTINUE
      ENDIF
C     
C     Write new coordinates.
C     
*rak:      if (util_print('new coordinates',print_low)) then
*rak:         IF(CNVGRD)THEN
*rak:            WRITE(6,1003)
*rak:         ELSE
*rak:            WRITE(6,1000)
*rak:         ENDIF
*rak:         WRITE(6,1001)
*rak:         DO 30 I = 1,NATOM
*rak:            WRITE(6,1002)I,(COORD(J,I),J=1,3)
*rak: 30      CONTINUE
*rak:         write(6,*)
*rak:      endif
*rak:      if (util_print('distances',print_default)) then
*rak:         CALL DISTAN(NATOM,COORD)
*rak:         write(6,*)
*rak:      endif
*rak:      if (util_print('angles',print_default)) then
*rak:         CALL ANGLE(NATOM,COORD)
*rak:         write(6,*)
*rak:      endif
C     
C     Calculate the vector of center of mass and the inertia
C     tensor for the new geometry.
C     
      IF (MWC) THEN
         CALL stpr_mgeom(COORD,ATMASS,CMASS,TENIN)
C     
C     Shift the mass center to the origin of the coordinate system.
C     
         DO 50 I=1,3
            IF (ABS(CMASS(I)).LT.1.0D-06) GOTO 50
            DO 60 J=1,NATOM
               COORD(I,J)=COORD(I,J)-CMASS(I)
 60         CONTINUE
 50      CONTINUE
         WRITE(6,1004)
         WRITE(6,1001)
         DO 70 I = 1,NATOM
            WRITE(6,1002)I,(COORD(J,I),J=1,3)
 70      CONTINUE
         write(6,*)
      ENDIF
      RETURN
 1000 FORMAT('  ',19('-'),' New coordinates ',19('-'))
 1001 FORMAT('  ATOM:',12x,'X',14x,'Y',14x,'Z')
 1002 FORMAT('  ',I3,6X,3(1X,F14.10))
 1003 FORMAT('  ',16('-'),' Converged coordinates ',16('-'))
 1004 FORMAT('  ',19('-'),' Shifted coordinates ',19('-'))
      END
C> @}

c
c     $Id: c_bybminimize.F 24489 2013-08-08 20:12:41Z bylaska $                       
c

*  ************************************************************
*  *                                                          *
*  *             Band by Band Kohn-Sham Minimizer             *
*  *                                                          *
*  *                                                          *
*  *                                                          *
*  ************************************************************
  
      subroutine c_bybminimize(E,deltae,deltac,current_iteration,
     >                       set_iterations,iterations)
      implicit none
      real*8     E(*)
      real*8     deltae,deltac
      integer    current_iteration
      logical    set_iterations
      integer    iterations


#include "stdio.fh"
#include "mafdecls.fh"
#include "util.fh"

*     **** local variables ****
      integer MASTER,taskid
      parameter (MASTER=0)

      real*8  deltat_min
      parameter (deltat_min=1.0d-3)
       
      integer vall_in(2),vall_out(2),vall_junk(2)
      real*8  Ein,deltae_history(10),ehfx,phfx
      real*8  ks_deltae,deltav,dV,deltav_old,diis_error
      integer nx,ny,nz,stalled_count


      real*8     tole,tolc
      real*8     ehartree,eorbit,exc,pxc,eion
      real*8     Enew,Eold,alpha
      !common / cgsd_block / Enew,Eold,alpha

      integer it,it_in,ispin,sd_it,cg_it

      logical value,precondition,done,stalled,oprint
      integer nfft3d
      


*     **** external functions ****
      logical  band_hfx
      logical  control_print,control_precondition
      integer  control_ispin,control_scf_algorithm
      integer  control_it_in,control_it_out,control_version
      real*8   control_tole,control_tolc,control_ks_alpha
      real*8   c_rho_error,cpsi_1energy
      real*8   c_dng_1ehartree,lattice_omega
      real*8   cpsi_1ke
      real*8   cpsi_1vl
      real*8   cpsi_1vnl
      real*8   cpsi_1vnlso
      real*8   c_rho_1exc
      real*8   c_rho_1pxc
      real*8   ewald_e
      real*8   cpsi_1eorbit
   
      external band_hfx
      external control_print,control_precondition
      external control_ispin,control_scf_algorithm
      external control_it_in,control_it_out,control_version
      external control_tole,control_tolc,control_ks_alpha
      external c_rho_error,cpsi_1energy
      external c_dng_1ehartree,lattice_omega
      external cpsi_1ke
      external cpsi_1vl,psi_1v_field
      external cpsi_1vnl
      external cpsi_1vnlso
      external c_rho_1exc
      external c_rho_1pxc
      external ewald_e
      external cpsi_1eorbit

      real*8   cpsi_1_noupdate_energy,cpsi_eigenvalue,ion_disp_energy
      external cpsi_1_noupdate_energy,cpsi_eigenvalue,ion_disp_energy
      logical  ion_disp_on
      external ion_disp_on
   

      Ein = E(1)
      call Parallel_taskid(taskid)
      oprint = (taskid.eq.MASTER).and.control_print(print_medium)

      call C3dB_nx(1,nx)
      call C3dB_ny(1,ny)
      call C3dB_nz(1,nz)
      dV = lattice_omega()/dble(nx*ny*nz)
      if (set_iterations) then
        it_in = iterations
        sd_it = 2 
        cg_it = 1 
      else
        it_in = control_it_in()*control_it_out()
        sd_it = 10
        cg_it = 10
      end if
      tole  = control_tole()
      tolc  = control_tolc()
      precondition = control_precondition()
      ispin = control_ispin()
      deltav_old = 10.0d0
      deltav     = 0.0d0

      stalled       = .false.
      deltae_history(1) = 0.0d0
      deltae_history(2) = 0.0d0
      deltae_history(3) = 0.0d0
      deltae_history(4) = 0.0d0
      stalled_count     = 0

      call C3dB_nfft3d(1,nfft3d)

*     **** allocate rho_in and rho_out ****
      value = MA_push_get(mt_dcpl,2*nfft3d,
     >                     'vall_in',vall_in(2),vall_in(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,2*nfft3d,
     >                     'vall_out',vall_out(2),vall_out(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,2*nfft3d,
     >                   'vall_junk',vall_junk(2),vall_junk(1))
c      value = value.and.
c     >        MA_push_get(mt_dcpl,2*nfft3d,
c     >                     'rho_in',rho_in(2),rho_in(1))
      if (.not. value) 
     >   call errquit('c_bybminimize:out of stack memory',0,0)

*     **** ion-ion energy ****
      eion = ewald_e()


*     **********************
*     **** bybminimizer ****
*     **********************

*     **** set the initial density ****
      if (current_iteration.eq.1) then
         Enew   = cpsi_1energy()
         alpha = control_ks_alpha()
         deltae = -9232323299.0d0
         ks_deltae = tole
         call c_electron_gen_vall()
         call c_electron_get_vall(dcpl_mb(vall_out(1)))
         call c_electron_get_vall(dcpl_mb(vall_in(1))) 

         call cpsi_1gen_hml()
         call cpsi_diagonalize_hml()
         call cpsi_1rotate2()
         call cpsi_2to1()
      else
         Enew   = cpsi_1energy()
         call c_electron_get_vall(dcpl_mb(vall_out(1)))
         call c_electron_get_vall(dcpl_mb(vall_in(1))) 
         !call psi_get_density(1,dcpl_mb(rho_in(1)))
      end if
  
*     **** iniitialize SCF Mixing ****    
      call nwpw_scf_mixing_init(control_scf_algorithm(),alpha,
     >                5,ispin,2*nfft3d,dcpl_mb(vall_out(1)))


*     ***** diis loop ****
      it   = 0
 2    it   = it + 1
      
*     **** diaganolize KS matrix ****
      call cpsi_KS_update(1,precondition,ks_deltae)

      call c_rho_1to2()
      Eold = Enew
      Enew = cpsi_1energy()


      deltae = Enew-Eold

      call c_electron_gen_vall()
      call c_electron_get_vall(dcpl_mb(vall_in(1)))

*     **** compute deltaV ****
      call dcopy(ispin*2*nfft3d,
     >           dcpl_mb(vall_in(1)),1,
     >           dcpl_mb(vall_junk(1)),1)
      call daxpy(ispin*2*nfft3d,
     >              (-1.0d0),
     >              dcpl_mb(vall_out(1)),1,
     >              dcpl_mb(vall_junk(1)),1)
      deltav = ddot(ispin*2*nfft3d,
     >                 dcpl_mb(vall_junk(1)),1,
     >                 dcpl_mb(vall_junk(1)),1)
      call C3dB_SumAll(deltav)
      deltav = deltav*dV
      


*     **** update vall using density mixing ****
      if ((it.le.0) .or.
     >    ((dabs(deltae).lt.1.0d5) .and.
     >    (deltav       .lt.1.0d5) .and.
     >    (.not.stalled          ))) then

         call nwpw_scf_mixing(dcpl_mb(vall_in(1)),dcpl_mb(vall_out(1)),
     >                        deltae,diis_error)

*     **** bad convergence - try fixed step steepest descent ****
      else

  30     call c_sdminimize(sd_it)
         Eold   = Enew
         Enew   = cpsi_1energy()
         !if (dabs(Enew-Eold).gt.1.0d2) go to 30

         call dcopy(ispin*2*nfft3d,
     >              dcpl_mb(vall_out(1)),1,
     >              dcpl_mb(vall_junk(1)),1)

         call c_electron_gen_vall()
         call c_electron_get_vall(dcpl_mb(vall_out(1))) 
         call nwpw_scf_mixing_reset(dcpl_mb(vall_out(1)))


         call daxpy(ispin*2*nfft3d,
     >              (-1.0d0),
     >              dcpl_mb(vall_out(1)),1,
     >              dcpl_mb(vall_junk(1)),1)
         deltav = ddot(ispin*2*nfft3d,
     >                 dcpl_mb(vall_junk(1)),1,
     >                 dcpl_mb(vall_junk(1)),1)
         call D3dB_SumAll(deltav)
         deltav = deltav*dV

         call cpsi_1gen_hml()
         call cpsi_diagonalize_hml()
         call cpsi_1rotate2()
         call cpsi_2to1()

         stalled       = .false.
         deltae_history(1) = 0.0d0
         deltae_history(2) = 0.0d0
         deltae_history(3) = 0.0d0
         deltae_history(4) = 0.0d0
         stalled_count     = 0

      end if
      call c_electron_set_vall(dcpl_mb(vall_out(1))) 
      
          
*     **** tolerance checks ****
      deltae = Enew-Eold   
      deltac = c_rho_error()
      E(1)   = Enew+eion

      if ((oprint).and.(.not.set_iterations)) then 
        write(luout,1310) it,E(1),deltae,deltac,deltav
        call util_flush(luout)
      end if
 1310 FORMAT(I8,E20.10,3E15.5)


      !**** set ks_deltae ****
      ks_deltae = 0.001d0*dabs(deltae)
      if (ks_deltae.lt.(0.1d0*tole)) ks_deltae = 0.1d0*tole
      if (ks_deltae.gt.1.0d-4) ks_deltae = 1.0d-4
      !ks_deltae = 0.1d0*tole



      deltav_old = deltav

      deltae_history(1)    = deltae_history(2)
      deltae_history(2)    = deltae_history(3)
      deltae_history(3)    = deltae_history(4)
      deltae_history(4)    = deltae        

      if (stalled_count .gt.4) then
        stalled = (deltae_history(4)
     >            +deltae_history(3)
     >            +deltae_history(2)
     >            +deltae_history(1)).gt.0.0d0
      else
         stalled = .false.
      end if
      stalled_count = stalled_count + 1
      stalled = .false.

      precondition = precondition.and.(dabs(deltae).gt.1*tole)

      done = ( (    (dabs(deltae).lt.tole)
     >         .and.(deltae.lt.0.0d0)
     >         .and.(deltac      .lt.tolc))
     >       .or. (it.ge.it_in))

      if (.not.done) go to 2



*     **** free memory ****
      call nwpw_scf_mixing_end()
c      value =           MA_pop_stack(rho_in(2))
      value = MA_pop_stack(vall_junk(2))
      value = value.and.MA_pop_stack(vall_out(2))
      value = value.and.MA_pop_stack(vall_in(2))
      if (.not. value) 
     >  call errquit('c_bybminimize: popping stack',1,0)

      call cpsi_check()


*     **** set return energies **** - This is duplicate code
      !Enew     = cpsi_1energy()
      eorbit   = cpsi_1eorbit()
      ehartree = c_dng_1ehartree()
      exc      = c_rho_1exc()
      pxc      = c_rho_1pxc()

      E(1)  = Enew + eion
      E(2)  = eorbit
      E(3)  = ehartree
      E(4)  = exc
      E(5)  = eion
      E(6)  = cpsi_1ke()
      E(7)  = cpsi_1vl()
      E(8)  = cpsi_1vnl()
      E(9)  = 2.0d0*ehartree
      E(10) = pxc
      E(11) = cpsi_1vnlso()

*     **** HFX terms ****
      if (band_HFX()) then
         call c_electron_HFX_energies(ehfx,phfx)
         E(26) = ehfx
         E(27) = phfx
      end if

*     **** Dispersion energy ****
      if (ion_disp_on()) then
         E(33) = ion_disp_energy()
         E(1)  = E(1) + E(33)
      end if

      return
      end
 

c     ==================================
c     == Delocalized internals driver ==
c     ==================================
c
      logical function deloc_driver(irtdb)
c
      implicit none
c
c     == general includes ==
#include "mafdecls.fh"
#include "errquit.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "global.fh"
#include "stdio.fh"
c
c     == delocalized internals includes ==
#include "deloc_data.fh"
c
c     == general ==
      integer irtdb   ! input: handle to the runtime database
      integer master
      logical returnstatus
      character*32 pname
c
c     == geometry related ==
      integer igeom  ! local handle to the main geometry object
c
      integer iatom, natom, ndim
c
      integer i_coord,h_coord   ! coordinates
      integer i_grad,h_grad     ! gradients
      integer i_atsymb,h_atsymb ! atomic symbols
      integer i_covrad,h_covrad ! covalent radii
      integer i_atnum,h_atnum   ! atomic numbers
c
      double precision energy
      character*16 atsymb       ! atomic symbol of one atom
      double precision xloc(3)  ! coordinate of one atom
      double precision qloc(3)  ! charge on one atom
c
c     == external functions ==
      logical task_gradient     ! energy/gradient driver
      external task_gradient
      logical getcovalentradii  ! get the covalent radii
      external getcovalentradii
      logical getatomicnumbers  ! get the atomic numbers
      external getatomicnumbers
c
c     == algorithm related ==
      integer maxiter, igeomiter, itype, ierror
      logical converged
      logical periodic
c
c     == preliminaries ==
      pname ="deloc_driver"     ! name of this driver
      master=ga_nodeid()        ! get the master node
      if (master.eq.0) then
        write(luout,*)
        write(luout,*) 
     & "Geometry optimization using delocalized internal coordinates"
        write(luout,*)
      end if
c
c     == allocate necessary memory ==
c
c     == create a local geometry object ==
      if(.not.geom_create(igeom,'geometry'))
     & call errquit(pname//'Failed to create geometry',0, GEOM_ERR)
c
c     == load the current geometry into the geometry object ==
      if(.not.geom_rtdb_load(irtdb,igeom,'geometry'))
     & call errquit(pname//'Failed to load geometry',0, GEOM_ERR)
c
c     == get the number of coordinates in the geometry ==
      if(.not. geom_ncent(igeom,natom) )
     & call errquit(pname//'No coordinates present',0, GEOM_ERR)
c
c     == allocate the coordinates ==
      if(.not.ma_alloc_get(mt_dbl,3*natom,'coords',h_coord,i_coord))
     & call errquit( pname//'Failed to allocate memory for centers',
     & 3*natom, MA_ERR)
c
c     == allocate the gradients ==
      if(.not.ma_alloc_get(mt_dbl,3*natom,'gradients',h_grad,i_grad))
     & call errquit( pname//'Failed to allocate memory for gradients',
     & 3*natom, MA_ERR)
c
c     == allocate the covalent radii ==
      if(.not.ma_alloc_get(mt_dbl,natom,'cov. radii',h_covrad,i_covrad))
     & call errquit( pname//'Failed to allocate memory for cov. radii',
     & natom, MA_ERR)
c
c     == allocate the atomic numbers ==
      if(.not.ma_alloc_get(mt_int,natom,'at. nums',h_atnum,i_atnum))
     & call errquit( pname//'Failed to allocate memory for at. nums',
     & natom, MA_ERR)
c
c     == determine system type: molecular (itype = 0) or periodic (itype > 0) ==
      periodic = .false.
      if(.not. geom_systype_get(igeom,itype)) itype = 0  ! molecular by default
      if (itype.ne.0) periodic = .true.
c
c     == get the number of iterations ==
      if(.not.rtdb_get(irtdb,'driver:nptopt',mt_int,1,maxiter))
     &  maxiter = 20
c
c     == get the covalent radii ==
      if (.not. getcovalentradii(igeom, natom, dbl_mb(i_covrad)))
     & call errquit(pname//'Failed to get cov. radii',0, GEOM_ERR)
c
c     == get the atomic numbers ==
      if (.not. getatomicnumbers(igeom, natom, int_mb(i_atnum)))
     & call errquit(pname//'Failed to get atomic. nums',0, GEOM_ERR)
c
c     == test print out ==
c      write(luout,*) "natom:",natom
c      do iatom = 1,natom
c       write(luout,*) dbl_mb(i_coord+3*(iatom-1)),
c     &                dbl_mb(i_coord+3*(iatom-1)+1),
c     &                dbl_mb(i_coord+3*(iatom-1)+2),
c     &                dbl_mb(i_covrad+iatom-1),
c     &                dbl_mb(i_atnum+iatom-1)
c      end do
c      stop
c       
c     == start optimization loop ==
      igeomiter = 0  ! initialize iteration counter
  20  continue 
c
c     == get the coordinates from the geometry object ==
      if(.not.geom_cart_coords_get(igeom,dbl_mb(i_coord)))
     & call errquit( pname//'Failed to get coordinates',0, GEOM_ERR)
c
c     == calculate the energy/gradient ==
      if (.not. task_gradient(irtdb)) 
     &   call errquit(pname//'task_gradient failed',0, GEOM_ERR)
c
c     == get the energy & gradients from the runtime database ==
      if (.not. rtdb_get(irtdb,'task:energy', mt_dbl, 1, energy))
     &   call errquit(pname//'Could not get energy',0, RTDB_ERR)
      if (.not. rtdb_get(irtdb, 'task:gradient', mt_dbl, 3*natom,
     &  dbl_mb(i_grad))) 
     & call errquit(pname//'Could not get gradient',0,RTDB_ERR)
c
c     == call the main delocalized internals driver
      converged = .false.
      ierror = 0
      call deloc(periodic, natom, ndim, 
     &           dbl_mb(i_coord),   ! coordinates
     &           dbl_mb(i_grad),    ! gradients
     &           dbl_mb(i_covrad),  ! covalent radii
     &           int_mb(i_atnum),   ! atomic numbers
     &           converged, ierror)
c
c     == decide what to do if ierror > 0 == will handle later
c     switch to another scheme after updating the database with the 
c     last good geometry
c
c     == update the geometry ==
      if(.not.geom_cart_coords_set(igeom,dbl_mb(i_coord)))  
     & call errquit(pname//'Failed to set coordinates',0, GEOM_ERR)
c
c     == update the runtime database ==
      if(.not.geom_rtdb_store(irtdb,igeom,'geometry'))
     & call errquit(pname//'Failed to store geometry',0, GEOM_ERR)
c
c     == update geometry optimization counter ==
      igeomiter = igeomiter + 1
c
c     == convergence check ==
      if (igeomiter.le.abs(maxiter).and. (.not. converged) ) then
        goto 20  ! go back to the main optimization loop
      else
       call errquit(
     & pname//'Geometry optimization did not converge',0,RTDB_ERR)
      end if
c
c     == end optimization loop ==
c
c     == deallocate necessary memory ==
      if(.not.ma_free_heap(h_grad))
     & call errquit(pname//'Failed to deallocate stack gradients',0,
     &       MA_ERR)
c
      if(.not.ma_free_heap(h_coord))
     & call errquit(pname//'Failed to deallocate stack coords',0,
     &       MA_ERR)
c
      if(.not.ma_free_heap(h_covrad))
     & call errquit(pname//'Failed to deallocate stack cov. radii',0,
     &       MA_ERR)
c
      if(.not.ma_free_heap(h_atnum))
     & call errquit(pname//'Failed to deallocate stack atomic. nums',0,
     &       MA_ERR)
c
       if(.not.geom_destroy(igeom))
     & call errquit(pname//'Failed to destroy geometry',0, GEOM_ERR)
c
      deloc_driver = .true.
      return
      end
c $Id: deloc_driver.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function argos_prepare_check(lfnout,nparms,mparms,ignore,
     + latt,catt,matt,natt,catm,latm,matm,natm,lbnd,mbnd,nbnd,
     + lang,mang,nang,ldih,mdih,ndih,limp,mimp,nimp,
     + lseq,cseq,mseq,nseq)
c
c $Id: argos_prepare_check.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
#include "argos_prepare_common.fh"
c
      integer lfnout,matm,natm,nparms,mparms,ignore
      integer matt,natt,mbnd,nbnd,mang,nang,mdih,ndih,mimp,nimp
      integer latt(3,matt),lbnd(4,mbnd),lang(5,mang),ldih(6,mdih)
      integer limp(6,mimp),latm(11,matm)
      character*6 catt(2,matt),catm(mparms,matm)
      integer mseq,nseq
      integer lseq(6,mseq)
      character*10 cseq(mseq)
c
      integer i,j,k,ii,jj,kk,mask
c
      argos_prepare_check=.true.
c
      mask=0
      do 123 j=1,nparms
      mask=ior(mask,2**(j-1))
  123 continue
c
c     check the atom types
c     --------------------
c
 1000 format(/,' Undetermined force field parameters',/)
c
      do 1 i=1,natt
      if(latt(1,i).le.0) then
      do 11 j=1,i-1
      if(latt(1,j).le.0.and.catt(1,i).eq.catt(1,j)) goto 1
   11 continue
      if(util_print('topology',print_none)) then
      if(argos_prepare_check) write(lfnout,1000)
      write(lfnout,1001) catt(1,i)
 1001 format(' Parameters could not be found for atom type     ',
     + a6)
      endif
      argos_prepare_check=.false.
      endif
    1 continue
c
      do 2 i=1,nbnd
      if(lbnd(3,i).le.0.and.lbnd(3,i).gt.-mask.and.lbnd(4,i).eq.0) then
      k=-lbnd(3,i)
      do 3 j=1,nparms
      if((catm(1+j,lbnd(1,i))(6:6).eq.'Q'.or.
     + catm(1+j,lbnd(1,i))(6:6).eq.'H').and.
     + (catm(1+j,lbnd(2,i))(6:6).eq.'Q'.or.
     + catm(1+j,lbnd(2,i))(6:6).eq.'H').and.ignore.ne.0) goto 3
      if(j.eq.1.and.(k.eq.1.or.k.eq.3.or.k.eq.5)) goto 3
      if(j.eq.2.and.(k.eq.2.or.k.eq.3.or.k.eq.6)) goto 3
      if(j.eq.3.and.(k.eq.4.or.k.eq.5.or.k.eq.6)) goto 3
      do 12 ii=1,i
      if(lbnd(3,ii).le.0.and.lbnd(3,ii).gt.-mask) then
      kk=-lbnd(3,i)
      do 13 jj=1,nparms
      if(jj.eq.1.and.(kk.eq.1.or.kk.eq.3.or.kk.eq.5)) goto 13
      if(jj.eq.2.and.(kk.eq.2.or.kk.eq.3.or.kk.eq.6)) goto 13
      if(jj.eq.3.and.(kk.eq.4.or.kk.eq.5.or.kk.eq.6)) goto 13
      if(i.eq.ii.and.j.eq.jj) goto 12
      if((catm(1+j,lbnd(1,i)).eq.catm(1+jj,lbnd(1,ii)).and.
     + catm(1+j,lbnd(2,i)).eq.catm(1+jj,lbnd(2,ii))).or.
     + (catm(1+j,lbnd(1,i)).eq.catm(1+jj,lbnd(2,ii)).and.
     + catm(1+j,lbnd(2,i)).eq.catm(1+jj,lbnd(1,ii)))) goto 3
   13 continue
      endif
   12 continue
      if(util_print('topology',print_none)) then
      if(argos_prepare_check) write(lfnout,1000)
      write(lfnout,1002)
     + catm(1+j,lbnd(1,i)),catm(1+j,lbnd(2,i)),
     + catm(1,lbnd(1,i)),catm(1,lbnd(2,i)),
     + cseq(latm(5,lbnd(1,i))),lseq(1,latm(5,lbnd(1,i))),
     + lbnd(1,i),lbnd(2,i),i,j,k
 1002 format(' Parameters could not be found for bond type     ',
     + a6,'-',a6,' (',a6,'-',a6,')',a6,i6,2i7,i7,2i3)
      endif
      argos_prepare_check=.false.
    3 continue
      endif
    2 continue
c
      do 4 i=1,nang
      if(lang(4,i).le.0.and.lang(4,i).gt.-mask.and.lang(5,i).eq.0) then
      k=-lang(4,i)
      do 5 j=1,nparms
      if((catm(1+j,lang(1,i))(6:6).eq.'Q'.or.
     + catm(1+j,lang(1,i))(6:6).eq.'H').and.
     + (catm(1+j,lang(2,i))(6:6).eq.'Q'.or.
     + catm(1+j,lang(2,i))(6:6).eq.'H').and.
     + (catm(1+j,lang(3,i))(6:6).eq.'Q'.or.
     + catm(1+j,lang(3,i))(6:6).eq.'H').and.ignore.ne.0) goto 5
      if(j.eq.1.and.(k.eq.1.or.k.eq.3.or.k.eq.5)) goto 5
      if(j.eq.2.and.(k.eq.2.or.k.eq.3.or.k.eq.6)) goto 5
      if(j.eq.3.and.(k.eq.4.or.k.eq.5.or.k.eq.6)) goto 5
      do 14 ii=1,i
      if(lang(4,ii).le.0.and.lang(4,ii).gt.-mask) then
      kk=-lang(4,i)
      do 15 jj=1,nparms
      if(jj.eq.1.and.(kk.eq.1.or.kk.eq.3.or.kk.eq.5)) goto 15
      if(jj.eq.2.and.(kk.eq.2.or.kk.eq.3.or.kk.eq.6)) goto 15
      if(jj.eq.3.and.(kk.eq.4.or.kk.eq.5.or.kk.eq.6)) goto 15
      if(i.eq.ii.and.j.eq.jj) goto 14
      if(catm(1+j,lang(2,i)).eq.catm(1+jj,lang(2,ii)).and.
     + ((catm(1+j,lang(1,i)).eq.catm(1+jj,lang(1,ii)).and.
     + catm(1+j,lang(3,i)).eq.catm(1+jj,lang(3,ii))).or.
     + (catm(1+j,lang(1,i)).eq.catm(1+jj,lang(3,ii)).and.
     + catm(1+j,lang(3,i)).eq.catm(1+jj,lang(1,ii))))) goto 5
   15 continue
      endif
   14 continue
      if(util_print('topology',print_none)) then
      if(argos_prepare_check) write(lfnout,1000)
      write(lfnout,1003)
     + catm(1+j,lang(1,i)),catm(1+j,lang(2,i)),catm(1+j,lang(3,i)),
     + catm(1,lang(1,i)),catm(1,lang(2,i)),catm(1,lang(3,i)),
     + cseq(latm(5,lang(1,i))),lseq(1,latm(5,lang(1,i))),
     + lang(1,i),lang(2,i),lang(3,i),i,j,k
 1003 format(' Parameters could not be found for angle type    ',
     + a6,'-',a6,'-',a6,' (',a6,'-',a6,'-',a6,')',a6,i6,3i7,i7,2i3)
      endif
      argos_prepare_check=.false.
    5 continue
      endif
    4 continue
c
      do 6 i=1,ndih
      if(ldih(5,i).le.0.and.ldih(5,i).gt.-mask.and.ldih(6,i).eq.0) then
      k=-ldih(5,i)
      do 7 j=1,nparms
      if((catm(1+j,ldih(1,i))(6:6).eq.'Q'.or.
     + catm(1+j,ldih(1,i))(6:6).eq.'H').and.
     + (catm(1+j,ldih(2,i))(6:6).eq.'Q'.or.
     + catm(1+j,ldih(2,i))(6:6).eq.'H').and.
     + (catm(1+j,ldih(3,i))(6:6).eq.'Q'.or.
     + catm(1+j,ldih(3,i))(6:6).eq.'H').and.
     + (catm(1+j,ldih(4,i))(6:6).eq.'Q'.or.
     + catm(1+j,ldih(4,i))(6:6).eq.'H').and.ignore.ne.0) goto 7
      if(j.eq.1.and.(k.eq.1.or.k.eq.3.or.k.eq.5)) goto 7
      if(j.eq.2.and.(k.eq.2.or.k.eq.3.or.k.eq.6)) goto 7
      if(j.eq.3.and.(k.eq.4.or.k.eq.5.or.k.eq.6)) goto 7
      do 16 ii=1,i
      if(ldih(5,ii).le.0.and.ldih(5,ii).gt.-mask) then
      kk=-ldih(5,i)
      do 17 jj=1,nparms
      if(jj.eq.1.and.(kk.eq.1.or.kk.eq.3.or.kk.eq.5)) goto 17
      if(jj.eq.2.and.(kk.eq.2.or.kk.eq.3.or.kk.eq.6)) goto 17
      if(jj.eq.3.and.(kk.eq.4.or.kk.eq.5.or.kk.eq.6)) goto 17
      if(i.eq.ii.and.j.eq.jj) goto 16
      if((catm(1+j,ldih(1,i)).eq.catm(1+jj,ldih(1,ii)).and.
     + catm(1+j,ldih(2,i)).eq.catm(1+jj,ldih(2,ii)).and.
     + catm(1+j,ldih(3,i)).eq.catm(1+jj,ldih(3,ii)).and.
     + catm(1+j,ldih(4,i)).eq.catm(1+jj,ldih(4,ii))).or.
     + (catm(1+j,ldih(1,i)).eq.catm(1+jj,ldih(4,ii)).and.
     + catm(1+j,ldih(2,i)).eq.catm(1+jj,ldih(3,ii)).and.
     + catm(1+j,ldih(3,i)).eq.catm(1+jj,ldih(2,ii)).and.
     + catm(1+j,ldih(4,i)).eq.catm(1+jj,ldih(1,ii)))) goto 7
   17 continue
      endif
   16 continue
      if(util_print('topology',print_none)) then
      if(argos_prepare_check) write(lfnout,1000)
      write(lfnout,1004) catm(1+j,ldih(1,i)),catm(1+j,ldih(2,i)),
     + catm(1+j,ldih(3,i)),catm(1+j,ldih(4,i)),catm(1,ldih(1,i)),
     + catm(1,ldih(2,i)),catm(1,ldih(3,i)),catm(1,ldih(4,i)),
     + cseq(latm(5,ldih(1,i))),lseq(1,latm(5,ldih(1,i))),
     + ldih(1,i),ldih(2,i),ldih(3,i),ldih(4,i),i,j,k
 1004 format(' Parameters could not be found for dihedral type ',
     + a6,'-',a6,'-',a6,'-',a6,' (',a6,'-',a6,'-',a6,'-',a6,')',
     + a6,i6,4i7,i7,2i3)
      endif
      argos_prepare_check=.false.
    7 continue
      endif
    6 continue
c
      do 8 i=1,nimp
      if(limp(5,i).le.0.and.limp(5,i).gt.-mask.and.limp(6,i).eq.0) then
      k=-limp(5,i)
      do 9 j=1,nparms
      if((catm(1+j,limp(1,i))(6:6).eq.'Q'.or.
     + catm(1+j,limp(1,i))(6:6).eq.'H').and.
     + (catm(1+j,limp(2,i))(6:6).eq.'Q'.or.
     + catm(1+j,limp(2,i))(6:6).eq.'H').and.
     + (catm(1+j,limp(3,i))(6:6).eq.'Q'.or.
     + catm(1+j,limp(3,i))(6:6).eq.'H').and.
     + (catm(1+j,limp(4,i))(6:6).eq.'Q'.or.
     + catm(1+j,limp(4,i))(6:6).eq.'H').and.ignore.ne.0) goto 9
      if(j.eq.1.and.(k.eq.1.or.k.eq.3.or.k.eq.5)) goto 9
      if(j.eq.2.and.(k.eq.2.or.k.eq.3.or.k.eq.6)) goto 9
      if(j.eq.3.and.(k.eq.4.or.k.eq.5.or.k.eq.6)) goto 9
      do 18 ii=1,i
      if(limp(5,ii).le.0.and.limp(5,ii).gt.-mask) then
      kk=-limp(5,i)
      do 19 jj=1,nparms
      if(jj.eq.1.and.(kk.eq.1.or.kk.eq.3.or.kk.eq.5)) goto 19
      if(jj.eq.2.and.(kk.eq.2.or.kk.eq.3.or.kk.eq.6)) goto 19
      if(jj.eq.3.and.(kk.eq.4.or.kk.eq.5.or.kk.eq.6)) goto 19
      if(i.eq.ii.and.j.eq.jj) goto 18
      if(catm(1+j,limp(1,i)).eq.catm(1+jj,limp(1,ii)).and.
     + ((catm(1+j,limp(2,i)).eq.catm(1+jj,limp(2,ii)).and.
     + catm(1+j,limp(3,i)).eq.catm(1+jj,limp(3,ii)).and.
     + catm(1+j,limp(4,i)).eq.catm(1+jj,limp(4,ii))).or.
     + (catm(1+j,limp(2,i)).eq.catm(1+jj,limp(2,ii)).and.
     + catm(1+j,limp(3,i)).eq.catm(1+jj,limp(4,ii)).and.
     + catm(1+j,limp(4,i)).eq.catm(1+jj,limp(3,ii))).or.
     + (catm(1+j,limp(2,i)).eq.catm(1+jj,limp(3,ii)).and.
     + catm(1+j,limp(3,i)).eq.catm(1+jj,limp(2,ii)).and.
     + catm(1+j,limp(4,i)).eq.catm(1+jj,limp(4,ii))).or.
     + (catm(1+j,limp(2,i)).eq.catm(1+jj,limp(3,ii)).and.
     + catm(1+j,limp(3,i)).eq.catm(1+jj,limp(4,ii)).and.
     + catm(1+j,limp(4,i)).eq.catm(1+jj,limp(2,ii))).or.
     + (catm(1+j,limp(2,i)).eq.catm(1+jj,limp(4,ii)).and.
     + catm(1+j,limp(3,i)).eq.catm(1+jj,limp(2,ii)).and.
     + catm(1+j,limp(4,i)).eq.catm(1+jj,limp(3,ii))).or.
     + (catm(1+j,limp(2,i)).eq.catm(1+jj,limp(4,ii)).and.
     + catm(1+j,limp(3,i)).eq.catm(1+jj,limp(3,ii)).and.
     + catm(1+j,limp(4,i)).eq.catm(1+jj,limp(2,ii))))) goto 9
   19 continue
      endif
   18 continue
      if(util_print('topology',print_none)) then
      if(argos_prepare_check) write(lfnout,1000)
      if(ffield(1:5).eq.'amber') then
      write(lfnout,1005) catm(1+j,limp(2,i)),catm(1+j,limp(3,i)),
     + catm(1+j,limp(1,i)),catm(1+j,limp(4,i)),
     + catm(1,limp(2,i)),catm(1,limp(3,i)),
     + catm(1,limp(1,i)),catm(1,limp(4,i)),
     + cseq(latm(5,limp(1,i))),lseq(1,latm(5,limp(1,i))),
     + limp(2,i),limp(3,i),limp(1,i),limp(4,i),i,j,k
      else
      write(lfnout,1005) catm(1+j,limp(1,i)),catm(1+j,limp(2,i)),
     + catm(1+j,limp(3,i)),catm(1+j,limp(4,i)),
     + catm(1,limp(1,i)),catm(1,limp(2,i)),
     + catm(1,limp(3,i)),catm(1,limp(4,i)),
     + cseq(latm(5,limp(1,i))),lseq(1,latm(5,limp(1,i))),
     + limp(1,i),limp(2,i),limp(3,i),limp(4,i),i,j,k
      endif
 1005 format(' Parameters could not be found for improper type ',
     + a6,'-',a6,'-',a6,'-',a6,' (',a6,'-',a6,'-',a6,'-',a6,')',
     + a6,i6,4i7,i7,2i3)
      endif
      argos_prepare_check=.false.
    9 continue
      endif
    8 continue
c
      return
      end
 

! $Id: paw_basis_data.F 25587 2014-05-11 15:51:47Z bylaska $

!**************************************************
!
!       Name: alloc_paw_basis_data
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      SUBROUTINE  alloc_paw_basis_data(nt,nb,ng)
      implicit none
#include "errquit.fh"
      integer nt
      integer nb(nt)
      integer ng(nt)

#include "paw_basis_data.fh"
#include "mafdecls.fh"      
#include "paw_ma.fh"


      logical ok
      integer it
      integer offset_nb
      integer offset_ngb
      integer offset_ng

      tot_ntype = nt

*     !*** find total size for the arrays ***    
      do it = 1, tot_ntype
        tot_nbasis     = tot_nbasis     + nb(it)
        tot_ngridbasis = tot_ngridbasis + nb(it)*ng(it)
        tot_ngrid      = tot_ngrid     + ng(it)
      end do

c      ok = MA_set_auto_verify(.TRUE.)

      ok = .TRUE.

      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"nbasis",nbasis)
      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"i_cut",i_cut)
      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"ngrid",ngrid)
      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"mult_l",mult_l)
      ok = ok .AND. my_alloc(MT_DBL,tot_ntype,"r1",r1)
      ok = ok .AND. my_alloc(MT_DBL,tot_ntype,"rmax",rmax)
      ok = ok .AND. my_alloc(MT_DBL,tot_ntype,"log_amesh",log_amesh)
      ok = ok .AND. my_alloc(MT_DBL,tot_ntype,"sigma",sigma)
      ok = ok .AND. my_alloc(MT_DBL,tot_ntype,"ion_charge",ion_charge) 
      ok = ok .AND. my_alloc(MT_DBL,tot_ntype,"core_charge",core_charge)
      ok = ok .AND. 
     >     my_alloc(MT_DBL,tot_ntype,"core_kin_energy",core_kin_energy)

      ok = ok .AND. my_alloc(MT_INT,tot_nbasis,"pr_n_ps",pr_n_ps)
      ok = ok .AND. my_alloc(MT_INT,tot_nbasis,"pr_n",pr_n)
      ok = ok .AND. my_alloc(MT_INT,tot_nbasis,"orb_l",orb_l)
      ok = ok .AND. my_alloc(MT_DBL,tot_nbasis,"eig",eig)

      ok = ok .AND. my_alloc(MT_DBL,tot_ngridbasis,"phi_ae",phi_ae)
      ok = ok .AND. 
     >     my_alloc(MT_DBL,tot_ngridbasis,"phi_ae_prime",phi_ae_prime)
      ok = ok .AND. my_alloc(MT_DBL,tot_ngridbasis,"phi_ps",phi_ps)
      ok = ok .AND. 
     >     my_alloc(MT_DBL,tot_ngridbasis,"phi_ps_prime",phi_ps_prime)
      ok = ok .AND. my_alloc(MT_DBL,tot_ngridbasis,"prj_ps",prj_ps)
      ok = ok .AND. 
     >     my_alloc(MT_DBL,tot_ngrid,"core_density",core_density)
      ok = ok .AND. 
     >     my_alloc(MT_DBL,tot_ngrid,"ps_core_density",ps_core_density)

      ok = ok .AND.
     >     my_alloc(MT_DBL,tot_ngrid,"core_density_prime",
     >              core_density_prime)
      ok = ok .AND. 
     >     my_alloc(MT_DBL,tot_ngrid,"ps_core_density_prime",
     >              ps_core_density_prime)

      ok = ok .AND. my_alloc(MT_DBL,tot_ngrid,"v_ps",v_ps)
      ok = ok .AND. my_alloc(MT_DBL,tot_ngridbasis,"prj_ps0",prj_ps0)
      ok = ok .AND. my_alloc(MT_DBL,tot_ngrid,"rgrid",rgrid)

      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"i_nb",i_nb)
      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"i_ng",i_ng)
      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"i_ngb",i_ngb)

      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"i_start",i_start)
      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"i_end",i_end)
      ok = ok .AND. my_alloc(MT_INT,tot_ntype,"npoints",npoints)

      if(.not. ok) then
        call errquit("failed to allocate paw_basis data ",0, MA_ERR)
      end if

      do it=1,tot_ntype
        int_mb(nbasis(1)-1 + it) = nb(it)
        int_mb(ngrid(1)-1 + it)  = ng(it)
      end do

      int_mb(i_nb(1) )  = 0
      int_mb(i_ng(1) )  = 0
      int_mb(i_ngb(1))  = 0

      do it=1,tot_ntype-1
        int_mb(i_nb(1) +it)  = int_mb(i_nb(1) + it - 1)  
     >                       + int_mb(nbasis(1)-1 + it)
        int_mb(i_ng(1) +it)  = int_mb(i_ng(1) + it - 1)  
     >                       + int_mb(ngrid(1)-1 + it)
        int_mb(i_ngb(1)+it)  = int_mb(i_ngb(1) + it - 1) 
     >                       + int_mb(nbasis(1)-1 + it)
     >                        *int_mb(ngrid(1)-1 + it)
      end do

      END !SUBROUTINE alloc_paw_basis_data


      SUBROUTINE dealloc_paw_basis_data()

      IMPLICIT NONE
#include "errquit.fh"
#include "paw_ma.fh"
#include "paw_basis_data.fh"

      logical ok

        ok = .true.
        ok = ok .and. my_dealloc(i_start)
        ok = ok .and. my_dealloc(i_end)
        ok = ok .and. my_dealloc(npoints)

        ok = ok .and. my_dealloc(i_ngb)
        ok = ok .and. my_dealloc(i_ng)
        ok = ok .and. my_dealloc(i_nb)
        ok = ok .and. my_dealloc(rgrid)
        ok = ok .and. my_dealloc(prj_ps0)
        ok = ok .and. my_dealloc(v_ps)
        ok = ok .and. my_dealloc(ps_core_density)
        ok = ok .and. my_dealloc(core_density)
        ok = ok .and. my_dealloc(ps_core_density_prime)
        ok = ok .and. my_dealloc(core_density_prime)
        ok = ok .and. my_dealloc(prj_ps)
        ok = ok .and. my_dealloc(phi_ps_prime)
        ok = ok .and. my_dealloc(phi_ps)
        ok = ok .and. my_dealloc(phi_ae_prime)
        ok = ok .and. my_dealloc(phi_ae)
        ok = ok .and. my_dealloc(eig)
        ok = ok .and. my_dealloc(orb_l)
        ok = ok .and. my_dealloc(pr_n)
        ok = ok .and. my_dealloc(pr_n_ps)
        ok = ok .and. my_dealloc(core_kin_energy)
        ok = ok .and. my_dealloc(ion_charge) 
        ok = ok .and. my_dealloc(core_charge) 
        ok = ok .and. my_dealloc(sigma)
        ok = ok .and. my_dealloc(log_amesh)
        ok = ok .and. my_dealloc(rmax)
        ok = ok .and. my_dealloc(r1)
        ok = ok .and. my_dealloc(mult_l)
        ok = ok .and. my_dealloc(ngrid)
        ok = ok .and. my_dealloc(i_cut)
        ok = ok .and. my_dealloc(nbasis)

        if(.not. ok) then
          call errquit("failed to deallocate paw_basis data ",0, MA_ERR)
        end if



      END !SUBROUTINE


c     *********************************
c     *                               *
c     *         paw_radgrid_map       *
c     *                               *
c     *********************************

      subroutine paw_radgrid_map(tot_nr,i_start,i_end)
      implicit none
      integer tot_nr
      integer i_start
      integer i_end

c     *** local variables ***
      integer nr,np,taskid
      real*8  tmp

      call Parallel_np(np)
      call Parallel_taskid(taskid)
      tmp = dble(tot_nr)/dble(np)
      nr = dint(tmp)

      i_start = 1 + taskid*nr

      if (taskid .eq. (np-1)) THEN
        i_end = tot_nr
      else
        i_end = i_start + nr
      end if

      return
      end




!**************************************************
!
!       Name: paw_basis_tot_ntype
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_tot_ntype()
      implicit none

#include "paw_basis_data.fh"

      paw_basis_tot_ntype = tot_ntype
      return
      END 

!**************************************************
!
!       Name: paw_basis_tot_nbasis
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_tot_nbasis()
      implicit none

#include "paw_basis_data.fh"

      paw_basis_tot_nbasis = tot_nbasis
      return
      END 

!**************************************************
!
!       Name: paw_basis_tot_ngrid
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_tot_ngrid()
      implicit none

#include "paw_basis_data.fh"

      paw_basis_tot_ngrid = tot_ngrid
      return
      END
 
!**************************************************
!
!       Name: paw_basis_tot_ngridbasis
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_tot_ngridbasis()
      implicit none

#include "paw_basis_data.fh"
 
      paw_basis_tot_ngridbasis = tot_ngridbasis
      return
      END
 
!**************************************************
!
!       Name: paw_basis_i_nbasis
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_nbasis(it)
      implicit none
      integer it
   
#include "paw_basis_data.fh"


      paw_basis_i_nbasis = nbasis(1) +  it-1
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_nbasis
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
        INTEGER FUNCTION  paw_basis_nbasis(it)
        implicit none
        integer it
     
#include "paw_basis_data.fh"
#include "mafdecls.fh"
  
        paw_basis_nbasis = int_mb(nbasis(1) +  it-1)
        return
        END 
  
!**************************************************
!
!       Name: paw_basis_i_ngrid
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_ngrid(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"

      paw_basis_i_ngrid = ngrid(1) +  it-1
      return
      END
 
!**************************************************
!
!       Name: paw_basis_ngrid
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      integer function paw_basis_ngrid(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_ngrid = int_mb(ngrid(1) +  it-1)
      return
      END
 
!**************************************************
!
!       Name:
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_mult_l(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"


      paw_basis_i_mult_l = mult_l(1) +  it-1
      return
      END 

!**************************************************
!
!       Name:
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_mult_l(it)
      implicit none
      integer it
    
#include "mafdecls.fh"      
#include "paw_basis_data.fh"


      paw_basis_mult_l = int_mb(mult_l(1) +  it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_r1
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_r1(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"

      paw_basis_i_r1 = r1(1) +  it-1
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_rmax
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_rmax(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"


      paw_basis_i_rmax = rmax(1) +  it-1
      return
      END 
!**************************************************
!
!       Name: paw_basis_i_cut
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_cut(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_i_cut = int_mb(i_cut(1) +  it-1)
      return
      END 


!**************************************************
!
!       Name: paw_basis_i_i_cut
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_i_cut(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"

      paw_basis_i_i_cut = i_cut(1) +  it-1
      return
      END 


!**************************************************
!
!       Name: paw_basis_i_i_start
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_i_start(it)
      implicit none
      integer it

#include "paw_basis_data.fh"

      paw_basis_i_i_start = i_start(1) +  it-1
      return
      END

!**************************************************
!
!       Name: paw_basis_i_start
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_start(it)
      implicit none
      integer it

#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_i_start = int_mb(i_start(1) +  it-1)
      return
      END


!**************************************************
!
!       Name: paw_basis_i_i_end
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_i_end(it)
      implicit none
      integer it

#include "paw_basis_data.fh"

      paw_basis_i_i_end = i_end(1) +  it-1
      return
      END


!**************************************************
!
!       Name: paw_basis_i_end
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_end(it)
      implicit none
      integer it

#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_i_end = int_mb(i_end(1) +  it-1)
      return
      END


!**************************************************
!
!       Name: paw_basis_i_npoints
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_npoints(it)
      implicit none
      integer it

#include "paw_basis_data.fh"

      paw_basis_i_npoints = npoints(1) +  it-1
      return
      END


!**************************************************
!
!       Name: paw_basis_npoints
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_npoints(it)
      implicit none
      integer it

#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_npoints = int_mb(npoints(1) +  it-1)
      return
      END



!**************************************************
!
!       Name: paw_basis_i_sigma
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_sigma(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"

      paw_basis_i_sigma = sigma(1) +  it-1
      return
      END 

!**************************************************
!
!       Name: paw_basis_log_amesh
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      double precision FUNCTION  paw_basis_log_amesh(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_log_amesh = dbl_mb(log_amesh(1)+it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_log_amesh
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_log_amesh(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"

      paw_basis_i_log_amesh = log_amesh(1) +  it-1
      return
      END 

!**************************************************
!
!       Name: paw_basis_core_charge
!
!       Purpose
!
!       Created:        8/06/2002
!**************************************************
      subroutine  calc_paw_basis_core_charge(ia,q)
      implicit none
      integer ia
      double precision q

#include "paw_basis_data.fh"
#include "integrate.fh"
#include "paw_basis.fh"
#include "mafdecls.fh"
      
      !*** local variables ***
      real*8 core,fourpi

c      !*** external functions ***
c      integer  paw_basis_i_core_density,paw_basis_i_rgrid
c      integer  paw_basis_i_log_amesh,paw_basis_i_ngrid
c      external paw_basis_i_core_density,paw_basis_i_rgrid
c      external paw_basis_i_log_amesh,paw_basis_i_ngrid

      fourpi = 16.0d0*datan(1.0d0)
      q = fourpi*def_integr(0,
     >                         dbl_mb(paw_basis_i_core_density(ia)),
     >                         2,
     >                         dbl_mb(paw_basis_i_rgrid(ia)),
     >                         dbl_mb(paw_basis_i_log_amesh(ia)),
     >                         int_mb(paw_basis_i_ngrid(ia)))

      return
      end

!**************************************************
!
!       Name: paw_basis_i_core_charge
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_core_charge(it)
      implicit none
      integer it

#include "paw_basis_data.fh"

      paw_basis_i_core_charge = core_charge(1) +  it-1
      return
      END

!**************************************************
!
!       Name: paw_basis_core_charge
!
!       Purpose
!
!       Created:        7/9/2002
!**************************************************
      DOUBLE PRECISION FUNCTION  paw_basis_core_charge(it)
      implicit none
      integer it

#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_core_charge = dbl_mb(core_charge(1) +  it-1)
      return
      END


!**************************************************
!
!       Name: paw_basis_i_ion_charge
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_ion_charge(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"

      paw_basis_i_ion_charge = ion_charge(1) +  it-1
      return
      END 

      
!**************************************************
!
!       Name: paw_basis_ion_charge
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      DOUBLE PRECISION FUNCTION  paw_basis_ion_charge(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_ion_charge = dbl_mb(ion_charge(1) +  it-1)
      return
      END 

      
**************************************************
!
!       Name: paw_basis_sphere_radius
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      real*8 function  paw_basis_sphere_radius(ia)
      implicit none
      integer ia
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      


      !*** external functions ***
      integer  paw_basis_i_rgrid,paw_basis_i_i_cut
      external paw_basis_i_rgrid,paw_basis_i_i_cut

      paw_basis_sphere_radius = dbl_mb(paw_basis_i_rgrid(ia)
     >                                 +int_mb(paw_basis_i_i_cut(ia))-1)
      return
      end 


**************************************************
!
!       Name: paw_basis_sigma
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      real*8 function  paw_basis_sigma(ia)
      implicit none
      integer ia
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      !*** external functions ***
      integer  paw_basis_i_sigma
      external paw_basis_i_sigma 

      paw_basis_sigma = dbl_mb(paw_basis_i_sigma(ia))
      return
      end

**************************************************
!
!       Name: paw_tot_nlm_nbasis
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      integer function  paw_tot_nlm_nbasis()

      implicit none

      integer ia
      integer ii
      integer l
    
#include "paw_geom.fh"

      !*** external functions ***
      integer  paw_nlm_nbasis
      external paw_nlm_nbasis

      paw_tot_nlm_nbasis = 0
      do ia=1,ion_nion()
        paw_tot_nlm_nbasis = paw_tot_nlm_nbasis + paw_nlm_nbasis(ia)
      end do

      return
      end


**************************************************
!
!       Name: paw_nlm_nbasis
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      integer function  paw_nlm_nbasis(ia)

      implicit none

      integer ia
      integer ii
      integer l
    
#include "paw_geom.fh"
#include "mafdecls.fh"      

      !*** external functions ***
      integer  paw_basis_i_orb_l,paw_basis_nbasis
      external paw_basis_i_orb_l,paw_basis_nbasis 

      paw_nlm_nbasis = 0
      do ii=1,paw_basis_nbasis(ia)
         l =  int_mb(paw_basis_i_orb_l(ia)+ii-1)
         paw_nlm_nbasis = paw_nlm_nbasis + 2*l+1
      end do

      return
      end


**************************************************
!
!       Name: paw_basis_n
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      integer function  paw_basis_n(ii,ia)
      implicit none
      integer ii,ia
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      !*** external functions ***
      integer  paw_basis_i_pr_n
      external paw_basis_i_pr_n

      paw_basis_n = int_mb(paw_basis_i_pr_n(ia)+ii-1)
      return
      end
     
**************************************************
!
!       Name: paw_basis_n_ps
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      integer function  paw_basis_n_ps(ii,ia)
      implicit none
      integer ii,ia
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      !*** external functions ***
      integer  paw_basis_i_pr_n_ps
      external paw_basis_i_pr_n_ps 

      paw_basis_n_ps = int_mb(paw_basis_i_pr_n_ps(ia)+ii-1)
      return
      end
     
**************************************************
!
!       Name: paw_basis_orb_l
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      integer function  paw_basis_orb_l(ii,ia)
      implicit none
      integer ii,ia
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      !*** external functions ***
      integer  paw_basis_i_orb_l
      external paw_basis_i_orb_l                                

      paw_basis_orb_l = int_mb(paw_basis_i_orb_l(ia)+ii-1)
      return
      end
     
   
**************************************************
!
!       Name: paw_basis_eig
!
!       Purpose 
!
!       Created:        8/06/2002
!**************************************************
      real*8 function  paw_basis_eig(ii,ia)
      implicit none
      integer ii,ia
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      !*** external functions ***
      integer  paw_basis_i_eig
      external paw_basis_i_eig

      paw_basis_eig = dbl_mb(paw_basis_i_eig(ia)+ii-1)
      return
      end
     

 
!**************************************************
!
!       Name: paw_basis_i_core_kin_energy
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_core_kin_energy(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"

      paw_basis_i_core_kin_energy = core_kin_energy(1) +  it-1
      return
      END 


!**************************************************
!
!       Name: paw_basis_core_kin_energy
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      double precision  FUNCTION  paw_basis_core_kin_energy(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_core_kin_energy = dbl_mb(core_kin_energy(1) +  it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_pr_n
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_pr_n(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_pr_n = pr_n(1) + int_mb(i_nb(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_pr_n_ps
!
!       Purpose 
!
!       Created:        7/9/200
!**************************************************
      INTEGER FUNCTION  paw_basis_i_pr_n_ps(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_pr_n_ps = pr_n_ps(1) + int_mb(i_nb(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_orb_l
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_orb_l(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_orb_l = orb_l(1) + int_mb(i_nb(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_eig
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_eig(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_eig = eig(1) + int_mb(i_nb(1) + it-1)
      return
      END   
  
!**************************************************
!
!       Name: paw_basis_i_core_density
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_core_density(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_core_density = core_density(1) +
     +     int_mb(i_ng(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_ps_core_density
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_ps_core_density(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_ps_core_density = ps_core_density(1) 
     >                      + int_mb(i_ng(1) + it-1)
      return
      END 



!**************************************************
!
!       Name: paw_basis_i_core_density_prime
!
!       Purpose - needed for gga's
!
!       Created:        1/28/2006
!**************************************************
      INTEGER FUNCTION  paw_basis_i_core_density_prime(it)
      implicit none
      integer it

#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_i_core_density_prime = core_density_prime(1)
     >                               + int_mb(i_ng(1)+it-1)
      return
      END

!**************************************************
!
!       Name: paw_basis_i_ps_core_density_prime
!
!       Purpose - needed for gga's
!
!       Created:        1/28/2006
!**************************************************
      INTEGER FUNCTION  paw_basis_i_ps_core_density_prime(it)
      implicit none
      integer it

#include "paw_basis_data.fh"
#include "mafdecls.fh"

      paw_basis_i_ps_core_density_prime = ps_core_density_prime(1)
     >                                  + int_mb(i_ng(1)+ it-1)
      return
      END


!**************************************************
!
!       Name: paw_basis_i_v_ps
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_v_ps(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_v_ps = v_ps(1) + int_mb(i_ng(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_rgrid
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_rgrid(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_rgrid = rgrid(1) + int_mb(i_ng(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_phi_ae
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_phi_ae(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_phi_ae = phi_ae(1) + int_mb(i_ngb(1) + it-1)
      return
      END 


!**************************************************
!
!       Name: paw_basis_i_phi_ps
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_phi_ps(it)
      implicit none
      integer it
    
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_phi_ps = phi_ps(1) + int_mb(i_ngb(1) + it-1)
      return
      END 


!**************************************************
!
!       Name: paw_basis_i_phi_ae_prime
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_phi_ae_prime(it)
      implicit none
      integer it
   
#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_phi_ae_prime = phi_ae_prime(1) + 
     +     int_mb(i_ngb(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_phi_ps_prime
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_phi_ps_prime(it)
      implicit none
      integer it

#include "paw_basis_data.fh"
#include "mafdecls.fh"      

      paw_basis_i_phi_ps_prime = phi_ps_prime(1) + 
     +     int_mb(i_ngb(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_prj_ps
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_prj_ps(it)
      implicit none
      integer it
 
#include "paw_basis_data.fh"
#include "mafdecls.fh"
      
      paw_basis_i_prj_ps = prj_ps(1) + int_mb(i_ngb(1) + it-1)
      return
      END 

!**************************************************
!
!       Name: paw_basis_i_prj_ps0
!
!       Purpose 
!
!       Created:        7/9/2002
!**************************************************
      INTEGER FUNCTION  paw_basis_i_prj_ps0(it)
      implicit none
      integer it
    
#include "mafdecls.fh"      
#include "paw_basis_data.fh"

      paw_basis_i_prj_ps0 = prj_ps0(1) + int_mb(i_ngb(1) + it-1)
      return
      END 

      subroutine set_max_i_cut(ic)
      implicit none
      integer ic
#include "paw_basis_data.fh"

        max_i_cut = ic

       end



      subroutine set_max_mult_l(l)
      implicit none
      integer l
#include "paw_basis_data.fh"

        max_mult_l = l

       end

      integer function paw_basis_max_i_cut()
      implicit none

#include "paw_basis_data.fh"

        paw_basis_max_i_cut= max_i_cut

      end

      integer function paw_basis_max_mult_l()
      implicit none

#include "paw_basis_data.fh"

        paw_basis_max_mult_l= max_mult_l

      end




c     *************************************************
c     *                                               *
c     *        paw_basis_derivative_ngrid             *
c     *                                               *
c     *************************************************
c
c  This routine computes the seven point derivative of f.
c  where f and df are stored on a logarithmic grid. The
c  dimensions of f and df are, f(1:ng), and df(1:ng)

      subroutine paw_basis_derivative_ngrid(ng,log_amesh,r,f,df)
      implicit none
      integer           ng
      double precision  log_amesh
      double precision  r(ng)
      double precision  f(ng)
      double precision df(ng)

      double precision one_over_60
      parameter (one_over_60 = 1.0d0/60.0d0)

      integer i,n1,n2,m1,m2
      double precision aa

      aa = one_over_60/log_amesh
      n1 = 1
      n2 = ng
      m1 = n1
      m2 = n2
     

      if (n1.le.3) then
        if ((n1.eq.1).and.(n1.ge.m1).and.(n1.le.m2)) then
          df(1) = aa*(-147.0d0*f(1)
     >               + 360.0d0*f(2)
     >               - 450.0d0*f(3)
     >               + 400.0d0*f(4)
     >               - 225.0d0*f(5)
     >               +  72.0d0*f(6)
     >               -  10.0d0*f(7))/r(1)
          n1 = n1+1
        end if 
        if ((n1.eq.2).and.(n1.ge.m1).and.(n1.le.m2)) then
          df(2) = aa*( -10.0d0*f(1)
     >               -  77.0d0*f(2)
     >               + 150.0d0*f(3)
     >               - 100.0d0*f(4)
     >               +  50.0d0*f(5)
     >               -  15.0d0*f(6)
     >               +   2.0d0*f(7))/r(2)
          n1 = n1+1
        end if 
        if ((n1.eq.3.and.(n1.ge.m1).and.(n1.le.m2))) then
          df(3) = aa*(  +2.0d0*f(1)
     >               -  24.0d0*f(2)
     >               -  35.0d0*f(3)
     >               +  80.0d0*f(4)
     >               -  30.0d0*f(5)
     >               +   8.0d0*f(6)
     >               -   1.0d0*f(7))/r(3)
          n1 = n1+1
        end if 
      end if

      if (n2.ge.(ng-2)) then
        if ((n2.eq.ng).and.(n2.ge.m1).and.(n2.le.m2)) then
          df(ng) = aa*( +147.0d0*f(ng)
     >                - 360.0d0*f(ng-1)
     >                + 450.0d0*f(ng-2)
     >                - 400.0d0*f(ng-3)
     >                + 225.0d0*f(ng-4)
     >                -  72.0d0*f(ng-5)
     >                +  10.0d0*f(ng-6))/r(ng)
          n2 = n2-1
        end if
        if ((n2.eq.(ng-1).and.(n2.ge.m1).and.(n2.le.m2))) then
          df(ng-1) = aa*( +10.0d0*f(ng)
     >                  +  77.0d0*f(ng-1)
     >                  - 150.0d0*f(ng-2)
     >                  + 100.0d0*f(ng-3)
     >                  -  50.0d0*f(ng-4)
     >                  +  15.0d0*f(ng-5)
     >                  -   2.0d0*f(ng-6))/r(ng-1)
          n2 = n2-1
        end if
        if ((n2.eq.(ng-2).and.(n2.ge.m1).and.(n2.le.m2))) then
          df(ng-2) = aa*(  -2.0d0*f(ng)
     >                  +  24.0d0*f(ng-1)
     >                  +  35.0d0*f(ng-2)
     >                  -  80.0d0*f(ng-3)
     >                  +  30.0d0*f(ng-4)
     >                  -   8.0d0*f(ng-5)
     >                  +   1.0d0*f(ng-6))/r(ng-2)
          n2 = n2-1
        end if
      end if

      do i=n1,n2
        df(i) = aa*(  -1.0d0*f(i-3)
     >             +   9.0d0*f(i-2)
     >             -  45.0d0*f(i-1)
     >             +  45.0d0*f(i+1)
     >             -   9.0d0*f(i+2)
     >             +   1.0d0*f(i+3))/r(i)
      end do

      return
      end
      

c
c $Id: pspw_dplot_input.F 19707 2010-10-29 17:59:36Z d3y133 $
c


*     *****************************************************
*     *                                                   *
*     *                   pspw_dplot_input                *
*     *                                                   *
*     *****************************************************

      subroutine pspw_dplot_input(rtdb)
      implicit none
      integer rtdb
c
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "nwc_const.fh"
c
      integer num_dirs          ! No. of known directives
      parameter (num_dirs = 14)
      character*22 dirs(num_dirs)
      data dirs / 'vectors',
     >            'density',
     >            'orbital',
     >            'position_tolerance',
     >            'elf',
     >            '2d_grid',
     >            '3d_grid',
     >            'origin',
     >            'limitxyz',
     >            'ncell',
     >            'atom_truncate',
     >            '1d_grid',
     >            'orbital2',
     >            'end'/

      integer num_dnames          ! No. of density directives
      parameter (num_dnames = 8)
      character*22 dnames(num_dnames)
      data dnames / 'total',
     >              'diff',
     >              'alpha',
     >              'beta',
     >              'laplacian',
     >              'potential',
     >              'up',
     >              'down' /
      integer num_enames          ! No. of ELF directives
      parameter (num_enames = 5)
      character*22 enames(num_enames)
      data enames / 'restricted',
     >              'up',
     >              'down',
     >              'alpha',
     >              'beta'   /

      logical value
      integer ind               ! Index of matched directive
      integer       number,number2,count,ia
      integer       name1_len,name2_len,name3_len
      character*50  name1,name2,name3
      character*50  filename
      character*50  wavefunction_filename
      character*255 test
      real*8        position_tolerance
      real*8        o(3),x(3),y(3),z(3)
      real*8        sizex(2),sizey(2),sizez(2),scal
      integer       j,jstart,jlast,jstride
      integer       nx,ny,nz,ncell(3),idx(2)
c
c
*     *** initializations ****
      position_tolerance=0.001d0
      call util_file_prefix('movecs',wavefunction_filename)
      ia    = ICHAR('a')
      count = 0
      value = rtdb_put(rtdb,'pspw_dplot:count',mt_int,1,count)
      if (.not.value)
     >     call errquit(
     >     'pspw_dplot_input: rtdb_put failed for count', 0, RTDB_ERR)


 10   if (.not. inp_read()) 
     >     call errquit(
     >           'pspw_dplot_input: inp_read failed', 0, INPUT_ERR)
      if (.not. inp_a(test))
     >     call errquit(
     >           'pspw_dplot_input: failed to read keyword', 0,
     &       INPUT_ERR)
      if (.not. inp_match(num_dirs, .false., test, dirs, ind))
     >     call errquit(
     >           'pspw_dplot_input: unknown directive', 0, INPUT_ERR)


      goto ( 100,  200, 300, 400, 500, 600,700,800,900,1000,1100,1200,
     >       350,
     >      9999) ind
      call errquit(
     >      'pspw_dplot_input: unimplemented directive', ind, INPUT_ERR)


c     
c  vectors
c     
 100  if (.not. inp_a(wavefunction_filename))
     >    call errquit(
     >         'pspw_dplot_input: failed to read vector', 0, INPUT_ERR)
      goto 10

c     
c  density
c     
*     *** read density option ****
 200  if (.not. inp_a(test))
     >   call errquit(
     >       'pspw_dplot_input: failed to read density keyword', 0,
     &       INPUT_ERR)

*     *** density number ****
      if (.not.inp_match(num_dnames,.false.,test,dnames,number))
     >     number = 1
      if (number .eq. 7) number = 3 
      if (number .eq. 8) number = 4 
*     !*** number = 1 - total
*     !*** number = 2 - difference
*     !*** number = 3 - alpha
*     !*** number = 4 - beta
*     !*** number = 5 - laplacian
*     !*** number = 6 - potential
*     !*** number = 7 - ELF

*     **** make density numbers negative ****
      number = -number

*     *** read filename ****
      if (.not. inp_a(filename))
     >    call errquit(
     >         'pspw_dplot_input: failed to read density filename', 0,
     &       INPUT_ERR)

*     **** define name  - not very elegent and could break if ****
*     ****                      count becomes very large      ****
      count = count + 1
      name1 = 'pspw_dplot:filename'//CHAR(count-1+ia)
      name2 = 'pspw_dplot:number'//CHAR(count-1+ia)
      name1_len = index(name1,' ') - 1
      name2_len = index(name2,' ') - 1

      ind = index(filename,' ') - 1
      value = rtdb_cput(rtdb,name1(1:name1_len),1,filename(1:ind))
      value = value.and.rtdb_put(rtdb,name2(1:name2_len),
     >                           mt_int,1,number)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:count',
     >                           mt_int,1,count)
      if (.not.value)
     >     call errquit(
     >     'pspw_dplot_input: rtdb_put failed for density', 0,
     &       RTDB_ERR)

      goto 10


c     
c  orbital
c     
*     *** read orbital number ****
 300  if (.not. inp_i(number))
     >   call errquit(
     >       'pspw_dplot_input: failed to read orbital number', 0,
     &       INPUT_ERR)

*     *** read filename ****
      if (.not. inp_a(filename))
     >    call errquit(
     >         'pspw_dplot_input: failed to read orbital filename', 0,
     &       INPUT_ERR)

*     **** define name  - not very elegent and could break if ****
*     ****                      count becomes very large      ****
      count = count + 1
      name1 = 'pspw_dplot:filename'//CHAR(count-1+ia)
      name2 = 'pspw_dplot:number'//CHAR(count-1+ia)
      name1_len = index(name1,' ') - 1
      name2_len = index(name2,' ') - 1

      ind = index(filename,' ') - 1
      value = rtdb_cput(rtdb,name1(1:name1_len),1,filename(1:ind))
      value = value.and.rtdb_put(rtdb,name2(1:name2_len),
     >                           mt_int,1,number)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:count',
     >                           mt_int,1,count)
      if (.not.value)
     >     call errquit(
     >     'pspw_dplot_input: rtdb_put failed for orbital', 0, RTDB_ERR)

      goto 10


c     
c  orbital2
c     
*     *** read orbital number ****
 350  if (.not. inp_i(number))
     >   call errquit(
     >       'pspw_dplot_input: failed to read orbital number1',0,
     &       INPUT_ERR)
      if (.not. inp_i(number2))
     >   call errquit(
     >       'pspw_dplot_input: failed to read orbital number2',0,
     &       INPUT_ERR)

*     *** read filename ****
      if (.not. inp_a(filename))
     >    call errquit(
     >         'pspw_dplot_input: failed to read orbital2 filename',0,
     &       INPUT_ERR)

*     **** define name  - not very elegent and could break if ****
*     ****                      count becomes very large      ****
      count = count + 1
      name1 = 'pspw_dplot:filename'//CHAR(count-1+ia)
      name2 = 'pspw_dplot:number1'//CHAR(count-1+ia)
      name3 = 'pspw_dplot:number2'//CHAR(count-1+ia)
      name1_len = index(name1,' ') - 1
      name2_len = index(name2,' ') - 1
      name3_len = index(name3,' ') - 1

      ind = index(filename,' ') - 1
      value = rtdb_cput(rtdb,name1(1:name1_len),1,filename(1:ind))
      value = value.and.rtdb_put(rtdb,name2(1:name2_len),
     >                           mt_int,1,number)
      value = value.and.rtdb_put(rtdb,name3(1:name3_len),
     >                           mt_int,1,number2)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:count',
     >                           mt_int,1,count)
      if (.not.value)
     >     call errquit(
     >     'pspw_dplot_input:rtdb_put failed for orbital2',0,RTDB_ERR)

      goto 10

c     
c position_tolerance
c     
*     **** read position_tolerance ****
 400  if (.not. inp_f(position_tolerance))
     >   call errquit(
     >       'pspw_dplot_input: failed to read position tolerance', 0,
     &       INPUT_ERR)

      goto 10

c    
c ELF
c     
 500  if (.not. inp_a(test))
     >   call errquit(
     >       'pspw_dplot_input: failed to read ELF keyword', 0,
     &       INPUT_ERR)

*     *** ELF number ****
      if (.not.inp_match(num_enames,.false.,test,enames,number))
     >     number = -7
      if (number .eq. 1) number = -7 
      if (number .eq. 2) number = -7
      if (number .eq. 3) number = -8
      if (number .eq. 4) number = -7
      if (number .eq. 5) number = -8
*     !*** number = -7 - ELF up
*     !*** number = -8 - ELF down

*      *** read ELF filename ****  
      if (.not. inp_a(filename))
     >   filename = test

*     **** define name  - not very elegent and could break if ****
*     ****                      count becomes very large      ****
      count = count + 1
      name1 = 'pspw_dplot:filename'//CHAR(count-1+ia)
      name2 = 'pspw_dplot:number'//CHAR(count-1+ia)
      name1_len = index(name1,' ') - 1
      name2_len = index(name2,' ') - 1

      ind = index(filename,' ') - 1
      value = rtdb_cput(rtdb,name1(1:name1_len),1,filename(1:ind))
      value = value.and.rtdb_put(rtdb,name2(1:name2_len),
     >                           mt_int,1,number)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:count',
     >                           mt_int,1,count)
      if (.not.value)
     >     call errquit(
     >     'pspw_dplot_input: rtdb_put failed for ELF', 0, RTDB_ERR)


      goto 10

c     
c 2d_grid
c     
*     **** read o,x,sizex,y,sizey ****
 600  value =            inp_read()
      value =  value.and.inp_f(o(1))
      value =  value.and.inp_f(o(2))
      value =  value.and.inp_f(o(3))

      value =  value.and.inp_read()
      value =  value.and.inp_f(x(1))
      value =  value.and.inp_f(x(2))
      value =  value.and.inp_f(x(3))
      value =  value.and.inp_f(sizex(1))
      value =  value.and.inp_f(sizex(2))

      value =  value.and.inp_read()
      value =  value.and.inp_f(y(1))
      value =  value.and.inp_f(y(2))
      value =  value.and.inp_f(y(3))
      value =  value.and.inp_f(sizey(1))
      value =  value.and.inp_f(sizey(2))
      

      value = value.and.rtdb_put(rtdb,'pspw_dplot:2d_grid:o',
     >                           mt_dbl,3,o)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:2d_grid:x',
     >                           mt_dbl,3,x)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:2d_grid:y',
     >                           mt_dbl,3,y)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:2d_grid:sizex',
     >                  mt_dbl,2,sizex)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:2d_grid:sizey',
     >                  mt_dbl,2,sizey)

      if (.not. value)
     >   call errquit(
     >    'pspw_dplot_input: 2d_grid failed to read', 0, RTDB_ERR)

      goto 10

c     
c 3d_grid
c     
*     **** read o,x,sizex,y,sizey,y,sizez ****
 700  value =            inp_read()
      value =  value.and.inp_f(o(1))
      value =  value.and.inp_f(o(2))
      value =  value.and.inp_f(o(3))

      value =  value.and.inp_read()
      value =  value.and.inp_f(x(1))
      value =  value.and.inp_f(x(2))
      value =  value.and.inp_f(x(3))
      value =  value.and.inp_f(sizex(1))
      value =  value.and.inp_f(sizex(2))
      value =  value.and.inp_i(nx)

      value =  value.and.inp_read()
      value =  value.and.inp_f(y(1))
      value =  value.and.inp_f(y(2))
      value =  value.and.inp_f(y(3))
      value =  value.and.inp_f(sizey(1))
      value =  value.and.inp_f(sizey(2))
      value =  value.and.inp_i(ny)

      value =  value.and.inp_read()
      value =  value.and.inp_f(z(1))
      value =  value.and.inp_f(z(2))
      value =  value.and.inp_f(z(3))
      value =  value.and.inp_f(sizez(1))
      value =  value.and.inp_f(sizez(2))
      value =  value.and.inp_i(nz)

      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:o',
     >                           mt_dbl,3,o)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:x',
     >                           mt_dbl,3,x)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:y',
     >                           mt_dbl,3,y)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:z',
     >                           mt_dbl,3,z)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:sizex',
     >                  mt_dbl,2,sizex)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:sizey',
     >                  mt_dbl,2,sizey)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:sizez',
     >                  mt_dbl,2,sizez)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:nx',
     >                  mt_int,1,nx)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:ny',
     >                  mt_int,1,ny)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:nz',
     >                  mt_int,1,nz)

      if (.not. value)
     >   call errquit(
     >    'pspw_dplot_input: 3d_grid failed to read', 0, RTDB_ERR)

      goto 10


c
c translate_origin
c
 800  value =            inp_f(o(1))
      value =  value.and.inp_f(o(2))
      value =  value.and.inp_f(o(3))

      value = value.and.rtdb_put(rtdb,'pspw_dplot:origin',
     >                           mt_dbl,3,o)

      if (.not. value)
     >   call errquit(
     >    'pspw_dplot_input: translate_origin failed to read',0,0)

      goto 10


c
c limitxyz
c
*     **** read o,x,sizex,y,sizey,y,sizez ****
 900  call get_scalefrominput(scal)

      value =  value.and.inp_read()
      value =  value.and.inp_f(sizex(1))
      value =  value.and.inp_f(sizex(2))
      value =  value.and.inp_i(nx)
      sizex(1) = scal*sizex(1)
      sizex(2) = scal*sizex(2)

      value =  value.and.inp_read()
      value =  value.and.inp_f(sizey(1))
      value =  value.and.inp_f(sizey(2))
      value =  value.and.inp_i(ny)
      sizey(1) = scal*sizey(1)
      sizey(2) = scal*sizey(2)

      value =  value.and.inp_read()
      value =  value.and.inp_f(sizez(1))
      value =  value.and.inp_f(sizez(2))
      value =  value.and.inp_i(nz)
      sizez(1) = scal*sizez(1)
      sizez(2) = scal*sizez(2)

      !*** set origin and axes ***
      o(1) = 0.0d0
      o(2) = 0.0d0
      o(3) = 0.0d0

      x(1) = 1.0d0
      x(2) = 0.0d0
      x(3) = 0.0d0

      y(1) = 0.0d0
      y(2) = 1.0d0
      y(3) = 0.0d0

      z(1) = 0.0d0
      z(2) = 0.0d0
      z(3) = 1.0d0

      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:o',
     >                           mt_dbl,3,o)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:x',
     >                           mt_dbl,3,x)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:y',
     >                           mt_dbl,3,y)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:3d_grid:z',
     >                           mt_dbl,3,z)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:sizex',
     >                  mt_dbl,2,sizex)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:sizey',
     >                  mt_dbl,2,sizey)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:sizez',
     >                  mt_dbl,2,sizez)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:nx',
     >                  mt_int,1,nx)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:ny',
     >                  mt_int,1,ny)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:3d_grid:nz',
     >                  mt_int,1,nz)

      if (.not. value)
     >   call errquit(
     >  'pspw_dplot_input: failed to write limitxyz',0,RTDB_ERR)

      goto 10


c
c ncell
c
 1000 if (.not.inp_i(ncell(1))) ncell(1) = 0
      if (.not.inp_i(ncell(2))) ncell(2) = 0
      if (.not.inp_i(ncell(3))) ncell(3) = 0
      if (.not.rtdb_put(rtdb,'pspw_dplot:ncell',mt_int,3,ncell))
     >   call errquit(
     >  'pspw_dplot_input: failed to write ncell',0,RTDB_ERR)

      goto 10

c
c atom_truncate
c
 1100 if (.not.MA_push_get(mt_int,nw_max_atom,'idx',idx(2),idx(1)))
     >   call errquit(
     >   'pspw_dplot_input:failed allocating idx',0,MA_ERR)

      nx = 0
      do while (inp_irange(jstart,jlast,jstride))
         do j=jstart,jlast,jstride
          int_mb(idx(1)+nx) = j
          nx = nx+1
         end do
      end do
      if (.not.rtdb_put(rtdb,'pspw_dplot:atom_truncate_size',
     >                  mt_int,1,nx))
     >  call errquit('pspw_dplot_input:failed write atom_truncate_size',
     >                0,RTDB_ERR)
      if (.not.rtdb_put(rtdb,'pspw_dplot:atom_truncate',
     >                  mt_int,nx,int_mb(idx(1))))
     >   call errquit('pspw_dplot_input:failed writing atom_truncate',
     >                0,RTDB_ERR)
      if (.not.MA_pop_stack(idx(2)))
     >   call errquit('pspw_dplot_input:failed deallocating idx',
     >                 0,MA_ERR)

      goto 10

c     
c 1d_grid
c     
*     **** read o,x,sizex,y,sizey ****
 1200 value =            inp_read()
      value =  value.and.inp_i(nx)

      value =  value.and.inp_read()
      value =  value.and.inp_f(o(1))
      value =  value.and.inp_f(o(2))
      value =  value.and.inp_f(o(3))

      value =  value.and.inp_read()
      value =  value.and.inp_f(x(1))
      value =  value.and.inp_f(x(2))
      value =  value.and.inp_f(x(3))


      value = value.and.rtdb_put(rtdb,'pspw_dplot:1d_grid:o',
     >                           mt_dbl,3,o)
      value = value.and.rtdb_put(rtdb,'pspw_dplot:1d_grid:x',
     >                           mt_dbl,3,x)
      value = value.and.
     >        rtdb_put(rtdb,'pspw_dplot:1d_grid:nx',
     >                  mt_int,1,nx)


      goto 10


 9999 continue

      ind = index(wavefunction_filename,' ') - 1
      value = rtdb_cput(rtdb,'pspw_dplot:wavefunction_filename',
     >                    1,wavefunction_filename(1:ind))
      value = value.and.
     >         rtdb_put(rtdb,'pspw_dplot:position_tolerance',
     >                  mt_dbl,1,position_tolerance)
      if (.not.value)
     >     call errquit(
     >     'pspw_dplot_input: rtdb_put failed for vector', 0, RTDB_ERR)

      return
      end

*> \brief \b ZUNG2R
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download ZUNG2R + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/zung2r.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/zung2r.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/zung2r.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE ZUNG2R( M, N, K, A, LDA, TAU, WORK, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, K, LDA, M, N
*       ..
*       .. Array Arguments ..
*       COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ZUNG2R generates an m by n complex matrix Q with orthonormal columns,
*> which is defined as the first n columns of a product of k elementary
*> reflectors of order m
*>
*>       Q  =  H(1) H(2) . . . H(k)
*>
*> as returned by ZGEQRF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix Q. M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix Q. M >= N >= 0.
*> \endverbatim
*>
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>          The number of elementary reflectors whose product defines the
*>          matrix Q. N >= K >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX*16 array, dimension (LDA,N)
*>          On entry, the i-th column must contain the vector which
*>          defines the elementary reflector H(i), for i = 1,2,...,k, as
*>          returned by ZGEQRF in the first k columns of its array
*>          argument A.
*>          On exit, the m by n matrix Q.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The first dimension of the array A. LDA >= max(1,M).
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is COMPLEX*16 array, dimension (K)
*>          TAU(i) must contain the scalar factor of the elementary
*>          reflector H(i), as returned by ZGEQRF.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX*16 array, dimension (N)
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0: successful exit
*>          < 0: if INFO = -i, the i-th argument has an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup complex16OTHERcomputational
*
*  =====================================================================
      SUBROUTINE ZUNG2R( M, N, K, A, LDA, TAU, WORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.0) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, J, L
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLARF, ZSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 .OR. N.GT.M ) THEN
         INFO = -2
      ELSE IF( K.LT.0 .OR. K.GT.N ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZUNG2R', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Initialise columns k+1:n to columns of the unit matrix
*
      DO 20 J = K + 1, N
         DO 10 L = 1, M
            A( L, J ) = ZERO
   10    CONTINUE
         A( J, J ) = ONE
   20 CONTINUE
*
      DO 40 I = K, 1, -1
*
*        Apply H(i) to A(i:m,i:n) from the left
*
         IF( I.LT.N ) THEN
            A( I, I ) = ONE
            CALL ZLARF( 'Left', M-I+1, N-I, A( I, I ), 1, TAU( I ),
     $                  A( I, I+1 ), LDA, WORK )
         END IF
         IF( I.LT.M )
     $      CALL ZSCAL( M-I, -TAU( I ), A( I+1, I ), 1 )
         A( I, I ) = ONE - TAU( I )
*
*        Set A(1:i-1,i) to zero
*
         DO 30 L = 1, I - 1
            A( L, I ) = ZERO
   30    CONTINUE
   40 CONTINUE
      RETURN
*
*     End of ZUNG2R
*
      END
c $Id: zung2r.f 24343 2013-06-22 05:35:15Z d3y133 $

*
* $Id: cgmontecarlov1.F 25933 2014-07-23 16:50:45Z bylaska $
*

***********************************************************************
*                      cgmontecarlov1                                 *
*                                                                     *
*     This is a developing NVT and NPT Monte-Carlo code for NWCHEM    *
*                                                                     *
***********************************************************************

      logical function cgmontecarlov1(rtdb,flag)
      implicit none
      integer rtdb
      integer flag

#include "global.fh"
#include "errquit.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "geom.fh"
#include "stdio.fh"

#include "nwpw_timing.fh"

*     *** local variables and parameters ****
      double precision kb
      parameter (kb=3.16679d-6)
      real*8 autoatm
      parameter (autoatm =290.360032539d6)

      
*     **** parallel variables ****
      integer  taskid,np,np_i,np_j
      integer  MASTER
      parameter(MASTER=0)

*     **** timing variables ****
      real*8   cpu1,cpu2,cpu3,cpu4
      real*8   t1,t2,t3,t4,av

*     **** lattice variables ****
      integer ngrid(3)
      real*8  a,b,c,alpha,beta,gamma,mc_beta
    

*     ***** energy variables ****
      integer ms,ispin
      real*8  E(40),en(2)
      real*8  dipole(3)
      real*8  stress(3,3),lstress(6)

*     **** gradient variables ****
      integer fion(2)

*     **** error variables ****
      logical value,newpsi
      integer ierr

*     **** local variables ****
      logical verlet,mulliken,SA,calc_pressure,change_volume
      logical oprint,lprint,hprint,qmmm,found,notfirststep,found_bak
      real*8  gx,gy,gz,cx,cy,cz,ddx,c0,c1,c2,dA,ddv,v0,v1,v2
      real*8  vgx,vgy,vgz,vcx,vcy,vcz,ekg,eki0,eki1,dt
      real*8  sum,w,emotion_time_shift,wa,wr,wa_r,wr_r,wa_v,wr_v
      real*8  EV,EV0,pi,esum1,esum2,eave,evar,E25,E26
      real*8  mc_unita1(3,3),mc_unita2(3,3)
      real*8  mc_dr,mc_dV,mc_atom_direction(3)
      real*8  ratio,ratio_v,ratio_r,aratio,omega1,omega2
      real*8  omega_all,omega_all2,omega_ave,omega_var
      real*8  icharge,cv
      real*8  sa_alpha(2),sa_decay(2),tt1,tt2,ssr,r,p1,p2,pressure
      real*8 Te_new,Tr_new,Te_init,Tr_init,mc_temperature,mc_pressure
      integer i,k,ia,nion,minimizer,mapping,icount
      integer nbq,mapping1d,it_in,it_out,seed
      integer mc_algorithm
      integer mc_napply,mc_ngroups,mc_group_size
      integer mc_group_start(2),mc_group_end(2),mc_group(2)
      integer vcount,geom1,frac1(2),nion1

      character*50 filename
      character*255 full_filename,full_bak


*     **** external functions ****
      real*8      psp_zv,psp_rc,ewald_rcut
      real*8      ewald_mandelung
      real*8      lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      real*8      lattice_unitg,ion_amass
      integer     ewald_ncut,ewald_nshl3d
      integer     psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      integer     psp_nprj,psp_psp_type
      character*4 ion_atom,ion_aname
      external    psp_zv,psp_rc,ewald_rcut
      external    ewald_mandelung
      external    lattice_omega,lattice_unita,lattice_ecut,lattice_wcut
      external    lattice_unitg,ion_amass
      external    ewald_ncut,ewald_nshl3d
      external    psp_lmmax,psp_lmax,psp_locp,ion_nkatm
      external    psp_nprj,psp_psp_type
      external    ion_atom,ion_aname
      
      external      psp_comment
      character*255 psp_comment,comment

      real*8   control_tole,control_tolc,control_tolr,ion_rion,ion_vion
      external control_tole,control_tolc,control_tolr,ion_rion,ion_vion
      real*8   control_time_step,control_fake_mass,control_bo_fake_mass
      external control_time_step,control_fake_mass,control_bo_fake_mass
      logical  control_read,control_move,ion_init,control_out_of_time
      external control_read,control_move,ion_init,control_out_of_time
      logical  control_translation,control_rotation,control_parallel_io
      external control_translation,control_rotation,control_parallel_io
      integer  pack_nwave_all
      integer  control_it_in,control_it_out,control_gga,control_version
      integer  control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      integer  pspw_charge_nion
      external pack_nwave_all
      external control_it_in,control_it_out,control_gga,control_version
      external control_ngrid,pack_nwave,ion_nion,ion_natm,ion_katm
      external pspw_charge_nion

      character*12 control_boundry
      external     control_boundry
      character*50 control_cell_name
      external     control_cell_name

      logical      psp_semicore
      real*8       psp_rcore,psp_ncore,psp_rlocal
      external     psp_semicore
      external     psp_rcore,psp_ncore,psp_rlocal

      logical  psi_initialize, psi_finalize
      integer  psi_ispin,psi_ne,electron_count,linesearch_count
      external psi_initialize, psi_finalize
      external psi_ispin,psi_ne,electron_count,linesearch_count
      real*8   cgsd_energy,cgsd_noit_energy
      external cgsd_energy,cgsd_noit_energy
      logical  control_Mulliken,control_DOS
      external control_Mulliken,control_DOS
      real*8   ion_TotalCharge
      external ion_TotalCharge
      logical  control_check_charge_multiplicity
      external control_check_charge_multiplicity
      logical   pspw_charge_found,ion_q_FixIon,ion_q_zFixIon
      external  pspw_charge_found,ion_q_FixIon,ion_q_zFixIon
      integer  control_minimizer,control_scf_algorithm
      external control_minimizer,control_scf_algorithm
      integer  control_ks_algorithm
      external control_ks_algorithm
      real*8   control_ks_alpha,control_kerker_g0
      external control_ks_alpha,control_kerker_g0
      logical  control_print,control_balance
      external control_print,control_balance
      integer  control_mapping,control_mapping1d,control_np_orbital
      external control_mapping,control_mapping1d,control_np_orbital
      integer  control_ks_maxit_orb,control_ks_maxit_orbs
      external control_ks_maxit_orb,control_ks_maxit_orbs

      logical  pspw_bqext,control_Fei
      external pspw_bqext,control_Fei

      integer  control_bo_steps_in,control_bo_steps_out
      integer  control_bo_algorithm,control_mc_seed,control_mc_algorithm
      real*8   control_mc_step_size,control_rti,ion_ke,ion_Temperature
      external control_bo_steps_in,control_bo_steps_out 
      external control_bo_algorithm,control_mc_seed,control_mc_algorithm
      external control_mc_step_size,control_rti,ion_ke,ion_Temperature
      real*8   control_mc_aratio,control_mc_Temperature,control_mc_ddx
      external control_mc_aratio,control_mc_Temperature,control_mc_ddx
      real*8   control_mc_ddv,control_mc_volume_step
      external control_mc_ddv,control_mc_volume_step
      real*8   control_mc_pressure
      external control_mc_pressure
      logical  control_SA,control_pressure
      external control_SA,control_pressure
      real*8   control_SA_decay
      external control_SA_decay
      integer  ion_nconstraints,ion_ndof,ion_rion_ptr
      external ion_nconstraints,ion_ndof,ion_rion_ptr


*                            |************|
*****************************|  PROLOGUE  |****************************
*                            |************|

      value = .true.
      pi = 4.0d0*datan(1.0d0)

      call nwpw_timing_init()
      call dcopy(30,0.0d0,0,E,1)


*     **** get parallel variables ****
      call Parallel_Init()
      call Parallel_np(np)
      call Parallel_taskid(taskid)

      value = control_read(11,rtdb)
      if (.not. value) 
     > call errquit('error reading control',0, INPUT_ERR)

      call Parallel2d_Init(control_np_orbital())
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

      oprint= ((taskid.eq.MASTER).and.control_print(print_medium))
      lprint= ((taskid.eq.MASTER).and.control_print(print_low))
      hprint= ((taskid.eq.MASTER).and.control_print(print_high))


      if (oprint) call current_second(cpu1)

*     ***** print out header ****
      if (oprint) then
         write(luout,1000)
         write(luout,1010)
         write(luout,1020)
         write(luout,1010)
         write(luout,1030)
         write(luout,1010)
         write(luout,1035)
         write(luout,1010)
         write(luout,1040)
         write(luout,1010)
         write(luout,1041)
         write(luout,1010)
         write(luout,1000)
         call nwpw_message(1)
         write(luout,1110)
      end if
      
      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      minimizer = control_minimizer()
      mapping   = control_mapping()

*     **** initialize psi_data ****
      call psi_data_init(100)


*     **** initialize a bunch of stuff ***
      call cgmontecarlo_start(rtdb,newpsi)

*     **** initialize DFT+U ****
      call psp_U_init()

*     **** initialize metadynamics ****
      call meta_initialize(rtdb)


*     **** initialize pressure ****
      calc_pressure = control_pressure().and.(control_version().eq.3)
      pressure      = 0.0d0
      p1            = 0.0d0
      p2            = 0.0d0

*     **** initialize linesearching ****
      call linesearch_init()


*     ******************************
*     **** scaling ion velocity ****
*     ******************************
      call ion_init_ke(ekg,eki0,eki1)


*     **** Initialize simulated annealing ****
      SA       = .false.
      Tr_init  = 0.0d0
      sa_alpha(2) = 1.0d0
      if (control_SA()) then
         dt = 1.0d0
         SA          = .false.
         sa_decay(2) = control_SA_decay(2)
         sa_alpha(2) = dexp( -(dt/control_SA_decay(2)) )
      end if



*     **** Initialize Monte-Carlo Parameters ****
      mc_dr  = control_mc_step_size()
      mc_dV  = control_mc_volume_step()
      mc_algorithm  = control_mc_algorithm()
      call control_mc_atom_direction(mc_atom_direction)
      call control_mc_ngroups(mc_napply,mc_ngroups,mc_group_size)
      if (mc_ngroups.lt.1) then
      
         value = MA_alloc_get(mt_int,1,
     >                    'mc_group_start',
     >                     mc_group_start(2),
     >                     mc_group_start(1))
         value = value.and.MA_alloc_get(mt_int,1,
     >                    'mc_group_end',
     >                     mc_group_end(2),
     >                     mc_group_end(1))
         value = value.and.MA_alloc_get(mt_int,1,
     >                    'mc_group',
     >                     mc_group(2),
     >                     mc_group(1))
         if (.not.value) 
     >     call errquit('cgmontecarlov1:out of heap memory',0,MA_ERR)
      else
         value = MA_alloc_get(mt_int,mc_ngroups,
     >                    'mc_group_start',
     >                     mc_group_start(2),
     >                     mc_group_start(1))
         value = value.and.MA_alloc_get(mt_int,mc_ngroups,
     >                    'mc_group_end',
     >                     mc_group_end(2),
     >                     mc_group_end(1))
         value = value.and.MA_alloc_get(mt_int,mc_group_size,
     >                    'mc_group',
     >                     mc_group(2),
     >                     mc_group(1))
         if (.not.value) 
     >      call errquit('cgmontecarlov1:out of heap memory',1,MA_ERR)
         call control_mc_groups(int_mb(mc_group_start(1)),
     >                          int_mb(mc_group_end(1)),
     >                          int_mb(mc_group(1)))
      end if


      seed           = control_mc_seed()
      mc_temperature = control_mc_Temperature()
      mc_pressure    = control_mc_pressure()
      mc_beta = util_random(control_mc_seed()) !**seed the random number generator
      mc_beta = 1.0d0/(kb*mc_temperature)

      aratio      = control_mc_aratio()

      ddx = control_mc_ddx()
      dA  = 1.0d0/(aratio*aratio-aratio)
      c0  = 1.0d0-ddx
      c1  = (aratio*aratio*(2*ddx) - (ddx))*dA
      c2  = (-aratio      *(2*ddx) + (ddx))*dA

      if (mc_algorithm.eq.2) then
         ddv = control_mc_ddv()
         v0  = 1.0d0-ddv
         v1  = (aratio*aratio*(2*ddv) - (ddv))*dA
         v2  = (-aratio      *(2*ddv) + (ddv))*dA
      end if




*                |**************************|
******************   summary of input data  **********************
*                |**************************|
      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)
      mulliken = control_Mulliken()


      if (oprint) then
         write(luout,1111) np
         write(luout,1117) np_i,np_j
         if (mapping.eq.1) write(luout,1112) 
         if (mapping.eq.2) write(luout,1113) 
         if (mapping.eq.3) write(luout,1118) 
         if (control_balance()) then
           write(luout,1114)
         else
           write(luout,1116)
         end if
         write(luout,1115)
         if (control_parallel_io()) then
           write(luout,1123)
         else
           write(luout,1124)
         end if

         write(luout,1121) control_boundry(),control_version()
         if (psi_ispin().eq.1) write(luout,1130) "restricted"
         if (psi_ispin().eq.2) write(luout,1130) "unrestricted"
         !if (qmmm) write(luout,1122)
         IF (control_gga().eq.-1) THEN
            write(luout,1131) 'off'
         ELSE IF (control_gga().eq.0) THEN
            write(luout,1131) 'LDA (Vosko et al) parameterization'
         ELSE IF (control_gga().eq.10) THEN
            write(luout,1131) 
     >      'PBE96 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.11) THEN
            write(luout,1131) 
     >      'BLYP (White and Bird) parameterization'
         ELSE IF (control_gga().eq.12) THEN
            write(luout,1131) 
     >      'revPBE (White and Bird) parameterization'
         ELSE IF (control_gga().eq.13) THEN
            write(luout,1131) 
     >      'PBEsol (White and Bird) parameterization'

         ELSE IF (control_gga().eq.110) THEN
            write(luout,1131) 
     >      'PBE0 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.112) THEN
            write(luout,1131) 
     >      'revPBE0 (White and Bird) parameterization'
         ELSE IF (control_gga().eq.113) THEN
            write(luout,1131) 
     >      'BNL (White and Bird) parameterization'
         ELSE IF (control_gga().eq.114) THEN
            write(luout,1131) 
     >      'HSE (White and Bird) parameterization'
         ELSE IF (control_gga().eq.115) THEN
            write(luout,1131) 
     >      'B3LYP (White and Bird) parameterization'

         ELSE IF (control_gga().eq.200) THEN
            write(luout,1131) 'Hartree-Fock'
         ELSE
            write(luout,1131) 'unknown parameterization'
            call errquit('bad exchange_correlation',0, INPUT_ERR)
         END IF
         call pspw_print_SIC(luout)
         call pspw_print_HFX(luout)
         write(luout,1140)
         do ia = 1,ion_nkatm()
            call psp_print(ia)
         end do

         icharge = -(psi_ne(1)+psi_ne(psi_ispin()))
         en(1)     = psi_ne(1)
         en(psi_ispin()) = psi_ne(psi_ispin())

         icharge = icharge + ion_TotalCharge()
         write(luout,1159) icharge
         write(luout,1160)
         write(luout,1170) (ion_atom(K),ion_natm(K),K=1,ion_nkatm())
         !if (hprint) then
         write(luout,1180)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(K,I),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz

         call pspw_charge_Print(luout)

         write(luout,1181)
         write(luout,1192) (I,ion_aname(I),
     >                  (ion_vion(K,I),K=1,3),I=1,ion_nion())
         write(luout,1200) vcx,vcy,vcz
         write(luout,1210) vgx,vgy,vgz
         write(luout,1211) ion_nconstraints(),ion_ndof()

         !end if

         !write(6,1220) psi_ne(1),psi_ne(psi_ispin()),' (Fourier space)'
c         if (fractional) then
c          write(6,1219) en(1),en(psi_ispin()),' (   fractional)'
c          write(6,1221) psi_ne(1),psi_ne(psi_ispin()),' (Fourier space)'
c         else
          write(luout,1220) psi_ne(1),psi_ne(psi_ispin()),
     >                      ' (Fourier space)'
          write(luout,1221) psi_ne(1),psi_ne(psi_ispin()),
     >                      ' (Fourier space)'
c         end if
         write(luout,1230)
         write(luout,1233) control_cell_name()
         write(luout,1241) lattice_unita(1,1),
     >                 lattice_unita(2,1),
     >                 lattice_unita(3,1)
         write(luout,1242) lattice_unita(1,2),
     >                 lattice_unita(2,2),
     >                 lattice_unita(3,2)
         write(luout,1243) lattice_unita(1,3),
     >                 lattice_unita(2,3),
     >                 lattice_unita(3,3)
         write(luout,1244) lattice_unitg(1,1),
     >                 lattice_unitg(2,1),
     >                 lattice_unitg(3,1)
         write(luout,1245) lattice_unitg(1,2),
     >                 lattice_unitg(2,2),
     >                 lattice_unitg(3,2)
         write(luout,1246) lattice_unitg(1,3),
     >                 lattice_unitg(2,3),
     >                 lattice_unitg(3,3)
         call lattice_abc_abg(a,b,c,alpha,beta,gamma)
         write(luout,1232) a,b,c,alpha,beta,gamma
         write(luout,1231) lattice_omega()
         write(luout,1250) lattice_ecut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(0),pack_nwave(0)
         write(luout,1251) lattice_wcut(),ngrid(1),ngrid(2),ngrid(3),
     >                 pack_nwave_all(1),pack_nwave(1)
         if (control_version().eq.3) then
         write(luout,1260) ewald_rcut(),ewald_ncut()
         write(luout,1261) ewald_mandelung()
         end if

         write(luout,1270)
         write(luout,1280) control_time_step(),control_fake_mass()
         write(luout,1290) control_tole(),control_tolc()
         write(luout,1281) control_it_in()*control_it_out(),
     >                 control_it_in(),control_it_out()
         if ((minimizer.eq.5).or.(minimizer.eq.8)) then
           write(luout,1291)
           if (control_ks_algorithm().eq.0) 
     >       write(luout,1292) "conjugate gradient"
           if (control_ks_algorithm().eq.1) 
     >       write(luout,1292) "rmm-diis"
           write(luout,1295) control_ks_maxit_orb(),
     >                       control_ks_maxit_orbs()
           if (control_scf_algorithm().eq.0) 
     >       write(luout,1293) "simple mixing"
           if (control_scf_algorithm().eq.1) 
     >       write(luout,1293) "Anderson potential mixing"
           if (control_scf_algorithm().eq.2) 
     >       write(luout,1293) "Johnson-Pulay mixing"
           if (control_scf_algorithm().eq.3) 
     >       write(luout,1293) "Anderson density mixing"
           write(luout,1294) control_ks_alpha()
           write(luout,1301) control_kerker_g0()
         end if
         write(luout,1310)
         if (.not.control_translation()) write(luout,1271)
         if (.not.control_rotation())    write(luout,1272)
         if (mc_algorithm.eq.0) then
            write(luout,1311) 'NVE Microcanonical Ensemble - ',
     >                        'HyperVolume Monte Carlo Algorithm'
         else if (mc_algorithm.eq.1) then
            write(luout,1311) 'NVT Canonical Ensemble - ',
     >                        'Metropolis Algorithm'
         else if (mc_algorithm.eq.2) then
            write(luout,1311) 'NPT Canonical Ensemble - ',
     >                        'Metropolis Algorithm'
         end if
         
         write(luout,1320) mc_dr,
     >    control_bo_steps_in()*control_bo_steps_out(),
     >    control_bo_steps_in(),control_bo_steps_out() 

         write(luout,1322) mc_temperature,mc_beta,seed
         if (mc_algorithm.eq.2) 
     >      write(luout,1326) mc_pressure,mc_pressure*autoatm,
     >                        ddv,v0,v1,v2
         write(luout,1323) aratio,ddx,c0,c1,c2
         write(luout,1324) mc_napply,mc_atom_direction
         write(luout,1325) mc_ngroups

         write(luout,1340) control_rti()
         write(luout,1222) eki0,ekg
         write(luout,1223) eki1
         write(luout,1224) (eki1-eki0)

c         write(luout,1394)
       
        if (calc_pressure) write(luout,1393)
         if (control_SA()) then
           write(luout,1396) sa_decay(2)
         end if
         if (mulliken) write(luout,1399)
         write(luout,1300)
         call util_flush(luout)
      end if

*                |***************************|
******************  simple Monte-Carlo loop  **********************
*                |***************************|
      if (taskid.eq.MASTER) call current_second(cpu2)
      if ((taskid.eq.MASTER).and.(.not.calc_pressure))  then
         if (mc_algorithm.lt.2) then
            call nwpw_message(12)
         else
            call nwpw_message(13)
         end if
      end if

      if ((taskid.eq.MASTER).and.(calc_pressure)) 
     >   call nwpw_message(11)


*     **** write initial position to xyz data ****
      call xyz_init()          ! unit=18
      call MOTION_init(rtdb)   ! unit=19


*     *** fei io ****
      call fei_init(rtdb)

*     **** ecce print ****
      call ecce_print_module_entry('task pspw Monte-Carlo')
      !call ecce_print_module_entry('driver')
      call movecs_ecce_print_off()



*     ************************************
*     **** open up other MOTION files ****
*     ************************************
*     **** open EMOTION file ****
      E25 = 0.0d0
      E26 = 0.0d0
      omega_all  = 0.0d0
      omega_all2 = 0.0d0
      wa  = 0.0d0
      wr  = 0.0d0
      wa_r  = 0.0d0
      wr_r  = 0.0d0
      wa_v  = 0.0d0
      wr_v  = 0.0d0
      if (.not.rtdb_cget(rtdb,'nwpw:emotion_filename',1,filename))
     >  call util_file_prefix('emotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER) then

*        **** check for backup file ****
         call util_file_name_noprefix('EMOTION99-bak',.false.,
     >                                .false.,
     >                                full_bak)
         inquire(file=full_bak,exist=found_bak)
         if (found_bak) then
            write(*,*)
            write(*,*) "EMOTION99-bak exists:"
            i=index(full_bak,' ')
            k=index(full_filename,' ')
            write(*,*) "   Copying ",full_bak(1:i),
     >                 " to ",full_filename(1:k)
            write(*,*)
            call util_file_copy(full_bak,full_filename)
         end if

         emotion_time_shift = 0.0d0
         inquire(file=full_filename,exist=found)
         if (found) then
           open(unit=31,file=full_filename,form='formatted',
     >          status='old')
           do while (found)
           if (mc_algorithm.lt.2) then
              read(31,*,end=100) emotion_time_shift,
     >                        EV,EV0,eave,evar,ratio,wa,wr,mc_dr
           else
              read(31,*,end=100) emotion_time_shift,
     >                EV,EV0,eave,evar,ratio,wa,wr,
     >                mc_dr,ratio_r,wa_r,wr_r,
     >                mc_dV,ratio_v,wa_v,wr_v,
     >                omega1,omega_ave,omega_var
              omega_all  = omega_all  + omega1
              omega_all2 = omega_all2 + omega1*omega1
           end if

           E25 = E25 + EV   !*** take care of running sums ***
           E26 = E26 + EV*EV
           end do
  100      continue
#if defined(FUJITSU_SOLARIS) || defined(PSCALE) || defined(__crayx1)
           backspace 31
#endif
         else
           open(unit=31,file=full_filename,form='formatted',
     >          status='new')
         end if
      end if
      call Parallel_Brdcst_value(MASTER,mc_dr)
      call Parallel_Brdcst_value(MASTER,E25)
      call Parallel_Brdcst_value(MASTER,E26)
      call Parallel_Brdcst_value(MASTER,wa)
      call Parallel_Brdcst_value(MASTER,wr)
      call Parallel_Brdcst_value(MASTER,wa_r)
      call Parallel_Brdcst_value(MASTER,wr_r)

      if (mc_algorithm.eq.2) then
         call Parallel_Brdcst_value(MASTER,mc_dV)
         call Parallel_Brdcst_value(MASTER,omega_all)
         call Parallel_Brdcst_value(MASTER,omega_all2)
         call Parallel_Brdcst_value(MASTER,wa_v)
         call Parallel_Brdcst_value(MASTER,wr_v)
      end if

*     **** open EIGMOTION file ****
      if (mulliken) then
        if (.not.rtdb_cget(rtdb,'nwpw:eigmotion_filename',1,filename))
     >    call util_file_prefix('eigmotion',filename)
      call util_file_name_noprefix(filename,.false.,
     >                             .false.,
     >                    full_filename)
      if (taskid.eq.MASTER)
     >   open(unit=32,file=full_filename,form='formatted')
      end if

      call xyz_write()

*     ****  allocate fion ***
      nion = ion_nion()
      if (pspw_charge_found().and.
     >    (.not.pspw_bqext())) nion = nion + pspw_charge_nion()

      value = MA_push_get(mt_dbl,(3*nion),
     >                       'fion',fion(2),fion(1))
      if (.not. value) call errquit('out of stack memory',0, MA_ERR)


*     *******************************
*     ***** do a simple mc loop *****
*     *******************************
      notfirststep = .false.



      call control_reduce_print()
      EV = cgsd_energy(newpsi)
      if (control_Fei())
     >   call cgsd_energy_gradient_md(dbl_mb(fion(1)))

      call xyz_write()

      it_out = control_bo_steps_out()
      it_in  = control_bo_steps_in()
      icount = 0
      if (it_out.lt.1) goto 102


      omega1 = lattice_omega()
      vcount = 0
      change_volume = .false.
  101 continue
         icount = icount + 1

c       **** inner loop ****
        do i=1,it_in

           !*** compute the trial energy ****
           if (mc_algorithm.eq.2) then
              if (taskid.eq.MASTER) alpha = util_random(0)
              call Parallel_Brdcst_value(MASTER,alpha)
              change_volume = alpha.le.(1.0d0/dble(ion_nion()))
           end if

*          **** change volume ****
           if (change_volume) then
              vcount = vcount + 1
              omega1 = lattice_omega()

              !*** rion --> frac1  ***
              call lattice_r1_to_frac(nion,
     >                                dbl_mb(ion_rion_ptr()),
     >                                dbl_mb(frac1(1)))
              call control_get_unita(mc_unita1)
              call cgmontecarlo_end(rtdb,flag)

*             **** volume change to unita1 --> unita2 ****
              if (taskid.eq.MASTER) alpha = (1.0d0*util_random(0)-0.5d0)
              call Parallel_Brdcst_value(MASTER,alpha)
              alpha = dexp(alpha*mc_dV/3.0d0)
              call dcopy(9,mc_unita1,1,mc_unita2,1)
              call dscal(9,alpha,mc_unita2,1)
              call Parallel_Brdcst_values(MASTER,9,mc_unita2)


*             **** change unitcell and reinitialize ****
              call control_set_unita(mc_unita2)
              call control_set_unita_frozen(mc_unita2)
              call cgmontecarlo_start(rtdb,newpsi)

              !*** frac1 -- > rion ***
              call lattice_frac_to_r1(nion,
     >                                dbl_mb(frac1(1)),
     >                                dbl_mb(ion_rion_ptr()))
              omega2 = lattice_omega()


*          **** change atom positions ****
           else
              call ion_MC_step(mc_dr,
     >                         mc_atom_direction,
     >                         mc_napply,
     >                         mc_ngroups,
     >                         int_mb(mc_group_start(1)),
     >                         int_mb(mc_group_end(1)),
     >                         int_mb(mc_group(1)))
           end if
           EV0 = cgsd_energy(.false.)

           if (change_volume) then
              w = dexp(-mc_beta*(EV0-EV) 
     >                 -mc_beta*mc_pressure*(omega2-omega1) 
     >                 +(ion_nion()+1)*dlog(omega2/omega1))
           else
              w = dexp(-mc_beta*(EV0-EV))
           end if

           if (taskid.eq.MASTER) alpha = util_random(0)
           call Parallel_Brdcst_value(MASTER,alpha)
        
           !*** accept the sequence ***
           if (alpha.lt.w) then
              EV = EV0
              if (change_volume) then
                 wa_v = wa_v + 1.0d0
                 omega1 = omega2
              else
                 wa_r = wa_r + 1.0d0
              end if
              wa = wa + 1.0d0
              if (control_Fei())
     >           call cgsd_energy_gradient_md(dbl_mb(fion(1)))

           !*** reject the sequence ***
           else
              if (change_volume) then
                 call cgmontecarlo_end(rtdb,flag)
                 call Parallel_Brdcst_values(MASTER,9,mc_unita1)
                 call control_set_unita(mc_unita1)
                 call control_set_unita_frozen(mc_unita1)
                 call cgmontecarlo_start(rtdb,newpsi)
                 call lattice_frac_to_r1(nion,
     >                                   dbl_mb(frac1(1)),
     >                                   dbl_mb(ion_rion_ptr()))
                 wr_v = wr_v + 1.0d0
              else
                 call ion_MC_reject_step()
                 wr_r = wr_r + 1.0d0
              end if
              wr = wr + 1.0d0
           end if

           E25 = E25 + EV
           E26 = E26 + EV*EV
           eave = E25/(wa+wr)
           evar = E26/(wa+wr)
           evar = evar - eave*eave
           ratio_r = wa_r/(wa_r+wr_r)
           ratio   = wa/(wa+wr)

           if (mc_algorithm.eq.2) then
              omega_all  = omega_all  + omega1
              omega_all2 = omega_all2 + omega1*omega1
              omega_ave  = omega_all/(wa+wr)
              omega_var  = omega_all2/(wa+wr)
              omega_var  = omega_var - omega_ave*omega_ave
              if ((wa_v+wr_v).gt.1.0d-6) then
                 ratio_v = wa_v/(wa_v+wr_v)
              else
                 ratio_v = 0.0d0
              end if
           end if

           if (oprint) then
             if (mc_algorithm.lt.2) then
                write(luout,1350) (icount-1)*it_in+i,EV,EV0,eave,
     >                              ratio,mc_dr
                write(31,1360) 
     >                dble((icount-1)*it_in+i)+emotion_time_shift,
     >                EV,EV0,eave,evar,ratio,wa,wr,mc_dr
             else
                write(luout,1351) (icount-1)*it_in+i,
     >                        EV,EV0,eave,
     >                        omega1,omega_ave,
     >                        ratio,mc_dr,mc_dv
c     >                        ratio_v,wa,wr,wa_v,wr_v
                write(31,1360) 
     >                dble((icount-1)*it_in+i)+emotion_time_shift,
     >                EV,EV0,eave,evar,ratio,wa,wr,
     >                mc_dr,ratio_r,wa_r,wr_r,
     >                mc_dv,ratio_v,wa_v,wr_v,
     >                omega1,omega_ave,omega_var
             end if
             call util_flush(luout)
             call util_flush(31)
           end if
           call fei_output(EV,dbl_mb(fion(1)))
           call xyz_write()
           call MOTION_write(dble((icount-1)*it_in+i)
     >                       +emotion_time_shift)

        end do

*       **** adjust MC steplength ****
        mc_dr = mc_dr*(c0 + c1*ratio_r + c2*ratio_r*ratio_r)
        !if ((ratio/aratio).gt.1.05d0) then
        !   dr = dr*(1.05d0)
        !else if ((ratio/aratio).lt.0.95d0) then
        !   dr = dr*(0.95d0)
        !else
        !   dr = dr*(ratio/aratio)
        !end if
        !if (ratio.lt.aratio) dr = dr*0.95d0
        !if (ratio.gt.aratio) dr = dr*1.05d0
        call Parallel_Brdcst_value(MASTER,mc_dr)

        if (mc_algorithm.eq.2) then
           if (vcount.ge.it_in) then
              mc_dV = mc_dV*(v0 + v1*ratio_v + v2*ratio_v*ratio_v)
              call Parallel_Brdcst_value(MASTER,mc_dV)
              vcount = 0
           end if
        end if

*        **** update thermostats using SA decay ****
         if (SA) then
           tt2 = icount*it_in*dt/sa_decay(2)
           Tr_new = Tr_init*dexp(-tt2)
         end if

*        **** exit early ****
         if (control_out_of_time()) then
            if (oprint)
     >       write(luout,*) ' *** out of time. iteration terminated'
            go to 102
         end if
      if (icount.lt.it_out) go to 101
      if (oprint) write(luout,*) 
     > '*** arived at the Maximum iteration.   terminated.'

*::::::::::::::::::::  end of iteration loop  :::::::::::::::::::::::::
      call control_up_print()

  102 continue
  

*     **** close xyz and MOTION files ****
      call xyz_end()
      call MOTION_end()
      if (taskid.eq.MASTER) then
         close(unit=31)
         if (mulliken) close(unit=32)

*        **** remove EMOTION backup file ***
         call util_file_name_noprefix('EMOTION99-bak',.false.,
     >                                .false.,
     >                                full_bak)
         call util_file_unlink(full_bak)

      end if

*     *** close fei io ****
      call fei_end()




*                |***************************|
******************     simple MD loop        **********************
*                |***************************|


*                |***************************|
****************** report summary of results **********************
*                |***************************|

      call center_geom(cx,cy,cz)
      call center_mass(gx,gy,gz)
      call center_v_geom(vcx,vcy,vcz)
      call center_v_mass(vgx,vgy,vgz)

      if (oprint) then
         call print_elapsed_time(icount*it_in*dt)
         write(luout,1300)
         write(luout,1410)
         write(luout,1420)
         do I=1,ion_nion()
           if (ion_q_FixIon(I)) then
           write(luout,1191) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else if (ion_q_zFixIon(I)) then
           write(luout,1193) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           else
           write(luout,1190) I,ion_aname(I),(ion_rion(k,i),K=1,3),
     >                   ion_amass(I)/1822.89d0
           end if
         end do
         write(luout,1200) cx,cy,cz
         write(luout,1210) gx,gy,gz
         write(luout,1211) ion_nconstraints(),ion_ndof()
      end if

      EV = cgsd_noit_energy()

      if (oprint) then


*       **** write out Temperatures ****
         cv = (evar)/(kb*ion_Temperature()**2)
         cv = cv/dble(ion_nion())
         write(luout,1492) eave
         write(luout,1493) evar
         write(luout,1494) cv

      end if
      call cgsd_energy_gradient(dbl_mb(fion(1)))

*     **** calculate excited state orbitals ****
      call cgsd_excited()

*     **** calculate oep eigenvalues ****
      call cgsd_oep_eigenvalues()

*     **** extra energy output for QA test ****
      if (lprint) write(6,1600) EV

*     **** calculate the spin contamination ****
      if (flag.gt.-1) call psi_spin2(dipole(1))

*     **** calculate the dipole ***
      dipole(1) = 0.0d0
      dipole(2) = 0.0d0
      dipole(3) = 0.0d0
      if (flag.gt.-1) call rho_dipole(dipole)


*     **** calculate the stress tensor ****
      call dcopy(9,0.0d0,0,stress,1)
      call dcopy(6,0.0d0,0,lstress,1)
      if (flag.eq.3) then
         call psp_stress_init()
         call psp_stress_readall()
         call cgsd_energy_stress(stress,lstress)
         call psp_stress_end()
      end if


*     *************************************************************
*     **** output energy, dipole, and gradient to rtdb for use ****
*     **** by task_energy and task_gradient                    ****
*     *************************************************************
      if (flag.gt.-1) then
      value = rtdb_put(rtdb,'pspw:energy',mt_dbl,1,EV)
      value = value.and.
     >        rtdb_put(rtdb,'pspw:dipole',mt_dbl,
     >                 3,dipole)
      end if
      if (flag.gt.0) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:gradient',mt_dbl,
     >                 3*nion,dbl_mb(fion(1)))
      end if
      if (flag.eq.3) then
        value = value.and.
     >        rtdb_put(rtdb,'pspw:stress',mt_dbl,
     >                 9,stress)
        value = value.and.
     >        rtdb_put(rtdb,'pspw:lstress',mt_dbl,
     >                 6,lstress)
      end if
      value = value.and.MA_pop_stack(fion(2))
      if (.not. value) 
     > call errquit('cgmontecarlov1: error writing rtdb',0,
     >       RTDB_ERR)

      if (taskid.eq.MASTER) call current_second(cpu3)

*                |***************************|
******************         Epilogue          **********************
*                |***************************|

*     **** calculate Mulliken Populations ***
      if (control_Mulliken()) call psi_Mulliken(rtdb)



*     **** deallocate memory and data structures ****
      call cgmontecarlo_end(rtdb,flag)


*     **** deallocate heap memory ****
      value =           MA_free_heap(mc_group_start(2))
      value = value.and.MA_free_heap(mc_group_end(2))
      value = value.and.MA_free_heap(mc_group(2))
      if (.not. value) 
     >  call errquit('cgmontecarlov1:freeing heap',3,MA_ERR)

      call meta_finalize(rtdb)
      call psp_U_end()
      call psi_data_end()


*     **** do anaylysis on MOTION files ****
      call cpmd_properties(rtdb)



*                |***************************|
****************** report consumed cputime   **********************
*                |***************************|
      if (lprint) then
         CALL current_second(cpu4)

         T1=CPU2-CPU1
         T2=CPU3-CPU2
         T3=CPU4-CPU3
         T4=CPU4-CPU1
         AV=T2/dble(electron_count())
         write(6,1801)
         write(6,1802)
         write(6,1803) T1
         write(6,1804) T2
         write(6,1805) T3
         write(6,1806) T4
         write(6,1807) AV,electron_count(),linesearch_count()

         call nwpw_timing_print_final(oprint,electron_count())

         write(6,*)
         CALL nwpw_MESSAGE(4)
      end if 



      call Parallel_Finalize()
      cgmontecarlov1 = value
      return


*:::::::::::::::::::::::::::  format  :::::::::::::::::::::::::::::::::
 1000 FORMAT(10X,'****************************************************')
 1010 FORMAT(10X,'*                                                  *')
 1020 FORMAT(10X,'*               NWPW PSPW Calculation              *')
 1030 FORMAT(10X,'*     [  NVT and NPT Monte-Carlo simulation   ]    *')
 1035 FORMAT(10x,'*     [  NorthWest Chemistry implementation   ]    *')
 1040 FORMAT(10X,'*            version #1.00   07/18/06              *')
 1041 FORMAT(10X,'*    This code was developed by Eric J. Bylaska.   *')
 1100 FORMAT(//)
 1110 FORMAT(10X,'================ input data ========================')
 1111 FORMAT(/' number of processors used:',I10)
 1112 FORMAT( ' parallel mapping         :      1d slab')
 1113 FORMAT( ' parallel mapping         :   2d hilbert')
 1114 FORMAT( ' parallel mapping         :     balanced')
 1115 FORMAT(/' options:')
 1116 FORMAT( ' parallel mapping         : not balanced')
 1117 FORMAT( ' processor grid           :',I4,' x',I4)
 1118 FORMAT( ' parallel mapping         :    2d hcurve')
 1120 FORMAT(5X,' ionic motion         = ',A)
 1121 FORMAT(5X,' boundary conditions  = ',A,'(version', I1,')')
 1122 FORMAT(5X,' qmmm simulation')
 1123 FORMAT( ' parallel io              :        on')
 1124 FORMAT( ' parallel io              :       off')
 1130 FORMAT(5X,' electron spin        = ',A)
 1131 FORMAT(5X,' exchange-correlation = ',A)
 1132 FORMAT(5X,' using fractional occupation')
 1140 FORMAT(/' elements involved in the cluster:')
 1150 FORMAT(5X,I2,': ',A4,'  core charge:',F4.1,'  lmax=',I3)
 1151 FORMAT(5X,'        cutoff =',4F8.3)
 1152 FORMAT(12X,' highest angular component      : ',i3)
 1153 FORMAT(12X,' local potential used           : ',i3)
 1154 FORMAT(12X,' number of non-local projections: ',i3)
 1155 FORMAT(12X,' semicore corrections included  : ',
     >       F6.3,' (radius) ',F6.3,' (charge)')
 1156 FORMAT(12X,' aperiodic cutoff radius        : ',F6.3)
 1157 FORMAT(12X,' comment    : ',A)
 1158 FORMAT(12X,' pseudpotential type            : ',i3)

 1159 FORMAT(/' total charge:',F8.3)
 1160 FORMAT(/' atomic composition:')
 1170 FORMAT(7(5X,A4,':',I5))
 1180 FORMAT(/' initial position of ions (au):')
 1181 FORMAT(/' initial velocity of ions after scaling (au):')

 1190 FORMAT(5X, I4, A5  ,' (',3F11.5,' ) - atomic mass= ',F7.3,' ')
 1191 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - fixed')
 1192 FORMAT(5X, I4, A5  ,' (',3F11.5,' )')
 1193 FORMAT(5X, I4, A5, ' (',3F11.5,
     >       ' ) - atomic mass= ',F7.3,' - z fixed')

 1200 FORMAT(5X,'    G.C. ',' (',3F11.5,' )')
 1210 FORMAT(5X,'   C.O.M.',' (',3F11.5,' )')
 1211 FORMAT(5X,'   number of constraints = ', I6,' ( DOF = ',I6,' )' )
 1219 FORMAT(/' number of active electrons: spin up=',F6.2,
     >        '  down=',F6.2,A)
 1220 FORMAT(/' number of active electrons: spin up=',I6,  
     >        '  down=',I6,A)
 1221 FORMAT( ' number of active orbitals : spin up=',I6,  
     >        '  down=',I6,A)

 1222 format(5x,' initial kinetic energy=',e12.5,' (ion)',2x,
     >                                     e12.5,' (c.o.m.)')
 1223 format(5x,' after scaling=         ',e12.5,' (ion)')
 1224 format(5x,' increased energy=      ',e12.5,' (ion)')
 1226 format(/' final kinetic energy= ',   e12.5,' (ion)',2x,
     >                                     e12.5,' (c.o.m.)')

 1230 FORMAT(/' supercell:')
 1231 FORMAT(5x,'             omega=',F12.1)
 1232 FORMAT(5x,' lattice:    a=    ',f8.3,' b=   ',f8.3,' c=    ',f8.3,
     >      /5x,'             alpha=',f8.3,' beta=',f8.3,' gamma=',f8.3)
 1233 FORMAT(5x,' cell_name:  ',A)
 1241 FORMAT(5x,' lattice:    a1=<',3f8.3,' >')
 1242 FORMAT(5x,'             a2=<',3f8.3,' >')
 1243 FORMAT(5x,'             a3=<',3f8.3,' >')
 1244 FORMAT(5x,' reciprocal: b1=<',3f8.3,' >')
 1245 FORMAT(5x,'             b2=<',3f8.3,' >')
 1246 FORMAT(5x,'             b3=<',3f8.3,' >')

 1250 FORMAT(/5X,' density cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
 1251 FORMAT(5X,' wavefnc cutoff=',F7.3,'  fft=',I3,'x',I3,'x',I3,
     &       '( ',I8,' waves ',I8,' per task)')
  
 1260 FORMAT(5X,' ewald summation: cut radius=',F8.2,'  and',I3)
 1261 FORMAT(5X,'                   madelung=',f11.8)
 1270 FORMAT(/' technical parameters for minimizer:')
 1271 FORMAT(5x, ' translation constrained')
 1272 FORMAT(5x, ' rotation constrained')
 1280 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1)
 1281 FORMAT(5X, ' maximum iterations =',I10, 
     >           ' ( ',I4,' inner ',I6,' outer )')
 1290 FORMAT(5X, ' tolerance=',E8.3,' (energy)',E12.3,
     &        ' (density)')
 1291 FORMAT(/' Kohn-Sham scf parameters:')
 1292 FORMAT(5X, ' Kohn-Sham algorithm  = ',A)
 1293 FORMAT(5X, ' SCF algorithm        = ',A)
 1294 FORMAT(5X, ' SCF mixing parameter =',F7.4)
 1295 FORMAT(5X, ' Kohn-Sham iterations = ',I4,
     >           ' (',I4,' outer)')
 1300 FORMAT(//)
 1301 FORMAT(5X, ' Kerker damping       =',F7.4)
 1310 FORMAT(/' Monte-Carlo parameters:')
 1311 FORMAT(5X, ' MC Algorithm= ',A,A)
 1320 FORMAT(5X, ' MC displacement=',F10.2,5X,' iterations=',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1321 FORMAT(5X, ' time step=',F10.2,5X,'ficticious mass=',F10.1,
     >       /5X,' iterations=',I10,
     >           ' ( ',I4,' inner ',I6,' outer )')
 1322 FORMAT(5X, ' temperature='F10.3,5x,' beta=',E10.3,' seed=',I10)
 1323 FORMAT(5X, ' targeted accept.=',F10.3,5X,
     >           ' ddx=',F10.3,' c0=',F10.3,' c1=',F10.3,' c2=',F10.3)
 1324 FORMAT(5X, ' number atom changes = 'I10,
     >           ' change vector = <',3F10.3'>')
 1325 FORMAT(5X, ' number of groups = 'I10)
 1326 FORMAT(5X, ' pressure='E10.3,' (',F10.3,' atm)',
     >           ' ddv=',F10.3,' v0=',F10.3,' v1=',F10.3,' v2=',F10.3)

 1330 FORMAT(5X, ' integration algorithm=   ',A)
 1340 FORMAT(/5X, ' cooling/heatting rate= ',e12.5,' (ion)')
 1350 FORMAT(I8,3E19.10,F16.3,F10.3,3E19.10,2F8.4)
 1351 FORMAT(I8,3E19.10,F10.2,3x,F10.2,4x,F8.3,2x,F8.3,3x,F8.3,9E19.10)
 1360 format(100e19.10)

 1393 format(/' Pressure Output Generated         ')
 1394 format(/' Constant Energy Simulation                     ')
 1395 format(/' Nose-Hoover Simulation - Thermostat Parameters:')
 1396 format(5x, 'SA decay rates  =',e10.3,' (ion)')
 1397 format(5x, 'link = ',I3,
     > ' Te =',f8.2,' Qe =',e10.3,' 2*pi/we=',e10.3,' Ee0=',e10.3)
 1398 format(5x, 'link = ',I3,
     > ' Tr =',f8.2,' Qr =',e10.3,' 2*pi/wr=',e10.3,' Er0=',e10.3)

 1399 format(//' Mulliken Analysis Output Generated            ')
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT(/' final position of ions:')
 1421 FORMAT(/' final velocity of ions:')
 1471 FORMAT(/' Kinetic energy (elc)    :',E19.10,' (',E15.5,'/elc)')
 1472 FORMAT( ' Kinetic energy (ion)    :',E19.10,' (',E15.5,'/ion)')
 1473 FORMAT( ' thermostat energy (elc) :',E19.10,' (',E15.5,'/elc)')
 1474 FORMAT( ' thermostat energy (ion) :',E19.10,' (',E15.5,'/ion)')
 1480 FORMAT(' Temperature :    ',F10.1,' K (ion)')
 1490 FORMAT('             :    ',F10.1,' K (c.o.m.)')
 1491 FORMAT(' Temperature :    ',F10.1,' K (elc)')
 1492 FORMAT(/' Eaverage           :    ',E19.10)
 1493 FORMAT( ' Evariance          :    ',E19.10)
 1494 FORMAT( ' Cv - f*kb/(2*nion) :    ',E19.10)
 1600 FORMAT(/' Total PSPW energy   :',E19.10)
 1801 FORMAT(//'== Timing ==')
 1802 FORMAT(/'cputime in seconds')
 1803 FORMAT( '  prologue    : ',E14.6)
 1804 FORMAT( '  main loop   : ',E14.6)
 1805 FORMAT( '  epilogue    : ',E14.6)
 1806 FORMAT( '  total       : ',E14.6)
 1807 FORMAT( '  cputime/step: ',E14.6,
     >        '       (',I8,' evalulations,', I8,' linesearches)')
 1808 FORMAT(A,E14.6,E14.6)
 1809 FORMAT(//A,2A14)

 9010 FORMAT(//' >> job terminated due to code =',I3,' <<')

 9000 if (taskid.eq.MASTER) write(6,9010) ierr
      call Parallel_Finalize()

      cgmontecarlov1 = value
      return
      END



*     ***********************************************
*     *                                             *
*     *             cgmontecarlo_start              *
*     *                                             *
*     ***********************************************

      subroutine cgmontecarlo_start(rtdb,newpsi)
      implicit none
      integer rtdb
      logical newpsi

*     **** local variables ****
      logical value,calc_pressure
      integer minimizer,mapping,mapping1d,ngrid(3),ne(2),ispin

*     **** external functions ****
      logical  control_pressure,control_check_charge_multiplicity
      logical  psp_semicore,ion_init,psi_initialize
      integer  control_version,control_ngrid,control_minimizer
      integer  control_mapping,control_mapping1d,psi_ne,psi_ispin
      external control_pressure,control_check_charge_multiplicity
      external psp_semicore,ion_init,psi_initialize
      external control_version,control_ngrid,control_minimizer
      external control_mapping,control_mapping1d,psi_ne,psi_ispin



      ngrid(1) = control_ngrid(1)
      ngrid(2) = control_ngrid(2)
      ngrid(3) = control_ngrid(3)
      minimizer = control_minimizer()
      mapping   = control_mapping()
      calc_pressure = control_pressure().and.(control_version().eq.3)

*     **** initialize D3dB data structure ****
      call D3dB_Init(1,ngrid(1),ngrid(2),ngrid(3),mapping)

*     ***** Initialize double D3dB data structure ****
      if (control_version().eq.4)
     >   call D3dB_Init(2,2*ngrid(1),2*ngrid(2),2*ngrid(3),mapping)

*     **** initialize lattice data structure ****
      call lattice_init()
      call G_init()
      call mask_init()
      call Pack_init()
      call D3dB_pfft_init()
      call ga_sync()

*     **** read ions ****
      value = ion_init(rtdb)

*     **** initialize FixIon constraint ****
      call ion_init_FixIon(rtdb)

*     **** allocate psp data structure and read in psedupotentials into it ****
      call psp_init()
      call psp_readall()
      if (psp_semicore(0)) call semicore_check()

*     **** initialize G,mask,ke,coulomb,and ewald data structures ****
      call ke_init()
      if (control_version().eq.3) call coulomb_init()
      if (control_version().eq.4) call coulomb2_init()
      call strfac_init()
      call phafac()
      if (control_version().eq.3) then
         call ewald_init()
         call ewald_phafac()
       end if

*     **** read in wavefunctions and initialize psi ****
      if (.not.control_check_charge_multiplicity()) then
        call psi_new()
        newpsi = .true.
      else
        newpsi = .false.
      end if

*     **** Initialize 1d mappings for ne spaces ****
      call psi_get_ne(ispin,ne)
      mapping1d   = control_mapping1d()
      call Dne_init(ispin,ne,mapping1d)


*     **** read in wavefunctions and initialize psi ****
      value = psi_initialize()

      !call D3dB_n_fft_init(1,psi_ne(1)+psi_ne(2))

*     **** electron and geodesic data structures ****
      call electron_init()
      if ((minimizer.eq.4).or.(minimizer.eq.7)) then  !debug
        call geodesic2_init()
      else
         call geodesic_init()
      end if

*     **** initialize QM/MM ****
      call pspw_init_APC(rtdb)
      call pspw_qmmm_init(rtdb)
      call pspw_charge_init(rtdb)

*     **** initialize SIC and HFX ****
      ne(1) = psi_ne(1)
      ne(2) = psi_ne(2)
      call pspw_init_SIC(rtdb,ne)
      call pspw_init_HFX(rtdb,psi_ispin(),ne)

*     **** initialize Meta GGA ****
      call nwpw_meta_gga_init()


      if (calc_pressure) then
         call psp_stress_init()
         call psp_stress_readall()
      end if

      return
      end


*     ***********************************************
*     *                                             *
*     *             cgmontecarlo_end                *
*     *                                             *
*     ***********************************************

      subroutine cgmontecarlo_end(rtdb,flag)
      implicit none
      integer rtdb
      integer flag

*     **** local variables ****
      logical value,calc_pressure
      integer minimizer


*     **** external functions ****
      logical  control_pressure,psi_finalize
      integer  control_minimizer,control_version
      external control_pressure,psi_finalize
      external control_minimizer,control_version


      minimizer     = control_minimizer()
      calc_pressure = control_pressure().and.(control_version().eq.3)

*     **** finalize pressure ****
      if (calc_pressure) then
         call psp_stress_end()
      end if

*     **** write wavefunctions to file and finalize psi ****
      if (flag.eq.-1) then
        value = psi_finalize(.false.)
      else
        value = psi_finalize(.true.)
      end if

*     **** write geometry to rtdb ****
      call pspw_charge_write(rtdb)
      call ion_write(rtdb)


      call electron_finalize()
      if ((minimizer.eq.4).or.(minimizer.eq.7)) then
        call geodesic2_finalize()
      else
        call geodesic_finalize()
      end if
      if (control_version().eq.3) call ewald_end()
      call strfac_end()
      if (control_version().eq.3) call coulomb_end()
      if (control_version().eq.4) call coulomb2_end()
      call ke_end()
      call mask_end()
      call Pack_end()
      call G_end()
      call nwpw_meta_gga_end()
      call pspw_end_SIC()
      call pspw_end_HFX()
      call pspw_end_APC()
      call pspw_charge_end()
      call pspw_qmmm_end()

      call ion_end()
      call psp_end()
      call ion_end_FixIon()
      !call D3dB_n_fft_end(1)
      call D3dB_pfft_end()
      call D3dB_end(1)
      if (control_version().eq.4) call D3dB_end(2)
      call Dne_end()

      return
      end

      Subroutine DGeWr (N, M, A, LDA, N0, M0, LUN, Label, LinWid,
     $   EFmt)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C $Id: dgewr.F 19707 2010-10-29 17:59:36Z d3y133 $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     dgewr -- Write a general matrix nicely formatted 
C
C SYNOPSIS
      Implicit NONE
#include "errquit.fh"
      Integer N, M, LDA, N0, M0, LinWid, LUN
      Double precision A(LDA,*)
      Character*(*) Label, EFmt
C
C ARGUMENTS
C     N       Row dimension of A (input)
C     M       Column dimension of A (input)
C     A       Matrix to be symmetrized (modified)
C     LDA     Leading dimension of A (input)
C     N0      Offset for numering of rows (input)
C     M0      Offset for numbering of columns (input)
C     LUN     Unit number to write to (input)
C     Label   Text label for matrix (input)
C     LinWid  Maximum line width to use (input)
C     EFmt    (Fortran) format of individual elements (input)
C             Allowed formats are {Ew.d,Fw.d,Dw.d,Gw.d}
C
C DESCRIPTION
C     "Pretty prints" a general matrix to the specified unit, which
C     must be opened for formatted writing, and positioned as desired.
C
C     The given element format string is analyzed to determine the
C     width required by each element, and two spaces are allowed
C     between elements.  This width is used to determine the number of
C     elements that can be output on each line.
C
C     The matrix is printed headed by the given label, which is
C     surrounded by lines of '-'s above and below to set it off.
C     If the label is passed in blank, no heading is printed.
C
C     Non-zero row/column offsets allow displayed row/column numbers
C     to be different from the numbering of the matrix itself.
C
C LIMITATIONS
C     Supported formats are: [DEFG]w.d
C     Long labels are wrapped without regard for their content.
C     The dashed lines that are used to surround the label are at
C        most MAXSTR in length.
C     Internally generated format strings rely on the fact that
C        blanks are not significant.  If this changes, it will be
C        necessary to be very careful in constructing the parts of
C        the format strings that pertain to integers (Iw specifiers).
C
C WARNING
C     The string PosFmt is case-sensitive.  If this source is
C     forced to all upper- or lowercase without some amount of care,
C     the routine may only accept format specifiers in a specific
C     case.
C
C TO BE ADDED
C     If row dimension is 1, don't print row label
C
C INCLUDED FILES
#include "inp.fh"
C
C ROUTINES REQUIRED
C     IndInt  Locate the left-most integer in a string (FStrings)
C     AtoI    Convert string to an integer (FStrings)
C
      Integer AtoI
      External AtoI
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C FIXED PARAMETERS
C     PosFmt  Allowed format speficiers
C
      Character*(*) PosFmt
      Parameter (PosFmt = 'DdEeFfGg')
C
C LOCAL VARIABLES
C     I       General use
C     J       General use
C     J2      General use
C     ii      General use
C     JJ      general use
C     LLabNr  Length of the row/column labeling number
C     NPerL   Number of elements per line
C     IW      Width of element, extracted from EFmt
C     ID      Decimal places of element, extracted from EFmt
C     LElem   Larger of LLabNr and IW, used as actual element width
C     LLen    Label length, used to pretty print it
C     MaxStr  Maximum length allocated to internal strings
C     CLFmt   Format string for column label
C     DFmt    Format string for lines of data
C     Dash    Holds the lines used in pretty printing Label
C
      Integer i, j, J2, ii, jj, LLabNr, NPerL, IW, ID, LElem, LLen
      Integer MaxStr
      Parameter (MaxStr = 255)
      Character*(MaxStr) CLFmt, DFmt, Dash
C
C     *****************************
C     * Check matrix dimensioning *
C     *****************************
C
      If (N .lt. 0 .OR. M .lt. 0) Call ErrQuit(
     $   'DGEWR: matrix dimensions cannot be negative', Min(M, N) ,
     &       INPUT_ERR)
      If (LDA .lt. Max(1, N)) Call ErrQuit(
     $   'DGEWR: leading dimension too small', LDA, INPUT_ERR)
C
C     ************************
C     * Check element format *
C     ************************
C     Make sure the format specifier is reasonable
C
      If (Index(PosFmt, EFmt(1:1)) .eq. 0) Call ErrQuit(
     $   'DGEWR: Unknown format specifer', 0, INPUT_ERR)
C
C     Get the total width
C
      Call IndInt (EFmt, I, J)
      IW = AtoI(EFmt(i:j))
      If (IW .le. 0) Call ErrQuit(
     $   'DGEWR: line width must be positive', IW, INPUT_ERR)
C
C     Next should be a '.'
C
      If (EFmt(j+1:j+1) .ne. '.') Call ErrQuit(
     $   'DGEWR: bad format specifier', 0, INPUT_ERR)
C
C     Get the number of decimal places
C
      Call IndInt (EFmt(j+1:), I, J2)
      ID = AtoI(EFmt(j+i:j+j2))
      If (ID .le. 0) Call ErrQuit('DGEWR: bad format specifier', ID,
     &       INPUT_ERR)
C
C     *********************************
C     * See if we can get away easily *
C     *********************************
C
      If (N .eq. 0 .OR. M .eq. 0) Return
C
C     ********************************
C     * Determine space requirements *
C     ********************************
C     Width of the labeling row/column number
C     We have to account for the offsets and what they might do to the
C     signs of the labels (which require an extra space).
C
      I = Min( 1+N0, 1+M0 )
      J = Max( N+N0, M+M0 )
      II = Int( Log10( dble( Abs(I)) ) +1 )
      JJ = Int( Log10( dble( Abs(J)) ) +1 )
      LLabNr = Max( II, JJ)
      If (II .ge. JJ .AND. I .lt. 0) LLabNr = LLabNr + 1
C
C     Determine now much we can fit on a line under the following
C     guidelines:
C        Column 1 blank
C        Column LinWid blank (to avoid extra newlines getting put in)
C        Elements separated by two spaces
C        Column width is larger of the element and the label
C
      LElem = Max (IW, LLabNr)
      NPerL = Int( (LinWid-LLabNr-2) / (LElem+2) )
C
C     Make sure we can fit something!!!
C
      If (NPerL .eq. 0) Call ErrQuit(
     $   'DGEWR: Specified format will not fit in line width', 0,
     &       INPUT_ERR)
C
C     *****************************
C     * Create the format strings *
C     *****************************
C
      Write (CLFmt, 9000) 1+LLabNr, NPerL, LElem - LLabNr + 2, LLabNr
 9000 Format( '(/', I10,'X,', I10,'(',I10, 'X,I', I10, '))' )
C
C     Number of blanks between elements must be increased if
C     column labels are larger than the element width
C
      Write (DFmt, 9010) LLabNr, NPerL, LElem - IW + 2,
     $   EFmt(:Inp_StrLen(EFmt))
 9010 Format( '(1X,I', I10,',', I10,'(', I10,'X,',A,'))' )
C
C     *******************
C     * Write the label *
C     *******************
C
      LLen = Inp_StrLen(Label)
      If (LLen .ne. 0) then
         Do 100 I = 1, Min(LinWid-2, LLen, MaxStr)
            Dash(i:i) = '-'
 100     Continue
         Write (LUN, 9100) Dash(:Min(LinWid-2, LLen, MaxStr))
         Do 200 i = 1, LLen, LinWid-2
            Write (LUN, 9100) Label(i:Min( LLen, i+LinWid-3))
 200     Continue
         Write (LUN, 9100) Dash(:Min(LinWid-2, LLen, MaxStr))
      EndIf
 9100 Format (1X, A)
C
C     ********************
C     * Write the matrix *
C     ********************
C
      Do 1000 j = 1, M, NPerL
         J2 = Min( J+NPerL-1, M)
         If (M .gt. 1) Write (LUN, CLFmt) (jj+M0, jj = J, J2)
         Write (LUN, '(A)') ' '
         Do 1010 i = 1, N
            Write (LUN, DFmt) i+N0, (A(i,jj), jj = J, J2)
 1010    Continue
 1000 Continue
C
      Return
      End

      subroutine dscalfile(scale,d_1,size)
c
c $Id: dscalfile.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Multiply a file by a constant
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      double precision scale
      integer d_1
      integer size
      integer nblocks,blocksize
      integer l_temp,k_temp
      integer i
      logical nodezero
      logical d_1isga
cc      integer nxtval
      integer  next, nprocs, count
cc      external nxtval
      INTEGER NXTASK
      EXTERNAL NXTASK
      logical noloadbalance
c
c     new
c
      if (fileisga(d_1)) then
        call ga_scale(d_1,scale)
        return
      endif
c
      noloadbalance = ((ioalg.eq.4).or.
     1                ((ioalg.eq.6).and.(.not.fileisga(d_1))))
      d_1isga = fileisga(d_1)
      if (.not.d_1isga) call dratoga(d_1)
      nodezero = (ga_nodeid().eq.0)
      nblocks = size/buffer_size
      if (nblocks*buffer_size.lt.size) nblocks = nblocks + 1
      blocksize = size/nblocks
      if (nblocks*blocksize.lt.size) blocksize = blocksize + 1
      if (nodezero.and.util_print('dscalfile',print_debug)) then
        write(LuOut,9190) d_1,size
        write(LuOut,9200) nblocks,blocksize
      endif
      if (.not.ma_push_get(mt_dbl,blocksize,'temporary',
     1  l_temp,k_temp))
     2  call errquit('dscalfile: MA problem',0,MA_ERR)
      nprocs = GA_NNODES()
      count = 0
cc      next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
      do i = 1,nblocks
        if (noloadbalance.or.(next.eq.count)) then
          if (util_print('dscalfile',print_debug))
     1      write(LuOut,9210) ga_nodeid(),(i-1)*blocksize,
     2                        min(size,i*blocksize)-(i-1)*blocksize
          call get_block(d_1,dbl_mb(k_temp),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
          call dscal(blocksize,scale,dbl_mb(k_temp),1)
          call put_block(d_1,dbl_mb(k_temp),
     1      min(size,i*blocksize)-(i-1)*blocksize,(i-1)*blocksize)
cc          next = NXTVAL(nprocs)
      next = NXTASK(nprocs, 1)
        endif
        count = count + 1
      enddo
cc      next = NXTVAL(-nprocs)
      next = NXTASK(-nprocs, 1)
      if (.not.d_1isga) call gatodra(d_1)
      if (.not.ma_pop_stack(l_temp))
     1  call errquit('dscalfile: MA problem',1,MA_ERR)
      call ga_sync()
 9190 format(/,1x,'        file handle:',i10,' size:',i10)
 9200 format(  1x,'            nblocks:',i10,' size:',i10)
 9210 format(  1x,i3,'          offset:',i10,' size:',i10)
      return
      end

      logical function mcscf_gradient(rtdb)
      implicit none
#include "errquit.fh"
      integer rtdb
c     
      logical mcscf, gradients
      external mcscf, gradients
c
      if (.not. mcscf(rtdb))
     $     call errquit('mcscf_gradient: mcscf energy failed', 0,
     &       CALC_ERR)
c
      call util_print_push
      call util_print_rtdb_load(rtdb,'mcscf')
      if (.not. gradients(rtdb))
     $     call errquit('mcscf_gradient: gradients failed', 0,
     &       CALC_ERR)
      call util_print_pop
c
      mcscf_gradient = .true.
c
      end
      logical function scf_gradient(rtdb)
c$Id: scf_gradient.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      logical scf, gradients
      external scf, gradients
c
      if (.not. scf(rtdb))
     $     call errquit('scf_gradient: scf energy failed', 0,
     &       CALC_ERR)
      call util_print_push
      call util_print_rtdb_load(rtdb,'scf')
      if (.not. gradients(rtdb))
     $     call errquit('scf_gradient: gradients failed', 0,
     &       CALC_ERR)
      call util_print_pop
c
      scf_gradient = .true.
c
      end

      SUBROUTINE lambda_ccsd_t(d_t1,k_t1_offset,d_t2,k_t2_offset,
     1                  d_y1,k_y1_offset,d_y2,k_y2_offset,
     2                  d_f1,k_f1_offset,d_v2,k_v2_offset,
     3                  energy1,energy2)
C
C     $Id: lambda_ccsd_t.F 23619 2013-02-22 19:31:33Z kowalski $
C
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_t1
      integer k_t1_offset
      integer d_t2
      integer k_t2_offset
      integer d_y1
      integer k_y1_offset
      integer d_y2
      integer k_y2_offset
      integer d_f1
      integer k_f1_offset
      integer d_v2
      integer k_v2_offset
      integer t_h1b, t_h1
      integer t_h2b, t_h2
      integer t_h3b, t_h3
      integer t_p4b, t_p4
      integer t_p5b, t_p5
      integer t_p6b, t_p6
      integer k_tdoubles,l_tdoubles
      integer k_ysingles,l_ysingles
      integer k_ydoublesA,l_ydoublesA ! L3 form, before sorting
      integer k_ydoubles,l_ydoubles   ! T3 form, after sorting
      integer size,i
      integer g_energy
      integer NXTVAL
      integer next
      integer nprocs
      integer count
      double precision energy1,energy2
      double precision factor
      external NXTVAL
C
#ifdef DEBUG_PRINT
      print*,"entering lambda_ccsd_t"
#endif
      if (.not.ga_create(mt_dbl,1,1,'perturbative',1,1,g_energy))
     1  call errquit('lambda_ccsd_t: GA problem',0,GA_ERR)
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      energy1=0.0d0
      energy2=0.0d0
      do t_p4b = noab+1,noab+nvab
       do t_p5b = t_p4b,noab+nvab
        do t_p6b = t_p5b,noab+nvab
         do t_h1b = 1,noab
          do t_h2b = t_h1b,noab
           do t_h3b = t_h2b,noab
            if (int_mb(k_spin+t_p4b-1)
     1         +int_mb(k_spin+t_p5b-1)
     2         +int_mb(k_spin+t_p6b-1)
     3      .eq.int_mb(k_spin+t_h1b-1)
     4         +int_mb(k_spin+t_h2b-1)
     5         +int_mb(k_spin+t_h3b-1)) then
            if ((.not.restricted).or.
     1         (int_mb(k_spin+t_p4b-1)
     1         +int_mb(k_spin+t_p5b-1)
     2         +int_mb(k_spin+t_p6b-1)
     3         +int_mb(k_spin+t_h1b-1)
     4         +int_mb(k_spin+t_h2b-1)
     5         +int_mb(k_spin+t_h3b-1).le.8)) then
            if (ieor(int_mb(k_sym+t_p4b-1),
     1          ieor(int_mb(k_sym+t_p5b-1),
     2          ieor(int_mb(k_sym+t_p6b-1),
     3          ieor(int_mb(k_sym+t_h1b-1),
     4          ieor(int_mb(k_sym+t_h2b-1),
     5               int_mb(k_sym+t_h3b-1)))))).eq.0) then
c
            if (next.eq.count) then
c
            size = int_mb(k_range+t_p4b-1)
     1           * int_mb(k_range+t_p5b-1)
     2           * int_mb(k_range+t_p6b-1)
     3           * int_mb(k_range+t_h1b-1)
     4           * int_mb(k_range+t_h2b-1)
     5           * int_mb(k_range+t_h3b-1)
c
            if (.not.MA_PUSH_GET(mt_dbl,size,'(T) right doubles',
     1        l_tdoubles,k_tdoubles)) 
     2        call errquit('lambda_ccsd_t: MA error',301,MA_ERR)
            if (.not.MA_PUSH_GET(mt_dbl,size,'(T) left singles',
     1        l_ysingles,k_ysingles)) 
     2        call errquit('lambda_ccsd_t: MA error',302,MA_ERR)
            if (.not.MA_PUSH_GET(mt_dbl,size,'(T) left doubles',
     1        l_ydoubles,k_ydoubles)) 
     2        call errquit('lambda_ccsd_t: MA error',303,MA_ERR)
c
            do i = 1, size
             dbl_mb(k_tdoubles+i-1) = 0.0d0
             dbl_mb(k_ysingles+i-1) = 0.0d0
             dbl_mb(k_ydoubles+i-1) = 0.0d0
            enddo
c
#ifdef DEBUG_PRINT
      print*,"before ccsd_t_doubles"
#endif
c
c           <T|{W*T2}|0> : i0(p4 p5 p6 h1 h2 h3)_vt += -P(9)*Sum(h7)*t(p4 p5 h1 h7)_t*v(h7 p6 h2 h3)_v
c                        : i0(p4 p5 p6 h1 h2 h3)_vt += -P(9)*Sum(p7)*t(p4 p7 h1 h2)_t*v(p5 p6 h3 p7)_v
c
            call ccsd_t_doubles(dbl_mb(k_tdoubles),d_t2,d_v2,
     1           k_t2_offset,k_v2_offset,
     2           t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
c
#ifdef DEBUG_PRINT
      print*,"before lambda_ccsd_t_left"
#endif
c
c           <0|L(F+W)|T> : i0(h4 h5 h6 p1 p2 p3)_yv += P(9)*y(h4 p1)_y*v(h5 h6 p2 p3)_v
c
            call lambda_ccsd_t_left(dbl_mb(k_ysingles),d_f1,d_v2,
     1           d_y1,d_y2,k_f1_offset,k_v2_offset,
     2           k_y1_offset,k_y2_offset,
     3           t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,1)
c
c           <0|L(F+W)|T> : i0(h4 h5 h6 p1 p2 p3)_yf += P(9)*y(h4 h5 p1 p2)_y*f(h6 p3)_f
c                        : i0(h4 h5 h6 p1 p2 p3)_yv += -P(9)*Sum(h7)*y(h4 h7 p1 p2)_y*v(h5 h6 h7 p3)_v
c                        : i0(h4 h5 h6 p1 p2 p3)_yv += -P(9)*Sum(p7)*y(h4 h5 p1 p7)_y*v(h6 p7 p2 p3)_v
c
            call lambda_ccsd_t_left(dbl_mb(k_ydoubles),d_f1,d_v2,
     1           d_y1,d_y2,k_f1_offset,k_v2_offset,
     2           k_y1_offset,k_y2_offset,
     3           t_h1b,t_h2b,t_h3b,t_p4b,t_p5b,t_p6b,2)
c
            if (restricted) then
              factor = 2.0d0
            else
              factor = 1.0d0
            endif
            if ((t_p4b.eq.t_p5b).and.(t_p5b.eq.t_p6b)) then
              factor = factor / 6.0d0
            else if ((t_p4b.eq.t_p5b).or.(t_p5b.eq.t_p6b)) then
              factor = factor / 2.0d0
            endif
            if ((t_h1b.eq.t_h2b).and.(t_h2b.eq.t_h3b)) then
              factor = factor / 6.0d0
            else if ((t_h1b.eq.t_h2b).or.(t_h2b.eq.t_h3b)) then
              factor = factor / 2.0d0
            endif
            i = 0
            do t_p4 = 1, int_mb(k_range+t_p4b-1)
             do t_p5 = 1, int_mb(k_range+t_p5b-1)
              do t_p6 = 1, int_mb(k_range+t_p6b-1)
               do t_h1 = 1, int_mb(k_range+t_h1b-1)
                do t_h2 = 1, int_mb(k_range+t_h2b-1)
                 do t_h3 = 1, int_mb(k_range+t_h3b-1)
                  i = i + 1
                  energy1 = energy1 + factor * dbl_mb(k_tdoubles+i-1)
     1                                       * dbl_mb(k_ydoubles+i-1)
     2      / (-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p4b-1)+t_p4-1)
     3         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     4         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     5         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     6         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     7         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1))
                  energy2 = energy2 + factor * dbl_mb(k_tdoubles+i-1)
     1             * (dbl_mb(k_ysingles+i-1) + dbl_mb(k_ydoubles+i-1))
     2      / (-dbl_mb(k_evl_sorted+int_mb(k_offset+t_p4b-1)+t_p4-1)
     3         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p5b-1)+t_p5-1)
     4         -dbl_mb(k_evl_sorted+int_mb(k_offset+t_p6b-1)+t_p6-1)
     5         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h1b-1)+t_h1-1)
     6         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h2b-1)+t_h2-1)
     7         +dbl_mb(k_evl_sorted+int_mb(k_offset+t_h3b-1)+t_h3-1))
                 enddo
                enddo
               enddo
              enddo
             enddo
            enddo
            if (.not.MA_POP_STACK(l_ydoubles)) 
     1        call errquit('lambda_ccsd_t',314,MA_ERR)
            if (.not.MA_POP_STACK(l_ysingles)) 
     1        call errquit('lambda_ccsd_t',312,MA_ERR)
            if (.not.MA_POP_STACK(l_tdoubles)) 
     1        call errquit('lambda_ccsd_t',311,MA_ERR)
c
            next = NXTVAL(nprocs)
            endif
            count = count + 1
c
            endif
            endif
            endif
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo
      next = NXTVAL(-nprocs)
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,energy1,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,energy1,1)
      call ga_zero(g_energy)
      call ga_acc(g_energy,1,1,1,1,energy2,1,1.0d0)
      call ga_sync()
      call ga_get(g_energy,1,1,1,1,energy2,1)
      if (.not.ga_destroy(g_energy))
     1  call errquit('lambda_ccsd_t: GA problem',1,GA_ERR)
      return
      end

      logical function pre_excl(l3rd,m3rd,n3rd,lbnd,mbnd,nbnd,
     + lang,mang,nang,lexc,mexc,nexc,nval,ival,ndx,catt,matt,
     + lats,nparms,mats,latm,matm,natm,lupdat)
c
c $Id: pre_excl.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer m3rd,n3rd,mbnd,nbnd,mang,nang,mexc,nexc
      integer matt,mats,matm,natm
      integer l3rd(2,m3rd),lbnd(4,mbnd),lang(5,mang),lexc(2,mexc)
      integer nval,nparms
      integer ival(nval),ndx(nval)
      character*6 catt(2,matt)
      integer lats(nparms,mats)
      integer latm(11,matm)
      logical lupdat
c
      integer i,j,k,l,in,jn,ln,itmp,ir
c
      if(n3rd.gt.mexc) call md_abort('increase mexc',9999)
      do 1 i=1,n3rd
      lexc(1,i)=l3rd(1,i)
      lexc(2,i)=l3rd(2,i)
    1 continue
      nexc=n3rd
c
      do 2 i=1,nbnd
      nexc=nexc+1
      if(nexc.gt.mexc) call md_abort('increase mexc',9999)
      lexc(1,nexc)=lbnd(1,i)
      lexc(2,nexc)=lbnd(2,i)
    2 continue
      do 3 i=1,nang
      nexc=nexc+1
      if(nexc.gt.mexc) call md_abort('increase mexc',9999)
      lexc(1,nexc)=min(lang(1,i),lang(3,i))
      lexc(2,nexc)=max(lang(1,i),lang(3,i))
    3 continue
c
      if(lupdat.and.nparms.eq.3) then
      do 4 i=1,natm-1
      if(catt(1,lats(2,latm(3,i)))(6:6).eq.'D') then
      do 5 j=i+1,natm
      if(catt(1,lats(3,latm(3,j)))(6:6).eq.'D') then
      nexc=nexc+1
      if(nexc.gt.mexc) call md_abort('increase mexc',9999)
      lexc(1,nexc)=i
      lexc(2,nexc)=j
      write(*,'(a,2i5)') 'Excluding ',i,j
      endif
    5 continue
      elseif(catt(1,lats(3,latm(3,i)))(6:6).eq.'D') then
      do 6 j=i+1,natm
      if(catt(1,lats(2,latm(3,j)))(6:6).eq.'D') then
      nexc=nexc+1
      if(nexc.gt.mexc) call md_abort('increase mexc',9999)
      lexc(1,nexc)=i
      lexc(2,nexc)=j
      write(*,'(a,2i5)') 'Excluding ',i,j
      endif
    6 continue
      endif
    4 continue
      endif
c
      if(nexc.gt.1) then
      do 7 i=1,nexc
      ndx(i)=i
    7 continue
      ln=nexc/2+1
      ir=nexc
    8 continue
      if(ln.gt.1) then
      ln=ln-1
      itmp=ndx(ln)
      else
      itmp=ndx(ir)
      ndx(ir)=ndx(1)
      ir=ir-1
      if(ir.eq.1) then
      ndx(1)=itmp
      goto 9
      endif
      endif
      in=ln
      jn=ln+ln
   10 continue
      if(jn.le.ir) then
      if(jn.lt.ir) then
      if(lexc(1,ndx(jn)).gt.lexc(1,ndx(jn+1)).or.
     + (lexc(1,ndx(jn)).eq.lexc(1,ndx(jn+1)).and.
     + lexc(2,ndx(jn)).gt.lexc(2,ndx(jn+1)))) then
      else
      jn=jn+1
      endif
      endif
      if(lexc(1,itmp).gt.lexc(1,ndx(jn)).or.
     + (lexc(1,itmp).eq.lexc(1,ndx(jn)).and.
     + lexc(2,itmp).gt.lexc(2,ndx(jn)))) then
      jn=ir+1
      else
      ndx(in)=ndx(jn)
      in=jn
      jn=jn+jn
      endif
      goto 10
      endif
      ndx(in)=itmp
      goto 8
    9 continue
c
      do 11 k=1,2
      do 12 i=1,nexc
      ival(i)=lexc(k,i)
   12 continue
      do 13 i=1,nexc
      lexc(k,i)=ival(ndx(i))
   13 continue
   11 continue
      endif
c
      if(nexc.gt.1) then
      l=nexc
      nexc=1
      do 14 i=2,l
      if(lexc(1,i).ne.lexc(1,nexc).or.lexc(2,i).ne.lexc(2,nexc)) then
      nexc=nexc+1
      lexc(1,nexc)=lexc(1,i)
      lexc(2,nexc)=lexc(2,i)
      endif
   14 continue
      endif
c
      pre_excl=.true.
      return
      end

      SUBROUTINE OFFSET_ccsdtq_lambda3_20_1(l_a_offset,k_a_offset,size)
C     $Id: OFFSET_ccsdtq_lambda3_20_1.F 19700 2010-10-29 17:11:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h4 h11 p8 p1 p2 p3 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h4b
      INTEGER h11b
      INTEGER p8b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      length = 0
      DO h4b = 1,noab
      DO h11b = 1,noab
      DO p8b = noab+1,noab+nvab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+p8b-1
     &) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_mb
     &(k_sym+p8b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),in
     &t_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h11b-
     &1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     &int_mb(k_spin+p3b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('ccsdtq_lambda3_20_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h4b = 1,noab
      DO h11b = 1,noab
      DO p8b = noab+1,noab+nvab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+p8b-1
     &) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b
     &-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_mb
     &(k_sym+p8b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),in
     &t_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_t)) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h11b-
     &1)+int_mb(k_spin+p8b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+
     &int_mb(k_spin+p3b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p3b - noab - 1 + nvab * (p2b - noab - 1 
     &+ nvab * (p1b - noab - 1 + nvab * (p8b - noab - 1 + nvab * (h11b -
     & 1 + noab * (h4b - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h4b-1) * int_mb(k_range+h11b-1) * int
     &_mb(k_range+p8b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
     & * int_mb(k_range+p3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine argos_diana_getsel
c
c $Id: argos_diana_getsel.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c     get atom selection
c     ------------------
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      if(.not.lsel) then
      call argos_diana_all(int_mb(i_isel),0,dbl_mb(i_wt),nsel)
      lsel=.true.
      endif
      call argos_diana_select(byte_mb(i_snam),int_mb(i_isel),
     + dbl_mb(i_wt),
     + dbl_mb(i_xref),nsel)
      if(me.eq.0) then
      write(*,3003) nsel,nsa
 3003 format(' Selected',i5,' out of',i5,' atoms')
      endif
      return
      end

C> \ingroup selci
C> @{
C>
      subroutine selci_eijil(e,i,j,l,ns,indbar,iocc,
     $     w1,w2,work,numf,numf2)
*
* $Id: eijil.F 24780 2013-11-07 21:23:59Z d3y133 $
*
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
      dimension e(*),indbar(*),iocc(*),work(*),
     $     w1(nfmax,nfmax,nsmax),w2(nfmax2,nfmax,nsmax-1)
c
c     e(u,v) = <Iu|Eij,il|Iv>, where u,v label the spin functions
c     and the orbital occupation of I is specified by ns, iocc
c     and indbar. Only for i.ne.j.ne.l. j and l are assumed
c     to be in order of increasing occupation in I
c
c     Note that this value is independent of i and can be simplified later
c
c     possible cases are:
c
c     iocc(j)  iocc(l)  case
c       0         0       1
c       0         1       2
c       1         1       3
c
      if (i.eq.j .or. i.eq.l .or. j.eq.l)
     $     call errquit('eijil: one of i=j,i=l,j=l',i, UNKNOWN_ERR)
      if (iocc(j).gt.iocc(l)) 
     $     call errquit('eijil: iocc ordering',iocc(j), UNKNOWN_ERR)
      numf = nf(ns)
      numf2 = nf(ns+2)
      ib = indbar(i) + (nsmax-ns-2)
*     call selci_mxma(w2(1,1,ib),1,nfmax2,w1(1,1,ib),1,nfmax,
*     $     e,1,numf,numf,numf2,numf2)
      call selci_axb(w2(1,1,ib),nfmax2,w1(1,1,ib),nfmax,
     $     e,numf,numf,numf2,numf2)
c
      icase = iocc(j) + iocc(l) + 1
      goto (10,20,30) icase
      call errquit('eijil: invalid case',icase, UNKNOWN_ERR)
c
c     nj=0, nl=0: e(u,v) = eiaeib(u,p)*w1(q,p,lb)*w1(v,q,jb)
c                                    ab     ->  la   ->     jl
c
 10   continue
      lb = indbar(l) + (nsmax-ns-2)
      jb = indbar(j) + (nsmax-ns-2)
      if (j.gt.l) jb = jb + 1
*      call selci_mxma(e,1,numf,w1(1,1,lb),nfmax,1,
*     $     work,1,numf,numf,numf2,numf2)
      call selci_axbt(e,numf,w1(1,1,lb),nfmax,
     $     work,numf,numf,numf2,numf2)
*      call selci_mxma(work,1,numf,w1(1,1,jb),nfmax,1,
*     $     e,1,numf,numf,numf2,numf2)
      call selci_axbt(work,numf,w1(1,1,jb),nfmax,
     $     e,numf,numf,numf2,numf2)
      return
c
c     nj=0, nl=1: e(u,v) = eiaeib(u,p)*w2(q,p,lb)*w1(v,q,jb)
c                                   lab     -> lla   ->    llj
c
 20   continue
      lb = indbar(l) + (nsmax-ns-2)
      jb = indbar(j) + (nsmax-ns)
      if (j.gt.l) jb = jb - 1
*      call selci_mxma(e,1,numf,w2(1,1,lb),nfmax2,1,
*     $     work,1,numf,numf,numf2,numf)
      call selci_axbt(e,numf,w2(1,1,lb),nfmax2,
     $     work,numf,numf,numf2,numf)
*      call selci_mxma(work,1,numf,w1(1,1,jb),nfmax,1,
*     $     e,1,numf,numf,numf,numf)
      call selci_axbt(work,numf,w1(1,1,jb),nfmax,
     $     e,numf,numf,numf,numf)
      numf2 = numf
      return
c
c     nj=1, nl=1: e(u,v) = eiaeib(u,p)*w2(q,p,lb)*w1(v,q,jb)
c                                  jlab    -> llja   ->   jjll
c
 30   continue
      lb = indbar(l) + (nsmax-ns-2)
      jb = indbar(j) + (nsmax-ns)
      if (j.gt.l) jb = jb - 1
      numf2m = nf(ns-2)
*      call selci_mxma(e,1,numf,w2(1,1,lb),nfmax2,1,
*     $     work,1,numf,numf,numf2,numf)
      call selci_axbt(e,numf,w2(1,1,lb),nfmax2,
     $     work,numf,numf,numf2,numf)
*      call selci_mxma(work,1,numf,w2(1,1,jb),nfmax2,1,
*     $     e,1,numf,numf,numf,numf2m)
      call selci_axbt(work,numf,w2(1,1,jb),nfmax2,
     $     e,numf,numf,numf,numf2m)
      numf2 = numf2m
c
      end
C>
C> @}

      SUBROUTINE YGEHRD( N, ILO, IHI, A, LDA, TAU, WORK, LWORK, INFO )
c $Id: ygehrd.F 19697 2010-10-29 16:57:34Z d3y133 $
*
      implicit none
#include "y64.fh"
      INTEGER            IHI, ILO, INFO, LDA, LWORK, N
      DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( LWORK )
c
      INTGR4    IHI4, ILO4, INFO4, LDA4, LWORK4, N4
c
      IHI4=ihi
      ILO4=ilo
      LDA4=lda
      LWORK4=lwork
      N4=n
c
      call DGEHRD( N4, ILO4, IHI4, A, LDA4, TAU, WORK, LWORK4, INFO4)
c
      info=info4
      return
      end

      SUBROUTINE ccsdtq_lr_alpha_1_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lr_alpha_1_5.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( p12 h13 )_yttra + = -1 * Sum ( h1 ) * tra ( p12 h1 )_tra * i2 ( h1 h13 )_yt
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p12b
      INTEGER h13b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h1b
      INTEGER p12b_1
      INTEGER h1b_1
      INTEGER h1b_2
      INTEGER h13b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p12b = noab+1,noab+nvab
      DO h13b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p12b-1)+int_mb(k_spin+h13b
     &-1).ne.4)) THEN
      IF (int_mb(k_spin+p12b-1) .eq. int_mb(k_spin+h13b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),int_mb(k_sym+h13b-1)) .eq. ieor(irre
     &p_y,ieor(irrep_t,irrep_tra))) THEN
      dimc = int_mb(k_range+p12b-1) * int_mb(k_range+h13b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_1_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h1b = 1,noab
      IF (int_mb(k_spin+p12b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),int_mb(k_sym+h1b-1)) .eq. irrep_tra)
     & THEN
      CALL TCE_RESTRICTED_2(p12b,h1b,p12b_1,h1b_1)
      CALL TCE_RESTRICTED_2(h1b,h13b,h1b_2,h13b_2)
      dim_common = int_mb(k_range+h1b-1)
      dima_sort = int_mb(k_range+p12b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h13b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_1_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_1_5',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p12b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+h1b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_1_5',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_1_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_1_5',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h13b_
     &2 - 1 + noab * (h1b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h13b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_1_5',6,M
     &A_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_1_5
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_1_5
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_1_5',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h13b-1
     &),int_mb(k_range+p12b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h13b 
     &- 1 + noab * (p12b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_1_5',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_1_5
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

      logical function argos_prepare_torang(x,mx,ia,ja,ka,la,angle)
c
c $Id: argos_prepare_torang.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer mx,ia,ja,ka,la
      real*8 x(3,mx),angle
c
      integer i,j,k
      real*8 xij(3),xkj(3),xkl(3),xm(3),xn(3)
c
      do 1 i=1,3
      xij(i)=x(i,ia)-x(i,ja)
      xkj(i)=x(i,ka)-x(i,ja)
      xkl(i)=x(i,ka)-x(i,la)
    1 continue
c
      do 2 i=1,3
      j=i+1
      if(j.eq.4) j=1
      k=j+1
      if(k.eq.4) k=1
      xm(i)=xij(j)*xkj(k)-xkj(j)*xij(k)
      xn(i)=xkj(j)*xkl(k)-xkl(j)*xkj(k)
    2 continue
c
      angle=acos((xm(1)*xn(1)+xm(2)*xn(2)+xm(3)*xn(3))/
     + sqrt((xm(1)*xm(1)+xm(2)*xm(2)+xm(3)*xm(3))*
     + (xn(1)*xn(1)+xn(2)*xn(2)+xn(3)*xn(3))))
c
      if(xkj(1)*(xm(2)*xn(3)-xm(3)*xn(2))+
     + xkj(2)*(xm(3)*xn(1)-xm(1)*xn(3))+
     + xkj(3)*(xm(1)*xn(2)-xm(2)*xn(1)).lt.0.0d0) angle=-angle
c
      argos_prepare_torang=.true.
      return
      end

      SUBROUTINE lambda_ccsd_t_left(a_i0,d_f1,d_v2,d_y1,d_y2,k_f1_offset
     &,k_v2_offset,k_y1_offset,k_y2_offset,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b
     &,t_p3b,toggle)
C     $Id: lambda_ccsd_t_left.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1 * P( 9 ) * y ( h4 p1 )_y * v ( h5 h6 p2 p3 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = 1 * P( 9 ) * y ( h4 h5 p1 p2 )_y * f ( h6 p3 )_f
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( h7 ) * y ( h4 h7 p1 p2 )_y * v ( h5 h6 h7 p3 )_v
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( p7 ) * y ( h4 h5 p1 p7 )_y * v ( h6 p7 p2 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER toggle
      INTEGER d_y1
      INTEGER k_y1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      DOUBLE PRECISION a_i0(*)
      IF (toggle .eq. 1) CALL lambda_ccsd_t_left_1(d_y1,k_y1_offset,d_v2
     &,k_v2_offset,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      IF (toggle .eq. 2) CALL lambda_ccsd_t_left_2(d_y2,k_y2_offset,d_f1
     &,k_f1_offset,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      IF (toggle .eq. 2) CALL lambda_ccsd_t_left_3(d_y2,k_y2_offset,d_v2
     &,k_v2_offset,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      IF (toggle .eq. 2) CALL lambda_ccsd_t_left_4(d_y2,k_y2_offset,d_v2
     &,k_v2_offset,a_i0,t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
      RETURN
      END
      SUBROUTINE lambda_ccsd_t_left_1(d_a,k_a_offset,d_b,k_b_offset,a_c,
     &t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: lambda_ccsd_t_left.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = 1 * P( 9 ) * y ( h4 p1 )_y * v ( h5 h6 p2 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h4b_1
      INTEGER p1b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_v)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1)) .eq. irrep_y) TH
     &EN
      CALL TCE_RESTRICTED_2(h4b,p1b,h4b_1,p1b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p2b,p3b,h5b_2,h6b_2,p2b_2,p3b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p2b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lambda_ccsd_t_left_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (h4b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lambda_ccsd_t_left_1',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lambda_ccsd_t_left_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lambda_ccsd_t_left_1',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &1',8,MA_ERR)
      END IF
      END IF
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,4,3,5,2,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,4,3,2,5,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,4,3,2,1,5,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,6,3,5,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,6,3,2,5,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,6,3,2,1,5,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,3,6,5,2,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,3,6,2,5,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),4,3,6,2,1,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &1',9,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE lambda_ccsd_t_left_2(d_a,k_a_offset,d_b,k_b_offset,a_c,
     &t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: lambda_ccsd_t_left.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yf + = 1 * P( 9 ) * y ( h4 h5 p1 p2 )_y * f ( h6 p3 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = noab+1,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_f)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,p2b,h4b_1,h5b_1,p1b_1,p2b_1)
      CALL TCE_RESTRICTED_2(h6b,p3b,h6b_2,p3b_2)
      dim_common = 1
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lambda_ccsd_t_left_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h5b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lambda_ccsd_t_left_2',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lambda_ccsd_t_left_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (h6b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p3b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lambda_ccsd_t_left_2',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &2',8,MA_ERR)
      END IF
      END IF
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,2,4,3,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,2,1,4,3,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,2,4,1,3,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),2,6,5,4,3,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),2,6,5,1,4,3,1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),2,6,5,4,1,3,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,2,5,4,3,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,2,5,1,4,3,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,2,5,4,1,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &2',9,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE lambda_ccsd_t_left_3(d_a,k_a_offset,d_b,k_b_offset,a_c,
     &t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: lambda_ccsd_t_left.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( h7 ) * y ( h4 h7 p1 p2 )_y * v ( h5 h6 h7 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h7b
      INTEGER h4b_1
      INTEGER h7b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER h7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = noab+1,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_v)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h7b = 1,noab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h7b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h7b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h4b,h7b,p1b,p2b,h4b_1,h7b_1,p1b_1,p2b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,h7b,h5b_2,h6b_2,p3b_2,h7b_2)
      dim_common = int_mb(k_range+h7b-1)
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+p1b-1) * int_mb
     &(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lambda_ccsd_t_left_3',2,MA_ERR)
      IF ((h7b .lt. h4b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h4b_1 - 1 + noab 
     &* (h7b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h4b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h4b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h7b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lambda_ccsd_t_left_3',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lambda_ccsd_t_left_3',5,MA_ERR)
      IF ((h7b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (h7b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h7b-1),int_mb(k_range+p3b-1)
     &,4,2,1,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lambda_ccsd_t_left_3',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,3,2,5,4,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,3,2,1,5,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),6,3,2,5,1,4,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,6,2,5,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,6,2,1,5,4,1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,6,2,5,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,2,6,5,4,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p3b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,2,6,1,5,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h5b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h4b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &2b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+h6b-1),int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_
     &mb(k_range+p1b-1),int_mb(k_range+h4b-1),3,2,6,5,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &3',9,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE lambda_ccsd_t_left_4(d_a,k_a_offset,d_b,k_b_offset,a_c,
     &t_h4b,t_h5b,t_h6b,t_p1b,t_p2b,t_p3b)
C     $Id: lambda_ccsd_t_left.F 19699 2010-10-29 17:07:13Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( h4 h5 h6 p1 p2 p3 )_yv + = -1 * P( 9 ) * Sum ( p7 ) * y ( h4 h5 p1 p7 )_y * v ( h6 p7 p2 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER t_h4b
      INTEGER t_h5b
      INTEGER t_h6b
      INTEGER t_p1b
      INTEGER t_p2b
      INTEGER t_p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p7b
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER p1b_1
      INTEGER p7b_1
      INTEGER h6b_2
      INTEGER p7b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      DOUBLE PRECISION a_c(*)
      LOGICAL skipped
      DO h4b = 1,noab
      DO h5b = h4b,noab
      DO h6b = 1,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      skipped = .true.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) skipped = .false.
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) skipped = .false.
      IF (.not.skipped) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+h6b-1)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+i
     &nt_mb(k_spin+p3b-1).ne.12)) THEN
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1)
     & .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+h6b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),int
     &_mb(k_sym+p3b-1)))))) .eq. ieor(irrep_y,irrep_v)) THEN
      dimc = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+h6b-1) * int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_m
     &b(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p7b = noab+1,noab+nvab
      IF (int_mb(k_spin+h4b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p7b-1)) THEN
      IF (ieor(int_mb(k_sym+h4b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p7b-1)))) .eq. irrep_y) THEN
      CALL TCE_RESTRICTED_4(h4b,h5b,p1b,p7b,h4b_1,h5b_1,p1b_1,p7b_1)
      CALL TCE_RESTRICTED_4(h6b,p7b,p2b,p3b,h6b_2,p7b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p7b-1)
      dima_sort = int_mb(k_range+h4b-1) * int_mb(k_range+h5b-1) * int_mb
     &(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h6b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &lambda_ccsd_t_left_4',2,MA_ERR)
      IF ((p7b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p1b_1
     & - noab - 1 + nvab * (p7b_1 - noab - 1 + nvab * (h5b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p7b-1),int_mb(k_range+p1b-1)
     &,4,2,1,3,-1.0d0)
      END IF
      IF ((p1b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p7b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (h5b_1 - 1 + noab 
     &* (h4b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p7b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('lambda_ccsd_t_left_4',3,
     &MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('lambda_ccsd_t_left_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &lambda_ccsd_t_left_4',5,MA_ERR)
      IF ((h6b .le. p7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1 + (noab+nvab) * (p7b_2 - 1 + (noab
     &+nvab) * (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+p7b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('lambda_ccsd_t_left_4',6,
     &MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &4',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &4',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,4,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,2,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h5b) .and. (t_h6b .eq. h6b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,5,3,2,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,4,2,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,2,4,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h6b) .and. (t_h5b .eq. h4b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),3,6,5,2,1,4,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p1b) .and. (t_p2b .eq. p2b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,4,2,1,1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p1b) .and. (t_p3b .eq. p
     &3b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,2,4,1,-1.0d0)
      END IF
      IF ((t_h4b .eq. h4b) .and. (t_h5b .eq. h6b) .and. (t_h6b .eq. h5b)
     & .and. (t_p1b .eq. p2b) .and. (t_p2b .eq. p3b) .and. (t_p3b .eq. p
     &1b)) THEN
      CALL TCE_SORTACC_6(dbl_mb(k_c_sort),a_c,int_mb(k_range+p3b-1),int_
     &mb(k_range+p2b-1),int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_
     &mb(k_range+h5b-1),int_mb(k_range+h4b-1),6,3,5,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('lambda_ccsd_t_left_
     &4',9,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      subroutine mepgs_input(rtdb)
*
* $Id: mepgs_input.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "nwc_const.fh"
#include "cgsopt.fh"
#include "cmepgs.fh"
#include "rtdb.fh"
#include "mafdecls.fh"
c
      integer rtdb
      character*255 field
      double precision ascale, bscale, tscale, hscale
      logical ignore
      integer mh
c
c     === set defaults ===
c
      mswg = .false.
c
c     ----- read values from input -----
c
 10   if(.not.inp_read())
     $     call errquit('mepgs_input: unexpected eof',911, INPUT_ERR)
      if (.not. inp_a(field))
     $     call errquit('mepgs_input: failed to read field',911,
     &       INPUT_ERR)
c
      if(inp_compare(.false.,'end',field)) then
         return
c
      else if(inp_compare(.false.,'evib',field)) then
         if(.not. inp_f(evib))
     $        call errquit('mepgs_input: evib',911, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'mepgs:evib',mt_dbl,1,evib))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if(inp_compare(.false.,'stride',field)) then
         if(.not. inp_f(stride)) 
     $        call errquit('mepgs_input: stride',911, INPUT_ERR)
         if (.not. rtdb_put(rtdb,'mepgs:stride',mt_dbl,1,stride))
     $        call errquit('mepgs_input: rtdb put failed',0, INPUT_ERR)
      else if(inp_compare(.false.,'maxst',field)) then
         if(.not. inp_f(maxst))
     $        call errquit('mepgs_input: maxst',911, INPUT_ERR)
         if (.not. rtdb_put(rtdb,'mepgs:maxst',mt_dbl,1,maxst))
     $        call errquit('mepgs_input: rtdb put failed',0, INPUT_ERR)
c
      else if(inp_compare(.false.,'nircopt',field) .or. 
     $        inp_compare(.false.,'maxmep',field)) then
         if(.not. inp_i(nircopt))
     $        call errquit('mepgs_input: nircopt/maxmep',911,
     &       INPUT_ERR)
         if (.not. rtdb_put(rtdb,'mepgs:nircopt',mt_int,1,nircopt))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if (inp_compare(.false.,'mswg',field)) then
         mswg = .true.
         if (.not. rtdb_put(rtdb,'ircgs:mswg',mt_log,1,mswg))
     $        call errquit('ircgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if (inp_compare(.false.,'nomswg',field)) then
         mswg = .false.
         if (.not. rtdb_put(rtdb,'ircgs:mswg',mt_log,1,mswg))
     $        call errquit('ircgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if (inp_compare(.false.,'backward',field)) then
         backward = .true.
         if (.not. rtdb_put(rtdb,'mepgs:backward',mt_log,1,backward))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
      else if (inp_compare(.false.,'forward',field)) then
         forward = .true.
         if (.not. rtdb_put(rtdb,'mepgs:forward',mt_log,1,forward))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if(inp_compare(.false.,'print',field)) then
         call util_print_input(rtdb,'mepgs')
c
      else if(inp_compare(.false.,'noprint',field)) then
         call util_print_input(rtdb,'mepgs')
c
      else if(inp_compare(.false.,'xyz',field)) then
         if (.not. inp_a(xyz)) then
            call util_file_prefix('x',xyz)
            xyz(inp_strlen(xyz)-1:) = ' '
         endif
         if (.not. rtdb_cput(rtdb,'mepgs:xyz',1,xyz))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if(inp_compare(.false.,'noxyz',field)) then
         ignore = rtdb_delete(rtdb,'mepgs:xyz')
c
c     Constrained optimization control 
c
      else if(inp_compare(.false.,'nptopt',field) .or.
     $        inp_compare(.false.,'maxiter',field)) then
         if(.not. inp_i(nptopt))
     $        call errquit('mepgs_input: nptopt/maxiter',911,
     &       INPUT_ERR)
         if (.not. rtdb_put(rtdb,'gsopt:nptopt',mt_int,1,nptopt))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if(inp_compare(.false.,'inhess',field)) then
         if(.not. inp_i(inhess)) 
     $        call errquit('mepgs_input: inhess',911, INPUT_ERR)
         if (.not. rtdb_put(rtdb,'mepgs:inhess',mt_int,1,inhess))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if(inp_compare(.false.,'opttol',field)) then
         if(.not. inp_f(opt_tol))
     $        call errquit('mepgs_input: opttol',911, INPUT_ERR)
         if (.not. rtdb_put(rtdb,'gsopt:opt_tol',mt_dbl,1,opt_tol))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
         grms_tol = 1.0d0*opt_tol
         gmax_tol = 1.5d0*opt_tol
         xrms_tol = 4.0d0*opt_tol
         xmax_tol = 6.0d0*opt_tol
         if (.not. rtdb_put(rtdb,'gsopt:gmax_tol',mt_dbl,1,gmax_tol))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'gsopt:grms_tol',mt_dbl,1,grms_tol))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'gsopt:xrms_tol',mt_dbl,1,xrms_tol))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'gsopt:xmax_tol',mt_dbl,1,xmax_tol))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)
c
      else if(inp_compare(.false.,'eprec',field)) then
         if(.not. inp_f(eprec))
     $        call errquit('mepgs_input: eprec',911, RTDB_ERR)
         if (.not. rtdb_put(rtdb,'gsopt:eprec',mt_dbl,1,eprec))
     $        call errquit('mepgs_input: rtdb put failed',0, RTDB_ERR)

c
      else
         call errquit('mepgs_input: unknown directive',0, INPUT_ERR)
      endif
c
      goto 10                   ! While loop
c
      end

      subroutine argos_cafe_rdgib(lfngib,dec,dlambd)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer lfngib
      real*8 dec(6,nsatot),dlambd
c
      if(npgdec.eq.0) call md_abort('rdgib error',0)
c
      call argos_cafe_rgib(lfngib,dbl_mb(i_sti),dec,dlambd)
c
      return
      end
c $Id: argos_cafe_rdgib.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function pre_fix(lfnout,ifix,jfix,rfix,cfix,
     + iwmr,xw,mwm,mwa,nwm,nwa,iwmrc,xwc,mwmc,nwmc,
     + isar,isgm,csa,xs,msa,nsa)
c
c $Id: pre_fix.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
      integer lfnout
      integer mwm,mwa,nwm,nwa,msa,nsa,mwmc,nwmc
      integer ifix,jfix
      real*8 rfix
      character*80 cfix
c
      real*8 xw(3,mwa,mwm),xs(3,msa),xwc(3,mwa,mwmc)
      integer iwmrc(mwmc),iwmr(mwm),isar(msa),isgm(msa)
      character*16 csa(msa)
c
      integer iatom,isgmnt,jsgmnt,ndx,ndy
      integer i,j,ifrst,ilast,jfrst
      character*6 aname
      logical lsin
      real*8 dx,dy,dz,d2,rfix2
      character*4 csgmnt,string
c
      rfix2=rfix*rfix
c
c     determine center
c
      isgmnt=0
      aname='      '
      ndx=index(cfix,':')
      ndy=index(cfix,' ')
      if(ndx.gt.0) then
      csgmnt='    '
      read(cfix(1:ndx-1),*,err=99) isgmnt
      goto 999
   99 continue
      isgmnt=0
      if(ndx.le.4) then
      csgmnt(1:ndx-1)=cfix(1:ndx-1)
      else
      csgmnt=cfix(1:4)
      endif
  999 continue
      if(ndy-ndx.gt.5)
     + call md_abort('pre_fix: atom name problem',9999)
      aname(1:ndy-ndx)=cfix(ndx+1:ndy)
      else
      if(ndy.gt.5) call md_abort('pre_modify: atom name problem',9999)
      aname(1:ndy-1)=cfix(1:ndy-1)
      endif
      do 1 i=1,index(aname,' ')-1
      if(aname(i:i).eq.'_') aname(i:i)=' '
    1 continue
c
  100 continue
c
      if(csgmnt.ne.'    ') then
      do 101 i=1,nsa
      string=csa(i)(1:4)
      if(csgmnt.eq.string.and.isgmnt.lt.isgm(i)) then
      isgmnt=isgm(i)
      goto 102
      endif
  101 continue
      goto 199
      endif
  102 continue
c
c     determine iatom : atom number of specified atom
c               ifrst : number first atom of the segment
c               ilast : number last atom of the segment
c
      iatom=0
      ifrst=0
      ilast=0
      do 2 i=1,nsa
      if(isgm(i).eq.isgmnt) then
      if(csa(i)(11:16).eq.aname) iatom=i
      if(ifrst.eq.0) ifrst=i
      ilast=i
      endif
    2 continue
c
      if(iatom.eq.0.or.ifrst.eq.0.or.ilast.eq.0) then
      if(util_print('restart',print_low)) then
      write(lfnout,'(a,i8,a,a)') 'Unable to find ',isgmnt,':',aname
      endif
      call md_abort('pre_fix: center not found',9999)
      endif
c
      if(util_print('restart',print_high)) then
      write(lfnout,1000) ifix,jfix,rfix,isgmnt,aname,ifrst,ilast
 1000 format(' fixed ',2i5,f12.6,1x,i5,':',a,5x,2i7)
      endif
c
c     fix solvent molecules
c     ---------------------
c
      do 3 i=1,nwm
      do 4 j=1,nwa
      dx=abs(xw(1,j,i)-xs(1,iatom))
      dy=abs(xw(2,j,i)-xs(2,iatom))
      dz=abs(xw(3,j,i)-xs(3,iatom))
      d2=dx*dx+dy*dy+dz*dz
      if(ifix.eq.1) then
      if(d2.ge.rfix2) iwmr(i)=2
      else
      if(d2.le.rfix2) iwmr(i)=2
      endif
    4 continue
    3 continue
      do 5 i=1,nwmc
      do 6 j=1,nwa
      dx=abs(xwc(1,j,i)-xs(1,iatom))
      dy=abs(xwc(2,j,i)-xs(2,iatom))
      dz=abs(xwc(3,j,i)-xs(3,iatom))
      d2=dx*dx+dy*dy+dz*dz
      if(ifix.eq.1) then
      if(d2.ge.rfix2) iwmrc(i)=2
      else
      if(d2.le.rfix2) iwmrc(i)=2
      endif
    6 continue
    5 continue
c
c     fix atoms
c     ---------
c
      if(jfix.eq.1) then
      do 7 i=1,nsa
      dx=abs(xs(1,i)-xs(1,iatom))
      dy=abs(xs(2,i)-xs(2,iatom))
      dz=abs(xs(3,i)-xs(3,iatom))
      d2=dx*dx+dy*dy+dz*dz
      if(ifix.eq.1) then
      if(d2.ge.rfix2) isar(i)=2
      else
      if(d2.le.rfix2) isar(i)=2
      endif
    7 continue
      else
c
c     fix segments
c     ------------
c
      jfrst=1
      do 8 i=1,nsa
      if(i.eq.nsa) then
      jsgmnt=0
      else
      jsgmnt=isgm(i+1)
      endif
c
      if(jsgmnt.ne.isgm(i)) then
      lsin=.false.
      do 9 j=jfrst,i
      dx=abs(xs(1,j)-xs(1,iatom))
      dy=abs(xs(2,j)-xs(2,iatom))
      dz=abs(xs(3,j)-xs(3,iatom))
      d2=dx*dx+dy*dy+dz*dz
      if(d2.le.rfix2) lsin=.true.
    9 continue
      if((lsin.and.ifix.eq.-1).or.(.not.lsin.and.ifix.eq.1)) then
      do 10 j=jfrst,i
      isar(j)=2
   10 continue
      endif
      jfrst=i+1
      endif
    8 continue
c
      endif
c
      if(csgmnt.ne.'    ') goto 100
  199 continue
c
      pre_fix=.true.
      return
c
 9999 continue
      pre_fix=.false.
      return
      end

      subroutine argos_space_resize(ipmin,ibownr,boxsiz,
     + factor,facx,facy,facz)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
c
      integer ipmin,ibownr(maxbox,3)
      real*8 factor,facx,facy,facz,boxsiz(maxbox,3)
c
      integer ibx,iby,ibz,ipminx,ipminy,ipminz
      real*8 bxi,bxr,byi,byr,bzi,bzr,rfact
c
c     load balancing based on resizing of node domains
c     ------------------------------------------------
c
      ipminx=mod(ipmin,npx)
      ipminy=mod((ipmin-ipminx)/npx,npy)
      ipminz=((ipmin-ipminx)/npx-ipminy)/npy
c
c     resizing boxes in x-dimension
c
      if(npx.gt.1.and.isload.eq.0) then
      do 7 ibx=nbx,2,-1
      boxsiz(ibx,1)=boxsiz(ibx,1)-boxsiz(ibx-1,1)
    7 continue
      bxi=zero
      bxr=zero
      do 8 ibx=1,nbx
      if(ibownr(ibx,1).eq.ipminx) then
      facx=1.0d0/boxsiz(ibx,1)
      boxsiz(ibx,1)=factor*boxsiz(ibx,1)
      if(boxsiz(ibx,1).lt.bxmin) boxsiz(ibx,1)=bxmin
      facx=facx*boxsiz(ibx,1)
      bxi=bxi+boxsiz(ibx,1)
      else
      bxr=bxr+boxsiz(ibx,1)
      endif
    8 continue
      rfact=(box(1)-bxi)/bxr
      do 9 ibx=1,nbx
      if(ibownr(ibx,1).ne.ipminx) boxsiz(ibx,1)=rfact*boxsiz(ibx,1)
      if(ibx.gt.1) boxsiz(ibx,1)=boxsiz(ibx,1)+boxsiz(ibx-1,1)
    9 continue
      endif
c
c     resizing boxes in y-dimension
c
      if(npy.gt.1.and.isload.eq.0) then
      do 10 iby=nby,2,-1
      boxsiz(iby,2)=boxsiz(iby,2)-boxsiz(iby-1,2)
   10 continue
      byi=zero
      byr=zero
      do 11 iby=1,nby
      if(ibownr(iby,2).eq.ipminy) then
      facy=1.0d0/boxsiz(iby,2)
      boxsiz(iby,2)=factor*boxsiz(iby,2)
      if(boxsiz(iby,2).lt.bymin) boxsiz(iby,2)=bymin
      facy=facy*boxsiz(iby,2)
      byi=byi+boxsiz(iby,2)
      else
      byr=byr+boxsiz(iby,2)
      endif
   11 continue
      rfact=(box(2)-byi)/byr
      do 12 iby=1,nby
      if(ibownr(iby,2).ne.ipminy) boxsiz(iby,2)=rfact*boxsiz(iby,2)
      if(iby.gt.1) boxsiz(iby,2)=boxsiz(iby,2)+boxsiz(iby-1,2)
   12 continue
      endif
c
c     resizing boxes in z-dimension
c
      if(npz.gt.1) then
      do 13 ibz=nbz,2,-1
      boxsiz(ibz,3)=boxsiz(ibz,3)-boxsiz(ibz-1,3)
   13 continue
      bzi=zero
      bzr=zero
      do 14 ibz=1,nbz
      if(ibownr(ibz,3).eq.ipminz) then
      facz=1.0d0/boxsiz(ibz,3)
      boxsiz(ibz,3)=factor*boxsiz(ibz,3)
      if(boxsiz(ibz,3).lt.bzmin) boxsiz(ibz,3)=bzmin
      facz=facz*boxsiz(ibz,3)
      bzi=bzi+boxsiz(ibz,3)
      else
      bzr=bzr+boxsiz(ibz,3)
      endif
   14 continue
      rfact=(box(3)-bzi)/bzr
      do 15 ibz=1,nbz
      if(ibownr(ibz,3).ne.ipminz) boxsiz(ibz,3)=rfact*boxsiz(ibz,3)
      if(ibz.gt.1) boxsiz(ibz,3)=boxsiz(ibz,3)+boxsiz(ibz-1,3)
   15 continue
      endif
c
      call ga_brdcst
     + (msp_19,boxsiz,ma_sizeof(mt_dbl,3*maxbox,mt_byte),0)
c
      return
      end
c $Id: argos_space_resize.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function pre_rstmod(lseq,mseq,nseq,lfnmod,filmod,lfnout)
c
c $Id: pre_rstmod.F 19697 2010-10-29 16:57:34Z d3y133 $
c
      implicit none
c
      integer mseq,nseq,lfnmod,lfnout
      integer lseq(mseq)
      character*80 card
      character*255 filmod
c
      integer mset,isgm
c
      open(unit=lfnmod,file=filmod(1:index(filmod,' ')-1),
     + form='formatted',status='old',err=999)
      rewind(unit=lfnmod)
    1 continue
      read(lfnmod,1000,end=99) card
 1000 format(a)
c
      if(card(1:7).eq.'segment') then
      read(card(9:13),'(i5)') isgm
      read(card(18:19),'(i2)') mset
c
      if(card(21:23).eq.'hop') then
cc      if(util_print('where',print_default)) then
      write(lfnout,2019) isgm,mset
 2019 format(' modify segment ',i5,' protonation state ',i5)
cc      endif
      lseq(isgm)=mset
      endif
      endif
      goto 1
 99   continue
c
      close(unit=lfnmod,status='keep')
c
 999  continue
c
      pre_rstmod=.true.
c
      return
      end

*> \brief \b CUNGBR
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download CUNGBR + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/cungbr.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/cungbr.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/cungbr.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CUNGBR( VECT, M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          VECT
*       INTEGER            INFO, K, LDA, LWORK, M, N
*       ..
*       .. Array Arguments ..
*       COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CUNGBR generates one of the complex unitary matrices Q or P**H
*> determined by CGEBRD when reducing a complex matrix A to bidiagonal
*> form: A = Q * B * P**H.  Q and P**H are defined as products of
*> elementary reflectors H(i) or G(i) respectively.
*>
*> If VECT = 'Q', A is assumed to have been an M-by-K matrix, and Q
*> is of order M:
*> if m >= k, Q = H(1) H(2) . . . H(k) and CUNGBR returns the first n
*> columns of Q, where m >= n >= k;
*> if m < k, Q = H(1) H(2) . . . H(m-1) and CUNGBR returns Q as an
*> M-by-M matrix.
*>
*> If VECT = 'P', A is assumed to have been a K-by-N matrix, and P**H
*> is of order N:
*> if k < n, P**H = G(k) . . . G(2) G(1) and CUNGBR returns the first m
*> rows of P**H, where n >= m >= k;
*> if k >= n, P**H = G(n-1) . . . G(2) G(1) and CUNGBR returns P**H as
*> an N-by-N matrix.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] VECT
*> \verbatim
*>          VECT is CHARACTER*1
*>          Specifies whether the matrix Q or the matrix P**H is
*>          required, as defined in the transformation applied by CGEBRD:
*>          = 'Q':  generate Q;
*>          = 'P':  generate P**H.
*> \endverbatim
*>
*> \param[in] M
*> \verbatim
*>          M is INTEGER
*>          The number of rows of the matrix Q or P**H to be returned.
*>          M >= 0.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of columns of the matrix Q or P**H to be returned.
*>          N >= 0.
*>          If VECT = 'Q', M >= N >= min(M,K);
*>          if VECT = 'P', N >= M >= min(N,K).
*> \endverbatim
*>
*> \param[in] K
*> \verbatim
*>          K is INTEGER
*>          If VECT = 'Q', the number of columns in the original M-by-K
*>          matrix reduced by CGEBRD.
*>          If VECT = 'P', the number of rows in the original K-by-N
*>          matrix reduced by CGEBRD.
*>          K >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is COMPLEX array, dimension (LDA,N)
*>          On entry, the vectors which define the elementary reflectors,
*>          as returned by CGEBRD.
*>          On exit, the M-by-N matrix Q or P**H.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A. LDA >= M.
*> \endverbatim
*>
*> \param[in] TAU
*> \verbatim
*>          TAU is COMPLEX array, dimension
*>                                (min(M,K)) if VECT = 'Q'
*>                                (min(N,K)) if VECT = 'P'
*>          TAU(i) must contain the scalar factor of the elementary
*>          reflector H(i) or G(i), which determines Q or P**H, as
*>          returned by CGEBRD in its array argument TAUQ or TAUP.
*> \endverbatim
*>
*> \param[out] WORK
*> \verbatim
*>          WORK is COMPLEX array, dimension (MAX(1,LWORK))
*>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>          The dimension of the array WORK. LWORK >= max(1,min(M,N)).
*>          For optimum performance LWORK >= min(M,N)*NB, where NB
*>          is the optimal blocksize.
*>
*>          If LWORK = -1, then a workspace query is assumed; the routine
*>          only calculates the optimal size of the WORK array, returns
*>          this value as the first entry of the WORK array, and no error
*>          message related to LWORK is issued by XERBLA.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date April 2012
*
*> \ingroup complexGBcomputational
*
*  =====================================================================
      SUBROUTINE CUNGBR( VECT, M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK computational routine (version 3.4.1) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     April 2012
*
*     .. Scalar Arguments ..
      CHARACTER          VECT
      INTEGER            INFO, K, LDA, LWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX            A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX            ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0E+0, 0.0E+0 ),
     $                   ONE = ( 1.0E+0, 0.0E+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, WANTQ
      INTEGER            I, IINFO, J, LWKOPT, MN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           ILAENV, LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           CUNGLQ, CUNGQR, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      WANTQ = LSAME( VECT, 'Q' )
      MN = MIN( M, N )
      LQUERY = ( LWORK.EQ.-1 )
      IF( .NOT.WANTQ .AND. .NOT.LSAME( VECT, 'P' ) ) THEN
         INFO = -1
      ELSE IF( M.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 .OR. ( WANTQ .AND. ( N.GT.M .OR. N.LT.MIN( M,
     $         K ) ) ) .OR. ( .NOT.WANTQ .AND. ( M.GT.N .OR. M.LT.
     $         MIN( N, K ) ) ) ) THEN
         INFO = -3
      ELSE IF( K.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -6
      ELSE IF( LWORK.LT.MAX( 1, MN ) .AND. .NOT.LQUERY ) THEN
         INFO = -9
      END IF
*
      IF( INFO.EQ.0 ) THEN
         WORK( 1 ) = 1
         IF( WANTQ ) THEN
            IF( M.GE.K ) THEN
               CALL CUNGQR( M, N, K, A, LDA, TAU, WORK, -1, IINFO )
            ELSE
               IF( M.GT.1 ) THEN
                  CALL CUNGQR( M-1, M-1, M-1, A( 2, 2 ), LDA, TAU, WORK,
     $                         -1, IINFO )
               END IF
            END IF
         ELSE
            IF( K.LT.N ) THEN
               CALL CUNGLQ( M, N, K, A, LDA, TAU, WORK, -1, IINFO )
            ELSE
               IF( N.GT.1 ) THEN
                  CALL CUNGLQ( N-1, N-1, N-1, A( 2, 2 ), LDA, TAU, WORK,
     $                         -1, IINFO )
               END IF
            END IF
         END IF
         LWKOPT = WORK( 1 )
         LWKOPT = MAX (LWKOPT, MN)
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'CUNGBR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         WORK( 1 ) = LWKOPT
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( WANTQ ) THEN
*
*        Form Q, determined by a call to CGEBRD to reduce an m-by-k
*        matrix
*
         IF( M.GE.K ) THEN
*
*           If m >= k, assume m >= n >= k
*
            CALL CUNGQR( M, N, K, A, LDA, TAU, WORK, LWORK, IINFO )
*
         ELSE
*
*           If m < k, assume m = n
*
*           Shift the vectors which define the elementary reflectors one
*           column to the right, and set the first row and column of Q
*           to those of the unit matrix
*
            DO 20 J = M, 2, -1
               A( 1, J ) = ZERO
               DO 10 I = J + 1, M
                  A( I, J ) = A( I, J-1 )
   10          CONTINUE
   20       CONTINUE
            A( 1, 1 ) = ONE
            DO 30 I = 2, M
               A( I, 1 ) = ZERO
   30       CONTINUE
            IF( M.GT.1 ) THEN
*
*              Form Q(2:m,2:m)
*
               CALL CUNGQR( M-1, M-1, M-1, A( 2, 2 ), LDA, TAU, WORK,
     $                      LWORK, IINFO )
            END IF
         END IF
      ELSE
*
*        Form P**H, determined by a call to CGEBRD to reduce a k-by-n
*        matrix
*
         IF( K.LT.N ) THEN
*
*           If k < n, assume k <= m <= n
*
            CALL CUNGLQ( M, N, K, A, LDA, TAU, WORK, LWORK, IINFO )
*
         ELSE
*
*           If k >= n, assume m = n
*
*           Shift the vectors which define the elementary reflectors one
*           row downward, and set the first row and column of P**H to
*           those of the unit matrix
*
            A( 1, 1 ) = ONE
            DO 40 I = 2, N
               A( I, 1 ) = ZERO
   40       CONTINUE
            DO 60 J = 2, N
               DO 50 I = J - 1, 2, -1
                  A( I, J ) = A( I-1, J )
   50          CONTINUE
               A( 1, J ) = ZERO
   60       CONTINUE
            IF( N.GT.1 ) THEN
*
*              Form P**H(2:n,2:n)
*
               CALL CUNGLQ( N-1, N-1, N-1, A( 2, 2 ), LDA, TAU, WORK,
     $                      LWORK, IINFO )
            END IF
         END IF
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of CUNGBR
*
      END
c $Id: cungbr.f 24343 2013-06-22 05:35:15Z d3y133 $

      logical function argos_prepare_repeat(card,lfnout,drep,box,
     + csa,isat,isgm,xs,vs,msa,nsa,xw,vw,mwm,mwa,nwm,nwa,
     + xwc,vwc,mwmc,nwmc)
c
c $Id: argos_prepare_repeat.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "util.fh"
c
      integer msa,nsa,mwm,nwm,mwa,nwa,mwmc,nwmc,lfnout
      integer isat(msa),isgm(msa)
      character*16 csa(msa)
      real*8 xs(3,msa),vs(3,msa),xw(3,mwa,mwm),vw(3,mwa,mwm)
      real*8 xwc(3,mwa,mwmc),vwc(3,mwa,mwmc),drep(3),box(3)
      character*80 card
c
      integer i,j,k,imin(3),jmin(3)
      real*8 xmax,xmin,dx(3),ds(3),r2min(3),r2(3)
      real*8 touch,ddx(3)
      logical done
c
      read(card(23:34),'(f12.6)') touch
c
      if(touch.le.0.0d0.and.box(1).gt.0.0d0.and.
     + box(2).gt.0.0d0.and.box(3).gt.0.0d0) then
      drep(1)=box(1)
      drep(2)=box(2)
      drep(3)=box(3)
      argos_prepare_repeat=.true.
      return
      endif
c
      do 1 k=1,3
      ddx(k)=touch
      xmax=xs(k,1)
      xmin=xs(k,1)
      do 2 i=2,nsa
      if(xs(k,i).gt.xmax) xmax=xs(k,i)
      if(xs(k,i).lt.xmin) xmin=xs(k,i)
    2 continue
      dx(k)=xmax-xmin+1.5d0*touch
    1 continue
c
      if(util_print('restart',print_high)) then
      write(lfnout,1000)
 1000 format(/,' Convergence',/,15x,'x',11x,'y',11x,'z',/)
      endif
c
   10 continue
c
      do 3 k=1,3
      imin(k)=1
      jmin(k)=1
      r2min(k)=1.0e24
    3 continue
c
      do 4 i=1,nsa
      do 5 j=1,nsa
      do 6 k=1,3
      ds(k)=xs(k,j)-xs(k,i)
    6 continue
      r2(1)=(ds(1)+dx(1))**2+ds(2)**2+ds(3)**2
      r2(2)=ds(1)**2+(ds(2)+dx(2))**2+ds(3)**2
      r2(3)=ds(1)**2+ds(2)**2+(ds(3)+dx(3))**2
      do 7 k=1,3
      if(r2(k).lt.r2min(k)) then
      imin(k)=i
      jmin(k)=j
      r2min(k)=r2(k)
      endif
    7 continue
    5 continue
    4 continue
c
c      write(*,'(a,3f12.6)') 'x ',(dx(k),k=1,3)
c      write(*,'(a,3f12.6)') 'r ',(sqrt(r2min(k)),k=1,3)
c
      done=.true.
c
      do 9 k=1,3
      if(sqrt(r2min(k)).lt.touch) then
      dx(k)=dx(k)+ddx(k)
      ddx(k)=0.5d0*ddx(k)
      endif
      dx(k)=dx(k)-ddx(k)
      if(ddx(k).gt.0.01) done=.false.
    9 continue
c
      if(util_print('restart',print_high)) then
      write(lfnout,1001) ddx
 1001 format(10x,3f12.6)
      endif
c
      if(.not.done) goto 10
c
      do 8 k=1,3
      drep(k)=dx(k)
    8 continue
c
      if(util_print('restart',print_medium)) then
      write(lfnout,1002)
 1002 format(' Repeat separation determined')
      endif
c
      argos_prepare_repeat=.true.
      return
c
 9999 continue
      argos_prepare_repeat=.false.
      return
      end

      SUBROUTINE tce_y1_offset_new(l_a_offset,k_a_offset,size,irrep)
C     $Id: tce_y1_offset_new.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     y ( h4 p1 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h4b
      INTEGER p1b
      integer irrep
      length = 0
      DO h4b = 1,noab
        DO p1b = noab+1,noab+nvab
          IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
            IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1))
     &          .eq. irrep) THEN
              IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+
     &                                  int_mb(k_spin+p1b-1).ne.4)) THEN
                length = length + 1
              END IF
            END IF
          END IF
        END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,
     &         k_a_offset)) CALL ERRQUIT('tce_y1_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h4b = 1,noab
        DO p1b = noab+1,noab+nvab
          IF (int_mb(k_spin+h4b-1) .eq. int_mb(k_spin+p1b-1)) THEN
            IF (ieor(int_mb(k_sym+h4b-1),int_mb(k_sym+p1b-1)) 
     &          .eq. irrep) THEN
              IF ((.not.restricted).or.(int_mb(k_spin+h4b-1)+
     &                                  int_mb(k_spin+p1b-1).ne.4)) THEN
                addr = addr + 1
                int_mb(k_a_offset+addr)=p1b-noab-1+nvab*(h4b-1)
                int_mb(k_a_offset+length+addr)=size
                size=size+int_mb(k_range+h4b-1)*int_mb(k_range+p1b-1)
              END IF
            END IF
          END IF
        END DO
      END DO
      RETURN
      END

      subroutine get_mo_rdm_ph(d_r1,k_r1_offset,k_rdm,denominator)
c
c Prints the particle-hole block of the 1-e reduced density matrix
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "util.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_r1
      integer p1b
      integer h2b
      integer p1
      integer h2
      integer k_r1_offset
      integer size
      integer l_r1,k_r1
      integer i
      logical nodezero
      character*4 irrep_p,irrep_h
      character*5 spinnames(2),spin_p,spin_h
      data spinnames/'alpha','beta '/
c->pengdong.fan
      integer k_rdm
      integer ip1,ih2,ipp1,ihh2,ind,np,nh,ind1,ind2,ind3
      double precision denominator
c<-pengdong.fan
c
      nodezero = (ga_nodeid().eq.0)
c      if (nodezero) write(LuOut,9000) 'particle-hole block'
      np=nmo(1)+nmo(ipol)-nocc(1)-nocc(ipol)
      nh=nocc(1)+nocc(ipol)
      do p1b = noab+1,noab+nvab
        do h2b = 1,noab
          if (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h2b-1)) then 
          if ((.not.restricted).or.(int_mb(k_spin+p1b-1)
     1      +int_mb(k_spin+h2b-1).ne.4)) then
          if (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h2b-1))
     1      .eq.irrep_e) then
            size = int_mb(k_range+p1b-1) * int_mb(k_range+h2b-1)
            if (.not.ma_push_get(mt_dbl,size,'r1',l_r1,k_r1))
     1        call errquit('tce_print_ph: MA problem',0,MA_ERR)
            call get_hash_block(d_r1,dbl_mb(k_r1),size,
     1        int_mb(k_r1_offset),((p1b-noab-1)*noab+h2b-1))
            i = 0
            do p1 = 1,int_mb(k_range+p1b-1)
              do h2 = 1,int_mb(k_range+h2b-1)
                i = i + 1
c                call sym_irrepname(geom,int_mb(k_sym+p1b-1)+1,irrep_p)
c                call sym_irrepname(geom,int_mb(k_sym+h2b-1)+1,irrep_h)
c                spin_p = spinnames(int_mb(k_spin+p1b-1))
c                spin_h = spinnames(int_mb(k_spin+h2b-1))
                ip1=int_mb(k_offset+p1b-1)+p1-1
                ih2=int_mb(k_offset+h2b-1)+h2-1
                ipp1=int_mb(k_mo_index+ip1)
                ihh2=int_mb(k_mo_index+ih2)
                ind=(ipp1-nh-1)+(ihh2-1)*np
                dbl_mb(k_rdm+ind)=dbl_mb(k_r1+i-1)/denominator
c                if (nodezero) write(LuOut,9010) 
c     1            int_mb(k_offset+p1b-1)+p1,irrep_p,spin_p,
c     2            int_mb(k_offset+h2b-1)+h2,irrep_h,spin_h,
c     2            dbl_mb(k_r1+i-1),ipp1,ihh2
              enddo
            enddo
            if (.not.ma_pop_stack(l_r1))
     1        call errquit('tce_print_ph: MA problem',1,MA_ERR)
          endif
          endif
          endif
        enddo
      enddo
      if(restricted) then
         do ip1 = 1,nmo(ipol)-nocc(ipol)
            ind1 = (2*ip1-1)
            ind2 = (2*ip1-1-1)
            do ih2 = 1,nocc(ipol)
               ind  = ind1+(2*ih2-1)*np
               ind3 = ind2+(2*ih2-1-1)*np
               dbl_mb(k_rdm+ind) = dbl_mb(k_rdm+ind3)
            enddo
         enddo
      endif
c      do ip1=1,np
c         ind1=(ip1-1)
c         do ih2=1,nh
c            ind=ind1+(ih2-1)*np
c            if(dabs(dbl_mb(k_rdm+ind)).gt.1.d-10) then
c              if(nodezero) write(LuOut,'(f30.16,i5,i5)') 
c     1           dbl_mb(k_rdm+ind),ip1+nh,ih2
c            endif
c         enddo
c      enddo
      call ga_sync()
 9000 format(/,1x,a)
 9010 format(1x,i3,a4,'(',a5,') --- ',i3,a4,'(',a5,')',f20.5,i4,i4)
      return
      end
c $Id: get_mo_rdm_ph.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_cafe_comw(xw,xwm,iwfr,iwto)
c
      implicit none
c
#include "argos_cafe_common.fh"
#include "mafdecls.fh"
c
      integer iwfr,iwto
      real*8 xw(mwm,3,mwa),xwm(mwm,3)
c
      call argos_cafe_cmw(xw,xwm,iwfr,iwto,int_mb(i_iwa),dbl_mb(i_mas))
c
      return
      end
c $Id: argos_cafe_comw.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine deletefile(d_sf)
c
c $Id: deletefile.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Creates a shared file and returns the handle
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "eaf.fh"
#include "dra.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_sf
      integer d_temp
      logical nodezero
      logical parallel
      integer i,j
      logical used
      character*255 filename
c
      cpusecs(2) = cpusecs(2) - util_cpusec()
      cpusecs(52) = cpusecs(52) - util_wallsec()
      nodezero = (ga_nodeid().eq.0)
      parallel = (ga_nnodes().gt.1)
      if (nodezero.and.util_print('files',print_debug))
     1  write(LuOut,9000) d_sf
      if (ioalg.eq.0) then
        if (parallel) call ga_sync()
        if (nfiles.eq.0)
     1    call errquit('deletefile: there is no file',nfiles,
     2    UNKNOWN_ERR)
        used = .false.
        do i = 1,nfiles
          if (filehandles(i).eq.d_sf) then
            filename = filenames(i)
            j = i
            used = .true.
          endif
        enddo
        if (.not.used)
     1    call errquit('deletefile: there is no such file',d_sf,
     2    UNKNOWN_ERR)
        if (j.lt.nfiles) then
          do i = j+1,nfiles
            filehandles(i-1) = filehandles(i)
            filenames(i-1) = filenames(i)
          enddo
        endif
        close(d_sf)
        if (parallel) call ga_sync()
        if (nodezero) then
          call util_file_unlink(filename)
        endif
        nfiles = nfiles - 1
        if (nodezero.and.util_print('files',print_debug)) then
          do i = 1,nfiles
            write(LuOut,9010) filehandles(i),filenames(i)(1:40)
          enddo
        endif
        if (parallel) call ga_sync()
      else if (ioalg.eq.1) then
        if (nfiles.eq.0)
     1    call errquit('deletefile: there is no file',nfiles,
     2    UNKNOWN_ERR)
        used = .false.
        do i = 1,nfiles
          if (filehandles(i).eq.d_sf) then
            filename = filenames(i)
            j = i
            used = .true.
          endif
        enddo
        if (.not.used)
     1    call errquit('deletefile: there is no such file',d_sf,
     2    UNKNOWN_ERR)
        if (j.lt.nfiles) then
          do i = j+1,nfiles
            filehandles(i-1) = filehandles(i)
            filenames(i-1) = filenames(i)
          enddo
        endif
        if (parallel) then
          call ga_sync()
          if (nodezero) then
            call util_file_unlink(filename)
          endif
          call ga_sync()
        else
          if (eaf_close(d_sf).ne.0)
     1      call errquit('deletefile: eaf problem',0,DISK_ERR)
          call util_file_unlink(filename)
        endif
        nfiles = nfiles - 1
        if (nodezero.and.util_print('files',print_debug)) then
          do i = 1,nfiles
            write(LuOut,9010) filehandles(i),filenames(i)(1:40)
          enddo
        endif
      else if (ioalg.eq.2) then
        if (.not.ga_destroy(d_sf))
     1    call errquit('deletefile: GA problem',0,GA_ERR)
      else if (ioalg.eq.3) then
        if (parallel) then
          call ga_sync()
          if (sf_open(d_sf).ne.0)
     1      call errquit('deletefile: sf problem',0,DISK_ERR)
        endif
        if (sf_destroy(d_sf).ne.0)
     1    call errquit('deletefile: sf problem',1,DISK_ERR)
        if (parallel) call ga_sync()
      else if (ioalg.eq.4) then
        if (nfiles.eq.0)
     1    call errquit('deletefile: there is no file',nfiles,
     2    UNKNOWN_ERR)
        used = .false.
        do i = 1,nfiles
          if (filehandles(i).eq.d_sf) then
            filename = filenames(i)
            j = i
            used = .true.
          endif
        enddo
        if (.not.used)
     1    call errquit('deletefile: there is no such file',d_sf,
     2    UNKNOWN_ERR)
        if (j.lt.nfiles) then
          do i = j+1,nfiles
            filehandles(i-1) = filehandles(i)
            filenames(i-1) = filenames(i)
          enddo
        endif
        if (eaf_close(d_sf).ne.0)
     1    call errquit('deletefile: eaf problem',0,DISK_ERR)
        call util_file_unlink(filename)
        nfiles = nfiles - 1
        if (nodezero.and.util_print('files',print_debug)) then
          do i = 1,nfiles
            write(LuOut,9010) filehandles(i),filenames(i)(1:40)
          enddo
        endif
      else if (ioalg.eq.5) then
        if (fileisga(d_sf)) then
          if (.not.ga_destroy(filehandles(d_sf)))
     1      call errquit('deletefile: GA problem',0,GA_ERR)
        else
          if (dra_open(filenames(d_sf),DRA_R,d_temp).ne.0)
     1      call errquit('deletefile: dra problem',0,DISK_ERR)
          if (dra_delete(d_temp).ne.0)
     1      call errquit('deletefile: dra problem',1,DISK_ERR)
        endif
        filehandles(d_sf) = 2**30
        if (d_sf.eq.nfiles) nfiles = nfiles - 1
        if (nodezero.and.util_print('files',print_debug))
     1    call filesummary
      else if (ioalg.eq.6) then
        if (fileisga(d_sf)) then
          if (.not.ga_destroy(filehandles(d_sf))) then
            write(LuOut,9010) filehandles(d_sf),filenames(d_sf)
            call errquit('deletefile: GA problem',0,GA_ERR)
          endif
        else
          if (eaf_close(filehandles(d_sf)).ne.0) then
            write(LuOut,9010) filehandles(d_sf),filenames(d_sf)
            call errquit('deletefile: eaf problem',0,DISK_ERR)
          endif
          call util_file_unlink(filenames(d_sf))
        endif
        filehandles(d_sf) = 2**30
        if (d_sf.eq.nfiles) nfiles = nfiles - 1
      endif
      cpusecs(2) = cpusecs(2) + util_cpusec()
      cpusecs(52) = cpusecs(52) + util_wallsec()
 9000 format(1x,'delete a file: file handle = ',i9)
 9010 format(1x,'file handle = ',i9,' file name = ',a)
      return
      end



















      subroutine deletefile_sf(d_sf)
c
c $Id: deletefile.F 19706 2010-10-29 17:52:31Z d3y133 $
c
c     Creates a shared file and returns the handle
c
      implicit none
#include "global.fh"
#include "mafdecls.fh"
#include "stdio.fh"
#include "util.fh"
#include "sf.fh"
#include "eaf.fh"
#include "dra.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      integer d_sf
      integer d_temp
      logical nodezero
      logical parallel
      integer i,j
      logical used
      character*255 filename
c
      cpusecs(2) = cpusecs(2) - util_cpusec()
      cpusecs(52) = cpusecs(52) - util_wallsec()
      nodezero = (ga_nodeid().eq.0)
      parallel = (ga_nnodes().gt.1)
      if (nodezero.and.util_print('files',print_debug))
     1  write(LuOut,9000) d_sf
c
c      else if (ioalg.eq.3) then
c
        if (parallel) then
          call ga_sync()
          if (sf_open(d_sf).ne.0)
     1      call errquit('deletefile: sf problem',0,DISK_ERR)
        endif
        if (sf_destroy(d_sf).ne.0)
     1    call errquit('deletefile: sf problem',1,DISK_ERR)
        if (parallel) call ga_sync()
c
c      endif
c
      cpusecs(2) = cpusecs(2) + util_cpusec()
      cpusecs(52) = cpusecs(52) + util_wallsec()
 9000 format(1x,'delete a file: file handle = ',i9)
 9010 format(1x,'file handle = ',i9,' file name = ',a)
      return
      end

      subroutine argos_space_acfbl(ibbl,lhandl,fw,fs,lbbl,jpl,
     + lpair,iwz,isz)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
c
      integer ibbl,lhandl
      real*8 fw(mwm,3,mwa,2),fs(msa,3,2)
      integer lbbl(mbbl,mbb2)
      integer jpl(mbox,mip2)
      logical lpair
      integer iwz(mwm),isz(msa)
c
      integer i,j,k,l,m,ibox,jbox,jnode,il,ih,jl,jh,ndx,nwnon,nsnon
      integer jwfr,jwto,jsfr,jsto
c
      if(ibbl.le.0.or.ibbl.gt.nbbl)
     + call md_abort('Index to lbbl out of range',ibbl)
c
      jnode=lbbl(ibbl,1)
      jbox=lbbl(ibbl,2)
      ibox=lbbl(ibbl,3)
      lbbl(ibbl,4)=lhandl
c
      if(jnode.eq.me) return
      if(ibbl.lt.nbbl) then
      if(lbbl(ibbl+1,1).eq.jnode.and.lbbl(ibbl+1,2).eq.jbox) return
      endif
c
      ndx=0
      do 3 i=1,jpl(1,1)
      if(jpl(30+i,1).eq.jbox) ndx=30+i
    3 continue
      if(ndx.eq.0)
     + call md_abort('Remote processor cell not found (2) ',0)
      jwfr=jpl(ndx,2)
      jwto=jpl(ndx,3)
      jsfr=jpl(ndx,4)
      jsto=jpl(ndx,5)
      if(jwfr.gt.0) then
      nwnon=jwto-jwfr+1
      if(nwmloc+nwnon.gt.mwm)
     + call md_abort('Dimension mwm too small',nwmloc+nwnon)
      call ga_distribution(ga_w,jnode,il,ih,jl,jh)
      call ga_acc(ga_w,il+jwfr-1,il+jwto-1,jl+6*mwa+3,jl+9*mwa+2,
     + fw(nwmloc+1,1,1,1),mwm,one)
      if(llong) call ga_acc(ga_w,il+jwfr-1,il+jwto-1,jl+9*mwa+3,
     + jl+12*mwa+2,fw(nwmloc+1,1,1,2),mwm,one)
      if(lpair) then
      call ga_distribution(ga_iwz,jnode,il,ih,jl,jh)
      call ga_acc(ga_iwz,il+jwfr-1,il+jwto-1,jl,jl,iwz(nwmloc+1),mwm,1)
      endif
      endif
      if(jsfr.gt.0) then
      nsnon=jsto-jsfr+1
      if(nsaloc+nsnon.gt.msa)
     + call md_abort('Dimension msa too small (5)',nsaloc+nsnon)
      call ga_distribution(ga_s,jnode,il,ih,jl,jh)
      call ga_acc(ga_s,il+jsfr-1,il+jsto-1,jl+6,jl+8,
     + fs(nsaloc+1,1,1),msa,one)
      if(llong) call ga_acc(ga_s,il+jsfr-1,il+jsto-1,jl+9,jl+11,
     + fs(nsaloc+1,1,2),msa,one)
      if(lpair) then
      call ga_distribution(ga_isz,jnode,il,ih,jl,jh)
      call ga_acc(ga_isz,il+jsfr-1,il+jsto-1,jl,jl,isz(nsaloc+1),msa,1)
      endif
      endif
c
      m=1
      if(llong) m=2
c
      do 9 l=1,m
      do 4 k=1,mwa
      do 5 j=1,3
      do 6 i=nwmloc+1,mwm
      fw(i,j,k,l)=zero
    6 continue
    5 continue
    4 continue
c
      do 7 j=1,3
      do 8 i=nsaloc+1,msa
      fs(i,j,l)=zero
    8 continue
    7 continue
    9 continue
c
      do 10 i=nwmloc+1,mwm
      iwz(i)=0
   10 continue
      do 11 i=nsaloc+1,msa
      isz(i)=0
   11 continue
c
      return
      end
c $Id: argos_space_acfbl.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function argos_prop_rmri(lfnmri,ndec,mropt,dfr,dfrm)
c
      implicit none
c
#include "argos_prop.fh"
c
      logical argos_cafe_rdmri
      external argos_cafe_rdmri
c
      integer lfnmri,ndec,mropt
      real*8 dfr(mda),dfrm(mda),dtmp
c
      integer i,nprp,nmxp
c
      read(lfnmri,err=9,end=9) nderiv,nda,nprp,nsum,nsumt,ndec,nmxp
      if(mropt.ne.2) then
      if(nprop.ne.nprp) then
      call md_abort('Number of properties nprop changed',0)
      endif
      if(maxp.ne.nmxp) then
      call md_abort('Number of properties maxp changed',0)
      endif
      endif
      read(lfnmri,err=9,end=9) deriv
      if(mda.lt.nda) then
      read(lfnmri,err=9,end=9) (dtmp,i=1,nda)
      read(lfnmri,err=9,end=9) (dtmp,i=1,nda)
      else
      read(lfnmri,err=9,end=9) (dfr(i),i=1,nda)
      read(lfnmri,err=9,end=9) (dfrm(i),i=1,nda)
      endif
      read(lfnmri,err=9,end=9) tsum,t2sum,tsumt,t2sumt
      if(mropt.ne.2) then
      read(lfnmri,err=9,end=9) (psum(i),i=1,maxp)
      read(lfnmri,err=9,end=9) (p2sum(i),i=1,maxp)
      read(lfnmri,err=9,end=9) (pslop(i),i=1,maxp)
      read(lfnmri,err=9,end=9) (psumt(i),i=1,maxp)
      read(lfnmri,err=9,end=9) (p2sumt(i),i=1,maxp)
      read(lfnmri,err=9,end=9) (pslopt(i),i=1,maxp)
      else
      do 1 i=1,6
      read(lfnmri,err=9,end=9) dtmp
    1 continue
      endif
      if(ndec.gt.0) then
      argos_prop_rmri=argos_cafe_rdmri(lfnmri)
      else
      argos_prop_rmri=.true.
      endif
      return
c
    9 continue
      argos_prop_rmri=.false.
      return
      end
c $Id: argos_prop_rmri.F 21176 2011-10-10 06:35:49Z d3y133 $

      SUBROUTINE ccsdtq_lr_alpha_6_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k
     &_c_offset)
C     $Id: ccsdtq_lr_alpha_6_4.F 19703 2010-10-29 17:30:23Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 h1 )_ytrb + = 1/144 * Sum ( h7 h8 h9 p3 p4 p5 p6 ) * trb ( p3 p4 p5 p6 h1 h7 h8 h9 )_trb * y ( h2 h7 h8 h9 p3 p4 p5 p6 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h7b
      INTEGER h8b
      INTEGER h9b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER p5b_1
      INTEGER p6b_1
      INTEGER h1b_1
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER h9b_1
      INTEGER h2b_2
      INTEGER h7b_2
      INTEGER h8b_2
      INTEGER h9b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER p5b_2
      INTEGER p6b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(4)
      INTEGER isuperp
      INTEGER nsubh(3)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+h2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &y,irrep_trb)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_6_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO p5b = p4b,noab+nvab
      DO p6b = p5b,noab+nvab
      DO h7b = 1,noab
      DO h8b = h7b,noab
      DO h9b = h8b,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)+int_mb(k_spin+p5b-1)
     &+int_mb(k_spin+p6b-1) .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h7b-
     &1)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h9b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(k_sym+h1b-1),ieo
     &r(int_mb(k_sym+h7b-1),ieor(int_mb(k_sym+h8b-1),int_mb(k_sym+h9b-1)
     &))))))) .eq. irrep_trb) THEN
      CALL TCE_RESTRICTED_8(p3b,p4b,p5b,p6b,h1b,h7b,h8b,h9b,p3b_1,p4b_1,
     &p5b_1,p6b_1,h1b_1,h7b_1,h8b_1,h9b_1)
      CALL TCE_RESTRICTED_8(h2b,h7b,h8b,h9b,p3b,p4b,p5b,p6b,h2b_2,h7b_2,
     &h8b_2,h9b_2,p3b_2,p4b_2,p5b_2,p6b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_mb(k_range+h7b-1) *
     & int_mb(k_range+h8b-1) * int_mb(k_range+h9b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_6_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_6_4',2,MA_ERR)
      IF ((h9b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h9b_1 - 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+h1b-1),8,7,6,5,4,3,2,1,-1.0d0)
      END IF
      IF ((h8b .lt. h1b) .and. (h1b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h9b-1),7,8,6,5,4,3,2,1,1.0d0)
      END IF
      IF ((h7b .lt. h1b) .and. (h1b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h1b_1 - 1 + noab * (h7b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h1b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),6,8,7,5,4,3,2,1,-1.0d0)
      END IF
      IF ((h1b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h9b_1
     & - 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1 + noab * (h1b_1 - 1 +
     & noab * (p6b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p4b
     &_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p5b-1),int_mb(k_range+p6b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h7b-1),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h9b-1),5,8,7,6,4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lr_alpha_6_4',3,M
     &A_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdtq_lr_alpha_6_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_6_4',5,MA_ERR)
      IF ((h9b .lt. h2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h2b_2 - 1 + noab * (h9b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h9b-1),int_mb(k_range+h2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),4,3,2,1,8,7,6,5,-1.0d0)
      END IF
      IF ((h8b .lt. h2b) .and. (h2b .le. h9b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h9b_2 - 1 + noab * (h2b_2 - 1
     & + noab * (h8b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h2b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),3,4,2,1,8,7,6,5,1.0d0)
      END IF
      IF ((h7b .lt. h2b) .and. (h2b .le. h8b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h9b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h2b_2 - 1 + noab * (h7b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),2,4,3,1,8,7,6,5,-1.0d0)
      END IF
      IF ((h2b .le. h7b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p6b_2
     & - noab - 1 + nvab * (p5b_2 - noab - 1 + nvab * (p4b_2 - noab - 1 
     &+ nvab * (p3b_2 - noab - 1 + nvab * (h9b_2 - 1 + noab * (h8b_2 - 1
     & + noab * (h7b_2 - 1 + noab * (h2b_2 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h7b-1),int_mb(k_range+h8b-1),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p6b-1),1,4,3,2,8,7,6,5,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdtq_lr_alpha_6_4',6,M
     &A_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      nsuperp(3) = 1
      nsuperp(4) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      IF (p4b .eq. p5b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      IF (p5b .eq. p6b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      nsubh(3) = 1
      isubh = 1
      IF (h7b .eq. h8b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      IF (h8b .eq. h9b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,144.0d0/FACTORIA
     &L(nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsuperp(3))/FACTORIA
     &L(nsuperp(4))/FACTORIAL(nsubh(1))/FACTORIAL(nsubh(2))/FACTORIAL(ns
     &ubh(3)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_6_4
     &',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_6_4
     &',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lr_alpha_6_4',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h1b-1),1,2,1.0d0/144.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (h2b - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lr_alpha_6_4',10,
     &MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdtq_lr_alpha_6_4
     &',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

       SUBROUTINE ex_inter(n,ist,irecord,jbuf,ierr)

       implicit none

       integer i,j,n,ifact,ist,nstart,ierr
       integer jbuf,irec_len

       character*1 cchar,irecord

       parameter(irec_len=100)

       dimension cchar(15),irecord(irec_len)

       data cchar/'0','1','2','3','4','5','6','7','8','9','+','&','/',
     $            '-','.'/

       jbuf=0
       ierr=0
       nstart=ist+n-1
       ifact=1
       do i = 1,n
        do j=1,14
          if(cchar(j).eq.irecord(nstart))goto 120
        enddo
110     ierr=1
        return
120     if(j.lt.11)goto 130
        if(nstart.ne.ist)goto 110
        if(j.ge.14)jbuf=-jbuf
        goto 150
130     jbuf=jbuf+(j-1)*ifact
        ifact=ifact*10
        nstart=nstart-1
       enddo

150    return

       END
c $Id: extrct_inte.f 22502 2012-05-20 06:11:57Z d3y133 $

      subroutine argos_diana_init
c
c $Id: argos_diana_init.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c
c     initialize variables
c     --------------------
c
c
      implicit none
c
#include "argos_diana_common.fh"
#include "argos_diana_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer i
      character*255 filcmd
c
c     set sequential access to rtdb
c     and ignore current state
c
      ignore=rtdb_parallel(.false.)
c
      lfnram=60
      lfndat=61
      lfnexp=62
      lfntcl=63
      lfnpca=64
      lfnavg=65
      lfnhol=66
      lfnpin=67
      lfnpou=68
      lfncmd=69
      lfnloc=70
      lfnhba=71
      lfnecc=72
      lfnrdf=73
      lfnref=76
      lfntrj=77
      lfncop=78
      lfnsup=79
      lfnchg=80
      lfnplt=81
      lfnxyz=82
      lfnana=83
      lfnrms=84
      lfnprj=85
      lfnval=86
      lfncov=87
      lfnvec=88
      lfnmin=89
      lfnmax=90
      lfntop=91
      lfnhis=92
      lfnepz=93
      lfngrp=94
      lfnord=95
      lfnsel=96
      lfndie=97
      lfnamp=98
c
      ntval=0
      ntvec=0
c
      ltop=.false.
c
      do 44 i=1,mhis
      idhis(i,3)=40+i
   44 continue
c      do 46 i=1,mord
c      rord(i,1)=zero
c      rord(i,2)=zero
c   46 continue
c
      lsonly=.false.
      lsuper=.false.
c
      ifrfr=1
      ifrto=0
      ifrsk=1
      ifrst=0
      ilast=0
c
      ndist=0
      nangl=0
      ntors=0
      nimps=0
      nord=0
c
      ndef=0
c
      nhis=0
      lhis=0
c
      nrot=0
c
      lsel=.false.
      lsels=.false.
      lselo=.false.
      active=.false.
      lrms=.false.
      lana=.false.
      lrama=.false.
      lesd=.false.
      lloc=.false.
      lhbond=.false.
      lrdf=.false.
      lesppt=.false.
c
      nave=0
      ndata=0
      time=0.0d0
      timr=0.0d0
      ldist=0
      icent=0
      jcent=0
      scale=1.0d0
      cpk=1.0d0
      stick=1.0d0
c
      ngrid=10
      iesppb=0
      rcut=1.0d0
c
      nfrtot=0
      nfrme=0
c
      indx=1
c
      rhbmin=0.0d0
      rhbmax=0.2d0
      hbdmin=1.9d0
      hbdmax=3.1416d0
      hbamin=1.9d0
      hbamax=3.1416d0
      numwhb=0
c
      ngroup=0
      ngroups=0
      if(.not.ma_push_get(mt_int,maxgrp*mxdef*mxnum,'iwrk',l_wrk,i_wrk))
     + call md_abort('Could not allocate wrk',0)
c
c
c     open the command file
c     ---------------------
c
      if(me.eq.0) then
      if(.not.rtdb_cget(irtdb,'ana:filcmd',1,filcmd))
     + call md_abort('Error rtdb_get filcmd',0)
      open(unit=lfncmd,file=filcmd(1:index(filcmd,' ')-1),
     + form='formatted',status='old',err=9999)
      rewind(unit=lfncmd)
      endif
c
      return
 9999 continue
      call md_abort('Could not open command file',0)
      return
      end

      subroutine ana_rdf_init()
c
c $Id: ana_rdf.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      if(.not.ma_push_get(mt_int,nrdf*nsel*mwa,'irdf',l_rdf,i_rdf))
     + call md_abort('Could not allocate irdf',0)
      print*,'rdf allocated in rdfhdr ',nrdf*nsel*mwa
c
      return
      end
      subroutine ana_rdfhdr(irdf)
c
      implicit none
c
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      integer irdf(nsel,mwa,nrdf)
c
      character*255 fname
      integer i,j,k,lq,l,m
c
      fname=filtrj
      lq=index(filtrj,'?')
      if(lq.gt.0) then
      fname=filtrj(1:lq-1)//cnum//filtrj(lq+1:index(filtrj,' ')-1)
      endif
      lq=index(fname,'.trj')
      fname(lq:lq+3)='.rdf'
c
      open(unit=lfnrdf,file=fname(1:index(fname,' ')-1),
     + status='unknown')
c
      write(*,3333) fname(1:index(fname,' ')-1)
 3333 format(/,' Opening rdf file ',a)
      rewind(lfnrdf)
c
      numrdf=0
c
      do 1 i=1,nrdf
      do 2 j=1,mwa
      do 3 k=1,nsel
      irdf(k,j,i)=0
    3 continue
    2 continue
    1 continue
c
      print*,'rdf set to zero in rdfhdr'
c
      return
      end
      subroutine ana_rdf(isel,xs,xw,irdf)
c
      implicit none
c
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      integer isel(msa),irdf(nsel,mwa,nrdf)
      real*8 xs(msa,3),xw(mwm,mwa,3)
      integer i,j,k,l,m
      real*8 d
c
      i=0
      do 1 j=1,nsa
      if(isel(j).gt.0) then
      i=i+1
      do 2 k=1,nwm
      do 3 l=1,nwa
      d=sqrt((xs(j,1)-xw(k,l,1))**2+(xs(j,2)-xw(k,l,2))**2+
     + (xs(j,3)-xw(k,l,3))**2)
      m=int(dble(nrdf*rrdf)/d)
      if(m.le.nrdf) irdf(i,l,m)=irdf(i,l,m)+1
    3 continue
    2 continue
      endif
    1 continue
c
      numrdf=numrdf+1
c
      return
      end
      subroutine ana_rdfwrt(isel,irdf)
c
      implicit none
c
#include "ana_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "rtdb.fh"
c
      integer isel(msa)
      integer irdf(nsel,mwa,nrdf)
c
      integer i,j,k,l,m
      real*8 d
c
      write(*,'(a)') 'ANA_RDFWRT'
c
      do 4 i=1,nsel
      do 5 m=1,nrdf
      write(*,'(2i5,10i10)') i,m,(irdf(i,l,m),l=1,nwa)
    5 continue
    4 continue
c
c      i=0
c      do 1 j=1,nsa
c      if(isel(j).gt.0) then
c      i=i+1
c      do 2 k=1,nrdf
c      d=dble(k)*rrdf/dble(nrdf)
c      write(*,1000) d,(irdf(i,l,k),l=1,nwa)
c 1000 format(f12.6,10i5)
c    2 continue
c      endif
c    1 continue
c
      close(unit=lfnrdf,status='keep')
      write(*,'(a)') ' Closing rdf file '
c
      return
      end

*> \brief \b DLARRK computes one eigenvalue of a symmetric tridiagonal matrix T to suitable accuracy.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLARRK + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlarrk.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlarrk.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlarrk.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLARRK( N, IW, GL, GU,
*                           D, E2, PIVMIN, RELTOL, W, WERR, INFO)
* 
*       .. Scalar Arguments ..
*       INTEGER   INFO, IW, N
*       DOUBLE PRECISION    PIVMIN, RELTOL, GL, GU, W, WERR
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   D( * ), E2( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLARRK computes one eigenvalue of a symmetric tridiagonal
*> matrix T to suitable accuracy. This is an auxiliary code to be
*> called from DSTEMR.
*>
*> To avoid overflow, the matrix must be scaled so that its
*> largest element is no greater than overflow**(1/2) * underflow**(1/4) in absolute value, and for greatest
*> accuracy, it should not be much smaller than that.
*>
*> See W. Kahan "Accurate Eigenvalues of a Symmetric Tridiagonal
*> Matrix", Report CS41, Computer Science Dept., Stanford
*> University, July 21, 1966.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the tridiagonal matrix T.  N >= 0.
*> \endverbatim
*>
*> \param[in] IW
*> \verbatim
*>          IW is INTEGER
*>          The index of the eigenvalues to be returned.
*> \endverbatim
*>
*> \param[in] GL
*> \verbatim
*>          GL is DOUBLE PRECISION
*> \endverbatim
*>
*> \param[in] GU
*> \verbatim
*>          GU is DOUBLE PRECISION
*>          An upper and a lower bound on the eigenvalue.
*> \endverbatim
*>
*> \param[in] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          The n diagonal elements of the tridiagonal matrix T.
*> \endverbatim
*>
*> \param[in] E2
*> \verbatim
*>          E2 is DOUBLE PRECISION array, dimension (N-1)
*>          The (n-1) squared off-diagonal elements of the tridiagonal matrix T.
*> \endverbatim
*>
*> \param[in] PIVMIN
*> \verbatim
*>          PIVMIN is DOUBLE PRECISION
*>          The minimum pivot allowed in the Sturm sequence for T.
*> \endverbatim
*>
*> \param[in] RELTOL
*> \verbatim
*>          RELTOL is DOUBLE PRECISION
*>          The minimum relative width of an interval.  When an interval
*>          is narrower than RELTOL times the larger (in
*>          magnitude) endpoint, then it is considered to be
*>          sufficiently small, i.e., converged.  Note: this should
*>          always be at least radix*machine epsilon.
*> \endverbatim
*>
*> \param[out] W
*> \verbatim
*>          W is DOUBLE PRECISION
*> \endverbatim
*>
*> \param[out] WERR
*> \verbatim
*>          WERR is DOUBLE PRECISION
*>          The error bound on the corresponding eigenvalue approximation
*>          in W.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:       Eigenvalue converged
*>          = -1:      Eigenvalue did NOT converge
*> \endverbatim
*
*> \par Internal Parameters:
*  =========================
*>
*> \verbatim
*>  FUDGE   DOUBLE PRECISION, default = 2
*>          A "fudge factor" to widen the Gershgorin intervals.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE DLARRK( N, IW, GL, GU,
     $                    D, E2, PIVMIN, RELTOL, W, WERR, INFO)
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER   INFO, IW, N
      DOUBLE PRECISION    PIVMIN, RELTOL, GL, GU, W, WERR
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), E2( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   FUDGE, HALF, TWO, ZERO
      PARAMETER          ( HALF = 0.5D0, TWO = 2.0D0,
     $                     FUDGE = TWO, ZERO = 0.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER   I, IT, ITMAX, NEGCNT
      DOUBLE PRECISION   ATOLI, EPS, LEFT, MID, RIGHT, RTOLI, TMP1,
     $                   TMP2, TNORM
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL   DLAMCH
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, INT, LOG, MAX
*     ..
*     .. Executable Statements ..
*
*     Get machine constants
      EPS = DLAMCH( 'P' )

      TNORM = MAX( ABS( GL ), ABS( GU ) )
      RTOLI = RELTOL
      ATOLI = FUDGE*TWO*PIVMIN

      ITMAX = INT( ( LOG( TNORM+PIVMIN )-LOG( PIVMIN ) ) /
     $           LOG( TWO ) ) + 2

      INFO = -1

      LEFT = GL - FUDGE*TNORM*EPS*N - FUDGE*TWO*PIVMIN
      RIGHT = GU + FUDGE*TNORM*EPS*N + FUDGE*TWO*PIVMIN
      IT = 0

 10   CONTINUE
*
*     Check if interval converged or maximum number of iterations reached
*
      TMP1 = ABS( RIGHT - LEFT )
      TMP2 = MAX( ABS(RIGHT), ABS(LEFT) )
      IF( TMP1.LT.MAX( ATOLI, PIVMIN, RTOLI*TMP2 ) ) THEN
         INFO = 0
         GOTO 30
      ENDIF
      IF(IT.GT.ITMAX)
     $   GOTO 30

*
*     Count number of negative pivots for mid-point
*
      IT = IT + 1
      MID = HALF * (LEFT + RIGHT)
      NEGCNT = 0
      TMP1 = D( 1 ) - MID
      IF( ABS( TMP1 ).LT.PIVMIN )
     $   TMP1 = -PIVMIN
      IF( TMP1.LE.ZERO )
     $   NEGCNT = NEGCNT + 1
*
      DO 20 I = 2, N
         TMP1 = D( I ) - E2( I-1 ) / TMP1 - MID
         IF( ABS( TMP1 ).LT.PIVMIN )
     $      TMP1 = -PIVMIN
         IF( TMP1.LE.ZERO )
     $      NEGCNT = NEGCNT + 1
 20   CONTINUE

      IF(NEGCNT.GE.IW) THEN
         RIGHT = MID
      ELSE
         LEFT = MID
      ENDIF
      GOTO 10

 30   CONTINUE
*
*     Converged or maximum number of iterations reached
*
      W = HALF * (LEFT + RIGHT)
      WERR = HALF * ABS( RIGHT - LEFT )

      RETURN
*
*     End of DLARRK
*
      END
c $Id: dlarrk.f 24343 2013-06-22 05:35:15Z d3y133 $

*> \brief \b DLAED2 used by sstedc. Merges eigenvalues and deflates secular equation. Used when the original matrix is tridiagonal.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLAED2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlaed2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlaed2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlaed2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLAED2( K, N, N1, D, Q, LDQ, INDXQ, RHO, Z, DLAMDA, W,
*                          Q2, INDX, INDXC, INDXP, COLTYP, INFO )
* 
*       .. Scalar Arguments ..
*       INTEGER            INFO, K, LDQ, N, N1
*       DOUBLE PRECISION   RHO
*       ..
*       .. Array Arguments ..
*       INTEGER            COLTYP( * ), INDX( * ), INDXC( * ), INDXP( * ),
*      $                   INDXQ( * )
*       DOUBLE PRECISION   D( * ), DLAMDA( * ), Q( LDQ, * ), Q2( * ),
*      $                   W( * ), Z( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLAED2 merges the two sets of eigenvalues together into a single
*> sorted set.  Then it tries to deflate the size of the problem.
*> There are two ways in which deflation can occur:  when two or more
*> eigenvalues are close together or if there is a tiny entry in the
*> Z vector.  For each such occurrence the order of the related secular
*> equation problem is reduced by one.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[out] K
*> \verbatim
*>          K is INTEGER
*>         The number of non-deflated eigenvalues, and the order of the
*>         related secular equation. 0 <= K <=N.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*> \endverbatim
*>
*> \param[in] N1
*> \verbatim
*>          N1 is INTEGER
*>         The location of the last eigenvalue in the leading sub-matrix.
*>         min(1,N) <= N1 <= N/2.
*> \endverbatim
*>
*> \param[in,out] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>         On entry, D contains the eigenvalues of the two submatrices to
*>         be combined.
*>         On exit, D contains the trailing (N-K) updated eigenvalues
*>         (those which were deflated) sorted into increasing order.
*> \endverbatim
*>
*> \param[in,out] Q
*> \verbatim
*>          Q is DOUBLE PRECISION array, dimension (LDQ, N)
*>         On entry, Q contains the eigenvectors of two submatrices in
*>         the two square blocks with corners at (1,1), (N1,N1)
*>         and (N1+1, N1+1), (N,N).
*>         On exit, Q contains the trailing (N-K) updated eigenvectors
*>         (those which were deflated) in its last N-K columns.
*> \endverbatim
*>
*> \param[in] LDQ
*> \verbatim
*>          LDQ is INTEGER
*>         The leading dimension of the array Q.  LDQ >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] INDXQ
*> \verbatim
*>          INDXQ is INTEGER array, dimension (N)
*>         The permutation which separately sorts the two sub-problems
*>         in D into ascending order.  Note that elements in the second
*>         half of this permutation must first have N1 added to their
*>         values. Destroyed on exit.
*> \endverbatim
*>
*> \param[in,out] RHO
*> \verbatim
*>          RHO is DOUBLE PRECISION
*>         On entry, the off-diagonal element associated with the rank-1
*>         cut which originally split the two submatrices which are now
*>         being recombined.
*>         On exit, RHO has been modified to the value required by
*>         DLAED3.
*> \endverbatim
*>
*> \param[in] Z
*> \verbatim
*>          Z is DOUBLE PRECISION array, dimension (N)
*>         On entry, Z contains the updating vector (the last
*>         row of the first sub-eigenvector matrix and the first row of
*>         the second sub-eigenvector matrix).
*>         On exit, the contents of Z have been destroyed by the updating
*>         process.
*> \endverbatim
*>
*> \param[out] DLAMDA
*> \verbatim
*>          DLAMDA is DOUBLE PRECISION array, dimension (N)
*>         A copy of the first K eigenvalues which will be used by
*>         DLAED3 to form the secular equation.
*> \endverbatim
*>
*> \param[out] W
*> \verbatim
*>          W is DOUBLE PRECISION array, dimension (N)
*>         The first k values of the final deflation-altered z-vector
*>         which will be passed to DLAED3.
*> \endverbatim
*>
*> \param[out] Q2
*> \verbatim
*>          Q2 is DOUBLE PRECISION array, dimension (N1**2+(N-N1)**2)
*>         A copy of the first K eigenvectors which will be used by
*>         DLAED3 in a matrix multiply (DGEMM) to solve for the new
*>         eigenvectors.
*> \endverbatim
*>
*> \param[out] INDX
*> \verbatim
*>          INDX is INTEGER array, dimension (N)
*>         The permutation used to sort the contents of DLAMDA into
*>         ascending order.
*> \endverbatim
*>
*> \param[out] INDXC
*> \verbatim
*>          INDXC is INTEGER array, dimension (N)
*>         The permutation used to arrange the columns of the deflated
*>         Q matrix into three groups:  the first group contains non-zero
*>         elements only at and above N1, the second contains
*>         non-zero elements only below N1, and the third is dense.
*> \endverbatim
*>
*> \param[out] INDXP
*> \verbatim
*>          INDXP is INTEGER array, dimension (N)
*>         The permutation used to place deflated values of D at the end
*>         of the array.  INDXP(1:K) points to the nondeflated D-values
*>         and INDXP(K+1:N) points to the deflated eigenvalues.
*> \endverbatim
*>
*> \param[out] COLTYP
*> \verbatim
*>          COLTYP is INTEGER array, dimension (N)
*>         During execution, a label which will indicate which of the
*>         following types a column in the Q2 matrix is:
*>         1 : non-zero in the upper half only;
*>         2 : dense;
*>         3 : non-zero in the lower half only;
*>         4 : deflated.
*>         On exit, COLTYP(i) is the number of columns of type i,
*>         for i=1 to 4 only.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit.
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup auxOTHERcomputational
*
*> \par Contributors:
*  ==================
*>
*> Jeff Rutter, Computer Science Division, University of California
*> at Berkeley, USA \n
*>  Modified by Francoise Tisseur, University of Tennessee
*>
*  =====================================================================
      SUBROUTINE DLAED2( K, N, N1, D, Q, LDQ, INDXQ, RHO, Z, DLAMDA, W,
     $                   Q2, INDX, INDXC, INDXP, COLTYP, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INFO, K, LDQ, N, N1
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            COLTYP( * ), INDX( * ), INDXC( * ), INDXP( * ),
     $                   INDXQ( * )
      DOUBLE PRECISION   D( * ), DLAMDA( * ), Q( LDQ, * ), Q2( * ),
     $                   W( * ), Z( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   MONE, ZERO, ONE, TWO, EIGHT
      PARAMETER          ( MONE = -1.0D0, ZERO = 0.0D0, ONE = 1.0D0,
     $                   TWO = 2.0D0, EIGHT = 8.0D0 )
*     ..
*     .. Local Arrays ..
      INTEGER            CTOT( 4 ), PSM( 4 )
*     ..
*     .. Local Scalars ..
      INTEGER            CT, I, IMAX, IQ1, IQ2, J, JMAX, JS, K2, N1P1,
     $                   N2, NJ, PJ
      DOUBLE PRECISION   C, EPS, S, T, TAU, TOL
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      DOUBLE PRECISION   DLAMCH, DLAPY2
      EXTERNAL           IDAMAX, DLAMCH, DLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DLACPY, DLAMRG, DROT, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
*
      IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDQ.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( MIN( 1, ( N / 2 ) ).GT.N1 .OR. ( N / 2 ).LT.N1 ) THEN
         INFO = -3
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAED2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      N2 = N - N1
      N1P1 = N1 + 1
*
      IF( RHO.LT.ZERO ) THEN
         CALL DSCAL( N2, MONE, Z( N1P1 ), 1 )
      END IF
*
*     Normalize z so that norm(z) = 1.  Since z is the concatenation of
*     two normalized vectors, norm2(z) = sqrt(2).
*
      T = ONE / SQRT( TWO )
      CALL DSCAL( N, T, Z, 1 )
*
*     RHO = ABS( norm(z)**2 * RHO )
*
      RHO = ABS( TWO*RHO )
*
*     Sort the eigenvalues into increasing order
*
      DO 10 I = N1P1, N
         INDXQ( I ) = INDXQ( I ) + N1
   10 CONTINUE
*
*     re-integrate the deflated parts from the last pass
*
      DO 20 I = 1, N
         DLAMDA( I ) = D( INDXQ( I ) )
   20 CONTINUE
      CALL DLAMRG( N1, N2, DLAMDA, 1, 1, INDXC )
      DO 30 I = 1, N
         INDX( I ) = INDXQ( INDXC( I ) )
   30 CONTINUE
*
*     Calculate the allowable deflation tolerance
*
      IMAX = IDAMAX( N, Z, 1 )
      JMAX = IDAMAX( N, D, 1 )
      EPS = DLAMCH( 'Epsilon' )
      TOL = EIGHT*EPS*MAX( ABS( D( JMAX ) ), ABS( Z( IMAX ) ) )
*
*     If the rank-1 modifier is small enough, no more needs to be done
*     except to reorganize Q so that its columns correspond with the
*     elements in D.
*
      IF( RHO*ABS( Z( IMAX ) ).LE.TOL ) THEN
         K = 0
         IQ2 = 1
         DO 40 J = 1, N
            I = INDX( J )
            CALL DCOPY( N, Q( 1, I ), 1, Q2( IQ2 ), 1 )
            DLAMDA( J ) = D( I )
            IQ2 = IQ2 + N
   40    CONTINUE
         CALL DLACPY( 'A', N, N, Q2, N, Q, LDQ )
         CALL DCOPY( N, DLAMDA, 1, D, 1 )
         GO TO 190
      END IF
*
*     If there are multiple eigenvalues then the problem deflates.  Here
*     the number of equal eigenvalues are found.  As each equal
*     eigenvalue is found, an elementary reflector is computed to rotate
*     the corresponding eigensubspace so that the corresponding
*     components of Z are zero in this new basis.
*
      DO 50 I = 1, N1
         COLTYP( I ) = 1
   50 CONTINUE
      DO 60 I = N1P1, N
         COLTYP( I ) = 3
   60 CONTINUE
*
*
      K = 0
      K2 = N + 1
      DO 70 J = 1, N
         NJ = INDX( J )
         IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
*
*           Deflate due to small z component.
*
            K2 = K2 - 1
            COLTYP( NJ ) = 4
            INDXP( K2 ) = NJ
            IF( J.EQ.N )
     $         GO TO 100
         ELSE
            PJ = NJ
            GO TO 80
         END IF
   70 CONTINUE
   80 CONTINUE
      J = J + 1
      NJ = INDX( J )
      IF( J.GT.N )
     $   GO TO 100
      IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
*
*        Deflate due to small z component.
*
         K2 = K2 - 1
         COLTYP( NJ ) = 4
         INDXP( K2 ) = NJ
      ELSE
*
*        Check if eigenvalues are close enough to allow deflation.
*
         S = Z( PJ )
         C = Z( NJ )
*
*        Find sqrt(a**2+b**2) without overflow or
*        destructive underflow.
*
         TAU = DLAPY2( C, S )
         T = D( NJ ) - D( PJ )
         C = C / TAU
         S = -S / TAU
         IF( ABS( T*C*S ).LE.TOL ) THEN
*
*           Deflation is possible.
*
            Z( NJ ) = TAU
            Z( PJ ) = ZERO
            IF( COLTYP( NJ ).NE.COLTYP( PJ ) )
     $         COLTYP( NJ ) = 2
            COLTYP( PJ ) = 4
            CALL DROT( N, Q( 1, PJ ), 1, Q( 1, NJ ), 1, C, S )
            T = D( PJ )*C**2 + D( NJ )*S**2
            D( NJ ) = D( PJ )*S**2 + D( NJ )*C**2
            D( PJ ) = T
            K2 = K2 - 1
            I = 1
   90       CONTINUE
            IF( K2+I.LE.N ) THEN
               IF( D( PJ ).LT.D( INDXP( K2+I ) ) ) THEN
                  INDXP( K2+I-1 ) = INDXP( K2+I )
                  INDXP( K2+I ) = PJ
                  I = I + 1
                  GO TO 90
               ELSE
                  INDXP( K2+I-1 ) = PJ
               END IF
            ELSE
               INDXP( K2+I-1 ) = PJ
            END IF
            PJ = NJ
         ELSE
            K = K + 1
            DLAMDA( K ) = D( PJ )
            W( K ) = Z( PJ )
            INDXP( K ) = PJ
            PJ = NJ
         END IF
      END IF
      GO TO 80
  100 CONTINUE
*
*     Record the last eigenvalue.
*
      K = K + 1
      DLAMDA( K ) = D( PJ )
      W( K ) = Z( PJ )
      INDXP( K ) = PJ
*
*     Count up the total number of the various types of columns, then
*     form a permutation which positions the four column types into
*     four uniform groups (although one or more of these groups may be
*     empty).
*
      DO 110 J = 1, 4
         CTOT( J ) = 0
  110 CONTINUE
      DO 120 J = 1, N
         CT = COLTYP( J )
         CTOT( CT ) = CTOT( CT ) + 1
  120 CONTINUE
*
*     PSM(*) = Position in SubMatrix (of types 1 through 4)
*
      PSM( 1 ) = 1
      PSM( 2 ) = 1 + CTOT( 1 )
      PSM( 3 ) = PSM( 2 ) + CTOT( 2 )
      PSM( 4 ) = PSM( 3 ) + CTOT( 3 )
      K = N - CTOT( 4 )
*
*     Fill out the INDXC array so that the permutation which it induces
*     will place all type-1 columns first, all type-2 columns next,
*     then all type-3's, and finally all type-4's.
*
      DO 130 J = 1, N
         JS = INDXP( J )
         CT = COLTYP( JS )
         INDX( PSM( CT ) ) = JS
         INDXC( PSM( CT ) ) = J
         PSM( CT ) = PSM( CT ) + 1
  130 CONTINUE
*
*     Sort the eigenvalues and corresponding eigenvectors into DLAMDA
*     and Q2 respectively.  The eigenvalues/vectors which were not
*     deflated go into the first K slots of DLAMDA and Q2 respectively,
*     while those which were deflated go into the last N - K slots.
*
      I = 1
      IQ1 = 1
      IQ2 = 1 + ( CTOT( 1 )+CTOT( 2 ) )*N1
      DO 140 J = 1, CTOT( 1 )
         JS = INDX( I )
         CALL DCOPY( N1, Q( 1, JS ), 1, Q2( IQ1 ), 1 )
         Z( I ) = D( JS )
         I = I + 1
         IQ1 = IQ1 + N1
  140 CONTINUE
*
      DO 150 J = 1, CTOT( 2 )
         JS = INDX( I )
         CALL DCOPY( N1, Q( 1, JS ), 1, Q2( IQ1 ), 1 )
         CALL DCOPY( N2, Q( N1+1, JS ), 1, Q2( IQ2 ), 1 )
         Z( I ) = D( JS )
         I = I + 1
         IQ1 = IQ1 + N1
         IQ2 = IQ2 + N2
  150 CONTINUE
*
      DO 160 J = 1, CTOT( 3 )
         JS = INDX( I )
         CALL DCOPY( N2, Q( N1+1, JS ), 1, Q2( IQ2 ), 1 )
         Z( I ) = D( JS )
         I = I + 1
         IQ2 = IQ2 + N2
  160 CONTINUE
*
      IQ1 = IQ2
      DO 170 J = 1, CTOT( 4 )
         JS = INDX( I )
         CALL DCOPY( N, Q( 1, JS ), 1, Q2( IQ2 ), 1 )
         IQ2 = IQ2 + N
         Z( I ) = D( JS )
         I = I + 1
  170 CONTINUE
*
*     The deflated eigenvalues and their corresponding vectors go back
*     into the last N - K slots of D and Q respectively.
*
      IF( K.LT.N ) THEN
         CALL DLACPY( 'A', N, CTOT( 4 ), Q2( IQ1 ), N, 
     $                Q( 1, K+1 ), LDQ )
         CALL DCOPY( N-K, Z( K+1 ), 1, D( K+1 ), 1 )
      END IF         
*
*     Copy CTOT into COLTYP for referencing in DLAED3.
*
      DO 180 J = 1, 4
         COLTYP( J ) = CTOT( J )
  180 CONTINUE
*
  190 CONTINUE
      RETURN
*
*     End of DLAED2
*
      END
c $Id: dlaed2.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine movecs_lock(geom, basis, g_old, g_new, evals, occ)
*
* $Id: movecs_lock.F 19707 2010-10-29 17:59:36Z d3y133 $
*
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
      integer geom, basis
      integer g_old             ! [input] Old movecs unchanged
      integer g_new             ! [input/output] New movecs reordered
      double precision evals(*) ! [input/output] Evals reordered
      double precision occ(*)   ! [input/output] Occupation reordered
c
c     Reorder the new MOs and evals so that the MOs correspond to
c     the old MOs according to a maximum overlap test
c
c     Form Sold-new = Cold*S*Cnew and find max element in each column.
c
      integer type, nbf, nmo
      integer g_s, g_tmp, g_sno
      integer ga_create_atom_blocked
      external ga_create_atom_blocked
c
      integer k_e, l_e, k_v, l_v, k_o, l_o,l_t,k_t
      integer i, j
      integer idamax
      external idamax
c
c     Get the overlap matrix
c
      g_s = ga_create_atom_blocked(geom, basis, 'movecs_lock:s')
      call ga_zero(g_s)
      call int_1e_ga(basis, basis, g_s, 'overlap',.false.)
c
c     Allocate workspace and form Snew-old
c
      call ga_inquire(g_old, type, nbf, nmo)
*ga:1:0
      if (.not. ga_create(mt_dbl, nbf, nmo, 'movecs_lock:tmp',
     $     nbf, 0, g_tmp)) call errquit
     $     ('movecs_lock: ga_create of tmp failed',nbf*nmo, GA_ERR)
*ga:1:0
      if (.not. ga_create(mt_dbl, nmo, nmo, 'movecs_lock:sno',
     $     nmo, 0, g_sno)) call errquit
     $     ('movecs_lock: ga_create of Sno failed',nmo*nmo, GA_ERR)
      if (.not. ma_push_get(mt_dbl, nmo, 'movecs_lock:e',l_e, k_e))
     $     call errquit('movecs_lock: insufficient memory',nmo, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nmo, 'movecs_lock:o',l_o, k_o))
     $     call errquit('movecs_lock: insufficient memory',nmo, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nbf, 'movecs_lock:v',l_v, k_v))
     $     call errquit('movecs_lock: insufficient memory',nbf, MA_ERR)
      if (.not. ma_push_get(mt_dbl, nbf, 'movecs_lock:t',l_t, k_t))
     $     call errquit('movecs_lock: insufficient memory',nbf, MA_ERR)
c
      call two_index_transf(g_s, g_new, g_old, g_tmp, g_sno)
c
c     Loop thru columns of sno, determine max overlapping vector and copy
c
      call ga_copy(g_new, g_tmp)
      call dcopy(nmo, evals, 1, dbl_mb(k_e), 1)
      call dcopy(nmo, occ, 1, dbl_mb(k_o), 1)
      call ga_sync
c
      if(ga_nodeid().eq.0) then
      do j = 1, nmo 
         call ga_get(g_sno, 1, nmo, j, j, dbl_mb(k_v), 1)
         i = idamax(nmo, dbl_mb(k_v), 1)
c
c     new vector i corresponds to old vector j
c
         if (i. ne. j) then
C
C         invalidate column that you have taken
C
          call dcopy(nmo, 0.0d0,0, dbl_mb(k_t), 1)
         call ga_put(g_sno, i, i, 1, nmo, dbl_mb(k_t), 1)

            if (util_print('movecs_lock', print_default)) then
               write(6,*) ' movecs_lock', i, j
               call util_flush(6)
            endif
         endif
         call ga_get(g_tmp, 1, nbf, i, i, dbl_mb(k_v), 1)
         call ga_put(g_new, 1, nbf, j, j, dbl_mb(k_v), 1)
         evals(j) = dbl_mb(k_e+i-1)
         occ(j)   = dbl_mb(k_o+i-1)
         dbl_mb(k_e+i-1) = 1.0d99 ! Larger than any valid eval
      enddo
c
c     Verify that all vectors have been used
c
      do i = 1, nmo
         if (dbl_mb(k_e+i-1) .ne. 1.0d99) call errquit
     $        ('movecs_lock: maximum overlap test neglected vectors',i,
     &       UNKNOWN_ERR)
      enddo
            if (util_print('movecs_lock', print_default)) then
               call util_flush(6)
            endif
      endif
c
c     Clean up
c
      if (.not. ma_chop_stack(l_e)) call errquit('movecs_lock: ma?',0,
     &       MA_ERR)
      if (.not. ga_destroy(g_sno)) call errquit('movecs_lock: ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_tmp)) call errquit('movecs_lock: ga?',0,
     &       GA_ERR)
      if (.not. ga_destroy(g_s))   call errquit('movecs_lock: ga?',0,
     &       GA_ERR)
c
      call ga_sync
c
      end

c===============================================================================================
ccase...Coulomb attenuation utilities
c===============================================================================================
c     need to initialize doscreen since case_setflags might not be called
      block data case_data
#include "case.fh"
      data doscreen /.false./
      data cam_srhf /.false./
      end
c
      subroutine case_setflags(screenflag)

c     Turn on/off the attenuation based on the screenflag

      implicit none

#include "stdio.fh"
#include "mafdecls.fh"
#include "case.fh"

      logical screenflag

      doscreen = .false.
      doscreen = screenflag
      call ga_sync()   ! synchronise over all processors

      return
      end
c
c===============================================================================================
ccase...Calculate the Coulomb attenuation (CASE) factors
c===============================================================================================
c
c================================================================================================
ccase...For the Texas 2e4c integrals
c================================================================================================
c
      subroutine case_txs(rho, rys, const)

      implicit none

#include "stdio.fh"
#include "mafdecls.fh"
#include "case.fh"

      double precision rho, rys, const
      double precision cam_omega2,mu

c     Calculate the screening factors
      mu = 1.d0
      cam_omega2 = cam_omega*cam_omega
      if (doscreen) mu = cam_omega2/(cam_omega2 + rho)

c     Debug print
c     write(luout,*) "In case_txs: cam_omega:",cam_omega
c     write(luout,*) "In case_txs: cam_exch:",cam_exch
c     write(luout,*) "In case_txs: doscreen:",doscreen

c     Multiply in the screening factors
      rys = mu*rys
      const = const*dsqrt(mu)
c 
      return
      end
c
c=================================================================================================
ccase...For the McMurchie-Davidson 2e4c integrals
c=================================================================================================
c
      subroutine case_md(rho)

      implicit none

#include "stdio.fh"
#include "mafdecls.fh"
#include "case.fh"

      double precision rho
      double precision cam_omega2,mu

c     Calculate the screening factors
      mu = 1.d0
      cam_omega2 = cam_omega*cam_omega
      if (doscreen) mu = cam_omega2/(cam_omega2 + rho)
c
c     Debug print
c     write(luout,*) "In case_md: cam_omega:",cam_omega
c     write(luout,*) "In case_md: cam_exch:",cam_exch
c     write(luout,*) "In case_md: doscreen:",doscreen

c     Multiply in the screening factors
      rho = mu*rho
c
      return
      end
c $Id: case_impl.F 22712 2012-08-15 04:53:07Z niri $

      Logical Function DPlot(rtdb)
*
* $Id: dplot.F 25600 2014-05-13 00:10:37Z d3y133 $
*
      Implicit None
#include "errquit.fh"
*     
************************************************************************
#include "inp.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "stdio.fh"
#include "util.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "context.fh"
************************************************************************
*     
*---- NWChem handles
      Integer rtdb, Geom, AO_Bas_Han
*---- Basis set variables
      Integer nBF_AO
*---- MO Vectors variables
      Logical  movecs_read_header, movecs_read, Int_Normalize
      logical ao_rdm_read
      External movecs_read_header, movecs_read, Int_Normalize
      external ao_rdm_read
c
      Character*80 File_Vec,File_Vec2
      Character*80 File_Mat1,File_Mat2
      character*20 scftype, scftype2
      Character*255 Title_Vec, Title_Vec2, Basis_Name, Basis_Name2
      Integer nBF,nBF2,nSet,nSet2,iSet,nSetTri,
     &        nMO(2),nMO2(2)
      Integer g_Vec(2),g_Dns(2),g_Dns2(2)
c
      Character*80 File_civecs
      Integer g_x(2),g_y(2)
      integer iroot
c
*---- Local variables
      Integer iProc,i,j,No_Of_Spacings(3),Lth_Tit,Out_Unit,iOff
      Integer nGrid,k_Grid,l_Grid,nPoint,nAtom,iAtom,Atom_Off
      Integer k_Tags,l_Tags,k_Charge,l_Charge
      Integer k_Vls,l_Vls,g_Vls,k_xyz,l_xyz,k_AMt,l_AMt,k_BMt,l_BMt
      Integer k_Dst,l_Dst,k_rq0,l_rq0
      Integer k_Ene,l_Ene,k_Occ,l_Occ
      Integer Lth_Vec,Lth_Out
      Integer nOrb,k_Orb,l_Orb
      Double Precision Ext_From_To(3,2),Scale,Volume
      Double Precision STD,Tot_Charge,maxelt
      Character Coord(3)
      Character*8 Units,What,Spin,Where
      Character*80 File_Out
      character*30 tag
      Character*255 Title
      Logical LResult, DeBug
      logical lgaussian,dodos
      double precision tol_rho
      logical ltransden,ldiffden
c     
      integer  ga_create_atom_blocked
      external ga_create_atom_blocked
c
*
************************************************************************
*     
      iProc = ga_nodeid()
      DeBug = util_print('dplot', print_high)
      Coord(1) = 'X'
      Coord(2) = 'Y'
      Coord(3) = 'Z'
*
*---- Push context down to DPlot
      If (.not.context_push('dplot'))
     &     Call ErrQuit('DPlot: context_push failed', 0, UNKNOWN_ERR)
*
***************************************
*     Read the data from the rtdb     *
***************************************
c
c --  Read output file format
      if (.not. rtdb_get(rtdb, 'dplot:lgaussian', mt_log, 1,
     &   lgaussian)) then
        call errquit('DPlot: rtdb_get failed - lgaussian: '
     &             //'No DPLOT input block?',11, INPUT_ERR)
      endif
c
c --  Read file names of MO vectors
      If (.not.rtdb_cget(rtdb,'dplot:File_Vec',1,File_Vec))
     &   Call ErrQuit('DPlot: rtdb_get failed - File_Vec',0,
     &       RTDB_ERR)
c
      If (.not.rtdb_cget(rtdb,'dplot:File_Vec2',1,File_Vec2))
     1   call errquit('DPlot: rtdb_get failed - File_Vec2',0,
     1        RTDB_ERR)
c
c --  Read civecs file
      If (.not.rtdb_cget(rtdb,'dplot:File_civecs',1,File_civecs))
     1   call errquit('DPlot: rtdb_get failed - File_civecs',0,
     1        RTDB_ERR)
c
c --  Read iroot
      If (.not.rtdb_get(rtdb,'dplot:iroot',mt_int,1,iroot))
     &   Call ErrQuit('DPlot: rtdb_get failed - iroot',0, RTDB_ERR)
c
c --  Read file names of one particle reduced density matrices
      If (.not.rtdb_cget(rtdb,'dplot:File_Mat1',1,File_Mat1))
     1   call errquit('DPlot: rtdb_get failed - File_Mat1',0,
     1        RTDB_ERR)
c
      If (.not.rtdb_cget(rtdb,'dplot:File_Mat2',1,File_Mat2))
     1   call errquit('DPlot: rtdb_get failed - File_Mat2',0,
     1        RTDB_ERR)
c
c --  Read dodos switch
      if (.not. rtdb_get(rtdb, 'dplot:dodos', mt_log, 1,
     &   dodos)) call errquit('dpinput:rtdb_get failed',11, RTDB_ERR)
      if(dodos) then
         call dplot_dosinit(rtdb,file_vec)
         DPlot = .TRUE.
         return
      endif
c
c --  Read tol_rho 
      if (.not. rtdb_get(rtdb, 'dplot:tol_rho', mt_dbl, 1, tol_rho)) 
     &   call errquit('dpinput:rtdb_get failed',11, RTDB_ERR)
c
c     Transition density
      If (.not.rtdb_get(rtdb,'dplot:transden',mt_log,1,ltransden))
     &   Call ErrQuit('DPlot_Input: rtdb_put failed - ltransden',0,
     &       RTDB_ERR)
c
c     Difference density
      If (.not.rtdb_get(rtdb,'dplot:diffden',mt_log,1,ldiffden))
     &   Call ErrQuit('DPlot_Input: rtdb_put failed - ldiffden',0,
     &       RTDB_ERR)
c
c --  Read units
      If (.not.rtdb_cget(rtdb,'dplot:Units',1,Units))
     &   Call ErrQuit('DPlot: rtdb_get failed - Units',0, RTDB_ERR)
      If (Debug . and . iProc.eq.0)
     &   Write(LuOut,*)' Units                : ',Units
c
c --  Read plot range
      If (.not.rtdb_get(rtdb,'dplot:Ext_From_To',mt_dbl,6,Ext_From_To))
     &   Call ErrQuit('DPlot: rtdb_get failed - Ext_From_To',0,
     &       RTDB_ERR)
c
c --  Read number of spacings for building the grids
      If (.not.rtdb_get(rtdb,'dplot:No_Of_Spacings',mt_int,
     &   3,No_Of_Spacings))
     &   Call ErrQuit('DPlot: rtdb_get failed - No_Of_Spacings',0,
     &       RTDB_ERR)
c
c --  Read output filename
      If (.not.rtdb_cget(rtdb,'dplot:File_Out',1,File_Out))
     &   Call ErrQuit('DPlot: rtdb_get failed - File_Out',0, RTDB_ERR)
c
c --  Read Title
      If (.not.rtdb_cget(rtdb,'dplot:Title',1,Title))
     &   Call ErrQuit('DPlot: rtdb_get failed - Title',0, RTDB_ERR)
c
c --  Read What
      If (.not.rtdb_cget(rtdb,'dplot:What',1,What))
     &   Call ErrQuit('DPlot: rtdb_get failed - What',0, RTDB_ERR)
c
c --  Read Spin
      If (.not.rtdb_cget(rtdb,'dplot:Spin',1,Spin))
     &   Call ErrQuit('DPlot: rtdb_get failed - Spin',0, RTDB_ERR)
c
c --  Read nOrb
      If (.not.rtdb_get(rtdb,'dplot:nOrb',mt_int,1,nOrb))
     &   Call ErrQuit('DPlot: rtdb_get failed - nOrb',0, RTDB_ERR)
c
c --  Read Where
      If (.not.rtdb_cget(rtdb,'dplot:Where',1,Where))
     &   Call ErrQuit('DPlot: rtdb_get failed - Where',0, RTDB_ERR)
c
c --  Read the total charge of the molecule
      If (.not.rtdb_get(rtdb,'charge',mt_dbl,1,Tot_Charge))
     &   Tot_Charge = 0.d0
c
c -- If there is no specified file names of MO vectors, then looking for
c    the scf or dft MO vectors names in RTDB.
      if (inp_compare(.false.,File_Vec,' ')) then
        tag = 'scf:input  vectors'
c        if (iproc.eq.0) then
c         write(luout,*) ' trying scf '
c        end if
        if (.not. rtdb_cget(rtdb, tag, 1, File_vec)) then
c        if (iproc.eq.0) then
c           write(luout,*) ' trying dft '
c        end if
           tag = 'dft:input  vectors'
           if (.not. rtdb_cget(rtdb, tag, 1, File_vec))
     .          call util_file_name('movecs',.false.,.false.,File_Vec)
           if (iproc.eq.0) write(luout,*) ' File vec is ',File_Vec
        endif
      endif
c
c ---- Reading information from RTDB is completed
c
c --- Printing out
      If (iProc.eq.0) Then
         Write(LuOut,*)
         Write(LuOut,*)' Limits (a.u.) specified for the density plot:'
         Write(LuOut,*)' ---------------------------------------------'
         Write(LuOut,*)
         Write(LuOut,*)'       From        To      # of spacings'
      End If
      Scale = 1.8897265d0
      If (Units.eq.'ANGSTROM') Call dscal(6,Scale,Ext_From_To,1)
c
c --  Calculate the total number of the specified grid points
      nGrid = 1
      Do i = 1, 3
         nGrid = nGrid*(No_Of_Spacings(i)+1)
         If (iProc.eq.0) Write(LuOut,'(a,2(2x,f10.5),5x,i5)')Coord(i),
     &      (Ext_From_To(i,j),j = 1, 2), No_Of_Spacings(i)
      End Do
      If (iProc.eq.0) Then
         Write(LuOut,*)
         Write(LuOut,*)' Total number of grid points = ',nGrid
         Write(LuOut,*)
      End If
c
c --  print out filenames of MO vectors 
      Lth_Vec = Inp_StrLen(File_Vec)
      If (iProc.eq.0 .and. File_Vec .ne. ' ') 
     &   Write(LuOut,*)' 1-st set of MOs      : ',File_Vec(1:Lth_Vec)
c
      Lth_Vec = Inp_StrLen(File_Vec2)
      If (iProc.eq.0 . and . File_Vec2.ne.' ') Then
         Write(LuOut,*)' 2-nd set of MOs      : ',File_Vec2(1:Lth_Vec)
      End If
c
c --  print out civecs filename 
      Lth_Vec = Inp_StrLen(File_civecs)
      If (iProc.eq.0 .and. File_civecs .ne. ' ') 
     &   Write(LuOut,*)' CIVECS file     : ',File_civecs(1:Lth_Vec)
c
c --  Print out the filenames of one particle reduced density matrices
      Lth_Vec = Inp_StrLen(File_Mat1)
      if (iproc.eq.0 .and. File_Mat1 .ne. ' ') Then
         Write(LuOut,*) ' 1-st One Particle Reduced Density Matrix :',
     1   File_Mat1(1:Lth_Vec)
      endif
c
      Lth_Vec = Inp_StrLen(File_Mat2)
      if (iproc.eq.0 .and. File_Mat2 .ne. ' ') Then
         write(LuOut,*) ' 2-nd One Particle Reduced Density Matrix :',
     1   File_Mat2(1:Lth_Vec)
      endif
c
c --  print out the output filename
      Lth_Out = Inp_StrLen(File_Out)
      If (iProc.eq.0) 
     &   Write(LuOut,*)' Output is written to : ',File_Out(1:Lth_Out)
c
c --  print out the Title
      Lth_Tit = Inp_StrLen(Title)
      If (Debug . and . iProc.eq.0)
     &   Write(LuOut,*)' Title                : ',Title(1:Lth_Tit)
c
c --  print out type of picture and output file format
      If (iProc.eq.0) Then
         If (What.eq.'DENSITY') Then
            Write(LuOut,*)' Type of picture      : CHARGE DENSITY'
         Else If (What.eq.'TRANSDEN') Then
            Write(LuOut,*)' Type of picture      : TRANSITION DENSITY'
         Else If (What.eq.'VIEW') Then
            Write(LuOut,*)' Type of picture      : ORBITAL VIEW'
         Else If (What.eq.'CHARGES') Then
            Write(LuOut,*)' Type of picture      : POTENTIAL'
         End If
      End If
c
      if(lgaussian) then
       if (iProc.eq.0)
     &      Write(LuOut,*)' Format used          : Gaussian9x Cube'
      else
       if (iProc.eq.0)
     &      Write(LuOut,*)' Format used          : InsightII'
      endif
c
c --  Set up the right combination of Spin and What 
      If (What.eq.'VIEW' . and . Spin.ne.'BETA')          ! ***Set Up***
     &   Spin = 'ALPHA'
      If (iProc.eq.0 . and . What.ne.'CHARGES')
     &   Write(LuOut,*)' Spin                 : ',Spin
*
c --  debuging and checking
      If (DeBug . and . iProc.eq.0)
     &   Write(LuOut,*)' nOrb                 = ', nOrb
      If (File_Vec2.ne.' ' . and . What.eq.'VIEW')         ! ***Check***
     &   Call ErrQuit('DPlot: VIEW is meaningless for 2 orbital sets',0,
     &       UNKNOWN_ERR)
      If (nOrb.ne.999999) Then
         LResult = MA_Push_Get(MT_Int,nOrb,'Orb',l_Orb,k_Orb)
         Call ErrMem(LResult,'DPlot: Failed to allocate Orb.',0)
         If (.not.rtdb_get(rtdb,'dplot:OrbNo',mt_int,
     &      nOrb,Int_mb(k_Orb)))
     &      Call ErrQuit('DPlot: rtdb_get failed - OrbNo',0, RTDB_ERR)
         If (iProc.eq.0) Then
            If (What.eq.'DENSITY') Then
               Write(LuOut,'(a,50(1x,i3))')
     &          '  The density is computed using orbitals : ',
     &          (Int_mb(k_Orb-1+j),j=1,nOrb)
            Else
               If (nOrb.gt.1 .and . What.eq.'VIEW')        ! ***Check***
     &            Call ErrQuit('DPlot: VIEW and nOrb > 1 conflict',0,
     &                 UNKNOWN_ERR)
               Write(LuOut,'(a,i3,a)')
     &         '  The orbital ',Int_mb(k_Orb),' is plotted'
            End If
         End If
      Else
         If (iProc.eq.0 . and . What.ne.'CHARGES') then
            if (File_Mat1.eq.' ') then
               Write(LuOut,*)' The density is computed using all',
     1                       ' orbitals'
            else
               Lth_Vec = Inp_StrLen(File_Mat1)
               Write(LuOut,*) ' The density is computed using ',
     1                        ' density matrices'
            endif
         endif
      End If
c      If (iProc.eq.0 . and . 
c     1   (File_Vec2.ne.' '.or.File_Mat2.ne.' ')) Then
c         Write(LuOut,*)
c     &   ' The density is computed as Rho = Rho(1) - Rho(2)'
c      End If
*
c --  Set up the grid
      If (What.eq.'VIEW') Where = 'GRID'                  ! ***Set Up***
      If (iProc.eq.0 . and . What.eq.'DENSITY') Then
         If (Where.eq.'GRID') Then
            Write(LuOut,*)' The density is computed on the specified',
     &                    ' grid'
         Else If (Where.eq.'NUCLEI') Then
            Write(LuOut,*)' The density is computed at the position',
     &                    ' of nuclei'
         Else If (Where.eq.'G+N') Then
            Write(LuOut,*)' The density is computed on the grid and',
     &                    ' at the position of nuclei'
         End If
      End If
*
      If (nOrb.ne.999999 . and . What.eq.'CHARGES')        ! ***Check***
     &   Call ErrQuit('DPlot: Charges and Orbitals conflict',0,
     &       UNKNOWN_ERR)
      If (What.eq.'CHARGES' . and . Where.ne.'GRID')       ! ***Check***
     &   Call ErrQuit('DPlot: Charges can be combined with GRID only',
     & 0, 0)
      If (What.eq.'CHARGES' . and . File_Vec2.ne.' ')      ! ***Check***
     &   Call ErrQuit('DPlot: Specify one orb. file for opt. Charges',
     & 0, 0)
*
*********************************
*     Start the calculation     *
*********************************
*
*---- Open the output file
      Out_Unit = LuOut
      If (iProc.eq.0 . and . Where.ne.'NUCLEI' . and .
     &    File_Out.ne.'OUTPUT') Then
            Out_Unit=20
            Open(unit=Out_Unit,
     &           file=File_Out,
     &           status='unknown',
     &           access='sequential',
     &           form='formatted',
     &           err=111)
      End If
*
*---- Write the title and the format to the output file
*
*---- Get the geometry
      If (.not.Geom_Create(Geom,'geometry'))
     &     Call ErrQuit('DPlot: Geom_Create failed',0,0)
      If (.not.Geom_RTDB_Load(rtdb,Geom,'geometry'))
     &     Call ErrQuit('DPlot: Geom_RTDB_Load failed',0,0)
*
      LResult = Geom_Ncent(Geom,nAtom)
      If (Where.eq.'GRID') Then
         nPoint   = nGrid
         Atom_Off = -1
      Else If (Where.eq.'NUCLEI') Then
         nPoint   = nAtom
         Atom_Off = 0
      Else If (Where.eq.'G+N') Then
         nPoint   = nAtom + nGrid
         Atom_Off = nGrid
      End If
*
*---- Get the basis set
      If (.not.Bas_Create(AO_Bas_Han,'ao basis'))
     &   Call ErrQuit('DPlot: Bas_Create failed',0,0)
      If (.not.Bas_RTDB_Load(rtdb,Geom,AO_Bas_Han,'ao basis'))
     &   Call ErrQuit('DPlot: Bas_RTDB_Load failed',0,0)
      If (.not.Int_Normalize(rtdb,AO_Bas_Han))
     &   Call ErrQuit('DPlot: Int_Normalize failed',0,0)
      If (.not.Bas_NumBF(AO_bas_han,nBF_AO))
     &   Call ErrQuit('DPlot: Bas_NumBF failed',0,0)
      If (Debug . and . iProc.eq.0)
     &   Write(LuOut,*)' nBF_AO     = ',nBF_AO
*
*---- Allocate memory and get tags, charges and cartesian coordiantes
      LResult = MA_Push_Get(MT_Byte,nAtom*16,'Tags',l_Tags,k_Tags)
      Call ErrMem(LResult,'C_C: Failed to allocate Tags',0)
      LResult = MA_Push_Get(MT_Dbl,nAtom,'Charge',l_Charge,k_Charge)
      Call ErrMem(LResult,'C_C: Failed to allocate Charge',0)
      LResult = MA_Push_Get(MT_Dbl,nAtom*3,'xyz',l_xyz,k_xyz)
      Call ErrMem(LResult,'C_C: Failed to allocate xyz',0)
*
      If ( .not.Geom_Cart_Get(Geom,nAtom,Byte_mb(k_Tags),
     &   Dbl_mb(k_xyz),Dbl_mb(k_Charge)) )
     &   Call ErrQuit('C_C: Geom_Cart_Get failed',0,0)
*
*---- Allocate memory for grid points and get the grid
      LResult = MA_Push_Get(MT_Dbl,3*nPoint,'Grid',l_Grid,k_Grid)
      Call ErrMem(LResult,'DPlot: Failed to allocate grid',0)
*
      If (Where.ne.'NUCLEI') Then
         Call Get_Grid(Dbl_mb(k_Grid),nGrid,
     &                 Ext_From_To(1,1),Ext_From_To(1,2),
     &                 No_Of_Spacings,Volume,Out_Unit,iProc,Where,
     &                 nAtom,Dbl_mb(k_xyz),What,
     .        lgaussian,dbl_mb(k_charge))
         If (What.eq.'CHARGES') nPoint = nGrid
         Call GA_Sync
      End If
*
      If (Where.ne.'GRID') Then
         Call dcopy(3*nAtom,Dbl_mb(k_xyz),1,Dbl_mb(k_Grid+3*Atom_Off),1)
         Call GA_Sync
      End If
*
*---- Read the info from the first MO file
      call util_file_name_resolve(File_Vec,.false.)
      If (.not.movecs_read_header(File_Vec,Title_Vec,Basis_Name, 
     &     scftype, nBF,nSet,nMO,2))
     &   Call ErrQuit('DPlot: movecs_read_header failed',1,0)
      nSetTri = nSet*(nSet+1)/2
*---- Check, if the MO Vectors correspond to the specified basis set
      If (nBF.ne.nBF_AO)
     &   Call ErrQuit('DPlot: Basis set is not consistent with MOVec',
     &   0,0)
*
      If (Debug . and . iProc.eq.0) Then
         Write(LuOut,*)
         Write(LuOut,*)' Title_Vec  = ',Title_Vec(1:60)
         Write(LuOut,*)' Basis_Name = ',Basis_Name(1:60)
         Write(LuOut,*)' nBF        = ',nBF
         Write(LuOut,*)' nSet       = ',nSet
         Write(LuOut,*)' nMO        = ',nMO(1),nMO(2)
      End If
*
*---- Create global array for MOs and the density matrix
      g_Vec(1) = ga_create_atom_blocked(Geom, AO_Bas_Han, 'Vec1')
      If (nSet.eq.2)then
         g_Vec(2) = ga_create_atom_blocked(Geom, AO_Bas_Han, 'Vec2')
      endif
      If (What.ne.'VIEW') Then
         g_Dns(1) = ga_create_atom_blocked(Geom, AO_Bas_Han, 'Dns1')
         If (nSet.eq.2)then
             g_Dns(2) = ga_create_atom_blocked(Geom, AO_Bas_Han, 'Dns2')
         endif
      End If
c
      If (What.ne.'VIEW') Then
         if (nOrb.eq.999999 .and. File_Mat1.ne.' ') then
            call ga_zero(g_dns(1))
c           Read first density matrix from file
            call util_file_name_resolve(File_Mat1, .false.)
            if (.not.ao_rdm_read(File_Mat1,ao_bas_han,g_Dns(1)))
     1         call errquit('DPlot: ao_rdm_read failed ',0,0)
c
c           Read second density matrix from file
            if (File_Mat2.ne.' ') then
               If (iProc.eq.0) Write(LuOut,*)' The density is',
     1                         ' computed as Rho = Rho(1) - Rho(2)'
               g_Dns2(1) = ga_create_atom_blocked(Geom, AO_Bas_Han, 
     1                         'Dn1')
               call ga_zero(g_Dns2(1))
               call util_file_name_resolve(File_Mat2, .false.)
               if(.not.ao_rdm_read(File_Mat2,ao_bas_han,g_Dns2(1)))
     1         call errquit('DPlot: ao_rdm_read failed',1,0)
c
c              Compute the difference between the density matrices
               call GA_dAdd(1.d0,g_Dns(1),-1.d0,g_Dns2(1),g_Dns(1))
               if (.not. ga_destroy(g_Dns2(1))) call errquit
     &            ('dplot: could not destroy g_Dns2(1)', 0,0)
            endif
c
         else if (File_civecs.ne.' ') then
c
          LResult = MA_Push_Get(MT_Dbl,nBF,'Ene',l_Ene,k_Ene)
          Call ErrMem(LResult,'DPlot: Failed to allocate orb. en.',0)
          LResult = MA_Push_Get(MT_Dbl,nBF,'Occ',l_Occ,k_Occ)
          Call ErrMem(LResult,'DPlot: Failed to allocate occ. num.',0)
          Do iSet = 1, nSet
            call util_file_name_resolve(File_Vec,.false.)
            If (.not.movecs_read(File_Vec,iSet,Dbl_mb(k_Occ),
     &       Dbl_mb(k_Ene),g_Vec(iSet)))
     &       Call ErrQuit('DPlot: movecs_read failed',0,0)
          End Do
          LResult = MA_Pop_Stack(l_Occ)
          Call ErrMem(LResult,'DPlot: Failed to deallocate occ. num.',0)
          LResult = MA_Pop_Stack(l_Ene)
          Call ErrMem(LResult,'DPlot: Failed to deallocate orb. en.',0)
c
c         Construct the transition density or difference density
          call util_file_name_resolve(File_civecs,.false.)
          call int_init(rtdb,1,AO_Bas_Han)
          if (iproc.eq.0) write(luout,*) ' Root: ', iroot
          if (ltransden) then
           call get_transden(spin,iroot,nset,File_civecs,ao_bas_han,
     &        g_Vec,g_Dns)
          else if (ldiffden) then
           call get_diffden(spin,iroot,nset,File_civecs,ao_bas_han,
     &        g_Vec,g_Dns)
          else
           call errquit('dplot: please specify transden or diffden',0,0)
          end if
          call int_terminate()
         else
*------- Get the density matrix for the first orbital file
           Call Get_Dens(Geom,AO_Bas_Han,nSet,nBF,g_Vec,g_Dns,
     &                   Spin,File_Vec,nOrb,k_Orb,iProc)
c          Calculate the difference
           if (File_Vec2.ne.' ') then
              If (iProc.eq.0) Write(LuOut,*)' The density is',
     1                   ' computed as Rho = Rho(1) - Rho(2)'
              call util_file_name_resolve(File_Vec2,.false.)
              If (.not.movecs_read_header(File_Vec2,Title_Vec2,
     1           Basis_Name2,scftype2, nBF2,nSet2,nMO2,2))
     &        Call ErrQuit('DPlot: movecs_read_header failed',2,0)
*------- Check, if the the orbital files match
              If (nBF2.ne.nBF . or . nSet2.ne.nSet)
     &        Call ErrQuit('DPlot: Orbital files do not match',0,0)
*------- Create global array for density matrix
              g_Dns2(1) = ga_create_atom_blocked(Geom, AO_Bas_Han, 
     1                    'Dn1')
              If (nSet.eq.2)then
                 g_Dns2(2) = ga_create_atom_blocked(Geom, AO_Bas_Han, 
     1                       'Dn2')
              endif
*------- Get the density matrix for the second orbital file
              Call Get_Dens(Geom,AO_Bas_Han,nSet,nBF,g_Vec,g_Dns2,
     &                      Spin,File_Vec2,nOrb,k_Orb,iProc)
*------- Form the final density
              Call GA_dAdd(1.d0,g_Dns(1),-1.d0,g_Dns2(1),g_Dns(1))
*------- Deallocate memory
              If (nSet.eq.2)then
                 if (.not. ga_destroy(g_Dns2(2))) call errquit
     &              ('dplot: could not destroy g_Dns(2)', 0,0)
              endif
              if (.not. ga_destroy(g_Dns2(1))) call errquit
     &           ('dplot: could not destroy g_Dns(1)', 0,0)
           endif
         endif
      Else
*------- Read the orbital file
         LResult = MA_Push_Get(MT_Dbl,nBF,'Ene',l_Ene,k_Ene)
         Call ErrMem(LResult,'DPlot: Failed to allocate orb. en.',0)
         LResult = MA_Push_Get(MT_Dbl,nBF,'Occ',l_Occ,k_Occ)
         Call ErrMem(LResult,'DPlot: Failed to allocate occ. num.',0)
         Do iSet = 1, nSet
            call util_file_name_resolve(File_Vec,.false.)
            If (.not.movecs_read(File_Vec,iSet,Dbl_mb(k_Occ),
     &         Dbl_mb(k_Ene),g_Vec(iSet)))
     &         Call ErrQuit('DPlot: movecs_read failed',0,0)
         End Do
         LResult = MA_Pop_Stack(l_Occ)
         Call ErrMem(LResult,'DPlot: Failed to deallocate occ. num.',0)
         LResult = MA_Pop_Stack(l_Ene)
         Call ErrMem(LResult,'DPlot: Failed to deallocate orb. en.',0)
      End If
*
*---- Get the values of the density at the grid points
      LResult = MA_Push_Get(MT_Dbl,nPoint,'Vls',l_Vls,k_Vls)
      Call ErrMem(LResult,'DPlot: Failed to allocate values',0)
*ga:1:0
      If (What.ne.'CHARGES') Then
         Call Create_Contour(rtdb,Geom,AO_Bas_Han,nBF,nPoint,
     &                       nSet,nSetTri,g_Dns(1),g_Vec(1),
     &                       Dbl_mb(k_Grid),Dbl_mb(k_Vls),
     .                       no_of_spacings, tol_rho,
     &                       What,Spin,Int_mb(k_Orb))
         maxelt=0d0
         do i=1,ngrid
            maxelt=max(maxelt,abs(dbl_mb(k_vls+i-1)))
         enddo
         if(iproc.eq.0) write(luout,*) ' max element ',maxelt
      Else
         if (.not. ga_create(mt_dbl, nPoint, 1, 'Vls', 
     &                       0, 0, g_Vls)) 
     &   call errquit('dplot: error creating g_Vls',0,0)
         LResult = MA_Push_Get(MT_Dbl,(nAtom+1)**2,'AMt',l_AMt,k_AMt)
         Call ErrMem(LResult,'C_C: Failed to allocate AMt',0)
         LResult = MA_Push_Get(MT_Dbl,nAtom+1,'BMt',l_BMt,k_BMt)
         Call ErrMem(LResult,'C_C: Failed to allocate BMt',0)
         LResult = MA_Push_Get(MT_Dbl,nAtom*nPoint,'Dst',l_Dst,k_Dst)
         Call ErrMem(LResult,'C_C: Failed to allocate Dst',0)
         LResult = MA_Push_Get(MT_Dbl,nAtom,'rq0',l_rq0,k_rq0)
         Call ErrMem(LResult,'C_C: Failed to allocate rq0',0)
*
         Call qdist(Dbl_mb(k_rq0),Dbl_mb(k_Dst),
     &              Dbl_mb(k_Grid),Dbl_mb(k_xyz),
     &              nPoint,nAtom)
         LResult = MA_Pop_Stack(l_rq0)
*
         Call Get_Charges(rtdb,Geom,AO_Bas_Han,nBF,nPoint,nAtom,
     &                   g_Dns(1),Dbl_mb(k_Grid),Dbl_mb(k_Vls),g_Vls,
     &                   Dbl_mb(k_xyz),Dbl_mb(k_Charge),Byte_mb(k_Tags),
     &                   Dbl_mb(k_AMt),Dbl_mb(k_BMt),Dbl_mb(k_Dst),
     &                   STD,Tot_Charge)
*
         LResult = MA_Pop_Stack(l_Dst)
         LResult = MA_Pop_Stack(l_BMt)
         LResult = MA_Pop_Stack(l_AMt)
         Call GA_Get(g_Vls,1,nPoint,1,1,Dbl_mb(k_Vls),nPoint)
         Call GA_Sync
         if (.not. ga_destroy(g_Vls)) call errquit
     &      ('dplot: could not destroy g_Vls', 0,0)
      End If
*
*---- Print out the values of the density matrix to the output
      call dplot_dump(lgaussian,out_unit,iproc,luout,
     ,     where,what,
     ,     title(1:Lth_Tit),
     ,     natom,dbl_mb(k_xyz),dbl_mb(k_charge),volume,tol_rho,
     ,     Ext_From_To(1,1),Ext_From_To(1,2),
     ,     no_of_spacings,ngrid,dbl_mb(k_vls),Byte_mb(k_Tags))
      If (iProc.eq.0 .and. (Where.ne.'GRID'.or.What.eq.'CHARGES')) Then
         Write(LuOut,*)
         If (What.eq.'CHARGES') Then
            Write(LuOut,*)'             Tag',
     &                    '         C o o r d i n a t e s',
     &                    '            Charges'
         Else
            Write(LuOut,*)'             Tag',
     &                    '         C o o r d i n a t e s',
     &                    '            Density'
         End If
         Write(LuOut,*)'             -------------------------------',
     &                 '-------------------------'
         Do iAtom = 1, nAtom
            iOff = (iAtom - 1)*3
            If (What.ne.'CHARGES')
     &         Dbl_mb(k_Charge-1+iAtom)=Dbl_mb(k_Vls+Atom_Off-1+iAtom)
            Write(LuOut,'(A16,3f12.6,3x,f15.10)')
     &           Byte_mb(k_Tags-1 + iAtom),
     &           (Dbl_mb(k_xyz+iOff+j),j=0,2),
     &           Dbl_mb(k_Charge-1+iAtom)
         End Do
         Write(LuOut,*)'             -------------------------------',
     &                 '-------------------------'
         If (What.eq.'CHARGES')
     &      Write(*,'(a,a,e8.2)')'              Standard deviation',
     &                         ' for the fitted charges = ',STD
         Write(LuOut,*)
      End If
*
*---- Deallocate memory
      LResult = MA_Pop_Stack(l_Vls)
      Call ErrMem(LResult,'DPlot: Failed to deallocate values',0)
      LResult = MA_Pop_Stack(l_Grid)
      Call ErrMem(LResult,'DPlot: Failed to deallocate grid',0)
      LResult = MA_Pop_Stack(l_xyz)
      Call ErrMem(LResult,'DPlot: Failed to deallocate xyz',0)
      LResult = MA_Pop_Stack(l_Charge)
      Call ErrMem(LResult,'DPlot: Failed to deallocate charge',0)
      LResult = MA_Pop_Stack(l_Tags)
      Call ErrMem(LResult,'DPlot: Failed to deallocate tags',0)
      If (nOrb.ne.999999) Then
         LResult = MA_Pop_Stack(l_Orb)
         Call ErrMem(LResult,'DPlot: Failed to deallocate Orb.',0)
      End If
*
*---- Destroy global arrays
c      Call GADest(g_Vls)
      If (What.eq.'DENSITY') Then
c         If (nSet.eq.2) Call GADest(g_Dns(2))
         If (nSet.eq.2)then
            if (.not. ga_destroy(g_Dns(2))) call errquit
     &         ('dplot: could not destroy g_Dns(2)', 0,0)
         endif
c         Call GADest(g_Dns(1))
         if (.not. ga_destroy(g_Dns(1))) call errquit
     &      ('dplot: could not destroy g_Dns(1)', 0,0)
      End If
c      If (nSet.eq.2) Call GADest(g_Vec(2))
      If (nSet.eq.2)then
         if (.not. ga_destroy(g_Vec(2))) call errquit
     &      ('dplot: could not destroy g_Vec(2)', 0,0)
      endif
c      Call GADest(g_Vec(1))
      if (.not. ga_destroy(g_Vec(1))) call errquit
     &   ('dplot: could not destroy g_Vec(1)', 0,0)
      If (.not.Geom_destroy(Geom))
     &     Call ErrQuit('DPlot: Geom_destory failed',0,0)
*
*---- Close the output file
      If (iProc.eq.0 . and . Where.ne.'NUCLEI' . and .
     &    File_Out.ne.'OUTPUT') Close(Out_Unit)
*
*---- Pop context
      If (.not.context_pop('dplot')) 
     &     Call ErrQuit('DPlot: context_pop failed',0,0)
*
*---- Normal termination
      DPlot = .TRUE.

      If (.not.Bas_destroy(AO_Bas_Han))
     &   Call ErrQuit('DPlot: Bas_destroy failed',0,0)
      Return
*
*---- Error exit
  111 Continue
      Call ErrQuit('Create_Contour: Failed to open output file',0,0)
      End

      logical function argos_space_rmri(lfnmri,stime,pres,
     + temp,tempw,temps,
     + iwl,iwlp,xw,vw,xwcr,isl,islp,xs,vs,ipl)
c
      implicit none
c
#include "argos_space_common.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "global.fh"
c
      integer lfnmri
      real*8 stime,pres,temp,tempw,temps
      integer iwl(mwm,miw2),isl(msa,mis2)
      integer iwlp(mwm,npackw),islp(msa,npack)
      real*8 xw(mwm,3,mwa),vw(mwm,3,mwa),xwcr(mwm,3)
      real*8 xs(msa,3),vs(msa,3)
      integer ipl(mbox,mip2)
c
      integer i,j,k,l,nwmn,nsan,node,ilp,ihp,jlp,jhp,ili,ihi,jli,jhi
      integer ilw,ihw,jlw,jhw,ils,ihs,jls,jhs
      integer ltemp(3)
      real*8 rtemp(12)
c
      if(me.eq.0) then
      read(lfnmri,err=9,end=9) ltemp,rtemp,nhist
      if(nhist.gt.0) read(lfnmri,err=9,end=9) (hist(j),j=1,nhist)
      do 1 node=np-1,0,-1
      read(lfnmri,err=9) ((ipl(j,k),j=1,mbox),k=1,mip2)
      nwmn=ipl(1,2)
      nsan=ipl(2,2)
      call ga_distribution(ga_ip,node,ilp,ihp,jlp,jhp)
      call ga_put(ga_ip,ilp,ihp,jlp,jhp,ipl,mbox)
      if(nwmn.gt.0) then
      read(lfnmri,err=9) ((iwl(j,k),j=1,nwmn),k=1,miw2)
      read(lfnmri,err=9) (((xw(j,k,l),j=1,nwmn),k=1,3),l=1,nwa)
      read(lfnmri,err=9) (((vw(j,k,l),j=1,nwmn),k=1,3),l=1,nwa)
      call ga_distribution(ga_iw,node,ili,ihi,jli,jhi)
      if(npackw.eq.0) then
      call ga_put(ga_iw,ili,ili+nwmn-1,jli,jhi,iwl,mwm)
      else
      call argos_space_packw(nwmn,iwl,iwlp)
      call ga_put(ga_iw,ili,ili+nwmn-1,jli,jli+npackw-1,iwlp,mwm)
      endif
      call ga_distribution(ga_w,node,ilw,ihw,jlw,jhw)
      call ga_put(ga_w,ilw,ilw+nwmn-1,jlw,jlw+3*mwa-1,xw,mwm)
      call ga_put(ga_w,ilw,ilw+nwmn-1,jlw+3*mwa,jlw+6*mwa-1,vw,mwm)
      endif
      if(nsan.gt.0) then
      read(lfnmri,err=9) ((isl(j,k),j=1,nsan),k=1,mis2)
      read(lfnmri,err=9) ((xs(j,k),j=1,nsan),k=1,3)
      read(lfnmri,err=9) ((vs(j,k),j=1,nsan),k=1,3)
      call ga_distribution(ga_is,node,ili,ihi,jli,jhi)
      if(npack.eq.0) then
      call ga_put(ga_is,ili,ili+nsan-1,jli,jhi,isl,msa)
      else
      call argos_space_pack(nsan,isl,islp)
      call ga_put(ga_is,ili,ili+nsan-1,jli,jli+npack-1,islp,msa)
      endif
      call ga_distribution(ga_s,node,ils,ihs,jls,jhs)
      call ga_put(ga_s,ils,ils+nsan-1,jls,jls+2,xs,msa)
      call ga_put(ga_s,ils,ils+nsan-1,jls+3,jls+5,vs,msa)
      endif
    1 continue
      endif
c
      call ga_brdcst(msp_12,ltemp,3*ma_sizeof(mt_int,1,mt_byte),0)
      call ga_brdcst(msp_13,rtemp,12*ma_sizeof(mt_dbl,1,mt_byte),0)
      nwm=ltemp(1)
      nwa=ltemp(2)
      nsa=ltemp(3)
      stime=rtemp(1)
      temp=rtemp(2)
      pres=rtemp(3)
      k=3
      do 2 i=1,3
      do 3 j=1,3
      k=k+1
      vlat(i,j)=rtemp(k)
    3 continue
    2 continue
      call ga_distribution(ga_ip,me,ilp,ihp,jlp,jhp)
      call ga_get(ga_ip,ilp,ihp,jlp,jhp,ipl,mbox)
      nwmloc=ipl(1,2)
      nsaloc=ipl(2,2)
      if(nwmloc.gt.0) then
      call ga_distribution(ga_iw,me,ili,ihi,jli,jhi)
      if(npackw.eq.0) then
      call ga_get(ga_iw,ili,ili+nwmloc-1,jli,jhi,iwl,mwm)
      else
      call ga_get(ga_iw,ili,ili+nwmloc-1,jli,jli+npackw-1,iwlp,mwm)
      call argos_space_unpackw(nwmloc,iwl,iwlp)
      endif
      call ga_distribution(ga_w,me,ilw,ihw,jlw,jhw)
      call ga_get(ga_w,ilw,ilw+nwmloc-1,jlw,jlw+3*mwa-1,xw,mwm)
      call ga_get(ga_w,ilw,ilw+nwmloc-1,jlw+3*mwa,jlw+6*mwa-1,vw,mwm)
      endif
      if(nsaloc.gt.0) then
      call ga_distribution(ga_is,me,ili,ihi,jli,jhi)
      if(npack.eq.0) then
      call ga_get(ga_is,ili,ili+nsaloc-1,jli,jhi,isl,msa)
      else
      call ga_get(ga_is,ili,ili+nsaloc-1,jli,jli+npack-1,islp,msa)
      call argos_space_unpack(nsaloc,isl,islp)
      endif
      call ga_distribution(ga_s,me,ils,ihs,jls,jhs)
      call ga_get(ga_s,ils,ils+nsaloc-1,jls,jls+2,xs,msa)
      call ga_get(ga_s,ils,ils+nsaloc-1,jls+3,jls+5,vs,msa)
      endif
c
      argos_space_rmri=.true.
      return
c
    9 continue
      argos_space_rmri=.false.
      return
      end
c $Id: argos_space_rmri.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function argos_prepare_rdrst(lfnout,lfnrst,filrst,
     + npbtyp,nbxtyp,box,
     + iwmr,xw,vw,mwm,mwa,nwm,nwa,iwmrc,xwc,vwc,mwmc,nwmc,
     + isar,xs,vs,msa,nsa,
     + inoe,dnoe,mnoe,noe,msm,nsm,mseq,nseq,lseq,ips)
c
c $Id: argos_prepare_rdrst.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer lfnrst,lfnout
      integer mwm,mwa,nwm,nwa,msa,nsa,mnoe,noe,msm,nsm,mwmc,nwmc
      integer mseq,nseq
      integer npbtyp,nbxtyp
      character*255 filrst
      real*8 xw(3,mwa,mwm),xs(3,msa),vw(3,mwa,mwm),vs(3,msa),box(3)
      real*8 xwc(3,mwa,mwmc),vwc(3,mwa,mwmc),dnoe(5,mnoe)
      integer iwmr(mwm),iwmrc(mwmc),isar(msa),inoe(2,mnoe),lseq(mseq)
      integer ips(msa)
c
      integer i,j,k,length,nhist,nseqi
      character*10 rstdat,rsttim
      real*8 rdummy
      character*1 cdummy
      logical lforces
c
#include "util.fh"
c
c     open the restart file
c     ---------------------
c
      length=index(filrst,' ')-1
      open(unit=lfnrst,file=filrst(1:length),form='formatted',
     + status='old',err=9999)
      rewind(lfnrst)
c
      call swatch(rstdat,rsttim)
c
      read(lfnrst,1001) rdummy,rstdat,rsttim,nhist,lforces
 1001 format(///,f12.6,2a10,i5,4x,l1)
      if(nhist.gt.0) then
      do 1 i=1,nhist
      read(lfnrst,1000) cdummy
 1000 format(a1)
    1 continue
      endif
      read(lfnrst,1002) npbtyp,nbxtyp,box(1),rdummy,rdummy,rdummy,
     + box(2),rdummy,rdummy,rdummy,box(3)
 1002 format(2i5,/,(3f12.6))
      read(lfnrst,1003) rdummy
 1003 format(e12.5)
      read(lfnrst,1004) rdummy,rdummy,rdummy
 1004 format(3f12.6)
      read(lfnrst,1005) nwm,nwa,nsm,nsa,nwmc,i,nseqi,i,noe
 1005 format(7i10,2i5)
c
      if(nwa.gt.mwa) then
      write(lfnout,3001) nwa,mwa
 3001 format('Number of solvent atoms is ',i5,' while expecting ',i5)
      goto 9999
      endif
      if(nwm-nwmc.gt.mwm) then
      write(lfnout,3002) nwm-nwmc,mwm
 3002 format('Number of solvent molecules is ',i5,
     + ' while expecting ',i5)
      goto 9999
      endif
      if(noe.gt.mnoe) then
      write(lfnout,3003) noe,mnoe
 3003 format('Number of NOE constraints is ',i5,' while expecting ',i5)
      goto 9999
      endif
      if(nwmc.gt.mwmc) then
      write(lfnout,3004) nwmc,mwmc
 3004 format('Number of crystal solvent molecules is ',i5,'
     + while expecting ',i5)
      goto 9999
      endif
      if(nsa.gt.msa) then
      write(lfnout,3005) nsa,msa
 3005 format('Number of solute atoms is ',i5,' while expecting ',i5)
      goto 9999
      endif
      if(nseqi.ne.nseq) then
      write(lfnout,3055) nseqi,nseq
 3055 format('Number of segments is ',i5,' while expecting ',i5)
      goto 9999
      endif
c
c     read coordinates
c
      if(nwm.gt.0) then
      if(nwmc.gt.0) then
      do 2 i=1,nwmc
      read(lfnrst,1006) ((xwc(k,j,i),k=1,3),(vwc(k,j,i),k=1,3),j=1,nwa)
 1006 format(2x,6f13.8)
      if(lforces) read(lfnrst,1109) ((rdummy,j=1,3),k=1,nwa)
 1109 format(2x,6e13.6)
      read(lfnrst,1007) iwmrc(i),(rdummy,k=1,3)
 1007 format(i1,1x,3f13.8)
    2 continue
      endif
      do 3 i=1,nwm-nwmc
      read(lfnrst,1006) ((xw(k,j,i),k=1,3),(vw(k,j,i),k=1,3),j=1,nwa)
      if(lforces) read(lfnrst,1109) ((rdummy,j=1,3),k=1,nwa)
      read(lfnrst,1007) iwmr(i),(rdummy,k=1,3)
    3 continue
      endif
      if(nsa.gt.0) then
      do 4 i=1,nsa
      read(lfnrst,1008) isar(i),(xs(k,i),k=1,3),(vs(k,i),k=1,3),ips(i)
 1008 format(i1,1x,6f13.8,i5)
      if(lforces) read(lfnrst,1111) (rdummy,j=1,3)
 1111 format(2x,6e13.6)
    4 continue
      endif
c
      if(nsm.gt.0) then
      read(lfnrst,1011) ((rdummy,k=1,3),i=1,nsm)
 1011 format(2x,3f13.8)
      endif
c
      if(nseq.gt.0) then
      read(lfnrst,1012) (lseq(i),i=1,nseq)
 1012 format(20i3)
      endif
c
c     read solute NOE restraints
c
c      if(noe.gt.0) then
c      read(lfnrst,1014) ((inoe(i,j),i=1,2),(dnoe(i,j),i=1,3),rdummy),
c     + (dnoe(i,j),i=4,5),j=1,noe)
c 1014 format(2i10,4f12.6,/,20x,2e12.5)
c      endif
c
      close(unit=lfnrst)
c
      nwm=nwm-nwmc
c
      if(util_print('where',print_default)) then
      write(lfnout,3000) filrst(1:length)
 3000 format(' Read restart',t40,a,/)
      endif
c
      argos_prepare_rdrst=.true.
      return
c
 9999 continue
      argos_prepare_rdrst=.false.
      return
      end

      subroutine et_fock(rtdb,geom,basis,
     1  g_pa,g_pb,nbf,tol2e,omega2)
c
c This routine uses fock_2e to calculate the 2e contribution to Vab
c
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "tcgmsg.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "sym.fh"
#include "util.fh"
#include "msgids.fh"
#include "stdio.fh"
c
      integer i
      integer rtdb             ! Runtime database
      integer geom             ! Geometry handle
      integer basis            ! AO basis set handle
      integer nbf              ! Number of AO basis functions
      integer g_pa             ! GA handle for alpha density
      integer g_pb             ! GA handle for beta  density
      double precision tol2e   ! 2-e integral tolerance
      integer g_fock(4)        ! GA handles for (anti-)symmetrized fock matrix
      integer g_dens(4)        ! GA handles for (anti-)symmetrized density matrix
      double precision jfac(4) ! Prefactor for HF Coulomb for fock_2e
      double precision kfac(4) ! Prefactor for HF exchange for fock_2e
      double precision omega2
      integer itype
      character*3 theory
c
 9993 format(1x,'Two-electron integral screening (tol2e) : ',1Pd8.2)
      if(ga_nodeid().eq.0) then
       write(LuOut,*) 
       write(LuOut,*) 'Beginning calculation of 2e contribution'
       write(LuOut,9993) tol2e
       write(LuOut,*)
      endif

c ----------------------------------
c Initialize fock builder parameters
c ----------------------------------
c
      call int_init(rtdb,1,basis)
      call int_acc_std()
      call schwarz_init(geom,basis)
      call scf_get_fock_param(rtdb,tol2e)
      call fock_force_direct(rtdb)
c
c --------------------------------------------------------------------
c Allocate work arrays, set bgj theory (fock_2e won't work without it)
c --------------------------------------------------------------------
c
      if(.not.rtdb_cget(rtdb,'task:theory',1,theory)) then
        call errquit('et_fock: unable to get theory',0, RTDB_ERR)
      endif
c
      if (theory.eq.'scf') then
        itype=1
      else if (theory.eq.'hf') then
        itype=1
      else if (theory.eq.'dft') then
        itype=2
      else 
         call errquit('et_fock: theory must be scf or dft',1, RTDB_ERR)
      endif
c 
      if (.not. rtdb_put(rtdb,'bgj:scf_type',mt_int,1, itype)) then
         call errquit('couldnt write bgj scftype',1, RTDB_ERR)
      endif
c
      do i = 1,4
        if(.not.ga_create(mt_dbl,nbf,nbf,'fock',0,0,g_fock(i)))
     $  call errquit('et_fock: ga_create failed', 0, GA_ERR)
        call ga_zero(g_fock(i))
c
        if(.not.ga_create(mt_dbl,nbf,nbf,'density',0,0,g_dens(i)))
     $  call errquit('et_fock: ga_create failed', 0, GA_ERR)
        call ga_zero(g_dens(i))
      enddo
c
c SYMMETRIC CONTRIBUTION:
c
c -----------------
c Set jfac and kfac
c -----------------
c
      jfac(1) = 1.0d0
      jfac(2) = 1.0d0
      jfac(3) = 0.0d0
      jfac(4) = 0.0d0
c
      kfac(1) = 0.0d0
      kfac(2) = 0.0d0
      kfac(3) = 1.0d0
      kfac(4) = 1.0d0
c
c -----------------------------
c Copy Pa and Pb and symmetrize
c -----------------------------
c
      call ga_copy(g_pa,g_dens(1))
      call ga_copy(g_pb,g_dens(2))
      call ga_copy(g_pa,g_dens(3))
      call ga_copy(g_pb,g_dens(4))
c
      do i = 1,4
        call ga_symmetrize (g_dens(i))
      enddo
c
c ---------------------------------------------
c Call fock_2e to get symmetrized fock matrices
c ---------------------------------------------
c
      call fock_2e( geom, basis, 4, jfac, kfac,
     $     tol2e, .false., g_dens, g_fock, .false.)
c
c --------------------------------------------
c Calculate symmetrized contribution to omega2
c --------------------------------------------
c
      omega2 = 0.0d0
      omega2 = omega2 + ga_ddot (g_fock(1),g_dens(1)) 
      omega2 = omega2 + ga_ddot (g_fock(1),g_dens(2)) 
      omega2 = omega2 + ga_ddot (g_fock(2),g_dens(1)) 
      omega2 = omega2 + ga_ddot (g_fock(2),g_dens(2)) 
      omega2 = omega2 - ga_ddot (g_fock(3),g_dens(1)) 
      omega2 = omega2 - ga_ddot (g_fock(4),g_dens(2)) 
c
c      do i = 1,nbf
c      do j = 1,nbf
c        call ga_get(g_fock(1), i, i, j, j,fJa,1)
c        call ga_get(g_fock(2), i, i, j, j,fJb,1)
c        call ga_get(g_fock(3), i, i, j, j,fKa,1)
c        call ga_get(g_fock(4), i, i, j, j,fKb,1)
c        call ga_get(g_dens(1), i, i, j, j,pa,1)
c        call ga_get(g_dens(2), i, i, j, j,pb,1)
c
c        omega2 = omega2 + pa*fJa
c        omega2 = omega2 + pb*fJa
c        omega2 = omega2 + pb*fJb
c        omega2 = omega2 + pa*fJb
c        omega2 = omega2 - pa*fKa
c        omega2 = omega2 - pb*fKb
c      enddo
c      enddo
c
c
c
c ANTI-SYMMETRIC CONTRIBUTION:
c
c -----------------
c Set jfac and kfac
c -----------------
c
      jfac(1) = 0.0d0
      jfac(2) = 0.0d0
c
      kfac(1) = 1.0d0
      kfac(2) = 1.0d0
c
c ----------------------------------
c Copy Pa and Pb and ANTI-symmetrize
c ---------------------------------
c
      call ga_copy(g_pa,g_dens(1))
      call ga_copy(g_pb,g_dens(2))
c
      do i = 1,2
        call ga_antisymmetrize (g_dens(i))
      enddo
c
c --------------------------------------------------
c Call fock_2e then get ANTI-symmetrized fock matrices
c --------------------------------------------------
c
      call fock_2e( geom, basis, 2, jfac, kfac,
     $     tol2e, .false., g_dens, g_fock, .true.)
c
      do i = 1,2
        call ga_antisymmetrize (g_fock(i))
      enddo
c
c --------------------------------------------
c Calculate ANTI-symmetrized contribution to omega2
c --------------------------------------------
c
      omega2 = omega2 - ga_ddot (g_fock(1),g_dens(1)) 
      omega2 = omega2 - ga_ddot (g_fock(2),g_dens(2)) 
c
c      do i = 1,nbf
c      do j = 1,nbf
c        call ga_get(g_fock(1), i, i, j, j,fKa,1)
c        call ga_get(g_fock(2), i, i, j, j,fKb,1)
c        call ga_get(g_dens(1), i, i, j, j,pa,1)
c        call ga_get(g_dens(2), i, i, j, j,pb,1)
c
c        omega2 = omega2 - pa*fKa 
c        omega2 = omega2 - pb*fKb 
c      enddo
c      enddo
c
c    
c
c --------------
c Destroy arrays
c --------------
c
      do i = 1,4
        if(.not.ga_destroy(g_fock(i)))
     $  call errquit('et_fock: ga_destroy failed', 0, GA_ERR)
c
        if(.not.ga_destroy(g_dens(i)))
     $  call errquit('et_fock: ga_create failed', 0, GA_ERR)
      enddo
c
       call fock_2e_tidy(rtdb)
       call schwarz_tidy()
c
       return
       end


c $Id: et_fock.F 21176 2011-10-10 06:35:49Z d3y133 $

C> \ingroup selci
C> @{
      subroutine selci_loada(h, g, int12, int34)
*
* $Id: loada.F 24790 2013-11-11 18:56:49Z d3y133 $
*
#include "implicit.fh"
#include "errquit.fh"
#include "ciinfo.fh"
      dimension h(nnorbs), g(numint), int12(nnorbs), int34(nnorbs)
#include "bitops.fh"
c
c     load the symmetry packed integrals in core
c     this version is reading from the ascii list of integrals
c
      call dfill(numint, 0.0d0, g, 1)
c
 10   read (iflint, *) gg, i, j, k, l
      if (k.gt.0) then
         if (abs(gg).lt.1.0d-10) goto 10
         if (i.lt.j) then
            ii = i
            i = j
            j = ii
         endif
         if (k.lt.l) then
            kk = k
            k = l
            l = kk
         endif
         if (max(i,k).gt.norbs) goto 10
         ij = iky(i) + j
         kl = iky(k) + l
         if (ij.lt.kl) then
            ijij = ij
            ij = kl
            kl = ijij
         endif
         ijs = ieor(isym(i),isym(j))
         kls = ieor(isym(k),isym(l))
         if (ijs.ne.kls) then
            write(ifllog,*) ' gg,i,j,k,l,ijs,kls,',gg,i,j,k,l,ijs,kls
            call errquit('integral should be zero by symmetry',0,
     &       CALC_ERR)
         endif
         g(int12(ij)+int34(kl)) = gg
         goto 10
      else if (i.gt.0) then
         if (abs(gg).lt.1.0d-10) goto 10
         if (i.lt.j) then
            ii = i
            i = j
            j = ii
         endif
         if (i.gt.norbs) goto 10
         ij = iky(i) + j
         ijs = ieor(isym(i),isym(j))
         if (ijs.ne.0) then
            write(ifllog,*) ' h,i,j,ijs',gg,i,j,ijs
            call errquit(' integral should be zero by symmetry',0,
     &       CALC_ERR)
         endif
         h(ij) = gg
         goto 10
      else if (i.eq.0) then
         repnuc = gg
         write(6,19) repnuc
 19      format(' nuclear replusion energy is ',f20.12)
         goto 10
      endif
c
      close(iflint,status='keep')
c
      end
C> @}

      SUBROUTINE ccsdt_lr_alpha2_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c
     &_offset)
C     $Id: ccsdt_lr_alpha2_5.F 19702 2010-10-29 17:26:22Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( )_ytrbtrav + = 1 * Sum ( h11 p7 h9 p10 ) * i1 ( h11 p7 h9 p10 )_ytrbtra * v ( h9 p10 h11 p7 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h11b
      INTEGER p7b
      INTEGER h9b
      INTEGER p10b
      INTEGER h11b_1
      INTEGER p7b_1
      INTEGER h9b_1
      INTEGER p10b_1
      INTEGER h9b_2
      INTEGER p10b_2
      INTEGER h11b_2
      INTEGER p7b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      IF (next.eq.count) THEN
      IF (0 .eq. ieor(irrep_y,ieor(irrep_trb,ieor(irrep_tra,irrep_v)))) 
     &THEN
      dimc = 1
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h11b = 1,noab
      DO p7b = noab+1,noab+nvab
      DO h9b = 1,noab
      DO p10b = noab+1,noab+nvab
      IF (int_mb(k_spin+h11b-1)+int_mb(k_spin+p7b-1) .eq. int_mb(k_spin+
     &h9b-1)+int_mb(k_spin+p10b-1)) THEN
      IF (ieor(int_mb(k_sym+h11b-1),ieor(int_mb(k_sym+p7b-1),ieor(int_mb
     &(k_sym+h9b-1),int_mb(k_sym+p10b-1)))) .eq. ieor(irrep_y,ieor(irrep
     &_trb,irrep_tra))) THEN
      CALL TCE_RESTRICTED_4(h11b,p7b,h9b,p10b,h11b_1,p7b_1,h9b_1,p10b_1)
      CALL TCE_RESTRICTED_4(h9b,p10b,h11b,p7b,h9b_2,p10b_2,h11b_2,p7b_2)
      dim_common = int_mb(k_range+h11b-1) * int_mb(k_range+p7b-1) * int_
     &mb(k_range+h9b-1) * int_mb(k_range+p10b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_5',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p10b_
     &1 - noab - 1 + nvab * (h9b_1 - 1 + noab * (p7b_1 - noab - 1 + nvab
     & * (h11b_1 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h11b-1
     &),int_mb(k_range+p7b-1),int_mb(k_range+h9b-1),int_mb(k_range+p10b-
     &1),4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_lr_alpha2_5',3,MA_
     &ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_lr_alpha2_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_5',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p7b_2
     & - 1 + (noab+nvab) * (h11b_2 - 1 + (noab+nvab) * (p10b_2 - 1 + (no
     &ab+nvab) * (h9b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h9b-1)
     &,int_mb(k_range+p10b-1),int_mb(k_range+h11b-1),int_mb(k_range+p7b-
     &1),2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_lr_alpha2_5',6,MA_
     &ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_5',
     &7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_5',
     &8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_lr_alpha2_5',9,MA_ERR)
      CALL TCE_SORT_0(dbl_mb(k_c_sort),dbl_mb(k_c),1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),0)
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_lr_alpha2_5',10,MA
     &_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_lr_alpha2_5',
     &11,MA_ERR)
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

*
* routines from basis.F that use blas calls
*
* $Id: bas_blas.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      logical function bas_get_exponent(basisin,icont,expon)
c
c  returns the exponents of a given mapped contraction 
c
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "stdio.fh"
c::function
      logical bas_check_handle
      external bas_check_handle
c:blas
c     dcopy
c::passed
      integer basisin         ! [input] basis set handle
      integer icont           ! [input] mapped contraction index
      double precision expon(*) ! [output] exponents
c::local
      integer basis, myucont, icontmax
      integer myprim,myexptr
c:: statement functions
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      bas_get_exponent = bas_check_handle(basisin,'bas_get_exponent')
      if (.not.bas_get_exponent) return

      basis = basisin + Basis_Handle_Offset 
      icontmax = ncont_tot_gb(basis)
      myucont = sf_ibs_cn2ucn(icont,basis)
      bas_get_exponent = icont.ge.0.and.icont.le.icontmax
      if (.not.(bas_get_exponent)) then
        write(LuOut,*)' bas_get_exponent: ERROR '
        write(LuOut,*)' contraction range for basis is 0:',
     &         icontmax
        write(LuOut,*)' information requested for contraction:',icont
        return
      endif
c
      myexptr = infbs_cont(CONT_IEXP,myucont,basis)
      myprim  = infbs_cont(CONT_NPRIM,myucont,basis)
      call dcopy(myprim,dbl_mb(mb_exndcf(myexptr,basis)),1,expon,1)
c
      bas_get_exponent = .true.
c
      return
      end
*.....................................................................
      logical function bas_get_coeff(basisin,icont,coeff)
c
c returns the coefficients for the given mapped contraction
c
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "bas_ibs_dec.fh"
#include "bas_exndcf_dec.fh"
#include "stdio.fh"
c::function
      logical bas_check_handle
      external bas_check_handle
c:blas
c     dcopy
c::passed
      integer basisin            ! [input] basis set handle
      integer icont              ! [input] mapped contraction index
      double precision coeff(*)  ! [output] mapped contraction coeffs.
c::local
      integer basis, myucont, icontmax
      integer mycoeffptr, myprim, mygen
c:: statement functions
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      bas_get_coeff = bas_check_handle(basisin,'bas_get_coeff')
      if (.not.bas_get_coeff) return

      basis = basisin + Basis_Handle_Offset 
c
      icontmax = ncont_tot_gb(basis)
      myucont = sf_ibs_cn2ucn(icont,basis)
      bas_get_coeff = icont.ge.0.and.icont.le.icontmax
      if (.not.(bas_get_coeff)) then
        write(LuOut,*)' bas_get_coeff: ERROR '
        write(LuOut,*)' contraction range for basis is 0:',
     &         icontmax
        write(LuOut,*)' information requested for contraction:',icont
        return
      endif
c
      mycoeffptr = infbs_cont(CONT_ICFP,myucont,basis)
      myprim  = infbs_cont(CONT_NPRIM,myucont,basis)
      mygen   = infbs_cont(CONT_NGEN,myucont,basis)
      call dcopy((myprim*mygen),
     &    dbl_mb(mb_exndcf(mycoeffptr,basis)),1,coeff,1)
c
      bas_get_coeff = .true.
c
      return
      end
*.....................................................................
      logical function bas_set_exponent(basisin,icont,expon,nexp)
c
c sets the exponents to the input array for a given mapped contraction
c
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "bas_ibs_dec.fh"
#include "bas_exndcf_dec.fh"
#include "stdio.fh"
c::function
      logical bas_check_handle
      external bas_check_handle
c:blas
c     dcopy
c::passed
      integer basisin ! [input] basis set handle        
      integer icont ! [input] mapped contraction index
      integer nexp ! [input] number of exponents for contraction
      double precision expon(nexp) ! [input] "new" exponents for 
*. . . . . . . . . . . . . . . .            contraction    
c::local
      integer basis, myucont, icontmax
      integer myprim,myexptr
c:: statement functions
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      bas_set_exponent = bas_check_handle(basisin,'bas_set_exponent')
      if (.not.bas_set_exponent) return

      basis = basisin + Basis_Handle_Offset 

      icontmax = ncont_tot_gb(basis)
      myucont = sf_ibs_cn2ucn(icont,basis)

      bas_set_exponent = icont.ge.0.and.icont.le.icontmax
      if (.not.(bas_set_exponent)) then
        write(LuOut,*)' bas_set_exponent: ERROR '
        write(LuOut,*)' contraction range for basis is 0:',
     &         icontmax
        write(LuOut,*)' information requested for contraction:',icont
        return
      endif
c
      myexptr = infbs_cont(CONT_IEXP,myucont,basis)
      myprim  = infbs_cont(CONT_NPRIM,myucont,basis)
      bas_set_exponent = myprim.eq.nexp
      if (.not.bas_set_exponent) then
        write(LuOut,*)' bas_set_exponent: ERROR '
        write(LuOut,*)' input and stored number of exponents ',
     &         '(nprim) differ '
        write(LuOut,*)' input  nprim: ',nexp
        write(LuOut,*)' stored nprim: ',myprim
        return
      endif
      call dcopy(nexp,expon,1,dbl_mb(mb_exndcf(myexptr,basis)),1)
c
      bas_set_exponent = .true.
c
      return
      end
*.....................................................................
      logical function bas_set_coeff(basisin,icont,coeff,ncoeff)
c
c sets the coefficients of the given mapped contraction
c
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "bas_ibs_dec.fh"
#include "bas_exndcf_dec.fh"
#include "stdio.fh"
c::function
      logical bas_check_handle
      external bas_check_handle
c:blas
c     dcopy
c::passed
      integer basisin ! [input] basis set handle                   
      integer icont ! [input] mapped contraction index           
      integer ncoeff ! [input] number of coeffs. for contraction
      double precision coeff(ncoeff) ! [input] "new" coeffs. 
*. . . . . . . . . . . . . . . . . .            for contraction    
c::local
      integer basis, myucont, icontmax
      integer mycoeffptr, myprim, mygen
c:: statement functions
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      bas_set_coeff = bas_check_handle(basisin,'bas_set_coeff')
      if (.not.bas_set_coeff) return

      basis = basisin + Basis_Handle_Offset 
c
      icontmax = ncont_tot_gb(basis)
      myucont = sf_ibs_cn2ucn(icont,basis)

      bas_set_coeff = icont.ge.0.and.icont.le.icontmax
      if (.not.(bas_set_coeff)) then
        write(LuOut,*)' bas_set_coeff: ERROR '
        write(LuOut,*)' contraction range for basis is 0:',
     &         icontmax
        write(LuOut,*)' information requested for contraction:',icont
        return
      endif
c
      mycoeffptr = infbs_cont(CONT_ICFP,myucont,basis)
      myprim  = infbs_cont(CONT_NPRIM,myucont,basis)
      mygen   = infbs_cont(CONT_NGEN,myucont,basis)
c
      bas_set_coeff = ncoeff .eq. (myprim*mygen)
      if(.not.bas_set_coeff) then
        write(LuOut,*)' bas_set_coeff: ERROR '
        write(LuOut,*)' input and stored number of coefficients ',
     &         '(nprim*ngen) differ '
        write(LuOut,*)' input  nprim*ngen: ',ncoeff
        write(LuOut,*)' stored nprim*ngen: ',(myprim*mygen)
        return
      endif
      call dcopy(ncoeff,coeff,1,dbl_mb(mb_exndcf(mycoeffptr,basis)),1)
c
      bas_set_coeff = .true.
c
      return
      end
*.....................................................................
      logical function ecp_get_rexponent(ecpin,icont,expon)
c
c returns the r-exponents of a given mapped contraction
c
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "stdio.fh"
c::function
      logical ecp_check_handle
      external ecp_check_handle
c:blas
c     dcopy
c::passed
      integer ecpin         ! [input] ecp set handle
      integer icont           ! [input] mapped contraction index
      double precision expon(*) ! [output] exponents
c::local
      integer ecp, myucont, icontmax
      integer myprim,myexptr
c:: statement functions
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      ecp_get_rexponent = ecp_check_handle(ecpin,'ecp_get_rexponent')
      if (.not.ecp_get_rexponent) return

      ecp = ecpin + Basis_Handle_Offset 
      icontmax = ncont_tot_gb(ecp)
      myucont = sf_ibs_cn2ucn(icont,ecp)
      ecp_get_rexponent = icont.ge.0.and.icont.le.icontmax
      if (.not.(ecp_get_rexponent)) then
        write(LuOut,*)' ecp_get_rexponent: ERROR '
        write(LuOut,*)' contraction range for ecp is 0:',
     &         icontmax
        write(LuOut,*)' information requested for contraction:',icont
        return
      endif
c
      myexptr = infbs_cont(CONT_IREXP,myucont,ecp)
      myprim  = infbs_cont(CONT_NPRIM,myucont,ecp)
      call dcopy(myprim,dbl_mb(mb_exndcf(myexptr,ecp)),1,expon,1)
c
      ecp_get_rexponent = .true.
c
      return
      end
*.....................................................................
      logical function ecp_set_rexponent(ecpin,icont,expon,nexp)
c
c sets the exponents to the input array for a given mapped contraction
c
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "geobasmapP.fh"
#include "basdeclsP.fh"
#include "bas_ibs_dec.fh"
#include "bas_exndcf_dec.fh"
#include "stdio.fh"
c::function
      logical ecp_check_handle
      external ecp_check_handle
c:blas
c     dcopy
c::passed
      integer ecpin ! [input] ecp set handle        
      integer icont ! [input] mapped contraction index
      integer nexp ! [input] number of exponents for contraction
      double precision expon(nexp) ! [input] "new" r-exponents 
*. . . . . . . . . . . . . . . .            for contraction    
c::local
      integer ecp, myucont, icontmax
      integer myprim,myexptr
c:: statement functions
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      ecp_set_rexponent = ecp_check_handle(ecpin,'ecp_set_rexponent')
      if (.not.ecp_set_rexponent) return

      ecp = ecpin + Basis_Handle_Offset 

      icontmax = ncont_tot_gb(ecp)
      myucont = sf_ibs_cn2ucn(icont,ecp)

      ecp_set_rexponent = icont.ge.0.and.icont.le.icontmax
      if (.not.(ecp_set_rexponent)) then
        write(LuOut,*)' ecp_set_rexponent: ERROR '
        write(LuOut,*)' contraction range for ecp is 0:',
     &         icontmax
        write(LuOut,*)' information requested for contraction:',icont
        return
      endif
c
      myexptr = infbs_cont(CONT_IEXP,myucont,ecp)
      myprim  = infbs_cont(CONT_NPRIM,myucont,ecp)
      ecp_set_rexponent = myprim.eq.nexp
      if (.not.ecp_set_rexponent) then
        write(LuOut,*)' ecp_set_rexponent: ERROR '
        write(LuOut,*)' input and stored number of exponents ',
     &         '(nprim) differ '
        write(LuOut,*)' input  nprim: ',nexp
        write(LuOut,*)' stored nprim: ',myprim
        return
      endif
      call dcopy(nexp,expon,1,dbl_mb(mb_exndcf(myexptr,ecp)),1)
c
      ecp_set_rexponent = .true.
c
      return
*.....................................................................
      end

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     inp_ilist -- read an integer list, possibly including ranges
C
C REVISION
C     $Id: inp_ilist.F 19708 2010-10-29 18:04:21Z d3y133 $
C
C SYNOPSIS
      Logical Function Inp_IList( MaxList, List, N)
      Implicit NONE
      Integer MaxList           ! [in]    Size of List
      Integer List( MaxList )   ! [inout] Contents of list
      Integer N                 ! [out]   Number of elements in list
C
C DESCRIPTION
C     Reads the line for a list of integers and puts
c     the results in List.  Ranges of integers may be compactly using
c     F90-style triplet notation. The number of elements set from the
c     input is returned in N. 
c
c     It USED to read the entire remainder of the input line. BUT now
c     reads until it finds something that is not an integer range.
c
c     IF (the remainder of the input line was read as a valid list)
c     .  inp_list returns .true. with N as the number of elements read
c     ELSE 
c     .  inp_list returns .false. with N as the number of elements 
c     .  and also sets the INP internal error message appropriately
c     .  which can be cleared with inp_clear_err
c
c     N may be returned in either case as zero.
c
C     If N > MaxList, it indicates that there is too much data on
C     the line to fit in List. NOTE that inp_ilist now returns
c     true in this scenario so the value of N must be checked 
c     for this condition.  A recovery action would be to reposition
c     the input to the beginning of the list, allocate a sufficiently
c     large array and then call inp_ilist again.  The input position may
c     be recorded with inp_cur_field() and reset with inp_set_field().
c     The INP error message is also set in this circumstance.
C
C INCLUDED FILES
c     none.
C
C EXTERNAL ROUTINES
      Integer  Inp_Cur_Field, Inp_N_Field
      Logical  Inp_IRange
      External Inp_Cur_Field, Inp_N_Field, Inp_IRange
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer First, Last, Stride, I
C
      N = 0
C
c     Read as many fields as possible as integer ranges
c
 10   If ( Inp_IRange(First, Last, Stride) ) then
C
C     Expand the triplet.  If there are too many elements for the List, 
C     we count them but do not overwrite the array bounds.
C
         Do I = First, Last, Stride
            N = N + 1
            If ( N .le. MaxList) List(N) = I
            If ( N .eq. MaxList+1) call inp_mark_err
     $          ('insufficient space for integer list')
         EndDo
         goto 10
      EndIf
C
C     OK if we are we are the end of the input line 
C
      inp_ilist = (inp_cur_field() .eq. inp_n_field()) 
C
      End

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c name
c     inp_ilist_size -- returns number of elements in list
c
c revision
c     $id: inp_ilist.f,v 1.3 1997/03/05 23:20:31 d3g681 exp $
c
c synopsis
      logical function inp_ilist_size(n)
      implicit none
      integer n                 ! [out]   number of elements in list

c
c description
c     reads the line of a list of integers and 
c     and returns total number of elements
c     designed to be use a helper routine for inp_ilist
c     on exit from this routine the input is repositioned back
c     to the original value
c
c external routines
      integer  inp_cur_field, inp_n_field
      external inp_cur_field, inp_n_field
      logical  inp_irange
      external inp_irange
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c local variables
      integer first, last, stride, i
      integer nc
c
c     
      nc = inp_cur_field()
      n = 0
c
c     read as many fields as possible as integer ranges
c
 10   if ( Inp_IRange(first, last, stride) ) then
c
c     expand the triplet.  if there are too many elements for the list, 
c     we count them but do not overwrite the array bounds.
c
         do i = first, last, stride
            n = n + 1
         enddo
         goto 10
      endif
c
c
      inp_ilist_size = (inp_cur_field() .eq. inp_n_field()) 
      call inp_set_field(nc)
      end

      SUBROUTINE cisdtq_c1(d_e0,d_f1,d_i0,d_t1,d_t2,d_t3,d_v2,k_e0_offse
     &t,k_f1_offset,k_i0_offset,k_t1_offset,k_t2_offset,k_t3_offset,k_v2
     &_offset)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_f + = 1 * f ( p2 h1 )_f
C     i0 ( p2 h1 )_tf + = -1 * Sum ( h3 ) * t ( p2 h3 )_t * f ( h3 h1 )_f
C     i0 ( p2 h1 )_tf + = 1 * Sum ( p3 ) * t ( p3 h1 )_t * f ( p2 p3 )_f
C     i0 ( p2 h1 )_vt + = -1 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 p2 h1 p3 )_v
C     i0 ( p2 h1 )_tf + = 1 * Sum ( p4 h3 ) * t ( p2 p4 h1 h3 )_t * f ( h3 p4 )_f
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h4 h5 p3 ) * t ( p2 p3 h4 h5 )_t * v ( h4 h5 h1 p3 )_v
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * v ( h5 p2 p3 p4 )_v
C     i0 ( p2 h1 )_vt + = 1/4 * Sum ( h5 h6 p3 p4 ) * t ( p2 p3 p4 h1 h5 h6 )_t * v ( h5 h6 p3 p4 )_v
C     i0 ( p2 h1 )_te + = -1 * e ( )_e * t ( p2 h1 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_f1
      INTEGER k_f1_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_v2
      INTEGER k_v2_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER d_t3
      INTEGER k_t3_offset
      INTEGER d_e0
      INTEGER k_e0_offset
#if !defined(CCSDTQ)
      CALL ERRQUIT('CISDTQ not compiled',0,CAPMIS_ERR)
      RETURN
      END
#else
      CALL cisdtq_c1_1(d_f1,k_f1_offset,d_i0,k_i0_offset)
      CALL cisdtq_c1_2(d_t1,k_t1_offset,d_f1,k_f1_offset,d_i0,k_i0_offse
     &t)
      CALL cisdtq_c1_3(d_t1,k_t1_offset,d_f1,k_f1_offset,d_i0,k_i0_offse
     &t)
      CALL cisdtq_c1_4(d_t1,k_t1_offset,d_v2,k_v2_offset,d_i0,k_i0_offse
     &t)
      CALL cisdtq_c1_5(d_t2,k_t2_offset,d_f1,k_f1_offset,d_i0,k_i0_offse
     &t)
      CALL cisdtq_c1_6(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i0,k_i0_offse
     &t)
      CALL cisdtq_c1_7(d_t2,k_t2_offset,d_v2,k_v2_offset,d_i0,k_i0_offse
     &t)
      CALL cisdtq_c1_8(d_t3,k_t3_offset,d_v2,k_v2_offset,d_i0,k_i0_offse
     &t)
      CALL cisdtq_c1_9(d_e0,k_e0_offset,d_t1,k_t1_offset,d_i0,k_i0_offse
     &t)
      RETURN
      END
      SUBROUTINE cisdtq_c1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_f + = 1 * f ( p2 h1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER p2b_1
      INTEGER h1b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. irrep_f) TH
     &EN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      CALL TCE_RESTRICTED_2(p2b,h1b,p2b_1,h1b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_1',1,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + (noab+nvab) * (p2b_1 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_1',2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_1',3,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_1',4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_1',5,MA_E
     &RR)
      END IF
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_2(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_tf + = -1 * Sum ( h3 ) * t ( p2 h3 )_t * f ( h3 h1 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h3b
      INTEGER p2b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER h1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &t,irrep_f)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h3b = 1,noab
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h3b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p2b,h3b,p2b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,h1b,h3b_2,h1b_2)
      dim_common = int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (p2b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_2',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h1b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_2',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_2',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_2',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_2',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_2',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_2',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_tf + = 1 * Sum ( p3 ) * t ( p3 h1 )_t * f ( p2 p3 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p3b_1
      INTEGER h1b_1
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &t,irrep_f)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h1b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h1b,p3b_1,h1b_1)
      CALL TCE_RESTRICTED_2(p2b,p3b,p2b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_3',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (p2b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_3',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_3',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_3',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_3',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),1,2,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_3',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_3',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_4(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_vt + = -1 * Sum ( h4 p3 ) * t ( p3 h4 )_t * v ( h4 p2 h1 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER p3b_1
      INTEGER h4b_1
      INTEGER p2b_2
      INTEGER h4b_2
      INTEGER h1b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_4',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      IF (int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h4b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),int_mb(k_sym+h4b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p3b,h4b,p3b_1,h4b_1)
      CALL TCE_RESTRICTED_4(p2b,h4b,h1b,p3b,p2b_2,h4b_2,h1b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1)
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_4',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_4',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h4b_1
     & - 1 + noab * (p3b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+h4b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_4',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_4',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_4',5,MA_ERR)
      IF ((h4b .le. p2b) .and. (h1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (h1b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_4',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_4',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_4',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_4',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_4',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_4',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_5(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_tf + = 1 * Sum ( p4 h3 ) * t ( p2 p4 h1 h3 )_t * f ( h3 p4 )_f
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p4b
      INTEGER h3b
      INTEGER p2b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h3b_1
      INTEGER h3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &t,irrep_f)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_5',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p4b = noab+1,noab+nvab
      DO h3b = 1,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h3b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h3b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p2b,p4b,h1b,h3b,p2b_1,p4b_1,h1b_1,h3b_1)
      CALL TCE_RESTRICTED_2(h3b,p4b,h3b_2,p4b_2)
      dim_common = int_mb(k_range+p4b-1) * int_mb(k_range+h3b-1)
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_5',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_5',2,MA_ERR)
      IF ((p4b .lt. p2b) .and. (h3b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h3b-1),int_mb(k_range+h1b-1)
     &,4,2,3,1,1.0d0)
      END IF
      IF ((p4b .lt. p2b) .and. (h1b .le. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p4b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h1b-1),int_mb(k_range+h3b-1)
     &,3,2,4,1,-1.0d0)
      END IF
      IF ((p2b .le. p4b) .and. (h3b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h3b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h3b-1),int_mb(k_range+h1b-1)
     &,4,1,3,2,-1.0d0)
      END IF
      IF ((p2b .le. p4b) .and. (h1b .le. h3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h3b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h3b-1)
     &,3,1,4,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_5',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_5',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_5',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (h3b_2 - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h3b-1)
     &,int_mb(k_range+p4b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_5',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_5',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_5',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_5',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_5',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_5',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_6(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h4 h5 p3 ) * t ( p2 p3 h4 h5 )_t * v ( h4 h5 h1 p3 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER h4b
      INTEGER h5b
      INTEGER p2b_1
      INTEGER p3b_1
      INTEGER h4b_1
      INTEGER h5b_1
      INTEGER h4b_2
      INTEGER h5b_2
      INTEGER h1b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_6',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO h4b = 1,noab
      DO h5b = h4b,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1) .eq. int_mb(k_spin+h
     &4b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+h4b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p2b,p3b,h4b,h5b,p2b_1,p3b_1,h4b_1,h5b_1)
      CALL TCE_RESTRICTED_4(h4b,h5b,h1b,p3b,h4b_2,h5b_2,h1b_2,p3b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+h4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_6',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_6',2,MA_ERR)
      IF ((p3b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,2,4,3,1,-1.0d0)
      END IF
      IF ((p2b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h4b_1 - 1 + noab * (p3b_1 - noab - 1 + nvab * (p2b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+h4b-1),int_mb(k_range+h5b-1)
     &,1,4,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_6',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_6',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_6',5,MA_ERR)
      IF ((h1b .le. p3b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - 1 + (noab+nvab) * (h1b_2 - 1 + (noab+nvab) * (h5b_2 - 1 + (noab
     &+nvab) * (h4b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h4b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h1b-1),int_mb(k_range+p3b-1)
     &,3,2,1,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_6',6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h4b .eq. h5b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_6',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_6',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_6',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_6',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_6',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_7(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_vt + = -1/2 * Sum ( h5 p3 p4 ) * t ( p3 p4 h1 h5 )_t * v ( h5 p2 p3 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER h5b
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h5b_1
      INTEGER p2b_2
      INTEGER h5b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_7',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h5b = 1,noab
      IF (int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1) .eq. int_mb(k_spin+h
     &1b-1)+int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p3b-1),ieor(int_mb(k_sym+p4b-1),ieor(int_mb(
     &k_sym+h1b-1),int_mb(k_sym+h5b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p3b,p4b,h1b,h5b,p3b_1,p4b_1,h1b_1,h5b_1)
      CALL TCE_RESTRICTED_4(p2b,h5b,p3b,p4b,p2b_2,h5b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+h5b-1)
      dima_sort = int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_7',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_7',2,MA_ERR)
      IF ((h5b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h5b-1),int_mb(k_range+h1b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noab - 1 + nvab * (p3b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+h1b-1),int_mb(k_range+h5b-1)
     &,3,4,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_7',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_7',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_7',5,MA_ERR)
      IF ((h5b .le. p2b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (p2b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,2,1,4,3,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_7',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2)),dbl_mb(k_a_sort),dim_common,dbl_
     &mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_7',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_7',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_7',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),1,2,-1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_7',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_7',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_8(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_vt + = 1/4 * Sum ( h5 h6 p3 p4 ) * t ( p2 p3 p4 h1 h5 h6 )_t * v ( h5 h6 p3 p4 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p3b
      INTEGER p4b
      INTEGER h5b
      INTEGER h6b
      INTEGER p2b_1
      INTEGER p3b_1
      INTEGER p4b_1
      INTEGER h1b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsuperp(2)
      INTEGER isuperp
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &v,irrep_t)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_8',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      DO h5b = 1,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1)
     & .eq. int_mb(k_spin+h1b-1)+int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p3b-1),ieor(int_mb(
     &k_sym+p4b-1),ieor(int_mb(k_sym+h1b-1),ieor(int_mb(k_sym+h5b-1),int
     &_mb(k_sym+h6b-1)))))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_6(p2b,p3b,p4b,h1b,h5b,h6b,p2b_1,p3b_1,p4b_1,h1
     &b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,p4b,h5b_2,h6b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1) * int_m
     &b(k_range+h5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dima = dim_common * dima_sort
      dimb_sort = 1
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_8',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_8',2,MA_ERR)
      IF ((p4b .lt. p2b) .and. (h6b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (p2b_1 - noa
     &b - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p2b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h1b-1),6,3,5,4,2,1,1.0d0)
      END IF
      IF ((p4b .lt. p2b) .and. (h5b .lt. h1b) .and. (h1b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h5b_1 - 1 + noab * (p2b_1 - noa
     &b - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p2b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h6b-1),5,3,6,4,2,1,-1.0d0)
      END IF
      IF ((p4b .lt. p2b) .and. (h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h1b_1 - 1 + noab * (p2b_1 - noa
     &b - 1 + nvab * (p4b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p4b-1),int_mb(k_range+p2b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),4,3,6,5,2,1,1.0d0)
      END IF
      IF ((p3b .lt. p2b) .and. (p2b .le. p4b) .and. (h6b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p4b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h1b-1),6,2,5,4,3,1,-1.0d0)
      END IF
      IF ((p3b .lt. p2b) .and. (p2b .le. p4b) .and. (h5b .lt. h1b) .and.
     & (h1b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p4b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h6b-1),5,2,6,4,3,1,1.0d0)
      END IF
      IF ((p3b .lt. p2b) .and. (p2b .le. p4b) .and. (h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p3b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),4,2,6,5,3,1,-1.0d0)
      END IF
      IF ((p2b .le. p3b) .and. (h6b .lt. h1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h1b_1
     & - 1 + noab * (h6b_1 - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p2b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+h1b-1),6,1,5,4,3,2,1.0d0)
      END IF
      IF ((p2b .le. p3b) .and. (h5b .lt. h1b) .and. (h1b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h1b_1 - 1 + noab * (h5b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p2b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h1b-1),int_mb(k_range+h6b-1),5,1,6,4,3,2,-1.0d0)
      END IF
      IF ((p2b .le. p3b) .and. (h1b .le. h5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (h1b_1 - 1 + noab * (p4b_1 - noa
     &b - 1 + nvab * (p3b_1 - noab - 1 + nvab * (p2b_1 - noab - 1)))))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p4b-1),int_mb(k_range+h1b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+h6b-1),4,1,6,5,3,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_8',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_8',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_8',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - 1 + (noab+nvab) * (p3b_2 - 1 + (noab+nvab) * (h6b_2 - 1 + (noab
     &+nvab) * (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_8',6,MA_ERR)
      nsuperp(1) = 1
      nsuperp(2) = 1
      isuperp = 1
      IF (p3b .eq. p4b) THEN
      nsuperp(isuperp) = nsuperp(isuperp) + 1
      ELSE
      isuperp = isuperp + 1
      END IF
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,4.0d0/FACTORIAL(
     &nsuperp(1))/FACTORIAL(nsuperp(2))/FACTORIAL(nsubh(1))/FACTORIAL(ns
     &ubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.
     &0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_8',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_8',8,MA_E
     &RR)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_8',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,1.0d0/4.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_8',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_8',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE cisdtq_c1_9(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_offse
     &t)
C     $Id: cisdtq_c1.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p2 h1 )_te + = -1 * e ( )_e * t ( p2 h1 )_t
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p2b
      INTEGER h1b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p2b_2
      INTEGER h1b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p2b = noab+1,noab+nvab
      DO h1b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p2b-1)+int_mb(k_spin+h1b-1
     &).ne.4)) THEN
      IF (int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h1b-1)) THEN
      IF (ieor(int_mb(k_sym+p2b-1),int_mb(k_sym+h1b-1)) .eq. ieor(irrep_
     &t,irrep_e)) THEN
      dimc = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('cisdtq_c1_9',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (0 .eq. irrep_e) THEN
      CALL TCE_RESTRICTED_2(p2b,h1b,p2b_2,h1b_2)
      dim_common = 1
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+h1b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('cisdtq_c1_9',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &cisdtq_c1_9',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_a),dbl_mb(k_a_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('cisdtq_c1_9',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('cisdtq_c1_9',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &cisdtq_c1_9',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(h1b_2
     & - 1 + noab * (p2b_2 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h1b-1),2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('cisdtq_c1_9',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('cisdtq_c1_9',7,MA_E
     &RR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('cisdtq_c1_9',8,MA_E
     &RR)
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &cisdtq_c1_9',9,MA_ERR)
      CALL TCE_SORT_2(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h1b-1)
     &,int_mb(k_range+p2b-1),2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h1b -
     & 1 + noab * (p2b - noab - 1)))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('cisdtq_c1_9',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('cisdtq_c1_9',11,MA_
     &ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
#endif

      logical function argos_prepare_ssize(isgm,xs,msa,nsa,rsgm)
c
      implicit none
c
      integer msa,nsa
      integer isgm(msa)
      real*8 xs(3,msa)
      real*8 rsgm
c
      integer i,j
      real*8 d
c
      rsgm=0.0d0
c
      do 1 i=1,nsa-1
      do 2 j=i+1,nsa
      if(isgm(i).eq.isgm(j)) then
      d=(xs(1,i)-xs(1,j))**2+(xs(2,i)-xs(2,j))**2+(xs(3,i)-xs(3,j))**2
      rsgm=max(rsgm,d)
      endif
    2 continue
    1 continue
      if(rsgm.gt.0) rsgm=dsqrt(rsgm)
c
      argos_prepare_ssize=.true.
c
      return
      end
c $Id: argos_prepare_ssize.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine fock_get_blk( narray, varray, ilo, ihi,
     $     jlo, jhi, buf, tmp)
c     
c     $Id: fock_get_blk.F 19707 2010-10-29 17:59:36Z d3y133 $
c     
      implicit none
#include "global.fh"
c     
c     get the block of the matrix g_array (over basis functions)
c     result into buf(1:idim, 1:jdim) as a dense array. 
c     
      integer narray, varray(narray)
      double precision buf(narray,*)
      double precision tmp(*)
      integer ilo, ihi, jlo, jhi
c
      integer iarray, jarray, i, j, ji
      integer ilen, jlen
c     
      ilen = ihi - ilo + 1
      jlen = jhi - jlo + 1
c     
      if ((ilen.gt.0).and.(jlen.gt.0)) then
         if (narray.gt.1) then
            do iarray=1,narray
c     
c     determine if this array is the same as one already fetched
c     ... if so just copy the data
c     
               do jarray = 1, iarray-1
                  if (varray(jarray) .eq. varray(iarray)) then
                     do j=1,jlen
                        ji = (j-1)*ilen
                        do i=1,ilen
                           buf(iarray,ji+i) = buf(jarray,ji+i)
                        enddo
                     enddo
                     goto 10
                  endif
               enddo
c
c     Array not a duplicate ... got to get it
c
               call ga_get(varray(iarray), ilo, ihi, jlo, jhi,
     $              tmp, ilen)
               do j=1,jlen
                  ji = (j-1)*ilen
                  do i=1,ilen
                     buf(iarray,ji+i) = tmp(ji+i)
                  enddo
               enddo
c
 10            continue
            enddo
         else
            call ga_get(varray(1), ilo, ihi, jlo, jhi, buf, ilen )
         endif
      endif
c     
      end
      subroutine get_atom_block(g_array, basis, iat, jat, buf,
     $     idim, jdim)
C$Id: fock_get_blk.F 19707 2010-10-29 17:59:36Z d3y133 $
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
c
      integer g_array, basis, iat, jat, idim, jdim
      double precision buf(*)
c
      integer ilo, ihi, jlo, jhi
c
c     get the block of the matrix g_array (over basis functions)
c     corresponding to the atoms iat and jat, putting the
c     result into buf(1:idim, 1:jdim) as a dense array. 
c     idim, jdim are returned
c
      if (.not. bas_ce2bfr(basis, iat, ilo, ihi))
     $     call errquit('get_atom_block: ce2bfr failed', 0, BASIS_ERR)
      if (.not. bas_ce2bfr(basis, jat, jlo, jhi))
     $     call errquit('get_atom_block: ce2bfr failed', 0, BASIS_ERR)
      idim = ihi - ilo + 1
      jdim = jhi - jlo + 1
c
      if (idim.gt.0 .and. jdim.gt.0) then
         call ga_get(g_array, ilo, ihi, jlo, jhi, buf, idim)
      endif
*      write(6,*) ' gab: ', iat, jat
*      call output(buf, 1, idim, 1, jdim, idim, jdim, 1)
c
      end

*> \brief \b DSYR
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DSYR(UPLO,N,ALPHA,X,INCX,A,LDA)
* 
*       .. Scalar Arguments ..
*       DOUBLE PRECISION ALPHA
*       INTEGER INCX,LDA,N
*       CHARACTER UPLO
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION A(LDA,*),X(*)
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DSYR   performs the symmetric rank 1 operation
*>
*>    A := alpha*x*x**T + A,
*>
*> where alpha is a real scalar, x is an n element vector and A is an
*> n by n symmetric matrix.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>           On entry, UPLO specifies whether the upper or lower
*>           triangular part of the array A is to be referenced as
*>           follows:
*>
*>              UPLO = 'U' or 'u'   Only the upper triangular part of A
*>                                  is to be referenced.
*>
*>              UPLO = 'L' or 'l'   Only the lower triangular part of A
*>                                  is to be referenced.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>           On entry, N specifies the order of the matrix A.
*>           N must be at least zero.
*> \endverbatim
*>
*> \param[in] ALPHA
*> \verbatim
*>          ALPHA is DOUBLE PRECISION.
*>           On entry, ALPHA specifies the scalar alpha.
*> \endverbatim
*>
*> \param[in] X
*> \verbatim
*>          X is DOUBLE PRECISION array of dimension at least
*>           ( 1 + ( n - 1 )*abs( INCX ) ).
*>           Before entry, the incremented array X must contain the n
*>           element vector x.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>           On entry, INCX specifies the increment for the elements of
*>           X. INCX must not be zero.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array of DIMENSION ( LDA, n ).
*>           Before entry with  UPLO = 'U' or 'u', the leading n by n
*>           upper triangular part of the array A must contain the upper
*>           triangular part of the symmetric matrix and the strictly
*>           lower triangular part of A is not referenced. On exit, the
*>           upper triangular part of the array A is overwritten by the
*>           upper triangular part of the updated matrix.
*>           Before entry with UPLO = 'L' or 'l', the leading n by n
*>           lower triangular part of the array A must contain the lower
*>           triangular part of the symmetric matrix and the strictly
*>           upper triangular part of A is not referenced. On exit, the
*>           lower triangular part of the array A is overwritten by the
*>           lower triangular part of the updated matrix.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>           On entry, LDA specifies the first dimension of A as declared
*>           in the calling (sub) program. LDA must be at least
*>           max( 1, n ).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date November 2011
*
*> \ingroup double_blas_level2
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  Level 2 Blas routine.
*>
*>  -- Written on 22-October-1986.
*>     Jack Dongarra, Argonne National Lab.
*>     Jeremy Du Croz, Nag Central Office.
*>     Sven Hammarling, Nag Central Office.
*>     Richard Hanson, Sandia National Labs.
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DSYR(UPLO,N,ALPHA,X,INCX,A,LDA)
*
*  -- Reference BLAS level2 routine (version 3.4.0) --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     November 2011
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION ALPHA
      INTEGER INCX,LDA,N
      CHARACTER UPLO
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION A(LDA,*),X(*)
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D+0)
*     ..
*     .. Local Scalars ..
      DOUBLE PRECISION TEMP
      INTEGER I,INFO,IX,J,JX,KX
*     ..
*     .. External Functions ..
      LOGICAL LSAME
      EXTERNAL LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC MAX
*     ..
*
*     Test the input parameters.
*
      INFO = 0
      IF (.NOT.LSAME(UPLO,'U') .AND. .NOT.LSAME(UPLO,'L')) THEN
          INFO = 1
      ELSE IF (N.LT.0) THEN
          INFO = 2
      ELSE IF (INCX.EQ.0) THEN
          INFO = 5
      ELSE IF (LDA.LT.MAX(1,N)) THEN
          INFO = 7
      END IF
      IF (INFO.NE.0) THEN
          CALL XERBLA('DSYR  ',INFO)
          RETURN
      END IF
*
*     Quick return if possible.
*
      IF ((N.EQ.0) .OR. (ALPHA.EQ.ZERO)) RETURN
*
*     Set the start point in X if the increment is not unity.
*
      IF (INCX.LE.0) THEN
          KX = 1 - (N-1)*INCX
      ELSE IF (INCX.NE.1) THEN
          KX = 1
      END IF
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through the triangular part
*     of A.
*
      IF (LSAME(UPLO,'U')) THEN
*
*        Form  A  when A is stored in upper triangle.
*
          IF (INCX.EQ.1) THEN
              DO 20 J = 1,N
                  IF (X(J).NE.ZERO) THEN
                      TEMP = ALPHA*X(J)
                      DO 10 I = 1,J
                          A(I,J) = A(I,J) + X(I)*TEMP
   10                 CONTINUE
                  END IF
   20         CONTINUE
          ELSE
              JX = KX
              DO 40 J = 1,N
                  IF (X(JX).NE.ZERO) THEN
                      TEMP = ALPHA*X(JX)
                      IX = KX
                      DO 30 I = 1,J
                          A(I,J) = A(I,J) + X(IX)*TEMP
                          IX = IX + INCX
   30                 CONTINUE
                  END IF
                  JX = JX + INCX
   40         CONTINUE
          END IF
      ELSE
*
*        Form  A  when A is stored in lower triangle.
*
          IF (INCX.EQ.1) THEN
              DO 60 J = 1,N
                  IF (X(J).NE.ZERO) THEN
                      TEMP = ALPHA*X(J)
                      DO 50 I = J,N
                          A(I,J) = A(I,J) + X(I)*TEMP
   50                 CONTINUE
                  END IF
   60         CONTINUE
          ELSE
              JX = KX
              DO 80 J = 1,N
                  IF (X(JX).NE.ZERO) THEN
                      TEMP = ALPHA*X(JX)
                      IX = JX
                      DO 70 I = J,N
                          A(I,J) = A(I,J) + X(IX)*TEMP
                          IX = IX + INCX
   70                 CONTINUE
                  END IF
                  JX = JX + INCX
   80         CONTINUE
          END IF
      END IF
*
      RETURN
*
*     End of DSYR  .
*
      END
c $Id: dsyr.f 24342 2013-06-22 05:32:15Z d3y133 $

*
* $Id: inner_loop_md.F 25768 2014-06-10 00:33:15Z bylaska $
*
*  ************************************************************
*  *                MPI cpmd routine                          *
*  *                                                          *
*  *  This is a developing cpmdv3 parallel code wrtten in     *
*  *  Fortran and MPI.                                        *
*  *                                                          *
*  *    + mpl message passing library used                    *
*  *                                                          *
*  *    + ngp is used instead of nfft in this proceudure      *
*  *                                                          *
*  *    + error checking is based on aimd.h parameters        *
*  *      then control file                                   *
*  ************************************************************
  
      subroutine inner_loop_md(verlet,sa_alpha,
     >                      ispin,ne,neq,
     >                      npack1,nfft3d,nemaxq,
     >                      psi0,psi1,psi2,dn,
     >                      it_in,it_sum,E,
     >                      hml,lmd,
     >                      Hpsi,psi_r,
     >                      calc_pressure,pressure,p1,p2,
     >                      fractional,occ0,occ1,occ2)
      implicit none
      logical    verlet
      real*8     sa_alpha(2)
      integer    ispin,ne(2),neq(2)
      integer    npack1,nfft3d,nemaxq
      complex*16 psi0(npack1,nemaxq)
      complex*16 psi1(npack1,nemaxq)
      complex*16 psi2(npack1,nemaxq)
      real*8     dn(2*nfft3d,2)
      integer    it_in,it_sum
      real*8     E(*)
      real*8     hml(*),lmd(*)

*     **** very big workspace variables ****
      complex*16 Hpsi(npack1,nemaxq)
      real*8     psi_r(2*nfft3d,nemaxq)

      logical calc_pressure
      real*8  pressure,p1,p2,stress(3,3)

      logical fractional
      real*8 occ0(*),occ1(*),occ2(*)

#include "mafdecls.fh"
#include "errquit.fh"
ccccccc#include "frac_occ.fh"


*     **** local variables ****
      logical move,fei
      integer n2ft3d,np,np_i,np_j
      integer i,j,ii,jj,n,n1(2),n2(2),it,ms,nn,ierr,gga
      integer nx,ny,nz
      integer index,indext
      real*8  sum,Eold,eorbit,eion,ehartr,eke,eki,sse,ssr,sa1,sa2
      real*8  exc,exc2,pxc,pxc2,dte,dte0,scal1,scal2,dv,dt,fmass,h
      real*8  ehsic,phsic,exsic,pxsic,ehfx,phfx,espring,enlocal
      !real*8  e_ionmm,e_qmmm,e_mmmm,e_pol,e_vib,e_cav
      real*8   e_lj,e_q,e_spring
      real*8  s,r


*     **** MA local variables ****
      logical value,nose,field_exist,sic,allow_translation
*     real*8     tmp_L(8*nemax*nemax)
*     complex*16 tmp1(nfft3d)
*     complex*16 tmp2(nfft3d)
c     complex*16  vl(nfft3d)
c     complex*16  vc(nfft3d)
c     complex*16 dng(nfft3d)
c     real*8     xcp(2*nfft3d,2)
c     real*8     xce(2*nfft3d,2)
c     real*8     fion(3,natmx)
      integer tmp_L(2)
      integer tmp1(2),tmp2(2)
      integer vl(2),vc(2),dng(2)
      integer rho(2),vlr_l(2),r_grid(2)
      integer xcp(2),xce(2),dnall(2)
      integer v_field(2)
      integer natmx,fion(2),ftest(2)
      integer npack0

*     ***** external functions ****
      integer  ion_nion,control_gga
      real*8   ion_ke,ion_ion_e,E_vnonlocal
      real*8   control_time_step,control_fake_mass,ion_dti
      real*8   lattice_omega,coulomb_e,ewald_e
      external ion_nion,control_gga
      external ion_ke,ion_ion_e,E_vnonlocal
      external control_time_step,control_fake_mass,ion_dti
      external lattice_omega,coulomb_e,ewald_e
      logical  psp_semicore
      external psp_semicore
      integer  control_version
      external control_version
      logical  control_Nose,control_Fei
      external control_Nose,control_Fei
      real*8   Nose_e_energy,Nose_r_energy,Nose_sse,Nose_ssr
      real*8   Nose_dXe,Nose_dXr
      external Nose_e_energy,Nose_r_energy,Nose_sse,Nose_ssr
      external Nose_dXe,Nose_dXr

*     ***** QM/MM external functions ****
      logical  pspw_charge_found,pspw_qmmm_found
      real*8   pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E
      external pspw_charge_found,pspw_qmmm_found
      external pspw_qmmm_LJ_E,pspw_qmmm_Q_E,pspw_qmmm_spring_E

      logical  dplot_iteration_check
      external dplot_iteration_check

      logical  pspw_SIC,pspw_SIC_relaxed,control_allow_translation
      logical  pspw_HFX,pspw_HFX_relaxed
      external pspw_SIC,pspw_SIC_relaxed,control_allow_translation
      external pspw_HFX,pspw_HFX_relaxed

      double precision Dneall_m_trace
      external         Dneall_m_trace
      logical  Dneall_m_push_get_block,Dneall_m_pop_stack
      external Dneall_m_push_get_block,Dneall_m_pop_stack

      logical  meta_found,tamd_found,psp_U_psputerm
      external meta_found,tamd_found,psp_U_psputerm
      logical  nwpw_meta_gga_on,ion_disp_on
      external nwpw_meta_gga_on,ion_disp_on
      real*8   nwpw_meta_gga_pxc,ion_disp_energy
      external nwpw_meta_gga_pxc,ion_disp_energy



      call Parallel_np(np)
      call Pack_npack(0,npack0)

      n2ft3d = 2*nfft3d
      field_exist       = pspw_charge_found()
      sic               = pspw_SIC()
      gga               = control_gga()
      allow_translation = control_allow_translation()
      fei = control_Fei()

*     **** allocate MA local variables ****
      call nwpw_timing_start(12)
      value = Dneall_m_push_get_block(1,8,tmp_L)
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d),'tmp1',tmp1(2),tmp1(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(nfft3d),'tmp2',tmp2(2),tmp2(1))

      if (control_version().eq.3) then
      value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'vc',  vc(2),  vc(1))
      end if

      if (control_version().eq.4) then
       value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'vc',vc(2),vc(1))

       value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'vlr_l',vlr_l(2),vlr_l(1))
      end if

      if ((control_version().eq.4).or.(field_exist)) then
       value = value.and.
     >    MA_push_get(mt_dbl,(3*n2ft3d),'r_grid',r_grid(2),r_grid(1))
      end if

      value = value.and.
     >  MA_push_get(mt_dcpl,(n2ft3d),'v_field',v_field(2),v_field(1))

      value = value.and.
     >         MA_push_get(mt_dcpl,(npack0),'vl',  vl(2),  vl(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(n2ft3d),'rho',rho(2), rho(1))
      value = value.and.
     >        MA_push_get(mt_dcpl,(npack0),'dng',dng(2), dng(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'xcp',xcp(2), xcp(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'xce',xce(2), xce(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(4*nfft3d),'dnall',dnall(2),dnall(1))
      natmx = ion_nion()
      value = value.and.
     >        MA_push_get(mt_dbl,(3*natmx),'fion',fion(2),fion(1))
      value = value.and.
     >        MA_push_get(mt_dbl,(3*natmx),'ftest',ftest(2),ftest(1))
      if (.not.value) 
     > call errquit('inner_loop_md:pushing stack',0, MA_ERR)
      call dcopy(4*nfft3d,0.0d0,0,dbl_mb(dnall(1)),1)
      call dcopy(4*nfft3d,0.0d0,0,dbl_mb(xcp(1)),1)
      call dcopy(4*nfft3d,0.0d0,0,dbl_mb(xce(1)),1)

      call nwpw_timing_end(12)
     
      call D3dB_nx(1,nx)
      call D3dB_ny(1,ny)
      call D3dB_nz(1,nz)
      move = .true.
      
      nose = control_Nose()
      sse = 1.0d0
      ssr = 1.0d0

      n1(1) = 1
      n2(1) = neq(1)
      n1(2) = neq(1) + 1
      n2(2) = neq(1) + neq(2)

      dt    = control_time_step()
      fmass = control_fake_mass()
      dte   = dt*dt/fmass
      if (.not. verlet) dte=0.5d0*dte
      if (.not.nose) then
        sa1 =    1.0d0/(2.0d0-sa_alpha(1))
        sa2 = sa_alpha(1)/(2.0d0-sa_alpha(1))
      end if

      scal1 = 1.0d0/dble(nx*ny*nz)
      scal2 = 1.0d0/lattice_omega()
      dv    = scal1*lattice_omega()

      if ((control_version().eq.4).or.(field_exist))
     >   call lattice_r_grid(dbl_mb(r_grid(1)))

      espring = 0.0d0


*     ******************************************
*     ****                                  ****
*     **** Start of molecular dynamics loop ****
*     ****                                  ****
*     ******************************************
      do it=1,it_in
        call dcopy(2*npack1*nemaxq,psi1,1,psi0,1)
        call dcopy(2*npack1*nemaxq,psi2,1,psi1,1)
*       *** skip ion_shift if newton step ***
        if (verlet) call ion_shift()
        if (nose.and.verlet) call Nose_shift()


*       ********************************
*       **** generate phaze factors ****
*       ********************************
        call phafac()
        if (control_version().eq.3) call ewald_phafac()

        call nwpw_timing_start(11)
*       *******************
*       **** get psi_r ****
*       *******************
c        do n=n1(1),n2(ispin)
c           call Pack_c_Copy(1,psi1(1,n),psi_r(1,n))
c           call Pack_c_unpack(1,psi_r(1,n))
c           call D3dB_cr_fft3b(1,psi_r(1,n))
c           call D3dB_r_Zero_Ends(1,psi_r(1,n))
c        end do
        do n=n1(1),n2(ispin)
           call Pack_c_Copy(1,psi1(1,n),psi_r(1,n))
        end do
        call Grsm_gh_fftb(nfft3d,n2(ispin),psi_r)
        do n=n1(1),n2(ispin)
           call D3dB_r_Zero_Ends(1,psi_r(1,n))
        end do

        call nwpw_meta_gga_gen_tau(ispin,neq,psi1)

*       *********************
*       **** generate dn ****
*       *********************
        call dcopy(ispin*n2ft3d,0.0d0,0,dn,1)
        if (fractional) then
          do ms=1,ispin
             do n=n1(ms),n2(ms)
                do i=1,n2ft3d
                   dn(i,ms) = dn(i,ms)
     >                      + scal2*(psi_r(i,n)**2)
     >                       *occ1(n)
                end do
             end do
             call D3dB_r_Zero_Ends(1,dn(1,ms))
             call D1dB_Vector_SumAll(n2ft3d,dn(1,ms))
          end do
        else
          do ms=1,ispin
             do n=n1(ms),n2(ms)
                do i=1,n2ft3d
                   dn(i,ms) = dn(i,ms) + scal2*(psi_r(i,n)**2)
                end do
             end do
             call D3dB_r_Zero_Ends(1,dn(1,ms))
             call D1dB_Vector_SumAll(n2ft3d,dn(1,ms))
          end do
        end if


*       **********************
*       **** generate dng ****
*       **********************
        call D3dB_rr_Sum(1,dn(1,1),dn(1,ispin),dbl_mb(rho(1)))
        call D3dB_r_SMul(1,scal1,dbl_mb(rho(1)),dcpl_mb(tmp1(1)))
        call D3dB_rc_fft3f(1,dcpl_mb(tmp1(1)))
        call Pack_c_pack(0,dcpl_mb(tmp1(1)))
        call Pack_c_Copy(0,dcpl_mb(tmp1(1)),dcpl_mb(dng(1)))

*       ********************************************************
*       **** generate dnall - used for semicore corrections ****
*       ********************************************************
        if (psp_semicore(0)) then
           call semicore_density_update()
           call semicore_density(dcpl_mb(tmp1(1)))
c           call D3dB_r_SMul(1,0.5d0,dcpl_mb(tmp1(1)),dcpl_mb(tmp1(1)))
           call D3dB_r_SMul1(1,0.5d0,dcpl_mb(tmp1(1)))
        else
           call dcopy(n2ft3d,0.0d0,0,dcpl_mb(tmp1(1)),1)
        end if
        do ms=1,ispin
          call D3dB_rr_Sum(1,dn(1,ms),
     >                     dcpl_mb(tmp1(1)),
     >                     dbl_mb(dnall(1) +(ms-1)*n2ft3d))
        end do
        call nwpw_timing_end(11)





*       *****************************************
*       **** generate local pseudopotential  ****
*       **** and also get force if move true ****
*       *****************************************
        call v_local(dcpl_mb(vl(1)),
     >               move,
     >               dcpl_mb(dng(1)),
     >               dbl_mb(fion(1)))


*       *** long-range psp for charge systems ***
        if (control_version().eq.4) then
          call v_lr_local(dbl_mb(r_grid(1)),
     >                    dbl_mb(vlr_l(1)))
          if (move) then
             call grad_v_lr_local(dbl_mb(r_grid(1)),
     >                            dbl_mb(rho(1)),
     >                            dbl_mb(fion(1)))
          end if
        end if


*       ************************************
*       **** generate coulomb potential ****
*       ************************************
        if (control_version().eq.3)
     >     call coulomb_v(dcpl_mb(dng(1)),dcpl_mb(vc(1)))

        if (control_version().eq.4)
     >     call coulomb2_v(dbl_mb(rho(1)),dbl_mb(vc(1)))


*       *************************************************
*       **** generate exchange-correlation potential ****
*       *************************************************
        call v_bwexc_all_tmp1(gga,n2ft3d,ispin,
     >                        dbl_mb(dnall(1)),
     >                        dbl_mb(xcp(1)),
     >                        dbl_mb(xce(1)),
     >                        dcpl_mb(tmp1(1)))

     
*       **********************************************
*       **** generate other real-space potentials ****
*       **********************************************
        if (field_exist) then

           call dcopy(n2ft3d,0.0d0,0,dbl_mb(v_field(1)),1)


*          **** generate charge potential ****
           if (pspw_charge_found()) then
            call pspw_charge_Generate_V(n2ft3d,
     >                               dbl_mb(r_grid(1)),
     >                               dbl_mb(v_field(1)))
           end if

        end if


*       ******************
*       **** get Hpsi ****
*       ******************
        if (control_version().eq.3)
     >  call psi_H(ispin,neq,psi1,psi_r,
     >             dcpl_mb(vl(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dcpl_mb(vc(1)),dbl_mb(xcp(1)),Hpsi,
     >             move,dbl_mb(fion(1)),fractional,occ1)

        if (control_version().eq.4)
     >     call psi_Hv4(ispin,neq,psi1,psi_r,
     >             dcpl_mb(vl(1)),dbl_mb(vlr_l(1)),
     >             dbl_mb(v_field(1)),field_exist,
     >             dbl_mb(vc(1)),dbl_mb(xcp(1)),Hpsi,
     >             move,dbl_mb(fion(1)),fractional,occ1)


*       **********************
*       **** get ewald force *
*       **********************
*       **** get the ewald force ****
        if (control_version().eq.3) call ewald_f(dbl_mb(fion(1)))

*       **** get the free-space ion force ****
        if (control_version().eq.4) call ion_ion_f(dbl_mb(fion(1)))
        
*       ************************
*       **** get semicoreforce *
*       ************************
        if (psp_semicore(0)) then
           call semicore_xc_F(ispin,dbl_mb(xcp(1)),dbl_mb(fion(1)))
        end if

*       **** get the qmmm force ****
        if (pspw_qmmm_found()) call pspw_qmmm_fion(dbl_mb(fion(1)))

*       **** get the dispersion force ****
        if (ion_disp_on()) call ion_disp_force(dbl_mb(fion(1)))


*       *****************************************
*       **** remove ion forces using ion_FixIon *
*       *****************************************
        if (fei) 
     >    call dcopy(3*natmx,dbl_mb(fion(1)),1,dbl_mb(ftest(1)),1)
        call ion_FixIon(dbl_mb(fion(1)))
c        if (meta) call meta_force(ispin,neq,psi1,Hpsi,dbl_mb(fion(1)))

        !**** center of mass constraint ****
c        if (.not.allow_translation) then
c          call remove_center_F_mass(dbl_mb(fion(1)))
c        end if

*       **************************
*       **** do a verlet step ****
*       **************************
        if (verlet) then
*          **** constant temperature ****
           if (nose) then 
             sse = Nose_sse()
             ssr = Nose_ssr()
             do n=1,n2(ispin)
              call Pack_c_SMul(1,0.5d0*dte,Hpsi(1,n),psi2(1,n))
              call Pack_cc_daxpy(1,-1.0d0,psi0(1,n),psi2(1,n))
              call Pack_cc_daxpy(1,1.0d0,psi1(1,n),psi2(1,n))
c              call Pack_c_SMul(1,2.0d0*sse,psi2(1,n),psi2(1,n))
              call Pack_c_SMul1(1,2.0d0*sse,psi2(1,n))
              call Pack_cc_daxpy(1,1.0d0,psi0(1,n),psi2(1,n))
             end do
             call ion_nose_step(ssr,dbl_mb(fion(1)))

*          **** constant energy ****
           else
             do n=1,n2(ispin)
              call Pack_c_SMul(1,dte*sa1,Hpsi(1,n),psi2(1,n))
              call Pack_cc_daxpy(1,-1.0d0*sa2,psi0(1,n),psi2(1,n))
              call Pack_cc_daxpy(1,2.0d0*sa1,psi1(1,n),psi2(1,n))
             end do

*            **** QM/MM Verlet update ****
             call ion_verlet_step(dbl_mb(fion(1)),sa_alpha(2))
           end if

*       **************************
*       **** do a newton step ****
*       **************************
        else
           r = 1.0d0
           s = 1.0d0
           if (nose) then
             r =  (1.0d0-0.5d0*dt*Nose_dXr())
             s =  (1.0d0-0.5d0*dt*Nose_dXe())
           end if
           do n=1,n2(ispin)
              call Pack_c_SMul(1,dte,Hpsi(1,n),psi2(1,n))
              call Pack_cc_daxpy(1,s*dt*sa_alpha(1),psi0(1,n),psi2(1,n))
c              call Pack_cc_Sum(1,psi2(1,n),psi1(1,n),psi2(1,n))
              call Pack_cc_Sum2(1,psi1(1,n),psi2(1,n))
           end do

*          **** QM/MM Newton update ****
           call ion_newton_step(dbl_mb(fion(1)),sa_alpha(2)*r)

        end if


*       *****************************************        
*       **** lagrange multiplier corrections ****
*       *****************************************        

        !**** orthoganality constraint ****
        dte0 = dte
        if (nose.and.verlet) dte0 = dte*sse
        if (fractional) then
        call psi_lmbda2(ispin,neq,nemaxq,npack1,psi1,psi2,
     >                  dte0,occ1,
     >                  lmd,dbl_mb(tmp_L(1)),ierr)
        else if (sic) then
        call psi_lmbda_sic(ispin,neq,nemaxq,npack1,psi1,psi2,dte0,
     >                 lmd,dbl_mb(tmp_L(1)),ierr)
        else
        call psi_lmbda(ispin,neq,nemaxq,npack1,psi1,psi2,dte0,
     >                 lmd,dbl_mb(tmp_L(1)),ierr)
        end if

        !**** center of mass constraint ****

        !**** total angular momentum constraint ****


*       **************************
*       *** update thermostats ***
*       **************************
        if (nose) then
          if (verlet) then
             eke = 0.0d0
             do i=1,n2(ispin)
                call Pack_cc_idot(1,psi2(1,i),psi0(1,i),sum)
                eke = eke+sum
             end do
             if (np.gt.1) call Parallel_SumAll(eke)
             eke = (ne(1)+ne(2) - eke)
             if (ispin.eq.1) eke = 2.0d0*eke
             eke = 0.5d0*(fmass/(dt*dt))*eke
             eki = ion_ke()
             call Nose_Verlet_Step(eke,eki)
          else
              eke = 0.0d0
              do i=1,n2(ispin)
                call Pack_cc_idot(1,psi0(1,i),psi0(1,i),sum)
                eke = eke+sum
              end do
              if (np.gt.1) call Parallel_SumAll(eke)
              if (ispin.eq.1) eke = 2.0d0*eke
              eke = eke*fmass
              eki = ion_ke()
              call Nose_Newton_Step(eke,eki)
          end if
        end if


*       ********************
*       **** call dplot ****
*       ********************
        if (dplot_iteration_check(it+it_sum)) then
         call dplot_iteration((it+it_sum),ispin,neq,psi1,dn,psi_r)
        end if


      end do
*     ******************************************************
*     ***** end main loop **********************************
*     ******************************************************

*     **** if newton then skip energy calculations ****
      if (.not. verlet) goto 333


*     *************************************
*     ***** total energy calculation ******
*     *************************************
      call nwpw_timing_start(10)
      call Parallel2d_np_i(np_i)
      call Parallel2d_np_j(np_j)

*     *** get orbital energies ****
      call Dneall_ffm_sym_Multiply(0,psi1,Hpsi,npack1,hml)
      call Dneall_m_scal(0,(-1.0d0),hml)
      if (fractional) then
         call Dneall_m_diag_scal(0,occ1,hml)
         eorbit = Dneall_m_trace(0,hml)
         call Dneall_m_diag_scal_inv(0,occ1,hml)
      else
         eorbit = Dneall_m_trace(0,hml)
      end if
      if (ispin.eq.1) eorbit = eorbit+eorbit



*     **** get ewald energy ****
      eion = 0.0d0
      if (control_version().eq.3) eion = ewald_e()

*     **** get free-space ion-ion energy ****
      if (control_version().eq.4) eion = ion_ion_e()


    
           
*     **** get coulomb energy ****
      if (control_version().eq.3) ehartr = coulomb_e(dcpl_mb(dng(1)))
      if (control_version().eq.4) then
         call D3dB_rr_dot(1,dbl_mb(rho(1)),dbl_mb(vc(1)),ehartr)
         ehartr = 0.5d0*ehartr*dv
      end if

        

*     **** get exchange-correlation energy ****
      call D3dB_rr_dot(1,dbl_mb(dnall(1)),dbl_mb(xce(1)),exc)
      call D3dB_rr_dot(1,dn(1,1),dbl_mb(xcp(1)),pxc)
      if (ispin.eq.1) then
         exc= exc + exc 
         pxc= pxc + pxc 
      else
         call D3dB_rr_dot(1,dbl_mb(dnall(1)+n2ft3d),
     >                      dbl_mb(xce(1)),exc2)
         call D3dB_rr_dot(1,dn(1,2),dbl_mb(xcp(1)+n2ft3d),pxc2)
         exc= exc + exc2
         pxc= pxc + pxc2
      end if
      exc = exc*dv
      pxc = pxc*dv

      if (nwpw_meta_gga_on()) then
         pxc = pxc + nwpw_meta_gga_pxc(ispin,neq,psi1)
      end if



        
*     **** velocity and kinetic energy of psi ****
      h = 1.0d0/(2.0d0*dt)
      eke = 0.0d0
      do i=1,n2(ispin)
c         call Pack_c_SMul(1,-h,psi0(1,i),psi0(1,i))
         call Pack_c_SMul1(1,-h,psi0(1,i))
         call Pack_cc_daxpy(1,h,psi2(1,i),psi0(1,i))
         call Pack_cc_idot(1,psi0(1,i),psi0(1,i),sum)
         eke = eke+sum
      end do
      if (np.gt.1) call Parallel_SumAll(eke)
      eke = eke*fmass
      if (ispin.eq.1) eke = 2.0d0*eke

 

*     **** total energy ****
      Eold=E(1)
      E(2) = eorbit + eion + exc - ehartr - pxc + espring
      E(3) = eke
      E(4) = ion_ke()
      E(5) = eorbit
      E(6) = ehartr
      E(7) = exc
      E(8) = eion
      E(22) = espring

*     ******** QM/MM energies ******
      if (pspw_qmmm_found()) then
         e_lj     = pspw_qmmm_LJ_E()
         e_q      = pspw_qmmm_Q_E()
         e_spring = pspw_qmmm_spring_E()
         E(2)  = E(2) + e_lj + e_q + e_spring

         E(11) = e_lj
         E(12) = e_q
         E(13) = e_spring
      end if

*     **** SIC corrections ****
      if (pspw_SIC()) then
         call pspw_energy_SIC(ispin,psi_r,ehsic,phsic,exsic,pxsic)
         E(2) = E(2) + ehsic + exsic
         E(16) = ehsic
         E(17) = exsic
         if (pspw_SIC_relaxed()) then
            E(2)  = E(2) - phsic - pxsic
            E(18) = phsic
            E(19) = pxsic
         end if
      end if

*     **** HFX corrections ****
      if (pspw_HFX()) then
         call pspw_energy_HFX(ispin,psi_r,ehfx,phfx)
         E(2) = E(2) + ehfx
         E(20) = ehfx
         if (pspw_HFX_relaxed()) then
            E(2)  = E(2) - phfx
            E(21) = phfx
         end if
      end if

*     **** DFT+U terms ****
      if (psp_U_psputerm()) then
         call psp_U_psputerm_energy(ehfx,phfx)
         E(29) =  ehfx
         E(30) =  phfx
         E(2)  = E(2) + E(29) - E(30)
      end if

*     **** metadynamics energy ****
      if (meta_found()) then
         call meta_energypotential(ispin,neq,psi1,E(31),E(32))
         E(2)  = E(2) + E(31) - E(32)
      end if

*     **** dispersion energy ***
      if (ion_disp_on()) then
         E(33) = ion_disp_energy()
         E(2)  = E(2) + E(33)
      end if

*     **** tamd energy ****
      if (tamd_found()) then
         call tamd_energypotential(ispin,neq,psi1,E(34),E(35))
         E(2)  = E(2) + E(34) - E(35)
      end if


*     **** Energy and Energy**2 sum ***
      E(25) = E(25) + E(2)
      E(26) = E(26) + E(2)*E(2)
      E(27) = E(27) + E(2)+E(3)+E(4)
      E(28) = E(28) + (E(2)+E(3)+E(4))**2

*     **** output Forces for Fei ***
      if (fei) call fei_output(E(2),dbl_mb(ftest(1)))


*     **** Nose thermostat energies ****
      if (nose) then
        E(9)  = Nose_e_energy()
        E(10) = Nose_r_energy()
        E(1)  = E(2)+E(3)+E(4)+E(9)+E(10)
      else
        E(1) = E(2)+E(3)+E(4)
      end if


*     ******** pressure ******
      if (calc_pressure) then

c*        ***** average Kohn-Sham v_nonlocal energy ****
c        call dcopy(2*npack1*nemaxq,0.0d0,0,Hpsi,1)
c        call v_nonlocal(ispin,neq,psi1,Hpsi,
c     >                .false.,dbl_mb(ftest(1)),fractional,occ1)
c        enlocal = 0.0d0
c        do ms=1,ispin
c        do n=n1(ms),n2(ms)
c         call Pack_cc_idot(1,psi1(1,n),Hpsi(1,n),sum)
c         if (fractional) sum=sum*occ1(n)
c         enlocal = enlocal - sum
c        end do
c        end do
c        if (np.gt.1) call Parallel_SumAll(enlocal)
c        if (ispin.eq.1) enlocal = 2.0d0*enlocal
        enlocal = E_vnonlocal(ispin,neq,fractional,occ1)


        call cgsd_pressure_stress(ispin,neq,psi1,
     >                            dbl_mb(dnall(1)),
     >                            dcpl_mb(dng(1)),
     >                            dbl_mb(xcp(1)),
     >                            enlocal,exc,pxc,
     >                            pressure,p1,p2,stress)
      end if


*      **** write ecce data ****
       call ecce_print_module_entry('task car-parrinello')
       call ion_ecce()

       call ecce_print1('total energy', mt_dbl,     E(1), 1)
       call ecce_print1('total kinetic', mt_dbl,    E(3)+E(4), 1)
       call ecce_print1('potential energy', mt_dbl, E(2), 1)
       call ecce_print1('electron kinetic', mt_dbl, E(3), 1)
       call ecce_print1('ion kinetic', mt_dbl,      E(4), 1)
       call ecce_print1('time', mt_dbl,      (it_in+it_sum)*dt, 1)

       call ecce_print2('total gradient', mt_dbl, dbl_mb(fion(1)),
     $        3,3,natmx)
       call ecce_print1('gradient norm', mt_dbl, E(1), 1)
       call ecce_print1('orbital gradient norm', mt_dbl, E(4), 1)
c       call ecce_print1('gradient max', mt_dbl, E(1), 1)
       call ecce_print_module_exit('task car-parrinello', 'ok')


      call nwpw_timing_end(10)

*     **** dealocate MA local variables ****
 333  continue
      call nwpw_timing_start(12)

      value = MA_pop_stack(ftest(2))
      value = value.and.MA_pop_stack(fion(2))
      value = value.and.MA_pop_stack(dnall(2))
      value = value.and.MA_pop_stack(xce(2))
      value = value.and.MA_pop_stack(xcp(2))
      value = value.and.MA_pop_stack(dng(2))
      value = value.and.MA_pop_stack(rho(2))
      value = value.and.MA_pop_stack(vl(2))
      value = value.and.MA_pop_stack(v_field(2))

      if ((control_version().eq.4).or.(field_exist)) 
     >  value = value.and.MA_pop_stack(r_grid(2))

      if (control_version().eq.4) 
     >  value = value.and.MA_pop_stack(vlr_l(2))

      value = value.and.MA_pop_stack(vc(2))
      value = value.and.MA_pop_stack(tmp2(2))
      value = value.and.MA_pop_stack(tmp1(2))
      value = value.and.Dneall_m_pop_stack(tmp_L)
      if (.not.value) 
     > call errquit('inner_loop_md:popping stack',1, MA_ERR)

      call nwpw_timing_end(12)

      return
      end
 

      subroutine w_zcji_zkab
     &  (w, zcji, zkab, 
     &   alo, ahi, blo, bhi, clo, chi, 
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zcji(zlo:zhi,clo:chi,jlo:jhi,ilo:ihi)
      double precision zkab(zlo:zhi,klo:khi,alo:ahi,blo:bhi)
      double precision r(zlo:zhi,alo:ahi,blo:bhi)
      double precision x(alo:ahi,blo:bhi,clo:chi,jlo:jhi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, jdim, jbegin, jend, ibegin
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do k = klo, khi
c
         do b = blo, bhi
            do a = alo, ahi
               do z = zlo, zhi
                  r(z,a,b) = zkab(z,k,a,b)
               enddo
            enddo
         enddo
c
         ibegin = ilo
         if (spin.eq.spinck)ibegin = max(ilo,k+1)
         do i = ibegin, ihi
c
            jbegin = jlo
            if (spin.eq.spinck)jbegin = max(jlo,k+1)
            jend = min(jhi,i-1)
            jdim = jend - jbegin + 1
c
            if (jdim.gt.0)then
c
               call dgemm('T', 'N', adim*bdim, cdim*jdim, zdim, alpha, 
     &              r, zdim, zcji(zlo,clo,jbegin,i), zdim, 
     &              0.0d0, x(alo,blo,clo,jbegin), adim*bdim)
c
               do j = jbegin, jend
                  do a = alo, ahi
                     do b = blo, min(bhi,a-1)
                        cend = chi
                        if (spin.eq.spinck)cend = min(chi,b-1)
                        do c = clo, cend
                           w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(a,b,c,j)
                        end do
                     end do
                  end do
               end do
c     
               flopcount = flopcount + 
     &              2d0*dble(adim*bdim*cdim)*zdim*jdim
c
            endif
         end do
      end do
c
      call uccsdt_flops_exit(1, flopcount)
c
      end
      subroutine w_zcjk_ziab
     &  (w, zcjk, ziab,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zcjk(zlo:zhi,clo:chi,jlo:jhi,klo:khi)
      double precision ziab(zlo:zhi,ilo:ihi,alo:ahi,blo:bhi)
      double precision r(zlo:zhi,alo:ahi,blo:bhi)
      double precision x(alo:ahi,blo:bhi,clo:chi,jlo:jhi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, jdim, jbegin, jend
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do i = ilo, ihi
c
         do b = blo, bhi
            do a = alo, ahi
               do z = zlo, zhi
                  r(z,a,b) = ziab(z,i,a,b)
               enddo
            enddo
         enddo
c
         kend = khi
         if (spin.eq.spinck) kend = min(khi,i-1)
         do k = klo, kend
c
            jbegin = jlo
            if (spin.eq.spinck)jbegin = max(jlo,k+1)
            jend = min(jhi,i-1)
c
            jdim = jend - jbegin + 1
c
            if (jdim.gt.0)then
c
               call dgemm('T', 'N', adim*bdim, cdim*jdim, zdim, alpha, 
     &              r, zdim, zcjk(zlo,clo,jbegin,k), zdim, 
     &              0.0d0, x(alo,blo,clo,jbegin), adim*bdim)
c
               do j = jbegin, jend
                  do a = alo, ahi
                     do b = blo, min(bhi,a-1)
                        cend = chi
                        if (spin.eq.spinck)cend = min(chi,b-1)
                        do c = clo, cend
                           w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(a,b,c,j)
                        end do
                     end do
                  end do
               end do
c     
               flopcount = flopcount + 
     &              2d0*dble(adim*bdim*cdim)*zdim*jdim
c
            endif
         end do
      end do
c
      call uccsdt_flops_exit(2,flopcount)
c
      end
      subroutine w_zcik_zjab
     &  (w, zcik, zjab,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zcik(zlo:zhi,clo:chi,ilo:ihi,klo:khi)
      double precision zjab(zlo:zhi,jlo:jhi,alo:ahi,blo:bhi)
      double precision r(zlo:zhi,alo:ahi,blo:bhi)
      double precision x(alo:ahi,blo:bhi,clo:chi,ilo:ihi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, idim, ibegin
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do j = jlo, jhi
c
         do b = blo, bhi
            do a = alo, ahi
               do z = zlo, zhi
                  r(z,a,b) = zjab(z,j,a,b)
               enddo
            enddo
         enddo
c
         kend = khi
         if (spin.eq.spinck) kend = min(khi,j-1)
         do k = klo, kend
c
            ibegin = max(ilo,j+1)
c
            idim = ihi - ibegin + 1
c
            if (idim.gt.0)then
c
               call dgemm('T', 'N', adim*bdim, cdim*idim, zdim, alpha, 
     &              r, zdim, zcik(zlo,clo,ibegin,k), zdim, 
     &              0.0d0, x(alo,blo,clo,ibegin), adim*bdim)
c
               do i = ibegin, ihi
                  do a = alo, ahi
                     do b = blo, min(bhi,a-1)
                        cend = chi
                        if (spin.eq.spinck)cend = min(chi,b-1)
                        do c = clo, cend
                           w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(a,b,c,i)
                        end do
                     end do
                  end do
               end do
c     
               flopcount = flopcount + 
     &              2d0*dble(adim*bdim*cdim)*zdim*idim
c
            endif
         end do
      end do
c
      call uccsdt_flops_exit(3, flopcount)
c
      end
      subroutine w_zaji_zkbc
     &  (w, zaji, zkbc,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zaji(zlo:zhi,alo:ahi,jlo:jhi,ilo:ihi)
      double precision zkbc(zlo:zhi,klo:khi,blo:bhi,clo:chi)
      double precision r(zlo:zhi,blo:bhi,clo:chi)
      double precision x(blo:bhi,clo:chi,alo:ahi,jlo:jhi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, jdim, jbegin, jend, ibegin
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do k = klo, khi
c
         do c = clo, chi
            do b = blo, bhi
               do z = zlo, zhi
                  r(z,b,c) = zkbc(z,k,b,c)
               enddo
            enddo
         enddo
c
         ibegin = ilo
         if (spin.eq.spinck)ibegin = max(ilo,k+1)
         do i = ibegin, ihi
c
            jbegin = jlo
            if (spin.eq.spinck)jbegin = max(jlo,k+1)
            jend = min(jhi,i-1)
            jdim = jend - jbegin + 1
c
            if (jdim.gt.0)then
c
               call dgemm('T', 'N', bdim*cdim, adim*jdim, zdim, alpha, 
     &              r, zdim, zaji(zlo,alo,jbegin,i), zdim, 
     &              0.0d0, x(blo,clo,alo,jbegin), bdim*cdim)
c
               do j = jbegin, jend
                  do a = alo, ahi
                     do b = blo, min(bhi,a-1)
                        cend = chi
                        if (spin.eq.spinck)cend = min(chi,b-1)
                        do c = clo, cend
                           w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(b,c,a,j)
                        end do
                     end do
                  end do
               end do
c     
               flopcount = flopcount + 
     &              2d0*dble(adim*bdim*cdim)*zdim*jdim
c
            endif
         end do
      end do
c
      call uccsdt_flops_exit(4, flopcount)
c
      end
      subroutine w_zbji_zkac
     &  (w, zbji, zkac,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zbji(zlo:zhi,blo:bhi,jlo:jhi,ilo:ihi)
      double precision zkac(zlo:zhi,klo:khi,alo:ahi,clo:chi)
      double precision r(zlo:zhi,alo:ahi,clo:chi)
      double precision x(alo:ahi,clo:chi,blo:bhi,jlo:jhi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, jdim, jbegin, jend, ibegin
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()

      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do k = klo, khi
c
         do c = clo, chi
            do a = alo, ahi
               do z = zlo, zhi
                  r(z,a,c) = zkac(z,k,a,c)
               enddo
            enddo
         enddo
c
         ibegin = ilo
         if (spin.eq.spinck)ibegin = max(ilo,k+1)
         do i = ibegin, ihi
c
            jbegin = jlo
            if (spin.eq.spinck)jbegin = max(jlo,k+1)
            jend = min(jhi,i-1)
            jdim = jend - jbegin + 1
c
            if (jdim.gt.0)then
c
               call dgemm('T', 'N', adim*cdim, bdim*jdim, zdim, alpha, 
     &              r, zdim, zbji(zlo,blo,jbegin,i), zdim, 
     &              0.0d0, x(alo,clo,blo,jbegin), adim*cdim)
c
               do j = jbegin, jend
                  do a = alo, ahi
                     do b = blo, min(bhi,a-1)
                        cend = chi
                        if (spin.eq.spinck)cend = min(chi,b-1)
                        do c = clo, cend
                           w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(a,c,b,j)
                        end do
                     end do
                  end do
               end do
c     
               flopcount = flopcount + 
     &              2d0*dble(adim*bdim*cdim)*zdim*jdim
c
            endif
         end do
      end do
c
      call uccsdt_flops_exit(5, flopcount)
c      
      end
      subroutine w_zakj_zicb
     &  (w, zakj, zicb,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zakj(zlo:zhi,alo:ahi,klo:khi,jlo:jhi)
      double precision zicb(zlo:zhi,ilo:ihi,clo:chi,blo:bhi)
      double precision r(zlo:zhi,clo:chi,blo:bhi)
      double precision x(clo:chi,blo:bhi,alo:ahi,klo:khi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, kdim
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do i = ilo, ihi
c
         do b = blo, bhi
            do c = clo, chi
               do z = zlo, zhi
                  r(z,c,b) = zicb(z,i,c,b)
               enddo
            enddo
         enddo
         do j = jlo, min(jhi,i-1)
            kend = khi
            if (spin.eq.spinck) kend = min(khi,j-1)
            kdim = kend - klo + 1
c
            call dgemm('T', 'N', cdim*bdim, adim*kdim, zdim, alpha, 
     &           r, zdim, zakj(zlo,alo,klo,j), zdim, 
     &           0.0d0, x, cdim*bdim)
c
            do k = klo, kend
               do a = alo, ahi
                  do b = blo, min(bhi,a-1)
                     cend = chi
                     if (spin.eq.spinck)cend = min(chi,b-1)
                     do c = clo, cend
                        w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(c,b,a,k)
                     end do
                  end do
               end do
            end do
c
            flopcount = flopcount + 2d0*dble(adim*bdim*cdim)*zdim*kdim
c
         end do
      end do
      call uccsdt_flops_exit(6, flopcount)
c
      end
      subroutine w_zbkj_zica
     &  (w, zbkj, zica,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zbkj(zlo:zhi,blo:bhi,klo:khi,jlo:jhi)
      double precision zica(zlo:zhi,ilo:ihi,clo:chi,alo:ahi)
      double precision r(zlo:zhi,clo:chi,alo:ahi)
      double precision x(clo:chi,alo:ahi,blo:bhi,klo:khi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, kdim
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do i = ilo, ihi
c
         do a = alo, ahi
            do c = clo, chi
               do z = zlo, zhi
                  r(z,c,a) = zica(z,i,c,a)
               enddo
            enddo
         enddo
         do j = jlo, min(jhi,i-1)
            kend = khi
            if (spin.eq.spinck) kend = min(khi,j-1)
            kdim = kend - klo + 1
c
            call dgemm('T', 'N', cdim*adim, bdim*kdim, zdim, alpha, 
     &           r, zdim, zbkj(zlo,blo,klo,j), zdim, 
     &           0.0d0, x, cdim*adim)
c
            do k = klo, kend
               do a = alo, ahi
                  do b = blo, min(bhi,a-1)
                     cend = chi
                     if (spin.eq.spinck)cend = min(chi,b-1)
                     do c = clo, cend
                        w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(c,a,b,k)
                     end do
                  end do
               end do
            end do
c
            flopcount = flopcount + 2d0*dble(adim*bdim*cdim)*zdim*kdim
c
         end do
      end do
c
      call uccsdt_flops_exit(7, flopcount)
c
      end
      subroutine w_zaki_zjcb
     &  (w, zaki, zjcb,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zaki(zlo:zhi,alo:ahi,klo:khi,ilo:ihi)
      double precision zjcb(zlo:zhi,jlo:jhi,clo:chi,blo:bhi)
      double precision r(zlo:zhi,clo:chi,blo:bhi)
      double precision x(clo:chi,blo:bhi,alo:ahi,klo:khi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, kdim, ibegin
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do j = jlo, jhi
c
         do b = blo, bhi
            do c = clo, chi
               do z = zlo, zhi
                  r(z,c,b) = zjcb(z,j,c,b)
               enddo
            enddo
         enddo
c
         ibegin = max(ilo,j+1)
         do i = ibegin, ihi
c
            kend = khi
            if (spin.eq.spinck) kend = min(khi,j-1)
            kdim = kend - klo + 1
c
            call dgemm('T', 'N', cdim*bdim, adim*kdim, zdim, alpha, 
     &           r, zdim, zaki(zlo,alo,klo,i), zdim, 
     &           0.0d0, x, cdim*bdim)
c
            do k = klo, kend
               do a = alo, ahi
                  do b = blo, min(bhi,a-1)
                     cend = chi
                     if (spin.eq.spinck)cend = min(chi,b-1)
                     do c = clo, cend
                        w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(c,b,a,k)
                     end do
                  end do
               end do
            end do
c
            flopcount = flopcount + 2d0*dble(adim*bdim*cdim)*zdim*kdim
c
         end do
      end do
c
      call uccsdt_flops_exit(8, flopcount)
c
      end
      subroutine w_zbki_zjca
     &  (w, zbki, zjca,
     &   alo, ahi, blo, bhi, clo, chi,
     &   ilo, ihi, jlo, jhi, klo, khi,
     &   zlo, zhi, spin, spinck, r, x, alpha)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     &        ilo, ihi, jlo, jhi, klo, khi,
     &        zlo, zhi, spin, spinck
c
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision zbki(zlo:zhi,blo:bhi,klo:khi,ilo:ihi)
      double precision zjca(zlo:zhi,jlo:jhi,clo:chi,alo:ahi)
      double precision r(zlo:zhi,clo:chi,alo:ahi)
      double precision x(clo:chi,alo:ahi,blo:bhi,klo:khi)
      double precision alpha
      integer i, j, k, a, b, c, z, cend, kend
      integer adim, bdim, cdim, zdim, kdim, ibegin
      double precision flopcount
c
      flopcount = 0d0
      call uccsdt_flops_enter()
c
      adim = ahi - alo + 1
      bdim = bhi - blo + 1
      cdim = chi - clo + 1
      zdim = zhi - zlo + 1
c
      do j = jlo, jhi
c     
         do a = alo, ahi
            do c = clo, chi
               do z = zlo, zhi
                  r(z,c,a) = zjca(z,j,c,a)
               enddo
            enddo
         enddo
c
         ibegin = max(ilo,j+1)
         do i = ibegin, ihi
c
            kend = khi
            if (spin.eq.spinck) kend = min(khi,j-1)
            kdim = kend - klo + 1
c
            call dgemm('T', 'N', cdim*adim, bdim*kdim, zdim, alpha, 
     &           r, zdim, zbki(zlo,blo,klo,i), zdim, 
     &           0.0d0, x, cdim*adim)
c
            do k = klo, kend
               do a = alo, ahi
                  do b = blo, min(bhi,a-1)
                     cend = chi
                     if (spin.eq.spinck)cend = min(chi,b-1)
                     do c = clo, cend
                        w(c,b,a,k,j,i) = w(c,b,a,k,j,i) + x(c,a,b,k)
                     end do
                  end do
               end do
            end do
c
            flopcount = flopcount + 2d0*dble(adim*bdim*cdim)*zdim*kdim
c
         end do
      end do
c
      call uccsdt_flops_exit(9, flopcount)
c
      end
      subroutine w_energy
     $  (w, t1, t1_ck, eps, energy,
     $   int_abij, int_abjk, int_abik, int_bcij,
     $   int_acij, int_bcjk, int_acjk, int_bcik,
     $   int_acik,
     $   alo, ahi, blo, bhi, clo, chi,
     $   ilo, ihi, jlo, jhi, klo, khi,
     $   vlo, vhi, olo, ohi, 
     $   vlo_ck, vhi_ck, olo_ck, ohi_ck, 
     $   spin, spinck, nmo)
c
      implicit none
      integer alo, ahi, blo, bhi, clo, chi,
     $        ilo, ihi, jlo, jhi, klo, khi,
     $        vlo, vhi, olo, ohi, 
     $        vlo_ck, vhi_ck, olo_ck, ohi_ck, 
     $        spin, spinck, nmo
c
      double precision t1(vlo:vhi,olo:ohi)
      double precision t1_ck(vlo_ck:vhi_ck,olo_ck:ohi_ck)
      double precision w(clo:chi,blo:bhi,alo:ahi,
     &                   klo:khi,jlo:jhi,ilo:ihi)
      double precision int_abij(alo:ahi,blo:bhi,ilo:ihi,jlo:jhi)
      double precision int_abjk(alo:ahi,blo:bhi,jlo:jhi,klo:khi)
      double precision int_abik(alo:ahi,blo:bhi,ilo:ihi,klo:khi)
      double precision int_bcij(blo:bhi,clo:chi,ilo:ihi,jlo:jhi)
      double precision int_acij(alo:ahi,clo:chi,ilo:ihi,jlo:jhi)
      double precision int_bcjk(blo:bhi,clo:chi,jlo:jhi,klo:khi)
      double precision int_acjk(alo:ahi,clo:chi,jlo:jhi,klo:khi)
      double precision int_bcik(blo:bhi,clo:chi,ilo:ihi,klo:khi)
      double precision int_acik(alo:ahi,clo:chi,ilo:ihi,klo:khi)
      double precision eps(nmo,2), energy, v, d
      integer i, j, k, a, b, c, ctop, ktop
      do a = alo, ahi
         do b = blo, min(bhi,a-1)
           ctop = chi
           if (spin.eq.spinck) ctop = min(chi,b-1)
            do c = clo, ctop
               do i = ilo, ihi
                  do j = jlo, min(jhi,i-1)
                    ktop = khi
                    if (spin.eq.spinck) ktop = min(khi,j-1)
                     do k = klo, ktop
c
                        v = w(c,b,a,k,j,i)
     $                        + t1_ck(c,k)*
     $                          int_abij(a,b,i,j)
     $                        + t1(a,i)*
     $                          int_bcjk(b,c,j,k)
     $                        - t1(b,i)*
     $                          int_acjk(a,c,j,k)
     $                        - t1(a,j)*
     $                          int_bcik(b,c,i,k)
     $                        + t1(b,j)*
     $                          int_acik(a,c,i,k)
c
                        if (spin .eq. spinck) then
                          v = v 
     $                        + t1(c,i)*
     $                          int_abjk(a,b,j,k)
     $                        - t1(c,j)*
     $                          int_abik(a,b,i,k)
     $                        + t1(a,k)*
     $                          int_bcij(b,c,i,j)
     $                        - t1(b,k)*
     $                          int_acij(a,c,i,j)
                        end if
c
                        d = eps(a,spin)+
     $                      eps(b,spin)+
     $                      eps(c,spinck)-
     $                      eps(i,spin)-
     $                      eps(j,spin)-
     $                      eps(k,spinck)
c
                        energy = energy - 
     $                           v*w(c,b,a,k,j,i)/d
                     end do
                  end do
               end do
            end do
         end do
      end do
c
      end
c $Id: triples_kernels.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine mymc_input(rtdb)
c
      implicit none
#include "errquit.fh"
c
#include "stdio.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "rtdb.fh"
c
      integer rtdb
c
      character*32 tag
      character*32 pname
      character*255 token
      double precision temp,stepsize,ratio,seed
      integer mcsteps,mode,gseed
c
      pname = "mymc_input: "
c
c      write(luout,*) "in ",pname
c
      call inp_set_field(0)
c
c     start parsing input
c     ------------------
      if (.not.inp_a(token))
     + call errquit('input: no input available',0, INPUT_ERR)
C      write(*,*) 'token is: ',token
c      write(*,*) 'token is: again' 
      if (.not.inp_compare(.false.,token,'mymc'))
     + call errquit('mymc_input: no input available',0, INPUT_ERR)
      goto 2
    1 continue
      if (.not.inp_read()) call errquit('my_input: premature EOF',0,
     &       INPUT_ERR)
    2 continue
      if(.not.inp_a(token)) goto 1
c
c     temperature 
c     -----------------
      if (inp_compare(.false.,"temp", token)) then
        if (.not.inp_f(temp))
     >    call errquit('mc_input: failed to read temp',0, INPUT_ERR)
        tag = "mc:temp"
        if (.not.rtdb_put(rtdb,"mymc:temp",mt_dbl,1,temp)) 
     >      call errquit(pname//'failed to store'//tag,0,
     >       RTDB_ERR)
        goto 2
      endif
c
c     number of  Monte carlo steps 
c     -----------
      if (inp_compare(.false.,"mcsteps", token)) then
        if (.not.inp_i(mcsteps))
     >  call errquit(pname//'failed to read MC steps',0, INPUT_ERR)
        tag = "mymc:mcsteps"
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_int,1,mcsteps))
     >    call errquit(pname//'failed to store '//tag,0, RTDB_ERR)
        goto 2
      endif

c
c     number of  Monte carlo steps 
c     -----------
      if (inp_compare(.false.,"mode", token)) then
        if (.not.inp_i(mode))
     >  call errquit(pname//'failed to read mode',0, INPUT_ERR)
        tag = "mymc:mode"
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_int,1,mode))
     >    call errquit(pname//'failed to store '//tag,0, RTDB_ERR)
        goto 2
      endif
c
c     size of stepsize
c     ----------------
      if (inp_compare(.false.,"stepsize", token) ) then
        if (.not.inp_f(stepsize))
     >    call errquit('failed to read stepsize',0, INPUT_ERR)
        tag = "mymc:stepsize"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,1,stepsize)) 
     >      call errquit(pname//'failed to store'//tag,0,RTDB_ERR)
        goto 2
      endif

c
c     size of stepsize
c     ----------------
      if (inp_compare(.false.,"ratio", token) ) then
        if (.not.inp_f(ratio))
     >    call errquit('failed to read ratio',0, INPUT_ERR)
        tag = "mymc:ratio"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,1,ratio))
     >      call errquit(pname//'failed to store'//tag,0,RTDB_ERR)
        goto 2
      endif

c
c     seed for dynrnd
c     ----------------
      if (inp_compare(.false.,"seed", token) ) then
        if (.not.inp_f(seed))
     >    call errquit('failed to read seed',0, INPUT_ERR)
        tag = "mymc:seed"
        if (.not.rtdb_put(rtdb,tag,mt_dbl,1,seed))
     >      call errquit(pname//'failed to store'//tag,0,RTDB_ERR)
        goto 2
      endif

c
c     seed for  gasdev
c     ----------------
      if (inp_compare(.false.,"gseed", token)) then
        if (.not.inp_i(gseed))
     >  call errquit(pname//'failed to read gseed',0, INPUT_ERR)
        tag = "mymc:gseed"
        if (.not.rtdb_put(rtdb,tag(1:inp_strlen(tag)),mt_int,1,gseed))
     >    call errquit(pname//'failed to store '//tag,0, RTDB_ERR)
        goto 2
      endif

c      write(*,*) 'End of mymc_input.'
      end


c $Id: mymc_input.F 21176 2011-10-10 06:35:49Z d3y133 $

c     $Id: paw_energy.F 19707 2010-10-29 17:59:36Z d3y133 $
      logical function paw_energy(rtdb)
      implicit none
      integer rtdb

      logical  paw_minimizer
      external paw_minimizer

      paw_energy = paw_minimizer(rtdb,0)
      return
      end

      implicit none
*
* $Id: testcarttrans.f 19707 2010-10-29 17:59:36Z d3y133 $
*
      integer lmax, npoly, numl, lmax2
      double precision drand
      external drand
      parameter (lmax = 3, npoly = 7)
      parameter (lmax2 = lmax+lmax)
      parameter (numl = (lmax+1)*(lmax+2)*(lmax+3)/6)
      integer i, j, k, l, m, ijk, ind, nlm, n
      integer i1, i2, j1, j2, k1, k2, l1, l2, l1p, l2p
      double precision x1, x2, y1, y2, z1, z2
      double precision test1, test2, test3, r, factor
      double precision  coeff(npoly,numl)
      double precision scoeff(npoly,numl)
      double precision ncoeff(npoly,numl)
      double precision dens(numl*numl),ndens(numl*numl),work(numl*numl)
      double precision junk, a, b, c, x, y, z, test, testn, err
      double precision d(((lmax2+1)*(lmax2+2))/2, -lmax2:lmax2, 0:lmax2)
      double precision 
     $     dinv(((lmax2+1)*(lmax2+2)*(lmax2+3))/6, -lmax2:lmax2,0:lmax2)
      double precision q(-lmax2:lmax2,0:lmax2)
c
      junk = drand(55512121)
      call xlm_init
      call xlm_coeff_inv(lmax2,d,dinv)
c
      do l = 0, lmax
         do m = 1, npoly
            ijk = (l*(l+1)*(l+2))/6
            do i = l,0,-1
               do j = l-i,0,-1
                  k = l-i-j
                  ijk = ijk + 1
                  scoeff(m,ijk) = drand(0) - 0.5d0
                  coeff(m,ijk) = scoeff(m,ijk)
               enddo
            enddo
         enddo
      enddo
c
      a = drand(0)-0.5d0
      b = drand(0)-0.5d0
      c = drand(0)-0.5d0
      x = drand(0)-0.5d0
      y = drand(0)-0.5d0
      z = drand(0)-0.5d0
      write(6,1) ' New center ', a, b, c
      write(6,1) ' Target     ', x, y, z
 1    format(a,3f12.6)
c
      call cart_poly_translate(lmax,npoly,coeff,ncoeff,a,b,c)
c
      err = 0.0d0
      do m = 1, npoly
         test = 0.0d0
         testn= 0.0d0
         ijk = 0
         do l = 0, lmax
            do i = l,0,-1
               do j = l-i,0,-1
                  k = l-i-j
                  ijk = ijk + 1
                  test = test + scoeff(m,ijk)*x**i*y**j*z**k
                  testn = testn + ncoeff(m,ijk)*
     $                 (x-a)**i*(y-b)**j*(z-c)**k
               enddo
            enddo
         enddo
         err = max(err,abs(test-testn))
**         write(6,*) m, test, testn, test-testn
      enddo
      write(6,*) ' Err from translation of poly ', err
c
      do i = 1, numl**2
         dens(i) = drand(0) - 0.5d0
      enddo
      x1 = drand(0)-0.5d0
      y1 = drand(0)-0.5d0
      z1 = drand(0)-0.5d0
      x2 = drand(0)-0.5d0
      y2 = drand(0)-0.5d0
      z2 = drand(0)-0.5d0
c
      write(6,1) ' New center ', a, b, c
      write(6,1) ' Center1    ', x1, y1, z1
      write(6,1) ' Center2    ', x2, y2, z2
      err = 0.0d0
      do l1 = 0, lmax
         do l2 = 0, lmax
c
            test1 = 0.0d0
            ind = 0
            do i2 = l2,0,-1
               do j2 = l2-i2,0,-1
                  k2 = l2-i2-j2
                  do i1 = l1,0,-1
                     do j1 = l1-i1,0,-1
                        k1 = l1-i1-j1
                        ind = ind + 1
                        test1 = test1 + dens(ind)*
     $                       (x-x1)**i1*(y-y1)**j1*(z-z1)**k1*
     $                       (x-x2)**i2*(y-y2)**j2*(z-z2)**k2
                     enddo
                  enddo
               enddo
            enddo
c                        
            call cart_dens_translate(l1,x1,y1,z1,l2,x2,y2,z2,
     $           a,b,c,dens,ndens,work)
c
            test2 = 0.0d0
            ind = 0
            do i2 = l2,0,-1
               do j2 = l2-i2,0,-1
                  k2 = l2-i2-j2
                  do i1 = l1,0,-1
                     do j1 = l1-i1,0,-1
                        k1 = l1-i1-j1
                        ind = ind + 1
                        test2 = test2 + dens(ind)*
     $                       (x-x1)**i1*(y-y1)**j1*(z-z1)**k1*
     $                       (x-x2)**i2*(y-y2)**j2*(z-z2)**k2
                     enddo
                  enddo
               enddo
            enddo
c                        
            test3 = 0.0d0
            ind = 0
            do l2p = 0, l2
               do i2 = l2p,0,-1
                  do j2 = l2p-i2,0,-1
                     k2 = l2p-i2-j2
                     do l1p = 0, l1
                        do i1 = l1p,0,-1
                           do j1 = l1p-i1,0,-1
                              k1 = l1p-i1-j1
                              ind = ind + 1
                              test3 = test3 + ndens(ind)*
     $                             (x-a)**i1*(y-b)**j1*(z-c)**k1*
     $                             (x-a)**i2*(y-b)**j2*(z-c)**k2
                           enddo
                        enddo
                     enddo
                  enddo
               enddo
            enddo
c
            err = max(err,abs(test3-test1))
**            write(6,*) l1, l2, test1, test3, test3-test1
c
            call cart_dens_product(l1,l2,ndens,work)
            ijk = 0
            test = 0.0d0
            do l = 0, l1+l2
               do i = l,0,-1
                  do j = l-i,0,-1
                     k = l-i-j
                     ijk = ijk + 1
                     test = test + work(ijk)*
     $                    (x-a)**i*(y-b)**j*(z-c)**k
                  enddo
               enddo
            enddo
c
            err = max(err,abs(test-test1))
**            write(6,*) test1-test
c
            call cart_dens_to_sph(l1+l2,work,ndens,dinv,lmax2)
            test = 0.0d0
            r = sqrt((x-a)**2 + (y-b)**2 + (z-c)**2)
            call xlm(l1+l2,x-a,y-b,z-c,q,lmax2)
            nlm = 0
            do n = 0, l1+l2
               do l = n, 0, -2
                  factor = r**(n-l)
                  do m = -l, l
                     nlm = nlm + 1
                     test = test + factor*q(m,l)*ndens(nlm)
                  enddo
               enddo
            enddo
            err = max(err,abs(test-test1))
**            write(6,*) test1-test
c
            call cart_dens_trans_prod_sph(
     $           l1, x1, y1, z1,
     $           l2, x2, y2, z2, 
     $           a, b, c, work, dinv, lmax2, dens, ndens)

            test = 0.0d0
            r = sqrt((x-a)**2 + (y-b)**2 + (z-c)**2)
            call xlm(l1+l2,x-a,y-b,z-c,q,lmax2)
            nlm = 0
            do n = 0, l1+l2
               do l = n, 0, -2
                  factor = r**(n-l)
                  do m = -l, l
                     nlm = nlm + 1
                     test = test + factor*q(m,l)*ndens(nlm)
                  enddo
               enddo
            enddo
            err = max(err,abs(test-test1))
**            write(6,*) test1-test
         enddo
      enddo
      write(6,*) ' Error from translation of density ', err
c
      end

C> \ingroup task
C> @{
      logical function task_pderiv(rtdb)
*
* $Id: rak20.F 23340 2013-01-03 18:34:37Z d3y133 $
*
***********************************************************************
* This is about the nuclear coordinate derivatives of multicenter 
* integrals that we need.  Notation:
*  i,j,p  compound basis function (in practice, shell) indices, 
*       including, specification of which center the function is on
*
*  Xi, Xj   orbital basis functions (chi), position of center not shown        
*           explicitly here
*
*  Gp      density basis function, ditto
*
*  R, R2   crystal lattice translation vectors
*
*  rnuc    position of some nucleus
*
*   1,2     electronic coordinates to be integrated (vol. elements d1,d2)
*
* I will just display the integrals whose derivatives we need, not the
*  differentiation itself.
*
* 1. orbital overlap   Int d1 Xi(1) Xj(1-R)   (i think we have this)  eq. 78
*
* 2. Kinetic energy    Int d1 Xi(1) [-del^2/2] Xj(1-R)     (ditto)      eq. 30
*
* 3. 1-center attraction  -Sum(nuc)Z(nuc) Int d1 Gp(1-R) /|1-rnuc|      eq. 60
*
* 4. 2-center repulsion  Int d1 d2 Gp(1) (1/r12) Gp(2-R)  [r12 obvious, 
*     p = some other p index] eq. 52
*
* 5. 2-center attraction -Sum(nuc)Z(nuc) Int d1 Xi(1+R2)Xj(1+R2-R)/|1-rnuc|  eq.42
*
* 6. 3-center repulsion Int d1 d2 Xi(1)Xj(1-R)(1/r12)Gp(2-R2)         eq. 41
* 
* All equations refer to our gross paper JCP 105, 10983 (1995),
* doi:10.1063/1.472866 of which I believe you have a copy of, if not I will
* bring one.
* 
* Probably you will need some more details on how we want this, or we can
* talk to you to understand how we get it, then we can reshuffle things as
* necessary.  For example do we get the derivative of any integral with
* repect to any arbitrary nucleus that we specify, or with respect to all
* nuclei in a single block of data, or only for those nuclei which are
* relevant (nonzero deriv.) for a given integral?  Call or message me as
* needed and Ill come over.)
* 
* Later
* John
***********************************************************************
* 

      implicit none
#include "errquit.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "geom.fh"
#include "bas.fh"
#include "util.fh"
c
      logical int_normalize
      external int_normalize
      logical pderiv_compute_1e1cpe
      external pderiv_compute_1e1cpe
      logical pderiv_compute_1epe
      external pderiv_compute_1epe
      logical pderiv_compute_1eov
      external pderiv_compute_1eov
      logical pderiv_compute_1eke
      external pderiv_compute_1eke
      logical pderiv_compute_2e2c
      external pderiv_compute_2e2c
      logical pderiv_compute_2e3c
      external pderiv_compute_2e3c
      logical pderiv_compute_mpole
      external pderiv_compute_mpole
      logical pderiv_compute_3ov
      external pderiv_compute_3ov
      logical pderiv_compute_2e3ct, pderiv_compute_d2e3ct
      external pderiv_compute_2e3ct, pderiv_compute_d2e3ct
c
      integer rtdb
c
      logical status
      integer basis, geom
      integer nat, nat3, size, maxg1, maxs1, maxg2, maxs2, maxg, maxs
      integer nbf, nbfsq
      integer hbuf, hbufp, hbufm, hscr, h1ec, h1efd, hxyz
      integer kbuf, kbufp, kbufm, kscr, k1ec, k1efd, kxyz
c
      task_pderiv = .false.
c
      if (.not.geom_create(geom,'geometry')) call errquit
     &    ('geom create failed',911, GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'geometry')) call errquit
     &    ('geom_rtdb_load failed',911, RTDB_ERR)
c
      if (.not.bas_create(basis,'ao basis')) call errquit
     &    ('bas_create failed',911, BASIS_ERR)
      if (.not.bas_rtdb_load(rtdb,geom,basis,'ao basis')) call errquit
     &    ('bas_rtdb_load failed',911, RTDB_ERR)
c
      write(6,*)' geom/basis loaded'
c
      if (.not.int_normalize(rtdb,basis)) stop ' norm error 1'
c
      if (.not. bas_print(basis))
     $    call errquit(' basis print failed', 0, BASIS_ERR)
c
      if (.not.bas_numbf(basis,nbf)) call errquit
     &    ('numbf failed',911, BASIS_ERR)
c
      nbfsq = nbf*nbf
      if (.not.geom_ncent(geom,nat)) stop 'geom_ncent fe'
      write(6,*) 'number of atoms ', nat
      nat3 = 3*nat
      size = max(nbf,56)  ! slmax = 35 for mpole
      size = nat3*nbfsq*size
      size = 2*size
c
      call intd_init(rtdb,1,basis)
      call int_mem_print()
      call int_mem_1e(maxg1,maxs1)
      call int_mem_2e3c(maxg2,maxs2)
      maxg2 = maxg2*3*4
      maxg1 = maxg1*35  ! mpole
      maxg = max(maxg1,maxg2)
      maxs = max(maxs1,maxs2)
      maxg = maxg + maxg/10
      maxs = maxs + maxs/10
      maxs = 2*maxs
      maxg = 2*maxg 
      write(6,*)' normal maxg1 ',maxg1
      write(6,*)' normal maxs1 ',maxs1
      write(6,*)' normal maxg2 ',maxg2
      write(6,*)' normal maxs2 ',maxs2
      write(6,*)' normal maxg  ',maxg
      write(6,*)' normal maxs  ',maxs
      status = ma_alloc_get(mt_dbl,maxg,'int buffer' ,hbuf,kbuf)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg,'int buffer plus',hbufp,kbufp)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg,'int buffer minus',hbufm,kbufm)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxs,'int scratch',hscr,kscr)
      status = status .and.
     &    ma_alloc_get(mt_dbl,size,'block c',h1ec,k1ec)
      status = status .and.
     &    ma_alloc_get(mt_dbl,size,'block fd',h1efd,k1efd)
      status = status .and.
     &    ma_alloc_get(mt_dbl,3*nat,'my coords',hxyz,kxyz)
      if (.not.status) stop ' memory alloc failed rak20 (1)'
c
      task_pderiv =  pderiv_compute_1e1cpe(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))
c
      task_pderiv = task_pderiv .and.
     &    pderiv_compute_1eov(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))
c
      task_pderiv = task_pderiv .and.
     &    pderiv_compute_1eke(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))
c
      task_pderiv = task_pderiv .and.
     &    pderiv_compute_1epe(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))
c
      task_pderiv = task_pderiv .and.
     &    pderiv_compute_2e2c(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))
c
      task_pderiv = task_pderiv .and.
     &    pderiv_compute_2e3c(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))
      
      task_pderiv = task_pderiv .and.
     &    pderiv_compute_3ov(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))
      
      task_pderiv = task_pderiv .and.
     &    pderiv_compute_mpole(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))

      task_pderiv = task_pderiv .and.
     &    pderiv_compute_2e3ct(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))

      task_pderiv = task_pderiv .and.
     &    pderiv_compute_d2e3ct(
     &    geom,basis,nbf,nat,
     &    maxg,maxs,
     &    dbl_mb(kbuf),dbl_mb(kbufp),dbl_mb(kbufm),
     &    dbl_mb(kscr),dbl_mb(k1ec),dbl_mb(k1efd),
     &    dbl_mb(kxyz))



      call intd_terminate()
      if (.not.bas_destroy(basis)) stop ' bas destroy fail'
      if (.not.geom_destroy(geom)) stop ' geom destroy fail'
      status = .true.
      status = status.and.ma_free_heap(hbuf)
      status = status.and.ma_free_heap(hbufp)
      status = status.and.ma_free_heap(hbufm)
      status = status.and.ma_free_heap(hscr)
      status = status.and.ma_free_heap(h1ec)
      status = status.and.ma_free_heap(h1efd)
      status = status.and.ma_free_heap(hxyz)
      task_pderiv = status.and.task_pderiv
c
      end
C> @}
      logical function pderiv_compute_1e1cpe(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,p1c,p1fd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision p1c(nbf,3,nat)
      double precision p1fd(nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3
      integer atom, ixyz
      double precision delta, factor, thresh, norm
      double precision R(3)
      integer nzero1, nzero2
      integer ishell, nshell, ilo, ihi, nbfsh, cnt, i
      integer IR
c
      call dfill(3,0.0d00,R,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*3*nat),0.0d00,p1c,1)
      call dfill((nbf*3*nat),0.0d00,p1fd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,2
        if (IR.eq.1) call dfill(3,0.0d00,R,1)
        if (IR.eq.2) then
          R(1) = 1.0d00
          R(2) = 2.0d00
          R(3) = 3.0d00
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 1'
        thresh = 1.0d-10
        delta = 0.0001d00
        factor = 1.0d00/(2.0d00*delta)
        nat3 = 3*nat
* store original coordintates
        call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        do ishell = 1, nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfsh = ihi - ilo + 1
          do atom = 1,nat
            do ixyz = 1,3
              call dcopy(nat3,xyz,1,coords(1,1,geom),1)
              coords(ixyz,atom,geom) = coords(ixyz,atom,geom) + delta
              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,buf,1)
              call dfill(lbuf,0.0d00,bufp,1)
              call intp_1e1cpe(basis,ishell,R,lscr,scr,lbuf,bufp)
*
              call dcopy(nat3,xyz,1,coords(1,1,geom),1)
              coords(ixyz,atom,geom) = coords(ixyz,atom,geom) - delta
              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,bufm,1)
              call intp_1e1cpe(basis,ishell,R,lscr,scr,lbuf,bufm)
*
              call dcopy(nbfsh,bufp,1,buf,1)
              call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
              call dscal(nbfsh,factor,buf,1)
              cnt = 1
              do i = ilo,ihi
                p1fd(i,ixyz,atom) = buf(cnt)
                cnt = cnt + 1
              enddo
            enddo
          enddo
        enddo
c
        write(6,*)' fd: full list '
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              if (abs(p1fd(i,ixyz,atom)).le.thresh) nzero1 = nzero1 + 1
*              write(6,10000)i,ixyz,atom,p1fd(i,ixyz,atom)
            enddo
          enddo
        enddo
        write(6,*)' fd: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              if (abs(p1fd(i,ixyz,atom)).gt.thresh) then
*               write(6,10000)i,ixyz,atom,p1fd(i,ixyz,atom)
                continue
              else
                nzero2 = nzero2 + 1
              endif
            enddo
          enddo
        enddo
        write(6,*)' fd: num zeros :1:', nzero1 
        write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)' fd: non-zero  :1:', ((nbf*3*nat)-nzero1)
        write(6,*)' fd: non-zero  :2:', ((nbf*3*nat)-nzero2)
        write(6,*)' fd: possible  : :', (nbf*3*nat)
c
        call dcopy(nat3,xyz,1,coords(1,1,geom),1)
        do ishell = 1,nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          call dfill(lscr,0.0d00,scr,1)
          call dfill(lbuf,0.0d00,buf,1)
          call intpd_1e1cpe(basis,ishell,R,lscr,scr,lbuf,buf)
          cnt = 1
          do atom=1,nat
            do ixyz = 1,3
              do i = ilo, ihi
                p1c(i,ixyz,atom) = buf(cnt)
                cnt = cnt + 1
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: full list '
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              if (abs(p1c(i,ixyz,atom)).le.thresh) nzero1 = nzero1 + 1
*              write(6,10001)i,ixyz,atom,p1c(i,ixyz,atom)
            enddo
          enddo
        enddo
        write(6,*)'  c: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              if (abs(p1c(i,ixyz,atom)).gt.thresh) then
*                write(6,10001)i,ixyz,atom,p1c(i,ixyz,atom)
                continue
              else
                nzero2 = nzero2 + 1
              endif
            enddo
          enddo
        enddo
        write(6,*)'  c: num zeros :1:', nzero1 
        write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)'  c: non-zero  :1:', ((nbf*3*nat)-nzero1)
        write(6,*)'  c: non-zero  :2:', ((nbf*3*nat)-nzero2)
        write(6,*)'  c: possible  : :', (nbf*3*nat)
c
10000   format(1x,'p1fd(',i3,',',i2,',',i3,') = ',1pd20.10)
10001   format(1x,' p1c(',i3,',',i2,',',i3,') = ',1pd20.10)
c
        call daxpy((nbf*3*nat),-1.0d00,p1fd,1,p1c,1)
        norm = ddot((nbf*3*nat),p1c,1,p1c,1)
        write(luout,*)' 1e1cpe difference norm:',ir,' ',norm
c
        pderiv_compute_1e1cpe = norm.lt.thresh
      enddo
      end
      logical function pderiv_compute_1eov(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,ovc,ovfd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision ovc(nbf,nbf,3,nat)
      double precision ovfd(nbf,nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3
      integer atom, ixyz, IR
      double precision delta, factor, thresh, norm
      double precision R(3)
      integer nzero1, nzero2
      integer nshell, cnt, nbfsh, watom(2)
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
c
      call dfill(3,0.0d00,R,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*3*nat),0.0d00,ovc,1)
      call dfill((nbf*nbf*3*nat),0.0d00,ovfd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,2
        if (IR.eq.1) call dfill(3,0.0d00,R,1)
        if (IR.eq.2) then
          R(1) = 1.0d00
          R(2) = 2.0d00
          R(3) = 3.0d00
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 2'
        thresh = 1.0d-10
        delta = 0.0001d00
        factor = 1.0d00/(2.0d00*delta)
        nat3 = 3*nat
* store original coordintates
        call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        do ishell = 1, nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            nbfsh = nbfshi*nbfshj
            do atom = 1,nat
              do ixyz = 1,3
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) + delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,buf,1)
                call dfill(lbuf,0.0d00,bufp,1)
                call intp_1eov(basis,ishell,basis,jshell,
     &              R,lscr,scr,lbuf,bufp)
*
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) - delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,bufm,1)
                call intp_1eov(basis,ishell,basis,jshell,
     &              R,lscr,scr,lbuf,bufm)
*
                call dcopy(nbfsh,bufp,1,buf,1)
                call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
                call dscal(nbfsh,factor,buf,1)
                cnt = 1
                do i = ilo,ihi
                  do j = jlo, jhi
                    ovfd(i,j,ixyz,atom) = buf(cnt)
                    ovfd(j,i,ixyz,atom) = buf(cnt)
                    cnt = cnt + 1
                  enddo
                enddo
                if (.not.ma_verify_allocator_stuff())
     &              stop ' ma broke 3'
              enddo
            enddo
          enddo
        enddo
c
        write(6,*)' fd: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(ovfd(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10000)i,j,ixyz,atom,ovfd(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf 
                if (abs(ovfd(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10000)i,j,ixyz,atom,ovfd(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: num zeros :1:', nzero1 
        write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)' fd: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)' fd: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)' fd: possible  : :', (nbf*nbf*3*nat)
        nzero1 = 0
        nzero2 = 0
c
        call dcopy(nat3,xyz,1,coords(1,1,geom),1)
        do ishell = 1,nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          do jshell = 1,ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            call dfill(lscr,0.0d00,scr,1)
            call dfill(lbuf,0.0d00,buf,1)
            call intpd_1eov(basis,ishell,basis,jshell,R,lscr,scr,
     &          lbuf,buf,watom)
*            write(6,*)'watom 1eov',watom
            cnt = 1
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 4'
            do atom=1,2
              if (watom(atom).gt.0) then
                do ixyz = 1,3
                  do i = ilo, ihi
                    do j = jlo, jhi
*buffer is <jlo:jhi, ilo:ihi, 1:3, 2>
                      ovc(i,j,ixyz,watom(atom)) = buf(cnt)
                      ovc(j,i,ixyz,watom(atom)) = buf(cnt)
                      cnt = cnt + 1
                    enddo
                  enddo
                enddo
              endif
            enddo
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 5'
          enddo
        enddo
        write(6,*)'  c: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(ovc(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10001)i,j,ixyz,atom,ovc(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(ovc(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10001)i,j,ixyz,atom,ovc(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: num zeros :1:', nzero1 
        write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)'  c: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)'  c: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)'  c: possible  : :', (nbf*nbf*3*nat)
c
10000   format(1x,'ovfd(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
10001   format(1x,' ovc(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
c
        call daxpy((nbf*nbf*3*nat),-1.0d00,ovfd,1,ovc,1)
        norm = ddot((nbf*nbf*3*nat),ovc,1,ovc,1)
        write(luout,*)' 1eov difference norm:',ir,' ',norm
c
        pderiv_compute_1eov = norm.lt.thresh
      enddo
      end
      logical function pderiv_compute_1eke(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,kec,kefd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision kec(nbf,nbf,3,nat)
      double precision kefd(nbf,nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3
      integer atom, ixyz, IR
      double precision delta, factor, thresh, norm
      double precision R(3)
      integer nzero1, nzero2
      integer nshell, cnt, nbfsh, watom(2)
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
c
      call dfill(3,0.0d00,R,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*3*nat),0.0d00,kec,1)
      call dfill((nbf*nbf*3*nat),0.0d00,kefd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,2
        if (IR.eq.1) call dfill(3,0.0d00,R,1)
        if (IR.eq.2) then
          R(1) = 1.0d00
          R(2) = 2.0d00
          R(3) = 3.0d00
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 6'
        thresh = 1.0d-10
        delta = 0.0001d00
        factor = 1.0d00/(2.0d00*delta)
        nat3 = 3*nat
* store original coordintates
        call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        do ishell = 1, nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            nbfsh = nbfshi*nbfshj
            do atom = 1,nat
              do ixyz = 1,3
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) + delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,buf,1)
                call dfill(lbuf,0.0d00,bufp,1)
                call intp_1eke(basis,ishell,basis,jshell,
     &              R,lscr,scr,lbuf,bufp)
*
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) - delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,bufm,1)
                call intp_1eke(basis,ishell,basis,jshell,
     &              R,lscr,scr,lbuf,bufm)
*
                call dcopy(nbfsh,bufp,1,buf,1)
                call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
                call dscal(nbfsh,factor,buf,1)
                cnt = 1
                do i = ilo,ihi
                  do j = jlo, jhi
                    kefd(i,j,ixyz,atom) = buf(cnt)
                    kefd(j,i,ixyz,atom) = buf(cnt)
                    cnt = cnt + 1
                  enddo
                enddo
                if (.not.ma_verify_allocator_stuff())
     &              stop ' ma broke 7'
              enddo
            enddo
          enddo
        enddo
c
        write(6,*)' fd: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(kefd(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10000)i,j,ixyz,atom,kefd(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf 
                if (abs(kefd(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10000)i,j,ixyz,atom,kefd(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: num zeros :1:', nzero1 
        write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)' fd: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)' fd: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)' fd: possible  : :', (nbf*nbf*3*nat)
        nzero1 = 0
        nzero2 = 0
c
        call dcopy(nat3,xyz,1,coords(1,1,geom),1)
        do ishell = 1,nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          do jshell = 1,ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            call dfill(lscr,0.0d00,scr,1)
            call dfill(lbuf,0.0d00,buf,1)
            call intpd_1eke(basis,ishell,basis,jshell,R,lscr,scr,
     &          lbuf,buf,watom)
*            write(6,*)'watom 1eke',watom
            cnt = 1
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 8'
            do atom=1,2
              if (watom(atom).gt.0) then
                do ixyz = 1,3
                  do i = ilo, ihi
                    do j = jlo, jhi
                      kec(i,j,ixyz,watom(atom)) = buf(cnt)
                      kec(j,i,ixyz,watom(atom)) = buf(cnt)
                      cnt = cnt + 1
                    enddo
                  enddo
                enddo
              endif
            enddo
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 9'
          enddo
        enddo
        write(6,*)'  c: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(kec(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10001)i,j,ixyz,atom,kec(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(kec(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10001)i,j,ixyz,atom,kec(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: num zeros :1:', nzero1 
        write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)'  c: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)'  c: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)'  c: possible  : :', (nbf*nbf*3*nat)
c
10000   format(1x,'kefd(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
10001   format(1x,' kec(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
c
        call daxpy((nbf*nbf*3*nat),-1.0d00,kefd,1,kec,1)
        norm = ddot((nbf*nbf*3*nat),kec,1,kec,1)
        write(luout,*)' 1eke difference norm:',ir,' ',norm
c
        pderiv_compute_1eke = norm.lt.thresh
      enddo
      end
      logical function pderiv_compute_1epe(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,pec,pefd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision pec(nbf,nbf,3,nat)
      double precision pefd(nbf,nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3
      integer atom, ixyz, IR
      double precision delta, factor, thresh, norm
      double precision R1(3), R2(3)
      integer nzero1, nzero2
      integer nshell, cnt, nbfsh
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
c
      call dfill(3,0.0d00,R1,1)
      call dfill(3,0.0d00,R2,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*3*nat),0.0d00,pec,1)
      call dfill((nbf*nbf*3*nat),0.0d00,pefd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,3
        if (IR.eq.1) then
          call dfill(3,0.0d00,R1,1)
          call dfill(3,0.0d00,R2,1)
        elseif (IR.eq.2) then
          call dfill(3,0.0d00,R2,1)
          R1(1) = 1.0d00
          R1(2) = 2.0d00
          R1(3) = 3.0d00
        elseif (IR.eq.3) then
          R1(1) = 1.0d00
          R1(2) = 2.0d00
          R1(3) = 3.0d00
          R2(1) = 3.0d00
          R2(2) = 4.0d00
          R2(3) = 5.0d00
        else
          stop ' how did IR get here'
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 10'
        thresh = 1.0d-10
        delta = 0.0001d00
        factor = 1.0d00/(2.0d00*delta)
        nat3 = 3*nat
* store original coordintates
        call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        do ishell = 1, nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            nbfsh = nbfshi*nbfshj
            do atom = 1,nat
              do ixyz = 1,3
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) + delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,buf,1)
                call dfill(lbuf,0.0d00,bufp,1)
                call intp_1epe(basis,ishell,R1,basis,jshell,
     &              R2,lscr,scr,lbuf,bufp)
*
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) - delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,bufm,1)
                call intp_1epe(basis,ishell,R1,basis,jshell,
     &              R2,lscr,scr,lbuf,bufm)
*
                call dcopy(nbfsh,bufp,1,buf,1)
                call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
                call dscal(nbfsh,factor,buf,1)
                cnt = 1
                do i = ilo,ihi
                  do j = jlo, jhi
                    pefd(i,j,ixyz,atom) = buf(cnt)
                    pefd(j,i,ixyz,atom) = buf(cnt)
                    cnt = cnt + 1
                  enddo
                enddo
                if (.not.ma_verify_allocator_stuff())
     &              stop ' ma broke 11'
              enddo
            enddo
          enddo
        enddo
c
        write(6,*)' fd: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(pefd(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10000)i,j,ixyz,atom,pefd(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf 
                if (abs(pefd(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10000)i,j,ixyz,atom,pefd(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: num zeros :1:', nzero1 
        write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)' fd: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)' fd: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)' fd: possible  : :', (nbf*nbf*3*nat)
        nzero1 = 0
        nzero2 = 0
c
        call dcopy(nat3,xyz,1,coords(1,1,geom),1)
        do ishell = 1,nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          do jshell = 1,ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            call dfill(lscr,0.0d00,scr,1)
            call dfill(lbuf,0.0d00,buf,1)
            call intpd_1epe(basis,ishell,R1,basis,jshell,R2,
     &          lscr,scr,lbuf,buf)
            cnt = 1
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 12'
            do atom=1,nat
              do ixyz = 1,3
                do i = ilo, ihi
                  do j = jlo, jhi
                    pec(i,j,ixyz,atom) = buf(cnt)
                    pec(j,i,ixyz,atom) = buf(cnt)
                    cnt = cnt + 1
                  enddo
                enddo
              enddo
            enddo
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 13'
          enddo
        enddo
        write(6,*)'  c: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(pec(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10001)i,j,ixyz,atom,pec(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(pec(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10001)i,j,ixyz,atom,pec(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: num zeros :1:', nzero1 
        write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)'  c: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)'  c: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)'  c: possible  : :', (nbf*nbf*3*nat)
c
10000   format(1x,'pefd(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
10001   format(1x,' pec(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
c
        call daxpy((nbf*nbf*3*nat),-1.0d00,pefd,1,pec,1)
        norm = ddot((nbf*nbf*3*nat),pec,1,pec,1)
        write(luout,*)' 1epe difference norm:',IR,' ',norm
c
        pderiv_compute_1epe = norm.lt.thresh
      enddo
      end
      logical function pderiv_compute_2e2c(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,eri2c,eri2fd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision eri2c(nbf,nbf,3,nat)
      double precision eri2fd(nbf,nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3
      integer atom, ixyz, IR
      double precision delta, factor, thresh, norm
      double precision R(3)
      integer nzero1, nzero2
      integer nshell, cnt, nbfsh, watom(2)
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
c
      call dfill(3,0.0d00,R,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*3*nat),0.0d00,eri2c,1)
      call dfill((nbf*nbf*3*nat),0.0d00,eri2fd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,2
        if (IR.eq.1) call dfill(3,0.0d00,R,1)
        if (IR.eq.2) then
          R(1) = 1.0d00
          R(2) = 2.0d00
          R(3) = 3.0d00
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 14'
        thresh = 1.0d-10
        delta = 0.0001d00
        factor = 1.0d00/(2.0d00*delta)
        nat3 = 3*nat
* store original coordintates
        call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        do ishell = 1, nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            nbfsh = nbfshi*nbfshj
            do atom = 1,nat
              do ixyz = 1,3
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) + delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,buf,1)
                call dfill(lbuf,0.0d00,bufp,1)
                call intp_2e2c(basis,ishell,basis,jshell,
     &              R,lscr,scr,lbuf,bufp)
*
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) = coords(ixyz,atom,geom) - delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,bufm,1)
                call intp_2e2c(basis,ishell,basis,jshell,
     &              R,lscr,scr,lbuf,bufm)
*
                call dcopy(nbfsh,bufp,1,buf,1)
                call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
                call dscal(nbfsh,factor,buf,1)
                cnt = 1
                do i = ilo,ihi
                  do j = jlo, jhi
                    eri2fd(i,j,ixyz,atom) = buf(cnt)
                    eri2fd(j,i,ixyz,atom) = buf(cnt)
                    cnt = cnt + 1
                  enddo
                enddo
                if (.not.ma_verify_allocator_stuff())
     &              stop ' ma broke 15'
              enddo
            enddo
          enddo
        enddo
c
        write(6,*)' fd: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(eri2fd(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10000)i,j,ixyz,atom,eri2fd(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf 
                if (abs(eri2fd(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10000)i,j,ixyz,atom,eri2fd(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: num zeros :1:', nzero1 
        write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)' fd: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)' fd: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)' fd: possible  : :', (nbf*nbf*3*nat)
        nzero1 = 0
        nzero2 = 0
c
        call dcopy(nat3,xyz,1,coords(1,1,geom),1)
        do ishell = 1,nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          do jshell = 1,ishell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            call dfill(lscr,0.0d00,scr,1)
            call dfill(lbuf,0.0d00,buf,1)
*            write(6,*)'rak20: ishell, jshell ',ishell,jshell
            call intpd_2e2c(basis,ishell,basis,jshell,R,lscr,scr,
     &          lbuf,buf,watom)
*            write(6,*)'watom 2e2c',watom
            cnt = 1
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 16'
            do atom=1,2
              if (watom(atom).gt.0) then
                do ixyz = 1,3
                  do i = ilo, ihi
                    do j = jlo, jhi
                      eri2c(i,j,ixyz,watom(atom)) = buf(cnt)
                      eri2c(j,i,ixyz,watom(atom)) = buf(cnt)
                      cnt = cnt + 1
                    enddo
                  enddo
                enddo
              endif
            enddo
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 17'
          enddo
        enddo
        write(6,*)'  c: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(eri2c(i,j,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                write(6,10001)i,j,ixyz,atom,eri2c(i,j,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                if (abs(eri2c(i,j,ixyz,atom)).gt.thresh) then
*                  write(6,10001)i,j,ixyz,atom,eri2c(i,j,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: num zeros :1:', nzero1 
        write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)'  c: non-zero  :1:', ((nbf*nbf*3*nat)-nzero1)
        write(6,*)'  c: non-zero  :2:', ((nbf*nbf*3*nat)-nzero2)
        write(6,*)'  c: possible  : :', (nbf*nbf*3*nat)
c
10000   format(1x,'eri2fd(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
10001   format(1x,' eri2c(',i3,',',i3,',',i2,',',i3,') = ',1pd20.10)
c
        call daxpy((nbf*nbf*3*nat),-1.0d00,eri2fd,1,eri2c,1)
        norm = ddot((nbf*nbf*3*nat),eri2c,1,eri2c,1)
        write(luout,*)' 2e2c difference norm:',ir,' ',norm
c
        pderiv_compute_2e2c = norm.lt.thresh
      enddo
      end
      logical function pderiv_compute_2e3c(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,eri3c,eri3fd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision eri3c(nbf,nbf,nbf,3,nat)
      double precision eri3fd(nbf,nbf,nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3, nintz
      integer atom, ixyz, IR
      double precision delta, factor, thresh, norm
      double precision R1(3), R2(3)
      integer nzero1, nzero2
      integer nshell, cnt, nbfsh, watom(4)
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
      integer kshell, klo, khi, nbfshk, k
c
      call dfill(3,0.0d00,R1,1)
      call dfill(3,0.0d00,R2,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*nbf*3*nat),0.0d00,eri3c,1)
      call dfill((nbf*nbf*nbf*3*nat),0.0d00,eri3fd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,3
        if (IR.eq.1) then
          call dfill(3,0.0d00,R1,1)
          call dfill(3,0.0d00,R2,1)
        elseif (IR.eq.2) then
          call dfill(3,0.0d00,R2,1)
          R1(1) = 1.0d00
          R1(2) = 2.0d00
          R1(3) = 3.0d00
        elseif (IR.eq.3) then
          R1(1) = 1.0d00
          R1(2) = 2.0d00
          R1(3) = 3.0d00
          R2(1) = 3.0d00
          R2(2) = 4.0d00
          R2(3) = 5.0d00
        else
          stop ' how did IR get here'
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 18'
        thresh = 1.0d-10
        delta = 0.0001d00
        factor = 1.0d00/(2.0d00*delta)
        nat3 = 3*nat
* store original coordintates
        call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        do ishell = 1, nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, nshell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            do kshell = 1, jshell
              if (.not.bas_cn2bfr(basis,kshell,klo,khi))
     &            stop 'cn2bfr error k'
              nbfshk = khi - klo + 1
              nbfsh = nbfshi*nbfshj*nbfshk
              do atom = 1,nat
                do ixyz = 1,3
                  call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                  coords(ixyz,atom,geom) =
     &                coords(ixyz,atom,geom) + delta
                  call dfill(lscr,0.0d00,scr,1)
                  call dfill(lbuf,0.0d00,buf,1)
                  call dfill(lbuf,0.0d00,bufp,1)
                  call intp_2e3c(basis,ishell,basis,jshell,kshell,
     &              R1,R2,lscr,scr,lbuf,bufp)
*
                  call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                  coords(ixyz,atom,geom) =
     &                coords(ixyz,atom,geom) - delta
                  call dfill(lscr,0.0d00,scr,1)
                  call dfill(lbuf,0.0d00,bufm,1)
                  call intp_2e3c(basis,ishell,basis,jshell,kshell,
     &              R1,R2,lscr,scr,lbuf,bufm)
*
                  call dcopy(nbfsh,bufp,1,buf,1)
                  call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
                  call dscal(nbfsh,factor,buf,1)
                  cnt = 1
                  do i = ilo,ihi
                    do j = jlo, jhi
                      do k = klo, khi
                        eri3fd(i,j,k,ixyz,atom) = buf(cnt)
                        eri3fd(i,k,j,ixyz,atom) = buf(cnt)
                        cnt = cnt + 1
                      enddo
                    enddo
                  enddo
                  if (.not.ma_verify_allocator_stuff())
     &                stop ' ma broke 19'
                enddo
              enddo
            enddo
          enddo
        enddo
c
        write(6,*)' fd: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                do k = 1,nbf
                  if (abs(eri3fd(i,j,k,ixyz,atom)).le.thresh)
     &                nzero1 = nzero1 + 1
*                  write(6,10000)i,j,k,ixyz,atom,eri3fd(i,j,k,ixyz,atom)
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf 
                do k = 1,nbf
                  if (abs(eri3fd(i,j,k,ixyz,atom)).gt.thresh) then
*                    write(6,10000)i,j,k,ixyz,atom,
*     &                  eri3fd(i,j,k,ixyz,atom)
                    continue
                  else
                    nzero2 = nzero2 + 1
                  endif
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: num zeros :1:', nzero1 
        write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)' fd: non-zero  :1:', ((nbf*nbf*nbf*3*nat)-nzero1)
        write(6,*)' fd: non-zero  :2:', ((nbf*nbf*nbf*3*nat)-nzero2)
        write(6,*)' fd: possible  : :', (nbf*nbf*nbf*3*nat)
        nzero1 = 0
        nzero2 = 0
c
        call dcopy(nat3,xyz,1,coords(1,1,geom),1)
        do ishell = 1,nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          do jshell = 1,nshell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            do kshell = 1, jshell
              if (.not.bas_cn2bfr(basis,kshell,klo,khi))
     &            stop 'cn2bfr error k'
              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,buf,1)
*              write(6,*)'rak20: ishell, jshell, kshell ',
*     &            ishell,jshell,kshell
              call intpd_2e3c(basis,ishell,basis,jshell,kshell,R1,R2,
     &            lscr,scr,lbuf,buf,watom)
*              write(6,*)'watom 2e3c',watom
              if (.not.ma_verify_allocator_stuff()) stop ' ma broke 20'
              nintz = (ihi-ilo+1)*(jhi-jlo+1)*(khi-klo+1)
              do atom=1,4
                if (watom(atom).gt.0) then
                  cnt = ((atom-1)*nintz*3) + 1
                  do ixyz = 1,3
                    do i = ilo, ihi
                      do j = jlo, jhi
                        do k = klo, khi
                          eri3c(i,j,k,ixyz,watom(atom)) = buf(cnt)
                          eri3c(i,k,j,ixyz,watom(atom)) = buf(cnt)
                          cnt = cnt + 1
                        enddo
                      enddo
                    enddo
                  enddo
                endif
              enddo
              if (.not.ma_verify_allocator_stuff()) stop ' ma broke 21'
            enddo
          enddo
        enddo
        write(6,*)'  c: full list i,j'
        nzero1 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                do k = 1,nbf
                  if (abs(eri3c(i,j,k,ixyz,atom)).le.thresh)
     &                nzero1 = nzero1 + 1
*                  write(6,10001)i,j,k,ixyz,atom,eri3c(i,j,k,ixyz,atom)
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: non-zero list '
        nzero2 = 0
        do atom = 1,nat
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                do k = 1,nbf
                  if (abs(eri3c(i,j,k,ixyz,atom)).gt.thresh) then
*                    write(6,10001)i,j,k,ixyz,atom,
*     &                  eri3c(i,j,k,ixyz,atom)
                    continue
                  else
                    nzero2 = nzero2 + 1
                  endif
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: num zeros :1:', nzero1 
        write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)'  c: non-zero  :1:', ((nbf*nbf*nbf*3*nat)-nzero1)
        write(6,*)'  c: non-zero  :2:', ((nbf*nbf*nbf*3*nat)-nzero2)
        write(6,*)'  c: possible  : :', (nbf*nbf*nbf*3*nat)
c
10000   format(1x,'eri3fd(',i3,',',i3,',',i3,',',i2,',',i3,
     &      ') = ',1pd20.10)
10001   format(1x,' eri3c(',i3,',',i3,',',i3,',',i2,',',i3,
     &      ') = ',1pd20.10)
c
        call daxpy((nbf*nbf*nbf*3*nat),-1.0d00,eri3fd,1,eri3c,1)
        norm = ddot((nbf*nbf*nbf*3*nat),eri3c,1,eri3c,1)
        write(luout,*)' 2e3c difference norm:',ir,' ',norm
c
        pderiv_compute_2e3c = norm.lt.thresh
      enddo
      end
      logical function pderiv_compute_3ov(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,ov3c,ov3fd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision ov3c(nbf,nbf,nbf,3,nat)
      double precision ov3fd(nbf,nbf,nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3, nintz
      integer atom, ixyz
      double precision delta, factor, thresh, norm
*rak:      double precision zeta(50)
*rak:      integer ztype, znp, zng, zsph
      integer nzero1, nzero2
      integer nshell, cnt, nbfsh, watom(3)
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
      integer kshell, klo, khi, nbfshk, k
c
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*nbf*3*nat),0.0d00,ov3c,1)
      call dfill((nbf*nbf*nbf*3*nat),0.0d00,ov3fd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      if (.not.ma_verify_allocator_stuff()) stop ' ma broke 18'
      thresh = 1.0d-10
      delta = 0.0001d00
      factor = 1.0d00/(2.0d00*delta)
      nat3 = 3*nat
* store original coordintates
      call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*
      if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
*
*rak:      if (.not.bas_continfo(basis,1,ztype,znp,zng,zsph)) stop 'e1'
*rak:      if (znp.gt.50) stop ' zeta dimension too small '
*rak:      call dfill(znp,0.0d00,zeta,1)
*rak:      if (.not.bas_get_exponent(basis,1,zeta)) stop 'bas_get_e failed'
*rak:      zeta(1) = 1.0d-50
*rak:      if (.not.bas_set_exponent(basis,1,zeta,znp))
*rak:     &    stop 'bas_set_e failed'
*
      do ishell = 1, nshell
        if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &      stop 'cn2bfr error i'
        nbfshi = ihi - ilo + 1
        do jshell = 1, nshell
          if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &        stop 'cn2bfr error j'
          nbfshj = jhi - jlo + 1
          do kshell = 1, nshell
            if (.not.bas_cn2bfr(basis,kshell,klo,khi))
     &          stop 'cn2bfr error k'
            nbfshk = khi - klo + 1
            nbfsh = nbfshi*nbfshj*nbfshk
            do atom = 1,nat
              do ixyz = 1,3
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) =
     &              coords(ixyz,atom,geom) + delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,buf,1)
                call dfill(lbuf,0.0d00,bufp,1)

                call int_1e3ov(
     &              basis,ishell,basis,jshell,basis,kshell,
     &              lscr,scr,lbuf,bufp)
*
                call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                coords(ixyz,atom,geom) =
     &              coords(ixyz,atom,geom) - delta
                call dfill(lscr,0.0d00,scr,1)
                call dfill(lbuf,0.0d00,bufm,1)
                call int_1e3ov(
     &              basis,ishell,basis,jshell,basis,kshell,
     &              lscr,scr,lbuf,bufm)
*
                call dcopy(nbfsh,bufp,1,buf,1)
                call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
                call dscal(nbfsh,factor,buf,1)
                cnt = 1
                do i = ilo,ihi
                  do j = jlo, jhi
                    do k = klo, khi
                      ov3fd(i,j,k,ixyz,atom) = buf(cnt)
                      cnt = cnt + 1
                    enddo
                  enddo
                enddo
                if (.not.ma_verify_allocator_stuff())
     &              stop ' ma broke 19'
              enddo
            enddo
          enddo
        enddo
      enddo
c
      write(6,*)' fd: full list i,j'
      nzero1 = 0
      do atom = 1,nat
        do ixyz = 1,3
          do i = 1,nbf
            do j = 1,nbf
              do k = 1,nbf
                if (abs(ov3fd(i,j,k,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                  write(6,10000)i,j,k,ixyz,atom,ov3fd(i,j,k,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
      enddo
      write(6,*)' fd: non-zero list '
      nzero2 = 0
      do atom = 1,nat
        do ixyz = 1,3
          do i = 1,nbf
            do j = 1,nbf 
              do k = 1,nbf
                if (abs(ov3fd(i,j,k,ixyz,atom)).gt.thresh) then
*                    write(6,10000)i,j,k,ixyz,atom,
*     &                  ov3fd(i,j,k,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
      enddo
      write(6,*)' fd: num zeros :1:', nzero1 
      write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &    (nzero2-nzero1)
      write(6,*)' fd: non-zero  :1:', ((nbf*nbf*nbf*3*nat)-nzero1)
      write(6,*)' fd: non-zero  :2:', ((nbf*nbf*nbf*3*nat)-nzero2)
      write(6,*)' fd: possible  : :', (nbf*nbf*nbf*3*nat)
      nzero1 = 0
      nzero2 = 0
c
      call dcopy(nat3,xyz,1,coords(1,1,geom),1)
      do ishell = 1,nshell
        if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &      stop 'cn2bfr error i'
        do jshell = 1,nshell
          if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &        stop 'cn2bfr error j'
          do kshell = 1, jshell
            if (.not.bas_cn2bfr(basis,kshell,klo,khi))
     &          stop 'cn2bfr error k'
            call dfill(lscr,0.0d00,scr,1)
            call dfill(lbuf,0.0d00,buf,1)
*              write(6,*)'rak20: ishell, jshell, kshell ',
*     &            ishell,jshell,kshell
            call intd_1e3ov(
     &          basis,ishell,basis,jshell,basis,kshell,
     &          lscr,scr,lbuf,buf,watom)
*              write(6,*)'watom 3ov',watom
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 20'
            nintz = (ihi-ilo+1)*(jhi-jlo+1)*(khi-klo+1)
            do atom=1,3
              if (watom(atom).gt.0) then
                cnt = ((atom-1)*nintz*3) + 1
                do ixyz = 1,3
                  do i = ilo, ihi
                    do j = jlo, jhi
                      do k = klo, khi
                        ov3c(i,j,k,ixyz,watom(atom)) = buf(cnt)
                        ov3c(i,k,j,ixyz,watom(atom)) = buf(cnt)
                        cnt = cnt + 1
                      enddo
                    enddo
                  enddo
                enddo
              endif
            enddo
            if (.not.ma_verify_allocator_stuff()) stop ' ma broke 21'
          enddo
        enddo
      enddo
      write(6,*)'  c: full list i,j'
      nzero1 = 0
      do atom = 1,nat
        do ixyz = 1,3
          do i = 1,nbf
            do j = 1,nbf
              do k = 1,nbf
                if (abs(ov3c(i,j,k,ixyz,atom)).le.thresh)
     &              nzero1 = nzero1 + 1
*                  write(6,10001)i,j,k,ixyz,atom,ov3c(i,j,k,ixyz,atom)
              enddo
            enddo
          enddo
        enddo
      enddo
      write(6,*)'  c: non-zero list '
      nzero2 = 0
      do atom = 1,nat
        do ixyz = 1,3
          do i = 1,nbf
            do j = 1,nbf
              do k = 1,nbf
                if (abs(ov3c(i,j,k,ixyz,atom)).gt.thresh) then
*                    write(6,10001)i,j,k,ixyz,atom,
*     &                  ov3c(i,j,k,ixyz,atom)
                  continue
                else
                  nzero2 = nzero2 + 1
                endif
              enddo
            enddo
          enddo
        enddo
      enddo
      write(6,*)'  c: num zeros :1:', nzero1 
      write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &    (nzero2-nzero1)
      write(6,*)'  c: non-zero  :1:', ((nbf*nbf*nbf*3*nat)-nzero1)
      write(6,*)'  c: non-zero  :2:', ((nbf*nbf*nbf*3*nat)-nzero2)
      write(6,*)'  c: possible  : :', (nbf*nbf*nbf*3*nat)
c
10000 format(1x,'ov3fd(',i3,',',i3,',',i3,',',i2,',',i3,
     &    ') = ',1pd20.10)
10001 format(1x,' ov3c(',i3,',',i3,',',i3,',',i2,',',i3,
     &    ') = ',1pd20.10)
c
      call daxpy((nbf*nbf*nbf*3*nat),-1.0d00,ov3fd,1,ov3c,1)
      norm = ddot((nbf*nbf*nbf*3*nat),ov3c,1,ov3c,1)
      write(luout,*)' 3ov difference norm: ',norm
c
      pderiv_compute_3ov = norm.lt.thresh
      end
      logical function pderiv_compute_mpole(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,mp3c,mp3fd,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      integer lval_max
      parameter (lval_max = 5)
      integer slmax 
*      parameter (slmax = 1)  ! for lval_max = 0
*      parameter (slmax = 4)  ! for lval_max = 1
*      parameter (slmax = 35) ! ! for lval_max = 4
      parameter (slmax = 56) ! 1 +3+6+10+15+21 = 35+21 = 56
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision mp3c(slmax,nbf,nbf,3,(nat+1))   ! add one for the multipole center 
      double precision mp3fd(slmax,nbf,nbf,3,(nat+1))  ! ditto
      double precision xyz(3,nat)
c
      integer nat3, nintz
      integer atom, ixyz, IR, lval, nbflval
      double precision delta, factor, thresh, norm
      double precision R1(3), l_center(3), l_orgcenter(3)
      integer nzero1, nzero2
      integer nshell, cnt, nbfsh, watom(3), nshell_bas
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
      integer k, klo, khi, num_ret
      integer h_diff, k_diff
      integer imp_cent
c
      integer pole_index
      pole_index(lval) = lval*((lval+3)*(lval+3)+2)/6 + 1
c
      call dfill(3,0.0d00,R1,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((slmax*nbf*nbf*3*(nat+1)),0.0d00,mp3c,1)
      call dfill((slmax*nbf*nbf*3*(nat+1)),0.0d00,mp3fd,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do imp_cent = 1, 2
        if (imp_cent.eq.1) then
          call dfill(3,0.0d00,l_center,1) ! start with multipole center at origin
        else if (imp_cent.eq.2) then
          call dcopy(3,coords(1,1,geom),1,l_center,1)
        endif
        call dcopy(3,l_center,1,l_orgcenter,1)

      do IR = 1, 3
        if (IR.eq.1) then
          call dfill(3,0.0d00,R1,1)
        elseif (IR.eq.2) then
          R1(1) = 1.0d00
          R1(2) = 2.0d00
          R1(3) = 3.0d00
        elseif (IR.eq.3) then
          R1(1) = 1.0d00
          R1(2) = 1.0d00
          R1(3) = 1.0d00
        else
          stop ' how did IR get here'
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 18'
        thresh = 1.0d-10
        delta = 0.0001d00
        factor = 1.0d00/(2.0d00*delta)
*rak:        write(6,*)' factor = ',factor
        nat3 = 3*nat
* store original coordintates
        call dcopy(nat3,coords(1,1,geom),1,xyz,1)
*rak:        write(6,*)' original coords '
*rak:        call output(coords(1,1,geom),1,3,1,nat,3,nat,1)
*rak:        write(6,*)' l_center',l_center
*rak:        write(6,*)' l_orgcenter',l_orgcenter
*
        if (.not.bas_numcont(basis,nshell_bas)) stop 'bas_numcont'
        nshell = nshell_bas
        nshell = 1 ! tmp change
*rak:        write(6,*)' nshell = ',nshell
        
        do ishell = 1, nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, nshell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            do lval = 0,lval_max
*rak:              write(6,*)'................................1',
*rak:     &            ishell,jshell,lval
              nbflval = (lval+1)*(lval+2)/2
              nbfsh = nbfshj*nbfshi*nbflval
              klo = pole_index((lval-1)) + 1
              klo = max(klo,1)  ! minumum value of klo is 1
              khi = pole_index(lval)
*rak:              write(6,*)' klo, khi',klo,khi
              do atom = 1,nat
                do ixyz = 1,3
                  call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                  coords(ixyz,atom,geom) =
     &                coords(ixyz,atom,geom) + delta
                  call dfill(lscr,0.0d00,scr,1)
                  call dfill(lbuf,0.0d00,buf,1)
                  call dfill(lbuf,0.0d00,bufp,1)
*rak:                  write(6,*)' coords intp_mpolel(1)',atom,ixyz
*rak:                  call output(coords(1,1,geom),1,3,1,nat,3,nat,1)
*rak:                  write(6,*)' l_center',l_center
*rak:                  write(6,*)' l_orgcenter',l_orgcenter,' -*'
                  call intp_mpolel(basis,ishell,basis,jshell,
     &              R1,lval,l_orgcenter,lscr,scr,lbuf,bufp,num_ret)
*                  call intp_1eov(basis,ishell,basis,jshell,
*     &                R1,lscr,scr,lbuf,buf)
*                  cnt = 0
*                  write(6,*)
*     &                ' i   j  cnt  mpole  ovl   diff + atom ixyz'
*                  do i = ilo,ihi
*                    do j = jlo,jhi
*                      cnt = cnt + 1
*                      norm = abs(bufp(cnt)-buf(cnt))
*                      write(6,*)i,j,cnt,bufp(cnt),buf(cnt),norm,
*     &                    atom, ixyz
*                    enddo
*                  enddo
*                  norm = 0.0d00
*                  call dfill(lbuf,0.0d00,buf,1)
*
                  call dcopy(nat3,xyz,1,coords(1,1,geom),1)
                  coords(ixyz,atom,geom) =
     &                coords(ixyz,atom,geom) - delta
                  call dfill(lscr,0.0d00,scr,1)
                  call dfill(lbuf,0.0d00,bufm,1)
*rak:                  write(6,*)' coords intp_mpolel(2)',atom,ixyz
*rak:                  call output(coords(1,1,geom),1,3,1,nat,3,nat,1)
*rak:                  write(6,*)' l_center',l_center
*rak:                  write(6,*)' l_orgcenter',l_orgcenter,' -*'
                  call intp_mpolel(basis,ishell,basis,jshell,
     &              R1,lval,l_orgcenter,lscr,scr,lbuf,bufm,num_ret)
*rak:                  call intp_1eov(basis,ishell,basis,jshell,
*rak:     &                R1,lscr,scr,lbuf,buf)
*rak:                  cnt = 0
*rak:                  write(6,*)
*rak:     &                ' i   j  cnt  mpole  ovl   diff - atom ixyz'
*rak:                  do i = ilo,ihi
*rak:                    do j = jlo,jhi
*rak:                      cnt = cnt + 1
*rak:                      norm = abs(bufp(cnt)-buf(cnt))
*rak:                      write(6,*)i,j,cnt,bufp(cnt),buf(cnt),norm,
*rak:     &                    atom,ixyz
*rak:                    enddo
*rak:                  enddo
*rak:                  norm = 0.0d00
*rak:                  call dfill(lbuf,0.0d00,buf,1)
*
*rak:                  call prak3mat(bufp,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                'bufp in atom move',atom,ixyz)
*rak:                  call prak3mat(bufm,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                'bufm in atom move',atom,ixyz)
                  call dcopy(nbfsh,bufp,1,buf,1)
                  call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
*rak:                  call prak3mat(buf,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                'buf before scale in atom move',atom,ixyz)
                  call dscal(nbfsh,factor,buf,1)
*rak:                  call prak3mat(buf,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                'buf in atom move',atom,ixyz)
                  cnt = 1
                  do i = ilo,ihi
                    do j = jlo, jhi
                      do k = klo, khi
                        mp3fd(k,j,i,ixyz,atom) = buf(cnt)
*rak:                        write(70,*)
*rak:     &                      'fd<',k,j,i,ixyz,atom,'>=',buf(cnt)
                        cnt = cnt + 1
                      enddo
                    enddo
                  enddo
*rak:                  write(6,*)' nbfsh ',nbfsh,' cnt ',cnt
                  if (.not.ma_verify_allocator_stuff())
     &                stop ' ma broke 19'
                enddo
              enddo
*             now do multipole center move
              call dcopy(nat3,xyz,1,coords(1,1,geom),1)  ! restore original atom coords
              do ixyz = 1,3
                  call dcopy(3,l_orgcenter,1,l_center,1)
                  l_center(ixyz) = l_center(ixyz) + delta
                  call dfill(lscr,0.0d00,scr,1)
                  call dfill(lbuf,0.0d00,buf,1)
                  call dfill(lbuf,0.0d00,bufp,1)
*rak:                  write(6,*)' coords intp_mpolel(3)',atom,ixyz
*rak:                  call output(coords(1,1,geom),1,3,1,nat,3,nat,1)
*rak:                  write(6,*)' l_center',l_center,' -*'
*rak:                  write(6,*)' l_orgcenter',l_orgcenter
                  call intp_mpolel(basis,ishell,basis,jshell,
     &              R1,lval,l_center,lscr,scr,lbuf,bufp,num_ret)
*
                  call dcopy(3,l_orgcenter,1,l_center,1)
                  l_center(ixyz) = l_center(ixyz) - delta
                  call dfill(lscr,0.0d00,scr,1)
                  call dfill(lbuf,0.0d00,bufm,1)
*rak:                  write(6,*)' coords intp_mpolel(4)',atom,ixyz
*rak:                  call output(coords(1,1,geom),1,3,1,nat,3,nat,1)
*rak:                  write(6,*)' l_center',l_center,' -*'
*rak:                  write(6,*)' l_orgcenter',l_orgcenter
                  call intp_mpolel(basis,ishell,basis,jshell,
     &              R1,lval,l_center,lscr,scr,lbuf,bufm,num_ret)
*
*rak:                  call prak3mat(bufp,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,                  
*rak:     &                'bufp',(nat+1),ixyz)
*rak:                  call prak3mat(bufm,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,                  
*rak:     &                'bufm',(nat+1),ixyz)
                  call dcopy(nbfsh,bufp,1,buf,1)
                  call daxpy(nbfsh,-1.0d00,bufm,1,buf,1)
*rak:                  call prak3mat(buf,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                'buf b4 scale in mp center move',(nat+1),ixyz)
                  call dscal(nbfsh,factor,buf,1)
*rak:                  call prak3mat(buf,nbfsh,nbfshi,nbfshj,nbflval,
*rak:     &                ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                'buf in mp center move',(nat+1),ixyz)
                  cnt = 1
                  do i = ilo,ihi
                    do j = jlo, jhi
                      do k = klo, khi
                        mp3fd(k,j,i,ixyz,nat+1) = buf(cnt)
*rak:                        write(70,*)
*rak:     &                      'fd<',k,j,i,ixyz,(nat+1),'>=',buf(cnt)
                        cnt = cnt + 1
                      enddo
                    enddo
                  enddo
                  if (.not.ma_verify_allocator_stuff())
     &                stop ' ma broke 19'
                
              enddo
            enddo
          enddo
        enddo
c
        write(6,*)' fd: full list i,j'
        nzero1 = 0
        do atom = 1,nat+1
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                do k = 1,slmax
                  if (abs(mp3fd(k,j,i,ixyz,atom)).le.thresh)
     &                nzero1 = nzero1 + 1
*                  write(6,10000)k,j,i,ixyz,atom,mp3fd(k,j,i,ixyz,atom)
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: non-zero list '
        nzero2 = 0
        do atom = 1,nat+1
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf 
                do k = 1,slmax
                  if (abs(mp3fd(k,j,i,ixyz,atom)).gt.thresh) then
*                    write(6,10000)k,j,i,ixyz,atom,
*     &                  mp3fd(k,j,i,ixyz,atom)
                    continue
                  else
                    nzero2 = nzero2 + 1
                  endif
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)' fd: num zeros :1:', nzero1 
        write(6,*)' fd: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)' fd: non-zero  :1:',
     &      ((nbf*nbf*slmax*3*(nat+1))-nzero1)
        write(6,*)' fd: non-zero  :2:',
     &      ((nbf*nbf*slmax*3*(nat+1))-nzero2)
        write(6,*)' fd: possible  : :',
     &      (nbf*nbf*slmax*3*(nat+1))
        nzero1 = 0
        nzero2 = 0
c
        call dcopy(nat3,xyz,1,coords(1,1,geom),1)
        do ishell = 1,nshell
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          do jshell = 1,nshell
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            do lval = 0, lval_max
*rak:              write(6,*)'................................2',
*rak:     &            ishell,jshell,lval
              klo = pole_index((lval-1)) + 1
              klo = max(klo,1)  ! minumum value of klo is 1
              khi = pole_index(lval)
*rak:              write(6,*)' klo, khi',klo,khi
c
              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,buf,1)
              call dfill(lbuf,0.0d00,bufp,1)
*rak:              write(6,*)'rak20: ishell, jshell,lval ',
*rak:     &            ishell,jshell,lval
*rak:              write(6,*)' lscr ', lscr
*rak:              call intpd_1eov(basis,ishell,basis,jshell,R1,lscr,scr,
*rak:     &            lbuf,bufp,watom)
*rak:              write(6,*)' coords intpd_mpolel'
*rak:              call output(coords(1,1,geom),1,3,1,nat,3,nat,1)
*rak:              write(6,*)' l_center',l_center
*rak:              write(6,*)' l_orgcenter',l_orgcenter,' -*'
              call intpd_mpolel(basis,ishell,basis,jshell,R1,
     &            lval,l_orgcenter,
     &            lscr,scr,lbuf,buf,num_ret,watom)
*rak:              cnt = 0
*rak:              write(6,*) ' atom ixyz  i   j  cnt  mpole  ovl   diff '
*rak:              do atom = 1,nat+1
*rak:                do ixyz = 1,3
*rak:                  do i = ilo,ihi
*rak:                    do j = jlo,jhi
*rak:                      cnt = cnt + 1
*rak:                      norm = abs(bufp(cnt)-buf(cnt))
*rak:                      write(6,*)
*rak:     &                    atom,ixyz,i,j,cnt,buf(cnt),bufp(cnt),norm
*rak:                    enddo
*rak:                  enddo
*rak:                enddo
*rak:              enddo
*rak:              call dfill(lbuf,0.0d00,bufp,1)
*rak:              write(6,*)'watom mpole',watom
              if (.not.ma_verify_allocator_stuff()) stop ' ma broke 20'
              nintz = (ihi-ilo+1)*(jhi-jlo+1)*((lval+1)*(lval+2)/2)
*rak:              write(6,*)'nintz ',nintz
*rak:              write(6,*)'ilo/hi',ilo,ihi
*rak:              write(6,*)'jlo/hi',jlo,jhi
*rak:              write(6,*)'klo/hi',klo,khi
              do atom=1,3
*rak:                write(6,*)' atom,watom(atom)',atom,watom(atom)
                if (watom(atom).gt.0) then
                  cnt = ((atom-1)*nintz*3) + 1
                  do ixyz = 1,3
*rak:                    k_diff = cnt + (ixyz-1)*nintz
*rak:                    call prak3mat(buf(k_diff),nbfsh,
*rak:     &                  nbfshi,nbfshj,nbflval,
*rak:     &                  ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                  'buf in derivs call(1)',watom(atom),ixyz)
                    do i = ilo, ihi
                      do j = jlo, jhi
                        do k = klo, khi
                          mp3c(k,j,i,ixyz,watom(atom)) = buf(cnt)
*rak:                          write(71,*)
*rak:     &                        ' c<',k,j,i,ixyz,watom(atom),'>=',buf(cnt)
                          cnt = cnt + 1
                        enddo
                      enddo
                    enddo
                  enddo
                endif
                if (watom(atom).eq.-3) then
                  cnt = ((atom-1)*nintz*3) + 1
                  do ixyz = 1,3
*rak:                    k_diff = cnt + (ixyz-1)*nintz
*rak:                    call prak3mat(buf(k_diff),nbfsh,
*rak:     &                  nbfshi,nbfshj,nbflval,
*rak:     &                  ilo,ihi,jlo,jhi,klo,khi,
*rak:     &                  'buf in derivs call(2)',watom(atom),ixyz)
                    do i = ilo, ihi
                      do j = jlo, jhi
                        do k = klo, khi
                          mp3c(k,j,i,ixyz,nat+1) = buf(cnt)
*rak:                          write(71,*)
*rak:     &                        ' c<',k,j,i,ixyz,(nat+1),'>=',buf(cnt)
                          cnt = cnt + 1
                        enddo
                      enddo
                    enddo
                  enddo
                endif
              enddo
              if (.not.ma_verify_allocator_stuff()) stop ' ma broke 21'
            enddo
          enddo
        enddo
        write(6,*)'  c: full list i,j'
        nzero1 = 0
        do atom = 1,nat+1
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                do k = 1,slmax
                  if (abs(mp3c(k,j,i,ixyz,atom)).le.thresh)
     &                nzero1 = nzero1 + 1
*                  write(6,10001)k,j,i,ixyz,atom,mp3c(k,j,i,ixyz,atom)
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: non-zero list '
        nzero2 = 0
        do atom = 1,nat+1
          do ixyz = 1,3
            do i = 1,nbf
              do j = 1,nbf
                do k = 1,slmax
                  if (abs(mp3c(k,j,i,ixyz,atom)).gt.thresh) then
*                    write(6,10001)k,j,i,ixyz,atom,
*     &                  mp3c(k,j,i,ixyz,atom)
                    continue
                  else
                    nzero2 = nzero2 + 1
                  endif
                enddo
              enddo
            enddo
          enddo
        enddo
        write(6,*)'  c: num zeros :1:', nzero1 
        write(6,*)'  c: num zeros :2:', nzero2, ':delta:',
     &      (nzero2-nzero1)
        write(6,*)'  c: non-zero  :1:',
     &      ((nbf*nbf*slmax*3*(nat+1))-nzero1)
        write(6,*)'  c: non-zero  :2:',
     &      ((nbf*nbf*slmax*3*(nat+1))-nzero2)
        write(6,*)'  c: possible  : :',
     &      (nbf*nbf*slmax*3*(nat+1))
c
10000   format(1x,'mp3fd(',i3,',',i3,',',i3,',',i2,',',i3,
     &      ') = ',1pd20.10)
10001   format(1x,' mp3c(',i3,',',i3,',',i3,',',i2,',',i3,
     &      ') = ',1pd20.10)
c
        if (.not.ma_alloc_get(mt_dbl,
     &      (nbf*nbf*slmax*3*(nat+1)),
     &      'diff buffer',
     &      h_diff,
     &      k_diff)) stop 'mpole: ma alloc failed'
        call dcopy ((nbf*nbf*slmax*3*(nat+1)),mp3c,1,dbl_mb(k_diff),1)
        call  daxpy((nbf*nbf*slmax*3*(nat+1)),
     &      -1.0d00,mp3fd,1,dbl_mb(k_diff),1)
        norm = ddot((nbf*nbf*slmax*3*(nat+1)),
     &      dbl_mb(k_diff),1,dbl_mb(k_diff),1)
        write(luout,*)' mpole difference norm:ir=',ir,
     &      ':imp_cent= ',imp_cent,': ',norm
c
        pderiv_compute_mpole = norm.lt.thresh
        if (.not.pderiv_compute_mpole) then
          do atom = 1,(nat+1)
            do ixyz = 1,3
              nintz = (atom-1)*3*slmax*nbf*nbf
              nintz = nintz + (ixyz-1)*slmax*nbf*nbf
              call prak3mat(dbl_mb(k_diff + nintz),
     &            (nbf*nbf*slmax),
     &            nbf,nbf,slmax,
     &            1,nbf,1,nbf,1,slmax,
     &            'diff matrix',atom,ixyz)
            enddo
          enddo
        endif
        if (.not.ma_free_heap(h_diff)) stop 'mpole: ma free failed '
      enddo
      enddo
      end
      subroutine prak3mat(buf,nbf,nbfi,nbfj,nbfk,
     &    ilo,ihi,jlo,jhi,klo,khi,msg,atom,ixyz)
      implicit none
      integer atom
      integer ixyz
      integer nbf, nbfi, nbfj, nbfk
      integer ilo,ihi,jlo,jhi,klo,khi
      character*(*) msg
      double precision buf(nbfk,nbfj,nbfi)
c
      integer i, j, k
c
      write(6,*)' '
      write(6,*)' prak3mat<',msg,'> atom=',atom,' ixyz=',ixyz
c
      if (nbf.ne.(nbfk*nbfj*nbfi)) then
        write(6,*)' nbf error '
        write(6,*)' nbf  = ',nbf
        write(6,*)' nbfi = ',nbfi
        write(6,*)' nbfj = ',nbfj
        write(6,*)' nbfk = ',nbfk
      endif
      do i = ilo,ihi
        do j = jlo,jhi
          do k = klo,khi
            if (abs(buf(k,j,i)).gt.1.0d-07) then
              write(6,10000)k,j,i,buf(k,j,i)
            endif
          enddo
        enddo
      enddo
      write(6,*)' '
10000 format(1x,'buf(',i3,',',i3,',',i3,')=',1pd20.10)
      end
      logical function pderiv_compute_2e3ct(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,eri3,eri3t,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision eri3t(nbf,nbf,nbf)
      double precision eri3(nbf,nbf,nbf)
      double precision xyz(3,nat)
c
      integer IR
      double precision thresh, norm
      double precision RJ(3), RK(3)
      integer nshell, cnt, nbfsh
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
      integer kshell, klo, khi, nbfshk, k
      integer nzero, nzerot, npos, npost
      integer h_diff, k_diff
c
      call dfill(3,0.0d00,RJ,1)
      call dfill(3,0.0d00,RK,1)
      call dfill((3*nat),0.0d00,xyz,1)
      call dfill((nbf*nbf*nbf),0.0d00,eri3t,1)
      call dfill((nbf*nbf*nbf),0.0d00,eri3,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,3
        if (IR.eq.1) then
          call dfill(3,0.0d00,RJ,1)
          call dfill(3,0.0d00,RK,1)
        elseif (IR.eq.2) then
          call dfill(3,0.0d00,RK,1)
          RJ(1) = 1.0d00
          RJ(2) = 2.0d00
          RJ(3) = 3.0d00
        elseif (IR.eq.3) then
          RJ(1) = 1.0d00
          RJ(2) = 2.0d00
          RJ(3) = 3.0d00
          RK(1) = 3.0d00
          RK(2) = 4.0d00
          RK(3) = 5.0d00
        else
          stop ' how did IR get here'
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 18'
        thresh = 1.0d-10
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        npos   = 0
        nzero  = 0
        nzerot = 0
        npost  = 0
        do ishell = 1, nshell ! basis functon NOT translated
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, nshell ! basis functon translated
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            do kshell = 1, nshell   ! fitting function
              if (.not.bas_cn2bfr(basis,kshell,klo,khi))
     &            stop 'cn2bfr error k'
              nbfshk = khi - klo + 1
              nbfsh = nbfshi*nbfshj*nbfshk
              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,buf,1)
              call intp_2e3c(basis,kshell,basis,jshell,ishell,
     &              Rk,Rj,lscr,scr,lbuf,buf)

              cnt = 1
              do k = klo, khi
                do j = jlo, jhi
                  do i = ilo, ihi
*                    write(70,*)i,j,k,buf(cnt)
                    npos = npos + 1
                    if (abs(buf(cnt)).lt.thresh) nzero = nzero+1
                    eri3(i,j,k) = buf(cnt)
                    cnt = cnt + 1
                  enddo
                enddo
              enddo

              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,buf,1)
              call intp_2e3ct(basis,ishell,jshell,basis,kshell,
     &            RJ,RK,lscr,scr,lbuf,buf)
*
              cnt = 1
              do i = ilo, ihi
                do j = jlo, jhi
                  do k = klo, khi
*                    write(71,*)i,j,k,buf(cnt)
                    npost = npost + 1
                    if (abs(buf(cnt)).lt.thresh) nzerot=nzerot+1
                    eri3t(i,j,k) = buf(cnt)
                    cnt = cnt + 1
                  enddo
                enddo
              enddo
c
            enddo
          enddo
        enddo
c
        if (.not.ma_alloc_get(mt_dbl,
     &      (nbf*nbf*nbf),
     &      'diff buffer',
     &      h_diff,
     &      k_diff)) stop '2e3ct: ma alloc failed'
        call dcopy((nbf*nbf*nbf),eri3,1,dbl_mb(k_diff),1)
        call daxpy((nbf*nbf*nbf),-1.0d00,eri3t,1,dbl_mb(k_diff),1)
        norm = ddot((nbf*nbf*nbf),dbl_mb(k_diff),1,dbl_mb(k_diff),1)
        write(luout,*)' 2e3ct info:'
        write(luout,*)' number possible in regular:',npos
        write(luout,*)' number zero     in regular:',nzero
        write(luout,*)' number non-zero in regular:',(npos-nzero)
        write(luout,*)' number possible in transpo:',npost
        write(luout,*)' number zero     in transpo:',nzerot
        write(luout,*)' number non-zero in transpo:',(npost-nzerot)
        write(luout,*)' 2e3ct difference norm:',ir,' ',norm
c
        pderiv_compute_2e3ct = norm.lt.thresh
        if (.not.pderiv_compute_2e3ct) then
          call prak2e3c(nbf,eri3,eri3t,dbl_mb(k_diff))
        endif
        if (.not.ma_free_heap(h_diff)) stop '2e3ct: ma free failed '
      enddo
      end
      subroutine prak2e3c(nbf,eri3,eri3t,diff)
      implicit none
      integer nbf
      double precision eri3 (nbf,nbf,nbf)
      double precision eri3t(nbf,nbf,nbf)
      double precision diff (nbf,nbf,nbf)
c
      integer i,j,k
c      
      do i = 1,nbf
        do j = 1,nbf
          do k = 1,nbf
            if (abs(diff(i,j,k)).gt.1.0d-07) then
              write(6,10000)i,j,k,
     &            eri3(i,j,k),
     &            eri3t(i,j,k),
     &            diff(i,j,k)
            endif
          enddo
        enddo
      enddo
10000 format(1x,'<',i3,',',i3,',',i3,'> =',3(1pd20.10))
      end
      logical function pderiv_compute_d2e3ct(
     &    geom,basis,nbf,nat,lbuf,lscr,
     &    buf,bufp,bufm,scr,eri3,eri3t,xyz)
      implicit none
#include "mafdecls.fh"
#include "nwc_const.fh"
#include "geomP.fh"
#include "bas.fh"
#include "stdio.fh"
c
      double precision ddot
      external ddot
c
      integer geom
      integer basis
      integer nbf
      integer nat
      integer lbuf
      integer lscr
      double precision buf(lbuf), bufp(lbuf), bufm(lbuf)
      double precision scr(lscr)
      double precision eri3t(nbf,nbf,nbf,3,nat)
      double precision eri3(nbf,nbf,nbf,3,nat)
      double precision xyz(3,nat)
c
      integer nat3, nintz
      integer atom, ixyz, IR
      double precision thresh, norm
      double precision RJ(3), RK(3)
      integer nshell, cnt, nbfsh, watom(4)
      integer ishell, ilo, ihi, nbfshi, i
      integer jshell, jlo, jhi, nbfshj, j
      integer kshell, klo, khi, nbfshk, k
      integer nzero, nzerot, npos, npost
      integer h_diff, k_diff
c
      nat3 = 3*nat
      call dfill(3,0.0d00,RJ,1)
      call dfill(3,0.0d00,RK,1)
      call dfill((nat3),0.0d00,xyz,1)
      call dfill((nbf*nbf*nbf*nat3),0.0d00,eri3t,1)
      call dfill((nbf*nbf*nbf*nat3),0.0d00,eri3,1)
      call dfill(lbuf,0.0d00,buf,1)
      call dfill(lbuf,0.0d00,bufp,1)
      call dfill(lbuf,0.0d00,bufm,1)
      call dfill(lscr,0.0d00,scr,1)
      do IR = 1,3
        if (IR.eq.1) then
          call dfill(3,0.0d00,RJ,1)
          call dfill(3,0.0d00,RK,1)
        elseif (IR.eq.2) then
          call dfill(3,0.0d00,RK,1)
          RJ(1) = 1.0d00
          RJ(2) = 2.0d00
          RJ(3) = 3.0d00
        elseif (IR.eq.3) then
          RJ(1) = 1.0d00
          RJ(2) = 2.0d00
          RJ(3) = 3.0d00
          RK(1) = 3.0d00
          RK(2) = 4.0d00
          RK(3) = 5.0d00
        else
          stop ' how did IR get here'
        endif
        if (.not.ma_verify_allocator_stuff()) stop ' ma broke 18'
        thresh = 1.0d-10
*
        if (.not.bas_numcont(basis,nshell)) stop 'bas_numcont'
        
        npos   = 0
        nzero  = 0
        nzerot = 0
        npost  = 0
        do ishell = 1, nshell ! basis functon NOT translated
          if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &        stop 'cn2bfr error i'
          nbfshi = ihi - ilo + 1
          do jshell = 1, nshell ! basis functon translated
            if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &          stop 'cn2bfr error j'
            nbfshj = jhi - jlo + 1
            do kshell = 1, nshell   ! fitting function
              if (.not.bas_cn2bfr(basis,kshell,klo,khi))
     &            stop 'cn2bfr error k'
              nbfshk = khi - klo + 1
              nbfsh = nbfshi*nbfshj*nbfshk
              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,buf,1)
              call intpd_2e3c(basis,kshell,basis,jshell,ishell,
     &              Rk,Rj,lscr,scr,lbuf,buf,watom)

              nintz = nbfsh
              do atom = 1,4
                if (watom(atom).gt.0) then
                  cnt = ((atom-1)*nintz*3) + 1
                  do ixyz = 1,3
                    do k = klo, khi
                      do j = jlo, jhi
                        do i = ilo, ihi
                          npos = npos + 1
                          if (abs(buf(cnt)).lt.thresh) nzero = nzero+1
*                          write(70,*)i,j,k,ixyz,watom(atom),buf(cnt)
                          eri3(i,j,k,ixyz,watom(atom)) = buf(cnt)
                          cnt = cnt + 1
                        enddo
                      enddo
                    enddo
                  enddo
                endif
              enddo

              call dfill(lscr,0.0d00,scr,1)
              call dfill(lbuf,0.0d00,buf,1)
              call intpd_2e3ct(basis,ishell,jshell,basis,kshell,
     &            RJ,RK,lscr,scr,lbuf,buf,watom)
*
              do atom = 1,4
                if (watom(atom).gt.0) then
                  cnt = ((atom-1)*nintz*3) + 1
                  do ixyz = 1,3
                    do i = ilo, ihi
                      do j = jlo, jhi
                        do k = klo, khi
                          npost = npost + 1
                          if (abs(buf(cnt)).lt.thresh) nzerot=nzerot+1
*                          write(71,*)i,j,k,ixyz,watom(atom),buf(cnt)
                          eri3t(i,j,k,ixyz,watom(atom)) = buf(cnt)
                          cnt = cnt + 1
                        enddo
                      enddo
                    enddo
                  enddo
                endif
              enddo
c
            enddo
          enddo
        enddo
c
        if (.not.ma_alloc_get(mt_dbl,
     &      (nbf*nbf*nbf*nat3),
     &      'diff buffer',
     &      h_diff,
     &      k_diff)) stop 'd2e3ct: ma alloc failed'
        call dcopy((nbf*nbf*nbf*nat3),eri3,1,dbl_mb(k_diff),1)
        call daxpy((nbf*nbf*nbf*nat3),-1.0d00,eri3t,1,dbl_mb(k_diff),1)
        norm =
     &      ddot((nbf*nbf*nbf*nat3),dbl_mb(k_diff),1,dbl_mb(k_diff),1)
        write(luout,*)' d2e3ct info:'
        write(luout,*)' number possible in regular:',npos
        write(luout,*)' number zero     in regular:',nzero
        write(luout,*)' number non-zero in regular:',(npos-nzero)
        write(luout,*)' number possible in transpo:',npost
        write(luout,*)' number zero     in transpo:',nzerot
        write(luout,*)' number non-zero in transpo:',(npost-nzerot)
        write(luout,*)' d2e3ct difference norm:',ir,' ',norm
c
        pderiv_compute_d2e3ct = norm.lt.thresh
        if (.not.pderiv_compute_d2e3ct) then
          call prakd2e3c(nbf,nat,eri3,eri3t,dbl_mb(k_diff))
        endif
        if (.not.ma_free_heap(h_diff)) stop 'd2e3ct: ma free failed '
      enddo
      end
      subroutine prakd2e3c(nbf,nat,eri3,eri3t,diff)
      implicit none
      integer nbf
      integer nat
      double precision eri3(nbf,nbf,nbf,3,nat)
      double precision eri3t(nbf,nbf,nbf,3,nat)
      double precision diff(nbf,nbf,nbf,3,nat)
c
      integer atom,ixyz,i,j,k
c
      do atom = 1,nat
        do ixyz = 1,3
          do i = 1,nbf
            do j = 1,nbf
              do k = 1,nbf
                if (abs(diff(i,j,k,ixyz,atom)).gt.1.0d-07) then
                  write(6,10000)i,j,k,ixyz,atom,
     &            eri3(i,j,k,ixyz,atom),
     &            eri3t(i,j,k,ixyz,atom),
     &            diff(i,j,k,ixyz,atom)
                endif
              enddo
            enddo
          enddo
        enddo
      enddo
10000 format(1x,'<',i3,',',i3,',',i3,',',i3,',',i3,'> =',3(1pd20.10))
      end

      subroutine hnd_dipvel(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     & expj,coefj,j_nprim,j_ngen,Lj,nint,dipvel,scr,lscr)
c
c $Id:
c
c     ----- Wrapper routine that sets the sizes of scratch blocks -----
c
      implicit double precision (a-h,o-z)
#include "hnd_pointers.fh"
      dimension scr(lscr)
c
c Use scratch for temps in integral calculation
c Scratch needs are 9*(Li+1)*(Lj+2)
c
c The pointers are defined in hdn_pointers.fh
c
      call hnd_dipvela(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,expj,
     1 coefj,j_nprim,j_ngen,Lj,nint,dipvel,
     2 scr(dip(1)),scr(dip(2)),scr(dip(3)),scr(dip(4)),scr(dip(5)),
     3 scr(dip(6)),scr(dip(7)),scr(dip(8)),scr(dip(9)))
c
      return
      end
c
      subroutine hnd_dipvela(xyzi,expi,coefi,i_nprim,i_ngen,Li,xyzj,
     1                       expj,coefj,j_nprim,j_ngen,Lj,nint,dipvel,
     2                       xv,yv,zv,dx,dy,dz,xxv,yyv,zzv)
c
      implicit double precision (a-h,o-z)
#include "nwc_const.fh"
#include "hnd_rys.fh"
#include "hnd_tol.fh"
#include "stdio.fh"
      common/hnd_xyzdip/xint,yint,zint,xxint,yyint,zzint,t,x0,y0,z0,
     1                  xi,yi,zi,xj,yj,zj,ni,nj,cx,cy,cz
      dimension Nxyz(3),xyzi(3),xyzj(3),expi(i_nprim),expj(j_nprim)
      dimension coefi(i_nprim,i_ngen),coefj(j_nprim,j_ngen)
      dimension dipvel(nint,3)
      dimension  xv(Li+1,Lj+2),  yv(Li+1,Lj+2),  zv(Li+1,Lj+2)
      dimension  dx(Li+1,Lj+2),  dy(Li+1,Lj+2),  dz(Li+1,Lj+2)
      dimension xxv(Li+1,Lj+2), yyv(Li+1,Lj+2), zzv(Li+1,Lj+2)
c
      data rln10  /2.30258d+00/
      data pi212  /1.1283791670955d+00/
c
      tol=rln10*itol
c
c     Zero integral array
c
      call dcopy(nint*3,0.0d0,0,h01,1)
c
c     ----- ishell -----
c
      xi=xyzi(1)
      yi=xyzi(2)
      zi=xyzi(3)
      lit = Li + 1
      maxi = lit*(lit+1)/2
c
c     ----- jshell -----
c
      xj=xyzj(1)
      yj=xyzj(2)
      zj=xyzj(3)
      ljt = Lj + 1
      maxj = ljt*(ljt+1)/2
      ljtmod=ljt+1
c
      rr=(xi-xj)**2+(yi-yj)**2+(zi-zj)**2
c
c     ----- i primitive -----
c
      do ig=1, i_nprim
      ai=expi(ig)
      arri=ai*rr
      axi=ai*xi
      ayi=ai*yi
      azi=ai*zi
      csi=coefi(ig,i_ngen)
c
c     ----- j primitive -----
c
      do jg=1,j_nprim
      aj=expj(jg)
      aa=ai+aj
      aa1=1.0d0/aa
      dum=aj*arri*aa1
      if(dum.gt.tol) goto 1000  
      fac= exp(-dum)
      csj=coefj(jg,j_ngen)
      ax=(axi+aj*xj)*aa1
      ay=(ayi+aj*yj)*aa1
      az=(azi+aj*zj)*aa1
c
c     ----- density factor -----
c
      cij=csi*csj*fac*aa1*pi212
c
c     ----- 
c
      t = sqrt(aa)
      t1=1.0d0/t
      x0=ax
      y0=ay
      z0=az
      do j=1,ljtmod
         nj=j
         do i=1,lit
            ni=i
            call hnd_dipxyz
            xv(i,j)=xint*t1
            yv(i,j)=yint*t1
            zv(i,j)=zint*t1
            xxv(i,j)=xxint*t1
            yyv(i,j)=yyint*t1
            zzv(i,j)=zzint*t1
         enddo
      enddo
      do i=1,lit
         dx(i,1)=(-(aj+aj)*xv(i,2))
         dy(i,1)=(-(aj+aj)*yv(i,2))
         dz(i,1)=(-(aj+aj)*zv(i,2))
         do j=2,ljt
            dx(i,j)= (dble(j-1)*xv(i,j-1)-(aj+aj)*xv(i,j+1))
            dy(i,j)= (dble(j-1)*yv(i,j-1)-(aj+aj)*yv(i,j+1))
            dz(i,j)= (dble(j-1)*zv(i,j-1)-(aj+aj)*zv(i,j+1))
         enddo
      enddo
c
      ij=0
      do j=1,maxj
         call getNxyz(Lj,j,Nxyz)
         jx = Nxyz(1) + 1
         jy = Nxyz(2) + 1
         jz = Nxyz(3) + 1
         do i=1,maxi
            call getNxyz(Li,i,Nxyz)
            ix = Nxyz(1) + 1
            iy = Nxyz(2) + 1
            iz = Nxyz(3) + 1
            dumx= xv(ix,jx)*dy(iy,jy)*zzv(iz,jz)
     1           -xv(ix,jx)*yyv(iy,jy)*dz(iz,jz)
            dumy= xxv(ix,jx)*yv(iy,jy)*dz(iz,jz)
     1           -dx(ix,jx)*yv(iy,jy)*zzv(iz,jz)
            dumz= dx(ix,jx)*yyv(iy,jy)*zv(iz,jz)
     1           -xxv(ix,jx)*dy(iy,jy)*zv(iz,jz)
            ij=ij+1
            dipvel(ij,1)=dipvel(ij,1)+dumx*cij
            dipvel(ij,2)=dipvel(ij,2)+dumy*cij
            dipvel(ij,3)=dipvel(ij,3)+dumz*cij
         enddo     
      enddo     
c
 1000 continue
c
      enddo
      enddo
c
      return
      end

c
c     wrapper utility function to print ao integrals
      subroutine print_integrals(basis, oskel)
c     
C$Id: print_integrals.F 23464 2013-01-18 20:22:20Z niri $
c
      implicit none
c     
#include "errquit.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "tcgmsg.fh"
#include "stdio.fh"
#include "bas.fh"
#include "geom.fh"
#include "rtdb.fh"
#include "util.fh"
c
      integer basis
      logical oskel
c
      if (util_print('kinetic',print_never)) then
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "Begin kinetic 1-e integrals"
          write(luout,*) "===================================="
       end if
       call print_1eints(basis, basis, 'kinetic', oskel)
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "End kinetic 1-e integrals"
          write(luout,*) "===================================="
       end if
      endif
c
      if (util_print('potential',print_never)) then
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "Begin potential 1-e integrals"
          write(luout,*) "===================================="
       end if
       call print_1eints(basis, basis, 'potential', oskel)
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "End potential 1-e integrals"
          write(luout,*) "===================================="
       end if
      endif
c
      if (util_print('overlap',print_never)) then
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "Begin overlap 1-e integrals"
          write(luout,*) "===================================="
       end if
       call print_1eints(basis, basis, 'overlap', oskel)
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "End overlap 1-e integrals"
          write(luout,*) "===================================="
       end if
      endif
c
      if (util_print('ao2eints',print_never)) then
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "Begin all 2-e integrals"
          write(luout,*) "===================================="
       end if
       call print_aoints(basis)
       if (ga_nodeid().eq.0) then
          write(luout,*) "===================================="
          write(luout,*) "End all 2-e integrals"
          write(luout,*) "===================================="
       end if
      endif
c
      if (util_print('allaoints',print_never)) ! Debug
     $     call print_aoints(basis)
c
      return
      end

      subroutine datoms(geom, basis, hatom, g_dens, oprin,
     +     pcap, qcap, fc, fo, s, u, t, h, dc, dos, dt, dold, ss,
     +     cvec, copn, smin, qmin, transf, cc, nbb, oprint_ener,
     $     odens, eatom,spec)
C     $Id: datoms.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
#include "errquit.fh"
#include "mafdecls.fh"
#include "geom.fh"
#include "stdio.fh"
      integer geom, basis
      logical odens,spec        ! If true make the global density
      double precision eatom    ! Return sum of atomic energies
c     
*rak: wrapper routine now.  doatoms_do does the actual work
c     
      integer nbb               ! No. of primtives used to dimension arrays
      integer g_dens
      real *8 hatom(*)
      real *8 pcap(*), qcap(*), fc(*), fo(*), s(*), u(*), t(*)
      real *8 h(*), dc(*), dos(*), dt(*), dold(*), ss(*)
      real *8 cvec(*), copn(*), smin(nbb,*), qmin(nbb,*),transf(*),cc(*)
      logical oprin, oprint_ener
c
      logical status_ma
      integer nat_dim
      integer h_odone, k_odone
      integer h_tags,  k_tags
c
      if (.not. geom_ncent(geom, nat_dim)) call errquit
     $     ('guess atom dens: geom_ncent failed', geom, GEOM_ERR)
      if (.not. ma_push_get
     &    (MT_LOG,nat_dim,'atomscf:doatomd:odone',h_odone,k_odone))
     &    call errquit('ma get atomscf:doatomd:odone failed',911,
     &       MA_ERR)
      if (.not. ma_push_get
     &    (MT_BYTE,16*nat_dim,'atomscf:doatomd:tags',h_tags,k_tags))
     &    call errquit('ma get atomscf:doatomd:tags failed',911,
     &       MA_ERR)

      call datoms_do(geom, basis, hatom, g_dens, oprin,
     &     pcap, qcap, fc, fo, s, u, t, h, dc, dos, dt, dold, ss,
     &     cvec, copn, smin, qmin, transf, cc, nbb, oprint_ener,
     &     odens, eatom, byte_mb(k_tags), log_mb(k_odone), nat_dim,spec)
      status_ma = .true.
      status_ma = status_ma .and. ma_pop_stack(h_tags)
      status_ma = status_ma .and. ma_pop_stack(h_odone)
      if (.not.status_ma) call errquit
     &    ('doatoms: fatal error popping tags/odone stack',911, MEM_ERR)
      end
      subroutine datoms_do(geom, basis, hatom, g_dens, oprin,
     +     pcap, qcap, fc, fo, s, u, t, h, dc, dos, dt, dold, ss,
     +     cvec, copn, smin, qmin, transf, cc, nbb, oprint_ener,
     $     odens, eatom, tags, odone, nat_dim,spec)
      implicit none
#include "errquit.fh"
#include "global.fh"
#include "bas.fh"
#include "geom.fh"
#include "cguess.fh"
#include "msgids.fh"
#include "stdio.fh"
      integer geom, basis
      logical odens,spec        ! If true make the global density
      double precision eatom    ! Return sum of atomic energies
c     
c...  subroutine to coordinate atom-scf calls and d-matrix gathering
c...  for atomic startup
c...  h,t  : full h-matrix and t-matrix to supply to atom
c...  d    : full density matrix as return parameter
c...  
c...  **note** data is transferred to atom directly via common/cguess/
c     
      integer nbb               ! No. of primtives used to dimension arrays
      integer g_dens
      real *8 hatom(*)
      real *8 pcap(*), qcap(*), fc(*), fo(*), s(*), u(*), t(*)
      real *8 h(*), dc(*), dos(*), dt(*), dold(*), ss(*)
      real *8 cvec(*), copn(*), smin(nbb,*), qmin(nbb,*),transf(*),cc(*)
      logical oprin, oprint_ener
c     
      integer nat_dim
      logical odone(nat_dim)
      character*16 tags(nat_dim)
c     
      double precision charge, coords(3)
      character*16 tag, element
      character*2 symbol
      integer atn
      integer natoms
      integer shift
      integer icnlo, icnhi, ibflo, ibfhi, jbfhi, jbflo, jat
c     
      integer ic(4,nb),iiloc(nb,4)
c     
      logical omyjob            ! True if this process does this atom
      integer nproc, me, icount ! Parallel processing info
c     
      integer ispdf, iat, j
      integer isymax
      real *8 toteng, znps
c     
      integer maxtyp
      parameter (maxtyp = 6)
c
      logical ospherical
c     
      toteng = 0.0d0
c     
c     Determine tags and which centers are identifiable atoms
c     with both positive charge and basis funcitons.
c     Odone keeps track of which centers have been done ... mark
c     centers that do not seem to be ataoms as done already.
c     
      if (.not. geom_ncent(geom, natoms)) call errquit
     $     ('guess atom dens: geom_ncent failed', geom, GEOM_ERR)
      if (natoms .gt. nat_dim) call errquit
     $     ('guess atom dens: mxnat too small ', natoms, UNKNOWN_ERR)
c
      do iat = 1 , natoms
         if (.not. geom_cent_get(geom, iat, tag, coords, charge))
     $        call errquit('guess atom dens: geom_cent_get?', iat,
     &       GEOM_ERR)
         if (.not. bas_ce2cnr(basis, iat, icnlo, icnhi))
     $        call errquit('guess atom dens: bas_ce2cnr?', iat,
     &       BASIS_ERR)
         odone(iat) =  .not.
     $        (geom_tag_to_element(tag, symbol, element, atn)
     $        .and.  charge.ge.1.0d0 .and. icnhi.gt.0)
         tags(iat)  = tag
      enddo
c     
c     Loop thru atoms doing the calculation
c     
      me = ga_nodeid()
      nproc = ga_nnodes()
      icount = 0
c     
      do iat = 1, natoms
c     
         if (.not. odone(iat)) then
            if (.not. geom_cent_get(geom, iat, tag, coords, charge))
     $           call errquit('guess atom dens: geom_cent_get?', iat,
     &       GEOM_ERR)
c     
c     Decide if this atom is my task
c     
            omyjob = mod(icount,nproc) .eq. me
            icount = icount + 1
            if (.not. omyjob) then
               do jat = iat, natoms
                  if (tags(jat) .eq. tag) odone(jat) = .true.
               enddo
               goto 1010
            endif
c     
*       write(6,*) me,' doing ', iat, ' ', tag, element
c     
            call atscf_bas_gather(geom, basis, iat, ic, iiloc,
     $           isymax, hatom, znps, element, tag, ospherical)
c     
            call atomd(oprin,luout,znps,ic,isymax,hatom,
     +           pcap, qcap, fc, fo, s, u, t, h, dc, dos, dt, dold, ss,
     +           cvec, copn, smin, qmin, transf, cc, nbb,
     +           element, tag,spec)
c
*ZIJING      call atom_eig_vec(znps,iat,cc,nsym,ncsh,nosh,nccup,nbc)
c     
c     loop thru atoms with the same tag and add in energy and density
c     
            if (.not. bas_ce2bfr(basis, iat, ibflo, ibfhi)) 
     $           call errquit('guess atom dens: bas_ce2bfr', iat,
     &       BASIS_ERR)
            do jat = iat, natoms
               if ((.not. odone(jat)) .and. tags(iat).eq.tags(jat)) then
                  toteng = toteng + energ
                  odone(jat) = .true.
c
                  if (odens) then
                     if (.not. bas_ce2bfr(basis, jat, jbflo, jbfhi))
     $                    call errquit('guess atom dens:bas_ce2bfr',jat,
     &       BASIS_ERR)
c     
c     shift adjusts iiloc() from atom iat to atom jat
c     
                     shift = jbflo - ibflo
                     do ispdf = 1, 4
                        do j = 1, nbc(ispdf)
                           iiloc(j,ispdf) = iiloc(j,ispdf) + shift
                        enddo
                     enddo
c     
                     call creded(g_dens, dt, iiloc, nbb, ospherical)
c     
c     undo the shifting ready for next atom ... clearer than fudging shift
c     
                     do ispdf = 1, 4
                        do j = 1, nbc(ispdf)
                           iiloc(j,ispdf) = iiloc(j,ispdf) - shift
                        enddo
                     enddo
                  endif
               endif
            enddo
         endif
c     
 1010    continue               ! Jump here if not this node task
      enddo
c     
      call ga_sync()
c     
      call ga_dgop(Msg_AtSCF, toteng, 1, '+')
      if (ga_nodeid().eq.0 .and. oprint_ener) then
         write (luout,6010) toteng
         call util_flush(luout)
      endif
c
      eatom = toteng
c
      return
 6010 format(' Sum of atomic energies: ',f20.8)
      end
      subroutine atscf_bas_gather(geom, basis, iat, ic, iiloc,
     $     isymax, hatom, znps, element, tag, ospherical)
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "bas.fh"
#include "cguess.fh"
#include "geom.fh"
      integer geom              ! [input]
      integer basis             ! [input]
      integer iat               ! [input]
      integer ic(4,nb)          ! [input]
      integer iiloc(nb,4)       ! [output]
      integer isymax            ! [output]
      double precision hatom(*) ! [output]
      double precision znps     ! [output]
      character*16 tag, element ! [output]
      logical ospherical        ! [output]
c     
c     Gather all of the basis/atomic information necessary in order
c     to call atomd() to perform an atomic SCF calculation on atom
c     number iat.
c     
      integer nshell
      double precision charge, coords(3)
      character*2 symbol
      integer atn
      integer type, nprim, ngen, sphcart, ispdf
      integer nbf_per_shell, ibf, igen, i, j, k, kh, kkzc
      double precision ee, fac
      integer icnlo, icnhi, ibflo, ibfhi, icont
      integer iisch(nb,4),iicnt(nb,4)
      logical status
      double precision expnt(nw_max_prim)
      double precision coeff(nw_max_prim*nw_max_gen_con)
      double precision pi32
c*debug-s
*      integer di,dj
*      integer mycalls
*      save mycalls
*      data mycalls /0/
c*debug-e
      data pi32/5.56832799683170d0/
c*debug-s
*      mycalls = mycalls + 1
*      write(6,*)'bas_gat:i:',mycalls,'  geom  : ',geom
*      write(6,*)'bas_gat:i:',mycalls,'  basis : ',basis
*      write(6,*)'bas_gat:i:',mycalls,'  iat   : ',iat
*      write(6,*)'bas_gat:i:',mycalls,'  ic    : ',
*     &    ((ic(di,dj),di=1,4),dj=1,nb)
c*debug-s
c     
c     gather shell / symmetry info
c     
      if (.not. bas_ce2cnr(basis, iat, icnlo, icnhi))
     $     call errquit('guess atom dens: bas_ce2cnr?', iat,
     &       BASIS_ERR)
      do i = 1 , 4
         nbc(i) = 0
      enddo
c     
c     nbc  # shells / symmetry
c     iisch  contains index of shell
c     iiloc  contains position of starting ao of shell in "real" world
c     translate to 1 (s)
c     
      nshell = 0
c     
c     loop thru general contractions on atom
c     
      do icont = icnlo, icnhi
         if (.not. bas_continfo(basis, icont, type, nprim, ngen,
     $        sphcart))
     $        call errquit('guess atom dens: bas_continfo', icont,
     &       BASIS_ERR)
*debug:              write(6,*)' basis handle    =',basis
*debug:              write(6,*)' for contraction =',icont
*debug:              write(6,*)' type            =',type
*debug:              write(6,*)' nprim           =',nprim
*debug:              write(6,*)' ngen            =',ngen
*debug:              write(6,*)' sphcart         =',sphcart
         if (.not. bas_cn2bfr(basis, icont, ibflo, ibfhi))
     $        call errquit('guess atom dens: bas_cn2bfr', icont,
     &       BASIS_ERR)
         if (nprim.gt.nw_max_prim .or. ngen.gt.nw_max_gen_con) 
     $       call errquit ('guess atom dens: nprim/ngen too big', 0,
     &       UNKNOWN_ERR)
c     
         if (type .le. 3) then  ! Only s/p/d/f functions
            nbf_per_shell = (ibfhi - ibflo + 1) / ngen
            if (type .eq. -1) nbf_per_shell = 1
            ibf = ibflo
c     
c     loop thru shells inside contractions
c     
            do igen = 1, ngen
               nshell = nshell + 1
c     
               if (type .eq. -1) then
                  ispdf = igen  ! 1/2 = s/p
               else
                  ispdf = type + 1
               endif
c     
               nbc(ispdf) = nbc(ispdf) + 1
               iicnt(nbc(ispdf),ispdf) = icont
               iisch(nbc(ispdf),ispdf) = igen
               iiloc(nbc(ispdf),ispdf) = ibf
c     
               ibf = ibf + nbf_per_shell
            enddo
         endif
      enddo
      ospherical = sphcart .eq. 1
c..   
c..   we gathered symmetry/shell info ; now get the real thing
c..   
      kkzc = 0
      kh = 0
      isymax = 0
      do ispdf = 1 , 4
c..   nbas = total # primitives for this symmetry
         nbas(ispdf) = 0
         if (nbc(ispdf).gt.0) isymax = ispdf
         do j = 1 , nbc(ispdf)
c     
c     get contraction coeffs and exponents
c     
            icont = iicnt(j,ispdf)
            igen  = iisch(j,ispdf)
            if (.not. bas_get_coeff(basis, icont, coeff))
     $           call errquit('guess atom dens: get_coeff', icont,
     &       BASIS_ERR)
            if (.not. bas_get_exponent(basis, icont, expnt))
     $           call errquit('guess atom dens: get_expnt', icont,
     &       BASIS_ERR)
            if (.not. bas_continfo(basis, icont, type, nprim,
     $           ngen, sphcart))
     $           call errquit('guess atom dens: continfo', icont,
     &       BASIS_ERR)
            
c..   ic = # number of primitives /contracted /symmetry
            ic(ispdf,j) = nprim
            nbas(ispdf) = nbas(ispdf) + nprim
c..   gather the primitives
            if(kkzc+nprim.gt.nb) call errquit(
     C           ' cguess.fh: increase nb to',kkzc+nprim,0)
            do k = 1, nprim
               kkzc = kkzc + 1
               zeta(kkzc) = expnt(k)
               cont(kkzc) = coeff(k + nprim*(igen-1))
c...  get contraction coeffs as we are used to
               ee = 2*zeta(kkzc)
               fac = pi32/(ee*sqrt(ee))
               if (ispdf.eq.2) then
                  fac = 0.5d0*fac/ee
               else if (ispdf.eq.3) then
*     fac = (1.0d0/3.0d0)  *  0.75d0*fac/(ee*ee)
                  fac = 0.75d0*fac/(ee*ee)
               else if (ispdf.eq.4) then
                  fac = 1.875d0*fac/(ee**3)
               end if
               cont(kkzc) = cont(kkzc)*sqrt(fac)
               ucont(kkzc) = 1.0d0/sqrt(fac)
            enddo
c...  in the pseudopotential case, we would be involved in
c...  gathering  the h integrals for the contracted aos
c...  so that they are added in at the right time (in atomd)
c...  use proper offset to use pure d or f functions (ioffhp)
c...  only the comments remain ...
            do k = 1 , j
               kh = kh + 1
               hatom(kh) = 0.0d0
            enddo
c...  
         enddo
      enddo
c..   
c..   all prepared call  atomd
c..   zeta,cont,nbas,nbc,nbas,ic,zn are passed via cguess
c..   energ and the density matrix dt are received via cguess
c..   note zn is the real nuclear charge / znps is the effective charg
c..   
      status = geom_cent_get(geom, iat, tag, coords, charge)
      status = geom_tag_to_element(tag, symbol, element, atn)
      zn = dble(atn)
      znps = charge
c
c call ecp integrals to fill hatom properly
c
      call atscf_ecp(geom,basis,tag,hatom,nbas,
     &    zeta,cont,ucont,kkzc)
*debug-s
*      write(6,*)'bas_gat:o:',mycalls,'  ic    : ',
*     &    ((ic(di,dj),di=1,4),dj=1,nb)
*      write(6,*)'bas_gat:o:',mycalls,'  iiloc  : ',
*     &    ((iiloc(di,dj),di=1,nb),dj=1,4)
*      write(6,*)'bas_gat:o:',mycalls,'  isymax : ',isymax
*      write(6,*)'bas_gat:o:',mycalls,'  znps   : ',znps
*      write(6,*)'bas_gat:o:',mycalls,'  tag    : ',tag
*      write(6,*)'bas_gat:o:',mycalls,'  element: ',element
*      write(6,*)'bas_gat:o:',mycalls,'  ospherical: ',ospherical
*debug-e
c     
      end

      SUBROUTINE tce_x3a_offset(l_a_offset,k_a_offset,size)
C     $Id: tce_x3a_offset.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     x ( p5 p6 p7 h3 h4 h9 )_x
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p5b
      INTEGER p6b
      INTEGER p7b
      INTEGER h3b
      INTEGER h4b
      INTEGER h9b
      LOGICAL ACOLO
      length = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h9b = h4b,noab
      IF(acolo(p5b,p6b,p7b,h3b,h4b,h9b)) THEN
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+h9b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),int
     &_mb(k_sym+h9b-1)))))) .eq. irrep_x) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+i
     &nt_mb(k_spin+h9b-1).ne.12)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END IF !active
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'tce_x3_offset',l_a_offset,
     1k_a_offset)) CALL ERRQUIT('tce_x3_offset',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p5b = noab+1,noab+nvab
      DO p6b = p5b,noab+nvab
      DO p7b = p6b,noab+nvab
      DO h3b = 1,noab
      DO h4b = h3b,noab
      DO h9b = h4b,noab
      IF(acolo(p5b,p6b,p7b,h3b,h4b,h9b)) THEN 
      IF (int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1)+int_mb(k_spin+p7b-1)
     & .eq. int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+int_mb(k_spin+h9b-
     &1)) THEN
      IF (ieor(int_mb(k_sym+p5b-1),ieor(int_mb(k_sym+p6b-1),ieor(int_mb(
     &k_sym+p7b-1),ieor(int_mb(k_sym+h3b-1),ieor(int_mb(k_sym+h4b-1),int
     &_mb(k_sym+h9b-1)))))) .eq. irrep_x) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p5b-1)+int_mb(k_spin+p6b-1
     &)+int_mb(k_spin+p7b-1)+int_mb(k_spin+h3b-1)+int_mb(k_spin+h4b-1)+i
     &nt_mb(k_spin+h9b-1).ne.12)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = h9b - 1 + noab * (h4b - 1 + noab * (h3b 
     &- 1 + noab * (p7b - noab - 1 + nvab * (p6b - noab - 1 + nvab * (p5
     &b - noab - 1)))))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p5b-1) * int_mb(k_range+p6b-1) * int_
     &mb(k_range+p7b-1) * int_mb(k_range+h3b-1) * int_mb(k_range+h4b-1) 
     &* int_mb(k_range+h9b-1)
      END IF
      END IF
      END IF
      END IF !active
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      block data initial_smd_system_data
      implicit none
#include "smd_system_data.fh"
c     
      data smd_system_cname /smd_system_nc*" "/

      data smd_system_rname /"atom",
     c                       "parameters",
     c                       "lattice",
     c                       "type",
     c                       "potential",
     c                       "coordinates",
     c                       "charge",
     c                       "velocity",
     c                       "mass",
     c                       "energy",
     c                       "force",
     c                       "excl_list",
     c                       "verlet_list",
     c                       "shakelist",
     c                       "bondlist",
     c                       "bond"/


      end

      subroutine smd_system_set_component(aname,sp_name)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c     
      character*(*) aname
      character*(*) sp_name
c
      character*32 pname,tag
      integer nrec
      integer i
      logical result
      logical ocase
c
      pname = "smd_system_set_component"
c
c      write(*,*) "in "//pname
c
c     case sensitive
      ocase = .true.
c
      nrec = smd_system_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_system_rname,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      smd_system_cname(i) = sp_name
      
      return
      end

      subroutine smd_system_unset_component(aname)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c     
      character*(*) aname
c
      character*32 pname,tag
      integer nrec
      integer i
      logical result
      logical ocase
c
      pname = "smd_system_set_component"
c
c      write(*,*) "in "//pname
c
c     case sensitive
      ocase = .true.
c
      nrec = smd_system_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_system_rname,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      smd_system_cname(i) = " "
      
      return
      end

      subroutine smd_system_get_component(sp_name,aname,oexist)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c     
      character*(*) aname
      character*(*) sp_name
c
      character*32 pname,tag
      integer nrec
      integer i
      logical oexist,result
      logical ocase
c
      pname = "smd_system_get_component"
c
c      write(*,*) "in "//pname
c
c     case sensitive
      ocase = .true.
c
      nrec = smd_system_nc
c
      tag = aname
      result = inp_match(nrec,ocase,aname,smd_system_rname,i)
      if(.not. result) 
     >  call errquit(
     >       pname//'no component '//tag,0, RTDB_ERR)

      sp_name = smd_system_cname(i)
      oexist = sp_name.ne." "
      
      return
      end

      subroutine smd_system_print(un)
      implicit none
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "global.fh"
#include "smd_system_data.fh"
c     
      integer un
c
      integer i
c
      character*30 pname
      pname = "smd_system_print"
c
c      write(*,*) "in "//pname
      do i=1,smd_system_nc
        if(smd_system_cname(i).ne."") then
        write(un,'(A16,"= ",A16)') smd_system_rname(i),
     >                 smd_system_cname(i)
        end if
      end do
      
      return
      end
c $Id: smd_system_data.F 22502 2012-05-20 06:11:57Z d3y133 $

c
c $Id: md_inpt.f 19707 2010-10-29 17:59:36Z d3y133 $
c

      SUBROUTINE md_inpt(inputfile,
     $                   iseed,tstep,nstep,nequl,nprnt,ntype,ncons,
     $    consatm,nbond,bondatm,nshel,shelatm,lveloc)

      implicit none
      character*(*) inputfile

      include 'p_input.inc'
      include 'p_array.inc'
      include 'cm_atom.inc'
      include 'cm_latt.inc'
      include 'cm_temp.inc'
      include 'cm_ewld.inc'
      include 'cm_cuto.inc'
      include 'cm_pote.inc'
      include 'cm_cons.inc'
      include 'cm_bond.inc'
      include 'cm_shel.inc'

      integer i,j,k
      integer ierr,ifield,istart,inum_char,infile
      integer iseed,ntype,nequl,nstep,nprnt
      integer ncons,consatm,nbond,bondatm,nshel,shelatm
      integer npote,potindex,pkey,patm1,patm2,imin,imax,idif

      real*8 tstep,para1,para2,para3

      character word*4,irecord*1,filename*20

      logical lend,lcoord,lveloc,lvectr

      dimension consatm(mxcons,2),bondatm(mxbond,2),shelatm(mxshel,2)
      dimension istart(irec_len),inum_char(irec_len),irecord(irec_len)

      open(unit=input,file=inputfile)
      infile=input

      nstep=0
      nequl=0
      nprnt=1
      ntype=0
      npote=0
      ncons=0
      nbond=0
      nshel=0
      natms=0
      iseed=620419483
      kmaxx=0
      kmaxy=0
      kmaxz=0
      tstep=0.0
      temp=0.0
      rcut=0.0
      vcut=0.0
      alpha=0.0
      lcoord=.false.
      lveloc=.false.
      lvectr=.false.

!##########################################################################
 100  call read_lin(infile,ifield,istart,inum_char,irecord,lend)
      if(lend)goto 200
      if(ifield.gt.0)then
       call ex_4char(istart(1),irecord,word)
!##########################################################################
       if(word.eq.'INCL')then
        j=0
        do k=istart(2),istart(2)+inum_char(2)
         j=j+1
         filename(j:j)=irecord(k)
        enddo
        write(output,"(/,1x,'Openning include file :',a20)")
     $   filename(1:j)
        open(unit=iinclude,file=filename(1:j))
        infile=iinclude
        goto 100
!##########################################################################
       elseif(word.eq.'VECT')then
        lvectr=.true.
        read(infile,*)latt(1,1),latt(2,1),latt(3,1)
        read(infile,*)latt(1,2),latt(2,2),latt(3,2)
        read(infile,*)latt(1,3),latt(2,3),latt(3,3)
        write(output,"(/,1x,'Simulation cell vectors')")
        write(output,'(3g20.10)')latt(1,1),latt(2,1),latt(3,1)
        write(output,'(3g20.10)')latt(1,2),latt(2,2),latt(3,2)
        write(output,'(3g20.10)')latt(1,3),latt(2,3),latt(3,3)
!##########################################################################
       elseif(word.eq.'COOR')then
        call ex_inter(inum_char(2),istart(2),irecord,natms,ierr)
        lcoord=.true.
        if(ierr.eq.1)then
         write(output,*)'Invalid number of particles'
        endif
        if(natms.gt.mxatms)then
         write(output,*)'Increase mxatms to ',natms
         stop
        endif
        do j=1,natms
         read(infile,*,end=300)atmtype(j),ccc(j,1),ccc(j,2),ccc(j,3)
        enddo
        write(output,"(/,1x,i9,' atom coordinates found')")natms
!##########################################################################
       elseif(word.eq.'VELO')then
        call ex_inter(inum_char(2),istart(2),irecord,natms,ierr)
        lveloc=.true.
        if(ierr.eq.1)then
         write(output,*)'Invalid number of particles'
         stop
        endif
        if(natms.gt.mxatms)then
         write(output,*)'Increase mxatms to ',natms
         stop
        endif
        do j=1,natms
         read(infile,*,end=300)vvv(j,1),vvv(j,2),vvv(j,3)
        enddo
        write(output,"(/,1x,i9,' atom velocities found')")natms
!##########################################################################
       elseif(word.eq.'ATOM')then
        call ex_inter(inum_char(2),istart(2),irecord,ntype,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid number of particle types'
         stop
        endif
        if(ntype.gt.mxtype)then
         write(output,*)'Increase mxtype to ',ntype
         stop
        endif
        write(output,"(/,1x,'Atom types: ',i6)")ntype
        potindex=0
        do j=1,ntype
         read(infile,*,end=300)typname(j),typmass(j),typchge(j),
     $    typmol(j)
         write(output,'(a8,1x,2(g20.10,1x),i6)')typname(j),typmass(j),
     $      typchge(j),typmol(j)
         do k=j,ntype
          potindex=potindex+1
          potkey(potindex)=0
         enddo
        enddo
!##########################################################################
       elseif(word.eq.'POTE')then
        call ex_inter(inum_char(2),istart(2),irecord,npote,ierr)
        if(npote.gt.mxpote)then
         write(output,*)'Increase mxpote to ',npote
         stop
        endif
        if(ntype.eq.0)then
         write(output,*)'Atom type info needs to be provided first'
         stop
        endif
        write(output,"(/,1x,'Potential parameters:')")
        do j=1,npote
         read(infile,*,end=300)pkey,patm1,patm2,para1,para2,para3
         imin=min(patm1,patm2)
         imax=max(patm1,patm2)
         idif=imax-imin
         potindex=0
         do k=1,imin-1
          potindex=potindex+(ntype-k+1)
         enddo
         potindex=potindex+idif+1
         potkey(potindex)=pkey 
         potpar(potindex,1)=para1
         potpar(potindex,2)=para2
         potpar(potindex,3)=para3
        enddo
        potindex=0
        do j=1,ntype
         do k=j,ntype
         potindex=potindex+1
         if(potkey(potindex).gt.0)then
          write(output,'(3(i3,1x),3(1x,g20.10))')j,k,potkey(potindex),
     $     potpar(potindex,1),potpar(potindex,2),potpar(potindex,3)
          endif
         enddo
        enddo
!##########################################################################
       elseif(word.eq.'CONS')then
        call ex_inter(inum_char(2),istart(2),irecord,ncons,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid number of constraints'
         stop
        endif
        if(ncons.gt.mxcons)then
         write(output,*)'Increase mxcons to ',ncons
         stop
        endif
        write(output,"(/,1x,'Distance constraints: ',i6)")ncons
        do j=1,ncons
         read(infile,*,end=300)consatm(j,1),consatm(j,2),consdist(j)
         write(output,'(2(i6,1x),g20.10)')consatm(j,1),consatm(j,2),
     $      consdist(j)
        enddo
!##########################################################################
       elseif(word.eq.'BOND')then
        call ex_inter(inum_char(2),istart(2),irecord,nbond,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid number of bonds'
         stop
        endif
        if(nbond.gt.mxbond)then
         write(output,*)'Increase mxbond to ',nbond
         stop
        endif
        write(output,"(/,1x,'Bonded interactions: ',i6)")nbond
        do j=1,nbond
         read(infile,*,end=300)bondatm(j,1),bondatm(j,2),bondfrce(j),
     $      bonddist(j)
         write(output,'(2(i6,1x),2(g20.10,1x))')bondatm(j,1),
     $      bondatm(j,2),bondfrce(j),bonddist(j)
        enddo
!##########################################################################
       elseif(word.eq.'SHEL')then
        call ex_inter(inum_char(2),istart(2),irecord,nshel,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid number of shells'
         stop
        endif
        if(nshel.gt.mxshel)then
         write(output,*)'Increase mxshel to ',nshel
         stop
        endif
        write(output,"(/,1x,'Number of core-shell units: ',i6)")nshel
        do j=1,nshel
         read(infile,*,end=300)shelatm(j,1),shelatm(j,2),shelfrce(j)
         write(output,'(2(i6,1x),g20.10)')shelatm(j,1),shelatm(j,2),
     $      shelfrce(j)
        enddo
!##########################################################################
       elseif(word.eq.'SEED')then
        call ex_inter(inum_char(2),istart(2),irecord,iseed,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid seed for random number generator'
         stop
        endif
        write(output,"(/,1x,'Seed for random number generator :',i18)")
     $   iseed
!##########################################################################
       elseif(word.eq.'TEMP')then
        call ex_1real(inum_char(2),istart(2),irecord,temp,ierr)
        if(ierr.eq.2)then
         write(output,*)'Invalid temperature'
         stop
        endif
        write(output,"(/,1x,'Temperature :',3x,f12.4)")temp
!##########################################################################
       elseif(word.eq.'CUTO')then
        call ex_1real(inum_char(2),istart(2),irecord,rcut,ierr)
        if(ierr.eq.2)then
         write(output,*)'Invalid cutoff distance'
         stop
        endif
        write(output,"(/,1x,'Cutoff distance :',3x,f12.4)")rcut
        rcutsq=rcut**2
!##########################################################################
       elseif(word.eq.'VERL')then
        call ex_1real(inum_char(2),istart(2),irecord,vcut,ierr)
        if(ierr.eq.2)then
         write(output,*)'Invalid verlet shell cutoff'
         stop
        endif
        write(output,"(/,1x,'Verlet shell cutoff :',3x,f12.4)")vcut
        vcutsq=vcut**2
!##########################################################################
       elseif(word.eq.'EWAL')then
        call ex_1real(inum_char(2),istart(2),irecord,alpha,ierr)
        if(ierr.eq.2)then
         write(output,*)'Invalid ewald parameter'
         stop
        endif
        write(output,"(/,1x,'Ewald parameter :',3x,f12.4)")alpha
!##########################################################################
       elseif(word.eq.'KVEC')then
        call ex_inter(inum_char(2),istart(2),irecord,kmaxx,ierr)
        call ex_inter(inum_char(3),istart(3),irecord,kmaxy,ierr)
        call ex_inter(inum_char(4),istart(4),irecord,kmaxz,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid number of k-vectors'
         stop
        endif
        if(kmaxx.gt.mxkvect)then
         write(output,*)'Increase mxkvect to ',kmaxx
         stop
        endif
        if(kmaxy.gt.mxkvect)then
         write(output,*)'Increase mxkvect to ',kmaxy
         stop
        endif
        if(kmaxz.gt.mxkvect)then
         write(output,*)'Increase mxkvect to ',kmaxz
         stop
        endif
        write(output,"(/,1x,'k-vectors :',3i4)")kmaxx,kmaxy,kmaxz
!##########################################################################
       elseif(word.eq.'STEP')then
        call ex_inter(inum_char(2),istart(2),irecord,nstep,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid number of MD steps'
         stop
        endif
        write(output,"(/,1x,'Number of MD steps :',i12)")nstep
!##########################################################################
       elseif(word.eq.'EQUI')then
        call ex_inter(inum_char(2),istart(2),irecord,nequl,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid number of equilibration steps'
         stop
        endif
        write(output,"(/,1x,'Number of equilibration steps :',i12)")
     $ nequl
!##########################################################################
       elseif(word.eq.'PRIN')then
        call ex_inter(inum_char(2),istart(2),irecord,nprnt,ierr)
        if(ierr.eq.1)then
         write(output,*)'Invalid printing frequency'
         stop
        endif
        write(output,"(/,1x,'Print every ',i9,' steps')")nprnt
!##########################################################################
       elseif(word.eq.'TIME')then
        call ex_1real(inum_char(2),istart(2),irecord,tstep,ierr)
        if(ierr.eq.2)then
         write(output,*)'Invalid integration timestep'
         stop
        endif
        write(output,"(/,1x,'Integration timestep :',3x,f12.4)")tstep
!##########################################################################
       endif
      endif

      goto 100

 200  continue

      if(infile.eq.input)then
       if(nstep.eq.0)then
        write(output,*)'Number of MD steps has not been defined'
        stop
       elseif(ntype.eq.0)then
        write(output,*)'Atom types have not been defined'
        stop
       elseif(natms.eq.0)then
        write(output,*)'Number of atoms has not been defined'
        stop
       elseif(kmaxx.eq.0)then
        write(output,*)'Number of k-vectors in x has not been defined'
        stop
       elseif(kmaxy.eq.0)then
        write(output,*)'Number of k-vectors in y has not been defined'
        stop
       elseif(kmaxz.eq.0)then
        write(output,*)'Number of k-vectors in z has not been defined'
        stop
       elseif(tstep.eq.0.0)then
        write(output,*)'Integration timestep has not been defined'
        stop
       elseif(temp.eq.0.0)then
        write(output,*)'Temperature has not been defined'
        stop
       elseif(rcut.eq.0.0)then
        write(output,*)'Short-range cutoff has not been defined'
        stop
       elseif(vcut.eq.0.0)then
        write(output,*)'Verlet list cutoff has not been defined'
        stop
       elseif(alpha.eq.0.0)then
        write(output,*)'Ewald parameter has not been defined'
        stop
       elseif(.not.lcoord)then
        write(output,*)'Could not find atomic coordinates'
        stop
       elseif(.not.lvectr)then
        write(output,*)'Could not find simulation cell vectors'
        stop
       endif
       write(output,*)
       return
      elseif(infile.eq.iinclude)then
       infile=input
       goto 100
      endif

 300  continue
      write(output,"(/,1x,'EOF reached in keyword ',a4)")word

      END

      logical function argos_prep_protein(sgmnam)
c
c $Id: argos_prep_protein.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
#include "argos_prep_common.fh"
c
      character*5 sgmnam
c
      argos_prep_protein=.true.
c
      if(sgmnam(1:3).eq.'ALA'.or.sgmnam(1:3).eq.'ARG'.or.
     + sgmnam(1:3).eq.'ASN'.or.sgmnam(1:3).eq.'ASP'.or.
     + sgmnam(1:3).eq.'CYS'.or.sgmnam(1:3).eq.'GLN'.or.
     + sgmnam(1:3).eq.'GLU'.or.sgmnam(1:3).eq.'GLY'.or.
     + sgmnam(1:3).eq.'HIS'.or.sgmnam(1:3).eq.'ILE'.or.
     + sgmnam(1:3).eq.'LEU'.or.sgmnam(1:3).eq.'LYS'.or.
     + sgmnam(1:3).eq.'MET'.or.sgmnam(1:3).eq.'PHE'.or.
     + sgmnam(1:3).eq.'PRO'.or.sgmnam(1:3).eq.'SER'.or.
     + sgmnam(1:3).eq.'THR'.or.sgmnam(1:3).eq.'TRP'.or.
     + sgmnam(1:3).eq.'TYR'.or.sgmnam(1:3).eq.'VAL') return
      if(ffield(1:5).eq.'amber') then
      if(sgmnam(1:3).eq.'ASH'.or.sgmnam(1:3).eq.'CYX'.or.
     + sgmnam(1:3).eq.'GLH'.or.sgmnam(1:3).eq.'HID'.or.
     + sgmnam(1:3).eq.'HIE'.or.sgmnam(1:3).eq.'HIP') return
      endif
      if(ffield(1:6).eq.'charmm') then
      if(sgmnam(1:3).eq.'CYX'.or.sgmnam(1:3).eq.'HSD'.or.
     + sgmnam(1:3).eq.'HSE'.or.sgmnam(1:3).eq.'HSP') return
      endif
c
      argos_prep_protein=.false.
      return
      end

      subroutine outpud(copn,cc,ntest,iwr)
C$Id: outpud.F 19708 2010-10-29 18:04:21Z d3y133 $
      implicit none
c
      real *8 copn(*), cc(*)
      integer ntest, iwr
c
#include "cguess.fh"
c
      integer i, j, k
      integer nbc1, naddr, noddr, jfirst, jlast
c
      if (ntest.gt.0) write (iwr,6010) nitscf , energ , cin , vir
      if (ntest.gt.0) write (iwr,6030)
      nbc1 = nbc(1)
      do i = 2 , nsym
         nbc1 = max(nbc1,nbc(i))
      enddo
      naddr = 0
      noddr = 0
      do i = 1 , nsym
         do j = 1 , ncsh(i) + nosh(i)
            do k = 1 , nbc(i)
               naddr = naddr + 1
               noddr = noddr + 1
               copn(noddr) = cc(naddr)
            enddo
            if (nbc(i).lt.nbc1) then
               do k = nbc(i) + 1 , nbc1
                  noddr = noddr + 1
                  copn(noddr) = 0.0d0
               enddo
            end if
         enddo
         naddr = naddr + nbc(i)*(nbc(i)-ncsh(i)-nosh(i))
      enddo
      jfirst = 1
 70   jlast = min(jfirst+7,nsht)
      if (ntest.gt.0) then
         write (iwr,6020) (eps(j),j=jfirst,jlast)
         write (iwr,6030)
         do i = 1 , nbc1
            write (iwr,6040) (copn(i+(j-1)*nbc1),j=jfirst,jlast)
         enddo
      end if
      if (jlast.eq.nsht) return
      jfirst = jfirst + 8
      if (ntest.gt.0) write (iwr,6030)
      go to 70
 6010 format (/,8x,'final scf results at iteration',i4,/,8x,
     +        'total hf energy',4x,'kinetic energy',4x,'virial theorem',
     +        /4x,3(e19.10),//,8x,'orbital energies and eigenvectors')
 6020 format (/,2x,8(2x,f12.5),1x)
 6030 format (' ')
 6040 format (2x,8f14.6)
      end

      SUBROUTINE TCE_DGEEV
     $    ( JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR,
     $                  LDVR, WORK, LWORK, INFO )
c $Id: tce_dgeev.F 19706 2010-10-29 17:52:31Z d3y133 $
c The subdoutine is identical to the original dgeev but had to be renamed,
c since otherwise, for IBM SP2, dynamically linked dgeev having different
c interface syntax is going to be used rather than this.
*
*  -- LAPACK driver routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOBVL, JOBVR
      INTEGER            INFO, LDA, LDVL, LDVR, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WI( * ), WORK( * ), WR( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEEV computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
*
*  Arguments
*  =========
*
*  JOBVL   (input) CHARACTER*1
*          = 'N': left eigenvectors of A are not computed;
*          = 'V': left eigenvectors of A are computed.
*
*  JOBVR   (input) CHARACTER*1
*          = 'N': right eigenvectors of A are not computed;
*          = 'V': right eigenvectors of A are computed.
*
*  N       (input) INTEGER
*          The order of the matrix A. N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the N-by-N matrix A.
*          On exit, A has been overwritten.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  WR      (output) DOUBLE PRECISION array, dimension (N)
*  WI      (output) DOUBLE PRECISION array, dimension (N)
*          WR and WI contain the real and imaginary parts,
*          respectively, of the computed eigenvalues.  Complex
*          conjugate pairs of eigenvalues appear consecutively
*          with the eigenvalue having the positive imaginary part
*          first.
*
*  VL      (output) DOUBLE PRECISION array, dimension (LDVL,N)
*          If JOBVL = 'V', the left eigenvectors u(j) are stored one
*          after another in the columns of VL, in the same order
*          as their eigenvalues.
*          If JOBVL = 'N', VL is not referenced.
*          If the j-th eigenvalue is real, then u(j) = VL(:,j),
*          the j-th column of VL.
*          If the j-th and (j+1)-st eigenvalues form a complex
*          conjugate pair, then u(j) = VL(:,j) + i*VL(:,j+1) and
*          u(j+1) = VL(:,j) - i*VL(:,j+1).
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.  LDVL >= 1; if
*          JOBVL = 'V', LDVL >= N.
*
*  VR      (output) DOUBLE PRECISION array, dimension (LDVR,N)
*          If JOBVR = 'V', the right eigenvectors v(j) are stored one
*          after another in the columns of VR, in the same order
*          as their eigenvalues.
*          If JOBVR = 'N', VR is not referenced.
*          If the j-th eigenvalue is real, then v(j) = VR(:,j),
*          the j-th column of VR.
*          If the j-th and (j+1)-st eigenvalues form a complex
*          conjugate pair, then v(j) = VR(:,j) + i*VR(:,j+1) and
*          v(j+1) = VR(:,j) - i*VR(:,j+1).
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.  LDVR >= 1; if
*          JOBVR = 'V', LDVR >= N.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,3*N), and
*          if JOBVL = 'V' or JOBVR = 'V', LWORK >= 4*N.  For good
*          performance, LWORK must generally be larger.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          > 0:  if INFO = i, the QR algorithm failed to compute all the
*                eigenvalues, and no eigenvectors have been computed;
*                elements i+1:N of WR and WI contain eigenvalues which
*                have converged.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D0, ONE = 1.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            SCALEA, WANTVL, WANTVR
      CHARACTER          SIDE
      INTEGER            HSWORK, I, IBAL, IERR, IHI, ILO, ITAU, IWRK, K,
     $                   MAXB, MAXWRK, MINWRK, NOUT
      DOUBLE PRECISION   ANRM, BIGNUM, CS, CSCALE, EPS, R, SCL, SMLNUM,
     $                   SN
*     ..
*     .. Local Arrays ..
      LOGICAL            SELECT( 1 )
      DOUBLE PRECISION   DUM( 1 )
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEBAK, DGEBAL, DGEHRD, DHSEQR, DLABAD, DLACPY,
     $                   DLARTG, DLASCL, DORGHR, DROT, DSCAL, DTREVC,
     $                   XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX, ILAENV
      DOUBLE PRECISION   DLAMCH, DLANGE, DLAPY2, DNRM2
      EXTERNAL           LSAME, IDAMAX, ILAENV, DLAMCH, DLANGE, DLAPY2,
     $                   DNRM2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      WANTVL = LSAME( JOBVL, 'V' )
      WANTVR = LSAME( JOBVR, 'V' )
      IF( ( .NOT.WANTVL ) .AND. ( .NOT.LSAME( JOBVL, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( ( .NOT.WANTVR ) .AND. ( .NOT.LSAME( JOBVR, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDVL.LT.1 .OR. ( WANTVL .AND. LDVL.LT.N ) ) THEN
         INFO = -9
      ELSE IF( LDVR.LT.1 .OR. ( WANTVR .AND. LDVR.LT.N ) ) THEN
         INFO = -11
      END IF
*
*     Compute workspace
*      (Note: Comments in the code beginning "Workspace:" describe the
*       minimal amount of workspace needed at that point in the code,
*       as well as the preferred amount for good performance.
*       NB refers to the optimal block size for the immediately
*       following subroutine, as returned by ILAENV.
*       HSWORK refers to the workspace preferred by DHSEQR, as
*       calculated below. HSWORK is computed assuming ILO=1 and IHI=N,
*       the worst case.)
*
      MINWRK = 1
      IF( INFO.EQ.0 .AND. LWORK.GE.1 ) THEN
         MAXWRK = 2*N + N*ILAENV( 1, 'DGEHRD', ' ', N, 1, N, 0 )
         IF( ( .NOT.WANTVL ) .AND. ( .NOT.WANTVR ) ) THEN
            MINWRK = MAX( 1, 3*N )
            MAXB = MAX( ILAENV( 8, 'DHSEQR', 'EN', N, 1, N, -1 ), 2 )
            K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'DHSEQR', 'EN', N, 1,
     $          N, -1 ) ) )
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, N+1, N+HSWORK )
         ELSE
            MINWRK = MAX( 1, 4*N )
            MAXWRK = MAX( MAXWRK, 2*N+( N-1 )*
     $               ILAENV( 1, 'DORGHR', ' ', N, 1, N, -1 ) )
            MAXB = MAX( ILAENV( 8, 'DHSEQR', 'SV', N, 1, N, -1 ), 2 )
            K = MIN( MAXB, N, MAX( 2, ILAENV( 4, 'DHSEQR', 'SV', N, 1,
     $          N, -1 ) ) )
            HSWORK = MAX( K*( K+2 ), 2*N )
            MAXWRK = MAX( MAXWRK, N+1, N+HSWORK )
            MAXWRK = MAX( MAXWRK, 4*N )
         END IF
         WORK( 1 ) = MAXWRK
      END IF
      IF( LWORK.LT.MINWRK ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGEEV ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
      SMLNUM = SQRT( SMLNUM ) / EPS
      BIGNUM = ONE / SMLNUM
*
*     Scale A if max element outside range [SMLNUM,BIGNUM]
*
      ANRM = DLANGE( 'M', N, N, A, LDA, DUM )
      SCALEA = .FALSE.
      IF( ANRM.GT.ZERO .AND. ANRM.LT.SMLNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = SMLNUM
      ELSE IF( ANRM.GT.BIGNUM ) THEN
         SCALEA = .TRUE.
         CSCALE = BIGNUM
      END IF
      IF( SCALEA )
     $   CALL DLASCL( 'G', 0, 0, ANRM, CSCALE, N, N, A, LDA, IERR )
*
*     Balance the matrix
*     (Workspace: need N)
*
      IBAL = 1
      CALL DGEBAL( 'B', N, A, LDA, ILO, IHI, WORK( IBAL ), IERR )
*
*     Reduce to upper Hessenberg form
*     (Workspace: need 3*N, prefer 2*N+N*NB)
*
      ITAU = IBAL + N
      IWRK = ITAU + N
      CALL DGEHRD( N, ILO, IHI, A, LDA, WORK( ITAU ), WORK( IWRK ),
     $             LWORK-IWRK+1, IERR )
*
      IF( WANTVL ) THEN
*
*        Want left eigenvectors
*        Copy Householder vectors to VL
*
         SIDE = 'L'
         CALL DLACPY( 'L', N, N, A, LDA, VL, LDVL )
*
*        Generate orthogonal matrix in VL
*        (Workspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*
         CALL DORGHR( N, ILO, IHI, VL, LDVL, WORK( ITAU ), WORK( IWRK ),
     $                LWORK-IWRK+1, IERR )
*
*        Perform QR iteration, accumulating Schur vectors in VL
*        (Workspace: need N+1, prefer N+HSWORK (see comments) )
*
         IWRK = ITAU
         CALL DHSEQR( 'S', 'V', N, ILO, IHI, A, LDA, WR, WI, VL, LDVL,
     $                WORK( IWRK ), LWORK-IWRK+1, INFO )
*
         IF( WANTVR ) THEN
*
*           Want left and right eigenvectors
*           Copy Schur vectors to VR
*
            SIDE = 'B'
            CALL DLACPY( 'F', N, N, VL, LDVL, VR, LDVR )
         END IF
*
      ELSE IF( WANTVR ) THEN
*
*        Want right eigenvectors
*        Copy Householder vectors to VR
*
         SIDE = 'R'
         CALL DLACPY( 'L', N, N, A, LDA, VR, LDVR )
*
*        Generate orthogonal matrix in VR
*        (Workspace: need 3*N-1, prefer 2*N+(N-1)*NB)
*
         CALL DORGHR( N, ILO, IHI, VR, LDVR, WORK( ITAU ), WORK( IWRK ),
     $                LWORK-IWRK+1, IERR )
*
*        Perform QR iteration, accumulating Schur vectors in VR
*        (Workspace: need N+1, prefer N+HSWORK (see comments) )
*
         IWRK = ITAU
         CALL DHSEQR( 'S', 'V', N, ILO, IHI, A, LDA, WR, WI, VR, LDVR,
     $                WORK( IWRK ), LWORK-IWRK+1, INFO )
*
      ELSE
*
*        Compute eigenvalues only
*        (Workspace: need N+1, prefer N+HSWORK (see comments) )
*
         IWRK = ITAU
         CALL DHSEQR( 'E', 'N', N, ILO, IHI, A, LDA, WR, WI, VR, LDVR,
     $                WORK( IWRK ), LWORK-IWRK+1, INFO )
      END IF
*
*     If INFO > 0 from DHSEQR, then quit
*
      IF( INFO.GT.0 )
     $   GO TO 50
*
      IF( WANTVL .OR. WANTVR ) THEN
*
*        Compute left and/or right eigenvectors
*        (Workspace: need 4*N)
*
         CALL DTREVC( SIDE, 'B', SELECT, N, A, LDA, VL, LDVL, VR, LDVR,
     $                N, NOUT, WORK( IWRK ), IERR )
      END IF
*
      IF( WANTVL ) THEN
*
*        Undo balancing of left eigenvectors
*        (Workspace: need N)
*
         CALL DGEBAK( 'B', 'L', N, ILO, IHI, WORK( IBAL ), N, VL, LDVL,
     $                IERR )
*
*        Normalize left eigenvectors and make largest component real
*
         DO 20 I = 1, N
            IF( WI( I ).EQ.ZERO ) THEN
               SCL = ONE / DNRM2( N, VL( 1, I ), 1 )
               CALL DSCAL( N, SCL, VL( 1, I ), 1 )
            ELSE IF( WI( I ).GT.ZERO ) THEN
               SCL = ONE / DLAPY2( DNRM2( N, VL( 1, I ), 1 ),
     $               DNRM2( N, VL( 1, I+1 ), 1 ) )
               CALL DSCAL( N, SCL, VL( 1, I ), 1 )
               CALL DSCAL( N, SCL, VL( 1, I+1 ), 1 )
               DO 10 K = 1, N
                  WORK( IWRK+K-1 ) = VL( K, I )**2 + VL( K, I+1 )**2
   10          CONTINUE
               K = IDAMAX( N, WORK( IWRK ), 1 )
               CALL DLARTG( VL( K, I ), VL( K, I+1 ), CS, SN, R )
               CALL DROT( N, VL( 1, I ), 1, VL( 1, I+1 ), 1, CS, SN )
               VL( K, I+1 ) = ZERO
            END IF
   20    CONTINUE
      END IF
*
      IF( WANTVR ) THEN
*
*        Undo balancing of right eigenvectors
*        (Workspace: need N)
*
         CALL DGEBAK( 'B', 'R', N, ILO, IHI, WORK( IBAL ), N, VR, LDVR,
     $                IERR )
*
*        Normalize right eigenvectors and make largest component real
*
         DO 40 I = 1, N
            IF( WI( I ).EQ.ZERO ) THEN
               SCL = ONE / DNRM2( N, VR( 1, I ), 1 )
               CALL DSCAL( N, SCL, VR( 1, I ), 1 )
            ELSE IF( WI( I ).GT.ZERO ) THEN
               SCL = ONE / DLAPY2( DNRM2( N, VR( 1, I ), 1 ),
     $               DNRM2( N, VR( 1, I+1 ), 1 ) )
               CALL DSCAL( N, SCL, VR( 1, I ), 1 )
               CALL DSCAL( N, SCL, VR( 1, I+1 ), 1 )
               DO 30 K = 1, N
                  WORK( IWRK+K-1 ) = VR( K, I )**2 + VR( K, I+1 )**2
   30          CONTINUE
               K = IDAMAX( N, WORK( IWRK ), 1 )
               CALL DLARTG( VR( K, I ), VR( K, I+1 ), CS, SN, R )
               CALL DROT( N, VR( 1, I ), 1, VR( 1, I+1 ), 1, CS, SN )
               VR( K, I+1 ) = ZERO
            END IF
   40    CONTINUE
      END IF
*
*     Undo scaling if necessary
*
   50 CONTINUE
      IF( SCALEA ) THEN
         CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N-INFO, 1, WR( INFO+1 ),
     $                MAX( N-INFO, 1 ), IERR )
         CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, N-INFO, 1, WI( INFO+1 ),
     $                MAX( N-INFO, 1 ), IERR )
         IF( INFO.GT.0 ) THEN
            CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, ILO-1, 1, WR, N,
     $                   IERR )
            CALL DLASCL( 'G', 0, 0, CSCALE, ANRM, ILO-1, 1, WI, N,
     $                   IERR )
         END IF
      END IF
*
      WORK( 1 ) = MAXWRK
      RETURN
*
*     End of DGEEV
*
      END

      SUBROUTINE ccsdt_y_tr1_14_3(d_a,k_a_offset,d_b,k_b_offset,d_c,k_c_
     &offset)
C     $Id: ccsdt_y_tr1_14_3.F 19701 2010-10-29 17:16:57Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h2 p12 p15 h11 h13 h14 )_vtr + = -1/2 * Sum ( h8 p5 ) * tr ( p5 p12 p15 h8 h13 h14 )_tr * i2 ( h2 h8 h11 p5 )_v
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h2b
      INTEGER p12b
      INTEGER p15b
      INTEGER h13b
      INTEGER h14b
      INTEGER h11b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER p5b
      INTEGER h8b
      INTEGER p12b_1
      INTEGER p15b_1
      INTEGER p5b_1
      INTEGER h13b_1
      INTEGER h14b_1
      INTEGER h8b_1
      INTEGER h2b_2
      INTEGER h8b_2
      INTEGER h11b_2
      INTEGER p5b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h2b = 1,noab
      DO p12b = noab+1,noab+nvab
      DO p15b = p12b,noab+nvab
      DO h13b = 1,noab
      DO h14b = h13b,noab
      DO h11b = 1,noab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h2b-1)+int_mb(k_spin+p12b-
     &1)+int_mb(k_spin+p15b-1)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h13b-
     &1)+int_mb(k_spin+h14b-1).ne.12)) THEN
      IF (int_mb(k_spin+h2b-1)+int_mb(k_spin+p12b-1)+int_mb(k_spin+p15b-
     &1) .eq. int_mb(k_spin+h11b-1)+int_mb(k_spin+h13b-1)+int_mb(k_spin+
     &h14b-1)) THEN
      IF (ieor(int_mb(k_sym+h2b-1),ieor(int_mb(k_sym+p12b-1),ieor(int_mb
     &(k_sym+p15b-1),ieor(int_mb(k_sym+h11b-1),ieor(int_mb(k_sym+h13b-1)
     &,int_mb(k_sym+h14b-1)))))) .eq. ieor(irrep_v,irrep_tr)) THEN
      dimc = int_mb(k_range+h2b-1) * int_mb(k_range+p12b-1) * int_mb(k_r
     &ange+p15b-1) * int_mb(k_range+h11b-1) * int_mb(k_range+h13b-1) * i
     &nt_mb(k_range+h14b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO p5b = noab+1,noab+nvab
      DO h8b = 1,noab
      IF (int_mb(k_spin+p12b-1)+int_mb(k_spin+p15b-1)+int_mb(k_spin+p5b-
     &1) .eq. int_mb(k_spin+h13b-1)+int_mb(k_spin+h14b-1)+int_mb(k_spin+
     &h8b-1)) THEN
      IF (ieor(int_mb(k_sym+p12b-1),ieor(int_mb(k_sym+p15b-1),ieor(int_m
     &b(k_sym+p5b-1),ieor(int_mb(k_sym+h13b-1),ieor(int_mb(k_sym+h14b-1)
     &,int_mb(k_sym+h8b-1)))))) .eq. irrep_tr) THEN
      CALL TCE_RESTRICTED_6(p12b,p15b,p5b,h13b,h14b,h8b,p12b_1,p15b_1,p5
     &b_1,h13b_1,h14b_1,h8b_1)
      CALL TCE_RESTRICTED_4(h2b,h8b,h11b,p5b,h2b_2,h8b_2,h11b_2,p5b_2)
      dim_common = int_mb(k_range+p5b-1) * int_mb(k_range+h8b-1)
      dima_sort = int_mb(k_range+p12b-1) * int_mb(k_range+p15b-1) * int_
     &mb(k_range+h13b-1) * int_mb(k_range+h14b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h2b-1) * int_mb(k_range+h11b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdt_y_tr1_14_3',2,MA_ERR)
      IF ((p5b .le. p12b) .and. (h8b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h8b_1 - 1 + noab * (p15b_1 - 
     &noab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+p15b-1),int_mb(k_range+h8b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),6,5,3,2,4,1,1.0d0
     &)
      END IF
      IF ((p5b .le. p12b) .and. (h13b .lt. h8b) .and. (h8b .le. h14b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h8b_1 - 1 + noab * (h13b_1 - 1 + noab * (p15b_1 - 
     &noab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+p15b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+h8b-1),int_mb(k_range+h14b-1),6,4,3,2,5,1,-1.0d
     &0)
      END IF
      IF ((p5b .le. p12b) .and. (h14b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (p15b_1 - 
     &noab - 1 + nvab * (p12b_1 - noab - 1 + nvab * (p5b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p5b-1)
     &,int_mb(k_range+p12b-1),int_mb(k_range+p15b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+h14b-1),int_mb(k_range+h8b-1),5,4,3,2,6,1,1.0d0
     &)
      END IF
      IF ((p12b .lt. p5b) .and. (p5b .le. p15b) .and. (h8b .le. h13b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h8b_1 - 1 + noab * (p15b_1 - 
     &noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p15b-1),int_mb(k_range+h8b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),6,5,3,1,4,2,-1.0d
     &0)
      END IF
      IF ((p12b .lt. p5b) .and. (p5b .le. p15b) .and. (h13b .lt. h8b) .a
     &nd. (h8b .le. h14b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h8b_1 - 1 + noab * (h13b_1 - 1 + noab * (p15b_1 - 
     &noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p15b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+h8b-1),int_mb(k_range+h14b-1),6,4,3,1,5,2,1.0d0
     &)
      END IF
      IF ((p12b .lt. p5b) .and. (p5b .le. p15b) .and. (h14b .lt. h8b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (p15b_1 - 
     &noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p5b-1),int_mb(k_range+p15b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+h14b-1),int_mb(k_range+h8b-1),5,4,3,1,6,2,-1.0d
     &0)
      END IF
      IF ((p15b .lt. p5b) .and. (h8b .le. h13b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h13b_1 - 1 + noab * (h8b_1 - 1 + noab * (p5b_1 - n
     &oab - 1 + nvab * (p15b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p15b-1),int_mb(k_range+p5b-1),int_mb(k_range+h8b-
     &1),int_mb(k_range+h13b-1),int_mb(k_range+h14b-1),6,5,2,1,4,3,1.0d0
     &)
      END IF
      IF ((p15b .lt. p5b) .and. (h13b .lt. h8b) .and. (h8b .le. h14b)) T
     &HEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h14b_
     &1 - 1 + noab * (h8b_1 - 1 + noab * (h13b_1 - 1 + noab * (p5b_1 - n
     &oab - 1 + nvab * (p15b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p15b-1),int_mb(k_range+p5b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+h8b-1),int_mb(k_range+h14b-1),6,4,2,1,5,3,-1.0d
     &0)
      END IF
      IF ((p15b .lt. p5b) .and. (h14b .lt. h8b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h8b_1
     & - 1 + noab * (h14b_1 - 1 + noab * (h13b_1 - 1 + noab * (p5b_1 - n
     &oab - 1 + nvab * (p15b_1 - noab - 1 + nvab * (p12b_1 - noab - 1)))
     &))))
      CALL TCE_SORT_6(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p12b-1
     &),int_mb(k_range+p15b-1),int_mb(k_range+p5b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+h14b-1),int_mb(k_range+h8b-1),5,4,2,1,6,3,1.0d0
     &)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdt_y_tr1_14_3',3,MA_E
     &RR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('ccsdt_y_tr1_14_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &ccsdt_y_tr1_14_3',5,MA_ERR)
      IF ((h8b .lt. h2b) .and. (h11b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h11b_2 - 1 + noab * (h2b_2 - 1 + noab * (h8b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h8b-1)
     &,int_mb(k_range+h2b-1),int_mb(k_range+h11b-1),int_mb(k_range+p5b-1
     &),3,2,1,4,-1.0d0)
      END IF
      IF ((h2b .le. h8b) .and. (h11b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p5b_2
     & - noab - 1 + nvab * (h11b_2 - 1 + noab * (h8b_2 - 1 + noab * (h2b
     &_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h2b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h11b-1),int_mb(k_range+p5b-1
     &),3,1,2,4,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('ccsdt_y_tr1_14_3',6,MA_E
     &RR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('ccsdt_y_tr1_14_3',7
     &,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdt_y_tr1_14_3',8
     &,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdt_y_tr1_14_3',9,MA_ERR)
      IF ((h11b .le. h13b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h14b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+p15b-1),int_mb(k_range+p12b-1),2,6,5,1,4,3,-1.0
     &d0/6.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h14b 
     &- 1 + noab * (h13b - 1 + noab * (h11b - 1 + noab * (p15b - noab - 
     &1 + nvab * (p12b - noab - 1 + nvab * (h2b - 1)))))))
      END IF
      IF ((h13b .le. h11b) .and. (h11b .le. h14b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h14b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+p15b-1),int_mb(k_range+p12b-1),2,6,5,4,1,3,1.0d
     &0/6.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h14b 
     &- 1 + noab * (h11b - 1 + noab * (h13b - 1 + noab * (p15b - noab - 
     &1 + nvab * (p12b - noab - 1 + nvab * (h2b - 1)))))))
      END IF
      IF ((h14b .le. h11b)) THEN
      CALL TCE_SORT_6(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+h11b-1
     &),int_mb(k_range+h2b-1),int_mb(k_range+h14b-1),int_mb(k_range+h13b
     &-1),int_mb(k_range+p15b-1),int_mb(k_range+p12b-1),2,6,5,4,3,1,-1.0
     &d0/6.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(h11b 
     &- 1 + noab * (h14b - 1 + noab * (h13b - 1 + noab * (p15b - noab - 
     &1 + nvab * (p12b - noab - 1 + nvab * (h2b - 1)))))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdt_y_tr1_14_3',10,MA_
     &ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('ccsdt_y_tr1_14_3',1
     &1,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END

c     $Id: c_cgsd_noit_energy.F 24498 2013-08-09 21:37:07Z bylaska $                       

*     ***************************
*     *				*
*     *	   c_cgsd_noit_energy	*
*     *				*
*     ***************************

      real*8 function c_cgsd_noit_energy()
      implicit none

#include "stdio.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "util.fh"
#include "errquit.fh"

      integer MASTER,taskid
      parameter (MASTER=0)

      logical value,mprint
      real*8  E(50),virial,EV
      real*8  f0,f1,f2,f3,f4,f5,f6
      integer rtdb,neall
      integer i,NN,nb

*     **** external functions ****
       integer  control_rtdb
       external control_rtdb
      logical     band_HFX
      logical     cpsp_semicore,control_out_of_time,cpsi_spin_orbit
      logical     control_fractional,control_print,brillioun_print
      character*4 ion_aname
      integer     control_it_in,control_it_out,control_minimizer
      integer     ion_nion,ion_katm,cpsi_ne,cpsi_ispin
      real*8      control_tole,control_tolc,cpsi_occupation_brdcst
      real*8      ion_rion,cpsi_eigenvalue_brdcst,cpsi_svector_brdcst
      real*8      ion_amass
      external    band_HFX
      external    cpsp_semicore,control_out_of_time,cpsi_spin_orbit
      external    control_fractional,control_print,brillioun_print
      external ion_aname
      external control_it_in,control_it_out,control_minimizer
      external ion_nion,ion_katm,cpsi_ne,cpsi_ispin
      external control_tole,control_tolc,cpsi_occupation_brdcst
      external ion_rion,cpsi_eigenvalue_brdcst,cpsi_svector_brdcst
      external ion_amass
      integer  brillioun_nbrillioun
      real*8   brillioun_k_brdcst,brillioun_ks_brdcst
      real*8   brillioun_weight_brdcst
      external brillioun_nbrillioun
      external brillioun_k_brdcst,brillioun_ks_brdcst
      external brillioun_weight_brdcst
      real*8   cpsi_smearfermi,cpsi_smearcorrection
      external cpsi_smearfermi,cpsi_smearcorrection
      logical  ion_disp_on
      external ion_disp_on


      call Parallel_taskid(taskid)

      mprint = (taskid.eq.MASTER).and.control_print(print_medium)


*     **** generate phaze factors and local psp and core density ****
c      call cphafac()
c      call cphafac_k()
      call c_electron_gen_vl_potential()
      if (cpsp_semicore(0)) call c_semicore_density_update()


      call c_nominimize(E)

*     **** diagonalize hamiltonian ****
      call cpsi_1gen_hml()
      call cpsi_diagonalize_hml()
      if (control_fractional()) then
         call cpsi_1define_occupation(.true.)
         E(12) = cpsi_smearcorrection()
         E(1)  = E(1) + E(12)
      end if


*     **** generate svectors ****
      if (cpsi_spin_orbit()) then
        call cpsi_1rotate2()
        call cpsi_2to1()
        call cpsi_1gen_svector()
      end if


**:::::::::::::::::   report summary of results  :::::::::::::::::::::::
      if (mprint) then
         neall = (cpsi_ne(1)+cpsi_ne(2))
         write(luout,1304)
         write(luout,1410)

         write(luout,*)
c         write(luout,1320) en(1),en(cpsi_ispin()),' (real space)'
         write(luout,1430) E(1),E(1)/ion_nion()
         write(luout,1440) E(2),E(2)/neall
         write(luout,1450) E(3),E(3)/neall
         write(luout,1460) E(4),E(4)/neall
         if (band_HFX()) then
           write(luout,1457) E(26),E(26)/neall
         end if
         write(luout,1470) E(5),E(5)/ion_nion()
         if (control_fractional()) write(luout,1471) E(12),E(12)/neall

         write(luout,1480) E(6),E(6)/neall
         write(luout,1490) E(7),E(7)/neall
         write(luout,1495) E(8),E(8)/neall
         write(luout,1496) E(9),E(9)/neall
         write(luout,1497) E(10),E(10)/neall
         write(luout,1499) E(11),E(11)/neall
         virial = (E(11)+E(10)+E(9)+E(8)+E(7))/E(6)
         write(luout,1498) virial
         if (band_HFX())  then
           write(luout,1502) E(27),E(27)/neall
         end if
        if (ion_disp_on()) then
            write(luout,1720) E(33)
        end if
      end if

      NN=cpsi_ne(1)-cpsi_ne(2)
      EV=27.2116d0
      if (mprint) then
        if (control_fractional()) then
          if (cpsi_ispin().eq.1) then
            write(luout,1507) cpsi_smearfermi(1),cpsi_smearfermi(1)*EV
          else
            write(luout,1507) cpsi_smearfermi(1),cpsi_smearfermi(1)*EV,
     >                        cpsi_smearfermi(2),cpsi_smearfermi(2)*EV
          end if
        end if
      end if

      if (brillioun_print()) then
      do nb=1,brillioun_nbrillioun()
         f0 = brillioun_weight_brdcst(nb) 
         f1 = brillioun_ks_brdcst(1,nb) 
         f2 = brillioun_ks_brdcst(2,nb) 
         f3 = brillioun_ks_brdcst(3,nb) 
         f4 = brillioun_k_brdcst(1,nb) 
         f5 = brillioun_k_brdcst(2,nb) 
         f6 = brillioun_k_brdcst(3,nb) 
         if (mprint) then
            write(luout,1508) nb,f0,f1,f2,f3,f4,f5,f6
            write(luout,1500)
         end if
         if (cpsi_spin_orbit()) then
           if (mprint) write(luout,1511)
           do i=0,cpsi_ne(1)-1
             f1 = cpsi_eigenvalue_brdcst(nb,1,cpsi_ne(1)-i) 
             f2 = cpsi_svector_brdcst(nb,cpsi_ne(1)-i,3) 
             f3 = cpsi_svector_brdcst(nb,cpsi_ne(1)-i,2) 
             f4 = cpsi_svector_brdcst(nb,cpsi_ne(1)-i,1) 
             f5 = cpsi_occupation_brdcst(nb,cpsi_ne(1)-i,1)
             if (mprint)
     >          write(luout,1512) f1,f1*EV,f2,f3,f4,f5
           end do
         else
           do i=0,NN-1
             f1 = cpsi_eigenvalue_brdcst(nb,1,cpsi_ne(1)-i) 
             f2 = cpsi_occupation_brdcst(nb,1,cpsi_ne(1)-i)
             if (mprint) write(luout,1510) f1,f1*EV,f2
           end do
           do i=0,cpsi_ne(2)-1
             f1 = cpsi_eigenvalue_brdcst(nb,1,cpsi_ne(1)-i-NN) 
             f2 = cpsi_occupation_brdcst(nb,1,cpsi_ne(1)-i-NN) 
             f3 = cpsi_eigenvalue_brdcst(nb,2,cpsi_ne(2)-i) 
             f4 = cpsi_occupation_brdcst(nb,2,cpsi_ne(2)-i)
             if (mprint) 
     >          write(luout,1510) f1,f1*EV,f2,f3,f3*EV,f4
           end do
         end if
      end do

      else
         if (mprint) write(luout,1501)
      endif




*     **** diagonalize hamiltonian and rotate psi ****
c     call psi_spin_density(en)
c     call psi_1gen_hml()
c     call psi_diagonalize_hml()
c
c     call psi_1rotate2()
c     call psi_2to1()


*     **** debug - energies written to rtdb for numerical stress ****
      rtdb = control_rtdb()
      value =           rtdb_put(rtdb,'band:E_ke',      mt_dbl,1,E(6))
      value = value.and.rtdb_put(rtdb,'band:E_hartree', mt_dbl,1,E(3))
      value = value.and.rtdb_put(rtdb,'band:E_xc',      mt_dbl,1,E(4))
      value = value.and.rtdb_put(rtdb,'band:E_ewald',   mt_dbl,1,E(5))
      value = value.and.rtdb_put(rtdb,'band:E_local',   mt_dbl,1,E(7))
      value = value.and.rtdb_put(rtdb,'band:E_nonlocal',mt_dbl,1,E(8))
      value = value.and.rtdb_put(rtdb,'band:E_disp',    mt_dbl,1,E(33))
      if (.not. value) call errquit(
     >   'c_cgsd_noit_energy: numerical stress - error writing rtdb',0,
     &       RTDB_ERR)


      c_cgsd_noit_energy = E(1)
      return
 1190 FORMAT(5X, I4, A3  ,' (',3F11.5,' ) - atomic mass= ',F6.3,' ')
 1200 FORMAT(5X,'  G.C. ',' (',3F11.5,' )')
 1210 FORMAT(5X,' C.O.M.',' (',3F11.5,' )')
 1300 FORMAT(//'======================')
 1301 FORMAT(  '= energy calculation =')
 1302 FORMAT(  '======================')
 1304 FORMAT(/)
 1305 FORMAT(10X,'== bundled Grassmann conjugate gradient iteration ==')
 1306 FORMAT(10X,'======== bundled Grassmann lmbfgs iteration ========')
 1307 FORMAT(10X,'============ Grassmann diis iteration ==============')
 1308 FORMAT(10X,'=== bundled Stiefel conjugate gradient iteration ===')
 1309 FORMAT(10X,'=========== band by band diis iteration ============')
 1310 FORMAT(I8,E20.10,3E15.5)
 1320 FORMAT(' number of electrons: spin up=',F11.5,'  down=',F11.5,A)
 1330 FORMAT(/' comparison between hamiltonian and lambda matrix')
 1340 FORMAT(I3,2I3,' H=',E16.7,', L=',E16.7,', H-L=',E16.7)
 1350 FORMAT(/' orthonormality')
 1360 FORMAT(I3,2I3,E18.7)
 1370 FORMAT(I3)
 1380 FORMAT(' ''',a,'''',I4)
 1390 FORMAT(I3)
 1400 FORMAT(I3,3E18.8/3X,3E18.8)
 1410 FORMAT(10X,'=============  summary of results  =================')
 1420 FORMAT( ' final position of ions:')
 1430 FORMAT(/' total     energy    :',E19.10,' (',E15.5,'/ion)')
 1440 FORMAT( ' total orbital energy:',E19.10,' (',E15.5,'/electron)')
 1450 FORMAT( ' hartree   energy    :',E19.10,' (',E15.5,'/electron)')
 1457 FORMAT( ' HF exchange energy  :',E19.10,' (',E15.5,'/electron)')
 1460 FORMAT( ' exc-corr  energy    :',E19.10,' (',E15.5,'/electron)')
 1470 FORMAT( ' ion-ion   energy    :',E19.10,' (',E15.5,'/ion)')
 1471 FORMAT( ' smearing  energy    :',E19.10,' (',E15.5,'/electron)')
 1480 FORMAT(/' K.S. kinetic energy :',E19.10,' (',E15.5,'/electron)')
 1490 FORMAT( ' K.S. V_l  energy    :',E19.10,' (',E15.5,'/electron)')
 1491 FORMAT( ' K.S. Vl+Vqm/mm      :',E19.10,' (',E15.5,'/electron)')
 1495 FORMAT( ' K.S. V_nl energy    :',E19.10,' (',E15.5,'/electron)')
 1496 FORMAT( ' K.S. V_Hart energy  :',E19.10,' (',E15.5,'/electron)')
 1497 FORMAT( ' K.S. V_xc energy    :',E19.10,' (',E15.5,'/electron)')
 1498 FORMAT( ' Virial Coefficient  :',E19.10)
 1499 FORMAT( ' K.S. V_nlso energy  :',E19.10,' (',E15.5,'/electron)')
 1500 FORMAT(/' orbital energies:')
 1501 FORMAT(/' orbital energies not printed',
     >        ' - number of k-points is very large')
 1502 FORMAT( ' K.S. HFX energy     :',E19.10,
     >        ' (',E15.5,'/electron)')
 1507 FORMAT(/' Fermi energy =',2(E18.7,' (',F8.3,'eV)'))
 1508 FORMAT(/' Brillouin zone point: ',i6,
     >       /'    weight=',f10.6,
     >       /'    k     =<',3f8.3,'> . <b1,b2,b3> ',
     >       /'          =<',3f8.3,'>')
 1510 FORMAT(2(E18.7,' (',F8.3,'eV) occ=',F5.3))
 1511 FORMAT(33x,"Spin(Sz,Sy,Sz)")
 1512 FORMAT(E18.7,' (',F8.3,' eV) (',F8.3,' zhat + ',F8.3,' yhat +',
     > F8.3,' xhat ) occ=',F5.3)

 1720 FORMAT(/' Dispersion energy   :',E19.10)

      end

      subroutine int_init_1eelec(maxbuf,maxscr,basis,nder,npt)
c
c $Id: hnd_init_1eelec.F 19696 2010-10-29 16:53:42Z d3y133 $
c
      implicit none
c
#include "hnd_pointers.fh"
#include "bas.fh"
#include "errquit.fh"
#include "global.fh"
c
      integer maxbuf    ! [output] buffer space for integrals
      integer maxscr    ! [output] scratch space needed
      integer basis     ! [input] basis set info
      integer nder      ! [input] integral derivative to be calculated
      integer npt       ! [input] number of grid points to be calculated
c
      integer lmax, iblk, i, mroots
c
c     Define Hermite polynomial values
c
      call hnd_whermt
c
c     set up memory requirements: get max L first
c
      lmax = -1
      if (.not.bas_high_angular(basis,lmax))
     &   call errquit('int_init_1eelec: lmax error',lmax, INT_ERR)
      lmax = lmax + 1
c
c     Calculate maximum buffer needed
c
      maxbuf = lmax*(lmax+1)*lmax*(lmax+1)/4 * npt * max(nder*3,1)
c
c     Calculate maximum scratch space needed
c
      mroots = (2*lmax+max(nder,0)-2)/2+1
      maxscr = 3*lmax*lmax*mroots
      if (nder.ge.1) maxscr = (nder+1)*maxscr
c
c     Set pointers for scratch space
c
      iblk = lmax*lmax*mroots
      do i = 1, 9
         elpt(i) = 1
      enddo
      do i = 2, 2+max(nder*3+1,1)
         elpt(i) = 1 + (i-1)*iblk
      enddo
c
c     If spherical basis, allocate scratch space for transformation
c     A little smaller than maxbuf: we will use maxbuf size
c
      maxscr = max(maxscr,maxbuf)
c
      return
      end

      SUBROUTINE eomccsd_2pdm_pppp_mo(d_i0,d_t1,d_t2,d_x0,d_x1,d_x2,d_y2
     &,k_i0_offset,k_t1_offset,k_t2_offset,k_x0_offset,k_x1_offset,k_x2_
     &offset,k_y2_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 p3 p4 )_yx + = 1/2 * Sum ( h5 h6 ) * x ( p1 p2 h5 h6 )_x * y ( h5 h6 p3 p4 )_y
C     i0 ( p1 p2 p3 p4 )_yxt + = -1 * P( 2 ) * Sum ( h5 ) * t ( p1 h5 )_t * i1 ( h5 p2 p3 p4 )_yx
C         i1 ( h5 p1 p2 p3 )_yx + = -1 * Sum ( h6 ) * x ( p1 h6 )_x * y ( h5 h6 p2 p3 )_y
C         i1 ( h5 p1 p2 p3 )_yxt + = 1/2 * Sum ( h6 ) * t ( p1 h6 )_t * i2 ( h5 h6 p2 p3 )_yx
C             i2 ( h5 h6 p1 p2 )_yx + = -1 * x ( )_x * y ( h5 h6 p1 p2 )_y
C     i0 ( p1 p2 p3 p4 )_yxt + = 1/2 * Sum ( h5 h6 ) * t ( p1 p2 h5 h6 )_t * i1 ( h5 h6 p3 p4 )_yx
C         i1 ( h5 h6 p1 p2 )_yx + = 1 * x ( )_x * y ( h5 h6 p1 p2 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_i0
      INTEGER k_i0_offset
      INTEGER d_x2
      INTEGER k_x2_offset
      INTEGER d_y2
      INTEGER k_y2_offset
      INTEGER d_t1
      INTEGER k_t1_offset
      INTEGER d_i1
      INTEGER k_i1_offset
      INTEGER d_t2
      INTEGER k_t2_offset
      INTEGER l_i1_offset
      INTEGER d_x1
      INTEGER k_x1_offset
      INTEGER size_i1
      INTEGER d_i2
      INTEGER k_i2_offset
      INTEGER l_i2_offset
      INTEGER d_x0
      INTEGER k_x0_offset
      INTEGER size_i2
      CHARACTER*255 filename
      CALL eomccsd_2pdm_pppp_mo_1(d_x2,k_x2_offset,d_y2,k_y2_offset,d_i0
     &,k_i0_offset)
      CALL OFFSET_eomccsd_2pdm_pppp_mo_2_1(l_i1_offset,k_i1_offset,size_
     &i1)
      CALL TCE_FILENAME('eomccsd_2pdm_pppp_mo_2_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL eomccsd_2pdm_pppp_mo_2_1(d_x1,k_x1_offset,d_y2,k_y2_offset,d_
     &i1,k_i1_offset)
      CALL OFFSET_eomccsd_2pdm_pppp_mo_2_2_1(l_i2_offset,k_i2_offset,siz
     &e_i2)
      CALL TCE_FILENAME('eomccsd_2pdm_pppp_mo_2_2_1_i2',filename)
      CALL CREATEFILE(filename,d_i2,size_i2)
      CALL eomccsd_2pdm_pppp_mo_2_2_1(d_x0,k_x0_offset,d_y2,k_y2_offset,
     &d_i2,k_i2_offset)
      CALL RECONCILEFILE(d_i2,size_i2)
      CALL eomccsd_2pdm_pppp_mo_2_2(d_t1,k_t1_offset,d_i2,k_i2_offset,d_
     &i1,k_i1_offset)
      CALL DELETEFILE(d_i2)
      IF (.not.MA_POP_STACK(l_i2_offset)) CALL ERRQUIT('eomccsd_2pdm_ppp
     &p_mo',-1,MA_ERR)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL eomccsd_2pdm_pppp_mo_2(d_t1,k_t1_offset,d_i1,k_i1_offset,d_i0
     &,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('eomccsd_2pdm_ppp
     &p_mo',-1,MA_ERR)
      CALL OFFSET_eomccsd_2pdm_pppp_mo_3_1(l_i1_offset,k_i1_offset,size_
     &i1)
      CALL TCE_FILENAME('eomccsd_2pdm_pppp_mo_3_1_i1',filename)
      CALL CREATEFILE(filename,d_i1,size_i1)
      CALL eomccsd_2pdm_pppp_mo_3_1(d_x0,k_x0_offset,d_y2,k_y2_offset,d_
     &i1,k_i1_offset)
      CALL RECONCILEFILE(d_i1,size_i1)
      CALL eomccsd_2pdm_pppp_mo_3(d_t2,k_t2_offset,d_i1,k_i1_offset,d_i0
     &,k_i0_offset)
      CALL DELETEFILE(d_i1)
      IF (.not.MA_POP_STACK(l_i1_offset)) CALL ERRQUIT('eomccsd_2pdm_ppp
     &p_mo',-1,MA_ERR)
      RETURN
      END
      SUBROUTINE eomccsd_2pdm_pppp_mo_1(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 p3 p4 )_yx + = 1/2 * Sum ( h5 h6 ) * x ( p1 p2 h5 h6 )_x * y ( h5 h6 p3 p4 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER p4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+p
     &3b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+p3b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+p3b-1) * int_mb(k_range+p4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_x) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h5b,h6b,p1b_1,p2b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,p4b,h5b_2,h6b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_1',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_1',
     &6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1)
     &,4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (p2b - noab - 1 + nvab
     & * (p1b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_1',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_2pdm_pppp_mo_2(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 p3 p4 )_yxt + = -1 * P( 2 ) * Sum ( h5 ) * t ( p1 h5 )_t * i1 ( h5 p2 p3 p4 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER p4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER p1b_1
      INTEGER h5b_1
      INTEGER p2b_2
      INTEGER h5b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = noab+1,noab+nvab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+p
     &3b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+p3b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_y,ieor(irrep_x
     &,irrep_t))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+p3b-1) * int_mb(k_range+p4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h5b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h5b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p1b,h5b,p1b_1,h5b_1)
      CALL TCE_RESTRICTED_4(p2b,h5b,p3b,p4b,p2b_2,h5b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+h5b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p2b-1) * int_mb(k_range+p3b-1) * int_mb
     &(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h5b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h5b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (p2b_2 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+p2b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,4,3,1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2',
     &6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2',9,MA_ERR)
      IF ((p1b .le. p2b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (p2b - noab - 1 + nvab
     & * (p1b - noab - 1)))))
      END IF
      IF ((p2b .le. p1b)) THEN
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1)
     &,3,4,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (p1b - noab - 1 + nvab
     & * (p2b - noab - 1)))))
      END IF
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_2pdm_pppp_mo_2_1(d_a,k_a_offset,d_b,k_b_offset,
     &d_c,k_c_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 p1 p2 p3 )_yx + = -1 * Sum ( h6 ) * x ( p1 h6 )_x * y ( h5 h6 p2 p3 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER h5b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h6b
      INTEGER p1b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &2b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p2b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+p2b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h6b = 1,noab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h6b-1)) .eq. irrep_x) TH
     &EN
      CALL TCE_RESTRICTED_2(p1b,h6b,p1b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p2b,p3b,h5b_2,h6b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h6b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_1
     &',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_1',5,MA_ERR)
      IF ((h6b .lt. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h5b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_1
     &',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_1',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h5b-1),int_mb(k_range+p1b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (h5b - 1 + noab * (p1b
     & - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_1
     &',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_eomccsd_2pdm_pppp_mo_2_1(l_a_offset,k_a_offset,s
     &ize)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 p1 p2 p3 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER p1b
      INTEGER h5b
      INTEGER p2b
      INTEGER p3b
      length = 0
      DO p1b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p
     &2b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(
     &k_sym+p2b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+p1b-1
     &)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO p1b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+p
     &2b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+p1b-1),ieor(int_mb(
     &k_sym+p2b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+p1b-1
     &)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p3b - noab - 1 + nvab * (p2b - noab - 1 
     &+ nvab * (h5b - 1 + noab * (p1b - noab - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+p1b-1) * int_mb(k_range+h5b-1) * int_
     &mb(k_range+p2b-1) * int_mb(k_range+p3b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE eomccsd_2pdm_pppp_mo_2_2(d_a,k_a_offset,d_b,k_b_offset,
     &d_c,k_c_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 p1 p2 p3 )_yxt + = 1/2 * Sum ( h6 ) * t ( p1 h6 )_t * i2 ( h5 h6 p2 p3 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER h5b
      INTEGER p2b
      INTEGER p3b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h6b
      INTEGER p1b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p2b_2
      INTEGER p3b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO h5b = 1,noab
      DO p2b = noab+1,noab+nvab
      DO p3b = p2b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+h5b-1
     &)+int_mb(k_spin+p2b-1)+int_mb(k_spin+p3b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+h5b-1) .eq. int_mb(k_spin+p
     &2b-1)+int_mb(k_spin+p3b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+h5b-1),ieor(int_mb(
     &k_sym+p2b-1),int_mb(k_sym+p3b-1)))) .eq. ieor(irrep_y,ieor(irrep_x
     &,irrep_t))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+h5b-1) * int_mb(k_ra
     &nge+p2b-1) * int_mb(k_range+p3b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_2',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h6b = 1,noab
      IF (int_mb(k_spin+p1b-1) .eq. int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),int_mb(k_sym+h6b-1)) .eq. irrep_t) TH
     &EN
      CALL TCE_RESTRICTED_2(p1b,h6b,p1b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p2b,p3b,h5b_2,h6b_2,p2b_2,p3b_2)
      dim_common = int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p1b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+p2b-1) * int_mb
     &(k_range+p3b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_2',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_2',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (p1b_1 - noab - 1)))
      CALL TCE_SORT_2(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h6b-1),1,2,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_2
     &',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_2',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_2',5,MA_ERR)
      IF ((h6b .lt. h5b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h5b_2 - 1 + noab 
     &* (h6b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h6b-1)
     &,int_mb(k_range+h5b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,2,1,-1.0d0)
      END IF
      IF ((h5b .le. h6b)) THEN
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p3b_2
     & - noab - 1 + nvab * (p2b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p2b-1),int_mb(k_range+p3b-1)
     &,4,3,1,2,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_2
     &',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_2',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_2',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_2',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p3b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h5b-1),int_mb(k_range+p1b-1)
     &,4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p3b -
     & noab - 1 + nvab * (p2b - noab - 1 + nvab * (h5b - 1 + noab * (p1b
     & - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_2
     &',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_2',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_2pdm_pppp_mo_2_2_1(d_a,k_a_offset,d_b,k_b_offse
     &t,d_c,k_c_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h5 h6 p1 p2 )_yx + = -1 * x ( )_x * y ( h5 h6 p1 p2 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_2_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (0 .eq. irrep_x) THEN
      CALL TCE_RESTRICTED_4(h5b,h6b,p1b,p2b,h5b_2,h6b_2,p1b_2,p2b_2)
      dim_common = 1
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_2_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_2_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_a),dbl_mb(k_a_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_2
     &_1',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_2_2_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_2_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_2
     &_1',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_2_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_2_1',8,MA_ERR)
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_2_2_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1)
     &,4,3,2,1,-1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h6b - 1 + noab * (h5b
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_2
     &_1',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_2_2_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_eomccsd_2pdm_pppp_mo_2_2_1(l_a_offset,k_a_offset
     &,size)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i2 ( h5 h6 p1 p2 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      length = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_2_2_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p2b - noab - 1 + nvab * (p1b - noab - 1 
     &+ nvab * (h6b - 1 + noab * (h5b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_
     &mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END
      SUBROUTINE eomccsd_2pdm_pppp_mo_3(d_a,k_a_offset,d_b,k_b_offset,d_
     &c,k_c_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i0 ( p1 p2 p3 p4 )_yxt + = 1/2 * Sum ( h5 h6 ) * t ( p1 p2 h5 h6 )_t * i1 ( h5 h6 p3 p4 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER p1b
      INTEGER p2b
      INTEGER p3b
      INTEGER p4b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER h5b_1
      INTEGER h6b_1
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p3b_2
      INTEGER p4b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER nsubh(2)
      INTEGER isubh
      INTEGER l_c
      INTEGER k_c
      DOUBLE PRECISION FACTORIAL
      EXTERNAL NXTVAL
      EXTERNAL FACTORIAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p3b = noab+1,noab+nvab
      DO p4b = p3b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1
     &)+int_mb(k_spin+p3b-1)+int_mb(k_spin+p4b-1).ne.8)) THEN
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+p
     &3b-1)+int_mb(k_spin+p4b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+p3b-1),int_mb(k_sym+p4b-1)))) .eq. ieor(irrep_y,ieor(irrep_x
     &,irrep_t))) THEN
      dimc = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1) * int_mb(k_ra
     &nge+p3b-1) * int_mb(k_range+p4b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_3',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      IF (int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1) .eq. int_mb(k_spin+h
     &5b-1)+int_mb(k_spin+h6b-1)) THEN
      IF (ieor(int_mb(k_sym+p1b-1),ieor(int_mb(k_sym+p2b-1),ieor(int_mb(
     &k_sym+h5b-1),int_mb(k_sym+h6b-1)))) .eq. irrep_t) THEN
      CALL TCE_RESTRICTED_4(p1b,p2b,h5b,h6b,p1b_1,p2b_1,h5b_1,h6b_1)
      CALL TCE_RESTRICTED_4(h5b,h6b,p3b,p4b,h5b_2,h6b_2,p3b_2,p4b_2)
      dim_common = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1)
      dima_sort = int_mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+p3b-1) * int_mb(k_range+p4b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_3',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_3',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(h6b_1
     & - 1 + noab * (h5b_1 - 1 + noab * (p2b_1 - noab - 1 + nvab * (p1b_
     &1 - noab - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+p1b-1)
     &,int_mb(k_range+p2b-1),int_mb(k_range+h5b-1),int_mb(k_range+h6b-1)
     &,2,1,4,3,1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_3',
     &3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_3',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_3',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p4b_2
     & - noab - 1 + nvab * (p3b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p3b-1),int_mb(k_range+p4b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_3',
     &6,MA_ERR)
      nsubh(1) = 1
      nsubh(2) = 1
      isubh = 1
      IF (h5b .eq. h6b) THEN
      nsubh(isubh) = nsubh(isubh) + 1
      ELSE
      isubh = isubh + 1
      END IF
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,2.0d0/FACTORIAL(
     &nsubh(1))/FACTORIAL(nsubh(2)),dbl_mb(k_a_sort),dim_common,dbl_mb(k
     &_b_sort),dim_common,1.0d0,dbl_mb(k_c_sort),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_3',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_3',8,MA_ERR)
      END IF
      END IF
      END IF
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_3',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p4b-1)
     &,int_mb(k_range+p3b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1)
     &,4,3,2,1,1.0d0/2.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p4b -
     & noab - 1 + nvab * (p3b - noab - 1 + nvab * (p2b - noab - 1 + nvab
     & * (p1b - noab - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_3',
     &10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_3',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE eomccsd_2pdm_pppp_mo_3_1(d_a,k_a_offset,d_b,k_b_offset,
     &d_c,k_c_offset)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 h6 p1 p2 )_yx + = 1 * x ( )_x * y ( h5 h6 p1 p2 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_b
      INTEGER k_b_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTVAL
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      INTEGER dimc
      INTEGER l_c_sort
      INTEGER k_c_sort
      INTEGER h5b_2
      INTEGER h6b_2
      INTEGER p1b_2
      INTEGER p2b_2
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER dimb_sort
      INTEGER dimb
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_b_sort
      INTEGER k_b_sort
      INTEGER l_b
      INTEGER k_b
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTVAL
      nprocs = GA_NNODES()
      count = 0
      next = NXTVAL(nprocs)
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      dimc = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb(k_ra
     &nge+p1b-1) * int_mb(k_range+p2b-1)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c_sort,k_c_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_3_1',0,MA_ERR)
      CALL DFILL(dimc,0.0d0,dbl_mb(k_c_sort),1)
      IF (0 .eq. irrep_x) THEN
      CALL TCE_RESTRICTED_4(h5b,h6b,p1b,p2b,h5b_2,h6b_2,p1b_2,p2b_2)
      dim_common = 1
      dima_sort = 1
      dima = dim_common * dima_sort
      dimb_sort = int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_mb
     &(k_range+p1b-1) * int_mb(k_range+p2b-1)
      dimb = dim_common * dimb_sort
      IF ((dima .gt. 0) .and. (dimb .gt. 0)) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_3_1',1,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_3_1',2,MA_ERR)
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),0)
      CALL TCE_SORT_0(dbl_mb(k_a),dbl_mb(k_a_sort),1.0d0)
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_3_1
     &',3,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b_sort,k_b_sort)) CALL
     & ERRQUIT('eomccsd_2pdm_pppp_mo_3_1',4,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimb,'noname',l_b,k_b)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_3_1',5,MA_ERR)
      CALL GET_HASH_BLOCK(d_b,dbl_mb(k_b),dimb,int_mb(k_b_offset),(p2b_2
     & - noab - 1 + nvab * (p1b_2 - noab - 1 + nvab * (h6b_2 - 1 + noab 
     &* (h5b_2 - 1)))))
      CALL TCE_SORT_4(dbl_mb(k_b),dbl_mb(k_b_sort),int_mb(k_range+h5b-1)
     &,int_mb(k_range+h6b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1)
     &,4,3,2,1,1.0d0)
      IF (.not.MA_POP_STACK(l_b)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_3_1
     &',6,MA_ERR)
      CALL DGEMM('T','N',dima_sort,dimb_sort,dim_common,1.0d0,dbl_mb(k_a
     &_sort),dim_common,dbl_mb(k_b_sort),dim_common,1.0d0,dbl_mb(k_c_sor
     &t),dima_sort)
      IF (.not.MA_POP_STACK(l_b_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_3_1',7,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_3_1',8,MA_ERR)
      END IF
      END IF
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &eomccsd_2pdm_pppp_mo_3_1',9,MA_ERR)
      CALL TCE_SORT_4(dbl_mb(k_c_sort),dbl_mb(k_c),int_mb(k_range+p2b-1)
     &,int_mb(k_range+p1b-1),int_mb(k_range+h6b-1),int_mb(k_range+h5b-1)
     &,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p2b -
     & noab - 1 + nvab * (p1b - noab - 1 + nvab * (h6b - 1 + noab * (h5b
     & - 1)))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_3_1
     &',10,MA_ERR)
      IF (.not.MA_POP_STACK(l_c_sort)) CALL ERRQUIT('eomccsd_2pdm_pppp_m
     &o_3_1',11,MA_ERR)
      END IF
      END IF
      END IF
      next = NXTVAL(nprocs)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      next = NXTVAL(-nprocs)
      call GA_SYNC()
      RETURN
      END
      SUBROUTINE OFFSET_eomccsd_2pdm_pppp_mo_3_1(l_a_offset,k_a_offset,s
     &ize)
C     $Id: eomccsd_2pdm_pppp_mo.F 19706 2010-10-29 17:52:31Z d3y133 $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i1 ( h5 h6 p1 p2 )_yx
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER l_a_offset
      INTEGER k_a_offset
      INTEGER size
      INTEGER length
      INTEGER addr
      INTEGER h5b
      INTEGER h6b
      INTEGER p1b
      INTEGER p2b
      length = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      length = length + 1
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      IF (.not.MA_PUSH_GET(mt_int,2*length+1,'noname',l_a_offset,k_a_off
     &set)) CALL ERRQUIT('eomccsd_2pdm_pppp_mo_3_1',0,MA_ERR)
      int_mb(k_a_offset) = length
      addr = 0
      size = 0
      DO h5b = 1,noab
      DO h6b = h5b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      IF (int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1) .eq. int_mb(k_spin+p
     &1b-1)+int_mb(k_spin+p2b-1)) THEN
      IF (ieor(int_mb(k_sym+h5b-1),ieor(int_mb(k_sym+h6b-1),ieor(int_mb(
     &k_sym+p1b-1),int_mb(k_sym+p2b-1)))) .eq. ieor(irrep_y,irrep_x)) TH
     &EN
      IF ((.not.restricted).or.(int_mb(k_spin+h5b-1)+int_mb(k_spin+h6b-1
     &)+int_mb(k_spin+p1b-1)+int_mb(k_spin+p2b-1).ne.8)) THEN
      addr = addr + 1
      int_mb(k_a_offset+addr) = p2b - noab - 1 + nvab * (p1b - noab - 1 
     &+ nvab * (h6b - 1 + noab * (h5b - 1)))
      int_mb(k_a_offset+length+addr) = size
      size = size + int_mb(k_range+h5b-1) * int_mb(k_range+h6b-1) * int_
     &mb(k_range+p1b-1) * int_mb(k_range+p2b-1)
      END IF
      END IF
      END IF
      END DO
      END DO
      END DO
      END DO
      RETURN
      END

      logical function argos_prepare_slvnum(islv,boxs,nwms,box,nwm)
c
c $Id: argos_prepare_slvnum.F 19708 2010-10-29 18:04:21Z d3y133 $
c
      implicit none
c
      integer islv,nwms,nwm
      real*8 boxs(3),box(3)
c
      nwm=0
      if(islv.eq.1) then
      nwm=2*int(dble(nwms)*(box(1)*box(2)*box(3))/
     + (boxs(1)*boxs(2)*boxs(3)))
      elseif(islv.eq.2) then
      nwm=int(dble(nwms)*0.5d0*(box(1)*box(2)*box(3))/
     + (boxs(1)*boxs(2)*boxs(3)))
      elseif(islv.eq.3) then
      nwm=2*int(dble(nwms)*(box(1)*box(2)*box(3))/
     + (boxs(1)*boxs(2)*boxs(3)))
      endif
c
      argos_prepare_slvnum=.true.
      return
      end

*
* $Id: cpsi_data.F 19707 2010-10-29 17:59:36Z d3y133 $
*

*     ************************************************
*     *                                              *
*     *                cpsi_data_init                *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_init(npsi0)
      implicit none
      integer npsi0

#include "mafdecls.fh"
#include "cpsi_data.fh"
#include "errquit.fh"

*     **** local variables ****
      logical value
      integer ltag

*     **** external functions ****
      logical  control_brillioun_ondisk
      external control_brillioun_ondisk

      brill_ondisk = control_brillioun_ondisk()

      npsi   = 2*npsi0
      tagmax = 0
      tagmin = npsi-1

      value = MA_alloc_get(mt_int,npsi,'nsize_psi',
     >                     nsize_psi(2),nsize_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'neall_psi',
     >                               neall_psi(2),neall_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'nbrill_psi',
     >                               nbrill_psi(2),nbrill_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'indx_psi',
     >                               indx_psi(2),indx_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'hndl_psi',
     >                               hndl_psi(2),hndl_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'curnb_psi',
     >                               curnb_psi(2),curnb_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'update_psi',
     >                               update_psi(2),update_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'list_psi',
     >                               list_psi(2),list_psi(1))
      value = value.and.MA_alloc_get(mt_int,npsi,'next_psi',
     >                               next_psi(2),next_psi(1))

      call icopy(npsi,0,0,int_mb(update_psi(1)),1)
      do ltag=0,npsi-1
         int_mb(list_psi(1)+ltag) = ltag
      end do

      if (.not.value) 
     > call errquit('cpsi_data_init: out of heap memory',0,MA_ERR)

      return
      end
*     ************************************************
*     *                                              *
*     *                cpsi_data_end                 *
*     *                                              *
*     ************************************************
*     
      subroutine cpsi_data_end()
      implicit none

#include "mafdecls.fh"
#include "cpsi_data.fh"
#include "errquit.fh"

*     ***** local variables ****
      logical value
      integer tag,ltag,hndl

      if (tagmax.gt.0) write(*,*) "CPSI_DATA_END, tagmax=",tagmax
      value = .true.
      do ltag=0,tagmax-1
         tag  = int_mb(list_psi(1)+ltag)
         hndl = int_mb(hndl_psi(1)+tag)
         value = value.and.MA_free_heap(hndl)
      end do
      value = value.and.MA_free_heap(nbrill_psi(2))
      value = value.and.MA_free_heap(neall_psi(2))
      value = value.and.MA_free_heap(nsize_psi(2))
      value = value.and.MA_free_heap(indx_psi(2))
      value = value.and.MA_free_heap(hndl_psi(2))
      value = value.and.MA_free_heap(curnb_psi(2))
      value = value.and.MA_free_heap(update_psi(2))
      value = value.and.MA_free_heap(list_psi(2))
      value = value.and.MA_free_heap(next_psi(2))
      if (.not.value)
     > call errquit('cpsi_data_end:error freeing heap',0,MA_ERR)

      return
      end 




*     ************************************************
*     *                                              *
*     *                cpsi_data_alloc               *
*     *                                              *
*     ************************************************
*     
      integer function cpsi_data_alloc(nbrill,neall,nsize)
      implicit none
      integer nbrill,neall,nsize

#include "mafdecls.fh"
#include "cpsi_data.fh"
#include "errquit.fh"

*     ***** local variables ****
      logical value
      integer tag,hndl,indx


      tag = int_mb(list_psi(1)+tagmax)
      int_mb(nbrill_psi(1)+tag) = nbrill
      int_mb(neall_psi(1) +tag) = neall
      int_mb(nsize_psi(1) +tag) = nsize
      int_mb(curnb_psi(1) +tag) = 1
      int_mb(update_psi(1)+tag) = 0
      int_mb(next_psi(1)+tag)   = -1

      value = MA_alloc_get(mt_dbl,(nbrill*neall*nsize),
     >                     'cpsi_alloc',hndl,indx)
      if (.not.value) 
     > call errquit('cpsi_data_alloc: out of heap memory',0,MA_ERR)


      int_mb(indx_psi(1)+tag)  = indx
      int_mb(hndl_psi(1)+tag)  = hndl

      tagmax = tagmax + 1

      cpsi_data_alloc = tag
      return
      end

*     ************************************************
*     *                                              *
*     *                cpsi_data_dealloc             *
*     *                                              *
*     ************************************************
*     
      subroutine cpsi_data_dealloc(tagin)
      implicit none
      integer tagin

#include "mafdecls.fh"
#include "cpsi_data.fh"
#include "errquit.fh"

*     ***** local variables ****
      integer ltagin,taglast,hndl

      hndl = int_mb(hndl_psi(1)+tagin)
      if (.not. MA_free_heap(hndl))
     > call errquit('cpsi_data_dealloc: error freeing heap',0,MA_ERR)

      tagmax  = tagmax - 1
      taglast = int_mb(list_psi(1)+tagmax)

*     **** swap list_psi(tagin) with list_psi(tagmax) ***
      if (tagin.ne.taglast) then
         !*** find where tagin is in the list ****
         ltagin = 0
         do while (int_mb(list_psi(1)+ltagin).ne.tagin)
             ltagin = ltagin + 1
         end do
         if (ltagin.gt.tagmax)
     > call errquit('cpsi_data_dealloc:cannot find tagin',tagin,0)
         int_mb(list_psi(1) + ltagin) = int_mb(list_psi(1) + tagmax)
         int_mb(list_psi(1) + tagmax) = tagin
      end if
      return
      end



*     ************************************************
*     *                                              *
*     *                cpsi_data_push_stack          *
*     *                                              *
*     ************************************************
*     
      integer function cpsi_data_push_stack(nbrill,neall,nsize)
      implicit none
      integer nbrill,neall,nsize

#include "mafdecls.fh"
#include "cpsi_data.fh"
#include "errquit.fh"

*     ***** local variables ****
      logical value
      integer tag,hndl,indx

      tag    = tagmin
      int_mb(nbrill_psi(1)+tag) = nbrill
      int_mb(neall_psi(1) +tag) = neall
      int_mb(nsize_psi(1) +tag) = nsize
      int_mb(curnb_psi(1) +tag) = 1
      int_mb(update_psi(1)+tag) = 0
      int_mb(next_psi(1)+tag)   = -1

      value = MA_push_get(mt_dbl,nbrill*neall*nsize,
     >                     'cpsi_stack',hndl,indx)
      if (.not.value)
     > call errquit('cpsi_data_push_stack: out of stack',0,MA_ERR)

      int_mb(indx_psi(1)+tag)  = indx
      int_mb(hndl_psi(1)+tag)  = hndl

      tagmin = tagmin - 1

      cpsi_data_push_stack = tag
      return
      end

*     ************************************************
*     *                                              *
*     *                cpsi_data_pop_stack           *
*     *                                              *
*     ************************************************
*     
      subroutine cpsi_data_pop_stack(tag)
      implicit none
      integer tag

#include "mafdecls.fh"
#include "cpsi_data.fh"
#include "errquit.fh"

*     ***** local variables ****
      integer hndl

      if (tag.ne.(tagmin+1))
     > call errquit('cpsi_data_push_stack:tag!=tagmin+1',0,MA_ERR)

      tagmin = tagmin + 1
      hndl = int_mb(hndl_psi(1)+tag) 
      if (.not.MA_pop_stack(hndl))
     > call errquit('cpsi_data_pop_stack: error popping stack',1,MA_ERR)

      return
      end

      
*     ************************************************
*     *                                              *
*     *                 cpsi_data_add                *
*     *                                              *
*     ************************************************
*     
      subroutine cpsi_data_add(tag,nb,n,psi)
      implicit none
      integer tag,nb,n
      real*8 psi(*)

#include "mafdecls.fh"
#include "cpsi_data.fh"
#include "errquit.fh"

*     ***** local variables ****
      integer indx,neall,nsize,shift,curr_nb

      indx  = int_mb(indx_psi(1) +tag)
      neall = int_mb(neall_psi(1)+tag)
      nsize = int_mb(nsize_psi(1)+tag)

      curr_nb = int_mb(curnb_psi(1)+tag)
c      if (brill_ondisk) then
c         shift = indx + ((nb-1)*nprj + (n-1))*nsize
c         .... add to local diskfile ***
c      else
c         shift = indx + ((n-1))*nsize
c      end if

      shift = indx + ((nb-1)*neall + (n-1))*nsize
      call dcopy(nsize,psi,1,dbl_mb(shift),1)

      return
      end 

*     ************************************************
*     *                                              *
*     *               cpsi_data_nsize                *
*     *                                              *
*     ************************************************
      integer function cpsi_data_nsize(tag)
      implicit none
      integer tag

#include "mafdecls.fh"
#include "cpsi_data.fh"

      cpsi_data_nsize = int_mb(nsize_psi(1)+tag)
      return
      end

*     ************************************************
*     *                                              *
*     *               cpsi_data_update               *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_update(tag)
      implicit none
      integer tag

#include "mafdecls.fh"
#include "cpsi_data.fh"

      int_mb(update_psi(1)+tag) = 1
      return
      end
*     ************************************************
*     *                                              *
*     *               cpsi_data_noupdate             *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_noupdate(tag)
      implicit none
      integer tag

#include "mafdecls.fh"
#include "cpsi_data.fh"

      int_mb(update_psi(1)+tag) = 0
      return
      end


*     ************************************************
*     *                                              *
*     *               cpsi_data_set_next             *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_set_next(tag,nexttag)
      implicit none
      integer tag,nexttag

#include "mafdecls.fh"
#include "cpsi_data.fh"

      int_mb(next_psi(1)+tag) = nexttag
      return
      end



*     ************************************************
*     *                                              *
*     *               cpsi_data_get_next             *
*     *                                              *
*     ************************************************
      integer function cpsi_data_get_next(tag)
      implicit none
      integer tag

#include "mafdecls.fh"
#include "cpsi_data.fh"

      cpsi_data_get_next = int_mb(next_psi(1)+tag)
      return
      end



*     ************************************************
*     *                                              *
*     *               cpsi_data_get_ptr              *
*     *                                              *
*     ************************************************
*     
      integer function cpsi_data_get_ptr(tag,nb,n)
      implicit none
      integer tag,nb,n

#include "mafdecls.fh"
#include "cpsi_data.fh"

*     ***** local variables ****
      integer indx,neall,nsize

      indx  = int_mb(indx_psi(1) +tag)
      neall = int_mb(neall_psi(1)+tag)
      nsize = int_mb(nsize_psi(1)+tag)

      cpsi_data_get_ptr = indx +((nb-1)*neall+(n-1))*nsize
      return
      end


*     ************************************************
*     *                                              *
*     *               cpsi_data_get_chnk             *
*     *                                              *
*     ************************************************
*
      integer function cpsi_data_get_chnk(tag,nb)
      implicit none
      integer tag,nb

#include "mafdecls.fh"
#include "cpsi_data.fh"

*     ***** local variables ****
      integer indx,neall,nsize

      indx  = int_mb(indx_psi(1) +tag)
      neall = int_mb(neall_psi(1)+tag)
      nsize = int_mb(nsize_psi(1)+tag)

      cpsi_data_get_chnk = indx +(nb-1)*neall*nsize
      return
      end


*     ************************************************
*     *                                              *
*     *               cpsi_data_get_allptr           *
*     *                                              *
*     ************************************************
*
      integer function cpsi_data_get_allptr(tag)
      implicit none
      integer tag

#include "mafdecls.fh"
#include "cpsi_data.fh"

      cpsi_data_get_allptr = int_mb(indx_psi(1) +tag)
      return
      end


*     ************************************************
*     *                                              *
*     *               cpsi_data_copy_brill           *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_copy_brill(tag,nb1,nb2)
      implicit none
      integer tag,nb1,nb2

#include "mafdecls.fh"
#include "cpsi_data.fh"
      
*     ***** local variables ****
      integer indx,neall,nsize,shift1,shift2
      
      indx  = int_mb(indx_psi(1) +tag)
      neall = int_mb(neall_psi(1)+tag)
      nsize = int_mb(nsize_psi(1)+tag)

      shift1 = indx + (nb1-1)*neall*nsize
      shift2 = indx + (nb2-1)*neall*nsize
      call dcopy(neall*nsize,dbl_mb(shift1),1,dbl_mb(shift2),1)

      return
      end 

*     ************************************************
*     *                                              *
*     *               cpsi_data_copyall              *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_copyall(tag1,tag2)
      implicit none
      integer tag1,tag2

#include "mafdecls.fh"
#include "cpsi_data.fh"

*     ***** local variables ****
      integer nbrill,neall,nsize
      integer indx1,neall1,nsize1,nbrill1
      integer indx2,neall2,nsize2,nbrill2
      
      indx1   = int_mb(indx_psi(1)  +tag1)
      indx2   = int_mb(indx_psi(1)  +tag2)
      neall1  = int_mb(neall_psi(1) +tag1)
      neall2  = int_mb(neall_psi(1) +tag2)
      nsize1  = int_mb(nsize_psi(1) +tag1)
      nsize2  = int_mb(nsize_psi(1) +tag2)
      nbrill1 = int_mb(nbrill_psi(1)+tag1)
      nbrill2 = int_mb(nbrill_psi(1)+tag2)

      nbrill = nbrill1
      nsize  = nsize1
      neall  = neall1
      call dcopy(nbrill*neall*nsize,dbl_mb(indx1),1,dbl_mb(indx2),1)

      return
      end

*     ************************************************
*     *                                              *
*     *               cpsi_data_zeroall              *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_zeroall(tag1)
      implicit none
      integer tag1

#include "mafdecls.fh"
#include "cpsi_data.fh"

*     ***** local variables ****
      integer nbrill,neall,nsize
      integer indx1,neall1,nsize1,nbrill1

      indx1   = int_mb(indx_psi(1)  +tag1)
      neall1  = int_mb(neall_psi(1) +tag1)
      nsize1  = int_mb(nsize_psi(1) +tag1)
      nbrill1 = int_mb(nbrill_psi(1)+tag1)

      nbrill = nbrill1
      nsize  = nsize1
      neall  = neall1
      call dcopy(nbrill*neall*nsize,0.0d0,0,dbl_mb(indx1),1)
      return
      end


*     ************************************************
*     *                                              *
*     *               cpsi_data_scalall              *
*     *                                              *
*     ************************************************
      subroutine cpsi_data_scalall(alpha,tag1)
      implicit none
      real*8 alpha
      integer tag1

#include "mafdecls.fh"
#include "cpsi_data.fh"

*     ***** local variables ****
      integer nbrill,neall,nsize
      integer indx1,neall1,nsize1,nbrill1

      indx1   = int_mb(indx_psi(1)  +tag1)
      neall1  = int_mb(neall_psi(1) +tag1)
      nsize1  = int_mb(nsize_psi(1) +tag1)
      nbrill1 = int_mb(nbrill_psi(1)+tag1)

      nbrill = nbrill1
      nsize  = nsize1
      neall  = neall1
      call dscal(nbrill*neall*nsize,alpha,dbl_mb(indx1),1)
      return
      end

C> \ingroup task
C> @{
      logical function task_ecp_print_integrals(rtdb)
      implicit none
#include "errquit.fh"
* $Id: rak26.F 22841 2012-09-12 06:55:13Z d3y133 $
c
#include "stdio.fh"
#include "mafdecls.fh"
#include "geom.fh"
#include "bas.fh"
c
      logical int_normalize, raktask26_a
      external int_normalize, raktask26_a
c
c
      integer rtdb
c
      logical status
      integer basis, geom
      integer nbf, nat, nshell
      integer maxg1, maxs1
      integer hbuf, hscr, hint
      integer kbuf, kscr, kint
c
      task_ecp_print_integrals = .false.
c
      if (.not.geom_create(geom,'geometry')) call errquit
     &    ('geom create failed',911, GEOM_ERR)
      if (.not.geom_rtdb_load(rtdb,geom,'geometry')) call errquit
     &    ('geom_rtdb_load failed',911, RTDB_ERR)
c
      if (.not.bas_create(basis,'ao basis')) call errquit
     &    ('bas_create failed',911, BASIS_ERR)
      if (.not.bas_rtdb_load(rtdb,geom,basis,'ao basis')) call errquit
     &    ('bas_rtdb_load failed',911, RTDB_ERR)
c
      write(6,*)' geom/basis loaded'
c
      if (.not.int_normalize(rtdb,basis)) stop ' norm error 1'
c
      if (.not. bas_print(basis))
     $    call errquit(' basis print failed', 0, BASIS_ERR)
c
      if (.not.bas_numbf(basis,nbf)) call errquit
     &    ('numbf failed',911, BASIS_ERR)
      if (.not.bas_numcont(basis,nshell)) call errquit
     &    ('numcont failed',911, BASIS_ERR)
c
      if (.not.geom_ncent(geom,nat)) stop 'geom_ncent fe'
      write(6,*) 'number of atoms ', nat
c
      call int_init(rtdb, 1, basis)
      call int_mem_1e(maxg1, maxs1)
      write(luout,*)' maxg1 = ',maxg1
      write(luout,*)' maxs1 = ',maxs1
      maxs1 = max(maxs1,(nbf*nbf))
      write(luout,*)' maxs1 = ',maxs1, ' after max for copy '
      status = .true.
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxg1,'int buffer' ,hbuf,kbuf)
      status = status .and.
     &    ma_alloc_get(mt_dbl,maxs1,'scr buffer' ,hscr,kscr)
      status = status .and.
     &    ma_alloc_get(mt_dbl,(nbf*nbf),'ints' ,hint,kint)
c
      task_ecp_print_integrals = raktask26_a(rtdb,
     &    geom, basis, nbf, nat, nshell, maxg1, maxs1,
     &    dbl_mb(kint), 
     &    dbl_mb(kbuf),
     &    dbl_mb(kscr))
      status = .true.
      status = status.and.ma_free_heap(hint)
      status = status.and.ma_free_heap(hbuf)
      status = status.and.ma_free_heap(hscr)
      status = status.and.bas_destroy(basis)
      status = status.and.geom_destroy(geom)
      task_ecp_print_integrals = task_ecp_print_integrals.and.status
      call int_terminate()
      end
C> @}
      logical function raktask26_a(rtdb,
     &    geom, basis, nbf, nat, nshell, szb, szs,
     &    zint,buf,scr)
      implicit none
#include "errquit.fh"
#include "nwc_const.fh"
#include "mafdecls.fh"
#include "geom.fh"
#include "geomP.fh"
#include "basdeclsP.fh"
#include "basP.fh"
#include "bas.fh"
#include "stdio.fh"
#include "geobasmapP.fh"
#include "inp.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
c
      integer rtdb, geom, basis, nbf, nat, nshell, szb, szs
      double precision zint(nbf,nbf)
      double precision buf(szb)
      double precision scr(szs)
c
      double precision val
      integer nshell_use
      integer ishell, ilo, ihi, nbfshi
      integer jshell, jlo, jhi, nbfshj
      integer ii_np, ii_gen, ii_exp, ii_cf, ii_type, ii_atom
      integer jj_np, jj_gen, jj_exp, jj_cf, jj_type, jj_atom
      integer nbfsh, ucont, xbas, cnt, i, j, lu
      logical does_it_exist
c
      character*255 filename
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
      call dfill (nbf*nbf,0.0d00,zint,1)
      call dfill (szb,0.0d00,buf,1)
      call dfill (szs,0.0d00,scr,1)
c
      xbas = basis + BASIS_HANDLE_OFFSET
      nshell_use = nshell
c
      do ishell = 1, nshell_use
        write(6,*)' fd: ishell = ',ishell,' of ',nshell_use
        call util_flush(6)
        if (.not.bas_cn2bfr(basis,ishell,ilo,ihi))
     &      stop 'cn2bfr error i'
        nbfshi = ihi - ilo + 1
        ucont = (sf_ibs_cn2ucn(ishell,xbas))
        ii_np   = infbs_cont(CONT_NPRIM,ucont,xbas)
        ii_gen  = infbs_cont(CONT_NGEN,ucont,xbas)
        ii_exp  = infbs_cont(CONT_IEXP,ucont,xbas)
        ii_cf   = infbs_cont(CONT_ICFP,ucont,xbas)
        ii_type = infbs_cont(CONT_TYPE,ucont,xbas)
        ii_atom = (sf_ibs_cn2ce(ishell,xbas))
        do jshell = 1, ishell
          if (.not.bas_cn2bfr(basis,jshell,jlo,jhi))
     &        stop 'cn2bfr error j'
          nbfshj = jhi - jlo + 1
          nbfsh = nbfshi*nbfshj
*          write(6,*)' fd:     jshell = ',jshell,' size =',nbfsh
          ucont = (sf_ibs_cn2ucn(jshell,xbas))
          jj_np   = infbs_cont(CONT_NPRIM,ucont,xbas)
          jj_gen  = infbs_cont(CONT_NGEN,ucont,xbas)
          jj_exp  = infbs_cont(CONT_IEXP,ucont,xbas)
          jj_cf   = infbs_cont(CONT_ICFP,ucont,xbas)
          jj_type = infbs_cont(CONT_TYPE,ucont,xbas)
          jj_atom = (sf_ibs_cn2ce(jshell,xbas))
*          
          call dfill (szb,0.0d00,buf,1)
          call dfill (szs,0.0d00,scr,1)
          call int_ecp_hf1(
     &        coords(1,ii_atom,geom),
     &        dbl_mb(mb_exndcf(ii_exp,xbas)),
     &        dbl_mb(mb_exndcf(ii_cf,xbas)),
     &        ii_np, ii_gen, ii_type, ii_atom,
          
     &        coords(1,jj_atom,geom),
     &        dbl_mb(mb_exndcf(jj_exp,xbas)),
     &        dbl_mb(mb_exndcf(jj_cf,xbas)),
     &        jj_np, jj_gen, jj_type, jj_atom,
          
     &        buf,nbfsh,scr,szs,.false.)
*--------          
          cnt = 1
          do i = ilo,ihi
            do j = jlo, jhi
              zint(i,j) = buf(cnt)
              zint(j,i) = buf(cnt)
            enddo
          enddo
*--------          
        enddo
      enddo
* now have full ecp integral matrix print it out      
c
      call util_file_name('ecp_integrals',.false.,.false.,filename)
c
      lu = 69
      does_it_exist = .false.
      inquire(file=filename,exist=does_it_exist)
      if (does_it_exist) then
        write(luout,*)
     &      'rak26: overwrite of existing file',
     &      filename(1:inp_strlen(filename))
        call util_file_unlink(filename)
      endif
*
      does_it_exist = .false.
      inquire(file=filename,exist=does_it_exist)
      if (does_it_exist) then
        write(luout,*)
     &      'rak26: file not unlinked:  ',
     &      filename(1:inp_strlen(filename))
        call errquit('rak26: fatal error ',911, DISK_ERR)
      endif
*
      open(unit=lu,file=filename,
     &    form='formatted',
     &    access='sequential',
     &    status='new')
      cnt = 0
      do i = 1,nbf
        do j = 1,i
          cnt = cnt + 1
          val = zint(i,j)
          if (abs(val).gt.1.0d-8) then
            write(lu,10000)cnt,i,j,val
          endif
        enddo
      enddo
      close(unit=lu,status='keep')
      raktask26_a = .true.
10000 format(1x,i10,i5,i5,1pd20.10)
      end

*> \brief \b DSYTD2 reduces a symmetric matrix to real symmetric tridiagonal form by an orthogonal similarity transformation (unblocked algorithm).
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DSYTD2 + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dsytd2.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dsytd2.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dsytd2.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DSYTD2( UPLO, N, A, LDA, D, E, TAU, INFO )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, N
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), D( * ), E( * ), TAU( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DSYTD2 reduces a real symmetric matrix A to symmetric tridiagonal
*> form T by an orthogonal similarity transformation: Q**T * A * Q = T.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          Specifies whether the upper or lower triangular part of the
*>          symmetric matrix A is stored:
*>          = 'U':  Upper triangular
*>          = 'L':  Lower triangular
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*>          n-by-n upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading n-by-n lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>          On exit, if UPLO = 'U', the diagonal and first superdiagonal
*>          of A are overwritten by the corresponding elements of the
*>          tridiagonal matrix T, and the elements above the first
*>          superdiagonal, with the array TAU, represent the orthogonal
*>          matrix Q as a product of elementary reflectors; if UPLO
*>          = 'L', the diagonal and first subdiagonal of A are over-
*>          written by the corresponding elements of the tridiagonal
*>          matrix T, and the elements below the first subdiagonal, with
*>          the array TAU, represent the orthogonal matrix Q as a product
*>          of elementary reflectors. See Further Details.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[out] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          The diagonal elements of the tridiagonal matrix T:
*>          D(i) = A(i,i).
*> \endverbatim
*>
*> \param[out] E
*> \verbatim
*>          E is DOUBLE PRECISION array, dimension (N-1)
*>          The off-diagonal elements of the tridiagonal matrix T:
*>          E(i) = A(i,i+1) if UPLO = 'U', E(i) = A(i+1,i) if UPLO = 'L'.
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is DOUBLE PRECISION array, dimension (N-1)
*>          The scalar factors of the elementary reflectors (see Further
*>          Details).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup doubleSYcomputational
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  If UPLO = 'U', the matrix Q is represented as a product of elementary
*>  reflectors
*>
*>     Q = H(n-1) . . . H(2) H(1).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**T
*>
*>  where tau is a real scalar, and v is a real vector with
*>  v(i+1:n) = 0 and v(i) = 1; v(1:i-1) is stored on exit in
*>  A(1:i-1,i+1), and tau in TAU(i).
*>
*>  If UPLO = 'L', the matrix Q is represented as a product of elementary
*>  reflectors
*>
*>     Q = H(1) H(2) . . . H(n-1).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**T
*>
*>  where tau is a real scalar, and v is a real vector with
*>  v(1:i) = 0 and v(i+1) = 1; v(i+2:n) is stored on exit in A(i+2:n,i),
*>  and tau in TAU(i).
*>
*>  The contents of A on exit are illustrated by the following examples
*>  with n = 5:
*>
*>  if UPLO = 'U':                       if UPLO = 'L':
*>
*>    (  d   e   v2  v3  v4 )              (  d                  )
*>    (      d   e   v3  v4 )              (  e   d              )
*>    (          d   e   v4 )              (  v1  e   d          )
*>    (              d   e  )              (  v1  v2  e   d      )
*>    (                  d  )              (  v1  v2  v3  e   d  )
*>
*>  where d and e denote diagonal and off-diagonal elements of T, and vi
*>  denotes an element of the vector defining H(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DSYTD2( UPLO, N, A, LDA, D, E, TAU, INFO )
*
*  -- LAPACK computational routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), D( * ), E( * ), TAU( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO, HALF
      PARAMETER          ( ONE = 1.0D0, ZERO = 0.0D0,
     $                   HALF = 1.0D0 / 2.0D0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            I
      DOUBLE PRECISION   ALPHA, TAUI
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DLARFG, DSYMV, DSYR2, XERBLA
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DDOT
      EXTERNAL           LSAME, DDOT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DSYTD2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Reduce the upper triangle of A
*
         DO 10 I = N - 1, 1, -1
*
*           Generate elementary reflector H(i) = I - tau * v * v**T
*           to annihilate A(1:i-1,i+1)
*
            CALL DLARFG( I, A( I, I+1 ), A( 1, I+1 ), 1, TAUI )
            E( I ) = A( I, I+1 )
*
            IF( TAUI.NE.ZERO ) THEN
*
*              Apply H(i) from both sides to A(1:i,1:i)
*
               A( I, I+1 ) = ONE
*
*              Compute  x := tau * A * v  storing x in TAU(1:i)
*
               CALL DSYMV( UPLO, I, TAUI, A, LDA, A( 1, I+1 ), 1, ZERO,
     $                     TAU, 1 )
*
*              Compute  w := x - 1/2 * tau * (x**T * v) * v
*
               ALPHA = -HALF*TAUI*DDOT( I, TAU, 1, A( 1, I+1 ), 1 )
               CALL DAXPY( I, ALPHA, A( 1, I+1 ), 1, TAU, 1 )
*
*              Apply the transformation as a rank-2 update:
*                 A := A - v * w**T - w * v**T
*
               CALL DSYR2( UPLO, I, -ONE, A( 1, I+1 ), 1, TAU, 1, A,
     $                     LDA )
*
               A( I, I+1 ) = E( I )
            END IF
            D( I+1 ) = A( I+1, I+1 )
            TAU( I ) = TAUI
   10    CONTINUE
         D( 1 ) = A( 1, 1 )
      ELSE
*
*        Reduce the lower triangle of A
*
         DO 20 I = 1, N - 1
*
*           Generate elementary reflector H(i) = I - tau * v * v**T
*           to annihilate A(i+2:n,i)
*
            CALL DLARFG( N-I, A( I+1, I ), A( MIN( I+2, N ), I ), 1,
     $                   TAUI )
            E( I ) = A( I+1, I )
*
            IF( TAUI.NE.ZERO ) THEN
*
*              Apply H(i) from both sides to A(i+1:n,i+1:n)
*
               A( I+1, I ) = ONE
*
*              Compute  x := tau * A * v  storing y in TAU(i:n-1)
*
               CALL DSYMV( UPLO, N-I, TAUI, A( I+1, I+1 ), LDA,
     $                     A( I+1, I ), 1, ZERO, TAU( I ), 1 )
*
*              Compute  w := x - 1/2 * tau * (x**T * v) * v
*
               ALPHA = -HALF*TAUI*DDOT( N-I, TAU( I ), 1, A( I+1, I ),
     $                 1 )
               CALL DAXPY( N-I, ALPHA, A( I+1, I ), 1, TAU( I ), 1 )
*
*              Apply the transformation as a rank-2 update:
*                 A := A - v * w**T - w * v**T
*
               CALL DSYR2( UPLO, N-I, -ONE, A( I+1, I ), 1, TAU( I ), 1,
     $                     A( I+1, I+1 ), LDA )
*
               A( I+1, I ) = E( I )
            END IF
            D( I ) = A( I, I )
            TAU( I ) = TAUI
   20    CONTINUE
         D( N ) = A( N, N )
      END IF
*
      RETURN
*
*     End of DSYTD2
*
      END
c $Id: dsytd2.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine argos_fold(iwl,isl,xw,xwm,xs,xsm)
c
      implicit none
c
#include "argos.fh"
c
      integer iwl(mwm,miw2),isl(msa,mis2)
      real*8 xw(mwm,3,mwa),xwm(mwm,3),xs(msa,3),xsm(msm,3)
c
      call argos_cafe_fold(nwmloc,xw,xwm,nsaloc,isl(1,lsatt),isl(1,
     + lsmol),
     + xs,xsm)
c
      return
      end
c $Id: argos_fold.F 21176 2011-10-10 06:35:49Z d3y133 $

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c                                   NOTICE
c
c   This software is being made available for internal testing and
c   evaluation purposes only. This software is a pre-release test version
c   which has not yet been authenticated and cleared for publication. Adherence
c   to this notice may be necessary for the author, Battelle Memorial
c   Institute, to successfully assert copyright in and commercialize this
c   software. This software is not intended for duplication or distribution
c   to third parties without the permission of the Manager of Software
c   Products at Pacific Northwest Laboratory, Richland, Washington,  99352.
c
      subroutine mdstep
#include "common.fh"
c
      double precision vbox, rmax
      integer i,j,me
      logical newcfg
      double precision cluster_check_radius
      logical debug
      if (istep.gt.3930438) then
        debug = .false.
      else
        debug = .false.
      endif
c
c   This routine guides the MD steps.
c   Begin the main loop through the MD steps
c
      me = ga_nodeid()
      r_confine = 0.0d00
      do 5000 istep = 1, nstep
c
        newcfg = .false.
        mbflg = .false.
        cmflg = .false.
        ipmode = 0
        t_rmndr = tau
        t_done = 0.0d00
        cllsn_cnt = 0
c
c  Check to see if there are any special instructions
c
        do 100 i = 1, nsc
c
c  is end >= istep >= beg
c
          if ((istep.ge.isc(i,1)).and.(istep.le.isc(i,2))) then
c
c   is mod(istep-beg,inc) = 0
c
            if (mod(istep,isc(i,3)).eq.0) then
c
c   get next configuration using the appropriate algorithm
c
              if (isc(i,4).eq.1) then
                call estep
                newcfg = .true.
              elseif (isc(i,4).eq.2) then
                prssr = rsc(i,2) 
                pmass = rsc(i,4)
                call pstep
                newcfg = .true.
              elseif (isc(i,4).eq.3) then
                tmprtr = rsc(i,1)
                prssr = rsc(i,2)
                pmass = rsc(i,4)
                call sstep
                newcfg = .true.
              elseif (isc(i,4).eq.4) then
                tmprtr = rsc(i,1)
                tmass = rsc(i,3)
                call tstep
                newcfg = .true.
              elseif (isc(i,4).eq.5) then
                tmprtr = rsc(i,1)
                prssr = rsc(i,2) 
                tmass = rsc(i,3)
                pmass = rsc(i,4)
                call ptstep
                newcfg = .true.
              elseif (isc(i,4).eq.6) then
                tmprtr = rsc(i,1)
                call mbstep
                newcfg = .true.
              elseif (isc(i,4).eq.7) then
                itarg = isc(i,2)
                tmprtr = rsc(i,1)
                tvol = rsc(i,2)
                tmass = rsc(i,3)
                call vlstep
                newcfg = .true.
              elseif (isc(i,4).eq.8) then
                tmprtr = rsc(i,1)
                call kstep
                newcfg = .true.
              elseif (isc(i,4).eq.9) then
                tmprtr = rsc(i,1)
                prssr = rsc(i,2) 
                tmass = rsc(i,3)
                pmass = rsc(i,4)
                ipmode = 1
                call ptstep
                newcfg = .true.
              elseif (isc(i,4).eq.10) then
                tmprtr = rsc(i,1)
                prssr = rsc(i,2) 
                tmass = rsc(i,3)
                pmass = rsc(i,4)
                ipmode = 2
                call ptstep
                newcfg = .true.
              endif
            endif
          endif
  100   continue
c
c  get next configuration if no special step is taken
c
        if (.not.newcfg) then
          if (dflalg.eq.1) then
            call estep
          elseif (dflalg.eq.2) then
            prssr = dfprs
            pmass = dfpm
            call pstep
          elseif (dflalg.eq.3) then
            tmprtr = dftmp
            prssr = dfprs
            pmass = dfpm
            call sstep
          elseif (dflalg.eq.4) then
            tmprtr = dftmp
            tmass = dftm
            call tstep
          elseif (dflalg.eq.5) then
            tmprtr = dftmp
            prssr = dfprs
            tmass = dftm
            pmass = dfpm
            call ptstep
          elseif (dflalg.eq.6) then
            tmprtr = dftmp
            call mbstep
          elseif (dflalg.eq.9) then
            tmprtr = dftmp
            prssr = dfprs
            tmass = dftm
            pmass = dfpm
            ipmode = 1
            call ptstep
          elseif (dflalg.eq.10) then
            tmprtr = dftmp
            prssr = dfprs
            tmass = dftm
            pmass = dfpm
            ipmode = 2
            call ptstep
          endif
        endif
            if (debug) then
              write(6,*) ga_nodeid(),' Got to 1 at step ',istep
            endif
c
c  Update remaining energy quantities
c
        nrg(3) = nrg(4) + nrg(6)
        vbox = xbox*ybox*zbox
        nrg(7) = nrg(5) * dble(atot-1) / vbox + nrg(15)

        if (istep.eq.equil_1) then
          call fixper
          do i = 1, antot
            do j = 1, 3
              ra(i,j,6) = ra(i,j,1)
            end do
          end do
          call cluster_com
          call cluster_center
          rmax = cluster_check_radius()
          if (rmax.gt.r_cluster) r_cluster = rmax + 0.01
        endif
        if (mod(istep,mcfreq).eq.0.and.istep.gt.equil_1) then
          call cluster_mc
          if (me.eq.0.and.l_rad) write(7,7100) dble(istep)*tau,r_cluster
        endif
            if (debug) then
              write(6,*) ga_nodeid(),' Got to 2 at step ',istep
            endif
        if (istep.gt.equil_2.and.r_cluster.le.cl_upper)
     +    call cluster_binr
            if (debug) then
              write(6,*) ga_nodeid(),' Got to 3 at step ',istep
            endif
        if (istep.eq.window_1) call cluster_reset_binr(1)
        if (istep.eq.window_2) call cluster_reset_binr(2)
c
c   Perform all statistical operations
c   on the new configuration.
c
c   print pressure
c
         if (mod(istep,istat).eq.0.and.l_stdio) then
           call header(istep)
           if (me.eq.0) write(6,6000) nrg(7) 
           if (me.eq.0) write(6,6300) nrg(3)
           if (me.eq.0) write(6,6700) nrg(6),nrg(4),nrg(5)
           if (me.eq.0) write(6,6800) xbox,ybox,zbox,scal1
           if (me.eq.0) write(6,6100) nrg(13),nrg(14),
     +       nrg(17),nrg(21)
           if (me.eq.0) write(6,6900) nrg(9)
         endif
c
c   accumulate energy statistics
c
         if (istep.gt.equil_2) call estat
c
         if (me.eq.0.and.l_step.and.mod(istep,1000).eq.0) then
           open(unit=2,file='step.cnt',status='unknown')
           write(2,*) 'proc : ',ga_pgroup_nodeid(ga_pgroup_get_world())
           write(2,*) 'istep : ',istep
           write(2,6900) nrg(9)
           write(2,6100) nrg(13),nrg(14),nrg(17),nrg(21)
           write(2,6000) nrg(7) 
           write(2,6300) nrg(3)
           write(2,6700) nrg(6),nrg(4),nrg(5)
           write(2,6800) xbox,ybox,zbox,scal1
           write(2,7000) r_cluster
           write(2,7200) cl_lower
           write(2,7300) cl_upper
           close(2)
         endif
 5000 continue
      return
 6000 format(1x,'The instantaneous pressure is ',f12.4)
 6100 format(1x,'Current energy statistics'/
     +          '       repulsion: ',f16.4,/
     +          '      dispersion: ',f16.4,/
     +          '           bonds: ',f16.4,/
     +          '          angles: ',f16.4)
 6200 format(1x,'Statistics at time ',i6,' ps')
 6300 format(1x,'The total energy is ',f12.4)
 6700 format('     potential      kinetic'/
     +       '     energy         energy   temperature'/,
     +          1x,3f13.3)
 6800 format(1x,'The current simulation cell dimensions:'/
     +         '              x:   ',f16.4,/
     +         '              y:   ',f16.4,/
     +         '              z:   ',f16.4,/
     +         '              s:   ',f16.4)
 6820 format(1x,'The current simulation cell dimensions:'/
     +         '              x:   ',f16.4,/
     +         '              y:   ',f16.4,/
     +         '              s:   ',f16.4)
 6900 format(1x,'The instantaneous value of the Hamiltonian is ',f12.4)
 7000 format(1x,'The current value of confining sphere is      ',f12.4)
 7100 format(2f16.8)
 7200 format(1x,'Lower bound of confining sphere               ',f12.4)
 7300 format(1x,'Upper bound of confining sphere               ',f12.4)
      end

#if HAVE_CONFIG_H
#   include "config.fh"
#endif
c
c FNAME - filename for test program
c
#define BASE_NAME  '/scratch/da.try'
#define BASE_NAME1 '/scratch/da1.try'
#ifdef  HPIODIR
#  define FNAME   HPIODIR//BASE_NAME
#  define FNAME1  HPIODIR//BASE_NAME1
#else
#  define FNAME   BASE_NAME
#  define FNAME1  BASE_NAME1
#endif

c#define MULTFILES 1

#ifdef SOLARIS
#  if MULTFILES
#    define USEMULTFILES 1
#  endif
#else
#  define USEMULTFILES 1
#endif

      program io
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
      integer status, me
      integer max_arrays
      integer stack, heap
      double precision max_sz, max_disk, max_mem 
      data max_arrays, max_sz, max_disk, max_mem /10,1d8,1d10, 1d6/
#if   defined(IBM)|| defined(CRAY_T3E)
      data stack, heap /70000000, 4000000/
#else
      data stack, heap /1200000, 800000/
#endif
c
#include "mp3.fh"
      call ga_initialize()
      if(.not. ga_uses_ma())then
         stack = 100000 
         heap  = 100000 
      endif
c
      if(ma_init(MT_F_DBL, stack, heap) ) then
        me    = ga_nodeid()
        if(dra_init(max_arrays, max_sz, max_disk, max_mem).ne.0)then
                call ga_error('dra_init failed: ',0)
        endif
        if (me.eq.0) print *,'  '
        if(me.eq.0)print *, 'TESTING PERFORMANCE OF DISK ARRAYS'
        if (me.eq.0) print *,' '
        call test_io_dbl()
        status = dra_terminate()
        call ga_terminate()
      else
        print *,'ma_init failed'
      endif
      if(me.eq.0)print *, 'all done ...'
      call MP_FINALIZE()
      end



      subroutine test_io_dbl
      implicit none
#include "mafdecls.fh"
#include "global.fh"
#include "dra.fh"
#include "mp3def.fh"
      integer n,m,ndim
      parameter (n=250, ndim=3)
      parameter (m = 2*n)
      double precision   err, tt0, tt1, mbytes, rmax, ravg
      integer g_a, g_b,  d_a, d_b
      double precision drand
      integer i, req, loop
      integer dlo(ndim),dhi(ndim),glo(ndim),ghi(ndim)
      integer dims(ndim),reqdims(ndim)
      integer me, nproc
      integer index, ld(ndim), chunk(ndim)
      integer iran
#if USEMULTFILES
      integer ilen
      character*80 filename, filename1
#endif
      integer util_mdtob
      logical status
      external  drand
      external util_mdtob
      intrinsic int, dble
      iran(i) = int(drand(0)*dble(i-1)) + 1
c    
      loop  = 30
      req = -1
      nproc = ga_nnodes()
      me    = ga_nodeid()
c    
      if (me.eq.0) print *, 'Creating global arrays ',n,' x',n,' x',n
      if (me.eq.0)call ffflush(6)
      call ga_sync()
      do i = 1, ndim
        dims(i) = n
        chunk(i) = 1
      end do

      if(.not. nga_create(MT_DBL, ndim, dims, 'a', chunk, g_a))
     &         call ga_error('nga_create failed: a', 0)
      if(.not. nga_create(MT_DBL, ndim, dims, 'b', chunk, g_b))
     &         call ga_error('nga_create failed: b', 0)
      if (me.eq.0) print *,'done '
      if (me.eq.0)call ffflush(6)
c
c     initialize g_a, g_b with random values
c     ... use ga_access to avoid allocating local buffers for ga_put
c
      call ga_sync()
      call nga_distribution(g_a, me, glo, ghi)
      call nga_access(g_a, glo, ghi, index, ld)
      call fill_random(DBL_MB(index), glo, ghi, ld(1), ld(2))
      call ga_sync()
*     if (me.eq.0) print *,'done '
*     if (me.eq.0)call ffflush(6)
c
      call ga_zero(g_b)
c
c
c.......................................................................
      if (me.eq.0) print *, 'creating disk array ',n,' x',n,' x',n
      if (me.eq.0)call ffflush(6)
      do i = 1, ndim
        reqdims(i) = n
      end do
#if USEMULTFILES
      ilen = len(FNAME)
      filename(1:ilen) = FNAME
      write(filename(ilen+1:ilen+1),200) me
  200 format(i1)
      if(ndra_create(MT_DBL, ndim, dims, 'A',
     &      filename, 
     &      DRA_RW, reqdims, d_a).ne.0)
     $   CALL ga_error('ndra_create failed: ',0)
#else
      if(ndra_create(MT_DBL, ndim, dims, 'A',
     &      FNAME, 
     &      DRA_RW, reqdims, d_a).ne.0)
     $   CALL ga_error('ndra_create failed: ',0)
#endif
c
      if(me.eq.0) print *, 'alligned blocking write'
      if (me.eq.0)call ffflush(6)
      tt0 = MP_TIMER()
      if(ndra_write(g_a, d_a,req).ne.0)
     $   CALL ga_error('ndra_write failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      rmax = tt1
      call ga_dgop(1,rmax,1,'max')
      mbytes = 1e-6*util_mdtob(n*n*n)
      if (me.eq.0)then
          write(6,100)mbytes,rmax,mbytes/rmax
      endif
c
      if(dra_close(d_a).ne.0)call ga_error('dra_close failed: ',d_a)
      tt1 = MP_TIMER() -tt0
      rmax = tt1
      call ga_dgop(1,rmax,1,'max')
      if (me.eq.0)then
          write(6,100)mbytes,rmax,mbytes/rmax
      endif
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'disk array closed '
      if (me.eq.0)call ffflush(6)
c.......................................................................
c
c
      if (me.eq.0) print *, 'creating disk array ',m,' x',m,' x',m
      if (me.eq.0)call ffflush(6)
      do i = 1, ndim
        dims(i) = m
        reqdims(i) = n
      end do
#ifdef USEMULTFILES
      ilen = len(FNAME1)
      filename1(1:ilen) = FNAME1
      write(filename1(ilen+1:ilen+1),200) me
      if(ndra_create(MT_DBL, ndim, dims, 'B',
     &      filename1,
     &      DRA_RW, reqdims, d_b).ne.0)
     $   CALL ga_error('ndra_create failed: ',0)
#else
      if(ndra_create(MT_DBL, ndim, dims, 'B',
     &      FNAME1,
     &      DRA_RW, reqdims, d_b).ne.0)
     $   CALL ga_error('ndra_create failed: ',0)
#endif
c
      if(me.eq.0) print *, 'non alligned blocking write'
      if (me.eq.0)call ffflush(6)
c
      do i = 1, ndim
        glo(i) = 1
        ghi(i) = n
        dlo(i) = 2
        dhi(i) = n+1
      end do
      tt0 = MP_TIMER()
      if(ndra_write_section(.false., g_a, glo, ghi,
     &               d_b, dlo, dhi, req).ne.0)
     &         call  ga_error('ndra_write_section failed:',0)

      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      rmax = tt1
      call ga_dgop(1,rmax,1,'max')
      mbytes = 1e-6*util_mdtob(n*n*n)
      if (me.eq.0)then
          write(6,100)mbytes,rmax,mbytes/rmax
      endif
c
      if(dra_close(d_b).ne.0)call ga_error('dra_close failed: ',d_b)
      tt1 = MP_TIMER() -tt0
      rmax = tt1
      call ga_dgop(1,rmax,1,'max')
      mbytes = 1e-6*util_mdtob(n*n*n)
      if (me.eq.0)then
          write(6,100)mbytes,rmax,mbytes/rmax
      endif
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'disk array closed '
      if (me.eq.0)call ffflush(6)
c.......................................................................
c
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'opening disk array'
#ifdef USEMULTFILES
      if(dra_open(filename,
     &            DRA_R, d_a).ne.0)
     &            call ga_error('dra_open failed',0)
#else
      if(dra_open(FNAME,
     &            DRA_R, d_a).ne.0)
     &            call ga_error('dra_open failed',0)
#endif
      if(me.eq.0) print *, 'alligned blocking read'
      if (me.eq.0)call ffflush(6)
      tt0 = MP_TIMER()
      if(ndra_read(g_b, d_a, req).ne.0)
     $   CALL ga_error('ndra_read failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      rmax = tt1
      call ga_dgop(1,rmax,1,'max')
      if (me.eq.0)then
          write(6,100)mbytes,rmax,mbytes/rmax
      endif
      call ga_dadd(1d0, g_a, -1d0, g_b, g_b)
      err = ga_ddot(g_b, g_b)
      if(err.ne.0) then
          if (me.eq.0) print *,'BTW, we have error =', err
cbjp          call ga_print(g_b) 
      else
          if (me.eq.0) print *,'OK'
      endif
      if(dra_delete(d_a).ne.0)
     &            call ga_error('dra_delete failed',0)
c.......................................................................
c
      if (me.eq.0) print *,' '
      if (me.eq.0) print *,'opening disk array'
#ifdef USEMULTFILES
      if(dra_open(filename1,
     &            DRA_R, d_b).ne.0)
     &            call ga_error('dra_open failed',0)
#else
      if(dra_open(FNAME1,
     &            DRA_R, d_b).ne.0)
     &            call ga_error('dra_open failed',0)
#endif
      if(me.eq.0) print *, 'non alligned blocking read'
      if (me.eq.0)call ffflush(6)
      tt0 = MP_TIMER()
      if(ndra_read_section(.false., g_b, glo, ghi,
     &               d_b, dlo, dhi, req).ne.0)
     &        call   ga_error('ndra_read_section failed:',0)
      if(dra_wait(req).ne.0) call ga_error('dra_wait failed: ' ,req)
      tt1 = MP_TIMER() -tt0
      rmax = tt1
      call ga_dgop(1,rmax,1,'max')
      if (me.eq.0)then
          write(6,100)mbytes,rmax,mbytes/rmax
      endif
      call ga_dadd(1d0, g_a, -1d0, g_b, g_b)
      err = ga_ddot(g_b, g_b)
      if(err.ne.0) then
          if (me.eq.0) print *,'BTW, we have error =', err
      else
          if (me.eq.0) print *,'OK'
      endif
      if(dra_delete(d_b).ne.0)
     &            call ga_error('dra_delete failed',0)
c.......................................................................
      status = ga_destroy(g_a)
      status = ga_destroy(g_b)
100   format(g11.2,' MB  time=',g11.2,' rate=',g11.3,'MB/s')
      end

      subroutine fill_random(a, lo, hi, ld1, ld2)
      parameter (ndim = 3)
      integer lo(ndim), hi(ndim), ld1, ld2
      double precision a(ld1,ld2,*), drand, seed1, seed2
      integer i,j,k
      external  drand
c
      do k=1, hi(3)-lo(3) + 1
        seed1 = drand(k)
        do j = 1, hi(2) - lo(2) + 1
          seed2 = seed1*j
          do i = 1, hi(1) - lo(1) + 1
            a(i,j,k)=seed2*i
          end do
        enddo
      enddo
      end

      SUBROUTINE ccsdtq_lambda2_29_2_1_1(d_a,k_a_offset,d_c,k_c_offset)
C     $Id: ccsdtq_lambda2_29_2_1_1.F 24184 2013-05-04 00:43:17Z edo $
C     This is a Fortran77 program generated by Tensor Contraction Engine v.1.0
C     Copyright (c) Battelle & Pacific Northwest National Laboratory (2002)
C     i3 ( h7 h8 h11 h12 p1 p2 p5 p9 )_y + = 1 * y ( h7 h8 h11 h12 p1 p2 p5 p9 )_y
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "sym.fh"
#include "errquit.fh"
#include "tce.fh"
      INTEGER d_a
      INTEGER k_a_offset
      INTEGER d_c
      INTEGER k_c_offset
      INTEGER NXTASK
      INTEGER next
      INTEGER nprocs
      INTEGER count
      INTEGER h7b
      INTEGER h8b
      INTEGER h11b
      INTEGER h12b
      INTEGER p1b
      INTEGER p2b
      INTEGER p5b
      INTEGER p9b
      INTEGER dimc
      INTEGER h7b_1
      INTEGER h8b_1
      INTEGER h11b_1
      INTEGER h12b_1
      INTEGER p1b_1
      INTEGER p2b_1
      INTEGER p5b_1
      INTEGER p9b_1
      INTEGER dim_common
      INTEGER dima_sort
      INTEGER dima
      INTEGER l_a_sort
      INTEGER k_a_sort
      INTEGER l_a
      INTEGER k_a
      INTEGER l_c
      INTEGER k_c
      EXTERNAL NXTASK
      nprocs = GA_NNODES()
      count = 0
      next = NXTASK(nprocs,1)
      DO h7b = 1,noab
      DO h8b = h7b,noab
      DO h11b = h8b,noab
      DO h12b = h11b,noab
      DO p1b = noab+1,noab+nvab
      DO p2b = p1b,noab+nvab
      DO p5b = noab+1,noab+nvab
      DO p9b = p5b,noab+nvab
      IF (next.eq.count) THEN
      IF ((.not.restricted).or.(int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b-1
     &)+int_mb(k_spin+h11b-1)+int_mb(k_spin+h12b-1)+int_mb(k_spin+p1b-1)
     &+int_mb(k_spin+p2b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p9b-1).ne
     &.16)) THEN
      IF (int_mb(k_spin+h7b-1)+int_mb(k_spin+h8b-1)+int_mb(k_spin+h11b-1
     &)+int_mb(k_spin+h12b-1) .eq. int_mb(k_spin+p1b-1)+int_mb(k_spin+p2
     &b-1)+int_mb(k_spin+p5b-1)+int_mb(k_spin+p9b-1)) THEN
      IF (ieor(int_mb(k_sym+h7b-1),ieor(int_mb(k_sym+h8b-1),ieor(int_mb(
     &k_sym+h11b-1),ieor(int_mb(k_sym+h12b-1),ieor(int_mb(k_sym+p1b-1),i
     &eor(int_mb(k_sym+p2b-1),ieor(int_mb(k_sym+p5b-1),int_mb(k_sym+p9b-
     &1)))))))) .eq. irrep_y) THEN
      dimc = int_mb(k_range+h7b-1) * int_mb(k_range+h8b-1) * int_mb(k_ra
     &nge+h11b-1) * int_mb(k_range+h12b-1) * int_mb(k_range+p1b-1) * int
     &_mb(k_range+p2b-1) * int_mb(k_range+p5b-1) * int_mb(k_range+p9b-1)
      CALL TCE_RESTRICTED_8(h7b,h8b,h11b,h12b,p1b,p2b,p5b,p9b,h7b_1,h8b_
     &1,h11b_1,h12b_1,p1b_1,p2b_1,p5b_1,p9b_1)
      dim_common = 1
      dima_sort = int_mb(k_range+h7b-1) * int_mb(k_range+h8b-1) * int_mb
     &(k_range+h11b-1) * int_mb(k_range+h12b-1) * int_mb(k_range+p1b-1) 
     &* int_mb(k_range+p2b-1) * int_mb(k_range+p5b-1) * int_mb(k_range+p
     &9b-1)
      dima = dim_common * dima_sort
      IF (dima .gt. 0) THEN
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a_sort,k_a_sort)) CALL
     & ERRQUIT('ccsdtq_lambda2_29_2_1_1',0,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dima,'noname',l_a,k_a)) CALL ERRQUIT('
     &ccsdtq_lambda2_29_2_1_1',1,MA_ERR)
      IF ((p9b .lt. p1b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p1b_1 - noab - 1 + nvab * (p9b_1 - noab - 1 
     &+ nvab * (p5b_1 - noab - 1 + nvab * (h12b_1 - 1 + noab * (h11b_1 -
     & 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p9b-1),int_mb(k_range+p1b-
     &1),int_mb(k_range+p2b-1),6,5,8,7,4,3,2,1,1.0d0)
      END IF
      IF ((p5b .lt. p1b) .and. (p1b .le. p9b) .and. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p9b_1 - noab - 1 + nvab * (p1b_1 - noab - 1 
     &+ nvab * (p5b_1 - noab - 1 + nvab * (h12b_1 - 1 + noab * (h11b_1 -
     & 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p2b-1),7,5,8,6,4,3,2,1,-1.0d0)
      END IF
      IF ((p5b .lt. p1b) .and. (p2b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p9b_1
     & - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p1b_1 - noab - 1 
     &+ nvab * (p5b_1 - noab - 1 + nvab * (h12b_1 - 1 + noab * (h11b_1 -
     & 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p5b-1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p9b-1),8,5,7,6,4,3,2,1,1.0d0)
      END IF
      IF ((p1b .le. p5b) .and. (p9b .lt. p2b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p2b_1
     & - noab - 1 + nvab * (p9b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 
     &+ nvab * (p1b_1 - noab - 1 + nvab * (h12b_1 - 1 + noab * (h11b_1 -
     & 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p9b-
     &1),int_mb(k_range+p2b-1),7,6,8,5,4,3,2,1,1.0d0)
      END IF
      IF ((p1b .le. p5b) .and. (p5b .lt. p2b) .and. (p2b .le. p9b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p9b_1
     & - noab - 1 + nvab * (p2b_1 - noab - 1 + nvab * (p5b_1 - noab - 1 
     &+ nvab * (p1b_1 - noab - 1 + nvab * (h12b_1 - 1 + noab * (h11b_1 -
     & 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p5b-1),int_mb(k_range+p2b-
     &1),int_mb(k_range+p9b-1),8,6,7,5,4,3,2,1,-1.0d0)
      END IF
      IF ((p2b .le. p5b)) THEN
      CALL GET_HASH_BLOCK(d_a,dbl_mb(k_a),dima,int_mb(k_a_offset),(p9b_1
     & - noab - 1 + nvab * (p5b_1 - noab - 1 + nvab * (p2b_1 - noab - 1 
     &+ nvab * (p1b_1 - noab - 1 + nvab * (h12b_1 - 1 + noab * (h11b_1 -
     & 1 + noab * (h8b_1 - 1 + noab * (h7b_1 - 1)))))))))
      CALL TCE_SORT_8(dbl_mb(k_a),dbl_mb(k_a_sort),int_mb(k_range+h7b-1)
     &,int_mb(k_range+h8b-1),int_mb(k_range+h11b-1),int_mb(k_range+h12b-
     &1),int_mb(k_range+p1b-1),int_mb(k_range+p2b-1),int_mb(k_range+p5b-
     &1),int_mb(k_range+p9b-1),8,7,6,5,4,3,2,1,1.0d0)
      END IF
      IF (.not.MA_POP_STACK(l_a)) CALL ERRQUIT('ccsdtq_lambda2_29_2_1_1'
     &,2,MA_ERR)
      IF (.not.MA_PUSH_GET(mt_dbl,dimc,'noname',l_c,k_c)) CALL ERRQUIT('
     &ccsdtq_lambda2_29_2_1_1',3,MA_ERR)
      CALL TCE_SORT_8(dbl_mb(k_a_sort),dbl_mb(k_c),int_mb(k_range+p9b-1)
     &,int_mb(k_range+p5b-1),int_mb(k_range+p2b-1),int_mb(k_range+p1b-1)
     &,int_mb(k_range+h12b-1),int_mb(k_range+h11b-1),int_mb(k_range+h8b-
     &1),int_mb(k_range+h7b-1),8,7,6,5,4,3,2,1,1.0d0)
      CALL ADD_HASH_BLOCK(d_c,dbl_mb(k_c),dimc,int_mb(k_c_offset),(p9b -
     & noab - 1 + nvab * (p5b - noab - 1 + nvab * (p2b - noab - 1 + nvab
     & * (p1b - noab - 1 + nvab * (h12b - 1 + noab * (h11b - 1 + noab * 
     &(h8b - 1 + noab * (h7b - 1)))))))))
      IF (.not.MA_POP_STACK(l_c)) CALL ERRQUIT('ccsdtq_lambda2_29_2_1_1'
     &,4,MA_ERR)
      IF (.not.MA_POP_STACK(l_a_sort)) CALL ERRQUIT('ccsdtq_lambda2_29_2
     &_1_1',5,MA_ERR)
      END IF
      END IF
      END IF
      END IF
      next = NXTASK(nprocs,1)
      END IF
      count = count + 1
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      END DO
      next = NXTASK(-nprocs,1)
      call GA_SYNC()
      RETURN
      END

      subroutine argos_pme_flag(iflag,icolor,inode)
c
      implicit none
c
#include "argos_pme_common.fh"
c
      integer iflag,icolor,inode
      integer il,ih,jl,jh,node,icolr
c
c     set flag iflag on node inode to color icolor:
c
c     icolor>=0 set flag to icolor
c     icolor<0  accumulate iabs(icolor) to flag
c
c     inode>=0  set/accumulate flag on node inode
c     inode<0   set/accumulate flag on all nodes
c
      icolr=iabs(icolor)
c
      if(inode.lt.0) then
      do 1 node=0,np-1
      call ga_distribution(ga_flg,node,il,ih,jl,jh)
      if(icolor.ge.0) then
      call ga_put(ga_flg,il,ih,jl+iflag,jl+iflag,icolr,1)
      else
      call ga_acc(ga_flg,il,ih,jl+iflag,jl+iflag,icolr,1,1)
      endif
    1 continue
      else
c
c     set flag on single node
c
      call ga_distribution(ga_flg,inode,il,ih,jl,jh)
      if(icolor.ge.0) then
      call ga_put(ga_flg,il,ih,jl+iflag,jl+iflag,icolr,1)
      else
      call ga_acc(ga_flg,il,ih,jl+iflag,jl+iflag,icolr,1,1)
      endif
      endif
c
      return
      end
c $Id: argos_pme_flag.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine dk_input(rtdb)
*
* $Id: dk_input.F 19696 2010-10-29 16:53:42Z d3y133 $
*
      implicit none
#include "rtdb.fh"
#include "context.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "inp.fh"
#include "stdio.fh"
#include "rel_consts.fh"
#include "util.fh"
#include "errquit.fh"
c     
c     Read input for calculations with Douglas-Kroll
c     
c     All input is of the form:
c     <keyword>                    or   
c     <keyword> <on||off>          or
c     <keyword> <fpp||dkh||dkfull> or a combination of the last two
c     
      integer rtdb ! [input] handle to database
c    
      character*255 test
      logical dk_run
      integer dk_type
c
c     Read input data beyond douglas-kroll; store in rtdb.
c     
      dk_run  = .true.
      dk_type = 2
c
  10  if (inp_a(test)) then
         if (inp_compare(.false., 'off', test)) then
            dk_run = .false.
         elseif (inp_compare(.false., 'on', test)) then
            dk_run  = .true.
         elseif (inp_compare(.false.,'fpp',test)) then
            dk_type = 1
         elseif (inp_compare(.false.,'dkh',test)) then
            dk_type = 2
         elseif (inp_compare(.false.,'dkfull',test)) then
            dk_type = 3
         elseif (inp_compare(.false.,'dk1',test)) then
            dk_type = 1
         elseif (inp_compare(.false.,'dk1full',test)) then
            dk_type = 1
         elseif (inp_compare(.false.,'dk2',test)) then
            dk_type = 2
         elseif (inp_compare(.false.,'dk2full',test)) then
            dk_type = 3
         elseif (inp_compare(.false.,'dk3',test)) then
            dk_type = 4
         elseif (inp_compare(.false.,'dk3full',test)) then
            dk_type = 5
         elseif (inp_compare(.false.,'resc',test)) then
            dk_type = 0
         else
            call errquit('dk_input: unknown directive',0, UNKNOWN_ERR)
         endif
         goto 10
      endif
c
c     If we are going to do Douglas-Kroll, write out a line informing user.
c
      if ((ga_nodeid() .eq. 0) .and .dk_run .and. 
     $     util_print('douglas-kroll', print_low)) then
         write(luout,20)
  20     format(/'Douglas-Kroll integrals are switched on !')
         if (dk_type .eq. 1) then
            write(luout,21)
  21        format(/'Integrals for the no-pair equation with ',
     $             'free-particle projection operators'/
     $             'will be computed.'/)
         elseif (dk_type .eq. 2) then
            write(luout,22)
  22        format(/'Integrals for the no-pair equation with ',
     $             'external-field projection operators'/
     $             'will be computed (Douglas-Kroll-Hess).'/)
         elseif (dk_type .eq. 3) then
            write(luout,23)
  23        format(/'Integrals for the no-pair equation with ',
     $             'external-field projection operators'/,
     $             'including cross-product terms will be computed.'/)
         elseif (dk_type .eq. 4) then
            write(luout,24)
  24        format(/'Integrals for the no-pair equation with '/
     $             'Douglas-Kroll Hamiltonian ',
     $             'correct to third order in the external potential'/
     $             'will be computed (3rd-order Douglas-Kroll).'/)
         elseif (dk_type .eq. 5) then
            write(luout,25)
  25        format(/'Integrals for the no-pair equation with '/
     $             'Douglas-Kroll Hamiltonian ',
     $             'correct to third order in the external potential'/
     $             'including cross-product terms will be computed.'/)
         elseif (dk_type .eq. 0) then
            write(luout,200)
 200        format(/'Integrals for the relativistic scheme by ',
     $             'eliminating small-components of the Dirac equation'/
     $             'will be computed (RESC).'/)
         endif
      endif
c
c     Put parameters in rtdb
c       
      if (.not. rtdb_put(rtdb, 'doug_kroll', mt_log, 1, dk_run))
     $   call errquit('dk_input: rtdb_put failed', 0, RTDB_ERR)
      if (.not. rtdb_put(rtdb, 'doug_kroll:type', mt_int, 1, dk_type))
     $   call errquit('dk_input: rtdb_put failed', 0, RTDB_ERR)
c
      return
c       
      end

C> \ingroup nwint
C> @{
C>
C> \brief Compute 2-electron 3-center Gaussian periodic electron
C> repulsion integral derivatives
C>
C> The code in question always uses density fitting approaches for
C> the 3-center 2-electron integrals are needed. See [1] for details.
C>
C> [1] JE Jaffe, AC Hess,
C>     <i>"Gaussian basis density functional theory for systems
C>     periodic in two or three dimensions: Energy and forces"</i>,
C>    J.Chem.Phys. <b>105</b>, 10983-10998 (1996), DOI:
C>    <a href="http://dx.doi.org/10.1063/1.472866">
C>    10.1063/1.472866</a>
C>
      subroutine intpd_2e3c(brain, ish, ketin, jsh, ksh, Ri, Rj, 
     &       lscr, scr, leri, eri, idatom)
*
* $Id: intpd_2e3c.F 23398 2013-01-08 08:18:46Z d3y133 $
*
      implicit none
c
c basic api routine to generate a block of 3 center two 
c  electron integral derivatives
c
c eri = <bra_g(ish)|ket_g(jsh).ket_g(ksh),3=xyz,3=atoms>
c
#include "apiP.fh"
#include "errquit.fh"
#include "bas.fh"
#include "nwc_const.fh"
#include "basP.fh"
#include "basdeclsP.fh"
#include "geomP.fh"
#include "geobasmapP.fh"
#include "stdio.fh"
#include "mafdecls.fh"
#include "bas_exndcf_dec.fh"
#include "bas_ibs_dec.fh"
#include "int_nbf.fh"
c
c::external subroutines used
c errquit
c::functions
      logical cando_nw
      logical int_chk_sh
      logical int_chk_init
      integer int_nint_cart
      external cando_nw
      external int_chk_sh
      external int_chk_init
      external int_nint_cart
c:: passed
      integer brain  !< [Input] basis set handle for bra function
      integer ketin  !< [Input] basis set handle for ket function
      integer ish    !< [Input] lexical contraction/shell index
      integer jsh    !< [Input] lexical contraction/shell index
      integer ksh    !< [Input] lexical contraction/shell index
      integer lscr   !< [Input] length of scratch array
      integer leri   !< [Input] length of ERI array
      integer idatom(4) !< [Output] atom index of derivatives
      double precision scr(lscr) !< [Scratch] scratch array 
      double precision eri(leri) !< [Output] ERI array
c translation vectors are in fractional coordinates !
      double precision Ri(3)  !< [Input] translation vector for ish center 
      double precision Rj(3)  !< [Input] translation vector for jsh center 
c:: local
      logical any_spherical
      logical shells_ok
      integer bra, ket 
      integer p_geom, cd_geom, ucont
      integer Lp, p_prim, p_gen, p_iexp, p_icfp, p_cent
      integer Lc, c_prim, c_gen, c_iexp, c_icfp, c_cent
      integer Ld, d_prim, d_gen, d_iexp, d_icfp, d_cent
      integer mynint
*      integer nintx
      double precision xyz_new_i(3)  ! new coordinates for ish function
      double precision xyz_new_j(3)  ! new coordinates for jsh function
c
      integer WarnP
      save WarnP
      data WarnP /0/
c
#include "bas_exndcf_sfn.fh"
#include "bas_ibs_sfn.fh"
c
c check initialization
c
      if (.not.int_chk_init('intpd_2e3c'))
     &       call errquit('intpd_2e3c: int_init was not called' ,0,
     &           INT_ERR)
c
c     check input shell ranges
c
      shells_ok = int_chk_sh(brain,ish)
      shells_ok = shells_ok .and. int_chk_sh(ketin,jsh)
      shells_ok = shells_ok .and. int_chk_sh(ketin,ksh)
      if (.not.shells_ok)
     &       call errquit('intpd_2e3c: invalid contraction/shell',0,
     &         BASIS_ERR)
c
c  check if gencon/sp shell
c
      call int_nogencont_check(brain,'intpd_2e3c:bra')
      call int_nogencont_check(ketin,'intpd_2e3c:ket')
      call int_nospshell_check(brain,'intpd_2e3c:bra')
      call int_nospshell_check(ketin,'intpd_2e3c:ket')
c
c     define center information required 
c
      bra = brain + BASIS_HANDLE_OFFSET
      ket = ketin + BASIS_HANDLE_OFFSET
      p_geom  = ibs_geom(bra)
      cd_geom = ibs_geom(ket)
c
      if (p_geom.ne.cd_geom.and.WarnP.eq.0) then
        write(luout,*)
     &      'intpd_2e3c: WARNING: possible geometry inconsistency'
        write(luout,*)'bra geometry handle:',p_geom
        write(luout,*)'ket geometry handle:',cd_geom
        WarnP = 1
      endif
c
      p_cent  = (sf_ibs_cn2ce(ish,bra))
      c_cent  = (sf_ibs_cn2ce(jsh,ket))
      d_cent  = (sf_ibs_cn2ce(ksh,ket))
      mynint = int_nint_cart(brain,ish,ketin,jsh,ketin,ksh,0,0)
      if (p_cent.eq.c_cent.and.c_cent.eq.d_cent) then
        call dcopy((mynint*3*4),0.0d00,0,eri,1)
        call ifill(4,-1,idatom,1)
        return
      endif
      if (mynint*3*4.gt.leri) then
        write(luout,*) 'nint*3*4 = ',mynint*3*4
        write(luout,*) 'leri     = ',leri
        call errquit('intpd_2e3c: nint>leri error',911, INT_ERR)
      endif
c.. translate ish center coordinates based on Ri
      call intp_txyz(p_cent,p_geom,Ri,xyz_new_i)
c.. translate jsh center coordinates based on Rj
      call intp_txyz(c_cent,cd_geom,Rj,xyz_new_j)
c
      if(cando_nw(brain,ish,0).and.cando_nw(ketin,jsh,ksh)) then
c
        any_spherical = bas_spherical(bra).or.bas_spherical(ket)
c
        ucont   = (sf_ibs_cn2ucn(ish,bra))
        Lp      = infbs_cont(CONT_TYPE ,ucont,bra)
        p_prim  = infbs_cont(CONT_NPRIM,ucont,bra)
        p_gen   = infbs_cont(CONT_NGEN ,ucont,bra)
        p_iexp  = infbs_cont(CONT_IEXP ,ucont,bra)
        p_icfp  = infbs_cont(CONT_ICFP ,ucont,bra)
c
        ucont   = (sf_ibs_cn2ucn(jsh,ket))
        Lc      = infbs_cont(CONT_TYPE ,ucont,ket)
        c_prim  = infbs_cont(CONT_NPRIM,ucont,ket)
        c_gen   = infbs_cont(CONT_NGEN ,ucont,ket)
        c_iexp  = infbs_cont(CONT_IEXP ,ucont,ket)
        c_icfp  = infbs_cont(CONT_ICFP ,ucont,ket)
c
        ucont   = (sf_ibs_cn2ucn(ksh,ket))
        Ld      = infbs_cont(CONT_TYPE ,ucont,ket)
        d_prim  = infbs_cont(CONT_NPRIM,ucont,ket)
        d_gen   = infbs_cont(CONT_NGEN ,ucont,ket)
        d_iexp  = infbs_cont(CONT_IEXP ,ucont,ket)
        d_icfp  = infbs_cont(CONT_ICFP ,ucont,ket)
c      
        call hf2d(
     &      xyz_new_i, dbl_mb(mb_exndcf(p_iexp,bra)),
     &      dbl_mb(mb_exndcf(p_icfp,bra)), p_prim, p_gen, Lp,
     &      p_cent,
     &      xyz_new_i, DCexp,
     &      DCcoeff           ,      1,     1, 0, p_cent,
     &      xyz_new_j, dbl_mb(mb_exndcf(c_iexp,ket)),
     &      dbl_mb(mb_exndcf(c_icfp,ket)), c_prim, c_gen, Lc, c_cent,
     &      coords(1,d_cent,cd_geom), dbl_mb(mb_exndcf(d_iexp,ket)),
     &      dbl_mb(mb_exndcf(d_icfp,ket)), d_prim,d_gen,Ld,d_cent,
c...................... canAB    canCD    canPQ
     &      eri, mynint, .false., .false., .false.,
c........... dryrun
     &      .false., scr, lscr)
c
        call intd_sum(eri,mynint,idatom,p_cent,p_cent,c_cent,d_cent)
*
        if (any_spherical) then
          call intd_2ec2s(eri,mynint,scr,lscr,
     &        Lp,0,Lc,Ld,p_gen,1,c_gen,d_gen,
     &        bas_spherical(bra),bas_spherical(ket),idatom)
        endif
      else
        write(luout,*)'intpd_2e3c: could not do nw integrals'
        write(luout,*)' brain :',brain
        write(luout,*)' ketin :',ketin
        write(luout,*)' ish   :',ish
        write(luout,*)' jsh   :',jsh
        write(luout,*)' ksh   :',ksh
        call errquit('intpd_2e3c: fatal error ',0, INT_ERR)
      endif
      end
C> @}

c
c
c auxiliary active-type logical functions
c acolo and acolo_o 
c
      LOGICAL FUNCTION ACOLO(p4b,p5b,p6b,h1b,h2b,h3b)
      IMPLICIT NONE
#include "global.fh"
#include "mafdecls.fh"
#include "util.fh"
#include "errquit.fh"
#include "tce.fh"
#include "tce_main.fh"
      INTEGER p4b
      INTEGER p5b
      INTEGER p6b
      INTEGER h1b
      INTEGER h2b
      INTEGER h3b
      INTEGER iocc
      INTEGER ivirt
      acolo = .false.
      iocc=int_mb(k_active+h1b-1)+int_mb(k_active+h2b-1)+ 
     &     int_mb(k_active+h3b-1)
      ivirt=int_mb(k_active+p4b-1)+int_mb(k_active+p5b-1)+
     &     int_mb(k_active+p6b-1) 
      if(iocc.ge.numact.and.ivirt.ge.numact) acolo=.true. 
      RETURN
      END
c $Id: acolo.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_hdrtim()
c
      implicit none
c
#include "argos.fh"
c
      write(lfntim,1200) np,56
 1200 format(2i5)
      write(lfntim,1201)
      write(lfntim,1202)
      write(lfntim,1203)
      write(lfntim,1204)
      write(lfntim,1205)
      write(lfntim,1206)
      write(lfntim,1207)
      write(lfntim,1208)
      write(lfntim,1209)
      write(lfntim,1210)
      write(lfntim,1211)
      write(lfntim,1212)
      write(lfntim,1213)
      write(lfntim,1214)
      write(lfntim,1215)
      write(lfntim,1216)
      write(lfntim,1217)
      write(lfntim,1218)
      write(lfntim,1219)
      write(lfntim,1220)
      write(lfntim,1221)
      write(lfntim,1222)
      write(lfntim,1223)
      write(lfntim,1224)
      write(lfntim,1225)
      write(lfntim,1226)
      write(lfntim,1227)
      write(lfntim,1228)
      write(lfntim,1229)
      write(lfntim,1230)
      write(lfntim,1231)
      write(lfntim,1232)
      write(lfntim,1233)
      write(lfntim,1234)
      write(lfntim,1235)
      write(lfntim,1236)
      write(lfntim,1237)
      write(lfntim,1238)
      write(lfntim,1239)
      write(lfntim,1240)
      write(lfntim,1241)
      write(lfntim,1242)
      write(lfntim,1243)
      write(lfntim,1244)
      write(lfntim,1245)
      write(lfntim,1246)
      write(lfntim,1247)
      write(lfntim,1248)
      write(lfntim,1249)
      write(lfntim,1250)
      write(lfntim,1251)
      write(lfntim,1252)
      write(lfntim,1253)
      write(lfntim,1254)
      write(lfntim,1255)
      write(lfntim,1256)
 1201 format('  1 : Initialization velocities')
 1202 format('  2 : Periodic Boundary Conditions')
 1203 format('  3 : Dynamic Load Balancing')
 1204 format('  4 : Atom Redistribution')
 1205 format('  5 : Center of Mass Coordinates')
 1206 format('  6 : Recording Trajectory')
 1207 format('  7 : CAFE Initialization')
 1208 format('  8 : QMD Forces Evaluation')
 1209 format('  9 : Synchronization')
 1210 format(' 10 : SPACE Initialization')
 1211 format(' 11 : Synchronization')
 1212 format(' 12 : Collapse Option')
 1213 format(' 13 : External Fields')
 1214 format(' 14 : Multiprocs Data Initialization')
 1215 format(' 15 : Multiprocs Data Communication')
 1216 format(' 16 : Multiprocs Data Forces Evaluation')
 1217 format(' 17 : Restraints Data Initialization')
 1218 format(' 18 : Restraints Data Communication')
 1219 format(' 19 : Restraints Data Forces Evaluation')
 1220 format(' 20 : PMF Data Initialization')
 1221 format(' 21 : PMF Data Communication')
 1222 format(' 22 : PMF Data Forces Evaluation')
 1223 format(' 23 : Induced Dipoles Evaluation')
 1224 format(' 24 : PME Initialization')
 1225 format(' 25 : PME Charge Grid Evaluation')
 1226 format(' 26 : PME Charge Grid Communication')
 1227 format(' 27 : PME Charge Grid Retrieval')
 1228 format(' 28 : PME Reverse 3D-pFFT')
 1229 format(' 29 : PME Energy Evaluation')
 1230 format(' 30 : PME Synchronization')
 1231 format(' 31 : PME Forward 3D-pFFT')
 1232 format(' 32 : PME Synchronization')
 1233 format(' 33 : Local Coordinates Retrieval')
 1234 format(' 34 : Local Forces Evaluation')
 1235 format(' 35 : Local Force Accumulation')
 1236 format(' 36 : Non-Local Coordinates Retrieval')
 1237 format(' 37 : Non-Local Forces Evaluation')
 1238 format(' 38 : Non-Local Force Accumulation')
 1239 format(' 39 : PME Wait')
 1240 format(' 40 : PME Forces Evaluation')
 1241 format(' 41 : PME Forces Communication')
 1242 format(' 42 : PME Node Synchronization')
 1243 format(' 43 : PME Flag')
 1244 format(' 44 : Synchronization')
 1245 format(' 45 : SPACE Finalization')
 1246 format(' 46 : QM/MM Forces Evaluation')
 1247 format(' 47 : Forces Normalization')
 1248 format(' 48 : Guided MD Forces')
 1249 format(' 49 : MD Time Step')
 1250 format(' 50 : SHAKE')
 1251 format(' 51 : CAFE Finalization')
 1252 format(' 52 : Center of Mass Motion Removal')
 1253 format(' 53 : SPACE Update')
 1254 format(' 54 : Property Evaluation')
 1255 format(' 55 : Restart File Update')
 1256 format(' 56 : TOTAL TIME PER STEP')
c
      return
      end
c $Id: argos_hdrtim.F 21176 2011-10-10 06:35:49Z d3y133 $

      subroutine argos_space_unpackw(numwm,iwl,iwlp)
c
      implicit none
c
#include "argos_space_common.fh"
#include "global.fh"
#include "msgids.fh"
#include "bitops.fh"
c
      integer numwm,iwl(mwm,miw2),iwlp(mwm,npackw)
c
      integer i,j,k,ipck
c
      ipck=miw2+1
      do 1 j=npackw,1,-1
      do 2 k=ipackw(j),1,-1
      ipck=ipck-1
      do 3 i=1,numwm
      iwl(i,ipck)=iand(iwlp(i,j),miwl(ipck))
      iwlp(i,j)=rshift(iwlp(i,j)-iwl(i,ipck),nbitw(ipck))
    3 continue
    2 continue
    1 continue
c
      return
      end
c $Id: argos_space_unpackw.F 21176 2011-10-10 06:35:49Z d3y133 $

      logical function esp(irtdb0)
c
c $Id: esp.F 25368 2014-03-21 06:10:42Z niri $
c
      implicit none
c
#include "esp_params.fh"
#include "esp_common.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "inp.fh"
#include "util.fh"
#include "stdio.fh"
c
      integer irtdb0
c
      call util_print_push
      call util_print_rtdb_load(irtdb,'esp')
c
c     me : number current node
c     np : number of nodes
c
      me=ga_nodeid()
      np=ga_nnodes()
      irtdb=irtdb0
c      lfnout=6
      lfnout=luout
      lfngrd=24
      lfner=25
      lfnplt=26
      lfnxyz=27
      lfnchg=28
c
c     read input from rtdb
c
      call esp_rtdbin
c
      if(util_print('output',print_medium)) then
      if(me.eq.0) then
      if(util_print('information',print_default)) then
      write(lfnout,*)
      write(lfnout,*)
      call util_print_centered(6,
     + 'NWChem Electrostatic Potential Fit Module',40,.true.)
      write(lfnout,*)
      write(lfnout,*)
      endif
      call ecce_print_module_entry('nwesp')
      endif
      endif
c
c     allocate memory
c
      call esp_malloc
c
c     setup the esp grid
c
      call esp_grid(dbl_mb(ixptr),dbl_mb(iqptr),dbl_mb(igptr),
     + dbl_mb(ivptr))
c
c     write input variables to output     
c
      call esp_wrtinp(dbl_mb(iqptr))
c
c     calculate the electrostatic potential on the grid
c
      if(newgrd.ne.0.or.denmat.ne.0) then 
         call esp_esp(dbl_mb(ieptr),  !ene
     +                dbl_mb(ioptr),  !occ 
     +                dbl_mb(idptr),  !dns
     +                dbl_mb(ixptr),  !x
     +                dbl_mb(iqptr),  !q
     +                dbl_mb(igptr),  !grid
     +                dbl_mb(ivptr))  !val
      end if ! newgrd, denmat
c
c     do the fitting
c
      call esp_fit(dbl_mb(igptr),dbl_mb(ivptr),dbl_mb(ixptr),
     + dbl_mb(iqptr),dbl_mb(iaptr),dbl_mb(ibptr),dbl_mb(icptr),
     + dbl_mb(iakptr),dbl_mb(iqkptr),int_mb(inptr),dbl_mb(iqfptr),
     + int_mb(ilptr),byte_mb(itptr))
c
c     calculate the electrical moments
c
      call esp_elemom(dbl_mb(ixptr),dbl_mb(iqfptr))
c
c     calculate rms deviation
c
      call esp_rms(dbl_mb(ixptr),dbl_mb(iqfptr),dbl_mb(igptr),
     + dbl_mb(ivptr))
c
c     write results
c
      call esp_out(byte_mb(itptr),dbl_mb(ixptr),dbl_mb(iqfptr),
     + dbl_mb(igptr),dbl_mb(ivptr))
c
c     electrostatic potential from partial charges on full grid
c
      call esp_plt(dbl_mb(ixptr),dbl_mb(iqfptr),dbl_mb(igptr),
     + byte_mb(itptr))
c
c     deallocate memory
c
      call esp_dalloc
c
      call util_print_pop
c
      esp=.true.
      return
      end

      SUBROUTINE vib_PRNTPD(A,NAD,M,IOUT2)
* $Id: vib_prntpd.F 25381 2014-03-26 02:59:30Z bylaska $
      IMPLICIT none ! REAL*8 (A-H,O-Z)
C
      integer nad, m, iout2
      double precision A(NAD)
c
      integer i, j, i1, i2
      integer iout, ii, jj, kk, nn, mm, ll
c
      CHARACTER*5 LINE
      DATA LINE /'-----'/
    1 FORMAT(3X,10(8X,I5))
    2 FORMAT(2X,21A6)
    3 FORMAT(2X,I3,2X,10(1PD13.5))
    4 FORMAT(/)
      IOUT=IOUT2
      IF (IOUT .EQ. 0) IOUT=6
      II=0
      JJ=0
  200 II=II+1
      JJ=JJ+1
      KK=10*JJ
      NN=KK*(KK+1)/2
      MM=M
      IF(M.GT.KK) MM=KK
      LL=2*(MM-II+1)+1
      WRITE(IOUT,1) (I,I=II,MM)
      WRITE(IOUT,2) LINE,LINE,LINE,LINE,LINE
      DO 101 I=II,M
         I1=II+I*(I-1)/2
         I2=I*(I+1)/2
         IF(I2.GT.NN) I2=I1+9
         WRITE(IOUT,3) I,(A(J),J=I1,I2)
  101 CONTINUE
      IF(M.LE.KK) GO TO 201
      WRITE(IOUT,4)
      II=KK
      GO TO 200
  201 RETURN
      END

*> \brief \b DLATRD reduces the first nb rows and columns of a symmetric/Hermitian matrix A to real tridiagonal form by an orthogonal similarity transformation.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download DLATRD + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dlatrd.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dlatrd.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dlatrd.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE DLATRD( UPLO, N, NB, A, LDA, E, TAU, W, LDW )
* 
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            LDA, LDW, N, NB
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), E( * ), TAU( * ), W( LDW, * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DLATRD reduces NB rows and columns of a real symmetric matrix A to
*> symmetric tridiagonal form by an orthogonal similarity
*> transformation Q**T * A * Q, and returns the matrices V and W which are
*> needed to apply the transformation to the unreduced part of A.
*>
*> If UPLO = 'U', DLATRD reduces the last NB rows and columns of a
*> matrix, of which the upper triangle is supplied;
*> if UPLO = 'L', DLATRD reduces the first NB rows and columns of a
*> matrix, of which the lower triangle is supplied.
*>
*> This is an auxiliary routine called by DSYTRD.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          Specifies whether the upper or lower triangular part of the
*>          symmetric matrix A is stored:
*>          = 'U': Upper triangular
*>          = 'L': Lower triangular
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.
*> \endverbatim
*>
*> \param[in] NB
*> \verbatim
*>          NB is INTEGER
*>          The number of rows and columns to be reduced.
*> \endverbatim
*>
*> \param[in,out] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*>          n-by-n upper triangular part of A contains the upper
*>          triangular part of the matrix A, and the strictly lower
*>          triangular part of A is not referenced.  If UPLO = 'L', the
*>          leading n-by-n lower triangular part of A contains the lower
*>          triangular part of the matrix A, and the strictly upper
*>          triangular part of A is not referenced.
*>          On exit:
*>          if UPLO = 'U', the last NB columns have been reduced to
*>            tridiagonal form, with the diagonal elements overwriting
*>            the diagonal elements of A; the elements above the diagonal
*>            with the array TAU, represent the orthogonal matrix Q as a
*>            product of elementary reflectors;
*>          if UPLO = 'L', the first NB columns have been reduced to
*>            tridiagonal form, with the diagonal elements overwriting
*>            the diagonal elements of A; the elements below the diagonal
*>            with the array TAU, represent the  orthogonal matrix Q as a
*>            product of elementary reflectors.
*>          See Further Details.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= (1,N).
*> \endverbatim
*>
*> \param[out] E
*> \verbatim
*>          E is DOUBLE PRECISION array, dimension (N-1)
*>          If UPLO = 'U', E(n-nb:n-1) contains the superdiagonal
*>          elements of the last NB columns of the reduced matrix;
*>          if UPLO = 'L', E(1:nb) contains the subdiagonal elements of
*>          the first NB columns of the reduced matrix.
*> \endverbatim
*>
*> \param[out] TAU
*> \verbatim
*>          TAU is DOUBLE PRECISION array, dimension (N-1)
*>          The scalar factors of the elementary reflectors, stored in
*>          TAU(n-nb:n-1) if UPLO = 'U', and in TAU(1:nb) if UPLO = 'L'.
*>          See Further Details.
*> \endverbatim
*>
*> \param[out] W
*> \verbatim
*>          W is DOUBLE PRECISION array, dimension (LDW,NB)
*>          The n-by-nb matrix W required to update the unreduced part
*>          of A.
*> \endverbatim
*>
*> \param[in] LDW
*> \verbatim
*>          LDW is INTEGER
*>          The leading dimension of the array W. LDW >= max(1,N).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup doubleOTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  If UPLO = 'U', the matrix Q is represented as a product of elementary
*>  reflectors
*>
*>     Q = H(n) H(n-1) . . . H(n-nb+1).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**T
*>
*>  where tau is a real scalar, and v is a real vector with
*>  v(i:n) = 0 and v(i-1) = 1; v(1:i-1) is stored on exit in A(1:i-1,i),
*>  and tau in TAU(i-1).
*>
*>  If UPLO = 'L', the matrix Q is represented as a product of elementary
*>  reflectors
*>
*>     Q = H(1) H(2) . . . H(nb).
*>
*>  Each H(i) has the form
*>
*>     H(i) = I - tau * v * v**T
*>
*>  where tau is a real scalar, and v is a real vector with
*>  v(1:i) = 0 and v(i+1) = 1; v(i+1:n) is stored on exit in A(i+1:n,i),
*>  and tau in TAU(i).
*>
*>  The elements of the vectors v together form the n-by-nb matrix V
*>  which is needed, with W, to apply the transformation to the unreduced
*>  part of the matrix, using a symmetric rank-2k update of the form:
*>  A := A - V*W**T - W*V**T.
*>
*>  The contents of A on exit are illustrated by the following examples
*>  with n = 5 and nb = 2:
*>
*>  if UPLO = 'U':                       if UPLO = 'L':
*>
*>    (  a   a   a   v4  v5 )              (  d                  )
*>    (      a   a   v4  v5 )              (  1   d              )
*>    (          a   1   v5 )              (  v1  1   a          )
*>    (              d   1  )              (  v1  v2  a   a      )
*>    (                  d  )              (  v1  v2  a   a   a  )
*>
*>  where d denotes a diagonal element of the reduced matrix, a denotes
*>  an element of the original matrix that is unchanged, and vi denotes
*>  an element of the vector defining H(i).
*> \endverbatim
*>
*  =====================================================================
      SUBROUTINE DLATRD( UPLO, N, NB, A, LDA, E, TAU, W, LDW )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            LDA, LDW, N, NB
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), E( * ), TAU( * ), W( LDW, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, HALF
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, HALF = 0.5D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IW
      DOUBLE PRECISION   ALPHA
*     ..
*     .. External Subroutines ..
      EXTERNAL           DAXPY, DGEMV, DLARFG, DSCAL, DSYMV
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DDOT
      EXTERNAL           LSAME, DDOT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
      IF( LSAME( UPLO, 'U' ) ) THEN
*
*        Reduce last NB columns of upper triangle
*
         DO 10 I = N, N - NB + 1, -1
            IW = I - N + NB
            IF( I.LT.N ) THEN
*
*              Update A(1:i,i)
*
               CALL DGEMV( 'No transpose', I, N-I, -ONE, A( 1, I+1 ),
     $                     LDA, W( I, IW+1 ), LDW, ONE, A( 1, I ), 1 )
               CALL DGEMV( 'No transpose', I, N-I, -ONE, W( 1, IW+1 ),
     $                     LDW, A( I, I+1 ), LDA, ONE, A( 1, I ), 1 )
            END IF
            IF( I.GT.1 ) THEN
*
*              Generate elementary reflector H(i) to annihilate
*              A(1:i-2,i)
*
               CALL DLARFG( I-1, A( I-1, I ), A( 1, I ), 1, TAU( I-1 ) )
               E( I-1 ) = A( I-1, I )
               A( I-1, I ) = ONE
*
*              Compute W(1:i-1,i)
*
               CALL DSYMV( 'Upper', I-1, ONE, A, LDA, A( 1, I ), 1,
     $                     ZERO, W( 1, IW ), 1 )
               IF( I.LT.N ) THEN
                  CALL DGEMV( 'Transpose', I-1, N-I, ONE, W( 1, IW+1 ),
     $                        LDW, A( 1, I ), 1, ZERO, W( I+1, IW ), 1 )
                  CALL DGEMV( 'No transpose', I-1, N-I, -ONE,
     $                        A( 1, I+1 ), LDA, W( I+1, IW ), 1, ONE,
     $                        W( 1, IW ), 1 )
                  CALL DGEMV( 'Transpose', I-1, N-I, ONE, A( 1, I+1 ),
     $                        LDA, A( 1, I ), 1, ZERO, W( I+1, IW ), 1 )
                  CALL DGEMV( 'No transpose', I-1, N-I, -ONE,
     $                        W( 1, IW+1 ), LDW, W( I+1, IW ), 1, ONE,
     $                        W( 1, IW ), 1 )
               END IF
               CALL DSCAL( I-1, TAU( I-1 ), W( 1, IW ), 1 )
               ALPHA = -HALF*TAU( I-1 )*DDOT( I-1, W( 1, IW ), 1,
     $                 A( 1, I ), 1 )
               CALL DAXPY( I-1, ALPHA, A( 1, I ), 1, W( 1, IW ), 1 )
            END IF
*
   10    CONTINUE
      ELSE
*
*        Reduce first NB columns of lower triangle
*
         DO 20 I = 1, NB
*
*           Update A(i:n,i)
*
            CALL DGEMV( 'No transpose', N-I+1, I-1, -ONE, A( I, 1 ),
     $                  LDA, W( I, 1 ), LDW, ONE, A( I, I ), 1 )
            CALL DGEMV( 'No transpose', N-I+1, I-1, -ONE, W( I, 1 ),
     $                  LDW, A( I, 1 ), LDA, ONE, A( I, I ), 1 )
            IF( I.LT.N ) THEN
*
*              Generate elementary reflector H(i) to annihilate
*              A(i+2:n,i)
*
               CALL DLARFG( N-I, A( I+1, I ), A( MIN( I+2, N ), I ), 1,
     $                      TAU( I ) )
               E( I ) = A( I+1, I )
               A( I+1, I ) = ONE
*
*              Compute W(i+1:n,i)
*
               CALL DSYMV( 'Lower', N-I, ONE, A( I+1, I+1 ), LDA,
     $                     A( I+1, I ), 1, ZERO, W( I+1, I ), 1 )
               CALL DGEMV( 'Transpose', N-I, I-1, ONE, W( I+1, 1 ), LDW,
     $                     A( I+1, I ), 1, ZERO, W( 1, I ), 1 )
               CALL DGEMV( 'No transpose', N-I, I-1, -ONE, A( I+1, 1 ),
     $                     LDA, W( 1, I ), 1, ONE, W( I+1, I ), 1 )
               CALL DGEMV( 'Transpose', N-I, I-1, ONE, A( I+1, 1 ), LDA,
     $                     A( I+1, I ), 1, ZERO, W( 1, I ), 1 )
               CALL DGEMV( 'No transpose', N-I, I-1, -ONE, W( I+1, 1 ),
     $                     LDW, W( 1, I ), 1, ONE, W( I+1, I ), 1 )
               CALL DSCAL( N-I, TAU( I ), W( I+1, I ), 1 )
               ALPHA = -HALF*TAU( I )*DDOT( N-I, W( I+1, I ), 1,
     $                 A( I+1, I ), 1 )
               CALL DAXPY( N-I, ALPHA, A( I+1, I ), 1, W( I+1, I ), 1 )
            END IF
*
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of DLATRD
*
      END
c $Id: dlatrd.f 24343 2013-06-22 05:35:15Z d3y133 $

      subroutine int_init_1emtpl(maxbuf,maxscr,basis,mpole)
c
c $Id: hnd_init_1emtpl.F 19696 2010-10-29 16:53:42Z d3y133 $
c
      implicit none
c
#include "hnd_pointers.fh"
#include "bas.fh"
#include "errquit.fh"
#include "global.fh"
c
      integer maxbuf    ! [output] buffer space for integrals
      integer maxscr    ! [output] scratch space needed
      integer basis     ! [input] basis set info
      integer mpole     ! [input] order of multipole
c
      integer lmax, iblk, i, mroots, lsz_buf, memsize
c
c     Define Hermite polynomial values
c
      call hnd_whermt
c
c     set up memory requirements: get max L first
c
      lmax = -1
      if (.not.bas_high_angular(basis,lmax))
     &   call errquit('int_mem_1emtpl: lmax error',lmax, INT_ERR)
      lmax = lmax + 1
c
c     Calculate maximum buffer needed
c
      maxbuf = lmax*(lmax+1)*lmax*(lmax+1)
      maxbuf = maxbuf * ((mpole+1)*(mpole+2)*(mpole+3))/6
c
c     Calculate maximum scratch space needed
c
      call emem_3ov(basis,basis,basis,lsz_buf,memsize)
      maxbuf = max(maxbuf,lsz_buf)
      maxscr = memsize
c
      return
      end

*
* $Id: idamax.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      integer function idamax(n,dx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c
      double precision dx(1),dmax
      integer i,incx,ix,n
c
      idamax = 0
      if( n .lt. 1 ) return
      idamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(dabs(dx(ix)).le.dmax) go to 5
         idamax = i
         dmax = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 dmax = dabs(dx(1))
      do 30 i = 2,n
         if(dabs(dx(i)).le.dmax) go to 30
         idamax = i
         dmax = dabs(dx(i))
   30 continue
      return
      end

      logical function task_smd_dynamics(rtdb)
      implicit none
      integer rtdb

#include "inp.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "stdio.fh"
#include "errquit.fh"
#include "smd_system.fh"
      character*72 namespace
      character*32 pname
      double precision etime1,etime2,etime3,etime4,etime5,etime6
      double precision energy,ewald1,ewald2,evdw
      logical operiodic
      integer i
      double precision ke
      integer ndata
      logical vupdate

      pname = "task_smd_dynamics"
      write(*,*) "in "//pname
c
c     start the clock
c     ---------------
      etime1=0.0
      etime2=0.0
      etime3=0.0
      etime4=0.0
      etime5=0.0
      etime6=0.0
      call cpu_time(etime1)
c
      call cpu_time(etime1)
      call smd_init("dynamics",rtdb)
      call cpu_time(etime2)
c
      call smd_vel_read(70)
      call smd_vel_write(71)
c
      if (.not.smd_system_ndata(ndata)) 
     >      call errquit(pname//'failed to get ndata',0,
     >       RTDB_ERR)
c
      write(*,*) "ndata",ndata
      do i=1,ndata
        write(93,*) "niter",i
        call smd_vlist_test(vupdate)
        call smd_vlist_update(vupdate,.true.)
        call smd_force_compute()
        call smd_coords_update()
        call smd_energy_compute()
        call smd_energy_print(6)
      end do
c
      call smd_vel_ke_compute(ke)
      call smd_end(rtdb)
c
      if (.not. rtdb_put(rtdb,'smd:energy',mt_dbl,1,energy))
     $     call errquit(pname//'failed put energy', 0, RTDB_ERR)
c

      call cpu_time(etime6)
      write(luout,'(/,a,f20.3)')'Total CPU time : ',(etime6-etime1)
      write(luout,'(/,a,f20.3)')'Initialization : ',(etime2-etime1)
      write(luout,'(/,a,f20.3)')'Verlet         : ',(etime3-etime2)
      write(luout,'(/,a,f20.3)')'Force          : ',(etime4-etime3)

      write(*,*) "Goodbye from task_smd"
      task_smd_dynamics = .true.

      return
      END
c $Id: task_smd_dynamics.F 22502 2012-05-20 06:11:57Z d3y133 $

*
* $Id: get_psp_type.F 22551 2012-06-03 03:29:10Z bylaska $
*

*     ***********************************
*     *             			*
*     *           get_psp_type		*
*     *             			*
*     ***********************************
      subroutine get_psp_type(psp_filename,psp_type)
      implicit none 
      character*(*) psp_filename
      integer psp_type

*    *** local variables ***
      logical found
      integer MASTER,taskid
      parameter(MASTER=0)

      integer l
      character*255 full_filename
      character*10 test

*     **** external functions ****
      integer  convert_psp_type
      external convert_psp_type

      call Parallel_taskid(taskid)

*     **** open psp_filename file ****
      if (taskid.eq.MASTER) then
        call util_file_name_noprefix(psp_filename,.false.,.false.,
     >                    full_filename)
        l = index(full_filename,' ') - 1
        open(unit=27,file=full_filename(1:l),form='formatted',
     >             status='old')
        read(27,'(A)') test
        close(27)

        psp_type = convert_psp_type(test)
      end if

c     **** send header to all nodes ****
      call Parallel_Brdcst_ivalue(MASTER,psp_type)

      return
      end

*     ***********************************
*     *             			*
*     *          convert_psp_type	*
*     *             			*
*     ***********************************
      integer function convert_psp_type(test)
      implicit none
      character*(*) test

      integer psp_type

      psp_type = 0
      if (test(1:1).eq.'0') psp_type = 0
      if (test(1:1).eq.'1') psp_type = 1
      if (test(1:1).eq.'2') psp_type = 2
      if (test(1:1).eq.'3') psp_type = 3
      if (test(1:1).eq.'4') psp_type = 4
      if (test(1:1).eq.'5') psp_type = 5
      if (test(1:1).eq.'6') psp_type = 6
      if (test(1:1).eq.'7') psp_type = 7
      if (test(1:1).eq.'8') psp_type = 8
      if (test(1:1).eq.'9') psp_type = 9

      convert_psp_type = psp_type
      return
      end

C $Id: ecp_angrad.f 19696 2010-10-29 16:53:42Z d3y133 $
************************************************************************
*                                                                      *
      subroutine ecp_angrad (n_comp_a,n_cont_a,n_comp_b,n_cont_b,
     &    angint,radint,ecp_ints)
*                                                                      *
*   Combine angular and radial parts to produce final integrals        *
*                                                                      *
*   Argument (status) - description                                    *
*                                                                      *
*   n_comp_a (inp) - number of components on centre A (cart or sph)    *
*   n_cont_a (inp) - number of contracted functions on centre A        *
*   n_comp_b (inp) - number of components on centre B (cart or sph)    *
*   n_cont_b (inp) - number of contracted functions on centre B        *
*   angint - angular integrals                                         *
*   radint - radial integrals                                          *
*   ecp_ints - final combined integrals                                *
*                                                                      *
*   Written by K. G. Dyall                                             *
*                                                                      *
************************************************************************
      implicit none
      integer n_comp_a,n_cont_a,n_comp_b,n_cont_b
      integer i_a,i_b,j_a,j_b
      double precision angint(n_comp_a,n_comp_b),
     &    radint(n_cont_a,n_cont_b),
     &    ecp_ints(n_comp_a,n_cont_a,n_comp_b,n_cont_b)
*
      do i_b = 1,n_cont_b
        do j_b = 1,n_comp_b
          do i_a = 1,n_cont_a
            do j_a = 1,n_comp_a
              ecp_ints(j_a,i_a,j_b,i_b) = ecp_ints(j_a,i_a,j_b,i_b)
     &            +radint(i_a,i_b)*angint(j_a,j_b)
            end do
          end do
        end do
      end do
*
      return
      end

*
* $Id: yposv.F 19697 2010-10-29 16:57:34Z d3y133 $
*

      SUBROUTINE YPOSV( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
      implicit none
#include "y64.fh"
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
c
      INTGR4            INFO4, LDA4, LDB4, N4, NRHS4
c
      lda4=lda
      ldb4=ldb
      n4=n
      nrhs4=nrhs
c
      call DPOSV( UPLO, N4, NRHS4, A, LDA4, B, LDB4, INFO4)
      info=info4
      RETURN
      END

*
* $Id: fci_couple3.F 19708 2010-10-29 18:04:21Z d3y133 $
*
      subroutine fci_couple3(vec, nvec, p, q, r, t, iocc, idim, 
     $     numsu, sulist, epqrstu)
      implicit none
#include "fciinfo.fh"
c     
c     Compute <V|Epq,rs,tu|Iw> for given CI vectors V, fixed orbitals
c     p,q,r,t and fixed orbital occupancy I (iocc), and all orbitals s,u
c     and primitive spin functions w.
c
c     Constrain the loops over s and u so that (pq)>=(rs)>=(tu).  If the
c     calling program externally constrains p>=r>=t (all q) then all
c     unique coupling coefficients will be generated.
c     
c     numsu returns the number of orbitals s,u giving a nonzero interaction
c     
c     sulist(1, 1...numsu) contains the values of s
c     sulist(2, 1...numsu) contains the values of u
c     
c     epqrstu(1...idim,1...nvec,1...numsu) contains the coupling coeffcients
c     
      integer nvec              ! [input] No. of vectors on the left hand side
      double precision vec(ndets,nvec) ! [input] The CI vectors
      integer p, q, r, t        ! [input] Fixed labels on Epq,rs,tu
      integer iocc(nactiv)      ! [input] Orbital occupation of I
      integer idim              ! [input] No. of spin functions for I
      integer numsu             ! [output] Returns the number of s,u
      integer sulist(2,*)       ! [output] Returns the list of interacting s,u
      double precision epqrstu(idim,nvec,*) ! [output] <Vi|Epqrstu|Iw>
c     
c     <V|Epq,rs,tu|Iw> = sum(Jv) V(Jv) <Jv|EpaErbEtcEcuEbsEaq|Iw> 
c     .  = sum(Jz) V(Jv) <Jv|EpaErbEtc|Oz><Oz|EcuEbsEaq|Iw>
c     .  = sum(Jz) V(Jv) (<Jv|Epa|Ny><Ny|Erb|Hg><Hg|Etc|Oz>)*
c     .                  (<Oz|Ecu|Mx><Mx|Ebs|Kf><Kf|Eaq|Iw>)
c     .  = sum(Jz) V(Jv) (<Ny|Eap|Jv><Hg|Ebr|Ny><Oz|Ect|Hg>)*
c     .                  (<Oz|Ecu|Mx><Mx|Ebs|Kf><Kf|Eaq|Iw>)
c     
c     where a,b,c are fictitious orbitals with c > b > a
c     and we have v(z), y(z), f(z), w(z), x(z), g(z)
c     
c     .      -q   -s   -u   +t   +r   +p
c     .    I -> K -> M -> O -> H -> N -> J
c     
c     Defer as much computation as possible until we have satisfied
c     all possible occupation and sparsity tests.
c     
      integer indbar(nactmx)    ! Posn amoung sing. occ. I/K/M/O/H/N/J
      integer kperm(ndetmx), mperm(ndetmx),hperm(ndetmx),
     $     nperm(ndetmx), iperm(ndetmx) ! Permutations of spin functions
      double precision kval(ndetmx), nval(ndetmx), mval(ndetmx),
     $     hval(ndetmx), ival(ndetmx) ! Accumulated phase factors
*     integer jperm(ndetmx)          ! Not used by optimized code
*     double precision jval(ndetmx)  ! Not used by optimized code
c     
      integer nsi, nsj, nsk, nsm, nsn, nsh, nso ! No. of sing. occ in I/...
      integer jdim, kdim, mdim, ndim, odim, hdim ! No. of dets for J/...
      integer np                ! Occuption of p in J
      integer nq                ! Occupation of q in I
      integer ns                ! Occupation of s in K
      integer nr                ! Occupation of r in N
      integer nt                ! Occupation of t in H
      integer nu                ! Occupation of u in M
      integer jwalk             ! Lexical index of J
      integer jdet              ! Offset of J in CI vector
      integer sympqrt           ! Sym product state*I*p*q*r*t
      integer symu              ! Required symmetry for u
      integer u, s, w, z, v, pbar, qbar, rbar, sbar, tbar, ubar,
     $     deltat, deltau, deltaq, deltar, deltas, idummy, i, ivec
      integer shi, uhi
      double precision sum, dummy
      logical omade_kval        ! Used to defer computation of kperm/kval
      logical omade_ival        ! Used to defer computaiton of iperm/ival
      double precision thresh
      parameter (thresh = 1d-12) ! Should be SQUARE of desired accuracy
#include "bitops.fh"      
c     
c     Check to see if q is really occupied, compute no. of open shells
c     and I indbar vector
c     
      nq = iocc(q)-1
      if (nq .le. 0) then
         numsu = 0
         return
      endif
c
      call fci_tstart(3,.false.)
c     
      nsi = 0
      sympqrt = ieor(ieor(orbsym(p),orbsym(r)),statesym)
      sympqrt = ieor(ieor(sympqrt,orbsym(q)),orbsym(t))
      do i = 1,nactiv
         if (iocc(i).eq.2) then 
            nsi = nsi + 1
            sympqrt = ieor(sympqrt,orbsym(i))
         endif
         indbar(i) = nsi
      enddo
      if (idim .ne. mnsdet(nsi)) call fci_err
     $     ('fci_couple3: mismatch for idim ', idim)
c     
      numsu = 1
c     
      iocc(q) = iocc(q) - 1     ! iocc now refers to K
c
c     More detailed info about q and K
c
      qbar = indbar(q)
      nsk  = nsi
      deltaq = -1
      if (nq .eq. 2) then
         deltaq = 1
         nsk = nsk + 2
         qbar = qbar + 1
      endif
      kdim = mnsdet(nsk)
c
c    Defer computation of <Ku|Eaq|Iw> until there is a non-zero term
c     
      omade_ival = .false.
c     
c     Loop thru s occupied in K
c     
      shi = nactiv
      if (p .eq. r) shi = q
      do s = 1, shi
         ns = iocc(s)-1         ! Occupation of s in K
         if (ns .gt. 0) then
            iocc(s) = iocc(s) - 1 ! iocc now refers to M
c     
            nsm  = nsk
            if (ns .eq. 2) nsm = nsm + 2
c     
c     Defer computation of <Mx|EbsEaq|Iw> = <Mx|Ebs|Ku><Ku|Eaq|Iw>
c     until we are sure we will need it
c     
            omade_kval = .false.
c     
c     Loop thru u occupied in M
c     
            uhi = nactiv
            if (t .eq. r) uhi = s
            symu = ieor(sympqrt,orbsym(s))
            do u = 1, uhi
               nu = iocc(u)-1   ! Occupation of u in M
               if (nu.gt.0 .and. orbsym(u).eq.symu) then
                  iocc(u) = iocc(u) - 1 ! iocc now refers to O
c     
                  nt = iocc(t)  ! Since iocc refers to O and we want H
                  if (nt .lt. 3) then
                     iocc(t) = iocc(t) + 1 ! iocc now refers to H
c     
                     nr = iocc(r) ! Since iocc refers to H and we want N
                     if (nr .lt. 3) then
                        iocc(r) = iocc(r) + 1 ! iocc now refers to N
c     
                        np = iocc(p) ! Since iocc refers to N and we want J
                        if (np .lt. 3) then
                           iocc(p) = iocc(p) + 1 ! iocc now refers to J
c     
                           nso = nsm
                           if (nu .eq. 2) nso = nso + 2
c     
                           nsh = nso
                           if (nt .eq. 2) nsh = nsh - 2
c     
                           nsn = nsh
                           if (nr .eq. 2) nsn = nsn - 2
c     
                           nsj = nsn
                           if (np .eq. 2) nsj = nsj - 2 
c     
c     Determine the index of J in the CI vector and apply sparsity test
c     
                           jdim = mnsdet(nsj)
*                           call fci_ofind_weight(jwalk,iocc)
*     manually inlined version of fci_ofind_weight
*
                           z = 1
                           jwalk = 1
                           do i = 1,nactiv
                              jwalk = jwalk + karcwt(iocc(i),z,i)
                              z = karc(iocc(i),z,i)
                           enddo
*
                           jdet = indexo(jwalk)
c     
                           sum = 0.0d0
                           do ivec = 1, nvec
                              do v = 1, jdim
                                 sum = sum + 
     $                                vec(jdet+v,ivec)*vec(jdet+v,ivec)
                              enddo
                           enddo
                           if (sum .gt. thresh) then
c
c     Make <Ku|Eaq|Iw> if have not already done so
c
                              if (.not. omade_ival) then
                                 call fci_apply_eaj(qbar, nq, idim,kdim, 
     $                                eajdata(eajptr(nsi)), 
     $                                eajphase(1,1,nsi), .true.,
     $                                idummy, dummy, iperm, ival)
                                 do i = q, nactiv ! Adjust indbar to K
                                    indbar(i) = indbar(i) + deltaq
                                 enddo
                                 omade_ival = .true.
                              endif
c
c     If not already done form <Mx|EbsEaq|Iw> = <Mx|Ebs|Ku><Ku|Eaq|Iw>
c
                              if (.not. omade_kval) then
                                 sbar = indbar(s)
                                 deltas = -1
                                 if (ns .eq. 2) then
                                    sbar = sbar + 1
                                    deltas = 1
                                 endif
                                 do i = s, nactiv ! Adjust indbar to M
                                    indbar(i) = indbar(i) + deltas
                                 enddo
                                 mdim = mnsdet(nsm)
                                 call fci_apply_eaj(sbar, ns,kdim,mdim, 
     $                                eajdata(eajptr(nsk)),
     $                                eajphase(1,1,nsk),
     $                                .false., iperm, ival, kperm, kval)
                                 omade_kval = .true.
                              endif
c     
c     More detailed info about u and O
c     
                              deltau = -1
                              ubar = indbar(u)
                              if (nu .eq. 2) then
                                 ubar = ubar + 1
                                 deltau = 1
                              endif
                              odim = mnsdet(nso)
c     
c     More detailed info about t and H
c     
                              deltat = 1
                              tbar = indbar(t)
                              if (nt .eq. 2) then
                                 deltat = -1
                                 tbar = tbar + 1
                              endif
                              hdim = mnsdet(nsh)
                              tbar = tbar + deltat
                              if (t .ge. u) tbar = tbar + deltau
c     
c     More detailed info about r and N
c     
                              deltar = 1
                              rbar = indbar(r)
                              if (nr .eq. 2) then
                                 deltar = -1
                                 rbar = rbar + 1
                              endif
                              ndim = mnsdet(nsn)
                              rbar = rbar + deltar
                              if (r .ge. u) rbar = rbar + deltau
                              if (r .ge. t) rbar = rbar + deltat
c     
c     More detailed info about p and J
c     
                              pbar = indbar(p)
                              if (np .eq. 1) pbar = pbar + 1
                              if (p .ge. r) pbar = pbar + deltar
                              if (p .ge. u) pbar = pbar + deltau
                              if (p .ge. t) pbar = pbar + deltat
c     
c     Form <Oz|Ecu|Mx><Mx|Ebs|Kf><Kf|Eaq|Iw>
c     
                              call fci_apply_eaj(ubar, nu, mdim, odim, 
     $                             eajdata(eajptr(nsm)), 
     $                             eajphase(1,1,nsm),
     $                             .false., kperm, kval, mperm, mval)
c
                              call fci_apply_eaj3(
     $                             pbar, np, eajdata(eajptr(nsj)), 
     $                             eajphase(1,1,nsj),
     $                             rbar, nr, eajdata(eajptr(nsn)), 
     $                             eajphase(1,1,nsn),
     $                             tbar, nt, eajdata(eajptr(nsh)), 
     $                             eajphase(1,1,nsh),
     $                             jdim, ndim, hdim, odim,
     $                             nperm, nval, hperm, hval)
c$$$
c$$$c     
c$$$c     Form <Ny|Eap|Jv>
c$$$c     
c$$$                              call fci_apply_eaj(pbar, np, jdim, ndim, 
c$$$     $                             eajdata(eajptr(nsj)), 
c$$$     $                             eajphase(1,1,nsj),
c$$$     $                             .true., idummy, dummy, jperm, jval)
c$$$c     
c$$$c     Form <Jv|EpaErb|Hg> = <Ny|Eap|Jv><Hg|Ebr|Ny>
c$$$c     
c$$$                              call fci_apply_eaj(rbar, nr, ndim, hdim, 
c$$$     $                             eajdata(eajptr(nsn)), 
c$$$     $                             eajphase(1,1,nsn),
c$$$     $                             .false., jperm, jval, nperm, nval)
c$$$c     
c$$$c     Form <Ny|Eap|Jv><Hg|Ebr|Ny><Oz|Ect|Hg>
c$$$c     
c$$$                              call fci_apply_eaj(tbar, nt, hdim, odim, 
c$$$     $                             eajdata(eajptr(nsh)), 
c$$$     $                             eajphase(1,1,nsh),
c$$$     $                             .false., nperm, nval, hperm, hval)
c     
c     Now sum(Jz) V(Jv) <Jv|EpaErbEtc|Oz><Oz|EcuEbsEaq|Iw>
c     .
c     .   noting that we have v(z) and w(z)
c     
                              do ivec = 1, nvec
                                 do w = 1, idim
                                    epqrstu(w,ivec,numsu) = 0.0d0
                                 enddo
                              enddo
c     
                              do ivec = 1, nvec
                                 do z = 1, odim
                                    v = hperm(z)
                                    w = mperm(z)
                                    epqrstu(w,ivec,numsu) = 
     $                                   epqrstu(w,ivec,numsu) + 
     $                                   vec(jdet+v,ivec)*
     $                                   hval(z)*mval(z)
                                 enddo
                              enddo
                              sulist(1,numsu) = s
                              sulist(2,numsu) = u
                              numsu = numsu + 1
                           endif ! sum.gt.thresh
c     
                           iocc(p) = iocc(p) - 1 ! iocc now refers to N
                        endif   ! np.lt.3
c     
                        iocc(r) = iocc(r) - 1 ! iocc now refers to H
                     endif      ! nr.lt.3
c     
                     iocc(t) = iocc(t) - 1 ! iocc now refers to O
                  endif         ! nt.lt.3
c     
                  iocc(u) = iocc(u) + 1 ! iocc now refers to M
               endif            ! nu.gt.0
            enddo               ! do u
c     
            if (omade_kval) then
               do i = s, nactiv ! Adjust indbar to refer to K
                  indbar(i) = indbar(i) - deltas
               enddo
            endif
            iocc(s) = iocc(s) + 1 ! iocc now refers to K
         endif                  ! ns.gt.0
      enddo                     ! do s
c     
      iocc(q) = iocc(q) + 1     ! iocc now refers to I
c
      numsu = numsu - 1
c
      call fci_tfinish(3,.false.)
c     
      end
      

      subroutine intgrl_input(rtdb)
      implicit none
* $Id: intgrl_input.F 19696 2010-10-29 16:53:42Z d3y133 $
#include "stdio.fh"
#include "errquit.fh"
#include "inp.fh"
#include "mafdecls.fh"
#include "global.fh"
#include "rtdb.fh"
#include "util.fh"
*     if (rtdb_get(rtdb,'int:cando_txs',MT_LOG,1,user_status)) then
*     if (rtdb_get(rtdb,'int:cando_sp',MT_LOG,1,user_status)) then
*     if (rtdb_get(rtdb,'int:cando_hnd',MT_LOG,1,user_status)) then
*     if (.not.(rtdb_get(rtdb,'int:full_mem',Mt_Log,1,o_do_full)))
*     if (.not. rtdb_get(rtdb,'int:mem2emax',Mt_Int,1,mem2emax))
*     if (.not.(rtdb_get(rtdb,'int:full_mem',Mt_Log,1,o_do_full)))
*     if (rtdb_get(rtdb,'int:acc_std',mt_dbl,1,val_int_acc_std)) then
*     if (rtdb_get(rtdb,'int:acc_high',mt_dbl,1,val_int_acc_high)) then 
*     if (.not. rtdb_get(rtdb,'dyall_mod_dir',mt_log,1,dyall_mod_dir))
*     if (.not. rtdb_get(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
*     if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,nesc_1e_approx))
*     if (.not. rtdb_get(rtdb,'ss_one_cent',mt_log,1,ss_one_cent))
*     if (.not. rtdb_get(rtdb,'do_ssss',mt_log,1,do_ssss)) 
*     if (.not. rtdb_get(rtdb,'doug_kroll',MT_LOG,1,doug_kroll)) 
*     if (.not. rtdb_get(rtdb,'doug_kroll:type',MT_INT,1,
*     if (.not. rtdb_get(rtdb,'doug_kroll:eventemp',MT_LOG,1,
*     if (.not. rtdb_get(rtdb,'doug_kroll:etratio',MT_DBL,1,
*     if (rtdb_get(rtdb,'int:cando_sp',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_nw',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_txs',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_hnd',MT_LOG,1,status)) then
*     if (.not. rtdb_get(rtdb,'dyall_mod_dir',mt_log,1,dyall_mod_dir))
*     if (.not. rtdb_get(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
*     if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,nesc_1e_approx))
*     if (.not. rtdb_get(rtdb,'ss_one_cent',mt_log,1,ss_one_cent))
*     if (.not. rtdb_get(rtdb,'do_ssss',mt_log,1,do_ssss)) 
*     if (.not. rtdb_get(rtdb,'doug_kroll',MT_LOG,1,doug_kroll))
*     if (.not. rtdb_get(rtdb,'doug_kroll:type',MT_INT,1,
*     if (.not. rtdb_get(rtdb,'doug_kroll:eventemp',MT_LOG,1,
*     if (.not. rtdb_get(rtdb,'doug_kroll:etratio',MT_DBL,1,
*     if (rtdb_get(rtdb,'intd:cando_txs',MT_LOG,1,status))
*     if (rtdb_get(rtdb,'int:cando_sp',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_nw',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_txs',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_hnd',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'intd:approxmem',MT_INT,1,intd_memtmp)) then
*     if (rtdb_get(rtdb,'intdd:cando_txs',MT_LOG,1,status))
*     if (rtdb_get(rtdb,'int:cando_sp',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_nw',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_txs',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'int:cando_hnd',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'intdd:approxmem',MT_INT,1,intd_memtmp)) then
*     status = rtdb_get(rtdb, 'doug_kroll', mt_log, 1, dk_run)
*     status = rtdb_get(rtdb, 'dyall_mod_dir', mt_log, 1, dmd_run)
*     if (rtdb_get(rtdb,'int:cando_txs',MT_LOG,1,user_status)) then
*     if (rtdb_get(rtdb,'intd:cando_txs',MT_LOG,1,user_status)) then
*     if (rtdb_get(rtdb,'intdd:cando_txs',MT_LOG,1,user_status)) then
*     if (rtdb_get(rtdb,'int:cando_sp',MT_LOG,1,user_status)) then
*     if (rtdb_get(rtdb,'int:cando_hnd',MT_LOG,1,user_status)) then
*     if (rtdb_get(rtdb,'int:cando_nw',MT_LOG,1,user_status)) then
*emem if (.not.(rtdb_get(rtdb,'int:full_mem',Mt_Log,1,o_do_full)))
*     if (rtdb_get(rtdb,'intd:approxmem',MT_INT,1,intd_memtmp)) then
*     if (rtdb_get(rtdb,'intdd:approxmem',MT_INT,1,intd_memtmp)) then
*     if (rtdb_get(rtdb,'intcsum:all',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:1e',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:ov',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:ke',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:pe',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:h1',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:3ov',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4c',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e4c',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e3c',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e2c',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:ovprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:keprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:peprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:h1print',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:3ovprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:2e4cprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:2e3cprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:2e2cprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4cprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4c:all_at_once',MT_LOG,1,status)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4c:atom_size',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4c:quartet_size',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4c:buffer_size',MT_INT,1,int_tmp)) then
*     if(rtdb_get(rtdb,'intcsum:b2e4c:scratch_size',MT_INT,1,int_tmp)) then
*     if(.not.rtdb_get(rtdb,'int:txs:iprint',MT_INT,1,iprint)) then
*     if (rtdb_get(rtdb,'int:txs:icheck',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:ncache',MT_INT,1,int_tmp)) then
*     else if (rtdb_get(rtdb,'int:txs:ncac',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:maxprice',MT_INT,1,int_tmp)) then
*     else if(rtdb_get(rtdb,'int:txs:ipay',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:iprint',MT_INT,1,int_tmp)) then
*     else if(rtdb_get(rtdb,'int:txs:prin',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:limi',MT_INT,3,rtdblim)) then
*     if (rtdb_get(rtdb,'int:txs:limxmem',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:limblks',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:limpair',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:iroute',MT_INT,1,int_tmp)) then
*     else if(rtdb_get(rtdb,'int:txs:rout',MT_INT,1,int_tmp)) then
*     if(rtdb_get(rtdb,'int:txs:lost_limit',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'intcsum:all',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:1e',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:ov',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:ke',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:pe',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:h1',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:3ov',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4c',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e4c',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e3c',MT_LOG,1,dummyL)) then
*     if (rtdb_get(rtdb,'intcsum:2e2c',MT_LOG,1,dummyL)) then
*rak: if (rtdb_get(rtdb,'int:ov69',MT_LOG,1,dumm69)) then
*rak: if (rtdb_get(rtdb,'int:ke69',MT_LOG,1,dumm69)) then
*rak: if (rtdb_get(rtdb,'int:pe69',MT_LOG,1,dumm69)) then
*rak: if (rtdb_get(rtdb,'int:h169',MT_LOG,1,dumm69)) then
*rak: if (rtdb_get(rtdb,'int:4c69',MT_LOG,1,dumm69)) then
*rak: if (rtdb_get(rtdb,'int:3c69',MT_LOG,1,dumm69)) then
*rak: if (rtdb_get(rtdb,'int:2c69',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:ovprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:keprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:peprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:h1print',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:3ovprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:2e4cprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:2e3cprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:2e2cprint',MT_LOG,1,dumm69)) then
*     if (.not. rtdb_get(rtdb,'dyall_mod_dir',mt_log,1,dyall_mod_dir))
*     if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,nesc_1e_approx))
*     if (.not. rtdb_get(rtdb,'int:mem2emax',Mt_Int,1,mem2c))
*     if (rtdb_get(rtdb,'intcsum:b2e4cprint',MT_LOG,1,dumm69)) then
*     if (rtdb_get(rtdb,'intcsum:b2e4c:all_at_once',
*     if(rtdb_get(rtdb,'intcsum:b2e4c:atom_size',
*     if(rtdb_get(rtdb,'intcsum:b2e4c:quartet_size',
*     if(rtdb_get(rtdb,'intcsum:b2e4c:buffer_size',
*     if(rtdb_get(rtdb,'intcsum:b2e4c:scratch_size',
*     if (.not. rtdb_get(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
*     if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,one_e_approx))
*     if (.not. rtdb_get(rtdb,'ss_one_cent',mt_log,1,one_cent)) 
*     if (.not. rtdb_get(rtdb,'do_ssss',mt_log,1,do_ssss)) 
*     if (.not. rtdb_get(rtdb,'atomic_nesc',mt_log,1,atomic_nesc))
*     if (.not. rtdb_get(rtdb,'nesc_1e_approx',mt_log,1,nesc_1e_approx))
*     if (rtdb_get(rtdb,'relativistic:clight',mt_dbl,1,clight))
*     if(.not.rtdb_get(rtdb,'int:txs:iprint',MT_INT,1,iprint)) then
*     if (rtdb_get(rtdb,'int:txs:icheck',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:ncache',MT_INT,1,int_tmp)) then
*     else if (rtdb_get(rtdb,'int:txs:ncac',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:maxprice',MT_INT,1,int_tmp)) then
*     else if(rtdb_get(rtdb,'int:txs:ipay',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:iprint',MT_INT,1,int_tmp)) then
*     else if(rtdb_get(rtdb,'int:txs:prin',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:limi',MT_INT,3,rtdblim)) then
*     if (rtdb_get(rtdb,'int:txs:limxmem',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:limblks',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:limpair',MT_INT,1,int_tmp)) then
*     if (rtdb_get(rtdb,'int:txs:iroute',MT_INT,1,int_tmp)) then
*     else if(rtdb_get(rtdb,'int:txs:rout',MT_INT,1,int_tmp)) then
*     if(rtdb_get(rtdb,'int:txs:lost_limit',MT_INT,1,int_tmp)) then
* int
*   [sp|rotated_axis] [on|off]
*   hondo [on|off]
*   [nwchem|mmdav] [on|off] 
*   texas [on|off] [1stoff] [2ndoff] [iprint <integer>] [icheck <integer>] \
*         [ncache <integer>] [route <integer>]\
*         [limit [xmem <integer>] [blocks <integer>] [pairs <integer>] lost <integer>]
*   accuracy [<real> | tol <integer>] [sleazy|default|tight|maximum] 
*   memory [approximate|full] [1stmem <integer>] [2ndmem <integer>]
*   checksum [all|1e|2e] || [ov|ke|pe|h1|3ov|2e4c|2e3c|2e2c|b2e4c] \
*            [[buffer|scratch] <integer>] [[quartet|atom] <integer>] 
*   print [ov|ke|pe|h1|3ov|2e4c|2e3c|2e2c|b2e4c] 
*   profile|timing_stats [on|off]
* end
      integer rtdb
*
      integer flen
      character*255 field
*
      if (ga_nodeid().ne.0) return
      call inp_set_field(0) ! goto start of the line
      if (.not. inp_a(field)) call errquit
     &    ('intgrl_input: no input present',911, UNKNOWN_ERR)
      if (.not.(inp_compare(.false.,'intgrl',field).or.
     &          inp_compare(.false.,'integral',field))) call errquit
     &    ('intgrl_input: not INTeGRaL input block',911, UNKNOWN_ERR)
00100 continue
      if (inp_read()) then
        if (.not.inp_a(field)) call errquit
     &      ('intgrl_input:any-keyword could not read field',911,
     &       UNKNOWN_ERR)
        if (inp_compare(.false.,'end',field)) then
          goto 90001
        else if (inp_compare(.false.,'rotated_axis',field).or.
     &           inp_compare(.false.,'sp',field)) then
          if (.not.inp_a(field)) call errquit
     &      ('intgrl_input:sp|rotated_axis: could not read on|off',911, 
     &      UNKNOWN_ERR)
          if (inp_compare(.false.,'on',field)) then
            if (.not.rtdb_put(rtdb,'int:cando_sp',MT_LOG,1,.true.))
     &          call errquit('intgrl_input: rtdb_put failed',911,
     &       RTDB_ERR)
          else if (inp_compare(.false.,'off',field)) then
            if (.not.rtdb_put(rtdb,'int:cando_sp',MT_LOG,1,.false.))
     &          call errquit('intgrl_input: rtdb_put failed',911,
     &       RTDB_ERR)
          else
            flen = inp_strlen(field)
            write(luout,*)' expected on|off got: ',field(1:flen)
            call errquit('intgrl_input: fatal error ',911, UNKNOWN_ERR)
          endif
          goto 00100
        else 
          goto 00100
        endif
      endif
90001 continue
      end

      subroutine dia_init
c
c $Id: dia_init.F 19708 2010-10-29 18:04:21Z d3y133 $
c
c
c     initialize variables
c     --------------------
c
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer i
      character*255 filcmd
c
c     set sequential access to rtdb
c     and ignore current state
c
      ignore=rtdb_parallel(.false.)
c
      lfncub=59
      lfnram=60
      lfndat=61
      lfnexp=62
      lfntcl=63
      lfnpca=64
      lfnavg=65
      lfnhol=66
      lfnpin=67
      lfnpou=68
      lfncmd=69
      lfnloc=70
      lfnhba=71
      lfnecc=72
      lfnrdf=73
      lfnref=76
      lfntrj=77
      lfncop=78
      lfnsup=79
      lfnchg=80
      lfnplt=81
      lfnxyz=82
      lfnana=83
      lfnrms=84
      lfnprj=85
      lfnval=86
      lfncov=87
      lfnvec=88
      lfnmin=89
      lfnmax=90
      lfntop=91
      lfnhis=92
      lfnepz=93
      lfngrp=94
      lfnord=95
      lfnsel=96
      lfndie=97
      lfnamp=98
c
      ntval=0
      ntvec=0
c
      ltop=.false.
c
      do 44 i=1,mhis
      idhis(i,3)=40+i
   44 continue
c      do 46 i=1,mord
c      rord(i,1)=zero
c      rord(i,2)=zero
c   46 continue
c
      lsonly=.false.
      lsuper=.false.
c
      ifrfr=1
      ifrto=0
      ifrsk=1
      ifrst=0
      ilast=0
c
      ndist=0
      nangl=0
      ntors=0
      nimps=0
      nord=0
c
      ndef=0
c
      nhis=0
      lhis=0
c
      nrot=0
c
      lsel=.false.
      lsels=.false.
      lselo=.false.
      active=.false.
      lrms=.false.
      lana=.false.
      lrama=.false.
      lesd=.false.
      lloc=.false.
      lhbond=.false.
      lrdf=.false.
      lesppt=.false.
c
      nave=0
      ndata=0
      time=0.0d0
      timr=0.0d0
      ldist=0
      icent=0
      jcent=0
      scale=1.0d0
      cpk=1.0d0
      stick=1.0d0
c
      ngrid=10
      iesppb=0
      rcut=1.0d0
c
      nfrtot=0
      nfrme=0
c
      indx=1
c
      rhbmin=0.0d0
      rhbmax=0.2d0
      hbdmin=1.9d0
      hbdmax=3.1416d0
      hbamin=1.9d0
      hbamax=3.1416d0
      numwhb=0
c
      ngroup=0
      ngroups=0
      if(.not.ma_push_get(mt_int,maxgrp*mxdef*mxnum,'iwrk',l_wrk,i_wrk))
     + call md_abort('Could not allocate wrk',0)
c
c
c     open the command file
c     ---------------------
c
      if(me.eq.0) then
      if(.not.rtdb_cget(irtdb,'ana:filcmd',1,filcmd))
     + call md_abort('Error rtdb_get filcmd',0)
      open(unit=lfncmd,file=filcmd(1:index(filcmd,' ')-1),
     + form='formatted',status='old',err=9999)
      rewind(unit=lfncmd)
      endif
c
      return
 9999 continue
      call md_abort('Could not open command file',0)
      return
      end
      subroutine dia_getcmd()
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "util.fh"
c
      lesd=.false.
c
      if(me.eq.0) then
      read(lfncmd,1000,end=9999) card
 1000 format(a)
      endif
      call util_char_ga_brdcst(mag_d00,card,0)
      cmd=card(1:6)
c
      return
 9999 continue
      call md_abort('Error readin command file',0) 
      return
      end
      logical function dia_getcard()
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "util.fh"
c
      if(me.eq.0) then
      read(lfncmd,1000,end=9999) card
 1000 format(a)
      endif
c
      dia_getcard=.true.
      return
c
 9999 continue
      dia_getcard=.false.
c
      return
      end
      subroutine dia_final()
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "msgids.fh"
#include "util.fh"
#include "rtdb.fh"
c 
      logical lopen
c
      if(me.eq.0) close(unit=lfncmd,status='delete')
c      if(me.eq.0) close(unit=lfncmd,status='keep')
c
      if(active) call dia_edfinal()
c
      if(.not.ma_pop_stack(l_sbnd))
     + call md_abort('Could not deallocate sbnd',0)
      if(.not.ma_pop_stack(l_iequi))
     + call md_abort('Could not deallocate iequi',0)
      if(.not.ma_pop_stack(l_imol))
     + call md_abort('Could not deallocate imol',0)
      if(.not.ma_pop_stack(l_iram))
     + call md_abort('Could not deallocate iram',0)
c
      call dia_finish(byte_mb(i_snam),.true.)
c
      if(.not.ma_pop_stack(l_wrk))
     + call md_abort('Could not deallocate iwrk',0)
c
      inquire(unit=lfnpca,opened=lopen)
      if(lopen) close(lfnpca,status='keep')
      inquire(unit=lfnord,opened=lopen)
      if(lopen) close(lfnord,status='keep')
      inquire(unit=lfndat,opened=lopen)
      if(lopen) close(lfndat,status='keep')
c
      ignore=rtdb_parallel(.true.)
c
      return
      end
      subroutine dia_update(x,m,ifr,ito)
c
      implicit none
c
      integer m,ifr,ito
      real*8 x(m,3)
c
#include "global.fh"
#include "msgids.fh"
c
      integer i,j
c
      if(ifr.gt.1) then
      do 1 j=1,3
      do 2 i=1,ifr-1
      x(i,j)=0.0d0
    2 continue
    1 continue
      endif
      if(ito.lt.m) then
      do 3 j=1,3
      do 4 i=ito+1,m
      x(i,j)=0.0d0
    4 continue
    3 continue
      endif
c
      call ga_dgop(mag_d12,x,3*m,'+')
c
      return
      end
      subroutine dia_anahdr(sgmnam)
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
c
      character*16 sgmnam(nsa)
      character*11 atom(4)
      integer i,j
c
      write(lfnana,1000) ndist,nangl,ntors,nimps
 1000 format(4i10)
c
      do 1 i=1,ndist
      do 11 j=1,2
      if(idist(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(idist(i,j,1))(12:16),':',
     + sgmnam(idist(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+idist(i,j,1),':',
     + wnam(idist(i,j,2))(6:10)
      endif
   11 continue
c
      write(lfnana,1001) (atom(j),j=1,2)
 1001 format(a11,'-',a11)
    1 continue
c
      do 2 i=1,nangl
      do 21 j=1,3
      if(iangl(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(iangl(i,j,1))(12:16),':',
     + sgmnam(iangl(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+iangl(i,j,1),':',
     + wnam(iangl(i,j,2))(6:10)
      endif
   21 continue
      write(lfnana,1002) (atom(j),j=1,3)
 1002 format(a11,'-',a11,'-',a11)
    2 continue
c
      do 3 i=1,ntors
      do 31 j=1,4
      if(itors(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(itors(i,j,1))(12:16),':',
     + sgmnam(itors(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+itors(i,j,1),':',
     + wnam(itors(i,j,2))(6:10)
      endif
   31 continue
      write(lfnana,1003) (atom(j),j=1,4)
 1003 format(a11,'-',a11,'-',a11,'-',a11)
    3 continue
c
      do 4 i=1,nimps
      do 41 j=1,4
      if(iimps(i,j,2).eq.0) then
      write(atom(j),'(a5,a,a5)') sgmnam(iimps(i,j,1))(12:16),':',
     + sgmnam(iimps(i,j,1))(6:10)
      else
      write(atom(j),'(i5,a,a5)') nsgm+iimps(i,j,1),':',
     + wnam(iimps(i,j,2))(6:10)
      endif
   41 continue
      write(lfnana,1003) (atom(j),j=1,4)
    4 continue
c
      return
      end
      logical function dia_wrtvec(ivec,fil,ndex,xa)
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer ivec
      character*255 fil
      integer i,j,k,l
      real*8 value,xa(msa,3)
      integer ndex(nsa)
c
      if(me.eq.0) then
      open(unit=lfntcl,file=filtcl(1:index(filtcl,' ')-1),
     + form='formatted',status='unknown',err=9999)
      open(unit=lfnvec,file=filvec(1:index(filvec,' ')-1),
     + form='formatted',status='unknown',err=9999)
      open(unit=lfnecc,file=filecc(1:index(filecc,' ')-1),
     + form='formatted',status='unknown',err=9999)
      open(unit=lfnamp,file=filamp(1:index(filamp,' ')-1),
     + form='formatted',status='unknown',err=9999)
      k=0
      l=0
      do 15 i=1,nsel
      value=0.0d0
      do 16 j=1,3
      value=value+(dbl_mb(i_cov+k))**2
      k=k+1
   16 continue
      l=l+1
      write(lfntcl,5555)
     + (10.0*xa(ndex(i),j),j=1,3),
     + (dbl_mb(i_cov+k-4+j),j=1,3)
 5555 format('draw vector2 {',3f12.6,'} {',3f12.6,'} 1.0 10')
      write(lfnamp,'(i5,f12.6)') i,sqrt(value)
   15 continue
c
      write(lfnecc,3013)
 3013 format('%begin%input file%1%char',/,
     + 'geometry noautosym units nm')
      do 314 i=1,nsa
      if(int_mb(i_osel+i-1).eq.1) then
      if(byte_mb(i_snam+(i-1)*16+5).eq.'2'.or.
     + byte_mb(i_snam+(i-1)*16+5).eq.'3'.or.
     + byte_mb(i_snam+(i-1)*16+5).eq.'4') then
      write(lfnecc,3014) ' ',byte_mb(i_snam+(i-1)*16+6),
     + (dbl_mb(i_xadat+i-1+j*msa),j=0,2)
      else
      write(lfnecc,3014) (byte_mb(i_snam+(i-1)*16+j),j=5,6),
     + (dbl_mb(i_xadat+i-1+j*msa),j=0,2)
      endif
 3014 format(2a1,1x,3f12.6)
      endif
  314 continue
      write(lfnecc,3012) nselo
 3012 format('end',/,'basis "ao basis" spherical print',/,
     + ' C library "6-31+G*"',/,
     + ' N library "6-31+G*"',/,
     + ' O library "6-31+G*"',/,
     + ' H library "6-31+G*"',/,
     + ' S library "6-31+G*"',/,
     + ' P library "6-31+G*"',/,
     + ' Ca library "6-31+G*"',/,
     + ' Na library "6-31+G*"',/,
     + 'end',/,
     + 'task scf gradient',/,
     + '%end%input file%1%char',/,
     + 'task_gradient%begin%total gradient%3 ',i7,'%double')
c
      k=0
      do 315 i=1,nsa
      if(int_mb(i_osel+i-1).eq.1) then
      if(int_mb(i_isel+i-1).eq.0) then
      write(lfnecc,3015) 0.0d0,0.0d0,0.0d0
 3015 format(3f12.6)
      else
      write(lfnecc,3015) (dbl_mb(i_cov+k+j),j=0,2)
      k=k+3
      endif
      endif
  315 continue
      write(lfnecc,3011) nselo
 3011 format('task_gradient%end%total gradient%3 ',i7,'%double')
c
      close(unit=lfntcl)
      close(unit=lfnvec)
      close(unit=lfnecc)
      close(unit=lfnval)
      close(unit=lfnprj)
      close(unit=lfnamp)
      write(*,'(/,a,i5,a,a)') ' Projection of vector ',ivec,
     +' written to ',fil(1:index(fil,' ')-1)
      close(unit=lfntrj)
      write(*,'(a)') ' Closing trj file '
      endif
      dia_wrtvec=.true.
      return
 9999 continue
      dia_wrtvec=.false.
      return
      end
      subroutine dia_xcollect(x,ifrom,nx,mx)
c
      implicit none
c
#include "dia_common.fh"
#include "dia_params.fh"
#include "global.fh"
#include "mafdecls.fh"
#include "rtdb.fh"
#include "msgids.fh"
#include "util.fh"
c
      integer ifrom,nx,mx
      real*8 x(mx,3)
c
      integer i,j
c
      if(np.gt.1) then
c
      do 1 j=1,3
      do 2 i=1,ifrom-1
      x(i,j)=zero
    2 continue
    1 continue
c
      do 3 j=1,3
      do 4 i=ifrom+nx+1,mx
      x(i,j)=zero
    4 continue
    3 continue
c
      call ga_dgop(mag_d08,x,3*mx,'+')
c
      endif
c
      return
      end
      subroutine dia_test(x,nsa)
      integer nsa
      real*8 x(nsa,3)
c
      integer i,j
c
      do 1 i=1,10
      write(*,'(i5,3f12.6)') i,(x(i,j),j=1,3)
    1 continue
c
      return
      end
      subroutine dia_test2(xtest,nxdim,nfr)
#include "dia_common.fh"
      integer nxdim
      real*8 xtest(nxdim,3,nfr)
c
      integer i,j,k
c
      do 2 k=1,nfr
      write(*,'(a,i5)') 'FRAME ',me*nfr+k
      do 1 i=1,10
      write(*,'(i5,3f12.6)') i,(xtest(i,j,k),j=1,3)
    1 continue
    2 continue
c
      return
      end

*
* $Id: integrate_kbpp_e_band_stress_ray.F 22503 2012-05-20 06:58:57Z d3y133 $
*

*     ********************************************
*     *                                          *
*     *        integrate_kbpp_e_band_stress_ray    *
*     *                                          *
*     ********************************************

      subroutine integrate_kbpp_e_band_stress_ray(version,
     >                            nrho,drho,lmax,locp,nmax,
     >                            n_extra,n_expansion,zv,
     >                            vp,wp,rho,f,cs,sn,
     >                            nray,G_ray,dvl_ray,dvnl_ray,
     >                            semicore,rho_sc_r,rho_sc_k_ray,
     >                            ierr)
      implicit none
      integer          version
      integer          nrho
      double precision drho
      integer          lmax
      integer          locp
      integer          nmax
      integer          n_extra,n_expansion(0:lmax)
      double precision zv
      double precision vp(nrho,0:lmax)
      double precision wp(nrho,0:(lmax+n_extra))
      double precision rho(nrho)
      double precision f(nrho)
      double precision cs(nrho)
      double precision sn(nrho)

      integer nray
      double precision G_ray(nray)
      double precision dvl_ray(nray)
      double precision dvnl_ray(nray,2,0:(lmax+n_extra))

      logical semicore
      double precision rho_sc_r(nrho,2)
      double precision rho_sc_k_ray(nray)
      integer ierr

#include "errquit.fh"

*     *** local variables ****
      integer np,taskid,MASTER
      parameter (MASTER=0)

      integer task_count
      integer k1,i,l,n,nb
      double precision pi,twopi,forpi
      double precision p0,p1,p2,p3
      double precision a,q
      integer indx(5,0:3)

*     **** external functions ****
      double precision dsum,simp
      external         dsum,simp

*     **** set up indx(n,l) --> to wp ****
      nb = lmax+1
      do l=0,lmax
         indx(1,l) = l
         do n=2,n_expansion(l)
            indx(n,l) = nb
            nb = nb+1
         end do
      end do

      call Parallel_np(np)
      call Parallel_taskid(taskid)

      if (lmax.gt.3) THEN
         call errquit('integrate_kbpp_e_band_stress_ray - lmax > f',0,
     >       INPUT_ERR)
        ierr=1
        return
      end if
      if ((nrho/2)*2.eq.nrho) then
      call errquit('integrate_kbpp_e_band_stress_ray-psp grid not odd',
     >       0,INPUT_ERR)
        ierr=2
        return
      end if

      pi=4.0d0*datan(1.0d0)
      twopi=2.0d0*pi
      forpi=4.0d0*pi
      p0=dsqrt(forpi)
      p1=dsqrt(3.0d0*forpi)
      p2=dsqrt(15.0d0*forpi)
      p3=dsqrt(105.0d0*forpi)

*======================  Fourier transformation  ======================
      call dcopy(nray,0.0d0,0,dvl_ray,1)
      call dcopy(2*(lmax+1+n_extra)*nray,0.0d0,0,dvnl_ray,1)
      call dcopy(nray,0.0d0,0,rho_sc_k_ray,1)
      task_count = -1
      DO 700 k1=2,nray
        task_count = task_count + 1
        if (mod(task_count,np).ne.taskid) go to 700

        q=G_ray(k1)
        
        do i=1,nrho
          cs(i)=DCOS(q*rho(i))
          sn(i)=DSIN(q*rho(i))
        end do

        GO TO (500,400,300,200), lmax+1

*::::::::::::::::::::::::::::::  f-wave  ::::::::::::::::::::::::::::::
  200   CONTINUE
        if (locp.ne.3) then
           do n=1,n_expansion(3)
              F(1)=0.0d0
              do i=2,nrho
                A=sn(i)/(q*rho(i))
                A=15.0d0*(A-cs(i))/(q*rho(i))**2 - 6*A + cs(i)
                f(i)=A*wp(i,indx(n,3))*vp(i,3)
              end do
              dvnl_ray(k1,1,indx(n,3))=p3*SIMP(nrho,F,drho)/q

              F(1)=0.0d0
              do i=2,nrho
                A= -60.0d0*sn(i)/(rho(i)**3 * q**5)
     >           +  60.0d0*cs(i)/(rho(i)**2 * q**4)
     >           +  27.0d0*sn(i)/(rho(i)    * q**3)
     >           -   7.0d0*cs(i)/(q**2)
     >           -   rho(i)*sn(i)/q
                f(i)=A*wp(i,indx(n,3))*vp(i,3)
              end do
              dvnl_ray(k1,2,indx(n,3))=p3*SIMP(nrho,F,drho)
           end do
        end if
*::::::::::::::::::::::::::::::  d-wave  ::::::::::::::::::::::::::::::
  300   CONTINUE
        if (locp.ne.2) then
          do n=1,n_expansion(2)
             F(1)=0.0d0
             DO i=2,nrho
               A=3.0d0*(sn(i)/(q*rho(i))-cs(i))/(q*rho(i))-sn(i)
               f(i)=A*wp(i,indx(n,2))*vp(i,2)
             END DO
             dvnl_ray(k1,1,indx(n,2))=p2*SIMP(nrho,F,drho)/q

             F(1)=0.0d0
             DO i=2,nrho
               A= -9.0d0*sn(i)/(rho(i)**2 * q**4)
     >          +  9.0d0*cs(i)/(rho(i)    * q**3)
     >          +  4.0d0*sn(i)/(q**2)
     >          -  rho(i)*cs(i)/q
               f(i)=A*wp(i,indx(n,2))*vp(i,2)
             END DO
             dvnl_ray(k1,2,indx(n,2))=p2*SIMP(nrho,F,drho)
          end do
        end if
*::::::::::::::::::::::::::::::  p-wave  ::::::::::::::::::::::::::::::
  400   CONTINUE
        if (locp.ne.1) then
           do n=1,n_expansion(1)
              F(1)=0.0d0
              DO i=2,nrho
                f(i)=(sn(i)/(q*rho(i))-cs(i))*wp(i,indx(n,1))*vp(i,1)
              END DO
              dvnl_ray(k1,1,indx(n,1))=p1*SIMP(nrho,F,drho)/q

              F(1)=0.0d0
              DO i=2,nrho
                f(i)=wp(i,indx(n,1))*vp(i,1)*(-2.0d0*sn(i)/(rho(i)*q**3)
     >                                 + 2.0d0*cs(i)/(q**2)
     >                                 + rho(i)*sn(i)/q)
              END DO
              dvnl_ray(k1,2,indx(n,1))=p1*SIMP(nrho,F,drho)
           end do
        end if
*::::::::::::::::::::::::::::::  s-wave  :::::::::::::::::::::::::::::::
  500   CONTINUE
        if (locp.ne.0) then
          do n=1,n_expansion(0)
             DO i=1,nrho
               f(i)=wp(i,indx(n,0))*vp(i,0) * ( -sn(i)/(q**2) 
     >                                 + rho(i)*cs(i)/q)
             END DO
             dvnl_ray(k1,1,indx(n,0)) = p0*SIMP(nrho,F,drho)
          end do
        end if
*::::::::::::::::::::::::::::::  local  :::::::::::::::::::::::::::::::
  600   CONTINUE

        do  i=1,nrho
          f(i)=rho(i)*vp(i,locp)*(rho(i)*cs(i)-sn(i)/q)
        end do
        dvl_ray(k1)= SIMP(nrho,f,drho)*forpi/q
     >   + zv*forpi/(q*q)*(2.0d0*cs(nrho)/q + rho(nrho)*sn(nrho))
*::::::::::::::::::::: semicore density :::::::::::::::::::::::::::::::
        if (semicore) then
           do  i=1,nrho
             f(i)=rho(i)*dsqrt(rho_sc_r(i,1))*(rho(i)*cs(i)-sn(i)/q)
           end do
           rho_sc_k_ray(k1)= SIMP(nrho,f,drho)*forpi/q
        end if
    
  700 CONTINUE

      call Parallel_Vector_SumAll(nray,rho_sc_k_ray)
      call Parallel_Vector_SumAll(nray,dvl_ray)
      call Parallel_Vector_Sumall(2*(lmax+1+n_extra)*nray,dvnl_ray)

*:::::::::::::::::::::::::::::::  G=0  ::::::::::::::::::::::::::::::::      
      dvl_ray(1)      = 0.0d0
      rho_sc_k_ray(1) = 0.0d0
      do l=0,lmax
        do n=1,n_expansion(l)
        dvnl_ray(1,1,indx(n,l))=0.0d0
        dvnl_ray(1,2,indx(n,l))=0.0d0
        end do
      end do

      ierr=0
      return
      end

      subroutine smd_rtdb_close(action)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) action
c
      integer rtdb
      logical result
      character*30 pname

      pname = "smd_rtdb_close"
      call smd_rtdb_get_handle(rtdb)
      if(rtdb.lt.0) call errquit(pname//"no rtdb to close")
      if(.not.rtdb_close(rtdb,action)) 
     >     call errquit(pname//" while rtdb_close",0,0)
      call smd_rtdb_set_handle(-1000)

      end 

      subroutine smd_rtdb_open(fname,action)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) fname
      character*(*) action
c
      integer rtdb
      logical result
      character*30 pname

      pname = "smd_rtdb_close"
      call smd_rtdb_get_handle(rtdb)
      if(rtdb.ge.0) call errquit(pname//"close rtdb first")
      if(.not.rtdb_open(fname,action,rtdb)) 
     >     call errquit(pname//" while rtdb_open",0,0)
      call smd_rtdb_set_handle(rtdb)

      end 

      subroutine smd_rtdb_get_handle(rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer rtdb
c
      logical result
      character*30 pname

      pname = "smd_rtdb_get_handle"
      call smd_rtdb_get_int("smd:rtdb_handle",1,rtdb,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_set_handle(rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer rtdb
c
      logical result
      character*30 pname

      pname = "smd_rtdb_set_handle"
      call smd_rtdb_put_int("smd:rtdb_handle",1,rtdb,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_get_istart(istart)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer istart
c
      logical result
      character*30 pname
c
      pname = "smd_rtdb_get_istart"
      call smd_rtdb_get_int("smd:fragment_istart",1,istart,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_get_iend(iend)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer iend
c
      logical result
      character*30 pname
c
      pname = "smd_rtdb_get_iend"
      call smd_rtdb_get_int("smd:fragment_iend",1,iend,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_get_nproc(nproc)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      integer nproc
c
      logical result
      character*30 pname
c
      pname = "smd_rtdb_get_nproc"
      call smd_rtdb_get_int("smd:fragment_nproc",1,nproc,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)

      end 

      subroutine smd_rtdb_get_name(rtdb_name)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "errquit.fh"
c
      character*(*) rtdb_name
c
      integer rtdb
      character*30 pname
      logical result

      pname = "smd_rtdb_get_name"
c      call smd_rtdb_get_handle(rtdb)
c      if(.not. rtdb_getfname(rtdb, rtdb_name)) call
c     *        errquit(pname//'rtdb_getfname failed',0,0)
      call smd_rtdb_get_string("smd:rtdb_name",1,rtdb_name,result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)


      end 

      subroutine smd_rtdb_get_operiodic(operiodic)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      logical operiodic
c
      double precision latt(3,3)
      character*32 pname
      character*80 tag
      double precision a(3)
      integer i
c
      pname = "smd_lat_rtdb_read"
c
c      write(*,*) "in "//pname
c
      tag="smd:operiodic"
      if (rtdb_get(smd_rtdb,tag,mt_log,1,operiodic)) 
     >    return

      operiodic = .true.
      tag="smd:lat_a"
      if (.not.rtdb_get(smd_rtdb,tag,mt_dbl,3,a(1))) 
     >      operiodic=.false.


      end 

      subroutine smd_rtdb_get_paramfile(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
c
      character*(*) filename
      logical result
c
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:paramfile',1,filename))
     >   result = .false.
      end 

      subroutine smd_rtdb_get_coordfile(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_rtdb_get_coordfile"
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:coordfile',1,filename))
     >   result = .false.

      end 

      subroutine smd_rtdb_get_veloc_input(filename,result)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "global.fh"

c
      character*(*) filename
      logical result
c
      character*30 pname

      pname = "smd_rtdb_get_veloc:input"
      
      result = .true.
      if(.not.rtdb_cget(smd_rtdb,'smd:veloc:input',1,filename))
     >   result = .false.

      end 

      subroutine smd_rtdb_init(parallel,rtdb)
      implicit none
#include "rtdb.fh"
#include "smd_rtdb_data.fh"
#include "mafdecls.fh"
#include "smd_const_data.fh"

      logical parallel
      integer rtdb
c
      character*(smd_string_size) namespace
      character*(smd_string_size) tag
      logical ignore,result,oldmode
      character*30 pname

      pname = "smd_rtdb_init"
      oldmode = rtdb_parallel(parallel)
      smd_rtdb = rtdb
c      if(.not. rtdb_getfname(rtdb, smd_rtdb_name)) call
c     *        errquit('rtdb_getfname failed',0,0)

      smd_istart=0
      smd_iend  =0
      smd_nproc =0
      ignore = rtdb_get(rtdb,"smd:istart",mt_int,1,smd_istart)
      ignore = rtdb_get(rtdb,"smd:iend",mt_int,1,smd_iend)
      ignore = rtdb_get(rtdb,"smd:nproc",mt_int,1,smd_nproc)

      tag = "rtdb"
      call smd_system_get_component(namespace,tag,result)
      if(.not.result)
     >  call errquit(
     >       pname//'no component '//tag,0,0)

      call smd_namespace_create(namespace)

      call smd_data_namespace_rtdb_get(rtdb,namespace,"smd")
      oldmode = rtdb_parallel(oldmode)
      end 

      subroutine smd_rtdb_get_log(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      logical datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_get_log"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_log(sname,dname,ndim,datum,result)
      return
      end

      subroutine smd_rtdb_get_int(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      integer datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_get_int"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_int(sname,dname,ndim,datum,result)
      return
      end

      subroutine smd_rtdb_put_int(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      integer datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_put_int"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) return
      call smd_data_put_int(sname,dname,ndim,datum)
      return
      end

      subroutine smd_rtdb_get_dbl(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
      character*(smd_string_size) sname
      character*(*) dname
      integer ndim
      double precision datum(ndim)
c
      integer ind
      logical result
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1

      pname = "smd_rtdb_get_dbl"
     
      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_dbl(sname,dname,ndim,datum,result)
      return
      end

      subroutine smd_rtdb_get_string(dname,ndim,datum,result)
      implicit none
c
#include "mafdecls.fh"
#include "errquit.fh"
#include "smd_const_data.fh"
#include "inp.fh"
      character*(*) dname
      integer ndim
      integer dtype
      character*(*) datum(ndim)
c
      integer ind
      integer ns,nd
      character*30 pname
      character*72 buffer
      integer i
      integer ndim1
      integer chunk
      logical result
      character*(smd_string_size) sname

      pname = "smd_rtdb_get_string"

      call smd_system_get_component(sname,"rtdb",result)
      if(.not.result) call errquit(pname//"no rtdb component",0,0)
      call smd_data_get_string(sname,dname,ndim,datum,result)
      return
      end

c $Id: smd_rtdb_data.F 22502 2012-05-20 06:11:57Z d3y133 $

      SUBROUTINE vib_TRANSP(A,NDIM,N)
C*MODULE VIB  *DECK TRANSP
* $Id: vib_transp.F 19708 2010-10-29 18:04:21Z d3y133 $
      IMPLICIT NONE
      integer ndim, n
      double precision A(NDIM,NDIM)
c
      double precision temp
      integer i, j
C
C  TRANSPOSE MATRIX A, STORE RESULT IN A.
C
      DO 10 I=1,N
        DO 10 J=1,I
          TEMP=A(I,J)
          A(I,J)=A(J,I)
   10     A(J,I)=TEMP
      RETURN
      END

*> \brief \b CLASSQ updates a sum of squares represented in scaled form.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at 
*            http://www.netlib.org/lapack/explore-html/ 
*
*> \htmlonly
*> Download CLASSQ + dependencies 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/classq.f"> 
*> [TGZ]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/classq.f"> 
*> [ZIP]</a> 
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/classq.f"> 
*> [TXT]</a>
*> \endhtmlonly 
*
*  Definition:
*  ===========
*
*       SUBROUTINE CLASSQ( N, X, INCX, SCALE, SUMSQ )
* 
*       .. Scalar Arguments ..
*       INTEGER            INCX, N
*       REAL               SCALE, SUMSQ
*       ..
*       .. Array Arguments ..
*       COMPLEX            X( * )
*       ..
*  
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> CLASSQ returns the values scl and ssq such that
*>
*>    ( scl**2 )*ssq = x( 1 )**2 +...+ x( n )**2 + ( scale**2 )*sumsq,
*>
*> where x( i ) = abs( X( 1 + ( i - 1 )*INCX ) ). The value of sumsq is
*> assumed to be at least unity and the value of ssq will then satisfy
*>
*>    1.0 .le. ssq .le. ( sumsq + 2*n ).
*>
*> scale is assumed to be non-negative and scl returns the value
*>
*>    scl = max( scale, abs( real( x( i ) ) ), abs( aimag( x( i ) ) ) ),
*>           i
*>
*> scale and sumsq must be supplied in SCALE and SUMSQ respectively.
*> SCALE and SUMSQ are overwritten by scl and ssq respectively.
*>
*> The routine makes only one pass through the vector X.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The number of elements to be used from the vector X.
*> \endverbatim
*>
*> \param[in] X
*> \verbatim
*>          X is COMPLEX array, dimension (N)
*>          The vector x as described above.
*>             x( i )  = X( 1 + ( i - 1 )*INCX ), 1 <= i <= n.
*> \endverbatim
*>
*> \param[in] INCX
*> \verbatim
*>          INCX is INTEGER
*>          The increment between successive values of the vector X.
*>          INCX > 0.
*> \endverbatim
*>
*> \param[in,out] SCALE
*> \verbatim
*>          SCALE is REAL
*>          On entry, the value  scale  in the equation above.
*>          On exit, SCALE is overwritten with the value  scl .
*> \endverbatim
*>
*> \param[in,out] SUMSQ
*> \verbatim
*>          SUMSQ is REAL
*>          On entry, the value  sumsq  in the equation above.
*>          On exit, SUMSQ is overwritten with the value  ssq .
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee 
*> \author Univ. of California Berkeley 
*> \author Univ. of Colorado Denver 
*> \author NAG Ltd. 
*
*> \date September 2012
*
*> \ingroup complexOTHERauxiliary
*
*  =====================================================================
      SUBROUTINE CLASSQ( N, X, INCX, SCALE, SUMSQ )
*
*  -- LAPACK auxiliary routine (version 3.4.2) --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*     September 2012
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      REAL               SCALE, SUMSQ
*     ..
*     .. Array Arguments ..
      COMPLEX            X( * )
*     ..
*
* =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            IX
      REAL               TEMP1
*     ..
*     .. External Functions ..
      LOGICAL            SISNAN
      EXTERNAL           SISNAN
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, AIMAG, REAL
*     ..
*     .. Executable Statements ..
*
      IF( N.GT.0 ) THEN
         DO 10 IX = 1, 1 + ( N-1 )*INCX, INCX
            TEMP1 = ABS( REAL( X( IX ) ) )
            IF( TEMP1.GT.ZERO.OR.SISNAN( TEMP1 ) ) THEN
               IF( SCALE.LT.TEMP1 ) THEN
                  SUMSQ = 1 + SUMSQ*( SCALE / TEMP1 )**2
                  SCALE = TEMP1
               ELSE
                  SUMSQ = SUMSQ + ( TEMP1 / SCALE )**2
               END IF
            END IF
            TEMP1 = ABS( AIMAG( X( IX ) ) )
            IF( TEMP1.GT.ZERO.OR.SISNAN( TEMP1 ) ) THEN
               IF( SCALE.LT.TEMP1 .OR. SISNAN( TEMP1 ) ) THEN
                  SUMSQ = 1 + SUMSQ*( SCALE / TEMP1 )**2
                  SCALE = TEMP1
               ELSE
                  SUMSQ = SUMSQ + ( TEMP1 / SCALE )**2
               END IF
            END IF
   10    CONTINUE
      END IF
*
      RETURN
*
*     End of CLASSQ
*
      END
c $Id: classq.f 24343 2013-06-22 05:35:15Z d3y133 $

      SUBROUTINE ZMATIN(IZMAT,NELS)
C*MODULE VIB  *DECK ZMATIN
* $Id: vib_zmatin.F 19708 2010-10-29 18:04:21Z d3y133 $
C
      IMPLICIT NONE
#include "nwc_const.fh"
*: input elsewhere now :      LOCICAL NVAROK
C
      INTEGER MXATM
      PARAMETER (MXATM=nw_max_atom)
      double precision zan,c
      COMMON /cvib_INFOA /  ZAN(MXATM),C(3,MXATM)
c
      integer nrow, ndeg
      COMMON /cvib_VBDCMP/ NROW,NDEG
c
      LOGICAL LINEAR
      integer nzmat, nzvar, nvar
      COMMON /cvib_ZMAT  / NZMAT,NZVAR,NVAR,LINEAR
c
      integer nzmat2, nzvar2, nvar2, nzmtrd
      COMMON /cvib_ZMTALT/ NZMAT2,NZVAR2,NVAR2,NZMTRD
c
      integer nat, nat3, nhess, nhesst
      COMMON /cvib_HESS/ NAT,NAT3,NHESS,NHESST   ! Hessian information
C
      INTEGER NELS
      INTEGER IZMAT(NELS)
C
*: input elsewhere now :      INTEGER NNAM
*: input elsewhere now :      PARAMETER (NNAM=1)
*: input elsewhere now :      DIMENSION QNAM(NNAM),KQNAM(NNAM)
C
*: input elsewhere now :      DATA QNAM /8HIZMAT   /
C
C     ----- THIS ROUTINE READS THE CODED Z-MATRIX -----
C     IN COMMON /cvib_ZMAT/, NZVAR IS THE NUMBER OF INPUT
C     COORDINATES, NVAR IS THE TOTAL NUMBER OF COORDINATES,
C     AND NZMAT IS THE TOTAL NUMBER OF CODE INTEGERS INPUT.
C
C----------Read NVAR, number of internal coordinates from
C          standard input.
C
*rak flags from input
*: input elsewhere now :      LINEAR = .TRUE.
*: input elsewhere now :      CALL FIND('LINEAR',IERR)
*: input elsewhere now :      IF(IERR .NE. 0)LINEAR = .FALSE.
*: input elsewhere now :      CALL FIND('NVAR  ',IERR)
*: input elsewhere now :      IF(IERR .NE. 0)THEN
*: input elsewhere now :        WRITE(6,*)'Did not find flag NVAR.  Call Bomb.'
*: input elsewhere now :        CALL BOMB(0)
*: input elsewhere now :      ENDIF
*: input elsewhere now :      READ(5,*)NZVAR
*: input elsewhere now :C
*: input elsewhere now :      KQNAM(1) = 10*7*NZVAR + 1
*: input elsewhere now :      DO 100 I=1,NELS
*: input elsewhere now :         IZMAT(I) = 0
*: input elsewhere now :  100 CONTINUE
*: input elsewhere now :C
*: input elsewhere now :C----------READ IN DESCRIPTION OF INTERNAL COORDINATES.
*: input elsewhere now :C
*: input elsewhere now :       CALL FIND('INTCRD',IERR)
*: input elsewhere now :       IF(IERR.NE.0)THEN
*: input elsewhere now :         WRITE(6,*)'Could not find flag INTCRD.  Call Bomb.'
*: input elsewhere now :         CALL BOMB(0)
*: input elsewhere now :       ENDIF
*: input elsewhere now :       IPT = 1
*: input elsewhere now :       DO 7117 IVAR = 1,NZVAR
*: input elsewhere now :         READ(5,*)IZMAT(IPT)
*: input elsewhere now :         ITYPE = IZMAT(IPT)
*: input elsewhere now :         IF(ITYPE .EQ. 1)THEN
*: input elsewhere now :          IPT2 = IPT + 2
*: input elsewhere now :         ELSEIF(ITYPE .EQ. 2)THEN
*: input elsewhere now :          IPT2 = IPT + 3
*: input elsewhere now :         ELSEIF(ITYPE .EQ. 3)THEN
*: input elsewhere now :          IPT2 = IPT + 4
*: input elsewhere now :         ELSEIF(ITYPE .EQ. 4)THEN
*: input elsewhere now :          IPT2 = IPT + 4
*: input elsewhere now :         ELSEIF(ITYPE .EQ. 5)THEN
*: input elsewhere now :          IPT2 = IPT + 3
*: input elsewhere now :         ELSEIF(ITYPE .EQ. 6)THEN
*: input elsewhere now :          IPT2 = IPT + 5
*: input elsewhere now :         ELSEIF(ITYPE .EQ. 7)THEN
*: input elsewhere now :          IPT2 = IPT + 6
*: input elsewhere now :         ELSE
*: input elsewhere now :          WRITE(6,9001)ITYPE
*: input elsewhere now :          CALL BOMB(0)
*: input elsewhere now :         ENDIF
*: input elsewhere now :         READ(5,*)(IZMAT(I),I=IPT+1,IPT2)
*: input elsewhere now :         IPT = IPT2 + 1
*: input elsewhere now : 7117  CONTINUE
*: input elsewhere now :C
*: input elsewhere now :C         INPUT OF INTERNALS REQUIRED IF COORD=UNIQUE, HINT, OR CART,
*: input elsewhere now :C         BUT FOR COORD=ZMT, ZMTMPC WE CAN USE $DATA INFO INSTEAD
*: input elsewhere now :C
*: input elsewhere now :C
*: input elsewhere now :C     ----- SCAN AND ANALYZE IZMAT -----
*: input elsewhere now :C     THE VALID TYPES ARE
*: input elsewhere now :C        1= STRETCH I-J
*: input elsewhere now :C        2= BEND I-J-K
*: input elsewhere now :C        3= TORSION I-J-K-L
*: input elsewhere now :C           (BETWEEN TWO PLANES HAVING TWO ATOMS IN COMMON)
*: input elsewhere now :C        4= OUT OF PLANE BEND I-J-K-L
*: input elsewhere now :C        5= LINEAR BEND I-J-K
*: input elsewhere now :C        6= 5 ATOM DIHEDRAL ANGLE I-J-K-L-M
*: input elsewhere now :C           (BETWEEN TWO PLANES HAVING ONE ATOM IN COMMON)
*: input elsewhere now :C        7= 6 ATOM GHOST TORSION ANGLE I1-I2-J-K-L1-L2
*: input elsewhere now :C
*: input elsewhere now :  200 CONTINUE
*: input elsewhere now :c      WRITE(6,9048)
*: input elsewhere now :      NVAR=0
*: input elsewhere now :      IZ = 1
*: input elsewhere now :      DO 230 I=1,NZVAR
*: input elsewhere now :         ITYPE=IZMAT(IZ)
*: input elsewhere now :         NCHK=0
*: input elsewhere now :         IF(ITYPE.EQ.1) NCHK=2
*: input elsewhere now :         IF(ITYPE.EQ.2) NCHK=3
*: input elsewhere now :         IF(ITYPE.EQ.3) NCHK=4
*: input elsewhere now :         IF(ITYPE.EQ.4) NCHK=4
*: input elsewhere now :         IF(ITYPE.EQ.5) NCHK=3
*: input elsewhere now :         IF(ITYPE.EQ.6) NCHK=5
*: input elsewhere now :         IF(ITYPE.EQ.7) NCHK=6
*: input elsewhere now :         IF(NCHK.EQ.0) THEN
*: input elsewhere now :            WRITE(6,9068) I,IZ,IZMAT(IZ)
*: input elsewhere now :            CALL BOMB(0)
*: input elsewhere now :         END IF
*: input elsewhere now :C
*: input elsewhere now :c         WRITE(6,9058) I,ITYPE,(IZMAT(IZ+J),J=1,NCHK)
*: input elsewhere now :         DO 210 J=1,NCHK
*: input elsewhere now :            IAT=IZMAT(IZ+J)
*: input elsewhere now :            IF(IAT.LE.0  .OR.  IAT.GT.NAT) THEN
*: input elsewhere now :               WRITE(6,9088) I,IZ,IAT,J,NAT
*: input elsewhere now :               CALL BOMB(0)
*: input elsewhere now :            END IF
*: input elsewhere now :  210    CONTINUE
*: input elsewhere now :C
*: input elsewhere now :         IZ=IZ+NCHK+1
*: input elsewhere now :         NVAR=NVAR+1
*: input elsewhere now :         IF(ITYPE.EQ.5) NVAR=NVAR+1
*: input elsewhere now :  230 CONTINUE
*: input elsewhere now :      NZMAT = IZ - 1
*: input elsewhere now :C
*: input elsewhere now :C --- IF NOT DOING VIBRATIONAL ANALYSIS, MUST SPECIFY EXACTLY 3N-NDEG
*: input elsewhere now :C --- INTERNAL COORDINATES.  OTHERWISE, MORE THAN 3N-NDEG IS OK.
*: input elsewhere now :C
*: input elsewhere now :      NDEG = 6
*: input elsewhere now :      IF (LINEAR) NDEG = 5
*: input elsewhere now :      NROW = NVAR + NDEG
*: input elsewhere now :      NVAROK = NVAR .EQ. (3*NAT-NDEG)
*: input elsewhere now :      IF (.NOT.NVAROK) THEN
*: input elsewhere now :         WRITE(6,9148) NDEG,NAT,NVAR
*: input elsewhere now :         CALL BOMB(0)
*: input elsewhere now :      END IF
*: input elsewhere now :C
*: input elsewhere now :C     ----- SAVE IZMAT ON TAPE 10 ----
*: input elsewhere now :C
*: input elsewhere now :c       CALL ADDARRAY(10,IZMAT,INTOWP(NELS),393)
*: input elsewhere now :C
*: input elsewhere now :      NVAR2  = NVAR
*: input elsewhere now :      NZMAT2 = NZMAT
*: input elsewhere now :      RETURN
*: input elsewhere now :C
*: input elsewhere now : 9000 FORMAT(1X,'COULD NOT LOCATE U:VIB')
*: input elsewhere now : 9001 FORMAT(1X,'UNKNOWN INTERNAL COORDINATE TYPE IN ',
*: input elsewhere now :     *          'INPUT DECK. ITYPE = ',I5)
*: input elsewhere now : 9008 FORMAT(1X,'ERROR IN $ZMAT INPUT - ERROR')
*: input elsewhere now : 9048 FORMAT(/3X,'--- ENCODED Z MATRIX ---'/
*: input elsewhere now :     *        1X,'COORD',2X,'TYPE',3X,'I',3X,'J',3X,'K',3X,'L',3X,'M',
*: input elsewhere now :     *        3X,'N')
*: input elsewhere now : 9058 FORMAT(1X,I3,3X,I4,1X,6I4)
*: input elsewhere now : 9068 FORMAT(1X,'INTERNAL COORD.',I3,' AT SUBSCRIPT',I4,
*: input elsewhere now :     *     ' IS OF ILLEGAL TYPE',I5)
*: input elsewhere now : 9088 FORMAT(1X,'INTERNAL COORD.',I3,' AT SUBSCRIPT',I4,
*: input elsewhere now :     *    ' IS FOLLOWED BY ILLEGAL ATOM',I4,' AT OFFSET',I4/
*: input elsewhere now :     *    ' HIGHEST LEGAL ATOM NUMBER IS',I4)
*: input elsewhere now : 9148 FORMAT(1X,'YOU MUST INPUT 3N-',I1,' INTERNAL COORDS WHERE N ='
*: input elsewhere now :     *      ,I3/' YOU HAVE PROVIDED ',I6)
      END

#!/bin/bash

export RUNTESTS=`pwd`/QA/runtests.mpi.unix
export NWCHEM_TOP=`pwd`
export NWCHEM_TARGET=LINUX$(dpkg-architecture -qDEB_HOST_ARCH_BITS)
export NWCHEM_EXECUTABLE=/usr/bin/nwchem
export NWCHEM_BASIS_LIBRARY=/usr/share/nwchem/libraries/
export NWCHEM_NWPW_LIBRARY=/usr/share/nwchem/libraryps/

(cd QA; ../debian/testsuite)

#!/bin/bash

set -e

if [ "x$MPI_FLAVOR" = "x" ]; then
  echo "===== TESTING NWCHEM WITH DEFAULT MPI INSTALLATION ====="
  export NWCHEM_EXECUTABLE=/usr/bin/nwchem
else
  echo "===== TESTING NWCHEM BUILD FOR $MPI_FLAVOR ====="
  export MPIRUN_PATH=/usr/bin/mpirun.${MPI_FLAVOR}
  export NWCHEM_EXECUTABLE=/usr/bin/nwchem.${MPI_FLAVOR}
fi


export RUNTESTS=`pwd`/QA/runtests.mpi.unix
export NWCHEM_TOP=`pwd`
export NWCHEM_TARGET=LINUX$(dpkg-architecture -qDEB_HOST_ARCH_BITS)
export NWCHEM_BASIS_LIBRARY=/usr/share/nwchem/libraries/
export NWCHEM_NWPW_LIBRARY=/usr/share/nwchem/libraryps/

(cd QA; ../debian/testsuite)

#!/bin/bash

DIR=$1
WD=`pwd`

if [[ ! -d $DIR ]]; then
  echo "Usage: make_paper.sh source_dir"
  exit -1
fi

if [[ ! -d output ]]; then
  mkdir output
fi

AUTHOR=`basename $DIR`
OUTDIR="output/$AUTHOR"

mkdir -p $OUTDIR
cp $DIR/* $OUTDIR
python publisher/build_paper.py $DIR $OUTDIR
if [ "$?" -ne "0" ]; then
    echo "Error building paper $DIR. Aborting."
    exit 1
fi
cd $OUTDIR
pdflatex paper.tex && pdflatex paper.tex | (python $WD/publisher/paper_cut.py)

# This file was auto-generated by /home/d3y133/nwchem-releases/nwchem-6.5/contrib/distro-tools/build_nwchem
setenv NWCHEM_TOP /home/d3y133/nwchem-releases/nwchem-6.5
setenv NWCHEM_TARGET LINUX64
setenv NWCHEM_MODULES "all python"
setenv NWCHEM_MPIF_WRAP /home/d3y133/Tools/bin/mpif90
setenv NWCHEM_MPIC_WRAP /home/d3y133/Tools/bin/mpicc
setenv NWCHEM_MPICXX_WRAP /home/d3y133/Tools/bin/mpicxx
setenv USE_NOFSCHECK Y
setenv USE_MPI y
setenv USE_MPIF y
setenv USE_MPIF4 y
setenv MPI_INCLUDE "-I/home/d3y133/Tools/include -I/home/d3y133/Tools/include"
setenv MPI_LIB "-L/home/d3y133/Tools/lib -L/home/d3y133/Tools/lib"
setenv LIBMPI "-lmpichf90 -lmpichf90 -lmpich -lopa -lpthread -lrt"
setenv FC gfortran
setenv CC gcc
setenv CXX g++
setenv ARMCI_NETWORK MPI-MT
setenv MSG_COMMS MPI
setenv BLASOPT " "
setenv PYTHON_EXE /usr/bin/python
setenv PYTHONVERSION 2.4
setenv USE_PYTHON64 yes
setenv PYTHONPATH /home/d3y133/Tools/lib64/python2.4/site-packages
setenv PYTHONHOME /usr
setenv PYTHONLIBTYPE a
alias renwc 'make FC=$FC ; pushd $NWCHEM_TOP/src ; make FC=$FC link ; popd'

# This file was auto-generated by /home/d3y133/nwchem-releases/nwchem-6.5/contrib/distro-tools/build_nwchem
unset NWCHEM_TOP
unset NWCHEM_TARGET
unset NWCHEM_MODULES
unset NWCHEM_MPIF_WRAP
unset NWCHEM_MPIC_WRAP
unset NWCHEM_MPICXX_WRAP
unset USE_NOFSCHECK
unset USE_MPI
unset USE_MPIF
unset USE_MPIF4
unset MPI_INCLUDE
unset MPI_LIB
unset LIBMPI
unset FC
unset CC
unset CXX
unset ARMCI_NETWORK
unset MSG_COMMS
unset BLASOPT
unset PYTHON_EXE
unset PYTHONVERSION
unset USE_PYTHON64
unset PYTHONPATH
unset PYTHONHOME
unset PYTHONLIBTYPE

#!/bin/sh
## Generate input file for SCF

if [ $# -lt 1 ]
then
    echo "Usage: $0 <number of Be atoms>"
    exit 1
fi

file=be.inpt
/bin/rm -rf $file

echo $1 >> $file
echo >> $file
iters=`expr $1 - 1`

for i in `seq 0 $iters`
do
    echo "4  `expr 4 "*" $i`.000 0.000 0.000" >> $file
done

#!/bin/sh
#
cd /tmp
runtest.unix procs 2 \
 $NWCHEM_TEST/na_k/nak \
 $NWCHEM_TEST/na_k/nak_md \
 $NWCHEM_TEST/crown/crown_md \
 $NWCHEM_TEST/ethanol/ethanol_md \
 $NWCHEM_TEST/ethanol/ethanol_ti \
 $NWCHEM_TEST/had/had_em \
 $NWCHEM_TEST/had/had_md \
 $NWCHEM_TEST/prep/a3n \
 $NWCHEM_TEST/prep/aal \
 $NWCHEM_TEST/prep/fsc \
 $NWCHEM_TEST/water/water_md
# $NWCHEM_TEST/h2o_qmd/h2o_scf 
